#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 10951
#define LARGE_STATE_COUNT 3239
#define SYMBOL_COUNT 592
#define ALIAS_COUNT 5
#define TOKEN_COUNT 255
#define EXTERNAL_TOKEN_COUNT 2
#define FIELD_COUNT 50
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 232

enum ts_symbol_identifiers {
  sym_identifier = 1,
  aux_sym_preproc_include_token1 = 2,
  aux_sym_preproc_include_token2 = 3,
  aux_sym_preproc_def_token1 = 4,
  anon_sym_LPAREN = 5,
  anon_sym_DOT_DOT_DOT = 6,
  anon_sym_COMMA = 7,
  anon_sym_RPAREN = 8,
  aux_sym_preproc_if_token1 = 9,
  anon_sym_LF = 10,
  aux_sym_preproc_if_token2 = 11,
  aux_sym_preproc_ifdef_token1 = 12,
  aux_sym_preproc_ifdef_token2 = 13,
  aux_sym_preproc_else_token1 = 14,
  aux_sym_preproc_elif_token1 = 15,
  aux_sym_preproc_elifdef_token1 = 16,
  aux_sym_preproc_elifdef_token2 = 17,
  sym_preproc_arg = 18,
  sym_preproc_directive = 19,
  anon_sym_LPAREN2 = 20,
  anon_sym_defined = 21,
  anon_sym_BANG = 22,
  anon_sym_TILDE = 23,
  anon_sym_DASH = 24,
  anon_sym_PLUS = 25,
  anon_sym_STAR = 26,
  anon_sym_SLASH = 27,
  anon_sym_PERCENT = 28,
  anon_sym_PIPE_PIPE = 29,
  anon_sym_AMP_AMP = 30,
  anon_sym_PIPE = 31,
  anon_sym_CARET = 32,
  anon_sym_AMP = 33,
  anon_sym_EQ_EQ = 34,
  anon_sym_BANG_EQ = 35,
  anon_sym_GT = 36,
  anon_sym_GT_EQ = 37,
  anon_sym_LT_EQ = 38,
  anon_sym_LT = 39,
  anon_sym_LT_LT = 40,
  anon_sym_GT_GT = 41,
  anon_sym_COLON = 42,
  anon_sym_SEMI = 43,
  anon_sym___extension__ = 44,
  anon_sym_typedef = 45,
  anon_sym_in = 46,
  anon_sym_out = 47,
  anon_sym_inout = 48,
  anon_sym_extern = 49,
  anon_sym___attribute__ = 50,
  anon_sym_COLON_COLON = 51,
  anon_sym_LBRACK_LBRACK = 52,
  anon_sym_RBRACK_RBRACK = 53,
  anon_sym___declspec = 54,
  anon_sym___based = 55,
  anon_sym___cdecl = 56,
  anon_sym___clrcall = 57,
  anon_sym___stdcall = 58,
  anon_sym___fastcall = 59,
  anon_sym___thiscall = 60,
  anon_sym___vectorcall = 61,
  sym_ms_restrict_modifier = 62,
  sym_ms_unsigned_ptr_modifier = 63,
  sym_ms_signed_ptr_modifier = 64,
  anon_sym__unaligned = 65,
  anon_sym___unaligned = 66,
  anon_sym_LBRACE = 67,
  anon_sym_RBRACE = 68,
  anon_sym_signed = 69,
  anon_sym_unsigned = 70,
  anon_sym_long = 71,
  anon_sym_short = 72,
  anon_sym_LBRACK = 73,
  anon_sym_static = 74,
  anon_sym_RBRACK = 75,
  anon_sym_EQ = 76,
  anon_sym_register = 77,
  anon_sym_inline = 78,
  anon_sym___inline = 79,
  anon_sym___inline__ = 80,
  anon_sym___forceinline = 81,
  anon_sym_thread_local = 82,
  anon_sym___thread = 83,
  anon_sym_const = 84,
  anon_sym_constexpr = 85,
  anon_sym_volatile = 86,
  anon_sym_restrict = 87,
  anon_sym___restrict__ = 88,
  anon_sym__Atomic = 89,
  anon_sym__Noreturn = 90,
  anon_sym_noreturn = 91,
  anon_sym_mutable = 92,
  anon_sym_constinit = 93,
  anon_sym_consteval = 94,
  anon_sym_alignas = 95,
  anon_sym__Alignas = 96,
  sym_primitive_type = 97,
  anon_sym_enum = 98,
  anon_sym_class = 99,
  anon_sym_struct = 100,
  anon_sym_union = 101,
  anon_sym_if = 102,
  anon_sym_else = 103,
  anon_sym_switch = 104,
  anon_sym_case = 105,
  anon_sym_default = 106,
  anon_sym_while = 107,
  anon_sym_do = 108,
  anon_sym_for = 109,
  anon_sym_return = 110,
  anon_sym_break = 111,
  anon_sym_continue = 112,
  anon_sym_goto = 113,
  anon_sym___try = 114,
  anon_sym___except = 115,
  anon_sym___finally = 116,
  anon_sym___leave = 117,
  anon_sym_QMARK = 118,
  anon_sym_STAR_EQ = 119,
  anon_sym_SLASH_EQ = 120,
  anon_sym_PERCENT_EQ = 121,
  anon_sym_PLUS_EQ = 122,
  anon_sym_DASH_EQ = 123,
  anon_sym_LT_LT_EQ = 124,
  anon_sym_GT_GT_EQ = 125,
  anon_sym_AMP_EQ = 126,
  anon_sym_CARET_EQ = 127,
  anon_sym_PIPE_EQ = 128,
  anon_sym_and_eq = 129,
  anon_sym_or_eq = 130,
  anon_sym_xor_eq = 131,
  anon_sym_not = 132,
  anon_sym_compl = 133,
  anon_sym_LT_EQ_GT = 134,
  anon_sym_or = 135,
  anon_sym_and = 136,
  anon_sym_bitor = 137,
  anon_sym_xor = 138,
  anon_sym_bitand = 139,
  anon_sym_not_eq = 140,
  anon_sym_is = 141,
  anon_sym_as = 142,
  anon_sym_DASH_DASH = 143,
  anon_sym_PLUS_PLUS = 144,
  anon_sym_sizeof = 145,
  anon_sym___alignof__ = 146,
  anon_sym___alignof = 147,
  anon_sym__alignof = 148,
  anon_sym_alignof = 149,
  anon_sym__Alignof = 150,
  anon_sym_offsetof = 151,
  anon_sym__Generic = 152,
  anon_sym_asm = 153,
  anon_sym___asm__ = 154,
  anon_sym_DOT = 155,
  anon_sym_DOT_STAR = 156,
  anon_sym_DASH_GT = 157,
  sym_number_literal = 158,
  anon_sym_L_SQUOTE = 159,
  anon_sym_u_SQUOTE = 160,
  anon_sym_U_SQUOTE = 161,
  anon_sym_u8_SQUOTE = 162,
  anon_sym_SQUOTE = 163,
  aux_sym_char_literal_token1 = 164,
  anon_sym_L_DQUOTE = 165,
  anon_sym_u_DQUOTE = 166,
  anon_sym_U_DQUOTE = 167,
  anon_sym_u8_DQUOTE = 168,
  anon_sym_DQUOTE = 169,
  aux_sym_string_literal_token1 = 170,
  sym_escape_sequence = 171,
  sym_system_lib_string = 172,
  sym_true = 173,
  sym_false = 174,
  anon_sym_NULL = 175,
  anon_sym_nullptr = 176,
  sym_comment = 177,
  anon_sym_var = 178,
  anon_sym_let = 179,
  anon_sym_This = 180,
  sym_auto = 181,
  anon_sym_decltype = 182,
  anon_sym_final = 183,
  anon_sym_override = 184,
  sym_virtual = 185,
  anon_sym_explicit = 186,
  anon_sym_typename = 187,
  anon_sym_template = 188,
  anon_sym_GT2 = 189,
  anon_sym_operator = 190,
  anon_sym_try = 191,
  anon_sym_delete = 192,
  anon_sym_0 = 193,
  anon_sym_friend = 194,
  anon_sym_public = 195,
  anon_sym_private = 196,
  anon_sym_protected = 197,
  anon_sym_noexcept = 198,
  anon_sym_throw = 199,
  anon_sym_namespace = 200,
  anon_sym_using = 201,
  anon_sym_static_assert = 202,
  anon_sym_concept = 203,
  anon_sym_co_return = 204,
  anon_sym_co_yield = 205,
  anon_sym_catch = 206,
  anon_sym_R_DQUOTE = 207,
  anon_sym_LR_DQUOTE = 208,
  anon_sym_uR_DQUOTE = 209,
  anon_sym_UR_DQUOTE = 210,
  anon_sym_u8R_DQUOTE = 211,
  anon_sym_co_await = 212,
  anon_sym_new = 213,
  anon_sym_requires = 214,
  anon_sym_DASH_GT_STAR = 215,
  anon_sym_LPAREN_RPAREN = 216,
  anon_sym_LBRACK_RBRACK = 217,
  anon_sym_DQUOTE_DQUOTE = 218,
  sym_this = 219,
  sym_literal_suffix = 220,
  anon_sym_discard = 221,
  anon_sym_precise = 222,
  anon_sym_shared = 223,
  anon_sym_groupshared = 224,
  anon_sym_uniform = 225,
  anon_sym_row_major = 226,
  anon_sym_column_major = 227,
  anon_sym_globallycoherent = 228,
  anon_sym_centroid = 229,
  anon_sym_noperspective = 230,
  anon_sym_nointerpolation = 231,
  anon_sym_sample = 232,
  anon_sym_linear = 233,
  anon_sym_snorm = 234,
  anon_sym_unorm = 235,
  anon_sym_point = 236,
  anon_sym_line = 237,
  anon_sym_triangleadj = 238,
  anon_sym_lineadj = 239,
  anon_sym_triangle = 240,
  anon_sym_cbuffer = 241,
  anon_sym_interface = 242,
  anon_sym_extension = 243,
  anon_sym_where = 244,
  anon_sym___exported = 245,
  anon_sym_import = 246,
  anon_sym___init = 247,
  anon_sym___subscript = 248,
  anon_sym_property = 249,
  anon_sym_get = 250,
  anon_sym_set = 251,
  anon_sym_associatedtype = 252,
  sym_raw_string_delimiter = 253,
  sym_raw_string_content = 254,
  sym_translation_unit = 255,
  sym__top_level_item = 256,
  sym__block_item = 257,
  sym_preproc_include = 258,
  sym_preproc_def = 259,
  sym_preproc_function_def = 260,
  sym_preproc_params = 261,
  sym_preproc_call = 262,
  sym_preproc_if = 263,
  sym_preproc_ifdef = 264,
  sym_preproc_else = 265,
  sym_preproc_elif = 266,
  sym_preproc_elifdef = 267,
  sym_preproc_if_in_field_declaration_list = 268,
  sym_preproc_ifdef_in_field_declaration_list = 269,
  sym_preproc_else_in_field_declaration_list = 270,
  sym_preproc_elif_in_field_declaration_list = 271,
  sym_preproc_elifdef_in_field_declaration_list = 272,
  sym_preproc_if_in_enumerator_list = 273,
  sym_preproc_ifdef_in_enumerator_list = 274,
  sym_preproc_else_in_enumerator_list = 275,
  sym_preproc_elif_in_enumerator_list = 276,
  sym_preproc_elifdef_in_enumerator_list = 277,
  sym_preproc_if_in_enumerator_list_no_comma = 278,
  sym_preproc_ifdef_in_enumerator_list_no_comma = 279,
  sym_preproc_else_in_enumerator_list_no_comma = 280,
  sym_preproc_elif_in_enumerator_list_no_comma = 281,
  sym_preproc_elifdef_in_enumerator_list_no_comma = 282,
  sym__preproc_expression = 283,
  sym_preproc_parenthesized_expression = 284,
  sym_preproc_defined = 285,
  sym_preproc_unary_expression = 286,
  sym_preproc_call_expression = 287,
  sym_preproc_argument_list = 288,
  sym_preproc_binary_expression = 289,
  sym_function_definition = 290,
  sym_declaration = 291,
  sym_type_definition = 292,
  sym__type_definition_type = 293,
  sym__type_definition_declarators = 294,
  sym__declaration_modifiers = 295,
  sym__declaration_specifiers = 296,
  sym_linkage_specification = 297,
  sym_attribute_specifier = 298,
  sym_attribute = 299,
  sym_attribute_declaration = 300,
  sym_ms_declspec_modifier = 301,
  sym_ms_based_modifier = 302,
  sym_ms_call_modifier = 303,
  sym_ms_unaligned_ptr_modifier = 304,
  sym_ms_pointer_modifier = 305,
  sym_declaration_list = 306,
  sym__declarator = 307,
  sym__field_declarator = 308,
  sym__type_declarator = 309,
  sym__abstract_declarator = 310,
  sym_parenthesized_declarator = 311,
  sym_parenthesized_field_declarator = 312,
  sym_parenthesized_type_declarator = 313,
  sym_abstract_parenthesized_declarator = 314,
  sym_attributed_declarator = 315,
  sym_attributed_field_declarator = 316,
  sym_attributed_type_declarator = 317,
  sym_pointer_declarator = 318,
  sym_pointer_field_declarator = 319,
  sym_pointer_type_declarator = 320,
  sym_abstract_pointer_declarator = 321,
  sym_function_declarator = 322,
  sym_function_field_declarator = 323,
  sym_function_type_declarator = 324,
  sym_abstract_function_declarator = 325,
  sym_array_declarator = 326,
  sym_array_field_declarator = 327,
  sym_array_type_declarator = 328,
  sym_abstract_array_declarator = 329,
  sym_init_declarator = 330,
  sym_compound_statement = 331,
  sym_storage_class_specifier = 332,
  sym_type_qualifier = 333,
  sym_alignas_qualifier = 334,
  sym_type_specifier = 335,
  sym_sized_type_specifier = 336,
  sym_enum_specifier = 337,
  sym_enumerator_list = 338,
  sym_struct_specifier = 339,
  sym_union_specifier = 340,
  sym_field_declaration_list = 341,
  sym__field_declaration_list_item = 342,
  sym_field_declaration = 343,
  sym_bitfield_clause = 344,
  sym_enumerator = 345,
  sym_parameter_list = 346,
  sym_parameter_declaration = 347,
  sym_attributed_statement = 348,
  sym_statement = 349,
  sym__top_level_statement = 350,
  sym_labeled_statement = 351,
  sym__top_level_expression_statement = 352,
  sym_expression_statement = 353,
  sym_if_statement = 354,
  sym_else_clause = 355,
  sym_switch_statement = 356,
  sym_case_statement = 357,
  sym_while_statement = 358,
  sym_do_statement = 359,
  sym_for_statement = 360,
  sym__for_statement_body = 361,
  sym_return_statement = 362,
  sym_break_statement = 363,
  sym_continue_statement = 364,
  sym_goto_statement = 365,
  sym_seh_try_statement = 366,
  sym_seh_except_clause = 367,
  sym_seh_finally_clause = 368,
  sym_seh_leave_statement = 369,
  sym_expression = 370,
  sym__string = 371,
  sym_comma_expression = 372,
  sym_conditional_expression = 373,
  sym_assignment_expression = 374,
  sym_pointer_expression = 375,
  sym_unary_expression = 376,
  sym_binary_expression = 377,
  sym_update_expression = 378,
  sym_cast_expression = 379,
  sym_type_descriptor = 380,
  sym_sizeof_expression = 381,
  sym_alignof_expression = 382,
  sym_offsetof_expression = 383,
  sym_generic_expression = 384,
  sym_subscript_expression = 385,
  sym_call_expression = 386,
  sym_gnu_asm_expression = 387,
  sym_gnu_asm_qualifier = 388,
  sym_gnu_asm_output_operand_list = 389,
  sym_gnu_asm_output_operand = 390,
  sym_gnu_asm_input_operand_list = 391,
  sym_gnu_asm_input_operand = 392,
  sym_gnu_asm_clobber_list = 393,
  sym_gnu_asm_goto_list = 394,
  sym_argument_list = 395,
  sym_field_expression = 396,
  sym_compound_literal_expression = 397,
  sym_parenthesized_expression = 398,
  sym_initializer_list = 399,
  sym_initializer_pair = 400,
  sym_subscript_designator = 401,
  sym_subscript_range_designator = 402,
  sym_field_designator = 403,
  sym_char_literal = 404,
  sym_concatenated_string = 405,
  sym_string_literal = 406,
  sym_null = 407,
  sym__empty_declaration = 408,
  sym_placeholder_type_specifier = 409,
  sym_decltype = 410,
  sym__class_declaration = 411,
  sym__class_declaration_item = 412,
  sym_class_specifier = 413,
  sym__class_name = 414,
  sym_virtual_specifier = 415,
  sym_explicit_function_specifier = 416,
  sym_base_class_clause = 417,
  sym__enum_base_clause = 418,
  sym_dependent_type = 419,
  sym_template_declaration = 420,
  sym_template_instantiation = 421,
  sym_template_parameter_list = 422,
  sym_type_parameter_declaration = 423,
  sym_variadic_type_parameter_declaration = 424,
  sym_optional_type_parameter_declaration = 425,
  sym_template_template_parameter_declaration = 426,
  sym_optional_parameter_declaration = 427,
  sym_variadic_parameter_declaration = 428,
  sym_variadic_declarator = 429,
  sym_variadic_reference_declarator = 430,
  sym_operator_cast = 431,
  sym_field_initializer_list = 432,
  sym_field_initializer = 433,
  sym_inline_method_definition = 434,
  sym__constructor_specifiers = 435,
  sym_operator_cast_definition = 436,
  sym_operator_cast_declaration = 437,
  sym_constructor_try_statement = 438,
  sym_constructor_or_destructor_definition = 439,
  sym_constructor_or_destructor_declaration = 440,
  sym_default_method_clause = 441,
  sym_delete_method_clause = 442,
  sym_pure_virtual_clause = 443,
  sym_friend_declaration = 444,
  sym_access_specifier = 445,
  sym_reference_declarator = 446,
  sym_reference_field_declarator = 447,
  sym_reference_type_declarator = 448,
  sym_abstract_reference_declarator = 449,
  sym_structured_binding_declarator = 450,
  sym_ref_qualifier = 451,
  sym__function_declarator_seq = 452,
  sym__function_attributes_start = 453,
  sym__function_exception_specification = 454,
  sym__function_attributes_end = 455,
  sym__function_postfix = 456,
  sym_trailing_return_type = 457,
  sym_noexcept = 458,
  sym_throw_specifier = 459,
  sym_template_type = 460,
  sym_template_method = 461,
  sym_template_function = 462,
  sym_template_argument_list = 463,
  sym_namespace_definition = 464,
  sym_namespace_alias_definition = 465,
  sym__namespace_specifier = 466,
  sym_nested_namespace_specifier = 467,
  sym_using_declaration = 468,
  sym_alias_declaration = 469,
  sym_static_assert_declaration = 470,
  sym_concept_definition = 471,
  sym_for_range_loop = 472,
  sym__for_range_loop_body = 473,
  sym_init_statement = 474,
  sym_condition_clause = 475,
  sym_condition_declaration = 476,
  sym_co_return_statement = 477,
  sym_co_yield_statement = 478,
  sym_throw_statement = 479,
  sym_try_statement = 480,
  sym_catch_clause = 481,
  sym_raw_string_literal = 482,
  sym_subscript_argument_list = 483,
  sym_co_await_expression = 484,
  sym_new_expression = 485,
  sym_new_declarator = 486,
  sym_delete_expression = 487,
  sym_type_requirement = 488,
  sym_compound_requirement = 489,
  sym__requirement = 490,
  sym_requirement_seq = 491,
  sym_constraint_conjunction = 492,
  sym_constraint_disjunction = 493,
  sym__requirement_clause_constraint = 494,
  sym_requires_clause = 495,
  sym_requires_parameter_list = 496,
  sym_requires_expression = 497,
  sym_lambda_expression = 498,
  sym_lambda_capture_specifier = 499,
  sym_lambda_default_capture = 500,
  sym__fold_operator = 501,
  sym__binary_fold_operator = 502,
  sym__unary_left_fold = 503,
  sym__unary_right_fold = 504,
  sym__binary_fold = 505,
  sym_fold_expression = 506,
  sym_parameter_pack_expansion = 507,
  sym_type_parameter_pack_expansion = 508,
  sym_destructor_name = 509,
  sym_dependent_identifier = 510,
  sym_dependent_field_identifier = 511,
  sym_dependent_type_identifier = 512,
  sym__scope_resolution = 513,
  sym_qualified_field_identifier = 514,
  sym_qualified_identifier = 515,
  sym_qualified_type_identifier = 516,
  sym_qualified_operator_cast_identifier = 517,
  sym__assignment_expression_lhs = 518,
  sym_operator_name = 519,
  sym_user_defined_literal = 520,
  sym_semantics = 521,
  sym_discard_statement = 522,
  sym_qualifiers = 523,
  sym_cbuffer_specifier = 524,
  sym_hlsl_attribute = 525,
  sym_type_hinted_declarator = 526,
  sym_type_hint = 527,
  sym_interface_specifier = 528,
  sym_extension_specifier = 529,
  sym_interface_requirements = 530,
  sym_where_clause = 531,
  sym_import_statement = 532,
  sym_init_declaration = 533,
  sym_subscript_declaration = 534,
  sym_property_declaration = 535,
  sym_property_get = 536,
  sym_property_set = 537,
  sym_associatedtype_declaration = 538,
  sym_associatedtype_specifier = 539,
  aux_sym_translation_unit_repeat1 = 540,
  aux_sym_preproc_params_repeat1 = 541,
  aux_sym_preproc_if_repeat1 = 542,
  aux_sym_preproc_if_in_field_declaration_list_repeat1 = 543,
  aux_sym_preproc_if_in_enumerator_list_repeat1 = 544,
  aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1 = 545,
  aux_sym_preproc_argument_list_repeat1 = 546,
  aux_sym_declaration_repeat1 = 547,
  aux_sym_type_definition_repeat1 = 548,
  aux_sym__type_definition_type_repeat1 = 549,
  aux_sym__type_definition_declarators_repeat1 = 550,
  aux_sym__declaration_specifiers_repeat1 = 551,
  aux_sym_attribute_declaration_repeat1 = 552,
  aux_sym_declaration_list_repeat1 = 553,
  aux_sym_attributed_declarator_repeat1 = 554,
  aux_sym_pointer_declarator_repeat1 = 555,
  aux_sym_array_declarator_repeat1 = 556,
  aux_sym_sized_type_specifier_repeat1 = 557,
  aux_sym_enumerator_list_repeat1 = 558,
  aux_sym_field_declaration_repeat1 = 559,
  aux_sym_parameter_list_repeat1 = 560,
  aux_sym_case_statement_repeat1 = 561,
  aux_sym_generic_expression_repeat1 = 562,
  aux_sym_gnu_asm_expression_repeat1 = 563,
  aux_sym_gnu_asm_output_operand_list_repeat1 = 564,
  aux_sym_gnu_asm_input_operand_list_repeat1 = 565,
  aux_sym_gnu_asm_clobber_list_repeat1 = 566,
  aux_sym_gnu_asm_goto_list_repeat1 = 567,
  aux_sym_argument_list_repeat1 = 568,
  aux_sym_initializer_list_repeat1 = 569,
  aux_sym_initializer_pair_repeat1 = 570,
  aux_sym_char_literal_repeat1 = 571,
  aux_sym_concatenated_string_repeat1 = 572,
  aux_sym_string_literal_repeat1 = 573,
  aux_sym__class_declaration_repeat1 = 574,
  aux_sym_base_class_clause_repeat1 = 575,
  aux_sym_template_parameter_list_repeat1 = 576,
  aux_sym_field_initializer_list_repeat1 = 577,
  aux_sym_operator_cast_definition_repeat1 = 578,
  aux_sym_constructor_try_statement_repeat1 = 579,
  aux_sym_structured_binding_declarator_repeat1 = 580,
  aux_sym__function_postfix_repeat1 = 581,
  aux_sym_throw_specifier_repeat1 = 582,
  aux_sym_template_argument_list_repeat1 = 583,
  aux_sym_subscript_argument_list_repeat1 = 584,
  aux_sym_requirement_seq_repeat1 = 585,
  aux_sym_requires_parameter_list_repeat1 = 586,
  aux_sym_lambda_capture_specifier_repeat1 = 587,
  aux_sym_interface_requirements_repeat1 = 588,
  aux_sym_where_clause_repeat1 = 589,
  aux_sym_import_statement_repeat1 = 590,
  aux_sym_subscript_declaration_repeat1 = 591,
  alias_sym_field_identifier = 592,
  alias_sym_namespace_identifier = 593,
  alias_sym_simple_requirement = 594,
  alias_sym_statement_identifier = 595,
  alias_sym_type_identifier = 596,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [aux_sym_preproc_include_token1] = "#include",
  [aux_sym_preproc_include_token2] = "preproc_include_token2",
  [aux_sym_preproc_def_token1] = "#define",
  [anon_sym_LPAREN] = "(",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [aux_sym_preproc_if_token1] = "#if",
  [anon_sym_LF] = "\n",
  [aux_sym_preproc_if_token2] = "#endif",
  [aux_sym_preproc_ifdef_token1] = "#ifdef",
  [aux_sym_preproc_ifdef_token2] = "#ifndef",
  [aux_sym_preproc_else_token1] = "#else",
  [aux_sym_preproc_elif_token1] = "#elif",
  [aux_sym_preproc_elifdef_token1] = "#elifdef",
  [aux_sym_preproc_elifdef_token2] = "#elifndef",
  [sym_preproc_arg] = "preproc_arg",
  [sym_preproc_directive] = "preproc_directive",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_defined] = "defined",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS] = "+",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_AMP] = "&",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_LT] = "<",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_COLON] = ":",
  [anon_sym_SEMI] = ";",
  [anon_sym___extension__] = "__extension__",
  [anon_sym_typedef] = "typedef",
  [anon_sym_in] = "in",
  [anon_sym_out] = "out",
  [anon_sym_inout] = "inout",
  [anon_sym_extern] = "extern",
  [anon_sym___attribute__] = "__attribute__",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym___declspec] = "__declspec",
  [anon_sym___based] = "__based",
  [anon_sym___cdecl] = "__cdecl",
  [anon_sym___clrcall] = "__clrcall",
  [anon_sym___stdcall] = "__stdcall",
  [anon_sym___fastcall] = "__fastcall",
  [anon_sym___thiscall] = "__thiscall",
  [anon_sym___vectorcall] = "__vectorcall",
  [sym_ms_restrict_modifier] = "ms_restrict_modifier",
  [sym_ms_unsigned_ptr_modifier] = "ms_unsigned_ptr_modifier",
  [sym_ms_signed_ptr_modifier] = "ms_signed_ptr_modifier",
  [anon_sym__unaligned] = "_unaligned",
  [anon_sym___unaligned] = "__unaligned",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_signed] = "signed",
  [anon_sym_unsigned] = "unsigned",
  [anon_sym_long] = "long",
  [anon_sym_short] = "short",
  [anon_sym_LBRACK] = "[",
  [anon_sym_static] = "static",
  [anon_sym_RBRACK] = "]",
  [anon_sym_EQ] = "=",
  [anon_sym_register] = "register",
  [anon_sym_inline] = "inline",
  [anon_sym___inline] = "__inline",
  [anon_sym___inline__] = "__inline__",
  [anon_sym___forceinline] = "__forceinline",
  [anon_sym_thread_local] = "thread_local",
  [anon_sym___thread] = "__thread",
  [anon_sym_const] = "const",
  [anon_sym_constexpr] = "constexpr",
  [anon_sym_volatile] = "volatile",
  [anon_sym_restrict] = "restrict",
  [anon_sym___restrict__] = "__restrict__",
  [anon_sym__Atomic] = "_Atomic",
  [anon_sym__Noreturn] = "_Noreturn",
  [anon_sym_noreturn] = "noreturn",
  [anon_sym_mutable] = "mutable",
  [anon_sym_constinit] = "constinit",
  [anon_sym_consteval] = "consteval",
  [anon_sym_alignas] = "alignas",
  [anon_sym__Alignas] = "_Alignas",
  [sym_primitive_type] = "primitive_type",
  [anon_sym_enum] = "enum",
  [anon_sym_class] = "class",
  [anon_sym_struct] = "struct",
  [anon_sym_union] = "union",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_for] = "for",
  [anon_sym_return] = "return",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_goto] = "goto",
  [anon_sym___try] = "__try",
  [anon_sym___except] = "__except",
  [anon_sym___finally] = "__finally",
  [anon_sym___leave] = "__leave",
  [anon_sym_QMARK] = "\?",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_and_eq] = "and_eq",
  [anon_sym_or_eq] = "or_eq",
  [anon_sym_xor_eq] = "xor_eq",
  [anon_sym_not] = "not",
  [anon_sym_compl] = "compl",
  [anon_sym_LT_EQ_GT] = "<=>",
  [anon_sym_or] = "or",
  [anon_sym_and] = "and",
  [anon_sym_bitor] = "bitor",
  [anon_sym_xor] = "xor",
  [anon_sym_bitand] = "bitand",
  [anon_sym_not_eq] = "not_eq",
  [anon_sym_is] = "is",
  [anon_sym_as] = "as",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_sizeof] = "sizeof",
  [anon_sym___alignof__] = "__alignof__",
  [anon_sym___alignof] = "__alignof",
  [anon_sym__alignof] = "_alignof",
  [anon_sym_alignof] = "alignof",
  [anon_sym__Alignof] = "_Alignof",
  [anon_sym_offsetof] = "offsetof",
  [anon_sym__Generic] = "_Generic",
  [anon_sym_asm] = "asm",
  [anon_sym___asm__] = "__asm__",
  [anon_sym_DOT] = ".",
  [anon_sym_DOT_STAR] = ".*",
  [anon_sym_DASH_GT] = "->",
  [sym_number_literal] = "number_literal",
  [anon_sym_L_SQUOTE] = "L'",
  [anon_sym_u_SQUOTE] = "u'",
  [anon_sym_U_SQUOTE] = "U'",
  [anon_sym_u8_SQUOTE] = "u8'",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_char_literal_token1] = "character",
  [anon_sym_L_DQUOTE] = "L\"",
  [anon_sym_u_DQUOTE] = "u\"",
  [anon_sym_U_DQUOTE] = "U\"",
  [anon_sym_u8_DQUOTE] = "u8\"",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_literal_token1] = "string_content",
  [sym_escape_sequence] = "escape_sequence",
  [sym_system_lib_string] = "system_lib_string",
  [sym_true] = "true",
  [sym_false] = "false",
  [anon_sym_NULL] = "NULL",
  [anon_sym_nullptr] = "nullptr",
  [sym_comment] = "comment",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_This] = "This",
  [sym_auto] = "auto",
  [anon_sym_decltype] = "decltype",
  [anon_sym_final] = "final",
  [anon_sym_override] = "override",
  [sym_virtual] = "virtual",
  [anon_sym_explicit] = "explicit",
  [anon_sym_typename] = "typename",
  [anon_sym_template] = "template",
  [anon_sym_GT2] = ">",
  [anon_sym_operator] = "operator",
  [anon_sym_try] = "try",
  [anon_sym_delete] = "delete",
  [anon_sym_0] = "0",
  [anon_sym_friend] = "friend",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_noexcept] = "noexcept",
  [anon_sym_throw] = "throw",
  [anon_sym_namespace] = "namespace",
  [anon_sym_using] = "using",
  [anon_sym_static_assert] = "static_assert",
  [anon_sym_concept] = "concept",
  [anon_sym_co_return] = "co_return",
  [anon_sym_co_yield] = "co_yield",
  [anon_sym_catch] = "catch",
  [anon_sym_R_DQUOTE] = "R\"",
  [anon_sym_LR_DQUOTE] = "LR\"",
  [anon_sym_uR_DQUOTE] = "uR\"",
  [anon_sym_UR_DQUOTE] = "UR\"",
  [anon_sym_u8R_DQUOTE] = "u8R\"",
  [anon_sym_co_await] = "co_await",
  [anon_sym_new] = "new",
  [anon_sym_requires] = "requires",
  [anon_sym_DASH_GT_STAR] = "->*",
  [anon_sym_LPAREN_RPAREN] = "()",
  [anon_sym_LBRACK_RBRACK] = "[]",
  [anon_sym_DQUOTE_DQUOTE] = "\"\"",
  [sym_this] = "this",
  [sym_literal_suffix] = "literal_suffix",
  [anon_sym_discard] = "discard",
  [anon_sym_precise] = "precise",
  [anon_sym_shared] = "shared",
  [anon_sym_groupshared] = "groupshared",
  [anon_sym_uniform] = "uniform",
  [anon_sym_row_major] = "row_major",
  [anon_sym_column_major] = "column_major",
  [anon_sym_globallycoherent] = "globallycoherent",
  [anon_sym_centroid] = "centroid",
  [anon_sym_noperspective] = "noperspective",
  [anon_sym_nointerpolation] = "nointerpolation",
  [anon_sym_sample] = "sample",
  [anon_sym_linear] = "linear",
  [anon_sym_snorm] = "snorm",
  [anon_sym_unorm] = "unorm",
  [anon_sym_point] = "point",
  [anon_sym_line] = "line",
  [anon_sym_triangleadj] = "triangleadj",
  [anon_sym_lineadj] = "lineadj",
  [anon_sym_triangle] = "triangle",
  [anon_sym_cbuffer] = "cbuffer",
  [anon_sym_interface] = "interface",
  [anon_sym_extension] = "extension",
  [anon_sym_where] = "where",
  [anon_sym___exported] = "__exported",
  [anon_sym_import] = "import",
  [anon_sym___init] = "__init",
  [anon_sym___subscript] = "__subscript",
  [anon_sym_property] = "property",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_associatedtype] = "associatedtype",
  [sym_raw_string_delimiter] = "raw_string_delimiter",
  [sym_raw_string_content] = "raw_string_content",
  [sym_translation_unit] = "translation_unit",
  [sym__top_level_item] = "_top_level_item",
  [sym__block_item] = "_block_item",
  [sym_preproc_include] = "preproc_include",
  [sym_preproc_def] = "preproc_def",
  [sym_preproc_function_def] = "preproc_function_def",
  [sym_preproc_params] = "preproc_params",
  [sym_preproc_call] = "preproc_call",
  [sym_preproc_if] = "preproc_if",
  [sym_preproc_ifdef] = "preproc_ifdef",
  [sym_preproc_else] = "preproc_else",
  [sym_preproc_elif] = "preproc_elif",
  [sym_preproc_elifdef] = "preproc_elifdef",
  [sym_preproc_if_in_field_declaration_list] = "preproc_if",
  [sym_preproc_ifdef_in_field_declaration_list] = "preproc_ifdef",
  [sym_preproc_else_in_field_declaration_list] = "preproc_else",
  [sym_preproc_elif_in_field_declaration_list] = "preproc_elif",
  [sym_preproc_elifdef_in_field_declaration_list] = "preproc_elifdef",
  [sym_preproc_if_in_enumerator_list] = "preproc_if",
  [sym_preproc_ifdef_in_enumerator_list] = "preproc_ifdef",
  [sym_preproc_else_in_enumerator_list] = "preproc_else",
  [sym_preproc_elif_in_enumerator_list] = "preproc_elif",
  [sym_preproc_elifdef_in_enumerator_list] = "preproc_elifdef",
  [sym_preproc_if_in_enumerator_list_no_comma] = "preproc_if",
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = "preproc_ifdef",
  [sym_preproc_else_in_enumerator_list_no_comma] = "preproc_else",
  [sym_preproc_elif_in_enumerator_list_no_comma] = "preproc_elif",
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = "preproc_elifdef",
  [sym__preproc_expression] = "_preproc_expression",
  [sym_preproc_parenthesized_expression] = "parenthesized_expression",
  [sym_preproc_defined] = "preproc_defined",
  [sym_preproc_unary_expression] = "unary_expression",
  [sym_preproc_call_expression] = "call_expression",
  [sym_preproc_argument_list] = "argument_list",
  [sym_preproc_binary_expression] = "binary_expression",
  [sym_function_definition] = "function_definition",
  [sym_declaration] = "declaration",
  [sym_type_definition] = "type_definition",
  [sym__type_definition_type] = "_type_definition_type",
  [sym__type_definition_declarators] = "_type_definition_declarators",
  [sym__declaration_modifiers] = "_declaration_modifiers",
  [sym__declaration_specifiers] = "_declaration_specifiers",
  [sym_linkage_specification] = "linkage_specification",
  [sym_attribute_specifier] = "attribute_specifier",
  [sym_attribute] = "attribute",
  [sym_attribute_declaration] = "attribute_declaration",
  [sym_ms_declspec_modifier] = "ms_declspec_modifier",
  [sym_ms_based_modifier] = "ms_based_modifier",
  [sym_ms_call_modifier] = "ms_call_modifier",
  [sym_ms_unaligned_ptr_modifier] = "ms_unaligned_ptr_modifier",
  [sym_ms_pointer_modifier] = "ms_pointer_modifier",
  [sym_declaration_list] = "declaration_list",
  [sym__declarator] = "_declarator",
  [sym__field_declarator] = "_field_declarator",
  [sym__type_declarator] = "_type_declarator",
  [sym__abstract_declarator] = "_abstract_declarator",
  [sym_parenthesized_declarator] = "parenthesized_declarator",
  [sym_parenthesized_field_declarator] = "parenthesized_declarator",
  [sym_parenthesized_type_declarator] = "parenthesized_declarator",
  [sym_abstract_parenthesized_declarator] = "abstract_parenthesized_declarator",
  [sym_attributed_declarator] = "attributed_declarator",
  [sym_attributed_field_declarator] = "attributed_declarator",
  [sym_attributed_type_declarator] = "attributed_declarator",
  [sym_pointer_declarator] = "pointer_declarator",
  [sym_pointer_field_declarator] = "pointer_declarator",
  [sym_pointer_type_declarator] = "pointer_type_declarator",
  [sym_abstract_pointer_declarator] = "abstract_pointer_declarator",
  [sym_function_declarator] = "function_declarator",
  [sym_function_field_declarator] = "function_declarator",
  [sym_function_type_declarator] = "function_declarator",
  [sym_abstract_function_declarator] = "abstract_function_declarator",
  [sym_array_declarator] = "array_declarator",
  [sym_array_field_declarator] = "array_declarator",
  [sym_array_type_declarator] = "array_declarator",
  [sym_abstract_array_declarator] = "abstract_array_declarator",
  [sym_init_declarator] = "init_declarator",
  [sym_compound_statement] = "compound_statement",
  [sym_storage_class_specifier] = "storage_class_specifier",
  [sym_type_qualifier] = "type_qualifier",
  [sym_alignas_qualifier] = "alignas_qualifier",
  [sym_type_specifier] = "type_specifier",
  [sym_sized_type_specifier] = "sized_type_specifier",
  [sym_enum_specifier] = "enum_specifier",
  [sym_enumerator_list] = "enumerator_list",
  [sym_struct_specifier] = "struct_specifier",
  [sym_union_specifier] = "union_specifier",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym__field_declaration_list_item] = "_field_declaration_list_item",
  [sym_field_declaration] = "field_declaration",
  [sym_bitfield_clause] = "bitfield_clause",
  [sym_enumerator] = "enumerator",
  [sym_parameter_list] = "parameter_list",
  [sym_parameter_declaration] = "parameter_declaration",
  [sym_attributed_statement] = "attributed_statement",
  [sym_statement] = "statement",
  [sym__top_level_statement] = "_top_level_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym__top_level_expression_statement] = "expression_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_if_statement] = "if_statement",
  [sym_else_clause] = "else_clause",
  [sym_switch_statement] = "switch_statement",
  [sym_case_statement] = "case_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_for_statement] = "for_statement",
  [sym__for_statement_body] = "_for_statement_body",
  [sym_return_statement] = "return_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_goto_statement] = "goto_statement",
  [sym_seh_try_statement] = "seh_try_statement",
  [sym_seh_except_clause] = "seh_except_clause",
  [sym_seh_finally_clause] = "seh_finally_clause",
  [sym_seh_leave_statement] = "seh_leave_statement",
  [sym_expression] = "expression",
  [sym__string] = "_string",
  [sym_comma_expression] = "comma_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_pointer_expression] = "pointer_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_update_expression] = "update_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_type_descriptor] = "type_descriptor",
  [sym_sizeof_expression] = "sizeof_expression",
  [sym_alignof_expression] = "alignof_expression",
  [sym_offsetof_expression] = "offsetof_expression",
  [sym_generic_expression] = "generic_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_call_expression] = "call_expression",
  [sym_gnu_asm_expression] = "gnu_asm_expression",
  [sym_gnu_asm_qualifier] = "gnu_asm_qualifier",
  [sym_gnu_asm_output_operand_list] = "gnu_asm_output_operand_list",
  [sym_gnu_asm_output_operand] = "gnu_asm_output_operand",
  [sym_gnu_asm_input_operand_list] = "gnu_asm_input_operand_list",
  [sym_gnu_asm_input_operand] = "gnu_asm_input_operand",
  [sym_gnu_asm_clobber_list] = "gnu_asm_clobber_list",
  [sym_gnu_asm_goto_list] = "gnu_asm_goto_list",
  [sym_argument_list] = "argument_list",
  [sym_field_expression] = "field_expression",
  [sym_compound_literal_expression] = "compound_literal_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_initializer_list] = "initializer_list",
  [sym_initializer_pair] = "initializer_pair",
  [sym_subscript_designator] = "subscript_designator",
  [sym_subscript_range_designator] = "subscript_range_designator",
  [sym_field_designator] = "field_designator",
  [sym_char_literal] = "char_literal",
  [sym_concatenated_string] = "concatenated_string",
  [sym_string_literal] = "string_literal",
  [sym_null] = "null",
  [sym__empty_declaration] = "_empty_declaration",
  [sym_placeholder_type_specifier] = "placeholder_type_specifier",
  [sym_decltype] = "decltype",
  [sym__class_declaration] = "_class_declaration",
  [sym__class_declaration_item] = "_class_declaration_item",
  [sym_class_specifier] = "class_specifier",
  [sym__class_name] = "_class_name",
  [sym_virtual_specifier] = "virtual_specifier",
  [sym_explicit_function_specifier] = "explicit_function_specifier",
  [sym_base_class_clause] = "base_class_clause",
  [sym__enum_base_clause] = "_enum_base_clause",
  [sym_dependent_type] = "dependent_type",
  [sym_template_declaration] = "template_declaration",
  [sym_template_instantiation] = "template_instantiation",
  [sym_template_parameter_list] = "template_parameter_list",
  [sym_type_parameter_declaration] = "type_parameter_declaration",
  [sym_variadic_type_parameter_declaration] = "variadic_type_parameter_declaration",
  [sym_optional_type_parameter_declaration] = "optional_type_parameter_declaration",
  [sym_template_template_parameter_declaration] = "template_template_parameter_declaration",
  [sym_optional_parameter_declaration] = "optional_parameter_declaration",
  [sym_variadic_parameter_declaration] = "variadic_parameter_declaration",
  [sym_variadic_declarator] = "variadic_declarator",
  [sym_variadic_reference_declarator] = "reference_declarator",
  [sym_operator_cast] = "operator_cast",
  [sym_field_initializer_list] = "field_initializer_list",
  [sym_field_initializer] = "field_initializer",
  [sym_inline_method_definition] = "function_definition",
  [sym__constructor_specifiers] = "_constructor_specifiers",
  [sym_operator_cast_definition] = "function_definition",
  [sym_operator_cast_declaration] = "declaration",
  [sym_constructor_try_statement] = "try_statement",
  [sym_constructor_or_destructor_definition] = "function_definition",
  [sym_constructor_or_destructor_declaration] = "declaration",
  [sym_default_method_clause] = "default_method_clause",
  [sym_delete_method_clause] = "delete_method_clause",
  [sym_pure_virtual_clause] = "pure_virtual_clause",
  [sym_friend_declaration] = "friend_declaration",
  [sym_access_specifier] = "access_specifier",
  [sym_reference_declarator] = "reference_declarator",
  [sym_reference_field_declarator] = "reference_declarator",
  [sym_reference_type_declarator] = "reference_declarator",
  [sym_abstract_reference_declarator] = "abstract_reference_declarator",
  [sym_structured_binding_declarator] = "structured_binding_declarator",
  [sym_ref_qualifier] = "ref_qualifier",
  [sym__function_declarator_seq] = "_function_declarator_seq",
  [sym__function_attributes_start] = "_function_attributes_start",
  [sym__function_exception_specification] = "_function_exception_specification",
  [sym__function_attributes_end] = "_function_attributes_end",
  [sym__function_postfix] = "_function_postfix",
  [sym_trailing_return_type] = "trailing_return_type",
  [sym_noexcept] = "noexcept",
  [sym_throw_specifier] = "throw_specifier",
  [sym_template_type] = "template_type",
  [sym_template_method] = "template_method",
  [sym_template_function] = "template_function",
  [sym_template_argument_list] = "template_argument_list",
  [sym_namespace_definition] = "namespace_definition",
  [sym_namespace_alias_definition] = "namespace_alias_definition",
  [sym__namespace_specifier] = "_namespace_specifier",
  [sym_nested_namespace_specifier] = "nested_namespace_specifier",
  [sym_using_declaration] = "using_declaration",
  [sym_alias_declaration] = "alias_declaration",
  [sym_static_assert_declaration] = "static_assert_declaration",
  [sym_concept_definition] = "concept_definition",
  [sym_for_range_loop] = "for_range_loop",
  [sym__for_range_loop_body] = "_for_range_loop_body",
  [sym_init_statement] = "init_statement",
  [sym_condition_clause] = "condition_clause",
  [sym_condition_declaration] = "declaration",
  [sym_co_return_statement] = "co_return_statement",
  [sym_co_yield_statement] = "co_yield_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_raw_string_literal] = "raw_string_literal",
  [sym_subscript_argument_list] = "subscript_argument_list",
  [sym_co_await_expression] = "co_await_expression",
  [sym_new_expression] = "new_expression",
  [sym_new_declarator] = "new_declarator",
  [sym_delete_expression] = "delete_expression",
  [sym_type_requirement] = "type_requirement",
  [sym_compound_requirement] = "compound_requirement",
  [sym__requirement] = "_requirement",
  [sym_requirement_seq] = "requirement_seq",
  [sym_constraint_conjunction] = "constraint_conjunction",
  [sym_constraint_disjunction] = "constraint_disjunction",
  [sym__requirement_clause_constraint] = "_requirement_clause_constraint",
  [sym_requires_clause] = "requires_clause",
  [sym_requires_parameter_list] = "parameter_list",
  [sym_requires_expression] = "requires_expression",
  [sym_lambda_expression] = "lambda_expression",
  [sym_lambda_capture_specifier] = "lambda_capture_specifier",
  [sym_lambda_default_capture] = "lambda_default_capture",
  [sym__fold_operator] = "_fold_operator",
  [sym__binary_fold_operator] = "_binary_fold_operator",
  [sym__unary_left_fold] = "_unary_left_fold",
  [sym__unary_right_fold] = "_unary_right_fold",
  [sym__binary_fold] = "_binary_fold",
  [sym_fold_expression] = "fold_expression",
  [sym_parameter_pack_expansion] = "parameter_pack_expansion",
  [sym_type_parameter_pack_expansion] = "parameter_pack_expansion",
  [sym_destructor_name] = "destructor_name",
  [sym_dependent_identifier] = "dependent_name",
  [sym_dependent_field_identifier] = "dependent_name",
  [sym_dependent_type_identifier] = "dependent_name",
  [sym__scope_resolution] = "_scope_resolution",
  [sym_qualified_field_identifier] = "qualified_identifier",
  [sym_qualified_identifier] = "qualified_identifier",
  [sym_qualified_type_identifier] = "qualified_identifier",
  [sym_qualified_operator_cast_identifier] = "qualified_identifier",
  [sym__assignment_expression_lhs] = "assignment_expression",
  [sym_operator_name] = "operator_name",
  [sym_user_defined_literal] = "user_defined_literal",
  [sym_semantics] = "semantics",
  [sym_discard_statement] = "discard_statement",
  [sym_qualifiers] = "qualifiers",
  [sym_cbuffer_specifier] = "cbuffer_specifier",
  [sym_hlsl_attribute] = "hlsl_attribute",
  [sym_type_hinted_declarator] = "type_hinted_declarator",
  [sym_type_hint] = "type_hint",
  [sym_interface_specifier] = "interface_specifier",
  [sym_extension_specifier] = "extension_specifier",
  [sym_interface_requirements] = "interface_requirements",
  [sym_where_clause] = "where_clause",
  [sym_import_statement] = "import_statement",
  [sym_init_declaration] = "init_declaration",
  [sym_subscript_declaration] = "subscript_declaration",
  [sym_property_declaration] = "property_declaration",
  [sym_property_get] = "property_get",
  [sym_property_set] = "property_set",
  [sym_associatedtype_declaration] = "associatedtype_declaration",
  [sym_associatedtype_specifier] = "associatedtype_specifier",
  [aux_sym_translation_unit_repeat1] = "translation_unit_repeat1",
  [aux_sym_preproc_params_repeat1] = "preproc_params_repeat1",
  [aux_sym_preproc_if_repeat1] = "preproc_if_repeat1",
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = "preproc_if_in_field_declaration_list_repeat1",
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = "preproc_if_in_enumerator_list_repeat1",
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = "preproc_if_in_enumerator_list_no_comma_repeat1",
  [aux_sym_preproc_argument_list_repeat1] = "preproc_argument_list_repeat1",
  [aux_sym_declaration_repeat1] = "declaration_repeat1",
  [aux_sym_type_definition_repeat1] = "type_definition_repeat1",
  [aux_sym__type_definition_type_repeat1] = "_type_definition_type_repeat1",
  [aux_sym__type_definition_declarators_repeat1] = "_type_definition_declarators_repeat1",
  [aux_sym__declaration_specifiers_repeat1] = "_declaration_specifiers_repeat1",
  [aux_sym_attribute_declaration_repeat1] = "attribute_declaration_repeat1",
  [aux_sym_declaration_list_repeat1] = "declaration_list_repeat1",
  [aux_sym_attributed_declarator_repeat1] = "attributed_declarator_repeat1",
  [aux_sym_pointer_declarator_repeat1] = "pointer_declarator_repeat1",
  [aux_sym_array_declarator_repeat1] = "array_declarator_repeat1",
  [aux_sym_sized_type_specifier_repeat1] = "sized_type_specifier_repeat1",
  [aux_sym_enumerator_list_repeat1] = "enumerator_list_repeat1",
  [aux_sym_field_declaration_repeat1] = "field_declaration_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_generic_expression_repeat1] = "generic_expression_repeat1",
  [aux_sym_gnu_asm_expression_repeat1] = "gnu_asm_expression_repeat1",
  [aux_sym_gnu_asm_output_operand_list_repeat1] = "gnu_asm_output_operand_list_repeat1",
  [aux_sym_gnu_asm_input_operand_list_repeat1] = "gnu_asm_input_operand_list_repeat1",
  [aux_sym_gnu_asm_clobber_list_repeat1] = "gnu_asm_clobber_list_repeat1",
  [aux_sym_gnu_asm_goto_list_repeat1] = "gnu_asm_goto_list_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_initializer_list_repeat1] = "initializer_list_repeat1",
  [aux_sym_initializer_pair_repeat1] = "initializer_pair_repeat1",
  [aux_sym_char_literal_repeat1] = "char_literal_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [aux_sym__class_declaration_repeat1] = "_class_declaration_repeat1",
  [aux_sym_base_class_clause_repeat1] = "base_class_clause_repeat1",
  [aux_sym_template_parameter_list_repeat1] = "template_parameter_list_repeat1",
  [aux_sym_field_initializer_list_repeat1] = "field_initializer_list_repeat1",
  [aux_sym_operator_cast_definition_repeat1] = "operator_cast_definition_repeat1",
  [aux_sym_constructor_try_statement_repeat1] = "constructor_try_statement_repeat1",
  [aux_sym_structured_binding_declarator_repeat1] = "structured_binding_declarator_repeat1",
  [aux_sym__function_postfix_repeat1] = "_function_postfix_repeat1",
  [aux_sym_throw_specifier_repeat1] = "throw_specifier_repeat1",
  [aux_sym_template_argument_list_repeat1] = "template_argument_list_repeat1",
  [aux_sym_subscript_argument_list_repeat1] = "subscript_argument_list_repeat1",
  [aux_sym_requirement_seq_repeat1] = "requirement_seq_repeat1",
  [aux_sym_requires_parameter_list_repeat1] = "requires_parameter_list_repeat1",
  [aux_sym_lambda_capture_specifier_repeat1] = "lambda_capture_specifier_repeat1",
  [aux_sym_interface_requirements_repeat1] = "interface_requirements_repeat1",
  [aux_sym_where_clause_repeat1] = "where_clause_repeat1",
  [aux_sym_import_statement_repeat1] = "import_statement_repeat1",
  [aux_sym_subscript_declaration_repeat1] = "subscript_declaration_repeat1",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_namespace_identifier] = "namespace_identifier",
  [alias_sym_simple_requirement] = "simple_requirement",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [aux_sym_preproc_include_token1] = aux_sym_preproc_include_token1,
  [aux_sym_preproc_include_token2] = aux_sym_preproc_include_token2,
  [aux_sym_preproc_def_token1] = aux_sym_preproc_def_token1,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [aux_sym_preproc_if_token1] = aux_sym_preproc_if_token1,
  [anon_sym_LF] = anon_sym_LF,
  [aux_sym_preproc_if_token2] = aux_sym_preproc_if_token2,
  [aux_sym_preproc_ifdef_token1] = aux_sym_preproc_ifdef_token1,
  [aux_sym_preproc_ifdef_token2] = aux_sym_preproc_ifdef_token2,
  [aux_sym_preproc_else_token1] = aux_sym_preproc_else_token1,
  [aux_sym_preproc_elif_token1] = aux_sym_preproc_elif_token1,
  [aux_sym_preproc_elifdef_token1] = aux_sym_preproc_elifdef_token1,
  [aux_sym_preproc_elifdef_token2] = aux_sym_preproc_elifdef_token2,
  [sym_preproc_arg] = sym_preproc_arg,
  [sym_preproc_directive] = sym_preproc_directive,
  [anon_sym_LPAREN2] = anon_sym_LPAREN,
  [anon_sym_defined] = anon_sym_defined,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym___extension__] = anon_sym___extension__,
  [anon_sym_typedef] = anon_sym_typedef,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_out] = anon_sym_out,
  [anon_sym_inout] = anon_sym_inout,
  [anon_sym_extern] = anon_sym_extern,
  [anon_sym___attribute__] = anon_sym___attribute__,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_LBRACK_LBRACK] = anon_sym_LBRACK_LBRACK,
  [anon_sym_RBRACK_RBRACK] = anon_sym_RBRACK_RBRACK,
  [anon_sym___declspec] = anon_sym___declspec,
  [anon_sym___based] = anon_sym___based,
  [anon_sym___cdecl] = anon_sym___cdecl,
  [anon_sym___clrcall] = anon_sym___clrcall,
  [anon_sym___stdcall] = anon_sym___stdcall,
  [anon_sym___fastcall] = anon_sym___fastcall,
  [anon_sym___thiscall] = anon_sym___thiscall,
  [anon_sym___vectorcall] = anon_sym___vectorcall,
  [sym_ms_restrict_modifier] = sym_ms_restrict_modifier,
  [sym_ms_unsigned_ptr_modifier] = sym_ms_unsigned_ptr_modifier,
  [sym_ms_signed_ptr_modifier] = sym_ms_signed_ptr_modifier,
  [anon_sym__unaligned] = anon_sym__unaligned,
  [anon_sym___unaligned] = anon_sym___unaligned,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_signed] = anon_sym_signed,
  [anon_sym_unsigned] = anon_sym_unsigned,
  [anon_sym_long] = anon_sym_long,
  [anon_sym_short] = anon_sym_short,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_register] = anon_sym_register,
  [anon_sym_inline] = anon_sym_inline,
  [anon_sym___inline] = anon_sym___inline,
  [anon_sym___inline__] = anon_sym___inline__,
  [anon_sym___forceinline] = anon_sym___forceinline,
  [anon_sym_thread_local] = anon_sym_thread_local,
  [anon_sym___thread] = anon_sym___thread,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_constexpr] = anon_sym_constexpr,
  [anon_sym_volatile] = anon_sym_volatile,
  [anon_sym_restrict] = anon_sym_restrict,
  [anon_sym___restrict__] = anon_sym___restrict__,
  [anon_sym__Atomic] = anon_sym__Atomic,
  [anon_sym__Noreturn] = anon_sym__Noreturn,
  [anon_sym_noreturn] = anon_sym_noreturn,
  [anon_sym_mutable] = anon_sym_mutable,
  [anon_sym_constinit] = anon_sym_constinit,
  [anon_sym_consteval] = anon_sym_consteval,
  [anon_sym_alignas] = anon_sym_alignas,
  [anon_sym__Alignas] = anon_sym__Alignas,
  [sym_primitive_type] = sym_primitive_type,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_union] = anon_sym_union,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym___try] = anon_sym___try,
  [anon_sym___except] = anon_sym___except,
  [anon_sym___finally] = anon_sym___finally,
  [anon_sym___leave] = anon_sym___leave,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_and_eq] = anon_sym_and_eq,
  [anon_sym_or_eq] = anon_sym_or_eq,
  [anon_sym_xor_eq] = anon_sym_xor_eq,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_compl] = anon_sym_compl,
  [anon_sym_LT_EQ_GT] = anon_sym_LT_EQ_GT,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_bitor] = anon_sym_bitor,
  [anon_sym_xor] = anon_sym_xor,
  [anon_sym_bitand] = anon_sym_bitand,
  [anon_sym_not_eq] = anon_sym_not_eq,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_sizeof] = anon_sym_sizeof,
  [anon_sym___alignof__] = anon_sym___alignof__,
  [anon_sym___alignof] = anon_sym___alignof,
  [anon_sym__alignof] = anon_sym__alignof,
  [anon_sym_alignof] = anon_sym_alignof,
  [anon_sym__Alignof] = anon_sym__Alignof,
  [anon_sym_offsetof] = anon_sym_offsetof,
  [anon_sym__Generic] = anon_sym__Generic,
  [anon_sym_asm] = anon_sym_asm,
  [anon_sym___asm__] = anon_sym___asm__,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_DOT_STAR] = anon_sym_DOT_STAR,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [sym_number_literal] = sym_number_literal,
  [anon_sym_L_SQUOTE] = anon_sym_L_SQUOTE,
  [anon_sym_u_SQUOTE] = anon_sym_u_SQUOTE,
  [anon_sym_U_SQUOTE] = anon_sym_U_SQUOTE,
  [anon_sym_u8_SQUOTE] = anon_sym_u8_SQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_char_literal_token1] = aux_sym_char_literal_token1,
  [anon_sym_L_DQUOTE] = anon_sym_L_DQUOTE,
  [anon_sym_u_DQUOTE] = anon_sym_u_DQUOTE,
  [anon_sym_U_DQUOTE] = anon_sym_U_DQUOTE,
  [anon_sym_u8_DQUOTE] = anon_sym_u8_DQUOTE,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_literal_token1] = aux_sym_string_literal_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_system_lib_string] = sym_system_lib_string,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [anon_sym_NULL] = anon_sym_NULL,
  [anon_sym_nullptr] = anon_sym_nullptr,
  [sym_comment] = sym_comment,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_This] = anon_sym_This,
  [sym_auto] = sym_auto,
  [anon_sym_decltype] = anon_sym_decltype,
  [anon_sym_final] = anon_sym_final,
  [anon_sym_override] = anon_sym_override,
  [sym_virtual] = sym_virtual,
  [anon_sym_explicit] = anon_sym_explicit,
  [anon_sym_typename] = anon_sym_typename,
  [anon_sym_template] = anon_sym_template,
  [anon_sym_GT2] = anon_sym_GT,
  [anon_sym_operator] = anon_sym_operator,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_0] = anon_sym_0,
  [anon_sym_friend] = anon_sym_friend,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_noexcept] = anon_sym_noexcept,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_using] = anon_sym_using,
  [anon_sym_static_assert] = anon_sym_static_assert,
  [anon_sym_concept] = anon_sym_concept,
  [anon_sym_co_return] = anon_sym_co_return,
  [anon_sym_co_yield] = anon_sym_co_yield,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_R_DQUOTE] = anon_sym_R_DQUOTE,
  [anon_sym_LR_DQUOTE] = anon_sym_LR_DQUOTE,
  [anon_sym_uR_DQUOTE] = anon_sym_uR_DQUOTE,
  [anon_sym_UR_DQUOTE] = anon_sym_UR_DQUOTE,
  [anon_sym_u8R_DQUOTE] = anon_sym_u8R_DQUOTE,
  [anon_sym_co_await] = anon_sym_co_await,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_requires] = anon_sym_requires,
  [anon_sym_DASH_GT_STAR] = anon_sym_DASH_GT_STAR,
  [anon_sym_LPAREN_RPAREN] = anon_sym_LPAREN_RPAREN,
  [anon_sym_LBRACK_RBRACK] = anon_sym_LBRACK_RBRACK,
  [anon_sym_DQUOTE_DQUOTE] = anon_sym_DQUOTE_DQUOTE,
  [sym_this] = sym_this,
  [sym_literal_suffix] = sym_literal_suffix,
  [anon_sym_discard] = anon_sym_discard,
  [anon_sym_precise] = anon_sym_precise,
  [anon_sym_shared] = anon_sym_shared,
  [anon_sym_groupshared] = anon_sym_groupshared,
  [anon_sym_uniform] = anon_sym_uniform,
  [anon_sym_row_major] = anon_sym_row_major,
  [anon_sym_column_major] = anon_sym_column_major,
  [anon_sym_globallycoherent] = anon_sym_globallycoherent,
  [anon_sym_centroid] = anon_sym_centroid,
  [anon_sym_noperspective] = anon_sym_noperspective,
  [anon_sym_nointerpolation] = anon_sym_nointerpolation,
  [anon_sym_sample] = anon_sym_sample,
  [anon_sym_linear] = anon_sym_linear,
  [anon_sym_snorm] = anon_sym_snorm,
  [anon_sym_unorm] = anon_sym_unorm,
  [anon_sym_point] = anon_sym_point,
  [anon_sym_line] = anon_sym_line,
  [anon_sym_triangleadj] = anon_sym_triangleadj,
  [anon_sym_lineadj] = anon_sym_lineadj,
  [anon_sym_triangle] = anon_sym_triangle,
  [anon_sym_cbuffer] = anon_sym_cbuffer,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_extension] = anon_sym_extension,
  [anon_sym_where] = anon_sym_where,
  [anon_sym___exported] = anon_sym___exported,
  [anon_sym_import] = anon_sym_import,
  [anon_sym___init] = anon_sym___init,
  [anon_sym___subscript] = anon_sym___subscript,
  [anon_sym_property] = anon_sym_property,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_associatedtype] = anon_sym_associatedtype,
  [sym_raw_string_delimiter] = sym_raw_string_delimiter,
  [sym_raw_string_content] = sym_raw_string_content,
  [sym_translation_unit] = sym_translation_unit,
  [sym__top_level_item] = sym__top_level_item,
  [sym__block_item] = sym__block_item,
  [sym_preproc_include] = sym_preproc_include,
  [sym_preproc_def] = sym_preproc_def,
  [sym_preproc_function_def] = sym_preproc_function_def,
  [sym_preproc_params] = sym_preproc_params,
  [sym_preproc_call] = sym_preproc_call,
  [sym_preproc_if] = sym_preproc_if,
  [sym_preproc_ifdef] = sym_preproc_ifdef,
  [sym_preproc_else] = sym_preproc_else,
  [sym_preproc_elif] = sym_preproc_elif,
  [sym_preproc_elifdef] = sym_preproc_elifdef,
  [sym_preproc_if_in_field_declaration_list] = sym_preproc_if,
  [sym_preproc_ifdef_in_field_declaration_list] = sym_preproc_ifdef,
  [sym_preproc_else_in_field_declaration_list] = sym_preproc_else,
  [sym_preproc_elif_in_field_declaration_list] = sym_preproc_elif,
  [sym_preproc_elifdef_in_field_declaration_list] = sym_preproc_elifdef,
  [sym_preproc_if_in_enumerator_list] = sym_preproc_if,
  [sym_preproc_ifdef_in_enumerator_list] = sym_preproc_ifdef,
  [sym_preproc_else_in_enumerator_list] = sym_preproc_else,
  [sym_preproc_elif_in_enumerator_list] = sym_preproc_elif,
  [sym_preproc_elifdef_in_enumerator_list] = sym_preproc_elifdef,
  [sym_preproc_if_in_enumerator_list_no_comma] = sym_preproc_if,
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = sym_preproc_ifdef,
  [sym_preproc_else_in_enumerator_list_no_comma] = sym_preproc_else,
  [sym_preproc_elif_in_enumerator_list_no_comma] = sym_preproc_elif,
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = sym_preproc_elifdef,
  [sym__preproc_expression] = sym__preproc_expression,
  [sym_preproc_parenthesized_expression] = sym_parenthesized_expression,
  [sym_preproc_defined] = sym_preproc_defined,
  [sym_preproc_unary_expression] = sym_unary_expression,
  [sym_preproc_call_expression] = sym_call_expression,
  [sym_preproc_argument_list] = sym_argument_list,
  [sym_preproc_binary_expression] = sym_binary_expression,
  [sym_function_definition] = sym_function_definition,
  [sym_declaration] = sym_declaration,
  [sym_type_definition] = sym_type_definition,
  [sym__type_definition_type] = sym__type_definition_type,
  [sym__type_definition_declarators] = sym__type_definition_declarators,
  [sym__declaration_modifiers] = sym__declaration_modifiers,
  [sym__declaration_specifiers] = sym__declaration_specifiers,
  [sym_linkage_specification] = sym_linkage_specification,
  [sym_attribute_specifier] = sym_attribute_specifier,
  [sym_attribute] = sym_attribute,
  [sym_attribute_declaration] = sym_attribute_declaration,
  [sym_ms_declspec_modifier] = sym_ms_declspec_modifier,
  [sym_ms_based_modifier] = sym_ms_based_modifier,
  [sym_ms_call_modifier] = sym_ms_call_modifier,
  [sym_ms_unaligned_ptr_modifier] = sym_ms_unaligned_ptr_modifier,
  [sym_ms_pointer_modifier] = sym_ms_pointer_modifier,
  [sym_declaration_list] = sym_declaration_list,
  [sym__declarator] = sym__declarator,
  [sym__field_declarator] = sym__field_declarator,
  [sym__type_declarator] = sym__type_declarator,
  [sym__abstract_declarator] = sym__abstract_declarator,
  [sym_parenthesized_declarator] = sym_parenthesized_declarator,
  [sym_parenthesized_field_declarator] = sym_parenthesized_declarator,
  [sym_parenthesized_type_declarator] = sym_parenthesized_declarator,
  [sym_abstract_parenthesized_declarator] = sym_abstract_parenthesized_declarator,
  [sym_attributed_declarator] = sym_attributed_declarator,
  [sym_attributed_field_declarator] = sym_attributed_declarator,
  [sym_attributed_type_declarator] = sym_attributed_declarator,
  [sym_pointer_declarator] = sym_pointer_declarator,
  [sym_pointer_field_declarator] = sym_pointer_declarator,
  [sym_pointer_type_declarator] = sym_pointer_type_declarator,
  [sym_abstract_pointer_declarator] = sym_abstract_pointer_declarator,
  [sym_function_declarator] = sym_function_declarator,
  [sym_function_field_declarator] = sym_function_declarator,
  [sym_function_type_declarator] = sym_function_declarator,
  [sym_abstract_function_declarator] = sym_abstract_function_declarator,
  [sym_array_declarator] = sym_array_declarator,
  [sym_array_field_declarator] = sym_array_declarator,
  [sym_array_type_declarator] = sym_array_declarator,
  [sym_abstract_array_declarator] = sym_abstract_array_declarator,
  [sym_init_declarator] = sym_init_declarator,
  [sym_compound_statement] = sym_compound_statement,
  [sym_storage_class_specifier] = sym_storage_class_specifier,
  [sym_type_qualifier] = sym_type_qualifier,
  [sym_alignas_qualifier] = sym_alignas_qualifier,
  [sym_type_specifier] = sym_type_specifier,
  [sym_sized_type_specifier] = sym_sized_type_specifier,
  [sym_enum_specifier] = sym_enum_specifier,
  [sym_enumerator_list] = sym_enumerator_list,
  [sym_struct_specifier] = sym_struct_specifier,
  [sym_union_specifier] = sym_union_specifier,
  [sym_field_declaration_list] = sym_field_declaration_list,
  [sym__field_declaration_list_item] = sym__field_declaration_list_item,
  [sym_field_declaration] = sym_field_declaration,
  [sym_bitfield_clause] = sym_bitfield_clause,
  [sym_enumerator] = sym_enumerator,
  [sym_parameter_list] = sym_parameter_list,
  [sym_parameter_declaration] = sym_parameter_declaration,
  [sym_attributed_statement] = sym_attributed_statement,
  [sym_statement] = sym_statement,
  [sym__top_level_statement] = sym__top_level_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym__top_level_expression_statement] = sym_expression_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_else_clause] = sym_else_clause,
  [sym_switch_statement] = sym_switch_statement,
  [sym_case_statement] = sym_case_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_for_statement] = sym_for_statement,
  [sym__for_statement_body] = sym__for_statement_body,
  [sym_return_statement] = sym_return_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_goto_statement] = sym_goto_statement,
  [sym_seh_try_statement] = sym_seh_try_statement,
  [sym_seh_except_clause] = sym_seh_except_clause,
  [sym_seh_finally_clause] = sym_seh_finally_clause,
  [sym_seh_leave_statement] = sym_seh_leave_statement,
  [sym_expression] = sym_expression,
  [sym__string] = sym__string,
  [sym_comma_expression] = sym_comma_expression,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_pointer_expression] = sym_pointer_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_type_descriptor] = sym_type_descriptor,
  [sym_sizeof_expression] = sym_sizeof_expression,
  [sym_alignof_expression] = sym_alignof_expression,
  [sym_offsetof_expression] = sym_offsetof_expression,
  [sym_generic_expression] = sym_generic_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_gnu_asm_expression] = sym_gnu_asm_expression,
  [sym_gnu_asm_qualifier] = sym_gnu_asm_qualifier,
  [sym_gnu_asm_output_operand_list] = sym_gnu_asm_output_operand_list,
  [sym_gnu_asm_output_operand] = sym_gnu_asm_output_operand,
  [sym_gnu_asm_input_operand_list] = sym_gnu_asm_input_operand_list,
  [sym_gnu_asm_input_operand] = sym_gnu_asm_input_operand,
  [sym_gnu_asm_clobber_list] = sym_gnu_asm_clobber_list,
  [sym_gnu_asm_goto_list] = sym_gnu_asm_goto_list,
  [sym_argument_list] = sym_argument_list,
  [sym_field_expression] = sym_field_expression,
  [sym_compound_literal_expression] = sym_compound_literal_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_initializer_list] = sym_initializer_list,
  [sym_initializer_pair] = sym_initializer_pair,
  [sym_subscript_designator] = sym_subscript_designator,
  [sym_subscript_range_designator] = sym_subscript_range_designator,
  [sym_field_designator] = sym_field_designator,
  [sym_char_literal] = sym_char_literal,
  [sym_concatenated_string] = sym_concatenated_string,
  [sym_string_literal] = sym_string_literal,
  [sym_null] = sym_null,
  [sym__empty_declaration] = sym__empty_declaration,
  [sym_placeholder_type_specifier] = sym_placeholder_type_specifier,
  [sym_decltype] = sym_decltype,
  [sym__class_declaration] = sym__class_declaration,
  [sym__class_declaration_item] = sym__class_declaration_item,
  [sym_class_specifier] = sym_class_specifier,
  [sym__class_name] = sym__class_name,
  [sym_virtual_specifier] = sym_virtual_specifier,
  [sym_explicit_function_specifier] = sym_explicit_function_specifier,
  [sym_base_class_clause] = sym_base_class_clause,
  [sym__enum_base_clause] = sym__enum_base_clause,
  [sym_dependent_type] = sym_dependent_type,
  [sym_template_declaration] = sym_template_declaration,
  [sym_template_instantiation] = sym_template_instantiation,
  [sym_template_parameter_list] = sym_template_parameter_list,
  [sym_type_parameter_declaration] = sym_type_parameter_declaration,
  [sym_variadic_type_parameter_declaration] = sym_variadic_type_parameter_declaration,
  [sym_optional_type_parameter_declaration] = sym_optional_type_parameter_declaration,
  [sym_template_template_parameter_declaration] = sym_template_template_parameter_declaration,
  [sym_optional_parameter_declaration] = sym_optional_parameter_declaration,
  [sym_variadic_parameter_declaration] = sym_variadic_parameter_declaration,
  [sym_variadic_declarator] = sym_variadic_declarator,
  [sym_variadic_reference_declarator] = sym_reference_declarator,
  [sym_operator_cast] = sym_operator_cast,
  [sym_field_initializer_list] = sym_field_initializer_list,
  [sym_field_initializer] = sym_field_initializer,
  [sym_inline_method_definition] = sym_function_definition,
  [sym__constructor_specifiers] = sym__constructor_specifiers,
  [sym_operator_cast_definition] = sym_function_definition,
  [sym_operator_cast_declaration] = sym_declaration,
  [sym_constructor_try_statement] = sym_try_statement,
  [sym_constructor_or_destructor_definition] = sym_function_definition,
  [sym_constructor_or_destructor_declaration] = sym_declaration,
  [sym_default_method_clause] = sym_default_method_clause,
  [sym_delete_method_clause] = sym_delete_method_clause,
  [sym_pure_virtual_clause] = sym_pure_virtual_clause,
  [sym_friend_declaration] = sym_friend_declaration,
  [sym_access_specifier] = sym_access_specifier,
  [sym_reference_declarator] = sym_reference_declarator,
  [sym_reference_field_declarator] = sym_reference_declarator,
  [sym_reference_type_declarator] = sym_reference_declarator,
  [sym_abstract_reference_declarator] = sym_abstract_reference_declarator,
  [sym_structured_binding_declarator] = sym_structured_binding_declarator,
  [sym_ref_qualifier] = sym_ref_qualifier,
  [sym__function_declarator_seq] = sym__function_declarator_seq,
  [sym__function_attributes_start] = sym__function_attributes_start,
  [sym__function_exception_specification] = sym__function_exception_specification,
  [sym__function_attributes_end] = sym__function_attributes_end,
  [sym__function_postfix] = sym__function_postfix,
  [sym_trailing_return_type] = sym_trailing_return_type,
  [sym_noexcept] = sym_noexcept,
  [sym_throw_specifier] = sym_throw_specifier,
  [sym_template_type] = sym_template_type,
  [sym_template_method] = sym_template_method,
  [sym_template_function] = sym_template_function,
  [sym_template_argument_list] = sym_template_argument_list,
  [sym_namespace_definition] = sym_namespace_definition,
  [sym_namespace_alias_definition] = sym_namespace_alias_definition,
  [sym__namespace_specifier] = sym__namespace_specifier,
  [sym_nested_namespace_specifier] = sym_nested_namespace_specifier,
  [sym_using_declaration] = sym_using_declaration,
  [sym_alias_declaration] = sym_alias_declaration,
  [sym_static_assert_declaration] = sym_static_assert_declaration,
  [sym_concept_definition] = sym_concept_definition,
  [sym_for_range_loop] = sym_for_range_loop,
  [sym__for_range_loop_body] = sym__for_range_loop_body,
  [sym_init_statement] = sym_init_statement,
  [sym_condition_clause] = sym_condition_clause,
  [sym_condition_declaration] = sym_declaration,
  [sym_co_return_statement] = sym_co_return_statement,
  [sym_co_yield_statement] = sym_co_yield_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_clause] = sym_catch_clause,
  [sym_raw_string_literal] = sym_raw_string_literal,
  [sym_subscript_argument_list] = sym_subscript_argument_list,
  [sym_co_await_expression] = sym_co_await_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_new_declarator] = sym_new_declarator,
  [sym_delete_expression] = sym_delete_expression,
  [sym_type_requirement] = sym_type_requirement,
  [sym_compound_requirement] = sym_compound_requirement,
  [sym__requirement] = sym__requirement,
  [sym_requirement_seq] = sym_requirement_seq,
  [sym_constraint_conjunction] = sym_constraint_conjunction,
  [sym_constraint_disjunction] = sym_constraint_disjunction,
  [sym__requirement_clause_constraint] = sym__requirement_clause_constraint,
  [sym_requires_clause] = sym_requires_clause,
  [sym_requires_parameter_list] = sym_parameter_list,
  [sym_requires_expression] = sym_requires_expression,
  [sym_lambda_expression] = sym_lambda_expression,
  [sym_lambda_capture_specifier] = sym_lambda_capture_specifier,
  [sym_lambda_default_capture] = sym_lambda_default_capture,
  [sym__fold_operator] = sym__fold_operator,
  [sym__binary_fold_operator] = sym__binary_fold_operator,
  [sym__unary_left_fold] = sym__unary_left_fold,
  [sym__unary_right_fold] = sym__unary_right_fold,
  [sym__binary_fold] = sym__binary_fold,
  [sym_fold_expression] = sym_fold_expression,
  [sym_parameter_pack_expansion] = sym_parameter_pack_expansion,
  [sym_type_parameter_pack_expansion] = sym_parameter_pack_expansion,
  [sym_destructor_name] = sym_destructor_name,
  [sym_dependent_identifier] = sym_dependent_identifier,
  [sym_dependent_field_identifier] = sym_dependent_identifier,
  [sym_dependent_type_identifier] = sym_dependent_identifier,
  [sym__scope_resolution] = sym__scope_resolution,
  [sym_qualified_field_identifier] = sym_qualified_identifier,
  [sym_qualified_identifier] = sym_qualified_identifier,
  [sym_qualified_type_identifier] = sym_qualified_identifier,
  [sym_qualified_operator_cast_identifier] = sym_qualified_identifier,
  [sym__assignment_expression_lhs] = sym_assignment_expression,
  [sym_operator_name] = sym_operator_name,
  [sym_user_defined_literal] = sym_user_defined_literal,
  [sym_semantics] = sym_semantics,
  [sym_discard_statement] = sym_discard_statement,
  [sym_qualifiers] = sym_qualifiers,
  [sym_cbuffer_specifier] = sym_cbuffer_specifier,
  [sym_hlsl_attribute] = sym_hlsl_attribute,
  [sym_type_hinted_declarator] = sym_type_hinted_declarator,
  [sym_type_hint] = sym_type_hint,
  [sym_interface_specifier] = sym_interface_specifier,
  [sym_extension_specifier] = sym_extension_specifier,
  [sym_interface_requirements] = sym_interface_requirements,
  [sym_where_clause] = sym_where_clause,
  [sym_import_statement] = sym_import_statement,
  [sym_init_declaration] = sym_init_declaration,
  [sym_subscript_declaration] = sym_subscript_declaration,
  [sym_property_declaration] = sym_property_declaration,
  [sym_property_get] = sym_property_get,
  [sym_property_set] = sym_property_set,
  [sym_associatedtype_declaration] = sym_associatedtype_declaration,
  [sym_associatedtype_specifier] = sym_associatedtype_specifier,
  [aux_sym_translation_unit_repeat1] = aux_sym_translation_unit_repeat1,
  [aux_sym_preproc_params_repeat1] = aux_sym_preproc_params_repeat1,
  [aux_sym_preproc_if_repeat1] = aux_sym_preproc_if_repeat1,
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = aux_sym_preproc_if_in_enumerator_list_repeat1,
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [aux_sym_preproc_argument_list_repeat1] = aux_sym_preproc_argument_list_repeat1,
  [aux_sym_declaration_repeat1] = aux_sym_declaration_repeat1,
  [aux_sym_type_definition_repeat1] = aux_sym_type_definition_repeat1,
  [aux_sym__type_definition_type_repeat1] = aux_sym__type_definition_type_repeat1,
  [aux_sym__type_definition_declarators_repeat1] = aux_sym__type_definition_declarators_repeat1,
  [aux_sym__declaration_specifiers_repeat1] = aux_sym__declaration_specifiers_repeat1,
  [aux_sym_attribute_declaration_repeat1] = aux_sym_attribute_declaration_repeat1,
  [aux_sym_declaration_list_repeat1] = aux_sym_declaration_list_repeat1,
  [aux_sym_attributed_declarator_repeat1] = aux_sym_attributed_declarator_repeat1,
  [aux_sym_pointer_declarator_repeat1] = aux_sym_pointer_declarator_repeat1,
  [aux_sym_array_declarator_repeat1] = aux_sym_array_declarator_repeat1,
  [aux_sym_sized_type_specifier_repeat1] = aux_sym_sized_type_specifier_repeat1,
  [aux_sym_enumerator_list_repeat1] = aux_sym_enumerator_list_repeat1,
  [aux_sym_field_declaration_repeat1] = aux_sym_field_declaration_repeat1,
  [aux_sym_parameter_list_repeat1] = aux_sym_parameter_list_repeat1,
  [aux_sym_case_statement_repeat1] = aux_sym_case_statement_repeat1,
  [aux_sym_generic_expression_repeat1] = aux_sym_generic_expression_repeat1,
  [aux_sym_gnu_asm_expression_repeat1] = aux_sym_gnu_asm_expression_repeat1,
  [aux_sym_gnu_asm_output_operand_list_repeat1] = aux_sym_gnu_asm_output_operand_list_repeat1,
  [aux_sym_gnu_asm_input_operand_list_repeat1] = aux_sym_gnu_asm_input_operand_list_repeat1,
  [aux_sym_gnu_asm_clobber_list_repeat1] = aux_sym_gnu_asm_clobber_list_repeat1,
  [aux_sym_gnu_asm_goto_list_repeat1] = aux_sym_gnu_asm_goto_list_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_initializer_list_repeat1] = aux_sym_initializer_list_repeat1,
  [aux_sym_initializer_pair_repeat1] = aux_sym_initializer_pair_repeat1,
  [aux_sym_char_literal_repeat1] = aux_sym_char_literal_repeat1,
  [aux_sym_concatenated_string_repeat1] = aux_sym_concatenated_string_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [aux_sym__class_declaration_repeat1] = aux_sym__class_declaration_repeat1,
  [aux_sym_base_class_clause_repeat1] = aux_sym_base_class_clause_repeat1,
  [aux_sym_template_parameter_list_repeat1] = aux_sym_template_parameter_list_repeat1,
  [aux_sym_field_initializer_list_repeat1] = aux_sym_field_initializer_list_repeat1,
  [aux_sym_operator_cast_definition_repeat1] = aux_sym_operator_cast_definition_repeat1,
  [aux_sym_constructor_try_statement_repeat1] = aux_sym_constructor_try_statement_repeat1,
  [aux_sym_structured_binding_declarator_repeat1] = aux_sym_structured_binding_declarator_repeat1,
  [aux_sym__function_postfix_repeat1] = aux_sym__function_postfix_repeat1,
  [aux_sym_throw_specifier_repeat1] = aux_sym_throw_specifier_repeat1,
  [aux_sym_template_argument_list_repeat1] = aux_sym_template_argument_list_repeat1,
  [aux_sym_subscript_argument_list_repeat1] = aux_sym_subscript_argument_list_repeat1,
  [aux_sym_requirement_seq_repeat1] = aux_sym_requirement_seq_repeat1,
  [aux_sym_requires_parameter_list_repeat1] = aux_sym_requires_parameter_list_repeat1,
  [aux_sym_lambda_capture_specifier_repeat1] = aux_sym_lambda_capture_specifier_repeat1,
  [aux_sym_interface_requirements_repeat1] = aux_sym_interface_requirements_repeat1,
  [aux_sym_where_clause_repeat1] = aux_sym_where_clause_repeat1,
  [aux_sym_import_statement_repeat1] = aux_sym_import_statement_repeat1,
  [aux_sym_subscript_declaration_repeat1] = aux_sym_subscript_declaration_repeat1,
  [alias_sym_field_identifier] = alias_sym_field_identifier,
  [alias_sym_namespace_identifier] = alias_sym_namespace_identifier,
  [alias_sym_simple_requirement] = alias_sym_simple_requirement,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_preproc_include_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_include_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_def_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_else_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elif_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elifdef_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elifdef_token2] = {
    .visible = true,
    .named = false,
  },
  [sym_preproc_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_directive] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defined] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___extension__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typedef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_out] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inout] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___attribute__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___declspec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___based] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___cdecl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___clrcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___stdcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___fastcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___thiscall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___vectorcall] = {
    .visible = true,
    .named = false,
  },
  [sym_ms_restrict_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_unsigned_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_signed_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym__unaligned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___unaligned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_signed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsigned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_long] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_short] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_register] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___inline__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___forceinline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_thread_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___thread] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constexpr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_restrict] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___restrict__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Atomic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Noreturn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noreturn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mutable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constinit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_consteval] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alignas] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Alignas] = {
    .visible = true,
    .named = false,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___except] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___leave] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xor_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_compl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bitor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bitand] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sizeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___alignof__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_offsetof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Generic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___asm__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_L_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_U_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_char_literal_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_L_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_U_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_literal_token1] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_system_lib_string] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_NULL] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nullptr] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_This] = {
    .visible = true,
    .named = false,
  },
  [sym_auto] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_decltype] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_final] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [sym_virtual] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_explicit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typename] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_template] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_operator] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_0] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_friend] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noexcept] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_concept] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_co_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_co_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_R_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_UR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8R_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_co_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_requires] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_suffix] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_discard] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_precise] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_shared] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_groupshared] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uniform] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_row_major] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_column_major] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_globallycoherent] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_centroid] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noperspective] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nointerpolation] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sample] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_linear] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_snorm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unorm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_point] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_line] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_triangleadj] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lineadj] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_triangle] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cbuffer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extension] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_where] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___exported] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___init] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___subscript] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_property] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_associatedtype] = {
    .visible = true,
    .named = false,
  },
  [sym_raw_string_delimiter] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym_translation_unit] = {
    .visible = true,
    .named = true,
  },
  [sym__top_level_item] = {
    .visible = false,
    .named = true,
  },
  [sym__block_item] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_include] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_function_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_params] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym__preproc_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_defined] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__type_definition_type] = {
    .visible = false,
    .named = true,
  },
  [sym__type_definition_declarators] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration_modifiers] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration_specifiers] = {
    .visible = false,
    .named = true,
  },
  [sym_linkage_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_declspec_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_based_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_call_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_unaligned_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_pointer_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__field_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__type_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__abstract_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_parenthesized_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_parenthesized_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_init_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_storage_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_alignas_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_specifier] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_sized_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_union_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__field_declaration_list_item] = {
    .visible = false,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_bitfield_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__top_level_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__top_level_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_statement_body] = {
    .visible = false,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_except_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_leave_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__string] = {
    .visible = false,
    .named = true,
  },
  [sym_comma_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym_sizeof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_alignof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_offsetof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_output_operand_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_output_operand] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_input_operand_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_input_operand] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_clobber_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_goto_list] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_literal_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_range_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_field_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_char_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_placeholder_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_decltype] = {
    .visible = true,
    .named = true,
  },
  [sym__class_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym__class_declaration_item] = {
    .visible = false,
    .named = true,
  },
  [sym_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym__class_name] = {
    .visible = false,
    .named = true,
  },
  [sym_virtual_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_explicit_function_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_base_class_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__enum_base_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_dependent_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_template_instantiation] = {
    .visible = true,
    .named = true,
  },
  [sym_template_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_template_template_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_cast] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_inline_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__constructor_specifiers] = {
    .visible = false,
    .named = true,
  },
  [sym_operator_cast_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_cast_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_or_destructor_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_or_destructor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_default_method_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_method_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_pure_virtual_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_friend_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_access_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_structured_binding_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_ref_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym__function_declarator_seq] = {
    .visible = false,
    .named = true,
  },
  [sym__function_attributes_start] = {
    .visible = false,
    .named = true,
  },
  [sym__function_exception_specification] = {
    .visible = false,
    .named = true,
  },
  [sym__function_attributes_end] = {
    .visible = false,
    .named = true,
  },
  [sym__function_postfix] = {
    .visible = false,
    .named = true,
  },
  [sym_trailing_return_type] = {
    .visible = true,
    .named = true,
  },
  [sym_noexcept] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_template_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_method] = {
    .visible = true,
    .named = true,
  },
  [sym_template_function] = {
    .visible = true,
    .named = true,
  },
  [sym_template_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_alias_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__namespace_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym_nested_namespace_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_using_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_static_assert_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_concept_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_for_range_loop] = {
    .visible = true,
    .named = true,
  },
  [sym__for_range_loop_body] = {
    .visible = false,
    .named = true,
  },
  [sym_init_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_condition_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_condition_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_co_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_co_yield_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_co_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_requirement] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_requirement] = {
    .visible = true,
    .named = true,
  },
  [sym__requirement] = {
    .visible = false,
    .named = true,
  },
  [sym_requirement_seq] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint_conjunction] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint_disjunction] = {
    .visible = true,
    .named = true,
  },
  [sym__requirement_clause_constraint] = {
    .visible = false,
    .named = true,
  },
  [sym_requires_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_requires_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_requires_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_capture_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_default_capture] = {
    .visible = true,
    .named = true,
  },
  [sym__fold_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__binary_fold_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_left_fold] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_right_fold] = {
    .visible = false,
    .named = true,
  },
  [sym__binary_fold] = {
    .visible = false,
    .named = true,
  },
  [sym_fold_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_pack_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_pack_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_destructor_name] = {
    .visible = true,
    .named = true,
  },
  [sym_dependent_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_dependent_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_dependent_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__scope_resolution] = {
    .visible = false,
    .named = true,
  },
  [sym_qualified_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_operator_cast_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__assignment_expression_lhs] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_name] = {
    .visible = true,
    .named = true,
  },
  [sym_user_defined_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_semantics] = {
    .visible = true,
    .named = true,
  },
  [sym_discard_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_qualifiers] = {
    .visible = true,
    .named = true,
  },
  [sym_cbuffer_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hlsl_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_type_hinted_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_type_hint] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_extension_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_requirements] = {
    .visible = true,
    .named = true,
  },
  [sym_where_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_init_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_property_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_property_get] = {
    .visible = true,
    .named = true,
  },
  [sym_property_set] = {
    .visible = true,
    .named = true,
  },
  [sym_associatedtype_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_associatedtype_specifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_translation_unit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_params_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_definition_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_definition_declarators_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__declaration_specifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attributed_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pointer_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sized_type_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_generic_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_output_operand_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_input_operand_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_clobber_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_goto_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_pair_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_char_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__class_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_base_class_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_operator_cast_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constructor_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_structured_binding_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__function_postfix_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_throw_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_subscript_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_requirement_seq_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_requires_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_lambda_capture_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interface_requirements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_where_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_subscript_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_namespace_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_simple_requirement] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_argument = 2,
  field_arguments = 3,
  field_assembly_code = 4,
  field_base = 5,
  field_body = 6,
  field_captures = 7,
  field_clobbers = 8,
  field_condition = 9,
  field_consequence = 10,
  field_constraint = 11,
  field_declarator = 12,
  field_default_type = 13,
  field_default_value = 14,
  field_delimiter = 15,
  field_designator = 16,
  field_directive = 17,
  field_end = 18,
  field_field = 19,
  field_filter = 20,
  field_function = 21,
  field_goto_labels = 22,
  field_indices = 23,
  field_initializer = 24,
  field_input_operands = 25,
  field_label = 26,
  field_left = 27,
  field_length = 28,
  field_member = 29,
  field_message = 30,
  field_name = 31,
  field_operand = 32,
  field_operator = 33,
  field_output_operands = 34,
  field_parameters = 35,
  field_path = 36,
  field_pattern = 37,
  field_placement = 38,
  field_prefix = 39,
  field_register = 40,
  field_requirements = 41,
  field_right = 42,
  field_scope = 43,
  field_size = 44,
  field_start = 45,
  field_symbol = 46,
  field_template_parameters = 47,
  field_type = 48,
  field_update = 49,
  field_value = 50,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_assembly_code] = "assembly_code",
  [field_base] = "base",
  [field_body] = "body",
  [field_captures] = "captures",
  [field_clobbers] = "clobbers",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constraint] = "constraint",
  [field_declarator] = "declarator",
  [field_default_type] = "default_type",
  [field_default_value] = "default_value",
  [field_delimiter] = "delimiter",
  [field_designator] = "designator",
  [field_directive] = "directive",
  [field_end] = "end",
  [field_field] = "field",
  [field_filter] = "filter",
  [field_function] = "function",
  [field_goto_labels] = "goto_labels",
  [field_indices] = "indices",
  [field_initializer] = "initializer",
  [field_input_operands] = "input_operands",
  [field_label] = "label",
  [field_left] = "left",
  [field_length] = "length",
  [field_member] = "member",
  [field_message] = "message",
  [field_name] = "name",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_output_operands] = "output_operands",
  [field_parameters] = "parameters",
  [field_path] = "path",
  [field_pattern] = "pattern",
  [field_placement] = "placement",
  [field_prefix] = "prefix",
  [field_register] = "register",
  [field_requirements] = "requirements",
  [field_right] = "right",
  [field_scope] = "scope",
  [field_size] = "size",
  [field_start] = "start",
  [field_symbol] = "symbol",
  [field_template_parameters] = "template_parameters",
  [field_type] = "type",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 2},
  [5] = {.index = 4, .length = 1},
  [6] = {.index = 5, .length = 1},
  [7] = {.index = 6, .length = 2},
  [8] = {.index = 8, .length = 2},
  [9] = {.index = 10, .length = 1},
  [10] = {.index = 11, .length = 1},
  [11] = {.index = 12, .length = 1},
  [12] = {.index = 13, .length = 2},
  [13] = {.index = 15, .length = 2},
  [14] = {.index = 17, .length = 1},
  [15] = {.index = 18, .length = 1},
  [16] = {.index = 19, .length = 2},
  [17] = {.index = 19, .length = 2},
  [18] = {.index = 0, .length = 1},
  [20] = {.index = 21, .length = 1},
  [21] = {.index = 22, .length = 1},
  [22] = {.index = 23, .length = 1},
  [23] = {.index = 24, .length = 1},
  [24] = {.index = 25, .length = 2},
  [25] = {.index = 27, .length = 2},
  [26] = {.index = 29, .length = 1},
  [27] = {.index = 30, .length = 1},
  [28] = {.index = 31, .length = 1},
  [29] = {.index = 32, .length = 2},
  [30] = {.index = 34, .length = 2},
  [31] = {.index = 18, .length = 1},
  [32] = {.index = 36, .length = 2},
  [33] = {.index = 38, .length = 1},
  [34] = {.index = 39, .length = 2},
  [35] = {.index = 39, .length = 2},
  [36] = {.index = 21, .length = 1},
  [37] = {.index = 41, .length = 1},
  [38] = {.index = 42, .length = 2},
  [39] = {.index = 44, .length = 2},
  [40] = {.index = 46, .length = 3},
  [41] = {.index = 49, .length = 1},
  [44] = {.index = 50, .length = 2},
  [45] = {.index = 52, .length = 1},
  [46] = {.index = 53, .length = 1},
  [47] = {.index = 54, .length = 1},
  [48] = {.index = 55, .length = 2},
  [49] = {.index = 57, .length = 2},
  [50] = {.index = 59, .length = 2},
  [51] = {.index = 61, .length = 2},
  [52] = {.index = 63, .length = 2},
  [53] = {.index = 65, .length = 1},
  [54] = {.index = 66, .length = 1},
  [55] = {.index = 67, .length = 3},
  [56] = {.index = 70, .length = 1},
  [57] = {.index = 71, .length = 1},
  [58] = {.index = 72, .length = 2},
  [60] = {.index = 55, .length = 2},
  [61] = {.index = 74, .length = 2},
  [62] = {.index = 76, .length = 2},
  [63] = {.index = 78, .length = 2},
  [65] = {.index = 80, .length = 2},
  [66] = {.index = 82, .length = 2},
  [67] = {.index = 84, .length = 3},
  [68] = {.index = 87, .length = 2},
  [69] = {.index = 89, .length = 3},
  [70] = {.index = 89, .length = 3},
  [71] = {.index = 92, .length = 3},
  [72] = {.index = 95, .length = 3},
  [73] = {.index = 98, .length = 3},
  [74] = {.index = 101, .length = 2},
  [75] = {.index = 103, .length = 2},
  [76] = {.index = 105, .length = 2},
  [77] = {.index = 107, .length = 1},
  [78] = {.index = 108, .length = 2},
  [79] = {.index = 110, .length = 2},
  [80] = {.index = 112, .length = 2},
  [81] = {.index = 114, .length = 3},
  [82] = {.index = 117, .length = 2},
  [83] = {.index = 119, .length = 1},
  [84] = {.index = 120, .length = 2},
  [85] = {.index = 122, .length = 2},
  [86] = {.index = 124, .length = 2},
  [87] = {.index = 126, .length = 2},
  [88] = {.index = 128, .length = 2},
  [89] = {.index = 130, .length = 2},
  [90] = {.index = 132, .length = 2},
  [91] = {.index = 134, .length = 2},
  [92] = {.index = 136, .length = 1},
  [93] = {.index = 134, .length = 2},
  [95] = {.index = 137, .length = 2},
  [96] = {.index = 139, .length = 1},
  [97] = {.index = 139, .length = 1},
  [98] = {.index = 140, .length = 3},
  [100] = {.index = 143, .length = 2},
  [101] = {.index = 145, .length = 2},
  [102] = {.index = 147, .length = 2},
  [103] = {.index = 149, .length = 3},
  [104] = {.index = 152, .length = 1},
  [105] = {.index = 153, .length = 1},
  [107] = {.index = 154, .length = 3},
  [108] = {.index = 157, .length = 3},
  [109] = {.index = 160, .length = 3},
  [110] = {.index = 163, .length = 3},
  [111] = {.index = 166, .length = 2},
  [112] = {.index = 168, .length = 3},
  [113] = {.index = 171, .length = 2},
  [114] = {.index = 173, .length = 3},
  [115] = {.index = 176, .length = 2},
  [116] = {.index = 19, .length = 2},
  [117] = {.index = 39, .length = 2},
  [118] = {.index = 178, .length = 2},
  [119] = {.index = 180, .length = 2},
  [120] = {.index = 182, .length = 1},
  [121] = {.index = 183, .length = 4},
  [122] = {.index = 187, .length = 4},
  [123] = {.index = 191, .length = 2},
  [124] = {.index = 193, .length = 3},
  [125] = {.index = 196, .length = 2},
  [126] = {.index = 198, .length = 2},
  [127] = {.index = 200, .length = 1},
  [128] = {.index = 201, .length = 2},
  [129] = {.index = 203, .length = 2},
  [130] = {.index = 205, .length = 3},
  [131] = {.index = 208, .length = 3},
  [132] = {.index = 211, .length = 3},
  [133] = {.index = 214, .length = 2},
  [134] = {.index = 216, .length = 2},
  [135] = {.index = 216, .length = 2},
  [136] = {.index = 218, .length = 2},
  [137] = {.index = 218, .length = 2},
  [138] = {.index = 220, .length = 2},
  [139] = {.index = 222, .length = 3},
  [140] = {.index = 225, .length = 2},
  [141] = {.index = 227, .length = 2},
  [142] = {.index = 229, .length = 3},
  [143] = {.index = 232, .length = 2},
  [144] = {.index = 234, .length = 3},
  [145] = {.index = 237, .length = 2},
  [146] = {.index = 239, .length = 1},
  [147] = {.index = 240, .length = 2},
  [148] = {.index = 242, .length = 2},
  [149] = {.index = 244, .length = 4},
  [150] = {.index = 248, .length = 5},
  [151] = {.index = 253, .length = 1},
  [152] = {.index = 254, .length = 1},
  [153] = {.index = 255, .length = 2},
  [154] = {.index = 257, .length = 1},
  [156] = {.index = 258, .length = 1},
  [157] = {.index = 259, .length = 2},
  [158] = {.index = 261, .length = 2},
  [159] = {.index = 11, .length = 1},
  [160] = {.index = 11, .length = 1},
  [161] = {.index = 263, .length = 2},
  [162] = {.index = 265, .length = 1},
  [163] = {.index = 266, .length = 1},
  [164] = {.index = 267, .length = 4},
  [165] = {.index = 271, .length = 4},
  [166] = {.index = 275, .length = 1},
  [167] = {.index = 276, .length = 3},
  [168] = {.index = 279, .length = 2},
  [169] = {.index = 281, .length = 3},
  [170] = {.index = 284, .length = 1},
  [171] = {.index = 285, .length = 5},
  [172] = {.index = 290, .length = 2},
  [173] = {.index = 292, .length = 3},
  [174] = {.index = 295, .length = 2},
  [175] = {.index = 297, .length = 2},
  [176] = {.index = 299, .length = 4},
  [177] = {.index = 303, .length = 2},
  [178] = {.index = 305, .length = 2},
  [179] = {.index = 307, .length = 1},
  [180] = {.index = 308, .length = 2},
  [182] = {.index = 310, .length = 3},
  [183] = {.index = 313, .length = 4},
  [184] = {.index = 317, .length = 4},
  [185] = {.index = 321, .length = 3},
  [186] = {.index = 324, .length = 2},
  [187] = {.index = 326, .length = 3},
  [188] = {.index = 329, .length = 3},
  [189] = {.index = 332, .length = 2},
  [190] = {.index = 334, .length = 2},
  [191] = {.index = 336, .length = 2},
  [192] = {.index = 338, .length = 2},
  [193] = {.index = 340, .length = 3},
  [194] = {.index = 343, .length = 2},
  [195] = {.index = 345, .length = 2},
  [196] = {.index = 347, .length = 3},
  [197] = {.index = 350, .length = 2},
  [198] = {.index = 352, .length = 3},
  [199] = {.index = 355, .length = 5},
  [200] = {.index = 360, .length = 3},
  [201] = {.index = 363, .length = 4},
  [202] = {.index = 367, .length = 3},
  [203] = {.index = 370, .length = 2},
  [204] = {.index = 372, .length = 2},
  [207] = {.index = 374, .length = 2},
  [208] = {.index = 376, .length = 4},
  [209] = {.index = 380, .length = 5},
  [210] = {.index = 385, .length = 3},
  [211] = {.index = 388, .length = 4},
  [212] = {.index = 392, .length = 2},
  [213] = {.index = 394, .length = 1},
  [214] = {.index = 395, .length = 4},
  [215] = {.index = 399, .length = 3},
  [216] = {.index = 402, .length = 2},
  [217] = {.index = 404, .length = 1},
  [220] = {.index = 405, .length = 5},
  [221] = {.index = 410, .length = 2},
  [222] = {.index = 412, .length = 2},
  [223] = {.index = 65, .length = 1},
  [224] = {.index = 414, .length = 5},
  [225] = {.index = 419, .length = 4},
  [227] = {.index = 423, .length = 2},
  [228] = {.index = 425, .length = 2},
  [229] = {.index = 427, .length = 5},
  [230] = {.index = 432, .length = 2},
  [231] = {.index = 434, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_type, 0},
  [1] =
    {field_directive, 0},
  [2] =
    {field_argument, 1},
    {field_operator, 0},
  [4] =
    {field_declarator, 1},
  [5] =
    {field_name, 0},
  [6] =
    {field_arguments, 1},
    {field_function, 0},
  [8] =
    {field_type, 0},
    {field_value, 1},
  [10] =
    {field_body, 1},
  [11] =
    {field_name, 1},
  [12] =
    {field_body, 0},
  [13] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [15] =
    {field_body, 0, .inherited = true},
    {field_name, 0, .inherited = true},
  [17] =
    {field_value, 1},
  [18] =
    {field_scope, 0},
  [19] =
    {field_arguments, 1},
    {field_name, 0},
  [21] =
    {field_type, 1},
  [22] =
    {field_requirements, 1},
  [23] =
    {field_constraint, 1},
  [24] =
    {field_parameters, 0},
  [25] =
    {field_declarator, 0},
    {field_parameters, 1, .inherited = true},
  [27] =
    {field_body, 1},
    {field_declarator, 0},
  [29] =
    {field_declarator, 0},
  [30] =
    {field_constraint, 0},
  [31] =
    {field_pattern, 0},
  [32] =
    {field_argument, 0},
    {field_operator, 1},
  [34] =
    {field_argument, 0},
    {field_indices, 1},
  [36] =
    {field_body, 1},
    {field_captures, 0},
  [38] =
    {field_parameters, 0, .inherited = true},
  [39] =
    {field_name, 1},
    {field_scope, 0, .inherited = true},
  [41] =
    {field_path, 1},
  [42] =
    {field_argument, 1},
    {field_directive, 0},
  [44] =
    {field_declarator, 1},
    {field_type, 0},
  [46] =
    {field_left, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right, 1, .inherited = true},
  [49] =
    {field_declarator, 2},
  [50] =
    {field_body, 2},
    {field_value, 1},
  [52] =
    {field_type, 2},
  [53] =
    {field_body, 2},
  [54] =
    {field_name, 2},
  [55] =
    {field_body, 2},
    {field_name, 1},
  [57] =
    {field_base, 2, .inherited = true},
    {field_name, 1},
  [59] =
    {field_body, 1},
    {field_name, 0},
  [61] =
    {field_condition, 1},
    {field_consequence, 2},
  [63] =
    {field_body, 2},
    {field_condition, 1},
  [65] =
    {field_label, 1},
  [66] =
    {field_label, 0},
  [67] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [70] =
    {field_type, 0, .inherited = true},
  [71] =
    {field_parameters, 1},
  [72] =
    {field_declarator, 2},
    {field_type, 1, .inherited = true},
  [74] =
    {field_arguments, 2},
    {field_type, 1},
  [76] =
    {field_declarator, 2},
    {field_type, 1},
  [78] =
    {field_placement, 1},
    {field_type, 2},
  [80] =
    {field_parameters, 1},
    {field_requirements, 2},
  [82] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
  [84] =
    {field_body, 2},
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
  [87] =
    {field_body, 2},
    {field_declarator, 0},
  [89] =
    {field_argument, 0},
    {field_field, 2},
    {field_operator, 1},
  [92] =
    {field_body, 2},
    {field_captures, 0},
    {field_declarator, 1},
  [95] =
    {field_body, 2},
    {field_captures, 0},
    {field_template_parameters, 1},
  [98] =
    {field_name, 1},
    {field_name, 2},
    {field_scope, 0, .inherited = true},
  [101] =
    {field_body, 2},
    {field_declarator, 1},
  [103] =
    {field_name, 1},
    {field_value, 2},
  [105] =
    {field_name, 1},
    {field_parameters, 2},
  [107] =
    {field_condition, 1},
  [108] =
    {field_alternative, 2},
    {field_name, 1},
  [110] =
    {field_declarator, 2},
    {field_type, 0},
  [112] =
    {field_left, 0},
    {field_right, 2},
  [114] =
    {field_left, 0},
    {field_operator, 1, .inherited = true},
    {field_right, 2},
  [117] =
    {field_type, 1},
    {field_value, 3},
  [119] =
    {field_declarator, 3},
  [120] =
    {field_declarator, 2, .inherited = true},
    {field_type, 1, .inherited = true},
  [122] =
    {field_declarator, 0},
    {field_parameters, 1},
  [124] =
    {field_declarator, 0},
    {field_declarator, 1, .inherited = true},
  [126] =
    {field_arguments, 3},
    {field_type, 2},
  [128] =
    {field_declarator, 3},
    {field_type, 2},
  [130] =
    {field_placement, 2},
    {field_type, 3},
  [132] =
    {field_name, 2},
    {field_prefix, 0},
  [134] =
    {field_body, 3},
    {field_name, 2},
  [136] =
    {field_body, 3},
  [137] =
    {field_base, 3, .inherited = true},
    {field_name, 2},
  [139] =
    {field_base, 1},
  [140] =
    {field_base, 2, .inherited = true},
    {field_body, 3},
    {field_name, 1},
  [143] =
    {field_body, 2, .inherited = true},
    {field_name, 2, .inherited = true},
  [145] =
    {field_body, 2},
    {field_name, 0},
  [147] =
    {field_condition, 2},
    {field_consequence, 3},
  [149] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [152] =
    {field_initializer, 0},
  [153] =
    {field_assembly_code, 2},
  [154] =
    {field_arguments, 3},
    {field_declarator, 2},
    {field_type, 1},
  [157] =
    {field_arguments, 3},
    {field_placement, 1},
    {field_type, 2},
  [160] =
    {field_declarator, 3},
    {field_placement, 1},
    {field_type, 2},
  [163] =
    {field_body, 3},
    {field_declarator, 2},
    {field_type, 0, .inherited = true},
  [166] =
    {field_declarator, 0},
    {field_value, 2},
  [168] =
    {field_declarator, 1},
    {field_declarator, 2, .inherited = true},
    {field_type, 0, .inherited = true},
  [171] =
    {field_declarator, 0, .inherited = true},
    {field_declarator, 1, .inherited = true},
  [173] =
    {field_body, 3},
    {field_declarator, 2},
    {field_type, 1, .inherited = true},
  [176] =
    {field_declarator, 0},
    {field_size, 2},
  [178] =
    {field_alternative, 3},
    {field_condition, 0},
  [180] =
    {field_declarator, 0},
    {field_default_value, 2},
  [182] =
    {field_size, 1},
  [183] =
    {field_body, 3},
    {field_captures, 0},
    {field_declarator, 2},
    {field_template_parameters, 1},
  [187] =
    {field_body, 3},
    {field_captures, 0},
    {field_constraint, 2},
    {field_template_parameters, 1},
  [191] =
    {field_body, 3},
    {field_declarator, 1},
  [193] =
    {field_name, 1},
    {field_parameters, 2},
    {field_value, 3},
  [196] =
    {field_alternative, 3},
    {field_condition, 1},
  [198] =
    {field_alternative, 3},
    {field_name, 1},
  [200] =
    {field_operator, 0},
  [201] =
    {field_declarator, 3},
    {field_type, 1},
  [203] =
    {field_declarator, 3, .inherited = true},
    {field_type, 2, .inherited = true},
  [205] =
    {field_arguments, 4},
    {field_declarator, 3},
    {field_type, 2},
  [208] =
    {field_arguments, 4},
    {field_placement, 2},
    {field_type, 3},
  [211] =
    {field_declarator, 4},
    {field_placement, 2},
    {field_type, 3},
  [214] =
    {field_body, 3},
    {field_name, 1},
  [216] =
    {field_body, 4},
    {field_name, 3},
  [218] =
    {field_designator, 0},
    {field_value, 2},
  [220] =
    {field_name, 0},
    {field_value, 2},
  [222] =
    {field_base, 3, .inherited = true},
    {field_body, 4},
    {field_name, 2},
  [225] =
    {field_body, 3},
    {field_name, 0},
  [227] =
    {field_body, 3, .inherited = true},
    {field_name, 3, .inherited = true},
  [229] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
    {field_value, 2},
  [232] =
    {field_initializer, 1},
    {field_value, 2},
  [234] =
    {field_alternative, 4},
    {field_condition, 2},
    {field_consequence, 3},
  [237] =
    {field_body, 1},
    {field_condition, 3},
  [239] =
    {field_update, 2},
  [240] =
    {field_initializer, 0},
    {field_update, 2},
  [242] =
    {field_condition, 1},
    {field_initializer, 0},
  [244] =
    {field_body, 4},
    {field_condition, 2, .inherited = true},
    {field_initializer, 2, .inherited = true},
    {field_update, 2, .inherited = true},
  [248] =
    {field_body, 4},
    {field_declarator, 2, .inherited = true},
    {field_initializer, 2, .inherited = true},
    {field_right, 2, .inherited = true},
    {field_type, 2, .inherited = true},
  [253] =
    {field_value, 3},
  [254] =
    {field_operand, 1},
  [255] =
    {field_assembly_code, 2},
    {field_output_operands, 3},
  [257] =
    {field_assembly_code, 3},
  [258] =
    {field_default_type, 2},
  [259] =
    {field_default_value, 2},
    {field_type, 0, .inherited = true},
  [261] =
    {field_body, 2},
    {field_parameters, 1},
  [263] =
    {field_name, 1},
    {field_type, 3},
  [265] =
    {field_condition, 2},
  [266] =
    {field_length, 1},
  [267] =
    {field_arguments, 4},
    {field_declarator, 3},
    {field_placement, 1},
    {field_type, 2},
  [271] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_declarator, 3},
    {field_type, 0, .inherited = true},
  [275] =
    {field_declarator, 4},
  [276] =
    {field_body, 4},
    {field_declarator, 3},
    {field_type, 1, .inherited = true},
  [279] =
    {field_declarator, 0},
    {field_size, 3},
  [281] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [284] =
    {field_size, 2},
  [285] =
    {field_body, 4},
    {field_captures, 0},
    {field_constraint, 2},
    {field_declarator, 3},
    {field_template_parameters, 1},
  [290] =
    {field_condition, 3},
    {field_consequence, 4},
  [292] =
    {field_body, 4},
    {field_declarator, 3},
    {field_type, 2, .inherited = true},
  [295] =
    {field_declarator, 1},
    {field_default_value, 3},
  [297] =
    {field_alternative, 4},
    {field_condition, 1},
  [299] =
    {field_arguments, 5},
    {field_declarator, 4},
    {field_placement, 2},
    {field_type, 3},
  [303] =
    {field_body, 2},
    {field_filter, 1},
  [305] =
    {field_body, 4},
    {field_name, 2},
  [307] =
    {field_body, 4},
  [308] =
    {field_body, 4},
    {field_name, 1},
  [310] =
    {field_declarator, 1},
    {field_default_value, 2},
    {field_type, 0, .inherited = true},
  [313] =
    {field_declarator, 1},
    {field_declarator, 2, .inherited = true},
    {field_default_value, 2, .inherited = true},
    {field_type, 0, .inherited = true},
  [317] =
    {field_declarator, 0, .inherited = true},
    {field_declarator, 1, .inherited = true},
    {field_default_value, 0, .inherited = true},
    {field_default_value, 1, .inherited = true},
  [321] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
    {field_value, 3},
  [324] =
    {field_condition, 1},
    {field_update, 3},
  [326] =
    {field_condition, 1},
    {field_initializer, 0},
    {field_update, 3},
  [329] =
    {field_declarator, 1},
    {field_right, 3},
    {field_type, 0, .inherited = true},
  [332] =
    {field_initializer, 0},
    {field_update, 3},
  [334] =
    {field_condition, 2},
    {field_initializer, 0},
  [336] =
    {field_member, 4},
    {field_type, 2},
  [338] =
    {field_operand, 1},
    {field_operand, 2, .inherited = true},
  [340] =
    {field_assembly_code, 2},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [343] =
    {field_assembly_code, 3},
    {field_output_operands, 4},
  [345] =
    {field_default_type, 3},
    {field_name, 1},
  [347] =
    {field_declarator, 1},
    {field_default_value, 3},
    {field_type, 0, .inherited = true},
  [350] =
    {field_name, 1},
    {field_type, 4},
  [352] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_declarator, 3},
  [355] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_declarator, 3},
    {field_declarator, 4, .inherited = true},
    {field_type, 0, .inherited = true},
  [360] =
    {field_alternative, 5},
    {field_condition, 3},
    {field_consequence, 4},
  [363] =
    {field_body, 5},
    {field_condition, 3, .inherited = true},
    {field_initializer, 3, .inherited = true},
    {field_update, 3, .inherited = true},
  [367] =
    {field_body, 5},
    {field_declarator, 4},
    {field_type, 2, .inherited = true},
  [370] =
    {field_body, 5},
    {field_name, 2},
  [372] =
    {field_end, 3},
    {field_start, 1},
  [374] =
    {field_declarator, 1},
    {field_default_value, 2},
  [376] =
    {field_declarator, 1},
    {field_declarator, 3, .inherited = true},
    {field_default_value, 3, .inherited = true},
    {field_type, 0, .inherited = true},
  [380] =
    {field_declarator, 1},
    {field_declarator, 3, .inherited = true},
    {field_default_value, 2},
    {field_default_value, 3, .inherited = true},
    {field_type, 0, .inherited = true},
  [385] =
    {field_condition, 2},
    {field_initializer, 0},
    {field_update, 4},
  [388] =
    {field_declarator, 2},
    {field_initializer, 0},
    {field_right, 4},
    {field_type, 1, .inherited = true},
  [392] =
    {field_operand, 0, .inherited = true},
    {field_operand, 1, .inherited = true},
  [394] =
    {field_register, 1},
  [395] =
    {field_assembly_code, 2},
    {field_clobbers, 5},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [399] =
    {field_assembly_code, 3},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [402] =
    {field_condition, 2},
    {field_message, 4},
  [404] =
    {field_delimiter, 1},
  [405] =
    {field_declarator, 1},
    {field_declarator, 4, .inherited = true},
    {field_default_value, 3},
    {field_default_value, 4, .inherited = true},
    {field_type, 0, .inherited = true},
  [410] =
    {field_constraint, 0},
    {field_value, 2},
  [412] =
    {field_register, 1},
    {field_register, 2, .inherited = true},
  [414] =
    {field_assembly_code, 2},
    {field_clobbers, 5},
    {field_goto_labels, 6},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [419] =
    {field_assembly_code, 3},
    {field_clobbers, 6},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [423] =
    {field_register, 0, .inherited = true},
    {field_register, 1, .inherited = true},
  [425] =
    {field_label, 1},
    {field_label, 2, .inherited = true},
  [427] =
    {field_assembly_code, 3},
    {field_clobbers, 6},
    {field_goto_labels, 7},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [432] =
    {field_label, 0, .inherited = true},
    {field_label, 1, .inherited = true},
  [434] =
    {field_constraint, 3},
    {field_symbol, 1},
    {field_value, 5},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = alias_sym_type_identifier,
  },
  [15] = {
    [0] = alias_sym_namespace_identifier,
  },
  [16] = {
    [0] = alias_sym_type_identifier,
  },
  [18] = {
    [0] = alias_sym_type_identifier,
  },
  [19] = {
    [0] = alias_sym_namespace_identifier,
  },
  [35] = {
    [1] = alias_sym_type_identifier,
  },
  [36] = {
    [1] = alias_sym_type_identifier,
  },
  [42] = {
    [0] = sym_primitive_type,
  },
  [43] = {
    [0] = sym_pointer_declarator,
  },
  [53] = {
    [1] = alias_sym_statement_identifier,
  },
  [54] = {
    [0] = alias_sym_statement_identifier,
  },
  [59] = {
    [1] = alias_sym_namespace_identifier,
  },
  [60] = {
    [1] = alias_sym_namespace_identifier,
  },
  [64] = {
    [0] = alias_sym_simple_requirement,
  },
  [69] = {
    [2] = alias_sym_field_identifier,
  },
  [91] = {
    [2] = alias_sym_namespace_identifier,
  },
  [94] = {
    [1] = alias_sym_field_identifier,
  },
  [97] = {
    [1] = alias_sym_type_identifier,
  },
  [99] = {
    [0] = alias_sym_field_identifier,
  },
  [106] = {
    [1] = alias_sym_type_identifier,
  },
  [116] = {
    [0] = alias_sym_field_identifier,
  },
  [117] = {
    [1] = alias_sym_field_identifier,
  },
  [134] = {
    [3] = alias_sym_namespace_identifier,
  },
  [136] = {
    [0] = alias_sym_field_identifier,
  },
  [155] = {
    [2] = alias_sym_type_identifier,
  },
  [159] = {
    [1] = alias_sym_namespace_identifier,
    [3] = alias_sym_namespace_identifier,
  },
  [160] = {
    [1] = alias_sym_namespace_identifier,
  },
  [161] = {
    [1] = alias_sym_type_identifier,
  },
  [165] = {
    [2] = sym_semantics,
    [3] = sym_semantics,
  },
  [181] = {
    [2] = sym_compound_statement,
    [3] = sym_compound_statement,
  },
  [191] = {
    [4] = alias_sym_field_identifier,
  },
  [195] = {
    [1] = alias_sym_type_identifier,
  },
  [197] = {
    [1] = alias_sym_type_identifier,
  },
  [198] = {
    [2] = sym_semantics,
    [3] = sym_semantics,
  },
  [199] = {
    [2] = sym_semantics,
    [3] = sym_semantics,
  },
  [205] = {
    [2] = sym_compound_statement,
    [3] = sym_compound_statement,
    [4] = sym_compound_statement,
  },
  [206] = {
    [3] = sym_compound_statement,
    [4] = sym_compound_statement,
  },
  [218] = {
    [3] = sym_compound_statement,
    [4] = sym_compound_statement,
    [5] = sym_compound_statement,
  },
  [219] = {
    [4] = sym_compound_statement,
    [5] = sym_compound_statement,
  },
  [226] = {
    [4] = sym_compound_statement,
    [5] = sym_compound_statement,
    [6] = sym_compound_statement,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_pointer_type_declarator, 2,
    sym_pointer_type_declarator,
    sym_pointer_declarator,
  sym_expression_statement, 2,
    sym_expression_statement,
    alias_sym_simple_requirement,
  sym_expression, 2,
    sym_expression,
    sym_semantics,
  aux_sym_subscript_declaration_repeat1, 2,
    aux_sym_subscript_declaration_repeat1,
    sym_compound_statement,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 2,
  [5] = 2,
  [6] = 2,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 9,
  [11] = 11,
  [12] = 8,
  [13] = 13,
  [14] = 14,
  [15] = 7,
  [16] = 16,
  [17] = 17,
  [18] = 13,
  [19] = 7,
  [20] = 13,
  [21] = 8,
  [22] = 13,
  [23] = 8,
  [24] = 9,
  [25] = 7,
  [26] = 9,
  [27] = 27,
  [28] = 28,
  [29] = 28,
  [30] = 27,
  [31] = 31,
  [32] = 32,
  [33] = 32,
  [34] = 28,
  [35] = 28,
  [36] = 28,
  [37] = 28,
  [38] = 38,
  [39] = 27,
  [40] = 28,
  [41] = 28,
  [42] = 42,
  [43] = 28,
  [44] = 32,
  [45] = 32,
  [46] = 28,
  [47] = 32,
  [48] = 32,
  [49] = 28,
  [50] = 38,
  [51] = 32,
  [52] = 28,
  [53] = 53,
  [54] = 28,
  [55] = 32,
  [56] = 32,
  [57] = 38,
  [58] = 38,
  [59] = 32,
  [60] = 42,
  [61] = 42,
  [62] = 62,
  [63] = 28,
  [64] = 32,
  [65] = 32,
  [66] = 42,
  [67] = 28,
  [68] = 32,
  [69] = 32,
  [70] = 28,
  [71] = 28,
  [72] = 32,
  [73] = 32,
  [74] = 32,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 80,
  [83] = 78,
  [84] = 81,
  [85] = 77,
  [86] = 79,
  [87] = 80,
  [88] = 77,
  [89] = 81,
  [90] = 81,
  [91] = 78,
  [92] = 79,
  [93] = 80,
  [94] = 79,
  [95] = 78,
  [96] = 77,
  [97] = 80,
  [98] = 77,
  [99] = 81,
  [100] = 78,
  [101] = 79,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 106,
  [107] = 107,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 104,
  [122] = 105,
  [123] = 110,
  [124] = 119,
  [125] = 106,
  [126] = 108,
  [127] = 120,
  [128] = 117,
  [129] = 107,
  [130] = 116,
  [131] = 118,
  [132] = 114,
  [133] = 113,
  [134] = 111,
  [135] = 109,
  [136] = 112,
  [137] = 115,
  [138] = 138,
  [139] = 105,
  [140] = 114,
  [141] = 120,
  [142] = 138,
  [143] = 112,
  [144] = 106,
  [145] = 138,
  [146] = 108,
  [147] = 109,
  [148] = 117,
  [149] = 116,
  [150] = 138,
  [151] = 110,
  [152] = 113,
  [153] = 119,
  [154] = 118,
  [155] = 138,
  [156] = 115,
  [157] = 107,
  [158] = 138,
  [159] = 159,
  [160] = 160,
  [161] = 160,
  [162] = 160,
  [163] = 160,
  [164] = 160,
  [165] = 160,
  [166] = 105,
  [167] = 115,
  [168] = 114,
  [169] = 117,
  [170] = 110,
  [171] = 119,
  [172] = 109,
  [173] = 118,
  [174] = 116,
  [175] = 107,
  [176] = 120,
  [177] = 106,
  [178] = 108,
  [179] = 113,
  [180] = 112,
  [181] = 111,
  [182] = 182,
  [183] = 182,
  [184] = 182,
  [185] = 182,
  [186] = 182,
  [187] = 111,
  [188] = 182,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 193,
  [194] = 194,
  [195] = 195,
  [196] = 196,
  [197] = 197,
  [198] = 105,
  [199] = 114,
  [200] = 113,
  [201] = 201,
  [202] = 110,
  [203] = 115,
  [204] = 112,
  [205] = 109,
  [206] = 120,
  [207] = 117,
  [208] = 119,
  [209] = 106,
  [210] = 107,
  [211] = 108,
  [212] = 212,
  [213] = 116,
  [214] = 118,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 220,
  [221] = 215,
  [222] = 222,
  [223] = 222,
  [224] = 224,
  [225] = 222,
  [226] = 215,
  [227] = 220,
  [228] = 218,
  [229] = 220,
  [230] = 218,
  [231] = 231,
  [232] = 232,
  [233] = 190,
  [234] = 234,
  [235] = 193,
  [236] = 236,
  [237] = 237,
  [238] = 232,
  [239] = 239,
  [240] = 231,
  [241] = 194,
  [242] = 196,
  [243] = 243,
  [244] = 118,
  [245] = 245,
  [246] = 107,
  [247] = 247,
  [248] = 201,
  [249] = 195,
  [250] = 120,
  [251] = 212,
  [252] = 108,
  [253] = 105,
  [254] = 110,
  [255] = 112,
  [256] = 113,
  [257] = 115,
  [258] = 114,
  [259] = 117,
  [260] = 119,
  [261] = 106,
  [262] = 197,
  [263] = 116,
  [264] = 264,
  [265] = 109,
  [266] = 193,
  [267] = 232,
  [268] = 268,
  [269] = 269,
  [270] = 270,
  [271] = 231,
  [272] = 270,
  [273] = 273,
  [274] = 231,
  [275] = 232,
  [276] = 276,
  [277] = 190,
  [278] = 270,
  [279] = 193,
  [280] = 280,
  [281] = 281,
  [282] = 191,
  [283] = 283,
  [284] = 284,
  [285] = 285,
  [286] = 245,
  [287] = 192,
  [288] = 243,
  [289] = 190,
  [290] = 264,
  [291] = 291,
  [292] = 292,
  [293] = 293,
  [294] = 291,
  [295] = 295,
  [296] = 296,
  [297] = 297,
  [298] = 298,
  [299] = 299,
  [300] = 300,
  [301] = 301,
  [302] = 301,
  [303] = 303,
  [304] = 291,
  [305] = 291,
  [306] = 301,
  [307] = 307,
  [308] = 291,
  [309] = 195,
  [310] = 310,
  [311] = 234,
  [312] = 312,
  [313] = 313,
  [314] = 113,
  [315] = 291,
  [316] = 301,
  [317] = 114,
  [318] = 318,
  [319] = 319,
  [320] = 320,
  [321] = 291,
  [322] = 196,
  [323] = 323,
  [324] = 291,
  [325] = 197,
  [326] = 201,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 194,
  [331] = 331,
  [332] = 332,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 291,
  [337] = 212,
  [338] = 301,
  [339] = 339,
  [340] = 301,
  [341] = 341,
  [342] = 342,
  [343] = 343,
  [344] = 344,
  [345] = 117,
  [346] = 119,
  [347] = 106,
  [348] = 348,
  [349] = 349,
  [350] = 107,
  [351] = 116,
  [352] = 109,
  [353] = 353,
  [354] = 354,
  [355] = 355,
  [356] = 356,
  [357] = 357,
  [358] = 358,
  [359] = 110,
  [360] = 360,
  [361] = 361,
  [362] = 115,
  [363] = 112,
  [364] = 105,
  [365] = 108,
  [366] = 120,
  [367] = 118,
  [368] = 368,
  [369] = 369,
  [370] = 370,
  [371] = 239,
  [372] = 372,
  [373] = 373,
  [374] = 374,
  [375] = 375,
  [376] = 291,
  [377] = 301,
  [378] = 378,
  [379] = 379,
  [380] = 380,
  [381] = 381,
  [382] = 301,
  [383] = 383,
  [384] = 291,
  [385] = 385,
  [386] = 301,
  [387] = 387,
  [388] = 388,
  [389] = 389,
  [390] = 301,
  [391] = 391,
  [392] = 392,
  [393] = 393,
  [394] = 394,
  [395] = 395,
  [396] = 396,
  [397] = 397,
  [398] = 398,
  [399] = 399,
  [400] = 237,
  [401] = 401,
  [402] = 402,
  [403] = 291,
  [404] = 239,
  [405] = 405,
  [406] = 406,
  [407] = 407,
  [408] = 301,
  [409] = 291,
  [410] = 410,
  [411] = 411,
  [412] = 412,
  [413] = 413,
  [414] = 291,
  [415] = 301,
  [416] = 416,
  [417] = 301,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 421,
  [422] = 422,
  [423] = 423,
  [424] = 291,
  [425] = 301,
  [426] = 426,
  [427] = 427,
  [428] = 428,
  [429] = 429,
  [430] = 301,
  [431] = 431,
  [432] = 432,
  [433] = 433,
  [434] = 434,
  [435] = 435,
  [436] = 436,
  [437] = 437,
  [438] = 438,
  [439] = 439,
  [440] = 440,
  [441] = 441,
  [442] = 442,
  [443] = 443,
  [444] = 444,
  [445] = 264,
  [446] = 446,
  [447] = 447,
  [448] = 448,
  [449] = 449,
  [450] = 450,
  [451] = 451,
  [452] = 452,
  [453] = 283,
  [454] = 454,
  [455] = 455,
  [456] = 195,
  [457] = 457,
  [458] = 458,
  [459] = 459,
  [460] = 194,
  [461] = 461,
  [462] = 462,
  [463] = 463,
  [464] = 464,
  [465] = 465,
  [466] = 466,
  [467] = 467,
  [468] = 468,
  [469] = 469,
  [470] = 470,
  [471] = 471,
  [472] = 472,
  [473] = 473,
  [474] = 474,
  [475] = 475,
  [476] = 476,
  [477] = 243,
  [478] = 478,
  [479] = 479,
  [480] = 480,
  [481] = 481,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 485,
  [486] = 486,
  [487] = 487,
  [488] = 488,
  [489] = 489,
  [490] = 490,
  [491] = 491,
  [492] = 281,
  [493] = 493,
  [494] = 494,
  [495] = 495,
  [496] = 496,
  [497] = 497,
  [498] = 498,
  [499] = 118,
  [500] = 500,
  [501] = 501,
  [502] = 502,
  [503] = 503,
  [504] = 504,
  [505] = 197,
  [506] = 196,
  [507] = 507,
  [508] = 508,
  [509] = 509,
  [510] = 201,
  [511] = 511,
  [512] = 512,
  [513] = 513,
  [514] = 120,
  [515] = 515,
  [516] = 108,
  [517] = 105,
  [518] = 112,
  [519] = 115,
  [520] = 520,
  [521] = 110,
  [522] = 522,
  [523] = 109,
  [524] = 524,
  [525] = 525,
  [526] = 212,
  [527] = 527,
  [528] = 116,
  [529] = 107,
  [530] = 106,
  [531] = 264,
  [532] = 532,
  [533] = 119,
  [534] = 117,
  [535] = 114,
  [536] = 113,
  [537] = 284,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 541,
  [542] = 542,
  [543] = 543,
  [544] = 544,
  [545] = 280,
  [546] = 243,
  [547] = 547,
  [548] = 548,
  [549] = 549,
  [550] = 550,
  [551] = 356,
  [552] = 392,
  [553] = 323,
  [554] = 327,
  [555] = 328,
  [556] = 329,
  [557] = 410,
  [558] = 374,
  [559] = 276,
  [560] = 360,
  [561] = 402,
  [562] = 276,
  [563] = 375,
  [564] = 401,
  [565] = 312,
  [566] = 334,
  [567] = 387,
  [568] = 393,
  [569] = 335,
  [570] = 399,
  [571] = 269,
  [572] = 344,
  [573] = 421,
  [574] = 411,
  [575] = 292,
  [576] = 353,
  [577] = 348,
  [578] = 343,
  [579] = 407,
  [580] = 333,
  [581] = 412,
  [582] = 413,
  [583] = 354,
  [584] = 416,
  [585] = 419,
  [586] = 397,
  [587] = 429,
  [588] = 431,
  [589] = 391,
  [590] = 332,
  [591] = 383,
  [592] = 331,
  [593] = 269,
  [594] = 320,
  [595] = 595,
  [596] = 394,
  [597] = 433,
  [598] = 310,
  [599] = 398,
  [600] = 380,
  [601] = 396,
  [602] = 395,
  [603] = 603,
  [604] = 381,
  [605] = 307,
  [606] = 300,
  [607] = 423,
  [608] = 299,
  [609] = 422,
  [610] = 293,
  [611] = 420,
  [612] = 406,
  [613] = 613,
  [614] = 237,
  [615] = 283,
  [616] = 284,
  [617] = 617,
  [618] = 191,
  [619] = 280,
  [620] = 620,
  [621] = 621,
  [622] = 191,
  [623] = 281,
  [624] = 532,
  [625] = 625,
  [626] = 626,
  [627] = 192,
  [628] = 628,
  [629] = 629,
  [630] = 630,
  [631] = 631,
  [632] = 192,
  [633] = 633,
  [634] = 234,
  [635] = 635,
  [636] = 283,
  [637] = 285,
  [638] = 638,
  [639] = 639,
  [640] = 640,
  [641] = 641,
  [642] = 642,
  [643] = 643,
  [644] = 644,
  [645] = 284,
  [646] = 495,
  [647] = 647,
  [648] = 463,
  [649] = 649,
  [650] = 280,
  [651] = 651,
  [652] = 281,
  [653] = 653,
  [654] = 300,
  [655] = 595,
  [656] = 394,
  [657] = 389,
  [658] = 378,
  [659] = 419,
  [660] = 416,
  [661] = 413,
  [662] = 412,
  [663] = 438,
  [664] = 439,
  [665] = 373,
  [666] = 410,
  [667] = 402,
  [668] = 401,
  [669] = 603,
  [670] = 440,
  [671] = 399,
  [672] = 332,
  [673] = 391,
  [674] = 394,
  [675] = 436,
  [676] = 333,
  [677] = 331,
  [678] = 432,
  [679] = 416,
  [680] = 332,
  [681] = 407,
  [682] = 428,
  [683] = 331,
  [684] = 427,
  [685] = 418,
  [686] = 349,
  [687] = 388,
  [688] = 420,
  [689] = 422,
  [690] = 323,
  [691] = 327,
  [692] = 328,
  [693] = 329,
  [694] = 353,
  [695] = 356,
  [696] = 423,
  [697] = 385,
  [698] = 360,
  [699] = 433,
  [700] = 379,
  [701] = 320,
  [702] = 374,
  [703] = 298,
  [704] = 237,
  [705] = 310,
  [706] = 342,
  [707] = 707,
  [708] = 431,
  [709] = 429,
  [710] = 307,
  [711] = 234,
  [712] = 354,
  [713] = 299,
  [714] = 357,
  [715] = 293,
  [716] = 341,
  [717] = 717,
  [718] = 437,
  [719] = 395,
  [720] = 333,
  [721] = 343,
  [722] = 348,
  [723] = 419,
  [724] = 395,
  [725] = 369,
  [726] = 396,
  [727] = 411,
  [728] = 375,
  [729] = 729,
  [730] = 730,
  [731] = 387,
  [732] = 410,
  [733] = 273,
  [734] = 360,
  [735] = 402,
  [736] = 303,
  [737] = 401,
  [738] = 399,
  [739] = 391,
  [740] = 413,
  [741] = 318,
  [742] = 412,
  [743] = 435,
  [744] = 744,
  [745] = 393,
  [746] = 348,
  [747] = 327,
  [748] = 297,
  [749] = 372,
  [750] = 368,
  [751] = 339,
  [752] = 313,
  [753] = 320,
  [754] = 434,
  [755] = 396,
  [756] = 380,
  [757] = 426,
  [758] = 398,
  [759] = 420,
  [760] = 268,
  [761] = 761,
  [762] = 422,
  [763] = 423,
  [764] = 312,
  [765] = 383,
  [766] = 361,
  [767] = 381,
  [768] = 343,
  [769] = 319,
  [770] = 310,
  [771] = 433,
  [772] = 307,
  [773] = 295,
  [774] = 406,
  [775] = 387,
  [776] = 397,
  [777] = 300,
  [778] = 397,
  [779] = 354,
  [780] = 380,
  [781] = 292,
  [782] = 299,
  [783] = 383,
  [784] = 381,
  [785] = 392,
  [786] = 411,
  [787] = 406,
  [788] = 392,
  [789] = 789,
  [790] = 292,
  [791] = 431,
  [792] = 356,
  [793] = 353,
  [794] = 794,
  [795] = 335,
  [796] = 334,
  [797] = 398,
  [798] = 358,
  [799] = 329,
  [800] = 323,
  [801] = 355,
  [802] = 328,
  [803] = 334,
  [804] = 375,
  [805] = 405,
  [806] = 393,
  [807] = 407,
  [808] = 335,
  [809] = 293,
  [810] = 374,
  [811] = 312,
  [812] = 429,
  [813] = 483,
  [814] = 524,
  [815] = 469,
  [816] = 513,
  [817] = 512,
  [818] = 511,
  [819] = 550,
  [820] = 457,
  [821] = 467,
  [822] = 653,
  [823] = 540,
  [824] = 525,
  [825] = 524,
  [826] = 550,
  [827] = 643,
  [828] = 641,
  [829] = 520,
  [830] = 520,
  [831] = 441,
  [832] = 479,
  [833] = 538,
  [834] = 496,
  [835] = 449,
  [836] = 548,
  [837] = 503,
  [838] = 502,
  [839] = 547,
  [840] = 448,
  [841] = 444,
  [842] = 458,
  [843] = 459,
  [844] = 464,
  [845] = 498,
  [846] = 629,
  [847] = 479,
  [848] = 441,
  [849] = 493,
  [850] = 491,
  [851] = 496,
  [852] = 625,
  [853] = 470,
  [854] = 471,
  [855] = 626,
  [856] = 540,
  [857] = 462,
  [858] = 473,
  [859] = 461,
  [860] = 544,
  [861] = 543,
  [862] = 651,
  [863] = 522,
  [864] = 539,
  [865] = 494,
  [866] = 500,
  [867] = 501,
  [868] = 504,
  [869] = 507,
  [870] = 508,
  [871] = 469,
  [872] = 476,
  [873] = 475,
  [874] = 630,
  [875] = 480,
  [876] = 527,
  [877] = 541,
  [878] = 547,
  [879] = 471,
  [880] = 461,
  [881] = 455,
  [882] = 454,
  [883] = 452,
  [884] = 542,
  [885] = 449,
  [886] = 644,
  [887] = 448,
  [888] = 447,
  [889] = 487,
  [890] = 541,
  [891] = 446,
  [892] = 457,
  [893] = 444,
  [894] = 443,
  [895] = 482,
  [896] = 458,
  [897] = 484,
  [898] = 459,
  [899] = 464,
  [900] = 269,
  [901] = 509,
  [902] = 621,
  [903] = 515,
  [904] = 465,
  [905] = 466,
  [906] = 549,
  [907] = 525,
  [908] = 549,
  [909] = 468,
  [910] = 442,
  [911] = 470,
  [912] = 472,
  [913] = 515,
  [914] = 446,
  [915] = 473,
  [916] = 474,
  [917] = 443,
  [918] = 617,
  [919] = 513,
  [920] = 512,
  [921] = 511,
  [922] = 480,
  [923] = 276,
  [924] = 482,
  [925] = 503,
  [926] = 502,
  [927] = 498,
  [928] = 493,
  [929] = 491,
  [930] = 628,
  [931] = 647,
  [932] = 631,
  [933] = 633,
  [934] = 481,
  [935] = 635,
  [936] = 485,
  [937] = 486,
  [938] = 451,
  [939] = 450,
  [940] = 476,
  [941] = 475,
  [942] = 484,
  [943] = 455,
  [944] = 454,
  [945] = 452,
  [946] = 447,
  [947] = 487,
  [948] = 465,
  [949] = 466,
  [950] = 468,
  [951] = 462,
  [952] = 442,
  [953] = 472,
  [954] = 488,
  [955] = 489,
  [956] = 451,
  [957] = 450,
  [958] = 474,
  [959] = 522,
  [960] = 509,
  [961] = 481,
  [962] = 485,
  [963] = 486,
  [964] = 490,
  [965] = 638,
  [966] = 494,
  [967] = 500,
  [968] = 488,
  [969] = 501,
  [970] = 504,
  [971] = 507,
  [972] = 489,
  [973] = 640,
  [974] = 490,
  [975] = 639,
  [976] = 538,
  [977] = 642,
  [978] = 539,
  [979] = 542,
  [980] = 543,
  [981] = 478,
  [982] = 620,
  [983] = 497,
  [984] = 508,
  [985] = 544,
  [986] = 548,
  [987] = 478,
  [988] = 497,
  [989] = 467,
  [990] = 527,
  [991] = 613,
  [992] = 483,
  [993] = 471,
  [994] = 707,
  [995] = 794,
  [996] = 789,
  [997] = 744,
  [998] = 509,
  [999] = 717,
  [1000] = 538,
  [1001] = 465,
  [1002] = 448,
  [1003] = 493,
  [1004] = 486,
  [1005] = 491,
  [1006] = 541,
  [1007] = 441,
  [1008] = 449,
  [1009] = 447,
  [1010] = 487,
  [1011] = 520,
  [1012] = 485,
  [1013] = 484,
  [1014] = 452,
  [1015] = 454,
  [1016] = 482,
  [1017] = 472,
  [1018] = 480,
  [1019] = 455,
  [1020] = 444,
  [1021] = 458,
  [1022] = 459,
  [1023] = 464,
  [1024] = 479,
  [1025] = 1025,
  [1026] = 451,
  [1027] = 450,
  [1028] = 550,
  [1029] = 522,
  [1030] = 527,
  [1031] = 498,
  [1032] = 443,
  [1033] = 1033,
  [1034] = 446,
  [1035] = 475,
  [1036] = 507,
  [1037] = 476,
  [1038] = 524,
  [1039] = 525,
  [1040] = 469,
  [1041] = 457,
  [1042] = 461,
  [1043] = 1043,
  [1044] = 462,
  [1045] = 481,
  [1046] = 466,
  [1047] = 478,
  [1048] = 497,
  [1049] = 540,
  [1050] = 468,
  [1051] = 502,
  [1052] = 442,
  [1053] = 488,
  [1054] = 489,
  [1055] = 503,
  [1056] = 548,
  [1057] = 513,
  [1058] = 1058,
  [1059] = 483,
  [1060] = 467,
  [1061] = 512,
  [1062] = 547,
  [1063] = 515,
  [1064] = 490,
  [1065] = 549,
  [1066] = 539,
  [1067] = 494,
  [1068] = 500,
  [1069] = 1069,
  [1070] = 542,
  [1071] = 474,
  [1072] = 501,
  [1073] = 543,
  [1074] = 473,
  [1075] = 504,
  [1076] = 470,
  [1077] = 544,
  [1078] = 508,
  [1079] = 511,
  [1080] = 1080,
  [1081] = 1080,
  [1082] = 1082,
  [1083] = 1082,
  [1084] = 1082,
  [1085] = 1082,
  [1086] = 1082,
  [1087] = 1082,
  [1088] = 1082,
  [1089] = 1089,
  [1090] = 1090,
  [1091] = 1090,
  [1092] = 1090,
  [1093] = 1093,
  [1094] = 1093,
  [1095] = 1090,
  [1096] = 1096,
  [1097] = 1090,
  [1098] = 1098,
  [1099] = 1099,
  [1100] = 1100,
  [1101] = 1099,
  [1102] = 1102,
  [1103] = 1093,
  [1104] = 1090,
  [1105] = 1098,
  [1106] = 1106,
  [1107] = 1093,
  [1108] = 1108,
  [1109] = 1109,
  [1110] = 1093,
  [1111] = 1090,
  [1112] = 1112,
  [1113] = 1113,
  [1114] = 1090,
  [1115] = 1109,
  [1116] = 1090,
  [1117] = 1102,
  [1118] = 1093,
  [1119] = 1102,
  [1120] = 1102,
  [1121] = 1099,
  [1122] = 1090,
  [1123] = 1123,
  [1124] = 1123,
  [1125] = 1090,
  [1126] = 1096,
  [1127] = 1127,
  [1128] = 1113,
  [1129] = 1090,
  [1130] = 1108,
  [1131] = 1100,
  [1132] = 1127,
  [1133] = 1127,
  [1134] = 1112,
  [1135] = 1135,
  [1136] = 1127,
  [1137] = 1106,
  [1138] = 1098,
  [1139] = 1113,
  [1140] = 1098,
  [1141] = 1108,
  [1142] = 1093,
  [1143] = 1096,
  [1144] = 1112,
  [1145] = 1106,
  [1146] = 1106,
  [1147] = 1096,
  [1148] = 1102,
  [1149] = 1093,
  [1150] = 1100,
  [1151] = 1112,
  [1152] = 1112,
  [1153] = 1113,
  [1154] = 1098,
  [1155] = 1113,
  [1156] = 1123,
  [1157] = 1106,
  [1158] = 1127,
  [1159] = 1108,
  [1160] = 1093,
  [1161] = 1100,
  [1162] = 1162,
  [1163] = 1099,
  [1164] = 1106,
  [1165] = 1090,
  [1166] = 1096,
  [1167] = 1113,
  [1168] = 1127,
  [1169] = 1112,
  [1170] = 1098,
  [1171] = 1127,
  [1172] = 1123,
  [1173] = 1135,
  [1174] = 1135,
  [1175] = 1109,
  [1176] = 1093,
  [1177] = 1093,
  [1178] = 1123,
  [1179] = 1135,
  [1180] = 1096,
  [1181] = 1109,
  [1182] = 1100,
  [1183] = 1108,
  [1184] = 1099,
  [1185] = 1093,
  [1186] = 1123,
  [1187] = 1108,
  [1188] = 1109,
  [1189] = 1135,
  [1190] = 1093,
  [1191] = 1099,
  [1192] = 1100,
  [1193] = 1102,
  [1194] = 1135,
  [1195] = 1195,
  [1196] = 1162,
  [1197] = 1197,
  [1198] = 231,
  [1199] = 232,
  [1200] = 193,
  [1201] = 1162,
  [1202] = 190,
  [1203] = 1162,
  [1204] = 1162,
  [1205] = 1205,
  [1206] = 1205,
  [1207] = 1205,
  [1208] = 1205,
  [1209] = 1209,
  [1210] = 1205,
  [1211] = 1205,
  [1212] = 1205,
  [1213] = 1162,
  [1214] = 1205,
  [1215] = 1205,
  [1216] = 1205,
  [1217] = 1205,
  [1218] = 1205,
  [1219] = 1205,
  [1220] = 1205,
  [1221] = 1205,
  [1222] = 1205,
  [1223] = 1205,
  [1224] = 1205,
  [1225] = 1205,
  [1226] = 1205,
  [1227] = 1205,
  [1228] = 1205,
  [1229] = 1205,
  [1230] = 1205,
  [1231] = 1205,
  [1232] = 1205,
  [1233] = 105,
  [1234] = 243,
  [1235] = 264,
  [1236] = 196,
  [1237] = 197,
  [1238] = 113,
  [1239] = 114,
  [1240] = 117,
  [1241] = 119,
  [1242] = 194,
  [1243] = 106,
  [1244] = 107,
  [1245] = 201,
  [1246] = 212,
  [1247] = 195,
  [1248] = 116,
  [1249] = 109,
  [1250] = 110,
  [1251] = 115,
  [1252] = 112,
  [1253] = 108,
  [1254] = 120,
  [1255] = 1255,
  [1256] = 118,
  [1257] = 1257,
  [1258] = 1257,
  [1259] = 1257,
  [1260] = 1260,
  [1261] = 1257,
  [1262] = 1162,
  [1263] = 1257,
  [1264] = 1257,
  [1265] = 1257,
  [1266] = 280,
  [1267] = 191,
  [1268] = 281,
  [1269] = 192,
  [1270] = 102,
  [1271] = 102,
  [1272] = 102,
  [1273] = 283,
  [1274] = 284,
  [1275] = 320,
  [1276] = 334,
  [1277] = 356,
  [1278] = 353,
  [1279] = 375,
  [1280] = 292,
  [1281] = 392,
  [1282] = 293,
  [1283] = 329,
  [1284] = 328,
  [1285] = 411,
  [1286] = 299,
  [1287] = 300,
  [1288] = 307,
  [1289] = 327,
  [1290] = 323,
  [1291] = 310,
  [1292] = 406,
  [1293] = 312,
  [1294] = 391,
  [1295] = 407,
  [1296] = 331,
  [1297] = 433,
  [1298] = 387,
  [1299] = 332,
  [1300] = 398,
  [1301] = 399,
  [1302] = 401,
  [1303] = 335,
  [1304] = 354,
  [1305] = 394,
  [1306] = 360,
  [1307] = 402,
  [1308] = 380,
  [1309] = 374,
  [1310] = 381,
  [1311] = 1311,
  [1312] = 383,
  [1313] = 393,
  [1314] = 1195,
  [1315] = 416,
  [1316] = 1197,
  [1317] = 234,
  [1318] = 237,
  [1319] = 1209,
  [1320] = 413,
  [1321] = 348,
  [1322] = 395,
  [1323] = 343,
  [1324] = 333,
  [1325] = 423,
  [1326] = 412,
  [1327] = 422,
  [1328] = 431,
  [1329] = 396,
  [1330] = 410,
  [1331] = 420,
  [1332] = 429,
  [1333] = 419,
  [1334] = 397,
  [1335] = 1335,
  [1336] = 1335,
  [1337] = 1337,
  [1338] = 1338,
  [1339] = 1338,
  [1340] = 1337,
  [1341] = 1338,
  [1342] = 1338,
  [1343] = 1338,
  [1344] = 1162,
  [1345] = 1162,
  [1346] = 1162,
  [1347] = 1162,
  [1348] = 1162,
  [1349] = 1162,
  [1350] = 1350,
  [1351] = 117,
  [1352] = 116,
  [1353] = 109,
  [1354] = 1354,
  [1355] = 119,
  [1356] = 113,
  [1357] = 105,
  [1358] = 108,
  [1359] = 120,
  [1360] = 118,
  [1361] = 104,
  [1362] = 112,
  [1363] = 110,
  [1364] = 115,
  [1365] = 1354,
  [1366] = 106,
  [1367] = 107,
  [1368] = 114,
  [1369] = 111,
  [1370] = 1370,
  [1371] = 1370,
  [1372] = 1370,
  [1373] = 1370,
  [1374] = 1374,
  [1375] = 104,
  [1376] = 441,
  [1377] = 540,
  [1378] = 109,
  [1379] = 104,
  [1380] = 116,
  [1381] = 107,
  [1382] = 120,
  [1383] = 106,
  [1384] = 119,
  [1385] = 114,
  [1386] = 112,
  [1387] = 117,
  [1388] = 118,
  [1389] = 108,
  [1390] = 113,
  [1391] = 105,
  [1392] = 110,
  [1393] = 111,
  [1394] = 115,
  [1395] = 1395,
  [1396] = 1396,
  [1397] = 1397,
  [1398] = 111,
  [1399] = 1395,
  [1400] = 1395,
  [1401] = 1401,
  [1402] = 1401,
  [1403] = 1403,
  [1404] = 1395,
  [1405] = 1401,
  [1406] = 1406,
  [1407] = 1406,
  [1408] = 1408,
  [1409] = 1409,
  [1410] = 1401,
  [1411] = 1411,
  [1412] = 1403,
  [1413] = 1411,
  [1414] = 1396,
  [1415] = 1415,
  [1416] = 1416,
  [1417] = 119,
  [1418] = 109,
  [1419] = 111,
  [1420] = 113,
  [1421] = 114,
  [1422] = 117,
  [1423] = 118,
  [1424] = 120,
  [1425] = 108,
  [1426] = 105,
  [1427] = 112,
  [1428] = 115,
  [1429] = 106,
  [1430] = 110,
  [1431] = 107,
  [1432] = 116,
  [1433] = 108,
  [1434] = 114,
  [1435] = 107,
  [1436] = 110,
  [1437] = 113,
  [1438] = 117,
  [1439] = 105,
  [1440] = 115,
  [1441] = 120,
  [1442] = 118,
  [1443] = 106,
  [1444] = 112,
  [1445] = 109,
  [1446] = 116,
  [1447] = 119,
  [1448] = 1448,
  [1449] = 1449,
  [1450] = 1448,
  [1451] = 1448,
  [1452] = 1448,
  [1453] = 1449,
  [1454] = 1454,
  [1455] = 1454,
  [1456] = 1454,
  [1457] = 1454,
  [1458] = 1454,
  [1459] = 1454,
  [1460] = 1454,
  [1461] = 111,
  [1462] = 1462,
  [1463] = 1462,
  [1464] = 1464,
  [1465] = 1462,
  [1466] = 1464,
  [1467] = 1462,
  [1468] = 1468,
  [1469] = 1462,
  [1470] = 1470,
  [1471] = 1468,
  [1472] = 1464,
  [1473] = 1464,
  [1474] = 1468,
  [1475] = 1475,
  [1476] = 1468,
  [1477] = 1475,
  [1478] = 1462,
  [1479] = 1475,
  [1480] = 1464,
  [1481] = 1468,
  [1482] = 1462,
  [1483] = 1475,
  [1484] = 1464,
  [1485] = 1462,
  [1486] = 1468,
  [1487] = 1468,
  [1488] = 1462,
  [1489] = 1468,
  [1490] = 1468,
  [1491] = 1491,
  [1492] = 1492,
  [1493] = 1493,
  [1494] = 1492,
  [1495] = 1493,
  [1496] = 1492,
  [1497] = 1492,
  [1498] = 1493,
  [1499] = 1493,
  [1500] = 1492,
  [1501] = 1501,
  [1502] = 1493,
  [1503] = 1501,
  [1504] = 1493,
  [1505] = 1492,
  [1506] = 1506,
  [1507] = 1506,
  [1508] = 1506,
  [1509] = 1509,
  [1510] = 1506,
  [1511] = 1506,
  [1512] = 1506,
  [1513] = 1513,
  [1514] = 1506,
  [1515] = 264,
  [1516] = 276,
  [1517] = 243,
  [1518] = 269,
  [1519] = 1519,
  [1520] = 649,
  [1521] = 1519,
  [1522] = 1519,
  [1523] = 1519,
  [1524] = 1524,
  [1525] = 281,
  [1526] = 1524,
  [1527] = 111,
  [1528] = 1528,
  [1529] = 1524,
  [1530] = 1530,
  [1531] = 192,
  [1532] = 191,
  [1533] = 1524,
  [1534] = 1524,
  [1535] = 1524,
  [1536] = 1524,
  [1537] = 1537,
  [1538] = 1538,
  [1539] = 484,
  [1540] = 1540,
  [1541] = 482,
  [1542] = 1540,
  [1543] = 480,
  [1544] = 1540,
  [1545] = 443,
  [1546] = 1540,
  [1547] = 446,
  [1548] = 520,
  [1549] = 509,
  [1550] = 461,
  [1551] = 471,
  [1552] = 1552,
  [1553] = 515,
  [1554] = 524,
  [1555] = 1540,
  [1556] = 525,
  [1557] = 547,
  [1558] = 497,
  [1559] = 478,
  [1560] = 541,
  [1561] = 539,
  [1562] = 538,
  [1563] = 1540,
  [1564] = 1564,
  [1565] = 1564,
  [1566] = 527,
  [1567] = 508,
  [1568] = 507,
  [1569] = 450,
  [1570] = 504,
  [1571] = 451,
  [1572] = 501,
  [1573] = 500,
  [1574] = 494,
  [1575] = 550,
  [1576] = 469,
  [1577] = 513,
  [1578] = 333,
  [1579] = 343,
  [1580] = 348,
  [1581] = 1581,
  [1582] = 1582,
  [1583] = 1583,
  [1584] = 394,
  [1585] = 1564,
  [1586] = 1564,
  [1587] = 420,
  [1588] = 422,
  [1589] = 512,
  [1590] = 511,
  [1591] = 423,
  [1592] = 503,
  [1593] = 431,
  [1594] = 429,
  [1595] = 502,
  [1596] = 1540,
  [1597] = 1597,
  [1598] = 441,
  [1599] = 383,
  [1600] = 498,
  [1601] = 479,
  [1602] = 381,
  [1603] = 312,
  [1604] = 1604,
  [1605] = 1605,
  [1606] = 1597,
  [1607] = 540,
  [1608] = 1540,
  [1609] = 334,
  [1610] = 335,
  [1611] = 1611,
  [1612] = 1612,
  [1613] = 1613,
  [1614] = 1614,
  [1615] = 1615,
  [1616] = 1616,
  [1617] = 1617,
  [1618] = 1564,
  [1619] = 1619,
  [1620] = 1620,
  [1621] = 1621,
  [1622] = 1622,
  [1623] = 1623,
  [1624] = 1624,
  [1625] = 1625,
  [1626] = 1626,
  [1627] = 1627,
  [1628] = 1628,
  [1629] = 1629,
  [1630] = 1540,
  [1631] = 1631,
  [1632] = 449,
  [1633] = 448,
  [1634] = 1597,
  [1635] = 1635,
  [1636] = 447,
  [1637] = 487,
  [1638] = 1638,
  [1639] = 1639,
  [1640] = 1640,
  [1641] = 1641,
  [1642] = 1642,
  [1643] = 444,
  [1644] = 1644,
  [1645] = 1645,
  [1646] = 1646,
  [1647] = 1647,
  [1648] = 1648,
  [1649] = 1649,
  [1650] = 1650,
  [1651] = 1651,
  [1652] = 458,
  [1653] = 473,
  [1654] = 459,
  [1655] = 464,
  [1656] = 470,
  [1657] = 442,
  [1658] = 1658,
  [1659] = 468,
  [1660] = 1660,
  [1661] = 1661,
  [1662] = 1662,
  [1663] = 465,
  [1664] = 466,
  [1665] = 1665,
  [1666] = 1666,
  [1667] = 1667,
  [1668] = 1668,
  [1669] = 1669,
  [1670] = 1670,
  [1671] = 1671,
  [1672] = 1672,
  [1673] = 1673,
  [1674] = 1674,
  [1675] = 1671,
  [1676] = 1676,
  [1677] = 1671,
  [1678] = 1676,
  [1679] = 1671,
  [1680] = 1670,
  [1681] = 243,
  [1682] = 1671,
  [1683] = 1671,
  [1684] = 1672,
  [1685] = 1669,
  [1686] = 1671,
  [1687] = 243,
  [1688] = 1672,
  [1689] = 269,
  [1690] = 1671,
  [1691] = 1691,
  [1692] = 1676,
  [1693] = 1672,
  [1694] = 1676,
  [1695] = 1671,
  [1696] = 1696,
  [1697] = 1697,
  [1698] = 1670,
  [1699] = 1671,
  [1700] = 1670,
  [1701] = 1676,
  [1702] = 1676,
  [1703] = 1670,
  [1704] = 1670,
  [1705] = 1676,
  [1706] = 1706,
  [1707] = 264,
  [1708] = 1670,
  [1709] = 1709,
  [1710] = 1672,
  [1711] = 1671,
  [1712] = 1676,
  [1713] = 1671,
  [1714] = 1672,
  [1715] = 1669,
  [1716] = 269,
  [1717] = 1672,
  [1718] = 1676,
  [1719] = 276,
  [1720] = 1720,
  [1721] = 1672,
  [1722] = 1670,
  [1723] = 1672,
  [1724] = 1670,
  [1725] = 1676,
  [1726] = 1672,
  [1727] = 276,
  [1728] = 1728,
  [1729] = 1672,
  [1730] = 1671,
  [1731] = 1670,
  [1732] = 1672,
  [1733] = 1676,
  [1734] = 264,
  [1735] = 1670,
  [1736] = 1736,
  [1737] = 1670,
  [1738] = 1676,
  [1739] = 1676,
  [1740] = 1740,
  [1741] = 1670,
  [1742] = 1742,
  [1743] = 1743,
  [1744] = 1672,
  [1745] = 1745,
  [1746] = 1746,
  [1747] = 1747,
  [1748] = 1748,
  [1749] = 1749,
  [1750] = 1750,
  [1751] = 1749,
  [1752] = 1752,
  [1753] = 1753,
  [1754] = 1754,
  [1755] = 1752,
  [1756] = 1749,
  [1757] = 1757,
  [1758] = 1758,
  [1759] = 1752,
  [1760] = 1760,
  [1761] = 1752,
  [1762] = 1749,
  [1763] = 1763,
  [1764] = 1752,
  [1765] = 1765,
  [1766] = 1749,
  [1767] = 1767,
  [1768] = 1768,
  [1769] = 1769,
  [1770] = 1770,
  [1771] = 1758,
  [1772] = 1749,
  [1773] = 1752,
  [1774] = 1752,
  [1775] = 1775,
  [1776] = 1758,
  [1777] = 1749,
  [1778] = 1778,
  [1779] = 1752,
  [1780] = 1758,
  [1781] = 1749,
  [1782] = 1749,
  [1783] = 649,
  [1784] = 1752,
  [1785] = 1785,
  [1786] = 1752,
  [1787] = 1749,
  [1788] = 1752,
  [1789] = 1789,
  [1790] = 1752,
  [1791] = 1749,
  [1792] = 1749,
  [1793] = 1752,
  [1794] = 1794,
  [1795] = 1795,
  [1796] = 1796,
  [1797] = 1749,
  [1798] = 1798,
  [1799] = 1799,
  [1800] = 1800,
  [1801] = 649,
  [1802] = 1758,
  [1803] = 1758,
  [1804] = 1758,
  [1805] = 1805,
  [1806] = 192,
  [1807] = 1807,
  [1808] = 1808,
  [1809] = 192,
  [1810] = 1810,
  [1811] = 1811,
  [1812] = 1812,
  [1813] = 191,
  [1814] = 1814,
  [1815] = 1815,
  [1816] = 1811,
  [1817] = 1808,
  [1818] = 191,
  [1819] = 1819,
  [1820] = 1820,
  [1821] = 1821,
  [1822] = 1812,
  [1823] = 1812,
  [1824] = 1808,
  [1825] = 1825,
  [1826] = 1826,
  [1827] = 1827,
  [1828] = 1811,
  [1829] = 1829,
  [1830] = 1830,
  [1831] = 1831,
  [1832] = 1832,
  [1833] = 1833,
  [1834] = 1834,
  [1835] = 1831,
  [1836] = 1812,
  [1837] = 1808,
  [1838] = 1811,
  [1839] = 1839,
  [1840] = 1811,
  [1841] = 1805,
  [1842] = 1842,
  [1843] = 1843,
  [1844] = 281,
  [1845] = 1845,
  [1846] = 1811,
  [1847] = 1847,
  [1848] = 1821,
  [1849] = 1849,
  [1850] = 1850,
  [1851] = 1811,
  [1852] = 1852,
  [1853] = 1853,
  [1854] = 1811,
  [1855] = 1855,
  [1856] = 1831,
  [1857] = 1857,
  [1858] = 1858,
  [1859] = 1859,
  [1860] = 1852,
  [1861] = 1821,
  [1862] = 1862,
  [1863] = 281,
  [1864] = 1805,
  [1865] = 1831,
  [1866] = 1825,
  [1867] = 1867,
  [1868] = 1868,
  [1869] = 1807,
  [1870] = 1821,
  [1871] = 1826,
  [1872] = 1833,
  [1873] = 1834,
  [1874] = 1842,
  [1875] = 1875,
  [1876] = 1812,
  [1877] = 1877,
  [1878] = 1878,
  [1879] = 1879,
  [1880] = 1880,
  [1881] = 1857,
  [1882] = 1853,
  [1883] = 1810,
  [1884] = 1815,
  [1885] = 1885,
  [1886] = 1886,
  [1887] = 1887,
  [1888] = 1811,
  [1889] = 1889,
  [1890] = 1805,
  [1891] = 1891,
  [1892] = 1892,
  [1893] = 1893,
  [1894] = 1811,
  [1895] = 1895,
  [1896] = 1896,
  [1897] = 1897,
  [1898] = 1898,
  [1899] = 1895,
  [1900] = 1821,
  [1901] = 1898,
  [1902] = 1808,
  [1903] = 1897,
  [1904] = 1896,
  [1905] = 1811,
  [1906] = 1831,
  [1907] = 1821,
  [1908] = 1831,
  [1909] = 1909,
  [1910] = 1852,
  [1911] = 1893,
  [1912] = 1821,
  [1913] = 1839,
  [1914] = 1858,
  [1915] = 1892,
  [1916] = 1852,
  [1917] = 1891,
  [1918] = 1889,
  [1919] = 1825,
  [1920] = 1920,
  [1921] = 1921,
  [1922] = 1811,
  [1923] = 1845,
  [1924] = 1887,
  [1925] = 1811,
  [1926] = 1875,
  [1927] = 1877,
  [1928] = 1868,
  [1929] = 1929,
  [1930] = 1878,
  [1931] = 1931,
  [1932] = 1880,
  [1933] = 1879,
  [1934] = 1886,
  [1935] = 1885,
  [1936] = 1936,
  [1937] = 1831,
  [1938] = 1938,
  [1939] = 1939,
  [1940] = 1938,
  [1941] = 1941,
  [1942] = 1942,
  [1943] = 1943,
  [1944] = 1944,
  [1945] = 1939,
  [1946] = 442,
  [1947] = 1947,
  [1948] = 1948,
  [1949] = 468,
  [1950] = 1950,
  [1951] = 1951,
  [1952] = 1952,
  [1953] = 1953,
  [1954] = 1954,
  [1955] = 1955,
  [1956] = 1956,
  [1957] = 1957,
  [1958] = 1958,
  [1959] = 473,
  [1960] = 1960,
  [1961] = 1961,
  [1962] = 1617,
  [1963] = 470,
  [1964] = 1620,
  [1965] = 1961,
  [1966] = 1943,
  [1967] = 1967,
  [1968] = 1947,
  [1969] = 1969,
  [1970] = 466,
  [1971] = 1622,
  [1972] = 465,
  [1973] = 1938,
  [1974] = 1624,
  [1975] = 1948,
  [1976] = 1976,
  [1977] = 1950,
  [1978] = 461,
  [1979] = 1625,
  [1980] = 464,
  [1981] = 1627,
  [1982] = 1629,
  [1983] = 1631,
  [1984] = 459,
  [1985] = 458,
  [1986] = 1635,
  [1987] = 1651,
  [1988] = 1988,
  [1989] = 1989,
  [1990] = 1989,
  [1991] = 1991,
  [1992] = 1961,
  [1993] = 1957,
  [1994] = 1954,
  [1995] = 444,
  [1996] = 1996,
  [1997] = 1997,
  [1998] = 487,
  [1999] = 447,
  [2000] = 1960,
  [2001] = 1958,
  [2002] = 1955,
  [2003] = 1956,
  [2004] = 448,
  [2005] = 1942,
  [2006] = 449,
  [2007] = 1941,
  [2008] = 2008,
  [2009] = 1967,
  [2010] = 524,
  [2011] = 525,
  [2012] = 1954,
  [2013] = 2013,
  [2014] = 1951,
  [2015] = 1939,
  [2016] = 1953,
  [2017] = 2017,
  [2018] = 1976,
  [2019] = 1953,
  [2020] = 2020,
  [2021] = 1976,
  [2022] = 1952,
  [2023] = 2023,
  [2024] = 1955,
  [2025] = 1950,
  [2026] = 1948,
  [2027] = 1947,
  [2028] = 1943,
  [2029] = 1991,
  [2030] = 1996,
  [2031] = 1997,
  [2032] = 2008,
  [2033] = 2013,
  [2034] = 1967,
  [2035] = 478,
  [2036] = 1989,
  [2037] = 497,
  [2038] = 2038,
  [2039] = 1942,
  [2040] = 1941,
  [2041] = 1939,
  [2042] = 1988,
  [2043] = 469,
  [2044] = 1969,
  [2045] = 2045,
  [2046] = 513,
  [2047] = 2047,
  [2048] = 512,
  [2049] = 511,
  [2050] = 1939,
  [2051] = 1938,
  [2052] = 2023,
  [2053] = 1583,
  [2054] = 1938,
  [2055] = 1635,
  [2056] = 1961,
  [2057] = 503,
  [2058] = 1582,
  [2059] = 1658,
  [2060] = 1660,
  [2061] = 502,
  [2062] = 1661,
  [2063] = 1951,
  [2064] = 1662,
  [2065] = 1665,
  [2066] = 1941,
  [2067] = 1942,
  [2068] = 1944,
  [2069] = 1956,
  [2070] = 1666,
  [2071] = 2071,
  [2072] = 1538,
  [2073] = 1668,
  [2074] = 1667,
  [2075] = 2075,
  [2076] = 1939,
  [2077] = 1967,
  [2078] = 335,
  [2079] = 1958,
  [2080] = 1960,
  [2081] = 450,
  [2082] = 1604,
  [2083] = 1537,
  [2084] = 1605,
  [2085] = 509,
  [2086] = 1997,
  [2087] = 1969,
  [2088] = 1988,
  [2089] = 2089,
  [2090] = 1957,
  [2091] = 2013,
  [2092] = 2008,
  [2093] = 2093,
  [2094] = 1997,
  [2095] = 1996,
  [2096] = 1976,
  [2097] = 451,
  [2098] = 1991,
  [2099] = 2099,
  [2100] = 1961,
  [2101] = 1943,
  [2102] = 1947,
  [2103] = 1957,
  [2104] = 1948,
  [2105] = 1950,
  [2106] = 1955,
  [2107] = 443,
  [2108] = 2023,
  [2109] = 498,
  [2110] = 1611,
  [2111] = 1989,
  [2112] = 1953,
  [2113] = 1989,
  [2114] = 450,
  [2115] = 1612,
  [2116] = 446,
  [2117] = 1942,
  [2118] = 2045,
  [2119] = 479,
  [2120] = 498,
  [2121] = 1613,
  [2122] = 1961,
  [2123] = 1614,
  [2124] = 2023,
  [2125] = 1941,
  [2126] = 2126,
  [2127] = 1615,
  [2128] = 1616,
  [2129] = 1996,
  [2130] = 1988,
  [2131] = 2131,
  [2132] = 2132,
  [2133] = 1969,
  [2134] = 1967,
  [2135] = 1958,
  [2136] = 1650,
  [2137] = 502,
  [2138] = 1649,
  [2139] = 1648,
  [2140] = 503,
  [2141] = 1647,
  [2142] = 1646,
  [2143] = 1645,
  [2144] = 1644,
  [2145] = 1619,
  [2146] = 1642,
  [2147] = 1641,
  [2148] = 1640,
  [2149] = 1639,
  [2150] = 1638,
  [2151] = 2089,
  [2152] = 1628,
  [2153] = 1621,
  [2154] = 1939,
  [2155] = 1953,
  [2156] = 1989,
  [2157] = 1626,
  [2158] = 1623,
  [2159] = 447,
  [2160] = 1621,
  [2161] = 487,
  [2162] = 1623,
  [2163] = 511,
  [2164] = 2089,
  [2165] = 512,
  [2166] = 333,
  [2167] = 1988,
  [2168] = 1957,
  [2169] = 1619,
  [2170] = 1616,
  [2171] = 1988,
  [2172] = 1969,
  [2173] = 513,
  [2174] = 2023,
  [2175] = 1615,
  [2176] = 1614,
  [2177] = 1626,
  [2178] = 1613,
  [2179] = 1988,
  [2180] = 469,
  [2181] = 550,
  [2182] = 2132,
  [2183] = 515,
  [2184] = 1969,
  [2185] = 1976,
  [2186] = 1938,
  [2187] = 465,
  [2188] = 1612,
  [2189] = 466,
  [2190] = 2190,
  [2191] = 2038,
  [2192] = 468,
  [2193] = 442,
  [2194] = 1611,
  [2195] = 1605,
  [2196] = 343,
  [2197] = 1583,
  [2198] = 1537,
  [2199] = 1604,
  [2200] = 1582,
  [2201] = 348,
  [2202] = 1954,
  [2203] = 2089,
  [2204] = 1950,
  [2205] = 1956,
  [2206] = 1976,
  [2207] = 1938,
  [2208] = 509,
  [2209] = 1969,
  [2210] = 1944,
  [2211] = 1988,
  [2212] = 494,
  [2213] = 1961,
  [2214] = 504,
  [2215] = 451,
  [2216] = 1953,
  [2217] = 1952,
  [2218] = 525,
  [2219] = 524,
  [2220] = 2190,
  [2221] = 2013,
  [2222] = 1961,
  [2223] = 520,
  [2224] = 2008,
  [2225] = 2225,
  [2226] = 1989,
  [2227] = 2089,
  [2228] = 2089,
  [2229] = 2229,
  [2230] = 2230,
  [2231] = 2231,
  [2232] = 1953,
  [2233] = 2233,
  [2234] = 1989,
  [2235] = 471,
  [2236] = 1988,
  [2237] = 1939,
  [2238] = 538,
  [2239] = 539,
  [2240] = 500,
  [2241] = 484,
  [2242] = 1958,
  [2243] = 2243,
  [2244] = 1997,
  [2245] = 501,
  [2246] = 482,
  [2247] = 2247,
  [2248] = 1939,
  [2249] = 2023,
  [2250] = 2250,
  [2251] = 1645,
  [2252] = 480,
  [2253] = 2253,
  [2254] = 2190,
  [2255] = 1996,
  [2256] = 1955,
  [2257] = 1950,
  [2258] = 2126,
  [2259] = 507,
  [2260] = 1948,
  [2261] = 1947,
  [2262] = 470,
  [2263] = 1991,
  [2264] = 1951,
  [2265] = 1943,
  [2266] = 1955,
  [2267] = 1991,
  [2268] = 1950,
  [2269] = 2190,
  [2270] = 1941,
  [2271] = 2023,
  [2272] = 1961,
  [2273] = 1942,
  [2274] = 1944,
  [2275] = 1956,
  [2276] = 1948,
  [2277] = 1947,
  [2278] = 1942,
  [2279] = 1943,
  [2280] = 1628,
  [2281] = 1991,
  [2282] = 1638,
  [2283] = 1996,
  [2284] = 1997,
  [2285] = 1639,
  [2286] = 1996,
  [2287] = 1969,
  [2288] = 1640,
  [2289] = 1641,
  [2290] = 1997,
  [2291] = 1989,
  [2292] = 2008,
  [2293] = 2013,
  [2294] = 1967,
  [2295] = 443,
  [2296] = 446,
  [2297] = 334,
  [2298] = 1941,
  [2299] = 2038,
  [2300] = 1958,
  [2301] = 1957,
  [2302] = 335,
  [2303] = 334,
  [2304] = 1960,
  [2305] = 1989,
  [2306] = 461,
  [2307] = 2008,
  [2308] = 1642,
  [2309] = 1955,
  [2310] = 2013,
  [2311] = 1953,
  [2312] = 1950,
  [2313] = 1967,
  [2314] = 2013,
  [2315] = 2008,
  [2316] = 1997,
  [2317] = 1644,
  [2318] = 1996,
  [2319] = 1967,
  [2320] = 1948,
  [2321] = 1991,
  [2322] = 707,
  [2323] = 1947,
  [2324] = 2190,
  [2325] = 1943,
  [2326] = 1991,
  [2327] = 1996,
  [2328] = 1969,
  [2329] = 1967,
  [2330] = 1938,
  [2331] = 1997,
  [2332] = 2008,
  [2333] = 2013,
  [2334] = 1976,
  [2335] = 1943,
  [2336] = 2131,
  [2337] = 480,
  [2338] = 1988,
  [2339] = 1967,
  [2340] = 1960,
  [2341] = 1955,
  [2342] = 1969,
  [2343] = 2045,
  [2344] = 1947,
  [2345] = 1948,
  [2346] = 1950,
  [2347] = 1988,
  [2348] = 1955,
  [2349] = 471,
  [2350] = 1953,
  [2351] = 484,
  [2352] = 508,
  [2353] = 2089,
  [2354] = 2013,
  [2355] = 1961,
  [2356] = 1646,
  [2357] = 540,
  [2358] = 312,
  [2359] = 1956,
  [2360] = 1955,
  [2361] = 482,
  [2362] = 1944,
  [2363] = 1950,
  [2364] = 1948,
  [2365] = 1942,
  [2366] = 1941,
  [2367] = 1947,
  [2368] = 1647,
  [2369] = 2045,
  [2370] = 2008,
  [2371] = 1943,
  [2372] = 1961,
  [2373] = 381,
  [2374] = 1943,
  [2375] = 1648,
  [2376] = 1991,
  [2377] = 383,
  [2378] = 1951,
  [2379] = 441,
  [2380] = 2126,
  [2381] = 1957,
  [2382] = 2382,
  [2383] = 1997,
  [2384] = 1996,
  [2385] = 1938,
  [2386] = 1976,
  [2387] = 1649,
  [2388] = 1939,
  [2389] = 1953,
  [2390] = 1996,
  [2391] = 1939,
  [2392] = 1954,
  [2393] = 2393,
  [2394] = 1650,
  [2395] = 1953,
  [2396] = 1957,
  [2397] = 1991,
  [2398] = 1939,
  [2399] = 2008,
  [2400] = 2013,
  [2401] = 1991,
  [2402] = 1952,
  [2403] = 1953,
  [2404] = 1948,
  [2405] = 1947,
  [2406] = 1943,
  [2407] = 2089,
  [2408] = 520,
  [2409] = 1943,
  [2410] = 1947,
  [2411] = 1939,
  [2412] = 1651,
  [2413] = 1967,
  [2414] = 1939,
  [2415] = 1991,
  [2416] = 1948,
  [2417] = 547,
  [2418] = 1938,
  [2419] = 1961,
  [2420] = 1976,
  [2421] = 1960,
  [2422] = 1969,
  [2423] = 2132,
  [2424] = 1988,
  [2425] = 1957,
  [2426] = 541,
  [2427] = 1950,
  [2428] = 540,
  [2429] = 1996,
  [2430] = 1948,
  [2431] = 2250,
  [2432] = 1955,
  [2433] = 1997,
  [2434] = 2089,
  [2435] = 2038,
  [2436] = 2008,
  [2437] = 1957,
  [2438] = 1953,
  [2439] = 1631,
  [2440] = 429,
  [2441] = 431,
  [2442] = 423,
  [2443] = 422,
  [2444] = 1939,
  [2445] = 381,
  [2446] = 1938,
  [2447] = 1976,
  [2448] = 1953,
  [2449] = 312,
  [2450] = 1939,
  [2451] = 550,
  [2452] = 1953,
  [2453] = 1939,
  [2454] = 1950,
  [2455] = 1997,
  [2456] = 1953,
  [2457] = 2071,
  [2458] = 2247,
  [2459] = 479,
  [2460] = 441,
  [2461] = 1976,
  [2462] = 1955,
  [2463] = 1953,
  [2464] = 383,
  [2465] = 1953,
  [2466] = 1952,
  [2467] = 1939,
  [2468] = 1953,
  [2469] = 1939,
  [2470] = 1953,
  [2471] = 1939,
  [2472] = 1953,
  [2473] = 429,
  [2474] = 431,
  [2475] = 1939,
  [2476] = 449,
  [2477] = 448,
  [2478] = 1953,
  [2479] = 1951,
  [2480] = 444,
  [2481] = 1957,
  [2482] = 2126,
  [2483] = 2008,
  [2484] = 458,
  [2485] = 459,
  [2486] = 464,
  [2487] = 420,
  [2488] = 1939,
  [2489] = 1658,
  [2490] = 1953,
  [2491] = 1939,
  [2492] = 2492,
  [2493] = 1953,
  [2494] = 2013,
  [2495] = 1939,
  [2496] = 1939,
  [2497] = 473,
  [2498] = 547,
  [2499] = 2126,
  [2500] = 1953,
  [2501] = 1967,
  [2502] = 1939,
  [2503] = 2045,
  [2504] = 1629,
  [2505] = 2089,
  [2506] = 1976,
  [2507] = 2008,
  [2508] = 2089,
  [2509] = 1957,
  [2510] = 497,
  [2511] = 1617,
  [2512] = 1947,
  [2513] = 1988,
  [2514] = 527,
  [2515] = 1969,
  [2516] = 478,
  [2517] = 1620,
  [2518] = 2089,
  [2519] = 420,
  [2520] = 422,
  [2521] = 423,
  [2522] = 1955,
  [2523] = 1622,
  [2524] = 1953,
  [2525] = 1660,
  [2526] = 1661,
  [2527] = 1950,
  [2528] = 1948,
  [2529] = 1947,
  [2530] = 1989,
  [2531] = 1943,
  [2532] = 1991,
  [2533] = 1996,
  [2534] = 1997,
  [2535] = 1627,
  [2536] = 2013,
  [2537] = 1960,
  [2538] = 2013,
  [2539] = 1967,
  [2540] = 515,
  [2541] = 1662,
  [2542] = 1961,
  [2543] = 333,
  [2544] = 394,
  [2545] = 343,
  [2546] = 348,
  [2547] = 1952,
  [2548] = 1954,
  [2549] = 1969,
  [2550] = 1624,
  [2551] = 1958,
  [2552] = 2089,
  [2553] = 527,
  [2554] = 1665,
  [2555] = 2555,
  [2556] = 2556,
  [2557] = 1957,
  [2558] = 1625,
  [2559] = 1938,
  [2560] = 1976,
  [2561] = 1667,
  [2562] = 1938,
  [2563] = 1668,
  [2564] = 538,
  [2565] = 539,
  [2566] = 1538,
  [2567] = 1666,
  [2568] = 541,
  [2569] = 494,
  [2570] = 500,
  [2571] = 501,
  [2572] = 504,
  [2573] = 1956,
  [2574] = 1944,
  [2575] = 507,
  [2576] = 508,
  [2577] = 1942,
  [2578] = 1941,
  [2579] = 2190,
  [2580] = 1951,
  [2581] = 394,
  [2582] = 2582,
  [2583] = 2583,
  [2584] = 2584,
  [2585] = 2585,
  [2586] = 2585,
  [2587] = 2585,
  [2588] = 2584,
  [2589] = 2585,
  [2590] = 2585,
  [2591] = 2585,
  [2592] = 2584,
  [2593] = 2585,
  [2594] = 2584,
  [2595] = 193,
  [2596] = 2596,
  [2597] = 190,
  [2598] = 1337,
  [2599] = 1337,
  [2600] = 117,
  [2601] = 106,
  [2602] = 196,
  [2603] = 192,
  [2604] = 112,
  [2605] = 285,
  [2606] = 113,
  [2607] = 2607,
  [2608] = 114,
  [2609] = 212,
  [2610] = 2610,
  [2611] = 201,
  [2612] = 707,
  [2613] = 119,
  [2614] = 197,
  [2615] = 105,
  [2616] = 194,
  [2617] = 191,
  [2618] = 195,
  [2619] = 107,
  [2620] = 116,
  [2621] = 115,
  [2622] = 109,
  [2623] = 110,
  [2624] = 118,
  [2625] = 120,
  [2626] = 108,
  [2627] = 1337,
  [2628] = 2628,
  [2629] = 2629,
  [2630] = 2630,
  [2631] = 463,
  [2632] = 644,
  [2633] = 1197,
  [2634] = 245,
  [2635] = 2583,
  [2636] = 1195,
  [2637] = 2637,
  [2638] = 635,
  [2639] = 630,
  [2640] = 108,
  [2641] = 120,
  [2642] = 119,
  [2643] = 110,
  [2644] = 117,
  [2645] = 114,
  [2646] = 113,
  [2647] = 2582,
  [2648] = 633,
  [2649] = 105,
  [2650] = 643,
  [2651] = 631,
  [2652] = 115,
  [2653] = 109,
  [2654] = 106,
  [2655] = 112,
  [2656] = 641,
  [2657] = 118,
  [2658] = 285,
  [2659] = 642,
  [2660] = 116,
  [2661] = 629,
  [2662] = 107,
  [2663] = 2663,
  [2664] = 2664,
  [2665] = 2665,
  [2666] = 2666,
  [2667] = 2664,
  [2668] = 2664,
  [2669] = 2664,
  [2670] = 2670,
  [2671] = 628,
  [2672] = 194,
  [2673] = 2673,
  [2674] = 2673,
  [2675] = 197,
  [2676] = 2673,
  [2677] = 595,
  [2678] = 603,
  [2679] = 201,
  [2680] = 196,
  [2681] = 2673,
  [2682] = 195,
  [2683] = 2673,
  [2684] = 2673,
  [2685] = 2673,
  [2686] = 212,
  [2687] = 2687,
  [2688] = 2687,
  [2689] = 2689,
  [2690] = 2689,
  [2691] = 2689,
  [2692] = 532,
  [2693] = 2689,
  [2694] = 2694,
  [2695] = 2689,
  [2696] = 2694,
  [2697] = 2689,
  [2698] = 2689,
  [2699] = 2699,
  [2700] = 638,
  [2701] = 625,
  [2702] = 620,
  [2703] = 617,
  [2704] = 626,
  [2705] = 647,
  [2706] = 613,
  [2707] = 2707,
  [2708] = 639,
  [2709] = 495,
  [2710] = 621,
  [2711] = 653,
  [2712] = 437,
  [2713] = 651,
  [2714] = 640,
  [2715] = 268,
  [2716] = 435,
  [2717] = 355,
  [2718] = 405,
  [2719] = 2719,
  [2720] = 295,
  [2721] = 341,
  [2722] = 2722,
  [2723] = 273,
  [2724] = 2719,
  [2725] = 303,
  [2726] = 369,
  [2727] = 789,
  [2728] = 794,
  [2729] = 432,
  [2730] = 298,
  [2731] = 2719,
  [2732] = 2719,
  [2733] = 495,
  [2734] = 436,
  [2735] = 349,
  [2736] = 357,
  [2737] = 434,
  [2738] = 285,
  [2739] = 358,
  [2740] = 297,
  [2741] = 361,
  [2742] = 190,
  [2743] = 2722,
  [2744] = 2722,
  [2745] = 237,
  [2746] = 428,
  [2747] = 2719,
  [2748] = 427,
  [2749] = 342,
  [2750] = 2719,
  [2751] = 418,
  [2752] = 193,
  [2753] = 313,
  [2754] = 2754,
  [2755] = 339,
  [2756] = 368,
  [2757] = 373,
  [2758] = 378,
  [2759] = 2719,
  [2760] = 2722,
  [2761] = 234,
  [2762] = 372,
  [2763] = 319,
  [2764] = 318,
  [2765] = 389,
  [2766] = 426,
  [2767] = 438,
  [2768] = 379,
  [2769] = 532,
  [2770] = 439,
  [2771] = 385,
  [2772] = 440,
  [2773] = 388,
  [2774] = 421,
  [2775] = 1195,
  [2776] = 2776,
  [2777] = 2665,
  [2778] = 2778,
  [2779] = 344,
  [2780] = 2754,
  [2781] = 2707,
  [2782] = 2782,
  [2783] = 1197,
  [2784] = 2784,
  [2785] = 2785,
  [2786] = 2786,
  [2787] = 116,
  [2788] = 120,
  [2789] = 108,
  [2790] = 105,
  [2791] = 201,
  [2792] = 2792,
  [2793] = 112,
  [2794] = 115,
  [2795] = 110,
  [2796] = 109,
  [2797] = 107,
  [2798] = 193,
  [2799] = 118,
  [2800] = 106,
  [2801] = 2801,
  [2802] = 119,
  [2803] = 117,
  [2804] = 2804,
  [2805] = 114,
  [2806] = 113,
  [2807] = 190,
  [2808] = 2808,
  [2809] = 2778,
  [2810] = 113,
  [2811] = 114,
  [2812] = 117,
  [2813] = 119,
  [2814] = 106,
  [2815] = 2785,
  [2816] = 212,
  [2817] = 107,
  [2818] = 2818,
  [2819] = 116,
  [2820] = 109,
  [2821] = 344,
  [2822] = 421,
  [2823] = 110,
  [2824] = 118,
  [2825] = 120,
  [2826] = 108,
  [2827] = 115,
  [2828] = 105,
  [2829] = 112,
  [2830] = 114,
  [2831] = 109,
  [2832] = 118,
  [2833] = 2833,
  [2834] = 112,
  [2835] = 2835,
  [2836] = 111,
  [2837] = 115,
  [2838] = 113,
  [2839] = 117,
  [2840] = 110,
  [2841] = 1195,
  [2842] = 119,
  [2843] = 105,
  [2844] = 201,
  [2845] = 108,
  [2846] = 106,
  [2847] = 107,
  [2848] = 104,
  [2849] = 104,
  [2850] = 120,
  [2851] = 2851,
  [2852] = 1197,
  [2853] = 116,
  [2854] = 113,
  [2855] = 195,
  [2856] = 120,
  [2857] = 245,
  [2858] = 635,
  [2859] = 197,
  [2860] = 268,
  [2861] = 196,
  [2862] = 2862,
  [2863] = 108,
  [2864] = 105,
  [2865] = 106,
  [2866] = 119,
  [2867] = 2808,
  [2868] = 2868,
  [2869] = 104,
  [2870] = 104,
  [2871] = 117,
  [2872] = 285,
  [2873] = 194,
  [2874] = 114,
  [2875] = 109,
  [2876] = 107,
  [2877] = 110,
  [2878] = 116,
  [2879] = 115,
  [2880] = 112,
  [2881] = 2881,
  [2882] = 2707,
  [2883] = 273,
  [2884] = 2786,
  [2885] = 118,
  [2886] = 358,
  [2887] = 439,
  [2888] = 361,
  [2889] = 355,
  [2890] = 341,
  [2891] = 295,
  [2892] = 644,
  [2893] = 349,
  [2894] = 237,
  [2895] = 717,
  [2896] = 426,
  [2897] = 297,
  [2898] = 2784,
  [2899] = 111,
  [2900] = 789,
  [2901] = 744,
  [2902] = 434,
  [2903] = 635,
  [2904] = 794,
  [2905] = 104,
  [2906] = 635,
  [2907] = 436,
  [2908] = 432,
  [2909] = 435,
  [2910] = 111,
  [2911] = 318,
  [2912] = 357,
  [2913] = 405,
  [2914] = 438,
  [2915] = 298,
  [2916] = 440,
  [2917] = 313,
  [2918] = 437,
  [2919] = 379,
  [2920] = 385,
  [2921] = 111,
  [2922] = 388,
  [2923] = 339,
  [2924] = 389,
  [2925] = 368,
  [2926] = 342,
  [2927] = 378,
  [2928] = 372,
  [2929] = 234,
  [2930] = 418,
  [2931] = 427,
  [2932] = 428,
  [2933] = 373,
  [2934] = 303,
  [2935] = 369,
  [2936] = 319,
  [2937] = 193,
  [2938] = 744,
  [2939] = 707,
  [2940] = 2940,
  [2941] = 717,
  [2942] = 104,
  [2943] = 190,
  [2944] = 111,
  [2945] = 2687,
  [2946] = 2946,
  [2947] = 195,
  [2948] = 628,
  [2949] = 630,
  [2950] = 2694,
  [2951] = 2951,
  [2952] = 2952,
  [2953] = 194,
  [2954] = 196,
  [2955] = 212,
  [2956] = 2956,
  [2957] = 111,
  [2958] = 197,
  [2959] = 2707,
  [2960] = 2960,
  [2961] = 641,
  [2962] = 629,
  [2963] = 2963,
  [2964] = 642,
  [2965] = 631,
  [2966] = 245,
  [2967] = 643,
  [2968] = 633,
  [2969] = 2969,
  [2970] = 201,
  [2971] = 2963,
  [2972] = 2969,
  [2973] = 2973,
  [2974] = 595,
  [2975] = 463,
  [2976] = 2973,
  [2977] = 2719,
  [2978] = 2978,
  [2979] = 245,
  [2980] = 2973,
  [2981] = 2784,
  [2982] = 2982,
  [2983] = 603,
  [2984] = 2719,
  [2985] = 2960,
  [2986] = 626,
  [2987] = 312,
  [2988] = 104,
  [2989] = 495,
  [2990] = 463,
  [2991] = 2784,
  [2992] = 495,
  [2993] = 2784,
  [2994] = 2582,
  [2995] = 2995,
  [2996] = 2784,
  [2997] = 2792,
  [2998] = 2978,
  [2999] = 635,
  [3000] = 268,
  [3001] = 653,
  [3002] = 394,
  [3003] = 644,
  [3004] = 651,
  [3005] = 2978,
  [3006] = 2801,
  [3007] = 1374,
  [3008] = 2995,
  [3009] = 2804,
  [3010] = 273,
  [3011] = 644,
  [3012] = 2978,
  [3013] = 621,
  [3014] = 617,
  [3015] = 620,
  [3016] = 625,
  [3017] = 3017,
  [3018] = 639,
  [3019] = 2804,
  [3020] = 2583,
  [3021] = 635,
  [3022] = 2978,
  [3023] = 2784,
  [3024] = 431,
  [3025] = 638,
  [3026] = 647,
  [3027] = 429,
  [3028] = 2978,
  [3029] = 441,
  [3030] = 540,
  [3031] = 2801,
  [3032] = 640,
  [3033] = 2792,
  [3034] = 613,
  [3035] = 318,
  [3036] = 2808,
  [3037] = 2801,
  [3038] = 313,
  [3039] = 339,
  [3040] = 234,
  [3041] = 2786,
  [3042] = 368,
  [3043] = 372,
  [3044] = 630,
  [3045] = 631,
  [3046] = 633,
  [3047] = 2784,
  [3048] = 319,
  [3049] = 2687,
  [3050] = 643,
  [3051] = 237,
  [3052] = 2881,
  [3053] = 2792,
  [3054] = 342,
  [3055] = 435,
  [3056] = 641,
  [3057] = 629,
  [3058] = 642,
  [3059] = 707,
  [3060] = 361,
  [3061] = 295,
  [3062] = 2804,
  [3063] = 297,
  [3064] = 603,
  [3065] = 303,
  [3066] = 2784,
  [3067] = 2694,
  [3068] = 369,
  [3069] = 379,
  [3070] = 385,
  [3071] = 388,
  [3072] = 418,
  [3073] = 298,
  [3074] = 349,
  [3075] = 427,
  [3076] = 428,
  [3077] = 2784,
  [3078] = 432,
  [3079] = 436,
  [3080] = 2784,
  [3081] = 373,
  [3082] = 378,
  [3083] = 3083,
  [3084] = 3084,
  [3085] = 3085,
  [3086] = 2868,
  [3087] = 389,
  [3088] = 285,
  [3089] = 3089,
  [3090] = 595,
  [3091] = 405,
  [3092] = 3092,
  [3093] = 440,
  [3094] = 3094,
  [3095] = 439,
  [3096] = 341,
  [3097] = 3097,
  [3098] = 438,
  [3099] = 355,
  [3100] = 437,
  [3101] = 434,
  [3102] = 357,
  [3103] = 426,
  [3104] = 358,
  [3105] = 653,
  [3106] = 626,
  [3107] = 3107,
  [3108] = 633,
  [3109] = 3109,
  [3110] = 3110,
  [3111] = 3111,
  [3112] = 631,
  [3113] = 3113,
  [3114] = 3114,
  [3115] = 3115,
  [3116] = 3116,
  [3117] = 3117,
  [3118] = 2963,
  [3119] = 3119,
  [3120] = 3120,
  [3121] = 104,
  [3122] = 628,
  [3123] = 651,
  [3124] = 642,
  [3125] = 630,
  [3126] = 629,
  [3127] = 628,
  [3128] = 638,
  [3129] = 640,
  [3130] = 3130,
  [3131] = 3131,
  [3132] = 3132,
  [3133] = 644,
  [3134] = 647,
  [3135] = 621,
  [3136] = 3136,
  [3137] = 625,
  [3138] = 643,
  [3139] = 641,
  [3140] = 3140,
  [3141] = 639,
  [3142] = 344,
  [3143] = 2960,
  [3144] = 421,
  [3145] = 2960,
  [3146] = 344,
  [3147] = 617,
  [3148] = 421,
  [3149] = 613,
  [3150] = 3150,
  [3151] = 620,
  [3152] = 2963,
  [3153] = 644,
  [3154] = 104,
  [3155] = 120,
  [3156] = 2868,
  [3157] = 3084,
  [3158] = 2808,
  [3159] = 113,
  [3160] = 285,
  [3161] = 118,
  [3162] = 114,
  [3163] = 3083,
  [3164] = 2786,
  [3165] = 2792,
  [3166] = 2963,
  [3167] = 111,
  [3168] = 2808,
  [3169] = 2960,
  [3170] = 117,
  [3171] = 3171,
  [3172] = 2786,
  [3173] = 3173,
  [3174] = 105,
  [3175] = 2881,
  [3176] = 108,
  [3177] = 119,
  [3178] = 112,
  [3179] = 3179,
  [3180] = 463,
  [3181] = 2868,
  [3182] = 2804,
  [3183] = 3084,
  [3184] = 2881,
  [3185] = 3083,
  [3186] = 3186,
  [3187] = 115,
  [3188] = 2801,
  [3189] = 110,
  [3190] = 106,
  [3191] = 107,
  [3192] = 109,
  [3193] = 635,
  [3194] = 3194,
  [3195] = 245,
  [3196] = 116,
  [3197] = 344,
  [3198] = 2808,
  [3199] = 635,
  [3200] = 3200,
  [3201] = 2808,
  [3202] = 3202,
  [3203] = 644,
  [3204] = 2868,
  [3205] = 3205,
  [3206] = 2868,
  [3207] = 3207,
  [3208] = 2881,
  [3209] = 3209,
  [3210] = 3210,
  [3211] = 3211,
  [3212] = 3212,
  [3213] = 3213,
  [3214] = 285,
  [3215] = 3215,
  [3216] = 3216,
  [3217] = 3217,
  [3218] = 3218,
  [3219] = 3219,
  [3220] = 421,
  [3221] = 2786,
  [3222] = 2868,
  [3223] = 1195,
  [3224] = 3224,
  [3225] = 3225,
  [3226] = 2786,
  [3227] = 2786,
  [3228] = 2881,
  [3229] = 3229,
  [3230] = 3230,
  [3231] = 2881,
  [3232] = 2808,
  [3233] = 463,
  [3234] = 3234,
  [3235] = 3235,
  [3236] = 495,
  [3237] = 1197,
  [3238] = 245,
  [3239] = 193,
  [3240] = 3083,
  [3241] = 3241,
  [3242] = 2960,
  [3243] = 3243,
  [3244] = 643,
  [3245] = 3245,
  [3246] = 641,
  [3247] = 3247,
  [3248] = 629,
  [3249] = 3249,
  [3250] = 3250,
  [3251] = 3251,
  [3252] = 3252,
  [3253] = 3253,
  [3254] = 3254,
  [3255] = 3255,
  [3256] = 1830,
  [3257] = 1814,
  [3258] = 1859,
  [3259] = 3259,
  [3260] = 630,
  [3261] = 1819,
  [3262] = 642,
  [3263] = 1867,
  [3264] = 2610,
  [3265] = 1909,
  [3266] = 2786,
  [3267] = 3267,
  [3268] = 3268,
  [3269] = 2868,
  [3270] = 3270,
  [3271] = 1855,
  [3272] = 3272,
  [3273] = 3273,
  [3274] = 3274,
  [3275] = 1847,
  [3276] = 1850,
  [3277] = 3277,
  [3278] = 3278,
  [3279] = 3279,
  [3280] = 3280,
  [3281] = 1827,
  [3282] = 3282,
  [3283] = 2607,
  [3284] = 3284,
  [3285] = 3084,
  [3286] = 1829,
  [3287] = 3287,
  [3288] = 3288,
  [3289] = 3289,
  [3290] = 631,
  [3291] = 633,
  [3292] = 3292,
  [3293] = 3293,
  [3294] = 3294,
  [3295] = 192,
  [3296] = 2881,
  [3297] = 1849,
  [3298] = 3298,
  [3299] = 1920,
  [3300] = 3300,
  [3301] = 3301,
  [3302] = 2963,
  [3303] = 495,
  [3304] = 3304,
  [3305] = 3305,
  [3306] = 3306,
  [3307] = 1843,
  [3308] = 3308,
  [3309] = 1921,
  [3310] = 3310,
  [3311] = 421,
  [3312] = 3312,
  [3313] = 3313,
  [3314] = 3314,
  [3315] = 3315,
  [3316] = 3316,
  [3317] = 3317,
  [3318] = 3318,
  [3319] = 3319,
  [3320] = 191,
  [3321] = 3321,
  [3322] = 111,
  [3323] = 2808,
  [3324] = 3324,
  [3325] = 3325,
  [3326] = 3326,
  [3327] = 3327,
  [3328] = 3328,
  [3329] = 3329,
  [3330] = 344,
  [3331] = 3331,
  [3332] = 3332,
  [3333] = 3333,
  [3334] = 190,
  [3335] = 3335,
  [3336] = 633,
  [3337] = 2786,
  [3338] = 2804,
  [3339] = 3333,
  [3340] = 463,
  [3341] = 245,
  [3342] = 2792,
  [3343] = 644,
  [3344] = 190,
  [3345] = 195,
  [3346] = 285,
  [3347] = 628,
  [3348] = 193,
  [3349] = 344,
  [3350] = 3329,
  [3351] = 2881,
  [3352] = 194,
  [3353] = 629,
  [3354] = 635,
  [3355] = 197,
  [3356] = 3356,
  [3357] = 2801,
  [3358] = 421,
  [3359] = 631,
  [3360] = 196,
  [3361] = 2868,
  [3362] = 2808,
  [3363] = 3293,
  [3364] = 197,
  [3365] = 196,
  [3366] = 642,
  [3367] = 643,
  [3368] = 641,
  [3369] = 630,
  [3370] = 3294,
  [3371] = 3371,
  [3372] = 212,
  [3373] = 194,
  [3374] = 2808,
  [3375] = 421,
  [3376] = 201,
  [3377] = 2881,
  [3378] = 717,
  [3379] = 2868,
  [3380] = 717,
  [3381] = 196,
  [3382] = 197,
  [3383] = 201,
  [3384] = 744,
  [3385] = 628,
  [3386] = 744,
  [3387] = 2786,
  [3388] = 744,
  [3389] = 495,
  [3390] = 344,
  [3391] = 717,
  [3392] = 212,
  [3393] = 195,
  [3394] = 194,
  [3395] = 190,
  [3396] = 201,
  [3397] = 633,
  [3398] = 2956,
  [3399] = 643,
  [3400] = 631,
  [3401] = 641,
  [3402] = 595,
  [3403] = 642,
  [3404] = 2946,
  [3405] = 603,
  [3406] = 630,
  [3407] = 193,
  [3408] = 629,
  [3409] = 2951,
  [3410] = 2952,
  [3411] = 107,
  [3412] = 638,
  [3413] = 626,
  [3414] = 120,
  [3415] = 2946,
  [3416] = 3416,
  [3417] = 2786,
  [3418] = 2951,
  [3419] = 3419,
  [3420] = 3420,
  [3421] = 2952,
  [3422] = 113,
  [3423] = 114,
  [3424] = 628,
  [3425] = 603,
  [3426] = 3426,
  [3427] = 3427,
  [3428] = 3428,
  [3429] = 118,
  [3430] = 3430,
  [3431] = 2868,
  [3432] = 2808,
  [3433] = 108,
  [3434] = 105,
  [3435] = 2881,
  [3436] = 639,
  [3437] = 111,
  [3438] = 344,
  [3439] = 647,
  [3440] = 117,
  [3441] = 3441,
  [3442] = 620,
  [3443] = 119,
  [3444] = 3444,
  [3445] = 3445,
  [3446] = 3446,
  [3447] = 3447,
  [3448] = 617,
  [3449] = 3449,
  [3450] = 621,
  [3451] = 106,
  [3452] = 3452,
  [3453] = 112,
  [3454] = 613,
  [3455] = 2956,
  [3456] = 115,
  [3457] = 195,
  [3458] = 116,
  [3459] = 3459,
  [3460] = 625,
  [3461] = 651,
  [3462] = 3462,
  [3463] = 421,
  [3464] = 3464,
  [3465] = 109,
  [3466] = 3466,
  [3467] = 653,
  [3468] = 595,
  [3469] = 3469,
  [3470] = 110,
  [3471] = 640,
  [3472] = 212,
  [3473] = 437,
  [3474] = 379,
  [3475] = 3301,
  [3476] = 273,
  [3477] = 3477,
  [3478] = 3267,
  [3479] = 389,
  [3480] = 626,
  [3481] = 3481,
  [3482] = 193,
  [3483] = 234,
  [3484] = 744,
  [3485] = 625,
  [3486] = 3486,
  [3487] = 653,
  [3488] = 237,
  [3489] = 3489,
  [3490] = 268,
  [3491] = 647,
  [3492] = 613,
  [3493] = 717,
  [3494] = 440,
  [3495] = 640,
  [3496] = 651,
  [3497] = 638,
  [3498] = 3489,
  [3499] = 3268,
  [3500] = 3270,
  [3501] = 3272,
  [3502] = 639,
  [3503] = 3273,
  [3504] = 620,
  [3505] = 111,
  [3506] = 617,
  [3507] = 3274,
  [3508] = 190,
  [3509] = 621,
  [3510] = 358,
  [3511] = 3416,
  [3512] = 603,
  [3513] = 2951,
  [3514] = 3489,
  [3515] = 435,
  [3516] = 361,
  [3517] = 3441,
  [3518] = 3459,
  [3519] = 3094,
  [3520] = 3447,
  [3521] = 3521,
  [3522] = 3521,
  [3523] = 385,
  [3524] = 2946,
  [3525] = 104,
  [3526] = 717,
  [3527] = 388,
  [3528] = 418,
  [3529] = 3092,
  [3530] = 378,
  [3531] = 373,
  [3532] = 427,
  [3533] = 349,
  [3534] = 273,
  [3535] = 428,
  [3536] = 298,
  [3537] = 379,
  [3538] = 369,
  [3539] = 303,
  [3540] = 432,
  [3541] = 436,
  [3542] = 3469,
  [3543] = 3521,
  [3544] = 2952,
  [3545] = 237,
  [3546] = 3462,
  [3547] = 3085,
  [3548] = 104,
  [3549] = 3489,
  [3550] = 341,
  [3551] = 355,
  [3552] = 357,
  [3553] = 342,
  [3554] = 3477,
  [3555] = 595,
  [3556] = 3419,
  [3557] = 426,
  [3558] = 434,
  [3559] = 438,
  [3560] = 439,
  [3561] = 319,
  [3562] = 268,
  [3563] = 440,
  [3564] = 3420,
  [3565] = 318,
  [3566] = 3452,
  [3567] = 707,
  [3568] = 3464,
  [3569] = 3444,
  [3570] = 2956,
  [3571] = 3462,
  [3572] = 437,
  [3573] = 3486,
  [3574] = 744,
  [3575] = 3426,
  [3576] = 3427,
  [3577] = 3481,
  [3578] = 372,
  [3579] = 3428,
  [3580] = 368,
  [3581] = 3335,
  [3582] = 339,
  [3583] = 313,
  [3584] = 3097,
  [3585] = 3089,
  [3586] = 3446,
  [3587] = 3469,
  [3588] = 405,
  [3589] = 3466,
  [3590] = 389,
  [3591] = 3430,
  [3592] = 3449,
  [3593] = 234,
  [3594] = 297,
  [3595] = 3445,
  [3596] = 295,
  [3597] = 349,
  [3598] = 357,
  [3599] = 361,
  [3600] = 435,
  [3601] = 388,
  [3602] = 717,
  [3603] = 104,
  [3604] = 212,
  [3605] = 418,
  [3606] = 626,
  [3607] = 625,
  [3608] = 427,
  [3609] = 428,
  [3610] = 2960,
  [3611] = 2963,
  [3612] = 374,
  [3613] = 647,
  [3614] = 613,
  [3615] = 640,
  [3616] = 3097,
  [3617] = 638,
  [3618] = 432,
  [3619] = 201,
  [3620] = 3136,
  [3621] = 3119,
  [3622] = 436,
  [3623] = 3120,
  [3624] = 342,
  [3625] = 319,
  [3626] = 3089,
  [3627] = 111,
  [3628] = 195,
  [3629] = 318,
  [3630] = 744,
  [3631] = 3094,
  [3632] = 439,
  [3633] = 3085,
  [3634] = 438,
  [3635] = 3110,
  [3636] = 434,
  [3637] = 426,
  [3638] = 3638,
  [3639] = 385,
  [3640] = 358,
  [3641] = 3641,
  [3642] = 369,
  [3643] = 355,
  [3644] = 707,
  [3645] = 341,
  [3646] = 639,
  [3647] = 378,
  [3648] = 373,
  [3649] = 3649,
  [3650] = 194,
  [3651] = 653,
  [3652] = 3092,
  [3653] = 620,
  [3654] = 3654,
  [3655] = 651,
  [3656] = 113,
  [3657] = 114,
  [3658] = 117,
  [3659] = 119,
  [3660] = 106,
  [3661] = 107,
  [3662] = 116,
  [3663] = 197,
  [3664] = 380,
  [3665] = 109,
  [3666] = 110,
  [3667] = 617,
  [3668] = 405,
  [3669] = 621,
  [3670] = 115,
  [3671] = 112,
  [3672] = 105,
  [3673] = 108,
  [3674] = 120,
  [3675] = 196,
  [3676] = 313,
  [3677] = 118,
  [3678] = 372,
  [3679] = 111,
  [3680] = 3680,
  [3681] = 368,
  [3682] = 298,
  [3683] = 295,
  [3684] = 339,
  [3685] = 297,
  [3686] = 303,
  [3687] = 3117,
  [3688] = 3114,
  [3689] = 3207,
  [3690] = 3215,
  [3691] = 3217,
  [3692] = 3692,
  [3693] = 3217,
  [3694] = 3452,
  [3695] = 3224,
  [3696] = 3225,
  [3697] = 2960,
  [3698] = 3213,
  [3699] = 3441,
  [3700] = 3229,
  [3701] = 3469,
  [3702] = 3466,
  [3703] = 3416,
  [3704] = 3416,
  [3705] = 273,
  [3706] = 111,
  [3707] = 389,
  [3708] = 3173,
  [3709] = 2963,
  [3710] = 3452,
  [3711] = 3446,
  [3712] = 3110,
  [3713] = 234,
  [3714] = 3459,
  [3715] = 437,
  [3716] = 440,
  [3717] = 3489,
  [3718] = 237,
  [3719] = 3444,
  [3720] = 3120,
  [3721] = 3419,
  [3722] = 3420,
  [3723] = 3114,
  [3724] = 3464,
  [3725] = 3426,
  [3726] = 3445,
  [3727] = 3427,
  [3728] = 3428,
  [3729] = 3430,
  [3730] = 3119,
  [3731] = 3207,
  [3732] = 3441,
  [3733] = 3445,
  [3734] = 3212,
  [3735] = 3447,
  [3736] = 3449,
  [3737] = 3466,
  [3738] = 3430,
  [3739] = 3136,
  [3740] = 245,
  [3741] = 3428,
  [3742] = 3427,
  [3743] = 3426,
  [3744] = 463,
  [3745] = 3464,
  [3746] = 3420,
  [3747] = 3419,
  [3748] = 3489,
  [3749] = 3205,
  [3750] = 3447,
  [3751] = 3444,
  [3752] = 379,
  [3753] = 3179,
  [3754] = 3449,
  [3755] = 3459,
  [3756] = 3194,
  [3757] = 104,
  [3758] = 3446,
  [3759] = 268,
  [3760] = 3207,
  [3761] = 3462,
  [3762] = 3207,
  [3763] = 3489,
  [3764] = 3489,
  [3765] = 3117,
  [3766] = 373,
  [3767] = 3767,
  [3768] = 3768,
  [3769] = 3769,
  [3770] = 3770,
  [3771] = 3770,
  [3772] = 1847,
  [3773] = 3768,
  [3774] = 3774,
  [3775] = 3775,
  [3776] = 319,
  [3777] = 3777,
  [3778] = 318,
  [3779] = 3770,
  [3780] = 3780,
  [3781] = 3774,
  [3782] = 3768,
  [3783] = 3213,
  [3784] = 3784,
  [3785] = 744,
  [3786] = 3224,
  [3787] = 3306,
  [3788] = 3769,
  [3789] = 3301,
  [3790] = 3225,
  [3791] = 1843,
  [3792] = 3441,
  [3793] = 3229,
  [3794] = 1197,
  [3795] = 3770,
  [3796] = 3130,
  [3797] = 3446,
  [3798] = 372,
  [3799] = 368,
  [3800] = 3444,
  [3801] = 3801,
  [3802] = 3802,
  [3803] = 339,
  [3804] = 3445,
  [3805] = 3212,
  [3806] = 3430,
  [3807] = 3150,
  [3808] = 3107,
  [3809] = 3809,
  [3810] = 313,
  [3811] = 1909,
  [3812] = 644,
  [3813] = 3428,
  [3814] = 2792,
  [3815] = 3809,
  [3816] = 3816,
  [3817] = 3817,
  [3818] = 3427,
  [3819] = 3774,
  [3820] = 3179,
  [3821] = 405,
  [3822] = 3774,
  [3823] = 3823,
  [3824] = 3823,
  [3825] = 3816,
  [3826] = 3801,
  [3827] = 3767,
  [3828] = 3828,
  [3829] = 3802,
  [3830] = 3207,
  [3831] = 3769,
  [3832] = 3832,
  [3833] = 3200,
  [3834] = 3784,
  [3835] = 3426,
  [3836] = 3464,
  [3837] = 3823,
  [3838] = 3420,
  [3839] = 3817,
  [3840] = 3419,
  [3841] = 1829,
  [3842] = 3447,
  [3843] = 3449,
  [3844] = 3769,
  [3845] = 3816,
  [3846] = 3832,
  [3847] = 3769,
  [3848] = 3848,
  [3849] = 3849,
  [3850] = 3784,
  [3851] = 3832,
  [3852] = 3205,
  [3853] = 3416,
  [3854] = 3452,
  [3855] = 3131,
  [3856] = 3332,
  [3857] = 1849,
  [3858] = 3823,
  [3859] = 2804,
  [3860] = 361,
  [3861] = 3861,
  [3862] = 3770,
  [3863] = 463,
  [3864] = 435,
  [3865] = 3802,
  [3866] = 3816,
  [3867] = 3801,
  [3868] = 3770,
  [3869] = 3115,
  [3870] = 3466,
  [3871] = 3784,
  [3872] = 3872,
  [3873] = 3848,
  [3874] = 3816,
  [3875] = 3801,
  [3876] = 3768,
  [3877] = 3459,
  [3878] = 3816,
  [3879] = 3802,
  [3880] = 3769,
  [3881] = 707,
  [3882] = 3823,
  [3883] = 3816,
  [3884] = 3884,
  [3885] = 3849,
  [3886] = 3784,
  [3887] = 3770,
  [3888] = 3802,
  [3889] = 3777,
  [3890] = 3802,
  [3891] = 3823,
  [3892] = 3768,
  [3893] = 3801,
  [3894] = 3861,
  [3895] = 3207,
  [3896] = 3896,
  [3897] = 295,
  [3898] = 3235,
  [3899] = 3801,
  [3900] = 3832,
  [3901] = 3768,
  [3902] = 3780,
  [3903] = 3207,
  [3904] = 3777,
  [3905] = 385,
  [3906] = 388,
  [3907] = 3784,
  [3908] = 297,
  [3909] = 3769,
  [3910] = 3823,
  [3911] = 3816,
  [3912] = 3802,
  [3913] = 3884,
  [3914] = 3770,
  [3915] = 3774,
  [3916] = 3916,
  [3917] = 3817,
  [3918] = 3784,
  [3919] = 3828,
  [3920] = 3770,
  [3921] = 3802,
  [3922] = 418,
  [3923] = 427,
  [3924] = 3823,
  [3925] = 3884,
  [3926] = 3775,
  [3927] = 3770,
  [3928] = 3872,
  [3929] = 1819,
  [3930] = 3802,
  [3931] = 3849,
  [3932] = 428,
  [3933] = 3768,
  [3934] = 3774,
  [3935] = 3861,
  [3936] = 3774,
  [3937] = 3816,
  [3938] = 3801,
  [3939] = 3823,
  [3940] = 3769,
  [3941] = 3848,
  [3942] = 3942,
  [3943] = 3816,
  [3944] = 3784,
  [3945] = 3802,
  [3946] = 3774,
  [3947] = 3774,
  [3948] = 3768,
  [3949] = 3777,
  [3950] = 342,
  [3951] = 3951,
  [3952] = 3848,
  [3953] = 3768,
  [3954] = 432,
  [3955] = 3828,
  [3956] = 3113,
  [3957] = 3116,
  [3958] = 3459,
  [3959] = 3111,
  [3960] = 3861,
  [3961] = 3109,
  [3962] = 3215,
  [3963] = 3777,
  [3964] = 3784,
  [3965] = 3784,
  [3966] = 3770,
  [3967] = 436,
  [3968] = 3230,
  [3969] = 3777,
  [3970] = 3884,
  [3971] = 3769,
  [3972] = 3861,
  [3973] = 3780,
  [3974] = 3777,
  [3975] = 3267,
  [3976] = 3817,
  [3977] = 303,
  [3978] = 369,
  [3979] = 3268,
  [3980] = 3270,
  [3981] = 3272,
  [3982] = 3273,
  [3983] = 3274,
  [3984] = 3861,
  [3985] = 3809,
  [3986] = 3768,
  [3987] = 298,
  [3988] = 3780,
  [3989] = 192,
  [3990] = 3777,
  [3991] = 3784,
  [3992] = 3784,
  [3993] = 3801,
  [3994] = 3489,
  [3995] = 3769,
  [3996] = 3173,
  [3997] = 349,
  [3998] = 1195,
  [3999] = 3802,
  [4000] = 3774,
  [4001] = 3828,
  [4002] = 3816,
  [4003] = 3861,
  [4004] = 1827,
  [4005] = 378,
  [4006] = 3849,
  [4007] = 3823,
  [4008] = 3777,
  [4009] = 3768,
  [4010] = 3884,
  [4011] = 3896,
  [4012] = 3942,
  [4013] = 3816,
  [4014] = 3861,
  [4015] = 3861,
  [4016] = 3951,
  [4017] = 3942,
  [4018] = 3770,
  [4019] = 3769,
  [4020] = 3770,
  [4021] = 3823,
  [4022] = 1867,
  [4023] = 3802,
  [4024] = 3784,
  [4025] = 3849,
  [4026] = 3768,
  [4027] = 3768,
  [4028] = 3774,
  [4029] = 3207,
  [4030] = 1850,
  [4031] = 4031,
  [4032] = 1830,
  [4033] = 3784,
  [4034] = 3215,
  [4035] = 1814,
  [4036] = 3848,
  [4037] = 3774,
  [4038] = 3802,
  [4039] = 3816,
  [4040] = 3823,
  [4041] = 3769,
  [4042] = 3816,
  [4043] = 3802,
  [4044] = 3769,
  [4045] = 3770,
  [4046] = 3770,
  [4047] = 3768,
  [4048] = 3774,
  [4049] = 3213,
  [4050] = 3849,
  [4051] = 3770,
  [4052] = 3774,
  [4053] = 3477,
  [4054] = 3828,
  [4055] = 3896,
  [4056] = 3217,
  [4057] = 3466,
  [4058] = 3768,
  [4059] = 3780,
  [4060] = 3884,
  [4061] = 3770,
  [4062] = 3769,
  [4063] = 3324,
  [4064] = 3816,
  [4065] = 3140,
  [4066] = 3481,
  [4067] = 3951,
  [4068] = 3224,
  [4069] = 3225,
  [4070] = 3802,
  [4071] = 3768,
  [4072] = 3784,
  [4073] = 3801,
  [4074] = 4031,
  [4075] = 3324,
  [4076] = 3770,
  [4077] = 3441,
  [4078] = 3229,
  [4079] = 3848,
  [4080] = 3816,
  [4081] = 3335,
  [4082] = 3802,
  [4083] = 3489,
  [4084] = 3823,
  [4085] = 3809,
  [4086] = 3832,
  [4087] = 3774,
  [4088] = 3823,
  [4089] = 3486,
  [4090] = 3816,
  [4091] = 3809,
  [4092] = 2801,
  [4093] = 3452,
  [4094] = 3823,
  [4095] = 3769,
  [4096] = 191,
  [4097] = 3774,
  [4098] = 3770,
  [4099] = 3774,
  [4100] = 1859,
  [4101] = 3780,
  [4102] = 3769,
  [4103] = 3477,
  [4104] = 3770,
  [4105] = 3784,
  [4106] = 3823,
  [4107] = 1855,
  [4108] = 3774,
  [4109] = 3770,
  [4110] = 3802,
  [4111] = 3774,
  [4112] = 3186,
  [4113] = 3816,
  [4114] = 341,
  [4115] = 3823,
  [4116] = 355,
  [4117] = 3769,
  [4118] = 3332,
  [4119] = 495,
  [4120] = 3769,
  [4121] = 3446,
  [4122] = 3801,
  [4123] = 357,
  [4124] = 358,
  [4125] = 3775,
  [4126] = 3802,
  [4127] = 3770,
  [4128] = 4128,
  [4129] = 3768,
  [4130] = 3769,
  [4131] = 3802,
  [4132] = 3768,
  [4133] = 3801,
  [4134] = 3481,
  [4135] = 111,
  [4136] = 3784,
  [4137] = 3942,
  [4138] = 3828,
  [4139] = 3816,
  [4140] = 3784,
  [4141] = 3802,
  [4142] = 3774,
  [4143] = 3802,
  [4144] = 3784,
  [4145] = 3774,
  [4146] = 3769,
  [4147] = 3823,
  [4148] = 495,
  [4149] = 3444,
  [4150] = 3132,
  [4151] = 3774,
  [4152] = 3767,
  [4153] = 3306,
  [4154] = 3770,
  [4155] = 4155,
  [4156] = 3784,
  [4157] = 426,
  [4158] = 3780,
  [4159] = 3486,
  [4160] = 434,
  [4161] = 3823,
  [4162] = 3816,
  [4163] = 3802,
  [4164] = 3784,
  [4165] = 3828,
  [4166] = 1921,
  [4167] = 1920,
  [4168] = 3942,
  [4169] = 3774,
  [4170] = 438,
  [4171] = 439,
  [4172] = 3769,
  [4173] = 3768,
  [4174] = 3770,
  [4175] = 3770,
  [4176] = 3848,
  [4177] = 3445,
  [4178] = 3212,
  [4179] = 3430,
  [4180] = 3428,
  [4181] = 3427,
  [4182] = 3426,
  [4183] = 3464,
  [4184] = 3420,
  [4185] = 3419,
  [4186] = 3447,
  [4187] = 3816,
  [4188] = 3449,
  [4189] = 3216,
  [4190] = 3801,
  [4191] = 3816,
  [4192] = 3817,
  [4193] = 717,
  [4194] = 3768,
  [4195] = 3872,
  [4196] = 3416,
  [4197] = 3823,
  [4198] = 3802,
  [4199] = 4199,
  [4200] = 3848,
  [4201] = 3205,
  [4202] = 3942,
  [4203] = 3784,
  [4204] = 3770,
  [4205] = 3768,
  [4206] = 3774,
  [4207] = 3780,
  [4208] = 3816,
  [4209] = 3769,
  [4210] = 3194,
  [4211] = 3872,
  [4212] = 3784,
  [4213] = 3823,
  [4214] = 3828,
  [4215] = 3767,
  [4216] = 3801,
  [4217] = 3768,
  [4218] = 3774,
  [4219] = 3816,
  [4220] = 3802,
  [4221] = 3768,
  [4222] = 3780,
  [4223] = 3823,
  [4224] = 3774,
  [4225] = 3769,
  [4226] = 3207,
  [4227] = 3832,
  [4228] = 3767,
  [4229] = 3848,
  [4230] = 3828,
  [4231] = 3823,
  [4232] = 3768,
  [4233] = 4233,
  [4234] = 3823,
  [4235] = 3872,
  [4236] = 3784,
  [4237] = 3769,
  [4238] = 3140,
  [4239] = 285,
  [4240] = 3489,
  [4241] = 4241,
  [4242] = 3294,
  [4243] = 2868,
  [4244] = 3253,
  [4245] = 3207,
  [4246] = 3150,
  [4247] = 3130,
  [4248] = 4241,
  [4249] = 3234,
  [4250] = 3321,
  [4251] = 3335,
  [4252] = 4241,
  [4253] = 3202,
  [4254] = 3335,
  [4255] = 190,
  [4256] = 3230,
  [4257] = 3306,
  [4258] = 3209,
  [4259] = 192,
  [4260] = 3210,
  [4261] = 3211,
  [4262] = 3217,
  [4263] = 348,
  [4264] = 343,
  [4265] = 4241,
  [4266] = 3282,
  [4267] = 3333,
  [4268] = 3332,
  [4269] = 3315,
  [4270] = 1921,
  [4271] = 2792,
  [4272] = 420,
  [4273] = 3109,
  [4274] = 4241,
  [4275] = 4241,
  [4276] = 3111,
  [4277] = 3116,
  [4278] = 3113,
  [4279] = 1830,
  [4280] = 422,
  [4281] = 333,
  [4282] = 423,
  [4283] = 3324,
  [4284] = 2808,
  [4285] = 193,
  [4286] = 3481,
  [4287] = 3329,
  [4288] = 3305,
  [4289] = 2610,
  [4290] = 3486,
  [4291] = 3325,
  [4292] = 3335,
  [4293] = 1850,
  [4294] = 1827,
  [4295] = 3314,
  [4296] = 4241,
  [4297] = 4241,
  [4298] = 3207,
  [4299] = 3287,
  [4300] = 1829,
  [4301] = 2607,
  [4302] = 3489,
  [4303] = 3132,
  [4304] = 3313,
  [4305] = 3107,
  [4306] = 3280,
  [4307] = 3331,
  [4308] = 3278,
  [4309] = 3288,
  [4310] = 3292,
  [4311] = 1847,
  [4312] = 3317,
  [4313] = 3326,
  [4314] = 4241,
  [4315] = 3115,
  [4316] = 3219,
  [4317] = 1867,
  [4318] = 1819,
  [4319] = 1814,
  [4320] = 4320,
  [4321] = 383,
  [4322] = 3489,
  [4323] = 1920,
  [4324] = 3316,
  [4325] = 3327,
  [4326] = 3216,
  [4327] = 381,
  [4328] = 3304,
  [4329] = 3254,
  [4330] = 3308,
  [4331] = 4241,
  [4332] = 3136,
  [4333] = 3274,
  [4334] = 4241,
  [4335] = 3273,
  [4336] = 3272,
  [4337] = 3270,
  [4338] = 3298,
  [4339] = 3268,
  [4340] = 3200,
  [4341] = 4241,
  [4342] = 4241,
  [4343] = 4241,
  [4344] = 4241,
  [4345] = 4241,
  [4346] = 3289,
  [4347] = 3284,
  [4348] = 1855,
  [4349] = 1859,
  [4350] = 4241,
  [4351] = 4241,
  [4352] = 3218,
  [4353] = 3114,
  [4354] = 3186,
  [4355] = 3267,
  [4356] = 3489,
  [4357] = 3243,
  [4358] = 2801,
  [4359] = 1195,
  [4360] = 4241,
  [4361] = 334,
  [4362] = 335,
  [4363] = 3255,
  [4364] = 3312,
  [4365] = 3310,
  [4366] = 629,
  [4367] = 3131,
  [4368] = 3300,
  [4369] = 3247,
  [4370] = 630,
  [4371] = 631,
  [4372] = 633,
  [4373] = 3120,
  [4374] = 4241,
  [4375] = 3277,
  [4376] = 2786,
  [4377] = 191,
  [4378] = 3301,
  [4379] = 3259,
  [4380] = 3279,
  [4381] = 3477,
  [4382] = 3250,
  [4383] = 3241,
  [4384] = 642,
  [4385] = 641,
  [4386] = 3245,
  [4387] = 3249,
  [4388] = 3319,
  [4389] = 3318,
  [4390] = 1843,
  [4391] = 643,
  [4392] = 4241,
  [4393] = 4241,
  [4394] = 3293,
  [4395] = 3251,
  [4396] = 3110,
  [4397] = 3235,
  [4398] = 2804,
  [4399] = 4241,
  [4400] = 4241,
  [4401] = 3207,
  [4402] = 1849,
  [4403] = 3252,
  [4404] = 1909,
  [4405] = 2881,
  [4406] = 1197,
  [4407] = 3328,
  [4408] = 196,
  [4409] = 117,
  [4410] = 3241,
  [4411] = 4411,
  [4412] = 3234,
  [4413] = 2960,
  [4414] = 3335,
  [4415] = 3324,
  [4416] = 3321,
  [4417] = 2963,
  [4418] = 3212,
  [4419] = 3312,
  [4420] = 3310,
  [4421] = 3430,
  [4422] = 3209,
  [4423] = 3210,
  [4424] = 3427,
  [4425] = 3335,
  [4426] = 3308,
  [4427] = 3211,
  [4428] = 2607,
  [4429] = 192,
  [4430] = 3255,
  [4431] = 3332,
  [4432] = 3426,
  [4433] = 3333,
  [4434] = 3464,
  [4435] = 3317,
  [4436] = 3306,
  [4437] = 3420,
  [4438] = 3245,
  [4439] = 3279,
  [4440] = 191,
  [4441] = 3294,
  [4442] = 3218,
  [4443] = 3219,
  [4444] = 3416,
  [4445] = 3249,
  [4446] = 3319,
  [4447] = 3202,
  [4448] = 3318,
  [4449] = 1849,
  [4450] = 3173,
  [4451] = 3419,
  [4452] = 3292,
  [4453] = 3288,
  [4454] = 3489,
  [4455] = 3282,
  [4456] = 113,
  [4457] = 4457,
  [4458] = 3251,
  [4459] = 3243,
  [4460] = 3293,
  [4461] = 3314,
  [4462] = 3305,
  [4463] = 3326,
  [4464] = 3331,
  [4465] = 1920,
  [4466] = 1921,
  [4467] = 421,
  [4468] = 344,
  [4469] = 114,
  [4470] = 3329,
  [4471] = 3207,
  [4472] = 117,
  [4473] = 3335,
  [4474] = 118,
  [4475] = 120,
  [4476] = 108,
  [4477] = 119,
  [4478] = 3489,
  [4479] = 1850,
  [4480] = 3459,
  [4481] = 3284,
  [4482] = 3287,
  [4483] = 3253,
  [4484] = 3273,
  [4485] = 3489,
  [4486] = 3252,
  [4487] = 3300,
  [4488] = 3304,
  [4489] = 3213,
  [4490] = 1830,
  [4491] = 3247,
  [4492] = 3277,
  [4493] = 3301,
  [4494] = 1843,
  [4495] = 1909,
  [4496] = 105,
  [4497] = 113,
  [4498] = 114,
  [4499] = 3445,
  [4500] = 112,
  [4501] = 119,
  [4502] = 106,
  [4503] = 107,
  [4504] = 2610,
  [4505] = 1859,
  [4506] = 116,
  [4507] = 115,
  [4508] = 1855,
  [4509] = 3289,
  [4510] = 3298,
  [4511] = 109,
  [4512] = 110,
  [4513] = 3254,
  [4514] = 1827,
  [4515] = 115,
  [4516] = 112,
  [4517] = 105,
  [4518] = 1814,
  [4519] = 1819,
  [4520] = 3313,
  [4521] = 1867,
  [4522] = 3267,
  [4523] = 3268,
  [4524] = 3270,
  [4525] = 3272,
  [4526] = 108,
  [4527] = 3274,
  [4528] = 1847,
  [4529] = 3278,
  [4530] = 120,
  [4531] = 3280,
  [4532] = 3224,
  [4533] = 3225,
  [4534] = 3441,
  [4535] = 3205,
  [4536] = 3229,
  [4537] = 1829,
  [4538] = 3325,
  [4539] = 118,
  [4540] = 3335,
  [4541] = 3489,
  [4542] = 628,
  [4543] = 110,
  [4544] = 197,
  [4545] = 3316,
  [4546] = 109,
  [4547] = 3315,
  [4548] = 194,
  [4549] = 212,
  [4550] = 3446,
  [4551] = 3444,
  [4552] = 195,
  [4553] = 3466,
  [4554] = 3428,
  [4555] = 116,
  [4556] = 3259,
  [4557] = 3250,
  [4558] = 111,
  [4559] = 3452,
  [4560] = 3449,
  [4561] = 3447,
  [4562] = 107,
  [4563] = 3328,
  [4564] = 106,
  [4565] = 3327,
  [4566] = 3200,
  [4567] = 2868,
  [4568] = 2881,
  [4569] = 3489,
  [4570] = 201,
  [4571] = 3489,
  [4572] = 2786,
  [4573] = 3481,
  [4574] = 3489,
  [4575] = 3486,
  [4576] = 3489,
  [4577] = 3489,
  [4578] = 2808,
  [4579] = 111,
  [4580] = 4580,
  [4581] = 3477,
  [4582] = 190,
  [4583] = 4583,
  [4584] = 3173,
  [4585] = 193,
  [4586] = 4586,
  [4587] = 4580,
  [4588] = 3489,
  [4589] = 2960,
  [4590] = 4583,
  [4591] = 2963,
  [4592] = 3229,
  [4593] = 3200,
  [4594] = 3255,
  [4595] = 2808,
  [4596] = 3312,
  [4597] = 3310,
  [4598] = 3300,
  [4599] = 3213,
  [4600] = 2786,
  [4601] = 3259,
  [4602] = 3250,
  [4603] = 3249,
  [4604] = 3319,
  [4605] = 3329,
  [4606] = 3318,
  [4607] = 1849,
  [4608] = 3282,
  [4609] = 3253,
  [4610] = 4610,
  [4611] = 3252,
  [4612] = 3251,
  [4613] = 3243,
  [4614] = 3293,
  [4615] = 3205,
  [4616] = 3319,
  [4617] = 285,
  [4618] = 3326,
  [4619] = 3331,
  [4620] = 1920,
  [4621] = 1921,
  [4622] = 2951,
  [4623] = 707,
  [4624] = 2952,
  [4625] = 3315,
  [4626] = 1830,
  [4627] = 1850,
  [4628] = 3284,
  [4629] = 3287,
  [4630] = 3313,
  [4631] = 2610,
  [4632] = 2956,
  [4633] = 1827,
  [4634] = 3317,
  [4635] = 3300,
  [4636] = 3294,
  [4637] = 3247,
  [4638] = 3316,
  [4639] = 2946,
  [4640] = 192,
  [4641] = 3277,
  [4642] = 1843,
  [4643] = 3254,
  [4644] = 245,
  [4645] = 2868,
  [4646] = 3325,
  [4647] = 1909,
  [4648] = 644,
  [4649] = 2607,
  [4650] = 1829,
  [4651] = 635,
  [4652] = 191,
  [4653] = 2808,
  [4654] = 3224,
  [4655] = 2881,
  [4656] = 2881,
  [4657] = 2868,
  [4658] = 3280,
  [4659] = 3278,
  [4660] = 3328,
  [4661] = 1867,
  [4662] = 3304,
  [4663] = 3308,
  [4664] = 3243,
  [4665] = 1819,
  [4666] = 595,
  [4667] = 1814,
  [4668] = 603,
  [4669] = 3333,
  [4670] = 2786,
  [4671] = 3254,
  [4672] = 1859,
  [4673] = 463,
  [4674] = 1847,
  [4675] = 4580,
  [4676] = 3225,
  [4677] = 3212,
  [4678] = 4583,
  [4679] = 344,
  [4680] = 1855,
  [4681] = 3289,
  [4682] = 3298,
  [4683] = 421,
  [4684] = 3327,
  [4685] = 613,
  [4686] = 651,
  [4687] = 3331,
  [4688] = 3325,
  [4689] = 3326,
  [4690] = 3255,
  [4691] = 638,
  [4692] = 640,
  [4693] = 2868,
  [4694] = 3312,
  [4695] = 3318,
  [4696] = 3287,
  [4697] = 3284,
  [4698] = 639,
  [4699] = 3304,
  [4700] = 3310,
  [4701] = 2881,
  [4702] = 2786,
  [4703] = 3251,
  [4704] = 3316,
  [4705] = 3282,
  [4706] = 3308,
  [4707] = 620,
  [4708] = 3289,
  [4709] = 4580,
  [4710] = 3315,
  [4711] = 3327,
  [4712] = 617,
  [4713] = 626,
  [4714] = 3277,
  [4715] = 621,
  [4716] = 3328,
  [4717] = 3253,
  [4718] = 3313,
  [4719] = 3317,
  [4720] = 3252,
  [4721] = 625,
  [4722] = 3259,
  [4723] = 495,
  [4724] = 4724,
  [4725] = 3298,
  [4726] = 3249,
  [4727] = 3247,
  [4728] = 3280,
  [4729] = 4583,
  [4730] = 2808,
  [4731] = 653,
  [4732] = 3278,
  [4733] = 3250,
  [4734] = 647,
  [4735] = 193,
  [4736] = 643,
  [4737] = 3120,
  [4738] = 3114,
  [4739] = 379,
  [4740] = 3136,
  [4741] = 641,
  [4742] = 273,
  [4743] = 642,
  [4744] = 234,
  [4745] = 389,
  [4746] = 629,
  [4747] = 190,
  [4748] = 2946,
  [4749] = 631,
  [4750] = 2956,
  [4751] = 437,
  [4752] = 268,
  [4753] = 2952,
  [4754] = 3110,
  [4755] = 630,
  [4756] = 237,
  [4757] = 440,
  [4758] = 633,
  [4759] = 2951,
  [4760] = 341,
  [4761] = 405,
  [4762] = 744,
  [4763] = 4763,
  [4764] = 744,
  [4765] = 432,
  [4766] = 295,
  [4767] = 313,
  [4768] = 339,
  [4769] = 297,
  [4770] = 717,
  [4771] = 361,
  [4772] = 4772,
  [4773] = 368,
  [4774] = 435,
  [4775] = 212,
  [4776] = 194,
  [4777] = 303,
  [4778] = 372,
  [4779] = 369,
  [4780] = 4780,
  [4781] = 385,
  [4782] = 298,
  [4783] = 349,
  [4784] = 717,
  [4785] = 373,
  [4786] = 378,
  [4787] = 628,
  [4788] = 4763,
  [4789] = 4580,
  [4790] = 421,
  [4791] = 4583,
  [4792] = 197,
  [4793] = 436,
  [4794] = 342,
  [4795] = 4780,
  [4796] = 196,
  [4797] = 4580,
  [4798] = 355,
  [4799] = 388,
  [4800] = 357,
  [4801] = 358,
  [4802] = 426,
  [4803] = 434,
  [4804] = 4583,
  [4805] = 418,
  [4806] = 427,
  [4807] = 438,
  [4808] = 318,
  [4809] = 344,
  [4810] = 439,
  [4811] = 4583,
  [4812] = 195,
  [4813] = 428,
  [4814] = 4580,
  [4815] = 319,
  [4816] = 2956,
  [4817] = 2952,
  [4818] = 4580,
  [4819] = 4819,
  [4820] = 4820,
  [4821] = 4820,
  [4822] = 4580,
  [4823] = 4772,
  [4824] = 193,
  [4825] = 4583,
  [4826] = 4763,
  [4827] = 2583,
  [4828] = 2946,
  [4829] = 4583,
  [4830] = 4819,
  [4831] = 201,
  [4832] = 4832,
  [4833] = 4832,
  [4834] = 4832,
  [4835] = 4819,
  [4836] = 190,
  [4837] = 4832,
  [4838] = 4819,
  [4839] = 4580,
  [4840] = 4583,
  [4841] = 4820,
  [4842] = 4820,
  [4843] = 2951,
  [4844] = 4832,
  [4845] = 4780,
  [4846] = 4820,
  [4847] = 2582,
  [4848] = 4819,
  [4849] = 4580,
  [4850] = 3333,
  [4851] = 4763,
  [4852] = 3441,
  [4853] = 495,
  [4854] = 3428,
  [4855] = 4780,
  [4856] = 4856,
  [4857] = 463,
  [4858] = 4858,
  [4859] = 4583,
  [4860] = 4580,
  [4861] = 3446,
  [4862] = 3293,
  [4863] = 4583,
  [4864] = 4580,
  [4865] = 2946,
  [4866] = 4866,
  [4867] = 4580,
  [4868] = 4583,
  [4869] = 4856,
  [4870] = 3329,
  [4871] = 463,
  [4872] = 3294,
  [4873] = 2956,
  [4874] = 3459,
  [4875] = 3466,
  [4876] = 3444,
  [4877] = 3452,
  [4878] = 4583,
  [4879] = 2951,
  [4880] = 3427,
  [4881] = 3426,
  [4882] = 3464,
  [4883] = 3420,
  [4884] = 3419,
  [4885] = 3447,
  [4886] = 3449,
  [4887] = 2952,
  [4888] = 595,
  [4889] = 3416,
  [4890] = 3445,
  [4891] = 3430,
  [4892] = 603,
  [4893] = 4893,
  [4894] = 651,
  [4895] = 617,
  [4896] = 4896,
  [4897] = 4896,
  [4898] = 4898,
  [4899] = 4896,
  [4900] = 620,
  [4901] = 3120,
  [4902] = 3486,
  [4903] = 644,
  [4904] = 4893,
  [4905] = 3481,
  [4906] = 4893,
  [4907] = 639,
  [4908] = 285,
  [4909] = 4898,
  [4910] = 4898,
  [4911] = 4893,
  [4912] = 285,
  [4913] = 3110,
  [4914] = 635,
  [4915] = 4896,
  [4916] = 495,
  [4917] = 635,
  [4918] = 4918,
  [4919] = 638,
  [4920] = 640,
  [4921] = 3136,
  [4922] = 4918,
  [4923] = 644,
  [4924] = 613,
  [4925] = 4918,
  [4926] = 4918,
  [4927] = 4896,
  [4928] = 4918,
  [4929] = 4896,
  [4930] = 4898,
  [4931] = 647,
  [4932] = 4896,
  [4933] = 4933,
  [4934] = 3477,
  [4935] = 4898,
  [4936] = 4893,
  [4937] = 4580,
  [4938] = 4583,
  [4939] = 4918,
  [4940] = 4898,
  [4941] = 4941,
  [4942] = 4942,
  [4943] = 4898,
  [4944] = 4893,
  [4945] = 4580,
  [4946] = 653,
  [4947] = 626,
  [4948] = 621,
  [4949] = 625,
  [4950] = 4918,
  [4951] = 4583,
  [4952] = 4893,
  [4953] = 3114,
  [4954] = 4954,
  [4955] = 1830,
  [4956] = 4780,
  [4957] = 4942,
  [4958] = 2607,
  [4959] = 4959,
  [4960] = 4763,
  [4961] = 437,
  [4962] = 268,
  [4963] = 4933,
  [4964] = 3477,
  [4965] = 2610,
  [4966] = 1843,
  [4967] = 1814,
  [4968] = 1819,
  [4969] = 1867,
  [4970] = 1909,
  [4971] = 1849,
  [4972] = 4580,
  [4973] = 2607,
  [4974] = 440,
  [4975] = 3486,
  [4976] = 1920,
  [4977] = 4780,
  [4978] = 1921,
  [4979] = 389,
  [4980] = 1859,
  [4981] = 1847,
  [4982] = 4763,
  [4983] = 4780,
  [4984] = 4959,
  [4985] = 4985,
  [4986] = 2610,
  [4987] = 4763,
  [4988] = 4959,
  [4989] = 379,
  [4990] = 234,
  [4991] = 192,
  [4992] = 4858,
  [4993] = 3481,
  [4994] = 1850,
  [4995] = 1829,
  [4996] = 4996,
  [4997] = 237,
  [4998] = 191,
  [4999] = 4999,
  [5000] = 4583,
  [5001] = 4985,
  [5002] = 4999,
  [5003] = 190,
  [5004] = 4996,
  [5005] = 1855,
  [5006] = 4954,
  [5007] = 273,
  [5008] = 193,
  [5009] = 1827,
  [5010] = 116,
  [5011] = 435,
  [5012] = 642,
  [5013] = 373,
  [5014] = 5014,
  [5015] = 105,
  [5016] = 349,
  [5017] = 107,
  [5018] = 298,
  [5019] = 106,
  [5020] = 369,
  [5021] = 119,
  [5022] = 303,
  [5023] = 117,
  [5024] = 5024,
  [5025] = 357,
  [5026] = 633,
  [5027] = 196,
  [5028] = 631,
  [5029] = 108,
  [5030] = 114,
  [5031] = 113,
  [5032] = 630,
  [5033] = 3452,
  [5034] = 4583,
  [5035] = 120,
  [5036] = 4780,
  [5037] = 118,
  [5038] = 297,
  [5039] = 3449,
  [5040] = 295,
  [5041] = 3447,
  [5042] = 3419,
  [5043] = 642,
  [5044] = 3420,
  [5045] = 3464,
  [5046] = 3441,
  [5047] = 3426,
  [5048] = 112,
  [5049] = 378,
  [5050] = 495,
  [5051] = 385,
  [5052] = 628,
  [5053] = 3427,
  [5054] = 641,
  [5055] = 643,
  [5056] = 717,
  [5057] = 3459,
  [5058] = 4580,
  [5059] = 3428,
  [5060] = 641,
  [5061] = 3430,
  [5062] = 4985,
  [5063] = 245,
  [5064] = 4996,
  [5065] = 3445,
  [5066] = 4954,
  [5067] = 5067,
  [5068] = 388,
  [5069] = 4999,
  [5070] = 629,
  [5071] = 418,
  [5072] = 361,
  [5073] = 3466,
  [5074] = 341,
  [5075] = 405,
  [5076] = 427,
  [5077] = 109,
  [5078] = 4780,
  [5079] = 428,
  [5080] = 744,
  [5081] = 432,
  [5082] = 212,
  [5083] = 436,
  [5084] = 4763,
  [5085] = 313,
  [5086] = 4763,
  [5087] = 339,
  [5088] = 4583,
  [5089] = 643,
  [5090] = 194,
  [5091] = 5091,
  [5092] = 5092,
  [5093] = 4763,
  [5094] = 707,
  [5095] = 3444,
  [5096] = 368,
  [5097] = 372,
  [5098] = 439,
  [5099] = 355,
  [5100] = 5091,
  [5101] = 5014,
  [5102] = 195,
  [5103] = 5103,
  [5104] = 633,
  [5105] = 3416,
  [5106] = 631,
  [5107] = 438,
  [5108] = 197,
  [5109] = 5109,
  [5110] = 4780,
  [5111] = 318,
  [5112] = 629,
  [5113] = 110,
  [5114] = 3446,
  [5115] = 434,
  [5116] = 5092,
  [5117] = 426,
  [5118] = 5109,
  [5119] = 285,
  [5120] = 4580,
  [5121] = 630,
  [5122] = 358,
  [5123] = 319,
  [5124] = 342,
  [5125] = 115,
  [5126] = 5126,
  [5127] = 3428,
  [5128] = 5126,
  [5129] = 5129,
  [5130] = 5130,
  [5131] = 5131,
  [5132] = 5132,
  [5133] = 4780,
  [5134] = 4954,
  [5135] = 4996,
  [5136] = 4985,
  [5137] = 4583,
  [5138] = 5131,
  [5139] = 4580,
  [5140] = 5140,
  [5141] = 5126,
  [5142] = 5142,
  [5143] = 5132,
  [5144] = 5144,
  [5145] = 5145,
  [5146] = 5146,
  [5147] = 5147,
  [5148] = 5148,
  [5149] = 5131,
  [5150] = 4999,
  [5151] = 5151,
  [5152] = 3446,
  [5153] = 5126,
  [5154] = 5144,
  [5155] = 5155,
  [5156] = 5146,
  [5157] = 5129,
  [5158] = 5131,
  [5159] = 5159,
  [5160] = 3444,
  [5161] = 5161,
  [5162] = 3445,
  [5163] = 3430,
  [5164] = 5144,
  [5165] = 463,
  [5166] = 3427,
  [5167] = 3426,
  [5168] = 3464,
  [5169] = 3420,
  [5170] = 3419,
  [5171] = 5126,
  [5172] = 3447,
  [5173] = 5144,
  [5174] = 5161,
  [5175] = 3449,
  [5176] = 4763,
  [5177] = 201,
  [5178] = 5142,
  [5179] = 3416,
  [5180] = 4780,
  [5181] = 5142,
  [5182] = 5147,
  [5183] = 5148,
  [5184] = 4780,
  [5185] = 4763,
  [5186] = 5147,
  [5187] = 5148,
  [5188] = 3452,
  [5189] = 3466,
  [5190] = 3459,
  [5191] = 5155,
  [5192] = 5146,
  [5193] = 5129,
  [5194] = 628,
  [5195] = 5195,
  [5196] = 5196,
  [5197] = 5155,
  [5198] = 5146,
  [5199] = 5129,
  [5200] = 5155,
  [5201] = 4580,
  [5202] = 193,
  [5203] = 5144,
  [5204] = 4583,
  [5205] = 5131,
  [5206] = 5206,
  [5207] = 5148,
  [5208] = 245,
  [5209] = 4780,
  [5210] = 5210,
  [5211] = 3441,
  [5212] = 5142,
  [5213] = 5142,
  [5214] = 4580,
  [5215] = 4763,
  [5216] = 5147,
  [5217] = 5148,
  [5218] = 190,
  [5219] = 463,
  [5220] = 5147,
  [5221] = 5155,
  [5222] = 5129,
  [5223] = 5146,
  [5224] = 5146,
  [5225] = 5155,
  [5226] = 5129,
  [5227] = 4583,
  [5228] = 463,
  [5229] = 5126,
  [5230] = 5230,
  [5231] = 5231,
  [5232] = 5129,
  [5233] = 5131,
  [5234] = 5155,
  [5235] = 5131,
  [5236] = 5129,
  [5237] = 5237,
  [5238] = 5238,
  [5239] = 5142,
  [5240] = 3136,
  [5241] = 5147,
  [5242] = 5148,
  [5243] = 5131,
  [5244] = 5155,
  [5245] = 5129,
  [5246] = 5129,
  [5247] = 5148,
  [5248] = 5155,
  [5249] = 5131,
  [5250] = 5131,
  [5251] = 5129,
  [5252] = 5147,
  [5253] = 5155,
  [5254] = 5147,
  [5255] = 5131,
  [5256] = 5129,
  [5257] = 5148,
  [5258] = 5155,
  [5259] = 5155,
  [5260] = 5129,
  [5261] = 4763,
  [5262] = 5131,
  [5263] = 3110,
  [5264] = 5131,
  [5265] = 5129,
  [5266] = 5142,
  [5267] = 5147,
  [5268] = 5148,
  [5269] = 5155,
  [5270] = 5129,
  [5271] = 5155,
  [5272] = 5131,
  [5273] = 5155,
  [5274] = 5131,
  [5275] = 5155,
  [5276] = 5129,
  [5277] = 5129,
  [5278] = 5155,
  [5279] = 5131,
  [5280] = 5131,
  [5281] = 5155,
  [5282] = 5129,
  [5283] = 5129,
  [5284] = 5155,
  [5285] = 5161,
  [5286] = 3114,
  [5287] = 4772,
  [5288] = 5131,
  [5289] = 5129,
  [5290] = 5155,
  [5291] = 5131,
  [5292] = 5129,
  [5293] = 5155,
  [5294] = 5131,
  [5295] = 3120,
  [5296] = 5129,
  [5297] = 5155,
  [5298] = 5131,
  [5299] = 5155,
  [5300] = 5126,
  [5301] = 5144,
  [5302] = 5131,
  [5303] = 5129,
  [5304] = 5131,
  [5305] = 5155,
  [5306] = 5129,
  [5307] = 5131,
  [5308] = 5155,
  [5309] = 5129,
  [5310] = 5131,
  [5311] = 5155,
  [5312] = 5129,
  [5313] = 5131,
  [5314] = 3229,
  [5315] = 5315,
  [5316] = 4763,
  [5317] = 3486,
  [5318] = 5315,
  [5319] = 4858,
  [5320] = 5320,
  [5321] = 3449,
  [5322] = 3447,
  [5323] = 3477,
  [5324] = 3419,
  [5325] = 3420,
  [5326] = 3464,
  [5327] = 3426,
  [5328] = 3427,
  [5329] = 3416,
  [5330] = 3428,
  [5331] = 3430,
  [5332] = 3212,
  [5333] = 3445,
  [5334] = 421,
  [5335] = 5315,
  [5336] = 5315,
  [5337] = 603,
  [5338] = 5338,
  [5339] = 5339,
  [5340] = 4583,
  [5341] = 4763,
  [5342] = 3444,
  [5343] = 4580,
  [5344] = 5344,
  [5345] = 595,
  [5346] = 5346,
  [5347] = 3224,
  [5348] = 3452,
  [5349] = 111,
  [5350] = 3446,
  [5351] = 5351,
  [5352] = 3229,
  [5353] = 5353,
  [5354] = 3225,
  [5355] = 5315,
  [5356] = 3224,
  [5357] = 3213,
  [5358] = 5358,
  [5359] = 3466,
  [5360] = 3441,
  [5361] = 5361,
  [5362] = 3459,
  [5363] = 3466,
  [5364] = 3452,
  [5365] = 3416,
  [5366] = 3449,
  [5367] = 5367,
  [5368] = 3446,
  [5369] = 3447,
  [5370] = 3419,
  [5371] = 5358,
  [5372] = 5315,
  [5373] = 3420,
  [5374] = 344,
  [5375] = 3173,
  [5376] = 5376,
  [5377] = 421,
  [5378] = 344,
  [5379] = 5067,
  [5380] = 3464,
  [5381] = 5381,
  [5382] = 3426,
  [5383] = 5383,
  [5384] = 3459,
  [5385] = 3427,
  [5386] = 5386,
  [5387] = 3428,
  [5388] = 4031,
  [5389] = 3430,
  [5390] = 3445,
  [5391] = 5391,
  [5392] = 3205,
  [5393] = 3481,
  [5394] = 3466,
  [5395] = 3444,
  [5396] = 3446,
  [5397] = 5315,
  [5398] = 5361,
  [5399] = 5315,
  [5400] = 5361,
  [5401] = 5315,
  [5402] = 3205,
  [5403] = 3444,
  [5404] = 5315,
  [5405] = 5381,
  [5406] = 5406,
  [5407] = 3212,
  [5408] = 3445,
  [5409] = 3430,
  [5410] = 3428,
  [5411] = 3427,
  [5412] = 3441,
  [5413] = 5413,
  [5414] = 5414,
  [5415] = 3426,
  [5416] = 5416,
  [5417] = 3464,
  [5418] = 3420,
  [5419] = 3225,
  [5420] = 3419,
  [5421] = 3447,
  [5422] = 5358,
  [5423] = 5315,
  [5424] = 3213,
  [5425] = 3449,
  [5426] = 5196,
  [5427] = 5427,
  [5428] = 5428,
  [5429] = 3416,
  [5430] = 4780,
  [5431] = 3452,
  [5432] = 3441,
  [5433] = 495,
  [5434] = 5358,
  [5435] = 5428,
  [5436] = 5427,
  [5437] = 5358,
  [5438] = 5438,
  [5439] = 3459,
  [5440] = 5361,
  [5441] = 5441,
  [5442] = 5406,
  [5443] = 5406,
  [5444] = 5444,
  [5445] = 5445,
  [5446] = 5067,
  [5447] = 5447,
  [5448] = 5448,
  [5449] = 5406,
  [5450] = 4580,
  [5451] = 5406,
  [5452] = 4724,
  [5453] = 5453,
  [5454] = 5454,
  [5455] = 5376,
  [5456] = 5456,
  [5457] = 5457,
  [5458] = 4583,
  [5459] = 5459,
  [5460] = 5460,
  [5461] = 4866,
  [5462] = 5462,
  [5463] = 644,
  [5464] = 5406,
  [5465] = 5358,
  [5466] = 5361,
  [5467] = 5406,
  [5468] = 5315,
  [5469] = 4780,
  [5470] = 5315,
  [5471] = 5471,
  [5472] = 5472,
  [5473] = 4999,
  [5474] = 4996,
  [5475] = 5475,
  [5476] = 603,
  [5477] = 5195,
  [5478] = 5478,
  [5479] = 4763,
  [5480] = 5475,
  [5481] = 635,
  [5482] = 5482,
  [5483] = 5478,
  [5484] = 5484,
  [5485] = 5475,
  [5486] = 5475,
  [5487] = 5487,
  [5488] = 4985,
  [5489] = 5489,
  [5490] = 5490,
  [5491] = 5491,
  [5492] = 5492,
  [5493] = 5151,
  [5494] = 5494,
  [5495] = 5471,
  [5496] = 5496,
  [5497] = 4780,
  [5498] = 4954,
  [5499] = 5499,
  [5500] = 4954,
  [5501] = 5501,
  [5502] = 5472,
  [5503] = 5484,
  [5504] = 5471,
  [5505] = 4999,
  [5506] = 5506,
  [5507] = 5487,
  [5508] = 5501,
  [5509] = 595,
  [5510] = 5482,
  [5511] = 5489,
  [5512] = 644,
  [5513] = 5381,
  [5514] = 5499,
  [5515] = 5515,
  [5516] = 3216,
  [5517] = 5517,
  [5518] = 5518,
  [5519] = 5519,
  [5520] = 5499,
  [5521] = 3486,
  [5522] = 190,
  [5523] = 5523,
  [5524] = 5484,
  [5525] = 5489,
  [5526] = 5526,
  [5527] = 495,
  [5528] = 5528,
  [5529] = 193,
  [5530] = 5471,
  [5531] = 5489,
  [5532] = 5490,
  [5533] = 5491,
  [5534] = 5492,
  [5535] = 5472,
  [5536] = 5536,
  [5537] = 3235,
  [5538] = 5496,
  [5539] = 5539,
  [5540] = 5506,
  [5541] = 5541,
  [5542] = 5542,
  [5543] = 5487,
  [5544] = 3481,
  [5545] = 5475,
  [5546] = 5487,
  [5547] = 5484,
  [5548] = 4985,
  [5549] = 4996,
  [5550] = 5490,
  [5551] = 5491,
  [5552] = 5552,
  [5553] = 5496,
  [5554] = 4954,
  [5555] = 4996,
  [5556] = 5492,
  [5557] = 5496,
  [5558] = 5492,
  [5559] = 5491,
  [5560] = 5526,
  [5561] = 4999,
  [5562] = 5562,
  [5563] = 3200,
  [5564] = 5475,
  [5565] = 5565,
  [5566] = 5472,
  [5567] = 5484,
  [5568] = 3477,
  [5569] = 5489,
  [5570] = 5570,
  [5571] = 5506,
  [5572] = 5381,
  [5573] = 5487,
  [5574] = 5484,
  [5575] = 5499,
  [5576] = 5576,
  [5577] = 5496,
  [5578] = 5489,
  [5579] = 5484,
  [5580] = 5472,
  [5581] = 5489,
  [5582] = 5490,
  [5583] = 5471,
  [5584] = 5487,
  [5585] = 5472,
  [5586] = 5586,
  [5587] = 5484,
  [5588] = 5506,
  [5589] = 5484,
  [5590] = 5492,
  [5591] = 5491,
  [5592] = 5592,
  [5593] = 4985,
  [5594] = 5471,
  [5595] = 5472,
  [5596] = 625,
  [5597] = 5597,
  [5598] = 5490,
  [5599] = 626,
  [5600] = 647,
  [5601] = 613,
  [5602] = 5494,
  [5603] = 640,
  [5604] = 638,
  [5605] = 639,
  [5606] = 5484,
  [5607] = 620,
  [5608] = 617,
  [5609] = 621,
  [5610] = 651,
  [5611] = 653,
  [5612] = 5484,
  [5613] = 5475,
  [5614] = 5487,
  [5615] = 3230,
  [5616] = 5526,
  [5617] = 5526,
  [5618] = 5526,
  [5619] = 5526,
  [5620] = 5620,
  [5621] = 3278,
  [5622] = 285,
  [5623] = 3243,
  [5624] = 3326,
  [5625] = 4999,
  [5626] = 3331,
  [5627] = 4954,
  [5628] = 3252,
  [5629] = 3253,
  [5630] = 3282,
  [5631] = 2583,
  [5632] = 4996,
  [5633] = 4724,
  [5634] = 193,
  [5635] = 2610,
  [5636] = 3284,
  [5637] = 4985,
  [5638] = 3287,
  [5639] = 3313,
  [5640] = 5067,
  [5641] = 5620,
  [5642] = 4858,
  [5643] = 5643,
  [5644] = 389,
  [5645] = 5645,
  [5646] = 5620,
  [5647] = 268,
  [5648] = 3317,
  [5649] = 3329,
  [5650] = 5645,
  [5651] = 3247,
  [5652] = 3319,
  [5653] = 3318,
  [5654] = 638,
  [5655] = 4780,
  [5656] = 3250,
  [5657] = 3259,
  [5658] = 3300,
  [5659] = 3327,
  [5660] = 3310,
  [5661] = 3312,
  [5662] = 640,
  [5663] = 3277,
  [5664] = 4780,
  [5665] = 2582,
  [5666] = 3255,
  [5667] = 4985,
  [5668] = 3328,
  [5669] = 641,
  [5670] = 4954,
  [5671] = 5671,
  [5672] = 4996,
  [5673] = 3308,
  [5674] = 3304,
  [5675] = 5441,
  [5676] = 5620,
  [5677] = 495,
  [5678] = 273,
  [5679] = 4763,
  [5680] = 5643,
  [5681] = 653,
  [5682] = 5643,
  [5683] = 5683,
  [5684] = 3333,
  [5685] = 4954,
  [5686] = 651,
  [5687] = 4999,
  [5688] = 613,
  [5689] = 190,
  [5690] = 625,
  [5691] = 237,
  [5692] = 3293,
  [5693] = 245,
  [5694] = 437,
  [5695] = 5643,
  [5696] = 626,
  [5697] = 631,
  [5698] = 3249,
  [5699] = 4999,
  [5700] = 633,
  [5701] = 344,
  [5702] = 629,
  [5703] = 4985,
  [5704] = 421,
  [5705] = 5705,
  [5706] = 440,
  [5707] = 5643,
  [5708] = 3315,
  [5709] = 5620,
  [5710] = 630,
  [5711] = 642,
  [5712] = 3289,
  [5713] = 5645,
  [5714] = 643,
  [5715] = 641,
  [5716] = 3254,
  [5717] = 3316,
  [5718] = 642,
  [5719] = 5645,
  [5720] = 3298,
  [5721] = 5620,
  [5722] = 629,
  [5723] = 5643,
  [5724] = 621,
  [5725] = 647,
  [5726] = 3294,
  [5727] = 5645,
  [5728] = 630,
  [5729] = 3251,
  [5730] = 3280,
  [5731] = 617,
  [5732] = 643,
  [5733] = 631,
  [5734] = 633,
  [5735] = 5620,
  [5736] = 190,
  [5737] = 234,
  [5738] = 5643,
  [5739] = 5645,
  [5740] = 5645,
  [5741] = 495,
  [5742] = 193,
  [5743] = 3325,
  [5744] = 4942,
  [5745] = 4933,
  [5746] = 379,
  [5747] = 5645,
  [5748] = 245,
  [5749] = 620,
  [5750] = 639,
  [5751] = 2607,
  [5752] = 5620,
  [5753] = 4996,
  [5754] = 5645,
  [5755] = 4763,
  [5756] = 5620,
  [5757] = 435,
  [5758] = 744,
  [5759] = 4985,
  [5760] = 434,
  [5761] = 4763,
  [5762] = 426,
  [5763] = 437,
  [5764] = 4999,
  [5765] = 4780,
  [5766] = 4999,
  [5767] = 4954,
  [5768] = 388,
  [5769] = 349,
  [5770] = 298,
  [5771] = 369,
  [5772] = 4954,
  [5773] = 4996,
  [5774] = 5774,
  [5775] = 4996,
  [5776] = 4985,
  [5777] = 5777,
  [5778] = 373,
  [5779] = 378,
  [5780] = 436,
  [5781] = 303,
  [5782] = 418,
  [5783] = 4985,
  [5784] = 342,
  [5785] = 4763,
  [5786] = 319,
  [5787] = 432,
  [5788] = 318,
  [5789] = 341,
  [5790] = 372,
  [5791] = 368,
  [5792] = 297,
  [5793] = 438,
  [5794] = 339,
  [5795] = 313,
  [5796] = 4999,
  [5797] = 439,
  [5798] = 5381,
  [5799] = 440,
  [5800] = 355,
  [5801] = 405,
  [5802] = 427,
  [5803] = 5803,
  [5804] = 295,
  [5805] = 357,
  [5806] = 379,
  [5807] = 297,
  [5808] = 717,
  [5809] = 5774,
  [5810] = 428,
  [5811] = 4954,
  [5812] = 495,
  [5813] = 5803,
  [5814] = 427,
  [5815] = 389,
  [5816] = 357,
  [5817] = 5817,
  [5818] = 303,
  [5819] = 428,
  [5820] = 369,
  [5821] = 4996,
  [5822] = 5381,
  [5823] = 358,
  [5824] = 355,
  [5825] = 405,
  [5826] = 361,
  [5827] = 341,
  [5828] = 418,
  [5829] = 707,
  [5830] = 435,
  [5831] = 4780,
  [5832] = 432,
  [5833] = 295,
  [5834] = 298,
  [5835] = 349,
  [5836] = 372,
  [5837] = 237,
  [5838] = 373,
  [5839] = 426,
  [5840] = 378,
  [5841] = 4999,
  [5842] = 4954,
  [5843] = 4780,
  [5844] = 4996,
  [5845] = 4985,
  [5846] = 385,
  [5847] = 434,
  [5848] = 358,
  [5849] = 5381,
  [5850] = 4763,
  [5851] = 313,
  [5852] = 342,
  [5853] = 436,
  [5854] = 385,
  [5855] = 234,
  [5856] = 368,
  [5857] = 361,
  [5858] = 439,
  [5859] = 644,
  [5860] = 319,
  [5861] = 339,
  [5862] = 388,
  [5863] = 318,
  [5864] = 5381,
  [5865] = 438,
  [5866] = 5866,
  [5867] = 5867,
  [5868] = 5868,
  [5869] = 5868,
  [5870] = 5870,
  [5871] = 5871,
  [5872] = 5870,
  [5873] = 5870,
  [5874] = 5874,
  [5875] = 5867,
  [5876] = 5870,
  [5877] = 5870,
  [5878] = 5878,
  [5879] = 5879,
  [5880] = 5867,
  [5881] = 5867,
  [5882] = 532,
  [5883] = 5870,
  [5884] = 5774,
  [5885] = 5774,
  [5886] = 5871,
  [5887] = 5887,
  [5888] = 4763,
  [5889] = 5867,
  [5890] = 5870,
  [5891] = 5867,
  [5892] = 5879,
  [5893] = 421,
  [5894] = 5894,
  [5895] = 344,
  [5896] = 5870,
  [5897] = 5866,
  [5898] = 5867,
  [5899] = 5899,
  [5900] = 5894,
  [5901] = 5894,
  [5902] = 5867,
  [5903] = 5887,
  [5904] = 5868,
  [5905] = 5887,
  [5906] = 4780,
  [5907] = 5871,
  [5908] = 5874,
  [5909] = 5870,
  [5910] = 5874,
  [5911] = 5887,
  [5912] = 5870,
  [5913] = 5879,
  [5914] = 5868,
  [5915] = 5887,
  [5916] = 5867,
  [5917] = 5151,
  [5918] = 5871,
  [5919] = 5867,
  [5920] = 628,
  [5921] = 4724,
  [5922] = 5870,
  [5923] = 5381,
  [5924] = 5867,
  [5925] = 5899,
  [5926] = 5867,
  [5927] = 5803,
  [5928] = 5870,
  [5929] = 5866,
  [5930] = 5899,
  [5931] = 5894,
  [5932] = 5894,
  [5933] = 5871,
  [5934] = 5868,
  [5935] = 5874,
  [5936] = 5867,
  [5937] = 5867,
  [5938] = 5879,
  [5939] = 5867,
  [5940] = 5887,
  [5941] = 4780,
  [5942] = 5867,
  [5943] = 744,
  [5944] = 5867,
  [5945] = 5870,
  [5946] = 4985,
  [5947] = 5870,
  [5948] = 5874,
  [5949] = 421,
  [5950] = 5870,
  [5951] = 5871,
  [5952] = 5867,
  [5953] = 5879,
  [5954] = 5871,
  [5955] = 5870,
  [5956] = 5874,
  [5957] = 5870,
  [5958] = 5803,
  [5959] = 5868,
  [5960] = 5870,
  [5961] = 344,
  [5962] = 5894,
  [5963] = 5871,
  [5964] = 4999,
  [5965] = 5381,
  [5966] = 5866,
  [5967] = 5879,
  [5968] = 5899,
  [5969] = 5868,
  [5970] = 4724,
  [5971] = 245,
  [5972] = 4954,
  [5973] = 5899,
  [5974] = 5867,
  [5975] = 5899,
  [5976] = 5870,
  [5977] = 5867,
  [5978] = 5870,
  [5979] = 5868,
  [5980] = 5870,
  [5981] = 4996,
  [5982] = 5867,
  [5983] = 5195,
  [5984] = 5984,
  [5985] = 5870,
  [5986] = 5894,
  [5987] = 5879,
  [5988] = 5866,
  [5989] = 5899,
  [5990] = 4999,
  [5991] = 4724,
  [5992] = 344,
  [5993] = 5867,
  [5994] = 5866,
  [5995] = 5866,
  [5996] = 5871,
  [5997] = 628,
  [5998] = 717,
  [5999] = 4954,
  [6000] = 4985,
  [6001] = 4996,
  [6002] = 5870,
  [6003] = 6003,
  [6004] = 421,
  [6005] = 5868,
  [6006] = 5870,
  [6007] = 5887,
  [6008] = 5867,
  [6009] = 4763,
  [6010] = 5867,
  [6011] = 5874,
  [6012] = 344,
  [6013] = 4999,
  [6014] = 5381,
  [6015] = 603,
  [6016] = 463,
  [6017] = 4772,
  [6018] = 4996,
  [6019] = 421,
  [6020] = 595,
  [6021] = 344,
  [6022] = 421,
  [6023] = 5381,
  [6024] = 344,
  [6025] = 421,
  [6026] = 4954,
  [6027] = 5441,
  [6028] = 5381,
  [6029] = 4985,
  [6030] = 5381,
  [6031] = 5803,
  [6032] = 5803,
  [6033] = 5774,
  [6034] = 4985,
  [6035] = 5774,
  [6036] = 4996,
  [6037] = 5195,
  [6038] = 6038,
  [6039] = 5381,
  [6040] = 6040,
  [6041] = 6041,
  [6042] = 6041,
  [6043] = 4954,
  [6044] = 5774,
  [6045] = 4724,
  [6046] = 5381,
  [6047] = 4954,
  [6048] = 4985,
  [6049] = 5803,
  [6050] = 6040,
  [6051] = 5381,
  [6052] = 4996,
  [6053] = 744,
  [6054] = 6038,
  [6055] = 5803,
  [6056] = 717,
  [6057] = 4999,
  [6058] = 5381,
  [6059] = 5151,
  [6060] = 6060,
  [6061] = 4999,
  [6062] = 5774,
  [6063] = 653,
  [6064] = 6064,
  [6065] = 4999,
  [6066] = 638,
  [6067] = 5381,
  [6068] = 4724,
  [6069] = 4985,
  [6070] = 5381,
  [6071] = 639,
  [6072] = 620,
  [6073] = 617,
  [6074] = 5774,
  [6075] = 6064,
  [6076] = 603,
  [6077] = 621,
  [6078] = 651,
  [6079] = 5381,
  [6080] = 6064,
  [6081] = 2583,
  [6082] = 5803,
  [6083] = 640,
  [6084] = 2582,
  [6085] = 4999,
  [6086] = 5774,
  [6087] = 5803,
  [6088] = 595,
  [6089] = 4985,
  [6090] = 4954,
  [6091] = 5381,
  [6092] = 613,
  [6093] = 4996,
  [6094] = 2582,
  [6095] = 647,
  [6096] = 5381,
  [6097] = 2583,
  [6098] = 595,
  [6099] = 5441,
  [6100] = 603,
  [6101] = 4954,
  [6102] = 625,
  [6103] = 4996,
  [6104] = 5381,
  [6105] = 4996,
  [6106] = 4954,
  [6107] = 626,
  [6108] = 4985,
  [6109] = 495,
  [6110] = 707,
  [6111] = 4999,
  [6112] = 5774,
  [6113] = 4985,
  [6114] = 644,
  [6115] = 5803,
  [6116] = 6116,
  [6117] = 5774,
  [6118] = 4933,
  [6119] = 5803,
  [6120] = 4942,
  [6121] = 629,
  [6122] = 5803,
  [6123] = 4954,
  [6124] = 6124,
  [6125] = 6125,
  [6126] = 6126,
  [6127] = 6127,
  [6128] = 630,
  [6129] = 643,
  [6130] = 4954,
  [6131] = 4985,
  [6132] = 641,
  [6133] = 5774,
  [6134] = 4999,
  [6135] = 5774,
  [6136] = 4996,
  [6137] = 532,
  [6138] = 6127,
  [6139] = 4996,
  [6140] = 642,
  [6141] = 631,
  [6142] = 532,
  [6143] = 717,
  [6144] = 6125,
  [6145] = 744,
  [6146] = 635,
  [6147] = 4999,
  [6148] = 5803,
  [6149] = 633,
  [6150] = 6126,
  [6151] = 640,
  [6152] = 626,
  [6153] = 653,
  [6154] = 651,
  [6155] = 621,
  [6156] = 794,
  [6157] = 639,
  [6158] = 5774,
  [6159] = 717,
  [6160] = 620,
  [6161] = 6161,
  [6162] = 6161,
  [6163] = 5803,
  [6164] = 6125,
  [6165] = 653,
  [6166] = 651,
  [6167] = 5803,
  [6168] = 621,
  [6169] = 617,
  [6170] = 620,
  [6171] = 638,
  [6172] = 5774,
  [6173] = 639,
  [6174] = 638,
  [6175] = 640,
  [6176] = 6125,
  [6177] = 744,
  [6178] = 6161,
  [6179] = 6161,
  [6180] = 6127,
  [6181] = 6161,
  [6182] = 647,
  [6183] = 5774,
  [6184] = 5803,
  [6185] = 6126,
  [6186] = 6161,
  [6187] = 617,
  [6188] = 5803,
  [6189] = 6126,
  [6190] = 6190,
  [6191] = 6191,
  [6192] = 6192,
  [6193] = 625,
  [6194] = 626,
  [6195] = 613,
  [6196] = 6127,
  [6197] = 613,
  [6198] = 647,
  [6199] = 625,
  [6200] = 5774,
  [6201] = 6201,
  [6202] = 6202,
  [6203] = 6202,
  [6204] = 6204,
  [6205] = 6201,
  [6206] = 6206,
  [6207] = 6207,
  [6208] = 6201,
  [6209] = 6207,
  [6210] = 6204,
  [6211] = 6202,
  [6212] = 6204,
  [6213] = 6206,
  [6214] = 6201,
  [6215] = 6207,
  [6216] = 6202,
  [6217] = 6206,
  [6218] = 628,
  [6219] = 6219,
  [6220] = 5803,
  [6221] = 6221,
  [6222] = 6222,
  [6223] = 5774,
  [6224] = 5774,
  [6225] = 6206,
  [6226] = 6207,
  [6227] = 6222,
  [6228] = 6206,
  [6229] = 6207,
  [6230] = 6221,
  [6231] = 6219,
  [6232] = 6204,
  [6233] = 6206,
  [6234] = 6207,
  [6235] = 6201,
  [6236] = 6202,
  [6237] = 6201,
  [6238] = 6204,
  [6239] = 6202,
  [6240] = 6204,
  [6241] = 6201,
  [6242] = 6201,
  [6243] = 6207,
  [6244] = 6206,
  [6245] = 6204,
  [6246] = 6202,
  [6247] = 6201,
  [6248] = 5803,
  [6249] = 5803,
  [6250] = 6222,
  [6251] = 6207,
  [6252] = 6206,
  [6253] = 6206,
  [6254] = 6204,
  [6255] = 6202,
  [6256] = 6204,
  [6257] = 5803,
  [6258] = 6202,
  [6259] = 6201,
  [6260] = 6202,
  [6261] = 6204,
  [6262] = 6201,
  [6263] = 6207,
  [6264] = 6206,
  [6265] = 6222,
  [6266] = 6204,
  [6267] = 6221,
  [6268] = 5774,
  [6269] = 6219,
  [6270] = 6207,
  [6271] = 6202,
  [6272] = 6204,
  [6273] = 6201,
  [6274] = 6207,
  [6275] = 6206,
  [6276] = 6202,
  [6277] = 6204,
  [6278] = 6201,
  [6279] = 6202,
  [6280] = 744,
  [6281] = 6206,
  [6282] = 6207,
  [6283] = 5803,
  [6284] = 6206,
  [6285] = 6204,
  [6286] = 6202,
  [6287] = 6204,
  [6288] = 744,
  [6289] = 6219,
  [6290] = 717,
  [6291] = 6221,
  [6292] = 6201,
  [6293] = 6207,
  [6294] = 6206,
  [6295] = 5774,
  [6296] = 6201,
  [6297] = 6222,
  [6298] = 6207,
  [6299] = 6206,
  [6300] = 6207,
  [6301] = 6202,
  [6302] = 6202,
  [6303] = 6221,
  [6304] = 6219,
  [6305] = 6204,
  [6306] = 6201,
  [6307] = 6207,
  [6308] = 6206,
  [6309] = 6202,
  [6310] = 6202,
  [6311] = 6204,
  [6312] = 6204,
  [6313] = 6201,
  [6314] = 5774,
  [6315] = 6207,
  [6316] = 6206,
  [6317] = 6206,
  [6318] = 6207,
  [6319] = 6207,
  [6320] = 6206,
  [6321] = 6201,
  [6322] = 6207,
  [6323] = 6206,
  [6324] = 6219,
  [6325] = 6219,
  [6326] = 6221,
  [6327] = 6222,
  [6328] = 6202,
  [6329] = 6201,
  [6330] = 6204,
  [6331] = 6204,
  [6332] = 6201,
  [6333] = 717,
  [6334] = 5803,
  [6335] = 789,
  [6336] = 6202,
  [6337] = 6202,
  [6338] = 6207,
  [6339] = 6206,
  [6340] = 6206,
  [6341] = 6221,
  [6342] = 6207,
  [6343] = 6222,
  [6344] = 5774,
  [6345] = 6201,
  [6346] = 6204,
  [6347] = 6202,
  [6348] = 6204,
  [6349] = 6201,
  [6350] = 6350,
  [6351] = 6351,
  [6352] = 6352,
  [6353] = 6353,
  [6354] = 6125,
  [6355] = 6355,
  [6356] = 6353,
  [6357] = 6357,
  [6358] = 6358,
  [6359] = 6127,
  [6360] = 6360,
  [6361] = 6355,
  [6362] = 6351,
  [6363] = 6363,
  [6364] = 6357,
  [6365] = 6351,
  [6366] = 6126,
  [6367] = 6360,
  [6368] = 6352,
  [6369] = 6352,
  [6370] = 6360,
  [6371] = 6353,
  [6372] = 6360,
  [6373] = 6360,
  [6374] = 6352,
  [6375] = 6352,
  [6376] = 6127,
  [6377] = 6360,
  [6378] = 6378,
  [6379] = 6360,
  [6380] = 6127,
  [6381] = 6360,
  [6382] = 6360,
  [6383] = 6352,
  [6384] = 6351,
  [6385] = 6385,
  [6386] = 6357,
  [6387] = 6353,
  [6388] = 6378,
  [6389] = 6355,
  [6390] = 6353,
  [6391] = 6360,
  [6392] = 6352,
  [6393] = 6355,
  [6394] = 6351,
  [6395] = 6126,
  [6396] = 6355,
  [6397] = 6355,
  [6398] = 6352,
  [6399] = 717,
  [6400] = 6400,
  [6401] = 6360,
  [6402] = 6357,
  [6403] = 6360,
  [6404] = 6378,
  [6405] = 6352,
  [6406] = 6352,
  [6407] = 717,
  [6408] = 6360,
  [6409] = 6352,
  [6410] = 6352,
  [6411] = 6358,
  [6412] = 6357,
  [6413] = 6351,
  [6414] = 6352,
  [6415] = 6352,
  [6416] = 6360,
  [6417] = 6126,
  [6418] = 6378,
  [6419] = 6127,
  [6420] = 6358,
  [6421] = 6352,
  [6422] = 6126,
  [6423] = 6352,
  [6424] = 6358,
  [6425] = 6125,
  [6426] = 6358,
  [6427] = 6352,
  [6428] = 6353,
  [6429] = 6360,
  [6430] = 6360,
  [6431] = 6357,
  [6432] = 6360,
  [6433] = 6352,
  [6434] = 6360,
  [6435] = 6125,
  [6436] = 6352,
  [6437] = 6360,
  [6438] = 6352,
  [6439] = 6125,
  [6440] = 6352,
  [6441] = 6360,
  [6442] = 6352,
  [6443] = 6352,
  [6444] = 6352,
  [6445] = 744,
  [6446] = 6355,
  [6447] = 6353,
  [6448] = 6352,
  [6449] = 6360,
  [6450] = 6352,
  [6451] = 6360,
  [6452] = 6357,
  [6453] = 744,
  [6454] = 6351,
  [6455] = 6455,
  [6456] = 6127,
  [6457] = 6127,
  [6458] = 6458,
  [6459] = 6126,
  [6460] = 6126,
  [6461] = 6125,
  [6462] = 6125,
  [6463] = 6125,
  [6464] = 6125,
  [6465] = 6126,
  [6466] = 6126,
  [6467] = 6127,
  [6468] = 6125,
  [6469] = 6125,
  [6470] = 6126,
  [6471] = 6127,
  [6472] = 6126,
  [6473] = 6127,
  [6474] = 6127,
  [6475] = 6125,
  [6476] = 6127,
  [6477] = 6127,
  [6478] = 6478,
  [6479] = 3117,
  [6480] = 6478,
  [6481] = 6127,
  [6482] = 6126,
  [6483] = 6126,
  [6484] = 6125,
  [6485] = 6127,
  [6486] = 6486,
  [6487] = 6126,
  [6488] = 6486,
  [6489] = 6486,
  [6490] = 6126,
  [6491] = 6125,
  [6492] = 6486,
  [6493] = 6125,
  [6494] = 6127,
  [6495] = 6495,
  [6496] = 6125,
  [6497] = 6127,
  [6498] = 6126,
  [6499] = 6127,
  [6500] = 6125,
  [6501] = 6495,
  [6502] = 6495,
  [6503] = 6495,
  [6504] = 6126,
  [6505] = 6126,
  [6506] = 6125,
  [6507] = 6495,
  [6508] = 6125,
  [6509] = 6127,
  [6510] = 6495,
  [6511] = 6127,
  [6512] = 6126,
  [6513] = 6126,
  [6514] = 6126,
  [6515] = 6478,
  [6516] = 6495,
  [6517] = 6127,
  [6518] = 6125,
  [6519] = 6125,
  [6520] = 6478,
  [6521] = 6521,
  [6522] = 6522,
  [6523] = 6522,
  [6524] = 6522,
  [6525] = 6525,
  [6526] = 6526,
  [6527] = 6527,
  [6528] = 6528,
  [6529] = 6529,
  [6530] = 6528,
  [6531] = 6528,
  [6532] = 6529,
  [6533] = 6529,
  [6534] = 6534,
  [6535] = 6526,
  [6536] = 6478,
  [6537] = 6527,
  [6538] = 6527,
  [6539] = 6526,
  [6540] = 6529,
  [6541] = 6541,
  [6542] = 6529,
  [6543] = 6528,
  [6544] = 6478,
  [6545] = 6545,
  [6546] = 6534,
  [6547] = 6527,
  [6548] = 6548,
  [6549] = 6545,
  [6550] = 6528,
  [6551] = 6551,
  [6552] = 6548,
  [6553] = 6529,
  [6554] = 6541,
  [6555] = 6478,
  [6556] = 6528,
  [6557] = 6529,
  [6558] = 6541,
  [6559] = 6528,
  [6560] = 6529,
  [6561] = 6528,
  [6562] = 6527,
  [6563] = 6545,
  [6564] = 6527,
  [6565] = 6529,
  [6566] = 6548,
  [6567] = 6567,
  [6568] = 6528,
  [6569] = 6529,
  [6570] = 6534,
  [6571] = 6526,
  [6572] = 6541,
  [6573] = 6534,
  [6574] = 6545,
  [6575] = 6548,
  [6576] = 6529,
  [6577] = 6577,
  [6578] = 6541,
  [6579] = 6528,
  [6580] = 6529,
  [6581] = 6527,
  [6582] = 6529,
  [6583] = 6528,
  [6584] = 6529,
  [6585] = 6527,
  [6586] = 6527,
  [6587] = 6529,
  [6588] = 6529,
  [6589] = 6528,
  [6590] = 6528,
  [6591] = 6528,
  [6592] = 6528,
  [6593] = 6528,
  [6594] = 6594,
  [6595] = 6595,
  [6596] = 6596,
  [6597] = 6534,
  [6598] = 6598,
  [6599] = 6598,
  [6600] = 6596,
  [6601] = 6601,
  [6602] = 6602,
  [6603] = 6596,
  [6604] = 6598,
  [6605] = 6548,
  [6606] = 6545,
  [6607] = 6602,
  [6608] = 6598,
  [6609] = 6596,
  [6610] = 6601,
  [6611] = 6595,
  [6612] = 6478,
  [6613] = 6526,
  [6614] = 6595,
  [6615] = 6602,
  [6616] = 6601,
  [6617] = 6617,
  [6618] = 6602,
  [6619] = 6598,
  [6620] = 6601,
  [6621] = 6595,
  [6622] = 6596,
  [6623] = 6596,
  [6624] = 6598,
  [6625] = 6596,
  [6626] = 6595,
  [6627] = 6601,
  [6628] = 6602,
  [6629] = 6598,
  [6630] = 6596,
  [6631] = 6631,
  [6632] = 6596,
  [6633] = 6595,
  [6634] = 6595,
  [6635] = 6596,
  [6636] = 6595,
  [6637] = 6601,
  [6638] = 6602,
  [6639] = 6601,
  [6640] = 6548,
  [6641] = 6596,
  [6642] = 6642,
  [6643] = 6643,
  [6644] = 6598,
  [6645] = 6594,
  [6646] = 6595,
  [6647] = 6595,
  [6648] = 6595,
  [6649] = 6602,
  [6650] = 6650,
  [6651] = 6601,
  [6652] = 6601,
  [6653] = 6595,
  [6654] = 6598,
  [6655] = 6598,
  [6656] = 6598,
  [6657] = 6602,
  [6658] = 6658,
  [6659] = 6601,
  [6660] = 6551,
  [6661] = 6602,
  [6662] = 6595,
  [6663] = 6598,
  [6664] = 6601,
  [6665] = 6602,
  [6666] = 6545,
  [6667] = 6601,
  [6668] = 6602,
  [6669] = 6598,
  [6670] = 6596,
  [6671] = 6596,
  [6672] = 6672,
  [6673] = 6602,
  [6674] = 6650,
  [6675] = 6601,
  [6676] = 6676,
  [6677] = 6601,
  [6678] = 6595,
  [6679] = 6595,
  [6680] = 6534,
  [6681] = 6598,
  [6682] = 6598,
  [6683] = 6595,
  [6684] = 6596,
  [6685] = 6596,
  [6686] = 6602,
  [6687] = 6602,
  [6688] = 6601,
  [6689] = 6478,
  [6690] = 6598,
  [6691] = 6691,
  [6692] = 6596,
  [6693] = 6596,
  [6694] = 6694,
  [6695] = 6598,
  [6696] = 6595,
  [6697] = 6594,
  [6698] = 6602,
  [6699] = 6699,
  [6700] = 6595,
  [6701] = 6478,
  [6702] = 6601,
  [6703] = 6602,
  [6704] = 6595,
  [6705] = 6596,
  [6706] = 6596,
  [6707] = 6601,
  [6708] = 6602,
  [6709] = 6601,
  [6710] = 6602,
  [6711] = 6596,
  [6712] = 6601,
  [6713] = 6601,
  [6714] = 6602,
  [6715] = 6598,
  [6716] = 6596,
  [6717] = 6598,
  [6718] = 6602,
  [6719] = 6650,
  [6720] = 6598,
  [6721] = 6601,
  [6722] = 6596,
  [6723] = 6595,
  [6724] = 6598,
  [6725] = 6595,
  [6726] = 6595,
  [6727] = 6526,
  [6728] = 6602,
  [6729] = 6602,
  [6730] = 3117,
  [6731] = 6598,
  [6732] = 6601,
  [6733] = 1830,
  [6734] = 6734,
  [6735] = 6478,
  [6736] = 1855,
  [6737] = 2607,
  [6738] = 6545,
  [6739] = 6739,
  [6740] = 192,
  [6741] = 1859,
  [6742] = 6742,
  [6743] = 6743,
  [6744] = 6744,
  [6745] = 6745,
  [6746] = 6746,
  [6747] = 6747,
  [6748] = 6748,
  [6749] = 6534,
  [6750] = 6750,
  [6751] = 6751,
  [6752] = 6752,
  [6753] = 6548,
  [6754] = 6754,
  [6755] = 6755,
  [6756] = 6742,
  [6757] = 6757,
  [6758] = 6758,
  [6759] = 6759,
  [6760] = 6754,
  [6761] = 6742,
  [6762] = 6742,
  [6763] = 6754,
  [6764] = 6764,
  [6765] = 6734,
  [6766] = 6766,
  [6767] = 1909,
  [6768] = 6752,
  [6769] = 1849,
  [6770] = 6754,
  [6771] = 1843,
  [6772] = 3477,
  [6773] = 6478,
  [6774] = 6774,
  [6775] = 6775,
  [6776] = 6776,
  [6777] = 6526,
  [6778] = 6734,
  [6779] = 6779,
  [6780] = 6780,
  [6781] = 6775,
  [6782] = 6754,
  [6783] = 6577,
  [6784] = 6784,
  [6785] = 6776,
  [6786] = 6734,
  [6787] = 6567,
  [6788] = 191,
  [6789] = 6789,
  [6790] = 6790,
  [6791] = 6747,
  [6792] = 6526,
  [6793] = 6742,
  [6794] = 6794,
  [6795] = 6742,
  [6796] = 6734,
  [6797] = 6776,
  [6798] = 6798,
  [6799] = 6534,
  [6800] = 6800,
  [6801] = 6754,
  [6802] = 1814,
  [6803] = 6545,
  [6804] = 1819,
  [6805] = 6805,
  [6806] = 1867,
  [6807] = 6548,
  [6808] = 1827,
  [6809] = 6809,
  [6810] = 2610,
  [6811] = 6764,
  [6812] = 6742,
  [6813] = 6813,
  [6814] = 6814,
  [6815] = 6478,
  [6816] = 6742,
  [6817] = 6817,
  [6818] = 6739,
  [6819] = 6743,
  [6820] = 6754,
  [6821] = 6734,
  [6822] = 6822,
  [6823] = 6779,
  [6824] = 6774,
  [6825] = 6800,
  [6826] = 6744,
  [6827] = 6746,
  [6828] = 1849,
  [6829] = 6734,
  [6830] = 6734,
  [6831] = 6831,
  [6832] = 6748,
  [6833] = 6750,
  [6834] = 6751,
  [6835] = 6784,
  [6836] = 6817,
  [6837] = 6734,
  [6838] = 191,
  [6839] = 6822,
  [6840] = 6755,
  [6841] = 6784,
  [6842] = 1829,
  [6843] = 6478,
  [6844] = 1920,
  [6845] = 6757,
  [6846] = 1847,
  [6847] = 6817,
  [6848] = 1920,
  [6849] = 1921,
  [6850] = 6779,
  [6851] = 6734,
  [6852] = 1867,
  [6853] = 1819,
  [6854] = 1814,
  [6855] = 1847,
  [6856] = 6856,
  [6857] = 6857,
  [6858] = 6800,
  [6859] = 6784,
  [6860] = 6734,
  [6861] = 192,
  [6862] = 1830,
  [6863] = 6863,
  [6864] = 6822,
  [6865] = 6865,
  [6866] = 1855,
  [6867] = 6734,
  [6868] = 1850,
  [6869] = 1921,
  [6870] = 1827,
  [6871] = 6754,
  [6872] = 1850,
  [6873] = 1859,
  [6874] = 6874,
  [6875] = 6742,
  [6876] = 6876,
  [6877] = 6754,
  [6878] = 6878,
  [6879] = 6734,
  [6880] = 6822,
  [6881] = 6764,
  [6882] = 6747,
  [6883] = 6800,
  [6884] = 1843,
  [6885] = 6776,
  [6886] = 1909,
  [6887] = 6817,
  [6888] = 6779,
  [6889] = 6889,
  [6890] = 6890,
  [6891] = 6891,
  [6892] = 6892,
  [6893] = 6893,
  [6894] = 6894,
  [6895] = 1829,
  [6896] = 2610,
  [6897] = 6892,
  [6898] = 6898,
  [6899] = 6899,
  [6900] = 6900,
  [6901] = 6901,
  [6902] = 6901,
  [6903] = 6822,
  [6904] = 6904,
  [6905] = 6899,
  [6906] = 6817,
  [6907] = 6907,
  [6908] = 6908,
  [6909] = 6789,
  [6910] = 6478,
  [6911] = 6784,
  [6912] = 6863,
  [6913] = 6779,
  [6914] = 6914,
  [6915] = 6784,
  [6916] = 6904,
  [6917] = 6917,
  [6918] = 6890,
  [6919] = 6917,
  [6920] = 6865,
  [6921] = 6921,
  [6922] = 6876,
  [6923] = 6878,
  [6924] = 6898,
  [6925] = 6907,
  [6926] = 6901,
  [6927] = 6898,
  [6928] = 6928,
  [6929] = 6794,
  [6930] = 6930,
  [6931] = 6904,
  [6932] = 6899,
  [6933] = 6899,
  [6934] = 6831,
  [6935] = 6822,
  [6936] = 6898,
  [6937] = 6809,
  [6938] = 6899,
  [6939] = 6891,
  [6940] = 6779,
  [6941] = 6898,
  [6942] = 6800,
  [6943] = 3477,
  [6944] = 6758,
  [6945] = 6893,
  [6946] = 1197,
  [6947] = 6898,
  [6948] = 6478,
  [6949] = 6949,
  [6950] = 6894,
  [6951] = 6817,
  [6952] = 6901,
  [6953] = 6900,
  [6954] = 6901,
  [6955] = 6856,
  [6956] = 2607,
  [6957] = 6957,
  [6958] = 6889,
  [6959] = 1195,
  [6960] = 6900,
  [6961] = 6901,
  [6962] = 6962,
  [6963] = 6917,
  [6964] = 6900,
  [6965] = 6759,
  [6966] = 6800,
  [6967] = 6967,
  [6968] = 6898,
  [6969] = 6857,
  [6970] = 6917,
  [6971] = 6899,
  [6972] = 6822,
  [6973] = 6973,
  [6974] = 6974,
  [6975] = 6975,
  [6976] = 6526,
  [6977] = 6779,
  [6978] = 6784,
  [6979] = 6548,
  [6980] = 6974,
  [6981] = 6817,
  [6982] = 6642,
  [6983] = 6545,
  [6984] = 6800,
  [6985] = 6985,
  [6986] = 6478,
  [6987] = 6985,
  [6988] = 6973,
  [6989] = 6545,
  [6990] = 6990,
  [6991] = 6991,
  [6992] = 6817,
  [6993] = 6548,
  [6994] = 6822,
  [6995] = 6691,
  [6996] = 6996,
  [6997] = 6784,
  [6998] = 6779,
  [6999] = 6534,
  [7000] = 7000,
  [7001] = 6672,
  [7002] = 6800,
  [7003] = 7003,
  [7004] = 6996,
  [7005] = 7000,
  [7006] = 6534,
  [7007] = 6526,
  [7008] = 7008,
  [7009] = 7009,
  [7010] = 7010,
  [7011] = 6478,
  [7012] = 7012,
  [7013] = 7013,
  [7014] = 7014,
  [7015] = 7015,
  [7016] = 6534,
  [7017] = 7014,
  [7018] = 7018,
  [7019] = 7009,
  [7020] = 2792,
  [7021] = 2607,
  [7022] = 2801,
  [7023] = 2610,
  [7024] = 7009,
  [7025] = 7025,
  [7026] = 7013,
  [7027] = 7009,
  [7028] = 2610,
  [7029] = 7013,
  [7030] = 7030,
  [7031] = 6567,
  [7032] = 7032,
  [7033] = 6577,
  [7034] = 7013,
  [7035] = 6545,
  [7036] = 7036,
  [7037] = 7009,
  [7038] = 6526,
  [7039] = 7014,
  [7040] = 7040,
  [7041] = 7009,
  [7042] = 7042,
  [7043] = 7009,
  [7044] = 7013,
  [7045] = 6526,
  [7046] = 6526,
  [7047] = 6548,
  [7048] = 6534,
  [7049] = 2804,
  [7050] = 7013,
  [7051] = 7014,
  [7052] = 7013,
  [7053] = 6545,
  [7054] = 6548,
  [7055] = 7025,
  [7056] = 6548,
  [7057] = 7009,
  [7058] = 6534,
  [7059] = 6534,
  [7060] = 7014,
  [7061] = 7061,
  [7062] = 7013,
  [7063] = 6545,
  [7064] = 7009,
  [7065] = 7012,
  [7066] = 7013,
  [7067] = 7018,
  [7068] = 6545,
  [7069] = 2607,
  [7070] = 6478,
  [7071] = 7042,
  [7072] = 6526,
  [7073] = 7032,
  [7074] = 7030,
  [7075] = 7075,
  [7076] = 7013,
  [7077] = 7010,
  [7078] = 7008,
  [7079] = 7075,
  [7080] = 7036,
  [7081] = 7040,
  [7082] = 7009,
  [7083] = 7014,
  [7084] = 7084,
  [7085] = 6548,
  [7086] = 7086,
  [7087] = 7086,
  [7088] = 7088,
  [7089] = 7089,
  [7090] = 7090,
  [7091] = 7091,
  [7092] = 7092,
  [7093] = 6548,
  [7094] = 7086,
  [7095] = 6548,
  [7096] = 7086,
  [7097] = 7097,
  [7098] = 7086,
  [7099] = 7086,
  [7100] = 7100,
  [7101] = 7101,
  [7102] = 7086,
  [7103] = 7103,
  [7104] = 7104,
  [7105] = 7105,
  [7106] = 7106,
  [7107] = 7107,
  [7108] = 7108,
  [7109] = 7109,
  [7110] = 6822,
  [7111] = 7090,
  [7112] = 6822,
  [7113] = 7086,
  [7114] = 7097,
  [7115] = 6545,
  [7116] = 7090,
  [7117] = 7117,
  [7118] = 7118,
  [7119] = 7086,
  [7120] = 7120,
  [7121] = 6817,
  [7122] = 7086,
  [7123] = 7086,
  [7124] = 6534,
  [7125] = 7125,
  [7126] = 7126,
  [7127] = 7127,
  [7128] = 7128,
  [7129] = 7086,
  [7130] = 7086,
  [7131] = 6545,
  [7132] = 6534,
  [7133] = 7133,
  [7134] = 6526,
  [7135] = 7135,
  [7136] = 7126,
  [7137] = 7090,
  [7138] = 7135,
  [7139] = 7128,
  [7140] = 7089,
  [7141] = 6800,
  [7142] = 7142,
  [7143] = 6548,
  [7144] = 7144,
  [7145] = 7145,
  [7146] = 7100,
  [7147] = 7086,
  [7148] = 7148,
  [7149] = 6779,
  [7150] = 7090,
  [7151] = 7127,
  [7152] = 7152,
  [7153] = 7153,
  [7154] = 7154,
  [7155] = 6784,
  [7156] = 6784,
  [7157] = 7120,
  [7158] = 7086,
  [7159] = 7086,
  [7160] = 6545,
  [7161] = 7161,
  [7162] = 6534,
  [7163] = 6526,
  [7164] = 6545,
  [7165] = 7145,
  [7166] = 7090,
  [7167] = 7167,
  [7168] = 7168,
  [7169] = 7169,
  [7170] = 7168,
  [7171] = 7167,
  [7172] = 7153,
  [7173] = 6779,
  [7174] = 6548,
  [7175] = 7148,
  [7176] = 6817,
  [7177] = 6534,
  [7178] = 6478,
  [7179] = 7154,
  [7180] = 7180,
  [7181] = 7181,
  [7182] = 7144,
  [7183] = 7012,
  [7184] = 7091,
  [7185] = 7086,
  [7186] = 7169,
  [7187] = 7133,
  [7188] = 7181,
  [7189] = 7189,
  [7190] = 6526,
  [7191] = 7125,
  [7192] = 7103,
  [7193] = 7104,
  [7194] = 7194,
  [7195] = 7075,
  [7196] = 7152,
  [7197] = 7012,
  [7198] = 6545,
  [7199] = 7199,
  [7200] = 7180,
  [7201] = 6478,
  [7202] = 7161,
  [7203] = 7042,
  [7204] = 7090,
  [7205] = 7205,
  [7206] = 6478,
  [7207] = 7142,
  [7208] = 7208,
  [7209] = 7105,
  [7210] = 7117,
  [7211] = 6800,
  [7212] = 7106,
  [7213] = 7107,
  [7214] = 7086,
  [7215] = 7040,
  [7216] = 7189,
  [7217] = 7205,
  [7218] = 7208,
  [7219] = 6526,
  [7220] = 7092,
  [7221] = 7032,
  [7222] = 7086,
  [7223] = 7030,
  [7224] = 7086,
  [7225] = 6534,
  [7226] = 7109,
  [7227] = 7199,
  [7228] = 6548,
  [7229] = 6545,
  [7230] = 6534,
  [7231] = 6526,
  [7232] = 7010,
  [7233] = 7086,
  [7234] = 7008,
  [7235] = 7101,
  [7236] = 7036,
  [7237] = 6548,
  [7238] = 7086,
  [7239] = 7108,
  [7240] = 7088,
  [7241] = 6526,
  [7242] = 7086,
  [7243] = 6779,
  [7244] = 6545,
  [7245] = 7245,
  [7246] = 6526,
  [7247] = 7040,
  [7248] = 6526,
  [7249] = 7249,
  [7250] = 6784,
  [7251] = 7008,
  [7252] = 6548,
  [7253] = 6779,
  [7254] = 6545,
  [7255] = 7255,
  [7256] = 7249,
  [7257] = 7010,
  [7258] = 6534,
  [7259] = 6800,
  [7260] = 7120,
  [7261] = 7245,
  [7262] = 7245,
  [7263] = 6800,
  [7264] = 7264,
  [7265] = 6534,
  [7266] = 7249,
  [7267] = 6534,
  [7268] = 6545,
  [7269] = 6817,
  [7270] = 7249,
  [7271] = 7030,
  [7272] = 7075,
  [7273] = 7032,
  [7274] = 7274,
  [7275] = 6822,
  [7276] = 7276,
  [7277] = 6817,
  [7278] = 7125,
  [7279] = 6817,
  [7280] = 7117,
  [7281] = 7181,
  [7282] = 7249,
  [7283] = 6548,
  [7284] = 6784,
  [7285] = 7169,
  [7286] = 7286,
  [7287] = 6526,
  [7288] = 7091,
  [7289] = 7289,
  [7290] = 6478,
  [7291] = 7144,
  [7292] = 6526,
  [7293] = 7293,
  [7294] = 7042,
  [7295] = 6548,
  [7296] = 7249,
  [7297] = 7105,
  [7298] = 7103,
  [7299] = 7299,
  [7300] = 7289,
  [7301] = 7104,
  [7302] = 6822,
  [7303] = 7106,
  [7304] = 7107,
  [7305] = 7289,
  [7306] = 7036,
  [7307] = 7289,
  [7308] = 7108,
  [7309] = 6534,
  [7310] = 7299,
  [7311] = 6784,
  [7312] = 7249,
  [7313] = 6822,
  [7314] = 7314,
  [7315] = 6800,
  [7316] = 7109,
  [7317] = 7317,
  [7318] = 7117,
  [7319] = 6779,
  [7320] = 6800,
  [7321] = 7249,
  [7322] = 6784,
  [7323] = 7323,
  [7324] = 7120,
  [7325] = 6548,
  [7326] = 6817,
  [7327] = 7245,
  [7328] = 7245,
  [7329] = 7289,
  [7330] = 7289,
  [7331] = 6545,
  [7332] = 7332,
  [7333] = 7249,
  [7334] = 7334,
  [7335] = 7245,
  [7336] = 7336,
  [7337] = 7337,
  [7338] = 7334,
  [7339] = 7154,
  [7340] = 7245,
  [7341] = 7249,
  [7342] = 6567,
  [7343] = 7334,
  [7344] = 6577,
  [7345] = 7334,
  [7346] = 7289,
  [7347] = 6779,
  [7348] = 6822,
  [7349] = 6478,
  [7350] = 6779,
  [7351] = 7012,
  [7352] = 7108,
  [7353] = 7107,
  [7354] = 7106,
  [7355] = 7355,
  [7356] = 7355,
  [7357] = 7355,
  [7358] = 7355,
  [7359] = 7109,
  [7360] = 7355,
  [7361] = 7361,
  [7362] = 7362,
  [7363] = 7363,
  [7364] = 7362,
  [7365] = 7355,
  [7366] = 7105,
  [7367] = 7104,
  [7368] = 7355,
  [7369] = 7103,
  [7370] = 7355,
  [7371] = 7355,
  [7372] = 3094,
  [7373] = 2808,
  [7374] = 7355,
  [7375] = 7355,
  [7376] = 7376,
  [7377] = 3085,
  [7378] = 6784,
  [7379] = 6817,
  [7380] = 6822,
  [7381] = 6779,
  [7382] = 6800,
  [7383] = 7362,
  [7384] = 7384,
  [7385] = 7385,
  [7386] = 7125,
  [7387] = 7181,
  [7388] = 7355,
  [7389] = 7169,
  [7390] = 7091,
  [7391] = 7144,
  [7392] = 7154,
  [7393] = 7299,
  [7394] = 7355,
  [7395] = 7395,
  [7396] = 3097,
  [7397] = 7376,
  [7398] = 7299,
  [7399] = 2881,
  [7400] = 7400,
  [7401] = 6800,
  [7402] = 6779,
  [7403] = 6822,
  [7404] = 2610,
  [7405] = 3217,
  [7406] = 7376,
  [7407] = 7407,
  [7408] = 6817,
  [7409] = 7376,
  [7410] = 6784,
  [7411] = 7355,
  [7412] = 7412,
  [7413] = 7407,
  [7414] = 6800,
  [7415] = 6779,
  [7416] = 6822,
  [7417] = 6817,
  [7418] = 6784,
  [7419] = 7419,
  [7420] = 7355,
  [7421] = 2868,
  [7422] = 6784,
  [7423] = 7362,
  [7424] = 7376,
  [7425] = 6817,
  [7426] = 6822,
  [7427] = 7407,
  [7428] = 7376,
  [7429] = 7355,
  [7430] = 6779,
  [7431] = 7431,
  [7432] = 6800,
  [7433] = 193,
  [7434] = 2786,
  [7435] = 7355,
  [7436] = 3092,
  [7437] = 7355,
  [7438] = 7355,
  [7439] = 2607,
  [7440] = 7355,
  [7441] = 7441,
  [7442] = 7355,
  [7443] = 7355,
  [7444] = 7376,
  [7445] = 6784,
  [7446] = 6817,
  [7447] = 6822,
  [7448] = 6779,
  [7449] = 7407,
  [7450] = 7362,
  [7451] = 6800,
  [7452] = 7355,
  [7453] = 7453,
  [7454] = 3089,
  [7455] = 7455,
  [7456] = 7407,
  [7457] = 6800,
  [7458] = 7407,
  [7459] = 6822,
  [7460] = 6817,
  [7461] = 6784,
  [7462] = 7012,
  [7463] = 7355,
  [7464] = 7362,
  [7465] = 495,
  [7466] = 7362,
  [7467] = 7407,
  [7468] = 6784,
  [7469] = 7036,
  [7470] = 7008,
  [7471] = 7036,
  [7472] = 7472,
  [7473] = 7144,
  [7474] = 7010,
  [7475] = 7475,
  [7476] = 7476,
  [7477] = 7030,
  [7478] = 7040,
  [7479] = 7125,
  [7480] = 7472,
  [7481] = 7032,
  [7482] = 7482,
  [7483] = 7042,
  [7484] = 7032,
  [7485] = 7485,
  [7486] = 7169,
  [7487] = 7075,
  [7488] = 6800,
  [7489] = 7042,
  [7490] = 7485,
  [7491] = 6800,
  [7492] = 7492,
  [7493] = 2607,
  [7494] = 6779,
  [7495] = 6779,
  [7496] = 3306,
  [7497] = 2607,
  [7498] = 7475,
  [7499] = 7154,
  [7500] = 7144,
  [7501] = 7091,
  [7502] = 7472,
  [7503] = 7485,
  [7504] = 7485,
  [7505] = 6822,
  [7506] = 2610,
  [7507] = 7169,
  [7508] = 6817,
  [7509] = 7485,
  [7510] = 7510,
  [7511] = 6784,
  [7512] = 6800,
  [7513] = 7475,
  [7514] = 6779,
  [7515] = 7515,
  [7516] = 6822,
  [7517] = 6817,
  [7518] = 6784,
  [7519] = 7485,
  [7520] = 7472,
  [7521] = 7515,
  [7522] = 7475,
  [7523] = 7475,
  [7524] = 7075,
  [7525] = 2610,
  [7526] = 7181,
  [7527] = 7125,
  [7528] = 7075,
  [7529] = 7012,
  [7530] = 7008,
  [7531] = 7485,
  [7532] = 7475,
  [7533] = 7012,
  [7534] = 7475,
  [7535] = 6800,
  [7536] = 7536,
  [7537] = 7482,
  [7538] = 7040,
  [7539] = 7475,
  [7540] = 7515,
  [7541] = 7036,
  [7542] = 6822,
  [7543] = 6817,
  [7544] = 7485,
  [7545] = 7536,
  [7546] = 7030,
  [7547] = 7008,
  [7548] = 7012,
  [7549] = 7485,
  [7550] = 7010,
  [7551] = 7475,
  [7552] = 7010,
  [7553] = 7030,
  [7554] = 7472,
  [7555] = 7032,
  [7556] = 7536,
  [7557] = 6779,
  [7558] = 6784,
  [7559] = 7482,
  [7560] = 7091,
  [7561] = 7561,
  [7562] = 7482,
  [7563] = 6817,
  [7564] = 7042,
  [7565] = 3207,
  [7566] = 7485,
  [7567] = 7120,
  [7568] = 7536,
  [7569] = 7515,
  [7570] = 7472,
  [7571] = 6822,
  [7572] = 7572,
  [7573] = 7492,
  [7574] = 7154,
  [7575] = 7575,
  [7576] = 7485,
  [7577] = 7475,
  [7578] = 3324,
  [7579] = 7181,
  [7580] = 3119,
  [7581] = 7482,
  [7582] = 7485,
  [7583] = 7120,
  [7584] = 7475,
  [7585] = 7475,
  [7586] = 7472,
  [7587] = 7040,
  [7588] = 7109,
  [7589] = 7589,
  [7590] = 7589,
  [7591] = 7169,
  [7592] = 7592,
  [7593] = 7181,
  [7594] = 7012,
  [7595] = 7125,
  [7596] = 7592,
  [7597] = 7589,
  [7598] = 7117,
  [7599] = 7104,
  [7600] = 7589,
  [7601] = 7105,
  [7602] = 7144,
  [7603] = 111,
  [7604] = 7012,
  [7605] = 7012,
  [7606] = 7589,
  [7607] = 3097,
  [7608] = 7154,
  [7609] = 7144,
  [7610] = 7091,
  [7611] = 7169,
  [7612] = 7117,
  [7613] = 7154,
  [7614] = 7117,
  [7615] = 7109,
  [7616] = 7181,
  [7617] = 7125,
  [7618] = 7618,
  [7619] = 3117,
  [7620] = 7120,
  [7621] = 7621,
  [7622] = 7042,
  [7623] = 7030,
  [7624] = 7624,
  [7625] = 3094,
  [7626] = 7626,
  [7627] = 7589,
  [7628] = 2610,
  [7629] = 7589,
  [7630] = 7103,
  [7631] = 7104,
  [7632] = 7105,
  [7633] = 7589,
  [7634] = 3092,
  [7635] = 7589,
  [7636] = 7106,
  [7637] = 7012,
  [7638] = 7107,
  [7639] = 7108,
  [7640] = 7012,
  [7641] = 3089,
  [7642] = 7117,
  [7643] = 7589,
  [7644] = 193,
  [7645] = 7645,
  [7646] = 7032,
  [7647] = 7075,
  [7648] = 7012,
  [7649] = 7091,
  [7650] = 7589,
  [7651] = 7589,
  [7652] = 344,
  [7653] = 421,
  [7654] = 190,
  [7655] = 7589,
  [7656] = 7103,
  [7657] = 7010,
  [7658] = 7104,
  [7659] = 7105,
  [7660] = 7106,
  [7661] = 7107,
  [7662] = 7108,
  [7663] = 7109,
  [7664] = 7589,
  [7665] = 7626,
  [7666] = 7042,
  [7667] = 7120,
  [7668] = 7008,
  [7669] = 7589,
  [7670] = 7036,
  [7671] = 7589,
  [7672] = 7040,
  [7673] = 7589,
  [7674] = 7589,
  [7675] = 7626,
  [7676] = 7030,
  [7677] = 7075,
  [7678] = 7012,
  [7679] = 7032,
  [7680] = 3085,
  [7681] = 7626,
  [7682] = 7589,
  [7683] = 7036,
  [7684] = 7040,
  [7685] = 2607,
  [7686] = 7589,
  [7687] = 7075,
  [7688] = 7626,
  [7689] = 7040,
  [7690] = 3017,
  [7691] = 7010,
  [7692] = 7008,
  [7693] = 7036,
  [7694] = 7008,
  [7695] = 7010,
  [7696] = 7589,
  [7697] = 7030,
  [7698] = 7032,
  [7699] = 7626,
  [7700] = 7042,
  [7701] = 7103,
  [7702] = 7589,
  [7703] = 7589,
  [7704] = 7120,
  [7705] = 7589,
  [7706] = 7108,
  [7707] = 7707,
  [7708] = 7107,
  [7709] = 7709,
  [7710] = 7106,
  [7711] = 7032,
  [7712] = 7120,
  [7713] = 7713,
  [7714] = 7714,
  [7715] = 3301,
  [7716] = 3130,
  [7717] = 3107,
  [7718] = 7718,
  [7719] = 7719,
  [7720] = 7042,
  [7721] = 7721,
  [7722] = 7117,
  [7723] = 7723,
  [7724] = 3150,
  [7725] = 7032,
  [7726] = 7030,
  [7727] = 7727,
  [7728] = 7728,
  [7729] = 7729,
  [7730] = 7730,
  [7731] = 7731,
  [7732] = 7010,
  [7733] = 7730,
  [7734] = 7008,
  [7735] = 7735,
  [7736] = 7036,
  [7737] = 7040,
  [7738] = 7075,
  [7739] = 7739,
  [7740] = 3202,
  [7741] = 7117,
  [7742] = 7742,
  [7743] = 7154,
  [7744] = 7744,
  [7745] = 7721,
  [7746] = 7723,
  [7747] = 7730,
  [7748] = 7120,
  [7749] = 7714,
  [7750] = 7718,
  [7751] = 7751,
  [7752] = 7742,
  [7753] = 7753,
  [7754] = 3131,
  [7755] = 7755,
  [7756] = 7744,
  [7757] = 3119,
  [7758] = 7317,
  [7759] = 7154,
  [7760] = 7120,
  [7761] = 7125,
  [7762] = 7181,
  [7763] = 7042,
  [7764] = 7169,
  [7765] = 7120,
  [7766] = 7744,
  [7767] = 7091,
  [7768] = 7030,
  [7769] = 7721,
  [7770] = 7144,
  [7771] = 7154,
  [7772] = 7739,
  [7773] = 7091,
  [7774] = 7739,
  [7775] = 7010,
  [7776] = 7008,
  [7777] = 7742,
  [7778] = 7036,
  [7779] = 7040,
  [7780] = 7742,
  [7781] = 7144,
  [7782] = 7299,
  [7783] = 3115,
  [7784] = 7075,
  [7785] = 7739,
  [7786] = 7786,
  [7787] = 7787,
  [7788] = 7714,
  [7789] = 7742,
  [7790] = 7255,
  [7791] = 7723,
  [7792] = 7792,
  [7793] = 7744,
  [7794] = 7794,
  [7795] = 7730,
  [7796] = 7117,
  [7797] = 7109,
  [7798] = 7723,
  [7799] = 7799,
  [7800] = 7800,
  [7801] = 7801,
  [7802] = 3140,
  [7803] = 7714,
  [7804] = 7804,
  [7805] = 7108,
  [7806] = 7107,
  [7807] = 7106,
  [7808] = 7105,
  [7809] = 3132,
  [7810] = 7104,
  [7811] = 7739,
  [7812] = 3017,
  [7813] = 7103,
  [7814] = 7814,
  [7815] = 7815,
  [7816] = 7721,
  [7817] = 7721,
  [7818] = 7109,
  [7819] = 7108,
  [7820] = 7107,
  [7821] = 7106,
  [7822] = 7105,
  [7823] = 7104,
  [7824] = 7103,
  [7825] = 7125,
  [7826] = 7826,
  [7827] = 7742,
  [7828] = 7739,
  [7829] = 7829,
  [7830] = 7721,
  [7831] = 7831,
  [7832] = 7714,
  [7833] = 3113,
  [7834] = 7834,
  [7835] = 7117,
  [7836] = 7120,
  [7837] = 7730,
  [7838] = 7299,
  [7839] = 7839,
  [7840] = 7840,
  [7841] = 7744,
  [7842] = 7181,
  [7843] = 7843,
  [7844] = 3267,
  [7845] = 7718,
  [7846] = 7730,
  [7847] = 7723,
  [7848] = 3109,
  [7849] = 3116,
  [7850] = 7144,
  [7851] = 7718,
  [7852] = 7852,
  [7853] = 7721,
  [7854] = 3332,
  [7855] = 7744,
  [7856] = 7856,
  [7857] = 7286,
  [7858] = 7299,
  [7859] = 3111,
  [7860] = 7714,
  [7861] = 7861,
  [7862] = 7103,
  [7863] = 7104,
  [7864] = 3268,
  [7865] = 7723,
  [7866] = 7866,
  [7867] = 7730,
  [7868] = 7091,
  [7869] = 7042,
  [7870] = 7105,
  [7871] = 7718,
  [7872] = 7032,
  [7873] = 7030,
  [7874] = 7010,
  [7875] = 7008,
  [7876] = 7036,
  [7877] = 7040,
  [7878] = 7075,
  [7879] = 7723,
  [7880] = 7744,
  [7881] = 3270,
  [7882] = 7882,
  [7883] = 7718,
  [7884] = 7884,
  [7885] = 7120,
  [7886] = 7117,
  [7887] = 3272,
  [7888] = 7106,
  [7889] = 7107,
  [7890] = 7714,
  [7891] = 3273,
  [7892] = 3274,
  [7893] = 7742,
  [7894] = 7894,
  [7895] = 7739,
  [7896] = 7108,
  [7897] = 7109,
  [7898] = 7120,
  [7899] = 7274,
  [7900] = 7117,
  [7901] = 7901,
  [7902] = 7264,
  [7903] = 7075,
  [7904] = 7904,
  [7905] = 7905,
  [7906] = 7906,
  [7907] = 7718,
  [7908] = 7169,
  [7909] = 7040,
  [7910] = 7042,
  [7911] = 7036,
  [7912] = 7008,
  [7913] = 7913,
  [7914] = 7010,
  [7915] = 7299,
  [7916] = 7030,
  [7917] = 7125,
  [7918] = 7169,
  [7919] = 7032,
  [7920] = 7920,
  [7921] = 7181,
  [7922] = 7922,
  [7923] = 7104,
  [7924] = 7106,
  [7925] = 7107,
  [7926] = 7108,
  [7927] = 119,
  [7928] = 7109,
  [7929] = 110,
  [7930] = 7299,
  [7931] = 117,
  [7932] = 109,
  [7933] = 115,
  [7934] = 7922,
  [7935] = 7935,
  [7936] = 7936,
  [7937] = 7105,
  [7938] = 7109,
  [7939] = 7108,
  [7940] = 116,
  [7941] = 7922,
  [7942] = 7107,
  [7943] = 7106,
  [7944] = 7105,
  [7945] = 7117,
  [7946] = 7103,
  [7947] = 108,
  [7948] = 7105,
  [7949] = 7106,
  [7950] = 7107,
  [7951] = 7108,
  [7952] = 7154,
  [7953] = 7144,
  [7954] = 7109,
  [7955] = 7922,
  [7956] = 7104,
  [7957] = 112,
  [7958] = 7958,
  [7959] = 7103,
  [7960] = 7621,
  [7961] = 7091,
  [7962] = 7922,
  [7963] = 7169,
  [7964] = 120,
  [7965] = 7299,
  [7966] = 7922,
  [7967] = 7154,
  [7968] = 7012,
  [7969] = 7969,
  [7970] = 7299,
  [7971] = 7922,
  [7972] = 7181,
  [7973] = 7105,
  [7974] = 7109,
  [7975] = 7125,
  [7976] = 7144,
  [7977] = 7977,
  [7978] = 7117,
  [7979] = 7075,
  [7980] = 105,
  [7981] = 7922,
  [7982] = 7982,
  [7983] = 7181,
  [7984] = 107,
  [7985] = 7985,
  [7986] = 7091,
  [7987] = 7103,
  [7988] = 7125,
  [7989] = 7104,
  [7990] = 7104,
  [7991] = 7169,
  [7992] = 114,
  [7993] = 7299,
  [7994] = 7075,
  [7995] = 7012,
  [7996] = 7040,
  [7997] = 7169,
  [7998] = 7181,
  [7999] = 7091,
  [8000] = 8000,
  [8001] = 7103,
  [8002] = 7572,
  [8003] = 7040,
  [8004] = 7922,
  [8005] = 8005,
  [8006] = 7922,
  [8007] = 7036,
  [8008] = 7299,
  [8009] = 7107,
  [8010] = 7008,
  [8011] = 7010,
  [8012] = 7106,
  [8013] = 113,
  [8014] = 7144,
  [8015] = 7030,
  [8016] = 7032,
  [8017] = 7036,
  [8018] = 7922,
  [8019] = 7008,
  [8020] = 106,
  [8021] = 7922,
  [8022] = 8022,
  [8023] = 7154,
  [8024] = 7010,
  [8025] = 7125,
  [8026] = 7042,
  [8027] = 7030,
  [8028] = 118,
  [8029] = 7108,
  [8030] = 7299,
  [8031] = 7032,
  [8032] = 7922,
  [8033] = 7042,
  [8034] = 7108,
  [8035] = 8035,
  [8036] = 7144,
  [8037] = 7040,
  [8038] = 7109,
  [8039] = 8035,
  [8040] = 8040,
  [8041] = 7103,
  [8042] = 7107,
  [8043] = 7144,
  [8044] = 7091,
  [8045] = 8040,
  [8046] = 8035,
  [8047] = 8047,
  [8048] = 7385,
  [8049] = 7106,
  [8050] = 8035,
  [8051] = 7091,
  [8052] = 2663,
  [8053] = 7169,
  [8054] = 7154,
  [8055] = 8040,
  [8056] = 7169,
  [8057] = 7255,
  [8058] = 7181,
  [8059] = 7125,
  [8060] = 7181,
  [8061] = 8035,
  [8062] = 7169,
  [8063] = 7030,
  [8064] = 8035,
  [8065] = 7012,
  [8066] = 8035,
  [8067] = 8035,
  [8068] = 8068,
  [8069] = 7120,
  [8070] = 8035,
  [8071] = 8035,
  [8072] = 7419,
  [8073] = 7105,
  [8074] = 7104,
  [8075] = 8035,
  [8076] = 8076,
  [8077] = 7125,
  [8078] = 8076,
  [8079] = 7107,
  [8080] = 7264,
  [8081] = 8076,
  [8082] = 8035,
  [8083] = 8047,
  [8084] = 7103,
  [8085] = 7125,
  [8086] = 8035,
  [8087] = 8076,
  [8088] = 7104,
  [8089] = 8035,
  [8090] = 8035,
  [8091] = 8040,
  [8092] = 8035,
  [8093] = 7299,
  [8094] = 8035,
  [8095] = 7105,
  [8096] = 232,
  [8097] = 7042,
  [8098] = 8035,
  [8099] = 7181,
  [8100] = 231,
  [8101] = 7106,
  [8102] = 8035,
  [8103] = 7154,
  [8104] = 8035,
  [8105] = 8047,
  [8106] = 8035,
  [8107] = 8035,
  [8108] = 7109,
  [8109] = 7274,
  [8110] = 7286,
  [8111] = 7144,
  [8112] = 8047,
  [8113] = 8035,
  [8114] = 8047,
  [8115] = 8035,
  [8116] = 8047,
  [8117] = 8035,
  [8118] = 7154,
  [8119] = 8035,
  [8120] = 8035,
  [8121] = 8121,
  [8122] = 8122,
  [8123] = 8122,
  [8124] = 7108,
  [8125] = 7120,
  [8126] = 8035,
  [8127] = 8035,
  [8128] = 7091,
  [8129] = 8122,
  [8130] = 7036,
  [8131] = 8122,
  [8132] = 8035,
  [8133] = 7075,
  [8134] = 8047,
  [8135] = 7008,
  [8136] = 7010,
  [8137] = 7299,
  [8138] = 7317,
  [8139] = 7032,
  [8140] = 7036,
  [8141] = 8141,
  [8142] = 8141,
  [8143] = 8143,
  [8144] = 7010,
  [8145] = 8145,
  [8146] = 8146,
  [8147] = 7012,
  [8148] = 7181,
  [8149] = 7012,
  [8150] = 3085,
  [8151] = 7274,
  [8152] = 8152,
  [8153] = 7453,
  [8154] = 7154,
  [8155] = 8155,
  [8156] = 7103,
  [8157] = 8152,
  [8158] = 8158,
  [8159] = 7104,
  [8160] = 7455,
  [8161] = 7120,
  [8162] = 7105,
  [8163] = 7106,
  [8164] = 8164,
  [8165] = 8165,
  [8166] = 7286,
  [8167] = 8167,
  [8168] = 7107,
  [8169] = 3094,
  [8170] = 3089,
  [8171] = 7264,
  [8172] = 7032,
  [8173] = 8173,
  [8174] = 8174,
  [8175] = 7108,
  [8176] = 7008,
  [8177] = 7042,
  [8178] = 8152,
  [8179] = 7125,
  [8180] = 8180,
  [8181] = 7317,
  [8182] = 7075,
  [8183] = 7181,
  [8184] = 8184,
  [8185] = 7255,
  [8186] = 8152,
  [8187] = 7012,
  [8188] = 7012,
  [8189] = 7012,
  [8190] = 3092,
  [8191] = 7109,
  [8192] = 8141,
  [8193] = 7075,
  [8194] = 7117,
  [8195] = 7125,
  [8196] = 7040,
  [8197] = 7008,
  [8198] = 7010,
  [8199] = 7030,
  [8200] = 7032,
  [8201] = 7040,
  [8202] = 7042,
  [8203] = 7169,
  [8204] = 7144,
  [8205] = 7385,
  [8206] = 7169,
  [8207] = 8152,
  [8208] = 8145,
  [8209] = 3097,
  [8210] = 7154,
  [8211] = 8145,
  [8212] = 7117,
  [8213] = 8213,
  [8214] = 7030,
  [8215] = 7091,
  [8216] = 8216,
  [8217] = 8152,
  [8218] = 7431,
  [8219] = 7036,
  [8220] = 8145,
  [8221] = 7091,
  [8222] = 7395,
  [8223] = 7400,
  [8224] = 8224,
  [8225] = 7144,
  [8226] = 3207,
  [8227] = 8146,
  [8228] = 8152,
  [8229] = 8141,
  [8230] = 7419,
  [8231] = 7181,
  [8232] = 8232,
  [8233] = 8233,
  [8234] = 8234,
  [8235] = 7109,
  [8236] = 8236,
  [8237] = 3097,
  [8238] = 8238,
  [8239] = 8239,
  [8240] = 8232,
  [8241] = 8232,
  [8242] = 8238,
  [8243] = 8232,
  [8244] = 8232,
  [8245] = 7091,
  [8246] = 7117,
  [8247] = 7075,
  [8248] = 7154,
  [8249] = 7040,
  [8250] = 3092,
  [8251] = 8232,
  [8252] = 8252,
  [8253] = 8232,
  [8254] = 8254,
  [8255] = 8252,
  [8256] = 3085,
  [8257] = 8232,
  [8258] = 7042,
  [8259] = 2628,
  [8260] = 7042,
  [8261] = 7030,
  [8262] = 8232,
  [8263] = 7103,
  [8264] = 7036,
  [8265] = 7032,
  [8266] = 7040,
  [8267] = 8232,
  [8268] = 7106,
  [8269] = 7125,
  [8270] = 7144,
  [8271] = 8232,
  [8272] = 2629,
  [8273] = 8232,
  [8274] = 7108,
  [8275] = 3119,
  [8276] = 8232,
  [8277] = 7032,
  [8278] = 8232,
  [8279] = 8279,
  [8280] = 7120,
  [8281] = 8232,
  [8282] = 8282,
  [8283] = 8236,
  [8284] = 3094,
  [8285] = 7144,
  [8286] = 7030,
  [8287] = 8232,
  [8288] = 8232,
  [8289] = 7010,
  [8290] = 8238,
  [8291] = 7008,
  [8292] = 8232,
  [8293] = 7091,
  [8294] = 8232,
  [8295] = 7299,
  [8296] = 7036,
  [8297] = 7117,
  [8298] = 8232,
  [8299] = 7169,
  [8300] = 7040,
  [8301] = 8232,
  [8302] = 7075,
  [8303] = 7181,
  [8304] = 7169,
  [8305] = 7030,
  [8306] = 8232,
  [8307] = 7032,
  [8308] = 8308,
  [8309] = 8232,
  [8310] = 7010,
  [8311] = 7091,
  [8312] = 7117,
  [8313] = 7104,
  [8314] = 7120,
  [8315] = 7109,
  [8316] = 7008,
  [8317] = 7144,
  [8318] = 7125,
  [8319] = 7154,
  [8320] = 7169,
  [8321] = 7120,
  [8322] = 7117,
  [8323] = 7120,
  [8324] = 7107,
  [8325] = 8232,
  [8326] = 8252,
  [8327] = 7075,
  [8328] = 8328,
  [8329] = 7105,
  [8330] = 2630,
  [8331] = 8331,
  [8332] = 7299,
  [8333] = 7108,
  [8334] = 8232,
  [8335] = 7125,
  [8336] = 7120,
  [8337] = 7036,
  [8338] = 7107,
  [8339] = 8308,
  [8340] = 8340,
  [8341] = 8308,
  [8342] = 8232,
  [8343] = 8343,
  [8344] = 7042,
  [8345] = 8236,
  [8346] = 7105,
  [8347] = 8238,
  [8348] = 7104,
  [8349] = 7008,
  [8350] = 3089,
  [8351] = 7010,
  [8352] = 7106,
  [8353] = 7181,
  [8354] = 7154,
  [8355] = 8252,
  [8356] = 3207,
  [8357] = 7103,
  [8358] = 8236,
  [8359] = 8308,
  [8360] = 8360,
  [8361] = 3119,
  [8362] = 7042,
  [8363] = 8363,
  [8364] = 8364,
  [8365] = 7154,
  [8366] = 8366,
  [8367] = 7169,
  [8368] = 8368,
  [8369] = 8369,
  [8370] = 8370,
  [8371] = 8364,
  [8372] = 8372,
  [8373] = 8373,
  [8374] = 7299,
  [8375] = 7181,
  [8376] = 8376,
  [8377] = 8377,
  [8378] = 7109,
  [8379] = 8379,
  [8380] = 8379,
  [8381] = 8373,
  [8382] = 8382,
  [8383] = 8366,
  [8384] = 8384,
  [8385] = 8360,
  [8386] = 8379,
  [8387] = 8372,
  [8388] = 8388,
  [8389] = 7299,
  [8390] = 7103,
  [8391] = 7032,
  [8392] = 8360,
  [8393] = 8360,
  [8394] = 7169,
  [8395] = 8395,
  [8396] = 8396,
  [8397] = 7075,
  [8398] = 8366,
  [8399] = 8399,
  [8400] = 8366,
  [8401] = 8401,
  [8402] = 8379,
  [8403] = 8403,
  [8404] = 8379,
  [8405] = 7075,
  [8406] = 8364,
  [8407] = 8379,
  [8408] = 8363,
  [8409] = 7108,
  [8410] = 8410,
  [8411] = 7032,
  [8412] = 8363,
  [8413] = 8364,
  [8414] = 7107,
  [8415] = 8415,
  [8416] = 7106,
  [8417] = 717,
  [8418] = 7040,
  [8419] = 8366,
  [8420] = 8379,
  [8421] = 8388,
  [8422] = 7040,
  [8423] = 8379,
  [8424] = 8364,
  [8425] = 7105,
  [8426] = 8370,
  [8427] = 7104,
  [8428] = 8428,
  [8429] = 7036,
  [8430] = 8430,
  [8431] = 7103,
  [8432] = 8366,
  [8433] = 3207,
  [8434] = 744,
  [8435] = 8363,
  [8436] = 8379,
  [8437] = 8382,
  [8438] = 7030,
  [8439] = 7709,
  [8440] = 8440,
  [8441] = 8379,
  [8442] = 8442,
  [8443] = 8369,
  [8444] = 8379,
  [8445] = 8370,
  [8446] = 7008,
  [8447] = 8379,
  [8448] = 7109,
  [8449] = 7010,
  [8450] = 8382,
  [8451] = 7125,
  [8452] = 8379,
  [8453] = 7042,
  [8454] = 8379,
  [8455] = 8379,
  [8456] = 8388,
  [8457] = 7104,
  [8458] = 8373,
  [8459] = 8382,
  [8460] = 7125,
  [8461] = 8379,
  [8462] = 7108,
  [8463] = 8395,
  [8464] = 8396,
  [8465] = 7107,
  [8466] = 7036,
  [8467] = 8364,
  [8468] = 7181,
  [8469] = 8469,
  [8470] = 8470,
  [8471] = 8382,
  [8472] = 8430,
  [8473] = 8360,
  [8474] = 7103,
  [8475] = 8379,
  [8476] = 8379,
  [8477] = 8379,
  [8478] = 8379,
  [8479] = 7091,
  [8480] = 8364,
  [8481] = 7091,
  [8482] = 7117,
  [8483] = 7010,
  [8484] = 3207,
  [8485] = 8485,
  [8486] = 8379,
  [8487] = 7104,
  [8488] = 7105,
  [8489] = 7106,
  [8490] = 7106,
  [8491] = 8379,
  [8492] = 7299,
  [8493] = 7707,
  [8494] = 8379,
  [8495] = 7008,
  [8496] = 8496,
  [8497] = 7107,
  [8498] = 8410,
  [8499] = 7144,
  [8500] = 7144,
  [8501] = 7108,
  [8502] = 8379,
  [8503] = 8382,
  [8504] = 8504,
  [8505] = 8505,
  [8506] = 8382,
  [8507] = 7117,
  [8508] = 8366,
  [8509] = 8372,
  [8510] = 8395,
  [8511] = 8511,
  [8512] = 7618,
  [8513] = 8369,
  [8514] = 8430,
  [8515] = 7105,
  [8516] = 8360,
  [8517] = 7030,
  [8518] = 8379,
  [8519] = 7154,
  [8520] = 8360,
  [8521] = 8521,
  [8522] = 7299,
  [8523] = 8379,
  [8524] = 7109,
  [8525] = 8396,
  [8526] = 8526,
  [8527] = 8527,
  [8528] = 7104,
  [8529] = 8529,
  [8530] = 8530,
  [8531] = 8531,
  [8532] = 8532,
  [8533] = 7105,
  [8534] = 7103,
  [8535] = 3179,
  [8536] = 8536,
  [8537] = 8537,
  [8538] = 8538,
  [8539] = 8539,
  [8540] = 8540,
  [8541] = 8541,
  [8542] = 8527,
  [8543] = 8543,
  [8544] = 8544,
  [8545] = 8543,
  [8546] = 8546,
  [8547] = 8547,
  [8548] = 8548,
  [8549] = 8529,
  [8550] = 7299,
  [8551] = 7109,
  [8552] = 8539,
  [8553] = 8553,
  [8554] = 8539,
  [8555] = 8532,
  [8556] = 7105,
  [8557] = 8557,
  [8558] = 8530,
  [8559] = 8532,
  [8560] = 8560,
  [8561] = 7108,
  [8562] = 8532,
  [8563] = 8532,
  [8564] = 8532,
  [8565] = 8543,
  [8566] = 8543,
  [8567] = 8567,
  [8568] = 8548,
  [8569] = 8527,
  [8570] = 8546,
  [8571] = 3207,
  [8572] = 8543,
  [8573] = 8537,
  [8574] = 8547,
  [8575] = 8548,
  [8576] = 8546,
  [8577] = 8530,
  [8578] = 8578,
  [8579] = 8530,
  [8580] = 8578,
  [8581] = 8544,
  [8582] = 8557,
  [8583] = 8578,
  [8584] = 8529,
  [8585] = 8532,
  [8586] = 8532,
  [8587] = 3207,
  [8588] = 7106,
  [8589] = 7107,
  [8590] = 8590,
  [8591] = 7108,
  [8592] = 8557,
  [8593] = 8593,
  [8594] = 7106,
  [8595] = 7107,
  [8596] = 7103,
  [8597] = 8537,
  [8598] = 7109,
  [8599] = 7299,
  [8600] = 8532,
  [8601] = 8601,
  [8602] = 7104,
  [8603] = 8603,
  [8604] = 8604,
  [8605] = 8605,
  [8606] = 8606,
  [8607] = 8607,
  [8608] = 8608,
  [8609] = 8609,
  [8610] = 8610,
  [8611] = 8611,
  [8612] = 8612,
  [8613] = 8613,
  [8614] = 8614,
  [8615] = 8606,
  [8616] = 8616,
  [8617] = 8617,
  [8618] = 8618,
  [8619] = 8619,
  [8620] = 8620,
  [8621] = 8621,
  [8622] = 8614,
  [8623] = 8603,
  [8624] = 8624,
  [8625] = 8625,
  [8626] = 8626,
  [8627] = 8625,
  [8628] = 8617,
  [8629] = 8629,
  [8630] = 8613,
  [8631] = 8631,
  [8632] = 8620,
  [8633] = 8633,
  [8634] = 8625,
  [8635] = 8610,
  [8636] = 8636,
  [8637] = 8606,
  [8638] = 8638,
  [8639] = 8639,
  [8640] = 8608,
  [8641] = 8610,
  [8642] = 8642,
  [8643] = 8608,
  [8644] = 8644,
  [8645] = 8616,
  [8646] = 8617,
  [8647] = 8605,
  [8648] = 8613,
  [8649] = 8607,
  [8650] = 8624,
  [8651] = 8610,
  [8652] = 8621,
  [8653] = 8653,
  [8654] = 8654,
  [8655] = 8629,
  [8656] = 8653,
  [8657] = 8629,
  [8658] = 8625,
  [8659] = 8614,
  [8660] = 8614,
  [8661] = 8661,
  [8662] = 8633,
  [8663] = 8663,
  [8664] = 8603,
  [8665] = 8618,
  [8666] = 8614,
  [8667] = 8667,
  [8668] = 8625,
  [8669] = 8612,
  [8670] = 8609,
  [8671] = 8671,
  [8672] = 8672,
  [8673] = 8624,
  [8674] = 8674,
  [8675] = 8675,
  [8676] = 8642,
  [8677] = 8606,
  [8678] = 8606,
  [8679] = 8679,
  [8680] = 8617,
  [8681] = 8681,
  [8682] = 8610,
  [8683] = 8613,
  [8684] = 8629,
  [8685] = 8624,
  [8686] = 8608,
  [8687] = 8606,
  [8688] = 8613,
  [8689] = 8610,
  [8690] = 8690,
  [8691] = 8621,
  [8692] = 8692,
  [8693] = 8631,
  [8694] = 8609,
  [8695] = 8612,
  [8696] = 8614,
  [8697] = 8653,
  [8698] = 8698,
  [8699] = 8618,
  [8700] = 8614,
  [8701] = 8603,
  [8702] = 8619,
  [8703] = 8621,
  [8704] = 8610,
  [8705] = 8631,
  [8706] = 8706,
  [8707] = 8606,
  [8708] = 8625,
  [8709] = 8709,
  [8710] = 8626,
  [8711] = 8633,
  [8712] = 8631,
  [8713] = 8620,
  [8714] = 8625,
  [8715] = 8636,
  [8716] = 8636,
  [8717] = 8606,
  [8718] = 8718,
  [8719] = 8719,
  [8720] = 8642,
  [8721] = 8610,
  [8722] = 8616,
  [8723] = 8723,
  [8724] = 8607,
  [8725] = 8725,
  [8726] = 8661,
  [8727] = 8621,
  [8728] = 8621,
  [8729] = 8617,
  [8730] = 8653,
  [8731] = 8613,
  [8732] = 8653,
  [8733] = 8633,
  [8734] = 8603,
  [8735] = 8621,
  [8736] = 8614,
  [8737] = 8618,
  [8738] = 8738,
  [8739] = 8631,
  [8740] = 8740,
  [8741] = 8612,
  [8742] = 8625,
  [8743] = 8609,
  [8744] = 8633,
  [8745] = 8738,
  [8746] = 8606,
  [8747] = 8617,
  [8748] = 8748,
  [8749] = 8749,
  [8750] = 8629,
  [8751] = 8606,
  [8752] = 8624,
  [8753] = 8608,
  [8754] = 8625,
  [8755] = 8610,
  [8756] = 8621,
  [8757] = 8757,
  [8758] = 8758,
  [8759] = 8620,
  [8760] = 8760,
  [8761] = 8761,
  [8762] = 8610,
  [8763] = 8619,
  [8764] = 8607,
  [8765] = 8631,
  [8766] = 8614,
  [8767] = 8767,
  [8768] = 8614,
  [8769] = 8614,
  [8770] = 8605,
  [8771] = 8614,
  [8772] = 8625,
  [8773] = 8619,
  [8774] = 8616,
  [8775] = 8619,
  [8776] = 8621,
  [8777] = 8614,
  [8778] = 8778,
  [8779] = 8631,
  [8780] = 8607,
  [8781] = 8606,
  [8782] = 8605,
  [8783] = 8620,
  [8784] = 8610,
  [8785] = 8625,
  [8786] = 8631,
  [8787] = 8636,
  [8788] = 8620,
  [8789] = 8642,
  [8790] = 8790,
  [8791] = 8626,
  [8792] = 8616,
  [8793] = 8661,
  [8794] = 8616,
  [8795] = 8626,
  [8796] = 8738,
  [8797] = 8614,
  [8798] = 8798,
  [8799] = 8661,
  [8800] = 8625,
  [8801] = 7419,
  [8802] = 8738,
  [8803] = 8621,
  [8804] = 8631,
  [8805] = 8653,
  [8806] = 8619,
  [8807] = 8620,
  [8808] = 8606,
  [8809] = 8625,
  [8810] = 8633,
  [8811] = 8610,
  [8812] = 8812,
  [8813] = 8618,
  [8814] = 8606,
  [8815] = 8636,
  [8816] = 8738,
  [8817] = 8661,
  [8818] = 8629,
  [8819] = 8642,
  [8820] = 8624,
  [8821] = 8620,
  [8822] = 8610,
  [8823] = 8616,
  [8824] = 8812,
  [8825] = 8825,
  [8826] = 8610,
  [8827] = 8642,
  [8828] = 8661,
  [8829] = 8605,
  [8830] = 8607,
  [8831] = 8606,
  [8832] = 8621,
  [8833] = 8833,
  [8834] = 8610,
  [8835] = 8636,
  [8836] = 8812,
  [8837] = 8614,
  [8838] = 8738,
  [8839] = 8625,
  [8840] = 8661,
  [8841] = 8620,
  [8842] = 8631,
  [8843] = 8620,
  [8844] = 8625,
  [8845] = 8653,
  [8846] = 8610,
  [8847] = 8636,
  [8848] = 8642,
  [8849] = 8606,
  [8850] = 8616,
  [8851] = 8625,
  [8852] = 8621,
  [8853] = 8606,
  [8854] = 8631,
  [8855] = 8633,
  [8856] = 8610,
  [8857] = 8603,
  [8858] = 8618,
  [8859] = 8859,
  [8860] = 8642,
  [8861] = 8606,
  [8862] = 8629,
  [8863] = 8624,
  [8864] = 8610,
  [8865] = 8812,
  [8866] = 8738,
  [8867] = 8626,
  [8868] = 8661,
  [8869] = 8869,
  [8870] = 8614,
  [8871] = 8633,
  [8872] = 8631,
  [8873] = 8621,
  [8874] = 8620,
  [8875] = 8606,
  [8876] = 8625,
  [8877] = 8636,
  [8878] = 8610,
  [8879] = 8642,
  [8880] = 8616,
  [8881] = 8626,
  [8882] = 8631,
  [8883] = 8738,
  [8884] = 8606,
  [8885] = 8621,
  [8886] = 8603,
  [8887] = 8618,
  [8888] = 8888,
  [8889] = 8612,
  [8890] = 8609,
  [8891] = 8633,
  [8892] = 8603,
  [8893] = 8618,
  [8894] = 8606,
  [8895] = 8610,
  [8896] = 8629,
  [8897] = 8606,
  [8898] = 8624,
  [8899] = 8610,
  [8900] = 8610,
  [8901] = 8617,
  [8902] = 8636,
  [8903] = 8614,
  [8904] = 8625,
  [8905] = 8605,
  [8906] = 8906,
  [8907] = 8738,
  [8908] = 8661,
  [8909] = 8625,
  [8910] = 8606,
  [8911] = 8603,
  [8912] = 8614,
  [8913] = 8612,
  [8914] = 8618,
  [8915] = 8631,
  [8916] = 8916,
  [8917] = 8917,
  [8918] = 8918,
  [8919] = 8606,
  [8920] = 8613,
  [8921] = 8631,
  [8922] = 8610,
  [8923] = 8620,
  [8924] = 8619,
  [8925] = 8642,
  [8926] = 8609,
  [8927] = 8629,
  [8928] = 8621,
  [8929] = 8633,
  [8930] = 8606,
  [8931] = 8629,
  [8932] = 8610,
  [8933] = 8606,
  [8934] = 8608,
  [8935] = 8606,
  [8936] = 8610,
  [8937] = 8610,
  [8938] = 8624,
  [8939] = 8614,
  [8940] = 8940,
  [8941] = 8941,
  [8942] = 8942,
  [8943] = 8943,
  [8944] = 8944,
  [8945] = 8945,
  [8946] = 8946,
  [8947] = 8941,
  [8948] = 8944,
  [8949] = 8949,
  [8950] = 8950,
  [8951] = 8951,
  [8952] = 8952,
  [8953] = 8953,
  [8954] = 8954,
  [8955] = 8955,
  [8956] = 8956,
  [8957] = 8949,
  [8958] = 8958,
  [8959] = 8959,
  [8960] = 8960,
  [8961] = 8961,
  [8962] = 8959,
  [8963] = 8946,
  [8964] = 8958,
  [8965] = 8941,
  [8966] = 8944,
  [8967] = 8949,
  [8968] = 8950,
  [8969] = 8951,
  [8970] = 8952,
  [8971] = 8956,
  [8972] = 8953,
  [8973] = 8954,
  [8974] = 8955,
  [8975] = 8956,
  [8976] = 8976,
  [8977] = 8958,
  [8978] = 8959,
  [8979] = 8955,
  [8980] = 8954,
  [8981] = 8953,
  [8982] = 8952,
  [8983] = 8951,
  [8984] = 8945,
  [8985] = 8950,
  [8986] = 8986,
  [8987] = 8987,
  [8988] = 8988,
  [8989] = 8989,
  [8990] = 8941,
  [8991] = 8959,
  [8992] = 8958,
  [8993] = 8976,
  [8994] = 8949,
  [8995] = 8995,
  [8996] = 8944,
  [8997] = 8976,
  [8998] = 8998,
  [8999] = 8999,
  [9000] = 8941,
  [9001] = 8943,
  [9002] = 9002,
  [9003] = 9003,
  [9004] = 9004,
  [9005] = 8956,
  [9006] = 9006,
  [9007] = 8946,
  [9008] = 8951,
  [9009] = 8976,
  [9010] = 9010,
  [9011] = 9011,
  [9012] = 8955,
  [9013] = 8143,
  [9014] = 280,
  [9015] = 8954,
  [9016] = 8950,
  [9017] = 8951,
  [9018] = 8952,
  [9019] = 9019,
  [9020] = 8976,
  [9021] = 8953,
  [9022] = 9022,
  [9023] = 8956,
  [9024] = 9024,
  [9025] = 9004,
  [9026] = 9026,
  [9027] = 8953,
  [9028] = 9028,
  [9029] = 8941,
  [9030] = 9030,
  [9031] = 9030,
  [9032] = 9032,
  [9033] = 9033,
  [9034] = 9034,
  [9035] = 8954,
  [9036] = 8955,
  [9037] = 8952,
  [9038] = 9038,
  [9039] = 8951,
  [9040] = 8944,
  [9041] = 8950,
  [9042] = 9028,
  [9043] = 8949,
  [9044] = 8944,
  [9045] = 8949,
  [9046] = 8950,
  [9047] = 8955,
  [9048] = 3207,
  [9049] = 8954,
  [9050] = 8953,
  [9051] = 9051,
  [9052] = 8976,
  [9053] = 8946,
  [9054] = 9054,
  [9055] = 9055,
  [9056] = 9022,
  [9057] = 9057,
  [9058] = 8956,
  [9059] = 9019,
  [9060] = 9060,
  [9061] = 8949,
  [9062] = 9024,
  [9063] = 8941,
  [9064] = 8944,
  [9065] = 8959,
  [9066] = 8941,
  [9067] = 8958,
  [9068] = 8956,
  [9069] = 8959,
  [9070] = 9024,
  [9071] = 9022,
  [9072] = 8955,
  [9073] = 8954,
  [9074] = 8958,
  [9075] = 8953,
  [9076] = 8952,
  [9077] = 8951,
  [9078] = 8958,
  [9079] = 9079,
  [9080] = 8956,
  [9081] = 8958,
  [9082] = 8959,
  [9083] = 8955,
  [9084] = 8954,
  [9085] = 8953,
  [9086] = 9086,
  [9087] = 9087,
  [9088] = 8952,
  [9089] = 9089,
  [9090] = 8953,
  [9091] = 8952,
  [9092] = 8951,
  [9093] = 8950,
  [9094] = 8950,
  [9095] = 8949,
  [9096] = 8944,
  [9097] = 8976,
  [9098] = 8949,
  [9099] = 9099,
  [9100] = 9100,
  [9101] = 8944,
  [9102] = 8941,
  [9103] = 8941,
  [9104] = 9104,
  [9105] = 8999,
  [9106] = 9038,
  [9107] = 9033,
  [9108] = 8946,
  [9109] = 9032,
  [9110] = 9110,
  [9111] = 9019,
  [9112] = 9086,
  [9113] = 9113,
  [9114] = 8945,
  [9115] = 9115,
  [9116] = 9089,
  [9117] = 8943,
  [9118] = 9086,
  [9119] = 9119,
  [9120] = 9120,
  [9121] = 9121,
  [9122] = 9019,
  [9123] = 9123,
  [9124] = 9087,
  [9125] = 8955,
  [9126] = 9126,
  [9127] = 9028,
  [9128] = 9128,
  [9129] = 8941,
  [9130] = 9030,
  [9131] = 8998,
  [9132] = 8959,
  [9133] = 8946,
  [9134] = 9134,
  [9135] = 9135,
  [9136] = 9087,
  [9137] = 8958,
  [9138] = 8976,
  [9139] = 9019,
  [9140] = 9140,
  [9141] = 8946,
  [9142] = 8956,
  [9143] = 8955,
  [9144] = 8954,
  [9145] = 8956,
  [9146] = 9002,
  [9147] = 8953,
  [9148] = 8952,
  [9149] = 8998,
  [9150] = 9019,
  [9151] = 8951,
  [9152] = 9099,
  [9153] = 9153,
  [9154] = 8950,
  [9155] = 8944,
  [9156] = 8952,
  [9157] = 8951,
  [9158] = 8949,
  [9159] = 8949,
  [9160] = 9160,
  [9161] = 8944,
  [9162] = 8950,
  [9163] = 8941,
  [9164] = 9089,
  [9165] = 8941,
  [9166] = 8958,
  [9167] = 9051,
  [9168] = 8946,
  [9169] = 8944,
  [9170] = 8949,
  [9171] = 8942,
  [9172] = 9099,
  [9173] = 9089,
  [9174] = 8953,
  [9175] = 9175,
  [9176] = 8946,
  [9177] = 8959,
  [9178] = 9089,
  [9179] = 8959,
  [9180] = 8958,
  [9181] = 8956,
  [9182] = 8955,
  [9183] = 8954,
  [9184] = 8958,
  [9185] = 8953,
  [9186] = 9086,
  [9187] = 9087,
  [9188] = 8952,
  [9189] = 8951,
  [9190] = 9190,
  [9191] = 9191,
  [9192] = 8950,
  [9193] = 8960,
  [9194] = 8956,
  [9195] = 8955,
  [9196] = 9196,
  [9197] = 8946,
  [9198] = 8949,
  [9199] = 8944,
  [9200] = 8954,
  [9201] = 8951,
  [9202] = 9019,
  [9203] = 9060,
  [9204] = 8950,
  [9205] = 8951,
  [9206] = 8941,
  [9207] = 9019,
  [9208] = 9208,
  [9209] = 8952,
  [9210] = 8951,
  [9211] = 8950,
  [9212] = 8949,
  [9213] = 8952,
  [9214] = 9120,
  [9215] = 9121,
  [9216] = 9123,
  [9217] = 9217,
  [9218] = 9087,
  [9219] = 8946,
  [9220] = 8960,
  [9221] = 8953,
  [9222] = 8944,
  [9223] = 9223,
  [9224] = 9224,
  [9225] = 8941,
  [9226] = 9002,
  [9227] = 9100,
  [9228] = 8941,
  [9229] = 8988,
  [9230] = 9230,
  [9231] = 9019,
  [9232] = 9232,
  [9233] = 8946,
  [9234] = 9120,
  [9235] = 9121,
  [9236] = 9123,
  [9237] = 9237,
  [9238] = 9099,
  [9239] = 8954,
  [9240] = 8944,
  [9241] = 9024,
  [9242] = 8949,
  [9243] = 9243,
  [9244] = 9002,
  [9245] = 9153,
  [9246] = 8959,
  [9247] = 8958,
  [9248] = 9248,
  [9249] = 8942,
  [9250] = 9250,
  [9251] = 9251,
  [9252] = 9089,
  [9253] = 9253,
  [9254] = 8956,
  [9255] = 8955,
  [9256] = 8946,
  [9257] = 8955,
  [9258] = 8954,
  [9259] = 9054,
  [9260] = 8953,
  [9261] = 9051,
  [9262] = 9153,
  [9263] = 8952,
  [9264] = 9160,
  [9265] = 9028,
  [9266] = 9153,
  [9267] = 8951,
  [9268] = 8956,
  [9269] = 9099,
  [9270] = 8950,
  [9271] = 9191,
  [9272] = 8959,
  [9273] = 8958,
  [9274] = 9054,
  [9275] = 8942,
  [9276] = 8949,
  [9277] = 9051,
  [9278] = 9278,
  [9279] = 8956,
  [9280] = 9004,
  [9281] = 9281,
  [9282] = 8958,
  [9283] = 9006,
  [9284] = 9284,
  [9285] = 8955,
  [9286] = 8950,
  [9287] = 8954,
  [9288] = 8995,
  [9289] = 9289,
  [9290] = 8944,
  [9291] = 8959,
  [9292] = 8953,
  [9293] = 8950,
  [9294] = 9057,
  [9295] = 8946,
  [9296] = 9086,
  [9297] = 9087,
  [9298] = 9248,
  [9299] = 8952,
  [9300] = 9002,
  [9301] = 8951,
  [9302] = 9006,
  [9303] = 9019,
  [9304] = 8952,
  [9305] = 8950,
  [9306] = 8976,
  [9307] = 8951,
  [9308] = 9051,
  [9309] = 9309,
  [9310] = 9310,
  [9311] = 8959,
  [9312] = 8942,
  [9313] = 9019,
  [9314] = 8960,
  [9315] = 8952,
  [9316] = 9060,
  [9317] = 8958,
  [9318] = 9019,
  [9319] = 8950,
  [9320] = 9320,
  [9321] = 9321,
  [9322] = 8956,
  [9323] = 9087,
  [9324] = 9324,
  [9325] = 9033,
  [9326] = 8955,
  [9327] = 8954,
  [9328] = 8959,
  [9329] = 9086,
  [9330] = 8949,
  [9331] = 9099,
  [9332] = 9135,
  [9333] = 8944,
  [9334] = 8953,
  [9335] = 9160,
  [9336] = 8951,
  [9337] = 8946,
  [9338] = 8946,
  [9339] = 8941,
  [9340] = 9024,
  [9341] = 9022,
  [9342] = 9342,
  [9343] = 9057,
  [9344] = 9030,
  [9345] = 9345,
  [9346] = 8952,
  [9347] = 9248,
  [9348] = 9123,
  [9349] = 8951,
  [9350] = 8950,
  [9351] = 9196,
  [9352] = 9121,
  [9353] = 9120,
  [9354] = 9153,
  [9355] = 9120,
  [9356] = 9356,
  [9357] = 9121,
  [9358] = 9123,
  [9359] = 9359,
  [9360] = 8949,
  [9361] = 8944,
  [9362] = 8941,
  [9363] = 8953,
  [9364] = 8976,
  [9365] = 9253,
  [9366] = 8999,
  [9367] = 9196,
  [9368] = 8946,
  [9369] = 9033,
  [9370] = 8946,
  [9371] = 9038,
  [9372] = 9160,
  [9373] = 9373,
  [9374] = 9196,
  [9375] = 8954,
  [9376] = 8954,
  [9377] = 9377,
  [9378] = 8952,
  [9379] = 9140,
  [9380] = 9019,
  [9381] = 8955,
  [9382] = 9382,
  [9383] = 9089,
  [9384] = 9019,
  [9385] = 8956,
  [9386] = 9248,
  [9387] = 9002,
  [9388] = 9388,
  [9389] = 8958,
  [9390] = 8959,
  [9391] = 8958,
  [9392] = 8959,
  [9393] = 9002,
  [9394] = 8956,
  [9395] = 9395,
  [9396] = 9060,
  [9397] = 9019,
  [9398] = 8955,
  [9399] = 8954,
  [9400] = 8945,
  [9401] = 8959,
  [9402] = 9099,
  [9403] = 9403,
  [9404] = 9019,
  [9405] = 9022,
  [9406] = 8953,
  [9407] = 9407,
  [9408] = 9408,
  [9409] = 9153,
  [9410] = 8952,
  [9411] = 9024,
  [9412] = 8951,
  [9413] = 8950,
  [9414] = 9248,
  [9415] = 8949,
  [9416] = 8944,
  [9417] = 8946,
  [9418] = 9057,
  [9419] = 8941,
  [9420] = 8959,
  [9421] = 8951,
  [9422] = 8946,
  [9423] = 9054,
  [9424] = 8958,
  [9425] = 9089,
  [9426] = 9426,
  [9427] = 9253,
  [9428] = 8995,
  [9429] = 8959,
  [9430] = 8941,
  [9431] = 8953,
  [9432] = 9432,
  [9433] = 9123,
  [9434] = 8941,
  [9435] = 9019,
  [9436] = 9002,
  [9437] = 9019,
  [9438] = 9121,
  [9439] = 9248,
  [9440] = 8958,
  [9441] = 8956,
  [9442] = 9442,
  [9443] = 9004,
  [9444] = 8959,
  [9445] = 8944,
  [9446] = 8958,
  [9447] = 8954,
  [9448] = 8955,
  [9449] = 9449,
  [9450] = 9230,
  [9451] = 8949,
  [9452] = 9452,
  [9453] = 8944,
  [9454] = 9120,
  [9455] = 9006,
  [9456] = 8956,
  [9457] = 8959,
  [9458] = 9135,
  [9459] = 8958,
  [9460] = 8988,
  [9461] = 8950,
  [9462] = 8956,
  [9463] = 9004,
  [9464] = 8988,
  [9465] = 8949,
  [9466] = 9466,
  [9467] = 8955,
  [9468] = 8954,
  [9469] = 8953,
  [9470] = 8995,
  [9471] = 9054,
  [9472] = 9057,
  [9473] = 9473,
  [9474] = 9060,
  [9475] = 9230,
  [9476] = 9086,
  [9477] = 9087,
  [9478] = 8956,
  [9479] = 9006,
  [9480] = 8952,
  [9481] = 8951,
  [9482] = 9028,
  [9483] = 9483,
  [9484] = 8950,
  [9485] = 9033,
  [9486] = 8955,
  [9487] = 8954,
  [9488] = 8953,
  [9489] = 9051,
  [9490] = 8942,
  [9491] = 9491,
  [9492] = 9492,
  [9493] = 8952,
  [9494] = 8951,
  [9495] = 8949,
  [9496] = 8952,
  [9497] = 8944,
  [9498] = 8950,
  [9499] = 9120,
  [9500] = 8960,
  [9501] = 9501,
  [9502] = 9502,
  [9503] = 8949,
  [9504] = 8959,
  [9505] = 8944,
  [9506] = 8960,
  [9507] = 9033,
  [9508] = 8941,
  [9509] = 9509,
  [9510] = 9019,
  [9511] = 9121,
  [9512] = 9160,
  [9513] = 9123,
  [9514] = 8953,
  [9515] = 8988,
  [9516] = 8954,
  [9517] = 8976,
  [9518] = 8955,
  [9519] = 8946,
  [9520] = 8976,
  [9521] = 8949,
  [9522] = 8988,
  [9523] = 8944,
  [9524] = 9004,
  [9525] = 8941,
  [9526] = 9086,
  [9527] = 8956,
  [9528] = 9024,
  [9529] = 8958,
  [9530] = 9022,
  [9531] = 8941,
  [9532] = 9028,
  [9533] = 8945,
  [9534] = 8942,
  [9535] = 9019,
  [9536] = 9051,
  [9537] = 8956,
  [9538] = 8950,
  [9539] = 8951,
  [9540] = 8952,
  [9541] = 9030,
  [9542] = 9542,
  [9543] = 9543,
  [9544] = 9030,
  [9545] = 8946,
  [9546] = 9057,
  [9547] = 9087,
  [9548] = 9086,
  [9549] = 9038,
  [9550] = 9057,
  [9551] = 9054,
  [9552] = 9552,
  [9553] = 9028,
  [9554] = 8958,
  [9555] = 9196,
  [9556] = 9253,
  [9557] = 9135,
  [9558] = 9060,
  [9559] = 9120,
  [9560] = 9121,
  [9561] = 9123,
  [9562] = 8953,
  [9563] = 9563,
  [9564] = 8954,
  [9565] = 8959,
  [9566] = 8955,
  [9567] = 8956,
  [9568] = 9135,
  [9569] = 8946,
  [9570] = 9160,
  [9571] = 8955,
  [9572] = 8959,
  [9573] = 9573,
  [9574] = 9022,
  [9575] = 8958,
  [9576] = 8955,
  [9577] = 9004,
  [9578] = 8955,
  [9579] = 9191,
  [9580] = 8956,
  [9581] = 9123,
  [9582] = 8958,
  [9583] = 8954,
  [9584] = 9006,
  [9585] = 9121,
  [9586] = 9586,
  [9587] = 8954,
  [9588] = 8953,
  [9589] = 9120,
  [9590] = 9135,
  [9591] = 8946,
  [9592] = 8944,
  [9593] = 8943,
  [9594] = 9248,
  [9595] = 9002,
  [9596] = 8949,
  [9597] = 8952,
  [9598] = 9598,
  [9599] = 8951,
  [9600] = 9230,
  [9601] = 8953,
  [9602] = 9602,
  [9603] = 283,
  [9604] = 9604,
  [9605] = 284,
  [9606] = 9019,
  [9607] = 8960,
  [9608] = 8950,
  [9609] = 9140,
  [9610] = 8945,
  [9611] = 9611,
  [9612] = 9612,
  [9613] = 9032,
  [9614] = 8950,
  [9615] = 9099,
  [9616] = 8949,
  [9617] = 9617,
  [9618] = 8944,
  [9619] = 9160,
  [9620] = 9196,
  [9621] = 9621,
  [9622] = 8946,
  [9623] = 8941,
  [9624] = 8951,
  [9625] = 9196,
  [9626] = 9237,
  [9627] = 9153,
  [9628] = 9153,
  [9629] = 9030,
  [9630] = 9630,
  [9631] = 9033,
  [9632] = 8946,
  [9633] = 8952,
  [9634] = 8953,
  [9635] = 8959,
  [9636] = 8941,
  [9637] = 9099,
  [9638] = 9089,
  [9639] = 9054,
  [9640] = 8954,
  [9641] = 9019,
  [9642] = 9642,
  [9643] = 9643,
  [9644] = 3250,
  [9645] = 3259,
  [9646] = 9646,
  [9647] = 9647,
  [9648] = 9648,
  [9649] = 9649,
  [9650] = 9650,
  [9651] = 9651,
  [9652] = 9652,
  [9653] = 9653,
  [9654] = 9654,
  [9655] = 3310,
  [9656] = 9643,
  [9657] = 9654,
  [9658] = 3312,
  [9659] = 9659,
  [9660] = 9660,
  [9661] = 9661,
  [9662] = 9662,
  [9663] = 9663,
  [9664] = 9647,
  [9665] = 9665,
  [9666] = 9660,
  [9667] = 9642,
  [9668] = 9668,
  [9669] = 9669,
  [9670] = 9670,
  [9671] = 9661,
  [9672] = 9669,
  [9673] = 9673,
  [9674] = 9674,
  [9675] = 9675,
  [9676] = 9676,
  [9677] = 9677,
  [9678] = 9678,
  [9679] = 9679,
  [9680] = 9652,
  [9681] = 9642,
  [9682] = 9682,
  [9683] = 9661,
  [9684] = 9684,
  [9685] = 3328,
  [9686] = 9686,
  [9687] = 9687,
  [9688] = 9686,
  [9689] = 9668,
  [9690] = 9642,
  [9691] = 9691,
  [9692] = 9692,
  [9693] = 9642,
  [9694] = 9668,
  [9695] = 9660,
  [9696] = 9660,
  [9697] = 3253,
  [9698] = 9698,
  [9699] = 9699,
  [9700] = 9673,
  [9701] = 3252,
  [9702] = 9702,
  [9703] = 9668,
  [9704] = 9674,
  [9705] = 9642,
  [9706] = 9669,
  [9707] = 9686,
  [9708] = 9675,
  [9709] = 9709,
  [9710] = 9659,
  [9711] = 9650,
  [9712] = 9670,
  [9713] = 9713,
  [9714] = 9676,
  [9715] = 9668,
  [9716] = 9677,
  [9717] = 9652,
  [9718] = 9661,
  [9719] = 9669,
  [9720] = 9720,
  [9721] = 9647,
  [9722] = 9647,
  [9723] = 9723,
  [9724] = 9724,
  [9725] = 9725,
  [9726] = 9653,
  [9727] = 9725,
  [9728] = 9728,
  [9729] = 9724,
  [9730] = 9730,
  [9731] = 9731,
  [9732] = 9732,
  [9733] = 9723,
  [9734] = 9678,
  [9735] = 9735,
  [9736] = 9720,
  [9737] = 9646,
  [9738] = 9668,
  [9739] = 9713,
  [9740] = 9670,
  [9741] = 9660,
  [9742] = 9659,
  [9743] = 9709,
  [9744] = 9735,
  [9745] = 9732,
  [9746] = 9731,
  [9747] = 9730,
  [9748] = 9728,
  [9749] = 9749,
  [9750] = 9661,
  [9751] = 9660,
  [9752] = 9647,
  [9753] = 9662,
  [9754] = 9686,
  [9755] = 9678,
  [9756] = 9756,
  [9757] = 9674,
  [9758] = 9728,
  [9759] = 9759,
  [9760] = 9662,
  [9761] = 9725,
  [9762] = 9647,
  [9763] = 9698,
  [9764] = 9669,
  [9765] = 9765,
  [9766] = 9678,
  [9767] = 9725,
  [9768] = 9687,
  [9769] = 9691,
  [9770] = 9765,
  [9771] = 9771,
  [9772] = 9669,
  [9773] = 9669,
  [9774] = 9661,
  [9775] = 9668,
  [9776] = 9673,
  [9777] = 9642,
  [9778] = 9647,
  [9779] = 9669,
  [9780] = 9643,
  [9781] = 9646,
  [9782] = 9660,
  [9783] = 9687,
  [9784] = 9660,
  [9785] = 3327,
  [9786] = 9649,
  [9787] = 9787,
  [9788] = 9661,
  [9789] = 9724,
  [9790] = 9654,
  [9791] = 9652,
  [9792] = 9792,
  [9793] = 9647,
  [9794] = 9692,
  [9795] = 9653,
  [9796] = 9677,
  [9797] = 9647,
  [9798] = 9798,
  [9799] = 9676,
  [9800] = 9787,
  [9801] = 9648,
  [9802] = 9650,
  [9803] = 9647,
  [9804] = 9675,
  [9805] = 9647,
  [9806] = 9806,
  [9807] = 9648,
  [9808] = 9669,
  [9809] = 9674,
  [9810] = 9661,
  [9811] = 9662,
  [9812] = 9686,
  [9813] = 9673,
  [9814] = 9653,
  [9815] = 9642,
  [9816] = 9668,
  [9817] = 9674,
  [9818] = 9660,
  [9819] = 3304,
  [9820] = 9669,
  [9821] = 9659,
  [9822] = 9692,
  [9823] = 9682,
  [9824] = 9824,
  [9825] = 9825,
  [9826] = 9826,
  [9827] = 9659,
  [9828] = 9662,
  [9829] = 9669,
  [9830] = 9798,
  [9831] = 9652,
  [9832] = 9661,
  [9833] = 9650,
  [9834] = 9787,
  [9835] = 9668,
  [9836] = 9642,
  [9837] = 9837,
  [9838] = 9654,
  [9839] = 9728,
  [9840] = 9840,
  [9841] = 9650,
  [9842] = 9648,
  [9843] = 9843,
  [9844] = 9844,
  [9845] = 9845,
  [9846] = 9648,
  [9847] = 9725,
  [9848] = 9848,
  [9849] = 9720,
  [9850] = 9723,
  [9851] = 9851,
  [9852] = 9686,
  [9853] = 9647,
  [9854] = 9724,
  [9855] = 9855,
  [9856] = 9647,
  [9857] = 9687,
  [9858] = 9787,
  [9859] = 9765,
  [9860] = 9686,
  [9861] = 9759,
  [9862] = 9713,
  [9863] = 9670,
  [9864] = 9691,
  [9865] = 9709,
  [9866] = 9723,
  [9867] = 9648,
  [9868] = 9642,
  [9869] = 9687,
  [9870] = 9668,
  [9871] = 9653,
  [9872] = 9654,
  [9873] = 9669,
  [9874] = 9798,
  [9875] = 9669,
  [9876] = 9660,
  [9877] = 9749,
  [9878] = 9713,
  [9879] = 9654,
  [9880] = 9698,
  [9881] = 9728,
  [9882] = 9647,
  [9883] = 9686,
  [9884] = 9691,
  [9885] = 9642,
  [9886] = 9735,
  [9887] = 9668,
  [9888] = 9692,
  [9889] = 9720,
  [9890] = 9648,
  [9891] = 9660,
  [9892] = 9652,
  [9893] = 9732,
  [9894] = 9643,
  [9895] = 9731,
  [9896] = 9661,
  [9897] = 9730,
  [9898] = 9649,
  [9899] = 9730,
  [9900] = 9731,
  [9901] = 9732,
  [9902] = 9902,
  [9903] = 9661,
  [9904] = 9653,
  [9905] = 9653,
  [9906] = 9735,
  [9907] = 9728,
  [9908] = 9787,
  [9909] = 9652,
  [9910] = 9668,
  [9911] = 9654,
  [9912] = 9647,
  [9913] = 9642,
  [9914] = 9669,
  [9915] = 9670,
  [9916] = 9669,
  [9917] = 9669,
  [9918] = 9660,
  [9919] = 9646,
  [9920] = 9662,
  [9921] = 9709,
  [9922] = 9787,
  [9923] = 9654,
  [9924] = 9647,
  [9925] = 9686,
  [9926] = 9686,
  [9927] = 9646,
  [9928] = 9928,
  [9929] = 9929,
  [9930] = 9662,
  [9931] = 9720,
  [9932] = 9642,
  [9933] = 9724,
  [9934] = 9668,
  [9935] = 9647,
  [9936] = 9649,
  [9937] = 9713,
  [9938] = 9938,
  [9939] = 9709,
  [9940] = 9692,
  [9941] = 9660,
  [9942] = 9699,
  [9943] = 9675,
  [9944] = 9787,
  [9945] = 9806,
  [9946] = 9673,
  [9947] = 9646,
  [9948] = 9787,
  [9949] = 9949,
  [9950] = 9647,
  [9951] = 9787,
  [9952] = 9676,
  [9953] = 9652,
  [9954] = 9787,
  [9955] = 9787,
  [9956] = 9677,
  [9957] = 9691,
  [9958] = 9682,
  [9959] = 9679,
  [9960] = 9698,
  [9961] = 9787,
  [9962] = 9647,
  [9963] = 9713,
  [9964] = 9964,
  [9965] = 9643,
  [9966] = 9966,
  [9967] = 9643,
  [9968] = 9652,
  [9969] = 9969,
  [9970] = 9669,
  [9971] = 9649,
  [9972] = 9787,
  [9973] = 9806,
  [9974] = 9787,
  [9975] = 9787,
  [9976] = 9713,
  [9977] = 9749,
  [9978] = 9728,
  [9979] = 9787,
  [9980] = 9661,
  [9981] = 9668,
  [9982] = 9661,
  [9983] = 9669,
  [9984] = 9787,
  [9985] = 9642,
  [9986] = 9986,
  [9987] = 9691,
  [9988] = 9988,
  [9989] = 9698,
  [9990] = 9674,
  [9991] = 9673,
  [9992] = 9651,
  [9993] = 9699,
  [9994] = 9654,
  [9995] = 9731,
  [9996] = 9651,
  [9997] = 9660,
  [9998] = 9720,
  [9999] = 9678,
  [10000] = 9724,
  [10001] = 9728,
  [10002] = 10002,
  [10003] = 9749,
  [10004] = 9713,
  [10005] = 9669,
  [10006] = 10006,
  [10007] = 9660,
  [10008] = 3313,
  [10009] = 10009,
  [10010] = 10010,
  [10011] = 9652,
  [10012] = 9649,
  [10013] = 9675,
  [10014] = 9798,
  [10015] = 9709,
  [10016] = 9676,
  [10017] = 9659,
  [10018] = 9713,
  [10019] = 9691,
  [10020] = 10020,
  [10021] = 9682,
  [10022] = 10022,
  [10023] = 9675,
  [10024] = 9670,
  [10025] = 9678,
  [10026] = 9676,
  [10027] = 9647,
  [10028] = 9643,
  [10029] = 9677,
  [10030] = 9677,
  [10031] = 9686,
  [10032] = 9713,
  [10033] = 9661,
  [10034] = 10034,
  [10035] = 9686,
  [10036] = 9713,
  [10037] = 10037,
  [10038] = 9642,
  [10039] = 9735,
  [10040] = 9668,
  [10041] = 10041,
  [10042] = 9669,
  [10043] = 10043,
  [10044] = 9732,
  [10045] = 9652,
  [10046] = 9661,
  [10047] = 9720,
  [10048] = 9730,
  [10049] = 9724,
  [10050] = 9731,
  [10051] = 9713,
  [10052] = 9691,
  [10053] = 9652,
  [10054] = 9765,
  [10055] = 9730,
  [10056] = 9679,
  [10057] = 9724,
  [10058] = 9725,
  [10059] = 9723,
  [10060] = 9678,
  [10061] = 9687,
  [10062] = 9720,
  [10063] = 9720,
  [10064] = 9713,
  [10065] = 10065,
  [10066] = 9735,
  [10067] = 9679,
  [10068] = 9669,
  [10069] = 9732,
  [10070] = 10070,
  [10071] = 10071,
  [10072] = 10072,
  [10073] = 10073,
  [10074] = 10074,
  [10075] = 10075,
  [10076] = 10076,
  [10077] = 10077,
  [10078] = 10078,
  [10079] = 10079,
  [10080] = 10077,
  [10081] = 10081,
  [10082] = 10082,
  [10083] = 10083,
  [10084] = 10074,
  [10085] = 10074,
  [10086] = 10086,
  [10087] = 10087,
  [10088] = 10088,
  [10089] = 10089,
  [10090] = 10090,
  [10091] = 10077,
  [10092] = 10092,
  [10093] = 10093,
  [10094] = 10094,
  [10095] = 10074,
  [10096] = 10096,
  [10097] = 10097,
  [10098] = 10077,
  [10099] = 10099,
  [10100] = 10100,
  [10101] = 10101,
  [10102] = 10077,
  [10103] = 10103,
  [10104] = 10104,
  [10105] = 10105,
  [10106] = 10074,
  [10107] = 10107,
  [10108] = 10108,
  [10109] = 10074,
  [10110] = 10082,
  [10111] = 10111,
  [10112] = 10077,
  [10113] = 10113,
  [10114] = 10114,
  [10115] = 10115,
  [10116] = 10074,
  [10117] = 10117,
  [10118] = 10118,
  [10119] = 10119,
  [10120] = 10077,
  [10121] = 10077,
  [10122] = 10122,
  [10123] = 10123,
  [10124] = 10074,
  [10125] = 10125,
  [10126] = 10126,
  [10127] = 10077,
  [10128] = 10128,
  [10129] = 10129,
  [10130] = 10130,
  [10131] = 10074,
  [10132] = 10132,
  [10133] = 10133,
  [10134] = 10077,
  [10135] = 10135,
  [10136] = 10136,
  [10137] = 10122,
  [10138] = 10074,
  [10139] = 10139,
  [10140] = 10140,
  [10141] = 10077,
  [10142] = 10104,
  [10143] = 10143,
  [10144] = 10144,
  [10145] = 10074,
  [10146] = 10146,
  [10147] = 10147,
  [10148] = 10077,
  [10149] = 10149,
  [10150] = 10150,
  [10151] = 10151,
  [10152] = 10074,
  [10153] = 10074,
  [10154] = 10082,
  [10155] = 10113,
  [10156] = 10156,
  [10157] = 10157,
  [10158] = 10077,
  [10159] = 10159,
  [10160] = 10160,
  [10161] = 10122,
  [10162] = 10162,
  [10163] = 10163,
  [10164] = 10164,
  [10165] = 10165,
  [10166] = 10166,
  [10167] = 10104,
  [10168] = 10168,
  [10169] = 10169,
  [10170] = 10170,
  [10171] = 6894,
  [10172] = 10172,
  [10173] = 10173,
  [10174] = 10174,
  [10175] = 10175,
  [10176] = 10077,
  [10177] = 10177,
  [10178] = 10178,
  [10179] = 10179,
  [10180] = 10180,
  [10181] = 10074,
  [10182] = 10082,
  [10183] = 10183,
  [10184] = 10087,
  [10185] = 10185,
  [10186] = 10113,
  [10187] = 10187,
  [10188] = 10188,
  [10189] = 10189,
  [10190] = 10077,
  [10191] = 10191,
  [10192] = 10122,
  [10193] = 10136,
  [10194] = 10123,
  [10195] = 10100,
  [10196] = 10178,
  [10197] = 10197,
  [10198] = 10198,
  [10199] = 10199,
  [10200] = 10200,
  [10201] = 10164,
  [10202] = 10202,
  [10203] = 10203,
  [10204] = 10204,
  [10205] = 10205,
  [10206] = 10206,
  [10207] = 10207,
  [10208] = 10166,
  [10209] = 10209,
  [10210] = 10210,
  [10211] = 10211,
  [10212] = 10212,
  [10213] = 10104,
  [10214] = 10214,
  [10215] = 10215,
  [10216] = 10216,
  [10217] = 10217,
  [10218] = 10218,
  [10219] = 10191,
  [10220] = 10170,
  [10221] = 10221,
  [10222] = 10217,
  [10223] = 10197,
  [10224] = 10224,
  [10225] = 10225,
  [10226] = 10226,
  [10227] = 10227,
  [10228] = 10228,
  [10229] = 10229,
  [10230] = 10163,
  [10231] = 10231,
  [10232] = 10174,
  [10233] = 10074,
  [10234] = 10234,
  [10235] = 10235,
  [10236] = 10082,
  [10237] = 10173,
  [10238] = 10238,
  [10239] = 10183,
  [10240] = 10094,
  [10241] = 10241,
  [10242] = 10087,
  [10243] = 10243,
  [10244] = 10146,
  [10245] = 10139,
  [10246] = 10136,
  [10247] = 10123,
  [10248] = 10248,
  [10249] = 10249,
  [10250] = 10113,
  [10251] = 10251,
  [10252] = 10111,
  [10253] = 10139,
  [10254] = 10147,
  [10255] = 10159,
  [10256] = 10235,
  [10257] = 10189,
  [10258] = 10175,
  [10259] = 10077,
  [10260] = 10187,
  [10261] = 10159,
  [10262] = 10122,
  [10263] = 10263,
  [10264] = 10136,
  [10265] = 10123,
  [10266] = 10107,
  [10267] = 10105,
  [10268] = 10108,
  [10269] = 10269,
  [10270] = 10159,
  [10271] = 10271,
  [10272] = 10229,
  [10273] = 10164,
  [10274] = 10166,
  [10275] = 10275,
  [10276] = 10212,
  [10277] = 10104,
  [10278] = 10179,
  [10279] = 10093,
  [10280] = 10177,
  [10281] = 10281,
  [10282] = 10078,
  [10283] = 10283,
  [10284] = 10234,
  [10285] = 10285,
  [10286] = 10286,
  [10287] = 6789,
  [10288] = 10149,
  [10289] = 10289,
  [10290] = 10290,
  [10291] = 10291,
  [10292] = 10292,
  [10293] = 10293,
  [10294] = 10294,
  [10295] = 10295,
  [10296] = 6809,
  [10297] = 10297,
  [10298] = 10298,
  [10299] = 10299,
  [10300] = 10217,
  [10301] = 10301,
  [10302] = 10070,
  [10303] = 10303,
  [10304] = 10304,
  [10305] = 10108,
  [10306] = 10199,
  [10307] = 10081,
  [10308] = 10133,
  [10309] = 10309,
  [10310] = 10079,
  [10311] = 10311,
  [10312] = 10183,
  [10313] = 10132,
  [10314] = 10314,
  [10315] = 10315,
  [10316] = 10316,
  [10317] = 10317,
  [10318] = 10130,
  [10319] = 10319,
  [10320] = 10320,
  [10321] = 10321,
  [10322] = 10322,
  [10323] = 10323,
  [10324] = 10125,
  [10325] = 10285,
  [10326] = 10183,
  [10327] = 10327,
  [10328] = 10168,
  [10329] = 10143,
  [10330] = 10330,
  [10331] = 10079,
  [10332] = 10143,
  [10333] = 10149,
  [10334] = 10078,
  [10335] = 10335,
  [10336] = 10123,
  [10337] = 10168,
  [10338] = 10136,
  [10339] = 10139,
  [10340] = 10340,
  [10341] = 10146,
  [10342] = 10342,
  [10343] = 10323,
  [10344] = 10344,
  [10345] = 10345,
  [10346] = 10346,
  [10347] = 10170,
  [10348] = 10348,
  [10349] = 10349,
  [10350] = 10350,
  [10351] = 10351,
  [10352] = 10352,
  [10353] = 10353,
  [10354] = 10183,
  [10355] = 10163,
  [10356] = 10174,
  [10357] = 10357,
  [10358] = 10227,
  [10359] = 10173,
  [10360] = 10360,
  [10361] = 10198,
  [10362] = 10362,
  [10363] = 10363,
  [10364] = 10320,
  [10365] = 10365,
  [10366] = 10366,
  [10367] = 10229,
  [10368] = 10159,
  [10369] = 10319,
  [10370] = 10200,
  [10371] = 10371,
  [10372] = 10372,
  [10373] = 10074,
  [10374] = 10082,
  [10375] = 10203,
  [10376] = 10376,
  [10377] = 10377,
  [10378] = 10378,
  [10379] = 10238,
  [10380] = 10241,
  [10381] = 10087,
  [10382] = 10382,
  [10383] = 10133,
  [10384] = 10130,
  [10385] = 10093,
  [10386] = 10125,
  [10387] = 10387,
  [10388] = 10388,
  [10389] = 10389,
  [10390] = 10113,
  [10391] = 10391,
  [10392] = 10392,
  [10393] = 10393,
  [10394] = 10394,
  [10395] = 10395,
  [10396] = 10396,
  [10397] = 10159,
  [10398] = 10398,
  [10399] = 10073,
  [10400] = 10400,
  [10401] = 10072,
  [10402] = 10088,
  [10403] = 10403,
  [10404] = 10404,
  [10405] = 10405,
  [10406] = 10406,
  [10407] = 10407,
  [10408] = 10077,
  [10409] = 10409,
  [10410] = 10410,
  [10411] = 10411,
  [10412] = 10092,
  [10413] = 10139,
  [10414] = 10122,
  [10415] = 10136,
  [10416] = 10123,
  [10417] = 10417,
  [10418] = 10107,
  [10419] = 10105,
  [10420] = 10420,
  [10421] = 10099,
  [10422] = 10165,
  [10423] = 10074,
  [10424] = 10114,
  [10425] = 10115,
  [10426] = 10285,
  [10427] = 10117,
  [10428] = 10118,
  [10429] = 10429,
  [10430] = 10217,
  [10431] = 10156,
  [10432] = 10225,
  [10433] = 10082,
  [10434] = 10087,
  [10435] = 10164,
  [10436] = 10140,
  [10437] = 10166,
  [10438] = 10212,
  [10439] = 10301,
  [10440] = 10440,
  [10441] = 10104,
  [10442] = 10169,
  [10443] = 10178,
  [10444] = 10157,
  [10445] = 10160,
  [10446] = 10073,
  [10447] = 10162,
  [10448] = 10448,
  [10449] = 10169,
  [10450] = 10118,
  [10451] = 10118,
  [10452] = 10178,
  [10453] = 10118,
  [10454] = 10177,
  [10455] = 10323,
  [10456] = 10179,
  [10457] = 10178,
  [10458] = 10118,
  [10459] = 10072,
  [10460] = 10460,
  [10461] = 10187,
  [10462] = 10269,
  [10463] = 10175,
  [10464] = 10139,
  [10465] = 10189,
  [10466] = 10178,
  [10467] = 10215,
  [10468] = 10210,
  [10469] = 10100,
  [10470] = 10088,
  [10471] = 10393,
  [10472] = 10320,
  [10473] = 10319,
  [10474] = 10178,
  [10475] = 10197,
  [10476] = 10118,
  [10477] = 10079,
  [10478] = 10198,
  [10479] = 10199,
  [10480] = 10200,
  [10481] = 10178,
  [10482] = 10118,
  [10483] = 10073,
  [10484] = 10203,
  [10485] = 10093,
  [10486] = 10079,
  [10487] = 10210,
  [10488] = 10178,
  [10489] = 10214,
  [10490] = 10099,
  [10491] = 10216,
  [10492] = 10178,
  [10493] = 10118,
  [10494] = 10073,
  [10495] = 10092,
  [10496] = 10093,
  [10497] = 10079,
  [10498] = 10498,
  [10499] = 10202,
  [10500] = 10205,
  [10501] = 10206,
  [10502] = 10209,
  [10503] = 10503,
  [10504] = 10211,
  [10505] = 10505,
  [10506] = 10283,
  [10507] = 10217,
  [10508] = 10178,
  [10509] = 10118,
  [10510] = 10225,
  [10511] = 10073,
  [10512] = 10227,
  [10513] = 10513,
  [10514] = 10093,
  [10515] = 10079,
  [10516] = 10301,
  [10517] = 10234,
  [10518] = 10235,
  [10519] = 10183,
  [10520] = 10094,
  [10521] = 10113,
  [10522] = 10522,
  [10523] = 10317,
  [10524] = 10524,
  [10525] = 10139,
  [10526] = 10147,
  [10527] = 10527,
  [10528] = 10291,
  [10529] = 10269,
  [10530] = 10293,
  [10531] = 10162,
  [10532] = 10275,
  [10533] = 10316,
  [10534] = 10317,
  [10535] = 10283,
  [10536] = 10536,
  [10537] = 10315,
  [10538] = 10538,
  [10539] = 10178,
  [10540] = 10169,
  [10541] = 10118,
  [10542] = 10115,
  [10543] = 10073,
  [10544] = 10101,
  [10545] = 10309,
  [10546] = 10139,
  [10547] = 10093,
  [10548] = 10079,
  [10549] = 10298,
  [10550] = 10304,
  [10551] = 10294,
  [10552] = 10271,
  [10553] = 10070,
  [10554] = 10316,
  [10555] = 10202,
  [10556] = 10205,
  [10557] = 10209,
  [10558] = 10271,
  [10559] = 10211,
  [10560] = 10315,
  [10561] = 10217,
  [10562] = 10225,
  [10563] = 10303,
  [10564] = 10227,
  [10565] = 10217,
  [10566] = 10391,
  [10567] = 10234,
  [10568] = 10235,
  [10569] = 10301,
  [10570] = 10147,
  [10571] = 10070,
  [10572] = 10271,
  [10573] = 10160,
  [10574] = 10309,
  [10575] = 10275,
  [10576] = 10217,
  [10577] = 10283,
  [10578] = 10299,
  [10579] = 10315,
  [10580] = 10178,
  [10581] = 10316,
  [10582] = 10169,
  [10583] = 10317,
  [10584] = 10118,
  [10585] = 10115,
  [10586] = 10073,
  [10587] = 10159,
  [10588] = 10139,
  [10589] = 10093,
  [10590] = 10157,
  [10591] = 10079,
  [10592] = 10238,
  [10593] = 10319,
  [10594] = 10202,
  [10595] = 10205,
  [10596] = 10209,
  [10597] = 10320,
  [10598] = 10211,
  [10599] = 10114,
  [10600] = 10115,
  [10601] = 10225,
  [10602] = 10227,
  [10603] = 10271,
  [10604] = 10070,
  [10605] = 10234,
  [10606] = 10235,
  [10607] = 10303,
  [10608] = 10147,
  [10609] = 10301,
  [10610] = 10610,
  [10611] = 10156,
  [10612] = 10275,
  [10613] = 10283,
  [10614] = 10614,
  [10615] = 10117,
  [10616] = 10323,
  [10617] = 10275,
  [10618] = 10118,
  [10619] = 10285,
  [10620] = 10216,
  [10621] = 10202,
  [10622] = 10205,
  [10623] = 10209,
  [10624] = 10210,
  [10625] = 10211,
  [10626] = 10178,
  [10627] = 10100,
  [10628] = 10227,
  [10629] = 10169,
  [10630] = 10118,
  [10631] = 10234,
  [10632] = 10235,
  [10633] = 10633,
  [10634] = 10147,
  [10635] = 10183,
  [10636] = 10117,
  [10637] = 10115,
  [10638] = 10275,
  [10639] = 10283,
  [10640] = 10072,
  [10641] = 10073,
  [10642] = 10133,
  [10643] = 10159,
  [10644] = 10173,
  [10645] = 10174,
  [10646] = 10309,
  [10647] = 10202,
  [10648] = 10205,
  [10649] = 10163,
  [10650] = 10211,
  [10651] = 10651,
  [10652] = 10170,
  [10653] = 10241,
  [10654] = 10168,
  [10655] = 10234,
  [10656] = 10235,
  [10657] = 10298,
  [10658] = 10139,
  [10659] = 10079,
  [10660] = 10660,
  [10661] = 10275,
  [10662] = 10662,
  [10663] = 10202,
  [10664] = 10211,
  [10665] = 10665,
  [10666] = 10235,
  [10667] = 10093,
  [10668] = 10149,
  [10669] = 10275,
  [10670] = 10143,
  [10671] = 10202,
  [10672] = 10211,
  [10673] = 10304,
  [10674] = 10235,
  [10675] = 10675,
  [10676] = 10275,
  [10677] = 10202,
  [10678] = 10211,
  [10679] = 10235,
  [10680] = 10275,
  [10681] = 10202,
  [10682] = 10211,
  [10683] = 10235,
  [10684] = 10275,
  [10685] = 10202,
  [10686] = 10235,
  [10687] = 10275,
  [10688] = 10202,
  [10689] = 10235,
  [10690] = 10275,
  [10691] = 10235,
  [10692] = 10275,
  [10693] = 10235,
  [10694] = 10275,
  [10695] = 10235,
  [10696] = 10275,
  [10697] = 10235,
  [10698] = 10275,
  [10699] = 10169,
  [10700] = 10271,
  [10701] = 10206,
  [10702] = 10702,
  [10703] = 10703,
  [10704] = 10168,
  [10705] = 10070,
  [10706] = 10706,
  [10707] = 10707,
  [10708] = 10301,
  [10709] = 10285,
  [10710] = 10710,
  [10711] = 10711,
  [10712] = 10712,
  [10713] = 10217,
  [10714] = 10714,
  [10715] = 10299,
  [10716] = 10716,
  [10717] = 10094,
  [10718] = 10718,
  [10719] = 10719,
  [10720] = 10720,
  [10721] = 10079,
  [10722] = 10111,
  [10723] = 10150,
  [10724] = 10271,
  [10725] = 10070,
  [10726] = 10301,
  [10727] = 10217,
  [10728] = 10728,
  [10729] = 10729,
  [10730] = 10730,
  [10731] = 10303,
  [10732] = 10732,
  [10733] = 10733,
  [10734] = 10294,
  [10735] = 10293,
  [10736] = 10736,
  [10737] = 10149,
  [10738] = 10078,
  [10739] = 10303,
  [10740] = 10216,
  [10741] = 10291,
  [10742] = 10093,
  [10743] = 10210,
  [10744] = 10178,
  [10745] = 10100,
  [10746] = 10174,
  [10747] = 10162,
  [10748] = 10139,
  [10749] = 10146,
  [10750] = 10750,
  [10751] = 10751,
  [10752] = 10118,
  [10753] = 10117,
  [10754] = 10115,
  [10755] = 10099,
  [10756] = 10072,
  [10757] = 10073,
  [10758] = 10133,
  [10759] = 10159,
  [10760] = 10170,
  [10761] = 10173,
  [10762] = 10298,
  [10763] = 10214,
  [10764] = 10215,
  [10765] = 10765,
  [10766] = 10174,
  [10767] = 10163,
  [10768] = 10768,
  [10769] = 10170,
  [10770] = 10770,
  [10771] = 10771,
  [10772] = 10146,
  [10773] = 10139,
  [10774] = 10093,
  [10775] = 10078,
  [10776] = 10149,
  [10777] = 10777,
  [10778] = 10079,
  [10779] = 10168,
  [10780] = 10163,
  [10781] = 10100,
  [10782] = 10216,
  [10783] = 10173,
  [10784] = 10285,
  [10785] = 10323,
  [10786] = 10159,
  [10787] = 10317,
  [10788] = 10133,
  [10789] = 10309,
  [10790] = 10790,
  [10791] = 10791,
  [10792] = 10130,
  [10793] = 10125,
  [10794] = 10271,
  [10795] = 10070,
  [10796] = 10301,
  [10797] = 10217,
  [10798] = 10303,
  [10799] = 10217,
  [10800] = 10073,
  [10801] = 10072,
  [10802] = 10802,
  [10803] = 10092,
  [10804] = 10216,
  [10805] = 10805,
  [10806] = 10159,
  [10807] = 10099,
  [10808] = 10210,
  [10809] = 10178,
  [10810] = 10115,
  [10811] = 10169,
  [10812] = 10162,
  [10813] = 10114,
  [10814] = 10164,
  [10815] = 10079,
  [10816] = 10816,
  [10817] = 10817,
  [10818] = 10118,
  [10819] = 2808,
  [10820] = 10820,
  [10821] = 10117,
  [10822] = 10117,
  [10823] = 10115,
  [10824] = 10703,
  [10825] = 10702,
  [10826] = 10099,
  [10827] = 10092,
  [10828] = 10072,
  [10829] = 10073,
  [10830] = 10118,
  [10831] = 10133,
  [10832] = 10211,
  [10833] = 10159,
  [10834] = 10834,
  [10835] = 10173,
  [10836] = 10174,
  [10837] = 10163,
  [10838] = 10170,
  [10839] = 10839,
  [10840] = 10840,
  [10841] = 10159,
  [10842] = 10842,
  [10843] = 10209,
  [10844] = 10206,
  [10845] = 10702,
  [10846] = 10703,
  [10847] = 10146,
  [10848] = 10166,
  [10849] = 10294,
  [10850] = 10094,
  [10851] = 10293,
  [10852] = 10111,
  [10853] = 10150,
  [10854] = 10139,
  [10855] = 10206,
  [10856] = 10140,
  [10857] = 10087,
  [10858] = 10291,
  [10859] = 10206,
  [10860] = 10702,
  [10861] = 10703,
  [10862] = 10093,
  [10863] = 10078,
  [10864] = 10094,
  [10865] = 10111,
  [10866] = 10150,
  [10867] = 10149,
  [10868] = 10868,
  [10869] = 10216,
  [10870] = 10702,
  [10871] = 10703,
  [10872] = 10168,
  [10873] = 10162,
  [10874] = 10111,
  [10875] = 10150,
  [10876] = 10285,
  [10877] = 10205,
  [10878] = 10702,
  [10879] = 10703,
  [10880] = 10323,
  [10881] = 6856,
  [10882] = 10111,
  [10883] = 10150,
  [10884] = 10204,
  [10885] = 10320,
  [10886] = 10702,
  [10887] = 10703,
  [10888] = 10319,
  [10889] = 10111,
  [10890] = 10150,
  [10891] = 10169,
  [10892] = 10140,
  [10893] = 10111,
  [10894] = 10150,
  [10895] = 10202,
  [10896] = 10317,
  [10897] = 10150,
  [10898] = 10898,
  [10899] = 10150,
  [10900] = 10316,
  [10901] = 10150,
  [10902] = 10315,
  [10903] = 10150,
  [10904] = 10309,
  [10905] = 10150,
  [10906] = 10271,
  [10907] = 10150,
  [10908] = 10070,
  [10909] = 10150,
  [10910] = 10301,
  [10911] = 10150,
  [10912] = 10217,
  [10913] = 10150,
  [10914] = 10842,
  [10915] = 10263,
  [10916] = 2786,
  [10917] = 10303,
  [10918] = 10842,
  [10919] = 10263,
  [10920] = 10100,
  [10921] = 10842,
  [10922] = 10263,
  [10923] = 10178,
  [10924] = 10842,
  [10925] = 10263,
  [10926] = 10294,
  [10927] = 10842,
  [10928] = 10263,
  [10929] = 10293,
  [10930] = 10263,
  [10931] = 10263,
  [10932] = 10263,
  [10933] = 10263,
  [10934] = 10263,
  [10935] = 10263,
  [10936] = 10263,
  [10937] = 10263,
  [10938] = 10263,
  [10939] = 10263,
  [10940] = 10263,
  [10941] = 10210,
  [10942] = 10291,
  [10943] = 10212,
  [10944] = 8560,
  [10945] = 10104,
  [10946] = 10839,
  [10947] = 10839,
  [10948] = 10839,
  [10949] = 10839,
  [10950] = 10839,
};

static TSCharacterRange sym_identifier_character_set_1[] = {
  {'$', '$'}, {'A', 'Z'}, {'\\', '\\'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba},
  {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x370, 0x374},
  {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5},
  {0x3f7, 0x481}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x64a},
  {0x66e, 0x66f}, {0x671, 0x6d3}, {0x6d5, 0x6d5}, {0x6e5, 0x6e6}, {0x6ee, 0x6ef}, {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710},
  {0x712, 0x72f}, {0x74d, 0x7a5}, {0x7b1, 0x7b1}, {0x7ca, 0x7ea}, {0x7f4, 0x7f5}, {0x7fa, 0x7fa}, {0x800, 0x815}, {0x81a, 0x81a},
  {0x824, 0x824}, {0x828, 0x828}, {0x840, 0x858}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c9}, {0x904, 0x939},
  {0x93d, 0x93d}, {0x950, 0x950}, {0x958, 0x961}, {0x971, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0},
  {0x9b2, 0x9b2}, {0x9b6, 0x9b9}, {0x9bd, 0x9bd}, {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc},
  {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c},
  {0xa5e, 0xa5e}, {0xa72, 0xa74}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9},
  {0xabd, 0xabd}, {0xad0, 0xad0}, {0xae0, 0xae1}, {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30},
  {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3d, 0xb3d}, {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a},
  {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9},
  {0xbd0, 0xbd0}, {0xc05, 0xc0c}, {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d},
  {0xc60, 0xc61}, {0xc80, 0xc80}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd},
  {0xcdd, 0xcde}, {0xce0, 0xce1}, {0xcf1, 0xcf2}, {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e},
  {0xd54, 0xd56}, {0xd5f, 0xd61}, {0xd7a, 0xd7f}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6},
  {0xe01, 0xe30}, {0xe32, 0xe32}, {0xe40, 0xe46}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5},
  {0xea7, 0xeb0}, {0xeb2, 0xeb2}, {0xebd, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47},
  {0xf49, 0xf6c}, {0xf88, 0xf8c}, {0x1000, 0x102a}, {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066},
  {0x106e, 0x1070}, {0x1075, 0x1081}, {0x108e, 0x108e}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248},
  {0x124a, 0x124d}, {0x1250, 0x1256}, {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5},
  {0x12b8, 0x12be}, {0x12c0, 0x12c0}, {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x1380, 0x138f},
  {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1711},
  {0x171f, 0x1731}, {0x1740, 0x1751}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dc}, {0x1820, 0x1878},
  {0x1880, 0x18a8}, {0x18aa, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9},
  {0x1a00, 0x1a16}, {0x1a20, 0x1a54}, {0x1aa7, 0x1aa7}, {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf}, {0x1bba, 0x1be5},
  {0x1c00, 0x1c23}, {0x1c4d, 0x1c4f}, {0x1c5a, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3},
  {0x1cf5, 0x1cf6}, {0x1cfa, 0x1cfa}, {0x1d00, 0x1dbf}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57},
  {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4},
  {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x2071, 0x2071}, {0x207f, 0x207f},
  {0x2090, 0x209c}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126},
  {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cee},
  {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d80, 0x2d96}, {0x2da0, 0x2da6},
  {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x3005, 0x3007},
  {0x3021, 0x3029}, {0x3031, 0x3035}, {0x3038, 0x303c}, {0x3041, 0x3096}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f},
  {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa61f},
  {0xa62a, 0xa62b}, {0xa640, 0xa66e}, {0xa67f, 0xa69d}, {0xa6a0, 0xa6ef}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1},
  {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa801}, {0xa803, 0xa805}, {0xa807, 0xa80a}, {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3},
  {0xa8f2, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa8fe}, {0xa90a, 0xa925}, {0xa930, 0xa946}, {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9cf, 0xa9cf},
  {0xa9e0, 0xa9e4}, {0xa9e6, 0xa9ef}, {0xa9fa, 0xa9fe}, {0xaa00, 0xaa28}, {0xaa40, 0xaa42}, {0xaa44, 0xaa4b}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a},
  {0xaa7e, 0xaaaf}, {0xaab1, 0xaab1}, {0xaab5, 0xaab6}, {0xaab9, 0xaabd}, {0xaac0, 0xaac0}, {0xaac2, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaea},
  {0xaaf2, 0xaaf4}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69},
  {0xab70, 0xabe2}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17},
  {0xfb1d, 0xfb1d}, {0xfb1f, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1},
  {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77},
  {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xff9d}, {0xffa0, 0xffbe},
  {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d},
  {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a},
  {0x10350, 0x10375}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb},
  {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1},
  {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba},
  {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e},
  {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a00}, {0x10a10, 0x10a13},
  {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae4}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55},
  {0x10b60, 0x10b72}, {0x10b80, 0x10b91}, {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d23}, {0x10e80, 0x10ea9}, {0x10eb0, 0x10eb1},
  {0x10f00, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f45}, {0x10f70, 0x10f81}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11003, 0x11037}, {0x11071, 0x11072},
  {0x11075, 0x11075}, {0x11083, 0x110af}, {0x110d0, 0x110e8}, {0x11103, 0x11126}, {0x11144, 0x11144}, {0x11147, 0x11147}, {0x11150, 0x11172}, {0x11176, 0x11176},
  {0x11183, 0x111b2}, {0x111c1, 0x111c4}, {0x111da, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x1122b}, {0x11280, 0x11286}, {0x11288, 0x11288},
  {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112de}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330},
  {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133d, 0x1133d}, {0x11350, 0x11350}, {0x1135d, 0x11361}, {0x11400, 0x11434}, {0x11447, 0x1144a}, {0x1145f, 0x11461},
  {0x11480, 0x114af}, {0x114c4, 0x114c5}, {0x114c7, 0x114c7}, {0x11580, 0x115ae}, {0x115d8, 0x115db}, {0x11600, 0x1162f}, {0x11644, 0x11644}, {0x11680, 0x116aa},
  {0x116b8, 0x116b8}, {0x11700, 0x1171a}, {0x11740, 0x11746}, {0x11800, 0x1182b}, {0x118a0, 0x118df}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913},
  {0x11915, 0x11916}, {0x11918, 0x1192f}, {0x1193f, 0x1193f}, {0x11941, 0x11941}, {0x119a0, 0x119a7}, {0x119aa, 0x119d0}, {0x119e1, 0x119e1}, {0x119e3, 0x119e3},
  {0x11a00, 0x11a00}, {0x11a0b, 0x11a32}, {0x11a3a, 0x11a3a}, {0x11a50, 0x11a50}, {0x11a5c, 0x11a89}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08},
  {0x11c0a, 0x11c2e}, {0x11c40, 0x11c40}, {0x11c72, 0x11c8f}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d30}, {0x11d46, 0x11d46}, {0x11d60, 0x11d65},
  {0x11d67, 0x11d68}, {0x11d6a, 0x11d89}, {0x11d98, 0x11d98}, {0x11ee0, 0x11ef2}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543},
  {0x12f90, 0x12ff0}, {0x13000, 0x1342e}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a70, 0x16abe}, {0x16ad0, 0x16aed}, {0x16b00, 0x16b2f},
  {0x16b40, 0x16b43}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f50, 0x16f50}, {0x16f93, 0x16f9f}, {0x16fe0, 0x16fe1},
  {0x16fe3, 0x16fe3}, {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122},
  {0x1b150, 0x1b152}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1d400, 0x1d454},
  {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3},
  {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546},
  {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e},
  {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1df00, 0x1df1e}, {0x1e100, 0x1e12c}, {0x1e137, 0x1e13d},
  {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ad}, {0x1e2c0, 0x1e2eb}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4},
  {0x1e900, 0x1e943}, {0x1e94b, 0x1e94b}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32},
  {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f},
  {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62},
  {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b},
  {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x20000, 0x2a6df}, {0x2a700, 0x2b738}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0},
  {0x2f800, 0x2fa1d}, {0x30000, 0x3134a},
};

static TSCharacterRange sym_identifier_character_set_2[] = {
  {'$', '$'}, {'0', '9'}, {'A', 'Z'}, {'\\', '\\'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5},
  {0xb7, 0xb7}, {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec},
  {0x2ee, 0x2ee}, {0x300, 0x374}, {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1},
  {0x3a3, 0x3f5}, {0x3f7, 0x481}, {0x483, 0x487}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x591, 0x5bd},
  {0x5bf, 0x5bf}, {0x5c1, 0x5c2}, {0x5c4, 0x5c5}, {0x5c7, 0x5c7}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x610, 0x61a}, {0x620, 0x669},
  {0x66e, 0x6d3}, {0x6d5, 0x6dc}, {0x6df, 0x6e8}, {0x6ea, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x74a}, {0x74d, 0x7b1}, {0x7c0, 0x7f5},
  {0x7fa, 0x7fa}, {0x7fd, 0x7fd}, {0x800, 0x82d}, {0x840, 0x85b}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x898, 0x8e1},
  {0x8e3, 0x963}, {0x966, 0x96f}, {0x971, 0x983}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2},
  {0x9b6, 0x9b9}, {0x9bc, 0x9c4}, {0x9c7, 0x9c8}, {0x9cb, 0x9ce}, {0x9d7, 0x9d7}, {0x9dc, 0x9dd}, {0x9df, 0x9e3}, {0x9e6, 0x9f1},
  {0x9fc, 0x9fc}, {0x9fe, 0x9fe}, {0xa01, 0xa03}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33},
  {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa3c, 0xa3c}, {0xa3e, 0xa42}, {0xa47, 0xa48}, {0xa4b, 0xa4d}, {0xa51, 0xa51}, {0xa59, 0xa5c},
  {0xa5e, 0xa5e}, {0xa66, 0xa75}, {0xa81, 0xa83}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3},
  {0xab5, 0xab9}, {0xabc, 0xac5}, {0xac7, 0xac9}, {0xacb, 0xacd}, {0xad0, 0xad0}, {0xae0, 0xae3}, {0xae6, 0xaef}, {0xaf9, 0xaff},
  {0xb01, 0xb03}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3c, 0xb44},
  {0xb47, 0xb48}, {0xb4b, 0xb4d}, {0xb55, 0xb57}, {0xb5c, 0xb5d}, {0xb5f, 0xb63}, {0xb66, 0xb6f}, {0xb71, 0xb71}, {0xb82, 0xb83},
  {0xb85, 0xb8a}, {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa},
  {0xbae, 0xbb9}, {0xbbe, 0xbc2}, {0xbc6, 0xbc8}, {0xbca, 0xbcd}, {0xbd0, 0xbd0}, {0xbd7, 0xbd7}, {0xbe6, 0xbef}, {0xc00, 0xc0c},
  {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3c, 0xc44}, {0xc46, 0xc48}, {0xc4a, 0xc4d}, {0xc55, 0xc56}, {0xc58, 0xc5a},
  {0xc5d, 0xc5d}, {0xc60, 0xc63}, {0xc66, 0xc6f}, {0xc80, 0xc83}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3},
  {0xcb5, 0xcb9}, {0xcbc, 0xcc4}, {0xcc6, 0xcc8}, {0xcca, 0xccd}, {0xcd5, 0xcd6}, {0xcdd, 0xcde}, {0xce0, 0xce3}, {0xce6, 0xcef},
  {0xcf1, 0xcf2}, {0xd00, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd44}, {0xd46, 0xd48}, {0xd4a, 0xd4e}, {0xd54, 0xd57}, {0xd5f, 0xd63},
  {0xd66, 0xd6f}, {0xd7a, 0xd7f}, {0xd81, 0xd83}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6},
  {0xdca, 0xdca}, {0xdcf, 0xdd4}, {0xdd6, 0xdd6}, {0xdd8, 0xddf}, {0xde6, 0xdef}, {0xdf2, 0xdf3}, {0xe01, 0xe3a}, {0xe40, 0xe4e},
  {0xe50, 0xe59}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xebd}, {0xec0, 0xec4},
  {0xec6, 0xec6}, {0xec8, 0xecd}, {0xed0, 0xed9}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf18, 0xf19}, {0xf20, 0xf29}, {0xf35, 0xf35},
  {0xf37, 0xf37}, {0xf39, 0xf39}, {0xf3e, 0xf47}, {0xf49, 0xf6c}, {0xf71, 0xf84}, {0xf86, 0xf97}, {0xf99, 0xfbc}, {0xfc6, 0xfc6},
  {0x1000, 0x1049}, {0x1050, 0x109d}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d},
  {0x1250, 0x1256}, {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be},
  {0x12c0, 0x12c0}, {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x135d, 0x135f}, {0x1369, 0x1371},
  {0x1380, 0x138f}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8},
  {0x1700, 0x1715}, {0x171f, 0x1734}, {0x1740, 0x1753}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1772, 0x1773}, {0x1780, 0x17d3}, {0x17d7, 0x17d7},
  {0x17dc, 0x17dd}, {0x17e0, 0x17e9}, {0x180b, 0x180d}, {0x180f, 0x1819}, {0x1820, 0x1878}, {0x1880, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e},
  {0x1920, 0x192b}, {0x1930, 0x193b}, {0x1946, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x19d0, 0x19da}, {0x1a00, 0x1a1b},
  {0x1a20, 0x1a5e}, {0x1a60, 0x1a7c}, {0x1a7f, 0x1a89}, {0x1a90, 0x1a99}, {0x1aa7, 0x1aa7}, {0x1ab0, 0x1abd}, {0x1abf, 0x1ace}, {0x1b00, 0x1b4c},
  {0x1b50, 0x1b59}, {0x1b6b, 0x1b73}, {0x1b80, 0x1bf3}, {0x1c00, 0x1c37}, {0x1c40, 0x1c49}, {0x1c4d, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba},
  {0x1cbd, 0x1cbf}, {0x1cd0, 0x1cd2}, {0x1cd4, 0x1cfa}, {0x1d00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57},
  {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4},
  {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x203f, 0x2040}, {0x2054, 0x2054},
  {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x20d0, 0x20dc}, {0x20e1, 0x20e1}, {0x20e5, 0x20f0}, {0x2102, 0x2102}, {0x2107, 0x2107},
  {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f},
  {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d},
  {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d7f, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6},
  {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x2de0, 0x2dff}, {0x3005, 0x3007}, {0x3021, 0x302f}, {0x3031, 0x3035}, {0x3038, 0x303c},
  {0x3041, 0x3096}, {0x3099, 0x309a}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf},
  {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa62b}, {0xa640, 0xa66f}, {0xa674, 0xa67d},
  {0xa67f, 0xa6f1}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa827},
  {0xa82c, 0xa82c}, {0xa840, 0xa873}, {0xa880, 0xa8c5}, {0xa8d0, 0xa8d9}, {0xa8e0, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa92d}, {0xa930, 0xa953},
  {0xa960, 0xa97c}, {0xa980, 0xa9c0}, {0xa9cf, 0xa9d9}, {0xa9e0, 0xa9fe}, {0xaa00, 0xaa36}, {0xaa40, 0xaa4d}, {0xaa50, 0xaa59}, {0xaa60, 0xaa76},
  {0xaa7a, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaef}, {0xaaf2, 0xaaf6}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26},
  {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabea}, {0xabec, 0xabed}, {0xabf0, 0xabf9}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6},
  {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c},
  {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7},
  {0xfdf0, 0xfdf9}, {0xfe00, 0xfe0f}, {0xfe20, 0xfe2f}, {0xfe33, 0xfe34}, {0xfe4d, 0xfe4f}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77},
  {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff10, 0xff19}, {0xff21, 0xff3a}, {0xff3f, 0xff3f}, {0xff41, 0xff5a},
  {0xff66, 0xffbe}, {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a},
  {0x1003c, 0x1003d}, {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x101fd, 0x101fd}, {0x10280, 0x1029c}, {0x102a0, 0x102d0},
  {0x102e0, 0x102e0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x1037a}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5},
  {0x10400, 0x1049d}, {0x104a0, 0x104a9}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a},
  {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755},
  {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838},
  {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939},
  {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a03}, {0x10a05, 0x10a06}, {0x10a0c, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a38, 0x10a3a},
  {0x10a3f, 0x10a3f}, {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae6}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72},
  {0x10b80, 0x10b91}, {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d27}, {0x10d30, 0x10d39}, {0x10e80, 0x10ea9}, {0x10eab, 0x10eac},
  {0x10eb0, 0x10eb1}, {0x10f00, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f50}, {0x10f70, 0x10f85}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11000, 0x11046},
  {0x11066, 0x11075}, {0x1107f, 0x110ba}, {0x110c2, 0x110c2}, {0x110d0, 0x110e8}, {0x110f0, 0x110f9}, {0x11100, 0x11134}, {0x11136, 0x1113f}, {0x11144, 0x11147},
  {0x11150, 0x11173}, {0x11176, 0x11176}, {0x11180, 0x111c4}, {0x111c9, 0x111cc}, {0x111ce, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x11237},
  {0x1123e, 0x1123e}, {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112ea}, {0x112f0, 0x112f9},
  {0x11300, 0x11303}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133b, 0x11344},
  {0x11347, 0x11348}, {0x1134b, 0x1134d}, {0x11350, 0x11350}, {0x11357, 0x11357}, {0x1135d, 0x11363}, {0x11366, 0x1136c}, {0x11370, 0x11374}, {0x11400, 0x1144a},
  {0x11450, 0x11459}, {0x1145e, 0x11461}, {0x11480, 0x114c5}, {0x114c7, 0x114c7}, {0x114d0, 0x114d9}, {0x11580, 0x115b5}, {0x115b8, 0x115c0}, {0x115d8, 0x115dd},
  {0x11600, 0x11640}, {0x11644, 0x11644}, {0x11650, 0x11659}, {0x11680, 0x116b8}, {0x116c0, 0x116c9}, {0x11700, 0x1171a}, {0x1171d, 0x1172b}, {0x11730, 0x11739},
  {0x11740, 0x11746}, {0x11800, 0x1183a}, {0x118a0, 0x118e9}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x11935},
  {0x11937, 0x11938}, {0x1193b, 0x11943}, {0x11950, 0x11959}, {0x119a0, 0x119a7}, {0x119aa, 0x119d7}, {0x119da, 0x119e1}, {0x119e3, 0x119e4}, {0x11a00, 0x11a3e},
  {0x11a47, 0x11a47}, {0x11a50, 0x11a99}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c36}, {0x11c38, 0x11c40}, {0x11c50, 0x11c59},
  {0x11c72, 0x11c8f}, {0x11c92, 0x11ca7}, {0x11ca9, 0x11cb6}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d36}, {0x11d3a, 0x11d3a}, {0x11d3c, 0x11d3d},
  {0x11d3f, 0x11d47}, {0x11d50, 0x11d59}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d8e}, {0x11d90, 0x11d91}, {0x11d93, 0x11d98}, {0x11da0, 0x11da9},
  {0x11ee0, 0x11ef6}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342e}, {0x14400, 0x14646},
  {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a60, 0x16a69}, {0x16a70, 0x16abe}, {0x16ac0, 0x16ac9}, {0x16ad0, 0x16aed}, {0x16af0, 0x16af4}, {0x16b00, 0x16b36},
  {0x16b40, 0x16b43}, {0x16b50, 0x16b59}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f4f, 0x16f87}, {0x16f8f, 0x16f9f},
  {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe4}, {0x16ff0, 0x16ff1}, {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb},
  {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b150, 0x1b152}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88},
  {0x1bc90, 0x1bc99}, {0x1bc9d, 0x1bc9e}, {0x1cf00, 0x1cf2d}, {0x1cf30, 0x1cf46}, {0x1d165, 0x1d169}, {0x1d16d, 0x1d172}, {0x1d17b, 0x1d182}, {0x1d185, 0x1d18b},
  {0x1d1aa, 0x1d1ad}, {0x1d242, 0x1d244}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac},
  {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539},
  {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa},
  {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb},
  {0x1d7ce, 0x1d7ff}, {0x1da00, 0x1da36}, {0x1da3b, 0x1da6c}, {0x1da75, 0x1da75}, {0x1da84, 0x1da84}, {0x1da9b, 0x1da9f}, {0x1daa1, 0x1daaf}, {0x1df00, 0x1df1e},
  {0x1e000, 0x1e006}, {0x1e008, 0x1e018}, {0x1e01b, 0x1e021}, {0x1e023, 0x1e024}, {0x1e026, 0x1e02a}, {0x1e100, 0x1e12c}, {0x1e130, 0x1e13d}, {0x1e140, 0x1e149},
  {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ae}, {0x1e2c0, 0x1e2f9}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4},
  {0x1e8d0, 0x1e8d6}, {0x1e900, 0x1e94b}, {0x1e950, 0x1e959}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27},
  {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b},
  {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f},
  {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89},
  {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x1fbf0, 0x1fbf9}, {0x20000, 0x2a6df}, {0x2a700, 0x2b738}, {0x2b740, 0x2b81d},
  {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0xe0100, 0xe01ef},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(352);
      ADVANCE_MAP(
        '!', 419,
        '"', 539,
        '#', 297,
        '%', 443,
        '&', 453,
        '\'', 530,
        '(', 356,
        ')', 359,
        '*', 439,
        '+', 433,
        ',', 358,
        '-', 422,
        '.', 504,
        '/', 441,
        '0', 654,
        ':', 472,
        ';', 473,
        '<', 463,
        '=', 485,
        '>', 652,
        '?', 488,
        'F', 579,
        'L', 553,
        'R', 556,
        'T', 583,
        'U', 557,
        '[', 481,
        '\\', 2,
        ']', 483,
        '^', 450,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 588,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        't', 630,
        'u', 560,
        'v', 622,
        '{', 477,
        '|', 447,
        '}', 478,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(348);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(515);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(171);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(171);
      if (lookahead == '\r') SKIP(1);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(182);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(182);
      if (lookahead == '\r') SKIP(3);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(181);
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(181);
      if (lookahead == '\r') SKIP(5);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(184);
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(184);
      if (lookahead == '\r') SKIP(7);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 9:
      if (lookahead == '\n') SKIP(183);
      END_STATE();
    case 10:
      if (lookahead == '\n') SKIP(183);
      if (lookahead == '\r') SKIP(9);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 11:
      if (lookahead == '\n') SKIP(172);
      END_STATE();
    case 12:
      if (lookahead == '\n') SKIP(172);
      if (lookahead == '\r') SKIP(11);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 13:
      if (lookahead == '\n') SKIP(173);
      END_STATE();
    case 14:
      if (lookahead == '\n') SKIP(173);
      if (lookahead == '\r') SKIP(13);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 15:
      if (lookahead == '\n') SKIP(249);
      END_STATE();
    case 16:
      if (lookahead == '\n') SKIP(249);
      if (lookahead == '\r') SKIP(15);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 17:
      if (lookahead == '\n') SKIP(185);
      END_STATE();
    case 18:
      if (lookahead == '\n') SKIP(185);
      if (lookahead == '\r') SKIP(17);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 19:
      if (lookahead == '\n') SKIP(205);
      END_STATE();
    case 20:
      if (lookahead == '\n') SKIP(205);
      if (lookahead == '\r') SKIP(19);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 21:
      if (lookahead == '\n') SKIP(250);
      END_STATE();
    case 22:
      if (lookahead == '\n') SKIP(250);
      if (lookahead == '\r') SKIP(21);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 23:
      if (lookahead == '\n') SKIP(179);
      END_STATE();
    case 24:
      if (lookahead == '\n') SKIP(179);
      if (lookahead == '\r') SKIP(23);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 25:
      if (lookahead == '\n') SKIP(186);
      END_STATE();
    case 26:
      if (lookahead == '\n') SKIP(186);
      if (lookahead == '\r') SKIP(25);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 27:
      if (lookahead == '\n') SKIP(176);
      END_STATE();
    case 28:
      if (lookahead == '\n') SKIP(176);
      if (lookahead == '\r') SKIP(27);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 29:
      if (lookahead == '\n') SKIP(177);
      END_STATE();
    case 30:
      if (lookahead == '\n') SKIP(177);
      if (lookahead == '\r') SKIP(29);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 31:
      if (lookahead == '\n') SKIP(198);
      END_STATE();
    case 32:
      if (lookahead == '\n') SKIP(198);
      if (lookahead == '\r') SKIP(31);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 33:
      if (lookahead == '\n') SKIP(194);
      END_STATE();
    case 34:
      if (lookahead == '\n') SKIP(194);
      if (lookahead == '\r') SKIP(33);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 35:
      if (lookahead == '\n') SKIP(206);
      END_STATE();
    case 36:
      if (lookahead == '\n') SKIP(206);
      if (lookahead == '\r') SKIP(35);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 37:
      if (lookahead == '\n') SKIP(204);
      END_STATE();
    case 38:
      if (lookahead == '\n') SKIP(204);
      if (lookahead == '\r') SKIP(37);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 39:
      if (lookahead == '\n') SKIP(235);
      END_STATE();
    case 40:
      if (lookahead == '\n') SKIP(235);
      if (lookahead == '\r') SKIP(39);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 41:
      if (lookahead == '\n') SKIP(187);
      END_STATE();
    case 42:
      if (lookahead == '\n') SKIP(187);
      if (lookahead == '\r') SKIP(41);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 43:
      if (lookahead == '\n') SKIP(195);
      END_STATE();
    case 44:
      if (lookahead == '\n') SKIP(195);
      if (lookahead == '\r') SKIP(43);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 45:
      if (lookahead == '\n') SKIP(199);
      END_STATE();
    case 46:
      if (lookahead == '\n') SKIP(199);
      if (lookahead == '\r') SKIP(45);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 47:
      if (lookahead == '\n') SKIP(248);
      END_STATE();
    case 48:
      if (lookahead == '\n') SKIP(248);
      if (lookahead == '\r') SKIP(47);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 49:
      if (lookahead == '\n') SKIP(189);
      END_STATE();
    case 50:
      if (lookahead == '\n') SKIP(189);
      if (lookahead == '\r') SKIP(49);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 51:
      if (lookahead == '\n') SKIP(207);
      END_STATE();
    case 52:
      if (lookahead == '\n') SKIP(207);
      if (lookahead == '\r') SKIP(51);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 53:
      if (lookahead == '\n') SKIP(243);
      END_STATE();
    case 54:
      if (lookahead == '\n') SKIP(243);
      if (lookahead == '\r') SKIP(53);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 55:
      if (lookahead == '\n') SKIP(215);
      END_STATE();
    case 56:
      if (lookahead == '\n') SKIP(215);
      if (lookahead == '\r') SKIP(55);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 57:
      if (lookahead == '\n') SKIP(219);
      END_STATE();
    case 58:
      if (lookahead == '\n') SKIP(219);
      if (lookahead == '\r') SKIP(57);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 59:
      if (lookahead == '\n') SKIP(252);
      END_STATE();
    case 60:
      if (lookahead == '\n') SKIP(252);
      if (lookahead == '\r') SKIP(59);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 61:
      if (lookahead == '\n') SKIP(190);
      END_STATE();
    case 62:
      if (lookahead == '\n') SKIP(190);
      if (lookahead == '\r') SKIP(61);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 63:
      if (lookahead == '\n') SKIP(226);
      END_STATE();
    case 64:
      if (lookahead == '\n') SKIP(226);
      if (lookahead == '\r') SKIP(63);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 65:
      if (lookahead == '\n') SKIP(236);
      END_STATE();
    case 66:
      if (lookahead == '\n') SKIP(236);
      if (lookahead == '\r') SKIP(65);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 67:
      if (lookahead == '\n') SKIP(196);
      END_STATE();
    case 68:
      if (lookahead == '\n') SKIP(196);
      if (lookahead == '\r') SKIP(67);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 69:
      if (lookahead == '\n') SKIP(200);
      END_STATE();
    case 70:
      if (lookahead == '\n') SKIP(200);
      if (lookahead == '\r') SKIP(69);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 71:
      if (lookahead == '\n') SKIP(251);
      END_STATE();
    case 72:
      if (lookahead == '\n') SKIP(251);
      if (lookahead == '\r') SKIP(71);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 73:
      if (lookahead == '\n') SKIP(222);
      END_STATE();
    case 74:
      if (lookahead == '\n') SKIP(222);
      if (lookahead == '\r') SKIP(73);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 75:
      if (lookahead == '\n') SKIP(230);
      END_STATE();
    case 76:
      if (lookahead == '\n') SKIP(230);
      if (lookahead == '\r') SKIP(75);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 77:
      if (lookahead == '\n') SKIP(213);
      END_STATE();
    case 78:
      if (lookahead == '\n') SKIP(213);
      if (lookahead == '\r') SKIP(77);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 79:
      if (lookahead == '\n') SKIP(229);
      END_STATE();
    case 80:
      if (lookahead == '\n') SKIP(229);
      if (lookahead == '\r') SKIP(79);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 81:
      if (lookahead == '\n') SKIP(228);
      END_STATE();
    case 82:
      if (lookahead == '\n') SKIP(228);
      if (lookahead == '\r') SKIP(81);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 83:
      if (lookahead == '\n') SKIP(221);
      END_STATE();
    case 84:
      if (lookahead == '\n') SKIP(221);
      if (lookahead == '\r') SKIP(83);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 85:
      if (lookahead == '\n') SKIP(180);
      END_STATE();
    case 86:
      if (lookahead == '\n') SKIP(180);
      if (lookahead == '\r') SKIP(85);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 87:
      if (lookahead == '\n') SKIP(254);
      END_STATE();
    case 88:
      if (lookahead == '\n') SKIP(254);
      if (lookahead == '\r') SKIP(87);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 89:
      if (lookahead == '\n') SKIP(253);
      END_STATE();
    case 90:
      if (lookahead == '\n') SKIP(253);
      if (lookahead == '\r') SKIP(89);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 91:
      if (lookahead == '\n') SKIP(255);
      END_STATE();
    case 92:
      if (lookahead == '\n') SKIP(255);
      if (lookahead == '\r') SKIP(91);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 93:
      if (lookahead == '\n') SKIP(256);
      END_STATE();
    case 94:
      if (lookahead == '\n') SKIP(256);
      if (lookahead == '\r') SKIP(93);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 95:
      if (lookahead == '\n') SKIP(234);
      END_STATE();
    case 96:
      if (lookahead == '\n') SKIP(234);
      if (lookahead == '\r') SKIP(95);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 97:
      if (lookahead == '\n') SKIP(263);
      END_STATE();
    case 98:
      if (lookahead == '\n') SKIP(263);
      if (lookahead == '\r') SKIP(97);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 99:
      if (lookahead == '\n') SKIP(188);
      END_STATE();
    case 100:
      if (lookahead == '\n') SKIP(188);
      if (lookahead == '\r') SKIP(99);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 101:
      if (lookahead == '\n') SKIP(103);
      END_STATE();
    case 102:
      if (lookahead == '\n') SKIP(103);
      if (lookahead == '\r') SKIP(101);
      END_STATE();
    case 103:
      ADVANCE_MAP(
        '\n', 361,
        '!', 284,
        '%', 442,
        '&', 452,
        '(', 417,
        '*', 438,
        '+', 431,
        '-', 421,
        '/', 440,
        '<', 466,
        '=', 285,
        '>', 457,
      );
      if (lookahead == '\\') SKIP(102);
      if (lookahead == '^') ADVANCE(449);
      if (lookahead == '|') ADVANCE(448);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(103);
      END_STATE();
    case 104:
      if (lookahead == '\n') SKIP(257);
      END_STATE();
    case 105:
      if (lookahead == '\n') SKIP(257);
      if (lookahead == '\r') SKIP(104);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 106:
      if (lookahead == '\n') SKIP(258);
      END_STATE();
    case 107:
      if (lookahead == '\n') SKIP(258);
      if (lookahead == '\r') SKIP(106);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 108:
      if (lookahead == '\n') SKIP(244);
      END_STATE();
    case 109:
      if (lookahead == '\n') SKIP(244);
      if (lookahead == '\r') SKIP(108);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 110:
      if (lookahead == '\n') SKIP(262);
      END_STATE();
    case 111:
      if (lookahead == '\n') SKIP(262);
      if (lookahead == '\r') SKIP(110);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 112:
      if (lookahead == '\n') SKIP(245);
      END_STATE();
    case 113:
      if (lookahead == '\n') SKIP(245);
      if (lookahead == '\r') SKIP(112);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 114:
      if (lookahead == '\n') SKIP(246);
      if (lookahead == '"') ADVANCE(539);
      if (lookahead == '/') ADVANCE(540);
      if (lookahead == '\\') ADVANCE(115);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(543);
      if (lookahead != 0) ADVANCE(544);
      END_STATE();
    case 115:
      if (lookahead == '\n') ADVANCE(546);
      if (lookahead == '\r') ADVANCE(545);
      if (lookahead == 'U') ADVANCE(346);
      if (lookahead == 'u') ADVANCE(338);
      if (lookahead == 'x') ADVANCE(334);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(548);
      if (lookahead != 0) ADVANCE(545);
      END_STATE();
    case 116:
      if (lookahead == '\n') ADVANCE(354);
      if (lookahead == '\r') ADVANCE(120);
      if (lookahead == '(') ADVANCE(356);
      if (lookahead == '/') ADVANCE(382);
      if (lookahead == '\\') ADVANCE(377);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(276);
      if (lookahead != 0) ADVANCE(384);
      END_STATE();
    case 117:
      if (lookahead == '\n') ADVANCE(354);
      if (lookahead == '\r') ADVANCE(120);
      if (lookahead == '/') ADVANCE(382);
      if (lookahead == '\\') ADVANCE(377);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(276);
      if (lookahead != 0) ADVANCE(384);
      END_STATE();
    case 118:
      if (lookahead == '\n') ADVANCE(354);
      if (lookahead == '\r') ADVANCE(119);
      if (lookahead == '(') ADVANCE(417);
      if (lookahead == '/') ADVANCE(267);
      if (lookahead == '\\') SKIP(123);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(264);
      END_STATE();
    case 119:
      if (lookahead == '\n') ADVANCE(354);
      if (lookahead == '(') ADVANCE(417);
      if (lookahead == '/') ADVANCE(267);
      if (lookahead == '\\') SKIP(123);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(264);
      END_STATE();
    case 120:
      if (lookahead == '\n') ADVANCE(354);
      if (lookahead == '/') ADVANCE(382);
      if (lookahead == '\\') ADVANCE(377);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(276);
      if (lookahead != 0) ADVANCE(384);
      END_STATE();
    case 121:
      if (lookahead == '\n') SKIP(259);
      if (lookahead == '\'') ADVANCE(530);
      if (lookahead == '/') ADVANCE(533);
      if (lookahead == '\\') ADVANCE(532);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(534);
      if (lookahead != 0) ADVANCE(531);
      END_STATE();
    case 122:
      if (lookahead == '\n') SKIP(264);
      END_STATE();
    case 123:
      if (lookahead == '\n') SKIP(264);
      if (lookahead == '\r') SKIP(122);
      END_STATE();
    case 124:
      if (lookahead == '\n') SKIP(174);
      END_STATE();
    case 125:
      if (lookahead == '\n') SKIP(174);
      if (lookahead == '\r') SKIP(124);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 126:
      if (lookahead == '\n') SKIP(178);
      END_STATE();
    case 127:
      if (lookahead == '\n') SKIP(178);
      if (lookahead == '\r') SKIP(126);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 128:
      if (lookahead == '\n') SKIP(209);
      END_STATE();
    case 129:
      if (lookahead == '\n') SKIP(209);
      if (lookahead == '\r') SKIP(128);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 130:
      if (lookahead == '\n') SKIP(210);
      END_STATE();
    case 131:
      if (lookahead == '\n') SKIP(210);
      if (lookahead == '\r') SKIP(130);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 132:
      if (lookahead == '\n') SKIP(220);
      END_STATE();
    case 133:
      if (lookahead == '\n') SKIP(220);
      if (lookahead == '\r') SKIP(132);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 134:
      if (lookahead == '\n') SKIP(192);
      END_STATE();
    case 135:
      if (lookahead == '\n') SKIP(192);
      if (lookahead == '\r') SKIP(134);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 136:
      if (lookahead == '\n') SKIP(238);
      END_STATE();
    case 137:
      if (lookahead == '\n') SKIP(238);
      if (lookahead == '\r') SKIP(136);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 138:
      if (lookahead == '\n') SKIP(237);
      END_STATE();
    case 139:
      if (lookahead == '\n') SKIP(237);
      if (lookahead == '\r') SKIP(138);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 140:
      if (lookahead == '\n') SKIP(202);
      END_STATE();
    case 141:
      if (lookahead == '\n') SKIP(202);
      if (lookahead == '\r') SKIP(140);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 142:
      if (lookahead == '\n') SKIP(240);
      END_STATE();
    case 143:
      if (lookahead == '\n') SKIP(240);
      if (lookahead == '\r') SKIP(142);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 144:
      if (lookahead == '\n') SKIP(212);
      END_STATE();
    case 145:
      if (lookahead == '\n') SKIP(212);
      if (lookahead == '\r') SKIP(144);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 146:
      if (lookahead == '\n') SKIP(233);
      END_STATE();
    case 147:
      if (lookahead == '\n') SKIP(233);
      if (lookahead == '\r') SKIP(146);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 148:
      if (lookahead == '\n') SKIP(225);
      END_STATE();
    case 149:
      if (lookahead == '\n') SKIP(225);
      if (lookahead == '\r') SKIP(148);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 150:
      if (lookahead == '\n') SKIP(175);
      END_STATE();
    case 151:
      if (lookahead == '\n') SKIP(175);
      if (lookahead == '\r') SKIP(150);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 152:
      if (lookahead == '\n') SKIP(216);
      END_STATE();
    case 153:
      if (lookahead == '\n') SKIP(216);
      if (lookahead == '\r') SKIP(152);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 154:
      if (lookahead == '\n') SKIP(227);
      END_STATE();
    case 155:
      if (lookahead == '\n') SKIP(227);
      if (lookahead == '\r') SKIP(154);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 156:
      if (lookahead == '\n') SKIP(218);
      END_STATE();
    case 157:
      if (lookahead == '\n') SKIP(218);
      if (lookahead == '\r') SKIP(156);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 158:
      if (lookahead == '\n') SKIP(232);
      END_STATE();
    case 159:
      if (lookahead == '\n') SKIP(232);
      if (lookahead == '\r') SKIP(158);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 160:
      if (lookahead == '\n') SKIP(224);
      END_STATE();
    case 161:
      if (lookahead == '\n') SKIP(224);
      if (lookahead == '\r') SKIP(160);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 162:
      if (lookahead == '\n') SKIP(208);
      END_STATE();
    case 163:
      if (lookahead == '\n') SKIP(208);
      if (lookahead == '\r') SKIP(162);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 164:
      if (lookahead == '\n') SKIP(239);
      END_STATE();
    case 165:
      if (lookahead == '\n') SKIP(239);
      if (lookahead == '\r') SKIP(164);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 166:
      if (lookahead == '\n') SKIP(242);
      END_STATE();
    case 167:
      if (lookahead == '\n') SKIP(242);
      if (lookahead == '\r') SKIP(166);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 168:
      if (lookahead == '\n') SKIP(214);
      END_STATE();
    case 169:
      if (lookahead == '\n') SKIP(214);
      if (lookahead == '\r') SKIP(168);
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 170:
      if (lookahead == '\r') ADVANCE(651);
      if (lookahead == '\\') ADVANCE(645);
      if (lookahead != 0) ADVANCE(650);
      END_STATE();
    case 171:
      ADVANCE_MAP(
        '!', 419,
        '"', 539,
        '#', 297,
        '%', 443,
        '&', 453,
        '\'', 530,
        '(', 417,
        ')', 359,
        '*', 439,
        '+', 433,
        ',', 358,
        '-', 422,
        '.', 504,
        '/', 441,
        '0', 654,
        ':', 472,
        ';', 473,
        '<', 463,
        '=', 485,
        '>', 652,
        '?', 488,
        'F', 579,
        'L', 553,
        'R', 556,
        'T', 583,
        'U', 557,
        '[', 481,
        '\\', 2,
        ']', 483,
        '^', 450,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 588,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        't', 630,
        'u', 560,
        'v', 622,
        '{', 477,
        '|', 447,
        '}', 478,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(171);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(515);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 172:
      ADVANCE_MAP(
        '!', 419,
        '"', 539,
        '#', 301,
        '%', 443,
        '&', 453,
        '\'', 530,
        '(', 417,
        '*', 439,
        '+', 433,
        ',', 358,
        '-', 423,
        '.', 504,
        '/', 441,
        '0', 512,
        ':', 472,
        ';', 473,
        '<', 463,
        '=', 485,
        '>', 458,
        '?', 488,
        'F', 579,
        'L', 553,
        'R', 556,
        'T', 583,
        'U', 557,
        '[', 480,
        '\\', 12,
        '^', 450,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 588,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        't', 630,
        'u', 560,
        'v', 622,
        '{', 477,
        '|', 447,
        '}', 478,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(172);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(515);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 173:
      ADVANCE_MAP(
        '!', 419,
        '"', 539,
        '#', 301,
        '%', 442,
        '&', 452,
        '\'', 530,
        '(', 417,
        ')', 359,
        '*', 438,
        '+', 434,
        ',', 358,
        '-', 424,
        '.', 504,
        '/', 440,
        '0', 512,
        ':', 472,
        ';', 473,
        '<', 465,
        '=', 285,
        '>', 457,
        '?', 488,
        'F', 579,
        'L', 553,
        'R', 556,
        'T', 583,
        'U', 557,
        '[', 480,
        '\\', 14,
        '^', 449,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 588,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        't', 630,
        'u', 560,
        'v', 622,
        '{', 477,
        '|', 448,
        '}', 478,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(173);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(515);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 174:
      ADVANCE_MAP(
        '!', 419,
        '"', 539,
        '#', 306,
        '%', 443,
        '&', 453,
        '\'', 530,
        '(', 417,
        ')', 359,
        '*', 439,
        '+', 433,
        ',', 358,
        '-', 423,
        '.', 504,
        '/', 441,
        '0', 512,
        ':', 472,
        ';', 473,
        '<', 463,
        '=', 485,
        '>', 458,
        '?', 488,
        'F', 579,
        'L', 553,
        'R', 556,
        'T', 583,
        'U', 557,
        '[', 479,
        '\\', 125,
        ']', 483,
        '^', 450,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 588,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        't', 630,
        'u', 560,
        'v', 622,
        '{', 477,
        '|', 447,
        '}', 478,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(174);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(515);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 175:
      ADVANCE_MAP(
        '!', 419,
        '"', 539,
        '#', 306,
        '%', 442,
        '&', 452,
        '\'', 530,
        '(', 417,
        ')', 359,
        '*', 438,
        '+', 434,
        ',', 358,
        '-', 424,
        '.', 504,
        '/', 440,
        '0', 512,
        ':', 472,
        ';', 473,
        '<', 465,
        '=', 285,
        '>', 457,
        '?', 488,
        'F', 579,
        'L', 553,
        'R', 556,
        'T', 583,
        'U', 557,
        '[', 479,
        '\\', 151,
        ']', 483,
        '^', 449,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 588,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        't', 630,
        'u', 560,
        'v', 622,
        '{', 477,
        '|', 448,
        '}', 478,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(175);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(515);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 176:
      ADVANCE_MAP(
        '!', 419,
        '"', 539,
        '%', 443,
        '&', 453,
        '\'', 530,
        '(', 417,
        ')', 359,
        '*', 439,
        '+', 433,
        ',', 358,
        '-', 422,
        '.', 504,
        '/', 441,
        '0', 512,
        ':', 283,
        '<', 463,
        '=', 485,
        '>', 458,
        '?', 488,
        'F', 579,
        'L', 553,
        'R', 556,
        'T', 583,
        'U', 557,
        '[', 479,
        '\\', 28,
        '^', 450,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 588,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        't', 630,
        'u', 560,
        'v', 622,
        '{', 477,
        '|', 447,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(176);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(515);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 177:
      ADVANCE_MAP(
        '!', 419,
        '"', 539,
        '%', 443,
        '&', 453,
        '\'', 530,
        '(', 417,
        '*', 439,
        '+', 433,
        ',', 358,
        '-', 423,
        '.', 504,
        '/', 441,
        '0', 512,
        ':', 283,
        '<', 463,
        '=', 485,
        '>', 652,
        '?', 488,
        'F', 579,
        'L', 553,
        'R', 556,
        'T', 583,
        'U', 557,
        '[', 479,
        '\\', 30,
        '^', 450,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 588,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        't', 630,
        'u', 560,
        'v', 622,
        '{', 477,
        '|', 447,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(177);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(515);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 178:
      ADVANCE_MAP(
        '!', 419,
        '"', 539,
        '%', 442,
        '&', 452,
        '\'', 530,
        '(', 417,
        '*', 438,
        '+', 434,
        ',', 358,
        '-', 424,
        '.', 504,
        '/', 440,
        '0', 512,
        ':', 283,
        '<', 465,
        '=', 285,
        '>', 652,
        '?', 488,
        'F', 579,
        'L', 553,
        'R', 556,
        'T', 583,
        'U', 557,
        '[', 479,
        '\\', 127,
        '^', 449,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 588,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        't', 630,
        'u', 560,
        'v', 622,
        '{', 477,
        '|', 448,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(178);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(515);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 179:
      ADVANCE_MAP(
        '!', 419,
        '"', 247,
        '%', 443,
        '&', 453,
        '(', 265,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 426,
        '/', 441,
        ':', 283,
        '<', 463,
        '=', 485,
        '>', 458,
        '[', 294,
        '\\', 24,
        '^', 450,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 617,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        'u', 610,
        'v', 622,
        '|', 447,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(179);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 180:
      ADVANCE_MAP(
        '!', 419,
        '"', 247,
        '%', 443,
        '&', 453,
        '(', 265,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 426,
        '/', 441,
        '<', 463,
        '=', 485,
        '>', 458,
        '[', 295,
        '\\', 86,
        '^', 450,
        '|', 447,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(180);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 181:
      ADVANCE_MAP(
        '!', 418,
        '"', 539,
        '#', 297,
        '&', 452,
        '\'', 530,
        '(', 417,
        '*', 438,
        '+', 434,
        '-', 425,
        '.', 326,
        '/', 267,
        '0', 512,
        ':', 472,
        ';', 473,
        '<', 462,
        '>', 456,
        'F', 579,
        'L', 553,
        'R', 556,
        'T', 583,
        'U', 557,
        '[', 480,
        '\\', 6,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 588,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        't', 630,
        'u', 560,
        'v', 622,
        '{', 477,
        '|', 446,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(181);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(515);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 182:
      ADVANCE_MAP(
        '!', 418,
        '"', 539,
        '#', 301,
        '%', 442,
        '&', 452,
        '\'', 530,
        '(', 417,
        ')', 359,
        '*', 438,
        '+', 434,
        ',', 358,
        '-', 425,
        '.', 506,
        '/', 440,
        '0', 512,
        ':', 472,
        ';', 473,
        '<', 462,
        '=', 484,
        '>', 652,
        'F', 579,
        'L', 553,
        'R', 556,
        'T', 583,
        'U', 557,
        '[', 480,
        '\\', 4,
        ']', 296,
        '^', 449,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 588,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        't', 630,
        'u', 560,
        'v', 622,
        '{', 477,
        '|', 320,
        '}', 478,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(182);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(515);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 183:
      ADVANCE_MAP(
        '!', 418,
        '"', 539,
        '#', 305,
        '&', 451,
        '\'', 530,
        '(', 417,
        ')', 359,
        '*', 438,
        '+', 434,
        '-', 425,
        '.', 273,
        '/', 267,
        '0', 512,
        ':', 472,
        ';', 473,
        '<', 462,
        '>', 288,
        'F', 579,
        'L', 553,
        'R', 556,
        'T', 583,
        'U', 557,
        '[', 480,
        '\\', 10,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 588,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        't', 630,
        'u', 560,
        'v', 622,
        '{', 477,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(183);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(515);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 184:
      ADVANCE_MAP(
        '!', 418,
        '"', 539,
        '#', 299,
        '&', 452,
        '\'', 530,
        '(', 417,
        '*', 438,
        '+', 434,
        '-', 425,
        '.', 326,
        '/', 267,
        '0', 512,
        ':', 472,
        ';', 473,
        '<', 462,
        '>', 286,
        'F', 579,
        'L', 553,
        'R', 556,
        'T', 583,
        'U', 557,
        '[', 480,
        '\\', 8,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 588,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        't', 630,
        'u', 560,
        'v', 622,
        '{', 477,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(184);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(515);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 185:
      ADVANCE_MAP(
        '!', 418,
        '"', 539,
        '&', 452,
        '\'', 530,
        '(', 417,
        ')', 359,
        '*', 438,
        '+', 434,
        ',', 358,
        '-', 425,
        '.', 506,
        '/', 267,
        '0', 512,
        ':', 283,
        ';', 473,
        '<', 462,
        '=', 484,
        '>', 652,
        'F', 579,
        'L', 553,
        'R', 556,
        'T', 583,
        'U', 557,
        '[', 479,
        '\\', 18,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 588,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        't', 630,
        'u', 560,
        'v', 622,
        '{', 477,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(185);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(515);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 186:
      ADVANCE_MAP(
        '!', 418,
        '"', 539,
        '&', 451,
        '\'', 530,
        '(', 417,
        ')', 359,
        '*', 438,
        '+', 434,
        ',', 358,
        '-', 425,
        '.', 506,
        '/', 267,
        '0', 512,
        ':', 472,
        ';', 473,
        '<', 462,
        '=', 484,
        '>', 652,
        'F', 579,
        'L', 553,
        'R', 556,
        'T', 583,
        'U', 557,
        '[', 479,
        '\\', 26,
        ']', 483,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 588,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        't', 630,
        'u', 560,
        'v', 622,
        '{', 477,
        '}', 478,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(186);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(515);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 187:
      ADVANCE_MAP(
        '!', 418,
        '"', 539,
        '&', 451,
        '\'', 530,
        '(', 417,
        '*', 438,
        '+', 434,
        '-', 425,
        '.', 326,
        '/', 267,
        '0', 654,
        ':', 283,
        'F', 579,
        'L', 553,
        'R', 556,
        'T', 583,
        'U', 557,
        '[', 479,
        '\\', 42,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 588,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        't', 630,
        'u', 560,
        'v', 622,
        '{', 477,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(187);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(515);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 188:
      ADVANCE_MAP(
        '!', 418,
        '\'', 530,
        '(', 417,
        ')', 359,
        '+', 436,
        '-', 429,
        '.', 326,
        '/', 267,
        '0', 512,
        'L', 571,
        'U', 572,
        '\\', 100,
        'u', 573,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(188);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(515);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 189:
      ADVANCE_MAP(
        '!', 284,
        '"', 539,
        '#', 306,
        '%', 443,
        '&', 453,
        '(', 417,
        ')', 359,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 427,
        '.', 503,
        '/', 441,
        ':', 472,
        ';', 473,
        '<', 463,
        '=', 485,
        '>', 458,
        '?', 488,
        'L', 554,
        'R', 556,
        'U', 558,
        '[', 479,
        '\\', 50,
        ']', 483,
        '^', 450,
        'u', 561,
        '{', 477,
        '|', 447,
        '}', 478,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(189);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 190:
      ADVANCE_MAP(
        '!', 284,
        '"', 539,
        '#', 306,
        '%', 443,
        '&', 453,
        '(', 417,
        ')', 359,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 427,
        '.', 503,
        '/', 441,
        ':', 471,
        ';', 473,
        '<', 463,
        '=', 485,
        '>', 458,
        '?', 488,
        'L', 554,
        'R', 556,
        'U', 558,
        '[', 479,
        '\\', 62,
        ']', 483,
        '^', 450,
        'u', 561,
        '|', 447,
        '}', 478,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(190);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 191:
      ADVANCE_MAP(
        '!', 284,
        '"', 539,
        '#', 306,
        '%', 443,
        '&', 453,
        '(', 417,
        ')', 359,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 427,
        '.', 503,
        '/', 441,
        ':', 471,
        ';', 473,
        '<', 463,
        '=', 485,
        '>', 458,
        '?', 488,
        'L', 664,
        'R', 665,
        'U', 666,
        '[', 479,
        '\\', 62,
        ']', 483,
        '^', 450,
        'u', 667,
        '|', 447,
        '}', 478,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(190);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(673);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 192:
      ADVANCE_MAP(
        '!', 284,
        '"', 539,
        '#', 306,
        '%', 442,
        '&', 452,
        '(', 417,
        ')', 359,
        '*', 438,
        '+', 432,
        ',', 358,
        '-', 428,
        '.', 503,
        '/', 440,
        ':', 471,
        ';', 473,
        '<', 465,
        '=', 285,
        '>', 457,
        '?', 488,
        'L', 554,
        'R', 556,
        'U', 558,
        '[', 479,
        '\\', 135,
        ']', 483,
        '^', 449,
        'u', 561,
        '|', 448,
        '}', 478,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(192);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 193:
      ADVANCE_MAP(
        '!', 284,
        '"', 539,
        '#', 306,
        '%', 442,
        '&', 452,
        '(', 417,
        ')', 359,
        '*', 438,
        '+', 432,
        ',', 358,
        '-', 428,
        '.', 503,
        '/', 440,
        ':', 471,
        ';', 473,
        '<', 465,
        '=', 285,
        '>', 457,
        '?', 488,
        'L', 664,
        'R', 665,
        'U', 666,
        '[', 479,
        '\\', 135,
        ']', 483,
        '^', 449,
        'u', 667,
        '|', 448,
        '}', 478,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(192);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(673);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 194:
      ADVANCE_MAP(
        '!', 284,
        '"', 539,
        '%', 443,
        '&', 453,
        '(', 417,
        ')', 359,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 426,
        '.', 503,
        '/', 441,
        ':', 472,
        '<', 463,
        '=', 485,
        '>', 458,
        '?', 488,
        'L', 554,
        'R', 556,
        'U', 558,
        '[', 480,
        '\\', 34,
        '^', 450,
        'u', 561,
        '{', 477,
        '|', 447,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(194);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 195:
      ADVANCE_MAP(
        '!', 284,
        '"', 539,
        '%', 443,
        '&', 453,
        '(', 417,
        ')', 359,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 426,
        '.', 503,
        '/', 441,
        ':', 283,
        '<', 463,
        '=', 485,
        '>', 458,
        '?', 488,
        'L', 554,
        'R', 556,
        'U', 558,
        '[', 479,
        '\\', 44,
        '^', 450,
        'u', 561,
        '{', 477,
        '|', 447,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(195);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 196:
      ADVANCE_MAP(
        '!', 284,
        '"', 539,
        '%', 443,
        '&', 453,
        '(', 417,
        ')', 359,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 426,
        '.', 503,
        '/', 441,
        '<', 463,
        '=', 485,
        '>', 458,
        '?', 488,
        'L', 554,
        'R', 556,
        'U', 558,
        '[', 479,
        '\\', 68,
        '^', 450,
        'u', 561,
        '|', 447,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(196);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 197:
      ADVANCE_MAP(
        '!', 284,
        '"', 539,
        '%', 443,
        '&', 453,
        '(', 417,
        ')', 359,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 426,
        '.', 503,
        '/', 441,
        '<', 463,
        '=', 485,
        '>', 458,
        '?', 488,
        'L', 664,
        'R', 665,
        'U', 666,
        '[', 479,
        '\\', 68,
        '^', 450,
        'u', 667,
        '|', 447,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(196);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(673);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 198:
      ADVANCE_MAP(
        '!', 284,
        '"', 539,
        '%', 443,
        '&', 453,
        '(', 417,
        ')', 359,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 427,
        '.', 503,
        '/', 441,
        ':', 472,
        ';', 473,
        '<', 463,
        '=', 485,
        '>', 458,
        '?', 488,
        'L', 554,
        'R', 556,
        'U', 558,
        '[', 480,
        '\\', 32,
        '^', 450,
        'u', 561,
        '{', 477,
        '|', 447,
        '}', 478,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(198);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 199:
      ADVANCE_MAP(
        '!', 284,
        '"', 539,
        '%', 443,
        '&', 453,
        '(', 417,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 427,
        '.', 503,
        '/', 441,
        ':', 472,
        '<', 463,
        '=', 485,
        '>', 652,
        '?', 488,
        'L', 554,
        'R', 556,
        'U', 558,
        '[', 479,
        '\\', 46,
        '^', 450,
        'u', 561,
        '{', 477,
        '|', 447,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(199);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 200:
      ADVANCE_MAP(
        '!', 284,
        '"', 539,
        '%', 443,
        '&', 453,
        '(', 417,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 427,
        '.', 503,
        '/', 441,
        ':', 471,
        '<', 463,
        '=', 485,
        '>', 652,
        '?', 488,
        'L', 554,
        'R', 556,
        'U', 558,
        '[', 479,
        '\\', 70,
        '^', 450,
        'u', 561,
        '|', 447,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(200);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 201:
      ADVANCE_MAP(
        '!', 284,
        '"', 539,
        '%', 443,
        '&', 453,
        '(', 417,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 427,
        '.', 503,
        '/', 441,
        ':', 471,
        '<', 463,
        '=', 485,
        '>', 652,
        '?', 488,
        'L', 664,
        'R', 665,
        'U', 666,
        '[', 479,
        '\\', 70,
        '^', 450,
        'u', 667,
        '|', 447,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(200);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(673);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 202:
      ADVANCE_MAP(
        '!', 284,
        '"', 539,
        '%', 442,
        '&', 452,
        '(', 417,
        '*', 438,
        '+', 432,
        ',', 358,
        '-', 428,
        '.', 503,
        '/', 440,
        ':', 471,
        '<', 465,
        '=', 285,
        '>', 652,
        '?', 488,
        'L', 554,
        'R', 556,
        'U', 558,
        '[', 479,
        '\\', 141,
        '^', 449,
        'u', 561,
        '|', 448,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(202);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 203:
      ADVANCE_MAP(
        '!', 284,
        '"', 539,
        '%', 442,
        '&', 452,
        '(', 417,
        '*', 438,
        '+', 432,
        ',', 358,
        '-', 428,
        '.', 503,
        '/', 440,
        ':', 471,
        '<', 465,
        '=', 285,
        '>', 652,
        '?', 488,
        'L', 664,
        'R', 665,
        'U', 666,
        '[', 479,
        '\\', 141,
        '^', 449,
        'u', 667,
        '|', 448,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(202);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(673);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 204:
      ADVANCE_MAP(
        '!', 284,
        '#', 317,
        '%', 443,
        '&', 453,
        '(', 417,
        ')', 359,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 426,
        '.', 503,
        '/', 441,
        ':', 472,
        ';', 473,
        '<', 463,
        '=', 485,
        '>', 458,
        '?', 488,
        '[', 480,
        '\\', 38,
        '^', 450,
        '{', 477,
        '|', 447,
        '}', 478,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(204);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 205:
      ADVANCE_MAP(
        '!', 284,
        '#', 302,
        '%', 442,
        '&', 452,
        '(', 417,
        ')', 359,
        '*', 438,
        '+', 431,
        ',', 358,
        '-', 421,
        '/', 440,
        ':', 283,
        ';', 473,
        '<', 466,
        '=', 285,
        '>', 457,
        '[', 480,
        '\\', 20,
        '^', 449,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 617,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        'u', 610,
        'v', 622,
        '|', 448,
        '}', 478,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(205);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 206:
      ADVANCE_MAP(
        '!', 284,
        '#', 306,
        '%', 443,
        '&', 453,
        '(', 417,
        ')', 359,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 427,
        '.', 503,
        '/', 441,
        '0', 653,
        ':', 472,
        ';', 473,
        '<', 463,
        '=', 485,
        '>', 458,
        '?', 488,
        '[', 480,
        '\\', 36,
        '^', 450,
        '{', 477,
        '|', 447,
        '}', 478,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(206);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 207:
      ADVANCE_MAP(
        '!', 284,
        '#', 306,
        '%', 443,
        '&', 453,
        '(', 417,
        ')', 359,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 427,
        '.', 503,
        '/', 441,
        ':', 472,
        ';', 473,
        '<', 463,
        '=', 485,
        '>', 458,
        '?', 488,
        '[', 479,
        '\\', 52,
        ']', 483,
        '^', 450,
        '{', 477,
        '|', 447,
        '}', 478,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(207);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 208:
      ADVANCE_MAP(
        '!', 284,
        '#', 306,
        '%', 443,
        '&', 453,
        '(', 417,
        ')', 359,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 427,
        '.', 503,
        '/', 441,
        ':', 471,
        ';', 473,
        '<', 463,
        '=', 485,
        '>', 458,
        '?', 488,
        '[', 480,
        '\\', 163,
        ']', 483,
        '^', 450,
        '{', 477,
        '|', 447,
        '}', 478,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(208);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 209:
      ADVANCE_MAP(
        '!', 284,
        '#', 306,
        '%', 443,
        '&', 453,
        '(', 417,
        ')', 359,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 427,
        '.', 503,
        '/', 441,
        ':', 471,
        ';', 473,
        '<', 463,
        '=', 485,
        '>', 458,
        '?', 488,
        '[', 479,
        '\\', 129,
        ']', 483,
        '^', 450,
        '{', 477,
        '|', 447,
        '}', 478,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(209);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 210:
      ADVANCE_MAP(
        '!', 284,
        '#', 306,
        '%', 443,
        '&', 453,
        '(', 417,
        ')', 359,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 427,
        '.', 503,
        '/', 441,
        ':', 471,
        ';', 473,
        '<', 463,
        '=', 485,
        '>', 458,
        '?', 488,
        '[', 479,
        '\\', 131,
        ']', 483,
        '^', 450,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 617,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        'u', 610,
        'v', 622,
        '{', 477,
        '|', 447,
        '}', 478,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(210);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 211:
      ADVANCE_MAP(
        '!', 284,
        '#', 306,
        '%', 443,
        '&', 453,
        '(', 417,
        ')', 359,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 427,
        '.', 503,
        '/', 441,
        ':', 471,
        ';', 473,
        '<', 463,
        '=', 485,
        '>', 458,
        '?', 488,
        '[', 479,
        '\\', 145,
        ']', 483,
        '^', 450,
        '|', 447,
        '}', 478,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(212);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(673);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 212:
      ADVANCE_MAP(
        '!', 284,
        '#', 306,
        '%', 443,
        '&', 453,
        '(', 417,
        ')', 359,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 427,
        '.', 503,
        '/', 441,
        ':', 471,
        ';', 473,
        '<', 463,
        '=', 485,
        '>', 458,
        '?', 488,
        '[', 479,
        '\\', 145,
        ']', 483,
        '^', 450,
        '|', 447,
        '}', 478,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(212);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 213:
      ADVANCE_MAP(
        '!', 284,
        '#', 306,
        '%', 443,
        '&', 453,
        '(', 417,
        ')', 359,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 427,
        '.', 503,
        '/', 441,
        ':', 471,
        ';', 473,
        '<', 463,
        '=', 485,
        '>', 458,
        '?', 488,
        '[', 482,
        '\\', 78,
        ']', 483,
        '^', 450,
        '|', 447,
        '}', 478,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(213);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 214:
      ADVANCE_MAP(
        '!', 284,
        '#', 306,
        '%', 442,
        '&', 452,
        '(', 417,
        ')', 359,
        '*', 438,
        '+', 432,
        ',', 358,
        '-', 428,
        '.', 503,
        '/', 440,
        ':', 472,
        ';', 473,
        '<', 465,
        '=', 285,
        '>', 457,
        '?', 488,
        '[', 479,
        '\\', 169,
        ']', 483,
        '^', 449,
        '{', 477,
        '|', 448,
        '}', 478,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(214);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 215:
      ADVANCE_MAP(
        '!', 284,
        '#', 306,
        '%', 442,
        '&', 452,
        '(', 417,
        ')', 359,
        '*', 438,
        '+', 432,
        ',', 358,
        '-', 428,
        '.', 503,
        '/', 440,
        ':', 471,
        ';', 473,
        '<', 465,
        '=', 285,
        '>', 457,
        '?', 488,
        '[', 479,
        '\\', 56,
        ']', 483,
        '^', 449,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 617,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        'u', 610,
        'v', 622,
        '{', 477,
        '|', 448,
        '}', 478,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(215);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 216:
      ADVANCE_MAP(
        '!', 284,
        '#', 306,
        '%', 442,
        '&', 452,
        '(', 417,
        ')', 359,
        '*', 438,
        '+', 432,
        ',', 358,
        '-', 428,
        '.', 503,
        '/', 440,
        ':', 471,
        ';', 473,
        '<', 465,
        '=', 285,
        '>', 457,
        '?', 488,
        '[', 479,
        '\\', 153,
        ']', 483,
        '^', 449,
        '{', 477,
        '|', 448,
        '}', 478,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(216);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 217:
      ADVANCE_MAP(
        '!', 284,
        '#', 306,
        '%', 442,
        '&', 452,
        '(', 417,
        ')', 359,
        '*', 438,
        '+', 432,
        ',', 358,
        '-', 428,
        '.', 503,
        '/', 440,
        ':', 471,
        ';', 473,
        '<', 465,
        '=', 285,
        '>', 457,
        '?', 488,
        '[', 479,
        '\\', 157,
        ']', 483,
        '^', 449,
        '|', 448,
        '}', 478,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(218);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(673);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 218:
      ADVANCE_MAP(
        '!', 284,
        '#', 306,
        '%', 442,
        '&', 452,
        '(', 417,
        ')', 359,
        '*', 438,
        '+', 432,
        ',', 358,
        '-', 428,
        '.', 503,
        '/', 440,
        ':', 471,
        ';', 473,
        '<', 465,
        '=', 285,
        '>', 457,
        '?', 488,
        '[', 479,
        '\\', 157,
        ']', 483,
        '^', 449,
        '|', 448,
        '}', 478,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(218);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 219:
      ADVANCE_MAP(
        '!', 284,
        '%', 443,
        '&', 453,
        '(', 417,
        ')', 359,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 426,
        '.', 503,
        '/', 441,
        ':', 472,
        '<', 463,
        '=', 485,
        '>', 458,
        '?', 488,
        '[', 479,
        '\\', 58,
        '^', 450,
        '{', 477,
        '|', 447,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(219);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 220:
      ADVANCE_MAP(
        '!', 284,
        '%', 443,
        '&', 453,
        '(', 417,
        ')', 359,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 426,
        '.', 503,
        '/', 441,
        ':', 471,
        '<', 463,
        '=', 485,
        '>', 458,
        '?', 488,
        '[', 479,
        '\\', 133,
        '^', 450,
        '{', 477,
        '|', 447,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(220);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 221:
      ADVANCE_MAP(
        '!', 284,
        '%', 443,
        '&', 453,
        '(', 417,
        ')', 359,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 426,
        '.', 503,
        '/', 441,
        '<', 463,
        '=', 485,
        '>', 458,
        '?', 488,
        '[', 481,
        '\\', 84,
        '^', 450,
        '|', 447,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(221);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 222:
      ADVANCE_MAP(
        '!', 284,
        '%', 443,
        '&', 453,
        '(', 417,
        ')', 359,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 426,
        '.', 503,
        '/', 441,
        '<', 463,
        '=', 485,
        '>', 458,
        '?', 488,
        '[', 479,
        '\\', 74,
        '^', 450,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 617,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        'u', 610,
        'v', 622,
        '{', 477,
        '|', 447,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(222);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 223:
      ADVANCE_MAP(
        '!', 284,
        '%', 443,
        '&', 453,
        '(', 417,
        ')', 359,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 426,
        '.', 503,
        '/', 441,
        '<', 463,
        '=', 485,
        '>', 458,
        '?', 488,
        '[', 479,
        '\\', 161,
        '^', 450,
        '|', 447,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(224);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(673);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 224:
      ADVANCE_MAP(
        '!', 284,
        '%', 443,
        '&', 453,
        '(', 417,
        ')', 359,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 426,
        '.', 503,
        '/', 441,
        '<', 463,
        '=', 485,
        '>', 458,
        '?', 488,
        '[', 479,
        '\\', 161,
        '^', 450,
        '|', 447,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(224);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 225:
      ADVANCE_MAP(
        '!', 284,
        '%', 443,
        '&', 453,
        '(', 417,
        ')', 359,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 426,
        '.', 503,
        '/', 441,
        '<', 463,
        '=', 485,
        '>', 458,
        '?', 488,
        '[', 482,
        '\\', 149,
        '^', 450,
        '|', 447,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(225);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 226:
      ADVANCE_MAP(
        '!', 284,
        '%', 443,
        '&', 453,
        '(', 417,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 427,
        '.', 503,
        '/', 441,
        ':', 472,
        '<', 463,
        '=', 485,
        '>', 652,
        '?', 488,
        '[', 479,
        '\\', 64,
        '^', 450,
        '{', 477,
        '|', 447,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(226);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 227:
      ADVANCE_MAP(
        '!', 284,
        '%', 443,
        '&', 453,
        '(', 417,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 427,
        '.', 503,
        '/', 441,
        ':', 471,
        '<', 463,
        '=', 485,
        '>', 652,
        '?', 488,
        '[', 479,
        '\\', 155,
        '^', 450,
        '{', 477,
        '|', 447,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(227);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 228:
      ADVANCE_MAP(
        '!', 284,
        '%', 443,
        '&', 453,
        '(', 417,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 427,
        '.', 503,
        '/', 441,
        ';', 473,
        '<', 463,
        '=', 485,
        '>', 458,
        '?', 488,
        '[', 481,
        '\\', 82,
        '^', 450,
        '|', 447,
        '}', 478,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(228);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 229:
      ADVANCE_MAP(
        '!', 284,
        '%', 443,
        '&', 453,
        '(', 417,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 427,
        '.', 503,
        '/', 441,
        '<', 463,
        '=', 485,
        '>', 652,
        '?', 488,
        '[', 480,
        '\\', 80,
        '^', 450,
        '|', 447,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(229);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 230:
      ADVANCE_MAP(
        '!', 284,
        '%', 443,
        '&', 453,
        '(', 417,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 427,
        '.', 503,
        '/', 441,
        '<', 463,
        '=', 485,
        '>', 652,
        '?', 488,
        '[', 479,
        '\\', 76,
        '^', 450,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 617,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        'u', 610,
        'v', 622,
        '{', 477,
        '|', 447,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(230);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 231:
      ADVANCE_MAP(
        '!', 284,
        '%', 443,
        '&', 453,
        '(', 417,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 427,
        '.', 503,
        '/', 441,
        '<', 463,
        '=', 485,
        '>', 652,
        '?', 488,
        '[', 479,
        '\\', 159,
        '^', 450,
        '|', 447,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(232);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(673);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 232:
      ADVANCE_MAP(
        '!', 284,
        '%', 443,
        '&', 453,
        '(', 417,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 427,
        '.', 503,
        '/', 441,
        '<', 463,
        '=', 485,
        '>', 652,
        '?', 488,
        '[', 479,
        '\\', 159,
        '^', 450,
        '|', 447,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(232);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 233:
      ADVANCE_MAP(
        '!', 284,
        '%', 443,
        '&', 453,
        '(', 417,
        '*', 439,
        '+', 435,
        ',', 358,
        '-', 427,
        '.', 503,
        '/', 441,
        '<', 463,
        '=', 485,
        '>', 652,
        '?', 488,
        '[', 482,
        '\\', 147,
        '^', 450,
        '|', 447,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(233);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 234:
      ADVANCE_MAP(
        '!', 284,
        '%', 443,
        '&', 453,
        '*', 439,
        '+', 437,
        ',', 358,
        '-', 430,
        '.', 266,
        '/', 441,
        '<', 464,
        '=', 485,
        '>', 458,
        '\\', 96,
        '^', 450,
        '|', 447,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(234);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 235:
      ADVANCE_MAP(
        '!', 284,
        '%', 442,
        '&', 452,
        '(', 417,
        ')', 359,
        '*', 438,
        '+', 432,
        ',', 358,
        '-', 428,
        '.', 503,
        '/', 440,
        ':', 472,
        ';', 473,
        '<', 465,
        '=', 285,
        '>', 457,
        '?', 488,
        '[', 480,
        '\\', 40,
        '^', 449,
        '{', 477,
        '|', 448,
        '}', 478,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(235);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 236:
      ADVANCE_MAP(
        '!', 284,
        '%', 442,
        '&', 452,
        '(', 417,
        ')', 359,
        '*', 438,
        '+', 432,
        ',', 358,
        '-', 428,
        '.', 503,
        '/', 440,
        ':', 472,
        ';', 473,
        '<', 465,
        '=', 285,
        '>', 457,
        '?', 488,
        '[', 479,
        '\\', 66,
        ']', 483,
        '^', 449,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 617,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        'u', 610,
        'v', 622,
        '{', 477,
        '|', 448,
        '}', 478,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(236);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 237:
      ADVANCE_MAP(
        '!', 284,
        '%', 442,
        '&', 452,
        '(', 417,
        ')', 359,
        '*', 438,
        '+', 432,
        ',', 358,
        '-', 428,
        '.', 503,
        '/', 440,
        ':', 283,
        ';', 473,
        '<', 465,
        '=', 285,
        '>', 457,
        '?', 488,
        '[', 479,
        '\\', 139,
        ']', 296,
        '^', 449,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 617,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        'u', 610,
        'v', 622,
        '{', 477,
        '|', 448,
        '}', 478,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(237);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 238:
      ADVANCE_MAP(
        '!', 284,
        '%', 442,
        '&', 452,
        '(', 417,
        '*', 438,
        '+', 432,
        ',', 358,
        '-', 428,
        '.', 503,
        '/', 440,
        ':', 472,
        '<', 465,
        '=', 485,
        '>', 652,
        '?', 488,
        '[', 479,
        '\\', 137,
        '^', 449,
        '{', 477,
        '|', 448,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(238);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 239:
      ADVANCE_MAP(
        '!', 284,
        '%', 442,
        '&', 452,
        '(', 417,
        '*', 438,
        '+', 432,
        ',', 358,
        '-', 428,
        '.', 503,
        '/', 440,
        ':', 471,
        '<', 465,
        '=', 285,
        '>', 652,
        '?', 488,
        '[', 479,
        '\\', 165,
        '^', 449,
        '{', 477,
        '|', 448,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(239);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 240:
      ADVANCE_MAP(
        '!', 284,
        '%', 442,
        '&', 452,
        '(', 417,
        '*', 438,
        '+', 432,
        ',', 358,
        '-', 428,
        '.', 503,
        '/', 440,
        '<', 465,
        '=', 285,
        '>', 652,
        '?', 488,
        '[', 479,
        '\\', 143,
        '^', 449,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 617,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        'u', 610,
        'v', 622,
        '{', 477,
        '|', 448,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(240);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 241:
      ADVANCE_MAP(
        '!', 284,
        '%', 442,
        '&', 452,
        '(', 417,
        '*', 438,
        '+', 432,
        ',', 358,
        '-', 428,
        '.', 503,
        '/', 440,
        '<', 465,
        '=', 285,
        '>', 652,
        '?', 488,
        '[', 479,
        '\\', 167,
        '^', 449,
        '|', 448,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(242);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(673);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 242:
      ADVANCE_MAP(
        '!', 284,
        '%', 442,
        '&', 452,
        '(', 417,
        '*', 438,
        '+', 432,
        ',', 358,
        '-', 428,
        '.', 503,
        '/', 440,
        '<', 465,
        '=', 285,
        '>', 652,
        '?', 488,
        '[', 479,
        '\\', 167,
        '^', 449,
        '|', 448,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(242);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 243:
      ADVANCE_MAP(
        '"', 539,
        '&', 452,
        '(', 417,
        '*', 438,
        '/', 267,
        ':', 283,
        'L', 555,
        'U', 559,
        '[', 480,
        '\\', 54,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 617,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        'u', 562,
        'v', 622,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(243);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 244:
      ADVANCE_MAP(
        '"', 539,
        ')', 359,
        ',', 358,
        '/', 267,
        ':', 471,
        'L', 554,
        'R', 556,
        'U', 558,
        '\\', 109,
        'u', 561,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(244);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 245:
      if (lookahead == '"') ADVANCE(539);
      if (lookahead == '/') ADVANCE(267);
      if (lookahead == '<') ADVANCE(290);
      if (lookahead == 'L') ADVANCE(555);
      if (lookahead == 'U') ADVANCE(559);
      if (lookahead == '\\') ADVANCE(113);
      if (lookahead == 'u') ADVANCE(563);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(245);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 246:
      if (lookahead == '"') ADVANCE(539);
      if (lookahead == '/') ADVANCE(267);
      if (lookahead == '\\') ADVANCE(115);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(246);
      END_STATE();
    case 247:
      if (lookahead == '"') ADVANCE(663);
      END_STATE();
    case 248:
      ADVANCE_MAP(
        '#', 306,
        '&', 452,
        '(', 417,
        ')', 359,
        '*', 438,
        ',', 358,
        '-', 289,
        '.', 505,
        '/', 267,
        ':', 472,
        ';', 473,
        '<', 462,
        '=', 484,
        '>', 652,
        '[', 480,
        '\\', 48,
        '{', 477,
        '|', 320,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(248);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 249:
      ADVANCE_MAP(
        '#', 298,
        '&', 452,
        '(', 417,
        ')', 359,
        '*', 438,
        '+', 431,
        ',', 358,
        '-', 289,
        '.', 505,
        '/', 267,
        ':', 472,
        ';', 473,
        '<', 462,
        '=', 484,
        '>', 652,
        '[', 480,
        '\\', 16,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 617,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        'u', 610,
        'v', 622,
        '{', 477,
        '|', 320,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(249);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 250:
      ADVANCE_MAP(
        '#', 300,
        '&', 452,
        '(', 417,
        '*', 438,
        ',', 358,
        '/', 267,
        ':', 283,
        ';', 473,
        '[', 480,
        '\\', 22,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 617,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        'u', 610,
        'v', 622,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(250);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 251:
      ADVANCE_MAP(
        '&', 452,
        '(', 417,
        ')', 359,
        '*', 438,
        ',', 358,
        '-', 289,
        '.', 505,
        '/', 267,
        ':', 472,
        ';', 473,
        '<', 462,
        '=', 484,
        '>', 652,
        '[', 479,
        '\\', 72,
        '{', 477,
        '|', 320,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(251);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 252:
      ADVANCE_MAP(
        '&', 452,
        '(', 417,
        ')', 359,
        '*', 438,
        ',', 358,
        '-', 289,
        '.', 505,
        '/', 267,
        ':', 471,
        ';', 473,
        '<', 462,
        '=', 484,
        '>', 652,
        '[', 480,
        '\\', 60,
        '{', 477,
        '|', 320,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(252);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 253:
      ADVANCE_MAP(
        '&', 452,
        '(', 417,
        ')', 359,
        '*', 438,
        ',', 358,
        '-', 289,
        '.', 505,
        '/', 267,
        ':', 471,
        ';', 473,
        '=', 484,
        '>', 652,
        '[', 480,
        '\\', 90,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 617,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        'u', 610,
        'v', 622,
        '{', 477,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(253);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 254:
      ADVANCE_MAP(
        '&', 452,
        '(', 417,
        ')', 359,
        '*', 438,
        ',', 358,
        '-', 289,
        '.', 505,
        '/', 267,
        ':', 471,
        ';', 473,
        '=', 484,
        '>', 652,
        '[', 479,
        '\\', 88,
        '{', 477,
        '|', 320,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(254);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 255:
      ADVANCE_MAP(
        '&', 452,
        '(', 417,
        ')', 359,
        '*', 438,
        ',', 358,
        '.', 505,
        '/', 267,
        ':', 471,
        ';', 473,
        '=', 484,
        '>', 652,
        '[', 479,
        '\\', 92,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 617,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        'u', 610,
        'v', 622,
        '{', 477,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(255);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 256:
      ADVANCE_MAP(
        '&', 452,
        '(', 417,
        ')', 359,
        '*', 438,
        ',', 358,
        '.', 502,
        '/', 267,
        ':', 472,
        ';', 473,
        '<', 462,
        '[', 479,
        '\\', 94,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 617,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        'u', 610,
        'v', 622,
        '{', 477,
        '|', 320,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(256);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 257:
      ADVANCE_MAP(
        '&', 451,
        '(', 417,
        ')', 359,
        ',', 358,
        '.', 272,
        '/', 267,
        ':', 471,
        ';', 473,
        '=', 484,
        '>', 652,
        '[', 479,
        '\\', 105,
        '{', 477,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(257);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 258:
      ADVANCE_MAP(
        '&', 451,
        '(', 417,
        ')', 359,
        ',', 358,
        '/', 267,
        ':', 471,
        ';', 473,
        '=', 484,
        '>', 652,
        '[', 480,
        '\\', 107,
        '{', 477,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(258);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 259:
      if (lookahead == '\'') ADVANCE(530);
      if (lookahead == '/') ADVANCE(267);
      if (lookahead == '\\') ADVANCE(115);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(259);
      END_STATE();
    case 260:
      if (lookahead == '\'') ADVANCE(331);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(321);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(260);
      END_STATE();
    case 261:
      if (lookahead == '\'') ADVANCE(327);
      if (lookahead == '.') ADVANCE(519);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(321);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(261);
      END_STATE();
    case 262:
      ADVANCE_MAP(
        '(', 417,
        ')', 359,
        ',', 358,
        '/', 267,
        ':', 471,
        ';', 473,
        '<', 462,
        '=', 484,
        '>', 652,
        '[', 481,
        '\\', 111,
        '{', 477,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(262);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 263:
      ADVANCE_MAP(
        '(', 417,
        '/', 267,
        ':', 283,
        'F', 579,
        'T', 583,
        '[', 479,
        '\\', 98,
        'f', 589,
        't', 630,
        '{', 477,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(263);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 264:
      if (lookahead == '(') ADVANCE(417);
      if (lookahead == '/') ADVANCE(267);
      if (lookahead == '\\') SKIP(123);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(264);
      END_STATE();
    case 265:
      if (lookahead == ')') ADVANCE(661);
      END_STATE();
    case 266:
      if (lookahead == '*') ADVANCE(507);
      END_STATE();
    case 267:
      if (lookahead == '*') ADVANCE(270);
      if (lookahead == '/') ADVANCE(650);
      END_STATE();
    case 268:
      if (lookahead == '*') ADVANCE(660);
      END_STATE();
    case 269:
      if (lookahead == '*') ADVANCE(269);
      if (lookahead == '/') ADVANCE(643);
      if (lookahead != 0) ADVANCE(270);
      END_STATE();
    case 270:
      if (lookahead == '*') ADVANCE(269);
      if (lookahead != 0) ADVANCE(270);
      END_STATE();
    case 271:
      if (lookahead == '*') ADVANCE(269);
      if (lookahead != 0) ADVANCE(375);
      END_STATE();
    case 272:
      if (lookahead == '.') ADVANCE(274);
      END_STATE();
    case 273:
      if (lookahead == '.') ADVANCE(274);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(511);
      END_STATE();
    case 274:
      if (lookahead == '.') ADVANCE(357);
      END_STATE();
    case 275:
      if (lookahead == '.') ADVANCE(331);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(517);
      END_STATE();
    case 276:
      if (lookahead == '/') ADVANCE(382);
      if (lookahead == '\\') ADVANCE(377);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(276);
      if (lookahead != 0) ADVANCE(384);
      END_STATE();
    case 277:
      if (lookahead == '1') ADVANCE(281);
      END_STATE();
    case 278:
      if (lookahead == '2') ADVANCE(510);
      END_STATE();
    case 279:
      if (lookahead == '2') ADVANCE(282);
      if (lookahead == '6') ADVANCE(510);
      END_STATE();
    case 280:
      if (lookahead == '4') ADVANCE(510);
      END_STATE();
    case 281:
      if (lookahead == '6') ADVANCE(510);
      END_STATE();
    case 282:
      if (lookahead == '8') ADVANCE(510);
      END_STATE();
    case 283:
      if (lookahead == ':') ADVANCE(474);
      END_STATE();
    case 284:
      if (lookahead == '=') ADVANCE(455);
      END_STATE();
    case 285:
      if (lookahead == '=') ADVANCE(454);
      END_STATE();
    case 286:
      if (lookahead == '=') ADVANCE(459);
      if (lookahead == '>') ADVANCE(469);
      END_STATE();
    case 287:
      if (lookahead == '=') ADVANCE(495);
      END_STATE();
    case 288:
      if (lookahead == '>') ADVANCE(287);
      END_STATE();
    case 289:
      if (lookahead == '>') ADVANCE(508);
      END_STATE();
    case 290:
      if (lookahead == '>') ADVANCE(549);
      if (lookahead == '\\') ADVANCE(291);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(290);
      END_STATE();
    case 291:
      if (lookahead == '>') ADVANCE(550);
      if (lookahead == '\\') ADVANCE(291);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(290);
      END_STATE();
    case 292:
      if (lookahead == 'F') ADVANCE(277);
      END_STATE();
    case 293:
      if (lookahead == 'U') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 294:
      if (lookahead == '[') ADVANCE(475);
      if (lookahead == ']') ADVANCE(662);
      END_STATE();
    case 295:
      if (lookahead == ']') ADVANCE(662);
      END_STATE();
    case 296:
      if (lookahead == ']') ADVANCE(476);
      END_STATE();
    case 297:
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == 'e') ADVANCE(411);
      if (lookahead == 'i') ADVANCE(399);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(297);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 298:
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == 'e') ADVANCE(411);
      if (lookahead == 'i') ADVANCE(400);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(298);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 299:
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == 'e') ADVANCE(413);
      if (lookahead == 'i') ADVANCE(399);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(299);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 300:
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == 'e') ADVANCE(413);
      if (lookahead == 'i') ADVANCE(400);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(300);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 301:
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == 'i') ADVANCE(399);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(301);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 302:
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == 'i') ADVANCE(400);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(302);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 303:
      if (lookahead == 'd') ADVANCE(315);
      END_STATE();
    case 304:
      if (lookahead == 'd') ADVANCE(309);
      END_STATE();
    case 305:
      if (lookahead == 'e') ADVANCE(319);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(305);
      END_STATE();
    case 306:
      if (lookahead == 'e') ADVANCE(318);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(306);
      END_STATE();
    case 307:
      if (lookahead == 'e') ADVANCE(366);
      END_STATE();
    case 308:
      if (lookahead == 'e') ADVANCE(313);
      END_STATE();
    case 309:
      if (lookahead == 'e') ADVANCE(314);
      END_STATE();
    case 310:
      if (lookahead == 'f') ADVANCE(277);
      END_STATE();
    case 311:
      if (lookahead == 'f') ADVANCE(362);
      END_STATE();
    case 312:
      if (lookahead == 'f') ADVANCE(368);
      END_STATE();
    case 313:
      if (lookahead == 'f') ADVANCE(370);
      END_STATE();
    case 314:
      if (lookahead == 'f') ADVANCE(372);
      END_STATE();
    case 315:
      if (lookahead == 'i') ADVANCE(311);
      END_STATE();
    case 316:
      if (lookahead == 'i') ADVANCE(312);
      if (lookahead == 's') ADVANCE(307);
      END_STATE();
    case 317:
      if (lookahead == 'i') ADVANCE(400);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(317);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 318:
      if (lookahead == 'l') ADVANCE(316);
      if (lookahead == 'n') ADVANCE(303);
      END_STATE();
    case 319:
      if (lookahead == 'n') ADVANCE(303);
      END_STATE();
    case 320:
      if (lookahead == '|') ADVANCE(444);
      END_STATE();
    case 321:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(328);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(516);
      END_STATE();
    case 322:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(321);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(260);
      END_STATE();
    case 323:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(514);
      END_STATE();
    case 324:
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(261);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(513);
      END_STATE();
    case 325:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(515);
      END_STATE();
    case 326:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(511);
      END_STATE();
    case 327:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(261);
      END_STATE();
    case 328:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(516);
      END_STATE();
    case 329:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(642);
      END_STATE();
    case 330:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(517);
      END_STATE();
    case 331:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(260);
      END_STATE();
    case 332:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(545);
      END_STATE();
    case 333:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(329);
      END_STATE();
    case 334:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(332);
      END_STATE();
    case 335:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(333);
      END_STATE();
    case 336:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(334);
      END_STATE();
    case 337:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(335);
      END_STATE();
    case 338:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(336);
      END_STATE();
    case 339:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(337);
      END_STATE();
    case 340:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(338);
      END_STATE();
    case 341:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(339);
      END_STATE();
    case 342:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(340);
      END_STATE();
    case 343:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(341);
      END_STATE();
    case 344:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(342);
      END_STATE();
    case 345:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(343);
      END_STATE();
    case 346:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(344);
      END_STATE();
    case 347:
      if (lookahead != 0 &&
          lookahead != '*') ADVANCE(384);
      END_STATE();
    case 348:
      if (eof) ADVANCE(352);
      ADVANCE_MAP(
        '!', 419,
        '"', 539,
        '#', 297,
        '%', 443,
        '&', 453,
        '\'', 530,
        '(', 417,
        ')', 359,
        '*', 439,
        '+', 433,
        ',', 358,
        '-', 422,
        '.', 504,
        '/', 441,
        '0', 654,
        ':', 472,
        ';', 473,
        '<', 463,
        '=', 485,
        '>', 652,
        '?', 488,
        'F', 579,
        'L', 553,
        'R', 556,
        'T', 583,
        'U', 557,
        '[', 481,
        '\\', 2,
        ']', 483,
        '^', 450,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 588,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        't', 630,
        'u', 560,
        'v', 622,
        '{', 477,
        '|', 447,
        '}', 478,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(348);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(515);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 349:
      if (eof) ADVANCE(352);
      ADVANCE_MAP(
        '!', 419,
        '"', 539,
        '#', 301,
        '%', 443,
        '&', 453,
        '\'', 530,
        '(', 417,
        '*', 439,
        '+', 433,
        ',', 358,
        '-', 423,
        '.', 504,
        '/', 441,
        '0', 512,
        ':', 472,
        ';', 473,
        '<', 463,
        '=', 485,
        '>', 458,
        '?', 488,
        'F', 579,
        'L', 553,
        'R', 556,
        'T', 583,
        'U', 557,
        '[', 480,
        '\\', 12,
        '^', 450,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 588,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        't', 630,
        'u', 560,
        'v', 622,
        '{', 477,
        '|', 447,
        '}', 478,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(349);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(515);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 350:
      if (eof) ADVANCE(352);
      ADVANCE_MAP(
        '!', 419,
        '"', 539,
        '#', 301,
        '%', 442,
        '&', 452,
        '\'', 530,
        '(', 417,
        ')', 359,
        '*', 438,
        '+', 434,
        ',', 358,
        '-', 424,
        '.', 504,
        '/', 440,
        '0', 512,
        ':', 472,
        ';', 473,
        '<', 465,
        '=', 285,
        '>', 457,
        '?', 488,
        'F', 579,
        'L', 553,
        'R', 556,
        'T', 583,
        'U', 557,
        '[', 480,
        '\\', 14,
        '^', 449,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 588,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        't', 630,
        'u', 560,
        'v', 622,
        '{', 477,
        '|', 448,
        '}', 478,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(350);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(515);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 351:
      if (eof) ADVANCE(352);
      ADVANCE_MAP(
        '!', 418,
        '"', 539,
        '#', 301,
        '%', 442,
        '&', 452,
        '\'', 530,
        '(', 417,
        ')', 359,
        '*', 438,
        '+', 434,
        ',', 358,
        '-', 425,
        '.', 506,
        '/', 440,
        '0', 512,
        ':', 472,
        ';', 473,
        '<', 462,
        '=', 484,
        '>', 652,
        'F', 579,
        'L', 553,
        'R', 556,
        'T', 583,
        'U', 557,
        '[', 480,
        '\\', 4,
        ']', 296,
        '^', 449,
        'b', 625,
        'c', 604,
        'd', 621,
        'f', 588,
        'i', 618,
        'm', 590,
        'n', 638,
        'p', 635,
        's', 605,
        't', 630,
        'u', 560,
        'v', 622,
        '{', 477,
        '|', 320,
        '}', 478,
        '~', 420,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(351);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(515);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(642);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(aux_sym_preproc_include_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(aux_sym_preproc_include_token2);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(aux_sym_preproc_def_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(aux_sym_preproc_if_token1);
      if (lookahead == 'd') ADVANCE(395);
      if (lookahead == 'n') ADVANCE(389);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(361);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(aux_sym_preproc_else_token1);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(aux_sym_preproc_else_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      if (lookahead == 'd') ADVANCE(308);
      if (lookahead == 'n') ADVANCE(304);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      if (lookahead == 'd') ADVANCE(397);
      if (lookahead == 'n') ADVANCE(390);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token1);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token2);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(270);
      if (lookahead == '*') ADVANCE(374);
      if (lookahead == '/') ADVANCE(643);
      if (lookahead == '\\') ADVANCE(380);
      if (lookahead != 0) ADVANCE(375);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(270);
      if (lookahead == '*') ADVANCE(374);
      if (lookahead == '/') ADVANCE(271);
      if (lookahead == '\\') ADVANCE(380);
      if (lookahead != 0) ADVANCE(375);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(650);
      if (lookahead == '\r') ADVANCE(644);
      if (lookahead == '/') ADVANCE(647);
      if (lookahead == '\\') ADVANCE(646);
      if (lookahead != 0) ADVANCE(648);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') SKIP(276);
      if (lookahead == '\r') ADVANCE(378);
      if (lookahead == '/') ADVANCE(347);
      if (lookahead == '\\') ADVANCE(379);
      if (lookahead != 0) ADVANCE(384);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') SKIP(276);
      if (lookahead == '/') ADVANCE(347);
      if (lookahead == '\\') ADVANCE(379);
      if (lookahead != 0) ADVANCE(384);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(385);
      if (lookahead == '/') ADVANCE(347);
      if (lookahead == '\\') ADVANCE(379);
      if (lookahead != 0) ADVANCE(384);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(383);
      if (lookahead == '*') ADVANCE(374);
      if (lookahead == '/') ADVANCE(271);
      if (lookahead == '\\') ADVANCE(380);
      if (lookahead != 0) ADVANCE(375);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(649);
      if (lookahead == '/') ADVANCE(647);
      if (lookahead == '\\') ADVANCE(646);
      if (lookahead != 0) ADVANCE(648);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(375);
      if (lookahead == '/') ADVANCE(647);
      if (lookahead == '\\') ADVANCE(379);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(384);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(374);
      if (lookahead == '/') ADVANCE(271);
      if (lookahead == '\\') ADVANCE(380);
      if (lookahead != 0) ADVANCE(375);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(347);
      if (lookahead == '\\') ADVANCE(379);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(384);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(347);
      if (lookahead == '\\') ADVANCE(379);
      if (lookahead != 0) ADVANCE(384);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'c') ADVANCE(412);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(410);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(394);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(396);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(398);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(401);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(367);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(355);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(353);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(404);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(405);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(406);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(407);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(360);
      if (lookahead == 'n') ADVANCE(386);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(360);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(408);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(369);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(363);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(364);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(365);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(371);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(373);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(414);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(402);
      if (lookahead == 's') ADVANCE(392);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(403);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(409);
      if (lookahead == 'n') ADVANCE(387);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(415);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n') ADVANCE(387);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n') ADVANCE(393);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'u') ADVANCE(388);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(416);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(455);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '.') ADVANCE(326);
      if (lookahead == '0') ADVANCE(512);
      if (lookahead == '=') ADVANCE(493);
      if (lookahead == '>') ADVANCE(509);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(515);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '.') ADVANCE(326);
      if (lookahead == '0') ADVANCE(512);
      if (lookahead == '=') ADVANCE(493);
      if (lookahead == '>') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(515);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '.') ADVANCE(326);
      if (lookahead == '0') ADVANCE(512);
      if (lookahead == '>') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(515);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '.') ADVANCE(326);
      if (lookahead == '0') ADVANCE(512);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(515);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '=') ADVANCE(493);
      if (lookahead == '>') ADVANCE(509);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '=') ADVANCE(493);
      if (lookahead == '>') ADVANCE(508);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '>') ADVANCE(508);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(326);
      if (lookahead == '0') ADVANCE(512);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(515);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(493);
      if (lookahead == '>') ADVANCE(268);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(501);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(501);
      if (lookahead == '.') ADVANCE(326);
      if (lookahead == '0') ADVANCE(512);
      if (lookahead == '=') ADVANCE(492);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(515);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(501);
      if (lookahead == '.') ADVANCE(326);
      if (lookahead == '0') ADVANCE(512);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(515);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(501);
      if (lookahead == '=') ADVANCE(492);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '.') ADVANCE(326);
      if (lookahead == '0') ADVANCE(512);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(515);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(492);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(489);
      END_STATE();
    case 440:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(270);
      if (lookahead == '/') ADVANCE(650);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(270);
      if (lookahead == '/') ADVANCE(650);
      if (lookahead == '=') ADVANCE(490);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(491);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(498);
      if (lookahead == '|') ADVANCE(444);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(444);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(497);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(445);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(445);
      if (lookahead == '=') ADVANCE(496);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(459);
      if (lookahead == '>') ADVANCE(469);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(459);
      if (lookahead == '>') ADVANCE(470);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '>') ADVANCE(499);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(468);
      if (lookahead == '=') ADVANCE(461);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(468);
      if (lookahead == '=') ADVANCE(460);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(467);
      if (lookahead == '=') ADVANCE(461);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(467);
      if (lookahead == '=') ADVANCE(460);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(494);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(495);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(474);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 478:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[') ADVANCE(475);
      END_STATE();
    case 481:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[') ADVANCE(475);
      if (lookahead == ']') ADVANCE(662);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == ']') ADVANCE(662);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(454);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(sym_primitive_type);
      if (lookahead == '1') ADVANCE(578);
      if (lookahead == '3') ADVANCE(576);
      if (lookahead == '6') ADVANCE(577);
      if (lookahead == '8') ADVANCE(587);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'p') ADVANCE(636);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(sym_primitive_type);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 488:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 494:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 495:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(anon_sym_LT_EQ_GT);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 502:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '*') ADVANCE(507);
      if (lookahead == '.') ADVANCE(274);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '*') ADVANCE(507);
      if (lookahead == '.') ADVANCE(274);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(511);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(274);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(274);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(511);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(anon_sym_DOT_STAR);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      if (lookahead == '*') ADVANCE(660);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(sym_number_literal);
      END_STATE();
    case 511:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 326,
        'B', 292,
        'b', 310,
        'E', 321,
        'e', 321,
        'F', 518,
        'f', 518,
        'L', 510,
        'l', 510,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(511);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 324,
        '.', 519,
        'L', 520,
        'l', 523,
        'B', 323,
        'b', 323,
        'E', 321,
        'e', 321,
        'U', 522,
        'u', 522,
        'X', 275,
        'x', 275,
        'Z', 525,
        'z', 525,
        '8', 261,
        '9', 261,
      );
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(513);
      END_STATE();
    case 513:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 324,
        '.', 519,
        'L', 520,
        'l', 523,
        'E', 321,
        'e', 321,
        'U', 522,
        'u', 522,
        'Z', 525,
        'z', 525,
        '8', 261,
        '9', 261,
      );
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(513);
      END_STATE();
    case 514:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 323,
        'L', 520,
        'l', 523,
        'U', 522,
        'u', 522,
        'Z', 525,
        'z', 525,
        '0', 514,
        '1', 514,
      );
      END_STATE();
    case 515:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 325,
        '.', 519,
        'L', 520,
        'l', 523,
        'E', 321,
        'e', 321,
        'U', 522,
        'u', 522,
        'Z', 525,
        'z', 525,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(515);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(328);
      if (lookahead == 'B') ADVANCE(292);
      if (lookahead == 'b') ADVANCE(310);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(518);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(510);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(516);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 330,
        '.', 322,
        'L', 520,
        'l', 523,
        'P', 321,
        'p', 321,
        'U', 522,
        'u', 522,
        'Z', 525,
        'z', 525,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(517);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '1') ADVANCE(279);
      if (lookahead == '3') ADVANCE(278);
      if (lookahead == '6') ADVANCE(280);
      END_STATE();
    case 519:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        'B', 292,
        'b', 310,
        'E', 321,
        'e', 321,
        'F', 518,
        'f', 518,
        'L', 510,
        'l', 510,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(511);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L') ADVANCE(525);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(510);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L') ADVANCE(510);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L') ADVANCE(521);
      if (lookahead == 'l') ADVANCE(524);
      if (lookahead == 'Z' ||
          lookahead == 'z') ADVANCE(510);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'l') ADVANCE(525);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(510);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'l') ADVANCE(510);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(510);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(anon_sym_L_SQUOTE);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(anon_sym_u_SQUOTE);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(anon_sym_U_SQUOTE);
      END_STATE();
    case 529:
      ACCEPT_TOKEN(anon_sym_u8_SQUOTE);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '\n') ADVANCE(546);
      if (lookahead == '\r') ADVANCE(545);
      if (lookahead == 'U') ADVANCE(346);
      if (lookahead == 'u') ADVANCE(338);
      if (lookahead == 'x') ADVANCE(334);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(548);
      if (lookahead != 0) ADVANCE(545);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '*') ADVANCE(270);
      if (lookahead == '/') ADVANCE(650);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '\\') ADVANCE(115);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(anon_sym_L_DQUOTE);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(anon_sym_u_DQUOTE);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(anon_sym_U_DQUOTE);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(anon_sym_u8_DQUOTE);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(542);
      if (lookahead == '/') ADVANCE(544);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(544);
      END_STATE();
    case 541:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(541);
      if (lookahead == '/') ADVANCE(544);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(542);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(541);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(542);
      END_STATE();
    case 543:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '/') ADVANCE(540);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(543);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(544);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(544);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(115);
      END_STATE();
    case 547:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(545);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(547);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(sym_system_lib_string);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(sym_system_lib_string);
      if (lookahead == '>') ADVANCE(549);
      if (lookahead == '\\') ADVANCE(291);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(290);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(sym_true);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(sym_false);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(535);
      if (lookahead == '\'') ADVANCE(526);
      if (lookahead == 'R') ADVANCE(564);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(535);
      if (lookahead == 'R') ADVANCE(564);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 555:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(535);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 556:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(655);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 557:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(537);
      if (lookahead == '\'') ADVANCE(528);
      if (lookahead == 'R') ADVANCE(565);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(537);
      if (lookahead == 'R') ADVANCE(565);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(537);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 560:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(536);
      if (lookahead == '\'') ADVANCE(527);
      if (lookahead == '8') ADVANCE(566);
      if (lookahead == 'R') ADVANCE(569);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'i') ADVANCE(620);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(536);
      if (lookahead == '8') ADVANCE(567);
      if (lookahead == 'R') ADVANCE(569);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 562:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(536);
      if (lookahead == '8') ADVANCE(568);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'i') ADVANCE(620);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(536);
      if (lookahead == '8') ADVANCE(568);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(656);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(658);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(538);
      if (lookahead == '\'') ADVANCE(529);
      if (lookahead == 'R') ADVANCE(570);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(538);
      if (lookahead == 'R') ADVANCE(570);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(538);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(657);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(659);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 571:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(526);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(528);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 573:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(527);
      if (lookahead == '8') ADVANCE(574);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 574:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(529);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 575:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '1') ADVANCE(578);
      if (lookahead == '3') ADVANCE(576);
      if (lookahead == '6') ADVANCE(577);
      if (lookahead == '8') ADVANCE(587);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'p') ADVANCE(636);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '2') ADVANCE(587);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 577:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '4') ADVANCE(587);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '6') ADVANCE(587);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 579:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'A') ADVANCE(582);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'E') ADVANCE(551);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 581:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'E') ADVANCE(552);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 582:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'L') ADVANCE(584);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'R') ADVANCE(585);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 584:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'S') ADVANCE(581);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'U') ADVANCE(580);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 586:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == '_') ADVANCE(593);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 587:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == '_') ADVANCE(633);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'a') ADVANCE(611);
      if (lookahead == 'l') ADVANCE(623);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'a') ADVANCE(611);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'a') ADVANCE(640);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'a') ADVANCE(627);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'a') ADVANCE(633);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'a') ADVANCE(615);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'b') ADVANCE(616);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'd') ADVANCE(487);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'd') ADVANCE(607);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'e') ADVANCE(551);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'e') ADVANCE(487);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'e') ADVANCE(552);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 600:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'e') ADVANCE(587);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 601:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'f') ADVANCE(587);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 602:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'f') ADVANCE(601);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'g') ADVANCE(619);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 604:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'h') ADVANCE(591);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 605:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'i') ADVANCE(641);
      if (lookahead == 's') ADVANCE(606);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 606:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'i') ADVANCE(641);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 607:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'i') ADVANCE(602);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 608:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'i') ADVANCE(603);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 609:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'i') ADVANCE(595);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 610:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'i') ADVANCE(620);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 611:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'l') ADVANCE(631);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 612:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'l') ADVANCE(487);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 613:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'l') ADVANCE(626);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 614:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'l') ADVANCE(613);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 615:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'l') ADVANCE(608);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 616:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'l') ADVANCE(598);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 617:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'l') ADVANCE(623);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 618:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'n') ADVANCE(632);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 619:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'n') ADVANCE(587);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 620:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'n') ADVANCE(634);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 621:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'o') ADVANCE(637);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 622:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'o') ADVANCE(609);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 623:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'o') ADVANCE(592);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 624:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'o') ADVANCE(612);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 625:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'o') ADVANCE(624);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 626:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'p') ADVANCE(636);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 627:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'r') ADVANCE(486);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 628:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'r') ADVANCE(596);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 629:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'r') ADVANCE(587);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 630:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'r') ADVANCE(639);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 631:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 's') ADVANCE(599);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 632:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 't') ADVANCE(486);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 633:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 't') ADVANCE(487);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 634:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 't') ADVANCE(575);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 635:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 't') ADVANCE(628);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 636:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 't') ADVANCE(629);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 637:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'u') ADVANCE(594);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 638:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'u') ADVANCE(614);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 639:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'u') ADVANCE(597);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 640:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'x') ADVANCE(586);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 641:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (lookahead == 'z') ADVANCE(600);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 642:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(293);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 643:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 644:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n') ADVANCE(650);
      if (lookahead == '/') ADVANCE(647);
      if (lookahead == '\\') ADVANCE(381);
      if (lookahead != 0) ADVANCE(648);
      END_STATE();
    case 645:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\r') ADVANCE(651);
      if (lookahead == '\\') ADVANCE(645);
      if (lookahead != 0) ADVANCE(650);
      END_STATE();
    case 646:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\r') ADVANCE(649);
      if (lookahead == '/') ADVANCE(647);
      if (lookahead == '\\') ADVANCE(646);
      if (lookahead != 0) ADVANCE(648);
      END_STATE();
    case 647:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '*') ADVANCE(650);
      if (lookahead == '\\') ADVANCE(376);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(648);
      END_STATE();
    case 648:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(647);
      if (lookahead == '\\') ADVANCE(381);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(648);
      END_STATE();
    case 649:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(647);
      if (lookahead == '\\') ADVANCE(381);
      if (lookahead != 0) ADVANCE(648);
      END_STATE();
    case 650:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(170);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(650);
      END_STATE();
    case 651:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(170);
      if (lookahead != 0) ADVANCE(650);
      END_STATE();
    case 652:
      ACCEPT_TOKEN(anon_sym_GT2);
      END_STATE();
    case 653:
      ACCEPT_TOKEN(anon_sym_0);
      END_STATE();
    case 654:
      ACCEPT_TOKEN(anon_sym_0);
      ADVANCE_MAP(
        '\'', 324,
        '.', 519,
        'L', 520,
        'l', 523,
        'B', 323,
        'b', 323,
        'E', 321,
        'e', 321,
        'U', 522,
        'u', 522,
        'X', 275,
        'x', 275,
        'Z', 525,
        'z', 525,
        '8', 261,
        '9', 261,
      );
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(513);
      END_STATE();
    case 655:
      ACCEPT_TOKEN(anon_sym_R_DQUOTE);
      END_STATE();
    case 656:
      ACCEPT_TOKEN(anon_sym_LR_DQUOTE);
      END_STATE();
    case 657:
      ACCEPT_TOKEN(anon_sym_uR_DQUOTE);
      END_STATE();
    case 658:
      ACCEPT_TOKEN(anon_sym_UR_DQUOTE);
      END_STATE();
    case 659:
      ACCEPT_TOKEN(anon_sym_u8R_DQUOTE);
      END_STATE();
    case 660:
      ACCEPT_TOKEN(anon_sym_DASH_GT_STAR);
      END_STATE();
    case 661:
      ACCEPT_TOKEN(anon_sym_LPAREN_RPAREN);
      END_STATE();
    case 662:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK);
      END_STATE();
    case 663:
      ACCEPT_TOKEN(anon_sym_DQUOTE_DQUOTE);
      END_STATE();
    case 664:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(535);
      if (lookahead == 'R') ADVANCE(668);
      if (lookahead == '\\') ADVANCE(293);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(673);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 665:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(655);
      if (lookahead == '\\') ADVANCE(293);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(673);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 666:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(537);
      if (lookahead == 'R') ADVANCE(669);
      if (lookahead == '\\') ADVANCE(293);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(673);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 667:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(536);
      if (lookahead == '8') ADVANCE(670);
      if (lookahead == 'R') ADVANCE(671);
      if (lookahead == '\\') ADVANCE(293);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(673);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 668:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(656);
      if (lookahead == '\\') ADVANCE(293);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(673);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 669:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(658);
      if (lookahead == '\\') ADVANCE(293);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(673);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 670:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(538);
      if (lookahead == 'R') ADVANCE(672);
      if (lookahead == '\\') ADVANCE(293);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(673);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 671:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(657);
      if (lookahead == '\\') ADVANCE(293);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(673);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 672:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(659);
      if (lookahead == '\\') ADVANCE(293);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(673);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    case 673:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '\\') ADVANCE(293);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(673);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(642);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'N') ADVANCE(1);
      if (lookahead == 'T') ADVANCE(2);
      if (lookahead == '\\') SKIP(3);
      if (lookahead == '_') ADVANCE(4);
      if (lookahead == 'a') ADVANCE(5);
      if (lookahead == 'b') ADVANCE(6);
      if (lookahead == 'c') ADVANCE(7);
      if (lookahead == 'd') ADVANCE(8);
      if (lookahead == 'e') ADVANCE(9);
      if (lookahead == 'f') ADVANCE(10);
      if (lookahead == 'g') ADVANCE(11);
      if (lookahead == 'i') ADVANCE(12);
      if (lookahead == 'l') ADVANCE(13);
      if (lookahead == 'm') ADVANCE(14);
      if (lookahead == 'n') ADVANCE(15);
      if (lookahead == 'o') ADVANCE(16);
      if (lookahead == 'p') ADVANCE(17);
      if (lookahead == 'r') ADVANCE(18);
      if (lookahead == 's') ADVANCE(19);
      if (lookahead == 't') ADVANCE(20);
      if (lookahead == 'u') ADVANCE(21);
      if (lookahead == 'v') ADVANCE(22);
      if (lookahead == 'w') ADVANCE(23);
      if (lookahead == 'x') ADVANCE(24);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'U') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'h') ADVANCE(26);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(0);
      if (lookahead == '\r') SKIP(27);
      END_STATE();
    case 4:
      if (lookahead == 'A') ADVANCE(28);
      if (lookahead == 'G') ADVANCE(29);
      if (lookahead == 'N') ADVANCE(30);
      if (lookahead == '_') ADVANCE(31);
      if (lookahead == 'a') ADVANCE(32);
      if (lookahead == 'u') ADVANCE(33);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(34);
      if (lookahead == 'n') ADVANCE(35);
      if (lookahead == 's') ADVANCE(36);
      if (lookahead == 'u') ADVANCE(37);
      END_STATE();
    case 6:
      if (lookahead == 'i') ADVANCE(38);
      if (lookahead == 'r') ADVANCE(39);
      END_STATE();
    case 7:
      if (lookahead == 'a') ADVANCE(40);
      if (lookahead == 'b') ADVANCE(41);
      if (lookahead == 'e') ADVANCE(42);
      if (lookahead == 'l') ADVANCE(43);
      if (lookahead == 'o') ADVANCE(44);
      END_STATE();
    case 8:
      if (lookahead == 'e') ADVANCE(45);
      if (lookahead == 'i') ADVANCE(46);
      if (lookahead == 'o') ADVANCE(47);
      END_STATE();
    case 9:
      if (lookahead == 'l') ADVANCE(48);
      if (lookahead == 'n') ADVANCE(49);
      if (lookahead == 'x') ADVANCE(50);
      END_STATE();
    case 10:
      if (lookahead == 'i') ADVANCE(51);
      if (lookahead == 'o') ADVANCE(52);
      if (lookahead == 'r') ADVANCE(53);
      END_STATE();
    case 11:
      if (lookahead == 'e') ADVANCE(54);
      if (lookahead == 'l') ADVANCE(55);
      if (lookahead == 'o') ADVANCE(56);
      if (lookahead == 'r') ADVANCE(57);
      END_STATE();
    case 12:
      if (lookahead == 'f') ADVANCE(58);
      if (lookahead == 'm') ADVANCE(59);
      if (lookahead == 'n') ADVANCE(60);
      if (lookahead == 's') ADVANCE(61);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(62);
      if (lookahead == 'i') ADVANCE(63);
      if (lookahead == 'o') ADVANCE(64);
      END_STATE();
    case 14:
      if (lookahead == 'u') ADVANCE(65);
      END_STATE();
    case 15:
      if (lookahead == 'a') ADVANCE(66);
      if (lookahead == 'e') ADVANCE(67);
      if (lookahead == 'o') ADVANCE(68);
      if (lookahead == 'u') ADVANCE(69);
      END_STATE();
    case 16:
      if (lookahead == 'f') ADVANCE(70);
      if (lookahead == 'p') ADVANCE(71);
      if (lookahead == 'r') ADVANCE(72);
      if (lookahead == 'u') ADVANCE(73);
      if (lookahead == 'v') ADVANCE(74);
      END_STATE();
    case 17:
      if (lookahead == 'o') ADVANCE(75);
      if (lookahead == 'r') ADVANCE(76);
      if (lookahead == 'u') ADVANCE(77);
      END_STATE();
    case 18:
      if (lookahead == 'e') ADVANCE(78);
      if (lookahead == 'o') ADVANCE(79);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(80);
      if (lookahead == 'e') ADVANCE(81);
      if (lookahead == 'h') ADVANCE(82);
      if (lookahead == 'i') ADVANCE(83);
      if (lookahead == 'n') ADVANCE(84);
      if (lookahead == 't') ADVANCE(85);
      if (lookahead == 'w') ADVANCE(86);
      END_STATE();
    case 20:
      if (lookahead == 'e') ADVANCE(87);
      if (lookahead == 'h') ADVANCE(88);
      if (lookahead == 'r') ADVANCE(89);
      if (lookahead == 'y') ADVANCE(90);
      END_STATE();
    case 21:
      if (lookahead == 'n') ADVANCE(91);
      if (lookahead == 's') ADVANCE(92);
      END_STATE();
    case 22:
      if (lookahead == 'a') ADVANCE(93);
      if (lookahead == 'i') ADVANCE(94);
      if (lookahead == 'o') ADVANCE(95);
      END_STATE();
    case 23:
      if (lookahead == 'h') ADVANCE(96);
      END_STATE();
    case 24:
      if (lookahead == 'o') ADVANCE(97);
      END_STATE();
    case 25:
      if (lookahead == 'L') ADVANCE(98);
      END_STATE();
    case 26:
      if (lookahead == 'i') ADVANCE(99);
      END_STATE();
    case 27:
      if (lookahead == '\n') SKIP(0);
      END_STATE();
    case 28:
      if (lookahead == 'l') ADVANCE(100);
      if (lookahead == 't') ADVANCE(101);
      END_STATE();
    case 29:
      if (lookahead == 'e') ADVANCE(102);
      END_STATE();
    case 30:
      if (lookahead == 'o') ADVANCE(103);
      END_STATE();
    case 31:
      ADVANCE_MAP(
        'a', 104,
        'b', 105,
        'c', 106,
        'd', 107,
        'e', 108,
        'f', 109,
        'i', 110,
        'l', 111,
        'r', 112,
        's', 113,
        't', 114,
        'u', 115,
        'v', 116,
      );
      END_STATE();
    case 32:
      if (lookahead == 'l') ADVANCE(117);
      END_STATE();
    case 33:
      if (lookahead == 'n') ADVANCE(118);
      END_STATE();
    case 34:
      if (lookahead == 'i') ADVANCE(119);
      END_STATE();
    case 35:
      if (lookahead == 'd') ADVANCE(120);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'm') ADVANCE(121);
      if (lookahead == 's') ADVANCE(122);
      END_STATE();
    case 37:
      if (lookahead == 't') ADVANCE(123);
      END_STATE();
    case 38:
      if (lookahead == 't') ADVANCE(124);
      END_STATE();
    case 39:
      if (lookahead == 'e') ADVANCE(125);
      END_STATE();
    case 40:
      if (lookahead == 's') ADVANCE(126);
      if (lookahead == 't') ADVANCE(127);
      END_STATE();
    case 41:
      if (lookahead == 'u') ADVANCE(128);
      END_STATE();
    case 42:
      if (lookahead == 'n') ADVANCE(129);
      END_STATE();
    case 43:
      if (lookahead == 'a') ADVANCE(130);
      END_STATE();
    case 44:
      if (lookahead == '_') ADVANCE(131);
      if (lookahead == 'l') ADVANCE(132);
      if (lookahead == 'm') ADVANCE(133);
      if (lookahead == 'n') ADVANCE(134);
      END_STATE();
    case 45:
      if (lookahead == 'c') ADVANCE(135);
      if (lookahead == 'f') ADVANCE(136);
      if (lookahead == 'l') ADVANCE(137);
      END_STATE();
    case 46:
      if (lookahead == 's') ADVANCE(138);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 48:
      if (lookahead == 's') ADVANCE(139);
      END_STATE();
    case 49:
      if (lookahead == 'u') ADVANCE(140);
      END_STATE();
    case 50:
      if (lookahead == 'p') ADVANCE(141);
      if (lookahead == 't') ADVANCE(142);
      END_STATE();
    case 51:
      if (lookahead == 'n') ADVANCE(143);
      END_STATE();
    case 52:
      if (lookahead == 'r') ADVANCE(144);
      END_STATE();
    case 53:
      if (lookahead == 'i') ADVANCE(145);
      END_STATE();
    case 54:
      if (lookahead == 't') ADVANCE(146);
      END_STATE();
    case 55:
      if (lookahead == 'o') ADVANCE(147);
      END_STATE();
    case 56:
      if (lookahead == 't') ADVANCE(148);
      END_STATE();
    case 57:
      if (lookahead == 'o') ADVANCE(149);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 59:
      if (lookahead == 'p') ADVANCE(150);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'l') ADVANCE(151);
      if (lookahead == 'o') ADVANCE(152);
      if (lookahead == 't') ADVANCE(153);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 62:
      if (lookahead == 't') ADVANCE(154);
      END_STATE();
    case 63:
      if (lookahead == 'n') ADVANCE(155);
      END_STATE();
    case 64:
      if (lookahead == 'n') ADVANCE(156);
      END_STATE();
    case 65:
      if (lookahead == 't') ADVANCE(157);
      END_STATE();
    case 66:
      if (lookahead == 'm') ADVANCE(158);
      END_STATE();
    case 67:
      if (lookahead == 'w') ADVANCE(159);
      END_STATE();
    case 68:
      if (lookahead == 'e') ADVANCE(160);
      if (lookahead == 'i') ADVANCE(161);
      if (lookahead == 'p') ADVANCE(162);
      if (lookahead == 'r') ADVANCE(163);
      if (lookahead == 't') ADVANCE(164);
      END_STATE();
    case 69:
      if (lookahead == 'l') ADVANCE(165);
      END_STATE();
    case 70:
      if (lookahead == 'f') ADVANCE(166);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(167);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == '_') ADVANCE(168);
      END_STATE();
    case 73:
      if (lookahead == 't') ADVANCE(169);
      END_STATE();
    case 74:
      if (lookahead == 'e') ADVANCE(170);
      END_STATE();
    case 75:
      if (lookahead == 'i') ADVANCE(171);
      END_STATE();
    case 76:
      if (lookahead == 'e') ADVANCE(172);
      if (lookahead == 'i') ADVANCE(173);
      if (lookahead == 'o') ADVANCE(174);
      END_STATE();
    case 77:
      if (lookahead == 'b') ADVANCE(175);
      END_STATE();
    case 78:
      if (lookahead == 'g') ADVANCE(176);
      if (lookahead == 'q') ADVANCE(177);
      if (lookahead == 's') ADVANCE(178);
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 79:
      if (lookahead == 'w') ADVANCE(180);
      END_STATE();
    case 80:
      if (lookahead == 'm') ADVANCE(181);
      END_STATE();
    case 81:
      if (lookahead == 't') ADVANCE(182);
      END_STATE();
    case 82:
      if (lookahead == 'a') ADVANCE(183);
      if (lookahead == 'o') ADVANCE(184);
      END_STATE();
    case 83:
      if (lookahead == 'g') ADVANCE(185);
      if (lookahead == 'z') ADVANCE(186);
      END_STATE();
    case 84:
      if (lookahead == 'o') ADVANCE(187);
      END_STATE();
    case 85:
      if (lookahead == 'a') ADVANCE(188);
      if (lookahead == 'r') ADVANCE(189);
      END_STATE();
    case 86:
      if (lookahead == 'i') ADVANCE(190);
      END_STATE();
    case 87:
      if (lookahead == 'm') ADVANCE(191);
      END_STATE();
    case 88:
      if (lookahead == 'i') ADVANCE(192);
      if (lookahead == 'r') ADVANCE(193);
      END_STATE();
    case 89:
      if (lookahead == 'i') ADVANCE(194);
      if (lookahead == 'y') ADVANCE(195);
      END_STATE();
    case 90:
      if (lookahead == 'p') ADVANCE(196);
      END_STATE();
    case 91:
      if (lookahead == 'i') ADVANCE(197);
      if (lookahead == 'o') ADVANCE(198);
      if (lookahead == 's') ADVANCE(199);
      END_STATE();
    case 92:
      if (lookahead == 'i') ADVANCE(200);
      END_STATE();
    case 93:
      if (lookahead == 'r') ADVANCE(201);
      END_STATE();
    case 94:
      if (lookahead == 'r') ADVANCE(202);
      END_STATE();
    case 95:
      if (lookahead == 'l') ADVANCE(203);
      END_STATE();
    case 96:
      if (lookahead == 'e') ADVANCE(204);
      if (lookahead == 'i') ADVANCE(205);
      END_STATE();
    case 97:
      if (lookahead == 'r') ADVANCE(206);
      END_STATE();
    case 98:
      if (lookahead == 'L') ADVANCE(207);
      END_STATE();
    case 99:
      if (lookahead == 's') ADVANCE(208);
      END_STATE();
    case 100:
      if (lookahead == 'i') ADVANCE(209);
      END_STATE();
    case 101:
      if (lookahead == 'o') ADVANCE(210);
      END_STATE();
    case 102:
      if (lookahead == 'n') ADVANCE(211);
      END_STATE();
    case 103:
      if (lookahead == 'r') ADVANCE(212);
      END_STATE();
    case 104:
      if (lookahead == 'l') ADVANCE(213);
      if (lookahead == 's') ADVANCE(214);
      if (lookahead == 't') ADVANCE(215);
      END_STATE();
    case 105:
      if (lookahead == 'a') ADVANCE(216);
      END_STATE();
    case 106:
      if (lookahead == 'd') ADVANCE(217);
      if (lookahead == 'l') ADVANCE(218);
      END_STATE();
    case 107:
      if (lookahead == 'e') ADVANCE(219);
      END_STATE();
    case 108:
      if (lookahead == 'x') ADVANCE(220);
      END_STATE();
    case 109:
      if (lookahead == 'a') ADVANCE(221);
      if (lookahead == 'i') ADVANCE(222);
      if (lookahead == 'o') ADVANCE(223);
      END_STATE();
    case 110:
      if (lookahead == 'n') ADVANCE(224);
      END_STATE();
    case 111:
      if (lookahead == 'e') ADVANCE(225);
      END_STATE();
    case 112:
      if (lookahead == 'e') ADVANCE(226);
      END_STATE();
    case 113:
      if (lookahead == 'p') ADVANCE(227);
      if (lookahead == 't') ADVANCE(228);
      if (lookahead == 'u') ADVANCE(229);
      END_STATE();
    case 114:
      if (lookahead == 'h') ADVANCE(230);
      if (lookahead == 'r') ADVANCE(231);
      END_STATE();
    case 115:
      if (lookahead == 'n') ADVANCE(232);
      if (lookahead == 'p') ADVANCE(233);
      END_STATE();
    case 116:
      if (lookahead == 'e') ADVANCE(234);
      END_STATE();
    case 117:
      if (lookahead == 'i') ADVANCE(235);
      END_STATE();
    case 118:
      if (lookahead == 'a') ADVANCE(236);
      END_STATE();
    case 119:
      if (lookahead == 'g') ADVANCE(237);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_and);
      if (lookahead == '_') ADVANCE(238);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_asm);
      END_STATE();
    case 122:
      if (lookahead == 'o') ADVANCE(239);
      END_STATE();
    case 123:
      if (lookahead == 'o') ADVANCE(240);
      END_STATE();
    case 124:
      if (lookahead == 'a') ADVANCE(241);
      if (lookahead == 'o') ADVANCE(242);
      END_STATE();
    case 125:
      if (lookahead == 'a') ADVANCE(243);
      END_STATE();
    case 126:
      if (lookahead == 'e') ADVANCE(244);
      END_STATE();
    case 127:
      if (lookahead == 'c') ADVANCE(245);
      END_STATE();
    case 128:
      if (lookahead == 'f') ADVANCE(246);
      END_STATE();
    case 129:
      if (lookahead == 't') ADVANCE(247);
      END_STATE();
    case 130:
      if (lookahead == 's') ADVANCE(248);
      END_STATE();
    case 131:
      if (lookahead == 'a') ADVANCE(249);
      if (lookahead == 'r') ADVANCE(250);
      if (lookahead == 'y') ADVANCE(251);
      END_STATE();
    case 132:
      if (lookahead == 'u') ADVANCE(252);
      END_STATE();
    case 133:
      if (lookahead == 'p') ADVANCE(253);
      END_STATE();
    case 134:
      if (lookahead == 'c') ADVANCE(254);
      if (lookahead == 's') ADVANCE(255);
      if (lookahead == 't') ADVANCE(256);
      END_STATE();
    case 135:
      if (lookahead == 'l') ADVANCE(257);
      END_STATE();
    case 136:
      if (lookahead == 'a') ADVANCE(258);
      if (lookahead == 'i') ADVANCE(259);
      END_STATE();
    case 137:
      if (lookahead == 'e') ADVANCE(260);
      END_STATE();
    case 138:
      if (lookahead == 'c') ADVANCE(261);
      END_STATE();
    case 139:
      if (lookahead == 'e') ADVANCE(262);
      END_STATE();
    case 140:
      if (lookahead == 'm') ADVANCE(263);
      END_STATE();
    case 141:
      if (lookahead == 'l') ADVANCE(264);
      END_STATE();
    case 142:
      if (lookahead == 'e') ADVANCE(265);
      END_STATE();
    case 143:
      if (lookahead == 'a') ADVANCE(266);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 145:
      if (lookahead == 'e') ADVANCE(267);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 147:
      if (lookahead == 'b') ADVANCE(268);
      END_STATE();
    case 148:
      if (lookahead == 'o') ADVANCE(269);
      END_STATE();
    case 149:
      if (lookahead == 'u') ADVANCE(270);
      END_STATE();
    case 150:
      if (lookahead == 'o') ADVANCE(271);
      END_STATE();
    case 151:
      if (lookahead == 'i') ADVANCE(272);
      END_STATE();
    case 152:
      if (lookahead == 'u') ADVANCE(273);
      END_STATE();
    case 153:
      if (lookahead == 'e') ADVANCE(274);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 155:
      if (lookahead == 'e') ADVANCE(275);
      END_STATE();
    case 156:
      if (lookahead == 'g') ADVANCE(276);
      END_STATE();
    case 157:
      if (lookahead == 'a') ADVANCE(277);
      END_STATE();
    case 158:
      if (lookahead == 'e') ADVANCE(278);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 160:
      if (lookahead == 'x') ADVANCE(279);
      END_STATE();
    case 161:
      if (lookahead == 'n') ADVANCE(280);
      END_STATE();
    case 162:
      if (lookahead == 'e') ADVANCE(281);
      END_STATE();
    case 163:
      if (lookahead == 'e') ADVANCE(282);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_not);
      if (lookahead == '_') ADVANCE(283);
      END_STATE();
    case 165:
      if (lookahead == 'l') ADVANCE(284);
      END_STATE();
    case 166:
      if (lookahead == 's') ADVANCE(285);
      END_STATE();
    case 167:
      if (lookahead == 'r') ADVANCE(286);
      END_STATE();
    case 168:
      if (lookahead == 'e') ADVANCE(287);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_out);
      END_STATE();
    case 170:
      if (lookahead == 'r') ADVANCE(288);
      END_STATE();
    case 171:
      if (lookahead == 'n') ADVANCE(289);
      END_STATE();
    case 172:
      if (lookahead == 'c') ADVANCE(290);
      END_STATE();
    case 173:
      if (lookahead == 'v') ADVANCE(291);
      END_STATE();
    case 174:
      if (lookahead == 'p') ADVANCE(292);
      if (lookahead == 't') ADVANCE(293);
      END_STATE();
    case 175:
      if (lookahead == 'l') ADVANCE(294);
      END_STATE();
    case 176:
      if (lookahead == 'i') ADVANCE(295);
      END_STATE();
    case 177:
      if (lookahead == 'u') ADVANCE(296);
      END_STATE();
    case 178:
      if (lookahead == 't') ADVANCE(297);
      END_STATE();
    case 179:
      if (lookahead == 'u') ADVANCE(298);
      END_STATE();
    case 180:
      if (lookahead == '_') ADVANCE(299);
      END_STATE();
    case 181:
      if (lookahead == 'p') ADVANCE(300);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 183:
      if (lookahead == 'r') ADVANCE(301);
      END_STATE();
    case 184:
      if (lookahead == 'r') ADVANCE(302);
      END_STATE();
    case 185:
      if (lookahead == 'n') ADVANCE(303);
      END_STATE();
    case 186:
      if (lookahead == 'e') ADVANCE(304);
      END_STATE();
    case 187:
      if (lookahead == 'r') ADVANCE(305);
      END_STATE();
    case 188:
      if (lookahead == 't') ADVANCE(306);
      END_STATE();
    case 189:
      if (lookahead == 'u') ADVANCE(307);
      END_STATE();
    case 190:
      if (lookahead == 't') ADVANCE(308);
      END_STATE();
    case 191:
      if (lookahead == 'p') ADVANCE(309);
      END_STATE();
    case 192:
      if (lookahead == 's') ADVANCE(310);
      END_STATE();
    case 193:
      if (lookahead == 'e') ADVANCE(311);
      if (lookahead == 'o') ADVANCE(312);
      END_STATE();
    case 194:
      if (lookahead == 'a') ADVANCE(313);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 196:
      if (lookahead == 'e') ADVANCE(314);
      END_STATE();
    case 197:
      if (lookahead == 'f') ADVANCE(315);
      if (lookahead == 'o') ADVANCE(316);
      END_STATE();
    case 198:
      if (lookahead == 'r') ADVANCE(317);
      END_STATE();
    case 199:
      if (lookahead == 'i') ADVANCE(318);
      END_STATE();
    case 200:
      if (lookahead == 'n') ADVANCE(319);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 202:
      if (lookahead == 't') ADVANCE(320);
      END_STATE();
    case 203:
      if (lookahead == 'a') ADVANCE(321);
      END_STATE();
    case 204:
      if (lookahead == 'r') ADVANCE(322);
      END_STATE();
    case 205:
      if (lookahead == 'l') ADVANCE(323);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_xor);
      if (lookahead == '_') ADVANCE(324);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_NULL);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_This);
      END_STATE();
    case 209:
      if (lookahead == 'g') ADVANCE(325);
      END_STATE();
    case 210:
      if (lookahead == 'm') ADVANCE(326);
      END_STATE();
    case 211:
      if (lookahead == 'e') ADVANCE(327);
      END_STATE();
    case 212:
      if (lookahead == 'e') ADVANCE(328);
      END_STATE();
    case 213:
      if (lookahead == 'i') ADVANCE(329);
      END_STATE();
    case 214:
      if (lookahead == 'm') ADVANCE(330);
      END_STATE();
    case 215:
      if (lookahead == 't') ADVANCE(331);
      END_STATE();
    case 216:
      if (lookahead == 's') ADVANCE(332);
      END_STATE();
    case 217:
      if (lookahead == 'e') ADVANCE(333);
      END_STATE();
    case 218:
      if (lookahead == 'r') ADVANCE(334);
      END_STATE();
    case 219:
      if (lookahead == 'c') ADVANCE(335);
      END_STATE();
    case 220:
      if (lookahead == 'c') ADVANCE(336);
      if (lookahead == 'p') ADVANCE(337);
      if (lookahead == 't') ADVANCE(338);
      END_STATE();
    case 221:
      if (lookahead == 's') ADVANCE(339);
      END_STATE();
    case 222:
      if (lookahead == 'n') ADVANCE(340);
      END_STATE();
    case 223:
      if (lookahead == 'r') ADVANCE(341);
      END_STATE();
    case 224:
      if (lookahead == 'i') ADVANCE(342);
      if (lookahead == 'l') ADVANCE(343);
      END_STATE();
    case 225:
      if (lookahead == 'a') ADVANCE(344);
      END_STATE();
    case 226:
      if (lookahead == 's') ADVANCE(345);
      END_STATE();
    case 227:
      if (lookahead == 't') ADVANCE(346);
      END_STATE();
    case 228:
      if (lookahead == 'd') ADVANCE(347);
      END_STATE();
    case 229:
      if (lookahead == 'b') ADVANCE(348);
      END_STATE();
    case 230:
      if (lookahead == 'i') ADVANCE(349);
      if (lookahead == 'r') ADVANCE(350);
      END_STATE();
    case 231:
      if (lookahead == 'y') ADVANCE(351);
      END_STATE();
    case 232:
      if (lookahead == 'a') ADVANCE(352);
      END_STATE();
    case 233:
      if (lookahead == 't') ADVANCE(353);
      END_STATE();
    case 234:
      if (lookahead == 'c') ADVANCE(354);
      END_STATE();
    case 235:
      if (lookahead == 'g') ADVANCE(355);
      END_STATE();
    case 236:
      if (lookahead == 'l') ADVANCE(356);
      END_STATE();
    case 237:
      if (lookahead == 'n') ADVANCE(357);
      END_STATE();
    case 238:
      if (lookahead == 'e') ADVANCE(358);
      END_STATE();
    case 239:
      if (lookahead == 'c') ADVANCE(359);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(sym_auto);
      END_STATE();
    case 241:
      if (lookahead == 'n') ADVANCE(360);
      END_STATE();
    case 242:
      if (lookahead == 'r') ADVANCE(361);
      END_STATE();
    case 243:
      if (lookahead == 'k') ADVANCE(362);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 245:
      if (lookahead == 'h') ADVANCE(363);
      END_STATE();
    case 246:
      if (lookahead == 'f') ADVANCE(364);
      END_STATE();
    case 247:
      if (lookahead == 'r') ADVANCE(365);
      END_STATE();
    case 248:
      if (lookahead == 's') ADVANCE(366);
      END_STATE();
    case 249:
      if (lookahead == 'w') ADVANCE(367);
      END_STATE();
    case 250:
      if (lookahead == 'e') ADVANCE(368);
      END_STATE();
    case 251:
      if (lookahead == 'i') ADVANCE(369);
      END_STATE();
    case 252:
      if (lookahead == 'm') ADVANCE(370);
      END_STATE();
    case 253:
      if (lookahead == 'l') ADVANCE(371);
      END_STATE();
    case 254:
      if (lookahead == 'e') ADVANCE(372);
      END_STATE();
    case 255:
      if (lookahead == 't') ADVANCE(373);
      END_STATE();
    case 256:
      if (lookahead == 'i') ADVANCE(374);
      END_STATE();
    case 257:
      if (lookahead == 't') ADVANCE(375);
      END_STATE();
    case 258:
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 259:
      if (lookahead == 'n') ADVANCE(377);
      END_STATE();
    case 260:
      if (lookahead == 't') ADVANCE(378);
      END_STATE();
    case 261:
      if (lookahead == 'a') ADVANCE(379);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 264:
      if (lookahead == 'i') ADVANCE(380);
      END_STATE();
    case 265:
      if (lookahead == 'n') ADVANCE(381);
      if (lookahead == 'r') ADVANCE(382);
      END_STATE();
    case 266:
      if (lookahead == 'l') ADVANCE(383);
      END_STATE();
    case 267:
      if (lookahead == 'n') ADVANCE(384);
      END_STATE();
    case 268:
      if (lookahead == 'a') ADVANCE(385);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 270:
      if (lookahead == 'p') ADVANCE(386);
      END_STATE();
    case 271:
      if (lookahead == 'r') ADVANCE(387);
      END_STATE();
    case 272:
      if (lookahead == 'n') ADVANCE(388);
      END_STATE();
    case 273:
      if (lookahead == 't') ADVANCE(389);
      END_STATE();
    case 274:
      if (lookahead == 'r') ADVANCE(390);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_line);
      if (lookahead == 'a') ADVANCE(391);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_long);
      END_STATE();
    case 277:
      if (lookahead == 'b') ADVANCE(392);
      END_STATE();
    case 278:
      if (lookahead == 's') ADVANCE(393);
      END_STATE();
    case 279:
      if (lookahead == 'c') ADVANCE(394);
      END_STATE();
    case 280:
      if (lookahead == 't') ADVANCE(395);
      END_STATE();
    case 281:
      if (lookahead == 'r') ADVANCE(396);
      END_STATE();
    case 282:
      if (lookahead == 't') ADVANCE(397);
      END_STATE();
    case 283:
      if (lookahead == 'e') ADVANCE(398);
      END_STATE();
    case 284:
      if (lookahead == 'p') ADVANCE(399);
      END_STATE();
    case 285:
      if (lookahead == 'e') ADVANCE(400);
      END_STATE();
    case 286:
      if (lookahead == 'a') ADVANCE(401);
      END_STATE();
    case 287:
      if (lookahead == 'q') ADVANCE(402);
      END_STATE();
    case 288:
      if (lookahead == 'r') ADVANCE(403);
      END_STATE();
    case 289:
      if (lookahead == 't') ADVANCE(404);
      END_STATE();
    case 290:
      if (lookahead == 'i') ADVANCE(405);
      END_STATE();
    case 291:
      if (lookahead == 'a') ADVANCE(406);
      END_STATE();
    case 292:
      if (lookahead == 'e') ADVANCE(407);
      END_STATE();
    case 293:
      if (lookahead == 'e') ADVANCE(408);
      END_STATE();
    case 294:
      if (lookahead == 'i') ADVANCE(409);
      END_STATE();
    case 295:
      if (lookahead == 's') ADVANCE(410);
      END_STATE();
    case 296:
      if (lookahead == 'i') ADVANCE(411);
      END_STATE();
    case 297:
      if (lookahead == 'r') ADVANCE(412);
      END_STATE();
    case 298:
      if (lookahead == 'r') ADVANCE(413);
      END_STATE();
    case 299:
      if (lookahead == 'm') ADVANCE(414);
      END_STATE();
    case 300:
      if (lookahead == 'l') ADVANCE(415);
      END_STATE();
    case 301:
      if (lookahead == 'e') ADVANCE(416);
      END_STATE();
    case 302:
      if (lookahead == 't') ADVANCE(417);
      END_STATE();
    case 303:
      if (lookahead == 'e') ADVANCE(418);
      END_STATE();
    case 304:
      if (lookahead == 'o') ADVANCE(419);
      END_STATE();
    case 305:
      if (lookahead == 'm') ADVANCE(420);
      END_STATE();
    case 306:
      if (lookahead == 'i') ADVANCE(421);
      END_STATE();
    case 307:
      if (lookahead == 'c') ADVANCE(422);
      END_STATE();
    case 308:
      if (lookahead == 'c') ADVANCE(423);
      END_STATE();
    case 309:
      if (lookahead == 'l') ADVANCE(424);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 311:
      if (lookahead == 'a') ADVANCE(425);
      END_STATE();
    case 312:
      if (lookahead == 'w') ADVANCE(426);
      END_STATE();
    case 313:
      if (lookahead == 'n') ADVANCE(427);
      END_STATE();
    case 314:
      if (lookahead == 'd') ADVANCE(428);
      if (lookahead == 'n') ADVANCE(429);
      END_STATE();
    case 315:
      if (lookahead == 'o') ADVANCE(430);
      END_STATE();
    case 316:
      if (lookahead == 'n') ADVANCE(431);
      END_STATE();
    case 317:
      if (lookahead == 'm') ADVANCE(432);
      END_STATE();
    case 318:
      if (lookahead == 'g') ADVANCE(433);
      END_STATE();
    case 319:
      if (lookahead == 'g') ADVANCE(434);
      END_STATE();
    case 320:
      if (lookahead == 'u') ADVANCE(435);
      END_STATE();
    case 321:
      if (lookahead == 't') ADVANCE(436);
      END_STATE();
    case 322:
      if (lookahead == 'e') ADVANCE(437);
      END_STATE();
    case 323:
      if (lookahead == 'e') ADVANCE(438);
      END_STATE();
    case 324:
      if (lookahead == 'e') ADVANCE(439);
      END_STATE();
    case 325:
      if (lookahead == 'n') ADVANCE(440);
      END_STATE();
    case 326:
      if (lookahead == 'i') ADVANCE(441);
      END_STATE();
    case 327:
      if (lookahead == 'r') ADVANCE(442);
      END_STATE();
    case 328:
      if (lookahead == 't') ADVANCE(443);
      END_STATE();
    case 329:
      if (lookahead == 'g') ADVANCE(444);
      END_STATE();
    case 330:
      if (lookahead == '_') ADVANCE(445);
      END_STATE();
    case 331:
      if (lookahead == 'r') ADVANCE(446);
      END_STATE();
    case 332:
      if (lookahead == 'e') ADVANCE(447);
      END_STATE();
    case 333:
      if (lookahead == 'c') ADVANCE(448);
      END_STATE();
    case 334:
      if (lookahead == 'c') ADVANCE(449);
      END_STATE();
    case 335:
      if (lookahead == 'l') ADVANCE(450);
      END_STATE();
    case 336:
      if (lookahead == 'e') ADVANCE(451);
      END_STATE();
    case 337:
      if (lookahead == 'o') ADVANCE(452);
      END_STATE();
    case 338:
      if (lookahead == 'e') ADVANCE(453);
      END_STATE();
    case 339:
      if (lookahead == 't') ADVANCE(454);
      END_STATE();
    case 340:
      if (lookahead == 'a') ADVANCE(455);
      END_STATE();
    case 341:
      if (lookahead == 'c') ADVANCE(456);
      END_STATE();
    case 342:
      if (lookahead == 't') ADVANCE(457);
      END_STATE();
    case 343:
      if (lookahead == 'i') ADVANCE(458);
      END_STATE();
    case 344:
      if (lookahead == 'v') ADVANCE(459);
      END_STATE();
    case 345:
      if (lookahead == 't') ADVANCE(460);
      END_STATE();
    case 346:
      if (lookahead == 'r') ADVANCE(461);
      END_STATE();
    case 347:
      if (lookahead == 'c') ADVANCE(462);
      END_STATE();
    case 348:
      if (lookahead == 's') ADVANCE(463);
      END_STATE();
    case 349:
      if (lookahead == 's') ADVANCE(464);
      END_STATE();
    case 350:
      if (lookahead == 'e') ADVANCE(465);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(anon_sym___try);
      END_STATE();
    case 352:
      if (lookahead == 'l') ADVANCE(466);
      END_STATE();
    case 353:
      if (lookahead == 'r') ADVANCE(467);
      END_STATE();
    case 354:
      if (lookahead == 't') ADVANCE(468);
      END_STATE();
    case 355:
      if (lookahead == 'n') ADVANCE(469);
      END_STATE();
    case 356:
      if (lookahead == 'i') ADVANCE(470);
      END_STATE();
    case 357:
      if (lookahead == 'a') ADVANCE(471);
      if (lookahead == 'o') ADVANCE(472);
      END_STATE();
    case 358:
      if (lookahead == 'q') ADVANCE(473);
      END_STATE();
    case 359:
      if (lookahead == 'i') ADVANCE(474);
      END_STATE();
    case 360:
      if (lookahead == 'd') ADVANCE(475);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(anon_sym_bitor);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 364:
      if (lookahead == 'e') ADVANCE(476);
      END_STATE();
    case 365:
      if (lookahead == 'o') ADVANCE(477);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 367:
      if (lookahead == 'a') ADVANCE(478);
      END_STATE();
    case 368:
      if (lookahead == 't') ADVANCE(479);
      END_STATE();
    case 369:
      if (lookahead == 'e') ADVANCE(480);
      END_STATE();
    case 370:
      if (lookahead == 'n') ADVANCE(481);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(anon_sym_compl);
      END_STATE();
    case 372:
      if (lookahead == 'p') ADVANCE(482);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(anon_sym_const);
      if (lookahead == 'e') ADVANCE(483);
      if (lookahead == 'i') ADVANCE(484);
      END_STATE();
    case 374:
      if (lookahead == 'n') ADVANCE(485);
      END_STATE();
    case 375:
      if (lookahead == 'y') ADVANCE(486);
      END_STATE();
    case 376:
      if (lookahead == 'l') ADVANCE(487);
      END_STATE();
    case 377:
      if (lookahead == 'e') ADVANCE(488);
      END_STATE();
    case 378:
      if (lookahead == 'e') ADVANCE(489);
      END_STATE();
    case 379:
      if (lookahead == 'r') ADVANCE(490);
      END_STATE();
    case 380:
      if (lookahead == 'c') ADVANCE(491);
      END_STATE();
    case 381:
      if (lookahead == 's') ADVANCE(492);
      END_STATE();
    case 382:
      if (lookahead == 'n') ADVANCE(493);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(anon_sym_final);
      END_STATE();
    case 384:
      if (lookahead == 'd') ADVANCE(494);
      END_STATE();
    case 385:
      if (lookahead == 'l') ADVANCE(495);
      END_STATE();
    case 386:
      if (lookahead == 's') ADVANCE(496);
      END_STATE();
    case 387:
      if (lookahead == 't') ADVANCE(497);
      END_STATE();
    case 388:
      if (lookahead == 'e') ADVANCE(498);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(anon_sym_inout);
      END_STATE();
    case 390:
      if (lookahead == 'f') ADVANCE(499);
      END_STATE();
    case 391:
      if (lookahead == 'd') ADVANCE(500);
      if (lookahead == 'r') ADVANCE(501);
      END_STATE();
    case 392:
      if (lookahead == 'l') ADVANCE(502);
      END_STATE();
    case 393:
      if (lookahead == 'p') ADVANCE(503);
      END_STATE();
    case 394:
      if (lookahead == 'e') ADVANCE(504);
      END_STATE();
    case 395:
      if (lookahead == 'e') ADVANCE(505);
      END_STATE();
    case 396:
      if (lookahead == 's') ADVANCE(506);
      END_STATE();
    case 397:
      if (lookahead == 'u') ADVANCE(507);
      END_STATE();
    case 398:
      if (lookahead == 'q') ADVANCE(508);
      END_STATE();
    case 399:
      if (lookahead == 't') ADVANCE(509);
      END_STATE();
    case 400:
      if (lookahead == 't') ADVANCE(510);
      END_STATE();
    case 401:
      if (lookahead == 't') ADVANCE(511);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(anon_sym_or_eq);
      END_STATE();
    case 403:
      if (lookahead == 'i') ADVANCE(512);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(anon_sym_point);
      END_STATE();
    case 405:
      if (lookahead == 's') ADVANCE(513);
      END_STATE();
    case 406:
      if (lookahead == 't') ADVANCE(514);
      END_STATE();
    case 407:
      if (lookahead == 'r') ADVANCE(515);
      END_STATE();
    case 408:
      if (lookahead == 'c') ADVANCE(516);
      END_STATE();
    case 409:
      if (lookahead == 'c') ADVANCE(517);
      END_STATE();
    case 410:
      if (lookahead == 't') ADVANCE(518);
      END_STATE();
    case 411:
      if (lookahead == 'r') ADVANCE(519);
      END_STATE();
    case 412:
      if (lookahead == 'i') ADVANCE(520);
      END_STATE();
    case 413:
      if (lookahead == 'n') ADVANCE(521);
      END_STATE();
    case 414:
      if (lookahead == 'a') ADVANCE(522);
      END_STATE();
    case 415:
      if (lookahead == 'e') ADVANCE(523);
      END_STATE();
    case 416:
      if (lookahead == 'd') ADVANCE(524);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(anon_sym_short);
      END_STATE();
    case 418:
      if (lookahead == 'd') ADVANCE(525);
      END_STATE();
    case 419:
      if (lookahead == 'f') ADVANCE(526);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(anon_sym_snorm);
      END_STATE();
    case 421:
      if (lookahead == 'c') ADVANCE(527);
      END_STATE();
    case 422:
      if (lookahead == 't') ADVANCE(528);
      END_STATE();
    case 423:
      if (lookahead == 'h') ADVANCE(529);
      END_STATE();
    case 424:
      if (lookahead == 'a') ADVANCE(530);
      END_STATE();
    case 425:
      if (lookahead == 'd') ADVANCE(531);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 427:
      if (lookahead == 'g') ADVANCE(532);
      END_STATE();
    case 428:
      if (lookahead == 'e') ADVANCE(533);
      END_STATE();
    case 429:
      if (lookahead == 'a') ADVANCE(534);
      END_STATE();
    case 430:
      if (lookahead == 'r') ADVANCE(535);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(anon_sym_unorm);
      END_STATE();
    case 433:
      if (lookahead == 'n') ADVANCE(536);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 435:
      if (lookahead == 'a') ADVANCE(537);
      END_STATE();
    case 436:
      if (lookahead == 'i') ADVANCE(538);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(anon_sym_where);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 439:
      if (lookahead == 'q') ADVANCE(539);
      END_STATE();
    case 440:
      if (lookahead == 'a') ADVANCE(540);
      if (lookahead == 'o') ADVANCE(541);
      END_STATE();
    case 441:
      if (lookahead == 'c') ADVANCE(542);
      END_STATE();
    case 442:
      if (lookahead == 'i') ADVANCE(543);
      END_STATE();
    case 443:
      if (lookahead == 'u') ADVANCE(544);
      END_STATE();
    case 444:
      if (lookahead == 'n') ADVANCE(545);
      END_STATE();
    case 445:
      if (lookahead == '_') ADVANCE(546);
      END_STATE();
    case 446:
      if (lookahead == 'i') ADVANCE(547);
      END_STATE();
    case 447:
      if (lookahead == 'd') ADVANCE(548);
      END_STATE();
    case 448:
      if (lookahead == 'l') ADVANCE(549);
      END_STATE();
    case 449:
      if (lookahead == 'a') ADVANCE(550);
      END_STATE();
    case 450:
      if (lookahead == 's') ADVANCE(551);
      END_STATE();
    case 451:
      if (lookahead == 'p') ADVANCE(552);
      END_STATE();
    case 452:
      if (lookahead == 'r') ADVANCE(553);
      END_STATE();
    case 453:
      if (lookahead == 'n') ADVANCE(554);
      END_STATE();
    case 454:
      if (lookahead == 'c') ADVANCE(555);
      END_STATE();
    case 455:
      if (lookahead == 'l') ADVANCE(556);
      END_STATE();
    case 456:
      if (lookahead == 'e') ADVANCE(557);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(anon_sym___init);
      END_STATE();
    case 458:
      if (lookahead == 'n') ADVANCE(558);
      END_STATE();
    case 459:
      if (lookahead == 'e') ADVANCE(559);
      END_STATE();
    case 460:
      if (lookahead == 'r') ADVANCE(560);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(sym_ms_signed_ptr_modifier);
      END_STATE();
    case 462:
      if (lookahead == 'a') ADVANCE(561);
      END_STATE();
    case 463:
      if (lookahead == 'c') ADVANCE(562);
      END_STATE();
    case 464:
      if (lookahead == 'c') ADVANCE(563);
      END_STATE();
    case 465:
      if (lookahead == 'a') ADVANCE(564);
      END_STATE();
    case 466:
      if (lookahead == 'i') ADVANCE(565);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(sym_ms_unsigned_ptr_modifier);
      END_STATE();
    case 468:
      if (lookahead == 'o') ADVANCE(566);
      END_STATE();
    case 469:
      if (lookahead == 'o') ADVANCE(567);
      END_STATE();
    case 470:
      if (lookahead == 'g') ADVANCE(568);
      END_STATE();
    case 471:
      if (lookahead == 's') ADVANCE(569);
      END_STATE();
    case 472:
      if (lookahead == 'f') ADVANCE(570);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(anon_sym_and_eq);
      END_STATE();
    case 474:
      if (lookahead == 'a') ADVANCE(571);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(anon_sym_bitand);
      END_STATE();
    case 476:
      if (lookahead == 'r') ADVANCE(572);
      END_STATE();
    case 477:
      if (lookahead == 'i') ADVANCE(573);
      END_STATE();
    case 478:
      if (lookahead == 'i') ADVANCE(574);
      END_STATE();
    case 479:
      if (lookahead == 'u') ADVANCE(575);
      END_STATE();
    case 480:
      if (lookahead == 'l') ADVANCE(576);
      END_STATE();
    case 481:
      if (lookahead == '_') ADVANCE(577);
      END_STATE();
    case 482:
      if (lookahead == 't') ADVANCE(578);
      END_STATE();
    case 483:
      if (lookahead == 'v') ADVANCE(579);
      if (lookahead == 'x') ADVANCE(580);
      END_STATE();
    case 484:
      if (lookahead == 'n') ADVANCE(581);
      END_STATE();
    case 485:
      if (lookahead == 'u') ADVANCE(582);
      END_STATE();
    case 486:
      if (lookahead == 'p') ADVANCE(583);
      END_STATE();
    case 487:
      if (lookahead == 't') ADVANCE(584);
      END_STATE();
    case 488:
      if (lookahead == 'd') ADVANCE(585);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 490:
      if (lookahead == 'd') ADVANCE(586);
      END_STATE();
    case 491:
      if (lookahead == 'i') ADVANCE(587);
      END_STATE();
    case 492:
      if (lookahead == 'i') ADVANCE(588);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 494:
      ACCEPT_TOKEN(anon_sym_friend);
      END_STATE();
    case 495:
      if (lookahead == 'l') ADVANCE(589);
      END_STATE();
    case 496:
      if (lookahead == 'h') ADVANCE(590);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(anon_sym_inline);
      END_STATE();
    case 499:
      if (lookahead == 'a') ADVANCE(591);
      END_STATE();
    case 500:
      if (lookahead == 'j') ADVANCE(592);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(anon_sym_linear);
      END_STATE();
    case 502:
      if (lookahead == 'e') ADVANCE(593);
      END_STATE();
    case 503:
      if (lookahead == 'a') ADVANCE(594);
      END_STATE();
    case 504:
      if (lookahead == 'p') ADVANCE(595);
      END_STATE();
    case 505:
      if (lookahead == 'r') ADVANCE(596);
      END_STATE();
    case 506:
      if (lookahead == 'p') ADVANCE(597);
      END_STATE();
    case 507:
      if (lookahead == 'r') ADVANCE(598);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(anon_sym_not_eq);
      END_STATE();
    case 509:
      if (lookahead == 'r') ADVANCE(599);
      END_STATE();
    case 510:
      if (lookahead == 'o') ADVANCE(600);
      END_STATE();
    case 511:
      if (lookahead == 'o') ADVANCE(601);
      END_STATE();
    case 512:
      if (lookahead == 'd') ADVANCE(602);
      END_STATE();
    case 513:
      if (lookahead == 'e') ADVANCE(603);
      END_STATE();
    case 514:
      if (lookahead == 'e') ADVANCE(604);
      END_STATE();
    case 515:
      if (lookahead == 't') ADVANCE(605);
      END_STATE();
    case 516:
      if (lookahead == 't') ADVANCE(606);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 518:
      if (lookahead == 'e') ADVANCE(607);
      END_STATE();
    case 519:
      if (lookahead == 'e') ADVANCE(608);
      END_STATE();
    case 520:
      if (lookahead == 'c') ADVANCE(609);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 522:
      if (lookahead == 'j') ADVANCE(610);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(anon_sym_sample);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(anon_sym_shared);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(anon_sym_signed);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(anon_sym_sizeof);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(anon_sym_static);
      if (lookahead == '_') ADVANCE(611);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 529:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 530:
      if (lookahead == 't') ADVANCE(612);
      END_STATE();
    case 531:
      if (lookahead == '_') ADVANCE(613);
      END_STATE();
    case 532:
      if (lookahead == 'l') ADVANCE(614);
      END_STATE();
    case 533:
      if (lookahead == 'f') ADVANCE(615);
      END_STATE();
    case 534:
      if (lookahead == 'm') ADVANCE(616);
      END_STATE();
    case 535:
      if (lookahead == 'm') ADVANCE(617);
      END_STATE();
    case 536:
      if (lookahead == 'e') ADVANCE(618);
      END_STATE();
    case 537:
      if (lookahead == 'l') ADVANCE(619);
      END_STATE();
    case 538:
      if (lookahead == 'l') ADVANCE(620);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(anon_sym_xor_eq);
      END_STATE();
    case 540:
      if (lookahead == 's') ADVANCE(621);
      END_STATE();
    case 541:
      if (lookahead == 'f') ADVANCE(622);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(anon_sym__Atomic);
      END_STATE();
    case 543:
      if (lookahead == 'c') ADVANCE(623);
      END_STATE();
    case 544:
      if (lookahead == 'r') ADVANCE(624);
      END_STATE();
    case 545:
      if (lookahead == 'o') ADVANCE(625);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(anon_sym___asm__);
      END_STATE();
    case 547:
      if (lookahead == 'b') ADVANCE(626);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(anon_sym___based);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(anon_sym___cdecl);
      END_STATE();
    case 550:
      if (lookahead == 'l') ADVANCE(627);
      END_STATE();
    case 551:
      if (lookahead == 'p') ADVANCE(628);
      END_STATE();
    case 552:
      if (lookahead == 't') ADVANCE(629);
      END_STATE();
    case 553:
      if (lookahead == 't') ADVANCE(630);
      END_STATE();
    case 554:
      if (lookahead == 's') ADVANCE(631);
      END_STATE();
    case 555:
      if (lookahead == 'a') ADVANCE(632);
      END_STATE();
    case 556:
      if (lookahead == 'l') ADVANCE(633);
      END_STATE();
    case 557:
      if (lookahead == 'i') ADVANCE(634);
      END_STATE();
    case 558:
      if (lookahead == 'e') ADVANCE(635);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(anon_sym___leave);
      END_STATE();
    case 560:
      if (lookahead == 'i') ADVANCE(636);
      END_STATE();
    case 561:
      if (lookahead == 'l') ADVANCE(637);
      END_STATE();
    case 562:
      if (lookahead == 'r') ADVANCE(638);
      END_STATE();
    case 563:
      if (lookahead == 'a') ADVANCE(639);
      END_STATE();
    case 564:
      if (lookahead == 'd') ADVANCE(640);
      END_STATE();
    case 565:
      if (lookahead == 'g') ADVANCE(641);
      END_STATE();
    case 566:
      if (lookahead == 'r') ADVANCE(642);
      END_STATE();
    case 567:
      if (lookahead == 'f') ADVANCE(643);
      END_STATE();
    case 568:
      if (lookahead == 'n') ADVANCE(644);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(anon_sym_alignas);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(anon_sym_alignof);
      END_STATE();
    case 571:
      if (lookahead == 't') ADVANCE(645);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(anon_sym_cbuffer);
      END_STATE();
    case 573:
      if (lookahead == 'd') ADVANCE(646);
      END_STATE();
    case 574:
      if (lookahead == 't') ADVANCE(647);
      END_STATE();
    case 575:
      if (lookahead == 'r') ADVANCE(648);
      END_STATE();
    case 576:
      if (lookahead == 'd') ADVANCE(649);
      END_STATE();
    case 577:
      if (lookahead == 'm') ADVANCE(650);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(anon_sym_concept);
      END_STATE();
    case 579:
      if (lookahead == 'a') ADVANCE(651);
      END_STATE();
    case 580:
      if (lookahead == 'p') ADVANCE(652);
      END_STATE();
    case 581:
      if (lookahead == 'i') ADVANCE(653);
      END_STATE();
    case 582:
      if (lookahead == 'e') ADVANCE(654);
      END_STATE();
    case 583:
      if (lookahead == 'e') ADVANCE(655);
      END_STATE();
    case 584:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(anon_sym_defined);
      END_STATE();
    case 586:
      ACCEPT_TOKEN(anon_sym_discard);
      END_STATE();
    case 587:
      if (lookahead == 't') ADVANCE(656);
      END_STATE();
    case 588:
      if (lookahead == 'o') ADVANCE(657);
      END_STATE();
    case 589:
      if (lookahead == 'y') ADVANCE(658);
      END_STATE();
    case 590:
      if (lookahead == 'a') ADVANCE(659);
      END_STATE();
    case 591:
      if (lookahead == 'c') ADVANCE(660);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(anon_sym_lineadj);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(anon_sym_mutable);
      END_STATE();
    case 594:
      if (lookahead == 'c') ADVANCE(661);
      END_STATE();
    case 595:
      if (lookahead == 't') ADVANCE(662);
      END_STATE();
    case 596:
      if (lookahead == 'p') ADVANCE(663);
      END_STATE();
    case 597:
      if (lookahead == 'e') ADVANCE(664);
      END_STATE();
    case 598:
      if (lookahead == 'n') ADVANCE(665);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(anon_sym_nullptr);
      END_STATE();
    case 600:
      if (lookahead == 'f') ADVANCE(666);
      END_STATE();
    case 601:
      if (lookahead == 'r') ADVANCE(667);
      END_STATE();
    case 602:
      if (lookahead == 'e') ADVANCE(668);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(anon_sym_precise);
      END_STATE();
    case 604:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 605:
      if (lookahead == 'y') ADVANCE(669);
      END_STATE();
    case 606:
      if (lookahead == 'e') ADVANCE(670);
      END_STATE();
    case 607:
      if (lookahead == 'r') ADVANCE(671);
      END_STATE();
    case 608:
      if (lookahead == 's') ADVANCE(672);
      END_STATE();
    case 609:
      if (lookahead == 't') ADVANCE(673);
      END_STATE();
    case 610:
      if (lookahead == 'o') ADVANCE(674);
      END_STATE();
    case 611:
      if (lookahead == 'a') ADVANCE(675);
      END_STATE();
    case 612:
      if (lookahead == 'e') ADVANCE(676);
      END_STATE();
    case 613:
      if (lookahead == 'l') ADVANCE(677);
      END_STATE();
    case 614:
      if (lookahead == 'e') ADVANCE(678);
      END_STATE();
    case 615:
      ACCEPT_TOKEN(anon_sym_typedef);
      END_STATE();
    case 616:
      if (lookahead == 'e') ADVANCE(679);
      END_STATE();
    case 617:
      ACCEPT_TOKEN(anon_sym_uniform);
      END_STATE();
    case 618:
      if (lookahead == 'd') ADVANCE(680);
      END_STATE();
    case 619:
      ACCEPT_TOKEN(sym_virtual);
      END_STATE();
    case 620:
      if (lookahead == 'e') ADVANCE(681);
      END_STATE();
    case 621:
      ACCEPT_TOKEN(anon_sym__Alignas);
      END_STATE();
    case 622:
      ACCEPT_TOKEN(anon_sym__Alignof);
      END_STATE();
    case 623:
      ACCEPT_TOKEN(anon_sym__Generic);
      END_STATE();
    case 624:
      if (lookahead == 'n') ADVANCE(682);
      END_STATE();
    case 625:
      if (lookahead == 'f') ADVANCE(683);
      END_STATE();
    case 626:
      if (lookahead == 'u') ADVANCE(684);
      END_STATE();
    case 627:
      if (lookahead == 'l') ADVANCE(685);
      END_STATE();
    case 628:
      if (lookahead == 'e') ADVANCE(686);
      END_STATE();
    case 629:
      ACCEPT_TOKEN(anon_sym___except);
      END_STATE();
    case 630:
      if (lookahead == 'e') ADVANCE(687);
      END_STATE();
    case 631:
      if (lookahead == 'i') ADVANCE(688);
      END_STATE();
    case 632:
      if (lookahead == 'l') ADVANCE(689);
      END_STATE();
    case 633:
      if (lookahead == 'y') ADVANCE(690);
      END_STATE();
    case 634:
      if (lookahead == 'n') ADVANCE(691);
      END_STATE();
    case 635:
      ACCEPT_TOKEN(anon_sym___inline);
      if (lookahead == '_') ADVANCE(692);
      END_STATE();
    case 636:
      if (lookahead == 'c') ADVANCE(693);
      END_STATE();
    case 637:
      if (lookahead == 'l') ADVANCE(694);
      END_STATE();
    case 638:
      if (lookahead == 'i') ADVANCE(695);
      END_STATE();
    case 639:
      if (lookahead == 'l') ADVANCE(696);
      END_STATE();
    case 640:
      ACCEPT_TOKEN(anon_sym___thread);
      END_STATE();
    case 641:
      if (lookahead == 'n') ADVANCE(697);
      END_STATE();
    case 642:
      if (lookahead == 'c') ADVANCE(698);
      END_STATE();
    case 643:
      ACCEPT_TOKEN(anon_sym__alignof);
      END_STATE();
    case 644:
      if (lookahead == 'e') ADVANCE(699);
      END_STATE();
    case 645:
      if (lookahead == 'e') ADVANCE(700);
      END_STATE();
    case 646:
      ACCEPT_TOKEN(anon_sym_centroid);
      END_STATE();
    case 647:
      ACCEPT_TOKEN(anon_sym_co_await);
      END_STATE();
    case 648:
      if (lookahead == 'n') ADVANCE(701);
      END_STATE();
    case 649:
      ACCEPT_TOKEN(anon_sym_co_yield);
      END_STATE();
    case 650:
      if (lookahead == 'a') ADVANCE(702);
      END_STATE();
    case 651:
      if (lookahead == 'l') ADVANCE(703);
      END_STATE();
    case 652:
      if (lookahead == 'r') ADVANCE(704);
      END_STATE();
    case 653:
      if (lookahead == 't') ADVANCE(705);
      END_STATE();
    case 654:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 655:
      ACCEPT_TOKEN(anon_sym_decltype);
      END_STATE();
    case 656:
      ACCEPT_TOKEN(anon_sym_explicit);
      END_STATE();
    case 657:
      if (lookahead == 'n') ADVANCE(706);
      END_STATE();
    case 658:
      if (lookahead == 'c') ADVANCE(707);
      END_STATE();
    case 659:
      if (lookahead == 'r') ADVANCE(708);
      END_STATE();
    case 660:
      if (lookahead == 'e') ADVANCE(709);
      END_STATE();
    case 661:
      if (lookahead == 'e') ADVANCE(710);
      END_STATE();
    case 662:
      ACCEPT_TOKEN(anon_sym_noexcept);
      END_STATE();
    case 663:
      if (lookahead == 'o') ADVANCE(711);
      END_STATE();
    case 664:
      if (lookahead == 'c') ADVANCE(712);
      END_STATE();
    case 665:
      ACCEPT_TOKEN(anon_sym_noreturn);
      END_STATE();
    case 666:
      ACCEPT_TOKEN(anon_sym_offsetof);
      END_STATE();
    case 667:
      ACCEPT_TOKEN(anon_sym_operator);
      END_STATE();
    case 668:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 669:
      ACCEPT_TOKEN(anon_sym_property);
      END_STATE();
    case 670:
      if (lookahead == 'd') ADVANCE(713);
      END_STATE();
    case 671:
      ACCEPT_TOKEN(anon_sym_register);
      END_STATE();
    case 672:
      ACCEPT_TOKEN(anon_sym_requires);
      END_STATE();
    case 673:
      ACCEPT_TOKEN(anon_sym_restrict);
      END_STATE();
    case 674:
      if (lookahead == 'r') ADVANCE(714);
      END_STATE();
    case 675:
      if (lookahead == 's') ADVANCE(715);
      END_STATE();
    case 676:
      ACCEPT_TOKEN(anon_sym_template);
      END_STATE();
    case 677:
      if (lookahead == 'o') ADVANCE(716);
      END_STATE();
    case 678:
      ACCEPT_TOKEN(anon_sym_triangle);
      if (lookahead == 'a') ADVANCE(717);
      END_STATE();
    case 679:
      ACCEPT_TOKEN(anon_sym_typename);
      END_STATE();
    case 680:
      ACCEPT_TOKEN(anon_sym_unsigned);
      END_STATE();
    case 681:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 682:
      ACCEPT_TOKEN(anon_sym__Noreturn);
      END_STATE();
    case 683:
      ACCEPT_TOKEN(anon_sym___alignof);
      if (lookahead == '_') ADVANCE(718);
      END_STATE();
    case 684:
      if (lookahead == 't') ADVANCE(719);
      END_STATE();
    case 685:
      ACCEPT_TOKEN(anon_sym___clrcall);
      END_STATE();
    case 686:
      if (lookahead == 'c') ADVANCE(720);
      END_STATE();
    case 687:
      if (lookahead == 'd') ADVANCE(721);
      END_STATE();
    case 688:
      if (lookahead == 'o') ADVANCE(722);
      END_STATE();
    case 689:
      if (lookahead == 'l') ADVANCE(723);
      END_STATE();
    case 690:
      ACCEPT_TOKEN(anon_sym___finally);
      END_STATE();
    case 691:
      if (lookahead == 'l') ADVANCE(724);
      END_STATE();
    case 692:
      if (lookahead == '_') ADVANCE(725);
      END_STATE();
    case 693:
      if (lookahead == 't') ADVANCE(726);
      END_STATE();
    case 694:
      ACCEPT_TOKEN(anon_sym___stdcall);
      END_STATE();
    case 695:
      if (lookahead == 'p') ADVANCE(727);
      END_STATE();
    case 696:
      if (lookahead == 'l') ADVANCE(728);
      END_STATE();
    case 697:
      if (lookahead == 'e') ADVANCE(729);
      END_STATE();
    case 698:
      if (lookahead == 'a') ADVANCE(730);
      END_STATE();
    case 699:
      if (lookahead == 'd') ADVANCE(731);
      END_STATE();
    case 700:
      if (lookahead == 'd') ADVANCE(732);
      END_STATE();
    case 701:
      ACCEPT_TOKEN(anon_sym_co_return);
      END_STATE();
    case 702:
      if (lookahead == 'j') ADVANCE(733);
      END_STATE();
    case 703:
      ACCEPT_TOKEN(anon_sym_consteval);
      END_STATE();
    case 704:
      ACCEPT_TOKEN(anon_sym_constexpr);
      END_STATE();
    case 705:
      ACCEPT_TOKEN(anon_sym_constinit);
      END_STATE();
    case 706:
      ACCEPT_TOKEN(anon_sym_extension);
      END_STATE();
    case 707:
      if (lookahead == 'o') ADVANCE(734);
      END_STATE();
    case 708:
      if (lookahead == 'e') ADVANCE(735);
      END_STATE();
    case 709:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 710:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 711:
      if (lookahead == 'l') ADVANCE(736);
      END_STATE();
    case 712:
      if (lookahead == 't') ADVANCE(737);
      END_STATE();
    case 713:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 714:
      ACCEPT_TOKEN(anon_sym_row_major);
      END_STATE();
    case 715:
      if (lookahead == 's') ADVANCE(738);
      END_STATE();
    case 716:
      if (lookahead == 'c') ADVANCE(739);
      END_STATE();
    case 717:
      if (lookahead == 'd') ADVANCE(740);
      END_STATE();
    case 718:
      if (lookahead == '_') ADVANCE(741);
      END_STATE();
    case 719:
      if (lookahead == 'e') ADVANCE(742);
      END_STATE();
    case 720:
      ACCEPT_TOKEN(anon_sym___declspec);
      END_STATE();
    case 721:
      ACCEPT_TOKEN(anon_sym___exported);
      END_STATE();
    case 722:
      if (lookahead == 'n') ADVANCE(743);
      END_STATE();
    case 723:
      ACCEPT_TOKEN(anon_sym___fastcall);
      END_STATE();
    case 724:
      if (lookahead == 'i') ADVANCE(744);
      END_STATE();
    case 725:
      ACCEPT_TOKEN(anon_sym___inline__);
      END_STATE();
    case 726:
      ACCEPT_TOKEN(sym_ms_restrict_modifier);
      if (lookahead == '_') ADVANCE(745);
      END_STATE();
    case 727:
      if (lookahead == 't') ADVANCE(746);
      END_STATE();
    case 728:
      ACCEPT_TOKEN(anon_sym___thiscall);
      END_STATE();
    case 729:
      if (lookahead == 'd') ADVANCE(747);
      END_STATE();
    case 730:
      if (lookahead == 'l') ADVANCE(748);
      END_STATE();
    case 731:
      ACCEPT_TOKEN(anon_sym__unaligned);
      END_STATE();
    case 732:
      if (lookahead == 't') ADVANCE(749);
      END_STATE();
    case 733:
      if (lookahead == 'o') ADVANCE(750);
      END_STATE();
    case 734:
      if (lookahead == 'h') ADVANCE(751);
      END_STATE();
    case 735:
      if (lookahead == 'd') ADVANCE(752);
      END_STATE();
    case 736:
      if (lookahead == 'a') ADVANCE(753);
      END_STATE();
    case 737:
      if (lookahead == 'i') ADVANCE(754);
      END_STATE();
    case 738:
      if (lookahead == 'e') ADVANCE(755);
      END_STATE();
    case 739:
      if (lookahead == 'a') ADVANCE(756);
      END_STATE();
    case 740:
      if (lookahead == 'j') ADVANCE(757);
      END_STATE();
    case 741:
      ACCEPT_TOKEN(anon_sym___alignof__);
      END_STATE();
    case 742:
      if (lookahead == '_') ADVANCE(758);
      END_STATE();
    case 743:
      if (lookahead == '_') ADVANCE(759);
      END_STATE();
    case 744:
      if (lookahead == 'n') ADVANCE(760);
      END_STATE();
    case 745:
      if (lookahead == '_') ADVANCE(761);
      END_STATE();
    case 746:
      ACCEPT_TOKEN(anon_sym___subscript);
      END_STATE();
    case 747:
      ACCEPT_TOKEN(anon_sym___unaligned);
      END_STATE();
    case 748:
      if (lookahead == 'l') ADVANCE(762);
      END_STATE();
    case 749:
      if (lookahead == 'y') ADVANCE(763);
      END_STATE();
    case 750:
      if (lookahead == 'r') ADVANCE(764);
      END_STATE();
    case 751:
      if (lookahead == 'e') ADVANCE(765);
      END_STATE();
    case 752:
      ACCEPT_TOKEN(anon_sym_groupshared);
      END_STATE();
    case 753:
      if (lookahead == 't') ADVANCE(766);
      END_STATE();
    case 754:
      if (lookahead == 'v') ADVANCE(767);
      END_STATE();
    case 755:
      if (lookahead == 'r') ADVANCE(768);
      END_STATE();
    case 756:
      if (lookahead == 'l') ADVANCE(769);
      END_STATE();
    case 757:
      ACCEPT_TOKEN(anon_sym_triangleadj);
      END_STATE();
    case 758:
      if (lookahead == '_') ADVANCE(770);
      END_STATE();
    case 759:
      if (lookahead == '_') ADVANCE(771);
      END_STATE();
    case 760:
      if (lookahead == 'e') ADVANCE(772);
      END_STATE();
    case 761:
      ACCEPT_TOKEN(anon_sym___restrict__);
      END_STATE();
    case 762:
      ACCEPT_TOKEN(anon_sym___vectorcall);
      END_STATE();
    case 763:
      if (lookahead == 'p') ADVANCE(773);
      END_STATE();
    case 764:
      ACCEPT_TOKEN(anon_sym_column_major);
      END_STATE();
    case 765:
      if (lookahead == 'r') ADVANCE(774);
      END_STATE();
    case 766:
      if (lookahead == 'i') ADVANCE(775);
      END_STATE();
    case 767:
      if (lookahead == 'e') ADVANCE(776);
      END_STATE();
    case 768:
      if (lookahead == 't') ADVANCE(777);
      END_STATE();
    case 769:
      ACCEPT_TOKEN(anon_sym_thread_local);
      END_STATE();
    case 770:
      ACCEPT_TOKEN(anon_sym___attribute__);
      END_STATE();
    case 771:
      ACCEPT_TOKEN(anon_sym___extension__);
      END_STATE();
    case 772:
      ACCEPT_TOKEN(anon_sym___forceinline);
      END_STATE();
    case 773:
      if (lookahead == 'e') ADVANCE(778);
      END_STATE();
    case 774:
      if (lookahead == 'e') ADVANCE(779);
      END_STATE();
    case 775:
      if (lookahead == 'o') ADVANCE(780);
      END_STATE();
    case 776:
      ACCEPT_TOKEN(anon_sym_noperspective);
      END_STATE();
    case 777:
      ACCEPT_TOKEN(anon_sym_static_assert);
      END_STATE();
    case 778:
      ACCEPT_TOKEN(anon_sym_associatedtype);
      END_STATE();
    case 779:
      if (lookahead == 'n') ADVANCE(781);
      END_STATE();
    case 780:
      if (lookahead == 'n') ADVANCE(782);
      END_STATE();
    case 781:
      if (lookahead == 't') ADVANCE(783);
      END_STATE();
    case 782:
      ACCEPT_TOKEN(anon_sym_nointerpolation);
      END_STATE();
    case 783:
      ACCEPT_TOKEN(anon_sym_globallycoherent);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 351},
  [2] = {.lex_state = 351},
  [3] = {.lex_state = 351},
  [4] = {.lex_state = 351},
  [5] = {.lex_state = 351},
  [6] = {.lex_state = 351},
  [7] = {.lex_state = 181},
  [8] = {.lex_state = 181},
  [9] = {.lex_state = 181},
  [10] = {.lex_state = 181},
  [11] = {.lex_state = 181},
  [12] = {.lex_state = 181},
  [13] = {.lex_state = 181},
  [14] = {.lex_state = 181},
  [15] = {.lex_state = 181},
  [16] = {.lex_state = 181},
  [17] = {.lex_state = 181},
  [18] = {.lex_state = 181},
  [19] = {.lex_state = 181},
  [20] = {.lex_state = 181},
  [21] = {.lex_state = 181},
  [22] = {.lex_state = 181},
  [23] = {.lex_state = 181},
  [24] = {.lex_state = 181},
  [25] = {.lex_state = 181},
  [26] = {.lex_state = 181},
  [27] = {.lex_state = 181},
  [28] = {.lex_state = 351},
  [29] = {.lex_state = 351},
  [30] = {.lex_state = 351},
  [31] = {.lex_state = 351},
  [32] = {.lex_state = 351},
  [33] = {.lex_state = 351},
  [34] = {.lex_state = 351},
  [35] = {.lex_state = 351},
  [36] = {.lex_state = 351},
  [37] = {.lex_state = 351},
  [38] = {.lex_state = 351},
  [39] = {.lex_state = 184},
  [40] = {.lex_state = 351},
  [41] = {.lex_state = 351},
  [42] = {.lex_state = 351},
  [43] = {.lex_state = 351},
  [44] = {.lex_state = 351},
  [45] = {.lex_state = 351},
  [46] = {.lex_state = 351},
  [47] = {.lex_state = 351},
  [48] = {.lex_state = 351},
  [49] = {.lex_state = 351},
  [50] = {.lex_state = 351},
  [51] = {.lex_state = 351},
  [52] = {.lex_state = 351},
  [53] = {.lex_state = 184},
  [54] = {.lex_state = 351},
  [55] = {.lex_state = 351},
  [56] = {.lex_state = 351},
  [57] = {.lex_state = 351},
  [58] = {.lex_state = 351},
  [59] = {.lex_state = 351},
  [60] = {.lex_state = 351},
  [61] = {.lex_state = 351},
  [62] = {.lex_state = 184},
  [63] = {.lex_state = 351},
  [64] = {.lex_state = 351},
  [65] = {.lex_state = 351},
  [66] = {.lex_state = 351},
  [67] = {.lex_state = 351},
  [68] = {.lex_state = 351},
  [69] = {.lex_state = 351},
  [70] = {.lex_state = 351},
  [71] = {.lex_state = 351},
  [72] = {.lex_state = 351},
  [73] = {.lex_state = 351},
  [74] = {.lex_state = 351},
  [75] = {.lex_state = 351},
  [76] = {.lex_state = 351},
  [77] = {.lex_state = 181},
  [78] = {.lex_state = 181},
  [79] = {.lex_state = 181},
  [80] = {.lex_state = 181},
  [81] = {.lex_state = 181},
  [82] = {.lex_state = 351},
  [83] = {.lex_state = 351},
  [84] = {.lex_state = 351},
  [85] = {.lex_state = 351},
  [86] = {.lex_state = 351},
  [87] = {.lex_state = 184},
  [88] = {.lex_state = 351},
  [89] = {.lex_state = 184},
  [90] = {.lex_state = 351},
  [91] = {.lex_state = 184},
  [92] = {.lex_state = 184},
  [93] = {.lex_state = 351},
  [94] = {.lex_state = 351},
  [95] = {.lex_state = 351},
  [96] = {.lex_state = 184},
  [97] = {.lex_state = 183},
  [98] = {.lex_state = 183},
  [99] = {.lex_state = 183},
  [100] = {.lex_state = 183},
  [101] = {.lex_state = 183},
  [102] = {.lex_state = 349},
  [103] = {.lex_state = 349},
  [104] = {.lex_state = 349},
  [105] = {.lex_state = 349},
  [106] = {.lex_state = 349},
  [107] = {.lex_state = 349},
  [108] = {.lex_state = 349},
  [109] = {.lex_state = 349},
  [110] = {.lex_state = 349},
  [111] = {.lex_state = 349},
  [112] = {.lex_state = 349},
  [113] = {.lex_state = 349},
  [114] = {.lex_state = 349},
  [115] = {.lex_state = 349},
  [116] = {.lex_state = 349},
  [117] = {.lex_state = 349},
  [118] = {.lex_state = 349},
  [119] = {.lex_state = 349},
  [120] = {.lex_state = 349},
  [121] = {.lex_state = 349},
  [122] = {.lex_state = 349},
  [123] = {.lex_state = 349},
  [124] = {.lex_state = 349},
  [125] = {.lex_state = 349},
  [126] = {.lex_state = 349},
  [127] = {.lex_state = 349},
  [128] = {.lex_state = 349},
  [129] = {.lex_state = 349},
  [130] = {.lex_state = 349},
  [131] = {.lex_state = 349},
  [132] = {.lex_state = 349},
  [133] = {.lex_state = 349},
  [134] = {.lex_state = 349},
  [135] = {.lex_state = 349},
  [136] = {.lex_state = 349},
  [137] = {.lex_state = 349},
  [138] = {.lex_state = 183},
  [139] = {.lex_state = 350},
  [140] = {.lex_state = 350},
  [141] = {.lex_state = 350},
  [142] = {.lex_state = 183},
  [143] = {.lex_state = 350},
  [144] = {.lex_state = 350},
  [145] = {.lex_state = 183},
  [146] = {.lex_state = 350},
  [147] = {.lex_state = 350},
  [148] = {.lex_state = 350},
  [149] = {.lex_state = 350},
  [150] = {.lex_state = 183},
  [151] = {.lex_state = 350},
  [152] = {.lex_state = 350},
  [153] = {.lex_state = 350},
  [154] = {.lex_state = 350},
  [155] = {.lex_state = 183},
  [156] = {.lex_state = 350},
  [157] = {.lex_state = 350},
  [158] = {.lex_state = 183},
  [159] = {.lex_state = 183},
  [160] = {.lex_state = 183},
  [161] = {.lex_state = 183},
  [162] = {.lex_state = 183},
  [163] = {.lex_state = 183},
  [164] = {.lex_state = 183},
  [165] = {.lex_state = 183},
  [166] = {.lex_state = 350},
  [167] = {.lex_state = 350},
  [168] = {.lex_state = 350},
  [169] = {.lex_state = 350},
  [170] = {.lex_state = 350},
  [171] = {.lex_state = 350},
  [172] = {.lex_state = 350},
  [173] = {.lex_state = 350},
  [174] = {.lex_state = 350},
  [175] = {.lex_state = 350},
  [176] = {.lex_state = 350},
  [177] = {.lex_state = 350},
  [178] = {.lex_state = 350},
  [179] = {.lex_state = 350},
  [180] = {.lex_state = 350},
  [181] = {.lex_state = 350},
  [182] = {.lex_state = 183},
  [183] = {.lex_state = 183},
  [184] = {.lex_state = 183},
  [185] = {.lex_state = 183},
  [186] = {.lex_state = 183},
  [187] = {.lex_state = 350},
  [188] = {.lex_state = 183},
  [189] = {.lex_state = 183},
  [190] = {.lex_state = 351},
  [191] = {.lex_state = 351},
  [192] = {.lex_state = 351},
  [193] = {.lex_state = 351},
  [194] = {.lex_state = 351},
  [195] = {.lex_state = 351},
  [196] = {.lex_state = 351},
  [197] = {.lex_state = 351},
  [198] = {.lex_state = 351},
  [199] = {.lex_state = 351},
  [200] = {.lex_state = 351},
  [201] = {.lex_state = 351},
  [202] = {.lex_state = 351},
  [203] = {.lex_state = 351},
  [204] = {.lex_state = 351},
  [205] = {.lex_state = 351},
  [206] = {.lex_state = 351},
  [207] = {.lex_state = 351},
  [208] = {.lex_state = 351},
  [209] = {.lex_state = 351},
  [210] = {.lex_state = 351},
  [211] = {.lex_state = 351},
  [212] = {.lex_state = 351},
  [213] = {.lex_state = 351},
  [214] = {.lex_state = 351},
  [215] = {.lex_state = 249},
  [216] = {.lex_state = 249},
  [217] = {.lex_state = 249},
  [218] = {.lex_state = 249},
  [219] = {.lex_state = 249},
  [220] = {.lex_state = 249},
  [221] = {.lex_state = 249},
  [222] = {.lex_state = 249},
  [223] = {.lex_state = 249},
  [224] = {.lex_state = 249},
  [225] = {.lex_state = 249},
  [226] = {.lex_state = 249},
  [227] = {.lex_state = 249},
  [228] = {.lex_state = 249},
  [229] = {.lex_state = 249},
  [230] = {.lex_state = 249},
  [231] = {.lex_state = 181},
  [232] = {.lex_state = 181},
  [233] = {.lex_state = 181},
  [234] = {.lex_state = 351},
  [235] = {.lex_state = 181},
  [236] = {.lex_state = 351},
  [237] = {.lex_state = 351},
  [238] = {.lex_state = 351},
  [239] = {.lex_state = 249},
  [240] = {.lex_state = 351},
  [241] = {.lex_state = 181},
  [242] = {.lex_state = 181},
  [243] = {.lex_state = 181},
  [244] = {.lex_state = 181},
  [245] = {.lex_state = 351},
  [246] = {.lex_state = 181},
  [247] = {.lex_state = 351},
  [248] = {.lex_state = 181},
  [249] = {.lex_state = 181},
  [250] = {.lex_state = 181},
  [251] = {.lex_state = 181},
  [252] = {.lex_state = 181},
  [253] = {.lex_state = 181},
  [254] = {.lex_state = 181},
  [255] = {.lex_state = 181},
  [256] = {.lex_state = 181},
  [257] = {.lex_state = 181},
  [258] = {.lex_state = 181},
  [259] = {.lex_state = 181},
  [260] = {.lex_state = 181},
  [261] = {.lex_state = 181},
  [262] = {.lex_state = 181},
  [263] = {.lex_state = 181},
  [264] = {.lex_state = 181},
  [265] = {.lex_state = 181},
  [266] = {.lex_state = 351},
  [267] = {.lex_state = 351},
  [268] = {.lex_state = 351},
  [269] = {.lex_state = 181},
  [270] = {.lex_state = 185},
  [271] = {.lex_state = 351},
  [272] = {.lex_state = 185},
  [273] = {.lex_state = 351},
  [274] = {.lex_state = 184},
  [275] = {.lex_state = 184},
  [276] = {.lex_state = 181},
  [277] = {.lex_state = 351},
  [278] = {.lex_state = 185},
  [279] = {.lex_state = 184},
  [280] = {.lex_state = 181},
  [281] = {.lex_state = 181},
  [282] = {.lex_state = 181},
  [283] = {.lex_state = 181},
  [284] = {.lex_state = 181},
  [285] = {.lex_state = 351},
  [286] = {.lex_state = 351},
  [287] = {.lex_state = 181},
  [288] = {.lex_state = 351},
  [289] = {.lex_state = 184},
  [290] = {.lex_state = 351},
  [291] = {.lex_state = 205},
  [292] = {.lex_state = 181},
  [293] = {.lex_state = 181},
  [294] = {.lex_state = 205},
  [295] = {.lex_state = 351},
  [296] = {.lex_state = 250},
  [297] = {.lex_state = 351},
  [298] = {.lex_state = 351},
  [299] = {.lex_state = 181},
  [300] = {.lex_state = 181},
  [301] = {.lex_state = 205},
  [302] = {.lex_state = 205},
  [303] = {.lex_state = 351},
  [304] = {.lex_state = 205},
  [305] = {.lex_state = 205},
  [306] = {.lex_state = 205},
  [307] = {.lex_state = 181},
  [308] = {.lex_state = 205},
  [309] = {.lex_state = 351},
  [310] = {.lex_state = 181},
  [311] = {.lex_state = 181},
  [312] = {.lex_state = 181},
  [313] = {.lex_state = 351},
  [314] = {.lex_state = 351},
  [315] = {.lex_state = 205},
  [316] = {.lex_state = 205},
  [317] = {.lex_state = 351},
  [318] = {.lex_state = 351},
  [319] = {.lex_state = 351},
  [320] = {.lex_state = 181},
  [321] = {.lex_state = 205},
  [322] = {.lex_state = 351},
  [323] = {.lex_state = 181},
  [324] = {.lex_state = 205},
  [325] = {.lex_state = 351},
  [326] = {.lex_state = 351},
  [327] = {.lex_state = 181},
  [328] = {.lex_state = 181},
  [329] = {.lex_state = 181},
  [330] = {.lex_state = 351},
  [331] = {.lex_state = 181},
  [332] = {.lex_state = 181},
  [333] = {.lex_state = 181},
  [334] = {.lex_state = 181},
  [335] = {.lex_state = 181},
  [336] = {.lex_state = 205},
  [337] = {.lex_state = 351},
  [338] = {.lex_state = 205},
  [339] = {.lex_state = 351},
  [340] = {.lex_state = 205},
  [341] = {.lex_state = 351},
  [342] = {.lex_state = 351},
  [343] = {.lex_state = 181},
  [344] = {.lex_state = 351},
  [345] = {.lex_state = 351},
  [346] = {.lex_state = 351},
  [347] = {.lex_state = 351},
  [348] = {.lex_state = 181},
  [349] = {.lex_state = 351},
  [350] = {.lex_state = 351},
  [351] = {.lex_state = 351},
  [352] = {.lex_state = 351},
  [353] = {.lex_state = 181},
  [354] = {.lex_state = 181},
  [355] = {.lex_state = 351},
  [356] = {.lex_state = 181},
  [357] = {.lex_state = 351},
  [358] = {.lex_state = 351},
  [359] = {.lex_state = 351},
  [360] = {.lex_state = 181},
  [361] = {.lex_state = 351},
  [362] = {.lex_state = 351},
  [363] = {.lex_state = 351},
  [364] = {.lex_state = 351},
  [365] = {.lex_state = 351},
  [366] = {.lex_state = 351},
  [367] = {.lex_state = 351},
  [368] = {.lex_state = 351},
  [369] = {.lex_state = 351},
  [370] = {.lex_state = 250},
  [371] = {.lex_state = 205},
  [372] = {.lex_state = 351},
  [373] = {.lex_state = 351},
  [374] = {.lex_state = 181},
  [375] = {.lex_state = 181},
  [376] = {.lex_state = 205},
  [377] = {.lex_state = 205},
  [378] = {.lex_state = 351},
  [379] = {.lex_state = 351},
  [380] = {.lex_state = 181},
  [381] = {.lex_state = 181},
  [382] = {.lex_state = 205},
  [383] = {.lex_state = 181},
  [384] = {.lex_state = 205},
  [385] = {.lex_state = 351},
  [386] = {.lex_state = 205},
  [387] = {.lex_state = 181},
  [388] = {.lex_state = 351},
  [389] = {.lex_state = 351},
  [390] = {.lex_state = 205},
  [391] = {.lex_state = 181},
  [392] = {.lex_state = 181},
  [393] = {.lex_state = 181},
  [394] = {.lex_state = 181},
  [395] = {.lex_state = 181},
  [396] = {.lex_state = 181},
  [397] = {.lex_state = 181},
  [398] = {.lex_state = 181},
  [399] = {.lex_state = 181},
  [400] = {.lex_state = 181},
  [401] = {.lex_state = 181},
  [402] = {.lex_state = 181},
  [403] = {.lex_state = 205},
  [404] = {.lex_state = 250},
  [405] = {.lex_state = 351},
  [406] = {.lex_state = 181},
  [407] = {.lex_state = 181},
  [408] = {.lex_state = 205},
  [409] = {.lex_state = 205},
  [410] = {.lex_state = 181},
  [411] = {.lex_state = 181},
  [412] = {.lex_state = 181},
  [413] = {.lex_state = 181},
  [414] = {.lex_state = 205},
  [415] = {.lex_state = 205},
  [416] = {.lex_state = 181},
  [417] = {.lex_state = 205},
  [418] = {.lex_state = 351},
  [419] = {.lex_state = 181},
  [420] = {.lex_state = 181},
  [421] = {.lex_state = 351},
  [422] = {.lex_state = 181},
  [423] = {.lex_state = 181},
  [424] = {.lex_state = 205},
  [425] = {.lex_state = 205},
  [426] = {.lex_state = 351},
  [427] = {.lex_state = 351},
  [428] = {.lex_state = 351},
  [429] = {.lex_state = 181},
  [430] = {.lex_state = 205},
  [431] = {.lex_state = 181},
  [432] = {.lex_state = 351},
  [433] = {.lex_state = 181},
  [434] = {.lex_state = 351},
  [435] = {.lex_state = 351},
  [436] = {.lex_state = 351},
  [437] = {.lex_state = 351},
  [438] = {.lex_state = 351},
  [439] = {.lex_state = 351},
  [440] = {.lex_state = 351},
  [441] = {.lex_state = 181},
  [442] = {.lex_state = 181},
  [443] = {.lex_state = 181},
  [444] = {.lex_state = 181},
  [445] = {.lex_state = 184},
  [446] = {.lex_state = 181},
  [447] = {.lex_state = 181},
  [448] = {.lex_state = 181},
  [449] = {.lex_state = 181},
  [450] = {.lex_state = 181},
  [451] = {.lex_state = 181},
  [452] = {.lex_state = 181},
  [453] = {.lex_state = 351},
  [454] = {.lex_state = 181},
  [455] = {.lex_state = 181},
  [456] = {.lex_state = 184},
  [457] = {.lex_state = 181},
  [458] = {.lex_state = 181},
  [459] = {.lex_state = 181},
  [460] = {.lex_state = 184},
  [461] = {.lex_state = 181},
  [462] = {.lex_state = 181},
  [463] = {.lex_state = 351},
  [464] = {.lex_state = 181},
  [465] = {.lex_state = 181},
  [466] = {.lex_state = 181},
  [467] = {.lex_state = 181},
  [468] = {.lex_state = 181},
  [469] = {.lex_state = 181},
  [470] = {.lex_state = 181},
  [471] = {.lex_state = 181},
  [472] = {.lex_state = 181},
  [473] = {.lex_state = 181},
  [474] = {.lex_state = 181},
  [475] = {.lex_state = 181},
  [476] = {.lex_state = 181},
  [477] = {.lex_state = 184},
  [478] = {.lex_state = 181},
  [479] = {.lex_state = 181},
  [480] = {.lex_state = 181},
  [481] = {.lex_state = 181},
  [482] = {.lex_state = 181},
  [483] = {.lex_state = 181},
  [484] = {.lex_state = 181},
  [485] = {.lex_state = 181},
  [486] = {.lex_state = 181},
  [487] = {.lex_state = 181},
  [488] = {.lex_state = 181},
  [489] = {.lex_state = 181},
  [490] = {.lex_state = 181},
  [491] = {.lex_state = 181},
  [492] = {.lex_state = 351},
  [493] = {.lex_state = 181},
  [494] = {.lex_state = 181},
  [495] = {.lex_state = 351},
  [496] = {.lex_state = 181},
  [497] = {.lex_state = 181},
  [498] = {.lex_state = 181},
  [499] = {.lex_state = 184},
  [500] = {.lex_state = 181},
  [501] = {.lex_state = 181},
  [502] = {.lex_state = 181},
  [503] = {.lex_state = 181},
  [504] = {.lex_state = 181},
  [505] = {.lex_state = 184},
  [506] = {.lex_state = 184},
  [507] = {.lex_state = 181},
  [508] = {.lex_state = 181},
  [509] = {.lex_state = 181},
  [510] = {.lex_state = 184},
  [511] = {.lex_state = 181},
  [512] = {.lex_state = 181},
  [513] = {.lex_state = 181},
  [514] = {.lex_state = 184},
  [515] = {.lex_state = 181},
  [516] = {.lex_state = 184},
  [517] = {.lex_state = 184},
  [518] = {.lex_state = 184},
  [519] = {.lex_state = 184},
  [520] = {.lex_state = 181},
  [521] = {.lex_state = 184},
  [522] = {.lex_state = 181},
  [523] = {.lex_state = 184},
  [524] = {.lex_state = 181},
  [525] = {.lex_state = 181},
  [526] = {.lex_state = 184},
  [527] = {.lex_state = 181},
  [528] = {.lex_state = 184},
  [529] = {.lex_state = 184},
  [530] = {.lex_state = 184},
  [531] = {.lex_state = 351},
  [532] = {.lex_state = 351},
  [533] = {.lex_state = 184},
  [534] = {.lex_state = 184},
  [535] = {.lex_state = 184},
  [536] = {.lex_state = 184},
  [537] = {.lex_state = 351},
  [538] = {.lex_state = 181},
  [539] = {.lex_state = 181},
  [540] = {.lex_state = 181},
  [541] = {.lex_state = 181},
  [542] = {.lex_state = 181},
  [543] = {.lex_state = 181},
  [544] = {.lex_state = 181},
  [545] = {.lex_state = 351},
  [546] = {.lex_state = 351},
  [547] = {.lex_state = 181},
  [548] = {.lex_state = 181},
  [549] = {.lex_state = 181},
  [550] = {.lex_state = 181},
  [551] = {.lex_state = 351},
  [552] = {.lex_state = 351},
  [553] = {.lex_state = 351},
  [554] = {.lex_state = 351},
  [555] = {.lex_state = 351},
  [556] = {.lex_state = 351},
  [557] = {.lex_state = 351},
  [558] = {.lex_state = 351},
  [559] = {.lex_state = 351},
  [560] = {.lex_state = 351},
  [561] = {.lex_state = 351},
  [562] = {.lex_state = 184},
  [563] = {.lex_state = 351},
  [564] = {.lex_state = 351},
  [565] = {.lex_state = 351},
  [566] = {.lex_state = 351},
  [567] = {.lex_state = 351},
  [568] = {.lex_state = 351},
  [569] = {.lex_state = 351},
  [570] = {.lex_state = 351},
  [571] = {.lex_state = 184},
  [572] = {.lex_state = 351},
  [573] = {.lex_state = 351},
  [574] = {.lex_state = 351},
  [575] = {.lex_state = 351},
  [576] = {.lex_state = 351},
  [577] = {.lex_state = 351},
  [578] = {.lex_state = 351},
  [579] = {.lex_state = 351},
  [580] = {.lex_state = 351},
  [581] = {.lex_state = 351},
  [582] = {.lex_state = 351},
  [583] = {.lex_state = 351},
  [584] = {.lex_state = 351},
  [585] = {.lex_state = 351},
  [586] = {.lex_state = 351},
  [587] = {.lex_state = 351},
  [588] = {.lex_state = 351},
  [589] = {.lex_state = 351},
  [590] = {.lex_state = 351},
  [591] = {.lex_state = 351},
  [592] = {.lex_state = 351},
  [593] = {.lex_state = 351},
  [594] = {.lex_state = 351},
  [595] = {.lex_state = 351},
  [596] = {.lex_state = 351},
  [597] = {.lex_state = 351},
  [598] = {.lex_state = 351},
  [599] = {.lex_state = 351},
  [600] = {.lex_state = 351},
  [601] = {.lex_state = 351},
  [602] = {.lex_state = 351},
  [603] = {.lex_state = 351},
  [604] = {.lex_state = 351},
  [605] = {.lex_state = 351},
  [606] = {.lex_state = 351},
  [607] = {.lex_state = 351},
  [608] = {.lex_state = 351},
  [609] = {.lex_state = 351},
  [610] = {.lex_state = 351},
  [611] = {.lex_state = 351},
  [612] = {.lex_state = 351},
  [613] = {.lex_state = 351},
  [614] = {.lex_state = 351},
  [615] = {.lex_state = 351},
  [616] = {.lex_state = 351},
  [617] = {.lex_state = 351},
  [618] = {.lex_state = 351},
  [619] = {.lex_state = 184},
  [620] = {.lex_state = 351},
  [621] = {.lex_state = 351},
  [622] = {.lex_state = 184},
  [623] = {.lex_state = 351},
  [624] = {.lex_state = 351},
  [625] = {.lex_state = 351},
  [626] = {.lex_state = 351},
  [627] = {.lex_state = 184},
  [628] = {.lex_state = 351},
  [629] = {.lex_state = 351},
  [630] = {.lex_state = 351},
  [631] = {.lex_state = 351},
  [632] = {.lex_state = 351},
  [633] = {.lex_state = 351},
  [634] = {.lex_state = 351},
  [635] = {.lex_state = 351},
  [636] = {.lex_state = 184},
  [637] = {.lex_state = 351},
  [638] = {.lex_state = 351},
  [639] = {.lex_state = 351},
  [640] = {.lex_state = 351},
  [641] = {.lex_state = 351},
  [642] = {.lex_state = 351},
  [643] = {.lex_state = 351},
  [644] = {.lex_state = 351},
  [645] = {.lex_state = 184},
  [646] = {.lex_state = 351},
  [647] = {.lex_state = 351},
  [648] = {.lex_state = 351},
  [649] = {.lex_state = 351},
  [650] = {.lex_state = 351},
  [651] = {.lex_state = 351},
  [652] = {.lex_state = 184},
  [653] = {.lex_state = 351},
  [654] = {.lex_state = 184},
  [655] = {.lex_state = 351},
  [656] = {.lex_state = 351},
  [657] = {.lex_state = 351},
  [658] = {.lex_state = 351},
  [659] = {.lex_state = 184},
  [660] = {.lex_state = 184},
  [661] = {.lex_state = 184},
  [662] = {.lex_state = 184},
  [663] = {.lex_state = 351},
  [664] = {.lex_state = 351},
  [665] = {.lex_state = 351},
  [666] = {.lex_state = 184},
  [667] = {.lex_state = 184},
  [668] = {.lex_state = 184},
  [669] = {.lex_state = 351},
  [670] = {.lex_state = 351},
  [671] = {.lex_state = 184},
  [672] = {.lex_state = 184},
  [673] = {.lex_state = 184},
  [674] = {.lex_state = 184},
  [675] = {.lex_state = 351},
  [676] = {.lex_state = 351},
  [677] = {.lex_state = 184},
  [678] = {.lex_state = 351},
  [679] = {.lex_state = 351},
  [680] = {.lex_state = 351},
  [681] = {.lex_state = 351},
  [682] = {.lex_state = 351},
  [683] = {.lex_state = 351},
  [684] = {.lex_state = 351},
  [685] = {.lex_state = 351},
  [686] = {.lex_state = 351},
  [687] = {.lex_state = 351},
  [688] = {.lex_state = 351},
  [689] = {.lex_state = 351},
  [690] = {.lex_state = 184},
  [691] = {.lex_state = 184},
  [692] = {.lex_state = 184},
  [693] = {.lex_state = 184},
  [694] = {.lex_state = 184},
  [695] = {.lex_state = 184},
  [696] = {.lex_state = 351},
  [697] = {.lex_state = 351},
  [698] = {.lex_state = 184},
  [699] = {.lex_state = 351},
  [700] = {.lex_state = 351},
  [701] = {.lex_state = 184},
  [702] = {.lex_state = 184},
  [703] = {.lex_state = 351},
  [704] = {.lex_state = 184},
  [705] = {.lex_state = 184},
  [706] = {.lex_state = 351},
  [707] = {.lex_state = 351},
  [708] = {.lex_state = 351},
  [709] = {.lex_state = 351},
  [710] = {.lex_state = 184},
  [711] = {.lex_state = 184},
  [712] = {.lex_state = 351},
  [713] = {.lex_state = 184},
  [714] = {.lex_state = 351},
  [715] = {.lex_state = 184},
  [716] = {.lex_state = 351},
  [717] = {.lex_state = 351},
  [718] = {.lex_state = 351},
  [719] = {.lex_state = 351},
  [720] = {.lex_state = 184},
  [721] = {.lex_state = 184},
  [722] = {.lex_state = 184},
  [723] = {.lex_state = 351},
  [724] = {.lex_state = 184},
  [725] = {.lex_state = 351},
  [726] = {.lex_state = 351},
  [727] = {.lex_state = 351},
  [728] = {.lex_state = 184},
  [729] = {.lex_state = 183},
  [730] = {.lex_state = 183},
  [731] = {.lex_state = 184},
  [732] = {.lex_state = 351},
  [733] = {.lex_state = 351},
  [734] = {.lex_state = 351},
  [735] = {.lex_state = 351},
  [736] = {.lex_state = 351},
  [737] = {.lex_state = 351},
  [738] = {.lex_state = 351},
  [739] = {.lex_state = 351},
  [740] = {.lex_state = 351},
  [741] = {.lex_state = 351},
  [742] = {.lex_state = 351},
  [743] = {.lex_state = 351},
  [744] = {.lex_state = 351},
  [745] = {.lex_state = 184},
  [746] = {.lex_state = 351},
  [747] = {.lex_state = 351},
  [748] = {.lex_state = 351},
  [749] = {.lex_state = 351},
  [750] = {.lex_state = 351},
  [751] = {.lex_state = 351},
  [752] = {.lex_state = 351},
  [753] = {.lex_state = 351},
  [754] = {.lex_state = 351},
  [755] = {.lex_state = 184},
  [756] = {.lex_state = 184},
  [757] = {.lex_state = 351},
  [758] = {.lex_state = 184},
  [759] = {.lex_state = 184},
  [760] = {.lex_state = 351},
  [761] = {.lex_state = 183},
  [762] = {.lex_state = 184},
  [763] = {.lex_state = 184},
  [764] = {.lex_state = 184},
  [765] = {.lex_state = 351},
  [766] = {.lex_state = 351},
  [767] = {.lex_state = 351},
  [768] = {.lex_state = 351},
  [769] = {.lex_state = 351},
  [770] = {.lex_state = 351},
  [771] = {.lex_state = 184},
  [772] = {.lex_state = 351},
  [773] = {.lex_state = 351},
  [774] = {.lex_state = 351},
  [775] = {.lex_state = 351},
  [776] = {.lex_state = 184},
  [777] = {.lex_state = 351},
  [778] = {.lex_state = 351},
  [779] = {.lex_state = 184},
  [780] = {.lex_state = 351},
  [781] = {.lex_state = 184},
  [782] = {.lex_state = 351},
  [783] = {.lex_state = 184},
  [784] = {.lex_state = 184},
  [785] = {.lex_state = 184},
  [786] = {.lex_state = 184},
  [787] = {.lex_state = 184},
  [788] = {.lex_state = 351},
  [789] = {.lex_state = 351},
  [790] = {.lex_state = 351},
  [791] = {.lex_state = 184},
  [792] = {.lex_state = 351},
  [793] = {.lex_state = 351},
  [794] = {.lex_state = 351},
  [795] = {.lex_state = 351},
  [796] = {.lex_state = 351},
  [797] = {.lex_state = 351},
  [798] = {.lex_state = 351},
  [799] = {.lex_state = 351},
  [800] = {.lex_state = 351},
  [801] = {.lex_state = 351},
  [802] = {.lex_state = 351},
  [803] = {.lex_state = 184},
  [804] = {.lex_state = 351},
  [805] = {.lex_state = 351},
  [806] = {.lex_state = 351},
  [807] = {.lex_state = 184},
  [808] = {.lex_state = 184},
  [809] = {.lex_state = 351},
  [810] = {.lex_state = 351},
  [811] = {.lex_state = 351},
  [812] = {.lex_state = 184},
  [813] = {.lex_state = 351},
  [814] = {.lex_state = 184},
  [815] = {.lex_state = 351},
  [816] = {.lex_state = 351},
  [817] = {.lex_state = 351},
  [818] = {.lex_state = 351},
  [819] = {.lex_state = 351},
  [820] = {.lex_state = 351},
  [821] = {.lex_state = 351},
  [822] = {.lex_state = 351},
  [823] = {.lex_state = 351},
  [824] = {.lex_state = 351},
  [825] = {.lex_state = 351},
  [826] = {.lex_state = 184},
  [827] = {.lex_state = 351},
  [828] = {.lex_state = 351},
  [829] = {.lex_state = 184},
  [830] = {.lex_state = 351},
  [831] = {.lex_state = 184},
  [832] = {.lex_state = 184},
  [833] = {.lex_state = 351},
  [834] = {.lex_state = 351},
  [835] = {.lex_state = 184},
  [836] = {.lex_state = 351},
  [837] = {.lex_state = 351},
  [838] = {.lex_state = 351},
  [839] = {.lex_state = 351},
  [840] = {.lex_state = 184},
  [841] = {.lex_state = 184},
  [842] = {.lex_state = 184},
  [843] = {.lex_state = 184},
  [844] = {.lex_state = 184},
  [845] = {.lex_state = 351},
  [846] = {.lex_state = 351},
  [847] = {.lex_state = 351},
  [848] = {.lex_state = 351},
  [849] = {.lex_state = 351},
  [850] = {.lex_state = 351},
  [851] = {.lex_state = 184},
  [852] = {.lex_state = 351},
  [853] = {.lex_state = 184},
  [854] = {.lex_state = 351},
  [855] = {.lex_state = 351},
  [856] = {.lex_state = 184},
  [857] = {.lex_state = 351},
  [858] = {.lex_state = 184},
  [859] = {.lex_state = 351},
  [860] = {.lex_state = 351},
  [861] = {.lex_state = 351},
  [862] = {.lex_state = 351},
  [863] = {.lex_state = 184},
  [864] = {.lex_state = 351},
  [865] = {.lex_state = 184},
  [866] = {.lex_state = 184},
  [867] = {.lex_state = 184},
  [868] = {.lex_state = 184},
  [869] = {.lex_state = 184},
  [870] = {.lex_state = 184},
  [871] = {.lex_state = 184},
  [872] = {.lex_state = 351},
  [873] = {.lex_state = 351},
  [874] = {.lex_state = 351},
  [875] = {.lex_state = 184},
  [876] = {.lex_state = 184},
  [877] = {.lex_state = 184},
  [878] = {.lex_state = 184},
  [879] = {.lex_state = 184},
  [880] = {.lex_state = 184},
  [881] = {.lex_state = 351},
  [882] = {.lex_state = 351},
  [883] = {.lex_state = 351},
  [884] = {.lex_state = 351},
  [885] = {.lex_state = 351},
  [886] = {.lex_state = 351},
  [887] = {.lex_state = 351},
  [888] = {.lex_state = 351},
  [889] = {.lex_state = 351},
  [890] = {.lex_state = 351},
  [891] = {.lex_state = 184},
  [892] = {.lex_state = 184},
  [893] = {.lex_state = 351},
  [894] = {.lex_state = 184},
  [895] = {.lex_state = 184},
  [896] = {.lex_state = 351},
  [897] = {.lex_state = 184},
  [898] = {.lex_state = 351},
  [899] = {.lex_state = 351},
  [900] = {.lex_state = 351},
  [901] = {.lex_state = 184},
  [902] = {.lex_state = 351},
  [903] = {.lex_state = 184},
  [904] = {.lex_state = 351},
  [905] = {.lex_state = 351},
  [906] = {.lex_state = 351},
  [907] = {.lex_state = 184},
  [908] = {.lex_state = 184},
  [909] = {.lex_state = 351},
  [910] = {.lex_state = 351},
  [911] = {.lex_state = 351},
  [912] = {.lex_state = 351},
  [913] = {.lex_state = 351},
  [914] = {.lex_state = 351},
  [915] = {.lex_state = 351},
  [916] = {.lex_state = 351},
  [917] = {.lex_state = 351},
  [918] = {.lex_state = 351},
  [919] = {.lex_state = 184},
  [920] = {.lex_state = 184},
  [921] = {.lex_state = 184},
  [922] = {.lex_state = 351},
  [923] = {.lex_state = 351},
  [924] = {.lex_state = 351},
  [925] = {.lex_state = 184},
  [926] = {.lex_state = 184},
  [927] = {.lex_state = 184},
  [928] = {.lex_state = 184},
  [929] = {.lex_state = 184},
  [930] = {.lex_state = 351},
  [931] = {.lex_state = 351},
  [932] = {.lex_state = 351},
  [933] = {.lex_state = 351},
  [934] = {.lex_state = 351},
  [935] = {.lex_state = 351},
  [936] = {.lex_state = 351},
  [937] = {.lex_state = 351},
  [938] = {.lex_state = 351},
  [939] = {.lex_state = 351},
  [940] = {.lex_state = 184},
  [941] = {.lex_state = 184},
  [942] = {.lex_state = 351},
  [943] = {.lex_state = 184},
  [944] = {.lex_state = 184},
  [945] = {.lex_state = 184},
  [946] = {.lex_state = 184},
  [947] = {.lex_state = 184},
  [948] = {.lex_state = 184},
  [949] = {.lex_state = 184},
  [950] = {.lex_state = 184},
  [951] = {.lex_state = 184},
  [952] = {.lex_state = 184},
  [953] = {.lex_state = 184},
  [954] = {.lex_state = 351},
  [955] = {.lex_state = 351},
  [956] = {.lex_state = 184},
  [957] = {.lex_state = 184},
  [958] = {.lex_state = 184},
  [959] = {.lex_state = 351},
  [960] = {.lex_state = 351},
  [961] = {.lex_state = 184},
  [962] = {.lex_state = 184},
  [963] = {.lex_state = 184},
  [964] = {.lex_state = 351},
  [965] = {.lex_state = 351},
  [966] = {.lex_state = 351},
  [967] = {.lex_state = 351},
  [968] = {.lex_state = 184},
  [969] = {.lex_state = 351},
  [970] = {.lex_state = 351},
  [971] = {.lex_state = 351},
  [972] = {.lex_state = 184},
  [973] = {.lex_state = 351},
  [974] = {.lex_state = 184},
  [975] = {.lex_state = 351},
  [976] = {.lex_state = 184},
  [977] = {.lex_state = 351},
  [978] = {.lex_state = 184},
  [979] = {.lex_state = 184},
  [980] = {.lex_state = 184},
  [981] = {.lex_state = 184},
  [982] = {.lex_state = 351},
  [983] = {.lex_state = 184},
  [984] = {.lex_state = 351},
  [985] = {.lex_state = 184},
  [986] = {.lex_state = 184},
  [987] = {.lex_state = 351},
  [988] = {.lex_state = 351},
  [989] = {.lex_state = 184},
  [990] = {.lex_state = 351},
  [991] = {.lex_state = 351},
  [992] = {.lex_state = 184},
  [993] = {.lex_state = 351},
  [994] = {.lex_state = 351},
  [995] = {.lex_state = 351},
  [996] = {.lex_state = 351},
  [997] = {.lex_state = 351},
  [998] = {.lex_state = 351},
  [999] = {.lex_state = 351},
  [1000] = {.lex_state = 351},
  [1001] = {.lex_state = 351},
  [1002] = {.lex_state = 351},
  [1003] = {.lex_state = 351},
  [1004] = {.lex_state = 351},
  [1005] = {.lex_state = 351},
  [1006] = {.lex_state = 351},
  [1007] = {.lex_state = 351},
  [1008] = {.lex_state = 351},
  [1009] = {.lex_state = 351},
  [1010] = {.lex_state = 351},
  [1011] = {.lex_state = 351},
  [1012] = {.lex_state = 351},
  [1013] = {.lex_state = 351},
  [1014] = {.lex_state = 351},
  [1015] = {.lex_state = 351},
  [1016] = {.lex_state = 351},
  [1017] = {.lex_state = 351},
  [1018] = {.lex_state = 351},
  [1019] = {.lex_state = 351},
  [1020] = {.lex_state = 351},
  [1021] = {.lex_state = 351},
  [1022] = {.lex_state = 351},
  [1023] = {.lex_state = 351},
  [1024] = {.lex_state = 351},
  [1025] = {.lex_state = 351},
  [1026] = {.lex_state = 351},
  [1027] = {.lex_state = 351},
  [1028] = {.lex_state = 351},
  [1029] = {.lex_state = 351},
  [1030] = {.lex_state = 351},
  [1031] = {.lex_state = 351},
  [1032] = {.lex_state = 351},
  [1033] = {.lex_state = 351},
  [1034] = {.lex_state = 351},
  [1035] = {.lex_state = 351},
  [1036] = {.lex_state = 351},
  [1037] = {.lex_state = 351},
  [1038] = {.lex_state = 351},
  [1039] = {.lex_state = 351},
  [1040] = {.lex_state = 351},
  [1041] = {.lex_state = 351},
  [1042] = {.lex_state = 351},
  [1043] = {.lex_state = 351},
  [1044] = {.lex_state = 351},
  [1045] = {.lex_state = 351},
  [1046] = {.lex_state = 351},
  [1047] = {.lex_state = 351},
  [1048] = {.lex_state = 351},
  [1049] = {.lex_state = 351},
  [1050] = {.lex_state = 351},
  [1051] = {.lex_state = 351},
  [1052] = {.lex_state = 351},
  [1053] = {.lex_state = 351},
  [1054] = {.lex_state = 351},
  [1055] = {.lex_state = 351},
  [1056] = {.lex_state = 351},
  [1057] = {.lex_state = 351},
  [1058] = {.lex_state = 351},
  [1059] = {.lex_state = 351},
  [1060] = {.lex_state = 351},
  [1061] = {.lex_state = 351},
  [1062] = {.lex_state = 351},
  [1063] = {.lex_state = 351},
  [1064] = {.lex_state = 351},
  [1065] = {.lex_state = 351},
  [1066] = {.lex_state = 351},
  [1067] = {.lex_state = 351},
  [1068] = {.lex_state = 351},
  [1069] = {.lex_state = 351},
  [1070] = {.lex_state = 351},
  [1071] = {.lex_state = 351},
  [1072] = {.lex_state = 351},
  [1073] = {.lex_state = 351},
  [1074] = {.lex_state = 351},
  [1075] = {.lex_state = 351},
  [1076] = {.lex_state = 351},
  [1077] = {.lex_state = 351},
  [1078] = {.lex_state = 351},
  [1079] = {.lex_state = 351},
  [1080] = {.lex_state = 179},
  [1081] = {.lex_state = 179},
  [1082] = {.lex_state = 249},
  [1083] = {.lex_state = 249},
  [1084] = {.lex_state = 249},
  [1085] = {.lex_state = 249},
  [1086] = {.lex_state = 249},
  [1087] = {.lex_state = 249},
  [1088] = {.lex_state = 249},
  [1089] = {.lex_state = 183},
  [1090] = {.lex_state = 186},
  [1091] = {.lex_state = 186},
  [1092] = {.lex_state = 186},
  [1093] = {.lex_state = 186},
  [1094] = {.lex_state = 186},
  [1095] = {.lex_state = 186},
  [1096] = {.lex_state = 183},
  [1097] = {.lex_state = 186},
  [1098] = {.lex_state = 183},
  [1099] = {.lex_state = 183},
  [1100] = {.lex_state = 183},
  [1101] = {.lex_state = 183},
  [1102] = {.lex_state = 183},
  [1103] = {.lex_state = 186},
  [1104] = {.lex_state = 186},
  [1105] = {.lex_state = 183},
  [1106] = {.lex_state = 183},
  [1107] = {.lex_state = 186},
  [1108] = {.lex_state = 183},
  [1109] = {.lex_state = 183},
  [1110] = {.lex_state = 186},
  [1111] = {.lex_state = 186},
  [1112] = {.lex_state = 183},
  [1113] = {.lex_state = 183},
  [1114] = {.lex_state = 186},
  [1115] = {.lex_state = 183},
  [1116] = {.lex_state = 186},
  [1117] = {.lex_state = 183},
  [1118] = {.lex_state = 186},
  [1119] = {.lex_state = 183},
  [1120] = {.lex_state = 183},
  [1121] = {.lex_state = 183},
  [1122] = {.lex_state = 186},
  [1123] = {.lex_state = 183},
  [1124] = {.lex_state = 183},
  [1125] = {.lex_state = 186},
  [1126] = {.lex_state = 183},
  [1127] = {.lex_state = 249},
  [1128] = {.lex_state = 183},
  [1129] = {.lex_state = 186},
  [1130] = {.lex_state = 183},
  [1131] = {.lex_state = 183},
  [1132] = {.lex_state = 249},
  [1133] = {.lex_state = 249},
  [1134] = {.lex_state = 183},
  [1135] = {.lex_state = 183},
  [1136] = {.lex_state = 249},
  [1137] = {.lex_state = 183},
  [1138] = {.lex_state = 183},
  [1139] = {.lex_state = 183},
  [1140] = {.lex_state = 183},
  [1141] = {.lex_state = 183},
  [1142] = {.lex_state = 186},
  [1143] = {.lex_state = 183},
  [1144] = {.lex_state = 183},
  [1145] = {.lex_state = 183},
  [1146] = {.lex_state = 183},
  [1147] = {.lex_state = 183},
  [1148] = {.lex_state = 183},
  [1149] = {.lex_state = 186},
  [1150] = {.lex_state = 183},
  [1151] = {.lex_state = 183},
  [1152] = {.lex_state = 183},
  [1153] = {.lex_state = 183},
  [1154] = {.lex_state = 183},
  [1155] = {.lex_state = 183},
  [1156] = {.lex_state = 183},
  [1157] = {.lex_state = 183},
  [1158] = {.lex_state = 249},
  [1159] = {.lex_state = 183},
  [1160] = {.lex_state = 186},
  [1161] = {.lex_state = 183},
  [1162] = {.lex_state = 174},
  [1163] = {.lex_state = 183},
  [1164] = {.lex_state = 183},
  [1165] = {.lex_state = 186},
  [1166] = {.lex_state = 183},
  [1167] = {.lex_state = 183},
  [1168] = {.lex_state = 249},
  [1169] = {.lex_state = 183},
  [1170] = {.lex_state = 183},
  [1171] = {.lex_state = 249},
  [1172] = {.lex_state = 183},
  [1173] = {.lex_state = 183},
  [1174] = {.lex_state = 183},
  [1175] = {.lex_state = 183},
  [1176] = {.lex_state = 186},
  [1177] = {.lex_state = 186},
  [1178] = {.lex_state = 183},
  [1179] = {.lex_state = 183},
  [1180] = {.lex_state = 183},
  [1181] = {.lex_state = 183},
  [1182] = {.lex_state = 183},
  [1183] = {.lex_state = 183},
  [1184] = {.lex_state = 183},
  [1185] = {.lex_state = 186},
  [1186] = {.lex_state = 183},
  [1187] = {.lex_state = 183},
  [1188] = {.lex_state = 183},
  [1189] = {.lex_state = 183},
  [1190] = {.lex_state = 186},
  [1191] = {.lex_state = 183},
  [1192] = {.lex_state = 183},
  [1193] = {.lex_state = 183},
  [1194] = {.lex_state = 183},
  [1195] = {.lex_state = 351},
  [1196] = {.lex_state = 174},
  [1197] = {.lex_state = 351},
  [1198] = {.lex_state = 183},
  [1199] = {.lex_state = 183},
  [1200] = {.lex_state = 183},
  [1201] = {.lex_state = 176},
  [1202] = {.lex_state = 183},
  [1203] = {.lex_state = 174},
  [1204] = {.lex_state = 174},
  [1205] = {.lex_state = 186},
  [1206] = {.lex_state = 186},
  [1207] = {.lex_state = 186},
  [1208] = {.lex_state = 186},
  [1209] = {.lex_state = 351},
  [1210] = {.lex_state = 186},
  [1211] = {.lex_state = 186},
  [1212] = {.lex_state = 186},
  [1213] = {.lex_state = 177},
  [1214] = {.lex_state = 186},
  [1215] = {.lex_state = 186},
  [1216] = {.lex_state = 186},
  [1217] = {.lex_state = 186},
  [1218] = {.lex_state = 186},
  [1219] = {.lex_state = 186},
  [1220] = {.lex_state = 186},
  [1221] = {.lex_state = 186},
  [1222] = {.lex_state = 186},
  [1223] = {.lex_state = 186},
  [1224] = {.lex_state = 186},
  [1225] = {.lex_state = 186},
  [1226] = {.lex_state = 186},
  [1227] = {.lex_state = 186},
  [1228] = {.lex_state = 186},
  [1229] = {.lex_state = 186},
  [1230] = {.lex_state = 186},
  [1231] = {.lex_state = 186},
  [1232] = {.lex_state = 186},
  [1233] = {.lex_state = 183},
  [1234] = {.lex_state = 183},
  [1235] = {.lex_state = 183},
  [1236] = {.lex_state = 183},
  [1237] = {.lex_state = 183},
  [1238] = {.lex_state = 183},
  [1239] = {.lex_state = 183},
  [1240] = {.lex_state = 183},
  [1241] = {.lex_state = 183},
  [1242] = {.lex_state = 183},
  [1243] = {.lex_state = 183},
  [1244] = {.lex_state = 183},
  [1245] = {.lex_state = 183},
  [1246] = {.lex_state = 183},
  [1247] = {.lex_state = 183},
  [1248] = {.lex_state = 183},
  [1249] = {.lex_state = 183},
  [1250] = {.lex_state = 183},
  [1251] = {.lex_state = 183},
  [1252] = {.lex_state = 183},
  [1253] = {.lex_state = 183},
  [1254] = {.lex_state = 183},
  [1255] = {.lex_state = 186},
  [1256] = {.lex_state = 183},
  [1257] = {.lex_state = 186},
  [1258] = {.lex_state = 186},
  [1259] = {.lex_state = 186},
  [1260] = {.lex_state = 198},
  [1261] = {.lex_state = 186},
  [1262] = {.lex_state = 176},
  [1263] = {.lex_state = 186},
  [1264] = {.lex_state = 186},
  [1265] = {.lex_state = 186},
  [1266] = {.lex_state = 183},
  [1267] = {.lex_state = 183},
  [1268] = {.lex_state = 183},
  [1269] = {.lex_state = 183},
  [1270] = {.lex_state = 198},
  [1271] = {.lex_state = 198},
  [1272] = {.lex_state = 198},
  [1273] = {.lex_state = 183},
  [1274] = {.lex_state = 183},
  [1275] = {.lex_state = 183},
  [1276] = {.lex_state = 183},
  [1277] = {.lex_state = 183},
  [1278] = {.lex_state = 183},
  [1279] = {.lex_state = 183},
  [1280] = {.lex_state = 183},
  [1281] = {.lex_state = 183},
  [1282] = {.lex_state = 183},
  [1283] = {.lex_state = 183},
  [1284] = {.lex_state = 183},
  [1285] = {.lex_state = 183},
  [1286] = {.lex_state = 183},
  [1287] = {.lex_state = 183},
  [1288] = {.lex_state = 183},
  [1289] = {.lex_state = 183},
  [1290] = {.lex_state = 183},
  [1291] = {.lex_state = 183},
  [1292] = {.lex_state = 183},
  [1293] = {.lex_state = 183},
  [1294] = {.lex_state = 183},
  [1295] = {.lex_state = 183},
  [1296] = {.lex_state = 183},
  [1297] = {.lex_state = 183},
  [1298] = {.lex_state = 183},
  [1299] = {.lex_state = 183},
  [1300] = {.lex_state = 183},
  [1301] = {.lex_state = 183},
  [1302] = {.lex_state = 183},
  [1303] = {.lex_state = 183},
  [1304] = {.lex_state = 183},
  [1305] = {.lex_state = 183},
  [1306] = {.lex_state = 183},
  [1307] = {.lex_state = 183},
  [1308] = {.lex_state = 183},
  [1309] = {.lex_state = 183},
  [1310] = {.lex_state = 183},
  [1311] = {.lex_state = 249},
  [1312] = {.lex_state = 183},
  [1313] = {.lex_state = 183},
  [1314] = {.lex_state = 183},
  [1315] = {.lex_state = 183},
  [1316] = {.lex_state = 183},
  [1317] = {.lex_state = 183},
  [1318] = {.lex_state = 183},
  [1319] = {.lex_state = 183},
  [1320] = {.lex_state = 183},
  [1321] = {.lex_state = 183},
  [1322] = {.lex_state = 183},
  [1323] = {.lex_state = 183},
  [1324] = {.lex_state = 183},
  [1325] = {.lex_state = 183},
  [1326] = {.lex_state = 183},
  [1327] = {.lex_state = 183},
  [1328] = {.lex_state = 183},
  [1329] = {.lex_state = 183},
  [1330] = {.lex_state = 183},
  [1331] = {.lex_state = 183},
  [1332] = {.lex_state = 183},
  [1333] = {.lex_state = 183},
  [1334] = {.lex_state = 183},
  [1335] = {.lex_state = 185},
  [1336] = {.lex_state = 185},
  [1337] = {.lex_state = 194},
  [1338] = {.lex_state = 198},
  [1339] = {.lex_state = 198},
  [1340] = {.lex_state = 198},
  [1341] = {.lex_state = 198},
  [1342] = {.lex_state = 198},
  [1343] = {.lex_state = 198},
  [1344] = {.lex_state = 175},
  [1345] = {.lex_state = 175},
  [1346] = {.lex_state = 175},
  [1347] = {.lex_state = 175},
  [1348] = {.lex_state = 175},
  [1349] = {.lex_state = 178},
  [1350] = {.lex_state = 175},
  [1351] = {.lex_state = 206},
  [1352] = {.lex_state = 206},
  [1353] = {.lex_state = 206},
  [1354] = {.lex_state = 249},
  [1355] = {.lex_state = 206},
  [1356] = {.lex_state = 206},
  [1357] = {.lex_state = 206},
  [1358] = {.lex_state = 206},
  [1359] = {.lex_state = 206},
  [1360] = {.lex_state = 206},
  [1361] = {.lex_state = 206},
  [1362] = {.lex_state = 206},
  [1363] = {.lex_state = 206},
  [1364] = {.lex_state = 206},
  [1365] = {.lex_state = 249},
  [1366] = {.lex_state = 206},
  [1367] = {.lex_state = 206},
  [1368] = {.lex_state = 206},
  [1369] = {.lex_state = 206},
  [1370] = {.lex_state = 249},
  [1371] = {.lex_state = 249},
  [1372] = {.lex_state = 249},
  [1373] = {.lex_state = 249},
  [1374] = {.lex_state = 183},
  [1375] = {.lex_state = 204},
  [1376] = {.lex_state = 183},
  [1377] = {.lex_state = 183},
  [1378] = {.lex_state = 204},
  [1379] = {.lex_state = 206},
  [1380] = {.lex_state = 204},
  [1381] = {.lex_state = 204},
  [1382] = {.lex_state = 204},
  [1383] = {.lex_state = 204},
  [1384] = {.lex_state = 204},
  [1385] = {.lex_state = 204},
  [1386] = {.lex_state = 204},
  [1387] = {.lex_state = 204},
  [1388] = {.lex_state = 204},
  [1389] = {.lex_state = 204},
  [1390] = {.lex_state = 204},
  [1391] = {.lex_state = 204},
  [1392] = {.lex_state = 204},
  [1393] = {.lex_state = 204},
  [1394] = {.lex_state = 204},
  [1395] = {.lex_state = 186},
  [1396] = {.lex_state = 186},
  [1397] = {.lex_state = 186},
  [1398] = {.lex_state = 206},
  [1399] = {.lex_state = 186},
  [1400] = {.lex_state = 186},
  [1401] = {.lex_state = 186},
  [1402] = {.lex_state = 186},
  [1403] = {.lex_state = 186},
  [1404] = {.lex_state = 186},
  [1405] = {.lex_state = 186},
  [1406] = {.lex_state = 186},
  [1407] = {.lex_state = 186},
  [1408] = {.lex_state = 186},
  [1409] = {.lex_state = 186},
  [1410] = {.lex_state = 186},
  [1411] = {.lex_state = 186},
  [1412] = {.lex_state = 186},
  [1413] = {.lex_state = 186},
  [1414] = {.lex_state = 186},
  [1415] = {.lex_state = 186},
  [1416] = {.lex_state = 186},
  [1417] = {.lex_state = 204},
  [1418] = {.lex_state = 204},
  [1419] = {.lex_state = 204},
  [1420] = {.lex_state = 204},
  [1421] = {.lex_state = 204},
  [1422] = {.lex_state = 204},
  [1423] = {.lex_state = 204},
  [1424] = {.lex_state = 204},
  [1425] = {.lex_state = 204},
  [1426] = {.lex_state = 204},
  [1427] = {.lex_state = 204},
  [1428] = {.lex_state = 204},
  [1429] = {.lex_state = 204},
  [1430] = {.lex_state = 204},
  [1431] = {.lex_state = 204},
  [1432] = {.lex_state = 204},
  [1433] = {.lex_state = 235},
  [1434] = {.lex_state = 235},
  [1435] = {.lex_state = 235},
  [1436] = {.lex_state = 235},
  [1437] = {.lex_state = 235},
  [1438] = {.lex_state = 235},
  [1439] = {.lex_state = 235},
  [1440] = {.lex_state = 235},
  [1441] = {.lex_state = 235},
  [1442] = {.lex_state = 235},
  [1443] = {.lex_state = 235},
  [1444] = {.lex_state = 235},
  [1445] = {.lex_state = 235},
  [1446] = {.lex_state = 235},
  [1447] = {.lex_state = 235},
  [1448] = {.lex_state = 249},
  [1449] = {.lex_state = 185},
  [1450] = {.lex_state = 249},
  [1451] = {.lex_state = 249},
  [1452] = {.lex_state = 249},
  [1453] = {.lex_state = 185},
  [1454] = {.lex_state = 249},
  [1455] = {.lex_state = 249},
  [1456] = {.lex_state = 249},
  [1457] = {.lex_state = 249},
  [1458] = {.lex_state = 249},
  [1459] = {.lex_state = 249},
  [1460] = {.lex_state = 249},
  [1461] = {.lex_state = 235},
  [1462] = {.lex_state = 186},
  [1463] = {.lex_state = 186},
  [1464] = {.lex_state = 186},
  [1465] = {.lex_state = 186},
  [1466] = {.lex_state = 186},
  [1467] = {.lex_state = 186},
  [1468] = {.lex_state = 186},
  [1469] = {.lex_state = 186},
  [1470] = {.lex_state = 186},
  [1471] = {.lex_state = 186},
  [1472] = {.lex_state = 186},
  [1473] = {.lex_state = 186},
  [1474] = {.lex_state = 186},
  [1475] = {.lex_state = 249},
  [1476] = {.lex_state = 186},
  [1477] = {.lex_state = 249},
  [1478] = {.lex_state = 186},
  [1479] = {.lex_state = 249},
  [1480] = {.lex_state = 186},
  [1481] = {.lex_state = 186},
  [1482] = {.lex_state = 186},
  [1483] = {.lex_state = 249},
  [1484] = {.lex_state = 186},
  [1485] = {.lex_state = 186},
  [1486] = {.lex_state = 186},
  [1487] = {.lex_state = 186},
  [1488] = {.lex_state = 186},
  [1489] = {.lex_state = 186},
  [1490] = {.lex_state = 186},
  [1491] = {.lex_state = 186},
  [1492] = {.lex_state = 186},
  [1493] = {.lex_state = 186},
  [1494] = {.lex_state = 186},
  [1495] = {.lex_state = 186},
  [1496] = {.lex_state = 186},
  [1497] = {.lex_state = 186},
  [1498] = {.lex_state = 186},
  [1499] = {.lex_state = 186},
  [1500] = {.lex_state = 186},
  [1501] = {.lex_state = 249},
  [1502] = {.lex_state = 186},
  [1503] = {.lex_state = 249},
  [1504] = {.lex_state = 186},
  [1505] = {.lex_state = 186},
  [1506] = {.lex_state = 249},
  [1507] = {.lex_state = 249},
  [1508] = {.lex_state = 249},
  [1509] = {.lex_state = 186},
  [1510] = {.lex_state = 249},
  [1511] = {.lex_state = 249},
  [1512] = {.lex_state = 249},
  [1513] = {.lex_state = 249},
  [1514] = {.lex_state = 249},
  [1515] = {.lex_state = 249},
  [1516] = {.lex_state = 249},
  [1517] = {.lex_state = 249},
  [1518] = {.lex_state = 249},
  [1519] = {.lex_state = 249},
  [1520] = {.lex_state = 249},
  [1521] = {.lex_state = 249},
  [1522] = {.lex_state = 249},
  [1523] = {.lex_state = 249},
  [1524] = {.lex_state = 186},
  [1525] = {.lex_state = 249},
  [1526] = {.lex_state = 186},
  [1527] = {.lex_state = 235},
  [1528] = {.lex_state = 249},
  [1529] = {.lex_state = 186},
  [1530] = {.lex_state = 249},
  [1531] = {.lex_state = 249},
  [1532] = {.lex_state = 249},
  [1533] = {.lex_state = 186},
  [1534] = {.lex_state = 186},
  [1535] = {.lex_state = 186},
  [1536] = {.lex_state = 186},
  [1537] = {.lex_state = 249},
  [1538] = {.lex_state = 249},
  [1539] = {.lex_state = 249},
  [1540] = {.lex_state = 186},
  [1541] = {.lex_state = 249},
  [1542] = {.lex_state = 186},
  [1543] = {.lex_state = 249},
  [1544] = {.lex_state = 186},
  [1545] = {.lex_state = 249},
  [1546] = {.lex_state = 186},
  [1547] = {.lex_state = 249},
  [1548] = {.lex_state = 249},
  [1549] = {.lex_state = 249},
  [1550] = {.lex_state = 249},
  [1551] = {.lex_state = 249},
  [1552] = {.lex_state = 249},
  [1553] = {.lex_state = 249},
  [1554] = {.lex_state = 249},
  [1555] = {.lex_state = 186},
  [1556] = {.lex_state = 249},
  [1557] = {.lex_state = 249},
  [1558] = {.lex_state = 249},
  [1559] = {.lex_state = 249},
  [1560] = {.lex_state = 249},
  [1561] = {.lex_state = 249},
  [1562] = {.lex_state = 249},
  [1563] = {.lex_state = 186},
  [1564] = {.lex_state = 186},
  [1565] = {.lex_state = 186},
  [1566] = {.lex_state = 249},
  [1567] = {.lex_state = 249},
  [1568] = {.lex_state = 249},
  [1569] = {.lex_state = 249},
  [1570] = {.lex_state = 249},
  [1571] = {.lex_state = 249},
  [1572] = {.lex_state = 249},
  [1573] = {.lex_state = 249},
  [1574] = {.lex_state = 249},
  [1575] = {.lex_state = 249},
  [1576] = {.lex_state = 249},
  [1577] = {.lex_state = 249},
  [1578] = {.lex_state = 249},
  [1579] = {.lex_state = 249},
  [1580] = {.lex_state = 249},
  [1581] = {.lex_state = 186},
  [1582] = {.lex_state = 249},
  [1583] = {.lex_state = 249},
  [1584] = {.lex_state = 249},
  [1585] = {.lex_state = 186},
  [1586] = {.lex_state = 186},
  [1587] = {.lex_state = 249},
  [1588] = {.lex_state = 249},
  [1589] = {.lex_state = 249},
  [1590] = {.lex_state = 249},
  [1591] = {.lex_state = 249},
  [1592] = {.lex_state = 249},
  [1593] = {.lex_state = 249},
  [1594] = {.lex_state = 249},
  [1595] = {.lex_state = 249},
  [1596] = {.lex_state = 186},
  [1597] = {.lex_state = 187},
  [1598] = {.lex_state = 249},
  [1599] = {.lex_state = 249},
  [1600] = {.lex_state = 249},
  [1601] = {.lex_state = 249},
  [1602] = {.lex_state = 249},
  [1603] = {.lex_state = 249},
  [1604] = {.lex_state = 249},
  [1605] = {.lex_state = 249},
  [1606] = {.lex_state = 187},
  [1607] = {.lex_state = 249},
  [1608] = {.lex_state = 186},
  [1609] = {.lex_state = 249},
  [1610] = {.lex_state = 249},
  [1611] = {.lex_state = 249},
  [1612] = {.lex_state = 249},
  [1613] = {.lex_state = 249},
  [1614] = {.lex_state = 249},
  [1615] = {.lex_state = 249},
  [1616] = {.lex_state = 249},
  [1617] = {.lex_state = 249},
  [1618] = {.lex_state = 186},
  [1619] = {.lex_state = 249},
  [1620] = {.lex_state = 249},
  [1621] = {.lex_state = 249},
  [1622] = {.lex_state = 249},
  [1623] = {.lex_state = 249},
  [1624] = {.lex_state = 249},
  [1625] = {.lex_state = 249},
  [1626] = {.lex_state = 249},
  [1627] = {.lex_state = 249},
  [1628] = {.lex_state = 249},
  [1629] = {.lex_state = 249},
  [1630] = {.lex_state = 186},
  [1631] = {.lex_state = 249},
  [1632] = {.lex_state = 249},
  [1633] = {.lex_state = 249},
  [1634] = {.lex_state = 187},
  [1635] = {.lex_state = 249},
  [1636] = {.lex_state = 249},
  [1637] = {.lex_state = 249},
  [1638] = {.lex_state = 249},
  [1639] = {.lex_state = 249},
  [1640] = {.lex_state = 249},
  [1641] = {.lex_state = 249},
  [1642] = {.lex_state = 249},
  [1643] = {.lex_state = 249},
  [1644] = {.lex_state = 249},
  [1645] = {.lex_state = 249},
  [1646] = {.lex_state = 249},
  [1647] = {.lex_state = 249},
  [1648] = {.lex_state = 249},
  [1649] = {.lex_state = 249},
  [1650] = {.lex_state = 249},
  [1651] = {.lex_state = 249},
  [1652] = {.lex_state = 249},
  [1653] = {.lex_state = 249},
  [1654] = {.lex_state = 249},
  [1655] = {.lex_state = 249},
  [1656] = {.lex_state = 249},
  [1657] = {.lex_state = 249},
  [1658] = {.lex_state = 249},
  [1659] = {.lex_state = 249},
  [1660] = {.lex_state = 249},
  [1661] = {.lex_state = 249},
  [1662] = {.lex_state = 249},
  [1663] = {.lex_state = 249},
  [1664] = {.lex_state = 249},
  [1665] = {.lex_state = 249},
  [1666] = {.lex_state = 249},
  [1667] = {.lex_state = 249},
  [1668] = {.lex_state = 249},
  [1669] = {.lex_state = 186},
  [1670] = {.lex_state = 185},
  [1671] = {.lex_state = 186},
  [1672] = {.lex_state = 186},
  [1673] = {.lex_state = 186},
  [1674] = {.lex_state = 186},
  [1675] = {.lex_state = 186},
  [1676] = {.lex_state = 185},
  [1677] = {.lex_state = 186},
  [1678] = {.lex_state = 185},
  [1679] = {.lex_state = 186},
  [1680] = {.lex_state = 185},
  [1681] = {.lex_state = 205},
  [1682] = {.lex_state = 186},
  [1683] = {.lex_state = 186},
  [1684] = {.lex_state = 186},
  [1685] = {.lex_state = 186},
  [1686] = {.lex_state = 186},
  [1687] = {.lex_state = 250},
  [1688] = {.lex_state = 186},
  [1689] = {.lex_state = 250},
  [1690] = {.lex_state = 186},
  [1691] = {.lex_state = 186},
  [1692] = {.lex_state = 185},
  [1693] = {.lex_state = 186},
  [1694] = {.lex_state = 185},
  [1695] = {.lex_state = 186},
  [1696] = {.lex_state = 186},
  [1697] = {.lex_state = 186},
  [1698] = {.lex_state = 185},
  [1699] = {.lex_state = 186},
  [1700] = {.lex_state = 185},
  [1701] = {.lex_state = 185},
  [1702] = {.lex_state = 185},
  [1703] = {.lex_state = 185},
  [1704] = {.lex_state = 185},
  [1705] = {.lex_state = 185},
  [1706] = {.lex_state = 186},
  [1707] = {.lex_state = 205},
  [1708] = {.lex_state = 185},
  [1709] = {.lex_state = 186},
  [1710] = {.lex_state = 186},
  [1711] = {.lex_state = 186},
  [1712] = {.lex_state = 185},
  [1713] = {.lex_state = 186},
  [1714] = {.lex_state = 186},
  [1715] = {.lex_state = 186},
  [1716] = {.lex_state = 205},
  [1717] = {.lex_state = 186},
  [1718] = {.lex_state = 185},
  [1719] = {.lex_state = 205},
  [1720] = {.lex_state = 186},
  [1721] = {.lex_state = 186},
  [1722] = {.lex_state = 185},
  [1723] = {.lex_state = 186},
  [1724] = {.lex_state = 185},
  [1725] = {.lex_state = 185},
  [1726] = {.lex_state = 186},
  [1727] = {.lex_state = 250},
  [1728] = {.lex_state = 186},
  [1729] = {.lex_state = 186},
  [1730] = {.lex_state = 186},
  [1731] = {.lex_state = 185},
  [1732] = {.lex_state = 186},
  [1733] = {.lex_state = 185},
  [1734] = {.lex_state = 250},
  [1735] = {.lex_state = 185},
  [1736] = {.lex_state = 186},
  [1737] = {.lex_state = 185},
  [1738] = {.lex_state = 185},
  [1739] = {.lex_state = 185},
  [1740] = {.lex_state = 186},
  [1741] = {.lex_state = 185},
  [1742] = {.lex_state = 186},
  [1743] = {.lex_state = 186},
  [1744] = {.lex_state = 186},
  [1745] = {.lex_state = 186},
  [1746] = {.lex_state = 186},
  [1747] = {.lex_state = 186},
  [1748] = {.lex_state = 186},
  [1749] = {.lex_state = 186},
  [1750] = {.lex_state = 186},
  [1751] = {.lex_state = 186},
  [1752] = {.lex_state = 186},
  [1753] = {.lex_state = 186},
  [1754] = {.lex_state = 186},
  [1755] = {.lex_state = 186},
  [1756] = {.lex_state = 186},
  [1757] = {.lex_state = 186},
  [1758] = {.lex_state = 186},
  [1759] = {.lex_state = 186},
  [1760] = {.lex_state = 186},
  [1761] = {.lex_state = 186},
  [1762] = {.lex_state = 186},
  [1763] = {.lex_state = 186},
  [1764] = {.lex_state = 186},
  [1765] = {.lex_state = 186},
  [1766] = {.lex_state = 186},
  [1767] = {.lex_state = 186},
  [1768] = {.lex_state = 186},
  [1769] = {.lex_state = 186},
  [1770] = {.lex_state = 186},
  [1771] = {.lex_state = 186},
  [1772] = {.lex_state = 186},
  [1773] = {.lex_state = 186},
  [1774] = {.lex_state = 186},
  [1775] = {.lex_state = 186},
  [1776] = {.lex_state = 186},
  [1777] = {.lex_state = 186},
  [1778] = {.lex_state = 186},
  [1779] = {.lex_state = 186},
  [1780] = {.lex_state = 186},
  [1781] = {.lex_state = 186},
  [1782] = {.lex_state = 186},
  [1783] = {.lex_state = 205},
  [1784] = {.lex_state = 186},
  [1785] = {.lex_state = 186},
  [1786] = {.lex_state = 186},
  [1787] = {.lex_state = 186},
  [1788] = {.lex_state = 186},
  [1789] = {.lex_state = 186},
  [1790] = {.lex_state = 186},
  [1791] = {.lex_state = 186},
  [1792] = {.lex_state = 186},
  [1793] = {.lex_state = 186},
  [1794] = {.lex_state = 186},
  [1795] = {.lex_state = 186},
  [1796] = {.lex_state = 186},
  [1797] = {.lex_state = 186},
  [1798] = {.lex_state = 186},
  [1799] = {.lex_state = 186},
  [1800] = {.lex_state = 186},
  [1801] = {.lex_state = 250},
  [1802] = {.lex_state = 186},
  [1803] = {.lex_state = 186},
  [1804] = {.lex_state = 186},
  [1805] = {.lex_state = 186},
  [1806] = {.lex_state = 250},
  [1807] = {.lex_state = 186},
  [1808] = {.lex_state = 186},
  [1809] = {.lex_state = 205},
  [1810] = {.lex_state = 186},
  [1811] = {.lex_state = 186},
  [1812] = {.lex_state = 186},
  [1813] = {.lex_state = 250},
  [1814] = {.lex_state = 249},
  [1815] = {.lex_state = 186},
  [1816] = {.lex_state = 186},
  [1817] = {.lex_state = 186},
  [1818] = {.lex_state = 205},
  [1819] = {.lex_state = 249},
  [1820] = {.lex_state = 186},
  [1821] = {.lex_state = 249},
  [1822] = {.lex_state = 186},
  [1823] = {.lex_state = 186},
  [1824] = {.lex_state = 186},
  [1825] = {.lex_state = 186},
  [1826] = {.lex_state = 186},
  [1827] = {.lex_state = 249},
  [1828] = {.lex_state = 186},
  [1829] = {.lex_state = 249},
  [1830] = {.lex_state = 249},
  [1831] = {.lex_state = 249},
  [1832] = {.lex_state = 186},
  [1833] = {.lex_state = 186},
  [1834] = {.lex_state = 186},
  [1835] = {.lex_state = 249},
  [1836] = {.lex_state = 186},
  [1837] = {.lex_state = 186},
  [1838] = {.lex_state = 186},
  [1839] = {.lex_state = 186},
  [1840] = {.lex_state = 186},
  [1841] = {.lex_state = 186},
  [1842] = {.lex_state = 186},
  [1843] = {.lex_state = 249},
  [1844] = {.lex_state = 250},
  [1845] = {.lex_state = 186},
  [1846] = {.lex_state = 186},
  [1847] = {.lex_state = 249},
  [1848] = {.lex_state = 249},
  [1849] = {.lex_state = 249},
  [1850] = {.lex_state = 249},
  [1851] = {.lex_state = 186},
  [1852] = {.lex_state = 186},
  [1853] = {.lex_state = 186},
  [1854] = {.lex_state = 186},
  [1855] = {.lex_state = 249},
  [1856] = {.lex_state = 249},
  [1857] = {.lex_state = 186},
  [1858] = {.lex_state = 186},
  [1859] = {.lex_state = 249},
  [1860] = {.lex_state = 186},
  [1861] = {.lex_state = 249},
  [1862] = {.lex_state = 186},
  [1863] = {.lex_state = 205},
  [1864] = {.lex_state = 186},
  [1865] = {.lex_state = 249},
  [1866] = {.lex_state = 186},
  [1867] = {.lex_state = 249},
  [1868] = {.lex_state = 186},
  [1869] = {.lex_state = 186},
  [1870] = {.lex_state = 249},
  [1871] = {.lex_state = 186},
  [1872] = {.lex_state = 186},
  [1873] = {.lex_state = 186},
  [1874] = {.lex_state = 186},
  [1875] = {.lex_state = 186},
  [1876] = {.lex_state = 186},
  [1877] = {.lex_state = 186},
  [1878] = {.lex_state = 186},
  [1879] = {.lex_state = 186},
  [1880] = {.lex_state = 186},
  [1881] = {.lex_state = 186},
  [1882] = {.lex_state = 186},
  [1883] = {.lex_state = 186},
  [1884] = {.lex_state = 186},
  [1885] = {.lex_state = 186},
  [1886] = {.lex_state = 186},
  [1887] = {.lex_state = 186},
  [1888] = {.lex_state = 186},
  [1889] = {.lex_state = 186},
  [1890] = {.lex_state = 186},
  [1891] = {.lex_state = 186},
  [1892] = {.lex_state = 186},
  [1893] = {.lex_state = 186},
  [1894] = {.lex_state = 186},
  [1895] = {.lex_state = 186},
  [1896] = {.lex_state = 186},
  [1897] = {.lex_state = 186},
  [1898] = {.lex_state = 186},
  [1899] = {.lex_state = 186},
  [1900] = {.lex_state = 249},
  [1901] = {.lex_state = 186},
  [1902] = {.lex_state = 186},
  [1903] = {.lex_state = 186},
  [1904] = {.lex_state = 186},
  [1905] = {.lex_state = 186},
  [1906] = {.lex_state = 249},
  [1907] = {.lex_state = 249},
  [1908] = {.lex_state = 249},
  [1909] = {.lex_state = 249},
  [1910] = {.lex_state = 186},
  [1911] = {.lex_state = 186},
  [1912] = {.lex_state = 249},
  [1913] = {.lex_state = 186},
  [1914] = {.lex_state = 186},
  [1915] = {.lex_state = 186},
  [1916] = {.lex_state = 186},
  [1917] = {.lex_state = 186},
  [1918] = {.lex_state = 186},
  [1919] = {.lex_state = 186},
  [1920] = {.lex_state = 249},
  [1921] = {.lex_state = 249},
  [1922] = {.lex_state = 186},
  [1923] = {.lex_state = 186},
  [1924] = {.lex_state = 186},
  [1925] = {.lex_state = 186},
  [1926] = {.lex_state = 186},
  [1927] = {.lex_state = 186},
  [1928] = {.lex_state = 186},
  [1929] = {.lex_state = 186},
  [1930] = {.lex_state = 186},
  [1931] = {.lex_state = 186},
  [1932] = {.lex_state = 186},
  [1933] = {.lex_state = 186},
  [1934] = {.lex_state = 186},
  [1935] = {.lex_state = 186},
  [1936] = {.lex_state = 249},
  [1937] = {.lex_state = 249},
  [1938] = {.lex_state = 186},
  [1939] = {.lex_state = 186},
  [1940] = {.lex_state = 186},
  [1941] = {.lex_state = 186},
  [1942] = {.lex_state = 186},
  [1943] = {.lex_state = 186},
  [1944] = {.lex_state = 186},
  [1945] = {.lex_state = 186},
  [1946] = {.lex_state = 250},
  [1947] = {.lex_state = 186},
  [1948] = {.lex_state = 186},
  [1949] = {.lex_state = 250},
  [1950] = {.lex_state = 186},
  [1951] = {.lex_state = 186},
  [1952] = {.lex_state = 186},
  [1953] = {.lex_state = 186},
  [1954] = {.lex_state = 186},
  [1955] = {.lex_state = 186},
  [1956] = {.lex_state = 186},
  [1957] = {.lex_state = 186},
  [1958] = {.lex_state = 186},
  [1959] = {.lex_state = 250},
  [1960] = {.lex_state = 186},
  [1961] = {.lex_state = 186},
  [1962] = {.lex_state = 250},
  [1963] = {.lex_state = 250},
  [1964] = {.lex_state = 250},
  [1965] = {.lex_state = 186},
  [1966] = {.lex_state = 186},
  [1967] = {.lex_state = 186},
  [1968] = {.lex_state = 186},
  [1969] = {.lex_state = 186},
  [1970] = {.lex_state = 250},
  [1971] = {.lex_state = 250},
  [1972] = {.lex_state = 250},
  [1973] = {.lex_state = 186},
  [1974] = {.lex_state = 250},
  [1975] = {.lex_state = 186},
  [1976] = {.lex_state = 186},
  [1977] = {.lex_state = 186},
  [1978] = {.lex_state = 250},
  [1979] = {.lex_state = 250},
  [1980] = {.lex_state = 250},
  [1981] = {.lex_state = 250},
  [1982] = {.lex_state = 250},
  [1983] = {.lex_state = 250},
  [1984] = {.lex_state = 250},
  [1985] = {.lex_state = 250},
  [1986] = {.lex_state = 250},
  [1987] = {.lex_state = 250},
  [1988] = {.lex_state = 186},
  [1989] = {.lex_state = 186},
  [1990] = {.lex_state = 186},
  [1991] = {.lex_state = 186},
  [1992] = {.lex_state = 186},
  [1993] = {.lex_state = 186},
  [1994] = {.lex_state = 186},
  [1995] = {.lex_state = 250},
  [1996] = {.lex_state = 186},
  [1997] = {.lex_state = 186},
  [1998] = {.lex_state = 250},
  [1999] = {.lex_state = 250},
  [2000] = {.lex_state = 186},
  [2001] = {.lex_state = 186},
  [2002] = {.lex_state = 186},
  [2003] = {.lex_state = 186},
  [2004] = {.lex_state = 250},
  [2005] = {.lex_state = 186},
  [2006] = {.lex_state = 250},
  [2007] = {.lex_state = 186},
  [2008] = {.lex_state = 186},
  [2009] = {.lex_state = 186},
  [2010] = {.lex_state = 205},
  [2011] = {.lex_state = 205},
  [2012] = {.lex_state = 186},
  [2013] = {.lex_state = 186},
  [2014] = {.lex_state = 186},
  [2015] = {.lex_state = 186},
  [2016] = {.lex_state = 186},
  [2017] = {.lex_state = 186},
  [2018] = {.lex_state = 186},
  [2019] = {.lex_state = 186},
  [2020] = {.lex_state = 186},
  [2021] = {.lex_state = 186},
  [2022] = {.lex_state = 186},
  [2023] = {.lex_state = 186},
  [2024] = {.lex_state = 186},
  [2025] = {.lex_state = 186},
  [2026] = {.lex_state = 186},
  [2027] = {.lex_state = 186},
  [2028] = {.lex_state = 186},
  [2029] = {.lex_state = 186},
  [2030] = {.lex_state = 186},
  [2031] = {.lex_state = 186},
  [2032] = {.lex_state = 186},
  [2033] = {.lex_state = 186},
  [2034] = {.lex_state = 186},
  [2035] = {.lex_state = 250},
  [2036] = {.lex_state = 186},
  [2037] = {.lex_state = 250},
  [2038] = {.lex_state = 249},
  [2039] = {.lex_state = 186},
  [2040] = {.lex_state = 186},
  [2041] = {.lex_state = 186},
  [2042] = {.lex_state = 186},
  [2043] = {.lex_state = 205},
  [2044] = {.lex_state = 186},
  [2045] = {.lex_state = 186},
  [2046] = {.lex_state = 205},
  [2047] = {.lex_state = 186},
  [2048] = {.lex_state = 205},
  [2049] = {.lex_state = 205},
  [2050] = {.lex_state = 186},
  [2051] = {.lex_state = 186},
  [2052] = {.lex_state = 186},
  [2053] = {.lex_state = 250},
  [2054] = {.lex_state = 186},
  [2055] = {.lex_state = 205},
  [2056] = {.lex_state = 186},
  [2057] = {.lex_state = 205},
  [2058] = {.lex_state = 250},
  [2059] = {.lex_state = 250},
  [2060] = {.lex_state = 250},
  [2061] = {.lex_state = 205},
  [2062] = {.lex_state = 250},
  [2063] = {.lex_state = 186},
  [2064] = {.lex_state = 250},
  [2065] = {.lex_state = 250},
  [2066] = {.lex_state = 186},
  [2067] = {.lex_state = 186},
  [2068] = {.lex_state = 186},
  [2069] = {.lex_state = 186},
  [2070] = {.lex_state = 250},
  [2071] = {.lex_state = 186},
  [2072] = {.lex_state = 250},
  [2073] = {.lex_state = 250},
  [2074] = {.lex_state = 250},
  [2075] = {.lex_state = 186},
  [2076] = {.lex_state = 186},
  [2077] = {.lex_state = 186},
  [2078] = {.lex_state = 205},
  [2079] = {.lex_state = 186},
  [2080] = {.lex_state = 186},
  [2081] = {.lex_state = 250},
  [2082] = {.lex_state = 205},
  [2083] = {.lex_state = 205},
  [2084] = {.lex_state = 205},
  [2085] = {.lex_state = 250},
  [2086] = {.lex_state = 186},
  [2087] = {.lex_state = 186},
  [2088] = {.lex_state = 186},
  [2089] = {.lex_state = 186},
  [2090] = {.lex_state = 186},
  [2091] = {.lex_state = 186},
  [2092] = {.lex_state = 186},
  [2093] = {.lex_state = 186},
  [2094] = {.lex_state = 186},
  [2095] = {.lex_state = 186},
  [2096] = {.lex_state = 186},
  [2097] = {.lex_state = 250},
  [2098] = {.lex_state = 186},
  [2099] = {.lex_state = 186},
  [2100] = {.lex_state = 186},
  [2101] = {.lex_state = 186},
  [2102] = {.lex_state = 186},
  [2103] = {.lex_state = 186},
  [2104] = {.lex_state = 186},
  [2105] = {.lex_state = 186},
  [2106] = {.lex_state = 186},
  [2107] = {.lex_state = 250},
  [2108] = {.lex_state = 186},
  [2109] = {.lex_state = 205},
  [2110] = {.lex_state = 205},
  [2111] = {.lex_state = 186},
  [2112] = {.lex_state = 186},
  [2113] = {.lex_state = 186},
  [2114] = {.lex_state = 205},
  [2115] = {.lex_state = 205},
  [2116] = {.lex_state = 250},
  [2117] = {.lex_state = 186},
  [2118] = {.lex_state = 186},
  [2119] = {.lex_state = 250},
  [2120] = {.lex_state = 250},
  [2121] = {.lex_state = 205},
  [2122] = {.lex_state = 186},
  [2123] = {.lex_state = 205},
  [2124] = {.lex_state = 186},
  [2125] = {.lex_state = 186},
  [2126] = {.lex_state = 186},
  [2127] = {.lex_state = 205},
  [2128] = {.lex_state = 205},
  [2129] = {.lex_state = 186},
  [2130] = {.lex_state = 186},
  [2131] = {.lex_state = 186},
  [2132] = {.lex_state = 186},
  [2133] = {.lex_state = 186},
  [2134] = {.lex_state = 186},
  [2135] = {.lex_state = 186},
  [2136] = {.lex_state = 250},
  [2137] = {.lex_state = 250},
  [2138] = {.lex_state = 250},
  [2139] = {.lex_state = 250},
  [2140] = {.lex_state = 250},
  [2141] = {.lex_state = 250},
  [2142] = {.lex_state = 250},
  [2143] = {.lex_state = 250},
  [2144] = {.lex_state = 250},
  [2145] = {.lex_state = 205},
  [2146] = {.lex_state = 250},
  [2147] = {.lex_state = 250},
  [2148] = {.lex_state = 250},
  [2149] = {.lex_state = 250},
  [2150] = {.lex_state = 250},
  [2151] = {.lex_state = 186},
  [2152] = {.lex_state = 250},
  [2153] = {.lex_state = 205},
  [2154] = {.lex_state = 186},
  [2155] = {.lex_state = 186},
  [2156] = {.lex_state = 186},
  [2157] = {.lex_state = 250},
  [2158] = {.lex_state = 250},
  [2159] = {.lex_state = 205},
  [2160] = {.lex_state = 250},
  [2161] = {.lex_state = 205},
  [2162] = {.lex_state = 205},
  [2163] = {.lex_state = 250},
  [2164] = {.lex_state = 186},
  [2165] = {.lex_state = 250},
  [2166] = {.lex_state = 205},
  [2167] = {.lex_state = 186},
  [2168] = {.lex_state = 186},
  [2169] = {.lex_state = 250},
  [2170] = {.lex_state = 250},
  [2171] = {.lex_state = 186},
  [2172] = {.lex_state = 186},
  [2173] = {.lex_state = 250},
  [2174] = {.lex_state = 186},
  [2175] = {.lex_state = 250},
  [2176] = {.lex_state = 250},
  [2177] = {.lex_state = 205},
  [2178] = {.lex_state = 250},
  [2179] = {.lex_state = 186},
  [2180] = {.lex_state = 250},
  [2181] = {.lex_state = 250},
  [2182] = {.lex_state = 186},
  [2183] = {.lex_state = 250},
  [2184] = {.lex_state = 186},
  [2185] = {.lex_state = 186},
  [2186] = {.lex_state = 186},
  [2187] = {.lex_state = 205},
  [2188] = {.lex_state = 250},
  [2189] = {.lex_state = 205},
  [2190] = {.lex_state = 186},
  [2191] = {.lex_state = 249},
  [2192] = {.lex_state = 205},
  [2193] = {.lex_state = 205},
  [2194] = {.lex_state = 250},
  [2195] = {.lex_state = 250},
  [2196] = {.lex_state = 205},
  [2197] = {.lex_state = 205},
  [2198] = {.lex_state = 250},
  [2199] = {.lex_state = 250},
  [2200] = {.lex_state = 205},
  [2201] = {.lex_state = 205},
  [2202] = {.lex_state = 186},
  [2203] = {.lex_state = 186},
  [2204] = {.lex_state = 186},
  [2205] = {.lex_state = 186},
  [2206] = {.lex_state = 186},
  [2207] = {.lex_state = 186},
  [2208] = {.lex_state = 205},
  [2209] = {.lex_state = 186},
  [2210] = {.lex_state = 186},
  [2211] = {.lex_state = 186},
  [2212] = {.lex_state = 250},
  [2213] = {.lex_state = 186},
  [2214] = {.lex_state = 250},
  [2215] = {.lex_state = 205},
  [2216] = {.lex_state = 186},
  [2217] = {.lex_state = 186},
  [2218] = {.lex_state = 250},
  [2219] = {.lex_state = 250},
  [2220] = {.lex_state = 186},
  [2221] = {.lex_state = 186},
  [2222] = {.lex_state = 186},
  [2223] = {.lex_state = 250},
  [2224] = {.lex_state = 186},
  [2225] = {.lex_state = 186},
  [2226] = {.lex_state = 186},
  [2227] = {.lex_state = 186},
  [2228] = {.lex_state = 186},
  [2229] = {.lex_state = 186},
  [2230] = {.lex_state = 186},
  [2231] = {.lex_state = 186},
  [2232] = {.lex_state = 186},
  [2233] = {.lex_state = 186},
  [2234] = {.lex_state = 186},
  [2235] = {.lex_state = 250},
  [2236] = {.lex_state = 186},
  [2237] = {.lex_state = 186},
  [2238] = {.lex_state = 205},
  [2239] = {.lex_state = 205},
  [2240] = {.lex_state = 250},
  [2241] = {.lex_state = 205},
  [2242] = {.lex_state = 186},
  [2243] = {.lex_state = 186},
  [2244] = {.lex_state = 186},
  [2245] = {.lex_state = 250},
  [2246] = {.lex_state = 205},
  [2247] = {.lex_state = 186},
  [2248] = {.lex_state = 186},
  [2249] = {.lex_state = 186},
  [2250] = {.lex_state = 186},
  [2251] = {.lex_state = 205},
  [2252] = {.lex_state = 250},
  [2253] = {.lex_state = 186},
  [2254] = {.lex_state = 186},
  [2255] = {.lex_state = 186},
  [2256] = {.lex_state = 186},
  [2257] = {.lex_state = 186},
  [2258] = {.lex_state = 186},
  [2259] = {.lex_state = 250},
  [2260] = {.lex_state = 186},
  [2261] = {.lex_state = 186},
  [2262] = {.lex_state = 205},
  [2263] = {.lex_state = 186},
  [2264] = {.lex_state = 186},
  [2265] = {.lex_state = 186},
  [2266] = {.lex_state = 186},
  [2267] = {.lex_state = 186},
  [2268] = {.lex_state = 186},
  [2269] = {.lex_state = 186},
  [2270] = {.lex_state = 186},
  [2271] = {.lex_state = 186},
  [2272] = {.lex_state = 186},
  [2273] = {.lex_state = 186},
  [2274] = {.lex_state = 186},
  [2275] = {.lex_state = 186},
  [2276] = {.lex_state = 186},
  [2277] = {.lex_state = 186},
  [2278] = {.lex_state = 186},
  [2279] = {.lex_state = 186},
  [2280] = {.lex_state = 205},
  [2281] = {.lex_state = 186},
  [2282] = {.lex_state = 205},
  [2283] = {.lex_state = 186},
  [2284] = {.lex_state = 186},
  [2285] = {.lex_state = 205},
  [2286] = {.lex_state = 186},
  [2287] = {.lex_state = 186},
  [2288] = {.lex_state = 205},
  [2289] = {.lex_state = 205},
  [2290] = {.lex_state = 186},
  [2291] = {.lex_state = 186},
  [2292] = {.lex_state = 186},
  [2293] = {.lex_state = 186},
  [2294] = {.lex_state = 186},
  [2295] = {.lex_state = 205},
  [2296] = {.lex_state = 205},
  [2297] = {.lex_state = 205},
  [2298] = {.lex_state = 186},
  [2299] = {.lex_state = 249},
  [2300] = {.lex_state = 186},
  [2301] = {.lex_state = 186},
  [2302] = {.lex_state = 250},
  [2303] = {.lex_state = 250},
  [2304] = {.lex_state = 186},
  [2305] = {.lex_state = 186},
  [2306] = {.lex_state = 205},
  [2307] = {.lex_state = 186},
  [2308] = {.lex_state = 205},
  [2309] = {.lex_state = 186},
  [2310] = {.lex_state = 186},
  [2311] = {.lex_state = 186},
  [2312] = {.lex_state = 186},
  [2313] = {.lex_state = 186},
  [2314] = {.lex_state = 186},
  [2315] = {.lex_state = 186},
  [2316] = {.lex_state = 186},
  [2317] = {.lex_state = 205},
  [2318] = {.lex_state = 186},
  [2319] = {.lex_state = 186},
  [2320] = {.lex_state = 186},
  [2321] = {.lex_state = 186},
  [2322] = {.lex_state = 249},
  [2323] = {.lex_state = 186},
  [2324] = {.lex_state = 186},
  [2325] = {.lex_state = 186},
  [2326] = {.lex_state = 186},
  [2327] = {.lex_state = 186},
  [2328] = {.lex_state = 186},
  [2329] = {.lex_state = 186},
  [2330] = {.lex_state = 186},
  [2331] = {.lex_state = 186},
  [2332] = {.lex_state = 186},
  [2333] = {.lex_state = 186},
  [2334] = {.lex_state = 186},
  [2335] = {.lex_state = 186},
  [2336] = {.lex_state = 186},
  [2337] = {.lex_state = 205},
  [2338] = {.lex_state = 186},
  [2339] = {.lex_state = 186},
  [2340] = {.lex_state = 186},
  [2341] = {.lex_state = 186},
  [2342] = {.lex_state = 186},
  [2343] = {.lex_state = 186},
  [2344] = {.lex_state = 186},
  [2345] = {.lex_state = 186},
  [2346] = {.lex_state = 186},
  [2347] = {.lex_state = 186},
  [2348] = {.lex_state = 186},
  [2349] = {.lex_state = 205},
  [2350] = {.lex_state = 186},
  [2351] = {.lex_state = 250},
  [2352] = {.lex_state = 250},
  [2353] = {.lex_state = 186},
  [2354] = {.lex_state = 186},
  [2355] = {.lex_state = 186},
  [2356] = {.lex_state = 205},
  [2357] = {.lex_state = 250},
  [2358] = {.lex_state = 250},
  [2359] = {.lex_state = 186},
  [2360] = {.lex_state = 186},
  [2361] = {.lex_state = 250},
  [2362] = {.lex_state = 186},
  [2363] = {.lex_state = 186},
  [2364] = {.lex_state = 186},
  [2365] = {.lex_state = 186},
  [2366] = {.lex_state = 186},
  [2367] = {.lex_state = 186},
  [2368] = {.lex_state = 205},
  [2369] = {.lex_state = 186},
  [2370] = {.lex_state = 186},
  [2371] = {.lex_state = 186},
  [2372] = {.lex_state = 186},
  [2373] = {.lex_state = 250},
  [2374] = {.lex_state = 186},
  [2375] = {.lex_state = 205},
  [2376] = {.lex_state = 186},
  [2377] = {.lex_state = 250},
  [2378] = {.lex_state = 186},
  [2379] = {.lex_state = 250},
  [2380] = {.lex_state = 186},
  [2381] = {.lex_state = 186},
  [2382] = {.lex_state = 186},
  [2383] = {.lex_state = 186},
  [2384] = {.lex_state = 186},
  [2385] = {.lex_state = 186},
  [2386] = {.lex_state = 186},
  [2387] = {.lex_state = 205},
  [2388] = {.lex_state = 186},
  [2389] = {.lex_state = 186},
  [2390] = {.lex_state = 186},
  [2391] = {.lex_state = 186},
  [2392] = {.lex_state = 186},
  [2393] = {.lex_state = 186},
  [2394] = {.lex_state = 205},
  [2395] = {.lex_state = 186},
  [2396] = {.lex_state = 186},
  [2397] = {.lex_state = 186},
  [2398] = {.lex_state = 186},
  [2399] = {.lex_state = 186},
  [2400] = {.lex_state = 186},
  [2401] = {.lex_state = 186},
  [2402] = {.lex_state = 186},
  [2403] = {.lex_state = 186},
  [2404] = {.lex_state = 186},
  [2405] = {.lex_state = 186},
  [2406] = {.lex_state = 186},
  [2407] = {.lex_state = 186},
  [2408] = {.lex_state = 205},
  [2409] = {.lex_state = 186},
  [2410] = {.lex_state = 186},
  [2411] = {.lex_state = 186},
  [2412] = {.lex_state = 205},
  [2413] = {.lex_state = 186},
  [2414] = {.lex_state = 186},
  [2415] = {.lex_state = 186},
  [2416] = {.lex_state = 186},
  [2417] = {.lex_state = 205},
  [2418] = {.lex_state = 186},
  [2419] = {.lex_state = 186},
  [2420] = {.lex_state = 186},
  [2421] = {.lex_state = 186},
  [2422] = {.lex_state = 186},
  [2423] = {.lex_state = 186},
  [2424] = {.lex_state = 186},
  [2425] = {.lex_state = 186},
  [2426] = {.lex_state = 205},
  [2427] = {.lex_state = 186},
  [2428] = {.lex_state = 205},
  [2429] = {.lex_state = 186},
  [2430] = {.lex_state = 186},
  [2431] = {.lex_state = 186},
  [2432] = {.lex_state = 186},
  [2433] = {.lex_state = 186},
  [2434] = {.lex_state = 186},
  [2435] = {.lex_state = 249},
  [2436] = {.lex_state = 186},
  [2437] = {.lex_state = 186},
  [2438] = {.lex_state = 186},
  [2439] = {.lex_state = 205},
  [2440] = {.lex_state = 250},
  [2441] = {.lex_state = 250},
  [2442] = {.lex_state = 250},
  [2443] = {.lex_state = 250},
  [2444] = {.lex_state = 186},
  [2445] = {.lex_state = 205},
  [2446] = {.lex_state = 186},
  [2447] = {.lex_state = 186},
  [2448] = {.lex_state = 186},
  [2449] = {.lex_state = 205},
  [2450] = {.lex_state = 186},
  [2451] = {.lex_state = 205},
  [2452] = {.lex_state = 186},
  [2453] = {.lex_state = 186},
  [2454] = {.lex_state = 186},
  [2455] = {.lex_state = 186},
  [2456] = {.lex_state = 186},
  [2457] = {.lex_state = 186},
  [2458] = {.lex_state = 186},
  [2459] = {.lex_state = 205},
  [2460] = {.lex_state = 205},
  [2461] = {.lex_state = 186},
  [2462] = {.lex_state = 186},
  [2463] = {.lex_state = 186},
  [2464] = {.lex_state = 205},
  [2465] = {.lex_state = 186},
  [2466] = {.lex_state = 186},
  [2467] = {.lex_state = 186},
  [2468] = {.lex_state = 186},
  [2469] = {.lex_state = 186},
  [2470] = {.lex_state = 186},
  [2471] = {.lex_state = 186},
  [2472] = {.lex_state = 186},
  [2473] = {.lex_state = 205},
  [2474] = {.lex_state = 205},
  [2475] = {.lex_state = 186},
  [2476] = {.lex_state = 205},
  [2477] = {.lex_state = 205},
  [2478] = {.lex_state = 186},
  [2479] = {.lex_state = 186},
  [2480] = {.lex_state = 205},
  [2481] = {.lex_state = 186},
  [2482] = {.lex_state = 186},
  [2483] = {.lex_state = 186},
  [2484] = {.lex_state = 205},
  [2485] = {.lex_state = 205},
  [2486] = {.lex_state = 205},
  [2487] = {.lex_state = 250},
  [2488] = {.lex_state = 186},
  [2489] = {.lex_state = 205},
  [2490] = {.lex_state = 186},
  [2491] = {.lex_state = 186},
  [2492] = {.lex_state = 186},
  [2493] = {.lex_state = 186},
  [2494] = {.lex_state = 186},
  [2495] = {.lex_state = 186},
  [2496] = {.lex_state = 186},
  [2497] = {.lex_state = 205},
  [2498] = {.lex_state = 250},
  [2499] = {.lex_state = 186},
  [2500] = {.lex_state = 186},
  [2501] = {.lex_state = 186},
  [2502] = {.lex_state = 186},
  [2503] = {.lex_state = 186},
  [2504] = {.lex_state = 205},
  [2505] = {.lex_state = 186},
  [2506] = {.lex_state = 186},
  [2507] = {.lex_state = 186},
  [2508] = {.lex_state = 186},
  [2509] = {.lex_state = 186},
  [2510] = {.lex_state = 205},
  [2511] = {.lex_state = 205},
  [2512] = {.lex_state = 186},
  [2513] = {.lex_state = 186},
  [2514] = {.lex_state = 205},
  [2515] = {.lex_state = 186},
  [2516] = {.lex_state = 205},
  [2517] = {.lex_state = 205},
  [2518] = {.lex_state = 186},
  [2519] = {.lex_state = 205},
  [2520] = {.lex_state = 205},
  [2521] = {.lex_state = 205},
  [2522] = {.lex_state = 186},
  [2523] = {.lex_state = 205},
  [2524] = {.lex_state = 186},
  [2525] = {.lex_state = 205},
  [2526] = {.lex_state = 205},
  [2527] = {.lex_state = 186},
  [2528] = {.lex_state = 186},
  [2529] = {.lex_state = 186},
  [2530] = {.lex_state = 186},
  [2531] = {.lex_state = 186},
  [2532] = {.lex_state = 186},
  [2533] = {.lex_state = 186},
  [2534] = {.lex_state = 186},
  [2535] = {.lex_state = 205},
  [2536] = {.lex_state = 186},
  [2537] = {.lex_state = 186},
  [2538] = {.lex_state = 186},
  [2539] = {.lex_state = 186},
  [2540] = {.lex_state = 205},
  [2541] = {.lex_state = 205},
  [2542] = {.lex_state = 186},
  [2543] = {.lex_state = 250},
  [2544] = {.lex_state = 205},
  [2545] = {.lex_state = 250},
  [2546] = {.lex_state = 250},
  [2547] = {.lex_state = 186},
  [2548] = {.lex_state = 186},
  [2549] = {.lex_state = 186},
  [2550] = {.lex_state = 205},
  [2551] = {.lex_state = 186},
  [2552] = {.lex_state = 186},
  [2553] = {.lex_state = 250},
  [2554] = {.lex_state = 205},
  [2555] = {.lex_state = 186},
  [2556] = {.lex_state = 186},
  [2557] = {.lex_state = 186},
  [2558] = {.lex_state = 205},
  [2559] = {.lex_state = 186},
  [2560] = {.lex_state = 186},
  [2561] = {.lex_state = 205},
  [2562] = {.lex_state = 186},
  [2563] = {.lex_state = 205},
  [2564] = {.lex_state = 250},
  [2565] = {.lex_state = 250},
  [2566] = {.lex_state = 205},
  [2567] = {.lex_state = 205},
  [2568] = {.lex_state = 250},
  [2569] = {.lex_state = 205},
  [2570] = {.lex_state = 205},
  [2571] = {.lex_state = 205},
  [2572] = {.lex_state = 205},
  [2573] = {.lex_state = 186},
  [2574] = {.lex_state = 186},
  [2575] = {.lex_state = 205},
  [2576] = {.lex_state = 205},
  [2577] = {.lex_state = 186},
  [2578] = {.lex_state = 186},
  [2579] = {.lex_state = 186},
  [2580] = {.lex_state = 186},
  [2581] = {.lex_state = 250},
  [2582] = {.lex_state = 249},
  [2583] = {.lex_state = 249},
  [2584] = {.lex_state = 235},
  [2585] = {.lex_state = 235},
  [2586] = {.lex_state = 235},
  [2587] = {.lex_state = 235},
  [2588] = {.lex_state = 235},
  [2589] = {.lex_state = 235},
  [2590] = {.lex_state = 235},
  [2591] = {.lex_state = 235},
  [2592] = {.lex_state = 235},
  [2593] = {.lex_state = 235},
  [2594] = {.lex_state = 235},
  [2595] = {.lex_state = 249},
  [2596] = {.lex_state = 194},
  [2597] = {.lex_state = 249},
  [2598] = {.lex_state = 195},
  [2599] = {.lex_state = 199},
  [2600] = {.lex_state = 249},
  [2601] = {.lex_state = 249},
  [2602] = {.lex_state = 249},
  [2603] = {.lex_state = 249},
  [2604] = {.lex_state = 249},
  [2605] = {.lex_state = 249},
  [2606] = {.lex_state = 249},
  [2607] = {.lex_state = 249},
  [2608] = {.lex_state = 249},
  [2609] = {.lex_state = 249},
  [2610] = {.lex_state = 249},
  [2611] = {.lex_state = 249},
  [2612] = {.lex_state = 248},
  [2613] = {.lex_state = 249},
  [2614] = {.lex_state = 249},
  [2615] = {.lex_state = 249},
  [2616] = {.lex_state = 249},
  [2617] = {.lex_state = 249},
  [2618] = {.lex_state = 249},
  [2619] = {.lex_state = 249},
  [2620] = {.lex_state = 249},
  [2621] = {.lex_state = 249},
  [2622] = {.lex_state = 249},
  [2623] = {.lex_state = 249},
  [2624] = {.lex_state = 249},
  [2625] = {.lex_state = 249},
  [2626] = {.lex_state = 249},
  [2627] = {.lex_state = 189},
  [2628] = {.lex_state = 249},
  [2629] = {.lex_state = 249},
  [2630] = {.lex_state = 249},
  [2631] = {.lex_state = 248},
  [2632] = {.lex_state = 249},
  [2633] = {.lex_state = 248},
  [2634] = {.lex_state = 248},
  [2635] = {.lex_state = 248},
  [2636] = {.lex_state = 248},
  [2637] = {.lex_state = 249},
  [2638] = {.lex_state = 249},
  [2639] = {.lex_state = 248},
  [2640] = {.lex_state = 207},
  [2641] = {.lex_state = 207},
  [2642] = {.lex_state = 207},
  [2643] = {.lex_state = 207},
  [2644] = {.lex_state = 207},
  [2645] = {.lex_state = 207},
  [2646] = {.lex_state = 207},
  [2647] = {.lex_state = 248},
  [2648] = {.lex_state = 248},
  [2649] = {.lex_state = 207},
  [2650] = {.lex_state = 248},
  [2651] = {.lex_state = 248},
  [2652] = {.lex_state = 207},
  [2653] = {.lex_state = 207},
  [2654] = {.lex_state = 207},
  [2655] = {.lex_state = 207},
  [2656] = {.lex_state = 248},
  [2657] = {.lex_state = 207},
  [2658] = {.lex_state = 248},
  [2659] = {.lex_state = 248},
  [2660] = {.lex_state = 207},
  [2661] = {.lex_state = 248},
  [2662] = {.lex_state = 207},
  [2663] = {.lex_state = 249},
  [2664] = {.lex_state = 243},
  [2665] = {.lex_state = 248},
  [2666] = {.lex_state = 248},
  [2667] = {.lex_state = 243},
  [2668] = {.lex_state = 243},
  [2669] = {.lex_state = 243},
  [2670] = {.lex_state = 248},
  [2671] = {.lex_state = 248},
  [2672] = {.lex_state = 248},
  [2673] = {.lex_state = 235},
  [2674] = {.lex_state = 235},
  [2675] = {.lex_state = 248},
  [2676] = {.lex_state = 235},
  [2677] = {.lex_state = 248},
  [2678] = {.lex_state = 248},
  [2679] = {.lex_state = 248},
  [2680] = {.lex_state = 248},
  [2681] = {.lex_state = 235},
  [2682] = {.lex_state = 248},
  [2683] = {.lex_state = 235},
  [2684] = {.lex_state = 235},
  [2685] = {.lex_state = 235},
  [2686] = {.lex_state = 248},
  [2687] = {.lex_state = 235},
  [2688] = {.lex_state = 248},
  [2689] = {.lex_state = 235},
  [2690] = {.lex_state = 235},
  [2691] = {.lex_state = 235},
  [2692] = {.lex_state = 235},
  [2693] = {.lex_state = 235},
  [2694] = {.lex_state = 248},
  [2695] = {.lex_state = 235},
  [2696] = {.lex_state = 235},
  [2697] = {.lex_state = 235},
  [2698] = {.lex_state = 235},
  [2699] = {.lex_state = 248},
  [2700] = {.lex_state = 248},
  [2701] = {.lex_state = 248},
  [2702] = {.lex_state = 248},
  [2703] = {.lex_state = 248},
  [2704] = {.lex_state = 248},
  [2705] = {.lex_state = 248},
  [2706] = {.lex_state = 248},
  [2707] = {.lex_state = 248},
  [2708] = {.lex_state = 248},
  [2709] = {.lex_state = 248},
  [2710] = {.lex_state = 248},
  [2711] = {.lex_state = 248},
  [2712] = {.lex_state = 248},
  [2713] = {.lex_state = 248},
  [2714] = {.lex_state = 248},
  [2715] = {.lex_state = 248},
  [2716] = {.lex_state = 248},
  [2717] = {.lex_state = 248},
  [2718] = {.lex_state = 248},
  [2719] = {.lex_state = 249},
  [2720] = {.lex_state = 248},
  [2721] = {.lex_state = 248},
  [2722] = {.lex_state = 249},
  [2723] = {.lex_state = 248},
  [2724] = {.lex_state = 249},
  [2725] = {.lex_state = 248},
  [2726] = {.lex_state = 248},
  [2727] = {.lex_state = 248},
  [2728] = {.lex_state = 248},
  [2729] = {.lex_state = 248},
  [2730] = {.lex_state = 248},
  [2731] = {.lex_state = 249},
  [2732] = {.lex_state = 249},
  [2733] = {.lex_state = 248},
  [2734] = {.lex_state = 248},
  [2735] = {.lex_state = 248},
  [2736] = {.lex_state = 248},
  [2737] = {.lex_state = 248},
  [2738] = {.lex_state = 215},
  [2739] = {.lex_state = 248},
  [2740] = {.lex_state = 248},
  [2741] = {.lex_state = 248},
  [2742] = {.lex_state = 248},
  [2743] = {.lex_state = 249},
  [2744] = {.lex_state = 249},
  [2745] = {.lex_state = 248},
  [2746] = {.lex_state = 248},
  [2747] = {.lex_state = 249},
  [2748] = {.lex_state = 248},
  [2749] = {.lex_state = 248},
  [2750] = {.lex_state = 249},
  [2751] = {.lex_state = 248},
  [2752] = {.lex_state = 248},
  [2753] = {.lex_state = 248},
  [2754] = {.lex_state = 248},
  [2755] = {.lex_state = 248},
  [2756] = {.lex_state = 248},
  [2757] = {.lex_state = 248},
  [2758] = {.lex_state = 248},
  [2759] = {.lex_state = 249},
  [2760] = {.lex_state = 249},
  [2761] = {.lex_state = 248},
  [2762] = {.lex_state = 248},
  [2763] = {.lex_state = 248},
  [2764] = {.lex_state = 248},
  [2765] = {.lex_state = 248},
  [2766] = {.lex_state = 248},
  [2767] = {.lex_state = 248},
  [2768] = {.lex_state = 248},
  [2769] = {.lex_state = 248},
  [2770] = {.lex_state = 248},
  [2771] = {.lex_state = 248},
  [2772] = {.lex_state = 248},
  [2773] = {.lex_state = 248},
  [2774] = {.lex_state = 235},
  [2775] = {.lex_state = 249},
  [2776] = {.lex_state = 249},
  [2777] = {.lex_state = 249},
  [2778] = {.lex_state = 249},
  [2779] = {.lex_state = 235},
  [2780] = {.lex_state = 249},
  [2781] = {.lex_state = 248},
  [2782] = {.lex_state = 248},
  [2783] = {.lex_state = 249},
  [2784] = {.lex_state = 189},
  [2785] = {.lex_state = 249},
  [2786] = {.lex_state = 249},
  [2787] = {.lex_state = 219},
  [2788] = {.lex_state = 219},
  [2789] = {.lex_state = 219},
  [2790] = {.lex_state = 219},
  [2791] = {.lex_state = 252},
  [2792] = {.lex_state = 191},
  [2793] = {.lex_state = 219},
  [2794] = {.lex_state = 219},
  [2795] = {.lex_state = 219},
  [2796] = {.lex_state = 219},
  [2797] = {.lex_state = 219},
  [2798] = {.lex_state = 248},
  [2799] = {.lex_state = 219},
  [2800] = {.lex_state = 219},
  [2801] = {.lex_state = 191},
  [2802] = {.lex_state = 219},
  [2803] = {.lex_state = 219},
  [2804] = {.lex_state = 191},
  [2805] = {.lex_state = 219},
  [2806] = {.lex_state = 219},
  [2807] = {.lex_state = 248},
  [2808] = {.lex_state = 249},
  [2809] = {.lex_state = 248},
  [2810] = {.lex_state = 226},
  [2811] = {.lex_state = 226},
  [2812] = {.lex_state = 226},
  [2813] = {.lex_state = 226},
  [2814] = {.lex_state = 226},
  [2815] = {.lex_state = 248},
  [2816] = {.lex_state = 236},
  [2817] = {.lex_state = 226},
  [2818] = {.lex_state = 248},
  [2819] = {.lex_state = 226},
  [2820] = {.lex_state = 226},
  [2821] = {.lex_state = 248},
  [2822] = {.lex_state = 248},
  [2823] = {.lex_state = 226},
  [2824] = {.lex_state = 226},
  [2825] = {.lex_state = 226},
  [2826] = {.lex_state = 226},
  [2827] = {.lex_state = 226},
  [2828] = {.lex_state = 226},
  [2829] = {.lex_state = 226},
  [2830] = {.lex_state = 248},
  [2831] = {.lex_state = 248},
  [2832] = {.lex_state = 248},
  [2833] = {.lex_state = 183},
  [2834] = {.lex_state = 248},
  [2835] = {.lex_state = 183},
  [2836] = {.lex_state = 204},
  [2837] = {.lex_state = 248},
  [2838] = {.lex_state = 248},
  [2839] = {.lex_state = 248},
  [2840] = {.lex_state = 248},
  [2841] = {.lex_state = 183},
  [2842] = {.lex_state = 248},
  [2843] = {.lex_state = 248},
  [2844] = {.lex_state = 215},
  [2845] = {.lex_state = 248},
  [2846] = {.lex_state = 248},
  [2847] = {.lex_state = 248},
  [2848] = {.lex_state = 248},
  [2849] = {.lex_state = 204},
  [2850] = {.lex_state = 248},
  [2851] = {.lex_state = 249},
  [2852] = {.lex_state = 183},
  [2853] = {.lex_state = 248},
  [2854] = {.lex_state = 236},
  [2855] = {.lex_state = 236},
  [2856] = {.lex_state = 236},
  [2857] = {.lex_state = 209},
  [2858] = {.lex_state = 249},
  [2859] = {.lex_state = 236},
  [2860] = {.lex_state = 236},
  [2861] = {.lex_state = 236},
  [2862] = {.lex_state = 235},
  [2863] = {.lex_state = 236},
  [2864] = {.lex_state = 236},
  [2865] = {.lex_state = 236},
  [2866] = {.lex_state = 236},
  [2867] = {.lex_state = 191},
  [2868] = {.lex_state = 191},
  [2869] = {.lex_state = 226},
  [2870] = {.lex_state = 219},
  [2871] = {.lex_state = 236},
  [2872] = {.lex_state = 210},
  [2873] = {.lex_state = 236},
  [2874] = {.lex_state = 236},
  [2875] = {.lex_state = 236},
  [2876] = {.lex_state = 236},
  [2877] = {.lex_state = 236},
  [2878] = {.lex_state = 236},
  [2879] = {.lex_state = 236},
  [2880] = {.lex_state = 236},
  [2881] = {.lex_state = 191},
  [2882] = {.lex_state = 248},
  [2883] = {.lex_state = 236},
  [2884] = {.lex_state = 191},
  [2885] = {.lex_state = 236},
  [2886] = {.lex_state = 215},
  [2887] = {.lex_state = 215},
  [2888] = {.lex_state = 215},
  [2889] = {.lex_state = 215},
  [2890] = {.lex_state = 215},
  [2891] = {.lex_state = 215},
  [2892] = {.lex_state = 215},
  [2893] = {.lex_state = 215},
  [2894] = {.lex_state = 215},
  [2895] = {.lex_state = 235},
  [2896] = {.lex_state = 215},
  [2897] = {.lex_state = 215},
  [2898] = {.lex_state = 189},
  [2899] = {.lex_state = 235},
  [2900] = {.lex_state = 235},
  [2901] = {.lex_state = 235},
  [2902] = {.lex_state = 215},
  [2903] = {.lex_state = 215},
  [2904] = {.lex_state = 235},
  [2905] = {.lex_state = 248},
  [2906] = {.lex_state = 215},
  [2907] = {.lex_state = 215},
  [2908] = {.lex_state = 215},
  [2909] = {.lex_state = 215},
  [2910] = {.lex_state = 226},
  [2911] = {.lex_state = 215},
  [2912] = {.lex_state = 215},
  [2913] = {.lex_state = 215},
  [2914] = {.lex_state = 215},
  [2915] = {.lex_state = 215},
  [2916] = {.lex_state = 215},
  [2917] = {.lex_state = 215},
  [2918] = {.lex_state = 215},
  [2919] = {.lex_state = 215},
  [2920] = {.lex_state = 215},
  [2921] = {.lex_state = 219},
  [2922] = {.lex_state = 215},
  [2923] = {.lex_state = 215},
  [2924] = {.lex_state = 215},
  [2925] = {.lex_state = 215},
  [2926] = {.lex_state = 215},
  [2927] = {.lex_state = 215},
  [2928] = {.lex_state = 215},
  [2929] = {.lex_state = 215},
  [2930] = {.lex_state = 215},
  [2931] = {.lex_state = 215},
  [2932] = {.lex_state = 215},
  [2933] = {.lex_state = 215},
  [2934] = {.lex_state = 215},
  [2935] = {.lex_state = 215},
  [2936] = {.lex_state = 215},
  [2937] = {.lex_state = 207},
  [2938] = {.lex_state = 248},
  [2939] = {.lex_state = 216},
  [2940] = {.lex_state = 186},
  [2941] = {.lex_state = 248},
  [2942] = {.lex_state = 207},
  [2943] = {.lex_state = 207},
  [2944] = {.lex_state = 248},
  [2945] = {.lex_state = 235},
  [2946] = {.lex_state = 209},
  [2947] = {.lex_state = 207},
  [2948] = {.lex_state = 216},
  [2949] = {.lex_state = 216},
  [2950] = {.lex_state = 235},
  [2951] = {.lex_state = 209},
  [2952] = {.lex_state = 209},
  [2953] = {.lex_state = 207},
  [2954] = {.lex_state = 207},
  [2955] = {.lex_state = 207},
  [2956] = {.lex_state = 209},
  [2957] = {.lex_state = 207},
  [2958] = {.lex_state = 207},
  [2959] = {.lex_state = 248},
  [2960] = {.lex_state = 191},
  [2961] = {.lex_state = 216},
  [2962] = {.lex_state = 216},
  [2963] = {.lex_state = 191},
  [2964] = {.lex_state = 216},
  [2965] = {.lex_state = 216},
  [2966] = {.lex_state = 252},
  [2967] = {.lex_state = 216},
  [2968] = {.lex_state = 216},
  [2969] = {.lex_state = 194},
  [2970] = {.lex_state = 209},
  [2971] = {.lex_state = 191},
  [2972] = {.lex_state = 198},
  [2973] = {.lex_state = 194},
  [2974] = {.lex_state = 209},
  [2975] = {.lex_state = 207},
  [2976] = {.lex_state = 198},
  [2977] = {.lex_state = 249},
  [2978] = {.lex_state = 189},
  [2979] = {.lex_state = 216},
  [2980] = {.lex_state = 198},
  [2981] = {.lex_state = 189},
  [2982] = {.lex_state = 189},
  [2983] = {.lex_state = 209},
  [2984] = {.lex_state = 249},
  [2985] = {.lex_state = 191},
  [2986] = {.lex_state = 209},
  [2987] = {.lex_state = 249},
  [2988] = {.lex_state = 248},
  [2989] = {.lex_state = 207},
  [2990] = {.lex_state = 207},
  [2991] = {.lex_state = 195},
  [2992] = {.lex_state = 207},
  [2993] = {.lex_state = 195},
  [2994] = {.lex_state = 186},
  [2995] = {.lex_state = 189},
  [2996] = {.lex_state = 189},
  [2997] = {.lex_state = 197},
  [2998] = {.lex_state = 189},
  [2999] = {.lex_state = 210},
  [3000] = {.lex_state = 207},
  [3001] = {.lex_state = 209},
  [3002] = {.lex_state = 249},
  [3003] = {.lex_state = 210},
  [3004] = {.lex_state = 209},
  [3005] = {.lex_state = 189},
  [3006] = {.lex_state = 191},
  [3007] = {.lex_state = 249},
  [3008] = {.lex_state = 189},
  [3009] = {.lex_state = 197},
  [3010] = {.lex_state = 207},
  [3011] = {.lex_state = 210},
  [3012] = {.lex_state = 189},
  [3013] = {.lex_state = 209},
  [3014] = {.lex_state = 209},
  [3015] = {.lex_state = 209},
  [3016] = {.lex_state = 209},
  [3017] = {.lex_state = 249},
  [3018] = {.lex_state = 209},
  [3019] = {.lex_state = 191},
  [3020] = {.lex_state = 186},
  [3021] = {.lex_state = 210},
  [3022] = {.lex_state = 189},
  [3023] = {.lex_state = 189},
  [3024] = {.lex_state = 249},
  [3025] = {.lex_state = 209},
  [3026] = {.lex_state = 209},
  [3027] = {.lex_state = 249},
  [3028] = {.lex_state = 189},
  [3029] = {.lex_state = 249},
  [3030] = {.lex_state = 249},
  [3031] = {.lex_state = 197},
  [3032] = {.lex_state = 209},
  [3033] = {.lex_state = 191},
  [3034] = {.lex_state = 209},
  [3035] = {.lex_state = 209},
  [3036] = {.lex_state = 191},
  [3037] = {.lex_state = 201},
  [3038] = {.lex_state = 209},
  [3039] = {.lex_state = 209},
  [3040] = {.lex_state = 209},
  [3041] = {.lex_state = 191},
  [3042] = {.lex_state = 209},
  [3043] = {.lex_state = 209},
  [3044] = {.lex_state = 207},
  [3045] = {.lex_state = 207},
  [3046] = {.lex_state = 207},
  [3047] = {.lex_state = 199},
  [3048] = {.lex_state = 209},
  [3049] = {.lex_state = 235},
  [3050] = {.lex_state = 207},
  [3051] = {.lex_state = 209},
  [3052] = {.lex_state = 191},
  [3053] = {.lex_state = 201},
  [3054] = {.lex_state = 209},
  [3055] = {.lex_state = 209},
  [3056] = {.lex_state = 207},
  [3057] = {.lex_state = 207},
  [3058] = {.lex_state = 207},
  [3059] = {.lex_state = 209},
  [3060] = {.lex_state = 209},
  [3061] = {.lex_state = 209},
  [3062] = {.lex_state = 201},
  [3063] = {.lex_state = 209},
  [3064] = {.lex_state = 216},
  [3065] = {.lex_state = 209},
  [3066] = {.lex_state = 189},
  [3067] = {.lex_state = 235},
  [3068] = {.lex_state = 209},
  [3069] = {.lex_state = 209},
  [3070] = {.lex_state = 209},
  [3071] = {.lex_state = 209},
  [3072] = {.lex_state = 209},
  [3073] = {.lex_state = 209},
  [3074] = {.lex_state = 209},
  [3075] = {.lex_state = 209},
  [3076] = {.lex_state = 209},
  [3077] = {.lex_state = 189},
  [3078] = {.lex_state = 209},
  [3079] = {.lex_state = 209},
  [3080] = {.lex_state = 199},
  [3081] = {.lex_state = 209},
  [3082] = {.lex_state = 209},
  [3083] = {.lex_state = 251},
  [3084] = {.lex_state = 251},
  [3085] = {.lex_state = 208},
  [3086] = {.lex_state = 191},
  [3087] = {.lex_state = 209},
  [3088] = {.lex_state = 207},
  [3089] = {.lex_state = 208},
  [3090] = {.lex_state = 216},
  [3091] = {.lex_state = 209},
  [3092] = {.lex_state = 208},
  [3093] = {.lex_state = 209},
  [3094] = {.lex_state = 208},
  [3095] = {.lex_state = 209},
  [3096] = {.lex_state = 209},
  [3097] = {.lex_state = 208},
  [3098] = {.lex_state = 209},
  [3099] = {.lex_state = 209},
  [3100] = {.lex_state = 209},
  [3101] = {.lex_state = 209},
  [3102] = {.lex_state = 209},
  [3103] = {.lex_state = 209},
  [3104] = {.lex_state = 209},
  [3105] = {.lex_state = 216},
  [3106] = {.lex_state = 216},
  [3107] = {.lex_state = 208},
  [3108] = {.lex_state = 209},
  [3109] = {.lex_state = 208},
  [3110] = {.lex_state = 209},
  [3111] = {.lex_state = 208},
  [3112] = {.lex_state = 209},
  [3113] = {.lex_state = 208},
  [3114] = {.lex_state = 209},
  [3115] = {.lex_state = 208},
  [3116] = {.lex_state = 208},
  [3117] = {.lex_state = 208},
  [3118] = {.lex_state = 197},
  [3119] = {.lex_state = 208},
  [3120] = {.lex_state = 209},
  [3121] = {.lex_state = 207},
  [3122] = {.lex_state = 207},
  [3123] = {.lex_state = 216},
  [3124] = {.lex_state = 209},
  [3125] = {.lex_state = 209},
  [3126] = {.lex_state = 209},
  [3127] = {.lex_state = 209},
  [3128] = {.lex_state = 216},
  [3129] = {.lex_state = 216},
  [3130] = {.lex_state = 208},
  [3131] = {.lex_state = 208},
  [3132] = {.lex_state = 208},
  [3133] = {.lex_state = 249},
  [3134] = {.lex_state = 216},
  [3135] = {.lex_state = 216},
  [3136] = {.lex_state = 209},
  [3137] = {.lex_state = 216},
  [3138] = {.lex_state = 209},
  [3139] = {.lex_state = 209},
  [3140] = {.lex_state = 208},
  [3141] = {.lex_state = 216},
  [3142] = {.lex_state = 252},
  [3143] = {.lex_state = 197},
  [3144] = {.lex_state = 252},
  [3145] = {.lex_state = 191},
  [3146] = {.lex_state = 209},
  [3147] = {.lex_state = 216},
  [3148] = {.lex_state = 209},
  [3149] = {.lex_state = 216},
  [3150] = {.lex_state = 208},
  [3151] = {.lex_state = 216},
  [3152] = {.lex_state = 191},
  [3153] = {.lex_state = 222},
  [3154] = {.lex_state = 248},
  [3155] = {.lex_state = 238},
  [3156] = {.lex_state = 197},
  [3157] = {.lex_state = 251},
  [3158] = {.lex_state = 191},
  [3159] = {.lex_state = 238},
  [3160] = {.lex_state = 222},
  [3161] = {.lex_state = 238},
  [3162] = {.lex_state = 238},
  [3163] = {.lex_state = 251},
  [3164] = {.lex_state = 191},
  [3165] = {.lex_state = 197},
  [3166] = {.lex_state = 201},
  [3167] = {.lex_state = 207},
  [3168] = {.lex_state = 197},
  [3169] = {.lex_state = 201},
  [3170] = {.lex_state = 238},
  [3171] = {.lex_state = 235},
  [3172] = {.lex_state = 197},
  [3173] = {.lex_state = 209},
  [3174] = {.lex_state = 238},
  [3175] = {.lex_state = 197},
  [3176] = {.lex_state = 238},
  [3177] = {.lex_state = 238},
  [3178] = {.lex_state = 238},
  [3179] = {.lex_state = 207},
  [3180] = {.lex_state = 219},
  [3181] = {.lex_state = 191},
  [3182] = {.lex_state = 197},
  [3183] = {.lex_state = 251},
  [3184] = {.lex_state = 191},
  [3185] = {.lex_state = 251},
  [3186] = {.lex_state = 207},
  [3187] = {.lex_state = 238},
  [3188] = {.lex_state = 197},
  [3189] = {.lex_state = 238},
  [3190] = {.lex_state = 238},
  [3191] = {.lex_state = 238},
  [3192] = {.lex_state = 238},
  [3193] = {.lex_state = 222},
  [3194] = {.lex_state = 207},
  [3195] = {.lex_state = 220},
  [3196] = {.lex_state = 238},
  [3197] = {.lex_state = 209},
  [3198] = {.lex_state = 197},
  [3199] = {.lex_state = 230},
  [3200] = {.lex_state = 209},
  [3201] = {.lex_state = 191},
  [3202] = {.lex_state = 209},
  [3203] = {.lex_state = 230},
  [3204] = {.lex_state = 197},
  [3205] = {.lex_state = 207},
  [3206] = {.lex_state = 201},
  [3207] = {.lex_state = 209},
  [3208] = {.lex_state = 201},
  [3209] = {.lex_state = 209},
  [3210] = {.lex_state = 209},
  [3211] = {.lex_state = 209},
  [3212] = {.lex_state = 207},
  [3213] = {.lex_state = 207},
  [3214] = {.lex_state = 230},
  [3215] = {.lex_state = 207},
  [3216] = {.lex_state = 208},
  [3217] = {.lex_state = 213},
  [3218] = {.lex_state = 209},
  [3219] = {.lex_state = 209},
  [3220] = {.lex_state = 209},
  [3221] = {.lex_state = 201},
  [3222] = {.lex_state = 191},
  [3223] = {.lex_state = 208},
  [3224] = {.lex_state = 207},
  [3225] = {.lex_state = 207},
  [3226] = {.lex_state = 197},
  [3227] = {.lex_state = 191},
  [3228] = {.lex_state = 191},
  [3229] = {.lex_state = 207},
  [3230] = {.lex_state = 208},
  [3231] = {.lex_state = 197},
  [3232] = {.lex_state = 201},
  [3233] = {.lex_state = 226},
  [3234] = {.lex_state = 209},
  [3235] = {.lex_state = 208},
  [3236] = {.lex_state = 219},
  [3237] = {.lex_state = 208},
  [3238] = {.lex_state = 227},
  [3239] = {.lex_state = 219},
  [3240] = {.lex_state = 251},
  [3241] = {.lex_state = 209},
  [3242] = {.lex_state = 197},
  [3243] = {.lex_state = 209},
  [3244] = {.lex_state = 219},
  [3245] = {.lex_state = 209},
  [3246] = {.lex_state = 219},
  [3247] = {.lex_state = 209},
  [3248] = {.lex_state = 219},
  [3249] = {.lex_state = 209},
  [3250] = {.lex_state = 209},
  [3251] = {.lex_state = 209},
  [3252] = {.lex_state = 209},
  [3253] = {.lex_state = 209},
  [3254] = {.lex_state = 209},
  [3255] = {.lex_state = 209},
  [3256] = {.lex_state = 209},
  [3257] = {.lex_state = 209},
  [3258] = {.lex_state = 209},
  [3259] = {.lex_state = 209},
  [3260] = {.lex_state = 219},
  [3261] = {.lex_state = 209},
  [3262] = {.lex_state = 219},
  [3263] = {.lex_state = 209},
  [3264] = {.lex_state = 209},
  [3265] = {.lex_state = 209},
  [3266] = {.lex_state = 201},
  [3267] = {.lex_state = 209},
  [3268] = {.lex_state = 209},
  [3269] = {.lex_state = 201},
  [3270] = {.lex_state = 209},
  [3271] = {.lex_state = 209},
  [3272] = {.lex_state = 209},
  [3273] = {.lex_state = 209},
  [3274] = {.lex_state = 209},
  [3275] = {.lex_state = 209},
  [3276] = {.lex_state = 209},
  [3277] = {.lex_state = 209},
  [3278] = {.lex_state = 209},
  [3279] = {.lex_state = 209},
  [3280] = {.lex_state = 209},
  [3281] = {.lex_state = 209},
  [3282] = {.lex_state = 209},
  [3283] = {.lex_state = 209},
  [3284] = {.lex_state = 209},
  [3285] = {.lex_state = 251},
  [3286] = {.lex_state = 209},
  [3287] = {.lex_state = 209},
  [3288] = {.lex_state = 209},
  [3289] = {.lex_state = 209},
  [3290] = {.lex_state = 219},
  [3291] = {.lex_state = 219},
  [3292] = {.lex_state = 209},
  [3293] = {.lex_state = 209},
  [3294] = {.lex_state = 209},
  [3295] = {.lex_state = 209},
  [3296] = {.lex_state = 201},
  [3297] = {.lex_state = 209},
  [3298] = {.lex_state = 209},
  [3299] = {.lex_state = 209},
  [3300] = {.lex_state = 209},
  [3301] = {.lex_state = 209},
  [3302] = {.lex_state = 197},
  [3303] = {.lex_state = 226},
  [3304] = {.lex_state = 209},
  [3305] = {.lex_state = 209},
  [3306] = {.lex_state = 209},
  [3307] = {.lex_state = 209},
  [3308] = {.lex_state = 209},
  [3309] = {.lex_state = 209},
  [3310] = {.lex_state = 209},
  [3311] = {.lex_state = 252},
  [3312] = {.lex_state = 209},
  [3313] = {.lex_state = 209},
  [3314] = {.lex_state = 209},
  [3315] = {.lex_state = 209},
  [3316] = {.lex_state = 209},
  [3317] = {.lex_state = 209},
  [3318] = {.lex_state = 209},
  [3319] = {.lex_state = 209},
  [3320] = {.lex_state = 209},
  [3321] = {.lex_state = 209},
  [3322] = {.lex_state = 235},
  [3323] = {.lex_state = 201},
  [3324] = {.lex_state = 209},
  [3325] = {.lex_state = 209},
  [3326] = {.lex_state = 209},
  [3327] = {.lex_state = 209},
  [3328] = {.lex_state = 209},
  [3329] = {.lex_state = 209},
  [3330] = {.lex_state = 252},
  [3331] = {.lex_state = 209},
  [3332] = {.lex_state = 209},
  [3333] = {.lex_state = 209},
  [3334] = {.lex_state = 219},
  [3335] = {.lex_state = 209},
  [3336] = {.lex_state = 226},
  [3337] = {.lex_state = 197},
  [3338] = {.lex_state = 193},
  [3339] = {.lex_state = 237},
  [3340] = {.lex_state = 219},
  [3341] = {.lex_state = 220},
  [3342] = {.lex_state = 193},
  [3343] = {.lex_state = 222},
  [3344] = {.lex_state = 226},
  [3345] = {.lex_state = 219},
  [3346] = {.lex_state = 222},
  [3347] = {.lex_state = 219},
  [3348] = {.lex_state = 226},
  [3349] = {.lex_state = 220},
  [3350] = {.lex_state = 237},
  [3351] = {.lex_state = 197},
  [3352] = {.lex_state = 219},
  [3353] = {.lex_state = 226},
  [3354] = {.lex_state = 222},
  [3355] = {.lex_state = 219},
  [3356] = {.lex_state = 235},
  [3357] = {.lex_state = 193},
  [3358] = {.lex_state = 220},
  [3359] = {.lex_state = 226},
  [3360] = {.lex_state = 219},
  [3361] = {.lex_state = 197},
  [3362] = {.lex_state = 197},
  [3363] = {.lex_state = 237},
  [3364] = {.lex_state = 219},
  [3365] = {.lex_state = 219},
  [3366] = {.lex_state = 226},
  [3367] = {.lex_state = 226},
  [3368] = {.lex_state = 226},
  [3369] = {.lex_state = 226},
  [3370] = {.lex_state = 237},
  [3371] = {.lex_state = 235},
  [3372] = {.lex_state = 219},
  [3373] = {.lex_state = 219},
  [3374] = {.lex_state = 197},
  [3375] = {.lex_state = 227},
  [3376] = {.lex_state = 220},
  [3377] = {.lex_state = 197},
  [3378] = {.lex_state = 235},
  [3379] = {.lex_state = 197},
  [3380] = {.lex_state = 207},
  [3381] = {.lex_state = 226},
  [3382] = {.lex_state = 226},
  [3383] = {.lex_state = 220},
  [3384] = {.lex_state = 209},
  [3385] = {.lex_state = 226},
  [3386] = {.lex_state = 207},
  [3387] = {.lex_state = 197},
  [3388] = {.lex_state = 235},
  [3389] = {.lex_state = 219},
  [3390] = {.lex_state = 227},
  [3391] = {.lex_state = 209},
  [3392] = {.lex_state = 226},
  [3393] = {.lex_state = 226},
  [3394] = {.lex_state = 226},
  [3395] = {.lex_state = 219},
  [3396] = {.lex_state = 227},
  [3397] = {.lex_state = 219},
  [3398] = {.lex_state = 219},
  [3399] = {.lex_state = 219},
  [3400] = {.lex_state = 219},
  [3401] = {.lex_state = 219},
  [3402] = {.lex_state = 219},
  [3403] = {.lex_state = 219},
  [3404] = {.lex_state = 219},
  [3405] = {.lex_state = 219},
  [3406] = {.lex_state = 219},
  [3407] = {.lex_state = 219},
  [3408] = {.lex_state = 219},
  [3409] = {.lex_state = 219},
  [3410] = {.lex_state = 219},
  [3411] = {.lex_state = 219},
  [3412] = {.lex_state = 219},
  [3413] = {.lex_state = 219},
  [3414] = {.lex_state = 219},
  [3415] = {.lex_state = 226},
  [3416] = {.lex_state = 207},
  [3417] = {.lex_state = 193},
  [3418] = {.lex_state = 226},
  [3419] = {.lex_state = 207},
  [3420] = {.lex_state = 207},
  [3421] = {.lex_state = 226},
  [3422] = {.lex_state = 219},
  [3423] = {.lex_state = 219},
  [3424] = {.lex_state = 219},
  [3425] = {.lex_state = 226},
  [3426] = {.lex_state = 207},
  [3427] = {.lex_state = 207},
  [3428] = {.lex_state = 207},
  [3429] = {.lex_state = 219},
  [3430] = {.lex_state = 207},
  [3431] = {.lex_state = 193},
  [3432] = {.lex_state = 193},
  [3433] = {.lex_state = 219},
  [3434] = {.lex_state = 219},
  [3435] = {.lex_state = 193},
  [3436] = {.lex_state = 219},
  [3437] = {.lex_state = 238},
  [3438] = {.lex_state = 220},
  [3439] = {.lex_state = 219},
  [3440] = {.lex_state = 219},
  [3441] = {.lex_state = 207},
  [3442] = {.lex_state = 219},
  [3443] = {.lex_state = 219},
  [3444] = {.lex_state = 207},
  [3445] = {.lex_state = 207},
  [3446] = {.lex_state = 207},
  [3447] = {.lex_state = 207},
  [3448] = {.lex_state = 219},
  [3449] = {.lex_state = 207},
  [3450] = {.lex_state = 219},
  [3451] = {.lex_state = 219},
  [3452] = {.lex_state = 207},
  [3453] = {.lex_state = 219},
  [3454] = {.lex_state = 219},
  [3455] = {.lex_state = 226},
  [3456] = {.lex_state = 219},
  [3457] = {.lex_state = 219},
  [3458] = {.lex_state = 219},
  [3459] = {.lex_state = 207},
  [3460] = {.lex_state = 219},
  [3461] = {.lex_state = 219},
  [3462] = {.lex_state = 251},
  [3463] = {.lex_state = 220},
  [3464] = {.lex_state = 207},
  [3465] = {.lex_state = 219},
  [3466] = {.lex_state = 207},
  [3467] = {.lex_state = 219},
  [3468] = {.lex_state = 226},
  [3469] = {.lex_state = 251},
  [3470] = {.lex_state = 219},
  [3471] = {.lex_state = 219},
  [3472] = {.lex_state = 219},
  [3473] = {.lex_state = 219},
  [3474] = {.lex_state = 219},
  [3475] = {.lex_state = 208},
  [3476] = {.lex_state = 219},
  [3477] = {.lex_state = 211},
  [3478] = {.lex_state = 208},
  [3479] = {.lex_state = 219},
  [3480] = {.lex_state = 226},
  [3481] = {.lex_state = 211},
  [3482] = {.lex_state = 186},
  [3483] = {.lex_state = 219},
  [3484] = {.lex_state = 235},
  [3485] = {.lex_state = 226},
  [3486] = {.lex_state = 211},
  [3487] = {.lex_state = 226},
  [3488] = {.lex_state = 219},
  [3489] = {.lex_state = 252},
  [3490] = {.lex_state = 219},
  [3491] = {.lex_state = 226},
  [3492] = {.lex_state = 226},
  [3493] = {.lex_state = 235},
  [3494] = {.lex_state = 219},
  [3495] = {.lex_state = 226},
  [3496] = {.lex_state = 226},
  [3497] = {.lex_state = 226},
  [3498] = {.lex_state = 252},
  [3499] = {.lex_state = 208},
  [3500] = {.lex_state = 208},
  [3501] = {.lex_state = 208},
  [3502] = {.lex_state = 226},
  [3503] = {.lex_state = 208},
  [3504] = {.lex_state = 226},
  [3505] = {.lex_state = 206},
  [3506] = {.lex_state = 226},
  [3507] = {.lex_state = 208},
  [3508] = {.lex_state = 186},
  [3509] = {.lex_state = 226},
  [3510] = {.lex_state = 219},
  [3511] = {.lex_state = 207},
  [3512] = {.lex_state = 219},
  [3513] = {.lex_state = 219},
  [3514] = {.lex_state = 252},
  [3515] = {.lex_state = 219},
  [3516] = {.lex_state = 219},
  [3517] = {.lex_state = 207},
  [3518] = {.lex_state = 207},
  [3519] = {.lex_state = 204},
  [3520] = {.lex_state = 207},
  [3521] = {.lex_state = 219},
  [3522] = {.lex_state = 219},
  [3523] = {.lex_state = 219},
  [3524] = {.lex_state = 219},
  [3525] = {.lex_state = 206},
  [3526] = {.lex_state = 219},
  [3527] = {.lex_state = 219},
  [3528] = {.lex_state = 219},
  [3529] = {.lex_state = 204},
  [3530] = {.lex_state = 219},
  [3531] = {.lex_state = 219},
  [3532] = {.lex_state = 219},
  [3533] = {.lex_state = 219},
  [3534] = {.lex_state = 226},
  [3535] = {.lex_state = 219},
  [3536] = {.lex_state = 219},
  [3537] = {.lex_state = 226},
  [3538] = {.lex_state = 219},
  [3539] = {.lex_state = 219},
  [3540] = {.lex_state = 219},
  [3541] = {.lex_state = 219},
  [3542] = {.lex_state = 251},
  [3543] = {.lex_state = 219},
  [3544] = {.lex_state = 219},
  [3545] = {.lex_state = 226},
  [3546] = {.lex_state = 251},
  [3547] = {.lex_state = 204},
  [3548] = {.lex_state = 204},
  [3549] = {.lex_state = 252},
  [3550] = {.lex_state = 219},
  [3551] = {.lex_state = 219},
  [3552] = {.lex_state = 219},
  [3553] = {.lex_state = 219},
  [3554] = {.lex_state = 211},
  [3555] = {.lex_state = 219},
  [3556] = {.lex_state = 207},
  [3557] = {.lex_state = 219},
  [3558] = {.lex_state = 219},
  [3559] = {.lex_state = 219},
  [3560] = {.lex_state = 219},
  [3561] = {.lex_state = 219},
  [3562] = {.lex_state = 226},
  [3563] = {.lex_state = 226},
  [3564] = {.lex_state = 207},
  [3565] = {.lex_state = 219},
  [3566] = {.lex_state = 207},
  [3567] = {.lex_state = 219},
  [3568] = {.lex_state = 207},
  [3569] = {.lex_state = 207},
  [3570] = {.lex_state = 219},
  [3571] = {.lex_state = 251},
  [3572] = {.lex_state = 226},
  [3573] = {.lex_state = 211},
  [3574] = {.lex_state = 219},
  [3575] = {.lex_state = 207},
  [3576] = {.lex_state = 207},
  [3577] = {.lex_state = 211},
  [3578] = {.lex_state = 219},
  [3579] = {.lex_state = 207},
  [3580] = {.lex_state = 219},
  [3581] = {.lex_state = 207},
  [3582] = {.lex_state = 219},
  [3583] = {.lex_state = 219},
  [3584] = {.lex_state = 204},
  [3585] = {.lex_state = 204},
  [3586] = {.lex_state = 207},
  [3587] = {.lex_state = 251},
  [3588] = {.lex_state = 219},
  [3589] = {.lex_state = 207},
  [3590] = {.lex_state = 226},
  [3591] = {.lex_state = 207},
  [3592] = {.lex_state = 207},
  [3593] = {.lex_state = 226},
  [3594] = {.lex_state = 219},
  [3595] = {.lex_state = 207},
  [3596] = {.lex_state = 219},
  [3597] = {.lex_state = 226},
  [3598] = {.lex_state = 226},
  [3599] = {.lex_state = 226},
  [3600] = {.lex_state = 226},
  [3601] = {.lex_state = 226},
  [3602] = {.lex_state = 226},
  [3603] = {.lex_state = 219},
  [3604] = {.lex_state = 186},
  [3605] = {.lex_state = 226},
  [3606] = {.lex_state = 219},
  [3607] = {.lex_state = 219},
  [3608] = {.lex_state = 226},
  [3609] = {.lex_state = 226},
  [3610] = {.lex_state = 193},
  [3611] = {.lex_state = 193},
  [3612] = {.lex_state = 186},
  [3613] = {.lex_state = 219},
  [3614] = {.lex_state = 219},
  [3615] = {.lex_state = 219},
  [3616] = {.lex_state = 229},
  [3617] = {.lex_state = 219},
  [3618] = {.lex_state = 226},
  [3619] = {.lex_state = 186},
  [3620] = {.lex_state = 219},
  [3621] = {.lex_state = 204},
  [3622] = {.lex_state = 226},
  [3623] = {.lex_state = 219},
  [3624] = {.lex_state = 226},
  [3625] = {.lex_state = 226},
  [3626] = {.lex_state = 229},
  [3627] = {.lex_state = 214},
  [3628] = {.lex_state = 186},
  [3629] = {.lex_state = 226},
  [3630] = {.lex_state = 226},
  [3631] = {.lex_state = 229},
  [3632] = {.lex_state = 226},
  [3633] = {.lex_state = 229},
  [3634] = {.lex_state = 226},
  [3635] = {.lex_state = 219},
  [3636] = {.lex_state = 226},
  [3637] = {.lex_state = 226},
  [3638] = {.lex_state = 186},
  [3639] = {.lex_state = 226},
  [3640] = {.lex_state = 226},
  [3641] = {.lex_state = 186},
  [3642] = {.lex_state = 226},
  [3643] = {.lex_state = 226},
  [3644] = {.lex_state = 226},
  [3645] = {.lex_state = 226},
  [3646] = {.lex_state = 219},
  [3647] = {.lex_state = 226},
  [3648] = {.lex_state = 226},
  [3649] = {.lex_state = 186},
  [3650] = {.lex_state = 186},
  [3651] = {.lex_state = 219},
  [3652] = {.lex_state = 229},
  [3653] = {.lex_state = 219},
  [3654] = {.lex_state = 186},
  [3655] = {.lex_state = 219},
  [3656] = {.lex_state = 186},
  [3657] = {.lex_state = 186},
  [3658] = {.lex_state = 186},
  [3659] = {.lex_state = 186},
  [3660] = {.lex_state = 186},
  [3661] = {.lex_state = 186},
  [3662] = {.lex_state = 186},
  [3663] = {.lex_state = 186},
  [3664] = {.lex_state = 186},
  [3665] = {.lex_state = 186},
  [3666] = {.lex_state = 186},
  [3667] = {.lex_state = 219},
  [3668] = {.lex_state = 226},
  [3669] = {.lex_state = 219},
  [3670] = {.lex_state = 186},
  [3671] = {.lex_state = 186},
  [3672] = {.lex_state = 186},
  [3673] = {.lex_state = 186},
  [3674] = {.lex_state = 186},
  [3675] = {.lex_state = 186},
  [3676] = {.lex_state = 226},
  [3677] = {.lex_state = 186},
  [3678] = {.lex_state = 226},
  [3679] = {.lex_state = 204},
  [3680] = {.lex_state = 186},
  [3681] = {.lex_state = 226},
  [3682] = {.lex_state = 226},
  [3683] = {.lex_state = 226},
  [3684] = {.lex_state = 226},
  [3685] = {.lex_state = 226},
  [3686] = {.lex_state = 226},
  [3687] = {.lex_state = 204},
  [3688] = {.lex_state = 219},
  [3689] = {.lex_state = 206},
  [3690] = {.lex_state = 219},
  [3691] = {.lex_state = 228},
  [3692] = {.lex_state = 249},
  [3693] = {.lex_state = 221},
  [3694] = {.lex_state = 207},
  [3695] = {.lex_state = 219},
  [3696] = {.lex_state = 219},
  [3697] = {.lex_state = 193},
  [3698] = {.lex_state = 219},
  [3699] = {.lex_state = 219},
  [3700] = {.lex_state = 219},
  [3701] = {.lex_state = 251},
  [3702] = {.lex_state = 207},
  [3703] = {.lex_state = 207},
  [3704] = {.lex_state = 219},
  [3705] = {.lex_state = 219},
  [3706] = {.lex_state = 219},
  [3707] = {.lex_state = 219},
  [3708] = {.lex_state = 219},
  [3709] = {.lex_state = 193},
  [3710] = {.lex_state = 219},
  [3711] = {.lex_state = 219},
  [3712] = {.lex_state = 226},
  [3713] = {.lex_state = 219},
  [3714] = {.lex_state = 207},
  [3715] = {.lex_state = 219},
  [3716] = {.lex_state = 219},
  [3717] = {.lex_state = 252},
  [3718] = {.lex_state = 219},
  [3719] = {.lex_state = 219},
  [3720] = {.lex_state = 226},
  [3721] = {.lex_state = 207},
  [3722] = {.lex_state = 207},
  [3723] = {.lex_state = 226},
  [3724] = {.lex_state = 207},
  [3725] = {.lex_state = 207},
  [3726] = {.lex_state = 219},
  [3727] = {.lex_state = 207},
  [3728] = {.lex_state = 207},
  [3729] = {.lex_state = 207},
  [3730] = {.lex_state = 229},
  [3731] = {.lex_state = 204},
  [3732] = {.lex_state = 207},
  [3733] = {.lex_state = 207},
  [3734] = {.lex_state = 219},
  [3735] = {.lex_state = 207},
  [3736] = {.lex_state = 207},
  [3737] = {.lex_state = 219},
  [3738] = {.lex_state = 219},
  [3739] = {.lex_state = 226},
  [3740] = {.lex_state = 216},
  [3741] = {.lex_state = 219},
  [3742] = {.lex_state = 219},
  [3743] = {.lex_state = 219},
  [3744] = {.lex_state = 214},
  [3745] = {.lex_state = 219},
  [3746] = {.lex_state = 219},
  [3747] = {.lex_state = 219},
  [3748] = {.lex_state = 252},
  [3749] = {.lex_state = 219},
  [3750] = {.lex_state = 219},
  [3751] = {.lex_state = 207},
  [3752] = {.lex_state = 219},
  [3753] = {.lex_state = 219},
  [3754] = {.lex_state = 219},
  [3755] = {.lex_state = 219},
  [3756] = {.lex_state = 219},
  [3757] = {.lex_state = 226},
  [3758] = {.lex_state = 207},
  [3759] = {.lex_state = 219},
  [3760] = {.lex_state = 206},
  [3761] = {.lex_state = 251},
  [3762] = {.lex_state = 204},
  [3763] = {.lex_state = 252},
  [3764] = {.lex_state = 252},
  [3765] = {.lex_state = 229},
  [3766] = {.lex_state = 219},
  [3767] = {.lex_state = 251},
  [3768] = {.lex_state = 249},
  [3769] = {.lex_state = 249},
  [3770] = {.lex_state = 249},
  [3771] = {.lex_state = 249},
  [3772] = {.lex_state = 216},
  [3773] = {.lex_state = 249},
  [3774] = {.lex_state = 249},
  [3775] = {.lex_state = 249},
  [3776] = {.lex_state = 219},
  [3777] = {.lex_state = 249},
  [3778] = {.lex_state = 219},
  [3779] = {.lex_state = 249},
  [3780] = {.lex_state = 249},
  [3781] = {.lex_state = 249},
  [3782] = {.lex_state = 249},
  [3783] = {.lex_state = 209},
  [3784] = {.lex_state = 249},
  [3785] = {.lex_state = 219},
  [3786] = {.lex_state = 209},
  [3787] = {.lex_state = 206},
  [3788] = {.lex_state = 249},
  [3789] = {.lex_state = 204},
  [3790] = {.lex_state = 209},
  [3791] = {.lex_state = 216},
  [3792] = {.lex_state = 209},
  [3793] = {.lex_state = 209},
  [3794] = {.lex_state = 204},
  [3795] = {.lex_state = 249},
  [3796] = {.lex_state = 204},
  [3797] = {.lex_state = 209},
  [3798] = {.lex_state = 219},
  [3799] = {.lex_state = 219},
  [3800] = {.lex_state = 209},
  [3801] = {.lex_state = 249},
  [3802] = {.lex_state = 249},
  [3803] = {.lex_state = 219},
  [3804] = {.lex_state = 209},
  [3805] = {.lex_state = 209},
  [3806] = {.lex_state = 209},
  [3807] = {.lex_state = 204},
  [3808] = {.lex_state = 204},
  [3809] = {.lex_state = 251},
  [3810] = {.lex_state = 219},
  [3811] = {.lex_state = 216},
  [3812] = {.lex_state = 215},
  [3813] = {.lex_state = 209},
  [3814] = {.lex_state = 193},
  [3815] = {.lex_state = 251},
  [3816] = {.lex_state = 249},
  [3817] = {.lex_state = 251},
  [3818] = {.lex_state = 209},
  [3819] = {.lex_state = 249},
  [3820] = {.lex_state = 226},
  [3821] = {.lex_state = 219},
  [3822] = {.lex_state = 249},
  [3823] = {.lex_state = 249},
  [3824] = {.lex_state = 249},
  [3825] = {.lex_state = 249},
  [3826] = {.lex_state = 249},
  [3827] = {.lex_state = 251},
  [3828] = {.lex_state = 219},
  [3829] = {.lex_state = 249},
  [3830] = {.lex_state = 219},
  [3831] = {.lex_state = 249},
  [3832] = {.lex_state = 249},
  [3833] = {.lex_state = 219},
  [3834] = {.lex_state = 249},
  [3835] = {.lex_state = 209},
  [3836] = {.lex_state = 209},
  [3837] = {.lex_state = 249},
  [3838] = {.lex_state = 209},
  [3839] = {.lex_state = 251},
  [3840] = {.lex_state = 209},
  [3841] = {.lex_state = 216},
  [3842] = {.lex_state = 209},
  [3843] = {.lex_state = 209},
  [3844] = {.lex_state = 249},
  [3845] = {.lex_state = 249},
  [3846] = {.lex_state = 249},
  [3847] = {.lex_state = 249},
  [3848] = {.lex_state = 249},
  [3849] = {.lex_state = 249},
  [3850] = {.lex_state = 249},
  [3851] = {.lex_state = 249},
  [3852] = {.lex_state = 209},
  [3853] = {.lex_state = 209},
  [3854] = {.lex_state = 209},
  [3855] = {.lex_state = 204},
  [3856] = {.lex_state = 206},
  [3857] = {.lex_state = 216},
  [3858] = {.lex_state = 249},
  [3859] = {.lex_state = 193},
  [3860] = {.lex_state = 219},
  [3861] = {.lex_state = 249},
  [3862] = {.lex_state = 249},
  [3863] = {.lex_state = 214},
  [3864] = {.lex_state = 219},
  [3865] = {.lex_state = 249},
  [3866] = {.lex_state = 249},
  [3867] = {.lex_state = 249},
  [3868] = {.lex_state = 249},
  [3869] = {.lex_state = 204},
  [3870] = {.lex_state = 209},
  [3871] = {.lex_state = 249},
  [3872] = {.lex_state = 251},
  [3873] = {.lex_state = 249},
  [3874] = {.lex_state = 249},
  [3875] = {.lex_state = 249},
  [3876] = {.lex_state = 249},
  [3877] = {.lex_state = 209},
  [3878] = {.lex_state = 249},
  [3879] = {.lex_state = 249},
  [3880] = {.lex_state = 249},
  [3881] = {.lex_state = 219},
  [3882] = {.lex_state = 249},
  [3883] = {.lex_state = 249},
  [3884] = {.lex_state = 249},
  [3885] = {.lex_state = 249},
  [3886] = {.lex_state = 249},
  [3887] = {.lex_state = 249},
  [3888] = {.lex_state = 249},
  [3889] = {.lex_state = 249},
  [3890] = {.lex_state = 249},
  [3891] = {.lex_state = 249},
  [3892] = {.lex_state = 249},
  [3893] = {.lex_state = 249},
  [3894] = {.lex_state = 249},
  [3895] = {.lex_state = 207},
  [3896] = {.lex_state = 249},
  [3897] = {.lex_state = 219},
  [3898] = {.lex_state = 204},
  [3899] = {.lex_state = 249},
  [3900] = {.lex_state = 249},
  [3901] = {.lex_state = 249},
  [3902] = {.lex_state = 249},
  [3903] = {.lex_state = 219},
  [3904] = {.lex_state = 249},
  [3905] = {.lex_state = 219},
  [3906] = {.lex_state = 219},
  [3907] = {.lex_state = 249},
  [3908] = {.lex_state = 219},
  [3909] = {.lex_state = 249},
  [3910] = {.lex_state = 249},
  [3911] = {.lex_state = 249},
  [3912] = {.lex_state = 249},
  [3913] = {.lex_state = 249},
  [3914] = {.lex_state = 249},
  [3915] = {.lex_state = 249},
  [3916] = {.lex_state = 207},
  [3917] = {.lex_state = 251},
  [3918] = {.lex_state = 249},
  [3919] = {.lex_state = 219},
  [3920] = {.lex_state = 249},
  [3921] = {.lex_state = 249},
  [3922] = {.lex_state = 219},
  [3923] = {.lex_state = 219},
  [3924] = {.lex_state = 249},
  [3925] = {.lex_state = 249},
  [3926] = {.lex_state = 249},
  [3927] = {.lex_state = 249},
  [3928] = {.lex_state = 251},
  [3929] = {.lex_state = 216},
  [3930] = {.lex_state = 249},
  [3931] = {.lex_state = 249},
  [3932] = {.lex_state = 219},
  [3933] = {.lex_state = 249},
  [3934] = {.lex_state = 249},
  [3935] = {.lex_state = 249},
  [3936] = {.lex_state = 249},
  [3937] = {.lex_state = 249},
  [3938] = {.lex_state = 249},
  [3939] = {.lex_state = 249},
  [3940] = {.lex_state = 249},
  [3941] = {.lex_state = 249},
  [3942] = {.lex_state = 180},
  [3943] = {.lex_state = 249},
  [3944] = {.lex_state = 249},
  [3945] = {.lex_state = 249},
  [3946] = {.lex_state = 249},
  [3947] = {.lex_state = 249},
  [3948] = {.lex_state = 249},
  [3949] = {.lex_state = 249},
  [3950] = {.lex_state = 219},
  [3951] = {.lex_state = 206},
  [3952] = {.lex_state = 249},
  [3953] = {.lex_state = 249},
  [3954] = {.lex_state = 219},
  [3955] = {.lex_state = 219},
  [3956] = {.lex_state = 204},
  [3957] = {.lex_state = 204},
  [3958] = {.lex_state = 226},
  [3959] = {.lex_state = 204},
  [3960] = {.lex_state = 249},
  [3961] = {.lex_state = 204},
  [3962] = {.lex_state = 226},
  [3963] = {.lex_state = 249},
  [3964] = {.lex_state = 249},
  [3965] = {.lex_state = 249},
  [3966] = {.lex_state = 249},
  [3967] = {.lex_state = 219},
  [3968] = {.lex_state = 204},
  [3969] = {.lex_state = 249},
  [3970] = {.lex_state = 249},
  [3971] = {.lex_state = 249},
  [3972] = {.lex_state = 249},
  [3973] = {.lex_state = 249},
  [3974] = {.lex_state = 249},
  [3975] = {.lex_state = 204},
  [3976] = {.lex_state = 251},
  [3977] = {.lex_state = 219},
  [3978] = {.lex_state = 219},
  [3979] = {.lex_state = 204},
  [3980] = {.lex_state = 204},
  [3981] = {.lex_state = 204},
  [3982] = {.lex_state = 204},
  [3983] = {.lex_state = 204},
  [3984] = {.lex_state = 249},
  [3985] = {.lex_state = 251},
  [3986] = {.lex_state = 249},
  [3987] = {.lex_state = 219},
  [3988] = {.lex_state = 249},
  [3989] = {.lex_state = 216},
  [3990] = {.lex_state = 249},
  [3991] = {.lex_state = 249},
  [3992] = {.lex_state = 249},
  [3993] = {.lex_state = 249},
  [3994] = {.lex_state = 248},
  [3995] = {.lex_state = 249},
  [3996] = {.lex_state = 226},
  [3997] = {.lex_state = 219},
  [3998] = {.lex_state = 204},
  [3999] = {.lex_state = 249},
  [4000] = {.lex_state = 249},
  [4001] = {.lex_state = 219},
  [4002] = {.lex_state = 249},
  [4003] = {.lex_state = 249},
  [4004] = {.lex_state = 216},
  [4005] = {.lex_state = 219},
  [4006] = {.lex_state = 249},
  [4007] = {.lex_state = 249},
  [4008] = {.lex_state = 249},
  [4009] = {.lex_state = 249},
  [4010] = {.lex_state = 249},
  [4011] = {.lex_state = 249},
  [4012] = {.lex_state = 180},
  [4013] = {.lex_state = 249},
  [4014] = {.lex_state = 249},
  [4015] = {.lex_state = 249},
  [4016] = {.lex_state = 204},
  [4017] = {.lex_state = 180},
  [4018] = {.lex_state = 249},
  [4019] = {.lex_state = 249},
  [4020] = {.lex_state = 249},
  [4021] = {.lex_state = 249},
  [4022] = {.lex_state = 216},
  [4023] = {.lex_state = 249},
  [4024] = {.lex_state = 249},
  [4025] = {.lex_state = 249},
  [4026] = {.lex_state = 249},
  [4027] = {.lex_state = 249},
  [4028] = {.lex_state = 249},
  [4029] = {.lex_state = 219},
  [4030] = {.lex_state = 216},
  [4031] = {.lex_state = 204},
  [4032] = {.lex_state = 216},
  [4033] = {.lex_state = 249},
  [4034] = {.lex_state = 209},
  [4035] = {.lex_state = 216},
  [4036] = {.lex_state = 249},
  [4037] = {.lex_state = 249},
  [4038] = {.lex_state = 249},
  [4039] = {.lex_state = 249},
  [4040] = {.lex_state = 249},
  [4041] = {.lex_state = 249},
  [4042] = {.lex_state = 249},
  [4043] = {.lex_state = 249},
  [4044] = {.lex_state = 249},
  [4045] = {.lex_state = 249},
  [4046] = {.lex_state = 249},
  [4047] = {.lex_state = 249},
  [4048] = {.lex_state = 249},
  [4049] = {.lex_state = 226},
  [4050] = {.lex_state = 249},
  [4051] = {.lex_state = 249},
  [4052] = {.lex_state = 249},
  [4053] = {.lex_state = 211},
  [4054] = {.lex_state = 219},
  [4055] = {.lex_state = 249},
  [4056] = {.lex_state = 225},
  [4057] = {.lex_state = 226},
  [4058] = {.lex_state = 249},
  [4059] = {.lex_state = 249},
  [4060] = {.lex_state = 249},
  [4061] = {.lex_state = 249},
  [4062] = {.lex_state = 249},
  [4063] = {.lex_state = 206},
  [4064] = {.lex_state = 249},
  [4065] = {.lex_state = 204},
  [4066] = {.lex_state = 223},
  [4067] = {.lex_state = 206},
  [4068] = {.lex_state = 226},
  [4069] = {.lex_state = 226},
  [4070] = {.lex_state = 249},
  [4071] = {.lex_state = 249},
  [4072] = {.lex_state = 249},
  [4073] = {.lex_state = 249},
  [4074] = {.lex_state = 206},
  [4075] = {.lex_state = 204},
  [4076] = {.lex_state = 249},
  [4077] = {.lex_state = 226},
  [4078] = {.lex_state = 226},
  [4079] = {.lex_state = 249},
  [4080] = {.lex_state = 249},
  [4081] = {.lex_state = 207},
  [4082] = {.lex_state = 249},
  [4083] = {.lex_state = 248},
  [4084] = {.lex_state = 249},
  [4085] = {.lex_state = 251},
  [4086] = {.lex_state = 249},
  [4087] = {.lex_state = 249},
  [4088] = {.lex_state = 249},
  [4089] = {.lex_state = 223},
  [4090] = {.lex_state = 249},
  [4091] = {.lex_state = 251},
  [4092] = {.lex_state = 193},
  [4093] = {.lex_state = 226},
  [4094] = {.lex_state = 249},
  [4095] = {.lex_state = 249},
  [4096] = {.lex_state = 216},
  [4097] = {.lex_state = 249},
  [4098] = {.lex_state = 249},
  [4099] = {.lex_state = 249},
  [4100] = {.lex_state = 216},
  [4101] = {.lex_state = 249},
  [4102] = {.lex_state = 249},
  [4103] = {.lex_state = 223},
  [4104] = {.lex_state = 249},
  [4105] = {.lex_state = 249},
  [4106] = {.lex_state = 249},
  [4107] = {.lex_state = 216},
  [4108] = {.lex_state = 249},
  [4109] = {.lex_state = 249},
  [4110] = {.lex_state = 249},
  [4111] = {.lex_state = 249},
  [4112] = {.lex_state = 219},
  [4113] = {.lex_state = 249},
  [4114] = {.lex_state = 219},
  [4115] = {.lex_state = 249},
  [4116] = {.lex_state = 219},
  [4117] = {.lex_state = 249},
  [4118] = {.lex_state = 204},
  [4119] = {.lex_state = 214},
  [4120] = {.lex_state = 249},
  [4121] = {.lex_state = 226},
  [4122] = {.lex_state = 249},
  [4123] = {.lex_state = 219},
  [4124] = {.lex_state = 219},
  [4125] = {.lex_state = 249},
  [4126] = {.lex_state = 249},
  [4127] = {.lex_state = 249},
  [4128] = {.lex_state = 249},
  [4129] = {.lex_state = 249},
  [4130] = {.lex_state = 249},
  [4131] = {.lex_state = 249},
  [4132] = {.lex_state = 249},
  [4133] = {.lex_state = 249},
  [4134] = {.lex_state = 211},
  [4135] = {.lex_state = 226},
  [4136] = {.lex_state = 249},
  [4137] = {.lex_state = 180},
  [4138] = {.lex_state = 219},
  [4139] = {.lex_state = 249},
  [4140] = {.lex_state = 249},
  [4141] = {.lex_state = 249},
  [4142] = {.lex_state = 249},
  [4143] = {.lex_state = 249},
  [4144] = {.lex_state = 249},
  [4145] = {.lex_state = 249},
  [4146] = {.lex_state = 249},
  [4147] = {.lex_state = 249},
  [4148] = {.lex_state = 214},
  [4149] = {.lex_state = 226},
  [4150] = {.lex_state = 204},
  [4151] = {.lex_state = 249},
  [4152] = {.lex_state = 251},
  [4153] = {.lex_state = 204},
  [4154] = {.lex_state = 249},
  [4155] = {.lex_state = 249},
  [4156] = {.lex_state = 249},
  [4157] = {.lex_state = 219},
  [4158] = {.lex_state = 249},
  [4159] = {.lex_state = 211},
  [4160] = {.lex_state = 219},
  [4161] = {.lex_state = 249},
  [4162] = {.lex_state = 249},
  [4163] = {.lex_state = 249},
  [4164] = {.lex_state = 249},
  [4165] = {.lex_state = 219},
  [4166] = {.lex_state = 216},
  [4167] = {.lex_state = 216},
  [4168] = {.lex_state = 180},
  [4169] = {.lex_state = 249},
  [4170] = {.lex_state = 219},
  [4171] = {.lex_state = 219},
  [4172] = {.lex_state = 249},
  [4173] = {.lex_state = 249},
  [4174] = {.lex_state = 249},
  [4175] = {.lex_state = 249},
  [4176] = {.lex_state = 249},
  [4177] = {.lex_state = 226},
  [4178] = {.lex_state = 226},
  [4179] = {.lex_state = 226},
  [4180] = {.lex_state = 226},
  [4181] = {.lex_state = 226},
  [4182] = {.lex_state = 226},
  [4183] = {.lex_state = 226},
  [4184] = {.lex_state = 226},
  [4185] = {.lex_state = 226},
  [4186] = {.lex_state = 226},
  [4187] = {.lex_state = 249},
  [4188] = {.lex_state = 226},
  [4189] = {.lex_state = 204},
  [4190] = {.lex_state = 249},
  [4191] = {.lex_state = 249},
  [4192] = {.lex_state = 251},
  [4193] = {.lex_state = 219},
  [4194] = {.lex_state = 249},
  [4195] = {.lex_state = 251},
  [4196] = {.lex_state = 226},
  [4197] = {.lex_state = 249},
  [4198] = {.lex_state = 249},
  [4199] = {.lex_state = 249},
  [4200] = {.lex_state = 249},
  [4201] = {.lex_state = 226},
  [4202] = {.lex_state = 180},
  [4203] = {.lex_state = 249},
  [4204] = {.lex_state = 249},
  [4205] = {.lex_state = 249},
  [4206] = {.lex_state = 249},
  [4207] = {.lex_state = 249},
  [4208] = {.lex_state = 249},
  [4209] = {.lex_state = 249},
  [4210] = {.lex_state = 226},
  [4211] = {.lex_state = 251},
  [4212] = {.lex_state = 249},
  [4213] = {.lex_state = 249},
  [4214] = {.lex_state = 219},
  [4215] = {.lex_state = 251},
  [4216] = {.lex_state = 249},
  [4217] = {.lex_state = 249},
  [4218] = {.lex_state = 249},
  [4219] = {.lex_state = 249},
  [4220] = {.lex_state = 249},
  [4221] = {.lex_state = 249},
  [4222] = {.lex_state = 249},
  [4223] = {.lex_state = 249},
  [4224] = {.lex_state = 249},
  [4225] = {.lex_state = 249},
  [4226] = {.lex_state = 206},
  [4227] = {.lex_state = 249},
  [4228] = {.lex_state = 251},
  [4229] = {.lex_state = 249},
  [4230] = {.lex_state = 219},
  [4231] = {.lex_state = 249},
  [4232] = {.lex_state = 249},
  [4233] = {.lex_state = 249},
  [4234] = {.lex_state = 249},
  [4235] = {.lex_state = 251},
  [4236] = {.lex_state = 249},
  [4237] = {.lex_state = 249},
  [4238] = {.lex_state = 229},
  [4239] = {.lex_state = 216},
  [4240] = {.lex_state = 235},
  [4241] = {.lex_state = 249},
  [4242] = {.lex_state = 219},
  [4243] = {.lex_state = 193},
  [4244] = {.lex_state = 219},
  [4245] = {.lex_state = 226},
  [4246] = {.lex_state = 229},
  [4247] = {.lex_state = 229},
  [4248] = {.lex_state = 249},
  [4249] = {.lex_state = 219},
  [4250] = {.lex_state = 219},
  [4251] = {.lex_state = 219},
  [4252] = {.lex_state = 249},
  [4253] = {.lex_state = 219},
  [4254] = {.lex_state = 207},
  [4255] = {.lex_state = 214},
  [4256] = {.lex_state = 229},
  [4257] = {.lex_state = 219},
  [4258] = {.lex_state = 219},
  [4259] = {.lex_state = 219},
  [4260] = {.lex_state = 219},
  [4261] = {.lex_state = 219},
  [4262] = {.lex_state = 233},
  [4263] = {.lex_state = 186},
  [4264] = {.lex_state = 186},
  [4265] = {.lex_state = 249},
  [4266] = {.lex_state = 219},
  [4267] = {.lex_state = 219},
  [4268] = {.lex_state = 219},
  [4269] = {.lex_state = 219},
  [4270] = {.lex_state = 219},
  [4271] = {.lex_state = 203},
  [4272] = {.lex_state = 186},
  [4273] = {.lex_state = 229},
  [4274] = {.lex_state = 249},
  [4275] = {.lex_state = 249},
  [4276] = {.lex_state = 229},
  [4277] = {.lex_state = 229},
  [4278] = {.lex_state = 229},
  [4279] = {.lex_state = 219},
  [4280] = {.lex_state = 186},
  [4281] = {.lex_state = 186},
  [4282] = {.lex_state = 186},
  [4283] = {.lex_state = 219},
  [4284] = {.lex_state = 193},
  [4285] = {.lex_state = 214},
  [4286] = {.lex_state = 231},
  [4287] = {.lex_state = 219},
  [4288] = {.lex_state = 219},
  [4289] = {.lex_state = 219},
  [4290] = {.lex_state = 231},
  [4291] = {.lex_state = 219},
  [4292] = {.lex_state = 219},
  [4293] = {.lex_state = 219},
  [4294] = {.lex_state = 219},
  [4295] = {.lex_state = 219},
  [4296] = {.lex_state = 249},
  [4297] = {.lex_state = 249},
  [4298] = {.lex_state = 226},
  [4299] = {.lex_state = 219},
  [4300] = {.lex_state = 219},
  [4301] = {.lex_state = 219},
  [4302] = {.lex_state = 252},
  [4303] = {.lex_state = 229},
  [4304] = {.lex_state = 219},
  [4305] = {.lex_state = 229},
  [4306] = {.lex_state = 219},
  [4307] = {.lex_state = 219},
  [4308] = {.lex_state = 219},
  [4309] = {.lex_state = 219},
  [4310] = {.lex_state = 219},
  [4311] = {.lex_state = 219},
  [4312] = {.lex_state = 219},
  [4313] = {.lex_state = 219},
  [4314] = {.lex_state = 249},
  [4315] = {.lex_state = 229},
  [4316] = {.lex_state = 219},
  [4317] = {.lex_state = 219},
  [4318] = {.lex_state = 219},
  [4319] = {.lex_state = 219},
  [4320] = {.lex_state = 249},
  [4321] = {.lex_state = 186},
  [4322] = {.lex_state = 235},
  [4323] = {.lex_state = 219},
  [4324] = {.lex_state = 219},
  [4325] = {.lex_state = 219},
  [4326] = {.lex_state = 229},
  [4327] = {.lex_state = 186},
  [4328] = {.lex_state = 219},
  [4329] = {.lex_state = 219},
  [4330] = {.lex_state = 219},
  [4331] = {.lex_state = 249},
  [4332] = {.lex_state = 219},
  [4333] = {.lex_state = 219},
  [4334] = {.lex_state = 249},
  [4335] = {.lex_state = 219},
  [4336] = {.lex_state = 219},
  [4337] = {.lex_state = 219},
  [4338] = {.lex_state = 219},
  [4339] = {.lex_state = 219},
  [4340] = {.lex_state = 226},
  [4341] = {.lex_state = 249},
  [4342] = {.lex_state = 249},
  [4343] = {.lex_state = 249},
  [4344] = {.lex_state = 249},
  [4345] = {.lex_state = 249},
  [4346] = {.lex_state = 219},
  [4347] = {.lex_state = 219},
  [4348] = {.lex_state = 219},
  [4349] = {.lex_state = 219},
  [4350] = {.lex_state = 249},
  [4351] = {.lex_state = 249},
  [4352] = {.lex_state = 219},
  [4353] = {.lex_state = 219},
  [4354] = {.lex_state = 226},
  [4355] = {.lex_state = 219},
  [4356] = {.lex_state = 252},
  [4357] = {.lex_state = 219},
  [4358] = {.lex_state = 203},
  [4359] = {.lex_state = 229},
  [4360] = {.lex_state = 249},
  [4361] = {.lex_state = 186},
  [4362] = {.lex_state = 186},
  [4363] = {.lex_state = 219},
  [4364] = {.lex_state = 219},
  [4365] = {.lex_state = 219},
  [4366] = {.lex_state = 216},
  [4367] = {.lex_state = 229},
  [4368] = {.lex_state = 219},
  [4369] = {.lex_state = 219},
  [4370] = {.lex_state = 216},
  [4371] = {.lex_state = 216},
  [4372] = {.lex_state = 216},
  [4373] = {.lex_state = 219},
  [4374] = {.lex_state = 249},
  [4375] = {.lex_state = 219},
  [4376] = {.lex_state = 193},
  [4377] = {.lex_state = 219},
  [4378] = {.lex_state = 219},
  [4379] = {.lex_state = 219},
  [4380] = {.lex_state = 219},
  [4381] = {.lex_state = 231},
  [4382] = {.lex_state = 219},
  [4383] = {.lex_state = 219},
  [4384] = {.lex_state = 216},
  [4385] = {.lex_state = 216},
  [4386] = {.lex_state = 219},
  [4387] = {.lex_state = 219},
  [4388] = {.lex_state = 219},
  [4389] = {.lex_state = 219},
  [4390] = {.lex_state = 219},
  [4391] = {.lex_state = 216},
  [4392] = {.lex_state = 249},
  [4393] = {.lex_state = 249},
  [4394] = {.lex_state = 219},
  [4395] = {.lex_state = 219},
  [4396] = {.lex_state = 219},
  [4397] = {.lex_state = 229},
  [4398] = {.lex_state = 203},
  [4399] = {.lex_state = 249},
  [4400] = {.lex_state = 249},
  [4401] = {.lex_state = 206},
  [4402] = {.lex_state = 219},
  [4403] = {.lex_state = 219},
  [4404] = {.lex_state = 219},
  [4405] = {.lex_state = 193},
  [4406] = {.lex_state = 229},
  [4407] = {.lex_state = 219},
  [4408] = {.lex_state = 214},
  [4409] = {.lex_state = 209},
  [4410] = {.lex_state = 226},
  [4411] = {.lex_state = 186},
  [4412] = {.lex_state = 226},
  [4413] = {.lex_state = 193},
  [4414] = {.lex_state = 226},
  [4415] = {.lex_state = 226},
  [4416] = {.lex_state = 226},
  [4417] = {.lex_state = 193},
  [4418] = {.lex_state = 219},
  [4419] = {.lex_state = 226},
  [4420] = {.lex_state = 226},
  [4421] = {.lex_state = 219},
  [4422] = {.lex_state = 226},
  [4423] = {.lex_state = 226},
  [4424] = {.lex_state = 219},
  [4425] = {.lex_state = 209},
  [4426] = {.lex_state = 226},
  [4427] = {.lex_state = 226},
  [4428] = {.lex_state = 226},
  [4429] = {.lex_state = 226},
  [4430] = {.lex_state = 226},
  [4431] = {.lex_state = 226},
  [4432] = {.lex_state = 219},
  [4433] = {.lex_state = 226},
  [4434] = {.lex_state = 219},
  [4435] = {.lex_state = 226},
  [4436] = {.lex_state = 226},
  [4437] = {.lex_state = 219},
  [4438] = {.lex_state = 226},
  [4439] = {.lex_state = 226},
  [4440] = {.lex_state = 226},
  [4441] = {.lex_state = 226},
  [4442] = {.lex_state = 226},
  [4443] = {.lex_state = 226},
  [4444] = {.lex_state = 219},
  [4445] = {.lex_state = 226},
  [4446] = {.lex_state = 226},
  [4447] = {.lex_state = 226},
  [4448] = {.lex_state = 226},
  [4449] = {.lex_state = 226},
  [4450] = {.lex_state = 219},
  [4451] = {.lex_state = 219},
  [4452] = {.lex_state = 226},
  [4453] = {.lex_state = 226},
  [4454] = {.lex_state = 252},
  [4455] = {.lex_state = 226},
  [4456] = {.lex_state = 214},
  [4457] = {.lex_state = 206},
  [4458] = {.lex_state = 226},
  [4459] = {.lex_state = 226},
  [4460] = {.lex_state = 226},
  [4461] = {.lex_state = 226},
  [4462] = {.lex_state = 226},
  [4463] = {.lex_state = 226},
  [4464] = {.lex_state = 226},
  [4465] = {.lex_state = 226},
  [4466] = {.lex_state = 226},
  [4467] = {.lex_state = 216},
  [4468] = {.lex_state = 216},
  [4469] = {.lex_state = 214},
  [4470] = {.lex_state = 226},
  [4471] = {.lex_state = 207},
  [4472] = {.lex_state = 214},
  [4473] = {.lex_state = 207},
  [4474] = {.lex_state = 214},
  [4475] = {.lex_state = 214},
  [4476] = {.lex_state = 214},
  [4477] = {.lex_state = 214},
  [4478] = {.lex_state = 252},
  [4479] = {.lex_state = 226},
  [4480] = {.lex_state = 219},
  [4481] = {.lex_state = 226},
  [4482] = {.lex_state = 226},
  [4483] = {.lex_state = 226},
  [4484] = {.lex_state = 226},
  [4485] = {.lex_state = 252},
  [4486] = {.lex_state = 226},
  [4487] = {.lex_state = 226},
  [4488] = {.lex_state = 226},
  [4489] = {.lex_state = 219},
  [4490] = {.lex_state = 226},
  [4491] = {.lex_state = 226},
  [4492] = {.lex_state = 226},
  [4493] = {.lex_state = 226},
  [4494] = {.lex_state = 226},
  [4495] = {.lex_state = 226},
  [4496] = {.lex_state = 214},
  [4497] = {.lex_state = 209},
  [4498] = {.lex_state = 209},
  [4499] = {.lex_state = 219},
  [4500] = {.lex_state = 214},
  [4501] = {.lex_state = 209},
  [4502] = {.lex_state = 209},
  [4503] = {.lex_state = 209},
  [4504] = {.lex_state = 226},
  [4505] = {.lex_state = 226},
  [4506] = {.lex_state = 209},
  [4507] = {.lex_state = 214},
  [4508] = {.lex_state = 226},
  [4509] = {.lex_state = 226},
  [4510] = {.lex_state = 226},
  [4511] = {.lex_state = 209},
  [4512] = {.lex_state = 209},
  [4513] = {.lex_state = 226},
  [4514] = {.lex_state = 226},
  [4515] = {.lex_state = 209},
  [4516] = {.lex_state = 209},
  [4517] = {.lex_state = 209},
  [4518] = {.lex_state = 226},
  [4519] = {.lex_state = 226},
  [4520] = {.lex_state = 226},
  [4521] = {.lex_state = 226},
  [4522] = {.lex_state = 226},
  [4523] = {.lex_state = 226},
  [4524] = {.lex_state = 226},
  [4525] = {.lex_state = 226},
  [4526] = {.lex_state = 209},
  [4527] = {.lex_state = 226},
  [4528] = {.lex_state = 226},
  [4529] = {.lex_state = 226},
  [4530] = {.lex_state = 209},
  [4531] = {.lex_state = 226},
  [4532] = {.lex_state = 219},
  [4533] = {.lex_state = 219},
  [4534] = {.lex_state = 219},
  [4535] = {.lex_state = 219},
  [4536] = {.lex_state = 219},
  [4537] = {.lex_state = 226},
  [4538] = {.lex_state = 226},
  [4539] = {.lex_state = 209},
  [4540] = {.lex_state = 226},
  [4541] = {.lex_state = 252},
  [4542] = {.lex_state = 216},
  [4543] = {.lex_state = 214},
  [4544] = {.lex_state = 214},
  [4545] = {.lex_state = 226},
  [4546] = {.lex_state = 214},
  [4547] = {.lex_state = 226},
  [4548] = {.lex_state = 214},
  [4549] = {.lex_state = 214},
  [4550] = {.lex_state = 219},
  [4551] = {.lex_state = 219},
  [4552] = {.lex_state = 214},
  [4553] = {.lex_state = 219},
  [4554] = {.lex_state = 219},
  [4555] = {.lex_state = 214},
  [4556] = {.lex_state = 226},
  [4557] = {.lex_state = 226},
  [4558] = {.lex_state = 219},
  [4559] = {.lex_state = 219},
  [4560] = {.lex_state = 219},
  [4561] = {.lex_state = 219},
  [4562] = {.lex_state = 214},
  [4563] = {.lex_state = 226},
  [4564] = {.lex_state = 214},
  [4565] = {.lex_state = 226},
  [4566] = {.lex_state = 219},
  [4567] = {.lex_state = 193},
  [4568] = {.lex_state = 193},
  [4569] = {.lex_state = 235},
  [4570] = {.lex_state = 216},
  [4571] = {.lex_state = 235},
  [4572] = {.lex_state = 193},
  [4573] = {.lex_state = 223},
  [4574] = {.lex_state = 248},
  [4575] = {.lex_state = 223},
  [4576] = {.lex_state = 248},
  [4577] = {.lex_state = 235},
  [4578] = {.lex_state = 193},
  [4579] = {.lex_state = 214},
  [4580] = {.lex_state = 252},
  [4581] = {.lex_state = 223},
  [4582] = {.lex_state = 214},
  [4583] = {.lex_state = 252},
  [4584] = {.lex_state = 216},
  [4585] = {.lex_state = 214},
  [4586] = {.lex_state = 207},
  [4587] = {.lex_state = 254},
  [4588] = {.lex_state = 235},
  [4589] = {.lex_state = 203},
  [4590] = {.lex_state = 254},
  [4591] = {.lex_state = 203},
  [4592] = {.lex_state = 216},
  [4593] = {.lex_state = 216},
  [4594] = {.lex_state = 219},
  [4595] = {.lex_state = 203},
  [4596] = {.lex_state = 219},
  [4597] = {.lex_state = 219},
  [4598] = {.lex_state = 216},
  [4599] = {.lex_state = 216},
  [4600] = {.lex_state = 203},
  [4601] = {.lex_state = 219},
  [4602] = {.lex_state = 219},
  [4603] = {.lex_state = 219},
  [4604] = {.lex_state = 219},
  [4605] = {.lex_state = 219},
  [4606] = {.lex_state = 219},
  [4607] = {.lex_state = 219},
  [4608] = {.lex_state = 219},
  [4609] = {.lex_state = 219},
  [4610] = {.lex_state = 193},
  [4611] = {.lex_state = 219},
  [4612] = {.lex_state = 219},
  [4613] = {.lex_state = 219},
  [4614] = {.lex_state = 219},
  [4615] = {.lex_state = 216},
  [4616] = {.lex_state = 216},
  [4617] = {.lex_state = 240},
  [4618] = {.lex_state = 219},
  [4619] = {.lex_state = 219},
  [4620] = {.lex_state = 219},
  [4621] = {.lex_state = 219},
  [4622] = {.lex_state = 216},
  [4623] = {.lex_state = 253},
  [4624] = {.lex_state = 216},
  [4625] = {.lex_state = 219},
  [4626] = {.lex_state = 219},
  [4627] = {.lex_state = 219},
  [4628] = {.lex_state = 219},
  [4629] = {.lex_state = 219},
  [4630] = {.lex_state = 219},
  [4631] = {.lex_state = 219},
  [4632] = {.lex_state = 216},
  [4633] = {.lex_state = 219},
  [4634] = {.lex_state = 219},
  [4635] = {.lex_state = 219},
  [4636] = {.lex_state = 219},
  [4637] = {.lex_state = 219},
  [4638] = {.lex_state = 219},
  [4639] = {.lex_state = 216},
  [4640] = {.lex_state = 219},
  [4641] = {.lex_state = 219},
  [4642] = {.lex_state = 219},
  [4643] = {.lex_state = 216},
  [4644] = {.lex_state = 239},
  [4645] = {.lex_state = 203},
  [4646] = {.lex_state = 219},
  [4647] = {.lex_state = 219},
  [4648] = {.lex_state = 240},
  [4649] = {.lex_state = 219},
  [4650] = {.lex_state = 219},
  [4651] = {.lex_state = 240},
  [4652] = {.lex_state = 219},
  [4653] = {.lex_state = 193},
  [4654] = {.lex_state = 216},
  [4655] = {.lex_state = 203},
  [4656] = {.lex_state = 193},
  [4657] = {.lex_state = 193},
  [4658] = {.lex_state = 219},
  [4659] = {.lex_state = 219},
  [4660] = {.lex_state = 219},
  [4661] = {.lex_state = 219},
  [4662] = {.lex_state = 219},
  [4663] = {.lex_state = 219},
  [4664] = {.lex_state = 216},
  [4665] = {.lex_state = 219},
  [4666] = {.lex_state = 216},
  [4667] = {.lex_state = 219},
  [4668] = {.lex_state = 216},
  [4669] = {.lex_state = 219},
  [4670] = {.lex_state = 193},
  [4671] = {.lex_state = 219},
  [4672] = {.lex_state = 219},
  [4673] = {.lex_state = 238},
  [4674] = {.lex_state = 219},
  [4675] = {.lex_state = 252},
  [4676] = {.lex_state = 216},
  [4677] = {.lex_state = 216},
  [4678] = {.lex_state = 252},
  [4679] = {.lex_state = 216},
  [4680] = {.lex_state = 219},
  [4681] = {.lex_state = 219},
  [4682] = {.lex_state = 219},
  [4683] = {.lex_state = 216},
  [4684] = {.lex_state = 219},
  [4685] = {.lex_state = 216},
  [4686] = {.lex_state = 216},
  [4687] = {.lex_state = 216},
  [4688] = {.lex_state = 216},
  [4689] = {.lex_state = 216},
  [4690] = {.lex_state = 216},
  [4691] = {.lex_state = 216},
  [4692] = {.lex_state = 216},
  [4693] = {.lex_state = 203},
  [4694] = {.lex_state = 216},
  [4695] = {.lex_state = 216},
  [4696] = {.lex_state = 216},
  [4697] = {.lex_state = 216},
  [4698] = {.lex_state = 216},
  [4699] = {.lex_state = 216},
  [4700] = {.lex_state = 216},
  [4701] = {.lex_state = 203},
  [4702] = {.lex_state = 203},
  [4703] = {.lex_state = 216},
  [4704] = {.lex_state = 216},
  [4705] = {.lex_state = 216},
  [4706] = {.lex_state = 216},
  [4707] = {.lex_state = 216},
  [4708] = {.lex_state = 216},
  [4709] = {.lex_state = 252},
  [4710] = {.lex_state = 216},
  [4711] = {.lex_state = 216},
  [4712] = {.lex_state = 216},
  [4713] = {.lex_state = 216},
  [4714] = {.lex_state = 216},
  [4715] = {.lex_state = 216},
  [4716] = {.lex_state = 216},
  [4717] = {.lex_state = 216},
  [4718] = {.lex_state = 216},
  [4719] = {.lex_state = 216},
  [4720] = {.lex_state = 216},
  [4721] = {.lex_state = 216},
  [4722] = {.lex_state = 216},
  [4723] = {.lex_state = 238},
  [4724] = {.lex_state = 253},
  [4725] = {.lex_state = 216},
  [4726] = {.lex_state = 216},
  [4727] = {.lex_state = 216},
  [4728] = {.lex_state = 216},
  [4729] = {.lex_state = 252},
  [4730] = {.lex_state = 203},
  [4731] = {.lex_state = 216},
  [4732] = {.lex_state = 216},
  [4733] = {.lex_state = 216},
  [4734] = {.lex_state = 216},
  [4735] = {.lex_state = 238},
  [4736] = {.lex_state = 238},
  [4737] = {.lex_state = 216},
  [4738] = {.lex_state = 216},
  [4739] = {.lex_state = 216},
  [4740] = {.lex_state = 216},
  [4741] = {.lex_state = 238},
  [4742] = {.lex_state = 214},
  [4743] = {.lex_state = 238},
  [4744] = {.lex_state = 216},
  [4745] = {.lex_state = 216},
  [4746] = {.lex_state = 238},
  [4747] = {.lex_state = 238},
  [4748] = {.lex_state = 216},
  [4749] = {.lex_state = 238},
  [4750] = {.lex_state = 216},
  [4751] = {.lex_state = 216},
  [4752] = {.lex_state = 214},
  [4753] = {.lex_state = 216},
  [4754] = {.lex_state = 216},
  [4755] = {.lex_state = 238},
  [4756] = {.lex_state = 216},
  [4757] = {.lex_state = 216},
  [4758] = {.lex_state = 238},
  [4759] = {.lex_state = 216},
  [4760] = {.lex_state = 216},
  [4761] = {.lex_state = 216},
  [4762] = {.lex_state = 216},
  [4763] = {.lex_state = 254},
  [4764] = {.lex_state = 216},
  [4765] = {.lex_state = 216},
  [4766] = {.lex_state = 216},
  [4767] = {.lex_state = 216},
  [4768] = {.lex_state = 216},
  [4769] = {.lex_state = 216},
  [4770] = {.lex_state = 216},
  [4771] = {.lex_state = 216},
  [4772] = {.lex_state = 255},
  [4773] = {.lex_state = 216},
  [4774] = {.lex_state = 216},
  [4775] = {.lex_state = 238},
  [4776] = {.lex_state = 238},
  [4777] = {.lex_state = 216},
  [4778] = {.lex_state = 216},
  [4779] = {.lex_state = 216},
  [4780] = {.lex_state = 254},
  [4781] = {.lex_state = 216},
  [4782] = {.lex_state = 216},
  [4783] = {.lex_state = 216},
  [4784] = {.lex_state = 216},
  [4785] = {.lex_state = 216},
  [4786] = {.lex_state = 216},
  [4787] = {.lex_state = 238},
  [4788] = {.lex_state = 252},
  [4789] = {.lex_state = 252},
  [4790] = {.lex_state = 239},
  [4791] = {.lex_state = 252},
  [4792] = {.lex_state = 238},
  [4793] = {.lex_state = 216},
  [4794] = {.lex_state = 216},
  [4795] = {.lex_state = 252},
  [4796] = {.lex_state = 238},
  [4797] = {.lex_state = 254},
  [4798] = {.lex_state = 216},
  [4799] = {.lex_state = 216},
  [4800] = {.lex_state = 216},
  [4801] = {.lex_state = 216},
  [4802] = {.lex_state = 216},
  [4803] = {.lex_state = 216},
  [4804] = {.lex_state = 251},
  [4805] = {.lex_state = 216},
  [4806] = {.lex_state = 216},
  [4807] = {.lex_state = 216},
  [4808] = {.lex_state = 216},
  [4809] = {.lex_state = 239},
  [4810] = {.lex_state = 216},
  [4811] = {.lex_state = 254},
  [4812] = {.lex_state = 238},
  [4813] = {.lex_state = 216},
  [4814] = {.lex_state = 251},
  [4815] = {.lex_state = 216},
  [4816] = {.lex_state = 216},
  [4817] = {.lex_state = 216},
  [4818] = {.lex_state = 216},
  [4819] = {.lex_state = 251},
  [4820] = {.lex_state = 251},
  [4821] = {.lex_state = 251},
  [4822] = {.lex_state = 254},
  [4823] = {.lex_state = 251},
  [4824] = {.lex_state = 256},
  [4825] = {.lex_state = 254},
  [4826] = {.lex_state = 252},
  [4827] = {.lex_state = 253},
  [4828] = {.lex_state = 216},
  [4829] = {.lex_state = 216},
  [4830] = {.lex_state = 251},
  [4831] = {.lex_state = 239},
  [4832] = {.lex_state = 251},
  [4833] = {.lex_state = 251},
  [4834] = {.lex_state = 251},
  [4835] = {.lex_state = 251},
  [4836] = {.lex_state = 256},
  [4837] = {.lex_state = 251},
  [4838] = {.lex_state = 251},
  [4839] = {.lex_state = 252},
  [4840] = {.lex_state = 252},
  [4841] = {.lex_state = 251},
  [4842] = {.lex_state = 251},
  [4843] = {.lex_state = 216},
  [4844] = {.lex_state = 251},
  [4845] = {.lex_state = 252},
  [4846] = {.lex_state = 251},
  [4847] = {.lex_state = 253},
  [4848] = {.lex_state = 251},
  [4849] = {.lex_state = 235},
  [4850] = {.lex_state = 216},
  [4851] = {.lex_state = 252},
  [4852] = {.lex_state = 216},
  [4853] = {.lex_state = 248},
  [4854] = {.lex_state = 216},
  [4855] = {.lex_state = 252},
  [4856] = {.lex_state = 251},
  [4857] = {.lex_state = 251},
  [4858] = {.lex_state = 252},
  [4859] = {.lex_state = 254},
  [4860] = {.lex_state = 254},
  [4861] = {.lex_state = 216},
  [4862] = {.lex_state = 216},
  [4863] = {.lex_state = 216},
  [4864] = {.lex_state = 216},
  [4865] = {.lex_state = 238},
  [4866] = {.lex_state = 216},
  [4867] = {.lex_state = 252},
  [4868] = {.lex_state = 252},
  [4869] = {.lex_state = 251},
  [4870] = {.lex_state = 216},
  [4871] = {.lex_state = 248},
  [4872] = {.lex_state = 216},
  [4873] = {.lex_state = 238},
  [4874] = {.lex_state = 216},
  [4875] = {.lex_state = 216},
  [4876] = {.lex_state = 216},
  [4877] = {.lex_state = 216},
  [4878] = {.lex_state = 235},
  [4879] = {.lex_state = 238},
  [4880] = {.lex_state = 216},
  [4881] = {.lex_state = 216},
  [4882] = {.lex_state = 216},
  [4883] = {.lex_state = 216},
  [4884] = {.lex_state = 216},
  [4885] = {.lex_state = 216},
  [4886] = {.lex_state = 216},
  [4887] = {.lex_state = 238},
  [4888] = {.lex_state = 238},
  [4889] = {.lex_state = 216},
  [4890] = {.lex_state = 216},
  [4891] = {.lex_state = 216},
  [4892] = {.lex_state = 238},
  [4893] = {.lex_state = 249},
  [4894] = {.lex_state = 238},
  [4895] = {.lex_state = 238},
  [4896] = {.lex_state = 249},
  [4897] = {.lex_state = 249},
  [4898] = {.lex_state = 249},
  [4899] = {.lex_state = 249},
  [4900] = {.lex_state = 238},
  [4901] = {.lex_state = 216},
  [4902] = {.lex_state = 217},
  [4903] = {.lex_state = 255},
  [4904] = {.lex_state = 249},
  [4905] = {.lex_state = 217},
  [4906] = {.lex_state = 249},
  [4907] = {.lex_state = 238},
  [4908] = {.lex_state = 253},
  [4909] = {.lex_state = 249},
  [4910] = {.lex_state = 249},
  [4911] = {.lex_state = 249},
  [4912] = {.lex_state = 255},
  [4913] = {.lex_state = 216},
  [4914] = {.lex_state = 255},
  [4915] = {.lex_state = 249},
  [4916] = {.lex_state = 251},
  [4917] = {.lex_state = 253},
  [4918] = {.lex_state = 249},
  [4919] = {.lex_state = 238},
  [4920] = {.lex_state = 238},
  [4921] = {.lex_state = 216},
  [4922] = {.lex_state = 249},
  [4923] = {.lex_state = 253},
  [4924] = {.lex_state = 238},
  [4925] = {.lex_state = 249},
  [4926] = {.lex_state = 249},
  [4927] = {.lex_state = 249},
  [4928] = {.lex_state = 249},
  [4929] = {.lex_state = 249},
  [4930] = {.lex_state = 249},
  [4931] = {.lex_state = 238},
  [4932] = {.lex_state = 249},
  [4933] = {.lex_state = 255},
  [4934] = {.lex_state = 217},
  [4935] = {.lex_state = 249},
  [4936] = {.lex_state = 249},
  [4937] = {.lex_state = 216},
  [4938] = {.lex_state = 251},
  [4939] = {.lex_state = 249},
  [4940] = {.lex_state = 249},
  [4941] = {.lex_state = 251},
  [4942] = {.lex_state = 255},
  [4943] = {.lex_state = 249},
  [4944] = {.lex_state = 249},
  [4945] = {.lex_state = 251},
  [4946] = {.lex_state = 238},
  [4947] = {.lex_state = 238},
  [4948] = {.lex_state = 238},
  [4949] = {.lex_state = 238},
  [4950] = {.lex_state = 249},
  [4951] = {.lex_state = 216},
  [4952] = {.lex_state = 249},
  [4953] = {.lex_state = 216},
  [4954] = {.lex_state = 252},
  [4955] = {.lex_state = 239},
  [4956] = {.lex_state = 252},
  [4957] = {.lex_state = 251},
  [4958] = {.lex_state = 216},
  [4959] = {.lex_state = 216},
  [4960] = {.lex_state = 254},
  [4961] = {.lex_state = 238},
  [4962] = {.lex_state = 238},
  [4963] = {.lex_state = 251},
  [4964] = {.lex_state = 217},
  [4965] = {.lex_state = 216},
  [4966] = {.lex_state = 239},
  [4967] = {.lex_state = 239},
  [4968] = {.lex_state = 239},
  [4969] = {.lex_state = 239},
  [4970] = {.lex_state = 239},
  [4971] = {.lex_state = 239},
  [4972] = {.lex_state = 251},
  [4973] = {.lex_state = 216},
  [4974] = {.lex_state = 238},
  [4975] = {.lex_state = 217},
  [4976] = {.lex_state = 239},
  [4977] = {.lex_state = 254},
  [4978] = {.lex_state = 239},
  [4979] = {.lex_state = 238},
  [4980] = {.lex_state = 239},
  [4981] = {.lex_state = 239},
  [4982] = {.lex_state = 252},
  [4983] = {.lex_state = 251},
  [4984] = {.lex_state = 216},
  [4985] = {.lex_state = 252},
  [4986] = {.lex_state = 216},
  [4987] = {.lex_state = 251},
  [4988] = {.lex_state = 216},
  [4989] = {.lex_state = 238},
  [4990] = {.lex_state = 238},
  [4991] = {.lex_state = 239},
  [4992] = {.lex_state = 248},
  [4993] = {.lex_state = 217},
  [4994] = {.lex_state = 239},
  [4995] = {.lex_state = 239},
  [4996] = {.lex_state = 252},
  [4997] = {.lex_state = 238},
  [4998] = {.lex_state = 239},
  [4999] = {.lex_state = 252},
  [5000] = {.lex_state = 251},
  [5001] = {.lex_state = 254},
  [5002] = {.lex_state = 254},
  [5003] = {.lex_state = 251},
  [5004] = {.lex_state = 254},
  [5005] = {.lex_state = 239},
  [5006] = {.lex_state = 254},
  [5007] = {.lex_state = 238},
  [5008] = {.lex_state = 251},
  [5009] = {.lex_state = 239},
  [5010] = {.lex_state = 251},
  [5011] = {.lex_state = 238},
  [5012] = {.lex_state = 254},
  [5013] = {.lex_state = 238},
  [5014] = {.lex_state = 235},
  [5015] = {.lex_state = 251},
  [5016] = {.lex_state = 238},
  [5017] = {.lex_state = 251},
  [5018] = {.lex_state = 238},
  [5019] = {.lex_state = 251},
  [5020] = {.lex_state = 238},
  [5021] = {.lex_state = 251},
  [5022] = {.lex_state = 238},
  [5023] = {.lex_state = 251},
  [5024] = {.lex_state = 216},
  [5025] = {.lex_state = 238},
  [5026] = {.lex_state = 254},
  [5027] = {.lex_state = 251},
  [5028] = {.lex_state = 254},
  [5029] = {.lex_state = 251},
  [5030] = {.lex_state = 251},
  [5031] = {.lex_state = 251},
  [5032] = {.lex_state = 254},
  [5033] = {.lex_state = 216},
  [5034] = {.lex_state = 216},
  [5035] = {.lex_state = 251},
  [5036] = {.lex_state = 216},
  [5037] = {.lex_state = 251},
  [5038] = {.lex_state = 238},
  [5039] = {.lex_state = 216},
  [5040] = {.lex_state = 238},
  [5041] = {.lex_state = 216},
  [5042] = {.lex_state = 216},
  [5043] = {.lex_state = 252},
  [5044] = {.lex_state = 216},
  [5045] = {.lex_state = 216},
  [5046] = {.lex_state = 216},
  [5047] = {.lex_state = 216},
  [5048] = {.lex_state = 251},
  [5049] = {.lex_state = 238},
  [5050] = {.lex_state = 248},
  [5051] = {.lex_state = 238},
  [5052] = {.lex_state = 252},
  [5053] = {.lex_state = 216},
  [5054] = {.lex_state = 252},
  [5055] = {.lex_state = 252},
  [5056] = {.lex_state = 238},
  [5057] = {.lex_state = 216},
  [5058] = {.lex_state = 254},
  [5059] = {.lex_state = 216},
  [5060] = {.lex_state = 254},
  [5061] = {.lex_state = 216},
  [5062] = {.lex_state = 252},
  [5063] = {.lex_state = 254},
  [5064] = {.lex_state = 252},
  [5065] = {.lex_state = 216},
  [5066] = {.lex_state = 252},
  [5067] = {.lex_state = 251},
  [5068] = {.lex_state = 238},
  [5069] = {.lex_state = 252},
  [5070] = {.lex_state = 254},
  [5071] = {.lex_state = 238},
  [5072] = {.lex_state = 238},
  [5073] = {.lex_state = 216},
  [5074] = {.lex_state = 238},
  [5075] = {.lex_state = 238},
  [5076] = {.lex_state = 238},
  [5077] = {.lex_state = 251},
  [5078] = {.lex_state = 252},
  [5079] = {.lex_state = 238},
  [5080] = {.lex_state = 238},
  [5081] = {.lex_state = 238},
  [5082] = {.lex_state = 251},
  [5083] = {.lex_state = 238},
  [5084] = {.lex_state = 252},
  [5085] = {.lex_state = 238},
  [5086] = {.lex_state = 254},
  [5087] = {.lex_state = 238},
  [5088] = {.lex_state = 254},
  [5089] = {.lex_state = 254},
  [5090] = {.lex_state = 251},
  [5091] = {.lex_state = 235},
  [5092] = {.lex_state = 235},
  [5093] = {.lex_state = 216},
  [5094] = {.lex_state = 238},
  [5095] = {.lex_state = 216},
  [5096] = {.lex_state = 238},
  [5097] = {.lex_state = 238},
  [5098] = {.lex_state = 238},
  [5099] = {.lex_state = 238},
  [5100] = {.lex_state = 235},
  [5101] = {.lex_state = 235},
  [5102] = {.lex_state = 251},
  [5103] = {.lex_state = 216},
  [5104] = {.lex_state = 252},
  [5105] = {.lex_state = 216},
  [5106] = {.lex_state = 252},
  [5107] = {.lex_state = 238},
  [5108] = {.lex_state = 251},
  [5109] = {.lex_state = 235},
  [5110] = {.lex_state = 254},
  [5111] = {.lex_state = 238},
  [5112] = {.lex_state = 252},
  [5113] = {.lex_state = 251},
  [5114] = {.lex_state = 216},
  [5115] = {.lex_state = 238},
  [5116] = {.lex_state = 235},
  [5117] = {.lex_state = 238},
  [5118] = {.lex_state = 235},
  [5119] = {.lex_state = 254},
  [5120] = {.lex_state = 216},
  [5121] = {.lex_state = 252},
  [5122] = {.lex_state = 238},
  [5123] = {.lex_state = 238},
  [5124] = {.lex_state = 238},
  [5125] = {.lex_state = 251},
  [5126] = {.lex_state = 216},
  [5127] = {.lex_state = 216},
  [5128] = {.lex_state = 216},
  [5129] = {.lex_state = 238},
  [5130] = {.lex_state = 216},
  [5131] = {.lex_state = 238},
  [5132] = {.lex_state = 216},
  [5133] = {.lex_state = 235},
  [5134] = {.lex_state = 252},
  [5135] = {.lex_state = 252},
  [5136] = {.lex_state = 252},
  [5137] = {.lex_state = 254},
  [5138] = {.lex_state = 238},
  [5139] = {.lex_state = 254},
  [5140] = {.lex_state = 216},
  [5141] = {.lex_state = 216},
  [5142] = {.lex_state = 216},
  [5143] = {.lex_state = 216},
  [5144] = {.lex_state = 216},
  [5145] = {.lex_state = 216},
  [5146] = {.lex_state = 216},
  [5147] = {.lex_state = 216},
  [5148] = {.lex_state = 216},
  [5149] = {.lex_state = 238},
  [5150] = {.lex_state = 252},
  [5151] = {.lex_state = 252},
  [5152] = {.lex_state = 216},
  [5153] = {.lex_state = 216},
  [5154] = {.lex_state = 216},
  [5155] = {.lex_state = 238},
  [5156] = {.lex_state = 216},
  [5157] = {.lex_state = 238},
  [5158] = {.lex_state = 238},
  [5159] = {.lex_state = 216},
  [5160] = {.lex_state = 216},
  [5161] = {.lex_state = 216},
  [5162] = {.lex_state = 216},
  [5163] = {.lex_state = 216},
  [5164] = {.lex_state = 216},
  [5165] = {.lex_state = 251},
  [5166] = {.lex_state = 216},
  [5167] = {.lex_state = 216},
  [5168] = {.lex_state = 216},
  [5169] = {.lex_state = 216},
  [5170] = {.lex_state = 216},
  [5171] = {.lex_state = 216},
  [5172] = {.lex_state = 216},
  [5173] = {.lex_state = 216},
  [5174] = {.lex_state = 216},
  [5175] = {.lex_state = 216},
  [5176] = {.lex_state = 254},
  [5177] = {.lex_state = 254},
  [5178] = {.lex_state = 216},
  [5179] = {.lex_state = 216},
  [5180] = {.lex_state = 252},
  [5181] = {.lex_state = 216},
  [5182] = {.lex_state = 216},
  [5183] = {.lex_state = 216},
  [5184] = {.lex_state = 254},
  [5185] = {.lex_state = 252},
  [5186] = {.lex_state = 216},
  [5187] = {.lex_state = 216},
  [5188] = {.lex_state = 216},
  [5189] = {.lex_state = 216},
  [5190] = {.lex_state = 216},
  [5191] = {.lex_state = 238},
  [5192] = {.lex_state = 216},
  [5193] = {.lex_state = 238},
  [5194] = {.lex_state = 254},
  [5195] = {.lex_state = 252},
  [5196] = {.lex_state = 216},
  [5197] = {.lex_state = 238},
  [5198] = {.lex_state = 216},
  [5199] = {.lex_state = 238},
  [5200] = {.lex_state = 238},
  [5201] = {.lex_state = 216},
  [5202] = {.lex_state = 248},
  [5203] = {.lex_state = 216},
  [5204] = {.lex_state = 216},
  [5205] = {.lex_state = 238},
  [5206] = {.lex_state = 216},
  [5207] = {.lex_state = 216},
  [5208] = {.lex_state = 252},
  [5209] = {.lex_state = 216},
  [5210] = {.lex_state = 216},
  [5211] = {.lex_state = 216},
  [5212] = {.lex_state = 216},
  [5213] = {.lex_state = 216},
  [5214] = {.lex_state = 235},
  [5215] = {.lex_state = 235},
  [5216] = {.lex_state = 216},
  [5217] = {.lex_state = 216},
  [5218] = {.lex_state = 248},
  [5219] = {.lex_state = 248},
  [5220] = {.lex_state = 216},
  [5221] = {.lex_state = 238},
  [5222] = {.lex_state = 238},
  [5223] = {.lex_state = 216},
  [5224] = {.lex_state = 216},
  [5225] = {.lex_state = 238},
  [5226] = {.lex_state = 238},
  [5227] = {.lex_state = 235},
  [5228] = {.lex_state = 251},
  [5229] = {.lex_state = 216},
  [5230] = {.lex_state = 216},
  [5231] = {.lex_state = 216},
  [5232] = {.lex_state = 238},
  [5233] = {.lex_state = 238},
  [5234] = {.lex_state = 238},
  [5235] = {.lex_state = 238},
  [5236] = {.lex_state = 238},
  [5237] = {.lex_state = 216},
  [5238] = {.lex_state = 216},
  [5239] = {.lex_state = 216},
  [5240] = {.lex_state = 238},
  [5241] = {.lex_state = 216},
  [5242] = {.lex_state = 216},
  [5243] = {.lex_state = 238},
  [5244] = {.lex_state = 238},
  [5245] = {.lex_state = 238},
  [5246] = {.lex_state = 238},
  [5247] = {.lex_state = 216},
  [5248] = {.lex_state = 238},
  [5249] = {.lex_state = 238},
  [5250] = {.lex_state = 238},
  [5251] = {.lex_state = 238},
  [5252] = {.lex_state = 216},
  [5253] = {.lex_state = 238},
  [5254] = {.lex_state = 216},
  [5255] = {.lex_state = 238},
  [5256] = {.lex_state = 238},
  [5257] = {.lex_state = 216},
  [5258] = {.lex_state = 238},
  [5259] = {.lex_state = 238},
  [5260] = {.lex_state = 238},
  [5261] = {.lex_state = 216},
  [5262] = {.lex_state = 238},
  [5263] = {.lex_state = 238},
  [5264] = {.lex_state = 238},
  [5265] = {.lex_state = 238},
  [5266] = {.lex_state = 216},
  [5267] = {.lex_state = 216},
  [5268] = {.lex_state = 216},
  [5269] = {.lex_state = 238},
  [5270] = {.lex_state = 238},
  [5271] = {.lex_state = 238},
  [5272] = {.lex_state = 238},
  [5273] = {.lex_state = 238},
  [5274] = {.lex_state = 238},
  [5275] = {.lex_state = 238},
  [5276] = {.lex_state = 238},
  [5277] = {.lex_state = 238},
  [5278] = {.lex_state = 238},
  [5279] = {.lex_state = 238},
  [5280] = {.lex_state = 238},
  [5281] = {.lex_state = 238},
  [5282] = {.lex_state = 238},
  [5283] = {.lex_state = 238},
  [5284] = {.lex_state = 238},
  [5285] = {.lex_state = 216},
  [5286] = {.lex_state = 238},
  [5287] = {.lex_state = 252},
  [5288] = {.lex_state = 238},
  [5289] = {.lex_state = 238},
  [5290] = {.lex_state = 238},
  [5291] = {.lex_state = 238},
  [5292] = {.lex_state = 238},
  [5293] = {.lex_state = 238},
  [5294] = {.lex_state = 238},
  [5295] = {.lex_state = 238},
  [5296] = {.lex_state = 238},
  [5297] = {.lex_state = 238},
  [5298] = {.lex_state = 238},
  [5299] = {.lex_state = 238},
  [5300] = {.lex_state = 216},
  [5301] = {.lex_state = 216},
  [5302] = {.lex_state = 238},
  [5303] = {.lex_state = 238},
  [5304] = {.lex_state = 238},
  [5305] = {.lex_state = 238},
  [5306] = {.lex_state = 238},
  [5307] = {.lex_state = 238},
  [5308] = {.lex_state = 238},
  [5309] = {.lex_state = 238},
  [5310] = {.lex_state = 238},
  [5311] = {.lex_state = 238},
  [5312] = {.lex_state = 238},
  [5313] = {.lex_state = 238},
  [5314] = {.lex_state = 238},
  [5315] = {.lex_state = 216},
  [5316] = {.lex_state = 251},
  [5317] = {.lex_state = 217},
  [5318] = {.lex_state = 216},
  [5319] = {.lex_state = 252},
  [5320] = {.lex_state = 216},
  [5321] = {.lex_state = 238},
  [5322] = {.lex_state = 238},
  [5323] = {.lex_state = 217},
  [5324] = {.lex_state = 238},
  [5325] = {.lex_state = 238},
  [5326] = {.lex_state = 238},
  [5327] = {.lex_state = 238},
  [5328] = {.lex_state = 238},
  [5329] = {.lex_state = 238},
  [5330] = {.lex_state = 238},
  [5331] = {.lex_state = 238},
  [5332] = {.lex_state = 238},
  [5333] = {.lex_state = 238},
  [5334] = {.lex_state = 252},
  [5335] = {.lex_state = 216},
  [5336] = {.lex_state = 216},
  [5337] = {.lex_state = 254},
  [5338] = {.lex_state = 216},
  [5339] = {.lex_state = 216},
  [5340] = {.lex_state = 216},
  [5341] = {.lex_state = 216},
  [5342] = {.lex_state = 238},
  [5343] = {.lex_state = 216},
  [5344] = {.lex_state = 216},
  [5345] = {.lex_state = 254},
  [5346] = {.lex_state = 238},
  [5347] = {.lex_state = 238},
  [5348] = {.lex_state = 238},
  [5349] = {.lex_state = 238},
  [5350] = {.lex_state = 238},
  [5351] = {.lex_state = 216},
  [5352] = {.lex_state = 216},
  [5353] = {.lex_state = 238},
  [5354] = {.lex_state = 216},
  [5355] = {.lex_state = 216},
  [5356] = {.lex_state = 216},
  [5357] = {.lex_state = 216},
  [5358] = {.lex_state = 216},
  [5359] = {.lex_state = 238},
  [5360] = {.lex_state = 216},
  [5361] = {.lex_state = 216},
  [5362] = {.lex_state = 216},
  [5363] = {.lex_state = 216},
  [5364] = {.lex_state = 216},
  [5365] = {.lex_state = 216},
  [5366] = {.lex_state = 216},
  [5367] = {.lex_state = 216},
  [5368] = {.lex_state = 216},
  [5369] = {.lex_state = 216},
  [5370] = {.lex_state = 216},
  [5371] = {.lex_state = 216},
  [5372] = {.lex_state = 216},
  [5373] = {.lex_state = 216},
  [5374] = {.lex_state = 252},
  [5375] = {.lex_state = 238},
  [5376] = {.lex_state = 238},
  [5377] = {.lex_state = 254},
  [5378] = {.lex_state = 254},
  [5379] = {.lex_state = 251},
  [5380] = {.lex_state = 216},
  [5381] = {.lex_state = 252},
  [5382] = {.lex_state = 216},
  [5383] = {.lex_state = 216},
  [5384] = {.lex_state = 238},
  [5385] = {.lex_state = 216},
  [5386] = {.lex_state = 238},
  [5387] = {.lex_state = 216},
  [5388] = {.lex_state = 235},
  [5389] = {.lex_state = 216},
  [5390] = {.lex_state = 216},
  [5391] = {.lex_state = 216},
  [5392] = {.lex_state = 238},
  [5393] = {.lex_state = 217},
  [5394] = {.lex_state = 216},
  [5395] = {.lex_state = 216},
  [5396] = {.lex_state = 216},
  [5397] = {.lex_state = 216},
  [5398] = {.lex_state = 216},
  [5399] = {.lex_state = 216},
  [5400] = {.lex_state = 216},
  [5401] = {.lex_state = 216},
  [5402] = {.lex_state = 216},
  [5403] = {.lex_state = 216},
  [5404] = {.lex_state = 216},
  [5405] = {.lex_state = 252},
  [5406] = {.lex_state = 216},
  [5407] = {.lex_state = 216},
  [5408] = {.lex_state = 216},
  [5409] = {.lex_state = 216},
  [5410] = {.lex_state = 216},
  [5411] = {.lex_state = 216},
  [5412] = {.lex_state = 216},
  [5413] = {.lex_state = 216},
  [5414] = {.lex_state = 216},
  [5415] = {.lex_state = 216},
  [5416] = {.lex_state = 216},
  [5417] = {.lex_state = 216},
  [5418] = {.lex_state = 216},
  [5419] = {.lex_state = 238},
  [5420] = {.lex_state = 216},
  [5421] = {.lex_state = 216},
  [5422] = {.lex_state = 216},
  [5423] = {.lex_state = 216},
  [5424] = {.lex_state = 238},
  [5425] = {.lex_state = 216},
  [5426] = {.lex_state = 216},
  [5427] = {.lex_state = 216},
  [5428] = {.lex_state = 216},
  [5429] = {.lex_state = 216},
  [5430] = {.lex_state = 216},
  [5431] = {.lex_state = 216},
  [5432] = {.lex_state = 238},
  [5433] = {.lex_state = 251},
  [5434] = {.lex_state = 216},
  [5435] = {.lex_state = 238},
  [5436] = {.lex_state = 238},
  [5437] = {.lex_state = 216},
  [5438] = {.lex_state = 216},
  [5439] = {.lex_state = 216},
  [5440] = {.lex_state = 216},
  [5441] = {.lex_state = 252},
  [5442] = {.lex_state = 216},
  [5443] = {.lex_state = 216},
  [5444] = {.lex_state = 216},
  [5445] = {.lex_state = 216},
  [5446] = {.lex_state = 251},
  [5447] = {.lex_state = 216},
  [5448] = {.lex_state = 249},
  [5449] = {.lex_state = 216},
  [5450] = {.lex_state = 251},
  [5451] = {.lex_state = 216},
  [5452] = {.lex_state = 248},
  [5453] = {.lex_state = 216},
  [5454] = {.lex_state = 216},
  [5455] = {.lex_state = 216},
  [5456] = {.lex_state = 216},
  [5457] = {.lex_state = 216},
  [5458] = {.lex_state = 251},
  [5459] = {.lex_state = 216},
  [5460] = {.lex_state = 216},
  [5461] = {.lex_state = 216},
  [5462] = {.lex_state = 216},
  [5463] = {.lex_state = 249},
  [5464] = {.lex_state = 216},
  [5465] = {.lex_state = 216},
  [5466] = {.lex_state = 216},
  [5467] = {.lex_state = 216},
  [5468] = {.lex_state = 216},
  [5469] = {.lex_state = 251},
  [5470] = {.lex_state = 216},
  [5471] = {.lex_state = 216},
  [5472] = {.lex_state = 216},
  [5473] = {.lex_state = 254},
  [5474] = {.lex_state = 251},
  [5475] = {.lex_state = 216},
  [5476] = {.lex_state = 252},
  [5477] = {.lex_state = 248},
  [5478] = {.lex_state = 216},
  [5479] = {.lex_state = 251},
  [5480] = {.lex_state = 216},
  [5481] = {.lex_state = 255},
  [5482] = {.lex_state = 216},
  [5483] = {.lex_state = 216},
  [5484] = {.lex_state = 216},
  [5485] = {.lex_state = 216},
  [5486] = {.lex_state = 216},
  [5487] = {.lex_state = 216},
  [5488] = {.lex_state = 251},
  [5489] = {.lex_state = 216},
  [5490] = {.lex_state = 216},
  [5491] = {.lex_state = 216},
  [5492] = {.lex_state = 216},
  [5493] = {.lex_state = 248},
  [5494] = {.lex_state = 216},
  [5495] = {.lex_state = 216},
  [5496] = {.lex_state = 216},
  [5497] = {.lex_state = 251},
  [5498] = {.lex_state = 254},
  [5499] = {.lex_state = 216},
  [5500] = {.lex_state = 251},
  [5501] = {.lex_state = 216},
  [5502] = {.lex_state = 216},
  [5503] = {.lex_state = 216},
  [5504] = {.lex_state = 216},
  [5505] = {.lex_state = 251},
  [5506] = {.lex_state = 216},
  [5507] = {.lex_state = 216},
  [5508] = {.lex_state = 216},
  [5509] = {.lex_state = 252},
  [5510] = {.lex_state = 216},
  [5511] = {.lex_state = 216},
  [5512] = {.lex_state = 255},
  [5513] = {.lex_state = 252},
  [5514] = {.lex_state = 216},
  [5515] = {.lex_state = 216},
  [5516] = {.lex_state = 252},
  [5517] = {.lex_state = 216},
  [5518] = {.lex_state = 216},
  [5519] = {.lex_state = 216},
  [5520] = {.lex_state = 216},
  [5521] = {.lex_state = 241},
  [5522] = {.lex_state = 251},
  [5523] = {.lex_state = 216},
  [5524] = {.lex_state = 216},
  [5525] = {.lex_state = 216},
  [5526] = {.lex_state = 216},
  [5527] = {.lex_state = 251},
  [5528] = {.lex_state = 216},
  [5529] = {.lex_state = 251},
  [5530] = {.lex_state = 216},
  [5531] = {.lex_state = 216},
  [5532] = {.lex_state = 216},
  [5533] = {.lex_state = 216},
  [5534] = {.lex_state = 216},
  [5535] = {.lex_state = 216},
  [5536] = {.lex_state = 216},
  [5537] = {.lex_state = 252},
  [5538] = {.lex_state = 216},
  [5539] = {.lex_state = 216},
  [5540] = {.lex_state = 216},
  [5541] = {.lex_state = 216},
  [5542] = {.lex_state = 216},
  [5543] = {.lex_state = 216},
  [5544] = {.lex_state = 241},
  [5545] = {.lex_state = 216},
  [5546] = {.lex_state = 216},
  [5547] = {.lex_state = 216},
  [5548] = {.lex_state = 252},
  [5549] = {.lex_state = 252},
  [5550] = {.lex_state = 216},
  [5551] = {.lex_state = 216},
  [5552] = {.lex_state = 216},
  [5553] = {.lex_state = 216},
  [5554] = {.lex_state = 252},
  [5555] = {.lex_state = 254},
  [5556] = {.lex_state = 216},
  [5557] = {.lex_state = 216},
  [5558] = {.lex_state = 216},
  [5559] = {.lex_state = 216},
  [5560] = {.lex_state = 216},
  [5561] = {.lex_state = 252},
  [5562] = {.lex_state = 216},
  [5563] = {.lex_state = 238},
  [5564] = {.lex_state = 216},
  [5565] = {.lex_state = 216},
  [5566] = {.lex_state = 216},
  [5567] = {.lex_state = 216},
  [5568] = {.lex_state = 241},
  [5569] = {.lex_state = 216},
  [5570] = {.lex_state = 216},
  [5571] = {.lex_state = 216},
  [5572] = {.lex_state = 252},
  [5573] = {.lex_state = 216},
  [5574] = {.lex_state = 216},
  [5575] = {.lex_state = 216},
  [5576] = {.lex_state = 216},
  [5577] = {.lex_state = 216},
  [5578] = {.lex_state = 216},
  [5579] = {.lex_state = 216},
  [5580] = {.lex_state = 216},
  [5581] = {.lex_state = 216},
  [5582] = {.lex_state = 216},
  [5583] = {.lex_state = 216},
  [5584] = {.lex_state = 216},
  [5585] = {.lex_state = 216},
  [5586] = {.lex_state = 216},
  [5587] = {.lex_state = 216},
  [5588] = {.lex_state = 216},
  [5589] = {.lex_state = 216},
  [5590] = {.lex_state = 216},
  [5591] = {.lex_state = 216},
  [5592] = {.lex_state = 234},
  [5593] = {.lex_state = 254},
  [5594] = {.lex_state = 216},
  [5595] = {.lex_state = 216},
  [5596] = {.lex_state = 254},
  [5597] = {.lex_state = 216},
  [5598] = {.lex_state = 216},
  [5599] = {.lex_state = 254},
  [5600] = {.lex_state = 254},
  [5601] = {.lex_state = 254},
  [5602] = {.lex_state = 216},
  [5603] = {.lex_state = 254},
  [5604] = {.lex_state = 254},
  [5605] = {.lex_state = 254},
  [5606] = {.lex_state = 216},
  [5607] = {.lex_state = 254},
  [5608] = {.lex_state = 254},
  [5609] = {.lex_state = 254},
  [5610] = {.lex_state = 254},
  [5611] = {.lex_state = 254},
  [5612] = {.lex_state = 216},
  [5613] = {.lex_state = 216},
  [5614] = {.lex_state = 216},
  [5615] = {.lex_state = 252},
  [5616] = {.lex_state = 216},
  [5617] = {.lex_state = 216},
  [5618] = {.lex_state = 216},
  [5619] = {.lex_state = 216},
  [5620] = {.lex_state = 249},
  [5621] = {.lex_state = 238},
  [5622] = {.lex_state = 254},
  [5623] = {.lex_state = 238},
  [5624] = {.lex_state = 238},
  [5625] = {.lex_state = 252},
  [5626] = {.lex_state = 238},
  [5627] = {.lex_state = 252},
  [5628] = {.lex_state = 238},
  [5629] = {.lex_state = 238},
  [5630] = {.lex_state = 238},
  [5631] = {.lex_state = 251},
  [5632] = {.lex_state = 252},
  [5633] = {.lex_state = 251},
  [5634] = {.lex_state = 251},
  [5635] = {.lex_state = 238},
  [5636] = {.lex_state = 238},
  [5637] = {.lex_state = 252},
  [5638] = {.lex_state = 238},
  [5639] = {.lex_state = 238},
  [5640] = {.lex_state = 251},
  [5641] = {.lex_state = 249},
  [5642] = {.lex_state = 235},
  [5643] = {.lex_state = 251},
  [5644] = {.lex_state = 254},
  [5645] = {.lex_state = 249},
  [5646] = {.lex_state = 249},
  [5647] = {.lex_state = 251},
  [5648] = {.lex_state = 238},
  [5649] = {.lex_state = 238},
  [5650] = {.lex_state = 249},
  [5651] = {.lex_state = 238},
  [5652] = {.lex_state = 238},
  [5653] = {.lex_state = 238},
  [5654] = {.lex_state = 252},
  [5655] = {.lex_state = 216},
  [5656] = {.lex_state = 238},
  [5657] = {.lex_state = 238},
  [5658] = {.lex_state = 238},
  [5659] = {.lex_state = 238},
  [5660] = {.lex_state = 238},
  [5661] = {.lex_state = 238},
  [5662] = {.lex_state = 252},
  [5663] = {.lex_state = 238},
  [5664] = {.lex_state = 254},
  [5665] = {.lex_state = 251},
  [5666] = {.lex_state = 238},
  [5667] = {.lex_state = 254},
  [5668] = {.lex_state = 238},
  [5669] = {.lex_state = 248},
  [5670] = {.lex_state = 216},
  [5671] = {.lex_state = 217},
  [5672] = {.lex_state = 254},
  [5673] = {.lex_state = 238},
  [5674] = {.lex_state = 238},
  [5675] = {.lex_state = 248},
  [5676] = {.lex_state = 249},
  [5677] = {.lex_state = 248},
  [5678] = {.lex_state = 251},
  [5679] = {.lex_state = 254},
  [5680] = {.lex_state = 251},
  [5681] = {.lex_state = 252},
  [5682] = {.lex_state = 251},
  [5683] = {.lex_state = 216},
  [5684] = {.lex_state = 238},
  [5685] = {.lex_state = 254},
  [5686] = {.lex_state = 252},
  [5687] = {.lex_state = 254},
  [5688] = {.lex_state = 252},
  [5689] = {.lex_state = 251},
  [5690] = {.lex_state = 252},
  [5691] = {.lex_state = 254},
  [5692] = {.lex_state = 238},
  [5693] = {.lex_state = 252},
  [5694] = {.lex_state = 254},
  [5695] = {.lex_state = 251},
  [5696] = {.lex_state = 252},
  [5697] = {.lex_state = 254},
  [5698] = {.lex_state = 238},
  [5699] = {.lex_state = 216},
  [5700] = {.lex_state = 254},
  [5701] = {.lex_state = 252},
  [5702] = {.lex_state = 254},
  [5703] = {.lex_state = 216},
  [5704] = {.lex_state = 252},
  [5705] = {.lex_state = 235},
  [5706] = {.lex_state = 254},
  [5707] = {.lex_state = 251},
  [5708] = {.lex_state = 238},
  [5709] = {.lex_state = 249},
  [5710] = {.lex_state = 254},
  [5711] = {.lex_state = 248},
  [5712] = {.lex_state = 238},
  [5713] = {.lex_state = 249},
  [5714] = {.lex_state = 254},
  [5715] = {.lex_state = 254},
  [5716] = {.lex_state = 238},
  [5717] = {.lex_state = 238},
  [5718] = {.lex_state = 254},
  [5719] = {.lex_state = 249},
  [5720] = {.lex_state = 238},
  [5721] = {.lex_state = 249},
  [5722] = {.lex_state = 248},
  [5723] = {.lex_state = 251},
  [5724] = {.lex_state = 252},
  [5725] = {.lex_state = 252},
  [5726] = {.lex_state = 238},
  [5727] = {.lex_state = 249},
  [5728] = {.lex_state = 248},
  [5729] = {.lex_state = 238},
  [5730] = {.lex_state = 238},
  [5731] = {.lex_state = 252},
  [5732] = {.lex_state = 248},
  [5733] = {.lex_state = 248},
  [5734] = {.lex_state = 248},
  [5735] = {.lex_state = 249},
  [5736] = {.lex_state = 251},
  [5737] = {.lex_state = 254},
  [5738] = {.lex_state = 251},
  [5739] = {.lex_state = 249},
  [5740] = {.lex_state = 249},
  [5741] = {.lex_state = 251},
  [5742] = {.lex_state = 251},
  [5743] = {.lex_state = 238},
  [5744] = {.lex_state = 252},
  [5745] = {.lex_state = 252},
  [5746] = {.lex_state = 254},
  [5747] = {.lex_state = 249},
  [5748] = {.lex_state = 215},
  [5749] = {.lex_state = 252},
  [5750] = {.lex_state = 252},
  [5751] = {.lex_state = 238},
  [5752] = {.lex_state = 249},
  [5753] = {.lex_state = 216},
  [5754] = {.lex_state = 249},
  [5755] = {.lex_state = 216},
  [5756] = {.lex_state = 249},
  [5757] = {.lex_state = 252},
  [5758] = {.lex_state = 252},
  [5759] = {.lex_state = 216},
  [5760] = {.lex_state = 252},
  [5761] = {.lex_state = 235},
  [5762] = {.lex_state = 252},
  [5763] = {.lex_state = 252},
  [5764] = {.lex_state = 216},
  [5765] = {.lex_state = 235},
  [5766] = {.lex_state = 254},
  [5767] = {.lex_state = 216},
  [5768] = {.lex_state = 254},
  [5769] = {.lex_state = 254},
  [5770] = {.lex_state = 254},
  [5771] = {.lex_state = 254},
  [5772] = {.lex_state = 254},
  [5773] = {.lex_state = 216},
  [5774] = {.lex_state = 252},
  [5775] = {.lex_state = 254},
  [5776] = {.lex_state = 254},
  [5777] = {.lex_state = 251},
  [5778] = {.lex_state = 254},
  [5779] = {.lex_state = 254},
  [5780] = {.lex_state = 252},
  [5781] = {.lex_state = 254},
  [5782] = {.lex_state = 254},
  [5783] = {.lex_state = 235},
  [5784] = {.lex_state = 254},
  [5785] = {.lex_state = 216},
  [5786] = {.lex_state = 254},
  [5787] = {.lex_state = 252},
  [5788] = {.lex_state = 254},
  [5789] = {.lex_state = 254},
  [5790] = {.lex_state = 254},
  [5791] = {.lex_state = 254},
  [5792] = {.lex_state = 254},
  [5793] = {.lex_state = 252},
  [5794] = {.lex_state = 254},
  [5795] = {.lex_state = 254},
  [5796] = {.lex_state = 235},
  [5797] = {.lex_state = 252},
  [5798] = {.lex_state = 252},
  [5799] = {.lex_state = 252},
  [5800] = {.lex_state = 254},
  [5801] = {.lex_state = 252},
  [5802] = {.lex_state = 254},
  [5803] = {.lex_state = 252},
  [5804] = {.lex_state = 252},
  [5805] = {.lex_state = 252},
  [5806] = {.lex_state = 252},
  [5807] = {.lex_state = 252},
  [5808] = {.lex_state = 252},
  [5809] = {.lex_state = 252},
  [5810] = {.lex_state = 252},
  [5811] = {.lex_state = 235},
  [5812] = {.lex_state = 251},
  [5813] = {.lex_state = 252},
  [5814] = {.lex_state = 252},
  [5815] = {.lex_state = 252},
  [5816] = {.lex_state = 254},
  [5817] = {.lex_state = 216},
  [5818] = {.lex_state = 252},
  [5819] = {.lex_state = 254},
  [5820] = {.lex_state = 252},
  [5821] = {.lex_state = 235},
  [5822] = {.lex_state = 252},
  [5823] = {.lex_state = 254},
  [5824] = {.lex_state = 252},
  [5825] = {.lex_state = 254},
  [5826] = {.lex_state = 254},
  [5827] = {.lex_state = 252},
  [5828] = {.lex_state = 252},
  [5829] = {.lex_state = 254},
  [5830] = {.lex_state = 254},
  [5831] = {.lex_state = 254},
  [5832] = {.lex_state = 254},
  [5833] = {.lex_state = 254},
  [5834] = {.lex_state = 252},
  [5835] = {.lex_state = 252},
  [5836] = {.lex_state = 252},
  [5837] = {.lex_state = 252},
  [5838] = {.lex_state = 252},
  [5839] = {.lex_state = 254},
  [5840] = {.lex_state = 252},
  [5841] = {.lex_state = 252},
  [5842] = {.lex_state = 252},
  [5843] = {.lex_state = 216},
  [5844] = {.lex_state = 252},
  [5845] = {.lex_state = 252},
  [5846] = {.lex_state = 252},
  [5847] = {.lex_state = 254},
  [5848] = {.lex_state = 252},
  [5849] = {.lex_state = 252},
  [5850] = {.lex_state = 254},
  [5851] = {.lex_state = 252},
  [5852] = {.lex_state = 252},
  [5853] = {.lex_state = 254},
  [5854] = {.lex_state = 254},
  [5855] = {.lex_state = 252},
  [5856] = {.lex_state = 252},
  [5857] = {.lex_state = 252},
  [5858] = {.lex_state = 254},
  [5859] = {.lex_state = 215},
  [5860] = {.lex_state = 252},
  [5861] = {.lex_state = 252},
  [5862] = {.lex_state = 252},
  [5863] = {.lex_state = 252},
  [5864] = {.lex_state = 252},
  [5865] = {.lex_state = 254},
  [5866] = {.lex_state = 251},
  [5867] = {.lex_state = 249},
  [5868] = {.lex_state = 249},
  [5869] = {.lex_state = 249},
  [5870] = {.lex_state = 249},
  [5871] = {.lex_state = 249},
  [5872] = {.lex_state = 249},
  [5873] = {.lex_state = 249},
  [5874] = {.lex_state = 251},
  [5875] = {.lex_state = 249},
  [5876] = {.lex_state = 249},
  [5877] = {.lex_state = 249},
  [5878] = {.lex_state = 249},
  [5879] = {.lex_state = 249},
  [5880] = {.lex_state = 249},
  [5881] = {.lex_state = 249},
  [5882] = {.lex_state = 254},
  [5883] = {.lex_state = 249},
  [5884] = {.lex_state = 252},
  [5885] = {.lex_state = 252},
  [5886] = {.lex_state = 249},
  [5887] = {.lex_state = 249},
  [5888] = {.lex_state = 251},
  [5889] = {.lex_state = 249},
  [5890] = {.lex_state = 249},
  [5891] = {.lex_state = 249},
  [5892] = {.lex_state = 249},
  [5893] = {.lex_state = 252},
  [5894] = {.lex_state = 249},
  [5895] = {.lex_state = 252},
  [5896] = {.lex_state = 249},
  [5897] = {.lex_state = 251},
  [5898] = {.lex_state = 249},
  [5899] = {.lex_state = 251},
  [5900] = {.lex_state = 249},
  [5901] = {.lex_state = 249},
  [5902] = {.lex_state = 249},
  [5903] = {.lex_state = 249},
  [5904] = {.lex_state = 249},
  [5905] = {.lex_state = 249},
  [5906] = {.lex_state = 216},
  [5907] = {.lex_state = 249},
  [5908] = {.lex_state = 251},
  [5909] = {.lex_state = 249},
  [5910] = {.lex_state = 251},
  [5911] = {.lex_state = 249},
  [5912] = {.lex_state = 249},
  [5913] = {.lex_state = 249},
  [5914] = {.lex_state = 249},
  [5915] = {.lex_state = 249},
  [5916] = {.lex_state = 249},
  [5917] = {.lex_state = 252},
  [5918] = {.lex_state = 249},
  [5919] = {.lex_state = 249},
  [5920] = {.lex_state = 254},
  [5921] = {.lex_state = 252},
  [5922] = {.lex_state = 249},
  [5923] = {.lex_state = 248},
  [5924] = {.lex_state = 249},
  [5925] = {.lex_state = 251},
  [5926] = {.lex_state = 249},
  [5927] = {.lex_state = 252},
  [5928] = {.lex_state = 249},
  [5929] = {.lex_state = 251},
  [5930] = {.lex_state = 251},
  [5931] = {.lex_state = 249},
  [5932] = {.lex_state = 249},
  [5933] = {.lex_state = 249},
  [5934] = {.lex_state = 249},
  [5935] = {.lex_state = 251},
  [5936] = {.lex_state = 249},
  [5937] = {.lex_state = 249},
  [5938] = {.lex_state = 249},
  [5939] = {.lex_state = 249},
  [5940] = {.lex_state = 249},
  [5941] = {.lex_state = 251},
  [5942] = {.lex_state = 249},
  [5943] = {.lex_state = 254},
  [5944] = {.lex_state = 249},
  [5945] = {.lex_state = 249},
  [5946] = {.lex_state = 251},
  [5947] = {.lex_state = 249},
  [5948] = {.lex_state = 251},
  [5949] = {.lex_state = 254},
  [5950] = {.lex_state = 249},
  [5951] = {.lex_state = 249},
  [5952] = {.lex_state = 249},
  [5953] = {.lex_state = 249},
  [5954] = {.lex_state = 249},
  [5955] = {.lex_state = 249},
  [5956] = {.lex_state = 251},
  [5957] = {.lex_state = 249},
  [5958] = {.lex_state = 252},
  [5959] = {.lex_state = 249},
  [5960] = {.lex_state = 249},
  [5961] = {.lex_state = 216},
  [5962] = {.lex_state = 249},
  [5963] = {.lex_state = 249},
  [5964] = {.lex_state = 216},
  [5965] = {.lex_state = 248},
  [5966] = {.lex_state = 251},
  [5967] = {.lex_state = 249},
  [5968] = {.lex_state = 251},
  [5969] = {.lex_state = 249},
  [5970] = {.lex_state = 249},
  [5971] = {.lex_state = 216},
  [5972] = {.lex_state = 216},
  [5973] = {.lex_state = 251},
  [5974] = {.lex_state = 249},
  [5975] = {.lex_state = 251},
  [5976] = {.lex_state = 249},
  [5977] = {.lex_state = 249},
  [5978] = {.lex_state = 249},
  [5979] = {.lex_state = 249},
  [5980] = {.lex_state = 249},
  [5981] = {.lex_state = 216},
  [5982] = {.lex_state = 249},
  [5983] = {.lex_state = 252},
  [5984] = {.lex_state = 249},
  [5985] = {.lex_state = 249},
  [5986] = {.lex_state = 249},
  [5987] = {.lex_state = 249},
  [5988] = {.lex_state = 251},
  [5989] = {.lex_state = 251},
  [5990] = {.lex_state = 251},
  [5991] = {.lex_state = 254},
  [5992] = {.lex_state = 254},
  [5993] = {.lex_state = 249},
  [5994] = {.lex_state = 251},
  [5995] = {.lex_state = 251},
  [5996] = {.lex_state = 249},
  [5997] = {.lex_state = 248},
  [5998] = {.lex_state = 254},
  [5999] = {.lex_state = 251},
  [6000] = {.lex_state = 216},
  [6001] = {.lex_state = 251},
  [6002] = {.lex_state = 249},
  [6003] = {.lex_state = 251},
  [6004] = {.lex_state = 216},
  [6005] = {.lex_state = 249},
  [6006] = {.lex_state = 249},
  [6007] = {.lex_state = 249},
  [6008] = {.lex_state = 249},
  [6009] = {.lex_state = 216},
  [6010] = {.lex_state = 249},
  [6011] = {.lex_state = 251},
  [6012] = {.lex_state = 216},
  [6013] = {.lex_state = 251},
  [6014] = {.lex_state = 235},
  [6015] = {.lex_state = 248},
  [6016] = {.lex_state = 249},
  [6017] = {.lex_state = 254},
  [6018] = {.lex_state = 251},
  [6019] = {.lex_state = 216},
  [6020] = {.lex_state = 248},
  [6021] = {.lex_state = 215},
  [6022] = {.lex_state = 215},
  [6023] = {.lex_state = 252},
  [6024] = {.lex_state = 254},
  [6025] = {.lex_state = 254},
  [6026] = {.lex_state = 251},
  [6027] = {.lex_state = 252},
  [6028] = {.lex_state = 235},
  [6029] = {.lex_state = 251},
  [6030] = {.lex_state = 252},
  [6031] = {.lex_state = 252},
  [6032] = {.lex_state = 252},
  [6033] = {.lex_state = 252},
  [6034] = {.lex_state = 216},
  [6035] = {.lex_state = 252},
  [6036] = {.lex_state = 254},
  [6037] = {.lex_state = 235},
  [6038] = {.lex_state = 235},
  [6039] = {.lex_state = 252},
  [6040] = {.lex_state = 235},
  [6041] = {.lex_state = 235},
  [6042] = {.lex_state = 235},
  [6043] = {.lex_state = 216},
  [6044] = {.lex_state = 252},
  [6045] = {.lex_state = 235},
  [6046] = {.lex_state = 252},
  [6047] = {.lex_state = 254},
  [6048] = {.lex_state = 254},
  [6049] = {.lex_state = 252},
  [6050] = {.lex_state = 235},
  [6051] = {.lex_state = 252},
  [6052] = {.lex_state = 216},
  [6053] = {.lex_state = 252},
  [6054] = {.lex_state = 235},
  [6055] = {.lex_state = 252},
  [6056] = {.lex_state = 252},
  [6057] = {.lex_state = 216},
  [6058] = {.lex_state = 252},
  [6059] = {.lex_state = 235},
  [6060] = {.lex_state = 248},
  [6061] = {.lex_state = 254},
  [6062] = {.lex_state = 252},
  [6063] = {.lex_state = 248},
  [6064] = {.lex_state = 251},
  [6065] = {.lex_state = 235},
  [6066] = {.lex_state = 248},
  [6067] = {.lex_state = 235},
  [6068] = {.lex_state = 251},
  [6069] = {.lex_state = 216},
  [6070] = {.lex_state = 235},
  [6071] = {.lex_state = 248},
  [6072] = {.lex_state = 248},
  [6073] = {.lex_state = 248},
  [6074] = {.lex_state = 248},
  [6075] = {.lex_state = 251},
  [6076] = {.lex_state = 249},
  [6077] = {.lex_state = 248},
  [6078] = {.lex_state = 248},
  [6079] = {.lex_state = 248},
  [6080] = {.lex_state = 251},
  [6081] = {.lex_state = 252},
  [6082] = {.lex_state = 248},
  [6083] = {.lex_state = 248},
  [6084] = {.lex_state = 252},
  [6085] = {.lex_state = 216},
  [6086] = {.lex_state = 248},
  [6087] = {.lex_state = 248},
  [6088] = {.lex_state = 249},
  [6089] = {.lex_state = 254},
  [6090] = {.lex_state = 235},
  [6091] = {.lex_state = 235},
  [6092] = {.lex_state = 248},
  [6093] = {.lex_state = 254},
  [6094] = {.lex_state = 254},
  [6095] = {.lex_state = 248},
  [6096] = {.lex_state = 248},
  [6097] = {.lex_state = 254},
  [6098] = {.lex_state = 216},
  [6099] = {.lex_state = 235},
  [6100] = {.lex_state = 216},
  [6101] = {.lex_state = 216},
  [6102] = {.lex_state = 248},
  [6103] = {.lex_state = 216},
  [6104] = {.lex_state = 235},
  [6105] = {.lex_state = 235},
  [6106] = {.lex_state = 254},
  [6107] = {.lex_state = 248},
  [6108] = {.lex_state = 235},
  [6109] = {.lex_state = 249},
  [6110] = {.lex_state = 252},
  [6111] = {.lex_state = 254},
  [6112] = {.lex_state = 252},
  [6113] = {.lex_state = 251},
  [6114] = {.lex_state = 249},
  [6115] = {.lex_state = 252},
  [6116] = {.lex_state = 249},
  [6117] = {.lex_state = 206},
  [6118] = {.lex_state = 254},
  [6119] = {.lex_state = 252},
  [6120] = {.lex_state = 254},
  [6121] = {.lex_state = 249},
  [6122] = {.lex_state = 206},
  [6123] = {.lex_state = 251},
  [6124] = {.lex_state = 249},
  [6125] = {.lex_state = 252},
  [6126] = {.lex_state = 252},
  [6127] = {.lex_state = 252},
  [6128] = {.lex_state = 249},
  [6129] = {.lex_state = 249},
  [6130] = {.lex_state = 216},
  [6131] = {.lex_state = 216},
  [6132] = {.lex_state = 249},
  [6133] = {.lex_state = 252},
  [6134] = {.lex_state = 251},
  [6135] = {.lex_state = 206},
  [6136] = {.lex_state = 251},
  [6137] = {.lex_state = 216},
  [6138] = {.lex_state = 252},
  [6139] = {.lex_state = 216},
  [6140] = {.lex_state = 249},
  [6141] = {.lex_state = 249},
  [6142] = {.lex_state = 216},
  [6143] = {.lex_state = 216},
  [6144] = {.lex_state = 252},
  [6145] = {.lex_state = 216},
  [6146] = {.lex_state = 249},
  [6147] = {.lex_state = 216},
  [6148] = {.lex_state = 206},
  [6149] = {.lex_state = 249},
  [6150] = {.lex_state = 252},
  [6151] = {.lex_state = 216},
  [6152] = {.lex_state = 216},
  [6153] = {.lex_state = 216},
  [6154] = {.lex_state = 216},
  [6155] = {.lex_state = 216},
  [6156] = {.lex_state = 251},
  [6157] = {.lex_state = 216},
  [6158] = {.lex_state = 252},
  [6159] = {.lex_state = 254},
  [6160] = {.lex_state = 216},
  [6161] = {.lex_state = 251},
  [6162] = {.lex_state = 251},
  [6163] = {.lex_state = 252},
  [6164] = {.lex_state = 252},
  [6165] = {.lex_state = 249},
  [6166] = {.lex_state = 249},
  [6167] = {.lex_state = 252},
  [6168] = {.lex_state = 249},
  [6169] = {.lex_state = 249},
  [6170] = {.lex_state = 249},
  [6171] = {.lex_state = 216},
  [6172] = {.lex_state = 252},
  [6173] = {.lex_state = 249},
  [6174] = {.lex_state = 249},
  [6175] = {.lex_state = 249},
  [6176] = {.lex_state = 252},
  [6177] = {.lex_state = 254},
  [6178] = {.lex_state = 251},
  [6179] = {.lex_state = 251},
  [6180] = {.lex_state = 252},
  [6181] = {.lex_state = 251},
  [6182] = {.lex_state = 216},
  [6183] = {.lex_state = 252},
  [6184] = {.lex_state = 252},
  [6185] = {.lex_state = 252},
  [6186] = {.lex_state = 251},
  [6187] = {.lex_state = 216},
  [6188] = {.lex_state = 252},
  [6189] = {.lex_state = 252},
  [6190] = {.lex_state = 251},
  [6191] = {.lex_state = 251},
  [6192] = {.lex_state = 251},
  [6193] = {.lex_state = 249},
  [6194] = {.lex_state = 249},
  [6195] = {.lex_state = 216},
  [6196] = {.lex_state = 252},
  [6197] = {.lex_state = 249},
  [6198] = {.lex_state = 249},
  [6199] = {.lex_state = 216},
  [6200] = {.lex_state = 252},
  [6201] = {.lex_state = 206},
  [6202] = {.lex_state = 206},
  [6203] = {.lex_state = 206},
  [6204] = {.lex_state = 206},
  [6205] = {.lex_state = 206},
  [6206] = {.lex_state = 206},
  [6207] = {.lex_state = 206},
  [6208] = {.lex_state = 206},
  [6209] = {.lex_state = 206},
  [6210] = {.lex_state = 206},
  [6211] = {.lex_state = 206},
  [6212] = {.lex_state = 206},
  [6213] = {.lex_state = 206},
  [6214] = {.lex_state = 206},
  [6215] = {.lex_state = 206},
  [6216] = {.lex_state = 206},
  [6217] = {.lex_state = 206},
  [6218] = {.lex_state = 249},
  [6219] = {.lex_state = 206},
  [6220] = {.lex_state = 206},
  [6221] = {.lex_state = 206},
  [6222] = {.lex_state = 206},
  [6223] = {.lex_state = 248},
  [6224] = {.lex_state = 206},
  [6225] = {.lex_state = 206},
  [6226] = {.lex_state = 206},
  [6227] = {.lex_state = 206},
  [6228] = {.lex_state = 206},
  [6229] = {.lex_state = 206},
  [6230] = {.lex_state = 206},
  [6231] = {.lex_state = 206},
  [6232] = {.lex_state = 206},
  [6233] = {.lex_state = 206},
  [6234] = {.lex_state = 206},
  [6235] = {.lex_state = 206},
  [6236] = {.lex_state = 206},
  [6237] = {.lex_state = 206},
  [6238] = {.lex_state = 206},
  [6239] = {.lex_state = 206},
  [6240] = {.lex_state = 206},
  [6241] = {.lex_state = 206},
  [6242] = {.lex_state = 206},
  [6243] = {.lex_state = 206},
  [6244] = {.lex_state = 206},
  [6245] = {.lex_state = 206},
  [6246] = {.lex_state = 206},
  [6247] = {.lex_state = 206},
  [6248] = {.lex_state = 248},
  [6249] = {.lex_state = 206},
  [6250] = {.lex_state = 206},
  [6251] = {.lex_state = 206},
  [6252] = {.lex_state = 206},
  [6253] = {.lex_state = 206},
  [6254] = {.lex_state = 206},
  [6255] = {.lex_state = 206},
  [6256] = {.lex_state = 206},
  [6257] = {.lex_state = 248},
  [6258] = {.lex_state = 206},
  [6259] = {.lex_state = 206},
  [6260] = {.lex_state = 206},
  [6261] = {.lex_state = 206},
  [6262] = {.lex_state = 206},
  [6263] = {.lex_state = 206},
  [6264] = {.lex_state = 206},
  [6265] = {.lex_state = 206},
  [6266] = {.lex_state = 206},
  [6267] = {.lex_state = 206},
  [6268] = {.lex_state = 248},
  [6269] = {.lex_state = 206},
  [6270] = {.lex_state = 206},
  [6271] = {.lex_state = 206},
  [6272] = {.lex_state = 206},
  [6273] = {.lex_state = 206},
  [6274] = {.lex_state = 206},
  [6275] = {.lex_state = 206},
  [6276] = {.lex_state = 206},
  [6277] = {.lex_state = 206},
  [6278] = {.lex_state = 206},
  [6279] = {.lex_state = 206},
  [6280] = {.lex_state = 235},
  [6281] = {.lex_state = 206},
  [6282] = {.lex_state = 206},
  [6283] = {.lex_state = 206},
  [6284] = {.lex_state = 206},
  [6285] = {.lex_state = 206},
  [6286] = {.lex_state = 206},
  [6287] = {.lex_state = 206},
  [6288] = {.lex_state = 254},
  [6289] = {.lex_state = 206},
  [6290] = {.lex_state = 254},
  [6291] = {.lex_state = 206},
  [6292] = {.lex_state = 206},
  [6293] = {.lex_state = 206},
  [6294] = {.lex_state = 206},
  [6295] = {.lex_state = 206},
  [6296] = {.lex_state = 206},
  [6297] = {.lex_state = 206},
  [6298] = {.lex_state = 206},
  [6299] = {.lex_state = 206},
  [6300] = {.lex_state = 206},
  [6301] = {.lex_state = 206},
  [6302] = {.lex_state = 206},
  [6303] = {.lex_state = 206},
  [6304] = {.lex_state = 206},
  [6305] = {.lex_state = 206},
  [6306] = {.lex_state = 206},
  [6307] = {.lex_state = 206},
  [6308] = {.lex_state = 206},
  [6309] = {.lex_state = 206},
  [6310] = {.lex_state = 206},
  [6311] = {.lex_state = 206},
  [6312] = {.lex_state = 206},
  [6313] = {.lex_state = 206},
  [6314] = {.lex_state = 206},
  [6315] = {.lex_state = 206},
  [6316] = {.lex_state = 206},
  [6317] = {.lex_state = 206},
  [6318] = {.lex_state = 206},
  [6319] = {.lex_state = 206},
  [6320] = {.lex_state = 206},
  [6321] = {.lex_state = 206},
  [6322] = {.lex_state = 206},
  [6323] = {.lex_state = 206},
  [6324] = {.lex_state = 206},
  [6325] = {.lex_state = 206},
  [6326] = {.lex_state = 206},
  [6327] = {.lex_state = 206},
  [6328] = {.lex_state = 206},
  [6329] = {.lex_state = 206},
  [6330] = {.lex_state = 206},
  [6331] = {.lex_state = 206},
  [6332] = {.lex_state = 206},
  [6333] = {.lex_state = 235},
  [6334] = {.lex_state = 206},
  [6335] = {.lex_state = 254},
  [6336] = {.lex_state = 206},
  [6337] = {.lex_state = 206},
  [6338] = {.lex_state = 206},
  [6339] = {.lex_state = 206},
  [6340] = {.lex_state = 206},
  [6341] = {.lex_state = 206},
  [6342] = {.lex_state = 206},
  [6343] = {.lex_state = 206},
  [6344] = {.lex_state = 206},
  [6345] = {.lex_state = 206},
  [6346] = {.lex_state = 206},
  [6347] = {.lex_state = 206},
  [6348] = {.lex_state = 206},
  [6349] = {.lex_state = 206},
  [6350] = {.lex_state = 251},
  [6351] = {.lex_state = 251},
  [6352] = {.lex_state = 254},
  [6353] = {.lex_state = 251},
  [6354] = {.lex_state = 252},
  [6355] = {.lex_state = 251},
  [6356] = {.lex_state = 251},
  [6357] = {.lex_state = 251},
  [6358] = {.lex_state = 251},
  [6359] = {.lex_state = 252},
  [6360] = {.lex_state = 206},
  [6361] = {.lex_state = 251},
  [6362] = {.lex_state = 251},
  [6363] = {.lex_state = 254},
  [6364] = {.lex_state = 251},
  [6365] = {.lex_state = 251},
  [6366] = {.lex_state = 252},
  [6367] = {.lex_state = 206},
  [6368] = {.lex_state = 254},
  [6369] = {.lex_state = 254},
  [6370] = {.lex_state = 206},
  [6371] = {.lex_state = 251},
  [6372] = {.lex_state = 206},
  [6373] = {.lex_state = 206},
  [6374] = {.lex_state = 254},
  [6375] = {.lex_state = 254},
  [6376] = {.lex_state = 252},
  [6377] = {.lex_state = 206},
  [6378] = {.lex_state = 251},
  [6379] = {.lex_state = 206},
  [6380] = {.lex_state = 252},
  [6381] = {.lex_state = 206},
  [6382] = {.lex_state = 206},
  [6383] = {.lex_state = 254},
  [6384] = {.lex_state = 251},
  [6385] = {.lex_state = 251},
  [6386] = {.lex_state = 251},
  [6387] = {.lex_state = 251},
  [6388] = {.lex_state = 251},
  [6389] = {.lex_state = 251},
  [6390] = {.lex_state = 251},
  [6391] = {.lex_state = 206},
  [6392] = {.lex_state = 254},
  [6393] = {.lex_state = 251},
  [6394] = {.lex_state = 251},
  [6395] = {.lex_state = 252},
  [6396] = {.lex_state = 251},
  [6397] = {.lex_state = 251},
  [6398] = {.lex_state = 254},
  [6399] = {.lex_state = 249},
  [6400] = {.lex_state = 251},
  [6401] = {.lex_state = 206},
  [6402] = {.lex_state = 251},
  [6403] = {.lex_state = 206},
  [6404] = {.lex_state = 251},
  [6405] = {.lex_state = 254},
  [6406] = {.lex_state = 254},
  [6407] = {.lex_state = 216},
  [6408] = {.lex_state = 206},
  [6409] = {.lex_state = 254},
  [6410] = {.lex_state = 254},
  [6411] = {.lex_state = 251},
  [6412] = {.lex_state = 251},
  [6413] = {.lex_state = 251},
  [6414] = {.lex_state = 254},
  [6415] = {.lex_state = 254},
  [6416] = {.lex_state = 206},
  [6417] = {.lex_state = 252},
  [6418] = {.lex_state = 251},
  [6419] = {.lex_state = 252},
  [6420] = {.lex_state = 251},
  [6421] = {.lex_state = 254},
  [6422] = {.lex_state = 252},
  [6423] = {.lex_state = 254},
  [6424] = {.lex_state = 251},
  [6425] = {.lex_state = 252},
  [6426] = {.lex_state = 251},
  [6427] = {.lex_state = 254},
  [6428] = {.lex_state = 251},
  [6429] = {.lex_state = 206},
  [6430] = {.lex_state = 206},
  [6431] = {.lex_state = 251},
  [6432] = {.lex_state = 206},
  [6433] = {.lex_state = 254},
  [6434] = {.lex_state = 206},
  [6435] = {.lex_state = 252},
  [6436] = {.lex_state = 254},
  [6437] = {.lex_state = 206},
  [6438] = {.lex_state = 254},
  [6439] = {.lex_state = 252},
  [6440] = {.lex_state = 254},
  [6441] = {.lex_state = 206},
  [6442] = {.lex_state = 254},
  [6443] = {.lex_state = 254},
  [6444] = {.lex_state = 254},
  [6445] = {.lex_state = 216},
  [6446] = {.lex_state = 251},
  [6447] = {.lex_state = 251},
  [6448] = {.lex_state = 254},
  [6449] = {.lex_state = 206},
  [6450] = {.lex_state = 254},
  [6451] = {.lex_state = 206},
  [6452] = {.lex_state = 251},
  [6453] = {.lex_state = 249},
  [6454] = {.lex_state = 251},
  [6455] = {.lex_state = 249},
  [6456] = {.lex_state = 248},
  [6457] = {.lex_state = 248},
  [6458] = {.lex_state = 249},
  [6459] = {.lex_state = 248},
  [6460] = {.lex_state = 248},
  [6461] = {.lex_state = 248},
  [6462] = {.lex_state = 248},
  [6463] = {.lex_state = 206},
  [6464] = {.lex_state = 252},
  [6465] = {.lex_state = 252},
  [6466] = {.lex_state = 252},
  [6467] = {.lex_state = 252},
  [6468] = {.lex_state = 252},
  [6469] = {.lex_state = 206},
  [6470] = {.lex_state = 206},
  [6471] = {.lex_state = 206},
  [6472] = {.lex_state = 206},
  [6473] = {.lex_state = 252},
  [6474] = {.lex_state = 206},
  [6475] = {.lex_state = 252},
  [6476] = {.lex_state = 252},
  [6477] = {.lex_state = 252},
  [6478] = {.lex_state = 254},
  [6479] = {.lex_state = 248},
  [6480] = {.lex_state = 252},
  [6481] = {.lex_state = 252},
  [6482] = {.lex_state = 252},
  [6483] = {.lex_state = 252},
  [6484] = {.lex_state = 252},
  [6485] = {.lex_state = 252},
  [6486] = {.lex_state = 249},
  [6487] = {.lex_state = 252},
  [6488] = {.lex_state = 249},
  [6489] = {.lex_state = 249},
  [6490] = {.lex_state = 252},
  [6491] = {.lex_state = 252},
  [6492] = {.lex_state = 249},
  [6493] = {.lex_state = 252},
  [6494] = {.lex_state = 206},
  [6495] = {.lex_state = 263},
  [6496] = {.lex_state = 248},
  [6497] = {.lex_state = 206},
  [6498] = {.lex_state = 206},
  [6499] = {.lex_state = 248},
  [6500] = {.lex_state = 206},
  [6501] = {.lex_state = 263},
  [6502] = {.lex_state = 263},
  [6503] = {.lex_state = 263},
  [6504] = {.lex_state = 248},
  [6505] = {.lex_state = 206},
  [6506] = {.lex_state = 206},
  [6507] = {.lex_state = 263},
  [6508] = {.lex_state = 206},
  [6509] = {.lex_state = 206},
  [6510] = {.lex_state = 263},
  [6511] = {.lex_state = 206},
  [6512] = {.lex_state = 206},
  [6513] = {.lex_state = 206},
  [6514] = {.lex_state = 248},
  [6515] = {.lex_state = 252},
  [6516] = {.lex_state = 263},
  [6517] = {.lex_state = 248},
  [6518] = {.lex_state = 248},
  [6519] = {.lex_state = 206},
  [6520] = {.lex_state = 252},
  [6521] = {.lex_state = 235},
  [6522] = {.lex_state = 252},
  [6523] = {.lex_state = 252},
  [6524] = {.lex_state = 252},
  [6525] = {.lex_state = 252},
  [6526] = {.lex_state = 252},
  [6527] = {.lex_state = 263},
  [6528] = {.lex_state = 263},
  [6529] = {.lex_state = 263},
  [6530] = {.lex_state = 263},
  [6531] = {.lex_state = 263},
  [6532] = {.lex_state = 263},
  [6533] = {.lex_state = 263},
  [6534] = {.lex_state = 252},
  [6535] = {.lex_state = 252},
  [6536] = {.lex_state = 252},
  [6537] = {.lex_state = 263},
  [6538] = {.lex_state = 263},
  [6539] = {.lex_state = 254},
  [6540] = {.lex_state = 263},
  [6541] = {.lex_state = 235},
  [6542] = {.lex_state = 263},
  [6543] = {.lex_state = 263},
  [6544] = {.lex_state = 254},
  [6545] = {.lex_state = 252},
  [6546] = {.lex_state = 254},
  [6547] = {.lex_state = 263},
  [6548] = {.lex_state = 252},
  [6549] = {.lex_state = 254},
  [6550] = {.lex_state = 263},
  [6551] = {.lex_state = 205},
  [6552] = {.lex_state = 254},
  [6553] = {.lex_state = 263},
  [6554] = {.lex_state = 235},
  [6555] = {.lex_state = 251},
  [6556] = {.lex_state = 263},
  [6557] = {.lex_state = 263},
  [6558] = {.lex_state = 235},
  [6559] = {.lex_state = 263},
  [6560] = {.lex_state = 263},
  [6561] = {.lex_state = 263},
  [6562] = {.lex_state = 263},
  [6563] = {.lex_state = 252},
  [6564] = {.lex_state = 263},
  [6565] = {.lex_state = 263},
  [6566] = {.lex_state = 252},
  [6567] = {.lex_state = 252},
  [6568] = {.lex_state = 263},
  [6569] = {.lex_state = 263},
  [6570] = {.lex_state = 252},
  [6571] = {.lex_state = 254},
  [6572] = {.lex_state = 235},
  [6573] = {.lex_state = 254},
  [6574] = {.lex_state = 254},
  [6575] = {.lex_state = 254},
  [6576] = {.lex_state = 263},
  [6577] = {.lex_state = 252},
  [6578] = {.lex_state = 235},
  [6579] = {.lex_state = 263},
  [6580] = {.lex_state = 263},
  [6581] = {.lex_state = 263},
  [6582] = {.lex_state = 263},
  [6583] = {.lex_state = 263},
  [6584] = {.lex_state = 263},
  [6585] = {.lex_state = 263},
  [6586] = {.lex_state = 263},
  [6587] = {.lex_state = 263},
  [6588] = {.lex_state = 263},
  [6589] = {.lex_state = 263},
  [6590] = {.lex_state = 263},
  [6591] = {.lex_state = 263},
  [6592] = {.lex_state = 263},
  [6593] = {.lex_state = 263},
  [6594] = {.lex_state = 188},
  [6595] = {.lex_state = 206},
  [6596] = {.lex_state = 206},
  [6597] = {.lex_state = 252},
  [6598] = {.lex_state = 206},
  [6599] = {.lex_state = 206},
  [6600] = {.lex_state = 206},
  [6601] = {.lex_state = 206},
  [6602] = {.lex_state = 206},
  [6603] = {.lex_state = 206},
  [6604] = {.lex_state = 206},
  [6605] = {.lex_state = 252},
  [6606] = {.lex_state = 252},
  [6607] = {.lex_state = 206},
  [6608] = {.lex_state = 206},
  [6609] = {.lex_state = 206},
  [6610] = {.lex_state = 206},
  [6611] = {.lex_state = 206},
  [6612] = {.lex_state = 252},
  [6613] = {.lex_state = 252},
  [6614] = {.lex_state = 206},
  [6615] = {.lex_state = 206},
  [6616] = {.lex_state = 206},
  [6617] = {.lex_state = 252},
  [6618] = {.lex_state = 206},
  [6619] = {.lex_state = 206},
  [6620] = {.lex_state = 206},
  [6621] = {.lex_state = 206},
  [6622] = {.lex_state = 206},
  [6623] = {.lex_state = 206},
  [6624] = {.lex_state = 206},
  [6625] = {.lex_state = 206},
  [6626] = {.lex_state = 206},
  [6627] = {.lex_state = 206},
  [6628] = {.lex_state = 206},
  [6629] = {.lex_state = 206},
  [6630] = {.lex_state = 206},
  [6631] = {.lex_state = 252},
  [6632] = {.lex_state = 206},
  [6633] = {.lex_state = 206},
  [6634] = {.lex_state = 206},
  [6635] = {.lex_state = 206},
  [6636] = {.lex_state = 206},
  [6637] = {.lex_state = 206},
  [6638] = {.lex_state = 206},
  [6639] = {.lex_state = 206},
  [6640] = {.lex_state = 252},
  [6641] = {.lex_state = 206},
  [6642] = {.lex_state = 252},
  [6643] = {.lex_state = 235},
  [6644] = {.lex_state = 206},
  [6645] = {.lex_state = 188},
  [6646] = {.lex_state = 206},
  [6647] = {.lex_state = 206},
  [6648] = {.lex_state = 206},
  [6649] = {.lex_state = 206},
  [6650] = {.lex_state = 205},
  [6651] = {.lex_state = 206},
  [6652] = {.lex_state = 206},
  [6653] = {.lex_state = 206},
  [6654] = {.lex_state = 206},
  [6655] = {.lex_state = 206},
  [6656] = {.lex_state = 206},
  [6657] = {.lex_state = 206},
  [6658] = {.lex_state = 252},
  [6659] = {.lex_state = 206},
  [6660] = {.lex_state = 103},
  [6661] = {.lex_state = 206},
  [6662] = {.lex_state = 206},
  [6663] = {.lex_state = 206},
  [6664] = {.lex_state = 206},
  [6665] = {.lex_state = 206},
  [6666] = {.lex_state = 252},
  [6667] = {.lex_state = 206},
  [6668] = {.lex_state = 206},
  [6669] = {.lex_state = 206},
  [6670] = {.lex_state = 206},
  [6671] = {.lex_state = 206},
  [6672] = {.lex_state = 252},
  [6673] = {.lex_state = 206},
  [6674] = {.lex_state = 205},
  [6675] = {.lex_state = 206},
  [6676] = {.lex_state = 252},
  [6677] = {.lex_state = 206},
  [6678] = {.lex_state = 206},
  [6679] = {.lex_state = 206},
  [6680] = {.lex_state = 252},
  [6681] = {.lex_state = 206},
  [6682] = {.lex_state = 206},
  [6683] = {.lex_state = 206},
  [6684] = {.lex_state = 206},
  [6685] = {.lex_state = 206},
  [6686] = {.lex_state = 206},
  [6687] = {.lex_state = 206},
  [6688] = {.lex_state = 206},
  [6689] = {.lex_state = 254},
  [6690] = {.lex_state = 206},
  [6691] = {.lex_state = 252},
  [6692] = {.lex_state = 206},
  [6693] = {.lex_state = 206},
  [6694] = {.lex_state = 252},
  [6695] = {.lex_state = 206},
  [6696] = {.lex_state = 206},
  [6697] = {.lex_state = 188},
  [6698] = {.lex_state = 206},
  [6699] = {.lex_state = 252},
  [6700] = {.lex_state = 206},
  [6701] = {.lex_state = 216},
  [6702] = {.lex_state = 206},
  [6703] = {.lex_state = 206},
  [6704] = {.lex_state = 206},
  [6705] = {.lex_state = 206},
  [6706] = {.lex_state = 206},
  [6707] = {.lex_state = 206},
  [6708] = {.lex_state = 206},
  [6709] = {.lex_state = 206},
  [6710] = {.lex_state = 206},
  [6711] = {.lex_state = 206},
  [6712] = {.lex_state = 206},
  [6713] = {.lex_state = 206},
  [6714] = {.lex_state = 206},
  [6715] = {.lex_state = 206},
  [6716] = {.lex_state = 206},
  [6717] = {.lex_state = 206},
  [6718] = {.lex_state = 206},
  [6719] = {.lex_state = 205},
  [6720] = {.lex_state = 206},
  [6721] = {.lex_state = 206},
  [6722] = {.lex_state = 206},
  [6723] = {.lex_state = 206},
  [6724] = {.lex_state = 206},
  [6725] = {.lex_state = 206},
  [6726] = {.lex_state = 206},
  [6727] = {.lex_state = 252},
  [6728] = {.lex_state = 206},
  [6729] = {.lex_state = 206},
  [6730] = {.lex_state = 252},
  [6731] = {.lex_state = 206},
  [6732] = {.lex_state = 206},
  [6733] = {.lex_state = 252},
  [6734] = {.lex_state = 235},
  [6735] = {.lex_state = 216},
  [6736] = {.lex_state = 252},
  [6737] = {.lex_state = 252},
  [6738] = {.lex_state = 252},
  [6739] = {.lex_state = 188},
  [6740] = {.lex_state = 252},
  [6741] = {.lex_state = 252},
  [6742] = {.lex_state = 249},
  [6743] = {.lex_state = 188},
  [6744] = {.lex_state = 188},
  [6745] = {.lex_state = 188},
  [6746] = {.lex_state = 188},
  [6747] = {.lex_state = 188},
  [6748] = {.lex_state = 188},
  [6749] = {.lex_state = 252},
  [6750] = {.lex_state = 188},
  [6751] = {.lex_state = 188},
  [6752] = {.lex_state = 188},
  [6753] = {.lex_state = 252},
  [6754] = {.lex_state = 249},
  [6755] = {.lex_state = 188},
  [6756] = {.lex_state = 249},
  [6757] = {.lex_state = 188},
  [6758] = {.lex_state = 205},
  [6759] = {.lex_state = 205},
  [6760] = {.lex_state = 249},
  [6761] = {.lex_state = 249},
  [6762] = {.lex_state = 249},
  [6763] = {.lex_state = 249},
  [6764] = {.lex_state = 235},
  [6765] = {.lex_state = 235},
  [6766] = {.lex_state = 188},
  [6767] = {.lex_state = 252},
  [6768] = {.lex_state = 188},
  [6769] = {.lex_state = 252},
  [6770] = {.lex_state = 249},
  [6771] = {.lex_state = 252},
  [6772] = {.lex_state = 205},
  [6773] = {.lex_state = 235},
  [6774] = {.lex_state = 188},
  [6775] = {.lex_state = 188},
  [6776] = {.lex_state = 188},
  [6777] = {.lex_state = 252},
  [6778] = {.lex_state = 235},
  [6779] = {.lex_state = 252},
  [6780] = {.lex_state = 188},
  [6781] = {.lex_state = 188},
  [6782] = {.lex_state = 249},
  [6783] = {.lex_state = 248},
  [6784] = {.lex_state = 252},
  [6785] = {.lex_state = 188},
  [6786] = {.lex_state = 235},
  [6787] = {.lex_state = 248},
  [6788] = {.lex_state = 252},
  [6789] = {.lex_state = 205},
  [6790] = {.lex_state = 188},
  [6791] = {.lex_state = 188},
  [6792] = {.lex_state = 252},
  [6793] = {.lex_state = 249},
  [6794] = {.lex_state = 205},
  [6795] = {.lex_state = 249},
  [6796] = {.lex_state = 235},
  [6797] = {.lex_state = 188},
  [6798] = {.lex_state = 188},
  [6799] = {.lex_state = 252},
  [6800] = {.lex_state = 252},
  [6801] = {.lex_state = 249},
  [6802] = {.lex_state = 252},
  [6803] = {.lex_state = 252},
  [6804] = {.lex_state = 252},
  [6805] = {.lex_state = 188},
  [6806] = {.lex_state = 252},
  [6807] = {.lex_state = 252},
  [6808] = {.lex_state = 252},
  [6809] = {.lex_state = 205},
  [6810] = {.lex_state = 252},
  [6811] = {.lex_state = 235},
  [6812] = {.lex_state = 249},
  [6813] = {.lex_state = 188},
  [6814] = {.lex_state = 188},
  [6815] = {.lex_state = 252},
  [6816] = {.lex_state = 249},
  [6817] = {.lex_state = 254},
  [6818] = {.lex_state = 188},
  [6819] = {.lex_state = 188},
  [6820] = {.lex_state = 249},
  [6821] = {.lex_state = 235},
  [6822] = {.lex_state = 254},
  [6823] = {.lex_state = 254},
  [6824] = {.lex_state = 188},
  [6825] = {.lex_state = 254},
  [6826] = {.lex_state = 188},
  [6827] = {.lex_state = 188},
  [6828] = {.lex_state = 254},
  [6829] = {.lex_state = 235},
  [6830] = {.lex_state = 235},
  [6831] = {.lex_state = 205},
  [6832] = {.lex_state = 188},
  [6833] = {.lex_state = 188},
  [6834] = {.lex_state = 188},
  [6835] = {.lex_state = 254},
  [6836] = {.lex_state = 254},
  [6837] = {.lex_state = 235},
  [6838] = {.lex_state = 254},
  [6839] = {.lex_state = 254},
  [6840] = {.lex_state = 188},
  [6841] = {.lex_state = 254},
  [6842] = {.lex_state = 254},
  [6843] = {.lex_state = 254},
  [6844] = {.lex_state = 252},
  [6845] = {.lex_state = 188},
  [6846] = {.lex_state = 254},
  [6847] = {.lex_state = 252},
  [6848] = {.lex_state = 254},
  [6849] = {.lex_state = 254},
  [6850] = {.lex_state = 254},
  [6851] = {.lex_state = 235},
  [6852] = {.lex_state = 254},
  [6853] = {.lex_state = 254},
  [6854] = {.lex_state = 254},
  [6855] = {.lex_state = 252},
  [6856] = {.lex_state = 205},
  [6857] = {.lex_state = 205},
  [6858] = {.lex_state = 254},
  [6859] = {.lex_state = 252},
  [6860] = {.lex_state = 235},
  [6861] = {.lex_state = 254},
  [6862] = {.lex_state = 254},
  [6863] = {.lex_state = 205},
  [6864] = {.lex_state = 252},
  [6865] = {.lex_state = 205},
  [6866] = {.lex_state = 254},
  [6867] = {.lex_state = 235},
  [6868] = {.lex_state = 254},
  [6869] = {.lex_state = 252},
  [6870] = {.lex_state = 254},
  [6871] = {.lex_state = 249},
  [6872] = {.lex_state = 252},
  [6873] = {.lex_state = 254},
  [6874] = {.lex_state = 205},
  [6875] = {.lex_state = 249},
  [6876] = {.lex_state = 205},
  [6877] = {.lex_state = 249},
  [6878] = {.lex_state = 205},
  [6879] = {.lex_state = 235},
  [6880] = {.lex_state = 252},
  [6881] = {.lex_state = 235},
  [6882] = {.lex_state = 188},
  [6883] = {.lex_state = 252},
  [6884] = {.lex_state = 254},
  [6885] = {.lex_state = 188},
  [6886] = {.lex_state = 254},
  [6887] = {.lex_state = 252},
  [6888] = {.lex_state = 252},
  [6889] = {.lex_state = 205},
  [6890] = {.lex_state = 205},
  [6891] = {.lex_state = 205},
  [6892] = {.lex_state = 205},
  [6893] = {.lex_state = 205},
  [6894] = {.lex_state = 205},
  [6895] = {.lex_state = 252},
  [6896] = {.lex_state = 254},
  [6897] = {.lex_state = 103},
  [6898] = {.lex_state = 249},
  [6899] = {.lex_state = 206},
  [6900] = {.lex_state = 103},
  [6901] = {.lex_state = 235},
  [6902] = {.lex_state = 235},
  [6903] = {.lex_state = 252},
  [6904] = {.lex_state = 103},
  [6905] = {.lex_state = 206},
  [6906] = {.lex_state = 252},
  [6907] = {.lex_state = 205},
  [6908] = {.lex_state = 103},
  [6909] = {.lex_state = 103},
  [6910] = {.lex_state = 251},
  [6911] = {.lex_state = 252},
  [6912] = {.lex_state = 103},
  [6913] = {.lex_state = 252},
  [6914] = {.lex_state = 249},
  [6915] = {.lex_state = 252},
  [6916] = {.lex_state = 103},
  [6917] = {.lex_state = 249},
  [6918] = {.lex_state = 103},
  [6919] = {.lex_state = 249},
  [6920] = {.lex_state = 103},
  [6921] = {.lex_state = 103},
  [6922] = {.lex_state = 103},
  [6923] = {.lex_state = 103},
  [6924] = {.lex_state = 249},
  [6925] = {.lex_state = 205},
  [6926] = {.lex_state = 235},
  [6927] = {.lex_state = 249},
  [6928] = {.lex_state = 103},
  [6929] = {.lex_state = 103},
  [6930] = {.lex_state = 103},
  [6931] = {.lex_state = 103},
  [6932] = {.lex_state = 206},
  [6933] = {.lex_state = 206},
  [6934] = {.lex_state = 103},
  [6935] = {.lex_state = 252},
  [6936] = {.lex_state = 249},
  [6937] = {.lex_state = 103},
  [6938] = {.lex_state = 206},
  [6939] = {.lex_state = 103},
  [6940] = {.lex_state = 252},
  [6941] = {.lex_state = 249},
  [6942] = {.lex_state = 252},
  [6943] = {.lex_state = 103},
  [6944] = {.lex_state = 103},
  [6945] = {.lex_state = 103},
  [6946] = {.lex_state = 252},
  [6947] = {.lex_state = 249},
  [6948] = {.lex_state = 216},
  [6949] = {.lex_state = 103},
  [6950] = {.lex_state = 103},
  [6951] = {.lex_state = 252},
  [6952] = {.lex_state = 235},
  [6953] = {.lex_state = 103},
  [6954] = {.lex_state = 235},
  [6955] = {.lex_state = 103},
  [6956] = {.lex_state = 254},
  [6957] = {.lex_state = 103},
  [6958] = {.lex_state = 103},
  [6959] = {.lex_state = 252},
  [6960] = {.lex_state = 103},
  [6961] = {.lex_state = 235},
  [6962] = {.lex_state = 103},
  [6963] = {.lex_state = 249},
  [6964] = {.lex_state = 103},
  [6965] = {.lex_state = 103},
  [6966] = {.lex_state = 252},
  [6967] = {.lex_state = 249},
  [6968] = {.lex_state = 249},
  [6969] = {.lex_state = 103},
  [6970] = {.lex_state = 249},
  [6971] = {.lex_state = 206},
  [6972] = {.lex_state = 252},
  [6973] = {.lex_state = 254},
  [6974] = {.lex_state = 252},
  [6975] = {.lex_state = 206},
  [6976] = {.lex_state = 251},
  [6977] = {.lex_state = 252},
  [6978] = {.lex_state = 252},
  [6979] = {.lex_state = 251},
  [6980] = {.lex_state = 254},
  [6981] = {.lex_state = 252},
  [6982] = {.lex_state = 248},
  [6983] = {.lex_state = 251},
  [6984] = {.lex_state = 252},
  [6985] = {.lex_state = 257},
  [6986] = {.lex_state = 251},
  [6987] = {.lex_state = 258},
  [6988] = {.lex_state = 252},
  [6989] = {.lex_state = 251},
  [6990] = {.lex_state = 206},
  [6991] = {.lex_state = 206},
  [6992] = {.lex_state = 252},
  [6993] = {.lex_state = 251},
  [6994] = {.lex_state = 252},
  [6995] = {.lex_state = 248},
  [6996] = {.lex_state = 257},
  [6997] = {.lex_state = 252},
  [6998] = {.lex_state = 252},
  [6999] = {.lex_state = 251},
  [7000] = {.lex_state = 258},
  [7001] = {.lex_state = 248},
  [7002] = {.lex_state = 252},
  [7003] = {.lex_state = 206},
  [7004] = {.lex_state = 258},
  [7005] = {.lex_state = 257},
  [7006] = {.lex_state = 251},
  [7007] = {.lex_state = 251},
  [7008] = {.lex_state = 252},
  [7009] = {.lex_state = 216},
  [7010] = {.lex_state = 252},
  [7011] = {.lex_state = 254},
  [7012] = {.lex_state = 252},
  [7013] = {.lex_state = 185},
  [7014] = {.lex_state = 206},
  [7015] = {.lex_state = 244},
  [7016] = {.lex_state = 207},
  [7017] = {.lex_state = 206},
  [7018] = {.lex_state = 235},
  [7019] = {.lex_state = 216},
  [7020] = {.lex_state = 244},
  [7021] = {.lex_state = 252},
  [7022] = {.lex_state = 244},
  [7023] = {.lex_state = 252},
  [7024] = {.lex_state = 216},
  [7025] = {.lex_state = 258},
  [7026] = {.lex_state = 185},
  [7027] = {.lex_state = 216},
  [7028] = {.lex_state = 216},
  [7029] = {.lex_state = 185},
  [7030] = {.lex_state = 252},
  [7031] = {.lex_state = 252},
  [7032] = {.lex_state = 252},
  [7033] = {.lex_state = 252},
  [7034] = {.lex_state = 185},
  [7035] = {.lex_state = 254},
  [7036] = {.lex_state = 252},
  [7037] = {.lex_state = 216},
  [7038] = {.lex_state = 207},
  [7039] = {.lex_state = 206},
  [7040] = {.lex_state = 252},
  [7041] = {.lex_state = 216},
  [7042] = {.lex_state = 252},
  [7043] = {.lex_state = 216},
  [7044] = {.lex_state = 185},
  [7045] = {.lex_state = 207},
  [7046] = {.lex_state = 254},
  [7047] = {.lex_state = 254},
  [7048] = {.lex_state = 207},
  [7049] = {.lex_state = 244},
  [7050] = {.lex_state = 185},
  [7051] = {.lex_state = 206},
  [7052] = {.lex_state = 185},
  [7053] = {.lex_state = 207},
  [7054] = {.lex_state = 207},
  [7055] = {.lex_state = 257},
  [7056] = {.lex_state = 254},
  [7057] = {.lex_state = 216},
  [7058] = {.lex_state = 254},
  [7059] = {.lex_state = 254},
  [7060] = {.lex_state = 206},
  [7061] = {.lex_state = 235},
  [7062] = {.lex_state = 185},
  [7063] = {.lex_state = 254},
  [7064] = {.lex_state = 216},
  [7065] = {.lex_state = 254},
  [7066] = {.lex_state = 185},
  [7067] = {.lex_state = 235},
  [7068] = {.lex_state = 207},
  [7069] = {.lex_state = 216},
  [7070] = {.lex_state = 185},
  [7071] = {.lex_state = 254},
  [7072] = {.lex_state = 254},
  [7073] = {.lex_state = 254},
  [7074] = {.lex_state = 254},
  [7075] = {.lex_state = 252},
  [7076] = {.lex_state = 185},
  [7077] = {.lex_state = 254},
  [7078] = {.lex_state = 254},
  [7079] = {.lex_state = 254},
  [7080] = {.lex_state = 254},
  [7081] = {.lex_state = 254},
  [7082] = {.lex_state = 216},
  [7083] = {.lex_state = 206},
  [7084] = {.lex_state = 235},
  [7085] = {.lex_state = 207},
  [7086] = {.lex_state = 249},
  [7087] = {.lex_state = 249},
  [7088] = {.lex_state = 254},
  [7089] = {.lex_state = 252},
  [7090] = {.lex_state = 252},
  [7091] = {.lex_state = 252},
  [7092] = {.lex_state = 254},
  [7093] = {.lex_state = 209},
  [7094] = {.lex_state = 249},
  [7095] = {.lex_state = 227},
  [7096] = {.lex_state = 249},
  [7097] = {.lex_state = 252},
  [7098] = {.lex_state = 249},
  [7099] = {.lex_state = 249},
  [7100] = {.lex_state = 252},
  [7101] = {.lex_state = 252},
  [7102] = {.lex_state = 249},
  [7103] = {.lex_state = 254},
  [7104] = {.lex_state = 254},
  [7105] = {.lex_state = 254},
  [7106] = {.lex_state = 254},
  [7107] = {.lex_state = 254},
  [7108] = {.lex_state = 254},
  [7109] = {.lex_state = 254},
  [7110] = {.lex_state = 251},
  [7111] = {.lex_state = 252},
  [7112] = {.lex_state = 251},
  [7113] = {.lex_state = 249},
  [7114] = {.lex_state = 254},
  [7115] = {.lex_state = 206},
  [7116] = {.lex_state = 252},
  [7117] = {.lex_state = 254},
  [7118] = {.lex_state = 206},
  [7119] = {.lex_state = 249},
  [7120] = {.lex_state = 254},
  [7121] = {.lex_state = 251},
  [7122] = {.lex_state = 249},
  [7123] = {.lex_state = 249},
  [7124] = {.lex_state = 206},
  [7125] = {.lex_state = 252},
  [7126] = {.lex_state = 252},
  [7127] = {.lex_state = 254},
  [7128] = {.lex_state = 254},
  [7129] = {.lex_state = 249},
  [7130] = {.lex_state = 249},
  [7131] = {.lex_state = 227},
  [7132] = {.lex_state = 227},
  [7133] = {.lex_state = 254},
  [7134] = {.lex_state = 227},
  [7135] = {.lex_state = 254},
  [7136] = {.lex_state = 254},
  [7137] = {.lex_state = 252},
  [7138] = {.lex_state = 252},
  [7139] = {.lex_state = 252},
  [7140] = {.lex_state = 254},
  [7141] = {.lex_state = 251},
  [7142] = {.lex_state = 254},
  [7143] = {.lex_state = 227},
  [7144] = {.lex_state = 252},
  [7145] = {.lex_state = 252},
  [7146] = {.lex_state = 254},
  [7147] = {.lex_state = 249},
  [7148] = {.lex_state = 254},
  [7149] = {.lex_state = 251},
  [7150] = {.lex_state = 252},
  [7151] = {.lex_state = 252},
  [7152] = {.lex_state = 252},
  [7153] = {.lex_state = 254},
  [7154] = {.lex_state = 252},
  [7155] = {.lex_state = 251},
  [7156] = {.lex_state = 251},
  [7157] = {.lex_state = 252},
  [7158] = {.lex_state = 249},
  [7159] = {.lex_state = 249},
  [7160] = {.lex_state = 227},
  [7161] = {.lex_state = 252},
  [7162] = {.lex_state = 227},
  [7163] = {.lex_state = 227},
  [7164] = {.lex_state = 209},
  [7165] = {.lex_state = 254},
  [7166] = {.lex_state = 252},
  [7167] = {.lex_state = 254},
  [7168] = {.lex_state = 254},
  [7169] = {.lex_state = 252},
  [7170] = {.lex_state = 252},
  [7171] = {.lex_state = 252},
  [7172] = {.lex_state = 252},
  [7173] = {.lex_state = 251},
  [7174] = {.lex_state = 206},
  [7175] = {.lex_state = 252},
  [7176] = {.lex_state = 251},
  [7177] = {.lex_state = 209},
  [7178] = {.lex_state = 203},
  [7179] = {.lex_state = 254},
  [7180] = {.lex_state = 254},
  [7181] = {.lex_state = 252},
  [7182] = {.lex_state = 254},
  [7183] = {.lex_state = 252},
  [7184] = {.lex_state = 254},
  [7185] = {.lex_state = 249},
  [7186] = {.lex_state = 254},
  [7187] = {.lex_state = 252},
  [7188] = {.lex_state = 254},
  [7189] = {.lex_state = 254},
  [7190] = {.lex_state = 206},
  [7191] = {.lex_state = 254},
  [7192] = {.lex_state = 252},
  [7193] = {.lex_state = 252},
  [7194] = {.lex_state = 206},
  [7195] = {.lex_state = 252},
  [7196] = {.lex_state = 254},
  [7197] = {.lex_state = 252},
  [7198] = {.lex_state = 206},
  [7199] = {.lex_state = 254},
  [7200] = {.lex_state = 252},
  [7201] = {.lex_state = 351},
  [7202] = {.lex_state = 254},
  [7203] = {.lex_state = 252},
  [7204] = {.lex_state = 252},
  [7205] = {.lex_state = 254},
  [7206] = {.lex_state = 215},
  [7207] = {.lex_state = 252},
  [7208] = {.lex_state = 254},
  [7209] = {.lex_state = 252},
  [7210] = {.lex_state = 252},
  [7211] = {.lex_state = 251},
  [7212] = {.lex_state = 252},
  [7213] = {.lex_state = 252},
  [7214] = {.lex_state = 249},
  [7215] = {.lex_state = 252},
  [7216] = {.lex_state = 252},
  [7217] = {.lex_state = 252},
  [7218] = {.lex_state = 252},
  [7219] = {.lex_state = 206},
  [7220] = {.lex_state = 252},
  [7221] = {.lex_state = 252},
  [7222] = {.lex_state = 249},
  [7223] = {.lex_state = 252},
  [7224] = {.lex_state = 249},
  [7225] = {.lex_state = 206},
  [7226] = {.lex_state = 252},
  [7227] = {.lex_state = 252},
  [7228] = {.lex_state = 209},
  [7229] = {.lex_state = 209},
  [7230] = {.lex_state = 209},
  [7231] = {.lex_state = 209},
  [7232] = {.lex_state = 252},
  [7233] = {.lex_state = 249},
  [7234] = {.lex_state = 252},
  [7235] = {.lex_state = 254},
  [7236] = {.lex_state = 252},
  [7237] = {.lex_state = 206},
  [7238] = {.lex_state = 249},
  [7239] = {.lex_state = 252},
  [7240] = {.lex_state = 252},
  [7241] = {.lex_state = 209},
  [7242] = {.lex_state = 249},
  [7243] = {.lex_state = 254},
  [7244] = {.lex_state = 207},
  [7245] = {.lex_state = 198},
  [7246] = {.lex_state = 226},
  [7247] = {.lex_state = 252},
  [7248] = {.lex_state = 207},
  [7249] = {.lex_state = 185},
  [7250] = {.lex_state = 254},
  [7251] = {.lex_state = 252},
  [7252] = {.lex_state = 226},
  [7253] = {.lex_state = 207},
  [7254] = {.lex_state = 226},
  [7255] = {.lex_state = 252},
  [7256] = {.lex_state = 185},
  [7257] = {.lex_state = 252},
  [7258] = {.lex_state = 207},
  [7259] = {.lex_state = 207},
  [7260] = {.lex_state = 252},
  [7261] = {.lex_state = 198},
  [7262] = {.lex_state = 198},
  [7263] = {.lex_state = 254},
  [7264] = {.lex_state = 252},
  [7265] = {.lex_state = 226},
  [7266] = {.lex_state = 185},
  [7267] = {.lex_state = 226},
  [7268] = {.lex_state = 226},
  [7269] = {.lex_state = 254},
  [7270] = {.lex_state = 185},
  [7271] = {.lex_state = 252},
  [7272] = {.lex_state = 252},
  [7273] = {.lex_state = 252},
  [7274] = {.lex_state = 252},
  [7275] = {.lex_state = 207},
  [7276] = {.lex_state = 198},
  [7277] = {.lex_state = 207},
  [7278] = {.lex_state = 252},
  [7279] = {.lex_state = 207},
  [7280] = {.lex_state = 252},
  [7281] = {.lex_state = 252},
  [7282] = {.lex_state = 185},
  [7283] = {.lex_state = 226},
  [7284] = {.lex_state = 207},
  [7285] = {.lex_state = 252},
  [7286] = {.lex_state = 252},
  [7287] = {.lex_state = 226},
  [7288] = {.lex_state = 252},
  [7289] = {.lex_state = 198},
  [7290] = {.lex_state = 185},
  [7291] = {.lex_state = 252},
  [7292] = {.lex_state = 207},
  [7293] = {.lex_state = 252},
  [7294] = {.lex_state = 252},
  [7295] = {.lex_state = 207},
  [7296] = {.lex_state = 185},
  [7297] = {.lex_state = 252},
  [7298] = {.lex_state = 252},
  [7299] = {.lex_state = 252},
  [7300] = {.lex_state = 198},
  [7301] = {.lex_state = 252},
  [7302] = {.lex_state = 207},
  [7303] = {.lex_state = 252},
  [7304] = {.lex_state = 252},
  [7305] = {.lex_state = 198},
  [7306] = {.lex_state = 252},
  [7307] = {.lex_state = 198},
  [7308] = {.lex_state = 252},
  [7309] = {.lex_state = 207},
  [7310] = {.lex_state = 254},
  [7311] = {.lex_state = 207},
  [7312] = {.lex_state = 185},
  [7313] = {.lex_state = 254},
  [7314] = {.lex_state = 206},
  [7315] = {.lex_state = 207},
  [7316] = {.lex_state = 252},
  [7317] = {.lex_state = 252},
  [7318] = {.lex_state = 252},
  [7319] = {.lex_state = 254},
  [7320] = {.lex_state = 254},
  [7321] = {.lex_state = 185},
  [7322] = {.lex_state = 254},
  [7323] = {.lex_state = 206},
  [7324] = {.lex_state = 252},
  [7325] = {.lex_state = 207},
  [7326] = {.lex_state = 254},
  [7327] = {.lex_state = 198},
  [7328] = {.lex_state = 198},
  [7329] = {.lex_state = 198},
  [7330] = {.lex_state = 198},
  [7331] = {.lex_state = 207},
  [7332] = {.lex_state = 191},
  [7333] = {.lex_state = 185},
  [7334] = {.lex_state = 206},
  [7335] = {.lex_state = 198},
  [7336] = {.lex_state = 206},
  [7337] = {.lex_state = 206},
  [7338] = {.lex_state = 206},
  [7339] = {.lex_state = 252},
  [7340] = {.lex_state = 198},
  [7341] = {.lex_state = 185},
  [7342] = {.lex_state = 206},
  [7343] = {.lex_state = 206},
  [7344] = {.lex_state = 206},
  [7345] = {.lex_state = 206},
  [7346] = {.lex_state = 198},
  [7347] = {.lex_state = 207},
  [7348] = {.lex_state = 254},
  [7349] = {.lex_state = 216},
  [7350] = {.lex_state = 206},
  [7351] = {.lex_state = 254},
  [7352] = {.lex_state = 252},
  [7353] = {.lex_state = 252},
  [7354] = {.lex_state = 252},
  [7355] = {.lex_state = 206},
  [7356] = {.lex_state = 206},
  [7357] = {.lex_state = 206},
  [7358] = {.lex_state = 206},
  [7359] = {.lex_state = 252},
  [7360] = {.lex_state = 206},
  [7361] = {.lex_state = 206},
  [7362] = {.lex_state = 252},
  [7363] = {.lex_state = 252},
  [7364] = {.lex_state = 252},
  [7365] = {.lex_state = 206},
  [7366] = {.lex_state = 252},
  [7367] = {.lex_state = 252},
  [7368] = {.lex_state = 206},
  [7369] = {.lex_state = 252},
  [7370] = {.lex_state = 206},
  [7371] = {.lex_state = 206},
  [7372] = {.lex_state = 252},
  [7373] = {.lex_state = 244},
  [7374] = {.lex_state = 206},
  [7375] = {.lex_state = 206},
  [7376] = {.lex_state = 198},
  [7377] = {.lex_state = 252},
  [7378] = {.lex_state = 209},
  [7379] = {.lex_state = 209},
  [7380] = {.lex_state = 209},
  [7381] = {.lex_state = 209},
  [7382] = {.lex_state = 209},
  [7383] = {.lex_state = 252},
  [7384] = {.lex_state = 206},
  [7385] = {.lex_state = 248},
  [7386] = {.lex_state = 252},
  [7387] = {.lex_state = 252},
  [7388] = {.lex_state = 206},
  [7389] = {.lex_state = 252},
  [7390] = {.lex_state = 252},
  [7391] = {.lex_state = 252},
  [7392] = {.lex_state = 252},
  [7393] = {.lex_state = 252},
  [7394] = {.lex_state = 206},
  [7395] = {.lex_state = 252},
  [7396] = {.lex_state = 252},
  [7397] = {.lex_state = 198},
  [7398] = {.lex_state = 252},
  [7399] = {.lex_state = 244},
  [7400] = {.lex_state = 252},
  [7401] = {.lex_state = 227},
  [7402] = {.lex_state = 227},
  [7403] = {.lex_state = 227},
  [7404] = {.lex_state = 254},
  [7405] = {.lex_state = 262},
  [7406] = {.lex_state = 198},
  [7407] = {.lex_state = 252},
  [7408] = {.lex_state = 227},
  [7409] = {.lex_state = 198},
  [7410] = {.lex_state = 227},
  [7411] = {.lex_state = 206},
  [7412] = {.lex_state = 206},
  [7413] = {.lex_state = 252},
  [7414] = {.lex_state = 227},
  [7415] = {.lex_state = 227},
  [7416] = {.lex_state = 227},
  [7417] = {.lex_state = 227},
  [7418] = {.lex_state = 227},
  [7419] = {.lex_state = 248},
  [7420] = {.lex_state = 206},
  [7421] = {.lex_state = 244},
  [7422] = {.lex_state = 209},
  [7423] = {.lex_state = 252},
  [7424] = {.lex_state = 198},
  [7425] = {.lex_state = 209},
  [7426] = {.lex_state = 209},
  [7427] = {.lex_state = 252},
  [7428] = {.lex_state = 198},
  [7429] = {.lex_state = 206},
  [7430] = {.lex_state = 209},
  [7431] = {.lex_state = 252},
  [7432] = {.lex_state = 209},
  [7433] = {.lex_state = 248},
  [7434] = {.lex_state = 244},
  [7435] = {.lex_state = 206},
  [7436] = {.lex_state = 252},
  [7437] = {.lex_state = 206},
  [7438] = {.lex_state = 206},
  [7439] = {.lex_state = 254},
  [7440] = {.lex_state = 206},
  [7441] = {.lex_state = 206},
  [7442] = {.lex_state = 206},
  [7443] = {.lex_state = 206},
  [7444] = {.lex_state = 198},
  [7445] = {.lex_state = 206},
  [7446] = {.lex_state = 206},
  [7447] = {.lex_state = 206},
  [7448] = {.lex_state = 206},
  [7449] = {.lex_state = 252},
  [7450] = {.lex_state = 252},
  [7451] = {.lex_state = 206},
  [7452] = {.lex_state = 206},
  [7453] = {.lex_state = 252},
  [7454] = {.lex_state = 252},
  [7455] = {.lex_state = 252},
  [7456] = {.lex_state = 252},
  [7457] = {.lex_state = 206},
  [7458] = {.lex_state = 252},
  [7459] = {.lex_state = 206},
  [7460] = {.lex_state = 206},
  [7461] = {.lex_state = 206},
  [7462] = {.lex_state = 254},
  [7463] = {.lex_state = 206},
  [7464] = {.lex_state = 252},
  [7465] = {.lex_state = 248},
  [7466] = {.lex_state = 252},
  [7467] = {.lex_state = 252},
  [7468] = {.lex_state = 207},
  [7469] = {.lex_state = 254},
  [7470] = {.lex_state = 252},
  [7471] = {.lex_state = 252},
  [7472] = {.lex_state = 0},
  [7473] = {.lex_state = 252},
  [7474] = {.lex_state = 252},
  [7475] = {.lex_state = 204},
  [7476] = {.lex_state = 248},
  [7477] = {.lex_state = 252},
  [7478] = {.lex_state = 252},
  [7479] = {.lex_state = 252},
  [7480] = {.lex_state = 0},
  [7481] = {.lex_state = 252},
  [7482] = {.lex_state = 206},
  [7483] = {.lex_state = 252},
  [7484] = {.lex_state = 254},
  [7485] = {.lex_state = 204},
  [7486] = {.lex_state = 252},
  [7487] = {.lex_state = 252},
  [7488] = {.lex_state = 207},
  [7489] = {.lex_state = 254},
  [7490] = {.lex_state = 204},
  [7491] = {.lex_state = 226},
  [7492] = {.lex_state = 185},
  [7493] = {.lex_state = 227},
  [7494] = {.lex_state = 207},
  [7495] = {.lex_state = 226},
  [7496] = {.lex_state = 252},
  [7497] = {.lex_state = 206},
  [7498] = {.lex_state = 204},
  [7499] = {.lex_state = 254},
  [7500] = {.lex_state = 254},
  [7501] = {.lex_state = 254},
  [7502] = {.lex_state = 0},
  [7503] = {.lex_state = 204},
  [7504] = {.lex_state = 204},
  [7505] = {.lex_state = 226},
  [7506] = {.lex_state = 227},
  [7507] = {.lex_state = 254},
  [7508] = {.lex_state = 226},
  [7509] = {.lex_state = 204},
  [7510] = {.lex_state = 206},
  [7511] = {.lex_state = 226},
  [7512] = {.lex_state = 226},
  [7513] = {.lex_state = 204},
  [7514] = {.lex_state = 226},
  [7515] = {.lex_state = 252},
  [7516] = {.lex_state = 226},
  [7517] = {.lex_state = 226},
  [7518] = {.lex_state = 226},
  [7519] = {.lex_state = 204},
  [7520] = {.lex_state = 0},
  [7521] = {.lex_state = 252},
  [7522] = {.lex_state = 204},
  [7523] = {.lex_state = 204},
  [7524] = {.lex_state = 251},
  [7525] = {.lex_state = 206},
  [7526] = {.lex_state = 254},
  [7527] = {.lex_state = 254},
  [7528] = {.lex_state = 254},
  [7529] = {.lex_state = 252},
  [7530] = {.lex_state = 254},
  [7531] = {.lex_state = 204},
  [7532] = {.lex_state = 204},
  [7533] = {.lex_state = 254},
  [7534] = {.lex_state = 204},
  [7535] = {.lex_state = 207},
  [7536] = {.lex_state = 252},
  [7537] = {.lex_state = 206},
  [7538] = {.lex_state = 251},
  [7539] = {.lex_state = 204},
  [7540] = {.lex_state = 252},
  [7541] = {.lex_state = 251},
  [7542] = {.lex_state = 207},
  [7543] = {.lex_state = 207},
  [7544] = {.lex_state = 204},
  [7545] = {.lex_state = 252},
  [7546] = {.lex_state = 254},
  [7547] = {.lex_state = 251},
  [7548] = {.lex_state = 252},
  [7549] = {.lex_state = 204},
  [7550] = {.lex_state = 251},
  [7551] = {.lex_state = 204},
  [7552] = {.lex_state = 254},
  [7553] = {.lex_state = 251},
  [7554] = {.lex_state = 0},
  [7555] = {.lex_state = 251},
  [7556] = {.lex_state = 252},
  [7557] = {.lex_state = 207},
  [7558] = {.lex_state = 207},
  [7559] = {.lex_state = 206},
  [7560] = {.lex_state = 252},
  [7561] = {.lex_state = 206},
  [7562] = {.lex_state = 206},
  [7563] = {.lex_state = 207},
  [7564] = {.lex_state = 251},
  [7565] = {.lex_state = 252},
  [7566] = {.lex_state = 204},
  [7567] = {.lex_state = 254},
  [7568] = {.lex_state = 252},
  [7569] = {.lex_state = 252},
  [7570] = {.lex_state = 0},
  [7571] = {.lex_state = 207},
  [7572] = {.lex_state = 252},
  [7573] = {.lex_state = 185},
  [7574] = {.lex_state = 252},
  [7575] = {.lex_state = 185},
  [7576] = {.lex_state = 204},
  [7577] = {.lex_state = 204},
  [7578] = {.lex_state = 252},
  [7579] = {.lex_state = 252},
  [7580] = {.lex_state = 252},
  [7581] = {.lex_state = 206},
  [7582] = {.lex_state = 204},
  [7583] = {.lex_state = 254},
  [7584] = {.lex_state = 204},
  [7585] = {.lex_state = 204},
  [7586] = {.lex_state = 0},
  [7587] = {.lex_state = 254},
  [7588] = {.lex_state = 254},
  [7589] = {.lex_state = 206},
  [7590] = {.lex_state = 206},
  [7591] = {.lex_state = 252},
  [7592] = {.lex_state = 252},
  [7593] = {.lex_state = 252},
  [7594] = {.lex_state = 254},
  [7595] = {.lex_state = 252},
  [7596] = {.lex_state = 252},
  [7597] = {.lex_state = 206},
  [7598] = {.lex_state = 251},
  [7599] = {.lex_state = 252},
  [7600] = {.lex_state = 206},
  [7601] = {.lex_state = 252},
  [7602] = {.lex_state = 252},
  [7603] = {.lex_state = 248},
  [7604] = {.lex_state = 254},
  [7605] = {.lex_state = 252},
  [7606] = {.lex_state = 206},
  [7607] = {.lex_state = 206},
  [7608] = {.lex_state = 251},
  [7609] = {.lex_state = 251},
  [7610] = {.lex_state = 251},
  [7611] = {.lex_state = 251},
  [7612] = {.lex_state = 251},
  [7613] = {.lex_state = 252},
  [7614] = {.lex_state = 252},
  [7615] = {.lex_state = 252},
  [7616] = {.lex_state = 251},
  [7617] = {.lex_state = 251},
  [7618] = {.lex_state = 252},
  [7619] = {.lex_state = 248},
  [7620] = {.lex_state = 254},
  [7621] = {.lex_state = 252},
  [7622] = {.lex_state = 252},
  [7623] = {.lex_state = 252},
  [7624] = {.lex_state = 0},
  [7625] = {.lex_state = 206},
  [7626] = {.lex_state = 252},
  [7627] = {.lex_state = 206},
  [7628] = {.lex_state = 207},
  [7629] = {.lex_state = 206},
  [7630] = {.lex_state = 254},
  [7631] = {.lex_state = 254},
  [7632] = {.lex_state = 254},
  [7633] = {.lex_state = 206},
  [7634] = {.lex_state = 206},
  [7635] = {.lex_state = 206},
  [7636] = {.lex_state = 254},
  [7637] = {.lex_state = 254},
  [7638] = {.lex_state = 254},
  [7639] = {.lex_state = 254},
  [7640] = {.lex_state = 254},
  [7641] = {.lex_state = 206},
  [7642] = {.lex_state = 254},
  [7643] = {.lex_state = 206},
  [7644] = {.lex_state = 248},
  [7645] = {.lex_state = 252},
  [7646] = {.lex_state = 252},
  [7647] = {.lex_state = 207},
  [7648] = {.lex_state = 254},
  [7649] = {.lex_state = 252},
  [7650] = {.lex_state = 206},
  [7651] = {.lex_state = 206},
  [7652] = {.lex_state = 252},
  [7653] = {.lex_state = 252},
  [7654] = {.lex_state = 248},
  [7655] = {.lex_state = 206},
  [7656] = {.lex_state = 251},
  [7657] = {.lex_state = 252},
  [7658] = {.lex_state = 251},
  [7659] = {.lex_state = 251},
  [7660] = {.lex_state = 251},
  [7661] = {.lex_state = 251},
  [7662] = {.lex_state = 251},
  [7663] = {.lex_state = 251},
  [7664] = {.lex_state = 206},
  [7665] = {.lex_state = 252},
  [7666] = {.lex_state = 207},
  [7667] = {.lex_state = 252},
  [7668] = {.lex_state = 252},
  [7669] = {.lex_state = 206},
  [7670] = {.lex_state = 252},
  [7671] = {.lex_state = 206},
  [7672] = {.lex_state = 252},
  [7673] = {.lex_state = 206},
  [7674] = {.lex_state = 206},
  [7675] = {.lex_state = 252},
  [7676] = {.lex_state = 207},
  [7677] = {.lex_state = 252},
  [7678] = {.lex_state = 252},
  [7679] = {.lex_state = 207},
  [7680] = {.lex_state = 206},
  [7681] = {.lex_state = 252},
  [7682] = {.lex_state = 206},
  [7683] = {.lex_state = 207},
  [7684] = {.lex_state = 207},
  [7685] = {.lex_state = 207},
  [7686] = {.lex_state = 206},
  [7687] = {.lex_state = 254},
  [7688] = {.lex_state = 252},
  [7689] = {.lex_state = 254},
  [7690] = {.lex_state = 251},
  [7691] = {.lex_state = 207},
  [7692] = {.lex_state = 207},
  [7693] = {.lex_state = 254},
  [7694] = {.lex_state = 254},
  [7695] = {.lex_state = 254},
  [7696] = {.lex_state = 206},
  [7697] = {.lex_state = 254},
  [7698] = {.lex_state = 254},
  [7699] = {.lex_state = 252},
  [7700] = {.lex_state = 254},
  [7701] = {.lex_state = 252},
  [7702] = {.lex_state = 206},
  [7703] = {.lex_state = 206},
  [7704] = {.lex_state = 252},
  [7705] = {.lex_state = 206},
  [7706] = {.lex_state = 252},
  [7707] = {.lex_state = 252},
  [7708] = {.lex_state = 252},
  [7709] = {.lex_state = 252},
  [7710] = {.lex_state = 252},
  [7711] = {.lex_state = 209},
  [7712] = {.lex_state = 254},
  [7713] = {.lex_state = 252},
  [7714] = {.lex_state = 206},
  [7715] = {.lex_state = 252},
  [7716] = {.lex_state = 252},
  [7717] = {.lex_state = 252},
  [7718] = {.lex_state = 206},
  [7719] = {.lex_state = 206},
  [7720] = {.lex_state = 252},
  [7721] = {.lex_state = 206},
  [7722] = {.lex_state = 252},
  [7723] = {.lex_state = 206},
  [7724] = {.lex_state = 252},
  [7725] = {.lex_state = 252},
  [7726] = {.lex_state = 252},
  [7727] = {.lex_state = 252},
  [7728] = {.lex_state = 252},
  [7729] = {.lex_state = 252},
  [7730] = {.lex_state = 206},
  [7731] = {.lex_state = 204},
  [7732] = {.lex_state = 252},
  [7733] = {.lex_state = 206},
  [7734] = {.lex_state = 252},
  [7735] = {.lex_state = 252},
  [7736] = {.lex_state = 252},
  [7737] = {.lex_state = 252},
  [7738] = {.lex_state = 252},
  [7739] = {.lex_state = 206},
  [7740] = {.lex_state = 252},
  [7741] = {.lex_state = 254},
  [7742] = {.lex_state = 206},
  [7743] = {.lex_state = 207},
  [7744] = {.lex_state = 206},
  [7745] = {.lex_state = 206},
  [7746] = {.lex_state = 206},
  [7747] = {.lex_state = 206},
  [7748] = {.lex_state = 254},
  [7749] = {.lex_state = 206},
  [7750] = {.lex_state = 206},
  [7751] = {.lex_state = 252},
  [7752] = {.lex_state = 206},
  [7753] = {.lex_state = 252},
  [7754] = {.lex_state = 252},
  [7755] = {.lex_state = 252},
  [7756] = {.lex_state = 206},
  [7757] = {.lex_state = 206},
  [7758] = {.lex_state = 206},
  [7759] = {.lex_state = 252},
  [7760] = {.lex_state = 254},
  [7761] = {.lex_state = 254},
  [7762] = {.lex_state = 254},
  [7763] = {.lex_state = 209},
  [7764] = {.lex_state = 254},
  [7765] = {.lex_state = 254},
  [7766] = {.lex_state = 206},
  [7767] = {.lex_state = 254},
  [7768] = {.lex_state = 209},
  [7769] = {.lex_state = 206},
  [7770] = {.lex_state = 254},
  [7771] = {.lex_state = 254},
  [7772] = {.lex_state = 206},
  [7773] = {.lex_state = 207},
  [7774] = {.lex_state = 206},
  [7775] = {.lex_state = 209},
  [7776] = {.lex_state = 209},
  [7777] = {.lex_state = 206},
  [7778] = {.lex_state = 209},
  [7779] = {.lex_state = 209},
  [7780] = {.lex_state = 206},
  [7781] = {.lex_state = 207},
  [7782] = {.lex_state = 252},
  [7783] = {.lex_state = 252},
  [7784] = {.lex_state = 209},
  [7785] = {.lex_state = 206},
  [7786] = {.lex_state = 206},
  [7787] = {.lex_state = 252},
  [7788] = {.lex_state = 206},
  [7789] = {.lex_state = 206},
  [7790] = {.lex_state = 206},
  [7791] = {.lex_state = 206},
  [7792] = {.lex_state = 252},
  [7793] = {.lex_state = 206},
  [7794] = {.lex_state = 252},
  [7795] = {.lex_state = 206},
  [7796] = {.lex_state = 252},
  [7797] = {.lex_state = 252},
  [7798] = {.lex_state = 206},
  [7799] = {.lex_state = 206},
  [7800] = {.lex_state = 252},
  [7801] = {.lex_state = 206},
  [7802] = {.lex_state = 252},
  [7803] = {.lex_state = 206},
  [7804] = {.lex_state = 252},
  [7805] = {.lex_state = 252},
  [7806] = {.lex_state = 252},
  [7807] = {.lex_state = 252},
  [7808] = {.lex_state = 252},
  [7809] = {.lex_state = 252},
  [7810] = {.lex_state = 252},
  [7811] = {.lex_state = 206},
  [7812] = {.lex_state = 249},
  [7813] = {.lex_state = 252},
  [7814] = {.lex_state = 252},
  [7815] = {.lex_state = 252},
  [7816] = {.lex_state = 206},
  [7817] = {.lex_state = 206},
  [7818] = {.lex_state = 207},
  [7819] = {.lex_state = 207},
  [7820] = {.lex_state = 207},
  [7821] = {.lex_state = 207},
  [7822] = {.lex_state = 207},
  [7823] = {.lex_state = 207},
  [7824] = {.lex_state = 207},
  [7825] = {.lex_state = 207},
  [7826] = {.lex_state = 252},
  [7827] = {.lex_state = 206},
  [7828] = {.lex_state = 206},
  [7829] = {.lex_state = 252},
  [7830] = {.lex_state = 206},
  [7831] = {.lex_state = 206},
  [7832] = {.lex_state = 206},
  [7833] = {.lex_state = 252},
  [7834] = {.lex_state = 206},
  [7835] = {.lex_state = 248},
  [7836] = {.lex_state = 252},
  [7837] = {.lex_state = 206},
  [7838] = {.lex_state = 254},
  [7839] = {.lex_state = 206},
  [7840] = {.lex_state = 206},
  [7841] = {.lex_state = 206},
  [7842] = {.lex_state = 207},
  [7843] = {.lex_state = 206},
  [7844] = {.lex_state = 252},
  [7845] = {.lex_state = 206},
  [7846] = {.lex_state = 206},
  [7847] = {.lex_state = 206},
  [7848] = {.lex_state = 252},
  [7849] = {.lex_state = 252},
  [7850] = {.lex_state = 252},
  [7851] = {.lex_state = 206},
  [7852] = {.lex_state = 252},
  [7853] = {.lex_state = 206},
  [7854] = {.lex_state = 252},
  [7855] = {.lex_state = 206},
  [7856] = {.lex_state = 206},
  [7857] = {.lex_state = 206},
  [7858] = {.lex_state = 251},
  [7859] = {.lex_state = 252},
  [7860] = {.lex_state = 206},
  [7861] = {.lex_state = 206},
  [7862] = {.lex_state = 254},
  [7863] = {.lex_state = 254},
  [7864] = {.lex_state = 252},
  [7865] = {.lex_state = 206},
  [7866] = {.lex_state = 252},
  [7867] = {.lex_state = 206},
  [7868] = {.lex_state = 252},
  [7869] = {.lex_state = 227},
  [7870] = {.lex_state = 254},
  [7871] = {.lex_state = 206},
  [7872] = {.lex_state = 227},
  [7873] = {.lex_state = 227},
  [7874] = {.lex_state = 227},
  [7875] = {.lex_state = 227},
  [7876] = {.lex_state = 227},
  [7877] = {.lex_state = 227},
  [7878] = {.lex_state = 227},
  [7879] = {.lex_state = 206},
  [7880] = {.lex_state = 206},
  [7881] = {.lex_state = 252},
  [7882] = {.lex_state = 252},
  [7883] = {.lex_state = 206},
  [7884] = {.lex_state = 252},
  [7885] = {.lex_state = 252},
  [7886] = {.lex_state = 254},
  [7887] = {.lex_state = 252},
  [7888] = {.lex_state = 254},
  [7889] = {.lex_state = 254},
  [7890] = {.lex_state = 206},
  [7891] = {.lex_state = 252},
  [7892] = {.lex_state = 252},
  [7893] = {.lex_state = 206},
  [7894] = {.lex_state = 206},
  [7895] = {.lex_state = 206},
  [7896] = {.lex_state = 254},
  [7897] = {.lex_state = 254},
  [7898] = {.lex_state = 254},
  [7899] = {.lex_state = 206},
  [7900] = {.lex_state = 254},
  [7901] = {.lex_state = 206},
  [7902] = {.lex_state = 206},
  [7903] = {.lex_state = 206},
  [7904] = {.lex_state = 206},
  [7905] = {.lex_state = 206},
  [7906] = {.lex_state = 206},
  [7907] = {.lex_state = 206},
  [7908] = {.lex_state = 207},
  [7909] = {.lex_state = 206},
  [7910] = {.lex_state = 206},
  [7911] = {.lex_state = 206},
  [7912] = {.lex_state = 206},
  [7913] = {.lex_state = 206},
  [7914] = {.lex_state = 206},
  [7915] = {.lex_state = 251},
  [7916] = {.lex_state = 206},
  [7917] = {.lex_state = 252},
  [7918] = {.lex_state = 252},
  [7919] = {.lex_state = 206},
  [7920] = {.lex_state = 206},
  [7921] = {.lex_state = 252},
  [7922] = {.lex_state = 235},
  [7923] = {.lex_state = 227},
  [7924] = {.lex_state = 206},
  [7925] = {.lex_state = 206},
  [7926] = {.lex_state = 206},
  [7927] = {.lex_state = 252},
  [7928] = {.lex_state = 206},
  [7929] = {.lex_state = 252},
  [7930] = {.lex_state = 252},
  [7931] = {.lex_state = 252},
  [7932] = {.lex_state = 252},
  [7933] = {.lex_state = 252},
  [7934] = {.lex_state = 235},
  [7935] = {.lex_state = 351},
  [7936] = {.lex_state = 252},
  [7937] = {.lex_state = 252},
  [7938] = {.lex_state = 209},
  [7939] = {.lex_state = 209},
  [7940] = {.lex_state = 252},
  [7941] = {.lex_state = 235},
  [7942] = {.lex_state = 209},
  [7943] = {.lex_state = 209},
  [7944] = {.lex_state = 209},
  [7945] = {.lex_state = 251},
  [7946] = {.lex_state = 227},
  [7947] = {.lex_state = 252},
  [7948] = {.lex_state = 227},
  [7949] = {.lex_state = 227},
  [7950] = {.lex_state = 227},
  [7951] = {.lex_state = 227},
  [7952] = {.lex_state = 209},
  [7953] = {.lex_state = 209},
  [7954] = {.lex_state = 227},
  [7955] = {.lex_state = 235},
  [7956] = {.lex_state = 209},
  [7957] = {.lex_state = 252},
  [7958] = {.lex_state = 206},
  [7959] = {.lex_state = 209},
  [7960] = {.lex_state = 252},
  [7961] = {.lex_state = 209},
  [7962] = {.lex_state = 235},
  [7963] = {.lex_state = 209},
  [7964] = {.lex_state = 252},
  [7965] = {.lex_state = 254},
  [7966] = {.lex_state = 235},
  [7967] = {.lex_state = 206},
  [7968] = {.lex_state = 254},
  [7969] = {.lex_state = 191},
  [7970] = {.lex_state = 254},
  [7971] = {.lex_state = 235},
  [7972] = {.lex_state = 209},
  [7973] = {.lex_state = 206},
  [7974] = {.lex_state = 252},
  [7975] = {.lex_state = 227},
  [7976] = {.lex_state = 206},
  [7977] = {.lex_state = 206},
  [7978] = {.lex_state = 251},
  [7979] = {.lex_state = 226},
  [7980] = {.lex_state = 252},
  [7981] = {.lex_state = 235},
  [7982] = {.lex_state = 206},
  [7983] = {.lex_state = 227},
  [7984] = {.lex_state = 252},
  [7985] = {.lex_state = 206},
  [7986] = {.lex_state = 206},
  [7987] = {.lex_state = 252},
  [7988] = {.lex_state = 209},
  [7989] = {.lex_state = 252},
  [7990] = {.lex_state = 206},
  [7991] = {.lex_state = 227},
  [7992] = {.lex_state = 252},
  [7993] = {.lex_state = 248},
  [7994] = {.lex_state = 207},
  [7995] = {.lex_state = 254},
  [7996] = {.lex_state = 226},
  [7997] = {.lex_state = 206},
  [7998] = {.lex_state = 206},
  [7999] = {.lex_state = 227},
  [8000] = {.lex_state = 206},
  [8001] = {.lex_state = 206},
  [8002] = {.lex_state = 248},
  [8003] = {.lex_state = 207},
  [8004] = {.lex_state = 235},
  [8005] = {.lex_state = 206},
  [8006] = {.lex_state = 235},
  [8007] = {.lex_state = 207},
  [8008] = {.lex_state = 254},
  [8009] = {.lex_state = 252},
  [8010] = {.lex_state = 207},
  [8011] = {.lex_state = 207},
  [8012] = {.lex_state = 252},
  [8013] = {.lex_state = 252},
  [8014] = {.lex_state = 227},
  [8015] = {.lex_state = 207},
  [8016] = {.lex_state = 207},
  [8017] = {.lex_state = 226},
  [8018] = {.lex_state = 235},
  [8019] = {.lex_state = 226},
  [8020] = {.lex_state = 252},
  [8021] = {.lex_state = 235},
  [8022] = {.lex_state = 191},
  [8023] = {.lex_state = 227},
  [8024] = {.lex_state = 226},
  [8025] = {.lex_state = 206},
  [8026] = {.lex_state = 207},
  [8027] = {.lex_state = 226},
  [8028] = {.lex_state = 252},
  [8029] = {.lex_state = 252},
  [8030] = {.lex_state = 252},
  [8031] = {.lex_state = 226},
  [8032] = {.lex_state = 235},
  [8033] = {.lex_state = 226},
  [8034] = {.lex_state = 226},
  [8035] = {.lex_state = 206},
  [8036] = {.lex_state = 251},
  [8037] = {.lex_state = 251},
  [8038] = {.lex_state = 226},
  [8039] = {.lex_state = 206},
  [8040] = {.lex_state = 245},
  [8041] = {.lex_state = 207},
  [8042] = {.lex_state = 226},
  [8043] = {.lex_state = 226},
  [8044] = {.lex_state = 251},
  [8045] = {.lex_state = 245},
  [8046] = {.lex_state = 206},
  [8047] = {.lex_state = 206},
  [8048] = {.lex_state = 351},
  [8049] = {.lex_state = 226},
  [8050] = {.lex_state = 206},
  [8051] = {.lex_state = 226},
  [8052] = {.lex_state = 251},
  [8053] = {.lex_state = 251},
  [8054] = {.lex_state = 251},
  [8055] = {.lex_state = 245},
  [8056] = {.lex_state = 226},
  [8057] = {.lex_state = 351},
  [8058] = {.lex_state = 226},
  [8059] = {.lex_state = 226},
  [8060] = {.lex_state = 251},
  [8061] = {.lex_state = 206},
  [8062] = {.lex_state = 207},
  [8063] = {.lex_state = 251},
  [8064] = {.lex_state = 206},
  [8065] = {.lex_state = 252},
  [8066] = {.lex_state = 206},
  [8067] = {.lex_state = 206},
  [8068] = {.lex_state = 185},
  [8069] = {.lex_state = 254},
  [8070] = {.lex_state = 206},
  [8071] = {.lex_state = 206},
  [8072] = {.lex_state = 351},
  [8073] = {.lex_state = 226},
  [8074] = {.lex_state = 226},
  [8075] = {.lex_state = 206},
  [8076] = {.lex_state = 206},
  [8077] = {.lex_state = 251},
  [8078] = {.lex_state = 206},
  [8079] = {.lex_state = 207},
  [8080] = {.lex_state = 351},
  [8081] = {.lex_state = 206},
  [8082] = {.lex_state = 206},
  [8083] = {.lex_state = 206},
  [8084] = {.lex_state = 226},
  [8085] = {.lex_state = 207},
  [8086] = {.lex_state = 206},
  [8087] = {.lex_state = 206},
  [8088] = {.lex_state = 207},
  [8089] = {.lex_state = 206},
  [8090] = {.lex_state = 206},
  [8091] = {.lex_state = 245},
  [8092] = {.lex_state = 206},
  [8093] = {.lex_state = 251},
  [8094] = {.lex_state = 206},
  [8095] = {.lex_state = 207},
  [8096] = {.lex_state = 252},
  [8097] = {.lex_state = 251},
  [8098] = {.lex_state = 206},
  [8099] = {.lex_state = 207},
  [8100] = {.lex_state = 252},
  [8101] = {.lex_state = 207},
  [8102] = {.lex_state = 206},
  [8103] = {.lex_state = 226},
  [8104] = {.lex_state = 206},
  [8105] = {.lex_state = 206},
  [8106] = {.lex_state = 206},
  [8107] = {.lex_state = 206},
  [8108] = {.lex_state = 207},
  [8109] = {.lex_state = 351},
  [8110] = {.lex_state = 351},
  [8111] = {.lex_state = 207},
  [8112] = {.lex_state = 206},
  [8113] = {.lex_state = 206},
  [8114] = {.lex_state = 206},
  [8115] = {.lex_state = 206},
  [8116] = {.lex_state = 206},
  [8117] = {.lex_state = 206},
  [8118] = {.lex_state = 207},
  [8119] = {.lex_state = 206},
  [8120] = {.lex_state = 206},
  [8121] = {.lex_state = 206},
  [8122] = {.lex_state = 206},
  [8123] = {.lex_state = 206},
  [8124] = {.lex_state = 207},
  [8125] = {.lex_state = 254},
  [8126] = {.lex_state = 206},
  [8127] = {.lex_state = 206},
  [8128] = {.lex_state = 207},
  [8129] = {.lex_state = 206},
  [8130] = {.lex_state = 251},
  [8131] = {.lex_state = 206},
  [8132] = {.lex_state = 206},
  [8133] = {.lex_state = 251},
  [8134] = {.lex_state = 206},
  [8135] = {.lex_state = 251},
  [8136] = {.lex_state = 251},
  [8137] = {.lex_state = 251},
  [8138] = {.lex_state = 351},
  [8139] = {.lex_state = 251},
  [8140] = {.lex_state = 254},
  [8141] = {.lex_state = 351},
  [8142] = {.lex_state = 351},
  [8143] = {.lex_state = 248},
  [8144] = {.lex_state = 185},
  [8145] = {.lex_state = 351},
  [8146] = {.lex_state = 215},
  [8147] = {.lex_state = 254},
  [8148] = {.lex_state = 207},
  [8149] = {.lex_state = 254},
  [8150] = {.lex_state = 351},
  [8151] = {.lex_state = 252},
  [8152] = {.lex_state = 351},
  [8153] = {.lex_state = 351},
  [8154] = {.lex_state = 254},
  [8155] = {.lex_state = 235},
  [8156] = {.lex_state = 251},
  [8157] = {.lex_state = 351},
  [8158] = {.lex_state = 252},
  [8159] = {.lex_state = 251},
  [8160] = {.lex_state = 351},
  [8161] = {.lex_state = 252},
  [8162] = {.lex_state = 251},
  [8163] = {.lex_state = 251},
  [8164] = {.lex_state = 351},
  [8165] = {.lex_state = 206},
  [8166] = {.lex_state = 252},
  [8167] = {.lex_state = 351},
  [8168] = {.lex_state = 251},
  [8169] = {.lex_state = 351},
  [8170] = {.lex_state = 351},
  [8171] = {.lex_state = 252},
  [8172] = {.lex_state = 185},
  [8173] = {.lex_state = 206},
  [8174] = {.lex_state = 235},
  [8175] = {.lex_state = 251},
  [8176] = {.lex_state = 185},
  [8177] = {.lex_state = 185},
  [8178] = {.lex_state = 351},
  [8179] = {.lex_state = 254},
  [8180] = {.lex_state = 351},
  [8181] = {.lex_state = 252},
  [8182] = {.lex_state = 185},
  [8183] = {.lex_state = 254},
  [8184] = {.lex_state = 351},
  [8185] = {.lex_state = 252},
  [8186] = {.lex_state = 351},
  [8187] = {.lex_state = 254},
  [8188] = {.lex_state = 254},
  [8189] = {.lex_state = 254},
  [8190] = {.lex_state = 351},
  [8191] = {.lex_state = 251},
  [8192] = {.lex_state = 351},
  [8193] = {.lex_state = 254},
  [8194] = {.lex_state = 251},
  [8195] = {.lex_state = 207},
  [8196] = {.lex_state = 254},
  [8197] = {.lex_state = 254},
  [8198] = {.lex_state = 254},
  [8199] = {.lex_state = 254},
  [8200] = {.lex_state = 254},
  [8201] = {.lex_state = 185},
  [8202] = {.lex_state = 254},
  [8203] = {.lex_state = 207},
  [8204] = {.lex_state = 254},
  [8205] = {.lex_state = 248},
  [8206] = {.lex_state = 254},
  [8207] = {.lex_state = 351},
  [8208] = {.lex_state = 351},
  [8209] = {.lex_state = 351},
  [8210] = {.lex_state = 207},
  [8211] = {.lex_state = 351},
  [8212] = {.lex_state = 185},
  [8213] = {.lex_state = 251},
  [8214] = {.lex_state = 185},
  [8215] = {.lex_state = 254},
  [8216] = {.lex_state = 185},
  [8217] = {.lex_state = 351},
  [8218] = {.lex_state = 351},
  [8219] = {.lex_state = 185},
  [8220] = {.lex_state = 351},
  [8221] = {.lex_state = 207},
  [8222] = {.lex_state = 351},
  [8223] = {.lex_state = 351},
  [8224] = {.lex_state = 185},
  [8225] = {.lex_state = 207},
  [8226] = {.lex_state = 252},
  [8227] = {.lex_state = 201},
  [8228] = {.lex_state = 351},
  [8229] = {.lex_state = 351},
  [8230] = {.lex_state = 248},
  [8231] = {.lex_state = 206},
  [8232] = {.lex_state = 252},
  [8233] = {.lex_state = 185},
  [8234] = {.lex_state = 206},
  [8235] = {.lex_state = 185},
  [8236] = {.lex_state = 351},
  [8237] = {.lex_state = 252},
  [8238] = {.lex_state = 206},
  [8239] = {.lex_state = 185},
  [8240] = {.lex_state = 252},
  [8241] = {.lex_state = 252},
  [8242] = {.lex_state = 206},
  [8243] = {.lex_state = 252},
  [8244] = {.lex_state = 252},
  [8245] = {.lex_state = 206},
  [8246] = {.lex_state = 254},
  [8247] = {.lex_state = 215},
  [8248] = {.lex_state = 209},
  [8249] = {.lex_state = 215},
  [8250] = {.lex_state = 252},
  [8251] = {.lex_state = 252},
  [8252] = {.lex_state = 351},
  [8253] = {.lex_state = 252},
  [8254] = {.lex_state = 185},
  [8255] = {.lex_state = 351},
  [8256] = {.lex_state = 252},
  [8257] = {.lex_state = 252},
  [8258] = {.lex_state = 201},
  [8259] = {.lex_state = 216},
  [8260] = {.lex_state = 351},
  [8261] = {.lex_state = 201},
  [8262] = {.lex_state = 252},
  [8263] = {.lex_state = 185},
  [8264] = {.lex_state = 201},
  [8265] = {.lex_state = 215},
  [8266] = {.lex_state = 201},
  [8267] = {.lex_state = 252},
  [8268] = {.lex_state = 254},
  [8269] = {.lex_state = 227},
  [8270] = {.lex_state = 209},
  [8271] = {.lex_state = 252},
  [8272] = {.lex_state = 216},
  [8273] = {.lex_state = 252},
  [8274] = {.lex_state = 185},
  [8275] = {.lex_state = 351},
  [8276] = {.lex_state = 252},
  [8277] = {.lex_state = 351},
  [8278] = {.lex_state = 252},
  [8279] = {.lex_state = 351},
  [8280] = {.lex_state = 254},
  [8281] = {.lex_state = 252},
  [8282] = {.lex_state = 185},
  [8283] = {.lex_state = 351},
  [8284] = {.lex_state = 252},
  [8285] = {.lex_state = 206},
  [8286] = {.lex_state = 351},
  [8287] = {.lex_state = 252},
  [8288] = {.lex_state = 252},
  [8289] = {.lex_state = 351},
  [8290] = {.lex_state = 206},
  [8291] = {.lex_state = 351},
  [8292] = {.lex_state = 252},
  [8293] = {.lex_state = 209},
  [8294] = {.lex_state = 252},
  [8295] = {.lex_state = 251},
  [8296] = {.lex_state = 351},
  [8297] = {.lex_state = 351},
  [8298] = {.lex_state = 252},
  [8299] = {.lex_state = 209},
  [8300] = {.lex_state = 351},
  [8301] = {.lex_state = 252},
  [8302] = {.lex_state = 351},
  [8303] = {.lex_state = 209},
  [8304] = {.lex_state = 227},
  [8305] = {.lex_state = 215},
  [8306] = {.lex_state = 252},
  [8307] = {.lex_state = 201},
  [8308] = {.lex_state = 206},
  [8309] = {.lex_state = 252},
  [8310] = {.lex_state = 201},
  [8311] = {.lex_state = 227},
  [8312] = {.lex_state = 254},
  [8313] = {.lex_state = 185},
  [8314] = {.lex_state = 254},
  [8315] = {.lex_state = 254},
  [8316] = {.lex_state = 201},
  [8317] = {.lex_state = 227},
  [8318] = {.lex_state = 206},
  [8319] = {.lex_state = 227},
  [8320] = {.lex_state = 206},
  [8321] = {.lex_state = 254},
  [8322] = {.lex_state = 254},
  [8323] = {.lex_state = 254},
  [8324] = {.lex_state = 185},
  [8325] = {.lex_state = 252},
  [8326] = {.lex_state = 351},
  [8327] = {.lex_state = 201},
  [8328] = {.lex_state = 351},
  [8329] = {.lex_state = 185},
  [8330] = {.lex_state = 216},
  [8331] = {.lex_state = 185},
  [8332] = {.lex_state = 185},
  [8333] = {.lex_state = 254},
  [8334] = {.lex_state = 252},
  [8335] = {.lex_state = 209},
  [8336] = {.lex_state = 254},
  [8337] = {.lex_state = 215},
  [8338] = {.lex_state = 254},
  [8339] = {.lex_state = 206},
  [8340] = {.lex_state = 185},
  [8341] = {.lex_state = 206},
  [8342] = {.lex_state = 252},
  [8343] = {.lex_state = 185},
  [8344] = {.lex_state = 215},
  [8345] = {.lex_state = 351},
  [8346] = {.lex_state = 254},
  [8347] = {.lex_state = 206},
  [8348] = {.lex_state = 254},
  [8349] = {.lex_state = 215},
  [8350] = {.lex_state = 252},
  [8351] = {.lex_state = 215},
  [8352] = {.lex_state = 185},
  [8353] = {.lex_state = 227},
  [8354] = {.lex_state = 206},
  [8355] = {.lex_state = 351},
  [8356] = {.lex_state = 248},
  [8357] = {.lex_state = 254},
  [8358] = {.lex_state = 351},
  [8359] = {.lex_state = 206},
  [8360] = {.lex_state = 206},
  [8361] = {.lex_state = 252},
  [8362] = {.lex_state = 207},
  [8363] = {.lex_state = 206},
  [8364] = {.lex_state = 248},
  [8365] = {.lex_state = 207},
  [8366] = {.lex_state = 248},
  [8367] = {.lex_state = 226},
  [8368] = {.lex_state = 204},
  [8369] = {.lex_state = 206},
  [8370] = {.lex_state = 206},
  [8371] = {.lex_state = 248},
  [8372] = {.lex_state = 206},
  [8373] = {.lex_state = 206},
  [8374] = {.lex_state = 351},
  [8375] = {.lex_state = 207},
  [8376] = {.lex_state = 206},
  [8377] = {.lex_state = 204},
  [8378] = {.lex_state = 201},
  [8379] = {.lex_state = 252},
  [8380] = {.lex_state = 252},
  [8381] = {.lex_state = 206},
  [8382] = {.lex_state = 206},
  [8383] = {.lex_state = 248},
  [8384] = {.lex_state = 206},
  [8385] = {.lex_state = 206},
  [8386] = {.lex_state = 252},
  [8387] = {.lex_state = 206},
  [8388] = {.lex_state = 206},
  [8389] = {.lex_state = 254},
  [8390] = {.lex_state = 215},
  [8391] = {.lex_state = 185},
  [8392] = {.lex_state = 206},
  [8393] = {.lex_state = 206},
  [8394] = {.lex_state = 207},
  [8395] = {.lex_state = 206},
  [8396] = {.lex_state = 206},
  [8397] = {.lex_state = 207},
  [8398] = {.lex_state = 248},
  [8399] = {.lex_state = 0},
  [8400] = {.lex_state = 248},
  [8401] = {.lex_state = 204},
  [8402] = {.lex_state = 252},
  [8403] = {.lex_state = 248},
  [8404] = {.lex_state = 252},
  [8405] = {.lex_state = 185},
  [8406] = {.lex_state = 248},
  [8407] = {.lex_state = 252},
  [8408] = {.lex_state = 206},
  [8409] = {.lex_state = 201},
  [8410] = {.lex_state = 254},
  [8411] = {.lex_state = 207},
  [8412] = {.lex_state = 206},
  [8413] = {.lex_state = 248},
  [8414] = {.lex_state = 201},
  [8415] = {.lex_state = 206},
  [8416] = {.lex_state = 201},
  [8417] = {.lex_state = 248},
  [8418] = {.lex_state = 207},
  [8419] = {.lex_state = 248},
  [8420] = {.lex_state = 252},
  [8421] = {.lex_state = 206},
  [8422] = {.lex_state = 185},
  [8423] = {.lex_state = 252},
  [8424] = {.lex_state = 248},
  [8425] = {.lex_state = 201},
  [8426] = {.lex_state = 206},
  [8427] = {.lex_state = 201},
  [8428] = {.lex_state = 204},
  [8429] = {.lex_state = 185},
  [8430] = {.lex_state = 206},
  [8431] = {.lex_state = 201},
  [8432] = {.lex_state = 248},
  [8433] = {.lex_state = 351},
  [8434] = {.lex_state = 248},
  [8435] = {.lex_state = 206},
  [8436] = {.lex_state = 252},
  [8437] = {.lex_state = 206},
  [8438] = {.lex_state = 185},
  [8439] = {.lex_state = 351},
  [8440] = {.lex_state = 204},
  [8441] = {.lex_state = 252},
  [8442] = {.lex_state = 248},
  [8443] = {.lex_state = 206},
  [8444] = {.lex_state = 252},
  [8445] = {.lex_state = 206},
  [8446] = {.lex_state = 185},
  [8447] = {.lex_state = 252},
  [8448] = {.lex_state = 215},
  [8449] = {.lex_state = 185},
  [8450] = {.lex_state = 206},
  [8451] = {.lex_state = 226},
  [8452] = {.lex_state = 252},
  [8453] = {.lex_state = 185},
  [8454] = {.lex_state = 252},
  [8455] = {.lex_state = 252},
  [8456] = {.lex_state = 206},
  [8457] = {.lex_state = 215},
  [8458] = {.lex_state = 206},
  [8459] = {.lex_state = 206},
  [8460] = {.lex_state = 207},
  [8461] = {.lex_state = 252},
  [8462] = {.lex_state = 215},
  [8463] = {.lex_state = 206},
  [8464] = {.lex_state = 206},
  [8465] = {.lex_state = 215},
  [8466] = {.lex_state = 207},
  [8467] = {.lex_state = 248},
  [8468] = {.lex_state = 226},
  [8469] = {.lex_state = 0},
  [8470] = {.lex_state = 252},
  [8471] = {.lex_state = 206},
  [8472] = {.lex_state = 206},
  [8473] = {.lex_state = 206},
  [8474] = {.lex_state = 351},
  [8475] = {.lex_state = 252},
  [8476] = {.lex_state = 252},
  [8477] = {.lex_state = 252},
  [8478] = {.lex_state = 252},
  [8479] = {.lex_state = 226},
  [8480] = {.lex_state = 248},
  [8481] = {.lex_state = 207},
  [8482] = {.lex_state = 251},
  [8483] = {.lex_state = 207},
  [8484] = {.lex_state = 351},
  [8485] = {.lex_state = 204},
  [8486] = {.lex_state = 252},
  [8487] = {.lex_state = 351},
  [8488] = {.lex_state = 351},
  [8489] = {.lex_state = 215},
  [8490] = {.lex_state = 351},
  [8491] = {.lex_state = 252},
  [8492] = {.lex_state = 254},
  [8493] = {.lex_state = 351},
  [8494] = {.lex_state = 252},
  [8495] = {.lex_state = 207},
  [8496] = {.lex_state = 204},
  [8497] = {.lex_state = 351},
  [8498] = {.lex_state = 254},
  [8499] = {.lex_state = 226},
  [8500] = {.lex_state = 207},
  [8501] = {.lex_state = 351},
  [8502] = {.lex_state = 252},
  [8503] = {.lex_state = 206},
  [8504] = {.lex_state = 204},
  [8505] = {.lex_state = 204},
  [8506] = {.lex_state = 206},
  [8507] = {.lex_state = 185},
  [8508] = {.lex_state = 248},
  [8509] = {.lex_state = 206},
  [8510] = {.lex_state = 206},
  [8511] = {.lex_state = 204},
  [8512] = {.lex_state = 351},
  [8513] = {.lex_state = 206},
  [8514] = {.lex_state = 206},
  [8515] = {.lex_state = 215},
  [8516] = {.lex_state = 206},
  [8517] = {.lex_state = 207},
  [8518] = {.lex_state = 252},
  [8519] = {.lex_state = 226},
  [8520] = {.lex_state = 206},
  [8521] = {.lex_state = 204},
  [8522] = {.lex_state = 254},
  [8523] = {.lex_state = 252},
  [8524] = {.lex_state = 351},
  [8525] = {.lex_state = 206},
  [8526] = {.lex_state = 0},
  [8527] = {.lex_state = 206},
  [8528] = {.lex_state = 207},
  [8529] = {.lex_state = 206},
  [8530] = {.lex_state = 206},
  [8531] = {.lex_state = 206},
  [8532] = {.lex_state = 252},
  [8533] = {.lex_state = 207},
  [8534] = {.lex_state = 185},
  [8535] = {.lex_state = 351},
  [8536] = {.lex_state = 252},
  [8537] = {.lex_state = 206},
  [8538] = {.lex_state = 0},
  [8539] = {.lex_state = 206},
  [8540] = {.lex_state = 206},
  [8541] = {.lex_state = 0},
  [8542] = {.lex_state = 206},
  [8543] = {.lex_state = 206},
  [8544] = {.lex_state = 185},
  [8545] = {.lex_state = 206},
  [8546] = {.lex_state = 206},
  [8547] = {.lex_state = 185},
  [8548] = {.lex_state = 206},
  [8549] = {.lex_state = 206},
  [8550] = {.lex_state = 185},
  [8551] = {.lex_state = 207},
  [8552] = {.lex_state = 206},
  [8553] = {.lex_state = 248},
  [8554] = {.lex_state = 206},
  [8555] = {.lex_state = 252},
  [8556] = {.lex_state = 185},
  [8557] = {.lex_state = 206},
  [8558] = {.lex_state = 206},
  [8559] = {.lex_state = 252},
  [8560] = {.lex_state = 206},
  [8561] = {.lex_state = 207},
  [8562] = {.lex_state = 252},
  [8563] = {.lex_state = 252},
  [8564] = {.lex_state = 252},
  [8565] = {.lex_state = 206},
  [8566] = {.lex_state = 206},
  [8567] = {.lex_state = 206},
  [8568] = {.lex_state = 206},
  [8569] = {.lex_state = 206},
  [8570] = {.lex_state = 206},
  [8571] = {.lex_state = 351},
  [8572] = {.lex_state = 206},
  [8573] = {.lex_state = 206},
  [8574] = {.lex_state = 185},
  [8575] = {.lex_state = 206},
  [8576] = {.lex_state = 206},
  [8577] = {.lex_state = 206},
  [8578] = {.lex_state = 206},
  [8579] = {.lex_state = 206},
  [8580] = {.lex_state = 206},
  [8581] = {.lex_state = 185},
  [8582] = {.lex_state = 206},
  [8583] = {.lex_state = 206},
  [8584] = {.lex_state = 206},
  [8585] = {.lex_state = 252},
  [8586] = {.lex_state = 252},
  [8587] = {.lex_state = 351},
  [8588] = {.lex_state = 185},
  [8589] = {.lex_state = 185},
  [8590] = {.lex_state = 0},
  [8591] = {.lex_state = 185},
  [8592] = {.lex_state = 206},
  [8593] = {.lex_state = 206},
  [8594] = {.lex_state = 207},
  [8595] = {.lex_state = 207},
  [8596] = {.lex_state = 207},
  [8597] = {.lex_state = 206},
  [8598] = {.lex_state = 185},
  [8599] = {.lex_state = 251},
  [8600] = {.lex_state = 252},
  [8601] = {.lex_state = 351},
  [8602] = {.lex_state = 185},
  [8603] = {.lex_state = 206},
  [8604] = {.lex_state = 215},
  [8605] = {.lex_state = 206},
  [8606] = {.lex_state = 351},
  [8607] = {.lex_state = 215},
  [8608] = {.lex_state = 215},
  [8609] = {.lex_state = 215},
  [8610] = {.lex_state = 351},
  [8611] = {.lex_state = 206},
  [8612] = {.lex_state = 215},
  [8613] = {.lex_state = 215},
  [8614] = {.lex_state = 114},
  [8615] = {.lex_state = 351},
  [8616] = {.lex_state = 206},
  [8617] = {.lex_state = 248},
  [8618] = {.lex_state = 206},
  [8619] = {.lex_state = 116},
  [8620] = {.lex_state = 121},
  [8621] = {.lex_state = 215},
  [8622] = {.lex_state = 114},
  [8623] = {.lex_state = 206},
  [8624] = {.lex_state = 206},
  [8625] = {.lex_state = 114},
  [8626] = {.lex_state = 351},
  [8627] = {.lex_state = 114},
  [8628] = {.lex_state = 248},
  [8629] = {.lex_state = 185},
  [8630] = {.lex_state = 215},
  [8631] = {.lex_state = 215},
  [8632] = {.lex_state = 121},
  [8633] = {.lex_state = 185},
  [8634] = {.lex_state = 114},
  [8635] = {.lex_state = 351},
  [8636] = {.lex_state = 351},
  [8637] = {.lex_state = 351},
  [8638] = {.lex_state = 121},
  [8639] = {.lex_state = 114},
  [8640] = {.lex_state = 215},
  [8641] = {.lex_state = 351},
  [8642] = {.lex_state = 185},
  [8643] = {.lex_state = 215},
  [8644] = {.lex_state = 248},
  [8645] = {.lex_state = 206},
  [8646] = {.lex_state = 248},
  [8647] = {.lex_state = 206},
  [8648] = {.lex_state = 215},
  [8649] = {.lex_state = 215},
  [8650] = {.lex_state = 206},
  [8651] = {.lex_state = 351},
  [8652] = {.lex_state = 215},
  [8653] = {.lex_state = 351},
  [8654] = {.lex_state = 0},
  [8655] = {.lex_state = 185},
  [8656] = {.lex_state = 351},
  [8657] = {.lex_state = 185},
  [8658] = {.lex_state = 114},
  [8659] = {.lex_state = 114},
  [8660] = {.lex_state = 114},
  [8661] = {.lex_state = 351},
  [8662] = {.lex_state = 185},
  [8663] = {.lex_state = 215},
  [8664] = {.lex_state = 206},
  [8665] = {.lex_state = 206},
  [8666] = {.lex_state = 114},
  [8667] = {.lex_state = 248},
  [8668] = {.lex_state = 114},
  [8669] = {.lex_state = 215},
  [8670] = {.lex_state = 215},
  [8671] = {.lex_state = 248},
  [8672] = {.lex_state = 215},
  [8673] = {.lex_state = 206},
  [8674] = {.lex_state = 0},
  [8675] = {.lex_state = 252},
  [8676] = {.lex_state = 185},
  [8677] = {.lex_state = 351},
  [8678] = {.lex_state = 351},
  [8679] = {.lex_state = 185},
  [8680] = {.lex_state = 248},
  [8681] = {.lex_state = 0},
  [8682] = {.lex_state = 351},
  [8683] = {.lex_state = 215},
  [8684] = {.lex_state = 185},
  [8685] = {.lex_state = 206},
  [8686] = {.lex_state = 215},
  [8687] = {.lex_state = 351},
  [8688] = {.lex_state = 215},
  [8689] = {.lex_state = 351},
  [8690] = {.lex_state = 215},
  [8691] = {.lex_state = 215},
  [8692] = {.lex_state = 0},
  [8693] = {.lex_state = 215},
  [8694] = {.lex_state = 215},
  [8695] = {.lex_state = 215},
  [8696] = {.lex_state = 114},
  [8697] = {.lex_state = 351},
  [8698] = {.lex_state = 215},
  [8699] = {.lex_state = 206},
  [8700] = {.lex_state = 114},
  [8701] = {.lex_state = 206},
  [8702] = {.lex_state = 116},
  [8703] = {.lex_state = 215},
  [8704] = {.lex_state = 351},
  [8705] = {.lex_state = 215},
  [8706] = {.lex_state = 351},
  [8707] = {.lex_state = 351},
  [8708] = {.lex_state = 114},
  [8709] = {.lex_state = 215},
  [8710] = {.lex_state = 351},
  [8711] = {.lex_state = 185},
  [8712] = {.lex_state = 215},
  [8713] = {.lex_state = 121},
  [8714] = {.lex_state = 114},
  [8715] = {.lex_state = 351},
  [8716] = {.lex_state = 351},
  [8717] = {.lex_state = 351},
  [8718] = {.lex_state = 215},
  [8719] = {.lex_state = 215},
  [8720] = {.lex_state = 185},
  [8721] = {.lex_state = 351},
  [8722] = {.lex_state = 206},
  [8723] = {.lex_state = 206},
  [8724] = {.lex_state = 215},
  [8725] = {.lex_state = 206},
  [8726] = {.lex_state = 351},
  [8727] = {.lex_state = 215},
  [8728] = {.lex_state = 215},
  [8729] = {.lex_state = 248},
  [8730] = {.lex_state = 351},
  [8731] = {.lex_state = 215},
  [8732] = {.lex_state = 351},
  [8733] = {.lex_state = 185},
  [8734] = {.lex_state = 206},
  [8735] = {.lex_state = 215},
  [8736] = {.lex_state = 114},
  [8737] = {.lex_state = 206},
  [8738] = {.lex_state = 351},
  [8739] = {.lex_state = 215},
  [8740] = {.lex_state = 0},
  [8741] = {.lex_state = 215},
  [8742] = {.lex_state = 114},
  [8743] = {.lex_state = 215},
  [8744] = {.lex_state = 185},
  [8745] = {.lex_state = 351},
  [8746] = {.lex_state = 351},
  [8747] = {.lex_state = 248},
  [8748] = {.lex_state = 0},
  [8749] = {.lex_state = 0},
  [8750] = {.lex_state = 185},
  [8751] = {.lex_state = 351},
  [8752] = {.lex_state = 206},
  [8753] = {.lex_state = 215},
  [8754] = {.lex_state = 114},
  [8755] = {.lex_state = 351},
  [8756] = {.lex_state = 215},
  [8757] = {.lex_state = 252},
  [8758] = {.lex_state = 0},
  [8759] = {.lex_state = 121},
  [8760] = {.lex_state = 0},
  [8761] = {.lex_state = 0},
  [8762] = {.lex_state = 351},
  [8763] = {.lex_state = 116},
  [8764] = {.lex_state = 215},
  [8765] = {.lex_state = 215},
  [8766] = {.lex_state = 114},
  [8767] = {.lex_state = 206},
  [8768] = {.lex_state = 114},
  [8769] = {.lex_state = 114},
  [8770] = {.lex_state = 206},
  [8771] = {.lex_state = 114},
  [8772] = {.lex_state = 114},
  [8773] = {.lex_state = 116},
  [8774] = {.lex_state = 206},
  [8775] = {.lex_state = 116},
  [8776] = {.lex_state = 215},
  [8777] = {.lex_state = 114},
  [8778] = {.lex_state = 206},
  [8779] = {.lex_state = 215},
  [8780] = {.lex_state = 215},
  [8781] = {.lex_state = 351},
  [8782] = {.lex_state = 206},
  [8783] = {.lex_state = 121},
  [8784] = {.lex_state = 351},
  [8785] = {.lex_state = 114},
  [8786] = {.lex_state = 215},
  [8787] = {.lex_state = 351},
  [8788] = {.lex_state = 121},
  [8789] = {.lex_state = 185},
  [8790] = {.lex_state = 0},
  [8791] = {.lex_state = 351},
  [8792] = {.lex_state = 206},
  [8793] = {.lex_state = 351},
  [8794] = {.lex_state = 206},
  [8795] = {.lex_state = 351},
  [8796] = {.lex_state = 351},
  [8797] = {.lex_state = 114},
  [8798] = {.lex_state = 0},
  [8799] = {.lex_state = 351},
  [8800] = {.lex_state = 114},
  [8801] = {.lex_state = 351},
  [8802] = {.lex_state = 351},
  [8803] = {.lex_state = 215},
  [8804] = {.lex_state = 215},
  [8805] = {.lex_state = 351},
  [8806] = {.lex_state = 116},
  [8807] = {.lex_state = 121},
  [8808] = {.lex_state = 351},
  [8809] = {.lex_state = 114},
  [8810] = {.lex_state = 185},
  [8811] = {.lex_state = 351},
  [8812] = {.lex_state = 351},
  [8813] = {.lex_state = 206},
  [8814] = {.lex_state = 351},
  [8815] = {.lex_state = 351},
  [8816] = {.lex_state = 351},
  [8817] = {.lex_state = 351},
  [8818] = {.lex_state = 185},
  [8819] = {.lex_state = 185},
  [8820] = {.lex_state = 206},
  [8821] = {.lex_state = 121},
  [8822] = {.lex_state = 351},
  [8823] = {.lex_state = 206},
  [8824] = {.lex_state = 351},
  [8825] = {.lex_state = 206},
  [8826] = {.lex_state = 351},
  [8827] = {.lex_state = 185},
  [8828] = {.lex_state = 351},
  [8829] = {.lex_state = 206},
  [8830] = {.lex_state = 215},
  [8831] = {.lex_state = 351},
  [8832] = {.lex_state = 215},
  [8833] = {.lex_state = 0},
  [8834] = {.lex_state = 351},
  [8835] = {.lex_state = 351},
  [8836] = {.lex_state = 351},
  [8837] = {.lex_state = 114},
  [8838] = {.lex_state = 351},
  [8839] = {.lex_state = 114},
  [8840] = {.lex_state = 351},
  [8841] = {.lex_state = 121},
  [8842] = {.lex_state = 215},
  [8843] = {.lex_state = 121},
  [8844] = {.lex_state = 114},
  [8845] = {.lex_state = 351},
  [8846] = {.lex_state = 351},
  [8847] = {.lex_state = 351},
  [8848] = {.lex_state = 185},
  [8849] = {.lex_state = 351},
  [8850] = {.lex_state = 206},
  [8851] = {.lex_state = 114},
  [8852] = {.lex_state = 215},
  [8853] = {.lex_state = 351},
  [8854] = {.lex_state = 215},
  [8855] = {.lex_state = 185},
  [8856] = {.lex_state = 351},
  [8857] = {.lex_state = 206},
  [8858] = {.lex_state = 206},
  [8859] = {.lex_state = 206},
  [8860] = {.lex_state = 185},
  [8861] = {.lex_state = 351},
  [8862] = {.lex_state = 185},
  [8863] = {.lex_state = 206},
  [8864] = {.lex_state = 351},
  [8865] = {.lex_state = 351},
  [8866] = {.lex_state = 351},
  [8867] = {.lex_state = 351},
  [8868] = {.lex_state = 351},
  [8869] = {.lex_state = 248},
  [8870] = {.lex_state = 114},
  [8871] = {.lex_state = 185},
  [8872] = {.lex_state = 215},
  [8873] = {.lex_state = 215},
  [8874] = {.lex_state = 121},
  [8875] = {.lex_state = 351},
  [8876] = {.lex_state = 114},
  [8877] = {.lex_state = 351},
  [8878] = {.lex_state = 351},
  [8879] = {.lex_state = 185},
  [8880] = {.lex_state = 206},
  [8881] = {.lex_state = 351},
  [8882] = {.lex_state = 215},
  [8883] = {.lex_state = 351},
  [8884] = {.lex_state = 351},
  [8885] = {.lex_state = 215},
  [8886] = {.lex_state = 206},
  [8887] = {.lex_state = 206},
  [8888] = {.lex_state = 206},
  [8889] = {.lex_state = 215},
  [8890] = {.lex_state = 215},
  [8891] = {.lex_state = 185},
  [8892] = {.lex_state = 206},
  [8893] = {.lex_state = 206},
  [8894] = {.lex_state = 351},
  [8895] = {.lex_state = 351},
  [8896] = {.lex_state = 185},
  [8897] = {.lex_state = 351},
  [8898] = {.lex_state = 206},
  [8899] = {.lex_state = 351},
  [8900] = {.lex_state = 351},
  [8901] = {.lex_state = 248},
  [8902] = {.lex_state = 351},
  [8903] = {.lex_state = 114},
  [8904] = {.lex_state = 114},
  [8905] = {.lex_state = 206},
  [8906] = {.lex_state = 215},
  [8907] = {.lex_state = 351},
  [8908] = {.lex_state = 351},
  [8909] = {.lex_state = 114},
  [8910] = {.lex_state = 351},
  [8911] = {.lex_state = 206},
  [8912] = {.lex_state = 114},
  [8913] = {.lex_state = 215},
  [8914] = {.lex_state = 206},
  [8915] = {.lex_state = 215},
  [8916] = {.lex_state = 206},
  [8917] = {.lex_state = 0},
  [8918] = {.lex_state = 351},
  [8919] = {.lex_state = 351},
  [8920] = {.lex_state = 215},
  [8921] = {.lex_state = 215},
  [8922] = {.lex_state = 351},
  [8923] = {.lex_state = 121},
  [8924] = {.lex_state = 116},
  [8925] = {.lex_state = 185},
  [8926] = {.lex_state = 215},
  [8927] = {.lex_state = 185},
  [8928] = {.lex_state = 215},
  [8929] = {.lex_state = 185},
  [8930] = {.lex_state = 351},
  [8931] = {.lex_state = 185},
  [8932] = {.lex_state = 351},
  [8933] = {.lex_state = 351},
  [8934] = {.lex_state = 215},
  [8935] = {.lex_state = 351},
  [8936] = {.lex_state = 351},
  [8937] = {.lex_state = 351},
  [8938] = {.lex_state = 206},
  [8939] = {.lex_state = 114},
  [8940] = {.lex_state = 0},
  [8941] = {.lex_state = 0},
  [8942] = {.lex_state = 215},
  [8943] = {.lex_state = 0},
  [8944] = {.lex_state = 0},
  [8945] = {.lex_state = 0},
  [8946] = {.lex_state = 0},
  [8947] = {.lex_state = 0},
  [8948] = {.lex_state = 0},
  [8949] = {.lex_state = 0},
  [8950] = {.lex_state = 0},
  [8951] = {.lex_state = 0},
  [8952] = {.lex_state = 0},
  [8953] = {.lex_state = 0},
  [8954] = {.lex_state = 0},
  [8955] = {.lex_state = 0},
  [8956] = {.lex_state = 0},
  [8957] = {.lex_state = 0},
  [8958] = {.lex_state = 0},
  [8959] = {.lex_state = 0},
  [8960] = {.lex_state = 0},
  [8961] = {.lex_state = 0},
  [8962] = {.lex_state = 0},
  [8963] = {.lex_state = 0},
  [8964] = {.lex_state = 0},
  [8965] = {.lex_state = 0},
  [8966] = {.lex_state = 0},
  [8967] = {.lex_state = 0},
  [8968] = {.lex_state = 0},
  [8969] = {.lex_state = 0},
  [8970] = {.lex_state = 0},
  [8971] = {.lex_state = 0},
  [8972] = {.lex_state = 0},
  [8973] = {.lex_state = 0},
  [8974] = {.lex_state = 0},
  [8975] = {.lex_state = 0},
  [8976] = {.lex_state = 121},
  [8977] = {.lex_state = 0},
  [8978] = {.lex_state = 0},
  [8979] = {.lex_state = 0},
  [8980] = {.lex_state = 0},
  [8981] = {.lex_state = 0},
  [8982] = {.lex_state = 0},
  [8983] = {.lex_state = 0},
  [8984] = {.lex_state = 0},
  [8985] = {.lex_state = 0},
  [8986] = {.lex_state = 0},
  [8987] = {.lex_state = 185},
  [8988] = {.lex_state = 206},
  [8989] = {.lex_state = 0},
  [8990] = {.lex_state = 0},
  [8991] = {.lex_state = 0},
  [8992] = {.lex_state = 0},
  [8993] = {.lex_state = 121},
  [8994] = {.lex_state = 0},
  [8995] = {.lex_state = 0},
  [8996] = {.lex_state = 0},
  [8997] = {.lex_state = 121},
  [8998] = {.lex_state = 0},
  [8999] = {.lex_state = 215},
  [9000] = {.lex_state = 0},
  [9001] = {.lex_state = 0},
  [9002] = {.lex_state = 351},
  [9003] = {.lex_state = 0},
  [9004] = {.lex_state = 215},
  [9005] = {.lex_state = 0},
  [9006] = {.lex_state = 0},
  [9007] = {.lex_state = 0},
  [9008] = {.lex_state = 0},
  [9009] = {.lex_state = 121},
  [9010] = {.lex_state = 0},
  [9011] = {.lex_state = 0},
  [9012] = {.lex_state = 0},
  [9013] = {.lex_state = 351},
  [9014] = {.lex_state = 206},
  [9015] = {.lex_state = 0},
  [9016] = {.lex_state = 0},
  [9017] = {.lex_state = 0},
  [9018] = {.lex_state = 0},
  [9019] = {.lex_state = 206},
  [9020] = {.lex_state = 121},
  [9021] = {.lex_state = 0},
  [9022] = {.lex_state = 215},
  [9023] = {.lex_state = 0},
  [9024] = {.lex_state = 215},
  [9025] = {.lex_state = 215},
  [9026] = {.lex_state = 215},
  [9027] = {.lex_state = 0},
  [9028] = {.lex_state = 206},
  [9029] = {.lex_state = 0},
  [9030] = {.lex_state = 0},
  [9031] = {.lex_state = 0},
  [9032] = {.lex_state = 0},
  [9033] = {.lex_state = 206},
  [9034] = {.lex_state = 351},
  [9035] = {.lex_state = 0},
  [9036] = {.lex_state = 0},
  [9037] = {.lex_state = 0},
  [9038] = {.lex_state = 0},
  [9039] = {.lex_state = 0},
  [9040] = {.lex_state = 0},
  [9041] = {.lex_state = 0},
  [9042] = {.lex_state = 206},
  [9043] = {.lex_state = 0},
  [9044] = {.lex_state = 0},
  [9045] = {.lex_state = 0},
  [9046] = {.lex_state = 0},
  [9047] = {.lex_state = 0},
  [9048] = {.lex_state = 351},
  [9049] = {.lex_state = 0},
  [9050] = {.lex_state = 0},
  [9051] = {.lex_state = 215},
  [9052] = {.lex_state = 121},
  [9053] = {.lex_state = 0},
  [9054] = {.lex_state = 215},
  [9055] = {.lex_state = 0},
  [9056] = {.lex_state = 215},
  [9057] = {.lex_state = 215},
  [9058] = {.lex_state = 0},
  [9059] = {.lex_state = 206},
  [9060] = {.lex_state = 206},
  [9061] = {.lex_state = 0},
  [9062] = {.lex_state = 215},
  [9063] = {.lex_state = 0},
  [9064] = {.lex_state = 0},
  [9065] = {.lex_state = 0},
  [9066] = {.lex_state = 0},
  [9067] = {.lex_state = 0},
  [9068] = {.lex_state = 0},
  [9069] = {.lex_state = 0},
  [9070] = {.lex_state = 215},
  [9071] = {.lex_state = 215},
  [9072] = {.lex_state = 0},
  [9073] = {.lex_state = 0},
  [9074] = {.lex_state = 0},
  [9075] = {.lex_state = 0},
  [9076] = {.lex_state = 0},
  [9077] = {.lex_state = 0},
  [9078] = {.lex_state = 0},
  [9079] = {.lex_state = 0},
  [9080] = {.lex_state = 0},
  [9081] = {.lex_state = 0},
  [9082] = {.lex_state = 0},
  [9083] = {.lex_state = 0},
  [9084] = {.lex_state = 0},
  [9085] = {.lex_state = 0},
  [9086] = {.lex_state = 0},
  [9087] = {.lex_state = 0},
  [9088] = {.lex_state = 0},
  [9089] = {.lex_state = 351},
  [9090] = {.lex_state = 0},
  [9091] = {.lex_state = 0},
  [9092] = {.lex_state = 0},
  [9093] = {.lex_state = 0},
  [9094] = {.lex_state = 0},
  [9095] = {.lex_state = 0},
  [9096] = {.lex_state = 0},
  [9097] = {.lex_state = 121},
  [9098] = {.lex_state = 0},
  [9099] = {.lex_state = 0},
  [9100] = {.lex_state = 0},
  [9101] = {.lex_state = 0},
  [9102] = {.lex_state = 0},
  [9103] = {.lex_state = 0},
  [9104] = {.lex_state = 0},
  [9105] = {.lex_state = 215},
  [9106] = {.lex_state = 0},
  [9107] = {.lex_state = 206},
  [9108] = {.lex_state = 0},
  [9109] = {.lex_state = 0},
  [9110] = {.lex_state = 215},
  [9111] = {.lex_state = 206},
  [9112] = {.lex_state = 0},
  [9113] = {.lex_state = 185},
  [9114] = {.lex_state = 0},
  [9115] = {.lex_state = 0},
  [9116] = {.lex_state = 351},
  [9117] = {.lex_state = 0},
  [9118] = {.lex_state = 0},
  [9119] = {.lex_state = 206},
  [9120] = {.lex_state = 0},
  [9121] = {.lex_state = 0},
  [9122] = {.lex_state = 206},
  [9123] = {.lex_state = 0},
  [9124] = {.lex_state = 0},
  [9125] = {.lex_state = 0},
  [9126] = {.lex_state = 351},
  [9127] = {.lex_state = 206},
  [9128] = {.lex_state = 0},
  [9129] = {.lex_state = 0},
  [9130] = {.lex_state = 0},
  [9131] = {.lex_state = 0},
  [9132] = {.lex_state = 0},
  [9133] = {.lex_state = 0},
  [9134] = {.lex_state = 0},
  [9135] = {.lex_state = 0},
  [9136] = {.lex_state = 0},
  [9137] = {.lex_state = 0},
  [9138] = {.lex_state = 121},
  [9139] = {.lex_state = 206},
  [9140] = {.lex_state = 349},
  [9141] = {.lex_state = 0},
  [9142] = {.lex_state = 0},
  [9143] = {.lex_state = 0},
  [9144] = {.lex_state = 0},
  [9145] = {.lex_state = 0},
  [9146] = {.lex_state = 351},
  [9147] = {.lex_state = 0},
  [9148] = {.lex_state = 0},
  [9149] = {.lex_state = 0},
  [9150] = {.lex_state = 206},
  [9151] = {.lex_state = 0},
  [9152] = {.lex_state = 0},
  [9153] = {.lex_state = 206},
  [9154] = {.lex_state = 0},
  [9155] = {.lex_state = 0},
  [9156] = {.lex_state = 0},
  [9157] = {.lex_state = 0},
  [9158] = {.lex_state = 0},
  [9159] = {.lex_state = 0},
  [9160] = {.lex_state = 215},
  [9161] = {.lex_state = 0},
  [9162] = {.lex_state = 0},
  [9163] = {.lex_state = 0},
  [9164] = {.lex_state = 351},
  [9165] = {.lex_state = 0},
  [9166] = {.lex_state = 0},
  [9167] = {.lex_state = 215},
  [9168] = {.lex_state = 0},
  [9169] = {.lex_state = 0},
  [9170] = {.lex_state = 0},
  [9171] = {.lex_state = 215},
  [9172] = {.lex_state = 0},
  [9173] = {.lex_state = 351},
  [9174] = {.lex_state = 0},
  [9175] = {.lex_state = 0},
  [9176] = {.lex_state = 0},
  [9177] = {.lex_state = 0},
  [9178] = {.lex_state = 351},
  [9179] = {.lex_state = 0},
  [9180] = {.lex_state = 0},
  [9181] = {.lex_state = 0},
  [9182] = {.lex_state = 0},
  [9183] = {.lex_state = 0},
  [9184] = {.lex_state = 0},
  [9185] = {.lex_state = 0},
  [9186] = {.lex_state = 0},
  [9187] = {.lex_state = 0},
  [9188] = {.lex_state = 0},
  [9189] = {.lex_state = 0},
  [9190] = {.lex_state = 0},
  [9191] = {.lex_state = 0},
  [9192] = {.lex_state = 0},
  [9193] = {.lex_state = 0},
  [9194] = {.lex_state = 0},
  [9195] = {.lex_state = 0},
  [9196] = {.lex_state = 206},
  [9197] = {.lex_state = 0},
  [9198] = {.lex_state = 0},
  [9199] = {.lex_state = 0},
  [9200] = {.lex_state = 0},
  [9201] = {.lex_state = 0},
  [9202] = {.lex_state = 206},
  [9203] = {.lex_state = 206},
  [9204] = {.lex_state = 0},
  [9205] = {.lex_state = 0},
  [9206] = {.lex_state = 0},
  [9207] = {.lex_state = 206},
  [9208] = {.lex_state = 215},
  [9209] = {.lex_state = 0},
  [9210] = {.lex_state = 0},
  [9211] = {.lex_state = 0},
  [9212] = {.lex_state = 0},
  [9213] = {.lex_state = 0},
  [9214] = {.lex_state = 0},
  [9215] = {.lex_state = 0},
  [9216] = {.lex_state = 0},
  [9217] = {.lex_state = 0},
  [9218] = {.lex_state = 0},
  [9219] = {.lex_state = 0},
  [9220] = {.lex_state = 0},
  [9221] = {.lex_state = 0},
  [9222] = {.lex_state = 0},
  [9223] = {.lex_state = 0},
  [9224] = {.lex_state = 0},
  [9225] = {.lex_state = 0},
  [9226] = {.lex_state = 351},
  [9227] = {.lex_state = 0},
  [9228] = {.lex_state = 0},
  [9229] = {.lex_state = 206},
  [9230] = {.lex_state = 0},
  [9231] = {.lex_state = 206},
  [9232] = {.lex_state = 0},
  [9233] = {.lex_state = 0},
  [9234] = {.lex_state = 0},
  [9235] = {.lex_state = 0},
  [9236] = {.lex_state = 0},
  [9237] = {.lex_state = 0},
  [9238] = {.lex_state = 0},
  [9239] = {.lex_state = 0},
  [9240] = {.lex_state = 0},
  [9241] = {.lex_state = 215},
  [9242] = {.lex_state = 0},
  [9243] = {.lex_state = 0},
  [9244] = {.lex_state = 351},
  [9245] = {.lex_state = 206},
  [9246] = {.lex_state = 0},
  [9247] = {.lex_state = 0},
  [9248] = {.lex_state = 0},
  [9249] = {.lex_state = 215},
  [9250] = {.lex_state = 0},
  [9251] = {.lex_state = 248},
  [9252] = {.lex_state = 351},
  [9253] = {.lex_state = 118},
  [9254] = {.lex_state = 0},
  [9255] = {.lex_state = 0},
  [9256] = {.lex_state = 0},
  [9257] = {.lex_state = 0},
  [9258] = {.lex_state = 0},
  [9259] = {.lex_state = 215},
  [9260] = {.lex_state = 0},
  [9261] = {.lex_state = 215},
  [9262] = {.lex_state = 206},
  [9263] = {.lex_state = 0},
  [9264] = {.lex_state = 215},
  [9265] = {.lex_state = 206},
  [9266] = {.lex_state = 206},
  [9267] = {.lex_state = 0},
  [9268] = {.lex_state = 0},
  [9269] = {.lex_state = 0},
  [9270] = {.lex_state = 0},
  [9271] = {.lex_state = 0},
  [9272] = {.lex_state = 0},
  [9273] = {.lex_state = 0},
  [9274] = {.lex_state = 215},
  [9275] = {.lex_state = 215},
  [9276] = {.lex_state = 0},
  [9277] = {.lex_state = 215},
  [9278] = {.lex_state = 215},
  [9279] = {.lex_state = 0},
  [9280] = {.lex_state = 215},
  [9281] = {.lex_state = 0},
  [9282] = {.lex_state = 0},
  [9283] = {.lex_state = 0},
  [9284] = {.lex_state = 206},
  [9285] = {.lex_state = 0},
  [9286] = {.lex_state = 0},
  [9287] = {.lex_state = 0},
  [9288] = {.lex_state = 0},
  [9289] = {.lex_state = 0},
  [9290] = {.lex_state = 0},
  [9291] = {.lex_state = 0},
  [9292] = {.lex_state = 0},
  [9293] = {.lex_state = 0},
  [9294] = {.lex_state = 215},
  [9295] = {.lex_state = 0},
  [9296] = {.lex_state = 0},
  [9297] = {.lex_state = 0},
  [9298] = {.lex_state = 0},
  [9299] = {.lex_state = 0},
  [9300] = {.lex_state = 351},
  [9301] = {.lex_state = 0},
  [9302] = {.lex_state = 0},
  [9303] = {.lex_state = 206},
  [9304] = {.lex_state = 0},
  [9305] = {.lex_state = 0},
  [9306] = {.lex_state = 121},
  [9307] = {.lex_state = 0},
  [9308] = {.lex_state = 215},
  [9309] = {.lex_state = 0},
  [9310] = {.lex_state = 0},
  [9311] = {.lex_state = 0},
  [9312] = {.lex_state = 215},
  [9313] = {.lex_state = 206},
  [9314] = {.lex_state = 0},
  [9315] = {.lex_state = 0},
  [9316] = {.lex_state = 206},
  [9317] = {.lex_state = 0},
  [9318] = {.lex_state = 206},
  [9319] = {.lex_state = 0},
  [9320] = {.lex_state = 0},
  [9321] = {.lex_state = 0},
  [9322] = {.lex_state = 0},
  [9323] = {.lex_state = 0},
  [9324] = {.lex_state = 0},
  [9325] = {.lex_state = 206},
  [9326] = {.lex_state = 0},
  [9327] = {.lex_state = 0},
  [9328] = {.lex_state = 0},
  [9329] = {.lex_state = 0},
  [9330] = {.lex_state = 0},
  [9331] = {.lex_state = 0},
  [9332] = {.lex_state = 0},
  [9333] = {.lex_state = 0},
  [9334] = {.lex_state = 0},
  [9335] = {.lex_state = 215},
  [9336] = {.lex_state = 0},
  [9337] = {.lex_state = 0},
  [9338] = {.lex_state = 0},
  [9339] = {.lex_state = 0},
  [9340] = {.lex_state = 215},
  [9341] = {.lex_state = 215},
  [9342] = {.lex_state = 0},
  [9343] = {.lex_state = 215},
  [9344] = {.lex_state = 0},
  [9345] = {.lex_state = 0},
  [9346] = {.lex_state = 0},
  [9347] = {.lex_state = 0},
  [9348] = {.lex_state = 0},
  [9349] = {.lex_state = 0},
  [9350] = {.lex_state = 0},
  [9351] = {.lex_state = 206},
  [9352] = {.lex_state = 0},
  [9353] = {.lex_state = 0},
  [9354] = {.lex_state = 206},
  [9355] = {.lex_state = 0},
  [9356] = {.lex_state = 0},
  [9357] = {.lex_state = 0},
  [9358] = {.lex_state = 0},
  [9359] = {.lex_state = 206},
  [9360] = {.lex_state = 0},
  [9361] = {.lex_state = 0},
  [9362] = {.lex_state = 0},
  [9363] = {.lex_state = 0},
  [9364] = {.lex_state = 121},
  [9365] = {.lex_state = 118},
  [9366] = {.lex_state = 215},
  [9367] = {.lex_state = 206},
  [9368] = {.lex_state = 0},
  [9369] = {.lex_state = 206},
  [9370] = {.lex_state = 0},
  [9371] = {.lex_state = 0},
  [9372] = {.lex_state = 215},
  [9373] = {.lex_state = 206},
  [9374] = {.lex_state = 206},
  [9375] = {.lex_state = 0},
  [9376] = {.lex_state = 0},
  [9377] = {.lex_state = 349},
  [9378] = {.lex_state = 0},
  [9379] = {.lex_state = 349},
  [9380] = {.lex_state = 206},
  [9381] = {.lex_state = 0},
  [9382] = {.lex_state = 185},
  [9383] = {.lex_state = 351},
  [9384] = {.lex_state = 206},
  [9385] = {.lex_state = 0},
  [9386] = {.lex_state = 0},
  [9387] = {.lex_state = 351},
  [9388] = {.lex_state = 0},
  [9389] = {.lex_state = 0},
  [9390] = {.lex_state = 0},
  [9391] = {.lex_state = 0},
  [9392] = {.lex_state = 0},
  [9393] = {.lex_state = 351},
  [9394] = {.lex_state = 0},
  [9395] = {.lex_state = 0},
  [9396] = {.lex_state = 206},
  [9397] = {.lex_state = 206},
  [9398] = {.lex_state = 0},
  [9399] = {.lex_state = 0},
  [9400] = {.lex_state = 0},
  [9401] = {.lex_state = 0},
  [9402] = {.lex_state = 0},
  [9403] = {.lex_state = 0},
  [9404] = {.lex_state = 206},
  [9405] = {.lex_state = 215},
  [9406] = {.lex_state = 0},
  [9407] = {.lex_state = 0},
  [9408] = {.lex_state = 0},
  [9409] = {.lex_state = 206},
  [9410] = {.lex_state = 0},
  [9411] = {.lex_state = 215},
  [9412] = {.lex_state = 0},
  [9413] = {.lex_state = 0},
  [9414] = {.lex_state = 0},
  [9415] = {.lex_state = 0},
  [9416] = {.lex_state = 0},
  [9417] = {.lex_state = 0},
  [9418] = {.lex_state = 215},
  [9419] = {.lex_state = 0},
  [9420] = {.lex_state = 0},
  [9421] = {.lex_state = 0},
  [9422] = {.lex_state = 0},
  [9423] = {.lex_state = 215},
  [9424] = {.lex_state = 0},
  [9425] = {.lex_state = 351},
  [9426] = {.lex_state = 0},
  [9427] = {.lex_state = 118},
  [9428] = {.lex_state = 0},
  [9429] = {.lex_state = 0},
  [9430] = {.lex_state = 0},
  [9431] = {.lex_state = 0},
  [9432] = {.lex_state = 0},
  [9433] = {.lex_state = 0},
  [9434] = {.lex_state = 0},
  [9435] = {.lex_state = 206},
  [9436] = {.lex_state = 351},
  [9437] = {.lex_state = 206},
  [9438] = {.lex_state = 0},
  [9439] = {.lex_state = 0},
  [9440] = {.lex_state = 0},
  [9441] = {.lex_state = 0},
  [9442] = {.lex_state = 0},
  [9443] = {.lex_state = 215},
  [9444] = {.lex_state = 0},
  [9445] = {.lex_state = 0},
  [9446] = {.lex_state = 0},
  [9447] = {.lex_state = 0},
  [9448] = {.lex_state = 0},
  [9449] = {.lex_state = 0},
  [9450] = {.lex_state = 0},
  [9451] = {.lex_state = 0},
  [9452] = {.lex_state = 0},
  [9453] = {.lex_state = 0},
  [9454] = {.lex_state = 0},
  [9455] = {.lex_state = 0},
  [9456] = {.lex_state = 0},
  [9457] = {.lex_state = 0},
  [9458] = {.lex_state = 0},
  [9459] = {.lex_state = 0},
  [9460] = {.lex_state = 206},
  [9461] = {.lex_state = 0},
  [9462] = {.lex_state = 0},
  [9463] = {.lex_state = 215},
  [9464] = {.lex_state = 206},
  [9465] = {.lex_state = 0},
  [9466] = {.lex_state = 215},
  [9467] = {.lex_state = 0},
  [9468] = {.lex_state = 0},
  [9469] = {.lex_state = 0},
  [9470] = {.lex_state = 0},
  [9471] = {.lex_state = 215},
  [9472] = {.lex_state = 215},
  [9473] = {.lex_state = 215},
  [9474] = {.lex_state = 206},
  [9475] = {.lex_state = 0},
  [9476] = {.lex_state = 0},
  [9477] = {.lex_state = 0},
  [9478] = {.lex_state = 0},
  [9479] = {.lex_state = 0},
  [9480] = {.lex_state = 0},
  [9481] = {.lex_state = 0},
  [9482] = {.lex_state = 206},
  [9483] = {.lex_state = 0},
  [9484] = {.lex_state = 0},
  [9485] = {.lex_state = 206},
  [9486] = {.lex_state = 0},
  [9487] = {.lex_state = 0},
  [9488] = {.lex_state = 0},
  [9489] = {.lex_state = 215},
  [9490] = {.lex_state = 215},
  [9491] = {.lex_state = 0},
  [9492] = {.lex_state = 0},
  [9493] = {.lex_state = 0},
  [9494] = {.lex_state = 0},
  [9495] = {.lex_state = 0},
  [9496] = {.lex_state = 0},
  [9497] = {.lex_state = 0},
  [9498] = {.lex_state = 0},
  [9499] = {.lex_state = 0},
  [9500] = {.lex_state = 0},
  [9501] = {.lex_state = 0},
  [9502] = {.lex_state = 0},
  [9503] = {.lex_state = 0},
  [9504] = {.lex_state = 0},
  [9505] = {.lex_state = 0},
  [9506] = {.lex_state = 0},
  [9507] = {.lex_state = 206},
  [9508] = {.lex_state = 0},
  [9509] = {.lex_state = 206},
  [9510] = {.lex_state = 206},
  [9511] = {.lex_state = 0},
  [9512] = {.lex_state = 215},
  [9513] = {.lex_state = 0},
  [9514] = {.lex_state = 0},
  [9515] = {.lex_state = 206},
  [9516] = {.lex_state = 0},
  [9517] = {.lex_state = 121},
  [9518] = {.lex_state = 0},
  [9519] = {.lex_state = 0},
  [9520] = {.lex_state = 121},
  [9521] = {.lex_state = 0},
  [9522] = {.lex_state = 206},
  [9523] = {.lex_state = 0},
  [9524] = {.lex_state = 215},
  [9525] = {.lex_state = 0},
  [9526] = {.lex_state = 0},
  [9527] = {.lex_state = 0},
  [9528] = {.lex_state = 215},
  [9529] = {.lex_state = 0},
  [9530] = {.lex_state = 215},
  [9531] = {.lex_state = 0},
  [9532] = {.lex_state = 206},
  [9533] = {.lex_state = 0},
  [9534] = {.lex_state = 215},
  [9535] = {.lex_state = 206},
  [9536] = {.lex_state = 215},
  [9537] = {.lex_state = 0},
  [9538] = {.lex_state = 0},
  [9539] = {.lex_state = 0},
  [9540] = {.lex_state = 0},
  [9541] = {.lex_state = 0},
  [9542] = {.lex_state = 0},
  [9543] = {.lex_state = 351},
  [9544] = {.lex_state = 0},
  [9545] = {.lex_state = 0},
  [9546] = {.lex_state = 215},
  [9547] = {.lex_state = 0},
  [9548] = {.lex_state = 0},
  [9549] = {.lex_state = 0},
  [9550] = {.lex_state = 215},
  [9551] = {.lex_state = 215},
  [9552] = {.lex_state = 206},
  [9553] = {.lex_state = 206},
  [9554] = {.lex_state = 0},
  [9555] = {.lex_state = 206},
  [9556] = {.lex_state = 118},
  [9557] = {.lex_state = 0},
  [9558] = {.lex_state = 206},
  [9559] = {.lex_state = 0},
  [9560] = {.lex_state = 0},
  [9561] = {.lex_state = 0},
  [9562] = {.lex_state = 0},
  [9563] = {.lex_state = 0},
  [9564] = {.lex_state = 0},
  [9565] = {.lex_state = 0},
  [9566] = {.lex_state = 0},
  [9567] = {.lex_state = 0},
  [9568] = {.lex_state = 0},
  [9569] = {.lex_state = 0},
  [9570] = {.lex_state = 215},
  [9571] = {.lex_state = 0},
  [9572] = {.lex_state = 0},
  [9573] = {.lex_state = 215},
  [9574] = {.lex_state = 215},
  [9575] = {.lex_state = 0},
  [9576] = {.lex_state = 0},
  [9577] = {.lex_state = 215},
  [9578] = {.lex_state = 0},
  [9579] = {.lex_state = 0},
  [9580] = {.lex_state = 0},
  [9581] = {.lex_state = 0},
  [9582] = {.lex_state = 0},
  [9583] = {.lex_state = 0},
  [9584] = {.lex_state = 0},
  [9585] = {.lex_state = 0},
  [9586] = {.lex_state = 215},
  [9587] = {.lex_state = 0},
  [9588] = {.lex_state = 0},
  [9589] = {.lex_state = 0},
  [9590] = {.lex_state = 0},
  [9591] = {.lex_state = 0},
  [9592] = {.lex_state = 0},
  [9593] = {.lex_state = 0},
  [9594] = {.lex_state = 0},
  [9595] = {.lex_state = 351},
  [9596] = {.lex_state = 0},
  [9597] = {.lex_state = 0},
  [9598] = {.lex_state = 0},
  [9599] = {.lex_state = 0},
  [9600] = {.lex_state = 0},
  [9601] = {.lex_state = 0},
  [9602] = {.lex_state = 0},
  [9603] = {.lex_state = 206},
  [9604] = {.lex_state = 0},
  [9605] = {.lex_state = 206},
  [9606] = {.lex_state = 206},
  [9607] = {.lex_state = 0},
  [9608] = {.lex_state = 0},
  [9609] = {.lex_state = 349},
  [9610] = {.lex_state = 0},
  [9611] = {.lex_state = 206},
  [9612] = {.lex_state = 351},
  [9613] = {.lex_state = 0},
  [9614] = {.lex_state = 0},
  [9615] = {.lex_state = 0},
  [9616] = {.lex_state = 0},
  [9617] = {.lex_state = 0},
  [9618] = {.lex_state = 0},
  [9619] = {.lex_state = 215},
  [9620] = {.lex_state = 206},
  [9621] = {.lex_state = 0},
  [9622] = {.lex_state = 0},
  [9623] = {.lex_state = 0},
  [9624] = {.lex_state = 0},
  [9625] = {.lex_state = 206},
  [9626] = {.lex_state = 0},
  [9627] = {.lex_state = 206},
  [9628] = {.lex_state = 206},
  [9629] = {.lex_state = 0},
  [9630] = {.lex_state = 0},
  [9631] = {.lex_state = 206},
  [9632] = {.lex_state = 0},
  [9633] = {.lex_state = 0},
  [9634] = {.lex_state = 0},
  [9635] = {.lex_state = 0},
  [9636] = {.lex_state = 0},
  [9637] = {.lex_state = 0},
  [9638] = {.lex_state = 351},
  [9639] = {.lex_state = 215},
  [9640] = {.lex_state = 0},
  [9641] = {.lex_state = 206},
  [9642] = {.lex_state = 0},
  [9643] = {.lex_state = 0},
  [9644] = {.lex_state = 206},
  [9645] = {.lex_state = 206},
  [9646] = {.lex_state = 351},
  [9647] = {.lex_state = 351},
  [9648] = {.lex_state = 117},
  [9649] = {.lex_state = 351},
  [9650] = {.lex_state = 351},
  [9651] = {.lex_state = 351},
  [9652] = {.lex_state = 0},
  [9653] = {.lex_state = 0},
  [9654] = {.lex_state = 0},
  [9655] = {.lex_state = 206},
  [9656] = {.lex_state = 0},
  [9657] = {.lex_state = 0},
  [9658] = {.lex_state = 206},
  [9659] = {.lex_state = 351},
  [9660] = {.lex_state = 0},
  [9661] = {.lex_state = 0},
  [9662] = {.lex_state = 0},
  [9663] = {.lex_state = 0},
  [9664] = {.lex_state = 351},
  [9665] = {.lex_state = 0},
  [9666] = {.lex_state = 0},
  [9667] = {.lex_state = 0},
  [9668] = {.lex_state = 0},
  [9669] = {.lex_state = 206},
  [9670] = {.lex_state = 0},
  [9671] = {.lex_state = 0},
  [9672] = {.lex_state = 206},
  [9673] = {.lex_state = 0},
  [9674] = {.lex_state = 0},
  [9675] = {.lex_state = 0},
  [9676] = {.lex_state = 0},
  [9677] = {.lex_state = 0},
  [9678] = {.lex_state = 117},
  [9679] = {.lex_state = 0},
  [9680] = {.lex_state = 0},
  [9681] = {.lex_state = 0},
  [9682] = {.lex_state = 351},
  [9683] = {.lex_state = 0},
  [9684] = {.lex_state = 0},
  [9685] = {.lex_state = 206},
  [9686] = {.lex_state = 0},
  [9687] = {.lex_state = 0},
  [9688] = {.lex_state = 0},
  [9689] = {.lex_state = 0},
  [9690] = {.lex_state = 0},
  [9691] = {.lex_state = 351},
  [9692] = {.lex_state = 0},
  [9693] = {.lex_state = 0},
  [9694] = {.lex_state = 0},
  [9695] = {.lex_state = 0},
  [9696] = {.lex_state = 0},
  [9697] = {.lex_state = 206},
  [9698] = {.lex_state = 351},
  [9699] = {.lex_state = 351},
  [9700] = {.lex_state = 0},
  [9701] = {.lex_state = 206},
  [9702] = {.lex_state = 0},
  [9703] = {.lex_state = 0},
  [9704] = {.lex_state = 0},
  [9705] = {.lex_state = 0},
  [9706] = {.lex_state = 206},
  [9707] = {.lex_state = 0},
  [9708] = {.lex_state = 0},
  [9709] = {.lex_state = 206},
  [9710] = {.lex_state = 351},
  [9711] = {.lex_state = 351},
  [9712] = {.lex_state = 0},
  [9713] = {.lex_state = 351},
  [9714] = {.lex_state = 0},
  [9715] = {.lex_state = 0},
  [9716] = {.lex_state = 0},
  [9717] = {.lex_state = 0},
  [9718] = {.lex_state = 0},
  [9719] = {.lex_state = 206},
  [9720] = {.lex_state = 206},
  [9721] = {.lex_state = 351},
  [9722] = {.lex_state = 351},
  [9723] = {.lex_state = 351},
  [9724] = {.lex_state = 0},
  [9725] = {.lex_state = 351},
  [9726] = {.lex_state = 0},
  [9727] = {.lex_state = 351},
  [9728] = {.lex_state = 0},
  [9729] = {.lex_state = 0},
  [9730] = {.lex_state = 0},
  [9731] = {.lex_state = 0},
  [9732] = {.lex_state = 0},
  [9733] = {.lex_state = 351},
  [9734] = {.lex_state = 117},
  [9735] = {.lex_state = 0},
  [9736] = {.lex_state = 206},
  [9737] = {.lex_state = 351},
  [9738] = {.lex_state = 0},
  [9739] = {.lex_state = 351},
  [9740] = {.lex_state = 0},
  [9741] = {.lex_state = 0},
  [9742] = {.lex_state = 351},
  [9743] = {.lex_state = 206},
  [9744] = {.lex_state = 0},
  [9745] = {.lex_state = 0},
  [9746] = {.lex_state = 0},
  [9747] = {.lex_state = 0},
  [9748] = {.lex_state = 0},
  [9749] = {.lex_state = 0},
  [9750] = {.lex_state = 0},
  [9751] = {.lex_state = 0},
  [9752] = {.lex_state = 351},
  [9753] = {.lex_state = 0},
  [9754] = {.lex_state = 0},
  [9755] = {.lex_state = 117},
  [9756] = {.lex_state = 0},
  [9757] = {.lex_state = 0},
  [9758] = {.lex_state = 0},
  [9759] = {.lex_state = 206},
  [9760] = {.lex_state = 0},
  [9761] = {.lex_state = 351},
  [9762] = {.lex_state = 351},
  [9763] = {.lex_state = 351},
  [9764] = {.lex_state = 206},
  [9765] = {.lex_state = 0},
  [9766] = {.lex_state = 117},
  [9767] = {.lex_state = 351},
  [9768] = {.lex_state = 0},
  [9769] = {.lex_state = 351},
  [9770] = {.lex_state = 0},
  [9771] = {.lex_state = 0},
  [9772] = {.lex_state = 206},
  [9773] = {.lex_state = 206},
  [9774] = {.lex_state = 0},
  [9775] = {.lex_state = 0},
  [9776] = {.lex_state = 0},
  [9777] = {.lex_state = 0},
  [9778] = {.lex_state = 351},
  [9779] = {.lex_state = 206},
  [9780] = {.lex_state = 0},
  [9781] = {.lex_state = 351},
  [9782] = {.lex_state = 0},
  [9783] = {.lex_state = 0},
  [9784] = {.lex_state = 0},
  [9785] = {.lex_state = 206},
  [9786] = {.lex_state = 351},
  [9787] = {.lex_state = 351, .external_lex_state = 2},
  [9788] = {.lex_state = 0},
  [9789] = {.lex_state = 0},
  [9790] = {.lex_state = 0},
  [9791] = {.lex_state = 0},
  [9792] = {.lex_state = 117},
  [9793] = {.lex_state = 351},
  [9794] = {.lex_state = 0},
  [9795] = {.lex_state = 0},
  [9796] = {.lex_state = 0},
  [9797] = {.lex_state = 351},
  [9798] = {.lex_state = 0},
  [9799] = {.lex_state = 0},
  [9800] = {.lex_state = 351, .external_lex_state = 2},
  [9801] = {.lex_state = 117},
  [9802] = {.lex_state = 351},
  [9803] = {.lex_state = 351},
  [9804] = {.lex_state = 0},
  [9805] = {.lex_state = 351},
  [9806] = {.lex_state = 0},
  [9807] = {.lex_state = 117},
  [9808] = {.lex_state = 206},
  [9809] = {.lex_state = 0},
  [9810] = {.lex_state = 0},
  [9811] = {.lex_state = 0},
  [9812] = {.lex_state = 0},
  [9813] = {.lex_state = 0},
  [9814] = {.lex_state = 0},
  [9815] = {.lex_state = 0},
  [9816] = {.lex_state = 0},
  [9817] = {.lex_state = 0},
  [9818] = {.lex_state = 0},
  [9819] = {.lex_state = 206},
  [9820] = {.lex_state = 206},
  [9821] = {.lex_state = 351},
  [9822] = {.lex_state = 0},
  [9823] = {.lex_state = 351},
  [9824] = {.lex_state = 0},
  [9825] = {.lex_state = 117},
  [9826] = {.lex_state = 0},
  [9827] = {.lex_state = 351},
  [9828] = {.lex_state = 0},
  [9829] = {.lex_state = 206},
  [9830] = {.lex_state = 0},
  [9831] = {.lex_state = 0},
  [9832] = {.lex_state = 0},
  [9833] = {.lex_state = 351},
  [9834] = {.lex_state = 351, .external_lex_state = 2},
  [9835] = {.lex_state = 0},
  [9836] = {.lex_state = 0},
  [9837] = {.lex_state = 0},
  [9838] = {.lex_state = 0},
  [9839] = {.lex_state = 0},
  [9840] = {.lex_state = 0},
  [9841] = {.lex_state = 351},
  [9842] = {.lex_state = 117},
  [9843] = {.lex_state = 0},
  [9844] = {.lex_state = 0},
  [9845] = {.lex_state = 0},
  [9846] = {.lex_state = 117},
  [9847] = {.lex_state = 351},
  [9848] = {.lex_state = 0},
  [9849] = {.lex_state = 206},
  [9850] = {.lex_state = 351},
  [9851] = {.lex_state = 0},
  [9852] = {.lex_state = 0},
  [9853] = {.lex_state = 351},
  [9854] = {.lex_state = 0},
  [9855] = {.lex_state = 0},
  [9856] = {.lex_state = 351},
  [9857] = {.lex_state = 0},
  [9858] = {.lex_state = 351, .external_lex_state = 2},
  [9859] = {.lex_state = 0},
  [9860] = {.lex_state = 0},
  [9861] = {.lex_state = 206},
  [9862] = {.lex_state = 351},
  [9863] = {.lex_state = 0},
  [9864] = {.lex_state = 351},
  [9865] = {.lex_state = 206},
  [9866] = {.lex_state = 351},
  [9867] = {.lex_state = 117},
  [9868] = {.lex_state = 0},
  [9869] = {.lex_state = 0},
  [9870] = {.lex_state = 0},
  [9871] = {.lex_state = 0},
  [9872] = {.lex_state = 0},
  [9873] = {.lex_state = 206},
  [9874] = {.lex_state = 0},
  [9875] = {.lex_state = 206},
  [9876] = {.lex_state = 0},
  [9877] = {.lex_state = 0},
  [9878] = {.lex_state = 351},
  [9879] = {.lex_state = 0},
  [9880] = {.lex_state = 351},
  [9881] = {.lex_state = 0},
  [9882] = {.lex_state = 351},
  [9883] = {.lex_state = 0},
  [9884] = {.lex_state = 351},
  [9885] = {.lex_state = 0},
  [9886] = {.lex_state = 0},
  [9887] = {.lex_state = 0},
  [9888] = {.lex_state = 0},
  [9889] = {.lex_state = 206},
  [9890] = {.lex_state = 117},
  [9891] = {.lex_state = 0},
  [9892] = {.lex_state = 0},
  [9893] = {.lex_state = 0},
  [9894] = {.lex_state = 0},
  [9895] = {.lex_state = 0},
  [9896] = {.lex_state = 0},
  [9897] = {.lex_state = 0},
  [9898] = {.lex_state = 351},
  [9899] = {.lex_state = 0},
  [9900] = {.lex_state = 0},
  [9901] = {.lex_state = 0},
  [9902] = {.lex_state = 0},
  [9903] = {.lex_state = 0},
  [9904] = {.lex_state = 0},
  [9905] = {.lex_state = 0},
  [9906] = {.lex_state = 0},
  [9907] = {.lex_state = 0},
  [9908] = {.lex_state = 351, .external_lex_state = 2},
  [9909] = {.lex_state = 0},
  [9910] = {.lex_state = 0},
  [9911] = {.lex_state = 0},
  [9912] = {.lex_state = 351},
  [9913] = {.lex_state = 0},
  [9914] = {.lex_state = 206},
  [9915] = {.lex_state = 0},
  [9916] = {.lex_state = 206},
  [9917] = {.lex_state = 206},
  [9918] = {.lex_state = 0},
  [9919] = {.lex_state = 351},
  [9920] = {.lex_state = 0},
  [9921] = {.lex_state = 206},
  [9922] = {.lex_state = 351, .external_lex_state = 2},
  [9923] = {.lex_state = 0},
  [9924] = {.lex_state = 351},
  [9925] = {.lex_state = 0},
  [9926] = {.lex_state = 0},
  [9927] = {.lex_state = 351},
  [9928] = {.lex_state = 206},
  [9929] = {.lex_state = 351},
  [9930] = {.lex_state = 0},
  [9931] = {.lex_state = 206},
  [9932] = {.lex_state = 0},
  [9933] = {.lex_state = 0},
  [9934] = {.lex_state = 0},
  [9935] = {.lex_state = 351},
  [9936] = {.lex_state = 351},
  [9937] = {.lex_state = 351},
  [9938] = {.lex_state = 117},
  [9939] = {.lex_state = 206},
  [9940] = {.lex_state = 0},
  [9941] = {.lex_state = 0},
  [9942] = {.lex_state = 351},
  [9943] = {.lex_state = 0},
  [9944] = {.lex_state = 351, .external_lex_state = 2},
  [9945] = {.lex_state = 0},
  [9946] = {.lex_state = 0},
  [9947] = {.lex_state = 351},
  [9948] = {.lex_state = 351, .external_lex_state = 2},
  [9949] = {.lex_state = 0},
  [9950] = {.lex_state = 351},
  [9951] = {.lex_state = 351, .external_lex_state = 2},
  [9952] = {.lex_state = 0},
  [9953] = {.lex_state = 0},
  [9954] = {.lex_state = 351, .external_lex_state = 2},
  [9955] = {.lex_state = 351, .external_lex_state = 2},
  [9956] = {.lex_state = 0},
  [9957] = {.lex_state = 351},
  [9958] = {.lex_state = 351},
  [9959] = {.lex_state = 0},
  [9960] = {.lex_state = 351},
  [9961] = {.lex_state = 351, .external_lex_state = 2},
  [9962] = {.lex_state = 351},
  [9963] = {.lex_state = 351},
  [9964] = {.lex_state = 0},
  [9965] = {.lex_state = 0},
  [9966] = {.lex_state = 0},
  [9967] = {.lex_state = 0},
  [9968] = {.lex_state = 0},
  [9969] = {.lex_state = 206},
  [9970] = {.lex_state = 206},
  [9971] = {.lex_state = 351},
  [9972] = {.lex_state = 351, .external_lex_state = 2},
  [9973] = {.lex_state = 0},
  [9974] = {.lex_state = 351, .external_lex_state = 2},
  [9975] = {.lex_state = 351, .external_lex_state = 2},
  [9976] = {.lex_state = 351},
  [9977] = {.lex_state = 0},
  [9978] = {.lex_state = 0},
  [9979] = {.lex_state = 351, .external_lex_state = 2},
  [9980] = {.lex_state = 0},
  [9981] = {.lex_state = 0},
  [9982] = {.lex_state = 0},
  [9983] = {.lex_state = 206},
  [9984] = {.lex_state = 351, .external_lex_state = 2},
  [9985] = {.lex_state = 0},
  [9986] = {.lex_state = 0},
  [9987] = {.lex_state = 351},
  [9988] = {.lex_state = 0},
  [9989] = {.lex_state = 351},
  [9990] = {.lex_state = 0},
  [9991] = {.lex_state = 0},
  [9992] = {.lex_state = 351},
  [9993] = {.lex_state = 351},
  [9994] = {.lex_state = 0},
  [9995] = {.lex_state = 0},
  [9996] = {.lex_state = 351},
  [9997] = {.lex_state = 0},
  [9998] = {.lex_state = 206},
  [9999] = {.lex_state = 117},
  [10000] = {.lex_state = 0},
  [10001] = {.lex_state = 0},
  [10002] = {.lex_state = 0},
  [10003] = {.lex_state = 0},
  [10004] = {.lex_state = 351},
  [10005] = {.lex_state = 206},
  [10006] = {.lex_state = 0},
  [10007] = {.lex_state = 0},
  [10008] = {.lex_state = 206},
  [10009] = {.lex_state = 351},
  [10010] = {.lex_state = 0},
  [10011] = {.lex_state = 0},
  [10012] = {.lex_state = 351},
  [10013] = {.lex_state = 0},
  [10014] = {.lex_state = 0},
  [10015] = {.lex_state = 206},
  [10016] = {.lex_state = 0},
  [10017] = {.lex_state = 351},
  [10018] = {.lex_state = 351},
  [10019] = {.lex_state = 351},
  [10020] = {.lex_state = 0},
  [10021] = {.lex_state = 351},
  [10022] = {.lex_state = 351},
  [10023] = {.lex_state = 0},
  [10024] = {.lex_state = 0},
  [10025] = {.lex_state = 117},
  [10026] = {.lex_state = 0},
  [10027] = {.lex_state = 351},
  [10028] = {.lex_state = 0},
  [10029] = {.lex_state = 0},
  [10030] = {.lex_state = 0},
  [10031] = {.lex_state = 0},
  [10032] = {.lex_state = 351},
  [10033] = {.lex_state = 0},
  [10034] = {.lex_state = 0},
  [10035] = {.lex_state = 0},
  [10036] = {.lex_state = 351},
  [10037] = {.lex_state = 0},
  [10038] = {.lex_state = 0},
  [10039] = {.lex_state = 0},
  [10040] = {.lex_state = 0},
  [10041] = {.lex_state = 351},
  [10042] = {.lex_state = 206},
  [10043] = {.lex_state = 206},
  [10044] = {.lex_state = 0},
  [10045] = {.lex_state = 0},
  [10046] = {.lex_state = 0},
  [10047] = {.lex_state = 206},
  [10048] = {.lex_state = 0},
  [10049] = {.lex_state = 0},
  [10050] = {.lex_state = 0},
  [10051] = {.lex_state = 351},
  [10052] = {.lex_state = 351},
  [10053] = {.lex_state = 0},
  [10054] = {.lex_state = 0},
  [10055] = {.lex_state = 0},
  [10056] = {.lex_state = 0},
  [10057] = {.lex_state = 0},
  [10058] = {.lex_state = 351},
  [10059] = {.lex_state = 351},
  [10060] = {.lex_state = 117},
  [10061] = {.lex_state = 0},
  [10062] = {.lex_state = 206},
  [10063] = {.lex_state = 206},
  [10064] = {.lex_state = 351},
  [10065] = {.lex_state = 0},
  [10066] = {.lex_state = 0},
  [10067] = {.lex_state = 0},
  [10068] = {.lex_state = 206},
  [10069] = {.lex_state = 0},
  [10070] = {.lex_state = 0},
  [10071] = {.lex_state = 183},
  [10072] = {.lex_state = 0},
  [10073] = {.lex_state = 0},
  [10074] = {.lex_state = 0, .external_lex_state = 2},
  [10075] = {.lex_state = 183},
  [10076] = {.lex_state = 206},
  [10077] = {.lex_state = 0},
  [10078] = {.lex_state = 0},
  [10079] = {.lex_state = 0},
  [10080] = {.lex_state = 0},
  [10081] = {.lex_state = 0},
  [10082] = {.lex_state = 0},
  [10083] = {.lex_state = 206},
  [10084] = {.lex_state = 0, .external_lex_state = 2},
  [10085] = {.lex_state = 0, .external_lex_state = 2},
  [10086] = {.lex_state = 206},
  [10087] = {.lex_state = 0},
  [10088] = {.lex_state = 0},
  [10089] = {.lex_state = 206},
  [10090] = {.lex_state = 183},
  [10091] = {.lex_state = 0},
  [10092] = {.lex_state = 0},
  [10093] = {.lex_state = 0},
  [10094] = {.lex_state = 351},
  [10095] = {.lex_state = 0, .external_lex_state = 2},
  [10096] = {.lex_state = 0},
  [10097] = {.lex_state = 183},
  [10098] = {.lex_state = 0},
  [10099] = {.lex_state = 0},
  [10100] = {.lex_state = 0},
  [10101] = {.lex_state = 206},
  [10102] = {.lex_state = 0},
  [10103] = {.lex_state = 0},
  [10104] = {.lex_state = 206},
  [10105] = {.lex_state = 206},
  [10106] = {.lex_state = 0, .external_lex_state = 2},
  [10107] = {.lex_state = 206},
  [10108] = {.lex_state = 215},
  [10109] = {.lex_state = 0, .external_lex_state = 2},
  [10110] = {.lex_state = 0},
  [10111] = {.lex_state = 206},
  [10112] = {.lex_state = 0},
  [10113] = {.lex_state = 206},
  [10114] = {.lex_state = 0},
  [10115] = {.lex_state = 0},
  [10116] = {.lex_state = 0, .external_lex_state = 2},
  [10117] = {.lex_state = 0},
  [10118] = {.lex_state = 0},
  [10119] = {.lex_state = 0},
  [10120] = {.lex_state = 0},
  [10121] = {.lex_state = 0},
  [10122] = {.lex_state = 206},
  [10123] = {.lex_state = 0},
  [10124] = {.lex_state = 0, .external_lex_state = 2},
  [10125] = {.lex_state = 183},
  [10126] = {.lex_state = 183},
  [10127] = {.lex_state = 0},
  [10128] = {.lex_state = 0},
  [10129] = {.lex_state = 0},
  [10130] = {.lex_state = 183},
  [10131] = {.lex_state = 0, .external_lex_state = 2},
  [10132] = {.lex_state = 0},
  [10133] = {.lex_state = 118},
  [10134] = {.lex_state = 0},
  [10135] = {.lex_state = 0},
  [10136] = {.lex_state = 0},
  [10137] = {.lex_state = 206},
  [10138] = {.lex_state = 0, .external_lex_state = 2},
  [10139] = {.lex_state = 0},
  [10140] = {.lex_state = 183},
  [10141] = {.lex_state = 0},
  [10142] = {.lex_state = 206},
  [10143] = {.lex_state = 183},
  [10144] = {.lex_state = 206},
  [10145] = {.lex_state = 0, .external_lex_state = 2},
  [10146] = {.lex_state = 0},
  [10147] = {.lex_state = 0},
  [10148] = {.lex_state = 0},
  [10149] = {.lex_state = 0},
  [10150] = {.lex_state = 0, .external_lex_state = 3},
  [10151] = {.lex_state = 0},
  [10152] = {.lex_state = 0, .external_lex_state = 2},
  [10153] = {.lex_state = 0, .external_lex_state = 2},
  [10154] = {.lex_state = 0},
  [10155] = {.lex_state = 206},
  [10156] = {.lex_state = 183},
  [10157] = {.lex_state = 0},
  [10158] = {.lex_state = 0},
  [10159] = {.lex_state = 215},
  [10160] = {.lex_state = 0},
  [10161] = {.lex_state = 206},
  [10162] = {.lex_state = 0},
  [10163] = {.lex_state = 0},
  [10164] = {.lex_state = 351},
  [10165] = {.lex_state = 206},
  [10166] = {.lex_state = 206},
  [10167] = {.lex_state = 206},
  [10168] = {.lex_state = 118},
  [10169] = {.lex_state = 0},
  [10170] = {.lex_state = 0},
  [10171] = {.lex_state = 118},
  [10172] = {.lex_state = 0},
  [10173] = {.lex_state = 0},
  [10174] = {.lex_state = 0},
  [10175] = {.lex_state = 0},
  [10176] = {.lex_state = 0},
  [10177] = {.lex_state = 183},
  [10178] = {.lex_state = 0},
  [10179] = {.lex_state = 183},
  [10180] = {.lex_state = 0},
  [10181] = {.lex_state = 0, .external_lex_state = 2},
  [10182] = {.lex_state = 0},
  [10183] = {.lex_state = 351},
  [10184] = {.lex_state = 0},
  [10185] = {.lex_state = 206},
  [10186] = {.lex_state = 206},
  [10187] = {.lex_state = 0},
  [10188] = {.lex_state = 351},
  [10189] = {.lex_state = 0},
  [10190] = {.lex_state = 0},
  [10191] = {.lex_state = 206},
  [10192] = {.lex_state = 206},
  [10193] = {.lex_state = 0},
  [10194] = {.lex_state = 0},
  [10195] = {.lex_state = 0},
  [10196] = {.lex_state = 0},
  [10197] = {.lex_state = 183},
  [10198] = {.lex_state = 0},
  [10199] = {.lex_state = 0},
  [10200] = {.lex_state = 0},
  [10201] = {.lex_state = 351},
  [10202] = {.lex_state = 351},
  [10203] = {.lex_state = 0},
  [10204] = {.lex_state = 351},
  [10205] = {.lex_state = 351},
  [10206] = {.lex_state = 351},
  [10207] = {.lex_state = 351},
  [10208] = {.lex_state = 206},
  [10209] = {.lex_state = 351},
  [10210] = {.lex_state = 0},
  [10211] = {.lex_state = 351},
  [10212] = {.lex_state = 206},
  [10213] = {.lex_state = 206},
  [10214] = {.lex_state = 0},
  [10215] = {.lex_state = 0},
  [10216] = {.lex_state = 0},
  [10217] = {.lex_state = 0},
  [10218] = {.lex_state = 206},
  [10219] = {.lex_state = 206},
  [10220] = {.lex_state = 0},
  [10221] = {.lex_state = 206},
  [10222] = {.lex_state = 0},
  [10223] = {.lex_state = 183},
  [10224] = {.lex_state = 183},
  [10225] = {.lex_state = 206},
  [10226] = {.lex_state = 206},
  [10227] = {.lex_state = 351},
  [10228] = {.lex_state = 0},
  [10229] = {.lex_state = 0},
  [10230] = {.lex_state = 0},
  [10231] = {.lex_state = 206},
  [10232] = {.lex_state = 0},
  [10233] = {.lex_state = 0, .external_lex_state = 2},
  [10234] = {.lex_state = 351},
  [10235] = {.lex_state = 0, .external_lex_state = 3},
  [10236] = {.lex_state = 0},
  [10237] = {.lex_state = 0},
  [10238] = {.lex_state = 0},
  [10239] = {.lex_state = 351},
  [10240] = {.lex_state = 351},
  [10241] = {.lex_state = 0},
  [10242] = {.lex_state = 0},
  [10243] = {.lex_state = 0},
  [10244] = {.lex_state = 0},
  [10245] = {.lex_state = 0},
  [10246] = {.lex_state = 0},
  [10247] = {.lex_state = 0},
  [10248] = {.lex_state = 0},
  [10249] = {.lex_state = 0},
  [10250] = {.lex_state = 206},
  [10251] = {.lex_state = 0},
  [10252] = {.lex_state = 206},
  [10253] = {.lex_state = 0},
  [10254] = {.lex_state = 0},
  [10255] = {.lex_state = 215},
  [10256] = {.lex_state = 0, .external_lex_state = 3},
  [10257] = {.lex_state = 0},
  [10258] = {.lex_state = 0},
  [10259] = {.lex_state = 0},
  [10260] = {.lex_state = 0},
  [10261] = {.lex_state = 215},
  [10262] = {.lex_state = 206},
  [10263] = {.lex_state = 351},
  [10264] = {.lex_state = 0},
  [10265] = {.lex_state = 0},
  [10266] = {.lex_state = 206},
  [10267] = {.lex_state = 206},
  [10268] = {.lex_state = 215},
  [10269] = {.lex_state = 206},
  [10270] = {.lex_state = 215},
  [10271] = {.lex_state = 0},
  [10272] = {.lex_state = 0},
  [10273] = {.lex_state = 351},
  [10274] = {.lex_state = 206},
  [10275] = {.lex_state = 0},
  [10276] = {.lex_state = 206},
  [10277] = {.lex_state = 206},
  [10278] = {.lex_state = 183},
  [10279] = {.lex_state = 0},
  [10280] = {.lex_state = 183},
  [10281] = {.lex_state = 183},
  [10282] = {.lex_state = 0},
  [10283] = {.lex_state = 215},
  [10284] = {.lex_state = 351},
  [10285] = {.lex_state = 0},
  [10286] = {.lex_state = 206},
  [10287] = {.lex_state = 118},
  [10288] = {.lex_state = 0},
  [10289] = {.lex_state = 0},
  [10290] = {.lex_state = 0},
  [10291] = {.lex_state = 215},
  [10292] = {.lex_state = 183},
  [10293] = {.lex_state = 0},
  [10294] = {.lex_state = 0},
  [10295] = {.lex_state = 206},
  [10296] = {.lex_state = 118},
  [10297] = {.lex_state = 0},
  [10298] = {.lex_state = 118},
  [10299] = {.lex_state = 0},
  [10300] = {.lex_state = 0},
  [10301] = {.lex_state = 0},
  [10302] = {.lex_state = 0},
  [10303] = {.lex_state = 118},
  [10304] = {.lex_state = 0},
  [10305] = {.lex_state = 215},
  [10306] = {.lex_state = 0},
  [10307] = {.lex_state = 0},
  [10308] = {.lex_state = 118},
  [10309] = {.lex_state = 206},
  [10310] = {.lex_state = 0},
  [10311] = {.lex_state = 183},
  [10312] = {.lex_state = 351},
  [10313] = {.lex_state = 0},
  [10314] = {.lex_state = 183},
  [10315] = {.lex_state = 0},
  [10316] = {.lex_state = 0},
  [10317] = {.lex_state = 0},
  [10318] = {.lex_state = 183},
  [10319] = {.lex_state = 0},
  [10320] = {.lex_state = 0},
  [10321] = {.lex_state = 183},
  [10322] = {.lex_state = 183},
  [10323] = {.lex_state = 206},
  [10324] = {.lex_state = 183},
  [10325] = {.lex_state = 0},
  [10326] = {.lex_state = 351},
  [10327] = {.lex_state = 0},
  [10328] = {.lex_state = 118},
  [10329] = {.lex_state = 183},
  [10330] = {.lex_state = 206},
  [10331] = {.lex_state = 0},
  [10332] = {.lex_state = 183},
  [10333] = {.lex_state = 0},
  [10334] = {.lex_state = 0},
  [10335] = {.lex_state = 0},
  [10336] = {.lex_state = 0},
  [10337] = {.lex_state = 118},
  [10338] = {.lex_state = 0},
  [10339] = {.lex_state = 0},
  [10340] = {.lex_state = 205},
  [10341] = {.lex_state = 0},
  [10342] = {.lex_state = 249},
  [10343] = {.lex_state = 206},
  [10344] = {.lex_state = 351},
  [10345] = {.lex_state = 351},
  [10346] = {.lex_state = 351},
  [10347] = {.lex_state = 0},
  [10348] = {.lex_state = 0},
  [10349] = {.lex_state = 0},
  [10350] = {.lex_state = 181},
  [10351] = {.lex_state = 351},
  [10352] = {.lex_state = 183},
  [10353] = {.lex_state = 0},
  [10354] = {.lex_state = 351},
  [10355] = {.lex_state = 0},
  [10356] = {.lex_state = 0},
  [10357] = {.lex_state = 0},
  [10358] = {.lex_state = 351},
  [10359] = {.lex_state = 0},
  [10360] = {.lex_state = 181},
  [10361] = {.lex_state = 0},
  [10362] = {.lex_state = 184},
  [10363] = {.lex_state = 205},
  [10364] = {.lex_state = 0},
  [10365] = {.lex_state = 351},
  [10366] = {.lex_state = 350},
  [10367] = {.lex_state = 0},
  [10368] = {.lex_state = 215},
  [10369] = {.lex_state = 0},
  [10370] = {.lex_state = 0},
  [10371] = {.lex_state = 184},
  [10372] = {.lex_state = 351},
  [10373] = {.lex_state = 0, .external_lex_state = 2},
  [10374] = {.lex_state = 0},
  [10375] = {.lex_state = 0},
  [10376] = {.lex_state = 0},
  [10377] = {.lex_state = 0},
  [10378] = {.lex_state = 0},
  [10379] = {.lex_state = 0},
  [10380] = {.lex_state = 0},
  [10381] = {.lex_state = 0},
  [10382] = {.lex_state = 0},
  [10383] = {.lex_state = 118},
  [10384] = {.lex_state = 183},
  [10385] = {.lex_state = 0},
  [10386] = {.lex_state = 183},
  [10387] = {.lex_state = 0},
  [10388] = {.lex_state = 0},
  [10389] = {.lex_state = 0},
  [10390] = {.lex_state = 206},
  [10391] = {.lex_state = 206},
  [10392] = {.lex_state = 0},
  [10393] = {.lex_state = 351},
  [10394] = {.lex_state = 183},
  [10395] = {.lex_state = 0},
  [10396] = {.lex_state = 0},
  [10397] = {.lex_state = 215},
  [10398] = {.lex_state = 0},
  [10399] = {.lex_state = 0},
  [10400] = {.lex_state = 0},
  [10401] = {.lex_state = 0},
  [10402] = {.lex_state = 0},
  [10403] = {.lex_state = 206},
  [10404] = {.lex_state = 206},
  [10405] = {.lex_state = 206},
  [10406] = {.lex_state = 206},
  [10407] = {.lex_state = 206},
  [10408] = {.lex_state = 0},
  [10409] = {.lex_state = 206},
  [10410] = {.lex_state = 0},
  [10411] = {.lex_state = 0},
  [10412] = {.lex_state = 0},
  [10413] = {.lex_state = 0},
  [10414] = {.lex_state = 206},
  [10415] = {.lex_state = 0},
  [10416] = {.lex_state = 0},
  [10417] = {.lex_state = 0},
  [10418] = {.lex_state = 206},
  [10419] = {.lex_state = 206},
  [10420] = {.lex_state = 0},
  [10421] = {.lex_state = 0},
  [10422] = {.lex_state = 206},
  [10423] = {.lex_state = 0, .external_lex_state = 2},
  [10424] = {.lex_state = 0},
  [10425] = {.lex_state = 0},
  [10426] = {.lex_state = 0},
  [10427] = {.lex_state = 0},
  [10428] = {.lex_state = 0},
  [10429] = {.lex_state = 0},
  [10430] = {.lex_state = 0},
  [10431] = {.lex_state = 183},
  [10432] = {.lex_state = 206},
  [10433] = {.lex_state = 0},
  [10434] = {.lex_state = 0},
  [10435] = {.lex_state = 351},
  [10436] = {.lex_state = 183},
  [10437] = {.lex_state = 206},
  [10438] = {.lex_state = 206},
  [10439] = {.lex_state = 0},
  [10440] = {.lex_state = 0},
  [10441] = {.lex_state = 206},
  [10442] = {.lex_state = 0},
  [10443] = {.lex_state = 0},
  [10444] = {.lex_state = 0},
  [10445] = {.lex_state = 0},
  [10446] = {.lex_state = 0},
  [10447] = {.lex_state = 0},
  [10448] = {.lex_state = 206},
  [10449] = {.lex_state = 0},
  [10450] = {.lex_state = 0},
  [10451] = {.lex_state = 0},
  [10452] = {.lex_state = 0},
  [10453] = {.lex_state = 0},
  [10454] = {.lex_state = 183},
  [10455] = {.lex_state = 206},
  [10456] = {.lex_state = 183},
  [10457] = {.lex_state = 0},
  [10458] = {.lex_state = 0},
  [10459] = {.lex_state = 0},
  [10460] = {.lex_state = 351},
  [10461] = {.lex_state = 0},
  [10462] = {.lex_state = 206},
  [10463] = {.lex_state = 0},
  [10464] = {.lex_state = 0},
  [10465] = {.lex_state = 0},
  [10466] = {.lex_state = 0},
  [10467] = {.lex_state = 0},
  [10468] = {.lex_state = 0},
  [10469] = {.lex_state = 0},
  [10470] = {.lex_state = 0},
  [10471] = {.lex_state = 351},
  [10472] = {.lex_state = 0},
  [10473] = {.lex_state = 0},
  [10474] = {.lex_state = 0},
  [10475] = {.lex_state = 183},
  [10476] = {.lex_state = 0},
  [10477] = {.lex_state = 0},
  [10478] = {.lex_state = 0},
  [10479] = {.lex_state = 0},
  [10480] = {.lex_state = 0},
  [10481] = {.lex_state = 0},
  [10482] = {.lex_state = 0},
  [10483] = {.lex_state = 0},
  [10484] = {.lex_state = 0},
  [10485] = {.lex_state = 0},
  [10486] = {.lex_state = 0},
  [10487] = {.lex_state = 0},
  [10488] = {.lex_state = 0},
  [10489] = {.lex_state = 0},
  [10490] = {.lex_state = 0},
  [10491] = {.lex_state = 0},
  [10492] = {.lex_state = 0},
  [10493] = {.lex_state = 0},
  [10494] = {.lex_state = 0},
  [10495] = {.lex_state = 0},
  [10496] = {.lex_state = 0},
  [10497] = {.lex_state = 0},
  [10498] = {.lex_state = 0},
  [10499] = {.lex_state = 351},
  [10500] = {.lex_state = 351},
  [10501] = {.lex_state = 351},
  [10502] = {.lex_state = 351},
  [10503] = {.lex_state = 0},
  [10504] = {.lex_state = 351},
  [10505] = {.lex_state = 351},
  [10506] = {.lex_state = 215},
  [10507] = {.lex_state = 0},
  [10508] = {.lex_state = 0},
  [10509] = {.lex_state = 0},
  [10510] = {.lex_state = 206},
  [10511] = {.lex_state = 0},
  [10512] = {.lex_state = 351},
  [10513] = {.lex_state = 0},
  [10514] = {.lex_state = 0},
  [10515] = {.lex_state = 0},
  [10516] = {.lex_state = 0},
  [10517] = {.lex_state = 351},
  [10518] = {.lex_state = 0, .external_lex_state = 3},
  [10519] = {.lex_state = 351},
  [10520] = {.lex_state = 351},
  [10521] = {.lex_state = 206},
  [10522] = {.lex_state = 0},
  [10523] = {.lex_state = 0},
  [10524] = {.lex_state = 0},
  [10525] = {.lex_state = 0},
  [10526] = {.lex_state = 0},
  [10527] = {.lex_state = 0},
  [10528] = {.lex_state = 215},
  [10529] = {.lex_state = 206},
  [10530] = {.lex_state = 0},
  [10531] = {.lex_state = 0},
  [10532] = {.lex_state = 0},
  [10533] = {.lex_state = 0},
  [10534] = {.lex_state = 0},
  [10535] = {.lex_state = 215},
  [10536] = {.lex_state = 0},
  [10537] = {.lex_state = 0},
  [10538] = {.lex_state = 0},
  [10539] = {.lex_state = 0},
  [10540] = {.lex_state = 0},
  [10541] = {.lex_state = 0},
  [10542] = {.lex_state = 0},
  [10543] = {.lex_state = 0},
  [10544] = {.lex_state = 206},
  [10545] = {.lex_state = 206},
  [10546] = {.lex_state = 0},
  [10547] = {.lex_state = 0},
  [10548] = {.lex_state = 0},
  [10549] = {.lex_state = 118},
  [10550] = {.lex_state = 0},
  [10551] = {.lex_state = 0},
  [10552] = {.lex_state = 0},
  [10553] = {.lex_state = 0},
  [10554] = {.lex_state = 0},
  [10555] = {.lex_state = 351},
  [10556] = {.lex_state = 351},
  [10557] = {.lex_state = 351},
  [10558] = {.lex_state = 0},
  [10559] = {.lex_state = 351},
  [10560] = {.lex_state = 0},
  [10561] = {.lex_state = 0},
  [10562] = {.lex_state = 206},
  [10563] = {.lex_state = 118},
  [10564] = {.lex_state = 351},
  [10565] = {.lex_state = 0},
  [10566] = {.lex_state = 206},
  [10567] = {.lex_state = 351},
  [10568] = {.lex_state = 0, .external_lex_state = 3},
  [10569] = {.lex_state = 0},
  [10570] = {.lex_state = 0},
  [10571] = {.lex_state = 0},
  [10572] = {.lex_state = 0},
  [10573] = {.lex_state = 0},
  [10574] = {.lex_state = 206},
  [10575] = {.lex_state = 0},
  [10576] = {.lex_state = 0},
  [10577] = {.lex_state = 215},
  [10578] = {.lex_state = 0},
  [10579] = {.lex_state = 0},
  [10580] = {.lex_state = 0},
  [10581] = {.lex_state = 0},
  [10582] = {.lex_state = 0},
  [10583] = {.lex_state = 0},
  [10584] = {.lex_state = 0},
  [10585] = {.lex_state = 0},
  [10586] = {.lex_state = 0},
  [10587] = {.lex_state = 215},
  [10588] = {.lex_state = 0},
  [10589] = {.lex_state = 0},
  [10590] = {.lex_state = 0},
  [10591] = {.lex_state = 0},
  [10592] = {.lex_state = 0},
  [10593] = {.lex_state = 0},
  [10594] = {.lex_state = 351},
  [10595] = {.lex_state = 351},
  [10596] = {.lex_state = 351},
  [10597] = {.lex_state = 0},
  [10598] = {.lex_state = 351},
  [10599] = {.lex_state = 0},
  [10600] = {.lex_state = 0},
  [10601] = {.lex_state = 206},
  [10602] = {.lex_state = 351},
  [10603] = {.lex_state = 0},
  [10604] = {.lex_state = 0},
  [10605] = {.lex_state = 351},
  [10606] = {.lex_state = 0, .external_lex_state = 3},
  [10607] = {.lex_state = 118},
  [10608] = {.lex_state = 0},
  [10609] = {.lex_state = 0},
  [10610] = {.lex_state = 0},
  [10611] = {.lex_state = 183},
  [10612] = {.lex_state = 0},
  [10613] = {.lex_state = 215},
  [10614] = {.lex_state = 206},
  [10615] = {.lex_state = 0},
  [10616] = {.lex_state = 206},
  [10617] = {.lex_state = 0},
  [10618] = {.lex_state = 0},
  [10619] = {.lex_state = 0},
  [10620] = {.lex_state = 0},
  [10621] = {.lex_state = 351},
  [10622] = {.lex_state = 351},
  [10623] = {.lex_state = 351},
  [10624] = {.lex_state = 0},
  [10625] = {.lex_state = 351},
  [10626] = {.lex_state = 0},
  [10627] = {.lex_state = 0},
  [10628] = {.lex_state = 351},
  [10629] = {.lex_state = 0},
  [10630] = {.lex_state = 0},
  [10631] = {.lex_state = 351},
  [10632] = {.lex_state = 0, .external_lex_state = 3},
  [10633] = {.lex_state = 206},
  [10634] = {.lex_state = 0},
  [10635] = {.lex_state = 351},
  [10636] = {.lex_state = 0},
  [10637] = {.lex_state = 0},
  [10638] = {.lex_state = 0},
  [10639] = {.lex_state = 215},
  [10640] = {.lex_state = 0},
  [10641] = {.lex_state = 0},
  [10642] = {.lex_state = 118},
  [10643] = {.lex_state = 215},
  [10644] = {.lex_state = 0},
  [10645] = {.lex_state = 0},
  [10646] = {.lex_state = 206},
  [10647] = {.lex_state = 351},
  [10648] = {.lex_state = 351},
  [10649] = {.lex_state = 0},
  [10650] = {.lex_state = 351},
  [10651] = {.lex_state = 0},
  [10652] = {.lex_state = 0},
  [10653] = {.lex_state = 0},
  [10654] = {.lex_state = 118},
  [10655] = {.lex_state = 351},
  [10656] = {.lex_state = 0, .external_lex_state = 3},
  [10657] = {.lex_state = 118},
  [10658] = {.lex_state = 0},
  [10659] = {.lex_state = 0},
  [10660] = {.lex_state = 0},
  [10661] = {.lex_state = 0},
  [10662] = {.lex_state = 0},
  [10663] = {.lex_state = 351},
  [10664] = {.lex_state = 351},
  [10665] = {.lex_state = 183},
  [10666] = {.lex_state = 0, .external_lex_state = 3},
  [10667] = {.lex_state = 0},
  [10668] = {.lex_state = 0},
  [10669] = {.lex_state = 0},
  [10670] = {.lex_state = 183},
  [10671] = {.lex_state = 351},
  [10672] = {.lex_state = 351},
  [10673] = {.lex_state = 0},
  [10674] = {.lex_state = 0, .external_lex_state = 3},
  [10675] = {.lex_state = 0},
  [10676] = {.lex_state = 0},
  [10677] = {.lex_state = 351},
  [10678] = {.lex_state = 351},
  [10679] = {.lex_state = 0, .external_lex_state = 3},
  [10680] = {.lex_state = 0},
  [10681] = {.lex_state = 351},
  [10682] = {.lex_state = 351},
  [10683] = {.lex_state = 0, .external_lex_state = 3},
  [10684] = {.lex_state = 0},
  [10685] = {.lex_state = 351},
  [10686] = {.lex_state = 0, .external_lex_state = 3},
  [10687] = {.lex_state = 0},
  [10688] = {.lex_state = 351},
  [10689] = {.lex_state = 0, .external_lex_state = 3},
  [10690] = {.lex_state = 0},
  [10691] = {.lex_state = 0, .external_lex_state = 3},
  [10692] = {.lex_state = 0},
  [10693] = {.lex_state = 0, .external_lex_state = 3},
  [10694] = {.lex_state = 0},
  [10695] = {.lex_state = 0, .external_lex_state = 3},
  [10696] = {.lex_state = 0},
  [10697] = {.lex_state = 0, .external_lex_state = 3},
  [10698] = {.lex_state = 0},
  [10699] = {.lex_state = 0},
  [10700] = {.lex_state = 0},
  [10701] = {.lex_state = 351},
  [10702] = {.lex_state = 351},
  [10703] = {.lex_state = 206},
  [10704] = {.lex_state = 118},
  [10705] = {.lex_state = 0},
  [10706] = {.lex_state = 0},
  [10707] = {.lex_state = 0},
  [10708] = {.lex_state = 0},
  [10709] = {.lex_state = 0},
  [10710] = {.lex_state = 0},
  [10711] = {.lex_state = 0},
  [10712] = {.lex_state = 0},
  [10713] = {.lex_state = 0},
  [10714] = {.lex_state = 0},
  [10715] = {.lex_state = 0},
  [10716] = {.lex_state = 183},
  [10717] = {.lex_state = 351},
  [10718] = {.lex_state = 0},
  [10719] = {.lex_state = 0},
  [10720] = {.lex_state = 0},
  [10721] = {.lex_state = 0},
  [10722] = {.lex_state = 206},
  [10723] = {.lex_state = 0, .external_lex_state = 3},
  [10724] = {.lex_state = 0},
  [10725] = {.lex_state = 0},
  [10726] = {.lex_state = 0},
  [10727] = {.lex_state = 0},
  [10728] = {.lex_state = 0},
  [10729] = {.lex_state = 183},
  [10730] = {.lex_state = 183},
  [10731] = {.lex_state = 118},
  [10732] = {.lex_state = 206},
  [10733] = {.lex_state = 206},
  [10734] = {.lex_state = 0},
  [10735] = {.lex_state = 0},
  [10736] = {.lex_state = 206},
  [10737] = {.lex_state = 0},
  [10738] = {.lex_state = 0},
  [10739] = {.lex_state = 118},
  [10740] = {.lex_state = 0},
  [10741] = {.lex_state = 215},
  [10742] = {.lex_state = 0},
  [10743] = {.lex_state = 0},
  [10744] = {.lex_state = 0},
  [10745] = {.lex_state = 0},
  [10746] = {.lex_state = 0},
  [10747] = {.lex_state = 0},
  [10748] = {.lex_state = 0},
  [10749] = {.lex_state = 0},
  [10750] = {.lex_state = 183},
  [10751] = {.lex_state = 183},
  [10752] = {.lex_state = 0},
  [10753] = {.lex_state = 0},
  [10754] = {.lex_state = 0},
  [10755] = {.lex_state = 0},
  [10756] = {.lex_state = 0},
  [10757] = {.lex_state = 0},
  [10758] = {.lex_state = 118},
  [10759] = {.lex_state = 215},
  [10760] = {.lex_state = 0},
  [10761] = {.lex_state = 0},
  [10762] = {.lex_state = 118},
  [10763] = {.lex_state = 0},
  [10764] = {.lex_state = 0},
  [10765] = {.lex_state = 0},
  [10766] = {.lex_state = 0},
  [10767] = {.lex_state = 0},
  [10768] = {.lex_state = 351},
  [10769] = {.lex_state = 0},
  [10770] = {.lex_state = 183},
  [10771] = {.lex_state = 183},
  [10772] = {.lex_state = 0},
  [10773] = {.lex_state = 0},
  [10774] = {.lex_state = 0},
  [10775] = {.lex_state = 0},
  [10776] = {.lex_state = 0},
  [10777] = {.lex_state = 206},
  [10778] = {.lex_state = 0},
  [10779] = {.lex_state = 118},
  [10780] = {.lex_state = 0},
  [10781] = {.lex_state = 0},
  [10782] = {.lex_state = 0},
  [10783] = {.lex_state = 0},
  [10784] = {.lex_state = 0},
  [10785] = {.lex_state = 206},
  [10786] = {.lex_state = 215},
  [10787] = {.lex_state = 0},
  [10788] = {.lex_state = 118},
  [10789] = {.lex_state = 206},
  [10790] = {.lex_state = 183},
  [10791] = {.lex_state = 183},
  [10792] = {.lex_state = 183},
  [10793] = {.lex_state = 183},
  [10794] = {.lex_state = 0},
  [10795] = {.lex_state = 0},
  [10796] = {.lex_state = 0},
  [10797] = {.lex_state = 0},
  [10798] = {.lex_state = 118},
  [10799] = {.lex_state = 0},
  [10800] = {.lex_state = 0},
  [10801] = {.lex_state = 0},
  [10802] = {.lex_state = 183},
  [10803] = {.lex_state = 0},
  [10804] = {.lex_state = 0},
  [10805] = {.lex_state = 215},
  [10806] = {.lex_state = 215},
  [10807] = {.lex_state = 0},
  [10808] = {.lex_state = 0},
  [10809] = {.lex_state = 0},
  [10810] = {.lex_state = 0},
  [10811] = {.lex_state = 0},
  [10812] = {.lex_state = 0},
  [10813] = {.lex_state = 0},
  [10814] = {.lex_state = 351},
  [10815] = {.lex_state = 0},
  [10816] = {.lex_state = 0},
  [10817] = {.lex_state = 206},
  [10818] = {.lex_state = 0},
  [10819] = {.lex_state = 118},
  [10820] = {.lex_state = 351},
  [10821] = {.lex_state = 0},
  [10822] = {.lex_state = 0},
  [10823] = {.lex_state = 0},
  [10824] = {.lex_state = 206},
  [10825] = {.lex_state = 351},
  [10826] = {.lex_state = 0},
  [10827] = {.lex_state = 0},
  [10828] = {.lex_state = 0},
  [10829] = {.lex_state = 0},
  [10830] = {.lex_state = 0},
  [10831] = {.lex_state = 118},
  [10832] = {.lex_state = 351},
  [10833] = {.lex_state = 215},
  [10834] = {.lex_state = 206},
  [10835] = {.lex_state = 0},
  [10836] = {.lex_state = 0},
  [10837] = {.lex_state = 0},
  [10838] = {.lex_state = 0},
  [10839] = {.lex_state = 351},
  [10840] = {.lex_state = 0},
  [10841] = {.lex_state = 215},
  [10842] = {.lex_state = 351},
  [10843] = {.lex_state = 351},
  [10844] = {.lex_state = 351},
  [10845] = {.lex_state = 351},
  [10846] = {.lex_state = 206},
  [10847] = {.lex_state = 0},
  [10848] = {.lex_state = 206},
  [10849] = {.lex_state = 0},
  [10850] = {.lex_state = 351},
  [10851] = {.lex_state = 0},
  [10852] = {.lex_state = 206},
  [10853] = {.lex_state = 0, .external_lex_state = 3},
  [10854] = {.lex_state = 0},
  [10855] = {.lex_state = 351},
  [10856] = {.lex_state = 183},
  [10857] = {.lex_state = 0},
  [10858] = {.lex_state = 215},
  [10859] = {.lex_state = 351},
  [10860] = {.lex_state = 351},
  [10861] = {.lex_state = 206},
  [10862] = {.lex_state = 0},
  [10863] = {.lex_state = 0},
  [10864] = {.lex_state = 351},
  [10865] = {.lex_state = 206},
  [10866] = {.lex_state = 0, .external_lex_state = 3},
  [10867] = {.lex_state = 0},
  [10868] = {.lex_state = 0},
  [10869] = {.lex_state = 0},
  [10870] = {.lex_state = 351},
  [10871] = {.lex_state = 206},
  [10872] = {.lex_state = 118},
  [10873] = {.lex_state = 0},
  [10874] = {.lex_state = 206},
  [10875] = {.lex_state = 0, .external_lex_state = 3},
  [10876] = {.lex_state = 0},
  [10877] = {.lex_state = 351},
  [10878] = {.lex_state = 351},
  [10879] = {.lex_state = 206},
  [10880] = {.lex_state = 206},
  [10881] = {.lex_state = 118},
  [10882] = {.lex_state = 206},
  [10883] = {.lex_state = 0, .external_lex_state = 3},
  [10884] = {.lex_state = 351},
  [10885] = {.lex_state = 0},
  [10886] = {.lex_state = 351},
  [10887] = {.lex_state = 206},
  [10888] = {.lex_state = 0},
  [10889] = {.lex_state = 206},
  [10890] = {.lex_state = 0, .external_lex_state = 3},
  [10891] = {.lex_state = 0},
  [10892] = {.lex_state = 183},
  [10893] = {.lex_state = 206},
  [10894] = {.lex_state = 0, .external_lex_state = 3},
  [10895] = {.lex_state = 351},
  [10896] = {.lex_state = 0},
  [10897] = {.lex_state = 0, .external_lex_state = 3},
  [10898] = {.lex_state = 183},
  [10899] = {.lex_state = 0, .external_lex_state = 3},
  [10900] = {.lex_state = 0},
  [10901] = {.lex_state = 0, .external_lex_state = 3},
  [10902] = {.lex_state = 0},
  [10903] = {.lex_state = 0, .external_lex_state = 3},
  [10904] = {.lex_state = 206},
  [10905] = {.lex_state = 0, .external_lex_state = 3},
  [10906] = {.lex_state = 0},
  [10907] = {.lex_state = 0, .external_lex_state = 3},
  [10908] = {.lex_state = 0},
  [10909] = {.lex_state = 0, .external_lex_state = 3},
  [10910] = {.lex_state = 0},
  [10911] = {.lex_state = 0, .external_lex_state = 3},
  [10912] = {.lex_state = 0},
  [10913] = {.lex_state = 0, .external_lex_state = 3},
  [10914] = {.lex_state = 351},
  [10915] = {.lex_state = 351},
  [10916] = {.lex_state = 118},
  [10917] = {.lex_state = 118},
  [10918] = {.lex_state = 351},
  [10919] = {.lex_state = 351},
  [10920] = {.lex_state = 0},
  [10921] = {.lex_state = 351},
  [10922] = {.lex_state = 351},
  [10923] = {.lex_state = 0},
  [10924] = {.lex_state = 351},
  [10925] = {.lex_state = 351},
  [10926] = {.lex_state = 0},
  [10927] = {.lex_state = 351},
  [10928] = {.lex_state = 351},
  [10929] = {.lex_state = 0},
  [10930] = {.lex_state = 351},
  [10931] = {.lex_state = 351},
  [10932] = {.lex_state = 351},
  [10933] = {.lex_state = 351},
  [10934] = {.lex_state = 351},
  [10935] = {.lex_state = 351},
  [10936] = {.lex_state = 351},
  [10937] = {.lex_state = 351},
  [10938] = {.lex_state = 351},
  [10939] = {.lex_state = 351},
  [10940] = {.lex_state = 351},
  [10941] = {.lex_state = 0},
  [10942] = {.lex_state = 215},
  [10943] = {.lex_state = 206},
  [10944] = {.lex_state = 215},
  [10945] = {.lex_state = 206},
  [10946] = {.lex_state = 351},
  [10947] = {.lex_state = 351},
  [10948] = {.lex_state = 351},
  [10949] = {.lex_state = 351},
  [10950] = {.lex_state = 351},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [aux_sym_preproc_include_token1] = ACTIONS(1),
    [aux_sym_preproc_def_token1] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [aux_sym_preproc_if_token1] = ACTIONS(1),
    [aux_sym_preproc_if_token2] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1),
    [aux_sym_preproc_else_token1] = ACTIONS(1),
    [aux_sym_preproc_elif_token1] = ACTIONS(1),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1),
    [sym_preproc_directive] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_defined] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym___extension__] = ACTIONS(1),
    [anon_sym_typedef] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_out] = ACTIONS(1),
    [anon_sym_inout] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym___attribute__] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1),
    [anon_sym___declspec] = ACTIONS(1),
    [anon_sym___based] = ACTIONS(1),
    [anon_sym___cdecl] = ACTIONS(1),
    [anon_sym___clrcall] = ACTIONS(1),
    [anon_sym___stdcall] = ACTIONS(1),
    [anon_sym___fastcall] = ACTIONS(1),
    [anon_sym___thiscall] = ACTIONS(1),
    [anon_sym___vectorcall] = ACTIONS(1),
    [sym_ms_restrict_modifier] = ACTIONS(1),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(1),
    [sym_ms_signed_ptr_modifier] = ACTIONS(1),
    [anon_sym__unaligned] = ACTIONS(1),
    [anon_sym___unaligned] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_signed] = ACTIONS(1),
    [anon_sym_unsigned] = ACTIONS(1),
    [anon_sym_long] = ACTIONS(1),
    [anon_sym_short] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_register] = ACTIONS(1),
    [anon_sym_inline] = ACTIONS(1),
    [anon_sym___inline] = ACTIONS(1),
    [anon_sym___inline__] = ACTIONS(1),
    [anon_sym___forceinline] = ACTIONS(1),
    [anon_sym_thread_local] = ACTIONS(1),
    [anon_sym___thread] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_constexpr] = ACTIONS(1),
    [anon_sym_volatile] = ACTIONS(1),
    [anon_sym_restrict] = ACTIONS(1),
    [anon_sym___restrict__] = ACTIONS(1),
    [anon_sym__Atomic] = ACTIONS(1),
    [anon_sym__Noreturn] = ACTIONS(1),
    [anon_sym_noreturn] = ACTIONS(1),
    [anon_sym_mutable] = ACTIONS(1),
    [anon_sym_constinit] = ACTIONS(1),
    [anon_sym_consteval] = ACTIONS(1),
    [anon_sym_alignas] = ACTIONS(1),
    [anon_sym__Alignas] = ACTIONS(1),
    [sym_primitive_type] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_union] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym___try] = ACTIONS(1),
    [anon_sym___except] = ACTIONS(1),
    [anon_sym___finally] = ACTIONS(1),
    [anon_sym___leave] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_and_eq] = ACTIONS(1),
    [anon_sym_or_eq] = ACTIONS(1),
    [anon_sym_xor_eq] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_compl] = ACTIONS(1),
    [anon_sym_LT_EQ_GT] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_bitor] = ACTIONS(1),
    [anon_sym_xor] = ACTIONS(1),
    [anon_sym_bitand] = ACTIONS(1),
    [anon_sym_not_eq] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_sizeof] = ACTIONS(1),
    [anon_sym___alignof__] = ACTIONS(1),
    [anon_sym___alignof] = ACTIONS(1),
    [anon_sym__alignof] = ACTIONS(1),
    [anon_sym_alignof] = ACTIONS(1),
    [anon_sym__Alignof] = ACTIONS(1),
    [anon_sym_offsetof] = ACTIONS(1),
    [anon_sym__Generic] = ACTIONS(1),
    [anon_sym_asm] = ACTIONS(1),
    [anon_sym___asm__] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DOT_STAR] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [sym_number_literal] = ACTIONS(1),
    [anon_sym_L_SQUOTE] = ACTIONS(1),
    [anon_sym_u_SQUOTE] = ACTIONS(1),
    [anon_sym_U_SQUOTE] = ACTIONS(1),
    [anon_sym_u8_SQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_L_DQUOTE] = ACTIONS(1),
    [anon_sym_u_DQUOTE] = ACTIONS(1),
    [anon_sym_U_DQUOTE] = ACTIONS(1),
    [anon_sym_u8_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [anon_sym_NULL] = ACTIONS(1),
    [anon_sym_nullptr] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_This] = ACTIONS(1),
    [sym_auto] = ACTIONS(1),
    [anon_sym_decltype] = ACTIONS(1),
    [anon_sym_final] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [sym_virtual] = ACTIONS(1),
    [anon_sym_explicit] = ACTIONS(1),
    [anon_sym_typename] = ACTIONS(1),
    [anon_sym_template] = ACTIONS(1),
    [anon_sym_GT2] = ACTIONS(1),
    [anon_sym_operator] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_0] = ACTIONS(1),
    [anon_sym_friend] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_noexcept] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_static_assert] = ACTIONS(1),
    [anon_sym_concept] = ACTIONS(1),
    [anon_sym_co_return] = ACTIONS(1),
    [anon_sym_co_yield] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_R_DQUOTE] = ACTIONS(1),
    [anon_sym_LR_DQUOTE] = ACTIONS(1),
    [anon_sym_uR_DQUOTE] = ACTIONS(1),
    [anon_sym_UR_DQUOTE] = ACTIONS(1),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1),
    [anon_sym_co_await] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_requires] = ACTIONS(1),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [anon_sym_discard] = ACTIONS(1),
    [anon_sym_precise] = ACTIONS(1),
    [anon_sym_shared] = ACTIONS(1),
    [anon_sym_groupshared] = ACTIONS(1),
    [anon_sym_uniform] = ACTIONS(1),
    [anon_sym_row_major] = ACTIONS(1),
    [anon_sym_column_major] = ACTIONS(1),
    [anon_sym_globallycoherent] = ACTIONS(1),
    [anon_sym_centroid] = ACTIONS(1),
    [anon_sym_noperspective] = ACTIONS(1),
    [anon_sym_nointerpolation] = ACTIONS(1),
    [anon_sym_sample] = ACTIONS(1),
    [anon_sym_linear] = ACTIONS(1),
    [anon_sym_snorm] = ACTIONS(1),
    [anon_sym_unorm] = ACTIONS(1),
    [anon_sym_point] = ACTIONS(1),
    [anon_sym_line] = ACTIONS(1),
    [anon_sym_triangleadj] = ACTIONS(1),
    [anon_sym_lineadj] = ACTIONS(1),
    [anon_sym_triangle] = ACTIONS(1),
    [anon_sym_cbuffer] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_extension] = ACTIONS(1),
    [anon_sym_where] = ACTIONS(1),
    [anon_sym___exported] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym___init] = ACTIONS(1),
    [anon_sym___subscript] = ACTIONS(1),
    [anon_sym_property] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_associatedtype] = ACTIONS(1),
    [sym_raw_string_delimiter] = ACTIONS(1),
    [sym_raw_string_content] = ACTIONS(1),
  },
  [1] = {
    [sym_translation_unit] = STATE(10816),
    [sym__top_level_item] = STATE(76),
    [sym_preproc_include] = STATE(76),
    [sym_preproc_def] = STATE(76),
    [sym_preproc_function_def] = STATE(76),
    [sym_preproc_call] = STATE(76),
    [sym_preproc_if] = STATE(76),
    [sym_preproc_ifdef] = STATE(76),
    [sym_function_definition] = STATE(76),
    [sym_declaration] = STATE(76),
    [sym_type_definition] = STATE(76),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5680),
    [sym_linkage_specification] = STATE(76),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1937),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7540),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(76),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(247),
    [sym_sized_type_specifier] = STATE(361),
    [sym_enum_specifier] = STATE(361),
    [sym_struct_specifier] = STATE(361),
    [sym_union_specifier] = STATE(361),
    [sym_attributed_statement] = STATE(1069),
    [sym__top_level_statement] = STATE(76),
    [sym_labeled_statement] = STATE(76),
    [sym__top_level_expression_statement] = STATE(76),
    [sym_if_statement] = STATE(76),
    [sym_switch_statement] = STATE(76),
    [sym_case_statement] = STATE(76),
    [sym_while_statement] = STATE(76),
    [sym_do_statement] = STATE(76),
    [sym_for_statement] = STATE(76),
    [sym_return_statement] = STATE(76),
    [sym_break_statement] = STATE(76),
    [sym_continue_statement] = STATE(76),
    [sym_goto_statement] = STATE(76),
    [sym_expression] = STATE(5683),
    [sym__string] = STATE(5817),
    [sym_conditional_expression] = STATE(5817),
    [sym_assignment_expression] = STATE(5817),
    [sym_pointer_expression] = STATE(4586),
    [sym_unary_expression] = STATE(5817),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(5817),
    [sym_cast_expression] = STATE(5817),
    [sym_sizeof_expression] = STATE(5817),
    [sym_alignof_expression] = STATE(5817),
    [sym_offsetof_expression] = STATE(5817),
    [sym_generic_expression] = STATE(5817),
    [sym_subscript_expression] = STATE(4586),
    [sym_call_expression] = STATE(4586),
    [sym_gnu_asm_expression] = STATE(5817),
    [sym_field_expression] = STATE(4586),
    [sym_compound_literal_expression] = STATE(5817),
    [sym_parenthesized_expression] = STATE(4586),
    [sym_char_literal] = STATE(5671),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(5817),
    [sym__empty_declaration] = STATE(76),
    [sym_placeholder_type_specifier] = STATE(361),
    [sym_decltype] = STATE(268),
    [sym_class_specifier] = STATE(361),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2588),
    [sym_dependent_type] = STATE(361),
    [sym_template_declaration] = STATE(76),
    [sym_template_instantiation] = STATE(76),
    [sym_operator_cast] = STATE(8467),
    [sym__constructor_specifiers] = STATE(2588),
    [sym_operator_cast_definition] = STATE(76),
    [sym_operator_cast_declaration] = STATE(76),
    [sym_constructor_or_destructor_definition] = STATE(76),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(995),
    [sym_template_function] = STATE(5705),
    [sym_namespace_definition] = STATE(76),
    [sym_namespace_alias_definition] = STATE(76),
    [sym_using_declaration] = STATE(76),
    [sym_alias_declaration] = STATE(76),
    [sym_static_assert_declaration] = STATE(76),
    [sym_concept_definition] = STATE(76),
    [sym_for_range_loop] = STATE(76),
    [sym_co_return_statement] = STATE(76),
    [sym_co_yield_statement] = STATE(76),
    [sym_throw_statement] = STATE(76),
    [sym_try_statement] = STATE(76),
    [sym_raw_string_literal] = STATE(4610),
    [sym_co_await_expression] = STATE(5817),
    [sym_new_expression] = STATE(5817),
    [sym_delete_expression] = STATE(5817),
    [sym_requires_clause] = STATE(5817),
    [sym_requires_expression] = STATE(5817),
    [sym_lambda_expression] = STATE(5817),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(5817),
    [sym_parameter_pack_expansion] = STATE(5817),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6558),
    [sym_qualified_identifier] = STATE(4457),
    [sym_qualified_type_identifier] = STATE(996),
    [sym_qualified_operator_cast_identifier] = STATE(8467),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4586),
    [sym_qualifiers] = STATE(2776),
    [sym_hlsl_attribute] = STATE(1479),
    [sym_interface_specifier] = STATE(361),
    [sym_extension_specifier] = STATE(361),
    [sym_import_statement] = STATE(76),
    [sym_associatedtype_specifier] = STATE(361),
    [aux_sym_translation_unit_repeat1] = STATE(76),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1102),
    [aux_sym_sized_type_specifier_repeat1] = STATE(886),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2588),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [aux_sym_preproc_include_token1] = ACTIONS(9),
    [aux_sym_preproc_def_token1] = ACTIONS(11),
    [aux_sym_preproc_if_token1] = ACTIONS(13),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(15),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(39),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(81),
    [anon_sym_default] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(111),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(117),
    [sym_false] = ACTIONS(117),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(121),
    [anon_sym_This] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(129),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_namespace] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(141),
    [anon_sym_static_assert] = ACTIONS(143),
    [anon_sym_concept] = ACTIONS(145),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(117),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(161),
    [anon_sym_extension] = ACTIONS(163),
    [anon_sym___exported] = ACTIONS(165),
    [anon_sym_import] = ACTIONS(167),
  },
  [2] = {
    [sym__block_item] = STATE(49),
    [sym_preproc_include] = STATE(49),
    [sym_preproc_def] = STATE(49),
    [sym_preproc_function_def] = STATE(49),
    [sym_preproc_call] = STATE(49),
    [sym_preproc_if] = STATE(49),
    [sym_preproc_ifdef] = STATE(49),
    [sym_function_definition] = STATE(49),
    [sym_declaration] = STATE(49),
    [sym_type_definition] = STATE(49),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(49),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(49),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5103),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(9006),
    [sym_initializer_pair] = STATE(9006),
    [sym_subscript_designator] = STATE(8254),
    [sym_subscript_range_designator] = STATE(8254),
    [sym_field_designator] = STATE(8254),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(49),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(49),
    [sym_template_instantiation] = STATE(49),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(49),
    [sym_operator_cast_declaration] = STATE(49),
    [sym_constructor_or_destructor_definition] = STATE(49),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(49),
    [sym_namespace_alias_definition] = STATE(49),
    [sym_using_declaration] = STATE(49),
    [sym_alias_declaration] = STATE(49),
    [sym_static_assert_declaration] = STATE(49),
    [sym_concept_definition] = STATE(49),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(49),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_initializer_pair_repeat1] = STATE(8254),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(169),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [anon_sym_COMMA] = ACTIONS(175),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_RBRACE] = ACTIONS(193),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(237),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [3] = {
    [sym__block_item] = STATE(34),
    [sym_preproc_include] = STATE(34),
    [sym_preproc_def] = STATE(34),
    [sym_preproc_function_def] = STATE(34),
    [sym_preproc_call] = STATE(34),
    [sym_preproc_if] = STATE(34),
    [sym_preproc_ifdef] = STATE(34),
    [sym_function_definition] = STATE(34),
    [sym_declaration] = STATE(34),
    [sym_type_definition] = STATE(34),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(34),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(34),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5103),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(9006),
    [sym_initializer_pair] = STATE(9006),
    [sym_subscript_designator] = STATE(8254),
    [sym_subscript_range_designator] = STATE(8254),
    [sym_field_designator] = STATE(8254),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(34),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(34),
    [sym_template_instantiation] = STATE(34),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(34),
    [sym_operator_cast_declaration] = STATE(34),
    [sym_constructor_or_destructor_definition] = STATE(34),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(34),
    [sym_namespace_alias_definition] = STATE(34),
    [sym_using_declaration] = STATE(34),
    [sym_alias_declaration] = STATE(34),
    [sym_static_assert_declaration] = STATE(34),
    [sym_concept_definition] = STATE(34),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(34),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_initializer_pair_repeat1] = STATE(8254),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(169),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [anon_sym_COMMA] = ACTIONS(175),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_RBRACE] = ACTIONS(275),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(237),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [4] = {
    [sym__block_item] = STATE(40),
    [sym_preproc_include] = STATE(40),
    [sym_preproc_def] = STATE(40),
    [sym_preproc_function_def] = STATE(40),
    [sym_preproc_call] = STATE(40),
    [sym_preproc_if] = STATE(40),
    [sym_preproc_ifdef] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym_declaration] = STATE(40),
    [sym_type_definition] = STATE(40),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(40),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(40),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5103),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(9006),
    [sym_initializer_pair] = STATE(9006),
    [sym_subscript_designator] = STATE(8254),
    [sym_subscript_range_designator] = STATE(8254),
    [sym_field_designator] = STATE(8254),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(40),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(40),
    [sym_template_instantiation] = STATE(40),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(40),
    [sym_operator_cast_declaration] = STATE(40),
    [sym_constructor_or_destructor_definition] = STATE(40),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(40),
    [sym_namespace_alias_definition] = STATE(40),
    [sym_using_declaration] = STATE(40),
    [sym_alias_declaration] = STATE(40),
    [sym_static_assert_declaration] = STATE(40),
    [sym_concept_definition] = STATE(40),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(40),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_initializer_pair_repeat1] = STATE(8254),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(169),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [anon_sym_COMMA] = ACTIONS(175),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_RBRACE] = ACTIONS(277),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(237),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [5] = {
    [sym__block_item] = STATE(52),
    [sym_preproc_include] = STATE(52),
    [sym_preproc_def] = STATE(52),
    [sym_preproc_function_def] = STATE(52),
    [sym_preproc_call] = STATE(52),
    [sym_preproc_if] = STATE(52),
    [sym_preproc_ifdef] = STATE(52),
    [sym_function_definition] = STATE(52),
    [sym_declaration] = STATE(52),
    [sym_type_definition] = STATE(52),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(52),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(52),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5103),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(9006),
    [sym_initializer_pair] = STATE(9006),
    [sym_subscript_designator] = STATE(8254),
    [sym_subscript_range_designator] = STATE(8254),
    [sym_field_designator] = STATE(8254),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(52),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(52),
    [sym_template_instantiation] = STATE(52),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(52),
    [sym_operator_cast_declaration] = STATE(52),
    [sym_constructor_or_destructor_definition] = STATE(52),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(52),
    [sym_namespace_alias_definition] = STATE(52),
    [sym_using_declaration] = STATE(52),
    [sym_alias_declaration] = STATE(52),
    [sym_static_assert_declaration] = STATE(52),
    [sym_concept_definition] = STATE(52),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(52),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_initializer_pair_repeat1] = STATE(8254),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(169),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [anon_sym_COMMA] = ACTIONS(175),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_RBRACE] = ACTIONS(279),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(237),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [6] = {
    [sym__block_item] = STATE(37),
    [sym_preproc_include] = STATE(37),
    [sym_preproc_def] = STATE(37),
    [sym_preproc_function_def] = STATE(37),
    [sym_preproc_call] = STATE(37),
    [sym_preproc_if] = STATE(37),
    [sym_preproc_ifdef] = STATE(37),
    [sym_function_definition] = STATE(37),
    [sym_declaration] = STATE(37),
    [sym_type_definition] = STATE(37),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(37),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(37),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5103),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(9006),
    [sym_initializer_pair] = STATE(9006),
    [sym_subscript_designator] = STATE(8254),
    [sym_subscript_range_designator] = STATE(8254),
    [sym_field_designator] = STATE(8254),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(37),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(37),
    [sym_template_instantiation] = STATE(37),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(37),
    [sym_operator_cast_declaration] = STATE(37),
    [sym_constructor_or_destructor_definition] = STATE(37),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(37),
    [sym_namespace_alias_definition] = STATE(37),
    [sym_using_declaration] = STATE(37),
    [sym_alias_declaration] = STATE(37),
    [sym_static_assert_declaration] = STATE(37),
    [sym_concept_definition] = STATE(37),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(37),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_initializer_pair_repeat1] = STATE(8254),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(169),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [anon_sym_COMMA] = ACTIONS(175),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_RBRACE] = ACTIONS(279),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(237),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [7] = {
    [sym__block_item] = STATE(27),
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(10386),
    [sym_preproc_elif] = STATE(10386),
    [sym_preproc_elifdef] = STATE(10386),
    [sym_function_definition] = STATE(27),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5695),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1831),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7515),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(406),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2673),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(496),
    [sym_statement] = STATE(27),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(27),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2594),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(27),
    [sym_template_instantiation] = STATE(27),
    [sym_operator_cast] = STATE(8424),
    [sym__constructor_specifiers] = STATE(2594),
    [sym_operator_cast_definition] = STATE(27),
    [sym_operator_cast_declaration] = STATE(27),
    [sym_constructor_or_destructor_definition] = STATE(27),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(27),
    [sym_namespace_alias_definition] = STATE(27),
    [sym_using_declaration] = STATE(27),
    [sym_alias_declaration] = STATE(27),
    [sym_static_assert_declaration] = STATE(27),
    [sym_concept_definition] = STATE(27),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8424),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(1475),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2594),
    [sym_identifier] = ACTIONS(281),
    [aux_sym_preproc_include_token1] = ACTIONS(283),
    [aux_sym_preproc_def_token1] = ACTIONS(285),
    [aux_sym_preproc_if_token1] = ACTIONS(287),
    [aux_sym_preproc_if_token2] = ACTIONS(289),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(291),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(291),
    [aux_sym_preproc_else_token1] = ACTIONS(293),
    [aux_sym_preproc_elif_token1] = ACTIONS(295),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(297),
    [sym_preproc_directive] = ACTIONS(299),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym___extension__] = ACTIONS(303),
    [anon_sym_typedef] = ACTIONS(305),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(307),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(311),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(339),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_using] = ACTIONS(347),
    [anon_sym_static_assert] = ACTIONS(349),
    [anon_sym_concept] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(359),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [8] = {
    [sym__block_item] = STATE(27),
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(10892),
    [sym_preproc_elif] = STATE(10892),
    [sym_preproc_elifdef] = STATE(10892),
    [sym_function_definition] = STATE(27),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5695),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1831),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7515),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(406),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2673),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(496),
    [sym_statement] = STATE(27),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(27),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2594),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(27),
    [sym_template_instantiation] = STATE(27),
    [sym_operator_cast] = STATE(8424),
    [sym__constructor_specifiers] = STATE(2594),
    [sym_operator_cast_definition] = STATE(27),
    [sym_operator_cast_declaration] = STATE(27),
    [sym_constructor_or_destructor_definition] = STATE(27),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(27),
    [sym_namespace_alias_definition] = STATE(27),
    [sym_using_declaration] = STATE(27),
    [sym_alias_declaration] = STATE(27),
    [sym_static_assert_declaration] = STATE(27),
    [sym_concept_definition] = STATE(27),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8424),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(1475),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2594),
    [sym_identifier] = ACTIONS(281),
    [aux_sym_preproc_include_token1] = ACTIONS(283),
    [aux_sym_preproc_def_token1] = ACTIONS(285),
    [aux_sym_preproc_if_token1] = ACTIONS(287),
    [aux_sym_preproc_if_token2] = ACTIONS(361),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(291),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(291),
    [aux_sym_preproc_else_token1] = ACTIONS(293),
    [aux_sym_preproc_elif_token1] = ACTIONS(295),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(297),
    [sym_preproc_directive] = ACTIONS(299),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym___extension__] = ACTIONS(303),
    [anon_sym_typedef] = ACTIONS(305),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(307),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(311),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(339),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_using] = ACTIONS(347),
    [anon_sym_static_assert] = ACTIONS(349),
    [anon_sym_concept] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(359),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [9] = {
    [sym__block_item] = STATE(25),
    [sym_preproc_include] = STATE(25),
    [sym_preproc_def] = STATE(25),
    [sym_preproc_function_def] = STATE(25),
    [sym_preproc_call] = STATE(25),
    [sym_preproc_if] = STATE(25),
    [sym_preproc_ifdef] = STATE(25),
    [sym_preproc_else] = STATE(10143),
    [sym_preproc_elif] = STATE(10143),
    [sym_preproc_elifdef] = STATE(10143),
    [sym_function_definition] = STATE(25),
    [sym_declaration] = STATE(25),
    [sym_type_definition] = STATE(25),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5695),
    [sym_linkage_specification] = STATE(25),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1831),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7515),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(406),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2673),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(496),
    [sym_statement] = STATE(25),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(25),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2594),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(25),
    [sym_template_instantiation] = STATE(25),
    [sym_operator_cast] = STATE(8424),
    [sym__constructor_specifiers] = STATE(2594),
    [sym_operator_cast_definition] = STATE(25),
    [sym_operator_cast_declaration] = STATE(25),
    [sym_constructor_or_destructor_definition] = STATE(25),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(25),
    [sym_namespace_alias_definition] = STATE(25),
    [sym_using_declaration] = STATE(25),
    [sym_alias_declaration] = STATE(25),
    [sym_static_assert_declaration] = STATE(25),
    [sym_concept_definition] = STATE(25),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8424),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(1475),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(25),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2594),
    [sym_identifier] = ACTIONS(281),
    [aux_sym_preproc_include_token1] = ACTIONS(283),
    [aux_sym_preproc_def_token1] = ACTIONS(285),
    [aux_sym_preproc_if_token1] = ACTIONS(287),
    [aux_sym_preproc_if_token2] = ACTIONS(363),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(291),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(291),
    [aux_sym_preproc_else_token1] = ACTIONS(293),
    [aux_sym_preproc_elif_token1] = ACTIONS(295),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(297),
    [sym_preproc_directive] = ACTIONS(299),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym___extension__] = ACTIONS(303),
    [anon_sym_typedef] = ACTIONS(305),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(307),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(311),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(339),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_using] = ACTIONS(347),
    [anon_sym_static_assert] = ACTIONS(349),
    [anon_sym_concept] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(359),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [10] = {
    [sym__block_item] = STATE(19),
    [sym_preproc_include] = STATE(19),
    [sym_preproc_def] = STATE(19),
    [sym_preproc_function_def] = STATE(19),
    [sym_preproc_call] = STATE(19),
    [sym_preproc_if] = STATE(19),
    [sym_preproc_ifdef] = STATE(19),
    [sym_preproc_else] = STATE(10332),
    [sym_preproc_elif] = STATE(10332),
    [sym_preproc_elifdef] = STATE(10332),
    [sym_function_definition] = STATE(19),
    [sym_declaration] = STATE(19),
    [sym_type_definition] = STATE(19),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5695),
    [sym_linkage_specification] = STATE(19),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1831),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7515),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(406),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2673),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(496),
    [sym_statement] = STATE(19),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(19),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2594),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(19),
    [sym_template_instantiation] = STATE(19),
    [sym_operator_cast] = STATE(8424),
    [sym__constructor_specifiers] = STATE(2594),
    [sym_operator_cast_definition] = STATE(19),
    [sym_operator_cast_declaration] = STATE(19),
    [sym_constructor_or_destructor_definition] = STATE(19),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(19),
    [sym_namespace_alias_definition] = STATE(19),
    [sym_using_declaration] = STATE(19),
    [sym_alias_declaration] = STATE(19),
    [sym_static_assert_declaration] = STATE(19),
    [sym_concept_definition] = STATE(19),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8424),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(1475),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(19),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2594),
    [sym_identifier] = ACTIONS(281),
    [aux_sym_preproc_include_token1] = ACTIONS(283),
    [aux_sym_preproc_def_token1] = ACTIONS(285),
    [aux_sym_preproc_if_token1] = ACTIONS(287),
    [aux_sym_preproc_if_token2] = ACTIONS(365),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(291),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(291),
    [aux_sym_preproc_else_token1] = ACTIONS(293),
    [aux_sym_preproc_elif_token1] = ACTIONS(295),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(297),
    [sym_preproc_directive] = ACTIONS(299),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym___extension__] = ACTIONS(303),
    [anon_sym_typedef] = ACTIONS(305),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(307),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(311),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(339),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_using] = ACTIONS(347),
    [anon_sym_static_assert] = ACTIONS(349),
    [anon_sym_concept] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(359),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [11] = {
    [sym__block_item] = STATE(27),
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(10321),
    [sym_preproc_elif] = STATE(10321),
    [sym_preproc_elifdef] = STATE(10321),
    [sym_function_definition] = STATE(27),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5695),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1831),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7515),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(406),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2673),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(496),
    [sym_statement] = STATE(27),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(27),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2594),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(27),
    [sym_template_instantiation] = STATE(27),
    [sym_operator_cast] = STATE(8424),
    [sym__constructor_specifiers] = STATE(2594),
    [sym_operator_cast_definition] = STATE(27),
    [sym_operator_cast_declaration] = STATE(27),
    [sym_constructor_or_destructor_definition] = STATE(27),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(27),
    [sym_namespace_alias_definition] = STATE(27),
    [sym_using_declaration] = STATE(27),
    [sym_alias_declaration] = STATE(27),
    [sym_static_assert_declaration] = STATE(27),
    [sym_concept_definition] = STATE(27),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8424),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(1475),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2594),
    [sym_identifier] = ACTIONS(281),
    [aux_sym_preproc_include_token1] = ACTIONS(283),
    [aux_sym_preproc_def_token1] = ACTIONS(285),
    [aux_sym_preproc_if_token1] = ACTIONS(287),
    [aux_sym_preproc_if_token2] = ACTIONS(367),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(291),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(291),
    [aux_sym_preproc_else_token1] = ACTIONS(293),
    [aux_sym_preproc_elif_token1] = ACTIONS(295),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(297),
    [sym_preproc_directive] = ACTIONS(299),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym___extension__] = ACTIONS(303),
    [anon_sym_typedef] = ACTIONS(305),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(307),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(311),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(339),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_using] = ACTIONS(347),
    [anon_sym_static_assert] = ACTIONS(349),
    [anon_sym_concept] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(359),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [12] = {
    [sym__block_item] = STATE(27),
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(10856),
    [sym_preproc_elif] = STATE(10856),
    [sym_preproc_elifdef] = STATE(10856),
    [sym_function_definition] = STATE(27),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5695),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1831),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7515),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(406),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2673),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(496),
    [sym_statement] = STATE(27),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(27),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2594),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(27),
    [sym_template_instantiation] = STATE(27),
    [sym_operator_cast] = STATE(8424),
    [sym__constructor_specifiers] = STATE(2594),
    [sym_operator_cast_definition] = STATE(27),
    [sym_operator_cast_declaration] = STATE(27),
    [sym_constructor_or_destructor_definition] = STATE(27),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(27),
    [sym_namespace_alias_definition] = STATE(27),
    [sym_using_declaration] = STATE(27),
    [sym_alias_declaration] = STATE(27),
    [sym_static_assert_declaration] = STATE(27),
    [sym_concept_definition] = STATE(27),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8424),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(1475),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2594),
    [sym_identifier] = ACTIONS(281),
    [aux_sym_preproc_include_token1] = ACTIONS(283),
    [aux_sym_preproc_def_token1] = ACTIONS(285),
    [aux_sym_preproc_if_token1] = ACTIONS(287),
    [aux_sym_preproc_if_token2] = ACTIONS(369),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(291),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(291),
    [aux_sym_preproc_else_token1] = ACTIONS(293),
    [aux_sym_preproc_elif_token1] = ACTIONS(295),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(297),
    [sym_preproc_directive] = ACTIONS(299),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym___extension__] = ACTIONS(303),
    [anon_sym_typedef] = ACTIONS(305),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(307),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(311),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(339),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_using] = ACTIONS(347),
    [anon_sym_static_assert] = ACTIONS(349),
    [anon_sym_concept] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(359),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [13] = {
    [sym__block_item] = STATE(23),
    [sym_preproc_include] = STATE(23),
    [sym_preproc_def] = STATE(23),
    [sym_preproc_function_def] = STATE(23),
    [sym_preproc_call] = STATE(23),
    [sym_preproc_if] = STATE(23),
    [sym_preproc_ifdef] = STATE(23),
    [sym_preproc_else] = STATE(10384),
    [sym_preproc_elif] = STATE(10384),
    [sym_preproc_elifdef] = STATE(10384),
    [sym_function_definition] = STATE(23),
    [sym_declaration] = STATE(23),
    [sym_type_definition] = STATE(23),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5695),
    [sym_linkage_specification] = STATE(23),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1831),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7515),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(406),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2673),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(496),
    [sym_statement] = STATE(23),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(23),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2594),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(23),
    [sym_template_instantiation] = STATE(23),
    [sym_operator_cast] = STATE(8424),
    [sym__constructor_specifiers] = STATE(2594),
    [sym_operator_cast_definition] = STATE(23),
    [sym_operator_cast_declaration] = STATE(23),
    [sym_constructor_or_destructor_definition] = STATE(23),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(23),
    [sym_namespace_alias_definition] = STATE(23),
    [sym_using_declaration] = STATE(23),
    [sym_alias_declaration] = STATE(23),
    [sym_static_assert_declaration] = STATE(23),
    [sym_concept_definition] = STATE(23),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8424),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(1475),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(23),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2594),
    [sym_identifier] = ACTIONS(281),
    [aux_sym_preproc_include_token1] = ACTIONS(283),
    [aux_sym_preproc_def_token1] = ACTIONS(285),
    [aux_sym_preproc_if_token1] = ACTIONS(287),
    [aux_sym_preproc_if_token2] = ACTIONS(371),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(291),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(291),
    [aux_sym_preproc_else_token1] = ACTIONS(293),
    [aux_sym_preproc_elif_token1] = ACTIONS(295),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(297),
    [sym_preproc_directive] = ACTIONS(299),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym___extension__] = ACTIONS(303),
    [anon_sym_typedef] = ACTIONS(305),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(307),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(311),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(339),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_using] = ACTIONS(347),
    [anon_sym_static_assert] = ACTIONS(349),
    [anon_sym_concept] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(359),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [14] = {
    [sym__block_item] = STATE(11),
    [sym_preproc_include] = STATE(11),
    [sym_preproc_def] = STATE(11),
    [sym_preproc_function_def] = STATE(11),
    [sym_preproc_call] = STATE(11),
    [sym_preproc_if] = STATE(11),
    [sym_preproc_ifdef] = STATE(11),
    [sym_preproc_else] = STATE(10898),
    [sym_preproc_elif] = STATE(10898),
    [sym_preproc_elifdef] = STATE(10898),
    [sym_function_definition] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_type_definition] = STATE(11),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5695),
    [sym_linkage_specification] = STATE(11),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1831),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7515),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(406),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2673),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(496),
    [sym_statement] = STATE(11),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(11),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2594),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(11),
    [sym_template_instantiation] = STATE(11),
    [sym_operator_cast] = STATE(8424),
    [sym__constructor_specifiers] = STATE(2594),
    [sym_operator_cast_definition] = STATE(11),
    [sym_operator_cast_declaration] = STATE(11),
    [sym_constructor_or_destructor_definition] = STATE(11),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(11),
    [sym_namespace_alias_definition] = STATE(11),
    [sym_using_declaration] = STATE(11),
    [sym_alias_declaration] = STATE(11),
    [sym_static_assert_declaration] = STATE(11),
    [sym_concept_definition] = STATE(11),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8424),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(1475),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(11),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2594),
    [sym_identifier] = ACTIONS(281),
    [aux_sym_preproc_include_token1] = ACTIONS(283),
    [aux_sym_preproc_def_token1] = ACTIONS(285),
    [aux_sym_preproc_if_token1] = ACTIONS(287),
    [aux_sym_preproc_if_token2] = ACTIONS(373),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(291),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(291),
    [aux_sym_preproc_else_token1] = ACTIONS(293),
    [aux_sym_preproc_elif_token1] = ACTIONS(295),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(297),
    [sym_preproc_directive] = ACTIONS(299),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym___extension__] = ACTIONS(303),
    [anon_sym_typedef] = ACTIONS(305),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(307),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(311),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(339),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_using] = ACTIONS(347),
    [anon_sym_static_assert] = ACTIONS(349),
    [anon_sym_concept] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(359),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [15] = {
    [sym__block_item] = STATE(27),
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(10793),
    [sym_preproc_elif] = STATE(10793),
    [sym_preproc_elifdef] = STATE(10793),
    [sym_function_definition] = STATE(27),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5695),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1831),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7515),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(406),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2673),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(496),
    [sym_statement] = STATE(27),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(27),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2594),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(27),
    [sym_template_instantiation] = STATE(27),
    [sym_operator_cast] = STATE(8424),
    [sym__constructor_specifiers] = STATE(2594),
    [sym_operator_cast_definition] = STATE(27),
    [sym_operator_cast_declaration] = STATE(27),
    [sym_constructor_or_destructor_definition] = STATE(27),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(27),
    [sym_namespace_alias_definition] = STATE(27),
    [sym_using_declaration] = STATE(27),
    [sym_alias_declaration] = STATE(27),
    [sym_static_assert_declaration] = STATE(27),
    [sym_concept_definition] = STATE(27),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8424),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(1475),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2594),
    [sym_identifier] = ACTIONS(281),
    [aux_sym_preproc_include_token1] = ACTIONS(283),
    [aux_sym_preproc_def_token1] = ACTIONS(285),
    [aux_sym_preproc_if_token1] = ACTIONS(287),
    [aux_sym_preproc_if_token2] = ACTIONS(375),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(291),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(291),
    [aux_sym_preproc_else_token1] = ACTIONS(293),
    [aux_sym_preproc_elif_token1] = ACTIONS(295),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(297),
    [sym_preproc_directive] = ACTIONS(299),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym___extension__] = ACTIONS(303),
    [anon_sym_typedef] = ACTIONS(305),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(307),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(311),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(339),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_using] = ACTIONS(347),
    [anon_sym_static_assert] = ACTIONS(349),
    [anon_sym_concept] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(359),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [16] = {
    [sym__block_item] = STATE(17),
    [sym_preproc_include] = STATE(17),
    [sym_preproc_def] = STATE(17),
    [sym_preproc_function_def] = STATE(17),
    [sym_preproc_call] = STATE(17),
    [sym_preproc_if] = STATE(17),
    [sym_preproc_ifdef] = STATE(17),
    [sym_preproc_else] = STATE(10322),
    [sym_preproc_elif] = STATE(10322),
    [sym_preproc_elifdef] = STATE(10322),
    [sym_function_definition] = STATE(17),
    [sym_declaration] = STATE(17),
    [sym_type_definition] = STATE(17),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5695),
    [sym_linkage_specification] = STATE(17),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1831),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7515),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(406),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2673),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(496),
    [sym_statement] = STATE(17),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(17),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2594),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(17),
    [sym_template_instantiation] = STATE(17),
    [sym_operator_cast] = STATE(8424),
    [sym__constructor_specifiers] = STATE(2594),
    [sym_operator_cast_definition] = STATE(17),
    [sym_operator_cast_declaration] = STATE(17),
    [sym_constructor_or_destructor_definition] = STATE(17),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(17),
    [sym_namespace_alias_definition] = STATE(17),
    [sym_using_declaration] = STATE(17),
    [sym_alias_declaration] = STATE(17),
    [sym_static_assert_declaration] = STATE(17),
    [sym_concept_definition] = STATE(17),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8424),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(1475),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(17),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2594),
    [sym_identifier] = ACTIONS(281),
    [aux_sym_preproc_include_token1] = ACTIONS(283),
    [aux_sym_preproc_def_token1] = ACTIONS(285),
    [aux_sym_preproc_if_token1] = ACTIONS(287),
    [aux_sym_preproc_if_token2] = ACTIONS(377),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(291),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(291),
    [aux_sym_preproc_else_token1] = ACTIONS(293),
    [aux_sym_preproc_elif_token1] = ACTIONS(295),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(297),
    [sym_preproc_directive] = ACTIONS(299),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym___extension__] = ACTIONS(303),
    [anon_sym_typedef] = ACTIONS(305),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(307),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(311),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(339),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_using] = ACTIONS(347),
    [anon_sym_static_assert] = ACTIONS(349),
    [anon_sym_concept] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(359),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [17] = {
    [sym__block_item] = STATE(27),
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(10126),
    [sym_preproc_elif] = STATE(10126),
    [sym_preproc_elifdef] = STATE(10126),
    [sym_function_definition] = STATE(27),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5695),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1831),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7515),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(406),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2673),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(496),
    [sym_statement] = STATE(27),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(27),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2594),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(27),
    [sym_template_instantiation] = STATE(27),
    [sym_operator_cast] = STATE(8424),
    [sym__constructor_specifiers] = STATE(2594),
    [sym_operator_cast_definition] = STATE(27),
    [sym_operator_cast_declaration] = STATE(27),
    [sym_constructor_or_destructor_definition] = STATE(27),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(27),
    [sym_namespace_alias_definition] = STATE(27),
    [sym_using_declaration] = STATE(27),
    [sym_alias_declaration] = STATE(27),
    [sym_static_assert_declaration] = STATE(27),
    [sym_concept_definition] = STATE(27),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8424),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(1475),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2594),
    [sym_identifier] = ACTIONS(281),
    [aux_sym_preproc_include_token1] = ACTIONS(283),
    [aux_sym_preproc_def_token1] = ACTIONS(285),
    [aux_sym_preproc_if_token1] = ACTIONS(287),
    [aux_sym_preproc_if_token2] = ACTIONS(379),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(291),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(291),
    [aux_sym_preproc_else_token1] = ACTIONS(293),
    [aux_sym_preproc_elif_token1] = ACTIONS(295),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(297),
    [sym_preproc_directive] = ACTIONS(299),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym___extension__] = ACTIONS(303),
    [anon_sym_typedef] = ACTIONS(305),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(307),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(311),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(339),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_using] = ACTIONS(347),
    [anon_sym_static_assert] = ACTIONS(349),
    [anon_sym_concept] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(359),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [18] = {
    [sym__block_item] = STATE(21),
    [sym_preproc_include] = STATE(21),
    [sym_preproc_def] = STATE(21),
    [sym_preproc_function_def] = STATE(21),
    [sym_preproc_call] = STATE(21),
    [sym_preproc_if] = STATE(21),
    [sym_preproc_ifdef] = STATE(21),
    [sym_preproc_else] = STATE(10130),
    [sym_preproc_elif] = STATE(10130),
    [sym_preproc_elifdef] = STATE(10130),
    [sym_function_definition] = STATE(21),
    [sym_declaration] = STATE(21),
    [sym_type_definition] = STATE(21),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5695),
    [sym_linkage_specification] = STATE(21),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1831),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7515),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(406),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2673),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(496),
    [sym_statement] = STATE(21),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(21),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2594),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(21),
    [sym_template_instantiation] = STATE(21),
    [sym_operator_cast] = STATE(8424),
    [sym__constructor_specifiers] = STATE(2594),
    [sym_operator_cast_definition] = STATE(21),
    [sym_operator_cast_declaration] = STATE(21),
    [sym_constructor_or_destructor_definition] = STATE(21),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(21),
    [sym_namespace_alias_definition] = STATE(21),
    [sym_using_declaration] = STATE(21),
    [sym_alias_declaration] = STATE(21),
    [sym_static_assert_declaration] = STATE(21),
    [sym_concept_definition] = STATE(21),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8424),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(1475),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(21),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2594),
    [sym_identifier] = ACTIONS(281),
    [aux_sym_preproc_include_token1] = ACTIONS(283),
    [aux_sym_preproc_def_token1] = ACTIONS(285),
    [aux_sym_preproc_if_token1] = ACTIONS(287),
    [aux_sym_preproc_if_token2] = ACTIONS(381),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(291),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(291),
    [aux_sym_preproc_else_token1] = ACTIONS(293),
    [aux_sym_preproc_elif_token1] = ACTIONS(295),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(297),
    [sym_preproc_directive] = ACTIONS(299),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym___extension__] = ACTIONS(303),
    [anon_sym_typedef] = ACTIONS(305),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(307),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(311),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(339),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_using] = ACTIONS(347),
    [anon_sym_static_assert] = ACTIONS(349),
    [anon_sym_concept] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(359),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [19] = {
    [sym__block_item] = STATE(27),
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(10125),
    [sym_preproc_elif] = STATE(10125),
    [sym_preproc_elifdef] = STATE(10125),
    [sym_function_definition] = STATE(27),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5695),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1831),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7515),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(406),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2673),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(496),
    [sym_statement] = STATE(27),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(27),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2594),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(27),
    [sym_template_instantiation] = STATE(27),
    [sym_operator_cast] = STATE(8424),
    [sym__constructor_specifiers] = STATE(2594),
    [sym_operator_cast_definition] = STATE(27),
    [sym_operator_cast_declaration] = STATE(27),
    [sym_constructor_or_destructor_definition] = STATE(27),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(27),
    [sym_namespace_alias_definition] = STATE(27),
    [sym_using_declaration] = STATE(27),
    [sym_alias_declaration] = STATE(27),
    [sym_static_assert_declaration] = STATE(27),
    [sym_concept_definition] = STATE(27),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8424),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(1475),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2594),
    [sym_identifier] = ACTIONS(281),
    [aux_sym_preproc_include_token1] = ACTIONS(283),
    [aux_sym_preproc_def_token1] = ACTIONS(285),
    [aux_sym_preproc_if_token1] = ACTIONS(287),
    [aux_sym_preproc_if_token2] = ACTIONS(383),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(291),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(291),
    [aux_sym_preproc_else_token1] = ACTIONS(293),
    [aux_sym_preproc_elif_token1] = ACTIONS(295),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(297),
    [sym_preproc_directive] = ACTIONS(299),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym___extension__] = ACTIONS(303),
    [anon_sym_typedef] = ACTIONS(305),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(307),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(311),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(339),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_using] = ACTIONS(347),
    [anon_sym_static_assert] = ACTIONS(349),
    [anon_sym_concept] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(359),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [20] = {
    [sym__block_item] = STATE(8),
    [sym_preproc_include] = STATE(8),
    [sym_preproc_def] = STATE(8),
    [sym_preproc_function_def] = STATE(8),
    [sym_preproc_call] = STATE(8),
    [sym_preproc_if] = STATE(8),
    [sym_preproc_ifdef] = STATE(8),
    [sym_preproc_else] = STATE(10318),
    [sym_preproc_elif] = STATE(10318),
    [sym_preproc_elifdef] = STATE(10318),
    [sym_function_definition] = STATE(8),
    [sym_declaration] = STATE(8),
    [sym_type_definition] = STATE(8),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5695),
    [sym_linkage_specification] = STATE(8),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1831),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7515),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(406),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2673),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(496),
    [sym_statement] = STATE(8),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(8),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2594),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(8),
    [sym_template_instantiation] = STATE(8),
    [sym_operator_cast] = STATE(8424),
    [sym__constructor_specifiers] = STATE(2594),
    [sym_operator_cast_definition] = STATE(8),
    [sym_operator_cast_declaration] = STATE(8),
    [sym_constructor_or_destructor_definition] = STATE(8),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(8),
    [sym_namespace_alias_definition] = STATE(8),
    [sym_using_declaration] = STATE(8),
    [sym_alias_declaration] = STATE(8),
    [sym_static_assert_declaration] = STATE(8),
    [sym_concept_definition] = STATE(8),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8424),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(1475),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(8),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2594),
    [sym_identifier] = ACTIONS(281),
    [aux_sym_preproc_include_token1] = ACTIONS(283),
    [aux_sym_preproc_def_token1] = ACTIONS(285),
    [aux_sym_preproc_if_token1] = ACTIONS(287),
    [aux_sym_preproc_if_token2] = ACTIONS(385),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(291),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(291),
    [aux_sym_preproc_else_token1] = ACTIONS(293),
    [aux_sym_preproc_elif_token1] = ACTIONS(295),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(297),
    [sym_preproc_directive] = ACTIONS(299),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym___extension__] = ACTIONS(303),
    [anon_sym_typedef] = ACTIONS(305),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(307),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(311),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(339),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_using] = ACTIONS(347),
    [anon_sym_static_assert] = ACTIONS(349),
    [anon_sym_concept] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(359),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [21] = {
    [sym__block_item] = STATE(27),
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(10140),
    [sym_preproc_elif] = STATE(10140),
    [sym_preproc_elifdef] = STATE(10140),
    [sym_function_definition] = STATE(27),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5695),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1831),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7515),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(406),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2673),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(496),
    [sym_statement] = STATE(27),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(27),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2594),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(27),
    [sym_template_instantiation] = STATE(27),
    [sym_operator_cast] = STATE(8424),
    [sym__constructor_specifiers] = STATE(2594),
    [sym_operator_cast_definition] = STATE(27),
    [sym_operator_cast_declaration] = STATE(27),
    [sym_constructor_or_destructor_definition] = STATE(27),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(27),
    [sym_namespace_alias_definition] = STATE(27),
    [sym_using_declaration] = STATE(27),
    [sym_alias_declaration] = STATE(27),
    [sym_static_assert_declaration] = STATE(27),
    [sym_concept_definition] = STATE(27),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8424),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(1475),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2594),
    [sym_identifier] = ACTIONS(281),
    [aux_sym_preproc_include_token1] = ACTIONS(283),
    [aux_sym_preproc_def_token1] = ACTIONS(285),
    [aux_sym_preproc_if_token1] = ACTIONS(287),
    [aux_sym_preproc_if_token2] = ACTIONS(387),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(291),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(291),
    [aux_sym_preproc_else_token1] = ACTIONS(293),
    [aux_sym_preproc_elif_token1] = ACTIONS(295),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(297),
    [sym_preproc_directive] = ACTIONS(299),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym___extension__] = ACTIONS(303),
    [anon_sym_typedef] = ACTIONS(305),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(307),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(311),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(339),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_using] = ACTIONS(347),
    [anon_sym_static_assert] = ACTIONS(349),
    [anon_sym_concept] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(359),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [22] = {
    [sym__block_item] = STATE(12),
    [sym_preproc_include] = STATE(12),
    [sym_preproc_def] = STATE(12),
    [sym_preproc_function_def] = STATE(12),
    [sym_preproc_call] = STATE(12),
    [sym_preproc_if] = STATE(12),
    [sym_preproc_ifdef] = STATE(12),
    [sym_preproc_else] = STATE(10792),
    [sym_preproc_elif] = STATE(10792),
    [sym_preproc_elifdef] = STATE(10792),
    [sym_function_definition] = STATE(12),
    [sym_declaration] = STATE(12),
    [sym_type_definition] = STATE(12),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5695),
    [sym_linkage_specification] = STATE(12),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1831),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7515),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(406),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2673),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(496),
    [sym_statement] = STATE(12),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(12),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2594),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(12),
    [sym_template_instantiation] = STATE(12),
    [sym_operator_cast] = STATE(8424),
    [sym__constructor_specifiers] = STATE(2594),
    [sym_operator_cast_definition] = STATE(12),
    [sym_operator_cast_declaration] = STATE(12),
    [sym_constructor_or_destructor_definition] = STATE(12),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(12),
    [sym_namespace_alias_definition] = STATE(12),
    [sym_using_declaration] = STATE(12),
    [sym_alias_declaration] = STATE(12),
    [sym_static_assert_declaration] = STATE(12),
    [sym_concept_definition] = STATE(12),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8424),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(1475),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(12),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2594),
    [sym_identifier] = ACTIONS(281),
    [aux_sym_preproc_include_token1] = ACTIONS(283),
    [aux_sym_preproc_def_token1] = ACTIONS(285),
    [aux_sym_preproc_if_token1] = ACTIONS(287),
    [aux_sym_preproc_if_token2] = ACTIONS(389),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(291),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(291),
    [aux_sym_preproc_else_token1] = ACTIONS(293),
    [aux_sym_preproc_elif_token1] = ACTIONS(295),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(297),
    [sym_preproc_directive] = ACTIONS(299),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym___extension__] = ACTIONS(303),
    [anon_sym_typedef] = ACTIONS(305),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(307),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(311),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(339),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_using] = ACTIONS(347),
    [anon_sym_static_assert] = ACTIONS(349),
    [anon_sym_concept] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(359),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [23] = {
    [sym__block_item] = STATE(27),
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(10436),
    [sym_preproc_elif] = STATE(10436),
    [sym_preproc_elifdef] = STATE(10436),
    [sym_function_definition] = STATE(27),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5695),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1831),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7515),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(406),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2673),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(496),
    [sym_statement] = STATE(27),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(27),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2594),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(27),
    [sym_template_instantiation] = STATE(27),
    [sym_operator_cast] = STATE(8424),
    [sym__constructor_specifiers] = STATE(2594),
    [sym_operator_cast_definition] = STATE(27),
    [sym_operator_cast_declaration] = STATE(27),
    [sym_constructor_or_destructor_definition] = STATE(27),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(27),
    [sym_namespace_alias_definition] = STATE(27),
    [sym_using_declaration] = STATE(27),
    [sym_alias_declaration] = STATE(27),
    [sym_static_assert_declaration] = STATE(27),
    [sym_concept_definition] = STATE(27),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8424),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(1475),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2594),
    [sym_identifier] = ACTIONS(281),
    [aux_sym_preproc_include_token1] = ACTIONS(283),
    [aux_sym_preproc_def_token1] = ACTIONS(285),
    [aux_sym_preproc_if_token1] = ACTIONS(287),
    [aux_sym_preproc_if_token2] = ACTIONS(391),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(291),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(291),
    [aux_sym_preproc_else_token1] = ACTIONS(293),
    [aux_sym_preproc_elif_token1] = ACTIONS(295),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(297),
    [sym_preproc_directive] = ACTIONS(299),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym___extension__] = ACTIONS(303),
    [anon_sym_typedef] = ACTIONS(305),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(307),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(311),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(339),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_using] = ACTIONS(347),
    [anon_sym_static_assert] = ACTIONS(349),
    [anon_sym_concept] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(359),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [24] = {
    [sym__block_item] = STATE(15),
    [sym_preproc_include] = STATE(15),
    [sym_preproc_def] = STATE(15),
    [sym_preproc_function_def] = STATE(15),
    [sym_preproc_call] = STATE(15),
    [sym_preproc_if] = STATE(15),
    [sym_preproc_ifdef] = STATE(15),
    [sym_preproc_else] = STATE(10670),
    [sym_preproc_elif] = STATE(10670),
    [sym_preproc_elifdef] = STATE(10670),
    [sym_function_definition] = STATE(15),
    [sym_declaration] = STATE(15),
    [sym_type_definition] = STATE(15),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5695),
    [sym_linkage_specification] = STATE(15),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1831),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7515),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(406),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2673),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(496),
    [sym_statement] = STATE(15),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(15),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2594),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(15),
    [sym_template_instantiation] = STATE(15),
    [sym_operator_cast] = STATE(8424),
    [sym__constructor_specifiers] = STATE(2594),
    [sym_operator_cast_definition] = STATE(15),
    [sym_operator_cast_declaration] = STATE(15),
    [sym_constructor_or_destructor_definition] = STATE(15),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(15),
    [sym_namespace_alias_definition] = STATE(15),
    [sym_using_declaration] = STATE(15),
    [sym_alias_declaration] = STATE(15),
    [sym_static_assert_declaration] = STATE(15),
    [sym_concept_definition] = STATE(15),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8424),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(1475),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(15),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2594),
    [sym_identifier] = ACTIONS(281),
    [aux_sym_preproc_include_token1] = ACTIONS(283),
    [aux_sym_preproc_def_token1] = ACTIONS(285),
    [aux_sym_preproc_if_token1] = ACTIONS(287),
    [aux_sym_preproc_if_token2] = ACTIONS(393),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(291),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(291),
    [aux_sym_preproc_else_token1] = ACTIONS(293),
    [aux_sym_preproc_elif_token1] = ACTIONS(295),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(297),
    [sym_preproc_directive] = ACTIONS(299),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym___extension__] = ACTIONS(303),
    [anon_sym_typedef] = ACTIONS(305),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(307),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(311),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(339),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_using] = ACTIONS(347),
    [anon_sym_static_assert] = ACTIONS(349),
    [anon_sym_concept] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(359),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [25] = {
    [sym__block_item] = STATE(27),
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(10324),
    [sym_preproc_elif] = STATE(10324),
    [sym_preproc_elifdef] = STATE(10324),
    [sym_function_definition] = STATE(27),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5695),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1831),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7515),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(406),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2673),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(496),
    [sym_statement] = STATE(27),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(27),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2594),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(27),
    [sym_template_instantiation] = STATE(27),
    [sym_operator_cast] = STATE(8424),
    [sym__constructor_specifiers] = STATE(2594),
    [sym_operator_cast_definition] = STATE(27),
    [sym_operator_cast_declaration] = STATE(27),
    [sym_constructor_or_destructor_definition] = STATE(27),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(27),
    [sym_namespace_alias_definition] = STATE(27),
    [sym_using_declaration] = STATE(27),
    [sym_alias_declaration] = STATE(27),
    [sym_static_assert_declaration] = STATE(27),
    [sym_concept_definition] = STATE(27),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8424),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(1475),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2594),
    [sym_identifier] = ACTIONS(281),
    [aux_sym_preproc_include_token1] = ACTIONS(283),
    [aux_sym_preproc_def_token1] = ACTIONS(285),
    [aux_sym_preproc_if_token1] = ACTIONS(287),
    [aux_sym_preproc_if_token2] = ACTIONS(395),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(291),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(291),
    [aux_sym_preproc_else_token1] = ACTIONS(293),
    [aux_sym_preproc_elif_token1] = ACTIONS(295),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(297),
    [sym_preproc_directive] = ACTIONS(299),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym___extension__] = ACTIONS(303),
    [anon_sym_typedef] = ACTIONS(305),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(307),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(311),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(339),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_using] = ACTIONS(347),
    [anon_sym_static_assert] = ACTIONS(349),
    [anon_sym_concept] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(359),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [26] = {
    [sym__block_item] = STATE(7),
    [sym_preproc_include] = STATE(7),
    [sym_preproc_def] = STATE(7),
    [sym_preproc_function_def] = STATE(7),
    [sym_preproc_call] = STATE(7),
    [sym_preproc_if] = STATE(7),
    [sym_preproc_ifdef] = STATE(7),
    [sym_preproc_else] = STATE(10329),
    [sym_preproc_elif] = STATE(10329),
    [sym_preproc_elifdef] = STATE(10329),
    [sym_function_definition] = STATE(7),
    [sym_declaration] = STATE(7),
    [sym_type_definition] = STATE(7),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5695),
    [sym_linkage_specification] = STATE(7),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1831),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7515),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(406),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2673),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(496),
    [sym_statement] = STATE(7),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(7),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2594),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(7),
    [sym_template_instantiation] = STATE(7),
    [sym_operator_cast] = STATE(8424),
    [sym__constructor_specifiers] = STATE(2594),
    [sym_operator_cast_definition] = STATE(7),
    [sym_operator_cast_declaration] = STATE(7),
    [sym_constructor_or_destructor_definition] = STATE(7),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(7),
    [sym_namespace_alias_definition] = STATE(7),
    [sym_using_declaration] = STATE(7),
    [sym_alias_declaration] = STATE(7),
    [sym_static_assert_declaration] = STATE(7),
    [sym_concept_definition] = STATE(7),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8424),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(1475),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(7),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2594),
    [sym_identifier] = ACTIONS(281),
    [aux_sym_preproc_include_token1] = ACTIONS(283),
    [aux_sym_preproc_def_token1] = ACTIONS(285),
    [aux_sym_preproc_if_token1] = ACTIONS(287),
    [aux_sym_preproc_if_token2] = ACTIONS(397),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(291),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(291),
    [aux_sym_preproc_else_token1] = ACTIONS(293),
    [aux_sym_preproc_elif_token1] = ACTIONS(295),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(297),
    [sym_preproc_directive] = ACTIONS(299),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym___extension__] = ACTIONS(303),
    [anon_sym_typedef] = ACTIONS(305),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(307),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(311),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(339),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_using] = ACTIONS(347),
    [anon_sym_static_assert] = ACTIONS(349),
    [anon_sym_concept] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(359),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [27] = {
    [sym__block_item] = STATE(27),
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_function_definition] = STATE(27),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5695),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1831),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7515),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(406),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2673),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(496),
    [sym_statement] = STATE(27),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(27),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2594),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(27),
    [sym_template_instantiation] = STATE(27),
    [sym_operator_cast] = STATE(8424),
    [sym__constructor_specifiers] = STATE(2594),
    [sym_operator_cast_definition] = STATE(27),
    [sym_operator_cast_declaration] = STATE(27),
    [sym_constructor_or_destructor_definition] = STATE(27),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(27),
    [sym_namespace_alias_definition] = STATE(27),
    [sym_using_declaration] = STATE(27),
    [sym_alias_declaration] = STATE(27),
    [sym_static_assert_declaration] = STATE(27),
    [sym_concept_definition] = STATE(27),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8424),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(1475),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2594),
    [sym_identifier] = ACTIONS(399),
    [aux_sym_preproc_include_token1] = ACTIONS(402),
    [aux_sym_preproc_def_token1] = ACTIONS(405),
    [aux_sym_preproc_if_token1] = ACTIONS(408),
    [aux_sym_preproc_if_token2] = ACTIONS(411),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(413),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(413),
    [aux_sym_preproc_else_token1] = ACTIONS(411),
    [aux_sym_preproc_elif_token1] = ACTIONS(411),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(411),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(411),
    [sym_preproc_directive] = ACTIONS(416),
    [anon_sym_LPAREN2] = ACTIONS(419),
    [anon_sym_BANG] = ACTIONS(422),
    [anon_sym_TILDE] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(428),
    [anon_sym_PLUS] = ACTIONS(428),
    [anon_sym_STAR] = ACTIONS(431),
    [anon_sym_AMP_AMP] = ACTIONS(434),
    [anon_sym_AMP] = ACTIONS(437),
    [anon_sym_SEMI] = ACTIONS(440),
    [anon_sym___extension__] = ACTIONS(443),
    [anon_sym_typedef] = ACTIONS(446),
    [anon_sym_in] = ACTIONS(449),
    [anon_sym_out] = ACTIONS(449),
    [anon_sym_inout] = ACTIONS(449),
    [anon_sym_extern] = ACTIONS(452),
    [anon_sym___attribute__] = ACTIONS(455),
    [anon_sym_COLON_COLON] = ACTIONS(458),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(461),
    [anon_sym___declspec] = ACTIONS(464),
    [anon_sym___based] = ACTIONS(467),
    [anon_sym___cdecl] = ACTIONS(470),
    [anon_sym___clrcall] = ACTIONS(470),
    [anon_sym___stdcall] = ACTIONS(470),
    [anon_sym___fastcall] = ACTIONS(470),
    [anon_sym___thiscall] = ACTIONS(470),
    [anon_sym___vectorcall] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(473),
    [anon_sym_signed] = ACTIONS(476),
    [anon_sym_unsigned] = ACTIONS(476),
    [anon_sym_long] = ACTIONS(476),
    [anon_sym_short] = ACTIONS(476),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(482),
    [anon_sym_register] = ACTIONS(482),
    [anon_sym_inline] = ACTIONS(485),
    [anon_sym___inline] = ACTIONS(482),
    [anon_sym___inline__] = ACTIONS(482),
    [anon_sym___forceinline] = ACTIONS(482),
    [anon_sym_thread_local] = ACTIONS(482),
    [anon_sym___thread] = ACTIONS(482),
    [anon_sym_const] = ACTIONS(488),
    [anon_sym_constexpr] = ACTIONS(488),
    [anon_sym_volatile] = ACTIONS(488),
    [anon_sym_restrict] = ACTIONS(488),
    [anon_sym___restrict__] = ACTIONS(488),
    [anon_sym__Atomic] = ACTIONS(488),
    [anon_sym__Noreturn] = ACTIONS(488),
    [anon_sym_noreturn] = ACTIONS(488),
    [anon_sym_mutable] = ACTIONS(488),
    [anon_sym_constinit] = ACTIONS(488),
    [anon_sym_consteval] = ACTIONS(488),
    [anon_sym_alignas] = ACTIONS(491),
    [anon_sym__Alignas] = ACTIONS(491),
    [sym_primitive_type] = ACTIONS(494),
    [anon_sym_enum] = ACTIONS(497),
    [anon_sym_class] = ACTIONS(500),
    [anon_sym_struct] = ACTIONS(503),
    [anon_sym_union] = ACTIONS(506),
    [anon_sym_if] = ACTIONS(509),
    [anon_sym_switch] = ACTIONS(512),
    [anon_sym_case] = ACTIONS(515),
    [anon_sym_default] = ACTIONS(518),
    [anon_sym_while] = ACTIONS(521),
    [anon_sym_do] = ACTIONS(524),
    [anon_sym_for] = ACTIONS(527),
    [anon_sym_return] = ACTIONS(530),
    [anon_sym_break] = ACTIONS(533),
    [anon_sym_continue] = ACTIONS(536),
    [anon_sym_goto] = ACTIONS(539),
    [anon_sym___try] = ACTIONS(542),
    [anon_sym___leave] = ACTIONS(545),
    [anon_sym_not] = ACTIONS(428),
    [anon_sym_compl] = ACTIONS(428),
    [anon_sym_DASH_DASH] = ACTIONS(548),
    [anon_sym_PLUS_PLUS] = ACTIONS(548),
    [anon_sym_sizeof] = ACTIONS(551),
    [anon_sym___alignof__] = ACTIONS(554),
    [anon_sym___alignof] = ACTIONS(554),
    [anon_sym__alignof] = ACTIONS(554),
    [anon_sym_alignof] = ACTIONS(554),
    [anon_sym__Alignof] = ACTIONS(554),
    [anon_sym_offsetof] = ACTIONS(557),
    [anon_sym__Generic] = ACTIONS(560),
    [anon_sym_asm] = ACTIONS(563),
    [anon_sym___asm__] = ACTIONS(563),
    [sym_number_literal] = ACTIONS(566),
    [anon_sym_L_SQUOTE] = ACTIONS(569),
    [anon_sym_u_SQUOTE] = ACTIONS(569),
    [anon_sym_U_SQUOTE] = ACTIONS(569),
    [anon_sym_u8_SQUOTE] = ACTIONS(569),
    [anon_sym_SQUOTE] = ACTIONS(569),
    [anon_sym_L_DQUOTE] = ACTIONS(572),
    [anon_sym_u_DQUOTE] = ACTIONS(572),
    [anon_sym_U_DQUOTE] = ACTIONS(572),
    [anon_sym_u8_DQUOTE] = ACTIONS(572),
    [anon_sym_DQUOTE] = ACTIONS(572),
    [sym_true] = ACTIONS(575),
    [sym_false] = ACTIONS(575),
    [anon_sym_NULL] = ACTIONS(578),
    [anon_sym_nullptr] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(581),
    [anon_sym_let] = ACTIONS(581),
    [anon_sym_This] = ACTIONS(581),
    [anon_sym_decltype] = ACTIONS(584),
    [sym_virtual] = ACTIONS(449),
    [anon_sym_explicit] = ACTIONS(587),
    [anon_sym_typename] = ACTIONS(590),
    [anon_sym_template] = ACTIONS(593),
    [anon_sym_operator] = ACTIONS(596),
    [anon_sym_try] = ACTIONS(599),
    [anon_sym_delete] = ACTIONS(602),
    [anon_sym_throw] = ACTIONS(605),
    [anon_sym_namespace] = ACTIONS(608),
    [anon_sym_using] = ACTIONS(611),
    [anon_sym_static_assert] = ACTIONS(614),
    [anon_sym_concept] = ACTIONS(617),
    [anon_sym_co_return] = ACTIONS(620),
    [anon_sym_co_yield] = ACTIONS(623),
    [anon_sym_R_DQUOTE] = ACTIONS(626),
    [anon_sym_LR_DQUOTE] = ACTIONS(626),
    [anon_sym_uR_DQUOTE] = ACTIONS(626),
    [anon_sym_UR_DQUOTE] = ACTIONS(626),
    [anon_sym_u8R_DQUOTE] = ACTIONS(626),
    [anon_sym_co_await] = ACTIONS(629),
    [anon_sym_new] = ACTIONS(632),
    [anon_sym_requires] = ACTIONS(635),
    [sym_this] = ACTIONS(575),
    [anon_sym_discard] = ACTIONS(638),
    [anon_sym_precise] = ACTIONS(641),
    [anon_sym_shared] = ACTIONS(641),
    [anon_sym_groupshared] = ACTIONS(641),
    [anon_sym_uniform] = ACTIONS(641),
    [anon_sym_row_major] = ACTIONS(641),
    [anon_sym_column_major] = ACTIONS(641),
    [anon_sym_globallycoherent] = ACTIONS(641),
    [anon_sym_centroid] = ACTIONS(641),
    [anon_sym_noperspective] = ACTIONS(641),
    [anon_sym_nointerpolation] = ACTIONS(641),
    [anon_sym_sample] = ACTIONS(641),
    [anon_sym_linear] = ACTIONS(641),
    [anon_sym_snorm] = ACTIONS(641),
    [anon_sym_unorm] = ACTIONS(641),
    [anon_sym_point] = ACTIONS(641),
    [anon_sym_line] = ACTIONS(641),
    [anon_sym_triangleadj] = ACTIONS(641),
    [anon_sym_lineadj] = ACTIONS(641),
    [anon_sym_triangle] = ACTIONS(641),
    [anon_sym_cbuffer] = ACTIONS(644),
    [anon_sym_interface] = ACTIONS(647),
    [anon_sym_extension] = ACTIONS(650),
  },
  [28] = {
    [sym__block_item] = STATE(30),
    [sym_preproc_include] = STATE(30),
    [sym_preproc_def] = STATE(30),
    [sym_preproc_function_def] = STATE(30),
    [sym_preproc_call] = STATE(30),
    [sym_preproc_if] = STATE(30),
    [sym_preproc_ifdef] = STATE(30),
    [sym_function_definition] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_type_definition] = STATE(30),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(30),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(30),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(30),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(30),
    [sym_template_instantiation] = STATE(30),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(30),
    [sym_operator_cast_declaration] = STATE(30),
    [sym_constructor_or_destructor_definition] = STATE(30),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(30),
    [sym_namespace_alias_definition] = STATE(30),
    [sym_using_declaration] = STATE(30),
    [sym_alias_declaration] = STATE(30),
    [sym_static_assert_declaration] = STATE(30),
    [sym_concept_definition] = STATE(30),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(30),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(657),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [29] = {
    [sym__block_item] = STATE(30),
    [sym_preproc_include] = STATE(30),
    [sym_preproc_def] = STATE(30),
    [sym_preproc_function_def] = STATE(30),
    [sym_preproc_call] = STATE(30),
    [sym_preproc_if] = STATE(30),
    [sym_preproc_ifdef] = STATE(30),
    [sym_function_definition] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_type_definition] = STATE(30),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(30),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(30),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(30),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(30),
    [sym_template_instantiation] = STATE(30),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(30),
    [sym_operator_cast_declaration] = STATE(30),
    [sym_constructor_or_destructor_definition] = STATE(30),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(30),
    [sym_namespace_alias_definition] = STATE(30),
    [sym_using_declaration] = STATE(30),
    [sym_alias_declaration] = STATE(30),
    [sym_static_assert_declaration] = STATE(30),
    [sym_concept_definition] = STATE(30),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(30),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(659),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [30] = {
    [sym__block_item] = STATE(30),
    [sym_preproc_include] = STATE(30),
    [sym_preproc_def] = STATE(30),
    [sym_preproc_function_def] = STATE(30),
    [sym_preproc_call] = STATE(30),
    [sym_preproc_if] = STATE(30),
    [sym_preproc_ifdef] = STATE(30),
    [sym_function_definition] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_type_definition] = STATE(30),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(30),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(30),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(30),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(30),
    [sym_template_instantiation] = STATE(30),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(30),
    [sym_operator_cast_declaration] = STATE(30),
    [sym_constructor_or_destructor_definition] = STATE(30),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(30),
    [sym_namespace_alias_definition] = STATE(30),
    [sym_using_declaration] = STATE(30),
    [sym_alias_declaration] = STATE(30),
    [sym_static_assert_declaration] = STATE(30),
    [sym_concept_definition] = STATE(30),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(30),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(661),
    [aux_sym_preproc_include_token1] = ACTIONS(664),
    [aux_sym_preproc_def_token1] = ACTIONS(667),
    [aux_sym_preproc_if_token1] = ACTIONS(670),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(673),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(673),
    [sym_preproc_directive] = ACTIONS(676),
    [anon_sym_LPAREN2] = ACTIONS(419),
    [anon_sym_BANG] = ACTIONS(422),
    [anon_sym_TILDE] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(428),
    [anon_sym_PLUS] = ACTIONS(428),
    [anon_sym_STAR] = ACTIONS(431),
    [anon_sym_AMP_AMP] = ACTIONS(434),
    [anon_sym_AMP] = ACTIONS(437),
    [anon_sym_SEMI] = ACTIONS(679),
    [anon_sym___extension__] = ACTIONS(682),
    [anon_sym_typedef] = ACTIONS(685),
    [anon_sym_in] = ACTIONS(449),
    [anon_sym_out] = ACTIONS(449),
    [anon_sym_inout] = ACTIONS(449),
    [anon_sym_extern] = ACTIONS(688),
    [anon_sym___attribute__] = ACTIONS(455),
    [anon_sym_COLON_COLON] = ACTIONS(458),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(461),
    [anon_sym___declspec] = ACTIONS(464),
    [anon_sym___based] = ACTIONS(467),
    [anon_sym___cdecl] = ACTIONS(470),
    [anon_sym___clrcall] = ACTIONS(470),
    [anon_sym___stdcall] = ACTIONS(470),
    [anon_sym___fastcall] = ACTIONS(470),
    [anon_sym___thiscall] = ACTIONS(470),
    [anon_sym___vectorcall] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(691),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_signed] = ACTIONS(476),
    [anon_sym_unsigned] = ACTIONS(476),
    [anon_sym_long] = ACTIONS(476),
    [anon_sym_short] = ACTIONS(476),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(482),
    [anon_sym_register] = ACTIONS(482),
    [anon_sym_inline] = ACTIONS(696),
    [anon_sym___inline] = ACTIONS(482),
    [anon_sym___inline__] = ACTIONS(482),
    [anon_sym___forceinline] = ACTIONS(482),
    [anon_sym_thread_local] = ACTIONS(482),
    [anon_sym___thread] = ACTIONS(482),
    [anon_sym_const] = ACTIONS(488),
    [anon_sym_constexpr] = ACTIONS(488),
    [anon_sym_volatile] = ACTIONS(488),
    [anon_sym_restrict] = ACTIONS(488),
    [anon_sym___restrict__] = ACTIONS(488),
    [anon_sym__Atomic] = ACTIONS(488),
    [anon_sym__Noreturn] = ACTIONS(488),
    [anon_sym_noreturn] = ACTIONS(488),
    [anon_sym_mutable] = ACTIONS(488),
    [anon_sym_constinit] = ACTIONS(488),
    [anon_sym_consteval] = ACTIONS(488),
    [anon_sym_alignas] = ACTIONS(491),
    [anon_sym__Alignas] = ACTIONS(491),
    [sym_primitive_type] = ACTIONS(494),
    [anon_sym_enum] = ACTIONS(497),
    [anon_sym_class] = ACTIONS(500),
    [anon_sym_struct] = ACTIONS(503),
    [anon_sym_union] = ACTIONS(506),
    [anon_sym_if] = ACTIONS(699),
    [anon_sym_switch] = ACTIONS(702),
    [anon_sym_case] = ACTIONS(705),
    [anon_sym_default] = ACTIONS(708),
    [anon_sym_while] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_return] = ACTIONS(720),
    [anon_sym_break] = ACTIONS(723),
    [anon_sym_continue] = ACTIONS(726),
    [anon_sym_goto] = ACTIONS(729),
    [anon_sym___try] = ACTIONS(732),
    [anon_sym___leave] = ACTIONS(735),
    [anon_sym_not] = ACTIONS(428),
    [anon_sym_compl] = ACTIONS(428),
    [anon_sym_DASH_DASH] = ACTIONS(548),
    [anon_sym_PLUS_PLUS] = ACTIONS(548),
    [anon_sym_sizeof] = ACTIONS(551),
    [anon_sym___alignof__] = ACTIONS(554),
    [anon_sym___alignof] = ACTIONS(554),
    [anon_sym__alignof] = ACTIONS(554),
    [anon_sym_alignof] = ACTIONS(554),
    [anon_sym__Alignof] = ACTIONS(554),
    [anon_sym_offsetof] = ACTIONS(557),
    [anon_sym__Generic] = ACTIONS(560),
    [anon_sym_asm] = ACTIONS(563),
    [anon_sym___asm__] = ACTIONS(563),
    [sym_number_literal] = ACTIONS(566),
    [anon_sym_L_SQUOTE] = ACTIONS(569),
    [anon_sym_u_SQUOTE] = ACTIONS(569),
    [anon_sym_U_SQUOTE] = ACTIONS(569),
    [anon_sym_u8_SQUOTE] = ACTIONS(569),
    [anon_sym_SQUOTE] = ACTIONS(569),
    [anon_sym_L_DQUOTE] = ACTIONS(572),
    [anon_sym_u_DQUOTE] = ACTIONS(572),
    [anon_sym_U_DQUOTE] = ACTIONS(572),
    [anon_sym_u8_DQUOTE] = ACTIONS(572),
    [anon_sym_DQUOTE] = ACTIONS(572),
    [sym_true] = ACTIONS(575),
    [sym_false] = ACTIONS(575),
    [anon_sym_NULL] = ACTIONS(578),
    [anon_sym_nullptr] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(581),
    [anon_sym_let] = ACTIONS(581),
    [anon_sym_This] = ACTIONS(581),
    [anon_sym_decltype] = ACTIONS(584),
    [sym_virtual] = ACTIONS(449),
    [anon_sym_explicit] = ACTIONS(587),
    [anon_sym_typename] = ACTIONS(590),
    [anon_sym_template] = ACTIONS(738),
    [anon_sym_operator] = ACTIONS(596),
    [anon_sym_try] = ACTIONS(741),
    [anon_sym_delete] = ACTIONS(602),
    [anon_sym_throw] = ACTIONS(744),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_using] = ACTIONS(750),
    [anon_sym_static_assert] = ACTIONS(753),
    [anon_sym_concept] = ACTIONS(756),
    [anon_sym_co_return] = ACTIONS(759),
    [anon_sym_co_yield] = ACTIONS(762),
    [anon_sym_R_DQUOTE] = ACTIONS(626),
    [anon_sym_LR_DQUOTE] = ACTIONS(626),
    [anon_sym_uR_DQUOTE] = ACTIONS(626),
    [anon_sym_UR_DQUOTE] = ACTIONS(626),
    [anon_sym_u8R_DQUOTE] = ACTIONS(626),
    [anon_sym_co_await] = ACTIONS(629),
    [anon_sym_new] = ACTIONS(632),
    [anon_sym_requires] = ACTIONS(635),
    [sym_this] = ACTIONS(575),
    [anon_sym_discard] = ACTIONS(765),
    [anon_sym_precise] = ACTIONS(641),
    [anon_sym_shared] = ACTIONS(641),
    [anon_sym_groupshared] = ACTIONS(641),
    [anon_sym_uniform] = ACTIONS(641),
    [anon_sym_row_major] = ACTIONS(641),
    [anon_sym_column_major] = ACTIONS(641),
    [anon_sym_globallycoherent] = ACTIONS(641),
    [anon_sym_centroid] = ACTIONS(641),
    [anon_sym_noperspective] = ACTIONS(641),
    [anon_sym_nointerpolation] = ACTIONS(641),
    [anon_sym_sample] = ACTIONS(641),
    [anon_sym_linear] = ACTIONS(641),
    [anon_sym_snorm] = ACTIONS(641),
    [anon_sym_unorm] = ACTIONS(641),
    [anon_sym_point] = ACTIONS(641),
    [anon_sym_line] = ACTIONS(641),
    [anon_sym_triangleadj] = ACTIONS(641),
    [anon_sym_lineadj] = ACTIONS(641),
    [anon_sym_triangle] = ACTIONS(641),
    [anon_sym_cbuffer] = ACTIONS(768),
    [anon_sym_interface] = ACTIONS(647),
    [anon_sym_extension] = ACTIONS(650),
  },
  [31] = {
    [sym__block_item] = STATE(31),
    [sym_preproc_include] = STATE(31),
    [sym_preproc_def] = STATE(31),
    [sym_preproc_function_def] = STATE(31),
    [sym_preproc_call] = STATE(31),
    [sym_preproc_if] = STATE(31),
    [sym_preproc_ifdef] = STATE(31),
    [sym_function_definition] = STATE(31),
    [sym_declaration] = STATE(31),
    [sym_type_definition] = STATE(31),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(31),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(236),
    [sym_sized_type_specifier] = STATE(766),
    [sym_enum_specifier] = STATE(766),
    [sym_struct_specifier] = STATE(766),
    [sym_union_specifier] = STATE(766),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(31),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(31),
    [sym_placeholder_type_specifier] = STATE(766),
    [sym_decltype] = STATE(760),
    [sym_class_specifier] = STATE(766),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(766),
    [sym_template_declaration] = STATE(31),
    [sym_template_instantiation] = STATE(31),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(31),
    [sym_operator_cast_declaration] = STATE(31),
    [sym_constructor_or_destructor_definition] = STATE(31),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(794),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(31),
    [sym_namespace_alias_definition] = STATE(31),
    [sym_using_declaration] = STATE(31),
    [sym_alias_declaration] = STATE(31),
    [sym_static_assert_declaration] = STATE(31),
    [sym_concept_definition] = STATE(31),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6541),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(789),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(766),
    [sym_extension_specifier] = STATE(766),
    [sym_associatedtype_specifier] = STATE(766),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_declaration_list_repeat1] = STATE(31),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(644),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(771),
    [aux_sym_preproc_include_token1] = ACTIONS(774),
    [aux_sym_preproc_def_token1] = ACTIONS(777),
    [aux_sym_preproc_if_token1] = ACTIONS(780),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(783),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(783),
    [sym_preproc_directive] = ACTIONS(786),
    [anon_sym_LPAREN2] = ACTIONS(789),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(795),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_STAR] = ACTIONS(801),
    [anon_sym_AMP_AMP] = ACTIONS(804),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_SEMI] = ACTIONS(810),
    [anon_sym___extension__] = ACTIONS(813),
    [anon_sym_typedef] = ACTIONS(816),
    [anon_sym_in] = ACTIONS(819),
    [anon_sym_out] = ACTIONS(819),
    [anon_sym_inout] = ACTIONS(819),
    [anon_sym_extern] = ACTIONS(822),
    [anon_sym___attribute__] = ACTIONS(825),
    [anon_sym_COLON_COLON] = ACTIONS(828),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(831),
    [anon_sym___declspec] = ACTIONS(834),
    [anon_sym___based] = ACTIONS(837),
    [anon_sym___cdecl] = ACTIONS(840),
    [anon_sym___clrcall] = ACTIONS(840),
    [anon_sym___stdcall] = ACTIONS(840),
    [anon_sym___fastcall] = ACTIONS(840),
    [anon_sym___thiscall] = ACTIONS(840),
    [anon_sym___vectorcall] = ACTIONS(840),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_RBRACE] = ACTIONS(846),
    [anon_sym_signed] = ACTIONS(848),
    [anon_sym_unsigned] = ACTIONS(848),
    [anon_sym_long] = ACTIONS(848),
    [anon_sym_short] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(851),
    [anon_sym_static] = ACTIONS(854),
    [anon_sym_register] = ACTIONS(854),
    [anon_sym_inline] = ACTIONS(857),
    [anon_sym___inline] = ACTIONS(854),
    [anon_sym___inline__] = ACTIONS(854),
    [anon_sym___forceinline] = ACTIONS(854),
    [anon_sym_thread_local] = ACTIONS(854),
    [anon_sym___thread] = ACTIONS(854),
    [anon_sym_const] = ACTIONS(860),
    [anon_sym_constexpr] = ACTIONS(860),
    [anon_sym_volatile] = ACTIONS(860),
    [anon_sym_restrict] = ACTIONS(860),
    [anon_sym___restrict__] = ACTIONS(860),
    [anon_sym__Atomic] = ACTIONS(860),
    [anon_sym__Noreturn] = ACTIONS(860),
    [anon_sym_noreturn] = ACTIONS(860),
    [anon_sym_mutable] = ACTIONS(860),
    [anon_sym_constinit] = ACTIONS(860),
    [anon_sym_consteval] = ACTIONS(860),
    [anon_sym_alignas] = ACTIONS(863),
    [anon_sym__Alignas] = ACTIONS(863),
    [sym_primitive_type] = ACTIONS(866),
    [anon_sym_enum] = ACTIONS(869),
    [anon_sym_class] = ACTIONS(872),
    [anon_sym_struct] = ACTIONS(875),
    [anon_sym_union] = ACTIONS(878),
    [anon_sym_if] = ACTIONS(881),
    [anon_sym_switch] = ACTIONS(884),
    [anon_sym_case] = ACTIONS(887),
    [anon_sym_default] = ACTIONS(890),
    [anon_sym_while] = ACTIONS(893),
    [anon_sym_do] = ACTIONS(896),
    [anon_sym_for] = ACTIONS(899),
    [anon_sym_return] = ACTIONS(902),
    [anon_sym_break] = ACTIONS(905),
    [anon_sym_continue] = ACTIONS(908),
    [anon_sym_goto] = ACTIONS(911),
    [anon_sym___try] = ACTIONS(914),
    [anon_sym___leave] = ACTIONS(917),
    [anon_sym_not] = ACTIONS(798),
    [anon_sym_compl] = ACTIONS(798),
    [anon_sym_DASH_DASH] = ACTIONS(920),
    [anon_sym_PLUS_PLUS] = ACTIONS(920),
    [anon_sym_sizeof] = ACTIONS(923),
    [anon_sym___alignof__] = ACTIONS(926),
    [anon_sym___alignof] = ACTIONS(926),
    [anon_sym__alignof] = ACTIONS(926),
    [anon_sym_alignof] = ACTIONS(926),
    [anon_sym__Alignof] = ACTIONS(926),
    [anon_sym_offsetof] = ACTIONS(929),
    [anon_sym__Generic] = ACTIONS(932),
    [anon_sym_asm] = ACTIONS(935),
    [anon_sym___asm__] = ACTIONS(935),
    [sym_number_literal] = ACTIONS(938),
    [anon_sym_L_SQUOTE] = ACTIONS(941),
    [anon_sym_u_SQUOTE] = ACTIONS(941),
    [anon_sym_U_SQUOTE] = ACTIONS(941),
    [anon_sym_u8_SQUOTE] = ACTIONS(941),
    [anon_sym_SQUOTE] = ACTIONS(941),
    [anon_sym_L_DQUOTE] = ACTIONS(944),
    [anon_sym_u_DQUOTE] = ACTIONS(944),
    [anon_sym_U_DQUOTE] = ACTIONS(944),
    [anon_sym_u8_DQUOTE] = ACTIONS(944),
    [anon_sym_DQUOTE] = ACTIONS(944),
    [sym_true] = ACTIONS(947),
    [sym_false] = ACTIONS(947),
    [anon_sym_NULL] = ACTIONS(950),
    [anon_sym_nullptr] = ACTIONS(950),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(953),
    [anon_sym_let] = ACTIONS(953),
    [anon_sym_This] = ACTIONS(953),
    [anon_sym_decltype] = ACTIONS(956),
    [sym_virtual] = ACTIONS(819),
    [anon_sym_explicit] = ACTIONS(959),
    [anon_sym_typename] = ACTIONS(962),
    [anon_sym_template] = ACTIONS(965),
    [anon_sym_operator] = ACTIONS(968),
    [anon_sym_try] = ACTIONS(971),
    [anon_sym_delete] = ACTIONS(974),
    [anon_sym_throw] = ACTIONS(977),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_static_assert] = ACTIONS(986),
    [anon_sym_concept] = ACTIONS(989),
    [anon_sym_co_return] = ACTIONS(992),
    [anon_sym_co_yield] = ACTIONS(995),
    [anon_sym_R_DQUOTE] = ACTIONS(998),
    [anon_sym_LR_DQUOTE] = ACTIONS(998),
    [anon_sym_uR_DQUOTE] = ACTIONS(998),
    [anon_sym_UR_DQUOTE] = ACTIONS(998),
    [anon_sym_u8R_DQUOTE] = ACTIONS(998),
    [anon_sym_co_await] = ACTIONS(1001),
    [anon_sym_new] = ACTIONS(1004),
    [anon_sym_requires] = ACTIONS(1007),
    [sym_this] = ACTIONS(947),
    [anon_sym_discard] = ACTIONS(1010),
    [anon_sym_precise] = ACTIONS(1013),
    [anon_sym_shared] = ACTIONS(1013),
    [anon_sym_groupshared] = ACTIONS(1013),
    [anon_sym_uniform] = ACTIONS(1013),
    [anon_sym_row_major] = ACTIONS(1013),
    [anon_sym_column_major] = ACTIONS(1013),
    [anon_sym_globallycoherent] = ACTIONS(1013),
    [anon_sym_centroid] = ACTIONS(1013),
    [anon_sym_noperspective] = ACTIONS(1013),
    [anon_sym_nointerpolation] = ACTIONS(1013),
    [anon_sym_sample] = ACTIONS(1013),
    [anon_sym_linear] = ACTIONS(1013),
    [anon_sym_snorm] = ACTIONS(1013),
    [anon_sym_unorm] = ACTIONS(1013),
    [anon_sym_point] = ACTIONS(1013),
    [anon_sym_line] = ACTIONS(1013),
    [anon_sym_triangleadj] = ACTIONS(1013),
    [anon_sym_lineadj] = ACTIONS(1013),
    [anon_sym_triangle] = ACTIONS(1013),
    [anon_sym_cbuffer] = ACTIONS(1016),
    [anon_sym_interface] = ACTIONS(1019),
    [anon_sym_extension] = ACTIONS(1022),
  },
  [32] = {
    [sym__block_item] = STATE(37),
    [sym_preproc_include] = STATE(37),
    [sym_preproc_def] = STATE(37),
    [sym_preproc_function_def] = STATE(37),
    [sym_preproc_call] = STATE(37),
    [sym_preproc_if] = STATE(37),
    [sym_preproc_ifdef] = STATE(37),
    [sym_function_definition] = STATE(37),
    [sym_declaration] = STATE(37),
    [sym_type_definition] = STATE(37),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(37),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(37),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(37),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(37),
    [sym_template_instantiation] = STATE(37),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(37),
    [sym_operator_cast_declaration] = STATE(37),
    [sym_constructor_or_destructor_definition] = STATE(37),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(37),
    [sym_namespace_alias_definition] = STATE(37),
    [sym_using_declaration] = STATE(37),
    [sym_alias_declaration] = STATE(37),
    [sym_static_assert_declaration] = STATE(37),
    [sym_concept_definition] = STATE(37),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(37),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1025),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [33] = {
    [sym__block_item] = STATE(34),
    [sym_preproc_include] = STATE(34),
    [sym_preproc_def] = STATE(34),
    [sym_preproc_function_def] = STATE(34),
    [sym_preproc_call] = STATE(34),
    [sym_preproc_if] = STATE(34),
    [sym_preproc_ifdef] = STATE(34),
    [sym_function_definition] = STATE(34),
    [sym_declaration] = STATE(34),
    [sym_type_definition] = STATE(34),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(34),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(34),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(34),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(34),
    [sym_template_instantiation] = STATE(34),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(34),
    [sym_operator_cast_declaration] = STATE(34),
    [sym_constructor_or_destructor_definition] = STATE(34),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(34),
    [sym_namespace_alias_definition] = STATE(34),
    [sym_using_declaration] = STATE(34),
    [sym_alias_declaration] = STATE(34),
    [sym_static_assert_declaration] = STATE(34),
    [sym_concept_definition] = STATE(34),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(34),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1027),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [34] = {
    [sym__block_item] = STATE(30),
    [sym_preproc_include] = STATE(30),
    [sym_preproc_def] = STATE(30),
    [sym_preproc_function_def] = STATE(30),
    [sym_preproc_call] = STATE(30),
    [sym_preproc_if] = STATE(30),
    [sym_preproc_ifdef] = STATE(30),
    [sym_function_definition] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_type_definition] = STATE(30),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(30),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(30),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(30),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(30),
    [sym_template_instantiation] = STATE(30),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(30),
    [sym_operator_cast_declaration] = STATE(30),
    [sym_constructor_or_destructor_definition] = STATE(30),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(30),
    [sym_namespace_alias_definition] = STATE(30),
    [sym_using_declaration] = STATE(30),
    [sym_alias_declaration] = STATE(30),
    [sym_static_assert_declaration] = STATE(30),
    [sym_concept_definition] = STATE(30),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(30),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1029),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [35] = {
    [sym__block_item] = STATE(30),
    [sym_preproc_include] = STATE(30),
    [sym_preproc_def] = STATE(30),
    [sym_preproc_function_def] = STATE(30),
    [sym_preproc_call] = STATE(30),
    [sym_preproc_if] = STATE(30),
    [sym_preproc_ifdef] = STATE(30),
    [sym_function_definition] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_type_definition] = STATE(30),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(30),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(30),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(30),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(30),
    [sym_template_instantiation] = STATE(30),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(30),
    [sym_operator_cast_declaration] = STATE(30),
    [sym_constructor_or_destructor_definition] = STATE(30),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(30),
    [sym_namespace_alias_definition] = STATE(30),
    [sym_using_declaration] = STATE(30),
    [sym_alias_declaration] = STATE(30),
    [sym_static_assert_declaration] = STATE(30),
    [sym_concept_definition] = STATE(30),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(30),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1031),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [36] = {
    [sym__block_item] = STATE(30),
    [sym_preproc_include] = STATE(30),
    [sym_preproc_def] = STATE(30),
    [sym_preproc_function_def] = STATE(30),
    [sym_preproc_call] = STATE(30),
    [sym_preproc_if] = STATE(30),
    [sym_preproc_ifdef] = STATE(30),
    [sym_function_definition] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_type_definition] = STATE(30),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(30),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(30),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(30),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(30),
    [sym_template_instantiation] = STATE(30),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(30),
    [sym_operator_cast_declaration] = STATE(30),
    [sym_constructor_or_destructor_definition] = STATE(30),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(30),
    [sym_namespace_alias_definition] = STATE(30),
    [sym_using_declaration] = STATE(30),
    [sym_alias_declaration] = STATE(30),
    [sym_static_assert_declaration] = STATE(30),
    [sym_concept_definition] = STATE(30),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(30),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1033),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [37] = {
    [sym__block_item] = STATE(30),
    [sym_preproc_include] = STATE(30),
    [sym_preproc_def] = STATE(30),
    [sym_preproc_function_def] = STATE(30),
    [sym_preproc_call] = STATE(30),
    [sym_preproc_if] = STATE(30),
    [sym_preproc_ifdef] = STATE(30),
    [sym_function_definition] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_type_definition] = STATE(30),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(30),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(30),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(30),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(30),
    [sym_template_instantiation] = STATE(30),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(30),
    [sym_operator_cast_declaration] = STATE(30),
    [sym_constructor_or_destructor_definition] = STATE(30),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(30),
    [sym_namespace_alias_definition] = STATE(30),
    [sym_using_declaration] = STATE(30),
    [sym_alias_declaration] = STATE(30),
    [sym_static_assert_declaration] = STATE(30),
    [sym_concept_definition] = STATE(30),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(30),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1035),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [38] = {
    [sym__block_item] = STATE(66),
    [sym_preproc_include] = STATE(66),
    [sym_preproc_def] = STATE(66),
    [sym_preproc_function_def] = STATE(66),
    [sym_preproc_call] = STATE(66),
    [sym_preproc_if] = STATE(66),
    [sym_preproc_ifdef] = STATE(66),
    [sym_function_definition] = STATE(66),
    [sym_declaration] = STATE(66),
    [sym_type_definition] = STATE(66),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(66),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(236),
    [sym_sized_type_specifier] = STATE(766),
    [sym_enum_specifier] = STATE(766),
    [sym_struct_specifier] = STATE(766),
    [sym_union_specifier] = STATE(766),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(66),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(66),
    [sym_placeholder_type_specifier] = STATE(766),
    [sym_decltype] = STATE(760),
    [sym_class_specifier] = STATE(766),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(766),
    [sym_template_declaration] = STATE(66),
    [sym_template_instantiation] = STATE(66),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(66),
    [sym_operator_cast_declaration] = STATE(66),
    [sym_constructor_or_destructor_definition] = STATE(66),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(794),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(66),
    [sym_namespace_alias_definition] = STATE(66),
    [sym_using_declaration] = STATE(66),
    [sym_alias_declaration] = STATE(66),
    [sym_static_assert_declaration] = STATE(66),
    [sym_concept_definition] = STATE(66),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6541),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(789),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(766),
    [sym_extension_specifier] = STATE(766),
    [sym_associatedtype_specifier] = STATE(766),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_declaration_list_repeat1] = STATE(66),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(644),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(1037),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1039),
    [anon_sym_signed] = ACTIONS(1041),
    [anon_sym_unsigned] = ACTIONS(1041),
    [anon_sym_long] = ACTIONS(1041),
    [anon_sym_short] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1043),
    [anon_sym_enum] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1047),
    [anon_sym_struct] = ACTIONS(1049),
    [anon_sym_union] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1053),
    [anon_sym_let] = ACTIONS(1053),
    [anon_sym_This] = ACTIONS(1053),
    [anon_sym_decltype] = ACTIONS(1055),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1057),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(1059),
    [anon_sym_extension] = ACTIONS(1061),
  },
  [39] = {
    [sym__block_item] = STATE(39),
    [sym_preproc_include] = STATE(39),
    [sym_preproc_def] = STATE(39),
    [sym_preproc_function_def] = STATE(39),
    [sym_preproc_call] = STATE(39),
    [sym_preproc_if] = STATE(39),
    [sym_preproc_ifdef] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_declaration] = STATE(39),
    [sym_type_definition] = STATE(39),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5738),
    [sym_linkage_specification] = STATE(39),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1856),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7569),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(787),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2683),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(851),
    [sym_statement] = STATE(39),
    [sym_labeled_statement] = STATE(787),
    [sym_expression_statement] = STATE(787),
    [sym_if_statement] = STATE(787),
    [sym_switch_statement] = STATE(787),
    [sym_case_statement] = STATE(787),
    [sym_while_statement] = STATE(787),
    [sym_do_statement] = STATE(787),
    [sym_for_statement] = STATE(787),
    [sym_return_statement] = STATE(787),
    [sym_break_statement] = STATE(787),
    [sym_continue_statement] = STATE(787),
    [sym_goto_statement] = STATE(787),
    [sym_seh_try_statement] = STATE(787),
    [sym_seh_leave_statement] = STATE(787),
    [sym_expression] = STATE(5465),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10896),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(39),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2584),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(39),
    [sym_template_instantiation] = STATE(39),
    [sym_operator_cast] = STATE(8413),
    [sym__constructor_specifiers] = STATE(2584),
    [sym_operator_cast_definition] = STATE(39),
    [sym_operator_cast_declaration] = STATE(39),
    [sym_constructor_or_destructor_definition] = STATE(39),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(39),
    [sym_namespace_alias_definition] = STATE(39),
    [sym_using_declaration] = STATE(39),
    [sym_alias_declaration] = STATE(39),
    [sym_static_assert_declaration] = STATE(39),
    [sym_concept_definition] = STATE(39),
    [sym_for_range_loop] = STATE(787),
    [sym_co_return_statement] = STATE(787),
    [sym_co_yield_statement] = STATE(787),
    [sym_throw_statement] = STATE(787),
    [sym_try_statement] = STATE(787),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8413),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(787),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(787),
    [sym_hlsl_attribute] = STATE(1483),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(39),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1148),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2584),
    [sym_identifier] = ACTIONS(1063),
    [aux_sym_preproc_include_token1] = ACTIONS(1066),
    [aux_sym_preproc_def_token1] = ACTIONS(1069),
    [aux_sym_preproc_if_token1] = ACTIONS(1072),
    [aux_sym_preproc_if_token2] = ACTIONS(411),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1075),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1075),
    [sym_preproc_directive] = ACTIONS(1078),
    [anon_sym_LPAREN2] = ACTIONS(419),
    [anon_sym_BANG] = ACTIONS(422),
    [anon_sym_TILDE] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(428),
    [anon_sym_PLUS] = ACTIONS(428),
    [anon_sym_STAR] = ACTIONS(431),
    [anon_sym_AMP_AMP] = ACTIONS(434),
    [anon_sym_AMP] = ACTIONS(437),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym___extension__] = ACTIONS(1084),
    [anon_sym_typedef] = ACTIONS(1087),
    [anon_sym_in] = ACTIONS(449),
    [anon_sym_out] = ACTIONS(449),
    [anon_sym_inout] = ACTIONS(449),
    [anon_sym_extern] = ACTIONS(1090),
    [anon_sym___attribute__] = ACTIONS(455),
    [anon_sym_COLON_COLON] = ACTIONS(458),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(461),
    [anon_sym___declspec] = ACTIONS(464),
    [anon_sym___based] = ACTIONS(467),
    [anon_sym___cdecl] = ACTIONS(470),
    [anon_sym___clrcall] = ACTIONS(470),
    [anon_sym___stdcall] = ACTIONS(470),
    [anon_sym___fastcall] = ACTIONS(470),
    [anon_sym___thiscall] = ACTIONS(470),
    [anon_sym___vectorcall] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_signed] = ACTIONS(476),
    [anon_sym_unsigned] = ACTIONS(476),
    [anon_sym_long] = ACTIONS(476),
    [anon_sym_short] = ACTIONS(476),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(482),
    [anon_sym_register] = ACTIONS(482),
    [anon_sym_inline] = ACTIONS(1096),
    [anon_sym___inline] = ACTIONS(482),
    [anon_sym___inline__] = ACTIONS(482),
    [anon_sym___forceinline] = ACTIONS(482),
    [anon_sym_thread_local] = ACTIONS(482),
    [anon_sym___thread] = ACTIONS(482),
    [anon_sym_const] = ACTIONS(488),
    [anon_sym_constexpr] = ACTIONS(488),
    [anon_sym_volatile] = ACTIONS(488),
    [anon_sym_restrict] = ACTIONS(488),
    [anon_sym___restrict__] = ACTIONS(488),
    [anon_sym__Atomic] = ACTIONS(488),
    [anon_sym__Noreturn] = ACTIONS(488),
    [anon_sym_noreturn] = ACTIONS(488),
    [anon_sym_mutable] = ACTIONS(488),
    [anon_sym_constinit] = ACTIONS(488),
    [anon_sym_consteval] = ACTIONS(488),
    [anon_sym_alignas] = ACTIONS(491),
    [anon_sym__Alignas] = ACTIONS(491),
    [sym_primitive_type] = ACTIONS(494),
    [anon_sym_enum] = ACTIONS(497),
    [anon_sym_class] = ACTIONS(500),
    [anon_sym_struct] = ACTIONS(503),
    [anon_sym_union] = ACTIONS(506),
    [anon_sym_if] = ACTIONS(1099),
    [anon_sym_switch] = ACTIONS(1102),
    [anon_sym_case] = ACTIONS(1105),
    [anon_sym_default] = ACTIONS(1108),
    [anon_sym_while] = ACTIONS(1111),
    [anon_sym_do] = ACTIONS(1114),
    [anon_sym_for] = ACTIONS(1117),
    [anon_sym_return] = ACTIONS(1120),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_continue] = ACTIONS(1126),
    [anon_sym_goto] = ACTIONS(1129),
    [anon_sym___try] = ACTIONS(1132),
    [anon_sym___leave] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(428),
    [anon_sym_compl] = ACTIONS(428),
    [anon_sym_DASH_DASH] = ACTIONS(548),
    [anon_sym_PLUS_PLUS] = ACTIONS(548),
    [anon_sym_sizeof] = ACTIONS(551),
    [anon_sym___alignof__] = ACTIONS(554),
    [anon_sym___alignof] = ACTIONS(554),
    [anon_sym__alignof] = ACTIONS(554),
    [anon_sym_alignof] = ACTIONS(554),
    [anon_sym__Alignof] = ACTIONS(554),
    [anon_sym_offsetof] = ACTIONS(557),
    [anon_sym__Generic] = ACTIONS(560),
    [anon_sym_asm] = ACTIONS(563),
    [anon_sym___asm__] = ACTIONS(563),
    [sym_number_literal] = ACTIONS(566),
    [anon_sym_L_SQUOTE] = ACTIONS(569),
    [anon_sym_u_SQUOTE] = ACTIONS(569),
    [anon_sym_U_SQUOTE] = ACTIONS(569),
    [anon_sym_u8_SQUOTE] = ACTIONS(569),
    [anon_sym_SQUOTE] = ACTIONS(569),
    [anon_sym_L_DQUOTE] = ACTIONS(572),
    [anon_sym_u_DQUOTE] = ACTIONS(572),
    [anon_sym_U_DQUOTE] = ACTIONS(572),
    [anon_sym_u8_DQUOTE] = ACTIONS(572),
    [anon_sym_DQUOTE] = ACTIONS(572),
    [sym_true] = ACTIONS(575),
    [sym_false] = ACTIONS(575),
    [anon_sym_NULL] = ACTIONS(578),
    [anon_sym_nullptr] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(581),
    [anon_sym_let] = ACTIONS(581),
    [anon_sym_This] = ACTIONS(581),
    [anon_sym_decltype] = ACTIONS(584),
    [sym_virtual] = ACTIONS(449),
    [anon_sym_explicit] = ACTIONS(587),
    [anon_sym_typename] = ACTIONS(590),
    [anon_sym_template] = ACTIONS(1138),
    [anon_sym_operator] = ACTIONS(596),
    [anon_sym_try] = ACTIONS(1141),
    [anon_sym_delete] = ACTIONS(602),
    [anon_sym_throw] = ACTIONS(1144),
    [anon_sym_namespace] = ACTIONS(1147),
    [anon_sym_using] = ACTIONS(1150),
    [anon_sym_static_assert] = ACTIONS(1153),
    [anon_sym_concept] = ACTIONS(1156),
    [anon_sym_co_return] = ACTIONS(1159),
    [anon_sym_co_yield] = ACTIONS(1162),
    [anon_sym_R_DQUOTE] = ACTIONS(626),
    [anon_sym_LR_DQUOTE] = ACTIONS(626),
    [anon_sym_uR_DQUOTE] = ACTIONS(626),
    [anon_sym_UR_DQUOTE] = ACTIONS(626),
    [anon_sym_u8R_DQUOTE] = ACTIONS(626),
    [anon_sym_co_await] = ACTIONS(629),
    [anon_sym_new] = ACTIONS(632),
    [anon_sym_requires] = ACTIONS(635),
    [sym_this] = ACTIONS(575),
    [anon_sym_discard] = ACTIONS(1165),
    [anon_sym_precise] = ACTIONS(641),
    [anon_sym_shared] = ACTIONS(641),
    [anon_sym_groupshared] = ACTIONS(641),
    [anon_sym_uniform] = ACTIONS(641),
    [anon_sym_row_major] = ACTIONS(641),
    [anon_sym_column_major] = ACTIONS(641),
    [anon_sym_globallycoherent] = ACTIONS(641),
    [anon_sym_centroid] = ACTIONS(641),
    [anon_sym_noperspective] = ACTIONS(641),
    [anon_sym_nointerpolation] = ACTIONS(641),
    [anon_sym_sample] = ACTIONS(641),
    [anon_sym_linear] = ACTIONS(641),
    [anon_sym_snorm] = ACTIONS(641),
    [anon_sym_unorm] = ACTIONS(641),
    [anon_sym_point] = ACTIONS(641),
    [anon_sym_line] = ACTIONS(641),
    [anon_sym_triangleadj] = ACTIONS(641),
    [anon_sym_lineadj] = ACTIONS(641),
    [anon_sym_triangle] = ACTIONS(641),
    [anon_sym_cbuffer] = ACTIONS(1168),
    [anon_sym_interface] = ACTIONS(647),
    [anon_sym_extension] = ACTIONS(650),
  },
  [40] = {
    [sym__block_item] = STATE(30),
    [sym_preproc_include] = STATE(30),
    [sym_preproc_def] = STATE(30),
    [sym_preproc_function_def] = STATE(30),
    [sym_preproc_call] = STATE(30),
    [sym_preproc_if] = STATE(30),
    [sym_preproc_ifdef] = STATE(30),
    [sym_function_definition] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_type_definition] = STATE(30),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(30),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(30),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(30),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(30),
    [sym_template_instantiation] = STATE(30),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(30),
    [sym_operator_cast_declaration] = STATE(30),
    [sym_constructor_or_destructor_definition] = STATE(30),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(30),
    [sym_namespace_alias_definition] = STATE(30),
    [sym_using_declaration] = STATE(30),
    [sym_alias_declaration] = STATE(30),
    [sym_static_assert_declaration] = STATE(30),
    [sym_concept_definition] = STATE(30),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(30),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1171),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [41] = {
    [sym__block_item] = STATE(30),
    [sym_preproc_include] = STATE(30),
    [sym_preproc_def] = STATE(30),
    [sym_preproc_function_def] = STATE(30),
    [sym_preproc_call] = STATE(30),
    [sym_preproc_if] = STATE(30),
    [sym_preproc_ifdef] = STATE(30),
    [sym_function_definition] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_type_definition] = STATE(30),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(30),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(30),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(30),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(30),
    [sym_template_instantiation] = STATE(30),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(30),
    [sym_operator_cast_declaration] = STATE(30),
    [sym_constructor_or_destructor_definition] = STATE(30),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(30),
    [sym_namespace_alias_definition] = STATE(30),
    [sym_using_declaration] = STATE(30),
    [sym_alias_declaration] = STATE(30),
    [sym_static_assert_declaration] = STATE(30),
    [sym_concept_definition] = STATE(30),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(30),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1173),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [42] = {
    [sym__block_item] = STATE(31),
    [sym_preproc_include] = STATE(31),
    [sym_preproc_def] = STATE(31),
    [sym_preproc_function_def] = STATE(31),
    [sym_preproc_call] = STATE(31),
    [sym_preproc_if] = STATE(31),
    [sym_preproc_ifdef] = STATE(31),
    [sym_function_definition] = STATE(31),
    [sym_declaration] = STATE(31),
    [sym_type_definition] = STATE(31),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(31),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(236),
    [sym_sized_type_specifier] = STATE(766),
    [sym_enum_specifier] = STATE(766),
    [sym_struct_specifier] = STATE(766),
    [sym_union_specifier] = STATE(766),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(31),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(31),
    [sym_placeholder_type_specifier] = STATE(766),
    [sym_decltype] = STATE(760),
    [sym_class_specifier] = STATE(766),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(766),
    [sym_template_declaration] = STATE(31),
    [sym_template_instantiation] = STATE(31),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(31),
    [sym_operator_cast_declaration] = STATE(31),
    [sym_constructor_or_destructor_definition] = STATE(31),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(794),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(31),
    [sym_namespace_alias_definition] = STATE(31),
    [sym_using_declaration] = STATE(31),
    [sym_alias_declaration] = STATE(31),
    [sym_static_assert_declaration] = STATE(31),
    [sym_concept_definition] = STATE(31),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6541),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(789),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(766),
    [sym_extension_specifier] = STATE(766),
    [sym_associatedtype_specifier] = STATE(766),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_declaration_list_repeat1] = STATE(31),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(644),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(1037),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1175),
    [anon_sym_signed] = ACTIONS(1041),
    [anon_sym_unsigned] = ACTIONS(1041),
    [anon_sym_long] = ACTIONS(1041),
    [anon_sym_short] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1043),
    [anon_sym_enum] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1047),
    [anon_sym_struct] = ACTIONS(1049),
    [anon_sym_union] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1053),
    [anon_sym_let] = ACTIONS(1053),
    [anon_sym_This] = ACTIONS(1053),
    [anon_sym_decltype] = ACTIONS(1055),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1057),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(1059),
    [anon_sym_extension] = ACTIONS(1061),
  },
  [43] = {
    [sym__block_item] = STATE(30),
    [sym_preproc_include] = STATE(30),
    [sym_preproc_def] = STATE(30),
    [sym_preproc_function_def] = STATE(30),
    [sym_preproc_call] = STATE(30),
    [sym_preproc_if] = STATE(30),
    [sym_preproc_ifdef] = STATE(30),
    [sym_function_definition] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_type_definition] = STATE(30),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(30),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(30),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(30),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(30),
    [sym_template_instantiation] = STATE(30),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(30),
    [sym_operator_cast_declaration] = STATE(30),
    [sym_constructor_or_destructor_definition] = STATE(30),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(30),
    [sym_namespace_alias_definition] = STATE(30),
    [sym_using_declaration] = STATE(30),
    [sym_alias_declaration] = STATE(30),
    [sym_static_assert_declaration] = STATE(30),
    [sym_concept_definition] = STATE(30),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(30),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1177),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [44] = {
    [sym__block_item] = STATE(46),
    [sym_preproc_include] = STATE(46),
    [sym_preproc_def] = STATE(46),
    [sym_preproc_function_def] = STATE(46),
    [sym_preproc_call] = STATE(46),
    [sym_preproc_if] = STATE(46),
    [sym_preproc_ifdef] = STATE(46),
    [sym_function_definition] = STATE(46),
    [sym_declaration] = STATE(46),
    [sym_type_definition] = STATE(46),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(46),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(46),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(46),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(46),
    [sym_template_instantiation] = STATE(46),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(46),
    [sym_operator_cast_declaration] = STATE(46),
    [sym_constructor_or_destructor_definition] = STATE(46),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(46),
    [sym_namespace_alias_definition] = STATE(46),
    [sym_using_declaration] = STATE(46),
    [sym_alias_declaration] = STATE(46),
    [sym_static_assert_declaration] = STATE(46),
    [sym_concept_definition] = STATE(46),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(46),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1179),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [45] = {
    [sym__block_item] = STATE(54),
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(54),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1181),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [46] = {
    [sym__block_item] = STATE(30),
    [sym_preproc_include] = STATE(30),
    [sym_preproc_def] = STATE(30),
    [sym_preproc_function_def] = STATE(30),
    [sym_preproc_call] = STATE(30),
    [sym_preproc_if] = STATE(30),
    [sym_preproc_ifdef] = STATE(30),
    [sym_function_definition] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_type_definition] = STATE(30),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(30),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(30),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(30),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(30),
    [sym_template_instantiation] = STATE(30),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(30),
    [sym_operator_cast_declaration] = STATE(30),
    [sym_constructor_or_destructor_definition] = STATE(30),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(30),
    [sym_namespace_alias_definition] = STATE(30),
    [sym_using_declaration] = STATE(30),
    [sym_alias_declaration] = STATE(30),
    [sym_static_assert_declaration] = STATE(30),
    [sym_concept_definition] = STATE(30),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(30),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1183),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [47] = {
    [sym__block_item] = STATE(49),
    [sym_preproc_include] = STATE(49),
    [sym_preproc_def] = STATE(49),
    [sym_preproc_function_def] = STATE(49),
    [sym_preproc_call] = STATE(49),
    [sym_preproc_if] = STATE(49),
    [sym_preproc_ifdef] = STATE(49),
    [sym_function_definition] = STATE(49),
    [sym_declaration] = STATE(49),
    [sym_type_definition] = STATE(49),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(49),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(49),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(49),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(49),
    [sym_template_instantiation] = STATE(49),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(49),
    [sym_operator_cast_declaration] = STATE(49),
    [sym_constructor_or_destructor_definition] = STATE(49),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(49),
    [sym_namespace_alias_definition] = STATE(49),
    [sym_using_declaration] = STATE(49),
    [sym_alias_declaration] = STATE(49),
    [sym_static_assert_declaration] = STATE(49),
    [sym_concept_definition] = STATE(49),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(49),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1185),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [48] = {
    [sym__block_item] = STATE(28),
    [sym_preproc_include] = STATE(28),
    [sym_preproc_def] = STATE(28),
    [sym_preproc_function_def] = STATE(28),
    [sym_preproc_call] = STATE(28),
    [sym_preproc_if] = STATE(28),
    [sym_preproc_ifdef] = STATE(28),
    [sym_function_definition] = STATE(28),
    [sym_declaration] = STATE(28),
    [sym_type_definition] = STATE(28),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(28),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(28),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(28),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(28),
    [sym_template_instantiation] = STATE(28),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(28),
    [sym_operator_cast_declaration] = STATE(28),
    [sym_constructor_or_destructor_definition] = STATE(28),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(28),
    [sym_namespace_alias_definition] = STATE(28),
    [sym_using_declaration] = STATE(28),
    [sym_alias_declaration] = STATE(28),
    [sym_static_assert_declaration] = STATE(28),
    [sym_concept_definition] = STATE(28),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(28),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1187),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [49] = {
    [sym__block_item] = STATE(30),
    [sym_preproc_include] = STATE(30),
    [sym_preproc_def] = STATE(30),
    [sym_preproc_function_def] = STATE(30),
    [sym_preproc_call] = STATE(30),
    [sym_preproc_if] = STATE(30),
    [sym_preproc_ifdef] = STATE(30),
    [sym_function_definition] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_type_definition] = STATE(30),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(30),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(30),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(30),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(30),
    [sym_template_instantiation] = STATE(30),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(30),
    [sym_operator_cast_declaration] = STATE(30),
    [sym_constructor_or_destructor_definition] = STATE(30),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(30),
    [sym_namespace_alias_definition] = STATE(30),
    [sym_using_declaration] = STATE(30),
    [sym_alias_declaration] = STATE(30),
    [sym_static_assert_declaration] = STATE(30),
    [sym_concept_definition] = STATE(30),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(30),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1189),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [50] = {
    [sym__block_item] = STATE(61),
    [sym_preproc_include] = STATE(61),
    [sym_preproc_def] = STATE(61),
    [sym_preproc_function_def] = STATE(61),
    [sym_preproc_call] = STATE(61),
    [sym_preproc_if] = STATE(61),
    [sym_preproc_ifdef] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_declaration] = STATE(61),
    [sym_type_definition] = STATE(61),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(61),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(236),
    [sym_sized_type_specifier] = STATE(766),
    [sym_enum_specifier] = STATE(766),
    [sym_struct_specifier] = STATE(766),
    [sym_union_specifier] = STATE(766),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(61),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(61),
    [sym_placeholder_type_specifier] = STATE(766),
    [sym_decltype] = STATE(760),
    [sym_class_specifier] = STATE(766),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(766),
    [sym_template_declaration] = STATE(61),
    [sym_template_instantiation] = STATE(61),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(61),
    [sym_operator_cast_declaration] = STATE(61),
    [sym_constructor_or_destructor_definition] = STATE(61),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(794),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(61),
    [sym_namespace_alias_definition] = STATE(61),
    [sym_using_declaration] = STATE(61),
    [sym_alias_declaration] = STATE(61),
    [sym_static_assert_declaration] = STATE(61),
    [sym_concept_definition] = STATE(61),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6541),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(789),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(766),
    [sym_extension_specifier] = STATE(766),
    [sym_associatedtype_specifier] = STATE(766),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_declaration_list_repeat1] = STATE(61),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(644),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(1037),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1191),
    [anon_sym_signed] = ACTIONS(1041),
    [anon_sym_unsigned] = ACTIONS(1041),
    [anon_sym_long] = ACTIONS(1041),
    [anon_sym_short] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1043),
    [anon_sym_enum] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1047),
    [anon_sym_struct] = ACTIONS(1049),
    [anon_sym_union] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1053),
    [anon_sym_let] = ACTIONS(1053),
    [anon_sym_This] = ACTIONS(1053),
    [anon_sym_decltype] = ACTIONS(1055),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1057),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(1059),
    [anon_sym_extension] = ACTIONS(1061),
  },
  [51] = {
    [sym__block_item] = STATE(70),
    [sym_preproc_include] = STATE(70),
    [sym_preproc_def] = STATE(70),
    [sym_preproc_function_def] = STATE(70),
    [sym_preproc_call] = STATE(70),
    [sym_preproc_if] = STATE(70),
    [sym_preproc_ifdef] = STATE(70),
    [sym_function_definition] = STATE(70),
    [sym_declaration] = STATE(70),
    [sym_type_definition] = STATE(70),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(70),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(70),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(70),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(70),
    [sym_template_instantiation] = STATE(70),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(70),
    [sym_operator_cast_declaration] = STATE(70),
    [sym_constructor_or_destructor_definition] = STATE(70),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(70),
    [sym_namespace_alias_definition] = STATE(70),
    [sym_using_declaration] = STATE(70),
    [sym_alias_declaration] = STATE(70),
    [sym_static_assert_declaration] = STATE(70),
    [sym_concept_definition] = STATE(70),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(70),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1193),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [52] = {
    [sym__block_item] = STATE(30),
    [sym_preproc_include] = STATE(30),
    [sym_preproc_def] = STATE(30),
    [sym_preproc_function_def] = STATE(30),
    [sym_preproc_call] = STATE(30),
    [sym_preproc_if] = STATE(30),
    [sym_preproc_ifdef] = STATE(30),
    [sym_function_definition] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_type_definition] = STATE(30),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(30),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(30),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(30),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(30),
    [sym_template_instantiation] = STATE(30),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(30),
    [sym_operator_cast_declaration] = STATE(30),
    [sym_constructor_or_destructor_definition] = STATE(30),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(30),
    [sym_namespace_alias_definition] = STATE(30),
    [sym_using_declaration] = STATE(30),
    [sym_alias_declaration] = STATE(30),
    [sym_static_assert_declaration] = STATE(30),
    [sym_concept_definition] = STATE(30),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(30),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1195),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [53] = {
    [sym__block_item] = STATE(39),
    [sym_preproc_include] = STATE(39),
    [sym_preproc_def] = STATE(39),
    [sym_preproc_function_def] = STATE(39),
    [sym_preproc_call] = STATE(39),
    [sym_preproc_if] = STATE(39),
    [sym_preproc_ifdef] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_declaration] = STATE(39),
    [sym_type_definition] = STATE(39),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5738),
    [sym_linkage_specification] = STATE(39),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1856),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7569),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(787),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2683),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(851),
    [sym_statement] = STATE(39),
    [sym_labeled_statement] = STATE(787),
    [sym_expression_statement] = STATE(787),
    [sym_if_statement] = STATE(787),
    [sym_switch_statement] = STATE(787),
    [sym_case_statement] = STATE(787),
    [sym_while_statement] = STATE(787),
    [sym_do_statement] = STATE(787),
    [sym_for_statement] = STATE(787),
    [sym_return_statement] = STATE(787),
    [sym_break_statement] = STATE(787),
    [sym_continue_statement] = STATE(787),
    [sym_goto_statement] = STATE(787),
    [sym_seh_try_statement] = STATE(787),
    [sym_seh_leave_statement] = STATE(787),
    [sym_expression] = STATE(5465),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10896),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(39),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2584),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(39),
    [sym_template_instantiation] = STATE(39),
    [sym_operator_cast] = STATE(8413),
    [sym__constructor_specifiers] = STATE(2584),
    [sym_operator_cast_definition] = STATE(39),
    [sym_operator_cast_declaration] = STATE(39),
    [sym_constructor_or_destructor_definition] = STATE(39),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(39),
    [sym_namespace_alias_definition] = STATE(39),
    [sym_using_declaration] = STATE(39),
    [sym_alias_declaration] = STATE(39),
    [sym_static_assert_declaration] = STATE(39),
    [sym_concept_definition] = STATE(39),
    [sym_for_range_loop] = STATE(787),
    [sym_co_return_statement] = STATE(787),
    [sym_co_yield_statement] = STATE(787),
    [sym_throw_statement] = STATE(787),
    [sym_try_statement] = STATE(787),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8413),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(787),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(787),
    [sym_hlsl_attribute] = STATE(1483),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(39),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1148),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2584),
    [sym_identifier] = ACTIONS(1197),
    [aux_sym_preproc_include_token1] = ACTIONS(1199),
    [aux_sym_preproc_def_token1] = ACTIONS(1201),
    [aux_sym_preproc_if_token1] = ACTIONS(1203),
    [aux_sym_preproc_if_token2] = ACTIONS(1205),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1207),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1207),
    [sym_preproc_directive] = ACTIONS(1209),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(1211),
    [anon_sym___extension__] = ACTIONS(1213),
    [anon_sym_typedef] = ACTIONS(1215),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(1217),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(1219),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(1221),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_switch] = ACTIONS(1225),
    [anon_sym_case] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1229),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_do] = ACTIONS(1233),
    [anon_sym_for] = ACTIONS(1235),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1239),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_goto] = ACTIONS(1243),
    [anon_sym___try] = ACTIONS(1245),
    [anon_sym___leave] = ACTIONS(1247),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(1251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(1253),
    [anon_sym_namespace] = ACTIONS(1255),
    [anon_sym_using] = ACTIONS(1257),
    [anon_sym_static_assert] = ACTIONS(1259),
    [anon_sym_concept] = ACTIONS(1261),
    [anon_sym_co_return] = ACTIONS(1263),
    [anon_sym_co_yield] = ACTIONS(1265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(1269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [54] = {
    [sym__block_item] = STATE(30),
    [sym_preproc_include] = STATE(30),
    [sym_preproc_def] = STATE(30),
    [sym_preproc_function_def] = STATE(30),
    [sym_preproc_call] = STATE(30),
    [sym_preproc_if] = STATE(30),
    [sym_preproc_ifdef] = STATE(30),
    [sym_function_definition] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_type_definition] = STATE(30),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(30),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(30),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(30),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(30),
    [sym_template_instantiation] = STATE(30),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(30),
    [sym_operator_cast_declaration] = STATE(30),
    [sym_constructor_or_destructor_definition] = STATE(30),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(30),
    [sym_namespace_alias_definition] = STATE(30),
    [sym_using_declaration] = STATE(30),
    [sym_alias_declaration] = STATE(30),
    [sym_static_assert_declaration] = STATE(30),
    [sym_concept_definition] = STATE(30),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(30),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1271),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [55] = {
    [sym__block_item] = STATE(29),
    [sym_preproc_include] = STATE(29),
    [sym_preproc_def] = STATE(29),
    [sym_preproc_function_def] = STATE(29),
    [sym_preproc_call] = STATE(29),
    [sym_preproc_if] = STATE(29),
    [sym_preproc_ifdef] = STATE(29),
    [sym_function_definition] = STATE(29),
    [sym_declaration] = STATE(29),
    [sym_type_definition] = STATE(29),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(29),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(29),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(29),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(29),
    [sym_template_instantiation] = STATE(29),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(29),
    [sym_operator_cast_declaration] = STATE(29),
    [sym_constructor_or_destructor_definition] = STATE(29),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(29),
    [sym_namespace_alias_definition] = STATE(29),
    [sym_using_declaration] = STATE(29),
    [sym_alias_declaration] = STATE(29),
    [sym_static_assert_declaration] = STATE(29),
    [sym_concept_definition] = STATE(29),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(29),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [56] = {
    [sym__block_item] = STATE(40),
    [sym_preproc_include] = STATE(40),
    [sym_preproc_def] = STATE(40),
    [sym_preproc_function_def] = STATE(40),
    [sym_preproc_call] = STATE(40),
    [sym_preproc_if] = STATE(40),
    [sym_preproc_ifdef] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym_declaration] = STATE(40),
    [sym_type_definition] = STATE(40),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(40),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(40),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(40),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(40),
    [sym_template_instantiation] = STATE(40),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(40),
    [sym_operator_cast_declaration] = STATE(40),
    [sym_constructor_or_destructor_definition] = STATE(40),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(40),
    [sym_namespace_alias_definition] = STATE(40),
    [sym_using_declaration] = STATE(40),
    [sym_alias_declaration] = STATE(40),
    [sym_static_assert_declaration] = STATE(40),
    [sym_concept_definition] = STATE(40),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(40),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1275),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [57] = {
    [sym__block_item] = STATE(60),
    [sym_preproc_include] = STATE(60),
    [sym_preproc_def] = STATE(60),
    [sym_preproc_function_def] = STATE(60),
    [sym_preproc_call] = STATE(60),
    [sym_preproc_if] = STATE(60),
    [sym_preproc_ifdef] = STATE(60),
    [sym_function_definition] = STATE(60),
    [sym_declaration] = STATE(60),
    [sym_type_definition] = STATE(60),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(60),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(236),
    [sym_sized_type_specifier] = STATE(766),
    [sym_enum_specifier] = STATE(766),
    [sym_struct_specifier] = STATE(766),
    [sym_union_specifier] = STATE(766),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(60),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(60),
    [sym_placeholder_type_specifier] = STATE(766),
    [sym_decltype] = STATE(760),
    [sym_class_specifier] = STATE(766),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(766),
    [sym_template_declaration] = STATE(60),
    [sym_template_instantiation] = STATE(60),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(60),
    [sym_operator_cast_declaration] = STATE(60),
    [sym_constructor_or_destructor_definition] = STATE(60),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(794),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(60),
    [sym_namespace_alias_definition] = STATE(60),
    [sym_using_declaration] = STATE(60),
    [sym_alias_declaration] = STATE(60),
    [sym_static_assert_declaration] = STATE(60),
    [sym_concept_definition] = STATE(60),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6541),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(789),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(766),
    [sym_extension_specifier] = STATE(766),
    [sym_associatedtype_specifier] = STATE(766),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_declaration_list_repeat1] = STATE(60),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(644),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(1037),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1277),
    [anon_sym_signed] = ACTIONS(1041),
    [anon_sym_unsigned] = ACTIONS(1041),
    [anon_sym_long] = ACTIONS(1041),
    [anon_sym_short] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1043),
    [anon_sym_enum] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1047),
    [anon_sym_struct] = ACTIONS(1049),
    [anon_sym_union] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1053),
    [anon_sym_let] = ACTIONS(1053),
    [anon_sym_This] = ACTIONS(1053),
    [anon_sym_decltype] = ACTIONS(1055),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1057),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(1059),
    [anon_sym_extension] = ACTIONS(1061),
  },
  [58] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(236),
    [sym_sized_type_specifier] = STATE(766),
    [sym_enum_specifier] = STATE(766),
    [sym_struct_specifier] = STATE(766),
    [sym_union_specifier] = STATE(766),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(766),
    [sym_decltype] = STATE(760),
    [sym_class_specifier] = STATE(766),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(766),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(794),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6541),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(789),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(766),
    [sym_extension_specifier] = STATE(766),
    [sym_associatedtype_specifier] = STATE(766),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_declaration_list_repeat1] = STATE(42),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(644),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(1037),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1279),
    [anon_sym_signed] = ACTIONS(1041),
    [anon_sym_unsigned] = ACTIONS(1041),
    [anon_sym_long] = ACTIONS(1041),
    [anon_sym_short] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1043),
    [anon_sym_enum] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1047),
    [anon_sym_struct] = ACTIONS(1049),
    [anon_sym_union] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1053),
    [anon_sym_let] = ACTIONS(1053),
    [anon_sym_This] = ACTIONS(1053),
    [anon_sym_decltype] = ACTIONS(1055),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1057),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(1059),
    [anon_sym_extension] = ACTIONS(1061),
  },
  [59] = {
    [sym__block_item] = STATE(71),
    [sym_preproc_include] = STATE(71),
    [sym_preproc_def] = STATE(71),
    [sym_preproc_function_def] = STATE(71),
    [sym_preproc_call] = STATE(71),
    [sym_preproc_if] = STATE(71),
    [sym_preproc_ifdef] = STATE(71),
    [sym_function_definition] = STATE(71),
    [sym_declaration] = STATE(71),
    [sym_type_definition] = STATE(71),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(71),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(71),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(71),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(71),
    [sym_template_instantiation] = STATE(71),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(71),
    [sym_operator_cast_declaration] = STATE(71),
    [sym_constructor_or_destructor_definition] = STATE(71),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(71),
    [sym_namespace_alias_definition] = STATE(71),
    [sym_using_declaration] = STATE(71),
    [sym_alias_declaration] = STATE(71),
    [sym_static_assert_declaration] = STATE(71),
    [sym_concept_definition] = STATE(71),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(71),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1281),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [60] = {
    [sym__block_item] = STATE(31),
    [sym_preproc_include] = STATE(31),
    [sym_preproc_def] = STATE(31),
    [sym_preproc_function_def] = STATE(31),
    [sym_preproc_call] = STATE(31),
    [sym_preproc_if] = STATE(31),
    [sym_preproc_ifdef] = STATE(31),
    [sym_function_definition] = STATE(31),
    [sym_declaration] = STATE(31),
    [sym_type_definition] = STATE(31),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(31),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(236),
    [sym_sized_type_specifier] = STATE(766),
    [sym_enum_specifier] = STATE(766),
    [sym_struct_specifier] = STATE(766),
    [sym_union_specifier] = STATE(766),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(31),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(31),
    [sym_placeholder_type_specifier] = STATE(766),
    [sym_decltype] = STATE(760),
    [sym_class_specifier] = STATE(766),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(766),
    [sym_template_declaration] = STATE(31),
    [sym_template_instantiation] = STATE(31),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(31),
    [sym_operator_cast_declaration] = STATE(31),
    [sym_constructor_or_destructor_definition] = STATE(31),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(794),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(31),
    [sym_namespace_alias_definition] = STATE(31),
    [sym_using_declaration] = STATE(31),
    [sym_alias_declaration] = STATE(31),
    [sym_static_assert_declaration] = STATE(31),
    [sym_concept_definition] = STATE(31),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6541),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(789),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(766),
    [sym_extension_specifier] = STATE(766),
    [sym_associatedtype_specifier] = STATE(766),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_declaration_list_repeat1] = STATE(31),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(644),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(1037),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1283),
    [anon_sym_signed] = ACTIONS(1041),
    [anon_sym_unsigned] = ACTIONS(1041),
    [anon_sym_long] = ACTIONS(1041),
    [anon_sym_short] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1043),
    [anon_sym_enum] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1047),
    [anon_sym_struct] = ACTIONS(1049),
    [anon_sym_union] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1053),
    [anon_sym_let] = ACTIONS(1053),
    [anon_sym_This] = ACTIONS(1053),
    [anon_sym_decltype] = ACTIONS(1055),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1057),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(1059),
    [anon_sym_extension] = ACTIONS(1061),
  },
  [61] = {
    [sym__block_item] = STATE(31),
    [sym_preproc_include] = STATE(31),
    [sym_preproc_def] = STATE(31),
    [sym_preproc_function_def] = STATE(31),
    [sym_preproc_call] = STATE(31),
    [sym_preproc_if] = STATE(31),
    [sym_preproc_ifdef] = STATE(31),
    [sym_function_definition] = STATE(31),
    [sym_declaration] = STATE(31),
    [sym_type_definition] = STATE(31),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(31),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(236),
    [sym_sized_type_specifier] = STATE(766),
    [sym_enum_specifier] = STATE(766),
    [sym_struct_specifier] = STATE(766),
    [sym_union_specifier] = STATE(766),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(31),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(31),
    [sym_placeholder_type_specifier] = STATE(766),
    [sym_decltype] = STATE(760),
    [sym_class_specifier] = STATE(766),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(766),
    [sym_template_declaration] = STATE(31),
    [sym_template_instantiation] = STATE(31),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(31),
    [sym_operator_cast_declaration] = STATE(31),
    [sym_constructor_or_destructor_definition] = STATE(31),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(794),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(31),
    [sym_namespace_alias_definition] = STATE(31),
    [sym_using_declaration] = STATE(31),
    [sym_alias_declaration] = STATE(31),
    [sym_static_assert_declaration] = STATE(31),
    [sym_concept_definition] = STATE(31),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6541),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(789),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(766),
    [sym_extension_specifier] = STATE(766),
    [sym_associatedtype_specifier] = STATE(766),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_declaration_list_repeat1] = STATE(31),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(644),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(1037),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1285),
    [anon_sym_signed] = ACTIONS(1041),
    [anon_sym_unsigned] = ACTIONS(1041),
    [anon_sym_long] = ACTIONS(1041),
    [anon_sym_short] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1043),
    [anon_sym_enum] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1047),
    [anon_sym_struct] = ACTIONS(1049),
    [anon_sym_union] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1053),
    [anon_sym_let] = ACTIONS(1053),
    [anon_sym_This] = ACTIONS(1053),
    [anon_sym_decltype] = ACTIONS(1055),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1057),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(1059),
    [anon_sym_extension] = ACTIONS(1061),
  },
  [62] = {
    [sym__block_item] = STATE(53),
    [sym_preproc_include] = STATE(53),
    [sym_preproc_def] = STATE(53),
    [sym_preproc_function_def] = STATE(53),
    [sym_preproc_call] = STATE(53),
    [sym_preproc_if] = STATE(53),
    [sym_preproc_ifdef] = STATE(53),
    [sym_function_definition] = STATE(53),
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5738),
    [sym_linkage_specification] = STATE(53),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1856),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7569),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(787),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2683),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(851),
    [sym_statement] = STATE(53),
    [sym_labeled_statement] = STATE(787),
    [sym_expression_statement] = STATE(787),
    [sym_if_statement] = STATE(787),
    [sym_switch_statement] = STATE(787),
    [sym_case_statement] = STATE(787),
    [sym_while_statement] = STATE(787),
    [sym_do_statement] = STATE(787),
    [sym_for_statement] = STATE(787),
    [sym_return_statement] = STATE(787),
    [sym_break_statement] = STATE(787),
    [sym_continue_statement] = STATE(787),
    [sym_goto_statement] = STATE(787),
    [sym_seh_try_statement] = STATE(787),
    [sym_seh_leave_statement] = STATE(787),
    [sym_expression] = STATE(5465),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10896),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(53),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2584),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(53),
    [sym_template_instantiation] = STATE(53),
    [sym_operator_cast] = STATE(8413),
    [sym__constructor_specifiers] = STATE(2584),
    [sym_operator_cast_definition] = STATE(53),
    [sym_operator_cast_declaration] = STATE(53),
    [sym_constructor_or_destructor_definition] = STATE(53),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(53),
    [sym_namespace_alias_definition] = STATE(53),
    [sym_using_declaration] = STATE(53),
    [sym_alias_declaration] = STATE(53),
    [sym_static_assert_declaration] = STATE(53),
    [sym_concept_definition] = STATE(53),
    [sym_for_range_loop] = STATE(787),
    [sym_co_return_statement] = STATE(787),
    [sym_co_yield_statement] = STATE(787),
    [sym_throw_statement] = STATE(787),
    [sym_try_statement] = STATE(787),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8413),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(787),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(787),
    [sym_hlsl_attribute] = STATE(1483),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(53),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1148),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2584),
    [sym_identifier] = ACTIONS(1197),
    [aux_sym_preproc_include_token1] = ACTIONS(1199),
    [aux_sym_preproc_def_token1] = ACTIONS(1201),
    [aux_sym_preproc_if_token1] = ACTIONS(1203),
    [aux_sym_preproc_if_token2] = ACTIONS(1287),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1207),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1207),
    [sym_preproc_directive] = ACTIONS(1209),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(1211),
    [anon_sym___extension__] = ACTIONS(1213),
    [anon_sym_typedef] = ACTIONS(1215),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(1217),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(1219),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(1221),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_switch] = ACTIONS(1225),
    [anon_sym_case] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1229),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_do] = ACTIONS(1233),
    [anon_sym_for] = ACTIONS(1235),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1239),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_goto] = ACTIONS(1243),
    [anon_sym___try] = ACTIONS(1245),
    [anon_sym___leave] = ACTIONS(1247),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(1251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(1253),
    [anon_sym_namespace] = ACTIONS(1255),
    [anon_sym_using] = ACTIONS(1257),
    [anon_sym_static_assert] = ACTIONS(1259),
    [anon_sym_concept] = ACTIONS(1261),
    [anon_sym_co_return] = ACTIONS(1263),
    [anon_sym_co_yield] = ACTIONS(1265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(1269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [63] = {
    [sym__block_item] = STATE(30),
    [sym_preproc_include] = STATE(30),
    [sym_preproc_def] = STATE(30),
    [sym_preproc_function_def] = STATE(30),
    [sym_preproc_call] = STATE(30),
    [sym_preproc_if] = STATE(30),
    [sym_preproc_ifdef] = STATE(30),
    [sym_function_definition] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_type_definition] = STATE(30),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(30),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(30),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(30),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(30),
    [sym_template_instantiation] = STATE(30),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(30),
    [sym_operator_cast_declaration] = STATE(30),
    [sym_constructor_or_destructor_definition] = STATE(30),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(30),
    [sym_namespace_alias_definition] = STATE(30),
    [sym_using_declaration] = STATE(30),
    [sym_alias_declaration] = STATE(30),
    [sym_static_assert_declaration] = STATE(30),
    [sym_concept_definition] = STATE(30),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(30),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1289),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [64] = {
    [sym__block_item] = STATE(36),
    [sym_preproc_include] = STATE(36),
    [sym_preproc_def] = STATE(36),
    [sym_preproc_function_def] = STATE(36),
    [sym_preproc_call] = STATE(36),
    [sym_preproc_if] = STATE(36),
    [sym_preproc_ifdef] = STATE(36),
    [sym_function_definition] = STATE(36),
    [sym_declaration] = STATE(36),
    [sym_type_definition] = STATE(36),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(36),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(36),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(36),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(36),
    [sym_template_instantiation] = STATE(36),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(36),
    [sym_operator_cast_declaration] = STATE(36),
    [sym_constructor_or_destructor_definition] = STATE(36),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(36),
    [sym_namespace_alias_definition] = STATE(36),
    [sym_using_declaration] = STATE(36),
    [sym_alias_declaration] = STATE(36),
    [sym_static_assert_declaration] = STATE(36),
    [sym_concept_definition] = STATE(36),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(36),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1291),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [65] = {
    [sym__block_item] = STATE(63),
    [sym_preproc_include] = STATE(63),
    [sym_preproc_def] = STATE(63),
    [sym_preproc_function_def] = STATE(63),
    [sym_preproc_call] = STATE(63),
    [sym_preproc_if] = STATE(63),
    [sym_preproc_ifdef] = STATE(63),
    [sym_function_definition] = STATE(63),
    [sym_declaration] = STATE(63),
    [sym_type_definition] = STATE(63),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(63),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(63),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(63),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(63),
    [sym_template_instantiation] = STATE(63),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(63),
    [sym_operator_cast_declaration] = STATE(63),
    [sym_constructor_or_destructor_definition] = STATE(63),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(63),
    [sym_namespace_alias_definition] = STATE(63),
    [sym_using_declaration] = STATE(63),
    [sym_alias_declaration] = STATE(63),
    [sym_static_assert_declaration] = STATE(63),
    [sym_concept_definition] = STATE(63),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(63),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1293),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [66] = {
    [sym__block_item] = STATE(31),
    [sym_preproc_include] = STATE(31),
    [sym_preproc_def] = STATE(31),
    [sym_preproc_function_def] = STATE(31),
    [sym_preproc_call] = STATE(31),
    [sym_preproc_if] = STATE(31),
    [sym_preproc_ifdef] = STATE(31),
    [sym_function_definition] = STATE(31),
    [sym_declaration] = STATE(31),
    [sym_type_definition] = STATE(31),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(31),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(236),
    [sym_sized_type_specifier] = STATE(766),
    [sym_enum_specifier] = STATE(766),
    [sym_struct_specifier] = STATE(766),
    [sym_union_specifier] = STATE(766),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(31),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(31),
    [sym_placeholder_type_specifier] = STATE(766),
    [sym_decltype] = STATE(760),
    [sym_class_specifier] = STATE(766),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(766),
    [sym_template_declaration] = STATE(31),
    [sym_template_instantiation] = STATE(31),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(31),
    [sym_operator_cast_declaration] = STATE(31),
    [sym_constructor_or_destructor_definition] = STATE(31),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(794),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(31),
    [sym_namespace_alias_definition] = STATE(31),
    [sym_using_declaration] = STATE(31),
    [sym_alias_declaration] = STATE(31),
    [sym_static_assert_declaration] = STATE(31),
    [sym_concept_definition] = STATE(31),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6541),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(789),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(766),
    [sym_extension_specifier] = STATE(766),
    [sym_associatedtype_specifier] = STATE(766),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_declaration_list_repeat1] = STATE(31),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(644),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(1037),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1295),
    [anon_sym_signed] = ACTIONS(1041),
    [anon_sym_unsigned] = ACTIONS(1041),
    [anon_sym_long] = ACTIONS(1041),
    [anon_sym_short] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1043),
    [anon_sym_enum] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1047),
    [anon_sym_struct] = ACTIONS(1049),
    [anon_sym_union] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1053),
    [anon_sym_let] = ACTIONS(1053),
    [anon_sym_This] = ACTIONS(1053),
    [anon_sym_decltype] = ACTIONS(1055),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1057),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(1059),
    [anon_sym_extension] = ACTIONS(1061),
  },
  [67] = {
    [sym__block_item] = STATE(30),
    [sym_preproc_include] = STATE(30),
    [sym_preproc_def] = STATE(30),
    [sym_preproc_function_def] = STATE(30),
    [sym_preproc_call] = STATE(30),
    [sym_preproc_if] = STATE(30),
    [sym_preproc_ifdef] = STATE(30),
    [sym_function_definition] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_type_definition] = STATE(30),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(30),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(30),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(30),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(30),
    [sym_template_instantiation] = STATE(30),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(30),
    [sym_operator_cast_declaration] = STATE(30),
    [sym_constructor_or_destructor_definition] = STATE(30),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(30),
    [sym_namespace_alias_definition] = STATE(30),
    [sym_using_declaration] = STATE(30),
    [sym_alias_declaration] = STATE(30),
    [sym_static_assert_declaration] = STATE(30),
    [sym_concept_definition] = STATE(30),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(30),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1297),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [68] = {
    [sym__block_item] = STATE(35),
    [sym_preproc_include] = STATE(35),
    [sym_preproc_def] = STATE(35),
    [sym_preproc_function_def] = STATE(35),
    [sym_preproc_call] = STATE(35),
    [sym_preproc_if] = STATE(35),
    [sym_preproc_ifdef] = STATE(35),
    [sym_function_definition] = STATE(35),
    [sym_declaration] = STATE(35),
    [sym_type_definition] = STATE(35),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(35),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(35),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(35),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(35),
    [sym_template_instantiation] = STATE(35),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(35),
    [sym_operator_cast_declaration] = STATE(35),
    [sym_constructor_or_destructor_definition] = STATE(35),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(35),
    [sym_namespace_alias_definition] = STATE(35),
    [sym_using_declaration] = STATE(35),
    [sym_alias_declaration] = STATE(35),
    [sym_static_assert_declaration] = STATE(35),
    [sym_concept_definition] = STATE(35),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(35),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1299),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [69] = {
    [sym__block_item] = STATE(67),
    [sym_preproc_include] = STATE(67),
    [sym_preproc_def] = STATE(67),
    [sym_preproc_function_def] = STATE(67),
    [sym_preproc_call] = STATE(67),
    [sym_preproc_if] = STATE(67),
    [sym_preproc_ifdef] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_declaration] = STATE(67),
    [sym_type_definition] = STATE(67),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(67),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(67),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(67),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(67),
    [sym_template_instantiation] = STATE(67),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(67),
    [sym_operator_cast_declaration] = STATE(67),
    [sym_constructor_or_destructor_definition] = STATE(67),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(67),
    [sym_namespace_alias_definition] = STATE(67),
    [sym_using_declaration] = STATE(67),
    [sym_alias_declaration] = STATE(67),
    [sym_static_assert_declaration] = STATE(67),
    [sym_concept_definition] = STATE(67),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(67),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1301),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [70] = {
    [sym__block_item] = STATE(30),
    [sym_preproc_include] = STATE(30),
    [sym_preproc_def] = STATE(30),
    [sym_preproc_function_def] = STATE(30),
    [sym_preproc_call] = STATE(30),
    [sym_preproc_if] = STATE(30),
    [sym_preproc_ifdef] = STATE(30),
    [sym_function_definition] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_type_definition] = STATE(30),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(30),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(30),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(30),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(30),
    [sym_template_instantiation] = STATE(30),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(30),
    [sym_operator_cast_declaration] = STATE(30),
    [sym_constructor_or_destructor_definition] = STATE(30),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(30),
    [sym_namespace_alias_definition] = STATE(30),
    [sym_using_declaration] = STATE(30),
    [sym_alias_declaration] = STATE(30),
    [sym_static_assert_declaration] = STATE(30),
    [sym_concept_definition] = STATE(30),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(30),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1303),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [71] = {
    [sym__block_item] = STATE(30),
    [sym_preproc_include] = STATE(30),
    [sym_preproc_def] = STATE(30),
    [sym_preproc_function_def] = STATE(30),
    [sym_preproc_call] = STATE(30),
    [sym_preproc_if] = STATE(30),
    [sym_preproc_ifdef] = STATE(30),
    [sym_function_definition] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_type_definition] = STATE(30),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(30),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(30),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(30),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(30),
    [sym_template_instantiation] = STATE(30),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(30),
    [sym_operator_cast_declaration] = STATE(30),
    [sym_constructor_or_destructor_definition] = STATE(30),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(30),
    [sym_namespace_alias_definition] = STATE(30),
    [sym_using_declaration] = STATE(30),
    [sym_alias_declaration] = STATE(30),
    [sym_static_assert_declaration] = STATE(30),
    [sym_concept_definition] = STATE(30),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(30),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1305),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [72] = {
    [sym__block_item] = STATE(52),
    [sym_preproc_include] = STATE(52),
    [sym_preproc_def] = STATE(52),
    [sym_preproc_function_def] = STATE(52),
    [sym_preproc_call] = STATE(52),
    [sym_preproc_if] = STATE(52),
    [sym_preproc_ifdef] = STATE(52),
    [sym_function_definition] = STATE(52),
    [sym_declaration] = STATE(52),
    [sym_type_definition] = STATE(52),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(52),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(52),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(52),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(52),
    [sym_template_instantiation] = STATE(52),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(52),
    [sym_operator_cast_declaration] = STATE(52),
    [sym_constructor_or_destructor_definition] = STATE(52),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(52),
    [sym_namespace_alias_definition] = STATE(52),
    [sym_using_declaration] = STATE(52),
    [sym_alias_declaration] = STATE(52),
    [sym_static_assert_declaration] = STATE(52),
    [sym_concept_definition] = STATE(52),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(52),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1307),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [73] = {
    [sym__block_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(43),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(43),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(43),
    [sym_template_instantiation] = STATE(43),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(43),
    [sym_operator_cast_declaration] = STATE(43),
    [sym_constructor_or_destructor_definition] = STATE(43),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_alias_definition] = STATE(43),
    [sym_using_declaration] = STATE(43),
    [sym_alias_declaration] = STATE(43),
    [sym_static_assert_declaration] = STATE(43),
    [sym_concept_definition] = STATE(43),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1309),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [74] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7521),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(774),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(834),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2592),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2592),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(5388),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6572),
    [sym_qualified_identifier] = STATE(3951),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_qualifiers] = STATE(2776),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(1477),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1311),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(249),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(257),
    [anon_sym_static_assert] = ACTIONS(259),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [75] = {
    [sym__top_level_item] = STATE(75),
    [sym_preproc_include] = STATE(75),
    [sym_preproc_def] = STATE(75),
    [sym_preproc_function_def] = STATE(75),
    [sym_preproc_call] = STATE(75),
    [sym_preproc_if] = STATE(75),
    [sym_preproc_ifdef] = STATE(75),
    [sym_function_definition] = STATE(75),
    [sym_declaration] = STATE(75),
    [sym_type_definition] = STATE(75),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5680),
    [sym_linkage_specification] = STATE(75),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1937),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7540),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(75),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(247),
    [sym_sized_type_specifier] = STATE(361),
    [sym_enum_specifier] = STATE(361),
    [sym_struct_specifier] = STATE(361),
    [sym_union_specifier] = STATE(361),
    [sym_attributed_statement] = STATE(1069),
    [sym__top_level_statement] = STATE(75),
    [sym_labeled_statement] = STATE(75),
    [sym__top_level_expression_statement] = STATE(75),
    [sym_if_statement] = STATE(75),
    [sym_switch_statement] = STATE(75),
    [sym_case_statement] = STATE(75),
    [sym_while_statement] = STATE(75),
    [sym_do_statement] = STATE(75),
    [sym_for_statement] = STATE(75),
    [sym_return_statement] = STATE(75),
    [sym_break_statement] = STATE(75),
    [sym_continue_statement] = STATE(75),
    [sym_goto_statement] = STATE(75),
    [sym_expression] = STATE(5683),
    [sym__string] = STATE(5817),
    [sym_conditional_expression] = STATE(5817),
    [sym_assignment_expression] = STATE(5817),
    [sym_pointer_expression] = STATE(4586),
    [sym_unary_expression] = STATE(5817),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(5817),
    [sym_cast_expression] = STATE(5817),
    [sym_sizeof_expression] = STATE(5817),
    [sym_alignof_expression] = STATE(5817),
    [sym_offsetof_expression] = STATE(5817),
    [sym_generic_expression] = STATE(5817),
    [sym_subscript_expression] = STATE(4586),
    [sym_call_expression] = STATE(4586),
    [sym_gnu_asm_expression] = STATE(5817),
    [sym_field_expression] = STATE(4586),
    [sym_compound_literal_expression] = STATE(5817),
    [sym_parenthesized_expression] = STATE(4586),
    [sym_char_literal] = STATE(5671),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(5817),
    [sym__empty_declaration] = STATE(75),
    [sym_placeholder_type_specifier] = STATE(361),
    [sym_decltype] = STATE(268),
    [sym_class_specifier] = STATE(361),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2588),
    [sym_dependent_type] = STATE(361),
    [sym_template_declaration] = STATE(75),
    [sym_template_instantiation] = STATE(75),
    [sym_operator_cast] = STATE(8467),
    [sym__constructor_specifiers] = STATE(2588),
    [sym_operator_cast_definition] = STATE(75),
    [sym_operator_cast_declaration] = STATE(75),
    [sym_constructor_or_destructor_definition] = STATE(75),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(995),
    [sym_template_function] = STATE(5705),
    [sym_namespace_definition] = STATE(75),
    [sym_namespace_alias_definition] = STATE(75),
    [sym_using_declaration] = STATE(75),
    [sym_alias_declaration] = STATE(75),
    [sym_static_assert_declaration] = STATE(75),
    [sym_concept_definition] = STATE(75),
    [sym_for_range_loop] = STATE(75),
    [sym_co_return_statement] = STATE(75),
    [sym_co_yield_statement] = STATE(75),
    [sym_throw_statement] = STATE(75),
    [sym_try_statement] = STATE(75),
    [sym_raw_string_literal] = STATE(4610),
    [sym_co_await_expression] = STATE(5817),
    [sym_new_expression] = STATE(5817),
    [sym_delete_expression] = STATE(5817),
    [sym_requires_clause] = STATE(5817),
    [sym_requires_expression] = STATE(5817),
    [sym_lambda_expression] = STATE(5817),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(5817),
    [sym_parameter_pack_expansion] = STATE(5817),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6558),
    [sym_qualified_identifier] = STATE(4457),
    [sym_qualified_type_identifier] = STATE(996),
    [sym_qualified_operator_cast_identifier] = STATE(8467),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4586),
    [sym_qualifiers] = STATE(2776),
    [sym_hlsl_attribute] = STATE(1479),
    [sym_interface_specifier] = STATE(361),
    [sym_extension_specifier] = STATE(361),
    [sym_import_statement] = STATE(75),
    [sym_associatedtype_specifier] = STATE(361),
    [aux_sym_translation_unit_repeat1] = STATE(75),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1102),
    [aux_sym_sized_type_specifier_repeat1] = STATE(886),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2588),
    [ts_builtin_sym_end] = ACTIONS(1313),
    [sym_identifier] = ACTIONS(1315),
    [aux_sym_preproc_include_token1] = ACTIONS(1318),
    [aux_sym_preproc_def_token1] = ACTIONS(1321),
    [aux_sym_preproc_if_token1] = ACTIONS(1324),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1327),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1327),
    [sym_preproc_directive] = ACTIONS(1330),
    [anon_sym_LPAREN2] = ACTIONS(1333),
    [anon_sym_BANG] = ACTIONS(1336),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_DASH] = ACTIONS(1342),
    [anon_sym_PLUS] = ACTIONS(1342),
    [anon_sym_STAR] = ACTIONS(1345),
    [anon_sym_AMP_AMP] = ACTIONS(1348),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym___extension__] = ACTIONS(1354),
    [anon_sym_typedef] = ACTIONS(1357),
    [anon_sym_in] = ACTIONS(1360),
    [anon_sym_out] = ACTIONS(1360),
    [anon_sym_inout] = ACTIONS(1360),
    [anon_sym_extern] = ACTIONS(1363),
    [anon_sym___attribute__] = ACTIONS(1366),
    [anon_sym_COLON_COLON] = ACTIONS(1369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1372),
    [anon_sym___declspec] = ACTIONS(1375),
    [anon_sym___based] = ACTIONS(1378),
    [anon_sym___cdecl] = ACTIONS(1381),
    [anon_sym___clrcall] = ACTIONS(1381),
    [anon_sym___stdcall] = ACTIONS(1381),
    [anon_sym___fastcall] = ACTIONS(1381),
    [anon_sym___thiscall] = ACTIONS(1381),
    [anon_sym___vectorcall] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(1384),
    [anon_sym_signed] = ACTIONS(1387),
    [anon_sym_unsigned] = ACTIONS(1387),
    [anon_sym_long] = ACTIONS(1387),
    [anon_sym_short] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1390),
    [anon_sym_static] = ACTIONS(1393),
    [anon_sym_register] = ACTIONS(1393),
    [anon_sym_inline] = ACTIONS(1396),
    [anon_sym___inline] = ACTIONS(1393),
    [anon_sym___inline__] = ACTIONS(1393),
    [anon_sym___forceinline] = ACTIONS(1393),
    [anon_sym_thread_local] = ACTIONS(1393),
    [anon_sym___thread] = ACTIONS(1393),
    [anon_sym_const] = ACTIONS(1399),
    [anon_sym_constexpr] = ACTIONS(1399),
    [anon_sym_volatile] = ACTIONS(1399),
    [anon_sym_restrict] = ACTIONS(1399),
    [anon_sym___restrict__] = ACTIONS(1399),
    [anon_sym__Atomic] = ACTIONS(1399),
    [anon_sym__Noreturn] = ACTIONS(1399),
    [anon_sym_noreturn] = ACTIONS(1399),
    [anon_sym_mutable] = ACTIONS(1399),
    [anon_sym_constinit] = ACTIONS(1399),
    [anon_sym_consteval] = ACTIONS(1399),
    [anon_sym_alignas] = ACTIONS(1402),
    [anon_sym__Alignas] = ACTIONS(1402),
    [sym_primitive_type] = ACTIONS(1405),
    [anon_sym_enum] = ACTIONS(1408),
    [anon_sym_class] = ACTIONS(1411),
    [anon_sym_struct] = ACTIONS(1414),
    [anon_sym_union] = ACTIONS(1417),
    [anon_sym_if] = ACTIONS(1420),
    [anon_sym_switch] = ACTIONS(1423),
    [anon_sym_case] = ACTIONS(1426),
    [anon_sym_default] = ACTIONS(1429),
    [anon_sym_while] = ACTIONS(1432),
    [anon_sym_do] = ACTIONS(1435),
    [anon_sym_for] = ACTIONS(1438),
    [anon_sym_return] = ACTIONS(1441),
    [anon_sym_break] = ACTIONS(1444),
    [anon_sym_continue] = ACTIONS(1447),
    [anon_sym_goto] = ACTIONS(1450),
    [anon_sym_not] = ACTIONS(1342),
    [anon_sym_compl] = ACTIONS(1342),
    [anon_sym_DASH_DASH] = ACTIONS(1453),
    [anon_sym_PLUS_PLUS] = ACTIONS(1453),
    [anon_sym_sizeof] = ACTIONS(1456),
    [anon_sym___alignof__] = ACTIONS(1459),
    [anon_sym___alignof] = ACTIONS(1459),
    [anon_sym__alignof] = ACTIONS(1459),
    [anon_sym_alignof] = ACTIONS(1459),
    [anon_sym__Alignof] = ACTIONS(1459),
    [anon_sym_offsetof] = ACTIONS(1462),
    [anon_sym__Generic] = ACTIONS(1465),
    [anon_sym_asm] = ACTIONS(1468),
    [anon_sym___asm__] = ACTIONS(1468),
    [sym_number_literal] = ACTIONS(1471),
    [anon_sym_L_SQUOTE] = ACTIONS(1474),
    [anon_sym_u_SQUOTE] = ACTIONS(1474),
    [anon_sym_U_SQUOTE] = ACTIONS(1474),
    [anon_sym_u8_SQUOTE] = ACTIONS(1474),
    [anon_sym_SQUOTE] = ACTIONS(1474),
    [anon_sym_L_DQUOTE] = ACTIONS(1477),
    [anon_sym_u_DQUOTE] = ACTIONS(1477),
    [anon_sym_U_DQUOTE] = ACTIONS(1477),
    [anon_sym_u8_DQUOTE] = ACTIONS(1477),
    [anon_sym_DQUOTE] = ACTIONS(1477),
    [sym_true] = ACTIONS(1480),
    [sym_false] = ACTIONS(1480),
    [anon_sym_NULL] = ACTIONS(1483),
    [anon_sym_nullptr] = ACTIONS(1483),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1486),
    [anon_sym_let] = ACTIONS(1486),
    [anon_sym_This] = ACTIONS(1486),
    [anon_sym_decltype] = ACTIONS(1489),
    [sym_virtual] = ACTIONS(1360),
    [anon_sym_explicit] = ACTIONS(1492),
    [anon_sym_typename] = ACTIONS(1495),
    [anon_sym_template] = ACTIONS(1498),
    [anon_sym_operator] = ACTIONS(1501),
    [anon_sym_try] = ACTIONS(1504),
    [anon_sym_delete] = ACTIONS(1507),
    [anon_sym_throw] = ACTIONS(1510),
    [anon_sym_namespace] = ACTIONS(1513),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_static_assert] = ACTIONS(1519),
    [anon_sym_concept] = ACTIONS(1522),
    [anon_sym_co_return] = ACTIONS(1525),
    [anon_sym_co_yield] = ACTIONS(1528),
    [anon_sym_R_DQUOTE] = ACTIONS(1531),
    [anon_sym_LR_DQUOTE] = ACTIONS(1531),
    [anon_sym_uR_DQUOTE] = ACTIONS(1531),
    [anon_sym_UR_DQUOTE] = ACTIONS(1531),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1531),
    [anon_sym_co_await] = ACTIONS(1534),
    [anon_sym_new] = ACTIONS(1537),
    [anon_sym_requires] = ACTIONS(1540),
    [sym_this] = ACTIONS(1480),
    [anon_sym_precise] = ACTIONS(1543),
    [anon_sym_shared] = ACTIONS(1543),
    [anon_sym_groupshared] = ACTIONS(1543),
    [anon_sym_uniform] = ACTIONS(1543),
    [anon_sym_row_major] = ACTIONS(1543),
    [anon_sym_column_major] = ACTIONS(1543),
    [anon_sym_globallycoherent] = ACTIONS(1543),
    [anon_sym_centroid] = ACTIONS(1543),
    [anon_sym_noperspective] = ACTIONS(1543),
    [anon_sym_nointerpolation] = ACTIONS(1543),
    [anon_sym_sample] = ACTIONS(1543),
    [anon_sym_linear] = ACTIONS(1543),
    [anon_sym_snorm] = ACTIONS(1543),
    [anon_sym_unorm] = ACTIONS(1543),
    [anon_sym_point] = ACTIONS(1543),
    [anon_sym_line] = ACTIONS(1543),
    [anon_sym_triangleadj] = ACTIONS(1543),
    [anon_sym_lineadj] = ACTIONS(1543),
    [anon_sym_triangle] = ACTIONS(1543),
    [anon_sym_interface] = ACTIONS(1546),
    [anon_sym_extension] = ACTIONS(1549),
    [anon_sym___exported] = ACTIONS(1552),
    [anon_sym_import] = ACTIONS(1555),
  },
  [76] = {
    [sym__top_level_item] = STATE(75),
    [sym_preproc_include] = STATE(75),
    [sym_preproc_def] = STATE(75),
    [sym_preproc_function_def] = STATE(75),
    [sym_preproc_call] = STATE(75),
    [sym_preproc_if] = STATE(75),
    [sym_preproc_ifdef] = STATE(75),
    [sym_function_definition] = STATE(75),
    [sym_declaration] = STATE(75),
    [sym_type_definition] = STATE(75),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5680),
    [sym_linkage_specification] = STATE(75),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(1209),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1937),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7540),
    [sym_array_declarator] = STATE(7882),
    [sym_compound_statement] = STATE(75),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(247),
    [sym_sized_type_specifier] = STATE(361),
    [sym_enum_specifier] = STATE(361),
    [sym_struct_specifier] = STATE(361),
    [sym_union_specifier] = STATE(361),
    [sym_attributed_statement] = STATE(1069),
    [sym__top_level_statement] = STATE(75),
    [sym_labeled_statement] = STATE(75),
    [sym__top_level_expression_statement] = STATE(75),
    [sym_if_statement] = STATE(75),
    [sym_switch_statement] = STATE(75),
    [sym_case_statement] = STATE(75),
    [sym_while_statement] = STATE(75),
    [sym_do_statement] = STATE(75),
    [sym_for_statement] = STATE(75),
    [sym_return_statement] = STATE(75),
    [sym_break_statement] = STATE(75),
    [sym_continue_statement] = STATE(75),
    [sym_goto_statement] = STATE(75),
    [sym_expression] = STATE(5683),
    [sym__string] = STATE(5817),
    [sym_conditional_expression] = STATE(5817),
    [sym_assignment_expression] = STATE(5817),
    [sym_pointer_expression] = STATE(4586),
    [sym_unary_expression] = STATE(5817),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(5817),
    [sym_cast_expression] = STATE(5817),
    [sym_sizeof_expression] = STATE(5817),
    [sym_alignof_expression] = STATE(5817),
    [sym_offsetof_expression] = STATE(5817),
    [sym_generic_expression] = STATE(5817),
    [sym_subscript_expression] = STATE(4586),
    [sym_call_expression] = STATE(4586),
    [sym_gnu_asm_expression] = STATE(5817),
    [sym_field_expression] = STATE(4586),
    [sym_compound_literal_expression] = STATE(5817),
    [sym_parenthesized_expression] = STATE(4586),
    [sym_char_literal] = STATE(5671),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(5817),
    [sym__empty_declaration] = STATE(75),
    [sym_placeholder_type_specifier] = STATE(361),
    [sym_decltype] = STATE(268),
    [sym_class_specifier] = STATE(361),
    [sym__class_name] = STATE(9700),
    [sym_explicit_function_specifier] = STATE(2588),
    [sym_dependent_type] = STATE(361),
    [sym_template_declaration] = STATE(75),
    [sym_template_instantiation] = STATE(75),
    [sym_operator_cast] = STATE(8467),
    [sym__constructor_specifiers] = STATE(2588),
    [sym_operator_cast_definition] = STATE(75),
    [sym_operator_cast_declaration] = STATE(75),
    [sym_constructor_or_destructor_definition] = STATE(75),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(995),
    [sym_template_function] = STATE(5705),
    [sym_namespace_definition] = STATE(75),
    [sym_namespace_alias_definition] = STATE(75),
    [sym_using_declaration] = STATE(75),
    [sym_alias_declaration] = STATE(75),
    [sym_static_assert_declaration] = STATE(75),
    [sym_concept_definition] = STATE(75),
    [sym_for_range_loop] = STATE(75),
    [sym_co_return_statement] = STATE(75),
    [sym_co_yield_statement] = STATE(75),
    [sym_throw_statement] = STATE(75),
    [sym_try_statement] = STATE(75),
    [sym_raw_string_literal] = STATE(4610),
    [sym_co_await_expression] = STATE(5817),
    [sym_new_expression] = STATE(5817),
    [sym_delete_expression] = STATE(5817),
    [sym_requires_clause] = STATE(5817),
    [sym_requires_expression] = STATE(5817),
    [sym_lambda_expression] = STATE(5817),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(5817),
    [sym_parameter_pack_expansion] = STATE(5817),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6558),
    [sym_qualified_identifier] = STATE(4457),
    [sym_qualified_type_identifier] = STATE(996),
    [sym_qualified_operator_cast_identifier] = STATE(8467),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4586),
    [sym_qualifiers] = STATE(2776),
    [sym_hlsl_attribute] = STATE(1479),
    [sym_interface_specifier] = STATE(361),
    [sym_extension_specifier] = STATE(361),
    [sym_import_statement] = STATE(75),
    [sym_associatedtype_specifier] = STATE(361),
    [aux_sym_translation_unit_repeat1] = STATE(75),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1102),
    [aux_sym_sized_type_specifier_repeat1] = STATE(886),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2588),
    [ts_builtin_sym_end] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(7),
    [aux_sym_preproc_include_token1] = ACTIONS(9),
    [aux_sym_preproc_def_token1] = ACTIONS(11),
    [aux_sym_preproc_if_token1] = ACTIONS(13),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(15),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(39),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(81),
    [anon_sym_default] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(111),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(117),
    [sym_false] = ACTIONS(117),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(121),
    [anon_sym_This] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(129),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_namespace] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(141),
    [anon_sym_static_assert] = ACTIONS(143),
    [anon_sym_concept] = ACTIONS(145),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(117),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(161),
    [anon_sym_extension] = ACTIONS(163),
    [anon_sym___exported] = ACTIONS(165),
    [anon_sym_import] = ACTIONS(167),
  },
  [77] = {
    [sym_declaration] = STATE(79),
    [sym_type_definition] = STATE(79),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6161),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(1319),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_compound_statement] = STATE(79),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(79),
    [sym_labeled_statement] = STATE(79),
    [sym_expression_statement] = STATE(79),
    [sym_if_statement] = STATE(79),
    [sym_switch_statement] = STATE(79),
    [sym_while_statement] = STATE(79),
    [sym_do_statement] = STATE(79),
    [sym_for_statement] = STATE(79),
    [sym_return_statement] = STATE(79),
    [sym_break_statement] = STATE(79),
    [sym_continue_statement] = STATE(79),
    [sym_goto_statement] = STATE(79),
    [sym_seh_try_statement] = STATE(79),
    [sym_seh_leave_statement] = STATE(79),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(79),
    [sym_co_return_statement] = STATE(79),
    [sym_co_yield_statement] = STATE(79),
    [sym_throw_statement] = STATE(79),
    [sym_try_statement] = STATE(79),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(79),
    [sym_qualifiers] = STATE(2038),
    [sym_cbuffer_specifier] = STATE(79),
    [sym_hlsl_attribute] = STATE(9743),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_case_statement_repeat1] = STATE(79),
    [sym_identifier] = ACTIONS(1560),
    [aux_sym_preproc_include_token1] = ACTIONS(1562),
    [aux_sym_preproc_def_token1] = ACTIONS(1562),
    [aux_sym_preproc_if_token1] = ACTIONS(1562),
    [aux_sym_preproc_if_token2] = ACTIONS(1562),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1562),
    [aux_sym_preproc_else_token1] = ACTIONS(1562),
    [aux_sym_preproc_elif_token1] = ACTIONS(1562),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1562),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1562),
    [sym_preproc_directive] = ACTIONS(1562),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP_AMP] = ACTIONS(1568),
    [anon_sym_AMP] = ACTIONS(1570),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym___extension__] = ACTIONS(303),
    [anon_sym_typedef] = ACTIONS(305),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1574),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1562),
    [anon_sym___cdecl] = ACTIONS(1562),
    [anon_sym___clrcall] = ACTIONS(1562),
    [anon_sym___stdcall] = ACTIONS(1562),
    [anon_sym___fastcall] = ACTIONS(1562),
    [anon_sym___thiscall] = ACTIONS(1562),
    [anon_sym___vectorcall] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_else] = ACTIONS(1562),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1562),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_explicit] = ACTIONS(1562),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(1562),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(1562),
    [anon_sym_using] = ACTIONS(1562),
    [anon_sym_static_assert] = ACTIONS(1562),
    [anon_sym_concept] = ACTIONS(1562),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(359),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [78] = {
    [sym_declaration] = STATE(78),
    [sym_type_definition] = STATE(78),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6161),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(1319),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_compound_statement] = STATE(78),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(78),
    [sym_labeled_statement] = STATE(78),
    [sym_expression_statement] = STATE(78),
    [sym_if_statement] = STATE(78),
    [sym_switch_statement] = STATE(78),
    [sym_while_statement] = STATE(78),
    [sym_do_statement] = STATE(78),
    [sym_for_statement] = STATE(78),
    [sym_return_statement] = STATE(78),
    [sym_break_statement] = STATE(78),
    [sym_continue_statement] = STATE(78),
    [sym_goto_statement] = STATE(78),
    [sym_seh_try_statement] = STATE(78),
    [sym_seh_leave_statement] = STATE(78),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(78),
    [sym_co_return_statement] = STATE(78),
    [sym_co_yield_statement] = STATE(78),
    [sym_throw_statement] = STATE(78),
    [sym_try_statement] = STATE(78),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(78),
    [sym_qualifiers] = STATE(2038),
    [sym_cbuffer_specifier] = STATE(78),
    [sym_hlsl_attribute] = STATE(9743),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_case_statement_repeat1] = STATE(78),
    [sym_identifier] = ACTIONS(1580),
    [aux_sym_preproc_include_token1] = ACTIONS(1583),
    [aux_sym_preproc_def_token1] = ACTIONS(1583),
    [aux_sym_preproc_if_token1] = ACTIONS(1583),
    [aux_sym_preproc_if_token2] = ACTIONS(1583),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1583),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1583),
    [aux_sym_preproc_else_token1] = ACTIONS(1583),
    [aux_sym_preproc_elif_token1] = ACTIONS(1583),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1583),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1583),
    [sym_preproc_directive] = ACTIONS(1583),
    [anon_sym_LPAREN2] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1588),
    [anon_sym_TILDE] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1594),
    [anon_sym_AMP_AMP] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1599),
    [anon_sym_SEMI] = ACTIONS(1602),
    [anon_sym___extension__] = ACTIONS(1605),
    [anon_sym_typedef] = ACTIONS(1608),
    [anon_sym_in] = ACTIONS(1611),
    [anon_sym_out] = ACTIONS(1611),
    [anon_sym_inout] = ACTIONS(1611),
    [anon_sym_extern] = ACTIONS(1614),
    [anon_sym___attribute__] = ACTIONS(1617),
    [anon_sym_COLON_COLON] = ACTIONS(1620),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1623),
    [anon_sym___declspec] = ACTIONS(1626),
    [anon_sym___based] = ACTIONS(1583),
    [anon_sym___cdecl] = ACTIONS(1583),
    [anon_sym___clrcall] = ACTIONS(1583),
    [anon_sym___stdcall] = ACTIONS(1583),
    [anon_sym___fastcall] = ACTIONS(1583),
    [anon_sym___thiscall] = ACTIONS(1583),
    [anon_sym___vectorcall] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1629),
    [anon_sym_signed] = ACTIONS(1632),
    [anon_sym_unsigned] = ACTIONS(1632),
    [anon_sym_long] = ACTIONS(1632),
    [anon_sym_short] = ACTIONS(1632),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_static] = ACTIONS(1614),
    [anon_sym_register] = ACTIONS(1614),
    [anon_sym_inline] = ACTIONS(1614),
    [anon_sym___inline] = ACTIONS(1614),
    [anon_sym___inline__] = ACTIONS(1614),
    [anon_sym___forceinline] = ACTIONS(1614),
    [anon_sym_thread_local] = ACTIONS(1614),
    [anon_sym___thread] = ACTIONS(1614),
    [anon_sym_const] = ACTIONS(1638),
    [anon_sym_constexpr] = ACTIONS(1638),
    [anon_sym_volatile] = ACTIONS(1638),
    [anon_sym_restrict] = ACTIONS(1638),
    [anon_sym___restrict__] = ACTIONS(1638),
    [anon_sym__Atomic] = ACTIONS(1638),
    [anon_sym__Noreturn] = ACTIONS(1638),
    [anon_sym_noreturn] = ACTIONS(1638),
    [anon_sym_mutable] = ACTIONS(1638),
    [anon_sym_constinit] = ACTIONS(1638),
    [anon_sym_consteval] = ACTIONS(1638),
    [anon_sym_alignas] = ACTIONS(1641),
    [anon_sym__Alignas] = ACTIONS(1641),
    [sym_primitive_type] = ACTIONS(1644),
    [anon_sym_enum] = ACTIONS(1647),
    [anon_sym_class] = ACTIONS(1650),
    [anon_sym_struct] = ACTIONS(1653),
    [anon_sym_union] = ACTIONS(1656),
    [anon_sym_if] = ACTIONS(1659),
    [anon_sym_else] = ACTIONS(1583),
    [anon_sym_switch] = ACTIONS(1662),
    [anon_sym_case] = ACTIONS(1583),
    [anon_sym_default] = ACTIONS(1583),
    [anon_sym_while] = ACTIONS(1665),
    [anon_sym_do] = ACTIONS(1668),
    [anon_sym_for] = ACTIONS(1671),
    [anon_sym_return] = ACTIONS(1674),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1680),
    [anon_sym_goto] = ACTIONS(1683),
    [anon_sym___try] = ACTIONS(1686),
    [anon_sym___leave] = ACTIONS(1689),
    [anon_sym_not] = ACTIONS(1591),
    [anon_sym_compl] = ACTIONS(1591),
    [anon_sym_DASH_DASH] = ACTIONS(1692),
    [anon_sym_PLUS_PLUS] = ACTIONS(1692),
    [anon_sym_sizeof] = ACTIONS(1695),
    [anon_sym___alignof__] = ACTIONS(1698),
    [anon_sym___alignof] = ACTIONS(1698),
    [anon_sym__alignof] = ACTIONS(1698),
    [anon_sym_alignof] = ACTIONS(1698),
    [anon_sym__Alignof] = ACTIONS(1698),
    [anon_sym_offsetof] = ACTIONS(1701),
    [anon_sym__Generic] = ACTIONS(1704),
    [anon_sym_asm] = ACTIONS(1707),
    [anon_sym___asm__] = ACTIONS(1707),
    [sym_number_literal] = ACTIONS(1710),
    [anon_sym_L_SQUOTE] = ACTIONS(1713),
    [anon_sym_u_SQUOTE] = ACTIONS(1713),
    [anon_sym_U_SQUOTE] = ACTIONS(1713),
    [anon_sym_u8_SQUOTE] = ACTIONS(1713),
    [anon_sym_SQUOTE] = ACTIONS(1713),
    [anon_sym_L_DQUOTE] = ACTIONS(1716),
    [anon_sym_u_DQUOTE] = ACTIONS(1716),
    [anon_sym_U_DQUOTE] = ACTIONS(1716),
    [anon_sym_u8_DQUOTE] = ACTIONS(1716),
    [anon_sym_DQUOTE] = ACTIONS(1716),
    [sym_true] = ACTIONS(1719),
    [sym_false] = ACTIONS(1719),
    [anon_sym_NULL] = ACTIONS(1722),
    [anon_sym_nullptr] = ACTIONS(1722),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1725),
    [anon_sym_let] = ACTIONS(1725),
    [anon_sym_This] = ACTIONS(1725),
    [anon_sym_decltype] = ACTIONS(1728),
    [sym_virtual] = ACTIONS(1611),
    [anon_sym_explicit] = ACTIONS(1583),
    [anon_sym_typename] = ACTIONS(1731),
    [anon_sym_template] = ACTIONS(1734),
    [anon_sym_operator] = ACTIONS(1583),
    [anon_sym_try] = ACTIONS(1737),
    [anon_sym_delete] = ACTIONS(1740),
    [anon_sym_throw] = ACTIONS(1743),
    [anon_sym_namespace] = ACTIONS(1583),
    [anon_sym_using] = ACTIONS(1583),
    [anon_sym_static_assert] = ACTIONS(1583),
    [anon_sym_concept] = ACTIONS(1583),
    [anon_sym_co_return] = ACTIONS(1746),
    [anon_sym_co_yield] = ACTIONS(1749),
    [anon_sym_R_DQUOTE] = ACTIONS(1752),
    [anon_sym_LR_DQUOTE] = ACTIONS(1752),
    [anon_sym_uR_DQUOTE] = ACTIONS(1752),
    [anon_sym_UR_DQUOTE] = ACTIONS(1752),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1752),
    [anon_sym_co_await] = ACTIONS(1755),
    [anon_sym_new] = ACTIONS(1758),
    [anon_sym_requires] = ACTIONS(1761),
    [sym_this] = ACTIONS(1719),
    [anon_sym_discard] = ACTIONS(1764),
    [anon_sym_precise] = ACTIONS(1767),
    [anon_sym_shared] = ACTIONS(1767),
    [anon_sym_groupshared] = ACTIONS(1767),
    [anon_sym_uniform] = ACTIONS(1767),
    [anon_sym_row_major] = ACTIONS(1767),
    [anon_sym_column_major] = ACTIONS(1767),
    [anon_sym_globallycoherent] = ACTIONS(1767),
    [anon_sym_centroid] = ACTIONS(1767),
    [anon_sym_noperspective] = ACTIONS(1767),
    [anon_sym_nointerpolation] = ACTIONS(1767),
    [anon_sym_sample] = ACTIONS(1767),
    [anon_sym_linear] = ACTIONS(1767),
    [anon_sym_snorm] = ACTIONS(1767),
    [anon_sym_unorm] = ACTIONS(1767),
    [anon_sym_point] = ACTIONS(1767),
    [anon_sym_line] = ACTIONS(1767),
    [anon_sym_triangleadj] = ACTIONS(1767),
    [anon_sym_lineadj] = ACTIONS(1767),
    [anon_sym_triangle] = ACTIONS(1767),
    [anon_sym_cbuffer] = ACTIONS(1770),
    [anon_sym_interface] = ACTIONS(1773),
    [anon_sym_extension] = ACTIONS(1776),
  },
  [79] = {
    [sym_declaration] = STATE(78),
    [sym_type_definition] = STATE(78),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6161),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(1319),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_compound_statement] = STATE(78),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(78),
    [sym_labeled_statement] = STATE(78),
    [sym_expression_statement] = STATE(78),
    [sym_if_statement] = STATE(78),
    [sym_switch_statement] = STATE(78),
    [sym_while_statement] = STATE(78),
    [sym_do_statement] = STATE(78),
    [sym_for_statement] = STATE(78),
    [sym_return_statement] = STATE(78),
    [sym_break_statement] = STATE(78),
    [sym_continue_statement] = STATE(78),
    [sym_goto_statement] = STATE(78),
    [sym_seh_try_statement] = STATE(78),
    [sym_seh_leave_statement] = STATE(78),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(78),
    [sym_co_return_statement] = STATE(78),
    [sym_co_yield_statement] = STATE(78),
    [sym_throw_statement] = STATE(78),
    [sym_try_statement] = STATE(78),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(78),
    [sym_qualifiers] = STATE(2038),
    [sym_cbuffer_specifier] = STATE(78),
    [sym_hlsl_attribute] = STATE(9743),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_case_statement_repeat1] = STATE(78),
    [sym_identifier] = ACTIONS(1560),
    [aux_sym_preproc_include_token1] = ACTIONS(1779),
    [aux_sym_preproc_def_token1] = ACTIONS(1779),
    [aux_sym_preproc_if_token1] = ACTIONS(1779),
    [aux_sym_preproc_if_token2] = ACTIONS(1779),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1779),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1779),
    [aux_sym_preproc_else_token1] = ACTIONS(1779),
    [aux_sym_preproc_elif_token1] = ACTIONS(1779),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1779),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1779),
    [sym_preproc_directive] = ACTIONS(1779),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP_AMP] = ACTIONS(1781),
    [anon_sym_AMP] = ACTIONS(1570),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym___extension__] = ACTIONS(303),
    [anon_sym_typedef] = ACTIONS(305),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1574),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1779),
    [anon_sym___cdecl] = ACTIONS(1779),
    [anon_sym___clrcall] = ACTIONS(1779),
    [anon_sym___stdcall] = ACTIONS(1779),
    [anon_sym___fastcall] = ACTIONS(1779),
    [anon_sym___thiscall] = ACTIONS(1779),
    [anon_sym___vectorcall] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_else] = ACTIONS(1779),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(1779),
    [anon_sym_default] = ACTIONS(1779),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_explicit] = ACTIONS(1779),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(1779),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(1779),
    [anon_sym_using] = ACTIONS(1779),
    [anon_sym_static_assert] = ACTIONS(1779),
    [anon_sym_concept] = ACTIONS(1779),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(359),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [80] = {
    [sym_declaration] = STATE(81),
    [sym_type_definition] = STATE(81),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6161),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(1319),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_compound_statement] = STATE(81),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(81),
    [sym_labeled_statement] = STATE(81),
    [sym_expression_statement] = STATE(81),
    [sym_if_statement] = STATE(81),
    [sym_switch_statement] = STATE(81),
    [sym_while_statement] = STATE(81),
    [sym_do_statement] = STATE(81),
    [sym_for_statement] = STATE(81),
    [sym_return_statement] = STATE(81),
    [sym_break_statement] = STATE(81),
    [sym_continue_statement] = STATE(81),
    [sym_goto_statement] = STATE(81),
    [sym_seh_try_statement] = STATE(81),
    [sym_seh_leave_statement] = STATE(81),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(81),
    [sym_co_return_statement] = STATE(81),
    [sym_co_yield_statement] = STATE(81),
    [sym_throw_statement] = STATE(81),
    [sym_try_statement] = STATE(81),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(81),
    [sym_qualifiers] = STATE(2038),
    [sym_cbuffer_specifier] = STATE(81),
    [sym_hlsl_attribute] = STATE(9743),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_case_statement_repeat1] = STATE(81),
    [sym_identifier] = ACTIONS(1560),
    [aux_sym_preproc_include_token1] = ACTIONS(1783),
    [aux_sym_preproc_def_token1] = ACTIONS(1783),
    [aux_sym_preproc_if_token1] = ACTIONS(1783),
    [aux_sym_preproc_if_token2] = ACTIONS(1783),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1783),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1783),
    [aux_sym_preproc_else_token1] = ACTIONS(1783),
    [aux_sym_preproc_elif_token1] = ACTIONS(1783),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1783),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1783),
    [sym_preproc_directive] = ACTIONS(1783),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP_AMP] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1570),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym___extension__] = ACTIONS(303),
    [anon_sym_typedef] = ACTIONS(305),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1574),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1783),
    [anon_sym___cdecl] = ACTIONS(1783),
    [anon_sym___clrcall] = ACTIONS(1783),
    [anon_sym___stdcall] = ACTIONS(1783),
    [anon_sym___fastcall] = ACTIONS(1783),
    [anon_sym___thiscall] = ACTIONS(1783),
    [anon_sym___vectorcall] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_else] = ACTIONS(1783),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(1783),
    [anon_sym_default] = ACTIONS(1783),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_explicit] = ACTIONS(1783),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(1783),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(1783),
    [anon_sym_using] = ACTIONS(1783),
    [anon_sym_static_assert] = ACTIONS(1783),
    [anon_sym_concept] = ACTIONS(1783),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(359),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [81] = {
    [sym_declaration] = STATE(78),
    [sym_type_definition] = STATE(78),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6161),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(1319),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_compound_statement] = STATE(78),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(78),
    [sym_labeled_statement] = STATE(78),
    [sym_expression_statement] = STATE(78),
    [sym_if_statement] = STATE(78),
    [sym_switch_statement] = STATE(78),
    [sym_while_statement] = STATE(78),
    [sym_do_statement] = STATE(78),
    [sym_for_statement] = STATE(78),
    [sym_return_statement] = STATE(78),
    [sym_break_statement] = STATE(78),
    [sym_continue_statement] = STATE(78),
    [sym_goto_statement] = STATE(78),
    [sym_seh_try_statement] = STATE(78),
    [sym_seh_leave_statement] = STATE(78),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(78),
    [sym_co_return_statement] = STATE(78),
    [sym_co_yield_statement] = STATE(78),
    [sym_throw_statement] = STATE(78),
    [sym_try_statement] = STATE(78),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(78),
    [sym_qualifiers] = STATE(2038),
    [sym_cbuffer_specifier] = STATE(78),
    [sym_hlsl_attribute] = STATE(9743),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_case_statement_repeat1] = STATE(78),
    [sym_identifier] = ACTIONS(1560),
    [aux_sym_preproc_include_token1] = ACTIONS(1787),
    [aux_sym_preproc_def_token1] = ACTIONS(1787),
    [aux_sym_preproc_if_token1] = ACTIONS(1787),
    [aux_sym_preproc_if_token2] = ACTIONS(1787),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1787),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1787),
    [aux_sym_preproc_else_token1] = ACTIONS(1787),
    [aux_sym_preproc_elif_token1] = ACTIONS(1787),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1787),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1787),
    [sym_preproc_directive] = ACTIONS(1787),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP_AMP] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1570),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym___extension__] = ACTIONS(303),
    [anon_sym_typedef] = ACTIONS(305),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1574),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1787),
    [anon_sym___cdecl] = ACTIONS(1787),
    [anon_sym___clrcall] = ACTIONS(1787),
    [anon_sym___stdcall] = ACTIONS(1787),
    [anon_sym___fastcall] = ACTIONS(1787),
    [anon_sym___thiscall] = ACTIONS(1787),
    [anon_sym___vectorcall] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_else] = ACTIONS(1787),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(1787),
    [anon_sym_default] = ACTIONS(1787),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_explicit] = ACTIONS(1787),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(1787),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1787),
    [anon_sym_static_assert] = ACTIONS(1787),
    [anon_sym_concept] = ACTIONS(1787),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(359),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [82] = {
    [sym_declaration] = STATE(84),
    [sym_type_definition] = STATE(84),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6181),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(1319),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_compound_statement] = STATE(84),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(84),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(5434),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10523),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(84),
    [sym_co_return_statement] = STATE(84),
    [sym_co_yield_statement] = STATE(84),
    [sym_throw_statement] = STATE(84),
    [sym_try_statement] = STATE(84),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(84),
    [sym_qualifiers] = STATE(2038),
    [sym_cbuffer_specifier] = STATE(84),
    [sym_hlsl_attribute] = STATE(10015),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1102),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_case_statement_repeat1] = STATE(84),
    [ts_builtin_sym_end] = ACTIONS(1785),
    [sym_identifier] = ACTIONS(1791),
    [aux_sym_preproc_include_token1] = ACTIONS(1783),
    [aux_sym_preproc_def_token1] = ACTIONS(1783),
    [aux_sym_preproc_if_token1] = ACTIONS(1783),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1783),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1783),
    [sym_preproc_directive] = ACTIONS(1783),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP_AMP] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1570),
    [anon_sym_SEMI] = ACTIONS(1793),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1574),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1783),
    [anon_sym___cdecl] = ACTIONS(1783),
    [anon_sym___clrcall] = ACTIONS(1783),
    [anon_sym___stdcall] = ACTIONS(1783),
    [anon_sym___fastcall] = ACTIONS(1783),
    [anon_sym___thiscall] = ACTIONS(1783),
    [anon_sym___vectorcall] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_else] = ACTIONS(1783),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(1783),
    [anon_sym_default] = ACTIONS(1783),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(1795),
    [anon_sym___leave] = ACTIONS(1797),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_explicit] = ACTIONS(1783),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(1783),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_namespace] = ACTIONS(1783),
    [anon_sym_using] = ACTIONS(1783),
    [anon_sym_static_assert] = ACTIONS(1783),
    [anon_sym_concept] = ACTIONS(1783),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1799),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(1801),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
    [anon_sym___exported] = ACTIONS(1783),
    [anon_sym_import] = ACTIONS(1783),
  },
  [83] = {
    [sym_declaration] = STATE(83),
    [sym_type_definition] = STATE(83),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6181),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(1319),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_compound_statement] = STATE(83),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(83),
    [sym_labeled_statement] = STATE(83),
    [sym_expression_statement] = STATE(83),
    [sym_if_statement] = STATE(83),
    [sym_switch_statement] = STATE(83),
    [sym_while_statement] = STATE(83),
    [sym_do_statement] = STATE(83),
    [sym_for_statement] = STATE(83),
    [sym_return_statement] = STATE(83),
    [sym_break_statement] = STATE(83),
    [sym_continue_statement] = STATE(83),
    [sym_goto_statement] = STATE(83),
    [sym_seh_try_statement] = STATE(83),
    [sym_seh_leave_statement] = STATE(83),
    [sym_expression] = STATE(5434),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10523),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(83),
    [sym_co_return_statement] = STATE(83),
    [sym_co_yield_statement] = STATE(83),
    [sym_throw_statement] = STATE(83),
    [sym_try_statement] = STATE(83),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(83),
    [sym_qualifiers] = STATE(2038),
    [sym_cbuffer_specifier] = STATE(83),
    [sym_hlsl_attribute] = STATE(10015),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1102),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_case_statement_repeat1] = STATE(83),
    [ts_builtin_sym_end] = ACTIONS(1597),
    [sym_identifier] = ACTIONS(1803),
    [aux_sym_preproc_include_token1] = ACTIONS(1583),
    [aux_sym_preproc_def_token1] = ACTIONS(1583),
    [aux_sym_preproc_if_token1] = ACTIONS(1583),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1583),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1583),
    [sym_preproc_directive] = ACTIONS(1583),
    [anon_sym_LPAREN2] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1588),
    [anon_sym_TILDE] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1594),
    [anon_sym_AMP_AMP] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1599),
    [anon_sym_SEMI] = ACTIONS(1806),
    [anon_sym___extension__] = ACTIONS(1809),
    [anon_sym_typedef] = ACTIONS(1812),
    [anon_sym_in] = ACTIONS(1611),
    [anon_sym_out] = ACTIONS(1611),
    [anon_sym_inout] = ACTIONS(1611),
    [anon_sym_extern] = ACTIONS(1614),
    [anon_sym___attribute__] = ACTIONS(1617),
    [anon_sym_COLON_COLON] = ACTIONS(1620),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1623),
    [anon_sym___declspec] = ACTIONS(1626),
    [anon_sym___based] = ACTIONS(1583),
    [anon_sym___cdecl] = ACTIONS(1583),
    [anon_sym___clrcall] = ACTIONS(1583),
    [anon_sym___stdcall] = ACTIONS(1583),
    [anon_sym___fastcall] = ACTIONS(1583),
    [anon_sym___thiscall] = ACTIONS(1583),
    [anon_sym___vectorcall] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1815),
    [anon_sym_signed] = ACTIONS(1632),
    [anon_sym_unsigned] = ACTIONS(1632),
    [anon_sym_long] = ACTIONS(1632),
    [anon_sym_short] = ACTIONS(1632),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_static] = ACTIONS(1614),
    [anon_sym_register] = ACTIONS(1614),
    [anon_sym_inline] = ACTIONS(1614),
    [anon_sym___inline] = ACTIONS(1614),
    [anon_sym___inline__] = ACTIONS(1614),
    [anon_sym___forceinline] = ACTIONS(1614),
    [anon_sym_thread_local] = ACTIONS(1614),
    [anon_sym___thread] = ACTIONS(1614),
    [anon_sym_const] = ACTIONS(1638),
    [anon_sym_constexpr] = ACTIONS(1638),
    [anon_sym_volatile] = ACTIONS(1638),
    [anon_sym_restrict] = ACTIONS(1638),
    [anon_sym___restrict__] = ACTIONS(1638),
    [anon_sym__Atomic] = ACTIONS(1638),
    [anon_sym__Noreturn] = ACTIONS(1638),
    [anon_sym_noreturn] = ACTIONS(1638),
    [anon_sym_mutable] = ACTIONS(1638),
    [anon_sym_constinit] = ACTIONS(1638),
    [anon_sym_consteval] = ACTIONS(1638),
    [anon_sym_alignas] = ACTIONS(1641),
    [anon_sym__Alignas] = ACTIONS(1641),
    [sym_primitive_type] = ACTIONS(1644),
    [anon_sym_enum] = ACTIONS(1647),
    [anon_sym_class] = ACTIONS(1650),
    [anon_sym_struct] = ACTIONS(1653),
    [anon_sym_union] = ACTIONS(1656),
    [anon_sym_if] = ACTIONS(1818),
    [anon_sym_else] = ACTIONS(1583),
    [anon_sym_switch] = ACTIONS(1821),
    [anon_sym_case] = ACTIONS(1583),
    [anon_sym_default] = ACTIONS(1583),
    [anon_sym_while] = ACTIONS(1824),
    [anon_sym_do] = ACTIONS(1827),
    [anon_sym_for] = ACTIONS(1830),
    [anon_sym_return] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1836),
    [anon_sym_continue] = ACTIONS(1839),
    [anon_sym_goto] = ACTIONS(1842),
    [anon_sym___try] = ACTIONS(1845),
    [anon_sym___leave] = ACTIONS(1848),
    [anon_sym_not] = ACTIONS(1591),
    [anon_sym_compl] = ACTIONS(1591),
    [anon_sym_DASH_DASH] = ACTIONS(1692),
    [anon_sym_PLUS_PLUS] = ACTIONS(1692),
    [anon_sym_sizeof] = ACTIONS(1695),
    [anon_sym___alignof__] = ACTIONS(1698),
    [anon_sym___alignof] = ACTIONS(1698),
    [anon_sym__alignof] = ACTIONS(1698),
    [anon_sym_alignof] = ACTIONS(1698),
    [anon_sym__Alignof] = ACTIONS(1698),
    [anon_sym_offsetof] = ACTIONS(1701),
    [anon_sym__Generic] = ACTIONS(1704),
    [anon_sym_asm] = ACTIONS(1707),
    [anon_sym___asm__] = ACTIONS(1707),
    [sym_number_literal] = ACTIONS(1710),
    [anon_sym_L_SQUOTE] = ACTIONS(1713),
    [anon_sym_u_SQUOTE] = ACTIONS(1713),
    [anon_sym_U_SQUOTE] = ACTIONS(1713),
    [anon_sym_u8_SQUOTE] = ACTIONS(1713),
    [anon_sym_SQUOTE] = ACTIONS(1713),
    [anon_sym_L_DQUOTE] = ACTIONS(1716),
    [anon_sym_u_DQUOTE] = ACTIONS(1716),
    [anon_sym_U_DQUOTE] = ACTIONS(1716),
    [anon_sym_u8_DQUOTE] = ACTIONS(1716),
    [anon_sym_DQUOTE] = ACTIONS(1716),
    [sym_true] = ACTIONS(1719),
    [sym_false] = ACTIONS(1719),
    [anon_sym_NULL] = ACTIONS(1722),
    [anon_sym_nullptr] = ACTIONS(1722),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1725),
    [anon_sym_let] = ACTIONS(1725),
    [anon_sym_This] = ACTIONS(1725),
    [anon_sym_decltype] = ACTIONS(1728),
    [sym_virtual] = ACTIONS(1611),
    [anon_sym_explicit] = ACTIONS(1583),
    [anon_sym_typename] = ACTIONS(1731),
    [anon_sym_template] = ACTIONS(1734),
    [anon_sym_operator] = ACTIONS(1583),
    [anon_sym_try] = ACTIONS(1851),
    [anon_sym_delete] = ACTIONS(1740),
    [anon_sym_throw] = ACTIONS(1854),
    [anon_sym_namespace] = ACTIONS(1583),
    [anon_sym_using] = ACTIONS(1583),
    [anon_sym_static_assert] = ACTIONS(1583),
    [anon_sym_concept] = ACTIONS(1583),
    [anon_sym_co_return] = ACTIONS(1857),
    [anon_sym_co_yield] = ACTIONS(1860),
    [anon_sym_R_DQUOTE] = ACTIONS(1752),
    [anon_sym_LR_DQUOTE] = ACTIONS(1752),
    [anon_sym_uR_DQUOTE] = ACTIONS(1752),
    [anon_sym_UR_DQUOTE] = ACTIONS(1752),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1752),
    [anon_sym_co_await] = ACTIONS(1755),
    [anon_sym_new] = ACTIONS(1758),
    [anon_sym_requires] = ACTIONS(1761),
    [sym_this] = ACTIONS(1719),
    [anon_sym_discard] = ACTIONS(1863),
    [anon_sym_precise] = ACTIONS(1767),
    [anon_sym_shared] = ACTIONS(1767),
    [anon_sym_groupshared] = ACTIONS(1767),
    [anon_sym_uniform] = ACTIONS(1767),
    [anon_sym_row_major] = ACTIONS(1767),
    [anon_sym_column_major] = ACTIONS(1767),
    [anon_sym_globallycoherent] = ACTIONS(1767),
    [anon_sym_centroid] = ACTIONS(1767),
    [anon_sym_noperspective] = ACTIONS(1767),
    [anon_sym_nointerpolation] = ACTIONS(1767),
    [anon_sym_sample] = ACTIONS(1767),
    [anon_sym_linear] = ACTIONS(1767),
    [anon_sym_snorm] = ACTIONS(1767),
    [anon_sym_unorm] = ACTIONS(1767),
    [anon_sym_point] = ACTIONS(1767),
    [anon_sym_line] = ACTIONS(1767),
    [anon_sym_triangleadj] = ACTIONS(1767),
    [anon_sym_lineadj] = ACTIONS(1767),
    [anon_sym_triangle] = ACTIONS(1767),
    [anon_sym_cbuffer] = ACTIONS(1866),
    [anon_sym_interface] = ACTIONS(1773),
    [anon_sym_extension] = ACTIONS(1776),
    [anon_sym___exported] = ACTIONS(1583),
    [anon_sym_import] = ACTIONS(1583),
  },
  [84] = {
    [sym_declaration] = STATE(83),
    [sym_type_definition] = STATE(83),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6181),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(1319),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_compound_statement] = STATE(83),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(83),
    [sym_labeled_statement] = STATE(83),
    [sym_expression_statement] = STATE(83),
    [sym_if_statement] = STATE(83),
    [sym_switch_statement] = STATE(83),
    [sym_while_statement] = STATE(83),
    [sym_do_statement] = STATE(83),
    [sym_for_statement] = STATE(83),
    [sym_return_statement] = STATE(83),
    [sym_break_statement] = STATE(83),
    [sym_continue_statement] = STATE(83),
    [sym_goto_statement] = STATE(83),
    [sym_seh_try_statement] = STATE(83),
    [sym_seh_leave_statement] = STATE(83),
    [sym_expression] = STATE(5434),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10523),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(83),
    [sym_co_return_statement] = STATE(83),
    [sym_co_yield_statement] = STATE(83),
    [sym_throw_statement] = STATE(83),
    [sym_try_statement] = STATE(83),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(83),
    [sym_qualifiers] = STATE(2038),
    [sym_cbuffer_specifier] = STATE(83),
    [sym_hlsl_attribute] = STATE(10015),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1102),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_case_statement_repeat1] = STATE(83),
    [ts_builtin_sym_end] = ACTIONS(1789),
    [sym_identifier] = ACTIONS(1791),
    [aux_sym_preproc_include_token1] = ACTIONS(1787),
    [aux_sym_preproc_def_token1] = ACTIONS(1787),
    [aux_sym_preproc_if_token1] = ACTIONS(1787),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1787),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1787),
    [sym_preproc_directive] = ACTIONS(1787),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP_AMP] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1570),
    [anon_sym_SEMI] = ACTIONS(1793),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1574),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1787),
    [anon_sym___cdecl] = ACTIONS(1787),
    [anon_sym___clrcall] = ACTIONS(1787),
    [anon_sym___stdcall] = ACTIONS(1787),
    [anon_sym___fastcall] = ACTIONS(1787),
    [anon_sym___thiscall] = ACTIONS(1787),
    [anon_sym___vectorcall] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_else] = ACTIONS(1787),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(1787),
    [anon_sym_default] = ACTIONS(1787),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(1795),
    [anon_sym___leave] = ACTIONS(1797),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_explicit] = ACTIONS(1787),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(1787),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_namespace] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1787),
    [anon_sym_static_assert] = ACTIONS(1787),
    [anon_sym_concept] = ACTIONS(1787),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1799),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(1801),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
    [anon_sym___exported] = ACTIONS(1787),
    [anon_sym_import] = ACTIONS(1787),
  },
  [85] = {
    [sym_declaration] = STATE(86),
    [sym_type_definition] = STATE(86),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6181),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(1319),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_compound_statement] = STATE(86),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(86),
    [sym_labeled_statement] = STATE(86),
    [sym_expression_statement] = STATE(86),
    [sym_if_statement] = STATE(86),
    [sym_switch_statement] = STATE(86),
    [sym_while_statement] = STATE(86),
    [sym_do_statement] = STATE(86),
    [sym_for_statement] = STATE(86),
    [sym_return_statement] = STATE(86),
    [sym_break_statement] = STATE(86),
    [sym_continue_statement] = STATE(86),
    [sym_goto_statement] = STATE(86),
    [sym_seh_try_statement] = STATE(86),
    [sym_seh_leave_statement] = STATE(86),
    [sym_expression] = STATE(5434),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10523),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(86),
    [sym_co_return_statement] = STATE(86),
    [sym_co_yield_statement] = STATE(86),
    [sym_throw_statement] = STATE(86),
    [sym_try_statement] = STATE(86),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(86),
    [sym_qualifiers] = STATE(2038),
    [sym_cbuffer_specifier] = STATE(86),
    [sym_hlsl_attribute] = STATE(10015),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1102),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_case_statement_repeat1] = STATE(86),
    [ts_builtin_sym_end] = ACTIONS(1568),
    [sym_identifier] = ACTIONS(1791),
    [aux_sym_preproc_include_token1] = ACTIONS(1562),
    [aux_sym_preproc_def_token1] = ACTIONS(1562),
    [aux_sym_preproc_if_token1] = ACTIONS(1562),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1562),
    [sym_preproc_directive] = ACTIONS(1562),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP_AMP] = ACTIONS(1568),
    [anon_sym_AMP] = ACTIONS(1570),
    [anon_sym_SEMI] = ACTIONS(1793),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1574),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1562),
    [anon_sym___cdecl] = ACTIONS(1562),
    [anon_sym___clrcall] = ACTIONS(1562),
    [anon_sym___stdcall] = ACTIONS(1562),
    [anon_sym___fastcall] = ACTIONS(1562),
    [anon_sym___thiscall] = ACTIONS(1562),
    [anon_sym___vectorcall] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_else] = ACTIONS(1562),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1562),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(1795),
    [anon_sym___leave] = ACTIONS(1797),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_explicit] = ACTIONS(1562),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(1562),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_namespace] = ACTIONS(1562),
    [anon_sym_using] = ACTIONS(1562),
    [anon_sym_static_assert] = ACTIONS(1562),
    [anon_sym_concept] = ACTIONS(1562),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1799),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(1801),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
    [anon_sym___exported] = ACTIONS(1562),
    [anon_sym_import] = ACTIONS(1562),
  },
  [86] = {
    [sym_declaration] = STATE(83),
    [sym_type_definition] = STATE(83),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6181),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(1319),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_compound_statement] = STATE(83),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(83),
    [sym_labeled_statement] = STATE(83),
    [sym_expression_statement] = STATE(83),
    [sym_if_statement] = STATE(83),
    [sym_switch_statement] = STATE(83),
    [sym_while_statement] = STATE(83),
    [sym_do_statement] = STATE(83),
    [sym_for_statement] = STATE(83),
    [sym_return_statement] = STATE(83),
    [sym_break_statement] = STATE(83),
    [sym_continue_statement] = STATE(83),
    [sym_goto_statement] = STATE(83),
    [sym_seh_try_statement] = STATE(83),
    [sym_seh_leave_statement] = STATE(83),
    [sym_expression] = STATE(5434),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10523),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(83),
    [sym_co_return_statement] = STATE(83),
    [sym_co_yield_statement] = STATE(83),
    [sym_throw_statement] = STATE(83),
    [sym_try_statement] = STATE(83),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(83),
    [sym_qualifiers] = STATE(2038),
    [sym_cbuffer_specifier] = STATE(83),
    [sym_hlsl_attribute] = STATE(10015),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1102),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_case_statement_repeat1] = STATE(83),
    [ts_builtin_sym_end] = ACTIONS(1781),
    [sym_identifier] = ACTIONS(1791),
    [aux_sym_preproc_include_token1] = ACTIONS(1779),
    [aux_sym_preproc_def_token1] = ACTIONS(1779),
    [aux_sym_preproc_if_token1] = ACTIONS(1779),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1779),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1779),
    [sym_preproc_directive] = ACTIONS(1779),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP_AMP] = ACTIONS(1781),
    [anon_sym_AMP] = ACTIONS(1570),
    [anon_sym_SEMI] = ACTIONS(1793),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1574),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1779),
    [anon_sym___cdecl] = ACTIONS(1779),
    [anon_sym___clrcall] = ACTIONS(1779),
    [anon_sym___stdcall] = ACTIONS(1779),
    [anon_sym___fastcall] = ACTIONS(1779),
    [anon_sym___thiscall] = ACTIONS(1779),
    [anon_sym___vectorcall] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_else] = ACTIONS(1779),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(1779),
    [anon_sym_default] = ACTIONS(1779),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(1795),
    [anon_sym___leave] = ACTIONS(1797),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_explicit] = ACTIONS(1779),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(1779),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_namespace] = ACTIONS(1779),
    [anon_sym_using] = ACTIONS(1779),
    [anon_sym_static_assert] = ACTIONS(1779),
    [anon_sym_concept] = ACTIONS(1779),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1799),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(1801),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
    [anon_sym___exported] = ACTIONS(1779),
    [anon_sym_import] = ACTIONS(1779),
  },
  [87] = {
    [sym_declaration] = STATE(89),
    [sym_type_definition] = STATE(89),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6179),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(1319),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_compound_statement] = STATE(89),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(89),
    [sym_labeled_statement] = STATE(89),
    [sym_expression_statement] = STATE(89),
    [sym_if_statement] = STATE(89),
    [sym_switch_statement] = STATE(89),
    [sym_while_statement] = STATE(89),
    [sym_do_statement] = STATE(89),
    [sym_for_statement] = STATE(89),
    [sym_return_statement] = STATE(89),
    [sym_break_statement] = STATE(89),
    [sym_continue_statement] = STATE(89),
    [sym_goto_statement] = STATE(89),
    [sym_seh_try_statement] = STATE(89),
    [sym_seh_leave_statement] = STATE(89),
    [sym_expression] = STATE(5465),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10896),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(89),
    [sym_co_return_statement] = STATE(89),
    [sym_co_yield_statement] = STATE(89),
    [sym_throw_statement] = STATE(89),
    [sym_try_statement] = STATE(89),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(89),
    [sym_qualifiers] = STATE(2038),
    [sym_cbuffer_specifier] = STATE(89),
    [sym_hlsl_attribute] = STATE(9939),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1148),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_case_statement_repeat1] = STATE(89),
    [sym_identifier] = ACTIONS(1869),
    [aux_sym_preproc_include_token1] = ACTIONS(1783),
    [aux_sym_preproc_def_token1] = ACTIONS(1783),
    [aux_sym_preproc_if_token1] = ACTIONS(1783),
    [aux_sym_preproc_if_token2] = ACTIONS(1783),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1783),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1783),
    [sym_preproc_directive] = ACTIONS(1783),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP_AMP] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1570),
    [anon_sym_SEMI] = ACTIONS(1211),
    [anon_sym___extension__] = ACTIONS(1213),
    [anon_sym_typedef] = ACTIONS(1215),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1574),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1783),
    [anon_sym___cdecl] = ACTIONS(1783),
    [anon_sym___clrcall] = ACTIONS(1783),
    [anon_sym___stdcall] = ACTIONS(1783),
    [anon_sym___fastcall] = ACTIONS(1783),
    [anon_sym___thiscall] = ACTIONS(1783),
    [anon_sym___vectorcall] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(1219),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1783),
    [anon_sym_switch] = ACTIONS(1225),
    [anon_sym_case] = ACTIONS(1783),
    [anon_sym_default] = ACTIONS(1783),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_do] = ACTIONS(1233),
    [anon_sym_for] = ACTIONS(1235),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1239),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_goto] = ACTIONS(1243),
    [anon_sym___try] = ACTIONS(1245),
    [anon_sym___leave] = ACTIONS(1247),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_explicit] = ACTIONS(1783),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(1783),
    [anon_sym_try] = ACTIONS(1251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(1253),
    [anon_sym_namespace] = ACTIONS(1783),
    [anon_sym_using] = ACTIONS(1783),
    [anon_sym_static_assert] = ACTIONS(1783),
    [anon_sym_concept] = ACTIONS(1783),
    [anon_sym_co_return] = ACTIONS(1263),
    [anon_sym_co_yield] = ACTIONS(1265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(1269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [88] = {
    [sym_declaration] = STATE(94),
    [sym_type_definition] = STATE(94),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6162),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(1319),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_compound_statement] = STATE(94),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(94),
    [sym_labeled_statement] = STATE(94),
    [sym_expression_statement] = STATE(94),
    [sym_if_statement] = STATE(94),
    [sym_switch_statement] = STATE(94),
    [sym_while_statement] = STATE(94),
    [sym_do_statement] = STATE(94),
    [sym_for_statement] = STATE(94),
    [sym_return_statement] = STATE(94),
    [sym_break_statement] = STATE(94),
    [sym_continue_statement] = STATE(94),
    [sym_goto_statement] = STATE(94),
    [sym_seh_try_statement] = STATE(94),
    [sym_seh_leave_statement] = STATE(94),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(94),
    [sym_co_return_statement] = STATE(94),
    [sym_co_yield_statement] = STATE(94),
    [sym_throw_statement] = STATE(94),
    [sym_try_statement] = STATE(94),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(94),
    [sym_qualifiers] = STATE(2038),
    [sym_cbuffer_specifier] = STATE(94),
    [sym_hlsl_attribute] = STATE(9709),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_case_statement_repeat1] = STATE(94),
    [sym_identifier] = ACTIONS(1871),
    [aux_sym_preproc_include_token1] = ACTIONS(1562),
    [aux_sym_preproc_def_token1] = ACTIONS(1562),
    [aux_sym_preproc_if_token1] = ACTIONS(1562),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1562),
    [sym_preproc_directive] = ACTIONS(1562),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP_AMP] = ACTIONS(1568),
    [anon_sym_AMP] = ACTIONS(1570),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1574),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1562),
    [anon_sym___cdecl] = ACTIONS(1562),
    [anon_sym___clrcall] = ACTIONS(1562),
    [anon_sym___stdcall] = ACTIONS(1562),
    [anon_sym___fastcall] = ACTIONS(1562),
    [anon_sym___thiscall] = ACTIONS(1562),
    [anon_sym___vectorcall] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1568),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_else] = ACTIONS(1562),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1562),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_explicit] = ACTIONS(1562),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(1562),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(1562),
    [anon_sym_using] = ACTIONS(1562),
    [anon_sym_static_assert] = ACTIONS(1562),
    [anon_sym_concept] = ACTIONS(1562),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [89] = {
    [sym_declaration] = STATE(91),
    [sym_type_definition] = STATE(91),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6179),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(1319),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_compound_statement] = STATE(91),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(91),
    [sym_labeled_statement] = STATE(91),
    [sym_expression_statement] = STATE(91),
    [sym_if_statement] = STATE(91),
    [sym_switch_statement] = STATE(91),
    [sym_while_statement] = STATE(91),
    [sym_do_statement] = STATE(91),
    [sym_for_statement] = STATE(91),
    [sym_return_statement] = STATE(91),
    [sym_break_statement] = STATE(91),
    [sym_continue_statement] = STATE(91),
    [sym_goto_statement] = STATE(91),
    [sym_seh_try_statement] = STATE(91),
    [sym_seh_leave_statement] = STATE(91),
    [sym_expression] = STATE(5465),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10896),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(91),
    [sym_co_return_statement] = STATE(91),
    [sym_co_yield_statement] = STATE(91),
    [sym_throw_statement] = STATE(91),
    [sym_try_statement] = STATE(91),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(91),
    [sym_qualifiers] = STATE(2038),
    [sym_cbuffer_specifier] = STATE(91),
    [sym_hlsl_attribute] = STATE(9939),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1148),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_case_statement_repeat1] = STATE(91),
    [sym_identifier] = ACTIONS(1869),
    [aux_sym_preproc_include_token1] = ACTIONS(1787),
    [aux_sym_preproc_def_token1] = ACTIONS(1787),
    [aux_sym_preproc_if_token1] = ACTIONS(1787),
    [aux_sym_preproc_if_token2] = ACTIONS(1787),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1787),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1787),
    [sym_preproc_directive] = ACTIONS(1787),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP_AMP] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1570),
    [anon_sym_SEMI] = ACTIONS(1211),
    [anon_sym___extension__] = ACTIONS(1213),
    [anon_sym_typedef] = ACTIONS(1215),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1574),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1787),
    [anon_sym___cdecl] = ACTIONS(1787),
    [anon_sym___clrcall] = ACTIONS(1787),
    [anon_sym___stdcall] = ACTIONS(1787),
    [anon_sym___fastcall] = ACTIONS(1787),
    [anon_sym___thiscall] = ACTIONS(1787),
    [anon_sym___vectorcall] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(1219),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1787),
    [anon_sym_switch] = ACTIONS(1225),
    [anon_sym_case] = ACTIONS(1787),
    [anon_sym_default] = ACTIONS(1787),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_do] = ACTIONS(1233),
    [anon_sym_for] = ACTIONS(1235),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1239),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_goto] = ACTIONS(1243),
    [anon_sym___try] = ACTIONS(1245),
    [anon_sym___leave] = ACTIONS(1247),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_explicit] = ACTIONS(1787),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(1787),
    [anon_sym_try] = ACTIONS(1251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(1253),
    [anon_sym_namespace] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1787),
    [anon_sym_static_assert] = ACTIONS(1787),
    [anon_sym_concept] = ACTIONS(1787),
    [anon_sym_co_return] = ACTIONS(1263),
    [anon_sym_co_yield] = ACTIONS(1265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(1269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [90] = {
    [sym_declaration] = STATE(95),
    [sym_type_definition] = STATE(95),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6162),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(1319),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_compound_statement] = STATE(95),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(95),
    [sym_labeled_statement] = STATE(95),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_switch_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_goto_statement] = STATE(95),
    [sym_seh_try_statement] = STATE(95),
    [sym_seh_leave_statement] = STATE(95),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(95),
    [sym_co_return_statement] = STATE(95),
    [sym_co_yield_statement] = STATE(95),
    [sym_throw_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(95),
    [sym_qualifiers] = STATE(2038),
    [sym_cbuffer_specifier] = STATE(95),
    [sym_hlsl_attribute] = STATE(9709),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_case_statement_repeat1] = STATE(95),
    [sym_identifier] = ACTIONS(1871),
    [aux_sym_preproc_include_token1] = ACTIONS(1787),
    [aux_sym_preproc_def_token1] = ACTIONS(1787),
    [aux_sym_preproc_if_token1] = ACTIONS(1787),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1787),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1787),
    [sym_preproc_directive] = ACTIONS(1787),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP_AMP] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1570),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1574),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1787),
    [anon_sym___cdecl] = ACTIONS(1787),
    [anon_sym___clrcall] = ACTIONS(1787),
    [anon_sym___stdcall] = ACTIONS(1787),
    [anon_sym___fastcall] = ACTIONS(1787),
    [anon_sym___thiscall] = ACTIONS(1787),
    [anon_sym___vectorcall] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1789),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_else] = ACTIONS(1787),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(1787),
    [anon_sym_default] = ACTIONS(1787),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_explicit] = ACTIONS(1787),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(1787),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1787),
    [anon_sym_static_assert] = ACTIONS(1787),
    [anon_sym_concept] = ACTIONS(1787),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [91] = {
    [sym_declaration] = STATE(91),
    [sym_type_definition] = STATE(91),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6179),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(1319),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_compound_statement] = STATE(91),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(91),
    [sym_labeled_statement] = STATE(91),
    [sym_expression_statement] = STATE(91),
    [sym_if_statement] = STATE(91),
    [sym_switch_statement] = STATE(91),
    [sym_while_statement] = STATE(91),
    [sym_do_statement] = STATE(91),
    [sym_for_statement] = STATE(91),
    [sym_return_statement] = STATE(91),
    [sym_break_statement] = STATE(91),
    [sym_continue_statement] = STATE(91),
    [sym_goto_statement] = STATE(91),
    [sym_seh_try_statement] = STATE(91),
    [sym_seh_leave_statement] = STATE(91),
    [sym_expression] = STATE(5465),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10896),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(91),
    [sym_co_return_statement] = STATE(91),
    [sym_co_yield_statement] = STATE(91),
    [sym_throw_statement] = STATE(91),
    [sym_try_statement] = STATE(91),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(91),
    [sym_qualifiers] = STATE(2038),
    [sym_cbuffer_specifier] = STATE(91),
    [sym_hlsl_attribute] = STATE(9939),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1148),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_case_statement_repeat1] = STATE(91),
    [sym_identifier] = ACTIONS(1873),
    [aux_sym_preproc_include_token1] = ACTIONS(1583),
    [aux_sym_preproc_def_token1] = ACTIONS(1583),
    [aux_sym_preproc_if_token1] = ACTIONS(1583),
    [aux_sym_preproc_if_token2] = ACTIONS(1583),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1583),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1583),
    [sym_preproc_directive] = ACTIONS(1583),
    [anon_sym_LPAREN2] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1588),
    [anon_sym_TILDE] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1594),
    [anon_sym_AMP_AMP] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1599),
    [anon_sym_SEMI] = ACTIONS(1876),
    [anon_sym___extension__] = ACTIONS(1879),
    [anon_sym_typedef] = ACTIONS(1882),
    [anon_sym_in] = ACTIONS(1611),
    [anon_sym_out] = ACTIONS(1611),
    [anon_sym_inout] = ACTIONS(1611),
    [anon_sym_extern] = ACTIONS(1614),
    [anon_sym___attribute__] = ACTIONS(1617),
    [anon_sym_COLON_COLON] = ACTIONS(1620),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1623),
    [anon_sym___declspec] = ACTIONS(1626),
    [anon_sym___based] = ACTIONS(1583),
    [anon_sym___cdecl] = ACTIONS(1583),
    [anon_sym___clrcall] = ACTIONS(1583),
    [anon_sym___stdcall] = ACTIONS(1583),
    [anon_sym___fastcall] = ACTIONS(1583),
    [anon_sym___thiscall] = ACTIONS(1583),
    [anon_sym___vectorcall] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1885),
    [anon_sym_signed] = ACTIONS(1632),
    [anon_sym_unsigned] = ACTIONS(1632),
    [anon_sym_long] = ACTIONS(1632),
    [anon_sym_short] = ACTIONS(1632),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_static] = ACTIONS(1614),
    [anon_sym_register] = ACTIONS(1614),
    [anon_sym_inline] = ACTIONS(1614),
    [anon_sym___inline] = ACTIONS(1614),
    [anon_sym___inline__] = ACTIONS(1614),
    [anon_sym___forceinline] = ACTIONS(1614),
    [anon_sym_thread_local] = ACTIONS(1614),
    [anon_sym___thread] = ACTIONS(1614),
    [anon_sym_const] = ACTIONS(1638),
    [anon_sym_constexpr] = ACTIONS(1638),
    [anon_sym_volatile] = ACTIONS(1638),
    [anon_sym_restrict] = ACTIONS(1638),
    [anon_sym___restrict__] = ACTIONS(1638),
    [anon_sym__Atomic] = ACTIONS(1638),
    [anon_sym__Noreturn] = ACTIONS(1638),
    [anon_sym_noreturn] = ACTIONS(1638),
    [anon_sym_mutable] = ACTIONS(1638),
    [anon_sym_constinit] = ACTIONS(1638),
    [anon_sym_consteval] = ACTIONS(1638),
    [anon_sym_alignas] = ACTIONS(1641),
    [anon_sym__Alignas] = ACTIONS(1641),
    [sym_primitive_type] = ACTIONS(1644),
    [anon_sym_enum] = ACTIONS(1647),
    [anon_sym_class] = ACTIONS(1650),
    [anon_sym_struct] = ACTIONS(1653),
    [anon_sym_union] = ACTIONS(1656),
    [anon_sym_if] = ACTIONS(1888),
    [anon_sym_else] = ACTIONS(1583),
    [anon_sym_switch] = ACTIONS(1891),
    [anon_sym_case] = ACTIONS(1583),
    [anon_sym_default] = ACTIONS(1583),
    [anon_sym_while] = ACTIONS(1894),
    [anon_sym_do] = ACTIONS(1897),
    [anon_sym_for] = ACTIONS(1900),
    [anon_sym_return] = ACTIONS(1903),
    [anon_sym_break] = ACTIONS(1906),
    [anon_sym_continue] = ACTIONS(1909),
    [anon_sym_goto] = ACTIONS(1912),
    [anon_sym___try] = ACTIONS(1915),
    [anon_sym___leave] = ACTIONS(1918),
    [anon_sym_not] = ACTIONS(1591),
    [anon_sym_compl] = ACTIONS(1591),
    [anon_sym_DASH_DASH] = ACTIONS(1692),
    [anon_sym_PLUS_PLUS] = ACTIONS(1692),
    [anon_sym_sizeof] = ACTIONS(1695),
    [anon_sym___alignof__] = ACTIONS(1698),
    [anon_sym___alignof] = ACTIONS(1698),
    [anon_sym__alignof] = ACTIONS(1698),
    [anon_sym_alignof] = ACTIONS(1698),
    [anon_sym__Alignof] = ACTIONS(1698),
    [anon_sym_offsetof] = ACTIONS(1701),
    [anon_sym__Generic] = ACTIONS(1704),
    [anon_sym_asm] = ACTIONS(1707),
    [anon_sym___asm__] = ACTIONS(1707),
    [sym_number_literal] = ACTIONS(1710),
    [anon_sym_L_SQUOTE] = ACTIONS(1713),
    [anon_sym_u_SQUOTE] = ACTIONS(1713),
    [anon_sym_U_SQUOTE] = ACTIONS(1713),
    [anon_sym_u8_SQUOTE] = ACTIONS(1713),
    [anon_sym_SQUOTE] = ACTIONS(1713),
    [anon_sym_L_DQUOTE] = ACTIONS(1716),
    [anon_sym_u_DQUOTE] = ACTIONS(1716),
    [anon_sym_U_DQUOTE] = ACTIONS(1716),
    [anon_sym_u8_DQUOTE] = ACTIONS(1716),
    [anon_sym_DQUOTE] = ACTIONS(1716),
    [sym_true] = ACTIONS(1719),
    [sym_false] = ACTIONS(1719),
    [anon_sym_NULL] = ACTIONS(1722),
    [anon_sym_nullptr] = ACTIONS(1722),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1725),
    [anon_sym_let] = ACTIONS(1725),
    [anon_sym_This] = ACTIONS(1725),
    [anon_sym_decltype] = ACTIONS(1728),
    [sym_virtual] = ACTIONS(1611),
    [anon_sym_explicit] = ACTIONS(1583),
    [anon_sym_typename] = ACTIONS(1731),
    [anon_sym_template] = ACTIONS(1734),
    [anon_sym_operator] = ACTIONS(1583),
    [anon_sym_try] = ACTIONS(1921),
    [anon_sym_delete] = ACTIONS(1740),
    [anon_sym_throw] = ACTIONS(1924),
    [anon_sym_namespace] = ACTIONS(1583),
    [anon_sym_using] = ACTIONS(1583),
    [anon_sym_static_assert] = ACTIONS(1583),
    [anon_sym_concept] = ACTIONS(1583),
    [anon_sym_co_return] = ACTIONS(1927),
    [anon_sym_co_yield] = ACTIONS(1930),
    [anon_sym_R_DQUOTE] = ACTIONS(1752),
    [anon_sym_LR_DQUOTE] = ACTIONS(1752),
    [anon_sym_uR_DQUOTE] = ACTIONS(1752),
    [anon_sym_UR_DQUOTE] = ACTIONS(1752),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1752),
    [anon_sym_co_await] = ACTIONS(1755),
    [anon_sym_new] = ACTIONS(1758),
    [anon_sym_requires] = ACTIONS(1761),
    [sym_this] = ACTIONS(1719),
    [anon_sym_discard] = ACTIONS(1933),
    [anon_sym_precise] = ACTIONS(1767),
    [anon_sym_shared] = ACTIONS(1767),
    [anon_sym_groupshared] = ACTIONS(1767),
    [anon_sym_uniform] = ACTIONS(1767),
    [anon_sym_row_major] = ACTIONS(1767),
    [anon_sym_column_major] = ACTIONS(1767),
    [anon_sym_globallycoherent] = ACTIONS(1767),
    [anon_sym_centroid] = ACTIONS(1767),
    [anon_sym_noperspective] = ACTIONS(1767),
    [anon_sym_nointerpolation] = ACTIONS(1767),
    [anon_sym_sample] = ACTIONS(1767),
    [anon_sym_linear] = ACTIONS(1767),
    [anon_sym_snorm] = ACTIONS(1767),
    [anon_sym_unorm] = ACTIONS(1767),
    [anon_sym_point] = ACTIONS(1767),
    [anon_sym_line] = ACTIONS(1767),
    [anon_sym_triangleadj] = ACTIONS(1767),
    [anon_sym_lineadj] = ACTIONS(1767),
    [anon_sym_triangle] = ACTIONS(1767),
    [anon_sym_cbuffer] = ACTIONS(1936),
    [anon_sym_interface] = ACTIONS(1773),
    [anon_sym_extension] = ACTIONS(1776),
  },
  [92] = {
    [sym_declaration] = STATE(91),
    [sym_type_definition] = STATE(91),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6179),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(1319),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_compound_statement] = STATE(91),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(91),
    [sym_labeled_statement] = STATE(91),
    [sym_expression_statement] = STATE(91),
    [sym_if_statement] = STATE(91),
    [sym_switch_statement] = STATE(91),
    [sym_while_statement] = STATE(91),
    [sym_do_statement] = STATE(91),
    [sym_for_statement] = STATE(91),
    [sym_return_statement] = STATE(91),
    [sym_break_statement] = STATE(91),
    [sym_continue_statement] = STATE(91),
    [sym_goto_statement] = STATE(91),
    [sym_seh_try_statement] = STATE(91),
    [sym_seh_leave_statement] = STATE(91),
    [sym_expression] = STATE(5465),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10896),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(91),
    [sym_co_return_statement] = STATE(91),
    [sym_co_yield_statement] = STATE(91),
    [sym_throw_statement] = STATE(91),
    [sym_try_statement] = STATE(91),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(91),
    [sym_qualifiers] = STATE(2038),
    [sym_cbuffer_specifier] = STATE(91),
    [sym_hlsl_attribute] = STATE(9939),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1148),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_case_statement_repeat1] = STATE(91),
    [sym_identifier] = ACTIONS(1869),
    [aux_sym_preproc_include_token1] = ACTIONS(1779),
    [aux_sym_preproc_def_token1] = ACTIONS(1779),
    [aux_sym_preproc_if_token1] = ACTIONS(1779),
    [aux_sym_preproc_if_token2] = ACTIONS(1779),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1779),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1779),
    [sym_preproc_directive] = ACTIONS(1779),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP_AMP] = ACTIONS(1781),
    [anon_sym_AMP] = ACTIONS(1570),
    [anon_sym_SEMI] = ACTIONS(1211),
    [anon_sym___extension__] = ACTIONS(1213),
    [anon_sym_typedef] = ACTIONS(1215),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1574),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1779),
    [anon_sym___cdecl] = ACTIONS(1779),
    [anon_sym___clrcall] = ACTIONS(1779),
    [anon_sym___stdcall] = ACTIONS(1779),
    [anon_sym___fastcall] = ACTIONS(1779),
    [anon_sym___thiscall] = ACTIONS(1779),
    [anon_sym___vectorcall] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(1219),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1779),
    [anon_sym_switch] = ACTIONS(1225),
    [anon_sym_case] = ACTIONS(1779),
    [anon_sym_default] = ACTIONS(1779),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_do] = ACTIONS(1233),
    [anon_sym_for] = ACTIONS(1235),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1239),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_goto] = ACTIONS(1243),
    [anon_sym___try] = ACTIONS(1245),
    [anon_sym___leave] = ACTIONS(1247),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_explicit] = ACTIONS(1779),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(1779),
    [anon_sym_try] = ACTIONS(1251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(1253),
    [anon_sym_namespace] = ACTIONS(1779),
    [anon_sym_using] = ACTIONS(1779),
    [anon_sym_static_assert] = ACTIONS(1779),
    [anon_sym_concept] = ACTIONS(1779),
    [anon_sym_co_return] = ACTIONS(1263),
    [anon_sym_co_yield] = ACTIONS(1265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(1269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [93] = {
    [sym_declaration] = STATE(90),
    [sym_type_definition] = STATE(90),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6162),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(1319),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_compound_statement] = STATE(90),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(90),
    [sym_labeled_statement] = STATE(90),
    [sym_expression_statement] = STATE(90),
    [sym_if_statement] = STATE(90),
    [sym_switch_statement] = STATE(90),
    [sym_while_statement] = STATE(90),
    [sym_do_statement] = STATE(90),
    [sym_for_statement] = STATE(90),
    [sym_return_statement] = STATE(90),
    [sym_break_statement] = STATE(90),
    [sym_continue_statement] = STATE(90),
    [sym_goto_statement] = STATE(90),
    [sym_seh_try_statement] = STATE(90),
    [sym_seh_leave_statement] = STATE(90),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(90),
    [sym_co_return_statement] = STATE(90),
    [sym_co_yield_statement] = STATE(90),
    [sym_throw_statement] = STATE(90),
    [sym_try_statement] = STATE(90),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(90),
    [sym_qualifiers] = STATE(2038),
    [sym_cbuffer_specifier] = STATE(90),
    [sym_hlsl_attribute] = STATE(9709),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_case_statement_repeat1] = STATE(90),
    [sym_identifier] = ACTIONS(1871),
    [aux_sym_preproc_include_token1] = ACTIONS(1783),
    [aux_sym_preproc_def_token1] = ACTIONS(1783),
    [aux_sym_preproc_if_token1] = ACTIONS(1783),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1783),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1783),
    [sym_preproc_directive] = ACTIONS(1783),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP_AMP] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1570),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1574),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1783),
    [anon_sym___cdecl] = ACTIONS(1783),
    [anon_sym___clrcall] = ACTIONS(1783),
    [anon_sym___stdcall] = ACTIONS(1783),
    [anon_sym___fastcall] = ACTIONS(1783),
    [anon_sym___thiscall] = ACTIONS(1783),
    [anon_sym___vectorcall] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1785),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_else] = ACTIONS(1783),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(1783),
    [anon_sym_default] = ACTIONS(1783),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_explicit] = ACTIONS(1783),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(1783),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(1783),
    [anon_sym_using] = ACTIONS(1783),
    [anon_sym_static_assert] = ACTIONS(1783),
    [anon_sym_concept] = ACTIONS(1783),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [94] = {
    [sym_declaration] = STATE(95),
    [sym_type_definition] = STATE(95),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6162),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(1319),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_compound_statement] = STATE(95),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(95),
    [sym_labeled_statement] = STATE(95),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_switch_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_goto_statement] = STATE(95),
    [sym_seh_try_statement] = STATE(95),
    [sym_seh_leave_statement] = STATE(95),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(95),
    [sym_co_return_statement] = STATE(95),
    [sym_co_yield_statement] = STATE(95),
    [sym_throw_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(95),
    [sym_qualifiers] = STATE(2038),
    [sym_cbuffer_specifier] = STATE(95),
    [sym_hlsl_attribute] = STATE(9709),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_case_statement_repeat1] = STATE(95),
    [sym_identifier] = ACTIONS(1871),
    [aux_sym_preproc_include_token1] = ACTIONS(1779),
    [aux_sym_preproc_def_token1] = ACTIONS(1779),
    [aux_sym_preproc_if_token1] = ACTIONS(1779),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1779),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1779),
    [sym_preproc_directive] = ACTIONS(1779),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP_AMP] = ACTIONS(1781),
    [anon_sym_AMP] = ACTIONS(1570),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1574),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1779),
    [anon_sym___cdecl] = ACTIONS(1779),
    [anon_sym___clrcall] = ACTIONS(1779),
    [anon_sym___stdcall] = ACTIONS(1779),
    [anon_sym___fastcall] = ACTIONS(1779),
    [anon_sym___thiscall] = ACTIONS(1779),
    [anon_sym___vectorcall] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(1781),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_else] = ACTIONS(1779),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(1779),
    [anon_sym_default] = ACTIONS(1779),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_explicit] = ACTIONS(1779),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(1779),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_namespace] = ACTIONS(1779),
    [anon_sym_using] = ACTIONS(1779),
    [anon_sym_static_assert] = ACTIONS(1779),
    [anon_sym_concept] = ACTIONS(1779),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [95] = {
    [sym_declaration] = STATE(95),
    [sym_type_definition] = STATE(95),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6162),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(1319),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_compound_statement] = STATE(95),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(95),
    [sym_labeled_statement] = STATE(95),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_switch_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_goto_statement] = STATE(95),
    [sym_seh_try_statement] = STATE(95),
    [sym_seh_leave_statement] = STATE(95),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(95),
    [sym_co_return_statement] = STATE(95),
    [sym_co_yield_statement] = STATE(95),
    [sym_throw_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(95),
    [sym_qualifiers] = STATE(2038),
    [sym_cbuffer_specifier] = STATE(95),
    [sym_hlsl_attribute] = STATE(9709),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_case_statement_repeat1] = STATE(95),
    [sym_identifier] = ACTIONS(1939),
    [aux_sym_preproc_include_token1] = ACTIONS(1583),
    [aux_sym_preproc_def_token1] = ACTIONS(1583),
    [aux_sym_preproc_if_token1] = ACTIONS(1583),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1583),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1583),
    [sym_preproc_directive] = ACTIONS(1583),
    [anon_sym_LPAREN2] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1588),
    [anon_sym_TILDE] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1594),
    [anon_sym_AMP_AMP] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1599),
    [anon_sym_SEMI] = ACTIONS(1942),
    [anon_sym___extension__] = ACTIONS(1945),
    [anon_sym_typedef] = ACTIONS(1948),
    [anon_sym_in] = ACTIONS(1611),
    [anon_sym_out] = ACTIONS(1611),
    [anon_sym_inout] = ACTIONS(1611),
    [anon_sym_extern] = ACTIONS(1614),
    [anon_sym___attribute__] = ACTIONS(1617),
    [anon_sym_COLON_COLON] = ACTIONS(1620),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1623),
    [anon_sym___declspec] = ACTIONS(1626),
    [anon_sym___based] = ACTIONS(1583),
    [anon_sym___cdecl] = ACTIONS(1583),
    [anon_sym___clrcall] = ACTIONS(1583),
    [anon_sym___stdcall] = ACTIONS(1583),
    [anon_sym___fastcall] = ACTIONS(1583),
    [anon_sym___thiscall] = ACTIONS(1583),
    [anon_sym___vectorcall] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1951),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [anon_sym_signed] = ACTIONS(1632),
    [anon_sym_unsigned] = ACTIONS(1632),
    [anon_sym_long] = ACTIONS(1632),
    [anon_sym_short] = ACTIONS(1632),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_static] = ACTIONS(1614),
    [anon_sym_register] = ACTIONS(1614),
    [anon_sym_inline] = ACTIONS(1614),
    [anon_sym___inline] = ACTIONS(1614),
    [anon_sym___inline__] = ACTIONS(1614),
    [anon_sym___forceinline] = ACTIONS(1614),
    [anon_sym_thread_local] = ACTIONS(1614),
    [anon_sym___thread] = ACTIONS(1614),
    [anon_sym_const] = ACTIONS(1638),
    [anon_sym_constexpr] = ACTIONS(1638),
    [anon_sym_volatile] = ACTIONS(1638),
    [anon_sym_restrict] = ACTIONS(1638),
    [anon_sym___restrict__] = ACTIONS(1638),
    [anon_sym__Atomic] = ACTIONS(1638),
    [anon_sym__Noreturn] = ACTIONS(1638),
    [anon_sym_noreturn] = ACTIONS(1638),
    [anon_sym_mutable] = ACTIONS(1638),
    [anon_sym_constinit] = ACTIONS(1638),
    [anon_sym_consteval] = ACTIONS(1638),
    [anon_sym_alignas] = ACTIONS(1641),
    [anon_sym__Alignas] = ACTIONS(1641),
    [sym_primitive_type] = ACTIONS(1644),
    [anon_sym_enum] = ACTIONS(1647),
    [anon_sym_class] = ACTIONS(1650),
    [anon_sym_struct] = ACTIONS(1653),
    [anon_sym_union] = ACTIONS(1656),
    [anon_sym_if] = ACTIONS(1954),
    [anon_sym_else] = ACTIONS(1583),
    [anon_sym_switch] = ACTIONS(1957),
    [anon_sym_case] = ACTIONS(1583),
    [anon_sym_default] = ACTIONS(1583),
    [anon_sym_while] = ACTIONS(1960),
    [anon_sym_do] = ACTIONS(1963),
    [anon_sym_for] = ACTIONS(1966),
    [anon_sym_return] = ACTIONS(1969),
    [anon_sym_break] = ACTIONS(1972),
    [anon_sym_continue] = ACTIONS(1975),
    [anon_sym_goto] = ACTIONS(1978),
    [anon_sym___try] = ACTIONS(1981),
    [anon_sym___leave] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1591),
    [anon_sym_compl] = ACTIONS(1591),
    [anon_sym_DASH_DASH] = ACTIONS(1692),
    [anon_sym_PLUS_PLUS] = ACTIONS(1692),
    [anon_sym_sizeof] = ACTIONS(1695),
    [anon_sym___alignof__] = ACTIONS(1698),
    [anon_sym___alignof] = ACTIONS(1698),
    [anon_sym__alignof] = ACTIONS(1698),
    [anon_sym_alignof] = ACTIONS(1698),
    [anon_sym__Alignof] = ACTIONS(1698),
    [anon_sym_offsetof] = ACTIONS(1701),
    [anon_sym__Generic] = ACTIONS(1704),
    [anon_sym_asm] = ACTIONS(1707),
    [anon_sym___asm__] = ACTIONS(1707),
    [sym_number_literal] = ACTIONS(1710),
    [anon_sym_L_SQUOTE] = ACTIONS(1713),
    [anon_sym_u_SQUOTE] = ACTIONS(1713),
    [anon_sym_U_SQUOTE] = ACTIONS(1713),
    [anon_sym_u8_SQUOTE] = ACTIONS(1713),
    [anon_sym_SQUOTE] = ACTIONS(1713),
    [anon_sym_L_DQUOTE] = ACTIONS(1716),
    [anon_sym_u_DQUOTE] = ACTIONS(1716),
    [anon_sym_U_DQUOTE] = ACTIONS(1716),
    [anon_sym_u8_DQUOTE] = ACTIONS(1716),
    [anon_sym_DQUOTE] = ACTIONS(1716),
    [sym_true] = ACTIONS(1719),
    [sym_false] = ACTIONS(1719),
    [anon_sym_NULL] = ACTIONS(1722),
    [anon_sym_nullptr] = ACTIONS(1722),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1725),
    [anon_sym_let] = ACTIONS(1725),
    [anon_sym_This] = ACTIONS(1725),
    [anon_sym_decltype] = ACTIONS(1728),
    [sym_virtual] = ACTIONS(1611),
    [anon_sym_explicit] = ACTIONS(1583),
    [anon_sym_typename] = ACTIONS(1731),
    [anon_sym_template] = ACTIONS(1734),
    [anon_sym_operator] = ACTIONS(1583),
    [anon_sym_try] = ACTIONS(1987),
    [anon_sym_delete] = ACTIONS(1740),
    [anon_sym_throw] = ACTIONS(1990),
    [anon_sym_namespace] = ACTIONS(1583),
    [anon_sym_using] = ACTIONS(1583),
    [anon_sym_static_assert] = ACTIONS(1583),
    [anon_sym_concept] = ACTIONS(1583),
    [anon_sym_co_return] = ACTIONS(1993),
    [anon_sym_co_yield] = ACTIONS(1996),
    [anon_sym_R_DQUOTE] = ACTIONS(1752),
    [anon_sym_LR_DQUOTE] = ACTIONS(1752),
    [anon_sym_uR_DQUOTE] = ACTIONS(1752),
    [anon_sym_UR_DQUOTE] = ACTIONS(1752),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1752),
    [anon_sym_co_await] = ACTIONS(1755),
    [anon_sym_new] = ACTIONS(1758),
    [anon_sym_requires] = ACTIONS(1761),
    [sym_this] = ACTIONS(1719),
    [anon_sym_discard] = ACTIONS(1999),
    [anon_sym_precise] = ACTIONS(1767),
    [anon_sym_shared] = ACTIONS(1767),
    [anon_sym_groupshared] = ACTIONS(1767),
    [anon_sym_uniform] = ACTIONS(1767),
    [anon_sym_row_major] = ACTIONS(1767),
    [anon_sym_column_major] = ACTIONS(1767),
    [anon_sym_globallycoherent] = ACTIONS(1767),
    [anon_sym_centroid] = ACTIONS(1767),
    [anon_sym_noperspective] = ACTIONS(1767),
    [anon_sym_nointerpolation] = ACTIONS(1767),
    [anon_sym_sample] = ACTIONS(1767),
    [anon_sym_linear] = ACTIONS(1767),
    [anon_sym_snorm] = ACTIONS(1767),
    [anon_sym_unorm] = ACTIONS(1767),
    [anon_sym_point] = ACTIONS(1767),
    [anon_sym_line] = ACTIONS(1767),
    [anon_sym_triangleadj] = ACTIONS(1767),
    [anon_sym_lineadj] = ACTIONS(1767),
    [anon_sym_triangle] = ACTIONS(1767),
    [anon_sym_cbuffer] = ACTIONS(2002),
    [anon_sym_interface] = ACTIONS(1773),
    [anon_sym_extension] = ACTIONS(1776),
  },
  [96] = {
    [sym_declaration] = STATE(92),
    [sym_type_definition] = STATE(92),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6179),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(1319),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_compound_statement] = STATE(92),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(92),
    [sym_labeled_statement] = STATE(92),
    [sym_expression_statement] = STATE(92),
    [sym_if_statement] = STATE(92),
    [sym_switch_statement] = STATE(92),
    [sym_while_statement] = STATE(92),
    [sym_do_statement] = STATE(92),
    [sym_for_statement] = STATE(92),
    [sym_return_statement] = STATE(92),
    [sym_break_statement] = STATE(92),
    [sym_continue_statement] = STATE(92),
    [sym_goto_statement] = STATE(92),
    [sym_seh_try_statement] = STATE(92),
    [sym_seh_leave_statement] = STATE(92),
    [sym_expression] = STATE(5465),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10896),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(92),
    [sym_co_return_statement] = STATE(92),
    [sym_co_yield_statement] = STATE(92),
    [sym_throw_statement] = STATE(92),
    [sym_try_statement] = STATE(92),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(92),
    [sym_qualifiers] = STATE(2038),
    [sym_cbuffer_specifier] = STATE(92),
    [sym_hlsl_attribute] = STATE(9939),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1148),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_case_statement_repeat1] = STATE(92),
    [sym_identifier] = ACTIONS(1869),
    [aux_sym_preproc_include_token1] = ACTIONS(1562),
    [aux_sym_preproc_def_token1] = ACTIONS(1562),
    [aux_sym_preproc_if_token1] = ACTIONS(1562),
    [aux_sym_preproc_if_token2] = ACTIONS(1562),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1562),
    [sym_preproc_directive] = ACTIONS(1562),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP_AMP] = ACTIONS(1568),
    [anon_sym_AMP] = ACTIONS(1570),
    [anon_sym_SEMI] = ACTIONS(1211),
    [anon_sym___extension__] = ACTIONS(1213),
    [anon_sym_typedef] = ACTIONS(1215),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1574),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1562),
    [anon_sym___cdecl] = ACTIONS(1562),
    [anon_sym___clrcall] = ACTIONS(1562),
    [anon_sym___stdcall] = ACTIONS(1562),
    [anon_sym___fastcall] = ACTIONS(1562),
    [anon_sym___thiscall] = ACTIONS(1562),
    [anon_sym___vectorcall] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1219),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1562),
    [anon_sym_switch] = ACTIONS(1225),
    [anon_sym_case] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1562),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_do] = ACTIONS(1233),
    [anon_sym_for] = ACTIONS(1235),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1239),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_goto] = ACTIONS(1243),
    [anon_sym___try] = ACTIONS(1245),
    [anon_sym___leave] = ACTIONS(1247),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_explicit] = ACTIONS(1562),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(1562),
    [anon_sym_try] = ACTIONS(1251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(1253),
    [anon_sym_namespace] = ACTIONS(1562),
    [anon_sym_using] = ACTIONS(1562),
    [anon_sym_static_assert] = ACTIONS(1562),
    [anon_sym_concept] = ACTIONS(1562),
    [anon_sym_co_return] = ACTIONS(1263),
    [anon_sym_co_yield] = ACTIONS(1265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1267),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(1269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [97] = {
    [sym_declaration] = STATE(99),
    [sym_type_definition] = STATE(99),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6186),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(1319),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_compound_statement] = STATE(99),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(99),
    [sym_labeled_statement] = STATE(99),
    [sym_expression_statement] = STATE(99),
    [sym_if_statement] = STATE(99),
    [sym_switch_statement] = STATE(99),
    [sym_while_statement] = STATE(99),
    [sym_do_statement] = STATE(99),
    [sym_for_statement] = STATE(99),
    [sym_return_statement] = STATE(99),
    [sym_break_statement] = STATE(99),
    [sym_continue_statement] = STATE(99),
    [sym_goto_statement] = STATE(99),
    [sym_seh_try_statement] = STATE(99),
    [sym_seh_leave_statement] = STATE(99),
    [sym_expression] = STATE(5437),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10787),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(99),
    [sym_co_return_statement] = STATE(99),
    [sym_co_yield_statement] = STATE(99),
    [sym_throw_statement] = STATE(99),
    [sym_try_statement] = STATE(99),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(99),
    [sym_qualifiers] = STATE(2038),
    [sym_cbuffer_specifier] = STATE(99),
    [sym_hlsl_attribute] = STATE(9865),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1193),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_case_statement_repeat1] = STATE(99),
    [sym_identifier] = ACTIONS(2005),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym___extension__] = ACTIONS(2009),
    [anon_sym_typedef] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1574),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(2015),
    [anon_sym_else] = ACTIONS(1783),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_while] = ACTIONS(2019),
    [anon_sym_do] = ACTIONS(2021),
    [anon_sym_for] = ACTIONS(2023),
    [anon_sym_return] = ACTIONS(2025),
    [anon_sym_break] = ACTIONS(2027),
    [anon_sym_continue] = ACTIONS(2029),
    [anon_sym_goto] = ACTIONS(2031),
    [anon_sym___try] = ACTIONS(2033),
    [anon_sym___leave] = ACTIONS(2035),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(2037),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(2039),
    [anon_sym_co_return] = ACTIONS(2041),
    [anon_sym_co_yield] = ACTIONS(2043),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(2045),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(2047),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [98] = {
    [sym_declaration] = STATE(101),
    [sym_type_definition] = STATE(101),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6186),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(1319),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_compound_statement] = STATE(101),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(101),
    [sym_labeled_statement] = STATE(101),
    [sym_expression_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_switch_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_do_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_return_statement] = STATE(101),
    [sym_break_statement] = STATE(101),
    [sym_continue_statement] = STATE(101),
    [sym_goto_statement] = STATE(101),
    [sym_seh_try_statement] = STATE(101),
    [sym_seh_leave_statement] = STATE(101),
    [sym_expression] = STATE(5437),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10787),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(101),
    [sym_co_return_statement] = STATE(101),
    [sym_co_yield_statement] = STATE(101),
    [sym_throw_statement] = STATE(101),
    [sym_try_statement] = STATE(101),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(101),
    [sym_qualifiers] = STATE(2038),
    [sym_cbuffer_specifier] = STATE(101),
    [sym_hlsl_attribute] = STATE(9865),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1193),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_case_statement_repeat1] = STATE(101),
    [sym_identifier] = ACTIONS(2005),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym___extension__] = ACTIONS(2009),
    [anon_sym_typedef] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1574),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(2015),
    [anon_sym_else] = ACTIONS(1562),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_while] = ACTIONS(2019),
    [anon_sym_do] = ACTIONS(2021),
    [anon_sym_for] = ACTIONS(2023),
    [anon_sym_return] = ACTIONS(2025),
    [anon_sym_break] = ACTIONS(2027),
    [anon_sym_continue] = ACTIONS(2029),
    [anon_sym_goto] = ACTIONS(2031),
    [anon_sym___try] = ACTIONS(2033),
    [anon_sym___leave] = ACTIONS(2035),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(2037),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(2039),
    [anon_sym_co_return] = ACTIONS(2041),
    [anon_sym_co_yield] = ACTIONS(2043),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(2045),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(2047),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [99] = {
    [sym_declaration] = STATE(100),
    [sym_type_definition] = STATE(100),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6186),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(1319),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_compound_statement] = STATE(100),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(100),
    [sym_labeled_statement] = STATE(100),
    [sym_expression_statement] = STATE(100),
    [sym_if_statement] = STATE(100),
    [sym_switch_statement] = STATE(100),
    [sym_while_statement] = STATE(100),
    [sym_do_statement] = STATE(100),
    [sym_for_statement] = STATE(100),
    [sym_return_statement] = STATE(100),
    [sym_break_statement] = STATE(100),
    [sym_continue_statement] = STATE(100),
    [sym_goto_statement] = STATE(100),
    [sym_seh_try_statement] = STATE(100),
    [sym_seh_leave_statement] = STATE(100),
    [sym_expression] = STATE(5437),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10787),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(100),
    [sym_co_return_statement] = STATE(100),
    [sym_co_yield_statement] = STATE(100),
    [sym_throw_statement] = STATE(100),
    [sym_try_statement] = STATE(100),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(100),
    [sym_qualifiers] = STATE(2038),
    [sym_cbuffer_specifier] = STATE(100),
    [sym_hlsl_attribute] = STATE(9865),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1193),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_case_statement_repeat1] = STATE(100),
    [sym_identifier] = ACTIONS(2005),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym___extension__] = ACTIONS(2009),
    [anon_sym_typedef] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1574),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(2015),
    [anon_sym_else] = ACTIONS(1787),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_while] = ACTIONS(2019),
    [anon_sym_do] = ACTIONS(2021),
    [anon_sym_for] = ACTIONS(2023),
    [anon_sym_return] = ACTIONS(2025),
    [anon_sym_break] = ACTIONS(2027),
    [anon_sym_continue] = ACTIONS(2029),
    [anon_sym_goto] = ACTIONS(2031),
    [anon_sym___try] = ACTIONS(2033),
    [anon_sym___leave] = ACTIONS(2035),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(2037),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(2039),
    [anon_sym_co_return] = ACTIONS(2041),
    [anon_sym_co_yield] = ACTIONS(2043),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(2045),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(2047),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [100] = {
    [sym_declaration] = STATE(100),
    [sym_type_definition] = STATE(100),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6186),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(1319),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_compound_statement] = STATE(100),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(100),
    [sym_labeled_statement] = STATE(100),
    [sym_expression_statement] = STATE(100),
    [sym_if_statement] = STATE(100),
    [sym_switch_statement] = STATE(100),
    [sym_while_statement] = STATE(100),
    [sym_do_statement] = STATE(100),
    [sym_for_statement] = STATE(100),
    [sym_return_statement] = STATE(100),
    [sym_break_statement] = STATE(100),
    [sym_continue_statement] = STATE(100),
    [sym_goto_statement] = STATE(100),
    [sym_seh_try_statement] = STATE(100),
    [sym_seh_leave_statement] = STATE(100),
    [sym_expression] = STATE(5437),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10787),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(100),
    [sym_co_return_statement] = STATE(100),
    [sym_co_yield_statement] = STATE(100),
    [sym_throw_statement] = STATE(100),
    [sym_try_statement] = STATE(100),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(100),
    [sym_qualifiers] = STATE(2038),
    [sym_cbuffer_specifier] = STATE(100),
    [sym_hlsl_attribute] = STATE(9865),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1193),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_case_statement_repeat1] = STATE(100),
    [sym_identifier] = ACTIONS(2049),
    [anon_sym_LPAREN2] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1588),
    [anon_sym_TILDE] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1594),
    [anon_sym_AMP] = ACTIONS(1594),
    [anon_sym_SEMI] = ACTIONS(2052),
    [anon_sym___extension__] = ACTIONS(2055),
    [anon_sym_typedef] = ACTIONS(2058),
    [anon_sym_in] = ACTIONS(1611),
    [anon_sym_out] = ACTIONS(1611),
    [anon_sym_inout] = ACTIONS(1611),
    [anon_sym_extern] = ACTIONS(1614),
    [anon_sym___attribute__] = ACTIONS(1617),
    [anon_sym_COLON_COLON] = ACTIONS(1620),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1623),
    [anon_sym___declspec] = ACTIONS(1626),
    [anon_sym_LBRACE] = ACTIONS(2061),
    [anon_sym_signed] = ACTIONS(1632),
    [anon_sym_unsigned] = ACTIONS(1632),
    [anon_sym_long] = ACTIONS(1632),
    [anon_sym_short] = ACTIONS(1632),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_static] = ACTIONS(1614),
    [anon_sym_register] = ACTIONS(1614),
    [anon_sym_inline] = ACTIONS(1614),
    [anon_sym___inline] = ACTIONS(1614),
    [anon_sym___inline__] = ACTIONS(1614),
    [anon_sym___forceinline] = ACTIONS(1614),
    [anon_sym_thread_local] = ACTIONS(1614),
    [anon_sym___thread] = ACTIONS(1614),
    [anon_sym_const] = ACTIONS(1638),
    [anon_sym_constexpr] = ACTIONS(1638),
    [anon_sym_volatile] = ACTIONS(1638),
    [anon_sym_restrict] = ACTIONS(1638),
    [anon_sym___restrict__] = ACTIONS(1638),
    [anon_sym__Atomic] = ACTIONS(1638),
    [anon_sym__Noreturn] = ACTIONS(1638),
    [anon_sym_noreturn] = ACTIONS(1638),
    [anon_sym_mutable] = ACTIONS(1638),
    [anon_sym_constinit] = ACTIONS(1638),
    [anon_sym_consteval] = ACTIONS(1638),
    [anon_sym_alignas] = ACTIONS(1641),
    [anon_sym__Alignas] = ACTIONS(1641),
    [sym_primitive_type] = ACTIONS(1644),
    [anon_sym_enum] = ACTIONS(1647),
    [anon_sym_class] = ACTIONS(1650),
    [anon_sym_struct] = ACTIONS(1653),
    [anon_sym_union] = ACTIONS(1656),
    [anon_sym_if] = ACTIONS(2064),
    [anon_sym_else] = ACTIONS(1583),
    [anon_sym_switch] = ACTIONS(2067),
    [anon_sym_while] = ACTIONS(2070),
    [anon_sym_do] = ACTIONS(2073),
    [anon_sym_for] = ACTIONS(2076),
    [anon_sym_return] = ACTIONS(2079),
    [anon_sym_break] = ACTIONS(2082),
    [anon_sym_continue] = ACTIONS(2085),
    [anon_sym_goto] = ACTIONS(2088),
    [anon_sym___try] = ACTIONS(2091),
    [anon_sym___leave] = ACTIONS(2094),
    [anon_sym_not] = ACTIONS(1591),
    [anon_sym_compl] = ACTIONS(1591),
    [anon_sym_DASH_DASH] = ACTIONS(1692),
    [anon_sym_PLUS_PLUS] = ACTIONS(1692),
    [anon_sym_sizeof] = ACTIONS(1695),
    [anon_sym___alignof__] = ACTIONS(1698),
    [anon_sym___alignof] = ACTIONS(1698),
    [anon_sym__alignof] = ACTIONS(1698),
    [anon_sym_alignof] = ACTIONS(1698),
    [anon_sym__Alignof] = ACTIONS(1698),
    [anon_sym_offsetof] = ACTIONS(1701),
    [anon_sym__Generic] = ACTIONS(1704),
    [anon_sym_asm] = ACTIONS(1707),
    [anon_sym___asm__] = ACTIONS(1707),
    [sym_number_literal] = ACTIONS(1710),
    [anon_sym_L_SQUOTE] = ACTIONS(1713),
    [anon_sym_u_SQUOTE] = ACTIONS(1713),
    [anon_sym_U_SQUOTE] = ACTIONS(1713),
    [anon_sym_u8_SQUOTE] = ACTIONS(1713),
    [anon_sym_SQUOTE] = ACTIONS(1713),
    [anon_sym_L_DQUOTE] = ACTIONS(1716),
    [anon_sym_u_DQUOTE] = ACTIONS(1716),
    [anon_sym_U_DQUOTE] = ACTIONS(1716),
    [anon_sym_u8_DQUOTE] = ACTIONS(1716),
    [anon_sym_DQUOTE] = ACTIONS(1716),
    [sym_true] = ACTIONS(1719),
    [sym_false] = ACTIONS(1719),
    [anon_sym_NULL] = ACTIONS(1722),
    [anon_sym_nullptr] = ACTIONS(1722),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1725),
    [anon_sym_let] = ACTIONS(1725),
    [anon_sym_This] = ACTIONS(1725),
    [anon_sym_decltype] = ACTIONS(1728),
    [sym_virtual] = ACTIONS(1611),
    [anon_sym_typename] = ACTIONS(1731),
    [anon_sym_template] = ACTIONS(1734),
    [anon_sym_try] = ACTIONS(2097),
    [anon_sym_delete] = ACTIONS(1740),
    [anon_sym_throw] = ACTIONS(2100),
    [anon_sym_co_return] = ACTIONS(2103),
    [anon_sym_co_yield] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(1752),
    [anon_sym_LR_DQUOTE] = ACTIONS(1752),
    [anon_sym_uR_DQUOTE] = ACTIONS(1752),
    [anon_sym_UR_DQUOTE] = ACTIONS(1752),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1752),
    [anon_sym_co_await] = ACTIONS(1755),
    [anon_sym_new] = ACTIONS(1758),
    [anon_sym_requires] = ACTIONS(1761),
    [sym_this] = ACTIONS(1719),
    [anon_sym_discard] = ACTIONS(2109),
    [anon_sym_precise] = ACTIONS(1767),
    [anon_sym_shared] = ACTIONS(1767),
    [anon_sym_groupshared] = ACTIONS(1767),
    [anon_sym_uniform] = ACTIONS(1767),
    [anon_sym_row_major] = ACTIONS(1767),
    [anon_sym_column_major] = ACTIONS(1767),
    [anon_sym_globallycoherent] = ACTIONS(1767),
    [anon_sym_centroid] = ACTIONS(1767),
    [anon_sym_noperspective] = ACTIONS(1767),
    [anon_sym_nointerpolation] = ACTIONS(1767),
    [anon_sym_sample] = ACTIONS(1767),
    [anon_sym_linear] = ACTIONS(1767),
    [anon_sym_snorm] = ACTIONS(1767),
    [anon_sym_unorm] = ACTIONS(1767),
    [anon_sym_point] = ACTIONS(1767),
    [anon_sym_line] = ACTIONS(1767),
    [anon_sym_triangleadj] = ACTIONS(1767),
    [anon_sym_lineadj] = ACTIONS(1767),
    [anon_sym_triangle] = ACTIONS(1767),
    [anon_sym_cbuffer] = ACTIONS(2112),
    [anon_sym_interface] = ACTIONS(1773),
    [anon_sym_extension] = ACTIONS(1776),
  },
  [101] = {
    [sym_declaration] = STATE(100),
    [sym_type_definition] = STATE(100),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6186),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(1319),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_compound_statement] = STATE(100),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_attributed_statement] = STATE(100),
    [sym_labeled_statement] = STATE(100),
    [sym_expression_statement] = STATE(100),
    [sym_if_statement] = STATE(100),
    [sym_switch_statement] = STATE(100),
    [sym_while_statement] = STATE(100),
    [sym_do_statement] = STATE(100),
    [sym_for_statement] = STATE(100),
    [sym_return_statement] = STATE(100),
    [sym_break_statement] = STATE(100),
    [sym_continue_statement] = STATE(100),
    [sym_goto_statement] = STATE(100),
    [sym_seh_try_statement] = STATE(100),
    [sym_seh_leave_statement] = STATE(100),
    [sym_expression] = STATE(5437),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10787),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(100),
    [sym_co_return_statement] = STATE(100),
    [sym_co_yield_statement] = STATE(100),
    [sym_throw_statement] = STATE(100),
    [sym_try_statement] = STATE(100),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(100),
    [sym_qualifiers] = STATE(2038),
    [sym_cbuffer_specifier] = STATE(100),
    [sym_hlsl_attribute] = STATE(9865),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_attributed_declarator_repeat1] = STATE(1193),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_case_statement_repeat1] = STATE(100),
    [sym_identifier] = ACTIONS(2005),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym___extension__] = ACTIONS(2009),
    [anon_sym_typedef] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1574),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(2015),
    [anon_sym_else] = ACTIONS(1779),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_while] = ACTIONS(2019),
    [anon_sym_do] = ACTIONS(2021),
    [anon_sym_for] = ACTIONS(2023),
    [anon_sym_return] = ACTIONS(2025),
    [anon_sym_break] = ACTIONS(2027),
    [anon_sym_continue] = ACTIONS(2029),
    [anon_sym_goto] = ACTIONS(2031),
    [anon_sym___try] = ACTIONS(2033),
    [anon_sym___leave] = ACTIONS(2035),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(2037),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(2039),
    [anon_sym_co_return] = ACTIONS(2041),
    [anon_sym_co_yield] = ACTIONS(2043),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(2045),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_cbuffer] = ACTIONS(2047),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [102] = {
    [sym_string_literal] = STATE(3342),
    [sym_template_argument_list] = STATE(181),
    [sym_raw_string_literal] = STATE(3342),
    [aux_sym_sized_type_specifier_repeat1] = STATE(630),
    [sym_identifier] = ACTIONS(2115),
    [aux_sym_preproc_include_token1] = ACTIONS(2115),
    [aux_sym_preproc_def_token1] = ACTIONS(2115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [aux_sym_preproc_if_token1] = ACTIONS(2115),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2115),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2115),
    [sym_preproc_directive] = ACTIONS(2115),
    [anon_sym_LPAREN2] = ACTIONS(2119),
    [anon_sym_BANG] = ACTIONS(2115),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2130),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(2133),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON] = ACTIONS(2136),
    [anon_sym_SEMI] = ACTIONS(2130),
    [anon_sym___extension__] = ACTIONS(2115),
    [anon_sym_typedef] = ACTIONS(2115),
    [anon_sym_in] = ACTIONS(2115),
    [anon_sym_out] = ACTIONS(2115),
    [anon_sym_inout] = ACTIONS(2115),
    [anon_sym_extern] = ACTIONS(2115),
    [anon_sym___attribute__] = ACTIONS(2115),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2140),
    [anon_sym___declspec] = ACTIONS(2115),
    [anon_sym___based] = ACTIONS(2115),
    [anon_sym___cdecl] = ACTIONS(2115),
    [anon_sym___clrcall] = ACTIONS(2115),
    [anon_sym___stdcall] = ACTIONS(2115),
    [anon_sym___fastcall] = ACTIONS(2115),
    [anon_sym___thiscall] = ACTIONS(2115),
    [anon_sym___vectorcall] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(2143),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_signed] = ACTIONS(2146),
    [anon_sym_unsigned] = ACTIONS(2146),
    [anon_sym_long] = ACTIONS(2146),
    [anon_sym_short] = ACTIONS(2146),
    [anon_sym_LBRACK] = ACTIONS(2148),
    [anon_sym_static] = ACTIONS(2115),
    [anon_sym_EQ] = ACTIONS(2152),
    [anon_sym_register] = ACTIONS(2115),
    [anon_sym_inline] = ACTIONS(2115),
    [anon_sym___inline] = ACTIONS(2115),
    [anon_sym___inline__] = ACTIONS(2115),
    [anon_sym___forceinline] = ACTIONS(2115),
    [anon_sym_thread_local] = ACTIONS(2115),
    [anon_sym___thread] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(2115),
    [anon_sym_constexpr] = ACTIONS(2115),
    [anon_sym_volatile] = ACTIONS(2115),
    [anon_sym_restrict] = ACTIONS(2115),
    [anon_sym___restrict__] = ACTIONS(2115),
    [anon_sym__Atomic] = ACTIONS(2115),
    [anon_sym__Noreturn] = ACTIONS(2115),
    [anon_sym_noreturn] = ACTIONS(2115),
    [anon_sym_mutable] = ACTIONS(2115),
    [anon_sym_constinit] = ACTIONS(2115),
    [anon_sym_consteval] = ACTIONS(2115),
    [anon_sym_alignas] = ACTIONS(2115),
    [anon_sym__Alignas] = ACTIONS(2115),
    [sym_primitive_type] = ACTIONS(2115),
    [anon_sym_enum] = ACTIONS(2115),
    [anon_sym_class] = ACTIONS(2115),
    [anon_sym_struct] = ACTIONS(2115),
    [anon_sym_union] = ACTIONS(2115),
    [anon_sym_if] = ACTIONS(2115),
    [anon_sym_switch] = ACTIONS(2115),
    [anon_sym_case] = ACTIONS(2115),
    [anon_sym_default] = ACTIONS(2115),
    [anon_sym_while] = ACTIONS(2115),
    [anon_sym_do] = ACTIONS(2115),
    [anon_sym_for] = ACTIONS(2115),
    [anon_sym_return] = ACTIONS(2115),
    [anon_sym_break] = ACTIONS(2115),
    [anon_sym_continue] = ACTIONS(2115),
    [anon_sym_goto] = ACTIONS(2115),
    [anon_sym___try] = ACTIONS(2115),
    [anon_sym___leave] = ACTIONS(2115),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2154),
    [anon_sym_SLASH_EQ] = ACTIONS(2154),
    [anon_sym_PERCENT_EQ] = ACTIONS(2154),
    [anon_sym_PLUS_EQ] = ACTIONS(2154),
    [anon_sym_DASH_EQ] = ACTIONS(2154),
    [anon_sym_LT_LT_EQ] = ACTIONS(2154),
    [anon_sym_GT_GT_EQ] = ACTIONS(2154),
    [anon_sym_AMP_EQ] = ACTIONS(2154),
    [anon_sym_CARET_EQ] = ACTIONS(2154),
    [anon_sym_PIPE_EQ] = ACTIONS(2154),
    [anon_sym_and_eq] = ACTIONS(2152),
    [anon_sym_or_eq] = ACTIONS(2152),
    [anon_sym_xor_eq] = ACTIONS(2152),
    [anon_sym_not] = ACTIONS(2115),
    [anon_sym_compl] = ACTIONS(2115),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2128),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2128),
    [anon_sym_not_eq] = ACTIONS(2128),
    [anon_sym_is] = ACTIONS(2128),
    [anon_sym_as] = ACTIONS(2128),
    [anon_sym_DASH_DASH] = ACTIONS(2130),
    [anon_sym_PLUS_PLUS] = ACTIONS(2130),
    [anon_sym_sizeof] = ACTIONS(2115),
    [anon_sym___alignof__] = ACTIONS(2115),
    [anon_sym___alignof] = ACTIONS(2115),
    [anon_sym__alignof] = ACTIONS(2115),
    [anon_sym_alignof] = ACTIONS(2115),
    [anon_sym__Alignof] = ACTIONS(2115),
    [anon_sym_offsetof] = ACTIONS(2115),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2115),
    [anon_sym___asm__] = ACTIONS(2115),
    [anon_sym_DOT] = ACTIONS(2125),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [sym_number_literal] = ACTIONS(2123),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(2115),
    [sym_false] = ACTIONS(2115),
    [anon_sym_NULL] = ACTIONS(2115),
    [anon_sym_nullptr] = ACTIONS(2115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2115),
    [anon_sym_let] = ACTIONS(2115),
    [anon_sym_This] = ACTIONS(2115),
    [anon_sym_decltype] = ACTIONS(2115),
    [sym_virtual] = ACTIONS(2115),
    [anon_sym_explicit] = ACTIONS(2115),
    [anon_sym_typename] = ACTIONS(2115),
    [anon_sym_template] = ACTIONS(2115),
    [anon_sym_operator] = ACTIONS(2115),
    [anon_sym_try] = ACTIONS(2115),
    [anon_sym_delete] = ACTIONS(2115),
    [anon_sym_throw] = ACTIONS(2115),
    [anon_sym_namespace] = ACTIONS(2115),
    [anon_sym_using] = ACTIONS(2115),
    [anon_sym_static_assert] = ACTIONS(2115),
    [anon_sym_concept] = ACTIONS(2115),
    [anon_sym_co_return] = ACTIONS(2115),
    [anon_sym_co_yield] = ACTIONS(2115),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_co_await] = ACTIONS(2115),
    [anon_sym_new] = ACTIONS(2115),
    [anon_sym_requires] = ACTIONS(2115),
    [sym_this] = ACTIONS(2115),
    [anon_sym_discard] = ACTIONS(2115),
    [anon_sym_precise] = ACTIONS(2115),
    [anon_sym_shared] = ACTIONS(2115),
    [anon_sym_groupshared] = ACTIONS(2115),
    [anon_sym_uniform] = ACTIONS(2115),
    [anon_sym_row_major] = ACTIONS(2115),
    [anon_sym_column_major] = ACTIONS(2115),
    [anon_sym_globallycoherent] = ACTIONS(2115),
    [anon_sym_centroid] = ACTIONS(2115),
    [anon_sym_noperspective] = ACTIONS(2115),
    [anon_sym_nointerpolation] = ACTIONS(2115),
    [anon_sym_sample] = ACTIONS(2115),
    [anon_sym_linear] = ACTIONS(2115),
    [anon_sym_snorm] = ACTIONS(2115),
    [anon_sym_unorm] = ACTIONS(2115),
    [anon_sym_point] = ACTIONS(2115),
    [anon_sym_line] = ACTIONS(2115),
    [anon_sym_triangleadj] = ACTIONS(2115),
    [anon_sym_lineadj] = ACTIONS(2115),
    [anon_sym_triangle] = ACTIONS(2115),
    [anon_sym_cbuffer] = ACTIONS(2115),
    [anon_sym_interface] = ACTIONS(2115),
    [anon_sym_extension] = ACTIONS(2115),
  },
  [103] = {
    [sym_string_literal] = STATE(3342),
    [sym_template_argument_list] = STATE(187),
    [sym_raw_string_literal] = STATE(3342),
    [aux_sym_sized_type_specifier_repeat1] = STATE(874),
    [ts_builtin_sym_end] = ACTIONS(2123),
    [sym_identifier] = ACTIONS(2115),
    [aux_sym_preproc_include_token1] = ACTIONS(2115),
    [aux_sym_preproc_def_token1] = ACTIONS(2115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [aux_sym_preproc_if_token1] = ACTIONS(2115),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2115),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2115),
    [sym_preproc_directive] = ACTIONS(2115),
    [anon_sym_LPAREN2] = ACTIONS(2119),
    [anon_sym_BANG] = ACTIONS(2115),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2130),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON] = ACTIONS(2163),
    [anon_sym_SEMI] = ACTIONS(2165),
    [anon_sym___extension__] = ACTIONS(2115),
    [anon_sym_typedef] = ACTIONS(2115),
    [anon_sym_in] = ACTIONS(2115),
    [anon_sym_out] = ACTIONS(2115),
    [anon_sym_inout] = ACTIONS(2115),
    [anon_sym_extern] = ACTIONS(2115),
    [anon_sym___attribute__] = ACTIONS(2115),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2140),
    [anon_sym___declspec] = ACTIONS(2115),
    [anon_sym___based] = ACTIONS(2115),
    [anon_sym___cdecl] = ACTIONS(2115),
    [anon_sym___clrcall] = ACTIONS(2115),
    [anon_sym___stdcall] = ACTIONS(2115),
    [anon_sym___fastcall] = ACTIONS(2115),
    [anon_sym___thiscall] = ACTIONS(2115),
    [anon_sym___vectorcall] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(2143),
    [anon_sym_signed] = ACTIONS(2167),
    [anon_sym_unsigned] = ACTIONS(2167),
    [anon_sym_long] = ACTIONS(2167),
    [anon_sym_short] = ACTIONS(2167),
    [anon_sym_LBRACK] = ACTIONS(2148),
    [anon_sym_static] = ACTIONS(2115),
    [anon_sym_EQ] = ACTIONS(2152),
    [anon_sym_register] = ACTIONS(2115),
    [anon_sym_inline] = ACTIONS(2115),
    [anon_sym___inline] = ACTIONS(2115),
    [anon_sym___inline__] = ACTIONS(2115),
    [anon_sym___forceinline] = ACTIONS(2115),
    [anon_sym_thread_local] = ACTIONS(2115),
    [anon_sym___thread] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(2115),
    [anon_sym_constexpr] = ACTIONS(2115),
    [anon_sym_volatile] = ACTIONS(2115),
    [anon_sym_restrict] = ACTIONS(2115),
    [anon_sym___restrict__] = ACTIONS(2115),
    [anon_sym__Atomic] = ACTIONS(2115),
    [anon_sym__Noreturn] = ACTIONS(2115),
    [anon_sym_noreturn] = ACTIONS(2115),
    [anon_sym_mutable] = ACTIONS(2115),
    [anon_sym_constinit] = ACTIONS(2115),
    [anon_sym_consteval] = ACTIONS(2115),
    [anon_sym_alignas] = ACTIONS(2115),
    [anon_sym__Alignas] = ACTIONS(2115),
    [sym_primitive_type] = ACTIONS(2115),
    [anon_sym_enum] = ACTIONS(2115),
    [anon_sym_class] = ACTIONS(2115),
    [anon_sym_struct] = ACTIONS(2115),
    [anon_sym_union] = ACTIONS(2115),
    [anon_sym_if] = ACTIONS(2115),
    [anon_sym_switch] = ACTIONS(2115),
    [anon_sym_case] = ACTIONS(2115),
    [anon_sym_default] = ACTIONS(2115),
    [anon_sym_while] = ACTIONS(2115),
    [anon_sym_do] = ACTIONS(2115),
    [anon_sym_for] = ACTIONS(2115),
    [anon_sym_return] = ACTIONS(2115),
    [anon_sym_break] = ACTIONS(2115),
    [anon_sym_continue] = ACTIONS(2115),
    [anon_sym_goto] = ACTIONS(2115),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2154),
    [anon_sym_SLASH_EQ] = ACTIONS(2154),
    [anon_sym_PERCENT_EQ] = ACTIONS(2154),
    [anon_sym_PLUS_EQ] = ACTIONS(2154),
    [anon_sym_DASH_EQ] = ACTIONS(2154),
    [anon_sym_LT_LT_EQ] = ACTIONS(2154),
    [anon_sym_GT_GT_EQ] = ACTIONS(2154),
    [anon_sym_AMP_EQ] = ACTIONS(2154),
    [anon_sym_CARET_EQ] = ACTIONS(2154),
    [anon_sym_PIPE_EQ] = ACTIONS(2154),
    [anon_sym_and_eq] = ACTIONS(2152),
    [anon_sym_or_eq] = ACTIONS(2152),
    [anon_sym_xor_eq] = ACTIONS(2152),
    [anon_sym_not] = ACTIONS(2115),
    [anon_sym_compl] = ACTIONS(2115),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2128),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2128),
    [anon_sym_not_eq] = ACTIONS(2128),
    [anon_sym_is] = ACTIONS(2128),
    [anon_sym_as] = ACTIONS(2128),
    [anon_sym_DASH_DASH] = ACTIONS(2130),
    [anon_sym_PLUS_PLUS] = ACTIONS(2130),
    [anon_sym_sizeof] = ACTIONS(2115),
    [anon_sym___alignof__] = ACTIONS(2115),
    [anon_sym___alignof] = ACTIONS(2115),
    [anon_sym__alignof] = ACTIONS(2115),
    [anon_sym_alignof] = ACTIONS(2115),
    [anon_sym__Alignof] = ACTIONS(2115),
    [anon_sym_offsetof] = ACTIONS(2115),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2115),
    [anon_sym___asm__] = ACTIONS(2115),
    [anon_sym_DOT] = ACTIONS(2125),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [sym_number_literal] = ACTIONS(2123),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(2115),
    [sym_false] = ACTIONS(2115),
    [anon_sym_NULL] = ACTIONS(2115),
    [anon_sym_nullptr] = ACTIONS(2115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2115),
    [anon_sym_let] = ACTIONS(2115),
    [anon_sym_This] = ACTIONS(2115),
    [anon_sym_decltype] = ACTIONS(2115),
    [sym_virtual] = ACTIONS(2115),
    [anon_sym_explicit] = ACTIONS(2115),
    [anon_sym_typename] = ACTIONS(2115),
    [anon_sym_template] = ACTIONS(2115),
    [anon_sym_operator] = ACTIONS(2115),
    [anon_sym_try] = ACTIONS(2115),
    [anon_sym_delete] = ACTIONS(2115),
    [anon_sym_throw] = ACTIONS(2115),
    [anon_sym_namespace] = ACTIONS(2115),
    [anon_sym_using] = ACTIONS(2115),
    [anon_sym_static_assert] = ACTIONS(2115),
    [anon_sym_concept] = ACTIONS(2115),
    [anon_sym_co_return] = ACTIONS(2115),
    [anon_sym_co_yield] = ACTIONS(2115),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_co_await] = ACTIONS(2115),
    [anon_sym_new] = ACTIONS(2115),
    [anon_sym_requires] = ACTIONS(2115),
    [sym_this] = ACTIONS(2115),
    [anon_sym_precise] = ACTIONS(2115),
    [anon_sym_shared] = ACTIONS(2115),
    [anon_sym_groupshared] = ACTIONS(2115),
    [anon_sym_uniform] = ACTIONS(2115),
    [anon_sym_row_major] = ACTIONS(2115),
    [anon_sym_column_major] = ACTIONS(2115),
    [anon_sym_globallycoherent] = ACTIONS(2115),
    [anon_sym_centroid] = ACTIONS(2115),
    [anon_sym_noperspective] = ACTIONS(2115),
    [anon_sym_nointerpolation] = ACTIONS(2115),
    [anon_sym_sample] = ACTIONS(2115),
    [anon_sym_linear] = ACTIONS(2115),
    [anon_sym_snorm] = ACTIONS(2115),
    [anon_sym_unorm] = ACTIONS(2115),
    [anon_sym_point] = ACTIONS(2115),
    [anon_sym_line] = ACTIONS(2115),
    [anon_sym_triangleadj] = ACTIONS(2115),
    [anon_sym_lineadj] = ACTIONS(2115),
    [anon_sym_triangle] = ACTIONS(2115),
    [anon_sym_interface] = ACTIONS(2115),
    [anon_sym_extension] = ACTIONS(2115),
    [anon_sym___exported] = ACTIONS(2115),
    [anon_sym_import] = ACTIONS(2115),
  },
  [104] = {
    [sym_template_argument_list] = STATE(111),
    [sym_identifier] = ACTIONS(2169),
    [aux_sym_preproc_include_token1] = ACTIONS(2169),
    [aux_sym_preproc_def_token1] = ACTIONS(2169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2171),
    [anon_sym_COMMA] = ACTIONS(2171),
    [aux_sym_preproc_if_token1] = ACTIONS(2169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2169),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2169),
    [sym_preproc_directive] = ACTIONS(2169),
    [anon_sym_LPAREN2] = ACTIONS(2173),
    [anon_sym_BANG] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2178),
    [anon_sym_PLUS] = ACTIONS(2178),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2171),
    [anon_sym_AMP_AMP] = ACTIONS(2173),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2171),
    [anon_sym_BANG_EQ] = ACTIONS(2171),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2171),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(2183),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_SEMI] = ACTIONS(2173),
    [anon_sym___extension__] = ACTIONS(2169),
    [anon_sym_typedef] = ACTIONS(2169),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_out] = ACTIONS(2169),
    [anon_sym_inout] = ACTIONS(2169),
    [anon_sym_extern] = ACTIONS(2169),
    [anon_sym___attribute__] = ACTIONS(2169),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2173),
    [anon_sym___declspec] = ACTIONS(2169),
    [anon_sym___based] = ACTIONS(2169),
    [anon_sym___cdecl] = ACTIONS(2169),
    [anon_sym___clrcall] = ACTIONS(2169),
    [anon_sym___stdcall] = ACTIONS(2169),
    [anon_sym___fastcall] = ACTIONS(2169),
    [anon_sym___thiscall] = ACTIONS(2169),
    [anon_sym___vectorcall] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2176),
    [anon_sym_RBRACE] = ACTIONS(2176),
    [anon_sym_signed] = ACTIONS(2169),
    [anon_sym_unsigned] = ACTIONS(2169),
    [anon_sym_long] = ACTIONS(2169),
    [anon_sym_short] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2169),
    [anon_sym_EQ] = ACTIONS(2181),
    [anon_sym_register] = ACTIONS(2169),
    [anon_sym_inline] = ACTIONS(2169),
    [anon_sym___inline] = ACTIONS(2169),
    [anon_sym___inline__] = ACTIONS(2169),
    [anon_sym___forceinline] = ACTIONS(2169),
    [anon_sym_thread_local] = ACTIONS(2169),
    [anon_sym___thread] = ACTIONS(2169),
    [anon_sym_const] = ACTIONS(2169),
    [anon_sym_constexpr] = ACTIONS(2169),
    [anon_sym_volatile] = ACTIONS(2169),
    [anon_sym_restrict] = ACTIONS(2169),
    [anon_sym___restrict__] = ACTIONS(2169),
    [anon_sym__Atomic] = ACTIONS(2169),
    [anon_sym__Noreturn] = ACTIONS(2169),
    [anon_sym_noreturn] = ACTIONS(2169),
    [anon_sym_mutable] = ACTIONS(2169),
    [anon_sym_constinit] = ACTIONS(2169),
    [anon_sym_consteval] = ACTIONS(2169),
    [anon_sym_alignas] = ACTIONS(2169),
    [anon_sym__Alignas] = ACTIONS(2169),
    [sym_primitive_type] = ACTIONS(2169),
    [anon_sym_enum] = ACTIONS(2169),
    [anon_sym_class] = ACTIONS(2169),
    [anon_sym_struct] = ACTIONS(2169),
    [anon_sym_union] = ACTIONS(2169),
    [anon_sym_if] = ACTIONS(2169),
    [anon_sym_switch] = ACTIONS(2169),
    [anon_sym_case] = ACTIONS(2169),
    [anon_sym_default] = ACTIONS(2169),
    [anon_sym_while] = ACTIONS(2169),
    [anon_sym_do] = ACTIONS(2169),
    [anon_sym_for] = ACTIONS(2169),
    [anon_sym_return] = ACTIONS(2169),
    [anon_sym_break] = ACTIONS(2169),
    [anon_sym_continue] = ACTIONS(2169),
    [anon_sym_goto] = ACTIONS(2169),
    [anon_sym___try] = ACTIONS(2169),
    [anon_sym___leave] = ACTIONS(2169),
    [anon_sym_QMARK] = ACTIONS(2171),
    [anon_sym_STAR_EQ] = ACTIONS(2171),
    [anon_sym_SLASH_EQ] = ACTIONS(2171),
    [anon_sym_PERCENT_EQ] = ACTIONS(2171),
    [anon_sym_PLUS_EQ] = ACTIONS(2171),
    [anon_sym_DASH_EQ] = ACTIONS(2171),
    [anon_sym_LT_LT_EQ] = ACTIONS(2171),
    [anon_sym_GT_GT_EQ] = ACTIONS(2171),
    [anon_sym_AMP_EQ] = ACTIONS(2171),
    [anon_sym_CARET_EQ] = ACTIONS(2171),
    [anon_sym_PIPE_EQ] = ACTIONS(2171),
    [anon_sym_and_eq] = ACTIONS(2181),
    [anon_sym_or_eq] = ACTIONS(2181),
    [anon_sym_xor_eq] = ACTIONS(2181),
    [anon_sym_not] = ACTIONS(2169),
    [anon_sym_compl] = ACTIONS(2169),
    [anon_sym_LT_EQ_GT] = ACTIONS(2171),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2181),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2181),
    [anon_sym_not_eq] = ACTIONS(2181),
    [anon_sym_is] = ACTIONS(2181),
    [anon_sym_as] = ACTIONS(2181),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_sizeof] = ACTIONS(2169),
    [anon_sym___alignof__] = ACTIONS(2169),
    [anon_sym___alignof] = ACTIONS(2169),
    [anon_sym__alignof] = ACTIONS(2169),
    [anon_sym_alignof] = ACTIONS(2169),
    [anon_sym__Alignof] = ACTIONS(2169),
    [anon_sym_offsetof] = ACTIONS(2169),
    [anon_sym__Generic] = ACTIONS(2169),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DOT_STAR] = ACTIONS(2171),
    [anon_sym_DASH_GT] = ACTIONS(2171),
    [sym_number_literal] = ACTIONS(2176),
    [anon_sym_L_SQUOTE] = ACTIONS(2176),
    [anon_sym_u_SQUOTE] = ACTIONS(2176),
    [anon_sym_U_SQUOTE] = ACTIONS(2176),
    [anon_sym_u8_SQUOTE] = ACTIONS(2176),
    [anon_sym_SQUOTE] = ACTIONS(2176),
    [anon_sym_L_DQUOTE] = ACTIONS(2176),
    [anon_sym_u_DQUOTE] = ACTIONS(2176),
    [anon_sym_U_DQUOTE] = ACTIONS(2176),
    [anon_sym_u8_DQUOTE] = ACTIONS(2176),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [sym_true] = ACTIONS(2169),
    [sym_false] = ACTIONS(2169),
    [anon_sym_NULL] = ACTIONS(2169),
    [anon_sym_nullptr] = ACTIONS(2169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2169),
    [anon_sym_let] = ACTIONS(2169),
    [anon_sym_This] = ACTIONS(2169),
    [anon_sym_decltype] = ACTIONS(2169),
    [sym_virtual] = ACTIONS(2169),
    [anon_sym_explicit] = ACTIONS(2169),
    [anon_sym_typename] = ACTIONS(2169),
    [anon_sym_template] = ACTIONS(2169),
    [anon_sym_operator] = ACTIONS(2169),
    [anon_sym_try] = ACTIONS(2169),
    [anon_sym_delete] = ACTIONS(2169),
    [anon_sym_throw] = ACTIONS(2169),
    [anon_sym_namespace] = ACTIONS(2169),
    [anon_sym_using] = ACTIONS(2169),
    [anon_sym_static_assert] = ACTIONS(2169),
    [anon_sym_concept] = ACTIONS(2169),
    [anon_sym_co_return] = ACTIONS(2169),
    [anon_sym_co_yield] = ACTIONS(2169),
    [anon_sym_R_DQUOTE] = ACTIONS(2176),
    [anon_sym_LR_DQUOTE] = ACTIONS(2176),
    [anon_sym_uR_DQUOTE] = ACTIONS(2176),
    [anon_sym_UR_DQUOTE] = ACTIONS(2176),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2176),
    [anon_sym_co_await] = ACTIONS(2169),
    [anon_sym_new] = ACTIONS(2169),
    [anon_sym_requires] = ACTIONS(2169),
    [sym_this] = ACTIONS(2169),
    [anon_sym_discard] = ACTIONS(2169),
    [anon_sym_precise] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_groupshared] = ACTIONS(2169),
    [anon_sym_uniform] = ACTIONS(2169),
    [anon_sym_row_major] = ACTIONS(2169),
    [anon_sym_column_major] = ACTIONS(2169),
    [anon_sym_globallycoherent] = ACTIONS(2169),
    [anon_sym_centroid] = ACTIONS(2169),
    [anon_sym_noperspective] = ACTIONS(2169),
    [anon_sym_nointerpolation] = ACTIONS(2169),
    [anon_sym_sample] = ACTIONS(2169),
    [anon_sym_linear] = ACTIONS(2169),
    [anon_sym_snorm] = ACTIONS(2169),
    [anon_sym_unorm] = ACTIONS(2169),
    [anon_sym_point] = ACTIONS(2169),
    [anon_sym_line] = ACTIONS(2169),
    [anon_sym_triangleadj] = ACTIONS(2169),
    [anon_sym_lineadj] = ACTIONS(2169),
    [anon_sym_triangle] = ACTIONS(2169),
    [anon_sym_cbuffer] = ACTIONS(2169),
    [anon_sym_interface] = ACTIONS(2169),
    [anon_sym_extension] = ACTIONS(2169),
  },
  [105] = {
    [sym_identifier] = ACTIONS(2186),
    [aux_sym_preproc_include_token1] = ACTIONS(2186),
    [aux_sym_preproc_def_token1] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_COMMA] = ACTIONS(2188),
    [aux_sym_preproc_if_token1] = ACTIONS(2186),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2186),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2186),
    [sym_preproc_directive] = ACTIONS(2186),
    [anon_sym_LPAREN2] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2186),
    [anon_sym_TILDE] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2186),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_STAR] = ACTIONS(2186),
    [anon_sym_SLASH] = ACTIONS(2186),
    [anon_sym_PERCENT] = ACTIONS(2186),
    [anon_sym_PIPE_PIPE] = ACTIONS(2188),
    [anon_sym_AMP_AMP] = ACTIONS(2188),
    [anon_sym_PIPE] = ACTIONS(2186),
    [anon_sym_CARET] = ACTIONS(2186),
    [anon_sym_AMP] = ACTIONS(2186),
    [anon_sym_EQ_EQ] = ACTIONS(2188),
    [anon_sym_BANG_EQ] = ACTIONS(2188),
    [anon_sym_GT] = ACTIONS(2186),
    [anon_sym_GT_EQ] = ACTIONS(2188),
    [anon_sym_LT_EQ] = ACTIONS(2186),
    [anon_sym_LT] = ACTIONS(2186),
    [anon_sym_LT_LT] = ACTIONS(2186),
    [anon_sym_GT_GT] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym___extension__] = ACTIONS(2186),
    [anon_sym_typedef] = ACTIONS(2186),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_out] = ACTIONS(2186),
    [anon_sym_inout] = ACTIONS(2186),
    [anon_sym_extern] = ACTIONS(2186),
    [anon_sym___attribute__] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2188),
    [anon_sym___declspec] = ACTIONS(2186),
    [anon_sym___based] = ACTIONS(2186),
    [anon_sym___cdecl] = ACTIONS(2186),
    [anon_sym___clrcall] = ACTIONS(2186),
    [anon_sym___stdcall] = ACTIONS(2186),
    [anon_sym___fastcall] = ACTIONS(2186),
    [anon_sym___thiscall] = ACTIONS(2186),
    [anon_sym___vectorcall] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_RBRACE] = ACTIONS(2188),
    [anon_sym_signed] = ACTIONS(2186),
    [anon_sym_unsigned] = ACTIONS(2186),
    [anon_sym_long] = ACTIONS(2186),
    [anon_sym_short] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_static] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_register] = ACTIONS(2186),
    [anon_sym_inline] = ACTIONS(2186),
    [anon_sym___inline] = ACTIONS(2186),
    [anon_sym___inline__] = ACTIONS(2186),
    [anon_sym___forceinline] = ACTIONS(2186),
    [anon_sym_thread_local] = ACTIONS(2186),
    [anon_sym___thread] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_constexpr] = ACTIONS(2186),
    [anon_sym_volatile] = ACTIONS(2186),
    [anon_sym_restrict] = ACTIONS(2186),
    [anon_sym___restrict__] = ACTIONS(2186),
    [anon_sym__Atomic] = ACTIONS(2186),
    [anon_sym__Noreturn] = ACTIONS(2186),
    [anon_sym_noreturn] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_constinit] = ACTIONS(2186),
    [anon_sym_consteval] = ACTIONS(2186),
    [anon_sym_alignas] = ACTIONS(2186),
    [anon_sym__Alignas] = ACTIONS(2186),
    [sym_primitive_type] = ACTIONS(2186),
    [anon_sym_enum] = ACTIONS(2186),
    [anon_sym_class] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_union] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_switch] = ACTIONS(2186),
    [anon_sym_case] = ACTIONS(2186),
    [anon_sym_default] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [anon_sym_do] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_break] = ACTIONS(2186),
    [anon_sym_continue] = ACTIONS(2186),
    [anon_sym_goto] = ACTIONS(2186),
    [anon_sym___try] = ACTIONS(2186),
    [anon_sym___leave] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_STAR_EQ] = ACTIONS(2188),
    [anon_sym_SLASH_EQ] = ACTIONS(2188),
    [anon_sym_PERCENT_EQ] = ACTIONS(2188),
    [anon_sym_PLUS_EQ] = ACTIONS(2188),
    [anon_sym_DASH_EQ] = ACTIONS(2188),
    [anon_sym_LT_LT_EQ] = ACTIONS(2188),
    [anon_sym_GT_GT_EQ] = ACTIONS(2188),
    [anon_sym_AMP_EQ] = ACTIONS(2188),
    [anon_sym_CARET_EQ] = ACTIONS(2188),
    [anon_sym_PIPE_EQ] = ACTIONS(2188),
    [anon_sym_and_eq] = ACTIONS(2186),
    [anon_sym_or_eq] = ACTIONS(2186),
    [anon_sym_xor_eq] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2186),
    [anon_sym_compl] = ACTIONS(2186),
    [anon_sym_LT_EQ_GT] = ACTIONS(2188),
    [anon_sym_or] = ACTIONS(2186),
    [anon_sym_and] = ACTIONS(2186),
    [anon_sym_bitor] = ACTIONS(2186),
    [anon_sym_xor] = ACTIONS(2186),
    [anon_sym_bitand] = ACTIONS(2186),
    [anon_sym_not_eq] = ACTIONS(2186),
    [anon_sym_is] = ACTIONS(2186),
    [anon_sym_as] = ACTIONS(2186),
    [anon_sym_DASH_DASH] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2188),
    [anon_sym_sizeof] = ACTIONS(2186),
    [anon_sym___alignof__] = ACTIONS(2186),
    [anon_sym___alignof] = ACTIONS(2186),
    [anon_sym__alignof] = ACTIONS(2186),
    [anon_sym_alignof] = ACTIONS(2186),
    [anon_sym__Alignof] = ACTIONS(2186),
    [anon_sym_offsetof] = ACTIONS(2186),
    [anon_sym__Generic] = ACTIONS(2186),
    [anon_sym_asm] = ACTIONS(2186),
    [anon_sym___asm__] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOT_STAR] = ACTIONS(2188),
    [anon_sym_DASH_GT] = ACTIONS(2188),
    [sym_number_literal] = ACTIONS(2188),
    [anon_sym_L_SQUOTE] = ACTIONS(2188),
    [anon_sym_u_SQUOTE] = ACTIONS(2188),
    [anon_sym_U_SQUOTE] = ACTIONS(2188),
    [anon_sym_u8_SQUOTE] = ACTIONS(2188),
    [anon_sym_SQUOTE] = ACTIONS(2188),
    [anon_sym_L_DQUOTE] = ACTIONS(2188),
    [anon_sym_u_DQUOTE] = ACTIONS(2188),
    [anon_sym_U_DQUOTE] = ACTIONS(2188),
    [anon_sym_u8_DQUOTE] = ACTIONS(2188),
    [anon_sym_DQUOTE] = ACTIONS(2188),
    [sym_true] = ACTIONS(2186),
    [sym_false] = ACTIONS(2186),
    [anon_sym_NULL] = ACTIONS(2186),
    [anon_sym_nullptr] = ACTIONS(2186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_This] = ACTIONS(2186),
    [anon_sym_decltype] = ACTIONS(2186),
    [sym_virtual] = ACTIONS(2186),
    [anon_sym_explicit] = ACTIONS(2186),
    [anon_sym_typename] = ACTIONS(2186),
    [anon_sym_template] = ACTIONS(2186),
    [anon_sym_operator] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_delete] = ACTIONS(2186),
    [anon_sym_throw] = ACTIONS(2186),
    [anon_sym_namespace] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_static_assert] = ACTIONS(2186),
    [anon_sym_concept] = ACTIONS(2186),
    [anon_sym_co_return] = ACTIONS(2186),
    [anon_sym_co_yield] = ACTIONS(2186),
    [anon_sym_R_DQUOTE] = ACTIONS(2188),
    [anon_sym_LR_DQUOTE] = ACTIONS(2188),
    [anon_sym_uR_DQUOTE] = ACTIONS(2188),
    [anon_sym_UR_DQUOTE] = ACTIONS(2188),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2188),
    [anon_sym_co_await] = ACTIONS(2186),
    [anon_sym_new] = ACTIONS(2186),
    [anon_sym_requires] = ACTIONS(2186),
    [sym_this] = ACTIONS(2186),
    [anon_sym_discard] = ACTIONS(2186),
    [anon_sym_precise] = ACTIONS(2186),
    [anon_sym_shared] = ACTIONS(2186),
    [anon_sym_groupshared] = ACTIONS(2186),
    [anon_sym_uniform] = ACTIONS(2186),
    [anon_sym_row_major] = ACTIONS(2186),
    [anon_sym_column_major] = ACTIONS(2186),
    [anon_sym_globallycoherent] = ACTIONS(2186),
    [anon_sym_centroid] = ACTIONS(2186),
    [anon_sym_noperspective] = ACTIONS(2186),
    [anon_sym_nointerpolation] = ACTIONS(2186),
    [anon_sym_sample] = ACTIONS(2186),
    [anon_sym_linear] = ACTIONS(2186),
    [anon_sym_snorm] = ACTIONS(2186),
    [anon_sym_unorm] = ACTIONS(2186),
    [anon_sym_point] = ACTIONS(2186),
    [anon_sym_line] = ACTIONS(2186),
    [anon_sym_triangleadj] = ACTIONS(2186),
    [anon_sym_lineadj] = ACTIONS(2186),
    [anon_sym_triangle] = ACTIONS(2186),
    [anon_sym_cbuffer] = ACTIONS(2186),
    [anon_sym_interface] = ACTIONS(2186),
    [anon_sym_extension] = ACTIONS(2186),
  },
  [106] = {
    [sym_identifier] = ACTIONS(2190),
    [aux_sym_preproc_include_token1] = ACTIONS(2190),
    [aux_sym_preproc_def_token1] = ACTIONS(2190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2192),
    [anon_sym_COMMA] = ACTIONS(2192),
    [aux_sym_preproc_if_token1] = ACTIONS(2190),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2190),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2190),
    [sym_preproc_directive] = ACTIONS(2190),
    [anon_sym_LPAREN2] = ACTIONS(2192),
    [anon_sym_BANG] = ACTIONS(2190),
    [anon_sym_TILDE] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2190),
    [anon_sym_PLUS] = ACTIONS(2190),
    [anon_sym_STAR] = ACTIONS(2190),
    [anon_sym_SLASH] = ACTIONS(2190),
    [anon_sym_PERCENT] = ACTIONS(2190),
    [anon_sym_PIPE_PIPE] = ACTIONS(2192),
    [anon_sym_AMP_AMP] = ACTIONS(2192),
    [anon_sym_PIPE] = ACTIONS(2190),
    [anon_sym_CARET] = ACTIONS(2190),
    [anon_sym_AMP] = ACTIONS(2190),
    [anon_sym_EQ_EQ] = ACTIONS(2192),
    [anon_sym_BANG_EQ] = ACTIONS(2192),
    [anon_sym_GT] = ACTIONS(2190),
    [anon_sym_GT_EQ] = ACTIONS(2192),
    [anon_sym_LT_EQ] = ACTIONS(2190),
    [anon_sym_LT] = ACTIONS(2190),
    [anon_sym_LT_LT] = ACTIONS(2190),
    [anon_sym_GT_GT] = ACTIONS(2190),
    [anon_sym_SEMI] = ACTIONS(2192),
    [anon_sym___extension__] = ACTIONS(2190),
    [anon_sym_typedef] = ACTIONS(2190),
    [anon_sym_in] = ACTIONS(2190),
    [anon_sym_out] = ACTIONS(2190),
    [anon_sym_inout] = ACTIONS(2190),
    [anon_sym_extern] = ACTIONS(2190),
    [anon_sym___attribute__] = ACTIONS(2190),
    [anon_sym_COLON_COLON] = ACTIONS(2192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2192),
    [anon_sym___declspec] = ACTIONS(2190),
    [anon_sym___based] = ACTIONS(2190),
    [anon_sym___cdecl] = ACTIONS(2190),
    [anon_sym___clrcall] = ACTIONS(2190),
    [anon_sym___stdcall] = ACTIONS(2190),
    [anon_sym___fastcall] = ACTIONS(2190),
    [anon_sym___thiscall] = ACTIONS(2190),
    [anon_sym___vectorcall] = ACTIONS(2190),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [anon_sym_RBRACE] = ACTIONS(2192),
    [anon_sym_signed] = ACTIONS(2190),
    [anon_sym_unsigned] = ACTIONS(2190),
    [anon_sym_long] = ACTIONS(2190),
    [anon_sym_short] = ACTIONS(2190),
    [anon_sym_LBRACK] = ACTIONS(2190),
    [anon_sym_static] = ACTIONS(2190),
    [anon_sym_EQ] = ACTIONS(2190),
    [anon_sym_register] = ACTIONS(2190),
    [anon_sym_inline] = ACTIONS(2190),
    [anon_sym___inline] = ACTIONS(2190),
    [anon_sym___inline__] = ACTIONS(2190),
    [anon_sym___forceinline] = ACTIONS(2190),
    [anon_sym_thread_local] = ACTIONS(2190),
    [anon_sym___thread] = ACTIONS(2190),
    [anon_sym_const] = ACTIONS(2190),
    [anon_sym_constexpr] = ACTIONS(2190),
    [anon_sym_volatile] = ACTIONS(2190),
    [anon_sym_restrict] = ACTIONS(2190),
    [anon_sym___restrict__] = ACTIONS(2190),
    [anon_sym__Atomic] = ACTIONS(2190),
    [anon_sym__Noreturn] = ACTIONS(2190),
    [anon_sym_noreturn] = ACTIONS(2190),
    [anon_sym_mutable] = ACTIONS(2190),
    [anon_sym_constinit] = ACTIONS(2190),
    [anon_sym_consteval] = ACTIONS(2190),
    [anon_sym_alignas] = ACTIONS(2190),
    [anon_sym__Alignas] = ACTIONS(2190),
    [sym_primitive_type] = ACTIONS(2190),
    [anon_sym_enum] = ACTIONS(2190),
    [anon_sym_class] = ACTIONS(2190),
    [anon_sym_struct] = ACTIONS(2190),
    [anon_sym_union] = ACTIONS(2190),
    [anon_sym_if] = ACTIONS(2190),
    [anon_sym_switch] = ACTIONS(2190),
    [anon_sym_case] = ACTIONS(2190),
    [anon_sym_default] = ACTIONS(2190),
    [anon_sym_while] = ACTIONS(2190),
    [anon_sym_do] = ACTIONS(2190),
    [anon_sym_for] = ACTIONS(2190),
    [anon_sym_return] = ACTIONS(2190),
    [anon_sym_break] = ACTIONS(2190),
    [anon_sym_continue] = ACTIONS(2190),
    [anon_sym_goto] = ACTIONS(2190),
    [anon_sym___try] = ACTIONS(2190),
    [anon_sym___leave] = ACTIONS(2190),
    [anon_sym_QMARK] = ACTIONS(2192),
    [anon_sym_STAR_EQ] = ACTIONS(2192),
    [anon_sym_SLASH_EQ] = ACTIONS(2192),
    [anon_sym_PERCENT_EQ] = ACTIONS(2192),
    [anon_sym_PLUS_EQ] = ACTIONS(2192),
    [anon_sym_DASH_EQ] = ACTIONS(2192),
    [anon_sym_LT_LT_EQ] = ACTIONS(2192),
    [anon_sym_GT_GT_EQ] = ACTIONS(2192),
    [anon_sym_AMP_EQ] = ACTIONS(2192),
    [anon_sym_CARET_EQ] = ACTIONS(2192),
    [anon_sym_PIPE_EQ] = ACTIONS(2192),
    [anon_sym_and_eq] = ACTIONS(2190),
    [anon_sym_or_eq] = ACTIONS(2190),
    [anon_sym_xor_eq] = ACTIONS(2190),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_compl] = ACTIONS(2190),
    [anon_sym_LT_EQ_GT] = ACTIONS(2192),
    [anon_sym_or] = ACTIONS(2190),
    [anon_sym_and] = ACTIONS(2190),
    [anon_sym_bitor] = ACTIONS(2190),
    [anon_sym_xor] = ACTIONS(2190),
    [anon_sym_bitand] = ACTIONS(2190),
    [anon_sym_not_eq] = ACTIONS(2190),
    [anon_sym_is] = ACTIONS(2190),
    [anon_sym_as] = ACTIONS(2190),
    [anon_sym_DASH_DASH] = ACTIONS(2192),
    [anon_sym_PLUS_PLUS] = ACTIONS(2192),
    [anon_sym_sizeof] = ACTIONS(2190),
    [anon_sym___alignof__] = ACTIONS(2190),
    [anon_sym___alignof] = ACTIONS(2190),
    [anon_sym__alignof] = ACTIONS(2190),
    [anon_sym_alignof] = ACTIONS(2190),
    [anon_sym__Alignof] = ACTIONS(2190),
    [anon_sym_offsetof] = ACTIONS(2190),
    [anon_sym__Generic] = ACTIONS(2190),
    [anon_sym_asm] = ACTIONS(2190),
    [anon_sym___asm__] = ACTIONS(2190),
    [anon_sym_DOT] = ACTIONS(2190),
    [anon_sym_DOT_STAR] = ACTIONS(2192),
    [anon_sym_DASH_GT] = ACTIONS(2192),
    [sym_number_literal] = ACTIONS(2192),
    [anon_sym_L_SQUOTE] = ACTIONS(2192),
    [anon_sym_u_SQUOTE] = ACTIONS(2192),
    [anon_sym_U_SQUOTE] = ACTIONS(2192),
    [anon_sym_u8_SQUOTE] = ACTIONS(2192),
    [anon_sym_SQUOTE] = ACTIONS(2192),
    [anon_sym_L_DQUOTE] = ACTIONS(2192),
    [anon_sym_u_DQUOTE] = ACTIONS(2192),
    [anon_sym_U_DQUOTE] = ACTIONS(2192),
    [anon_sym_u8_DQUOTE] = ACTIONS(2192),
    [anon_sym_DQUOTE] = ACTIONS(2192),
    [sym_true] = ACTIONS(2190),
    [sym_false] = ACTIONS(2190),
    [anon_sym_NULL] = ACTIONS(2190),
    [anon_sym_nullptr] = ACTIONS(2190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2190),
    [anon_sym_let] = ACTIONS(2190),
    [anon_sym_This] = ACTIONS(2190),
    [anon_sym_decltype] = ACTIONS(2190),
    [sym_virtual] = ACTIONS(2190),
    [anon_sym_explicit] = ACTIONS(2190),
    [anon_sym_typename] = ACTIONS(2190),
    [anon_sym_template] = ACTIONS(2190),
    [anon_sym_operator] = ACTIONS(2190),
    [anon_sym_try] = ACTIONS(2190),
    [anon_sym_delete] = ACTIONS(2190),
    [anon_sym_throw] = ACTIONS(2190),
    [anon_sym_namespace] = ACTIONS(2190),
    [anon_sym_using] = ACTIONS(2190),
    [anon_sym_static_assert] = ACTIONS(2190),
    [anon_sym_concept] = ACTIONS(2190),
    [anon_sym_co_return] = ACTIONS(2190),
    [anon_sym_co_yield] = ACTIONS(2190),
    [anon_sym_R_DQUOTE] = ACTIONS(2192),
    [anon_sym_LR_DQUOTE] = ACTIONS(2192),
    [anon_sym_uR_DQUOTE] = ACTIONS(2192),
    [anon_sym_UR_DQUOTE] = ACTIONS(2192),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2192),
    [anon_sym_co_await] = ACTIONS(2190),
    [anon_sym_new] = ACTIONS(2190),
    [anon_sym_requires] = ACTIONS(2190),
    [sym_this] = ACTIONS(2190),
    [anon_sym_discard] = ACTIONS(2190),
    [anon_sym_precise] = ACTIONS(2190),
    [anon_sym_shared] = ACTIONS(2190),
    [anon_sym_groupshared] = ACTIONS(2190),
    [anon_sym_uniform] = ACTIONS(2190),
    [anon_sym_row_major] = ACTIONS(2190),
    [anon_sym_column_major] = ACTIONS(2190),
    [anon_sym_globallycoherent] = ACTIONS(2190),
    [anon_sym_centroid] = ACTIONS(2190),
    [anon_sym_noperspective] = ACTIONS(2190),
    [anon_sym_nointerpolation] = ACTIONS(2190),
    [anon_sym_sample] = ACTIONS(2190),
    [anon_sym_linear] = ACTIONS(2190),
    [anon_sym_snorm] = ACTIONS(2190),
    [anon_sym_unorm] = ACTIONS(2190),
    [anon_sym_point] = ACTIONS(2190),
    [anon_sym_line] = ACTIONS(2190),
    [anon_sym_triangleadj] = ACTIONS(2190),
    [anon_sym_lineadj] = ACTIONS(2190),
    [anon_sym_triangle] = ACTIONS(2190),
    [anon_sym_cbuffer] = ACTIONS(2190),
    [anon_sym_interface] = ACTIONS(2190),
    [anon_sym_extension] = ACTIONS(2190),
  },
  [107] = {
    [sym_identifier] = ACTIONS(2194),
    [aux_sym_preproc_include_token1] = ACTIONS(2194),
    [aux_sym_preproc_def_token1] = ACTIONS(2194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2196),
    [anon_sym_COMMA] = ACTIONS(2196),
    [aux_sym_preproc_if_token1] = ACTIONS(2194),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2194),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2194),
    [sym_preproc_directive] = ACTIONS(2194),
    [anon_sym_LPAREN2] = ACTIONS(2196),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2194),
    [anon_sym_PLUS] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(2194),
    [anon_sym_SLASH] = ACTIONS(2194),
    [anon_sym_PERCENT] = ACTIONS(2194),
    [anon_sym_PIPE_PIPE] = ACTIONS(2196),
    [anon_sym_AMP_AMP] = ACTIONS(2196),
    [anon_sym_PIPE] = ACTIONS(2194),
    [anon_sym_CARET] = ACTIONS(2194),
    [anon_sym_AMP] = ACTIONS(2194),
    [anon_sym_EQ_EQ] = ACTIONS(2196),
    [anon_sym_BANG_EQ] = ACTIONS(2196),
    [anon_sym_GT] = ACTIONS(2194),
    [anon_sym_GT_EQ] = ACTIONS(2196),
    [anon_sym_LT_EQ] = ACTIONS(2194),
    [anon_sym_LT] = ACTIONS(2194),
    [anon_sym_LT_LT] = ACTIONS(2194),
    [anon_sym_GT_GT] = ACTIONS(2194),
    [anon_sym_SEMI] = ACTIONS(2196),
    [anon_sym___extension__] = ACTIONS(2194),
    [anon_sym_typedef] = ACTIONS(2194),
    [anon_sym_in] = ACTIONS(2194),
    [anon_sym_out] = ACTIONS(2194),
    [anon_sym_inout] = ACTIONS(2194),
    [anon_sym_extern] = ACTIONS(2194),
    [anon_sym___attribute__] = ACTIONS(2194),
    [anon_sym_COLON_COLON] = ACTIONS(2196),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2196),
    [anon_sym___declspec] = ACTIONS(2194),
    [anon_sym___based] = ACTIONS(2194),
    [anon_sym___cdecl] = ACTIONS(2194),
    [anon_sym___clrcall] = ACTIONS(2194),
    [anon_sym___stdcall] = ACTIONS(2194),
    [anon_sym___fastcall] = ACTIONS(2194),
    [anon_sym___thiscall] = ACTIONS(2194),
    [anon_sym___vectorcall] = ACTIONS(2194),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_RBRACE] = ACTIONS(2196),
    [anon_sym_signed] = ACTIONS(2194),
    [anon_sym_unsigned] = ACTIONS(2194),
    [anon_sym_long] = ACTIONS(2194),
    [anon_sym_short] = ACTIONS(2194),
    [anon_sym_LBRACK] = ACTIONS(2194),
    [anon_sym_static] = ACTIONS(2194),
    [anon_sym_EQ] = ACTIONS(2194),
    [anon_sym_register] = ACTIONS(2194),
    [anon_sym_inline] = ACTIONS(2194),
    [anon_sym___inline] = ACTIONS(2194),
    [anon_sym___inline__] = ACTIONS(2194),
    [anon_sym___forceinline] = ACTIONS(2194),
    [anon_sym_thread_local] = ACTIONS(2194),
    [anon_sym___thread] = ACTIONS(2194),
    [anon_sym_const] = ACTIONS(2194),
    [anon_sym_constexpr] = ACTIONS(2194),
    [anon_sym_volatile] = ACTIONS(2194),
    [anon_sym_restrict] = ACTIONS(2194),
    [anon_sym___restrict__] = ACTIONS(2194),
    [anon_sym__Atomic] = ACTIONS(2194),
    [anon_sym__Noreturn] = ACTIONS(2194),
    [anon_sym_noreturn] = ACTIONS(2194),
    [anon_sym_mutable] = ACTIONS(2194),
    [anon_sym_constinit] = ACTIONS(2194),
    [anon_sym_consteval] = ACTIONS(2194),
    [anon_sym_alignas] = ACTIONS(2194),
    [anon_sym__Alignas] = ACTIONS(2194),
    [sym_primitive_type] = ACTIONS(2194),
    [anon_sym_enum] = ACTIONS(2194),
    [anon_sym_class] = ACTIONS(2194),
    [anon_sym_struct] = ACTIONS(2194),
    [anon_sym_union] = ACTIONS(2194),
    [anon_sym_if] = ACTIONS(2194),
    [anon_sym_switch] = ACTIONS(2194),
    [anon_sym_case] = ACTIONS(2194),
    [anon_sym_default] = ACTIONS(2194),
    [anon_sym_while] = ACTIONS(2194),
    [anon_sym_do] = ACTIONS(2194),
    [anon_sym_for] = ACTIONS(2194),
    [anon_sym_return] = ACTIONS(2194),
    [anon_sym_break] = ACTIONS(2194),
    [anon_sym_continue] = ACTIONS(2194),
    [anon_sym_goto] = ACTIONS(2194),
    [anon_sym___try] = ACTIONS(2194),
    [anon_sym___leave] = ACTIONS(2194),
    [anon_sym_QMARK] = ACTIONS(2196),
    [anon_sym_STAR_EQ] = ACTIONS(2196),
    [anon_sym_SLASH_EQ] = ACTIONS(2196),
    [anon_sym_PERCENT_EQ] = ACTIONS(2196),
    [anon_sym_PLUS_EQ] = ACTIONS(2196),
    [anon_sym_DASH_EQ] = ACTIONS(2196),
    [anon_sym_LT_LT_EQ] = ACTIONS(2196),
    [anon_sym_GT_GT_EQ] = ACTIONS(2196),
    [anon_sym_AMP_EQ] = ACTIONS(2196),
    [anon_sym_CARET_EQ] = ACTIONS(2196),
    [anon_sym_PIPE_EQ] = ACTIONS(2196),
    [anon_sym_and_eq] = ACTIONS(2194),
    [anon_sym_or_eq] = ACTIONS(2194),
    [anon_sym_xor_eq] = ACTIONS(2194),
    [anon_sym_not] = ACTIONS(2194),
    [anon_sym_compl] = ACTIONS(2194),
    [anon_sym_LT_EQ_GT] = ACTIONS(2196),
    [anon_sym_or] = ACTIONS(2194),
    [anon_sym_and] = ACTIONS(2194),
    [anon_sym_bitor] = ACTIONS(2194),
    [anon_sym_xor] = ACTIONS(2194),
    [anon_sym_bitand] = ACTIONS(2194),
    [anon_sym_not_eq] = ACTIONS(2194),
    [anon_sym_is] = ACTIONS(2194),
    [anon_sym_as] = ACTIONS(2194),
    [anon_sym_DASH_DASH] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2196),
    [anon_sym_sizeof] = ACTIONS(2194),
    [anon_sym___alignof__] = ACTIONS(2194),
    [anon_sym___alignof] = ACTIONS(2194),
    [anon_sym__alignof] = ACTIONS(2194),
    [anon_sym_alignof] = ACTIONS(2194),
    [anon_sym__Alignof] = ACTIONS(2194),
    [anon_sym_offsetof] = ACTIONS(2194),
    [anon_sym__Generic] = ACTIONS(2194),
    [anon_sym_asm] = ACTIONS(2194),
    [anon_sym___asm__] = ACTIONS(2194),
    [anon_sym_DOT] = ACTIONS(2194),
    [anon_sym_DOT_STAR] = ACTIONS(2196),
    [anon_sym_DASH_GT] = ACTIONS(2196),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_L_SQUOTE] = ACTIONS(2196),
    [anon_sym_u_SQUOTE] = ACTIONS(2196),
    [anon_sym_U_SQUOTE] = ACTIONS(2196),
    [anon_sym_u8_SQUOTE] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(2196),
    [anon_sym_L_DQUOTE] = ACTIONS(2196),
    [anon_sym_u_DQUOTE] = ACTIONS(2196),
    [anon_sym_U_DQUOTE] = ACTIONS(2196),
    [anon_sym_u8_DQUOTE] = ACTIONS(2196),
    [anon_sym_DQUOTE] = ACTIONS(2196),
    [sym_true] = ACTIONS(2194),
    [sym_false] = ACTIONS(2194),
    [anon_sym_NULL] = ACTIONS(2194),
    [anon_sym_nullptr] = ACTIONS(2194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2194),
    [anon_sym_let] = ACTIONS(2194),
    [anon_sym_This] = ACTIONS(2194),
    [anon_sym_decltype] = ACTIONS(2194),
    [sym_virtual] = ACTIONS(2194),
    [anon_sym_explicit] = ACTIONS(2194),
    [anon_sym_typename] = ACTIONS(2194),
    [anon_sym_template] = ACTIONS(2194),
    [anon_sym_operator] = ACTIONS(2194),
    [anon_sym_try] = ACTIONS(2194),
    [anon_sym_delete] = ACTIONS(2194),
    [anon_sym_throw] = ACTIONS(2194),
    [anon_sym_namespace] = ACTIONS(2194),
    [anon_sym_using] = ACTIONS(2194),
    [anon_sym_static_assert] = ACTIONS(2194),
    [anon_sym_concept] = ACTIONS(2194),
    [anon_sym_co_return] = ACTIONS(2194),
    [anon_sym_co_yield] = ACTIONS(2194),
    [anon_sym_R_DQUOTE] = ACTIONS(2196),
    [anon_sym_LR_DQUOTE] = ACTIONS(2196),
    [anon_sym_uR_DQUOTE] = ACTIONS(2196),
    [anon_sym_UR_DQUOTE] = ACTIONS(2196),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2196),
    [anon_sym_co_await] = ACTIONS(2194),
    [anon_sym_new] = ACTIONS(2194),
    [anon_sym_requires] = ACTIONS(2194),
    [sym_this] = ACTIONS(2194),
    [anon_sym_discard] = ACTIONS(2194),
    [anon_sym_precise] = ACTIONS(2194),
    [anon_sym_shared] = ACTIONS(2194),
    [anon_sym_groupshared] = ACTIONS(2194),
    [anon_sym_uniform] = ACTIONS(2194),
    [anon_sym_row_major] = ACTIONS(2194),
    [anon_sym_column_major] = ACTIONS(2194),
    [anon_sym_globallycoherent] = ACTIONS(2194),
    [anon_sym_centroid] = ACTIONS(2194),
    [anon_sym_noperspective] = ACTIONS(2194),
    [anon_sym_nointerpolation] = ACTIONS(2194),
    [anon_sym_sample] = ACTIONS(2194),
    [anon_sym_linear] = ACTIONS(2194),
    [anon_sym_snorm] = ACTIONS(2194),
    [anon_sym_unorm] = ACTIONS(2194),
    [anon_sym_point] = ACTIONS(2194),
    [anon_sym_line] = ACTIONS(2194),
    [anon_sym_triangleadj] = ACTIONS(2194),
    [anon_sym_lineadj] = ACTIONS(2194),
    [anon_sym_triangle] = ACTIONS(2194),
    [anon_sym_cbuffer] = ACTIONS(2194),
    [anon_sym_interface] = ACTIONS(2194),
    [anon_sym_extension] = ACTIONS(2194),
  },
  [108] = {
    [sym_identifier] = ACTIONS(2198),
    [aux_sym_preproc_include_token1] = ACTIONS(2198),
    [aux_sym_preproc_def_token1] = ACTIONS(2198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_COMMA] = ACTIONS(2200),
    [aux_sym_preproc_if_token1] = ACTIONS(2198),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2198),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2198),
    [sym_preproc_directive] = ACTIONS(2198),
    [anon_sym_LPAREN2] = ACTIONS(2200),
    [anon_sym_BANG] = ACTIONS(2198),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(2198),
    [anon_sym_SLASH] = ACTIONS(2198),
    [anon_sym_PERCENT] = ACTIONS(2198),
    [anon_sym_PIPE_PIPE] = ACTIONS(2200),
    [anon_sym_AMP_AMP] = ACTIONS(2200),
    [anon_sym_PIPE] = ACTIONS(2198),
    [anon_sym_CARET] = ACTIONS(2198),
    [anon_sym_AMP] = ACTIONS(2198),
    [anon_sym_EQ_EQ] = ACTIONS(2200),
    [anon_sym_BANG_EQ] = ACTIONS(2200),
    [anon_sym_GT] = ACTIONS(2198),
    [anon_sym_GT_EQ] = ACTIONS(2200),
    [anon_sym_LT_EQ] = ACTIONS(2198),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_LT_LT] = ACTIONS(2198),
    [anon_sym_GT_GT] = ACTIONS(2198),
    [anon_sym_SEMI] = ACTIONS(2200),
    [anon_sym___extension__] = ACTIONS(2198),
    [anon_sym_typedef] = ACTIONS(2198),
    [anon_sym_in] = ACTIONS(2198),
    [anon_sym_out] = ACTIONS(2198),
    [anon_sym_inout] = ACTIONS(2198),
    [anon_sym_extern] = ACTIONS(2198),
    [anon_sym___attribute__] = ACTIONS(2198),
    [anon_sym_COLON_COLON] = ACTIONS(2200),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2200),
    [anon_sym___declspec] = ACTIONS(2198),
    [anon_sym___based] = ACTIONS(2198),
    [anon_sym___cdecl] = ACTIONS(2198),
    [anon_sym___clrcall] = ACTIONS(2198),
    [anon_sym___stdcall] = ACTIONS(2198),
    [anon_sym___fastcall] = ACTIONS(2198),
    [anon_sym___thiscall] = ACTIONS(2198),
    [anon_sym___vectorcall] = ACTIONS(2198),
    [anon_sym_LBRACE] = ACTIONS(2200),
    [anon_sym_RBRACE] = ACTIONS(2200),
    [anon_sym_signed] = ACTIONS(2198),
    [anon_sym_unsigned] = ACTIONS(2198),
    [anon_sym_long] = ACTIONS(2198),
    [anon_sym_short] = ACTIONS(2198),
    [anon_sym_LBRACK] = ACTIONS(2198),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_EQ] = ACTIONS(2198),
    [anon_sym_register] = ACTIONS(2198),
    [anon_sym_inline] = ACTIONS(2198),
    [anon_sym___inline] = ACTIONS(2198),
    [anon_sym___inline__] = ACTIONS(2198),
    [anon_sym___forceinline] = ACTIONS(2198),
    [anon_sym_thread_local] = ACTIONS(2198),
    [anon_sym___thread] = ACTIONS(2198),
    [anon_sym_const] = ACTIONS(2198),
    [anon_sym_constexpr] = ACTIONS(2198),
    [anon_sym_volatile] = ACTIONS(2198),
    [anon_sym_restrict] = ACTIONS(2198),
    [anon_sym___restrict__] = ACTIONS(2198),
    [anon_sym__Atomic] = ACTIONS(2198),
    [anon_sym__Noreturn] = ACTIONS(2198),
    [anon_sym_noreturn] = ACTIONS(2198),
    [anon_sym_mutable] = ACTIONS(2198),
    [anon_sym_constinit] = ACTIONS(2198),
    [anon_sym_consteval] = ACTIONS(2198),
    [anon_sym_alignas] = ACTIONS(2198),
    [anon_sym__Alignas] = ACTIONS(2198),
    [sym_primitive_type] = ACTIONS(2198),
    [anon_sym_enum] = ACTIONS(2198),
    [anon_sym_class] = ACTIONS(2198),
    [anon_sym_struct] = ACTIONS(2198),
    [anon_sym_union] = ACTIONS(2198),
    [anon_sym_if] = ACTIONS(2198),
    [anon_sym_switch] = ACTIONS(2198),
    [anon_sym_case] = ACTIONS(2198),
    [anon_sym_default] = ACTIONS(2198),
    [anon_sym_while] = ACTIONS(2198),
    [anon_sym_do] = ACTIONS(2198),
    [anon_sym_for] = ACTIONS(2198),
    [anon_sym_return] = ACTIONS(2198),
    [anon_sym_break] = ACTIONS(2198),
    [anon_sym_continue] = ACTIONS(2198),
    [anon_sym_goto] = ACTIONS(2198),
    [anon_sym___try] = ACTIONS(2198),
    [anon_sym___leave] = ACTIONS(2198),
    [anon_sym_QMARK] = ACTIONS(2200),
    [anon_sym_STAR_EQ] = ACTIONS(2200),
    [anon_sym_SLASH_EQ] = ACTIONS(2200),
    [anon_sym_PERCENT_EQ] = ACTIONS(2200),
    [anon_sym_PLUS_EQ] = ACTIONS(2200),
    [anon_sym_DASH_EQ] = ACTIONS(2200),
    [anon_sym_LT_LT_EQ] = ACTIONS(2200),
    [anon_sym_GT_GT_EQ] = ACTIONS(2200),
    [anon_sym_AMP_EQ] = ACTIONS(2200),
    [anon_sym_CARET_EQ] = ACTIONS(2200),
    [anon_sym_PIPE_EQ] = ACTIONS(2200),
    [anon_sym_and_eq] = ACTIONS(2198),
    [anon_sym_or_eq] = ACTIONS(2198),
    [anon_sym_xor_eq] = ACTIONS(2198),
    [anon_sym_not] = ACTIONS(2198),
    [anon_sym_compl] = ACTIONS(2198),
    [anon_sym_LT_EQ_GT] = ACTIONS(2200),
    [anon_sym_or] = ACTIONS(2198),
    [anon_sym_and] = ACTIONS(2198),
    [anon_sym_bitor] = ACTIONS(2198),
    [anon_sym_xor] = ACTIONS(2198),
    [anon_sym_bitand] = ACTIONS(2198),
    [anon_sym_not_eq] = ACTIONS(2198),
    [anon_sym_is] = ACTIONS(2198),
    [anon_sym_as] = ACTIONS(2198),
    [anon_sym_DASH_DASH] = ACTIONS(2200),
    [anon_sym_PLUS_PLUS] = ACTIONS(2200),
    [anon_sym_sizeof] = ACTIONS(2198),
    [anon_sym___alignof__] = ACTIONS(2198),
    [anon_sym___alignof] = ACTIONS(2198),
    [anon_sym__alignof] = ACTIONS(2198),
    [anon_sym_alignof] = ACTIONS(2198),
    [anon_sym__Alignof] = ACTIONS(2198),
    [anon_sym_offsetof] = ACTIONS(2198),
    [anon_sym__Generic] = ACTIONS(2198),
    [anon_sym_asm] = ACTIONS(2198),
    [anon_sym___asm__] = ACTIONS(2198),
    [anon_sym_DOT] = ACTIONS(2198),
    [anon_sym_DOT_STAR] = ACTIONS(2200),
    [anon_sym_DASH_GT] = ACTIONS(2200),
    [sym_number_literal] = ACTIONS(2200),
    [anon_sym_L_SQUOTE] = ACTIONS(2200),
    [anon_sym_u_SQUOTE] = ACTIONS(2200),
    [anon_sym_U_SQUOTE] = ACTIONS(2200),
    [anon_sym_u8_SQUOTE] = ACTIONS(2200),
    [anon_sym_SQUOTE] = ACTIONS(2200),
    [anon_sym_L_DQUOTE] = ACTIONS(2200),
    [anon_sym_u_DQUOTE] = ACTIONS(2200),
    [anon_sym_U_DQUOTE] = ACTIONS(2200),
    [anon_sym_u8_DQUOTE] = ACTIONS(2200),
    [anon_sym_DQUOTE] = ACTIONS(2200),
    [sym_true] = ACTIONS(2198),
    [sym_false] = ACTIONS(2198),
    [anon_sym_NULL] = ACTIONS(2198),
    [anon_sym_nullptr] = ACTIONS(2198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2198),
    [anon_sym_let] = ACTIONS(2198),
    [anon_sym_This] = ACTIONS(2198),
    [anon_sym_decltype] = ACTIONS(2198),
    [sym_virtual] = ACTIONS(2198),
    [anon_sym_explicit] = ACTIONS(2198),
    [anon_sym_typename] = ACTIONS(2198),
    [anon_sym_template] = ACTIONS(2198),
    [anon_sym_operator] = ACTIONS(2198),
    [anon_sym_try] = ACTIONS(2198),
    [anon_sym_delete] = ACTIONS(2198),
    [anon_sym_throw] = ACTIONS(2198),
    [anon_sym_namespace] = ACTIONS(2198),
    [anon_sym_using] = ACTIONS(2198),
    [anon_sym_static_assert] = ACTIONS(2198),
    [anon_sym_concept] = ACTIONS(2198),
    [anon_sym_co_return] = ACTIONS(2198),
    [anon_sym_co_yield] = ACTIONS(2198),
    [anon_sym_R_DQUOTE] = ACTIONS(2200),
    [anon_sym_LR_DQUOTE] = ACTIONS(2200),
    [anon_sym_uR_DQUOTE] = ACTIONS(2200),
    [anon_sym_UR_DQUOTE] = ACTIONS(2200),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2200),
    [anon_sym_co_await] = ACTIONS(2198),
    [anon_sym_new] = ACTIONS(2198),
    [anon_sym_requires] = ACTIONS(2198),
    [sym_this] = ACTIONS(2198),
    [anon_sym_discard] = ACTIONS(2198),
    [anon_sym_precise] = ACTIONS(2198),
    [anon_sym_shared] = ACTIONS(2198),
    [anon_sym_groupshared] = ACTIONS(2198),
    [anon_sym_uniform] = ACTIONS(2198),
    [anon_sym_row_major] = ACTIONS(2198),
    [anon_sym_column_major] = ACTIONS(2198),
    [anon_sym_globallycoherent] = ACTIONS(2198),
    [anon_sym_centroid] = ACTIONS(2198),
    [anon_sym_noperspective] = ACTIONS(2198),
    [anon_sym_nointerpolation] = ACTIONS(2198),
    [anon_sym_sample] = ACTIONS(2198),
    [anon_sym_linear] = ACTIONS(2198),
    [anon_sym_snorm] = ACTIONS(2198),
    [anon_sym_unorm] = ACTIONS(2198),
    [anon_sym_point] = ACTIONS(2198),
    [anon_sym_line] = ACTIONS(2198),
    [anon_sym_triangleadj] = ACTIONS(2198),
    [anon_sym_lineadj] = ACTIONS(2198),
    [anon_sym_triangle] = ACTIONS(2198),
    [anon_sym_cbuffer] = ACTIONS(2198),
    [anon_sym_interface] = ACTIONS(2198),
    [anon_sym_extension] = ACTIONS(2198),
  },
  [109] = {
    [sym_identifier] = ACTIONS(2202),
    [aux_sym_preproc_include_token1] = ACTIONS(2202),
    [aux_sym_preproc_def_token1] = ACTIONS(2202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2204),
    [aux_sym_preproc_if_token1] = ACTIONS(2202),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2202),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2202),
    [sym_preproc_directive] = ACTIONS(2202),
    [anon_sym_LPAREN2] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2202),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2202),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_STAR] = ACTIONS(2202),
    [anon_sym_SLASH] = ACTIONS(2202),
    [anon_sym_PERCENT] = ACTIONS(2202),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2202),
    [anon_sym_CARET] = ACTIONS(2202),
    [anon_sym_AMP] = ACTIONS(2202),
    [anon_sym_EQ_EQ] = ACTIONS(2204),
    [anon_sym_BANG_EQ] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(2202),
    [anon_sym_GT_EQ] = ACTIONS(2204),
    [anon_sym_LT_EQ] = ACTIONS(2202),
    [anon_sym_LT] = ACTIONS(2202),
    [anon_sym_LT_LT] = ACTIONS(2202),
    [anon_sym_GT_GT] = ACTIONS(2202),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym___extension__] = ACTIONS(2202),
    [anon_sym_typedef] = ACTIONS(2202),
    [anon_sym_in] = ACTIONS(2202),
    [anon_sym_out] = ACTIONS(2202),
    [anon_sym_inout] = ACTIONS(2202),
    [anon_sym_extern] = ACTIONS(2202),
    [anon_sym___attribute__] = ACTIONS(2202),
    [anon_sym_COLON_COLON] = ACTIONS(2204),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2204),
    [anon_sym___declspec] = ACTIONS(2202),
    [anon_sym___based] = ACTIONS(2202),
    [anon_sym___cdecl] = ACTIONS(2202),
    [anon_sym___clrcall] = ACTIONS(2202),
    [anon_sym___stdcall] = ACTIONS(2202),
    [anon_sym___fastcall] = ACTIONS(2202),
    [anon_sym___thiscall] = ACTIONS(2202),
    [anon_sym___vectorcall] = ACTIONS(2202),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_signed] = ACTIONS(2202),
    [anon_sym_unsigned] = ACTIONS(2202),
    [anon_sym_long] = ACTIONS(2202),
    [anon_sym_short] = ACTIONS(2202),
    [anon_sym_LBRACK] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2202),
    [anon_sym_EQ] = ACTIONS(2202),
    [anon_sym_register] = ACTIONS(2202),
    [anon_sym_inline] = ACTIONS(2202),
    [anon_sym___inline] = ACTIONS(2202),
    [anon_sym___inline__] = ACTIONS(2202),
    [anon_sym___forceinline] = ACTIONS(2202),
    [anon_sym_thread_local] = ACTIONS(2202),
    [anon_sym___thread] = ACTIONS(2202),
    [anon_sym_const] = ACTIONS(2202),
    [anon_sym_constexpr] = ACTIONS(2202),
    [anon_sym_volatile] = ACTIONS(2202),
    [anon_sym_restrict] = ACTIONS(2202),
    [anon_sym___restrict__] = ACTIONS(2202),
    [anon_sym__Atomic] = ACTIONS(2202),
    [anon_sym__Noreturn] = ACTIONS(2202),
    [anon_sym_noreturn] = ACTIONS(2202),
    [anon_sym_mutable] = ACTIONS(2202),
    [anon_sym_constinit] = ACTIONS(2202),
    [anon_sym_consteval] = ACTIONS(2202),
    [anon_sym_alignas] = ACTIONS(2202),
    [anon_sym__Alignas] = ACTIONS(2202),
    [sym_primitive_type] = ACTIONS(2202),
    [anon_sym_enum] = ACTIONS(2202),
    [anon_sym_class] = ACTIONS(2202),
    [anon_sym_struct] = ACTIONS(2202),
    [anon_sym_union] = ACTIONS(2202),
    [anon_sym_if] = ACTIONS(2202),
    [anon_sym_switch] = ACTIONS(2202),
    [anon_sym_case] = ACTIONS(2202),
    [anon_sym_default] = ACTIONS(2202),
    [anon_sym_while] = ACTIONS(2202),
    [anon_sym_do] = ACTIONS(2202),
    [anon_sym_for] = ACTIONS(2202),
    [anon_sym_return] = ACTIONS(2202),
    [anon_sym_break] = ACTIONS(2202),
    [anon_sym_continue] = ACTIONS(2202),
    [anon_sym_goto] = ACTIONS(2202),
    [anon_sym___try] = ACTIONS(2202),
    [anon_sym___leave] = ACTIONS(2202),
    [anon_sym_QMARK] = ACTIONS(2204),
    [anon_sym_STAR_EQ] = ACTIONS(2204),
    [anon_sym_SLASH_EQ] = ACTIONS(2204),
    [anon_sym_PERCENT_EQ] = ACTIONS(2204),
    [anon_sym_PLUS_EQ] = ACTIONS(2204),
    [anon_sym_DASH_EQ] = ACTIONS(2204),
    [anon_sym_LT_LT_EQ] = ACTIONS(2204),
    [anon_sym_GT_GT_EQ] = ACTIONS(2204),
    [anon_sym_AMP_EQ] = ACTIONS(2204),
    [anon_sym_CARET_EQ] = ACTIONS(2204),
    [anon_sym_PIPE_EQ] = ACTIONS(2204),
    [anon_sym_and_eq] = ACTIONS(2202),
    [anon_sym_or_eq] = ACTIONS(2202),
    [anon_sym_xor_eq] = ACTIONS(2202),
    [anon_sym_not] = ACTIONS(2202),
    [anon_sym_compl] = ACTIONS(2202),
    [anon_sym_LT_EQ_GT] = ACTIONS(2204),
    [anon_sym_or] = ACTIONS(2202),
    [anon_sym_and] = ACTIONS(2202),
    [anon_sym_bitor] = ACTIONS(2202),
    [anon_sym_xor] = ACTIONS(2202),
    [anon_sym_bitand] = ACTIONS(2202),
    [anon_sym_not_eq] = ACTIONS(2202),
    [anon_sym_is] = ACTIONS(2202),
    [anon_sym_as] = ACTIONS(2202),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_sizeof] = ACTIONS(2202),
    [anon_sym___alignof__] = ACTIONS(2202),
    [anon_sym___alignof] = ACTIONS(2202),
    [anon_sym__alignof] = ACTIONS(2202),
    [anon_sym_alignof] = ACTIONS(2202),
    [anon_sym__Alignof] = ACTIONS(2202),
    [anon_sym_offsetof] = ACTIONS(2202),
    [anon_sym__Generic] = ACTIONS(2202),
    [anon_sym_asm] = ACTIONS(2202),
    [anon_sym___asm__] = ACTIONS(2202),
    [anon_sym_DOT] = ACTIONS(2202),
    [anon_sym_DOT_STAR] = ACTIONS(2204),
    [anon_sym_DASH_GT] = ACTIONS(2204),
    [sym_number_literal] = ACTIONS(2204),
    [anon_sym_L_SQUOTE] = ACTIONS(2204),
    [anon_sym_u_SQUOTE] = ACTIONS(2204),
    [anon_sym_U_SQUOTE] = ACTIONS(2204),
    [anon_sym_u8_SQUOTE] = ACTIONS(2204),
    [anon_sym_SQUOTE] = ACTIONS(2204),
    [anon_sym_L_DQUOTE] = ACTIONS(2204),
    [anon_sym_u_DQUOTE] = ACTIONS(2204),
    [anon_sym_U_DQUOTE] = ACTIONS(2204),
    [anon_sym_u8_DQUOTE] = ACTIONS(2204),
    [anon_sym_DQUOTE] = ACTIONS(2204),
    [sym_true] = ACTIONS(2202),
    [sym_false] = ACTIONS(2202),
    [anon_sym_NULL] = ACTIONS(2202),
    [anon_sym_nullptr] = ACTIONS(2202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2202),
    [anon_sym_let] = ACTIONS(2202),
    [anon_sym_This] = ACTIONS(2202),
    [anon_sym_decltype] = ACTIONS(2202),
    [sym_virtual] = ACTIONS(2202),
    [anon_sym_explicit] = ACTIONS(2202),
    [anon_sym_typename] = ACTIONS(2202),
    [anon_sym_template] = ACTIONS(2202),
    [anon_sym_operator] = ACTIONS(2202),
    [anon_sym_try] = ACTIONS(2202),
    [anon_sym_delete] = ACTIONS(2202),
    [anon_sym_throw] = ACTIONS(2202),
    [anon_sym_namespace] = ACTIONS(2202),
    [anon_sym_using] = ACTIONS(2202),
    [anon_sym_static_assert] = ACTIONS(2202),
    [anon_sym_concept] = ACTIONS(2202),
    [anon_sym_co_return] = ACTIONS(2202),
    [anon_sym_co_yield] = ACTIONS(2202),
    [anon_sym_R_DQUOTE] = ACTIONS(2204),
    [anon_sym_LR_DQUOTE] = ACTIONS(2204),
    [anon_sym_uR_DQUOTE] = ACTIONS(2204),
    [anon_sym_UR_DQUOTE] = ACTIONS(2204),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2204),
    [anon_sym_co_await] = ACTIONS(2202),
    [anon_sym_new] = ACTIONS(2202),
    [anon_sym_requires] = ACTIONS(2202),
    [sym_this] = ACTIONS(2202),
    [anon_sym_discard] = ACTIONS(2202),
    [anon_sym_precise] = ACTIONS(2202),
    [anon_sym_shared] = ACTIONS(2202),
    [anon_sym_groupshared] = ACTIONS(2202),
    [anon_sym_uniform] = ACTIONS(2202),
    [anon_sym_row_major] = ACTIONS(2202),
    [anon_sym_column_major] = ACTIONS(2202),
    [anon_sym_globallycoherent] = ACTIONS(2202),
    [anon_sym_centroid] = ACTIONS(2202),
    [anon_sym_noperspective] = ACTIONS(2202),
    [anon_sym_nointerpolation] = ACTIONS(2202),
    [anon_sym_sample] = ACTIONS(2202),
    [anon_sym_linear] = ACTIONS(2202),
    [anon_sym_snorm] = ACTIONS(2202),
    [anon_sym_unorm] = ACTIONS(2202),
    [anon_sym_point] = ACTIONS(2202),
    [anon_sym_line] = ACTIONS(2202),
    [anon_sym_triangleadj] = ACTIONS(2202),
    [anon_sym_lineadj] = ACTIONS(2202),
    [anon_sym_triangle] = ACTIONS(2202),
    [anon_sym_cbuffer] = ACTIONS(2202),
    [anon_sym_interface] = ACTIONS(2202),
    [anon_sym_extension] = ACTIONS(2202),
  },
  [110] = {
    [sym_identifier] = ACTIONS(2206),
    [aux_sym_preproc_include_token1] = ACTIONS(2206),
    [aux_sym_preproc_def_token1] = ACTIONS(2206),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2208),
    [anon_sym_COMMA] = ACTIONS(2208),
    [aux_sym_preproc_if_token1] = ACTIONS(2206),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2206),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2206),
    [sym_preproc_directive] = ACTIONS(2206),
    [anon_sym_LPAREN2] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2208),
    [anon_sym_DASH] = ACTIONS(2206),
    [anon_sym_PLUS] = ACTIONS(2206),
    [anon_sym_STAR] = ACTIONS(2206),
    [anon_sym_SLASH] = ACTIONS(2206),
    [anon_sym_PERCENT] = ACTIONS(2206),
    [anon_sym_PIPE_PIPE] = ACTIONS(2208),
    [anon_sym_AMP_AMP] = ACTIONS(2208),
    [anon_sym_PIPE] = ACTIONS(2206),
    [anon_sym_CARET] = ACTIONS(2206),
    [anon_sym_AMP] = ACTIONS(2206),
    [anon_sym_EQ_EQ] = ACTIONS(2208),
    [anon_sym_BANG_EQ] = ACTIONS(2208),
    [anon_sym_GT] = ACTIONS(2206),
    [anon_sym_GT_EQ] = ACTIONS(2208),
    [anon_sym_LT_EQ] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2206),
    [anon_sym_LT_LT] = ACTIONS(2206),
    [anon_sym_GT_GT] = ACTIONS(2206),
    [anon_sym_SEMI] = ACTIONS(2208),
    [anon_sym___extension__] = ACTIONS(2206),
    [anon_sym_typedef] = ACTIONS(2206),
    [anon_sym_in] = ACTIONS(2206),
    [anon_sym_out] = ACTIONS(2206),
    [anon_sym_inout] = ACTIONS(2206),
    [anon_sym_extern] = ACTIONS(2206),
    [anon_sym___attribute__] = ACTIONS(2206),
    [anon_sym_COLON_COLON] = ACTIONS(2208),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2208),
    [anon_sym___declspec] = ACTIONS(2206),
    [anon_sym___based] = ACTIONS(2206),
    [anon_sym___cdecl] = ACTIONS(2206),
    [anon_sym___clrcall] = ACTIONS(2206),
    [anon_sym___stdcall] = ACTIONS(2206),
    [anon_sym___fastcall] = ACTIONS(2206),
    [anon_sym___thiscall] = ACTIONS(2206),
    [anon_sym___vectorcall] = ACTIONS(2206),
    [anon_sym_LBRACE] = ACTIONS(2208),
    [anon_sym_RBRACE] = ACTIONS(2208),
    [anon_sym_signed] = ACTIONS(2206),
    [anon_sym_unsigned] = ACTIONS(2206),
    [anon_sym_long] = ACTIONS(2206),
    [anon_sym_short] = ACTIONS(2206),
    [anon_sym_LBRACK] = ACTIONS(2206),
    [anon_sym_static] = ACTIONS(2206),
    [anon_sym_EQ] = ACTIONS(2206),
    [anon_sym_register] = ACTIONS(2206),
    [anon_sym_inline] = ACTIONS(2206),
    [anon_sym___inline] = ACTIONS(2206),
    [anon_sym___inline__] = ACTIONS(2206),
    [anon_sym___forceinline] = ACTIONS(2206),
    [anon_sym_thread_local] = ACTIONS(2206),
    [anon_sym___thread] = ACTIONS(2206),
    [anon_sym_const] = ACTIONS(2206),
    [anon_sym_constexpr] = ACTIONS(2206),
    [anon_sym_volatile] = ACTIONS(2206),
    [anon_sym_restrict] = ACTIONS(2206),
    [anon_sym___restrict__] = ACTIONS(2206),
    [anon_sym__Atomic] = ACTIONS(2206),
    [anon_sym__Noreturn] = ACTIONS(2206),
    [anon_sym_noreturn] = ACTIONS(2206),
    [anon_sym_mutable] = ACTIONS(2206),
    [anon_sym_constinit] = ACTIONS(2206),
    [anon_sym_consteval] = ACTIONS(2206),
    [anon_sym_alignas] = ACTIONS(2206),
    [anon_sym__Alignas] = ACTIONS(2206),
    [sym_primitive_type] = ACTIONS(2206),
    [anon_sym_enum] = ACTIONS(2206),
    [anon_sym_class] = ACTIONS(2206),
    [anon_sym_struct] = ACTIONS(2206),
    [anon_sym_union] = ACTIONS(2206),
    [anon_sym_if] = ACTIONS(2206),
    [anon_sym_switch] = ACTIONS(2206),
    [anon_sym_case] = ACTIONS(2206),
    [anon_sym_default] = ACTIONS(2206),
    [anon_sym_while] = ACTIONS(2206),
    [anon_sym_do] = ACTIONS(2206),
    [anon_sym_for] = ACTIONS(2206),
    [anon_sym_return] = ACTIONS(2206),
    [anon_sym_break] = ACTIONS(2206),
    [anon_sym_continue] = ACTIONS(2206),
    [anon_sym_goto] = ACTIONS(2206),
    [anon_sym___try] = ACTIONS(2206),
    [anon_sym___leave] = ACTIONS(2206),
    [anon_sym_QMARK] = ACTIONS(2208),
    [anon_sym_STAR_EQ] = ACTIONS(2208),
    [anon_sym_SLASH_EQ] = ACTIONS(2208),
    [anon_sym_PERCENT_EQ] = ACTIONS(2208),
    [anon_sym_PLUS_EQ] = ACTIONS(2208),
    [anon_sym_DASH_EQ] = ACTIONS(2208),
    [anon_sym_LT_LT_EQ] = ACTIONS(2208),
    [anon_sym_GT_GT_EQ] = ACTIONS(2208),
    [anon_sym_AMP_EQ] = ACTIONS(2208),
    [anon_sym_CARET_EQ] = ACTIONS(2208),
    [anon_sym_PIPE_EQ] = ACTIONS(2208),
    [anon_sym_and_eq] = ACTIONS(2206),
    [anon_sym_or_eq] = ACTIONS(2206),
    [anon_sym_xor_eq] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_compl] = ACTIONS(2206),
    [anon_sym_LT_EQ_GT] = ACTIONS(2208),
    [anon_sym_or] = ACTIONS(2206),
    [anon_sym_and] = ACTIONS(2206),
    [anon_sym_bitor] = ACTIONS(2206),
    [anon_sym_xor] = ACTIONS(2206),
    [anon_sym_bitand] = ACTIONS(2206),
    [anon_sym_not_eq] = ACTIONS(2206),
    [anon_sym_is] = ACTIONS(2206),
    [anon_sym_as] = ACTIONS(2206),
    [anon_sym_DASH_DASH] = ACTIONS(2208),
    [anon_sym_PLUS_PLUS] = ACTIONS(2208),
    [anon_sym_sizeof] = ACTIONS(2206),
    [anon_sym___alignof__] = ACTIONS(2206),
    [anon_sym___alignof] = ACTIONS(2206),
    [anon_sym__alignof] = ACTIONS(2206),
    [anon_sym_alignof] = ACTIONS(2206),
    [anon_sym__Alignof] = ACTIONS(2206),
    [anon_sym_offsetof] = ACTIONS(2206),
    [anon_sym__Generic] = ACTIONS(2206),
    [anon_sym_asm] = ACTIONS(2206),
    [anon_sym___asm__] = ACTIONS(2206),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_DOT_STAR] = ACTIONS(2208),
    [anon_sym_DASH_GT] = ACTIONS(2208),
    [sym_number_literal] = ACTIONS(2208),
    [anon_sym_L_SQUOTE] = ACTIONS(2208),
    [anon_sym_u_SQUOTE] = ACTIONS(2208),
    [anon_sym_U_SQUOTE] = ACTIONS(2208),
    [anon_sym_u8_SQUOTE] = ACTIONS(2208),
    [anon_sym_SQUOTE] = ACTIONS(2208),
    [anon_sym_L_DQUOTE] = ACTIONS(2208),
    [anon_sym_u_DQUOTE] = ACTIONS(2208),
    [anon_sym_U_DQUOTE] = ACTIONS(2208),
    [anon_sym_u8_DQUOTE] = ACTIONS(2208),
    [anon_sym_DQUOTE] = ACTIONS(2208),
    [sym_true] = ACTIONS(2206),
    [sym_false] = ACTIONS(2206),
    [anon_sym_NULL] = ACTIONS(2206),
    [anon_sym_nullptr] = ACTIONS(2206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2206),
    [anon_sym_let] = ACTIONS(2206),
    [anon_sym_This] = ACTIONS(2206),
    [anon_sym_decltype] = ACTIONS(2206),
    [sym_virtual] = ACTIONS(2206),
    [anon_sym_explicit] = ACTIONS(2206),
    [anon_sym_typename] = ACTIONS(2206),
    [anon_sym_template] = ACTIONS(2206),
    [anon_sym_operator] = ACTIONS(2206),
    [anon_sym_try] = ACTIONS(2206),
    [anon_sym_delete] = ACTIONS(2206),
    [anon_sym_throw] = ACTIONS(2206),
    [anon_sym_namespace] = ACTIONS(2206),
    [anon_sym_using] = ACTIONS(2206),
    [anon_sym_static_assert] = ACTIONS(2206),
    [anon_sym_concept] = ACTIONS(2206),
    [anon_sym_co_return] = ACTIONS(2206),
    [anon_sym_co_yield] = ACTIONS(2206),
    [anon_sym_R_DQUOTE] = ACTIONS(2208),
    [anon_sym_LR_DQUOTE] = ACTIONS(2208),
    [anon_sym_uR_DQUOTE] = ACTIONS(2208),
    [anon_sym_UR_DQUOTE] = ACTIONS(2208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2208),
    [anon_sym_co_await] = ACTIONS(2206),
    [anon_sym_new] = ACTIONS(2206),
    [anon_sym_requires] = ACTIONS(2206),
    [sym_this] = ACTIONS(2206),
    [anon_sym_discard] = ACTIONS(2206),
    [anon_sym_precise] = ACTIONS(2206),
    [anon_sym_shared] = ACTIONS(2206),
    [anon_sym_groupshared] = ACTIONS(2206),
    [anon_sym_uniform] = ACTIONS(2206),
    [anon_sym_row_major] = ACTIONS(2206),
    [anon_sym_column_major] = ACTIONS(2206),
    [anon_sym_globallycoherent] = ACTIONS(2206),
    [anon_sym_centroid] = ACTIONS(2206),
    [anon_sym_noperspective] = ACTIONS(2206),
    [anon_sym_nointerpolation] = ACTIONS(2206),
    [anon_sym_sample] = ACTIONS(2206),
    [anon_sym_linear] = ACTIONS(2206),
    [anon_sym_snorm] = ACTIONS(2206),
    [anon_sym_unorm] = ACTIONS(2206),
    [anon_sym_point] = ACTIONS(2206),
    [anon_sym_line] = ACTIONS(2206),
    [anon_sym_triangleadj] = ACTIONS(2206),
    [anon_sym_lineadj] = ACTIONS(2206),
    [anon_sym_triangle] = ACTIONS(2206),
    [anon_sym_cbuffer] = ACTIONS(2206),
    [anon_sym_interface] = ACTIONS(2206),
    [anon_sym_extension] = ACTIONS(2206),
  },
  [111] = {
    [sym_identifier] = ACTIONS(2210),
    [aux_sym_preproc_include_token1] = ACTIONS(2210),
    [aux_sym_preproc_def_token1] = ACTIONS(2210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2212),
    [anon_sym_COMMA] = ACTIONS(2212),
    [aux_sym_preproc_if_token1] = ACTIONS(2210),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2210),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2210),
    [sym_preproc_directive] = ACTIONS(2210),
    [anon_sym_LPAREN2] = ACTIONS(2214),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2217),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2219),
    [anon_sym_SLASH] = ACTIONS(2222),
    [anon_sym_PERCENT] = ACTIONS(2222),
    [anon_sym_PIPE_PIPE] = ACTIONS(2212),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2222),
    [anon_sym_CARET] = ACTIONS(2222),
    [anon_sym_AMP] = ACTIONS(2219),
    [anon_sym_EQ_EQ] = ACTIONS(2212),
    [anon_sym_BANG_EQ] = ACTIONS(2212),
    [anon_sym_GT] = ACTIONS(2222),
    [anon_sym_GT_EQ] = ACTIONS(2212),
    [anon_sym_LT_EQ] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(2222),
    [anon_sym_LT_LT] = ACTIONS(2222),
    [anon_sym_GT_GT] = ACTIONS(2222),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym___extension__] = ACTIONS(2210),
    [anon_sym_typedef] = ACTIONS(2210),
    [anon_sym_in] = ACTIONS(2210),
    [anon_sym_out] = ACTIONS(2210),
    [anon_sym_inout] = ACTIONS(2210),
    [anon_sym_extern] = ACTIONS(2210),
    [anon_sym___attribute__] = ACTIONS(2210),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2214),
    [anon_sym___declspec] = ACTIONS(2210),
    [anon_sym___based] = ACTIONS(2210),
    [anon_sym___cdecl] = ACTIONS(2210),
    [anon_sym___clrcall] = ACTIONS(2210),
    [anon_sym___stdcall] = ACTIONS(2210),
    [anon_sym___fastcall] = ACTIONS(2210),
    [anon_sym___thiscall] = ACTIONS(2210),
    [anon_sym___vectorcall] = ACTIONS(2210),
    [anon_sym_LBRACE] = ACTIONS(2217),
    [anon_sym_RBRACE] = ACTIONS(2217),
    [anon_sym_signed] = ACTIONS(2210),
    [anon_sym_unsigned] = ACTIONS(2210),
    [anon_sym_long] = ACTIONS(2210),
    [anon_sym_short] = ACTIONS(2210),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_static] = ACTIONS(2210),
    [anon_sym_EQ] = ACTIONS(2222),
    [anon_sym_register] = ACTIONS(2210),
    [anon_sym_inline] = ACTIONS(2210),
    [anon_sym___inline] = ACTIONS(2210),
    [anon_sym___inline__] = ACTIONS(2210),
    [anon_sym___forceinline] = ACTIONS(2210),
    [anon_sym_thread_local] = ACTIONS(2210),
    [anon_sym___thread] = ACTIONS(2210),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_constexpr] = ACTIONS(2210),
    [anon_sym_volatile] = ACTIONS(2210),
    [anon_sym_restrict] = ACTIONS(2210),
    [anon_sym___restrict__] = ACTIONS(2210),
    [anon_sym__Atomic] = ACTIONS(2210),
    [anon_sym__Noreturn] = ACTIONS(2210),
    [anon_sym_noreturn] = ACTIONS(2210),
    [anon_sym_mutable] = ACTIONS(2210),
    [anon_sym_constinit] = ACTIONS(2210),
    [anon_sym_consteval] = ACTIONS(2210),
    [anon_sym_alignas] = ACTIONS(2210),
    [anon_sym__Alignas] = ACTIONS(2210),
    [sym_primitive_type] = ACTIONS(2210),
    [anon_sym_enum] = ACTIONS(2210),
    [anon_sym_class] = ACTIONS(2210),
    [anon_sym_struct] = ACTIONS(2210),
    [anon_sym_union] = ACTIONS(2210),
    [anon_sym_if] = ACTIONS(2210),
    [anon_sym_switch] = ACTIONS(2210),
    [anon_sym_case] = ACTIONS(2210),
    [anon_sym_default] = ACTIONS(2210),
    [anon_sym_while] = ACTIONS(2210),
    [anon_sym_do] = ACTIONS(2210),
    [anon_sym_for] = ACTIONS(2210),
    [anon_sym_return] = ACTIONS(2210),
    [anon_sym_break] = ACTIONS(2210),
    [anon_sym_continue] = ACTIONS(2210),
    [anon_sym_goto] = ACTIONS(2210),
    [anon_sym___try] = ACTIONS(2210),
    [anon_sym___leave] = ACTIONS(2210),
    [anon_sym_QMARK] = ACTIONS(2212),
    [anon_sym_STAR_EQ] = ACTIONS(2212),
    [anon_sym_SLASH_EQ] = ACTIONS(2212),
    [anon_sym_PERCENT_EQ] = ACTIONS(2212),
    [anon_sym_PLUS_EQ] = ACTIONS(2212),
    [anon_sym_DASH_EQ] = ACTIONS(2212),
    [anon_sym_LT_LT_EQ] = ACTIONS(2212),
    [anon_sym_GT_GT_EQ] = ACTIONS(2212),
    [anon_sym_AMP_EQ] = ACTIONS(2212),
    [anon_sym_CARET_EQ] = ACTIONS(2212),
    [anon_sym_PIPE_EQ] = ACTIONS(2212),
    [anon_sym_and_eq] = ACTIONS(2222),
    [anon_sym_or_eq] = ACTIONS(2222),
    [anon_sym_xor_eq] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2210),
    [anon_sym_compl] = ACTIONS(2210),
    [anon_sym_LT_EQ_GT] = ACTIONS(2212),
    [anon_sym_or] = ACTIONS(2222),
    [anon_sym_and] = ACTIONS(2222),
    [anon_sym_bitor] = ACTIONS(2222),
    [anon_sym_xor] = ACTIONS(2222),
    [anon_sym_bitand] = ACTIONS(2222),
    [anon_sym_not_eq] = ACTIONS(2222),
    [anon_sym_is] = ACTIONS(2222),
    [anon_sym_as] = ACTIONS(2222),
    [anon_sym_DASH_DASH] = ACTIONS(2214),
    [anon_sym_PLUS_PLUS] = ACTIONS(2214),
    [anon_sym_sizeof] = ACTIONS(2210),
    [anon_sym___alignof__] = ACTIONS(2210),
    [anon_sym___alignof] = ACTIONS(2210),
    [anon_sym__alignof] = ACTIONS(2210),
    [anon_sym_alignof] = ACTIONS(2210),
    [anon_sym__Alignof] = ACTIONS(2210),
    [anon_sym_offsetof] = ACTIONS(2210),
    [anon_sym__Generic] = ACTIONS(2210),
    [anon_sym_asm] = ACTIONS(2210),
    [anon_sym___asm__] = ACTIONS(2210),
    [anon_sym_DOT] = ACTIONS(2219),
    [anon_sym_DOT_STAR] = ACTIONS(2212),
    [anon_sym_DASH_GT] = ACTIONS(2212),
    [sym_number_literal] = ACTIONS(2217),
    [anon_sym_L_SQUOTE] = ACTIONS(2217),
    [anon_sym_u_SQUOTE] = ACTIONS(2217),
    [anon_sym_U_SQUOTE] = ACTIONS(2217),
    [anon_sym_u8_SQUOTE] = ACTIONS(2217),
    [anon_sym_SQUOTE] = ACTIONS(2217),
    [anon_sym_L_DQUOTE] = ACTIONS(2217),
    [anon_sym_u_DQUOTE] = ACTIONS(2217),
    [anon_sym_U_DQUOTE] = ACTIONS(2217),
    [anon_sym_u8_DQUOTE] = ACTIONS(2217),
    [anon_sym_DQUOTE] = ACTIONS(2217),
    [sym_true] = ACTIONS(2210),
    [sym_false] = ACTIONS(2210),
    [anon_sym_NULL] = ACTIONS(2210),
    [anon_sym_nullptr] = ACTIONS(2210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2210),
    [anon_sym_let] = ACTIONS(2210),
    [anon_sym_This] = ACTIONS(2210),
    [anon_sym_decltype] = ACTIONS(2210),
    [sym_virtual] = ACTIONS(2210),
    [anon_sym_explicit] = ACTIONS(2210),
    [anon_sym_typename] = ACTIONS(2210),
    [anon_sym_template] = ACTIONS(2210),
    [anon_sym_operator] = ACTIONS(2210),
    [anon_sym_try] = ACTIONS(2210),
    [anon_sym_delete] = ACTIONS(2210),
    [anon_sym_throw] = ACTIONS(2210),
    [anon_sym_namespace] = ACTIONS(2210),
    [anon_sym_using] = ACTIONS(2210),
    [anon_sym_static_assert] = ACTIONS(2210),
    [anon_sym_concept] = ACTIONS(2210),
    [anon_sym_co_return] = ACTIONS(2210),
    [anon_sym_co_yield] = ACTIONS(2210),
    [anon_sym_R_DQUOTE] = ACTIONS(2217),
    [anon_sym_LR_DQUOTE] = ACTIONS(2217),
    [anon_sym_uR_DQUOTE] = ACTIONS(2217),
    [anon_sym_UR_DQUOTE] = ACTIONS(2217),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2217),
    [anon_sym_co_await] = ACTIONS(2210),
    [anon_sym_new] = ACTIONS(2210),
    [anon_sym_requires] = ACTIONS(2210),
    [sym_this] = ACTIONS(2210),
    [anon_sym_discard] = ACTIONS(2210),
    [anon_sym_precise] = ACTIONS(2210),
    [anon_sym_shared] = ACTIONS(2210),
    [anon_sym_groupshared] = ACTIONS(2210),
    [anon_sym_uniform] = ACTIONS(2210),
    [anon_sym_row_major] = ACTIONS(2210),
    [anon_sym_column_major] = ACTIONS(2210),
    [anon_sym_globallycoherent] = ACTIONS(2210),
    [anon_sym_centroid] = ACTIONS(2210),
    [anon_sym_noperspective] = ACTIONS(2210),
    [anon_sym_nointerpolation] = ACTIONS(2210),
    [anon_sym_sample] = ACTIONS(2210),
    [anon_sym_linear] = ACTIONS(2210),
    [anon_sym_snorm] = ACTIONS(2210),
    [anon_sym_unorm] = ACTIONS(2210),
    [anon_sym_point] = ACTIONS(2210),
    [anon_sym_line] = ACTIONS(2210),
    [anon_sym_triangleadj] = ACTIONS(2210),
    [anon_sym_lineadj] = ACTIONS(2210),
    [anon_sym_triangle] = ACTIONS(2210),
    [anon_sym_cbuffer] = ACTIONS(2210),
    [anon_sym_interface] = ACTIONS(2210),
    [anon_sym_extension] = ACTIONS(2210),
  },
  [112] = {
    [sym_identifier] = ACTIONS(2224),
    [aux_sym_preproc_include_token1] = ACTIONS(2224),
    [aux_sym_preproc_def_token1] = ACTIONS(2224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2226),
    [anon_sym_COMMA] = ACTIONS(2226),
    [aux_sym_preproc_if_token1] = ACTIONS(2224),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2224),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2224),
    [sym_preproc_directive] = ACTIONS(2224),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_PLUS] = ACTIONS(2224),
    [anon_sym_STAR] = ACTIONS(2224),
    [anon_sym_SLASH] = ACTIONS(2224),
    [anon_sym_PERCENT] = ACTIONS(2224),
    [anon_sym_PIPE_PIPE] = ACTIONS(2226),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_PIPE] = ACTIONS(2224),
    [anon_sym_CARET] = ACTIONS(2224),
    [anon_sym_AMP] = ACTIONS(2224),
    [anon_sym_EQ_EQ] = ACTIONS(2226),
    [anon_sym_BANG_EQ] = ACTIONS(2226),
    [anon_sym_GT] = ACTIONS(2224),
    [anon_sym_GT_EQ] = ACTIONS(2226),
    [anon_sym_LT_EQ] = ACTIONS(2224),
    [anon_sym_LT] = ACTIONS(2224),
    [anon_sym_LT_LT] = ACTIONS(2224),
    [anon_sym_GT_GT] = ACTIONS(2224),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym___extension__] = ACTIONS(2224),
    [anon_sym_typedef] = ACTIONS(2224),
    [anon_sym_in] = ACTIONS(2224),
    [anon_sym_out] = ACTIONS(2224),
    [anon_sym_inout] = ACTIONS(2224),
    [anon_sym_extern] = ACTIONS(2224),
    [anon_sym___attribute__] = ACTIONS(2224),
    [anon_sym_COLON_COLON] = ACTIONS(2226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2226),
    [anon_sym___declspec] = ACTIONS(2224),
    [anon_sym___based] = ACTIONS(2224),
    [anon_sym___cdecl] = ACTIONS(2224),
    [anon_sym___clrcall] = ACTIONS(2224),
    [anon_sym___stdcall] = ACTIONS(2224),
    [anon_sym___fastcall] = ACTIONS(2224),
    [anon_sym___thiscall] = ACTIONS(2224),
    [anon_sym___vectorcall] = ACTIONS(2224),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_RBRACE] = ACTIONS(2226),
    [anon_sym_signed] = ACTIONS(2224),
    [anon_sym_unsigned] = ACTIONS(2224),
    [anon_sym_long] = ACTIONS(2224),
    [anon_sym_short] = ACTIONS(2224),
    [anon_sym_LBRACK] = ACTIONS(2224),
    [anon_sym_static] = ACTIONS(2224),
    [anon_sym_EQ] = ACTIONS(2224),
    [anon_sym_register] = ACTIONS(2224),
    [anon_sym_inline] = ACTIONS(2224),
    [anon_sym___inline] = ACTIONS(2224),
    [anon_sym___inline__] = ACTIONS(2224),
    [anon_sym___forceinline] = ACTIONS(2224),
    [anon_sym_thread_local] = ACTIONS(2224),
    [anon_sym___thread] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_constexpr] = ACTIONS(2224),
    [anon_sym_volatile] = ACTIONS(2224),
    [anon_sym_restrict] = ACTIONS(2224),
    [anon_sym___restrict__] = ACTIONS(2224),
    [anon_sym__Atomic] = ACTIONS(2224),
    [anon_sym__Noreturn] = ACTIONS(2224),
    [anon_sym_noreturn] = ACTIONS(2224),
    [anon_sym_mutable] = ACTIONS(2224),
    [anon_sym_constinit] = ACTIONS(2224),
    [anon_sym_consteval] = ACTIONS(2224),
    [anon_sym_alignas] = ACTIONS(2224),
    [anon_sym__Alignas] = ACTIONS(2224),
    [sym_primitive_type] = ACTIONS(2224),
    [anon_sym_enum] = ACTIONS(2224),
    [anon_sym_class] = ACTIONS(2224),
    [anon_sym_struct] = ACTIONS(2224),
    [anon_sym_union] = ACTIONS(2224),
    [anon_sym_if] = ACTIONS(2224),
    [anon_sym_switch] = ACTIONS(2224),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2224),
    [anon_sym_while] = ACTIONS(2224),
    [anon_sym_do] = ACTIONS(2224),
    [anon_sym_for] = ACTIONS(2224),
    [anon_sym_return] = ACTIONS(2224),
    [anon_sym_break] = ACTIONS(2224),
    [anon_sym_continue] = ACTIONS(2224),
    [anon_sym_goto] = ACTIONS(2224),
    [anon_sym___try] = ACTIONS(2224),
    [anon_sym___leave] = ACTIONS(2224),
    [anon_sym_QMARK] = ACTIONS(2226),
    [anon_sym_STAR_EQ] = ACTIONS(2226),
    [anon_sym_SLASH_EQ] = ACTIONS(2226),
    [anon_sym_PERCENT_EQ] = ACTIONS(2226),
    [anon_sym_PLUS_EQ] = ACTIONS(2226),
    [anon_sym_DASH_EQ] = ACTIONS(2226),
    [anon_sym_LT_LT_EQ] = ACTIONS(2226),
    [anon_sym_GT_GT_EQ] = ACTIONS(2226),
    [anon_sym_AMP_EQ] = ACTIONS(2226),
    [anon_sym_CARET_EQ] = ACTIONS(2226),
    [anon_sym_PIPE_EQ] = ACTIONS(2226),
    [anon_sym_and_eq] = ACTIONS(2224),
    [anon_sym_or_eq] = ACTIONS(2224),
    [anon_sym_xor_eq] = ACTIONS(2224),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_compl] = ACTIONS(2224),
    [anon_sym_LT_EQ_GT] = ACTIONS(2226),
    [anon_sym_or] = ACTIONS(2224),
    [anon_sym_and] = ACTIONS(2224),
    [anon_sym_bitor] = ACTIONS(2224),
    [anon_sym_xor] = ACTIONS(2224),
    [anon_sym_bitand] = ACTIONS(2224),
    [anon_sym_not_eq] = ACTIONS(2224),
    [anon_sym_is] = ACTIONS(2224),
    [anon_sym_as] = ACTIONS(2224),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_sizeof] = ACTIONS(2224),
    [anon_sym___alignof__] = ACTIONS(2224),
    [anon_sym___alignof] = ACTIONS(2224),
    [anon_sym__alignof] = ACTIONS(2224),
    [anon_sym_alignof] = ACTIONS(2224),
    [anon_sym__Alignof] = ACTIONS(2224),
    [anon_sym_offsetof] = ACTIONS(2224),
    [anon_sym__Generic] = ACTIONS(2224),
    [anon_sym_asm] = ACTIONS(2224),
    [anon_sym___asm__] = ACTIONS(2224),
    [anon_sym_DOT] = ACTIONS(2224),
    [anon_sym_DOT_STAR] = ACTIONS(2226),
    [anon_sym_DASH_GT] = ACTIONS(2226),
    [sym_number_literal] = ACTIONS(2226),
    [anon_sym_L_SQUOTE] = ACTIONS(2226),
    [anon_sym_u_SQUOTE] = ACTIONS(2226),
    [anon_sym_U_SQUOTE] = ACTIONS(2226),
    [anon_sym_u8_SQUOTE] = ACTIONS(2226),
    [anon_sym_SQUOTE] = ACTIONS(2226),
    [anon_sym_L_DQUOTE] = ACTIONS(2226),
    [anon_sym_u_DQUOTE] = ACTIONS(2226),
    [anon_sym_U_DQUOTE] = ACTIONS(2226),
    [anon_sym_u8_DQUOTE] = ACTIONS(2226),
    [anon_sym_DQUOTE] = ACTIONS(2226),
    [sym_true] = ACTIONS(2224),
    [sym_false] = ACTIONS(2224),
    [anon_sym_NULL] = ACTIONS(2224),
    [anon_sym_nullptr] = ACTIONS(2224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2224),
    [anon_sym_let] = ACTIONS(2224),
    [anon_sym_This] = ACTIONS(2224),
    [anon_sym_decltype] = ACTIONS(2224),
    [sym_virtual] = ACTIONS(2224),
    [anon_sym_explicit] = ACTIONS(2224),
    [anon_sym_typename] = ACTIONS(2224),
    [anon_sym_template] = ACTIONS(2224),
    [anon_sym_operator] = ACTIONS(2224),
    [anon_sym_try] = ACTIONS(2224),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_throw] = ACTIONS(2224),
    [anon_sym_namespace] = ACTIONS(2224),
    [anon_sym_using] = ACTIONS(2224),
    [anon_sym_static_assert] = ACTIONS(2224),
    [anon_sym_concept] = ACTIONS(2224),
    [anon_sym_co_return] = ACTIONS(2224),
    [anon_sym_co_yield] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(2226),
    [anon_sym_LR_DQUOTE] = ACTIONS(2226),
    [anon_sym_uR_DQUOTE] = ACTIONS(2226),
    [anon_sym_UR_DQUOTE] = ACTIONS(2226),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2226),
    [anon_sym_co_await] = ACTIONS(2224),
    [anon_sym_new] = ACTIONS(2224),
    [anon_sym_requires] = ACTIONS(2224),
    [sym_this] = ACTIONS(2224),
    [anon_sym_discard] = ACTIONS(2224),
    [anon_sym_precise] = ACTIONS(2224),
    [anon_sym_shared] = ACTIONS(2224),
    [anon_sym_groupshared] = ACTIONS(2224),
    [anon_sym_uniform] = ACTIONS(2224),
    [anon_sym_row_major] = ACTIONS(2224),
    [anon_sym_column_major] = ACTIONS(2224),
    [anon_sym_globallycoherent] = ACTIONS(2224),
    [anon_sym_centroid] = ACTIONS(2224),
    [anon_sym_noperspective] = ACTIONS(2224),
    [anon_sym_nointerpolation] = ACTIONS(2224),
    [anon_sym_sample] = ACTIONS(2224),
    [anon_sym_linear] = ACTIONS(2224),
    [anon_sym_snorm] = ACTIONS(2224),
    [anon_sym_unorm] = ACTIONS(2224),
    [anon_sym_point] = ACTIONS(2224),
    [anon_sym_line] = ACTIONS(2224),
    [anon_sym_triangleadj] = ACTIONS(2224),
    [anon_sym_lineadj] = ACTIONS(2224),
    [anon_sym_triangle] = ACTIONS(2224),
    [anon_sym_cbuffer] = ACTIONS(2224),
    [anon_sym_interface] = ACTIONS(2224),
    [anon_sym_extension] = ACTIONS(2224),
  },
  [113] = {
    [sym_identifier] = ACTIONS(2228),
    [aux_sym_preproc_include_token1] = ACTIONS(2228),
    [aux_sym_preproc_def_token1] = ACTIONS(2228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2230),
    [anon_sym_COMMA] = ACTIONS(2230),
    [aux_sym_preproc_if_token1] = ACTIONS(2228),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2228),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2228),
    [sym_preproc_directive] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2228),
    [anon_sym_PLUS] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(2228),
    [anon_sym_SLASH] = ACTIONS(2228),
    [anon_sym_PERCENT] = ACTIONS(2228),
    [anon_sym_PIPE_PIPE] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_PIPE] = ACTIONS(2228),
    [anon_sym_CARET] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2228),
    [anon_sym_EQ_EQ] = ACTIONS(2230),
    [anon_sym_BANG_EQ] = ACTIONS(2230),
    [anon_sym_GT] = ACTIONS(2228),
    [anon_sym_GT_EQ] = ACTIONS(2230),
    [anon_sym_LT_EQ] = ACTIONS(2228),
    [anon_sym_LT] = ACTIONS(2228),
    [anon_sym_LT_LT] = ACTIONS(2228),
    [anon_sym_GT_GT] = ACTIONS(2228),
    [anon_sym_SEMI] = ACTIONS(2230),
    [anon_sym___extension__] = ACTIONS(2228),
    [anon_sym_typedef] = ACTIONS(2228),
    [anon_sym_in] = ACTIONS(2228),
    [anon_sym_out] = ACTIONS(2228),
    [anon_sym_inout] = ACTIONS(2228),
    [anon_sym_extern] = ACTIONS(2228),
    [anon_sym___attribute__] = ACTIONS(2228),
    [anon_sym_COLON_COLON] = ACTIONS(2230),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2230),
    [anon_sym___declspec] = ACTIONS(2228),
    [anon_sym___based] = ACTIONS(2228),
    [anon_sym___cdecl] = ACTIONS(2228),
    [anon_sym___clrcall] = ACTIONS(2228),
    [anon_sym___stdcall] = ACTIONS(2228),
    [anon_sym___fastcall] = ACTIONS(2228),
    [anon_sym___thiscall] = ACTIONS(2228),
    [anon_sym___vectorcall] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_RBRACE] = ACTIONS(2230),
    [anon_sym_signed] = ACTIONS(2228),
    [anon_sym_unsigned] = ACTIONS(2228),
    [anon_sym_long] = ACTIONS(2228),
    [anon_sym_short] = ACTIONS(2228),
    [anon_sym_LBRACK] = ACTIONS(2228),
    [anon_sym_static] = ACTIONS(2228),
    [anon_sym_EQ] = ACTIONS(2228),
    [anon_sym_register] = ACTIONS(2228),
    [anon_sym_inline] = ACTIONS(2228),
    [anon_sym___inline] = ACTIONS(2228),
    [anon_sym___inline__] = ACTIONS(2228),
    [anon_sym___forceinline] = ACTIONS(2228),
    [anon_sym_thread_local] = ACTIONS(2228),
    [anon_sym___thread] = ACTIONS(2228),
    [anon_sym_const] = ACTIONS(2228),
    [anon_sym_constexpr] = ACTIONS(2228),
    [anon_sym_volatile] = ACTIONS(2228),
    [anon_sym_restrict] = ACTIONS(2228),
    [anon_sym___restrict__] = ACTIONS(2228),
    [anon_sym__Atomic] = ACTIONS(2228),
    [anon_sym__Noreturn] = ACTIONS(2228),
    [anon_sym_noreturn] = ACTIONS(2228),
    [anon_sym_mutable] = ACTIONS(2228),
    [anon_sym_constinit] = ACTIONS(2228),
    [anon_sym_consteval] = ACTIONS(2228),
    [anon_sym_alignas] = ACTIONS(2228),
    [anon_sym__Alignas] = ACTIONS(2228),
    [sym_primitive_type] = ACTIONS(2228),
    [anon_sym_enum] = ACTIONS(2228),
    [anon_sym_class] = ACTIONS(2228),
    [anon_sym_struct] = ACTIONS(2228),
    [anon_sym_union] = ACTIONS(2228),
    [anon_sym_if] = ACTIONS(2228),
    [anon_sym_switch] = ACTIONS(2228),
    [anon_sym_case] = ACTIONS(2228),
    [anon_sym_default] = ACTIONS(2228),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2228),
    [anon_sym_for] = ACTIONS(2228),
    [anon_sym_return] = ACTIONS(2228),
    [anon_sym_break] = ACTIONS(2228),
    [anon_sym_continue] = ACTIONS(2228),
    [anon_sym_goto] = ACTIONS(2228),
    [anon_sym___try] = ACTIONS(2228),
    [anon_sym___leave] = ACTIONS(2228),
    [anon_sym_QMARK] = ACTIONS(2230),
    [anon_sym_STAR_EQ] = ACTIONS(2230),
    [anon_sym_SLASH_EQ] = ACTIONS(2230),
    [anon_sym_PERCENT_EQ] = ACTIONS(2230),
    [anon_sym_PLUS_EQ] = ACTIONS(2230),
    [anon_sym_DASH_EQ] = ACTIONS(2230),
    [anon_sym_LT_LT_EQ] = ACTIONS(2230),
    [anon_sym_GT_GT_EQ] = ACTIONS(2230),
    [anon_sym_AMP_EQ] = ACTIONS(2230),
    [anon_sym_CARET_EQ] = ACTIONS(2230),
    [anon_sym_PIPE_EQ] = ACTIONS(2230),
    [anon_sym_and_eq] = ACTIONS(2228),
    [anon_sym_or_eq] = ACTIONS(2228),
    [anon_sym_xor_eq] = ACTIONS(2228),
    [anon_sym_not] = ACTIONS(2228),
    [anon_sym_compl] = ACTIONS(2228),
    [anon_sym_LT_EQ_GT] = ACTIONS(2230),
    [anon_sym_or] = ACTIONS(2228),
    [anon_sym_and] = ACTIONS(2228),
    [anon_sym_bitor] = ACTIONS(2228),
    [anon_sym_xor] = ACTIONS(2228),
    [anon_sym_bitand] = ACTIONS(2228),
    [anon_sym_not_eq] = ACTIONS(2228),
    [anon_sym_is] = ACTIONS(2228),
    [anon_sym_as] = ACTIONS(2228),
    [anon_sym_DASH_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_PLUS] = ACTIONS(2230),
    [anon_sym_sizeof] = ACTIONS(2228),
    [anon_sym___alignof__] = ACTIONS(2228),
    [anon_sym___alignof] = ACTIONS(2228),
    [anon_sym__alignof] = ACTIONS(2228),
    [anon_sym_alignof] = ACTIONS(2228),
    [anon_sym__Alignof] = ACTIONS(2228),
    [anon_sym_offsetof] = ACTIONS(2228),
    [anon_sym__Generic] = ACTIONS(2228),
    [anon_sym_asm] = ACTIONS(2228),
    [anon_sym___asm__] = ACTIONS(2228),
    [anon_sym_DOT] = ACTIONS(2228),
    [anon_sym_DOT_STAR] = ACTIONS(2230),
    [anon_sym_DASH_GT] = ACTIONS(2230),
    [sym_number_literal] = ACTIONS(2230),
    [anon_sym_L_SQUOTE] = ACTIONS(2230),
    [anon_sym_u_SQUOTE] = ACTIONS(2230),
    [anon_sym_U_SQUOTE] = ACTIONS(2230),
    [anon_sym_u8_SQUOTE] = ACTIONS(2230),
    [anon_sym_SQUOTE] = ACTIONS(2230),
    [anon_sym_L_DQUOTE] = ACTIONS(2230),
    [anon_sym_u_DQUOTE] = ACTIONS(2230),
    [anon_sym_U_DQUOTE] = ACTIONS(2230),
    [anon_sym_u8_DQUOTE] = ACTIONS(2230),
    [anon_sym_DQUOTE] = ACTIONS(2230),
    [sym_true] = ACTIONS(2228),
    [sym_false] = ACTIONS(2228),
    [anon_sym_NULL] = ACTIONS(2228),
    [anon_sym_nullptr] = ACTIONS(2228),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(2228),
    [anon_sym_This] = ACTIONS(2228),
    [anon_sym_decltype] = ACTIONS(2228),
    [sym_virtual] = ACTIONS(2228),
    [anon_sym_explicit] = ACTIONS(2228),
    [anon_sym_typename] = ACTIONS(2228),
    [anon_sym_template] = ACTIONS(2228),
    [anon_sym_operator] = ACTIONS(2228),
    [anon_sym_try] = ACTIONS(2228),
    [anon_sym_delete] = ACTIONS(2228),
    [anon_sym_throw] = ACTIONS(2228),
    [anon_sym_namespace] = ACTIONS(2228),
    [anon_sym_using] = ACTIONS(2228),
    [anon_sym_static_assert] = ACTIONS(2228),
    [anon_sym_concept] = ACTIONS(2228),
    [anon_sym_co_return] = ACTIONS(2228),
    [anon_sym_co_yield] = ACTIONS(2228),
    [anon_sym_R_DQUOTE] = ACTIONS(2230),
    [anon_sym_LR_DQUOTE] = ACTIONS(2230),
    [anon_sym_uR_DQUOTE] = ACTIONS(2230),
    [anon_sym_UR_DQUOTE] = ACTIONS(2230),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2230),
    [anon_sym_co_await] = ACTIONS(2228),
    [anon_sym_new] = ACTIONS(2228),
    [anon_sym_requires] = ACTIONS(2228),
    [sym_this] = ACTIONS(2228),
    [anon_sym_discard] = ACTIONS(2228),
    [anon_sym_precise] = ACTIONS(2228),
    [anon_sym_shared] = ACTIONS(2228),
    [anon_sym_groupshared] = ACTIONS(2228),
    [anon_sym_uniform] = ACTIONS(2228),
    [anon_sym_row_major] = ACTIONS(2228),
    [anon_sym_column_major] = ACTIONS(2228),
    [anon_sym_globallycoherent] = ACTIONS(2228),
    [anon_sym_centroid] = ACTIONS(2228),
    [anon_sym_noperspective] = ACTIONS(2228),
    [anon_sym_nointerpolation] = ACTIONS(2228),
    [anon_sym_sample] = ACTIONS(2228),
    [anon_sym_linear] = ACTIONS(2228),
    [anon_sym_snorm] = ACTIONS(2228),
    [anon_sym_unorm] = ACTIONS(2228),
    [anon_sym_point] = ACTIONS(2228),
    [anon_sym_line] = ACTIONS(2228),
    [anon_sym_triangleadj] = ACTIONS(2228),
    [anon_sym_lineadj] = ACTIONS(2228),
    [anon_sym_triangle] = ACTIONS(2228),
    [anon_sym_cbuffer] = ACTIONS(2228),
    [anon_sym_interface] = ACTIONS(2228),
    [anon_sym_extension] = ACTIONS(2228),
  },
  [114] = {
    [sym_identifier] = ACTIONS(2232),
    [aux_sym_preproc_include_token1] = ACTIONS(2232),
    [aux_sym_preproc_def_token1] = ACTIONS(2232),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_COMMA] = ACTIONS(2234),
    [aux_sym_preproc_if_token1] = ACTIONS(2232),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2232),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2232),
    [sym_preproc_directive] = ACTIONS(2232),
    [anon_sym_LPAREN2] = ACTIONS(2234),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2232),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_STAR] = ACTIONS(2232),
    [anon_sym_SLASH] = ACTIONS(2232),
    [anon_sym_PERCENT] = ACTIONS(2232),
    [anon_sym_PIPE_PIPE] = ACTIONS(2234),
    [anon_sym_AMP_AMP] = ACTIONS(2234),
    [anon_sym_PIPE] = ACTIONS(2232),
    [anon_sym_CARET] = ACTIONS(2232),
    [anon_sym_AMP] = ACTIONS(2232),
    [anon_sym_EQ_EQ] = ACTIONS(2234),
    [anon_sym_BANG_EQ] = ACTIONS(2234),
    [anon_sym_GT] = ACTIONS(2232),
    [anon_sym_GT_EQ] = ACTIONS(2234),
    [anon_sym_LT_EQ] = ACTIONS(2232),
    [anon_sym_LT] = ACTIONS(2232),
    [anon_sym_LT_LT] = ACTIONS(2232),
    [anon_sym_GT_GT] = ACTIONS(2232),
    [anon_sym_SEMI] = ACTIONS(2234),
    [anon_sym___extension__] = ACTIONS(2232),
    [anon_sym_typedef] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2232),
    [anon_sym_out] = ACTIONS(2232),
    [anon_sym_inout] = ACTIONS(2232),
    [anon_sym_extern] = ACTIONS(2232),
    [anon_sym___attribute__] = ACTIONS(2232),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2234),
    [anon_sym___declspec] = ACTIONS(2232),
    [anon_sym___based] = ACTIONS(2232),
    [anon_sym___cdecl] = ACTIONS(2232),
    [anon_sym___clrcall] = ACTIONS(2232),
    [anon_sym___stdcall] = ACTIONS(2232),
    [anon_sym___fastcall] = ACTIONS(2232),
    [anon_sym___thiscall] = ACTIONS(2232),
    [anon_sym___vectorcall] = ACTIONS(2232),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_RBRACE] = ACTIONS(2234),
    [anon_sym_signed] = ACTIONS(2232),
    [anon_sym_unsigned] = ACTIONS(2232),
    [anon_sym_long] = ACTIONS(2232),
    [anon_sym_short] = ACTIONS(2232),
    [anon_sym_LBRACK] = ACTIONS(2232),
    [anon_sym_static] = ACTIONS(2232),
    [anon_sym_EQ] = ACTIONS(2232),
    [anon_sym_register] = ACTIONS(2232),
    [anon_sym_inline] = ACTIONS(2232),
    [anon_sym___inline] = ACTIONS(2232),
    [anon_sym___inline__] = ACTIONS(2232),
    [anon_sym___forceinline] = ACTIONS(2232),
    [anon_sym_thread_local] = ACTIONS(2232),
    [anon_sym___thread] = ACTIONS(2232),
    [anon_sym_const] = ACTIONS(2232),
    [anon_sym_constexpr] = ACTIONS(2232),
    [anon_sym_volatile] = ACTIONS(2232),
    [anon_sym_restrict] = ACTIONS(2232),
    [anon_sym___restrict__] = ACTIONS(2232),
    [anon_sym__Atomic] = ACTIONS(2232),
    [anon_sym__Noreturn] = ACTIONS(2232),
    [anon_sym_noreturn] = ACTIONS(2232),
    [anon_sym_mutable] = ACTIONS(2232),
    [anon_sym_constinit] = ACTIONS(2232),
    [anon_sym_consteval] = ACTIONS(2232),
    [anon_sym_alignas] = ACTIONS(2232),
    [anon_sym__Alignas] = ACTIONS(2232),
    [sym_primitive_type] = ACTIONS(2232),
    [anon_sym_enum] = ACTIONS(2232),
    [anon_sym_class] = ACTIONS(2232),
    [anon_sym_struct] = ACTIONS(2232),
    [anon_sym_union] = ACTIONS(2232),
    [anon_sym_if] = ACTIONS(2232),
    [anon_sym_switch] = ACTIONS(2232),
    [anon_sym_case] = ACTIONS(2232),
    [anon_sym_default] = ACTIONS(2232),
    [anon_sym_while] = ACTIONS(2232),
    [anon_sym_do] = ACTIONS(2232),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2232),
    [anon_sym_break] = ACTIONS(2232),
    [anon_sym_continue] = ACTIONS(2232),
    [anon_sym_goto] = ACTIONS(2232),
    [anon_sym___try] = ACTIONS(2232),
    [anon_sym___leave] = ACTIONS(2232),
    [anon_sym_QMARK] = ACTIONS(2234),
    [anon_sym_STAR_EQ] = ACTIONS(2234),
    [anon_sym_SLASH_EQ] = ACTIONS(2234),
    [anon_sym_PERCENT_EQ] = ACTIONS(2234),
    [anon_sym_PLUS_EQ] = ACTIONS(2234),
    [anon_sym_DASH_EQ] = ACTIONS(2234),
    [anon_sym_LT_LT_EQ] = ACTIONS(2234),
    [anon_sym_GT_GT_EQ] = ACTIONS(2234),
    [anon_sym_AMP_EQ] = ACTIONS(2234),
    [anon_sym_CARET_EQ] = ACTIONS(2234),
    [anon_sym_PIPE_EQ] = ACTIONS(2234),
    [anon_sym_and_eq] = ACTIONS(2232),
    [anon_sym_or_eq] = ACTIONS(2232),
    [anon_sym_xor_eq] = ACTIONS(2232),
    [anon_sym_not] = ACTIONS(2232),
    [anon_sym_compl] = ACTIONS(2232),
    [anon_sym_LT_EQ_GT] = ACTIONS(2234),
    [anon_sym_or] = ACTIONS(2232),
    [anon_sym_and] = ACTIONS(2232),
    [anon_sym_bitor] = ACTIONS(2232),
    [anon_sym_xor] = ACTIONS(2232),
    [anon_sym_bitand] = ACTIONS(2232),
    [anon_sym_not_eq] = ACTIONS(2232),
    [anon_sym_is] = ACTIONS(2232),
    [anon_sym_as] = ACTIONS(2232),
    [anon_sym_DASH_DASH] = ACTIONS(2234),
    [anon_sym_PLUS_PLUS] = ACTIONS(2234),
    [anon_sym_sizeof] = ACTIONS(2232),
    [anon_sym___alignof__] = ACTIONS(2232),
    [anon_sym___alignof] = ACTIONS(2232),
    [anon_sym__alignof] = ACTIONS(2232),
    [anon_sym_alignof] = ACTIONS(2232),
    [anon_sym__Alignof] = ACTIONS(2232),
    [anon_sym_offsetof] = ACTIONS(2232),
    [anon_sym__Generic] = ACTIONS(2232),
    [anon_sym_asm] = ACTIONS(2232),
    [anon_sym___asm__] = ACTIONS(2232),
    [anon_sym_DOT] = ACTIONS(2232),
    [anon_sym_DOT_STAR] = ACTIONS(2234),
    [anon_sym_DASH_GT] = ACTIONS(2234),
    [sym_number_literal] = ACTIONS(2234),
    [anon_sym_L_SQUOTE] = ACTIONS(2234),
    [anon_sym_u_SQUOTE] = ACTIONS(2234),
    [anon_sym_U_SQUOTE] = ACTIONS(2234),
    [anon_sym_u8_SQUOTE] = ACTIONS(2234),
    [anon_sym_SQUOTE] = ACTIONS(2234),
    [anon_sym_L_DQUOTE] = ACTIONS(2234),
    [anon_sym_u_DQUOTE] = ACTIONS(2234),
    [anon_sym_U_DQUOTE] = ACTIONS(2234),
    [anon_sym_u8_DQUOTE] = ACTIONS(2234),
    [anon_sym_DQUOTE] = ACTIONS(2234),
    [sym_true] = ACTIONS(2232),
    [sym_false] = ACTIONS(2232),
    [anon_sym_NULL] = ACTIONS(2232),
    [anon_sym_nullptr] = ACTIONS(2232),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2232),
    [anon_sym_let] = ACTIONS(2232),
    [anon_sym_This] = ACTIONS(2232),
    [anon_sym_decltype] = ACTIONS(2232),
    [sym_virtual] = ACTIONS(2232),
    [anon_sym_explicit] = ACTIONS(2232),
    [anon_sym_typename] = ACTIONS(2232),
    [anon_sym_template] = ACTIONS(2232),
    [anon_sym_operator] = ACTIONS(2232),
    [anon_sym_try] = ACTIONS(2232),
    [anon_sym_delete] = ACTIONS(2232),
    [anon_sym_throw] = ACTIONS(2232),
    [anon_sym_namespace] = ACTIONS(2232),
    [anon_sym_using] = ACTIONS(2232),
    [anon_sym_static_assert] = ACTIONS(2232),
    [anon_sym_concept] = ACTIONS(2232),
    [anon_sym_co_return] = ACTIONS(2232),
    [anon_sym_co_yield] = ACTIONS(2232),
    [anon_sym_R_DQUOTE] = ACTIONS(2234),
    [anon_sym_LR_DQUOTE] = ACTIONS(2234),
    [anon_sym_uR_DQUOTE] = ACTIONS(2234),
    [anon_sym_UR_DQUOTE] = ACTIONS(2234),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2234),
    [anon_sym_co_await] = ACTIONS(2232),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_requires] = ACTIONS(2232),
    [sym_this] = ACTIONS(2232),
    [anon_sym_discard] = ACTIONS(2232),
    [anon_sym_precise] = ACTIONS(2232),
    [anon_sym_shared] = ACTIONS(2232),
    [anon_sym_groupshared] = ACTIONS(2232),
    [anon_sym_uniform] = ACTIONS(2232),
    [anon_sym_row_major] = ACTIONS(2232),
    [anon_sym_column_major] = ACTIONS(2232),
    [anon_sym_globallycoherent] = ACTIONS(2232),
    [anon_sym_centroid] = ACTIONS(2232),
    [anon_sym_noperspective] = ACTIONS(2232),
    [anon_sym_nointerpolation] = ACTIONS(2232),
    [anon_sym_sample] = ACTIONS(2232),
    [anon_sym_linear] = ACTIONS(2232),
    [anon_sym_snorm] = ACTIONS(2232),
    [anon_sym_unorm] = ACTIONS(2232),
    [anon_sym_point] = ACTIONS(2232),
    [anon_sym_line] = ACTIONS(2232),
    [anon_sym_triangleadj] = ACTIONS(2232),
    [anon_sym_lineadj] = ACTIONS(2232),
    [anon_sym_triangle] = ACTIONS(2232),
    [anon_sym_cbuffer] = ACTIONS(2232),
    [anon_sym_interface] = ACTIONS(2232),
    [anon_sym_extension] = ACTIONS(2232),
  },
  [115] = {
    [sym_identifier] = ACTIONS(2236),
    [aux_sym_preproc_include_token1] = ACTIONS(2236),
    [aux_sym_preproc_def_token1] = ACTIONS(2236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2238),
    [anon_sym_COMMA] = ACTIONS(2238),
    [aux_sym_preproc_if_token1] = ACTIONS(2236),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2236),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2236),
    [sym_preproc_directive] = ACTIONS(2236),
    [anon_sym_LPAREN2] = ACTIONS(2238),
    [anon_sym_BANG] = ACTIONS(2236),
    [anon_sym_TILDE] = ACTIONS(2238),
    [anon_sym_DASH] = ACTIONS(2236),
    [anon_sym_PLUS] = ACTIONS(2236),
    [anon_sym_STAR] = ACTIONS(2236),
    [anon_sym_SLASH] = ACTIONS(2236),
    [anon_sym_PERCENT] = ACTIONS(2236),
    [anon_sym_PIPE_PIPE] = ACTIONS(2238),
    [anon_sym_AMP_AMP] = ACTIONS(2238),
    [anon_sym_PIPE] = ACTIONS(2236),
    [anon_sym_CARET] = ACTIONS(2236),
    [anon_sym_AMP] = ACTIONS(2236),
    [anon_sym_EQ_EQ] = ACTIONS(2238),
    [anon_sym_BANG_EQ] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2236),
    [anon_sym_GT_EQ] = ACTIONS(2238),
    [anon_sym_LT_EQ] = ACTIONS(2236),
    [anon_sym_LT] = ACTIONS(2236),
    [anon_sym_LT_LT] = ACTIONS(2236),
    [anon_sym_GT_GT] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(2238),
    [anon_sym___extension__] = ACTIONS(2236),
    [anon_sym_typedef] = ACTIONS(2236),
    [anon_sym_in] = ACTIONS(2236),
    [anon_sym_out] = ACTIONS(2236),
    [anon_sym_inout] = ACTIONS(2236),
    [anon_sym_extern] = ACTIONS(2236),
    [anon_sym___attribute__] = ACTIONS(2236),
    [anon_sym_COLON_COLON] = ACTIONS(2238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2238),
    [anon_sym___declspec] = ACTIONS(2236),
    [anon_sym___based] = ACTIONS(2236),
    [anon_sym___cdecl] = ACTIONS(2236),
    [anon_sym___clrcall] = ACTIONS(2236),
    [anon_sym___stdcall] = ACTIONS(2236),
    [anon_sym___fastcall] = ACTIONS(2236),
    [anon_sym___thiscall] = ACTIONS(2236),
    [anon_sym___vectorcall] = ACTIONS(2236),
    [anon_sym_LBRACE] = ACTIONS(2238),
    [anon_sym_RBRACE] = ACTIONS(2238),
    [anon_sym_signed] = ACTIONS(2236),
    [anon_sym_unsigned] = ACTIONS(2236),
    [anon_sym_long] = ACTIONS(2236),
    [anon_sym_short] = ACTIONS(2236),
    [anon_sym_LBRACK] = ACTIONS(2236),
    [anon_sym_static] = ACTIONS(2236),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_register] = ACTIONS(2236),
    [anon_sym_inline] = ACTIONS(2236),
    [anon_sym___inline] = ACTIONS(2236),
    [anon_sym___inline__] = ACTIONS(2236),
    [anon_sym___forceinline] = ACTIONS(2236),
    [anon_sym_thread_local] = ACTIONS(2236),
    [anon_sym___thread] = ACTIONS(2236),
    [anon_sym_const] = ACTIONS(2236),
    [anon_sym_constexpr] = ACTIONS(2236),
    [anon_sym_volatile] = ACTIONS(2236),
    [anon_sym_restrict] = ACTIONS(2236),
    [anon_sym___restrict__] = ACTIONS(2236),
    [anon_sym__Atomic] = ACTIONS(2236),
    [anon_sym__Noreturn] = ACTIONS(2236),
    [anon_sym_noreturn] = ACTIONS(2236),
    [anon_sym_mutable] = ACTIONS(2236),
    [anon_sym_constinit] = ACTIONS(2236),
    [anon_sym_consteval] = ACTIONS(2236),
    [anon_sym_alignas] = ACTIONS(2236),
    [anon_sym__Alignas] = ACTIONS(2236),
    [sym_primitive_type] = ACTIONS(2236),
    [anon_sym_enum] = ACTIONS(2236),
    [anon_sym_class] = ACTIONS(2236),
    [anon_sym_struct] = ACTIONS(2236),
    [anon_sym_union] = ACTIONS(2236),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_switch] = ACTIONS(2236),
    [anon_sym_case] = ACTIONS(2236),
    [anon_sym_default] = ACTIONS(2236),
    [anon_sym_while] = ACTIONS(2236),
    [anon_sym_do] = ACTIONS(2236),
    [anon_sym_for] = ACTIONS(2236),
    [anon_sym_return] = ACTIONS(2236),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2236),
    [anon_sym_goto] = ACTIONS(2236),
    [anon_sym___try] = ACTIONS(2236),
    [anon_sym___leave] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2238),
    [anon_sym_SLASH_EQ] = ACTIONS(2238),
    [anon_sym_PERCENT_EQ] = ACTIONS(2238),
    [anon_sym_PLUS_EQ] = ACTIONS(2238),
    [anon_sym_DASH_EQ] = ACTIONS(2238),
    [anon_sym_LT_LT_EQ] = ACTIONS(2238),
    [anon_sym_GT_GT_EQ] = ACTIONS(2238),
    [anon_sym_AMP_EQ] = ACTIONS(2238),
    [anon_sym_CARET_EQ] = ACTIONS(2238),
    [anon_sym_PIPE_EQ] = ACTIONS(2238),
    [anon_sym_and_eq] = ACTIONS(2236),
    [anon_sym_or_eq] = ACTIONS(2236),
    [anon_sym_xor_eq] = ACTIONS(2236),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_compl] = ACTIONS(2236),
    [anon_sym_LT_EQ_GT] = ACTIONS(2238),
    [anon_sym_or] = ACTIONS(2236),
    [anon_sym_and] = ACTIONS(2236),
    [anon_sym_bitor] = ACTIONS(2236),
    [anon_sym_xor] = ACTIONS(2236),
    [anon_sym_bitand] = ACTIONS(2236),
    [anon_sym_not_eq] = ACTIONS(2236),
    [anon_sym_is] = ACTIONS(2236),
    [anon_sym_as] = ACTIONS(2236),
    [anon_sym_DASH_DASH] = ACTIONS(2238),
    [anon_sym_PLUS_PLUS] = ACTIONS(2238),
    [anon_sym_sizeof] = ACTIONS(2236),
    [anon_sym___alignof__] = ACTIONS(2236),
    [anon_sym___alignof] = ACTIONS(2236),
    [anon_sym__alignof] = ACTIONS(2236),
    [anon_sym_alignof] = ACTIONS(2236),
    [anon_sym__Alignof] = ACTIONS(2236),
    [anon_sym_offsetof] = ACTIONS(2236),
    [anon_sym__Generic] = ACTIONS(2236),
    [anon_sym_asm] = ACTIONS(2236),
    [anon_sym___asm__] = ACTIONS(2236),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_DOT_STAR] = ACTIONS(2238),
    [anon_sym_DASH_GT] = ACTIONS(2238),
    [sym_number_literal] = ACTIONS(2238),
    [anon_sym_L_SQUOTE] = ACTIONS(2238),
    [anon_sym_u_SQUOTE] = ACTIONS(2238),
    [anon_sym_U_SQUOTE] = ACTIONS(2238),
    [anon_sym_u8_SQUOTE] = ACTIONS(2238),
    [anon_sym_SQUOTE] = ACTIONS(2238),
    [anon_sym_L_DQUOTE] = ACTIONS(2238),
    [anon_sym_u_DQUOTE] = ACTIONS(2238),
    [anon_sym_U_DQUOTE] = ACTIONS(2238),
    [anon_sym_u8_DQUOTE] = ACTIONS(2238),
    [anon_sym_DQUOTE] = ACTIONS(2238),
    [sym_true] = ACTIONS(2236),
    [sym_false] = ACTIONS(2236),
    [anon_sym_NULL] = ACTIONS(2236),
    [anon_sym_nullptr] = ACTIONS(2236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2236),
    [anon_sym_let] = ACTIONS(2236),
    [anon_sym_This] = ACTIONS(2236),
    [anon_sym_decltype] = ACTIONS(2236),
    [sym_virtual] = ACTIONS(2236),
    [anon_sym_explicit] = ACTIONS(2236),
    [anon_sym_typename] = ACTIONS(2236),
    [anon_sym_template] = ACTIONS(2236),
    [anon_sym_operator] = ACTIONS(2236),
    [anon_sym_try] = ACTIONS(2236),
    [anon_sym_delete] = ACTIONS(2236),
    [anon_sym_throw] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(2236),
    [anon_sym_using] = ACTIONS(2236),
    [anon_sym_static_assert] = ACTIONS(2236),
    [anon_sym_concept] = ACTIONS(2236),
    [anon_sym_co_return] = ACTIONS(2236),
    [anon_sym_co_yield] = ACTIONS(2236),
    [anon_sym_R_DQUOTE] = ACTIONS(2238),
    [anon_sym_LR_DQUOTE] = ACTIONS(2238),
    [anon_sym_uR_DQUOTE] = ACTIONS(2238),
    [anon_sym_UR_DQUOTE] = ACTIONS(2238),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2238),
    [anon_sym_co_await] = ACTIONS(2236),
    [anon_sym_new] = ACTIONS(2236),
    [anon_sym_requires] = ACTIONS(2236),
    [sym_this] = ACTIONS(2236),
    [anon_sym_discard] = ACTIONS(2236),
    [anon_sym_precise] = ACTIONS(2236),
    [anon_sym_shared] = ACTIONS(2236),
    [anon_sym_groupshared] = ACTIONS(2236),
    [anon_sym_uniform] = ACTIONS(2236),
    [anon_sym_row_major] = ACTIONS(2236),
    [anon_sym_column_major] = ACTIONS(2236),
    [anon_sym_globallycoherent] = ACTIONS(2236),
    [anon_sym_centroid] = ACTIONS(2236),
    [anon_sym_noperspective] = ACTIONS(2236),
    [anon_sym_nointerpolation] = ACTIONS(2236),
    [anon_sym_sample] = ACTIONS(2236),
    [anon_sym_linear] = ACTIONS(2236),
    [anon_sym_snorm] = ACTIONS(2236),
    [anon_sym_unorm] = ACTIONS(2236),
    [anon_sym_point] = ACTIONS(2236),
    [anon_sym_line] = ACTIONS(2236),
    [anon_sym_triangleadj] = ACTIONS(2236),
    [anon_sym_lineadj] = ACTIONS(2236),
    [anon_sym_triangle] = ACTIONS(2236),
    [anon_sym_cbuffer] = ACTIONS(2236),
    [anon_sym_interface] = ACTIONS(2236),
    [anon_sym_extension] = ACTIONS(2236),
  },
  [116] = {
    [sym_identifier] = ACTIONS(2240),
    [aux_sym_preproc_include_token1] = ACTIONS(2240),
    [aux_sym_preproc_def_token1] = ACTIONS(2240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2242),
    [aux_sym_preproc_if_token1] = ACTIONS(2240),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2240),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2240),
    [sym_preproc_directive] = ACTIONS(2240),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2240),
    [anon_sym_PLUS] = ACTIONS(2240),
    [anon_sym_STAR] = ACTIONS(2240),
    [anon_sym_SLASH] = ACTIONS(2240),
    [anon_sym_PERCENT] = ACTIONS(2240),
    [anon_sym_PIPE_PIPE] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_PIPE] = ACTIONS(2240),
    [anon_sym_CARET] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2240),
    [anon_sym_EQ_EQ] = ACTIONS(2242),
    [anon_sym_BANG_EQ] = ACTIONS(2242),
    [anon_sym_GT] = ACTIONS(2240),
    [anon_sym_GT_EQ] = ACTIONS(2242),
    [anon_sym_LT_EQ] = ACTIONS(2240),
    [anon_sym_LT] = ACTIONS(2240),
    [anon_sym_LT_LT] = ACTIONS(2240),
    [anon_sym_GT_GT] = ACTIONS(2240),
    [anon_sym_SEMI] = ACTIONS(2242),
    [anon_sym___extension__] = ACTIONS(2240),
    [anon_sym_typedef] = ACTIONS(2240),
    [anon_sym_in] = ACTIONS(2240),
    [anon_sym_out] = ACTIONS(2240),
    [anon_sym_inout] = ACTIONS(2240),
    [anon_sym_extern] = ACTIONS(2240),
    [anon_sym___attribute__] = ACTIONS(2240),
    [anon_sym_COLON_COLON] = ACTIONS(2242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2242),
    [anon_sym___declspec] = ACTIONS(2240),
    [anon_sym___based] = ACTIONS(2240),
    [anon_sym___cdecl] = ACTIONS(2240),
    [anon_sym___clrcall] = ACTIONS(2240),
    [anon_sym___stdcall] = ACTIONS(2240),
    [anon_sym___fastcall] = ACTIONS(2240),
    [anon_sym___thiscall] = ACTIONS(2240),
    [anon_sym___vectorcall] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_RBRACE] = ACTIONS(2242),
    [anon_sym_signed] = ACTIONS(2240),
    [anon_sym_unsigned] = ACTIONS(2240),
    [anon_sym_long] = ACTIONS(2240),
    [anon_sym_short] = ACTIONS(2240),
    [anon_sym_LBRACK] = ACTIONS(2240),
    [anon_sym_static] = ACTIONS(2240),
    [anon_sym_EQ] = ACTIONS(2240),
    [anon_sym_register] = ACTIONS(2240),
    [anon_sym_inline] = ACTIONS(2240),
    [anon_sym___inline] = ACTIONS(2240),
    [anon_sym___inline__] = ACTIONS(2240),
    [anon_sym___forceinline] = ACTIONS(2240),
    [anon_sym_thread_local] = ACTIONS(2240),
    [anon_sym___thread] = ACTIONS(2240),
    [anon_sym_const] = ACTIONS(2240),
    [anon_sym_constexpr] = ACTIONS(2240),
    [anon_sym_volatile] = ACTIONS(2240),
    [anon_sym_restrict] = ACTIONS(2240),
    [anon_sym___restrict__] = ACTIONS(2240),
    [anon_sym__Atomic] = ACTIONS(2240),
    [anon_sym__Noreturn] = ACTIONS(2240),
    [anon_sym_noreturn] = ACTIONS(2240),
    [anon_sym_mutable] = ACTIONS(2240),
    [anon_sym_constinit] = ACTIONS(2240),
    [anon_sym_consteval] = ACTIONS(2240),
    [anon_sym_alignas] = ACTIONS(2240),
    [anon_sym__Alignas] = ACTIONS(2240),
    [sym_primitive_type] = ACTIONS(2240),
    [anon_sym_enum] = ACTIONS(2240),
    [anon_sym_class] = ACTIONS(2240),
    [anon_sym_struct] = ACTIONS(2240),
    [anon_sym_union] = ACTIONS(2240),
    [anon_sym_if] = ACTIONS(2240),
    [anon_sym_switch] = ACTIONS(2240),
    [anon_sym_case] = ACTIONS(2240),
    [anon_sym_default] = ACTIONS(2240),
    [anon_sym_while] = ACTIONS(2240),
    [anon_sym_do] = ACTIONS(2240),
    [anon_sym_for] = ACTIONS(2240),
    [anon_sym_return] = ACTIONS(2240),
    [anon_sym_break] = ACTIONS(2240),
    [anon_sym_continue] = ACTIONS(2240),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym___try] = ACTIONS(2240),
    [anon_sym___leave] = ACTIONS(2240),
    [anon_sym_QMARK] = ACTIONS(2242),
    [anon_sym_STAR_EQ] = ACTIONS(2242),
    [anon_sym_SLASH_EQ] = ACTIONS(2242),
    [anon_sym_PERCENT_EQ] = ACTIONS(2242),
    [anon_sym_PLUS_EQ] = ACTIONS(2242),
    [anon_sym_DASH_EQ] = ACTIONS(2242),
    [anon_sym_LT_LT_EQ] = ACTIONS(2242),
    [anon_sym_GT_GT_EQ] = ACTIONS(2242),
    [anon_sym_AMP_EQ] = ACTIONS(2242),
    [anon_sym_CARET_EQ] = ACTIONS(2242),
    [anon_sym_PIPE_EQ] = ACTIONS(2242),
    [anon_sym_and_eq] = ACTIONS(2240),
    [anon_sym_or_eq] = ACTIONS(2240),
    [anon_sym_xor_eq] = ACTIONS(2240),
    [anon_sym_not] = ACTIONS(2240),
    [anon_sym_compl] = ACTIONS(2240),
    [anon_sym_LT_EQ_GT] = ACTIONS(2242),
    [anon_sym_or] = ACTIONS(2240),
    [anon_sym_and] = ACTIONS(2240),
    [anon_sym_bitor] = ACTIONS(2240),
    [anon_sym_xor] = ACTIONS(2240),
    [anon_sym_bitand] = ACTIONS(2240),
    [anon_sym_not_eq] = ACTIONS(2240),
    [anon_sym_is] = ACTIONS(2240),
    [anon_sym_as] = ACTIONS(2240),
    [anon_sym_DASH_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_PLUS] = ACTIONS(2242),
    [anon_sym_sizeof] = ACTIONS(2240),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2240),
    [anon_sym__Generic] = ACTIONS(2240),
    [anon_sym_asm] = ACTIONS(2240),
    [anon_sym___asm__] = ACTIONS(2240),
    [anon_sym_DOT] = ACTIONS(2240),
    [anon_sym_DOT_STAR] = ACTIONS(2242),
    [anon_sym_DASH_GT] = ACTIONS(2242),
    [sym_number_literal] = ACTIONS(2242),
    [anon_sym_L_SQUOTE] = ACTIONS(2242),
    [anon_sym_u_SQUOTE] = ACTIONS(2242),
    [anon_sym_U_SQUOTE] = ACTIONS(2242),
    [anon_sym_u8_SQUOTE] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(2242),
    [anon_sym_L_DQUOTE] = ACTIONS(2242),
    [anon_sym_u_DQUOTE] = ACTIONS(2242),
    [anon_sym_U_DQUOTE] = ACTIONS(2242),
    [anon_sym_u8_DQUOTE] = ACTIONS(2242),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [sym_true] = ACTIONS(2240),
    [sym_false] = ACTIONS(2240),
    [anon_sym_NULL] = ACTIONS(2240),
    [anon_sym_nullptr] = ACTIONS(2240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2240),
    [anon_sym_let] = ACTIONS(2240),
    [anon_sym_This] = ACTIONS(2240),
    [anon_sym_decltype] = ACTIONS(2240),
    [sym_virtual] = ACTIONS(2240),
    [anon_sym_explicit] = ACTIONS(2240),
    [anon_sym_typename] = ACTIONS(2240),
    [anon_sym_template] = ACTIONS(2240),
    [anon_sym_operator] = ACTIONS(2240),
    [anon_sym_try] = ACTIONS(2240),
    [anon_sym_delete] = ACTIONS(2240),
    [anon_sym_throw] = ACTIONS(2240),
    [anon_sym_namespace] = ACTIONS(2240),
    [anon_sym_using] = ACTIONS(2240),
    [anon_sym_static_assert] = ACTIONS(2240),
    [anon_sym_concept] = ACTIONS(2240),
    [anon_sym_co_return] = ACTIONS(2240),
    [anon_sym_co_yield] = ACTIONS(2240),
    [anon_sym_R_DQUOTE] = ACTIONS(2242),
    [anon_sym_LR_DQUOTE] = ACTIONS(2242),
    [anon_sym_uR_DQUOTE] = ACTIONS(2242),
    [anon_sym_UR_DQUOTE] = ACTIONS(2242),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2242),
    [anon_sym_co_await] = ACTIONS(2240),
    [anon_sym_new] = ACTIONS(2240),
    [anon_sym_requires] = ACTIONS(2240),
    [sym_this] = ACTIONS(2240),
    [anon_sym_discard] = ACTIONS(2240),
    [anon_sym_precise] = ACTIONS(2240),
    [anon_sym_shared] = ACTIONS(2240),
    [anon_sym_groupshared] = ACTIONS(2240),
    [anon_sym_uniform] = ACTIONS(2240),
    [anon_sym_row_major] = ACTIONS(2240),
    [anon_sym_column_major] = ACTIONS(2240),
    [anon_sym_globallycoherent] = ACTIONS(2240),
    [anon_sym_centroid] = ACTIONS(2240),
    [anon_sym_noperspective] = ACTIONS(2240),
    [anon_sym_nointerpolation] = ACTIONS(2240),
    [anon_sym_sample] = ACTIONS(2240),
    [anon_sym_linear] = ACTIONS(2240),
    [anon_sym_snorm] = ACTIONS(2240),
    [anon_sym_unorm] = ACTIONS(2240),
    [anon_sym_point] = ACTIONS(2240),
    [anon_sym_line] = ACTIONS(2240),
    [anon_sym_triangleadj] = ACTIONS(2240),
    [anon_sym_lineadj] = ACTIONS(2240),
    [anon_sym_triangle] = ACTIONS(2240),
    [anon_sym_cbuffer] = ACTIONS(2240),
    [anon_sym_interface] = ACTIONS(2240),
    [anon_sym_extension] = ACTIONS(2240),
  },
  [117] = {
    [sym_identifier] = ACTIONS(2244),
    [aux_sym_preproc_include_token1] = ACTIONS(2244),
    [aux_sym_preproc_def_token1] = ACTIONS(2244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(2246),
    [aux_sym_preproc_if_token1] = ACTIONS(2244),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2244),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2244),
    [sym_preproc_directive] = ACTIONS(2244),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_BANG] = ACTIONS(2244),
    [anon_sym_TILDE] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2244),
    [anon_sym_PLUS] = ACTIONS(2244),
    [anon_sym_STAR] = ACTIONS(2244),
    [anon_sym_SLASH] = ACTIONS(2244),
    [anon_sym_PERCENT] = ACTIONS(2244),
    [anon_sym_PIPE_PIPE] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2244),
    [anon_sym_CARET] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2244),
    [anon_sym_EQ_EQ] = ACTIONS(2246),
    [anon_sym_BANG_EQ] = ACTIONS(2246),
    [anon_sym_GT] = ACTIONS(2244),
    [anon_sym_GT_EQ] = ACTIONS(2246),
    [anon_sym_LT_EQ] = ACTIONS(2244),
    [anon_sym_LT] = ACTIONS(2244),
    [anon_sym_LT_LT] = ACTIONS(2244),
    [anon_sym_GT_GT] = ACTIONS(2244),
    [anon_sym_SEMI] = ACTIONS(2246),
    [anon_sym___extension__] = ACTIONS(2244),
    [anon_sym_typedef] = ACTIONS(2244),
    [anon_sym_in] = ACTIONS(2244),
    [anon_sym_out] = ACTIONS(2244),
    [anon_sym_inout] = ACTIONS(2244),
    [anon_sym_extern] = ACTIONS(2244),
    [anon_sym___attribute__] = ACTIONS(2244),
    [anon_sym_COLON_COLON] = ACTIONS(2246),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2246),
    [anon_sym___declspec] = ACTIONS(2244),
    [anon_sym___based] = ACTIONS(2244),
    [anon_sym___cdecl] = ACTIONS(2244),
    [anon_sym___clrcall] = ACTIONS(2244),
    [anon_sym___stdcall] = ACTIONS(2244),
    [anon_sym___fastcall] = ACTIONS(2244),
    [anon_sym___thiscall] = ACTIONS(2244),
    [anon_sym___vectorcall] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_RBRACE] = ACTIONS(2246),
    [anon_sym_signed] = ACTIONS(2244),
    [anon_sym_unsigned] = ACTIONS(2244),
    [anon_sym_long] = ACTIONS(2244),
    [anon_sym_short] = ACTIONS(2244),
    [anon_sym_LBRACK] = ACTIONS(2244),
    [anon_sym_static] = ACTIONS(2244),
    [anon_sym_EQ] = ACTIONS(2244),
    [anon_sym_register] = ACTIONS(2244),
    [anon_sym_inline] = ACTIONS(2244),
    [anon_sym___inline] = ACTIONS(2244),
    [anon_sym___inline__] = ACTIONS(2244),
    [anon_sym___forceinline] = ACTIONS(2244),
    [anon_sym_thread_local] = ACTIONS(2244),
    [anon_sym___thread] = ACTIONS(2244),
    [anon_sym_const] = ACTIONS(2244),
    [anon_sym_constexpr] = ACTIONS(2244),
    [anon_sym_volatile] = ACTIONS(2244),
    [anon_sym_restrict] = ACTIONS(2244),
    [anon_sym___restrict__] = ACTIONS(2244),
    [anon_sym__Atomic] = ACTIONS(2244),
    [anon_sym__Noreturn] = ACTIONS(2244),
    [anon_sym_noreturn] = ACTIONS(2244),
    [anon_sym_mutable] = ACTIONS(2244),
    [anon_sym_constinit] = ACTIONS(2244),
    [anon_sym_consteval] = ACTIONS(2244),
    [anon_sym_alignas] = ACTIONS(2244),
    [anon_sym__Alignas] = ACTIONS(2244),
    [sym_primitive_type] = ACTIONS(2244),
    [anon_sym_enum] = ACTIONS(2244),
    [anon_sym_class] = ACTIONS(2244),
    [anon_sym_struct] = ACTIONS(2244),
    [anon_sym_union] = ACTIONS(2244),
    [anon_sym_if] = ACTIONS(2244),
    [anon_sym_switch] = ACTIONS(2244),
    [anon_sym_case] = ACTIONS(2244),
    [anon_sym_default] = ACTIONS(2244),
    [anon_sym_while] = ACTIONS(2244),
    [anon_sym_do] = ACTIONS(2244),
    [anon_sym_for] = ACTIONS(2244),
    [anon_sym_return] = ACTIONS(2244),
    [anon_sym_break] = ACTIONS(2244),
    [anon_sym_continue] = ACTIONS(2244),
    [anon_sym_goto] = ACTIONS(2244),
    [anon_sym___try] = ACTIONS(2244),
    [anon_sym___leave] = ACTIONS(2244),
    [anon_sym_QMARK] = ACTIONS(2246),
    [anon_sym_STAR_EQ] = ACTIONS(2246),
    [anon_sym_SLASH_EQ] = ACTIONS(2246),
    [anon_sym_PERCENT_EQ] = ACTIONS(2246),
    [anon_sym_PLUS_EQ] = ACTIONS(2246),
    [anon_sym_DASH_EQ] = ACTIONS(2246),
    [anon_sym_LT_LT_EQ] = ACTIONS(2246),
    [anon_sym_GT_GT_EQ] = ACTIONS(2246),
    [anon_sym_AMP_EQ] = ACTIONS(2246),
    [anon_sym_CARET_EQ] = ACTIONS(2246),
    [anon_sym_PIPE_EQ] = ACTIONS(2246),
    [anon_sym_and_eq] = ACTIONS(2244),
    [anon_sym_or_eq] = ACTIONS(2244),
    [anon_sym_xor_eq] = ACTIONS(2244),
    [anon_sym_not] = ACTIONS(2244),
    [anon_sym_compl] = ACTIONS(2244),
    [anon_sym_LT_EQ_GT] = ACTIONS(2246),
    [anon_sym_or] = ACTIONS(2244),
    [anon_sym_and] = ACTIONS(2244),
    [anon_sym_bitor] = ACTIONS(2244),
    [anon_sym_xor] = ACTIONS(2244),
    [anon_sym_bitand] = ACTIONS(2244),
    [anon_sym_not_eq] = ACTIONS(2244),
    [anon_sym_is] = ACTIONS(2244),
    [anon_sym_as] = ACTIONS(2244),
    [anon_sym_DASH_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_PLUS] = ACTIONS(2246),
    [anon_sym_sizeof] = ACTIONS(2244),
    [anon_sym___alignof__] = ACTIONS(2244),
    [anon_sym___alignof] = ACTIONS(2244),
    [anon_sym__alignof] = ACTIONS(2244),
    [anon_sym_alignof] = ACTIONS(2244),
    [anon_sym__Alignof] = ACTIONS(2244),
    [anon_sym_offsetof] = ACTIONS(2244),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2244),
    [anon_sym___asm__] = ACTIONS(2244),
    [anon_sym_DOT] = ACTIONS(2244),
    [anon_sym_DOT_STAR] = ACTIONS(2246),
    [anon_sym_DASH_GT] = ACTIONS(2246),
    [sym_number_literal] = ACTIONS(2246),
    [anon_sym_L_SQUOTE] = ACTIONS(2246),
    [anon_sym_u_SQUOTE] = ACTIONS(2246),
    [anon_sym_U_SQUOTE] = ACTIONS(2246),
    [anon_sym_u8_SQUOTE] = ACTIONS(2246),
    [anon_sym_SQUOTE] = ACTIONS(2246),
    [anon_sym_L_DQUOTE] = ACTIONS(2246),
    [anon_sym_u_DQUOTE] = ACTIONS(2246),
    [anon_sym_U_DQUOTE] = ACTIONS(2246),
    [anon_sym_u8_DQUOTE] = ACTIONS(2246),
    [anon_sym_DQUOTE] = ACTIONS(2246),
    [sym_true] = ACTIONS(2244),
    [sym_false] = ACTIONS(2244),
    [anon_sym_NULL] = ACTIONS(2244),
    [anon_sym_nullptr] = ACTIONS(2244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2244),
    [anon_sym_let] = ACTIONS(2244),
    [anon_sym_This] = ACTIONS(2244),
    [anon_sym_decltype] = ACTIONS(2244),
    [sym_virtual] = ACTIONS(2244),
    [anon_sym_explicit] = ACTIONS(2244),
    [anon_sym_typename] = ACTIONS(2244),
    [anon_sym_template] = ACTIONS(2244),
    [anon_sym_operator] = ACTIONS(2244),
    [anon_sym_try] = ACTIONS(2244),
    [anon_sym_delete] = ACTIONS(2244),
    [anon_sym_throw] = ACTIONS(2244),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_using] = ACTIONS(2244),
    [anon_sym_static_assert] = ACTIONS(2244),
    [anon_sym_concept] = ACTIONS(2244),
    [anon_sym_co_return] = ACTIONS(2244),
    [anon_sym_co_yield] = ACTIONS(2244),
    [anon_sym_R_DQUOTE] = ACTIONS(2246),
    [anon_sym_LR_DQUOTE] = ACTIONS(2246),
    [anon_sym_uR_DQUOTE] = ACTIONS(2246),
    [anon_sym_UR_DQUOTE] = ACTIONS(2246),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2246),
    [anon_sym_co_await] = ACTIONS(2244),
    [anon_sym_new] = ACTIONS(2244),
    [anon_sym_requires] = ACTIONS(2244),
    [sym_this] = ACTIONS(2244),
    [anon_sym_discard] = ACTIONS(2244),
    [anon_sym_precise] = ACTIONS(2244),
    [anon_sym_shared] = ACTIONS(2244),
    [anon_sym_groupshared] = ACTIONS(2244),
    [anon_sym_uniform] = ACTIONS(2244),
    [anon_sym_row_major] = ACTIONS(2244),
    [anon_sym_column_major] = ACTIONS(2244),
    [anon_sym_globallycoherent] = ACTIONS(2244),
    [anon_sym_centroid] = ACTIONS(2244),
    [anon_sym_noperspective] = ACTIONS(2244),
    [anon_sym_nointerpolation] = ACTIONS(2244),
    [anon_sym_sample] = ACTIONS(2244),
    [anon_sym_linear] = ACTIONS(2244),
    [anon_sym_snorm] = ACTIONS(2244),
    [anon_sym_unorm] = ACTIONS(2244),
    [anon_sym_point] = ACTIONS(2244),
    [anon_sym_line] = ACTIONS(2244),
    [anon_sym_triangleadj] = ACTIONS(2244),
    [anon_sym_lineadj] = ACTIONS(2244),
    [anon_sym_triangle] = ACTIONS(2244),
    [anon_sym_cbuffer] = ACTIONS(2244),
    [anon_sym_interface] = ACTIONS(2244),
    [anon_sym_extension] = ACTIONS(2244),
  },
  [118] = {
    [sym_identifier] = ACTIONS(2248),
    [aux_sym_preproc_include_token1] = ACTIONS(2248),
    [aux_sym_preproc_def_token1] = ACTIONS(2248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2250),
    [aux_sym_preproc_if_token1] = ACTIONS(2248),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2248),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2248),
    [sym_preproc_directive] = ACTIONS(2248),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2248),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2248),
    [anon_sym_PLUS] = ACTIONS(2248),
    [anon_sym_STAR] = ACTIONS(2248),
    [anon_sym_SLASH] = ACTIONS(2248),
    [anon_sym_PERCENT] = ACTIONS(2248),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2248),
    [anon_sym_EQ_EQ] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_GT] = ACTIONS(2248),
    [anon_sym_GT_EQ] = ACTIONS(2250),
    [anon_sym_LT_EQ] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_LT_LT] = ACTIONS(2248),
    [anon_sym_GT_GT] = ACTIONS(2248),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym___extension__] = ACTIONS(2248),
    [anon_sym_typedef] = ACTIONS(2248),
    [anon_sym_in] = ACTIONS(2248),
    [anon_sym_out] = ACTIONS(2248),
    [anon_sym_inout] = ACTIONS(2248),
    [anon_sym_extern] = ACTIONS(2248),
    [anon_sym___attribute__] = ACTIONS(2248),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2250),
    [anon_sym___declspec] = ACTIONS(2248),
    [anon_sym___based] = ACTIONS(2248),
    [anon_sym___cdecl] = ACTIONS(2248),
    [anon_sym___clrcall] = ACTIONS(2248),
    [anon_sym___stdcall] = ACTIONS(2248),
    [anon_sym___fastcall] = ACTIONS(2248),
    [anon_sym___thiscall] = ACTIONS(2248),
    [anon_sym___vectorcall] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_signed] = ACTIONS(2248),
    [anon_sym_unsigned] = ACTIONS(2248),
    [anon_sym_long] = ACTIONS(2248),
    [anon_sym_short] = ACTIONS(2248),
    [anon_sym_LBRACK] = ACTIONS(2248),
    [anon_sym_static] = ACTIONS(2248),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_register] = ACTIONS(2248),
    [anon_sym_inline] = ACTIONS(2248),
    [anon_sym___inline] = ACTIONS(2248),
    [anon_sym___inline__] = ACTIONS(2248),
    [anon_sym___forceinline] = ACTIONS(2248),
    [anon_sym_thread_local] = ACTIONS(2248),
    [anon_sym___thread] = ACTIONS(2248),
    [anon_sym_const] = ACTIONS(2248),
    [anon_sym_constexpr] = ACTIONS(2248),
    [anon_sym_volatile] = ACTIONS(2248),
    [anon_sym_restrict] = ACTIONS(2248),
    [anon_sym___restrict__] = ACTIONS(2248),
    [anon_sym__Atomic] = ACTIONS(2248),
    [anon_sym__Noreturn] = ACTIONS(2248),
    [anon_sym_noreturn] = ACTIONS(2248),
    [anon_sym_mutable] = ACTIONS(2248),
    [anon_sym_constinit] = ACTIONS(2248),
    [anon_sym_consteval] = ACTIONS(2248),
    [anon_sym_alignas] = ACTIONS(2248),
    [anon_sym__Alignas] = ACTIONS(2248),
    [sym_primitive_type] = ACTIONS(2248),
    [anon_sym_enum] = ACTIONS(2248),
    [anon_sym_class] = ACTIONS(2248),
    [anon_sym_struct] = ACTIONS(2248),
    [anon_sym_union] = ACTIONS(2248),
    [anon_sym_if] = ACTIONS(2248),
    [anon_sym_switch] = ACTIONS(2248),
    [anon_sym_case] = ACTIONS(2248),
    [anon_sym_default] = ACTIONS(2248),
    [anon_sym_while] = ACTIONS(2248),
    [anon_sym_do] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2248),
    [anon_sym_break] = ACTIONS(2248),
    [anon_sym_continue] = ACTIONS(2248),
    [anon_sym_goto] = ACTIONS(2248),
    [anon_sym___try] = ACTIONS(2248),
    [anon_sym___leave] = ACTIONS(2248),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_STAR_EQ] = ACTIONS(2250),
    [anon_sym_SLASH_EQ] = ACTIONS(2250),
    [anon_sym_PERCENT_EQ] = ACTIONS(2250),
    [anon_sym_PLUS_EQ] = ACTIONS(2250),
    [anon_sym_DASH_EQ] = ACTIONS(2250),
    [anon_sym_LT_LT_EQ] = ACTIONS(2250),
    [anon_sym_GT_GT_EQ] = ACTIONS(2250),
    [anon_sym_AMP_EQ] = ACTIONS(2250),
    [anon_sym_CARET_EQ] = ACTIONS(2250),
    [anon_sym_PIPE_EQ] = ACTIONS(2250),
    [anon_sym_and_eq] = ACTIONS(2248),
    [anon_sym_or_eq] = ACTIONS(2248),
    [anon_sym_xor_eq] = ACTIONS(2248),
    [anon_sym_not] = ACTIONS(2248),
    [anon_sym_compl] = ACTIONS(2248),
    [anon_sym_LT_EQ_GT] = ACTIONS(2250),
    [anon_sym_or] = ACTIONS(2248),
    [anon_sym_and] = ACTIONS(2248),
    [anon_sym_bitor] = ACTIONS(2248),
    [anon_sym_xor] = ACTIONS(2248),
    [anon_sym_bitand] = ACTIONS(2248),
    [anon_sym_not_eq] = ACTIONS(2248),
    [anon_sym_is] = ACTIONS(2248),
    [anon_sym_as] = ACTIONS(2248),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_sizeof] = ACTIONS(2248),
    [anon_sym___alignof__] = ACTIONS(2248),
    [anon_sym___alignof] = ACTIONS(2248),
    [anon_sym__alignof] = ACTIONS(2248),
    [anon_sym_alignof] = ACTIONS(2248),
    [anon_sym__Alignof] = ACTIONS(2248),
    [anon_sym_offsetof] = ACTIONS(2248),
    [anon_sym__Generic] = ACTIONS(2248),
    [anon_sym_asm] = ACTIONS(2248),
    [anon_sym___asm__] = ACTIONS(2248),
    [anon_sym_DOT] = ACTIONS(2248),
    [anon_sym_DOT_STAR] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2250),
    [sym_number_literal] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2250),
    [anon_sym_u_SQUOTE] = ACTIONS(2250),
    [anon_sym_U_SQUOTE] = ACTIONS(2250),
    [anon_sym_u8_SQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym_L_DQUOTE] = ACTIONS(2250),
    [anon_sym_u_DQUOTE] = ACTIONS(2250),
    [anon_sym_U_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [sym_true] = ACTIONS(2248),
    [sym_false] = ACTIONS(2248),
    [anon_sym_NULL] = ACTIONS(2248),
    [anon_sym_nullptr] = ACTIONS(2248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2248),
    [anon_sym_let] = ACTIONS(2248),
    [anon_sym_This] = ACTIONS(2248),
    [anon_sym_decltype] = ACTIONS(2248),
    [sym_virtual] = ACTIONS(2248),
    [anon_sym_explicit] = ACTIONS(2248),
    [anon_sym_typename] = ACTIONS(2248),
    [anon_sym_template] = ACTIONS(2248),
    [anon_sym_operator] = ACTIONS(2248),
    [anon_sym_try] = ACTIONS(2248),
    [anon_sym_delete] = ACTIONS(2248),
    [anon_sym_throw] = ACTIONS(2248),
    [anon_sym_namespace] = ACTIONS(2248),
    [anon_sym_using] = ACTIONS(2248),
    [anon_sym_static_assert] = ACTIONS(2248),
    [anon_sym_concept] = ACTIONS(2248),
    [anon_sym_co_return] = ACTIONS(2248),
    [anon_sym_co_yield] = ACTIONS(2248),
    [anon_sym_R_DQUOTE] = ACTIONS(2250),
    [anon_sym_LR_DQUOTE] = ACTIONS(2250),
    [anon_sym_uR_DQUOTE] = ACTIONS(2250),
    [anon_sym_UR_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2250),
    [anon_sym_co_await] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2248),
    [anon_sym_requires] = ACTIONS(2248),
    [sym_this] = ACTIONS(2248),
    [anon_sym_discard] = ACTIONS(2248),
    [anon_sym_precise] = ACTIONS(2248),
    [anon_sym_shared] = ACTIONS(2248),
    [anon_sym_groupshared] = ACTIONS(2248),
    [anon_sym_uniform] = ACTIONS(2248),
    [anon_sym_row_major] = ACTIONS(2248),
    [anon_sym_column_major] = ACTIONS(2248),
    [anon_sym_globallycoherent] = ACTIONS(2248),
    [anon_sym_centroid] = ACTIONS(2248),
    [anon_sym_noperspective] = ACTIONS(2248),
    [anon_sym_nointerpolation] = ACTIONS(2248),
    [anon_sym_sample] = ACTIONS(2248),
    [anon_sym_linear] = ACTIONS(2248),
    [anon_sym_snorm] = ACTIONS(2248),
    [anon_sym_unorm] = ACTIONS(2248),
    [anon_sym_point] = ACTIONS(2248),
    [anon_sym_line] = ACTIONS(2248),
    [anon_sym_triangleadj] = ACTIONS(2248),
    [anon_sym_lineadj] = ACTIONS(2248),
    [anon_sym_triangle] = ACTIONS(2248),
    [anon_sym_cbuffer] = ACTIONS(2248),
    [anon_sym_interface] = ACTIONS(2248),
    [anon_sym_extension] = ACTIONS(2248),
  },
  [119] = {
    [sym_identifier] = ACTIONS(2252),
    [aux_sym_preproc_include_token1] = ACTIONS(2252),
    [aux_sym_preproc_def_token1] = ACTIONS(2252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2254),
    [anon_sym_COMMA] = ACTIONS(2254),
    [aux_sym_preproc_if_token1] = ACTIONS(2252),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2252),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2252),
    [sym_preproc_directive] = ACTIONS(2252),
    [anon_sym_LPAREN2] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2252),
    [anon_sym_TILDE] = ACTIONS(2254),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_SLASH] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2252),
    [anon_sym_PIPE_PIPE] = ACTIONS(2254),
    [anon_sym_AMP_AMP] = ACTIONS(2254),
    [anon_sym_PIPE] = ACTIONS(2252),
    [anon_sym_CARET] = ACTIONS(2252),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_EQ_EQ] = ACTIONS(2254),
    [anon_sym_BANG_EQ] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2252),
    [anon_sym_GT_EQ] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2252),
    [anon_sym_LT_LT] = ACTIONS(2252),
    [anon_sym_GT_GT] = ACTIONS(2252),
    [anon_sym_SEMI] = ACTIONS(2254),
    [anon_sym___extension__] = ACTIONS(2252),
    [anon_sym_typedef] = ACTIONS(2252),
    [anon_sym_in] = ACTIONS(2252),
    [anon_sym_out] = ACTIONS(2252),
    [anon_sym_inout] = ACTIONS(2252),
    [anon_sym_extern] = ACTIONS(2252),
    [anon_sym___attribute__] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2254),
    [anon_sym___declspec] = ACTIONS(2252),
    [anon_sym___based] = ACTIONS(2252),
    [anon_sym___cdecl] = ACTIONS(2252),
    [anon_sym___clrcall] = ACTIONS(2252),
    [anon_sym___stdcall] = ACTIONS(2252),
    [anon_sym___fastcall] = ACTIONS(2252),
    [anon_sym___thiscall] = ACTIONS(2252),
    [anon_sym___vectorcall] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_RBRACE] = ACTIONS(2254),
    [anon_sym_signed] = ACTIONS(2252),
    [anon_sym_unsigned] = ACTIONS(2252),
    [anon_sym_long] = ACTIONS(2252),
    [anon_sym_short] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2252),
    [anon_sym_EQ] = ACTIONS(2252),
    [anon_sym_register] = ACTIONS(2252),
    [anon_sym_inline] = ACTIONS(2252),
    [anon_sym___inline] = ACTIONS(2252),
    [anon_sym___inline__] = ACTIONS(2252),
    [anon_sym___forceinline] = ACTIONS(2252),
    [anon_sym_thread_local] = ACTIONS(2252),
    [anon_sym___thread] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2252),
    [anon_sym_constexpr] = ACTIONS(2252),
    [anon_sym_volatile] = ACTIONS(2252),
    [anon_sym_restrict] = ACTIONS(2252),
    [anon_sym___restrict__] = ACTIONS(2252),
    [anon_sym__Atomic] = ACTIONS(2252),
    [anon_sym__Noreturn] = ACTIONS(2252),
    [anon_sym_noreturn] = ACTIONS(2252),
    [anon_sym_mutable] = ACTIONS(2252),
    [anon_sym_constinit] = ACTIONS(2252),
    [anon_sym_consteval] = ACTIONS(2252),
    [anon_sym_alignas] = ACTIONS(2252),
    [anon_sym__Alignas] = ACTIONS(2252),
    [sym_primitive_type] = ACTIONS(2252),
    [anon_sym_enum] = ACTIONS(2252),
    [anon_sym_class] = ACTIONS(2252),
    [anon_sym_struct] = ACTIONS(2252),
    [anon_sym_union] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_switch] = ACTIONS(2252),
    [anon_sym_case] = ACTIONS(2252),
    [anon_sym_default] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_do] = ACTIONS(2252),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2252),
    [anon_sym_goto] = ACTIONS(2252),
    [anon_sym___try] = ACTIONS(2252),
    [anon_sym___leave] = ACTIONS(2252),
    [anon_sym_QMARK] = ACTIONS(2254),
    [anon_sym_STAR_EQ] = ACTIONS(2254),
    [anon_sym_SLASH_EQ] = ACTIONS(2254),
    [anon_sym_PERCENT_EQ] = ACTIONS(2254),
    [anon_sym_PLUS_EQ] = ACTIONS(2254),
    [anon_sym_DASH_EQ] = ACTIONS(2254),
    [anon_sym_LT_LT_EQ] = ACTIONS(2254),
    [anon_sym_GT_GT_EQ] = ACTIONS(2254),
    [anon_sym_AMP_EQ] = ACTIONS(2254),
    [anon_sym_CARET_EQ] = ACTIONS(2254),
    [anon_sym_PIPE_EQ] = ACTIONS(2254),
    [anon_sym_and_eq] = ACTIONS(2252),
    [anon_sym_or_eq] = ACTIONS(2252),
    [anon_sym_xor_eq] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2252),
    [anon_sym_compl] = ACTIONS(2252),
    [anon_sym_LT_EQ_GT] = ACTIONS(2254),
    [anon_sym_or] = ACTIONS(2252),
    [anon_sym_and] = ACTIONS(2252),
    [anon_sym_bitor] = ACTIONS(2252),
    [anon_sym_xor] = ACTIONS(2252),
    [anon_sym_bitand] = ACTIONS(2252),
    [anon_sym_not_eq] = ACTIONS(2252),
    [anon_sym_is] = ACTIONS(2252),
    [anon_sym_as] = ACTIONS(2252),
    [anon_sym_DASH_DASH] = ACTIONS(2254),
    [anon_sym_PLUS_PLUS] = ACTIONS(2254),
    [anon_sym_sizeof] = ACTIONS(2252),
    [anon_sym___alignof__] = ACTIONS(2252),
    [anon_sym___alignof] = ACTIONS(2252),
    [anon_sym__alignof] = ACTIONS(2252),
    [anon_sym_alignof] = ACTIONS(2252),
    [anon_sym__Alignof] = ACTIONS(2252),
    [anon_sym_offsetof] = ACTIONS(2252),
    [anon_sym__Generic] = ACTIONS(2252),
    [anon_sym_asm] = ACTIONS(2252),
    [anon_sym___asm__] = ACTIONS(2252),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_DOT_STAR] = ACTIONS(2254),
    [anon_sym_DASH_GT] = ACTIONS(2254),
    [sym_number_literal] = ACTIONS(2254),
    [anon_sym_L_SQUOTE] = ACTIONS(2254),
    [anon_sym_u_SQUOTE] = ACTIONS(2254),
    [anon_sym_U_SQUOTE] = ACTIONS(2254),
    [anon_sym_u8_SQUOTE] = ACTIONS(2254),
    [anon_sym_SQUOTE] = ACTIONS(2254),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2252),
    [sym_false] = ACTIONS(2252),
    [anon_sym_NULL] = ACTIONS(2252),
    [anon_sym_nullptr] = ACTIONS(2252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_This] = ACTIONS(2252),
    [anon_sym_decltype] = ACTIONS(2252),
    [sym_virtual] = ACTIONS(2252),
    [anon_sym_explicit] = ACTIONS(2252),
    [anon_sym_typename] = ACTIONS(2252),
    [anon_sym_template] = ACTIONS(2252),
    [anon_sym_operator] = ACTIONS(2252),
    [anon_sym_try] = ACTIONS(2252),
    [anon_sym_delete] = ACTIONS(2252),
    [anon_sym_throw] = ACTIONS(2252),
    [anon_sym_namespace] = ACTIONS(2252),
    [anon_sym_using] = ACTIONS(2252),
    [anon_sym_static_assert] = ACTIONS(2252),
    [anon_sym_concept] = ACTIONS(2252),
    [anon_sym_co_return] = ACTIONS(2252),
    [anon_sym_co_yield] = ACTIONS(2252),
    [anon_sym_R_DQUOTE] = ACTIONS(2254),
    [anon_sym_LR_DQUOTE] = ACTIONS(2254),
    [anon_sym_uR_DQUOTE] = ACTIONS(2254),
    [anon_sym_UR_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2254),
    [anon_sym_co_await] = ACTIONS(2252),
    [anon_sym_new] = ACTIONS(2252),
    [anon_sym_requires] = ACTIONS(2252),
    [sym_this] = ACTIONS(2252),
    [anon_sym_discard] = ACTIONS(2252),
    [anon_sym_precise] = ACTIONS(2252),
    [anon_sym_shared] = ACTIONS(2252),
    [anon_sym_groupshared] = ACTIONS(2252),
    [anon_sym_uniform] = ACTIONS(2252),
    [anon_sym_row_major] = ACTIONS(2252),
    [anon_sym_column_major] = ACTIONS(2252),
    [anon_sym_globallycoherent] = ACTIONS(2252),
    [anon_sym_centroid] = ACTIONS(2252),
    [anon_sym_noperspective] = ACTIONS(2252),
    [anon_sym_nointerpolation] = ACTIONS(2252),
    [anon_sym_sample] = ACTIONS(2252),
    [anon_sym_linear] = ACTIONS(2252),
    [anon_sym_snorm] = ACTIONS(2252),
    [anon_sym_unorm] = ACTIONS(2252),
    [anon_sym_point] = ACTIONS(2252),
    [anon_sym_line] = ACTIONS(2252),
    [anon_sym_triangleadj] = ACTIONS(2252),
    [anon_sym_lineadj] = ACTIONS(2252),
    [anon_sym_triangle] = ACTIONS(2252),
    [anon_sym_cbuffer] = ACTIONS(2252),
    [anon_sym_interface] = ACTIONS(2252),
    [anon_sym_extension] = ACTIONS(2252),
  },
  [120] = {
    [sym_identifier] = ACTIONS(2256),
    [aux_sym_preproc_include_token1] = ACTIONS(2256),
    [aux_sym_preproc_def_token1] = ACTIONS(2256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2258),
    [anon_sym_COMMA] = ACTIONS(2258),
    [aux_sym_preproc_if_token1] = ACTIONS(2256),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2256),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2256),
    [sym_preproc_directive] = ACTIONS(2256),
    [anon_sym_LPAREN2] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(2256),
    [anon_sym_TILDE] = ACTIONS(2258),
    [anon_sym_DASH] = ACTIONS(2256),
    [anon_sym_PLUS] = ACTIONS(2256),
    [anon_sym_STAR] = ACTIONS(2256),
    [anon_sym_SLASH] = ACTIONS(2256),
    [anon_sym_PERCENT] = ACTIONS(2256),
    [anon_sym_PIPE_PIPE] = ACTIONS(2258),
    [anon_sym_AMP_AMP] = ACTIONS(2258),
    [anon_sym_PIPE] = ACTIONS(2256),
    [anon_sym_CARET] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(2256),
    [anon_sym_EQ_EQ] = ACTIONS(2258),
    [anon_sym_BANG_EQ] = ACTIONS(2258),
    [anon_sym_GT] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2258),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_LT] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2256),
    [anon_sym_GT_GT] = ACTIONS(2256),
    [anon_sym_SEMI] = ACTIONS(2258),
    [anon_sym___extension__] = ACTIONS(2256),
    [anon_sym_typedef] = ACTIONS(2256),
    [anon_sym_in] = ACTIONS(2256),
    [anon_sym_out] = ACTIONS(2256),
    [anon_sym_inout] = ACTIONS(2256),
    [anon_sym_extern] = ACTIONS(2256),
    [anon_sym___attribute__] = ACTIONS(2256),
    [anon_sym_COLON_COLON] = ACTIONS(2258),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2258),
    [anon_sym___declspec] = ACTIONS(2256),
    [anon_sym___based] = ACTIONS(2256),
    [anon_sym___cdecl] = ACTIONS(2256),
    [anon_sym___clrcall] = ACTIONS(2256),
    [anon_sym___stdcall] = ACTIONS(2256),
    [anon_sym___fastcall] = ACTIONS(2256),
    [anon_sym___thiscall] = ACTIONS(2256),
    [anon_sym___vectorcall] = ACTIONS(2256),
    [anon_sym_LBRACE] = ACTIONS(2258),
    [anon_sym_RBRACE] = ACTIONS(2258),
    [anon_sym_signed] = ACTIONS(2256),
    [anon_sym_unsigned] = ACTIONS(2256),
    [anon_sym_long] = ACTIONS(2256),
    [anon_sym_short] = ACTIONS(2256),
    [anon_sym_LBRACK] = ACTIONS(2256),
    [anon_sym_static] = ACTIONS(2256),
    [anon_sym_EQ] = ACTIONS(2256),
    [anon_sym_register] = ACTIONS(2256),
    [anon_sym_inline] = ACTIONS(2256),
    [anon_sym___inline] = ACTIONS(2256),
    [anon_sym___inline__] = ACTIONS(2256),
    [anon_sym___forceinline] = ACTIONS(2256),
    [anon_sym_thread_local] = ACTIONS(2256),
    [anon_sym___thread] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_constexpr] = ACTIONS(2256),
    [anon_sym_volatile] = ACTIONS(2256),
    [anon_sym_restrict] = ACTIONS(2256),
    [anon_sym___restrict__] = ACTIONS(2256),
    [anon_sym__Atomic] = ACTIONS(2256),
    [anon_sym__Noreturn] = ACTIONS(2256),
    [anon_sym_noreturn] = ACTIONS(2256),
    [anon_sym_mutable] = ACTIONS(2256),
    [anon_sym_constinit] = ACTIONS(2256),
    [anon_sym_consteval] = ACTIONS(2256),
    [anon_sym_alignas] = ACTIONS(2256),
    [anon_sym__Alignas] = ACTIONS(2256),
    [sym_primitive_type] = ACTIONS(2256),
    [anon_sym_enum] = ACTIONS(2256),
    [anon_sym_class] = ACTIONS(2256),
    [anon_sym_struct] = ACTIONS(2256),
    [anon_sym_union] = ACTIONS(2256),
    [anon_sym_if] = ACTIONS(2256),
    [anon_sym_switch] = ACTIONS(2256),
    [anon_sym_case] = ACTIONS(2256),
    [anon_sym_default] = ACTIONS(2256),
    [anon_sym_while] = ACTIONS(2256),
    [anon_sym_do] = ACTIONS(2256),
    [anon_sym_for] = ACTIONS(2256),
    [anon_sym_return] = ACTIONS(2256),
    [anon_sym_break] = ACTIONS(2256),
    [anon_sym_continue] = ACTIONS(2256),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym___try] = ACTIONS(2256),
    [anon_sym___leave] = ACTIONS(2256),
    [anon_sym_QMARK] = ACTIONS(2258),
    [anon_sym_STAR_EQ] = ACTIONS(2258),
    [anon_sym_SLASH_EQ] = ACTIONS(2258),
    [anon_sym_PERCENT_EQ] = ACTIONS(2258),
    [anon_sym_PLUS_EQ] = ACTIONS(2258),
    [anon_sym_DASH_EQ] = ACTIONS(2258),
    [anon_sym_LT_LT_EQ] = ACTIONS(2258),
    [anon_sym_GT_GT_EQ] = ACTIONS(2258),
    [anon_sym_AMP_EQ] = ACTIONS(2258),
    [anon_sym_CARET_EQ] = ACTIONS(2258),
    [anon_sym_PIPE_EQ] = ACTIONS(2258),
    [anon_sym_and_eq] = ACTIONS(2256),
    [anon_sym_or_eq] = ACTIONS(2256),
    [anon_sym_xor_eq] = ACTIONS(2256),
    [anon_sym_not] = ACTIONS(2256),
    [anon_sym_compl] = ACTIONS(2256),
    [anon_sym_LT_EQ_GT] = ACTIONS(2258),
    [anon_sym_or] = ACTIONS(2256),
    [anon_sym_and] = ACTIONS(2256),
    [anon_sym_bitor] = ACTIONS(2256),
    [anon_sym_xor] = ACTIONS(2256),
    [anon_sym_bitand] = ACTIONS(2256),
    [anon_sym_not_eq] = ACTIONS(2256),
    [anon_sym_is] = ACTIONS(2256),
    [anon_sym_as] = ACTIONS(2256),
    [anon_sym_DASH_DASH] = ACTIONS(2258),
    [anon_sym_PLUS_PLUS] = ACTIONS(2258),
    [anon_sym_sizeof] = ACTIONS(2256),
    [anon_sym___alignof__] = ACTIONS(2256),
    [anon_sym___alignof] = ACTIONS(2256),
    [anon_sym__alignof] = ACTIONS(2256),
    [anon_sym_alignof] = ACTIONS(2256),
    [anon_sym__Alignof] = ACTIONS(2256),
    [anon_sym_offsetof] = ACTIONS(2256),
    [anon_sym__Generic] = ACTIONS(2256),
    [anon_sym_asm] = ACTIONS(2256),
    [anon_sym___asm__] = ACTIONS(2256),
    [anon_sym_DOT] = ACTIONS(2256),
    [anon_sym_DOT_STAR] = ACTIONS(2258),
    [anon_sym_DASH_GT] = ACTIONS(2258),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_L_SQUOTE] = ACTIONS(2258),
    [anon_sym_u_SQUOTE] = ACTIONS(2258),
    [anon_sym_U_SQUOTE] = ACTIONS(2258),
    [anon_sym_u8_SQUOTE] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(2258),
    [anon_sym_L_DQUOTE] = ACTIONS(2258),
    [anon_sym_u_DQUOTE] = ACTIONS(2258),
    [anon_sym_U_DQUOTE] = ACTIONS(2258),
    [anon_sym_u8_DQUOTE] = ACTIONS(2258),
    [anon_sym_DQUOTE] = ACTIONS(2258),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2256),
    [anon_sym_nullptr] = ACTIONS(2256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_This] = ACTIONS(2256),
    [anon_sym_decltype] = ACTIONS(2256),
    [sym_virtual] = ACTIONS(2256),
    [anon_sym_explicit] = ACTIONS(2256),
    [anon_sym_typename] = ACTIONS(2256),
    [anon_sym_template] = ACTIONS(2256),
    [anon_sym_operator] = ACTIONS(2256),
    [anon_sym_try] = ACTIONS(2256),
    [anon_sym_delete] = ACTIONS(2256),
    [anon_sym_throw] = ACTIONS(2256),
    [anon_sym_namespace] = ACTIONS(2256),
    [anon_sym_using] = ACTIONS(2256),
    [anon_sym_static_assert] = ACTIONS(2256),
    [anon_sym_concept] = ACTIONS(2256),
    [anon_sym_co_return] = ACTIONS(2256),
    [anon_sym_co_yield] = ACTIONS(2256),
    [anon_sym_R_DQUOTE] = ACTIONS(2258),
    [anon_sym_LR_DQUOTE] = ACTIONS(2258),
    [anon_sym_uR_DQUOTE] = ACTIONS(2258),
    [anon_sym_UR_DQUOTE] = ACTIONS(2258),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2258),
    [anon_sym_co_await] = ACTIONS(2256),
    [anon_sym_new] = ACTIONS(2256),
    [anon_sym_requires] = ACTIONS(2256),
    [sym_this] = ACTIONS(2256),
    [anon_sym_discard] = ACTIONS(2256),
    [anon_sym_precise] = ACTIONS(2256),
    [anon_sym_shared] = ACTIONS(2256),
    [anon_sym_groupshared] = ACTIONS(2256),
    [anon_sym_uniform] = ACTIONS(2256),
    [anon_sym_row_major] = ACTIONS(2256),
    [anon_sym_column_major] = ACTIONS(2256),
    [anon_sym_globallycoherent] = ACTIONS(2256),
    [anon_sym_centroid] = ACTIONS(2256),
    [anon_sym_noperspective] = ACTIONS(2256),
    [anon_sym_nointerpolation] = ACTIONS(2256),
    [anon_sym_sample] = ACTIONS(2256),
    [anon_sym_linear] = ACTIONS(2256),
    [anon_sym_snorm] = ACTIONS(2256),
    [anon_sym_unorm] = ACTIONS(2256),
    [anon_sym_point] = ACTIONS(2256),
    [anon_sym_line] = ACTIONS(2256),
    [anon_sym_triangleadj] = ACTIONS(2256),
    [anon_sym_lineadj] = ACTIONS(2256),
    [anon_sym_triangle] = ACTIONS(2256),
    [anon_sym_cbuffer] = ACTIONS(2256),
    [anon_sym_interface] = ACTIONS(2256),
    [anon_sym_extension] = ACTIONS(2256),
  },
  [121] = {
    [sym_template_argument_list] = STATE(134),
    [ts_builtin_sym_end] = ACTIONS(2176),
    [sym_identifier] = ACTIONS(2169),
    [aux_sym_preproc_include_token1] = ACTIONS(2169),
    [aux_sym_preproc_def_token1] = ACTIONS(2169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2171),
    [aux_sym_preproc_if_token1] = ACTIONS(2169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2169),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2169),
    [sym_preproc_directive] = ACTIONS(2169),
    [anon_sym_LPAREN2] = ACTIONS(2173),
    [anon_sym_BANG] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2178),
    [anon_sym_PLUS] = ACTIONS(2178),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2171),
    [anon_sym_AMP_AMP] = ACTIONS(2173),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2171),
    [anon_sym_BANG_EQ] = ACTIONS(2171),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2171),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(2260),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_SEMI] = ACTIONS(2173),
    [anon_sym___extension__] = ACTIONS(2169),
    [anon_sym_typedef] = ACTIONS(2169),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_out] = ACTIONS(2169),
    [anon_sym_inout] = ACTIONS(2169),
    [anon_sym_extern] = ACTIONS(2169),
    [anon_sym___attribute__] = ACTIONS(2169),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2173),
    [anon_sym___declspec] = ACTIONS(2169),
    [anon_sym___based] = ACTIONS(2169),
    [anon_sym___cdecl] = ACTIONS(2169),
    [anon_sym___clrcall] = ACTIONS(2169),
    [anon_sym___stdcall] = ACTIONS(2169),
    [anon_sym___fastcall] = ACTIONS(2169),
    [anon_sym___thiscall] = ACTIONS(2169),
    [anon_sym___vectorcall] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2176),
    [anon_sym_signed] = ACTIONS(2169),
    [anon_sym_unsigned] = ACTIONS(2169),
    [anon_sym_long] = ACTIONS(2169),
    [anon_sym_short] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2169),
    [anon_sym_EQ] = ACTIONS(2181),
    [anon_sym_register] = ACTIONS(2169),
    [anon_sym_inline] = ACTIONS(2169),
    [anon_sym___inline] = ACTIONS(2169),
    [anon_sym___inline__] = ACTIONS(2169),
    [anon_sym___forceinline] = ACTIONS(2169),
    [anon_sym_thread_local] = ACTIONS(2169),
    [anon_sym___thread] = ACTIONS(2169),
    [anon_sym_const] = ACTIONS(2169),
    [anon_sym_constexpr] = ACTIONS(2169),
    [anon_sym_volatile] = ACTIONS(2169),
    [anon_sym_restrict] = ACTIONS(2169),
    [anon_sym___restrict__] = ACTIONS(2169),
    [anon_sym__Atomic] = ACTIONS(2169),
    [anon_sym__Noreturn] = ACTIONS(2169),
    [anon_sym_noreturn] = ACTIONS(2169),
    [anon_sym_mutable] = ACTIONS(2169),
    [anon_sym_constinit] = ACTIONS(2169),
    [anon_sym_consteval] = ACTIONS(2169),
    [anon_sym_alignas] = ACTIONS(2169),
    [anon_sym__Alignas] = ACTIONS(2169),
    [sym_primitive_type] = ACTIONS(2169),
    [anon_sym_enum] = ACTIONS(2169),
    [anon_sym_class] = ACTIONS(2169),
    [anon_sym_struct] = ACTIONS(2169),
    [anon_sym_union] = ACTIONS(2169),
    [anon_sym_if] = ACTIONS(2169),
    [anon_sym_switch] = ACTIONS(2169),
    [anon_sym_case] = ACTIONS(2169),
    [anon_sym_default] = ACTIONS(2169),
    [anon_sym_while] = ACTIONS(2169),
    [anon_sym_do] = ACTIONS(2169),
    [anon_sym_for] = ACTIONS(2169),
    [anon_sym_return] = ACTIONS(2169),
    [anon_sym_break] = ACTIONS(2169),
    [anon_sym_continue] = ACTIONS(2169),
    [anon_sym_goto] = ACTIONS(2169),
    [anon_sym_QMARK] = ACTIONS(2171),
    [anon_sym_STAR_EQ] = ACTIONS(2171),
    [anon_sym_SLASH_EQ] = ACTIONS(2171),
    [anon_sym_PERCENT_EQ] = ACTIONS(2171),
    [anon_sym_PLUS_EQ] = ACTIONS(2171),
    [anon_sym_DASH_EQ] = ACTIONS(2171),
    [anon_sym_LT_LT_EQ] = ACTIONS(2171),
    [anon_sym_GT_GT_EQ] = ACTIONS(2171),
    [anon_sym_AMP_EQ] = ACTIONS(2171),
    [anon_sym_CARET_EQ] = ACTIONS(2171),
    [anon_sym_PIPE_EQ] = ACTIONS(2171),
    [anon_sym_and_eq] = ACTIONS(2181),
    [anon_sym_or_eq] = ACTIONS(2181),
    [anon_sym_xor_eq] = ACTIONS(2181),
    [anon_sym_not] = ACTIONS(2169),
    [anon_sym_compl] = ACTIONS(2169),
    [anon_sym_LT_EQ_GT] = ACTIONS(2171),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2181),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2181),
    [anon_sym_not_eq] = ACTIONS(2181),
    [anon_sym_is] = ACTIONS(2181),
    [anon_sym_as] = ACTIONS(2181),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_sizeof] = ACTIONS(2169),
    [anon_sym___alignof__] = ACTIONS(2169),
    [anon_sym___alignof] = ACTIONS(2169),
    [anon_sym__alignof] = ACTIONS(2169),
    [anon_sym_alignof] = ACTIONS(2169),
    [anon_sym__Alignof] = ACTIONS(2169),
    [anon_sym_offsetof] = ACTIONS(2169),
    [anon_sym__Generic] = ACTIONS(2169),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DOT_STAR] = ACTIONS(2171),
    [anon_sym_DASH_GT] = ACTIONS(2171),
    [sym_number_literal] = ACTIONS(2176),
    [anon_sym_L_SQUOTE] = ACTIONS(2176),
    [anon_sym_u_SQUOTE] = ACTIONS(2176),
    [anon_sym_U_SQUOTE] = ACTIONS(2176),
    [anon_sym_u8_SQUOTE] = ACTIONS(2176),
    [anon_sym_SQUOTE] = ACTIONS(2176),
    [anon_sym_L_DQUOTE] = ACTIONS(2176),
    [anon_sym_u_DQUOTE] = ACTIONS(2176),
    [anon_sym_U_DQUOTE] = ACTIONS(2176),
    [anon_sym_u8_DQUOTE] = ACTIONS(2176),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [sym_true] = ACTIONS(2169),
    [sym_false] = ACTIONS(2169),
    [anon_sym_NULL] = ACTIONS(2169),
    [anon_sym_nullptr] = ACTIONS(2169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2169),
    [anon_sym_let] = ACTIONS(2169),
    [anon_sym_This] = ACTIONS(2169),
    [anon_sym_decltype] = ACTIONS(2169),
    [sym_virtual] = ACTIONS(2169),
    [anon_sym_explicit] = ACTIONS(2169),
    [anon_sym_typename] = ACTIONS(2169),
    [anon_sym_template] = ACTIONS(2169),
    [anon_sym_operator] = ACTIONS(2169),
    [anon_sym_try] = ACTIONS(2169),
    [anon_sym_delete] = ACTIONS(2169),
    [anon_sym_throw] = ACTIONS(2169),
    [anon_sym_namespace] = ACTIONS(2169),
    [anon_sym_using] = ACTIONS(2169),
    [anon_sym_static_assert] = ACTIONS(2169),
    [anon_sym_concept] = ACTIONS(2169),
    [anon_sym_co_return] = ACTIONS(2169),
    [anon_sym_co_yield] = ACTIONS(2169),
    [anon_sym_R_DQUOTE] = ACTIONS(2176),
    [anon_sym_LR_DQUOTE] = ACTIONS(2176),
    [anon_sym_uR_DQUOTE] = ACTIONS(2176),
    [anon_sym_UR_DQUOTE] = ACTIONS(2176),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2176),
    [anon_sym_co_await] = ACTIONS(2169),
    [anon_sym_new] = ACTIONS(2169),
    [anon_sym_requires] = ACTIONS(2169),
    [sym_this] = ACTIONS(2169),
    [anon_sym_precise] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_groupshared] = ACTIONS(2169),
    [anon_sym_uniform] = ACTIONS(2169),
    [anon_sym_row_major] = ACTIONS(2169),
    [anon_sym_column_major] = ACTIONS(2169),
    [anon_sym_globallycoherent] = ACTIONS(2169),
    [anon_sym_centroid] = ACTIONS(2169),
    [anon_sym_noperspective] = ACTIONS(2169),
    [anon_sym_nointerpolation] = ACTIONS(2169),
    [anon_sym_sample] = ACTIONS(2169),
    [anon_sym_linear] = ACTIONS(2169),
    [anon_sym_snorm] = ACTIONS(2169),
    [anon_sym_unorm] = ACTIONS(2169),
    [anon_sym_point] = ACTIONS(2169),
    [anon_sym_line] = ACTIONS(2169),
    [anon_sym_triangleadj] = ACTIONS(2169),
    [anon_sym_lineadj] = ACTIONS(2169),
    [anon_sym_triangle] = ACTIONS(2169),
    [anon_sym_interface] = ACTIONS(2169),
    [anon_sym_extension] = ACTIONS(2169),
    [anon_sym___exported] = ACTIONS(2169),
    [anon_sym_import] = ACTIONS(2169),
  },
  [122] = {
    [ts_builtin_sym_end] = ACTIONS(2188),
    [sym_identifier] = ACTIONS(2186),
    [aux_sym_preproc_include_token1] = ACTIONS(2186),
    [aux_sym_preproc_def_token1] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [aux_sym_preproc_if_token1] = ACTIONS(2186),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2186),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2186),
    [sym_preproc_directive] = ACTIONS(2186),
    [anon_sym_LPAREN2] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2186),
    [anon_sym_TILDE] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2186),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_STAR] = ACTIONS(2186),
    [anon_sym_SLASH] = ACTIONS(2186),
    [anon_sym_PERCENT] = ACTIONS(2186),
    [anon_sym_PIPE_PIPE] = ACTIONS(2188),
    [anon_sym_AMP_AMP] = ACTIONS(2188),
    [anon_sym_PIPE] = ACTIONS(2186),
    [anon_sym_CARET] = ACTIONS(2186),
    [anon_sym_AMP] = ACTIONS(2186),
    [anon_sym_EQ_EQ] = ACTIONS(2188),
    [anon_sym_BANG_EQ] = ACTIONS(2188),
    [anon_sym_GT] = ACTIONS(2186),
    [anon_sym_GT_EQ] = ACTIONS(2188),
    [anon_sym_LT_EQ] = ACTIONS(2186),
    [anon_sym_LT] = ACTIONS(2186),
    [anon_sym_LT_LT] = ACTIONS(2186),
    [anon_sym_GT_GT] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym___extension__] = ACTIONS(2186),
    [anon_sym_typedef] = ACTIONS(2186),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_out] = ACTIONS(2186),
    [anon_sym_inout] = ACTIONS(2186),
    [anon_sym_extern] = ACTIONS(2186),
    [anon_sym___attribute__] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2188),
    [anon_sym___declspec] = ACTIONS(2186),
    [anon_sym___based] = ACTIONS(2186),
    [anon_sym___cdecl] = ACTIONS(2186),
    [anon_sym___clrcall] = ACTIONS(2186),
    [anon_sym___stdcall] = ACTIONS(2186),
    [anon_sym___fastcall] = ACTIONS(2186),
    [anon_sym___thiscall] = ACTIONS(2186),
    [anon_sym___vectorcall] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_signed] = ACTIONS(2186),
    [anon_sym_unsigned] = ACTIONS(2186),
    [anon_sym_long] = ACTIONS(2186),
    [anon_sym_short] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_static] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_register] = ACTIONS(2186),
    [anon_sym_inline] = ACTIONS(2186),
    [anon_sym___inline] = ACTIONS(2186),
    [anon_sym___inline__] = ACTIONS(2186),
    [anon_sym___forceinline] = ACTIONS(2186),
    [anon_sym_thread_local] = ACTIONS(2186),
    [anon_sym___thread] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_constexpr] = ACTIONS(2186),
    [anon_sym_volatile] = ACTIONS(2186),
    [anon_sym_restrict] = ACTIONS(2186),
    [anon_sym___restrict__] = ACTIONS(2186),
    [anon_sym__Atomic] = ACTIONS(2186),
    [anon_sym__Noreturn] = ACTIONS(2186),
    [anon_sym_noreturn] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_constinit] = ACTIONS(2186),
    [anon_sym_consteval] = ACTIONS(2186),
    [anon_sym_alignas] = ACTIONS(2186),
    [anon_sym__Alignas] = ACTIONS(2186),
    [sym_primitive_type] = ACTIONS(2186),
    [anon_sym_enum] = ACTIONS(2186),
    [anon_sym_class] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_union] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_switch] = ACTIONS(2186),
    [anon_sym_case] = ACTIONS(2186),
    [anon_sym_default] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [anon_sym_do] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_break] = ACTIONS(2186),
    [anon_sym_continue] = ACTIONS(2186),
    [anon_sym_goto] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_STAR_EQ] = ACTIONS(2188),
    [anon_sym_SLASH_EQ] = ACTIONS(2188),
    [anon_sym_PERCENT_EQ] = ACTIONS(2188),
    [anon_sym_PLUS_EQ] = ACTIONS(2188),
    [anon_sym_DASH_EQ] = ACTIONS(2188),
    [anon_sym_LT_LT_EQ] = ACTIONS(2188),
    [anon_sym_GT_GT_EQ] = ACTIONS(2188),
    [anon_sym_AMP_EQ] = ACTIONS(2188),
    [anon_sym_CARET_EQ] = ACTIONS(2188),
    [anon_sym_PIPE_EQ] = ACTIONS(2188),
    [anon_sym_and_eq] = ACTIONS(2186),
    [anon_sym_or_eq] = ACTIONS(2186),
    [anon_sym_xor_eq] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2186),
    [anon_sym_compl] = ACTIONS(2186),
    [anon_sym_LT_EQ_GT] = ACTIONS(2188),
    [anon_sym_or] = ACTIONS(2186),
    [anon_sym_and] = ACTIONS(2186),
    [anon_sym_bitor] = ACTIONS(2186),
    [anon_sym_xor] = ACTIONS(2186),
    [anon_sym_bitand] = ACTIONS(2186),
    [anon_sym_not_eq] = ACTIONS(2186),
    [anon_sym_is] = ACTIONS(2186),
    [anon_sym_as] = ACTIONS(2186),
    [anon_sym_DASH_DASH] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2188),
    [anon_sym_sizeof] = ACTIONS(2186),
    [anon_sym___alignof__] = ACTIONS(2186),
    [anon_sym___alignof] = ACTIONS(2186),
    [anon_sym__alignof] = ACTIONS(2186),
    [anon_sym_alignof] = ACTIONS(2186),
    [anon_sym__Alignof] = ACTIONS(2186),
    [anon_sym_offsetof] = ACTIONS(2186),
    [anon_sym__Generic] = ACTIONS(2186),
    [anon_sym_asm] = ACTIONS(2186),
    [anon_sym___asm__] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOT_STAR] = ACTIONS(2188),
    [anon_sym_DASH_GT] = ACTIONS(2188),
    [sym_number_literal] = ACTIONS(2188),
    [anon_sym_L_SQUOTE] = ACTIONS(2188),
    [anon_sym_u_SQUOTE] = ACTIONS(2188),
    [anon_sym_U_SQUOTE] = ACTIONS(2188),
    [anon_sym_u8_SQUOTE] = ACTIONS(2188),
    [anon_sym_SQUOTE] = ACTIONS(2188),
    [anon_sym_L_DQUOTE] = ACTIONS(2188),
    [anon_sym_u_DQUOTE] = ACTIONS(2188),
    [anon_sym_U_DQUOTE] = ACTIONS(2188),
    [anon_sym_u8_DQUOTE] = ACTIONS(2188),
    [anon_sym_DQUOTE] = ACTIONS(2188),
    [sym_true] = ACTIONS(2186),
    [sym_false] = ACTIONS(2186),
    [anon_sym_NULL] = ACTIONS(2186),
    [anon_sym_nullptr] = ACTIONS(2186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_This] = ACTIONS(2186),
    [anon_sym_decltype] = ACTIONS(2186),
    [sym_virtual] = ACTIONS(2186),
    [anon_sym_explicit] = ACTIONS(2186),
    [anon_sym_typename] = ACTIONS(2186),
    [anon_sym_template] = ACTIONS(2186),
    [anon_sym_operator] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_delete] = ACTIONS(2186),
    [anon_sym_throw] = ACTIONS(2186),
    [anon_sym_namespace] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_static_assert] = ACTIONS(2186),
    [anon_sym_concept] = ACTIONS(2186),
    [anon_sym_co_return] = ACTIONS(2186),
    [anon_sym_co_yield] = ACTIONS(2186),
    [anon_sym_R_DQUOTE] = ACTIONS(2188),
    [anon_sym_LR_DQUOTE] = ACTIONS(2188),
    [anon_sym_uR_DQUOTE] = ACTIONS(2188),
    [anon_sym_UR_DQUOTE] = ACTIONS(2188),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2188),
    [anon_sym_co_await] = ACTIONS(2186),
    [anon_sym_new] = ACTIONS(2186),
    [anon_sym_requires] = ACTIONS(2186),
    [sym_this] = ACTIONS(2186),
    [anon_sym_precise] = ACTIONS(2186),
    [anon_sym_shared] = ACTIONS(2186),
    [anon_sym_groupshared] = ACTIONS(2186),
    [anon_sym_uniform] = ACTIONS(2186),
    [anon_sym_row_major] = ACTIONS(2186),
    [anon_sym_column_major] = ACTIONS(2186),
    [anon_sym_globallycoherent] = ACTIONS(2186),
    [anon_sym_centroid] = ACTIONS(2186),
    [anon_sym_noperspective] = ACTIONS(2186),
    [anon_sym_nointerpolation] = ACTIONS(2186),
    [anon_sym_sample] = ACTIONS(2186),
    [anon_sym_linear] = ACTIONS(2186),
    [anon_sym_snorm] = ACTIONS(2186),
    [anon_sym_unorm] = ACTIONS(2186),
    [anon_sym_point] = ACTIONS(2186),
    [anon_sym_line] = ACTIONS(2186),
    [anon_sym_triangleadj] = ACTIONS(2186),
    [anon_sym_lineadj] = ACTIONS(2186),
    [anon_sym_triangle] = ACTIONS(2186),
    [anon_sym_interface] = ACTIONS(2186),
    [anon_sym_extension] = ACTIONS(2186),
    [anon_sym___exported] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
  },
  [123] = {
    [ts_builtin_sym_end] = ACTIONS(2208),
    [sym_identifier] = ACTIONS(2206),
    [aux_sym_preproc_include_token1] = ACTIONS(2206),
    [aux_sym_preproc_def_token1] = ACTIONS(2206),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2208),
    [aux_sym_preproc_if_token1] = ACTIONS(2206),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2206),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2206),
    [sym_preproc_directive] = ACTIONS(2206),
    [anon_sym_LPAREN2] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2208),
    [anon_sym_DASH] = ACTIONS(2206),
    [anon_sym_PLUS] = ACTIONS(2206),
    [anon_sym_STAR] = ACTIONS(2206),
    [anon_sym_SLASH] = ACTIONS(2206),
    [anon_sym_PERCENT] = ACTIONS(2206),
    [anon_sym_PIPE_PIPE] = ACTIONS(2208),
    [anon_sym_AMP_AMP] = ACTIONS(2208),
    [anon_sym_PIPE] = ACTIONS(2206),
    [anon_sym_CARET] = ACTIONS(2206),
    [anon_sym_AMP] = ACTIONS(2206),
    [anon_sym_EQ_EQ] = ACTIONS(2208),
    [anon_sym_BANG_EQ] = ACTIONS(2208),
    [anon_sym_GT] = ACTIONS(2206),
    [anon_sym_GT_EQ] = ACTIONS(2208),
    [anon_sym_LT_EQ] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2206),
    [anon_sym_LT_LT] = ACTIONS(2206),
    [anon_sym_GT_GT] = ACTIONS(2206),
    [anon_sym_SEMI] = ACTIONS(2208),
    [anon_sym___extension__] = ACTIONS(2206),
    [anon_sym_typedef] = ACTIONS(2206),
    [anon_sym_in] = ACTIONS(2206),
    [anon_sym_out] = ACTIONS(2206),
    [anon_sym_inout] = ACTIONS(2206),
    [anon_sym_extern] = ACTIONS(2206),
    [anon_sym___attribute__] = ACTIONS(2206),
    [anon_sym_COLON_COLON] = ACTIONS(2208),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2208),
    [anon_sym___declspec] = ACTIONS(2206),
    [anon_sym___based] = ACTIONS(2206),
    [anon_sym___cdecl] = ACTIONS(2206),
    [anon_sym___clrcall] = ACTIONS(2206),
    [anon_sym___stdcall] = ACTIONS(2206),
    [anon_sym___fastcall] = ACTIONS(2206),
    [anon_sym___thiscall] = ACTIONS(2206),
    [anon_sym___vectorcall] = ACTIONS(2206),
    [anon_sym_LBRACE] = ACTIONS(2208),
    [anon_sym_signed] = ACTIONS(2206),
    [anon_sym_unsigned] = ACTIONS(2206),
    [anon_sym_long] = ACTIONS(2206),
    [anon_sym_short] = ACTIONS(2206),
    [anon_sym_LBRACK] = ACTIONS(2206),
    [anon_sym_static] = ACTIONS(2206),
    [anon_sym_EQ] = ACTIONS(2206),
    [anon_sym_register] = ACTIONS(2206),
    [anon_sym_inline] = ACTIONS(2206),
    [anon_sym___inline] = ACTIONS(2206),
    [anon_sym___inline__] = ACTIONS(2206),
    [anon_sym___forceinline] = ACTIONS(2206),
    [anon_sym_thread_local] = ACTIONS(2206),
    [anon_sym___thread] = ACTIONS(2206),
    [anon_sym_const] = ACTIONS(2206),
    [anon_sym_constexpr] = ACTIONS(2206),
    [anon_sym_volatile] = ACTIONS(2206),
    [anon_sym_restrict] = ACTIONS(2206),
    [anon_sym___restrict__] = ACTIONS(2206),
    [anon_sym__Atomic] = ACTIONS(2206),
    [anon_sym__Noreturn] = ACTIONS(2206),
    [anon_sym_noreturn] = ACTIONS(2206),
    [anon_sym_mutable] = ACTIONS(2206),
    [anon_sym_constinit] = ACTIONS(2206),
    [anon_sym_consteval] = ACTIONS(2206),
    [anon_sym_alignas] = ACTIONS(2206),
    [anon_sym__Alignas] = ACTIONS(2206),
    [sym_primitive_type] = ACTIONS(2206),
    [anon_sym_enum] = ACTIONS(2206),
    [anon_sym_class] = ACTIONS(2206),
    [anon_sym_struct] = ACTIONS(2206),
    [anon_sym_union] = ACTIONS(2206),
    [anon_sym_if] = ACTIONS(2206),
    [anon_sym_switch] = ACTIONS(2206),
    [anon_sym_case] = ACTIONS(2206),
    [anon_sym_default] = ACTIONS(2206),
    [anon_sym_while] = ACTIONS(2206),
    [anon_sym_do] = ACTIONS(2206),
    [anon_sym_for] = ACTIONS(2206),
    [anon_sym_return] = ACTIONS(2206),
    [anon_sym_break] = ACTIONS(2206),
    [anon_sym_continue] = ACTIONS(2206),
    [anon_sym_goto] = ACTIONS(2206),
    [anon_sym_QMARK] = ACTIONS(2208),
    [anon_sym_STAR_EQ] = ACTIONS(2208),
    [anon_sym_SLASH_EQ] = ACTIONS(2208),
    [anon_sym_PERCENT_EQ] = ACTIONS(2208),
    [anon_sym_PLUS_EQ] = ACTIONS(2208),
    [anon_sym_DASH_EQ] = ACTIONS(2208),
    [anon_sym_LT_LT_EQ] = ACTIONS(2208),
    [anon_sym_GT_GT_EQ] = ACTIONS(2208),
    [anon_sym_AMP_EQ] = ACTIONS(2208),
    [anon_sym_CARET_EQ] = ACTIONS(2208),
    [anon_sym_PIPE_EQ] = ACTIONS(2208),
    [anon_sym_and_eq] = ACTIONS(2206),
    [anon_sym_or_eq] = ACTIONS(2206),
    [anon_sym_xor_eq] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_compl] = ACTIONS(2206),
    [anon_sym_LT_EQ_GT] = ACTIONS(2208),
    [anon_sym_or] = ACTIONS(2206),
    [anon_sym_and] = ACTIONS(2206),
    [anon_sym_bitor] = ACTIONS(2206),
    [anon_sym_xor] = ACTIONS(2206),
    [anon_sym_bitand] = ACTIONS(2206),
    [anon_sym_not_eq] = ACTIONS(2206),
    [anon_sym_is] = ACTIONS(2206),
    [anon_sym_as] = ACTIONS(2206),
    [anon_sym_DASH_DASH] = ACTIONS(2208),
    [anon_sym_PLUS_PLUS] = ACTIONS(2208),
    [anon_sym_sizeof] = ACTIONS(2206),
    [anon_sym___alignof__] = ACTIONS(2206),
    [anon_sym___alignof] = ACTIONS(2206),
    [anon_sym__alignof] = ACTIONS(2206),
    [anon_sym_alignof] = ACTIONS(2206),
    [anon_sym__Alignof] = ACTIONS(2206),
    [anon_sym_offsetof] = ACTIONS(2206),
    [anon_sym__Generic] = ACTIONS(2206),
    [anon_sym_asm] = ACTIONS(2206),
    [anon_sym___asm__] = ACTIONS(2206),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_DOT_STAR] = ACTIONS(2208),
    [anon_sym_DASH_GT] = ACTIONS(2208),
    [sym_number_literal] = ACTIONS(2208),
    [anon_sym_L_SQUOTE] = ACTIONS(2208),
    [anon_sym_u_SQUOTE] = ACTIONS(2208),
    [anon_sym_U_SQUOTE] = ACTIONS(2208),
    [anon_sym_u8_SQUOTE] = ACTIONS(2208),
    [anon_sym_SQUOTE] = ACTIONS(2208),
    [anon_sym_L_DQUOTE] = ACTIONS(2208),
    [anon_sym_u_DQUOTE] = ACTIONS(2208),
    [anon_sym_U_DQUOTE] = ACTIONS(2208),
    [anon_sym_u8_DQUOTE] = ACTIONS(2208),
    [anon_sym_DQUOTE] = ACTIONS(2208),
    [sym_true] = ACTIONS(2206),
    [sym_false] = ACTIONS(2206),
    [anon_sym_NULL] = ACTIONS(2206),
    [anon_sym_nullptr] = ACTIONS(2206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2206),
    [anon_sym_let] = ACTIONS(2206),
    [anon_sym_This] = ACTIONS(2206),
    [anon_sym_decltype] = ACTIONS(2206),
    [sym_virtual] = ACTIONS(2206),
    [anon_sym_explicit] = ACTIONS(2206),
    [anon_sym_typename] = ACTIONS(2206),
    [anon_sym_template] = ACTIONS(2206),
    [anon_sym_operator] = ACTIONS(2206),
    [anon_sym_try] = ACTIONS(2206),
    [anon_sym_delete] = ACTIONS(2206),
    [anon_sym_throw] = ACTIONS(2206),
    [anon_sym_namespace] = ACTIONS(2206),
    [anon_sym_using] = ACTIONS(2206),
    [anon_sym_static_assert] = ACTIONS(2206),
    [anon_sym_concept] = ACTIONS(2206),
    [anon_sym_co_return] = ACTIONS(2206),
    [anon_sym_co_yield] = ACTIONS(2206),
    [anon_sym_R_DQUOTE] = ACTIONS(2208),
    [anon_sym_LR_DQUOTE] = ACTIONS(2208),
    [anon_sym_uR_DQUOTE] = ACTIONS(2208),
    [anon_sym_UR_DQUOTE] = ACTIONS(2208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2208),
    [anon_sym_co_await] = ACTIONS(2206),
    [anon_sym_new] = ACTIONS(2206),
    [anon_sym_requires] = ACTIONS(2206),
    [sym_this] = ACTIONS(2206),
    [anon_sym_precise] = ACTIONS(2206),
    [anon_sym_shared] = ACTIONS(2206),
    [anon_sym_groupshared] = ACTIONS(2206),
    [anon_sym_uniform] = ACTIONS(2206),
    [anon_sym_row_major] = ACTIONS(2206),
    [anon_sym_column_major] = ACTIONS(2206),
    [anon_sym_globallycoherent] = ACTIONS(2206),
    [anon_sym_centroid] = ACTIONS(2206),
    [anon_sym_noperspective] = ACTIONS(2206),
    [anon_sym_nointerpolation] = ACTIONS(2206),
    [anon_sym_sample] = ACTIONS(2206),
    [anon_sym_linear] = ACTIONS(2206),
    [anon_sym_snorm] = ACTIONS(2206),
    [anon_sym_unorm] = ACTIONS(2206),
    [anon_sym_point] = ACTIONS(2206),
    [anon_sym_line] = ACTIONS(2206),
    [anon_sym_triangleadj] = ACTIONS(2206),
    [anon_sym_lineadj] = ACTIONS(2206),
    [anon_sym_triangle] = ACTIONS(2206),
    [anon_sym_interface] = ACTIONS(2206),
    [anon_sym_extension] = ACTIONS(2206),
    [anon_sym___exported] = ACTIONS(2206),
    [anon_sym_import] = ACTIONS(2206),
  },
  [124] = {
    [ts_builtin_sym_end] = ACTIONS(2254),
    [sym_identifier] = ACTIONS(2252),
    [aux_sym_preproc_include_token1] = ACTIONS(2252),
    [aux_sym_preproc_def_token1] = ACTIONS(2252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2254),
    [aux_sym_preproc_if_token1] = ACTIONS(2252),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2252),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2252),
    [sym_preproc_directive] = ACTIONS(2252),
    [anon_sym_LPAREN2] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2252),
    [anon_sym_TILDE] = ACTIONS(2254),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_SLASH] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2252),
    [anon_sym_PIPE_PIPE] = ACTIONS(2254),
    [anon_sym_AMP_AMP] = ACTIONS(2254),
    [anon_sym_PIPE] = ACTIONS(2252),
    [anon_sym_CARET] = ACTIONS(2252),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_EQ_EQ] = ACTIONS(2254),
    [anon_sym_BANG_EQ] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2252),
    [anon_sym_GT_EQ] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2252),
    [anon_sym_LT_LT] = ACTIONS(2252),
    [anon_sym_GT_GT] = ACTIONS(2252),
    [anon_sym_SEMI] = ACTIONS(2254),
    [anon_sym___extension__] = ACTIONS(2252),
    [anon_sym_typedef] = ACTIONS(2252),
    [anon_sym_in] = ACTIONS(2252),
    [anon_sym_out] = ACTIONS(2252),
    [anon_sym_inout] = ACTIONS(2252),
    [anon_sym_extern] = ACTIONS(2252),
    [anon_sym___attribute__] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2254),
    [anon_sym___declspec] = ACTIONS(2252),
    [anon_sym___based] = ACTIONS(2252),
    [anon_sym___cdecl] = ACTIONS(2252),
    [anon_sym___clrcall] = ACTIONS(2252),
    [anon_sym___stdcall] = ACTIONS(2252),
    [anon_sym___fastcall] = ACTIONS(2252),
    [anon_sym___thiscall] = ACTIONS(2252),
    [anon_sym___vectorcall] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_signed] = ACTIONS(2252),
    [anon_sym_unsigned] = ACTIONS(2252),
    [anon_sym_long] = ACTIONS(2252),
    [anon_sym_short] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2252),
    [anon_sym_EQ] = ACTIONS(2252),
    [anon_sym_register] = ACTIONS(2252),
    [anon_sym_inline] = ACTIONS(2252),
    [anon_sym___inline] = ACTIONS(2252),
    [anon_sym___inline__] = ACTIONS(2252),
    [anon_sym___forceinline] = ACTIONS(2252),
    [anon_sym_thread_local] = ACTIONS(2252),
    [anon_sym___thread] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2252),
    [anon_sym_constexpr] = ACTIONS(2252),
    [anon_sym_volatile] = ACTIONS(2252),
    [anon_sym_restrict] = ACTIONS(2252),
    [anon_sym___restrict__] = ACTIONS(2252),
    [anon_sym__Atomic] = ACTIONS(2252),
    [anon_sym__Noreturn] = ACTIONS(2252),
    [anon_sym_noreturn] = ACTIONS(2252),
    [anon_sym_mutable] = ACTIONS(2252),
    [anon_sym_constinit] = ACTIONS(2252),
    [anon_sym_consteval] = ACTIONS(2252),
    [anon_sym_alignas] = ACTIONS(2252),
    [anon_sym__Alignas] = ACTIONS(2252),
    [sym_primitive_type] = ACTIONS(2252),
    [anon_sym_enum] = ACTIONS(2252),
    [anon_sym_class] = ACTIONS(2252),
    [anon_sym_struct] = ACTIONS(2252),
    [anon_sym_union] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_switch] = ACTIONS(2252),
    [anon_sym_case] = ACTIONS(2252),
    [anon_sym_default] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_do] = ACTIONS(2252),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2252),
    [anon_sym_goto] = ACTIONS(2252),
    [anon_sym_QMARK] = ACTIONS(2254),
    [anon_sym_STAR_EQ] = ACTIONS(2254),
    [anon_sym_SLASH_EQ] = ACTIONS(2254),
    [anon_sym_PERCENT_EQ] = ACTIONS(2254),
    [anon_sym_PLUS_EQ] = ACTIONS(2254),
    [anon_sym_DASH_EQ] = ACTIONS(2254),
    [anon_sym_LT_LT_EQ] = ACTIONS(2254),
    [anon_sym_GT_GT_EQ] = ACTIONS(2254),
    [anon_sym_AMP_EQ] = ACTIONS(2254),
    [anon_sym_CARET_EQ] = ACTIONS(2254),
    [anon_sym_PIPE_EQ] = ACTIONS(2254),
    [anon_sym_and_eq] = ACTIONS(2252),
    [anon_sym_or_eq] = ACTIONS(2252),
    [anon_sym_xor_eq] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2252),
    [anon_sym_compl] = ACTIONS(2252),
    [anon_sym_LT_EQ_GT] = ACTIONS(2254),
    [anon_sym_or] = ACTIONS(2252),
    [anon_sym_and] = ACTIONS(2252),
    [anon_sym_bitor] = ACTIONS(2252),
    [anon_sym_xor] = ACTIONS(2252),
    [anon_sym_bitand] = ACTIONS(2252),
    [anon_sym_not_eq] = ACTIONS(2252),
    [anon_sym_is] = ACTIONS(2252),
    [anon_sym_as] = ACTIONS(2252),
    [anon_sym_DASH_DASH] = ACTIONS(2254),
    [anon_sym_PLUS_PLUS] = ACTIONS(2254),
    [anon_sym_sizeof] = ACTIONS(2252),
    [anon_sym___alignof__] = ACTIONS(2252),
    [anon_sym___alignof] = ACTIONS(2252),
    [anon_sym__alignof] = ACTIONS(2252),
    [anon_sym_alignof] = ACTIONS(2252),
    [anon_sym__Alignof] = ACTIONS(2252),
    [anon_sym_offsetof] = ACTIONS(2252),
    [anon_sym__Generic] = ACTIONS(2252),
    [anon_sym_asm] = ACTIONS(2252),
    [anon_sym___asm__] = ACTIONS(2252),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_DOT_STAR] = ACTIONS(2254),
    [anon_sym_DASH_GT] = ACTIONS(2254),
    [sym_number_literal] = ACTIONS(2254),
    [anon_sym_L_SQUOTE] = ACTIONS(2254),
    [anon_sym_u_SQUOTE] = ACTIONS(2254),
    [anon_sym_U_SQUOTE] = ACTIONS(2254),
    [anon_sym_u8_SQUOTE] = ACTIONS(2254),
    [anon_sym_SQUOTE] = ACTIONS(2254),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2252),
    [sym_false] = ACTIONS(2252),
    [anon_sym_NULL] = ACTIONS(2252),
    [anon_sym_nullptr] = ACTIONS(2252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_This] = ACTIONS(2252),
    [anon_sym_decltype] = ACTIONS(2252),
    [sym_virtual] = ACTIONS(2252),
    [anon_sym_explicit] = ACTIONS(2252),
    [anon_sym_typename] = ACTIONS(2252),
    [anon_sym_template] = ACTIONS(2252),
    [anon_sym_operator] = ACTIONS(2252),
    [anon_sym_try] = ACTIONS(2252),
    [anon_sym_delete] = ACTIONS(2252),
    [anon_sym_throw] = ACTIONS(2252),
    [anon_sym_namespace] = ACTIONS(2252),
    [anon_sym_using] = ACTIONS(2252),
    [anon_sym_static_assert] = ACTIONS(2252),
    [anon_sym_concept] = ACTIONS(2252),
    [anon_sym_co_return] = ACTIONS(2252),
    [anon_sym_co_yield] = ACTIONS(2252),
    [anon_sym_R_DQUOTE] = ACTIONS(2254),
    [anon_sym_LR_DQUOTE] = ACTIONS(2254),
    [anon_sym_uR_DQUOTE] = ACTIONS(2254),
    [anon_sym_UR_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2254),
    [anon_sym_co_await] = ACTIONS(2252),
    [anon_sym_new] = ACTIONS(2252),
    [anon_sym_requires] = ACTIONS(2252),
    [sym_this] = ACTIONS(2252),
    [anon_sym_precise] = ACTIONS(2252),
    [anon_sym_shared] = ACTIONS(2252),
    [anon_sym_groupshared] = ACTIONS(2252),
    [anon_sym_uniform] = ACTIONS(2252),
    [anon_sym_row_major] = ACTIONS(2252),
    [anon_sym_column_major] = ACTIONS(2252),
    [anon_sym_globallycoherent] = ACTIONS(2252),
    [anon_sym_centroid] = ACTIONS(2252),
    [anon_sym_noperspective] = ACTIONS(2252),
    [anon_sym_nointerpolation] = ACTIONS(2252),
    [anon_sym_sample] = ACTIONS(2252),
    [anon_sym_linear] = ACTIONS(2252),
    [anon_sym_snorm] = ACTIONS(2252),
    [anon_sym_unorm] = ACTIONS(2252),
    [anon_sym_point] = ACTIONS(2252),
    [anon_sym_line] = ACTIONS(2252),
    [anon_sym_triangleadj] = ACTIONS(2252),
    [anon_sym_lineadj] = ACTIONS(2252),
    [anon_sym_triangle] = ACTIONS(2252),
    [anon_sym_interface] = ACTIONS(2252),
    [anon_sym_extension] = ACTIONS(2252),
    [anon_sym___exported] = ACTIONS(2252),
    [anon_sym_import] = ACTIONS(2252),
  },
  [125] = {
    [ts_builtin_sym_end] = ACTIONS(2192),
    [sym_identifier] = ACTIONS(2190),
    [aux_sym_preproc_include_token1] = ACTIONS(2190),
    [aux_sym_preproc_def_token1] = ACTIONS(2190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2192),
    [aux_sym_preproc_if_token1] = ACTIONS(2190),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2190),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2190),
    [sym_preproc_directive] = ACTIONS(2190),
    [anon_sym_LPAREN2] = ACTIONS(2192),
    [anon_sym_BANG] = ACTIONS(2190),
    [anon_sym_TILDE] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2190),
    [anon_sym_PLUS] = ACTIONS(2190),
    [anon_sym_STAR] = ACTIONS(2190),
    [anon_sym_SLASH] = ACTIONS(2190),
    [anon_sym_PERCENT] = ACTIONS(2190),
    [anon_sym_PIPE_PIPE] = ACTIONS(2192),
    [anon_sym_AMP_AMP] = ACTIONS(2192),
    [anon_sym_PIPE] = ACTIONS(2190),
    [anon_sym_CARET] = ACTIONS(2190),
    [anon_sym_AMP] = ACTIONS(2190),
    [anon_sym_EQ_EQ] = ACTIONS(2192),
    [anon_sym_BANG_EQ] = ACTIONS(2192),
    [anon_sym_GT] = ACTIONS(2190),
    [anon_sym_GT_EQ] = ACTIONS(2192),
    [anon_sym_LT_EQ] = ACTIONS(2190),
    [anon_sym_LT] = ACTIONS(2190),
    [anon_sym_LT_LT] = ACTIONS(2190),
    [anon_sym_GT_GT] = ACTIONS(2190),
    [anon_sym_SEMI] = ACTIONS(2192),
    [anon_sym___extension__] = ACTIONS(2190),
    [anon_sym_typedef] = ACTIONS(2190),
    [anon_sym_in] = ACTIONS(2190),
    [anon_sym_out] = ACTIONS(2190),
    [anon_sym_inout] = ACTIONS(2190),
    [anon_sym_extern] = ACTIONS(2190),
    [anon_sym___attribute__] = ACTIONS(2190),
    [anon_sym_COLON_COLON] = ACTIONS(2192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2192),
    [anon_sym___declspec] = ACTIONS(2190),
    [anon_sym___based] = ACTIONS(2190),
    [anon_sym___cdecl] = ACTIONS(2190),
    [anon_sym___clrcall] = ACTIONS(2190),
    [anon_sym___stdcall] = ACTIONS(2190),
    [anon_sym___fastcall] = ACTIONS(2190),
    [anon_sym___thiscall] = ACTIONS(2190),
    [anon_sym___vectorcall] = ACTIONS(2190),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [anon_sym_signed] = ACTIONS(2190),
    [anon_sym_unsigned] = ACTIONS(2190),
    [anon_sym_long] = ACTIONS(2190),
    [anon_sym_short] = ACTIONS(2190),
    [anon_sym_LBRACK] = ACTIONS(2190),
    [anon_sym_static] = ACTIONS(2190),
    [anon_sym_EQ] = ACTIONS(2190),
    [anon_sym_register] = ACTIONS(2190),
    [anon_sym_inline] = ACTIONS(2190),
    [anon_sym___inline] = ACTIONS(2190),
    [anon_sym___inline__] = ACTIONS(2190),
    [anon_sym___forceinline] = ACTIONS(2190),
    [anon_sym_thread_local] = ACTIONS(2190),
    [anon_sym___thread] = ACTIONS(2190),
    [anon_sym_const] = ACTIONS(2190),
    [anon_sym_constexpr] = ACTIONS(2190),
    [anon_sym_volatile] = ACTIONS(2190),
    [anon_sym_restrict] = ACTIONS(2190),
    [anon_sym___restrict__] = ACTIONS(2190),
    [anon_sym__Atomic] = ACTIONS(2190),
    [anon_sym__Noreturn] = ACTIONS(2190),
    [anon_sym_noreturn] = ACTIONS(2190),
    [anon_sym_mutable] = ACTIONS(2190),
    [anon_sym_constinit] = ACTIONS(2190),
    [anon_sym_consteval] = ACTIONS(2190),
    [anon_sym_alignas] = ACTIONS(2190),
    [anon_sym__Alignas] = ACTIONS(2190),
    [sym_primitive_type] = ACTIONS(2190),
    [anon_sym_enum] = ACTIONS(2190),
    [anon_sym_class] = ACTIONS(2190),
    [anon_sym_struct] = ACTIONS(2190),
    [anon_sym_union] = ACTIONS(2190),
    [anon_sym_if] = ACTIONS(2190),
    [anon_sym_switch] = ACTIONS(2190),
    [anon_sym_case] = ACTIONS(2190),
    [anon_sym_default] = ACTIONS(2190),
    [anon_sym_while] = ACTIONS(2190),
    [anon_sym_do] = ACTIONS(2190),
    [anon_sym_for] = ACTIONS(2190),
    [anon_sym_return] = ACTIONS(2190),
    [anon_sym_break] = ACTIONS(2190),
    [anon_sym_continue] = ACTIONS(2190),
    [anon_sym_goto] = ACTIONS(2190),
    [anon_sym_QMARK] = ACTIONS(2192),
    [anon_sym_STAR_EQ] = ACTIONS(2192),
    [anon_sym_SLASH_EQ] = ACTIONS(2192),
    [anon_sym_PERCENT_EQ] = ACTIONS(2192),
    [anon_sym_PLUS_EQ] = ACTIONS(2192),
    [anon_sym_DASH_EQ] = ACTIONS(2192),
    [anon_sym_LT_LT_EQ] = ACTIONS(2192),
    [anon_sym_GT_GT_EQ] = ACTIONS(2192),
    [anon_sym_AMP_EQ] = ACTIONS(2192),
    [anon_sym_CARET_EQ] = ACTIONS(2192),
    [anon_sym_PIPE_EQ] = ACTIONS(2192),
    [anon_sym_and_eq] = ACTIONS(2190),
    [anon_sym_or_eq] = ACTIONS(2190),
    [anon_sym_xor_eq] = ACTIONS(2190),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_compl] = ACTIONS(2190),
    [anon_sym_LT_EQ_GT] = ACTIONS(2192),
    [anon_sym_or] = ACTIONS(2190),
    [anon_sym_and] = ACTIONS(2190),
    [anon_sym_bitor] = ACTIONS(2190),
    [anon_sym_xor] = ACTIONS(2190),
    [anon_sym_bitand] = ACTIONS(2190),
    [anon_sym_not_eq] = ACTIONS(2190),
    [anon_sym_is] = ACTIONS(2190),
    [anon_sym_as] = ACTIONS(2190),
    [anon_sym_DASH_DASH] = ACTIONS(2192),
    [anon_sym_PLUS_PLUS] = ACTIONS(2192),
    [anon_sym_sizeof] = ACTIONS(2190),
    [anon_sym___alignof__] = ACTIONS(2190),
    [anon_sym___alignof] = ACTIONS(2190),
    [anon_sym__alignof] = ACTIONS(2190),
    [anon_sym_alignof] = ACTIONS(2190),
    [anon_sym__Alignof] = ACTIONS(2190),
    [anon_sym_offsetof] = ACTIONS(2190),
    [anon_sym__Generic] = ACTIONS(2190),
    [anon_sym_asm] = ACTIONS(2190),
    [anon_sym___asm__] = ACTIONS(2190),
    [anon_sym_DOT] = ACTIONS(2190),
    [anon_sym_DOT_STAR] = ACTIONS(2192),
    [anon_sym_DASH_GT] = ACTIONS(2192),
    [sym_number_literal] = ACTIONS(2192),
    [anon_sym_L_SQUOTE] = ACTIONS(2192),
    [anon_sym_u_SQUOTE] = ACTIONS(2192),
    [anon_sym_U_SQUOTE] = ACTIONS(2192),
    [anon_sym_u8_SQUOTE] = ACTIONS(2192),
    [anon_sym_SQUOTE] = ACTIONS(2192),
    [anon_sym_L_DQUOTE] = ACTIONS(2192),
    [anon_sym_u_DQUOTE] = ACTIONS(2192),
    [anon_sym_U_DQUOTE] = ACTIONS(2192),
    [anon_sym_u8_DQUOTE] = ACTIONS(2192),
    [anon_sym_DQUOTE] = ACTIONS(2192),
    [sym_true] = ACTIONS(2190),
    [sym_false] = ACTIONS(2190),
    [anon_sym_NULL] = ACTIONS(2190),
    [anon_sym_nullptr] = ACTIONS(2190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2190),
    [anon_sym_let] = ACTIONS(2190),
    [anon_sym_This] = ACTIONS(2190),
    [anon_sym_decltype] = ACTIONS(2190),
    [sym_virtual] = ACTIONS(2190),
    [anon_sym_explicit] = ACTIONS(2190),
    [anon_sym_typename] = ACTIONS(2190),
    [anon_sym_template] = ACTIONS(2190),
    [anon_sym_operator] = ACTIONS(2190),
    [anon_sym_try] = ACTIONS(2190),
    [anon_sym_delete] = ACTIONS(2190),
    [anon_sym_throw] = ACTIONS(2190),
    [anon_sym_namespace] = ACTIONS(2190),
    [anon_sym_using] = ACTIONS(2190),
    [anon_sym_static_assert] = ACTIONS(2190),
    [anon_sym_concept] = ACTIONS(2190),
    [anon_sym_co_return] = ACTIONS(2190),
    [anon_sym_co_yield] = ACTIONS(2190),
    [anon_sym_R_DQUOTE] = ACTIONS(2192),
    [anon_sym_LR_DQUOTE] = ACTIONS(2192),
    [anon_sym_uR_DQUOTE] = ACTIONS(2192),
    [anon_sym_UR_DQUOTE] = ACTIONS(2192),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2192),
    [anon_sym_co_await] = ACTIONS(2190),
    [anon_sym_new] = ACTIONS(2190),
    [anon_sym_requires] = ACTIONS(2190),
    [sym_this] = ACTIONS(2190),
    [anon_sym_precise] = ACTIONS(2190),
    [anon_sym_shared] = ACTIONS(2190),
    [anon_sym_groupshared] = ACTIONS(2190),
    [anon_sym_uniform] = ACTIONS(2190),
    [anon_sym_row_major] = ACTIONS(2190),
    [anon_sym_column_major] = ACTIONS(2190),
    [anon_sym_globallycoherent] = ACTIONS(2190),
    [anon_sym_centroid] = ACTIONS(2190),
    [anon_sym_noperspective] = ACTIONS(2190),
    [anon_sym_nointerpolation] = ACTIONS(2190),
    [anon_sym_sample] = ACTIONS(2190),
    [anon_sym_linear] = ACTIONS(2190),
    [anon_sym_snorm] = ACTIONS(2190),
    [anon_sym_unorm] = ACTIONS(2190),
    [anon_sym_point] = ACTIONS(2190),
    [anon_sym_line] = ACTIONS(2190),
    [anon_sym_triangleadj] = ACTIONS(2190),
    [anon_sym_lineadj] = ACTIONS(2190),
    [anon_sym_triangle] = ACTIONS(2190),
    [anon_sym_interface] = ACTIONS(2190),
    [anon_sym_extension] = ACTIONS(2190),
    [anon_sym___exported] = ACTIONS(2190),
    [anon_sym_import] = ACTIONS(2190),
  },
  [126] = {
    [ts_builtin_sym_end] = ACTIONS(2200),
    [sym_identifier] = ACTIONS(2198),
    [aux_sym_preproc_include_token1] = ACTIONS(2198),
    [aux_sym_preproc_def_token1] = ACTIONS(2198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [aux_sym_preproc_if_token1] = ACTIONS(2198),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2198),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2198),
    [sym_preproc_directive] = ACTIONS(2198),
    [anon_sym_LPAREN2] = ACTIONS(2200),
    [anon_sym_BANG] = ACTIONS(2198),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(2198),
    [anon_sym_SLASH] = ACTIONS(2198),
    [anon_sym_PERCENT] = ACTIONS(2198),
    [anon_sym_PIPE_PIPE] = ACTIONS(2200),
    [anon_sym_AMP_AMP] = ACTIONS(2200),
    [anon_sym_PIPE] = ACTIONS(2198),
    [anon_sym_CARET] = ACTIONS(2198),
    [anon_sym_AMP] = ACTIONS(2198),
    [anon_sym_EQ_EQ] = ACTIONS(2200),
    [anon_sym_BANG_EQ] = ACTIONS(2200),
    [anon_sym_GT] = ACTIONS(2198),
    [anon_sym_GT_EQ] = ACTIONS(2200),
    [anon_sym_LT_EQ] = ACTIONS(2198),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_LT_LT] = ACTIONS(2198),
    [anon_sym_GT_GT] = ACTIONS(2198),
    [anon_sym_SEMI] = ACTIONS(2200),
    [anon_sym___extension__] = ACTIONS(2198),
    [anon_sym_typedef] = ACTIONS(2198),
    [anon_sym_in] = ACTIONS(2198),
    [anon_sym_out] = ACTIONS(2198),
    [anon_sym_inout] = ACTIONS(2198),
    [anon_sym_extern] = ACTIONS(2198),
    [anon_sym___attribute__] = ACTIONS(2198),
    [anon_sym_COLON_COLON] = ACTIONS(2200),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2200),
    [anon_sym___declspec] = ACTIONS(2198),
    [anon_sym___based] = ACTIONS(2198),
    [anon_sym___cdecl] = ACTIONS(2198),
    [anon_sym___clrcall] = ACTIONS(2198),
    [anon_sym___stdcall] = ACTIONS(2198),
    [anon_sym___fastcall] = ACTIONS(2198),
    [anon_sym___thiscall] = ACTIONS(2198),
    [anon_sym___vectorcall] = ACTIONS(2198),
    [anon_sym_LBRACE] = ACTIONS(2200),
    [anon_sym_signed] = ACTIONS(2198),
    [anon_sym_unsigned] = ACTIONS(2198),
    [anon_sym_long] = ACTIONS(2198),
    [anon_sym_short] = ACTIONS(2198),
    [anon_sym_LBRACK] = ACTIONS(2198),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_EQ] = ACTIONS(2198),
    [anon_sym_register] = ACTIONS(2198),
    [anon_sym_inline] = ACTIONS(2198),
    [anon_sym___inline] = ACTIONS(2198),
    [anon_sym___inline__] = ACTIONS(2198),
    [anon_sym___forceinline] = ACTIONS(2198),
    [anon_sym_thread_local] = ACTIONS(2198),
    [anon_sym___thread] = ACTIONS(2198),
    [anon_sym_const] = ACTIONS(2198),
    [anon_sym_constexpr] = ACTIONS(2198),
    [anon_sym_volatile] = ACTIONS(2198),
    [anon_sym_restrict] = ACTIONS(2198),
    [anon_sym___restrict__] = ACTIONS(2198),
    [anon_sym__Atomic] = ACTIONS(2198),
    [anon_sym__Noreturn] = ACTIONS(2198),
    [anon_sym_noreturn] = ACTIONS(2198),
    [anon_sym_mutable] = ACTIONS(2198),
    [anon_sym_constinit] = ACTIONS(2198),
    [anon_sym_consteval] = ACTIONS(2198),
    [anon_sym_alignas] = ACTIONS(2198),
    [anon_sym__Alignas] = ACTIONS(2198),
    [sym_primitive_type] = ACTIONS(2198),
    [anon_sym_enum] = ACTIONS(2198),
    [anon_sym_class] = ACTIONS(2198),
    [anon_sym_struct] = ACTIONS(2198),
    [anon_sym_union] = ACTIONS(2198),
    [anon_sym_if] = ACTIONS(2198),
    [anon_sym_switch] = ACTIONS(2198),
    [anon_sym_case] = ACTIONS(2198),
    [anon_sym_default] = ACTIONS(2198),
    [anon_sym_while] = ACTIONS(2198),
    [anon_sym_do] = ACTIONS(2198),
    [anon_sym_for] = ACTIONS(2198),
    [anon_sym_return] = ACTIONS(2198),
    [anon_sym_break] = ACTIONS(2198),
    [anon_sym_continue] = ACTIONS(2198),
    [anon_sym_goto] = ACTIONS(2198),
    [anon_sym_QMARK] = ACTIONS(2200),
    [anon_sym_STAR_EQ] = ACTIONS(2200),
    [anon_sym_SLASH_EQ] = ACTIONS(2200),
    [anon_sym_PERCENT_EQ] = ACTIONS(2200),
    [anon_sym_PLUS_EQ] = ACTIONS(2200),
    [anon_sym_DASH_EQ] = ACTIONS(2200),
    [anon_sym_LT_LT_EQ] = ACTIONS(2200),
    [anon_sym_GT_GT_EQ] = ACTIONS(2200),
    [anon_sym_AMP_EQ] = ACTIONS(2200),
    [anon_sym_CARET_EQ] = ACTIONS(2200),
    [anon_sym_PIPE_EQ] = ACTIONS(2200),
    [anon_sym_and_eq] = ACTIONS(2198),
    [anon_sym_or_eq] = ACTIONS(2198),
    [anon_sym_xor_eq] = ACTIONS(2198),
    [anon_sym_not] = ACTIONS(2198),
    [anon_sym_compl] = ACTIONS(2198),
    [anon_sym_LT_EQ_GT] = ACTIONS(2200),
    [anon_sym_or] = ACTIONS(2198),
    [anon_sym_and] = ACTIONS(2198),
    [anon_sym_bitor] = ACTIONS(2198),
    [anon_sym_xor] = ACTIONS(2198),
    [anon_sym_bitand] = ACTIONS(2198),
    [anon_sym_not_eq] = ACTIONS(2198),
    [anon_sym_is] = ACTIONS(2198),
    [anon_sym_as] = ACTIONS(2198),
    [anon_sym_DASH_DASH] = ACTIONS(2200),
    [anon_sym_PLUS_PLUS] = ACTIONS(2200),
    [anon_sym_sizeof] = ACTIONS(2198),
    [anon_sym___alignof__] = ACTIONS(2198),
    [anon_sym___alignof] = ACTIONS(2198),
    [anon_sym__alignof] = ACTIONS(2198),
    [anon_sym_alignof] = ACTIONS(2198),
    [anon_sym__Alignof] = ACTIONS(2198),
    [anon_sym_offsetof] = ACTIONS(2198),
    [anon_sym__Generic] = ACTIONS(2198),
    [anon_sym_asm] = ACTIONS(2198),
    [anon_sym___asm__] = ACTIONS(2198),
    [anon_sym_DOT] = ACTIONS(2198),
    [anon_sym_DOT_STAR] = ACTIONS(2200),
    [anon_sym_DASH_GT] = ACTIONS(2200),
    [sym_number_literal] = ACTIONS(2200),
    [anon_sym_L_SQUOTE] = ACTIONS(2200),
    [anon_sym_u_SQUOTE] = ACTIONS(2200),
    [anon_sym_U_SQUOTE] = ACTIONS(2200),
    [anon_sym_u8_SQUOTE] = ACTIONS(2200),
    [anon_sym_SQUOTE] = ACTIONS(2200),
    [anon_sym_L_DQUOTE] = ACTIONS(2200),
    [anon_sym_u_DQUOTE] = ACTIONS(2200),
    [anon_sym_U_DQUOTE] = ACTIONS(2200),
    [anon_sym_u8_DQUOTE] = ACTIONS(2200),
    [anon_sym_DQUOTE] = ACTIONS(2200),
    [sym_true] = ACTIONS(2198),
    [sym_false] = ACTIONS(2198),
    [anon_sym_NULL] = ACTIONS(2198),
    [anon_sym_nullptr] = ACTIONS(2198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2198),
    [anon_sym_let] = ACTIONS(2198),
    [anon_sym_This] = ACTIONS(2198),
    [anon_sym_decltype] = ACTIONS(2198),
    [sym_virtual] = ACTIONS(2198),
    [anon_sym_explicit] = ACTIONS(2198),
    [anon_sym_typename] = ACTIONS(2198),
    [anon_sym_template] = ACTIONS(2198),
    [anon_sym_operator] = ACTIONS(2198),
    [anon_sym_try] = ACTIONS(2198),
    [anon_sym_delete] = ACTIONS(2198),
    [anon_sym_throw] = ACTIONS(2198),
    [anon_sym_namespace] = ACTIONS(2198),
    [anon_sym_using] = ACTIONS(2198),
    [anon_sym_static_assert] = ACTIONS(2198),
    [anon_sym_concept] = ACTIONS(2198),
    [anon_sym_co_return] = ACTIONS(2198),
    [anon_sym_co_yield] = ACTIONS(2198),
    [anon_sym_R_DQUOTE] = ACTIONS(2200),
    [anon_sym_LR_DQUOTE] = ACTIONS(2200),
    [anon_sym_uR_DQUOTE] = ACTIONS(2200),
    [anon_sym_UR_DQUOTE] = ACTIONS(2200),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2200),
    [anon_sym_co_await] = ACTIONS(2198),
    [anon_sym_new] = ACTIONS(2198),
    [anon_sym_requires] = ACTIONS(2198),
    [sym_this] = ACTIONS(2198),
    [anon_sym_precise] = ACTIONS(2198),
    [anon_sym_shared] = ACTIONS(2198),
    [anon_sym_groupshared] = ACTIONS(2198),
    [anon_sym_uniform] = ACTIONS(2198),
    [anon_sym_row_major] = ACTIONS(2198),
    [anon_sym_column_major] = ACTIONS(2198),
    [anon_sym_globallycoherent] = ACTIONS(2198),
    [anon_sym_centroid] = ACTIONS(2198),
    [anon_sym_noperspective] = ACTIONS(2198),
    [anon_sym_nointerpolation] = ACTIONS(2198),
    [anon_sym_sample] = ACTIONS(2198),
    [anon_sym_linear] = ACTIONS(2198),
    [anon_sym_snorm] = ACTIONS(2198),
    [anon_sym_unorm] = ACTIONS(2198),
    [anon_sym_point] = ACTIONS(2198),
    [anon_sym_line] = ACTIONS(2198),
    [anon_sym_triangleadj] = ACTIONS(2198),
    [anon_sym_lineadj] = ACTIONS(2198),
    [anon_sym_triangle] = ACTIONS(2198),
    [anon_sym_interface] = ACTIONS(2198),
    [anon_sym_extension] = ACTIONS(2198),
    [anon_sym___exported] = ACTIONS(2198),
    [anon_sym_import] = ACTIONS(2198),
  },
  [127] = {
    [ts_builtin_sym_end] = ACTIONS(2258),
    [sym_identifier] = ACTIONS(2256),
    [aux_sym_preproc_include_token1] = ACTIONS(2256),
    [aux_sym_preproc_def_token1] = ACTIONS(2256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2258),
    [aux_sym_preproc_if_token1] = ACTIONS(2256),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2256),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2256),
    [sym_preproc_directive] = ACTIONS(2256),
    [anon_sym_LPAREN2] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(2256),
    [anon_sym_TILDE] = ACTIONS(2258),
    [anon_sym_DASH] = ACTIONS(2256),
    [anon_sym_PLUS] = ACTIONS(2256),
    [anon_sym_STAR] = ACTIONS(2256),
    [anon_sym_SLASH] = ACTIONS(2256),
    [anon_sym_PERCENT] = ACTIONS(2256),
    [anon_sym_PIPE_PIPE] = ACTIONS(2258),
    [anon_sym_AMP_AMP] = ACTIONS(2258),
    [anon_sym_PIPE] = ACTIONS(2256),
    [anon_sym_CARET] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(2256),
    [anon_sym_EQ_EQ] = ACTIONS(2258),
    [anon_sym_BANG_EQ] = ACTIONS(2258),
    [anon_sym_GT] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2258),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_LT] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2256),
    [anon_sym_GT_GT] = ACTIONS(2256),
    [anon_sym_SEMI] = ACTIONS(2258),
    [anon_sym___extension__] = ACTIONS(2256),
    [anon_sym_typedef] = ACTIONS(2256),
    [anon_sym_in] = ACTIONS(2256),
    [anon_sym_out] = ACTIONS(2256),
    [anon_sym_inout] = ACTIONS(2256),
    [anon_sym_extern] = ACTIONS(2256),
    [anon_sym___attribute__] = ACTIONS(2256),
    [anon_sym_COLON_COLON] = ACTIONS(2258),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2258),
    [anon_sym___declspec] = ACTIONS(2256),
    [anon_sym___based] = ACTIONS(2256),
    [anon_sym___cdecl] = ACTIONS(2256),
    [anon_sym___clrcall] = ACTIONS(2256),
    [anon_sym___stdcall] = ACTIONS(2256),
    [anon_sym___fastcall] = ACTIONS(2256),
    [anon_sym___thiscall] = ACTIONS(2256),
    [anon_sym___vectorcall] = ACTIONS(2256),
    [anon_sym_LBRACE] = ACTIONS(2258),
    [anon_sym_signed] = ACTIONS(2256),
    [anon_sym_unsigned] = ACTIONS(2256),
    [anon_sym_long] = ACTIONS(2256),
    [anon_sym_short] = ACTIONS(2256),
    [anon_sym_LBRACK] = ACTIONS(2256),
    [anon_sym_static] = ACTIONS(2256),
    [anon_sym_EQ] = ACTIONS(2256),
    [anon_sym_register] = ACTIONS(2256),
    [anon_sym_inline] = ACTIONS(2256),
    [anon_sym___inline] = ACTIONS(2256),
    [anon_sym___inline__] = ACTIONS(2256),
    [anon_sym___forceinline] = ACTIONS(2256),
    [anon_sym_thread_local] = ACTIONS(2256),
    [anon_sym___thread] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_constexpr] = ACTIONS(2256),
    [anon_sym_volatile] = ACTIONS(2256),
    [anon_sym_restrict] = ACTIONS(2256),
    [anon_sym___restrict__] = ACTIONS(2256),
    [anon_sym__Atomic] = ACTIONS(2256),
    [anon_sym__Noreturn] = ACTIONS(2256),
    [anon_sym_noreturn] = ACTIONS(2256),
    [anon_sym_mutable] = ACTIONS(2256),
    [anon_sym_constinit] = ACTIONS(2256),
    [anon_sym_consteval] = ACTIONS(2256),
    [anon_sym_alignas] = ACTIONS(2256),
    [anon_sym__Alignas] = ACTIONS(2256),
    [sym_primitive_type] = ACTIONS(2256),
    [anon_sym_enum] = ACTIONS(2256),
    [anon_sym_class] = ACTIONS(2256),
    [anon_sym_struct] = ACTIONS(2256),
    [anon_sym_union] = ACTIONS(2256),
    [anon_sym_if] = ACTIONS(2256),
    [anon_sym_switch] = ACTIONS(2256),
    [anon_sym_case] = ACTIONS(2256),
    [anon_sym_default] = ACTIONS(2256),
    [anon_sym_while] = ACTIONS(2256),
    [anon_sym_do] = ACTIONS(2256),
    [anon_sym_for] = ACTIONS(2256),
    [anon_sym_return] = ACTIONS(2256),
    [anon_sym_break] = ACTIONS(2256),
    [anon_sym_continue] = ACTIONS(2256),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_QMARK] = ACTIONS(2258),
    [anon_sym_STAR_EQ] = ACTIONS(2258),
    [anon_sym_SLASH_EQ] = ACTIONS(2258),
    [anon_sym_PERCENT_EQ] = ACTIONS(2258),
    [anon_sym_PLUS_EQ] = ACTIONS(2258),
    [anon_sym_DASH_EQ] = ACTIONS(2258),
    [anon_sym_LT_LT_EQ] = ACTIONS(2258),
    [anon_sym_GT_GT_EQ] = ACTIONS(2258),
    [anon_sym_AMP_EQ] = ACTIONS(2258),
    [anon_sym_CARET_EQ] = ACTIONS(2258),
    [anon_sym_PIPE_EQ] = ACTIONS(2258),
    [anon_sym_and_eq] = ACTIONS(2256),
    [anon_sym_or_eq] = ACTIONS(2256),
    [anon_sym_xor_eq] = ACTIONS(2256),
    [anon_sym_not] = ACTIONS(2256),
    [anon_sym_compl] = ACTIONS(2256),
    [anon_sym_LT_EQ_GT] = ACTIONS(2258),
    [anon_sym_or] = ACTIONS(2256),
    [anon_sym_and] = ACTIONS(2256),
    [anon_sym_bitor] = ACTIONS(2256),
    [anon_sym_xor] = ACTIONS(2256),
    [anon_sym_bitand] = ACTIONS(2256),
    [anon_sym_not_eq] = ACTIONS(2256),
    [anon_sym_is] = ACTIONS(2256),
    [anon_sym_as] = ACTIONS(2256),
    [anon_sym_DASH_DASH] = ACTIONS(2258),
    [anon_sym_PLUS_PLUS] = ACTIONS(2258),
    [anon_sym_sizeof] = ACTIONS(2256),
    [anon_sym___alignof__] = ACTIONS(2256),
    [anon_sym___alignof] = ACTIONS(2256),
    [anon_sym__alignof] = ACTIONS(2256),
    [anon_sym_alignof] = ACTIONS(2256),
    [anon_sym__Alignof] = ACTIONS(2256),
    [anon_sym_offsetof] = ACTIONS(2256),
    [anon_sym__Generic] = ACTIONS(2256),
    [anon_sym_asm] = ACTIONS(2256),
    [anon_sym___asm__] = ACTIONS(2256),
    [anon_sym_DOT] = ACTIONS(2256),
    [anon_sym_DOT_STAR] = ACTIONS(2258),
    [anon_sym_DASH_GT] = ACTIONS(2258),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_L_SQUOTE] = ACTIONS(2258),
    [anon_sym_u_SQUOTE] = ACTIONS(2258),
    [anon_sym_U_SQUOTE] = ACTIONS(2258),
    [anon_sym_u8_SQUOTE] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(2258),
    [anon_sym_L_DQUOTE] = ACTIONS(2258),
    [anon_sym_u_DQUOTE] = ACTIONS(2258),
    [anon_sym_U_DQUOTE] = ACTIONS(2258),
    [anon_sym_u8_DQUOTE] = ACTIONS(2258),
    [anon_sym_DQUOTE] = ACTIONS(2258),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2256),
    [anon_sym_nullptr] = ACTIONS(2256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_This] = ACTIONS(2256),
    [anon_sym_decltype] = ACTIONS(2256),
    [sym_virtual] = ACTIONS(2256),
    [anon_sym_explicit] = ACTIONS(2256),
    [anon_sym_typename] = ACTIONS(2256),
    [anon_sym_template] = ACTIONS(2256),
    [anon_sym_operator] = ACTIONS(2256),
    [anon_sym_try] = ACTIONS(2256),
    [anon_sym_delete] = ACTIONS(2256),
    [anon_sym_throw] = ACTIONS(2256),
    [anon_sym_namespace] = ACTIONS(2256),
    [anon_sym_using] = ACTIONS(2256),
    [anon_sym_static_assert] = ACTIONS(2256),
    [anon_sym_concept] = ACTIONS(2256),
    [anon_sym_co_return] = ACTIONS(2256),
    [anon_sym_co_yield] = ACTIONS(2256),
    [anon_sym_R_DQUOTE] = ACTIONS(2258),
    [anon_sym_LR_DQUOTE] = ACTIONS(2258),
    [anon_sym_uR_DQUOTE] = ACTIONS(2258),
    [anon_sym_UR_DQUOTE] = ACTIONS(2258),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2258),
    [anon_sym_co_await] = ACTIONS(2256),
    [anon_sym_new] = ACTIONS(2256),
    [anon_sym_requires] = ACTIONS(2256),
    [sym_this] = ACTIONS(2256),
    [anon_sym_precise] = ACTIONS(2256),
    [anon_sym_shared] = ACTIONS(2256),
    [anon_sym_groupshared] = ACTIONS(2256),
    [anon_sym_uniform] = ACTIONS(2256),
    [anon_sym_row_major] = ACTIONS(2256),
    [anon_sym_column_major] = ACTIONS(2256),
    [anon_sym_globallycoherent] = ACTIONS(2256),
    [anon_sym_centroid] = ACTIONS(2256),
    [anon_sym_noperspective] = ACTIONS(2256),
    [anon_sym_nointerpolation] = ACTIONS(2256),
    [anon_sym_sample] = ACTIONS(2256),
    [anon_sym_linear] = ACTIONS(2256),
    [anon_sym_snorm] = ACTIONS(2256),
    [anon_sym_unorm] = ACTIONS(2256),
    [anon_sym_point] = ACTIONS(2256),
    [anon_sym_line] = ACTIONS(2256),
    [anon_sym_triangleadj] = ACTIONS(2256),
    [anon_sym_lineadj] = ACTIONS(2256),
    [anon_sym_triangle] = ACTIONS(2256),
    [anon_sym_interface] = ACTIONS(2256),
    [anon_sym_extension] = ACTIONS(2256),
    [anon_sym___exported] = ACTIONS(2256),
    [anon_sym_import] = ACTIONS(2256),
  },
  [128] = {
    [ts_builtin_sym_end] = ACTIONS(2246),
    [sym_identifier] = ACTIONS(2244),
    [aux_sym_preproc_include_token1] = ACTIONS(2244),
    [aux_sym_preproc_def_token1] = ACTIONS(2244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [aux_sym_preproc_if_token1] = ACTIONS(2244),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2244),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2244),
    [sym_preproc_directive] = ACTIONS(2244),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_BANG] = ACTIONS(2244),
    [anon_sym_TILDE] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2244),
    [anon_sym_PLUS] = ACTIONS(2244),
    [anon_sym_STAR] = ACTIONS(2244),
    [anon_sym_SLASH] = ACTIONS(2244),
    [anon_sym_PERCENT] = ACTIONS(2244),
    [anon_sym_PIPE_PIPE] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2244),
    [anon_sym_CARET] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2244),
    [anon_sym_EQ_EQ] = ACTIONS(2246),
    [anon_sym_BANG_EQ] = ACTIONS(2246),
    [anon_sym_GT] = ACTIONS(2244),
    [anon_sym_GT_EQ] = ACTIONS(2246),
    [anon_sym_LT_EQ] = ACTIONS(2244),
    [anon_sym_LT] = ACTIONS(2244),
    [anon_sym_LT_LT] = ACTIONS(2244),
    [anon_sym_GT_GT] = ACTIONS(2244),
    [anon_sym_SEMI] = ACTIONS(2246),
    [anon_sym___extension__] = ACTIONS(2244),
    [anon_sym_typedef] = ACTIONS(2244),
    [anon_sym_in] = ACTIONS(2244),
    [anon_sym_out] = ACTIONS(2244),
    [anon_sym_inout] = ACTIONS(2244),
    [anon_sym_extern] = ACTIONS(2244),
    [anon_sym___attribute__] = ACTIONS(2244),
    [anon_sym_COLON_COLON] = ACTIONS(2246),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2246),
    [anon_sym___declspec] = ACTIONS(2244),
    [anon_sym___based] = ACTIONS(2244),
    [anon_sym___cdecl] = ACTIONS(2244),
    [anon_sym___clrcall] = ACTIONS(2244),
    [anon_sym___stdcall] = ACTIONS(2244),
    [anon_sym___fastcall] = ACTIONS(2244),
    [anon_sym___thiscall] = ACTIONS(2244),
    [anon_sym___vectorcall] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_signed] = ACTIONS(2244),
    [anon_sym_unsigned] = ACTIONS(2244),
    [anon_sym_long] = ACTIONS(2244),
    [anon_sym_short] = ACTIONS(2244),
    [anon_sym_LBRACK] = ACTIONS(2244),
    [anon_sym_static] = ACTIONS(2244),
    [anon_sym_EQ] = ACTIONS(2244),
    [anon_sym_register] = ACTIONS(2244),
    [anon_sym_inline] = ACTIONS(2244),
    [anon_sym___inline] = ACTIONS(2244),
    [anon_sym___inline__] = ACTIONS(2244),
    [anon_sym___forceinline] = ACTIONS(2244),
    [anon_sym_thread_local] = ACTIONS(2244),
    [anon_sym___thread] = ACTIONS(2244),
    [anon_sym_const] = ACTIONS(2244),
    [anon_sym_constexpr] = ACTIONS(2244),
    [anon_sym_volatile] = ACTIONS(2244),
    [anon_sym_restrict] = ACTIONS(2244),
    [anon_sym___restrict__] = ACTIONS(2244),
    [anon_sym__Atomic] = ACTIONS(2244),
    [anon_sym__Noreturn] = ACTIONS(2244),
    [anon_sym_noreturn] = ACTIONS(2244),
    [anon_sym_mutable] = ACTIONS(2244),
    [anon_sym_constinit] = ACTIONS(2244),
    [anon_sym_consteval] = ACTIONS(2244),
    [anon_sym_alignas] = ACTIONS(2244),
    [anon_sym__Alignas] = ACTIONS(2244),
    [sym_primitive_type] = ACTIONS(2244),
    [anon_sym_enum] = ACTIONS(2244),
    [anon_sym_class] = ACTIONS(2244),
    [anon_sym_struct] = ACTIONS(2244),
    [anon_sym_union] = ACTIONS(2244),
    [anon_sym_if] = ACTIONS(2244),
    [anon_sym_switch] = ACTIONS(2244),
    [anon_sym_case] = ACTIONS(2244),
    [anon_sym_default] = ACTIONS(2244),
    [anon_sym_while] = ACTIONS(2244),
    [anon_sym_do] = ACTIONS(2244),
    [anon_sym_for] = ACTIONS(2244),
    [anon_sym_return] = ACTIONS(2244),
    [anon_sym_break] = ACTIONS(2244),
    [anon_sym_continue] = ACTIONS(2244),
    [anon_sym_goto] = ACTIONS(2244),
    [anon_sym_QMARK] = ACTIONS(2246),
    [anon_sym_STAR_EQ] = ACTIONS(2246),
    [anon_sym_SLASH_EQ] = ACTIONS(2246),
    [anon_sym_PERCENT_EQ] = ACTIONS(2246),
    [anon_sym_PLUS_EQ] = ACTIONS(2246),
    [anon_sym_DASH_EQ] = ACTIONS(2246),
    [anon_sym_LT_LT_EQ] = ACTIONS(2246),
    [anon_sym_GT_GT_EQ] = ACTIONS(2246),
    [anon_sym_AMP_EQ] = ACTIONS(2246),
    [anon_sym_CARET_EQ] = ACTIONS(2246),
    [anon_sym_PIPE_EQ] = ACTIONS(2246),
    [anon_sym_and_eq] = ACTIONS(2244),
    [anon_sym_or_eq] = ACTIONS(2244),
    [anon_sym_xor_eq] = ACTIONS(2244),
    [anon_sym_not] = ACTIONS(2244),
    [anon_sym_compl] = ACTIONS(2244),
    [anon_sym_LT_EQ_GT] = ACTIONS(2246),
    [anon_sym_or] = ACTIONS(2244),
    [anon_sym_and] = ACTIONS(2244),
    [anon_sym_bitor] = ACTIONS(2244),
    [anon_sym_xor] = ACTIONS(2244),
    [anon_sym_bitand] = ACTIONS(2244),
    [anon_sym_not_eq] = ACTIONS(2244),
    [anon_sym_is] = ACTIONS(2244),
    [anon_sym_as] = ACTIONS(2244),
    [anon_sym_DASH_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_PLUS] = ACTIONS(2246),
    [anon_sym_sizeof] = ACTIONS(2244),
    [anon_sym___alignof__] = ACTIONS(2244),
    [anon_sym___alignof] = ACTIONS(2244),
    [anon_sym__alignof] = ACTIONS(2244),
    [anon_sym_alignof] = ACTIONS(2244),
    [anon_sym__Alignof] = ACTIONS(2244),
    [anon_sym_offsetof] = ACTIONS(2244),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2244),
    [anon_sym___asm__] = ACTIONS(2244),
    [anon_sym_DOT] = ACTIONS(2244),
    [anon_sym_DOT_STAR] = ACTIONS(2246),
    [anon_sym_DASH_GT] = ACTIONS(2246),
    [sym_number_literal] = ACTIONS(2246),
    [anon_sym_L_SQUOTE] = ACTIONS(2246),
    [anon_sym_u_SQUOTE] = ACTIONS(2246),
    [anon_sym_U_SQUOTE] = ACTIONS(2246),
    [anon_sym_u8_SQUOTE] = ACTIONS(2246),
    [anon_sym_SQUOTE] = ACTIONS(2246),
    [anon_sym_L_DQUOTE] = ACTIONS(2246),
    [anon_sym_u_DQUOTE] = ACTIONS(2246),
    [anon_sym_U_DQUOTE] = ACTIONS(2246),
    [anon_sym_u8_DQUOTE] = ACTIONS(2246),
    [anon_sym_DQUOTE] = ACTIONS(2246),
    [sym_true] = ACTIONS(2244),
    [sym_false] = ACTIONS(2244),
    [anon_sym_NULL] = ACTIONS(2244),
    [anon_sym_nullptr] = ACTIONS(2244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2244),
    [anon_sym_let] = ACTIONS(2244),
    [anon_sym_This] = ACTIONS(2244),
    [anon_sym_decltype] = ACTIONS(2244),
    [sym_virtual] = ACTIONS(2244),
    [anon_sym_explicit] = ACTIONS(2244),
    [anon_sym_typename] = ACTIONS(2244),
    [anon_sym_template] = ACTIONS(2244),
    [anon_sym_operator] = ACTIONS(2244),
    [anon_sym_try] = ACTIONS(2244),
    [anon_sym_delete] = ACTIONS(2244),
    [anon_sym_throw] = ACTIONS(2244),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_using] = ACTIONS(2244),
    [anon_sym_static_assert] = ACTIONS(2244),
    [anon_sym_concept] = ACTIONS(2244),
    [anon_sym_co_return] = ACTIONS(2244),
    [anon_sym_co_yield] = ACTIONS(2244),
    [anon_sym_R_DQUOTE] = ACTIONS(2246),
    [anon_sym_LR_DQUOTE] = ACTIONS(2246),
    [anon_sym_uR_DQUOTE] = ACTIONS(2246),
    [anon_sym_UR_DQUOTE] = ACTIONS(2246),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2246),
    [anon_sym_co_await] = ACTIONS(2244),
    [anon_sym_new] = ACTIONS(2244),
    [anon_sym_requires] = ACTIONS(2244),
    [sym_this] = ACTIONS(2244),
    [anon_sym_precise] = ACTIONS(2244),
    [anon_sym_shared] = ACTIONS(2244),
    [anon_sym_groupshared] = ACTIONS(2244),
    [anon_sym_uniform] = ACTIONS(2244),
    [anon_sym_row_major] = ACTIONS(2244),
    [anon_sym_column_major] = ACTIONS(2244),
    [anon_sym_globallycoherent] = ACTIONS(2244),
    [anon_sym_centroid] = ACTIONS(2244),
    [anon_sym_noperspective] = ACTIONS(2244),
    [anon_sym_nointerpolation] = ACTIONS(2244),
    [anon_sym_sample] = ACTIONS(2244),
    [anon_sym_linear] = ACTIONS(2244),
    [anon_sym_snorm] = ACTIONS(2244),
    [anon_sym_unorm] = ACTIONS(2244),
    [anon_sym_point] = ACTIONS(2244),
    [anon_sym_line] = ACTIONS(2244),
    [anon_sym_triangleadj] = ACTIONS(2244),
    [anon_sym_lineadj] = ACTIONS(2244),
    [anon_sym_triangle] = ACTIONS(2244),
    [anon_sym_interface] = ACTIONS(2244),
    [anon_sym_extension] = ACTIONS(2244),
    [anon_sym___exported] = ACTIONS(2244),
    [anon_sym_import] = ACTIONS(2244),
  },
  [129] = {
    [ts_builtin_sym_end] = ACTIONS(2196),
    [sym_identifier] = ACTIONS(2194),
    [aux_sym_preproc_include_token1] = ACTIONS(2194),
    [aux_sym_preproc_def_token1] = ACTIONS(2194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2196),
    [aux_sym_preproc_if_token1] = ACTIONS(2194),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2194),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2194),
    [sym_preproc_directive] = ACTIONS(2194),
    [anon_sym_LPAREN2] = ACTIONS(2196),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2194),
    [anon_sym_PLUS] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(2194),
    [anon_sym_SLASH] = ACTIONS(2194),
    [anon_sym_PERCENT] = ACTIONS(2194),
    [anon_sym_PIPE_PIPE] = ACTIONS(2196),
    [anon_sym_AMP_AMP] = ACTIONS(2196),
    [anon_sym_PIPE] = ACTIONS(2194),
    [anon_sym_CARET] = ACTIONS(2194),
    [anon_sym_AMP] = ACTIONS(2194),
    [anon_sym_EQ_EQ] = ACTIONS(2196),
    [anon_sym_BANG_EQ] = ACTIONS(2196),
    [anon_sym_GT] = ACTIONS(2194),
    [anon_sym_GT_EQ] = ACTIONS(2196),
    [anon_sym_LT_EQ] = ACTIONS(2194),
    [anon_sym_LT] = ACTIONS(2194),
    [anon_sym_LT_LT] = ACTIONS(2194),
    [anon_sym_GT_GT] = ACTIONS(2194),
    [anon_sym_SEMI] = ACTIONS(2196),
    [anon_sym___extension__] = ACTIONS(2194),
    [anon_sym_typedef] = ACTIONS(2194),
    [anon_sym_in] = ACTIONS(2194),
    [anon_sym_out] = ACTIONS(2194),
    [anon_sym_inout] = ACTIONS(2194),
    [anon_sym_extern] = ACTIONS(2194),
    [anon_sym___attribute__] = ACTIONS(2194),
    [anon_sym_COLON_COLON] = ACTIONS(2196),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2196),
    [anon_sym___declspec] = ACTIONS(2194),
    [anon_sym___based] = ACTIONS(2194),
    [anon_sym___cdecl] = ACTIONS(2194),
    [anon_sym___clrcall] = ACTIONS(2194),
    [anon_sym___stdcall] = ACTIONS(2194),
    [anon_sym___fastcall] = ACTIONS(2194),
    [anon_sym___thiscall] = ACTIONS(2194),
    [anon_sym___vectorcall] = ACTIONS(2194),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_signed] = ACTIONS(2194),
    [anon_sym_unsigned] = ACTIONS(2194),
    [anon_sym_long] = ACTIONS(2194),
    [anon_sym_short] = ACTIONS(2194),
    [anon_sym_LBRACK] = ACTIONS(2194),
    [anon_sym_static] = ACTIONS(2194),
    [anon_sym_EQ] = ACTIONS(2194),
    [anon_sym_register] = ACTIONS(2194),
    [anon_sym_inline] = ACTIONS(2194),
    [anon_sym___inline] = ACTIONS(2194),
    [anon_sym___inline__] = ACTIONS(2194),
    [anon_sym___forceinline] = ACTIONS(2194),
    [anon_sym_thread_local] = ACTIONS(2194),
    [anon_sym___thread] = ACTIONS(2194),
    [anon_sym_const] = ACTIONS(2194),
    [anon_sym_constexpr] = ACTIONS(2194),
    [anon_sym_volatile] = ACTIONS(2194),
    [anon_sym_restrict] = ACTIONS(2194),
    [anon_sym___restrict__] = ACTIONS(2194),
    [anon_sym__Atomic] = ACTIONS(2194),
    [anon_sym__Noreturn] = ACTIONS(2194),
    [anon_sym_noreturn] = ACTIONS(2194),
    [anon_sym_mutable] = ACTIONS(2194),
    [anon_sym_constinit] = ACTIONS(2194),
    [anon_sym_consteval] = ACTIONS(2194),
    [anon_sym_alignas] = ACTIONS(2194),
    [anon_sym__Alignas] = ACTIONS(2194),
    [sym_primitive_type] = ACTIONS(2194),
    [anon_sym_enum] = ACTIONS(2194),
    [anon_sym_class] = ACTIONS(2194),
    [anon_sym_struct] = ACTIONS(2194),
    [anon_sym_union] = ACTIONS(2194),
    [anon_sym_if] = ACTIONS(2194),
    [anon_sym_switch] = ACTIONS(2194),
    [anon_sym_case] = ACTIONS(2194),
    [anon_sym_default] = ACTIONS(2194),
    [anon_sym_while] = ACTIONS(2194),
    [anon_sym_do] = ACTIONS(2194),
    [anon_sym_for] = ACTIONS(2194),
    [anon_sym_return] = ACTIONS(2194),
    [anon_sym_break] = ACTIONS(2194),
    [anon_sym_continue] = ACTIONS(2194),
    [anon_sym_goto] = ACTIONS(2194),
    [anon_sym_QMARK] = ACTIONS(2196),
    [anon_sym_STAR_EQ] = ACTIONS(2196),
    [anon_sym_SLASH_EQ] = ACTIONS(2196),
    [anon_sym_PERCENT_EQ] = ACTIONS(2196),
    [anon_sym_PLUS_EQ] = ACTIONS(2196),
    [anon_sym_DASH_EQ] = ACTIONS(2196),
    [anon_sym_LT_LT_EQ] = ACTIONS(2196),
    [anon_sym_GT_GT_EQ] = ACTIONS(2196),
    [anon_sym_AMP_EQ] = ACTIONS(2196),
    [anon_sym_CARET_EQ] = ACTIONS(2196),
    [anon_sym_PIPE_EQ] = ACTIONS(2196),
    [anon_sym_and_eq] = ACTIONS(2194),
    [anon_sym_or_eq] = ACTIONS(2194),
    [anon_sym_xor_eq] = ACTIONS(2194),
    [anon_sym_not] = ACTIONS(2194),
    [anon_sym_compl] = ACTIONS(2194),
    [anon_sym_LT_EQ_GT] = ACTIONS(2196),
    [anon_sym_or] = ACTIONS(2194),
    [anon_sym_and] = ACTIONS(2194),
    [anon_sym_bitor] = ACTIONS(2194),
    [anon_sym_xor] = ACTIONS(2194),
    [anon_sym_bitand] = ACTIONS(2194),
    [anon_sym_not_eq] = ACTIONS(2194),
    [anon_sym_is] = ACTIONS(2194),
    [anon_sym_as] = ACTIONS(2194),
    [anon_sym_DASH_DASH] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2196),
    [anon_sym_sizeof] = ACTIONS(2194),
    [anon_sym___alignof__] = ACTIONS(2194),
    [anon_sym___alignof] = ACTIONS(2194),
    [anon_sym__alignof] = ACTIONS(2194),
    [anon_sym_alignof] = ACTIONS(2194),
    [anon_sym__Alignof] = ACTIONS(2194),
    [anon_sym_offsetof] = ACTIONS(2194),
    [anon_sym__Generic] = ACTIONS(2194),
    [anon_sym_asm] = ACTIONS(2194),
    [anon_sym___asm__] = ACTIONS(2194),
    [anon_sym_DOT] = ACTIONS(2194),
    [anon_sym_DOT_STAR] = ACTIONS(2196),
    [anon_sym_DASH_GT] = ACTIONS(2196),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_L_SQUOTE] = ACTIONS(2196),
    [anon_sym_u_SQUOTE] = ACTIONS(2196),
    [anon_sym_U_SQUOTE] = ACTIONS(2196),
    [anon_sym_u8_SQUOTE] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(2196),
    [anon_sym_L_DQUOTE] = ACTIONS(2196),
    [anon_sym_u_DQUOTE] = ACTIONS(2196),
    [anon_sym_U_DQUOTE] = ACTIONS(2196),
    [anon_sym_u8_DQUOTE] = ACTIONS(2196),
    [anon_sym_DQUOTE] = ACTIONS(2196),
    [sym_true] = ACTIONS(2194),
    [sym_false] = ACTIONS(2194),
    [anon_sym_NULL] = ACTIONS(2194),
    [anon_sym_nullptr] = ACTIONS(2194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2194),
    [anon_sym_let] = ACTIONS(2194),
    [anon_sym_This] = ACTIONS(2194),
    [anon_sym_decltype] = ACTIONS(2194),
    [sym_virtual] = ACTIONS(2194),
    [anon_sym_explicit] = ACTIONS(2194),
    [anon_sym_typename] = ACTIONS(2194),
    [anon_sym_template] = ACTIONS(2194),
    [anon_sym_operator] = ACTIONS(2194),
    [anon_sym_try] = ACTIONS(2194),
    [anon_sym_delete] = ACTIONS(2194),
    [anon_sym_throw] = ACTIONS(2194),
    [anon_sym_namespace] = ACTIONS(2194),
    [anon_sym_using] = ACTIONS(2194),
    [anon_sym_static_assert] = ACTIONS(2194),
    [anon_sym_concept] = ACTIONS(2194),
    [anon_sym_co_return] = ACTIONS(2194),
    [anon_sym_co_yield] = ACTIONS(2194),
    [anon_sym_R_DQUOTE] = ACTIONS(2196),
    [anon_sym_LR_DQUOTE] = ACTIONS(2196),
    [anon_sym_uR_DQUOTE] = ACTIONS(2196),
    [anon_sym_UR_DQUOTE] = ACTIONS(2196),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2196),
    [anon_sym_co_await] = ACTIONS(2194),
    [anon_sym_new] = ACTIONS(2194),
    [anon_sym_requires] = ACTIONS(2194),
    [sym_this] = ACTIONS(2194),
    [anon_sym_precise] = ACTIONS(2194),
    [anon_sym_shared] = ACTIONS(2194),
    [anon_sym_groupshared] = ACTIONS(2194),
    [anon_sym_uniform] = ACTIONS(2194),
    [anon_sym_row_major] = ACTIONS(2194),
    [anon_sym_column_major] = ACTIONS(2194),
    [anon_sym_globallycoherent] = ACTIONS(2194),
    [anon_sym_centroid] = ACTIONS(2194),
    [anon_sym_noperspective] = ACTIONS(2194),
    [anon_sym_nointerpolation] = ACTIONS(2194),
    [anon_sym_sample] = ACTIONS(2194),
    [anon_sym_linear] = ACTIONS(2194),
    [anon_sym_snorm] = ACTIONS(2194),
    [anon_sym_unorm] = ACTIONS(2194),
    [anon_sym_point] = ACTIONS(2194),
    [anon_sym_line] = ACTIONS(2194),
    [anon_sym_triangleadj] = ACTIONS(2194),
    [anon_sym_lineadj] = ACTIONS(2194),
    [anon_sym_triangle] = ACTIONS(2194),
    [anon_sym_interface] = ACTIONS(2194),
    [anon_sym_extension] = ACTIONS(2194),
    [anon_sym___exported] = ACTIONS(2194),
    [anon_sym_import] = ACTIONS(2194),
  },
  [130] = {
    [ts_builtin_sym_end] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(2240),
    [aux_sym_preproc_include_token1] = ACTIONS(2240),
    [aux_sym_preproc_def_token1] = ACTIONS(2240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2242),
    [aux_sym_preproc_if_token1] = ACTIONS(2240),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2240),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2240),
    [sym_preproc_directive] = ACTIONS(2240),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2240),
    [anon_sym_PLUS] = ACTIONS(2240),
    [anon_sym_STAR] = ACTIONS(2240),
    [anon_sym_SLASH] = ACTIONS(2240),
    [anon_sym_PERCENT] = ACTIONS(2240),
    [anon_sym_PIPE_PIPE] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_PIPE] = ACTIONS(2240),
    [anon_sym_CARET] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2240),
    [anon_sym_EQ_EQ] = ACTIONS(2242),
    [anon_sym_BANG_EQ] = ACTIONS(2242),
    [anon_sym_GT] = ACTIONS(2240),
    [anon_sym_GT_EQ] = ACTIONS(2242),
    [anon_sym_LT_EQ] = ACTIONS(2240),
    [anon_sym_LT] = ACTIONS(2240),
    [anon_sym_LT_LT] = ACTIONS(2240),
    [anon_sym_GT_GT] = ACTIONS(2240),
    [anon_sym_SEMI] = ACTIONS(2242),
    [anon_sym___extension__] = ACTIONS(2240),
    [anon_sym_typedef] = ACTIONS(2240),
    [anon_sym_in] = ACTIONS(2240),
    [anon_sym_out] = ACTIONS(2240),
    [anon_sym_inout] = ACTIONS(2240),
    [anon_sym_extern] = ACTIONS(2240),
    [anon_sym___attribute__] = ACTIONS(2240),
    [anon_sym_COLON_COLON] = ACTIONS(2242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2242),
    [anon_sym___declspec] = ACTIONS(2240),
    [anon_sym___based] = ACTIONS(2240),
    [anon_sym___cdecl] = ACTIONS(2240),
    [anon_sym___clrcall] = ACTIONS(2240),
    [anon_sym___stdcall] = ACTIONS(2240),
    [anon_sym___fastcall] = ACTIONS(2240),
    [anon_sym___thiscall] = ACTIONS(2240),
    [anon_sym___vectorcall] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_signed] = ACTIONS(2240),
    [anon_sym_unsigned] = ACTIONS(2240),
    [anon_sym_long] = ACTIONS(2240),
    [anon_sym_short] = ACTIONS(2240),
    [anon_sym_LBRACK] = ACTIONS(2240),
    [anon_sym_static] = ACTIONS(2240),
    [anon_sym_EQ] = ACTIONS(2240),
    [anon_sym_register] = ACTIONS(2240),
    [anon_sym_inline] = ACTIONS(2240),
    [anon_sym___inline] = ACTIONS(2240),
    [anon_sym___inline__] = ACTIONS(2240),
    [anon_sym___forceinline] = ACTIONS(2240),
    [anon_sym_thread_local] = ACTIONS(2240),
    [anon_sym___thread] = ACTIONS(2240),
    [anon_sym_const] = ACTIONS(2240),
    [anon_sym_constexpr] = ACTIONS(2240),
    [anon_sym_volatile] = ACTIONS(2240),
    [anon_sym_restrict] = ACTIONS(2240),
    [anon_sym___restrict__] = ACTIONS(2240),
    [anon_sym__Atomic] = ACTIONS(2240),
    [anon_sym__Noreturn] = ACTIONS(2240),
    [anon_sym_noreturn] = ACTIONS(2240),
    [anon_sym_mutable] = ACTIONS(2240),
    [anon_sym_constinit] = ACTIONS(2240),
    [anon_sym_consteval] = ACTIONS(2240),
    [anon_sym_alignas] = ACTIONS(2240),
    [anon_sym__Alignas] = ACTIONS(2240),
    [sym_primitive_type] = ACTIONS(2240),
    [anon_sym_enum] = ACTIONS(2240),
    [anon_sym_class] = ACTIONS(2240),
    [anon_sym_struct] = ACTIONS(2240),
    [anon_sym_union] = ACTIONS(2240),
    [anon_sym_if] = ACTIONS(2240),
    [anon_sym_switch] = ACTIONS(2240),
    [anon_sym_case] = ACTIONS(2240),
    [anon_sym_default] = ACTIONS(2240),
    [anon_sym_while] = ACTIONS(2240),
    [anon_sym_do] = ACTIONS(2240),
    [anon_sym_for] = ACTIONS(2240),
    [anon_sym_return] = ACTIONS(2240),
    [anon_sym_break] = ACTIONS(2240),
    [anon_sym_continue] = ACTIONS(2240),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_QMARK] = ACTIONS(2242),
    [anon_sym_STAR_EQ] = ACTIONS(2242),
    [anon_sym_SLASH_EQ] = ACTIONS(2242),
    [anon_sym_PERCENT_EQ] = ACTIONS(2242),
    [anon_sym_PLUS_EQ] = ACTIONS(2242),
    [anon_sym_DASH_EQ] = ACTIONS(2242),
    [anon_sym_LT_LT_EQ] = ACTIONS(2242),
    [anon_sym_GT_GT_EQ] = ACTIONS(2242),
    [anon_sym_AMP_EQ] = ACTIONS(2242),
    [anon_sym_CARET_EQ] = ACTIONS(2242),
    [anon_sym_PIPE_EQ] = ACTIONS(2242),
    [anon_sym_and_eq] = ACTIONS(2240),
    [anon_sym_or_eq] = ACTIONS(2240),
    [anon_sym_xor_eq] = ACTIONS(2240),
    [anon_sym_not] = ACTIONS(2240),
    [anon_sym_compl] = ACTIONS(2240),
    [anon_sym_LT_EQ_GT] = ACTIONS(2242),
    [anon_sym_or] = ACTIONS(2240),
    [anon_sym_and] = ACTIONS(2240),
    [anon_sym_bitor] = ACTIONS(2240),
    [anon_sym_xor] = ACTIONS(2240),
    [anon_sym_bitand] = ACTIONS(2240),
    [anon_sym_not_eq] = ACTIONS(2240),
    [anon_sym_is] = ACTIONS(2240),
    [anon_sym_as] = ACTIONS(2240),
    [anon_sym_DASH_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_PLUS] = ACTIONS(2242),
    [anon_sym_sizeof] = ACTIONS(2240),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2240),
    [anon_sym__Generic] = ACTIONS(2240),
    [anon_sym_asm] = ACTIONS(2240),
    [anon_sym___asm__] = ACTIONS(2240),
    [anon_sym_DOT] = ACTIONS(2240),
    [anon_sym_DOT_STAR] = ACTIONS(2242),
    [anon_sym_DASH_GT] = ACTIONS(2242),
    [sym_number_literal] = ACTIONS(2242),
    [anon_sym_L_SQUOTE] = ACTIONS(2242),
    [anon_sym_u_SQUOTE] = ACTIONS(2242),
    [anon_sym_U_SQUOTE] = ACTIONS(2242),
    [anon_sym_u8_SQUOTE] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(2242),
    [anon_sym_L_DQUOTE] = ACTIONS(2242),
    [anon_sym_u_DQUOTE] = ACTIONS(2242),
    [anon_sym_U_DQUOTE] = ACTIONS(2242),
    [anon_sym_u8_DQUOTE] = ACTIONS(2242),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [sym_true] = ACTIONS(2240),
    [sym_false] = ACTIONS(2240),
    [anon_sym_NULL] = ACTIONS(2240),
    [anon_sym_nullptr] = ACTIONS(2240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2240),
    [anon_sym_let] = ACTIONS(2240),
    [anon_sym_This] = ACTIONS(2240),
    [anon_sym_decltype] = ACTIONS(2240),
    [sym_virtual] = ACTIONS(2240),
    [anon_sym_explicit] = ACTIONS(2240),
    [anon_sym_typename] = ACTIONS(2240),
    [anon_sym_template] = ACTIONS(2240),
    [anon_sym_operator] = ACTIONS(2240),
    [anon_sym_try] = ACTIONS(2240),
    [anon_sym_delete] = ACTIONS(2240),
    [anon_sym_throw] = ACTIONS(2240),
    [anon_sym_namespace] = ACTIONS(2240),
    [anon_sym_using] = ACTIONS(2240),
    [anon_sym_static_assert] = ACTIONS(2240),
    [anon_sym_concept] = ACTIONS(2240),
    [anon_sym_co_return] = ACTIONS(2240),
    [anon_sym_co_yield] = ACTIONS(2240),
    [anon_sym_R_DQUOTE] = ACTIONS(2242),
    [anon_sym_LR_DQUOTE] = ACTIONS(2242),
    [anon_sym_uR_DQUOTE] = ACTIONS(2242),
    [anon_sym_UR_DQUOTE] = ACTIONS(2242),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2242),
    [anon_sym_co_await] = ACTIONS(2240),
    [anon_sym_new] = ACTIONS(2240),
    [anon_sym_requires] = ACTIONS(2240),
    [sym_this] = ACTIONS(2240),
    [anon_sym_precise] = ACTIONS(2240),
    [anon_sym_shared] = ACTIONS(2240),
    [anon_sym_groupshared] = ACTIONS(2240),
    [anon_sym_uniform] = ACTIONS(2240),
    [anon_sym_row_major] = ACTIONS(2240),
    [anon_sym_column_major] = ACTIONS(2240),
    [anon_sym_globallycoherent] = ACTIONS(2240),
    [anon_sym_centroid] = ACTIONS(2240),
    [anon_sym_noperspective] = ACTIONS(2240),
    [anon_sym_nointerpolation] = ACTIONS(2240),
    [anon_sym_sample] = ACTIONS(2240),
    [anon_sym_linear] = ACTIONS(2240),
    [anon_sym_snorm] = ACTIONS(2240),
    [anon_sym_unorm] = ACTIONS(2240),
    [anon_sym_point] = ACTIONS(2240),
    [anon_sym_line] = ACTIONS(2240),
    [anon_sym_triangleadj] = ACTIONS(2240),
    [anon_sym_lineadj] = ACTIONS(2240),
    [anon_sym_triangle] = ACTIONS(2240),
    [anon_sym_interface] = ACTIONS(2240),
    [anon_sym_extension] = ACTIONS(2240),
    [anon_sym___exported] = ACTIONS(2240),
    [anon_sym_import] = ACTIONS(2240),
  },
  [131] = {
    [ts_builtin_sym_end] = ACTIONS(2250),
    [sym_identifier] = ACTIONS(2248),
    [aux_sym_preproc_include_token1] = ACTIONS(2248),
    [aux_sym_preproc_def_token1] = ACTIONS(2248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2250),
    [aux_sym_preproc_if_token1] = ACTIONS(2248),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2248),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2248),
    [sym_preproc_directive] = ACTIONS(2248),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2248),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2248),
    [anon_sym_PLUS] = ACTIONS(2248),
    [anon_sym_STAR] = ACTIONS(2248),
    [anon_sym_SLASH] = ACTIONS(2248),
    [anon_sym_PERCENT] = ACTIONS(2248),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2248),
    [anon_sym_EQ_EQ] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_GT] = ACTIONS(2248),
    [anon_sym_GT_EQ] = ACTIONS(2250),
    [anon_sym_LT_EQ] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_LT_LT] = ACTIONS(2248),
    [anon_sym_GT_GT] = ACTIONS(2248),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym___extension__] = ACTIONS(2248),
    [anon_sym_typedef] = ACTIONS(2248),
    [anon_sym_in] = ACTIONS(2248),
    [anon_sym_out] = ACTIONS(2248),
    [anon_sym_inout] = ACTIONS(2248),
    [anon_sym_extern] = ACTIONS(2248),
    [anon_sym___attribute__] = ACTIONS(2248),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2250),
    [anon_sym___declspec] = ACTIONS(2248),
    [anon_sym___based] = ACTIONS(2248),
    [anon_sym___cdecl] = ACTIONS(2248),
    [anon_sym___clrcall] = ACTIONS(2248),
    [anon_sym___stdcall] = ACTIONS(2248),
    [anon_sym___fastcall] = ACTIONS(2248),
    [anon_sym___thiscall] = ACTIONS(2248),
    [anon_sym___vectorcall] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_signed] = ACTIONS(2248),
    [anon_sym_unsigned] = ACTIONS(2248),
    [anon_sym_long] = ACTIONS(2248),
    [anon_sym_short] = ACTIONS(2248),
    [anon_sym_LBRACK] = ACTIONS(2248),
    [anon_sym_static] = ACTIONS(2248),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_register] = ACTIONS(2248),
    [anon_sym_inline] = ACTIONS(2248),
    [anon_sym___inline] = ACTIONS(2248),
    [anon_sym___inline__] = ACTIONS(2248),
    [anon_sym___forceinline] = ACTIONS(2248),
    [anon_sym_thread_local] = ACTIONS(2248),
    [anon_sym___thread] = ACTIONS(2248),
    [anon_sym_const] = ACTIONS(2248),
    [anon_sym_constexpr] = ACTIONS(2248),
    [anon_sym_volatile] = ACTIONS(2248),
    [anon_sym_restrict] = ACTIONS(2248),
    [anon_sym___restrict__] = ACTIONS(2248),
    [anon_sym__Atomic] = ACTIONS(2248),
    [anon_sym__Noreturn] = ACTIONS(2248),
    [anon_sym_noreturn] = ACTIONS(2248),
    [anon_sym_mutable] = ACTIONS(2248),
    [anon_sym_constinit] = ACTIONS(2248),
    [anon_sym_consteval] = ACTIONS(2248),
    [anon_sym_alignas] = ACTIONS(2248),
    [anon_sym__Alignas] = ACTIONS(2248),
    [sym_primitive_type] = ACTIONS(2248),
    [anon_sym_enum] = ACTIONS(2248),
    [anon_sym_class] = ACTIONS(2248),
    [anon_sym_struct] = ACTIONS(2248),
    [anon_sym_union] = ACTIONS(2248),
    [anon_sym_if] = ACTIONS(2248),
    [anon_sym_switch] = ACTIONS(2248),
    [anon_sym_case] = ACTIONS(2248),
    [anon_sym_default] = ACTIONS(2248),
    [anon_sym_while] = ACTIONS(2248),
    [anon_sym_do] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2248),
    [anon_sym_break] = ACTIONS(2248),
    [anon_sym_continue] = ACTIONS(2248),
    [anon_sym_goto] = ACTIONS(2248),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_STAR_EQ] = ACTIONS(2250),
    [anon_sym_SLASH_EQ] = ACTIONS(2250),
    [anon_sym_PERCENT_EQ] = ACTIONS(2250),
    [anon_sym_PLUS_EQ] = ACTIONS(2250),
    [anon_sym_DASH_EQ] = ACTIONS(2250),
    [anon_sym_LT_LT_EQ] = ACTIONS(2250),
    [anon_sym_GT_GT_EQ] = ACTIONS(2250),
    [anon_sym_AMP_EQ] = ACTIONS(2250),
    [anon_sym_CARET_EQ] = ACTIONS(2250),
    [anon_sym_PIPE_EQ] = ACTIONS(2250),
    [anon_sym_and_eq] = ACTIONS(2248),
    [anon_sym_or_eq] = ACTIONS(2248),
    [anon_sym_xor_eq] = ACTIONS(2248),
    [anon_sym_not] = ACTIONS(2248),
    [anon_sym_compl] = ACTIONS(2248),
    [anon_sym_LT_EQ_GT] = ACTIONS(2250),
    [anon_sym_or] = ACTIONS(2248),
    [anon_sym_and] = ACTIONS(2248),
    [anon_sym_bitor] = ACTIONS(2248),
    [anon_sym_xor] = ACTIONS(2248),
    [anon_sym_bitand] = ACTIONS(2248),
    [anon_sym_not_eq] = ACTIONS(2248),
    [anon_sym_is] = ACTIONS(2248),
    [anon_sym_as] = ACTIONS(2248),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_sizeof] = ACTIONS(2248),
    [anon_sym___alignof__] = ACTIONS(2248),
    [anon_sym___alignof] = ACTIONS(2248),
    [anon_sym__alignof] = ACTIONS(2248),
    [anon_sym_alignof] = ACTIONS(2248),
    [anon_sym__Alignof] = ACTIONS(2248),
    [anon_sym_offsetof] = ACTIONS(2248),
    [anon_sym__Generic] = ACTIONS(2248),
    [anon_sym_asm] = ACTIONS(2248),
    [anon_sym___asm__] = ACTIONS(2248),
    [anon_sym_DOT] = ACTIONS(2248),
    [anon_sym_DOT_STAR] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2250),
    [sym_number_literal] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2250),
    [anon_sym_u_SQUOTE] = ACTIONS(2250),
    [anon_sym_U_SQUOTE] = ACTIONS(2250),
    [anon_sym_u8_SQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym_L_DQUOTE] = ACTIONS(2250),
    [anon_sym_u_DQUOTE] = ACTIONS(2250),
    [anon_sym_U_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [sym_true] = ACTIONS(2248),
    [sym_false] = ACTIONS(2248),
    [anon_sym_NULL] = ACTIONS(2248),
    [anon_sym_nullptr] = ACTIONS(2248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2248),
    [anon_sym_let] = ACTIONS(2248),
    [anon_sym_This] = ACTIONS(2248),
    [anon_sym_decltype] = ACTIONS(2248),
    [sym_virtual] = ACTIONS(2248),
    [anon_sym_explicit] = ACTIONS(2248),
    [anon_sym_typename] = ACTIONS(2248),
    [anon_sym_template] = ACTIONS(2248),
    [anon_sym_operator] = ACTIONS(2248),
    [anon_sym_try] = ACTIONS(2248),
    [anon_sym_delete] = ACTIONS(2248),
    [anon_sym_throw] = ACTIONS(2248),
    [anon_sym_namespace] = ACTIONS(2248),
    [anon_sym_using] = ACTIONS(2248),
    [anon_sym_static_assert] = ACTIONS(2248),
    [anon_sym_concept] = ACTIONS(2248),
    [anon_sym_co_return] = ACTIONS(2248),
    [anon_sym_co_yield] = ACTIONS(2248),
    [anon_sym_R_DQUOTE] = ACTIONS(2250),
    [anon_sym_LR_DQUOTE] = ACTIONS(2250),
    [anon_sym_uR_DQUOTE] = ACTIONS(2250),
    [anon_sym_UR_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2250),
    [anon_sym_co_await] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2248),
    [anon_sym_requires] = ACTIONS(2248),
    [sym_this] = ACTIONS(2248),
    [anon_sym_precise] = ACTIONS(2248),
    [anon_sym_shared] = ACTIONS(2248),
    [anon_sym_groupshared] = ACTIONS(2248),
    [anon_sym_uniform] = ACTIONS(2248),
    [anon_sym_row_major] = ACTIONS(2248),
    [anon_sym_column_major] = ACTIONS(2248),
    [anon_sym_globallycoherent] = ACTIONS(2248),
    [anon_sym_centroid] = ACTIONS(2248),
    [anon_sym_noperspective] = ACTIONS(2248),
    [anon_sym_nointerpolation] = ACTIONS(2248),
    [anon_sym_sample] = ACTIONS(2248),
    [anon_sym_linear] = ACTIONS(2248),
    [anon_sym_snorm] = ACTIONS(2248),
    [anon_sym_unorm] = ACTIONS(2248),
    [anon_sym_point] = ACTIONS(2248),
    [anon_sym_line] = ACTIONS(2248),
    [anon_sym_triangleadj] = ACTIONS(2248),
    [anon_sym_lineadj] = ACTIONS(2248),
    [anon_sym_triangle] = ACTIONS(2248),
    [anon_sym_interface] = ACTIONS(2248),
    [anon_sym_extension] = ACTIONS(2248),
    [anon_sym___exported] = ACTIONS(2248),
    [anon_sym_import] = ACTIONS(2248),
  },
  [132] = {
    [ts_builtin_sym_end] = ACTIONS(2234),
    [sym_identifier] = ACTIONS(2232),
    [aux_sym_preproc_include_token1] = ACTIONS(2232),
    [aux_sym_preproc_def_token1] = ACTIONS(2232),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [aux_sym_preproc_if_token1] = ACTIONS(2232),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2232),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2232),
    [sym_preproc_directive] = ACTIONS(2232),
    [anon_sym_LPAREN2] = ACTIONS(2234),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2232),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_STAR] = ACTIONS(2232),
    [anon_sym_SLASH] = ACTIONS(2232),
    [anon_sym_PERCENT] = ACTIONS(2232),
    [anon_sym_PIPE_PIPE] = ACTIONS(2234),
    [anon_sym_AMP_AMP] = ACTIONS(2234),
    [anon_sym_PIPE] = ACTIONS(2232),
    [anon_sym_CARET] = ACTIONS(2232),
    [anon_sym_AMP] = ACTIONS(2232),
    [anon_sym_EQ_EQ] = ACTIONS(2234),
    [anon_sym_BANG_EQ] = ACTIONS(2234),
    [anon_sym_GT] = ACTIONS(2232),
    [anon_sym_GT_EQ] = ACTIONS(2234),
    [anon_sym_LT_EQ] = ACTIONS(2232),
    [anon_sym_LT] = ACTIONS(2232),
    [anon_sym_LT_LT] = ACTIONS(2232),
    [anon_sym_GT_GT] = ACTIONS(2232),
    [anon_sym_SEMI] = ACTIONS(2234),
    [anon_sym___extension__] = ACTIONS(2232),
    [anon_sym_typedef] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2232),
    [anon_sym_out] = ACTIONS(2232),
    [anon_sym_inout] = ACTIONS(2232),
    [anon_sym_extern] = ACTIONS(2232),
    [anon_sym___attribute__] = ACTIONS(2232),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2234),
    [anon_sym___declspec] = ACTIONS(2232),
    [anon_sym___based] = ACTIONS(2232),
    [anon_sym___cdecl] = ACTIONS(2232),
    [anon_sym___clrcall] = ACTIONS(2232),
    [anon_sym___stdcall] = ACTIONS(2232),
    [anon_sym___fastcall] = ACTIONS(2232),
    [anon_sym___thiscall] = ACTIONS(2232),
    [anon_sym___vectorcall] = ACTIONS(2232),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_signed] = ACTIONS(2232),
    [anon_sym_unsigned] = ACTIONS(2232),
    [anon_sym_long] = ACTIONS(2232),
    [anon_sym_short] = ACTIONS(2232),
    [anon_sym_LBRACK] = ACTIONS(2232),
    [anon_sym_static] = ACTIONS(2232),
    [anon_sym_EQ] = ACTIONS(2232),
    [anon_sym_register] = ACTIONS(2232),
    [anon_sym_inline] = ACTIONS(2232),
    [anon_sym___inline] = ACTIONS(2232),
    [anon_sym___inline__] = ACTIONS(2232),
    [anon_sym___forceinline] = ACTIONS(2232),
    [anon_sym_thread_local] = ACTIONS(2232),
    [anon_sym___thread] = ACTIONS(2232),
    [anon_sym_const] = ACTIONS(2232),
    [anon_sym_constexpr] = ACTIONS(2232),
    [anon_sym_volatile] = ACTIONS(2232),
    [anon_sym_restrict] = ACTIONS(2232),
    [anon_sym___restrict__] = ACTIONS(2232),
    [anon_sym__Atomic] = ACTIONS(2232),
    [anon_sym__Noreturn] = ACTIONS(2232),
    [anon_sym_noreturn] = ACTIONS(2232),
    [anon_sym_mutable] = ACTIONS(2232),
    [anon_sym_constinit] = ACTIONS(2232),
    [anon_sym_consteval] = ACTIONS(2232),
    [anon_sym_alignas] = ACTIONS(2232),
    [anon_sym__Alignas] = ACTIONS(2232),
    [sym_primitive_type] = ACTIONS(2232),
    [anon_sym_enum] = ACTIONS(2232),
    [anon_sym_class] = ACTIONS(2232),
    [anon_sym_struct] = ACTIONS(2232),
    [anon_sym_union] = ACTIONS(2232),
    [anon_sym_if] = ACTIONS(2232),
    [anon_sym_switch] = ACTIONS(2232),
    [anon_sym_case] = ACTIONS(2232),
    [anon_sym_default] = ACTIONS(2232),
    [anon_sym_while] = ACTIONS(2232),
    [anon_sym_do] = ACTIONS(2232),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2232),
    [anon_sym_break] = ACTIONS(2232),
    [anon_sym_continue] = ACTIONS(2232),
    [anon_sym_goto] = ACTIONS(2232),
    [anon_sym_QMARK] = ACTIONS(2234),
    [anon_sym_STAR_EQ] = ACTIONS(2234),
    [anon_sym_SLASH_EQ] = ACTIONS(2234),
    [anon_sym_PERCENT_EQ] = ACTIONS(2234),
    [anon_sym_PLUS_EQ] = ACTIONS(2234),
    [anon_sym_DASH_EQ] = ACTIONS(2234),
    [anon_sym_LT_LT_EQ] = ACTIONS(2234),
    [anon_sym_GT_GT_EQ] = ACTIONS(2234),
    [anon_sym_AMP_EQ] = ACTIONS(2234),
    [anon_sym_CARET_EQ] = ACTIONS(2234),
    [anon_sym_PIPE_EQ] = ACTIONS(2234),
    [anon_sym_and_eq] = ACTIONS(2232),
    [anon_sym_or_eq] = ACTIONS(2232),
    [anon_sym_xor_eq] = ACTIONS(2232),
    [anon_sym_not] = ACTIONS(2232),
    [anon_sym_compl] = ACTIONS(2232),
    [anon_sym_LT_EQ_GT] = ACTIONS(2234),
    [anon_sym_or] = ACTIONS(2232),
    [anon_sym_and] = ACTIONS(2232),
    [anon_sym_bitor] = ACTIONS(2232),
    [anon_sym_xor] = ACTIONS(2232),
    [anon_sym_bitand] = ACTIONS(2232),
    [anon_sym_not_eq] = ACTIONS(2232),
    [anon_sym_is] = ACTIONS(2232),
    [anon_sym_as] = ACTIONS(2232),
    [anon_sym_DASH_DASH] = ACTIONS(2234),
    [anon_sym_PLUS_PLUS] = ACTIONS(2234),
    [anon_sym_sizeof] = ACTIONS(2232),
    [anon_sym___alignof__] = ACTIONS(2232),
    [anon_sym___alignof] = ACTIONS(2232),
    [anon_sym__alignof] = ACTIONS(2232),
    [anon_sym_alignof] = ACTIONS(2232),
    [anon_sym__Alignof] = ACTIONS(2232),
    [anon_sym_offsetof] = ACTIONS(2232),
    [anon_sym__Generic] = ACTIONS(2232),
    [anon_sym_asm] = ACTIONS(2232),
    [anon_sym___asm__] = ACTIONS(2232),
    [anon_sym_DOT] = ACTIONS(2232),
    [anon_sym_DOT_STAR] = ACTIONS(2234),
    [anon_sym_DASH_GT] = ACTIONS(2234),
    [sym_number_literal] = ACTIONS(2234),
    [anon_sym_L_SQUOTE] = ACTIONS(2234),
    [anon_sym_u_SQUOTE] = ACTIONS(2234),
    [anon_sym_U_SQUOTE] = ACTIONS(2234),
    [anon_sym_u8_SQUOTE] = ACTIONS(2234),
    [anon_sym_SQUOTE] = ACTIONS(2234),
    [anon_sym_L_DQUOTE] = ACTIONS(2234),
    [anon_sym_u_DQUOTE] = ACTIONS(2234),
    [anon_sym_U_DQUOTE] = ACTIONS(2234),
    [anon_sym_u8_DQUOTE] = ACTIONS(2234),
    [anon_sym_DQUOTE] = ACTIONS(2234),
    [sym_true] = ACTIONS(2232),
    [sym_false] = ACTIONS(2232),
    [anon_sym_NULL] = ACTIONS(2232),
    [anon_sym_nullptr] = ACTIONS(2232),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2232),
    [anon_sym_let] = ACTIONS(2232),
    [anon_sym_This] = ACTIONS(2232),
    [anon_sym_decltype] = ACTIONS(2232),
    [sym_virtual] = ACTIONS(2232),
    [anon_sym_explicit] = ACTIONS(2232),
    [anon_sym_typename] = ACTIONS(2232),
    [anon_sym_template] = ACTIONS(2232),
    [anon_sym_operator] = ACTIONS(2232),
    [anon_sym_try] = ACTIONS(2232),
    [anon_sym_delete] = ACTIONS(2232),
    [anon_sym_throw] = ACTIONS(2232),
    [anon_sym_namespace] = ACTIONS(2232),
    [anon_sym_using] = ACTIONS(2232),
    [anon_sym_static_assert] = ACTIONS(2232),
    [anon_sym_concept] = ACTIONS(2232),
    [anon_sym_co_return] = ACTIONS(2232),
    [anon_sym_co_yield] = ACTIONS(2232),
    [anon_sym_R_DQUOTE] = ACTIONS(2234),
    [anon_sym_LR_DQUOTE] = ACTIONS(2234),
    [anon_sym_uR_DQUOTE] = ACTIONS(2234),
    [anon_sym_UR_DQUOTE] = ACTIONS(2234),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2234),
    [anon_sym_co_await] = ACTIONS(2232),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_requires] = ACTIONS(2232),
    [sym_this] = ACTIONS(2232),
    [anon_sym_precise] = ACTIONS(2232),
    [anon_sym_shared] = ACTIONS(2232),
    [anon_sym_groupshared] = ACTIONS(2232),
    [anon_sym_uniform] = ACTIONS(2232),
    [anon_sym_row_major] = ACTIONS(2232),
    [anon_sym_column_major] = ACTIONS(2232),
    [anon_sym_globallycoherent] = ACTIONS(2232),
    [anon_sym_centroid] = ACTIONS(2232),
    [anon_sym_noperspective] = ACTIONS(2232),
    [anon_sym_nointerpolation] = ACTIONS(2232),
    [anon_sym_sample] = ACTIONS(2232),
    [anon_sym_linear] = ACTIONS(2232),
    [anon_sym_snorm] = ACTIONS(2232),
    [anon_sym_unorm] = ACTIONS(2232),
    [anon_sym_point] = ACTIONS(2232),
    [anon_sym_line] = ACTIONS(2232),
    [anon_sym_triangleadj] = ACTIONS(2232),
    [anon_sym_lineadj] = ACTIONS(2232),
    [anon_sym_triangle] = ACTIONS(2232),
    [anon_sym_interface] = ACTIONS(2232),
    [anon_sym_extension] = ACTIONS(2232),
    [anon_sym___exported] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(2232),
  },
  [133] = {
    [ts_builtin_sym_end] = ACTIONS(2230),
    [sym_identifier] = ACTIONS(2228),
    [aux_sym_preproc_include_token1] = ACTIONS(2228),
    [aux_sym_preproc_def_token1] = ACTIONS(2228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2230),
    [aux_sym_preproc_if_token1] = ACTIONS(2228),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2228),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2228),
    [sym_preproc_directive] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2228),
    [anon_sym_PLUS] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(2228),
    [anon_sym_SLASH] = ACTIONS(2228),
    [anon_sym_PERCENT] = ACTIONS(2228),
    [anon_sym_PIPE_PIPE] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_PIPE] = ACTIONS(2228),
    [anon_sym_CARET] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2228),
    [anon_sym_EQ_EQ] = ACTIONS(2230),
    [anon_sym_BANG_EQ] = ACTIONS(2230),
    [anon_sym_GT] = ACTIONS(2228),
    [anon_sym_GT_EQ] = ACTIONS(2230),
    [anon_sym_LT_EQ] = ACTIONS(2228),
    [anon_sym_LT] = ACTIONS(2228),
    [anon_sym_LT_LT] = ACTIONS(2228),
    [anon_sym_GT_GT] = ACTIONS(2228),
    [anon_sym_SEMI] = ACTIONS(2230),
    [anon_sym___extension__] = ACTIONS(2228),
    [anon_sym_typedef] = ACTIONS(2228),
    [anon_sym_in] = ACTIONS(2228),
    [anon_sym_out] = ACTIONS(2228),
    [anon_sym_inout] = ACTIONS(2228),
    [anon_sym_extern] = ACTIONS(2228),
    [anon_sym___attribute__] = ACTIONS(2228),
    [anon_sym_COLON_COLON] = ACTIONS(2230),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2230),
    [anon_sym___declspec] = ACTIONS(2228),
    [anon_sym___based] = ACTIONS(2228),
    [anon_sym___cdecl] = ACTIONS(2228),
    [anon_sym___clrcall] = ACTIONS(2228),
    [anon_sym___stdcall] = ACTIONS(2228),
    [anon_sym___fastcall] = ACTIONS(2228),
    [anon_sym___thiscall] = ACTIONS(2228),
    [anon_sym___vectorcall] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_signed] = ACTIONS(2228),
    [anon_sym_unsigned] = ACTIONS(2228),
    [anon_sym_long] = ACTIONS(2228),
    [anon_sym_short] = ACTIONS(2228),
    [anon_sym_LBRACK] = ACTIONS(2228),
    [anon_sym_static] = ACTIONS(2228),
    [anon_sym_EQ] = ACTIONS(2228),
    [anon_sym_register] = ACTIONS(2228),
    [anon_sym_inline] = ACTIONS(2228),
    [anon_sym___inline] = ACTIONS(2228),
    [anon_sym___inline__] = ACTIONS(2228),
    [anon_sym___forceinline] = ACTIONS(2228),
    [anon_sym_thread_local] = ACTIONS(2228),
    [anon_sym___thread] = ACTIONS(2228),
    [anon_sym_const] = ACTIONS(2228),
    [anon_sym_constexpr] = ACTIONS(2228),
    [anon_sym_volatile] = ACTIONS(2228),
    [anon_sym_restrict] = ACTIONS(2228),
    [anon_sym___restrict__] = ACTIONS(2228),
    [anon_sym__Atomic] = ACTIONS(2228),
    [anon_sym__Noreturn] = ACTIONS(2228),
    [anon_sym_noreturn] = ACTIONS(2228),
    [anon_sym_mutable] = ACTIONS(2228),
    [anon_sym_constinit] = ACTIONS(2228),
    [anon_sym_consteval] = ACTIONS(2228),
    [anon_sym_alignas] = ACTIONS(2228),
    [anon_sym__Alignas] = ACTIONS(2228),
    [sym_primitive_type] = ACTIONS(2228),
    [anon_sym_enum] = ACTIONS(2228),
    [anon_sym_class] = ACTIONS(2228),
    [anon_sym_struct] = ACTIONS(2228),
    [anon_sym_union] = ACTIONS(2228),
    [anon_sym_if] = ACTIONS(2228),
    [anon_sym_switch] = ACTIONS(2228),
    [anon_sym_case] = ACTIONS(2228),
    [anon_sym_default] = ACTIONS(2228),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2228),
    [anon_sym_for] = ACTIONS(2228),
    [anon_sym_return] = ACTIONS(2228),
    [anon_sym_break] = ACTIONS(2228),
    [anon_sym_continue] = ACTIONS(2228),
    [anon_sym_goto] = ACTIONS(2228),
    [anon_sym_QMARK] = ACTIONS(2230),
    [anon_sym_STAR_EQ] = ACTIONS(2230),
    [anon_sym_SLASH_EQ] = ACTIONS(2230),
    [anon_sym_PERCENT_EQ] = ACTIONS(2230),
    [anon_sym_PLUS_EQ] = ACTIONS(2230),
    [anon_sym_DASH_EQ] = ACTIONS(2230),
    [anon_sym_LT_LT_EQ] = ACTIONS(2230),
    [anon_sym_GT_GT_EQ] = ACTIONS(2230),
    [anon_sym_AMP_EQ] = ACTIONS(2230),
    [anon_sym_CARET_EQ] = ACTIONS(2230),
    [anon_sym_PIPE_EQ] = ACTIONS(2230),
    [anon_sym_and_eq] = ACTIONS(2228),
    [anon_sym_or_eq] = ACTIONS(2228),
    [anon_sym_xor_eq] = ACTIONS(2228),
    [anon_sym_not] = ACTIONS(2228),
    [anon_sym_compl] = ACTIONS(2228),
    [anon_sym_LT_EQ_GT] = ACTIONS(2230),
    [anon_sym_or] = ACTIONS(2228),
    [anon_sym_and] = ACTIONS(2228),
    [anon_sym_bitor] = ACTIONS(2228),
    [anon_sym_xor] = ACTIONS(2228),
    [anon_sym_bitand] = ACTIONS(2228),
    [anon_sym_not_eq] = ACTIONS(2228),
    [anon_sym_is] = ACTIONS(2228),
    [anon_sym_as] = ACTIONS(2228),
    [anon_sym_DASH_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_PLUS] = ACTIONS(2230),
    [anon_sym_sizeof] = ACTIONS(2228),
    [anon_sym___alignof__] = ACTIONS(2228),
    [anon_sym___alignof] = ACTIONS(2228),
    [anon_sym__alignof] = ACTIONS(2228),
    [anon_sym_alignof] = ACTIONS(2228),
    [anon_sym__Alignof] = ACTIONS(2228),
    [anon_sym_offsetof] = ACTIONS(2228),
    [anon_sym__Generic] = ACTIONS(2228),
    [anon_sym_asm] = ACTIONS(2228),
    [anon_sym___asm__] = ACTIONS(2228),
    [anon_sym_DOT] = ACTIONS(2228),
    [anon_sym_DOT_STAR] = ACTIONS(2230),
    [anon_sym_DASH_GT] = ACTIONS(2230),
    [sym_number_literal] = ACTIONS(2230),
    [anon_sym_L_SQUOTE] = ACTIONS(2230),
    [anon_sym_u_SQUOTE] = ACTIONS(2230),
    [anon_sym_U_SQUOTE] = ACTIONS(2230),
    [anon_sym_u8_SQUOTE] = ACTIONS(2230),
    [anon_sym_SQUOTE] = ACTIONS(2230),
    [anon_sym_L_DQUOTE] = ACTIONS(2230),
    [anon_sym_u_DQUOTE] = ACTIONS(2230),
    [anon_sym_U_DQUOTE] = ACTIONS(2230),
    [anon_sym_u8_DQUOTE] = ACTIONS(2230),
    [anon_sym_DQUOTE] = ACTIONS(2230),
    [sym_true] = ACTIONS(2228),
    [sym_false] = ACTIONS(2228),
    [anon_sym_NULL] = ACTIONS(2228),
    [anon_sym_nullptr] = ACTIONS(2228),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(2228),
    [anon_sym_This] = ACTIONS(2228),
    [anon_sym_decltype] = ACTIONS(2228),
    [sym_virtual] = ACTIONS(2228),
    [anon_sym_explicit] = ACTIONS(2228),
    [anon_sym_typename] = ACTIONS(2228),
    [anon_sym_template] = ACTIONS(2228),
    [anon_sym_operator] = ACTIONS(2228),
    [anon_sym_try] = ACTIONS(2228),
    [anon_sym_delete] = ACTIONS(2228),
    [anon_sym_throw] = ACTIONS(2228),
    [anon_sym_namespace] = ACTIONS(2228),
    [anon_sym_using] = ACTIONS(2228),
    [anon_sym_static_assert] = ACTIONS(2228),
    [anon_sym_concept] = ACTIONS(2228),
    [anon_sym_co_return] = ACTIONS(2228),
    [anon_sym_co_yield] = ACTIONS(2228),
    [anon_sym_R_DQUOTE] = ACTIONS(2230),
    [anon_sym_LR_DQUOTE] = ACTIONS(2230),
    [anon_sym_uR_DQUOTE] = ACTIONS(2230),
    [anon_sym_UR_DQUOTE] = ACTIONS(2230),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2230),
    [anon_sym_co_await] = ACTIONS(2228),
    [anon_sym_new] = ACTIONS(2228),
    [anon_sym_requires] = ACTIONS(2228),
    [sym_this] = ACTIONS(2228),
    [anon_sym_precise] = ACTIONS(2228),
    [anon_sym_shared] = ACTIONS(2228),
    [anon_sym_groupshared] = ACTIONS(2228),
    [anon_sym_uniform] = ACTIONS(2228),
    [anon_sym_row_major] = ACTIONS(2228),
    [anon_sym_column_major] = ACTIONS(2228),
    [anon_sym_globallycoherent] = ACTIONS(2228),
    [anon_sym_centroid] = ACTIONS(2228),
    [anon_sym_noperspective] = ACTIONS(2228),
    [anon_sym_nointerpolation] = ACTIONS(2228),
    [anon_sym_sample] = ACTIONS(2228),
    [anon_sym_linear] = ACTIONS(2228),
    [anon_sym_snorm] = ACTIONS(2228),
    [anon_sym_unorm] = ACTIONS(2228),
    [anon_sym_point] = ACTIONS(2228),
    [anon_sym_line] = ACTIONS(2228),
    [anon_sym_triangleadj] = ACTIONS(2228),
    [anon_sym_lineadj] = ACTIONS(2228),
    [anon_sym_triangle] = ACTIONS(2228),
    [anon_sym_interface] = ACTIONS(2228),
    [anon_sym_extension] = ACTIONS(2228),
    [anon_sym___exported] = ACTIONS(2228),
    [anon_sym_import] = ACTIONS(2228),
  },
  [134] = {
    [ts_builtin_sym_end] = ACTIONS(2217),
    [sym_identifier] = ACTIONS(2210),
    [aux_sym_preproc_include_token1] = ACTIONS(2210),
    [aux_sym_preproc_def_token1] = ACTIONS(2210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2212),
    [aux_sym_preproc_if_token1] = ACTIONS(2210),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2210),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2210),
    [sym_preproc_directive] = ACTIONS(2210),
    [anon_sym_LPAREN2] = ACTIONS(2214),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2217),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2219),
    [anon_sym_SLASH] = ACTIONS(2222),
    [anon_sym_PERCENT] = ACTIONS(2222),
    [anon_sym_PIPE_PIPE] = ACTIONS(2212),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2222),
    [anon_sym_CARET] = ACTIONS(2222),
    [anon_sym_AMP] = ACTIONS(2219),
    [anon_sym_EQ_EQ] = ACTIONS(2212),
    [anon_sym_BANG_EQ] = ACTIONS(2212),
    [anon_sym_GT] = ACTIONS(2222),
    [anon_sym_GT_EQ] = ACTIONS(2212),
    [anon_sym_LT_EQ] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(2222),
    [anon_sym_LT_LT] = ACTIONS(2222),
    [anon_sym_GT_GT] = ACTIONS(2222),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym___extension__] = ACTIONS(2210),
    [anon_sym_typedef] = ACTIONS(2210),
    [anon_sym_in] = ACTIONS(2210),
    [anon_sym_out] = ACTIONS(2210),
    [anon_sym_inout] = ACTIONS(2210),
    [anon_sym_extern] = ACTIONS(2210),
    [anon_sym___attribute__] = ACTIONS(2210),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2214),
    [anon_sym___declspec] = ACTIONS(2210),
    [anon_sym___based] = ACTIONS(2210),
    [anon_sym___cdecl] = ACTIONS(2210),
    [anon_sym___clrcall] = ACTIONS(2210),
    [anon_sym___stdcall] = ACTIONS(2210),
    [anon_sym___fastcall] = ACTIONS(2210),
    [anon_sym___thiscall] = ACTIONS(2210),
    [anon_sym___vectorcall] = ACTIONS(2210),
    [anon_sym_LBRACE] = ACTIONS(2217),
    [anon_sym_signed] = ACTIONS(2210),
    [anon_sym_unsigned] = ACTIONS(2210),
    [anon_sym_long] = ACTIONS(2210),
    [anon_sym_short] = ACTIONS(2210),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_static] = ACTIONS(2210),
    [anon_sym_EQ] = ACTIONS(2222),
    [anon_sym_register] = ACTIONS(2210),
    [anon_sym_inline] = ACTIONS(2210),
    [anon_sym___inline] = ACTIONS(2210),
    [anon_sym___inline__] = ACTIONS(2210),
    [anon_sym___forceinline] = ACTIONS(2210),
    [anon_sym_thread_local] = ACTIONS(2210),
    [anon_sym___thread] = ACTIONS(2210),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_constexpr] = ACTIONS(2210),
    [anon_sym_volatile] = ACTIONS(2210),
    [anon_sym_restrict] = ACTIONS(2210),
    [anon_sym___restrict__] = ACTIONS(2210),
    [anon_sym__Atomic] = ACTIONS(2210),
    [anon_sym__Noreturn] = ACTIONS(2210),
    [anon_sym_noreturn] = ACTIONS(2210),
    [anon_sym_mutable] = ACTIONS(2210),
    [anon_sym_constinit] = ACTIONS(2210),
    [anon_sym_consteval] = ACTIONS(2210),
    [anon_sym_alignas] = ACTIONS(2210),
    [anon_sym__Alignas] = ACTIONS(2210),
    [sym_primitive_type] = ACTIONS(2210),
    [anon_sym_enum] = ACTIONS(2210),
    [anon_sym_class] = ACTIONS(2210),
    [anon_sym_struct] = ACTIONS(2210),
    [anon_sym_union] = ACTIONS(2210),
    [anon_sym_if] = ACTIONS(2210),
    [anon_sym_switch] = ACTIONS(2210),
    [anon_sym_case] = ACTIONS(2210),
    [anon_sym_default] = ACTIONS(2210),
    [anon_sym_while] = ACTIONS(2210),
    [anon_sym_do] = ACTIONS(2210),
    [anon_sym_for] = ACTIONS(2210),
    [anon_sym_return] = ACTIONS(2210),
    [anon_sym_break] = ACTIONS(2210),
    [anon_sym_continue] = ACTIONS(2210),
    [anon_sym_goto] = ACTIONS(2210),
    [anon_sym_QMARK] = ACTIONS(2212),
    [anon_sym_STAR_EQ] = ACTIONS(2212),
    [anon_sym_SLASH_EQ] = ACTIONS(2212),
    [anon_sym_PERCENT_EQ] = ACTIONS(2212),
    [anon_sym_PLUS_EQ] = ACTIONS(2212),
    [anon_sym_DASH_EQ] = ACTIONS(2212),
    [anon_sym_LT_LT_EQ] = ACTIONS(2212),
    [anon_sym_GT_GT_EQ] = ACTIONS(2212),
    [anon_sym_AMP_EQ] = ACTIONS(2212),
    [anon_sym_CARET_EQ] = ACTIONS(2212),
    [anon_sym_PIPE_EQ] = ACTIONS(2212),
    [anon_sym_and_eq] = ACTIONS(2222),
    [anon_sym_or_eq] = ACTIONS(2222),
    [anon_sym_xor_eq] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2210),
    [anon_sym_compl] = ACTIONS(2210),
    [anon_sym_LT_EQ_GT] = ACTIONS(2212),
    [anon_sym_or] = ACTIONS(2222),
    [anon_sym_and] = ACTIONS(2222),
    [anon_sym_bitor] = ACTIONS(2222),
    [anon_sym_xor] = ACTIONS(2222),
    [anon_sym_bitand] = ACTIONS(2222),
    [anon_sym_not_eq] = ACTIONS(2222),
    [anon_sym_is] = ACTIONS(2222),
    [anon_sym_as] = ACTIONS(2222),
    [anon_sym_DASH_DASH] = ACTIONS(2214),
    [anon_sym_PLUS_PLUS] = ACTIONS(2214),
    [anon_sym_sizeof] = ACTIONS(2210),
    [anon_sym___alignof__] = ACTIONS(2210),
    [anon_sym___alignof] = ACTIONS(2210),
    [anon_sym__alignof] = ACTIONS(2210),
    [anon_sym_alignof] = ACTIONS(2210),
    [anon_sym__Alignof] = ACTIONS(2210),
    [anon_sym_offsetof] = ACTIONS(2210),
    [anon_sym__Generic] = ACTIONS(2210),
    [anon_sym_asm] = ACTIONS(2210),
    [anon_sym___asm__] = ACTIONS(2210),
    [anon_sym_DOT] = ACTIONS(2219),
    [anon_sym_DOT_STAR] = ACTIONS(2212),
    [anon_sym_DASH_GT] = ACTIONS(2212),
    [sym_number_literal] = ACTIONS(2217),
    [anon_sym_L_SQUOTE] = ACTIONS(2217),
    [anon_sym_u_SQUOTE] = ACTIONS(2217),
    [anon_sym_U_SQUOTE] = ACTIONS(2217),
    [anon_sym_u8_SQUOTE] = ACTIONS(2217),
    [anon_sym_SQUOTE] = ACTIONS(2217),
    [anon_sym_L_DQUOTE] = ACTIONS(2217),
    [anon_sym_u_DQUOTE] = ACTIONS(2217),
    [anon_sym_U_DQUOTE] = ACTIONS(2217),
    [anon_sym_u8_DQUOTE] = ACTIONS(2217),
    [anon_sym_DQUOTE] = ACTIONS(2217),
    [sym_true] = ACTIONS(2210),
    [sym_false] = ACTIONS(2210),
    [anon_sym_NULL] = ACTIONS(2210),
    [anon_sym_nullptr] = ACTIONS(2210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2210),
    [anon_sym_let] = ACTIONS(2210),
    [anon_sym_This] = ACTIONS(2210),
    [anon_sym_decltype] = ACTIONS(2210),
    [sym_virtual] = ACTIONS(2210),
    [anon_sym_explicit] = ACTIONS(2210),
    [anon_sym_typename] = ACTIONS(2210),
    [anon_sym_template] = ACTIONS(2210),
    [anon_sym_operator] = ACTIONS(2210),
    [anon_sym_try] = ACTIONS(2210),
    [anon_sym_delete] = ACTIONS(2210),
    [anon_sym_throw] = ACTIONS(2210),
    [anon_sym_namespace] = ACTIONS(2210),
    [anon_sym_using] = ACTIONS(2210),
    [anon_sym_static_assert] = ACTIONS(2210),
    [anon_sym_concept] = ACTIONS(2210),
    [anon_sym_co_return] = ACTIONS(2210),
    [anon_sym_co_yield] = ACTIONS(2210),
    [anon_sym_R_DQUOTE] = ACTIONS(2217),
    [anon_sym_LR_DQUOTE] = ACTIONS(2217),
    [anon_sym_uR_DQUOTE] = ACTIONS(2217),
    [anon_sym_UR_DQUOTE] = ACTIONS(2217),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2217),
    [anon_sym_co_await] = ACTIONS(2210),
    [anon_sym_new] = ACTIONS(2210),
    [anon_sym_requires] = ACTIONS(2210),
    [sym_this] = ACTIONS(2210),
    [anon_sym_precise] = ACTIONS(2210),
    [anon_sym_shared] = ACTIONS(2210),
    [anon_sym_groupshared] = ACTIONS(2210),
    [anon_sym_uniform] = ACTIONS(2210),
    [anon_sym_row_major] = ACTIONS(2210),
    [anon_sym_column_major] = ACTIONS(2210),
    [anon_sym_globallycoherent] = ACTIONS(2210),
    [anon_sym_centroid] = ACTIONS(2210),
    [anon_sym_noperspective] = ACTIONS(2210),
    [anon_sym_nointerpolation] = ACTIONS(2210),
    [anon_sym_sample] = ACTIONS(2210),
    [anon_sym_linear] = ACTIONS(2210),
    [anon_sym_snorm] = ACTIONS(2210),
    [anon_sym_unorm] = ACTIONS(2210),
    [anon_sym_point] = ACTIONS(2210),
    [anon_sym_line] = ACTIONS(2210),
    [anon_sym_triangleadj] = ACTIONS(2210),
    [anon_sym_lineadj] = ACTIONS(2210),
    [anon_sym_triangle] = ACTIONS(2210),
    [anon_sym_interface] = ACTIONS(2210),
    [anon_sym_extension] = ACTIONS(2210),
    [anon_sym___exported] = ACTIONS(2210),
    [anon_sym_import] = ACTIONS(2210),
  },
  [135] = {
    [ts_builtin_sym_end] = ACTIONS(2204),
    [sym_identifier] = ACTIONS(2202),
    [aux_sym_preproc_include_token1] = ACTIONS(2202),
    [aux_sym_preproc_def_token1] = ACTIONS(2202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2204),
    [aux_sym_preproc_if_token1] = ACTIONS(2202),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2202),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2202),
    [sym_preproc_directive] = ACTIONS(2202),
    [anon_sym_LPAREN2] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2202),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2202),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_STAR] = ACTIONS(2202),
    [anon_sym_SLASH] = ACTIONS(2202),
    [anon_sym_PERCENT] = ACTIONS(2202),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2202),
    [anon_sym_CARET] = ACTIONS(2202),
    [anon_sym_AMP] = ACTIONS(2202),
    [anon_sym_EQ_EQ] = ACTIONS(2204),
    [anon_sym_BANG_EQ] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(2202),
    [anon_sym_GT_EQ] = ACTIONS(2204),
    [anon_sym_LT_EQ] = ACTIONS(2202),
    [anon_sym_LT] = ACTIONS(2202),
    [anon_sym_LT_LT] = ACTIONS(2202),
    [anon_sym_GT_GT] = ACTIONS(2202),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym___extension__] = ACTIONS(2202),
    [anon_sym_typedef] = ACTIONS(2202),
    [anon_sym_in] = ACTIONS(2202),
    [anon_sym_out] = ACTIONS(2202),
    [anon_sym_inout] = ACTIONS(2202),
    [anon_sym_extern] = ACTIONS(2202),
    [anon_sym___attribute__] = ACTIONS(2202),
    [anon_sym_COLON_COLON] = ACTIONS(2204),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2204),
    [anon_sym___declspec] = ACTIONS(2202),
    [anon_sym___based] = ACTIONS(2202),
    [anon_sym___cdecl] = ACTIONS(2202),
    [anon_sym___clrcall] = ACTIONS(2202),
    [anon_sym___stdcall] = ACTIONS(2202),
    [anon_sym___fastcall] = ACTIONS(2202),
    [anon_sym___thiscall] = ACTIONS(2202),
    [anon_sym___vectorcall] = ACTIONS(2202),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_signed] = ACTIONS(2202),
    [anon_sym_unsigned] = ACTIONS(2202),
    [anon_sym_long] = ACTIONS(2202),
    [anon_sym_short] = ACTIONS(2202),
    [anon_sym_LBRACK] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2202),
    [anon_sym_EQ] = ACTIONS(2202),
    [anon_sym_register] = ACTIONS(2202),
    [anon_sym_inline] = ACTIONS(2202),
    [anon_sym___inline] = ACTIONS(2202),
    [anon_sym___inline__] = ACTIONS(2202),
    [anon_sym___forceinline] = ACTIONS(2202),
    [anon_sym_thread_local] = ACTIONS(2202),
    [anon_sym___thread] = ACTIONS(2202),
    [anon_sym_const] = ACTIONS(2202),
    [anon_sym_constexpr] = ACTIONS(2202),
    [anon_sym_volatile] = ACTIONS(2202),
    [anon_sym_restrict] = ACTIONS(2202),
    [anon_sym___restrict__] = ACTIONS(2202),
    [anon_sym__Atomic] = ACTIONS(2202),
    [anon_sym__Noreturn] = ACTIONS(2202),
    [anon_sym_noreturn] = ACTIONS(2202),
    [anon_sym_mutable] = ACTIONS(2202),
    [anon_sym_constinit] = ACTIONS(2202),
    [anon_sym_consteval] = ACTIONS(2202),
    [anon_sym_alignas] = ACTIONS(2202),
    [anon_sym__Alignas] = ACTIONS(2202),
    [sym_primitive_type] = ACTIONS(2202),
    [anon_sym_enum] = ACTIONS(2202),
    [anon_sym_class] = ACTIONS(2202),
    [anon_sym_struct] = ACTIONS(2202),
    [anon_sym_union] = ACTIONS(2202),
    [anon_sym_if] = ACTIONS(2202),
    [anon_sym_switch] = ACTIONS(2202),
    [anon_sym_case] = ACTIONS(2202),
    [anon_sym_default] = ACTIONS(2202),
    [anon_sym_while] = ACTIONS(2202),
    [anon_sym_do] = ACTIONS(2202),
    [anon_sym_for] = ACTIONS(2202),
    [anon_sym_return] = ACTIONS(2202),
    [anon_sym_break] = ACTIONS(2202),
    [anon_sym_continue] = ACTIONS(2202),
    [anon_sym_goto] = ACTIONS(2202),
    [anon_sym_QMARK] = ACTIONS(2204),
    [anon_sym_STAR_EQ] = ACTIONS(2204),
    [anon_sym_SLASH_EQ] = ACTIONS(2204),
    [anon_sym_PERCENT_EQ] = ACTIONS(2204),
    [anon_sym_PLUS_EQ] = ACTIONS(2204),
    [anon_sym_DASH_EQ] = ACTIONS(2204),
    [anon_sym_LT_LT_EQ] = ACTIONS(2204),
    [anon_sym_GT_GT_EQ] = ACTIONS(2204),
    [anon_sym_AMP_EQ] = ACTIONS(2204),
    [anon_sym_CARET_EQ] = ACTIONS(2204),
    [anon_sym_PIPE_EQ] = ACTIONS(2204),
    [anon_sym_and_eq] = ACTIONS(2202),
    [anon_sym_or_eq] = ACTIONS(2202),
    [anon_sym_xor_eq] = ACTIONS(2202),
    [anon_sym_not] = ACTIONS(2202),
    [anon_sym_compl] = ACTIONS(2202),
    [anon_sym_LT_EQ_GT] = ACTIONS(2204),
    [anon_sym_or] = ACTIONS(2202),
    [anon_sym_and] = ACTIONS(2202),
    [anon_sym_bitor] = ACTIONS(2202),
    [anon_sym_xor] = ACTIONS(2202),
    [anon_sym_bitand] = ACTIONS(2202),
    [anon_sym_not_eq] = ACTIONS(2202),
    [anon_sym_is] = ACTIONS(2202),
    [anon_sym_as] = ACTIONS(2202),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_sizeof] = ACTIONS(2202),
    [anon_sym___alignof__] = ACTIONS(2202),
    [anon_sym___alignof] = ACTIONS(2202),
    [anon_sym__alignof] = ACTIONS(2202),
    [anon_sym_alignof] = ACTIONS(2202),
    [anon_sym__Alignof] = ACTIONS(2202),
    [anon_sym_offsetof] = ACTIONS(2202),
    [anon_sym__Generic] = ACTIONS(2202),
    [anon_sym_asm] = ACTIONS(2202),
    [anon_sym___asm__] = ACTIONS(2202),
    [anon_sym_DOT] = ACTIONS(2202),
    [anon_sym_DOT_STAR] = ACTIONS(2204),
    [anon_sym_DASH_GT] = ACTIONS(2204),
    [sym_number_literal] = ACTIONS(2204),
    [anon_sym_L_SQUOTE] = ACTIONS(2204),
    [anon_sym_u_SQUOTE] = ACTIONS(2204),
    [anon_sym_U_SQUOTE] = ACTIONS(2204),
    [anon_sym_u8_SQUOTE] = ACTIONS(2204),
    [anon_sym_SQUOTE] = ACTIONS(2204),
    [anon_sym_L_DQUOTE] = ACTIONS(2204),
    [anon_sym_u_DQUOTE] = ACTIONS(2204),
    [anon_sym_U_DQUOTE] = ACTIONS(2204),
    [anon_sym_u8_DQUOTE] = ACTIONS(2204),
    [anon_sym_DQUOTE] = ACTIONS(2204),
    [sym_true] = ACTIONS(2202),
    [sym_false] = ACTIONS(2202),
    [anon_sym_NULL] = ACTIONS(2202),
    [anon_sym_nullptr] = ACTIONS(2202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2202),
    [anon_sym_let] = ACTIONS(2202),
    [anon_sym_This] = ACTIONS(2202),
    [anon_sym_decltype] = ACTIONS(2202),
    [sym_virtual] = ACTIONS(2202),
    [anon_sym_explicit] = ACTIONS(2202),
    [anon_sym_typename] = ACTIONS(2202),
    [anon_sym_template] = ACTIONS(2202),
    [anon_sym_operator] = ACTIONS(2202),
    [anon_sym_try] = ACTIONS(2202),
    [anon_sym_delete] = ACTIONS(2202),
    [anon_sym_throw] = ACTIONS(2202),
    [anon_sym_namespace] = ACTIONS(2202),
    [anon_sym_using] = ACTIONS(2202),
    [anon_sym_static_assert] = ACTIONS(2202),
    [anon_sym_concept] = ACTIONS(2202),
    [anon_sym_co_return] = ACTIONS(2202),
    [anon_sym_co_yield] = ACTIONS(2202),
    [anon_sym_R_DQUOTE] = ACTIONS(2204),
    [anon_sym_LR_DQUOTE] = ACTIONS(2204),
    [anon_sym_uR_DQUOTE] = ACTIONS(2204),
    [anon_sym_UR_DQUOTE] = ACTIONS(2204),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2204),
    [anon_sym_co_await] = ACTIONS(2202),
    [anon_sym_new] = ACTIONS(2202),
    [anon_sym_requires] = ACTIONS(2202),
    [sym_this] = ACTIONS(2202),
    [anon_sym_precise] = ACTIONS(2202),
    [anon_sym_shared] = ACTIONS(2202),
    [anon_sym_groupshared] = ACTIONS(2202),
    [anon_sym_uniform] = ACTIONS(2202),
    [anon_sym_row_major] = ACTIONS(2202),
    [anon_sym_column_major] = ACTIONS(2202),
    [anon_sym_globallycoherent] = ACTIONS(2202),
    [anon_sym_centroid] = ACTIONS(2202),
    [anon_sym_noperspective] = ACTIONS(2202),
    [anon_sym_nointerpolation] = ACTIONS(2202),
    [anon_sym_sample] = ACTIONS(2202),
    [anon_sym_linear] = ACTIONS(2202),
    [anon_sym_snorm] = ACTIONS(2202),
    [anon_sym_unorm] = ACTIONS(2202),
    [anon_sym_point] = ACTIONS(2202),
    [anon_sym_line] = ACTIONS(2202),
    [anon_sym_triangleadj] = ACTIONS(2202),
    [anon_sym_lineadj] = ACTIONS(2202),
    [anon_sym_triangle] = ACTIONS(2202),
    [anon_sym_interface] = ACTIONS(2202),
    [anon_sym_extension] = ACTIONS(2202),
    [anon_sym___exported] = ACTIONS(2202),
    [anon_sym_import] = ACTIONS(2202),
  },
  [136] = {
    [ts_builtin_sym_end] = ACTIONS(2226),
    [sym_identifier] = ACTIONS(2224),
    [aux_sym_preproc_include_token1] = ACTIONS(2224),
    [aux_sym_preproc_def_token1] = ACTIONS(2224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2226),
    [aux_sym_preproc_if_token1] = ACTIONS(2224),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2224),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2224),
    [sym_preproc_directive] = ACTIONS(2224),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_PLUS] = ACTIONS(2224),
    [anon_sym_STAR] = ACTIONS(2224),
    [anon_sym_SLASH] = ACTIONS(2224),
    [anon_sym_PERCENT] = ACTIONS(2224),
    [anon_sym_PIPE_PIPE] = ACTIONS(2226),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_PIPE] = ACTIONS(2224),
    [anon_sym_CARET] = ACTIONS(2224),
    [anon_sym_AMP] = ACTIONS(2224),
    [anon_sym_EQ_EQ] = ACTIONS(2226),
    [anon_sym_BANG_EQ] = ACTIONS(2226),
    [anon_sym_GT] = ACTIONS(2224),
    [anon_sym_GT_EQ] = ACTIONS(2226),
    [anon_sym_LT_EQ] = ACTIONS(2224),
    [anon_sym_LT] = ACTIONS(2224),
    [anon_sym_LT_LT] = ACTIONS(2224),
    [anon_sym_GT_GT] = ACTIONS(2224),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym___extension__] = ACTIONS(2224),
    [anon_sym_typedef] = ACTIONS(2224),
    [anon_sym_in] = ACTIONS(2224),
    [anon_sym_out] = ACTIONS(2224),
    [anon_sym_inout] = ACTIONS(2224),
    [anon_sym_extern] = ACTIONS(2224),
    [anon_sym___attribute__] = ACTIONS(2224),
    [anon_sym_COLON_COLON] = ACTIONS(2226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2226),
    [anon_sym___declspec] = ACTIONS(2224),
    [anon_sym___based] = ACTIONS(2224),
    [anon_sym___cdecl] = ACTIONS(2224),
    [anon_sym___clrcall] = ACTIONS(2224),
    [anon_sym___stdcall] = ACTIONS(2224),
    [anon_sym___fastcall] = ACTIONS(2224),
    [anon_sym___thiscall] = ACTIONS(2224),
    [anon_sym___vectorcall] = ACTIONS(2224),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_signed] = ACTIONS(2224),
    [anon_sym_unsigned] = ACTIONS(2224),
    [anon_sym_long] = ACTIONS(2224),
    [anon_sym_short] = ACTIONS(2224),
    [anon_sym_LBRACK] = ACTIONS(2224),
    [anon_sym_static] = ACTIONS(2224),
    [anon_sym_EQ] = ACTIONS(2224),
    [anon_sym_register] = ACTIONS(2224),
    [anon_sym_inline] = ACTIONS(2224),
    [anon_sym___inline] = ACTIONS(2224),
    [anon_sym___inline__] = ACTIONS(2224),
    [anon_sym___forceinline] = ACTIONS(2224),
    [anon_sym_thread_local] = ACTIONS(2224),
    [anon_sym___thread] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_constexpr] = ACTIONS(2224),
    [anon_sym_volatile] = ACTIONS(2224),
    [anon_sym_restrict] = ACTIONS(2224),
    [anon_sym___restrict__] = ACTIONS(2224),
    [anon_sym__Atomic] = ACTIONS(2224),
    [anon_sym__Noreturn] = ACTIONS(2224),
    [anon_sym_noreturn] = ACTIONS(2224),
    [anon_sym_mutable] = ACTIONS(2224),
    [anon_sym_constinit] = ACTIONS(2224),
    [anon_sym_consteval] = ACTIONS(2224),
    [anon_sym_alignas] = ACTIONS(2224),
    [anon_sym__Alignas] = ACTIONS(2224),
    [sym_primitive_type] = ACTIONS(2224),
    [anon_sym_enum] = ACTIONS(2224),
    [anon_sym_class] = ACTIONS(2224),
    [anon_sym_struct] = ACTIONS(2224),
    [anon_sym_union] = ACTIONS(2224),
    [anon_sym_if] = ACTIONS(2224),
    [anon_sym_switch] = ACTIONS(2224),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2224),
    [anon_sym_while] = ACTIONS(2224),
    [anon_sym_do] = ACTIONS(2224),
    [anon_sym_for] = ACTIONS(2224),
    [anon_sym_return] = ACTIONS(2224),
    [anon_sym_break] = ACTIONS(2224),
    [anon_sym_continue] = ACTIONS(2224),
    [anon_sym_goto] = ACTIONS(2224),
    [anon_sym_QMARK] = ACTIONS(2226),
    [anon_sym_STAR_EQ] = ACTIONS(2226),
    [anon_sym_SLASH_EQ] = ACTIONS(2226),
    [anon_sym_PERCENT_EQ] = ACTIONS(2226),
    [anon_sym_PLUS_EQ] = ACTIONS(2226),
    [anon_sym_DASH_EQ] = ACTIONS(2226),
    [anon_sym_LT_LT_EQ] = ACTIONS(2226),
    [anon_sym_GT_GT_EQ] = ACTIONS(2226),
    [anon_sym_AMP_EQ] = ACTIONS(2226),
    [anon_sym_CARET_EQ] = ACTIONS(2226),
    [anon_sym_PIPE_EQ] = ACTIONS(2226),
    [anon_sym_and_eq] = ACTIONS(2224),
    [anon_sym_or_eq] = ACTIONS(2224),
    [anon_sym_xor_eq] = ACTIONS(2224),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_compl] = ACTIONS(2224),
    [anon_sym_LT_EQ_GT] = ACTIONS(2226),
    [anon_sym_or] = ACTIONS(2224),
    [anon_sym_and] = ACTIONS(2224),
    [anon_sym_bitor] = ACTIONS(2224),
    [anon_sym_xor] = ACTIONS(2224),
    [anon_sym_bitand] = ACTIONS(2224),
    [anon_sym_not_eq] = ACTIONS(2224),
    [anon_sym_is] = ACTIONS(2224),
    [anon_sym_as] = ACTIONS(2224),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_sizeof] = ACTIONS(2224),
    [anon_sym___alignof__] = ACTIONS(2224),
    [anon_sym___alignof] = ACTIONS(2224),
    [anon_sym__alignof] = ACTIONS(2224),
    [anon_sym_alignof] = ACTIONS(2224),
    [anon_sym__Alignof] = ACTIONS(2224),
    [anon_sym_offsetof] = ACTIONS(2224),
    [anon_sym__Generic] = ACTIONS(2224),
    [anon_sym_asm] = ACTIONS(2224),
    [anon_sym___asm__] = ACTIONS(2224),
    [anon_sym_DOT] = ACTIONS(2224),
    [anon_sym_DOT_STAR] = ACTIONS(2226),
    [anon_sym_DASH_GT] = ACTIONS(2226),
    [sym_number_literal] = ACTIONS(2226),
    [anon_sym_L_SQUOTE] = ACTIONS(2226),
    [anon_sym_u_SQUOTE] = ACTIONS(2226),
    [anon_sym_U_SQUOTE] = ACTIONS(2226),
    [anon_sym_u8_SQUOTE] = ACTIONS(2226),
    [anon_sym_SQUOTE] = ACTIONS(2226),
    [anon_sym_L_DQUOTE] = ACTIONS(2226),
    [anon_sym_u_DQUOTE] = ACTIONS(2226),
    [anon_sym_U_DQUOTE] = ACTIONS(2226),
    [anon_sym_u8_DQUOTE] = ACTIONS(2226),
    [anon_sym_DQUOTE] = ACTIONS(2226),
    [sym_true] = ACTIONS(2224),
    [sym_false] = ACTIONS(2224),
    [anon_sym_NULL] = ACTIONS(2224),
    [anon_sym_nullptr] = ACTIONS(2224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2224),
    [anon_sym_let] = ACTIONS(2224),
    [anon_sym_This] = ACTIONS(2224),
    [anon_sym_decltype] = ACTIONS(2224),
    [sym_virtual] = ACTIONS(2224),
    [anon_sym_explicit] = ACTIONS(2224),
    [anon_sym_typename] = ACTIONS(2224),
    [anon_sym_template] = ACTIONS(2224),
    [anon_sym_operator] = ACTIONS(2224),
    [anon_sym_try] = ACTIONS(2224),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_throw] = ACTIONS(2224),
    [anon_sym_namespace] = ACTIONS(2224),
    [anon_sym_using] = ACTIONS(2224),
    [anon_sym_static_assert] = ACTIONS(2224),
    [anon_sym_concept] = ACTIONS(2224),
    [anon_sym_co_return] = ACTIONS(2224),
    [anon_sym_co_yield] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(2226),
    [anon_sym_LR_DQUOTE] = ACTIONS(2226),
    [anon_sym_uR_DQUOTE] = ACTIONS(2226),
    [anon_sym_UR_DQUOTE] = ACTIONS(2226),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2226),
    [anon_sym_co_await] = ACTIONS(2224),
    [anon_sym_new] = ACTIONS(2224),
    [anon_sym_requires] = ACTIONS(2224),
    [sym_this] = ACTIONS(2224),
    [anon_sym_precise] = ACTIONS(2224),
    [anon_sym_shared] = ACTIONS(2224),
    [anon_sym_groupshared] = ACTIONS(2224),
    [anon_sym_uniform] = ACTIONS(2224),
    [anon_sym_row_major] = ACTIONS(2224),
    [anon_sym_column_major] = ACTIONS(2224),
    [anon_sym_globallycoherent] = ACTIONS(2224),
    [anon_sym_centroid] = ACTIONS(2224),
    [anon_sym_noperspective] = ACTIONS(2224),
    [anon_sym_nointerpolation] = ACTIONS(2224),
    [anon_sym_sample] = ACTIONS(2224),
    [anon_sym_linear] = ACTIONS(2224),
    [anon_sym_snorm] = ACTIONS(2224),
    [anon_sym_unorm] = ACTIONS(2224),
    [anon_sym_point] = ACTIONS(2224),
    [anon_sym_line] = ACTIONS(2224),
    [anon_sym_triangleadj] = ACTIONS(2224),
    [anon_sym_lineadj] = ACTIONS(2224),
    [anon_sym_triangle] = ACTIONS(2224),
    [anon_sym_interface] = ACTIONS(2224),
    [anon_sym_extension] = ACTIONS(2224),
    [anon_sym___exported] = ACTIONS(2224),
    [anon_sym_import] = ACTIONS(2224),
  },
  [137] = {
    [ts_builtin_sym_end] = ACTIONS(2238),
    [sym_identifier] = ACTIONS(2236),
    [aux_sym_preproc_include_token1] = ACTIONS(2236),
    [aux_sym_preproc_def_token1] = ACTIONS(2236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2238),
    [aux_sym_preproc_if_token1] = ACTIONS(2236),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2236),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2236),
    [sym_preproc_directive] = ACTIONS(2236),
    [anon_sym_LPAREN2] = ACTIONS(2238),
    [anon_sym_BANG] = ACTIONS(2236),
    [anon_sym_TILDE] = ACTIONS(2238),
    [anon_sym_DASH] = ACTIONS(2236),
    [anon_sym_PLUS] = ACTIONS(2236),
    [anon_sym_STAR] = ACTIONS(2236),
    [anon_sym_SLASH] = ACTIONS(2236),
    [anon_sym_PERCENT] = ACTIONS(2236),
    [anon_sym_PIPE_PIPE] = ACTIONS(2238),
    [anon_sym_AMP_AMP] = ACTIONS(2238),
    [anon_sym_PIPE] = ACTIONS(2236),
    [anon_sym_CARET] = ACTIONS(2236),
    [anon_sym_AMP] = ACTIONS(2236),
    [anon_sym_EQ_EQ] = ACTIONS(2238),
    [anon_sym_BANG_EQ] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2236),
    [anon_sym_GT_EQ] = ACTIONS(2238),
    [anon_sym_LT_EQ] = ACTIONS(2236),
    [anon_sym_LT] = ACTIONS(2236),
    [anon_sym_LT_LT] = ACTIONS(2236),
    [anon_sym_GT_GT] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(2238),
    [anon_sym___extension__] = ACTIONS(2236),
    [anon_sym_typedef] = ACTIONS(2236),
    [anon_sym_in] = ACTIONS(2236),
    [anon_sym_out] = ACTIONS(2236),
    [anon_sym_inout] = ACTIONS(2236),
    [anon_sym_extern] = ACTIONS(2236),
    [anon_sym___attribute__] = ACTIONS(2236),
    [anon_sym_COLON_COLON] = ACTIONS(2238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2238),
    [anon_sym___declspec] = ACTIONS(2236),
    [anon_sym___based] = ACTIONS(2236),
    [anon_sym___cdecl] = ACTIONS(2236),
    [anon_sym___clrcall] = ACTIONS(2236),
    [anon_sym___stdcall] = ACTIONS(2236),
    [anon_sym___fastcall] = ACTIONS(2236),
    [anon_sym___thiscall] = ACTIONS(2236),
    [anon_sym___vectorcall] = ACTIONS(2236),
    [anon_sym_LBRACE] = ACTIONS(2238),
    [anon_sym_signed] = ACTIONS(2236),
    [anon_sym_unsigned] = ACTIONS(2236),
    [anon_sym_long] = ACTIONS(2236),
    [anon_sym_short] = ACTIONS(2236),
    [anon_sym_LBRACK] = ACTIONS(2236),
    [anon_sym_static] = ACTIONS(2236),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_register] = ACTIONS(2236),
    [anon_sym_inline] = ACTIONS(2236),
    [anon_sym___inline] = ACTIONS(2236),
    [anon_sym___inline__] = ACTIONS(2236),
    [anon_sym___forceinline] = ACTIONS(2236),
    [anon_sym_thread_local] = ACTIONS(2236),
    [anon_sym___thread] = ACTIONS(2236),
    [anon_sym_const] = ACTIONS(2236),
    [anon_sym_constexpr] = ACTIONS(2236),
    [anon_sym_volatile] = ACTIONS(2236),
    [anon_sym_restrict] = ACTIONS(2236),
    [anon_sym___restrict__] = ACTIONS(2236),
    [anon_sym__Atomic] = ACTIONS(2236),
    [anon_sym__Noreturn] = ACTIONS(2236),
    [anon_sym_noreturn] = ACTIONS(2236),
    [anon_sym_mutable] = ACTIONS(2236),
    [anon_sym_constinit] = ACTIONS(2236),
    [anon_sym_consteval] = ACTIONS(2236),
    [anon_sym_alignas] = ACTIONS(2236),
    [anon_sym__Alignas] = ACTIONS(2236),
    [sym_primitive_type] = ACTIONS(2236),
    [anon_sym_enum] = ACTIONS(2236),
    [anon_sym_class] = ACTIONS(2236),
    [anon_sym_struct] = ACTIONS(2236),
    [anon_sym_union] = ACTIONS(2236),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_switch] = ACTIONS(2236),
    [anon_sym_case] = ACTIONS(2236),
    [anon_sym_default] = ACTIONS(2236),
    [anon_sym_while] = ACTIONS(2236),
    [anon_sym_do] = ACTIONS(2236),
    [anon_sym_for] = ACTIONS(2236),
    [anon_sym_return] = ACTIONS(2236),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2236),
    [anon_sym_goto] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2238),
    [anon_sym_SLASH_EQ] = ACTIONS(2238),
    [anon_sym_PERCENT_EQ] = ACTIONS(2238),
    [anon_sym_PLUS_EQ] = ACTIONS(2238),
    [anon_sym_DASH_EQ] = ACTIONS(2238),
    [anon_sym_LT_LT_EQ] = ACTIONS(2238),
    [anon_sym_GT_GT_EQ] = ACTIONS(2238),
    [anon_sym_AMP_EQ] = ACTIONS(2238),
    [anon_sym_CARET_EQ] = ACTIONS(2238),
    [anon_sym_PIPE_EQ] = ACTIONS(2238),
    [anon_sym_and_eq] = ACTIONS(2236),
    [anon_sym_or_eq] = ACTIONS(2236),
    [anon_sym_xor_eq] = ACTIONS(2236),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_compl] = ACTIONS(2236),
    [anon_sym_LT_EQ_GT] = ACTIONS(2238),
    [anon_sym_or] = ACTIONS(2236),
    [anon_sym_and] = ACTIONS(2236),
    [anon_sym_bitor] = ACTIONS(2236),
    [anon_sym_xor] = ACTIONS(2236),
    [anon_sym_bitand] = ACTIONS(2236),
    [anon_sym_not_eq] = ACTIONS(2236),
    [anon_sym_is] = ACTIONS(2236),
    [anon_sym_as] = ACTIONS(2236),
    [anon_sym_DASH_DASH] = ACTIONS(2238),
    [anon_sym_PLUS_PLUS] = ACTIONS(2238),
    [anon_sym_sizeof] = ACTIONS(2236),
    [anon_sym___alignof__] = ACTIONS(2236),
    [anon_sym___alignof] = ACTIONS(2236),
    [anon_sym__alignof] = ACTIONS(2236),
    [anon_sym_alignof] = ACTIONS(2236),
    [anon_sym__Alignof] = ACTIONS(2236),
    [anon_sym_offsetof] = ACTIONS(2236),
    [anon_sym__Generic] = ACTIONS(2236),
    [anon_sym_asm] = ACTIONS(2236),
    [anon_sym___asm__] = ACTIONS(2236),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_DOT_STAR] = ACTIONS(2238),
    [anon_sym_DASH_GT] = ACTIONS(2238),
    [sym_number_literal] = ACTIONS(2238),
    [anon_sym_L_SQUOTE] = ACTIONS(2238),
    [anon_sym_u_SQUOTE] = ACTIONS(2238),
    [anon_sym_U_SQUOTE] = ACTIONS(2238),
    [anon_sym_u8_SQUOTE] = ACTIONS(2238),
    [anon_sym_SQUOTE] = ACTIONS(2238),
    [anon_sym_L_DQUOTE] = ACTIONS(2238),
    [anon_sym_u_DQUOTE] = ACTIONS(2238),
    [anon_sym_U_DQUOTE] = ACTIONS(2238),
    [anon_sym_u8_DQUOTE] = ACTIONS(2238),
    [anon_sym_DQUOTE] = ACTIONS(2238),
    [sym_true] = ACTIONS(2236),
    [sym_false] = ACTIONS(2236),
    [anon_sym_NULL] = ACTIONS(2236),
    [anon_sym_nullptr] = ACTIONS(2236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2236),
    [anon_sym_let] = ACTIONS(2236),
    [anon_sym_This] = ACTIONS(2236),
    [anon_sym_decltype] = ACTIONS(2236),
    [sym_virtual] = ACTIONS(2236),
    [anon_sym_explicit] = ACTIONS(2236),
    [anon_sym_typename] = ACTIONS(2236),
    [anon_sym_template] = ACTIONS(2236),
    [anon_sym_operator] = ACTIONS(2236),
    [anon_sym_try] = ACTIONS(2236),
    [anon_sym_delete] = ACTIONS(2236),
    [anon_sym_throw] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(2236),
    [anon_sym_using] = ACTIONS(2236),
    [anon_sym_static_assert] = ACTIONS(2236),
    [anon_sym_concept] = ACTIONS(2236),
    [anon_sym_co_return] = ACTIONS(2236),
    [anon_sym_co_yield] = ACTIONS(2236),
    [anon_sym_R_DQUOTE] = ACTIONS(2238),
    [anon_sym_LR_DQUOTE] = ACTIONS(2238),
    [anon_sym_uR_DQUOTE] = ACTIONS(2238),
    [anon_sym_UR_DQUOTE] = ACTIONS(2238),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2238),
    [anon_sym_co_await] = ACTIONS(2236),
    [anon_sym_new] = ACTIONS(2236),
    [anon_sym_requires] = ACTIONS(2236),
    [sym_this] = ACTIONS(2236),
    [anon_sym_precise] = ACTIONS(2236),
    [anon_sym_shared] = ACTIONS(2236),
    [anon_sym_groupshared] = ACTIONS(2236),
    [anon_sym_uniform] = ACTIONS(2236),
    [anon_sym_row_major] = ACTIONS(2236),
    [anon_sym_column_major] = ACTIONS(2236),
    [anon_sym_globallycoherent] = ACTIONS(2236),
    [anon_sym_centroid] = ACTIONS(2236),
    [anon_sym_noperspective] = ACTIONS(2236),
    [anon_sym_nointerpolation] = ACTIONS(2236),
    [anon_sym_sample] = ACTIONS(2236),
    [anon_sym_linear] = ACTIONS(2236),
    [anon_sym_snorm] = ACTIONS(2236),
    [anon_sym_unorm] = ACTIONS(2236),
    [anon_sym_point] = ACTIONS(2236),
    [anon_sym_line] = ACTIONS(2236),
    [anon_sym_triangleadj] = ACTIONS(2236),
    [anon_sym_lineadj] = ACTIONS(2236),
    [anon_sym_triangle] = ACTIONS(2236),
    [anon_sym_interface] = ACTIONS(2236),
    [anon_sym_extension] = ACTIONS(2236),
    [anon_sym___exported] = ACTIONS(2236),
    [anon_sym_import] = ACTIONS(2236),
  },
  [138] = {
    [sym_declaration] = STATE(729),
    [sym_type_definition] = STATE(3007),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6190),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_expression_statement] = STATE(3007),
    [sym__for_statement_body] = STATE(10265),
    [sym_expression] = STATE(5444),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10135),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_alias_declaration] = STATE(3007),
    [sym__for_range_loop_body] = STATE(10264),
    [sym_init_statement] = STATE(1936),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(2263),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(2265),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2269),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2273),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_using] = ACTIONS(2275),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [139] = {
    [ts_builtin_sym_end] = ACTIONS(2188),
    [sym_identifier] = ACTIONS(2186),
    [aux_sym_preproc_include_token1] = ACTIONS(2186),
    [aux_sym_preproc_def_token1] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [aux_sym_preproc_if_token1] = ACTIONS(2186),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2186),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2186),
    [sym_preproc_directive] = ACTIONS(2186),
    [anon_sym_LPAREN2] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2186),
    [anon_sym_TILDE] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2186),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_STAR] = ACTIONS(2188),
    [anon_sym_SLASH] = ACTIONS(2186),
    [anon_sym_PERCENT] = ACTIONS(2188),
    [anon_sym_PIPE_PIPE] = ACTIONS(2188),
    [anon_sym_AMP_AMP] = ACTIONS(2188),
    [anon_sym_PIPE] = ACTIONS(2186),
    [anon_sym_CARET] = ACTIONS(2188),
    [anon_sym_AMP] = ACTIONS(2186),
    [anon_sym_EQ_EQ] = ACTIONS(2188),
    [anon_sym_BANG_EQ] = ACTIONS(2188),
    [anon_sym_GT] = ACTIONS(2186),
    [anon_sym_GT_EQ] = ACTIONS(2188),
    [anon_sym_LT_EQ] = ACTIONS(2186),
    [anon_sym_LT] = ACTIONS(2186),
    [anon_sym_LT_LT] = ACTIONS(2188),
    [anon_sym_GT_GT] = ACTIONS(2188),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym___extension__] = ACTIONS(2186),
    [anon_sym_typedef] = ACTIONS(2186),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_out] = ACTIONS(2186),
    [anon_sym_inout] = ACTIONS(2186),
    [anon_sym_extern] = ACTIONS(2186),
    [anon_sym___attribute__] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2188),
    [anon_sym___declspec] = ACTIONS(2186),
    [anon_sym___based] = ACTIONS(2186),
    [anon_sym___cdecl] = ACTIONS(2186),
    [anon_sym___clrcall] = ACTIONS(2186),
    [anon_sym___stdcall] = ACTIONS(2186),
    [anon_sym___fastcall] = ACTIONS(2186),
    [anon_sym___thiscall] = ACTIONS(2186),
    [anon_sym___vectorcall] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_signed] = ACTIONS(2186),
    [anon_sym_unsigned] = ACTIONS(2186),
    [anon_sym_long] = ACTIONS(2186),
    [anon_sym_short] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_static] = ACTIONS(2186),
    [anon_sym_register] = ACTIONS(2186),
    [anon_sym_inline] = ACTIONS(2186),
    [anon_sym___inline] = ACTIONS(2186),
    [anon_sym___inline__] = ACTIONS(2186),
    [anon_sym___forceinline] = ACTIONS(2186),
    [anon_sym_thread_local] = ACTIONS(2186),
    [anon_sym___thread] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_constexpr] = ACTIONS(2186),
    [anon_sym_volatile] = ACTIONS(2186),
    [anon_sym_restrict] = ACTIONS(2186),
    [anon_sym___restrict__] = ACTIONS(2186),
    [anon_sym__Atomic] = ACTIONS(2186),
    [anon_sym__Noreturn] = ACTIONS(2186),
    [anon_sym_noreturn] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_constinit] = ACTIONS(2186),
    [anon_sym_consteval] = ACTIONS(2186),
    [anon_sym_alignas] = ACTIONS(2186),
    [anon_sym__Alignas] = ACTIONS(2186),
    [sym_primitive_type] = ACTIONS(2186),
    [anon_sym_enum] = ACTIONS(2186),
    [anon_sym_class] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_union] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_switch] = ACTIONS(2186),
    [anon_sym_case] = ACTIONS(2186),
    [anon_sym_default] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [anon_sym_do] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_break] = ACTIONS(2186),
    [anon_sym_continue] = ACTIONS(2186),
    [anon_sym_goto] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2186),
    [anon_sym_compl] = ACTIONS(2186),
    [anon_sym_LT_EQ_GT] = ACTIONS(2188),
    [anon_sym_or] = ACTIONS(2186),
    [anon_sym_and] = ACTIONS(2186),
    [anon_sym_bitor] = ACTIONS(2186),
    [anon_sym_xor] = ACTIONS(2186),
    [anon_sym_bitand] = ACTIONS(2186),
    [anon_sym_not_eq] = ACTIONS(2186),
    [anon_sym_is] = ACTIONS(2186),
    [anon_sym_as] = ACTIONS(2186),
    [anon_sym_DASH_DASH] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2188),
    [anon_sym_sizeof] = ACTIONS(2186),
    [anon_sym___alignof__] = ACTIONS(2186),
    [anon_sym___alignof] = ACTIONS(2186),
    [anon_sym__alignof] = ACTIONS(2186),
    [anon_sym_alignof] = ACTIONS(2186),
    [anon_sym__Alignof] = ACTIONS(2186),
    [anon_sym_offsetof] = ACTIONS(2186),
    [anon_sym__Generic] = ACTIONS(2186),
    [anon_sym_asm] = ACTIONS(2186),
    [anon_sym___asm__] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOT_STAR] = ACTIONS(2188),
    [anon_sym_DASH_GT] = ACTIONS(2188),
    [sym_number_literal] = ACTIONS(2188),
    [anon_sym_L_SQUOTE] = ACTIONS(2188),
    [anon_sym_u_SQUOTE] = ACTIONS(2188),
    [anon_sym_U_SQUOTE] = ACTIONS(2188),
    [anon_sym_u8_SQUOTE] = ACTIONS(2188),
    [anon_sym_SQUOTE] = ACTIONS(2188),
    [anon_sym_L_DQUOTE] = ACTIONS(2188),
    [anon_sym_u_DQUOTE] = ACTIONS(2188),
    [anon_sym_U_DQUOTE] = ACTIONS(2188),
    [anon_sym_u8_DQUOTE] = ACTIONS(2188),
    [anon_sym_DQUOTE] = ACTIONS(2188),
    [sym_true] = ACTIONS(2186),
    [sym_false] = ACTIONS(2186),
    [anon_sym_NULL] = ACTIONS(2186),
    [anon_sym_nullptr] = ACTIONS(2186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_This] = ACTIONS(2186),
    [anon_sym_decltype] = ACTIONS(2186),
    [anon_sym_final] = ACTIONS(2186),
    [anon_sym_override] = ACTIONS(2186),
    [sym_virtual] = ACTIONS(2186),
    [anon_sym_explicit] = ACTIONS(2186),
    [anon_sym_typename] = ACTIONS(2186),
    [anon_sym_template] = ACTIONS(2186),
    [anon_sym_operator] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_delete] = ACTIONS(2186),
    [anon_sym_throw] = ACTIONS(2186),
    [anon_sym_namespace] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_static_assert] = ACTIONS(2186),
    [anon_sym_concept] = ACTIONS(2186),
    [anon_sym_co_return] = ACTIONS(2186),
    [anon_sym_co_yield] = ACTIONS(2186),
    [anon_sym_R_DQUOTE] = ACTIONS(2188),
    [anon_sym_LR_DQUOTE] = ACTIONS(2188),
    [anon_sym_uR_DQUOTE] = ACTIONS(2188),
    [anon_sym_UR_DQUOTE] = ACTIONS(2188),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2188),
    [anon_sym_co_await] = ACTIONS(2186),
    [anon_sym_new] = ACTIONS(2186),
    [anon_sym_requires] = ACTIONS(2186),
    [sym_this] = ACTIONS(2186),
    [anon_sym_precise] = ACTIONS(2186),
    [anon_sym_shared] = ACTIONS(2186),
    [anon_sym_groupshared] = ACTIONS(2186),
    [anon_sym_uniform] = ACTIONS(2186),
    [anon_sym_row_major] = ACTIONS(2186),
    [anon_sym_column_major] = ACTIONS(2186),
    [anon_sym_globallycoherent] = ACTIONS(2186),
    [anon_sym_centroid] = ACTIONS(2186),
    [anon_sym_noperspective] = ACTIONS(2186),
    [anon_sym_nointerpolation] = ACTIONS(2186),
    [anon_sym_sample] = ACTIONS(2186),
    [anon_sym_linear] = ACTIONS(2186),
    [anon_sym_snorm] = ACTIONS(2186),
    [anon_sym_unorm] = ACTIONS(2186),
    [anon_sym_point] = ACTIONS(2186),
    [anon_sym_line] = ACTIONS(2186),
    [anon_sym_triangleadj] = ACTIONS(2186),
    [anon_sym_lineadj] = ACTIONS(2186),
    [anon_sym_triangle] = ACTIONS(2186),
    [anon_sym_interface] = ACTIONS(2186),
    [anon_sym_extension] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym___exported] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
  },
  [140] = {
    [ts_builtin_sym_end] = ACTIONS(2234),
    [sym_identifier] = ACTIONS(2232),
    [aux_sym_preproc_include_token1] = ACTIONS(2232),
    [aux_sym_preproc_def_token1] = ACTIONS(2232),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_COMMA] = ACTIONS(2234),
    [anon_sym_RPAREN] = ACTIONS(2234),
    [aux_sym_preproc_if_token1] = ACTIONS(2232),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2232),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2232),
    [sym_preproc_directive] = ACTIONS(2232),
    [anon_sym_LPAREN2] = ACTIONS(2234),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2232),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2232),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_PIPE_PIPE] = ACTIONS(2234),
    [anon_sym_AMP_AMP] = ACTIONS(2234),
    [anon_sym_PIPE] = ACTIONS(2232),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2232),
    [anon_sym_EQ_EQ] = ACTIONS(2234),
    [anon_sym_BANG_EQ] = ACTIONS(2234),
    [anon_sym_GT] = ACTIONS(2232),
    [anon_sym_GT_EQ] = ACTIONS(2234),
    [anon_sym_LT_EQ] = ACTIONS(2232),
    [anon_sym_LT] = ACTIONS(2232),
    [anon_sym_LT_LT] = ACTIONS(2234),
    [anon_sym_GT_GT] = ACTIONS(2234),
    [anon_sym_COLON] = ACTIONS(2232),
    [anon_sym_SEMI] = ACTIONS(2234),
    [anon_sym___extension__] = ACTIONS(2232),
    [anon_sym_typedef] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2232),
    [anon_sym_out] = ACTIONS(2232),
    [anon_sym_inout] = ACTIONS(2232),
    [anon_sym_extern] = ACTIONS(2232),
    [anon_sym___attribute__] = ACTIONS(2232),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2234),
    [anon_sym___declspec] = ACTIONS(2232),
    [anon_sym___based] = ACTIONS(2232),
    [anon_sym___cdecl] = ACTIONS(2232),
    [anon_sym___clrcall] = ACTIONS(2232),
    [anon_sym___stdcall] = ACTIONS(2232),
    [anon_sym___fastcall] = ACTIONS(2232),
    [anon_sym___thiscall] = ACTIONS(2232),
    [anon_sym___vectorcall] = ACTIONS(2232),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_signed] = ACTIONS(2232),
    [anon_sym_unsigned] = ACTIONS(2232),
    [anon_sym_long] = ACTIONS(2232),
    [anon_sym_short] = ACTIONS(2232),
    [anon_sym_LBRACK] = ACTIONS(2232),
    [anon_sym_static] = ACTIONS(2232),
    [anon_sym_register] = ACTIONS(2232),
    [anon_sym_inline] = ACTIONS(2232),
    [anon_sym___inline] = ACTIONS(2232),
    [anon_sym___inline__] = ACTIONS(2232),
    [anon_sym___forceinline] = ACTIONS(2232),
    [anon_sym_thread_local] = ACTIONS(2232),
    [anon_sym___thread] = ACTIONS(2232),
    [anon_sym_const] = ACTIONS(2232),
    [anon_sym_constexpr] = ACTIONS(2232),
    [anon_sym_volatile] = ACTIONS(2232),
    [anon_sym_restrict] = ACTIONS(2232),
    [anon_sym___restrict__] = ACTIONS(2232),
    [anon_sym__Atomic] = ACTIONS(2232),
    [anon_sym__Noreturn] = ACTIONS(2232),
    [anon_sym_noreturn] = ACTIONS(2232),
    [anon_sym_mutable] = ACTIONS(2232),
    [anon_sym_constinit] = ACTIONS(2232),
    [anon_sym_consteval] = ACTIONS(2232),
    [anon_sym_alignas] = ACTIONS(2232),
    [anon_sym__Alignas] = ACTIONS(2232),
    [sym_primitive_type] = ACTIONS(2232),
    [anon_sym_enum] = ACTIONS(2232),
    [anon_sym_class] = ACTIONS(2232),
    [anon_sym_struct] = ACTIONS(2232),
    [anon_sym_union] = ACTIONS(2232),
    [anon_sym_if] = ACTIONS(2232),
    [anon_sym_else] = ACTIONS(2232),
    [anon_sym_switch] = ACTIONS(2232),
    [anon_sym_case] = ACTIONS(2232),
    [anon_sym_default] = ACTIONS(2232),
    [anon_sym_while] = ACTIONS(2232),
    [anon_sym_do] = ACTIONS(2232),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2232),
    [anon_sym_break] = ACTIONS(2232),
    [anon_sym_continue] = ACTIONS(2232),
    [anon_sym_goto] = ACTIONS(2232),
    [anon_sym_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2232),
    [anon_sym_compl] = ACTIONS(2232),
    [anon_sym_LT_EQ_GT] = ACTIONS(2234),
    [anon_sym_or] = ACTIONS(2232),
    [anon_sym_and] = ACTIONS(2232),
    [anon_sym_bitor] = ACTIONS(2232),
    [anon_sym_xor] = ACTIONS(2232),
    [anon_sym_bitand] = ACTIONS(2232),
    [anon_sym_not_eq] = ACTIONS(2232),
    [anon_sym_is] = ACTIONS(2232),
    [anon_sym_as] = ACTIONS(2232),
    [anon_sym_DASH_DASH] = ACTIONS(2234),
    [anon_sym_PLUS_PLUS] = ACTIONS(2234),
    [anon_sym_sizeof] = ACTIONS(2232),
    [anon_sym___alignof__] = ACTIONS(2232),
    [anon_sym___alignof] = ACTIONS(2232),
    [anon_sym__alignof] = ACTIONS(2232),
    [anon_sym_alignof] = ACTIONS(2232),
    [anon_sym__Alignof] = ACTIONS(2232),
    [anon_sym_offsetof] = ACTIONS(2232),
    [anon_sym__Generic] = ACTIONS(2232),
    [anon_sym_asm] = ACTIONS(2232),
    [anon_sym___asm__] = ACTIONS(2232),
    [anon_sym_DOT] = ACTIONS(2232),
    [anon_sym_DOT_STAR] = ACTIONS(2234),
    [anon_sym_DASH_GT] = ACTIONS(2234),
    [sym_number_literal] = ACTIONS(2234),
    [anon_sym_L_SQUOTE] = ACTIONS(2234),
    [anon_sym_u_SQUOTE] = ACTIONS(2234),
    [anon_sym_U_SQUOTE] = ACTIONS(2234),
    [anon_sym_u8_SQUOTE] = ACTIONS(2234),
    [anon_sym_SQUOTE] = ACTIONS(2234),
    [anon_sym_L_DQUOTE] = ACTIONS(2234),
    [anon_sym_u_DQUOTE] = ACTIONS(2234),
    [anon_sym_U_DQUOTE] = ACTIONS(2234),
    [anon_sym_u8_DQUOTE] = ACTIONS(2234),
    [anon_sym_DQUOTE] = ACTIONS(2234),
    [sym_true] = ACTIONS(2232),
    [sym_false] = ACTIONS(2232),
    [anon_sym_NULL] = ACTIONS(2232),
    [anon_sym_nullptr] = ACTIONS(2232),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2232),
    [anon_sym_let] = ACTIONS(2232),
    [anon_sym_This] = ACTIONS(2232),
    [anon_sym_decltype] = ACTIONS(2232),
    [anon_sym_final] = ACTIONS(2232),
    [anon_sym_override] = ACTIONS(2232),
    [sym_virtual] = ACTIONS(2232),
    [anon_sym_explicit] = ACTIONS(2232),
    [anon_sym_typename] = ACTIONS(2232),
    [anon_sym_template] = ACTIONS(2232),
    [anon_sym_operator] = ACTIONS(2232),
    [anon_sym_try] = ACTIONS(2232),
    [anon_sym_delete] = ACTIONS(2232),
    [anon_sym_throw] = ACTIONS(2232),
    [anon_sym_namespace] = ACTIONS(2232),
    [anon_sym_using] = ACTIONS(2232),
    [anon_sym_static_assert] = ACTIONS(2232),
    [anon_sym_concept] = ACTIONS(2232),
    [anon_sym_co_return] = ACTIONS(2232),
    [anon_sym_co_yield] = ACTIONS(2232),
    [anon_sym_R_DQUOTE] = ACTIONS(2234),
    [anon_sym_LR_DQUOTE] = ACTIONS(2234),
    [anon_sym_uR_DQUOTE] = ACTIONS(2234),
    [anon_sym_UR_DQUOTE] = ACTIONS(2234),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2234),
    [anon_sym_co_await] = ACTIONS(2232),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_requires] = ACTIONS(2232),
    [sym_this] = ACTIONS(2232),
    [anon_sym_precise] = ACTIONS(2232),
    [anon_sym_shared] = ACTIONS(2232),
    [anon_sym_groupshared] = ACTIONS(2232),
    [anon_sym_uniform] = ACTIONS(2232),
    [anon_sym_row_major] = ACTIONS(2232),
    [anon_sym_column_major] = ACTIONS(2232),
    [anon_sym_globallycoherent] = ACTIONS(2232),
    [anon_sym_centroid] = ACTIONS(2232),
    [anon_sym_noperspective] = ACTIONS(2232),
    [anon_sym_nointerpolation] = ACTIONS(2232),
    [anon_sym_sample] = ACTIONS(2232),
    [anon_sym_linear] = ACTIONS(2232),
    [anon_sym_snorm] = ACTIONS(2232),
    [anon_sym_unorm] = ACTIONS(2232),
    [anon_sym_point] = ACTIONS(2232),
    [anon_sym_line] = ACTIONS(2232),
    [anon_sym_triangleadj] = ACTIONS(2232),
    [anon_sym_lineadj] = ACTIONS(2232),
    [anon_sym_triangle] = ACTIONS(2232),
    [anon_sym_interface] = ACTIONS(2232),
    [anon_sym_extension] = ACTIONS(2232),
    [anon_sym_where] = ACTIONS(2232),
    [anon_sym___exported] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(2232),
  },
  [141] = {
    [ts_builtin_sym_end] = ACTIONS(2258),
    [sym_identifier] = ACTIONS(2256),
    [aux_sym_preproc_include_token1] = ACTIONS(2256),
    [aux_sym_preproc_def_token1] = ACTIONS(2256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2258),
    [anon_sym_COMMA] = ACTIONS(2258),
    [anon_sym_RPAREN] = ACTIONS(2258),
    [aux_sym_preproc_if_token1] = ACTIONS(2256),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2256),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2256),
    [sym_preproc_directive] = ACTIONS(2256),
    [anon_sym_LPAREN2] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(2256),
    [anon_sym_TILDE] = ACTIONS(2258),
    [anon_sym_DASH] = ACTIONS(2256),
    [anon_sym_PLUS] = ACTIONS(2256),
    [anon_sym_STAR] = ACTIONS(2258),
    [anon_sym_SLASH] = ACTIONS(2256),
    [anon_sym_PERCENT] = ACTIONS(2258),
    [anon_sym_PIPE_PIPE] = ACTIONS(2258),
    [anon_sym_AMP_AMP] = ACTIONS(2258),
    [anon_sym_PIPE] = ACTIONS(2256),
    [anon_sym_CARET] = ACTIONS(2258),
    [anon_sym_AMP] = ACTIONS(2256),
    [anon_sym_EQ_EQ] = ACTIONS(2258),
    [anon_sym_BANG_EQ] = ACTIONS(2258),
    [anon_sym_GT] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2258),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_LT] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_COLON] = ACTIONS(2256),
    [anon_sym_SEMI] = ACTIONS(2258),
    [anon_sym___extension__] = ACTIONS(2256),
    [anon_sym_typedef] = ACTIONS(2256),
    [anon_sym_in] = ACTIONS(2256),
    [anon_sym_out] = ACTIONS(2256),
    [anon_sym_inout] = ACTIONS(2256),
    [anon_sym_extern] = ACTIONS(2256),
    [anon_sym___attribute__] = ACTIONS(2256),
    [anon_sym_COLON_COLON] = ACTIONS(2258),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2258),
    [anon_sym___declspec] = ACTIONS(2256),
    [anon_sym___based] = ACTIONS(2256),
    [anon_sym___cdecl] = ACTIONS(2256),
    [anon_sym___clrcall] = ACTIONS(2256),
    [anon_sym___stdcall] = ACTIONS(2256),
    [anon_sym___fastcall] = ACTIONS(2256),
    [anon_sym___thiscall] = ACTIONS(2256),
    [anon_sym___vectorcall] = ACTIONS(2256),
    [anon_sym_LBRACE] = ACTIONS(2258),
    [anon_sym_signed] = ACTIONS(2256),
    [anon_sym_unsigned] = ACTIONS(2256),
    [anon_sym_long] = ACTIONS(2256),
    [anon_sym_short] = ACTIONS(2256),
    [anon_sym_LBRACK] = ACTIONS(2256),
    [anon_sym_static] = ACTIONS(2256),
    [anon_sym_register] = ACTIONS(2256),
    [anon_sym_inline] = ACTIONS(2256),
    [anon_sym___inline] = ACTIONS(2256),
    [anon_sym___inline__] = ACTIONS(2256),
    [anon_sym___forceinline] = ACTIONS(2256),
    [anon_sym_thread_local] = ACTIONS(2256),
    [anon_sym___thread] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_constexpr] = ACTIONS(2256),
    [anon_sym_volatile] = ACTIONS(2256),
    [anon_sym_restrict] = ACTIONS(2256),
    [anon_sym___restrict__] = ACTIONS(2256),
    [anon_sym__Atomic] = ACTIONS(2256),
    [anon_sym__Noreturn] = ACTIONS(2256),
    [anon_sym_noreturn] = ACTIONS(2256),
    [anon_sym_mutable] = ACTIONS(2256),
    [anon_sym_constinit] = ACTIONS(2256),
    [anon_sym_consteval] = ACTIONS(2256),
    [anon_sym_alignas] = ACTIONS(2256),
    [anon_sym__Alignas] = ACTIONS(2256),
    [sym_primitive_type] = ACTIONS(2256),
    [anon_sym_enum] = ACTIONS(2256),
    [anon_sym_class] = ACTIONS(2256),
    [anon_sym_struct] = ACTIONS(2256),
    [anon_sym_union] = ACTIONS(2256),
    [anon_sym_if] = ACTIONS(2256),
    [anon_sym_else] = ACTIONS(2256),
    [anon_sym_switch] = ACTIONS(2256),
    [anon_sym_case] = ACTIONS(2256),
    [anon_sym_default] = ACTIONS(2256),
    [anon_sym_while] = ACTIONS(2256),
    [anon_sym_do] = ACTIONS(2256),
    [anon_sym_for] = ACTIONS(2256),
    [anon_sym_return] = ACTIONS(2256),
    [anon_sym_break] = ACTIONS(2256),
    [anon_sym_continue] = ACTIONS(2256),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_QMARK] = ACTIONS(2258),
    [anon_sym_not] = ACTIONS(2256),
    [anon_sym_compl] = ACTIONS(2256),
    [anon_sym_LT_EQ_GT] = ACTIONS(2258),
    [anon_sym_or] = ACTIONS(2256),
    [anon_sym_and] = ACTIONS(2256),
    [anon_sym_bitor] = ACTIONS(2256),
    [anon_sym_xor] = ACTIONS(2256),
    [anon_sym_bitand] = ACTIONS(2256),
    [anon_sym_not_eq] = ACTIONS(2256),
    [anon_sym_is] = ACTIONS(2256),
    [anon_sym_as] = ACTIONS(2256),
    [anon_sym_DASH_DASH] = ACTIONS(2258),
    [anon_sym_PLUS_PLUS] = ACTIONS(2258),
    [anon_sym_sizeof] = ACTIONS(2256),
    [anon_sym___alignof__] = ACTIONS(2256),
    [anon_sym___alignof] = ACTIONS(2256),
    [anon_sym__alignof] = ACTIONS(2256),
    [anon_sym_alignof] = ACTIONS(2256),
    [anon_sym__Alignof] = ACTIONS(2256),
    [anon_sym_offsetof] = ACTIONS(2256),
    [anon_sym__Generic] = ACTIONS(2256),
    [anon_sym_asm] = ACTIONS(2256),
    [anon_sym___asm__] = ACTIONS(2256),
    [anon_sym_DOT] = ACTIONS(2256),
    [anon_sym_DOT_STAR] = ACTIONS(2258),
    [anon_sym_DASH_GT] = ACTIONS(2258),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_L_SQUOTE] = ACTIONS(2258),
    [anon_sym_u_SQUOTE] = ACTIONS(2258),
    [anon_sym_U_SQUOTE] = ACTIONS(2258),
    [anon_sym_u8_SQUOTE] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(2258),
    [anon_sym_L_DQUOTE] = ACTIONS(2258),
    [anon_sym_u_DQUOTE] = ACTIONS(2258),
    [anon_sym_U_DQUOTE] = ACTIONS(2258),
    [anon_sym_u8_DQUOTE] = ACTIONS(2258),
    [anon_sym_DQUOTE] = ACTIONS(2258),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2256),
    [anon_sym_nullptr] = ACTIONS(2256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_This] = ACTIONS(2256),
    [anon_sym_decltype] = ACTIONS(2256),
    [anon_sym_final] = ACTIONS(2256),
    [anon_sym_override] = ACTIONS(2256),
    [sym_virtual] = ACTIONS(2256),
    [anon_sym_explicit] = ACTIONS(2256),
    [anon_sym_typename] = ACTIONS(2256),
    [anon_sym_template] = ACTIONS(2256),
    [anon_sym_operator] = ACTIONS(2256),
    [anon_sym_try] = ACTIONS(2256),
    [anon_sym_delete] = ACTIONS(2256),
    [anon_sym_throw] = ACTIONS(2256),
    [anon_sym_namespace] = ACTIONS(2256),
    [anon_sym_using] = ACTIONS(2256),
    [anon_sym_static_assert] = ACTIONS(2256),
    [anon_sym_concept] = ACTIONS(2256),
    [anon_sym_co_return] = ACTIONS(2256),
    [anon_sym_co_yield] = ACTIONS(2256),
    [anon_sym_R_DQUOTE] = ACTIONS(2258),
    [anon_sym_LR_DQUOTE] = ACTIONS(2258),
    [anon_sym_uR_DQUOTE] = ACTIONS(2258),
    [anon_sym_UR_DQUOTE] = ACTIONS(2258),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2258),
    [anon_sym_co_await] = ACTIONS(2256),
    [anon_sym_new] = ACTIONS(2256),
    [anon_sym_requires] = ACTIONS(2256),
    [sym_this] = ACTIONS(2256),
    [anon_sym_precise] = ACTIONS(2256),
    [anon_sym_shared] = ACTIONS(2256),
    [anon_sym_groupshared] = ACTIONS(2256),
    [anon_sym_uniform] = ACTIONS(2256),
    [anon_sym_row_major] = ACTIONS(2256),
    [anon_sym_column_major] = ACTIONS(2256),
    [anon_sym_globallycoherent] = ACTIONS(2256),
    [anon_sym_centroid] = ACTIONS(2256),
    [anon_sym_noperspective] = ACTIONS(2256),
    [anon_sym_nointerpolation] = ACTIONS(2256),
    [anon_sym_sample] = ACTIONS(2256),
    [anon_sym_linear] = ACTIONS(2256),
    [anon_sym_snorm] = ACTIONS(2256),
    [anon_sym_unorm] = ACTIONS(2256),
    [anon_sym_point] = ACTIONS(2256),
    [anon_sym_line] = ACTIONS(2256),
    [anon_sym_triangleadj] = ACTIONS(2256),
    [anon_sym_lineadj] = ACTIONS(2256),
    [anon_sym_triangle] = ACTIONS(2256),
    [anon_sym_interface] = ACTIONS(2256),
    [anon_sym_extension] = ACTIONS(2256),
    [anon_sym_where] = ACTIONS(2256),
    [anon_sym___exported] = ACTIONS(2256),
    [anon_sym_import] = ACTIONS(2256),
  },
  [142] = {
    [sym_declaration] = STATE(729),
    [sym_type_definition] = STATE(3007),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6190),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_expression_statement] = STATE(3007),
    [sym__for_statement_body] = STATE(10416),
    [sym_expression] = STATE(5444),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10135),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_alias_declaration] = STATE(3007),
    [sym__for_range_loop_body] = STATE(10415),
    [sym_init_statement] = STATE(1936),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(2263),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(2265),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2269),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2273),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_using] = ACTIONS(2275),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [143] = {
    [ts_builtin_sym_end] = ACTIONS(2226),
    [sym_identifier] = ACTIONS(2224),
    [aux_sym_preproc_include_token1] = ACTIONS(2224),
    [aux_sym_preproc_def_token1] = ACTIONS(2224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2226),
    [anon_sym_COMMA] = ACTIONS(2226),
    [anon_sym_RPAREN] = ACTIONS(2226),
    [aux_sym_preproc_if_token1] = ACTIONS(2224),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2224),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2224),
    [sym_preproc_directive] = ACTIONS(2224),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_PLUS] = ACTIONS(2224),
    [anon_sym_STAR] = ACTIONS(2226),
    [anon_sym_SLASH] = ACTIONS(2224),
    [anon_sym_PERCENT] = ACTIONS(2226),
    [anon_sym_PIPE_PIPE] = ACTIONS(2226),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_PIPE] = ACTIONS(2224),
    [anon_sym_CARET] = ACTIONS(2226),
    [anon_sym_AMP] = ACTIONS(2224),
    [anon_sym_EQ_EQ] = ACTIONS(2226),
    [anon_sym_BANG_EQ] = ACTIONS(2226),
    [anon_sym_GT] = ACTIONS(2224),
    [anon_sym_GT_EQ] = ACTIONS(2226),
    [anon_sym_LT_EQ] = ACTIONS(2224),
    [anon_sym_LT] = ACTIONS(2224),
    [anon_sym_LT_LT] = ACTIONS(2226),
    [anon_sym_GT_GT] = ACTIONS(2226),
    [anon_sym_COLON] = ACTIONS(2224),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym___extension__] = ACTIONS(2224),
    [anon_sym_typedef] = ACTIONS(2224),
    [anon_sym_in] = ACTIONS(2224),
    [anon_sym_out] = ACTIONS(2224),
    [anon_sym_inout] = ACTIONS(2224),
    [anon_sym_extern] = ACTIONS(2224),
    [anon_sym___attribute__] = ACTIONS(2224),
    [anon_sym_COLON_COLON] = ACTIONS(2226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2226),
    [anon_sym___declspec] = ACTIONS(2224),
    [anon_sym___based] = ACTIONS(2224),
    [anon_sym___cdecl] = ACTIONS(2224),
    [anon_sym___clrcall] = ACTIONS(2224),
    [anon_sym___stdcall] = ACTIONS(2224),
    [anon_sym___fastcall] = ACTIONS(2224),
    [anon_sym___thiscall] = ACTIONS(2224),
    [anon_sym___vectorcall] = ACTIONS(2224),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_signed] = ACTIONS(2224),
    [anon_sym_unsigned] = ACTIONS(2224),
    [anon_sym_long] = ACTIONS(2224),
    [anon_sym_short] = ACTIONS(2224),
    [anon_sym_LBRACK] = ACTIONS(2224),
    [anon_sym_static] = ACTIONS(2224),
    [anon_sym_register] = ACTIONS(2224),
    [anon_sym_inline] = ACTIONS(2224),
    [anon_sym___inline] = ACTIONS(2224),
    [anon_sym___inline__] = ACTIONS(2224),
    [anon_sym___forceinline] = ACTIONS(2224),
    [anon_sym_thread_local] = ACTIONS(2224),
    [anon_sym___thread] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_constexpr] = ACTIONS(2224),
    [anon_sym_volatile] = ACTIONS(2224),
    [anon_sym_restrict] = ACTIONS(2224),
    [anon_sym___restrict__] = ACTIONS(2224),
    [anon_sym__Atomic] = ACTIONS(2224),
    [anon_sym__Noreturn] = ACTIONS(2224),
    [anon_sym_noreturn] = ACTIONS(2224),
    [anon_sym_mutable] = ACTIONS(2224),
    [anon_sym_constinit] = ACTIONS(2224),
    [anon_sym_consteval] = ACTIONS(2224),
    [anon_sym_alignas] = ACTIONS(2224),
    [anon_sym__Alignas] = ACTIONS(2224),
    [sym_primitive_type] = ACTIONS(2224),
    [anon_sym_enum] = ACTIONS(2224),
    [anon_sym_class] = ACTIONS(2224),
    [anon_sym_struct] = ACTIONS(2224),
    [anon_sym_union] = ACTIONS(2224),
    [anon_sym_if] = ACTIONS(2224),
    [anon_sym_else] = ACTIONS(2224),
    [anon_sym_switch] = ACTIONS(2224),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2224),
    [anon_sym_while] = ACTIONS(2224),
    [anon_sym_do] = ACTIONS(2224),
    [anon_sym_for] = ACTIONS(2224),
    [anon_sym_return] = ACTIONS(2224),
    [anon_sym_break] = ACTIONS(2224),
    [anon_sym_continue] = ACTIONS(2224),
    [anon_sym_goto] = ACTIONS(2224),
    [anon_sym_QMARK] = ACTIONS(2226),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_compl] = ACTIONS(2224),
    [anon_sym_LT_EQ_GT] = ACTIONS(2226),
    [anon_sym_or] = ACTIONS(2224),
    [anon_sym_and] = ACTIONS(2224),
    [anon_sym_bitor] = ACTIONS(2224),
    [anon_sym_xor] = ACTIONS(2224),
    [anon_sym_bitand] = ACTIONS(2224),
    [anon_sym_not_eq] = ACTIONS(2224),
    [anon_sym_is] = ACTIONS(2224),
    [anon_sym_as] = ACTIONS(2224),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_sizeof] = ACTIONS(2224),
    [anon_sym___alignof__] = ACTIONS(2224),
    [anon_sym___alignof] = ACTIONS(2224),
    [anon_sym__alignof] = ACTIONS(2224),
    [anon_sym_alignof] = ACTIONS(2224),
    [anon_sym__Alignof] = ACTIONS(2224),
    [anon_sym_offsetof] = ACTIONS(2224),
    [anon_sym__Generic] = ACTIONS(2224),
    [anon_sym_asm] = ACTIONS(2224),
    [anon_sym___asm__] = ACTIONS(2224),
    [anon_sym_DOT] = ACTIONS(2224),
    [anon_sym_DOT_STAR] = ACTIONS(2226),
    [anon_sym_DASH_GT] = ACTIONS(2226),
    [sym_number_literal] = ACTIONS(2226),
    [anon_sym_L_SQUOTE] = ACTIONS(2226),
    [anon_sym_u_SQUOTE] = ACTIONS(2226),
    [anon_sym_U_SQUOTE] = ACTIONS(2226),
    [anon_sym_u8_SQUOTE] = ACTIONS(2226),
    [anon_sym_SQUOTE] = ACTIONS(2226),
    [anon_sym_L_DQUOTE] = ACTIONS(2226),
    [anon_sym_u_DQUOTE] = ACTIONS(2226),
    [anon_sym_U_DQUOTE] = ACTIONS(2226),
    [anon_sym_u8_DQUOTE] = ACTIONS(2226),
    [anon_sym_DQUOTE] = ACTIONS(2226),
    [sym_true] = ACTIONS(2224),
    [sym_false] = ACTIONS(2224),
    [anon_sym_NULL] = ACTIONS(2224),
    [anon_sym_nullptr] = ACTIONS(2224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2224),
    [anon_sym_let] = ACTIONS(2224),
    [anon_sym_This] = ACTIONS(2224),
    [anon_sym_decltype] = ACTIONS(2224),
    [anon_sym_final] = ACTIONS(2224),
    [anon_sym_override] = ACTIONS(2224),
    [sym_virtual] = ACTIONS(2224),
    [anon_sym_explicit] = ACTIONS(2224),
    [anon_sym_typename] = ACTIONS(2224),
    [anon_sym_template] = ACTIONS(2224),
    [anon_sym_operator] = ACTIONS(2224),
    [anon_sym_try] = ACTIONS(2224),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_throw] = ACTIONS(2224),
    [anon_sym_namespace] = ACTIONS(2224),
    [anon_sym_using] = ACTIONS(2224),
    [anon_sym_static_assert] = ACTIONS(2224),
    [anon_sym_concept] = ACTIONS(2224),
    [anon_sym_co_return] = ACTIONS(2224),
    [anon_sym_co_yield] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(2226),
    [anon_sym_LR_DQUOTE] = ACTIONS(2226),
    [anon_sym_uR_DQUOTE] = ACTIONS(2226),
    [anon_sym_UR_DQUOTE] = ACTIONS(2226),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2226),
    [anon_sym_co_await] = ACTIONS(2224),
    [anon_sym_new] = ACTIONS(2224),
    [anon_sym_requires] = ACTIONS(2224),
    [sym_this] = ACTIONS(2224),
    [anon_sym_precise] = ACTIONS(2224),
    [anon_sym_shared] = ACTIONS(2224),
    [anon_sym_groupshared] = ACTIONS(2224),
    [anon_sym_uniform] = ACTIONS(2224),
    [anon_sym_row_major] = ACTIONS(2224),
    [anon_sym_column_major] = ACTIONS(2224),
    [anon_sym_globallycoherent] = ACTIONS(2224),
    [anon_sym_centroid] = ACTIONS(2224),
    [anon_sym_noperspective] = ACTIONS(2224),
    [anon_sym_nointerpolation] = ACTIONS(2224),
    [anon_sym_sample] = ACTIONS(2224),
    [anon_sym_linear] = ACTIONS(2224),
    [anon_sym_snorm] = ACTIONS(2224),
    [anon_sym_unorm] = ACTIONS(2224),
    [anon_sym_point] = ACTIONS(2224),
    [anon_sym_line] = ACTIONS(2224),
    [anon_sym_triangleadj] = ACTIONS(2224),
    [anon_sym_lineadj] = ACTIONS(2224),
    [anon_sym_triangle] = ACTIONS(2224),
    [anon_sym_interface] = ACTIONS(2224),
    [anon_sym_extension] = ACTIONS(2224),
    [anon_sym_where] = ACTIONS(2224),
    [anon_sym___exported] = ACTIONS(2224),
    [anon_sym_import] = ACTIONS(2224),
  },
  [144] = {
    [ts_builtin_sym_end] = ACTIONS(2192),
    [sym_identifier] = ACTIONS(2190),
    [aux_sym_preproc_include_token1] = ACTIONS(2190),
    [aux_sym_preproc_def_token1] = ACTIONS(2190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2192),
    [anon_sym_COMMA] = ACTIONS(2192),
    [anon_sym_RPAREN] = ACTIONS(2192),
    [aux_sym_preproc_if_token1] = ACTIONS(2190),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2190),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2190),
    [sym_preproc_directive] = ACTIONS(2190),
    [anon_sym_LPAREN2] = ACTIONS(2192),
    [anon_sym_BANG] = ACTIONS(2190),
    [anon_sym_TILDE] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2190),
    [anon_sym_PLUS] = ACTIONS(2190),
    [anon_sym_STAR] = ACTIONS(2192),
    [anon_sym_SLASH] = ACTIONS(2190),
    [anon_sym_PERCENT] = ACTIONS(2192),
    [anon_sym_PIPE_PIPE] = ACTIONS(2192),
    [anon_sym_AMP_AMP] = ACTIONS(2192),
    [anon_sym_PIPE] = ACTIONS(2190),
    [anon_sym_CARET] = ACTIONS(2192),
    [anon_sym_AMP] = ACTIONS(2190),
    [anon_sym_EQ_EQ] = ACTIONS(2192),
    [anon_sym_BANG_EQ] = ACTIONS(2192),
    [anon_sym_GT] = ACTIONS(2190),
    [anon_sym_GT_EQ] = ACTIONS(2192),
    [anon_sym_LT_EQ] = ACTIONS(2190),
    [anon_sym_LT] = ACTIONS(2190),
    [anon_sym_LT_LT] = ACTIONS(2192),
    [anon_sym_GT_GT] = ACTIONS(2192),
    [anon_sym_COLON] = ACTIONS(2190),
    [anon_sym_SEMI] = ACTIONS(2192),
    [anon_sym___extension__] = ACTIONS(2190),
    [anon_sym_typedef] = ACTIONS(2190),
    [anon_sym_in] = ACTIONS(2190),
    [anon_sym_out] = ACTIONS(2190),
    [anon_sym_inout] = ACTIONS(2190),
    [anon_sym_extern] = ACTIONS(2190),
    [anon_sym___attribute__] = ACTIONS(2190),
    [anon_sym_COLON_COLON] = ACTIONS(2192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2192),
    [anon_sym___declspec] = ACTIONS(2190),
    [anon_sym___based] = ACTIONS(2190),
    [anon_sym___cdecl] = ACTIONS(2190),
    [anon_sym___clrcall] = ACTIONS(2190),
    [anon_sym___stdcall] = ACTIONS(2190),
    [anon_sym___fastcall] = ACTIONS(2190),
    [anon_sym___thiscall] = ACTIONS(2190),
    [anon_sym___vectorcall] = ACTIONS(2190),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [anon_sym_signed] = ACTIONS(2190),
    [anon_sym_unsigned] = ACTIONS(2190),
    [anon_sym_long] = ACTIONS(2190),
    [anon_sym_short] = ACTIONS(2190),
    [anon_sym_LBRACK] = ACTIONS(2190),
    [anon_sym_static] = ACTIONS(2190),
    [anon_sym_register] = ACTIONS(2190),
    [anon_sym_inline] = ACTIONS(2190),
    [anon_sym___inline] = ACTIONS(2190),
    [anon_sym___inline__] = ACTIONS(2190),
    [anon_sym___forceinline] = ACTIONS(2190),
    [anon_sym_thread_local] = ACTIONS(2190),
    [anon_sym___thread] = ACTIONS(2190),
    [anon_sym_const] = ACTIONS(2190),
    [anon_sym_constexpr] = ACTIONS(2190),
    [anon_sym_volatile] = ACTIONS(2190),
    [anon_sym_restrict] = ACTIONS(2190),
    [anon_sym___restrict__] = ACTIONS(2190),
    [anon_sym__Atomic] = ACTIONS(2190),
    [anon_sym__Noreturn] = ACTIONS(2190),
    [anon_sym_noreturn] = ACTIONS(2190),
    [anon_sym_mutable] = ACTIONS(2190),
    [anon_sym_constinit] = ACTIONS(2190),
    [anon_sym_consteval] = ACTIONS(2190),
    [anon_sym_alignas] = ACTIONS(2190),
    [anon_sym__Alignas] = ACTIONS(2190),
    [sym_primitive_type] = ACTIONS(2190),
    [anon_sym_enum] = ACTIONS(2190),
    [anon_sym_class] = ACTIONS(2190),
    [anon_sym_struct] = ACTIONS(2190),
    [anon_sym_union] = ACTIONS(2190),
    [anon_sym_if] = ACTIONS(2190),
    [anon_sym_else] = ACTIONS(2190),
    [anon_sym_switch] = ACTIONS(2190),
    [anon_sym_case] = ACTIONS(2190),
    [anon_sym_default] = ACTIONS(2190),
    [anon_sym_while] = ACTIONS(2190),
    [anon_sym_do] = ACTIONS(2190),
    [anon_sym_for] = ACTIONS(2190),
    [anon_sym_return] = ACTIONS(2190),
    [anon_sym_break] = ACTIONS(2190),
    [anon_sym_continue] = ACTIONS(2190),
    [anon_sym_goto] = ACTIONS(2190),
    [anon_sym_QMARK] = ACTIONS(2192),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_compl] = ACTIONS(2190),
    [anon_sym_LT_EQ_GT] = ACTIONS(2192),
    [anon_sym_or] = ACTIONS(2190),
    [anon_sym_and] = ACTIONS(2190),
    [anon_sym_bitor] = ACTIONS(2190),
    [anon_sym_xor] = ACTIONS(2190),
    [anon_sym_bitand] = ACTIONS(2190),
    [anon_sym_not_eq] = ACTIONS(2190),
    [anon_sym_is] = ACTIONS(2190),
    [anon_sym_as] = ACTIONS(2190),
    [anon_sym_DASH_DASH] = ACTIONS(2192),
    [anon_sym_PLUS_PLUS] = ACTIONS(2192),
    [anon_sym_sizeof] = ACTIONS(2190),
    [anon_sym___alignof__] = ACTIONS(2190),
    [anon_sym___alignof] = ACTIONS(2190),
    [anon_sym__alignof] = ACTIONS(2190),
    [anon_sym_alignof] = ACTIONS(2190),
    [anon_sym__Alignof] = ACTIONS(2190),
    [anon_sym_offsetof] = ACTIONS(2190),
    [anon_sym__Generic] = ACTIONS(2190),
    [anon_sym_asm] = ACTIONS(2190),
    [anon_sym___asm__] = ACTIONS(2190),
    [anon_sym_DOT] = ACTIONS(2190),
    [anon_sym_DOT_STAR] = ACTIONS(2192),
    [anon_sym_DASH_GT] = ACTIONS(2192),
    [sym_number_literal] = ACTIONS(2192),
    [anon_sym_L_SQUOTE] = ACTIONS(2192),
    [anon_sym_u_SQUOTE] = ACTIONS(2192),
    [anon_sym_U_SQUOTE] = ACTIONS(2192),
    [anon_sym_u8_SQUOTE] = ACTIONS(2192),
    [anon_sym_SQUOTE] = ACTIONS(2192),
    [anon_sym_L_DQUOTE] = ACTIONS(2192),
    [anon_sym_u_DQUOTE] = ACTIONS(2192),
    [anon_sym_U_DQUOTE] = ACTIONS(2192),
    [anon_sym_u8_DQUOTE] = ACTIONS(2192),
    [anon_sym_DQUOTE] = ACTIONS(2192),
    [sym_true] = ACTIONS(2190),
    [sym_false] = ACTIONS(2190),
    [anon_sym_NULL] = ACTIONS(2190),
    [anon_sym_nullptr] = ACTIONS(2190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2190),
    [anon_sym_let] = ACTIONS(2190),
    [anon_sym_This] = ACTIONS(2190),
    [anon_sym_decltype] = ACTIONS(2190),
    [anon_sym_final] = ACTIONS(2190),
    [anon_sym_override] = ACTIONS(2190),
    [sym_virtual] = ACTIONS(2190),
    [anon_sym_explicit] = ACTIONS(2190),
    [anon_sym_typename] = ACTIONS(2190),
    [anon_sym_template] = ACTIONS(2190),
    [anon_sym_operator] = ACTIONS(2190),
    [anon_sym_try] = ACTIONS(2190),
    [anon_sym_delete] = ACTIONS(2190),
    [anon_sym_throw] = ACTIONS(2190),
    [anon_sym_namespace] = ACTIONS(2190),
    [anon_sym_using] = ACTIONS(2190),
    [anon_sym_static_assert] = ACTIONS(2190),
    [anon_sym_concept] = ACTIONS(2190),
    [anon_sym_co_return] = ACTIONS(2190),
    [anon_sym_co_yield] = ACTIONS(2190),
    [anon_sym_R_DQUOTE] = ACTIONS(2192),
    [anon_sym_LR_DQUOTE] = ACTIONS(2192),
    [anon_sym_uR_DQUOTE] = ACTIONS(2192),
    [anon_sym_UR_DQUOTE] = ACTIONS(2192),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2192),
    [anon_sym_co_await] = ACTIONS(2190),
    [anon_sym_new] = ACTIONS(2190),
    [anon_sym_requires] = ACTIONS(2190),
    [sym_this] = ACTIONS(2190),
    [anon_sym_precise] = ACTIONS(2190),
    [anon_sym_shared] = ACTIONS(2190),
    [anon_sym_groupshared] = ACTIONS(2190),
    [anon_sym_uniform] = ACTIONS(2190),
    [anon_sym_row_major] = ACTIONS(2190),
    [anon_sym_column_major] = ACTIONS(2190),
    [anon_sym_globallycoherent] = ACTIONS(2190),
    [anon_sym_centroid] = ACTIONS(2190),
    [anon_sym_noperspective] = ACTIONS(2190),
    [anon_sym_nointerpolation] = ACTIONS(2190),
    [anon_sym_sample] = ACTIONS(2190),
    [anon_sym_linear] = ACTIONS(2190),
    [anon_sym_snorm] = ACTIONS(2190),
    [anon_sym_unorm] = ACTIONS(2190),
    [anon_sym_point] = ACTIONS(2190),
    [anon_sym_line] = ACTIONS(2190),
    [anon_sym_triangleadj] = ACTIONS(2190),
    [anon_sym_lineadj] = ACTIONS(2190),
    [anon_sym_triangle] = ACTIONS(2190),
    [anon_sym_interface] = ACTIONS(2190),
    [anon_sym_extension] = ACTIONS(2190),
    [anon_sym_where] = ACTIONS(2190),
    [anon_sym___exported] = ACTIONS(2190),
    [anon_sym_import] = ACTIONS(2190),
  },
  [145] = {
    [sym_declaration] = STATE(729),
    [sym_type_definition] = STATE(3007),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6190),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_expression_statement] = STATE(3007),
    [sym__for_statement_body] = STATE(10123),
    [sym_expression] = STATE(5444),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10135),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_alias_declaration] = STATE(3007),
    [sym__for_range_loop_body] = STATE(10136),
    [sym_init_statement] = STATE(1936),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(2263),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(2265),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2269),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2273),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_using] = ACTIONS(2275),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [146] = {
    [ts_builtin_sym_end] = ACTIONS(2200),
    [sym_identifier] = ACTIONS(2198),
    [aux_sym_preproc_include_token1] = ACTIONS(2198),
    [aux_sym_preproc_def_token1] = ACTIONS(2198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_COMMA] = ACTIONS(2200),
    [anon_sym_RPAREN] = ACTIONS(2200),
    [aux_sym_preproc_if_token1] = ACTIONS(2198),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2198),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2198),
    [sym_preproc_directive] = ACTIONS(2198),
    [anon_sym_LPAREN2] = ACTIONS(2200),
    [anon_sym_BANG] = ACTIONS(2198),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(2200),
    [anon_sym_SLASH] = ACTIONS(2198),
    [anon_sym_PERCENT] = ACTIONS(2200),
    [anon_sym_PIPE_PIPE] = ACTIONS(2200),
    [anon_sym_AMP_AMP] = ACTIONS(2200),
    [anon_sym_PIPE] = ACTIONS(2198),
    [anon_sym_CARET] = ACTIONS(2200),
    [anon_sym_AMP] = ACTIONS(2198),
    [anon_sym_EQ_EQ] = ACTIONS(2200),
    [anon_sym_BANG_EQ] = ACTIONS(2200),
    [anon_sym_GT] = ACTIONS(2198),
    [anon_sym_GT_EQ] = ACTIONS(2200),
    [anon_sym_LT_EQ] = ACTIONS(2198),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_LT_LT] = ACTIONS(2200),
    [anon_sym_GT_GT] = ACTIONS(2200),
    [anon_sym_COLON] = ACTIONS(2198),
    [anon_sym_SEMI] = ACTIONS(2200),
    [anon_sym___extension__] = ACTIONS(2198),
    [anon_sym_typedef] = ACTIONS(2198),
    [anon_sym_in] = ACTIONS(2198),
    [anon_sym_out] = ACTIONS(2198),
    [anon_sym_inout] = ACTIONS(2198),
    [anon_sym_extern] = ACTIONS(2198),
    [anon_sym___attribute__] = ACTIONS(2198),
    [anon_sym_COLON_COLON] = ACTIONS(2200),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2200),
    [anon_sym___declspec] = ACTIONS(2198),
    [anon_sym___based] = ACTIONS(2198),
    [anon_sym___cdecl] = ACTIONS(2198),
    [anon_sym___clrcall] = ACTIONS(2198),
    [anon_sym___stdcall] = ACTIONS(2198),
    [anon_sym___fastcall] = ACTIONS(2198),
    [anon_sym___thiscall] = ACTIONS(2198),
    [anon_sym___vectorcall] = ACTIONS(2198),
    [anon_sym_LBRACE] = ACTIONS(2200),
    [anon_sym_signed] = ACTIONS(2198),
    [anon_sym_unsigned] = ACTIONS(2198),
    [anon_sym_long] = ACTIONS(2198),
    [anon_sym_short] = ACTIONS(2198),
    [anon_sym_LBRACK] = ACTIONS(2198),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_register] = ACTIONS(2198),
    [anon_sym_inline] = ACTIONS(2198),
    [anon_sym___inline] = ACTIONS(2198),
    [anon_sym___inline__] = ACTIONS(2198),
    [anon_sym___forceinline] = ACTIONS(2198),
    [anon_sym_thread_local] = ACTIONS(2198),
    [anon_sym___thread] = ACTIONS(2198),
    [anon_sym_const] = ACTIONS(2198),
    [anon_sym_constexpr] = ACTIONS(2198),
    [anon_sym_volatile] = ACTIONS(2198),
    [anon_sym_restrict] = ACTIONS(2198),
    [anon_sym___restrict__] = ACTIONS(2198),
    [anon_sym__Atomic] = ACTIONS(2198),
    [anon_sym__Noreturn] = ACTIONS(2198),
    [anon_sym_noreturn] = ACTIONS(2198),
    [anon_sym_mutable] = ACTIONS(2198),
    [anon_sym_constinit] = ACTIONS(2198),
    [anon_sym_consteval] = ACTIONS(2198),
    [anon_sym_alignas] = ACTIONS(2198),
    [anon_sym__Alignas] = ACTIONS(2198),
    [sym_primitive_type] = ACTIONS(2198),
    [anon_sym_enum] = ACTIONS(2198),
    [anon_sym_class] = ACTIONS(2198),
    [anon_sym_struct] = ACTIONS(2198),
    [anon_sym_union] = ACTIONS(2198),
    [anon_sym_if] = ACTIONS(2198),
    [anon_sym_else] = ACTIONS(2198),
    [anon_sym_switch] = ACTIONS(2198),
    [anon_sym_case] = ACTIONS(2198),
    [anon_sym_default] = ACTIONS(2198),
    [anon_sym_while] = ACTIONS(2198),
    [anon_sym_do] = ACTIONS(2198),
    [anon_sym_for] = ACTIONS(2198),
    [anon_sym_return] = ACTIONS(2198),
    [anon_sym_break] = ACTIONS(2198),
    [anon_sym_continue] = ACTIONS(2198),
    [anon_sym_goto] = ACTIONS(2198),
    [anon_sym_QMARK] = ACTIONS(2200),
    [anon_sym_not] = ACTIONS(2198),
    [anon_sym_compl] = ACTIONS(2198),
    [anon_sym_LT_EQ_GT] = ACTIONS(2200),
    [anon_sym_or] = ACTIONS(2198),
    [anon_sym_and] = ACTIONS(2198),
    [anon_sym_bitor] = ACTIONS(2198),
    [anon_sym_xor] = ACTIONS(2198),
    [anon_sym_bitand] = ACTIONS(2198),
    [anon_sym_not_eq] = ACTIONS(2198),
    [anon_sym_is] = ACTIONS(2198),
    [anon_sym_as] = ACTIONS(2198),
    [anon_sym_DASH_DASH] = ACTIONS(2200),
    [anon_sym_PLUS_PLUS] = ACTIONS(2200),
    [anon_sym_sizeof] = ACTIONS(2198),
    [anon_sym___alignof__] = ACTIONS(2198),
    [anon_sym___alignof] = ACTIONS(2198),
    [anon_sym__alignof] = ACTIONS(2198),
    [anon_sym_alignof] = ACTIONS(2198),
    [anon_sym__Alignof] = ACTIONS(2198),
    [anon_sym_offsetof] = ACTIONS(2198),
    [anon_sym__Generic] = ACTIONS(2198),
    [anon_sym_asm] = ACTIONS(2198),
    [anon_sym___asm__] = ACTIONS(2198),
    [anon_sym_DOT] = ACTIONS(2198),
    [anon_sym_DOT_STAR] = ACTIONS(2200),
    [anon_sym_DASH_GT] = ACTIONS(2200),
    [sym_number_literal] = ACTIONS(2200),
    [anon_sym_L_SQUOTE] = ACTIONS(2200),
    [anon_sym_u_SQUOTE] = ACTIONS(2200),
    [anon_sym_U_SQUOTE] = ACTIONS(2200),
    [anon_sym_u8_SQUOTE] = ACTIONS(2200),
    [anon_sym_SQUOTE] = ACTIONS(2200),
    [anon_sym_L_DQUOTE] = ACTIONS(2200),
    [anon_sym_u_DQUOTE] = ACTIONS(2200),
    [anon_sym_U_DQUOTE] = ACTIONS(2200),
    [anon_sym_u8_DQUOTE] = ACTIONS(2200),
    [anon_sym_DQUOTE] = ACTIONS(2200),
    [sym_true] = ACTIONS(2198),
    [sym_false] = ACTIONS(2198),
    [anon_sym_NULL] = ACTIONS(2198),
    [anon_sym_nullptr] = ACTIONS(2198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2198),
    [anon_sym_let] = ACTIONS(2198),
    [anon_sym_This] = ACTIONS(2198),
    [anon_sym_decltype] = ACTIONS(2198),
    [anon_sym_final] = ACTIONS(2198),
    [anon_sym_override] = ACTIONS(2198),
    [sym_virtual] = ACTIONS(2198),
    [anon_sym_explicit] = ACTIONS(2198),
    [anon_sym_typename] = ACTIONS(2198),
    [anon_sym_template] = ACTIONS(2198),
    [anon_sym_operator] = ACTIONS(2198),
    [anon_sym_try] = ACTIONS(2198),
    [anon_sym_delete] = ACTIONS(2198),
    [anon_sym_throw] = ACTIONS(2198),
    [anon_sym_namespace] = ACTIONS(2198),
    [anon_sym_using] = ACTIONS(2198),
    [anon_sym_static_assert] = ACTIONS(2198),
    [anon_sym_concept] = ACTIONS(2198),
    [anon_sym_co_return] = ACTIONS(2198),
    [anon_sym_co_yield] = ACTIONS(2198),
    [anon_sym_R_DQUOTE] = ACTIONS(2200),
    [anon_sym_LR_DQUOTE] = ACTIONS(2200),
    [anon_sym_uR_DQUOTE] = ACTIONS(2200),
    [anon_sym_UR_DQUOTE] = ACTIONS(2200),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2200),
    [anon_sym_co_await] = ACTIONS(2198),
    [anon_sym_new] = ACTIONS(2198),
    [anon_sym_requires] = ACTIONS(2198),
    [sym_this] = ACTIONS(2198),
    [anon_sym_precise] = ACTIONS(2198),
    [anon_sym_shared] = ACTIONS(2198),
    [anon_sym_groupshared] = ACTIONS(2198),
    [anon_sym_uniform] = ACTIONS(2198),
    [anon_sym_row_major] = ACTIONS(2198),
    [anon_sym_column_major] = ACTIONS(2198),
    [anon_sym_globallycoherent] = ACTIONS(2198),
    [anon_sym_centroid] = ACTIONS(2198),
    [anon_sym_noperspective] = ACTIONS(2198),
    [anon_sym_nointerpolation] = ACTIONS(2198),
    [anon_sym_sample] = ACTIONS(2198),
    [anon_sym_linear] = ACTIONS(2198),
    [anon_sym_snorm] = ACTIONS(2198),
    [anon_sym_unorm] = ACTIONS(2198),
    [anon_sym_point] = ACTIONS(2198),
    [anon_sym_line] = ACTIONS(2198),
    [anon_sym_triangleadj] = ACTIONS(2198),
    [anon_sym_lineadj] = ACTIONS(2198),
    [anon_sym_triangle] = ACTIONS(2198),
    [anon_sym_interface] = ACTIONS(2198),
    [anon_sym_extension] = ACTIONS(2198),
    [anon_sym_where] = ACTIONS(2198),
    [anon_sym___exported] = ACTIONS(2198),
    [anon_sym_import] = ACTIONS(2198),
  },
  [147] = {
    [ts_builtin_sym_end] = ACTIONS(2204),
    [sym_identifier] = ACTIONS(2202),
    [aux_sym_preproc_include_token1] = ACTIONS(2202),
    [aux_sym_preproc_def_token1] = ACTIONS(2202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_RPAREN] = ACTIONS(2204),
    [aux_sym_preproc_if_token1] = ACTIONS(2202),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2202),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2202),
    [sym_preproc_directive] = ACTIONS(2202),
    [anon_sym_LPAREN2] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2202),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2202),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_STAR] = ACTIONS(2204),
    [anon_sym_SLASH] = ACTIONS(2202),
    [anon_sym_PERCENT] = ACTIONS(2204),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2202),
    [anon_sym_CARET] = ACTIONS(2204),
    [anon_sym_AMP] = ACTIONS(2202),
    [anon_sym_EQ_EQ] = ACTIONS(2204),
    [anon_sym_BANG_EQ] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(2202),
    [anon_sym_GT_EQ] = ACTIONS(2204),
    [anon_sym_LT_EQ] = ACTIONS(2202),
    [anon_sym_LT] = ACTIONS(2202),
    [anon_sym_LT_LT] = ACTIONS(2204),
    [anon_sym_GT_GT] = ACTIONS(2204),
    [anon_sym_COLON] = ACTIONS(2202),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym___extension__] = ACTIONS(2202),
    [anon_sym_typedef] = ACTIONS(2202),
    [anon_sym_in] = ACTIONS(2202),
    [anon_sym_out] = ACTIONS(2202),
    [anon_sym_inout] = ACTIONS(2202),
    [anon_sym_extern] = ACTIONS(2202),
    [anon_sym___attribute__] = ACTIONS(2202),
    [anon_sym_COLON_COLON] = ACTIONS(2204),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2204),
    [anon_sym___declspec] = ACTIONS(2202),
    [anon_sym___based] = ACTIONS(2202),
    [anon_sym___cdecl] = ACTIONS(2202),
    [anon_sym___clrcall] = ACTIONS(2202),
    [anon_sym___stdcall] = ACTIONS(2202),
    [anon_sym___fastcall] = ACTIONS(2202),
    [anon_sym___thiscall] = ACTIONS(2202),
    [anon_sym___vectorcall] = ACTIONS(2202),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_signed] = ACTIONS(2202),
    [anon_sym_unsigned] = ACTIONS(2202),
    [anon_sym_long] = ACTIONS(2202),
    [anon_sym_short] = ACTIONS(2202),
    [anon_sym_LBRACK] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2202),
    [anon_sym_register] = ACTIONS(2202),
    [anon_sym_inline] = ACTIONS(2202),
    [anon_sym___inline] = ACTIONS(2202),
    [anon_sym___inline__] = ACTIONS(2202),
    [anon_sym___forceinline] = ACTIONS(2202),
    [anon_sym_thread_local] = ACTIONS(2202),
    [anon_sym___thread] = ACTIONS(2202),
    [anon_sym_const] = ACTIONS(2202),
    [anon_sym_constexpr] = ACTIONS(2202),
    [anon_sym_volatile] = ACTIONS(2202),
    [anon_sym_restrict] = ACTIONS(2202),
    [anon_sym___restrict__] = ACTIONS(2202),
    [anon_sym__Atomic] = ACTIONS(2202),
    [anon_sym__Noreturn] = ACTIONS(2202),
    [anon_sym_noreturn] = ACTIONS(2202),
    [anon_sym_mutable] = ACTIONS(2202),
    [anon_sym_constinit] = ACTIONS(2202),
    [anon_sym_consteval] = ACTIONS(2202),
    [anon_sym_alignas] = ACTIONS(2202),
    [anon_sym__Alignas] = ACTIONS(2202),
    [sym_primitive_type] = ACTIONS(2202),
    [anon_sym_enum] = ACTIONS(2202),
    [anon_sym_class] = ACTIONS(2202),
    [anon_sym_struct] = ACTIONS(2202),
    [anon_sym_union] = ACTIONS(2202),
    [anon_sym_if] = ACTIONS(2202),
    [anon_sym_else] = ACTIONS(2202),
    [anon_sym_switch] = ACTIONS(2202),
    [anon_sym_case] = ACTIONS(2202),
    [anon_sym_default] = ACTIONS(2202),
    [anon_sym_while] = ACTIONS(2202),
    [anon_sym_do] = ACTIONS(2202),
    [anon_sym_for] = ACTIONS(2202),
    [anon_sym_return] = ACTIONS(2202),
    [anon_sym_break] = ACTIONS(2202),
    [anon_sym_continue] = ACTIONS(2202),
    [anon_sym_goto] = ACTIONS(2202),
    [anon_sym_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2202),
    [anon_sym_compl] = ACTIONS(2202),
    [anon_sym_LT_EQ_GT] = ACTIONS(2204),
    [anon_sym_or] = ACTIONS(2202),
    [anon_sym_and] = ACTIONS(2202),
    [anon_sym_bitor] = ACTIONS(2202),
    [anon_sym_xor] = ACTIONS(2202),
    [anon_sym_bitand] = ACTIONS(2202),
    [anon_sym_not_eq] = ACTIONS(2202),
    [anon_sym_is] = ACTIONS(2202),
    [anon_sym_as] = ACTIONS(2202),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_sizeof] = ACTIONS(2202),
    [anon_sym___alignof__] = ACTIONS(2202),
    [anon_sym___alignof] = ACTIONS(2202),
    [anon_sym__alignof] = ACTIONS(2202),
    [anon_sym_alignof] = ACTIONS(2202),
    [anon_sym__Alignof] = ACTIONS(2202),
    [anon_sym_offsetof] = ACTIONS(2202),
    [anon_sym__Generic] = ACTIONS(2202),
    [anon_sym_asm] = ACTIONS(2202),
    [anon_sym___asm__] = ACTIONS(2202),
    [anon_sym_DOT] = ACTIONS(2202),
    [anon_sym_DOT_STAR] = ACTIONS(2204),
    [anon_sym_DASH_GT] = ACTIONS(2204),
    [sym_number_literal] = ACTIONS(2204),
    [anon_sym_L_SQUOTE] = ACTIONS(2204),
    [anon_sym_u_SQUOTE] = ACTIONS(2204),
    [anon_sym_U_SQUOTE] = ACTIONS(2204),
    [anon_sym_u8_SQUOTE] = ACTIONS(2204),
    [anon_sym_SQUOTE] = ACTIONS(2204),
    [anon_sym_L_DQUOTE] = ACTIONS(2204),
    [anon_sym_u_DQUOTE] = ACTIONS(2204),
    [anon_sym_U_DQUOTE] = ACTIONS(2204),
    [anon_sym_u8_DQUOTE] = ACTIONS(2204),
    [anon_sym_DQUOTE] = ACTIONS(2204),
    [sym_true] = ACTIONS(2202),
    [sym_false] = ACTIONS(2202),
    [anon_sym_NULL] = ACTIONS(2202),
    [anon_sym_nullptr] = ACTIONS(2202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2202),
    [anon_sym_let] = ACTIONS(2202),
    [anon_sym_This] = ACTIONS(2202),
    [anon_sym_decltype] = ACTIONS(2202),
    [anon_sym_final] = ACTIONS(2202),
    [anon_sym_override] = ACTIONS(2202),
    [sym_virtual] = ACTIONS(2202),
    [anon_sym_explicit] = ACTIONS(2202),
    [anon_sym_typename] = ACTIONS(2202),
    [anon_sym_template] = ACTIONS(2202),
    [anon_sym_operator] = ACTIONS(2202),
    [anon_sym_try] = ACTIONS(2202),
    [anon_sym_delete] = ACTIONS(2202),
    [anon_sym_throw] = ACTIONS(2202),
    [anon_sym_namespace] = ACTIONS(2202),
    [anon_sym_using] = ACTIONS(2202),
    [anon_sym_static_assert] = ACTIONS(2202),
    [anon_sym_concept] = ACTIONS(2202),
    [anon_sym_co_return] = ACTIONS(2202),
    [anon_sym_co_yield] = ACTIONS(2202),
    [anon_sym_R_DQUOTE] = ACTIONS(2204),
    [anon_sym_LR_DQUOTE] = ACTIONS(2204),
    [anon_sym_uR_DQUOTE] = ACTIONS(2204),
    [anon_sym_UR_DQUOTE] = ACTIONS(2204),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2204),
    [anon_sym_co_await] = ACTIONS(2202),
    [anon_sym_new] = ACTIONS(2202),
    [anon_sym_requires] = ACTIONS(2202),
    [sym_this] = ACTIONS(2202),
    [anon_sym_precise] = ACTIONS(2202),
    [anon_sym_shared] = ACTIONS(2202),
    [anon_sym_groupshared] = ACTIONS(2202),
    [anon_sym_uniform] = ACTIONS(2202),
    [anon_sym_row_major] = ACTIONS(2202),
    [anon_sym_column_major] = ACTIONS(2202),
    [anon_sym_globallycoherent] = ACTIONS(2202),
    [anon_sym_centroid] = ACTIONS(2202),
    [anon_sym_noperspective] = ACTIONS(2202),
    [anon_sym_nointerpolation] = ACTIONS(2202),
    [anon_sym_sample] = ACTIONS(2202),
    [anon_sym_linear] = ACTIONS(2202),
    [anon_sym_snorm] = ACTIONS(2202),
    [anon_sym_unorm] = ACTIONS(2202),
    [anon_sym_point] = ACTIONS(2202),
    [anon_sym_line] = ACTIONS(2202),
    [anon_sym_triangleadj] = ACTIONS(2202),
    [anon_sym_lineadj] = ACTIONS(2202),
    [anon_sym_triangle] = ACTIONS(2202),
    [anon_sym_interface] = ACTIONS(2202),
    [anon_sym_extension] = ACTIONS(2202),
    [anon_sym_where] = ACTIONS(2202),
    [anon_sym___exported] = ACTIONS(2202),
    [anon_sym_import] = ACTIONS(2202),
  },
  [148] = {
    [ts_builtin_sym_end] = ACTIONS(2246),
    [sym_identifier] = ACTIONS(2244),
    [aux_sym_preproc_include_token1] = ACTIONS(2244),
    [aux_sym_preproc_def_token1] = ACTIONS(2244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(2246),
    [anon_sym_RPAREN] = ACTIONS(2246),
    [aux_sym_preproc_if_token1] = ACTIONS(2244),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2244),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2244),
    [sym_preproc_directive] = ACTIONS(2244),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_BANG] = ACTIONS(2244),
    [anon_sym_TILDE] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2244),
    [anon_sym_PLUS] = ACTIONS(2244),
    [anon_sym_STAR] = ACTIONS(2246),
    [anon_sym_SLASH] = ACTIONS(2244),
    [anon_sym_PERCENT] = ACTIONS(2246),
    [anon_sym_PIPE_PIPE] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2244),
    [anon_sym_CARET] = ACTIONS(2246),
    [anon_sym_AMP] = ACTIONS(2244),
    [anon_sym_EQ_EQ] = ACTIONS(2246),
    [anon_sym_BANG_EQ] = ACTIONS(2246),
    [anon_sym_GT] = ACTIONS(2244),
    [anon_sym_GT_EQ] = ACTIONS(2246),
    [anon_sym_LT_EQ] = ACTIONS(2244),
    [anon_sym_LT] = ACTIONS(2244),
    [anon_sym_LT_LT] = ACTIONS(2246),
    [anon_sym_GT_GT] = ACTIONS(2246),
    [anon_sym_COLON] = ACTIONS(2244),
    [anon_sym_SEMI] = ACTIONS(2246),
    [anon_sym___extension__] = ACTIONS(2244),
    [anon_sym_typedef] = ACTIONS(2244),
    [anon_sym_in] = ACTIONS(2244),
    [anon_sym_out] = ACTIONS(2244),
    [anon_sym_inout] = ACTIONS(2244),
    [anon_sym_extern] = ACTIONS(2244),
    [anon_sym___attribute__] = ACTIONS(2244),
    [anon_sym_COLON_COLON] = ACTIONS(2246),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2246),
    [anon_sym___declspec] = ACTIONS(2244),
    [anon_sym___based] = ACTIONS(2244),
    [anon_sym___cdecl] = ACTIONS(2244),
    [anon_sym___clrcall] = ACTIONS(2244),
    [anon_sym___stdcall] = ACTIONS(2244),
    [anon_sym___fastcall] = ACTIONS(2244),
    [anon_sym___thiscall] = ACTIONS(2244),
    [anon_sym___vectorcall] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_signed] = ACTIONS(2244),
    [anon_sym_unsigned] = ACTIONS(2244),
    [anon_sym_long] = ACTIONS(2244),
    [anon_sym_short] = ACTIONS(2244),
    [anon_sym_LBRACK] = ACTIONS(2244),
    [anon_sym_static] = ACTIONS(2244),
    [anon_sym_register] = ACTIONS(2244),
    [anon_sym_inline] = ACTIONS(2244),
    [anon_sym___inline] = ACTIONS(2244),
    [anon_sym___inline__] = ACTIONS(2244),
    [anon_sym___forceinline] = ACTIONS(2244),
    [anon_sym_thread_local] = ACTIONS(2244),
    [anon_sym___thread] = ACTIONS(2244),
    [anon_sym_const] = ACTIONS(2244),
    [anon_sym_constexpr] = ACTIONS(2244),
    [anon_sym_volatile] = ACTIONS(2244),
    [anon_sym_restrict] = ACTIONS(2244),
    [anon_sym___restrict__] = ACTIONS(2244),
    [anon_sym__Atomic] = ACTIONS(2244),
    [anon_sym__Noreturn] = ACTIONS(2244),
    [anon_sym_noreturn] = ACTIONS(2244),
    [anon_sym_mutable] = ACTIONS(2244),
    [anon_sym_constinit] = ACTIONS(2244),
    [anon_sym_consteval] = ACTIONS(2244),
    [anon_sym_alignas] = ACTIONS(2244),
    [anon_sym__Alignas] = ACTIONS(2244),
    [sym_primitive_type] = ACTIONS(2244),
    [anon_sym_enum] = ACTIONS(2244),
    [anon_sym_class] = ACTIONS(2244),
    [anon_sym_struct] = ACTIONS(2244),
    [anon_sym_union] = ACTIONS(2244),
    [anon_sym_if] = ACTIONS(2244),
    [anon_sym_else] = ACTIONS(2244),
    [anon_sym_switch] = ACTIONS(2244),
    [anon_sym_case] = ACTIONS(2244),
    [anon_sym_default] = ACTIONS(2244),
    [anon_sym_while] = ACTIONS(2244),
    [anon_sym_do] = ACTIONS(2244),
    [anon_sym_for] = ACTIONS(2244),
    [anon_sym_return] = ACTIONS(2244),
    [anon_sym_break] = ACTIONS(2244),
    [anon_sym_continue] = ACTIONS(2244),
    [anon_sym_goto] = ACTIONS(2244),
    [anon_sym_QMARK] = ACTIONS(2246),
    [anon_sym_not] = ACTIONS(2244),
    [anon_sym_compl] = ACTIONS(2244),
    [anon_sym_LT_EQ_GT] = ACTIONS(2246),
    [anon_sym_or] = ACTIONS(2244),
    [anon_sym_and] = ACTIONS(2244),
    [anon_sym_bitor] = ACTIONS(2244),
    [anon_sym_xor] = ACTIONS(2244),
    [anon_sym_bitand] = ACTIONS(2244),
    [anon_sym_not_eq] = ACTIONS(2244),
    [anon_sym_is] = ACTIONS(2244),
    [anon_sym_as] = ACTIONS(2244),
    [anon_sym_DASH_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_PLUS] = ACTIONS(2246),
    [anon_sym_sizeof] = ACTIONS(2244),
    [anon_sym___alignof__] = ACTIONS(2244),
    [anon_sym___alignof] = ACTIONS(2244),
    [anon_sym__alignof] = ACTIONS(2244),
    [anon_sym_alignof] = ACTIONS(2244),
    [anon_sym__Alignof] = ACTIONS(2244),
    [anon_sym_offsetof] = ACTIONS(2244),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2244),
    [anon_sym___asm__] = ACTIONS(2244),
    [anon_sym_DOT] = ACTIONS(2244),
    [anon_sym_DOT_STAR] = ACTIONS(2246),
    [anon_sym_DASH_GT] = ACTIONS(2246),
    [sym_number_literal] = ACTIONS(2246),
    [anon_sym_L_SQUOTE] = ACTIONS(2246),
    [anon_sym_u_SQUOTE] = ACTIONS(2246),
    [anon_sym_U_SQUOTE] = ACTIONS(2246),
    [anon_sym_u8_SQUOTE] = ACTIONS(2246),
    [anon_sym_SQUOTE] = ACTIONS(2246),
    [anon_sym_L_DQUOTE] = ACTIONS(2246),
    [anon_sym_u_DQUOTE] = ACTIONS(2246),
    [anon_sym_U_DQUOTE] = ACTIONS(2246),
    [anon_sym_u8_DQUOTE] = ACTIONS(2246),
    [anon_sym_DQUOTE] = ACTIONS(2246),
    [sym_true] = ACTIONS(2244),
    [sym_false] = ACTIONS(2244),
    [anon_sym_NULL] = ACTIONS(2244),
    [anon_sym_nullptr] = ACTIONS(2244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2244),
    [anon_sym_let] = ACTIONS(2244),
    [anon_sym_This] = ACTIONS(2244),
    [anon_sym_decltype] = ACTIONS(2244),
    [anon_sym_final] = ACTIONS(2244),
    [anon_sym_override] = ACTIONS(2244),
    [sym_virtual] = ACTIONS(2244),
    [anon_sym_explicit] = ACTIONS(2244),
    [anon_sym_typename] = ACTIONS(2244),
    [anon_sym_template] = ACTIONS(2244),
    [anon_sym_operator] = ACTIONS(2244),
    [anon_sym_try] = ACTIONS(2244),
    [anon_sym_delete] = ACTIONS(2244),
    [anon_sym_throw] = ACTIONS(2244),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_using] = ACTIONS(2244),
    [anon_sym_static_assert] = ACTIONS(2244),
    [anon_sym_concept] = ACTIONS(2244),
    [anon_sym_co_return] = ACTIONS(2244),
    [anon_sym_co_yield] = ACTIONS(2244),
    [anon_sym_R_DQUOTE] = ACTIONS(2246),
    [anon_sym_LR_DQUOTE] = ACTIONS(2246),
    [anon_sym_uR_DQUOTE] = ACTIONS(2246),
    [anon_sym_UR_DQUOTE] = ACTIONS(2246),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2246),
    [anon_sym_co_await] = ACTIONS(2244),
    [anon_sym_new] = ACTIONS(2244),
    [anon_sym_requires] = ACTIONS(2244),
    [sym_this] = ACTIONS(2244),
    [anon_sym_precise] = ACTIONS(2244),
    [anon_sym_shared] = ACTIONS(2244),
    [anon_sym_groupshared] = ACTIONS(2244),
    [anon_sym_uniform] = ACTIONS(2244),
    [anon_sym_row_major] = ACTIONS(2244),
    [anon_sym_column_major] = ACTIONS(2244),
    [anon_sym_globallycoherent] = ACTIONS(2244),
    [anon_sym_centroid] = ACTIONS(2244),
    [anon_sym_noperspective] = ACTIONS(2244),
    [anon_sym_nointerpolation] = ACTIONS(2244),
    [anon_sym_sample] = ACTIONS(2244),
    [anon_sym_linear] = ACTIONS(2244),
    [anon_sym_snorm] = ACTIONS(2244),
    [anon_sym_unorm] = ACTIONS(2244),
    [anon_sym_point] = ACTIONS(2244),
    [anon_sym_line] = ACTIONS(2244),
    [anon_sym_triangleadj] = ACTIONS(2244),
    [anon_sym_lineadj] = ACTIONS(2244),
    [anon_sym_triangle] = ACTIONS(2244),
    [anon_sym_interface] = ACTIONS(2244),
    [anon_sym_extension] = ACTIONS(2244),
    [anon_sym_where] = ACTIONS(2244),
    [anon_sym___exported] = ACTIONS(2244),
    [anon_sym_import] = ACTIONS(2244),
  },
  [149] = {
    [ts_builtin_sym_end] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(2240),
    [aux_sym_preproc_include_token1] = ACTIONS(2240),
    [aux_sym_preproc_def_token1] = ACTIONS(2240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2242),
    [anon_sym_RPAREN] = ACTIONS(2242),
    [aux_sym_preproc_if_token1] = ACTIONS(2240),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2240),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2240),
    [sym_preproc_directive] = ACTIONS(2240),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2240),
    [anon_sym_PLUS] = ACTIONS(2240),
    [anon_sym_STAR] = ACTIONS(2242),
    [anon_sym_SLASH] = ACTIONS(2240),
    [anon_sym_PERCENT] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_PIPE] = ACTIONS(2240),
    [anon_sym_CARET] = ACTIONS(2242),
    [anon_sym_AMP] = ACTIONS(2240),
    [anon_sym_EQ_EQ] = ACTIONS(2242),
    [anon_sym_BANG_EQ] = ACTIONS(2242),
    [anon_sym_GT] = ACTIONS(2240),
    [anon_sym_GT_EQ] = ACTIONS(2242),
    [anon_sym_LT_EQ] = ACTIONS(2240),
    [anon_sym_LT] = ACTIONS(2240),
    [anon_sym_LT_LT] = ACTIONS(2242),
    [anon_sym_GT_GT] = ACTIONS(2242),
    [anon_sym_COLON] = ACTIONS(2240),
    [anon_sym_SEMI] = ACTIONS(2242),
    [anon_sym___extension__] = ACTIONS(2240),
    [anon_sym_typedef] = ACTIONS(2240),
    [anon_sym_in] = ACTIONS(2240),
    [anon_sym_out] = ACTIONS(2240),
    [anon_sym_inout] = ACTIONS(2240),
    [anon_sym_extern] = ACTIONS(2240),
    [anon_sym___attribute__] = ACTIONS(2240),
    [anon_sym_COLON_COLON] = ACTIONS(2242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2242),
    [anon_sym___declspec] = ACTIONS(2240),
    [anon_sym___based] = ACTIONS(2240),
    [anon_sym___cdecl] = ACTIONS(2240),
    [anon_sym___clrcall] = ACTIONS(2240),
    [anon_sym___stdcall] = ACTIONS(2240),
    [anon_sym___fastcall] = ACTIONS(2240),
    [anon_sym___thiscall] = ACTIONS(2240),
    [anon_sym___vectorcall] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_signed] = ACTIONS(2240),
    [anon_sym_unsigned] = ACTIONS(2240),
    [anon_sym_long] = ACTIONS(2240),
    [anon_sym_short] = ACTIONS(2240),
    [anon_sym_LBRACK] = ACTIONS(2240),
    [anon_sym_static] = ACTIONS(2240),
    [anon_sym_register] = ACTIONS(2240),
    [anon_sym_inline] = ACTIONS(2240),
    [anon_sym___inline] = ACTIONS(2240),
    [anon_sym___inline__] = ACTIONS(2240),
    [anon_sym___forceinline] = ACTIONS(2240),
    [anon_sym_thread_local] = ACTIONS(2240),
    [anon_sym___thread] = ACTIONS(2240),
    [anon_sym_const] = ACTIONS(2240),
    [anon_sym_constexpr] = ACTIONS(2240),
    [anon_sym_volatile] = ACTIONS(2240),
    [anon_sym_restrict] = ACTIONS(2240),
    [anon_sym___restrict__] = ACTIONS(2240),
    [anon_sym__Atomic] = ACTIONS(2240),
    [anon_sym__Noreturn] = ACTIONS(2240),
    [anon_sym_noreturn] = ACTIONS(2240),
    [anon_sym_mutable] = ACTIONS(2240),
    [anon_sym_constinit] = ACTIONS(2240),
    [anon_sym_consteval] = ACTIONS(2240),
    [anon_sym_alignas] = ACTIONS(2240),
    [anon_sym__Alignas] = ACTIONS(2240),
    [sym_primitive_type] = ACTIONS(2240),
    [anon_sym_enum] = ACTIONS(2240),
    [anon_sym_class] = ACTIONS(2240),
    [anon_sym_struct] = ACTIONS(2240),
    [anon_sym_union] = ACTIONS(2240),
    [anon_sym_if] = ACTIONS(2240),
    [anon_sym_else] = ACTIONS(2240),
    [anon_sym_switch] = ACTIONS(2240),
    [anon_sym_case] = ACTIONS(2240),
    [anon_sym_default] = ACTIONS(2240),
    [anon_sym_while] = ACTIONS(2240),
    [anon_sym_do] = ACTIONS(2240),
    [anon_sym_for] = ACTIONS(2240),
    [anon_sym_return] = ACTIONS(2240),
    [anon_sym_break] = ACTIONS(2240),
    [anon_sym_continue] = ACTIONS(2240),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_QMARK] = ACTIONS(2242),
    [anon_sym_not] = ACTIONS(2240),
    [anon_sym_compl] = ACTIONS(2240),
    [anon_sym_LT_EQ_GT] = ACTIONS(2242),
    [anon_sym_or] = ACTIONS(2240),
    [anon_sym_and] = ACTIONS(2240),
    [anon_sym_bitor] = ACTIONS(2240),
    [anon_sym_xor] = ACTIONS(2240),
    [anon_sym_bitand] = ACTIONS(2240),
    [anon_sym_not_eq] = ACTIONS(2240),
    [anon_sym_is] = ACTIONS(2240),
    [anon_sym_as] = ACTIONS(2240),
    [anon_sym_DASH_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_PLUS] = ACTIONS(2242),
    [anon_sym_sizeof] = ACTIONS(2240),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2240),
    [anon_sym__Generic] = ACTIONS(2240),
    [anon_sym_asm] = ACTIONS(2240),
    [anon_sym___asm__] = ACTIONS(2240),
    [anon_sym_DOT] = ACTIONS(2240),
    [anon_sym_DOT_STAR] = ACTIONS(2242),
    [anon_sym_DASH_GT] = ACTIONS(2242),
    [sym_number_literal] = ACTIONS(2242),
    [anon_sym_L_SQUOTE] = ACTIONS(2242),
    [anon_sym_u_SQUOTE] = ACTIONS(2242),
    [anon_sym_U_SQUOTE] = ACTIONS(2242),
    [anon_sym_u8_SQUOTE] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(2242),
    [anon_sym_L_DQUOTE] = ACTIONS(2242),
    [anon_sym_u_DQUOTE] = ACTIONS(2242),
    [anon_sym_U_DQUOTE] = ACTIONS(2242),
    [anon_sym_u8_DQUOTE] = ACTIONS(2242),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [sym_true] = ACTIONS(2240),
    [sym_false] = ACTIONS(2240),
    [anon_sym_NULL] = ACTIONS(2240),
    [anon_sym_nullptr] = ACTIONS(2240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2240),
    [anon_sym_let] = ACTIONS(2240),
    [anon_sym_This] = ACTIONS(2240),
    [anon_sym_decltype] = ACTIONS(2240),
    [anon_sym_final] = ACTIONS(2240),
    [anon_sym_override] = ACTIONS(2240),
    [sym_virtual] = ACTIONS(2240),
    [anon_sym_explicit] = ACTIONS(2240),
    [anon_sym_typename] = ACTIONS(2240),
    [anon_sym_template] = ACTIONS(2240),
    [anon_sym_operator] = ACTIONS(2240),
    [anon_sym_try] = ACTIONS(2240),
    [anon_sym_delete] = ACTIONS(2240),
    [anon_sym_throw] = ACTIONS(2240),
    [anon_sym_namespace] = ACTIONS(2240),
    [anon_sym_using] = ACTIONS(2240),
    [anon_sym_static_assert] = ACTIONS(2240),
    [anon_sym_concept] = ACTIONS(2240),
    [anon_sym_co_return] = ACTIONS(2240),
    [anon_sym_co_yield] = ACTIONS(2240),
    [anon_sym_R_DQUOTE] = ACTIONS(2242),
    [anon_sym_LR_DQUOTE] = ACTIONS(2242),
    [anon_sym_uR_DQUOTE] = ACTIONS(2242),
    [anon_sym_UR_DQUOTE] = ACTIONS(2242),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2242),
    [anon_sym_co_await] = ACTIONS(2240),
    [anon_sym_new] = ACTIONS(2240),
    [anon_sym_requires] = ACTIONS(2240),
    [sym_this] = ACTIONS(2240),
    [anon_sym_precise] = ACTIONS(2240),
    [anon_sym_shared] = ACTIONS(2240),
    [anon_sym_groupshared] = ACTIONS(2240),
    [anon_sym_uniform] = ACTIONS(2240),
    [anon_sym_row_major] = ACTIONS(2240),
    [anon_sym_column_major] = ACTIONS(2240),
    [anon_sym_globallycoherent] = ACTIONS(2240),
    [anon_sym_centroid] = ACTIONS(2240),
    [anon_sym_noperspective] = ACTIONS(2240),
    [anon_sym_nointerpolation] = ACTIONS(2240),
    [anon_sym_sample] = ACTIONS(2240),
    [anon_sym_linear] = ACTIONS(2240),
    [anon_sym_snorm] = ACTIONS(2240),
    [anon_sym_unorm] = ACTIONS(2240),
    [anon_sym_point] = ACTIONS(2240),
    [anon_sym_line] = ACTIONS(2240),
    [anon_sym_triangleadj] = ACTIONS(2240),
    [anon_sym_lineadj] = ACTIONS(2240),
    [anon_sym_triangle] = ACTIONS(2240),
    [anon_sym_interface] = ACTIONS(2240),
    [anon_sym_extension] = ACTIONS(2240),
    [anon_sym_where] = ACTIONS(2240),
    [anon_sym___exported] = ACTIONS(2240),
    [anon_sym_import] = ACTIONS(2240),
  },
  [150] = {
    [sym_declaration] = STATE(729),
    [sym_type_definition] = STATE(3007),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6190),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_expression_statement] = STATE(3007),
    [sym__for_statement_body] = STATE(10247),
    [sym_expression] = STATE(5444),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10135),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_alias_declaration] = STATE(3007),
    [sym__for_range_loop_body] = STATE(10246),
    [sym_init_statement] = STATE(1936),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(2263),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(2265),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2269),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2273),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_using] = ACTIONS(2275),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [151] = {
    [ts_builtin_sym_end] = ACTIONS(2208),
    [sym_identifier] = ACTIONS(2206),
    [aux_sym_preproc_include_token1] = ACTIONS(2206),
    [aux_sym_preproc_def_token1] = ACTIONS(2206),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2208),
    [anon_sym_COMMA] = ACTIONS(2208),
    [anon_sym_RPAREN] = ACTIONS(2208),
    [aux_sym_preproc_if_token1] = ACTIONS(2206),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2206),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2206),
    [sym_preproc_directive] = ACTIONS(2206),
    [anon_sym_LPAREN2] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2208),
    [anon_sym_DASH] = ACTIONS(2206),
    [anon_sym_PLUS] = ACTIONS(2206),
    [anon_sym_STAR] = ACTIONS(2208),
    [anon_sym_SLASH] = ACTIONS(2206),
    [anon_sym_PERCENT] = ACTIONS(2208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2208),
    [anon_sym_AMP_AMP] = ACTIONS(2208),
    [anon_sym_PIPE] = ACTIONS(2206),
    [anon_sym_CARET] = ACTIONS(2208),
    [anon_sym_AMP] = ACTIONS(2206),
    [anon_sym_EQ_EQ] = ACTIONS(2208),
    [anon_sym_BANG_EQ] = ACTIONS(2208),
    [anon_sym_GT] = ACTIONS(2206),
    [anon_sym_GT_EQ] = ACTIONS(2208),
    [anon_sym_LT_EQ] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2206),
    [anon_sym_LT_LT] = ACTIONS(2208),
    [anon_sym_GT_GT] = ACTIONS(2208),
    [anon_sym_COLON] = ACTIONS(2206),
    [anon_sym_SEMI] = ACTIONS(2208),
    [anon_sym___extension__] = ACTIONS(2206),
    [anon_sym_typedef] = ACTIONS(2206),
    [anon_sym_in] = ACTIONS(2206),
    [anon_sym_out] = ACTIONS(2206),
    [anon_sym_inout] = ACTIONS(2206),
    [anon_sym_extern] = ACTIONS(2206),
    [anon_sym___attribute__] = ACTIONS(2206),
    [anon_sym_COLON_COLON] = ACTIONS(2208),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2208),
    [anon_sym___declspec] = ACTIONS(2206),
    [anon_sym___based] = ACTIONS(2206),
    [anon_sym___cdecl] = ACTIONS(2206),
    [anon_sym___clrcall] = ACTIONS(2206),
    [anon_sym___stdcall] = ACTIONS(2206),
    [anon_sym___fastcall] = ACTIONS(2206),
    [anon_sym___thiscall] = ACTIONS(2206),
    [anon_sym___vectorcall] = ACTIONS(2206),
    [anon_sym_LBRACE] = ACTIONS(2208),
    [anon_sym_signed] = ACTIONS(2206),
    [anon_sym_unsigned] = ACTIONS(2206),
    [anon_sym_long] = ACTIONS(2206),
    [anon_sym_short] = ACTIONS(2206),
    [anon_sym_LBRACK] = ACTIONS(2206),
    [anon_sym_static] = ACTIONS(2206),
    [anon_sym_register] = ACTIONS(2206),
    [anon_sym_inline] = ACTIONS(2206),
    [anon_sym___inline] = ACTIONS(2206),
    [anon_sym___inline__] = ACTIONS(2206),
    [anon_sym___forceinline] = ACTIONS(2206),
    [anon_sym_thread_local] = ACTIONS(2206),
    [anon_sym___thread] = ACTIONS(2206),
    [anon_sym_const] = ACTIONS(2206),
    [anon_sym_constexpr] = ACTIONS(2206),
    [anon_sym_volatile] = ACTIONS(2206),
    [anon_sym_restrict] = ACTIONS(2206),
    [anon_sym___restrict__] = ACTIONS(2206),
    [anon_sym__Atomic] = ACTIONS(2206),
    [anon_sym__Noreturn] = ACTIONS(2206),
    [anon_sym_noreturn] = ACTIONS(2206),
    [anon_sym_mutable] = ACTIONS(2206),
    [anon_sym_constinit] = ACTIONS(2206),
    [anon_sym_consteval] = ACTIONS(2206),
    [anon_sym_alignas] = ACTIONS(2206),
    [anon_sym__Alignas] = ACTIONS(2206),
    [sym_primitive_type] = ACTIONS(2206),
    [anon_sym_enum] = ACTIONS(2206),
    [anon_sym_class] = ACTIONS(2206),
    [anon_sym_struct] = ACTIONS(2206),
    [anon_sym_union] = ACTIONS(2206),
    [anon_sym_if] = ACTIONS(2206),
    [anon_sym_else] = ACTIONS(2206),
    [anon_sym_switch] = ACTIONS(2206),
    [anon_sym_case] = ACTIONS(2206),
    [anon_sym_default] = ACTIONS(2206),
    [anon_sym_while] = ACTIONS(2206),
    [anon_sym_do] = ACTIONS(2206),
    [anon_sym_for] = ACTIONS(2206),
    [anon_sym_return] = ACTIONS(2206),
    [anon_sym_break] = ACTIONS(2206),
    [anon_sym_continue] = ACTIONS(2206),
    [anon_sym_goto] = ACTIONS(2206),
    [anon_sym_QMARK] = ACTIONS(2208),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_compl] = ACTIONS(2206),
    [anon_sym_LT_EQ_GT] = ACTIONS(2208),
    [anon_sym_or] = ACTIONS(2206),
    [anon_sym_and] = ACTIONS(2206),
    [anon_sym_bitor] = ACTIONS(2206),
    [anon_sym_xor] = ACTIONS(2206),
    [anon_sym_bitand] = ACTIONS(2206),
    [anon_sym_not_eq] = ACTIONS(2206),
    [anon_sym_is] = ACTIONS(2206),
    [anon_sym_as] = ACTIONS(2206),
    [anon_sym_DASH_DASH] = ACTIONS(2208),
    [anon_sym_PLUS_PLUS] = ACTIONS(2208),
    [anon_sym_sizeof] = ACTIONS(2206),
    [anon_sym___alignof__] = ACTIONS(2206),
    [anon_sym___alignof] = ACTIONS(2206),
    [anon_sym__alignof] = ACTIONS(2206),
    [anon_sym_alignof] = ACTIONS(2206),
    [anon_sym__Alignof] = ACTIONS(2206),
    [anon_sym_offsetof] = ACTIONS(2206),
    [anon_sym__Generic] = ACTIONS(2206),
    [anon_sym_asm] = ACTIONS(2206),
    [anon_sym___asm__] = ACTIONS(2206),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_DOT_STAR] = ACTIONS(2208),
    [anon_sym_DASH_GT] = ACTIONS(2208),
    [sym_number_literal] = ACTIONS(2208),
    [anon_sym_L_SQUOTE] = ACTIONS(2208),
    [anon_sym_u_SQUOTE] = ACTIONS(2208),
    [anon_sym_U_SQUOTE] = ACTIONS(2208),
    [anon_sym_u8_SQUOTE] = ACTIONS(2208),
    [anon_sym_SQUOTE] = ACTIONS(2208),
    [anon_sym_L_DQUOTE] = ACTIONS(2208),
    [anon_sym_u_DQUOTE] = ACTIONS(2208),
    [anon_sym_U_DQUOTE] = ACTIONS(2208),
    [anon_sym_u8_DQUOTE] = ACTIONS(2208),
    [anon_sym_DQUOTE] = ACTIONS(2208),
    [sym_true] = ACTIONS(2206),
    [sym_false] = ACTIONS(2206),
    [anon_sym_NULL] = ACTIONS(2206),
    [anon_sym_nullptr] = ACTIONS(2206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2206),
    [anon_sym_let] = ACTIONS(2206),
    [anon_sym_This] = ACTIONS(2206),
    [anon_sym_decltype] = ACTIONS(2206),
    [anon_sym_final] = ACTIONS(2206),
    [anon_sym_override] = ACTIONS(2206),
    [sym_virtual] = ACTIONS(2206),
    [anon_sym_explicit] = ACTIONS(2206),
    [anon_sym_typename] = ACTIONS(2206),
    [anon_sym_template] = ACTIONS(2206),
    [anon_sym_operator] = ACTIONS(2206),
    [anon_sym_try] = ACTIONS(2206),
    [anon_sym_delete] = ACTIONS(2206),
    [anon_sym_throw] = ACTIONS(2206),
    [anon_sym_namespace] = ACTIONS(2206),
    [anon_sym_using] = ACTIONS(2206),
    [anon_sym_static_assert] = ACTIONS(2206),
    [anon_sym_concept] = ACTIONS(2206),
    [anon_sym_co_return] = ACTIONS(2206),
    [anon_sym_co_yield] = ACTIONS(2206),
    [anon_sym_R_DQUOTE] = ACTIONS(2208),
    [anon_sym_LR_DQUOTE] = ACTIONS(2208),
    [anon_sym_uR_DQUOTE] = ACTIONS(2208),
    [anon_sym_UR_DQUOTE] = ACTIONS(2208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2208),
    [anon_sym_co_await] = ACTIONS(2206),
    [anon_sym_new] = ACTIONS(2206),
    [anon_sym_requires] = ACTIONS(2206),
    [sym_this] = ACTIONS(2206),
    [anon_sym_precise] = ACTIONS(2206),
    [anon_sym_shared] = ACTIONS(2206),
    [anon_sym_groupshared] = ACTIONS(2206),
    [anon_sym_uniform] = ACTIONS(2206),
    [anon_sym_row_major] = ACTIONS(2206),
    [anon_sym_column_major] = ACTIONS(2206),
    [anon_sym_globallycoherent] = ACTIONS(2206),
    [anon_sym_centroid] = ACTIONS(2206),
    [anon_sym_noperspective] = ACTIONS(2206),
    [anon_sym_nointerpolation] = ACTIONS(2206),
    [anon_sym_sample] = ACTIONS(2206),
    [anon_sym_linear] = ACTIONS(2206),
    [anon_sym_snorm] = ACTIONS(2206),
    [anon_sym_unorm] = ACTIONS(2206),
    [anon_sym_point] = ACTIONS(2206),
    [anon_sym_line] = ACTIONS(2206),
    [anon_sym_triangleadj] = ACTIONS(2206),
    [anon_sym_lineadj] = ACTIONS(2206),
    [anon_sym_triangle] = ACTIONS(2206),
    [anon_sym_interface] = ACTIONS(2206),
    [anon_sym_extension] = ACTIONS(2206),
    [anon_sym_where] = ACTIONS(2206),
    [anon_sym___exported] = ACTIONS(2206),
    [anon_sym_import] = ACTIONS(2206),
  },
  [152] = {
    [ts_builtin_sym_end] = ACTIONS(2230),
    [sym_identifier] = ACTIONS(2228),
    [aux_sym_preproc_include_token1] = ACTIONS(2228),
    [aux_sym_preproc_def_token1] = ACTIONS(2228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2230),
    [anon_sym_COMMA] = ACTIONS(2230),
    [anon_sym_RPAREN] = ACTIONS(2230),
    [aux_sym_preproc_if_token1] = ACTIONS(2228),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2228),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2228),
    [sym_preproc_directive] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2228),
    [anon_sym_PLUS] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(2230),
    [anon_sym_SLASH] = ACTIONS(2228),
    [anon_sym_PERCENT] = ACTIONS(2230),
    [anon_sym_PIPE_PIPE] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_PIPE] = ACTIONS(2228),
    [anon_sym_CARET] = ACTIONS(2230),
    [anon_sym_AMP] = ACTIONS(2228),
    [anon_sym_EQ_EQ] = ACTIONS(2230),
    [anon_sym_BANG_EQ] = ACTIONS(2230),
    [anon_sym_GT] = ACTIONS(2228),
    [anon_sym_GT_EQ] = ACTIONS(2230),
    [anon_sym_LT_EQ] = ACTIONS(2228),
    [anon_sym_LT] = ACTIONS(2228),
    [anon_sym_LT_LT] = ACTIONS(2230),
    [anon_sym_GT_GT] = ACTIONS(2230),
    [anon_sym_COLON] = ACTIONS(2228),
    [anon_sym_SEMI] = ACTIONS(2230),
    [anon_sym___extension__] = ACTIONS(2228),
    [anon_sym_typedef] = ACTIONS(2228),
    [anon_sym_in] = ACTIONS(2228),
    [anon_sym_out] = ACTIONS(2228),
    [anon_sym_inout] = ACTIONS(2228),
    [anon_sym_extern] = ACTIONS(2228),
    [anon_sym___attribute__] = ACTIONS(2228),
    [anon_sym_COLON_COLON] = ACTIONS(2230),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2230),
    [anon_sym___declspec] = ACTIONS(2228),
    [anon_sym___based] = ACTIONS(2228),
    [anon_sym___cdecl] = ACTIONS(2228),
    [anon_sym___clrcall] = ACTIONS(2228),
    [anon_sym___stdcall] = ACTIONS(2228),
    [anon_sym___fastcall] = ACTIONS(2228),
    [anon_sym___thiscall] = ACTIONS(2228),
    [anon_sym___vectorcall] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_signed] = ACTIONS(2228),
    [anon_sym_unsigned] = ACTIONS(2228),
    [anon_sym_long] = ACTIONS(2228),
    [anon_sym_short] = ACTIONS(2228),
    [anon_sym_LBRACK] = ACTIONS(2228),
    [anon_sym_static] = ACTIONS(2228),
    [anon_sym_register] = ACTIONS(2228),
    [anon_sym_inline] = ACTIONS(2228),
    [anon_sym___inline] = ACTIONS(2228),
    [anon_sym___inline__] = ACTIONS(2228),
    [anon_sym___forceinline] = ACTIONS(2228),
    [anon_sym_thread_local] = ACTIONS(2228),
    [anon_sym___thread] = ACTIONS(2228),
    [anon_sym_const] = ACTIONS(2228),
    [anon_sym_constexpr] = ACTIONS(2228),
    [anon_sym_volatile] = ACTIONS(2228),
    [anon_sym_restrict] = ACTIONS(2228),
    [anon_sym___restrict__] = ACTIONS(2228),
    [anon_sym__Atomic] = ACTIONS(2228),
    [anon_sym__Noreturn] = ACTIONS(2228),
    [anon_sym_noreturn] = ACTIONS(2228),
    [anon_sym_mutable] = ACTIONS(2228),
    [anon_sym_constinit] = ACTIONS(2228),
    [anon_sym_consteval] = ACTIONS(2228),
    [anon_sym_alignas] = ACTIONS(2228),
    [anon_sym__Alignas] = ACTIONS(2228),
    [sym_primitive_type] = ACTIONS(2228),
    [anon_sym_enum] = ACTIONS(2228),
    [anon_sym_class] = ACTIONS(2228),
    [anon_sym_struct] = ACTIONS(2228),
    [anon_sym_union] = ACTIONS(2228),
    [anon_sym_if] = ACTIONS(2228),
    [anon_sym_else] = ACTIONS(2228),
    [anon_sym_switch] = ACTIONS(2228),
    [anon_sym_case] = ACTIONS(2228),
    [anon_sym_default] = ACTIONS(2228),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2228),
    [anon_sym_for] = ACTIONS(2228),
    [anon_sym_return] = ACTIONS(2228),
    [anon_sym_break] = ACTIONS(2228),
    [anon_sym_continue] = ACTIONS(2228),
    [anon_sym_goto] = ACTIONS(2228),
    [anon_sym_QMARK] = ACTIONS(2230),
    [anon_sym_not] = ACTIONS(2228),
    [anon_sym_compl] = ACTIONS(2228),
    [anon_sym_LT_EQ_GT] = ACTIONS(2230),
    [anon_sym_or] = ACTIONS(2228),
    [anon_sym_and] = ACTIONS(2228),
    [anon_sym_bitor] = ACTIONS(2228),
    [anon_sym_xor] = ACTIONS(2228),
    [anon_sym_bitand] = ACTIONS(2228),
    [anon_sym_not_eq] = ACTIONS(2228),
    [anon_sym_is] = ACTIONS(2228),
    [anon_sym_as] = ACTIONS(2228),
    [anon_sym_DASH_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_PLUS] = ACTIONS(2230),
    [anon_sym_sizeof] = ACTIONS(2228),
    [anon_sym___alignof__] = ACTIONS(2228),
    [anon_sym___alignof] = ACTIONS(2228),
    [anon_sym__alignof] = ACTIONS(2228),
    [anon_sym_alignof] = ACTIONS(2228),
    [anon_sym__Alignof] = ACTIONS(2228),
    [anon_sym_offsetof] = ACTIONS(2228),
    [anon_sym__Generic] = ACTIONS(2228),
    [anon_sym_asm] = ACTIONS(2228),
    [anon_sym___asm__] = ACTIONS(2228),
    [anon_sym_DOT] = ACTIONS(2228),
    [anon_sym_DOT_STAR] = ACTIONS(2230),
    [anon_sym_DASH_GT] = ACTIONS(2230),
    [sym_number_literal] = ACTIONS(2230),
    [anon_sym_L_SQUOTE] = ACTIONS(2230),
    [anon_sym_u_SQUOTE] = ACTIONS(2230),
    [anon_sym_U_SQUOTE] = ACTIONS(2230),
    [anon_sym_u8_SQUOTE] = ACTIONS(2230),
    [anon_sym_SQUOTE] = ACTIONS(2230),
    [anon_sym_L_DQUOTE] = ACTIONS(2230),
    [anon_sym_u_DQUOTE] = ACTIONS(2230),
    [anon_sym_U_DQUOTE] = ACTIONS(2230),
    [anon_sym_u8_DQUOTE] = ACTIONS(2230),
    [anon_sym_DQUOTE] = ACTIONS(2230),
    [sym_true] = ACTIONS(2228),
    [sym_false] = ACTIONS(2228),
    [anon_sym_NULL] = ACTIONS(2228),
    [anon_sym_nullptr] = ACTIONS(2228),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(2228),
    [anon_sym_This] = ACTIONS(2228),
    [anon_sym_decltype] = ACTIONS(2228),
    [anon_sym_final] = ACTIONS(2228),
    [anon_sym_override] = ACTIONS(2228),
    [sym_virtual] = ACTIONS(2228),
    [anon_sym_explicit] = ACTIONS(2228),
    [anon_sym_typename] = ACTIONS(2228),
    [anon_sym_template] = ACTIONS(2228),
    [anon_sym_operator] = ACTIONS(2228),
    [anon_sym_try] = ACTIONS(2228),
    [anon_sym_delete] = ACTIONS(2228),
    [anon_sym_throw] = ACTIONS(2228),
    [anon_sym_namespace] = ACTIONS(2228),
    [anon_sym_using] = ACTIONS(2228),
    [anon_sym_static_assert] = ACTIONS(2228),
    [anon_sym_concept] = ACTIONS(2228),
    [anon_sym_co_return] = ACTIONS(2228),
    [anon_sym_co_yield] = ACTIONS(2228),
    [anon_sym_R_DQUOTE] = ACTIONS(2230),
    [anon_sym_LR_DQUOTE] = ACTIONS(2230),
    [anon_sym_uR_DQUOTE] = ACTIONS(2230),
    [anon_sym_UR_DQUOTE] = ACTIONS(2230),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2230),
    [anon_sym_co_await] = ACTIONS(2228),
    [anon_sym_new] = ACTIONS(2228),
    [anon_sym_requires] = ACTIONS(2228),
    [sym_this] = ACTIONS(2228),
    [anon_sym_precise] = ACTIONS(2228),
    [anon_sym_shared] = ACTIONS(2228),
    [anon_sym_groupshared] = ACTIONS(2228),
    [anon_sym_uniform] = ACTIONS(2228),
    [anon_sym_row_major] = ACTIONS(2228),
    [anon_sym_column_major] = ACTIONS(2228),
    [anon_sym_globallycoherent] = ACTIONS(2228),
    [anon_sym_centroid] = ACTIONS(2228),
    [anon_sym_noperspective] = ACTIONS(2228),
    [anon_sym_nointerpolation] = ACTIONS(2228),
    [anon_sym_sample] = ACTIONS(2228),
    [anon_sym_linear] = ACTIONS(2228),
    [anon_sym_snorm] = ACTIONS(2228),
    [anon_sym_unorm] = ACTIONS(2228),
    [anon_sym_point] = ACTIONS(2228),
    [anon_sym_line] = ACTIONS(2228),
    [anon_sym_triangleadj] = ACTIONS(2228),
    [anon_sym_lineadj] = ACTIONS(2228),
    [anon_sym_triangle] = ACTIONS(2228),
    [anon_sym_interface] = ACTIONS(2228),
    [anon_sym_extension] = ACTIONS(2228),
    [anon_sym_where] = ACTIONS(2228),
    [anon_sym___exported] = ACTIONS(2228),
    [anon_sym_import] = ACTIONS(2228),
  },
  [153] = {
    [ts_builtin_sym_end] = ACTIONS(2254),
    [sym_identifier] = ACTIONS(2252),
    [aux_sym_preproc_include_token1] = ACTIONS(2252),
    [aux_sym_preproc_def_token1] = ACTIONS(2252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2254),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_RPAREN] = ACTIONS(2254),
    [aux_sym_preproc_if_token1] = ACTIONS(2252),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2252),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2252),
    [sym_preproc_directive] = ACTIONS(2252),
    [anon_sym_LPAREN2] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2252),
    [anon_sym_TILDE] = ACTIONS(2254),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2254),
    [anon_sym_SLASH] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2254),
    [anon_sym_PIPE_PIPE] = ACTIONS(2254),
    [anon_sym_AMP_AMP] = ACTIONS(2254),
    [anon_sym_PIPE] = ACTIONS(2252),
    [anon_sym_CARET] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_EQ_EQ] = ACTIONS(2254),
    [anon_sym_BANG_EQ] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2252),
    [anon_sym_GT_EQ] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2252),
    [anon_sym_LT_LT] = ACTIONS(2254),
    [anon_sym_GT_GT] = ACTIONS(2254),
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym_SEMI] = ACTIONS(2254),
    [anon_sym___extension__] = ACTIONS(2252),
    [anon_sym_typedef] = ACTIONS(2252),
    [anon_sym_in] = ACTIONS(2252),
    [anon_sym_out] = ACTIONS(2252),
    [anon_sym_inout] = ACTIONS(2252),
    [anon_sym_extern] = ACTIONS(2252),
    [anon_sym___attribute__] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2254),
    [anon_sym___declspec] = ACTIONS(2252),
    [anon_sym___based] = ACTIONS(2252),
    [anon_sym___cdecl] = ACTIONS(2252),
    [anon_sym___clrcall] = ACTIONS(2252),
    [anon_sym___stdcall] = ACTIONS(2252),
    [anon_sym___fastcall] = ACTIONS(2252),
    [anon_sym___thiscall] = ACTIONS(2252),
    [anon_sym___vectorcall] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_signed] = ACTIONS(2252),
    [anon_sym_unsigned] = ACTIONS(2252),
    [anon_sym_long] = ACTIONS(2252),
    [anon_sym_short] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2252),
    [anon_sym_register] = ACTIONS(2252),
    [anon_sym_inline] = ACTIONS(2252),
    [anon_sym___inline] = ACTIONS(2252),
    [anon_sym___inline__] = ACTIONS(2252),
    [anon_sym___forceinline] = ACTIONS(2252),
    [anon_sym_thread_local] = ACTIONS(2252),
    [anon_sym___thread] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2252),
    [anon_sym_constexpr] = ACTIONS(2252),
    [anon_sym_volatile] = ACTIONS(2252),
    [anon_sym_restrict] = ACTIONS(2252),
    [anon_sym___restrict__] = ACTIONS(2252),
    [anon_sym__Atomic] = ACTIONS(2252),
    [anon_sym__Noreturn] = ACTIONS(2252),
    [anon_sym_noreturn] = ACTIONS(2252),
    [anon_sym_mutable] = ACTIONS(2252),
    [anon_sym_constinit] = ACTIONS(2252),
    [anon_sym_consteval] = ACTIONS(2252),
    [anon_sym_alignas] = ACTIONS(2252),
    [anon_sym__Alignas] = ACTIONS(2252),
    [sym_primitive_type] = ACTIONS(2252),
    [anon_sym_enum] = ACTIONS(2252),
    [anon_sym_class] = ACTIONS(2252),
    [anon_sym_struct] = ACTIONS(2252),
    [anon_sym_union] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_else] = ACTIONS(2252),
    [anon_sym_switch] = ACTIONS(2252),
    [anon_sym_case] = ACTIONS(2252),
    [anon_sym_default] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_do] = ACTIONS(2252),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2252),
    [anon_sym_goto] = ACTIONS(2252),
    [anon_sym_QMARK] = ACTIONS(2254),
    [anon_sym_not] = ACTIONS(2252),
    [anon_sym_compl] = ACTIONS(2252),
    [anon_sym_LT_EQ_GT] = ACTIONS(2254),
    [anon_sym_or] = ACTIONS(2252),
    [anon_sym_and] = ACTIONS(2252),
    [anon_sym_bitor] = ACTIONS(2252),
    [anon_sym_xor] = ACTIONS(2252),
    [anon_sym_bitand] = ACTIONS(2252),
    [anon_sym_not_eq] = ACTIONS(2252),
    [anon_sym_is] = ACTIONS(2252),
    [anon_sym_as] = ACTIONS(2252),
    [anon_sym_DASH_DASH] = ACTIONS(2254),
    [anon_sym_PLUS_PLUS] = ACTIONS(2254),
    [anon_sym_sizeof] = ACTIONS(2252),
    [anon_sym___alignof__] = ACTIONS(2252),
    [anon_sym___alignof] = ACTIONS(2252),
    [anon_sym__alignof] = ACTIONS(2252),
    [anon_sym_alignof] = ACTIONS(2252),
    [anon_sym__Alignof] = ACTIONS(2252),
    [anon_sym_offsetof] = ACTIONS(2252),
    [anon_sym__Generic] = ACTIONS(2252),
    [anon_sym_asm] = ACTIONS(2252),
    [anon_sym___asm__] = ACTIONS(2252),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_DOT_STAR] = ACTIONS(2254),
    [anon_sym_DASH_GT] = ACTIONS(2254),
    [sym_number_literal] = ACTIONS(2254),
    [anon_sym_L_SQUOTE] = ACTIONS(2254),
    [anon_sym_u_SQUOTE] = ACTIONS(2254),
    [anon_sym_U_SQUOTE] = ACTIONS(2254),
    [anon_sym_u8_SQUOTE] = ACTIONS(2254),
    [anon_sym_SQUOTE] = ACTIONS(2254),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2252),
    [sym_false] = ACTIONS(2252),
    [anon_sym_NULL] = ACTIONS(2252),
    [anon_sym_nullptr] = ACTIONS(2252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_This] = ACTIONS(2252),
    [anon_sym_decltype] = ACTIONS(2252),
    [anon_sym_final] = ACTIONS(2252),
    [anon_sym_override] = ACTIONS(2252),
    [sym_virtual] = ACTIONS(2252),
    [anon_sym_explicit] = ACTIONS(2252),
    [anon_sym_typename] = ACTIONS(2252),
    [anon_sym_template] = ACTIONS(2252),
    [anon_sym_operator] = ACTIONS(2252),
    [anon_sym_try] = ACTIONS(2252),
    [anon_sym_delete] = ACTIONS(2252),
    [anon_sym_throw] = ACTIONS(2252),
    [anon_sym_namespace] = ACTIONS(2252),
    [anon_sym_using] = ACTIONS(2252),
    [anon_sym_static_assert] = ACTIONS(2252),
    [anon_sym_concept] = ACTIONS(2252),
    [anon_sym_co_return] = ACTIONS(2252),
    [anon_sym_co_yield] = ACTIONS(2252),
    [anon_sym_R_DQUOTE] = ACTIONS(2254),
    [anon_sym_LR_DQUOTE] = ACTIONS(2254),
    [anon_sym_uR_DQUOTE] = ACTIONS(2254),
    [anon_sym_UR_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2254),
    [anon_sym_co_await] = ACTIONS(2252),
    [anon_sym_new] = ACTIONS(2252),
    [anon_sym_requires] = ACTIONS(2252),
    [sym_this] = ACTIONS(2252),
    [anon_sym_precise] = ACTIONS(2252),
    [anon_sym_shared] = ACTIONS(2252),
    [anon_sym_groupshared] = ACTIONS(2252),
    [anon_sym_uniform] = ACTIONS(2252),
    [anon_sym_row_major] = ACTIONS(2252),
    [anon_sym_column_major] = ACTIONS(2252),
    [anon_sym_globallycoherent] = ACTIONS(2252),
    [anon_sym_centroid] = ACTIONS(2252),
    [anon_sym_noperspective] = ACTIONS(2252),
    [anon_sym_nointerpolation] = ACTIONS(2252),
    [anon_sym_sample] = ACTIONS(2252),
    [anon_sym_linear] = ACTIONS(2252),
    [anon_sym_snorm] = ACTIONS(2252),
    [anon_sym_unorm] = ACTIONS(2252),
    [anon_sym_point] = ACTIONS(2252),
    [anon_sym_line] = ACTIONS(2252),
    [anon_sym_triangleadj] = ACTIONS(2252),
    [anon_sym_lineadj] = ACTIONS(2252),
    [anon_sym_triangle] = ACTIONS(2252),
    [anon_sym_interface] = ACTIONS(2252),
    [anon_sym_extension] = ACTIONS(2252),
    [anon_sym_where] = ACTIONS(2252),
    [anon_sym___exported] = ACTIONS(2252),
    [anon_sym_import] = ACTIONS(2252),
  },
  [154] = {
    [ts_builtin_sym_end] = ACTIONS(2250),
    [sym_identifier] = ACTIONS(2248),
    [aux_sym_preproc_include_token1] = ACTIONS(2248),
    [aux_sym_preproc_def_token1] = ACTIONS(2248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_RPAREN] = ACTIONS(2250),
    [aux_sym_preproc_if_token1] = ACTIONS(2248),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2248),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2248),
    [sym_preproc_directive] = ACTIONS(2248),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2248),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2248),
    [anon_sym_PLUS] = ACTIONS(2248),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_SLASH] = ACTIONS(2248),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2248),
    [anon_sym_EQ_EQ] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_GT] = ACTIONS(2248),
    [anon_sym_GT_EQ] = ACTIONS(2250),
    [anon_sym_LT_EQ] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_LT_LT] = ACTIONS(2250),
    [anon_sym_GT_GT] = ACTIONS(2250),
    [anon_sym_COLON] = ACTIONS(2248),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym___extension__] = ACTIONS(2248),
    [anon_sym_typedef] = ACTIONS(2248),
    [anon_sym_in] = ACTIONS(2248),
    [anon_sym_out] = ACTIONS(2248),
    [anon_sym_inout] = ACTIONS(2248),
    [anon_sym_extern] = ACTIONS(2248),
    [anon_sym___attribute__] = ACTIONS(2248),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2250),
    [anon_sym___declspec] = ACTIONS(2248),
    [anon_sym___based] = ACTIONS(2248),
    [anon_sym___cdecl] = ACTIONS(2248),
    [anon_sym___clrcall] = ACTIONS(2248),
    [anon_sym___stdcall] = ACTIONS(2248),
    [anon_sym___fastcall] = ACTIONS(2248),
    [anon_sym___thiscall] = ACTIONS(2248),
    [anon_sym___vectorcall] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_signed] = ACTIONS(2248),
    [anon_sym_unsigned] = ACTIONS(2248),
    [anon_sym_long] = ACTIONS(2248),
    [anon_sym_short] = ACTIONS(2248),
    [anon_sym_LBRACK] = ACTIONS(2248),
    [anon_sym_static] = ACTIONS(2248),
    [anon_sym_register] = ACTIONS(2248),
    [anon_sym_inline] = ACTIONS(2248),
    [anon_sym___inline] = ACTIONS(2248),
    [anon_sym___inline__] = ACTIONS(2248),
    [anon_sym___forceinline] = ACTIONS(2248),
    [anon_sym_thread_local] = ACTIONS(2248),
    [anon_sym___thread] = ACTIONS(2248),
    [anon_sym_const] = ACTIONS(2248),
    [anon_sym_constexpr] = ACTIONS(2248),
    [anon_sym_volatile] = ACTIONS(2248),
    [anon_sym_restrict] = ACTIONS(2248),
    [anon_sym___restrict__] = ACTIONS(2248),
    [anon_sym__Atomic] = ACTIONS(2248),
    [anon_sym__Noreturn] = ACTIONS(2248),
    [anon_sym_noreturn] = ACTIONS(2248),
    [anon_sym_mutable] = ACTIONS(2248),
    [anon_sym_constinit] = ACTIONS(2248),
    [anon_sym_consteval] = ACTIONS(2248),
    [anon_sym_alignas] = ACTIONS(2248),
    [anon_sym__Alignas] = ACTIONS(2248),
    [sym_primitive_type] = ACTIONS(2248),
    [anon_sym_enum] = ACTIONS(2248),
    [anon_sym_class] = ACTIONS(2248),
    [anon_sym_struct] = ACTIONS(2248),
    [anon_sym_union] = ACTIONS(2248),
    [anon_sym_if] = ACTIONS(2248),
    [anon_sym_else] = ACTIONS(2248),
    [anon_sym_switch] = ACTIONS(2248),
    [anon_sym_case] = ACTIONS(2248),
    [anon_sym_default] = ACTIONS(2248),
    [anon_sym_while] = ACTIONS(2248),
    [anon_sym_do] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2248),
    [anon_sym_break] = ACTIONS(2248),
    [anon_sym_continue] = ACTIONS(2248),
    [anon_sym_goto] = ACTIONS(2248),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_not] = ACTIONS(2248),
    [anon_sym_compl] = ACTIONS(2248),
    [anon_sym_LT_EQ_GT] = ACTIONS(2250),
    [anon_sym_or] = ACTIONS(2248),
    [anon_sym_and] = ACTIONS(2248),
    [anon_sym_bitor] = ACTIONS(2248),
    [anon_sym_xor] = ACTIONS(2248),
    [anon_sym_bitand] = ACTIONS(2248),
    [anon_sym_not_eq] = ACTIONS(2248),
    [anon_sym_is] = ACTIONS(2248),
    [anon_sym_as] = ACTIONS(2248),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_sizeof] = ACTIONS(2248),
    [anon_sym___alignof__] = ACTIONS(2248),
    [anon_sym___alignof] = ACTIONS(2248),
    [anon_sym__alignof] = ACTIONS(2248),
    [anon_sym_alignof] = ACTIONS(2248),
    [anon_sym__Alignof] = ACTIONS(2248),
    [anon_sym_offsetof] = ACTIONS(2248),
    [anon_sym__Generic] = ACTIONS(2248),
    [anon_sym_asm] = ACTIONS(2248),
    [anon_sym___asm__] = ACTIONS(2248),
    [anon_sym_DOT] = ACTIONS(2248),
    [anon_sym_DOT_STAR] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2250),
    [sym_number_literal] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2250),
    [anon_sym_u_SQUOTE] = ACTIONS(2250),
    [anon_sym_U_SQUOTE] = ACTIONS(2250),
    [anon_sym_u8_SQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym_L_DQUOTE] = ACTIONS(2250),
    [anon_sym_u_DQUOTE] = ACTIONS(2250),
    [anon_sym_U_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [sym_true] = ACTIONS(2248),
    [sym_false] = ACTIONS(2248),
    [anon_sym_NULL] = ACTIONS(2248),
    [anon_sym_nullptr] = ACTIONS(2248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2248),
    [anon_sym_let] = ACTIONS(2248),
    [anon_sym_This] = ACTIONS(2248),
    [anon_sym_decltype] = ACTIONS(2248),
    [anon_sym_final] = ACTIONS(2248),
    [anon_sym_override] = ACTIONS(2248),
    [sym_virtual] = ACTIONS(2248),
    [anon_sym_explicit] = ACTIONS(2248),
    [anon_sym_typename] = ACTIONS(2248),
    [anon_sym_template] = ACTIONS(2248),
    [anon_sym_operator] = ACTIONS(2248),
    [anon_sym_try] = ACTIONS(2248),
    [anon_sym_delete] = ACTIONS(2248),
    [anon_sym_throw] = ACTIONS(2248),
    [anon_sym_namespace] = ACTIONS(2248),
    [anon_sym_using] = ACTIONS(2248),
    [anon_sym_static_assert] = ACTIONS(2248),
    [anon_sym_concept] = ACTIONS(2248),
    [anon_sym_co_return] = ACTIONS(2248),
    [anon_sym_co_yield] = ACTIONS(2248),
    [anon_sym_R_DQUOTE] = ACTIONS(2250),
    [anon_sym_LR_DQUOTE] = ACTIONS(2250),
    [anon_sym_uR_DQUOTE] = ACTIONS(2250),
    [anon_sym_UR_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2250),
    [anon_sym_co_await] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2248),
    [anon_sym_requires] = ACTIONS(2248),
    [sym_this] = ACTIONS(2248),
    [anon_sym_precise] = ACTIONS(2248),
    [anon_sym_shared] = ACTIONS(2248),
    [anon_sym_groupshared] = ACTIONS(2248),
    [anon_sym_uniform] = ACTIONS(2248),
    [anon_sym_row_major] = ACTIONS(2248),
    [anon_sym_column_major] = ACTIONS(2248),
    [anon_sym_globallycoherent] = ACTIONS(2248),
    [anon_sym_centroid] = ACTIONS(2248),
    [anon_sym_noperspective] = ACTIONS(2248),
    [anon_sym_nointerpolation] = ACTIONS(2248),
    [anon_sym_sample] = ACTIONS(2248),
    [anon_sym_linear] = ACTIONS(2248),
    [anon_sym_snorm] = ACTIONS(2248),
    [anon_sym_unorm] = ACTIONS(2248),
    [anon_sym_point] = ACTIONS(2248),
    [anon_sym_line] = ACTIONS(2248),
    [anon_sym_triangleadj] = ACTIONS(2248),
    [anon_sym_lineadj] = ACTIONS(2248),
    [anon_sym_triangle] = ACTIONS(2248),
    [anon_sym_interface] = ACTIONS(2248),
    [anon_sym_extension] = ACTIONS(2248),
    [anon_sym_where] = ACTIONS(2248),
    [anon_sym___exported] = ACTIONS(2248),
    [anon_sym_import] = ACTIONS(2248),
  },
  [155] = {
    [sym_declaration] = STATE(729),
    [sym_type_definition] = STATE(3007),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6190),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_expression_statement] = STATE(3007),
    [sym__for_statement_body] = STATE(10336),
    [sym_expression] = STATE(5444),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10135),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_alias_declaration] = STATE(3007),
    [sym__for_range_loop_body] = STATE(10338),
    [sym_init_statement] = STATE(1936),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(2263),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(2265),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2269),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2273),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_using] = ACTIONS(2275),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [156] = {
    [ts_builtin_sym_end] = ACTIONS(2238),
    [sym_identifier] = ACTIONS(2236),
    [aux_sym_preproc_include_token1] = ACTIONS(2236),
    [aux_sym_preproc_def_token1] = ACTIONS(2236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2238),
    [anon_sym_COMMA] = ACTIONS(2238),
    [anon_sym_RPAREN] = ACTIONS(2238),
    [aux_sym_preproc_if_token1] = ACTIONS(2236),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2236),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2236),
    [sym_preproc_directive] = ACTIONS(2236),
    [anon_sym_LPAREN2] = ACTIONS(2238),
    [anon_sym_BANG] = ACTIONS(2236),
    [anon_sym_TILDE] = ACTIONS(2238),
    [anon_sym_DASH] = ACTIONS(2236),
    [anon_sym_PLUS] = ACTIONS(2236),
    [anon_sym_STAR] = ACTIONS(2238),
    [anon_sym_SLASH] = ACTIONS(2236),
    [anon_sym_PERCENT] = ACTIONS(2238),
    [anon_sym_PIPE_PIPE] = ACTIONS(2238),
    [anon_sym_AMP_AMP] = ACTIONS(2238),
    [anon_sym_PIPE] = ACTIONS(2236),
    [anon_sym_CARET] = ACTIONS(2238),
    [anon_sym_AMP] = ACTIONS(2236),
    [anon_sym_EQ_EQ] = ACTIONS(2238),
    [anon_sym_BANG_EQ] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2236),
    [anon_sym_GT_EQ] = ACTIONS(2238),
    [anon_sym_LT_EQ] = ACTIONS(2236),
    [anon_sym_LT] = ACTIONS(2236),
    [anon_sym_LT_LT] = ACTIONS(2238),
    [anon_sym_GT_GT] = ACTIONS(2238),
    [anon_sym_COLON] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(2238),
    [anon_sym___extension__] = ACTIONS(2236),
    [anon_sym_typedef] = ACTIONS(2236),
    [anon_sym_in] = ACTIONS(2236),
    [anon_sym_out] = ACTIONS(2236),
    [anon_sym_inout] = ACTIONS(2236),
    [anon_sym_extern] = ACTIONS(2236),
    [anon_sym___attribute__] = ACTIONS(2236),
    [anon_sym_COLON_COLON] = ACTIONS(2238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2238),
    [anon_sym___declspec] = ACTIONS(2236),
    [anon_sym___based] = ACTIONS(2236),
    [anon_sym___cdecl] = ACTIONS(2236),
    [anon_sym___clrcall] = ACTIONS(2236),
    [anon_sym___stdcall] = ACTIONS(2236),
    [anon_sym___fastcall] = ACTIONS(2236),
    [anon_sym___thiscall] = ACTIONS(2236),
    [anon_sym___vectorcall] = ACTIONS(2236),
    [anon_sym_LBRACE] = ACTIONS(2238),
    [anon_sym_signed] = ACTIONS(2236),
    [anon_sym_unsigned] = ACTIONS(2236),
    [anon_sym_long] = ACTIONS(2236),
    [anon_sym_short] = ACTIONS(2236),
    [anon_sym_LBRACK] = ACTIONS(2236),
    [anon_sym_static] = ACTIONS(2236),
    [anon_sym_register] = ACTIONS(2236),
    [anon_sym_inline] = ACTIONS(2236),
    [anon_sym___inline] = ACTIONS(2236),
    [anon_sym___inline__] = ACTIONS(2236),
    [anon_sym___forceinline] = ACTIONS(2236),
    [anon_sym_thread_local] = ACTIONS(2236),
    [anon_sym___thread] = ACTIONS(2236),
    [anon_sym_const] = ACTIONS(2236),
    [anon_sym_constexpr] = ACTIONS(2236),
    [anon_sym_volatile] = ACTIONS(2236),
    [anon_sym_restrict] = ACTIONS(2236),
    [anon_sym___restrict__] = ACTIONS(2236),
    [anon_sym__Atomic] = ACTIONS(2236),
    [anon_sym__Noreturn] = ACTIONS(2236),
    [anon_sym_noreturn] = ACTIONS(2236),
    [anon_sym_mutable] = ACTIONS(2236),
    [anon_sym_constinit] = ACTIONS(2236),
    [anon_sym_consteval] = ACTIONS(2236),
    [anon_sym_alignas] = ACTIONS(2236),
    [anon_sym__Alignas] = ACTIONS(2236),
    [sym_primitive_type] = ACTIONS(2236),
    [anon_sym_enum] = ACTIONS(2236),
    [anon_sym_class] = ACTIONS(2236),
    [anon_sym_struct] = ACTIONS(2236),
    [anon_sym_union] = ACTIONS(2236),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_else] = ACTIONS(2236),
    [anon_sym_switch] = ACTIONS(2236),
    [anon_sym_case] = ACTIONS(2236),
    [anon_sym_default] = ACTIONS(2236),
    [anon_sym_while] = ACTIONS(2236),
    [anon_sym_do] = ACTIONS(2236),
    [anon_sym_for] = ACTIONS(2236),
    [anon_sym_return] = ACTIONS(2236),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2236),
    [anon_sym_goto] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_compl] = ACTIONS(2236),
    [anon_sym_LT_EQ_GT] = ACTIONS(2238),
    [anon_sym_or] = ACTIONS(2236),
    [anon_sym_and] = ACTIONS(2236),
    [anon_sym_bitor] = ACTIONS(2236),
    [anon_sym_xor] = ACTIONS(2236),
    [anon_sym_bitand] = ACTIONS(2236),
    [anon_sym_not_eq] = ACTIONS(2236),
    [anon_sym_is] = ACTIONS(2236),
    [anon_sym_as] = ACTIONS(2236),
    [anon_sym_DASH_DASH] = ACTIONS(2238),
    [anon_sym_PLUS_PLUS] = ACTIONS(2238),
    [anon_sym_sizeof] = ACTIONS(2236),
    [anon_sym___alignof__] = ACTIONS(2236),
    [anon_sym___alignof] = ACTIONS(2236),
    [anon_sym__alignof] = ACTIONS(2236),
    [anon_sym_alignof] = ACTIONS(2236),
    [anon_sym__Alignof] = ACTIONS(2236),
    [anon_sym_offsetof] = ACTIONS(2236),
    [anon_sym__Generic] = ACTIONS(2236),
    [anon_sym_asm] = ACTIONS(2236),
    [anon_sym___asm__] = ACTIONS(2236),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_DOT_STAR] = ACTIONS(2238),
    [anon_sym_DASH_GT] = ACTIONS(2238),
    [sym_number_literal] = ACTIONS(2238),
    [anon_sym_L_SQUOTE] = ACTIONS(2238),
    [anon_sym_u_SQUOTE] = ACTIONS(2238),
    [anon_sym_U_SQUOTE] = ACTIONS(2238),
    [anon_sym_u8_SQUOTE] = ACTIONS(2238),
    [anon_sym_SQUOTE] = ACTIONS(2238),
    [anon_sym_L_DQUOTE] = ACTIONS(2238),
    [anon_sym_u_DQUOTE] = ACTIONS(2238),
    [anon_sym_U_DQUOTE] = ACTIONS(2238),
    [anon_sym_u8_DQUOTE] = ACTIONS(2238),
    [anon_sym_DQUOTE] = ACTIONS(2238),
    [sym_true] = ACTIONS(2236),
    [sym_false] = ACTIONS(2236),
    [anon_sym_NULL] = ACTIONS(2236),
    [anon_sym_nullptr] = ACTIONS(2236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2236),
    [anon_sym_let] = ACTIONS(2236),
    [anon_sym_This] = ACTIONS(2236),
    [anon_sym_decltype] = ACTIONS(2236),
    [anon_sym_final] = ACTIONS(2236),
    [anon_sym_override] = ACTIONS(2236),
    [sym_virtual] = ACTIONS(2236),
    [anon_sym_explicit] = ACTIONS(2236),
    [anon_sym_typename] = ACTIONS(2236),
    [anon_sym_template] = ACTIONS(2236),
    [anon_sym_operator] = ACTIONS(2236),
    [anon_sym_try] = ACTIONS(2236),
    [anon_sym_delete] = ACTIONS(2236),
    [anon_sym_throw] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(2236),
    [anon_sym_using] = ACTIONS(2236),
    [anon_sym_static_assert] = ACTIONS(2236),
    [anon_sym_concept] = ACTIONS(2236),
    [anon_sym_co_return] = ACTIONS(2236),
    [anon_sym_co_yield] = ACTIONS(2236),
    [anon_sym_R_DQUOTE] = ACTIONS(2238),
    [anon_sym_LR_DQUOTE] = ACTIONS(2238),
    [anon_sym_uR_DQUOTE] = ACTIONS(2238),
    [anon_sym_UR_DQUOTE] = ACTIONS(2238),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2238),
    [anon_sym_co_await] = ACTIONS(2236),
    [anon_sym_new] = ACTIONS(2236),
    [anon_sym_requires] = ACTIONS(2236),
    [sym_this] = ACTIONS(2236),
    [anon_sym_precise] = ACTIONS(2236),
    [anon_sym_shared] = ACTIONS(2236),
    [anon_sym_groupshared] = ACTIONS(2236),
    [anon_sym_uniform] = ACTIONS(2236),
    [anon_sym_row_major] = ACTIONS(2236),
    [anon_sym_column_major] = ACTIONS(2236),
    [anon_sym_globallycoherent] = ACTIONS(2236),
    [anon_sym_centroid] = ACTIONS(2236),
    [anon_sym_noperspective] = ACTIONS(2236),
    [anon_sym_nointerpolation] = ACTIONS(2236),
    [anon_sym_sample] = ACTIONS(2236),
    [anon_sym_linear] = ACTIONS(2236),
    [anon_sym_snorm] = ACTIONS(2236),
    [anon_sym_unorm] = ACTIONS(2236),
    [anon_sym_point] = ACTIONS(2236),
    [anon_sym_line] = ACTIONS(2236),
    [anon_sym_triangleadj] = ACTIONS(2236),
    [anon_sym_lineadj] = ACTIONS(2236),
    [anon_sym_triangle] = ACTIONS(2236),
    [anon_sym_interface] = ACTIONS(2236),
    [anon_sym_extension] = ACTIONS(2236),
    [anon_sym_where] = ACTIONS(2236),
    [anon_sym___exported] = ACTIONS(2236),
    [anon_sym_import] = ACTIONS(2236),
  },
  [157] = {
    [ts_builtin_sym_end] = ACTIONS(2196),
    [sym_identifier] = ACTIONS(2194),
    [aux_sym_preproc_include_token1] = ACTIONS(2194),
    [aux_sym_preproc_def_token1] = ACTIONS(2194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2196),
    [anon_sym_COMMA] = ACTIONS(2196),
    [anon_sym_RPAREN] = ACTIONS(2196),
    [aux_sym_preproc_if_token1] = ACTIONS(2194),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2194),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2194),
    [sym_preproc_directive] = ACTIONS(2194),
    [anon_sym_LPAREN2] = ACTIONS(2196),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2194),
    [anon_sym_PLUS] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(2196),
    [anon_sym_SLASH] = ACTIONS(2194),
    [anon_sym_PERCENT] = ACTIONS(2196),
    [anon_sym_PIPE_PIPE] = ACTIONS(2196),
    [anon_sym_AMP_AMP] = ACTIONS(2196),
    [anon_sym_PIPE] = ACTIONS(2194),
    [anon_sym_CARET] = ACTIONS(2196),
    [anon_sym_AMP] = ACTIONS(2194),
    [anon_sym_EQ_EQ] = ACTIONS(2196),
    [anon_sym_BANG_EQ] = ACTIONS(2196),
    [anon_sym_GT] = ACTIONS(2194),
    [anon_sym_GT_EQ] = ACTIONS(2196),
    [anon_sym_LT_EQ] = ACTIONS(2194),
    [anon_sym_LT] = ACTIONS(2194),
    [anon_sym_LT_LT] = ACTIONS(2196),
    [anon_sym_GT_GT] = ACTIONS(2196),
    [anon_sym_COLON] = ACTIONS(2194),
    [anon_sym_SEMI] = ACTIONS(2196),
    [anon_sym___extension__] = ACTIONS(2194),
    [anon_sym_typedef] = ACTIONS(2194),
    [anon_sym_in] = ACTIONS(2194),
    [anon_sym_out] = ACTIONS(2194),
    [anon_sym_inout] = ACTIONS(2194),
    [anon_sym_extern] = ACTIONS(2194),
    [anon_sym___attribute__] = ACTIONS(2194),
    [anon_sym_COLON_COLON] = ACTIONS(2196),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2196),
    [anon_sym___declspec] = ACTIONS(2194),
    [anon_sym___based] = ACTIONS(2194),
    [anon_sym___cdecl] = ACTIONS(2194),
    [anon_sym___clrcall] = ACTIONS(2194),
    [anon_sym___stdcall] = ACTIONS(2194),
    [anon_sym___fastcall] = ACTIONS(2194),
    [anon_sym___thiscall] = ACTIONS(2194),
    [anon_sym___vectorcall] = ACTIONS(2194),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_signed] = ACTIONS(2194),
    [anon_sym_unsigned] = ACTIONS(2194),
    [anon_sym_long] = ACTIONS(2194),
    [anon_sym_short] = ACTIONS(2194),
    [anon_sym_LBRACK] = ACTIONS(2194),
    [anon_sym_static] = ACTIONS(2194),
    [anon_sym_register] = ACTIONS(2194),
    [anon_sym_inline] = ACTIONS(2194),
    [anon_sym___inline] = ACTIONS(2194),
    [anon_sym___inline__] = ACTIONS(2194),
    [anon_sym___forceinline] = ACTIONS(2194),
    [anon_sym_thread_local] = ACTIONS(2194),
    [anon_sym___thread] = ACTIONS(2194),
    [anon_sym_const] = ACTIONS(2194),
    [anon_sym_constexpr] = ACTIONS(2194),
    [anon_sym_volatile] = ACTIONS(2194),
    [anon_sym_restrict] = ACTIONS(2194),
    [anon_sym___restrict__] = ACTIONS(2194),
    [anon_sym__Atomic] = ACTIONS(2194),
    [anon_sym__Noreturn] = ACTIONS(2194),
    [anon_sym_noreturn] = ACTIONS(2194),
    [anon_sym_mutable] = ACTIONS(2194),
    [anon_sym_constinit] = ACTIONS(2194),
    [anon_sym_consteval] = ACTIONS(2194),
    [anon_sym_alignas] = ACTIONS(2194),
    [anon_sym__Alignas] = ACTIONS(2194),
    [sym_primitive_type] = ACTIONS(2194),
    [anon_sym_enum] = ACTIONS(2194),
    [anon_sym_class] = ACTIONS(2194),
    [anon_sym_struct] = ACTIONS(2194),
    [anon_sym_union] = ACTIONS(2194),
    [anon_sym_if] = ACTIONS(2194),
    [anon_sym_else] = ACTIONS(2194),
    [anon_sym_switch] = ACTIONS(2194),
    [anon_sym_case] = ACTIONS(2194),
    [anon_sym_default] = ACTIONS(2194),
    [anon_sym_while] = ACTIONS(2194),
    [anon_sym_do] = ACTIONS(2194),
    [anon_sym_for] = ACTIONS(2194),
    [anon_sym_return] = ACTIONS(2194),
    [anon_sym_break] = ACTIONS(2194),
    [anon_sym_continue] = ACTIONS(2194),
    [anon_sym_goto] = ACTIONS(2194),
    [anon_sym_QMARK] = ACTIONS(2196),
    [anon_sym_not] = ACTIONS(2194),
    [anon_sym_compl] = ACTIONS(2194),
    [anon_sym_LT_EQ_GT] = ACTIONS(2196),
    [anon_sym_or] = ACTIONS(2194),
    [anon_sym_and] = ACTIONS(2194),
    [anon_sym_bitor] = ACTIONS(2194),
    [anon_sym_xor] = ACTIONS(2194),
    [anon_sym_bitand] = ACTIONS(2194),
    [anon_sym_not_eq] = ACTIONS(2194),
    [anon_sym_is] = ACTIONS(2194),
    [anon_sym_as] = ACTIONS(2194),
    [anon_sym_DASH_DASH] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2196),
    [anon_sym_sizeof] = ACTIONS(2194),
    [anon_sym___alignof__] = ACTIONS(2194),
    [anon_sym___alignof] = ACTIONS(2194),
    [anon_sym__alignof] = ACTIONS(2194),
    [anon_sym_alignof] = ACTIONS(2194),
    [anon_sym__Alignof] = ACTIONS(2194),
    [anon_sym_offsetof] = ACTIONS(2194),
    [anon_sym__Generic] = ACTIONS(2194),
    [anon_sym_asm] = ACTIONS(2194),
    [anon_sym___asm__] = ACTIONS(2194),
    [anon_sym_DOT] = ACTIONS(2194),
    [anon_sym_DOT_STAR] = ACTIONS(2196),
    [anon_sym_DASH_GT] = ACTIONS(2196),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_L_SQUOTE] = ACTIONS(2196),
    [anon_sym_u_SQUOTE] = ACTIONS(2196),
    [anon_sym_U_SQUOTE] = ACTIONS(2196),
    [anon_sym_u8_SQUOTE] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(2196),
    [anon_sym_L_DQUOTE] = ACTIONS(2196),
    [anon_sym_u_DQUOTE] = ACTIONS(2196),
    [anon_sym_U_DQUOTE] = ACTIONS(2196),
    [anon_sym_u8_DQUOTE] = ACTIONS(2196),
    [anon_sym_DQUOTE] = ACTIONS(2196),
    [sym_true] = ACTIONS(2194),
    [sym_false] = ACTIONS(2194),
    [anon_sym_NULL] = ACTIONS(2194),
    [anon_sym_nullptr] = ACTIONS(2194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2194),
    [anon_sym_let] = ACTIONS(2194),
    [anon_sym_This] = ACTIONS(2194),
    [anon_sym_decltype] = ACTIONS(2194),
    [anon_sym_final] = ACTIONS(2194),
    [anon_sym_override] = ACTIONS(2194),
    [sym_virtual] = ACTIONS(2194),
    [anon_sym_explicit] = ACTIONS(2194),
    [anon_sym_typename] = ACTIONS(2194),
    [anon_sym_template] = ACTIONS(2194),
    [anon_sym_operator] = ACTIONS(2194),
    [anon_sym_try] = ACTIONS(2194),
    [anon_sym_delete] = ACTIONS(2194),
    [anon_sym_throw] = ACTIONS(2194),
    [anon_sym_namespace] = ACTIONS(2194),
    [anon_sym_using] = ACTIONS(2194),
    [anon_sym_static_assert] = ACTIONS(2194),
    [anon_sym_concept] = ACTIONS(2194),
    [anon_sym_co_return] = ACTIONS(2194),
    [anon_sym_co_yield] = ACTIONS(2194),
    [anon_sym_R_DQUOTE] = ACTIONS(2196),
    [anon_sym_LR_DQUOTE] = ACTIONS(2196),
    [anon_sym_uR_DQUOTE] = ACTIONS(2196),
    [anon_sym_UR_DQUOTE] = ACTIONS(2196),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2196),
    [anon_sym_co_await] = ACTIONS(2194),
    [anon_sym_new] = ACTIONS(2194),
    [anon_sym_requires] = ACTIONS(2194),
    [sym_this] = ACTIONS(2194),
    [anon_sym_precise] = ACTIONS(2194),
    [anon_sym_shared] = ACTIONS(2194),
    [anon_sym_groupshared] = ACTIONS(2194),
    [anon_sym_uniform] = ACTIONS(2194),
    [anon_sym_row_major] = ACTIONS(2194),
    [anon_sym_column_major] = ACTIONS(2194),
    [anon_sym_globallycoherent] = ACTIONS(2194),
    [anon_sym_centroid] = ACTIONS(2194),
    [anon_sym_noperspective] = ACTIONS(2194),
    [anon_sym_nointerpolation] = ACTIONS(2194),
    [anon_sym_sample] = ACTIONS(2194),
    [anon_sym_linear] = ACTIONS(2194),
    [anon_sym_snorm] = ACTIONS(2194),
    [anon_sym_unorm] = ACTIONS(2194),
    [anon_sym_point] = ACTIONS(2194),
    [anon_sym_line] = ACTIONS(2194),
    [anon_sym_triangleadj] = ACTIONS(2194),
    [anon_sym_lineadj] = ACTIONS(2194),
    [anon_sym_triangle] = ACTIONS(2194),
    [anon_sym_interface] = ACTIONS(2194),
    [anon_sym_extension] = ACTIONS(2194),
    [anon_sym_where] = ACTIONS(2194),
    [anon_sym___exported] = ACTIONS(2194),
    [anon_sym_import] = ACTIONS(2194),
  },
  [158] = {
    [sym_declaration] = STATE(729),
    [sym_type_definition] = STATE(3007),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6190),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_expression_statement] = STATE(3007),
    [sym__for_statement_body] = STATE(10194),
    [sym_expression] = STATE(5444),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10135),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_alias_declaration] = STATE(3007),
    [sym__for_range_loop_body] = STATE(10193),
    [sym_init_statement] = STATE(1936),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(2263),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(2265),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2269),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2273),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_using] = ACTIONS(2275),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [159] = {
    [sym_declaration] = STATE(1374),
    [sym_type_definition] = STATE(1374),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6192),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_expression_statement] = STATE(1374),
    [sym_expression] = STATE(5145),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(9964),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_alias_declaration] = STATE(1374),
    [sym_init_statement] = STATE(189),
    [sym_condition_declaration] = STATE(10119),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(2263),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym___extension__] = ACTIONS(2009),
    [anon_sym_typedef] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2273),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_using] = ACTIONS(2277),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [160] = {
    [sym__declaration_modifiers] = STATE(2299),
    [sym__declaration_specifiers] = STATE(4856),
    [sym_attribute_specifier] = STATE(2299),
    [sym_attribute_declaration] = STATE(2299),
    [sym_ms_declspec_modifier] = STATE(2299),
    [sym_storage_class_specifier] = STATE(2299),
    [sym_type_qualifier] = STATE(2299),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2694),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_parameter_declaration] = STATE(9395),
    [sym_expression] = STATE(3828),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9991),
    [sym_dependent_type] = STATE(2741),
    [sym_optional_parameter_declaration] = STATE(9395),
    [sym_variadic_parameter_declaration] = STATE(9395),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym__unary_left_fold] = STATE(10301),
    [sym__unary_right_fold] = STATE(10302),
    [sym__binary_fold] = STATE(10271),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6867),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4251),
    [sym_qualifiers] = STATE(2299),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2299),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(2279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_RPAREN] = ACTIONS(2283),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_out] = ACTIONS(2293),
    [anon_sym_inout] = ACTIONS(2293),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2273),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2297),
    [anon_sym_enum] = ACTIONS(2299),
    [anon_sym_class] = ACTIONS(2301),
    [anon_sym_struct] = ACTIONS(2303),
    [anon_sym_union] = ACTIONS(2305),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(2293),
    [anon_sym_typename] = ACTIONS(2329),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2341),
    [anon_sym_extension] = ACTIONS(2343),
  },
  [161] = {
    [sym__declaration_modifiers] = STATE(2299),
    [sym__declaration_specifiers] = STATE(4856),
    [sym_attribute_specifier] = STATE(2299),
    [sym_attribute_declaration] = STATE(2299),
    [sym_ms_declspec_modifier] = STATE(2299),
    [sym_storage_class_specifier] = STATE(2299),
    [sym_type_qualifier] = STATE(2299),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2694),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_parameter_declaration] = STATE(9395),
    [sym_expression] = STATE(4054),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9991),
    [sym_dependent_type] = STATE(2741),
    [sym_optional_parameter_declaration] = STATE(9395),
    [sym_variadic_parameter_declaration] = STATE(9395),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym__unary_left_fold] = STATE(10910),
    [sym__unary_right_fold] = STATE(10908),
    [sym__binary_fold] = STATE(10906),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6867),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4251),
    [sym_qualifiers] = STATE(2299),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2299),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(2279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_RPAREN] = ACTIONS(2283),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_out] = ACTIONS(2293),
    [anon_sym_inout] = ACTIONS(2293),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2273),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2297),
    [anon_sym_enum] = ACTIONS(2299),
    [anon_sym_class] = ACTIONS(2301),
    [anon_sym_struct] = ACTIONS(2303),
    [anon_sym_union] = ACTIONS(2305),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(2293),
    [anon_sym_typename] = ACTIONS(2329),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2341),
    [anon_sym_extension] = ACTIONS(2343),
  },
  [162] = {
    [sym__declaration_modifiers] = STATE(2299),
    [sym__declaration_specifiers] = STATE(4856),
    [sym_attribute_specifier] = STATE(2299),
    [sym_attribute_declaration] = STATE(2299),
    [sym_ms_declspec_modifier] = STATE(2299),
    [sym_storage_class_specifier] = STATE(2299),
    [sym_type_qualifier] = STATE(2299),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2694),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_parameter_declaration] = STATE(9395),
    [sym_expression] = STATE(3955),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9991),
    [sym_dependent_type] = STATE(2741),
    [sym_optional_parameter_declaration] = STATE(9395),
    [sym_variadic_parameter_declaration] = STATE(9395),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym__unary_left_fold] = STATE(10796),
    [sym__unary_right_fold] = STATE(10795),
    [sym__binary_fold] = STATE(10794),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6867),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4251),
    [sym_qualifiers] = STATE(2299),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2299),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(2279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_RPAREN] = ACTIONS(2283),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_out] = ACTIONS(2293),
    [anon_sym_inout] = ACTIONS(2293),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2273),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2297),
    [anon_sym_enum] = ACTIONS(2299),
    [anon_sym_class] = ACTIONS(2301),
    [anon_sym_struct] = ACTIONS(2303),
    [anon_sym_union] = ACTIONS(2305),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(2293),
    [anon_sym_typename] = ACTIONS(2329),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2341),
    [anon_sym_extension] = ACTIONS(2343),
  },
  [163] = {
    [sym__declaration_modifiers] = STATE(2299),
    [sym__declaration_specifiers] = STATE(4856),
    [sym_attribute_specifier] = STATE(2299),
    [sym_attribute_declaration] = STATE(2299),
    [sym_ms_declspec_modifier] = STATE(2299),
    [sym_storage_class_specifier] = STATE(2299),
    [sym_type_qualifier] = STATE(2299),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2694),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_parameter_declaration] = STATE(9395),
    [sym_expression] = STATE(4214),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9991),
    [sym_dependent_type] = STATE(2741),
    [sym_optional_parameter_declaration] = STATE(9395),
    [sym_variadic_parameter_declaration] = STATE(9395),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym__unary_left_fold] = STATE(10439),
    [sym__unary_right_fold] = STATE(10553),
    [sym__binary_fold] = STATE(10552),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6867),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4251),
    [sym_qualifiers] = STATE(2299),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2299),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(2279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_RPAREN] = ACTIONS(2283),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_out] = ACTIONS(2293),
    [anon_sym_inout] = ACTIONS(2293),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2273),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2297),
    [anon_sym_enum] = ACTIONS(2299),
    [anon_sym_class] = ACTIONS(2301),
    [anon_sym_struct] = ACTIONS(2303),
    [anon_sym_union] = ACTIONS(2305),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(2293),
    [anon_sym_typename] = ACTIONS(2329),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2341),
    [anon_sym_extension] = ACTIONS(2343),
  },
  [164] = {
    [sym__declaration_modifiers] = STATE(2299),
    [sym__declaration_specifiers] = STATE(4856),
    [sym_attribute_specifier] = STATE(2299),
    [sym_attribute_declaration] = STATE(2299),
    [sym_ms_declspec_modifier] = STATE(2299),
    [sym_storage_class_specifier] = STATE(2299),
    [sym_type_qualifier] = STATE(2299),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2694),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_parameter_declaration] = STATE(9395),
    [sym_expression] = STATE(4230),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9991),
    [sym_dependent_type] = STATE(2741),
    [sym_optional_parameter_declaration] = STATE(9395),
    [sym_variadic_parameter_declaration] = STATE(9395),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym__unary_left_fold] = STATE(10569),
    [sym__unary_right_fold] = STATE(10571),
    [sym__binary_fold] = STATE(10572),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6867),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4251),
    [sym_qualifiers] = STATE(2299),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2299),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(2279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_RPAREN] = ACTIONS(2283),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_out] = ACTIONS(2293),
    [anon_sym_inout] = ACTIONS(2293),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2273),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2297),
    [anon_sym_enum] = ACTIONS(2299),
    [anon_sym_class] = ACTIONS(2301),
    [anon_sym_struct] = ACTIONS(2303),
    [anon_sym_union] = ACTIONS(2305),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(2293),
    [anon_sym_typename] = ACTIONS(2329),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2341),
    [anon_sym_extension] = ACTIONS(2343),
  },
  [165] = {
    [sym__declaration_modifiers] = STATE(2299),
    [sym__declaration_specifiers] = STATE(4856),
    [sym_attribute_specifier] = STATE(2299),
    [sym_attribute_declaration] = STATE(2299),
    [sym_ms_declspec_modifier] = STATE(2299),
    [sym_storage_class_specifier] = STATE(2299),
    [sym_type_qualifier] = STATE(2299),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2694),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_parameter_declaration] = STATE(9395),
    [sym_expression] = STATE(4138),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9991),
    [sym_dependent_type] = STATE(2741),
    [sym_optional_parameter_declaration] = STATE(9395),
    [sym_variadic_parameter_declaration] = STATE(9395),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym__unary_left_fold] = STATE(10708),
    [sym__unary_right_fold] = STATE(10705),
    [sym__binary_fold] = STATE(10700),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6867),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4251),
    [sym_qualifiers] = STATE(2299),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2299),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(2279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_RPAREN] = ACTIONS(2283),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_out] = ACTIONS(2293),
    [anon_sym_inout] = ACTIONS(2293),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2273),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2297),
    [anon_sym_enum] = ACTIONS(2299),
    [anon_sym_class] = ACTIONS(2301),
    [anon_sym_struct] = ACTIONS(2303),
    [anon_sym_union] = ACTIONS(2305),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(2293),
    [anon_sym_typename] = ACTIONS(2329),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2341),
    [anon_sym_extension] = ACTIONS(2343),
  },
  [166] = {
    [sym_identifier] = ACTIONS(2186),
    [aux_sym_preproc_include_token1] = ACTIONS(2186),
    [aux_sym_preproc_def_token1] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_COMMA] = ACTIONS(2188),
    [aux_sym_preproc_if_token1] = ACTIONS(2186),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2186),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2186),
    [sym_preproc_directive] = ACTIONS(2186),
    [anon_sym_LPAREN2] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2186),
    [anon_sym_TILDE] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2186),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_STAR] = ACTIONS(2188),
    [anon_sym_SLASH] = ACTIONS(2186),
    [anon_sym_PERCENT] = ACTIONS(2188),
    [anon_sym_PIPE_PIPE] = ACTIONS(2188),
    [anon_sym_AMP_AMP] = ACTIONS(2188),
    [anon_sym_PIPE] = ACTIONS(2186),
    [anon_sym_CARET] = ACTIONS(2188),
    [anon_sym_AMP] = ACTIONS(2186),
    [anon_sym_EQ_EQ] = ACTIONS(2188),
    [anon_sym_BANG_EQ] = ACTIONS(2188),
    [anon_sym_GT] = ACTIONS(2186),
    [anon_sym_GT_EQ] = ACTIONS(2188),
    [anon_sym_LT_EQ] = ACTIONS(2186),
    [anon_sym_LT] = ACTIONS(2186),
    [anon_sym_LT_LT] = ACTIONS(2188),
    [anon_sym_GT_GT] = ACTIONS(2188),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym___extension__] = ACTIONS(2186),
    [anon_sym_typedef] = ACTIONS(2186),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_out] = ACTIONS(2186),
    [anon_sym_inout] = ACTIONS(2186),
    [anon_sym_extern] = ACTIONS(2186),
    [anon_sym___attribute__] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2188),
    [anon_sym___declspec] = ACTIONS(2186),
    [anon_sym___based] = ACTIONS(2186),
    [anon_sym___cdecl] = ACTIONS(2186),
    [anon_sym___clrcall] = ACTIONS(2186),
    [anon_sym___stdcall] = ACTIONS(2186),
    [anon_sym___fastcall] = ACTIONS(2186),
    [anon_sym___thiscall] = ACTIONS(2186),
    [anon_sym___vectorcall] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_RBRACE] = ACTIONS(2188),
    [anon_sym_signed] = ACTIONS(2186),
    [anon_sym_unsigned] = ACTIONS(2186),
    [anon_sym_long] = ACTIONS(2186),
    [anon_sym_short] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_static] = ACTIONS(2186),
    [anon_sym_register] = ACTIONS(2186),
    [anon_sym_inline] = ACTIONS(2186),
    [anon_sym___inline] = ACTIONS(2186),
    [anon_sym___inline__] = ACTIONS(2186),
    [anon_sym___forceinline] = ACTIONS(2186),
    [anon_sym_thread_local] = ACTIONS(2186),
    [anon_sym___thread] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_constexpr] = ACTIONS(2186),
    [anon_sym_volatile] = ACTIONS(2186),
    [anon_sym_restrict] = ACTIONS(2186),
    [anon_sym___restrict__] = ACTIONS(2186),
    [anon_sym__Atomic] = ACTIONS(2186),
    [anon_sym__Noreturn] = ACTIONS(2186),
    [anon_sym_noreturn] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_constinit] = ACTIONS(2186),
    [anon_sym_consteval] = ACTIONS(2186),
    [anon_sym_alignas] = ACTIONS(2186),
    [anon_sym__Alignas] = ACTIONS(2186),
    [sym_primitive_type] = ACTIONS(2186),
    [anon_sym_enum] = ACTIONS(2186),
    [anon_sym_class] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_union] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_switch] = ACTIONS(2186),
    [anon_sym_case] = ACTIONS(2186),
    [anon_sym_default] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [anon_sym_do] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_break] = ACTIONS(2186),
    [anon_sym_continue] = ACTIONS(2186),
    [anon_sym_goto] = ACTIONS(2186),
    [anon_sym___try] = ACTIONS(2186),
    [anon_sym___leave] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2186),
    [anon_sym_compl] = ACTIONS(2186),
    [anon_sym_LT_EQ_GT] = ACTIONS(2188),
    [anon_sym_or] = ACTIONS(2186),
    [anon_sym_and] = ACTIONS(2186),
    [anon_sym_bitor] = ACTIONS(2186),
    [anon_sym_xor] = ACTIONS(2186),
    [anon_sym_bitand] = ACTIONS(2186),
    [anon_sym_not_eq] = ACTIONS(2186),
    [anon_sym_is] = ACTIONS(2186),
    [anon_sym_as] = ACTIONS(2186),
    [anon_sym_DASH_DASH] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2188),
    [anon_sym_sizeof] = ACTIONS(2186),
    [anon_sym___alignof__] = ACTIONS(2186),
    [anon_sym___alignof] = ACTIONS(2186),
    [anon_sym__alignof] = ACTIONS(2186),
    [anon_sym_alignof] = ACTIONS(2186),
    [anon_sym__Alignof] = ACTIONS(2186),
    [anon_sym_offsetof] = ACTIONS(2186),
    [anon_sym__Generic] = ACTIONS(2186),
    [anon_sym_asm] = ACTIONS(2186),
    [anon_sym___asm__] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOT_STAR] = ACTIONS(2188),
    [anon_sym_DASH_GT] = ACTIONS(2188),
    [sym_number_literal] = ACTIONS(2188),
    [anon_sym_L_SQUOTE] = ACTIONS(2188),
    [anon_sym_u_SQUOTE] = ACTIONS(2188),
    [anon_sym_U_SQUOTE] = ACTIONS(2188),
    [anon_sym_u8_SQUOTE] = ACTIONS(2188),
    [anon_sym_SQUOTE] = ACTIONS(2188),
    [anon_sym_L_DQUOTE] = ACTIONS(2188),
    [anon_sym_u_DQUOTE] = ACTIONS(2188),
    [anon_sym_U_DQUOTE] = ACTIONS(2188),
    [anon_sym_u8_DQUOTE] = ACTIONS(2188),
    [anon_sym_DQUOTE] = ACTIONS(2188),
    [sym_true] = ACTIONS(2186),
    [sym_false] = ACTIONS(2186),
    [anon_sym_NULL] = ACTIONS(2186),
    [anon_sym_nullptr] = ACTIONS(2186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_This] = ACTIONS(2186),
    [anon_sym_decltype] = ACTIONS(2186),
    [sym_virtual] = ACTIONS(2186),
    [anon_sym_explicit] = ACTIONS(2186),
    [anon_sym_typename] = ACTIONS(2186),
    [anon_sym_template] = ACTIONS(2186),
    [anon_sym_operator] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_delete] = ACTIONS(2186),
    [anon_sym_throw] = ACTIONS(2186),
    [anon_sym_namespace] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_static_assert] = ACTIONS(2186),
    [anon_sym_concept] = ACTIONS(2186),
    [anon_sym_co_return] = ACTIONS(2186),
    [anon_sym_co_yield] = ACTIONS(2186),
    [anon_sym_R_DQUOTE] = ACTIONS(2188),
    [anon_sym_LR_DQUOTE] = ACTIONS(2188),
    [anon_sym_uR_DQUOTE] = ACTIONS(2188),
    [anon_sym_UR_DQUOTE] = ACTIONS(2188),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2188),
    [anon_sym_co_await] = ACTIONS(2186),
    [anon_sym_new] = ACTIONS(2186),
    [anon_sym_requires] = ACTIONS(2186),
    [sym_this] = ACTIONS(2186),
    [anon_sym_discard] = ACTIONS(2186),
    [anon_sym_precise] = ACTIONS(2186),
    [anon_sym_shared] = ACTIONS(2186),
    [anon_sym_groupshared] = ACTIONS(2186),
    [anon_sym_uniform] = ACTIONS(2186),
    [anon_sym_row_major] = ACTIONS(2186),
    [anon_sym_column_major] = ACTIONS(2186),
    [anon_sym_globallycoherent] = ACTIONS(2186),
    [anon_sym_centroid] = ACTIONS(2186),
    [anon_sym_noperspective] = ACTIONS(2186),
    [anon_sym_nointerpolation] = ACTIONS(2186),
    [anon_sym_sample] = ACTIONS(2186),
    [anon_sym_linear] = ACTIONS(2186),
    [anon_sym_snorm] = ACTIONS(2186),
    [anon_sym_unorm] = ACTIONS(2186),
    [anon_sym_point] = ACTIONS(2186),
    [anon_sym_line] = ACTIONS(2186),
    [anon_sym_triangleadj] = ACTIONS(2186),
    [anon_sym_lineadj] = ACTIONS(2186),
    [anon_sym_triangle] = ACTIONS(2186),
    [anon_sym_cbuffer] = ACTIONS(2186),
    [anon_sym_interface] = ACTIONS(2186),
    [anon_sym_extension] = ACTIONS(2186),
  },
  [167] = {
    [sym_identifier] = ACTIONS(2236),
    [aux_sym_preproc_include_token1] = ACTIONS(2236),
    [aux_sym_preproc_def_token1] = ACTIONS(2236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2238),
    [anon_sym_COMMA] = ACTIONS(2238),
    [aux_sym_preproc_if_token1] = ACTIONS(2236),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2236),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2236),
    [sym_preproc_directive] = ACTIONS(2236),
    [anon_sym_LPAREN2] = ACTIONS(2238),
    [anon_sym_BANG] = ACTIONS(2236),
    [anon_sym_TILDE] = ACTIONS(2238),
    [anon_sym_DASH] = ACTIONS(2236),
    [anon_sym_PLUS] = ACTIONS(2236),
    [anon_sym_STAR] = ACTIONS(2238),
    [anon_sym_SLASH] = ACTIONS(2236),
    [anon_sym_PERCENT] = ACTIONS(2238),
    [anon_sym_PIPE_PIPE] = ACTIONS(2238),
    [anon_sym_AMP_AMP] = ACTIONS(2238),
    [anon_sym_PIPE] = ACTIONS(2236),
    [anon_sym_CARET] = ACTIONS(2238),
    [anon_sym_AMP] = ACTIONS(2236),
    [anon_sym_EQ_EQ] = ACTIONS(2238),
    [anon_sym_BANG_EQ] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2236),
    [anon_sym_GT_EQ] = ACTIONS(2238),
    [anon_sym_LT_EQ] = ACTIONS(2236),
    [anon_sym_LT] = ACTIONS(2236),
    [anon_sym_LT_LT] = ACTIONS(2238),
    [anon_sym_GT_GT] = ACTIONS(2238),
    [anon_sym_SEMI] = ACTIONS(2238),
    [anon_sym___extension__] = ACTIONS(2236),
    [anon_sym_typedef] = ACTIONS(2236),
    [anon_sym_in] = ACTIONS(2236),
    [anon_sym_out] = ACTIONS(2236),
    [anon_sym_inout] = ACTIONS(2236),
    [anon_sym_extern] = ACTIONS(2236),
    [anon_sym___attribute__] = ACTIONS(2236),
    [anon_sym_COLON_COLON] = ACTIONS(2238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2238),
    [anon_sym___declspec] = ACTIONS(2236),
    [anon_sym___based] = ACTIONS(2236),
    [anon_sym___cdecl] = ACTIONS(2236),
    [anon_sym___clrcall] = ACTIONS(2236),
    [anon_sym___stdcall] = ACTIONS(2236),
    [anon_sym___fastcall] = ACTIONS(2236),
    [anon_sym___thiscall] = ACTIONS(2236),
    [anon_sym___vectorcall] = ACTIONS(2236),
    [anon_sym_LBRACE] = ACTIONS(2238),
    [anon_sym_RBRACE] = ACTIONS(2238),
    [anon_sym_signed] = ACTIONS(2236),
    [anon_sym_unsigned] = ACTIONS(2236),
    [anon_sym_long] = ACTIONS(2236),
    [anon_sym_short] = ACTIONS(2236),
    [anon_sym_LBRACK] = ACTIONS(2236),
    [anon_sym_static] = ACTIONS(2236),
    [anon_sym_register] = ACTIONS(2236),
    [anon_sym_inline] = ACTIONS(2236),
    [anon_sym___inline] = ACTIONS(2236),
    [anon_sym___inline__] = ACTIONS(2236),
    [anon_sym___forceinline] = ACTIONS(2236),
    [anon_sym_thread_local] = ACTIONS(2236),
    [anon_sym___thread] = ACTIONS(2236),
    [anon_sym_const] = ACTIONS(2236),
    [anon_sym_constexpr] = ACTIONS(2236),
    [anon_sym_volatile] = ACTIONS(2236),
    [anon_sym_restrict] = ACTIONS(2236),
    [anon_sym___restrict__] = ACTIONS(2236),
    [anon_sym__Atomic] = ACTIONS(2236),
    [anon_sym__Noreturn] = ACTIONS(2236),
    [anon_sym_noreturn] = ACTIONS(2236),
    [anon_sym_mutable] = ACTIONS(2236),
    [anon_sym_constinit] = ACTIONS(2236),
    [anon_sym_consteval] = ACTIONS(2236),
    [anon_sym_alignas] = ACTIONS(2236),
    [anon_sym__Alignas] = ACTIONS(2236),
    [sym_primitive_type] = ACTIONS(2236),
    [anon_sym_enum] = ACTIONS(2236),
    [anon_sym_class] = ACTIONS(2236),
    [anon_sym_struct] = ACTIONS(2236),
    [anon_sym_union] = ACTIONS(2236),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_switch] = ACTIONS(2236),
    [anon_sym_case] = ACTIONS(2236),
    [anon_sym_default] = ACTIONS(2236),
    [anon_sym_while] = ACTIONS(2236),
    [anon_sym_do] = ACTIONS(2236),
    [anon_sym_for] = ACTIONS(2236),
    [anon_sym_return] = ACTIONS(2236),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2236),
    [anon_sym_goto] = ACTIONS(2236),
    [anon_sym___try] = ACTIONS(2236),
    [anon_sym___leave] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_compl] = ACTIONS(2236),
    [anon_sym_LT_EQ_GT] = ACTIONS(2238),
    [anon_sym_or] = ACTIONS(2236),
    [anon_sym_and] = ACTIONS(2236),
    [anon_sym_bitor] = ACTIONS(2236),
    [anon_sym_xor] = ACTIONS(2236),
    [anon_sym_bitand] = ACTIONS(2236),
    [anon_sym_not_eq] = ACTIONS(2236),
    [anon_sym_is] = ACTIONS(2236),
    [anon_sym_as] = ACTIONS(2236),
    [anon_sym_DASH_DASH] = ACTIONS(2238),
    [anon_sym_PLUS_PLUS] = ACTIONS(2238),
    [anon_sym_sizeof] = ACTIONS(2236),
    [anon_sym___alignof__] = ACTIONS(2236),
    [anon_sym___alignof] = ACTIONS(2236),
    [anon_sym__alignof] = ACTIONS(2236),
    [anon_sym_alignof] = ACTIONS(2236),
    [anon_sym__Alignof] = ACTIONS(2236),
    [anon_sym_offsetof] = ACTIONS(2236),
    [anon_sym__Generic] = ACTIONS(2236),
    [anon_sym_asm] = ACTIONS(2236),
    [anon_sym___asm__] = ACTIONS(2236),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_DOT_STAR] = ACTIONS(2238),
    [anon_sym_DASH_GT] = ACTIONS(2238),
    [sym_number_literal] = ACTIONS(2238),
    [anon_sym_L_SQUOTE] = ACTIONS(2238),
    [anon_sym_u_SQUOTE] = ACTIONS(2238),
    [anon_sym_U_SQUOTE] = ACTIONS(2238),
    [anon_sym_u8_SQUOTE] = ACTIONS(2238),
    [anon_sym_SQUOTE] = ACTIONS(2238),
    [anon_sym_L_DQUOTE] = ACTIONS(2238),
    [anon_sym_u_DQUOTE] = ACTIONS(2238),
    [anon_sym_U_DQUOTE] = ACTIONS(2238),
    [anon_sym_u8_DQUOTE] = ACTIONS(2238),
    [anon_sym_DQUOTE] = ACTIONS(2238),
    [sym_true] = ACTIONS(2236),
    [sym_false] = ACTIONS(2236),
    [anon_sym_NULL] = ACTIONS(2236),
    [anon_sym_nullptr] = ACTIONS(2236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2236),
    [anon_sym_let] = ACTIONS(2236),
    [anon_sym_This] = ACTIONS(2236),
    [anon_sym_decltype] = ACTIONS(2236),
    [sym_virtual] = ACTIONS(2236),
    [anon_sym_explicit] = ACTIONS(2236),
    [anon_sym_typename] = ACTIONS(2236),
    [anon_sym_template] = ACTIONS(2236),
    [anon_sym_operator] = ACTIONS(2236),
    [anon_sym_try] = ACTIONS(2236),
    [anon_sym_delete] = ACTIONS(2236),
    [anon_sym_throw] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(2236),
    [anon_sym_using] = ACTIONS(2236),
    [anon_sym_static_assert] = ACTIONS(2236),
    [anon_sym_concept] = ACTIONS(2236),
    [anon_sym_co_return] = ACTIONS(2236),
    [anon_sym_co_yield] = ACTIONS(2236),
    [anon_sym_R_DQUOTE] = ACTIONS(2238),
    [anon_sym_LR_DQUOTE] = ACTIONS(2238),
    [anon_sym_uR_DQUOTE] = ACTIONS(2238),
    [anon_sym_UR_DQUOTE] = ACTIONS(2238),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2238),
    [anon_sym_co_await] = ACTIONS(2236),
    [anon_sym_new] = ACTIONS(2236),
    [anon_sym_requires] = ACTIONS(2236),
    [sym_this] = ACTIONS(2236),
    [anon_sym_discard] = ACTIONS(2236),
    [anon_sym_precise] = ACTIONS(2236),
    [anon_sym_shared] = ACTIONS(2236),
    [anon_sym_groupshared] = ACTIONS(2236),
    [anon_sym_uniform] = ACTIONS(2236),
    [anon_sym_row_major] = ACTIONS(2236),
    [anon_sym_column_major] = ACTIONS(2236),
    [anon_sym_globallycoherent] = ACTIONS(2236),
    [anon_sym_centroid] = ACTIONS(2236),
    [anon_sym_noperspective] = ACTIONS(2236),
    [anon_sym_nointerpolation] = ACTIONS(2236),
    [anon_sym_sample] = ACTIONS(2236),
    [anon_sym_linear] = ACTIONS(2236),
    [anon_sym_snorm] = ACTIONS(2236),
    [anon_sym_unorm] = ACTIONS(2236),
    [anon_sym_point] = ACTIONS(2236),
    [anon_sym_line] = ACTIONS(2236),
    [anon_sym_triangleadj] = ACTIONS(2236),
    [anon_sym_lineadj] = ACTIONS(2236),
    [anon_sym_triangle] = ACTIONS(2236),
    [anon_sym_cbuffer] = ACTIONS(2236),
    [anon_sym_interface] = ACTIONS(2236),
    [anon_sym_extension] = ACTIONS(2236),
  },
  [168] = {
    [sym_identifier] = ACTIONS(2232),
    [aux_sym_preproc_include_token1] = ACTIONS(2232),
    [aux_sym_preproc_def_token1] = ACTIONS(2232),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_COMMA] = ACTIONS(2234),
    [aux_sym_preproc_if_token1] = ACTIONS(2232),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2232),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2232),
    [sym_preproc_directive] = ACTIONS(2232),
    [anon_sym_LPAREN2] = ACTIONS(2234),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2232),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2232),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_PIPE_PIPE] = ACTIONS(2234),
    [anon_sym_AMP_AMP] = ACTIONS(2234),
    [anon_sym_PIPE] = ACTIONS(2232),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2232),
    [anon_sym_EQ_EQ] = ACTIONS(2234),
    [anon_sym_BANG_EQ] = ACTIONS(2234),
    [anon_sym_GT] = ACTIONS(2232),
    [anon_sym_GT_EQ] = ACTIONS(2234),
    [anon_sym_LT_EQ] = ACTIONS(2232),
    [anon_sym_LT] = ACTIONS(2232),
    [anon_sym_LT_LT] = ACTIONS(2234),
    [anon_sym_GT_GT] = ACTIONS(2234),
    [anon_sym_SEMI] = ACTIONS(2234),
    [anon_sym___extension__] = ACTIONS(2232),
    [anon_sym_typedef] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2232),
    [anon_sym_out] = ACTIONS(2232),
    [anon_sym_inout] = ACTIONS(2232),
    [anon_sym_extern] = ACTIONS(2232),
    [anon_sym___attribute__] = ACTIONS(2232),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2234),
    [anon_sym___declspec] = ACTIONS(2232),
    [anon_sym___based] = ACTIONS(2232),
    [anon_sym___cdecl] = ACTIONS(2232),
    [anon_sym___clrcall] = ACTIONS(2232),
    [anon_sym___stdcall] = ACTIONS(2232),
    [anon_sym___fastcall] = ACTIONS(2232),
    [anon_sym___thiscall] = ACTIONS(2232),
    [anon_sym___vectorcall] = ACTIONS(2232),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_RBRACE] = ACTIONS(2234),
    [anon_sym_signed] = ACTIONS(2232),
    [anon_sym_unsigned] = ACTIONS(2232),
    [anon_sym_long] = ACTIONS(2232),
    [anon_sym_short] = ACTIONS(2232),
    [anon_sym_LBRACK] = ACTIONS(2232),
    [anon_sym_static] = ACTIONS(2232),
    [anon_sym_register] = ACTIONS(2232),
    [anon_sym_inline] = ACTIONS(2232),
    [anon_sym___inline] = ACTIONS(2232),
    [anon_sym___inline__] = ACTIONS(2232),
    [anon_sym___forceinline] = ACTIONS(2232),
    [anon_sym_thread_local] = ACTIONS(2232),
    [anon_sym___thread] = ACTIONS(2232),
    [anon_sym_const] = ACTIONS(2232),
    [anon_sym_constexpr] = ACTIONS(2232),
    [anon_sym_volatile] = ACTIONS(2232),
    [anon_sym_restrict] = ACTIONS(2232),
    [anon_sym___restrict__] = ACTIONS(2232),
    [anon_sym__Atomic] = ACTIONS(2232),
    [anon_sym__Noreturn] = ACTIONS(2232),
    [anon_sym_noreturn] = ACTIONS(2232),
    [anon_sym_mutable] = ACTIONS(2232),
    [anon_sym_constinit] = ACTIONS(2232),
    [anon_sym_consteval] = ACTIONS(2232),
    [anon_sym_alignas] = ACTIONS(2232),
    [anon_sym__Alignas] = ACTIONS(2232),
    [sym_primitive_type] = ACTIONS(2232),
    [anon_sym_enum] = ACTIONS(2232),
    [anon_sym_class] = ACTIONS(2232),
    [anon_sym_struct] = ACTIONS(2232),
    [anon_sym_union] = ACTIONS(2232),
    [anon_sym_if] = ACTIONS(2232),
    [anon_sym_switch] = ACTIONS(2232),
    [anon_sym_case] = ACTIONS(2232),
    [anon_sym_default] = ACTIONS(2232),
    [anon_sym_while] = ACTIONS(2232),
    [anon_sym_do] = ACTIONS(2232),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2232),
    [anon_sym_break] = ACTIONS(2232),
    [anon_sym_continue] = ACTIONS(2232),
    [anon_sym_goto] = ACTIONS(2232),
    [anon_sym___try] = ACTIONS(2232),
    [anon_sym___leave] = ACTIONS(2232),
    [anon_sym_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2232),
    [anon_sym_compl] = ACTIONS(2232),
    [anon_sym_LT_EQ_GT] = ACTIONS(2234),
    [anon_sym_or] = ACTIONS(2232),
    [anon_sym_and] = ACTIONS(2232),
    [anon_sym_bitor] = ACTIONS(2232),
    [anon_sym_xor] = ACTIONS(2232),
    [anon_sym_bitand] = ACTIONS(2232),
    [anon_sym_not_eq] = ACTIONS(2232),
    [anon_sym_is] = ACTIONS(2232),
    [anon_sym_as] = ACTIONS(2232),
    [anon_sym_DASH_DASH] = ACTIONS(2234),
    [anon_sym_PLUS_PLUS] = ACTIONS(2234),
    [anon_sym_sizeof] = ACTIONS(2232),
    [anon_sym___alignof__] = ACTIONS(2232),
    [anon_sym___alignof] = ACTIONS(2232),
    [anon_sym__alignof] = ACTIONS(2232),
    [anon_sym_alignof] = ACTIONS(2232),
    [anon_sym__Alignof] = ACTIONS(2232),
    [anon_sym_offsetof] = ACTIONS(2232),
    [anon_sym__Generic] = ACTIONS(2232),
    [anon_sym_asm] = ACTIONS(2232),
    [anon_sym___asm__] = ACTIONS(2232),
    [anon_sym_DOT] = ACTIONS(2232),
    [anon_sym_DOT_STAR] = ACTIONS(2234),
    [anon_sym_DASH_GT] = ACTIONS(2234),
    [sym_number_literal] = ACTIONS(2234),
    [anon_sym_L_SQUOTE] = ACTIONS(2234),
    [anon_sym_u_SQUOTE] = ACTIONS(2234),
    [anon_sym_U_SQUOTE] = ACTIONS(2234),
    [anon_sym_u8_SQUOTE] = ACTIONS(2234),
    [anon_sym_SQUOTE] = ACTIONS(2234),
    [anon_sym_L_DQUOTE] = ACTIONS(2234),
    [anon_sym_u_DQUOTE] = ACTIONS(2234),
    [anon_sym_U_DQUOTE] = ACTIONS(2234),
    [anon_sym_u8_DQUOTE] = ACTIONS(2234),
    [anon_sym_DQUOTE] = ACTIONS(2234),
    [sym_true] = ACTIONS(2232),
    [sym_false] = ACTIONS(2232),
    [anon_sym_NULL] = ACTIONS(2232),
    [anon_sym_nullptr] = ACTIONS(2232),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2232),
    [anon_sym_let] = ACTIONS(2232),
    [anon_sym_This] = ACTIONS(2232),
    [anon_sym_decltype] = ACTIONS(2232),
    [sym_virtual] = ACTIONS(2232),
    [anon_sym_explicit] = ACTIONS(2232),
    [anon_sym_typename] = ACTIONS(2232),
    [anon_sym_template] = ACTIONS(2232),
    [anon_sym_operator] = ACTIONS(2232),
    [anon_sym_try] = ACTIONS(2232),
    [anon_sym_delete] = ACTIONS(2232),
    [anon_sym_throw] = ACTIONS(2232),
    [anon_sym_namespace] = ACTIONS(2232),
    [anon_sym_using] = ACTIONS(2232),
    [anon_sym_static_assert] = ACTIONS(2232),
    [anon_sym_concept] = ACTIONS(2232),
    [anon_sym_co_return] = ACTIONS(2232),
    [anon_sym_co_yield] = ACTIONS(2232),
    [anon_sym_R_DQUOTE] = ACTIONS(2234),
    [anon_sym_LR_DQUOTE] = ACTIONS(2234),
    [anon_sym_uR_DQUOTE] = ACTIONS(2234),
    [anon_sym_UR_DQUOTE] = ACTIONS(2234),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2234),
    [anon_sym_co_await] = ACTIONS(2232),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_requires] = ACTIONS(2232),
    [sym_this] = ACTIONS(2232),
    [anon_sym_discard] = ACTIONS(2232),
    [anon_sym_precise] = ACTIONS(2232),
    [anon_sym_shared] = ACTIONS(2232),
    [anon_sym_groupshared] = ACTIONS(2232),
    [anon_sym_uniform] = ACTIONS(2232),
    [anon_sym_row_major] = ACTIONS(2232),
    [anon_sym_column_major] = ACTIONS(2232),
    [anon_sym_globallycoherent] = ACTIONS(2232),
    [anon_sym_centroid] = ACTIONS(2232),
    [anon_sym_noperspective] = ACTIONS(2232),
    [anon_sym_nointerpolation] = ACTIONS(2232),
    [anon_sym_sample] = ACTIONS(2232),
    [anon_sym_linear] = ACTIONS(2232),
    [anon_sym_snorm] = ACTIONS(2232),
    [anon_sym_unorm] = ACTIONS(2232),
    [anon_sym_point] = ACTIONS(2232),
    [anon_sym_line] = ACTIONS(2232),
    [anon_sym_triangleadj] = ACTIONS(2232),
    [anon_sym_lineadj] = ACTIONS(2232),
    [anon_sym_triangle] = ACTIONS(2232),
    [anon_sym_cbuffer] = ACTIONS(2232),
    [anon_sym_interface] = ACTIONS(2232),
    [anon_sym_extension] = ACTIONS(2232),
  },
  [169] = {
    [sym_identifier] = ACTIONS(2244),
    [aux_sym_preproc_include_token1] = ACTIONS(2244),
    [aux_sym_preproc_def_token1] = ACTIONS(2244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(2246),
    [aux_sym_preproc_if_token1] = ACTIONS(2244),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2244),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2244),
    [sym_preproc_directive] = ACTIONS(2244),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_BANG] = ACTIONS(2244),
    [anon_sym_TILDE] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2244),
    [anon_sym_PLUS] = ACTIONS(2244),
    [anon_sym_STAR] = ACTIONS(2246),
    [anon_sym_SLASH] = ACTIONS(2244),
    [anon_sym_PERCENT] = ACTIONS(2246),
    [anon_sym_PIPE_PIPE] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2244),
    [anon_sym_CARET] = ACTIONS(2246),
    [anon_sym_AMP] = ACTIONS(2244),
    [anon_sym_EQ_EQ] = ACTIONS(2246),
    [anon_sym_BANG_EQ] = ACTIONS(2246),
    [anon_sym_GT] = ACTIONS(2244),
    [anon_sym_GT_EQ] = ACTIONS(2246),
    [anon_sym_LT_EQ] = ACTIONS(2244),
    [anon_sym_LT] = ACTIONS(2244),
    [anon_sym_LT_LT] = ACTIONS(2246),
    [anon_sym_GT_GT] = ACTIONS(2246),
    [anon_sym_SEMI] = ACTIONS(2246),
    [anon_sym___extension__] = ACTIONS(2244),
    [anon_sym_typedef] = ACTIONS(2244),
    [anon_sym_in] = ACTIONS(2244),
    [anon_sym_out] = ACTIONS(2244),
    [anon_sym_inout] = ACTIONS(2244),
    [anon_sym_extern] = ACTIONS(2244),
    [anon_sym___attribute__] = ACTIONS(2244),
    [anon_sym_COLON_COLON] = ACTIONS(2246),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2246),
    [anon_sym___declspec] = ACTIONS(2244),
    [anon_sym___based] = ACTIONS(2244),
    [anon_sym___cdecl] = ACTIONS(2244),
    [anon_sym___clrcall] = ACTIONS(2244),
    [anon_sym___stdcall] = ACTIONS(2244),
    [anon_sym___fastcall] = ACTIONS(2244),
    [anon_sym___thiscall] = ACTIONS(2244),
    [anon_sym___vectorcall] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_RBRACE] = ACTIONS(2246),
    [anon_sym_signed] = ACTIONS(2244),
    [anon_sym_unsigned] = ACTIONS(2244),
    [anon_sym_long] = ACTIONS(2244),
    [anon_sym_short] = ACTIONS(2244),
    [anon_sym_LBRACK] = ACTIONS(2244),
    [anon_sym_static] = ACTIONS(2244),
    [anon_sym_register] = ACTIONS(2244),
    [anon_sym_inline] = ACTIONS(2244),
    [anon_sym___inline] = ACTIONS(2244),
    [anon_sym___inline__] = ACTIONS(2244),
    [anon_sym___forceinline] = ACTIONS(2244),
    [anon_sym_thread_local] = ACTIONS(2244),
    [anon_sym___thread] = ACTIONS(2244),
    [anon_sym_const] = ACTIONS(2244),
    [anon_sym_constexpr] = ACTIONS(2244),
    [anon_sym_volatile] = ACTIONS(2244),
    [anon_sym_restrict] = ACTIONS(2244),
    [anon_sym___restrict__] = ACTIONS(2244),
    [anon_sym__Atomic] = ACTIONS(2244),
    [anon_sym__Noreturn] = ACTIONS(2244),
    [anon_sym_noreturn] = ACTIONS(2244),
    [anon_sym_mutable] = ACTIONS(2244),
    [anon_sym_constinit] = ACTIONS(2244),
    [anon_sym_consteval] = ACTIONS(2244),
    [anon_sym_alignas] = ACTIONS(2244),
    [anon_sym__Alignas] = ACTIONS(2244),
    [sym_primitive_type] = ACTIONS(2244),
    [anon_sym_enum] = ACTIONS(2244),
    [anon_sym_class] = ACTIONS(2244),
    [anon_sym_struct] = ACTIONS(2244),
    [anon_sym_union] = ACTIONS(2244),
    [anon_sym_if] = ACTIONS(2244),
    [anon_sym_switch] = ACTIONS(2244),
    [anon_sym_case] = ACTIONS(2244),
    [anon_sym_default] = ACTIONS(2244),
    [anon_sym_while] = ACTIONS(2244),
    [anon_sym_do] = ACTIONS(2244),
    [anon_sym_for] = ACTIONS(2244),
    [anon_sym_return] = ACTIONS(2244),
    [anon_sym_break] = ACTIONS(2244),
    [anon_sym_continue] = ACTIONS(2244),
    [anon_sym_goto] = ACTIONS(2244),
    [anon_sym___try] = ACTIONS(2244),
    [anon_sym___leave] = ACTIONS(2244),
    [anon_sym_QMARK] = ACTIONS(2246),
    [anon_sym_not] = ACTIONS(2244),
    [anon_sym_compl] = ACTIONS(2244),
    [anon_sym_LT_EQ_GT] = ACTIONS(2246),
    [anon_sym_or] = ACTIONS(2244),
    [anon_sym_and] = ACTIONS(2244),
    [anon_sym_bitor] = ACTIONS(2244),
    [anon_sym_xor] = ACTIONS(2244),
    [anon_sym_bitand] = ACTIONS(2244),
    [anon_sym_not_eq] = ACTIONS(2244),
    [anon_sym_is] = ACTIONS(2244),
    [anon_sym_as] = ACTIONS(2244),
    [anon_sym_DASH_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_PLUS] = ACTIONS(2246),
    [anon_sym_sizeof] = ACTIONS(2244),
    [anon_sym___alignof__] = ACTIONS(2244),
    [anon_sym___alignof] = ACTIONS(2244),
    [anon_sym__alignof] = ACTIONS(2244),
    [anon_sym_alignof] = ACTIONS(2244),
    [anon_sym__Alignof] = ACTIONS(2244),
    [anon_sym_offsetof] = ACTIONS(2244),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2244),
    [anon_sym___asm__] = ACTIONS(2244),
    [anon_sym_DOT] = ACTIONS(2244),
    [anon_sym_DOT_STAR] = ACTIONS(2246),
    [anon_sym_DASH_GT] = ACTIONS(2246),
    [sym_number_literal] = ACTIONS(2246),
    [anon_sym_L_SQUOTE] = ACTIONS(2246),
    [anon_sym_u_SQUOTE] = ACTIONS(2246),
    [anon_sym_U_SQUOTE] = ACTIONS(2246),
    [anon_sym_u8_SQUOTE] = ACTIONS(2246),
    [anon_sym_SQUOTE] = ACTIONS(2246),
    [anon_sym_L_DQUOTE] = ACTIONS(2246),
    [anon_sym_u_DQUOTE] = ACTIONS(2246),
    [anon_sym_U_DQUOTE] = ACTIONS(2246),
    [anon_sym_u8_DQUOTE] = ACTIONS(2246),
    [anon_sym_DQUOTE] = ACTIONS(2246),
    [sym_true] = ACTIONS(2244),
    [sym_false] = ACTIONS(2244),
    [anon_sym_NULL] = ACTIONS(2244),
    [anon_sym_nullptr] = ACTIONS(2244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2244),
    [anon_sym_let] = ACTIONS(2244),
    [anon_sym_This] = ACTIONS(2244),
    [anon_sym_decltype] = ACTIONS(2244),
    [sym_virtual] = ACTIONS(2244),
    [anon_sym_explicit] = ACTIONS(2244),
    [anon_sym_typename] = ACTIONS(2244),
    [anon_sym_template] = ACTIONS(2244),
    [anon_sym_operator] = ACTIONS(2244),
    [anon_sym_try] = ACTIONS(2244),
    [anon_sym_delete] = ACTIONS(2244),
    [anon_sym_throw] = ACTIONS(2244),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_using] = ACTIONS(2244),
    [anon_sym_static_assert] = ACTIONS(2244),
    [anon_sym_concept] = ACTIONS(2244),
    [anon_sym_co_return] = ACTIONS(2244),
    [anon_sym_co_yield] = ACTIONS(2244),
    [anon_sym_R_DQUOTE] = ACTIONS(2246),
    [anon_sym_LR_DQUOTE] = ACTIONS(2246),
    [anon_sym_uR_DQUOTE] = ACTIONS(2246),
    [anon_sym_UR_DQUOTE] = ACTIONS(2246),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2246),
    [anon_sym_co_await] = ACTIONS(2244),
    [anon_sym_new] = ACTIONS(2244),
    [anon_sym_requires] = ACTIONS(2244),
    [sym_this] = ACTIONS(2244),
    [anon_sym_discard] = ACTIONS(2244),
    [anon_sym_precise] = ACTIONS(2244),
    [anon_sym_shared] = ACTIONS(2244),
    [anon_sym_groupshared] = ACTIONS(2244),
    [anon_sym_uniform] = ACTIONS(2244),
    [anon_sym_row_major] = ACTIONS(2244),
    [anon_sym_column_major] = ACTIONS(2244),
    [anon_sym_globallycoherent] = ACTIONS(2244),
    [anon_sym_centroid] = ACTIONS(2244),
    [anon_sym_noperspective] = ACTIONS(2244),
    [anon_sym_nointerpolation] = ACTIONS(2244),
    [anon_sym_sample] = ACTIONS(2244),
    [anon_sym_linear] = ACTIONS(2244),
    [anon_sym_snorm] = ACTIONS(2244),
    [anon_sym_unorm] = ACTIONS(2244),
    [anon_sym_point] = ACTIONS(2244),
    [anon_sym_line] = ACTIONS(2244),
    [anon_sym_triangleadj] = ACTIONS(2244),
    [anon_sym_lineadj] = ACTIONS(2244),
    [anon_sym_triangle] = ACTIONS(2244),
    [anon_sym_cbuffer] = ACTIONS(2244),
    [anon_sym_interface] = ACTIONS(2244),
    [anon_sym_extension] = ACTIONS(2244),
  },
  [170] = {
    [sym_identifier] = ACTIONS(2206),
    [aux_sym_preproc_include_token1] = ACTIONS(2206),
    [aux_sym_preproc_def_token1] = ACTIONS(2206),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2208),
    [anon_sym_COMMA] = ACTIONS(2208),
    [aux_sym_preproc_if_token1] = ACTIONS(2206),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2206),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2206),
    [sym_preproc_directive] = ACTIONS(2206),
    [anon_sym_LPAREN2] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2208),
    [anon_sym_DASH] = ACTIONS(2206),
    [anon_sym_PLUS] = ACTIONS(2206),
    [anon_sym_STAR] = ACTIONS(2208),
    [anon_sym_SLASH] = ACTIONS(2206),
    [anon_sym_PERCENT] = ACTIONS(2208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2208),
    [anon_sym_AMP_AMP] = ACTIONS(2208),
    [anon_sym_PIPE] = ACTIONS(2206),
    [anon_sym_CARET] = ACTIONS(2208),
    [anon_sym_AMP] = ACTIONS(2206),
    [anon_sym_EQ_EQ] = ACTIONS(2208),
    [anon_sym_BANG_EQ] = ACTIONS(2208),
    [anon_sym_GT] = ACTIONS(2206),
    [anon_sym_GT_EQ] = ACTIONS(2208),
    [anon_sym_LT_EQ] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2206),
    [anon_sym_LT_LT] = ACTIONS(2208),
    [anon_sym_GT_GT] = ACTIONS(2208),
    [anon_sym_SEMI] = ACTIONS(2208),
    [anon_sym___extension__] = ACTIONS(2206),
    [anon_sym_typedef] = ACTIONS(2206),
    [anon_sym_in] = ACTIONS(2206),
    [anon_sym_out] = ACTIONS(2206),
    [anon_sym_inout] = ACTIONS(2206),
    [anon_sym_extern] = ACTIONS(2206),
    [anon_sym___attribute__] = ACTIONS(2206),
    [anon_sym_COLON_COLON] = ACTIONS(2208),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2208),
    [anon_sym___declspec] = ACTIONS(2206),
    [anon_sym___based] = ACTIONS(2206),
    [anon_sym___cdecl] = ACTIONS(2206),
    [anon_sym___clrcall] = ACTIONS(2206),
    [anon_sym___stdcall] = ACTIONS(2206),
    [anon_sym___fastcall] = ACTIONS(2206),
    [anon_sym___thiscall] = ACTIONS(2206),
    [anon_sym___vectorcall] = ACTIONS(2206),
    [anon_sym_LBRACE] = ACTIONS(2208),
    [anon_sym_RBRACE] = ACTIONS(2208),
    [anon_sym_signed] = ACTIONS(2206),
    [anon_sym_unsigned] = ACTIONS(2206),
    [anon_sym_long] = ACTIONS(2206),
    [anon_sym_short] = ACTIONS(2206),
    [anon_sym_LBRACK] = ACTIONS(2206),
    [anon_sym_static] = ACTIONS(2206),
    [anon_sym_register] = ACTIONS(2206),
    [anon_sym_inline] = ACTIONS(2206),
    [anon_sym___inline] = ACTIONS(2206),
    [anon_sym___inline__] = ACTIONS(2206),
    [anon_sym___forceinline] = ACTIONS(2206),
    [anon_sym_thread_local] = ACTIONS(2206),
    [anon_sym___thread] = ACTIONS(2206),
    [anon_sym_const] = ACTIONS(2206),
    [anon_sym_constexpr] = ACTIONS(2206),
    [anon_sym_volatile] = ACTIONS(2206),
    [anon_sym_restrict] = ACTIONS(2206),
    [anon_sym___restrict__] = ACTIONS(2206),
    [anon_sym__Atomic] = ACTIONS(2206),
    [anon_sym__Noreturn] = ACTIONS(2206),
    [anon_sym_noreturn] = ACTIONS(2206),
    [anon_sym_mutable] = ACTIONS(2206),
    [anon_sym_constinit] = ACTIONS(2206),
    [anon_sym_consteval] = ACTIONS(2206),
    [anon_sym_alignas] = ACTIONS(2206),
    [anon_sym__Alignas] = ACTIONS(2206),
    [sym_primitive_type] = ACTIONS(2206),
    [anon_sym_enum] = ACTIONS(2206),
    [anon_sym_class] = ACTIONS(2206),
    [anon_sym_struct] = ACTIONS(2206),
    [anon_sym_union] = ACTIONS(2206),
    [anon_sym_if] = ACTIONS(2206),
    [anon_sym_switch] = ACTIONS(2206),
    [anon_sym_case] = ACTIONS(2206),
    [anon_sym_default] = ACTIONS(2206),
    [anon_sym_while] = ACTIONS(2206),
    [anon_sym_do] = ACTIONS(2206),
    [anon_sym_for] = ACTIONS(2206),
    [anon_sym_return] = ACTIONS(2206),
    [anon_sym_break] = ACTIONS(2206),
    [anon_sym_continue] = ACTIONS(2206),
    [anon_sym_goto] = ACTIONS(2206),
    [anon_sym___try] = ACTIONS(2206),
    [anon_sym___leave] = ACTIONS(2206),
    [anon_sym_QMARK] = ACTIONS(2208),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_compl] = ACTIONS(2206),
    [anon_sym_LT_EQ_GT] = ACTIONS(2208),
    [anon_sym_or] = ACTIONS(2206),
    [anon_sym_and] = ACTIONS(2206),
    [anon_sym_bitor] = ACTIONS(2206),
    [anon_sym_xor] = ACTIONS(2206),
    [anon_sym_bitand] = ACTIONS(2206),
    [anon_sym_not_eq] = ACTIONS(2206),
    [anon_sym_is] = ACTIONS(2206),
    [anon_sym_as] = ACTIONS(2206),
    [anon_sym_DASH_DASH] = ACTIONS(2208),
    [anon_sym_PLUS_PLUS] = ACTIONS(2208),
    [anon_sym_sizeof] = ACTIONS(2206),
    [anon_sym___alignof__] = ACTIONS(2206),
    [anon_sym___alignof] = ACTIONS(2206),
    [anon_sym__alignof] = ACTIONS(2206),
    [anon_sym_alignof] = ACTIONS(2206),
    [anon_sym__Alignof] = ACTIONS(2206),
    [anon_sym_offsetof] = ACTIONS(2206),
    [anon_sym__Generic] = ACTIONS(2206),
    [anon_sym_asm] = ACTIONS(2206),
    [anon_sym___asm__] = ACTIONS(2206),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_DOT_STAR] = ACTIONS(2208),
    [anon_sym_DASH_GT] = ACTIONS(2208),
    [sym_number_literal] = ACTIONS(2208),
    [anon_sym_L_SQUOTE] = ACTIONS(2208),
    [anon_sym_u_SQUOTE] = ACTIONS(2208),
    [anon_sym_U_SQUOTE] = ACTIONS(2208),
    [anon_sym_u8_SQUOTE] = ACTIONS(2208),
    [anon_sym_SQUOTE] = ACTIONS(2208),
    [anon_sym_L_DQUOTE] = ACTIONS(2208),
    [anon_sym_u_DQUOTE] = ACTIONS(2208),
    [anon_sym_U_DQUOTE] = ACTIONS(2208),
    [anon_sym_u8_DQUOTE] = ACTIONS(2208),
    [anon_sym_DQUOTE] = ACTIONS(2208),
    [sym_true] = ACTIONS(2206),
    [sym_false] = ACTIONS(2206),
    [anon_sym_NULL] = ACTIONS(2206),
    [anon_sym_nullptr] = ACTIONS(2206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2206),
    [anon_sym_let] = ACTIONS(2206),
    [anon_sym_This] = ACTIONS(2206),
    [anon_sym_decltype] = ACTIONS(2206),
    [sym_virtual] = ACTIONS(2206),
    [anon_sym_explicit] = ACTIONS(2206),
    [anon_sym_typename] = ACTIONS(2206),
    [anon_sym_template] = ACTIONS(2206),
    [anon_sym_operator] = ACTIONS(2206),
    [anon_sym_try] = ACTIONS(2206),
    [anon_sym_delete] = ACTIONS(2206),
    [anon_sym_throw] = ACTIONS(2206),
    [anon_sym_namespace] = ACTIONS(2206),
    [anon_sym_using] = ACTIONS(2206),
    [anon_sym_static_assert] = ACTIONS(2206),
    [anon_sym_concept] = ACTIONS(2206),
    [anon_sym_co_return] = ACTIONS(2206),
    [anon_sym_co_yield] = ACTIONS(2206),
    [anon_sym_R_DQUOTE] = ACTIONS(2208),
    [anon_sym_LR_DQUOTE] = ACTIONS(2208),
    [anon_sym_uR_DQUOTE] = ACTIONS(2208),
    [anon_sym_UR_DQUOTE] = ACTIONS(2208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2208),
    [anon_sym_co_await] = ACTIONS(2206),
    [anon_sym_new] = ACTIONS(2206),
    [anon_sym_requires] = ACTIONS(2206),
    [sym_this] = ACTIONS(2206),
    [anon_sym_discard] = ACTIONS(2206),
    [anon_sym_precise] = ACTIONS(2206),
    [anon_sym_shared] = ACTIONS(2206),
    [anon_sym_groupshared] = ACTIONS(2206),
    [anon_sym_uniform] = ACTIONS(2206),
    [anon_sym_row_major] = ACTIONS(2206),
    [anon_sym_column_major] = ACTIONS(2206),
    [anon_sym_globallycoherent] = ACTIONS(2206),
    [anon_sym_centroid] = ACTIONS(2206),
    [anon_sym_noperspective] = ACTIONS(2206),
    [anon_sym_nointerpolation] = ACTIONS(2206),
    [anon_sym_sample] = ACTIONS(2206),
    [anon_sym_linear] = ACTIONS(2206),
    [anon_sym_snorm] = ACTIONS(2206),
    [anon_sym_unorm] = ACTIONS(2206),
    [anon_sym_point] = ACTIONS(2206),
    [anon_sym_line] = ACTIONS(2206),
    [anon_sym_triangleadj] = ACTIONS(2206),
    [anon_sym_lineadj] = ACTIONS(2206),
    [anon_sym_triangle] = ACTIONS(2206),
    [anon_sym_cbuffer] = ACTIONS(2206),
    [anon_sym_interface] = ACTIONS(2206),
    [anon_sym_extension] = ACTIONS(2206),
  },
  [171] = {
    [sym_identifier] = ACTIONS(2252),
    [aux_sym_preproc_include_token1] = ACTIONS(2252),
    [aux_sym_preproc_def_token1] = ACTIONS(2252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2254),
    [anon_sym_COMMA] = ACTIONS(2254),
    [aux_sym_preproc_if_token1] = ACTIONS(2252),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2252),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2252),
    [sym_preproc_directive] = ACTIONS(2252),
    [anon_sym_LPAREN2] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2252),
    [anon_sym_TILDE] = ACTIONS(2254),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2254),
    [anon_sym_SLASH] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2254),
    [anon_sym_PIPE_PIPE] = ACTIONS(2254),
    [anon_sym_AMP_AMP] = ACTIONS(2254),
    [anon_sym_PIPE] = ACTIONS(2252),
    [anon_sym_CARET] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_EQ_EQ] = ACTIONS(2254),
    [anon_sym_BANG_EQ] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2252),
    [anon_sym_GT_EQ] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2252),
    [anon_sym_LT_LT] = ACTIONS(2254),
    [anon_sym_GT_GT] = ACTIONS(2254),
    [anon_sym_SEMI] = ACTIONS(2254),
    [anon_sym___extension__] = ACTIONS(2252),
    [anon_sym_typedef] = ACTIONS(2252),
    [anon_sym_in] = ACTIONS(2252),
    [anon_sym_out] = ACTIONS(2252),
    [anon_sym_inout] = ACTIONS(2252),
    [anon_sym_extern] = ACTIONS(2252),
    [anon_sym___attribute__] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2254),
    [anon_sym___declspec] = ACTIONS(2252),
    [anon_sym___based] = ACTIONS(2252),
    [anon_sym___cdecl] = ACTIONS(2252),
    [anon_sym___clrcall] = ACTIONS(2252),
    [anon_sym___stdcall] = ACTIONS(2252),
    [anon_sym___fastcall] = ACTIONS(2252),
    [anon_sym___thiscall] = ACTIONS(2252),
    [anon_sym___vectorcall] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_RBRACE] = ACTIONS(2254),
    [anon_sym_signed] = ACTIONS(2252),
    [anon_sym_unsigned] = ACTIONS(2252),
    [anon_sym_long] = ACTIONS(2252),
    [anon_sym_short] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2252),
    [anon_sym_register] = ACTIONS(2252),
    [anon_sym_inline] = ACTIONS(2252),
    [anon_sym___inline] = ACTIONS(2252),
    [anon_sym___inline__] = ACTIONS(2252),
    [anon_sym___forceinline] = ACTIONS(2252),
    [anon_sym_thread_local] = ACTIONS(2252),
    [anon_sym___thread] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2252),
    [anon_sym_constexpr] = ACTIONS(2252),
    [anon_sym_volatile] = ACTIONS(2252),
    [anon_sym_restrict] = ACTIONS(2252),
    [anon_sym___restrict__] = ACTIONS(2252),
    [anon_sym__Atomic] = ACTIONS(2252),
    [anon_sym__Noreturn] = ACTIONS(2252),
    [anon_sym_noreturn] = ACTIONS(2252),
    [anon_sym_mutable] = ACTIONS(2252),
    [anon_sym_constinit] = ACTIONS(2252),
    [anon_sym_consteval] = ACTIONS(2252),
    [anon_sym_alignas] = ACTIONS(2252),
    [anon_sym__Alignas] = ACTIONS(2252),
    [sym_primitive_type] = ACTIONS(2252),
    [anon_sym_enum] = ACTIONS(2252),
    [anon_sym_class] = ACTIONS(2252),
    [anon_sym_struct] = ACTIONS(2252),
    [anon_sym_union] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_switch] = ACTIONS(2252),
    [anon_sym_case] = ACTIONS(2252),
    [anon_sym_default] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_do] = ACTIONS(2252),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2252),
    [anon_sym_goto] = ACTIONS(2252),
    [anon_sym___try] = ACTIONS(2252),
    [anon_sym___leave] = ACTIONS(2252),
    [anon_sym_QMARK] = ACTIONS(2254),
    [anon_sym_not] = ACTIONS(2252),
    [anon_sym_compl] = ACTIONS(2252),
    [anon_sym_LT_EQ_GT] = ACTIONS(2254),
    [anon_sym_or] = ACTIONS(2252),
    [anon_sym_and] = ACTIONS(2252),
    [anon_sym_bitor] = ACTIONS(2252),
    [anon_sym_xor] = ACTIONS(2252),
    [anon_sym_bitand] = ACTIONS(2252),
    [anon_sym_not_eq] = ACTIONS(2252),
    [anon_sym_is] = ACTIONS(2252),
    [anon_sym_as] = ACTIONS(2252),
    [anon_sym_DASH_DASH] = ACTIONS(2254),
    [anon_sym_PLUS_PLUS] = ACTIONS(2254),
    [anon_sym_sizeof] = ACTIONS(2252),
    [anon_sym___alignof__] = ACTIONS(2252),
    [anon_sym___alignof] = ACTIONS(2252),
    [anon_sym__alignof] = ACTIONS(2252),
    [anon_sym_alignof] = ACTIONS(2252),
    [anon_sym__Alignof] = ACTIONS(2252),
    [anon_sym_offsetof] = ACTIONS(2252),
    [anon_sym__Generic] = ACTIONS(2252),
    [anon_sym_asm] = ACTIONS(2252),
    [anon_sym___asm__] = ACTIONS(2252),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_DOT_STAR] = ACTIONS(2254),
    [anon_sym_DASH_GT] = ACTIONS(2254),
    [sym_number_literal] = ACTIONS(2254),
    [anon_sym_L_SQUOTE] = ACTIONS(2254),
    [anon_sym_u_SQUOTE] = ACTIONS(2254),
    [anon_sym_U_SQUOTE] = ACTIONS(2254),
    [anon_sym_u8_SQUOTE] = ACTIONS(2254),
    [anon_sym_SQUOTE] = ACTIONS(2254),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2252),
    [sym_false] = ACTIONS(2252),
    [anon_sym_NULL] = ACTIONS(2252),
    [anon_sym_nullptr] = ACTIONS(2252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_This] = ACTIONS(2252),
    [anon_sym_decltype] = ACTIONS(2252),
    [sym_virtual] = ACTIONS(2252),
    [anon_sym_explicit] = ACTIONS(2252),
    [anon_sym_typename] = ACTIONS(2252),
    [anon_sym_template] = ACTIONS(2252),
    [anon_sym_operator] = ACTIONS(2252),
    [anon_sym_try] = ACTIONS(2252),
    [anon_sym_delete] = ACTIONS(2252),
    [anon_sym_throw] = ACTIONS(2252),
    [anon_sym_namespace] = ACTIONS(2252),
    [anon_sym_using] = ACTIONS(2252),
    [anon_sym_static_assert] = ACTIONS(2252),
    [anon_sym_concept] = ACTIONS(2252),
    [anon_sym_co_return] = ACTIONS(2252),
    [anon_sym_co_yield] = ACTIONS(2252),
    [anon_sym_R_DQUOTE] = ACTIONS(2254),
    [anon_sym_LR_DQUOTE] = ACTIONS(2254),
    [anon_sym_uR_DQUOTE] = ACTIONS(2254),
    [anon_sym_UR_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2254),
    [anon_sym_co_await] = ACTIONS(2252),
    [anon_sym_new] = ACTIONS(2252),
    [anon_sym_requires] = ACTIONS(2252),
    [sym_this] = ACTIONS(2252),
    [anon_sym_discard] = ACTIONS(2252),
    [anon_sym_precise] = ACTIONS(2252),
    [anon_sym_shared] = ACTIONS(2252),
    [anon_sym_groupshared] = ACTIONS(2252),
    [anon_sym_uniform] = ACTIONS(2252),
    [anon_sym_row_major] = ACTIONS(2252),
    [anon_sym_column_major] = ACTIONS(2252),
    [anon_sym_globallycoherent] = ACTIONS(2252),
    [anon_sym_centroid] = ACTIONS(2252),
    [anon_sym_noperspective] = ACTIONS(2252),
    [anon_sym_nointerpolation] = ACTIONS(2252),
    [anon_sym_sample] = ACTIONS(2252),
    [anon_sym_linear] = ACTIONS(2252),
    [anon_sym_snorm] = ACTIONS(2252),
    [anon_sym_unorm] = ACTIONS(2252),
    [anon_sym_point] = ACTIONS(2252),
    [anon_sym_line] = ACTIONS(2252),
    [anon_sym_triangleadj] = ACTIONS(2252),
    [anon_sym_lineadj] = ACTIONS(2252),
    [anon_sym_triangle] = ACTIONS(2252),
    [anon_sym_cbuffer] = ACTIONS(2252),
    [anon_sym_interface] = ACTIONS(2252),
    [anon_sym_extension] = ACTIONS(2252),
  },
  [172] = {
    [sym_identifier] = ACTIONS(2202),
    [aux_sym_preproc_include_token1] = ACTIONS(2202),
    [aux_sym_preproc_def_token1] = ACTIONS(2202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2204),
    [aux_sym_preproc_if_token1] = ACTIONS(2202),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2202),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2202),
    [sym_preproc_directive] = ACTIONS(2202),
    [anon_sym_LPAREN2] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2202),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2202),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_STAR] = ACTIONS(2204),
    [anon_sym_SLASH] = ACTIONS(2202),
    [anon_sym_PERCENT] = ACTIONS(2204),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2202),
    [anon_sym_CARET] = ACTIONS(2204),
    [anon_sym_AMP] = ACTIONS(2202),
    [anon_sym_EQ_EQ] = ACTIONS(2204),
    [anon_sym_BANG_EQ] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(2202),
    [anon_sym_GT_EQ] = ACTIONS(2204),
    [anon_sym_LT_EQ] = ACTIONS(2202),
    [anon_sym_LT] = ACTIONS(2202),
    [anon_sym_LT_LT] = ACTIONS(2204),
    [anon_sym_GT_GT] = ACTIONS(2204),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym___extension__] = ACTIONS(2202),
    [anon_sym_typedef] = ACTIONS(2202),
    [anon_sym_in] = ACTIONS(2202),
    [anon_sym_out] = ACTIONS(2202),
    [anon_sym_inout] = ACTIONS(2202),
    [anon_sym_extern] = ACTIONS(2202),
    [anon_sym___attribute__] = ACTIONS(2202),
    [anon_sym_COLON_COLON] = ACTIONS(2204),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2204),
    [anon_sym___declspec] = ACTIONS(2202),
    [anon_sym___based] = ACTIONS(2202),
    [anon_sym___cdecl] = ACTIONS(2202),
    [anon_sym___clrcall] = ACTIONS(2202),
    [anon_sym___stdcall] = ACTIONS(2202),
    [anon_sym___fastcall] = ACTIONS(2202),
    [anon_sym___thiscall] = ACTIONS(2202),
    [anon_sym___vectorcall] = ACTIONS(2202),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_signed] = ACTIONS(2202),
    [anon_sym_unsigned] = ACTIONS(2202),
    [anon_sym_long] = ACTIONS(2202),
    [anon_sym_short] = ACTIONS(2202),
    [anon_sym_LBRACK] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2202),
    [anon_sym_register] = ACTIONS(2202),
    [anon_sym_inline] = ACTIONS(2202),
    [anon_sym___inline] = ACTIONS(2202),
    [anon_sym___inline__] = ACTIONS(2202),
    [anon_sym___forceinline] = ACTIONS(2202),
    [anon_sym_thread_local] = ACTIONS(2202),
    [anon_sym___thread] = ACTIONS(2202),
    [anon_sym_const] = ACTIONS(2202),
    [anon_sym_constexpr] = ACTIONS(2202),
    [anon_sym_volatile] = ACTIONS(2202),
    [anon_sym_restrict] = ACTIONS(2202),
    [anon_sym___restrict__] = ACTIONS(2202),
    [anon_sym__Atomic] = ACTIONS(2202),
    [anon_sym__Noreturn] = ACTIONS(2202),
    [anon_sym_noreturn] = ACTIONS(2202),
    [anon_sym_mutable] = ACTIONS(2202),
    [anon_sym_constinit] = ACTIONS(2202),
    [anon_sym_consteval] = ACTIONS(2202),
    [anon_sym_alignas] = ACTIONS(2202),
    [anon_sym__Alignas] = ACTIONS(2202),
    [sym_primitive_type] = ACTIONS(2202),
    [anon_sym_enum] = ACTIONS(2202),
    [anon_sym_class] = ACTIONS(2202),
    [anon_sym_struct] = ACTIONS(2202),
    [anon_sym_union] = ACTIONS(2202),
    [anon_sym_if] = ACTIONS(2202),
    [anon_sym_switch] = ACTIONS(2202),
    [anon_sym_case] = ACTIONS(2202),
    [anon_sym_default] = ACTIONS(2202),
    [anon_sym_while] = ACTIONS(2202),
    [anon_sym_do] = ACTIONS(2202),
    [anon_sym_for] = ACTIONS(2202),
    [anon_sym_return] = ACTIONS(2202),
    [anon_sym_break] = ACTIONS(2202),
    [anon_sym_continue] = ACTIONS(2202),
    [anon_sym_goto] = ACTIONS(2202),
    [anon_sym___try] = ACTIONS(2202),
    [anon_sym___leave] = ACTIONS(2202),
    [anon_sym_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2202),
    [anon_sym_compl] = ACTIONS(2202),
    [anon_sym_LT_EQ_GT] = ACTIONS(2204),
    [anon_sym_or] = ACTIONS(2202),
    [anon_sym_and] = ACTIONS(2202),
    [anon_sym_bitor] = ACTIONS(2202),
    [anon_sym_xor] = ACTIONS(2202),
    [anon_sym_bitand] = ACTIONS(2202),
    [anon_sym_not_eq] = ACTIONS(2202),
    [anon_sym_is] = ACTIONS(2202),
    [anon_sym_as] = ACTIONS(2202),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_sizeof] = ACTIONS(2202),
    [anon_sym___alignof__] = ACTIONS(2202),
    [anon_sym___alignof] = ACTIONS(2202),
    [anon_sym__alignof] = ACTIONS(2202),
    [anon_sym_alignof] = ACTIONS(2202),
    [anon_sym__Alignof] = ACTIONS(2202),
    [anon_sym_offsetof] = ACTIONS(2202),
    [anon_sym__Generic] = ACTIONS(2202),
    [anon_sym_asm] = ACTIONS(2202),
    [anon_sym___asm__] = ACTIONS(2202),
    [anon_sym_DOT] = ACTIONS(2202),
    [anon_sym_DOT_STAR] = ACTIONS(2204),
    [anon_sym_DASH_GT] = ACTIONS(2204),
    [sym_number_literal] = ACTIONS(2204),
    [anon_sym_L_SQUOTE] = ACTIONS(2204),
    [anon_sym_u_SQUOTE] = ACTIONS(2204),
    [anon_sym_U_SQUOTE] = ACTIONS(2204),
    [anon_sym_u8_SQUOTE] = ACTIONS(2204),
    [anon_sym_SQUOTE] = ACTIONS(2204),
    [anon_sym_L_DQUOTE] = ACTIONS(2204),
    [anon_sym_u_DQUOTE] = ACTIONS(2204),
    [anon_sym_U_DQUOTE] = ACTIONS(2204),
    [anon_sym_u8_DQUOTE] = ACTIONS(2204),
    [anon_sym_DQUOTE] = ACTIONS(2204),
    [sym_true] = ACTIONS(2202),
    [sym_false] = ACTIONS(2202),
    [anon_sym_NULL] = ACTIONS(2202),
    [anon_sym_nullptr] = ACTIONS(2202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2202),
    [anon_sym_let] = ACTIONS(2202),
    [anon_sym_This] = ACTIONS(2202),
    [anon_sym_decltype] = ACTIONS(2202),
    [sym_virtual] = ACTIONS(2202),
    [anon_sym_explicit] = ACTIONS(2202),
    [anon_sym_typename] = ACTIONS(2202),
    [anon_sym_template] = ACTIONS(2202),
    [anon_sym_operator] = ACTIONS(2202),
    [anon_sym_try] = ACTIONS(2202),
    [anon_sym_delete] = ACTIONS(2202),
    [anon_sym_throw] = ACTIONS(2202),
    [anon_sym_namespace] = ACTIONS(2202),
    [anon_sym_using] = ACTIONS(2202),
    [anon_sym_static_assert] = ACTIONS(2202),
    [anon_sym_concept] = ACTIONS(2202),
    [anon_sym_co_return] = ACTIONS(2202),
    [anon_sym_co_yield] = ACTIONS(2202),
    [anon_sym_R_DQUOTE] = ACTIONS(2204),
    [anon_sym_LR_DQUOTE] = ACTIONS(2204),
    [anon_sym_uR_DQUOTE] = ACTIONS(2204),
    [anon_sym_UR_DQUOTE] = ACTIONS(2204),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2204),
    [anon_sym_co_await] = ACTIONS(2202),
    [anon_sym_new] = ACTIONS(2202),
    [anon_sym_requires] = ACTIONS(2202),
    [sym_this] = ACTIONS(2202),
    [anon_sym_discard] = ACTIONS(2202),
    [anon_sym_precise] = ACTIONS(2202),
    [anon_sym_shared] = ACTIONS(2202),
    [anon_sym_groupshared] = ACTIONS(2202),
    [anon_sym_uniform] = ACTIONS(2202),
    [anon_sym_row_major] = ACTIONS(2202),
    [anon_sym_column_major] = ACTIONS(2202),
    [anon_sym_globallycoherent] = ACTIONS(2202),
    [anon_sym_centroid] = ACTIONS(2202),
    [anon_sym_noperspective] = ACTIONS(2202),
    [anon_sym_nointerpolation] = ACTIONS(2202),
    [anon_sym_sample] = ACTIONS(2202),
    [anon_sym_linear] = ACTIONS(2202),
    [anon_sym_snorm] = ACTIONS(2202),
    [anon_sym_unorm] = ACTIONS(2202),
    [anon_sym_point] = ACTIONS(2202),
    [anon_sym_line] = ACTIONS(2202),
    [anon_sym_triangleadj] = ACTIONS(2202),
    [anon_sym_lineadj] = ACTIONS(2202),
    [anon_sym_triangle] = ACTIONS(2202),
    [anon_sym_cbuffer] = ACTIONS(2202),
    [anon_sym_interface] = ACTIONS(2202),
    [anon_sym_extension] = ACTIONS(2202),
  },
  [173] = {
    [sym_identifier] = ACTIONS(2248),
    [aux_sym_preproc_include_token1] = ACTIONS(2248),
    [aux_sym_preproc_def_token1] = ACTIONS(2248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2250),
    [aux_sym_preproc_if_token1] = ACTIONS(2248),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2248),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2248),
    [sym_preproc_directive] = ACTIONS(2248),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2248),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2248),
    [anon_sym_PLUS] = ACTIONS(2248),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_SLASH] = ACTIONS(2248),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2248),
    [anon_sym_EQ_EQ] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_GT] = ACTIONS(2248),
    [anon_sym_GT_EQ] = ACTIONS(2250),
    [anon_sym_LT_EQ] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_LT_LT] = ACTIONS(2250),
    [anon_sym_GT_GT] = ACTIONS(2250),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym___extension__] = ACTIONS(2248),
    [anon_sym_typedef] = ACTIONS(2248),
    [anon_sym_in] = ACTIONS(2248),
    [anon_sym_out] = ACTIONS(2248),
    [anon_sym_inout] = ACTIONS(2248),
    [anon_sym_extern] = ACTIONS(2248),
    [anon_sym___attribute__] = ACTIONS(2248),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2250),
    [anon_sym___declspec] = ACTIONS(2248),
    [anon_sym___based] = ACTIONS(2248),
    [anon_sym___cdecl] = ACTIONS(2248),
    [anon_sym___clrcall] = ACTIONS(2248),
    [anon_sym___stdcall] = ACTIONS(2248),
    [anon_sym___fastcall] = ACTIONS(2248),
    [anon_sym___thiscall] = ACTIONS(2248),
    [anon_sym___vectorcall] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_signed] = ACTIONS(2248),
    [anon_sym_unsigned] = ACTIONS(2248),
    [anon_sym_long] = ACTIONS(2248),
    [anon_sym_short] = ACTIONS(2248),
    [anon_sym_LBRACK] = ACTIONS(2248),
    [anon_sym_static] = ACTIONS(2248),
    [anon_sym_register] = ACTIONS(2248),
    [anon_sym_inline] = ACTIONS(2248),
    [anon_sym___inline] = ACTIONS(2248),
    [anon_sym___inline__] = ACTIONS(2248),
    [anon_sym___forceinline] = ACTIONS(2248),
    [anon_sym_thread_local] = ACTIONS(2248),
    [anon_sym___thread] = ACTIONS(2248),
    [anon_sym_const] = ACTIONS(2248),
    [anon_sym_constexpr] = ACTIONS(2248),
    [anon_sym_volatile] = ACTIONS(2248),
    [anon_sym_restrict] = ACTIONS(2248),
    [anon_sym___restrict__] = ACTIONS(2248),
    [anon_sym__Atomic] = ACTIONS(2248),
    [anon_sym__Noreturn] = ACTIONS(2248),
    [anon_sym_noreturn] = ACTIONS(2248),
    [anon_sym_mutable] = ACTIONS(2248),
    [anon_sym_constinit] = ACTIONS(2248),
    [anon_sym_consteval] = ACTIONS(2248),
    [anon_sym_alignas] = ACTIONS(2248),
    [anon_sym__Alignas] = ACTIONS(2248),
    [sym_primitive_type] = ACTIONS(2248),
    [anon_sym_enum] = ACTIONS(2248),
    [anon_sym_class] = ACTIONS(2248),
    [anon_sym_struct] = ACTIONS(2248),
    [anon_sym_union] = ACTIONS(2248),
    [anon_sym_if] = ACTIONS(2248),
    [anon_sym_switch] = ACTIONS(2248),
    [anon_sym_case] = ACTIONS(2248),
    [anon_sym_default] = ACTIONS(2248),
    [anon_sym_while] = ACTIONS(2248),
    [anon_sym_do] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2248),
    [anon_sym_break] = ACTIONS(2248),
    [anon_sym_continue] = ACTIONS(2248),
    [anon_sym_goto] = ACTIONS(2248),
    [anon_sym___try] = ACTIONS(2248),
    [anon_sym___leave] = ACTIONS(2248),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_not] = ACTIONS(2248),
    [anon_sym_compl] = ACTIONS(2248),
    [anon_sym_LT_EQ_GT] = ACTIONS(2250),
    [anon_sym_or] = ACTIONS(2248),
    [anon_sym_and] = ACTIONS(2248),
    [anon_sym_bitor] = ACTIONS(2248),
    [anon_sym_xor] = ACTIONS(2248),
    [anon_sym_bitand] = ACTIONS(2248),
    [anon_sym_not_eq] = ACTIONS(2248),
    [anon_sym_is] = ACTIONS(2248),
    [anon_sym_as] = ACTIONS(2248),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_sizeof] = ACTIONS(2248),
    [anon_sym___alignof__] = ACTIONS(2248),
    [anon_sym___alignof] = ACTIONS(2248),
    [anon_sym__alignof] = ACTIONS(2248),
    [anon_sym_alignof] = ACTIONS(2248),
    [anon_sym__Alignof] = ACTIONS(2248),
    [anon_sym_offsetof] = ACTIONS(2248),
    [anon_sym__Generic] = ACTIONS(2248),
    [anon_sym_asm] = ACTIONS(2248),
    [anon_sym___asm__] = ACTIONS(2248),
    [anon_sym_DOT] = ACTIONS(2248),
    [anon_sym_DOT_STAR] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2250),
    [sym_number_literal] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2250),
    [anon_sym_u_SQUOTE] = ACTIONS(2250),
    [anon_sym_U_SQUOTE] = ACTIONS(2250),
    [anon_sym_u8_SQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym_L_DQUOTE] = ACTIONS(2250),
    [anon_sym_u_DQUOTE] = ACTIONS(2250),
    [anon_sym_U_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [sym_true] = ACTIONS(2248),
    [sym_false] = ACTIONS(2248),
    [anon_sym_NULL] = ACTIONS(2248),
    [anon_sym_nullptr] = ACTIONS(2248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2248),
    [anon_sym_let] = ACTIONS(2248),
    [anon_sym_This] = ACTIONS(2248),
    [anon_sym_decltype] = ACTIONS(2248),
    [sym_virtual] = ACTIONS(2248),
    [anon_sym_explicit] = ACTIONS(2248),
    [anon_sym_typename] = ACTIONS(2248),
    [anon_sym_template] = ACTIONS(2248),
    [anon_sym_operator] = ACTIONS(2248),
    [anon_sym_try] = ACTIONS(2248),
    [anon_sym_delete] = ACTIONS(2248),
    [anon_sym_throw] = ACTIONS(2248),
    [anon_sym_namespace] = ACTIONS(2248),
    [anon_sym_using] = ACTIONS(2248),
    [anon_sym_static_assert] = ACTIONS(2248),
    [anon_sym_concept] = ACTIONS(2248),
    [anon_sym_co_return] = ACTIONS(2248),
    [anon_sym_co_yield] = ACTIONS(2248),
    [anon_sym_R_DQUOTE] = ACTIONS(2250),
    [anon_sym_LR_DQUOTE] = ACTIONS(2250),
    [anon_sym_uR_DQUOTE] = ACTIONS(2250),
    [anon_sym_UR_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2250),
    [anon_sym_co_await] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2248),
    [anon_sym_requires] = ACTIONS(2248),
    [sym_this] = ACTIONS(2248),
    [anon_sym_discard] = ACTIONS(2248),
    [anon_sym_precise] = ACTIONS(2248),
    [anon_sym_shared] = ACTIONS(2248),
    [anon_sym_groupshared] = ACTIONS(2248),
    [anon_sym_uniform] = ACTIONS(2248),
    [anon_sym_row_major] = ACTIONS(2248),
    [anon_sym_column_major] = ACTIONS(2248),
    [anon_sym_globallycoherent] = ACTIONS(2248),
    [anon_sym_centroid] = ACTIONS(2248),
    [anon_sym_noperspective] = ACTIONS(2248),
    [anon_sym_nointerpolation] = ACTIONS(2248),
    [anon_sym_sample] = ACTIONS(2248),
    [anon_sym_linear] = ACTIONS(2248),
    [anon_sym_snorm] = ACTIONS(2248),
    [anon_sym_unorm] = ACTIONS(2248),
    [anon_sym_point] = ACTIONS(2248),
    [anon_sym_line] = ACTIONS(2248),
    [anon_sym_triangleadj] = ACTIONS(2248),
    [anon_sym_lineadj] = ACTIONS(2248),
    [anon_sym_triangle] = ACTIONS(2248),
    [anon_sym_cbuffer] = ACTIONS(2248),
    [anon_sym_interface] = ACTIONS(2248),
    [anon_sym_extension] = ACTIONS(2248),
  },
  [174] = {
    [sym_identifier] = ACTIONS(2240),
    [aux_sym_preproc_include_token1] = ACTIONS(2240),
    [aux_sym_preproc_def_token1] = ACTIONS(2240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2242),
    [aux_sym_preproc_if_token1] = ACTIONS(2240),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2240),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2240),
    [sym_preproc_directive] = ACTIONS(2240),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2240),
    [anon_sym_PLUS] = ACTIONS(2240),
    [anon_sym_STAR] = ACTIONS(2242),
    [anon_sym_SLASH] = ACTIONS(2240),
    [anon_sym_PERCENT] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_PIPE] = ACTIONS(2240),
    [anon_sym_CARET] = ACTIONS(2242),
    [anon_sym_AMP] = ACTIONS(2240),
    [anon_sym_EQ_EQ] = ACTIONS(2242),
    [anon_sym_BANG_EQ] = ACTIONS(2242),
    [anon_sym_GT] = ACTIONS(2240),
    [anon_sym_GT_EQ] = ACTIONS(2242),
    [anon_sym_LT_EQ] = ACTIONS(2240),
    [anon_sym_LT] = ACTIONS(2240),
    [anon_sym_LT_LT] = ACTIONS(2242),
    [anon_sym_GT_GT] = ACTIONS(2242),
    [anon_sym_SEMI] = ACTIONS(2242),
    [anon_sym___extension__] = ACTIONS(2240),
    [anon_sym_typedef] = ACTIONS(2240),
    [anon_sym_in] = ACTIONS(2240),
    [anon_sym_out] = ACTIONS(2240),
    [anon_sym_inout] = ACTIONS(2240),
    [anon_sym_extern] = ACTIONS(2240),
    [anon_sym___attribute__] = ACTIONS(2240),
    [anon_sym_COLON_COLON] = ACTIONS(2242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2242),
    [anon_sym___declspec] = ACTIONS(2240),
    [anon_sym___based] = ACTIONS(2240),
    [anon_sym___cdecl] = ACTIONS(2240),
    [anon_sym___clrcall] = ACTIONS(2240),
    [anon_sym___stdcall] = ACTIONS(2240),
    [anon_sym___fastcall] = ACTIONS(2240),
    [anon_sym___thiscall] = ACTIONS(2240),
    [anon_sym___vectorcall] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_RBRACE] = ACTIONS(2242),
    [anon_sym_signed] = ACTIONS(2240),
    [anon_sym_unsigned] = ACTIONS(2240),
    [anon_sym_long] = ACTIONS(2240),
    [anon_sym_short] = ACTIONS(2240),
    [anon_sym_LBRACK] = ACTIONS(2240),
    [anon_sym_static] = ACTIONS(2240),
    [anon_sym_register] = ACTIONS(2240),
    [anon_sym_inline] = ACTIONS(2240),
    [anon_sym___inline] = ACTIONS(2240),
    [anon_sym___inline__] = ACTIONS(2240),
    [anon_sym___forceinline] = ACTIONS(2240),
    [anon_sym_thread_local] = ACTIONS(2240),
    [anon_sym___thread] = ACTIONS(2240),
    [anon_sym_const] = ACTIONS(2240),
    [anon_sym_constexpr] = ACTIONS(2240),
    [anon_sym_volatile] = ACTIONS(2240),
    [anon_sym_restrict] = ACTIONS(2240),
    [anon_sym___restrict__] = ACTIONS(2240),
    [anon_sym__Atomic] = ACTIONS(2240),
    [anon_sym__Noreturn] = ACTIONS(2240),
    [anon_sym_noreturn] = ACTIONS(2240),
    [anon_sym_mutable] = ACTIONS(2240),
    [anon_sym_constinit] = ACTIONS(2240),
    [anon_sym_consteval] = ACTIONS(2240),
    [anon_sym_alignas] = ACTIONS(2240),
    [anon_sym__Alignas] = ACTIONS(2240),
    [sym_primitive_type] = ACTIONS(2240),
    [anon_sym_enum] = ACTIONS(2240),
    [anon_sym_class] = ACTIONS(2240),
    [anon_sym_struct] = ACTIONS(2240),
    [anon_sym_union] = ACTIONS(2240),
    [anon_sym_if] = ACTIONS(2240),
    [anon_sym_switch] = ACTIONS(2240),
    [anon_sym_case] = ACTIONS(2240),
    [anon_sym_default] = ACTIONS(2240),
    [anon_sym_while] = ACTIONS(2240),
    [anon_sym_do] = ACTIONS(2240),
    [anon_sym_for] = ACTIONS(2240),
    [anon_sym_return] = ACTIONS(2240),
    [anon_sym_break] = ACTIONS(2240),
    [anon_sym_continue] = ACTIONS(2240),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym___try] = ACTIONS(2240),
    [anon_sym___leave] = ACTIONS(2240),
    [anon_sym_QMARK] = ACTIONS(2242),
    [anon_sym_not] = ACTIONS(2240),
    [anon_sym_compl] = ACTIONS(2240),
    [anon_sym_LT_EQ_GT] = ACTIONS(2242),
    [anon_sym_or] = ACTIONS(2240),
    [anon_sym_and] = ACTIONS(2240),
    [anon_sym_bitor] = ACTIONS(2240),
    [anon_sym_xor] = ACTIONS(2240),
    [anon_sym_bitand] = ACTIONS(2240),
    [anon_sym_not_eq] = ACTIONS(2240),
    [anon_sym_is] = ACTIONS(2240),
    [anon_sym_as] = ACTIONS(2240),
    [anon_sym_DASH_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_PLUS] = ACTIONS(2242),
    [anon_sym_sizeof] = ACTIONS(2240),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2240),
    [anon_sym__Generic] = ACTIONS(2240),
    [anon_sym_asm] = ACTIONS(2240),
    [anon_sym___asm__] = ACTIONS(2240),
    [anon_sym_DOT] = ACTIONS(2240),
    [anon_sym_DOT_STAR] = ACTIONS(2242),
    [anon_sym_DASH_GT] = ACTIONS(2242),
    [sym_number_literal] = ACTIONS(2242),
    [anon_sym_L_SQUOTE] = ACTIONS(2242),
    [anon_sym_u_SQUOTE] = ACTIONS(2242),
    [anon_sym_U_SQUOTE] = ACTIONS(2242),
    [anon_sym_u8_SQUOTE] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(2242),
    [anon_sym_L_DQUOTE] = ACTIONS(2242),
    [anon_sym_u_DQUOTE] = ACTIONS(2242),
    [anon_sym_U_DQUOTE] = ACTIONS(2242),
    [anon_sym_u8_DQUOTE] = ACTIONS(2242),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [sym_true] = ACTIONS(2240),
    [sym_false] = ACTIONS(2240),
    [anon_sym_NULL] = ACTIONS(2240),
    [anon_sym_nullptr] = ACTIONS(2240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2240),
    [anon_sym_let] = ACTIONS(2240),
    [anon_sym_This] = ACTIONS(2240),
    [anon_sym_decltype] = ACTIONS(2240),
    [sym_virtual] = ACTIONS(2240),
    [anon_sym_explicit] = ACTIONS(2240),
    [anon_sym_typename] = ACTIONS(2240),
    [anon_sym_template] = ACTIONS(2240),
    [anon_sym_operator] = ACTIONS(2240),
    [anon_sym_try] = ACTIONS(2240),
    [anon_sym_delete] = ACTIONS(2240),
    [anon_sym_throw] = ACTIONS(2240),
    [anon_sym_namespace] = ACTIONS(2240),
    [anon_sym_using] = ACTIONS(2240),
    [anon_sym_static_assert] = ACTIONS(2240),
    [anon_sym_concept] = ACTIONS(2240),
    [anon_sym_co_return] = ACTIONS(2240),
    [anon_sym_co_yield] = ACTIONS(2240),
    [anon_sym_R_DQUOTE] = ACTIONS(2242),
    [anon_sym_LR_DQUOTE] = ACTIONS(2242),
    [anon_sym_uR_DQUOTE] = ACTIONS(2242),
    [anon_sym_UR_DQUOTE] = ACTIONS(2242),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2242),
    [anon_sym_co_await] = ACTIONS(2240),
    [anon_sym_new] = ACTIONS(2240),
    [anon_sym_requires] = ACTIONS(2240),
    [sym_this] = ACTIONS(2240),
    [anon_sym_discard] = ACTIONS(2240),
    [anon_sym_precise] = ACTIONS(2240),
    [anon_sym_shared] = ACTIONS(2240),
    [anon_sym_groupshared] = ACTIONS(2240),
    [anon_sym_uniform] = ACTIONS(2240),
    [anon_sym_row_major] = ACTIONS(2240),
    [anon_sym_column_major] = ACTIONS(2240),
    [anon_sym_globallycoherent] = ACTIONS(2240),
    [anon_sym_centroid] = ACTIONS(2240),
    [anon_sym_noperspective] = ACTIONS(2240),
    [anon_sym_nointerpolation] = ACTIONS(2240),
    [anon_sym_sample] = ACTIONS(2240),
    [anon_sym_linear] = ACTIONS(2240),
    [anon_sym_snorm] = ACTIONS(2240),
    [anon_sym_unorm] = ACTIONS(2240),
    [anon_sym_point] = ACTIONS(2240),
    [anon_sym_line] = ACTIONS(2240),
    [anon_sym_triangleadj] = ACTIONS(2240),
    [anon_sym_lineadj] = ACTIONS(2240),
    [anon_sym_triangle] = ACTIONS(2240),
    [anon_sym_cbuffer] = ACTIONS(2240),
    [anon_sym_interface] = ACTIONS(2240),
    [anon_sym_extension] = ACTIONS(2240),
  },
  [175] = {
    [sym_identifier] = ACTIONS(2194),
    [aux_sym_preproc_include_token1] = ACTIONS(2194),
    [aux_sym_preproc_def_token1] = ACTIONS(2194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2196),
    [anon_sym_COMMA] = ACTIONS(2196),
    [aux_sym_preproc_if_token1] = ACTIONS(2194),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2194),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2194),
    [sym_preproc_directive] = ACTIONS(2194),
    [anon_sym_LPAREN2] = ACTIONS(2196),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2194),
    [anon_sym_PLUS] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(2196),
    [anon_sym_SLASH] = ACTIONS(2194),
    [anon_sym_PERCENT] = ACTIONS(2196),
    [anon_sym_PIPE_PIPE] = ACTIONS(2196),
    [anon_sym_AMP_AMP] = ACTIONS(2196),
    [anon_sym_PIPE] = ACTIONS(2194),
    [anon_sym_CARET] = ACTIONS(2196),
    [anon_sym_AMP] = ACTIONS(2194),
    [anon_sym_EQ_EQ] = ACTIONS(2196),
    [anon_sym_BANG_EQ] = ACTIONS(2196),
    [anon_sym_GT] = ACTIONS(2194),
    [anon_sym_GT_EQ] = ACTIONS(2196),
    [anon_sym_LT_EQ] = ACTIONS(2194),
    [anon_sym_LT] = ACTIONS(2194),
    [anon_sym_LT_LT] = ACTIONS(2196),
    [anon_sym_GT_GT] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2196),
    [anon_sym___extension__] = ACTIONS(2194),
    [anon_sym_typedef] = ACTIONS(2194),
    [anon_sym_in] = ACTIONS(2194),
    [anon_sym_out] = ACTIONS(2194),
    [anon_sym_inout] = ACTIONS(2194),
    [anon_sym_extern] = ACTIONS(2194),
    [anon_sym___attribute__] = ACTIONS(2194),
    [anon_sym_COLON_COLON] = ACTIONS(2196),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2196),
    [anon_sym___declspec] = ACTIONS(2194),
    [anon_sym___based] = ACTIONS(2194),
    [anon_sym___cdecl] = ACTIONS(2194),
    [anon_sym___clrcall] = ACTIONS(2194),
    [anon_sym___stdcall] = ACTIONS(2194),
    [anon_sym___fastcall] = ACTIONS(2194),
    [anon_sym___thiscall] = ACTIONS(2194),
    [anon_sym___vectorcall] = ACTIONS(2194),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_RBRACE] = ACTIONS(2196),
    [anon_sym_signed] = ACTIONS(2194),
    [anon_sym_unsigned] = ACTIONS(2194),
    [anon_sym_long] = ACTIONS(2194),
    [anon_sym_short] = ACTIONS(2194),
    [anon_sym_LBRACK] = ACTIONS(2194),
    [anon_sym_static] = ACTIONS(2194),
    [anon_sym_register] = ACTIONS(2194),
    [anon_sym_inline] = ACTIONS(2194),
    [anon_sym___inline] = ACTIONS(2194),
    [anon_sym___inline__] = ACTIONS(2194),
    [anon_sym___forceinline] = ACTIONS(2194),
    [anon_sym_thread_local] = ACTIONS(2194),
    [anon_sym___thread] = ACTIONS(2194),
    [anon_sym_const] = ACTIONS(2194),
    [anon_sym_constexpr] = ACTIONS(2194),
    [anon_sym_volatile] = ACTIONS(2194),
    [anon_sym_restrict] = ACTIONS(2194),
    [anon_sym___restrict__] = ACTIONS(2194),
    [anon_sym__Atomic] = ACTIONS(2194),
    [anon_sym__Noreturn] = ACTIONS(2194),
    [anon_sym_noreturn] = ACTIONS(2194),
    [anon_sym_mutable] = ACTIONS(2194),
    [anon_sym_constinit] = ACTIONS(2194),
    [anon_sym_consteval] = ACTIONS(2194),
    [anon_sym_alignas] = ACTIONS(2194),
    [anon_sym__Alignas] = ACTIONS(2194),
    [sym_primitive_type] = ACTIONS(2194),
    [anon_sym_enum] = ACTIONS(2194),
    [anon_sym_class] = ACTIONS(2194),
    [anon_sym_struct] = ACTIONS(2194),
    [anon_sym_union] = ACTIONS(2194),
    [anon_sym_if] = ACTIONS(2194),
    [anon_sym_switch] = ACTIONS(2194),
    [anon_sym_case] = ACTIONS(2194),
    [anon_sym_default] = ACTIONS(2194),
    [anon_sym_while] = ACTIONS(2194),
    [anon_sym_do] = ACTIONS(2194),
    [anon_sym_for] = ACTIONS(2194),
    [anon_sym_return] = ACTIONS(2194),
    [anon_sym_break] = ACTIONS(2194),
    [anon_sym_continue] = ACTIONS(2194),
    [anon_sym_goto] = ACTIONS(2194),
    [anon_sym___try] = ACTIONS(2194),
    [anon_sym___leave] = ACTIONS(2194),
    [anon_sym_QMARK] = ACTIONS(2196),
    [anon_sym_not] = ACTIONS(2194),
    [anon_sym_compl] = ACTIONS(2194),
    [anon_sym_LT_EQ_GT] = ACTIONS(2196),
    [anon_sym_or] = ACTIONS(2194),
    [anon_sym_and] = ACTIONS(2194),
    [anon_sym_bitor] = ACTIONS(2194),
    [anon_sym_xor] = ACTIONS(2194),
    [anon_sym_bitand] = ACTIONS(2194),
    [anon_sym_not_eq] = ACTIONS(2194),
    [anon_sym_is] = ACTIONS(2194),
    [anon_sym_as] = ACTIONS(2194),
    [anon_sym_DASH_DASH] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2196),
    [anon_sym_sizeof] = ACTIONS(2194),
    [anon_sym___alignof__] = ACTIONS(2194),
    [anon_sym___alignof] = ACTIONS(2194),
    [anon_sym__alignof] = ACTIONS(2194),
    [anon_sym_alignof] = ACTIONS(2194),
    [anon_sym__Alignof] = ACTIONS(2194),
    [anon_sym_offsetof] = ACTIONS(2194),
    [anon_sym__Generic] = ACTIONS(2194),
    [anon_sym_asm] = ACTIONS(2194),
    [anon_sym___asm__] = ACTIONS(2194),
    [anon_sym_DOT] = ACTIONS(2194),
    [anon_sym_DOT_STAR] = ACTIONS(2196),
    [anon_sym_DASH_GT] = ACTIONS(2196),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_L_SQUOTE] = ACTIONS(2196),
    [anon_sym_u_SQUOTE] = ACTIONS(2196),
    [anon_sym_U_SQUOTE] = ACTIONS(2196),
    [anon_sym_u8_SQUOTE] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(2196),
    [anon_sym_L_DQUOTE] = ACTIONS(2196),
    [anon_sym_u_DQUOTE] = ACTIONS(2196),
    [anon_sym_U_DQUOTE] = ACTIONS(2196),
    [anon_sym_u8_DQUOTE] = ACTIONS(2196),
    [anon_sym_DQUOTE] = ACTIONS(2196),
    [sym_true] = ACTIONS(2194),
    [sym_false] = ACTIONS(2194),
    [anon_sym_NULL] = ACTIONS(2194),
    [anon_sym_nullptr] = ACTIONS(2194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2194),
    [anon_sym_let] = ACTIONS(2194),
    [anon_sym_This] = ACTIONS(2194),
    [anon_sym_decltype] = ACTIONS(2194),
    [sym_virtual] = ACTIONS(2194),
    [anon_sym_explicit] = ACTIONS(2194),
    [anon_sym_typename] = ACTIONS(2194),
    [anon_sym_template] = ACTIONS(2194),
    [anon_sym_operator] = ACTIONS(2194),
    [anon_sym_try] = ACTIONS(2194),
    [anon_sym_delete] = ACTIONS(2194),
    [anon_sym_throw] = ACTIONS(2194),
    [anon_sym_namespace] = ACTIONS(2194),
    [anon_sym_using] = ACTIONS(2194),
    [anon_sym_static_assert] = ACTIONS(2194),
    [anon_sym_concept] = ACTIONS(2194),
    [anon_sym_co_return] = ACTIONS(2194),
    [anon_sym_co_yield] = ACTIONS(2194),
    [anon_sym_R_DQUOTE] = ACTIONS(2196),
    [anon_sym_LR_DQUOTE] = ACTIONS(2196),
    [anon_sym_uR_DQUOTE] = ACTIONS(2196),
    [anon_sym_UR_DQUOTE] = ACTIONS(2196),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2196),
    [anon_sym_co_await] = ACTIONS(2194),
    [anon_sym_new] = ACTIONS(2194),
    [anon_sym_requires] = ACTIONS(2194),
    [sym_this] = ACTIONS(2194),
    [anon_sym_discard] = ACTIONS(2194),
    [anon_sym_precise] = ACTIONS(2194),
    [anon_sym_shared] = ACTIONS(2194),
    [anon_sym_groupshared] = ACTIONS(2194),
    [anon_sym_uniform] = ACTIONS(2194),
    [anon_sym_row_major] = ACTIONS(2194),
    [anon_sym_column_major] = ACTIONS(2194),
    [anon_sym_globallycoherent] = ACTIONS(2194),
    [anon_sym_centroid] = ACTIONS(2194),
    [anon_sym_noperspective] = ACTIONS(2194),
    [anon_sym_nointerpolation] = ACTIONS(2194),
    [anon_sym_sample] = ACTIONS(2194),
    [anon_sym_linear] = ACTIONS(2194),
    [anon_sym_snorm] = ACTIONS(2194),
    [anon_sym_unorm] = ACTIONS(2194),
    [anon_sym_point] = ACTIONS(2194),
    [anon_sym_line] = ACTIONS(2194),
    [anon_sym_triangleadj] = ACTIONS(2194),
    [anon_sym_lineadj] = ACTIONS(2194),
    [anon_sym_triangle] = ACTIONS(2194),
    [anon_sym_cbuffer] = ACTIONS(2194),
    [anon_sym_interface] = ACTIONS(2194),
    [anon_sym_extension] = ACTIONS(2194),
  },
  [176] = {
    [sym_identifier] = ACTIONS(2256),
    [aux_sym_preproc_include_token1] = ACTIONS(2256),
    [aux_sym_preproc_def_token1] = ACTIONS(2256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2258),
    [anon_sym_COMMA] = ACTIONS(2258),
    [aux_sym_preproc_if_token1] = ACTIONS(2256),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2256),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2256),
    [sym_preproc_directive] = ACTIONS(2256),
    [anon_sym_LPAREN2] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(2256),
    [anon_sym_TILDE] = ACTIONS(2258),
    [anon_sym_DASH] = ACTIONS(2256),
    [anon_sym_PLUS] = ACTIONS(2256),
    [anon_sym_STAR] = ACTIONS(2258),
    [anon_sym_SLASH] = ACTIONS(2256),
    [anon_sym_PERCENT] = ACTIONS(2258),
    [anon_sym_PIPE_PIPE] = ACTIONS(2258),
    [anon_sym_AMP_AMP] = ACTIONS(2258),
    [anon_sym_PIPE] = ACTIONS(2256),
    [anon_sym_CARET] = ACTIONS(2258),
    [anon_sym_AMP] = ACTIONS(2256),
    [anon_sym_EQ_EQ] = ACTIONS(2258),
    [anon_sym_BANG_EQ] = ACTIONS(2258),
    [anon_sym_GT] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2258),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_LT] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_SEMI] = ACTIONS(2258),
    [anon_sym___extension__] = ACTIONS(2256),
    [anon_sym_typedef] = ACTIONS(2256),
    [anon_sym_in] = ACTIONS(2256),
    [anon_sym_out] = ACTIONS(2256),
    [anon_sym_inout] = ACTIONS(2256),
    [anon_sym_extern] = ACTIONS(2256),
    [anon_sym___attribute__] = ACTIONS(2256),
    [anon_sym_COLON_COLON] = ACTIONS(2258),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2258),
    [anon_sym___declspec] = ACTIONS(2256),
    [anon_sym___based] = ACTIONS(2256),
    [anon_sym___cdecl] = ACTIONS(2256),
    [anon_sym___clrcall] = ACTIONS(2256),
    [anon_sym___stdcall] = ACTIONS(2256),
    [anon_sym___fastcall] = ACTIONS(2256),
    [anon_sym___thiscall] = ACTIONS(2256),
    [anon_sym___vectorcall] = ACTIONS(2256),
    [anon_sym_LBRACE] = ACTIONS(2258),
    [anon_sym_RBRACE] = ACTIONS(2258),
    [anon_sym_signed] = ACTIONS(2256),
    [anon_sym_unsigned] = ACTIONS(2256),
    [anon_sym_long] = ACTIONS(2256),
    [anon_sym_short] = ACTIONS(2256),
    [anon_sym_LBRACK] = ACTIONS(2256),
    [anon_sym_static] = ACTIONS(2256),
    [anon_sym_register] = ACTIONS(2256),
    [anon_sym_inline] = ACTIONS(2256),
    [anon_sym___inline] = ACTIONS(2256),
    [anon_sym___inline__] = ACTIONS(2256),
    [anon_sym___forceinline] = ACTIONS(2256),
    [anon_sym_thread_local] = ACTIONS(2256),
    [anon_sym___thread] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_constexpr] = ACTIONS(2256),
    [anon_sym_volatile] = ACTIONS(2256),
    [anon_sym_restrict] = ACTIONS(2256),
    [anon_sym___restrict__] = ACTIONS(2256),
    [anon_sym__Atomic] = ACTIONS(2256),
    [anon_sym__Noreturn] = ACTIONS(2256),
    [anon_sym_noreturn] = ACTIONS(2256),
    [anon_sym_mutable] = ACTIONS(2256),
    [anon_sym_constinit] = ACTIONS(2256),
    [anon_sym_consteval] = ACTIONS(2256),
    [anon_sym_alignas] = ACTIONS(2256),
    [anon_sym__Alignas] = ACTIONS(2256),
    [sym_primitive_type] = ACTIONS(2256),
    [anon_sym_enum] = ACTIONS(2256),
    [anon_sym_class] = ACTIONS(2256),
    [anon_sym_struct] = ACTIONS(2256),
    [anon_sym_union] = ACTIONS(2256),
    [anon_sym_if] = ACTIONS(2256),
    [anon_sym_switch] = ACTIONS(2256),
    [anon_sym_case] = ACTIONS(2256),
    [anon_sym_default] = ACTIONS(2256),
    [anon_sym_while] = ACTIONS(2256),
    [anon_sym_do] = ACTIONS(2256),
    [anon_sym_for] = ACTIONS(2256),
    [anon_sym_return] = ACTIONS(2256),
    [anon_sym_break] = ACTIONS(2256),
    [anon_sym_continue] = ACTIONS(2256),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym___try] = ACTIONS(2256),
    [anon_sym___leave] = ACTIONS(2256),
    [anon_sym_QMARK] = ACTIONS(2258),
    [anon_sym_not] = ACTIONS(2256),
    [anon_sym_compl] = ACTIONS(2256),
    [anon_sym_LT_EQ_GT] = ACTIONS(2258),
    [anon_sym_or] = ACTIONS(2256),
    [anon_sym_and] = ACTIONS(2256),
    [anon_sym_bitor] = ACTIONS(2256),
    [anon_sym_xor] = ACTIONS(2256),
    [anon_sym_bitand] = ACTIONS(2256),
    [anon_sym_not_eq] = ACTIONS(2256),
    [anon_sym_is] = ACTIONS(2256),
    [anon_sym_as] = ACTIONS(2256),
    [anon_sym_DASH_DASH] = ACTIONS(2258),
    [anon_sym_PLUS_PLUS] = ACTIONS(2258),
    [anon_sym_sizeof] = ACTIONS(2256),
    [anon_sym___alignof__] = ACTIONS(2256),
    [anon_sym___alignof] = ACTIONS(2256),
    [anon_sym__alignof] = ACTIONS(2256),
    [anon_sym_alignof] = ACTIONS(2256),
    [anon_sym__Alignof] = ACTIONS(2256),
    [anon_sym_offsetof] = ACTIONS(2256),
    [anon_sym__Generic] = ACTIONS(2256),
    [anon_sym_asm] = ACTIONS(2256),
    [anon_sym___asm__] = ACTIONS(2256),
    [anon_sym_DOT] = ACTIONS(2256),
    [anon_sym_DOT_STAR] = ACTIONS(2258),
    [anon_sym_DASH_GT] = ACTIONS(2258),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_L_SQUOTE] = ACTIONS(2258),
    [anon_sym_u_SQUOTE] = ACTIONS(2258),
    [anon_sym_U_SQUOTE] = ACTIONS(2258),
    [anon_sym_u8_SQUOTE] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(2258),
    [anon_sym_L_DQUOTE] = ACTIONS(2258),
    [anon_sym_u_DQUOTE] = ACTIONS(2258),
    [anon_sym_U_DQUOTE] = ACTIONS(2258),
    [anon_sym_u8_DQUOTE] = ACTIONS(2258),
    [anon_sym_DQUOTE] = ACTIONS(2258),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2256),
    [anon_sym_nullptr] = ACTIONS(2256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_This] = ACTIONS(2256),
    [anon_sym_decltype] = ACTIONS(2256),
    [sym_virtual] = ACTIONS(2256),
    [anon_sym_explicit] = ACTIONS(2256),
    [anon_sym_typename] = ACTIONS(2256),
    [anon_sym_template] = ACTIONS(2256),
    [anon_sym_operator] = ACTIONS(2256),
    [anon_sym_try] = ACTIONS(2256),
    [anon_sym_delete] = ACTIONS(2256),
    [anon_sym_throw] = ACTIONS(2256),
    [anon_sym_namespace] = ACTIONS(2256),
    [anon_sym_using] = ACTIONS(2256),
    [anon_sym_static_assert] = ACTIONS(2256),
    [anon_sym_concept] = ACTIONS(2256),
    [anon_sym_co_return] = ACTIONS(2256),
    [anon_sym_co_yield] = ACTIONS(2256),
    [anon_sym_R_DQUOTE] = ACTIONS(2258),
    [anon_sym_LR_DQUOTE] = ACTIONS(2258),
    [anon_sym_uR_DQUOTE] = ACTIONS(2258),
    [anon_sym_UR_DQUOTE] = ACTIONS(2258),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2258),
    [anon_sym_co_await] = ACTIONS(2256),
    [anon_sym_new] = ACTIONS(2256),
    [anon_sym_requires] = ACTIONS(2256),
    [sym_this] = ACTIONS(2256),
    [anon_sym_discard] = ACTIONS(2256),
    [anon_sym_precise] = ACTIONS(2256),
    [anon_sym_shared] = ACTIONS(2256),
    [anon_sym_groupshared] = ACTIONS(2256),
    [anon_sym_uniform] = ACTIONS(2256),
    [anon_sym_row_major] = ACTIONS(2256),
    [anon_sym_column_major] = ACTIONS(2256),
    [anon_sym_globallycoherent] = ACTIONS(2256),
    [anon_sym_centroid] = ACTIONS(2256),
    [anon_sym_noperspective] = ACTIONS(2256),
    [anon_sym_nointerpolation] = ACTIONS(2256),
    [anon_sym_sample] = ACTIONS(2256),
    [anon_sym_linear] = ACTIONS(2256),
    [anon_sym_snorm] = ACTIONS(2256),
    [anon_sym_unorm] = ACTIONS(2256),
    [anon_sym_point] = ACTIONS(2256),
    [anon_sym_line] = ACTIONS(2256),
    [anon_sym_triangleadj] = ACTIONS(2256),
    [anon_sym_lineadj] = ACTIONS(2256),
    [anon_sym_triangle] = ACTIONS(2256),
    [anon_sym_cbuffer] = ACTIONS(2256),
    [anon_sym_interface] = ACTIONS(2256),
    [anon_sym_extension] = ACTIONS(2256),
  },
  [177] = {
    [sym_identifier] = ACTIONS(2190),
    [aux_sym_preproc_include_token1] = ACTIONS(2190),
    [aux_sym_preproc_def_token1] = ACTIONS(2190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2192),
    [anon_sym_COMMA] = ACTIONS(2192),
    [aux_sym_preproc_if_token1] = ACTIONS(2190),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2190),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2190),
    [sym_preproc_directive] = ACTIONS(2190),
    [anon_sym_LPAREN2] = ACTIONS(2192),
    [anon_sym_BANG] = ACTIONS(2190),
    [anon_sym_TILDE] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2190),
    [anon_sym_PLUS] = ACTIONS(2190),
    [anon_sym_STAR] = ACTIONS(2192),
    [anon_sym_SLASH] = ACTIONS(2190),
    [anon_sym_PERCENT] = ACTIONS(2192),
    [anon_sym_PIPE_PIPE] = ACTIONS(2192),
    [anon_sym_AMP_AMP] = ACTIONS(2192),
    [anon_sym_PIPE] = ACTIONS(2190),
    [anon_sym_CARET] = ACTIONS(2192),
    [anon_sym_AMP] = ACTIONS(2190),
    [anon_sym_EQ_EQ] = ACTIONS(2192),
    [anon_sym_BANG_EQ] = ACTIONS(2192),
    [anon_sym_GT] = ACTIONS(2190),
    [anon_sym_GT_EQ] = ACTIONS(2192),
    [anon_sym_LT_EQ] = ACTIONS(2190),
    [anon_sym_LT] = ACTIONS(2190),
    [anon_sym_LT_LT] = ACTIONS(2192),
    [anon_sym_GT_GT] = ACTIONS(2192),
    [anon_sym_SEMI] = ACTIONS(2192),
    [anon_sym___extension__] = ACTIONS(2190),
    [anon_sym_typedef] = ACTIONS(2190),
    [anon_sym_in] = ACTIONS(2190),
    [anon_sym_out] = ACTIONS(2190),
    [anon_sym_inout] = ACTIONS(2190),
    [anon_sym_extern] = ACTIONS(2190),
    [anon_sym___attribute__] = ACTIONS(2190),
    [anon_sym_COLON_COLON] = ACTIONS(2192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2192),
    [anon_sym___declspec] = ACTIONS(2190),
    [anon_sym___based] = ACTIONS(2190),
    [anon_sym___cdecl] = ACTIONS(2190),
    [anon_sym___clrcall] = ACTIONS(2190),
    [anon_sym___stdcall] = ACTIONS(2190),
    [anon_sym___fastcall] = ACTIONS(2190),
    [anon_sym___thiscall] = ACTIONS(2190),
    [anon_sym___vectorcall] = ACTIONS(2190),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [anon_sym_RBRACE] = ACTIONS(2192),
    [anon_sym_signed] = ACTIONS(2190),
    [anon_sym_unsigned] = ACTIONS(2190),
    [anon_sym_long] = ACTIONS(2190),
    [anon_sym_short] = ACTIONS(2190),
    [anon_sym_LBRACK] = ACTIONS(2190),
    [anon_sym_static] = ACTIONS(2190),
    [anon_sym_register] = ACTIONS(2190),
    [anon_sym_inline] = ACTIONS(2190),
    [anon_sym___inline] = ACTIONS(2190),
    [anon_sym___inline__] = ACTIONS(2190),
    [anon_sym___forceinline] = ACTIONS(2190),
    [anon_sym_thread_local] = ACTIONS(2190),
    [anon_sym___thread] = ACTIONS(2190),
    [anon_sym_const] = ACTIONS(2190),
    [anon_sym_constexpr] = ACTIONS(2190),
    [anon_sym_volatile] = ACTIONS(2190),
    [anon_sym_restrict] = ACTIONS(2190),
    [anon_sym___restrict__] = ACTIONS(2190),
    [anon_sym__Atomic] = ACTIONS(2190),
    [anon_sym__Noreturn] = ACTIONS(2190),
    [anon_sym_noreturn] = ACTIONS(2190),
    [anon_sym_mutable] = ACTIONS(2190),
    [anon_sym_constinit] = ACTIONS(2190),
    [anon_sym_consteval] = ACTIONS(2190),
    [anon_sym_alignas] = ACTIONS(2190),
    [anon_sym__Alignas] = ACTIONS(2190),
    [sym_primitive_type] = ACTIONS(2190),
    [anon_sym_enum] = ACTIONS(2190),
    [anon_sym_class] = ACTIONS(2190),
    [anon_sym_struct] = ACTIONS(2190),
    [anon_sym_union] = ACTIONS(2190),
    [anon_sym_if] = ACTIONS(2190),
    [anon_sym_switch] = ACTIONS(2190),
    [anon_sym_case] = ACTIONS(2190),
    [anon_sym_default] = ACTIONS(2190),
    [anon_sym_while] = ACTIONS(2190),
    [anon_sym_do] = ACTIONS(2190),
    [anon_sym_for] = ACTIONS(2190),
    [anon_sym_return] = ACTIONS(2190),
    [anon_sym_break] = ACTIONS(2190),
    [anon_sym_continue] = ACTIONS(2190),
    [anon_sym_goto] = ACTIONS(2190),
    [anon_sym___try] = ACTIONS(2190),
    [anon_sym___leave] = ACTIONS(2190),
    [anon_sym_QMARK] = ACTIONS(2192),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_compl] = ACTIONS(2190),
    [anon_sym_LT_EQ_GT] = ACTIONS(2192),
    [anon_sym_or] = ACTIONS(2190),
    [anon_sym_and] = ACTIONS(2190),
    [anon_sym_bitor] = ACTIONS(2190),
    [anon_sym_xor] = ACTIONS(2190),
    [anon_sym_bitand] = ACTIONS(2190),
    [anon_sym_not_eq] = ACTIONS(2190),
    [anon_sym_is] = ACTIONS(2190),
    [anon_sym_as] = ACTIONS(2190),
    [anon_sym_DASH_DASH] = ACTIONS(2192),
    [anon_sym_PLUS_PLUS] = ACTIONS(2192),
    [anon_sym_sizeof] = ACTIONS(2190),
    [anon_sym___alignof__] = ACTIONS(2190),
    [anon_sym___alignof] = ACTIONS(2190),
    [anon_sym__alignof] = ACTIONS(2190),
    [anon_sym_alignof] = ACTIONS(2190),
    [anon_sym__Alignof] = ACTIONS(2190),
    [anon_sym_offsetof] = ACTIONS(2190),
    [anon_sym__Generic] = ACTIONS(2190),
    [anon_sym_asm] = ACTIONS(2190),
    [anon_sym___asm__] = ACTIONS(2190),
    [anon_sym_DOT] = ACTIONS(2190),
    [anon_sym_DOT_STAR] = ACTIONS(2192),
    [anon_sym_DASH_GT] = ACTIONS(2192),
    [sym_number_literal] = ACTIONS(2192),
    [anon_sym_L_SQUOTE] = ACTIONS(2192),
    [anon_sym_u_SQUOTE] = ACTIONS(2192),
    [anon_sym_U_SQUOTE] = ACTIONS(2192),
    [anon_sym_u8_SQUOTE] = ACTIONS(2192),
    [anon_sym_SQUOTE] = ACTIONS(2192),
    [anon_sym_L_DQUOTE] = ACTIONS(2192),
    [anon_sym_u_DQUOTE] = ACTIONS(2192),
    [anon_sym_U_DQUOTE] = ACTIONS(2192),
    [anon_sym_u8_DQUOTE] = ACTIONS(2192),
    [anon_sym_DQUOTE] = ACTIONS(2192),
    [sym_true] = ACTIONS(2190),
    [sym_false] = ACTIONS(2190),
    [anon_sym_NULL] = ACTIONS(2190),
    [anon_sym_nullptr] = ACTIONS(2190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2190),
    [anon_sym_let] = ACTIONS(2190),
    [anon_sym_This] = ACTIONS(2190),
    [anon_sym_decltype] = ACTIONS(2190),
    [sym_virtual] = ACTIONS(2190),
    [anon_sym_explicit] = ACTIONS(2190),
    [anon_sym_typename] = ACTIONS(2190),
    [anon_sym_template] = ACTIONS(2190),
    [anon_sym_operator] = ACTIONS(2190),
    [anon_sym_try] = ACTIONS(2190),
    [anon_sym_delete] = ACTIONS(2190),
    [anon_sym_throw] = ACTIONS(2190),
    [anon_sym_namespace] = ACTIONS(2190),
    [anon_sym_using] = ACTIONS(2190),
    [anon_sym_static_assert] = ACTIONS(2190),
    [anon_sym_concept] = ACTIONS(2190),
    [anon_sym_co_return] = ACTIONS(2190),
    [anon_sym_co_yield] = ACTIONS(2190),
    [anon_sym_R_DQUOTE] = ACTIONS(2192),
    [anon_sym_LR_DQUOTE] = ACTIONS(2192),
    [anon_sym_uR_DQUOTE] = ACTIONS(2192),
    [anon_sym_UR_DQUOTE] = ACTIONS(2192),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2192),
    [anon_sym_co_await] = ACTIONS(2190),
    [anon_sym_new] = ACTIONS(2190),
    [anon_sym_requires] = ACTIONS(2190),
    [sym_this] = ACTIONS(2190),
    [anon_sym_discard] = ACTIONS(2190),
    [anon_sym_precise] = ACTIONS(2190),
    [anon_sym_shared] = ACTIONS(2190),
    [anon_sym_groupshared] = ACTIONS(2190),
    [anon_sym_uniform] = ACTIONS(2190),
    [anon_sym_row_major] = ACTIONS(2190),
    [anon_sym_column_major] = ACTIONS(2190),
    [anon_sym_globallycoherent] = ACTIONS(2190),
    [anon_sym_centroid] = ACTIONS(2190),
    [anon_sym_noperspective] = ACTIONS(2190),
    [anon_sym_nointerpolation] = ACTIONS(2190),
    [anon_sym_sample] = ACTIONS(2190),
    [anon_sym_linear] = ACTIONS(2190),
    [anon_sym_snorm] = ACTIONS(2190),
    [anon_sym_unorm] = ACTIONS(2190),
    [anon_sym_point] = ACTIONS(2190),
    [anon_sym_line] = ACTIONS(2190),
    [anon_sym_triangleadj] = ACTIONS(2190),
    [anon_sym_lineadj] = ACTIONS(2190),
    [anon_sym_triangle] = ACTIONS(2190),
    [anon_sym_cbuffer] = ACTIONS(2190),
    [anon_sym_interface] = ACTIONS(2190),
    [anon_sym_extension] = ACTIONS(2190),
  },
  [178] = {
    [sym_identifier] = ACTIONS(2198),
    [aux_sym_preproc_include_token1] = ACTIONS(2198),
    [aux_sym_preproc_def_token1] = ACTIONS(2198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_COMMA] = ACTIONS(2200),
    [aux_sym_preproc_if_token1] = ACTIONS(2198),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2198),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2198),
    [sym_preproc_directive] = ACTIONS(2198),
    [anon_sym_LPAREN2] = ACTIONS(2200),
    [anon_sym_BANG] = ACTIONS(2198),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(2200),
    [anon_sym_SLASH] = ACTIONS(2198),
    [anon_sym_PERCENT] = ACTIONS(2200),
    [anon_sym_PIPE_PIPE] = ACTIONS(2200),
    [anon_sym_AMP_AMP] = ACTIONS(2200),
    [anon_sym_PIPE] = ACTIONS(2198),
    [anon_sym_CARET] = ACTIONS(2200),
    [anon_sym_AMP] = ACTIONS(2198),
    [anon_sym_EQ_EQ] = ACTIONS(2200),
    [anon_sym_BANG_EQ] = ACTIONS(2200),
    [anon_sym_GT] = ACTIONS(2198),
    [anon_sym_GT_EQ] = ACTIONS(2200),
    [anon_sym_LT_EQ] = ACTIONS(2198),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_LT_LT] = ACTIONS(2200),
    [anon_sym_GT_GT] = ACTIONS(2200),
    [anon_sym_SEMI] = ACTIONS(2200),
    [anon_sym___extension__] = ACTIONS(2198),
    [anon_sym_typedef] = ACTIONS(2198),
    [anon_sym_in] = ACTIONS(2198),
    [anon_sym_out] = ACTIONS(2198),
    [anon_sym_inout] = ACTIONS(2198),
    [anon_sym_extern] = ACTIONS(2198),
    [anon_sym___attribute__] = ACTIONS(2198),
    [anon_sym_COLON_COLON] = ACTIONS(2200),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2200),
    [anon_sym___declspec] = ACTIONS(2198),
    [anon_sym___based] = ACTIONS(2198),
    [anon_sym___cdecl] = ACTIONS(2198),
    [anon_sym___clrcall] = ACTIONS(2198),
    [anon_sym___stdcall] = ACTIONS(2198),
    [anon_sym___fastcall] = ACTIONS(2198),
    [anon_sym___thiscall] = ACTIONS(2198),
    [anon_sym___vectorcall] = ACTIONS(2198),
    [anon_sym_LBRACE] = ACTIONS(2200),
    [anon_sym_RBRACE] = ACTIONS(2200),
    [anon_sym_signed] = ACTIONS(2198),
    [anon_sym_unsigned] = ACTIONS(2198),
    [anon_sym_long] = ACTIONS(2198),
    [anon_sym_short] = ACTIONS(2198),
    [anon_sym_LBRACK] = ACTIONS(2198),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_register] = ACTIONS(2198),
    [anon_sym_inline] = ACTIONS(2198),
    [anon_sym___inline] = ACTIONS(2198),
    [anon_sym___inline__] = ACTIONS(2198),
    [anon_sym___forceinline] = ACTIONS(2198),
    [anon_sym_thread_local] = ACTIONS(2198),
    [anon_sym___thread] = ACTIONS(2198),
    [anon_sym_const] = ACTIONS(2198),
    [anon_sym_constexpr] = ACTIONS(2198),
    [anon_sym_volatile] = ACTIONS(2198),
    [anon_sym_restrict] = ACTIONS(2198),
    [anon_sym___restrict__] = ACTIONS(2198),
    [anon_sym__Atomic] = ACTIONS(2198),
    [anon_sym__Noreturn] = ACTIONS(2198),
    [anon_sym_noreturn] = ACTIONS(2198),
    [anon_sym_mutable] = ACTIONS(2198),
    [anon_sym_constinit] = ACTIONS(2198),
    [anon_sym_consteval] = ACTIONS(2198),
    [anon_sym_alignas] = ACTIONS(2198),
    [anon_sym__Alignas] = ACTIONS(2198),
    [sym_primitive_type] = ACTIONS(2198),
    [anon_sym_enum] = ACTIONS(2198),
    [anon_sym_class] = ACTIONS(2198),
    [anon_sym_struct] = ACTIONS(2198),
    [anon_sym_union] = ACTIONS(2198),
    [anon_sym_if] = ACTIONS(2198),
    [anon_sym_switch] = ACTIONS(2198),
    [anon_sym_case] = ACTIONS(2198),
    [anon_sym_default] = ACTIONS(2198),
    [anon_sym_while] = ACTIONS(2198),
    [anon_sym_do] = ACTIONS(2198),
    [anon_sym_for] = ACTIONS(2198),
    [anon_sym_return] = ACTIONS(2198),
    [anon_sym_break] = ACTIONS(2198),
    [anon_sym_continue] = ACTIONS(2198),
    [anon_sym_goto] = ACTIONS(2198),
    [anon_sym___try] = ACTIONS(2198),
    [anon_sym___leave] = ACTIONS(2198),
    [anon_sym_QMARK] = ACTIONS(2200),
    [anon_sym_not] = ACTIONS(2198),
    [anon_sym_compl] = ACTIONS(2198),
    [anon_sym_LT_EQ_GT] = ACTIONS(2200),
    [anon_sym_or] = ACTIONS(2198),
    [anon_sym_and] = ACTIONS(2198),
    [anon_sym_bitor] = ACTIONS(2198),
    [anon_sym_xor] = ACTIONS(2198),
    [anon_sym_bitand] = ACTIONS(2198),
    [anon_sym_not_eq] = ACTIONS(2198),
    [anon_sym_is] = ACTIONS(2198),
    [anon_sym_as] = ACTIONS(2198),
    [anon_sym_DASH_DASH] = ACTIONS(2200),
    [anon_sym_PLUS_PLUS] = ACTIONS(2200),
    [anon_sym_sizeof] = ACTIONS(2198),
    [anon_sym___alignof__] = ACTIONS(2198),
    [anon_sym___alignof] = ACTIONS(2198),
    [anon_sym__alignof] = ACTIONS(2198),
    [anon_sym_alignof] = ACTIONS(2198),
    [anon_sym__Alignof] = ACTIONS(2198),
    [anon_sym_offsetof] = ACTIONS(2198),
    [anon_sym__Generic] = ACTIONS(2198),
    [anon_sym_asm] = ACTIONS(2198),
    [anon_sym___asm__] = ACTIONS(2198),
    [anon_sym_DOT] = ACTIONS(2198),
    [anon_sym_DOT_STAR] = ACTIONS(2200),
    [anon_sym_DASH_GT] = ACTIONS(2200),
    [sym_number_literal] = ACTIONS(2200),
    [anon_sym_L_SQUOTE] = ACTIONS(2200),
    [anon_sym_u_SQUOTE] = ACTIONS(2200),
    [anon_sym_U_SQUOTE] = ACTIONS(2200),
    [anon_sym_u8_SQUOTE] = ACTIONS(2200),
    [anon_sym_SQUOTE] = ACTIONS(2200),
    [anon_sym_L_DQUOTE] = ACTIONS(2200),
    [anon_sym_u_DQUOTE] = ACTIONS(2200),
    [anon_sym_U_DQUOTE] = ACTIONS(2200),
    [anon_sym_u8_DQUOTE] = ACTIONS(2200),
    [anon_sym_DQUOTE] = ACTIONS(2200),
    [sym_true] = ACTIONS(2198),
    [sym_false] = ACTIONS(2198),
    [anon_sym_NULL] = ACTIONS(2198),
    [anon_sym_nullptr] = ACTIONS(2198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2198),
    [anon_sym_let] = ACTIONS(2198),
    [anon_sym_This] = ACTIONS(2198),
    [anon_sym_decltype] = ACTIONS(2198),
    [sym_virtual] = ACTIONS(2198),
    [anon_sym_explicit] = ACTIONS(2198),
    [anon_sym_typename] = ACTIONS(2198),
    [anon_sym_template] = ACTIONS(2198),
    [anon_sym_operator] = ACTIONS(2198),
    [anon_sym_try] = ACTIONS(2198),
    [anon_sym_delete] = ACTIONS(2198),
    [anon_sym_throw] = ACTIONS(2198),
    [anon_sym_namespace] = ACTIONS(2198),
    [anon_sym_using] = ACTIONS(2198),
    [anon_sym_static_assert] = ACTIONS(2198),
    [anon_sym_concept] = ACTIONS(2198),
    [anon_sym_co_return] = ACTIONS(2198),
    [anon_sym_co_yield] = ACTIONS(2198),
    [anon_sym_R_DQUOTE] = ACTIONS(2200),
    [anon_sym_LR_DQUOTE] = ACTIONS(2200),
    [anon_sym_uR_DQUOTE] = ACTIONS(2200),
    [anon_sym_UR_DQUOTE] = ACTIONS(2200),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2200),
    [anon_sym_co_await] = ACTIONS(2198),
    [anon_sym_new] = ACTIONS(2198),
    [anon_sym_requires] = ACTIONS(2198),
    [sym_this] = ACTIONS(2198),
    [anon_sym_discard] = ACTIONS(2198),
    [anon_sym_precise] = ACTIONS(2198),
    [anon_sym_shared] = ACTIONS(2198),
    [anon_sym_groupshared] = ACTIONS(2198),
    [anon_sym_uniform] = ACTIONS(2198),
    [anon_sym_row_major] = ACTIONS(2198),
    [anon_sym_column_major] = ACTIONS(2198),
    [anon_sym_globallycoherent] = ACTIONS(2198),
    [anon_sym_centroid] = ACTIONS(2198),
    [anon_sym_noperspective] = ACTIONS(2198),
    [anon_sym_nointerpolation] = ACTIONS(2198),
    [anon_sym_sample] = ACTIONS(2198),
    [anon_sym_linear] = ACTIONS(2198),
    [anon_sym_snorm] = ACTIONS(2198),
    [anon_sym_unorm] = ACTIONS(2198),
    [anon_sym_point] = ACTIONS(2198),
    [anon_sym_line] = ACTIONS(2198),
    [anon_sym_triangleadj] = ACTIONS(2198),
    [anon_sym_lineadj] = ACTIONS(2198),
    [anon_sym_triangle] = ACTIONS(2198),
    [anon_sym_cbuffer] = ACTIONS(2198),
    [anon_sym_interface] = ACTIONS(2198),
    [anon_sym_extension] = ACTIONS(2198),
  },
  [179] = {
    [sym_identifier] = ACTIONS(2228),
    [aux_sym_preproc_include_token1] = ACTIONS(2228),
    [aux_sym_preproc_def_token1] = ACTIONS(2228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2230),
    [anon_sym_COMMA] = ACTIONS(2230),
    [aux_sym_preproc_if_token1] = ACTIONS(2228),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2228),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2228),
    [sym_preproc_directive] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2228),
    [anon_sym_PLUS] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(2230),
    [anon_sym_SLASH] = ACTIONS(2228),
    [anon_sym_PERCENT] = ACTIONS(2230),
    [anon_sym_PIPE_PIPE] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_PIPE] = ACTIONS(2228),
    [anon_sym_CARET] = ACTIONS(2230),
    [anon_sym_AMP] = ACTIONS(2228),
    [anon_sym_EQ_EQ] = ACTIONS(2230),
    [anon_sym_BANG_EQ] = ACTIONS(2230),
    [anon_sym_GT] = ACTIONS(2228),
    [anon_sym_GT_EQ] = ACTIONS(2230),
    [anon_sym_LT_EQ] = ACTIONS(2228),
    [anon_sym_LT] = ACTIONS(2228),
    [anon_sym_LT_LT] = ACTIONS(2230),
    [anon_sym_GT_GT] = ACTIONS(2230),
    [anon_sym_SEMI] = ACTIONS(2230),
    [anon_sym___extension__] = ACTIONS(2228),
    [anon_sym_typedef] = ACTIONS(2228),
    [anon_sym_in] = ACTIONS(2228),
    [anon_sym_out] = ACTIONS(2228),
    [anon_sym_inout] = ACTIONS(2228),
    [anon_sym_extern] = ACTIONS(2228),
    [anon_sym___attribute__] = ACTIONS(2228),
    [anon_sym_COLON_COLON] = ACTIONS(2230),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2230),
    [anon_sym___declspec] = ACTIONS(2228),
    [anon_sym___based] = ACTIONS(2228),
    [anon_sym___cdecl] = ACTIONS(2228),
    [anon_sym___clrcall] = ACTIONS(2228),
    [anon_sym___stdcall] = ACTIONS(2228),
    [anon_sym___fastcall] = ACTIONS(2228),
    [anon_sym___thiscall] = ACTIONS(2228),
    [anon_sym___vectorcall] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_RBRACE] = ACTIONS(2230),
    [anon_sym_signed] = ACTIONS(2228),
    [anon_sym_unsigned] = ACTIONS(2228),
    [anon_sym_long] = ACTIONS(2228),
    [anon_sym_short] = ACTIONS(2228),
    [anon_sym_LBRACK] = ACTIONS(2228),
    [anon_sym_static] = ACTIONS(2228),
    [anon_sym_register] = ACTIONS(2228),
    [anon_sym_inline] = ACTIONS(2228),
    [anon_sym___inline] = ACTIONS(2228),
    [anon_sym___inline__] = ACTIONS(2228),
    [anon_sym___forceinline] = ACTIONS(2228),
    [anon_sym_thread_local] = ACTIONS(2228),
    [anon_sym___thread] = ACTIONS(2228),
    [anon_sym_const] = ACTIONS(2228),
    [anon_sym_constexpr] = ACTIONS(2228),
    [anon_sym_volatile] = ACTIONS(2228),
    [anon_sym_restrict] = ACTIONS(2228),
    [anon_sym___restrict__] = ACTIONS(2228),
    [anon_sym__Atomic] = ACTIONS(2228),
    [anon_sym__Noreturn] = ACTIONS(2228),
    [anon_sym_noreturn] = ACTIONS(2228),
    [anon_sym_mutable] = ACTIONS(2228),
    [anon_sym_constinit] = ACTIONS(2228),
    [anon_sym_consteval] = ACTIONS(2228),
    [anon_sym_alignas] = ACTIONS(2228),
    [anon_sym__Alignas] = ACTIONS(2228),
    [sym_primitive_type] = ACTIONS(2228),
    [anon_sym_enum] = ACTIONS(2228),
    [anon_sym_class] = ACTIONS(2228),
    [anon_sym_struct] = ACTIONS(2228),
    [anon_sym_union] = ACTIONS(2228),
    [anon_sym_if] = ACTIONS(2228),
    [anon_sym_switch] = ACTIONS(2228),
    [anon_sym_case] = ACTIONS(2228),
    [anon_sym_default] = ACTIONS(2228),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2228),
    [anon_sym_for] = ACTIONS(2228),
    [anon_sym_return] = ACTIONS(2228),
    [anon_sym_break] = ACTIONS(2228),
    [anon_sym_continue] = ACTIONS(2228),
    [anon_sym_goto] = ACTIONS(2228),
    [anon_sym___try] = ACTIONS(2228),
    [anon_sym___leave] = ACTIONS(2228),
    [anon_sym_QMARK] = ACTIONS(2230),
    [anon_sym_not] = ACTIONS(2228),
    [anon_sym_compl] = ACTIONS(2228),
    [anon_sym_LT_EQ_GT] = ACTIONS(2230),
    [anon_sym_or] = ACTIONS(2228),
    [anon_sym_and] = ACTIONS(2228),
    [anon_sym_bitor] = ACTIONS(2228),
    [anon_sym_xor] = ACTIONS(2228),
    [anon_sym_bitand] = ACTIONS(2228),
    [anon_sym_not_eq] = ACTIONS(2228),
    [anon_sym_is] = ACTIONS(2228),
    [anon_sym_as] = ACTIONS(2228),
    [anon_sym_DASH_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_PLUS] = ACTIONS(2230),
    [anon_sym_sizeof] = ACTIONS(2228),
    [anon_sym___alignof__] = ACTIONS(2228),
    [anon_sym___alignof] = ACTIONS(2228),
    [anon_sym__alignof] = ACTIONS(2228),
    [anon_sym_alignof] = ACTIONS(2228),
    [anon_sym__Alignof] = ACTIONS(2228),
    [anon_sym_offsetof] = ACTIONS(2228),
    [anon_sym__Generic] = ACTIONS(2228),
    [anon_sym_asm] = ACTIONS(2228),
    [anon_sym___asm__] = ACTIONS(2228),
    [anon_sym_DOT] = ACTIONS(2228),
    [anon_sym_DOT_STAR] = ACTIONS(2230),
    [anon_sym_DASH_GT] = ACTIONS(2230),
    [sym_number_literal] = ACTIONS(2230),
    [anon_sym_L_SQUOTE] = ACTIONS(2230),
    [anon_sym_u_SQUOTE] = ACTIONS(2230),
    [anon_sym_U_SQUOTE] = ACTIONS(2230),
    [anon_sym_u8_SQUOTE] = ACTIONS(2230),
    [anon_sym_SQUOTE] = ACTIONS(2230),
    [anon_sym_L_DQUOTE] = ACTIONS(2230),
    [anon_sym_u_DQUOTE] = ACTIONS(2230),
    [anon_sym_U_DQUOTE] = ACTIONS(2230),
    [anon_sym_u8_DQUOTE] = ACTIONS(2230),
    [anon_sym_DQUOTE] = ACTIONS(2230),
    [sym_true] = ACTIONS(2228),
    [sym_false] = ACTIONS(2228),
    [anon_sym_NULL] = ACTIONS(2228),
    [anon_sym_nullptr] = ACTIONS(2228),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(2228),
    [anon_sym_This] = ACTIONS(2228),
    [anon_sym_decltype] = ACTIONS(2228),
    [sym_virtual] = ACTIONS(2228),
    [anon_sym_explicit] = ACTIONS(2228),
    [anon_sym_typename] = ACTIONS(2228),
    [anon_sym_template] = ACTIONS(2228),
    [anon_sym_operator] = ACTIONS(2228),
    [anon_sym_try] = ACTIONS(2228),
    [anon_sym_delete] = ACTIONS(2228),
    [anon_sym_throw] = ACTIONS(2228),
    [anon_sym_namespace] = ACTIONS(2228),
    [anon_sym_using] = ACTIONS(2228),
    [anon_sym_static_assert] = ACTIONS(2228),
    [anon_sym_concept] = ACTIONS(2228),
    [anon_sym_co_return] = ACTIONS(2228),
    [anon_sym_co_yield] = ACTIONS(2228),
    [anon_sym_R_DQUOTE] = ACTIONS(2230),
    [anon_sym_LR_DQUOTE] = ACTIONS(2230),
    [anon_sym_uR_DQUOTE] = ACTIONS(2230),
    [anon_sym_UR_DQUOTE] = ACTIONS(2230),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2230),
    [anon_sym_co_await] = ACTIONS(2228),
    [anon_sym_new] = ACTIONS(2228),
    [anon_sym_requires] = ACTIONS(2228),
    [sym_this] = ACTIONS(2228),
    [anon_sym_discard] = ACTIONS(2228),
    [anon_sym_precise] = ACTIONS(2228),
    [anon_sym_shared] = ACTIONS(2228),
    [anon_sym_groupshared] = ACTIONS(2228),
    [anon_sym_uniform] = ACTIONS(2228),
    [anon_sym_row_major] = ACTIONS(2228),
    [anon_sym_column_major] = ACTIONS(2228),
    [anon_sym_globallycoherent] = ACTIONS(2228),
    [anon_sym_centroid] = ACTIONS(2228),
    [anon_sym_noperspective] = ACTIONS(2228),
    [anon_sym_nointerpolation] = ACTIONS(2228),
    [anon_sym_sample] = ACTIONS(2228),
    [anon_sym_linear] = ACTIONS(2228),
    [anon_sym_snorm] = ACTIONS(2228),
    [anon_sym_unorm] = ACTIONS(2228),
    [anon_sym_point] = ACTIONS(2228),
    [anon_sym_line] = ACTIONS(2228),
    [anon_sym_triangleadj] = ACTIONS(2228),
    [anon_sym_lineadj] = ACTIONS(2228),
    [anon_sym_triangle] = ACTIONS(2228),
    [anon_sym_cbuffer] = ACTIONS(2228),
    [anon_sym_interface] = ACTIONS(2228),
    [anon_sym_extension] = ACTIONS(2228),
  },
  [180] = {
    [sym_identifier] = ACTIONS(2224),
    [aux_sym_preproc_include_token1] = ACTIONS(2224),
    [aux_sym_preproc_def_token1] = ACTIONS(2224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2226),
    [anon_sym_COMMA] = ACTIONS(2226),
    [aux_sym_preproc_if_token1] = ACTIONS(2224),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2224),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2224),
    [sym_preproc_directive] = ACTIONS(2224),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_PLUS] = ACTIONS(2224),
    [anon_sym_STAR] = ACTIONS(2226),
    [anon_sym_SLASH] = ACTIONS(2224),
    [anon_sym_PERCENT] = ACTIONS(2226),
    [anon_sym_PIPE_PIPE] = ACTIONS(2226),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_PIPE] = ACTIONS(2224),
    [anon_sym_CARET] = ACTIONS(2226),
    [anon_sym_AMP] = ACTIONS(2224),
    [anon_sym_EQ_EQ] = ACTIONS(2226),
    [anon_sym_BANG_EQ] = ACTIONS(2226),
    [anon_sym_GT] = ACTIONS(2224),
    [anon_sym_GT_EQ] = ACTIONS(2226),
    [anon_sym_LT_EQ] = ACTIONS(2224),
    [anon_sym_LT] = ACTIONS(2224),
    [anon_sym_LT_LT] = ACTIONS(2226),
    [anon_sym_GT_GT] = ACTIONS(2226),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym___extension__] = ACTIONS(2224),
    [anon_sym_typedef] = ACTIONS(2224),
    [anon_sym_in] = ACTIONS(2224),
    [anon_sym_out] = ACTIONS(2224),
    [anon_sym_inout] = ACTIONS(2224),
    [anon_sym_extern] = ACTIONS(2224),
    [anon_sym___attribute__] = ACTIONS(2224),
    [anon_sym_COLON_COLON] = ACTIONS(2226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2226),
    [anon_sym___declspec] = ACTIONS(2224),
    [anon_sym___based] = ACTIONS(2224),
    [anon_sym___cdecl] = ACTIONS(2224),
    [anon_sym___clrcall] = ACTIONS(2224),
    [anon_sym___stdcall] = ACTIONS(2224),
    [anon_sym___fastcall] = ACTIONS(2224),
    [anon_sym___thiscall] = ACTIONS(2224),
    [anon_sym___vectorcall] = ACTIONS(2224),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_RBRACE] = ACTIONS(2226),
    [anon_sym_signed] = ACTIONS(2224),
    [anon_sym_unsigned] = ACTIONS(2224),
    [anon_sym_long] = ACTIONS(2224),
    [anon_sym_short] = ACTIONS(2224),
    [anon_sym_LBRACK] = ACTIONS(2224),
    [anon_sym_static] = ACTIONS(2224),
    [anon_sym_register] = ACTIONS(2224),
    [anon_sym_inline] = ACTIONS(2224),
    [anon_sym___inline] = ACTIONS(2224),
    [anon_sym___inline__] = ACTIONS(2224),
    [anon_sym___forceinline] = ACTIONS(2224),
    [anon_sym_thread_local] = ACTIONS(2224),
    [anon_sym___thread] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_constexpr] = ACTIONS(2224),
    [anon_sym_volatile] = ACTIONS(2224),
    [anon_sym_restrict] = ACTIONS(2224),
    [anon_sym___restrict__] = ACTIONS(2224),
    [anon_sym__Atomic] = ACTIONS(2224),
    [anon_sym__Noreturn] = ACTIONS(2224),
    [anon_sym_noreturn] = ACTIONS(2224),
    [anon_sym_mutable] = ACTIONS(2224),
    [anon_sym_constinit] = ACTIONS(2224),
    [anon_sym_consteval] = ACTIONS(2224),
    [anon_sym_alignas] = ACTIONS(2224),
    [anon_sym__Alignas] = ACTIONS(2224),
    [sym_primitive_type] = ACTIONS(2224),
    [anon_sym_enum] = ACTIONS(2224),
    [anon_sym_class] = ACTIONS(2224),
    [anon_sym_struct] = ACTIONS(2224),
    [anon_sym_union] = ACTIONS(2224),
    [anon_sym_if] = ACTIONS(2224),
    [anon_sym_switch] = ACTIONS(2224),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2224),
    [anon_sym_while] = ACTIONS(2224),
    [anon_sym_do] = ACTIONS(2224),
    [anon_sym_for] = ACTIONS(2224),
    [anon_sym_return] = ACTIONS(2224),
    [anon_sym_break] = ACTIONS(2224),
    [anon_sym_continue] = ACTIONS(2224),
    [anon_sym_goto] = ACTIONS(2224),
    [anon_sym___try] = ACTIONS(2224),
    [anon_sym___leave] = ACTIONS(2224),
    [anon_sym_QMARK] = ACTIONS(2226),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_compl] = ACTIONS(2224),
    [anon_sym_LT_EQ_GT] = ACTIONS(2226),
    [anon_sym_or] = ACTIONS(2224),
    [anon_sym_and] = ACTIONS(2224),
    [anon_sym_bitor] = ACTIONS(2224),
    [anon_sym_xor] = ACTIONS(2224),
    [anon_sym_bitand] = ACTIONS(2224),
    [anon_sym_not_eq] = ACTIONS(2224),
    [anon_sym_is] = ACTIONS(2224),
    [anon_sym_as] = ACTIONS(2224),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_sizeof] = ACTIONS(2224),
    [anon_sym___alignof__] = ACTIONS(2224),
    [anon_sym___alignof] = ACTIONS(2224),
    [anon_sym__alignof] = ACTIONS(2224),
    [anon_sym_alignof] = ACTIONS(2224),
    [anon_sym__Alignof] = ACTIONS(2224),
    [anon_sym_offsetof] = ACTIONS(2224),
    [anon_sym__Generic] = ACTIONS(2224),
    [anon_sym_asm] = ACTIONS(2224),
    [anon_sym___asm__] = ACTIONS(2224),
    [anon_sym_DOT] = ACTIONS(2224),
    [anon_sym_DOT_STAR] = ACTIONS(2226),
    [anon_sym_DASH_GT] = ACTIONS(2226),
    [sym_number_literal] = ACTIONS(2226),
    [anon_sym_L_SQUOTE] = ACTIONS(2226),
    [anon_sym_u_SQUOTE] = ACTIONS(2226),
    [anon_sym_U_SQUOTE] = ACTIONS(2226),
    [anon_sym_u8_SQUOTE] = ACTIONS(2226),
    [anon_sym_SQUOTE] = ACTIONS(2226),
    [anon_sym_L_DQUOTE] = ACTIONS(2226),
    [anon_sym_u_DQUOTE] = ACTIONS(2226),
    [anon_sym_U_DQUOTE] = ACTIONS(2226),
    [anon_sym_u8_DQUOTE] = ACTIONS(2226),
    [anon_sym_DQUOTE] = ACTIONS(2226),
    [sym_true] = ACTIONS(2224),
    [sym_false] = ACTIONS(2224),
    [anon_sym_NULL] = ACTIONS(2224),
    [anon_sym_nullptr] = ACTIONS(2224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2224),
    [anon_sym_let] = ACTIONS(2224),
    [anon_sym_This] = ACTIONS(2224),
    [anon_sym_decltype] = ACTIONS(2224),
    [sym_virtual] = ACTIONS(2224),
    [anon_sym_explicit] = ACTIONS(2224),
    [anon_sym_typename] = ACTIONS(2224),
    [anon_sym_template] = ACTIONS(2224),
    [anon_sym_operator] = ACTIONS(2224),
    [anon_sym_try] = ACTIONS(2224),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_throw] = ACTIONS(2224),
    [anon_sym_namespace] = ACTIONS(2224),
    [anon_sym_using] = ACTIONS(2224),
    [anon_sym_static_assert] = ACTIONS(2224),
    [anon_sym_concept] = ACTIONS(2224),
    [anon_sym_co_return] = ACTIONS(2224),
    [anon_sym_co_yield] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(2226),
    [anon_sym_LR_DQUOTE] = ACTIONS(2226),
    [anon_sym_uR_DQUOTE] = ACTIONS(2226),
    [anon_sym_UR_DQUOTE] = ACTIONS(2226),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2226),
    [anon_sym_co_await] = ACTIONS(2224),
    [anon_sym_new] = ACTIONS(2224),
    [anon_sym_requires] = ACTIONS(2224),
    [sym_this] = ACTIONS(2224),
    [anon_sym_discard] = ACTIONS(2224),
    [anon_sym_precise] = ACTIONS(2224),
    [anon_sym_shared] = ACTIONS(2224),
    [anon_sym_groupshared] = ACTIONS(2224),
    [anon_sym_uniform] = ACTIONS(2224),
    [anon_sym_row_major] = ACTIONS(2224),
    [anon_sym_column_major] = ACTIONS(2224),
    [anon_sym_globallycoherent] = ACTIONS(2224),
    [anon_sym_centroid] = ACTIONS(2224),
    [anon_sym_noperspective] = ACTIONS(2224),
    [anon_sym_nointerpolation] = ACTIONS(2224),
    [anon_sym_sample] = ACTIONS(2224),
    [anon_sym_linear] = ACTIONS(2224),
    [anon_sym_snorm] = ACTIONS(2224),
    [anon_sym_unorm] = ACTIONS(2224),
    [anon_sym_point] = ACTIONS(2224),
    [anon_sym_line] = ACTIONS(2224),
    [anon_sym_triangleadj] = ACTIONS(2224),
    [anon_sym_lineadj] = ACTIONS(2224),
    [anon_sym_triangle] = ACTIONS(2224),
    [anon_sym_cbuffer] = ACTIONS(2224),
    [anon_sym_interface] = ACTIONS(2224),
    [anon_sym_extension] = ACTIONS(2224),
  },
  [181] = {
    [sym_identifier] = ACTIONS(2210),
    [aux_sym_preproc_include_token1] = ACTIONS(2210),
    [aux_sym_preproc_def_token1] = ACTIONS(2210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2212),
    [anon_sym_COMMA] = ACTIONS(2212),
    [aux_sym_preproc_if_token1] = ACTIONS(2210),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2210),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2210),
    [sym_preproc_directive] = ACTIONS(2210),
    [anon_sym_LPAREN2] = ACTIONS(2214),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2217),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2214),
    [anon_sym_SLASH] = ACTIONS(2222),
    [anon_sym_PERCENT] = ACTIONS(2212),
    [anon_sym_PIPE_PIPE] = ACTIONS(2212),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2222),
    [anon_sym_CARET] = ACTIONS(2212),
    [anon_sym_AMP] = ACTIONS(2219),
    [anon_sym_EQ_EQ] = ACTIONS(2212),
    [anon_sym_BANG_EQ] = ACTIONS(2212),
    [anon_sym_GT] = ACTIONS(2222),
    [anon_sym_GT_EQ] = ACTIONS(2212),
    [anon_sym_LT_EQ] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(2222),
    [anon_sym_LT_LT] = ACTIONS(2212),
    [anon_sym_GT_GT] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym___extension__] = ACTIONS(2210),
    [anon_sym_typedef] = ACTIONS(2210),
    [anon_sym_in] = ACTIONS(2210),
    [anon_sym_out] = ACTIONS(2210),
    [anon_sym_inout] = ACTIONS(2210),
    [anon_sym_extern] = ACTIONS(2210),
    [anon_sym___attribute__] = ACTIONS(2210),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2214),
    [anon_sym___declspec] = ACTIONS(2210),
    [anon_sym___based] = ACTIONS(2210),
    [anon_sym___cdecl] = ACTIONS(2210),
    [anon_sym___clrcall] = ACTIONS(2210),
    [anon_sym___stdcall] = ACTIONS(2210),
    [anon_sym___fastcall] = ACTIONS(2210),
    [anon_sym___thiscall] = ACTIONS(2210),
    [anon_sym___vectorcall] = ACTIONS(2210),
    [anon_sym_LBRACE] = ACTIONS(2217),
    [anon_sym_RBRACE] = ACTIONS(2217),
    [anon_sym_signed] = ACTIONS(2210),
    [anon_sym_unsigned] = ACTIONS(2210),
    [anon_sym_long] = ACTIONS(2210),
    [anon_sym_short] = ACTIONS(2210),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_static] = ACTIONS(2210),
    [anon_sym_register] = ACTIONS(2210),
    [anon_sym_inline] = ACTIONS(2210),
    [anon_sym___inline] = ACTIONS(2210),
    [anon_sym___inline__] = ACTIONS(2210),
    [anon_sym___forceinline] = ACTIONS(2210),
    [anon_sym_thread_local] = ACTIONS(2210),
    [anon_sym___thread] = ACTIONS(2210),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_constexpr] = ACTIONS(2210),
    [anon_sym_volatile] = ACTIONS(2210),
    [anon_sym_restrict] = ACTIONS(2210),
    [anon_sym___restrict__] = ACTIONS(2210),
    [anon_sym__Atomic] = ACTIONS(2210),
    [anon_sym__Noreturn] = ACTIONS(2210),
    [anon_sym_noreturn] = ACTIONS(2210),
    [anon_sym_mutable] = ACTIONS(2210),
    [anon_sym_constinit] = ACTIONS(2210),
    [anon_sym_consteval] = ACTIONS(2210),
    [anon_sym_alignas] = ACTIONS(2210),
    [anon_sym__Alignas] = ACTIONS(2210),
    [sym_primitive_type] = ACTIONS(2210),
    [anon_sym_enum] = ACTIONS(2210),
    [anon_sym_class] = ACTIONS(2210),
    [anon_sym_struct] = ACTIONS(2210),
    [anon_sym_union] = ACTIONS(2210),
    [anon_sym_if] = ACTIONS(2210),
    [anon_sym_switch] = ACTIONS(2210),
    [anon_sym_case] = ACTIONS(2210),
    [anon_sym_default] = ACTIONS(2210),
    [anon_sym_while] = ACTIONS(2210),
    [anon_sym_do] = ACTIONS(2210),
    [anon_sym_for] = ACTIONS(2210),
    [anon_sym_return] = ACTIONS(2210),
    [anon_sym_break] = ACTIONS(2210),
    [anon_sym_continue] = ACTIONS(2210),
    [anon_sym_goto] = ACTIONS(2210),
    [anon_sym___try] = ACTIONS(2210),
    [anon_sym___leave] = ACTIONS(2210),
    [anon_sym_QMARK] = ACTIONS(2212),
    [anon_sym_not] = ACTIONS(2210),
    [anon_sym_compl] = ACTIONS(2210),
    [anon_sym_LT_EQ_GT] = ACTIONS(2212),
    [anon_sym_or] = ACTIONS(2222),
    [anon_sym_and] = ACTIONS(2222),
    [anon_sym_bitor] = ACTIONS(2222),
    [anon_sym_xor] = ACTIONS(2222),
    [anon_sym_bitand] = ACTIONS(2222),
    [anon_sym_not_eq] = ACTIONS(2222),
    [anon_sym_is] = ACTIONS(2222),
    [anon_sym_as] = ACTIONS(2222),
    [anon_sym_DASH_DASH] = ACTIONS(2214),
    [anon_sym_PLUS_PLUS] = ACTIONS(2214),
    [anon_sym_sizeof] = ACTIONS(2210),
    [anon_sym___alignof__] = ACTIONS(2210),
    [anon_sym___alignof] = ACTIONS(2210),
    [anon_sym__alignof] = ACTIONS(2210),
    [anon_sym_alignof] = ACTIONS(2210),
    [anon_sym__Alignof] = ACTIONS(2210),
    [anon_sym_offsetof] = ACTIONS(2210),
    [anon_sym__Generic] = ACTIONS(2210),
    [anon_sym_asm] = ACTIONS(2210),
    [anon_sym___asm__] = ACTIONS(2210),
    [anon_sym_DOT] = ACTIONS(2219),
    [anon_sym_DOT_STAR] = ACTIONS(2212),
    [anon_sym_DASH_GT] = ACTIONS(2212),
    [sym_number_literal] = ACTIONS(2217),
    [anon_sym_L_SQUOTE] = ACTIONS(2217),
    [anon_sym_u_SQUOTE] = ACTIONS(2217),
    [anon_sym_U_SQUOTE] = ACTIONS(2217),
    [anon_sym_u8_SQUOTE] = ACTIONS(2217),
    [anon_sym_SQUOTE] = ACTIONS(2217),
    [anon_sym_L_DQUOTE] = ACTIONS(2217),
    [anon_sym_u_DQUOTE] = ACTIONS(2217),
    [anon_sym_U_DQUOTE] = ACTIONS(2217),
    [anon_sym_u8_DQUOTE] = ACTIONS(2217),
    [anon_sym_DQUOTE] = ACTIONS(2217),
    [sym_true] = ACTIONS(2210),
    [sym_false] = ACTIONS(2210),
    [anon_sym_NULL] = ACTIONS(2210),
    [anon_sym_nullptr] = ACTIONS(2210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2210),
    [anon_sym_let] = ACTIONS(2210),
    [anon_sym_This] = ACTIONS(2210),
    [anon_sym_decltype] = ACTIONS(2210),
    [sym_virtual] = ACTIONS(2210),
    [anon_sym_explicit] = ACTIONS(2210),
    [anon_sym_typename] = ACTIONS(2210),
    [anon_sym_template] = ACTIONS(2210),
    [anon_sym_operator] = ACTIONS(2210),
    [anon_sym_try] = ACTIONS(2210),
    [anon_sym_delete] = ACTIONS(2210),
    [anon_sym_throw] = ACTIONS(2210),
    [anon_sym_namespace] = ACTIONS(2210),
    [anon_sym_using] = ACTIONS(2210),
    [anon_sym_static_assert] = ACTIONS(2210),
    [anon_sym_concept] = ACTIONS(2210),
    [anon_sym_co_return] = ACTIONS(2210),
    [anon_sym_co_yield] = ACTIONS(2210),
    [anon_sym_R_DQUOTE] = ACTIONS(2217),
    [anon_sym_LR_DQUOTE] = ACTIONS(2217),
    [anon_sym_uR_DQUOTE] = ACTIONS(2217),
    [anon_sym_UR_DQUOTE] = ACTIONS(2217),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2217),
    [anon_sym_co_await] = ACTIONS(2210),
    [anon_sym_new] = ACTIONS(2210),
    [anon_sym_requires] = ACTIONS(2210),
    [sym_this] = ACTIONS(2210),
    [anon_sym_discard] = ACTIONS(2210),
    [anon_sym_precise] = ACTIONS(2210),
    [anon_sym_shared] = ACTIONS(2210),
    [anon_sym_groupshared] = ACTIONS(2210),
    [anon_sym_uniform] = ACTIONS(2210),
    [anon_sym_row_major] = ACTIONS(2210),
    [anon_sym_column_major] = ACTIONS(2210),
    [anon_sym_globallycoherent] = ACTIONS(2210),
    [anon_sym_centroid] = ACTIONS(2210),
    [anon_sym_noperspective] = ACTIONS(2210),
    [anon_sym_nointerpolation] = ACTIONS(2210),
    [anon_sym_sample] = ACTIONS(2210),
    [anon_sym_linear] = ACTIONS(2210),
    [anon_sym_snorm] = ACTIONS(2210),
    [anon_sym_unorm] = ACTIONS(2210),
    [anon_sym_point] = ACTIONS(2210),
    [anon_sym_line] = ACTIONS(2210),
    [anon_sym_triangleadj] = ACTIONS(2210),
    [anon_sym_lineadj] = ACTIONS(2210),
    [anon_sym_triangle] = ACTIONS(2210),
    [anon_sym_cbuffer] = ACTIONS(2210),
    [anon_sym_interface] = ACTIONS(2210),
    [anon_sym_extension] = ACTIONS(2210),
  },
  [182] = {
    [sym_declaration] = STATE(1769),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6178),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__for_statement_body] = STATE(10184),
    [sym_expression] = STATE(5459),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10868),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(2263),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(2345),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2273),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [183] = {
    [sym_declaration] = STATE(1769),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6178),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__for_statement_body] = STATE(10242),
    [sym_expression] = STATE(5459),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10868),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(2263),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(2345),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2273),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [184] = {
    [sym_declaration] = STATE(1769),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6178),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__for_statement_body] = STATE(10381),
    [sym_expression] = STATE(5459),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10868),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(2263),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(2345),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2273),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [185] = {
    [sym_declaration] = STATE(1769),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6178),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__for_statement_body] = STATE(10087),
    [sym_expression] = STATE(5459),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10868),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(2263),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(2345),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2273),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [186] = {
    [sym_declaration] = STATE(1769),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6178),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__for_statement_body] = STATE(10857),
    [sym_expression] = STATE(5459),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10868),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(2263),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(2345),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2273),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [187] = {
    [ts_builtin_sym_end] = ACTIONS(2217),
    [sym_identifier] = ACTIONS(2210),
    [aux_sym_preproc_include_token1] = ACTIONS(2210),
    [aux_sym_preproc_def_token1] = ACTIONS(2210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2212),
    [aux_sym_preproc_if_token1] = ACTIONS(2210),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2210),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2210),
    [sym_preproc_directive] = ACTIONS(2210),
    [anon_sym_LPAREN2] = ACTIONS(2214),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2217),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2214),
    [anon_sym_SLASH] = ACTIONS(2222),
    [anon_sym_PERCENT] = ACTIONS(2212),
    [anon_sym_PIPE_PIPE] = ACTIONS(2212),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2222),
    [anon_sym_CARET] = ACTIONS(2212),
    [anon_sym_AMP] = ACTIONS(2219),
    [anon_sym_EQ_EQ] = ACTIONS(2212),
    [anon_sym_BANG_EQ] = ACTIONS(2212),
    [anon_sym_GT] = ACTIONS(2222),
    [anon_sym_GT_EQ] = ACTIONS(2212),
    [anon_sym_LT_EQ] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(2222),
    [anon_sym_LT_LT] = ACTIONS(2212),
    [anon_sym_GT_GT] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym___extension__] = ACTIONS(2210),
    [anon_sym_typedef] = ACTIONS(2210),
    [anon_sym_in] = ACTIONS(2210),
    [anon_sym_out] = ACTIONS(2210),
    [anon_sym_inout] = ACTIONS(2210),
    [anon_sym_extern] = ACTIONS(2210),
    [anon_sym___attribute__] = ACTIONS(2210),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2214),
    [anon_sym___declspec] = ACTIONS(2210),
    [anon_sym___based] = ACTIONS(2210),
    [anon_sym___cdecl] = ACTIONS(2210),
    [anon_sym___clrcall] = ACTIONS(2210),
    [anon_sym___stdcall] = ACTIONS(2210),
    [anon_sym___fastcall] = ACTIONS(2210),
    [anon_sym___thiscall] = ACTIONS(2210),
    [anon_sym___vectorcall] = ACTIONS(2210),
    [anon_sym_LBRACE] = ACTIONS(2217),
    [anon_sym_signed] = ACTIONS(2210),
    [anon_sym_unsigned] = ACTIONS(2210),
    [anon_sym_long] = ACTIONS(2210),
    [anon_sym_short] = ACTIONS(2210),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_static] = ACTIONS(2210),
    [anon_sym_register] = ACTIONS(2210),
    [anon_sym_inline] = ACTIONS(2210),
    [anon_sym___inline] = ACTIONS(2210),
    [anon_sym___inline__] = ACTIONS(2210),
    [anon_sym___forceinline] = ACTIONS(2210),
    [anon_sym_thread_local] = ACTIONS(2210),
    [anon_sym___thread] = ACTIONS(2210),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_constexpr] = ACTIONS(2210),
    [anon_sym_volatile] = ACTIONS(2210),
    [anon_sym_restrict] = ACTIONS(2210),
    [anon_sym___restrict__] = ACTIONS(2210),
    [anon_sym__Atomic] = ACTIONS(2210),
    [anon_sym__Noreturn] = ACTIONS(2210),
    [anon_sym_noreturn] = ACTIONS(2210),
    [anon_sym_mutable] = ACTIONS(2210),
    [anon_sym_constinit] = ACTIONS(2210),
    [anon_sym_consteval] = ACTIONS(2210),
    [anon_sym_alignas] = ACTIONS(2210),
    [anon_sym__Alignas] = ACTIONS(2210),
    [sym_primitive_type] = ACTIONS(2210),
    [anon_sym_enum] = ACTIONS(2210),
    [anon_sym_class] = ACTIONS(2210),
    [anon_sym_struct] = ACTIONS(2210),
    [anon_sym_union] = ACTIONS(2210),
    [anon_sym_if] = ACTIONS(2210),
    [anon_sym_switch] = ACTIONS(2210),
    [anon_sym_case] = ACTIONS(2210),
    [anon_sym_default] = ACTIONS(2210),
    [anon_sym_while] = ACTIONS(2210),
    [anon_sym_do] = ACTIONS(2210),
    [anon_sym_for] = ACTIONS(2210),
    [anon_sym_return] = ACTIONS(2210),
    [anon_sym_break] = ACTIONS(2210),
    [anon_sym_continue] = ACTIONS(2210),
    [anon_sym_goto] = ACTIONS(2210),
    [anon_sym_QMARK] = ACTIONS(2212),
    [anon_sym_not] = ACTIONS(2210),
    [anon_sym_compl] = ACTIONS(2210),
    [anon_sym_LT_EQ_GT] = ACTIONS(2212),
    [anon_sym_or] = ACTIONS(2222),
    [anon_sym_and] = ACTIONS(2222),
    [anon_sym_bitor] = ACTIONS(2222),
    [anon_sym_xor] = ACTIONS(2222),
    [anon_sym_bitand] = ACTIONS(2222),
    [anon_sym_not_eq] = ACTIONS(2222),
    [anon_sym_is] = ACTIONS(2222),
    [anon_sym_as] = ACTIONS(2222),
    [anon_sym_DASH_DASH] = ACTIONS(2214),
    [anon_sym_PLUS_PLUS] = ACTIONS(2214),
    [anon_sym_sizeof] = ACTIONS(2210),
    [anon_sym___alignof__] = ACTIONS(2210),
    [anon_sym___alignof] = ACTIONS(2210),
    [anon_sym__alignof] = ACTIONS(2210),
    [anon_sym_alignof] = ACTIONS(2210),
    [anon_sym__Alignof] = ACTIONS(2210),
    [anon_sym_offsetof] = ACTIONS(2210),
    [anon_sym__Generic] = ACTIONS(2210),
    [anon_sym_asm] = ACTIONS(2210),
    [anon_sym___asm__] = ACTIONS(2210),
    [anon_sym_DOT] = ACTIONS(2219),
    [anon_sym_DOT_STAR] = ACTIONS(2212),
    [anon_sym_DASH_GT] = ACTIONS(2212),
    [sym_number_literal] = ACTIONS(2217),
    [anon_sym_L_SQUOTE] = ACTIONS(2217),
    [anon_sym_u_SQUOTE] = ACTIONS(2217),
    [anon_sym_U_SQUOTE] = ACTIONS(2217),
    [anon_sym_u8_SQUOTE] = ACTIONS(2217),
    [anon_sym_SQUOTE] = ACTIONS(2217),
    [anon_sym_L_DQUOTE] = ACTIONS(2217),
    [anon_sym_u_DQUOTE] = ACTIONS(2217),
    [anon_sym_U_DQUOTE] = ACTIONS(2217),
    [anon_sym_u8_DQUOTE] = ACTIONS(2217),
    [anon_sym_DQUOTE] = ACTIONS(2217),
    [sym_true] = ACTIONS(2210),
    [sym_false] = ACTIONS(2210),
    [anon_sym_NULL] = ACTIONS(2210),
    [anon_sym_nullptr] = ACTIONS(2210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2210),
    [anon_sym_let] = ACTIONS(2210),
    [anon_sym_This] = ACTIONS(2210),
    [anon_sym_decltype] = ACTIONS(2210),
    [sym_virtual] = ACTIONS(2210),
    [anon_sym_explicit] = ACTIONS(2210),
    [anon_sym_typename] = ACTIONS(2210),
    [anon_sym_template] = ACTIONS(2210),
    [anon_sym_operator] = ACTIONS(2210),
    [anon_sym_try] = ACTIONS(2210),
    [anon_sym_delete] = ACTIONS(2210),
    [anon_sym_throw] = ACTIONS(2210),
    [anon_sym_namespace] = ACTIONS(2210),
    [anon_sym_using] = ACTIONS(2210),
    [anon_sym_static_assert] = ACTIONS(2210),
    [anon_sym_concept] = ACTIONS(2210),
    [anon_sym_co_return] = ACTIONS(2210),
    [anon_sym_co_yield] = ACTIONS(2210),
    [anon_sym_R_DQUOTE] = ACTIONS(2217),
    [anon_sym_LR_DQUOTE] = ACTIONS(2217),
    [anon_sym_uR_DQUOTE] = ACTIONS(2217),
    [anon_sym_UR_DQUOTE] = ACTIONS(2217),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2217),
    [anon_sym_co_await] = ACTIONS(2210),
    [anon_sym_new] = ACTIONS(2210),
    [anon_sym_requires] = ACTIONS(2210),
    [sym_this] = ACTIONS(2210),
    [anon_sym_precise] = ACTIONS(2210),
    [anon_sym_shared] = ACTIONS(2210),
    [anon_sym_groupshared] = ACTIONS(2210),
    [anon_sym_uniform] = ACTIONS(2210),
    [anon_sym_row_major] = ACTIONS(2210),
    [anon_sym_column_major] = ACTIONS(2210),
    [anon_sym_globallycoherent] = ACTIONS(2210),
    [anon_sym_centroid] = ACTIONS(2210),
    [anon_sym_noperspective] = ACTIONS(2210),
    [anon_sym_nointerpolation] = ACTIONS(2210),
    [anon_sym_sample] = ACTIONS(2210),
    [anon_sym_linear] = ACTIONS(2210),
    [anon_sym_snorm] = ACTIONS(2210),
    [anon_sym_unorm] = ACTIONS(2210),
    [anon_sym_point] = ACTIONS(2210),
    [anon_sym_line] = ACTIONS(2210),
    [anon_sym_triangleadj] = ACTIONS(2210),
    [anon_sym_lineadj] = ACTIONS(2210),
    [anon_sym_triangle] = ACTIONS(2210),
    [anon_sym_interface] = ACTIONS(2210),
    [anon_sym_extension] = ACTIONS(2210),
    [anon_sym___exported] = ACTIONS(2210),
    [anon_sym_import] = ACTIONS(2210),
  },
  [188] = {
    [sym_declaration] = STATE(1769),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6178),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__for_statement_body] = STATE(10434),
    [sym_expression] = STATE(5459),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10868),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(2263),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(2345),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2273),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [189] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6350),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_expression] = STATE(5320),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10513),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2728),
    [sym_template_function] = STATE(4704),
    [sym_condition_declaration] = STATE(10513),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6837),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(2727),
    [sym_user_defined_literal] = STATE(4081),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(2263),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2273),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(201),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [190] = {
    [sym_template_argument_list] = STATE(212),
    [ts_builtin_sym_end] = ACTIONS(2347),
    [sym_identifier] = ACTIONS(2349),
    [aux_sym_preproc_include_token1] = ACTIONS(2349),
    [aux_sym_preproc_def_token1] = ACTIONS(2349),
    [anon_sym_COMMA] = ACTIONS(2347),
    [anon_sym_RPAREN] = ACTIONS(2347),
    [aux_sym_preproc_if_token1] = ACTIONS(2349),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2349),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2349),
    [sym_preproc_directive] = ACTIONS(2349),
    [anon_sym_LPAREN2] = ACTIONS(2347),
    [anon_sym_BANG] = ACTIONS(2347),
    [anon_sym_TILDE] = ACTIONS(2347),
    [anon_sym_DASH] = ACTIONS(2349),
    [anon_sym_PLUS] = ACTIONS(2349),
    [anon_sym_STAR] = ACTIONS(2347),
    [anon_sym_PIPE_PIPE] = ACTIONS(2347),
    [anon_sym_AMP_AMP] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2349),
    [anon_sym_LT] = ACTIONS(2351),
    [anon_sym_COLON] = ACTIONS(2349),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym___extension__] = ACTIONS(2349),
    [anon_sym_typedef] = ACTIONS(2349),
    [anon_sym_in] = ACTIONS(2349),
    [anon_sym_out] = ACTIONS(2349),
    [anon_sym_inout] = ACTIONS(2349),
    [anon_sym_extern] = ACTIONS(2349),
    [anon_sym___attribute__] = ACTIONS(2349),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2347),
    [anon_sym___declspec] = ACTIONS(2349),
    [anon_sym___based] = ACTIONS(2349),
    [anon_sym___cdecl] = ACTIONS(2349),
    [anon_sym___clrcall] = ACTIONS(2349),
    [anon_sym___stdcall] = ACTIONS(2349),
    [anon_sym___fastcall] = ACTIONS(2349),
    [anon_sym___thiscall] = ACTIONS(2349),
    [anon_sym___vectorcall] = ACTIONS(2349),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_signed] = ACTIONS(2349),
    [anon_sym_unsigned] = ACTIONS(2349),
    [anon_sym_long] = ACTIONS(2349),
    [anon_sym_short] = ACTIONS(2349),
    [anon_sym_LBRACK] = ACTIONS(2349),
    [anon_sym_static] = ACTIONS(2349),
    [anon_sym_EQ] = ACTIONS(2347),
    [anon_sym_register] = ACTIONS(2349),
    [anon_sym_inline] = ACTIONS(2349),
    [anon_sym___inline] = ACTIONS(2349),
    [anon_sym___inline__] = ACTIONS(2349),
    [anon_sym___forceinline] = ACTIONS(2349),
    [anon_sym_thread_local] = ACTIONS(2349),
    [anon_sym___thread] = ACTIONS(2349),
    [anon_sym_const] = ACTIONS(2349),
    [anon_sym_constexpr] = ACTIONS(2349),
    [anon_sym_volatile] = ACTIONS(2349),
    [anon_sym_restrict] = ACTIONS(2349),
    [anon_sym___restrict__] = ACTIONS(2349),
    [anon_sym__Atomic] = ACTIONS(2349),
    [anon_sym__Noreturn] = ACTIONS(2349),
    [anon_sym_noreturn] = ACTIONS(2349),
    [anon_sym_mutable] = ACTIONS(2349),
    [anon_sym_constinit] = ACTIONS(2349),
    [anon_sym_consteval] = ACTIONS(2349),
    [anon_sym_alignas] = ACTIONS(2349),
    [anon_sym__Alignas] = ACTIONS(2349),
    [sym_primitive_type] = ACTIONS(2349),
    [anon_sym_enum] = ACTIONS(2349),
    [anon_sym_class] = ACTIONS(2349),
    [anon_sym_struct] = ACTIONS(2349),
    [anon_sym_union] = ACTIONS(2349),
    [anon_sym_if] = ACTIONS(2349),
    [anon_sym_else] = ACTIONS(2349),
    [anon_sym_switch] = ACTIONS(2349),
    [anon_sym_case] = ACTIONS(2349),
    [anon_sym_default] = ACTIONS(2349),
    [anon_sym_while] = ACTIONS(2349),
    [anon_sym_do] = ACTIONS(2349),
    [anon_sym_for] = ACTIONS(2349),
    [anon_sym_return] = ACTIONS(2349),
    [anon_sym_break] = ACTIONS(2349),
    [anon_sym_continue] = ACTIONS(2349),
    [anon_sym_goto] = ACTIONS(2349),
    [anon_sym___try] = ACTIONS(2349),
    [anon_sym___leave] = ACTIONS(2349),
    [anon_sym_not] = ACTIONS(2349),
    [anon_sym_compl] = ACTIONS(2349),
    [anon_sym_or] = ACTIONS(2349),
    [anon_sym_and] = ACTIONS(2349),
    [anon_sym_DASH_DASH] = ACTIONS(2347),
    [anon_sym_PLUS_PLUS] = ACTIONS(2347),
    [anon_sym_sizeof] = ACTIONS(2349),
    [anon_sym___alignof__] = ACTIONS(2349),
    [anon_sym___alignof] = ACTIONS(2349),
    [anon_sym__alignof] = ACTIONS(2349),
    [anon_sym_alignof] = ACTIONS(2349),
    [anon_sym__Alignof] = ACTIONS(2349),
    [anon_sym_offsetof] = ACTIONS(2349),
    [anon_sym__Generic] = ACTIONS(2349),
    [anon_sym_asm] = ACTIONS(2349),
    [anon_sym___asm__] = ACTIONS(2349),
    [anon_sym_DOT] = ACTIONS(2349),
    [sym_number_literal] = ACTIONS(2347),
    [anon_sym_L_SQUOTE] = ACTIONS(2347),
    [anon_sym_u_SQUOTE] = ACTIONS(2347),
    [anon_sym_U_SQUOTE] = ACTIONS(2347),
    [anon_sym_u8_SQUOTE] = ACTIONS(2347),
    [anon_sym_SQUOTE] = ACTIONS(2347),
    [anon_sym_L_DQUOTE] = ACTIONS(2347),
    [anon_sym_u_DQUOTE] = ACTIONS(2347),
    [anon_sym_U_DQUOTE] = ACTIONS(2347),
    [anon_sym_u8_DQUOTE] = ACTIONS(2347),
    [anon_sym_DQUOTE] = ACTIONS(2347),
    [sym_true] = ACTIONS(2349),
    [sym_false] = ACTIONS(2349),
    [anon_sym_NULL] = ACTIONS(2349),
    [anon_sym_nullptr] = ACTIONS(2349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2349),
    [anon_sym_let] = ACTIONS(2349),
    [anon_sym_This] = ACTIONS(2349),
    [anon_sym_decltype] = ACTIONS(2349),
    [anon_sym_final] = ACTIONS(2349),
    [anon_sym_override] = ACTIONS(2349),
    [sym_virtual] = ACTIONS(2349),
    [anon_sym_explicit] = ACTIONS(2349),
    [anon_sym_typename] = ACTIONS(2349),
    [anon_sym_template] = ACTIONS(2349),
    [anon_sym_GT2] = ACTIONS(2347),
    [anon_sym_operator] = ACTIONS(2349),
    [anon_sym_try] = ACTIONS(2349),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_throw] = ACTIONS(2349),
    [anon_sym_namespace] = ACTIONS(2349),
    [anon_sym_using] = ACTIONS(2349),
    [anon_sym_static_assert] = ACTIONS(2349),
    [anon_sym_concept] = ACTIONS(2349),
    [anon_sym_co_return] = ACTIONS(2349),
    [anon_sym_co_yield] = ACTIONS(2349),
    [anon_sym_R_DQUOTE] = ACTIONS(2347),
    [anon_sym_LR_DQUOTE] = ACTIONS(2347),
    [anon_sym_uR_DQUOTE] = ACTIONS(2347),
    [anon_sym_UR_DQUOTE] = ACTIONS(2347),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2347),
    [anon_sym_co_await] = ACTIONS(2349),
    [anon_sym_new] = ACTIONS(2349),
    [anon_sym_requires] = ACTIONS(2349),
    [sym_this] = ACTIONS(2349),
    [anon_sym_discard] = ACTIONS(2349),
    [anon_sym_precise] = ACTIONS(2349),
    [anon_sym_shared] = ACTIONS(2349),
    [anon_sym_groupshared] = ACTIONS(2349),
    [anon_sym_uniform] = ACTIONS(2349),
    [anon_sym_row_major] = ACTIONS(2349),
    [anon_sym_column_major] = ACTIONS(2349),
    [anon_sym_globallycoherent] = ACTIONS(2349),
    [anon_sym_centroid] = ACTIONS(2349),
    [anon_sym_noperspective] = ACTIONS(2349),
    [anon_sym_nointerpolation] = ACTIONS(2349),
    [anon_sym_sample] = ACTIONS(2349),
    [anon_sym_linear] = ACTIONS(2349),
    [anon_sym_snorm] = ACTIONS(2349),
    [anon_sym_unorm] = ACTIONS(2349),
    [anon_sym_point] = ACTIONS(2349),
    [anon_sym_line] = ACTIONS(2349),
    [anon_sym_triangleadj] = ACTIONS(2349),
    [anon_sym_lineadj] = ACTIONS(2349),
    [anon_sym_triangle] = ACTIONS(2349),
    [anon_sym_cbuffer] = ACTIONS(2349),
    [anon_sym_interface] = ACTIONS(2349),
    [anon_sym_extension] = ACTIONS(2349),
    [anon_sym_where] = ACTIONS(2349),
    [anon_sym___exported] = ACTIONS(2349),
    [anon_sym_import] = ACTIONS(2349),
  },
  [191] = {
    [ts_builtin_sym_end] = ACTIONS(2353),
    [sym_identifier] = ACTIONS(2355),
    [aux_sym_preproc_include_token1] = ACTIONS(2355),
    [aux_sym_preproc_def_token1] = ACTIONS(2355),
    [anon_sym_COMMA] = ACTIONS(2353),
    [anon_sym_RPAREN] = ACTIONS(2353),
    [aux_sym_preproc_if_token1] = ACTIONS(2355),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2355),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2355),
    [sym_preproc_directive] = ACTIONS(2355),
    [anon_sym_LPAREN2] = ACTIONS(2353),
    [anon_sym_BANG] = ACTIONS(2353),
    [anon_sym_TILDE] = ACTIONS(2353),
    [anon_sym_DASH] = ACTIONS(2355),
    [anon_sym_PLUS] = ACTIONS(2355),
    [anon_sym_STAR] = ACTIONS(2353),
    [anon_sym_PIPE_PIPE] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(2353),
    [anon_sym_AMP] = ACTIONS(2355),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym___extension__] = ACTIONS(2355),
    [anon_sym_typedef] = ACTIONS(2355),
    [anon_sym_in] = ACTIONS(2355),
    [anon_sym_out] = ACTIONS(2355),
    [anon_sym_inout] = ACTIONS(2355),
    [anon_sym_extern] = ACTIONS(2355),
    [anon_sym___attribute__] = ACTIONS(2355),
    [anon_sym_COLON_COLON] = ACTIONS(2353),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2353),
    [anon_sym___declspec] = ACTIONS(2355),
    [anon_sym___based] = ACTIONS(2355),
    [anon_sym___cdecl] = ACTIONS(2355),
    [anon_sym___clrcall] = ACTIONS(2355),
    [anon_sym___stdcall] = ACTIONS(2355),
    [anon_sym___fastcall] = ACTIONS(2355),
    [anon_sym___thiscall] = ACTIONS(2355),
    [anon_sym___vectorcall] = ACTIONS(2355),
    [anon_sym_LBRACE] = ACTIONS(2353),
    [anon_sym_RBRACE] = ACTIONS(2353),
    [anon_sym_signed] = ACTIONS(2355),
    [anon_sym_unsigned] = ACTIONS(2355),
    [anon_sym_long] = ACTIONS(2355),
    [anon_sym_short] = ACTIONS(2355),
    [anon_sym_LBRACK] = ACTIONS(2355),
    [anon_sym_static] = ACTIONS(2355),
    [anon_sym_register] = ACTIONS(2355),
    [anon_sym_inline] = ACTIONS(2355),
    [anon_sym___inline] = ACTIONS(2355),
    [anon_sym___inline__] = ACTIONS(2355),
    [anon_sym___forceinline] = ACTIONS(2355),
    [anon_sym_thread_local] = ACTIONS(2355),
    [anon_sym___thread] = ACTIONS(2355),
    [anon_sym_const] = ACTIONS(2355),
    [anon_sym_constexpr] = ACTIONS(2355),
    [anon_sym_volatile] = ACTIONS(2355),
    [anon_sym_restrict] = ACTIONS(2355),
    [anon_sym___restrict__] = ACTIONS(2355),
    [anon_sym__Atomic] = ACTIONS(2355),
    [anon_sym__Noreturn] = ACTIONS(2355),
    [anon_sym_noreturn] = ACTIONS(2355),
    [anon_sym_mutable] = ACTIONS(2355),
    [anon_sym_constinit] = ACTIONS(2355),
    [anon_sym_consteval] = ACTIONS(2355),
    [anon_sym_alignas] = ACTIONS(2355),
    [anon_sym__Alignas] = ACTIONS(2355),
    [sym_primitive_type] = ACTIONS(2355),
    [anon_sym_enum] = ACTIONS(2355),
    [anon_sym_class] = ACTIONS(2355),
    [anon_sym_struct] = ACTIONS(2355),
    [anon_sym_union] = ACTIONS(2355),
    [anon_sym_if] = ACTIONS(2355),
    [anon_sym_else] = ACTIONS(2355),
    [anon_sym_switch] = ACTIONS(2355),
    [anon_sym_case] = ACTIONS(2355),
    [anon_sym_default] = ACTIONS(2355),
    [anon_sym_while] = ACTIONS(2355),
    [anon_sym_do] = ACTIONS(2355),
    [anon_sym_for] = ACTIONS(2355),
    [anon_sym_return] = ACTIONS(2355),
    [anon_sym_break] = ACTIONS(2355),
    [anon_sym_continue] = ACTIONS(2355),
    [anon_sym_goto] = ACTIONS(2355),
    [anon_sym___try] = ACTIONS(2355),
    [anon_sym___except] = ACTIONS(2355),
    [anon_sym___finally] = ACTIONS(2355),
    [anon_sym___leave] = ACTIONS(2355),
    [anon_sym_not] = ACTIONS(2355),
    [anon_sym_compl] = ACTIONS(2355),
    [anon_sym_or] = ACTIONS(2355),
    [anon_sym_and] = ACTIONS(2355),
    [anon_sym_DASH_DASH] = ACTIONS(2353),
    [anon_sym_PLUS_PLUS] = ACTIONS(2353),
    [anon_sym_sizeof] = ACTIONS(2355),
    [anon_sym___alignof__] = ACTIONS(2355),
    [anon_sym___alignof] = ACTIONS(2355),
    [anon_sym__alignof] = ACTIONS(2355),
    [anon_sym_alignof] = ACTIONS(2355),
    [anon_sym__Alignof] = ACTIONS(2355),
    [anon_sym_offsetof] = ACTIONS(2355),
    [anon_sym__Generic] = ACTIONS(2355),
    [anon_sym_asm] = ACTIONS(2355),
    [anon_sym___asm__] = ACTIONS(2355),
    [sym_number_literal] = ACTIONS(2353),
    [anon_sym_L_SQUOTE] = ACTIONS(2353),
    [anon_sym_u_SQUOTE] = ACTIONS(2353),
    [anon_sym_U_SQUOTE] = ACTIONS(2353),
    [anon_sym_u8_SQUOTE] = ACTIONS(2353),
    [anon_sym_SQUOTE] = ACTIONS(2353),
    [anon_sym_L_DQUOTE] = ACTIONS(2353),
    [anon_sym_u_DQUOTE] = ACTIONS(2353),
    [anon_sym_U_DQUOTE] = ACTIONS(2353),
    [anon_sym_u8_DQUOTE] = ACTIONS(2353),
    [anon_sym_DQUOTE] = ACTIONS(2353),
    [sym_true] = ACTIONS(2355),
    [sym_false] = ACTIONS(2355),
    [anon_sym_NULL] = ACTIONS(2355),
    [anon_sym_nullptr] = ACTIONS(2355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2355),
    [anon_sym_let] = ACTIONS(2355),
    [anon_sym_This] = ACTIONS(2355),
    [anon_sym_decltype] = ACTIONS(2355),
    [anon_sym_final] = ACTIONS(2355),
    [anon_sym_override] = ACTIONS(2355),
    [sym_virtual] = ACTIONS(2355),
    [anon_sym_explicit] = ACTIONS(2355),
    [anon_sym_typename] = ACTIONS(2355),
    [anon_sym_template] = ACTIONS(2355),
    [anon_sym_operator] = ACTIONS(2355),
    [anon_sym_try] = ACTIONS(2355),
    [anon_sym_delete] = ACTIONS(2355),
    [anon_sym_throw] = ACTIONS(2355),
    [anon_sym_namespace] = ACTIONS(2355),
    [anon_sym_using] = ACTIONS(2355),
    [anon_sym_static_assert] = ACTIONS(2355),
    [anon_sym_concept] = ACTIONS(2355),
    [anon_sym_co_return] = ACTIONS(2355),
    [anon_sym_co_yield] = ACTIONS(2355),
    [anon_sym_catch] = ACTIONS(2355),
    [anon_sym_R_DQUOTE] = ACTIONS(2353),
    [anon_sym_LR_DQUOTE] = ACTIONS(2353),
    [anon_sym_uR_DQUOTE] = ACTIONS(2353),
    [anon_sym_UR_DQUOTE] = ACTIONS(2353),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2353),
    [anon_sym_co_await] = ACTIONS(2355),
    [anon_sym_new] = ACTIONS(2355),
    [anon_sym_requires] = ACTIONS(2355),
    [sym_this] = ACTIONS(2355),
    [anon_sym_discard] = ACTIONS(2355),
    [anon_sym_precise] = ACTIONS(2355),
    [anon_sym_shared] = ACTIONS(2355),
    [anon_sym_groupshared] = ACTIONS(2355),
    [anon_sym_uniform] = ACTIONS(2355),
    [anon_sym_row_major] = ACTIONS(2355),
    [anon_sym_column_major] = ACTIONS(2355),
    [anon_sym_globallycoherent] = ACTIONS(2355),
    [anon_sym_centroid] = ACTIONS(2355),
    [anon_sym_noperspective] = ACTIONS(2355),
    [anon_sym_nointerpolation] = ACTIONS(2355),
    [anon_sym_sample] = ACTIONS(2355),
    [anon_sym_linear] = ACTIONS(2355),
    [anon_sym_snorm] = ACTIONS(2355),
    [anon_sym_unorm] = ACTIONS(2355),
    [anon_sym_point] = ACTIONS(2355),
    [anon_sym_line] = ACTIONS(2355),
    [anon_sym_triangleadj] = ACTIONS(2355),
    [anon_sym_lineadj] = ACTIONS(2355),
    [anon_sym_triangle] = ACTIONS(2355),
    [anon_sym_cbuffer] = ACTIONS(2355),
    [anon_sym_interface] = ACTIONS(2355),
    [anon_sym_extension] = ACTIONS(2355),
    [anon_sym_where] = ACTIONS(2355),
    [anon_sym___exported] = ACTIONS(2355),
    [anon_sym_import] = ACTIONS(2355),
    [anon_sym_get] = ACTIONS(2355),
    [anon_sym_set] = ACTIONS(2355),
  },
  [192] = {
    [ts_builtin_sym_end] = ACTIONS(2357),
    [sym_identifier] = ACTIONS(2359),
    [aux_sym_preproc_include_token1] = ACTIONS(2359),
    [aux_sym_preproc_def_token1] = ACTIONS(2359),
    [anon_sym_COMMA] = ACTIONS(2357),
    [anon_sym_RPAREN] = ACTIONS(2357),
    [aux_sym_preproc_if_token1] = ACTIONS(2359),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2359),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2359),
    [sym_preproc_directive] = ACTIONS(2359),
    [anon_sym_LPAREN2] = ACTIONS(2357),
    [anon_sym_BANG] = ACTIONS(2357),
    [anon_sym_TILDE] = ACTIONS(2357),
    [anon_sym_DASH] = ACTIONS(2359),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_STAR] = ACTIONS(2357),
    [anon_sym_PIPE_PIPE] = ACTIONS(2357),
    [anon_sym_AMP_AMP] = ACTIONS(2357),
    [anon_sym_AMP] = ACTIONS(2359),
    [anon_sym_SEMI] = ACTIONS(2357),
    [anon_sym___extension__] = ACTIONS(2359),
    [anon_sym_typedef] = ACTIONS(2359),
    [anon_sym_in] = ACTIONS(2359),
    [anon_sym_out] = ACTIONS(2359),
    [anon_sym_inout] = ACTIONS(2359),
    [anon_sym_extern] = ACTIONS(2359),
    [anon_sym___attribute__] = ACTIONS(2359),
    [anon_sym_COLON_COLON] = ACTIONS(2357),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2357),
    [anon_sym___declspec] = ACTIONS(2359),
    [anon_sym___based] = ACTIONS(2359),
    [anon_sym___cdecl] = ACTIONS(2359),
    [anon_sym___clrcall] = ACTIONS(2359),
    [anon_sym___stdcall] = ACTIONS(2359),
    [anon_sym___fastcall] = ACTIONS(2359),
    [anon_sym___thiscall] = ACTIONS(2359),
    [anon_sym___vectorcall] = ACTIONS(2359),
    [anon_sym_LBRACE] = ACTIONS(2357),
    [anon_sym_RBRACE] = ACTIONS(2357),
    [anon_sym_signed] = ACTIONS(2359),
    [anon_sym_unsigned] = ACTIONS(2359),
    [anon_sym_long] = ACTIONS(2359),
    [anon_sym_short] = ACTIONS(2359),
    [anon_sym_LBRACK] = ACTIONS(2359),
    [anon_sym_static] = ACTIONS(2359),
    [anon_sym_register] = ACTIONS(2359),
    [anon_sym_inline] = ACTIONS(2359),
    [anon_sym___inline] = ACTIONS(2359),
    [anon_sym___inline__] = ACTIONS(2359),
    [anon_sym___forceinline] = ACTIONS(2359),
    [anon_sym_thread_local] = ACTIONS(2359),
    [anon_sym___thread] = ACTIONS(2359),
    [anon_sym_const] = ACTIONS(2359),
    [anon_sym_constexpr] = ACTIONS(2359),
    [anon_sym_volatile] = ACTIONS(2359),
    [anon_sym_restrict] = ACTIONS(2359),
    [anon_sym___restrict__] = ACTIONS(2359),
    [anon_sym__Atomic] = ACTIONS(2359),
    [anon_sym__Noreturn] = ACTIONS(2359),
    [anon_sym_noreturn] = ACTIONS(2359),
    [anon_sym_mutable] = ACTIONS(2359),
    [anon_sym_constinit] = ACTIONS(2359),
    [anon_sym_consteval] = ACTIONS(2359),
    [anon_sym_alignas] = ACTIONS(2359),
    [anon_sym__Alignas] = ACTIONS(2359),
    [sym_primitive_type] = ACTIONS(2359),
    [anon_sym_enum] = ACTIONS(2359),
    [anon_sym_class] = ACTIONS(2359),
    [anon_sym_struct] = ACTIONS(2359),
    [anon_sym_union] = ACTIONS(2359),
    [anon_sym_if] = ACTIONS(2359),
    [anon_sym_else] = ACTIONS(2359),
    [anon_sym_switch] = ACTIONS(2359),
    [anon_sym_case] = ACTIONS(2359),
    [anon_sym_default] = ACTIONS(2359),
    [anon_sym_while] = ACTIONS(2359),
    [anon_sym_do] = ACTIONS(2359),
    [anon_sym_for] = ACTIONS(2359),
    [anon_sym_return] = ACTIONS(2359),
    [anon_sym_break] = ACTIONS(2359),
    [anon_sym_continue] = ACTIONS(2359),
    [anon_sym_goto] = ACTIONS(2359),
    [anon_sym___try] = ACTIONS(2359),
    [anon_sym___except] = ACTIONS(2359),
    [anon_sym___finally] = ACTIONS(2359),
    [anon_sym___leave] = ACTIONS(2359),
    [anon_sym_not] = ACTIONS(2359),
    [anon_sym_compl] = ACTIONS(2359),
    [anon_sym_or] = ACTIONS(2359),
    [anon_sym_and] = ACTIONS(2359),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
    [anon_sym_sizeof] = ACTIONS(2359),
    [anon_sym___alignof__] = ACTIONS(2359),
    [anon_sym___alignof] = ACTIONS(2359),
    [anon_sym__alignof] = ACTIONS(2359),
    [anon_sym_alignof] = ACTIONS(2359),
    [anon_sym__Alignof] = ACTIONS(2359),
    [anon_sym_offsetof] = ACTIONS(2359),
    [anon_sym__Generic] = ACTIONS(2359),
    [anon_sym_asm] = ACTIONS(2359),
    [anon_sym___asm__] = ACTIONS(2359),
    [sym_number_literal] = ACTIONS(2357),
    [anon_sym_L_SQUOTE] = ACTIONS(2357),
    [anon_sym_u_SQUOTE] = ACTIONS(2357),
    [anon_sym_U_SQUOTE] = ACTIONS(2357),
    [anon_sym_u8_SQUOTE] = ACTIONS(2357),
    [anon_sym_SQUOTE] = ACTIONS(2357),
    [anon_sym_L_DQUOTE] = ACTIONS(2357),
    [anon_sym_u_DQUOTE] = ACTIONS(2357),
    [anon_sym_U_DQUOTE] = ACTIONS(2357),
    [anon_sym_u8_DQUOTE] = ACTIONS(2357),
    [anon_sym_DQUOTE] = ACTIONS(2357),
    [sym_true] = ACTIONS(2359),
    [sym_false] = ACTIONS(2359),
    [anon_sym_NULL] = ACTIONS(2359),
    [anon_sym_nullptr] = ACTIONS(2359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2359),
    [anon_sym_let] = ACTIONS(2359),
    [anon_sym_This] = ACTIONS(2359),
    [anon_sym_decltype] = ACTIONS(2359),
    [anon_sym_final] = ACTIONS(2359),
    [anon_sym_override] = ACTIONS(2359),
    [sym_virtual] = ACTIONS(2359),
    [anon_sym_explicit] = ACTIONS(2359),
    [anon_sym_typename] = ACTIONS(2359),
    [anon_sym_template] = ACTIONS(2359),
    [anon_sym_operator] = ACTIONS(2359),
    [anon_sym_try] = ACTIONS(2359),
    [anon_sym_delete] = ACTIONS(2359),
    [anon_sym_throw] = ACTIONS(2359),
    [anon_sym_namespace] = ACTIONS(2359),
    [anon_sym_using] = ACTIONS(2359),
    [anon_sym_static_assert] = ACTIONS(2359),
    [anon_sym_concept] = ACTIONS(2359),
    [anon_sym_co_return] = ACTIONS(2359),
    [anon_sym_co_yield] = ACTIONS(2359),
    [anon_sym_catch] = ACTIONS(2359),
    [anon_sym_R_DQUOTE] = ACTIONS(2357),
    [anon_sym_LR_DQUOTE] = ACTIONS(2357),
    [anon_sym_uR_DQUOTE] = ACTIONS(2357),
    [anon_sym_UR_DQUOTE] = ACTIONS(2357),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2357),
    [anon_sym_co_await] = ACTIONS(2359),
    [anon_sym_new] = ACTIONS(2359),
    [anon_sym_requires] = ACTIONS(2359),
    [sym_this] = ACTIONS(2359),
    [anon_sym_discard] = ACTIONS(2359),
    [anon_sym_precise] = ACTIONS(2359),
    [anon_sym_shared] = ACTIONS(2359),
    [anon_sym_groupshared] = ACTIONS(2359),
    [anon_sym_uniform] = ACTIONS(2359),
    [anon_sym_row_major] = ACTIONS(2359),
    [anon_sym_column_major] = ACTIONS(2359),
    [anon_sym_globallycoherent] = ACTIONS(2359),
    [anon_sym_centroid] = ACTIONS(2359),
    [anon_sym_noperspective] = ACTIONS(2359),
    [anon_sym_nointerpolation] = ACTIONS(2359),
    [anon_sym_sample] = ACTIONS(2359),
    [anon_sym_linear] = ACTIONS(2359),
    [anon_sym_snorm] = ACTIONS(2359),
    [anon_sym_unorm] = ACTIONS(2359),
    [anon_sym_point] = ACTIONS(2359),
    [anon_sym_line] = ACTIONS(2359),
    [anon_sym_triangleadj] = ACTIONS(2359),
    [anon_sym_lineadj] = ACTIONS(2359),
    [anon_sym_triangle] = ACTIONS(2359),
    [anon_sym_cbuffer] = ACTIONS(2359),
    [anon_sym_interface] = ACTIONS(2359),
    [anon_sym_extension] = ACTIONS(2359),
    [anon_sym_where] = ACTIONS(2359),
    [anon_sym___exported] = ACTIONS(2359),
    [anon_sym_import] = ACTIONS(2359),
    [anon_sym_get] = ACTIONS(2359),
    [anon_sym_set] = ACTIONS(2359),
  },
  [193] = {
    [sym_template_argument_list] = STATE(212),
    [ts_builtin_sym_end] = ACTIONS(2176),
    [sym_identifier] = ACTIONS(2169),
    [aux_sym_preproc_include_token1] = ACTIONS(2169),
    [aux_sym_preproc_def_token1] = ACTIONS(2169),
    [anon_sym_COMMA] = ACTIONS(2176),
    [anon_sym_RPAREN] = ACTIONS(2176),
    [aux_sym_preproc_if_token1] = ACTIONS(2169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2169),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2169),
    [sym_preproc_directive] = ACTIONS(2169),
    [anon_sym_LPAREN2] = ACTIONS(2176),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2169),
    [anon_sym_PLUS] = ACTIONS(2169),
    [anon_sym_STAR] = ACTIONS(2176),
    [anon_sym_PIPE_PIPE] = ACTIONS(2176),
    [anon_sym_AMP_AMP] = ACTIONS(2176),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(2351),
    [anon_sym_COLON] = ACTIONS(2169),
    [anon_sym_SEMI] = ACTIONS(2176),
    [anon_sym___extension__] = ACTIONS(2169),
    [anon_sym_typedef] = ACTIONS(2169),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_out] = ACTIONS(2169),
    [anon_sym_inout] = ACTIONS(2169),
    [anon_sym_extern] = ACTIONS(2169),
    [anon_sym___attribute__] = ACTIONS(2169),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2176),
    [anon_sym___declspec] = ACTIONS(2169),
    [anon_sym___based] = ACTIONS(2169),
    [anon_sym___cdecl] = ACTIONS(2169),
    [anon_sym___clrcall] = ACTIONS(2169),
    [anon_sym___stdcall] = ACTIONS(2169),
    [anon_sym___fastcall] = ACTIONS(2169),
    [anon_sym___thiscall] = ACTIONS(2169),
    [anon_sym___vectorcall] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2176),
    [anon_sym_signed] = ACTIONS(2169),
    [anon_sym_unsigned] = ACTIONS(2169),
    [anon_sym_long] = ACTIONS(2169),
    [anon_sym_short] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(2169),
    [anon_sym_static] = ACTIONS(2169),
    [anon_sym_EQ] = ACTIONS(2176),
    [anon_sym_register] = ACTIONS(2169),
    [anon_sym_inline] = ACTIONS(2169),
    [anon_sym___inline] = ACTIONS(2169),
    [anon_sym___inline__] = ACTIONS(2169),
    [anon_sym___forceinline] = ACTIONS(2169),
    [anon_sym_thread_local] = ACTIONS(2169),
    [anon_sym___thread] = ACTIONS(2169),
    [anon_sym_const] = ACTIONS(2169),
    [anon_sym_constexpr] = ACTIONS(2169),
    [anon_sym_volatile] = ACTIONS(2169),
    [anon_sym_restrict] = ACTIONS(2169),
    [anon_sym___restrict__] = ACTIONS(2169),
    [anon_sym__Atomic] = ACTIONS(2169),
    [anon_sym__Noreturn] = ACTIONS(2169),
    [anon_sym_noreturn] = ACTIONS(2169),
    [anon_sym_mutable] = ACTIONS(2169),
    [anon_sym_constinit] = ACTIONS(2169),
    [anon_sym_consteval] = ACTIONS(2169),
    [anon_sym_alignas] = ACTIONS(2169),
    [anon_sym__Alignas] = ACTIONS(2169),
    [sym_primitive_type] = ACTIONS(2169),
    [anon_sym_enum] = ACTIONS(2169),
    [anon_sym_class] = ACTIONS(2169),
    [anon_sym_struct] = ACTIONS(2169),
    [anon_sym_union] = ACTIONS(2169),
    [anon_sym_if] = ACTIONS(2169),
    [anon_sym_else] = ACTIONS(2169),
    [anon_sym_switch] = ACTIONS(2169),
    [anon_sym_case] = ACTIONS(2169),
    [anon_sym_default] = ACTIONS(2169),
    [anon_sym_while] = ACTIONS(2169),
    [anon_sym_do] = ACTIONS(2169),
    [anon_sym_for] = ACTIONS(2169),
    [anon_sym_return] = ACTIONS(2169),
    [anon_sym_break] = ACTIONS(2169),
    [anon_sym_continue] = ACTIONS(2169),
    [anon_sym_goto] = ACTIONS(2169),
    [anon_sym___try] = ACTIONS(2169),
    [anon_sym___leave] = ACTIONS(2169),
    [anon_sym_not] = ACTIONS(2169),
    [anon_sym_compl] = ACTIONS(2169),
    [anon_sym_or] = ACTIONS(2169),
    [anon_sym_and] = ACTIONS(2169),
    [anon_sym_DASH_DASH] = ACTIONS(2176),
    [anon_sym_PLUS_PLUS] = ACTIONS(2176),
    [anon_sym_sizeof] = ACTIONS(2169),
    [anon_sym___alignof__] = ACTIONS(2169),
    [anon_sym___alignof] = ACTIONS(2169),
    [anon_sym__alignof] = ACTIONS(2169),
    [anon_sym_alignof] = ACTIONS(2169),
    [anon_sym__Alignof] = ACTIONS(2169),
    [anon_sym_offsetof] = ACTIONS(2169),
    [anon_sym__Generic] = ACTIONS(2169),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [anon_sym_DOT] = ACTIONS(2169),
    [sym_number_literal] = ACTIONS(2176),
    [anon_sym_L_SQUOTE] = ACTIONS(2176),
    [anon_sym_u_SQUOTE] = ACTIONS(2176),
    [anon_sym_U_SQUOTE] = ACTIONS(2176),
    [anon_sym_u8_SQUOTE] = ACTIONS(2176),
    [anon_sym_SQUOTE] = ACTIONS(2176),
    [anon_sym_L_DQUOTE] = ACTIONS(2176),
    [anon_sym_u_DQUOTE] = ACTIONS(2176),
    [anon_sym_U_DQUOTE] = ACTIONS(2176),
    [anon_sym_u8_DQUOTE] = ACTIONS(2176),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [sym_true] = ACTIONS(2169),
    [sym_false] = ACTIONS(2169),
    [anon_sym_NULL] = ACTIONS(2169),
    [anon_sym_nullptr] = ACTIONS(2169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2169),
    [anon_sym_let] = ACTIONS(2169),
    [anon_sym_This] = ACTIONS(2169),
    [anon_sym_decltype] = ACTIONS(2169),
    [anon_sym_final] = ACTIONS(2169),
    [anon_sym_override] = ACTIONS(2169),
    [sym_virtual] = ACTIONS(2169),
    [anon_sym_explicit] = ACTIONS(2169),
    [anon_sym_typename] = ACTIONS(2169),
    [anon_sym_template] = ACTIONS(2169),
    [anon_sym_GT2] = ACTIONS(2176),
    [anon_sym_operator] = ACTIONS(2169),
    [anon_sym_try] = ACTIONS(2169),
    [anon_sym_delete] = ACTIONS(2169),
    [anon_sym_throw] = ACTIONS(2169),
    [anon_sym_namespace] = ACTIONS(2169),
    [anon_sym_using] = ACTIONS(2169),
    [anon_sym_static_assert] = ACTIONS(2169),
    [anon_sym_concept] = ACTIONS(2169),
    [anon_sym_co_return] = ACTIONS(2169),
    [anon_sym_co_yield] = ACTIONS(2169),
    [anon_sym_R_DQUOTE] = ACTIONS(2176),
    [anon_sym_LR_DQUOTE] = ACTIONS(2176),
    [anon_sym_uR_DQUOTE] = ACTIONS(2176),
    [anon_sym_UR_DQUOTE] = ACTIONS(2176),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2176),
    [anon_sym_co_await] = ACTIONS(2169),
    [anon_sym_new] = ACTIONS(2169),
    [anon_sym_requires] = ACTIONS(2169),
    [sym_this] = ACTIONS(2169),
    [anon_sym_discard] = ACTIONS(2169),
    [anon_sym_precise] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_groupshared] = ACTIONS(2169),
    [anon_sym_uniform] = ACTIONS(2169),
    [anon_sym_row_major] = ACTIONS(2169),
    [anon_sym_column_major] = ACTIONS(2169),
    [anon_sym_globallycoherent] = ACTIONS(2169),
    [anon_sym_centroid] = ACTIONS(2169),
    [anon_sym_noperspective] = ACTIONS(2169),
    [anon_sym_nointerpolation] = ACTIONS(2169),
    [anon_sym_sample] = ACTIONS(2169),
    [anon_sym_linear] = ACTIONS(2169),
    [anon_sym_snorm] = ACTIONS(2169),
    [anon_sym_unorm] = ACTIONS(2169),
    [anon_sym_point] = ACTIONS(2169),
    [anon_sym_line] = ACTIONS(2169),
    [anon_sym_triangleadj] = ACTIONS(2169),
    [anon_sym_lineadj] = ACTIONS(2169),
    [anon_sym_triangle] = ACTIONS(2169),
    [anon_sym_cbuffer] = ACTIONS(2169),
    [anon_sym_interface] = ACTIONS(2169),
    [anon_sym_extension] = ACTIONS(2169),
    [anon_sym_where] = ACTIONS(2169),
    [anon_sym___exported] = ACTIONS(2169),
    [anon_sym_import] = ACTIONS(2169),
  },
  [194] = {
    [ts_builtin_sym_end] = ACTIONS(2361),
    [sym_identifier] = ACTIONS(2363),
    [aux_sym_preproc_include_token1] = ACTIONS(2363),
    [aux_sym_preproc_def_token1] = ACTIONS(2363),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2361),
    [anon_sym_COMMA] = ACTIONS(2361),
    [anon_sym_RPAREN] = ACTIONS(2361),
    [aux_sym_preproc_if_token1] = ACTIONS(2363),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2363),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2363),
    [sym_preproc_directive] = ACTIONS(2363),
    [anon_sym_LPAREN2] = ACTIONS(2361),
    [anon_sym_BANG] = ACTIONS(2361),
    [anon_sym_TILDE] = ACTIONS(2361),
    [anon_sym_DASH] = ACTIONS(2363),
    [anon_sym_PLUS] = ACTIONS(2363),
    [anon_sym_STAR] = ACTIONS(2361),
    [anon_sym_PIPE_PIPE] = ACTIONS(2361),
    [anon_sym_AMP_AMP] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(2363),
    [anon_sym_COLON] = ACTIONS(2363),
    [anon_sym_SEMI] = ACTIONS(2361),
    [anon_sym___extension__] = ACTIONS(2363),
    [anon_sym_typedef] = ACTIONS(2363),
    [anon_sym_in] = ACTIONS(2363),
    [anon_sym_out] = ACTIONS(2363),
    [anon_sym_inout] = ACTIONS(2363),
    [anon_sym_extern] = ACTIONS(2363),
    [anon_sym___attribute__] = ACTIONS(2363),
    [anon_sym_COLON_COLON] = ACTIONS(2361),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2361),
    [anon_sym___declspec] = ACTIONS(2363),
    [anon_sym___based] = ACTIONS(2363),
    [anon_sym___cdecl] = ACTIONS(2363),
    [anon_sym___clrcall] = ACTIONS(2363),
    [anon_sym___stdcall] = ACTIONS(2363),
    [anon_sym___fastcall] = ACTIONS(2363),
    [anon_sym___thiscall] = ACTIONS(2363),
    [anon_sym___vectorcall] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_signed] = ACTIONS(2363),
    [anon_sym_unsigned] = ACTIONS(2363),
    [anon_sym_long] = ACTIONS(2363),
    [anon_sym_short] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(2363),
    [anon_sym_static] = ACTIONS(2363),
    [anon_sym_EQ] = ACTIONS(2361),
    [anon_sym_register] = ACTIONS(2363),
    [anon_sym_inline] = ACTIONS(2363),
    [anon_sym___inline] = ACTIONS(2363),
    [anon_sym___inline__] = ACTIONS(2363),
    [anon_sym___forceinline] = ACTIONS(2363),
    [anon_sym_thread_local] = ACTIONS(2363),
    [anon_sym___thread] = ACTIONS(2363),
    [anon_sym_const] = ACTIONS(2363),
    [anon_sym_constexpr] = ACTIONS(2363),
    [anon_sym_volatile] = ACTIONS(2363),
    [anon_sym_restrict] = ACTIONS(2363),
    [anon_sym___restrict__] = ACTIONS(2363),
    [anon_sym__Atomic] = ACTIONS(2363),
    [anon_sym__Noreturn] = ACTIONS(2363),
    [anon_sym_noreturn] = ACTIONS(2363),
    [anon_sym_mutable] = ACTIONS(2363),
    [anon_sym_constinit] = ACTIONS(2363),
    [anon_sym_consteval] = ACTIONS(2363),
    [anon_sym_alignas] = ACTIONS(2363),
    [anon_sym__Alignas] = ACTIONS(2363),
    [sym_primitive_type] = ACTIONS(2363),
    [anon_sym_enum] = ACTIONS(2363),
    [anon_sym_class] = ACTIONS(2363),
    [anon_sym_struct] = ACTIONS(2363),
    [anon_sym_union] = ACTIONS(2363),
    [anon_sym_if] = ACTIONS(2363),
    [anon_sym_else] = ACTIONS(2363),
    [anon_sym_switch] = ACTIONS(2363),
    [anon_sym_case] = ACTIONS(2363),
    [anon_sym_default] = ACTIONS(2363),
    [anon_sym_while] = ACTIONS(2363),
    [anon_sym_do] = ACTIONS(2363),
    [anon_sym_for] = ACTIONS(2363),
    [anon_sym_return] = ACTIONS(2363),
    [anon_sym_break] = ACTIONS(2363),
    [anon_sym_continue] = ACTIONS(2363),
    [anon_sym_goto] = ACTIONS(2363),
    [anon_sym___try] = ACTIONS(2363),
    [anon_sym___leave] = ACTIONS(2363),
    [anon_sym_not] = ACTIONS(2363),
    [anon_sym_compl] = ACTIONS(2363),
    [anon_sym_or] = ACTIONS(2363),
    [anon_sym_and] = ACTIONS(2363),
    [anon_sym_DASH_DASH] = ACTIONS(2361),
    [anon_sym_PLUS_PLUS] = ACTIONS(2361),
    [anon_sym_sizeof] = ACTIONS(2363),
    [anon_sym___alignof__] = ACTIONS(2363),
    [anon_sym___alignof] = ACTIONS(2363),
    [anon_sym__alignof] = ACTIONS(2363),
    [anon_sym_alignof] = ACTIONS(2363),
    [anon_sym__Alignof] = ACTIONS(2363),
    [anon_sym_offsetof] = ACTIONS(2363),
    [anon_sym__Generic] = ACTIONS(2363),
    [anon_sym_asm] = ACTIONS(2363),
    [anon_sym___asm__] = ACTIONS(2363),
    [anon_sym_DOT] = ACTIONS(2363),
    [sym_number_literal] = ACTIONS(2361),
    [anon_sym_L_SQUOTE] = ACTIONS(2361),
    [anon_sym_u_SQUOTE] = ACTIONS(2361),
    [anon_sym_U_SQUOTE] = ACTIONS(2361),
    [anon_sym_u8_SQUOTE] = ACTIONS(2361),
    [anon_sym_SQUOTE] = ACTIONS(2361),
    [anon_sym_L_DQUOTE] = ACTIONS(2361),
    [anon_sym_u_DQUOTE] = ACTIONS(2361),
    [anon_sym_U_DQUOTE] = ACTIONS(2361),
    [anon_sym_u8_DQUOTE] = ACTIONS(2361),
    [anon_sym_DQUOTE] = ACTIONS(2361),
    [sym_true] = ACTIONS(2363),
    [sym_false] = ACTIONS(2363),
    [anon_sym_NULL] = ACTIONS(2363),
    [anon_sym_nullptr] = ACTIONS(2363),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2363),
    [anon_sym_let] = ACTIONS(2363),
    [anon_sym_This] = ACTIONS(2363),
    [anon_sym_decltype] = ACTIONS(2363),
    [anon_sym_final] = ACTIONS(2363),
    [anon_sym_override] = ACTIONS(2363),
    [sym_virtual] = ACTIONS(2363),
    [anon_sym_explicit] = ACTIONS(2363),
    [anon_sym_typename] = ACTIONS(2363),
    [anon_sym_template] = ACTIONS(2363),
    [anon_sym_GT2] = ACTIONS(2361),
    [anon_sym_operator] = ACTIONS(2363),
    [anon_sym_try] = ACTIONS(2363),
    [anon_sym_delete] = ACTIONS(2363),
    [anon_sym_throw] = ACTIONS(2363),
    [anon_sym_namespace] = ACTIONS(2363),
    [anon_sym_using] = ACTIONS(2363),
    [anon_sym_static_assert] = ACTIONS(2363),
    [anon_sym_concept] = ACTIONS(2363),
    [anon_sym_co_return] = ACTIONS(2363),
    [anon_sym_co_yield] = ACTIONS(2363),
    [anon_sym_R_DQUOTE] = ACTIONS(2361),
    [anon_sym_LR_DQUOTE] = ACTIONS(2361),
    [anon_sym_uR_DQUOTE] = ACTIONS(2361),
    [anon_sym_UR_DQUOTE] = ACTIONS(2361),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2361),
    [anon_sym_co_await] = ACTIONS(2363),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_requires] = ACTIONS(2363),
    [sym_this] = ACTIONS(2363),
    [anon_sym_discard] = ACTIONS(2363),
    [anon_sym_precise] = ACTIONS(2363),
    [anon_sym_shared] = ACTIONS(2363),
    [anon_sym_groupshared] = ACTIONS(2363),
    [anon_sym_uniform] = ACTIONS(2363),
    [anon_sym_row_major] = ACTIONS(2363),
    [anon_sym_column_major] = ACTIONS(2363),
    [anon_sym_globallycoherent] = ACTIONS(2363),
    [anon_sym_centroid] = ACTIONS(2363),
    [anon_sym_noperspective] = ACTIONS(2363),
    [anon_sym_nointerpolation] = ACTIONS(2363),
    [anon_sym_sample] = ACTIONS(2363),
    [anon_sym_linear] = ACTIONS(2363),
    [anon_sym_snorm] = ACTIONS(2363),
    [anon_sym_unorm] = ACTIONS(2363),
    [anon_sym_point] = ACTIONS(2363),
    [anon_sym_line] = ACTIONS(2363),
    [anon_sym_triangleadj] = ACTIONS(2363),
    [anon_sym_lineadj] = ACTIONS(2363),
    [anon_sym_triangle] = ACTIONS(2363),
    [anon_sym_cbuffer] = ACTIONS(2363),
    [anon_sym_interface] = ACTIONS(2363),
    [anon_sym_extension] = ACTIONS(2363),
    [anon_sym_where] = ACTIONS(2363),
    [anon_sym___exported] = ACTIONS(2363),
    [anon_sym_import] = ACTIONS(2363),
  },
  [195] = {
    [ts_builtin_sym_end] = ACTIONS(2365),
    [sym_identifier] = ACTIONS(2367),
    [aux_sym_preproc_include_token1] = ACTIONS(2367),
    [aux_sym_preproc_def_token1] = ACTIONS(2367),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(2365),
    [anon_sym_RPAREN] = ACTIONS(2365),
    [aux_sym_preproc_if_token1] = ACTIONS(2367),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2367),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2367),
    [sym_preproc_directive] = ACTIONS(2367),
    [anon_sym_LPAREN2] = ACTIONS(2365),
    [anon_sym_BANG] = ACTIONS(2365),
    [anon_sym_TILDE] = ACTIONS(2365),
    [anon_sym_DASH] = ACTIONS(2367),
    [anon_sym_PLUS] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2365),
    [anon_sym_PIPE_PIPE] = ACTIONS(2365),
    [anon_sym_AMP_AMP] = ACTIONS(2365),
    [anon_sym_AMP] = ACTIONS(2367),
    [anon_sym_COLON] = ACTIONS(2367),
    [anon_sym_SEMI] = ACTIONS(2365),
    [anon_sym___extension__] = ACTIONS(2367),
    [anon_sym_typedef] = ACTIONS(2367),
    [anon_sym_in] = ACTIONS(2367),
    [anon_sym_out] = ACTIONS(2367),
    [anon_sym_inout] = ACTIONS(2367),
    [anon_sym_extern] = ACTIONS(2367),
    [anon_sym___attribute__] = ACTIONS(2367),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2365),
    [anon_sym___declspec] = ACTIONS(2367),
    [anon_sym___based] = ACTIONS(2367),
    [anon_sym___cdecl] = ACTIONS(2367),
    [anon_sym___clrcall] = ACTIONS(2367),
    [anon_sym___stdcall] = ACTIONS(2367),
    [anon_sym___fastcall] = ACTIONS(2367),
    [anon_sym___thiscall] = ACTIONS(2367),
    [anon_sym___vectorcall] = ACTIONS(2367),
    [anon_sym_LBRACE] = ACTIONS(2365),
    [anon_sym_signed] = ACTIONS(2367),
    [anon_sym_unsigned] = ACTIONS(2367),
    [anon_sym_long] = ACTIONS(2367),
    [anon_sym_short] = ACTIONS(2367),
    [anon_sym_LBRACK] = ACTIONS(2367),
    [anon_sym_static] = ACTIONS(2367),
    [anon_sym_EQ] = ACTIONS(2365),
    [anon_sym_register] = ACTIONS(2367),
    [anon_sym_inline] = ACTIONS(2367),
    [anon_sym___inline] = ACTIONS(2367),
    [anon_sym___inline__] = ACTIONS(2367),
    [anon_sym___forceinline] = ACTIONS(2367),
    [anon_sym_thread_local] = ACTIONS(2367),
    [anon_sym___thread] = ACTIONS(2367),
    [anon_sym_const] = ACTIONS(2367),
    [anon_sym_constexpr] = ACTIONS(2367),
    [anon_sym_volatile] = ACTIONS(2367),
    [anon_sym_restrict] = ACTIONS(2367),
    [anon_sym___restrict__] = ACTIONS(2367),
    [anon_sym__Atomic] = ACTIONS(2367),
    [anon_sym__Noreturn] = ACTIONS(2367),
    [anon_sym_noreturn] = ACTIONS(2367),
    [anon_sym_mutable] = ACTIONS(2367),
    [anon_sym_constinit] = ACTIONS(2367),
    [anon_sym_consteval] = ACTIONS(2367),
    [anon_sym_alignas] = ACTIONS(2367),
    [anon_sym__Alignas] = ACTIONS(2367),
    [sym_primitive_type] = ACTIONS(2367),
    [anon_sym_enum] = ACTIONS(2367),
    [anon_sym_class] = ACTIONS(2367),
    [anon_sym_struct] = ACTIONS(2367),
    [anon_sym_union] = ACTIONS(2367),
    [anon_sym_if] = ACTIONS(2367),
    [anon_sym_else] = ACTIONS(2367),
    [anon_sym_switch] = ACTIONS(2367),
    [anon_sym_case] = ACTIONS(2367),
    [anon_sym_default] = ACTIONS(2367),
    [anon_sym_while] = ACTIONS(2367),
    [anon_sym_do] = ACTIONS(2367),
    [anon_sym_for] = ACTIONS(2367),
    [anon_sym_return] = ACTIONS(2367),
    [anon_sym_break] = ACTIONS(2367),
    [anon_sym_continue] = ACTIONS(2367),
    [anon_sym_goto] = ACTIONS(2367),
    [anon_sym___try] = ACTIONS(2367),
    [anon_sym___leave] = ACTIONS(2367),
    [anon_sym_not] = ACTIONS(2367),
    [anon_sym_compl] = ACTIONS(2367),
    [anon_sym_or] = ACTIONS(2367),
    [anon_sym_and] = ACTIONS(2367),
    [anon_sym_DASH_DASH] = ACTIONS(2365),
    [anon_sym_PLUS_PLUS] = ACTIONS(2365),
    [anon_sym_sizeof] = ACTIONS(2367),
    [anon_sym___alignof__] = ACTIONS(2367),
    [anon_sym___alignof] = ACTIONS(2367),
    [anon_sym__alignof] = ACTIONS(2367),
    [anon_sym_alignof] = ACTIONS(2367),
    [anon_sym__Alignof] = ACTIONS(2367),
    [anon_sym_offsetof] = ACTIONS(2367),
    [anon_sym__Generic] = ACTIONS(2367),
    [anon_sym_asm] = ACTIONS(2367),
    [anon_sym___asm__] = ACTIONS(2367),
    [anon_sym_DOT] = ACTIONS(2367),
    [sym_number_literal] = ACTIONS(2365),
    [anon_sym_L_SQUOTE] = ACTIONS(2365),
    [anon_sym_u_SQUOTE] = ACTIONS(2365),
    [anon_sym_U_SQUOTE] = ACTIONS(2365),
    [anon_sym_u8_SQUOTE] = ACTIONS(2365),
    [anon_sym_SQUOTE] = ACTIONS(2365),
    [anon_sym_L_DQUOTE] = ACTIONS(2365),
    [anon_sym_u_DQUOTE] = ACTIONS(2365),
    [anon_sym_U_DQUOTE] = ACTIONS(2365),
    [anon_sym_u8_DQUOTE] = ACTIONS(2365),
    [anon_sym_DQUOTE] = ACTIONS(2365),
    [sym_true] = ACTIONS(2367),
    [sym_false] = ACTIONS(2367),
    [anon_sym_NULL] = ACTIONS(2367),
    [anon_sym_nullptr] = ACTIONS(2367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2367),
    [anon_sym_let] = ACTIONS(2367),
    [anon_sym_This] = ACTIONS(2367),
    [anon_sym_decltype] = ACTIONS(2367),
    [anon_sym_final] = ACTIONS(2367),
    [anon_sym_override] = ACTIONS(2367),
    [sym_virtual] = ACTIONS(2367),
    [anon_sym_explicit] = ACTIONS(2367),
    [anon_sym_typename] = ACTIONS(2367),
    [anon_sym_template] = ACTIONS(2367),
    [anon_sym_GT2] = ACTIONS(2365),
    [anon_sym_operator] = ACTIONS(2367),
    [anon_sym_try] = ACTIONS(2367),
    [anon_sym_delete] = ACTIONS(2367),
    [anon_sym_throw] = ACTIONS(2367),
    [anon_sym_namespace] = ACTIONS(2367),
    [anon_sym_using] = ACTIONS(2367),
    [anon_sym_static_assert] = ACTIONS(2367),
    [anon_sym_concept] = ACTIONS(2367),
    [anon_sym_co_return] = ACTIONS(2367),
    [anon_sym_co_yield] = ACTIONS(2367),
    [anon_sym_R_DQUOTE] = ACTIONS(2365),
    [anon_sym_LR_DQUOTE] = ACTIONS(2365),
    [anon_sym_uR_DQUOTE] = ACTIONS(2365),
    [anon_sym_UR_DQUOTE] = ACTIONS(2365),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2365),
    [anon_sym_co_await] = ACTIONS(2367),
    [anon_sym_new] = ACTIONS(2367),
    [anon_sym_requires] = ACTIONS(2367),
    [sym_this] = ACTIONS(2367),
    [anon_sym_discard] = ACTIONS(2367),
    [anon_sym_precise] = ACTIONS(2367),
    [anon_sym_shared] = ACTIONS(2367),
    [anon_sym_groupshared] = ACTIONS(2367),
    [anon_sym_uniform] = ACTIONS(2367),
    [anon_sym_row_major] = ACTIONS(2367),
    [anon_sym_column_major] = ACTIONS(2367),
    [anon_sym_globallycoherent] = ACTIONS(2367),
    [anon_sym_centroid] = ACTIONS(2367),
    [anon_sym_noperspective] = ACTIONS(2367),
    [anon_sym_nointerpolation] = ACTIONS(2367),
    [anon_sym_sample] = ACTIONS(2367),
    [anon_sym_linear] = ACTIONS(2367),
    [anon_sym_snorm] = ACTIONS(2367),
    [anon_sym_unorm] = ACTIONS(2367),
    [anon_sym_point] = ACTIONS(2367),
    [anon_sym_line] = ACTIONS(2367),
    [anon_sym_triangleadj] = ACTIONS(2367),
    [anon_sym_lineadj] = ACTIONS(2367),
    [anon_sym_triangle] = ACTIONS(2367),
    [anon_sym_cbuffer] = ACTIONS(2367),
    [anon_sym_interface] = ACTIONS(2367),
    [anon_sym_extension] = ACTIONS(2367),
    [anon_sym_where] = ACTIONS(2367),
    [anon_sym___exported] = ACTIONS(2367),
    [anon_sym_import] = ACTIONS(2367),
  },
  [196] = {
    [ts_builtin_sym_end] = ACTIONS(2371),
    [sym_identifier] = ACTIONS(2373),
    [aux_sym_preproc_include_token1] = ACTIONS(2373),
    [aux_sym_preproc_def_token1] = ACTIONS(2373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2371),
    [anon_sym_COMMA] = ACTIONS(2371),
    [anon_sym_RPAREN] = ACTIONS(2371),
    [aux_sym_preproc_if_token1] = ACTIONS(2373),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2373),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2373),
    [sym_preproc_directive] = ACTIONS(2373),
    [anon_sym_LPAREN2] = ACTIONS(2371),
    [anon_sym_BANG] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym___extension__] = ACTIONS(2373),
    [anon_sym_typedef] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_out] = ACTIONS(2373),
    [anon_sym_inout] = ACTIONS(2373),
    [anon_sym_extern] = ACTIONS(2373),
    [anon_sym___attribute__] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2371),
    [anon_sym___declspec] = ACTIONS(2373),
    [anon_sym___based] = ACTIONS(2373),
    [anon_sym___cdecl] = ACTIONS(2373),
    [anon_sym___clrcall] = ACTIONS(2373),
    [anon_sym___stdcall] = ACTIONS(2373),
    [anon_sym___fastcall] = ACTIONS(2373),
    [anon_sym___thiscall] = ACTIONS(2373),
    [anon_sym___vectorcall] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_signed] = ACTIONS(2373),
    [anon_sym_unsigned] = ACTIONS(2373),
    [anon_sym_long] = ACTIONS(2373),
    [anon_sym_short] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2373),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_EQ] = ACTIONS(2371),
    [anon_sym_register] = ACTIONS(2373),
    [anon_sym_inline] = ACTIONS(2373),
    [anon_sym___inline] = ACTIONS(2373),
    [anon_sym___inline__] = ACTIONS(2373),
    [anon_sym___forceinline] = ACTIONS(2373),
    [anon_sym_thread_local] = ACTIONS(2373),
    [anon_sym___thread] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym___restrict__] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym__Noreturn] = ACTIONS(2373),
    [anon_sym_noreturn] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_constinit] = ACTIONS(2373),
    [anon_sym_consteval] = ACTIONS(2373),
    [anon_sym_alignas] = ACTIONS(2373),
    [anon_sym__Alignas] = ACTIONS(2373),
    [sym_primitive_type] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_class] = ACTIONS(2373),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_else] = ACTIONS(2373),
    [anon_sym_switch] = ACTIONS(2373),
    [anon_sym_case] = ACTIONS(2373),
    [anon_sym_default] = ACTIONS(2373),
    [anon_sym_while] = ACTIONS(2373),
    [anon_sym_do] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2373),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2373),
    [anon_sym_goto] = ACTIONS(2373),
    [anon_sym___try] = ACTIONS(2373),
    [anon_sym___leave] = ACTIONS(2373),
    [anon_sym_not] = ACTIONS(2373),
    [anon_sym_compl] = ACTIONS(2373),
    [anon_sym_or] = ACTIONS(2373),
    [anon_sym_and] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_sizeof] = ACTIONS(2373),
    [anon_sym___alignof__] = ACTIONS(2373),
    [anon_sym___alignof] = ACTIONS(2373),
    [anon_sym__alignof] = ACTIONS(2373),
    [anon_sym_alignof] = ACTIONS(2373),
    [anon_sym__Alignof] = ACTIONS(2373),
    [anon_sym_offsetof] = ACTIONS(2373),
    [anon_sym__Generic] = ACTIONS(2373),
    [anon_sym_asm] = ACTIONS(2373),
    [anon_sym___asm__] = ACTIONS(2373),
    [anon_sym_DOT] = ACTIONS(2373),
    [sym_number_literal] = ACTIONS(2371),
    [anon_sym_L_SQUOTE] = ACTIONS(2371),
    [anon_sym_u_SQUOTE] = ACTIONS(2371),
    [anon_sym_U_SQUOTE] = ACTIONS(2371),
    [anon_sym_u8_SQUOTE] = ACTIONS(2371),
    [anon_sym_SQUOTE] = ACTIONS(2371),
    [anon_sym_L_DQUOTE] = ACTIONS(2371),
    [anon_sym_u_DQUOTE] = ACTIONS(2371),
    [anon_sym_U_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8_DQUOTE] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [anon_sym_NULL] = ACTIONS(2373),
    [anon_sym_nullptr] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_This] = ACTIONS(2373),
    [anon_sym_decltype] = ACTIONS(2373),
    [anon_sym_final] = ACTIONS(2373),
    [anon_sym_override] = ACTIONS(2373),
    [sym_virtual] = ACTIONS(2373),
    [anon_sym_explicit] = ACTIONS(2373),
    [anon_sym_typename] = ACTIONS(2373),
    [anon_sym_template] = ACTIONS(2373),
    [anon_sym_GT2] = ACTIONS(2371),
    [anon_sym_operator] = ACTIONS(2373),
    [anon_sym_try] = ACTIONS(2373),
    [anon_sym_delete] = ACTIONS(2373),
    [anon_sym_throw] = ACTIONS(2373),
    [anon_sym_namespace] = ACTIONS(2373),
    [anon_sym_using] = ACTIONS(2373),
    [anon_sym_static_assert] = ACTIONS(2373),
    [anon_sym_concept] = ACTIONS(2373),
    [anon_sym_co_return] = ACTIONS(2373),
    [anon_sym_co_yield] = ACTIONS(2373),
    [anon_sym_R_DQUOTE] = ACTIONS(2371),
    [anon_sym_LR_DQUOTE] = ACTIONS(2371),
    [anon_sym_uR_DQUOTE] = ACTIONS(2371),
    [anon_sym_UR_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2371),
    [anon_sym_co_await] = ACTIONS(2373),
    [anon_sym_new] = ACTIONS(2373),
    [anon_sym_requires] = ACTIONS(2373),
    [sym_this] = ACTIONS(2373),
    [anon_sym_discard] = ACTIONS(2373),
    [anon_sym_precise] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_groupshared] = ACTIONS(2373),
    [anon_sym_uniform] = ACTIONS(2373),
    [anon_sym_row_major] = ACTIONS(2373),
    [anon_sym_column_major] = ACTIONS(2373),
    [anon_sym_globallycoherent] = ACTIONS(2373),
    [anon_sym_centroid] = ACTIONS(2373),
    [anon_sym_noperspective] = ACTIONS(2373),
    [anon_sym_nointerpolation] = ACTIONS(2373),
    [anon_sym_sample] = ACTIONS(2373),
    [anon_sym_linear] = ACTIONS(2373),
    [anon_sym_snorm] = ACTIONS(2373),
    [anon_sym_unorm] = ACTIONS(2373),
    [anon_sym_point] = ACTIONS(2373),
    [anon_sym_line] = ACTIONS(2373),
    [anon_sym_triangleadj] = ACTIONS(2373),
    [anon_sym_lineadj] = ACTIONS(2373),
    [anon_sym_triangle] = ACTIONS(2373),
    [anon_sym_cbuffer] = ACTIONS(2373),
    [anon_sym_interface] = ACTIONS(2373),
    [anon_sym_extension] = ACTIONS(2373),
    [anon_sym_where] = ACTIONS(2373),
    [anon_sym___exported] = ACTIONS(2373),
    [anon_sym_import] = ACTIONS(2373),
  },
  [197] = {
    [ts_builtin_sym_end] = ACTIONS(2371),
    [sym_identifier] = ACTIONS(2373),
    [aux_sym_preproc_include_token1] = ACTIONS(2373),
    [aux_sym_preproc_def_token1] = ACTIONS(2373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2371),
    [anon_sym_COMMA] = ACTIONS(2371),
    [anon_sym_RPAREN] = ACTIONS(2371),
    [aux_sym_preproc_if_token1] = ACTIONS(2373),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2373),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2373),
    [sym_preproc_directive] = ACTIONS(2373),
    [anon_sym_LPAREN2] = ACTIONS(2371),
    [anon_sym_BANG] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym___extension__] = ACTIONS(2373),
    [anon_sym_typedef] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_out] = ACTIONS(2373),
    [anon_sym_inout] = ACTIONS(2373),
    [anon_sym_extern] = ACTIONS(2373),
    [anon_sym___attribute__] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2371),
    [anon_sym___declspec] = ACTIONS(2373),
    [anon_sym___based] = ACTIONS(2373),
    [anon_sym___cdecl] = ACTIONS(2373),
    [anon_sym___clrcall] = ACTIONS(2373),
    [anon_sym___stdcall] = ACTIONS(2373),
    [anon_sym___fastcall] = ACTIONS(2373),
    [anon_sym___thiscall] = ACTIONS(2373),
    [anon_sym___vectorcall] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_signed] = ACTIONS(2373),
    [anon_sym_unsigned] = ACTIONS(2373),
    [anon_sym_long] = ACTIONS(2373),
    [anon_sym_short] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2373),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_EQ] = ACTIONS(2371),
    [anon_sym_register] = ACTIONS(2373),
    [anon_sym_inline] = ACTIONS(2373),
    [anon_sym___inline] = ACTIONS(2373),
    [anon_sym___inline__] = ACTIONS(2373),
    [anon_sym___forceinline] = ACTIONS(2373),
    [anon_sym_thread_local] = ACTIONS(2373),
    [anon_sym___thread] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym___restrict__] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym__Noreturn] = ACTIONS(2373),
    [anon_sym_noreturn] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_constinit] = ACTIONS(2373),
    [anon_sym_consteval] = ACTIONS(2373),
    [anon_sym_alignas] = ACTIONS(2373),
    [anon_sym__Alignas] = ACTIONS(2373),
    [sym_primitive_type] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_class] = ACTIONS(2373),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_else] = ACTIONS(2373),
    [anon_sym_switch] = ACTIONS(2373),
    [anon_sym_case] = ACTIONS(2373),
    [anon_sym_default] = ACTIONS(2373),
    [anon_sym_while] = ACTIONS(2373),
    [anon_sym_do] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2373),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2373),
    [anon_sym_goto] = ACTIONS(2373),
    [anon_sym___try] = ACTIONS(2373),
    [anon_sym___leave] = ACTIONS(2373),
    [anon_sym_not] = ACTIONS(2373),
    [anon_sym_compl] = ACTIONS(2373),
    [anon_sym_or] = ACTIONS(2373),
    [anon_sym_and] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_sizeof] = ACTIONS(2373),
    [anon_sym___alignof__] = ACTIONS(2373),
    [anon_sym___alignof] = ACTIONS(2373),
    [anon_sym__alignof] = ACTIONS(2373),
    [anon_sym_alignof] = ACTIONS(2373),
    [anon_sym__Alignof] = ACTIONS(2373),
    [anon_sym_offsetof] = ACTIONS(2373),
    [anon_sym__Generic] = ACTIONS(2373),
    [anon_sym_asm] = ACTIONS(2373),
    [anon_sym___asm__] = ACTIONS(2373),
    [anon_sym_DOT] = ACTIONS(2373),
    [sym_number_literal] = ACTIONS(2371),
    [anon_sym_L_SQUOTE] = ACTIONS(2371),
    [anon_sym_u_SQUOTE] = ACTIONS(2371),
    [anon_sym_U_SQUOTE] = ACTIONS(2371),
    [anon_sym_u8_SQUOTE] = ACTIONS(2371),
    [anon_sym_SQUOTE] = ACTIONS(2371),
    [anon_sym_L_DQUOTE] = ACTIONS(2371),
    [anon_sym_u_DQUOTE] = ACTIONS(2371),
    [anon_sym_U_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8_DQUOTE] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [anon_sym_NULL] = ACTIONS(2373),
    [anon_sym_nullptr] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_This] = ACTIONS(2373),
    [anon_sym_decltype] = ACTIONS(2373),
    [anon_sym_final] = ACTIONS(2373),
    [anon_sym_override] = ACTIONS(2373),
    [sym_virtual] = ACTIONS(2373),
    [anon_sym_explicit] = ACTIONS(2373),
    [anon_sym_typename] = ACTIONS(2373),
    [anon_sym_template] = ACTIONS(2373),
    [anon_sym_GT2] = ACTIONS(2371),
    [anon_sym_operator] = ACTIONS(2373),
    [anon_sym_try] = ACTIONS(2373),
    [anon_sym_delete] = ACTIONS(2373),
    [anon_sym_throw] = ACTIONS(2373),
    [anon_sym_namespace] = ACTIONS(2373),
    [anon_sym_using] = ACTIONS(2373),
    [anon_sym_static_assert] = ACTIONS(2373),
    [anon_sym_concept] = ACTIONS(2373),
    [anon_sym_co_return] = ACTIONS(2373),
    [anon_sym_co_yield] = ACTIONS(2373),
    [anon_sym_R_DQUOTE] = ACTIONS(2371),
    [anon_sym_LR_DQUOTE] = ACTIONS(2371),
    [anon_sym_uR_DQUOTE] = ACTIONS(2371),
    [anon_sym_UR_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2371),
    [anon_sym_co_await] = ACTIONS(2373),
    [anon_sym_new] = ACTIONS(2373),
    [anon_sym_requires] = ACTIONS(2373),
    [sym_this] = ACTIONS(2373),
    [anon_sym_discard] = ACTIONS(2373),
    [anon_sym_precise] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_groupshared] = ACTIONS(2373),
    [anon_sym_uniform] = ACTIONS(2373),
    [anon_sym_row_major] = ACTIONS(2373),
    [anon_sym_column_major] = ACTIONS(2373),
    [anon_sym_globallycoherent] = ACTIONS(2373),
    [anon_sym_centroid] = ACTIONS(2373),
    [anon_sym_noperspective] = ACTIONS(2373),
    [anon_sym_nointerpolation] = ACTIONS(2373),
    [anon_sym_sample] = ACTIONS(2373),
    [anon_sym_linear] = ACTIONS(2373),
    [anon_sym_snorm] = ACTIONS(2373),
    [anon_sym_unorm] = ACTIONS(2373),
    [anon_sym_point] = ACTIONS(2373),
    [anon_sym_line] = ACTIONS(2373),
    [anon_sym_triangleadj] = ACTIONS(2373),
    [anon_sym_lineadj] = ACTIONS(2373),
    [anon_sym_triangle] = ACTIONS(2373),
    [anon_sym_cbuffer] = ACTIONS(2373),
    [anon_sym_interface] = ACTIONS(2373),
    [anon_sym_extension] = ACTIONS(2373),
    [anon_sym_where] = ACTIONS(2373),
    [anon_sym___exported] = ACTIONS(2373),
    [anon_sym_import] = ACTIONS(2373),
  },
  [198] = {
    [ts_builtin_sym_end] = ACTIONS(2188),
    [sym_identifier] = ACTIONS(2186),
    [aux_sym_preproc_include_token1] = ACTIONS(2186),
    [aux_sym_preproc_def_token1] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [aux_sym_preproc_if_token1] = ACTIONS(2186),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2186),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2186),
    [sym_preproc_directive] = ACTIONS(2186),
    [anon_sym_LPAREN2] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2188),
    [anon_sym_TILDE] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2186),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_STAR] = ACTIONS(2188),
    [anon_sym_PIPE_PIPE] = ACTIONS(2188),
    [anon_sym_AMP_AMP] = ACTIONS(2188),
    [anon_sym_AMP] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym___extension__] = ACTIONS(2186),
    [anon_sym_typedef] = ACTIONS(2186),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_out] = ACTIONS(2186),
    [anon_sym_inout] = ACTIONS(2186),
    [anon_sym_extern] = ACTIONS(2186),
    [anon_sym___attribute__] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2188),
    [anon_sym___declspec] = ACTIONS(2186),
    [anon_sym___based] = ACTIONS(2186),
    [anon_sym___cdecl] = ACTIONS(2186),
    [anon_sym___clrcall] = ACTIONS(2186),
    [anon_sym___stdcall] = ACTIONS(2186),
    [anon_sym___fastcall] = ACTIONS(2186),
    [anon_sym___thiscall] = ACTIONS(2186),
    [anon_sym___vectorcall] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_signed] = ACTIONS(2186),
    [anon_sym_unsigned] = ACTIONS(2186),
    [anon_sym_long] = ACTIONS(2186),
    [anon_sym_short] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_static] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2188),
    [anon_sym_register] = ACTIONS(2186),
    [anon_sym_inline] = ACTIONS(2186),
    [anon_sym___inline] = ACTIONS(2186),
    [anon_sym___inline__] = ACTIONS(2186),
    [anon_sym___forceinline] = ACTIONS(2186),
    [anon_sym_thread_local] = ACTIONS(2186),
    [anon_sym___thread] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_constexpr] = ACTIONS(2186),
    [anon_sym_volatile] = ACTIONS(2186),
    [anon_sym_restrict] = ACTIONS(2186),
    [anon_sym___restrict__] = ACTIONS(2186),
    [anon_sym__Atomic] = ACTIONS(2186),
    [anon_sym__Noreturn] = ACTIONS(2186),
    [anon_sym_noreturn] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_constinit] = ACTIONS(2186),
    [anon_sym_consteval] = ACTIONS(2186),
    [anon_sym_alignas] = ACTIONS(2186),
    [anon_sym__Alignas] = ACTIONS(2186),
    [sym_primitive_type] = ACTIONS(2186),
    [anon_sym_enum] = ACTIONS(2186),
    [anon_sym_class] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_union] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_switch] = ACTIONS(2186),
    [anon_sym_case] = ACTIONS(2186),
    [anon_sym_default] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [anon_sym_do] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_break] = ACTIONS(2186),
    [anon_sym_continue] = ACTIONS(2186),
    [anon_sym_goto] = ACTIONS(2186),
    [anon_sym___try] = ACTIONS(2186),
    [anon_sym___leave] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2186),
    [anon_sym_compl] = ACTIONS(2186),
    [anon_sym_or] = ACTIONS(2186),
    [anon_sym_and] = ACTIONS(2186),
    [anon_sym_DASH_DASH] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2188),
    [anon_sym_sizeof] = ACTIONS(2186),
    [anon_sym___alignof__] = ACTIONS(2186),
    [anon_sym___alignof] = ACTIONS(2186),
    [anon_sym__alignof] = ACTIONS(2186),
    [anon_sym_alignof] = ACTIONS(2186),
    [anon_sym__Alignof] = ACTIONS(2186),
    [anon_sym_offsetof] = ACTIONS(2186),
    [anon_sym__Generic] = ACTIONS(2186),
    [anon_sym_asm] = ACTIONS(2186),
    [anon_sym___asm__] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [sym_number_literal] = ACTIONS(2188),
    [anon_sym_L_SQUOTE] = ACTIONS(2188),
    [anon_sym_u_SQUOTE] = ACTIONS(2188),
    [anon_sym_U_SQUOTE] = ACTIONS(2188),
    [anon_sym_u8_SQUOTE] = ACTIONS(2188),
    [anon_sym_SQUOTE] = ACTIONS(2188),
    [anon_sym_L_DQUOTE] = ACTIONS(2188),
    [anon_sym_u_DQUOTE] = ACTIONS(2188),
    [anon_sym_U_DQUOTE] = ACTIONS(2188),
    [anon_sym_u8_DQUOTE] = ACTIONS(2188),
    [anon_sym_DQUOTE] = ACTIONS(2188),
    [sym_true] = ACTIONS(2186),
    [sym_false] = ACTIONS(2186),
    [anon_sym_NULL] = ACTIONS(2186),
    [anon_sym_nullptr] = ACTIONS(2186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_This] = ACTIONS(2186),
    [anon_sym_decltype] = ACTIONS(2186),
    [anon_sym_final] = ACTIONS(2186),
    [anon_sym_override] = ACTIONS(2186),
    [sym_virtual] = ACTIONS(2186),
    [anon_sym_explicit] = ACTIONS(2186),
    [anon_sym_typename] = ACTIONS(2186),
    [anon_sym_template] = ACTIONS(2186),
    [anon_sym_GT2] = ACTIONS(2188),
    [anon_sym_operator] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_delete] = ACTIONS(2186),
    [anon_sym_throw] = ACTIONS(2186),
    [anon_sym_namespace] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_static_assert] = ACTIONS(2186),
    [anon_sym_concept] = ACTIONS(2186),
    [anon_sym_co_return] = ACTIONS(2186),
    [anon_sym_co_yield] = ACTIONS(2186),
    [anon_sym_R_DQUOTE] = ACTIONS(2188),
    [anon_sym_LR_DQUOTE] = ACTIONS(2188),
    [anon_sym_uR_DQUOTE] = ACTIONS(2188),
    [anon_sym_UR_DQUOTE] = ACTIONS(2188),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2188),
    [anon_sym_co_await] = ACTIONS(2186),
    [anon_sym_new] = ACTIONS(2186),
    [anon_sym_requires] = ACTIONS(2186),
    [sym_this] = ACTIONS(2186),
    [anon_sym_discard] = ACTIONS(2186),
    [anon_sym_precise] = ACTIONS(2186),
    [anon_sym_shared] = ACTIONS(2186),
    [anon_sym_groupshared] = ACTIONS(2186),
    [anon_sym_uniform] = ACTIONS(2186),
    [anon_sym_row_major] = ACTIONS(2186),
    [anon_sym_column_major] = ACTIONS(2186),
    [anon_sym_globallycoherent] = ACTIONS(2186),
    [anon_sym_centroid] = ACTIONS(2186),
    [anon_sym_noperspective] = ACTIONS(2186),
    [anon_sym_nointerpolation] = ACTIONS(2186),
    [anon_sym_sample] = ACTIONS(2186),
    [anon_sym_linear] = ACTIONS(2186),
    [anon_sym_snorm] = ACTIONS(2186),
    [anon_sym_unorm] = ACTIONS(2186),
    [anon_sym_point] = ACTIONS(2186),
    [anon_sym_line] = ACTIONS(2186),
    [anon_sym_triangleadj] = ACTIONS(2186),
    [anon_sym_lineadj] = ACTIONS(2186),
    [anon_sym_triangle] = ACTIONS(2186),
    [anon_sym_cbuffer] = ACTIONS(2186),
    [anon_sym_interface] = ACTIONS(2186),
    [anon_sym_extension] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym___exported] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
  },
  [199] = {
    [ts_builtin_sym_end] = ACTIONS(2234),
    [sym_identifier] = ACTIONS(2232),
    [aux_sym_preproc_include_token1] = ACTIONS(2232),
    [aux_sym_preproc_def_token1] = ACTIONS(2232),
    [anon_sym_COMMA] = ACTIONS(2234),
    [anon_sym_RPAREN] = ACTIONS(2234),
    [aux_sym_preproc_if_token1] = ACTIONS(2232),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2232),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2232),
    [sym_preproc_directive] = ACTIONS(2232),
    [anon_sym_LPAREN2] = ACTIONS(2234),
    [anon_sym_BANG] = ACTIONS(2234),
    [anon_sym_TILDE] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2232),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_PIPE_PIPE] = ACTIONS(2234),
    [anon_sym_AMP_AMP] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2232),
    [anon_sym_COLON] = ACTIONS(2232),
    [anon_sym_SEMI] = ACTIONS(2234),
    [anon_sym___extension__] = ACTIONS(2232),
    [anon_sym_typedef] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2232),
    [anon_sym_out] = ACTIONS(2232),
    [anon_sym_inout] = ACTIONS(2232),
    [anon_sym_extern] = ACTIONS(2232),
    [anon_sym___attribute__] = ACTIONS(2232),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2234),
    [anon_sym___declspec] = ACTIONS(2232),
    [anon_sym___based] = ACTIONS(2232),
    [anon_sym___cdecl] = ACTIONS(2232),
    [anon_sym___clrcall] = ACTIONS(2232),
    [anon_sym___stdcall] = ACTIONS(2232),
    [anon_sym___fastcall] = ACTIONS(2232),
    [anon_sym___thiscall] = ACTIONS(2232),
    [anon_sym___vectorcall] = ACTIONS(2232),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_signed] = ACTIONS(2232),
    [anon_sym_unsigned] = ACTIONS(2232),
    [anon_sym_long] = ACTIONS(2232),
    [anon_sym_short] = ACTIONS(2232),
    [anon_sym_LBRACK] = ACTIONS(2232),
    [anon_sym_static] = ACTIONS(2232),
    [anon_sym_EQ] = ACTIONS(2234),
    [anon_sym_register] = ACTIONS(2232),
    [anon_sym_inline] = ACTIONS(2232),
    [anon_sym___inline] = ACTIONS(2232),
    [anon_sym___inline__] = ACTIONS(2232),
    [anon_sym___forceinline] = ACTIONS(2232),
    [anon_sym_thread_local] = ACTIONS(2232),
    [anon_sym___thread] = ACTIONS(2232),
    [anon_sym_const] = ACTIONS(2232),
    [anon_sym_constexpr] = ACTIONS(2232),
    [anon_sym_volatile] = ACTIONS(2232),
    [anon_sym_restrict] = ACTIONS(2232),
    [anon_sym___restrict__] = ACTIONS(2232),
    [anon_sym__Atomic] = ACTIONS(2232),
    [anon_sym__Noreturn] = ACTIONS(2232),
    [anon_sym_noreturn] = ACTIONS(2232),
    [anon_sym_mutable] = ACTIONS(2232),
    [anon_sym_constinit] = ACTIONS(2232),
    [anon_sym_consteval] = ACTIONS(2232),
    [anon_sym_alignas] = ACTIONS(2232),
    [anon_sym__Alignas] = ACTIONS(2232),
    [sym_primitive_type] = ACTIONS(2232),
    [anon_sym_enum] = ACTIONS(2232),
    [anon_sym_class] = ACTIONS(2232),
    [anon_sym_struct] = ACTIONS(2232),
    [anon_sym_union] = ACTIONS(2232),
    [anon_sym_if] = ACTIONS(2232),
    [anon_sym_else] = ACTIONS(2232),
    [anon_sym_switch] = ACTIONS(2232),
    [anon_sym_case] = ACTIONS(2232),
    [anon_sym_default] = ACTIONS(2232),
    [anon_sym_while] = ACTIONS(2232),
    [anon_sym_do] = ACTIONS(2232),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2232),
    [anon_sym_break] = ACTIONS(2232),
    [anon_sym_continue] = ACTIONS(2232),
    [anon_sym_goto] = ACTIONS(2232),
    [anon_sym___try] = ACTIONS(2232),
    [anon_sym___leave] = ACTIONS(2232),
    [anon_sym_not] = ACTIONS(2232),
    [anon_sym_compl] = ACTIONS(2232),
    [anon_sym_or] = ACTIONS(2232),
    [anon_sym_and] = ACTIONS(2232),
    [anon_sym_DASH_DASH] = ACTIONS(2234),
    [anon_sym_PLUS_PLUS] = ACTIONS(2234),
    [anon_sym_sizeof] = ACTIONS(2232),
    [anon_sym___alignof__] = ACTIONS(2232),
    [anon_sym___alignof] = ACTIONS(2232),
    [anon_sym__alignof] = ACTIONS(2232),
    [anon_sym_alignof] = ACTIONS(2232),
    [anon_sym__Alignof] = ACTIONS(2232),
    [anon_sym_offsetof] = ACTIONS(2232),
    [anon_sym__Generic] = ACTIONS(2232),
    [anon_sym_asm] = ACTIONS(2232),
    [anon_sym___asm__] = ACTIONS(2232),
    [anon_sym_DOT] = ACTIONS(2232),
    [sym_number_literal] = ACTIONS(2234),
    [anon_sym_L_SQUOTE] = ACTIONS(2234),
    [anon_sym_u_SQUOTE] = ACTIONS(2234),
    [anon_sym_U_SQUOTE] = ACTIONS(2234),
    [anon_sym_u8_SQUOTE] = ACTIONS(2234),
    [anon_sym_SQUOTE] = ACTIONS(2234),
    [anon_sym_L_DQUOTE] = ACTIONS(2234),
    [anon_sym_u_DQUOTE] = ACTIONS(2234),
    [anon_sym_U_DQUOTE] = ACTIONS(2234),
    [anon_sym_u8_DQUOTE] = ACTIONS(2234),
    [anon_sym_DQUOTE] = ACTIONS(2234),
    [sym_true] = ACTIONS(2232),
    [sym_false] = ACTIONS(2232),
    [anon_sym_NULL] = ACTIONS(2232),
    [anon_sym_nullptr] = ACTIONS(2232),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2232),
    [anon_sym_let] = ACTIONS(2232),
    [anon_sym_This] = ACTIONS(2232),
    [anon_sym_decltype] = ACTIONS(2232),
    [anon_sym_final] = ACTIONS(2232),
    [anon_sym_override] = ACTIONS(2232),
    [sym_virtual] = ACTIONS(2232),
    [anon_sym_explicit] = ACTIONS(2232),
    [anon_sym_typename] = ACTIONS(2232),
    [anon_sym_template] = ACTIONS(2232),
    [anon_sym_GT2] = ACTIONS(2234),
    [anon_sym_operator] = ACTIONS(2232),
    [anon_sym_try] = ACTIONS(2232),
    [anon_sym_delete] = ACTIONS(2232),
    [anon_sym_throw] = ACTIONS(2232),
    [anon_sym_namespace] = ACTIONS(2232),
    [anon_sym_using] = ACTIONS(2232),
    [anon_sym_static_assert] = ACTIONS(2232),
    [anon_sym_concept] = ACTIONS(2232),
    [anon_sym_co_return] = ACTIONS(2232),
    [anon_sym_co_yield] = ACTIONS(2232),
    [anon_sym_R_DQUOTE] = ACTIONS(2234),
    [anon_sym_LR_DQUOTE] = ACTIONS(2234),
    [anon_sym_uR_DQUOTE] = ACTIONS(2234),
    [anon_sym_UR_DQUOTE] = ACTIONS(2234),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2234),
    [anon_sym_co_await] = ACTIONS(2232),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_requires] = ACTIONS(2232),
    [sym_this] = ACTIONS(2232),
    [anon_sym_discard] = ACTIONS(2232),
    [anon_sym_precise] = ACTIONS(2232),
    [anon_sym_shared] = ACTIONS(2232),
    [anon_sym_groupshared] = ACTIONS(2232),
    [anon_sym_uniform] = ACTIONS(2232),
    [anon_sym_row_major] = ACTIONS(2232),
    [anon_sym_column_major] = ACTIONS(2232),
    [anon_sym_globallycoherent] = ACTIONS(2232),
    [anon_sym_centroid] = ACTIONS(2232),
    [anon_sym_noperspective] = ACTIONS(2232),
    [anon_sym_nointerpolation] = ACTIONS(2232),
    [anon_sym_sample] = ACTIONS(2232),
    [anon_sym_linear] = ACTIONS(2232),
    [anon_sym_snorm] = ACTIONS(2232),
    [anon_sym_unorm] = ACTIONS(2232),
    [anon_sym_point] = ACTIONS(2232),
    [anon_sym_line] = ACTIONS(2232),
    [anon_sym_triangleadj] = ACTIONS(2232),
    [anon_sym_lineadj] = ACTIONS(2232),
    [anon_sym_triangle] = ACTIONS(2232),
    [anon_sym_cbuffer] = ACTIONS(2232),
    [anon_sym_interface] = ACTIONS(2232),
    [anon_sym_extension] = ACTIONS(2232),
    [anon_sym_where] = ACTIONS(2232),
    [anon_sym___exported] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(2232),
  },
  [200] = {
    [ts_builtin_sym_end] = ACTIONS(2230),
    [sym_identifier] = ACTIONS(2228),
    [aux_sym_preproc_include_token1] = ACTIONS(2228),
    [aux_sym_preproc_def_token1] = ACTIONS(2228),
    [anon_sym_COMMA] = ACTIONS(2230),
    [anon_sym_RPAREN] = ACTIONS(2230),
    [aux_sym_preproc_if_token1] = ACTIONS(2228),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2228),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2228),
    [sym_preproc_directive] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_BANG] = ACTIONS(2230),
    [anon_sym_TILDE] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2228),
    [anon_sym_PLUS] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(2230),
    [anon_sym_PIPE_PIPE] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_AMP] = ACTIONS(2228),
    [anon_sym_COLON] = ACTIONS(2228),
    [anon_sym_SEMI] = ACTIONS(2230),
    [anon_sym___extension__] = ACTIONS(2228),
    [anon_sym_typedef] = ACTIONS(2228),
    [anon_sym_in] = ACTIONS(2228),
    [anon_sym_out] = ACTIONS(2228),
    [anon_sym_inout] = ACTIONS(2228),
    [anon_sym_extern] = ACTIONS(2228),
    [anon_sym___attribute__] = ACTIONS(2228),
    [anon_sym_COLON_COLON] = ACTIONS(2230),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2230),
    [anon_sym___declspec] = ACTIONS(2228),
    [anon_sym___based] = ACTIONS(2228),
    [anon_sym___cdecl] = ACTIONS(2228),
    [anon_sym___clrcall] = ACTIONS(2228),
    [anon_sym___stdcall] = ACTIONS(2228),
    [anon_sym___fastcall] = ACTIONS(2228),
    [anon_sym___thiscall] = ACTIONS(2228),
    [anon_sym___vectorcall] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_signed] = ACTIONS(2228),
    [anon_sym_unsigned] = ACTIONS(2228),
    [anon_sym_long] = ACTIONS(2228),
    [anon_sym_short] = ACTIONS(2228),
    [anon_sym_LBRACK] = ACTIONS(2228),
    [anon_sym_static] = ACTIONS(2228),
    [anon_sym_EQ] = ACTIONS(2230),
    [anon_sym_register] = ACTIONS(2228),
    [anon_sym_inline] = ACTIONS(2228),
    [anon_sym___inline] = ACTIONS(2228),
    [anon_sym___inline__] = ACTIONS(2228),
    [anon_sym___forceinline] = ACTIONS(2228),
    [anon_sym_thread_local] = ACTIONS(2228),
    [anon_sym___thread] = ACTIONS(2228),
    [anon_sym_const] = ACTIONS(2228),
    [anon_sym_constexpr] = ACTIONS(2228),
    [anon_sym_volatile] = ACTIONS(2228),
    [anon_sym_restrict] = ACTIONS(2228),
    [anon_sym___restrict__] = ACTIONS(2228),
    [anon_sym__Atomic] = ACTIONS(2228),
    [anon_sym__Noreturn] = ACTIONS(2228),
    [anon_sym_noreturn] = ACTIONS(2228),
    [anon_sym_mutable] = ACTIONS(2228),
    [anon_sym_constinit] = ACTIONS(2228),
    [anon_sym_consteval] = ACTIONS(2228),
    [anon_sym_alignas] = ACTIONS(2228),
    [anon_sym__Alignas] = ACTIONS(2228),
    [sym_primitive_type] = ACTIONS(2228),
    [anon_sym_enum] = ACTIONS(2228),
    [anon_sym_class] = ACTIONS(2228),
    [anon_sym_struct] = ACTIONS(2228),
    [anon_sym_union] = ACTIONS(2228),
    [anon_sym_if] = ACTIONS(2228),
    [anon_sym_else] = ACTIONS(2228),
    [anon_sym_switch] = ACTIONS(2228),
    [anon_sym_case] = ACTIONS(2228),
    [anon_sym_default] = ACTIONS(2228),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2228),
    [anon_sym_for] = ACTIONS(2228),
    [anon_sym_return] = ACTIONS(2228),
    [anon_sym_break] = ACTIONS(2228),
    [anon_sym_continue] = ACTIONS(2228),
    [anon_sym_goto] = ACTIONS(2228),
    [anon_sym___try] = ACTIONS(2228),
    [anon_sym___leave] = ACTIONS(2228),
    [anon_sym_not] = ACTIONS(2228),
    [anon_sym_compl] = ACTIONS(2228),
    [anon_sym_or] = ACTIONS(2228),
    [anon_sym_and] = ACTIONS(2228),
    [anon_sym_DASH_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_PLUS] = ACTIONS(2230),
    [anon_sym_sizeof] = ACTIONS(2228),
    [anon_sym___alignof__] = ACTIONS(2228),
    [anon_sym___alignof] = ACTIONS(2228),
    [anon_sym__alignof] = ACTIONS(2228),
    [anon_sym_alignof] = ACTIONS(2228),
    [anon_sym__Alignof] = ACTIONS(2228),
    [anon_sym_offsetof] = ACTIONS(2228),
    [anon_sym__Generic] = ACTIONS(2228),
    [anon_sym_asm] = ACTIONS(2228),
    [anon_sym___asm__] = ACTIONS(2228),
    [anon_sym_DOT] = ACTIONS(2228),
    [sym_number_literal] = ACTIONS(2230),
    [anon_sym_L_SQUOTE] = ACTIONS(2230),
    [anon_sym_u_SQUOTE] = ACTIONS(2230),
    [anon_sym_U_SQUOTE] = ACTIONS(2230),
    [anon_sym_u8_SQUOTE] = ACTIONS(2230),
    [anon_sym_SQUOTE] = ACTIONS(2230),
    [anon_sym_L_DQUOTE] = ACTIONS(2230),
    [anon_sym_u_DQUOTE] = ACTIONS(2230),
    [anon_sym_U_DQUOTE] = ACTIONS(2230),
    [anon_sym_u8_DQUOTE] = ACTIONS(2230),
    [anon_sym_DQUOTE] = ACTIONS(2230),
    [sym_true] = ACTIONS(2228),
    [sym_false] = ACTIONS(2228),
    [anon_sym_NULL] = ACTIONS(2228),
    [anon_sym_nullptr] = ACTIONS(2228),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(2228),
    [anon_sym_This] = ACTIONS(2228),
    [anon_sym_decltype] = ACTIONS(2228),
    [anon_sym_final] = ACTIONS(2228),
    [anon_sym_override] = ACTIONS(2228),
    [sym_virtual] = ACTIONS(2228),
    [anon_sym_explicit] = ACTIONS(2228),
    [anon_sym_typename] = ACTIONS(2228),
    [anon_sym_template] = ACTIONS(2228),
    [anon_sym_GT2] = ACTIONS(2230),
    [anon_sym_operator] = ACTIONS(2228),
    [anon_sym_try] = ACTIONS(2228),
    [anon_sym_delete] = ACTIONS(2228),
    [anon_sym_throw] = ACTIONS(2228),
    [anon_sym_namespace] = ACTIONS(2228),
    [anon_sym_using] = ACTIONS(2228),
    [anon_sym_static_assert] = ACTIONS(2228),
    [anon_sym_concept] = ACTIONS(2228),
    [anon_sym_co_return] = ACTIONS(2228),
    [anon_sym_co_yield] = ACTIONS(2228),
    [anon_sym_R_DQUOTE] = ACTIONS(2230),
    [anon_sym_LR_DQUOTE] = ACTIONS(2230),
    [anon_sym_uR_DQUOTE] = ACTIONS(2230),
    [anon_sym_UR_DQUOTE] = ACTIONS(2230),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2230),
    [anon_sym_co_await] = ACTIONS(2228),
    [anon_sym_new] = ACTIONS(2228),
    [anon_sym_requires] = ACTIONS(2228),
    [sym_this] = ACTIONS(2228),
    [anon_sym_discard] = ACTIONS(2228),
    [anon_sym_precise] = ACTIONS(2228),
    [anon_sym_shared] = ACTIONS(2228),
    [anon_sym_groupshared] = ACTIONS(2228),
    [anon_sym_uniform] = ACTIONS(2228),
    [anon_sym_row_major] = ACTIONS(2228),
    [anon_sym_column_major] = ACTIONS(2228),
    [anon_sym_globallycoherent] = ACTIONS(2228),
    [anon_sym_centroid] = ACTIONS(2228),
    [anon_sym_noperspective] = ACTIONS(2228),
    [anon_sym_nointerpolation] = ACTIONS(2228),
    [anon_sym_sample] = ACTIONS(2228),
    [anon_sym_linear] = ACTIONS(2228),
    [anon_sym_snorm] = ACTIONS(2228),
    [anon_sym_unorm] = ACTIONS(2228),
    [anon_sym_point] = ACTIONS(2228),
    [anon_sym_line] = ACTIONS(2228),
    [anon_sym_triangleadj] = ACTIONS(2228),
    [anon_sym_lineadj] = ACTIONS(2228),
    [anon_sym_triangle] = ACTIONS(2228),
    [anon_sym_cbuffer] = ACTIONS(2228),
    [anon_sym_interface] = ACTIONS(2228),
    [anon_sym_extension] = ACTIONS(2228),
    [anon_sym_where] = ACTIONS(2228),
    [anon_sym___exported] = ACTIONS(2228),
    [anon_sym_import] = ACTIONS(2228),
  },
  [201] = {
    [ts_builtin_sym_end] = ACTIONS(2371),
    [sym_identifier] = ACTIONS(2373),
    [aux_sym_preproc_include_token1] = ACTIONS(2373),
    [aux_sym_preproc_def_token1] = ACTIONS(2373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2371),
    [anon_sym_COMMA] = ACTIONS(2371),
    [anon_sym_RPAREN] = ACTIONS(2371),
    [aux_sym_preproc_if_token1] = ACTIONS(2373),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2373),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2373),
    [sym_preproc_directive] = ACTIONS(2373),
    [anon_sym_LPAREN2] = ACTIONS(2371),
    [anon_sym_BANG] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym___extension__] = ACTIONS(2373),
    [anon_sym_typedef] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_out] = ACTIONS(2373),
    [anon_sym_inout] = ACTIONS(2373),
    [anon_sym_extern] = ACTIONS(2373),
    [anon_sym___attribute__] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2371),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2371),
    [anon_sym___declspec] = ACTIONS(2373),
    [anon_sym___based] = ACTIONS(2373),
    [anon_sym___cdecl] = ACTIONS(2373),
    [anon_sym___clrcall] = ACTIONS(2373),
    [anon_sym___stdcall] = ACTIONS(2373),
    [anon_sym___fastcall] = ACTIONS(2373),
    [anon_sym___thiscall] = ACTIONS(2373),
    [anon_sym___vectorcall] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_signed] = ACTIONS(2373),
    [anon_sym_unsigned] = ACTIONS(2373),
    [anon_sym_long] = ACTIONS(2373),
    [anon_sym_short] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2373),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_register] = ACTIONS(2373),
    [anon_sym_inline] = ACTIONS(2373),
    [anon_sym___inline] = ACTIONS(2373),
    [anon_sym___inline__] = ACTIONS(2373),
    [anon_sym___forceinline] = ACTIONS(2373),
    [anon_sym_thread_local] = ACTIONS(2373),
    [anon_sym___thread] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym___restrict__] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym__Noreturn] = ACTIONS(2373),
    [anon_sym_noreturn] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_constinit] = ACTIONS(2373),
    [anon_sym_consteval] = ACTIONS(2373),
    [anon_sym_alignas] = ACTIONS(2373),
    [anon_sym__Alignas] = ACTIONS(2373),
    [sym_primitive_type] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_class] = ACTIONS(2373),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_else] = ACTIONS(2373),
    [anon_sym_switch] = ACTIONS(2373),
    [anon_sym_case] = ACTIONS(2373),
    [anon_sym_default] = ACTIONS(2373),
    [anon_sym_while] = ACTIONS(2373),
    [anon_sym_do] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2373),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2373),
    [anon_sym_goto] = ACTIONS(2373),
    [anon_sym___try] = ACTIONS(2373),
    [anon_sym___leave] = ACTIONS(2373),
    [anon_sym_not] = ACTIONS(2373),
    [anon_sym_compl] = ACTIONS(2373),
    [anon_sym_or] = ACTIONS(2373),
    [anon_sym_and] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_sizeof] = ACTIONS(2373),
    [anon_sym___alignof__] = ACTIONS(2373),
    [anon_sym___alignof] = ACTIONS(2373),
    [anon_sym__alignof] = ACTIONS(2373),
    [anon_sym_alignof] = ACTIONS(2373),
    [anon_sym__Alignof] = ACTIONS(2373),
    [anon_sym_offsetof] = ACTIONS(2373),
    [anon_sym__Generic] = ACTIONS(2373),
    [anon_sym_asm] = ACTIONS(2373),
    [anon_sym___asm__] = ACTIONS(2373),
    [anon_sym_DOT] = ACTIONS(2373),
    [sym_number_literal] = ACTIONS(2371),
    [anon_sym_L_SQUOTE] = ACTIONS(2371),
    [anon_sym_u_SQUOTE] = ACTIONS(2371),
    [anon_sym_U_SQUOTE] = ACTIONS(2371),
    [anon_sym_u8_SQUOTE] = ACTIONS(2371),
    [anon_sym_SQUOTE] = ACTIONS(2371),
    [anon_sym_L_DQUOTE] = ACTIONS(2371),
    [anon_sym_u_DQUOTE] = ACTIONS(2371),
    [anon_sym_U_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8_DQUOTE] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [anon_sym_NULL] = ACTIONS(2373),
    [anon_sym_nullptr] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_This] = ACTIONS(2373),
    [anon_sym_decltype] = ACTIONS(2373),
    [anon_sym_final] = ACTIONS(2373),
    [anon_sym_override] = ACTIONS(2373),
    [sym_virtual] = ACTIONS(2373),
    [anon_sym_explicit] = ACTIONS(2373),
    [anon_sym_typename] = ACTIONS(2373),
    [anon_sym_template] = ACTIONS(2373),
    [anon_sym_GT2] = ACTIONS(2371),
    [anon_sym_operator] = ACTIONS(2373),
    [anon_sym_try] = ACTIONS(2373),
    [anon_sym_delete] = ACTIONS(2373),
    [anon_sym_throw] = ACTIONS(2373),
    [anon_sym_namespace] = ACTIONS(2373),
    [anon_sym_using] = ACTIONS(2373),
    [anon_sym_static_assert] = ACTIONS(2373),
    [anon_sym_concept] = ACTIONS(2373),
    [anon_sym_co_return] = ACTIONS(2373),
    [anon_sym_co_yield] = ACTIONS(2373),
    [anon_sym_R_DQUOTE] = ACTIONS(2371),
    [anon_sym_LR_DQUOTE] = ACTIONS(2371),
    [anon_sym_uR_DQUOTE] = ACTIONS(2371),
    [anon_sym_UR_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2371),
    [anon_sym_co_await] = ACTIONS(2373),
    [anon_sym_new] = ACTIONS(2373),
    [anon_sym_requires] = ACTIONS(2373),
    [sym_this] = ACTIONS(2373),
    [anon_sym_discard] = ACTIONS(2373),
    [anon_sym_precise] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_groupshared] = ACTIONS(2373),
    [anon_sym_uniform] = ACTIONS(2373),
    [anon_sym_row_major] = ACTIONS(2373),
    [anon_sym_column_major] = ACTIONS(2373),
    [anon_sym_globallycoherent] = ACTIONS(2373),
    [anon_sym_centroid] = ACTIONS(2373),
    [anon_sym_noperspective] = ACTIONS(2373),
    [anon_sym_nointerpolation] = ACTIONS(2373),
    [anon_sym_sample] = ACTIONS(2373),
    [anon_sym_linear] = ACTIONS(2373),
    [anon_sym_snorm] = ACTIONS(2373),
    [anon_sym_unorm] = ACTIONS(2373),
    [anon_sym_point] = ACTIONS(2373),
    [anon_sym_line] = ACTIONS(2373),
    [anon_sym_triangleadj] = ACTIONS(2373),
    [anon_sym_lineadj] = ACTIONS(2373),
    [anon_sym_triangle] = ACTIONS(2373),
    [anon_sym_cbuffer] = ACTIONS(2373),
    [anon_sym_interface] = ACTIONS(2373),
    [anon_sym_extension] = ACTIONS(2373),
    [anon_sym_where] = ACTIONS(2373),
    [anon_sym___exported] = ACTIONS(2373),
    [anon_sym_import] = ACTIONS(2373),
  },
  [202] = {
    [ts_builtin_sym_end] = ACTIONS(2208),
    [sym_identifier] = ACTIONS(2206),
    [aux_sym_preproc_include_token1] = ACTIONS(2206),
    [aux_sym_preproc_def_token1] = ACTIONS(2206),
    [anon_sym_COMMA] = ACTIONS(2208),
    [anon_sym_RPAREN] = ACTIONS(2208),
    [aux_sym_preproc_if_token1] = ACTIONS(2206),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2206),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2206),
    [sym_preproc_directive] = ACTIONS(2206),
    [anon_sym_LPAREN2] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2208),
    [anon_sym_TILDE] = ACTIONS(2208),
    [anon_sym_DASH] = ACTIONS(2206),
    [anon_sym_PLUS] = ACTIONS(2206),
    [anon_sym_STAR] = ACTIONS(2208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2208),
    [anon_sym_AMP_AMP] = ACTIONS(2208),
    [anon_sym_AMP] = ACTIONS(2206),
    [anon_sym_COLON] = ACTIONS(2206),
    [anon_sym_SEMI] = ACTIONS(2208),
    [anon_sym___extension__] = ACTIONS(2206),
    [anon_sym_typedef] = ACTIONS(2206),
    [anon_sym_in] = ACTIONS(2206),
    [anon_sym_out] = ACTIONS(2206),
    [anon_sym_inout] = ACTIONS(2206),
    [anon_sym_extern] = ACTIONS(2206),
    [anon_sym___attribute__] = ACTIONS(2206),
    [anon_sym_COLON_COLON] = ACTIONS(2208),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2208),
    [anon_sym___declspec] = ACTIONS(2206),
    [anon_sym___based] = ACTIONS(2206),
    [anon_sym___cdecl] = ACTIONS(2206),
    [anon_sym___clrcall] = ACTIONS(2206),
    [anon_sym___stdcall] = ACTIONS(2206),
    [anon_sym___fastcall] = ACTIONS(2206),
    [anon_sym___thiscall] = ACTIONS(2206),
    [anon_sym___vectorcall] = ACTIONS(2206),
    [anon_sym_LBRACE] = ACTIONS(2208),
    [anon_sym_signed] = ACTIONS(2206),
    [anon_sym_unsigned] = ACTIONS(2206),
    [anon_sym_long] = ACTIONS(2206),
    [anon_sym_short] = ACTIONS(2206),
    [anon_sym_LBRACK] = ACTIONS(2206),
    [anon_sym_static] = ACTIONS(2206),
    [anon_sym_EQ] = ACTIONS(2208),
    [anon_sym_register] = ACTIONS(2206),
    [anon_sym_inline] = ACTIONS(2206),
    [anon_sym___inline] = ACTIONS(2206),
    [anon_sym___inline__] = ACTIONS(2206),
    [anon_sym___forceinline] = ACTIONS(2206),
    [anon_sym_thread_local] = ACTIONS(2206),
    [anon_sym___thread] = ACTIONS(2206),
    [anon_sym_const] = ACTIONS(2206),
    [anon_sym_constexpr] = ACTIONS(2206),
    [anon_sym_volatile] = ACTIONS(2206),
    [anon_sym_restrict] = ACTIONS(2206),
    [anon_sym___restrict__] = ACTIONS(2206),
    [anon_sym__Atomic] = ACTIONS(2206),
    [anon_sym__Noreturn] = ACTIONS(2206),
    [anon_sym_noreturn] = ACTIONS(2206),
    [anon_sym_mutable] = ACTIONS(2206),
    [anon_sym_constinit] = ACTIONS(2206),
    [anon_sym_consteval] = ACTIONS(2206),
    [anon_sym_alignas] = ACTIONS(2206),
    [anon_sym__Alignas] = ACTIONS(2206),
    [sym_primitive_type] = ACTIONS(2206),
    [anon_sym_enum] = ACTIONS(2206),
    [anon_sym_class] = ACTIONS(2206),
    [anon_sym_struct] = ACTIONS(2206),
    [anon_sym_union] = ACTIONS(2206),
    [anon_sym_if] = ACTIONS(2206),
    [anon_sym_else] = ACTIONS(2206),
    [anon_sym_switch] = ACTIONS(2206),
    [anon_sym_case] = ACTIONS(2206),
    [anon_sym_default] = ACTIONS(2206),
    [anon_sym_while] = ACTIONS(2206),
    [anon_sym_do] = ACTIONS(2206),
    [anon_sym_for] = ACTIONS(2206),
    [anon_sym_return] = ACTIONS(2206),
    [anon_sym_break] = ACTIONS(2206),
    [anon_sym_continue] = ACTIONS(2206),
    [anon_sym_goto] = ACTIONS(2206),
    [anon_sym___try] = ACTIONS(2206),
    [anon_sym___leave] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_compl] = ACTIONS(2206),
    [anon_sym_or] = ACTIONS(2206),
    [anon_sym_and] = ACTIONS(2206),
    [anon_sym_DASH_DASH] = ACTIONS(2208),
    [anon_sym_PLUS_PLUS] = ACTIONS(2208),
    [anon_sym_sizeof] = ACTIONS(2206),
    [anon_sym___alignof__] = ACTIONS(2206),
    [anon_sym___alignof] = ACTIONS(2206),
    [anon_sym__alignof] = ACTIONS(2206),
    [anon_sym_alignof] = ACTIONS(2206),
    [anon_sym__Alignof] = ACTIONS(2206),
    [anon_sym_offsetof] = ACTIONS(2206),
    [anon_sym__Generic] = ACTIONS(2206),
    [anon_sym_asm] = ACTIONS(2206),
    [anon_sym___asm__] = ACTIONS(2206),
    [anon_sym_DOT] = ACTIONS(2206),
    [sym_number_literal] = ACTIONS(2208),
    [anon_sym_L_SQUOTE] = ACTIONS(2208),
    [anon_sym_u_SQUOTE] = ACTIONS(2208),
    [anon_sym_U_SQUOTE] = ACTIONS(2208),
    [anon_sym_u8_SQUOTE] = ACTIONS(2208),
    [anon_sym_SQUOTE] = ACTIONS(2208),
    [anon_sym_L_DQUOTE] = ACTIONS(2208),
    [anon_sym_u_DQUOTE] = ACTIONS(2208),
    [anon_sym_U_DQUOTE] = ACTIONS(2208),
    [anon_sym_u8_DQUOTE] = ACTIONS(2208),
    [anon_sym_DQUOTE] = ACTIONS(2208),
    [sym_true] = ACTIONS(2206),
    [sym_false] = ACTIONS(2206),
    [anon_sym_NULL] = ACTIONS(2206),
    [anon_sym_nullptr] = ACTIONS(2206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2206),
    [anon_sym_let] = ACTIONS(2206),
    [anon_sym_This] = ACTIONS(2206),
    [anon_sym_decltype] = ACTIONS(2206),
    [anon_sym_final] = ACTIONS(2206),
    [anon_sym_override] = ACTIONS(2206),
    [sym_virtual] = ACTIONS(2206),
    [anon_sym_explicit] = ACTIONS(2206),
    [anon_sym_typename] = ACTIONS(2206),
    [anon_sym_template] = ACTIONS(2206),
    [anon_sym_GT2] = ACTIONS(2208),
    [anon_sym_operator] = ACTIONS(2206),
    [anon_sym_try] = ACTIONS(2206),
    [anon_sym_delete] = ACTIONS(2206),
    [anon_sym_throw] = ACTIONS(2206),
    [anon_sym_namespace] = ACTIONS(2206),
    [anon_sym_using] = ACTIONS(2206),
    [anon_sym_static_assert] = ACTIONS(2206),
    [anon_sym_concept] = ACTIONS(2206),
    [anon_sym_co_return] = ACTIONS(2206),
    [anon_sym_co_yield] = ACTIONS(2206),
    [anon_sym_R_DQUOTE] = ACTIONS(2208),
    [anon_sym_LR_DQUOTE] = ACTIONS(2208),
    [anon_sym_uR_DQUOTE] = ACTIONS(2208),
    [anon_sym_UR_DQUOTE] = ACTIONS(2208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2208),
    [anon_sym_co_await] = ACTIONS(2206),
    [anon_sym_new] = ACTIONS(2206),
    [anon_sym_requires] = ACTIONS(2206),
    [sym_this] = ACTIONS(2206),
    [anon_sym_discard] = ACTIONS(2206),
    [anon_sym_precise] = ACTIONS(2206),
    [anon_sym_shared] = ACTIONS(2206),
    [anon_sym_groupshared] = ACTIONS(2206),
    [anon_sym_uniform] = ACTIONS(2206),
    [anon_sym_row_major] = ACTIONS(2206),
    [anon_sym_column_major] = ACTIONS(2206),
    [anon_sym_globallycoherent] = ACTIONS(2206),
    [anon_sym_centroid] = ACTIONS(2206),
    [anon_sym_noperspective] = ACTIONS(2206),
    [anon_sym_nointerpolation] = ACTIONS(2206),
    [anon_sym_sample] = ACTIONS(2206),
    [anon_sym_linear] = ACTIONS(2206),
    [anon_sym_snorm] = ACTIONS(2206),
    [anon_sym_unorm] = ACTIONS(2206),
    [anon_sym_point] = ACTIONS(2206),
    [anon_sym_line] = ACTIONS(2206),
    [anon_sym_triangleadj] = ACTIONS(2206),
    [anon_sym_lineadj] = ACTIONS(2206),
    [anon_sym_triangle] = ACTIONS(2206),
    [anon_sym_cbuffer] = ACTIONS(2206),
    [anon_sym_interface] = ACTIONS(2206),
    [anon_sym_extension] = ACTIONS(2206),
    [anon_sym_where] = ACTIONS(2206),
    [anon_sym___exported] = ACTIONS(2206),
    [anon_sym_import] = ACTIONS(2206),
  },
  [203] = {
    [ts_builtin_sym_end] = ACTIONS(2238),
    [sym_identifier] = ACTIONS(2236),
    [aux_sym_preproc_include_token1] = ACTIONS(2236),
    [aux_sym_preproc_def_token1] = ACTIONS(2236),
    [anon_sym_COMMA] = ACTIONS(2238),
    [anon_sym_RPAREN] = ACTIONS(2238),
    [aux_sym_preproc_if_token1] = ACTIONS(2236),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2236),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2236),
    [sym_preproc_directive] = ACTIONS(2236),
    [anon_sym_LPAREN2] = ACTIONS(2238),
    [anon_sym_BANG] = ACTIONS(2238),
    [anon_sym_TILDE] = ACTIONS(2238),
    [anon_sym_DASH] = ACTIONS(2236),
    [anon_sym_PLUS] = ACTIONS(2236),
    [anon_sym_STAR] = ACTIONS(2238),
    [anon_sym_PIPE_PIPE] = ACTIONS(2238),
    [anon_sym_AMP_AMP] = ACTIONS(2238),
    [anon_sym_AMP] = ACTIONS(2236),
    [anon_sym_COLON] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(2238),
    [anon_sym___extension__] = ACTIONS(2236),
    [anon_sym_typedef] = ACTIONS(2236),
    [anon_sym_in] = ACTIONS(2236),
    [anon_sym_out] = ACTIONS(2236),
    [anon_sym_inout] = ACTIONS(2236),
    [anon_sym_extern] = ACTIONS(2236),
    [anon_sym___attribute__] = ACTIONS(2236),
    [anon_sym_COLON_COLON] = ACTIONS(2238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2238),
    [anon_sym___declspec] = ACTIONS(2236),
    [anon_sym___based] = ACTIONS(2236),
    [anon_sym___cdecl] = ACTIONS(2236),
    [anon_sym___clrcall] = ACTIONS(2236),
    [anon_sym___stdcall] = ACTIONS(2236),
    [anon_sym___fastcall] = ACTIONS(2236),
    [anon_sym___thiscall] = ACTIONS(2236),
    [anon_sym___vectorcall] = ACTIONS(2236),
    [anon_sym_LBRACE] = ACTIONS(2238),
    [anon_sym_signed] = ACTIONS(2236),
    [anon_sym_unsigned] = ACTIONS(2236),
    [anon_sym_long] = ACTIONS(2236),
    [anon_sym_short] = ACTIONS(2236),
    [anon_sym_LBRACK] = ACTIONS(2236),
    [anon_sym_static] = ACTIONS(2236),
    [anon_sym_EQ] = ACTIONS(2238),
    [anon_sym_register] = ACTIONS(2236),
    [anon_sym_inline] = ACTIONS(2236),
    [anon_sym___inline] = ACTIONS(2236),
    [anon_sym___inline__] = ACTIONS(2236),
    [anon_sym___forceinline] = ACTIONS(2236),
    [anon_sym_thread_local] = ACTIONS(2236),
    [anon_sym___thread] = ACTIONS(2236),
    [anon_sym_const] = ACTIONS(2236),
    [anon_sym_constexpr] = ACTIONS(2236),
    [anon_sym_volatile] = ACTIONS(2236),
    [anon_sym_restrict] = ACTIONS(2236),
    [anon_sym___restrict__] = ACTIONS(2236),
    [anon_sym__Atomic] = ACTIONS(2236),
    [anon_sym__Noreturn] = ACTIONS(2236),
    [anon_sym_noreturn] = ACTIONS(2236),
    [anon_sym_mutable] = ACTIONS(2236),
    [anon_sym_constinit] = ACTIONS(2236),
    [anon_sym_consteval] = ACTIONS(2236),
    [anon_sym_alignas] = ACTIONS(2236),
    [anon_sym__Alignas] = ACTIONS(2236),
    [sym_primitive_type] = ACTIONS(2236),
    [anon_sym_enum] = ACTIONS(2236),
    [anon_sym_class] = ACTIONS(2236),
    [anon_sym_struct] = ACTIONS(2236),
    [anon_sym_union] = ACTIONS(2236),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_else] = ACTIONS(2236),
    [anon_sym_switch] = ACTIONS(2236),
    [anon_sym_case] = ACTIONS(2236),
    [anon_sym_default] = ACTIONS(2236),
    [anon_sym_while] = ACTIONS(2236),
    [anon_sym_do] = ACTIONS(2236),
    [anon_sym_for] = ACTIONS(2236),
    [anon_sym_return] = ACTIONS(2236),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2236),
    [anon_sym_goto] = ACTIONS(2236),
    [anon_sym___try] = ACTIONS(2236),
    [anon_sym___leave] = ACTIONS(2236),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_compl] = ACTIONS(2236),
    [anon_sym_or] = ACTIONS(2236),
    [anon_sym_and] = ACTIONS(2236),
    [anon_sym_DASH_DASH] = ACTIONS(2238),
    [anon_sym_PLUS_PLUS] = ACTIONS(2238),
    [anon_sym_sizeof] = ACTIONS(2236),
    [anon_sym___alignof__] = ACTIONS(2236),
    [anon_sym___alignof] = ACTIONS(2236),
    [anon_sym__alignof] = ACTIONS(2236),
    [anon_sym_alignof] = ACTIONS(2236),
    [anon_sym__Alignof] = ACTIONS(2236),
    [anon_sym_offsetof] = ACTIONS(2236),
    [anon_sym__Generic] = ACTIONS(2236),
    [anon_sym_asm] = ACTIONS(2236),
    [anon_sym___asm__] = ACTIONS(2236),
    [anon_sym_DOT] = ACTIONS(2236),
    [sym_number_literal] = ACTIONS(2238),
    [anon_sym_L_SQUOTE] = ACTIONS(2238),
    [anon_sym_u_SQUOTE] = ACTIONS(2238),
    [anon_sym_U_SQUOTE] = ACTIONS(2238),
    [anon_sym_u8_SQUOTE] = ACTIONS(2238),
    [anon_sym_SQUOTE] = ACTIONS(2238),
    [anon_sym_L_DQUOTE] = ACTIONS(2238),
    [anon_sym_u_DQUOTE] = ACTIONS(2238),
    [anon_sym_U_DQUOTE] = ACTIONS(2238),
    [anon_sym_u8_DQUOTE] = ACTIONS(2238),
    [anon_sym_DQUOTE] = ACTIONS(2238),
    [sym_true] = ACTIONS(2236),
    [sym_false] = ACTIONS(2236),
    [anon_sym_NULL] = ACTIONS(2236),
    [anon_sym_nullptr] = ACTIONS(2236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2236),
    [anon_sym_let] = ACTIONS(2236),
    [anon_sym_This] = ACTIONS(2236),
    [anon_sym_decltype] = ACTIONS(2236),
    [anon_sym_final] = ACTIONS(2236),
    [anon_sym_override] = ACTIONS(2236),
    [sym_virtual] = ACTIONS(2236),
    [anon_sym_explicit] = ACTIONS(2236),
    [anon_sym_typename] = ACTIONS(2236),
    [anon_sym_template] = ACTIONS(2236),
    [anon_sym_GT2] = ACTIONS(2238),
    [anon_sym_operator] = ACTIONS(2236),
    [anon_sym_try] = ACTIONS(2236),
    [anon_sym_delete] = ACTIONS(2236),
    [anon_sym_throw] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(2236),
    [anon_sym_using] = ACTIONS(2236),
    [anon_sym_static_assert] = ACTIONS(2236),
    [anon_sym_concept] = ACTIONS(2236),
    [anon_sym_co_return] = ACTIONS(2236),
    [anon_sym_co_yield] = ACTIONS(2236),
    [anon_sym_R_DQUOTE] = ACTIONS(2238),
    [anon_sym_LR_DQUOTE] = ACTIONS(2238),
    [anon_sym_uR_DQUOTE] = ACTIONS(2238),
    [anon_sym_UR_DQUOTE] = ACTIONS(2238),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2238),
    [anon_sym_co_await] = ACTIONS(2236),
    [anon_sym_new] = ACTIONS(2236),
    [anon_sym_requires] = ACTIONS(2236),
    [sym_this] = ACTIONS(2236),
    [anon_sym_discard] = ACTIONS(2236),
    [anon_sym_precise] = ACTIONS(2236),
    [anon_sym_shared] = ACTIONS(2236),
    [anon_sym_groupshared] = ACTIONS(2236),
    [anon_sym_uniform] = ACTIONS(2236),
    [anon_sym_row_major] = ACTIONS(2236),
    [anon_sym_column_major] = ACTIONS(2236),
    [anon_sym_globallycoherent] = ACTIONS(2236),
    [anon_sym_centroid] = ACTIONS(2236),
    [anon_sym_noperspective] = ACTIONS(2236),
    [anon_sym_nointerpolation] = ACTIONS(2236),
    [anon_sym_sample] = ACTIONS(2236),
    [anon_sym_linear] = ACTIONS(2236),
    [anon_sym_snorm] = ACTIONS(2236),
    [anon_sym_unorm] = ACTIONS(2236),
    [anon_sym_point] = ACTIONS(2236),
    [anon_sym_line] = ACTIONS(2236),
    [anon_sym_triangleadj] = ACTIONS(2236),
    [anon_sym_lineadj] = ACTIONS(2236),
    [anon_sym_triangle] = ACTIONS(2236),
    [anon_sym_cbuffer] = ACTIONS(2236),
    [anon_sym_interface] = ACTIONS(2236),
    [anon_sym_extension] = ACTIONS(2236),
    [anon_sym_where] = ACTIONS(2236),
    [anon_sym___exported] = ACTIONS(2236),
    [anon_sym_import] = ACTIONS(2236),
  },
  [204] = {
    [ts_builtin_sym_end] = ACTIONS(2226),
    [sym_identifier] = ACTIONS(2224),
    [aux_sym_preproc_include_token1] = ACTIONS(2224),
    [aux_sym_preproc_def_token1] = ACTIONS(2224),
    [anon_sym_COMMA] = ACTIONS(2226),
    [anon_sym_RPAREN] = ACTIONS(2226),
    [aux_sym_preproc_if_token1] = ACTIONS(2224),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2224),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2224),
    [sym_preproc_directive] = ACTIONS(2224),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_BANG] = ACTIONS(2226),
    [anon_sym_TILDE] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_PLUS] = ACTIONS(2224),
    [anon_sym_STAR] = ACTIONS(2226),
    [anon_sym_PIPE_PIPE] = ACTIONS(2226),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_AMP] = ACTIONS(2224),
    [anon_sym_COLON] = ACTIONS(2224),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym___extension__] = ACTIONS(2224),
    [anon_sym_typedef] = ACTIONS(2224),
    [anon_sym_in] = ACTIONS(2224),
    [anon_sym_out] = ACTIONS(2224),
    [anon_sym_inout] = ACTIONS(2224),
    [anon_sym_extern] = ACTIONS(2224),
    [anon_sym___attribute__] = ACTIONS(2224),
    [anon_sym_COLON_COLON] = ACTIONS(2226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2226),
    [anon_sym___declspec] = ACTIONS(2224),
    [anon_sym___based] = ACTIONS(2224),
    [anon_sym___cdecl] = ACTIONS(2224),
    [anon_sym___clrcall] = ACTIONS(2224),
    [anon_sym___stdcall] = ACTIONS(2224),
    [anon_sym___fastcall] = ACTIONS(2224),
    [anon_sym___thiscall] = ACTIONS(2224),
    [anon_sym___vectorcall] = ACTIONS(2224),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_signed] = ACTIONS(2224),
    [anon_sym_unsigned] = ACTIONS(2224),
    [anon_sym_long] = ACTIONS(2224),
    [anon_sym_short] = ACTIONS(2224),
    [anon_sym_LBRACK] = ACTIONS(2224),
    [anon_sym_static] = ACTIONS(2224),
    [anon_sym_EQ] = ACTIONS(2226),
    [anon_sym_register] = ACTIONS(2224),
    [anon_sym_inline] = ACTIONS(2224),
    [anon_sym___inline] = ACTIONS(2224),
    [anon_sym___inline__] = ACTIONS(2224),
    [anon_sym___forceinline] = ACTIONS(2224),
    [anon_sym_thread_local] = ACTIONS(2224),
    [anon_sym___thread] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_constexpr] = ACTIONS(2224),
    [anon_sym_volatile] = ACTIONS(2224),
    [anon_sym_restrict] = ACTIONS(2224),
    [anon_sym___restrict__] = ACTIONS(2224),
    [anon_sym__Atomic] = ACTIONS(2224),
    [anon_sym__Noreturn] = ACTIONS(2224),
    [anon_sym_noreturn] = ACTIONS(2224),
    [anon_sym_mutable] = ACTIONS(2224),
    [anon_sym_constinit] = ACTIONS(2224),
    [anon_sym_consteval] = ACTIONS(2224),
    [anon_sym_alignas] = ACTIONS(2224),
    [anon_sym__Alignas] = ACTIONS(2224),
    [sym_primitive_type] = ACTIONS(2224),
    [anon_sym_enum] = ACTIONS(2224),
    [anon_sym_class] = ACTIONS(2224),
    [anon_sym_struct] = ACTIONS(2224),
    [anon_sym_union] = ACTIONS(2224),
    [anon_sym_if] = ACTIONS(2224),
    [anon_sym_else] = ACTIONS(2224),
    [anon_sym_switch] = ACTIONS(2224),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2224),
    [anon_sym_while] = ACTIONS(2224),
    [anon_sym_do] = ACTIONS(2224),
    [anon_sym_for] = ACTIONS(2224),
    [anon_sym_return] = ACTIONS(2224),
    [anon_sym_break] = ACTIONS(2224),
    [anon_sym_continue] = ACTIONS(2224),
    [anon_sym_goto] = ACTIONS(2224),
    [anon_sym___try] = ACTIONS(2224),
    [anon_sym___leave] = ACTIONS(2224),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_compl] = ACTIONS(2224),
    [anon_sym_or] = ACTIONS(2224),
    [anon_sym_and] = ACTIONS(2224),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_sizeof] = ACTIONS(2224),
    [anon_sym___alignof__] = ACTIONS(2224),
    [anon_sym___alignof] = ACTIONS(2224),
    [anon_sym__alignof] = ACTIONS(2224),
    [anon_sym_alignof] = ACTIONS(2224),
    [anon_sym__Alignof] = ACTIONS(2224),
    [anon_sym_offsetof] = ACTIONS(2224),
    [anon_sym__Generic] = ACTIONS(2224),
    [anon_sym_asm] = ACTIONS(2224),
    [anon_sym___asm__] = ACTIONS(2224),
    [anon_sym_DOT] = ACTIONS(2224),
    [sym_number_literal] = ACTIONS(2226),
    [anon_sym_L_SQUOTE] = ACTIONS(2226),
    [anon_sym_u_SQUOTE] = ACTIONS(2226),
    [anon_sym_U_SQUOTE] = ACTIONS(2226),
    [anon_sym_u8_SQUOTE] = ACTIONS(2226),
    [anon_sym_SQUOTE] = ACTIONS(2226),
    [anon_sym_L_DQUOTE] = ACTIONS(2226),
    [anon_sym_u_DQUOTE] = ACTIONS(2226),
    [anon_sym_U_DQUOTE] = ACTIONS(2226),
    [anon_sym_u8_DQUOTE] = ACTIONS(2226),
    [anon_sym_DQUOTE] = ACTIONS(2226),
    [sym_true] = ACTIONS(2224),
    [sym_false] = ACTIONS(2224),
    [anon_sym_NULL] = ACTIONS(2224),
    [anon_sym_nullptr] = ACTIONS(2224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2224),
    [anon_sym_let] = ACTIONS(2224),
    [anon_sym_This] = ACTIONS(2224),
    [anon_sym_decltype] = ACTIONS(2224),
    [anon_sym_final] = ACTIONS(2224),
    [anon_sym_override] = ACTIONS(2224),
    [sym_virtual] = ACTIONS(2224),
    [anon_sym_explicit] = ACTIONS(2224),
    [anon_sym_typename] = ACTIONS(2224),
    [anon_sym_template] = ACTIONS(2224),
    [anon_sym_GT2] = ACTIONS(2226),
    [anon_sym_operator] = ACTIONS(2224),
    [anon_sym_try] = ACTIONS(2224),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_throw] = ACTIONS(2224),
    [anon_sym_namespace] = ACTIONS(2224),
    [anon_sym_using] = ACTIONS(2224),
    [anon_sym_static_assert] = ACTIONS(2224),
    [anon_sym_concept] = ACTIONS(2224),
    [anon_sym_co_return] = ACTIONS(2224),
    [anon_sym_co_yield] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(2226),
    [anon_sym_LR_DQUOTE] = ACTIONS(2226),
    [anon_sym_uR_DQUOTE] = ACTIONS(2226),
    [anon_sym_UR_DQUOTE] = ACTIONS(2226),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2226),
    [anon_sym_co_await] = ACTIONS(2224),
    [anon_sym_new] = ACTIONS(2224),
    [anon_sym_requires] = ACTIONS(2224),
    [sym_this] = ACTIONS(2224),
    [anon_sym_discard] = ACTIONS(2224),
    [anon_sym_precise] = ACTIONS(2224),
    [anon_sym_shared] = ACTIONS(2224),
    [anon_sym_groupshared] = ACTIONS(2224),
    [anon_sym_uniform] = ACTIONS(2224),
    [anon_sym_row_major] = ACTIONS(2224),
    [anon_sym_column_major] = ACTIONS(2224),
    [anon_sym_globallycoherent] = ACTIONS(2224),
    [anon_sym_centroid] = ACTIONS(2224),
    [anon_sym_noperspective] = ACTIONS(2224),
    [anon_sym_nointerpolation] = ACTIONS(2224),
    [anon_sym_sample] = ACTIONS(2224),
    [anon_sym_linear] = ACTIONS(2224),
    [anon_sym_snorm] = ACTIONS(2224),
    [anon_sym_unorm] = ACTIONS(2224),
    [anon_sym_point] = ACTIONS(2224),
    [anon_sym_line] = ACTIONS(2224),
    [anon_sym_triangleadj] = ACTIONS(2224),
    [anon_sym_lineadj] = ACTIONS(2224),
    [anon_sym_triangle] = ACTIONS(2224),
    [anon_sym_cbuffer] = ACTIONS(2224),
    [anon_sym_interface] = ACTIONS(2224),
    [anon_sym_extension] = ACTIONS(2224),
    [anon_sym_where] = ACTIONS(2224),
    [anon_sym___exported] = ACTIONS(2224),
    [anon_sym_import] = ACTIONS(2224),
  },
  [205] = {
    [ts_builtin_sym_end] = ACTIONS(2204),
    [sym_identifier] = ACTIONS(2202),
    [aux_sym_preproc_include_token1] = ACTIONS(2202),
    [aux_sym_preproc_def_token1] = ACTIONS(2202),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_RPAREN] = ACTIONS(2204),
    [aux_sym_preproc_if_token1] = ACTIONS(2202),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2202),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2202),
    [sym_preproc_directive] = ACTIONS(2202),
    [anon_sym_LPAREN2] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2204),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2202),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_STAR] = ACTIONS(2204),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_AMP] = ACTIONS(2202),
    [anon_sym_COLON] = ACTIONS(2202),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym___extension__] = ACTIONS(2202),
    [anon_sym_typedef] = ACTIONS(2202),
    [anon_sym_in] = ACTIONS(2202),
    [anon_sym_out] = ACTIONS(2202),
    [anon_sym_inout] = ACTIONS(2202),
    [anon_sym_extern] = ACTIONS(2202),
    [anon_sym___attribute__] = ACTIONS(2202),
    [anon_sym_COLON_COLON] = ACTIONS(2204),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2204),
    [anon_sym___declspec] = ACTIONS(2202),
    [anon_sym___based] = ACTIONS(2202),
    [anon_sym___cdecl] = ACTIONS(2202),
    [anon_sym___clrcall] = ACTIONS(2202),
    [anon_sym___stdcall] = ACTIONS(2202),
    [anon_sym___fastcall] = ACTIONS(2202),
    [anon_sym___thiscall] = ACTIONS(2202),
    [anon_sym___vectorcall] = ACTIONS(2202),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_signed] = ACTIONS(2202),
    [anon_sym_unsigned] = ACTIONS(2202),
    [anon_sym_long] = ACTIONS(2202),
    [anon_sym_short] = ACTIONS(2202),
    [anon_sym_LBRACK] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2202),
    [anon_sym_EQ] = ACTIONS(2204),
    [anon_sym_register] = ACTIONS(2202),
    [anon_sym_inline] = ACTIONS(2202),
    [anon_sym___inline] = ACTIONS(2202),
    [anon_sym___inline__] = ACTIONS(2202),
    [anon_sym___forceinline] = ACTIONS(2202),
    [anon_sym_thread_local] = ACTIONS(2202),
    [anon_sym___thread] = ACTIONS(2202),
    [anon_sym_const] = ACTIONS(2202),
    [anon_sym_constexpr] = ACTIONS(2202),
    [anon_sym_volatile] = ACTIONS(2202),
    [anon_sym_restrict] = ACTIONS(2202),
    [anon_sym___restrict__] = ACTIONS(2202),
    [anon_sym__Atomic] = ACTIONS(2202),
    [anon_sym__Noreturn] = ACTIONS(2202),
    [anon_sym_noreturn] = ACTIONS(2202),
    [anon_sym_mutable] = ACTIONS(2202),
    [anon_sym_constinit] = ACTIONS(2202),
    [anon_sym_consteval] = ACTIONS(2202),
    [anon_sym_alignas] = ACTIONS(2202),
    [anon_sym__Alignas] = ACTIONS(2202),
    [sym_primitive_type] = ACTIONS(2202),
    [anon_sym_enum] = ACTIONS(2202),
    [anon_sym_class] = ACTIONS(2202),
    [anon_sym_struct] = ACTIONS(2202),
    [anon_sym_union] = ACTIONS(2202),
    [anon_sym_if] = ACTIONS(2202),
    [anon_sym_else] = ACTIONS(2202),
    [anon_sym_switch] = ACTIONS(2202),
    [anon_sym_case] = ACTIONS(2202),
    [anon_sym_default] = ACTIONS(2202),
    [anon_sym_while] = ACTIONS(2202),
    [anon_sym_do] = ACTIONS(2202),
    [anon_sym_for] = ACTIONS(2202),
    [anon_sym_return] = ACTIONS(2202),
    [anon_sym_break] = ACTIONS(2202),
    [anon_sym_continue] = ACTIONS(2202),
    [anon_sym_goto] = ACTIONS(2202),
    [anon_sym___try] = ACTIONS(2202),
    [anon_sym___leave] = ACTIONS(2202),
    [anon_sym_not] = ACTIONS(2202),
    [anon_sym_compl] = ACTIONS(2202),
    [anon_sym_or] = ACTIONS(2202),
    [anon_sym_and] = ACTIONS(2202),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_sizeof] = ACTIONS(2202),
    [anon_sym___alignof__] = ACTIONS(2202),
    [anon_sym___alignof] = ACTIONS(2202),
    [anon_sym__alignof] = ACTIONS(2202),
    [anon_sym_alignof] = ACTIONS(2202),
    [anon_sym__Alignof] = ACTIONS(2202),
    [anon_sym_offsetof] = ACTIONS(2202),
    [anon_sym__Generic] = ACTIONS(2202),
    [anon_sym_asm] = ACTIONS(2202),
    [anon_sym___asm__] = ACTIONS(2202),
    [anon_sym_DOT] = ACTIONS(2202),
    [sym_number_literal] = ACTIONS(2204),
    [anon_sym_L_SQUOTE] = ACTIONS(2204),
    [anon_sym_u_SQUOTE] = ACTIONS(2204),
    [anon_sym_U_SQUOTE] = ACTIONS(2204),
    [anon_sym_u8_SQUOTE] = ACTIONS(2204),
    [anon_sym_SQUOTE] = ACTIONS(2204),
    [anon_sym_L_DQUOTE] = ACTIONS(2204),
    [anon_sym_u_DQUOTE] = ACTIONS(2204),
    [anon_sym_U_DQUOTE] = ACTIONS(2204),
    [anon_sym_u8_DQUOTE] = ACTIONS(2204),
    [anon_sym_DQUOTE] = ACTIONS(2204),
    [sym_true] = ACTIONS(2202),
    [sym_false] = ACTIONS(2202),
    [anon_sym_NULL] = ACTIONS(2202),
    [anon_sym_nullptr] = ACTIONS(2202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2202),
    [anon_sym_let] = ACTIONS(2202),
    [anon_sym_This] = ACTIONS(2202),
    [anon_sym_decltype] = ACTIONS(2202),
    [anon_sym_final] = ACTIONS(2202),
    [anon_sym_override] = ACTIONS(2202),
    [sym_virtual] = ACTIONS(2202),
    [anon_sym_explicit] = ACTIONS(2202),
    [anon_sym_typename] = ACTIONS(2202),
    [anon_sym_template] = ACTIONS(2202),
    [anon_sym_GT2] = ACTIONS(2204),
    [anon_sym_operator] = ACTIONS(2202),
    [anon_sym_try] = ACTIONS(2202),
    [anon_sym_delete] = ACTIONS(2202),
    [anon_sym_throw] = ACTIONS(2202),
    [anon_sym_namespace] = ACTIONS(2202),
    [anon_sym_using] = ACTIONS(2202),
    [anon_sym_static_assert] = ACTIONS(2202),
    [anon_sym_concept] = ACTIONS(2202),
    [anon_sym_co_return] = ACTIONS(2202),
    [anon_sym_co_yield] = ACTIONS(2202),
    [anon_sym_R_DQUOTE] = ACTIONS(2204),
    [anon_sym_LR_DQUOTE] = ACTIONS(2204),
    [anon_sym_uR_DQUOTE] = ACTIONS(2204),
    [anon_sym_UR_DQUOTE] = ACTIONS(2204),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2204),
    [anon_sym_co_await] = ACTIONS(2202),
    [anon_sym_new] = ACTIONS(2202),
    [anon_sym_requires] = ACTIONS(2202),
    [sym_this] = ACTIONS(2202),
    [anon_sym_discard] = ACTIONS(2202),
    [anon_sym_precise] = ACTIONS(2202),
    [anon_sym_shared] = ACTIONS(2202),
    [anon_sym_groupshared] = ACTIONS(2202),
    [anon_sym_uniform] = ACTIONS(2202),
    [anon_sym_row_major] = ACTIONS(2202),
    [anon_sym_column_major] = ACTIONS(2202),
    [anon_sym_globallycoherent] = ACTIONS(2202),
    [anon_sym_centroid] = ACTIONS(2202),
    [anon_sym_noperspective] = ACTIONS(2202),
    [anon_sym_nointerpolation] = ACTIONS(2202),
    [anon_sym_sample] = ACTIONS(2202),
    [anon_sym_linear] = ACTIONS(2202),
    [anon_sym_snorm] = ACTIONS(2202),
    [anon_sym_unorm] = ACTIONS(2202),
    [anon_sym_point] = ACTIONS(2202),
    [anon_sym_line] = ACTIONS(2202),
    [anon_sym_triangleadj] = ACTIONS(2202),
    [anon_sym_lineadj] = ACTIONS(2202),
    [anon_sym_triangle] = ACTIONS(2202),
    [anon_sym_cbuffer] = ACTIONS(2202),
    [anon_sym_interface] = ACTIONS(2202),
    [anon_sym_extension] = ACTIONS(2202),
    [anon_sym_where] = ACTIONS(2202),
    [anon_sym___exported] = ACTIONS(2202),
    [anon_sym_import] = ACTIONS(2202),
  },
  [206] = {
    [ts_builtin_sym_end] = ACTIONS(2258),
    [sym_identifier] = ACTIONS(2256),
    [aux_sym_preproc_include_token1] = ACTIONS(2256),
    [aux_sym_preproc_def_token1] = ACTIONS(2256),
    [anon_sym_COMMA] = ACTIONS(2258),
    [anon_sym_RPAREN] = ACTIONS(2258),
    [aux_sym_preproc_if_token1] = ACTIONS(2256),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2256),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2256),
    [sym_preproc_directive] = ACTIONS(2256),
    [anon_sym_LPAREN2] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [anon_sym_DASH] = ACTIONS(2256),
    [anon_sym_PLUS] = ACTIONS(2256),
    [anon_sym_STAR] = ACTIONS(2258),
    [anon_sym_PIPE_PIPE] = ACTIONS(2258),
    [anon_sym_AMP_AMP] = ACTIONS(2258),
    [anon_sym_AMP] = ACTIONS(2256),
    [anon_sym_COLON] = ACTIONS(2256),
    [anon_sym_SEMI] = ACTIONS(2258),
    [anon_sym___extension__] = ACTIONS(2256),
    [anon_sym_typedef] = ACTIONS(2256),
    [anon_sym_in] = ACTIONS(2256),
    [anon_sym_out] = ACTIONS(2256),
    [anon_sym_inout] = ACTIONS(2256),
    [anon_sym_extern] = ACTIONS(2256),
    [anon_sym___attribute__] = ACTIONS(2256),
    [anon_sym_COLON_COLON] = ACTIONS(2258),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2258),
    [anon_sym___declspec] = ACTIONS(2256),
    [anon_sym___based] = ACTIONS(2256),
    [anon_sym___cdecl] = ACTIONS(2256),
    [anon_sym___clrcall] = ACTIONS(2256),
    [anon_sym___stdcall] = ACTIONS(2256),
    [anon_sym___fastcall] = ACTIONS(2256),
    [anon_sym___thiscall] = ACTIONS(2256),
    [anon_sym___vectorcall] = ACTIONS(2256),
    [anon_sym_LBRACE] = ACTIONS(2258),
    [anon_sym_signed] = ACTIONS(2256),
    [anon_sym_unsigned] = ACTIONS(2256),
    [anon_sym_long] = ACTIONS(2256),
    [anon_sym_short] = ACTIONS(2256),
    [anon_sym_LBRACK] = ACTIONS(2256),
    [anon_sym_static] = ACTIONS(2256),
    [anon_sym_EQ] = ACTIONS(2258),
    [anon_sym_register] = ACTIONS(2256),
    [anon_sym_inline] = ACTIONS(2256),
    [anon_sym___inline] = ACTIONS(2256),
    [anon_sym___inline__] = ACTIONS(2256),
    [anon_sym___forceinline] = ACTIONS(2256),
    [anon_sym_thread_local] = ACTIONS(2256),
    [anon_sym___thread] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_constexpr] = ACTIONS(2256),
    [anon_sym_volatile] = ACTIONS(2256),
    [anon_sym_restrict] = ACTIONS(2256),
    [anon_sym___restrict__] = ACTIONS(2256),
    [anon_sym__Atomic] = ACTIONS(2256),
    [anon_sym__Noreturn] = ACTIONS(2256),
    [anon_sym_noreturn] = ACTIONS(2256),
    [anon_sym_mutable] = ACTIONS(2256),
    [anon_sym_constinit] = ACTIONS(2256),
    [anon_sym_consteval] = ACTIONS(2256),
    [anon_sym_alignas] = ACTIONS(2256),
    [anon_sym__Alignas] = ACTIONS(2256),
    [sym_primitive_type] = ACTIONS(2256),
    [anon_sym_enum] = ACTIONS(2256),
    [anon_sym_class] = ACTIONS(2256),
    [anon_sym_struct] = ACTIONS(2256),
    [anon_sym_union] = ACTIONS(2256),
    [anon_sym_if] = ACTIONS(2256),
    [anon_sym_else] = ACTIONS(2256),
    [anon_sym_switch] = ACTIONS(2256),
    [anon_sym_case] = ACTIONS(2256),
    [anon_sym_default] = ACTIONS(2256),
    [anon_sym_while] = ACTIONS(2256),
    [anon_sym_do] = ACTIONS(2256),
    [anon_sym_for] = ACTIONS(2256),
    [anon_sym_return] = ACTIONS(2256),
    [anon_sym_break] = ACTIONS(2256),
    [anon_sym_continue] = ACTIONS(2256),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym___try] = ACTIONS(2256),
    [anon_sym___leave] = ACTIONS(2256),
    [anon_sym_not] = ACTIONS(2256),
    [anon_sym_compl] = ACTIONS(2256),
    [anon_sym_or] = ACTIONS(2256),
    [anon_sym_and] = ACTIONS(2256),
    [anon_sym_DASH_DASH] = ACTIONS(2258),
    [anon_sym_PLUS_PLUS] = ACTIONS(2258),
    [anon_sym_sizeof] = ACTIONS(2256),
    [anon_sym___alignof__] = ACTIONS(2256),
    [anon_sym___alignof] = ACTIONS(2256),
    [anon_sym__alignof] = ACTIONS(2256),
    [anon_sym_alignof] = ACTIONS(2256),
    [anon_sym__Alignof] = ACTIONS(2256),
    [anon_sym_offsetof] = ACTIONS(2256),
    [anon_sym__Generic] = ACTIONS(2256),
    [anon_sym_asm] = ACTIONS(2256),
    [anon_sym___asm__] = ACTIONS(2256),
    [anon_sym_DOT] = ACTIONS(2256),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_L_SQUOTE] = ACTIONS(2258),
    [anon_sym_u_SQUOTE] = ACTIONS(2258),
    [anon_sym_U_SQUOTE] = ACTIONS(2258),
    [anon_sym_u8_SQUOTE] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(2258),
    [anon_sym_L_DQUOTE] = ACTIONS(2258),
    [anon_sym_u_DQUOTE] = ACTIONS(2258),
    [anon_sym_U_DQUOTE] = ACTIONS(2258),
    [anon_sym_u8_DQUOTE] = ACTIONS(2258),
    [anon_sym_DQUOTE] = ACTIONS(2258),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2256),
    [anon_sym_nullptr] = ACTIONS(2256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_This] = ACTIONS(2256),
    [anon_sym_decltype] = ACTIONS(2256),
    [anon_sym_final] = ACTIONS(2256),
    [anon_sym_override] = ACTIONS(2256),
    [sym_virtual] = ACTIONS(2256),
    [anon_sym_explicit] = ACTIONS(2256),
    [anon_sym_typename] = ACTIONS(2256),
    [anon_sym_template] = ACTIONS(2256),
    [anon_sym_GT2] = ACTIONS(2258),
    [anon_sym_operator] = ACTIONS(2256),
    [anon_sym_try] = ACTIONS(2256),
    [anon_sym_delete] = ACTIONS(2256),
    [anon_sym_throw] = ACTIONS(2256),
    [anon_sym_namespace] = ACTIONS(2256),
    [anon_sym_using] = ACTIONS(2256),
    [anon_sym_static_assert] = ACTIONS(2256),
    [anon_sym_concept] = ACTIONS(2256),
    [anon_sym_co_return] = ACTIONS(2256),
    [anon_sym_co_yield] = ACTIONS(2256),
    [anon_sym_R_DQUOTE] = ACTIONS(2258),
    [anon_sym_LR_DQUOTE] = ACTIONS(2258),
    [anon_sym_uR_DQUOTE] = ACTIONS(2258),
    [anon_sym_UR_DQUOTE] = ACTIONS(2258),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2258),
    [anon_sym_co_await] = ACTIONS(2256),
    [anon_sym_new] = ACTIONS(2256),
    [anon_sym_requires] = ACTIONS(2256),
    [sym_this] = ACTIONS(2256),
    [anon_sym_discard] = ACTIONS(2256),
    [anon_sym_precise] = ACTIONS(2256),
    [anon_sym_shared] = ACTIONS(2256),
    [anon_sym_groupshared] = ACTIONS(2256),
    [anon_sym_uniform] = ACTIONS(2256),
    [anon_sym_row_major] = ACTIONS(2256),
    [anon_sym_column_major] = ACTIONS(2256),
    [anon_sym_globallycoherent] = ACTIONS(2256),
    [anon_sym_centroid] = ACTIONS(2256),
    [anon_sym_noperspective] = ACTIONS(2256),
    [anon_sym_nointerpolation] = ACTIONS(2256),
    [anon_sym_sample] = ACTIONS(2256),
    [anon_sym_linear] = ACTIONS(2256),
    [anon_sym_snorm] = ACTIONS(2256),
    [anon_sym_unorm] = ACTIONS(2256),
    [anon_sym_point] = ACTIONS(2256),
    [anon_sym_line] = ACTIONS(2256),
    [anon_sym_triangleadj] = ACTIONS(2256),
    [anon_sym_lineadj] = ACTIONS(2256),
    [anon_sym_triangle] = ACTIONS(2256),
    [anon_sym_cbuffer] = ACTIONS(2256),
    [anon_sym_interface] = ACTIONS(2256),
    [anon_sym_extension] = ACTIONS(2256),
    [anon_sym_where] = ACTIONS(2256),
    [anon_sym___exported] = ACTIONS(2256),
    [anon_sym_import] = ACTIONS(2256),
  },
  [207] = {
    [ts_builtin_sym_end] = ACTIONS(2246),
    [sym_identifier] = ACTIONS(2244),
    [aux_sym_preproc_include_token1] = ACTIONS(2244),
    [aux_sym_preproc_def_token1] = ACTIONS(2244),
    [anon_sym_COMMA] = ACTIONS(2246),
    [anon_sym_RPAREN] = ACTIONS(2246),
    [aux_sym_preproc_if_token1] = ACTIONS(2244),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2244),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2244),
    [sym_preproc_directive] = ACTIONS(2244),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2244),
    [anon_sym_PLUS] = ACTIONS(2244),
    [anon_sym_STAR] = ACTIONS(2246),
    [anon_sym_PIPE_PIPE] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_AMP] = ACTIONS(2244),
    [anon_sym_COLON] = ACTIONS(2244),
    [anon_sym_SEMI] = ACTIONS(2246),
    [anon_sym___extension__] = ACTIONS(2244),
    [anon_sym_typedef] = ACTIONS(2244),
    [anon_sym_in] = ACTIONS(2244),
    [anon_sym_out] = ACTIONS(2244),
    [anon_sym_inout] = ACTIONS(2244),
    [anon_sym_extern] = ACTIONS(2244),
    [anon_sym___attribute__] = ACTIONS(2244),
    [anon_sym_COLON_COLON] = ACTIONS(2246),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2246),
    [anon_sym___declspec] = ACTIONS(2244),
    [anon_sym___based] = ACTIONS(2244),
    [anon_sym___cdecl] = ACTIONS(2244),
    [anon_sym___clrcall] = ACTIONS(2244),
    [anon_sym___stdcall] = ACTIONS(2244),
    [anon_sym___fastcall] = ACTIONS(2244),
    [anon_sym___thiscall] = ACTIONS(2244),
    [anon_sym___vectorcall] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_signed] = ACTIONS(2244),
    [anon_sym_unsigned] = ACTIONS(2244),
    [anon_sym_long] = ACTIONS(2244),
    [anon_sym_short] = ACTIONS(2244),
    [anon_sym_LBRACK] = ACTIONS(2244),
    [anon_sym_static] = ACTIONS(2244),
    [anon_sym_EQ] = ACTIONS(2246),
    [anon_sym_register] = ACTIONS(2244),
    [anon_sym_inline] = ACTIONS(2244),
    [anon_sym___inline] = ACTIONS(2244),
    [anon_sym___inline__] = ACTIONS(2244),
    [anon_sym___forceinline] = ACTIONS(2244),
    [anon_sym_thread_local] = ACTIONS(2244),
    [anon_sym___thread] = ACTIONS(2244),
    [anon_sym_const] = ACTIONS(2244),
    [anon_sym_constexpr] = ACTIONS(2244),
    [anon_sym_volatile] = ACTIONS(2244),
    [anon_sym_restrict] = ACTIONS(2244),
    [anon_sym___restrict__] = ACTIONS(2244),
    [anon_sym__Atomic] = ACTIONS(2244),
    [anon_sym__Noreturn] = ACTIONS(2244),
    [anon_sym_noreturn] = ACTIONS(2244),
    [anon_sym_mutable] = ACTIONS(2244),
    [anon_sym_constinit] = ACTIONS(2244),
    [anon_sym_consteval] = ACTIONS(2244),
    [anon_sym_alignas] = ACTIONS(2244),
    [anon_sym__Alignas] = ACTIONS(2244),
    [sym_primitive_type] = ACTIONS(2244),
    [anon_sym_enum] = ACTIONS(2244),
    [anon_sym_class] = ACTIONS(2244),
    [anon_sym_struct] = ACTIONS(2244),
    [anon_sym_union] = ACTIONS(2244),
    [anon_sym_if] = ACTIONS(2244),
    [anon_sym_else] = ACTIONS(2244),
    [anon_sym_switch] = ACTIONS(2244),
    [anon_sym_case] = ACTIONS(2244),
    [anon_sym_default] = ACTIONS(2244),
    [anon_sym_while] = ACTIONS(2244),
    [anon_sym_do] = ACTIONS(2244),
    [anon_sym_for] = ACTIONS(2244),
    [anon_sym_return] = ACTIONS(2244),
    [anon_sym_break] = ACTIONS(2244),
    [anon_sym_continue] = ACTIONS(2244),
    [anon_sym_goto] = ACTIONS(2244),
    [anon_sym___try] = ACTIONS(2244),
    [anon_sym___leave] = ACTIONS(2244),
    [anon_sym_not] = ACTIONS(2244),
    [anon_sym_compl] = ACTIONS(2244),
    [anon_sym_or] = ACTIONS(2244),
    [anon_sym_and] = ACTIONS(2244),
    [anon_sym_DASH_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_PLUS] = ACTIONS(2246),
    [anon_sym_sizeof] = ACTIONS(2244),
    [anon_sym___alignof__] = ACTIONS(2244),
    [anon_sym___alignof] = ACTIONS(2244),
    [anon_sym__alignof] = ACTIONS(2244),
    [anon_sym_alignof] = ACTIONS(2244),
    [anon_sym__Alignof] = ACTIONS(2244),
    [anon_sym_offsetof] = ACTIONS(2244),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2244),
    [anon_sym___asm__] = ACTIONS(2244),
    [anon_sym_DOT] = ACTIONS(2244),
    [sym_number_literal] = ACTIONS(2246),
    [anon_sym_L_SQUOTE] = ACTIONS(2246),
    [anon_sym_u_SQUOTE] = ACTIONS(2246),
    [anon_sym_U_SQUOTE] = ACTIONS(2246),
    [anon_sym_u8_SQUOTE] = ACTIONS(2246),
    [anon_sym_SQUOTE] = ACTIONS(2246),
    [anon_sym_L_DQUOTE] = ACTIONS(2246),
    [anon_sym_u_DQUOTE] = ACTIONS(2246),
    [anon_sym_U_DQUOTE] = ACTIONS(2246),
    [anon_sym_u8_DQUOTE] = ACTIONS(2246),
    [anon_sym_DQUOTE] = ACTIONS(2246),
    [sym_true] = ACTIONS(2244),
    [sym_false] = ACTIONS(2244),
    [anon_sym_NULL] = ACTIONS(2244),
    [anon_sym_nullptr] = ACTIONS(2244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2244),
    [anon_sym_let] = ACTIONS(2244),
    [anon_sym_This] = ACTIONS(2244),
    [anon_sym_decltype] = ACTIONS(2244),
    [anon_sym_final] = ACTIONS(2244),
    [anon_sym_override] = ACTIONS(2244),
    [sym_virtual] = ACTIONS(2244),
    [anon_sym_explicit] = ACTIONS(2244),
    [anon_sym_typename] = ACTIONS(2244),
    [anon_sym_template] = ACTIONS(2244),
    [anon_sym_GT2] = ACTIONS(2246),
    [anon_sym_operator] = ACTIONS(2244),
    [anon_sym_try] = ACTIONS(2244),
    [anon_sym_delete] = ACTIONS(2244),
    [anon_sym_throw] = ACTIONS(2244),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_using] = ACTIONS(2244),
    [anon_sym_static_assert] = ACTIONS(2244),
    [anon_sym_concept] = ACTIONS(2244),
    [anon_sym_co_return] = ACTIONS(2244),
    [anon_sym_co_yield] = ACTIONS(2244),
    [anon_sym_R_DQUOTE] = ACTIONS(2246),
    [anon_sym_LR_DQUOTE] = ACTIONS(2246),
    [anon_sym_uR_DQUOTE] = ACTIONS(2246),
    [anon_sym_UR_DQUOTE] = ACTIONS(2246),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2246),
    [anon_sym_co_await] = ACTIONS(2244),
    [anon_sym_new] = ACTIONS(2244),
    [anon_sym_requires] = ACTIONS(2244),
    [sym_this] = ACTIONS(2244),
    [anon_sym_discard] = ACTIONS(2244),
    [anon_sym_precise] = ACTIONS(2244),
    [anon_sym_shared] = ACTIONS(2244),
    [anon_sym_groupshared] = ACTIONS(2244),
    [anon_sym_uniform] = ACTIONS(2244),
    [anon_sym_row_major] = ACTIONS(2244),
    [anon_sym_column_major] = ACTIONS(2244),
    [anon_sym_globallycoherent] = ACTIONS(2244),
    [anon_sym_centroid] = ACTIONS(2244),
    [anon_sym_noperspective] = ACTIONS(2244),
    [anon_sym_nointerpolation] = ACTIONS(2244),
    [anon_sym_sample] = ACTIONS(2244),
    [anon_sym_linear] = ACTIONS(2244),
    [anon_sym_snorm] = ACTIONS(2244),
    [anon_sym_unorm] = ACTIONS(2244),
    [anon_sym_point] = ACTIONS(2244),
    [anon_sym_line] = ACTIONS(2244),
    [anon_sym_triangleadj] = ACTIONS(2244),
    [anon_sym_lineadj] = ACTIONS(2244),
    [anon_sym_triangle] = ACTIONS(2244),
    [anon_sym_cbuffer] = ACTIONS(2244),
    [anon_sym_interface] = ACTIONS(2244),
    [anon_sym_extension] = ACTIONS(2244),
    [anon_sym_where] = ACTIONS(2244),
    [anon_sym___exported] = ACTIONS(2244),
    [anon_sym_import] = ACTIONS(2244),
  },
  [208] = {
    [ts_builtin_sym_end] = ACTIONS(2254),
    [sym_identifier] = ACTIONS(2252),
    [aux_sym_preproc_include_token1] = ACTIONS(2252),
    [aux_sym_preproc_def_token1] = ACTIONS(2252),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_RPAREN] = ACTIONS(2254),
    [aux_sym_preproc_if_token1] = ACTIONS(2252),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2252),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2252),
    [sym_preproc_directive] = ACTIONS(2252),
    [anon_sym_LPAREN2] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2254),
    [anon_sym_TILDE] = ACTIONS(2254),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2254),
    [anon_sym_PIPE_PIPE] = ACTIONS(2254),
    [anon_sym_AMP_AMP] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym_SEMI] = ACTIONS(2254),
    [anon_sym___extension__] = ACTIONS(2252),
    [anon_sym_typedef] = ACTIONS(2252),
    [anon_sym_in] = ACTIONS(2252),
    [anon_sym_out] = ACTIONS(2252),
    [anon_sym_inout] = ACTIONS(2252),
    [anon_sym_extern] = ACTIONS(2252),
    [anon_sym___attribute__] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2254),
    [anon_sym___declspec] = ACTIONS(2252),
    [anon_sym___based] = ACTIONS(2252),
    [anon_sym___cdecl] = ACTIONS(2252),
    [anon_sym___clrcall] = ACTIONS(2252),
    [anon_sym___stdcall] = ACTIONS(2252),
    [anon_sym___fastcall] = ACTIONS(2252),
    [anon_sym___thiscall] = ACTIONS(2252),
    [anon_sym___vectorcall] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_signed] = ACTIONS(2252),
    [anon_sym_unsigned] = ACTIONS(2252),
    [anon_sym_long] = ACTIONS(2252),
    [anon_sym_short] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2252),
    [anon_sym_EQ] = ACTIONS(2254),
    [anon_sym_register] = ACTIONS(2252),
    [anon_sym_inline] = ACTIONS(2252),
    [anon_sym___inline] = ACTIONS(2252),
    [anon_sym___inline__] = ACTIONS(2252),
    [anon_sym___forceinline] = ACTIONS(2252),
    [anon_sym_thread_local] = ACTIONS(2252),
    [anon_sym___thread] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2252),
    [anon_sym_constexpr] = ACTIONS(2252),
    [anon_sym_volatile] = ACTIONS(2252),
    [anon_sym_restrict] = ACTIONS(2252),
    [anon_sym___restrict__] = ACTIONS(2252),
    [anon_sym__Atomic] = ACTIONS(2252),
    [anon_sym__Noreturn] = ACTIONS(2252),
    [anon_sym_noreturn] = ACTIONS(2252),
    [anon_sym_mutable] = ACTIONS(2252),
    [anon_sym_constinit] = ACTIONS(2252),
    [anon_sym_consteval] = ACTIONS(2252),
    [anon_sym_alignas] = ACTIONS(2252),
    [anon_sym__Alignas] = ACTIONS(2252),
    [sym_primitive_type] = ACTIONS(2252),
    [anon_sym_enum] = ACTIONS(2252),
    [anon_sym_class] = ACTIONS(2252),
    [anon_sym_struct] = ACTIONS(2252),
    [anon_sym_union] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_else] = ACTIONS(2252),
    [anon_sym_switch] = ACTIONS(2252),
    [anon_sym_case] = ACTIONS(2252),
    [anon_sym_default] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_do] = ACTIONS(2252),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2252),
    [anon_sym_goto] = ACTIONS(2252),
    [anon_sym___try] = ACTIONS(2252),
    [anon_sym___leave] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2252),
    [anon_sym_compl] = ACTIONS(2252),
    [anon_sym_or] = ACTIONS(2252),
    [anon_sym_and] = ACTIONS(2252),
    [anon_sym_DASH_DASH] = ACTIONS(2254),
    [anon_sym_PLUS_PLUS] = ACTIONS(2254),
    [anon_sym_sizeof] = ACTIONS(2252),
    [anon_sym___alignof__] = ACTIONS(2252),
    [anon_sym___alignof] = ACTIONS(2252),
    [anon_sym__alignof] = ACTIONS(2252),
    [anon_sym_alignof] = ACTIONS(2252),
    [anon_sym__Alignof] = ACTIONS(2252),
    [anon_sym_offsetof] = ACTIONS(2252),
    [anon_sym__Generic] = ACTIONS(2252),
    [anon_sym_asm] = ACTIONS(2252),
    [anon_sym___asm__] = ACTIONS(2252),
    [anon_sym_DOT] = ACTIONS(2252),
    [sym_number_literal] = ACTIONS(2254),
    [anon_sym_L_SQUOTE] = ACTIONS(2254),
    [anon_sym_u_SQUOTE] = ACTIONS(2254),
    [anon_sym_U_SQUOTE] = ACTIONS(2254),
    [anon_sym_u8_SQUOTE] = ACTIONS(2254),
    [anon_sym_SQUOTE] = ACTIONS(2254),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2252),
    [sym_false] = ACTIONS(2252),
    [anon_sym_NULL] = ACTIONS(2252),
    [anon_sym_nullptr] = ACTIONS(2252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_This] = ACTIONS(2252),
    [anon_sym_decltype] = ACTIONS(2252),
    [anon_sym_final] = ACTIONS(2252),
    [anon_sym_override] = ACTIONS(2252),
    [sym_virtual] = ACTIONS(2252),
    [anon_sym_explicit] = ACTIONS(2252),
    [anon_sym_typename] = ACTIONS(2252),
    [anon_sym_template] = ACTIONS(2252),
    [anon_sym_GT2] = ACTIONS(2254),
    [anon_sym_operator] = ACTIONS(2252),
    [anon_sym_try] = ACTIONS(2252),
    [anon_sym_delete] = ACTIONS(2252),
    [anon_sym_throw] = ACTIONS(2252),
    [anon_sym_namespace] = ACTIONS(2252),
    [anon_sym_using] = ACTIONS(2252),
    [anon_sym_static_assert] = ACTIONS(2252),
    [anon_sym_concept] = ACTIONS(2252),
    [anon_sym_co_return] = ACTIONS(2252),
    [anon_sym_co_yield] = ACTIONS(2252),
    [anon_sym_R_DQUOTE] = ACTIONS(2254),
    [anon_sym_LR_DQUOTE] = ACTIONS(2254),
    [anon_sym_uR_DQUOTE] = ACTIONS(2254),
    [anon_sym_UR_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2254),
    [anon_sym_co_await] = ACTIONS(2252),
    [anon_sym_new] = ACTIONS(2252),
    [anon_sym_requires] = ACTIONS(2252),
    [sym_this] = ACTIONS(2252),
    [anon_sym_discard] = ACTIONS(2252),
    [anon_sym_precise] = ACTIONS(2252),
    [anon_sym_shared] = ACTIONS(2252),
    [anon_sym_groupshared] = ACTIONS(2252),
    [anon_sym_uniform] = ACTIONS(2252),
    [anon_sym_row_major] = ACTIONS(2252),
    [anon_sym_column_major] = ACTIONS(2252),
    [anon_sym_globallycoherent] = ACTIONS(2252),
    [anon_sym_centroid] = ACTIONS(2252),
    [anon_sym_noperspective] = ACTIONS(2252),
    [anon_sym_nointerpolation] = ACTIONS(2252),
    [anon_sym_sample] = ACTIONS(2252),
    [anon_sym_linear] = ACTIONS(2252),
    [anon_sym_snorm] = ACTIONS(2252),
    [anon_sym_unorm] = ACTIONS(2252),
    [anon_sym_point] = ACTIONS(2252),
    [anon_sym_line] = ACTIONS(2252),
    [anon_sym_triangleadj] = ACTIONS(2252),
    [anon_sym_lineadj] = ACTIONS(2252),
    [anon_sym_triangle] = ACTIONS(2252),
    [anon_sym_cbuffer] = ACTIONS(2252),
    [anon_sym_interface] = ACTIONS(2252),
    [anon_sym_extension] = ACTIONS(2252),
    [anon_sym_where] = ACTIONS(2252),
    [anon_sym___exported] = ACTIONS(2252),
    [anon_sym_import] = ACTIONS(2252),
  },
  [209] = {
    [ts_builtin_sym_end] = ACTIONS(2192),
    [sym_identifier] = ACTIONS(2190),
    [aux_sym_preproc_include_token1] = ACTIONS(2190),
    [aux_sym_preproc_def_token1] = ACTIONS(2190),
    [anon_sym_COMMA] = ACTIONS(2192),
    [anon_sym_RPAREN] = ACTIONS(2192),
    [aux_sym_preproc_if_token1] = ACTIONS(2190),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2190),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2190),
    [sym_preproc_directive] = ACTIONS(2190),
    [anon_sym_LPAREN2] = ACTIONS(2192),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2190),
    [anon_sym_PLUS] = ACTIONS(2190),
    [anon_sym_STAR] = ACTIONS(2192),
    [anon_sym_PIPE_PIPE] = ACTIONS(2192),
    [anon_sym_AMP_AMP] = ACTIONS(2192),
    [anon_sym_AMP] = ACTIONS(2190),
    [anon_sym_COLON] = ACTIONS(2190),
    [anon_sym_SEMI] = ACTIONS(2192),
    [anon_sym___extension__] = ACTIONS(2190),
    [anon_sym_typedef] = ACTIONS(2190),
    [anon_sym_in] = ACTIONS(2190),
    [anon_sym_out] = ACTIONS(2190),
    [anon_sym_inout] = ACTIONS(2190),
    [anon_sym_extern] = ACTIONS(2190),
    [anon_sym___attribute__] = ACTIONS(2190),
    [anon_sym_COLON_COLON] = ACTIONS(2192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2192),
    [anon_sym___declspec] = ACTIONS(2190),
    [anon_sym___based] = ACTIONS(2190),
    [anon_sym___cdecl] = ACTIONS(2190),
    [anon_sym___clrcall] = ACTIONS(2190),
    [anon_sym___stdcall] = ACTIONS(2190),
    [anon_sym___fastcall] = ACTIONS(2190),
    [anon_sym___thiscall] = ACTIONS(2190),
    [anon_sym___vectorcall] = ACTIONS(2190),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [anon_sym_signed] = ACTIONS(2190),
    [anon_sym_unsigned] = ACTIONS(2190),
    [anon_sym_long] = ACTIONS(2190),
    [anon_sym_short] = ACTIONS(2190),
    [anon_sym_LBRACK] = ACTIONS(2190),
    [anon_sym_static] = ACTIONS(2190),
    [anon_sym_EQ] = ACTIONS(2192),
    [anon_sym_register] = ACTIONS(2190),
    [anon_sym_inline] = ACTIONS(2190),
    [anon_sym___inline] = ACTIONS(2190),
    [anon_sym___inline__] = ACTIONS(2190),
    [anon_sym___forceinline] = ACTIONS(2190),
    [anon_sym_thread_local] = ACTIONS(2190),
    [anon_sym___thread] = ACTIONS(2190),
    [anon_sym_const] = ACTIONS(2190),
    [anon_sym_constexpr] = ACTIONS(2190),
    [anon_sym_volatile] = ACTIONS(2190),
    [anon_sym_restrict] = ACTIONS(2190),
    [anon_sym___restrict__] = ACTIONS(2190),
    [anon_sym__Atomic] = ACTIONS(2190),
    [anon_sym__Noreturn] = ACTIONS(2190),
    [anon_sym_noreturn] = ACTIONS(2190),
    [anon_sym_mutable] = ACTIONS(2190),
    [anon_sym_constinit] = ACTIONS(2190),
    [anon_sym_consteval] = ACTIONS(2190),
    [anon_sym_alignas] = ACTIONS(2190),
    [anon_sym__Alignas] = ACTIONS(2190),
    [sym_primitive_type] = ACTIONS(2190),
    [anon_sym_enum] = ACTIONS(2190),
    [anon_sym_class] = ACTIONS(2190),
    [anon_sym_struct] = ACTIONS(2190),
    [anon_sym_union] = ACTIONS(2190),
    [anon_sym_if] = ACTIONS(2190),
    [anon_sym_else] = ACTIONS(2190),
    [anon_sym_switch] = ACTIONS(2190),
    [anon_sym_case] = ACTIONS(2190),
    [anon_sym_default] = ACTIONS(2190),
    [anon_sym_while] = ACTIONS(2190),
    [anon_sym_do] = ACTIONS(2190),
    [anon_sym_for] = ACTIONS(2190),
    [anon_sym_return] = ACTIONS(2190),
    [anon_sym_break] = ACTIONS(2190),
    [anon_sym_continue] = ACTIONS(2190),
    [anon_sym_goto] = ACTIONS(2190),
    [anon_sym___try] = ACTIONS(2190),
    [anon_sym___leave] = ACTIONS(2190),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_compl] = ACTIONS(2190),
    [anon_sym_or] = ACTIONS(2190),
    [anon_sym_and] = ACTIONS(2190),
    [anon_sym_DASH_DASH] = ACTIONS(2192),
    [anon_sym_PLUS_PLUS] = ACTIONS(2192),
    [anon_sym_sizeof] = ACTIONS(2190),
    [anon_sym___alignof__] = ACTIONS(2190),
    [anon_sym___alignof] = ACTIONS(2190),
    [anon_sym__alignof] = ACTIONS(2190),
    [anon_sym_alignof] = ACTIONS(2190),
    [anon_sym__Alignof] = ACTIONS(2190),
    [anon_sym_offsetof] = ACTIONS(2190),
    [anon_sym__Generic] = ACTIONS(2190),
    [anon_sym_asm] = ACTIONS(2190),
    [anon_sym___asm__] = ACTIONS(2190),
    [anon_sym_DOT] = ACTIONS(2190),
    [sym_number_literal] = ACTIONS(2192),
    [anon_sym_L_SQUOTE] = ACTIONS(2192),
    [anon_sym_u_SQUOTE] = ACTIONS(2192),
    [anon_sym_U_SQUOTE] = ACTIONS(2192),
    [anon_sym_u8_SQUOTE] = ACTIONS(2192),
    [anon_sym_SQUOTE] = ACTIONS(2192),
    [anon_sym_L_DQUOTE] = ACTIONS(2192),
    [anon_sym_u_DQUOTE] = ACTIONS(2192),
    [anon_sym_U_DQUOTE] = ACTIONS(2192),
    [anon_sym_u8_DQUOTE] = ACTIONS(2192),
    [anon_sym_DQUOTE] = ACTIONS(2192),
    [sym_true] = ACTIONS(2190),
    [sym_false] = ACTIONS(2190),
    [anon_sym_NULL] = ACTIONS(2190),
    [anon_sym_nullptr] = ACTIONS(2190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2190),
    [anon_sym_let] = ACTIONS(2190),
    [anon_sym_This] = ACTIONS(2190),
    [anon_sym_decltype] = ACTIONS(2190),
    [anon_sym_final] = ACTIONS(2190),
    [anon_sym_override] = ACTIONS(2190),
    [sym_virtual] = ACTIONS(2190),
    [anon_sym_explicit] = ACTIONS(2190),
    [anon_sym_typename] = ACTIONS(2190),
    [anon_sym_template] = ACTIONS(2190),
    [anon_sym_GT2] = ACTIONS(2192),
    [anon_sym_operator] = ACTIONS(2190),
    [anon_sym_try] = ACTIONS(2190),
    [anon_sym_delete] = ACTIONS(2190),
    [anon_sym_throw] = ACTIONS(2190),
    [anon_sym_namespace] = ACTIONS(2190),
    [anon_sym_using] = ACTIONS(2190),
    [anon_sym_static_assert] = ACTIONS(2190),
    [anon_sym_concept] = ACTIONS(2190),
    [anon_sym_co_return] = ACTIONS(2190),
    [anon_sym_co_yield] = ACTIONS(2190),
    [anon_sym_R_DQUOTE] = ACTIONS(2192),
    [anon_sym_LR_DQUOTE] = ACTIONS(2192),
    [anon_sym_uR_DQUOTE] = ACTIONS(2192),
    [anon_sym_UR_DQUOTE] = ACTIONS(2192),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2192),
    [anon_sym_co_await] = ACTIONS(2190),
    [anon_sym_new] = ACTIONS(2190),
    [anon_sym_requires] = ACTIONS(2190),
    [sym_this] = ACTIONS(2190),
    [anon_sym_discard] = ACTIONS(2190),
    [anon_sym_precise] = ACTIONS(2190),
    [anon_sym_shared] = ACTIONS(2190),
    [anon_sym_groupshared] = ACTIONS(2190),
    [anon_sym_uniform] = ACTIONS(2190),
    [anon_sym_row_major] = ACTIONS(2190),
    [anon_sym_column_major] = ACTIONS(2190),
    [anon_sym_globallycoherent] = ACTIONS(2190),
    [anon_sym_centroid] = ACTIONS(2190),
    [anon_sym_noperspective] = ACTIONS(2190),
    [anon_sym_nointerpolation] = ACTIONS(2190),
    [anon_sym_sample] = ACTIONS(2190),
    [anon_sym_linear] = ACTIONS(2190),
    [anon_sym_snorm] = ACTIONS(2190),
    [anon_sym_unorm] = ACTIONS(2190),
    [anon_sym_point] = ACTIONS(2190),
    [anon_sym_line] = ACTIONS(2190),
    [anon_sym_triangleadj] = ACTIONS(2190),
    [anon_sym_lineadj] = ACTIONS(2190),
    [anon_sym_triangle] = ACTIONS(2190),
    [anon_sym_cbuffer] = ACTIONS(2190),
    [anon_sym_interface] = ACTIONS(2190),
    [anon_sym_extension] = ACTIONS(2190),
    [anon_sym_where] = ACTIONS(2190),
    [anon_sym___exported] = ACTIONS(2190),
    [anon_sym_import] = ACTIONS(2190),
  },
  [210] = {
    [ts_builtin_sym_end] = ACTIONS(2196),
    [sym_identifier] = ACTIONS(2194),
    [aux_sym_preproc_include_token1] = ACTIONS(2194),
    [aux_sym_preproc_def_token1] = ACTIONS(2194),
    [anon_sym_COMMA] = ACTIONS(2196),
    [anon_sym_RPAREN] = ACTIONS(2196),
    [aux_sym_preproc_if_token1] = ACTIONS(2194),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2194),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2194),
    [sym_preproc_directive] = ACTIONS(2194),
    [anon_sym_LPAREN2] = ACTIONS(2196),
    [anon_sym_BANG] = ACTIONS(2196),
    [anon_sym_TILDE] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2194),
    [anon_sym_PLUS] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(2196),
    [anon_sym_PIPE_PIPE] = ACTIONS(2196),
    [anon_sym_AMP_AMP] = ACTIONS(2196),
    [anon_sym_AMP] = ACTIONS(2194),
    [anon_sym_COLON] = ACTIONS(2194),
    [anon_sym_SEMI] = ACTIONS(2196),
    [anon_sym___extension__] = ACTIONS(2194),
    [anon_sym_typedef] = ACTIONS(2194),
    [anon_sym_in] = ACTIONS(2194),
    [anon_sym_out] = ACTIONS(2194),
    [anon_sym_inout] = ACTIONS(2194),
    [anon_sym_extern] = ACTIONS(2194),
    [anon_sym___attribute__] = ACTIONS(2194),
    [anon_sym_COLON_COLON] = ACTIONS(2196),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2196),
    [anon_sym___declspec] = ACTIONS(2194),
    [anon_sym___based] = ACTIONS(2194),
    [anon_sym___cdecl] = ACTIONS(2194),
    [anon_sym___clrcall] = ACTIONS(2194),
    [anon_sym___stdcall] = ACTIONS(2194),
    [anon_sym___fastcall] = ACTIONS(2194),
    [anon_sym___thiscall] = ACTIONS(2194),
    [anon_sym___vectorcall] = ACTIONS(2194),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_signed] = ACTIONS(2194),
    [anon_sym_unsigned] = ACTIONS(2194),
    [anon_sym_long] = ACTIONS(2194),
    [anon_sym_short] = ACTIONS(2194),
    [anon_sym_LBRACK] = ACTIONS(2194),
    [anon_sym_static] = ACTIONS(2194),
    [anon_sym_EQ] = ACTIONS(2196),
    [anon_sym_register] = ACTIONS(2194),
    [anon_sym_inline] = ACTIONS(2194),
    [anon_sym___inline] = ACTIONS(2194),
    [anon_sym___inline__] = ACTIONS(2194),
    [anon_sym___forceinline] = ACTIONS(2194),
    [anon_sym_thread_local] = ACTIONS(2194),
    [anon_sym___thread] = ACTIONS(2194),
    [anon_sym_const] = ACTIONS(2194),
    [anon_sym_constexpr] = ACTIONS(2194),
    [anon_sym_volatile] = ACTIONS(2194),
    [anon_sym_restrict] = ACTIONS(2194),
    [anon_sym___restrict__] = ACTIONS(2194),
    [anon_sym__Atomic] = ACTIONS(2194),
    [anon_sym__Noreturn] = ACTIONS(2194),
    [anon_sym_noreturn] = ACTIONS(2194),
    [anon_sym_mutable] = ACTIONS(2194),
    [anon_sym_constinit] = ACTIONS(2194),
    [anon_sym_consteval] = ACTIONS(2194),
    [anon_sym_alignas] = ACTIONS(2194),
    [anon_sym__Alignas] = ACTIONS(2194),
    [sym_primitive_type] = ACTIONS(2194),
    [anon_sym_enum] = ACTIONS(2194),
    [anon_sym_class] = ACTIONS(2194),
    [anon_sym_struct] = ACTIONS(2194),
    [anon_sym_union] = ACTIONS(2194),
    [anon_sym_if] = ACTIONS(2194),
    [anon_sym_else] = ACTIONS(2194),
    [anon_sym_switch] = ACTIONS(2194),
    [anon_sym_case] = ACTIONS(2194),
    [anon_sym_default] = ACTIONS(2194),
    [anon_sym_while] = ACTIONS(2194),
    [anon_sym_do] = ACTIONS(2194),
    [anon_sym_for] = ACTIONS(2194),
    [anon_sym_return] = ACTIONS(2194),
    [anon_sym_break] = ACTIONS(2194),
    [anon_sym_continue] = ACTIONS(2194),
    [anon_sym_goto] = ACTIONS(2194),
    [anon_sym___try] = ACTIONS(2194),
    [anon_sym___leave] = ACTIONS(2194),
    [anon_sym_not] = ACTIONS(2194),
    [anon_sym_compl] = ACTIONS(2194),
    [anon_sym_or] = ACTIONS(2194),
    [anon_sym_and] = ACTIONS(2194),
    [anon_sym_DASH_DASH] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2196),
    [anon_sym_sizeof] = ACTIONS(2194),
    [anon_sym___alignof__] = ACTIONS(2194),
    [anon_sym___alignof] = ACTIONS(2194),
    [anon_sym__alignof] = ACTIONS(2194),
    [anon_sym_alignof] = ACTIONS(2194),
    [anon_sym__Alignof] = ACTIONS(2194),
    [anon_sym_offsetof] = ACTIONS(2194),
    [anon_sym__Generic] = ACTIONS(2194),
    [anon_sym_asm] = ACTIONS(2194),
    [anon_sym___asm__] = ACTIONS(2194),
    [anon_sym_DOT] = ACTIONS(2194),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_L_SQUOTE] = ACTIONS(2196),
    [anon_sym_u_SQUOTE] = ACTIONS(2196),
    [anon_sym_U_SQUOTE] = ACTIONS(2196),
    [anon_sym_u8_SQUOTE] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(2196),
    [anon_sym_L_DQUOTE] = ACTIONS(2196),
    [anon_sym_u_DQUOTE] = ACTIONS(2196),
    [anon_sym_U_DQUOTE] = ACTIONS(2196),
    [anon_sym_u8_DQUOTE] = ACTIONS(2196),
    [anon_sym_DQUOTE] = ACTIONS(2196),
    [sym_true] = ACTIONS(2194),
    [sym_false] = ACTIONS(2194),
    [anon_sym_NULL] = ACTIONS(2194),
    [anon_sym_nullptr] = ACTIONS(2194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2194),
    [anon_sym_let] = ACTIONS(2194),
    [anon_sym_This] = ACTIONS(2194),
    [anon_sym_decltype] = ACTIONS(2194),
    [anon_sym_final] = ACTIONS(2194),
    [anon_sym_override] = ACTIONS(2194),
    [sym_virtual] = ACTIONS(2194),
    [anon_sym_explicit] = ACTIONS(2194),
    [anon_sym_typename] = ACTIONS(2194),
    [anon_sym_template] = ACTIONS(2194),
    [anon_sym_GT2] = ACTIONS(2196),
    [anon_sym_operator] = ACTIONS(2194),
    [anon_sym_try] = ACTIONS(2194),
    [anon_sym_delete] = ACTIONS(2194),
    [anon_sym_throw] = ACTIONS(2194),
    [anon_sym_namespace] = ACTIONS(2194),
    [anon_sym_using] = ACTIONS(2194),
    [anon_sym_static_assert] = ACTIONS(2194),
    [anon_sym_concept] = ACTIONS(2194),
    [anon_sym_co_return] = ACTIONS(2194),
    [anon_sym_co_yield] = ACTIONS(2194),
    [anon_sym_R_DQUOTE] = ACTIONS(2196),
    [anon_sym_LR_DQUOTE] = ACTIONS(2196),
    [anon_sym_uR_DQUOTE] = ACTIONS(2196),
    [anon_sym_UR_DQUOTE] = ACTIONS(2196),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2196),
    [anon_sym_co_await] = ACTIONS(2194),
    [anon_sym_new] = ACTIONS(2194),
    [anon_sym_requires] = ACTIONS(2194),
    [sym_this] = ACTIONS(2194),
    [anon_sym_discard] = ACTIONS(2194),
    [anon_sym_precise] = ACTIONS(2194),
    [anon_sym_shared] = ACTIONS(2194),
    [anon_sym_groupshared] = ACTIONS(2194),
    [anon_sym_uniform] = ACTIONS(2194),
    [anon_sym_row_major] = ACTIONS(2194),
    [anon_sym_column_major] = ACTIONS(2194),
    [anon_sym_globallycoherent] = ACTIONS(2194),
    [anon_sym_centroid] = ACTIONS(2194),
    [anon_sym_noperspective] = ACTIONS(2194),
    [anon_sym_nointerpolation] = ACTIONS(2194),
    [anon_sym_sample] = ACTIONS(2194),
    [anon_sym_linear] = ACTIONS(2194),
    [anon_sym_snorm] = ACTIONS(2194),
    [anon_sym_unorm] = ACTIONS(2194),
    [anon_sym_point] = ACTIONS(2194),
    [anon_sym_line] = ACTIONS(2194),
    [anon_sym_triangleadj] = ACTIONS(2194),
    [anon_sym_lineadj] = ACTIONS(2194),
    [anon_sym_triangle] = ACTIONS(2194),
    [anon_sym_cbuffer] = ACTIONS(2194),
    [anon_sym_interface] = ACTIONS(2194),
    [anon_sym_extension] = ACTIONS(2194),
    [anon_sym_where] = ACTIONS(2194),
    [anon_sym___exported] = ACTIONS(2194),
    [anon_sym_import] = ACTIONS(2194),
  },
  [211] = {
    [ts_builtin_sym_end] = ACTIONS(2200),
    [sym_identifier] = ACTIONS(2198),
    [aux_sym_preproc_include_token1] = ACTIONS(2198),
    [aux_sym_preproc_def_token1] = ACTIONS(2198),
    [anon_sym_COMMA] = ACTIONS(2200),
    [anon_sym_RPAREN] = ACTIONS(2200),
    [aux_sym_preproc_if_token1] = ACTIONS(2198),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2198),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2198),
    [sym_preproc_directive] = ACTIONS(2198),
    [anon_sym_LPAREN2] = ACTIONS(2200),
    [anon_sym_BANG] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(2200),
    [anon_sym_PIPE_PIPE] = ACTIONS(2200),
    [anon_sym_AMP_AMP] = ACTIONS(2200),
    [anon_sym_AMP] = ACTIONS(2198),
    [anon_sym_COLON] = ACTIONS(2198),
    [anon_sym_SEMI] = ACTIONS(2200),
    [anon_sym___extension__] = ACTIONS(2198),
    [anon_sym_typedef] = ACTIONS(2198),
    [anon_sym_in] = ACTIONS(2198),
    [anon_sym_out] = ACTIONS(2198),
    [anon_sym_inout] = ACTIONS(2198),
    [anon_sym_extern] = ACTIONS(2198),
    [anon_sym___attribute__] = ACTIONS(2198),
    [anon_sym_COLON_COLON] = ACTIONS(2200),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2200),
    [anon_sym___declspec] = ACTIONS(2198),
    [anon_sym___based] = ACTIONS(2198),
    [anon_sym___cdecl] = ACTIONS(2198),
    [anon_sym___clrcall] = ACTIONS(2198),
    [anon_sym___stdcall] = ACTIONS(2198),
    [anon_sym___fastcall] = ACTIONS(2198),
    [anon_sym___thiscall] = ACTIONS(2198),
    [anon_sym___vectorcall] = ACTIONS(2198),
    [anon_sym_LBRACE] = ACTIONS(2200),
    [anon_sym_signed] = ACTIONS(2198),
    [anon_sym_unsigned] = ACTIONS(2198),
    [anon_sym_long] = ACTIONS(2198),
    [anon_sym_short] = ACTIONS(2198),
    [anon_sym_LBRACK] = ACTIONS(2198),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_EQ] = ACTIONS(2200),
    [anon_sym_register] = ACTIONS(2198),
    [anon_sym_inline] = ACTIONS(2198),
    [anon_sym___inline] = ACTIONS(2198),
    [anon_sym___inline__] = ACTIONS(2198),
    [anon_sym___forceinline] = ACTIONS(2198),
    [anon_sym_thread_local] = ACTIONS(2198),
    [anon_sym___thread] = ACTIONS(2198),
    [anon_sym_const] = ACTIONS(2198),
    [anon_sym_constexpr] = ACTIONS(2198),
    [anon_sym_volatile] = ACTIONS(2198),
    [anon_sym_restrict] = ACTIONS(2198),
    [anon_sym___restrict__] = ACTIONS(2198),
    [anon_sym__Atomic] = ACTIONS(2198),
    [anon_sym__Noreturn] = ACTIONS(2198),
    [anon_sym_noreturn] = ACTIONS(2198),
    [anon_sym_mutable] = ACTIONS(2198),
    [anon_sym_constinit] = ACTIONS(2198),
    [anon_sym_consteval] = ACTIONS(2198),
    [anon_sym_alignas] = ACTIONS(2198),
    [anon_sym__Alignas] = ACTIONS(2198),
    [sym_primitive_type] = ACTIONS(2198),
    [anon_sym_enum] = ACTIONS(2198),
    [anon_sym_class] = ACTIONS(2198),
    [anon_sym_struct] = ACTIONS(2198),
    [anon_sym_union] = ACTIONS(2198),
    [anon_sym_if] = ACTIONS(2198),
    [anon_sym_else] = ACTIONS(2198),
    [anon_sym_switch] = ACTIONS(2198),
    [anon_sym_case] = ACTIONS(2198),
    [anon_sym_default] = ACTIONS(2198),
    [anon_sym_while] = ACTIONS(2198),
    [anon_sym_do] = ACTIONS(2198),
    [anon_sym_for] = ACTIONS(2198),
    [anon_sym_return] = ACTIONS(2198),
    [anon_sym_break] = ACTIONS(2198),
    [anon_sym_continue] = ACTIONS(2198),
    [anon_sym_goto] = ACTIONS(2198),
    [anon_sym___try] = ACTIONS(2198),
    [anon_sym___leave] = ACTIONS(2198),
    [anon_sym_not] = ACTIONS(2198),
    [anon_sym_compl] = ACTIONS(2198),
    [anon_sym_or] = ACTIONS(2198),
    [anon_sym_and] = ACTIONS(2198),
    [anon_sym_DASH_DASH] = ACTIONS(2200),
    [anon_sym_PLUS_PLUS] = ACTIONS(2200),
    [anon_sym_sizeof] = ACTIONS(2198),
    [anon_sym___alignof__] = ACTIONS(2198),
    [anon_sym___alignof] = ACTIONS(2198),
    [anon_sym__alignof] = ACTIONS(2198),
    [anon_sym_alignof] = ACTIONS(2198),
    [anon_sym__Alignof] = ACTIONS(2198),
    [anon_sym_offsetof] = ACTIONS(2198),
    [anon_sym__Generic] = ACTIONS(2198),
    [anon_sym_asm] = ACTIONS(2198),
    [anon_sym___asm__] = ACTIONS(2198),
    [anon_sym_DOT] = ACTIONS(2198),
    [sym_number_literal] = ACTIONS(2200),
    [anon_sym_L_SQUOTE] = ACTIONS(2200),
    [anon_sym_u_SQUOTE] = ACTIONS(2200),
    [anon_sym_U_SQUOTE] = ACTIONS(2200),
    [anon_sym_u8_SQUOTE] = ACTIONS(2200),
    [anon_sym_SQUOTE] = ACTIONS(2200),
    [anon_sym_L_DQUOTE] = ACTIONS(2200),
    [anon_sym_u_DQUOTE] = ACTIONS(2200),
    [anon_sym_U_DQUOTE] = ACTIONS(2200),
    [anon_sym_u8_DQUOTE] = ACTIONS(2200),
    [anon_sym_DQUOTE] = ACTIONS(2200),
    [sym_true] = ACTIONS(2198),
    [sym_false] = ACTIONS(2198),
    [anon_sym_NULL] = ACTIONS(2198),
    [anon_sym_nullptr] = ACTIONS(2198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2198),
    [anon_sym_let] = ACTIONS(2198),
    [anon_sym_This] = ACTIONS(2198),
    [anon_sym_decltype] = ACTIONS(2198),
    [anon_sym_final] = ACTIONS(2198),
    [anon_sym_override] = ACTIONS(2198),
    [sym_virtual] = ACTIONS(2198),
    [anon_sym_explicit] = ACTIONS(2198),
    [anon_sym_typename] = ACTIONS(2198),
    [anon_sym_template] = ACTIONS(2198),
    [anon_sym_GT2] = ACTIONS(2200),
    [anon_sym_operator] = ACTIONS(2198),
    [anon_sym_try] = ACTIONS(2198),
    [anon_sym_delete] = ACTIONS(2198),
    [anon_sym_throw] = ACTIONS(2198),
    [anon_sym_namespace] = ACTIONS(2198),
    [anon_sym_using] = ACTIONS(2198),
    [anon_sym_static_assert] = ACTIONS(2198),
    [anon_sym_concept] = ACTIONS(2198),
    [anon_sym_co_return] = ACTIONS(2198),
    [anon_sym_co_yield] = ACTIONS(2198),
    [anon_sym_R_DQUOTE] = ACTIONS(2200),
    [anon_sym_LR_DQUOTE] = ACTIONS(2200),
    [anon_sym_uR_DQUOTE] = ACTIONS(2200),
    [anon_sym_UR_DQUOTE] = ACTIONS(2200),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2200),
    [anon_sym_co_await] = ACTIONS(2198),
    [anon_sym_new] = ACTIONS(2198),
    [anon_sym_requires] = ACTIONS(2198),
    [sym_this] = ACTIONS(2198),
    [anon_sym_discard] = ACTIONS(2198),
    [anon_sym_precise] = ACTIONS(2198),
    [anon_sym_shared] = ACTIONS(2198),
    [anon_sym_groupshared] = ACTIONS(2198),
    [anon_sym_uniform] = ACTIONS(2198),
    [anon_sym_row_major] = ACTIONS(2198),
    [anon_sym_column_major] = ACTIONS(2198),
    [anon_sym_globallycoherent] = ACTIONS(2198),
    [anon_sym_centroid] = ACTIONS(2198),
    [anon_sym_noperspective] = ACTIONS(2198),
    [anon_sym_nointerpolation] = ACTIONS(2198),
    [anon_sym_sample] = ACTIONS(2198),
    [anon_sym_linear] = ACTIONS(2198),
    [anon_sym_snorm] = ACTIONS(2198),
    [anon_sym_unorm] = ACTIONS(2198),
    [anon_sym_point] = ACTIONS(2198),
    [anon_sym_line] = ACTIONS(2198),
    [anon_sym_triangleadj] = ACTIONS(2198),
    [anon_sym_lineadj] = ACTIONS(2198),
    [anon_sym_triangle] = ACTIONS(2198),
    [anon_sym_cbuffer] = ACTIONS(2198),
    [anon_sym_interface] = ACTIONS(2198),
    [anon_sym_extension] = ACTIONS(2198),
    [anon_sym_where] = ACTIONS(2198),
    [anon_sym___exported] = ACTIONS(2198),
    [anon_sym_import] = ACTIONS(2198),
  },
  [212] = {
    [ts_builtin_sym_end] = ACTIONS(2217),
    [sym_identifier] = ACTIONS(2210),
    [aux_sym_preproc_include_token1] = ACTIONS(2210),
    [aux_sym_preproc_def_token1] = ACTIONS(2210),
    [anon_sym_COMMA] = ACTIONS(2217),
    [anon_sym_RPAREN] = ACTIONS(2217),
    [aux_sym_preproc_if_token1] = ACTIONS(2210),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2210),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2210),
    [sym_preproc_directive] = ACTIONS(2210),
    [anon_sym_LPAREN2] = ACTIONS(2217),
    [anon_sym_BANG] = ACTIONS(2217),
    [anon_sym_TILDE] = ACTIONS(2217),
    [anon_sym_DASH] = ACTIONS(2210),
    [anon_sym_PLUS] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(2217),
    [anon_sym_PIPE_PIPE] = ACTIONS(2217),
    [anon_sym_AMP_AMP] = ACTIONS(2217),
    [anon_sym_AMP] = ACTIONS(2210),
    [anon_sym_COLON] = ACTIONS(2210),
    [anon_sym_SEMI] = ACTIONS(2217),
    [anon_sym___extension__] = ACTIONS(2210),
    [anon_sym_typedef] = ACTIONS(2210),
    [anon_sym_in] = ACTIONS(2210),
    [anon_sym_out] = ACTIONS(2210),
    [anon_sym_inout] = ACTIONS(2210),
    [anon_sym_extern] = ACTIONS(2210),
    [anon_sym___attribute__] = ACTIONS(2210),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2217),
    [anon_sym___declspec] = ACTIONS(2210),
    [anon_sym___based] = ACTIONS(2210),
    [anon_sym___cdecl] = ACTIONS(2210),
    [anon_sym___clrcall] = ACTIONS(2210),
    [anon_sym___stdcall] = ACTIONS(2210),
    [anon_sym___fastcall] = ACTIONS(2210),
    [anon_sym___thiscall] = ACTIONS(2210),
    [anon_sym___vectorcall] = ACTIONS(2210),
    [anon_sym_LBRACE] = ACTIONS(2217),
    [anon_sym_signed] = ACTIONS(2210),
    [anon_sym_unsigned] = ACTIONS(2210),
    [anon_sym_long] = ACTIONS(2210),
    [anon_sym_short] = ACTIONS(2210),
    [anon_sym_LBRACK] = ACTIONS(2210),
    [anon_sym_static] = ACTIONS(2210),
    [anon_sym_EQ] = ACTIONS(2217),
    [anon_sym_register] = ACTIONS(2210),
    [anon_sym_inline] = ACTIONS(2210),
    [anon_sym___inline] = ACTIONS(2210),
    [anon_sym___inline__] = ACTIONS(2210),
    [anon_sym___forceinline] = ACTIONS(2210),
    [anon_sym_thread_local] = ACTIONS(2210),
    [anon_sym___thread] = ACTIONS(2210),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_constexpr] = ACTIONS(2210),
    [anon_sym_volatile] = ACTIONS(2210),
    [anon_sym_restrict] = ACTIONS(2210),
    [anon_sym___restrict__] = ACTIONS(2210),
    [anon_sym__Atomic] = ACTIONS(2210),
    [anon_sym__Noreturn] = ACTIONS(2210),
    [anon_sym_noreturn] = ACTIONS(2210),
    [anon_sym_mutable] = ACTIONS(2210),
    [anon_sym_constinit] = ACTIONS(2210),
    [anon_sym_consteval] = ACTIONS(2210),
    [anon_sym_alignas] = ACTIONS(2210),
    [anon_sym__Alignas] = ACTIONS(2210),
    [sym_primitive_type] = ACTIONS(2210),
    [anon_sym_enum] = ACTIONS(2210),
    [anon_sym_class] = ACTIONS(2210),
    [anon_sym_struct] = ACTIONS(2210),
    [anon_sym_union] = ACTIONS(2210),
    [anon_sym_if] = ACTIONS(2210),
    [anon_sym_else] = ACTIONS(2210),
    [anon_sym_switch] = ACTIONS(2210),
    [anon_sym_case] = ACTIONS(2210),
    [anon_sym_default] = ACTIONS(2210),
    [anon_sym_while] = ACTIONS(2210),
    [anon_sym_do] = ACTIONS(2210),
    [anon_sym_for] = ACTIONS(2210),
    [anon_sym_return] = ACTIONS(2210),
    [anon_sym_break] = ACTIONS(2210),
    [anon_sym_continue] = ACTIONS(2210),
    [anon_sym_goto] = ACTIONS(2210),
    [anon_sym___try] = ACTIONS(2210),
    [anon_sym___leave] = ACTIONS(2210),
    [anon_sym_not] = ACTIONS(2210),
    [anon_sym_compl] = ACTIONS(2210),
    [anon_sym_or] = ACTIONS(2210),
    [anon_sym_and] = ACTIONS(2210),
    [anon_sym_DASH_DASH] = ACTIONS(2217),
    [anon_sym_PLUS_PLUS] = ACTIONS(2217),
    [anon_sym_sizeof] = ACTIONS(2210),
    [anon_sym___alignof__] = ACTIONS(2210),
    [anon_sym___alignof] = ACTIONS(2210),
    [anon_sym__alignof] = ACTIONS(2210),
    [anon_sym_alignof] = ACTIONS(2210),
    [anon_sym__Alignof] = ACTIONS(2210),
    [anon_sym_offsetof] = ACTIONS(2210),
    [anon_sym__Generic] = ACTIONS(2210),
    [anon_sym_asm] = ACTIONS(2210),
    [anon_sym___asm__] = ACTIONS(2210),
    [anon_sym_DOT] = ACTIONS(2210),
    [sym_number_literal] = ACTIONS(2217),
    [anon_sym_L_SQUOTE] = ACTIONS(2217),
    [anon_sym_u_SQUOTE] = ACTIONS(2217),
    [anon_sym_U_SQUOTE] = ACTIONS(2217),
    [anon_sym_u8_SQUOTE] = ACTIONS(2217),
    [anon_sym_SQUOTE] = ACTIONS(2217),
    [anon_sym_L_DQUOTE] = ACTIONS(2217),
    [anon_sym_u_DQUOTE] = ACTIONS(2217),
    [anon_sym_U_DQUOTE] = ACTIONS(2217),
    [anon_sym_u8_DQUOTE] = ACTIONS(2217),
    [anon_sym_DQUOTE] = ACTIONS(2217),
    [sym_true] = ACTIONS(2210),
    [sym_false] = ACTIONS(2210),
    [anon_sym_NULL] = ACTIONS(2210),
    [anon_sym_nullptr] = ACTIONS(2210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2210),
    [anon_sym_let] = ACTIONS(2210),
    [anon_sym_This] = ACTIONS(2210),
    [anon_sym_decltype] = ACTIONS(2210),
    [anon_sym_final] = ACTIONS(2210),
    [anon_sym_override] = ACTIONS(2210),
    [sym_virtual] = ACTIONS(2210),
    [anon_sym_explicit] = ACTIONS(2210),
    [anon_sym_typename] = ACTIONS(2210),
    [anon_sym_template] = ACTIONS(2210),
    [anon_sym_GT2] = ACTIONS(2217),
    [anon_sym_operator] = ACTIONS(2210),
    [anon_sym_try] = ACTIONS(2210),
    [anon_sym_delete] = ACTIONS(2210),
    [anon_sym_throw] = ACTIONS(2210),
    [anon_sym_namespace] = ACTIONS(2210),
    [anon_sym_using] = ACTIONS(2210),
    [anon_sym_static_assert] = ACTIONS(2210),
    [anon_sym_concept] = ACTIONS(2210),
    [anon_sym_co_return] = ACTIONS(2210),
    [anon_sym_co_yield] = ACTIONS(2210),
    [anon_sym_R_DQUOTE] = ACTIONS(2217),
    [anon_sym_LR_DQUOTE] = ACTIONS(2217),
    [anon_sym_uR_DQUOTE] = ACTIONS(2217),
    [anon_sym_UR_DQUOTE] = ACTIONS(2217),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2217),
    [anon_sym_co_await] = ACTIONS(2210),
    [anon_sym_new] = ACTIONS(2210),
    [anon_sym_requires] = ACTIONS(2210),
    [sym_this] = ACTIONS(2210),
    [anon_sym_discard] = ACTIONS(2210),
    [anon_sym_precise] = ACTIONS(2210),
    [anon_sym_shared] = ACTIONS(2210),
    [anon_sym_groupshared] = ACTIONS(2210),
    [anon_sym_uniform] = ACTIONS(2210),
    [anon_sym_row_major] = ACTIONS(2210),
    [anon_sym_column_major] = ACTIONS(2210),
    [anon_sym_globallycoherent] = ACTIONS(2210),
    [anon_sym_centroid] = ACTIONS(2210),
    [anon_sym_noperspective] = ACTIONS(2210),
    [anon_sym_nointerpolation] = ACTIONS(2210),
    [anon_sym_sample] = ACTIONS(2210),
    [anon_sym_linear] = ACTIONS(2210),
    [anon_sym_snorm] = ACTIONS(2210),
    [anon_sym_unorm] = ACTIONS(2210),
    [anon_sym_point] = ACTIONS(2210),
    [anon_sym_line] = ACTIONS(2210),
    [anon_sym_triangleadj] = ACTIONS(2210),
    [anon_sym_lineadj] = ACTIONS(2210),
    [anon_sym_triangle] = ACTIONS(2210),
    [anon_sym_cbuffer] = ACTIONS(2210),
    [anon_sym_interface] = ACTIONS(2210),
    [anon_sym_extension] = ACTIONS(2210),
    [anon_sym_where] = ACTIONS(2210),
    [anon_sym___exported] = ACTIONS(2210),
    [anon_sym_import] = ACTIONS(2210),
  },
  [213] = {
    [ts_builtin_sym_end] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(2240),
    [aux_sym_preproc_include_token1] = ACTIONS(2240),
    [aux_sym_preproc_def_token1] = ACTIONS(2240),
    [anon_sym_COMMA] = ACTIONS(2242),
    [anon_sym_RPAREN] = ACTIONS(2242),
    [aux_sym_preproc_if_token1] = ACTIONS(2240),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2240),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2240),
    [sym_preproc_directive] = ACTIONS(2240),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2242),
    [anon_sym_TILDE] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2240),
    [anon_sym_PLUS] = ACTIONS(2240),
    [anon_sym_STAR] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_AMP] = ACTIONS(2240),
    [anon_sym_COLON] = ACTIONS(2240),
    [anon_sym_SEMI] = ACTIONS(2242),
    [anon_sym___extension__] = ACTIONS(2240),
    [anon_sym_typedef] = ACTIONS(2240),
    [anon_sym_in] = ACTIONS(2240),
    [anon_sym_out] = ACTIONS(2240),
    [anon_sym_inout] = ACTIONS(2240),
    [anon_sym_extern] = ACTIONS(2240),
    [anon_sym___attribute__] = ACTIONS(2240),
    [anon_sym_COLON_COLON] = ACTIONS(2242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2242),
    [anon_sym___declspec] = ACTIONS(2240),
    [anon_sym___based] = ACTIONS(2240),
    [anon_sym___cdecl] = ACTIONS(2240),
    [anon_sym___clrcall] = ACTIONS(2240),
    [anon_sym___stdcall] = ACTIONS(2240),
    [anon_sym___fastcall] = ACTIONS(2240),
    [anon_sym___thiscall] = ACTIONS(2240),
    [anon_sym___vectorcall] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_signed] = ACTIONS(2240),
    [anon_sym_unsigned] = ACTIONS(2240),
    [anon_sym_long] = ACTIONS(2240),
    [anon_sym_short] = ACTIONS(2240),
    [anon_sym_LBRACK] = ACTIONS(2240),
    [anon_sym_static] = ACTIONS(2240),
    [anon_sym_EQ] = ACTIONS(2242),
    [anon_sym_register] = ACTIONS(2240),
    [anon_sym_inline] = ACTIONS(2240),
    [anon_sym___inline] = ACTIONS(2240),
    [anon_sym___inline__] = ACTIONS(2240),
    [anon_sym___forceinline] = ACTIONS(2240),
    [anon_sym_thread_local] = ACTIONS(2240),
    [anon_sym___thread] = ACTIONS(2240),
    [anon_sym_const] = ACTIONS(2240),
    [anon_sym_constexpr] = ACTIONS(2240),
    [anon_sym_volatile] = ACTIONS(2240),
    [anon_sym_restrict] = ACTIONS(2240),
    [anon_sym___restrict__] = ACTIONS(2240),
    [anon_sym__Atomic] = ACTIONS(2240),
    [anon_sym__Noreturn] = ACTIONS(2240),
    [anon_sym_noreturn] = ACTIONS(2240),
    [anon_sym_mutable] = ACTIONS(2240),
    [anon_sym_constinit] = ACTIONS(2240),
    [anon_sym_consteval] = ACTIONS(2240),
    [anon_sym_alignas] = ACTIONS(2240),
    [anon_sym__Alignas] = ACTIONS(2240),
    [sym_primitive_type] = ACTIONS(2240),
    [anon_sym_enum] = ACTIONS(2240),
    [anon_sym_class] = ACTIONS(2240),
    [anon_sym_struct] = ACTIONS(2240),
    [anon_sym_union] = ACTIONS(2240),
    [anon_sym_if] = ACTIONS(2240),
    [anon_sym_else] = ACTIONS(2240),
    [anon_sym_switch] = ACTIONS(2240),
    [anon_sym_case] = ACTIONS(2240),
    [anon_sym_default] = ACTIONS(2240),
    [anon_sym_while] = ACTIONS(2240),
    [anon_sym_do] = ACTIONS(2240),
    [anon_sym_for] = ACTIONS(2240),
    [anon_sym_return] = ACTIONS(2240),
    [anon_sym_break] = ACTIONS(2240),
    [anon_sym_continue] = ACTIONS(2240),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym___try] = ACTIONS(2240),
    [anon_sym___leave] = ACTIONS(2240),
    [anon_sym_not] = ACTIONS(2240),
    [anon_sym_compl] = ACTIONS(2240),
    [anon_sym_or] = ACTIONS(2240),
    [anon_sym_and] = ACTIONS(2240),
    [anon_sym_DASH_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_PLUS] = ACTIONS(2242),
    [anon_sym_sizeof] = ACTIONS(2240),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2240),
    [anon_sym__Generic] = ACTIONS(2240),
    [anon_sym_asm] = ACTIONS(2240),
    [anon_sym___asm__] = ACTIONS(2240),
    [anon_sym_DOT] = ACTIONS(2240),
    [sym_number_literal] = ACTIONS(2242),
    [anon_sym_L_SQUOTE] = ACTIONS(2242),
    [anon_sym_u_SQUOTE] = ACTIONS(2242),
    [anon_sym_U_SQUOTE] = ACTIONS(2242),
    [anon_sym_u8_SQUOTE] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(2242),
    [anon_sym_L_DQUOTE] = ACTIONS(2242),
    [anon_sym_u_DQUOTE] = ACTIONS(2242),
    [anon_sym_U_DQUOTE] = ACTIONS(2242),
    [anon_sym_u8_DQUOTE] = ACTIONS(2242),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [sym_true] = ACTIONS(2240),
    [sym_false] = ACTIONS(2240),
    [anon_sym_NULL] = ACTIONS(2240),
    [anon_sym_nullptr] = ACTIONS(2240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2240),
    [anon_sym_let] = ACTIONS(2240),
    [anon_sym_This] = ACTIONS(2240),
    [anon_sym_decltype] = ACTIONS(2240),
    [anon_sym_final] = ACTIONS(2240),
    [anon_sym_override] = ACTIONS(2240),
    [sym_virtual] = ACTIONS(2240),
    [anon_sym_explicit] = ACTIONS(2240),
    [anon_sym_typename] = ACTIONS(2240),
    [anon_sym_template] = ACTIONS(2240),
    [anon_sym_GT2] = ACTIONS(2242),
    [anon_sym_operator] = ACTIONS(2240),
    [anon_sym_try] = ACTIONS(2240),
    [anon_sym_delete] = ACTIONS(2240),
    [anon_sym_throw] = ACTIONS(2240),
    [anon_sym_namespace] = ACTIONS(2240),
    [anon_sym_using] = ACTIONS(2240),
    [anon_sym_static_assert] = ACTIONS(2240),
    [anon_sym_concept] = ACTIONS(2240),
    [anon_sym_co_return] = ACTIONS(2240),
    [anon_sym_co_yield] = ACTIONS(2240),
    [anon_sym_R_DQUOTE] = ACTIONS(2242),
    [anon_sym_LR_DQUOTE] = ACTIONS(2242),
    [anon_sym_uR_DQUOTE] = ACTIONS(2242),
    [anon_sym_UR_DQUOTE] = ACTIONS(2242),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2242),
    [anon_sym_co_await] = ACTIONS(2240),
    [anon_sym_new] = ACTIONS(2240),
    [anon_sym_requires] = ACTIONS(2240),
    [sym_this] = ACTIONS(2240),
    [anon_sym_discard] = ACTIONS(2240),
    [anon_sym_precise] = ACTIONS(2240),
    [anon_sym_shared] = ACTIONS(2240),
    [anon_sym_groupshared] = ACTIONS(2240),
    [anon_sym_uniform] = ACTIONS(2240),
    [anon_sym_row_major] = ACTIONS(2240),
    [anon_sym_column_major] = ACTIONS(2240),
    [anon_sym_globallycoherent] = ACTIONS(2240),
    [anon_sym_centroid] = ACTIONS(2240),
    [anon_sym_noperspective] = ACTIONS(2240),
    [anon_sym_nointerpolation] = ACTIONS(2240),
    [anon_sym_sample] = ACTIONS(2240),
    [anon_sym_linear] = ACTIONS(2240),
    [anon_sym_snorm] = ACTIONS(2240),
    [anon_sym_unorm] = ACTIONS(2240),
    [anon_sym_point] = ACTIONS(2240),
    [anon_sym_line] = ACTIONS(2240),
    [anon_sym_triangleadj] = ACTIONS(2240),
    [anon_sym_lineadj] = ACTIONS(2240),
    [anon_sym_triangle] = ACTIONS(2240),
    [anon_sym_cbuffer] = ACTIONS(2240),
    [anon_sym_interface] = ACTIONS(2240),
    [anon_sym_extension] = ACTIONS(2240),
    [anon_sym_where] = ACTIONS(2240),
    [anon_sym___exported] = ACTIONS(2240),
    [anon_sym_import] = ACTIONS(2240),
  },
  [214] = {
    [ts_builtin_sym_end] = ACTIONS(2250),
    [sym_identifier] = ACTIONS(2248),
    [aux_sym_preproc_include_token1] = ACTIONS(2248),
    [aux_sym_preproc_def_token1] = ACTIONS(2248),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_RPAREN] = ACTIONS(2250),
    [aux_sym_preproc_if_token1] = ACTIONS(2248),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2248),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2248),
    [sym_preproc_directive] = ACTIONS(2248),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2248),
    [anon_sym_PLUS] = ACTIONS(2248),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2248),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym___extension__] = ACTIONS(2248),
    [anon_sym_typedef] = ACTIONS(2248),
    [anon_sym_in] = ACTIONS(2248),
    [anon_sym_out] = ACTIONS(2248),
    [anon_sym_inout] = ACTIONS(2248),
    [anon_sym_extern] = ACTIONS(2248),
    [anon_sym___attribute__] = ACTIONS(2248),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2250),
    [anon_sym___declspec] = ACTIONS(2248),
    [anon_sym___based] = ACTIONS(2248),
    [anon_sym___cdecl] = ACTIONS(2248),
    [anon_sym___clrcall] = ACTIONS(2248),
    [anon_sym___stdcall] = ACTIONS(2248),
    [anon_sym___fastcall] = ACTIONS(2248),
    [anon_sym___thiscall] = ACTIONS(2248),
    [anon_sym___vectorcall] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_signed] = ACTIONS(2248),
    [anon_sym_unsigned] = ACTIONS(2248),
    [anon_sym_long] = ACTIONS(2248),
    [anon_sym_short] = ACTIONS(2248),
    [anon_sym_LBRACK] = ACTIONS(2248),
    [anon_sym_static] = ACTIONS(2248),
    [anon_sym_EQ] = ACTIONS(2250),
    [anon_sym_register] = ACTIONS(2248),
    [anon_sym_inline] = ACTIONS(2248),
    [anon_sym___inline] = ACTIONS(2248),
    [anon_sym___inline__] = ACTIONS(2248),
    [anon_sym___forceinline] = ACTIONS(2248),
    [anon_sym_thread_local] = ACTIONS(2248),
    [anon_sym___thread] = ACTIONS(2248),
    [anon_sym_const] = ACTIONS(2248),
    [anon_sym_constexpr] = ACTIONS(2248),
    [anon_sym_volatile] = ACTIONS(2248),
    [anon_sym_restrict] = ACTIONS(2248),
    [anon_sym___restrict__] = ACTIONS(2248),
    [anon_sym__Atomic] = ACTIONS(2248),
    [anon_sym__Noreturn] = ACTIONS(2248),
    [anon_sym_noreturn] = ACTIONS(2248),
    [anon_sym_mutable] = ACTIONS(2248),
    [anon_sym_constinit] = ACTIONS(2248),
    [anon_sym_consteval] = ACTIONS(2248),
    [anon_sym_alignas] = ACTIONS(2248),
    [anon_sym__Alignas] = ACTIONS(2248),
    [sym_primitive_type] = ACTIONS(2248),
    [anon_sym_enum] = ACTIONS(2248),
    [anon_sym_class] = ACTIONS(2248),
    [anon_sym_struct] = ACTIONS(2248),
    [anon_sym_union] = ACTIONS(2248),
    [anon_sym_if] = ACTIONS(2248),
    [anon_sym_else] = ACTIONS(2248),
    [anon_sym_switch] = ACTIONS(2248),
    [anon_sym_case] = ACTIONS(2248),
    [anon_sym_default] = ACTIONS(2248),
    [anon_sym_while] = ACTIONS(2248),
    [anon_sym_do] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2248),
    [anon_sym_break] = ACTIONS(2248),
    [anon_sym_continue] = ACTIONS(2248),
    [anon_sym_goto] = ACTIONS(2248),
    [anon_sym___try] = ACTIONS(2248),
    [anon_sym___leave] = ACTIONS(2248),
    [anon_sym_not] = ACTIONS(2248),
    [anon_sym_compl] = ACTIONS(2248),
    [anon_sym_or] = ACTIONS(2248),
    [anon_sym_and] = ACTIONS(2248),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_sizeof] = ACTIONS(2248),
    [anon_sym___alignof__] = ACTIONS(2248),
    [anon_sym___alignof] = ACTIONS(2248),
    [anon_sym__alignof] = ACTIONS(2248),
    [anon_sym_alignof] = ACTIONS(2248),
    [anon_sym__Alignof] = ACTIONS(2248),
    [anon_sym_offsetof] = ACTIONS(2248),
    [anon_sym__Generic] = ACTIONS(2248),
    [anon_sym_asm] = ACTIONS(2248),
    [anon_sym___asm__] = ACTIONS(2248),
    [anon_sym_DOT] = ACTIONS(2248),
    [sym_number_literal] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2250),
    [anon_sym_u_SQUOTE] = ACTIONS(2250),
    [anon_sym_U_SQUOTE] = ACTIONS(2250),
    [anon_sym_u8_SQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym_L_DQUOTE] = ACTIONS(2250),
    [anon_sym_u_DQUOTE] = ACTIONS(2250),
    [anon_sym_U_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [sym_true] = ACTIONS(2248),
    [sym_false] = ACTIONS(2248),
    [anon_sym_NULL] = ACTIONS(2248),
    [anon_sym_nullptr] = ACTIONS(2248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2248),
    [anon_sym_let] = ACTIONS(2248),
    [anon_sym_This] = ACTIONS(2248),
    [anon_sym_decltype] = ACTIONS(2248),
    [anon_sym_final] = ACTIONS(2248),
    [anon_sym_override] = ACTIONS(2248),
    [sym_virtual] = ACTIONS(2248),
    [anon_sym_explicit] = ACTIONS(2248),
    [anon_sym_typename] = ACTIONS(2248),
    [anon_sym_template] = ACTIONS(2248),
    [anon_sym_GT2] = ACTIONS(2250),
    [anon_sym_operator] = ACTIONS(2248),
    [anon_sym_try] = ACTIONS(2248),
    [anon_sym_delete] = ACTIONS(2248),
    [anon_sym_throw] = ACTIONS(2248),
    [anon_sym_namespace] = ACTIONS(2248),
    [anon_sym_using] = ACTIONS(2248),
    [anon_sym_static_assert] = ACTIONS(2248),
    [anon_sym_concept] = ACTIONS(2248),
    [anon_sym_co_return] = ACTIONS(2248),
    [anon_sym_co_yield] = ACTIONS(2248),
    [anon_sym_R_DQUOTE] = ACTIONS(2250),
    [anon_sym_LR_DQUOTE] = ACTIONS(2250),
    [anon_sym_uR_DQUOTE] = ACTIONS(2250),
    [anon_sym_UR_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2250),
    [anon_sym_co_await] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2248),
    [anon_sym_requires] = ACTIONS(2248),
    [sym_this] = ACTIONS(2248),
    [anon_sym_discard] = ACTIONS(2248),
    [anon_sym_precise] = ACTIONS(2248),
    [anon_sym_shared] = ACTIONS(2248),
    [anon_sym_groupshared] = ACTIONS(2248),
    [anon_sym_uniform] = ACTIONS(2248),
    [anon_sym_row_major] = ACTIONS(2248),
    [anon_sym_column_major] = ACTIONS(2248),
    [anon_sym_globallycoherent] = ACTIONS(2248),
    [anon_sym_centroid] = ACTIONS(2248),
    [anon_sym_noperspective] = ACTIONS(2248),
    [anon_sym_nointerpolation] = ACTIONS(2248),
    [anon_sym_sample] = ACTIONS(2248),
    [anon_sym_linear] = ACTIONS(2248),
    [anon_sym_snorm] = ACTIONS(2248),
    [anon_sym_unorm] = ACTIONS(2248),
    [anon_sym_point] = ACTIONS(2248),
    [anon_sym_line] = ACTIONS(2248),
    [anon_sym_triangleadj] = ACTIONS(2248),
    [anon_sym_lineadj] = ACTIONS(2248),
    [anon_sym_triangle] = ACTIONS(2248),
    [anon_sym_cbuffer] = ACTIONS(2248),
    [anon_sym_interface] = ACTIONS(2248),
    [anon_sym_extension] = ACTIONS(2248),
    [anon_sym_where] = ACTIONS(2248),
    [anon_sym___exported] = ACTIONS(2248),
    [anon_sym_import] = ACTIONS(2248),
  },
  [215] = {
    [sym_preproc_def] = STATE(239),
    [sym_preproc_function_def] = STATE(239),
    [sym_preproc_call] = STATE(239),
    [sym_preproc_if_in_field_declaration_list] = STATE(239),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(239),
    [sym_preproc_else_in_field_declaration_list] = STATE(10197),
    [sym_preproc_elif_in_field_declaration_list] = STATE(10197),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(10197),
    [sym_type_definition] = STATE(239),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6881),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7467),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(239),
    [sym_field_declaration] = STATE(239),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2591),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(239),
    [sym_operator_cast] = STATE(8364),
    [sym_inline_method_definition] = STATE(239),
    [sym__constructor_specifiers] = STATE(2591),
    [sym_operator_cast_definition] = STATE(239),
    [sym_operator_cast_declaration] = STATE(239),
    [sym_constructor_or_destructor_definition] = STATE(239),
    [sym_constructor_or_destructor_declaration] = STATE(239),
    [sym_friend_declaration] = STATE(239),
    [sym_access_specifier] = STATE(10268),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(239),
    [sym_alias_declaration] = STATE(239),
    [sym_static_assert_declaration] = STATE(239),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8364),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(239),
    [sym_subscript_declaration] = STATE(239),
    [sym_property_declaration] = STATE(239),
    [sym_associatedtype_declaration] = STATE(239),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(239),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2377),
    [aux_sym_preproc_if_token1] = ACTIONS(2379),
    [aux_sym_preproc_if_token2] = ACTIONS(2381),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2383),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2383),
    [aux_sym_preproc_else_token1] = ACTIONS(2385),
    [aux_sym_preproc_elif_token1] = ACTIONS(2387),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2389),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2389),
    [sym_preproc_directive] = ACTIONS(2391),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2401),
    [anon_sym_typedef] = ACTIONS(2403),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2421),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2423),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2427),
    [anon_sym_static_assert] = ACTIONS(2429),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2435),
    [anon_sym___subscript] = ACTIONS(2437),
    [anon_sym_property] = ACTIONS(2439),
    [anon_sym_associatedtype] = ACTIONS(2441),
  },
  [216] = {
    [sym_preproc_def] = STATE(239),
    [sym_preproc_function_def] = STATE(239),
    [sym_preproc_call] = STATE(239),
    [sym_preproc_if_in_field_declaration_list] = STATE(239),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(239),
    [sym_preproc_else_in_field_declaration_list] = STATE(10802),
    [sym_preproc_elif_in_field_declaration_list] = STATE(10802),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(10802),
    [sym_type_definition] = STATE(239),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6881),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7467),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(239),
    [sym_field_declaration] = STATE(239),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2591),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(239),
    [sym_operator_cast] = STATE(8364),
    [sym_inline_method_definition] = STATE(239),
    [sym__constructor_specifiers] = STATE(2591),
    [sym_operator_cast_definition] = STATE(239),
    [sym_operator_cast_declaration] = STATE(239),
    [sym_constructor_or_destructor_definition] = STATE(239),
    [sym_constructor_or_destructor_declaration] = STATE(239),
    [sym_friend_declaration] = STATE(239),
    [sym_access_specifier] = STATE(10268),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(239),
    [sym_alias_declaration] = STATE(239),
    [sym_static_assert_declaration] = STATE(239),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8364),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(239),
    [sym_subscript_declaration] = STATE(239),
    [sym_property_declaration] = STATE(239),
    [sym_associatedtype_declaration] = STATE(239),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(239),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2377),
    [aux_sym_preproc_if_token1] = ACTIONS(2379),
    [aux_sym_preproc_if_token2] = ACTIONS(2443),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2383),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2383),
    [aux_sym_preproc_else_token1] = ACTIONS(2385),
    [aux_sym_preproc_elif_token1] = ACTIONS(2387),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2389),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2389),
    [sym_preproc_directive] = ACTIONS(2391),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2401),
    [anon_sym_typedef] = ACTIONS(2403),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2421),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2423),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2427),
    [anon_sym_static_assert] = ACTIONS(2429),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2435),
    [anon_sym___subscript] = ACTIONS(2437),
    [anon_sym_property] = ACTIONS(2439),
    [anon_sym_associatedtype] = ACTIONS(2441),
  },
  [217] = {
    [sym_preproc_def] = STATE(239),
    [sym_preproc_function_def] = STATE(239),
    [sym_preproc_call] = STATE(239),
    [sym_preproc_if_in_field_declaration_list] = STATE(239),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(239),
    [sym_preproc_else_in_field_declaration_list] = STATE(10751),
    [sym_preproc_elif_in_field_declaration_list] = STATE(10751),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(10751),
    [sym_type_definition] = STATE(239),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6881),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7467),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(239),
    [sym_field_declaration] = STATE(239),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2591),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(239),
    [sym_operator_cast] = STATE(8364),
    [sym_inline_method_definition] = STATE(239),
    [sym__constructor_specifiers] = STATE(2591),
    [sym_operator_cast_definition] = STATE(239),
    [sym_operator_cast_declaration] = STATE(239),
    [sym_constructor_or_destructor_definition] = STATE(239),
    [sym_constructor_or_destructor_declaration] = STATE(239),
    [sym_friend_declaration] = STATE(239),
    [sym_access_specifier] = STATE(10268),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(239),
    [sym_alias_declaration] = STATE(239),
    [sym_static_assert_declaration] = STATE(239),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8364),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(239),
    [sym_subscript_declaration] = STATE(239),
    [sym_property_declaration] = STATE(239),
    [sym_associatedtype_declaration] = STATE(239),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(239),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2377),
    [aux_sym_preproc_if_token1] = ACTIONS(2379),
    [aux_sym_preproc_if_token2] = ACTIONS(2445),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2383),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2383),
    [aux_sym_preproc_else_token1] = ACTIONS(2385),
    [aux_sym_preproc_elif_token1] = ACTIONS(2387),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2389),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2389),
    [sym_preproc_directive] = ACTIONS(2391),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2401),
    [anon_sym_typedef] = ACTIONS(2403),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2421),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2423),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2427),
    [anon_sym_static_assert] = ACTIONS(2429),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2435),
    [anon_sym___subscript] = ACTIONS(2437),
    [anon_sym_property] = ACTIONS(2439),
    [anon_sym_associatedtype] = ACTIONS(2441),
  },
  [218] = {
    [sym_preproc_def] = STATE(215),
    [sym_preproc_function_def] = STATE(215),
    [sym_preproc_call] = STATE(215),
    [sym_preproc_if_in_field_declaration_list] = STATE(215),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(215),
    [sym_preproc_else_in_field_declaration_list] = STATE(10177),
    [sym_preproc_elif_in_field_declaration_list] = STATE(10177),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(10177),
    [sym_type_definition] = STATE(215),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6881),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7467),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(215),
    [sym_field_declaration] = STATE(215),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2591),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(215),
    [sym_operator_cast] = STATE(8364),
    [sym_inline_method_definition] = STATE(215),
    [sym__constructor_specifiers] = STATE(2591),
    [sym_operator_cast_definition] = STATE(215),
    [sym_operator_cast_declaration] = STATE(215),
    [sym_constructor_or_destructor_definition] = STATE(215),
    [sym_constructor_or_destructor_declaration] = STATE(215),
    [sym_friend_declaration] = STATE(215),
    [sym_access_specifier] = STATE(10268),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(215),
    [sym_alias_declaration] = STATE(215),
    [sym_static_assert_declaration] = STATE(215),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8364),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(215),
    [sym_subscript_declaration] = STATE(215),
    [sym_property_declaration] = STATE(215),
    [sym_associatedtype_declaration] = STATE(215),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(215),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2377),
    [aux_sym_preproc_if_token1] = ACTIONS(2379),
    [aux_sym_preproc_if_token2] = ACTIONS(2447),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2383),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2383),
    [aux_sym_preproc_else_token1] = ACTIONS(2385),
    [aux_sym_preproc_elif_token1] = ACTIONS(2387),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2389),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2389),
    [sym_preproc_directive] = ACTIONS(2391),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2401),
    [anon_sym_typedef] = ACTIONS(2403),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2421),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2423),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2427),
    [anon_sym_static_assert] = ACTIONS(2429),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2435),
    [anon_sym___subscript] = ACTIONS(2437),
    [anon_sym_property] = ACTIONS(2439),
    [anon_sym_associatedtype] = ACTIONS(2441),
  },
  [219] = {
    [sym_preproc_def] = STATE(216),
    [sym_preproc_function_def] = STATE(216),
    [sym_preproc_call] = STATE(216),
    [sym_preproc_if_in_field_declaration_list] = STATE(216),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(216),
    [sym_preproc_else_in_field_declaration_list] = STATE(10750),
    [sym_preproc_elif_in_field_declaration_list] = STATE(10750),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(10750),
    [sym_type_definition] = STATE(216),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6881),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7467),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(216),
    [sym_field_declaration] = STATE(216),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2591),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(216),
    [sym_operator_cast] = STATE(8364),
    [sym_inline_method_definition] = STATE(216),
    [sym__constructor_specifiers] = STATE(2591),
    [sym_operator_cast_definition] = STATE(216),
    [sym_operator_cast_declaration] = STATE(216),
    [sym_constructor_or_destructor_definition] = STATE(216),
    [sym_constructor_or_destructor_declaration] = STATE(216),
    [sym_friend_declaration] = STATE(216),
    [sym_access_specifier] = STATE(10268),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(216),
    [sym_alias_declaration] = STATE(216),
    [sym_static_assert_declaration] = STATE(216),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8364),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(216),
    [sym_subscript_declaration] = STATE(216),
    [sym_property_declaration] = STATE(216),
    [sym_associatedtype_declaration] = STATE(216),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(216),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2377),
    [aux_sym_preproc_if_token1] = ACTIONS(2379),
    [aux_sym_preproc_if_token2] = ACTIONS(2449),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2383),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2383),
    [aux_sym_preproc_else_token1] = ACTIONS(2385),
    [aux_sym_preproc_elif_token1] = ACTIONS(2387),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2389),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2389),
    [sym_preproc_directive] = ACTIONS(2391),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2401),
    [anon_sym_typedef] = ACTIONS(2403),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2421),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2423),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2427),
    [anon_sym_static_assert] = ACTIONS(2429),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2435),
    [anon_sym___subscript] = ACTIONS(2437),
    [anon_sym_property] = ACTIONS(2439),
    [anon_sym_associatedtype] = ACTIONS(2441),
  },
  [220] = {
    [sym_preproc_def] = STATE(225),
    [sym_preproc_function_def] = STATE(225),
    [sym_preproc_call] = STATE(225),
    [sym_preproc_if_in_field_declaration_list] = STATE(225),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(225),
    [sym_preproc_else_in_field_declaration_list] = STATE(10611),
    [sym_preproc_elif_in_field_declaration_list] = STATE(10611),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(10611),
    [sym_type_definition] = STATE(225),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6881),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7467),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(225),
    [sym_field_declaration] = STATE(225),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2591),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(225),
    [sym_operator_cast] = STATE(8364),
    [sym_inline_method_definition] = STATE(225),
    [sym__constructor_specifiers] = STATE(2591),
    [sym_operator_cast_definition] = STATE(225),
    [sym_operator_cast_declaration] = STATE(225),
    [sym_constructor_or_destructor_definition] = STATE(225),
    [sym_constructor_or_destructor_declaration] = STATE(225),
    [sym_friend_declaration] = STATE(225),
    [sym_access_specifier] = STATE(10268),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(225),
    [sym_alias_declaration] = STATE(225),
    [sym_static_assert_declaration] = STATE(225),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8364),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(225),
    [sym_subscript_declaration] = STATE(225),
    [sym_property_declaration] = STATE(225),
    [sym_associatedtype_declaration] = STATE(225),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(225),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2377),
    [aux_sym_preproc_if_token1] = ACTIONS(2379),
    [aux_sym_preproc_if_token2] = ACTIONS(2451),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2383),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2383),
    [aux_sym_preproc_else_token1] = ACTIONS(2385),
    [aux_sym_preproc_elif_token1] = ACTIONS(2387),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2389),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2389),
    [sym_preproc_directive] = ACTIONS(2391),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2401),
    [anon_sym_typedef] = ACTIONS(2403),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2421),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2423),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2427),
    [anon_sym_static_assert] = ACTIONS(2429),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2435),
    [anon_sym___subscript] = ACTIONS(2437),
    [anon_sym_property] = ACTIONS(2439),
    [anon_sym_associatedtype] = ACTIONS(2441),
  },
  [221] = {
    [sym_preproc_def] = STATE(239),
    [sym_preproc_function_def] = STATE(239),
    [sym_preproc_call] = STATE(239),
    [sym_preproc_if_in_field_declaration_list] = STATE(239),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(239),
    [sym_preproc_else_in_field_declaration_list] = STATE(10223),
    [sym_preproc_elif_in_field_declaration_list] = STATE(10223),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(10223),
    [sym_type_definition] = STATE(239),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6881),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7467),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(239),
    [sym_field_declaration] = STATE(239),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2591),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(239),
    [sym_operator_cast] = STATE(8364),
    [sym_inline_method_definition] = STATE(239),
    [sym__constructor_specifiers] = STATE(2591),
    [sym_operator_cast_definition] = STATE(239),
    [sym_operator_cast_declaration] = STATE(239),
    [sym_constructor_or_destructor_definition] = STATE(239),
    [sym_constructor_or_destructor_declaration] = STATE(239),
    [sym_friend_declaration] = STATE(239),
    [sym_access_specifier] = STATE(10268),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(239),
    [sym_alias_declaration] = STATE(239),
    [sym_static_assert_declaration] = STATE(239),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8364),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(239),
    [sym_subscript_declaration] = STATE(239),
    [sym_property_declaration] = STATE(239),
    [sym_associatedtype_declaration] = STATE(239),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(239),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2377),
    [aux_sym_preproc_if_token1] = ACTIONS(2379),
    [aux_sym_preproc_if_token2] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2383),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2383),
    [aux_sym_preproc_else_token1] = ACTIONS(2385),
    [aux_sym_preproc_elif_token1] = ACTIONS(2387),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2389),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2389),
    [sym_preproc_directive] = ACTIONS(2391),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2401),
    [anon_sym_typedef] = ACTIONS(2403),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2421),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2423),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2427),
    [anon_sym_static_assert] = ACTIONS(2429),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2435),
    [anon_sym___subscript] = ACTIONS(2437),
    [anon_sym_property] = ACTIONS(2439),
    [anon_sym_associatedtype] = ACTIONS(2441),
  },
  [222] = {
    [sym_preproc_def] = STATE(239),
    [sym_preproc_function_def] = STATE(239),
    [sym_preproc_call] = STATE(239),
    [sym_preproc_if_in_field_declaration_list] = STATE(239),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(239),
    [sym_preproc_else_in_field_declaration_list] = STATE(10456),
    [sym_preproc_elif_in_field_declaration_list] = STATE(10456),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(10456),
    [sym_type_definition] = STATE(239),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6881),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7467),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(239),
    [sym_field_declaration] = STATE(239),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2591),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(239),
    [sym_operator_cast] = STATE(8364),
    [sym_inline_method_definition] = STATE(239),
    [sym__constructor_specifiers] = STATE(2591),
    [sym_operator_cast_definition] = STATE(239),
    [sym_operator_cast_declaration] = STATE(239),
    [sym_constructor_or_destructor_definition] = STATE(239),
    [sym_constructor_or_destructor_declaration] = STATE(239),
    [sym_friend_declaration] = STATE(239),
    [sym_access_specifier] = STATE(10268),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(239),
    [sym_alias_declaration] = STATE(239),
    [sym_static_assert_declaration] = STATE(239),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8364),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(239),
    [sym_subscript_declaration] = STATE(239),
    [sym_property_declaration] = STATE(239),
    [sym_associatedtype_declaration] = STATE(239),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(239),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2377),
    [aux_sym_preproc_if_token1] = ACTIONS(2379),
    [aux_sym_preproc_if_token2] = ACTIONS(2455),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2383),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2383),
    [aux_sym_preproc_else_token1] = ACTIONS(2385),
    [aux_sym_preproc_elif_token1] = ACTIONS(2387),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2389),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2389),
    [sym_preproc_directive] = ACTIONS(2391),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2401),
    [anon_sym_typedef] = ACTIONS(2403),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2421),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2423),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2427),
    [anon_sym_static_assert] = ACTIONS(2429),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2435),
    [anon_sym___subscript] = ACTIONS(2437),
    [anon_sym_property] = ACTIONS(2439),
    [anon_sym_associatedtype] = ACTIONS(2441),
  },
  [223] = {
    [sym_preproc_def] = STATE(239),
    [sym_preproc_function_def] = STATE(239),
    [sym_preproc_call] = STATE(239),
    [sym_preproc_if_in_field_declaration_list] = STATE(239),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(239),
    [sym_preproc_else_in_field_declaration_list] = STATE(10179),
    [sym_preproc_elif_in_field_declaration_list] = STATE(10179),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(10179),
    [sym_type_definition] = STATE(239),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6881),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7467),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(239),
    [sym_field_declaration] = STATE(239),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2591),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(239),
    [sym_operator_cast] = STATE(8364),
    [sym_inline_method_definition] = STATE(239),
    [sym__constructor_specifiers] = STATE(2591),
    [sym_operator_cast_definition] = STATE(239),
    [sym_operator_cast_declaration] = STATE(239),
    [sym_constructor_or_destructor_definition] = STATE(239),
    [sym_constructor_or_destructor_declaration] = STATE(239),
    [sym_friend_declaration] = STATE(239),
    [sym_access_specifier] = STATE(10268),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(239),
    [sym_alias_declaration] = STATE(239),
    [sym_static_assert_declaration] = STATE(239),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8364),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(239),
    [sym_subscript_declaration] = STATE(239),
    [sym_property_declaration] = STATE(239),
    [sym_associatedtype_declaration] = STATE(239),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(239),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2377),
    [aux_sym_preproc_if_token1] = ACTIONS(2379),
    [aux_sym_preproc_if_token2] = ACTIONS(2457),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2383),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2383),
    [aux_sym_preproc_else_token1] = ACTIONS(2385),
    [aux_sym_preproc_elif_token1] = ACTIONS(2387),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2389),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2389),
    [sym_preproc_directive] = ACTIONS(2391),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2401),
    [anon_sym_typedef] = ACTIONS(2403),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2421),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2423),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2427),
    [anon_sym_static_assert] = ACTIONS(2429),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2435),
    [anon_sym___subscript] = ACTIONS(2437),
    [anon_sym_property] = ACTIONS(2439),
    [anon_sym_associatedtype] = ACTIONS(2441),
  },
  [224] = {
    [sym_preproc_def] = STATE(217),
    [sym_preproc_function_def] = STATE(217),
    [sym_preproc_call] = STATE(217),
    [sym_preproc_if_in_field_declaration_list] = STATE(217),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(217),
    [sym_preproc_else_in_field_declaration_list] = STATE(10224),
    [sym_preproc_elif_in_field_declaration_list] = STATE(10224),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(10224),
    [sym_type_definition] = STATE(217),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6881),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7467),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(217),
    [sym_field_declaration] = STATE(217),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2591),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(217),
    [sym_operator_cast] = STATE(8364),
    [sym_inline_method_definition] = STATE(217),
    [sym__constructor_specifiers] = STATE(2591),
    [sym_operator_cast_definition] = STATE(217),
    [sym_operator_cast_declaration] = STATE(217),
    [sym_constructor_or_destructor_definition] = STATE(217),
    [sym_constructor_or_destructor_declaration] = STATE(217),
    [sym_friend_declaration] = STATE(217),
    [sym_access_specifier] = STATE(10268),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(217),
    [sym_alias_declaration] = STATE(217),
    [sym_static_assert_declaration] = STATE(217),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8364),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(217),
    [sym_subscript_declaration] = STATE(217),
    [sym_property_declaration] = STATE(217),
    [sym_associatedtype_declaration] = STATE(217),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(217),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2377),
    [aux_sym_preproc_if_token1] = ACTIONS(2379),
    [aux_sym_preproc_if_token2] = ACTIONS(2459),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2383),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2383),
    [aux_sym_preproc_else_token1] = ACTIONS(2385),
    [aux_sym_preproc_elif_token1] = ACTIONS(2387),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2389),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2389),
    [sym_preproc_directive] = ACTIONS(2391),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2401),
    [anon_sym_typedef] = ACTIONS(2403),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2421),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2423),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2427),
    [anon_sym_static_assert] = ACTIONS(2429),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2435),
    [anon_sym___subscript] = ACTIONS(2437),
    [anon_sym_property] = ACTIONS(2439),
    [anon_sym_associatedtype] = ACTIONS(2441),
  },
  [225] = {
    [sym_preproc_def] = STATE(239),
    [sym_preproc_function_def] = STATE(239),
    [sym_preproc_call] = STATE(239),
    [sym_preproc_if_in_field_declaration_list] = STATE(239),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(239),
    [sym_preproc_else_in_field_declaration_list] = STATE(10278),
    [sym_preproc_elif_in_field_declaration_list] = STATE(10278),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(10278),
    [sym_type_definition] = STATE(239),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6881),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7467),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(239),
    [sym_field_declaration] = STATE(239),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2591),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(239),
    [sym_operator_cast] = STATE(8364),
    [sym_inline_method_definition] = STATE(239),
    [sym__constructor_specifiers] = STATE(2591),
    [sym_operator_cast_definition] = STATE(239),
    [sym_operator_cast_declaration] = STATE(239),
    [sym_constructor_or_destructor_definition] = STATE(239),
    [sym_constructor_or_destructor_declaration] = STATE(239),
    [sym_friend_declaration] = STATE(239),
    [sym_access_specifier] = STATE(10268),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(239),
    [sym_alias_declaration] = STATE(239),
    [sym_static_assert_declaration] = STATE(239),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8364),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(239),
    [sym_subscript_declaration] = STATE(239),
    [sym_property_declaration] = STATE(239),
    [sym_associatedtype_declaration] = STATE(239),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(239),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2377),
    [aux_sym_preproc_if_token1] = ACTIONS(2379),
    [aux_sym_preproc_if_token2] = ACTIONS(2461),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2383),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2383),
    [aux_sym_preproc_else_token1] = ACTIONS(2385),
    [aux_sym_preproc_elif_token1] = ACTIONS(2387),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2389),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2389),
    [sym_preproc_directive] = ACTIONS(2391),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2401),
    [anon_sym_typedef] = ACTIONS(2403),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2421),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2423),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2427),
    [anon_sym_static_assert] = ACTIONS(2429),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2435),
    [anon_sym___subscript] = ACTIONS(2437),
    [anon_sym_property] = ACTIONS(2439),
    [anon_sym_associatedtype] = ACTIONS(2441),
  },
  [226] = {
    [sym_preproc_def] = STATE(239),
    [sym_preproc_function_def] = STATE(239),
    [sym_preproc_call] = STATE(239),
    [sym_preproc_if_in_field_declaration_list] = STATE(239),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(239),
    [sym_preproc_else_in_field_declaration_list] = STATE(10475),
    [sym_preproc_elif_in_field_declaration_list] = STATE(10475),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(10475),
    [sym_type_definition] = STATE(239),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6881),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7467),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(239),
    [sym_field_declaration] = STATE(239),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2591),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(239),
    [sym_operator_cast] = STATE(8364),
    [sym_inline_method_definition] = STATE(239),
    [sym__constructor_specifiers] = STATE(2591),
    [sym_operator_cast_definition] = STATE(239),
    [sym_operator_cast_declaration] = STATE(239),
    [sym_constructor_or_destructor_definition] = STATE(239),
    [sym_constructor_or_destructor_declaration] = STATE(239),
    [sym_friend_declaration] = STATE(239),
    [sym_access_specifier] = STATE(10268),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(239),
    [sym_alias_declaration] = STATE(239),
    [sym_static_assert_declaration] = STATE(239),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8364),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(239),
    [sym_subscript_declaration] = STATE(239),
    [sym_property_declaration] = STATE(239),
    [sym_associatedtype_declaration] = STATE(239),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(239),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2377),
    [aux_sym_preproc_if_token1] = ACTIONS(2379),
    [aux_sym_preproc_if_token2] = ACTIONS(2463),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2383),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2383),
    [aux_sym_preproc_else_token1] = ACTIONS(2385),
    [aux_sym_preproc_elif_token1] = ACTIONS(2387),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2389),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2389),
    [sym_preproc_directive] = ACTIONS(2391),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2401),
    [anon_sym_typedef] = ACTIONS(2403),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2421),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2423),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2427),
    [anon_sym_static_assert] = ACTIONS(2429),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2435),
    [anon_sym___subscript] = ACTIONS(2437),
    [anon_sym_property] = ACTIONS(2439),
    [anon_sym_associatedtype] = ACTIONS(2441),
  },
  [227] = {
    [sym_preproc_def] = STATE(223),
    [sym_preproc_function_def] = STATE(223),
    [sym_preproc_call] = STATE(223),
    [sym_preproc_if_in_field_declaration_list] = STATE(223),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(223),
    [sym_preproc_else_in_field_declaration_list] = STATE(10156),
    [sym_preproc_elif_in_field_declaration_list] = STATE(10156),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(10156),
    [sym_type_definition] = STATE(223),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6881),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7467),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(223),
    [sym_field_declaration] = STATE(223),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2591),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(223),
    [sym_operator_cast] = STATE(8364),
    [sym_inline_method_definition] = STATE(223),
    [sym__constructor_specifiers] = STATE(2591),
    [sym_operator_cast_definition] = STATE(223),
    [sym_operator_cast_declaration] = STATE(223),
    [sym_constructor_or_destructor_definition] = STATE(223),
    [sym_constructor_or_destructor_declaration] = STATE(223),
    [sym_friend_declaration] = STATE(223),
    [sym_access_specifier] = STATE(10268),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(223),
    [sym_alias_declaration] = STATE(223),
    [sym_static_assert_declaration] = STATE(223),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8364),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(223),
    [sym_subscript_declaration] = STATE(223),
    [sym_property_declaration] = STATE(223),
    [sym_associatedtype_declaration] = STATE(223),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(223),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2377),
    [aux_sym_preproc_if_token1] = ACTIONS(2379),
    [aux_sym_preproc_if_token2] = ACTIONS(2465),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2383),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2383),
    [aux_sym_preproc_else_token1] = ACTIONS(2385),
    [aux_sym_preproc_elif_token1] = ACTIONS(2387),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2389),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2389),
    [sym_preproc_directive] = ACTIONS(2391),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2401),
    [anon_sym_typedef] = ACTIONS(2403),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2421),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2423),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2427),
    [anon_sym_static_assert] = ACTIONS(2429),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2435),
    [anon_sym___subscript] = ACTIONS(2437),
    [anon_sym_property] = ACTIONS(2439),
    [anon_sym_associatedtype] = ACTIONS(2441),
  },
  [228] = {
    [sym_preproc_def] = STATE(226),
    [sym_preproc_function_def] = STATE(226),
    [sym_preproc_call] = STATE(226),
    [sym_preproc_if_in_field_declaration_list] = STATE(226),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(226),
    [sym_preproc_else_in_field_declaration_list] = STATE(10454),
    [sym_preproc_elif_in_field_declaration_list] = STATE(10454),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(10454),
    [sym_type_definition] = STATE(226),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6881),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7467),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(226),
    [sym_field_declaration] = STATE(226),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2591),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(226),
    [sym_operator_cast] = STATE(8364),
    [sym_inline_method_definition] = STATE(226),
    [sym__constructor_specifiers] = STATE(2591),
    [sym_operator_cast_definition] = STATE(226),
    [sym_operator_cast_declaration] = STATE(226),
    [sym_constructor_or_destructor_definition] = STATE(226),
    [sym_constructor_or_destructor_declaration] = STATE(226),
    [sym_friend_declaration] = STATE(226),
    [sym_access_specifier] = STATE(10268),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(226),
    [sym_alias_declaration] = STATE(226),
    [sym_static_assert_declaration] = STATE(226),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8364),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(226),
    [sym_subscript_declaration] = STATE(226),
    [sym_property_declaration] = STATE(226),
    [sym_associatedtype_declaration] = STATE(226),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(226),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2377),
    [aux_sym_preproc_if_token1] = ACTIONS(2379),
    [aux_sym_preproc_if_token2] = ACTIONS(2467),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2383),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2383),
    [aux_sym_preproc_else_token1] = ACTIONS(2385),
    [aux_sym_preproc_elif_token1] = ACTIONS(2387),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2389),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2389),
    [sym_preproc_directive] = ACTIONS(2391),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2401),
    [anon_sym_typedef] = ACTIONS(2403),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2421),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2423),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2427),
    [anon_sym_static_assert] = ACTIONS(2429),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2435),
    [anon_sym___subscript] = ACTIONS(2437),
    [anon_sym_property] = ACTIONS(2439),
    [anon_sym_associatedtype] = ACTIONS(2441),
  },
  [229] = {
    [sym_preproc_def] = STATE(222),
    [sym_preproc_function_def] = STATE(222),
    [sym_preproc_call] = STATE(222),
    [sym_preproc_if_in_field_declaration_list] = STATE(222),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(222),
    [sym_preproc_else_in_field_declaration_list] = STATE(10431),
    [sym_preproc_elif_in_field_declaration_list] = STATE(10431),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(10431),
    [sym_type_definition] = STATE(222),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6881),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7467),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(222),
    [sym_field_declaration] = STATE(222),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2591),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(222),
    [sym_operator_cast] = STATE(8364),
    [sym_inline_method_definition] = STATE(222),
    [sym__constructor_specifiers] = STATE(2591),
    [sym_operator_cast_definition] = STATE(222),
    [sym_operator_cast_declaration] = STATE(222),
    [sym_constructor_or_destructor_definition] = STATE(222),
    [sym_constructor_or_destructor_declaration] = STATE(222),
    [sym_friend_declaration] = STATE(222),
    [sym_access_specifier] = STATE(10268),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(222),
    [sym_alias_declaration] = STATE(222),
    [sym_static_assert_declaration] = STATE(222),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8364),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(222),
    [sym_subscript_declaration] = STATE(222),
    [sym_property_declaration] = STATE(222),
    [sym_associatedtype_declaration] = STATE(222),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(222),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2377),
    [aux_sym_preproc_if_token1] = ACTIONS(2379),
    [aux_sym_preproc_if_token2] = ACTIONS(2469),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2383),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2383),
    [aux_sym_preproc_else_token1] = ACTIONS(2385),
    [aux_sym_preproc_elif_token1] = ACTIONS(2387),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2389),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2389),
    [sym_preproc_directive] = ACTIONS(2391),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2401),
    [anon_sym_typedef] = ACTIONS(2403),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2421),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2423),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2427),
    [anon_sym_static_assert] = ACTIONS(2429),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2435),
    [anon_sym___subscript] = ACTIONS(2437),
    [anon_sym_property] = ACTIONS(2439),
    [anon_sym_associatedtype] = ACTIONS(2441),
  },
  [230] = {
    [sym_preproc_def] = STATE(221),
    [sym_preproc_function_def] = STATE(221),
    [sym_preproc_call] = STATE(221),
    [sym_preproc_if_in_field_declaration_list] = STATE(221),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(221),
    [sym_preproc_else_in_field_declaration_list] = STATE(10280),
    [sym_preproc_elif_in_field_declaration_list] = STATE(10280),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(10280),
    [sym_type_definition] = STATE(221),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6881),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7467),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(221),
    [sym_field_declaration] = STATE(221),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2591),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(221),
    [sym_operator_cast] = STATE(8364),
    [sym_inline_method_definition] = STATE(221),
    [sym__constructor_specifiers] = STATE(2591),
    [sym_operator_cast_definition] = STATE(221),
    [sym_operator_cast_declaration] = STATE(221),
    [sym_constructor_or_destructor_definition] = STATE(221),
    [sym_constructor_or_destructor_declaration] = STATE(221),
    [sym_friend_declaration] = STATE(221),
    [sym_access_specifier] = STATE(10268),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(221),
    [sym_alias_declaration] = STATE(221),
    [sym_static_assert_declaration] = STATE(221),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8364),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(221),
    [sym_subscript_declaration] = STATE(221),
    [sym_property_declaration] = STATE(221),
    [sym_associatedtype_declaration] = STATE(221),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(221),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2377),
    [aux_sym_preproc_if_token1] = ACTIONS(2379),
    [aux_sym_preproc_if_token2] = ACTIONS(2471),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2383),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2383),
    [aux_sym_preproc_else_token1] = ACTIONS(2385),
    [aux_sym_preproc_elif_token1] = ACTIONS(2387),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2389),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2389),
    [sym_preproc_directive] = ACTIONS(2391),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2401),
    [anon_sym_typedef] = ACTIONS(2403),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2421),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2423),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2427),
    [anon_sym_static_assert] = ACTIONS(2429),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2435),
    [anon_sym___subscript] = ACTIONS(2437),
    [anon_sym_property] = ACTIONS(2439),
    [anon_sym_associatedtype] = ACTIONS(2441),
  },
  [231] = {
    [sym_field_declaration_list] = STATE(416),
    [sym_virtual_specifier] = STATE(8643),
    [sym_base_class_clause] = STATE(9893),
    [sym_identifier] = ACTIONS(2473),
    [aux_sym_preproc_include_token1] = ACTIONS(2473),
    [aux_sym_preproc_def_token1] = ACTIONS(2473),
    [aux_sym_preproc_if_token1] = ACTIONS(2473),
    [aux_sym_preproc_if_token2] = ACTIONS(2473),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2473),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2473),
    [aux_sym_preproc_else_token1] = ACTIONS(2473),
    [aux_sym_preproc_elif_token1] = ACTIONS(2473),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2473),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2473),
    [sym_preproc_directive] = ACTIONS(2473),
    [anon_sym_LPAREN2] = ACTIONS(2475),
    [anon_sym_BANG] = ACTIONS(2475),
    [anon_sym_TILDE] = ACTIONS(2475),
    [anon_sym_DASH] = ACTIONS(2473),
    [anon_sym_PLUS] = ACTIONS(2473),
    [anon_sym_STAR] = ACTIONS(2475),
    [anon_sym_AMP_AMP] = ACTIONS(2475),
    [anon_sym_AMP] = ACTIONS(2473),
    [anon_sym_COLON] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(2475),
    [anon_sym___extension__] = ACTIONS(2473),
    [anon_sym_typedef] = ACTIONS(2473),
    [anon_sym_in] = ACTIONS(2473),
    [anon_sym_out] = ACTIONS(2473),
    [anon_sym_inout] = ACTIONS(2473),
    [anon_sym_extern] = ACTIONS(2473),
    [anon_sym___attribute__] = ACTIONS(2473),
    [anon_sym_COLON_COLON] = ACTIONS(2475),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2475),
    [anon_sym___declspec] = ACTIONS(2473),
    [anon_sym___based] = ACTIONS(2473),
    [anon_sym___cdecl] = ACTIONS(2473),
    [anon_sym___clrcall] = ACTIONS(2473),
    [anon_sym___stdcall] = ACTIONS(2473),
    [anon_sym___fastcall] = ACTIONS(2473),
    [anon_sym___thiscall] = ACTIONS(2473),
    [anon_sym___vectorcall] = ACTIONS(2473),
    [anon_sym_LBRACE] = ACTIONS(2479),
    [anon_sym_signed] = ACTIONS(2473),
    [anon_sym_unsigned] = ACTIONS(2473),
    [anon_sym_long] = ACTIONS(2473),
    [anon_sym_short] = ACTIONS(2473),
    [anon_sym_LBRACK] = ACTIONS(2473),
    [anon_sym_static] = ACTIONS(2473),
    [anon_sym_register] = ACTIONS(2473),
    [anon_sym_inline] = ACTIONS(2473),
    [anon_sym___inline] = ACTIONS(2473),
    [anon_sym___inline__] = ACTIONS(2473),
    [anon_sym___forceinline] = ACTIONS(2473),
    [anon_sym_thread_local] = ACTIONS(2473),
    [anon_sym___thread] = ACTIONS(2473),
    [anon_sym_const] = ACTIONS(2473),
    [anon_sym_constexpr] = ACTIONS(2473),
    [anon_sym_volatile] = ACTIONS(2473),
    [anon_sym_restrict] = ACTIONS(2473),
    [anon_sym___restrict__] = ACTIONS(2473),
    [anon_sym__Atomic] = ACTIONS(2473),
    [anon_sym__Noreturn] = ACTIONS(2473),
    [anon_sym_noreturn] = ACTIONS(2473),
    [anon_sym_mutable] = ACTIONS(2473),
    [anon_sym_constinit] = ACTIONS(2473),
    [anon_sym_consteval] = ACTIONS(2473),
    [anon_sym_alignas] = ACTIONS(2473),
    [anon_sym__Alignas] = ACTIONS(2473),
    [sym_primitive_type] = ACTIONS(2473),
    [anon_sym_enum] = ACTIONS(2473),
    [anon_sym_class] = ACTIONS(2473),
    [anon_sym_struct] = ACTIONS(2473),
    [anon_sym_union] = ACTIONS(2473),
    [anon_sym_if] = ACTIONS(2473),
    [anon_sym_else] = ACTIONS(2473),
    [anon_sym_switch] = ACTIONS(2473),
    [anon_sym_case] = ACTIONS(2473),
    [anon_sym_default] = ACTIONS(2473),
    [anon_sym_while] = ACTIONS(2473),
    [anon_sym_do] = ACTIONS(2473),
    [anon_sym_for] = ACTIONS(2473),
    [anon_sym_return] = ACTIONS(2473),
    [anon_sym_break] = ACTIONS(2473),
    [anon_sym_continue] = ACTIONS(2473),
    [anon_sym_goto] = ACTIONS(2473),
    [anon_sym___try] = ACTIONS(2473),
    [anon_sym___leave] = ACTIONS(2473),
    [anon_sym_not] = ACTIONS(2473),
    [anon_sym_compl] = ACTIONS(2473),
    [anon_sym_DASH_DASH] = ACTIONS(2475),
    [anon_sym_PLUS_PLUS] = ACTIONS(2475),
    [anon_sym_sizeof] = ACTIONS(2473),
    [anon_sym___alignof__] = ACTIONS(2473),
    [anon_sym___alignof] = ACTIONS(2473),
    [anon_sym__alignof] = ACTIONS(2473),
    [anon_sym_alignof] = ACTIONS(2473),
    [anon_sym__Alignof] = ACTIONS(2473),
    [anon_sym_offsetof] = ACTIONS(2473),
    [anon_sym__Generic] = ACTIONS(2473),
    [anon_sym_asm] = ACTIONS(2473),
    [anon_sym___asm__] = ACTIONS(2473),
    [sym_number_literal] = ACTIONS(2475),
    [anon_sym_L_SQUOTE] = ACTIONS(2475),
    [anon_sym_u_SQUOTE] = ACTIONS(2475),
    [anon_sym_U_SQUOTE] = ACTIONS(2475),
    [anon_sym_u8_SQUOTE] = ACTIONS(2475),
    [anon_sym_SQUOTE] = ACTIONS(2475),
    [anon_sym_L_DQUOTE] = ACTIONS(2475),
    [anon_sym_u_DQUOTE] = ACTIONS(2475),
    [anon_sym_U_DQUOTE] = ACTIONS(2475),
    [anon_sym_u8_DQUOTE] = ACTIONS(2475),
    [anon_sym_DQUOTE] = ACTIONS(2475),
    [sym_true] = ACTIONS(2473),
    [sym_false] = ACTIONS(2473),
    [anon_sym_NULL] = ACTIONS(2473),
    [anon_sym_nullptr] = ACTIONS(2473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2473),
    [anon_sym_let] = ACTIONS(2473),
    [anon_sym_This] = ACTIONS(2473),
    [anon_sym_decltype] = ACTIONS(2473),
    [anon_sym_final] = ACTIONS(2481),
    [anon_sym_override] = ACTIONS(2481),
    [sym_virtual] = ACTIONS(2473),
    [anon_sym_explicit] = ACTIONS(2473),
    [anon_sym_typename] = ACTIONS(2473),
    [anon_sym_template] = ACTIONS(2473),
    [anon_sym_operator] = ACTIONS(2473),
    [anon_sym_try] = ACTIONS(2473),
    [anon_sym_delete] = ACTIONS(2473),
    [anon_sym_throw] = ACTIONS(2473),
    [anon_sym_namespace] = ACTIONS(2473),
    [anon_sym_using] = ACTIONS(2473),
    [anon_sym_static_assert] = ACTIONS(2473),
    [anon_sym_concept] = ACTIONS(2473),
    [anon_sym_co_return] = ACTIONS(2473),
    [anon_sym_co_yield] = ACTIONS(2473),
    [anon_sym_R_DQUOTE] = ACTIONS(2475),
    [anon_sym_LR_DQUOTE] = ACTIONS(2475),
    [anon_sym_uR_DQUOTE] = ACTIONS(2475),
    [anon_sym_UR_DQUOTE] = ACTIONS(2475),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2475),
    [anon_sym_co_await] = ACTIONS(2473),
    [anon_sym_new] = ACTIONS(2473),
    [anon_sym_requires] = ACTIONS(2473),
    [sym_this] = ACTIONS(2473),
    [anon_sym_discard] = ACTIONS(2473),
    [anon_sym_precise] = ACTIONS(2473),
    [anon_sym_shared] = ACTIONS(2473),
    [anon_sym_groupshared] = ACTIONS(2473),
    [anon_sym_uniform] = ACTIONS(2473),
    [anon_sym_row_major] = ACTIONS(2473),
    [anon_sym_column_major] = ACTIONS(2473),
    [anon_sym_globallycoherent] = ACTIONS(2473),
    [anon_sym_centroid] = ACTIONS(2473),
    [anon_sym_noperspective] = ACTIONS(2473),
    [anon_sym_nointerpolation] = ACTIONS(2473),
    [anon_sym_sample] = ACTIONS(2473),
    [anon_sym_linear] = ACTIONS(2473),
    [anon_sym_snorm] = ACTIONS(2473),
    [anon_sym_unorm] = ACTIONS(2473),
    [anon_sym_point] = ACTIONS(2473),
    [anon_sym_line] = ACTIONS(2473),
    [anon_sym_triangleadj] = ACTIONS(2473),
    [anon_sym_lineadj] = ACTIONS(2473),
    [anon_sym_triangle] = ACTIONS(2473),
    [anon_sym_cbuffer] = ACTIONS(2473),
    [anon_sym_interface] = ACTIONS(2473),
    [anon_sym_extension] = ACTIONS(2473),
  },
  [232] = {
    [sym_field_declaration_list] = STATE(398),
    [sym_virtual_specifier] = STATE(8694),
    [sym_base_class_clause] = STATE(9677),
    [sym_identifier] = ACTIONS(2483),
    [aux_sym_preproc_include_token1] = ACTIONS(2483),
    [aux_sym_preproc_def_token1] = ACTIONS(2483),
    [aux_sym_preproc_if_token1] = ACTIONS(2483),
    [aux_sym_preproc_if_token2] = ACTIONS(2483),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2483),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2483),
    [aux_sym_preproc_else_token1] = ACTIONS(2483),
    [aux_sym_preproc_elif_token1] = ACTIONS(2483),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2483),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2483),
    [sym_preproc_directive] = ACTIONS(2483),
    [anon_sym_LPAREN2] = ACTIONS(2485),
    [anon_sym_BANG] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2483),
    [anon_sym_PLUS] = ACTIONS(2483),
    [anon_sym_STAR] = ACTIONS(2485),
    [anon_sym_AMP_AMP] = ACTIONS(2485),
    [anon_sym_AMP] = ACTIONS(2483),
    [anon_sym_COLON] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(2485),
    [anon_sym___extension__] = ACTIONS(2483),
    [anon_sym_typedef] = ACTIONS(2483),
    [anon_sym_in] = ACTIONS(2483),
    [anon_sym_out] = ACTIONS(2483),
    [anon_sym_inout] = ACTIONS(2483),
    [anon_sym_extern] = ACTIONS(2483),
    [anon_sym___attribute__] = ACTIONS(2483),
    [anon_sym_COLON_COLON] = ACTIONS(2485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2485),
    [anon_sym___declspec] = ACTIONS(2483),
    [anon_sym___based] = ACTIONS(2483),
    [anon_sym___cdecl] = ACTIONS(2483),
    [anon_sym___clrcall] = ACTIONS(2483),
    [anon_sym___stdcall] = ACTIONS(2483),
    [anon_sym___fastcall] = ACTIONS(2483),
    [anon_sym___thiscall] = ACTIONS(2483),
    [anon_sym___vectorcall] = ACTIONS(2483),
    [anon_sym_LBRACE] = ACTIONS(2479),
    [anon_sym_signed] = ACTIONS(2483),
    [anon_sym_unsigned] = ACTIONS(2483),
    [anon_sym_long] = ACTIONS(2483),
    [anon_sym_short] = ACTIONS(2483),
    [anon_sym_LBRACK] = ACTIONS(2483),
    [anon_sym_static] = ACTIONS(2483),
    [anon_sym_register] = ACTIONS(2483),
    [anon_sym_inline] = ACTIONS(2483),
    [anon_sym___inline] = ACTIONS(2483),
    [anon_sym___inline__] = ACTIONS(2483),
    [anon_sym___forceinline] = ACTIONS(2483),
    [anon_sym_thread_local] = ACTIONS(2483),
    [anon_sym___thread] = ACTIONS(2483),
    [anon_sym_const] = ACTIONS(2483),
    [anon_sym_constexpr] = ACTIONS(2483),
    [anon_sym_volatile] = ACTIONS(2483),
    [anon_sym_restrict] = ACTIONS(2483),
    [anon_sym___restrict__] = ACTIONS(2483),
    [anon_sym__Atomic] = ACTIONS(2483),
    [anon_sym__Noreturn] = ACTIONS(2483),
    [anon_sym_noreturn] = ACTIONS(2483),
    [anon_sym_mutable] = ACTIONS(2483),
    [anon_sym_constinit] = ACTIONS(2483),
    [anon_sym_consteval] = ACTIONS(2483),
    [anon_sym_alignas] = ACTIONS(2483),
    [anon_sym__Alignas] = ACTIONS(2483),
    [sym_primitive_type] = ACTIONS(2483),
    [anon_sym_enum] = ACTIONS(2483),
    [anon_sym_class] = ACTIONS(2483),
    [anon_sym_struct] = ACTIONS(2483),
    [anon_sym_union] = ACTIONS(2483),
    [anon_sym_if] = ACTIONS(2483),
    [anon_sym_else] = ACTIONS(2483),
    [anon_sym_switch] = ACTIONS(2483),
    [anon_sym_case] = ACTIONS(2483),
    [anon_sym_default] = ACTIONS(2483),
    [anon_sym_while] = ACTIONS(2483),
    [anon_sym_do] = ACTIONS(2483),
    [anon_sym_for] = ACTIONS(2483),
    [anon_sym_return] = ACTIONS(2483),
    [anon_sym_break] = ACTIONS(2483),
    [anon_sym_continue] = ACTIONS(2483),
    [anon_sym_goto] = ACTIONS(2483),
    [anon_sym___try] = ACTIONS(2483),
    [anon_sym___leave] = ACTIONS(2483),
    [anon_sym_not] = ACTIONS(2483),
    [anon_sym_compl] = ACTIONS(2483),
    [anon_sym_DASH_DASH] = ACTIONS(2485),
    [anon_sym_PLUS_PLUS] = ACTIONS(2485),
    [anon_sym_sizeof] = ACTIONS(2483),
    [anon_sym___alignof__] = ACTIONS(2483),
    [anon_sym___alignof] = ACTIONS(2483),
    [anon_sym__alignof] = ACTIONS(2483),
    [anon_sym_alignof] = ACTIONS(2483),
    [anon_sym__Alignof] = ACTIONS(2483),
    [anon_sym_offsetof] = ACTIONS(2483),
    [anon_sym__Generic] = ACTIONS(2483),
    [anon_sym_asm] = ACTIONS(2483),
    [anon_sym___asm__] = ACTIONS(2483),
    [sym_number_literal] = ACTIONS(2485),
    [anon_sym_L_SQUOTE] = ACTIONS(2485),
    [anon_sym_u_SQUOTE] = ACTIONS(2485),
    [anon_sym_U_SQUOTE] = ACTIONS(2485),
    [anon_sym_u8_SQUOTE] = ACTIONS(2485),
    [anon_sym_SQUOTE] = ACTIONS(2485),
    [anon_sym_L_DQUOTE] = ACTIONS(2485),
    [anon_sym_u_DQUOTE] = ACTIONS(2485),
    [anon_sym_U_DQUOTE] = ACTIONS(2485),
    [anon_sym_u8_DQUOTE] = ACTIONS(2485),
    [anon_sym_DQUOTE] = ACTIONS(2485),
    [sym_true] = ACTIONS(2483),
    [sym_false] = ACTIONS(2483),
    [anon_sym_NULL] = ACTIONS(2483),
    [anon_sym_nullptr] = ACTIONS(2483),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2483),
    [anon_sym_let] = ACTIONS(2483),
    [anon_sym_This] = ACTIONS(2483),
    [anon_sym_decltype] = ACTIONS(2483),
    [anon_sym_final] = ACTIONS(2481),
    [anon_sym_override] = ACTIONS(2481),
    [sym_virtual] = ACTIONS(2483),
    [anon_sym_explicit] = ACTIONS(2483),
    [anon_sym_typename] = ACTIONS(2483),
    [anon_sym_template] = ACTIONS(2483),
    [anon_sym_operator] = ACTIONS(2483),
    [anon_sym_try] = ACTIONS(2483),
    [anon_sym_delete] = ACTIONS(2483),
    [anon_sym_throw] = ACTIONS(2483),
    [anon_sym_namespace] = ACTIONS(2483),
    [anon_sym_using] = ACTIONS(2483),
    [anon_sym_static_assert] = ACTIONS(2483),
    [anon_sym_concept] = ACTIONS(2483),
    [anon_sym_co_return] = ACTIONS(2483),
    [anon_sym_co_yield] = ACTIONS(2483),
    [anon_sym_R_DQUOTE] = ACTIONS(2485),
    [anon_sym_LR_DQUOTE] = ACTIONS(2485),
    [anon_sym_uR_DQUOTE] = ACTIONS(2485),
    [anon_sym_UR_DQUOTE] = ACTIONS(2485),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2485),
    [anon_sym_co_await] = ACTIONS(2483),
    [anon_sym_new] = ACTIONS(2483),
    [anon_sym_requires] = ACTIONS(2483),
    [sym_this] = ACTIONS(2483),
    [anon_sym_discard] = ACTIONS(2483),
    [anon_sym_precise] = ACTIONS(2483),
    [anon_sym_shared] = ACTIONS(2483),
    [anon_sym_groupshared] = ACTIONS(2483),
    [anon_sym_uniform] = ACTIONS(2483),
    [anon_sym_row_major] = ACTIONS(2483),
    [anon_sym_column_major] = ACTIONS(2483),
    [anon_sym_globallycoherent] = ACTIONS(2483),
    [anon_sym_centroid] = ACTIONS(2483),
    [anon_sym_noperspective] = ACTIONS(2483),
    [anon_sym_nointerpolation] = ACTIONS(2483),
    [anon_sym_sample] = ACTIONS(2483),
    [anon_sym_linear] = ACTIONS(2483),
    [anon_sym_snorm] = ACTIONS(2483),
    [anon_sym_unorm] = ACTIONS(2483),
    [anon_sym_point] = ACTIONS(2483),
    [anon_sym_line] = ACTIONS(2483),
    [anon_sym_triangleadj] = ACTIONS(2483),
    [anon_sym_lineadj] = ACTIONS(2483),
    [anon_sym_triangle] = ACTIONS(2483),
    [anon_sym_cbuffer] = ACTIONS(2483),
    [anon_sym_interface] = ACTIONS(2483),
    [anon_sym_extension] = ACTIONS(2483),
  },
  [233] = {
    [sym_template_argument_list] = STATE(251),
    [sym_identifier] = ACTIONS(2349),
    [aux_sym_preproc_include_token1] = ACTIONS(2349),
    [aux_sym_preproc_def_token1] = ACTIONS(2349),
    [aux_sym_preproc_if_token1] = ACTIONS(2349),
    [aux_sym_preproc_if_token2] = ACTIONS(2349),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2349),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2349),
    [aux_sym_preproc_else_token1] = ACTIONS(2349),
    [aux_sym_preproc_elif_token1] = ACTIONS(2349),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2349),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2349),
    [sym_preproc_directive] = ACTIONS(2349),
    [anon_sym_LPAREN2] = ACTIONS(2347),
    [anon_sym_BANG] = ACTIONS(2347),
    [anon_sym_TILDE] = ACTIONS(2347),
    [anon_sym_DASH] = ACTIONS(2349),
    [anon_sym_PLUS] = ACTIONS(2349),
    [anon_sym_STAR] = ACTIONS(2347),
    [anon_sym_AMP_AMP] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2349),
    [anon_sym_LT] = ACTIONS(2487),
    [anon_sym_COLON] = ACTIONS(2349),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym___extension__] = ACTIONS(2349),
    [anon_sym_typedef] = ACTIONS(2349),
    [anon_sym_in] = ACTIONS(2349),
    [anon_sym_out] = ACTIONS(2349),
    [anon_sym_inout] = ACTIONS(2349),
    [anon_sym_extern] = ACTIONS(2349),
    [anon_sym___attribute__] = ACTIONS(2349),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2347),
    [anon_sym___declspec] = ACTIONS(2349),
    [anon_sym___based] = ACTIONS(2349),
    [anon_sym___cdecl] = ACTIONS(2349),
    [anon_sym___clrcall] = ACTIONS(2349),
    [anon_sym___stdcall] = ACTIONS(2349),
    [anon_sym___fastcall] = ACTIONS(2349),
    [anon_sym___thiscall] = ACTIONS(2349),
    [anon_sym___vectorcall] = ACTIONS(2349),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_signed] = ACTIONS(2349),
    [anon_sym_unsigned] = ACTIONS(2349),
    [anon_sym_long] = ACTIONS(2349),
    [anon_sym_short] = ACTIONS(2349),
    [anon_sym_LBRACK] = ACTIONS(2349),
    [anon_sym_static] = ACTIONS(2349),
    [anon_sym_register] = ACTIONS(2349),
    [anon_sym_inline] = ACTIONS(2349),
    [anon_sym___inline] = ACTIONS(2349),
    [anon_sym___inline__] = ACTIONS(2349),
    [anon_sym___forceinline] = ACTIONS(2349),
    [anon_sym_thread_local] = ACTIONS(2349),
    [anon_sym___thread] = ACTIONS(2349),
    [anon_sym_const] = ACTIONS(2349),
    [anon_sym_constexpr] = ACTIONS(2349),
    [anon_sym_volatile] = ACTIONS(2349),
    [anon_sym_restrict] = ACTIONS(2349),
    [anon_sym___restrict__] = ACTIONS(2349),
    [anon_sym__Atomic] = ACTIONS(2349),
    [anon_sym__Noreturn] = ACTIONS(2349),
    [anon_sym_noreturn] = ACTIONS(2349),
    [anon_sym_mutable] = ACTIONS(2349),
    [anon_sym_constinit] = ACTIONS(2349),
    [anon_sym_consteval] = ACTIONS(2349),
    [anon_sym_alignas] = ACTIONS(2349),
    [anon_sym__Alignas] = ACTIONS(2349),
    [sym_primitive_type] = ACTIONS(2349),
    [anon_sym_enum] = ACTIONS(2349),
    [anon_sym_class] = ACTIONS(2349),
    [anon_sym_struct] = ACTIONS(2349),
    [anon_sym_union] = ACTIONS(2349),
    [anon_sym_if] = ACTIONS(2349),
    [anon_sym_else] = ACTIONS(2349),
    [anon_sym_switch] = ACTIONS(2349),
    [anon_sym_case] = ACTIONS(2349),
    [anon_sym_default] = ACTIONS(2349),
    [anon_sym_while] = ACTIONS(2349),
    [anon_sym_do] = ACTIONS(2349),
    [anon_sym_for] = ACTIONS(2349),
    [anon_sym_return] = ACTIONS(2349),
    [anon_sym_break] = ACTIONS(2349),
    [anon_sym_continue] = ACTIONS(2349),
    [anon_sym_goto] = ACTIONS(2349),
    [anon_sym___try] = ACTIONS(2349),
    [anon_sym___leave] = ACTIONS(2349),
    [anon_sym_not] = ACTIONS(2349),
    [anon_sym_compl] = ACTIONS(2349),
    [anon_sym_DASH_DASH] = ACTIONS(2347),
    [anon_sym_PLUS_PLUS] = ACTIONS(2347),
    [anon_sym_sizeof] = ACTIONS(2349),
    [anon_sym___alignof__] = ACTIONS(2349),
    [anon_sym___alignof] = ACTIONS(2349),
    [anon_sym__alignof] = ACTIONS(2349),
    [anon_sym_alignof] = ACTIONS(2349),
    [anon_sym__Alignof] = ACTIONS(2349),
    [anon_sym_offsetof] = ACTIONS(2349),
    [anon_sym__Generic] = ACTIONS(2349),
    [anon_sym_asm] = ACTIONS(2349),
    [anon_sym___asm__] = ACTIONS(2349),
    [sym_number_literal] = ACTIONS(2347),
    [anon_sym_L_SQUOTE] = ACTIONS(2347),
    [anon_sym_u_SQUOTE] = ACTIONS(2347),
    [anon_sym_U_SQUOTE] = ACTIONS(2347),
    [anon_sym_u8_SQUOTE] = ACTIONS(2347),
    [anon_sym_SQUOTE] = ACTIONS(2347),
    [anon_sym_L_DQUOTE] = ACTIONS(2347),
    [anon_sym_u_DQUOTE] = ACTIONS(2347),
    [anon_sym_U_DQUOTE] = ACTIONS(2347),
    [anon_sym_u8_DQUOTE] = ACTIONS(2347),
    [anon_sym_DQUOTE] = ACTIONS(2347),
    [sym_true] = ACTIONS(2349),
    [sym_false] = ACTIONS(2349),
    [anon_sym_NULL] = ACTIONS(2349),
    [anon_sym_nullptr] = ACTIONS(2349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2349),
    [anon_sym_let] = ACTIONS(2349),
    [anon_sym_This] = ACTIONS(2349),
    [anon_sym_decltype] = ACTIONS(2349),
    [anon_sym_final] = ACTIONS(2349),
    [anon_sym_override] = ACTIONS(2349),
    [sym_virtual] = ACTIONS(2349),
    [anon_sym_explicit] = ACTIONS(2349),
    [anon_sym_typename] = ACTIONS(2349),
    [anon_sym_template] = ACTIONS(2349),
    [anon_sym_operator] = ACTIONS(2349),
    [anon_sym_try] = ACTIONS(2349),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_throw] = ACTIONS(2349),
    [anon_sym_namespace] = ACTIONS(2349),
    [anon_sym_using] = ACTIONS(2349),
    [anon_sym_static_assert] = ACTIONS(2349),
    [anon_sym_concept] = ACTIONS(2349),
    [anon_sym_co_return] = ACTIONS(2349),
    [anon_sym_co_yield] = ACTIONS(2349),
    [anon_sym_R_DQUOTE] = ACTIONS(2347),
    [anon_sym_LR_DQUOTE] = ACTIONS(2347),
    [anon_sym_uR_DQUOTE] = ACTIONS(2347),
    [anon_sym_UR_DQUOTE] = ACTIONS(2347),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2347),
    [anon_sym_co_await] = ACTIONS(2349),
    [anon_sym_new] = ACTIONS(2349),
    [anon_sym_requires] = ACTIONS(2349),
    [sym_this] = ACTIONS(2349),
    [anon_sym_discard] = ACTIONS(2349),
    [anon_sym_precise] = ACTIONS(2349),
    [anon_sym_shared] = ACTIONS(2349),
    [anon_sym_groupshared] = ACTIONS(2349),
    [anon_sym_uniform] = ACTIONS(2349),
    [anon_sym_row_major] = ACTIONS(2349),
    [anon_sym_column_major] = ACTIONS(2349),
    [anon_sym_globallycoherent] = ACTIONS(2349),
    [anon_sym_centroid] = ACTIONS(2349),
    [anon_sym_noperspective] = ACTIONS(2349),
    [anon_sym_nointerpolation] = ACTIONS(2349),
    [anon_sym_sample] = ACTIONS(2349),
    [anon_sym_linear] = ACTIONS(2349),
    [anon_sym_snorm] = ACTIONS(2349),
    [anon_sym_unorm] = ACTIONS(2349),
    [anon_sym_point] = ACTIONS(2349),
    [anon_sym_line] = ACTIONS(2349),
    [anon_sym_triangleadj] = ACTIONS(2349),
    [anon_sym_lineadj] = ACTIONS(2349),
    [anon_sym_triangle] = ACTIONS(2349),
    [anon_sym_cbuffer] = ACTIONS(2349),
    [anon_sym_interface] = ACTIONS(2349),
    [anon_sym_extension] = ACTIONS(2349),
  },
  [234] = {
    [ts_builtin_sym_end] = ACTIONS(2489),
    [sym_identifier] = ACTIONS(2491),
    [aux_sym_preproc_include_token1] = ACTIONS(2491),
    [aux_sym_preproc_def_token1] = ACTIONS(2491),
    [anon_sym_COMMA] = ACTIONS(2489),
    [anon_sym_RPAREN] = ACTIONS(2489),
    [aux_sym_preproc_if_token1] = ACTIONS(2491),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2491),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2491),
    [sym_preproc_directive] = ACTIONS(2491),
    [anon_sym_LPAREN2] = ACTIONS(2489),
    [anon_sym_BANG] = ACTIONS(2489),
    [anon_sym_TILDE] = ACTIONS(2489),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(2489),
    [anon_sym_AMP_AMP] = ACTIONS(2489),
    [anon_sym_AMP] = ACTIONS(2491),
    [anon_sym_SEMI] = ACTIONS(2489),
    [anon_sym___extension__] = ACTIONS(2491),
    [anon_sym_typedef] = ACTIONS(2491),
    [anon_sym_in] = ACTIONS(2491),
    [anon_sym_out] = ACTIONS(2491),
    [anon_sym_inout] = ACTIONS(2491),
    [anon_sym_extern] = ACTIONS(2491),
    [anon_sym___attribute__] = ACTIONS(2491),
    [anon_sym_COLON_COLON] = ACTIONS(2489),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2489),
    [anon_sym___declspec] = ACTIONS(2491),
    [anon_sym___based] = ACTIONS(2491),
    [anon_sym___cdecl] = ACTIONS(2491),
    [anon_sym___clrcall] = ACTIONS(2491),
    [anon_sym___stdcall] = ACTIONS(2491),
    [anon_sym___fastcall] = ACTIONS(2491),
    [anon_sym___thiscall] = ACTIONS(2491),
    [anon_sym___vectorcall] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(2489),
    [anon_sym_signed] = ACTIONS(2491),
    [anon_sym_unsigned] = ACTIONS(2491),
    [anon_sym_long] = ACTIONS(2491),
    [anon_sym_short] = ACTIONS(2491),
    [anon_sym_LBRACK] = ACTIONS(2491),
    [anon_sym_static] = ACTIONS(2491),
    [anon_sym_register] = ACTIONS(2491),
    [anon_sym_inline] = ACTIONS(2491),
    [anon_sym___inline] = ACTIONS(2491),
    [anon_sym___inline__] = ACTIONS(2491),
    [anon_sym___forceinline] = ACTIONS(2491),
    [anon_sym_thread_local] = ACTIONS(2491),
    [anon_sym___thread] = ACTIONS(2491),
    [anon_sym_const] = ACTIONS(2491),
    [anon_sym_constexpr] = ACTIONS(2491),
    [anon_sym_volatile] = ACTIONS(2491),
    [anon_sym_restrict] = ACTIONS(2491),
    [anon_sym___restrict__] = ACTIONS(2491),
    [anon_sym__Atomic] = ACTIONS(2491),
    [anon_sym__Noreturn] = ACTIONS(2491),
    [anon_sym_noreturn] = ACTIONS(2491),
    [anon_sym_mutable] = ACTIONS(2491),
    [anon_sym_constinit] = ACTIONS(2491),
    [anon_sym_consteval] = ACTIONS(2491),
    [anon_sym_alignas] = ACTIONS(2491),
    [anon_sym__Alignas] = ACTIONS(2491),
    [sym_primitive_type] = ACTIONS(2491),
    [anon_sym_enum] = ACTIONS(2491),
    [anon_sym_class] = ACTIONS(2491),
    [anon_sym_struct] = ACTIONS(2491),
    [anon_sym_union] = ACTIONS(2491),
    [anon_sym_if] = ACTIONS(2491),
    [anon_sym_else] = ACTIONS(2491),
    [anon_sym_switch] = ACTIONS(2491),
    [anon_sym_case] = ACTIONS(2491),
    [anon_sym_default] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2491),
    [anon_sym_do] = ACTIONS(2491),
    [anon_sym_for] = ACTIONS(2491),
    [anon_sym_return] = ACTIONS(2491),
    [anon_sym_break] = ACTIONS(2491),
    [anon_sym_continue] = ACTIONS(2491),
    [anon_sym_goto] = ACTIONS(2491),
    [anon_sym___try] = ACTIONS(2491),
    [anon_sym___leave] = ACTIONS(2491),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(2489),
    [anon_sym_PLUS_PLUS] = ACTIONS(2489),
    [anon_sym_sizeof] = ACTIONS(2491),
    [anon_sym___alignof__] = ACTIONS(2491),
    [anon_sym___alignof] = ACTIONS(2491),
    [anon_sym__alignof] = ACTIONS(2491),
    [anon_sym_alignof] = ACTIONS(2491),
    [anon_sym__Alignof] = ACTIONS(2491),
    [anon_sym_offsetof] = ACTIONS(2491),
    [anon_sym__Generic] = ACTIONS(2491),
    [anon_sym_asm] = ACTIONS(2491),
    [anon_sym___asm__] = ACTIONS(2491),
    [anon_sym_DOT] = ACTIONS(2491),
    [sym_number_literal] = ACTIONS(2489),
    [anon_sym_L_SQUOTE] = ACTIONS(2489),
    [anon_sym_u_SQUOTE] = ACTIONS(2489),
    [anon_sym_U_SQUOTE] = ACTIONS(2489),
    [anon_sym_u8_SQUOTE] = ACTIONS(2489),
    [anon_sym_SQUOTE] = ACTIONS(2489),
    [anon_sym_L_DQUOTE] = ACTIONS(2489),
    [anon_sym_u_DQUOTE] = ACTIONS(2489),
    [anon_sym_U_DQUOTE] = ACTIONS(2489),
    [anon_sym_u8_DQUOTE] = ACTIONS(2489),
    [anon_sym_DQUOTE] = ACTIONS(2489),
    [sym_true] = ACTIONS(2491),
    [sym_false] = ACTIONS(2491),
    [anon_sym_NULL] = ACTIONS(2491),
    [anon_sym_nullptr] = ACTIONS(2491),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2491),
    [anon_sym_let] = ACTIONS(2491),
    [anon_sym_This] = ACTIONS(2491),
    [anon_sym_decltype] = ACTIONS(2491),
    [anon_sym_final] = ACTIONS(2491),
    [anon_sym_override] = ACTIONS(2491),
    [sym_virtual] = ACTIONS(2491),
    [anon_sym_explicit] = ACTIONS(2491),
    [anon_sym_typename] = ACTIONS(2491),
    [anon_sym_template] = ACTIONS(2491),
    [anon_sym_GT2] = ACTIONS(2489),
    [anon_sym_operator] = ACTIONS(2491),
    [anon_sym_try] = ACTIONS(2491),
    [anon_sym_delete] = ACTIONS(2491),
    [anon_sym_throw] = ACTIONS(2491),
    [anon_sym_namespace] = ACTIONS(2491),
    [anon_sym_using] = ACTIONS(2491),
    [anon_sym_static_assert] = ACTIONS(2491),
    [anon_sym_concept] = ACTIONS(2491),
    [anon_sym_co_return] = ACTIONS(2491),
    [anon_sym_co_yield] = ACTIONS(2491),
    [anon_sym_R_DQUOTE] = ACTIONS(2489),
    [anon_sym_LR_DQUOTE] = ACTIONS(2489),
    [anon_sym_uR_DQUOTE] = ACTIONS(2489),
    [anon_sym_UR_DQUOTE] = ACTIONS(2489),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2489),
    [anon_sym_co_await] = ACTIONS(2491),
    [anon_sym_new] = ACTIONS(2491),
    [anon_sym_requires] = ACTIONS(2491),
    [sym_this] = ACTIONS(2491),
    [anon_sym_discard] = ACTIONS(2491),
    [anon_sym_precise] = ACTIONS(2491),
    [anon_sym_shared] = ACTIONS(2491),
    [anon_sym_groupshared] = ACTIONS(2491),
    [anon_sym_uniform] = ACTIONS(2491),
    [anon_sym_row_major] = ACTIONS(2491),
    [anon_sym_column_major] = ACTIONS(2491),
    [anon_sym_globallycoherent] = ACTIONS(2491),
    [anon_sym_centroid] = ACTIONS(2491),
    [anon_sym_noperspective] = ACTIONS(2491),
    [anon_sym_nointerpolation] = ACTIONS(2491),
    [anon_sym_sample] = ACTIONS(2491),
    [anon_sym_linear] = ACTIONS(2491),
    [anon_sym_snorm] = ACTIONS(2491),
    [anon_sym_unorm] = ACTIONS(2491),
    [anon_sym_point] = ACTIONS(2491),
    [anon_sym_line] = ACTIONS(2491),
    [anon_sym_triangleadj] = ACTIONS(2491),
    [anon_sym_lineadj] = ACTIONS(2491),
    [anon_sym_triangle] = ACTIONS(2491),
    [anon_sym_cbuffer] = ACTIONS(2491),
    [anon_sym_interface] = ACTIONS(2491),
    [anon_sym_extension] = ACTIONS(2491),
    [anon_sym_where] = ACTIONS(2491),
    [anon_sym___exported] = ACTIONS(2491),
    [anon_sym_import] = ACTIONS(2491),
  },
  [235] = {
    [sym_template_argument_list] = STATE(251),
    [sym_identifier] = ACTIONS(2169),
    [aux_sym_preproc_include_token1] = ACTIONS(2169),
    [aux_sym_preproc_def_token1] = ACTIONS(2169),
    [aux_sym_preproc_if_token1] = ACTIONS(2169),
    [aux_sym_preproc_if_token2] = ACTIONS(2169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2169),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2169),
    [aux_sym_preproc_else_token1] = ACTIONS(2169),
    [aux_sym_preproc_elif_token1] = ACTIONS(2169),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2169),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2169),
    [sym_preproc_directive] = ACTIONS(2169),
    [anon_sym_LPAREN2] = ACTIONS(2176),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2169),
    [anon_sym_PLUS] = ACTIONS(2169),
    [anon_sym_STAR] = ACTIONS(2176),
    [anon_sym_AMP_AMP] = ACTIONS(2176),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(2487),
    [anon_sym_COLON] = ACTIONS(2169),
    [anon_sym_SEMI] = ACTIONS(2176),
    [anon_sym___extension__] = ACTIONS(2169),
    [anon_sym_typedef] = ACTIONS(2169),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_out] = ACTIONS(2169),
    [anon_sym_inout] = ACTIONS(2169),
    [anon_sym_extern] = ACTIONS(2169),
    [anon_sym___attribute__] = ACTIONS(2169),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2176),
    [anon_sym___declspec] = ACTIONS(2169),
    [anon_sym___based] = ACTIONS(2169),
    [anon_sym___cdecl] = ACTIONS(2169),
    [anon_sym___clrcall] = ACTIONS(2169),
    [anon_sym___stdcall] = ACTIONS(2169),
    [anon_sym___fastcall] = ACTIONS(2169),
    [anon_sym___thiscall] = ACTIONS(2169),
    [anon_sym___vectorcall] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2176),
    [anon_sym_signed] = ACTIONS(2169),
    [anon_sym_unsigned] = ACTIONS(2169),
    [anon_sym_long] = ACTIONS(2169),
    [anon_sym_short] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(2169),
    [anon_sym_static] = ACTIONS(2169),
    [anon_sym_register] = ACTIONS(2169),
    [anon_sym_inline] = ACTIONS(2169),
    [anon_sym___inline] = ACTIONS(2169),
    [anon_sym___inline__] = ACTIONS(2169),
    [anon_sym___forceinline] = ACTIONS(2169),
    [anon_sym_thread_local] = ACTIONS(2169),
    [anon_sym___thread] = ACTIONS(2169),
    [anon_sym_const] = ACTIONS(2169),
    [anon_sym_constexpr] = ACTIONS(2169),
    [anon_sym_volatile] = ACTIONS(2169),
    [anon_sym_restrict] = ACTIONS(2169),
    [anon_sym___restrict__] = ACTIONS(2169),
    [anon_sym__Atomic] = ACTIONS(2169),
    [anon_sym__Noreturn] = ACTIONS(2169),
    [anon_sym_noreturn] = ACTIONS(2169),
    [anon_sym_mutable] = ACTIONS(2169),
    [anon_sym_constinit] = ACTIONS(2169),
    [anon_sym_consteval] = ACTIONS(2169),
    [anon_sym_alignas] = ACTIONS(2169),
    [anon_sym__Alignas] = ACTIONS(2169),
    [sym_primitive_type] = ACTIONS(2169),
    [anon_sym_enum] = ACTIONS(2169),
    [anon_sym_class] = ACTIONS(2169),
    [anon_sym_struct] = ACTIONS(2169),
    [anon_sym_union] = ACTIONS(2169),
    [anon_sym_if] = ACTIONS(2169),
    [anon_sym_else] = ACTIONS(2169),
    [anon_sym_switch] = ACTIONS(2169),
    [anon_sym_case] = ACTIONS(2169),
    [anon_sym_default] = ACTIONS(2169),
    [anon_sym_while] = ACTIONS(2169),
    [anon_sym_do] = ACTIONS(2169),
    [anon_sym_for] = ACTIONS(2169),
    [anon_sym_return] = ACTIONS(2169),
    [anon_sym_break] = ACTIONS(2169),
    [anon_sym_continue] = ACTIONS(2169),
    [anon_sym_goto] = ACTIONS(2169),
    [anon_sym___try] = ACTIONS(2169),
    [anon_sym___leave] = ACTIONS(2169),
    [anon_sym_not] = ACTIONS(2169),
    [anon_sym_compl] = ACTIONS(2169),
    [anon_sym_DASH_DASH] = ACTIONS(2176),
    [anon_sym_PLUS_PLUS] = ACTIONS(2176),
    [anon_sym_sizeof] = ACTIONS(2169),
    [anon_sym___alignof__] = ACTIONS(2169),
    [anon_sym___alignof] = ACTIONS(2169),
    [anon_sym__alignof] = ACTIONS(2169),
    [anon_sym_alignof] = ACTIONS(2169),
    [anon_sym__Alignof] = ACTIONS(2169),
    [anon_sym_offsetof] = ACTIONS(2169),
    [anon_sym__Generic] = ACTIONS(2169),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [sym_number_literal] = ACTIONS(2176),
    [anon_sym_L_SQUOTE] = ACTIONS(2176),
    [anon_sym_u_SQUOTE] = ACTIONS(2176),
    [anon_sym_U_SQUOTE] = ACTIONS(2176),
    [anon_sym_u8_SQUOTE] = ACTIONS(2176),
    [anon_sym_SQUOTE] = ACTIONS(2176),
    [anon_sym_L_DQUOTE] = ACTIONS(2176),
    [anon_sym_u_DQUOTE] = ACTIONS(2176),
    [anon_sym_U_DQUOTE] = ACTIONS(2176),
    [anon_sym_u8_DQUOTE] = ACTIONS(2176),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [sym_true] = ACTIONS(2169),
    [sym_false] = ACTIONS(2169),
    [anon_sym_NULL] = ACTIONS(2169),
    [anon_sym_nullptr] = ACTIONS(2169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2169),
    [anon_sym_let] = ACTIONS(2169),
    [anon_sym_This] = ACTIONS(2169),
    [anon_sym_decltype] = ACTIONS(2169),
    [anon_sym_final] = ACTIONS(2169),
    [anon_sym_override] = ACTIONS(2169),
    [sym_virtual] = ACTIONS(2169),
    [anon_sym_explicit] = ACTIONS(2169),
    [anon_sym_typename] = ACTIONS(2169),
    [anon_sym_template] = ACTIONS(2169),
    [anon_sym_operator] = ACTIONS(2169),
    [anon_sym_try] = ACTIONS(2169),
    [anon_sym_delete] = ACTIONS(2169),
    [anon_sym_throw] = ACTIONS(2169),
    [anon_sym_namespace] = ACTIONS(2169),
    [anon_sym_using] = ACTIONS(2169),
    [anon_sym_static_assert] = ACTIONS(2169),
    [anon_sym_concept] = ACTIONS(2169),
    [anon_sym_co_return] = ACTIONS(2169),
    [anon_sym_co_yield] = ACTIONS(2169),
    [anon_sym_R_DQUOTE] = ACTIONS(2176),
    [anon_sym_LR_DQUOTE] = ACTIONS(2176),
    [anon_sym_uR_DQUOTE] = ACTIONS(2176),
    [anon_sym_UR_DQUOTE] = ACTIONS(2176),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2176),
    [anon_sym_co_await] = ACTIONS(2169),
    [anon_sym_new] = ACTIONS(2169),
    [anon_sym_requires] = ACTIONS(2169),
    [sym_this] = ACTIONS(2169),
    [anon_sym_discard] = ACTIONS(2169),
    [anon_sym_precise] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_groupshared] = ACTIONS(2169),
    [anon_sym_uniform] = ACTIONS(2169),
    [anon_sym_row_major] = ACTIONS(2169),
    [anon_sym_column_major] = ACTIONS(2169),
    [anon_sym_globallycoherent] = ACTIONS(2169),
    [anon_sym_centroid] = ACTIONS(2169),
    [anon_sym_noperspective] = ACTIONS(2169),
    [anon_sym_nointerpolation] = ACTIONS(2169),
    [anon_sym_sample] = ACTIONS(2169),
    [anon_sym_linear] = ACTIONS(2169),
    [anon_sym_snorm] = ACTIONS(2169),
    [anon_sym_unorm] = ACTIONS(2169),
    [anon_sym_point] = ACTIONS(2169),
    [anon_sym_line] = ACTIONS(2169),
    [anon_sym_triangleadj] = ACTIONS(2169),
    [anon_sym_lineadj] = ACTIONS(2169),
    [anon_sym_triangle] = ACTIONS(2169),
    [anon_sym_cbuffer] = ACTIONS(2169),
    [anon_sym_interface] = ACTIONS(2169),
    [anon_sym_extension] = ACTIONS(2169),
  },
  [236] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_qualifiers] = STATE(2666),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(2493),
    [aux_sym_preproc_include_token1] = ACTIONS(2496),
    [aux_sym_preproc_def_token1] = ACTIONS(2496),
    [aux_sym_preproc_if_token1] = ACTIONS(2496),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2496),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2496),
    [sym_preproc_directive] = ACTIONS(2496),
    [anon_sym_LPAREN2] = ACTIONS(2498),
    [anon_sym_BANG] = ACTIONS(2501),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(2498),
    [anon_sym_AMP_AMP] = ACTIONS(2498),
    [anon_sym_AMP] = ACTIONS(2493),
    [anon_sym_SEMI] = ACTIONS(2503),
    [anon_sym___extension__] = ACTIONS(2506),
    [anon_sym_typedef] = ACTIONS(2496),
    [anon_sym_in] = ACTIONS(2509),
    [anon_sym_out] = ACTIONS(2509),
    [anon_sym_inout] = ACTIONS(2509),
    [anon_sym_extern] = ACTIONS(2512),
    [anon_sym___attribute__] = ACTIONS(2515),
    [anon_sym_COLON_COLON] = ACTIONS(2498),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2518),
    [anon_sym___declspec] = ACTIONS(2521),
    [anon_sym___based] = ACTIONS(2493),
    [anon_sym___cdecl] = ACTIONS(2493),
    [anon_sym___clrcall] = ACTIONS(2493),
    [anon_sym___stdcall] = ACTIONS(2493),
    [anon_sym___fastcall] = ACTIONS(2493),
    [anon_sym___thiscall] = ACTIONS(2493),
    [anon_sym___vectorcall] = ACTIONS(2493),
    [anon_sym_LBRACE] = ACTIONS(2501),
    [anon_sym_RBRACE] = ACTIONS(2501),
    [anon_sym_signed] = ACTIONS(2496),
    [anon_sym_unsigned] = ACTIONS(2496),
    [anon_sym_long] = ACTIONS(2496),
    [anon_sym_short] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(2493),
    [anon_sym_static] = ACTIONS(2512),
    [anon_sym_register] = ACTIONS(2512),
    [anon_sym_inline] = ACTIONS(2512),
    [anon_sym___inline] = ACTIONS(2512),
    [anon_sym___inline__] = ACTIONS(2512),
    [anon_sym___forceinline] = ACTIONS(2512),
    [anon_sym_thread_local] = ACTIONS(2512),
    [anon_sym___thread] = ACTIONS(2512),
    [anon_sym_const] = ACTIONS(2506),
    [anon_sym_constexpr] = ACTIONS(2506),
    [anon_sym_volatile] = ACTIONS(2506),
    [anon_sym_restrict] = ACTIONS(2506),
    [anon_sym___restrict__] = ACTIONS(2506),
    [anon_sym__Atomic] = ACTIONS(2506),
    [anon_sym__Noreturn] = ACTIONS(2506),
    [anon_sym_noreturn] = ACTIONS(2506),
    [anon_sym_mutable] = ACTIONS(2506),
    [anon_sym_constinit] = ACTIONS(2506),
    [anon_sym_consteval] = ACTIONS(2506),
    [anon_sym_alignas] = ACTIONS(2524),
    [anon_sym__Alignas] = ACTIONS(2524),
    [sym_primitive_type] = ACTIONS(2496),
    [anon_sym_enum] = ACTIONS(2496),
    [anon_sym_class] = ACTIONS(2496),
    [anon_sym_struct] = ACTIONS(2496),
    [anon_sym_union] = ACTIONS(2496),
    [anon_sym_if] = ACTIONS(2496),
    [anon_sym_switch] = ACTIONS(2496),
    [anon_sym_case] = ACTIONS(2496),
    [anon_sym_default] = ACTIONS(2496),
    [anon_sym_while] = ACTIONS(2496),
    [anon_sym_do] = ACTIONS(2496),
    [anon_sym_for] = ACTIONS(2496),
    [anon_sym_return] = ACTIONS(2496),
    [anon_sym_break] = ACTIONS(2496),
    [anon_sym_continue] = ACTIONS(2496),
    [anon_sym_goto] = ACTIONS(2496),
    [anon_sym___try] = ACTIONS(2496),
    [anon_sym___leave] = ACTIONS(2496),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(2501),
    [anon_sym_PLUS_PLUS] = ACTIONS(2501),
    [anon_sym_sizeof] = ACTIONS(2496),
    [anon_sym___alignof__] = ACTIONS(2496),
    [anon_sym___alignof] = ACTIONS(2496),
    [anon_sym__alignof] = ACTIONS(2496),
    [anon_sym_alignof] = ACTIONS(2496),
    [anon_sym__Alignof] = ACTIONS(2496),
    [anon_sym_offsetof] = ACTIONS(2496),
    [anon_sym__Generic] = ACTIONS(2496),
    [anon_sym_asm] = ACTIONS(2496),
    [anon_sym___asm__] = ACTIONS(2496),
    [anon_sym_DOT] = ACTIONS(2527),
    [sym_number_literal] = ACTIONS(2501),
    [anon_sym_L_SQUOTE] = ACTIONS(2501),
    [anon_sym_u_SQUOTE] = ACTIONS(2501),
    [anon_sym_U_SQUOTE] = ACTIONS(2501),
    [anon_sym_u8_SQUOTE] = ACTIONS(2501),
    [anon_sym_SQUOTE] = ACTIONS(2501),
    [anon_sym_L_DQUOTE] = ACTIONS(2501),
    [anon_sym_u_DQUOTE] = ACTIONS(2501),
    [anon_sym_U_DQUOTE] = ACTIONS(2501),
    [anon_sym_u8_DQUOTE] = ACTIONS(2501),
    [anon_sym_DQUOTE] = ACTIONS(2501),
    [sym_true] = ACTIONS(2496),
    [sym_false] = ACTIONS(2496),
    [anon_sym_NULL] = ACTIONS(2496),
    [anon_sym_nullptr] = ACTIONS(2496),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2529),
    [anon_sym_let] = ACTIONS(2529),
    [anon_sym_This] = ACTIONS(2529),
    [anon_sym_decltype] = ACTIONS(2493),
    [sym_virtual] = ACTIONS(2509),
    [anon_sym_explicit] = ACTIONS(2496),
    [anon_sym_typename] = ACTIONS(2496),
    [anon_sym_template] = ACTIONS(2493),
    [anon_sym_operator] = ACTIONS(2493),
    [anon_sym_try] = ACTIONS(2496),
    [anon_sym_delete] = ACTIONS(2496),
    [anon_sym_throw] = ACTIONS(2496),
    [anon_sym_namespace] = ACTIONS(2496),
    [anon_sym_using] = ACTIONS(2496),
    [anon_sym_static_assert] = ACTIONS(2496),
    [anon_sym_concept] = ACTIONS(2496),
    [anon_sym_co_return] = ACTIONS(2496),
    [anon_sym_co_yield] = ACTIONS(2496),
    [anon_sym_R_DQUOTE] = ACTIONS(2501),
    [anon_sym_LR_DQUOTE] = ACTIONS(2501),
    [anon_sym_uR_DQUOTE] = ACTIONS(2501),
    [anon_sym_UR_DQUOTE] = ACTIONS(2501),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2501),
    [anon_sym_co_await] = ACTIONS(2496),
    [anon_sym_new] = ACTIONS(2496),
    [anon_sym_requires] = ACTIONS(2496),
    [sym_this] = ACTIONS(2496),
    [anon_sym_discard] = ACTIONS(2496),
    [anon_sym_precise] = ACTIONS(2531),
    [anon_sym_shared] = ACTIONS(2531),
    [anon_sym_groupshared] = ACTIONS(2531),
    [anon_sym_uniform] = ACTIONS(2531),
    [anon_sym_row_major] = ACTIONS(2531),
    [anon_sym_column_major] = ACTIONS(2531),
    [anon_sym_globallycoherent] = ACTIONS(2531),
    [anon_sym_centroid] = ACTIONS(2531),
    [anon_sym_noperspective] = ACTIONS(2531),
    [anon_sym_nointerpolation] = ACTIONS(2531),
    [anon_sym_sample] = ACTIONS(2531),
    [anon_sym_linear] = ACTIONS(2531),
    [anon_sym_snorm] = ACTIONS(2531),
    [anon_sym_unorm] = ACTIONS(2531),
    [anon_sym_point] = ACTIONS(2531),
    [anon_sym_line] = ACTIONS(2531),
    [anon_sym_triangleadj] = ACTIONS(2531),
    [anon_sym_lineadj] = ACTIONS(2531),
    [anon_sym_triangle] = ACTIONS(2531),
    [anon_sym_cbuffer] = ACTIONS(2496),
    [anon_sym_interface] = ACTIONS(2496),
    [anon_sym_extension] = ACTIONS(2496),
  },
  [237] = {
    [ts_builtin_sym_end] = ACTIONS(2534),
    [sym_identifier] = ACTIONS(2536),
    [aux_sym_preproc_include_token1] = ACTIONS(2536),
    [aux_sym_preproc_def_token1] = ACTIONS(2536),
    [anon_sym_COMMA] = ACTIONS(2534),
    [anon_sym_RPAREN] = ACTIONS(2534),
    [aux_sym_preproc_if_token1] = ACTIONS(2536),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2536),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2536),
    [sym_preproc_directive] = ACTIONS(2536),
    [anon_sym_LPAREN2] = ACTIONS(2534),
    [anon_sym_BANG] = ACTIONS(2534),
    [anon_sym_TILDE] = ACTIONS(2534),
    [anon_sym_DASH] = ACTIONS(2536),
    [anon_sym_PLUS] = ACTIONS(2536),
    [anon_sym_STAR] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
    [anon_sym_SEMI] = ACTIONS(2534),
    [anon_sym___extension__] = ACTIONS(2536),
    [anon_sym_typedef] = ACTIONS(2536),
    [anon_sym_in] = ACTIONS(2536),
    [anon_sym_out] = ACTIONS(2536),
    [anon_sym_inout] = ACTIONS(2536),
    [anon_sym_extern] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(2534),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2534),
    [anon_sym___declspec] = ACTIONS(2536),
    [anon_sym___based] = ACTIONS(2536),
    [anon_sym___cdecl] = ACTIONS(2536),
    [anon_sym___clrcall] = ACTIONS(2536),
    [anon_sym___stdcall] = ACTIONS(2536),
    [anon_sym___fastcall] = ACTIONS(2536),
    [anon_sym___thiscall] = ACTIONS(2536),
    [anon_sym___vectorcall] = ACTIONS(2536),
    [anon_sym_LBRACE] = ACTIONS(2534),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(2536),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_register] = ACTIONS(2536),
    [anon_sym_inline] = ACTIONS(2536),
    [anon_sym___inline] = ACTIONS(2536),
    [anon_sym___inline__] = ACTIONS(2536),
    [anon_sym___forceinline] = ACTIONS(2536),
    [anon_sym_thread_local] = ACTIONS(2536),
    [anon_sym___thread] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2536),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_class] = ACTIONS(2536),
    [anon_sym_struct] = ACTIONS(2536),
    [anon_sym_union] = ACTIONS(2536),
    [anon_sym_if] = ACTIONS(2536),
    [anon_sym_else] = ACTIONS(2536),
    [anon_sym_switch] = ACTIONS(2536),
    [anon_sym_case] = ACTIONS(2536),
    [anon_sym_default] = ACTIONS(2536),
    [anon_sym_while] = ACTIONS(2536),
    [anon_sym_do] = ACTIONS(2536),
    [anon_sym_for] = ACTIONS(2536),
    [anon_sym_return] = ACTIONS(2536),
    [anon_sym_break] = ACTIONS(2536),
    [anon_sym_continue] = ACTIONS(2536),
    [anon_sym_goto] = ACTIONS(2536),
    [anon_sym___try] = ACTIONS(2536),
    [anon_sym___leave] = ACTIONS(2536),
    [anon_sym_not] = ACTIONS(2536),
    [anon_sym_compl] = ACTIONS(2536),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_sizeof] = ACTIONS(2536),
    [anon_sym___alignof__] = ACTIONS(2536),
    [anon_sym___alignof] = ACTIONS(2536),
    [anon_sym__alignof] = ACTIONS(2536),
    [anon_sym_alignof] = ACTIONS(2536),
    [anon_sym__Alignof] = ACTIONS(2536),
    [anon_sym_offsetof] = ACTIONS(2536),
    [anon_sym__Generic] = ACTIONS(2536),
    [anon_sym_asm] = ACTIONS(2536),
    [anon_sym___asm__] = ACTIONS(2536),
    [anon_sym_DOT] = ACTIONS(2536),
    [sym_number_literal] = ACTIONS(2534),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2534),
    [anon_sym_u_DQUOTE] = ACTIONS(2534),
    [anon_sym_U_DQUOTE] = ACTIONS(2534),
    [anon_sym_u8_DQUOTE] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [sym_true] = ACTIONS(2536),
    [sym_false] = ACTIONS(2536),
    [anon_sym_NULL] = ACTIONS(2536),
    [anon_sym_nullptr] = ACTIONS(2536),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2536),
    [anon_sym_let] = ACTIONS(2536),
    [anon_sym_This] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2536),
    [anon_sym_final] = ACTIONS(2536),
    [anon_sym_override] = ACTIONS(2536),
    [sym_virtual] = ACTIONS(2536),
    [anon_sym_explicit] = ACTIONS(2536),
    [anon_sym_typename] = ACTIONS(2536),
    [anon_sym_template] = ACTIONS(2536),
    [anon_sym_GT2] = ACTIONS(2534),
    [anon_sym_operator] = ACTIONS(2536),
    [anon_sym_try] = ACTIONS(2536),
    [anon_sym_delete] = ACTIONS(2536),
    [anon_sym_throw] = ACTIONS(2536),
    [anon_sym_namespace] = ACTIONS(2536),
    [anon_sym_using] = ACTIONS(2536),
    [anon_sym_static_assert] = ACTIONS(2536),
    [anon_sym_concept] = ACTIONS(2536),
    [anon_sym_co_return] = ACTIONS(2536),
    [anon_sym_co_yield] = ACTIONS(2536),
    [anon_sym_R_DQUOTE] = ACTIONS(2534),
    [anon_sym_LR_DQUOTE] = ACTIONS(2534),
    [anon_sym_uR_DQUOTE] = ACTIONS(2534),
    [anon_sym_UR_DQUOTE] = ACTIONS(2534),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2534),
    [anon_sym_co_await] = ACTIONS(2536),
    [anon_sym_new] = ACTIONS(2536),
    [anon_sym_requires] = ACTIONS(2536),
    [sym_this] = ACTIONS(2536),
    [anon_sym_discard] = ACTIONS(2536),
    [anon_sym_precise] = ACTIONS(2536),
    [anon_sym_shared] = ACTIONS(2536),
    [anon_sym_groupshared] = ACTIONS(2536),
    [anon_sym_uniform] = ACTIONS(2536),
    [anon_sym_row_major] = ACTIONS(2536),
    [anon_sym_column_major] = ACTIONS(2536),
    [anon_sym_globallycoherent] = ACTIONS(2536),
    [anon_sym_centroid] = ACTIONS(2536),
    [anon_sym_noperspective] = ACTIONS(2536),
    [anon_sym_nointerpolation] = ACTIONS(2536),
    [anon_sym_sample] = ACTIONS(2536),
    [anon_sym_linear] = ACTIONS(2536),
    [anon_sym_snorm] = ACTIONS(2536),
    [anon_sym_unorm] = ACTIONS(2536),
    [anon_sym_point] = ACTIONS(2536),
    [anon_sym_line] = ACTIONS(2536),
    [anon_sym_triangleadj] = ACTIONS(2536),
    [anon_sym_lineadj] = ACTIONS(2536),
    [anon_sym_triangle] = ACTIONS(2536),
    [anon_sym_cbuffer] = ACTIONS(2536),
    [anon_sym_interface] = ACTIONS(2536),
    [anon_sym_extension] = ACTIONS(2536),
    [anon_sym_where] = ACTIONS(2536),
    [anon_sym___exported] = ACTIONS(2536),
    [anon_sym_import] = ACTIONS(2536),
  },
  [238] = {
    [sym_field_declaration_list] = STATE(599),
    [sym_virtual_specifier] = STATE(8890),
    [sym_base_class_clause] = STATE(9956),
    [ts_builtin_sym_end] = ACTIONS(2485),
    [sym_identifier] = ACTIONS(2483),
    [aux_sym_preproc_include_token1] = ACTIONS(2483),
    [aux_sym_preproc_def_token1] = ACTIONS(2483),
    [aux_sym_preproc_if_token1] = ACTIONS(2483),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2483),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2483),
    [sym_preproc_directive] = ACTIONS(2483),
    [anon_sym_LPAREN2] = ACTIONS(2485),
    [anon_sym_BANG] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2483),
    [anon_sym_PLUS] = ACTIONS(2483),
    [anon_sym_STAR] = ACTIONS(2485),
    [anon_sym_AMP_AMP] = ACTIONS(2485),
    [anon_sym_AMP] = ACTIONS(2483),
    [anon_sym_COLON] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(2485),
    [anon_sym___extension__] = ACTIONS(2483),
    [anon_sym_typedef] = ACTIONS(2483),
    [anon_sym_in] = ACTIONS(2483),
    [anon_sym_out] = ACTIONS(2483),
    [anon_sym_inout] = ACTIONS(2483),
    [anon_sym_extern] = ACTIONS(2483),
    [anon_sym___attribute__] = ACTIONS(2483),
    [anon_sym_COLON_COLON] = ACTIONS(2485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2485),
    [anon_sym___declspec] = ACTIONS(2483),
    [anon_sym___based] = ACTIONS(2483),
    [anon_sym___cdecl] = ACTIONS(2483),
    [anon_sym___clrcall] = ACTIONS(2483),
    [anon_sym___stdcall] = ACTIONS(2483),
    [anon_sym___fastcall] = ACTIONS(2483),
    [anon_sym___thiscall] = ACTIONS(2483),
    [anon_sym___vectorcall] = ACTIONS(2483),
    [anon_sym_LBRACE] = ACTIONS(2538),
    [anon_sym_signed] = ACTIONS(2483),
    [anon_sym_unsigned] = ACTIONS(2483),
    [anon_sym_long] = ACTIONS(2483),
    [anon_sym_short] = ACTIONS(2483),
    [anon_sym_LBRACK] = ACTIONS(2483),
    [anon_sym_static] = ACTIONS(2483),
    [anon_sym_register] = ACTIONS(2483),
    [anon_sym_inline] = ACTIONS(2483),
    [anon_sym___inline] = ACTIONS(2483),
    [anon_sym___inline__] = ACTIONS(2483),
    [anon_sym___forceinline] = ACTIONS(2483),
    [anon_sym_thread_local] = ACTIONS(2483),
    [anon_sym___thread] = ACTIONS(2483),
    [anon_sym_const] = ACTIONS(2483),
    [anon_sym_constexpr] = ACTIONS(2483),
    [anon_sym_volatile] = ACTIONS(2483),
    [anon_sym_restrict] = ACTIONS(2483),
    [anon_sym___restrict__] = ACTIONS(2483),
    [anon_sym__Atomic] = ACTIONS(2483),
    [anon_sym__Noreturn] = ACTIONS(2483),
    [anon_sym_noreturn] = ACTIONS(2483),
    [anon_sym_mutable] = ACTIONS(2483),
    [anon_sym_constinit] = ACTIONS(2483),
    [anon_sym_consteval] = ACTIONS(2483),
    [anon_sym_alignas] = ACTIONS(2483),
    [anon_sym__Alignas] = ACTIONS(2483),
    [sym_primitive_type] = ACTIONS(2483),
    [anon_sym_enum] = ACTIONS(2483),
    [anon_sym_class] = ACTIONS(2483),
    [anon_sym_struct] = ACTIONS(2483),
    [anon_sym_union] = ACTIONS(2483),
    [anon_sym_if] = ACTIONS(2483),
    [anon_sym_else] = ACTIONS(2483),
    [anon_sym_switch] = ACTIONS(2483),
    [anon_sym_case] = ACTIONS(2483),
    [anon_sym_default] = ACTIONS(2483),
    [anon_sym_while] = ACTIONS(2483),
    [anon_sym_do] = ACTIONS(2483),
    [anon_sym_for] = ACTIONS(2483),
    [anon_sym_return] = ACTIONS(2483),
    [anon_sym_break] = ACTIONS(2483),
    [anon_sym_continue] = ACTIONS(2483),
    [anon_sym_goto] = ACTIONS(2483),
    [anon_sym___try] = ACTIONS(2483),
    [anon_sym___leave] = ACTIONS(2483),
    [anon_sym_not] = ACTIONS(2483),
    [anon_sym_compl] = ACTIONS(2483),
    [anon_sym_DASH_DASH] = ACTIONS(2485),
    [anon_sym_PLUS_PLUS] = ACTIONS(2485),
    [anon_sym_sizeof] = ACTIONS(2483),
    [anon_sym___alignof__] = ACTIONS(2483),
    [anon_sym___alignof] = ACTIONS(2483),
    [anon_sym__alignof] = ACTIONS(2483),
    [anon_sym_alignof] = ACTIONS(2483),
    [anon_sym__Alignof] = ACTIONS(2483),
    [anon_sym_offsetof] = ACTIONS(2483),
    [anon_sym__Generic] = ACTIONS(2483),
    [anon_sym_asm] = ACTIONS(2483),
    [anon_sym___asm__] = ACTIONS(2483),
    [sym_number_literal] = ACTIONS(2485),
    [anon_sym_L_SQUOTE] = ACTIONS(2485),
    [anon_sym_u_SQUOTE] = ACTIONS(2485),
    [anon_sym_U_SQUOTE] = ACTIONS(2485),
    [anon_sym_u8_SQUOTE] = ACTIONS(2485),
    [anon_sym_SQUOTE] = ACTIONS(2485),
    [anon_sym_L_DQUOTE] = ACTIONS(2485),
    [anon_sym_u_DQUOTE] = ACTIONS(2485),
    [anon_sym_U_DQUOTE] = ACTIONS(2485),
    [anon_sym_u8_DQUOTE] = ACTIONS(2485),
    [anon_sym_DQUOTE] = ACTIONS(2485),
    [sym_true] = ACTIONS(2483),
    [sym_false] = ACTIONS(2483),
    [anon_sym_NULL] = ACTIONS(2483),
    [anon_sym_nullptr] = ACTIONS(2483),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2483),
    [anon_sym_let] = ACTIONS(2483),
    [anon_sym_This] = ACTIONS(2483),
    [anon_sym_decltype] = ACTIONS(2483),
    [anon_sym_final] = ACTIONS(2481),
    [anon_sym_override] = ACTIONS(2481),
    [sym_virtual] = ACTIONS(2483),
    [anon_sym_explicit] = ACTIONS(2483),
    [anon_sym_typename] = ACTIONS(2483),
    [anon_sym_template] = ACTIONS(2483),
    [anon_sym_operator] = ACTIONS(2483),
    [anon_sym_try] = ACTIONS(2483),
    [anon_sym_delete] = ACTIONS(2483),
    [anon_sym_throw] = ACTIONS(2483),
    [anon_sym_namespace] = ACTIONS(2483),
    [anon_sym_using] = ACTIONS(2483),
    [anon_sym_static_assert] = ACTIONS(2483),
    [anon_sym_concept] = ACTIONS(2483),
    [anon_sym_co_return] = ACTIONS(2483),
    [anon_sym_co_yield] = ACTIONS(2483),
    [anon_sym_R_DQUOTE] = ACTIONS(2485),
    [anon_sym_LR_DQUOTE] = ACTIONS(2485),
    [anon_sym_uR_DQUOTE] = ACTIONS(2485),
    [anon_sym_UR_DQUOTE] = ACTIONS(2485),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2485),
    [anon_sym_co_await] = ACTIONS(2483),
    [anon_sym_new] = ACTIONS(2483),
    [anon_sym_requires] = ACTIONS(2483),
    [sym_this] = ACTIONS(2483),
    [anon_sym_discard] = ACTIONS(2483),
    [anon_sym_precise] = ACTIONS(2483),
    [anon_sym_shared] = ACTIONS(2483),
    [anon_sym_groupshared] = ACTIONS(2483),
    [anon_sym_uniform] = ACTIONS(2483),
    [anon_sym_row_major] = ACTIONS(2483),
    [anon_sym_column_major] = ACTIONS(2483),
    [anon_sym_globallycoherent] = ACTIONS(2483),
    [anon_sym_centroid] = ACTIONS(2483),
    [anon_sym_noperspective] = ACTIONS(2483),
    [anon_sym_nointerpolation] = ACTIONS(2483),
    [anon_sym_sample] = ACTIONS(2483),
    [anon_sym_linear] = ACTIONS(2483),
    [anon_sym_snorm] = ACTIONS(2483),
    [anon_sym_unorm] = ACTIONS(2483),
    [anon_sym_point] = ACTIONS(2483),
    [anon_sym_line] = ACTIONS(2483),
    [anon_sym_triangleadj] = ACTIONS(2483),
    [anon_sym_lineadj] = ACTIONS(2483),
    [anon_sym_triangle] = ACTIONS(2483),
    [anon_sym_cbuffer] = ACTIONS(2483),
    [anon_sym_interface] = ACTIONS(2483),
    [anon_sym_extension] = ACTIONS(2483),
    [anon_sym___exported] = ACTIONS(2483),
    [anon_sym_import] = ACTIONS(2483),
  },
  [239] = {
    [sym_preproc_def] = STATE(239),
    [sym_preproc_function_def] = STATE(239),
    [sym_preproc_call] = STATE(239),
    [sym_preproc_if_in_field_declaration_list] = STATE(239),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(239),
    [sym_type_definition] = STATE(239),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6881),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7467),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(239),
    [sym_field_declaration] = STATE(239),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2591),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(239),
    [sym_operator_cast] = STATE(8364),
    [sym_inline_method_definition] = STATE(239),
    [sym__constructor_specifiers] = STATE(2591),
    [sym_operator_cast_definition] = STATE(239),
    [sym_operator_cast_declaration] = STATE(239),
    [sym_constructor_or_destructor_definition] = STATE(239),
    [sym_constructor_or_destructor_declaration] = STATE(239),
    [sym_friend_declaration] = STATE(239),
    [sym_access_specifier] = STATE(10268),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(239),
    [sym_alias_declaration] = STATE(239),
    [sym_static_assert_declaration] = STATE(239),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8364),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(239),
    [sym_subscript_declaration] = STATE(239),
    [sym_property_declaration] = STATE(239),
    [sym_associatedtype_declaration] = STATE(239),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(239),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(2540),
    [aux_sym_preproc_def_token1] = ACTIONS(2543),
    [aux_sym_preproc_if_token1] = ACTIONS(2546),
    [aux_sym_preproc_if_token2] = ACTIONS(2549),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2551),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2551),
    [aux_sym_preproc_else_token1] = ACTIONS(2549),
    [aux_sym_preproc_elif_token1] = ACTIONS(2549),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2549),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2549),
    [sym_preproc_directive] = ACTIONS(2554),
    [anon_sym_LPAREN2] = ACTIONS(2557),
    [anon_sym_TILDE] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2566),
    [anon_sym_AMP] = ACTIONS(2569),
    [anon_sym___extension__] = ACTIONS(2572),
    [anon_sym_typedef] = ACTIONS(2575),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_out] = ACTIONS(2578),
    [anon_sym_inout] = ACTIONS(2578),
    [anon_sym_extern] = ACTIONS(2581),
    [anon_sym___attribute__] = ACTIONS(2584),
    [anon_sym_COLON_COLON] = ACTIONS(2587),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2590),
    [anon_sym___declspec] = ACTIONS(2593),
    [anon_sym___based] = ACTIONS(2596),
    [anon_sym_signed] = ACTIONS(2599),
    [anon_sym_unsigned] = ACTIONS(2599),
    [anon_sym_long] = ACTIONS(2599),
    [anon_sym_short] = ACTIONS(2599),
    [anon_sym_LBRACK] = ACTIONS(2602),
    [anon_sym_static] = ACTIONS(2581),
    [anon_sym_register] = ACTIONS(2581),
    [anon_sym_inline] = ACTIONS(2581),
    [anon_sym___inline] = ACTIONS(2581),
    [anon_sym___inline__] = ACTIONS(2581),
    [anon_sym___forceinline] = ACTIONS(2581),
    [anon_sym_thread_local] = ACTIONS(2581),
    [anon_sym___thread] = ACTIONS(2581),
    [anon_sym_const] = ACTIONS(2605),
    [anon_sym_constexpr] = ACTIONS(2605),
    [anon_sym_volatile] = ACTIONS(2605),
    [anon_sym_restrict] = ACTIONS(2605),
    [anon_sym___restrict__] = ACTIONS(2605),
    [anon_sym__Atomic] = ACTIONS(2605),
    [anon_sym__Noreturn] = ACTIONS(2605),
    [anon_sym_noreturn] = ACTIONS(2605),
    [anon_sym_mutable] = ACTIONS(2605),
    [anon_sym_constinit] = ACTIONS(2605),
    [anon_sym_consteval] = ACTIONS(2605),
    [anon_sym_alignas] = ACTIONS(2608),
    [anon_sym__Alignas] = ACTIONS(2608),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_enum] = ACTIONS(2614),
    [anon_sym_class] = ACTIONS(2617),
    [anon_sym_struct] = ACTIONS(2620),
    [anon_sym_union] = ACTIONS(2623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2626),
    [anon_sym_let] = ACTIONS(2626),
    [anon_sym_This] = ACTIONS(2626),
    [anon_sym_decltype] = ACTIONS(2629),
    [sym_virtual] = ACTIONS(2578),
    [anon_sym_explicit] = ACTIONS(2632),
    [anon_sym_typename] = ACTIONS(2635),
    [anon_sym_template] = ACTIONS(2638),
    [anon_sym_operator] = ACTIONS(2641),
    [anon_sym_friend] = ACTIONS(2644),
    [anon_sym_public] = ACTIONS(2647),
    [anon_sym_private] = ACTIONS(2647),
    [anon_sym_protected] = ACTIONS(2647),
    [anon_sym_using] = ACTIONS(2650),
    [anon_sym_static_assert] = ACTIONS(2653),
    [anon_sym_precise] = ACTIONS(2656),
    [anon_sym_shared] = ACTIONS(2656),
    [anon_sym_groupshared] = ACTIONS(2656),
    [anon_sym_uniform] = ACTIONS(2656),
    [anon_sym_row_major] = ACTIONS(2656),
    [anon_sym_column_major] = ACTIONS(2656),
    [anon_sym_globallycoherent] = ACTIONS(2656),
    [anon_sym_centroid] = ACTIONS(2656),
    [anon_sym_noperspective] = ACTIONS(2656),
    [anon_sym_nointerpolation] = ACTIONS(2656),
    [anon_sym_sample] = ACTIONS(2656),
    [anon_sym_linear] = ACTIONS(2656),
    [anon_sym_snorm] = ACTIONS(2656),
    [anon_sym_unorm] = ACTIONS(2656),
    [anon_sym_point] = ACTIONS(2656),
    [anon_sym_line] = ACTIONS(2656),
    [anon_sym_triangleadj] = ACTIONS(2656),
    [anon_sym_lineadj] = ACTIONS(2656),
    [anon_sym_triangle] = ACTIONS(2656),
    [anon_sym_interface] = ACTIONS(2659),
    [anon_sym_extension] = ACTIONS(2662),
    [anon_sym___init] = ACTIONS(2665),
    [anon_sym___subscript] = ACTIONS(2668),
    [anon_sym_property] = ACTIONS(2671),
    [anon_sym_associatedtype] = ACTIONS(2674),
  },
  [240] = {
    [sym_field_declaration_list] = STATE(584),
    [sym_virtual_specifier] = STATE(8934),
    [sym_base_class_clause] = STATE(10069),
    [ts_builtin_sym_end] = ACTIONS(2475),
    [sym_identifier] = ACTIONS(2473),
    [aux_sym_preproc_include_token1] = ACTIONS(2473),
    [aux_sym_preproc_def_token1] = ACTIONS(2473),
    [aux_sym_preproc_if_token1] = ACTIONS(2473),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2473),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2473),
    [sym_preproc_directive] = ACTIONS(2473),
    [anon_sym_LPAREN2] = ACTIONS(2475),
    [anon_sym_BANG] = ACTIONS(2475),
    [anon_sym_TILDE] = ACTIONS(2475),
    [anon_sym_DASH] = ACTIONS(2473),
    [anon_sym_PLUS] = ACTIONS(2473),
    [anon_sym_STAR] = ACTIONS(2475),
    [anon_sym_AMP_AMP] = ACTIONS(2475),
    [anon_sym_AMP] = ACTIONS(2473),
    [anon_sym_COLON] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(2475),
    [anon_sym___extension__] = ACTIONS(2473),
    [anon_sym_typedef] = ACTIONS(2473),
    [anon_sym_in] = ACTIONS(2473),
    [anon_sym_out] = ACTIONS(2473),
    [anon_sym_inout] = ACTIONS(2473),
    [anon_sym_extern] = ACTIONS(2473),
    [anon_sym___attribute__] = ACTIONS(2473),
    [anon_sym_COLON_COLON] = ACTIONS(2475),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2475),
    [anon_sym___declspec] = ACTIONS(2473),
    [anon_sym___based] = ACTIONS(2473),
    [anon_sym___cdecl] = ACTIONS(2473),
    [anon_sym___clrcall] = ACTIONS(2473),
    [anon_sym___stdcall] = ACTIONS(2473),
    [anon_sym___fastcall] = ACTIONS(2473),
    [anon_sym___thiscall] = ACTIONS(2473),
    [anon_sym___vectorcall] = ACTIONS(2473),
    [anon_sym_LBRACE] = ACTIONS(2538),
    [anon_sym_signed] = ACTIONS(2473),
    [anon_sym_unsigned] = ACTIONS(2473),
    [anon_sym_long] = ACTIONS(2473),
    [anon_sym_short] = ACTIONS(2473),
    [anon_sym_LBRACK] = ACTIONS(2473),
    [anon_sym_static] = ACTIONS(2473),
    [anon_sym_register] = ACTIONS(2473),
    [anon_sym_inline] = ACTIONS(2473),
    [anon_sym___inline] = ACTIONS(2473),
    [anon_sym___inline__] = ACTIONS(2473),
    [anon_sym___forceinline] = ACTIONS(2473),
    [anon_sym_thread_local] = ACTIONS(2473),
    [anon_sym___thread] = ACTIONS(2473),
    [anon_sym_const] = ACTIONS(2473),
    [anon_sym_constexpr] = ACTIONS(2473),
    [anon_sym_volatile] = ACTIONS(2473),
    [anon_sym_restrict] = ACTIONS(2473),
    [anon_sym___restrict__] = ACTIONS(2473),
    [anon_sym__Atomic] = ACTIONS(2473),
    [anon_sym__Noreturn] = ACTIONS(2473),
    [anon_sym_noreturn] = ACTIONS(2473),
    [anon_sym_mutable] = ACTIONS(2473),
    [anon_sym_constinit] = ACTIONS(2473),
    [anon_sym_consteval] = ACTIONS(2473),
    [anon_sym_alignas] = ACTIONS(2473),
    [anon_sym__Alignas] = ACTIONS(2473),
    [sym_primitive_type] = ACTIONS(2473),
    [anon_sym_enum] = ACTIONS(2473),
    [anon_sym_class] = ACTIONS(2473),
    [anon_sym_struct] = ACTIONS(2473),
    [anon_sym_union] = ACTIONS(2473),
    [anon_sym_if] = ACTIONS(2473),
    [anon_sym_else] = ACTIONS(2473),
    [anon_sym_switch] = ACTIONS(2473),
    [anon_sym_case] = ACTIONS(2473),
    [anon_sym_default] = ACTIONS(2473),
    [anon_sym_while] = ACTIONS(2473),
    [anon_sym_do] = ACTIONS(2473),
    [anon_sym_for] = ACTIONS(2473),
    [anon_sym_return] = ACTIONS(2473),
    [anon_sym_break] = ACTIONS(2473),
    [anon_sym_continue] = ACTIONS(2473),
    [anon_sym_goto] = ACTIONS(2473),
    [anon_sym___try] = ACTIONS(2473),
    [anon_sym___leave] = ACTIONS(2473),
    [anon_sym_not] = ACTIONS(2473),
    [anon_sym_compl] = ACTIONS(2473),
    [anon_sym_DASH_DASH] = ACTIONS(2475),
    [anon_sym_PLUS_PLUS] = ACTIONS(2475),
    [anon_sym_sizeof] = ACTIONS(2473),
    [anon_sym___alignof__] = ACTIONS(2473),
    [anon_sym___alignof] = ACTIONS(2473),
    [anon_sym__alignof] = ACTIONS(2473),
    [anon_sym_alignof] = ACTIONS(2473),
    [anon_sym__Alignof] = ACTIONS(2473),
    [anon_sym_offsetof] = ACTIONS(2473),
    [anon_sym__Generic] = ACTIONS(2473),
    [anon_sym_asm] = ACTIONS(2473),
    [anon_sym___asm__] = ACTIONS(2473),
    [sym_number_literal] = ACTIONS(2475),
    [anon_sym_L_SQUOTE] = ACTIONS(2475),
    [anon_sym_u_SQUOTE] = ACTIONS(2475),
    [anon_sym_U_SQUOTE] = ACTIONS(2475),
    [anon_sym_u8_SQUOTE] = ACTIONS(2475),
    [anon_sym_SQUOTE] = ACTIONS(2475),
    [anon_sym_L_DQUOTE] = ACTIONS(2475),
    [anon_sym_u_DQUOTE] = ACTIONS(2475),
    [anon_sym_U_DQUOTE] = ACTIONS(2475),
    [anon_sym_u8_DQUOTE] = ACTIONS(2475),
    [anon_sym_DQUOTE] = ACTIONS(2475),
    [sym_true] = ACTIONS(2473),
    [sym_false] = ACTIONS(2473),
    [anon_sym_NULL] = ACTIONS(2473),
    [anon_sym_nullptr] = ACTIONS(2473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2473),
    [anon_sym_let] = ACTIONS(2473),
    [anon_sym_This] = ACTIONS(2473),
    [anon_sym_decltype] = ACTIONS(2473),
    [anon_sym_final] = ACTIONS(2481),
    [anon_sym_override] = ACTIONS(2481),
    [sym_virtual] = ACTIONS(2473),
    [anon_sym_explicit] = ACTIONS(2473),
    [anon_sym_typename] = ACTIONS(2473),
    [anon_sym_template] = ACTIONS(2473),
    [anon_sym_operator] = ACTIONS(2473),
    [anon_sym_try] = ACTIONS(2473),
    [anon_sym_delete] = ACTIONS(2473),
    [anon_sym_throw] = ACTIONS(2473),
    [anon_sym_namespace] = ACTIONS(2473),
    [anon_sym_using] = ACTIONS(2473),
    [anon_sym_static_assert] = ACTIONS(2473),
    [anon_sym_concept] = ACTIONS(2473),
    [anon_sym_co_return] = ACTIONS(2473),
    [anon_sym_co_yield] = ACTIONS(2473),
    [anon_sym_R_DQUOTE] = ACTIONS(2475),
    [anon_sym_LR_DQUOTE] = ACTIONS(2475),
    [anon_sym_uR_DQUOTE] = ACTIONS(2475),
    [anon_sym_UR_DQUOTE] = ACTIONS(2475),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2475),
    [anon_sym_co_await] = ACTIONS(2473),
    [anon_sym_new] = ACTIONS(2473),
    [anon_sym_requires] = ACTIONS(2473),
    [sym_this] = ACTIONS(2473),
    [anon_sym_discard] = ACTIONS(2473),
    [anon_sym_precise] = ACTIONS(2473),
    [anon_sym_shared] = ACTIONS(2473),
    [anon_sym_groupshared] = ACTIONS(2473),
    [anon_sym_uniform] = ACTIONS(2473),
    [anon_sym_row_major] = ACTIONS(2473),
    [anon_sym_column_major] = ACTIONS(2473),
    [anon_sym_globallycoherent] = ACTIONS(2473),
    [anon_sym_centroid] = ACTIONS(2473),
    [anon_sym_noperspective] = ACTIONS(2473),
    [anon_sym_nointerpolation] = ACTIONS(2473),
    [anon_sym_sample] = ACTIONS(2473),
    [anon_sym_linear] = ACTIONS(2473),
    [anon_sym_snorm] = ACTIONS(2473),
    [anon_sym_unorm] = ACTIONS(2473),
    [anon_sym_point] = ACTIONS(2473),
    [anon_sym_line] = ACTIONS(2473),
    [anon_sym_triangleadj] = ACTIONS(2473),
    [anon_sym_lineadj] = ACTIONS(2473),
    [anon_sym_triangle] = ACTIONS(2473),
    [anon_sym_cbuffer] = ACTIONS(2473),
    [anon_sym_interface] = ACTIONS(2473),
    [anon_sym_extension] = ACTIONS(2473),
    [anon_sym___exported] = ACTIONS(2473),
    [anon_sym_import] = ACTIONS(2473),
  },
  [241] = {
    [sym_identifier] = ACTIONS(2363),
    [aux_sym_preproc_include_token1] = ACTIONS(2363),
    [aux_sym_preproc_def_token1] = ACTIONS(2363),
    [aux_sym_preproc_if_token1] = ACTIONS(2363),
    [aux_sym_preproc_if_token2] = ACTIONS(2363),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2363),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2363),
    [aux_sym_preproc_else_token1] = ACTIONS(2363),
    [aux_sym_preproc_elif_token1] = ACTIONS(2363),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2363),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2363),
    [sym_preproc_directive] = ACTIONS(2363),
    [anon_sym_LPAREN2] = ACTIONS(2361),
    [anon_sym_BANG] = ACTIONS(2361),
    [anon_sym_TILDE] = ACTIONS(2361),
    [anon_sym_DASH] = ACTIONS(2363),
    [anon_sym_PLUS] = ACTIONS(2363),
    [anon_sym_STAR] = ACTIONS(2361),
    [anon_sym_AMP_AMP] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(2363),
    [anon_sym_COLON] = ACTIONS(2363),
    [anon_sym_SEMI] = ACTIONS(2361),
    [anon_sym___extension__] = ACTIONS(2363),
    [anon_sym_typedef] = ACTIONS(2363),
    [anon_sym_in] = ACTIONS(2363),
    [anon_sym_out] = ACTIONS(2363),
    [anon_sym_inout] = ACTIONS(2363),
    [anon_sym_extern] = ACTIONS(2363),
    [anon_sym___attribute__] = ACTIONS(2363),
    [anon_sym_COLON_COLON] = ACTIONS(2361),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2361),
    [anon_sym___declspec] = ACTIONS(2363),
    [anon_sym___based] = ACTIONS(2363),
    [anon_sym___cdecl] = ACTIONS(2363),
    [anon_sym___clrcall] = ACTIONS(2363),
    [anon_sym___stdcall] = ACTIONS(2363),
    [anon_sym___fastcall] = ACTIONS(2363),
    [anon_sym___thiscall] = ACTIONS(2363),
    [anon_sym___vectorcall] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_signed] = ACTIONS(2363),
    [anon_sym_unsigned] = ACTIONS(2363),
    [anon_sym_long] = ACTIONS(2363),
    [anon_sym_short] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(2363),
    [anon_sym_static] = ACTIONS(2363),
    [anon_sym_register] = ACTIONS(2363),
    [anon_sym_inline] = ACTIONS(2363),
    [anon_sym___inline] = ACTIONS(2363),
    [anon_sym___inline__] = ACTIONS(2363),
    [anon_sym___forceinline] = ACTIONS(2363),
    [anon_sym_thread_local] = ACTIONS(2363),
    [anon_sym___thread] = ACTIONS(2363),
    [anon_sym_const] = ACTIONS(2363),
    [anon_sym_constexpr] = ACTIONS(2363),
    [anon_sym_volatile] = ACTIONS(2363),
    [anon_sym_restrict] = ACTIONS(2363),
    [anon_sym___restrict__] = ACTIONS(2363),
    [anon_sym__Atomic] = ACTIONS(2363),
    [anon_sym__Noreturn] = ACTIONS(2363),
    [anon_sym_noreturn] = ACTIONS(2363),
    [anon_sym_mutable] = ACTIONS(2363),
    [anon_sym_constinit] = ACTIONS(2363),
    [anon_sym_consteval] = ACTIONS(2363),
    [anon_sym_alignas] = ACTIONS(2363),
    [anon_sym__Alignas] = ACTIONS(2363),
    [sym_primitive_type] = ACTIONS(2363),
    [anon_sym_enum] = ACTIONS(2363),
    [anon_sym_class] = ACTIONS(2363),
    [anon_sym_struct] = ACTIONS(2363),
    [anon_sym_union] = ACTIONS(2363),
    [anon_sym_if] = ACTIONS(2363),
    [anon_sym_else] = ACTIONS(2363),
    [anon_sym_switch] = ACTIONS(2363),
    [anon_sym_case] = ACTIONS(2363),
    [anon_sym_default] = ACTIONS(2363),
    [anon_sym_while] = ACTIONS(2363),
    [anon_sym_do] = ACTIONS(2363),
    [anon_sym_for] = ACTIONS(2363),
    [anon_sym_return] = ACTIONS(2363),
    [anon_sym_break] = ACTIONS(2363),
    [anon_sym_continue] = ACTIONS(2363),
    [anon_sym_goto] = ACTIONS(2363),
    [anon_sym___try] = ACTIONS(2363),
    [anon_sym___leave] = ACTIONS(2363),
    [anon_sym_not] = ACTIONS(2363),
    [anon_sym_compl] = ACTIONS(2363),
    [anon_sym_DASH_DASH] = ACTIONS(2361),
    [anon_sym_PLUS_PLUS] = ACTIONS(2361),
    [anon_sym_sizeof] = ACTIONS(2363),
    [anon_sym___alignof__] = ACTIONS(2363),
    [anon_sym___alignof] = ACTIONS(2363),
    [anon_sym__alignof] = ACTIONS(2363),
    [anon_sym_alignof] = ACTIONS(2363),
    [anon_sym__Alignof] = ACTIONS(2363),
    [anon_sym_offsetof] = ACTIONS(2363),
    [anon_sym__Generic] = ACTIONS(2363),
    [anon_sym_asm] = ACTIONS(2363),
    [anon_sym___asm__] = ACTIONS(2363),
    [sym_number_literal] = ACTIONS(2361),
    [anon_sym_L_SQUOTE] = ACTIONS(2361),
    [anon_sym_u_SQUOTE] = ACTIONS(2361),
    [anon_sym_U_SQUOTE] = ACTIONS(2361),
    [anon_sym_u8_SQUOTE] = ACTIONS(2361),
    [anon_sym_SQUOTE] = ACTIONS(2361),
    [anon_sym_L_DQUOTE] = ACTIONS(2361),
    [anon_sym_u_DQUOTE] = ACTIONS(2361),
    [anon_sym_U_DQUOTE] = ACTIONS(2361),
    [anon_sym_u8_DQUOTE] = ACTIONS(2361),
    [anon_sym_DQUOTE] = ACTIONS(2361),
    [sym_true] = ACTIONS(2363),
    [sym_false] = ACTIONS(2363),
    [anon_sym_NULL] = ACTIONS(2363),
    [anon_sym_nullptr] = ACTIONS(2363),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2363),
    [anon_sym_let] = ACTIONS(2363),
    [anon_sym_This] = ACTIONS(2363),
    [anon_sym_decltype] = ACTIONS(2363),
    [anon_sym_final] = ACTIONS(2363),
    [anon_sym_override] = ACTIONS(2363),
    [sym_virtual] = ACTIONS(2363),
    [anon_sym_explicit] = ACTIONS(2363),
    [anon_sym_typename] = ACTIONS(2363),
    [anon_sym_template] = ACTIONS(2363),
    [anon_sym_operator] = ACTIONS(2363),
    [anon_sym_try] = ACTIONS(2363),
    [anon_sym_delete] = ACTIONS(2363),
    [anon_sym_throw] = ACTIONS(2363),
    [anon_sym_namespace] = ACTIONS(2363),
    [anon_sym_using] = ACTIONS(2363),
    [anon_sym_static_assert] = ACTIONS(2363),
    [anon_sym_concept] = ACTIONS(2363),
    [anon_sym_co_return] = ACTIONS(2363),
    [anon_sym_co_yield] = ACTIONS(2363),
    [anon_sym_R_DQUOTE] = ACTIONS(2361),
    [anon_sym_LR_DQUOTE] = ACTIONS(2361),
    [anon_sym_uR_DQUOTE] = ACTIONS(2361),
    [anon_sym_UR_DQUOTE] = ACTIONS(2361),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2361),
    [anon_sym_co_await] = ACTIONS(2363),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_requires] = ACTIONS(2363),
    [sym_this] = ACTIONS(2363),
    [anon_sym_discard] = ACTIONS(2363),
    [anon_sym_precise] = ACTIONS(2363),
    [anon_sym_shared] = ACTIONS(2363),
    [anon_sym_groupshared] = ACTIONS(2363),
    [anon_sym_uniform] = ACTIONS(2363),
    [anon_sym_row_major] = ACTIONS(2363),
    [anon_sym_column_major] = ACTIONS(2363),
    [anon_sym_globallycoherent] = ACTIONS(2363),
    [anon_sym_centroid] = ACTIONS(2363),
    [anon_sym_noperspective] = ACTIONS(2363),
    [anon_sym_nointerpolation] = ACTIONS(2363),
    [anon_sym_sample] = ACTIONS(2363),
    [anon_sym_linear] = ACTIONS(2363),
    [anon_sym_snorm] = ACTIONS(2363),
    [anon_sym_unorm] = ACTIONS(2363),
    [anon_sym_point] = ACTIONS(2363),
    [anon_sym_line] = ACTIONS(2363),
    [anon_sym_triangleadj] = ACTIONS(2363),
    [anon_sym_lineadj] = ACTIONS(2363),
    [anon_sym_triangle] = ACTIONS(2363),
    [anon_sym_cbuffer] = ACTIONS(2363),
    [anon_sym_interface] = ACTIONS(2363),
    [anon_sym_extension] = ACTIONS(2363),
  },
  [242] = {
    [sym_identifier] = ACTIONS(2373),
    [aux_sym_preproc_include_token1] = ACTIONS(2373),
    [aux_sym_preproc_def_token1] = ACTIONS(2373),
    [aux_sym_preproc_if_token1] = ACTIONS(2373),
    [aux_sym_preproc_if_token2] = ACTIONS(2373),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2373),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2373),
    [aux_sym_preproc_else_token1] = ACTIONS(2373),
    [aux_sym_preproc_elif_token1] = ACTIONS(2373),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2373),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2373),
    [sym_preproc_directive] = ACTIONS(2373),
    [anon_sym_LPAREN2] = ACTIONS(2371),
    [anon_sym_BANG] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym___extension__] = ACTIONS(2373),
    [anon_sym_typedef] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_out] = ACTIONS(2373),
    [anon_sym_inout] = ACTIONS(2373),
    [anon_sym_extern] = ACTIONS(2373),
    [anon_sym___attribute__] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2371),
    [anon_sym___declspec] = ACTIONS(2373),
    [anon_sym___based] = ACTIONS(2373),
    [anon_sym___cdecl] = ACTIONS(2373),
    [anon_sym___clrcall] = ACTIONS(2373),
    [anon_sym___stdcall] = ACTIONS(2373),
    [anon_sym___fastcall] = ACTIONS(2373),
    [anon_sym___thiscall] = ACTIONS(2373),
    [anon_sym___vectorcall] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_signed] = ACTIONS(2373),
    [anon_sym_unsigned] = ACTIONS(2373),
    [anon_sym_long] = ACTIONS(2373),
    [anon_sym_short] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2373),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_register] = ACTIONS(2373),
    [anon_sym_inline] = ACTIONS(2373),
    [anon_sym___inline] = ACTIONS(2373),
    [anon_sym___inline__] = ACTIONS(2373),
    [anon_sym___forceinline] = ACTIONS(2373),
    [anon_sym_thread_local] = ACTIONS(2373),
    [anon_sym___thread] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym___restrict__] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym__Noreturn] = ACTIONS(2373),
    [anon_sym_noreturn] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_constinit] = ACTIONS(2373),
    [anon_sym_consteval] = ACTIONS(2373),
    [anon_sym_alignas] = ACTIONS(2373),
    [anon_sym__Alignas] = ACTIONS(2373),
    [sym_primitive_type] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_class] = ACTIONS(2373),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_else] = ACTIONS(2373),
    [anon_sym_switch] = ACTIONS(2373),
    [anon_sym_case] = ACTIONS(2373),
    [anon_sym_default] = ACTIONS(2373),
    [anon_sym_while] = ACTIONS(2373),
    [anon_sym_do] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2373),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2373),
    [anon_sym_goto] = ACTIONS(2373),
    [anon_sym___try] = ACTIONS(2373),
    [anon_sym___leave] = ACTIONS(2373),
    [anon_sym_not] = ACTIONS(2373),
    [anon_sym_compl] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_sizeof] = ACTIONS(2373),
    [anon_sym___alignof__] = ACTIONS(2373),
    [anon_sym___alignof] = ACTIONS(2373),
    [anon_sym__alignof] = ACTIONS(2373),
    [anon_sym_alignof] = ACTIONS(2373),
    [anon_sym__Alignof] = ACTIONS(2373),
    [anon_sym_offsetof] = ACTIONS(2373),
    [anon_sym__Generic] = ACTIONS(2373),
    [anon_sym_asm] = ACTIONS(2373),
    [anon_sym___asm__] = ACTIONS(2373),
    [sym_number_literal] = ACTIONS(2371),
    [anon_sym_L_SQUOTE] = ACTIONS(2371),
    [anon_sym_u_SQUOTE] = ACTIONS(2371),
    [anon_sym_U_SQUOTE] = ACTIONS(2371),
    [anon_sym_u8_SQUOTE] = ACTIONS(2371),
    [anon_sym_SQUOTE] = ACTIONS(2371),
    [anon_sym_L_DQUOTE] = ACTIONS(2371),
    [anon_sym_u_DQUOTE] = ACTIONS(2371),
    [anon_sym_U_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8_DQUOTE] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [anon_sym_NULL] = ACTIONS(2373),
    [anon_sym_nullptr] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_This] = ACTIONS(2373),
    [anon_sym_decltype] = ACTIONS(2373),
    [anon_sym_final] = ACTIONS(2373),
    [anon_sym_override] = ACTIONS(2373),
    [sym_virtual] = ACTIONS(2373),
    [anon_sym_explicit] = ACTIONS(2373),
    [anon_sym_typename] = ACTIONS(2373),
    [anon_sym_template] = ACTIONS(2373),
    [anon_sym_operator] = ACTIONS(2373),
    [anon_sym_try] = ACTIONS(2373),
    [anon_sym_delete] = ACTIONS(2373),
    [anon_sym_throw] = ACTIONS(2373),
    [anon_sym_namespace] = ACTIONS(2373),
    [anon_sym_using] = ACTIONS(2373),
    [anon_sym_static_assert] = ACTIONS(2373),
    [anon_sym_concept] = ACTIONS(2373),
    [anon_sym_co_return] = ACTIONS(2373),
    [anon_sym_co_yield] = ACTIONS(2373),
    [anon_sym_R_DQUOTE] = ACTIONS(2371),
    [anon_sym_LR_DQUOTE] = ACTIONS(2371),
    [anon_sym_uR_DQUOTE] = ACTIONS(2371),
    [anon_sym_UR_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2371),
    [anon_sym_co_await] = ACTIONS(2373),
    [anon_sym_new] = ACTIONS(2373),
    [anon_sym_requires] = ACTIONS(2373),
    [sym_this] = ACTIONS(2373),
    [anon_sym_discard] = ACTIONS(2373),
    [anon_sym_precise] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_groupshared] = ACTIONS(2373),
    [anon_sym_uniform] = ACTIONS(2373),
    [anon_sym_row_major] = ACTIONS(2373),
    [anon_sym_column_major] = ACTIONS(2373),
    [anon_sym_globallycoherent] = ACTIONS(2373),
    [anon_sym_centroid] = ACTIONS(2373),
    [anon_sym_noperspective] = ACTIONS(2373),
    [anon_sym_nointerpolation] = ACTIONS(2373),
    [anon_sym_sample] = ACTIONS(2373),
    [anon_sym_linear] = ACTIONS(2373),
    [anon_sym_snorm] = ACTIONS(2373),
    [anon_sym_unorm] = ACTIONS(2373),
    [anon_sym_point] = ACTIONS(2373),
    [anon_sym_line] = ACTIONS(2373),
    [anon_sym_triangleadj] = ACTIONS(2373),
    [anon_sym_lineadj] = ACTIONS(2373),
    [anon_sym_triangle] = ACTIONS(2373),
    [anon_sym_cbuffer] = ACTIONS(2373),
    [anon_sym_interface] = ACTIONS(2373),
    [anon_sym_extension] = ACTIONS(2373),
  },
  [243] = {
    [sym_catch_clause] = STATE(264),
    [aux_sym_constructor_try_statement_repeat1] = STATE(264),
    [sym_identifier] = ACTIONS(2677),
    [aux_sym_preproc_include_token1] = ACTIONS(2677),
    [aux_sym_preproc_def_token1] = ACTIONS(2677),
    [aux_sym_preproc_if_token1] = ACTIONS(2677),
    [aux_sym_preproc_if_token2] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2677),
    [aux_sym_preproc_else_token1] = ACTIONS(2677),
    [aux_sym_preproc_elif_token1] = ACTIONS(2677),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2677),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2677),
    [sym_preproc_directive] = ACTIONS(2677),
    [anon_sym_LPAREN2] = ACTIONS(2679),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_DASH] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_STAR] = ACTIONS(2679),
    [anon_sym_AMP_AMP] = ACTIONS(2679),
    [anon_sym_AMP] = ACTIONS(2677),
    [anon_sym_SEMI] = ACTIONS(2679),
    [anon_sym___extension__] = ACTIONS(2677),
    [anon_sym_typedef] = ACTIONS(2677),
    [anon_sym_in] = ACTIONS(2677),
    [anon_sym_out] = ACTIONS(2677),
    [anon_sym_inout] = ACTIONS(2677),
    [anon_sym_extern] = ACTIONS(2677),
    [anon_sym___attribute__] = ACTIONS(2677),
    [anon_sym_COLON_COLON] = ACTIONS(2679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2679),
    [anon_sym___declspec] = ACTIONS(2677),
    [anon_sym___based] = ACTIONS(2677),
    [anon_sym___cdecl] = ACTIONS(2677),
    [anon_sym___clrcall] = ACTIONS(2677),
    [anon_sym___stdcall] = ACTIONS(2677),
    [anon_sym___fastcall] = ACTIONS(2677),
    [anon_sym___thiscall] = ACTIONS(2677),
    [anon_sym___vectorcall] = ACTIONS(2677),
    [anon_sym_LBRACE] = ACTIONS(2679),
    [anon_sym_signed] = ACTIONS(2677),
    [anon_sym_unsigned] = ACTIONS(2677),
    [anon_sym_long] = ACTIONS(2677),
    [anon_sym_short] = ACTIONS(2677),
    [anon_sym_LBRACK] = ACTIONS(2677),
    [anon_sym_static] = ACTIONS(2677),
    [anon_sym_register] = ACTIONS(2677),
    [anon_sym_inline] = ACTIONS(2677),
    [anon_sym___inline] = ACTIONS(2677),
    [anon_sym___inline__] = ACTIONS(2677),
    [anon_sym___forceinline] = ACTIONS(2677),
    [anon_sym_thread_local] = ACTIONS(2677),
    [anon_sym___thread] = ACTIONS(2677),
    [anon_sym_const] = ACTIONS(2677),
    [anon_sym_constexpr] = ACTIONS(2677),
    [anon_sym_volatile] = ACTIONS(2677),
    [anon_sym_restrict] = ACTIONS(2677),
    [anon_sym___restrict__] = ACTIONS(2677),
    [anon_sym__Atomic] = ACTIONS(2677),
    [anon_sym__Noreturn] = ACTIONS(2677),
    [anon_sym_noreturn] = ACTIONS(2677),
    [anon_sym_mutable] = ACTIONS(2677),
    [anon_sym_constinit] = ACTIONS(2677),
    [anon_sym_consteval] = ACTIONS(2677),
    [anon_sym_alignas] = ACTIONS(2677),
    [anon_sym__Alignas] = ACTIONS(2677),
    [sym_primitive_type] = ACTIONS(2677),
    [anon_sym_enum] = ACTIONS(2677),
    [anon_sym_class] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(2677),
    [anon_sym_union] = ACTIONS(2677),
    [anon_sym_if] = ACTIONS(2677),
    [anon_sym_else] = ACTIONS(2677),
    [anon_sym_switch] = ACTIONS(2677),
    [anon_sym_case] = ACTIONS(2677),
    [anon_sym_default] = ACTIONS(2677),
    [anon_sym_while] = ACTIONS(2677),
    [anon_sym_do] = ACTIONS(2677),
    [anon_sym_for] = ACTIONS(2677),
    [anon_sym_return] = ACTIONS(2677),
    [anon_sym_break] = ACTIONS(2677),
    [anon_sym_continue] = ACTIONS(2677),
    [anon_sym_goto] = ACTIONS(2677),
    [anon_sym___try] = ACTIONS(2677),
    [anon_sym___leave] = ACTIONS(2677),
    [anon_sym_not] = ACTIONS(2677),
    [anon_sym_compl] = ACTIONS(2677),
    [anon_sym_DASH_DASH] = ACTIONS(2679),
    [anon_sym_PLUS_PLUS] = ACTIONS(2679),
    [anon_sym_sizeof] = ACTIONS(2677),
    [anon_sym___alignof__] = ACTIONS(2677),
    [anon_sym___alignof] = ACTIONS(2677),
    [anon_sym__alignof] = ACTIONS(2677),
    [anon_sym_alignof] = ACTIONS(2677),
    [anon_sym__Alignof] = ACTIONS(2677),
    [anon_sym_offsetof] = ACTIONS(2677),
    [anon_sym__Generic] = ACTIONS(2677),
    [anon_sym_asm] = ACTIONS(2677),
    [anon_sym___asm__] = ACTIONS(2677),
    [sym_number_literal] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2679),
    [anon_sym_u_SQUOTE] = ACTIONS(2679),
    [anon_sym_U_SQUOTE] = ACTIONS(2679),
    [anon_sym_u8_SQUOTE] = ACTIONS(2679),
    [anon_sym_SQUOTE] = ACTIONS(2679),
    [anon_sym_L_DQUOTE] = ACTIONS(2679),
    [anon_sym_u_DQUOTE] = ACTIONS(2679),
    [anon_sym_U_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8_DQUOTE] = ACTIONS(2679),
    [anon_sym_DQUOTE] = ACTIONS(2679),
    [sym_true] = ACTIONS(2677),
    [sym_false] = ACTIONS(2677),
    [anon_sym_NULL] = ACTIONS(2677),
    [anon_sym_nullptr] = ACTIONS(2677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2677),
    [anon_sym_let] = ACTIONS(2677),
    [anon_sym_This] = ACTIONS(2677),
    [anon_sym_decltype] = ACTIONS(2677),
    [sym_virtual] = ACTIONS(2677),
    [anon_sym_explicit] = ACTIONS(2677),
    [anon_sym_typename] = ACTIONS(2677),
    [anon_sym_template] = ACTIONS(2677),
    [anon_sym_operator] = ACTIONS(2677),
    [anon_sym_try] = ACTIONS(2677),
    [anon_sym_delete] = ACTIONS(2677),
    [anon_sym_throw] = ACTIONS(2677),
    [anon_sym_namespace] = ACTIONS(2677),
    [anon_sym_using] = ACTIONS(2677),
    [anon_sym_static_assert] = ACTIONS(2677),
    [anon_sym_concept] = ACTIONS(2677),
    [anon_sym_co_return] = ACTIONS(2677),
    [anon_sym_co_yield] = ACTIONS(2677),
    [anon_sym_catch] = ACTIONS(2681),
    [anon_sym_R_DQUOTE] = ACTIONS(2679),
    [anon_sym_LR_DQUOTE] = ACTIONS(2679),
    [anon_sym_uR_DQUOTE] = ACTIONS(2679),
    [anon_sym_UR_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2679),
    [anon_sym_co_await] = ACTIONS(2677),
    [anon_sym_new] = ACTIONS(2677),
    [anon_sym_requires] = ACTIONS(2677),
    [sym_this] = ACTIONS(2677),
    [anon_sym_discard] = ACTIONS(2677),
    [anon_sym_precise] = ACTIONS(2677),
    [anon_sym_shared] = ACTIONS(2677),
    [anon_sym_groupshared] = ACTIONS(2677),
    [anon_sym_uniform] = ACTIONS(2677),
    [anon_sym_row_major] = ACTIONS(2677),
    [anon_sym_column_major] = ACTIONS(2677),
    [anon_sym_globallycoherent] = ACTIONS(2677),
    [anon_sym_centroid] = ACTIONS(2677),
    [anon_sym_noperspective] = ACTIONS(2677),
    [anon_sym_nointerpolation] = ACTIONS(2677),
    [anon_sym_sample] = ACTIONS(2677),
    [anon_sym_linear] = ACTIONS(2677),
    [anon_sym_snorm] = ACTIONS(2677),
    [anon_sym_unorm] = ACTIONS(2677),
    [anon_sym_point] = ACTIONS(2677),
    [anon_sym_line] = ACTIONS(2677),
    [anon_sym_triangleadj] = ACTIONS(2677),
    [anon_sym_lineadj] = ACTIONS(2677),
    [anon_sym_triangle] = ACTIONS(2677),
    [anon_sym_cbuffer] = ACTIONS(2677),
    [anon_sym_interface] = ACTIONS(2677),
    [anon_sym_extension] = ACTIONS(2677),
  },
  [244] = {
    [sym_identifier] = ACTIONS(2248),
    [aux_sym_preproc_include_token1] = ACTIONS(2248),
    [aux_sym_preproc_def_token1] = ACTIONS(2248),
    [aux_sym_preproc_if_token1] = ACTIONS(2248),
    [aux_sym_preproc_if_token2] = ACTIONS(2248),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2248),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2248),
    [aux_sym_preproc_else_token1] = ACTIONS(2248),
    [aux_sym_preproc_elif_token1] = ACTIONS(2248),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2248),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2248),
    [sym_preproc_directive] = ACTIONS(2248),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2248),
    [anon_sym_PLUS] = ACTIONS(2248),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2248),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym___extension__] = ACTIONS(2248),
    [anon_sym_typedef] = ACTIONS(2248),
    [anon_sym_in] = ACTIONS(2248),
    [anon_sym_out] = ACTIONS(2248),
    [anon_sym_inout] = ACTIONS(2248),
    [anon_sym_extern] = ACTIONS(2248),
    [anon_sym___attribute__] = ACTIONS(2248),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2250),
    [anon_sym___declspec] = ACTIONS(2248),
    [anon_sym___based] = ACTIONS(2248),
    [anon_sym___cdecl] = ACTIONS(2248),
    [anon_sym___clrcall] = ACTIONS(2248),
    [anon_sym___stdcall] = ACTIONS(2248),
    [anon_sym___fastcall] = ACTIONS(2248),
    [anon_sym___thiscall] = ACTIONS(2248),
    [anon_sym___vectorcall] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_signed] = ACTIONS(2248),
    [anon_sym_unsigned] = ACTIONS(2248),
    [anon_sym_long] = ACTIONS(2248),
    [anon_sym_short] = ACTIONS(2248),
    [anon_sym_LBRACK] = ACTIONS(2248),
    [anon_sym_static] = ACTIONS(2248),
    [anon_sym_register] = ACTIONS(2248),
    [anon_sym_inline] = ACTIONS(2248),
    [anon_sym___inline] = ACTIONS(2248),
    [anon_sym___inline__] = ACTIONS(2248),
    [anon_sym___forceinline] = ACTIONS(2248),
    [anon_sym_thread_local] = ACTIONS(2248),
    [anon_sym___thread] = ACTIONS(2248),
    [anon_sym_const] = ACTIONS(2248),
    [anon_sym_constexpr] = ACTIONS(2248),
    [anon_sym_volatile] = ACTIONS(2248),
    [anon_sym_restrict] = ACTIONS(2248),
    [anon_sym___restrict__] = ACTIONS(2248),
    [anon_sym__Atomic] = ACTIONS(2248),
    [anon_sym__Noreturn] = ACTIONS(2248),
    [anon_sym_noreturn] = ACTIONS(2248),
    [anon_sym_mutable] = ACTIONS(2248),
    [anon_sym_constinit] = ACTIONS(2248),
    [anon_sym_consteval] = ACTIONS(2248),
    [anon_sym_alignas] = ACTIONS(2248),
    [anon_sym__Alignas] = ACTIONS(2248),
    [sym_primitive_type] = ACTIONS(2248),
    [anon_sym_enum] = ACTIONS(2248),
    [anon_sym_class] = ACTIONS(2248),
    [anon_sym_struct] = ACTIONS(2248),
    [anon_sym_union] = ACTIONS(2248),
    [anon_sym_if] = ACTIONS(2248),
    [anon_sym_else] = ACTIONS(2248),
    [anon_sym_switch] = ACTIONS(2248),
    [anon_sym_case] = ACTIONS(2248),
    [anon_sym_default] = ACTIONS(2248),
    [anon_sym_while] = ACTIONS(2248),
    [anon_sym_do] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2248),
    [anon_sym_break] = ACTIONS(2248),
    [anon_sym_continue] = ACTIONS(2248),
    [anon_sym_goto] = ACTIONS(2248),
    [anon_sym___try] = ACTIONS(2248),
    [anon_sym___leave] = ACTIONS(2248),
    [anon_sym_not] = ACTIONS(2248),
    [anon_sym_compl] = ACTIONS(2248),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_sizeof] = ACTIONS(2248),
    [anon_sym___alignof__] = ACTIONS(2248),
    [anon_sym___alignof] = ACTIONS(2248),
    [anon_sym__alignof] = ACTIONS(2248),
    [anon_sym_alignof] = ACTIONS(2248),
    [anon_sym__Alignof] = ACTIONS(2248),
    [anon_sym_offsetof] = ACTIONS(2248),
    [anon_sym__Generic] = ACTIONS(2248),
    [anon_sym_asm] = ACTIONS(2248),
    [anon_sym___asm__] = ACTIONS(2248),
    [sym_number_literal] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2250),
    [anon_sym_u_SQUOTE] = ACTIONS(2250),
    [anon_sym_U_SQUOTE] = ACTIONS(2250),
    [anon_sym_u8_SQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym_L_DQUOTE] = ACTIONS(2250),
    [anon_sym_u_DQUOTE] = ACTIONS(2250),
    [anon_sym_U_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [sym_true] = ACTIONS(2248),
    [sym_false] = ACTIONS(2248),
    [anon_sym_NULL] = ACTIONS(2248),
    [anon_sym_nullptr] = ACTIONS(2248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2248),
    [anon_sym_let] = ACTIONS(2248),
    [anon_sym_This] = ACTIONS(2248),
    [anon_sym_decltype] = ACTIONS(2248),
    [anon_sym_final] = ACTIONS(2248),
    [anon_sym_override] = ACTIONS(2248),
    [sym_virtual] = ACTIONS(2248),
    [anon_sym_explicit] = ACTIONS(2248),
    [anon_sym_typename] = ACTIONS(2248),
    [anon_sym_template] = ACTIONS(2248),
    [anon_sym_operator] = ACTIONS(2248),
    [anon_sym_try] = ACTIONS(2248),
    [anon_sym_delete] = ACTIONS(2248),
    [anon_sym_throw] = ACTIONS(2248),
    [anon_sym_namespace] = ACTIONS(2248),
    [anon_sym_using] = ACTIONS(2248),
    [anon_sym_static_assert] = ACTIONS(2248),
    [anon_sym_concept] = ACTIONS(2248),
    [anon_sym_co_return] = ACTIONS(2248),
    [anon_sym_co_yield] = ACTIONS(2248),
    [anon_sym_R_DQUOTE] = ACTIONS(2250),
    [anon_sym_LR_DQUOTE] = ACTIONS(2250),
    [anon_sym_uR_DQUOTE] = ACTIONS(2250),
    [anon_sym_UR_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2250),
    [anon_sym_co_await] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2248),
    [anon_sym_requires] = ACTIONS(2248),
    [sym_this] = ACTIONS(2248),
    [anon_sym_discard] = ACTIONS(2248),
    [anon_sym_precise] = ACTIONS(2248),
    [anon_sym_shared] = ACTIONS(2248),
    [anon_sym_groupshared] = ACTIONS(2248),
    [anon_sym_uniform] = ACTIONS(2248),
    [anon_sym_row_major] = ACTIONS(2248),
    [anon_sym_column_major] = ACTIONS(2248),
    [anon_sym_globallycoherent] = ACTIONS(2248),
    [anon_sym_centroid] = ACTIONS(2248),
    [anon_sym_noperspective] = ACTIONS(2248),
    [anon_sym_nointerpolation] = ACTIONS(2248),
    [anon_sym_sample] = ACTIONS(2248),
    [anon_sym_linear] = ACTIONS(2248),
    [anon_sym_snorm] = ACTIONS(2248),
    [anon_sym_unorm] = ACTIONS(2248),
    [anon_sym_point] = ACTIONS(2248),
    [anon_sym_line] = ACTIONS(2248),
    [anon_sym_triangleadj] = ACTIONS(2248),
    [anon_sym_lineadj] = ACTIONS(2248),
    [anon_sym_triangle] = ACTIONS(2248),
    [anon_sym_cbuffer] = ACTIONS(2248),
    [anon_sym_interface] = ACTIONS(2248),
    [anon_sym_extension] = ACTIONS(2248),
  },
  [245] = {
    [sym_attribute_specifier] = STATE(682),
    [sym_field_declaration_list] = STATE(640),
    [sym_virtual_specifier] = STATE(8803),
    [sym_base_class_clause] = STATE(9815),
    [sym_identifier] = ACTIONS(2683),
    [aux_sym_preproc_include_token1] = ACTIONS(2683),
    [aux_sym_preproc_def_token1] = ACTIONS(2683),
    [aux_sym_preproc_if_token1] = ACTIONS(2683),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2683),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2683),
    [sym_preproc_directive] = ACTIONS(2683),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_BANG] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2683),
    [anon_sym_PLUS] = ACTIONS(2683),
    [anon_sym_STAR] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_COLON] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(2685),
    [anon_sym___extension__] = ACTIONS(2683),
    [anon_sym_typedef] = ACTIONS(2683),
    [anon_sym_in] = ACTIONS(2683),
    [anon_sym_out] = ACTIONS(2683),
    [anon_sym_inout] = ACTIONS(2683),
    [anon_sym_extern] = ACTIONS(2683),
    [anon_sym___attribute__] = ACTIONS(2687),
    [anon_sym_COLON_COLON] = ACTIONS(2685),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2685),
    [anon_sym___declspec] = ACTIONS(2683),
    [anon_sym___based] = ACTIONS(2683),
    [anon_sym___cdecl] = ACTIONS(2683),
    [anon_sym___clrcall] = ACTIONS(2683),
    [anon_sym___stdcall] = ACTIONS(2683),
    [anon_sym___fastcall] = ACTIONS(2683),
    [anon_sym___thiscall] = ACTIONS(2683),
    [anon_sym___vectorcall] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_RBRACE] = ACTIONS(2685),
    [anon_sym_signed] = ACTIONS(2683),
    [anon_sym_unsigned] = ACTIONS(2683),
    [anon_sym_long] = ACTIONS(2683),
    [anon_sym_short] = ACTIONS(2683),
    [anon_sym_LBRACK] = ACTIONS(2683),
    [anon_sym_static] = ACTIONS(2683),
    [anon_sym_register] = ACTIONS(2683),
    [anon_sym_inline] = ACTIONS(2683),
    [anon_sym___inline] = ACTIONS(2683),
    [anon_sym___inline__] = ACTIONS(2683),
    [anon_sym___forceinline] = ACTIONS(2683),
    [anon_sym_thread_local] = ACTIONS(2683),
    [anon_sym___thread] = ACTIONS(2683),
    [anon_sym_const] = ACTIONS(2683),
    [anon_sym_constexpr] = ACTIONS(2683),
    [anon_sym_volatile] = ACTIONS(2683),
    [anon_sym_restrict] = ACTIONS(2683),
    [anon_sym___restrict__] = ACTIONS(2683),
    [anon_sym__Atomic] = ACTIONS(2683),
    [anon_sym__Noreturn] = ACTIONS(2683),
    [anon_sym_noreturn] = ACTIONS(2683),
    [anon_sym_mutable] = ACTIONS(2683),
    [anon_sym_constinit] = ACTIONS(2683),
    [anon_sym_consteval] = ACTIONS(2683),
    [anon_sym_alignas] = ACTIONS(2683),
    [anon_sym__Alignas] = ACTIONS(2683),
    [sym_primitive_type] = ACTIONS(2683),
    [anon_sym_enum] = ACTIONS(2683),
    [anon_sym_class] = ACTIONS(2683),
    [anon_sym_struct] = ACTIONS(2683),
    [anon_sym_union] = ACTIONS(2683),
    [anon_sym_if] = ACTIONS(2683),
    [anon_sym_switch] = ACTIONS(2683),
    [anon_sym_case] = ACTIONS(2683),
    [anon_sym_default] = ACTIONS(2683),
    [anon_sym_while] = ACTIONS(2683),
    [anon_sym_do] = ACTIONS(2683),
    [anon_sym_for] = ACTIONS(2683),
    [anon_sym_return] = ACTIONS(2683),
    [anon_sym_break] = ACTIONS(2683),
    [anon_sym_continue] = ACTIONS(2683),
    [anon_sym_goto] = ACTIONS(2683),
    [anon_sym___try] = ACTIONS(2683),
    [anon_sym___leave] = ACTIONS(2683),
    [anon_sym_not] = ACTIONS(2683),
    [anon_sym_compl] = ACTIONS(2683),
    [anon_sym_DASH_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_PLUS] = ACTIONS(2685),
    [anon_sym_sizeof] = ACTIONS(2683),
    [anon_sym___alignof__] = ACTIONS(2683),
    [anon_sym___alignof] = ACTIONS(2683),
    [anon_sym__alignof] = ACTIONS(2683),
    [anon_sym_alignof] = ACTIONS(2683),
    [anon_sym__Alignof] = ACTIONS(2683),
    [anon_sym_offsetof] = ACTIONS(2683),
    [anon_sym__Generic] = ACTIONS(2683),
    [anon_sym_asm] = ACTIONS(2683),
    [anon_sym___asm__] = ACTIONS(2683),
    [anon_sym_DOT] = ACTIONS(2683),
    [sym_number_literal] = ACTIONS(2685),
    [anon_sym_L_SQUOTE] = ACTIONS(2685),
    [anon_sym_u_SQUOTE] = ACTIONS(2685),
    [anon_sym_U_SQUOTE] = ACTIONS(2685),
    [anon_sym_u8_SQUOTE] = ACTIONS(2685),
    [anon_sym_SQUOTE] = ACTIONS(2685),
    [anon_sym_L_DQUOTE] = ACTIONS(2685),
    [anon_sym_u_DQUOTE] = ACTIONS(2685),
    [anon_sym_U_DQUOTE] = ACTIONS(2685),
    [anon_sym_u8_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [sym_true] = ACTIONS(2683),
    [sym_false] = ACTIONS(2683),
    [anon_sym_NULL] = ACTIONS(2683),
    [anon_sym_nullptr] = ACTIONS(2683),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2683),
    [anon_sym_let] = ACTIONS(2683),
    [anon_sym_This] = ACTIONS(2683),
    [anon_sym_decltype] = ACTIONS(2683),
    [anon_sym_final] = ACTIONS(2481),
    [anon_sym_override] = ACTIONS(2481),
    [sym_virtual] = ACTIONS(2683),
    [anon_sym_explicit] = ACTIONS(2683),
    [anon_sym_typename] = ACTIONS(2683),
    [anon_sym_template] = ACTIONS(2683),
    [anon_sym_operator] = ACTIONS(2683),
    [anon_sym_try] = ACTIONS(2683),
    [anon_sym_delete] = ACTIONS(2683),
    [anon_sym_throw] = ACTIONS(2683),
    [anon_sym_namespace] = ACTIONS(2683),
    [anon_sym_using] = ACTIONS(2683),
    [anon_sym_static_assert] = ACTIONS(2683),
    [anon_sym_concept] = ACTIONS(2683),
    [anon_sym_co_return] = ACTIONS(2683),
    [anon_sym_co_yield] = ACTIONS(2683),
    [anon_sym_R_DQUOTE] = ACTIONS(2685),
    [anon_sym_LR_DQUOTE] = ACTIONS(2685),
    [anon_sym_uR_DQUOTE] = ACTIONS(2685),
    [anon_sym_UR_DQUOTE] = ACTIONS(2685),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2685),
    [anon_sym_co_await] = ACTIONS(2683),
    [anon_sym_new] = ACTIONS(2683),
    [anon_sym_requires] = ACTIONS(2683),
    [sym_this] = ACTIONS(2683),
    [anon_sym_discard] = ACTIONS(2683),
    [anon_sym_precise] = ACTIONS(2683),
    [anon_sym_shared] = ACTIONS(2683),
    [anon_sym_groupshared] = ACTIONS(2683),
    [anon_sym_uniform] = ACTIONS(2683),
    [anon_sym_row_major] = ACTIONS(2683),
    [anon_sym_column_major] = ACTIONS(2683),
    [anon_sym_globallycoherent] = ACTIONS(2683),
    [anon_sym_centroid] = ACTIONS(2683),
    [anon_sym_noperspective] = ACTIONS(2683),
    [anon_sym_nointerpolation] = ACTIONS(2683),
    [anon_sym_sample] = ACTIONS(2683),
    [anon_sym_linear] = ACTIONS(2683),
    [anon_sym_snorm] = ACTIONS(2683),
    [anon_sym_unorm] = ACTIONS(2683),
    [anon_sym_point] = ACTIONS(2683),
    [anon_sym_line] = ACTIONS(2683),
    [anon_sym_triangleadj] = ACTIONS(2683),
    [anon_sym_lineadj] = ACTIONS(2683),
    [anon_sym_triangle] = ACTIONS(2683),
    [anon_sym_cbuffer] = ACTIONS(2683),
    [anon_sym_interface] = ACTIONS(2683),
    [anon_sym_extension] = ACTIONS(2683),
  },
  [246] = {
    [sym_identifier] = ACTIONS(2194),
    [aux_sym_preproc_include_token1] = ACTIONS(2194),
    [aux_sym_preproc_def_token1] = ACTIONS(2194),
    [aux_sym_preproc_if_token1] = ACTIONS(2194),
    [aux_sym_preproc_if_token2] = ACTIONS(2194),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2194),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2194),
    [aux_sym_preproc_else_token1] = ACTIONS(2194),
    [aux_sym_preproc_elif_token1] = ACTIONS(2194),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2194),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2194),
    [sym_preproc_directive] = ACTIONS(2194),
    [anon_sym_LPAREN2] = ACTIONS(2196),
    [anon_sym_BANG] = ACTIONS(2196),
    [anon_sym_TILDE] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2194),
    [anon_sym_PLUS] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(2196),
    [anon_sym_AMP_AMP] = ACTIONS(2196),
    [anon_sym_AMP] = ACTIONS(2194),
    [anon_sym_COLON] = ACTIONS(2194),
    [anon_sym_SEMI] = ACTIONS(2196),
    [anon_sym___extension__] = ACTIONS(2194),
    [anon_sym_typedef] = ACTIONS(2194),
    [anon_sym_in] = ACTIONS(2194),
    [anon_sym_out] = ACTIONS(2194),
    [anon_sym_inout] = ACTIONS(2194),
    [anon_sym_extern] = ACTIONS(2194),
    [anon_sym___attribute__] = ACTIONS(2194),
    [anon_sym_COLON_COLON] = ACTIONS(2196),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2196),
    [anon_sym___declspec] = ACTIONS(2194),
    [anon_sym___based] = ACTIONS(2194),
    [anon_sym___cdecl] = ACTIONS(2194),
    [anon_sym___clrcall] = ACTIONS(2194),
    [anon_sym___stdcall] = ACTIONS(2194),
    [anon_sym___fastcall] = ACTIONS(2194),
    [anon_sym___thiscall] = ACTIONS(2194),
    [anon_sym___vectorcall] = ACTIONS(2194),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_signed] = ACTIONS(2194),
    [anon_sym_unsigned] = ACTIONS(2194),
    [anon_sym_long] = ACTIONS(2194),
    [anon_sym_short] = ACTIONS(2194),
    [anon_sym_LBRACK] = ACTIONS(2194),
    [anon_sym_static] = ACTIONS(2194),
    [anon_sym_register] = ACTIONS(2194),
    [anon_sym_inline] = ACTIONS(2194),
    [anon_sym___inline] = ACTIONS(2194),
    [anon_sym___inline__] = ACTIONS(2194),
    [anon_sym___forceinline] = ACTIONS(2194),
    [anon_sym_thread_local] = ACTIONS(2194),
    [anon_sym___thread] = ACTIONS(2194),
    [anon_sym_const] = ACTIONS(2194),
    [anon_sym_constexpr] = ACTIONS(2194),
    [anon_sym_volatile] = ACTIONS(2194),
    [anon_sym_restrict] = ACTIONS(2194),
    [anon_sym___restrict__] = ACTIONS(2194),
    [anon_sym__Atomic] = ACTIONS(2194),
    [anon_sym__Noreturn] = ACTIONS(2194),
    [anon_sym_noreturn] = ACTIONS(2194),
    [anon_sym_mutable] = ACTIONS(2194),
    [anon_sym_constinit] = ACTIONS(2194),
    [anon_sym_consteval] = ACTIONS(2194),
    [anon_sym_alignas] = ACTIONS(2194),
    [anon_sym__Alignas] = ACTIONS(2194),
    [sym_primitive_type] = ACTIONS(2194),
    [anon_sym_enum] = ACTIONS(2194),
    [anon_sym_class] = ACTIONS(2194),
    [anon_sym_struct] = ACTIONS(2194),
    [anon_sym_union] = ACTIONS(2194),
    [anon_sym_if] = ACTIONS(2194),
    [anon_sym_else] = ACTIONS(2194),
    [anon_sym_switch] = ACTIONS(2194),
    [anon_sym_case] = ACTIONS(2194),
    [anon_sym_default] = ACTIONS(2194),
    [anon_sym_while] = ACTIONS(2194),
    [anon_sym_do] = ACTIONS(2194),
    [anon_sym_for] = ACTIONS(2194),
    [anon_sym_return] = ACTIONS(2194),
    [anon_sym_break] = ACTIONS(2194),
    [anon_sym_continue] = ACTIONS(2194),
    [anon_sym_goto] = ACTIONS(2194),
    [anon_sym___try] = ACTIONS(2194),
    [anon_sym___leave] = ACTIONS(2194),
    [anon_sym_not] = ACTIONS(2194),
    [anon_sym_compl] = ACTIONS(2194),
    [anon_sym_DASH_DASH] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2196),
    [anon_sym_sizeof] = ACTIONS(2194),
    [anon_sym___alignof__] = ACTIONS(2194),
    [anon_sym___alignof] = ACTIONS(2194),
    [anon_sym__alignof] = ACTIONS(2194),
    [anon_sym_alignof] = ACTIONS(2194),
    [anon_sym__Alignof] = ACTIONS(2194),
    [anon_sym_offsetof] = ACTIONS(2194),
    [anon_sym__Generic] = ACTIONS(2194),
    [anon_sym_asm] = ACTIONS(2194),
    [anon_sym___asm__] = ACTIONS(2194),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_L_SQUOTE] = ACTIONS(2196),
    [anon_sym_u_SQUOTE] = ACTIONS(2196),
    [anon_sym_U_SQUOTE] = ACTIONS(2196),
    [anon_sym_u8_SQUOTE] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(2196),
    [anon_sym_L_DQUOTE] = ACTIONS(2196),
    [anon_sym_u_DQUOTE] = ACTIONS(2196),
    [anon_sym_U_DQUOTE] = ACTIONS(2196),
    [anon_sym_u8_DQUOTE] = ACTIONS(2196),
    [anon_sym_DQUOTE] = ACTIONS(2196),
    [sym_true] = ACTIONS(2194),
    [sym_false] = ACTIONS(2194),
    [anon_sym_NULL] = ACTIONS(2194),
    [anon_sym_nullptr] = ACTIONS(2194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2194),
    [anon_sym_let] = ACTIONS(2194),
    [anon_sym_This] = ACTIONS(2194),
    [anon_sym_decltype] = ACTIONS(2194),
    [anon_sym_final] = ACTIONS(2194),
    [anon_sym_override] = ACTIONS(2194),
    [sym_virtual] = ACTIONS(2194),
    [anon_sym_explicit] = ACTIONS(2194),
    [anon_sym_typename] = ACTIONS(2194),
    [anon_sym_template] = ACTIONS(2194),
    [anon_sym_operator] = ACTIONS(2194),
    [anon_sym_try] = ACTIONS(2194),
    [anon_sym_delete] = ACTIONS(2194),
    [anon_sym_throw] = ACTIONS(2194),
    [anon_sym_namespace] = ACTIONS(2194),
    [anon_sym_using] = ACTIONS(2194),
    [anon_sym_static_assert] = ACTIONS(2194),
    [anon_sym_concept] = ACTIONS(2194),
    [anon_sym_co_return] = ACTIONS(2194),
    [anon_sym_co_yield] = ACTIONS(2194),
    [anon_sym_R_DQUOTE] = ACTIONS(2196),
    [anon_sym_LR_DQUOTE] = ACTIONS(2196),
    [anon_sym_uR_DQUOTE] = ACTIONS(2196),
    [anon_sym_UR_DQUOTE] = ACTIONS(2196),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2196),
    [anon_sym_co_await] = ACTIONS(2194),
    [anon_sym_new] = ACTIONS(2194),
    [anon_sym_requires] = ACTIONS(2194),
    [sym_this] = ACTIONS(2194),
    [anon_sym_discard] = ACTIONS(2194),
    [anon_sym_precise] = ACTIONS(2194),
    [anon_sym_shared] = ACTIONS(2194),
    [anon_sym_groupshared] = ACTIONS(2194),
    [anon_sym_uniform] = ACTIONS(2194),
    [anon_sym_row_major] = ACTIONS(2194),
    [anon_sym_column_major] = ACTIONS(2194),
    [anon_sym_globallycoherent] = ACTIONS(2194),
    [anon_sym_centroid] = ACTIONS(2194),
    [anon_sym_noperspective] = ACTIONS(2194),
    [anon_sym_nointerpolation] = ACTIONS(2194),
    [anon_sym_sample] = ACTIONS(2194),
    [anon_sym_linear] = ACTIONS(2194),
    [anon_sym_snorm] = ACTIONS(2194),
    [anon_sym_unorm] = ACTIONS(2194),
    [anon_sym_point] = ACTIONS(2194),
    [anon_sym_line] = ACTIONS(2194),
    [anon_sym_triangleadj] = ACTIONS(2194),
    [anon_sym_lineadj] = ACTIONS(2194),
    [anon_sym_triangle] = ACTIONS(2194),
    [anon_sym_cbuffer] = ACTIONS(2194),
    [anon_sym_interface] = ACTIONS(2194),
    [anon_sym_extension] = ACTIONS(2194),
  },
  [247] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_qualifiers] = STATE(2666),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [ts_builtin_sym_end] = ACTIONS(2691),
    [sym_identifier] = ACTIONS(2693),
    [aux_sym_preproc_include_token1] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(2696),
    [aux_sym_preproc_if_token1] = ACTIONS(2696),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2696),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2696),
    [sym_preproc_directive] = ACTIONS(2696),
    [anon_sym_LPAREN2] = ACTIONS(2698),
    [anon_sym_BANG] = ACTIONS(2691),
    [anon_sym_TILDE] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2696),
    [anon_sym_STAR] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2698),
    [anon_sym_AMP] = ACTIONS(2693),
    [anon_sym_SEMI] = ACTIONS(2701),
    [anon_sym___extension__] = ACTIONS(2703),
    [anon_sym_typedef] = ACTIONS(2696),
    [anon_sym_in] = ACTIONS(2706),
    [anon_sym_out] = ACTIONS(2706),
    [anon_sym_inout] = ACTIONS(2706),
    [anon_sym_extern] = ACTIONS(2709),
    [anon_sym___attribute__] = ACTIONS(2712),
    [anon_sym_COLON_COLON] = ACTIONS(2698),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2715),
    [anon_sym___declspec] = ACTIONS(2718),
    [anon_sym___based] = ACTIONS(2693),
    [anon_sym___cdecl] = ACTIONS(2693),
    [anon_sym___clrcall] = ACTIONS(2693),
    [anon_sym___stdcall] = ACTIONS(2693),
    [anon_sym___fastcall] = ACTIONS(2693),
    [anon_sym___thiscall] = ACTIONS(2693),
    [anon_sym___vectorcall] = ACTIONS(2693),
    [anon_sym_LBRACE] = ACTIONS(2691),
    [anon_sym_signed] = ACTIONS(2696),
    [anon_sym_unsigned] = ACTIONS(2696),
    [anon_sym_long] = ACTIONS(2696),
    [anon_sym_short] = ACTIONS(2696),
    [anon_sym_LBRACK] = ACTIONS(2693),
    [anon_sym_static] = ACTIONS(2709),
    [anon_sym_register] = ACTIONS(2709),
    [anon_sym_inline] = ACTIONS(2709),
    [anon_sym___inline] = ACTIONS(2709),
    [anon_sym___inline__] = ACTIONS(2709),
    [anon_sym___forceinline] = ACTIONS(2709),
    [anon_sym_thread_local] = ACTIONS(2709),
    [anon_sym___thread] = ACTIONS(2709),
    [anon_sym_const] = ACTIONS(2703),
    [anon_sym_constexpr] = ACTIONS(2703),
    [anon_sym_volatile] = ACTIONS(2703),
    [anon_sym_restrict] = ACTIONS(2703),
    [anon_sym___restrict__] = ACTIONS(2703),
    [anon_sym__Atomic] = ACTIONS(2703),
    [anon_sym__Noreturn] = ACTIONS(2703),
    [anon_sym_noreturn] = ACTIONS(2703),
    [anon_sym_mutable] = ACTIONS(2703),
    [anon_sym_constinit] = ACTIONS(2703),
    [anon_sym_consteval] = ACTIONS(2703),
    [anon_sym_alignas] = ACTIONS(2721),
    [anon_sym__Alignas] = ACTIONS(2721),
    [sym_primitive_type] = ACTIONS(2696),
    [anon_sym_enum] = ACTIONS(2696),
    [anon_sym_class] = ACTIONS(2696),
    [anon_sym_struct] = ACTIONS(2696),
    [anon_sym_union] = ACTIONS(2696),
    [anon_sym_if] = ACTIONS(2696),
    [anon_sym_switch] = ACTIONS(2696),
    [anon_sym_case] = ACTIONS(2696),
    [anon_sym_default] = ACTIONS(2696),
    [anon_sym_while] = ACTIONS(2696),
    [anon_sym_do] = ACTIONS(2696),
    [anon_sym_for] = ACTIONS(2696),
    [anon_sym_return] = ACTIONS(2696),
    [anon_sym_break] = ACTIONS(2696),
    [anon_sym_continue] = ACTIONS(2696),
    [anon_sym_goto] = ACTIONS(2696),
    [anon_sym_not] = ACTIONS(2696),
    [anon_sym_compl] = ACTIONS(2696),
    [anon_sym_DASH_DASH] = ACTIONS(2691),
    [anon_sym_PLUS_PLUS] = ACTIONS(2691),
    [anon_sym_sizeof] = ACTIONS(2696),
    [anon_sym___alignof__] = ACTIONS(2696),
    [anon_sym___alignof] = ACTIONS(2696),
    [anon_sym__alignof] = ACTIONS(2696),
    [anon_sym_alignof] = ACTIONS(2696),
    [anon_sym__Alignof] = ACTIONS(2696),
    [anon_sym_offsetof] = ACTIONS(2696),
    [anon_sym__Generic] = ACTIONS(2696),
    [anon_sym_asm] = ACTIONS(2696),
    [anon_sym___asm__] = ACTIONS(2696),
    [anon_sym_DOT] = ACTIONS(2724),
    [sym_number_literal] = ACTIONS(2691),
    [anon_sym_L_SQUOTE] = ACTIONS(2691),
    [anon_sym_u_SQUOTE] = ACTIONS(2691),
    [anon_sym_U_SQUOTE] = ACTIONS(2691),
    [anon_sym_u8_SQUOTE] = ACTIONS(2691),
    [anon_sym_SQUOTE] = ACTIONS(2691),
    [anon_sym_L_DQUOTE] = ACTIONS(2691),
    [anon_sym_u_DQUOTE] = ACTIONS(2691),
    [anon_sym_U_DQUOTE] = ACTIONS(2691),
    [anon_sym_u8_DQUOTE] = ACTIONS(2691),
    [anon_sym_DQUOTE] = ACTIONS(2691),
    [sym_true] = ACTIONS(2696),
    [sym_false] = ACTIONS(2696),
    [anon_sym_NULL] = ACTIONS(2696),
    [anon_sym_nullptr] = ACTIONS(2696),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2726),
    [anon_sym_let] = ACTIONS(2726),
    [anon_sym_This] = ACTIONS(2726),
    [anon_sym_decltype] = ACTIONS(2693),
    [sym_virtual] = ACTIONS(2706),
    [anon_sym_explicit] = ACTIONS(2696),
    [anon_sym_typename] = ACTIONS(2696),
    [anon_sym_template] = ACTIONS(2693),
    [anon_sym_operator] = ACTIONS(2693),
    [anon_sym_try] = ACTIONS(2696),
    [anon_sym_delete] = ACTIONS(2696),
    [anon_sym_throw] = ACTIONS(2696),
    [anon_sym_namespace] = ACTIONS(2696),
    [anon_sym_using] = ACTIONS(2696),
    [anon_sym_static_assert] = ACTIONS(2696),
    [anon_sym_concept] = ACTIONS(2696),
    [anon_sym_co_return] = ACTIONS(2696),
    [anon_sym_co_yield] = ACTIONS(2696),
    [anon_sym_R_DQUOTE] = ACTIONS(2691),
    [anon_sym_LR_DQUOTE] = ACTIONS(2691),
    [anon_sym_uR_DQUOTE] = ACTIONS(2691),
    [anon_sym_UR_DQUOTE] = ACTIONS(2691),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2691),
    [anon_sym_co_await] = ACTIONS(2696),
    [anon_sym_new] = ACTIONS(2696),
    [anon_sym_requires] = ACTIONS(2696),
    [sym_this] = ACTIONS(2696),
    [anon_sym_precise] = ACTIONS(2728),
    [anon_sym_shared] = ACTIONS(2728),
    [anon_sym_groupshared] = ACTIONS(2728),
    [anon_sym_uniform] = ACTIONS(2728),
    [anon_sym_row_major] = ACTIONS(2728),
    [anon_sym_column_major] = ACTIONS(2728),
    [anon_sym_globallycoherent] = ACTIONS(2728),
    [anon_sym_centroid] = ACTIONS(2728),
    [anon_sym_noperspective] = ACTIONS(2728),
    [anon_sym_nointerpolation] = ACTIONS(2728),
    [anon_sym_sample] = ACTIONS(2728),
    [anon_sym_linear] = ACTIONS(2728),
    [anon_sym_snorm] = ACTIONS(2728),
    [anon_sym_unorm] = ACTIONS(2728),
    [anon_sym_point] = ACTIONS(2728),
    [anon_sym_line] = ACTIONS(2728),
    [anon_sym_triangleadj] = ACTIONS(2728),
    [anon_sym_lineadj] = ACTIONS(2728),
    [anon_sym_triangle] = ACTIONS(2728),
    [anon_sym_interface] = ACTIONS(2696),
    [anon_sym_extension] = ACTIONS(2696),
    [anon_sym___exported] = ACTIONS(2696),
    [anon_sym_import] = ACTIONS(2696),
  },
  [248] = {
    [sym_identifier] = ACTIONS(2373),
    [aux_sym_preproc_include_token1] = ACTIONS(2373),
    [aux_sym_preproc_def_token1] = ACTIONS(2373),
    [aux_sym_preproc_if_token1] = ACTIONS(2373),
    [aux_sym_preproc_if_token2] = ACTIONS(2373),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2373),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2373),
    [aux_sym_preproc_else_token1] = ACTIONS(2373),
    [aux_sym_preproc_elif_token1] = ACTIONS(2373),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2373),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2373),
    [sym_preproc_directive] = ACTIONS(2373),
    [anon_sym_LPAREN2] = ACTIONS(2371),
    [anon_sym_BANG] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym___extension__] = ACTIONS(2373),
    [anon_sym_typedef] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_out] = ACTIONS(2373),
    [anon_sym_inout] = ACTIONS(2373),
    [anon_sym_extern] = ACTIONS(2373),
    [anon_sym___attribute__] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2371),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2371),
    [anon_sym___declspec] = ACTIONS(2373),
    [anon_sym___based] = ACTIONS(2373),
    [anon_sym___cdecl] = ACTIONS(2373),
    [anon_sym___clrcall] = ACTIONS(2373),
    [anon_sym___stdcall] = ACTIONS(2373),
    [anon_sym___fastcall] = ACTIONS(2373),
    [anon_sym___thiscall] = ACTIONS(2373),
    [anon_sym___vectorcall] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_signed] = ACTIONS(2373),
    [anon_sym_unsigned] = ACTIONS(2373),
    [anon_sym_long] = ACTIONS(2373),
    [anon_sym_short] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2373),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_register] = ACTIONS(2373),
    [anon_sym_inline] = ACTIONS(2373),
    [anon_sym___inline] = ACTIONS(2373),
    [anon_sym___inline__] = ACTIONS(2373),
    [anon_sym___forceinline] = ACTIONS(2373),
    [anon_sym_thread_local] = ACTIONS(2373),
    [anon_sym___thread] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym___restrict__] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym__Noreturn] = ACTIONS(2373),
    [anon_sym_noreturn] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_constinit] = ACTIONS(2373),
    [anon_sym_consteval] = ACTIONS(2373),
    [anon_sym_alignas] = ACTIONS(2373),
    [anon_sym__Alignas] = ACTIONS(2373),
    [sym_primitive_type] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_class] = ACTIONS(2373),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_else] = ACTIONS(2373),
    [anon_sym_switch] = ACTIONS(2373),
    [anon_sym_case] = ACTIONS(2373),
    [anon_sym_default] = ACTIONS(2373),
    [anon_sym_while] = ACTIONS(2373),
    [anon_sym_do] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2373),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2373),
    [anon_sym_goto] = ACTIONS(2373),
    [anon_sym___try] = ACTIONS(2373),
    [anon_sym___leave] = ACTIONS(2373),
    [anon_sym_not] = ACTIONS(2373),
    [anon_sym_compl] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_sizeof] = ACTIONS(2373),
    [anon_sym___alignof__] = ACTIONS(2373),
    [anon_sym___alignof] = ACTIONS(2373),
    [anon_sym__alignof] = ACTIONS(2373),
    [anon_sym_alignof] = ACTIONS(2373),
    [anon_sym__Alignof] = ACTIONS(2373),
    [anon_sym_offsetof] = ACTIONS(2373),
    [anon_sym__Generic] = ACTIONS(2373),
    [anon_sym_asm] = ACTIONS(2373),
    [anon_sym___asm__] = ACTIONS(2373),
    [sym_number_literal] = ACTIONS(2371),
    [anon_sym_L_SQUOTE] = ACTIONS(2371),
    [anon_sym_u_SQUOTE] = ACTIONS(2371),
    [anon_sym_U_SQUOTE] = ACTIONS(2371),
    [anon_sym_u8_SQUOTE] = ACTIONS(2371),
    [anon_sym_SQUOTE] = ACTIONS(2371),
    [anon_sym_L_DQUOTE] = ACTIONS(2371),
    [anon_sym_u_DQUOTE] = ACTIONS(2371),
    [anon_sym_U_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8_DQUOTE] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [anon_sym_NULL] = ACTIONS(2373),
    [anon_sym_nullptr] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_This] = ACTIONS(2373),
    [anon_sym_decltype] = ACTIONS(2373),
    [anon_sym_final] = ACTIONS(2373),
    [anon_sym_override] = ACTIONS(2373),
    [sym_virtual] = ACTIONS(2373),
    [anon_sym_explicit] = ACTIONS(2373),
    [anon_sym_typename] = ACTIONS(2373),
    [anon_sym_template] = ACTIONS(2373),
    [anon_sym_operator] = ACTIONS(2373),
    [anon_sym_try] = ACTIONS(2373),
    [anon_sym_delete] = ACTIONS(2373),
    [anon_sym_throw] = ACTIONS(2373),
    [anon_sym_namespace] = ACTIONS(2373),
    [anon_sym_using] = ACTIONS(2373),
    [anon_sym_static_assert] = ACTIONS(2373),
    [anon_sym_concept] = ACTIONS(2373),
    [anon_sym_co_return] = ACTIONS(2373),
    [anon_sym_co_yield] = ACTIONS(2373),
    [anon_sym_R_DQUOTE] = ACTIONS(2371),
    [anon_sym_LR_DQUOTE] = ACTIONS(2371),
    [anon_sym_uR_DQUOTE] = ACTIONS(2371),
    [anon_sym_UR_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2371),
    [anon_sym_co_await] = ACTIONS(2373),
    [anon_sym_new] = ACTIONS(2373),
    [anon_sym_requires] = ACTIONS(2373),
    [sym_this] = ACTIONS(2373),
    [anon_sym_discard] = ACTIONS(2373),
    [anon_sym_precise] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_groupshared] = ACTIONS(2373),
    [anon_sym_uniform] = ACTIONS(2373),
    [anon_sym_row_major] = ACTIONS(2373),
    [anon_sym_column_major] = ACTIONS(2373),
    [anon_sym_globallycoherent] = ACTIONS(2373),
    [anon_sym_centroid] = ACTIONS(2373),
    [anon_sym_noperspective] = ACTIONS(2373),
    [anon_sym_nointerpolation] = ACTIONS(2373),
    [anon_sym_sample] = ACTIONS(2373),
    [anon_sym_linear] = ACTIONS(2373),
    [anon_sym_snorm] = ACTIONS(2373),
    [anon_sym_unorm] = ACTIONS(2373),
    [anon_sym_point] = ACTIONS(2373),
    [anon_sym_line] = ACTIONS(2373),
    [anon_sym_triangleadj] = ACTIONS(2373),
    [anon_sym_lineadj] = ACTIONS(2373),
    [anon_sym_triangle] = ACTIONS(2373),
    [anon_sym_cbuffer] = ACTIONS(2373),
    [anon_sym_interface] = ACTIONS(2373),
    [anon_sym_extension] = ACTIONS(2373),
  },
  [249] = {
    [sym_identifier] = ACTIONS(2367),
    [aux_sym_preproc_include_token1] = ACTIONS(2367),
    [aux_sym_preproc_def_token1] = ACTIONS(2367),
    [aux_sym_preproc_if_token1] = ACTIONS(2367),
    [aux_sym_preproc_if_token2] = ACTIONS(2367),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2367),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2367),
    [aux_sym_preproc_else_token1] = ACTIONS(2367),
    [aux_sym_preproc_elif_token1] = ACTIONS(2367),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2367),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2367),
    [sym_preproc_directive] = ACTIONS(2367),
    [anon_sym_LPAREN2] = ACTIONS(2365),
    [anon_sym_BANG] = ACTIONS(2365),
    [anon_sym_TILDE] = ACTIONS(2365),
    [anon_sym_DASH] = ACTIONS(2367),
    [anon_sym_PLUS] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2365),
    [anon_sym_AMP_AMP] = ACTIONS(2365),
    [anon_sym_AMP] = ACTIONS(2367),
    [anon_sym_COLON] = ACTIONS(2367),
    [anon_sym_SEMI] = ACTIONS(2365),
    [anon_sym___extension__] = ACTIONS(2367),
    [anon_sym_typedef] = ACTIONS(2367),
    [anon_sym_in] = ACTIONS(2367),
    [anon_sym_out] = ACTIONS(2367),
    [anon_sym_inout] = ACTIONS(2367),
    [anon_sym_extern] = ACTIONS(2367),
    [anon_sym___attribute__] = ACTIONS(2367),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2365),
    [anon_sym___declspec] = ACTIONS(2367),
    [anon_sym___based] = ACTIONS(2367),
    [anon_sym___cdecl] = ACTIONS(2367),
    [anon_sym___clrcall] = ACTIONS(2367),
    [anon_sym___stdcall] = ACTIONS(2367),
    [anon_sym___fastcall] = ACTIONS(2367),
    [anon_sym___thiscall] = ACTIONS(2367),
    [anon_sym___vectorcall] = ACTIONS(2367),
    [anon_sym_LBRACE] = ACTIONS(2365),
    [anon_sym_signed] = ACTIONS(2367),
    [anon_sym_unsigned] = ACTIONS(2367),
    [anon_sym_long] = ACTIONS(2367),
    [anon_sym_short] = ACTIONS(2367),
    [anon_sym_LBRACK] = ACTIONS(2367),
    [anon_sym_static] = ACTIONS(2367),
    [anon_sym_register] = ACTIONS(2367),
    [anon_sym_inline] = ACTIONS(2367),
    [anon_sym___inline] = ACTIONS(2367),
    [anon_sym___inline__] = ACTIONS(2367),
    [anon_sym___forceinline] = ACTIONS(2367),
    [anon_sym_thread_local] = ACTIONS(2367),
    [anon_sym___thread] = ACTIONS(2367),
    [anon_sym_const] = ACTIONS(2367),
    [anon_sym_constexpr] = ACTIONS(2367),
    [anon_sym_volatile] = ACTIONS(2367),
    [anon_sym_restrict] = ACTIONS(2367),
    [anon_sym___restrict__] = ACTIONS(2367),
    [anon_sym__Atomic] = ACTIONS(2367),
    [anon_sym__Noreturn] = ACTIONS(2367),
    [anon_sym_noreturn] = ACTIONS(2367),
    [anon_sym_mutable] = ACTIONS(2367),
    [anon_sym_constinit] = ACTIONS(2367),
    [anon_sym_consteval] = ACTIONS(2367),
    [anon_sym_alignas] = ACTIONS(2367),
    [anon_sym__Alignas] = ACTIONS(2367),
    [sym_primitive_type] = ACTIONS(2367),
    [anon_sym_enum] = ACTIONS(2367),
    [anon_sym_class] = ACTIONS(2367),
    [anon_sym_struct] = ACTIONS(2367),
    [anon_sym_union] = ACTIONS(2367),
    [anon_sym_if] = ACTIONS(2367),
    [anon_sym_else] = ACTIONS(2367),
    [anon_sym_switch] = ACTIONS(2367),
    [anon_sym_case] = ACTIONS(2367),
    [anon_sym_default] = ACTIONS(2367),
    [anon_sym_while] = ACTIONS(2367),
    [anon_sym_do] = ACTIONS(2367),
    [anon_sym_for] = ACTIONS(2367),
    [anon_sym_return] = ACTIONS(2367),
    [anon_sym_break] = ACTIONS(2367),
    [anon_sym_continue] = ACTIONS(2367),
    [anon_sym_goto] = ACTIONS(2367),
    [anon_sym___try] = ACTIONS(2367),
    [anon_sym___leave] = ACTIONS(2367),
    [anon_sym_not] = ACTIONS(2367),
    [anon_sym_compl] = ACTIONS(2367),
    [anon_sym_DASH_DASH] = ACTIONS(2365),
    [anon_sym_PLUS_PLUS] = ACTIONS(2365),
    [anon_sym_sizeof] = ACTIONS(2367),
    [anon_sym___alignof__] = ACTIONS(2367),
    [anon_sym___alignof] = ACTIONS(2367),
    [anon_sym__alignof] = ACTIONS(2367),
    [anon_sym_alignof] = ACTIONS(2367),
    [anon_sym__Alignof] = ACTIONS(2367),
    [anon_sym_offsetof] = ACTIONS(2367),
    [anon_sym__Generic] = ACTIONS(2367),
    [anon_sym_asm] = ACTIONS(2367),
    [anon_sym___asm__] = ACTIONS(2367),
    [sym_number_literal] = ACTIONS(2365),
    [anon_sym_L_SQUOTE] = ACTIONS(2365),
    [anon_sym_u_SQUOTE] = ACTIONS(2365),
    [anon_sym_U_SQUOTE] = ACTIONS(2365),
    [anon_sym_u8_SQUOTE] = ACTIONS(2365),
    [anon_sym_SQUOTE] = ACTIONS(2365),
    [anon_sym_L_DQUOTE] = ACTIONS(2365),
    [anon_sym_u_DQUOTE] = ACTIONS(2365),
    [anon_sym_U_DQUOTE] = ACTIONS(2365),
    [anon_sym_u8_DQUOTE] = ACTIONS(2365),
    [anon_sym_DQUOTE] = ACTIONS(2365),
    [sym_true] = ACTIONS(2367),
    [sym_false] = ACTIONS(2367),
    [anon_sym_NULL] = ACTIONS(2367),
    [anon_sym_nullptr] = ACTIONS(2367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2367),
    [anon_sym_let] = ACTIONS(2367),
    [anon_sym_This] = ACTIONS(2367),
    [anon_sym_decltype] = ACTIONS(2367),
    [anon_sym_final] = ACTIONS(2367),
    [anon_sym_override] = ACTIONS(2367),
    [sym_virtual] = ACTIONS(2367),
    [anon_sym_explicit] = ACTIONS(2367),
    [anon_sym_typename] = ACTIONS(2367),
    [anon_sym_template] = ACTIONS(2367),
    [anon_sym_operator] = ACTIONS(2367),
    [anon_sym_try] = ACTIONS(2367),
    [anon_sym_delete] = ACTIONS(2367),
    [anon_sym_throw] = ACTIONS(2367),
    [anon_sym_namespace] = ACTIONS(2367),
    [anon_sym_using] = ACTIONS(2367),
    [anon_sym_static_assert] = ACTIONS(2367),
    [anon_sym_concept] = ACTIONS(2367),
    [anon_sym_co_return] = ACTIONS(2367),
    [anon_sym_co_yield] = ACTIONS(2367),
    [anon_sym_R_DQUOTE] = ACTIONS(2365),
    [anon_sym_LR_DQUOTE] = ACTIONS(2365),
    [anon_sym_uR_DQUOTE] = ACTIONS(2365),
    [anon_sym_UR_DQUOTE] = ACTIONS(2365),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2365),
    [anon_sym_co_await] = ACTIONS(2367),
    [anon_sym_new] = ACTIONS(2367),
    [anon_sym_requires] = ACTIONS(2367),
    [sym_this] = ACTIONS(2367),
    [anon_sym_discard] = ACTIONS(2367),
    [anon_sym_precise] = ACTIONS(2367),
    [anon_sym_shared] = ACTIONS(2367),
    [anon_sym_groupshared] = ACTIONS(2367),
    [anon_sym_uniform] = ACTIONS(2367),
    [anon_sym_row_major] = ACTIONS(2367),
    [anon_sym_column_major] = ACTIONS(2367),
    [anon_sym_globallycoherent] = ACTIONS(2367),
    [anon_sym_centroid] = ACTIONS(2367),
    [anon_sym_noperspective] = ACTIONS(2367),
    [anon_sym_nointerpolation] = ACTIONS(2367),
    [anon_sym_sample] = ACTIONS(2367),
    [anon_sym_linear] = ACTIONS(2367),
    [anon_sym_snorm] = ACTIONS(2367),
    [anon_sym_unorm] = ACTIONS(2367),
    [anon_sym_point] = ACTIONS(2367),
    [anon_sym_line] = ACTIONS(2367),
    [anon_sym_triangleadj] = ACTIONS(2367),
    [anon_sym_lineadj] = ACTIONS(2367),
    [anon_sym_triangle] = ACTIONS(2367),
    [anon_sym_cbuffer] = ACTIONS(2367),
    [anon_sym_interface] = ACTIONS(2367),
    [anon_sym_extension] = ACTIONS(2367),
  },
  [250] = {
    [sym_identifier] = ACTIONS(2256),
    [aux_sym_preproc_include_token1] = ACTIONS(2256),
    [aux_sym_preproc_def_token1] = ACTIONS(2256),
    [aux_sym_preproc_if_token1] = ACTIONS(2256),
    [aux_sym_preproc_if_token2] = ACTIONS(2256),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2256),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2256),
    [aux_sym_preproc_else_token1] = ACTIONS(2256),
    [aux_sym_preproc_elif_token1] = ACTIONS(2256),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2256),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2256),
    [sym_preproc_directive] = ACTIONS(2256),
    [anon_sym_LPAREN2] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [anon_sym_DASH] = ACTIONS(2256),
    [anon_sym_PLUS] = ACTIONS(2256),
    [anon_sym_STAR] = ACTIONS(2258),
    [anon_sym_AMP_AMP] = ACTIONS(2258),
    [anon_sym_AMP] = ACTIONS(2256),
    [anon_sym_COLON] = ACTIONS(2256),
    [anon_sym_SEMI] = ACTIONS(2258),
    [anon_sym___extension__] = ACTIONS(2256),
    [anon_sym_typedef] = ACTIONS(2256),
    [anon_sym_in] = ACTIONS(2256),
    [anon_sym_out] = ACTIONS(2256),
    [anon_sym_inout] = ACTIONS(2256),
    [anon_sym_extern] = ACTIONS(2256),
    [anon_sym___attribute__] = ACTIONS(2256),
    [anon_sym_COLON_COLON] = ACTIONS(2258),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2258),
    [anon_sym___declspec] = ACTIONS(2256),
    [anon_sym___based] = ACTIONS(2256),
    [anon_sym___cdecl] = ACTIONS(2256),
    [anon_sym___clrcall] = ACTIONS(2256),
    [anon_sym___stdcall] = ACTIONS(2256),
    [anon_sym___fastcall] = ACTIONS(2256),
    [anon_sym___thiscall] = ACTIONS(2256),
    [anon_sym___vectorcall] = ACTIONS(2256),
    [anon_sym_LBRACE] = ACTIONS(2258),
    [anon_sym_signed] = ACTIONS(2256),
    [anon_sym_unsigned] = ACTIONS(2256),
    [anon_sym_long] = ACTIONS(2256),
    [anon_sym_short] = ACTIONS(2256),
    [anon_sym_LBRACK] = ACTIONS(2256),
    [anon_sym_static] = ACTIONS(2256),
    [anon_sym_register] = ACTIONS(2256),
    [anon_sym_inline] = ACTIONS(2256),
    [anon_sym___inline] = ACTIONS(2256),
    [anon_sym___inline__] = ACTIONS(2256),
    [anon_sym___forceinline] = ACTIONS(2256),
    [anon_sym_thread_local] = ACTIONS(2256),
    [anon_sym___thread] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_constexpr] = ACTIONS(2256),
    [anon_sym_volatile] = ACTIONS(2256),
    [anon_sym_restrict] = ACTIONS(2256),
    [anon_sym___restrict__] = ACTIONS(2256),
    [anon_sym__Atomic] = ACTIONS(2256),
    [anon_sym__Noreturn] = ACTIONS(2256),
    [anon_sym_noreturn] = ACTIONS(2256),
    [anon_sym_mutable] = ACTIONS(2256),
    [anon_sym_constinit] = ACTIONS(2256),
    [anon_sym_consteval] = ACTIONS(2256),
    [anon_sym_alignas] = ACTIONS(2256),
    [anon_sym__Alignas] = ACTIONS(2256),
    [sym_primitive_type] = ACTIONS(2256),
    [anon_sym_enum] = ACTIONS(2256),
    [anon_sym_class] = ACTIONS(2256),
    [anon_sym_struct] = ACTIONS(2256),
    [anon_sym_union] = ACTIONS(2256),
    [anon_sym_if] = ACTIONS(2256),
    [anon_sym_else] = ACTIONS(2256),
    [anon_sym_switch] = ACTIONS(2256),
    [anon_sym_case] = ACTIONS(2256),
    [anon_sym_default] = ACTIONS(2256),
    [anon_sym_while] = ACTIONS(2256),
    [anon_sym_do] = ACTIONS(2256),
    [anon_sym_for] = ACTIONS(2256),
    [anon_sym_return] = ACTIONS(2256),
    [anon_sym_break] = ACTIONS(2256),
    [anon_sym_continue] = ACTIONS(2256),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym___try] = ACTIONS(2256),
    [anon_sym___leave] = ACTIONS(2256),
    [anon_sym_not] = ACTIONS(2256),
    [anon_sym_compl] = ACTIONS(2256),
    [anon_sym_DASH_DASH] = ACTIONS(2258),
    [anon_sym_PLUS_PLUS] = ACTIONS(2258),
    [anon_sym_sizeof] = ACTIONS(2256),
    [anon_sym___alignof__] = ACTIONS(2256),
    [anon_sym___alignof] = ACTIONS(2256),
    [anon_sym__alignof] = ACTIONS(2256),
    [anon_sym_alignof] = ACTIONS(2256),
    [anon_sym__Alignof] = ACTIONS(2256),
    [anon_sym_offsetof] = ACTIONS(2256),
    [anon_sym__Generic] = ACTIONS(2256),
    [anon_sym_asm] = ACTIONS(2256),
    [anon_sym___asm__] = ACTIONS(2256),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_L_SQUOTE] = ACTIONS(2258),
    [anon_sym_u_SQUOTE] = ACTIONS(2258),
    [anon_sym_U_SQUOTE] = ACTIONS(2258),
    [anon_sym_u8_SQUOTE] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(2258),
    [anon_sym_L_DQUOTE] = ACTIONS(2258),
    [anon_sym_u_DQUOTE] = ACTIONS(2258),
    [anon_sym_U_DQUOTE] = ACTIONS(2258),
    [anon_sym_u8_DQUOTE] = ACTIONS(2258),
    [anon_sym_DQUOTE] = ACTIONS(2258),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2256),
    [anon_sym_nullptr] = ACTIONS(2256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_This] = ACTIONS(2256),
    [anon_sym_decltype] = ACTIONS(2256),
    [anon_sym_final] = ACTIONS(2256),
    [anon_sym_override] = ACTIONS(2256),
    [sym_virtual] = ACTIONS(2256),
    [anon_sym_explicit] = ACTIONS(2256),
    [anon_sym_typename] = ACTIONS(2256),
    [anon_sym_template] = ACTIONS(2256),
    [anon_sym_operator] = ACTIONS(2256),
    [anon_sym_try] = ACTIONS(2256),
    [anon_sym_delete] = ACTIONS(2256),
    [anon_sym_throw] = ACTIONS(2256),
    [anon_sym_namespace] = ACTIONS(2256),
    [anon_sym_using] = ACTIONS(2256),
    [anon_sym_static_assert] = ACTIONS(2256),
    [anon_sym_concept] = ACTIONS(2256),
    [anon_sym_co_return] = ACTIONS(2256),
    [anon_sym_co_yield] = ACTIONS(2256),
    [anon_sym_R_DQUOTE] = ACTIONS(2258),
    [anon_sym_LR_DQUOTE] = ACTIONS(2258),
    [anon_sym_uR_DQUOTE] = ACTIONS(2258),
    [anon_sym_UR_DQUOTE] = ACTIONS(2258),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2258),
    [anon_sym_co_await] = ACTIONS(2256),
    [anon_sym_new] = ACTIONS(2256),
    [anon_sym_requires] = ACTIONS(2256),
    [sym_this] = ACTIONS(2256),
    [anon_sym_discard] = ACTIONS(2256),
    [anon_sym_precise] = ACTIONS(2256),
    [anon_sym_shared] = ACTIONS(2256),
    [anon_sym_groupshared] = ACTIONS(2256),
    [anon_sym_uniform] = ACTIONS(2256),
    [anon_sym_row_major] = ACTIONS(2256),
    [anon_sym_column_major] = ACTIONS(2256),
    [anon_sym_globallycoherent] = ACTIONS(2256),
    [anon_sym_centroid] = ACTIONS(2256),
    [anon_sym_noperspective] = ACTIONS(2256),
    [anon_sym_nointerpolation] = ACTIONS(2256),
    [anon_sym_sample] = ACTIONS(2256),
    [anon_sym_linear] = ACTIONS(2256),
    [anon_sym_snorm] = ACTIONS(2256),
    [anon_sym_unorm] = ACTIONS(2256),
    [anon_sym_point] = ACTIONS(2256),
    [anon_sym_line] = ACTIONS(2256),
    [anon_sym_triangleadj] = ACTIONS(2256),
    [anon_sym_lineadj] = ACTIONS(2256),
    [anon_sym_triangle] = ACTIONS(2256),
    [anon_sym_cbuffer] = ACTIONS(2256),
    [anon_sym_interface] = ACTIONS(2256),
    [anon_sym_extension] = ACTIONS(2256),
  },
  [251] = {
    [sym_identifier] = ACTIONS(2210),
    [aux_sym_preproc_include_token1] = ACTIONS(2210),
    [aux_sym_preproc_def_token1] = ACTIONS(2210),
    [aux_sym_preproc_if_token1] = ACTIONS(2210),
    [aux_sym_preproc_if_token2] = ACTIONS(2210),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2210),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2210),
    [aux_sym_preproc_else_token1] = ACTIONS(2210),
    [aux_sym_preproc_elif_token1] = ACTIONS(2210),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2210),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2210),
    [sym_preproc_directive] = ACTIONS(2210),
    [anon_sym_LPAREN2] = ACTIONS(2217),
    [anon_sym_BANG] = ACTIONS(2217),
    [anon_sym_TILDE] = ACTIONS(2217),
    [anon_sym_DASH] = ACTIONS(2210),
    [anon_sym_PLUS] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(2217),
    [anon_sym_AMP_AMP] = ACTIONS(2217),
    [anon_sym_AMP] = ACTIONS(2210),
    [anon_sym_COLON] = ACTIONS(2210),
    [anon_sym_SEMI] = ACTIONS(2217),
    [anon_sym___extension__] = ACTIONS(2210),
    [anon_sym_typedef] = ACTIONS(2210),
    [anon_sym_in] = ACTIONS(2210),
    [anon_sym_out] = ACTIONS(2210),
    [anon_sym_inout] = ACTIONS(2210),
    [anon_sym_extern] = ACTIONS(2210),
    [anon_sym___attribute__] = ACTIONS(2210),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2217),
    [anon_sym___declspec] = ACTIONS(2210),
    [anon_sym___based] = ACTIONS(2210),
    [anon_sym___cdecl] = ACTIONS(2210),
    [anon_sym___clrcall] = ACTIONS(2210),
    [anon_sym___stdcall] = ACTIONS(2210),
    [anon_sym___fastcall] = ACTIONS(2210),
    [anon_sym___thiscall] = ACTIONS(2210),
    [anon_sym___vectorcall] = ACTIONS(2210),
    [anon_sym_LBRACE] = ACTIONS(2217),
    [anon_sym_signed] = ACTIONS(2210),
    [anon_sym_unsigned] = ACTIONS(2210),
    [anon_sym_long] = ACTIONS(2210),
    [anon_sym_short] = ACTIONS(2210),
    [anon_sym_LBRACK] = ACTIONS(2210),
    [anon_sym_static] = ACTIONS(2210),
    [anon_sym_register] = ACTIONS(2210),
    [anon_sym_inline] = ACTIONS(2210),
    [anon_sym___inline] = ACTIONS(2210),
    [anon_sym___inline__] = ACTIONS(2210),
    [anon_sym___forceinline] = ACTIONS(2210),
    [anon_sym_thread_local] = ACTIONS(2210),
    [anon_sym___thread] = ACTIONS(2210),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_constexpr] = ACTIONS(2210),
    [anon_sym_volatile] = ACTIONS(2210),
    [anon_sym_restrict] = ACTIONS(2210),
    [anon_sym___restrict__] = ACTIONS(2210),
    [anon_sym__Atomic] = ACTIONS(2210),
    [anon_sym__Noreturn] = ACTIONS(2210),
    [anon_sym_noreturn] = ACTIONS(2210),
    [anon_sym_mutable] = ACTIONS(2210),
    [anon_sym_constinit] = ACTIONS(2210),
    [anon_sym_consteval] = ACTIONS(2210),
    [anon_sym_alignas] = ACTIONS(2210),
    [anon_sym__Alignas] = ACTIONS(2210),
    [sym_primitive_type] = ACTIONS(2210),
    [anon_sym_enum] = ACTIONS(2210),
    [anon_sym_class] = ACTIONS(2210),
    [anon_sym_struct] = ACTIONS(2210),
    [anon_sym_union] = ACTIONS(2210),
    [anon_sym_if] = ACTIONS(2210),
    [anon_sym_else] = ACTIONS(2210),
    [anon_sym_switch] = ACTIONS(2210),
    [anon_sym_case] = ACTIONS(2210),
    [anon_sym_default] = ACTIONS(2210),
    [anon_sym_while] = ACTIONS(2210),
    [anon_sym_do] = ACTIONS(2210),
    [anon_sym_for] = ACTIONS(2210),
    [anon_sym_return] = ACTIONS(2210),
    [anon_sym_break] = ACTIONS(2210),
    [anon_sym_continue] = ACTIONS(2210),
    [anon_sym_goto] = ACTIONS(2210),
    [anon_sym___try] = ACTIONS(2210),
    [anon_sym___leave] = ACTIONS(2210),
    [anon_sym_not] = ACTIONS(2210),
    [anon_sym_compl] = ACTIONS(2210),
    [anon_sym_DASH_DASH] = ACTIONS(2217),
    [anon_sym_PLUS_PLUS] = ACTIONS(2217),
    [anon_sym_sizeof] = ACTIONS(2210),
    [anon_sym___alignof__] = ACTIONS(2210),
    [anon_sym___alignof] = ACTIONS(2210),
    [anon_sym__alignof] = ACTIONS(2210),
    [anon_sym_alignof] = ACTIONS(2210),
    [anon_sym__Alignof] = ACTIONS(2210),
    [anon_sym_offsetof] = ACTIONS(2210),
    [anon_sym__Generic] = ACTIONS(2210),
    [anon_sym_asm] = ACTIONS(2210),
    [anon_sym___asm__] = ACTIONS(2210),
    [sym_number_literal] = ACTIONS(2217),
    [anon_sym_L_SQUOTE] = ACTIONS(2217),
    [anon_sym_u_SQUOTE] = ACTIONS(2217),
    [anon_sym_U_SQUOTE] = ACTIONS(2217),
    [anon_sym_u8_SQUOTE] = ACTIONS(2217),
    [anon_sym_SQUOTE] = ACTIONS(2217),
    [anon_sym_L_DQUOTE] = ACTIONS(2217),
    [anon_sym_u_DQUOTE] = ACTIONS(2217),
    [anon_sym_U_DQUOTE] = ACTIONS(2217),
    [anon_sym_u8_DQUOTE] = ACTIONS(2217),
    [anon_sym_DQUOTE] = ACTIONS(2217),
    [sym_true] = ACTIONS(2210),
    [sym_false] = ACTIONS(2210),
    [anon_sym_NULL] = ACTIONS(2210),
    [anon_sym_nullptr] = ACTIONS(2210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2210),
    [anon_sym_let] = ACTIONS(2210),
    [anon_sym_This] = ACTIONS(2210),
    [anon_sym_decltype] = ACTIONS(2210),
    [anon_sym_final] = ACTIONS(2210),
    [anon_sym_override] = ACTIONS(2210),
    [sym_virtual] = ACTIONS(2210),
    [anon_sym_explicit] = ACTIONS(2210),
    [anon_sym_typename] = ACTIONS(2210),
    [anon_sym_template] = ACTIONS(2210),
    [anon_sym_operator] = ACTIONS(2210),
    [anon_sym_try] = ACTIONS(2210),
    [anon_sym_delete] = ACTIONS(2210),
    [anon_sym_throw] = ACTIONS(2210),
    [anon_sym_namespace] = ACTIONS(2210),
    [anon_sym_using] = ACTIONS(2210),
    [anon_sym_static_assert] = ACTIONS(2210),
    [anon_sym_concept] = ACTIONS(2210),
    [anon_sym_co_return] = ACTIONS(2210),
    [anon_sym_co_yield] = ACTIONS(2210),
    [anon_sym_R_DQUOTE] = ACTIONS(2217),
    [anon_sym_LR_DQUOTE] = ACTIONS(2217),
    [anon_sym_uR_DQUOTE] = ACTIONS(2217),
    [anon_sym_UR_DQUOTE] = ACTIONS(2217),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2217),
    [anon_sym_co_await] = ACTIONS(2210),
    [anon_sym_new] = ACTIONS(2210),
    [anon_sym_requires] = ACTIONS(2210),
    [sym_this] = ACTIONS(2210),
    [anon_sym_discard] = ACTIONS(2210),
    [anon_sym_precise] = ACTIONS(2210),
    [anon_sym_shared] = ACTIONS(2210),
    [anon_sym_groupshared] = ACTIONS(2210),
    [anon_sym_uniform] = ACTIONS(2210),
    [anon_sym_row_major] = ACTIONS(2210),
    [anon_sym_column_major] = ACTIONS(2210),
    [anon_sym_globallycoherent] = ACTIONS(2210),
    [anon_sym_centroid] = ACTIONS(2210),
    [anon_sym_noperspective] = ACTIONS(2210),
    [anon_sym_nointerpolation] = ACTIONS(2210),
    [anon_sym_sample] = ACTIONS(2210),
    [anon_sym_linear] = ACTIONS(2210),
    [anon_sym_snorm] = ACTIONS(2210),
    [anon_sym_unorm] = ACTIONS(2210),
    [anon_sym_point] = ACTIONS(2210),
    [anon_sym_line] = ACTIONS(2210),
    [anon_sym_triangleadj] = ACTIONS(2210),
    [anon_sym_lineadj] = ACTIONS(2210),
    [anon_sym_triangle] = ACTIONS(2210),
    [anon_sym_cbuffer] = ACTIONS(2210),
    [anon_sym_interface] = ACTIONS(2210),
    [anon_sym_extension] = ACTIONS(2210),
  },
  [252] = {
    [sym_identifier] = ACTIONS(2198),
    [aux_sym_preproc_include_token1] = ACTIONS(2198),
    [aux_sym_preproc_def_token1] = ACTIONS(2198),
    [aux_sym_preproc_if_token1] = ACTIONS(2198),
    [aux_sym_preproc_if_token2] = ACTIONS(2198),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2198),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2198),
    [aux_sym_preproc_else_token1] = ACTIONS(2198),
    [aux_sym_preproc_elif_token1] = ACTIONS(2198),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2198),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2198),
    [sym_preproc_directive] = ACTIONS(2198),
    [anon_sym_LPAREN2] = ACTIONS(2200),
    [anon_sym_BANG] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(2200),
    [anon_sym_AMP_AMP] = ACTIONS(2200),
    [anon_sym_AMP] = ACTIONS(2198),
    [anon_sym_COLON] = ACTIONS(2198),
    [anon_sym_SEMI] = ACTIONS(2200),
    [anon_sym___extension__] = ACTIONS(2198),
    [anon_sym_typedef] = ACTIONS(2198),
    [anon_sym_in] = ACTIONS(2198),
    [anon_sym_out] = ACTIONS(2198),
    [anon_sym_inout] = ACTIONS(2198),
    [anon_sym_extern] = ACTIONS(2198),
    [anon_sym___attribute__] = ACTIONS(2198),
    [anon_sym_COLON_COLON] = ACTIONS(2200),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2200),
    [anon_sym___declspec] = ACTIONS(2198),
    [anon_sym___based] = ACTIONS(2198),
    [anon_sym___cdecl] = ACTIONS(2198),
    [anon_sym___clrcall] = ACTIONS(2198),
    [anon_sym___stdcall] = ACTIONS(2198),
    [anon_sym___fastcall] = ACTIONS(2198),
    [anon_sym___thiscall] = ACTIONS(2198),
    [anon_sym___vectorcall] = ACTIONS(2198),
    [anon_sym_LBRACE] = ACTIONS(2200),
    [anon_sym_signed] = ACTIONS(2198),
    [anon_sym_unsigned] = ACTIONS(2198),
    [anon_sym_long] = ACTIONS(2198),
    [anon_sym_short] = ACTIONS(2198),
    [anon_sym_LBRACK] = ACTIONS(2198),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_register] = ACTIONS(2198),
    [anon_sym_inline] = ACTIONS(2198),
    [anon_sym___inline] = ACTIONS(2198),
    [anon_sym___inline__] = ACTIONS(2198),
    [anon_sym___forceinline] = ACTIONS(2198),
    [anon_sym_thread_local] = ACTIONS(2198),
    [anon_sym___thread] = ACTIONS(2198),
    [anon_sym_const] = ACTIONS(2198),
    [anon_sym_constexpr] = ACTIONS(2198),
    [anon_sym_volatile] = ACTIONS(2198),
    [anon_sym_restrict] = ACTIONS(2198),
    [anon_sym___restrict__] = ACTIONS(2198),
    [anon_sym__Atomic] = ACTIONS(2198),
    [anon_sym__Noreturn] = ACTIONS(2198),
    [anon_sym_noreturn] = ACTIONS(2198),
    [anon_sym_mutable] = ACTIONS(2198),
    [anon_sym_constinit] = ACTIONS(2198),
    [anon_sym_consteval] = ACTIONS(2198),
    [anon_sym_alignas] = ACTIONS(2198),
    [anon_sym__Alignas] = ACTIONS(2198),
    [sym_primitive_type] = ACTIONS(2198),
    [anon_sym_enum] = ACTIONS(2198),
    [anon_sym_class] = ACTIONS(2198),
    [anon_sym_struct] = ACTIONS(2198),
    [anon_sym_union] = ACTIONS(2198),
    [anon_sym_if] = ACTIONS(2198),
    [anon_sym_else] = ACTIONS(2198),
    [anon_sym_switch] = ACTIONS(2198),
    [anon_sym_case] = ACTIONS(2198),
    [anon_sym_default] = ACTIONS(2198),
    [anon_sym_while] = ACTIONS(2198),
    [anon_sym_do] = ACTIONS(2198),
    [anon_sym_for] = ACTIONS(2198),
    [anon_sym_return] = ACTIONS(2198),
    [anon_sym_break] = ACTIONS(2198),
    [anon_sym_continue] = ACTIONS(2198),
    [anon_sym_goto] = ACTIONS(2198),
    [anon_sym___try] = ACTIONS(2198),
    [anon_sym___leave] = ACTIONS(2198),
    [anon_sym_not] = ACTIONS(2198),
    [anon_sym_compl] = ACTIONS(2198),
    [anon_sym_DASH_DASH] = ACTIONS(2200),
    [anon_sym_PLUS_PLUS] = ACTIONS(2200),
    [anon_sym_sizeof] = ACTIONS(2198),
    [anon_sym___alignof__] = ACTIONS(2198),
    [anon_sym___alignof] = ACTIONS(2198),
    [anon_sym__alignof] = ACTIONS(2198),
    [anon_sym_alignof] = ACTIONS(2198),
    [anon_sym__Alignof] = ACTIONS(2198),
    [anon_sym_offsetof] = ACTIONS(2198),
    [anon_sym__Generic] = ACTIONS(2198),
    [anon_sym_asm] = ACTIONS(2198),
    [anon_sym___asm__] = ACTIONS(2198),
    [sym_number_literal] = ACTIONS(2200),
    [anon_sym_L_SQUOTE] = ACTIONS(2200),
    [anon_sym_u_SQUOTE] = ACTIONS(2200),
    [anon_sym_U_SQUOTE] = ACTIONS(2200),
    [anon_sym_u8_SQUOTE] = ACTIONS(2200),
    [anon_sym_SQUOTE] = ACTIONS(2200),
    [anon_sym_L_DQUOTE] = ACTIONS(2200),
    [anon_sym_u_DQUOTE] = ACTIONS(2200),
    [anon_sym_U_DQUOTE] = ACTIONS(2200),
    [anon_sym_u8_DQUOTE] = ACTIONS(2200),
    [anon_sym_DQUOTE] = ACTIONS(2200),
    [sym_true] = ACTIONS(2198),
    [sym_false] = ACTIONS(2198),
    [anon_sym_NULL] = ACTIONS(2198),
    [anon_sym_nullptr] = ACTIONS(2198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2198),
    [anon_sym_let] = ACTIONS(2198),
    [anon_sym_This] = ACTIONS(2198),
    [anon_sym_decltype] = ACTIONS(2198),
    [anon_sym_final] = ACTIONS(2198),
    [anon_sym_override] = ACTIONS(2198),
    [sym_virtual] = ACTIONS(2198),
    [anon_sym_explicit] = ACTIONS(2198),
    [anon_sym_typename] = ACTIONS(2198),
    [anon_sym_template] = ACTIONS(2198),
    [anon_sym_operator] = ACTIONS(2198),
    [anon_sym_try] = ACTIONS(2198),
    [anon_sym_delete] = ACTIONS(2198),
    [anon_sym_throw] = ACTIONS(2198),
    [anon_sym_namespace] = ACTIONS(2198),
    [anon_sym_using] = ACTIONS(2198),
    [anon_sym_static_assert] = ACTIONS(2198),
    [anon_sym_concept] = ACTIONS(2198),
    [anon_sym_co_return] = ACTIONS(2198),
    [anon_sym_co_yield] = ACTIONS(2198),
    [anon_sym_R_DQUOTE] = ACTIONS(2200),
    [anon_sym_LR_DQUOTE] = ACTIONS(2200),
    [anon_sym_uR_DQUOTE] = ACTIONS(2200),
    [anon_sym_UR_DQUOTE] = ACTIONS(2200),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2200),
    [anon_sym_co_await] = ACTIONS(2198),
    [anon_sym_new] = ACTIONS(2198),
    [anon_sym_requires] = ACTIONS(2198),
    [sym_this] = ACTIONS(2198),
    [anon_sym_discard] = ACTIONS(2198),
    [anon_sym_precise] = ACTIONS(2198),
    [anon_sym_shared] = ACTIONS(2198),
    [anon_sym_groupshared] = ACTIONS(2198),
    [anon_sym_uniform] = ACTIONS(2198),
    [anon_sym_row_major] = ACTIONS(2198),
    [anon_sym_column_major] = ACTIONS(2198),
    [anon_sym_globallycoherent] = ACTIONS(2198),
    [anon_sym_centroid] = ACTIONS(2198),
    [anon_sym_noperspective] = ACTIONS(2198),
    [anon_sym_nointerpolation] = ACTIONS(2198),
    [anon_sym_sample] = ACTIONS(2198),
    [anon_sym_linear] = ACTIONS(2198),
    [anon_sym_snorm] = ACTIONS(2198),
    [anon_sym_unorm] = ACTIONS(2198),
    [anon_sym_point] = ACTIONS(2198),
    [anon_sym_line] = ACTIONS(2198),
    [anon_sym_triangleadj] = ACTIONS(2198),
    [anon_sym_lineadj] = ACTIONS(2198),
    [anon_sym_triangle] = ACTIONS(2198),
    [anon_sym_cbuffer] = ACTIONS(2198),
    [anon_sym_interface] = ACTIONS(2198),
    [anon_sym_extension] = ACTIONS(2198),
  },
  [253] = {
    [sym_identifier] = ACTIONS(2186),
    [aux_sym_preproc_include_token1] = ACTIONS(2186),
    [aux_sym_preproc_def_token1] = ACTIONS(2186),
    [aux_sym_preproc_if_token1] = ACTIONS(2186),
    [aux_sym_preproc_if_token2] = ACTIONS(2186),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2186),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2186),
    [aux_sym_preproc_else_token1] = ACTIONS(2186),
    [aux_sym_preproc_elif_token1] = ACTIONS(2186),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2186),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2186),
    [sym_preproc_directive] = ACTIONS(2186),
    [anon_sym_LPAREN2] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2188),
    [anon_sym_TILDE] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2186),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_STAR] = ACTIONS(2188),
    [anon_sym_AMP_AMP] = ACTIONS(2188),
    [anon_sym_AMP] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym___extension__] = ACTIONS(2186),
    [anon_sym_typedef] = ACTIONS(2186),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_out] = ACTIONS(2186),
    [anon_sym_inout] = ACTIONS(2186),
    [anon_sym_extern] = ACTIONS(2186),
    [anon_sym___attribute__] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2188),
    [anon_sym___declspec] = ACTIONS(2186),
    [anon_sym___based] = ACTIONS(2186),
    [anon_sym___cdecl] = ACTIONS(2186),
    [anon_sym___clrcall] = ACTIONS(2186),
    [anon_sym___stdcall] = ACTIONS(2186),
    [anon_sym___fastcall] = ACTIONS(2186),
    [anon_sym___thiscall] = ACTIONS(2186),
    [anon_sym___vectorcall] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_signed] = ACTIONS(2186),
    [anon_sym_unsigned] = ACTIONS(2186),
    [anon_sym_long] = ACTIONS(2186),
    [anon_sym_short] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_static] = ACTIONS(2186),
    [anon_sym_register] = ACTIONS(2186),
    [anon_sym_inline] = ACTIONS(2186),
    [anon_sym___inline] = ACTIONS(2186),
    [anon_sym___inline__] = ACTIONS(2186),
    [anon_sym___forceinline] = ACTIONS(2186),
    [anon_sym_thread_local] = ACTIONS(2186),
    [anon_sym___thread] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_constexpr] = ACTIONS(2186),
    [anon_sym_volatile] = ACTIONS(2186),
    [anon_sym_restrict] = ACTIONS(2186),
    [anon_sym___restrict__] = ACTIONS(2186),
    [anon_sym__Atomic] = ACTIONS(2186),
    [anon_sym__Noreturn] = ACTIONS(2186),
    [anon_sym_noreturn] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_constinit] = ACTIONS(2186),
    [anon_sym_consteval] = ACTIONS(2186),
    [anon_sym_alignas] = ACTIONS(2186),
    [anon_sym__Alignas] = ACTIONS(2186),
    [sym_primitive_type] = ACTIONS(2186),
    [anon_sym_enum] = ACTIONS(2186),
    [anon_sym_class] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_union] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_switch] = ACTIONS(2186),
    [anon_sym_case] = ACTIONS(2186),
    [anon_sym_default] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [anon_sym_do] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_break] = ACTIONS(2186),
    [anon_sym_continue] = ACTIONS(2186),
    [anon_sym_goto] = ACTIONS(2186),
    [anon_sym___try] = ACTIONS(2186),
    [anon_sym___leave] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2186),
    [anon_sym_compl] = ACTIONS(2186),
    [anon_sym_DASH_DASH] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2188),
    [anon_sym_sizeof] = ACTIONS(2186),
    [anon_sym___alignof__] = ACTIONS(2186),
    [anon_sym___alignof] = ACTIONS(2186),
    [anon_sym__alignof] = ACTIONS(2186),
    [anon_sym_alignof] = ACTIONS(2186),
    [anon_sym__Alignof] = ACTIONS(2186),
    [anon_sym_offsetof] = ACTIONS(2186),
    [anon_sym__Generic] = ACTIONS(2186),
    [anon_sym_asm] = ACTIONS(2186),
    [anon_sym___asm__] = ACTIONS(2186),
    [sym_number_literal] = ACTIONS(2188),
    [anon_sym_L_SQUOTE] = ACTIONS(2188),
    [anon_sym_u_SQUOTE] = ACTIONS(2188),
    [anon_sym_U_SQUOTE] = ACTIONS(2188),
    [anon_sym_u8_SQUOTE] = ACTIONS(2188),
    [anon_sym_SQUOTE] = ACTIONS(2188),
    [anon_sym_L_DQUOTE] = ACTIONS(2188),
    [anon_sym_u_DQUOTE] = ACTIONS(2188),
    [anon_sym_U_DQUOTE] = ACTIONS(2188),
    [anon_sym_u8_DQUOTE] = ACTIONS(2188),
    [anon_sym_DQUOTE] = ACTIONS(2188),
    [sym_true] = ACTIONS(2186),
    [sym_false] = ACTIONS(2186),
    [anon_sym_NULL] = ACTIONS(2186),
    [anon_sym_nullptr] = ACTIONS(2186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_This] = ACTIONS(2186),
    [anon_sym_decltype] = ACTIONS(2186),
    [anon_sym_final] = ACTIONS(2186),
    [anon_sym_override] = ACTIONS(2186),
    [sym_virtual] = ACTIONS(2186),
    [anon_sym_explicit] = ACTIONS(2186),
    [anon_sym_typename] = ACTIONS(2186),
    [anon_sym_template] = ACTIONS(2186),
    [anon_sym_operator] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_delete] = ACTIONS(2186),
    [anon_sym_throw] = ACTIONS(2186),
    [anon_sym_namespace] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_static_assert] = ACTIONS(2186),
    [anon_sym_concept] = ACTIONS(2186),
    [anon_sym_co_return] = ACTIONS(2186),
    [anon_sym_co_yield] = ACTIONS(2186),
    [anon_sym_R_DQUOTE] = ACTIONS(2188),
    [anon_sym_LR_DQUOTE] = ACTIONS(2188),
    [anon_sym_uR_DQUOTE] = ACTIONS(2188),
    [anon_sym_UR_DQUOTE] = ACTIONS(2188),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2188),
    [anon_sym_co_await] = ACTIONS(2186),
    [anon_sym_new] = ACTIONS(2186),
    [anon_sym_requires] = ACTIONS(2186),
    [sym_this] = ACTIONS(2186),
    [anon_sym_discard] = ACTIONS(2186),
    [anon_sym_precise] = ACTIONS(2186),
    [anon_sym_shared] = ACTIONS(2186),
    [anon_sym_groupshared] = ACTIONS(2186),
    [anon_sym_uniform] = ACTIONS(2186),
    [anon_sym_row_major] = ACTIONS(2186),
    [anon_sym_column_major] = ACTIONS(2186),
    [anon_sym_globallycoherent] = ACTIONS(2186),
    [anon_sym_centroid] = ACTIONS(2186),
    [anon_sym_noperspective] = ACTIONS(2186),
    [anon_sym_nointerpolation] = ACTIONS(2186),
    [anon_sym_sample] = ACTIONS(2186),
    [anon_sym_linear] = ACTIONS(2186),
    [anon_sym_snorm] = ACTIONS(2186),
    [anon_sym_unorm] = ACTIONS(2186),
    [anon_sym_point] = ACTIONS(2186),
    [anon_sym_line] = ACTIONS(2186),
    [anon_sym_triangleadj] = ACTIONS(2186),
    [anon_sym_lineadj] = ACTIONS(2186),
    [anon_sym_triangle] = ACTIONS(2186),
    [anon_sym_cbuffer] = ACTIONS(2186),
    [anon_sym_interface] = ACTIONS(2186),
    [anon_sym_extension] = ACTIONS(2186),
  },
  [254] = {
    [sym_identifier] = ACTIONS(2206),
    [aux_sym_preproc_include_token1] = ACTIONS(2206),
    [aux_sym_preproc_def_token1] = ACTIONS(2206),
    [aux_sym_preproc_if_token1] = ACTIONS(2206),
    [aux_sym_preproc_if_token2] = ACTIONS(2206),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2206),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2206),
    [aux_sym_preproc_else_token1] = ACTIONS(2206),
    [aux_sym_preproc_elif_token1] = ACTIONS(2206),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2206),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2206),
    [sym_preproc_directive] = ACTIONS(2206),
    [anon_sym_LPAREN2] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2208),
    [anon_sym_TILDE] = ACTIONS(2208),
    [anon_sym_DASH] = ACTIONS(2206),
    [anon_sym_PLUS] = ACTIONS(2206),
    [anon_sym_STAR] = ACTIONS(2208),
    [anon_sym_AMP_AMP] = ACTIONS(2208),
    [anon_sym_AMP] = ACTIONS(2206),
    [anon_sym_COLON] = ACTIONS(2206),
    [anon_sym_SEMI] = ACTIONS(2208),
    [anon_sym___extension__] = ACTIONS(2206),
    [anon_sym_typedef] = ACTIONS(2206),
    [anon_sym_in] = ACTIONS(2206),
    [anon_sym_out] = ACTIONS(2206),
    [anon_sym_inout] = ACTIONS(2206),
    [anon_sym_extern] = ACTIONS(2206),
    [anon_sym___attribute__] = ACTIONS(2206),
    [anon_sym_COLON_COLON] = ACTIONS(2208),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2208),
    [anon_sym___declspec] = ACTIONS(2206),
    [anon_sym___based] = ACTIONS(2206),
    [anon_sym___cdecl] = ACTIONS(2206),
    [anon_sym___clrcall] = ACTIONS(2206),
    [anon_sym___stdcall] = ACTIONS(2206),
    [anon_sym___fastcall] = ACTIONS(2206),
    [anon_sym___thiscall] = ACTIONS(2206),
    [anon_sym___vectorcall] = ACTIONS(2206),
    [anon_sym_LBRACE] = ACTIONS(2208),
    [anon_sym_signed] = ACTIONS(2206),
    [anon_sym_unsigned] = ACTIONS(2206),
    [anon_sym_long] = ACTIONS(2206),
    [anon_sym_short] = ACTIONS(2206),
    [anon_sym_LBRACK] = ACTIONS(2206),
    [anon_sym_static] = ACTIONS(2206),
    [anon_sym_register] = ACTIONS(2206),
    [anon_sym_inline] = ACTIONS(2206),
    [anon_sym___inline] = ACTIONS(2206),
    [anon_sym___inline__] = ACTIONS(2206),
    [anon_sym___forceinline] = ACTIONS(2206),
    [anon_sym_thread_local] = ACTIONS(2206),
    [anon_sym___thread] = ACTIONS(2206),
    [anon_sym_const] = ACTIONS(2206),
    [anon_sym_constexpr] = ACTIONS(2206),
    [anon_sym_volatile] = ACTIONS(2206),
    [anon_sym_restrict] = ACTIONS(2206),
    [anon_sym___restrict__] = ACTIONS(2206),
    [anon_sym__Atomic] = ACTIONS(2206),
    [anon_sym__Noreturn] = ACTIONS(2206),
    [anon_sym_noreturn] = ACTIONS(2206),
    [anon_sym_mutable] = ACTIONS(2206),
    [anon_sym_constinit] = ACTIONS(2206),
    [anon_sym_consteval] = ACTIONS(2206),
    [anon_sym_alignas] = ACTIONS(2206),
    [anon_sym__Alignas] = ACTIONS(2206),
    [sym_primitive_type] = ACTIONS(2206),
    [anon_sym_enum] = ACTIONS(2206),
    [anon_sym_class] = ACTIONS(2206),
    [anon_sym_struct] = ACTIONS(2206),
    [anon_sym_union] = ACTIONS(2206),
    [anon_sym_if] = ACTIONS(2206),
    [anon_sym_else] = ACTIONS(2206),
    [anon_sym_switch] = ACTIONS(2206),
    [anon_sym_case] = ACTIONS(2206),
    [anon_sym_default] = ACTIONS(2206),
    [anon_sym_while] = ACTIONS(2206),
    [anon_sym_do] = ACTIONS(2206),
    [anon_sym_for] = ACTIONS(2206),
    [anon_sym_return] = ACTIONS(2206),
    [anon_sym_break] = ACTIONS(2206),
    [anon_sym_continue] = ACTIONS(2206),
    [anon_sym_goto] = ACTIONS(2206),
    [anon_sym___try] = ACTIONS(2206),
    [anon_sym___leave] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_compl] = ACTIONS(2206),
    [anon_sym_DASH_DASH] = ACTIONS(2208),
    [anon_sym_PLUS_PLUS] = ACTIONS(2208),
    [anon_sym_sizeof] = ACTIONS(2206),
    [anon_sym___alignof__] = ACTIONS(2206),
    [anon_sym___alignof] = ACTIONS(2206),
    [anon_sym__alignof] = ACTIONS(2206),
    [anon_sym_alignof] = ACTIONS(2206),
    [anon_sym__Alignof] = ACTIONS(2206),
    [anon_sym_offsetof] = ACTIONS(2206),
    [anon_sym__Generic] = ACTIONS(2206),
    [anon_sym_asm] = ACTIONS(2206),
    [anon_sym___asm__] = ACTIONS(2206),
    [sym_number_literal] = ACTIONS(2208),
    [anon_sym_L_SQUOTE] = ACTIONS(2208),
    [anon_sym_u_SQUOTE] = ACTIONS(2208),
    [anon_sym_U_SQUOTE] = ACTIONS(2208),
    [anon_sym_u8_SQUOTE] = ACTIONS(2208),
    [anon_sym_SQUOTE] = ACTIONS(2208),
    [anon_sym_L_DQUOTE] = ACTIONS(2208),
    [anon_sym_u_DQUOTE] = ACTIONS(2208),
    [anon_sym_U_DQUOTE] = ACTIONS(2208),
    [anon_sym_u8_DQUOTE] = ACTIONS(2208),
    [anon_sym_DQUOTE] = ACTIONS(2208),
    [sym_true] = ACTIONS(2206),
    [sym_false] = ACTIONS(2206),
    [anon_sym_NULL] = ACTIONS(2206),
    [anon_sym_nullptr] = ACTIONS(2206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2206),
    [anon_sym_let] = ACTIONS(2206),
    [anon_sym_This] = ACTIONS(2206),
    [anon_sym_decltype] = ACTIONS(2206),
    [anon_sym_final] = ACTIONS(2206),
    [anon_sym_override] = ACTIONS(2206),
    [sym_virtual] = ACTIONS(2206),
    [anon_sym_explicit] = ACTIONS(2206),
    [anon_sym_typename] = ACTIONS(2206),
    [anon_sym_template] = ACTIONS(2206),
    [anon_sym_operator] = ACTIONS(2206),
    [anon_sym_try] = ACTIONS(2206),
    [anon_sym_delete] = ACTIONS(2206),
    [anon_sym_throw] = ACTIONS(2206),
    [anon_sym_namespace] = ACTIONS(2206),
    [anon_sym_using] = ACTIONS(2206),
    [anon_sym_static_assert] = ACTIONS(2206),
    [anon_sym_concept] = ACTIONS(2206),
    [anon_sym_co_return] = ACTIONS(2206),
    [anon_sym_co_yield] = ACTIONS(2206),
    [anon_sym_R_DQUOTE] = ACTIONS(2208),
    [anon_sym_LR_DQUOTE] = ACTIONS(2208),
    [anon_sym_uR_DQUOTE] = ACTIONS(2208),
    [anon_sym_UR_DQUOTE] = ACTIONS(2208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2208),
    [anon_sym_co_await] = ACTIONS(2206),
    [anon_sym_new] = ACTIONS(2206),
    [anon_sym_requires] = ACTIONS(2206),
    [sym_this] = ACTIONS(2206),
    [anon_sym_discard] = ACTIONS(2206),
    [anon_sym_precise] = ACTIONS(2206),
    [anon_sym_shared] = ACTIONS(2206),
    [anon_sym_groupshared] = ACTIONS(2206),
    [anon_sym_uniform] = ACTIONS(2206),
    [anon_sym_row_major] = ACTIONS(2206),
    [anon_sym_column_major] = ACTIONS(2206),
    [anon_sym_globallycoherent] = ACTIONS(2206),
    [anon_sym_centroid] = ACTIONS(2206),
    [anon_sym_noperspective] = ACTIONS(2206),
    [anon_sym_nointerpolation] = ACTIONS(2206),
    [anon_sym_sample] = ACTIONS(2206),
    [anon_sym_linear] = ACTIONS(2206),
    [anon_sym_snorm] = ACTIONS(2206),
    [anon_sym_unorm] = ACTIONS(2206),
    [anon_sym_point] = ACTIONS(2206),
    [anon_sym_line] = ACTIONS(2206),
    [anon_sym_triangleadj] = ACTIONS(2206),
    [anon_sym_lineadj] = ACTIONS(2206),
    [anon_sym_triangle] = ACTIONS(2206),
    [anon_sym_cbuffer] = ACTIONS(2206),
    [anon_sym_interface] = ACTIONS(2206),
    [anon_sym_extension] = ACTIONS(2206),
  },
  [255] = {
    [sym_identifier] = ACTIONS(2224),
    [aux_sym_preproc_include_token1] = ACTIONS(2224),
    [aux_sym_preproc_def_token1] = ACTIONS(2224),
    [aux_sym_preproc_if_token1] = ACTIONS(2224),
    [aux_sym_preproc_if_token2] = ACTIONS(2224),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2224),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2224),
    [aux_sym_preproc_else_token1] = ACTIONS(2224),
    [aux_sym_preproc_elif_token1] = ACTIONS(2224),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2224),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2224),
    [sym_preproc_directive] = ACTIONS(2224),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_BANG] = ACTIONS(2226),
    [anon_sym_TILDE] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_PLUS] = ACTIONS(2224),
    [anon_sym_STAR] = ACTIONS(2226),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_AMP] = ACTIONS(2224),
    [anon_sym_COLON] = ACTIONS(2224),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym___extension__] = ACTIONS(2224),
    [anon_sym_typedef] = ACTIONS(2224),
    [anon_sym_in] = ACTIONS(2224),
    [anon_sym_out] = ACTIONS(2224),
    [anon_sym_inout] = ACTIONS(2224),
    [anon_sym_extern] = ACTIONS(2224),
    [anon_sym___attribute__] = ACTIONS(2224),
    [anon_sym_COLON_COLON] = ACTIONS(2226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2226),
    [anon_sym___declspec] = ACTIONS(2224),
    [anon_sym___based] = ACTIONS(2224),
    [anon_sym___cdecl] = ACTIONS(2224),
    [anon_sym___clrcall] = ACTIONS(2224),
    [anon_sym___stdcall] = ACTIONS(2224),
    [anon_sym___fastcall] = ACTIONS(2224),
    [anon_sym___thiscall] = ACTIONS(2224),
    [anon_sym___vectorcall] = ACTIONS(2224),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_signed] = ACTIONS(2224),
    [anon_sym_unsigned] = ACTIONS(2224),
    [anon_sym_long] = ACTIONS(2224),
    [anon_sym_short] = ACTIONS(2224),
    [anon_sym_LBRACK] = ACTIONS(2224),
    [anon_sym_static] = ACTIONS(2224),
    [anon_sym_register] = ACTIONS(2224),
    [anon_sym_inline] = ACTIONS(2224),
    [anon_sym___inline] = ACTIONS(2224),
    [anon_sym___inline__] = ACTIONS(2224),
    [anon_sym___forceinline] = ACTIONS(2224),
    [anon_sym_thread_local] = ACTIONS(2224),
    [anon_sym___thread] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_constexpr] = ACTIONS(2224),
    [anon_sym_volatile] = ACTIONS(2224),
    [anon_sym_restrict] = ACTIONS(2224),
    [anon_sym___restrict__] = ACTIONS(2224),
    [anon_sym__Atomic] = ACTIONS(2224),
    [anon_sym__Noreturn] = ACTIONS(2224),
    [anon_sym_noreturn] = ACTIONS(2224),
    [anon_sym_mutable] = ACTIONS(2224),
    [anon_sym_constinit] = ACTIONS(2224),
    [anon_sym_consteval] = ACTIONS(2224),
    [anon_sym_alignas] = ACTIONS(2224),
    [anon_sym__Alignas] = ACTIONS(2224),
    [sym_primitive_type] = ACTIONS(2224),
    [anon_sym_enum] = ACTIONS(2224),
    [anon_sym_class] = ACTIONS(2224),
    [anon_sym_struct] = ACTIONS(2224),
    [anon_sym_union] = ACTIONS(2224),
    [anon_sym_if] = ACTIONS(2224),
    [anon_sym_else] = ACTIONS(2224),
    [anon_sym_switch] = ACTIONS(2224),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2224),
    [anon_sym_while] = ACTIONS(2224),
    [anon_sym_do] = ACTIONS(2224),
    [anon_sym_for] = ACTIONS(2224),
    [anon_sym_return] = ACTIONS(2224),
    [anon_sym_break] = ACTIONS(2224),
    [anon_sym_continue] = ACTIONS(2224),
    [anon_sym_goto] = ACTIONS(2224),
    [anon_sym___try] = ACTIONS(2224),
    [anon_sym___leave] = ACTIONS(2224),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_compl] = ACTIONS(2224),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_sizeof] = ACTIONS(2224),
    [anon_sym___alignof__] = ACTIONS(2224),
    [anon_sym___alignof] = ACTIONS(2224),
    [anon_sym__alignof] = ACTIONS(2224),
    [anon_sym_alignof] = ACTIONS(2224),
    [anon_sym__Alignof] = ACTIONS(2224),
    [anon_sym_offsetof] = ACTIONS(2224),
    [anon_sym__Generic] = ACTIONS(2224),
    [anon_sym_asm] = ACTIONS(2224),
    [anon_sym___asm__] = ACTIONS(2224),
    [sym_number_literal] = ACTIONS(2226),
    [anon_sym_L_SQUOTE] = ACTIONS(2226),
    [anon_sym_u_SQUOTE] = ACTIONS(2226),
    [anon_sym_U_SQUOTE] = ACTIONS(2226),
    [anon_sym_u8_SQUOTE] = ACTIONS(2226),
    [anon_sym_SQUOTE] = ACTIONS(2226),
    [anon_sym_L_DQUOTE] = ACTIONS(2226),
    [anon_sym_u_DQUOTE] = ACTIONS(2226),
    [anon_sym_U_DQUOTE] = ACTIONS(2226),
    [anon_sym_u8_DQUOTE] = ACTIONS(2226),
    [anon_sym_DQUOTE] = ACTIONS(2226),
    [sym_true] = ACTIONS(2224),
    [sym_false] = ACTIONS(2224),
    [anon_sym_NULL] = ACTIONS(2224),
    [anon_sym_nullptr] = ACTIONS(2224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2224),
    [anon_sym_let] = ACTIONS(2224),
    [anon_sym_This] = ACTIONS(2224),
    [anon_sym_decltype] = ACTIONS(2224),
    [anon_sym_final] = ACTIONS(2224),
    [anon_sym_override] = ACTIONS(2224),
    [sym_virtual] = ACTIONS(2224),
    [anon_sym_explicit] = ACTIONS(2224),
    [anon_sym_typename] = ACTIONS(2224),
    [anon_sym_template] = ACTIONS(2224),
    [anon_sym_operator] = ACTIONS(2224),
    [anon_sym_try] = ACTIONS(2224),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_throw] = ACTIONS(2224),
    [anon_sym_namespace] = ACTIONS(2224),
    [anon_sym_using] = ACTIONS(2224),
    [anon_sym_static_assert] = ACTIONS(2224),
    [anon_sym_concept] = ACTIONS(2224),
    [anon_sym_co_return] = ACTIONS(2224),
    [anon_sym_co_yield] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(2226),
    [anon_sym_LR_DQUOTE] = ACTIONS(2226),
    [anon_sym_uR_DQUOTE] = ACTIONS(2226),
    [anon_sym_UR_DQUOTE] = ACTIONS(2226),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2226),
    [anon_sym_co_await] = ACTIONS(2224),
    [anon_sym_new] = ACTIONS(2224),
    [anon_sym_requires] = ACTIONS(2224),
    [sym_this] = ACTIONS(2224),
    [anon_sym_discard] = ACTIONS(2224),
    [anon_sym_precise] = ACTIONS(2224),
    [anon_sym_shared] = ACTIONS(2224),
    [anon_sym_groupshared] = ACTIONS(2224),
    [anon_sym_uniform] = ACTIONS(2224),
    [anon_sym_row_major] = ACTIONS(2224),
    [anon_sym_column_major] = ACTIONS(2224),
    [anon_sym_globallycoherent] = ACTIONS(2224),
    [anon_sym_centroid] = ACTIONS(2224),
    [anon_sym_noperspective] = ACTIONS(2224),
    [anon_sym_nointerpolation] = ACTIONS(2224),
    [anon_sym_sample] = ACTIONS(2224),
    [anon_sym_linear] = ACTIONS(2224),
    [anon_sym_snorm] = ACTIONS(2224),
    [anon_sym_unorm] = ACTIONS(2224),
    [anon_sym_point] = ACTIONS(2224),
    [anon_sym_line] = ACTIONS(2224),
    [anon_sym_triangleadj] = ACTIONS(2224),
    [anon_sym_lineadj] = ACTIONS(2224),
    [anon_sym_triangle] = ACTIONS(2224),
    [anon_sym_cbuffer] = ACTIONS(2224),
    [anon_sym_interface] = ACTIONS(2224),
    [anon_sym_extension] = ACTIONS(2224),
  },
  [256] = {
    [sym_identifier] = ACTIONS(2228),
    [aux_sym_preproc_include_token1] = ACTIONS(2228),
    [aux_sym_preproc_def_token1] = ACTIONS(2228),
    [aux_sym_preproc_if_token1] = ACTIONS(2228),
    [aux_sym_preproc_if_token2] = ACTIONS(2228),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2228),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2228),
    [aux_sym_preproc_else_token1] = ACTIONS(2228),
    [aux_sym_preproc_elif_token1] = ACTIONS(2228),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2228),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2228),
    [sym_preproc_directive] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_BANG] = ACTIONS(2230),
    [anon_sym_TILDE] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2228),
    [anon_sym_PLUS] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_AMP] = ACTIONS(2228),
    [anon_sym_COLON] = ACTIONS(2228),
    [anon_sym_SEMI] = ACTIONS(2230),
    [anon_sym___extension__] = ACTIONS(2228),
    [anon_sym_typedef] = ACTIONS(2228),
    [anon_sym_in] = ACTIONS(2228),
    [anon_sym_out] = ACTIONS(2228),
    [anon_sym_inout] = ACTIONS(2228),
    [anon_sym_extern] = ACTIONS(2228),
    [anon_sym___attribute__] = ACTIONS(2228),
    [anon_sym_COLON_COLON] = ACTIONS(2230),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2230),
    [anon_sym___declspec] = ACTIONS(2228),
    [anon_sym___based] = ACTIONS(2228),
    [anon_sym___cdecl] = ACTIONS(2228),
    [anon_sym___clrcall] = ACTIONS(2228),
    [anon_sym___stdcall] = ACTIONS(2228),
    [anon_sym___fastcall] = ACTIONS(2228),
    [anon_sym___thiscall] = ACTIONS(2228),
    [anon_sym___vectorcall] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_signed] = ACTIONS(2228),
    [anon_sym_unsigned] = ACTIONS(2228),
    [anon_sym_long] = ACTIONS(2228),
    [anon_sym_short] = ACTIONS(2228),
    [anon_sym_LBRACK] = ACTIONS(2228),
    [anon_sym_static] = ACTIONS(2228),
    [anon_sym_register] = ACTIONS(2228),
    [anon_sym_inline] = ACTIONS(2228),
    [anon_sym___inline] = ACTIONS(2228),
    [anon_sym___inline__] = ACTIONS(2228),
    [anon_sym___forceinline] = ACTIONS(2228),
    [anon_sym_thread_local] = ACTIONS(2228),
    [anon_sym___thread] = ACTIONS(2228),
    [anon_sym_const] = ACTIONS(2228),
    [anon_sym_constexpr] = ACTIONS(2228),
    [anon_sym_volatile] = ACTIONS(2228),
    [anon_sym_restrict] = ACTIONS(2228),
    [anon_sym___restrict__] = ACTIONS(2228),
    [anon_sym__Atomic] = ACTIONS(2228),
    [anon_sym__Noreturn] = ACTIONS(2228),
    [anon_sym_noreturn] = ACTIONS(2228),
    [anon_sym_mutable] = ACTIONS(2228),
    [anon_sym_constinit] = ACTIONS(2228),
    [anon_sym_consteval] = ACTIONS(2228),
    [anon_sym_alignas] = ACTIONS(2228),
    [anon_sym__Alignas] = ACTIONS(2228),
    [sym_primitive_type] = ACTIONS(2228),
    [anon_sym_enum] = ACTIONS(2228),
    [anon_sym_class] = ACTIONS(2228),
    [anon_sym_struct] = ACTIONS(2228),
    [anon_sym_union] = ACTIONS(2228),
    [anon_sym_if] = ACTIONS(2228),
    [anon_sym_else] = ACTIONS(2228),
    [anon_sym_switch] = ACTIONS(2228),
    [anon_sym_case] = ACTIONS(2228),
    [anon_sym_default] = ACTIONS(2228),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2228),
    [anon_sym_for] = ACTIONS(2228),
    [anon_sym_return] = ACTIONS(2228),
    [anon_sym_break] = ACTIONS(2228),
    [anon_sym_continue] = ACTIONS(2228),
    [anon_sym_goto] = ACTIONS(2228),
    [anon_sym___try] = ACTIONS(2228),
    [anon_sym___leave] = ACTIONS(2228),
    [anon_sym_not] = ACTIONS(2228),
    [anon_sym_compl] = ACTIONS(2228),
    [anon_sym_DASH_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_PLUS] = ACTIONS(2230),
    [anon_sym_sizeof] = ACTIONS(2228),
    [anon_sym___alignof__] = ACTIONS(2228),
    [anon_sym___alignof] = ACTIONS(2228),
    [anon_sym__alignof] = ACTIONS(2228),
    [anon_sym_alignof] = ACTIONS(2228),
    [anon_sym__Alignof] = ACTIONS(2228),
    [anon_sym_offsetof] = ACTIONS(2228),
    [anon_sym__Generic] = ACTIONS(2228),
    [anon_sym_asm] = ACTIONS(2228),
    [anon_sym___asm__] = ACTIONS(2228),
    [sym_number_literal] = ACTIONS(2230),
    [anon_sym_L_SQUOTE] = ACTIONS(2230),
    [anon_sym_u_SQUOTE] = ACTIONS(2230),
    [anon_sym_U_SQUOTE] = ACTIONS(2230),
    [anon_sym_u8_SQUOTE] = ACTIONS(2230),
    [anon_sym_SQUOTE] = ACTIONS(2230),
    [anon_sym_L_DQUOTE] = ACTIONS(2230),
    [anon_sym_u_DQUOTE] = ACTIONS(2230),
    [anon_sym_U_DQUOTE] = ACTIONS(2230),
    [anon_sym_u8_DQUOTE] = ACTIONS(2230),
    [anon_sym_DQUOTE] = ACTIONS(2230),
    [sym_true] = ACTIONS(2228),
    [sym_false] = ACTIONS(2228),
    [anon_sym_NULL] = ACTIONS(2228),
    [anon_sym_nullptr] = ACTIONS(2228),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(2228),
    [anon_sym_This] = ACTIONS(2228),
    [anon_sym_decltype] = ACTIONS(2228),
    [anon_sym_final] = ACTIONS(2228),
    [anon_sym_override] = ACTIONS(2228),
    [sym_virtual] = ACTIONS(2228),
    [anon_sym_explicit] = ACTIONS(2228),
    [anon_sym_typename] = ACTIONS(2228),
    [anon_sym_template] = ACTIONS(2228),
    [anon_sym_operator] = ACTIONS(2228),
    [anon_sym_try] = ACTIONS(2228),
    [anon_sym_delete] = ACTIONS(2228),
    [anon_sym_throw] = ACTIONS(2228),
    [anon_sym_namespace] = ACTIONS(2228),
    [anon_sym_using] = ACTIONS(2228),
    [anon_sym_static_assert] = ACTIONS(2228),
    [anon_sym_concept] = ACTIONS(2228),
    [anon_sym_co_return] = ACTIONS(2228),
    [anon_sym_co_yield] = ACTIONS(2228),
    [anon_sym_R_DQUOTE] = ACTIONS(2230),
    [anon_sym_LR_DQUOTE] = ACTIONS(2230),
    [anon_sym_uR_DQUOTE] = ACTIONS(2230),
    [anon_sym_UR_DQUOTE] = ACTIONS(2230),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2230),
    [anon_sym_co_await] = ACTIONS(2228),
    [anon_sym_new] = ACTIONS(2228),
    [anon_sym_requires] = ACTIONS(2228),
    [sym_this] = ACTIONS(2228),
    [anon_sym_discard] = ACTIONS(2228),
    [anon_sym_precise] = ACTIONS(2228),
    [anon_sym_shared] = ACTIONS(2228),
    [anon_sym_groupshared] = ACTIONS(2228),
    [anon_sym_uniform] = ACTIONS(2228),
    [anon_sym_row_major] = ACTIONS(2228),
    [anon_sym_column_major] = ACTIONS(2228),
    [anon_sym_globallycoherent] = ACTIONS(2228),
    [anon_sym_centroid] = ACTIONS(2228),
    [anon_sym_noperspective] = ACTIONS(2228),
    [anon_sym_nointerpolation] = ACTIONS(2228),
    [anon_sym_sample] = ACTIONS(2228),
    [anon_sym_linear] = ACTIONS(2228),
    [anon_sym_snorm] = ACTIONS(2228),
    [anon_sym_unorm] = ACTIONS(2228),
    [anon_sym_point] = ACTIONS(2228),
    [anon_sym_line] = ACTIONS(2228),
    [anon_sym_triangleadj] = ACTIONS(2228),
    [anon_sym_lineadj] = ACTIONS(2228),
    [anon_sym_triangle] = ACTIONS(2228),
    [anon_sym_cbuffer] = ACTIONS(2228),
    [anon_sym_interface] = ACTIONS(2228),
    [anon_sym_extension] = ACTIONS(2228),
  },
  [257] = {
    [sym_identifier] = ACTIONS(2236),
    [aux_sym_preproc_include_token1] = ACTIONS(2236),
    [aux_sym_preproc_def_token1] = ACTIONS(2236),
    [aux_sym_preproc_if_token1] = ACTIONS(2236),
    [aux_sym_preproc_if_token2] = ACTIONS(2236),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2236),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2236),
    [aux_sym_preproc_else_token1] = ACTIONS(2236),
    [aux_sym_preproc_elif_token1] = ACTIONS(2236),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2236),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2236),
    [sym_preproc_directive] = ACTIONS(2236),
    [anon_sym_LPAREN2] = ACTIONS(2238),
    [anon_sym_BANG] = ACTIONS(2238),
    [anon_sym_TILDE] = ACTIONS(2238),
    [anon_sym_DASH] = ACTIONS(2236),
    [anon_sym_PLUS] = ACTIONS(2236),
    [anon_sym_STAR] = ACTIONS(2238),
    [anon_sym_AMP_AMP] = ACTIONS(2238),
    [anon_sym_AMP] = ACTIONS(2236),
    [anon_sym_COLON] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(2238),
    [anon_sym___extension__] = ACTIONS(2236),
    [anon_sym_typedef] = ACTIONS(2236),
    [anon_sym_in] = ACTIONS(2236),
    [anon_sym_out] = ACTIONS(2236),
    [anon_sym_inout] = ACTIONS(2236),
    [anon_sym_extern] = ACTIONS(2236),
    [anon_sym___attribute__] = ACTIONS(2236),
    [anon_sym_COLON_COLON] = ACTIONS(2238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2238),
    [anon_sym___declspec] = ACTIONS(2236),
    [anon_sym___based] = ACTIONS(2236),
    [anon_sym___cdecl] = ACTIONS(2236),
    [anon_sym___clrcall] = ACTIONS(2236),
    [anon_sym___stdcall] = ACTIONS(2236),
    [anon_sym___fastcall] = ACTIONS(2236),
    [anon_sym___thiscall] = ACTIONS(2236),
    [anon_sym___vectorcall] = ACTIONS(2236),
    [anon_sym_LBRACE] = ACTIONS(2238),
    [anon_sym_signed] = ACTIONS(2236),
    [anon_sym_unsigned] = ACTIONS(2236),
    [anon_sym_long] = ACTIONS(2236),
    [anon_sym_short] = ACTIONS(2236),
    [anon_sym_LBRACK] = ACTIONS(2236),
    [anon_sym_static] = ACTIONS(2236),
    [anon_sym_register] = ACTIONS(2236),
    [anon_sym_inline] = ACTIONS(2236),
    [anon_sym___inline] = ACTIONS(2236),
    [anon_sym___inline__] = ACTIONS(2236),
    [anon_sym___forceinline] = ACTIONS(2236),
    [anon_sym_thread_local] = ACTIONS(2236),
    [anon_sym___thread] = ACTIONS(2236),
    [anon_sym_const] = ACTIONS(2236),
    [anon_sym_constexpr] = ACTIONS(2236),
    [anon_sym_volatile] = ACTIONS(2236),
    [anon_sym_restrict] = ACTIONS(2236),
    [anon_sym___restrict__] = ACTIONS(2236),
    [anon_sym__Atomic] = ACTIONS(2236),
    [anon_sym__Noreturn] = ACTIONS(2236),
    [anon_sym_noreturn] = ACTIONS(2236),
    [anon_sym_mutable] = ACTIONS(2236),
    [anon_sym_constinit] = ACTIONS(2236),
    [anon_sym_consteval] = ACTIONS(2236),
    [anon_sym_alignas] = ACTIONS(2236),
    [anon_sym__Alignas] = ACTIONS(2236),
    [sym_primitive_type] = ACTIONS(2236),
    [anon_sym_enum] = ACTIONS(2236),
    [anon_sym_class] = ACTIONS(2236),
    [anon_sym_struct] = ACTIONS(2236),
    [anon_sym_union] = ACTIONS(2236),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_else] = ACTIONS(2236),
    [anon_sym_switch] = ACTIONS(2236),
    [anon_sym_case] = ACTIONS(2236),
    [anon_sym_default] = ACTIONS(2236),
    [anon_sym_while] = ACTIONS(2236),
    [anon_sym_do] = ACTIONS(2236),
    [anon_sym_for] = ACTIONS(2236),
    [anon_sym_return] = ACTIONS(2236),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2236),
    [anon_sym_goto] = ACTIONS(2236),
    [anon_sym___try] = ACTIONS(2236),
    [anon_sym___leave] = ACTIONS(2236),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_compl] = ACTIONS(2236),
    [anon_sym_DASH_DASH] = ACTIONS(2238),
    [anon_sym_PLUS_PLUS] = ACTIONS(2238),
    [anon_sym_sizeof] = ACTIONS(2236),
    [anon_sym___alignof__] = ACTIONS(2236),
    [anon_sym___alignof] = ACTIONS(2236),
    [anon_sym__alignof] = ACTIONS(2236),
    [anon_sym_alignof] = ACTIONS(2236),
    [anon_sym__Alignof] = ACTIONS(2236),
    [anon_sym_offsetof] = ACTIONS(2236),
    [anon_sym__Generic] = ACTIONS(2236),
    [anon_sym_asm] = ACTIONS(2236),
    [anon_sym___asm__] = ACTIONS(2236),
    [sym_number_literal] = ACTIONS(2238),
    [anon_sym_L_SQUOTE] = ACTIONS(2238),
    [anon_sym_u_SQUOTE] = ACTIONS(2238),
    [anon_sym_U_SQUOTE] = ACTIONS(2238),
    [anon_sym_u8_SQUOTE] = ACTIONS(2238),
    [anon_sym_SQUOTE] = ACTIONS(2238),
    [anon_sym_L_DQUOTE] = ACTIONS(2238),
    [anon_sym_u_DQUOTE] = ACTIONS(2238),
    [anon_sym_U_DQUOTE] = ACTIONS(2238),
    [anon_sym_u8_DQUOTE] = ACTIONS(2238),
    [anon_sym_DQUOTE] = ACTIONS(2238),
    [sym_true] = ACTIONS(2236),
    [sym_false] = ACTIONS(2236),
    [anon_sym_NULL] = ACTIONS(2236),
    [anon_sym_nullptr] = ACTIONS(2236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2236),
    [anon_sym_let] = ACTIONS(2236),
    [anon_sym_This] = ACTIONS(2236),
    [anon_sym_decltype] = ACTIONS(2236),
    [anon_sym_final] = ACTIONS(2236),
    [anon_sym_override] = ACTIONS(2236),
    [sym_virtual] = ACTIONS(2236),
    [anon_sym_explicit] = ACTIONS(2236),
    [anon_sym_typename] = ACTIONS(2236),
    [anon_sym_template] = ACTIONS(2236),
    [anon_sym_operator] = ACTIONS(2236),
    [anon_sym_try] = ACTIONS(2236),
    [anon_sym_delete] = ACTIONS(2236),
    [anon_sym_throw] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(2236),
    [anon_sym_using] = ACTIONS(2236),
    [anon_sym_static_assert] = ACTIONS(2236),
    [anon_sym_concept] = ACTIONS(2236),
    [anon_sym_co_return] = ACTIONS(2236),
    [anon_sym_co_yield] = ACTIONS(2236),
    [anon_sym_R_DQUOTE] = ACTIONS(2238),
    [anon_sym_LR_DQUOTE] = ACTIONS(2238),
    [anon_sym_uR_DQUOTE] = ACTIONS(2238),
    [anon_sym_UR_DQUOTE] = ACTIONS(2238),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2238),
    [anon_sym_co_await] = ACTIONS(2236),
    [anon_sym_new] = ACTIONS(2236),
    [anon_sym_requires] = ACTIONS(2236),
    [sym_this] = ACTIONS(2236),
    [anon_sym_discard] = ACTIONS(2236),
    [anon_sym_precise] = ACTIONS(2236),
    [anon_sym_shared] = ACTIONS(2236),
    [anon_sym_groupshared] = ACTIONS(2236),
    [anon_sym_uniform] = ACTIONS(2236),
    [anon_sym_row_major] = ACTIONS(2236),
    [anon_sym_column_major] = ACTIONS(2236),
    [anon_sym_globallycoherent] = ACTIONS(2236),
    [anon_sym_centroid] = ACTIONS(2236),
    [anon_sym_noperspective] = ACTIONS(2236),
    [anon_sym_nointerpolation] = ACTIONS(2236),
    [anon_sym_sample] = ACTIONS(2236),
    [anon_sym_linear] = ACTIONS(2236),
    [anon_sym_snorm] = ACTIONS(2236),
    [anon_sym_unorm] = ACTIONS(2236),
    [anon_sym_point] = ACTIONS(2236),
    [anon_sym_line] = ACTIONS(2236),
    [anon_sym_triangleadj] = ACTIONS(2236),
    [anon_sym_lineadj] = ACTIONS(2236),
    [anon_sym_triangle] = ACTIONS(2236),
    [anon_sym_cbuffer] = ACTIONS(2236),
    [anon_sym_interface] = ACTIONS(2236),
    [anon_sym_extension] = ACTIONS(2236),
  },
  [258] = {
    [sym_identifier] = ACTIONS(2232),
    [aux_sym_preproc_include_token1] = ACTIONS(2232),
    [aux_sym_preproc_def_token1] = ACTIONS(2232),
    [aux_sym_preproc_if_token1] = ACTIONS(2232),
    [aux_sym_preproc_if_token2] = ACTIONS(2232),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2232),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2232),
    [aux_sym_preproc_else_token1] = ACTIONS(2232),
    [aux_sym_preproc_elif_token1] = ACTIONS(2232),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2232),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2232),
    [sym_preproc_directive] = ACTIONS(2232),
    [anon_sym_LPAREN2] = ACTIONS(2234),
    [anon_sym_BANG] = ACTIONS(2234),
    [anon_sym_TILDE] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2232),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_AMP_AMP] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2232),
    [anon_sym_COLON] = ACTIONS(2232),
    [anon_sym_SEMI] = ACTIONS(2234),
    [anon_sym___extension__] = ACTIONS(2232),
    [anon_sym_typedef] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2232),
    [anon_sym_out] = ACTIONS(2232),
    [anon_sym_inout] = ACTIONS(2232),
    [anon_sym_extern] = ACTIONS(2232),
    [anon_sym___attribute__] = ACTIONS(2232),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2234),
    [anon_sym___declspec] = ACTIONS(2232),
    [anon_sym___based] = ACTIONS(2232),
    [anon_sym___cdecl] = ACTIONS(2232),
    [anon_sym___clrcall] = ACTIONS(2232),
    [anon_sym___stdcall] = ACTIONS(2232),
    [anon_sym___fastcall] = ACTIONS(2232),
    [anon_sym___thiscall] = ACTIONS(2232),
    [anon_sym___vectorcall] = ACTIONS(2232),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_signed] = ACTIONS(2232),
    [anon_sym_unsigned] = ACTIONS(2232),
    [anon_sym_long] = ACTIONS(2232),
    [anon_sym_short] = ACTIONS(2232),
    [anon_sym_LBRACK] = ACTIONS(2232),
    [anon_sym_static] = ACTIONS(2232),
    [anon_sym_register] = ACTIONS(2232),
    [anon_sym_inline] = ACTIONS(2232),
    [anon_sym___inline] = ACTIONS(2232),
    [anon_sym___inline__] = ACTIONS(2232),
    [anon_sym___forceinline] = ACTIONS(2232),
    [anon_sym_thread_local] = ACTIONS(2232),
    [anon_sym___thread] = ACTIONS(2232),
    [anon_sym_const] = ACTIONS(2232),
    [anon_sym_constexpr] = ACTIONS(2232),
    [anon_sym_volatile] = ACTIONS(2232),
    [anon_sym_restrict] = ACTIONS(2232),
    [anon_sym___restrict__] = ACTIONS(2232),
    [anon_sym__Atomic] = ACTIONS(2232),
    [anon_sym__Noreturn] = ACTIONS(2232),
    [anon_sym_noreturn] = ACTIONS(2232),
    [anon_sym_mutable] = ACTIONS(2232),
    [anon_sym_constinit] = ACTIONS(2232),
    [anon_sym_consteval] = ACTIONS(2232),
    [anon_sym_alignas] = ACTIONS(2232),
    [anon_sym__Alignas] = ACTIONS(2232),
    [sym_primitive_type] = ACTIONS(2232),
    [anon_sym_enum] = ACTIONS(2232),
    [anon_sym_class] = ACTIONS(2232),
    [anon_sym_struct] = ACTIONS(2232),
    [anon_sym_union] = ACTIONS(2232),
    [anon_sym_if] = ACTIONS(2232),
    [anon_sym_else] = ACTIONS(2232),
    [anon_sym_switch] = ACTIONS(2232),
    [anon_sym_case] = ACTIONS(2232),
    [anon_sym_default] = ACTIONS(2232),
    [anon_sym_while] = ACTIONS(2232),
    [anon_sym_do] = ACTIONS(2232),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2232),
    [anon_sym_break] = ACTIONS(2232),
    [anon_sym_continue] = ACTIONS(2232),
    [anon_sym_goto] = ACTIONS(2232),
    [anon_sym___try] = ACTIONS(2232),
    [anon_sym___leave] = ACTIONS(2232),
    [anon_sym_not] = ACTIONS(2232),
    [anon_sym_compl] = ACTIONS(2232),
    [anon_sym_DASH_DASH] = ACTIONS(2234),
    [anon_sym_PLUS_PLUS] = ACTIONS(2234),
    [anon_sym_sizeof] = ACTIONS(2232),
    [anon_sym___alignof__] = ACTIONS(2232),
    [anon_sym___alignof] = ACTIONS(2232),
    [anon_sym__alignof] = ACTIONS(2232),
    [anon_sym_alignof] = ACTIONS(2232),
    [anon_sym__Alignof] = ACTIONS(2232),
    [anon_sym_offsetof] = ACTIONS(2232),
    [anon_sym__Generic] = ACTIONS(2232),
    [anon_sym_asm] = ACTIONS(2232),
    [anon_sym___asm__] = ACTIONS(2232),
    [sym_number_literal] = ACTIONS(2234),
    [anon_sym_L_SQUOTE] = ACTIONS(2234),
    [anon_sym_u_SQUOTE] = ACTIONS(2234),
    [anon_sym_U_SQUOTE] = ACTIONS(2234),
    [anon_sym_u8_SQUOTE] = ACTIONS(2234),
    [anon_sym_SQUOTE] = ACTIONS(2234),
    [anon_sym_L_DQUOTE] = ACTIONS(2234),
    [anon_sym_u_DQUOTE] = ACTIONS(2234),
    [anon_sym_U_DQUOTE] = ACTIONS(2234),
    [anon_sym_u8_DQUOTE] = ACTIONS(2234),
    [anon_sym_DQUOTE] = ACTIONS(2234),
    [sym_true] = ACTIONS(2232),
    [sym_false] = ACTIONS(2232),
    [anon_sym_NULL] = ACTIONS(2232),
    [anon_sym_nullptr] = ACTIONS(2232),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2232),
    [anon_sym_let] = ACTIONS(2232),
    [anon_sym_This] = ACTIONS(2232),
    [anon_sym_decltype] = ACTIONS(2232),
    [anon_sym_final] = ACTIONS(2232),
    [anon_sym_override] = ACTIONS(2232),
    [sym_virtual] = ACTIONS(2232),
    [anon_sym_explicit] = ACTIONS(2232),
    [anon_sym_typename] = ACTIONS(2232),
    [anon_sym_template] = ACTIONS(2232),
    [anon_sym_operator] = ACTIONS(2232),
    [anon_sym_try] = ACTIONS(2232),
    [anon_sym_delete] = ACTIONS(2232),
    [anon_sym_throw] = ACTIONS(2232),
    [anon_sym_namespace] = ACTIONS(2232),
    [anon_sym_using] = ACTIONS(2232),
    [anon_sym_static_assert] = ACTIONS(2232),
    [anon_sym_concept] = ACTIONS(2232),
    [anon_sym_co_return] = ACTIONS(2232),
    [anon_sym_co_yield] = ACTIONS(2232),
    [anon_sym_R_DQUOTE] = ACTIONS(2234),
    [anon_sym_LR_DQUOTE] = ACTIONS(2234),
    [anon_sym_uR_DQUOTE] = ACTIONS(2234),
    [anon_sym_UR_DQUOTE] = ACTIONS(2234),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2234),
    [anon_sym_co_await] = ACTIONS(2232),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_requires] = ACTIONS(2232),
    [sym_this] = ACTIONS(2232),
    [anon_sym_discard] = ACTIONS(2232),
    [anon_sym_precise] = ACTIONS(2232),
    [anon_sym_shared] = ACTIONS(2232),
    [anon_sym_groupshared] = ACTIONS(2232),
    [anon_sym_uniform] = ACTIONS(2232),
    [anon_sym_row_major] = ACTIONS(2232),
    [anon_sym_column_major] = ACTIONS(2232),
    [anon_sym_globallycoherent] = ACTIONS(2232),
    [anon_sym_centroid] = ACTIONS(2232),
    [anon_sym_noperspective] = ACTIONS(2232),
    [anon_sym_nointerpolation] = ACTIONS(2232),
    [anon_sym_sample] = ACTIONS(2232),
    [anon_sym_linear] = ACTIONS(2232),
    [anon_sym_snorm] = ACTIONS(2232),
    [anon_sym_unorm] = ACTIONS(2232),
    [anon_sym_point] = ACTIONS(2232),
    [anon_sym_line] = ACTIONS(2232),
    [anon_sym_triangleadj] = ACTIONS(2232),
    [anon_sym_lineadj] = ACTIONS(2232),
    [anon_sym_triangle] = ACTIONS(2232),
    [anon_sym_cbuffer] = ACTIONS(2232),
    [anon_sym_interface] = ACTIONS(2232),
    [anon_sym_extension] = ACTIONS(2232),
  },
  [259] = {
    [sym_identifier] = ACTIONS(2244),
    [aux_sym_preproc_include_token1] = ACTIONS(2244),
    [aux_sym_preproc_def_token1] = ACTIONS(2244),
    [aux_sym_preproc_if_token1] = ACTIONS(2244),
    [aux_sym_preproc_if_token2] = ACTIONS(2244),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2244),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2244),
    [aux_sym_preproc_else_token1] = ACTIONS(2244),
    [aux_sym_preproc_elif_token1] = ACTIONS(2244),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2244),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2244),
    [sym_preproc_directive] = ACTIONS(2244),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2244),
    [anon_sym_PLUS] = ACTIONS(2244),
    [anon_sym_STAR] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_AMP] = ACTIONS(2244),
    [anon_sym_COLON] = ACTIONS(2244),
    [anon_sym_SEMI] = ACTIONS(2246),
    [anon_sym___extension__] = ACTIONS(2244),
    [anon_sym_typedef] = ACTIONS(2244),
    [anon_sym_in] = ACTIONS(2244),
    [anon_sym_out] = ACTIONS(2244),
    [anon_sym_inout] = ACTIONS(2244),
    [anon_sym_extern] = ACTIONS(2244),
    [anon_sym___attribute__] = ACTIONS(2244),
    [anon_sym_COLON_COLON] = ACTIONS(2246),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2246),
    [anon_sym___declspec] = ACTIONS(2244),
    [anon_sym___based] = ACTIONS(2244),
    [anon_sym___cdecl] = ACTIONS(2244),
    [anon_sym___clrcall] = ACTIONS(2244),
    [anon_sym___stdcall] = ACTIONS(2244),
    [anon_sym___fastcall] = ACTIONS(2244),
    [anon_sym___thiscall] = ACTIONS(2244),
    [anon_sym___vectorcall] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_signed] = ACTIONS(2244),
    [anon_sym_unsigned] = ACTIONS(2244),
    [anon_sym_long] = ACTIONS(2244),
    [anon_sym_short] = ACTIONS(2244),
    [anon_sym_LBRACK] = ACTIONS(2244),
    [anon_sym_static] = ACTIONS(2244),
    [anon_sym_register] = ACTIONS(2244),
    [anon_sym_inline] = ACTIONS(2244),
    [anon_sym___inline] = ACTIONS(2244),
    [anon_sym___inline__] = ACTIONS(2244),
    [anon_sym___forceinline] = ACTIONS(2244),
    [anon_sym_thread_local] = ACTIONS(2244),
    [anon_sym___thread] = ACTIONS(2244),
    [anon_sym_const] = ACTIONS(2244),
    [anon_sym_constexpr] = ACTIONS(2244),
    [anon_sym_volatile] = ACTIONS(2244),
    [anon_sym_restrict] = ACTIONS(2244),
    [anon_sym___restrict__] = ACTIONS(2244),
    [anon_sym__Atomic] = ACTIONS(2244),
    [anon_sym__Noreturn] = ACTIONS(2244),
    [anon_sym_noreturn] = ACTIONS(2244),
    [anon_sym_mutable] = ACTIONS(2244),
    [anon_sym_constinit] = ACTIONS(2244),
    [anon_sym_consteval] = ACTIONS(2244),
    [anon_sym_alignas] = ACTIONS(2244),
    [anon_sym__Alignas] = ACTIONS(2244),
    [sym_primitive_type] = ACTIONS(2244),
    [anon_sym_enum] = ACTIONS(2244),
    [anon_sym_class] = ACTIONS(2244),
    [anon_sym_struct] = ACTIONS(2244),
    [anon_sym_union] = ACTIONS(2244),
    [anon_sym_if] = ACTIONS(2244),
    [anon_sym_else] = ACTIONS(2244),
    [anon_sym_switch] = ACTIONS(2244),
    [anon_sym_case] = ACTIONS(2244),
    [anon_sym_default] = ACTIONS(2244),
    [anon_sym_while] = ACTIONS(2244),
    [anon_sym_do] = ACTIONS(2244),
    [anon_sym_for] = ACTIONS(2244),
    [anon_sym_return] = ACTIONS(2244),
    [anon_sym_break] = ACTIONS(2244),
    [anon_sym_continue] = ACTIONS(2244),
    [anon_sym_goto] = ACTIONS(2244),
    [anon_sym___try] = ACTIONS(2244),
    [anon_sym___leave] = ACTIONS(2244),
    [anon_sym_not] = ACTIONS(2244),
    [anon_sym_compl] = ACTIONS(2244),
    [anon_sym_DASH_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_PLUS] = ACTIONS(2246),
    [anon_sym_sizeof] = ACTIONS(2244),
    [anon_sym___alignof__] = ACTIONS(2244),
    [anon_sym___alignof] = ACTIONS(2244),
    [anon_sym__alignof] = ACTIONS(2244),
    [anon_sym_alignof] = ACTIONS(2244),
    [anon_sym__Alignof] = ACTIONS(2244),
    [anon_sym_offsetof] = ACTIONS(2244),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2244),
    [anon_sym___asm__] = ACTIONS(2244),
    [sym_number_literal] = ACTIONS(2246),
    [anon_sym_L_SQUOTE] = ACTIONS(2246),
    [anon_sym_u_SQUOTE] = ACTIONS(2246),
    [anon_sym_U_SQUOTE] = ACTIONS(2246),
    [anon_sym_u8_SQUOTE] = ACTIONS(2246),
    [anon_sym_SQUOTE] = ACTIONS(2246),
    [anon_sym_L_DQUOTE] = ACTIONS(2246),
    [anon_sym_u_DQUOTE] = ACTIONS(2246),
    [anon_sym_U_DQUOTE] = ACTIONS(2246),
    [anon_sym_u8_DQUOTE] = ACTIONS(2246),
    [anon_sym_DQUOTE] = ACTIONS(2246),
    [sym_true] = ACTIONS(2244),
    [sym_false] = ACTIONS(2244),
    [anon_sym_NULL] = ACTIONS(2244),
    [anon_sym_nullptr] = ACTIONS(2244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2244),
    [anon_sym_let] = ACTIONS(2244),
    [anon_sym_This] = ACTIONS(2244),
    [anon_sym_decltype] = ACTIONS(2244),
    [anon_sym_final] = ACTIONS(2244),
    [anon_sym_override] = ACTIONS(2244),
    [sym_virtual] = ACTIONS(2244),
    [anon_sym_explicit] = ACTIONS(2244),
    [anon_sym_typename] = ACTIONS(2244),
    [anon_sym_template] = ACTIONS(2244),
    [anon_sym_operator] = ACTIONS(2244),
    [anon_sym_try] = ACTIONS(2244),
    [anon_sym_delete] = ACTIONS(2244),
    [anon_sym_throw] = ACTIONS(2244),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_using] = ACTIONS(2244),
    [anon_sym_static_assert] = ACTIONS(2244),
    [anon_sym_concept] = ACTIONS(2244),
    [anon_sym_co_return] = ACTIONS(2244),
    [anon_sym_co_yield] = ACTIONS(2244),
    [anon_sym_R_DQUOTE] = ACTIONS(2246),
    [anon_sym_LR_DQUOTE] = ACTIONS(2246),
    [anon_sym_uR_DQUOTE] = ACTIONS(2246),
    [anon_sym_UR_DQUOTE] = ACTIONS(2246),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2246),
    [anon_sym_co_await] = ACTIONS(2244),
    [anon_sym_new] = ACTIONS(2244),
    [anon_sym_requires] = ACTIONS(2244),
    [sym_this] = ACTIONS(2244),
    [anon_sym_discard] = ACTIONS(2244),
    [anon_sym_precise] = ACTIONS(2244),
    [anon_sym_shared] = ACTIONS(2244),
    [anon_sym_groupshared] = ACTIONS(2244),
    [anon_sym_uniform] = ACTIONS(2244),
    [anon_sym_row_major] = ACTIONS(2244),
    [anon_sym_column_major] = ACTIONS(2244),
    [anon_sym_globallycoherent] = ACTIONS(2244),
    [anon_sym_centroid] = ACTIONS(2244),
    [anon_sym_noperspective] = ACTIONS(2244),
    [anon_sym_nointerpolation] = ACTIONS(2244),
    [anon_sym_sample] = ACTIONS(2244),
    [anon_sym_linear] = ACTIONS(2244),
    [anon_sym_snorm] = ACTIONS(2244),
    [anon_sym_unorm] = ACTIONS(2244),
    [anon_sym_point] = ACTIONS(2244),
    [anon_sym_line] = ACTIONS(2244),
    [anon_sym_triangleadj] = ACTIONS(2244),
    [anon_sym_lineadj] = ACTIONS(2244),
    [anon_sym_triangle] = ACTIONS(2244),
    [anon_sym_cbuffer] = ACTIONS(2244),
    [anon_sym_interface] = ACTIONS(2244),
    [anon_sym_extension] = ACTIONS(2244),
  },
  [260] = {
    [sym_identifier] = ACTIONS(2252),
    [aux_sym_preproc_include_token1] = ACTIONS(2252),
    [aux_sym_preproc_def_token1] = ACTIONS(2252),
    [aux_sym_preproc_if_token1] = ACTIONS(2252),
    [aux_sym_preproc_if_token2] = ACTIONS(2252),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2252),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2252),
    [aux_sym_preproc_else_token1] = ACTIONS(2252),
    [aux_sym_preproc_elif_token1] = ACTIONS(2252),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2252),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2252),
    [sym_preproc_directive] = ACTIONS(2252),
    [anon_sym_LPAREN2] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2254),
    [anon_sym_TILDE] = ACTIONS(2254),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2254),
    [anon_sym_AMP_AMP] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym_SEMI] = ACTIONS(2254),
    [anon_sym___extension__] = ACTIONS(2252),
    [anon_sym_typedef] = ACTIONS(2252),
    [anon_sym_in] = ACTIONS(2252),
    [anon_sym_out] = ACTIONS(2252),
    [anon_sym_inout] = ACTIONS(2252),
    [anon_sym_extern] = ACTIONS(2252),
    [anon_sym___attribute__] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2254),
    [anon_sym___declspec] = ACTIONS(2252),
    [anon_sym___based] = ACTIONS(2252),
    [anon_sym___cdecl] = ACTIONS(2252),
    [anon_sym___clrcall] = ACTIONS(2252),
    [anon_sym___stdcall] = ACTIONS(2252),
    [anon_sym___fastcall] = ACTIONS(2252),
    [anon_sym___thiscall] = ACTIONS(2252),
    [anon_sym___vectorcall] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_signed] = ACTIONS(2252),
    [anon_sym_unsigned] = ACTIONS(2252),
    [anon_sym_long] = ACTIONS(2252),
    [anon_sym_short] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2252),
    [anon_sym_register] = ACTIONS(2252),
    [anon_sym_inline] = ACTIONS(2252),
    [anon_sym___inline] = ACTIONS(2252),
    [anon_sym___inline__] = ACTIONS(2252),
    [anon_sym___forceinline] = ACTIONS(2252),
    [anon_sym_thread_local] = ACTIONS(2252),
    [anon_sym___thread] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2252),
    [anon_sym_constexpr] = ACTIONS(2252),
    [anon_sym_volatile] = ACTIONS(2252),
    [anon_sym_restrict] = ACTIONS(2252),
    [anon_sym___restrict__] = ACTIONS(2252),
    [anon_sym__Atomic] = ACTIONS(2252),
    [anon_sym__Noreturn] = ACTIONS(2252),
    [anon_sym_noreturn] = ACTIONS(2252),
    [anon_sym_mutable] = ACTIONS(2252),
    [anon_sym_constinit] = ACTIONS(2252),
    [anon_sym_consteval] = ACTIONS(2252),
    [anon_sym_alignas] = ACTIONS(2252),
    [anon_sym__Alignas] = ACTIONS(2252),
    [sym_primitive_type] = ACTIONS(2252),
    [anon_sym_enum] = ACTIONS(2252),
    [anon_sym_class] = ACTIONS(2252),
    [anon_sym_struct] = ACTIONS(2252),
    [anon_sym_union] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_else] = ACTIONS(2252),
    [anon_sym_switch] = ACTIONS(2252),
    [anon_sym_case] = ACTIONS(2252),
    [anon_sym_default] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_do] = ACTIONS(2252),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2252),
    [anon_sym_goto] = ACTIONS(2252),
    [anon_sym___try] = ACTIONS(2252),
    [anon_sym___leave] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2252),
    [anon_sym_compl] = ACTIONS(2252),
    [anon_sym_DASH_DASH] = ACTIONS(2254),
    [anon_sym_PLUS_PLUS] = ACTIONS(2254),
    [anon_sym_sizeof] = ACTIONS(2252),
    [anon_sym___alignof__] = ACTIONS(2252),
    [anon_sym___alignof] = ACTIONS(2252),
    [anon_sym__alignof] = ACTIONS(2252),
    [anon_sym_alignof] = ACTIONS(2252),
    [anon_sym__Alignof] = ACTIONS(2252),
    [anon_sym_offsetof] = ACTIONS(2252),
    [anon_sym__Generic] = ACTIONS(2252),
    [anon_sym_asm] = ACTIONS(2252),
    [anon_sym___asm__] = ACTIONS(2252),
    [sym_number_literal] = ACTIONS(2254),
    [anon_sym_L_SQUOTE] = ACTIONS(2254),
    [anon_sym_u_SQUOTE] = ACTIONS(2254),
    [anon_sym_U_SQUOTE] = ACTIONS(2254),
    [anon_sym_u8_SQUOTE] = ACTIONS(2254),
    [anon_sym_SQUOTE] = ACTIONS(2254),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2252),
    [sym_false] = ACTIONS(2252),
    [anon_sym_NULL] = ACTIONS(2252),
    [anon_sym_nullptr] = ACTIONS(2252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_This] = ACTIONS(2252),
    [anon_sym_decltype] = ACTIONS(2252),
    [anon_sym_final] = ACTIONS(2252),
    [anon_sym_override] = ACTIONS(2252),
    [sym_virtual] = ACTIONS(2252),
    [anon_sym_explicit] = ACTIONS(2252),
    [anon_sym_typename] = ACTIONS(2252),
    [anon_sym_template] = ACTIONS(2252),
    [anon_sym_operator] = ACTIONS(2252),
    [anon_sym_try] = ACTIONS(2252),
    [anon_sym_delete] = ACTIONS(2252),
    [anon_sym_throw] = ACTIONS(2252),
    [anon_sym_namespace] = ACTIONS(2252),
    [anon_sym_using] = ACTIONS(2252),
    [anon_sym_static_assert] = ACTIONS(2252),
    [anon_sym_concept] = ACTIONS(2252),
    [anon_sym_co_return] = ACTIONS(2252),
    [anon_sym_co_yield] = ACTIONS(2252),
    [anon_sym_R_DQUOTE] = ACTIONS(2254),
    [anon_sym_LR_DQUOTE] = ACTIONS(2254),
    [anon_sym_uR_DQUOTE] = ACTIONS(2254),
    [anon_sym_UR_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2254),
    [anon_sym_co_await] = ACTIONS(2252),
    [anon_sym_new] = ACTIONS(2252),
    [anon_sym_requires] = ACTIONS(2252),
    [sym_this] = ACTIONS(2252),
    [anon_sym_discard] = ACTIONS(2252),
    [anon_sym_precise] = ACTIONS(2252),
    [anon_sym_shared] = ACTIONS(2252),
    [anon_sym_groupshared] = ACTIONS(2252),
    [anon_sym_uniform] = ACTIONS(2252),
    [anon_sym_row_major] = ACTIONS(2252),
    [anon_sym_column_major] = ACTIONS(2252),
    [anon_sym_globallycoherent] = ACTIONS(2252),
    [anon_sym_centroid] = ACTIONS(2252),
    [anon_sym_noperspective] = ACTIONS(2252),
    [anon_sym_nointerpolation] = ACTIONS(2252),
    [anon_sym_sample] = ACTIONS(2252),
    [anon_sym_linear] = ACTIONS(2252),
    [anon_sym_snorm] = ACTIONS(2252),
    [anon_sym_unorm] = ACTIONS(2252),
    [anon_sym_point] = ACTIONS(2252),
    [anon_sym_line] = ACTIONS(2252),
    [anon_sym_triangleadj] = ACTIONS(2252),
    [anon_sym_lineadj] = ACTIONS(2252),
    [anon_sym_triangle] = ACTIONS(2252),
    [anon_sym_cbuffer] = ACTIONS(2252),
    [anon_sym_interface] = ACTIONS(2252),
    [anon_sym_extension] = ACTIONS(2252),
  },
  [261] = {
    [sym_identifier] = ACTIONS(2190),
    [aux_sym_preproc_include_token1] = ACTIONS(2190),
    [aux_sym_preproc_def_token1] = ACTIONS(2190),
    [aux_sym_preproc_if_token1] = ACTIONS(2190),
    [aux_sym_preproc_if_token2] = ACTIONS(2190),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2190),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2190),
    [aux_sym_preproc_else_token1] = ACTIONS(2190),
    [aux_sym_preproc_elif_token1] = ACTIONS(2190),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2190),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2190),
    [sym_preproc_directive] = ACTIONS(2190),
    [anon_sym_LPAREN2] = ACTIONS(2192),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2190),
    [anon_sym_PLUS] = ACTIONS(2190),
    [anon_sym_STAR] = ACTIONS(2192),
    [anon_sym_AMP_AMP] = ACTIONS(2192),
    [anon_sym_AMP] = ACTIONS(2190),
    [anon_sym_COLON] = ACTIONS(2190),
    [anon_sym_SEMI] = ACTIONS(2192),
    [anon_sym___extension__] = ACTIONS(2190),
    [anon_sym_typedef] = ACTIONS(2190),
    [anon_sym_in] = ACTIONS(2190),
    [anon_sym_out] = ACTIONS(2190),
    [anon_sym_inout] = ACTIONS(2190),
    [anon_sym_extern] = ACTIONS(2190),
    [anon_sym___attribute__] = ACTIONS(2190),
    [anon_sym_COLON_COLON] = ACTIONS(2192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2192),
    [anon_sym___declspec] = ACTIONS(2190),
    [anon_sym___based] = ACTIONS(2190),
    [anon_sym___cdecl] = ACTIONS(2190),
    [anon_sym___clrcall] = ACTIONS(2190),
    [anon_sym___stdcall] = ACTIONS(2190),
    [anon_sym___fastcall] = ACTIONS(2190),
    [anon_sym___thiscall] = ACTIONS(2190),
    [anon_sym___vectorcall] = ACTIONS(2190),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [anon_sym_signed] = ACTIONS(2190),
    [anon_sym_unsigned] = ACTIONS(2190),
    [anon_sym_long] = ACTIONS(2190),
    [anon_sym_short] = ACTIONS(2190),
    [anon_sym_LBRACK] = ACTIONS(2190),
    [anon_sym_static] = ACTIONS(2190),
    [anon_sym_register] = ACTIONS(2190),
    [anon_sym_inline] = ACTIONS(2190),
    [anon_sym___inline] = ACTIONS(2190),
    [anon_sym___inline__] = ACTIONS(2190),
    [anon_sym___forceinline] = ACTIONS(2190),
    [anon_sym_thread_local] = ACTIONS(2190),
    [anon_sym___thread] = ACTIONS(2190),
    [anon_sym_const] = ACTIONS(2190),
    [anon_sym_constexpr] = ACTIONS(2190),
    [anon_sym_volatile] = ACTIONS(2190),
    [anon_sym_restrict] = ACTIONS(2190),
    [anon_sym___restrict__] = ACTIONS(2190),
    [anon_sym__Atomic] = ACTIONS(2190),
    [anon_sym__Noreturn] = ACTIONS(2190),
    [anon_sym_noreturn] = ACTIONS(2190),
    [anon_sym_mutable] = ACTIONS(2190),
    [anon_sym_constinit] = ACTIONS(2190),
    [anon_sym_consteval] = ACTIONS(2190),
    [anon_sym_alignas] = ACTIONS(2190),
    [anon_sym__Alignas] = ACTIONS(2190),
    [sym_primitive_type] = ACTIONS(2190),
    [anon_sym_enum] = ACTIONS(2190),
    [anon_sym_class] = ACTIONS(2190),
    [anon_sym_struct] = ACTIONS(2190),
    [anon_sym_union] = ACTIONS(2190),
    [anon_sym_if] = ACTIONS(2190),
    [anon_sym_else] = ACTIONS(2190),
    [anon_sym_switch] = ACTIONS(2190),
    [anon_sym_case] = ACTIONS(2190),
    [anon_sym_default] = ACTIONS(2190),
    [anon_sym_while] = ACTIONS(2190),
    [anon_sym_do] = ACTIONS(2190),
    [anon_sym_for] = ACTIONS(2190),
    [anon_sym_return] = ACTIONS(2190),
    [anon_sym_break] = ACTIONS(2190),
    [anon_sym_continue] = ACTIONS(2190),
    [anon_sym_goto] = ACTIONS(2190),
    [anon_sym___try] = ACTIONS(2190),
    [anon_sym___leave] = ACTIONS(2190),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_compl] = ACTIONS(2190),
    [anon_sym_DASH_DASH] = ACTIONS(2192),
    [anon_sym_PLUS_PLUS] = ACTIONS(2192),
    [anon_sym_sizeof] = ACTIONS(2190),
    [anon_sym___alignof__] = ACTIONS(2190),
    [anon_sym___alignof] = ACTIONS(2190),
    [anon_sym__alignof] = ACTIONS(2190),
    [anon_sym_alignof] = ACTIONS(2190),
    [anon_sym__Alignof] = ACTIONS(2190),
    [anon_sym_offsetof] = ACTIONS(2190),
    [anon_sym__Generic] = ACTIONS(2190),
    [anon_sym_asm] = ACTIONS(2190),
    [anon_sym___asm__] = ACTIONS(2190),
    [sym_number_literal] = ACTIONS(2192),
    [anon_sym_L_SQUOTE] = ACTIONS(2192),
    [anon_sym_u_SQUOTE] = ACTIONS(2192),
    [anon_sym_U_SQUOTE] = ACTIONS(2192),
    [anon_sym_u8_SQUOTE] = ACTIONS(2192),
    [anon_sym_SQUOTE] = ACTIONS(2192),
    [anon_sym_L_DQUOTE] = ACTIONS(2192),
    [anon_sym_u_DQUOTE] = ACTIONS(2192),
    [anon_sym_U_DQUOTE] = ACTIONS(2192),
    [anon_sym_u8_DQUOTE] = ACTIONS(2192),
    [anon_sym_DQUOTE] = ACTIONS(2192),
    [sym_true] = ACTIONS(2190),
    [sym_false] = ACTIONS(2190),
    [anon_sym_NULL] = ACTIONS(2190),
    [anon_sym_nullptr] = ACTIONS(2190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2190),
    [anon_sym_let] = ACTIONS(2190),
    [anon_sym_This] = ACTIONS(2190),
    [anon_sym_decltype] = ACTIONS(2190),
    [anon_sym_final] = ACTIONS(2190),
    [anon_sym_override] = ACTIONS(2190),
    [sym_virtual] = ACTIONS(2190),
    [anon_sym_explicit] = ACTIONS(2190),
    [anon_sym_typename] = ACTIONS(2190),
    [anon_sym_template] = ACTIONS(2190),
    [anon_sym_operator] = ACTIONS(2190),
    [anon_sym_try] = ACTIONS(2190),
    [anon_sym_delete] = ACTIONS(2190),
    [anon_sym_throw] = ACTIONS(2190),
    [anon_sym_namespace] = ACTIONS(2190),
    [anon_sym_using] = ACTIONS(2190),
    [anon_sym_static_assert] = ACTIONS(2190),
    [anon_sym_concept] = ACTIONS(2190),
    [anon_sym_co_return] = ACTIONS(2190),
    [anon_sym_co_yield] = ACTIONS(2190),
    [anon_sym_R_DQUOTE] = ACTIONS(2192),
    [anon_sym_LR_DQUOTE] = ACTIONS(2192),
    [anon_sym_uR_DQUOTE] = ACTIONS(2192),
    [anon_sym_UR_DQUOTE] = ACTIONS(2192),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2192),
    [anon_sym_co_await] = ACTIONS(2190),
    [anon_sym_new] = ACTIONS(2190),
    [anon_sym_requires] = ACTIONS(2190),
    [sym_this] = ACTIONS(2190),
    [anon_sym_discard] = ACTIONS(2190),
    [anon_sym_precise] = ACTIONS(2190),
    [anon_sym_shared] = ACTIONS(2190),
    [anon_sym_groupshared] = ACTIONS(2190),
    [anon_sym_uniform] = ACTIONS(2190),
    [anon_sym_row_major] = ACTIONS(2190),
    [anon_sym_column_major] = ACTIONS(2190),
    [anon_sym_globallycoherent] = ACTIONS(2190),
    [anon_sym_centroid] = ACTIONS(2190),
    [anon_sym_noperspective] = ACTIONS(2190),
    [anon_sym_nointerpolation] = ACTIONS(2190),
    [anon_sym_sample] = ACTIONS(2190),
    [anon_sym_linear] = ACTIONS(2190),
    [anon_sym_snorm] = ACTIONS(2190),
    [anon_sym_unorm] = ACTIONS(2190),
    [anon_sym_point] = ACTIONS(2190),
    [anon_sym_line] = ACTIONS(2190),
    [anon_sym_triangleadj] = ACTIONS(2190),
    [anon_sym_lineadj] = ACTIONS(2190),
    [anon_sym_triangle] = ACTIONS(2190),
    [anon_sym_cbuffer] = ACTIONS(2190),
    [anon_sym_interface] = ACTIONS(2190),
    [anon_sym_extension] = ACTIONS(2190),
  },
  [262] = {
    [sym_identifier] = ACTIONS(2373),
    [aux_sym_preproc_include_token1] = ACTIONS(2373),
    [aux_sym_preproc_def_token1] = ACTIONS(2373),
    [aux_sym_preproc_if_token1] = ACTIONS(2373),
    [aux_sym_preproc_if_token2] = ACTIONS(2373),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2373),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2373),
    [aux_sym_preproc_else_token1] = ACTIONS(2373),
    [aux_sym_preproc_elif_token1] = ACTIONS(2373),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2373),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2373),
    [sym_preproc_directive] = ACTIONS(2373),
    [anon_sym_LPAREN2] = ACTIONS(2371),
    [anon_sym_BANG] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym___extension__] = ACTIONS(2373),
    [anon_sym_typedef] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_out] = ACTIONS(2373),
    [anon_sym_inout] = ACTIONS(2373),
    [anon_sym_extern] = ACTIONS(2373),
    [anon_sym___attribute__] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2371),
    [anon_sym___declspec] = ACTIONS(2373),
    [anon_sym___based] = ACTIONS(2373),
    [anon_sym___cdecl] = ACTIONS(2373),
    [anon_sym___clrcall] = ACTIONS(2373),
    [anon_sym___stdcall] = ACTIONS(2373),
    [anon_sym___fastcall] = ACTIONS(2373),
    [anon_sym___thiscall] = ACTIONS(2373),
    [anon_sym___vectorcall] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_signed] = ACTIONS(2373),
    [anon_sym_unsigned] = ACTIONS(2373),
    [anon_sym_long] = ACTIONS(2373),
    [anon_sym_short] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2373),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_register] = ACTIONS(2373),
    [anon_sym_inline] = ACTIONS(2373),
    [anon_sym___inline] = ACTIONS(2373),
    [anon_sym___inline__] = ACTIONS(2373),
    [anon_sym___forceinline] = ACTIONS(2373),
    [anon_sym_thread_local] = ACTIONS(2373),
    [anon_sym___thread] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym___restrict__] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym__Noreturn] = ACTIONS(2373),
    [anon_sym_noreturn] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_constinit] = ACTIONS(2373),
    [anon_sym_consteval] = ACTIONS(2373),
    [anon_sym_alignas] = ACTIONS(2373),
    [anon_sym__Alignas] = ACTIONS(2373),
    [sym_primitive_type] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_class] = ACTIONS(2373),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_else] = ACTIONS(2373),
    [anon_sym_switch] = ACTIONS(2373),
    [anon_sym_case] = ACTIONS(2373),
    [anon_sym_default] = ACTIONS(2373),
    [anon_sym_while] = ACTIONS(2373),
    [anon_sym_do] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2373),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2373),
    [anon_sym_goto] = ACTIONS(2373),
    [anon_sym___try] = ACTIONS(2373),
    [anon_sym___leave] = ACTIONS(2373),
    [anon_sym_not] = ACTIONS(2373),
    [anon_sym_compl] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_sizeof] = ACTIONS(2373),
    [anon_sym___alignof__] = ACTIONS(2373),
    [anon_sym___alignof] = ACTIONS(2373),
    [anon_sym__alignof] = ACTIONS(2373),
    [anon_sym_alignof] = ACTIONS(2373),
    [anon_sym__Alignof] = ACTIONS(2373),
    [anon_sym_offsetof] = ACTIONS(2373),
    [anon_sym__Generic] = ACTIONS(2373),
    [anon_sym_asm] = ACTIONS(2373),
    [anon_sym___asm__] = ACTIONS(2373),
    [sym_number_literal] = ACTIONS(2371),
    [anon_sym_L_SQUOTE] = ACTIONS(2371),
    [anon_sym_u_SQUOTE] = ACTIONS(2371),
    [anon_sym_U_SQUOTE] = ACTIONS(2371),
    [anon_sym_u8_SQUOTE] = ACTIONS(2371),
    [anon_sym_SQUOTE] = ACTIONS(2371),
    [anon_sym_L_DQUOTE] = ACTIONS(2371),
    [anon_sym_u_DQUOTE] = ACTIONS(2371),
    [anon_sym_U_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8_DQUOTE] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [anon_sym_NULL] = ACTIONS(2373),
    [anon_sym_nullptr] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_This] = ACTIONS(2373),
    [anon_sym_decltype] = ACTIONS(2373),
    [anon_sym_final] = ACTIONS(2373),
    [anon_sym_override] = ACTIONS(2373),
    [sym_virtual] = ACTIONS(2373),
    [anon_sym_explicit] = ACTIONS(2373),
    [anon_sym_typename] = ACTIONS(2373),
    [anon_sym_template] = ACTIONS(2373),
    [anon_sym_operator] = ACTIONS(2373),
    [anon_sym_try] = ACTIONS(2373),
    [anon_sym_delete] = ACTIONS(2373),
    [anon_sym_throw] = ACTIONS(2373),
    [anon_sym_namespace] = ACTIONS(2373),
    [anon_sym_using] = ACTIONS(2373),
    [anon_sym_static_assert] = ACTIONS(2373),
    [anon_sym_concept] = ACTIONS(2373),
    [anon_sym_co_return] = ACTIONS(2373),
    [anon_sym_co_yield] = ACTIONS(2373),
    [anon_sym_R_DQUOTE] = ACTIONS(2371),
    [anon_sym_LR_DQUOTE] = ACTIONS(2371),
    [anon_sym_uR_DQUOTE] = ACTIONS(2371),
    [anon_sym_UR_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2371),
    [anon_sym_co_await] = ACTIONS(2373),
    [anon_sym_new] = ACTIONS(2373),
    [anon_sym_requires] = ACTIONS(2373),
    [sym_this] = ACTIONS(2373),
    [anon_sym_discard] = ACTIONS(2373),
    [anon_sym_precise] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_groupshared] = ACTIONS(2373),
    [anon_sym_uniform] = ACTIONS(2373),
    [anon_sym_row_major] = ACTIONS(2373),
    [anon_sym_column_major] = ACTIONS(2373),
    [anon_sym_globallycoherent] = ACTIONS(2373),
    [anon_sym_centroid] = ACTIONS(2373),
    [anon_sym_noperspective] = ACTIONS(2373),
    [anon_sym_nointerpolation] = ACTIONS(2373),
    [anon_sym_sample] = ACTIONS(2373),
    [anon_sym_linear] = ACTIONS(2373),
    [anon_sym_snorm] = ACTIONS(2373),
    [anon_sym_unorm] = ACTIONS(2373),
    [anon_sym_point] = ACTIONS(2373),
    [anon_sym_line] = ACTIONS(2373),
    [anon_sym_triangleadj] = ACTIONS(2373),
    [anon_sym_lineadj] = ACTIONS(2373),
    [anon_sym_triangle] = ACTIONS(2373),
    [anon_sym_cbuffer] = ACTIONS(2373),
    [anon_sym_interface] = ACTIONS(2373),
    [anon_sym_extension] = ACTIONS(2373),
  },
  [263] = {
    [sym_identifier] = ACTIONS(2240),
    [aux_sym_preproc_include_token1] = ACTIONS(2240),
    [aux_sym_preproc_def_token1] = ACTIONS(2240),
    [aux_sym_preproc_if_token1] = ACTIONS(2240),
    [aux_sym_preproc_if_token2] = ACTIONS(2240),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2240),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2240),
    [aux_sym_preproc_else_token1] = ACTIONS(2240),
    [aux_sym_preproc_elif_token1] = ACTIONS(2240),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2240),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2240),
    [sym_preproc_directive] = ACTIONS(2240),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2242),
    [anon_sym_TILDE] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2240),
    [anon_sym_PLUS] = ACTIONS(2240),
    [anon_sym_STAR] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_AMP] = ACTIONS(2240),
    [anon_sym_COLON] = ACTIONS(2240),
    [anon_sym_SEMI] = ACTIONS(2242),
    [anon_sym___extension__] = ACTIONS(2240),
    [anon_sym_typedef] = ACTIONS(2240),
    [anon_sym_in] = ACTIONS(2240),
    [anon_sym_out] = ACTIONS(2240),
    [anon_sym_inout] = ACTIONS(2240),
    [anon_sym_extern] = ACTIONS(2240),
    [anon_sym___attribute__] = ACTIONS(2240),
    [anon_sym_COLON_COLON] = ACTIONS(2242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2242),
    [anon_sym___declspec] = ACTIONS(2240),
    [anon_sym___based] = ACTIONS(2240),
    [anon_sym___cdecl] = ACTIONS(2240),
    [anon_sym___clrcall] = ACTIONS(2240),
    [anon_sym___stdcall] = ACTIONS(2240),
    [anon_sym___fastcall] = ACTIONS(2240),
    [anon_sym___thiscall] = ACTIONS(2240),
    [anon_sym___vectorcall] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_signed] = ACTIONS(2240),
    [anon_sym_unsigned] = ACTIONS(2240),
    [anon_sym_long] = ACTIONS(2240),
    [anon_sym_short] = ACTIONS(2240),
    [anon_sym_LBRACK] = ACTIONS(2240),
    [anon_sym_static] = ACTIONS(2240),
    [anon_sym_register] = ACTIONS(2240),
    [anon_sym_inline] = ACTIONS(2240),
    [anon_sym___inline] = ACTIONS(2240),
    [anon_sym___inline__] = ACTIONS(2240),
    [anon_sym___forceinline] = ACTIONS(2240),
    [anon_sym_thread_local] = ACTIONS(2240),
    [anon_sym___thread] = ACTIONS(2240),
    [anon_sym_const] = ACTIONS(2240),
    [anon_sym_constexpr] = ACTIONS(2240),
    [anon_sym_volatile] = ACTIONS(2240),
    [anon_sym_restrict] = ACTIONS(2240),
    [anon_sym___restrict__] = ACTIONS(2240),
    [anon_sym__Atomic] = ACTIONS(2240),
    [anon_sym__Noreturn] = ACTIONS(2240),
    [anon_sym_noreturn] = ACTIONS(2240),
    [anon_sym_mutable] = ACTIONS(2240),
    [anon_sym_constinit] = ACTIONS(2240),
    [anon_sym_consteval] = ACTIONS(2240),
    [anon_sym_alignas] = ACTIONS(2240),
    [anon_sym__Alignas] = ACTIONS(2240),
    [sym_primitive_type] = ACTIONS(2240),
    [anon_sym_enum] = ACTIONS(2240),
    [anon_sym_class] = ACTIONS(2240),
    [anon_sym_struct] = ACTIONS(2240),
    [anon_sym_union] = ACTIONS(2240),
    [anon_sym_if] = ACTIONS(2240),
    [anon_sym_else] = ACTIONS(2240),
    [anon_sym_switch] = ACTIONS(2240),
    [anon_sym_case] = ACTIONS(2240),
    [anon_sym_default] = ACTIONS(2240),
    [anon_sym_while] = ACTIONS(2240),
    [anon_sym_do] = ACTIONS(2240),
    [anon_sym_for] = ACTIONS(2240),
    [anon_sym_return] = ACTIONS(2240),
    [anon_sym_break] = ACTIONS(2240),
    [anon_sym_continue] = ACTIONS(2240),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym___try] = ACTIONS(2240),
    [anon_sym___leave] = ACTIONS(2240),
    [anon_sym_not] = ACTIONS(2240),
    [anon_sym_compl] = ACTIONS(2240),
    [anon_sym_DASH_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_PLUS] = ACTIONS(2242),
    [anon_sym_sizeof] = ACTIONS(2240),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2240),
    [anon_sym__Generic] = ACTIONS(2240),
    [anon_sym_asm] = ACTIONS(2240),
    [anon_sym___asm__] = ACTIONS(2240),
    [sym_number_literal] = ACTIONS(2242),
    [anon_sym_L_SQUOTE] = ACTIONS(2242),
    [anon_sym_u_SQUOTE] = ACTIONS(2242),
    [anon_sym_U_SQUOTE] = ACTIONS(2242),
    [anon_sym_u8_SQUOTE] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(2242),
    [anon_sym_L_DQUOTE] = ACTIONS(2242),
    [anon_sym_u_DQUOTE] = ACTIONS(2242),
    [anon_sym_U_DQUOTE] = ACTIONS(2242),
    [anon_sym_u8_DQUOTE] = ACTIONS(2242),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [sym_true] = ACTIONS(2240),
    [sym_false] = ACTIONS(2240),
    [anon_sym_NULL] = ACTIONS(2240),
    [anon_sym_nullptr] = ACTIONS(2240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2240),
    [anon_sym_let] = ACTIONS(2240),
    [anon_sym_This] = ACTIONS(2240),
    [anon_sym_decltype] = ACTIONS(2240),
    [anon_sym_final] = ACTIONS(2240),
    [anon_sym_override] = ACTIONS(2240),
    [sym_virtual] = ACTIONS(2240),
    [anon_sym_explicit] = ACTIONS(2240),
    [anon_sym_typename] = ACTIONS(2240),
    [anon_sym_template] = ACTIONS(2240),
    [anon_sym_operator] = ACTIONS(2240),
    [anon_sym_try] = ACTIONS(2240),
    [anon_sym_delete] = ACTIONS(2240),
    [anon_sym_throw] = ACTIONS(2240),
    [anon_sym_namespace] = ACTIONS(2240),
    [anon_sym_using] = ACTIONS(2240),
    [anon_sym_static_assert] = ACTIONS(2240),
    [anon_sym_concept] = ACTIONS(2240),
    [anon_sym_co_return] = ACTIONS(2240),
    [anon_sym_co_yield] = ACTIONS(2240),
    [anon_sym_R_DQUOTE] = ACTIONS(2242),
    [anon_sym_LR_DQUOTE] = ACTIONS(2242),
    [anon_sym_uR_DQUOTE] = ACTIONS(2242),
    [anon_sym_UR_DQUOTE] = ACTIONS(2242),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2242),
    [anon_sym_co_await] = ACTIONS(2240),
    [anon_sym_new] = ACTIONS(2240),
    [anon_sym_requires] = ACTIONS(2240),
    [sym_this] = ACTIONS(2240),
    [anon_sym_discard] = ACTIONS(2240),
    [anon_sym_precise] = ACTIONS(2240),
    [anon_sym_shared] = ACTIONS(2240),
    [anon_sym_groupshared] = ACTIONS(2240),
    [anon_sym_uniform] = ACTIONS(2240),
    [anon_sym_row_major] = ACTIONS(2240),
    [anon_sym_column_major] = ACTIONS(2240),
    [anon_sym_globallycoherent] = ACTIONS(2240),
    [anon_sym_centroid] = ACTIONS(2240),
    [anon_sym_noperspective] = ACTIONS(2240),
    [anon_sym_nointerpolation] = ACTIONS(2240),
    [anon_sym_sample] = ACTIONS(2240),
    [anon_sym_linear] = ACTIONS(2240),
    [anon_sym_snorm] = ACTIONS(2240),
    [anon_sym_unorm] = ACTIONS(2240),
    [anon_sym_point] = ACTIONS(2240),
    [anon_sym_line] = ACTIONS(2240),
    [anon_sym_triangleadj] = ACTIONS(2240),
    [anon_sym_lineadj] = ACTIONS(2240),
    [anon_sym_triangle] = ACTIONS(2240),
    [anon_sym_cbuffer] = ACTIONS(2240),
    [anon_sym_interface] = ACTIONS(2240),
    [anon_sym_extension] = ACTIONS(2240),
  },
  [264] = {
    [sym_catch_clause] = STATE(264),
    [aux_sym_constructor_try_statement_repeat1] = STATE(264),
    [sym_identifier] = ACTIONS(2731),
    [aux_sym_preproc_include_token1] = ACTIONS(2731),
    [aux_sym_preproc_def_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token2] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2731),
    [aux_sym_preproc_else_token1] = ACTIONS(2731),
    [aux_sym_preproc_elif_token1] = ACTIONS(2731),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(2733),
    [anon_sym_BANG] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2731),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_AMP_AMP] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2731),
    [anon_sym_SEMI] = ACTIONS(2733),
    [anon_sym___extension__] = ACTIONS(2731),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_in] = ACTIONS(2731),
    [anon_sym_out] = ACTIONS(2731),
    [anon_sym_inout] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym___based] = ACTIONS(2731),
    [anon_sym___cdecl] = ACTIONS(2731),
    [anon_sym___clrcall] = ACTIONS(2731),
    [anon_sym___stdcall] = ACTIONS(2731),
    [anon_sym___fastcall] = ACTIONS(2731),
    [anon_sym___thiscall] = ACTIONS(2731),
    [anon_sym___vectorcall] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2733),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym__Alignas] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [anon_sym_if] = ACTIONS(2731),
    [anon_sym_else] = ACTIONS(2731),
    [anon_sym_switch] = ACTIONS(2731),
    [anon_sym_case] = ACTIONS(2731),
    [anon_sym_default] = ACTIONS(2731),
    [anon_sym_while] = ACTIONS(2731),
    [anon_sym_do] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2731),
    [anon_sym_return] = ACTIONS(2731),
    [anon_sym_break] = ACTIONS(2731),
    [anon_sym_continue] = ACTIONS(2731),
    [anon_sym_goto] = ACTIONS(2731),
    [anon_sym___try] = ACTIONS(2731),
    [anon_sym___leave] = ACTIONS(2731),
    [anon_sym_not] = ACTIONS(2731),
    [anon_sym_compl] = ACTIONS(2731),
    [anon_sym_DASH_DASH] = ACTIONS(2733),
    [anon_sym_PLUS_PLUS] = ACTIONS(2733),
    [anon_sym_sizeof] = ACTIONS(2731),
    [anon_sym___alignof__] = ACTIONS(2731),
    [anon_sym___alignof] = ACTIONS(2731),
    [anon_sym__alignof] = ACTIONS(2731),
    [anon_sym_alignof] = ACTIONS(2731),
    [anon_sym__Alignof] = ACTIONS(2731),
    [anon_sym_offsetof] = ACTIONS(2731),
    [anon_sym__Generic] = ACTIONS(2731),
    [anon_sym_asm] = ACTIONS(2731),
    [anon_sym___asm__] = ACTIONS(2731),
    [sym_number_literal] = ACTIONS(2733),
    [anon_sym_L_SQUOTE] = ACTIONS(2733),
    [anon_sym_u_SQUOTE] = ACTIONS(2733),
    [anon_sym_U_SQUOTE] = ACTIONS(2733),
    [anon_sym_u8_SQUOTE] = ACTIONS(2733),
    [anon_sym_SQUOTE] = ACTIONS(2733),
    [anon_sym_L_DQUOTE] = ACTIONS(2733),
    [anon_sym_u_DQUOTE] = ACTIONS(2733),
    [anon_sym_U_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8_DQUOTE] = ACTIONS(2733),
    [anon_sym_DQUOTE] = ACTIONS(2733),
    [sym_true] = ACTIONS(2731),
    [sym_false] = ACTIONS(2731),
    [anon_sym_NULL] = ACTIONS(2731),
    [anon_sym_nullptr] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2731),
    [anon_sym_let] = ACTIONS(2731),
    [anon_sym_This] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(2731),
    [sym_virtual] = ACTIONS(2731),
    [anon_sym_explicit] = ACTIONS(2731),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(2731),
    [anon_sym_operator] = ACTIONS(2731),
    [anon_sym_try] = ACTIONS(2731),
    [anon_sym_delete] = ACTIONS(2731),
    [anon_sym_throw] = ACTIONS(2731),
    [anon_sym_namespace] = ACTIONS(2731),
    [anon_sym_using] = ACTIONS(2731),
    [anon_sym_static_assert] = ACTIONS(2731),
    [anon_sym_concept] = ACTIONS(2731),
    [anon_sym_co_return] = ACTIONS(2731),
    [anon_sym_co_yield] = ACTIONS(2731),
    [anon_sym_catch] = ACTIONS(2735),
    [anon_sym_R_DQUOTE] = ACTIONS(2733),
    [anon_sym_LR_DQUOTE] = ACTIONS(2733),
    [anon_sym_uR_DQUOTE] = ACTIONS(2733),
    [anon_sym_UR_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2733),
    [anon_sym_co_await] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2731),
    [anon_sym_requires] = ACTIONS(2731),
    [sym_this] = ACTIONS(2731),
    [anon_sym_discard] = ACTIONS(2731),
    [anon_sym_precise] = ACTIONS(2731),
    [anon_sym_shared] = ACTIONS(2731),
    [anon_sym_groupshared] = ACTIONS(2731),
    [anon_sym_uniform] = ACTIONS(2731),
    [anon_sym_row_major] = ACTIONS(2731),
    [anon_sym_column_major] = ACTIONS(2731),
    [anon_sym_globallycoherent] = ACTIONS(2731),
    [anon_sym_centroid] = ACTIONS(2731),
    [anon_sym_noperspective] = ACTIONS(2731),
    [anon_sym_nointerpolation] = ACTIONS(2731),
    [anon_sym_sample] = ACTIONS(2731),
    [anon_sym_linear] = ACTIONS(2731),
    [anon_sym_snorm] = ACTIONS(2731),
    [anon_sym_unorm] = ACTIONS(2731),
    [anon_sym_point] = ACTIONS(2731),
    [anon_sym_line] = ACTIONS(2731),
    [anon_sym_triangleadj] = ACTIONS(2731),
    [anon_sym_lineadj] = ACTIONS(2731),
    [anon_sym_triangle] = ACTIONS(2731),
    [anon_sym_cbuffer] = ACTIONS(2731),
    [anon_sym_interface] = ACTIONS(2731),
    [anon_sym_extension] = ACTIONS(2731),
  },
  [265] = {
    [sym_identifier] = ACTIONS(2202),
    [aux_sym_preproc_include_token1] = ACTIONS(2202),
    [aux_sym_preproc_def_token1] = ACTIONS(2202),
    [aux_sym_preproc_if_token1] = ACTIONS(2202),
    [aux_sym_preproc_if_token2] = ACTIONS(2202),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2202),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2202),
    [aux_sym_preproc_else_token1] = ACTIONS(2202),
    [aux_sym_preproc_elif_token1] = ACTIONS(2202),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2202),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2202),
    [sym_preproc_directive] = ACTIONS(2202),
    [anon_sym_LPAREN2] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2204),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2202),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_STAR] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_AMP] = ACTIONS(2202),
    [anon_sym_COLON] = ACTIONS(2202),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym___extension__] = ACTIONS(2202),
    [anon_sym_typedef] = ACTIONS(2202),
    [anon_sym_in] = ACTIONS(2202),
    [anon_sym_out] = ACTIONS(2202),
    [anon_sym_inout] = ACTIONS(2202),
    [anon_sym_extern] = ACTIONS(2202),
    [anon_sym___attribute__] = ACTIONS(2202),
    [anon_sym_COLON_COLON] = ACTIONS(2204),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2204),
    [anon_sym___declspec] = ACTIONS(2202),
    [anon_sym___based] = ACTIONS(2202),
    [anon_sym___cdecl] = ACTIONS(2202),
    [anon_sym___clrcall] = ACTIONS(2202),
    [anon_sym___stdcall] = ACTIONS(2202),
    [anon_sym___fastcall] = ACTIONS(2202),
    [anon_sym___thiscall] = ACTIONS(2202),
    [anon_sym___vectorcall] = ACTIONS(2202),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_signed] = ACTIONS(2202),
    [anon_sym_unsigned] = ACTIONS(2202),
    [anon_sym_long] = ACTIONS(2202),
    [anon_sym_short] = ACTIONS(2202),
    [anon_sym_LBRACK] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2202),
    [anon_sym_register] = ACTIONS(2202),
    [anon_sym_inline] = ACTIONS(2202),
    [anon_sym___inline] = ACTIONS(2202),
    [anon_sym___inline__] = ACTIONS(2202),
    [anon_sym___forceinline] = ACTIONS(2202),
    [anon_sym_thread_local] = ACTIONS(2202),
    [anon_sym___thread] = ACTIONS(2202),
    [anon_sym_const] = ACTIONS(2202),
    [anon_sym_constexpr] = ACTIONS(2202),
    [anon_sym_volatile] = ACTIONS(2202),
    [anon_sym_restrict] = ACTIONS(2202),
    [anon_sym___restrict__] = ACTIONS(2202),
    [anon_sym__Atomic] = ACTIONS(2202),
    [anon_sym__Noreturn] = ACTIONS(2202),
    [anon_sym_noreturn] = ACTIONS(2202),
    [anon_sym_mutable] = ACTIONS(2202),
    [anon_sym_constinit] = ACTIONS(2202),
    [anon_sym_consteval] = ACTIONS(2202),
    [anon_sym_alignas] = ACTIONS(2202),
    [anon_sym__Alignas] = ACTIONS(2202),
    [sym_primitive_type] = ACTIONS(2202),
    [anon_sym_enum] = ACTIONS(2202),
    [anon_sym_class] = ACTIONS(2202),
    [anon_sym_struct] = ACTIONS(2202),
    [anon_sym_union] = ACTIONS(2202),
    [anon_sym_if] = ACTIONS(2202),
    [anon_sym_else] = ACTIONS(2202),
    [anon_sym_switch] = ACTIONS(2202),
    [anon_sym_case] = ACTIONS(2202),
    [anon_sym_default] = ACTIONS(2202),
    [anon_sym_while] = ACTIONS(2202),
    [anon_sym_do] = ACTIONS(2202),
    [anon_sym_for] = ACTIONS(2202),
    [anon_sym_return] = ACTIONS(2202),
    [anon_sym_break] = ACTIONS(2202),
    [anon_sym_continue] = ACTIONS(2202),
    [anon_sym_goto] = ACTIONS(2202),
    [anon_sym___try] = ACTIONS(2202),
    [anon_sym___leave] = ACTIONS(2202),
    [anon_sym_not] = ACTIONS(2202),
    [anon_sym_compl] = ACTIONS(2202),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_sizeof] = ACTIONS(2202),
    [anon_sym___alignof__] = ACTIONS(2202),
    [anon_sym___alignof] = ACTIONS(2202),
    [anon_sym__alignof] = ACTIONS(2202),
    [anon_sym_alignof] = ACTIONS(2202),
    [anon_sym__Alignof] = ACTIONS(2202),
    [anon_sym_offsetof] = ACTIONS(2202),
    [anon_sym__Generic] = ACTIONS(2202),
    [anon_sym_asm] = ACTIONS(2202),
    [anon_sym___asm__] = ACTIONS(2202),
    [sym_number_literal] = ACTIONS(2204),
    [anon_sym_L_SQUOTE] = ACTIONS(2204),
    [anon_sym_u_SQUOTE] = ACTIONS(2204),
    [anon_sym_U_SQUOTE] = ACTIONS(2204),
    [anon_sym_u8_SQUOTE] = ACTIONS(2204),
    [anon_sym_SQUOTE] = ACTIONS(2204),
    [anon_sym_L_DQUOTE] = ACTIONS(2204),
    [anon_sym_u_DQUOTE] = ACTIONS(2204),
    [anon_sym_U_DQUOTE] = ACTIONS(2204),
    [anon_sym_u8_DQUOTE] = ACTIONS(2204),
    [anon_sym_DQUOTE] = ACTIONS(2204),
    [sym_true] = ACTIONS(2202),
    [sym_false] = ACTIONS(2202),
    [anon_sym_NULL] = ACTIONS(2202),
    [anon_sym_nullptr] = ACTIONS(2202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2202),
    [anon_sym_let] = ACTIONS(2202),
    [anon_sym_This] = ACTIONS(2202),
    [anon_sym_decltype] = ACTIONS(2202),
    [anon_sym_final] = ACTIONS(2202),
    [anon_sym_override] = ACTIONS(2202),
    [sym_virtual] = ACTIONS(2202),
    [anon_sym_explicit] = ACTIONS(2202),
    [anon_sym_typename] = ACTIONS(2202),
    [anon_sym_template] = ACTIONS(2202),
    [anon_sym_operator] = ACTIONS(2202),
    [anon_sym_try] = ACTIONS(2202),
    [anon_sym_delete] = ACTIONS(2202),
    [anon_sym_throw] = ACTIONS(2202),
    [anon_sym_namespace] = ACTIONS(2202),
    [anon_sym_using] = ACTIONS(2202),
    [anon_sym_static_assert] = ACTIONS(2202),
    [anon_sym_concept] = ACTIONS(2202),
    [anon_sym_co_return] = ACTIONS(2202),
    [anon_sym_co_yield] = ACTIONS(2202),
    [anon_sym_R_DQUOTE] = ACTIONS(2204),
    [anon_sym_LR_DQUOTE] = ACTIONS(2204),
    [anon_sym_uR_DQUOTE] = ACTIONS(2204),
    [anon_sym_UR_DQUOTE] = ACTIONS(2204),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2204),
    [anon_sym_co_await] = ACTIONS(2202),
    [anon_sym_new] = ACTIONS(2202),
    [anon_sym_requires] = ACTIONS(2202),
    [sym_this] = ACTIONS(2202),
    [anon_sym_discard] = ACTIONS(2202),
    [anon_sym_precise] = ACTIONS(2202),
    [anon_sym_shared] = ACTIONS(2202),
    [anon_sym_groupshared] = ACTIONS(2202),
    [anon_sym_uniform] = ACTIONS(2202),
    [anon_sym_row_major] = ACTIONS(2202),
    [anon_sym_column_major] = ACTIONS(2202),
    [anon_sym_globallycoherent] = ACTIONS(2202),
    [anon_sym_centroid] = ACTIONS(2202),
    [anon_sym_noperspective] = ACTIONS(2202),
    [anon_sym_nointerpolation] = ACTIONS(2202),
    [anon_sym_sample] = ACTIONS(2202),
    [anon_sym_linear] = ACTIONS(2202),
    [anon_sym_snorm] = ACTIONS(2202),
    [anon_sym_unorm] = ACTIONS(2202),
    [anon_sym_point] = ACTIONS(2202),
    [anon_sym_line] = ACTIONS(2202),
    [anon_sym_triangleadj] = ACTIONS(2202),
    [anon_sym_lineadj] = ACTIONS(2202),
    [anon_sym_triangle] = ACTIONS(2202),
    [anon_sym_cbuffer] = ACTIONS(2202),
    [anon_sym_interface] = ACTIONS(2202),
    [anon_sym_extension] = ACTIONS(2202),
  },
  [266] = {
    [sym_template_argument_list] = STATE(337),
    [sym_identifier] = ACTIONS(2169),
    [aux_sym_preproc_include_token1] = ACTIONS(2169),
    [aux_sym_preproc_def_token1] = ACTIONS(2169),
    [aux_sym_preproc_if_token1] = ACTIONS(2169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2169),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2169),
    [sym_preproc_directive] = ACTIONS(2169),
    [anon_sym_LPAREN2] = ACTIONS(2176),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2169),
    [anon_sym_PLUS] = ACTIONS(2169),
    [anon_sym_STAR] = ACTIONS(2176),
    [anon_sym_AMP_AMP] = ACTIONS(2176),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(2738),
    [anon_sym_COLON] = ACTIONS(2169),
    [anon_sym_SEMI] = ACTIONS(2176),
    [anon_sym___extension__] = ACTIONS(2169),
    [anon_sym_typedef] = ACTIONS(2169),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_out] = ACTIONS(2169),
    [anon_sym_inout] = ACTIONS(2169),
    [anon_sym_extern] = ACTIONS(2169),
    [anon_sym___attribute__] = ACTIONS(2169),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2176),
    [anon_sym___declspec] = ACTIONS(2169),
    [anon_sym___based] = ACTIONS(2169),
    [anon_sym___cdecl] = ACTIONS(2169),
    [anon_sym___clrcall] = ACTIONS(2169),
    [anon_sym___stdcall] = ACTIONS(2169),
    [anon_sym___fastcall] = ACTIONS(2169),
    [anon_sym___thiscall] = ACTIONS(2169),
    [anon_sym___vectorcall] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2176),
    [anon_sym_RBRACE] = ACTIONS(2176),
    [anon_sym_signed] = ACTIONS(2169),
    [anon_sym_unsigned] = ACTIONS(2169),
    [anon_sym_long] = ACTIONS(2169),
    [anon_sym_short] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(2169),
    [anon_sym_static] = ACTIONS(2169),
    [anon_sym_register] = ACTIONS(2169),
    [anon_sym_inline] = ACTIONS(2169),
    [anon_sym___inline] = ACTIONS(2169),
    [anon_sym___inline__] = ACTIONS(2169),
    [anon_sym___forceinline] = ACTIONS(2169),
    [anon_sym_thread_local] = ACTIONS(2169),
    [anon_sym___thread] = ACTIONS(2169),
    [anon_sym_const] = ACTIONS(2169),
    [anon_sym_constexpr] = ACTIONS(2169),
    [anon_sym_volatile] = ACTIONS(2169),
    [anon_sym_restrict] = ACTIONS(2169),
    [anon_sym___restrict__] = ACTIONS(2169),
    [anon_sym__Atomic] = ACTIONS(2169),
    [anon_sym__Noreturn] = ACTIONS(2169),
    [anon_sym_noreturn] = ACTIONS(2169),
    [anon_sym_mutable] = ACTIONS(2169),
    [anon_sym_constinit] = ACTIONS(2169),
    [anon_sym_consteval] = ACTIONS(2169),
    [anon_sym_alignas] = ACTIONS(2169),
    [anon_sym__Alignas] = ACTIONS(2169),
    [sym_primitive_type] = ACTIONS(2169),
    [anon_sym_enum] = ACTIONS(2169),
    [anon_sym_class] = ACTIONS(2169),
    [anon_sym_struct] = ACTIONS(2169),
    [anon_sym_union] = ACTIONS(2169),
    [anon_sym_if] = ACTIONS(2169),
    [anon_sym_else] = ACTIONS(2169),
    [anon_sym_switch] = ACTIONS(2169),
    [anon_sym_case] = ACTIONS(2169),
    [anon_sym_default] = ACTIONS(2169),
    [anon_sym_while] = ACTIONS(2169),
    [anon_sym_do] = ACTIONS(2169),
    [anon_sym_for] = ACTIONS(2169),
    [anon_sym_return] = ACTIONS(2169),
    [anon_sym_break] = ACTIONS(2169),
    [anon_sym_continue] = ACTIONS(2169),
    [anon_sym_goto] = ACTIONS(2169),
    [anon_sym___try] = ACTIONS(2169),
    [anon_sym___leave] = ACTIONS(2169),
    [anon_sym_not] = ACTIONS(2169),
    [anon_sym_compl] = ACTIONS(2169),
    [anon_sym_DASH_DASH] = ACTIONS(2176),
    [anon_sym_PLUS_PLUS] = ACTIONS(2176),
    [anon_sym_sizeof] = ACTIONS(2169),
    [anon_sym___alignof__] = ACTIONS(2169),
    [anon_sym___alignof] = ACTIONS(2169),
    [anon_sym__alignof] = ACTIONS(2169),
    [anon_sym_alignof] = ACTIONS(2169),
    [anon_sym__Alignof] = ACTIONS(2169),
    [anon_sym_offsetof] = ACTIONS(2169),
    [anon_sym__Generic] = ACTIONS(2169),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [anon_sym_DOT] = ACTIONS(2169),
    [sym_number_literal] = ACTIONS(2176),
    [anon_sym_L_SQUOTE] = ACTIONS(2176),
    [anon_sym_u_SQUOTE] = ACTIONS(2176),
    [anon_sym_U_SQUOTE] = ACTIONS(2176),
    [anon_sym_u8_SQUOTE] = ACTIONS(2176),
    [anon_sym_SQUOTE] = ACTIONS(2176),
    [anon_sym_L_DQUOTE] = ACTIONS(2176),
    [anon_sym_u_DQUOTE] = ACTIONS(2176),
    [anon_sym_U_DQUOTE] = ACTIONS(2176),
    [anon_sym_u8_DQUOTE] = ACTIONS(2176),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [sym_true] = ACTIONS(2169),
    [sym_false] = ACTIONS(2169),
    [anon_sym_NULL] = ACTIONS(2169),
    [anon_sym_nullptr] = ACTIONS(2169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2169),
    [anon_sym_let] = ACTIONS(2169),
    [anon_sym_This] = ACTIONS(2169),
    [anon_sym_decltype] = ACTIONS(2169),
    [anon_sym_final] = ACTIONS(2169),
    [anon_sym_override] = ACTIONS(2169),
    [sym_virtual] = ACTIONS(2169),
    [anon_sym_explicit] = ACTIONS(2169),
    [anon_sym_typename] = ACTIONS(2169),
    [anon_sym_template] = ACTIONS(2169),
    [anon_sym_operator] = ACTIONS(2169),
    [anon_sym_try] = ACTIONS(2169),
    [anon_sym_delete] = ACTIONS(2169),
    [anon_sym_throw] = ACTIONS(2169),
    [anon_sym_namespace] = ACTIONS(2169),
    [anon_sym_using] = ACTIONS(2169),
    [anon_sym_static_assert] = ACTIONS(2169),
    [anon_sym_concept] = ACTIONS(2169),
    [anon_sym_co_return] = ACTIONS(2169),
    [anon_sym_co_yield] = ACTIONS(2169),
    [anon_sym_R_DQUOTE] = ACTIONS(2176),
    [anon_sym_LR_DQUOTE] = ACTIONS(2176),
    [anon_sym_uR_DQUOTE] = ACTIONS(2176),
    [anon_sym_UR_DQUOTE] = ACTIONS(2176),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2176),
    [anon_sym_co_await] = ACTIONS(2169),
    [anon_sym_new] = ACTIONS(2169),
    [anon_sym_requires] = ACTIONS(2169),
    [sym_this] = ACTIONS(2169),
    [anon_sym_discard] = ACTIONS(2169),
    [anon_sym_precise] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_groupshared] = ACTIONS(2169),
    [anon_sym_uniform] = ACTIONS(2169),
    [anon_sym_row_major] = ACTIONS(2169),
    [anon_sym_column_major] = ACTIONS(2169),
    [anon_sym_globallycoherent] = ACTIONS(2169),
    [anon_sym_centroid] = ACTIONS(2169),
    [anon_sym_noperspective] = ACTIONS(2169),
    [anon_sym_nointerpolation] = ACTIONS(2169),
    [anon_sym_sample] = ACTIONS(2169),
    [anon_sym_linear] = ACTIONS(2169),
    [anon_sym_snorm] = ACTIONS(2169),
    [anon_sym_unorm] = ACTIONS(2169),
    [anon_sym_point] = ACTIONS(2169),
    [anon_sym_line] = ACTIONS(2169),
    [anon_sym_triangleadj] = ACTIONS(2169),
    [anon_sym_lineadj] = ACTIONS(2169),
    [anon_sym_triangle] = ACTIONS(2169),
    [anon_sym_cbuffer] = ACTIONS(2169),
    [anon_sym_interface] = ACTIONS(2169),
    [anon_sym_extension] = ACTIONS(2169),
  },
  [267] = {
    [sym_field_declaration_list] = STATE(797),
    [sym_virtual_specifier] = STATE(8926),
    [sym_base_class_clause] = STATE(10029),
    [sym_identifier] = ACTIONS(2483),
    [aux_sym_preproc_include_token1] = ACTIONS(2483),
    [aux_sym_preproc_def_token1] = ACTIONS(2483),
    [aux_sym_preproc_if_token1] = ACTIONS(2483),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2483),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2483),
    [sym_preproc_directive] = ACTIONS(2483),
    [anon_sym_LPAREN2] = ACTIONS(2485),
    [anon_sym_BANG] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2483),
    [anon_sym_PLUS] = ACTIONS(2483),
    [anon_sym_STAR] = ACTIONS(2485),
    [anon_sym_AMP_AMP] = ACTIONS(2485),
    [anon_sym_AMP] = ACTIONS(2483),
    [anon_sym_COLON] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(2485),
    [anon_sym___extension__] = ACTIONS(2483),
    [anon_sym_typedef] = ACTIONS(2483),
    [anon_sym_in] = ACTIONS(2483),
    [anon_sym_out] = ACTIONS(2483),
    [anon_sym_inout] = ACTIONS(2483),
    [anon_sym_extern] = ACTIONS(2483),
    [anon_sym___attribute__] = ACTIONS(2483),
    [anon_sym_COLON_COLON] = ACTIONS(2485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2485),
    [anon_sym___declspec] = ACTIONS(2483),
    [anon_sym___based] = ACTIONS(2483),
    [anon_sym___cdecl] = ACTIONS(2483),
    [anon_sym___clrcall] = ACTIONS(2483),
    [anon_sym___stdcall] = ACTIONS(2483),
    [anon_sym___fastcall] = ACTIONS(2483),
    [anon_sym___thiscall] = ACTIONS(2483),
    [anon_sym___vectorcall] = ACTIONS(2483),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_RBRACE] = ACTIONS(2485),
    [anon_sym_signed] = ACTIONS(2483),
    [anon_sym_unsigned] = ACTIONS(2483),
    [anon_sym_long] = ACTIONS(2483),
    [anon_sym_short] = ACTIONS(2483),
    [anon_sym_LBRACK] = ACTIONS(2483),
    [anon_sym_static] = ACTIONS(2483),
    [anon_sym_register] = ACTIONS(2483),
    [anon_sym_inline] = ACTIONS(2483),
    [anon_sym___inline] = ACTIONS(2483),
    [anon_sym___inline__] = ACTIONS(2483),
    [anon_sym___forceinline] = ACTIONS(2483),
    [anon_sym_thread_local] = ACTIONS(2483),
    [anon_sym___thread] = ACTIONS(2483),
    [anon_sym_const] = ACTIONS(2483),
    [anon_sym_constexpr] = ACTIONS(2483),
    [anon_sym_volatile] = ACTIONS(2483),
    [anon_sym_restrict] = ACTIONS(2483),
    [anon_sym___restrict__] = ACTIONS(2483),
    [anon_sym__Atomic] = ACTIONS(2483),
    [anon_sym__Noreturn] = ACTIONS(2483),
    [anon_sym_noreturn] = ACTIONS(2483),
    [anon_sym_mutable] = ACTIONS(2483),
    [anon_sym_constinit] = ACTIONS(2483),
    [anon_sym_consteval] = ACTIONS(2483),
    [anon_sym_alignas] = ACTIONS(2483),
    [anon_sym__Alignas] = ACTIONS(2483),
    [sym_primitive_type] = ACTIONS(2483),
    [anon_sym_enum] = ACTIONS(2483),
    [anon_sym_class] = ACTIONS(2483),
    [anon_sym_struct] = ACTIONS(2483),
    [anon_sym_union] = ACTIONS(2483),
    [anon_sym_if] = ACTIONS(2483),
    [anon_sym_else] = ACTIONS(2483),
    [anon_sym_switch] = ACTIONS(2483),
    [anon_sym_case] = ACTIONS(2483),
    [anon_sym_default] = ACTIONS(2483),
    [anon_sym_while] = ACTIONS(2483),
    [anon_sym_do] = ACTIONS(2483),
    [anon_sym_for] = ACTIONS(2483),
    [anon_sym_return] = ACTIONS(2483),
    [anon_sym_break] = ACTIONS(2483),
    [anon_sym_continue] = ACTIONS(2483),
    [anon_sym_goto] = ACTIONS(2483),
    [anon_sym___try] = ACTIONS(2483),
    [anon_sym___leave] = ACTIONS(2483),
    [anon_sym_not] = ACTIONS(2483),
    [anon_sym_compl] = ACTIONS(2483),
    [anon_sym_DASH_DASH] = ACTIONS(2485),
    [anon_sym_PLUS_PLUS] = ACTIONS(2485),
    [anon_sym_sizeof] = ACTIONS(2483),
    [anon_sym___alignof__] = ACTIONS(2483),
    [anon_sym___alignof] = ACTIONS(2483),
    [anon_sym__alignof] = ACTIONS(2483),
    [anon_sym_alignof] = ACTIONS(2483),
    [anon_sym__Alignof] = ACTIONS(2483),
    [anon_sym_offsetof] = ACTIONS(2483),
    [anon_sym__Generic] = ACTIONS(2483),
    [anon_sym_asm] = ACTIONS(2483),
    [anon_sym___asm__] = ACTIONS(2483),
    [sym_number_literal] = ACTIONS(2485),
    [anon_sym_L_SQUOTE] = ACTIONS(2485),
    [anon_sym_u_SQUOTE] = ACTIONS(2485),
    [anon_sym_U_SQUOTE] = ACTIONS(2485),
    [anon_sym_u8_SQUOTE] = ACTIONS(2485),
    [anon_sym_SQUOTE] = ACTIONS(2485),
    [anon_sym_L_DQUOTE] = ACTIONS(2485),
    [anon_sym_u_DQUOTE] = ACTIONS(2485),
    [anon_sym_U_DQUOTE] = ACTIONS(2485),
    [anon_sym_u8_DQUOTE] = ACTIONS(2485),
    [anon_sym_DQUOTE] = ACTIONS(2485),
    [sym_true] = ACTIONS(2483),
    [sym_false] = ACTIONS(2483),
    [anon_sym_NULL] = ACTIONS(2483),
    [anon_sym_nullptr] = ACTIONS(2483),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2483),
    [anon_sym_let] = ACTIONS(2483),
    [anon_sym_This] = ACTIONS(2483),
    [anon_sym_decltype] = ACTIONS(2483),
    [anon_sym_final] = ACTIONS(2481),
    [anon_sym_override] = ACTIONS(2481),
    [sym_virtual] = ACTIONS(2483),
    [anon_sym_explicit] = ACTIONS(2483),
    [anon_sym_typename] = ACTIONS(2483),
    [anon_sym_template] = ACTIONS(2483),
    [anon_sym_operator] = ACTIONS(2483),
    [anon_sym_try] = ACTIONS(2483),
    [anon_sym_delete] = ACTIONS(2483),
    [anon_sym_throw] = ACTIONS(2483),
    [anon_sym_namespace] = ACTIONS(2483),
    [anon_sym_using] = ACTIONS(2483),
    [anon_sym_static_assert] = ACTIONS(2483),
    [anon_sym_concept] = ACTIONS(2483),
    [anon_sym_co_return] = ACTIONS(2483),
    [anon_sym_co_yield] = ACTIONS(2483),
    [anon_sym_R_DQUOTE] = ACTIONS(2485),
    [anon_sym_LR_DQUOTE] = ACTIONS(2485),
    [anon_sym_uR_DQUOTE] = ACTIONS(2485),
    [anon_sym_UR_DQUOTE] = ACTIONS(2485),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2485),
    [anon_sym_co_await] = ACTIONS(2483),
    [anon_sym_new] = ACTIONS(2483),
    [anon_sym_requires] = ACTIONS(2483),
    [sym_this] = ACTIONS(2483),
    [anon_sym_discard] = ACTIONS(2483),
    [anon_sym_precise] = ACTIONS(2483),
    [anon_sym_shared] = ACTIONS(2483),
    [anon_sym_groupshared] = ACTIONS(2483),
    [anon_sym_uniform] = ACTIONS(2483),
    [anon_sym_row_major] = ACTIONS(2483),
    [anon_sym_column_major] = ACTIONS(2483),
    [anon_sym_globallycoherent] = ACTIONS(2483),
    [anon_sym_centroid] = ACTIONS(2483),
    [anon_sym_noperspective] = ACTIONS(2483),
    [anon_sym_nointerpolation] = ACTIONS(2483),
    [anon_sym_sample] = ACTIONS(2483),
    [anon_sym_linear] = ACTIONS(2483),
    [anon_sym_snorm] = ACTIONS(2483),
    [anon_sym_unorm] = ACTIONS(2483),
    [anon_sym_point] = ACTIONS(2483),
    [anon_sym_line] = ACTIONS(2483),
    [anon_sym_triangleadj] = ACTIONS(2483),
    [anon_sym_lineadj] = ACTIONS(2483),
    [anon_sym_triangle] = ACTIONS(2483),
    [anon_sym_cbuffer] = ACTIONS(2483),
    [anon_sym_interface] = ACTIONS(2483),
    [anon_sym_extension] = ACTIONS(2483),
  },
  [268] = {
    [ts_builtin_sym_end] = ACTIONS(2740),
    [sym_identifier] = ACTIONS(2742),
    [aux_sym_preproc_include_token1] = ACTIONS(2742),
    [aux_sym_preproc_def_token1] = ACTIONS(2742),
    [anon_sym_COMMA] = ACTIONS(2740),
    [anon_sym_RPAREN] = ACTIONS(2740),
    [aux_sym_preproc_if_token1] = ACTIONS(2742),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2742),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2742),
    [sym_preproc_directive] = ACTIONS(2742),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_BANG] = ACTIONS(2740),
    [anon_sym_TILDE] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2742),
    [anon_sym_PLUS] = ACTIONS(2742),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_COLON] = ACTIONS(2742),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym___extension__] = ACTIONS(2742),
    [anon_sym_typedef] = ACTIONS(2742),
    [anon_sym_in] = ACTIONS(2742),
    [anon_sym_out] = ACTIONS(2742),
    [anon_sym_inout] = ACTIONS(2742),
    [anon_sym_extern] = ACTIONS(2742),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2740),
    [anon_sym___declspec] = ACTIONS(2742),
    [anon_sym___based] = ACTIONS(2742),
    [anon_sym___cdecl] = ACTIONS(2742),
    [anon_sym___clrcall] = ACTIONS(2742),
    [anon_sym___stdcall] = ACTIONS(2742),
    [anon_sym___fastcall] = ACTIONS(2742),
    [anon_sym___thiscall] = ACTIONS(2742),
    [anon_sym___vectorcall] = ACTIONS(2742),
    [anon_sym_LBRACE] = ACTIONS(2740),
    [anon_sym_signed] = ACTIONS(2742),
    [anon_sym_unsigned] = ACTIONS(2742),
    [anon_sym_long] = ACTIONS(2742),
    [anon_sym_short] = ACTIONS(2742),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2742),
    [anon_sym_EQ] = ACTIONS(2740),
    [anon_sym_register] = ACTIONS(2742),
    [anon_sym_inline] = ACTIONS(2742),
    [anon_sym___inline] = ACTIONS(2742),
    [anon_sym___inline__] = ACTIONS(2742),
    [anon_sym___forceinline] = ACTIONS(2742),
    [anon_sym_thread_local] = ACTIONS(2742),
    [anon_sym___thread] = ACTIONS(2742),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_constexpr] = ACTIONS(2742),
    [anon_sym_volatile] = ACTIONS(2742),
    [anon_sym_restrict] = ACTIONS(2742),
    [anon_sym___restrict__] = ACTIONS(2742),
    [anon_sym__Atomic] = ACTIONS(2742),
    [anon_sym__Noreturn] = ACTIONS(2742),
    [anon_sym_noreturn] = ACTIONS(2742),
    [anon_sym_mutable] = ACTIONS(2742),
    [anon_sym_constinit] = ACTIONS(2742),
    [anon_sym_consteval] = ACTIONS(2742),
    [anon_sym_alignas] = ACTIONS(2742),
    [anon_sym__Alignas] = ACTIONS(2742),
    [sym_primitive_type] = ACTIONS(2742),
    [anon_sym_enum] = ACTIONS(2742),
    [anon_sym_class] = ACTIONS(2742),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2742),
    [anon_sym_if] = ACTIONS(2742),
    [anon_sym_switch] = ACTIONS(2742),
    [anon_sym_case] = ACTIONS(2742),
    [anon_sym_default] = ACTIONS(2742),
    [anon_sym_while] = ACTIONS(2742),
    [anon_sym_do] = ACTIONS(2742),
    [anon_sym_for] = ACTIONS(2742),
    [anon_sym_return] = ACTIONS(2742),
    [anon_sym_break] = ACTIONS(2742),
    [anon_sym_continue] = ACTIONS(2742),
    [anon_sym_goto] = ACTIONS(2742),
    [anon_sym_not] = ACTIONS(2742),
    [anon_sym_compl] = ACTIONS(2742),
    [anon_sym_DASH_DASH] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2740),
    [anon_sym_sizeof] = ACTIONS(2742),
    [anon_sym___alignof__] = ACTIONS(2742),
    [anon_sym___alignof] = ACTIONS(2742),
    [anon_sym__alignof] = ACTIONS(2742),
    [anon_sym_alignof] = ACTIONS(2742),
    [anon_sym__Alignof] = ACTIONS(2742),
    [anon_sym_offsetof] = ACTIONS(2742),
    [anon_sym__Generic] = ACTIONS(2742),
    [anon_sym_asm] = ACTIONS(2742),
    [anon_sym___asm__] = ACTIONS(2742),
    [anon_sym_DOT] = ACTIONS(2742),
    [sym_number_literal] = ACTIONS(2740),
    [anon_sym_L_SQUOTE] = ACTIONS(2740),
    [anon_sym_u_SQUOTE] = ACTIONS(2740),
    [anon_sym_U_SQUOTE] = ACTIONS(2740),
    [anon_sym_u8_SQUOTE] = ACTIONS(2740),
    [anon_sym_SQUOTE] = ACTIONS(2740),
    [anon_sym_L_DQUOTE] = ACTIONS(2740),
    [anon_sym_u_DQUOTE] = ACTIONS(2740),
    [anon_sym_U_DQUOTE] = ACTIONS(2740),
    [anon_sym_u8_DQUOTE] = ACTIONS(2740),
    [anon_sym_DQUOTE] = ACTIONS(2740),
    [sym_true] = ACTIONS(2742),
    [sym_false] = ACTIONS(2742),
    [anon_sym_NULL] = ACTIONS(2742),
    [anon_sym_nullptr] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
    [anon_sym_decltype] = ACTIONS(2742),
    [anon_sym_final] = ACTIONS(2742),
    [anon_sym_override] = ACTIONS(2742),
    [sym_virtual] = ACTIONS(2742),
    [anon_sym_explicit] = ACTIONS(2742),
    [anon_sym_typename] = ACTIONS(2742),
    [anon_sym_template] = ACTIONS(2742),
    [anon_sym_GT2] = ACTIONS(2740),
    [anon_sym_operator] = ACTIONS(2742),
    [anon_sym_try] = ACTIONS(2742),
    [anon_sym_delete] = ACTIONS(2742),
    [anon_sym_throw] = ACTIONS(2742),
    [anon_sym_namespace] = ACTIONS(2742),
    [anon_sym_using] = ACTIONS(2742),
    [anon_sym_static_assert] = ACTIONS(2742),
    [anon_sym_concept] = ACTIONS(2742),
    [anon_sym_co_return] = ACTIONS(2742),
    [anon_sym_co_yield] = ACTIONS(2742),
    [anon_sym_R_DQUOTE] = ACTIONS(2740),
    [anon_sym_LR_DQUOTE] = ACTIONS(2740),
    [anon_sym_uR_DQUOTE] = ACTIONS(2740),
    [anon_sym_UR_DQUOTE] = ACTIONS(2740),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2740),
    [anon_sym_co_await] = ACTIONS(2742),
    [anon_sym_new] = ACTIONS(2742),
    [anon_sym_requires] = ACTIONS(2742),
    [sym_this] = ACTIONS(2742),
    [anon_sym_precise] = ACTIONS(2742),
    [anon_sym_shared] = ACTIONS(2742),
    [anon_sym_groupshared] = ACTIONS(2742),
    [anon_sym_uniform] = ACTIONS(2742),
    [anon_sym_row_major] = ACTIONS(2742),
    [anon_sym_column_major] = ACTIONS(2742),
    [anon_sym_globallycoherent] = ACTIONS(2742),
    [anon_sym_centroid] = ACTIONS(2742),
    [anon_sym_noperspective] = ACTIONS(2742),
    [anon_sym_nointerpolation] = ACTIONS(2742),
    [anon_sym_sample] = ACTIONS(2742),
    [anon_sym_linear] = ACTIONS(2742),
    [anon_sym_snorm] = ACTIONS(2742),
    [anon_sym_unorm] = ACTIONS(2742),
    [anon_sym_point] = ACTIONS(2742),
    [anon_sym_line] = ACTIONS(2742),
    [anon_sym_triangleadj] = ACTIONS(2742),
    [anon_sym_lineadj] = ACTIONS(2742),
    [anon_sym_triangle] = ACTIONS(2742),
    [anon_sym_interface] = ACTIONS(2742),
    [anon_sym_extension] = ACTIONS(2742),
    [anon_sym_where] = ACTIONS(2742),
    [anon_sym___exported] = ACTIONS(2742),
    [anon_sym_import] = ACTIONS(2742),
  },
  [269] = {
    [sym_catch_clause] = STATE(264),
    [aux_sym_constructor_try_statement_repeat1] = STATE(264),
    [sym_identifier] = ACTIONS(2744),
    [aux_sym_preproc_include_token1] = ACTIONS(2744),
    [aux_sym_preproc_def_token1] = ACTIONS(2744),
    [aux_sym_preproc_if_token1] = ACTIONS(2744),
    [aux_sym_preproc_if_token2] = ACTIONS(2744),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2744),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2744),
    [aux_sym_preproc_else_token1] = ACTIONS(2744),
    [aux_sym_preproc_elif_token1] = ACTIONS(2744),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2744),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2744),
    [sym_preproc_directive] = ACTIONS(2744),
    [anon_sym_LPAREN2] = ACTIONS(2746),
    [anon_sym_BANG] = ACTIONS(2746),
    [anon_sym_TILDE] = ACTIONS(2746),
    [anon_sym_DASH] = ACTIONS(2744),
    [anon_sym_PLUS] = ACTIONS(2744),
    [anon_sym_STAR] = ACTIONS(2746),
    [anon_sym_AMP_AMP] = ACTIONS(2746),
    [anon_sym_AMP] = ACTIONS(2744),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym___extension__] = ACTIONS(2744),
    [anon_sym_typedef] = ACTIONS(2744),
    [anon_sym_in] = ACTIONS(2744),
    [anon_sym_out] = ACTIONS(2744),
    [anon_sym_inout] = ACTIONS(2744),
    [anon_sym_extern] = ACTIONS(2744),
    [anon_sym___attribute__] = ACTIONS(2744),
    [anon_sym_COLON_COLON] = ACTIONS(2746),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2746),
    [anon_sym___declspec] = ACTIONS(2744),
    [anon_sym___based] = ACTIONS(2744),
    [anon_sym___cdecl] = ACTIONS(2744),
    [anon_sym___clrcall] = ACTIONS(2744),
    [anon_sym___stdcall] = ACTIONS(2744),
    [anon_sym___fastcall] = ACTIONS(2744),
    [anon_sym___thiscall] = ACTIONS(2744),
    [anon_sym___vectorcall] = ACTIONS(2744),
    [anon_sym_LBRACE] = ACTIONS(2746),
    [anon_sym_signed] = ACTIONS(2744),
    [anon_sym_unsigned] = ACTIONS(2744),
    [anon_sym_long] = ACTIONS(2744),
    [anon_sym_short] = ACTIONS(2744),
    [anon_sym_LBRACK] = ACTIONS(2744),
    [anon_sym_static] = ACTIONS(2744),
    [anon_sym_register] = ACTIONS(2744),
    [anon_sym_inline] = ACTIONS(2744),
    [anon_sym___inline] = ACTIONS(2744),
    [anon_sym___inline__] = ACTIONS(2744),
    [anon_sym___forceinline] = ACTIONS(2744),
    [anon_sym_thread_local] = ACTIONS(2744),
    [anon_sym___thread] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_constexpr] = ACTIONS(2744),
    [anon_sym_volatile] = ACTIONS(2744),
    [anon_sym_restrict] = ACTIONS(2744),
    [anon_sym___restrict__] = ACTIONS(2744),
    [anon_sym__Atomic] = ACTIONS(2744),
    [anon_sym__Noreturn] = ACTIONS(2744),
    [anon_sym_noreturn] = ACTIONS(2744),
    [anon_sym_mutable] = ACTIONS(2744),
    [anon_sym_constinit] = ACTIONS(2744),
    [anon_sym_consteval] = ACTIONS(2744),
    [anon_sym_alignas] = ACTIONS(2744),
    [anon_sym__Alignas] = ACTIONS(2744),
    [sym_primitive_type] = ACTIONS(2744),
    [anon_sym_enum] = ACTIONS(2744),
    [anon_sym_class] = ACTIONS(2744),
    [anon_sym_struct] = ACTIONS(2744),
    [anon_sym_union] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2744),
    [anon_sym_switch] = ACTIONS(2744),
    [anon_sym_case] = ACTIONS(2744),
    [anon_sym_default] = ACTIONS(2744),
    [anon_sym_while] = ACTIONS(2744),
    [anon_sym_do] = ACTIONS(2744),
    [anon_sym_for] = ACTIONS(2744),
    [anon_sym_return] = ACTIONS(2744),
    [anon_sym_break] = ACTIONS(2744),
    [anon_sym_continue] = ACTIONS(2744),
    [anon_sym_goto] = ACTIONS(2744),
    [anon_sym___try] = ACTIONS(2744),
    [anon_sym___leave] = ACTIONS(2744),
    [anon_sym_not] = ACTIONS(2744),
    [anon_sym_compl] = ACTIONS(2744),
    [anon_sym_DASH_DASH] = ACTIONS(2746),
    [anon_sym_PLUS_PLUS] = ACTIONS(2746),
    [anon_sym_sizeof] = ACTIONS(2744),
    [anon_sym___alignof__] = ACTIONS(2744),
    [anon_sym___alignof] = ACTIONS(2744),
    [anon_sym__alignof] = ACTIONS(2744),
    [anon_sym_alignof] = ACTIONS(2744),
    [anon_sym__Alignof] = ACTIONS(2744),
    [anon_sym_offsetof] = ACTIONS(2744),
    [anon_sym__Generic] = ACTIONS(2744),
    [anon_sym_asm] = ACTIONS(2744),
    [anon_sym___asm__] = ACTIONS(2744),
    [sym_number_literal] = ACTIONS(2746),
    [anon_sym_L_SQUOTE] = ACTIONS(2746),
    [anon_sym_u_SQUOTE] = ACTIONS(2746),
    [anon_sym_U_SQUOTE] = ACTIONS(2746),
    [anon_sym_u8_SQUOTE] = ACTIONS(2746),
    [anon_sym_SQUOTE] = ACTIONS(2746),
    [anon_sym_L_DQUOTE] = ACTIONS(2746),
    [anon_sym_u_DQUOTE] = ACTIONS(2746),
    [anon_sym_U_DQUOTE] = ACTIONS(2746),
    [anon_sym_u8_DQUOTE] = ACTIONS(2746),
    [anon_sym_DQUOTE] = ACTIONS(2746),
    [sym_true] = ACTIONS(2744),
    [sym_false] = ACTIONS(2744),
    [anon_sym_NULL] = ACTIONS(2744),
    [anon_sym_nullptr] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2744),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_This] = ACTIONS(2744),
    [anon_sym_decltype] = ACTIONS(2744),
    [sym_virtual] = ACTIONS(2744),
    [anon_sym_explicit] = ACTIONS(2744),
    [anon_sym_typename] = ACTIONS(2744),
    [anon_sym_template] = ACTIONS(2744),
    [anon_sym_operator] = ACTIONS(2744),
    [anon_sym_try] = ACTIONS(2744),
    [anon_sym_delete] = ACTIONS(2744),
    [anon_sym_throw] = ACTIONS(2744),
    [anon_sym_namespace] = ACTIONS(2744),
    [anon_sym_using] = ACTIONS(2744),
    [anon_sym_static_assert] = ACTIONS(2744),
    [anon_sym_concept] = ACTIONS(2744),
    [anon_sym_co_return] = ACTIONS(2744),
    [anon_sym_co_yield] = ACTIONS(2744),
    [anon_sym_catch] = ACTIONS(2681),
    [anon_sym_R_DQUOTE] = ACTIONS(2746),
    [anon_sym_LR_DQUOTE] = ACTIONS(2746),
    [anon_sym_uR_DQUOTE] = ACTIONS(2746),
    [anon_sym_UR_DQUOTE] = ACTIONS(2746),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2746),
    [anon_sym_co_await] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(2744),
    [anon_sym_requires] = ACTIONS(2744),
    [sym_this] = ACTIONS(2744),
    [anon_sym_discard] = ACTIONS(2744),
    [anon_sym_precise] = ACTIONS(2744),
    [anon_sym_shared] = ACTIONS(2744),
    [anon_sym_groupshared] = ACTIONS(2744),
    [anon_sym_uniform] = ACTIONS(2744),
    [anon_sym_row_major] = ACTIONS(2744),
    [anon_sym_column_major] = ACTIONS(2744),
    [anon_sym_globallycoherent] = ACTIONS(2744),
    [anon_sym_centroid] = ACTIONS(2744),
    [anon_sym_noperspective] = ACTIONS(2744),
    [anon_sym_nointerpolation] = ACTIONS(2744),
    [anon_sym_sample] = ACTIONS(2744),
    [anon_sym_linear] = ACTIONS(2744),
    [anon_sym_snorm] = ACTIONS(2744),
    [anon_sym_unorm] = ACTIONS(2744),
    [anon_sym_point] = ACTIONS(2744),
    [anon_sym_line] = ACTIONS(2744),
    [anon_sym_triangleadj] = ACTIONS(2744),
    [anon_sym_lineadj] = ACTIONS(2744),
    [anon_sym_triangle] = ACTIONS(2744),
    [anon_sym_cbuffer] = ACTIONS(2744),
    [anon_sym_interface] = ACTIONS(2744),
    [anon_sym_extension] = ACTIONS(2744),
  },
  [270] = {
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(6400),
    [sym__declarator] = STATE(8164),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7882),
    [sym_array_declarator] = STATE(7882),
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(3521),
    [sym__string] = STATE(4324),
    [sym_comma_expression] = STATE(10578),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_type_descriptor] = STATE(10576),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9813),
    [sym_dependent_type] = STATE(2888),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4031),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym__unary_left_fold] = STATE(10439),
    [sym__unary_right_fold] = STATE(10553),
    [sym__binary_fold] = STATE(10552),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6734),
    [sym_qualified_identifier] = STATE(4016),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym__assignment_expression_lhs] = STATE(10550),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4292),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(2750),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2754),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2758),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2760),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(2764),
    [anon_sym___clrcall] = ACTIONS(2764),
    [anon_sym___stdcall] = ACTIONS(2764),
    [anon_sym___fastcall] = ACTIONS(2764),
    [anon_sym___thiscall] = ACTIONS(2764),
    [anon_sym___vectorcall] = ACTIONS(2764),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(2808),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [271] = {
    [sym_field_declaration_list] = STATE(679),
    [sym_virtual_specifier] = STATE(8608),
    [sym_base_class_clause] = STATE(10044),
    [sym_identifier] = ACTIONS(2473),
    [aux_sym_preproc_include_token1] = ACTIONS(2473),
    [aux_sym_preproc_def_token1] = ACTIONS(2473),
    [aux_sym_preproc_if_token1] = ACTIONS(2473),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2473),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2473),
    [sym_preproc_directive] = ACTIONS(2473),
    [anon_sym_LPAREN2] = ACTIONS(2475),
    [anon_sym_BANG] = ACTIONS(2475),
    [anon_sym_TILDE] = ACTIONS(2475),
    [anon_sym_DASH] = ACTIONS(2473),
    [anon_sym_PLUS] = ACTIONS(2473),
    [anon_sym_STAR] = ACTIONS(2475),
    [anon_sym_AMP_AMP] = ACTIONS(2475),
    [anon_sym_AMP] = ACTIONS(2473),
    [anon_sym_COLON] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(2475),
    [anon_sym___extension__] = ACTIONS(2473),
    [anon_sym_typedef] = ACTIONS(2473),
    [anon_sym_in] = ACTIONS(2473),
    [anon_sym_out] = ACTIONS(2473),
    [anon_sym_inout] = ACTIONS(2473),
    [anon_sym_extern] = ACTIONS(2473),
    [anon_sym___attribute__] = ACTIONS(2473),
    [anon_sym_COLON_COLON] = ACTIONS(2475),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2475),
    [anon_sym___declspec] = ACTIONS(2473),
    [anon_sym___based] = ACTIONS(2473),
    [anon_sym___cdecl] = ACTIONS(2473),
    [anon_sym___clrcall] = ACTIONS(2473),
    [anon_sym___stdcall] = ACTIONS(2473),
    [anon_sym___fastcall] = ACTIONS(2473),
    [anon_sym___thiscall] = ACTIONS(2473),
    [anon_sym___vectorcall] = ACTIONS(2473),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_RBRACE] = ACTIONS(2475),
    [anon_sym_signed] = ACTIONS(2473),
    [anon_sym_unsigned] = ACTIONS(2473),
    [anon_sym_long] = ACTIONS(2473),
    [anon_sym_short] = ACTIONS(2473),
    [anon_sym_LBRACK] = ACTIONS(2473),
    [anon_sym_static] = ACTIONS(2473),
    [anon_sym_register] = ACTIONS(2473),
    [anon_sym_inline] = ACTIONS(2473),
    [anon_sym___inline] = ACTIONS(2473),
    [anon_sym___inline__] = ACTIONS(2473),
    [anon_sym___forceinline] = ACTIONS(2473),
    [anon_sym_thread_local] = ACTIONS(2473),
    [anon_sym___thread] = ACTIONS(2473),
    [anon_sym_const] = ACTIONS(2473),
    [anon_sym_constexpr] = ACTIONS(2473),
    [anon_sym_volatile] = ACTIONS(2473),
    [anon_sym_restrict] = ACTIONS(2473),
    [anon_sym___restrict__] = ACTIONS(2473),
    [anon_sym__Atomic] = ACTIONS(2473),
    [anon_sym__Noreturn] = ACTIONS(2473),
    [anon_sym_noreturn] = ACTIONS(2473),
    [anon_sym_mutable] = ACTIONS(2473),
    [anon_sym_constinit] = ACTIONS(2473),
    [anon_sym_consteval] = ACTIONS(2473),
    [anon_sym_alignas] = ACTIONS(2473),
    [anon_sym__Alignas] = ACTIONS(2473),
    [sym_primitive_type] = ACTIONS(2473),
    [anon_sym_enum] = ACTIONS(2473),
    [anon_sym_class] = ACTIONS(2473),
    [anon_sym_struct] = ACTIONS(2473),
    [anon_sym_union] = ACTIONS(2473),
    [anon_sym_if] = ACTIONS(2473),
    [anon_sym_else] = ACTIONS(2473),
    [anon_sym_switch] = ACTIONS(2473),
    [anon_sym_case] = ACTIONS(2473),
    [anon_sym_default] = ACTIONS(2473),
    [anon_sym_while] = ACTIONS(2473),
    [anon_sym_do] = ACTIONS(2473),
    [anon_sym_for] = ACTIONS(2473),
    [anon_sym_return] = ACTIONS(2473),
    [anon_sym_break] = ACTIONS(2473),
    [anon_sym_continue] = ACTIONS(2473),
    [anon_sym_goto] = ACTIONS(2473),
    [anon_sym___try] = ACTIONS(2473),
    [anon_sym___leave] = ACTIONS(2473),
    [anon_sym_not] = ACTIONS(2473),
    [anon_sym_compl] = ACTIONS(2473),
    [anon_sym_DASH_DASH] = ACTIONS(2475),
    [anon_sym_PLUS_PLUS] = ACTIONS(2475),
    [anon_sym_sizeof] = ACTIONS(2473),
    [anon_sym___alignof__] = ACTIONS(2473),
    [anon_sym___alignof] = ACTIONS(2473),
    [anon_sym__alignof] = ACTIONS(2473),
    [anon_sym_alignof] = ACTIONS(2473),
    [anon_sym__Alignof] = ACTIONS(2473),
    [anon_sym_offsetof] = ACTIONS(2473),
    [anon_sym__Generic] = ACTIONS(2473),
    [anon_sym_asm] = ACTIONS(2473),
    [anon_sym___asm__] = ACTIONS(2473),
    [sym_number_literal] = ACTIONS(2475),
    [anon_sym_L_SQUOTE] = ACTIONS(2475),
    [anon_sym_u_SQUOTE] = ACTIONS(2475),
    [anon_sym_U_SQUOTE] = ACTIONS(2475),
    [anon_sym_u8_SQUOTE] = ACTIONS(2475),
    [anon_sym_SQUOTE] = ACTIONS(2475),
    [anon_sym_L_DQUOTE] = ACTIONS(2475),
    [anon_sym_u_DQUOTE] = ACTIONS(2475),
    [anon_sym_U_DQUOTE] = ACTIONS(2475),
    [anon_sym_u8_DQUOTE] = ACTIONS(2475),
    [anon_sym_DQUOTE] = ACTIONS(2475),
    [sym_true] = ACTIONS(2473),
    [sym_false] = ACTIONS(2473),
    [anon_sym_NULL] = ACTIONS(2473),
    [anon_sym_nullptr] = ACTIONS(2473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2473),
    [anon_sym_let] = ACTIONS(2473),
    [anon_sym_This] = ACTIONS(2473),
    [anon_sym_decltype] = ACTIONS(2473),
    [anon_sym_final] = ACTIONS(2481),
    [anon_sym_override] = ACTIONS(2481),
    [sym_virtual] = ACTIONS(2473),
    [anon_sym_explicit] = ACTIONS(2473),
    [anon_sym_typename] = ACTIONS(2473),
    [anon_sym_template] = ACTIONS(2473),
    [anon_sym_operator] = ACTIONS(2473),
    [anon_sym_try] = ACTIONS(2473),
    [anon_sym_delete] = ACTIONS(2473),
    [anon_sym_throw] = ACTIONS(2473),
    [anon_sym_namespace] = ACTIONS(2473),
    [anon_sym_using] = ACTIONS(2473),
    [anon_sym_static_assert] = ACTIONS(2473),
    [anon_sym_concept] = ACTIONS(2473),
    [anon_sym_co_return] = ACTIONS(2473),
    [anon_sym_co_yield] = ACTIONS(2473),
    [anon_sym_R_DQUOTE] = ACTIONS(2475),
    [anon_sym_LR_DQUOTE] = ACTIONS(2475),
    [anon_sym_uR_DQUOTE] = ACTIONS(2475),
    [anon_sym_UR_DQUOTE] = ACTIONS(2475),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2475),
    [anon_sym_co_await] = ACTIONS(2473),
    [anon_sym_new] = ACTIONS(2473),
    [anon_sym_requires] = ACTIONS(2473),
    [sym_this] = ACTIONS(2473),
    [anon_sym_discard] = ACTIONS(2473),
    [anon_sym_precise] = ACTIONS(2473),
    [anon_sym_shared] = ACTIONS(2473),
    [anon_sym_groupshared] = ACTIONS(2473),
    [anon_sym_uniform] = ACTIONS(2473),
    [anon_sym_row_major] = ACTIONS(2473),
    [anon_sym_column_major] = ACTIONS(2473),
    [anon_sym_globallycoherent] = ACTIONS(2473),
    [anon_sym_centroid] = ACTIONS(2473),
    [anon_sym_noperspective] = ACTIONS(2473),
    [anon_sym_nointerpolation] = ACTIONS(2473),
    [anon_sym_sample] = ACTIONS(2473),
    [anon_sym_linear] = ACTIONS(2473),
    [anon_sym_snorm] = ACTIONS(2473),
    [anon_sym_unorm] = ACTIONS(2473),
    [anon_sym_point] = ACTIONS(2473),
    [anon_sym_line] = ACTIONS(2473),
    [anon_sym_triangleadj] = ACTIONS(2473),
    [anon_sym_lineadj] = ACTIONS(2473),
    [anon_sym_triangle] = ACTIONS(2473),
    [anon_sym_cbuffer] = ACTIONS(2473),
    [anon_sym_interface] = ACTIONS(2473),
    [anon_sym_extension] = ACTIONS(2473),
  },
  [272] = {
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(6400),
    [sym__declarator] = STATE(8164),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7882),
    [sym_array_declarator] = STATE(7882),
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(3522),
    [sym__string] = STATE(4324),
    [sym_comma_expression] = STATE(10715),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_type_descriptor] = STATE(10713),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9813),
    [sym_dependent_type] = STATE(2888),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4031),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym__unary_left_fold] = STATE(10708),
    [sym__unary_right_fold] = STATE(10705),
    [sym__binary_fold] = STATE(10700),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6734),
    [sym_qualified_identifier] = STATE(4016),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym__assignment_expression_lhs] = STATE(10673),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4292),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(2750),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2754),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2758),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2760),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(2764),
    [anon_sym___clrcall] = ACTIONS(2764),
    [anon_sym___stdcall] = ACTIONS(2764),
    [anon_sym___fastcall] = ACTIONS(2764),
    [anon_sym___thiscall] = ACTIONS(2764),
    [anon_sym___vectorcall] = ACTIONS(2764),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(2808),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [273] = {
    [ts_builtin_sym_end] = ACTIONS(2824),
    [sym_identifier] = ACTIONS(2826),
    [aux_sym_preproc_include_token1] = ACTIONS(2826),
    [aux_sym_preproc_def_token1] = ACTIONS(2826),
    [anon_sym_COMMA] = ACTIONS(2824),
    [anon_sym_RPAREN] = ACTIONS(2824),
    [aux_sym_preproc_if_token1] = ACTIONS(2826),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2826),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2826),
    [sym_preproc_directive] = ACTIONS(2826),
    [anon_sym_LPAREN2] = ACTIONS(2824),
    [anon_sym_BANG] = ACTIONS(2824),
    [anon_sym_TILDE] = ACTIONS(2824),
    [anon_sym_DASH] = ACTIONS(2826),
    [anon_sym_PLUS] = ACTIONS(2826),
    [anon_sym_STAR] = ACTIONS(2824),
    [anon_sym_AMP_AMP] = ACTIONS(2824),
    [anon_sym_AMP] = ACTIONS(2826),
    [anon_sym_COLON] = ACTIONS(2826),
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym___extension__] = ACTIONS(2826),
    [anon_sym_typedef] = ACTIONS(2826),
    [anon_sym_in] = ACTIONS(2826),
    [anon_sym_out] = ACTIONS(2826),
    [anon_sym_inout] = ACTIONS(2826),
    [anon_sym_extern] = ACTIONS(2826),
    [anon_sym___attribute__] = ACTIONS(2826),
    [anon_sym_COLON_COLON] = ACTIONS(2824),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2824),
    [anon_sym___declspec] = ACTIONS(2826),
    [anon_sym___based] = ACTIONS(2826),
    [anon_sym___cdecl] = ACTIONS(2826),
    [anon_sym___clrcall] = ACTIONS(2826),
    [anon_sym___stdcall] = ACTIONS(2826),
    [anon_sym___fastcall] = ACTIONS(2826),
    [anon_sym___thiscall] = ACTIONS(2826),
    [anon_sym___vectorcall] = ACTIONS(2826),
    [anon_sym_LBRACE] = ACTIONS(2824),
    [anon_sym_signed] = ACTIONS(2826),
    [anon_sym_unsigned] = ACTIONS(2826),
    [anon_sym_long] = ACTIONS(2826),
    [anon_sym_short] = ACTIONS(2826),
    [anon_sym_LBRACK] = ACTIONS(2826),
    [anon_sym_static] = ACTIONS(2826),
    [anon_sym_EQ] = ACTIONS(2824),
    [anon_sym_register] = ACTIONS(2826),
    [anon_sym_inline] = ACTIONS(2826),
    [anon_sym___inline] = ACTIONS(2826),
    [anon_sym___inline__] = ACTIONS(2826),
    [anon_sym___forceinline] = ACTIONS(2826),
    [anon_sym_thread_local] = ACTIONS(2826),
    [anon_sym___thread] = ACTIONS(2826),
    [anon_sym_const] = ACTIONS(2826),
    [anon_sym_constexpr] = ACTIONS(2826),
    [anon_sym_volatile] = ACTIONS(2826),
    [anon_sym_restrict] = ACTIONS(2826),
    [anon_sym___restrict__] = ACTIONS(2826),
    [anon_sym__Atomic] = ACTIONS(2826),
    [anon_sym__Noreturn] = ACTIONS(2826),
    [anon_sym_noreturn] = ACTIONS(2826),
    [anon_sym_mutable] = ACTIONS(2826),
    [anon_sym_constinit] = ACTIONS(2826),
    [anon_sym_consteval] = ACTIONS(2826),
    [anon_sym_alignas] = ACTIONS(2826),
    [anon_sym__Alignas] = ACTIONS(2826),
    [sym_primitive_type] = ACTIONS(2826),
    [anon_sym_enum] = ACTIONS(2826),
    [anon_sym_class] = ACTIONS(2826),
    [anon_sym_struct] = ACTIONS(2826),
    [anon_sym_union] = ACTIONS(2826),
    [anon_sym_if] = ACTIONS(2826),
    [anon_sym_switch] = ACTIONS(2826),
    [anon_sym_case] = ACTIONS(2826),
    [anon_sym_default] = ACTIONS(2826),
    [anon_sym_while] = ACTIONS(2826),
    [anon_sym_do] = ACTIONS(2826),
    [anon_sym_for] = ACTIONS(2826),
    [anon_sym_return] = ACTIONS(2826),
    [anon_sym_break] = ACTIONS(2826),
    [anon_sym_continue] = ACTIONS(2826),
    [anon_sym_goto] = ACTIONS(2826),
    [anon_sym_not] = ACTIONS(2826),
    [anon_sym_compl] = ACTIONS(2826),
    [anon_sym_DASH_DASH] = ACTIONS(2824),
    [anon_sym_PLUS_PLUS] = ACTIONS(2824),
    [anon_sym_sizeof] = ACTIONS(2826),
    [anon_sym___alignof__] = ACTIONS(2826),
    [anon_sym___alignof] = ACTIONS(2826),
    [anon_sym__alignof] = ACTIONS(2826),
    [anon_sym_alignof] = ACTIONS(2826),
    [anon_sym__Alignof] = ACTIONS(2826),
    [anon_sym_offsetof] = ACTIONS(2826),
    [anon_sym__Generic] = ACTIONS(2826),
    [anon_sym_asm] = ACTIONS(2826),
    [anon_sym___asm__] = ACTIONS(2826),
    [anon_sym_DOT] = ACTIONS(2826),
    [sym_number_literal] = ACTIONS(2824),
    [anon_sym_L_SQUOTE] = ACTIONS(2824),
    [anon_sym_u_SQUOTE] = ACTIONS(2824),
    [anon_sym_U_SQUOTE] = ACTIONS(2824),
    [anon_sym_u8_SQUOTE] = ACTIONS(2824),
    [anon_sym_SQUOTE] = ACTIONS(2824),
    [anon_sym_L_DQUOTE] = ACTIONS(2824),
    [anon_sym_u_DQUOTE] = ACTIONS(2824),
    [anon_sym_U_DQUOTE] = ACTIONS(2824),
    [anon_sym_u8_DQUOTE] = ACTIONS(2824),
    [anon_sym_DQUOTE] = ACTIONS(2824),
    [sym_true] = ACTIONS(2826),
    [sym_false] = ACTIONS(2826),
    [anon_sym_NULL] = ACTIONS(2826),
    [anon_sym_nullptr] = ACTIONS(2826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2826),
    [anon_sym_let] = ACTIONS(2826),
    [anon_sym_This] = ACTIONS(2826),
    [anon_sym_decltype] = ACTIONS(2826),
    [anon_sym_final] = ACTIONS(2826),
    [anon_sym_override] = ACTIONS(2826),
    [sym_virtual] = ACTIONS(2826),
    [anon_sym_explicit] = ACTIONS(2826),
    [anon_sym_typename] = ACTIONS(2826),
    [anon_sym_template] = ACTIONS(2826),
    [anon_sym_GT2] = ACTIONS(2824),
    [anon_sym_operator] = ACTIONS(2826),
    [anon_sym_try] = ACTIONS(2826),
    [anon_sym_delete] = ACTIONS(2826),
    [anon_sym_throw] = ACTIONS(2826),
    [anon_sym_namespace] = ACTIONS(2826),
    [anon_sym_using] = ACTIONS(2826),
    [anon_sym_static_assert] = ACTIONS(2826),
    [anon_sym_concept] = ACTIONS(2826),
    [anon_sym_co_return] = ACTIONS(2826),
    [anon_sym_co_yield] = ACTIONS(2826),
    [anon_sym_R_DQUOTE] = ACTIONS(2824),
    [anon_sym_LR_DQUOTE] = ACTIONS(2824),
    [anon_sym_uR_DQUOTE] = ACTIONS(2824),
    [anon_sym_UR_DQUOTE] = ACTIONS(2824),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2824),
    [anon_sym_co_await] = ACTIONS(2826),
    [anon_sym_new] = ACTIONS(2826),
    [anon_sym_requires] = ACTIONS(2826),
    [sym_this] = ACTIONS(2826),
    [anon_sym_precise] = ACTIONS(2826),
    [anon_sym_shared] = ACTIONS(2826),
    [anon_sym_groupshared] = ACTIONS(2826),
    [anon_sym_uniform] = ACTIONS(2826),
    [anon_sym_row_major] = ACTIONS(2826),
    [anon_sym_column_major] = ACTIONS(2826),
    [anon_sym_globallycoherent] = ACTIONS(2826),
    [anon_sym_centroid] = ACTIONS(2826),
    [anon_sym_noperspective] = ACTIONS(2826),
    [anon_sym_nointerpolation] = ACTIONS(2826),
    [anon_sym_sample] = ACTIONS(2826),
    [anon_sym_linear] = ACTIONS(2826),
    [anon_sym_snorm] = ACTIONS(2826),
    [anon_sym_unorm] = ACTIONS(2826),
    [anon_sym_point] = ACTIONS(2826),
    [anon_sym_line] = ACTIONS(2826),
    [anon_sym_triangleadj] = ACTIONS(2826),
    [anon_sym_lineadj] = ACTIONS(2826),
    [anon_sym_triangle] = ACTIONS(2826),
    [anon_sym_interface] = ACTIONS(2826),
    [anon_sym_extension] = ACTIONS(2826),
    [anon_sym_where] = ACTIONS(2826),
    [anon_sym___exported] = ACTIONS(2826),
    [anon_sym_import] = ACTIONS(2826),
  },
  [274] = {
    [sym_field_declaration_list] = STATE(660),
    [sym_virtual_specifier] = STATE(8686),
    [sym_base_class_clause] = STATE(9732),
    [sym_identifier] = ACTIONS(2473),
    [aux_sym_preproc_include_token1] = ACTIONS(2473),
    [aux_sym_preproc_def_token1] = ACTIONS(2473),
    [aux_sym_preproc_if_token1] = ACTIONS(2473),
    [aux_sym_preproc_if_token2] = ACTIONS(2473),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2473),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2473),
    [sym_preproc_directive] = ACTIONS(2473),
    [anon_sym_LPAREN2] = ACTIONS(2475),
    [anon_sym_BANG] = ACTIONS(2475),
    [anon_sym_TILDE] = ACTIONS(2475),
    [anon_sym_DASH] = ACTIONS(2473),
    [anon_sym_PLUS] = ACTIONS(2473),
    [anon_sym_STAR] = ACTIONS(2475),
    [anon_sym_AMP_AMP] = ACTIONS(2475),
    [anon_sym_AMP] = ACTIONS(2473),
    [anon_sym_COLON] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(2475),
    [anon_sym___extension__] = ACTIONS(2473),
    [anon_sym_typedef] = ACTIONS(2473),
    [anon_sym_in] = ACTIONS(2473),
    [anon_sym_out] = ACTIONS(2473),
    [anon_sym_inout] = ACTIONS(2473),
    [anon_sym_extern] = ACTIONS(2473),
    [anon_sym___attribute__] = ACTIONS(2473),
    [anon_sym_COLON_COLON] = ACTIONS(2475),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2475),
    [anon_sym___declspec] = ACTIONS(2473),
    [anon_sym___based] = ACTIONS(2473),
    [anon_sym___cdecl] = ACTIONS(2473),
    [anon_sym___clrcall] = ACTIONS(2473),
    [anon_sym___stdcall] = ACTIONS(2473),
    [anon_sym___fastcall] = ACTIONS(2473),
    [anon_sym___thiscall] = ACTIONS(2473),
    [anon_sym___vectorcall] = ACTIONS(2473),
    [anon_sym_LBRACE] = ACTIONS(2828),
    [anon_sym_signed] = ACTIONS(2473),
    [anon_sym_unsigned] = ACTIONS(2473),
    [anon_sym_long] = ACTIONS(2473),
    [anon_sym_short] = ACTIONS(2473),
    [anon_sym_LBRACK] = ACTIONS(2473),
    [anon_sym_static] = ACTIONS(2473),
    [anon_sym_register] = ACTIONS(2473),
    [anon_sym_inline] = ACTIONS(2473),
    [anon_sym___inline] = ACTIONS(2473),
    [anon_sym___inline__] = ACTIONS(2473),
    [anon_sym___forceinline] = ACTIONS(2473),
    [anon_sym_thread_local] = ACTIONS(2473),
    [anon_sym___thread] = ACTIONS(2473),
    [anon_sym_const] = ACTIONS(2473),
    [anon_sym_constexpr] = ACTIONS(2473),
    [anon_sym_volatile] = ACTIONS(2473),
    [anon_sym_restrict] = ACTIONS(2473),
    [anon_sym___restrict__] = ACTIONS(2473),
    [anon_sym__Atomic] = ACTIONS(2473),
    [anon_sym__Noreturn] = ACTIONS(2473),
    [anon_sym_noreturn] = ACTIONS(2473),
    [anon_sym_mutable] = ACTIONS(2473),
    [anon_sym_constinit] = ACTIONS(2473),
    [anon_sym_consteval] = ACTIONS(2473),
    [anon_sym_alignas] = ACTIONS(2473),
    [anon_sym__Alignas] = ACTIONS(2473),
    [sym_primitive_type] = ACTIONS(2473),
    [anon_sym_enum] = ACTIONS(2473),
    [anon_sym_class] = ACTIONS(2473),
    [anon_sym_struct] = ACTIONS(2473),
    [anon_sym_union] = ACTIONS(2473),
    [anon_sym_if] = ACTIONS(2473),
    [anon_sym_else] = ACTIONS(2473),
    [anon_sym_switch] = ACTIONS(2473),
    [anon_sym_case] = ACTIONS(2473),
    [anon_sym_default] = ACTIONS(2473),
    [anon_sym_while] = ACTIONS(2473),
    [anon_sym_do] = ACTIONS(2473),
    [anon_sym_for] = ACTIONS(2473),
    [anon_sym_return] = ACTIONS(2473),
    [anon_sym_break] = ACTIONS(2473),
    [anon_sym_continue] = ACTIONS(2473),
    [anon_sym_goto] = ACTIONS(2473),
    [anon_sym___try] = ACTIONS(2473),
    [anon_sym___leave] = ACTIONS(2473),
    [anon_sym_not] = ACTIONS(2473),
    [anon_sym_compl] = ACTIONS(2473),
    [anon_sym_DASH_DASH] = ACTIONS(2475),
    [anon_sym_PLUS_PLUS] = ACTIONS(2475),
    [anon_sym_sizeof] = ACTIONS(2473),
    [anon_sym___alignof__] = ACTIONS(2473),
    [anon_sym___alignof] = ACTIONS(2473),
    [anon_sym__alignof] = ACTIONS(2473),
    [anon_sym_alignof] = ACTIONS(2473),
    [anon_sym__Alignof] = ACTIONS(2473),
    [anon_sym_offsetof] = ACTIONS(2473),
    [anon_sym__Generic] = ACTIONS(2473),
    [anon_sym_asm] = ACTIONS(2473),
    [anon_sym___asm__] = ACTIONS(2473),
    [sym_number_literal] = ACTIONS(2475),
    [anon_sym_L_SQUOTE] = ACTIONS(2475),
    [anon_sym_u_SQUOTE] = ACTIONS(2475),
    [anon_sym_U_SQUOTE] = ACTIONS(2475),
    [anon_sym_u8_SQUOTE] = ACTIONS(2475),
    [anon_sym_SQUOTE] = ACTIONS(2475),
    [anon_sym_L_DQUOTE] = ACTIONS(2475),
    [anon_sym_u_DQUOTE] = ACTIONS(2475),
    [anon_sym_U_DQUOTE] = ACTIONS(2475),
    [anon_sym_u8_DQUOTE] = ACTIONS(2475),
    [anon_sym_DQUOTE] = ACTIONS(2475),
    [sym_true] = ACTIONS(2473),
    [sym_false] = ACTIONS(2473),
    [anon_sym_NULL] = ACTIONS(2473),
    [anon_sym_nullptr] = ACTIONS(2473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2473),
    [anon_sym_let] = ACTIONS(2473),
    [anon_sym_This] = ACTIONS(2473),
    [anon_sym_decltype] = ACTIONS(2473),
    [anon_sym_final] = ACTIONS(2481),
    [anon_sym_override] = ACTIONS(2481),
    [sym_virtual] = ACTIONS(2473),
    [anon_sym_explicit] = ACTIONS(2473),
    [anon_sym_typename] = ACTIONS(2473),
    [anon_sym_template] = ACTIONS(2473),
    [anon_sym_operator] = ACTIONS(2473),
    [anon_sym_try] = ACTIONS(2473),
    [anon_sym_delete] = ACTIONS(2473),
    [anon_sym_throw] = ACTIONS(2473),
    [anon_sym_namespace] = ACTIONS(2473),
    [anon_sym_using] = ACTIONS(2473),
    [anon_sym_static_assert] = ACTIONS(2473),
    [anon_sym_concept] = ACTIONS(2473),
    [anon_sym_co_return] = ACTIONS(2473),
    [anon_sym_co_yield] = ACTIONS(2473),
    [anon_sym_R_DQUOTE] = ACTIONS(2475),
    [anon_sym_LR_DQUOTE] = ACTIONS(2475),
    [anon_sym_uR_DQUOTE] = ACTIONS(2475),
    [anon_sym_UR_DQUOTE] = ACTIONS(2475),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2475),
    [anon_sym_co_await] = ACTIONS(2473),
    [anon_sym_new] = ACTIONS(2473),
    [anon_sym_requires] = ACTIONS(2473),
    [sym_this] = ACTIONS(2473),
    [anon_sym_discard] = ACTIONS(2473),
    [anon_sym_precise] = ACTIONS(2473),
    [anon_sym_shared] = ACTIONS(2473),
    [anon_sym_groupshared] = ACTIONS(2473),
    [anon_sym_uniform] = ACTIONS(2473),
    [anon_sym_row_major] = ACTIONS(2473),
    [anon_sym_column_major] = ACTIONS(2473),
    [anon_sym_globallycoherent] = ACTIONS(2473),
    [anon_sym_centroid] = ACTIONS(2473),
    [anon_sym_noperspective] = ACTIONS(2473),
    [anon_sym_nointerpolation] = ACTIONS(2473),
    [anon_sym_sample] = ACTIONS(2473),
    [anon_sym_linear] = ACTIONS(2473),
    [anon_sym_snorm] = ACTIONS(2473),
    [anon_sym_unorm] = ACTIONS(2473),
    [anon_sym_point] = ACTIONS(2473),
    [anon_sym_line] = ACTIONS(2473),
    [anon_sym_triangleadj] = ACTIONS(2473),
    [anon_sym_lineadj] = ACTIONS(2473),
    [anon_sym_triangle] = ACTIONS(2473),
    [anon_sym_cbuffer] = ACTIONS(2473),
    [anon_sym_interface] = ACTIONS(2473),
    [anon_sym_extension] = ACTIONS(2473),
  },
  [275] = {
    [sym_field_declaration_list] = STATE(758),
    [sym_virtual_specifier] = STATE(8670),
    [sym_base_class_clause] = STATE(9796),
    [sym_identifier] = ACTIONS(2483),
    [aux_sym_preproc_include_token1] = ACTIONS(2483),
    [aux_sym_preproc_def_token1] = ACTIONS(2483),
    [aux_sym_preproc_if_token1] = ACTIONS(2483),
    [aux_sym_preproc_if_token2] = ACTIONS(2483),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2483),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2483),
    [sym_preproc_directive] = ACTIONS(2483),
    [anon_sym_LPAREN2] = ACTIONS(2485),
    [anon_sym_BANG] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2483),
    [anon_sym_PLUS] = ACTIONS(2483),
    [anon_sym_STAR] = ACTIONS(2485),
    [anon_sym_AMP_AMP] = ACTIONS(2485),
    [anon_sym_AMP] = ACTIONS(2483),
    [anon_sym_COLON] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(2485),
    [anon_sym___extension__] = ACTIONS(2483),
    [anon_sym_typedef] = ACTIONS(2483),
    [anon_sym_in] = ACTIONS(2483),
    [anon_sym_out] = ACTIONS(2483),
    [anon_sym_inout] = ACTIONS(2483),
    [anon_sym_extern] = ACTIONS(2483),
    [anon_sym___attribute__] = ACTIONS(2483),
    [anon_sym_COLON_COLON] = ACTIONS(2485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2485),
    [anon_sym___declspec] = ACTIONS(2483),
    [anon_sym___based] = ACTIONS(2483),
    [anon_sym___cdecl] = ACTIONS(2483),
    [anon_sym___clrcall] = ACTIONS(2483),
    [anon_sym___stdcall] = ACTIONS(2483),
    [anon_sym___fastcall] = ACTIONS(2483),
    [anon_sym___thiscall] = ACTIONS(2483),
    [anon_sym___vectorcall] = ACTIONS(2483),
    [anon_sym_LBRACE] = ACTIONS(2828),
    [anon_sym_signed] = ACTIONS(2483),
    [anon_sym_unsigned] = ACTIONS(2483),
    [anon_sym_long] = ACTIONS(2483),
    [anon_sym_short] = ACTIONS(2483),
    [anon_sym_LBRACK] = ACTIONS(2483),
    [anon_sym_static] = ACTIONS(2483),
    [anon_sym_register] = ACTIONS(2483),
    [anon_sym_inline] = ACTIONS(2483),
    [anon_sym___inline] = ACTIONS(2483),
    [anon_sym___inline__] = ACTIONS(2483),
    [anon_sym___forceinline] = ACTIONS(2483),
    [anon_sym_thread_local] = ACTIONS(2483),
    [anon_sym___thread] = ACTIONS(2483),
    [anon_sym_const] = ACTIONS(2483),
    [anon_sym_constexpr] = ACTIONS(2483),
    [anon_sym_volatile] = ACTIONS(2483),
    [anon_sym_restrict] = ACTIONS(2483),
    [anon_sym___restrict__] = ACTIONS(2483),
    [anon_sym__Atomic] = ACTIONS(2483),
    [anon_sym__Noreturn] = ACTIONS(2483),
    [anon_sym_noreturn] = ACTIONS(2483),
    [anon_sym_mutable] = ACTIONS(2483),
    [anon_sym_constinit] = ACTIONS(2483),
    [anon_sym_consteval] = ACTIONS(2483),
    [anon_sym_alignas] = ACTIONS(2483),
    [anon_sym__Alignas] = ACTIONS(2483),
    [sym_primitive_type] = ACTIONS(2483),
    [anon_sym_enum] = ACTIONS(2483),
    [anon_sym_class] = ACTIONS(2483),
    [anon_sym_struct] = ACTIONS(2483),
    [anon_sym_union] = ACTIONS(2483),
    [anon_sym_if] = ACTIONS(2483),
    [anon_sym_else] = ACTIONS(2483),
    [anon_sym_switch] = ACTIONS(2483),
    [anon_sym_case] = ACTIONS(2483),
    [anon_sym_default] = ACTIONS(2483),
    [anon_sym_while] = ACTIONS(2483),
    [anon_sym_do] = ACTIONS(2483),
    [anon_sym_for] = ACTIONS(2483),
    [anon_sym_return] = ACTIONS(2483),
    [anon_sym_break] = ACTIONS(2483),
    [anon_sym_continue] = ACTIONS(2483),
    [anon_sym_goto] = ACTIONS(2483),
    [anon_sym___try] = ACTIONS(2483),
    [anon_sym___leave] = ACTIONS(2483),
    [anon_sym_not] = ACTIONS(2483),
    [anon_sym_compl] = ACTIONS(2483),
    [anon_sym_DASH_DASH] = ACTIONS(2485),
    [anon_sym_PLUS_PLUS] = ACTIONS(2485),
    [anon_sym_sizeof] = ACTIONS(2483),
    [anon_sym___alignof__] = ACTIONS(2483),
    [anon_sym___alignof] = ACTIONS(2483),
    [anon_sym__alignof] = ACTIONS(2483),
    [anon_sym_alignof] = ACTIONS(2483),
    [anon_sym__Alignof] = ACTIONS(2483),
    [anon_sym_offsetof] = ACTIONS(2483),
    [anon_sym__Generic] = ACTIONS(2483),
    [anon_sym_asm] = ACTIONS(2483),
    [anon_sym___asm__] = ACTIONS(2483),
    [sym_number_literal] = ACTIONS(2485),
    [anon_sym_L_SQUOTE] = ACTIONS(2485),
    [anon_sym_u_SQUOTE] = ACTIONS(2485),
    [anon_sym_U_SQUOTE] = ACTIONS(2485),
    [anon_sym_u8_SQUOTE] = ACTIONS(2485),
    [anon_sym_SQUOTE] = ACTIONS(2485),
    [anon_sym_L_DQUOTE] = ACTIONS(2485),
    [anon_sym_u_DQUOTE] = ACTIONS(2485),
    [anon_sym_U_DQUOTE] = ACTIONS(2485),
    [anon_sym_u8_DQUOTE] = ACTIONS(2485),
    [anon_sym_DQUOTE] = ACTIONS(2485),
    [sym_true] = ACTIONS(2483),
    [sym_false] = ACTIONS(2483),
    [anon_sym_NULL] = ACTIONS(2483),
    [anon_sym_nullptr] = ACTIONS(2483),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2483),
    [anon_sym_let] = ACTIONS(2483),
    [anon_sym_This] = ACTIONS(2483),
    [anon_sym_decltype] = ACTIONS(2483),
    [anon_sym_final] = ACTIONS(2481),
    [anon_sym_override] = ACTIONS(2481),
    [sym_virtual] = ACTIONS(2483),
    [anon_sym_explicit] = ACTIONS(2483),
    [anon_sym_typename] = ACTIONS(2483),
    [anon_sym_template] = ACTIONS(2483),
    [anon_sym_operator] = ACTIONS(2483),
    [anon_sym_try] = ACTIONS(2483),
    [anon_sym_delete] = ACTIONS(2483),
    [anon_sym_throw] = ACTIONS(2483),
    [anon_sym_namespace] = ACTIONS(2483),
    [anon_sym_using] = ACTIONS(2483),
    [anon_sym_static_assert] = ACTIONS(2483),
    [anon_sym_concept] = ACTIONS(2483),
    [anon_sym_co_return] = ACTIONS(2483),
    [anon_sym_co_yield] = ACTIONS(2483),
    [anon_sym_R_DQUOTE] = ACTIONS(2485),
    [anon_sym_LR_DQUOTE] = ACTIONS(2485),
    [anon_sym_uR_DQUOTE] = ACTIONS(2485),
    [anon_sym_UR_DQUOTE] = ACTIONS(2485),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2485),
    [anon_sym_co_await] = ACTIONS(2483),
    [anon_sym_new] = ACTIONS(2483),
    [anon_sym_requires] = ACTIONS(2483),
    [sym_this] = ACTIONS(2483),
    [anon_sym_discard] = ACTIONS(2483),
    [anon_sym_precise] = ACTIONS(2483),
    [anon_sym_shared] = ACTIONS(2483),
    [anon_sym_groupshared] = ACTIONS(2483),
    [anon_sym_uniform] = ACTIONS(2483),
    [anon_sym_row_major] = ACTIONS(2483),
    [anon_sym_column_major] = ACTIONS(2483),
    [anon_sym_globallycoherent] = ACTIONS(2483),
    [anon_sym_centroid] = ACTIONS(2483),
    [anon_sym_noperspective] = ACTIONS(2483),
    [anon_sym_nointerpolation] = ACTIONS(2483),
    [anon_sym_sample] = ACTIONS(2483),
    [anon_sym_linear] = ACTIONS(2483),
    [anon_sym_snorm] = ACTIONS(2483),
    [anon_sym_unorm] = ACTIONS(2483),
    [anon_sym_point] = ACTIONS(2483),
    [anon_sym_line] = ACTIONS(2483),
    [anon_sym_triangleadj] = ACTIONS(2483),
    [anon_sym_lineadj] = ACTIONS(2483),
    [anon_sym_triangle] = ACTIONS(2483),
    [anon_sym_cbuffer] = ACTIONS(2483),
    [anon_sym_interface] = ACTIONS(2483),
    [anon_sym_extension] = ACTIONS(2483),
  },
  [276] = {
    [sym_catch_clause] = STATE(264),
    [aux_sym_constructor_try_statement_repeat1] = STATE(264),
    [sym_identifier] = ACTIONS(2830),
    [aux_sym_preproc_include_token1] = ACTIONS(2830),
    [aux_sym_preproc_def_token1] = ACTIONS(2830),
    [aux_sym_preproc_if_token1] = ACTIONS(2830),
    [aux_sym_preproc_if_token2] = ACTIONS(2830),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2830),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2830),
    [aux_sym_preproc_else_token1] = ACTIONS(2830),
    [aux_sym_preproc_elif_token1] = ACTIONS(2830),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2830),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2830),
    [sym_preproc_directive] = ACTIONS(2830),
    [anon_sym_LPAREN2] = ACTIONS(2832),
    [anon_sym_BANG] = ACTIONS(2832),
    [anon_sym_TILDE] = ACTIONS(2832),
    [anon_sym_DASH] = ACTIONS(2830),
    [anon_sym_PLUS] = ACTIONS(2830),
    [anon_sym_STAR] = ACTIONS(2832),
    [anon_sym_AMP_AMP] = ACTIONS(2832),
    [anon_sym_AMP] = ACTIONS(2830),
    [anon_sym_SEMI] = ACTIONS(2832),
    [anon_sym___extension__] = ACTIONS(2830),
    [anon_sym_typedef] = ACTIONS(2830),
    [anon_sym_in] = ACTIONS(2830),
    [anon_sym_out] = ACTIONS(2830),
    [anon_sym_inout] = ACTIONS(2830),
    [anon_sym_extern] = ACTIONS(2830),
    [anon_sym___attribute__] = ACTIONS(2830),
    [anon_sym_COLON_COLON] = ACTIONS(2832),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2832),
    [anon_sym___declspec] = ACTIONS(2830),
    [anon_sym___based] = ACTIONS(2830),
    [anon_sym___cdecl] = ACTIONS(2830),
    [anon_sym___clrcall] = ACTIONS(2830),
    [anon_sym___stdcall] = ACTIONS(2830),
    [anon_sym___fastcall] = ACTIONS(2830),
    [anon_sym___thiscall] = ACTIONS(2830),
    [anon_sym___vectorcall] = ACTIONS(2830),
    [anon_sym_LBRACE] = ACTIONS(2832),
    [anon_sym_signed] = ACTIONS(2830),
    [anon_sym_unsigned] = ACTIONS(2830),
    [anon_sym_long] = ACTIONS(2830),
    [anon_sym_short] = ACTIONS(2830),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [anon_sym_static] = ACTIONS(2830),
    [anon_sym_register] = ACTIONS(2830),
    [anon_sym_inline] = ACTIONS(2830),
    [anon_sym___inline] = ACTIONS(2830),
    [anon_sym___inline__] = ACTIONS(2830),
    [anon_sym___forceinline] = ACTIONS(2830),
    [anon_sym_thread_local] = ACTIONS(2830),
    [anon_sym___thread] = ACTIONS(2830),
    [anon_sym_const] = ACTIONS(2830),
    [anon_sym_constexpr] = ACTIONS(2830),
    [anon_sym_volatile] = ACTIONS(2830),
    [anon_sym_restrict] = ACTIONS(2830),
    [anon_sym___restrict__] = ACTIONS(2830),
    [anon_sym__Atomic] = ACTIONS(2830),
    [anon_sym__Noreturn] = ACTIONS(2830),
    [anon_sym_noreturn] = ACTIONS(2830),
    [anon_sym_mutable] = ACTIONS(2830),
    [anon_sym_constinit] = ACTIONS(2830),
    [anon_sym_consteval] = ACTIONS(2830),
    [anon_sym_alignas] = ACTIONS(2830),
    [anon_sym__Alignas] = ACTIONS(2830),
    [sym_primitive_type] = ACTIONS(2830),
    [anon_sym_enum] = ACTIONS(2830),
    [anon_sym_class] = ACTIONS(2830),
    [anon_sym_struct] = ACTIONS(2830),
    [anon_sym_union] = ACTIONS(2830),
    [anon_sym_if] = ACTIONS(2830),
    [anon_sym_switch] = ACTIONS(2830),
    [anon_sym_case] = ACTIONS(2830),
    [anon_sym_default] = ACTIONS(2830),
    [anon_sym_while] = ACTIONS(2830),
    [anon_sym_do] = ACTIONS(2830),
    [anon_sym_for] = ACTIONS(2830),
    [anon_sym_return] = ACTIONS(2830),
    [anon_sym_break] = ACTIONS(2830),
    [anon_sym_continue] = ACTIONS(2830),
    [anon_sym_goto] = ACTIONS(2830),
    [anon_sym___try] = ACTIONS(2830),
    [anon_sym___leave] = ACTIONS(2830),
    [anon_sym_not] = ACTIONS(2830),
    [anon_sym_compl] = ACTIONS(2830),
    [anon_sym_DASH_DASH] = ACTIONS(2832),
    [anon_sym_PLUS_PLUS] = ACTIONS(2832),
    [anon_sym_sizeof] = ACTIONS(2830),
    [anon_sym___alignof__] = ACTIONS(2830),
    [anon_sym___alignof] = ACTIONS(2830),
    [anon_sym__alignof] = ACTIONS(2830),
    [anon_sym_alignof] = ACTIONS(2830),
    [anon_sym__Alignof] = ACTIONS(2830),
    [anon_sym_offsetof] = ACTIONS(2830),
    [anon_sym__Generic] = ACTIONS(2830),
    [anon_sym_asm] = ACTIONS(2830),
    [anon_sym___asm__] = ACTIONS(2830),
    [sym_number_literal] = ACTIONS(2832),
    [anon_sym_L_SQUOTE] = ACTIONS(2832),
    [anon_sym_u_SQUOTE] = ACTIONS(2832),
    [anon_sym_U_SQUOTE] = ACTIONS(2832),
    [anon_sym_u8_SQUOTE] = ACTIONS(2832),
    [anon_sym_SQUOTE] = ACTIONS(2832),
    [anon_sym_L_DQUOTE] = ACTIONS(2832),
    [anon_sym_u_DQUOTE] = ACTIONS(2832),
    [anon_sym_U_DQUOTE] = ACTIONS(2832),
    [anon_sym_u8_DQUOTE] = ACTIONS(2832),
    [anon_sym_DQUOTE] = ACTIONS(2832),
    [sym_true] = ACTIONS(2830),
    [sym_false] = ACTIONS(2830),
    [anon_sym_NULL] = ACTIONS(2830),
    [anon_sym_nullptr] = ACTIONS(2830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2830),
    [anon_sym_let] = ACTIONS(2830),
    [anon_sym_This] = ACTIONS(2830),
    [anon_sym_decltype] = ACTIONS(2830),
    [sym_virtual] = ACTIONS(2830),
    [anon_sym_explicit] = ACTIONS(2830),
    [anon_sym_typename] = ACTIONS(2830),
    [anon_sym_template] = ACTIONS(2830),
    [anon_sym_operator] = ACTIONS(2830),
    [anon_sym_try] = ACTIONS(2830),
    [anon_sym_delete] = ACTIONS(2830),
    [anon_sym_throw] = ACTIONS(2830),
    [anon_sym_namespace] = ACTIONS(2830),
    [anon_sym_using] = ACTIONS(2830),
    [anon_sym_static_assert] = ACTIONS(2830),
    [anon_sym_concept] = ACTIONS(2830),
    [anon_sym_co_return] = ACTIONS(2830),
    [anon_sym_co_yield] = ACTIONS(2830),
    [anon_sym_catch] = ACTIONS(2681),
    [anon_sym_R_DQUOTE] = ACTIONS(2832),
    [anon_sym_LR_DQUOTE] = ACTIONS(2832),
    [anon_sym_uR_DQUOTE] = ACTIONS(2832),
    [anon_sym_UR_DQUOTE] = ACTIONS(2832),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2832),
    [anon_sym_co_await] = ACTIONS(2830),
    [anon_sym_new] = ACTIONS(2830),
    [anon_sym_requires] = ACTIONS(2830),
    [sym_this] = ACTIONS(2830),
    [anon_sym_discard] = ACTIONS(2830),
    [anon_sym_precise] = ACTIONS(2830),
    [anon_sym_shared] = ACTIONS(2830),
    [anon_sym_groupshared] = ACTIONS(2830),
    [anon_sym_uniform] = ACTIONS(2830),
    [anon_sym_row_major] = ACTIONS(2830),
    [anon_sym_column_major] = ACTIONS(2830),
    [anon_sym_globallycoherent] = ACTIONS(2830),
    [anon_sym_centroid] = ACTIONS(2830),
    [anon_sym_noperspective] = ACTIONS(2830),
    [anon_sym_nointerpolation] = ACTIONS(2830),
    [anon_sym_sample] = ACTIONS(2830),
    [anon_sym_linear] = ACTIONS(2830),
    [anon_sym_snorm] = ACTIONS(2830),
    [anon_sym_unorm] = ACTIONS(2830),
    [anon_sym_point] = ACTIONS(2830),
    [anon_sym_line] = ACTIONS(2830),
    [anon_sym_triangleadj] = ACTIONS(2830),
    [anon_sym_lineadj] = ACTIONS(2830),
    [anon_sym_triangle] = ACTIONS(2830),
    [anon_sym_cbuffer] = ACTIONS(2830),
    [anon_sym_interface] = ACTIONS(2830),
    [anon_sym_extension] = ACTIONS(2830),
  },
  [277] = {
    [sym_template_argument_list] = STATE(337),
    [sym_identifier] = ACTIONS(2349),
    [aux_sym_preproc_include_token1] = ACTIONS(2349),
    [aux_sym_preproc_def_token1] = ACTIONS(2349),
    [aux_sym_preproc_if_token1] = ACTIONS(2349),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2349),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2349),
    [sym_preproc_directive] = ACTIONS(2349),
    [anon_sym_LPAREN2] = ACTIONS(2347),
    [anon_sym_BANG] = ACTIONS(2347),
    [anon_sym_TILDE] = ACTIONS(2347),
    [anon_sym_DASH] = ACTIONS(2349),
    [anon_sym_PLUS] = ACTIONS(2349),
    [anon_sym_STAR] = ACTIONS(2347),
    [anon_sym_AMP_AMP] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2349),
    [anon_sym_LT] = ACTIONS(2738),
    [anon_sym_COLON] = ACTIONS(2349),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym___extension__] = ACTIONS(2349),
    [anon_sym_typedef] = ACTIONS(2349),
    [anon_sym_in] = ACTIONS(2349),
    [anon_sym_out] = ACTIONS(2349),
    [anon_sym_inout] = ACTIONS(2349),
    [anon_sym_extern] = ACTIONS(2349),
    [anon_sym___attribute__] = ACTIONS(2349),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2347),
    [anon_sym___declspec] = ACTIONS(2349),
    [anon_sym___based] = ACTIONS(2349),
    [anon_sym___cdecl] = ACTIONS(2349),
    [anon_sym___clrcall] = ACTIONS(2349),
    [anon_sym___stdcall] = ACTIONS(2349),
    [anon_sym___fastcall] = ACTIONS(2349),
    [anon_sym___thiscall] = ACTIONS(2349),
    [anon_sym___vectorcall] = ACTIONS(2349),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_RBRACE] = ACTIONS(2347),
    [anon_sym_signed] = ACTIONS(2349),
    [anon_sym_unsigned] = ACTIONS(2349),
    [anon_sym_long] = ACTIONS(2349),
    [anon_sym_short] = ACTIONS(2349),
    [anon_sym_LBRACK] = ACTIONS(2349),
    [anon_sym_static] = ACTIONS(2349),
    [anon_sym_register] = ACTIONS(2349),
    [anon_sym_inline] = ACTIONS(2349),
    [anon_sym___inline] = ACTIONS(2349),
    [anon_sym___inline__] = ACTIONS(2349),
    [anon_sym___forceinline] = ACTIONS(2349),
    [anon_sym_thread_local] = ACTIONS(2349),
    [anon_sym___thread] = ACTIONS(2349),
    [anon_sym_const] = ACTIONS(2349),
    [anon_sym_constexpr] = ACTIONS(2349),
    [anon_sym_volatile] = ACTIONS(2349),
    [anon_sym_restrict] = ACTIONS(2349),
    [anon_sym___restrict__] = ACTIONS(2349),
    [anon_sym__Atomic] = ACTIONS(2349),
    [anon_sym__Noreturn] = ACTIONS(2349),
    [anon_sym_noreturn] = ACTIONS(2349),
    [anon_sym_mutable] = ACTIONS(2349),
    [anon_sym_constinit] = ACTIONS(2349),
    [anon_sym_consteval] = ACTIONS(2349),
    [anon_sym_alignas] = ACTIONS(2349),
    [anon_sym__Alignas] = ACTIONS(2349),
    [sym_primitive_type] = ACTIONS(2349),
    [anon_sym_enum] = ACTIONS(2349),
    [anon_sym_class] = ACTIONS(2349),
    [anon_sym_struct] = ACTIONS(2349),
    [anon_sym_union] = ACTIONS(2349),
    [anon_sym_if] = ACTIONS(2349),
    [anon_sym_else] = ACTIONS(2349),
    [anon_sym_switch] = ACTIONS(2349),
    [anon_sym_case] = ACTIONS(2349),
    [anon_sym_default] = ACTIONS(2349),
    [anon_sym_while] = ACTIONS(2349),
    [anon_sym_do] = ACTIONS(2349),
    [anon_sym_for] = ACTIONS(2349),
    [anon_sym_return] = ACTIONS(2349),
    [anon_sym_break] = ACTIONS(2349),
    [anon_sym_continue] = ACTIONS(2349),
    [anon_sym_goto] = ACTIONS(2349),
    [anon_sym___try] = ACTIONS(2349),
    [anon_sym___leave] = ACTIONS(2349),
    [anon_sym_not] = ACTIONS(2349),
    [anon_sym_compl] = ACTIONS(2349),
    [anon_sym_DASH_DASH] = ACTIONS(2347),
    [anon_sym_PLUS_PLUS] = ACTIONS(2347),
    [anon_sym_sizeof] = ACTIONS(2349),
    [anon_sym___alignof__] = ACTIONS(2349),
    [anon_sym___alignof] = ACTIONS(2349),
    [anon_sym__alignof] = ACTIONS(2349),
    [anon_sym_alignof] = ACTIONS(2349),
    [anon_sym__Alignof] = ACTIONS(2349),
    [anon_sym_offsetof] = ACTIONS(2349),
    [anon_sym__Generic] = ACTIONS(2349),
    [anon_sym_asm] = ACTIONS(2349),
    [anon_sym___asm__] = ACTIONS(2349),
    [anon_sym_DOT] = ACTIONS(2349),
    [sym_number_literal] = ACTIONS(2347),
    [anon_sym_L_SQUOTE] = ACTIONS(2347),
    [anon_sym_u_SQUOTE] = ACTIONS(2347),
    [anon_sym_U_SQUOTE] = ACTIONS(2347),
    [anon_sym_u8_SQUOTE] = ACTIONS(2347),
    [anon_sym_SQUOTE] = ACTIONS(2347),
    [anon_sym_L_DQUOTE] = ACTIONS(2347),
    [anon_sym_u_DQUOTE] = ACTIONS(2347),
    [anon_sym_U_DQUOTE] = ACTIONS(2347),
    [anon_sym_u8_DQUOTE] = ACTIONS(2347),
    [anon_sym_DQUOTE] = ACTIONS(2347),
    [sym_true] = ACTIONS(2349),
    [sym_false] = ACTIONS(2349),
    [anon_sym_NULL] = ACTIONS(2349),
    [anon_sym_nullptr] = ACTIONS(2349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2349),
    [anon_sym_let] = ACTIONS(2349),
    [anon_sym_This] = ACTIONS(2349),
    [anon_sym_decltype] = ACTIONS(2349),
    [anon_sym_final] = ACTIONS(2349),
    [anon_sym_override] = ACTIONS(2349),
    [sym_virtual] = ACTIONS(2349),
    [anon_sym_explicit] = ACTIONS(2349),
    [anon_sym_typename] = ACTIONS(2349),
    [anon_sym_template] = ACTIONS(2349),
    [anon_sym_operator] = ACTIONS(2349),
    [anon_sym_try] = ACTIONS(2349),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_throw] = ACTIONS(2349),
    [anon_sym_namespace] = ACTIONS(2349),
    [anon_sym_using] = ACTIONS(2349),
    [anon_sym_static_assert] = ACTIONS(2349),
    [anon_sym_concept] = ACTIONS(2349),
    [anon_sym_co_return] = ACTIONS(2349),
    [anon_sym_co_yield] = ACTIONS(2349),
    [anon_sym_R_DQUOTE] = ACTIONS(2347),
    [anon_sym_LR_DQUOTE] = ACTIONS(2347),
    [anon_sym_uR_DQUOTE] = ACTIONS(2347),
    [anon_sym_UR_DQUOTE] = ACTIONS(2347),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2347),
    [anon_sym_co_await] = ACTIONS(2349),
    [anon_sym_new] = ACTIONS(2349),
    [anon_sym_requires] = ACTIONS(2349),
    [sym_this] = ACTIONS(2349),
    [anon_sym_discard] = ACTIONS(2349),
    [anon_sym_precise] = ACTIONS(2349),
    [anon_sym_shared] = ACTIONS(2349),
    [anon_sym_groupshared] = ACTIONS(2349),
    [anon_sym_uniform] = ACTIONS(2349),
    [anon_sym_row_major] = ACTIONS(2349),
    [anon_sym_column_major] = ACTIONS(2349),
    [anon_sym_globallycoherent] = ACTIONS(2349),
    [anon_sym_centroid] = ACTIONS(2349),
    [anon_sym_noperspective] = ACTIONS(2349),
    [anon_sym_nointerpolation] = ACTIONS(2349),
    [anon_sym_sample] = ACTIONS(2349),
    [anon_sym_linear] = ACTIONS(2349),
    [anon_sym_snorm] = ACTIONS(2349),
    [anon_sym_unorm] = ACTIONS(2349),
    [anon_sym_point] = ACTIONS(2349),
    [anon_sym_line] = ACTIONS(2349),
    [anon_sym_triangleadj] = ACTIONS(2349),
    [anon_sym_lineadj] = ACTIONS(2349),
    [anon_sym_triangle] = ACTIONS(2349),
    [anon_sym_cbuffer] = ACTIONS(2349),
    [anon_sym_interface] = ACTIONS(2349),
    [anon_sym_extension] = ACTIONS(2349),
  },
  [278] = {
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(6400),
    [sym__declarator] = STATE(8164),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7882),
    [sym_array_declarator] = STATE(7882),
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(3522),
    [sym__string] = STATE(4324),
    [sym_comma_expression] = STATE(10715),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_type_descriptor] = STATE(10300),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9813),
    [sym_dependent_type] = STATE(2888),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4031),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym__unary_left_fold] = STATE(10301),
    [sym__unary_right_fold] = STATE(10302),
    [sym__binary_fold] = STATE(10271),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6734),
    [sym_qualified_identifier] = STATE(4016),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym__assignment_expression_lhs] = STATE(10673),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4292),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(2750),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2754),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2758),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2760),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(2764),
    [anon_sym___clrcall] = ACTIONS(2764),
    [anon_sym___stdcall] = ACTIONS(2764),
    [anon_sym___fastcall] = ACTIONS(2764),
    [anon_sym___thiscall] = ACTIONS(2764),
    [anon_sym___vectorcall] = ACTIONS(2764),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(2808),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [279] = {
    [sym_template_argument_list] = STATE(526),
    [sym_identifier] = ACTIONS(2169),
    [aux_sym_preproc_include_token1] = ACTIONS(2169),
    [aux_sym_preproc_def_token1] = ACTIONS(2169),
    [aux_sym_preproc_if_token1] = ACTIONS(2169),
    [aux_sym_preproc_if_token2] = ACTIONS(2169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2169),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2169),
    [sym_preproc_directive] = ACTIONS(2169),
    [anon_sym_LPAREN2] = ACTIONS(2176),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2169),
    [anon_sym_PLUS] = ACTIONS(2169),
    [anon_sym_STAR] = ACTIONS(2176),
    [anon_sym_AMP_AMP] = ACTIONS(2176),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(2834),
    [anon_sym_COLON] = ACTIONS(2169),
    [anon_sym_SEMI] = ACTIONS(2176),
    [anon_sym___extension__] = ACTIONS(2169),
    [anon_sym_typedef] = ACTIONS(2169),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_out] = ACTIONS(2169),
    [anon_sym_inout] = ACTIONS(2169),
    [anon_sym_extern] = ACTIONS(2169),
    [anon_sym___attribute__] = ACTIONS(2169),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2176),
    [anon_sym___declspec] = ACTIONS(2169),
    [anon_sym___based] = ACTIONS(2169),
    [anon_sym___cdecl] = ACTIONS(2169),
    [anon_sym___clrcall] = ACTIONS(2169),
    [anon_sym___stdcall] = ACTIONS(2169),
    [anon_sym___fastcall] = ACTIONS(2169),
    [anon_sym___thiscall] = ACTIONS(2169),
    [anon_sym___vectorcall] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2176),
    [anon_sym_signed] = ACTIONS(2169),
    [anon_sym_unsigned] = ACTIONS(2169),
    [anon_sym_long] = ACTIONS(2169),
    [anon_sym_short] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(2169),
    [anon_sym_static] = ACTIONS(2169),
    [anon_sym_register] = ACTIONS(2169),
    [anon_sym_inline] = ACTIONS(2169),
    [anon_sym___inline] = ACTIONS(2169),
    [anon_sym___inline__] = ACTIONS(2169),
    [anon_sym___forceinline] = ACTIONS(2169),
    [anon_sym_thread_local] = ACTIONS(2169),
    [anon_sym___thread] = ACTIONS(2169),
    [anon_sym_const] = ACTIONS(2169),
    [anon_sym_constexpr] = ACTIONS(2169),
    [anon_sym_volatile] = ACTIONS(2169),
    [anon_sym_restrict] = ACTIONS(2169),
    [anon_sym___restrict__] = ACTIONS(2169),
    [anon_sym__Atomic] = ACTIONS(2169),
    [anon_sym__Noreturn] = ACTIONS(2169),
    [anon_sym_noreturn] = ACTIONS(2169),
    [anon_sym_mutable] = ACTIONS(2169),
    [anon_sym_constinit] = ACTIONS(2169),
    [anon_sym_consteval] = ACTIONS(2169),
    [anon_sym_alignas] = ACTIONS(2169),
    [anon_sym__Alignas] = ACTIONS(2169),
    [sym_primitive_type] = ACTIONS(2169),
    [anon_sym_enum] = ACTIONS(2169),
    [anon_sym_class] = ACTIONS(2169),
    [anon_sym_struct] = ACTIONS(2169),
    [anon_sym_union] = ACTIONS(2169),
    [anon_sym_if] = ACTIONS(2169),
    [anon_sym_else] = ACTIONS(2169),
    [anon_sym_switch] = ACTIONS(2169),
    [anon_sym_case] = ACTIONS(2169),
    [anon_sym_default] = ACTIONS(2169),
    [anon_sym_while] = ACTIONS(2169),
    [anon_sym_do] = ACTIONS(2169),
    [anon_sym_for] = ACTIONS(2169),
    [anon_sym_return] = ACTIONS(2169),
    [anon_sym_break] = ACTIONS(2169),
    [anon_sym_continue] = ACTIONS(2169),
    [anon_sym_goto] = ACTIONS(2169),
    [anon_sym___try] = ACTIONS(2169),
    [anon_sym___leave] = ACTIONS(2169),
    [anon_sym_not] = ACTIONS(2169),
    [anon_sym_compl] = ACTIONS(2169),
    [anon_sym_DASH_DASH] = ACTIONS(2176),
    [anon_sym_PLUS_PLUS] = ACTIONS(2176),
    [anon_sym_sizeof] = ACTIONS(2169),
    [anon_sym___alignof__] = ACTIONS(2169),
    [anon_sym___alignof] = ACTIONS(2169),
    [anon_sym__alignof] = ACTIONS(2169),
    [anon_sym_alignof] = ACTIONS(2169),
    [anon_sym__Alignof] = ACTIONS(2169),
    [anon_sym_offsetof] = ACTIONS(2169),
    [anon_sym__Generic] = ACTIONS(2169),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [sym_number_literal] = ACTIONS(2176),
    [anon_sym_L_SQUOTE] = ACTIONS(2176),
    [anon_sym_u_SQUOTE] = ACTIONS(2176),
    [anon_sym_U_SQUOTE] = ACTIONS(2176),
    [anon_sym_u8_SQUOTE] = ACTIONS(2176),
    [anon_sym_SQUOTE] = ACTIONS(2176),
    [anon_sym_L_DQUOTE] = ACTIONS(2176),
    [anon_sym_u_DQUOTE] = ACTIONS(2176),
    [anon_sym_U_DQUOTE] = ACTIONS(2176),
    [anon_sym_u8_DQUOTE] = ACTIONS(2176),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [sym_true] = ACTIONS(2169),
    [sym_false] = ACTIONS(2169),
    [anon_sym_NULL] = ACTIONS(2169),
    [anon_sym_nullptr] = ACTIONS(2169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2169),
    [anon_sym_let] = ACTIONS(2169),
    [anon_sym_This] = ACTIONS(2169),
    [anon_sym_decltype] = ACTIONS(2169),
    [anon_sym_final] = ACTIONS(2169),
    [anon_sym_override] = ACTIONS(2169),
    [sym_virtual] = ACTIONS(2169),
    [anon_sym_explicit] = ACTIONS(2169),
    [anon_sym_typename] = ACTIONS(2169),
    [anon_sym_template] = ACTIONS(2169),
    [anon_sym_operator] = ACTIONS(2169),
    [anon_sym_try] = ACTIONS(2169),
    [anon_sym_delete] = ACTIONS(2169),
    [anon_sym_throw] = ACTIONS(2169),
    [anon_sym_namespace] = ACTIONS(2169),
    [anon_sym_using] = ACTIONS(2169),
    [anon_sym_static_assert] = ACTIONS(2169),
    [anon_sym_concept] = ACTIONS(2169),
    [anon_sym_co_return] = ACTIONS(2169),
    [anon_sym_co_yield] = ACTIONS(2169),
    [anon_sym_R_DQUOTE] = ACTIONS(2176),
    [anon_sym_LR_DQUOTE] = ACTIONS(2176),
    [anon_sym_uR_DQUOTE] = ACTIONS(2176),
    [anon_sym_UR_DQUOTE] = ACTIONS(2176),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2176),
    [anon_sym_co_await] = ACTIONS(2169),
    [anon_sym_new] = ACTIONS(2169),
    [anon_sym_requires] = ACTIONS(2169),
    [sym_this] = ACTIONS(2169),
    [anon_sym_discard] = ACTIONS(2169),
    [anon_sym_precise] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_groupshared] = ACTIONS(2169),
    [anon_sym_uniform] = ACTIONS(2169),
    [anon_sym_row_major] = ACTIONS(2169),
    [anon_sym_column_major] = ACTIONS(2169),
    [anon_sym_globallycoherent] = ACTIONS(2169),
    [anon_sym_centroid] = ACTIONS(2169),
    [anon_sym_noperspective] = ACTIONS(2169),
    [anon_sym_nointerpolation] = ACTIONS(2169),
    [anon_sym_sample] = ACTIONS(2169),
    [anon_sym_linear] = ACTIONS(2169),
    [anon_sym_snorm] = ACTIONS(2169),
    [anon_sym_unorm] = ACTIONS(2169),
    [anon_sym_point] = ACTIONS(2169),
    [anon_sym_line] = ACTIONS(2169),
    [anon_sym_triangleadj] = ACTIONS(2169),
    [anon_sym_lineadj] = ACTIONS(2169),
    [anon_sym_triangle] = ACTIONS(2169),
    [anon_sym_cbuffer] = ACTIONS(2169),
    [anon_sym_interface] = ACTIONS(2169),
    [anon_sym_extension] = ACTIONS(2169),
  },
  [280] = {
    [sym_else_clause] = STATE(410),
    [sym_identifier] = ACTIONS(2836),
    [aux_sym_preproc_include_token1] = ACTIONS(2836),
    [aux_sym_preproc_def_token1] = ACTIONS(2836),
    [aux_sym_preproc_if_token1] = ACTIONS(2836),
    [aux_sym_preproc_if_token2] = ACTIONS(2836),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2836),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2836),
    [aux_sym_preproc_else_token1] = ACTIONS(2836),
    [aux_sym_preproc_elif_token1] = ACTIONS(2836),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2836),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2836),
    [sym_preproc_directive] = ACTIONS(2836),
    [anon_sym_LPAREN2] = ACTIONS(2838),
    [anon_sym_BANG] = ACTIONS(2838),
    [anon_sym_TILDE] = ACTIONS(2838),
    [anon_sym_DASH] = ACTIONS(2836),
    [anon_sym_PLUS] = ACTIONS(2836),
    [anon_sym_STAR] = ACTIONS(2838),
    [anon_sym_AMP_AMP] = ACTIONS(2838),
    [anon_sym_AMP] = ACTIONS(2836),
    [anon_sym_SEMI] = ACTIONS(2838),
    [anon_sym___extension__] = ACTIONS(2836),
    [anon_sym_typedef] = ACTIONS(2836),
    [anon_sym_in] = ACTIONS(2836),
    [anon_sym_out] = ACTIONS(2836),
    [anon_sym_inout] = ACTIONS(2836),
    [anon_sym_extern] = ACTIONS(2836),
    [anon_sym___attribute__] = ACTIONS(2836),
    [anon_sym_COLON_COLON] = ACTIONS(2838),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2838),
    [anon_sym___declspec] = ACTIONS(2836),
    [anon_sym___based] = ACTIONS(2836),
    [anon_sym___cdecl] = ACTIONS(2836),
    [anon_sym___clrcall] = ACTIONS(2836),
    [anon_sym___stdcall] = ACTIONS(2836),
    [anon_sym___fastcall] = ACTIONS(2836),
    [anon_sym___thiscall] = ACTIONS(2836),
    [anon_sym___vectorcall] = ACTIONS(2836),
    [anon_sym_LBRACE] = ACTIONS(2838),
    [anon_sym_signed] = ACTIONS(2836),
    [anon_sym_unsigned] = ACTIONS(2836),
    [anon_sym_long] = ACTIONS(2836),
    [anon_sym_short] = ACTIONS(2836),
    [anon_sym_LBRACK] = ACTIONS(2836),
    [anon_sym_static] = ACTIONS(2836),
    [anon_sym_register] = ACTIONS(2836),
    [anon_sym_inline] = ACTIONS(2836),
    [anon_sym___inline] = ACTIONS(2836),
    [anon_sym___inline__] = ACTIONS(2836),
    [anon_sym___forceinline] = ACTIONS(2836),
    [anon_sym_thread_local] = ACTIONS(2836),
    [anon_sym___thread] = ACTIONS(2836),
    [anon_sym_const] = ACTIONS(2836),
    [anon_sym_constexpr] = ACTIONS(2836),
    [anon_sym_volatile] = ACTIONS(2836),
    [anon_sym_restrict] = ACTIONS(2836),
    [anon_sym___restrict__] = ACTIONS(2836),
    [anon_sym__Atomic] = ACTIONS(2836),
    [anon_sym__Noreturn] = ACTIONS(2836),
    [anon_sym_noreturn] = ACTIONS(2836),
    [anon_sym_mutable] = ACTIONS(2836),
    [anon_sym_constinit] = ACTIONS(2836),
    [anon_sym_consteval] = ACTIONS(2836),
    [anon_sym_alignas] = ACTIONS(2836),
    [anon_sym__Alignas] = ACTIONS(2836),
    [sym_primitive_type] = ACTIONS(2836),
    [anon_sym_enum] = ACTIONS(2836),
    [anon_sym_class] = ACTIONS(2836),
    [anon_sym_struct] = ACTIONS(2836),
    [anon_sym_union] = ACTIONS(2836),
    [anon_sym_if] = ACTIONS(2836),
    [anon_sym_else] = ACTIONS(2840),
    [anon_sym_switch] = ACTIONS(2836),
    [anon_sym_case] = ACTIONS(2836),
    [anon_sym_default] = ACTIONS(2836),
    [anon_sym_while] = ACTIONS(2836),
    [anon_sym_do] = ACTIONS(2836),
    [anon_sym_for] = ACTIONS(2836),
    [anon_sym_return] = ACTIONS(2836),
    [anon_sym_break] = ACTIONS(2836),
    [anon_sym_continue] = ACTIONS(2836),
    [anon_sym_goto] = ACTIONS(2836),
    [anon_sym___try] = ACTIONS(2836),
    [anon_sym___leave] = ACTIONS(2836),
    [anon_sym_not] = ACTIONS(2836),
    [anon_sym_compl] = ACTIONS(2836),
    [anon_sym_DASH_DASH] = ACTIONS(2838),
    [anon_sym_PLUS_PLUS] = ACTIONS(2838),
    [anon_sym_sizeof] = ACTIONS(2836),
    [anon_sym___alignof__] = ACTIONS(2836),
    [anon_sym___alignof] = ACTIONS(2836),
    [anon_sym__alignof] = ACTIONS(2836),
    [anon_sym_alignof] = ACTIONS(2836),
    [anon_sym__Alignof] = ACTIONS(2836),
    [anon_sym_offsetof] = ACTIONS(2836),
    [anon_sym__Generic] = ACTIONS(2836),
    [anon_sym_asm] = ACTIONS(2836),
    [anon_sym___asm__] = ACTIONS(2836),
    [sym_number_literal] = ACTIONS(2838),
    [anon_sym_L_SQUOTE] = ACTIONS(2838),
    [anon_sym_u_SQUOTE] = ACTIONS(2838),
    [anon_sym_U_SQUOTE] = ACTIONS(2838),
    [anon_sym_u8_SQUOTE] = ACTIONS(2838),
    [anon_sym_SQUOTE] = ACTIONS(2838),
    [anon_sym_L_DQUOTE] = ACTIONS(2838),
    [anon_sym_u_DQUOTE] = ACTIONS(2838),
    [anon_sym_U_DQUOTE] = ACTIONS(2838),
    [anon_sym_u8_DQUOTE] = ACTIONS(2838),
    [anon_sym_DQUOTE] = ACTIONS(2838),
    [sym_true] = ACTIONS(2836),
    [sym_false] = ACTIONS(2836),
    [anon_sym_NULL] = ACTIONS(2836),
    [anon_sym_nullptr] = ACTIONS(2836),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2836),
    [anon_sym_let] = ACTIONS(2836),
    [anon_sym_This] = ACTIONS(2836),
    [anon_sym_decltype] = ACTIONS(2836),
    [sym_virtual] = ACTIONS(2836),
    [anon_sym_explicit] = ACTIONS(2836),
    [anon_sym_typename] = ACTIONS(2836),
    [anon_sym_template] = ACTIONS(2836),
    [anon_sym_operator] = ACTIONS(2836),
    [anon_sym_try] = ACTIONS(2836),
    [anon_sym_delete] = ACTIONS(2836),
    [anon_sym_throw] = ACTIONS(2836),
    [anon_sym_namespace] = ACTIONS(2836),
    [anon_sym_using] = ACTIONS(2836),
    [anon_sym_static_assert] = ACTIONS(2836),
    [anon_sym_concept] = ACTIONS(2836),
    [anon_sym_co_return] = ACTIONS(2836),
    [anon_sym_co_yield] = ACTIONS(2836),
    [anon_sym_R_DQUOTE] = ACTIONS(2838),
    [anon_sym_LR_DQUOTE] = ACTIONS(2838),
    [anon_sym_uR_DQUOTE] = ACTIONS(2838),
    [anon_sym_UR_DQUOTE] = ACTIONS(2838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2838),
    [anon_sym_co_await] = ACTIONS(2836),
    [anon_sym_new] = ACTIONS(2836),
    [anon_sym_requires] = ACTIONS(2836),
    [sym_this] = ACTIONS(2836),
    [anon_sym_discard] = ACTIONS(2836),
    [anon_sym_precise] = ACTIONS(2836),
    [anon_sym_shared] = ACTIONS(2836),
    [anon_sym_groupshared] = ACTIONS(2836),
    [anon_sym_uniform] = ACTIONS(2836),
    [anon_sym_row_major] = ACTIONS(2836),
    [anon_sym_column_major] = ACTIONS(2836),
    [anon_sym_globallycoherent] = ACTIONS(2836),
    [anon_sym_centroid] = ACTIONS(2836),
    [anon_sym_noperspective] = ACTIONS(2836),
    [anon_sym_nointerpolation] = ACTIONS(2836),
    [anon_sym_sample] = ACTIONS(2836),
    [anon_sym_linear] = ACTIONS(2836),
    [anon_sym_snorm] = ACTIONS(2836),
    [anon_sym_unorm] = ACTIONS(2836),
    [anon_sym_point] = ACTIONS(2836),
    [anon_sym_line] = ACTIONS(2836),
    [anon_sym_triangleadj] = ACTIONS(2836),
    [anon_sym_lineadj] = ACTIONS(2836),
    [anon_sym_triangle] = ACTIONS(2836),
    [anon_sym_cbuffer] = ACTIONS(2836),
    [anon_sym_interface] = ACTIONS(2836),
    [anon_sym_extension] = ACTIONS(2836),
  },
  [281] = {
    [sym_identifier] = ACTIONS(2842),
    [aux_sym_preproc_include_token1] = ACTIONS(2842),
    [aux_sym_preproc_def_token1] = ACTIONS(2842),
    [aux_sym_preproc_if_token1] = ACTIONS(2842),
    [aux_sym_preproc_if_token2] = ACTIONS(2842),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2842),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2842),
    [aux_sym_preproc_else_token1] = ACTIONS(2842),
    [aux_sym_preproc_elif_token1] = ACTIONS(2842),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2842),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2842),
    [sym_preproc_directive] = ACTIONS(2842),
    [anon_sym_LPAREN2] = ACTIONS(2844),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_TILDE] = ACTIONS(2844),
    [anon_sym_DASH] = ACTIONS(2842),
    [anon_sym_PLUS] = ACTIONS(2842),
    [anon_sym_STAR] = ACTIONS(2844),
    [anon_sym_AMP_AMP] = ACTIONS(2844),
    [anon_sym_AMP] = ACTIONS(2842),
    [anon_sym_SEMI] = ACTIONS(2844),
    [anon_sym___extension__] = ACTIONS(2842),
    [anon_sym_typedef] = ACTIONS(2842),
    [anon_sym_in] = ACTIONS(2842),
    [anon_sym_out] = ACTIONS(2842),
    [anon_sym_inout] = ACTIONS(2842),
    [anon_sym_extern] = ACTIONS(2842),
    [anon_sym___attribute__] = ACTIONS(2842),
    [anon_sym_COLON_COLON] = ACTIONS(2844),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2844),
    [anon_sym___declspec] = ACTIONS(2842),
    [anon_sym___based] = ACTIONS(2842),
    [anon_sym___cdecl] = ACTIONS(2842),
    [anon_sym___clrcall] = ACTIONS(2842),
    [anon_sym___stdcall] = ACTIONS(2842),
    [anon_sym___fastcall] = ACTIONS(2842),
    [anon_sym___thiscall] = ACTIONS(2842),
    [anon_sym___vectorcall] = ACTIONS(2842),
    [anon_sym_LBRACE] = ACTIONS(2844),
    [anon_sym_signed] = ACTIONS(2842),
    [anon_sym_unsigned] = ACTIONS(2842),
    [anon_sym_long] = ACTIONS(2842),
    [anon_sym_short] = ACTIONS(2842),
    [anon_sym_LBRACK] = ACTIONS(2842),
    [anon_sym_static] = ACTIONS(2842),
    [anon_sym_register] = ACTIONS(2842),
    [anon_sym_inline] = ACTIONS(2842),
    [anon_sym___inline] = ACTIONS(2842),
    [anon_sym___inline__] = ACTIONS(2842),
    [anon_sym___forceinline] = ACTIONS(2842),
    [anon_sym_thread_local] = ACTIONS(2842),
    [anon_sym___thread] = ACTIONS(2842),
    [anon_sym_const] = ACTIONS(2842),
    [anon_sym_constexpr] = ACTIONS(2842),
    [anon_sym_volatile] = ACTIONS(2842),
    [anon_sym_restrict] = ACTIONS(2842),
    [anon_sym___restrict__] = ACTIONS(2842),
    [anon_sym__Atomic] = ACTIONS(2842),
    [anon_sym__Noreturn] = ACTIONS(2842),
    [anon_sym_noreturn] = ACTIONS(2842),
    [anon_sym_mutable] = ACTIONS(2842),
    [anon_sym_constinit] = ACTIONS(2842),
    [anon_sym_consteval] = ACTIONS(2842),
    [anon_sym_alignas] = ACTIONS(2842),
    [anon_sym__Alignas] = ACTIONS(2842),
    [sym_primitive_type] = ACTIONS(2842),
    [anon_sym_enum] = ACTIONS(2842),
    [anon_sym_class] = ACTIONS(2842),
    [anon_sym_struct] = ACTIONS(2842),
    [anon_sym_union] = ACTIONS(2842),
    [anon_sym_if] = ACTIONS(2842),
    [anon_sym_else] = ACTIONS(2842),
    [anon_sym_switch] = ACTIONS(2842),
    [anon_sym_case] = ACTIONS(2842),
    [anon_sym_default] = ACTIONS(2842),
    [anon_sym_while] = ACTIONS(2842),
    [anon_sym_do] = ACTIONS(2842),
    [anon_sym_for] = ACTIONS(2842),
    [anon_sym_return] = ACTIONS(2842),
    [anon_sym_break] = ACTIONS(2842),
    [anon_sym_continue] = ACTIONS(2842),
    [anon_sym_goto] = ACTIONS(2842),
    [anon_sym___try] = ACTIONS(2842),
    [anon_sym___leave] = ACTIONS(2842),
    [anon_sym_not] = ACTIONS(2842),
    [anon_sym_compl] = ACTIONS(2842),
    [anon_sym_DASH_DASH] = ACTIONS(2844),
    [anon_sym_PLUS_PLUS] = ACTIONS(2844),
    [anon_sym_sizeof] = ACTIONS(2842),
    [anon_sym___alignof__] = ACTIONS(2842),
    [anon_sym___alignof] = ACTIONS(2842),
    [anon_sym__alignof] = ACTIONS(2842),
    [anon_sym_alignof] = ACTIONS(2842),
    [anon_sym__Alignof] = ACTIONS(2842),
    [anon_sym_offsetof] = ACTIONS(2842),
    [anon_sym__Generic] = ACTIONS(2842),
    [anon_sym_asm] = ACTIONS(2842),
    [anon_sym___asm__] = ACTIONS(2842),
    [sym_number_literal] = ACTIONS(2844),
    [anon_sym_L_SQUOTE] = ACTIONS(2844),
    [anon_sym_u_SQUOTE] = ACTIONS(2844),
    [anon_sym_U_SQUOTE] = ACTIONS(2844),
    [anon_sym_u8_SQUOTE] = ACTIONS(2844),
    [anon_sym_SQUOTE] = ACTIONS(2844),
    [anon_sym_L_DQUOTE] = ACTIONS(2844),
    [anon_sym_u_DQUOTE] = ACTIONS(2844),
    [anon_sym_U_DQUOTE] = ACTIONS(2844),
    [anon_sym_u8_DQUOTE] = ACTIONS(2844),
    [anon_sym_DQUOTE] = ACTIONS(2844),
    [sym_true] = ACTIONS(2842),
    [sym_false] = ACTIONS(2842),
    [anon_sym_NULL] = ACTIONS(2842),
    [anon_sym_nullptr] = ACTIONS(2842),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2842),
    [anon_sym_let] = ACTIONS(2842),
    [anon_sym_This] = ACTIONS(2842),
    [anon_sym_decltype] = ACTIONS(2842),
    [sym_virtual] = ACTIONS(2842),
    [anon_sym_explicit] = ACTIONS(2842),
    [anon_sym_typename] = ACTIONS(2842),
    [anon_sym_template] = ACTIONS(2842),
    [anon_sym_operator] = ACTIONS(2842),
    [anon_sym_try] = ACTIONS(2842),
    [anon_sym_delete] = ACTIONS(2842),
    [anon_sym_throw] = ACTIONS(2842),
    [anon_sym_namespace] = ACTIONS(2842),
    [anon_sym_using] = ACTIONS(2842),
    [anon_sym_static_assert] = ACTIONS(2842),
    [anon_sym_concept] = ACTIONS(2842),
    [anon_sym_co_return] = ACTIONS(2842),
    [anon_sym_co_yield] = ACTIONS(2842),
    [anon_sym_catch] = ACTIONS(2842),
    [anon_sym_R_DQUOTE] = ACTIONS(2844),
    [anon_sym_LR_DQUOTE] = ACTIONS(2844),
    [anon_sym_uR_DQUOTE] = ACTIONS(2844),
    [anon_sym_UR_DQUOTE] = ACTIONS(2844),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2844),
    [anon_sym_co_await] = ACTIONS(2842),
    [anon_sym_new] = ACTIONS(2842),
    [anon_sym_requires] = ACTIONS(2842),
    [sym_this] = ACTIONS(2842),
    [anon_sym_discard] = ACTIONS(2842),
    [anon_sym_precise] = ACTIONS(2842),
    [anon_sym_shared] = ACTIONS(2842),
    [anon_sym_groupshared] = ACTIONS(2842),
    [anon_sym_uniform] = ACTIONS(2842),
    [anon_sym_row_major] = ACTIONS(2842),
    [anon_sym_column_major] = ACTIONS(2842),
    [anon_sym_globallycoherent] = ACTIONS(2842),
    [anon_sym_centroid] = ACTIONS(2842),
    [anon_sym_noperspective] = ACTIONS(2842),
    [anon_sym_nointerpolation] = ACTIONS(2842),
    [anon_sym_sample] = ACTIONS(2842),
    [anon_sym_linear] = ACTIONS(2842),
    [anon_sym_snorm] = ACTIONS(2842),
    [anon_sym_unorm] = ACTIONS(2842),
    [anon_sym_point] = ACTIONS(2842),
    [anon_sym_line] = ACTIONS(2842),
    [anon_sym_triangleadj] = ACTIONS(2842),
    [anon_sym_lineadj] = ACTIONS(2842),
    [anon_sym_triangle] = ACTIONS(2842),
    [anon_sym_cbuffer] = ACTIONS(2842),
    [anon_sym_interface] = ACTIONS(2842),
    [anon_sym_extension] = ACTIONS(2842),
  },
  [282] = {
    [sym_identifier] = ACTIONS(2355),
    [aux_sym_preproc_include_token1] = ACTIONS(2355),
    [aux_sym_preproc_def_token1] = ACTIONS(2355),
    [aux_sym_preproc_if_token1] = ACTIONS(2355),
    [aux_sym_preproc_if_token2] = ACTIONS(2355),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2355),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2355),
    [aux_sym_preproc_else_token1] = ACTIONS(2355),
    [aux_sym_preproc_elif_token1] = ACTIONS(2355),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2355),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2355),
    [sym_preproc_directive] = ACTIONS(2355),
    [anon_sym_LPAREN2] = ACTIONS(2353),
    [anon_sym_BANG] = ACTIONS(2353),
    [anon_sym_TILDE] = ACTIONS(2353),
    [anon_sym_DASH] = ACTIONS(2355),
    [anon_sym_PLUS] = ACTIONS(2355),
    [anon_sym_STAR] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(2353),
    [anon_sym_AMP] = ACTIONS(2355),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym___extension__] = ACTIONS(2355),
    [anon_sym_typedef] = ACTIONS(2355),
    [anon_sym_in] = ACTIONS(2355),
    [anon_sym_out] = ACTIONS(2355),
    [anon_sym_inout] = ACTIONS(2355),
    [anon_sym_extern] = ACTIONS(2355),
    [anon_sym___attribute__] = ACTIONS(2355),
    [anon_sym_COLON_COLON] = ACTIONS(2353),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2353),
    [anon_sym___declspec] = ACTIONS(2355),
    [anon_sym___based] = ACTIONS(2355),
    [anon_sym___cdecl] = ACTIONS(2355),
    [anon_sym___clrcall] = ACTIONS(2355),
    [anon_sym___stdcall] = ACTIONS(2355),
    [anon_sym___fastcall] = ACTIONS(2355),
    [anon_sym___thiscall] = ACTIONS(2355),
    [anon_sym___vectorcall] = ACTIONS(2355),
    [anon_sym_LBRACE] = ACTIONS(2353),
    [anon_sym_signed] = ACTIONS(2355),
    [anon_sym_unsigned] = ACTIONS(2355),
    [anon_sym_long] = ACTIONS(2355),
    [anon_sym_short] = ACTIONS(2355),
    [anon_sym_LBRACK] = ACTIONS(2355),
    [anon_sym_static] = ACTIONS(2355),
    [anon_sym_register] = ACTIONS(2355),
    [anon_sym_inline] = ACTIONS(2355),
    [anon_sym___inline] = ACTIONS(2355),
    [anon_sym___inline__] = ACTIONS(2355),
    [anon_sym___forceinline] = ACTIONS(2355),
    [anon_sym_thread_local] = ACTIONS(2355),
    [anon_sym___thread] = ACTIONS(2355),
    [anon_sym_const] = ACTIONS(2355),
    [anon_sym_constexpr] = ACTIONS(2355),
    [anon_sym_volatile] = ACTIONS(2355),
    [anon_sym_restrict] = ACTIONS(2355),
    [anon_sym___restrict__] = ACTIONS(2355),
    [anon_sym__Atomic] = ACTIONS(2355),
    [anon_sym__Noreturn] = ACTIONS(2355),
    [anon_sym_noreturn] = ACTIONS(2355),
    [anon_sym_mutable] = ACTIONS(2355),
    [anon_sym_constinit] = ACTIONS(2355),
    [anon_sym_consteval] = ACTIONS(2355),
    [anon_sym_alignas] = ACTIONS(2355),
    [anon_sym__Alignas] = ACTIONS(2355),
    [sym_primitive_type] = ACTIONS(2355),
    [anon_sym_enum] = ACTIONS(2355),
    [anon_sym_class] = ACTIONS(2355),
    [anon_sym_struct] = ACTIONS(2355),
    [anon_sym_union] = ACTIONS(2355),
    [anon_sym_if] = ACTIONS(2355),
    [anon_sym_else] = ACTIONS(2355),
    [anon_sym_switch] = ACTIONS(2355),
    [anon_sym_case] = ACTIONS(2355),
    [anon_sym_default] = ACTIONS(2355),
    [anon_sym_while] = ACTIONS(2355),
    [anon_sym_do] = ACTIONS(2355),
    [anon_sym_for] = ACTIONS(2355),
    [anon_sym_return] = ACTIONS(2355),
    [anon_sym_break] = ACTIONS(2355),
    [anon_sym_continue] = ACTIONS(2355),
    [anon_sym_goto] = ACTIONS(2355),
    [anon_sym___try] = ACTIONS(2355),
    [anon_sym___leave] = ACTIONS(2355),
    [anon_sym_not] = ACTIONS(2355),
    [anon_sym_compl] = ACTIONS(2355),
    [anon_sym_DASH_DASH] = ACTIONS(2353),
    [anon_sym_PLUS_PLUS] = ACTIONS(2353),
    [anon_sym_sizeof] = ACTIONS(2355),
    [anon_sym___alignof__] = ACTIONS(2355),
    [anon_sym___alignof] = ACTIONS(2355),
    [anon_sym__alignof] = ACTIONS(2355),
    [anon_sym_alignof] = ACTIONS(2355),
    [anon_sym__Alignof] = ACTIONS(2355),
    [anon_sym_offsetof] = ACTIONS(2355),
    [anon_sym__Generic] = ACTIONS(2355),
    [anon_sym_asm] = ACTIONS(2355),
    [anon_sym___asm__] = ACTIONS(2355),
    [sym_number_literal] = ACTIONS(2353),
    [anon_sym_L_SQUOTE] = ACTIONS(2353),
    [anon_sym_u_SQUOTE] = ACTIONS(2353),
    [anon_sym_U_SQUOTE] = ACTIONS(2353),
    [anon_sym_u8_SQUOTE] = ACTIONS(2353),
    [anon_sym_SQUOTE] = ACTIONS(2353),
    [anon_sym_L_DQUOTE] = ACTIONS(2353),
    [anon_sym_u_DQUOTE] = ACTIONS(2353),
    [anon_sym_U_DQUOTE] = ACTIONS(2353),
    [anon_sym_u8_DQUOTE] = ACTIONS(2353),
    [anon_sym_DQUOTE] = ACTIONS(2353),
    [sym_true] = ACTIONS(2355),
    [sym_false] = ACTIONS(2355),
    [anon_sym_NULL] = ACTIONS(2355),
    [anon_sym_nullptr] = ACTIONS(2355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2355),
    [anon_sym_let] = ACTIONS(2355),
    [anon_sym_This] = ACTIONS(2355),
    [anon_sym_decltype] = ACTIONS(2355),
    [sym_virtual] = ACTIONS(2355),
    [anon_sym_explicit] = ACTIONS(2355),
    [anon_sym_typename] = ACTIONS(2355),
    [anon_sym_template] = ACTIONS(2355),
    [anon_sym_operator] = ACTIONS(2355),
    [anon_sym_try] = ACTIONS(2355),
    [anon_sym_delete] = ACTIONS(2355),
    [anon_sym_throw] = ACTIONS(2355),
    [anon_sym_namespace] = ACTIONS(2355),
    [anon_sym_using] = ACTIONS(2355),
    [anon_sym_static_assert] = ACTIONS(2355),
    [anon_sym_concept] = ACTIONS(2355),
    [anon_sym_co_return] = ACTIONS(2355),
    [anon_sym_co_yield] = ACTIONS(2355),
    [anon_sym_catch] = ACTIONS(2355),
    [anon_sym_R_DQUOTE] = ACTIONS(2353),
    [anon_sym_LR_DQUOTE] = ACTIONS(2353),
    [anon_sym_uR_DQUOTE] = ACTIONS(2353),
    [anon_sym_UR_DQUOTE] = ACTIONS(2353),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2353),
    [anon_sym_co_await] = ACTIONS(2355),
    [anon_sym_new] = ACTIONS(2355),
    [anon_sym_requires] = ACTIONS(2355),
    [sym_this] = ACTIONS(2355),
    [anon_sym_discard] = ACTIONS(2355),
    [anon_sym_precise] = ACTIONS(2355),
    [anon_sym_shared] = ACTIONS(2355),
    [anon_sym_groupshared] = ACTIONS(2355),
    [anon_sym_uniform] = ACTIONS(2355),
    [anon_sym_row_major] = ACTIONS(2355),
    [anon_sym_column_major] = ACTIONS(2355),
    [anon_sym_globallycoherent] = ACTIONS(2355),
    [anon_sym_centroid] = ACTIONS(2355),
    [anon_sym_noperspective] = ACTIONS(2355),
    [anon_sym_nointerpolation] = ACTIONS(2355),
    [anon_sym_sample] = ACTIONS(2355),
    [anon_sym_linear] = ACTIONS(2355),
    [anon_sym_snorm] = ACTIONS(2355),
    [anon_sym_unorm] = ACTIONS(2355),
    [anon_sym_point] = ACTIONS(2355),
    [anon_sym_line] = ACTIONS(2355),
    [anon_sym_triangleadj] = ACTIONS(2355),
    [anon_sym_lineadj] = ACTIONS(2355),
    [anon_sym_triangle] = ACTIONS(2355),
    [anon_sym_cbuffer] = ACTIONS(2355),
    [anon_sym_interface] = ACTIONS(2355),
    [anon_sym_extension] = ACTIONS(2355),
  },
  [283] = {
    [sym_else_clause] = STATE(407),
    [sym_identifier] = ACTIONS(2846),
    [aux_sym_preproc_include_token1] = ACTIONS(2846),
    [aux_sym_preproc_def_token1] = ACTIONS(2846),
    [aux_sym_preproc_if_token1] = ACTIONS(2846),
    [aux_sym_preproc_if_token2] = ACTIONS(2846),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2846),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2846),
    [aux_sym_preproc_else_token1] = ACTIONS(2846),
    [aux_sym_preproc_elif_token1] = ACTIONS(2846),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2846),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2846),
    [sym_preproc_directive] = ACTIONS(2846),
    [anon_sym_LPAREN2] = ACTIONS(2848),
    [anon_sym_BANG] = ACTIONS(2848),
    [anon_sym_TILDE] = ACTIONS(2848),
    [anon_sym_DASH] = ACTIONS(2846),
    [anon_sym_PLUS] = ACTIONS(2846),
    [anon_sym_STAR] = ACTIONS(2848),
    [anon_sym_AMP_AMP] = ACTIONS(2848),
    [anon_sym_AMP] = ACTIONS(2846),
    [anon_sym_SEMI] = ACTIONS(2848),
    [anon_sym___extension__] = ACTIONS(2846),
    [anon_sym_typedef] = ACTIONS(2846),
    [anon_sym_in] = ACTIONS(2846),
    [anon_sym_out] = ACTIONS(2846),
    [anon_sym_inout] = ACTIONS(2846),
    [anon_sym_extern] = ACTIONS(2846),
    [anon_sym___attribute__] = ACTIONS(2846),
    [anon_sym_COLON_COLON] = ACTIONS(2848),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2848),
    [anon_sym___declspec] = ACTIONS(2846),
    [anon_sym___based] = ACTIONS(2846),
    [anon_sym___cdecl] = ACTIONS(2846),
    [anon_sym___clrcall] = ACTIONS(2846),
    [anon_sym___stdcall] = ACTIONS(2846),
    [anon_sym___fastcall] = ACTIONS(2846),
    [anon_sym___thiscall] = ACTIONS(2846),
    [anon_sym___vectorcall] = ACTIONS(2846),
    [anon_sym_LBRACE] = ACTIONS(2848),
    [anon_sym_signed] = ACTIONS(2846),
    [anon_sym_unsigned] = ACTIONS(2846),
    [anon_sym_long] = ACTIONS(2846),
    [anon_sym_short] = ACTIONS(2846),
    [anon_sym_LBRACK] = ACTIONS(2846),
    [anon_sym_static] = ACTIONS(2846),
    [anon_sym_register] = ACTIONS(2846),
    [anon_sym_inline] = ACTIONS(2846),
    [anon_sym___inline] = ACTIONS(2846),
    [anon_sym___inline__] = ACTIONS(2846),
    [anon_sym___forceinline] = ACTIONS(2846),
    [anon_sym_thread_local] = ACTIONS(2846),
    [anon_sym___thread] = ACTIONS(2846),
    [anon_sym_const] = ACTIONS(2846),
    [anon_sym_constexpr] = ACTIONS(2846),
    [anon_sym_volatile] = ACTIONS(2846),
    [anon_sym_restrict] = ACTIONS(2846),
    [anon_sym___restrict__] = ACTIONS(2846),
    [anon_sym__Atomic] = ACTIONS(2846),
    [anon_sym__Noreturn] = ACTIONS(2846),
    [anon_sym_noreturn] = ACTIONS(2846),
    [anon_sym_mutable] = ACTIONS(2846),
    [anon_sym_constinit] = ACTIONS(2846),
    [anon_sym_consteval] = ACTIONS(2846),
    [anon_sym_alignas] = ACTIONS(2846),
    [anon_sym__Alignas] = ACTIONS(2846),
    [sym_primitive_type] = ACTIONS(2846),
    [anon_sym_enum] = ACTIONS(2846),
    [anon_sym_class] = ACTIONS(2846),
    [anon_sym_struct] = ACTIONS(2846),
    [anon_sym_union] = ACTIONS(2846),
    [anon_sym_if] = ACTIONS(2846),
    [anon_sym_else] = ACTIONS(2840),
    [anon_sym_switch] = ACTIONS(2846),
    [anon_sym_case] = ACTIONS(2846),
    [anon_sym_default] = ACTIONS(2846),
    [anon_sym_while] = ACTIONS(2846),
    [anon_sym_do] = ACTIONS(2846),
    [anon_sym_for] = ACTIONS(2846),
    [anon_sym_return] = ACTIONS(2846),
    [anon_sym_break] = ACTIONS(2846),
    [anon_sym_continue] = ACTIONS(2846),
    [anon_sym_goto] = ACTIONS(2846),
    [anon_sym___try] = ACTIONS(2846),
    [anon_sym___leave] = ACTIONS(2846),
    [anon_sym_not] = ACTIONS(2846),
    [anon_sym_compl] = ACTIONS(2846),
    [anon_sym_DASH_DASH] = ACTIONS(2848),
    [anon_sym_PLUS_PLUS] = ACTIONS(2848),
    [anon_sym_sizeof] = ACTIONS(2846),
    [anon_sym___alignof__] = ACTIONS(2846),
    [anon_sym___alignof] = ACTIONS(2846),
    [anon_sym__alignof] = ACTIONS(2846),
    [anon_sym_alignof] = ACTIONS(2846),
    [anon_sym__Alignof] = ACTIONS(2846),
    [anon_sym_offsetof] = ACTIONS(2846),
    [anon_sym__Generic] = ACTIONS(2846),
    [anon_sym_asm] = ACTIONS(2846),
    [anon_sym___asm__] = ACTIONS(2846),
    [sym_number_literal] = ACTIONS(2848),
    [anon_sym_L_SQUOTE] = ACTIONS(2848),
    [anon_sym_u_SQUOTE] = ACTIONS(2848),
    [anon_sym_U_SQUOTE] = ACTIONS(2848),
    [anon_sym_u8_SQUOTE] = ACTIONS(2848),
    [anon_sym_SQUOTE] = ACTIONS(2848),
    [anon_sym_L_DQUOTE] = ACTIONS(2848),
    [anon_sym_u_DQUOTE] = ACTIONS(2848),
    [anon_sym_U_DQUOTE] = ACTIONS(2848),
    [anon_sym_u8_DQUOTE] = ACTIONS(2848),
    [anon_sym_DQUOTE] = ACTIONS(2848),
    [sym_true] = ACTIONS(2846),
    [sym_false] = ACTIONS(2846),
    [anon_sym_NULL] = ACTIONS(2846),
    [anon_sym_nullptr] = ACTIONS(2846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2846),
    [anon_sym_let] = ACTIONS(2846),
    [anon_sym_This] = ACTIONS(2846),
    [anon_sym_decltype] = ACTIONS(2846),
    [sym_virtual] = ACTIONS(2846),
    [anon_sym_explicit] = ACTIONS(2846),
    [anon_sym_typename] = ACTIONS(2846),
    [anon_sym_template] = ACTIONS(2846),
    [anon_sym_operator] = ACTIONS(2846),
    [anon_sym_try] = ACTIONS(2846),
    [anon_sym_delete] = ACTIONS(2846),
    [anon_sym_throw] = ACTIONS(2846),
    [anon_sym_namespace] = ACTIONS(2846),
    [anon_sym_using] = ACTIONS(2846),
    [anon_sym_static_assert] = ACTIONS(2846),
    [anon_sym_concept] = ACTIONS(2846),
    [anon_sym_co_return] = ACTIONS(2846),
    [anon_sym_co_yield] = ACTIONS(2846),
    [anon_sym_R_DQUOTE] = ACTIONS(2848),
    [anon_sym_LR_DQUOTE] = ACTIONS(2848),
    [anon_sym_uR_DQUOTE] = ACTIONS(2848),
    [anon_sym_UR_DQUOTE] = ACTIONS(2848),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2848),
    [anon_sym_co_await] = ACTIONS(2846),
    [anon_sym_new] = ACTIONS(2846),
    [anon_sym_requires] = ACTIONS(2846),
    [sym_this] = ACTIONS(2846),
    [anon_sym_discard] = ACTIONS(2846),
    [anon_sym_precise] = ACTIONS(2846),
    [anon_sym_shared] = ACTIONS(2846),
    [anon_sym_groupshared] = ACTIONS(2846),
    [anon_sym_uniform] = ACTIONS(2846),
    [anon_sym_row_major] = ACTIONS(2846),
    [anon_sym_column_major] = ACTIONS(2846),
    [anon_sym_globallycoherent] = ACTIONS(2846),
    [anon_sym_centroid] = ACTIONS(2846),
    [anon_sym_noperspective] = ACTIONS(2846),
    [anon_sym_nointerpolation] = ACTIONS(2846),
    [anon_sym_sample] = ACTIONS(2846),
    [anon_sym_linear] = ACTIONS(2846),
    [anon_sym_snorm] = ACTIONS(2846),
    [anon_sym_unorm] = ACTIONS(2846),
    [anon_sym_point] = ACTIONS(2846),
    [anon_sym_line] = ACTIONS(2846),
    [anon_sym_triangleadj] = ACTIONS(2846),
    [anon_sym_lineadj] = ACTIONS(2846),
    [anon_sym_triangle] = ACTIONS(2846),
    [anon_sym_cbuffer] = ACTIONS(2846),
    [anon_sym_interface] = ACTIONS(2846),
    [anon_sym_extension] = ACTIONS(2846),
  },
  [284] = {
    [sym_else_clause] = STATE(353),
    [sym_identifier] = ACTIONS(2850),
    [aux_sym_preproc_include_token1] = ACTIONS(2850),
    [aux_sym_preproc_def_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token2] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2850),
    [aux_sym_preproc_else_token1] = ACTIONS(2850),
    [aux_sym_preproc_elif_token1] = ACTIONS(2850),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2850),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2850),
    [sym_preproc_directive] = ACTIONS(2850),
    [anon_sym_LPAREN2] = ACTIONS(2852),
    [anon_sym_BANG] = ACTIONS(2852),
    [anon_sym_TILDE] = ACTIONS(2852),
    [anon_sym_DASH] = ACTIONS(2850),
    [anon_sym_PLUS] = ACTIONS(2850),
    [anon_sym_STAR] = ACTIONS(2852),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_AMP] = ACTIONS(2850),
    [anon_sym_SEMI] = ACTIONS(2852),
    [anon_sym___extension__] = ACTIONS(2850),
    [anon_sym_typedef] = ACTIONS(2850),
    [anon_sym_in] = ACTIONS(2850),
    [anon_sym_out] = ACTIONS(2850),
    [anon_sym_inout] = ACTIONS(2850),
    [anon_sym_extern] = ACTIONS(2850),
    [anon_sym___attribute__] = ACTIONS(2850),
    [anon_sym_COLON_COLON] = ACTIONS(2852),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2852),
    [anon_sym___declspec] = ACTIONS(2850),
    [anon_sym___based] = ACTIONS(2850),
    [anon_sym___cdecl] = ACTIONS(2850),
    [anon_sym___clrcall] = ACTIONS(2850),
    [anon_sym___stdcall] = ACTIONS(2850),
    [anon_sym___fastcall] = ACTIONS(2850),
    [anon_sym___thiscall] = ACTIONS(2850),
    [anon_sym___vectorcall] = ACTIONS(2850),
    [anon_sym_LBRACE] = ACTIONS(2852),
    [anon_sym_signed] = ACTIONS(2850),
    [anon_sym_unsigned] = ACTIONS(2850),
    [anon_sym_long] = ACTIONS(2850),
    [anon_sym_short] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2850),
    [anon_sym_static] = ACTIONS(2850),
    [anon_sym_register] = ACTIONS(2850),
    [anon_sym_inline] = ACTIONS(2850),
    [anon_sym___inline] = ACTIONS(2850),
    [anon_sym___inline__] = ACTIONS(2850),
    [anon_sym___forceinline] = ACTIONS(2850),
    [anon_sym_thread_local] = ACTIONS(2850),
    [anon_sym___thread] = ACTIONS(2850),
    [anon_sym_const] = ACTIONS(2850),
    [anon_sym_constexpr] = ACTIONS(2850),
    [anon_sym_volatile] = ACTIONS(2850),
    [anon_sym_restrict] = ACTIONS(2850),
    [anon_sym___restrict__] = ACTIONS(2850),
    [anon_sym__Atomic] = ACTIONS(2850),
    [anon_sym__Noreturn] = ACTIONS(2850),
    [anon_sym_noreturn] = ACTIONS(2850),
    [anon_sym_mutable] = ACTIONS(2850),
    [anon_sym_constinit] = ACTIONS(2850),
    [anon_sym_consteval] = ACTIONS(2850),
    [anon_sym_alignas] = ACTIONS(2850),
    [anon_sym__Alignas] = ACTIONS(2850),
    [sym_primitive_type] = ACTIONS(2850),
    [anon_sym_enum] = ACTIONS(2850),
    [anon_sym_class] = ACTIONS(2850),
    [anon_sym_struct] = ACTIONS(2850),
    [anon_sym_union] = ACTIONS(2850),
    [anon_sym_if] = ACTIONS(2850),
    [anon_sym_else] = ACTIONS(2840),
    [anon_sym_switch] = ACTIONS(2850),
    [anon_sym_case] = ACTIONS(2850),
    [anon_sym_default] = ACTIONS(2850),
    [anon_sym_while] = ACTIONS(2850),
    [anon_sym_do] = ACTIONS(2850),
    [anon_sym_for] = ACTIONS(2850),
    [anon_sym_return] = ACTIONS(2850),
    [anon_sym_break] = ACTIONS(2850),
    [anon_sym_continue] = ACTIONS(2850),
    [anon_sym_goto] = ACTIONS(2850),
    [anon_sym___try] = ACTIONS(2850),
    [anon_sym___leave] = ACTIONS(2850),
    [anon_sym_not] = ACTIONS(2850),
    [anon_sym_compl] = ACTIONS(2850),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_sizeof] = ACTIONS(2850),
    [anon_sym___alignof__] = ACTIONS(2850),
    [anon_sym___alignof] = ACTIONS(2850),
    [anon_sym__alignof] = ACTIONS(2850),
    [anon_sym_alignof] = ACTIONS(2850),
    [anon_sym__Alignof] = ACTIONS(2850),
    [anon_sym_offsetof] = ACTIONS(2850),
    [anon_sym__Generic] = ACTIONS(2850),
    [anon_sym_asm] = ACTIONS(2850),
    [anon_sym___asm__] = ACTIONS(2850),
    [sym_number_literal] = ACTIONS(2852),
    [anon_sym_L_SQUOTE] = ACTIONS(2852),
    [anon_sym_u_SQUOTE] = ACTIONS(2852),
    [anon_sym_U_SQUOTE] = ACTIONS(2852),
    [anon_sym_u8_SQUOTE] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2852),
    [anon_sym_L_DQUOTE] = ACTIONS(2852),
    [anon_sym_u_DQUOTE] = ACTIONS(2852),
    [anon_sym_U_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8_DQUOTE] = ACTIONS(2852),
    [anon_sym_DQUOTE] = ACTIONS(2852),
    [sym_true] = ACTIONS(2850),
    [sym_false] = ACTIONS(2850),
    [anon_sym_NULL] = ACTIONS(2850),
    [anon_sym_nullptr] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2850),
    [anon_sym_let] = ACTIONS(2850),
    [anon_sym_This] = ACTIONS(2850),
    [anon_sym_decltype] = ACTIONS(2850),
    [sym_virtual] = ACTIONS(2850),
    [anon_sym_explicit] = ACTIONS(2850),
    [anon_sym_typename] = ACTIONS(2850),
    [anon_sym_template] = ACTIONS(2850),
    [anon_sym_operator] = ACTIONS(2850),
    [anon_sym_try] = ACTIONS(2850),
    [anon_sym_delete] = ACTIONS(2850),
    [anon_sym_throw] = ACTIONS(2850),
    [anon_sym_namespace] = ACTIONS(2850),
    [anon_sym_using] = ACTIONS(2850),
    [anon_sym_static_assert] = ACTIONS(2850),
    [anon_sym_concept] = ACTIONS(2850),
    [anon_sym_co_return] = ACTIONS(2850),
    [anon_sym_co_yield] = ACTIONS(2850),
    [anon_sym_R_DQUOTE] = ACTIONS(2852),
    [anon_sym_LR_DQUOTE] = ACTIONS(2852),
    [anon_sym_uR_DQUOTE] = ACTIONS(2852),
    [anon_sym_UR_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2852),
    [anon_sym_co_await] = ACTIONS(2850),
    [anon_sym_new] = ACTIONS(2850),
    [anon_sym_requires] = ACTIONS(2850),
    [sym_this] = ACTIONS(2850),
    [anon_sym_discard] = ACTIONS(2850),
    [anon_sym_precise] = ACTIONS(2850),
    [anon_sym_shared] = ACTIONS(2850),
    [anon_sym_groupshared] = ACTIONS(2850),
    [anon_sym_uniform] = ACTIONS(2850),
    [anon_sym_row_major] = ACTIONS(2850),
    [anon_sym_column_major] = ACTIONS(2850),
    [anon_sym_globallycoherent] = ACTIONS(2850),
    [anon_sym_centroid] = ACTIONS(2850),
    [anon_sym_noperspective] = ACTIONS(2850),
    [anon_sym_nointerpolation] = ACTIONS(2850),
    [anon_sym_sample] = ACTIONS(2850),
    [anon_sym_linear] = ACTIONS(2850),
    [anon_sym_snorm] = ACTIONS(2850),
    [anon_sym_unorm] = ACTIONS(2850),
    [anon_sym_point] = ACTIONS(2850),
    [anon_sym_line] = ACTIONS(2850),
    [anon_sym_triangleadj] = ACTIONS(2850),
    [anon_sym_lineadj] = ACTIONS(2850),
    [anon_sym_triangle] = ACTIONS(2850),
    [anon_sym_cbuffer] = ACTIONS(2850),
    [anon_sym_interface] = ACTIONS(2850),
    [anon_sym_extension] = ACTIONS(2850),
  },
  [285] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(285),
    [ts_builtin_sym_end] = ACTIONS(2854),
    [sym_identifier] = ACTIONS(2856),
    [aux_sym_preproc_include_token1] = ACTIONS(2856),
    [aux_sym_preproc_def_token1] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(2854),
    [anon_sym_RPAREN] = ACTIONS(2854),
    [aux_sym_preproc_if_token1] = ACTIONS(2856),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2856),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2856),
    [sym_preproc_directive] = ACTIONS(2856),
    [anon_sym_LPAREN2] = ACTIONS(2854),
    [anon_sym_BANG] = ACTIONS(2854),
    [anon_sym_TILDE] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(2856),
    [anon_sym_PLUS] = ACTIONS(2856),
    [anon_sym_STAR] = ACTIONS(2854),
    [anon_sym_AMP_AMP] = ACTIONS(2854),
    [anon_sym_AMP] = ACTIONS(2856),
    [anon_sym_SEMI] = ACTIONS(2854),
    [anon_sym___extension__] = ACTIONS(2856),
    [anon_sym_typedef] = ACTIONS(2856),
    [anon_sym_in] = ACTIONS(2856),
    [anon_sym_out] = ACTIONS(2856),
    [anon_sym_inout] = ACTIONS(2856),
    [anon_sym_extern] = ACTIONS(2856),
    [anon_sym___attribute__] = ACTIONS(2856),
    [anon_sym_COLON_COLON] = ACTIONS(2854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2854),
    [anon_sym___declspec] = ACTIONS(2856),
    [anon_sym___based] = ACTIONS(2856),
    [anon_sym___cdecl] = ACTIONS(2856),
    [anon_sym___clrcall] = ACTIONS(2856),
    [anon_sym___stdcall] = ACTIONS(2856),
    [anon_sym___fastcall] = ACTIONS(2856),
    [anon_sym___thiscall] = ACTIONS(2856),
    [anon_sym___vectorcall] = ACTIONS(2856),
    [anon_sym_LBRACE] = ACTIONS(2854),
    [anon_sym_signed] = ACTIONS(2858),
    [anon_sym_unsigned] = ACTIONS(2858),
    [anon_sym_long] = ACTIONS(2858),
    [anon_sym_short] = ACTIONS(2858),
    [anon_sym_LBRACK] = ACTIONS(2856),
    [anon_sym_static] = ACTIONS(2856),
    [anon_sym_register] = ACTIONS(2856),
    [anon_sym_inline] = ACTIONS(2856),
    [anon_sym___inline] = ACTIONS(2856),
    [anon_sym___inline__] = ACTIONS(2856),
    [anon_sym___forceinline] = ACTIONS(2856),
    [anon_sym_thread_local] = ACTIONS(2856),
    [anon_sym___thread] = ACTIONS(2856),
    [anon_sym_const] = ACTIONS(2856),
    [anon_sym_constexpr] = ACTIONS(2856),
    [anon_sym_volatile] = ACTIONS(2856),
    [anon_sym_restrict] = ACTIONS(2856),
    [anon_sym___restrict__] = ACTIONS(2856),
    [anon_sym__Atomic] = ACTIONS(2856),
    [anon_sym__Noreturn] = ACTIONS(2856),
    [anon_sym_noreturn] = ACTIONS(2856),
    [anon_sym_mutable] = ACTIONS(2856),
    [anon_sym_constinit] = ACTIONS(2856),
    [anon_sym_consteval] = ACTIONS(2856),
    [anon_sym_alignas] = ACTIONS(2856),
    [anon_sym__Alignas] = ACTIONS(2856),
    [sym_primitive_type] = ACTIONS(2856),
    [anon_sym_enum] = ACTIONS(2856),
    [anon_sym_class] = ACTIONS(2856),
    [anon_sym_struct] = ACTIONS(2856),
    [anon_sym_union] = ACTIONS(2856),
    [anon_sym_if] = ACTIONS(2856),
    [anon_sym_switch] = ACTIONS(2856),
    [anon_sym_case] = ACTIONS(2856),
    [anon_sym_default] = ACTIONS(2856),
    [anon_sym_while] = ACTIONS(2856),
    [anon_sym_do] = ACTIONS(2856),
    [anon_sym_for] = ACTIONS(2856),
    [anon_sym_return] = ACTIONS(2856),
    [anon_sym_break] = ACTIONS(2856),
    [anon_sym_continue] = ACTIONS(2856),
    [anon_sym_goto] = ACTIONS(2856),
    [anon_sym_not] = ACTIONS(2856),
    [anon_sym_compl] = ACTIONS(2856),
    [anon_sym_DASH_DASH] = ACTIONS(2854),
    [anon_sym_PLUS_PLUS] = ACTIONS(2854),
    [anon_sym_sizeof] = ACTIONS(2856),
    [anon_sym___alignof__] = ACTIONS(2856),
    [anon_sym___alignof] = ACTIONS(2856),
    [anon_sym__alignof] = ACTIONS(2856),
    [anon_sym_alignof] = ACTIONS(2856),
    [anon_sym__Alignof] = ACTIONS(2856),
    [anon_sym_offsetof] = ACTIONS(2856),
    [anon_sym__Generic] = ACTIONS(2856),
    [anon_sym_asm] = ACTIONS(2856),
    [anon_sym___asm__] = ACTIONS(2856),
    [anon_sym_DOT] = ACTIONS(2856),
    [sym_number_literal] = ACTIONS(2854),
    [anon_sym_L_SQUOTE] = ACTIONS(2854),
    [anon_sym_u_SQUOTE] = ACTIONS(2854),
    [anon_sym_U_SQUOTE] = ACTIONS(2854),
    [anon_sym_u8_SQUOTE] = ACTIONS(2854),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_L_DQUOTE] = ACTIONS(2854),
    [anon_sym_u_DQUOTE] = ACTIONS(2854),
    [anon_sym_U_DQUOTE] = ACTIONS(2854),
    [anon_sym_u8_DQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE] = ACTIONS(2854),
    [sym_true] = ACTIONS(2856),
    [sym_false] = ACTIONS(2856),
    [anon_sym_NULL] = ACTIONS(2856),
    [anon_sym_nullptr] = ACTIONS(2856),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2856),
    [anon_sym_let] = ACTIONS(2856),
    [anon_sym_This] = ACTIONS(2856),
    [anon_sym_decltype] = ACTIONS(2856),
    [anon_sym_final] = ACTIONS(2856),
    [anon_sym_override] = ACTIONS(2856),
    [sym_virtual] = ACTIONS(2856),
    [anon_sym_explicit] = ACTIONS(2856),
    [anon_sym_typename] = ACTIONS(2856),
    [anon_sym_template] = ACTIONS(2856),
    [anon_sym_GT2] = ACTIONS(2854),
    [anon_sym_operator] = ACTIONS(2856),
    [anon_sym_try] = ACTIONS(2856),
    [anon_sym_delete] = ACTIONS(2856),
    [anon_sym_throw] = ACTIONS(2856),
    [anon_sym_namespace] = ACTIONS(2856),
    [anon_sym_using] = ACTIONS(2856),
    [anon_sym_static_assert] = ACTIONS(2856),
    [anon_sym_concept] = ACTIONS(2856),
    [anon_sym_co_return] = ACTIONS(2856),
    [anon_sym_co_yield] = ACTIONS(2856),
    [anon_sym_R_DQUOTE] = ACTIONS(2854),
    [anon_sym_LR_DQUOTE] = ACTIONS(2854),
    [anon_sym_uR_DQUOTE] = ACTIONS(2854),
    [anon_sym_UR_DQUOTE] = ACTIONS(2854),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2854),
    [anon_sym_co_await] = ACTIONS(2856),
    [anon_sym_new] = ACTIONS(2856),
    [anon_sym_requires] = ACTIONS(2856),
    [sym_this] = ACTIONS(2856),
    [anon_sym_precise] = ACTIONS(2856),
    [anon_sym_shared] = ACTIONS(2856),
    [anon_sym_groupshared] = ACTIONS(2856),
    [anon_sym_uniform] = ACTIONS(2856),
    [anon_sym_row_major] = ACTIONS(2856),
    [anon_sym_column_major] = ACTIONS(2856),
    [anon_sym_globallycoherent] = ACTIONS(2856),
    [anon_sym_centroid] = ACTIONS(2856),
    [anon_sym_noperspective] = ACTIONS(2856),
    [anon_sym_nointerpolation] = ACTIONS(2856),
    [anon_sym_sample] = ACTIONS(2856),
    [anon_sym_linear] = ACTIONS(2856),
    [anon_sym_snorm] = ACTIONS(2856),
    [anon_sym_unorm] = ACTIONS(2856),
    [anon_sym_point] = ACTIONS(2856),
    [anon_sym_line] = ACTIONS(2856),
    [anon_sym_triangleadj] = ACTIONS(2856),
    [anon_sym_lineadj] = ACTIONS(2856),
    [anon_sym_triangle] = ACTIONS(2856),
    [anon_sym_interface] = ACTIONS(2856),
    [anon_sym_extension] = ACTIONS(2856),
    [anon_sym_where] = ACTIONS(2856),
    [anon_sym___exported] = ACTIONS(2856),
    [anon_sym_import] = ACTIONS(2856),
  },
  [286] = {
    [sym_attribute_specifier] = STATE(428),
    [sym_field_declaration_list] = STATE(973),
    [sym_virtual_specifier] = STATE(8621),
    [sym_base_class_clause] = STATE(9985),
    [ts_builtin_sym_end] = ACTIONS(2685),
    [sym_identifier] = ACTIONS(2683),
    [aux_sym_preproc_include_token1] = ACTIONS(2683),
    [aux_sym_preproc_def_token1] = ACTIONS(2683),
    [aux_sym_preproc_if_token1] = ACTIONS(2683),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2683),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2683),
    [sym_preproc_directive] = ACTIONS(2683),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_BANG] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2683),
    [anon_sym_PLUS] = ACTIONS(2683),
    [anon_sym_STAR] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_COLON] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(2685),
    [anon_sym___extension__] = ACTIONS(2683),
    [anon_sym_typedef] = ACTIONS(2683),
    [anon_sym_in] = ACTIONS(2683),
    [anon_sym_out] = ACTIONS(2683),
    [anon_sym_inout] = ACTIONS(2683),
    [anon_sym_extern] = ACTIONS(2683),
    [anon_sym___attribute__] = ACTIONS(2861),
    [anon_sym_COLON_COLON] = ACTIONS(2685),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2685),
    [anon_sym___declspec] = ACTIONS(2683),
    [anon_sym___based] = ACTIONS(2683),
    [anon_sym___cdecl] = ACTIONS(2683),
    [anon_sym___clrcall] = ACTIONS(2683),
    [anon_sym___stdcall] = ACTIONS(2683),
    [anon_sym___fastcall] = ACTIONS(2683),
    [anon_sym___thiscall] = ACTIONS(2683),
    [anon_sym___vectorcall] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(2538),
    [anon_sym_signed] = ACTIONS(2683),
    [anon_sym_unsigned] = ACTIONS(2683),
    [anon_sym_long] = ACTIONS(2683),
    [anon_sym_short] = ACTIONS(2683),
    [anon_sym_LBRACK] = ACTIONS(2683),
    [anon_sym_static] = ACTIONS(2683),
    [anon_sym_register] = ACTIONS(2683),
    [anon_sym_inline] = ACTIONS(2683),
    [anon_sym___inline] = ACTIONS(2683),
    [anon_sym___inline__] = ACTIONS(2683),
    [anon_sym___forceinline] = ACTIONS(2683),
    [anon_sym_thread_local] = ACTIONS(2683),
    [anon_sym___thread] = ACTIONS(2683),
    [anon_sym_const] = ACTIONS(2683),
    [anon_sym_constexpr] = ACTIONS(2683),
    [anon_sym_volatile] = ACTIONS(2683),
    [anon_sym_restrict] = ACTIONS(2683),
    [anon_sym___restrict__] = ACTIONS(2683),
    [anon_sym__Atomic] = ACTIONS(2683),
    [anon_sym__Noreturn] = ACTIONS(2683),
    [anon_sym_noreturn] = ACTIONS(2683),
    [anon_sym_mutable] = ACTIONS(2683),
    [anon_sym_constinit] = ACTIONS(2683),
    [anon_sym_consteval] = ACTIONS(2683),
    [anon_sym_alignas] = ACTIONS(2683),
    [anon_sym__Alignas] = ACTIONS(2683),
    [sym_primitive_type] = ACTIONS(2683),
    [anon_sym_enum] = ACTIONS(2683),
    [anon_sym_class] = ACTIONS(2683),
    [anon_sym_struct] = ACTIONS(2683),
    [anon_sym_union] = ACTIONS(2683),
    [anon_sym_if] = ACTIONS(2683),
    [anon_sym_switch] = ACTIONS(2683),
    [anon_sym_case] = ACTIONS(2683),
    [anon_sym_default] = ACTIONS(2683),
    [anon_sym_while] = ACTIONS(2683),
    [anon_sym_do] = ACTIONS(2683),
    [anon_sym_for] = ACTIONS(2683),
    [anon_sym_return] = ACTIONS(2683),
    [anon_sym_break] = ACTIONS(2683),
    [anon_sym_continue] = ACTIONS(2683),
    [anon_sym_goto] = ACTIONS(2683),
    [anon_sym_not] = ACTIONS(2683),
    [anon_sym_compl] = ACTIONS(2683),
    [anon_sym_DASH_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_PLUS] = ACTIONS(2685),
    [anon_sym_sizeof] = ACTIONS(2683),
    [anon_sym___alignof__] = ACTIONS(2683),
    [anon_sym___alignof] = ACTIONS(2683),
    [anon_sym__alignof] = ACTIONS(2683),
    [anon_sym_alignof] = ACTIONS(2683),
    [anon_sym__Alignof] = ACTIONS(2683),
    [anon_sym_offsetof] = ACTIONS(2683),
    [anon_sym__Generic] = ACTIONS(2683),
    [anon_sym_asm] = ACTIONS(2683),
    [anon_sym___asm__] = ACTIONS(2683),
    [anon_sym_DOT] = ACTIONS(2683),
    [sym_number_literal] = ACTIONS(2685),
    [anon_sym_L_SQUOTE] = ACTIONS(2685),
    [anon_sym_u_SQUOTE] = ACTIONS(2685),
    [anon_sym_U_SQUOTE] = ACTIONS(2685),
    [anon_sym_u8_SQUOTE] = ACTIONS(2685),
    [anon_sym_SQUOTE] = ACTIONS(2685),
    [anon_sym_L_DQUOTE] = ACTIONS(2685),
    [anon_sym_u_DQUOTE] = ACTIONS(2685),
    [anon_sym_U_DQUOTE] = ACTIONS(2685),
    [anon_sym_u8_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [sym_true] = ACTIONS(2683),
    [sym_false] = ACTIONS(2683),
    [anon_sym_NULL] = ACTIONS(2683),
    [anon_sym_nullptr] = ACTIONS(2683),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2683),
    [anon_sym_let] = ACTIONS(2683),
    [anon_sym_This] = ACTIONS(2683),
    [anon_sym_decltype] = ACTIONS(2683),
    [anon_sym_final] = ACTIONS(2481),
    [anon_sym_override] = ACTIONS(2481),
    [sym_virtual] = ACTIONS(2683),
    [anon_sym_explicit] = ACTIONS(2683),
    [anon_sym_typename] = ACTIONS(2683),
    [anon_sym_template] = ACTIONS(2683),
    [anon_sym_operator] = ACTIONS(2683),
    [anon_sym_try] = ACTIONS(2683),
    [anon_sym_delete] = ACTIONS(2683),
    [anon_sym_throw] = ACTIONS(2683),
    [anon_sym_namespace] = ACTIONS(2683),
    [anon_sym_using] = ACTIONS(2683),
    [anon_sym_static_assert] = ACTIONS(2683),
    [anon_sym_concept] = ACTIONS(2683),
    [anon_sym_co_return] = ACTIONS(2683),
    [anon_sym_co_yield] = ACTIONS(2683),
    [anon_sym_R_DQUOTE] = ACTIONS(2685),
    [anon_sym_LR_DQUOTE] = ACTIONS(2685),
    [anon_sym_uR_DQUOTE] = ACTIONS(2685),
    [anon_sym_UR_DQUOTE] = ACTIONS(2685),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2685),
    [anon_sym_co_await] = ACTIONS(2683),
    [anon_sym_new] = ACTIONS(2683),
    [anon_sym_requires] = ACTIONS(2683),
    [sym_this] = ACTIONS(2683),
    [anon_sym_precise] = ACTIONS(2683),
    [anon_sym_shared] = ACTIONS(2683),
    [anon_sym_groupshared] = ACTIONS(2683),
    [anon_sym_uniform] = ACTIONS(2683),
    [anon_sym_row_major] = ACTIONS(2683),
    [anon_sym_column_major] = ACTIONS(2683),
    [anon_sym_globallycoherent] = ACTIONS(2683),
    [anon_sym_centroid] = ACTIONS(2683),
    [anon_sym_noperspective] = ACTIONS(2683),
    [anon_sym_nointerpolation] = ACTIONS(2683),
    [anon_sym_sample] = ACTIONS(2683),
    [anon_sym_linear] = ACTIONS(2683),
    [anon_sym_snorm] = ACTIONS(2683),
    [anon_sym_unorm] = ACTIONS(2683),
    [anon_sym_point] = ACTIONS(2683),
    [anon_sym_line] = ACTIONS(2683),
    [anon_sym_triangleadj] = ACTIONS(2683),
    [anon_sym_lineadj] = ACTIONS(2683),
    [anon_sym_triangle] = ACTIONS(2683),
    [anon_sym_interface] = ACTIONS(2683),
    [anon_sym_extension] = ACTIONS(2683),
    [anon_sym___exported] = ACTIONS(2683),
    [anon_sym_import] = ACTIONS(2683),
  },
  [287] = {
    [sym_identifier] = ACTIONS(2359),
    [aux_sym_preproc_include_token1] = ACTIONS(2359),
    [aux_sym_preproc_def_token1] = ACTIONS(2359),
    [aux_sym_preproc_if_token1] = ACTIONS(2359),
    [aux_sym_preproc_if_token2] = ACTIONS(2359),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2359),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2359),
    [aux_sym_preproc_else_token1] = ACTIONS(2359),
    [aux_sym_preproc_elif_token1] = ACTIONS(2359),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2359),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2359),
    [sym_preproc_directive] = ACTIONS(2359),
    [anon_sym_LPAREN2] = ACTIONS(2357),
    [anon_sym_BANG] = ACTIONS(2357),
    [anon_sym_TILDE] = ACTIONS(2357),
    [anon_sym_DASH] = ACTIONS(2359),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_STAR] = ACTIONS(2357),
    [anon_sym_AMP_AMP] = ACTIONS(2357),
    [anon_sym_AMP] = ACTIONS(2359),
    [anon_sym_SEMI] = ACTIONS(2357),
    [anon_sym___extension__] = ACTIONS(2359),
    [anon_sym_typedef] = ACTIONS(2359),
    [anon_sym_in] = ACTIONS(2359),
    [anon_sym_out] = ACTIONS(2359),
    [anon_sym_inout] = ACTIONS(2359),
    [anon_sym_extern] = ACTIONS(2359),
    [anon_sym___attribute__] = ACTIONS(2359),
    [anon_sym_COLON_COLON] = ACTIONS(2357),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2357),
    [anon_sym___declspec] = ACTIONS(2359),
    [anon_sym___based] = ACTIONS(2359),
    [anon_sym___cdecl] = ACTIONS(2359),
    [anon_sym___clrcall] = ACTIONS(2359),
    [anon_sym___stdcall] = ACTIONS(2359),
    [anon_sym___fastcall] = ACTIONS(2359),
    [anon_sym___thiscall] = ACTIONS(2359),
    [anon_sym___vectorcall] = ACTIONS(2359),
    [anon_sym_LBRACE] = ACTIONS(2357),
    [anon_sym_signed] = ACTIONS(2359),
    [anon_sym_unsigned] = ACTIONS(2359),
    [anon_sym_long] = ACTIONS(2359),
    [anon_sym_short] = ACTIONS(2359),
    [anon_sym_LBRACK] = ACTIONS(2359),
    [anon_sym_static] = ACTIONS(2359),
    [anon_sym_register] = ACTIONS(2359),
    [anon_sym_inline] = ACTIONS(2359),
    [anon_sym___inline] = ACTIONS(2359),
    [anon_sym___inline__] = ACTIONS(2359),
    [anon_sym___forceinline] = ACTIONS(2359),
    [anon_sym_thread_local] = ACTIONS(2359),
    [anon_sym___thread] = ACTIONS(2359),
    [anon_sym_const] = ACTIONS(2359),
    [anon_sym_constexpr] = ACTIONS(2359),
    [anon_sym_volatile] = ACTIONS(2359),
    [anon_sym_restrict] = ACTIONS(2359),
    [anon_sym___restrict__] = ACTIONS(2359),
    [anon_sym__Atomic] = ACTIONS(2359),
    [anon_sym__Noreturn] = ACTIONS(2359),
    [anon_sym_noreturn] = ACTIONS(2359),
    [anon_sym_mutable] = ACTIONS(2359),
    [anon_sym_constinit] = ACTIONS(2359),
    [anon_sym_consteval] = ACTIONS(2359),
    [anon_sym_alignas] = ACTIONS(2359),
    [anon_sym__Alignas] = ACTIONS(2359),
    [sym_primitive_type] = ACTIONS(2359),
    [anon_sym_enum] = ACTIONS(2359),
    [anon_sym_class] = ACTIONS(2359),
    [anon_sym_struct] = ACTIONS(2359),
    [anon_sym_union] = ACTIONS(2359),
    [anon_sym_if] = ACTIONS(2359),
    [anon_sym_else] = ACTIONS(2359),
    [anon_sym_switch] = ACTIONS(2359),
    [anon_sym_case] = ACTIONS(2359),
    [anon_sym_default] = ACTIONS(2359),
    [anon_sym_while] = ACTIONS(2359),
    [anon_sym_do] = ACTIONS(2359),
    [anon_sym_for] = ACTIONS(2359),
    [anon_sym_return] = ACTIONS(2359),
    [anon_sym_break] = ACTIONS(2359),
    [anon_sym_continue] = ACTIONS(2359),
    [anon_sym_goto] = ACTIONS(2359),
    [anon_sym___try] = ACTIONS(2359),
    [anon_sym___leave] = ACTIONS(2359),
    [anon_sym_not] = ACTIONS(2359),
    [anon_sym_compl] = ACTIONS(2359),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
    [anon_sym_sizeof] = ACTIONS(2359),
    [anon_sym___alignof__] = ACTIONS(2359),
    [anon_sym___alignof] = ACTIONS(2359),
    [anon_sym__alignof] = ACTIONS(2359),
    [anon_sym_alignof] = ACTIONS(2359),
    [anon_sym__Alignof] = ACTIONS(2359),
    [anon_sym_offsetof] = ACTIONS(2359),
    [anon_sym__Generic] = ACTIONS(2359),
    [anon_sym_asm] = ACTIONS(2359),
    [anon_sym___asm__] = ACTIONS(2359),
    [sym_number_literal] = ACTIONS(2357),
    [anon_sym_L_SQUOTE] = ACTIONS(2357),
    [anon_sym_u_SQUOTE] = ACTIONS(2357),
    [anon_sym_U_SQUOTE] = ACTIONS(2357),
    [anon_sym_u8_SQUOTE] = ACTIONS(2357),
    [anon_sym_SQUOTE] = ACTIONS(2357),
    [anon_sym_L_DQUOTE] = ACTIONS(2357),
    [anon_sym_u_DQUOTE] = ACTIONS(2357),
    [anon_sym_U_DQUOTE] = ACTIONS(2357),
    [anon_sym_u8_DQUOTE] = ACTIONS(2357),
    [anon_sym_DQUOTE] = ACTIONS(2357),
    [sym_true] = ACTIONS(2359),
    [sym_false] = ACTIONS(2359),
    [anon_sym_NULL] = ACTIONS(2359),
    [anon_sym_nullptr] = ACTIONS(2359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2359),
    [anon_sym_let] = ACTIONS(2359),
    [anon_sym_This] = ACTIONS(2359),
    [anon_sym_decltype] = ACTIONS(2359),
    [sym_virtual] = ACTIONS(2359),
    [anon_sym_explicit] = ACTIONS(2359),
    [anon_sym_typename] = ACTIONS(2359),
    [anon_sym_template] = ACTIONS(2359),
    [anon_sym_operator] = ACTIONS(2359),
    [anon_sym_try] = ACTIONS(2359),
    [anon_sym_delete] = ACTIONS(2359),
    [anon_sym_throw] = ACTIONS(2359),
    [anon_sym_namespace] = ACTIONS(2359),
    [anon_sym_using] = ACTIONS(2359),
    [anon_sym_static_assert] = ACTIONS(2359),
    [anon_sym_concept] = ACTIONS(2359),
    [anon_sym_co_return] = ACTIONS(2359),
    [anon_sym_co_yield] = ACTIONS(2359),
    [anon_sym_catch] = ACTIONS(2359),
    [anon_sym_R_DQUOTE] = ACTIONS(2357),
    [anon_sym_LR_DQUOTE] = ACTIONS(2357),
    [anon_sym_uR_DQUOTE] = ACTIONS(2357),
    [anon_sym_UR_DQUOTE] = ACTIONS(2357),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2357),
    [anon_sym_co_await] = ACTIONS(2359),
    [anon_sym_new] = ACTIONS(2359),
    [anon_sym_requires] = ACTIONS(2359),
    [sym_this] = ACTIONS(2359),
    [anon_sym_discard] = ACTIONS(2359),
    [anon_sym_precise] = ACTIONS(2359),
    [anon_sym_shared] = ACTIONS(2359),
    [anon_sym_groupshared] = ACTIONS(2359),
    [anon_sym_uniform] = ACTIONS(2359),
    [anon_sym_row_major] = ACTIONS(2359),
    [anon_sym_column_major] = ACTIONS(2359),
    [anon_sym_globallycoherent] = ACTIONS(2359),
    [anon_sym_centroid] = ACTIONS(2359),
    [anon_sym_noperspective] = ACTIONS(2359),
    [anon_sym_nointerpolation] = ACTIONS(2359),
    [anon_sym_sample] = ACTIONS(2359),
    [anon_sym_linear] = ACTIONS(2359),
    [anon_sym_snorm] = ACTIONS(2359),
    [anon_sym_unorm] = ACTIONS(2359),
    [anon_sym_point] = ACTIONS(2359),
    [anon_sym_line] = ACTIONS(2359),
    [anon_sym_triangleadj] = ACTIONS(2359),
    [anon_sym_lineadj] = ACTIONS(2359),
    [anon_sym_triangle] = ACTIONS(2359),
    [anon_sym_cbuffer] = ACTIONS(2359),
    [anon_sym_interface] = ACTIONS(2359),
    [anon_sym_extension] = ACTIONS(2359),
  },
  [288] = {
    [sym_catch_clause] = STATE(290),
    [aux_sym_constructor_try_statement_repeat1] = STATE(290),
    [ts_builtin_sym_end] = ACTIONS(2679),
    [sym_identifier] = ACTIONS(2677),
    [aux_sym_preproc_include_token1] = ACTIONS(2677),
    [aux_sym_preproc_def_token1] = ACTIONS(2677),
    [aux_sym_preproc_if_token1] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2677),
    [sym_preproc_directive] = ACTIONS(2677),
    [anon_sym_LPAREN2] = ACTIONS(2679),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_DASH] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_STAR] = ACTIONS(2679),
    [anon_sym_AMP_AMP] = ACTIONS(2679),
    [anon_sym_AMP] = ACTIONS(2677),
    [anon_sym_SEMI] = ACTIONS(2679),
    [anon_sym___extension__] = ACTIONS(2677),
    [anon_sym_typedef] = ACTIONS(2677),
    [anon_sym_in] = ACTIONS(2677),
    [anon_sym_out] = ACTIONS(2677),
    [anon_sym_inout] = ACTIONS(2677),
    [anon_sym_extern] = ACTIONS(2677),
    [anon_sym___attribute__] = ACTIONS(2677),
    [anon_sym_COLON_COLON] = ACTIONS(2679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2679),
    [anon_sym___declspec] = ACTIONS(2677),
    [anon_sym___based] = ACTIONS(2677),
    [anon_sym___cdecl] = ACTIONS(2677),
    [anon_sym___clrcall] = ACTIONS(2677),
    [anon_sym___stdcall] = ACTIONS(2677),
    [anon_sym___fastcall] = ACTIONS(2677),
    [anon_sym___thiscall] = ACTIONS(2677),
    [anon_sym___vectorcall] = ACTIONS(2677),
    [anon_sym_LBRACE] = ACTIONS(2679),
    [anon_sym_signed] = ACTIONS(2677),
    [anon_sym_unsigned] = ACTIONS(2677),
    [anon_sym_long] = ACTIONS(2677),
    [anon_sym_short] = ACTIONS(2677),
    [anon_sym_LBRACK] = ACTIONS(2677),
    [anon_sym_static] = ACTIONS(2677),
    [anon_sym_register] = ACTIONS(2677),
    [anon_sym_inline] = ACTIONS(2677),
    [anon_sym___inline] = ACTIONS(2677),
    [anon_sym___inline__] = ACTIONS(2677),
    [anon_sym___forceinline] = ACTIONS(2677),
    [anon_sym_thread_local] = ACTIONS(2677),
    [anon_sym___thread] = ACTIONS(2677),
    [anon_sym_const] = ACTIONS(2677),
    [anon_sym_constexpr] = ACTIONS(2677),
    [anon_sym_volatile] = ACTIONS(2677),
    [anon_sym_restrict] = ACTIONS(2677),
    [anon_sym___restrict__] = ACTIONS(2677),
    [anon_sym__Atomic] = ACTIONS(2677),
    [anon_sym__Noreturn] = ACTIONS(2677),
    [anon_sym_noreturn] = ACTIONS(2677),
    [anon_sym_mutable] = ACTIONS(2677),
    [anon_sym_constinit] = ACTIONS(2677),
    [anon_sym_consteval] = ACTIONS(2677),
    [anon_sym_alignas] = ACTIONS(2677),
    [anon_sym__Alignas] = ACTIONS(2677),
    [sym_primitive_type] = ACTIONS(2677),
    [anon_sym_enum] = ACTIONS(2677),
    [anon_sym_class] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(2677),
    [anon_sym_union] = ACTIONS(2677),
    [anon_sym_if] = ACTIONS(2677),
    [anon_sym_else] = ACTIONS(2677),
    [anon_sym_switch] = ACTIONS(2677),
    [anon_sym_case] = ACTIONS(2677),
    [anon_sym_default] = ACTIONS(2677),
    [anon_sym_while] = ACTIONS(2677),
    [anon_sym_do] = ACTIONS(2677),
    [anon_sym_for] = ACTIONS(2677),
    [anon_sym_return] = ACTIONS(2677),
    [anon_sym_break] = ACTIONS(2677),
    [anon_sym_continue] = ACTIONS(2677),
    [anon_sym_goto] = ACTIONS(2677),
    [anon_sym___try] = ACTIONS(2677),
    [anon_sym___leave] = ACTIONS(2677),
    [anon_sym_not] = ACTIONS(2677),
    [anon_sym_compl] = ACTIONS(2677),
    [anon_sym_DASH_DASH] = ACTIONS(2679),
    [anon_sym_PLUS_PLUS] = ACTIONS(2679),
    [anon_sym_sizeof] = ACTIONS(2677),
    [anon_sym___alignof__] = ACTIONS(2677),
    [anon_sym___alignof] = ACTIONS(2677),
    [anon_sym__alignof] = ACTIONS(2677),
    [anon_sym_alignof] = ACTIONS(2677),
    [anon_sym__Alignof] = ACTIONS(2677),
    [anon_sym_offsetof] = ACTIONS(2677),
    [anon_sym__Generic] = ACTIONS(2677),
    [anon_sym_asm] = ACTIONS(2677),
    [anon_sym___asm__] = ACTIONS(2677),
    [sym_number_literal] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2679),
    [anon_sym_u_SQUOTE] = ACTIONS(2679),
    [anon_sym_U_SQUOTE] = ACTIONS(2679),
    [anon_sym_u8_SQUOTE] = ACTIONS(2679),
    [anon_sym_SQUOTE] = ACTIONS(2679),
    [anon_sym_L_DQUOTE] = ACTIONS(2679),
    [anon_sym_u_DQUOTE] = ACTIONS(2679),
    [anon_sym_U_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8_DQUOTE] = ACTIONS(2679),
    [anon_sym_DQUOTE] = ACTIONS(2679),
    [sym_true] = ACTIONS(2677),
    [sym_false] = ACTIONS(2677),
    [anon_sym_NULL] = ACTIONS(2677),
    [anon_sym_nullptr] = ACTIONS(2677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2677),
    [anon_sym_let] = ACTIONS(2677),
    [anon_sym_This] = ACTIONS(2677),
    [anon_sym_decltype] = ACTIONS(2677),
    [sym_virtual] = ACTIONS(2677),
    [anon_sym_explicit] = ACTIONS(2677),
    [anon_sym_typename] = ACTIONS(2677),
    [anon_sym_template] = ACTIONS(2677),
    [anon_sym_operator] = ACTIONS(2677),
    [anon_sym_try] = ACTIONS(2677),
    [anon_sym_delete] = ACTIONS(2677),
    [anon_sym_throw] = ACTIONS(2677),
    [anon_sym_namespace] = ACTIONS(2677),
    [anon_sym_using] = ACTIONS(2677),
    [anon_sym_static_assert] = ACTIONS(2677),
    [anon_sym_concept] = ACTIONS(2677),
    [anon_sym_co_return] = ACTIONS(2677),
    [anon_sym_co_yield] = ACTIONS(2677),
    [anon_sym_catch] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2679),
    [anon_sym_LR_DQUOTE] = ACTIONS(2679),
    [anon_sym_uR_DQUOTE] = ACTIONS(2679),
    [anon_sym_UR_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2679),
    [anon_sym_co_await] = ACTIONS(2677),
    [anon_sym_new] = ACTIONS(2677),
    [anon_sym_requires] = ACTIONS(2677),
    [sym_this] = ACTIONS(2677),
    [anon_sym_discard] = ACTIONS(2677),
    [anon_sym_precise] = ACTIONS(2677),
    [anon_sym_shared] = ACTIONS(2677),
    [anon_sym_groupshared] = ACTIONS(2677),
    [anon_sym_uniform] = ACTIONS(2677),
    [anon_sym_row_major] = ACTIONS(2677),
    [anon_sym_column_major] = ACTIONS(2677),
    [anon_sym_globallycoherent] = ACTIONS(2677),
    [anon_sym_centroid] = ACTIONS(2677),
    [anon_sym_noperspective] = ACTIONS(2677),
    [anon_sym_nointerpolation] = ACTIONS(2677),
    [anon_sym_sample] = ACTIONS(2677),
    [anon_sym_linear] = ACTIONS(2677),
    [anon_sym_snorm] = ACTIONS(2677),
    [anon_sym_unorm] = ACTIONS(2677),
    [anon_sym_point] = ACTIONS(2677),
    [anon_sym_line] = ACTIONS(2677),
    [anon_sym_triangleadj] = ACTIONS(2677),
    [anon_sym_lineadj] = ACTIONS(2677),
    [anon_sym_triangle] = ACTIONS(2677),
    [anon_sym_cbuffer] = ACTIONS(2677),
    [anon_sym_interface] = ACTIONS(2677),
    [anon_sym_extension] = ACTIONS(2677),
    [anon_sym___exported] = ACTIONS(2677),
    [anon_sym_import] = ACTIONS(2677),
  },
  [289] = {
    [sym_template_argument_list] = STATE(526),
    [sym_identifier] = ACTIONS(2349),
    [aux_sym_preproc_include_token1] = ACTIONS(2349),
    [aux_sym_preproc_def_token1] = ACTIONS(2349),
    [aux_sym_preproc_if_token1] = ACTIONS(2349),
    [aux_sym_preproc_if_token2] = ACTIONS(2349),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2349),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2349),
    [sym_preproc_directive] = ACTIONS(2349),
    [anon_sym_LPAREN2] = ACTIONS(2347),
    [anon_sym_BANG] = ACTIONS(2347),
    [anon_sym_TILDE] = ACTIONS(2347),
    [anon_sym_DASH] = ACTIONS(2349),
    [anon_sym_PLUS] = ACTIONS(2349),
    [anon_sym_STAR] = ACTIONS(2347),
    [anon_sym_AMP_AMP] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2349),
    [anon_sym_LT] = ACTIONS(2834),
    [anon_sym_COLON] = ACTIONS(2349),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym___extension__] = ACTIONS(2349),
    [anon_sym_typedef] = ACTIONS(2349),
    [anon_sym_in] = ACTIONS(2349),
    [anon_sym_out] = ACTIONS(2349),
    [anon_sym_inout] = ACTIONS(2349),
    [anon_sym_extern] = ACTIONS(2349),
    [anon_sym___attribute__] = ACTIONS(2349),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2347),
    [anon_sym___declspec] = ACTIONS(2349),
    [anon_sym___based] = ACTIONS(2349),
    [anon_sym___cdecl] = ACTIONS(2349),
    [anon_sym___clrcall] = ACTIONS(2349),
    [anon_sym___stdcall] = ACTIONS(2349),
    [anon_sym___fastcall] = ACTIONS(2349),
    [anon_sym___thiscall] = ACTIONS(2349),
    [anon_sym___vectorcall] = ACTIONS(2349),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_signed] = ACTIONS(2349),
    [anon_sym_unsigned] = ACTIONS(2349),
    [anon_sym_long] = ACTIONS(2349),
    [anon_sym_short] = ACTIONS(2349),
    [anon_sym_LBRACK] = ACTIONS(2349),
    [anon_sym_static] = ACTIONS(2349),
    [anon_sym_register] = ACTIONS(2349),
    [anon_sym_inline] = ACTIONS(2349),
    [anon_sym___inline] = ACTIONS(2349),
    [anon_sym___inline__] = ACTIONS(2349),
    [anon_sym___forceinline] = ACTIONS(2349),
    [anon_sym_thread_local] = ACTIONS(2349),
    [anon_sym___thread] = ACTIONS(2349),
    [anon_sym_const] = ACTIONS(2349),
    [anon_sym_constexpr] = ACTIONS(2349),
    [anon_sym_volatile] = ACTIONS(2349),
    [anon_sym_restrict] = ACTIONS(2349),
    [anon_sym___restrict__] = ACTIONS(2349),
    [anon_sym__Atomic] = ACTIONS(2349),
    [anon_sym__Noreturn] = ACTIONS(2349),
    [anon_sym_noreturn] = ACTIONS(2349),
    [anon_sym_mutable] = ACTIONS(2349),
    [anon_sym_constinit] = ACTIONS(2349),
    [anon_sym_consteval] = ACTIONS(2349),
    [anon_sym_alignas] = ACTIONS(2349),
    [anon_sym__Alignas] = ACTIONS(2349),
    [sym_primitive_type] = ACTIONS(2349),
    [anon_sym_enum] = ACTIONS(2349),
    [anon_sym_class] = ACTIONS(2349),
    [anon_sym_struct] = ACTIONS(2349),
    [anon_sym_union] = ACTIONS(2349),
    [anon_sym_if] = ACTIONS(2349),
    [anon_sym_else] = ACTIONS(2349),
    [anon_sym_switch] = ACTIONS(2349),
    [anon_sym_case] = ACTIONS(2349),
    [anon_sym_default] = ACTIONS(2349),
    [anon_sym_while] = ACTIONS(2349),
    [anon_sym_do] = ACTIONS(2349),
    [anon_sym_for] = ACTIONS(2349),
    [anon_sym_return] = ACTIONS(2349),
    [anon_sym_break] = ACTIONS(2349),
    [anon_sym_continue] = ACTIONS(2349),
    [anon_sym_goto] = ACTIONS(2349),
    [anon_sym___try] = ACTIONS(2349),
    [anon_sym___leave] = ACTIONS(2349),
    [anon_sym_not] = ACTIONS(2349),
    [anon_sym_compl] = ACTIONS(2349),
    [anon_sym_DASH_DASH] = ACTIONS(2347),
    [anon_sym_PLUS_PLUS] = ACTIONS(2347),
    [anon_sym_sizeof] = ACTIONS(2349),
    [anon_sym___alignof__] = ACTIONS(2349),
    [anon_sym___alignof] = ACTIONS(2349),
    [anon_sym__alignof] = ACTIONS(2349),
    [anon_sym_alignof] = ACTIONS(2349),
    [anon_sym__Alignof] = ACTIONS(2349),
    [anon_sym_offsetof] = ACTIONS(2349),
    [anon_sym__Generic] = ACTIONS(2349),
    [anon_sym_asm] = ACTIONS(2349),
    [anon_sym___asm__] = ACTIONS(2349),
    [sym_number_literal] = ACTIONS(2347),
    [anon_sym_L_SQUOTE] = ACTIONS(2347),
    [anon_sym_u_SQUOTE] = ACTIONS(2347),
    [anon_sym_U_SQUOTE] = ACTIONS(2347),
    [anon_sym_u8_SQUOTE] = ACTIONS(2347),
    [anon_sym_SQUOTE] = ACTIONS(2347),
    [anon_sym_L_DQUOTE] = ACTIONS(2347),
    [anon_sym_u_DQUOTE] = ACTIONS(2347),
    [anon_sym_U_DQUOTE] = ACTIONS(2347),
    [anon_sym_u8_DQUOTE] = ACTIONS(2347),
    [anon_sym_DQUOTE] = ACTIONS(2347),
    [sym_true] = ACTIONS(2349),
    [sym_false] = ACTIONS(2349),
    [anon_sym_NULL] = ACTIONS(2349),
    [anon_sym_nullptr] = ACTIONS(2349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2349),
    [anon_sym_let] = ACTIONS(2349),
    [anon_sym_This] = ACTIONS(2349),
    [anon_sym_decltype] = ACTIONS(2349),
    [anon_sym_final] = ACTIONS(2349),
    [anon_sym_override] = ACTIONS(2349),
    [sym_virtual] = ACTIONS(2349),
    [anon_sym_explicit] = ACTIONS(2349),
    [anon_sym_typename] = ACTIONS(2349),
    [anon_sym_template] = ACTIONS(2349),
    [anon_sym_operator] = ACTIONS(2349),
    [anon_sym_try] = ACTIONS(2349),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_throw] = ACTIONS(2349),
    [anon_sym_namespace] = ACTIONS(2349),
    [anon_sym_using] = ACTIONS(2349),
    [anon_sym_static_assert] = ACTIONS(2349),
    [anon_sym_concept] = ACTIONS(2349),
    [anon_sym_co_return] = ACTIONS(2349),
    [anon_sym_co_yield] = ACTIONS(2349),
    [anon_sym_R_DQUOTE] = ACTIONS(2347),
    [anon_sym_LR_DQUOTE] = ACTIONS(2347),
    [anon_sym_uR_DQUOTE] = ACTIONS(2347),
    [anon_sym_UR_DQUOTE] = ACTIONS(2347),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2347),
    [anon_sym_co_await] = ACTIONS(2349),
    [anon_sym_new] = ACTIONS(2349),
    [anon_sym_requires] = ACTIONS(2349),
    [sym_this] = ACTIONS(2349),
    [anon_sym_discard] = ACTIONS(2349),
    [anon_sym_precise] = ACTIONS(2349),
    [anon_sym_shared] = ACTIONS(2349),
    [anon_sym_groupshared] = ACTIONS(2349),
    [anon_sym_uniform] = ACTIONS(2349),
    [anon_sym_row_major] = ACTIONS(2349),
    [anon_sym_column_major] = ACTIONS(2349),
    [anon_sym_globallycoherent] = ACTIONS(2349),
    [anon_sym_centroid] = ACTIONS(2349),
    [anon_sym_noperspective] = ACTIONS(2349),
    [anon_sym_nointerpolation] = ACTIONS(2349),
    [anon_sym_sample] = ACTIONS(2349),
    [anon_sym_linear] = ACTIONS(2349),
    [anon_sym_snorm] = ACTIONS(2349),
    [anon_sym_unorm] = ACTIONS(2349),
    [anon_sym_point] = ACTIONS(2349),
    [anon_sym_line] = ACTIONS(2349),
    [anon_sym_triangleadj] = ACTIONS(2349),
    [anon_sym_lineadj] = ACTIONS(2349),
    [anon_sym_triangle] = ACTIONS(2349),
    [anon_sym_cbuffer] = ACTIONS(2349),
    [anon_sym_interface] = ACTIONS(2349),
    [anon_sym_extension] = ACTIONS(2349),
  },
  [290] = {
    [sym_catch_clause] = STATE(290),
    [aux_sym_constructor_try_statement_repeat1] = STATE(290),
    [ts_builtin_sym_end] = ACTIONS(2733),
    [sym_identifier] = ACTIONS(2731),
    [aux_sym_preproc_include_token1] = ACTIONS(2731),
    [aux_sym_preproc_def_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(2733),
    [anon_sym_BANG] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2731),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_AMP_AMP] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2731),
    [anon_sym_SEMI] = ACTIONS(2733),
    [anon_sym___extension__] = ACTIONS(2731),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_in] = ACTIONS(2731),
    [anon_sym_out] = ACTIONS(2731),
    [anon_sym_inout] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym___based] = ACTIONS(2731),
    [anon_sym___cdecl] = ACTIONS(2731),
    [anon_sym___clrcall] = ACTIONS(2731),
    [anon_sym___stdcall] = ACTIONS(2731),
    [anon_sym___fastcall] = ACTIONS(2731),
    [anon_sym___thiscall] = ACTIONS(2731),
    [anon_sym___vectorcall] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2733),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym__Alignas] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [anon_sym_if] = ACTIONS(2731),
    [anon_sym_else] = ACTIONS(2731),
    [anon_sym_switch] = ACTIONS(2731),
    [anon_sym_case] = ACTIONS(2731),
    [anon_sym_default] = ACTIONS(2731),
    [anon_sym_while] = ACTIONS(2731),
    [anon_sym_do] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2731),
    [anon_sym_return] = ACTIONS(2731),
    [anon_sym_break] = ACTIONS(2731),
    [anon_sym_continue] = ACTIONS(2731),
    [anon_sym_goto] = ACTIONS(2731),
    [anon_sym___try] = ACTIONS(2731),
    [anon_sym___leave] = ACTIONS(2731),
    [anon_sym_not] = ACTIONS(2731),
    [anon_sym_compl] = ACTIONS(2731),
    [anon_sym_DASH_DASH] = ACTIONS(2733),
    [anon_sym_PLUS_PLUS] = ACTIONS(2733),
    [anon_sym_sizeof] = ACTIONS(2731),
    [anon_sym___alignof__] = ACTIONS(2731),
    [anon_sym___alignof] = ACTIONS(2731),
    [anon_sym__alignof] = ACTIONS(2731),
    [anon_sym_alignof] = ACTIONS(2731),
    [anon_sym__Alignof] = ACTIONS(2731),
    [anon_sym_offsetof] = ACTIONS(2731),
    [anon_sym__Generic] = ACTIONS(2731),
    [anon_sym_asm] = ACTIONS(2731),
    [anon_sym___asm__] = ACTIONS(2731),
    [sym_number_literal] = ACTIONS(2733),
    [anon_sym_L_SQUOTE] = ACTIONS(2733),
    [anon_sym_u_SQUOTE] = ACTIONS(2733),
    [anon_sym_U_SQUOTE] = ACTIONS(2733),
    [anon_sym_u8_SQUOTE] = ACTIONS(2733),
    [anon_sym_SQUOTE] = ACTIONS(2733),
    [anon_sym_L_DQUOTE] = ACTIONS(2733),
    [anon_sym_u_DQUOTE] = ACTIONS(2733),
    [anon_sym_U_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8_DQUOTE] = ACTIONS(2733),
    [anon_sym_DQUOTE] = ACTIONS(2733),
    [sym_true] = ACTIONS(2731),
    [sym_false] = ACTIONS(2731),
    [anon_sym_NULL] = ACTIONS(2731),
    [anon_sym_nullptr] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2731),
    [anon_sym_let] = ACTIONS(2731),
    [anon_sym_This] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(2731),
    [sym_virtual] = ACTIONS(2731),
    [anon_sym_explicit] = ACTIONS(2731),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(2731),
    [anon_sym_operator] = ACTIONS(2731),
    [anon_sym_try] = ACTIONS(2731),
    [anon_sym_delete] = ACTIONS(2731),
    [anon_sym_throw] = ACTIONS(2731),
    [anon_sym_namespace] = ACTIONS(2731),
    [anon_sym_using] = ACTIONS(2731),
    [anon_sym_static_assert] = ACTIONS(2731),
    [anon_sym_concept] = ACTIONS(2731),
    [anon_sym_co_return] = ACTIONS(2731),
    [anon_sym_co_yield] = ACTIONS(2731),
    [anon_sym_catch] = ACTIONS(2865),
    [anon_sym_R_DQUOTE] = ACTIONS(2733),
    [anon_sym_LR_DQUOTE] = ACTIONS(2733),
    [anon_sym_uR_DQUOTE] = ACTIONS(2733),
    [anon_sym_UR_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2733),
    [anon_sym_co_await] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2731),
    [anon_sym_requires] = ACTIONS(2731),
    [sym_this] = ACTIONS(2731),
    [anon_sym_discard] = ACTIONS(2731),
    [anon_sym_precise] = ACTIONS(2731),
    [anon_sym_shared] = ACTIONS(2731),
    [anon_sym_groupshared] = ACTIONS(2731),
    [anon_sym_uniform] = ACTIONS(2731),
    [anon_sym_row_major] = ACTIONS(2731),
    [anon_sym_column_major] = ACTIONS(2731),
    [anon_sym_globallycoherent] = ACTIONS(2731),
    [anon_sym_centroid] = ACTIONS(2731),
    [anon_sym_noperspective] = ACTIONS(2731),
    [anon_sym_nointerpolation] = ACTIONS(2731),
    [anon_sym_sample] = ACTIONS(2731),
    [anon_sym_linear] = ACTIONS(2731),
    [anon_sym_snorm] = ACTIONS(2731),
    [anon_sym_unorm] = ACTIONS(2731),
    [anon_sym_point] = ACTIONS(2731),
    [anon_sym_line] = ACTIONS(2731),
    [anon_sym_triangleadj] = ACTIONS(2731),
    [anon_sym_lineadj] = ACTIONS(2731),
    [anon_sym_triangle] = ACTIONS(2731),
    [anon_sym_cbuffer] = ACTIONS(2731),
    [anon_sym_interface] = ACTIONS(2731),
    [anon_sym_extension] = ACTIONS(2731),
    [anon_sym___exported] = ACTIONS(2731),
    [anon_sym_import] = ACTIONS(2731),
  },
  [291] = {
    [sym_preproc_def] = STATE(430),
    [sym_preproc_function_def] = STATE(430),
    [sym_preproc_call] = STATE(430),
    [sym_preproc_if_in_field_declaration_list] = STATE(430),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(430),
    [sym_type_definition] = STATE(430),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(430),
    [sym_field_declaration] = STATE(430),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(430),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(430),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(430),
    [sym_operator_cast_declaration] = STATE(430),
    [sym_constructor_or_destructor_definition] = STATE(430),
    [sym_constructor_or_destructor_declaration] = STATE(430),
    [sym_friend_declaration] = STATE(430),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(430),
    [sym_alias_declaration] = STATE(430),
    [sym_static_assert_declaration] = STATE(430),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(430),
    [sym_subscript_declaration] = STATE(430),
    [sym_property_declaration] = STATE(430),
    [sym_associatedtype_declaration] = STATE(430),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(430),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(2880),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [292] = {
    [sym_identifier] = ACTIONS(2898),
    [aux_sym_preproc_include_token1] = ACTIONS(2898),
    [aux_sym_preproc_def_token1] = ACTIONS(2898),
    [aux_sym_preproc_if_token1] = ACTIONS(2898),
    [aux_sym_preproc_if_token2] = ACTIONS(2898),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2898),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2898),
    [aux_sym_preproc_else_token1] = ACTIONS(2898),
    [aux_sym_preproc_elif_token1] = ACTIONS(2898),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2898),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2898),
    [sym_preproc_directive] = ACTIONS(2898),
    [anon_sym_LPAREN2] = ACTIONS(2900),
    [anon_sym_BANG] = ACTIONS(2900),
    [anon_sym_TILDE] = ACTIONS(2900),
    [anon_sym_DASH] = ACTIONS(2898),
    [anon_sym_PLUS] = ACTIONS(2898),
    [anon_sym_STAR] = ACTIONS(2900),
    [anon_sym_AMP_AMP] = ACTIONS(2900),
    [anon_sym_AMP] = ACTIONS(2898),
    [anon_sym_SEMI] = ACTIONS(2900),
    [anon_sym___extension__] = ACTIONS(2898),
    [anon_sym_typedef] = ACTIONS(2898),
    [anon_sym_in] = ACTIONS(2898),
    [anon_sym_out] = ACTIONS(2898),
    [anon_sym_inout] = ACTIONS(2898),
    [anon_sym_extern] = ACTIONS(2898),
    [anon_sym___attribute__] = ACTIONS(2898),
    [anon_sym_COLON_COLON] = ACTIONS(2900),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2900),
    [anon_sym___declspec] = ACTIONS(2898),
    [anon_sym___based] = ACTIONS(2898),
    [anon_sym___cdecl] = ACTIONS(2898),
    [anon_sym___clrcall] = ACTIONS(2898),
    [anon_sym___stdcall] = ACTIONS(2898),
    [anon_sym___fastcall] = ACTIONS(2898),
    [anon_sym___thiscall] = ACTIONS(2898),
    [anon_sym___vectorcall] = ACTIONS(2898),
    [anon_sym_LBRACE] = ACTIONS(2900),
    [anon_sym_signed] = ACTIONS(2898),
    [anon_sym_unsigned] = ACTIONS(2898),
    [anon_sym_long] = ACTIONS(2898),
    [anon_sym_short] = ACTIONS(2898),
    [anon_sym_LBRACK] = ACTIONS(2898),
    [anon_sym_static] = ACTIONS(2898),
    [anon_sym_register] = ACTIONS(2898),
    [anon_sym_inline] = ACTIONS(2898),
    [anon_sym___inline] = ACTIONS(2898),
    [anon_sym___inline__] = ACTIONS(2898),
    [anon_sym___forceinline] = ACTIONS(2898),
    [anon_sym_thread_local] = ACTIONS(2898),
    [anon_sym___thread] = ACTIONS(2898),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_constexpr] = ACTIONS(2898),
    [anon_sym_volatile] = ACTIONS(2898),
    [anon_sym_restrict] = ACTIONS(2898),
    [anon_sym___restrict__] = ACTIONS(2898),
    [anon_sym__Atomic] = ACTIONS(2898),
    [anon_sym__Noreturn] = ACTIONS(2898),
    [anon_sym_noreturn] = ACTIONS(2898),
    [anon_sym_mutable] = ACTIONS(2898),
    [anon_sym_constinit] = ACTIONS(2898),
    [anon_sym_consteval] = ACTIONS(2898),
    [anon_sym_alignas] = ACTIONS(2898),
    [anon_sym__Alignas] = ACTIONS(2898),
    [sym_primitive_type] = ACTIONS(2898),
    [anon_sym_enum] = ACTIONS(2898),
    [anon_sym_class] = ACTIONS(2898),
    [anon_sym_struct] = ACTIONS(2898),
    [anon_sym_union] = ACTIONS(2898),
    [anon_sym_if] = ACTIONS(2898),
    [anon_sym_else] = ACTIONS(2898),
    [anon_sym_switch] = ACTIONS(2898),
    [anon_sym_case] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2898),
    [anon_sym_while] = ACTIONS(2898),
    [anon_sym_do] = ACTIONS(2898),
    [anon_sym_for] = ACTIONS(2898),
    [anon_sym_return] = ACTIONS(2898),
    [anon_sym_break] = ACTIONS(2898),
    [anon_sym_continue] = ACTIONS(2898),
    [anon_sym_goto] = ACTIONS(2898),
    [anon_sym___try] = ACTIONS(2898),
    [anon_sym___leave] = ACTIONS(2898),
    [anon_sym_not] = ACTIONS(2898),
    [anon_sym_compl] = ACTIONS(2898),
    [anon_sym_DASH_DASH] = ACTIONS(2900),
    [anon_sym_PLUS_PLUS] = ACTIONS(2900),
    [anon_sym_sizeof] = ACTIONS(2898),
    [anon_sym___alignof__] = ACTIONS(2898),
    [anon_sym___alignof] = ACTIONS(2898),
    [anon_sym__alignof] = ACTIONS(2898),
    [anon_sym_alignof] = ACTIONS(2898),
    [anon_sym__Alignof] = ACTIONS(2898),
    [anon_sym_offsetof] = ACTIONS(2898),
    [anon_sym__Generic] = ACTIONS(2898),
    [anon_sym_asm] = ACTIONS(2898),
    [anon_sym___asm__] = ACTIONS(2898),
    [sym_number_literal] = ACTIONS(2900),
    [anon_sym_L_SQUOTE] = ACTIONS(2900),
    [anon_sym_u_SQUOTE] = ACTIONS(2900),
    [anon_sym_U_SQUOTE] = ACTIONS(2900),
    [anon_sym_u8_SQUOTE] = ACTIONS(2900),
    [anon_sym_SQUOTE] = ACTIONS(2900),
    [anon_sym_L_DQUOTE] = ACTIONS(2900),
    [anon_sym_u_DQUOTE] = ACTIONS(2900),
    [anon_sym_U_DQUOTE] = ACTIONS(2900),
    [anon_sym_u8_DQUOTE] = ACTIONS(2900),
    [anon_sym_DQUOTE] = ACTIONS(2900),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2898),
    [anon_sym_nullptr] = ACTIONS(2898),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2898),
    [anon_sym_let] = ACTIONS(2898),
    [anon_sym_This] = ACTIONS(2898),
    [anon_sym_decltype] = ACTIONS(2898),
    [sym_virtual] = ACTIONS(2898),
    [anon_sym_explicit] = ACTIONS(2898),
    [anon_sym_typename] = ACTIONS(2898),
    [anon_sym_template] = ACTIONS(2898),
    [anon_sym_operator] = ACTIONS(2898),
    [anon_sym_try] = ACTIONS(2898),
    [anon_sym_delete] = ACTIONS(2898),
    [anon_sym_throw] = ACTIONS(2898),
    [anon_sym_namespace] = ACTIONS(2898),
    [anon_sym_using] = ACTIONS(2898),
    [anon_sym_static_assert] = ACTIONS(2898),
    [anon_sym_concept] = ACTIONS(2898),
    [anon_sym_co_return] = ACTIONS(2898),
    [anon_sym_co_yield] = ACTIONS(2898),
    [anon_sym_R_DQUOTE] = ACTIONS(2900),
    [anon_sym_LR_DQUOTE] = ACTIONS(2900),
    [anon_sym_uR_DQUOTE] = ACTIONS(2900),
    [anon_sym_UR_DQUOTE] = ACTIONS(2900),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2900),
    [anon_sym_co_await] = ACTIONS(2898),
    [anon_sym_new] = ACTIONS(2898),
    [anon_sym_requires] = ACTIONS(2898),
    [sym_this] = ACTIONS(2898),
    [anon_sym_discard] = ACTIONS(2898),
    [anon_sym_precise] = ACTIONS(2898),
    [anon_sym_shared] = ACTIONS(2898),
    [anon_sym_groupshared] = ACTIONS(2898),
    [anon_sym_uniform] = ACTIONS(2898),
    [anon_sym_row_major] = ACTIONS(2898),
    [anon_sym_column_major] = ACTIONS(2898),
    [anon_sym_globallycoherent] = ACTIONS(2898),
    [anon_sym_centroid] = ACTIONS(2898),
    [anon_sym_noperspective] = ACTIONS(2898),
    [anon_sym_nointerpolation] = ACTIONS(2898),
    [anon_sym_sample] = ACTIONS(2898),
    [anon_sym_linear] = ACTIONS(2898),
    [anon_sym_snorm] = ACTIONS(2898),
    [anon_sym_unorm] = ACTIONS(2898),
    [anon_sym_point] = ACTIONS(2898),
    [anon_sym_line] = ACTIONS(2898),
    [anon_sym_triangleadj] = ACTIONS(2898),
    [anon_sym_lineadj] = ACTIONS(2898),
    [anon_sym_triangle] = ACTIONS(2898),
    [anon_sym_cbuffer] = ACTIONS(2898),
    [anon_sym_interface] = ACTIONS(2898),
    [anon_sym_extension] = ACTIONS(2898),
  },
  [293] = {
    [sym_identifier] = ACTIONS(2902),
    [aux_sym_preproc_include_token1] = ACTIONS(2902),
    [aux_sym_preproc_def_token1] = ACTIONS(2902),
    [aux_sym_preproc_if_token1] = ACTIONS(2902),
    [aux_sym_preproc_if_token2] = ACTIONS(2902),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2902),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2902),
    [aux_sym_preproc_else_token1] = ACTIONS(2902),
    [aux_sym_preproc_elif_token1] = ACTIONS(2902),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2902),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2902),
    [sym_preproc_directive] = ACTIONS(2902),
    [anon_sym_LPAREN2] = ACTIONS(2904),
    [anon_sym_BANG] = ACTIONS(2904),
    [anon_sym_TILDE] = ACTIONS(2904),
    [anon_sym_DASH] = ACTIONS(2902),
    [anon_sym_PLUS] = ACTIONS(2902),
    [anon_sym_STAR] = ACTIONS(2904),
    [anon_sym_AMP_AMP] = ACTIONS(2904),
    [anon_sym_AMP] = ACTIONS(2902),
    [anon_sym_SEMI] = ACTIONS(2904),
    [anon_sym___extension__] = ACTIONS(2902),
    [anon_sym_typedef] = ACTIONS(2902),
    [anon_sym_in] = ACTIONS(2902),
    [anon_sym_out] = ACTIONS(2902),
    [anon_sym_inout] = ACTIONS(2902),
    [anon_sym_extern] = ACTIONS(2902),
    [anon_sym___attribute__] = ACTIONS(2902),
    [anon_sym_COLON_COLON] = ACTIONS(2904),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2904),
    [anon_sym___declspec] = ACTIONS(2902),
    [anon_sym___based] = ACTIONS(2902),
    [anon_sym___cdecl] = ACTIONS(2902),
    [anon_sym___clrcall] = ACTIONS(2902),
    [anon_sym___stdcall] = ACTIONS(2902),
    [anon_sym___fastcall] = ACTIONS(2902),
    [anon_sym___thiscall] = ACTIONS(2902),
    [anon_sym___vectorcall] = ACTIONS(2902),
    [anon_sym_LBRACE] = ACTIONS(2904),
    [anon_sym_signed] = ACTIONS(2902),
    [anon_sym_unsigned] = ACTIONS(2902),
    [anon_sym_long] = ACTIONS(2902),
    [anon_sym_short] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2902),
    [anon_sym_static] = ACTIONS(2902),
    [anon_sym_register] = ACTIONS(2902),
    [anon_sym_inline] = ACTIONS(2902),
    [anon_sym___inline] = ACTIONS(2902),
    [anon_sym___inline__] = ACTIONS(2902),
    [anon_sym___forceinline] = ACTIONS(2902),
    [anon_sym_thread_local] = ACTIONS(2902),
    [anon_sym___thread] = ACTIONS(2902),
    [anon_sym_const] = ACTIONS(2902),
    [anon_sym_constexpr] = ACTIONS(2902),
    [anon_sym_volatile] = ACTIONS(2902),
    [anon_sym_restrict] = ACTIONS(2902),
    [anon_sym___restrict__] = ACTIONS(2902),
    [anon_sym__Atomic] = ACTIONS(2902),
    [anon_sym__Noreturn] = ACTIONS(2902),
    [anon_sym_noreturn] = ACTIONS(2902),
    [anon_sym_mutable] = ACTIONS(2902),
    [anon_sym_constinit] = ACTIONS(2902),
    [anon_sym_consteval] = ACTIONS(2902),
    [anon_sym_alignas] = ACTIONS(2902),
    [anon_sym__Alignas] = ACTIONS(2902),
    [sym_primitive_type] = ACTIONS(2902),
    [anon_sym_enum] = ACTIONS(2902),
    [anon_sym_class] = ACTIONS(2902),
    [anon_sym_struct] = ACTIONS(2902),
    [anon_sym_union] = ACTIONS(2902),
    [anon_sym_if] = ACTIONS(2902),
    [anon_sym_else] = ACTIONS(2902),
    [anon_sym_switch] = ACTIONS(2902),
    [anon_sym_case] = ACTIONS(2902),
    [anon_sym_default] = ACTIONS(2902),
    [anon_sym_while] = ACTIONS(2902),
    [anon_sym_do] = ACTIONS(2902),
    [anon_sym_for] = ACTIONS(2902),
    [anon_sym_return] = ACTIONS(2902),
    [anon_sym_break] = ACTIONS(2902),
    [anon_sym_continue] = ACTIONS(2902),
    [anon_sym_goto] = ACTIONS(2902),
    [anon_sym___try] = ACTIONS(2902),
    [anon_sym___leave] = ACTIONS(2902),
    [anon_sym_not] = ACTIONS(2902),
    [anon_sym_compl] = ACTIONS(2902),
    [anon_sym_DASH_DASH] = ACTIONS(2904),
    [anon_sym_PLUS_PLUS] = ACTIONS(2904),
    [anon_sym_sizeof] = ACTIONS(2902),
    [anon_sym___alignof__] = ACTIONS(2902),
    [anon_sym___alignof] = ACTIONS(2902),
    [anon_sym__alignof] = ACTIONS(2902),
    [anon_sym_alignof] = ACTIONS(2902),
    [anon_sym__Alignof] = ACTIONS(2902),
    [anon_sym_offsetof] = ACTIONS(2902),
    [anon_sym__Generic] = ACTIONS(2902),
    [anon_sym_asm] = ACTIONS(2902),
    [anon_sym___asm__] = ACTIONS(2902),
    [sym_number_literal] = ACTIONS(2904),
    [anon_sym_L_SQUOTE] = ACTIONS(2904),
    [anon_sym_u_SQUOTE] = ACTIONS(2904),
    [anon_sym_U_SQUOTE] = ACTIONS(2904),
    [anon_sym_u8_SQUOTE] = ACTIONS(2904),
    [anon_sym_SQUOTE] = ACTIONS(2904),
    [anon_sym_L_DQUOTE] = ACTIONS(2904),
    [anon_sym_u_DQUOTE] = ACTIONS(2904),
    [anon_sym_U_DQUOTE] = ACTIONS(2904),
    [anon_sym_u8_DQUOTE] = ACTIONS(2904),
    [anon_sym_DQUOTE] = ACTIONS(2904),
    [sym_true] = ACTIONS(2902),
    [sym_false] = ACTIONS(2902),
    [anon_sym_NULL] = ACTIONS(2902),
    [anon_sym_nullptr] = ACTIONS(2902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2902),
    [anon_sym_let] = ACTIONS(2902),
    [anon_sym_This] = ACTIONS(2902),
    [anon_sym_decltype] = ACTIONS(2902),
    [sym_virtual] = ACTIONS(2902),
    [anon_sym_explicit] = ACTIONS(2902),
    [anon_sym_typename] = ACTIONS(2902),
    [anon_sym_template] = ACTIONS(2902),
    [anon_sym_operator] = ACTIONS(2902),
    [anon_sym_try] = ACTIONS(2902),
    [anon_sym_delete] = ACTIONS(2902),
    [anon_sym_throw] = ACTIONS(2902),
    [anon_sym_namespace] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_static_assert] = ACTIONS(2902),
    [anon_sym_concept] = ACTIONS(2902),
    [anon_sym_co_return] = ACTIONS(2902),
    [anon_sym_co_yield] = ACTIONS(2902),
    [anon_sym_R_DQUOTE] = ACTIONS(2904),
    [anon_sym_LR_DQUOTE] = ACTIONS(2904),
    [anon_sym_uR_DQUOTE] = ACTIONS(2904),
    [anon_sym_UR_DQUOTE] = ACTIONS(2904),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2904),
    [anon_sym_co_await] = ACTIONS(2902),
    [anon_sym_new] = ACTIONS(2902),
    [anon_sym_requires] = ACTIONS(2902),
    [sym_this] = ACTIONS(2902),
    [anon_sym_discard] = ACTIONS(2902),
    [anon_sym_precise] = ACTIONS(2902),
    [anon_sym_shared] = ACTIONS(2902),
    [anon_sym_groupshared] = ACTIONS(2902),
    [anon_sym_uniform] = ACTIONS(2902),
    [anon_sym_row_major] = ACTIONS(2902),
    [anon_sym_column_major] = ACTIONS(2902),
    [anon_sym_globallycoherent] = ACTIONS(2902),
    [anon_sym_centroid] = ACTIONS(2902),
    [anon_sym_noperspective] = ACTIONS(2902),
    [anon_sym_nointerpolation] = ACTIONS(2902),
    [anon_sym_sample] = ACTIONS(2902),
    [anon_sym_linear] = ACTIONS(2902),
    [anon_sym_snorm] = ACTIONS(2902),
    [anon_sym_unorm] = ACTIONS(2902),
    [anon_sym_point] = ACTIONS(2902),
    [anon_sym_line] = ACTIONS(2902),
    [anon_sym_triangleadj] = ACTIONS(2902),
    [anon_sym_lineadj] = ACTIONS(2902),
    [anon_sym_triangle] = ACTIONS(2902),
    [anon_sym_cbuffer] = ACTIONS(2902),
    [anon_sym_interface] = ACTIONS(2902),
    [anon_sym_extension] = ACTIONS(2902),
  },
  [294] = {
    [sym_preproc_def] = STATE(390),
    [sym_preproc_function_def] = STATE(390),
    [sym_preproc_call] = STATE(390),
    [sym_preproc_if_in_field_declaration_list] = STATE(390),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(390),
    [sym_type_definition] = STATE(390),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(390),
    [sym_field_declaration] = STATE(390),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(390),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(390),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(390),
    [sym_operator_cast_declaration] = STATE(390),
    [sym_constructor_or_destructor_definition] = STATE(390),
    [sym_constructor_or_destructor_declaration] = STATE(390),
    [sym_friend_declaration] = STATE(390),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(390),
    [sym_alias_declaration] = STATE(390),
    [sym_static_assert_declaration] = STATE(390),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(390),
    [sym_subscript_declaration] = STATE(390),
    [sym_property_declaration] = STATE(390),
    [sym_associatedtype_declaration] = STATE(390),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(390),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(2906),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [295] = {
    [ts_builtin_sym_end] = ACTIONS(2908),
    [sym_identifier] = ACTIONS(2910),
    [aux_sym_preproc_include_token1] = ACTIONS(2910),
    [aux_sym_preproc_def_token1] = ACTIONS(2910),
    [anon_sym_COMMA] = ACTIONS(2908),
    [anon_sym_RPAREN] = ACTIONS(2908),
    [aux_sym_preproc_if_token1] = ACTIONS(2910),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2910),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2910),
    [sym_preproc_directive] = ACTIONS(2910),
    [anon_sym_LPAREN2] = ACTIONS(2908),
    [anon_sym_BANG] = ACTIONS(2908),
    [anon_sym_TILDE] = ACTIONS(2908),
    [anon_sym_DASH] = ACTIONS(2910),
    [anon_sym_PLUS] = ACTIONS(2910),
    [anon_sym_STAR] = ACTIONS(2908),
    [anon_sym_AMP_AMP] = ACTIONS(2908),
    [anon_sym_AMP] = ACTIONS(2910),
    [anon_sym_SEMI] = ACTIONS(2908),
    [anon_sym___extension__] = ACTIONS(2910),
    [anon_sym_typedef] = ACTIONS(2910),
    [anon_sym_in] = ACTIONS(2910),
    [anon_sym_out] = ACTIONS(2910),
    [anon_sym_inout] = ACTIONS(2910),
    [anon_sym_extern] = ACTIONS(2910),
    [anon_sym___attribute__] = ACTIONS(2910),
    [anon_sym_COLON_COLON] = ACTIONS(2908),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2908),
    [anon_sym___declspec] = ACTIONS(2910),
    [anon_sym___based] = ACTIONS(2910),
    [anon_sym___cdecl] = ACTIONS(2910),
    [anon_sym___clrcall] = ACTIONS(2910),
    [anon_sym___stdcall] = ACTIONS(2910),
    [anon_sym___fastcall] = ACTIONS(2910),
    [anon_sym___thiscall] = ACTIONS(2910),
    [anon_sym___vectorcall] = ACTIONS(2910),
    [anon_sym_LBRACE] = ACTIONS(2908),
    [anon_sym_signed] = ACTIONS(2910),
    [anon_sym_unsigned] = ACTIONS(2910),
    [anon_sym_long] = ACTIONS(2910),
    [anon_sym_short] = ACTIONS(2910),
    [anon_sym_LBRACK] = ACTIONS(2910),
    [anon_sym_static] = ACTIONS(2910),
    [anon_sym_register] = ACTIONS(2910),
    [anon_sym_inline] = ACTIONS(2910),
    [anon_sym___inline] = ACTIONS(2910),
    [anon_sym___inline__] = ACTIONS(2910),
    [anon_sym___forceinline] = ACTIONS(2910),
    [anon_sym_thread_local] = ACTIONS(2910),
    [anon_sym___thread] = ACTIONS(2910),
    [anon_sym_const] = ACTIONS(2910),
    [anon_sym_constexpr] = ACTIONS(2910),
    [anon_sym_volatile] = ACTIONS(2910),
    [anon_sym_restrict] = ACTIONS(2910),
    [anon_sym___restrict__] = ACTIONS(2910),
    [anon_sym__Atomic] = ACTIONS(2910),
    [anon_sym__Noreturn] = ACTIONS(2910),
    [anon_sym_noreturn] = ACTIONS(2910),
    [anon_sym_mutable] = ACTIONS(2910),
    [anon_sym_constinit] = ACTIONS(2910),
    [anon_sym_consteval] = ACTIONS(2910),
    [anon_sym_alignas] = ACTIONS(2910),
    [anon_sym__Alignas] = ACTIONS(2910),
    [sym_primitive_type] = ACTIONS(2910),
    [anon_sym_enum] = ACTIONS(2910),
    [anon_sym_class] = ACTIONS(2910),
    [anon_sym_struct] = ACTIONS(2910),
    [anon_sym_union] = ACTIONS(2910),
    [anon_sym_if] = ACTIONS(2910),
    [anon_sym_switch] = ACTIONS(2910),
    [anon_sym_case] = ACTIONS(2910),
    [anon_sym_default] = ACTIONS(2910),
    [anon_sym_while] = ACTIONS(2910),
    [anon_sym_do] = ACTIONS(2910),
    [anon_sym_for] = ACTIONS(2910),
    [anon_sym_return] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2910),
    [anon_sym_continue] = ACTIONS(2910),
    [anon_sym_goto] = ACTIONS(2910),
    [anon_sym_not] = ACTIONS(2910),
    [anon_sym_compl] = ACTIONS(2910),
    [anon_sym_DASH_DASH] = ACTIONS(2908),
    [anon_sym_PLUS_PLUS] = ACTIONS(2908),
    [anon_sym_sizeof] = ACTIONS(2910),
    [anon_sym___alignof__] = ACTIONS(2910),
    [anon_sym___alignof] = ACTIONS(2910),
    [anon_sym__alignof] = ACTIONS(2910),
    [anon_sym_alignof] = ACTIONS(2910),
    [anon_sym__Alignof] = ACTIONS(2910),
    [anon_sym_offsetof] = ACTIONS(2910),
    [anon_sym__Generic] = ACTIONS(2910),
    [anon_sym_asm] = ACTIONS(2910),
    [anon_sym___asm__] = ACTIONS(2910),
    [anon_sym_DOT] = ACTIONS(2910),
    [sym_number_literal] = ACTIONS(2908),
    [anon_sym_L_SQUOTE] = ACTIONS(2908),
    [anon_sym_u_SQUOTE] = ACTIONS(2908),
    [anon_sym_U_SQUOTE] = ACTIONS(2908),
    [anon_sym_u8_SQUOTE] = ACTIONS(2908),
    [anon_sym_SQUOTE] = ACTIONS(2908),
    [anon_sym_L_DQUOTE] = ACTIONS(2908),
    [anon_sym_u_DQUOTE] = ACTIONS(2908),
    [anon_sym_U_DQUOTE] = ACTIONS(2908),
    [anon_sym_u8_DQUOTE] = ACTIONS(2908),
    [anon_sym_DQUOTE] = ACTIONS(2908),
    [sym_true] = ACTIONS(2910),
    [sym_false] = ACTIONS(2910),
    [anon_sym_NULL] = ACTIONS(2910),
    [anon_sym_nullptr] = ACTIONS(2910),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2910),
    [anon_sym_let] = ACTIONS(2910),
    [anon_sym_This] = ACTIONS(2910),
    [anon_sym_decltype] = ACTIONS(2910),
    [anon_sym_final] = ACTIONS(2910),
    [anon_sym_override] = ACTIONS(2910),
    [sym_virtual] = ACTIONS(2910),
    [anon_sym_explicit] = ACTIONS(2910),
    [anon_sym_typename] = ACTIONS(2910),
    [anon_sym_template] = ACTIONS(2910),
    [anon_sym_GT2] = ACTIONS(2908),
    [anon_sym_operator] = ACTIONS(2910),
    [anon_sym_try] = ACTIONS(2910),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_throw] = ACTIONS(2910),
    [anon_sym_namespace] = ACTIONS(2910),
    [anon_sym_using] = ACTIONS(2910),
    [anon_sym_static_assert] = ACTIONS(2910),
    [anon_sym_concept] = ACTIONS(2910),
    [anon_sym_co_return] = ACTIONS(2910),
    [anon_sym_co_yield] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2908),
    [anon_sym_LR_DQUOTE] = ACTIONS(2908),
    [anon_sym_uR_DQUOTE] = ACTIONS(2908),
    [anon_sym_UR_DQUOTE] = ACTIONS(2908),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2908),
    [anon_sym_co_await] = ACTIONS(2910),
    [anon_sym_new] = ACTIONS(2910),
    [anon_sym_requires] = ACTIONS(2910),
    [sym_this] = ACTIONS(2910),
    [anon_sym_precise] = ACTIONS(2910),
    [anon_sym_shared] = ACTIONS(2910),
    [anon_sym_groupshared] = ACTIONS(2910),
    [anon_sym_uniform] = ACTIONS(2910),
    [anon_sym_row_major] = ACTIONS(2910),
    [anon_sym_column_major] = ACTIONS(2910),
    [anon_sym_globallycoherent] = ACTIONS(2910),
    [anon_sym_centroid] = ACTIONS(2910),
    [anon_sym_noperspective] = ACTIONS(2910),
    [anon_sym_nointerpolation] = ACTIONS(2910),
    [anon_sym_sample] = ACTIONS(2910),
    [anon_sym_linear] = ACTIONS(2910),
    [anon_sym_snorm] = ACTIONS(2910),
    [anon_sym_unorm] = ACTIONS(2910),
    [anon_sym_point] = ACTIONS(2910),
    [anon_sym_line] = ACTIONS(2910),
    [anon_sym_triangleadj] = ACTIONS(2910),
    [anon_sym_lineadj] = ACTIONS(2910),
    [anon_sym_triangle] = ACTIONS(2910),
    [anon_sym_interface] = ACTIONS(2910),
    [anon_sym_extension] = ACTIONS(2910),
    [anon_sym_where] = ACTIONS(2910),
    [anon_sym___exported] = ACTIONS(2910),
    [anon_sym_import] = ACTIONS(2910),
  },
  [296] = {
    [sym_preproc_def] = STATE(404),
    [sym_preproc_function_def] = STATE(404),
    [sym_preproc_call] = STATE(404),
    [sym_preproc_if_in_field_declaration_list] = STATE(404),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(404),
    [sym_type_definition] = STATE(404),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6811),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7427),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(404),
    [sym_field_declaration] = STATE(404),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2593),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(404),
    [sym_operator_cast] = STATE(8371),
    [sym_inline_method_definition] = STATE(404),
    [sym__constructor_specifiers] = STATE(2593),
    [sym_operator_cast_definition] = STATE(404),
    [sym_operator_cast_declaration] = STATE(404),
    [sym_constructor_or_destructor_definition] = STATE(404),
    [sym_constructor_or_destructor_declaration] = STATE(404),
    [sym_friend_declaration] = STATE(404),
    [sym_access_specifier] = STATE(10305),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(404),
    [sym_alias_declaration] = STATE(404),
    [sym_static_assert_declaration] = STATE(404),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8371),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(404),
    [sym_subscript_declaration] = STATE(404),
    [sym_property_declaration] = STATE(404),
    [sym_associatedtype_declaration] = STATE(404),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(404),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2593),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2912),
    [aux_sym_preproc_if_token1] = ACTIONS(2914),
    [aux_sym_preproc_if_token2] = ACTIONS(2916),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2918),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2918),
    [sym_preproc_directive] = ACTIONS(2920),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2922),
    [anon_sym_typedef] = ACTIONS(2924),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2926),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2928),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2930),
    [anon_sym_static_assert] = ACTIONS(2932),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2934),
    [anon_sym___subscript] = ACTIONS(2936),
    [anon_sym_property] = ACTIONS(2938),
    [anon_sym_associatedtype] = ACTIONS(2940),
  },
  [297] = {
    [ts_builtin_sym_end] = ACTIONS(2942),
    [sym_identifier] = ACTIONS(2944),
    [aux_sym_preproc_include_token1] = ACTIONS(2944),
    [aux_sym_preproc_def_token1] = ACTIONS(2944),
    [anon_sym_COMMA] = ACTIONS(2942),
    [anon_sym_RPAREN] = ACTIONS(2942),
    [aux_sym_preproc_if_token1] = ACTIONS(2944),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2944),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2944),
    [sym_preproc_directive] = ACTIONS(2944),
    [anon_sym_LPAREN2] = ACTIONS(2942),
    [anon_sym_BANG] = ACTIONS(2942),
    [anon_sym_TILDE] = ACTIONS(2942),
    [anon_sym_DASH] = ACTIONS(2944),
    [anon_sym_PLUS] = ACTIONS(2944),
    [anon_sym_STAR] = ACTIONS(2942),
    [anon_sym_AMP_AMP] = ACTIONS(2942),
    [anon_sym_AMP] = ACTIONS(2944),
    [anon_sym_SEMI] = ACTIONS(2942),
    [anon_sym___extension__] = ACTIONS(2944),
    [anon_sym_typedef] = ACTIONS(2944),
    [anon_sym_in] = ACTIONS(2944),
    [anon_sym_out] = ACTIONS(2944),
    [anon_sym_inout] = ACTIONS(2944),
    [anon_sym_extern] = ACTIONS(2944),
    [anon_sym___attribute__] = ACTIONS(2944),
    [anon_sym_COLON_COLON] = ACTIONS(2942),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2942),
    [anon_sym___declspec] = ACTIONS(2944),
    [anon_sym___based] = ACTIONS(2944),
    [anon_sym___cdecl] = ACTIONS(2944),
    [anon_sym___clrcall] = ACTIONS(2944),
    [anon_sym___stdcall] = ACTIONS(2944),
    [anon_sym___fastcall] = ACTIONS(2944),
    [anon_sym___thiscall] = ACTIONS(2944),
    [anon_sym___vectorcall] = ACTIONS(2944),
    [anon_sym_LBRACE] = ACTIONS(2942),
    [anon_sym_signed] = ACTIONS(2944),
    [anon_sym_unsigned] = ACTIONS(2944),
    [anon_sym_long] = ACTIONS(2944),
    [anon_sym_short] = ACTIONS(2944),
    [anon_sym_LBRACK] = ACTIONS(2944),
    [anon_sym_static] = ACTIONS(2944),
    [anon_sym_register] = ACTIONS(2944),
    [anon_sym_inline] = ACTIONS(2944),
    [anon_sym___inline] = ACTIONS(2944),
    [anon_sym___inline__] = ACTIONS(2944),
    [anon_sym___forceinline] = ACTIONS(2944),
    [anon_sym_thread_local] = ACTIONS(2944),
    [anon_sym___thread] = ACTIONS(2944),
    [anon_sym_const] = ACTIONS(2944),
    [anon_sym_constexpr] = ACTIONS(2944),
    [anon_sym_volatile] = ACTIONS(2944),
    [anon_sym_restrict] = ACTIONS(2944),
    [anon_sym___restrict__] = ACTIONS(2944),
    [anon_sym__Atomic] = ACTIONS(2944),
    [anon_sym__Noreturn] = ACTIONS(2944),
    [anon_sym_noreturn] = ACTIONS(2944),
    [anon_sym_mutable] = ACTIONS(2944),
    [anon_sym_constinit] = ACTIONS(2944),
    [anon_sym_consteval] = ACTIONS(2944),
    [anon_sym_alignas] = ACTIONS(2944),
    [anon_sym__Alignas] = ACTIONS(2944),
    [sym_primitive_type] = ACTIONS(2944),
    [anon_sym_enum] = ACTIONS(2944),
    [anon_sym_class] = ACTIONS(2944),
    [anon_sym_struct] = ACTIONS(2944),
    [anon_sym_union] = ACTIONS(2944),
    [anon_sym_if] = ACTIONS(2944),
    [anon_sym_switch] = ACTIONS(2944),
    [anon_sym_case] = ACTIONS(2944),
    [anon_sym_default] = ACTIONS(2944),
    [anon_sym_while] = ACTIONS(2944),
    [anon_sym_do] = ACTIONS(2944),
    [anon_sym_for] = ACTIONS(2944),
    [anon_sym_return] = ACTIONS(2944),
    [anon_sym_break] = ACTIONS(2944),
    [anon_sym_continue] = ACTIONS(2944),
    [anon_sym_goto] = ACTIONS(2944),
    [anon_sym_not] = ACTIONS(2944),
    [anon_sym_compl] = ACTIONS(2944),
    [anon_sym_DASH_DASH] = ACTIONS(2942),
    [anon_sym_PLUS_PLUS] = ACTIONS(2942),
    [anon_sym_sizeof] = ACTIONS(2944),
    [anon_sym___alignof__] = ACTIONS(2944),
    [anon_sym___alignof] = ACTIONS(2944),
    [anon_sym__alignof] = ACTIONS(2944),
    [anon_sym_alignof] = ACTIONS(2944),
    [anon_sym__Alignof] = ACTIONS(2944),
    [anon_sym_offsetof] = ACTIONS(2944),
    [anon_sym__Generic] = ACTIONS(2944),
    [anon_sym_asm] = ACTIONS(2944),
    [anon_sym___asm__] = ACTIONS(2944),
    [anon_sym_DOT] = ACTIONS(2944),
    [sym_number_literal] = ACTIONS(2942),
    [anon_sym_L_SQUOTE] = ACTIONS(2942),
    [anon_sym_u_SQUOTE] = ACTIONS(2942),
    [anon_sym_U_SQUOTE] = ACTIONS(2942),
    [anon_sym_u8_SQUOTE] = ACTIONS(2942),
    [anon_sym_SQUOTE] = ACTIONS(2942),
    [anon_sym_L_DQUOTE] = ACTIONS(2942),
    [anon_sym_u_DQUOTE] = ACTIONS(2942),
    [anon_sym_U_DQUOTE] = ACTIONS(2942),
    [anon_sym_u8_DQUOTE] = ACTIONS(2942),
    [anon_sym_DQUOTE] = ACTIONS(2942),
    [sym_true] = ACTIONS(2944),
    [sym_false] = ACTIONS(2944),
    [anon_sym_NULL] = ACTIONS(2944),
    [anon_sym_nullptr] = ACTIONS(2944),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2944),
    [anon_sym_let] = ACTIONS(2944),
    [anon_sym_This] = ACTIONS(2944),
    [anon_sym_decltype] = ACTIONS(2944),
    [anon_sym_final] = ACTIONS(2944),
    [anon_sym_override] = ACTIONS(2944),
    [sym_virtual] = ACTIONS(2944),
    [anon_sym_explicit] = ACTIONS(2944),
    [anon_sym_typename] = ACTIONS(2944),
    [anon_sym_template] = ACTIONS(2944),
    [anon_sym_GT2] = ACTIONS(2942),
    [anon_sym_operator] = ACTIONS(2944),
    [anon_sym_try] = ACTIONS(2944),
    [anon_sym_delete] = ACTIONS(2944),
    [anon_sym_throw] = ACTIONS(2944),
    [anon_sym_namespace] = ACTIONS(2944),
    [anon_sym_using] = ACTIONS(2944),
    [anon_sym_static_assert] = ACTIONS(2944),
    [anon_sym_concept] = ACTIONS(2944),
    [anon_sym_co_return] = ACTIONS(2944),
    [anon_sym_co_yield] = ACTIONS(2944),
    [anon_sym_R_DQUOTE] = ACTIONS(2942),
    [anon_sym_LR_DQUOTE] = ACTIONS(2942),
    [anon_sym_uR_DQUOTE] = ACTIONS(2942),
    [anon_sym_UR_DQUOTE] = ACTIONS(2942),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2942),
    [anon_sym_co_await] = ACTIONS(2944),
    [anon_sym_new] = ACTIONS(2944),
    [anon_sym_requires] = ACTIONS(2944),
    [sym_this] = ACTIONS(2944),
    [anon_sym_precise] = ACTIONS(2944),
    [anon_sym_shared] = ACTIONS(2944),
    [anon_sym_groupshared] = ACTIONS(2944),
    [anon_sym_uniform] = ACTIONS(2944),
    [anon_sym_row_major] = ACTIONS(2944),
    [anon_sym_column_major] = ACTIONS(2944),
    [anon_sym_globallycoherent] = ACTIONS(2944),
    [anon_sym_centroid] = ACTIONS(2944),
    [anon_sym_noperspective] = ACTIONS(2944),
    [anon_sym_nointerpolation] = ACTIONS(2944),
    [anon_sym_sample] = ACTIONS(2944),
    [anon_sym_linear] = ACTIONS(2944),
    [anon_sym_snorm] = ACTIONS(2944),
    [anon_sym_unorm] = ACTIONS(2944),
    [anon_sym_point] = ACTIONS(2944),
    [anon_sym_line] = ACTIONS(2944),
    [anon_sym_triangleadj] = ACTIONS(2944),
    [anon_sym_lineadj] = ACTIONS(2944),
    [anon_sym_triangle] = ACTIONS(2944),
    [anon_sym_interface] = ACTIONS(2944),
    [anon_sym_extension] = ACTIONS(2944),
    [anon_sym_where] = ACTIONS(2944),
    [anon_sym___exported] = ACTIONS(2944),
    [anon_sym_import] = ACTIONS(2944),
  },
  [298] = {
    [ts_builtin_sym_end] = ACTIONS(2946),
    [sym_identifier] = ACTIONS(2948),
    [aux_sym_preproc_include_token1] = ACTIONS(2948),
    [aux_sym_preproc_def_token1] = ACTIONS(2948),
    [anon_sym_COMMA] = ACTIONS(2946),
    [anon_sym_RPAREN] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2948),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2948),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2948),
    [sym_preproc_directive] = ACTIONS(2948),
    [anon_sym_LPAREN2] = ACTIONS(2946),
    [anon_sym_BANG] = ACTIONS(2946),
    [anon_sym_TILDE] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2948),
    [anon_sym_PLUS] = ACTIONS(2948),
    [anon_sym_STAR] = ACTIONS(2946),
    [anon_sym_AMP_AMP] = ACTIONS(2946),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2946),
    [anon_sym___extension__] = ACTIONS(2948),
    [anon_sym_typedef] = ACTIONS(2948),
    [anon_sym_in] = ACTIONS(2948),
    [anon_sym_out] = ACTIONS(2948),
    [anon_sym_inout] = ACTIONS(2948),
    [anon_sym_extern] = ACTIONS(2948),
    [anon_sym___attribute__] = ACTIONS(2948),
    [anon_sym_COLON_COLON] = ACTIONS(2946),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2946),
    [anon_sym___declspec] = ACTIONS(2948),
    [anon_sym___based] = ACTIONS(2948),
    [anon_sym___cdecl] = ACTIONS(2948),
    [anon_sym___clrcall] = ACTIONS(2948),
    [anon_sym___stdcall] = ACTIONS(2948),
    [anon_sym___fastcall] = ACTIONS(2948),
    [anon_sym___thiscall] = ACTIONS(2948),
    [anon_sym___vectorcall] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2946),
    [anon_sym_signed] = ACTIONS(2948),
    [anon_sym_unsigned] = ACTIONS(2948),
    [anon_sym_long] = ACTIONS(2948),
    [anon_sym_short] = ACTIONS(2948),
    [anon_sym_LBRACK] = ACTIONS(2948),
    [anon_sym_static] = ACTIONS(2948),
    [anon_sym_register] = ACTIONS(2948),
    [anon_sym_inline] = ACTIONS(2948),
    [anon_sym___inline] = ACTIONS(2948),
    [anon_sym___inline__] = ACTIONS(2948),
    [anon_sym___forceinline] = ACTIONS(2948),
    [anon_sym_thread_local] = ACTIONS(2948),
    [anon_sym___thread] = ACTIONS(2948),
    [anon_sym_const] = ACTIONS(2948),
    [anon_sym_constexpr] = ACTIONS(2948),
    [anon_sym_volatile] = ACTIONS(2948),
    [anon_sym_restrict] = ACTIONS(2948),
    [anon_sym___restrict__] = ACTIONS(2948),
    [anon_sym__Atomic] = ACTIONS(2948),
    [anon_sym__Noreturn] = ACTIONS(2948),
    [anon_sym_noreturn] = ACTIONS(2948),
    [anon_sym_mutable] = ACTIONS(2948),
    [anon_sym_constinit] = ACTIONS(2948),
    [anon_sym_consteval] = ACTIONS(2948),
    [anon_sym_alignas] = ACTIONS(2948),
    [anon_sym__Alignas] = ACTIONS(2948),
    [sym_primitive_type] = ACTIONS(2948),
    [anon_sym_enum] = ACTIONS(2948),
    [anon_sym_class] = ACTIONS(2948),
    [anon_sym_struct] = ACTIONS(2948),
    [anon_sym_union] = ACTIONS(2948),
    [anon_sym_if] = ACTIONS(2948),
    [anon_sym_switch] = ACTIONS(2948),
    [anon_sym_case] = ACTIONS(2948),
    [anon_sym_default] = ACTIONS(2948),
    [anon_sym_while] = ACTIONS(2948),
    [anon_sym_do] = ACTIONS(2948),
    [anon_sym_for] = ACTIONS(2948),
    [anon_sym_return] = ACTIONS(2948),
    [anon_sym_break] = ACTIONS(2948),
    [anon_sym_continue] = ACTIONS(2948),
    [anon_sym_goto] = ACTIONS(2948),
    [anon_sym_not] = ACTIONS(2948),
    [anon_sym_compl] = ACTIONS(2948),
    [anon_sym_DASH_DASH] = ACTIONS(2946),
    [anon_sym_PLUS_PLUS] = ACTIONS(2946),
    [anon_sym_sizeof] = ACTIONS(2948),
    [anon_sym___alignof__] = ACTIONS(2948),
    [anon_sym___alignof] = ACTIONS(2948),
    [anon_sym__alignof] = ACTIONS(2948),
    [anon_sym_alignof] = ACTIONS(2948),
    [anon_sym__Alignof] = ACTIONS(2948),
    [anon_sym_offsetof] = ACTIONS(2948),
    [anon_sym__Generic] = ACTIONS(2948),
    [anon_sym_asm] = ACTIONS(2948),
    [anon_sym___asm__] = ACTIONS(2948),
    [anon_sym_DOT] = ACTIONS(2948),
    [sym_number_literal] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2946),
    [anon_sym_u_SQUOTE] = ACTIONS(2946),
    [anon_sym_U_SQUOTE] = ACTIONS(2946),
    [anon_sym_u8_SQUOTE] = ACTIONS(2946),
    [anon_sym_SQUOTE] = ACTIONS(2946),
    [anon_sym_L_DQUOTE] = ACTIONS(2946),
    [anon_sym_u_DQUOTE] = ACTIONS(2946),
    [anon_sym_U_DQUOTE] = ACTIONS(2946),
    [anon_sym_u8_DQUOTE] = ACTIONS(2946),
    [anon_sym_DQUOTE] = ACTIONS(2946),
    [sym_true] = ACTIONS(2948),
    [sym_false] = ACTIONS(2948),
    [anon_sym_NULL] = ACTIONS(2948),
    [anon_sym_nullptr] = ACTIONS(2948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2948),
    [anon_sym_let] = ACTIONS(2948),
    [anon_sym_This] = ACTIONS(2948),
    [anon_sym_decltype] = ACTIONS(2948),
    [anon_sym_final] = ACTIONS(2948),
    [anon_sym_override] = ACTIONS(2948),
    [sym_virtual] = ACTIONS(2948),
    [anon_sym_explicit] = ACTIONS(2948),
    [anon_sym_typename] = ACTIONS(2948),
    [anon_sym_template] = ACTIONS(2948),
    [anon_sym_GT2] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2948),
    [anon_sym_try] = ACTIONS(2948),
    [anon_sym_delete] = ACTIONS(2948),
    [anon_sym_throw] = ACTIONS(2948),
    [anon_sym_namespace] = ACTIONS(2948),
    [anon_sym_using] = ACTIONS(2948),
    [anon_sym_static_assert] = ACTIONS(2948),
    [anon_sym_concept] = ACTIONS(2948),
    [anon_sym_co_return] = ACTIONS(2948),
    [anon_sym_co_yield] = ACTIONS(2948),
    [anon_sym_R_DQUOTE] = ACTIONS(2946),
    [anon_sym_LR_DQUOTE] = ACTIONS(2946),
    [anon_sym_uR_DQUOTE] = ACTIONS(2946),
    [anon_sym_UR_DQUOTE] = ACTIONS(2946),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2946),
    [anon_sym_co_await] = ACTIONS(2948),
    [anon_sym_new] = ACTIONS(2948),
    [anon_sym_requires] = ACTIONS(2948),
    [sym_this] = ACTIONS(2948),
    [anon_sym_precise] = ACTIONS(2948),
    [anon_sym_shared] = ACTIONS(2948),
    [anon_sym_groupshared] = ACTIONS(2948),
    [anon_sym_uniform] = ACTIONS(2948),
    [anon_sym_row_major] = ACTIONS(2948),
    [anon_sym_column_major] = ACTIONS(2948),
    [anon_sym_globallycoherent] = ACTIONS(2948),
    [anon_sym_centroid] = ACTIONS(2948),
    [anon_sym_noperspective] = ACTIONS(2948),
    [anon_sym_nointerpolation] = ACTIONS(2948),
    [anon_sym_sample] = ACTIONS(2948),
    [anon_sym_linear] = ACTIONS(2948),
    [anon_sym_snorm] = ACTIONS(2948),
    [anon_sym_unorm] = ACTIONS(2948),
    [anon_sym_point] = ACTIONS(2948),
    [anon_sym_line] = ACTIONS(2948),
    [anon_sym_triangleadj] = ACTIONS(2948),
    [anon_sym_lineadj] = ACTIONS(2948),
    [anon_sym_triangle] = ACTIONS(2948),
    [anon_sym_interface] = ACTIONS(2948),
    [anon_sym_extension] = ACTIONS(2948),
    [anon_sym_where] = ACTIONS(2948),
    [anon_sym___exported] = ACTIONS(2948),
    [anon_sym_import] = ACTIONS(2948),
  },
  [299] = {
    [sym_identifier] = ACTIONS(2950),
    [aux_sym_preproc_include_token1] = ACTIONS(2950),
    [aux_sym_preproc_def_token1] = ACTIONS(2950),
    [aux_sym_preproc_if_token1] = ACTIONS(2950),
    [aux_sym_preproc_if_token2] = ACTIONS(2950),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2950),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2950),
    [aux_sym_preproc_else_token1] = ACTIONS(2950),
    [aux_sym_preproc_elif_token1] = ACTIONS(2950),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2950),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2950),
    [sym_preproc_directive] = ACTIONS(2950),
    [anon_sym_LPAREN2] = ACTIONS(2952),
    [anon_sym_BANG] = ACTIONS(2952),
    [anon_sym_TILDE] = ACTIONS(2952),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_STAR] = ACTIONS(2952),
    [anon_sym_AMP_AMP] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2950),
    [anon_sym_SEMI] = ACTIONS(2952),
    [anon_sym___extension__] = ACTIONS(2950),
    [anon_sym_typedef] = ACTIONS(2950),
    [anon_sym_in] = ACTIONS(2950),
    [anon_sym_out] = ACTIONS(2950),
    [anon_sym_inout] = ACTIONS(2950),
    [anon_sym_extern] = ACTIONS(2950),
    [anon_sym___attribute__] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2952),
    [anon_sym___declspec] = ACTIONS(2950),
    [anon_sym___based] = ACTIONS(2950),
    [anon_sym___cdecl] = ACTIONS(2950),
    [anon_sym___clrcall] = ACTIONS(2950),
    [anon_sym___stdcall] = ACTIONS(2950),
    [anon_sym___fastcall] = ACTIONS(2950),
    [anon_sym___thiscall] = ACTIONS(2950),
    [anon_sym___vectorcall] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2952),
    [anon_sym_signed] = ACTIONS(2950),
    [anon_sym_unsigned] = ACTIONS(2950),
    [anon_sym_long] = ACTIONS(2950),
    [anon_sym_short] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_static] = ACTIONS(2950),
    [anon_sym_register] = ACTIONS(2950),
    [anon_sym_inline] = ACTIONS(2950),
    [anon_sym___inline] = ACTIONS(2950),
    [anon_sym___inline__] = ACTIONS(2950),
    [anon_sym___forceinline] = ACTIONS(2950),
    [anon_sym_thread_local] = ACTIONS(2950),
    [anon_sym___thread] = ACTIONS(2950),
    [anon_sym_const] = ACTIONS(2950),
    [anon_sym_constexpr] = ACTIONS(2950),
    [anon_sym_volatile] = ACTIONS(2950),
    [anon_sym_restrict] = ACTIONS(2950),
    [anon_sym___restrict__] = ACTIONS(2950),
    [anon_sym__Atomic] = ACTIONS(2950),
    [anon_sym__Noreturn] = ACTIONS(2950),
    [anon_sym_noreturn] = ACTIONS(2950),
    [anon_sym_mutable] = ACTIONS(2950),
    [anon_sym_constinit] = ACTIONS(2950),
    [anon_sym_consteval] = ACTIONS(2950),
    [anon_sym_alignas] = ACTIONS(2950),
    [anon_sym__Alignas] = ACTIONS(2950),
    [sym_primitive_type] = ACTIONS(2950),
    [anon_sym_enum] = ACTIONS(2950),
    [anon_sym_class] = ACTIONS(2950),
    [anon_sym_struct] = ACTIONS(2950),
    [anon_sym_union] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_else] = ACTIONS(2950),
    [anon_sym_switch] = ACTIONS(2950),
    [anon_sym_case] = ACTIONS(2950),
    [anon_sym_default] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_break] = ACTIONS(2950),
    [anon_sym_continue] = ACTIONS(2950),
    [anon_sym_goto] = ACTIONS(2950),
    [anon_sym___try] = ACTIONS(2950),
    [anon_sym___leave] = ACTIONS(2950),
    [anon_sym_not] = ACTIONS(2950),
    [anon_sym_compl] = ACTIONS(2950),
    [anon_sym_DASH_DASH] = ACTIONS(2952),
    [anon_sym_PLUS_PLUS] = ACTIONS(2952),
    [anon_sym_sizeof] = ACTIONS(2950),
    [anon_sym___alignof__] = ACTIONS(2950),
    [anon_sym___alignof] = ACTIONS(2950),
    [anon_sym__alignof] = ACTIONS(2950),
    [anon_sym_alignof] = ACTIONS(2950),
    [anon_sym__Alignof] = ACTIONS(2950),
    [anon_sym_offsetof] = ACTIONS(2950),
    [anon_sym__Generic] = ACTIONS(2950),
    [anon_sym_asm] = ACTIONS(2950),
    [anon_sym___asm__] = ACTIONS(2950),
    [sym_number_literal] = ACTIONS(2952),
    [anon_sym_L_SQUOTE] = ACTIONS(2952),
    [anon_sym_u_SQUOTE] = ACTIONS(2952),
    [anon_sym_U_SQUOTE] = ACTIONS(2952),
    [anon_sym_u8_SQUOTE] = ACTIONS(2952),
    [anon_sym_SQUOTE] = ACTIONS(2952),
    [anon_sym_L_DQUOTE] = ACTIONS(2952),
    [anon_sym_u_DQUOTE] = ACTIONS(2952),
    [anon_sym_U_DQUOTE] = ACTIONS(2952),
    [anon_sym_u8_DQUOTE] = ACTIONS(2952),
    [anon_sym_DQUOTE] = ACTIONS(2952),
    [sym_true] = ACTIONS(2950),
    [sym_false] = ACTIONS(2950),
    [anon_sym_NULL] = ACTIONS(2950),
    [anon_sym_nullptr] = ACTIONS(2950),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2950),
    [anon_sym_let] = ACTIONS(2950),
    [anon_sym_This] = ACTIONS(2950),
    [anon_sym_decltype] = ACTIONS(2950),
    [sym_virtual] = ACTIONS(2950),
    [anon_sym_explicit] = ACTIONS(2950),
    [anon_sym_typename] = ACTIONS(2950),
    [anon_sym_template] = ACTIONS(2950),
    [anon_sym_operator] = ACTIONS(2950),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_delete] = ACTIONS(2950),
    [anon_sym_throw] = ACTIONS(2950),
    [anon_sym_namespace] = ACTIONS(2950),
    [anon_sym_using] = ACTIONS(2950),
    [anon_sym_static_assert] = ACTIONS(2950),
    [anon_sym_concept] = ACTIONS(2950),
    [anon_sym_co_return] = ACTIONS(2950),
    [anon_sym_co_yield] = ACTIONS(2950),
    [anon_sym_R_DQUOTE] = ACTIONS(2952),
    [anon_sym_LR_DQUOTE] = ACTIONS(2952),
    [anon_sym_uR_DQUOTE] = ACTIONS(2952),
    [anon_sym_UR_DQUOTE] = ACTIONS(2952),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2952),
    [anon_sym_co_await] = ACTIONS(2950),
    [anon_sym_new] = ACTIONS(2950),
    [anon_sym_requires] = ACTIONS(2950),
    [sym_this] = ACTIONS(2950),
    [anon_sym_discard] = ACTIONS(2950),
    [anon_sym_precise] = ACTIONS(2950),
    [anon_sym_shared] = ACTIONS(2950),
    [anon_sym_groupshared] = ACTIONS(2950),
    [anon_sym_uniform] = ACTIONS(2950),
    [anon_sym_row_major] = ACTIONS(2950),
    [anon_sym_column_major] = ACTIONS(2950),
    [anon_sym_globallycoherent] = ACTIONS(2950),
    [anon_sym_centroid] = ACTIONS(2950),
    [anon_sym_noperspective] = ACTIONS(2950),
    [anon_sym_nointerpolation] = ACTIONS(2950),
    [anon_sym_sample] = ACTIONS(2950),
    [anon_sym_linear] = ACTIONS(2950),
    [anon_sym_snorm] = ACTIONS(2950),
    [anon_sym_unorm] = ACTIONS(2950),
    [anon_sym_point] = ACTIONS(2950),
    [anon_sym_line] = ACTIONS(2950),
    [anon_sym_triangleadj] = ACTIONS(2950),
    [anon_sym_lineadj] = ACTIONS(2950),
    [anon_sym_triangle] = ACTIONS(2950),
    [anon_sym_cbuffer] = ACTIONS(2950),
    [anon_sym_interface] = ACTIONS(2950),
    [anon_sym_extension] = ACTIONS(2950),
  },
  [300] = {
    [sym_identifier] = ACTIONS(2954),
    [aux_sym_preproc_include_token1] = ACTIONS(2954),
    [aux_sym_preproc_def_token1] = ACTIONS(2954),
    [aux_sym_preproc_if_token1] = ACTIONS(2954),
    [aux_sym_preproc_if_token2] = ACTIONS(2954),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2954),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2954),
    [aux_sym_preproc_else_token1] = ACTIONS(2954),
    [aux_sym_preproc_elif_token1] = ACTIONS(2954),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2954),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2954),
    [sym_preproc_directive] = ACTIONS(2954),
    [anon_sym_LPAREN2] = ACTIONS(2956),
    [anon_sym_BANG] = ACTIONS(2956),
    [anon_sym_TILDE] = ACTIONS(2956),
    [anon_sym_DASH] = ACTIONS(2954),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_STAR] = ACTIONS(2956),
    [anon_sym_AMP_AMP] = ACTIONS(2956),
    [anon_sym_AMP] = ACTIONS(2954),
    [anon_sym_SEMI] = ACTIONS(2956),
    [anon_sym___extension__] = ACTIONS(2954),
    [anon_sym_typedef] = ACTIONS(2954),
    [anon_sym_in] = ACTIONS(2954),
    [anon_sym_out] = ACTIONS(2954),
    [anon_sym_inout] = ACTIONS(2954),
    [anon_sym_extern] = ACTIONS(2954),
    [anon_sym___attribute__] = ACTIONS(2954),
    [anon_sym_COLON_COLON] = ACTIONS(2956),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2956),
    [anon_sym___declspec] = ACTIONS(2954),
    [anon_sym___based] = ACTIONS(2954),
    [anon_sym___cdecl] = ACTIONS(2954),
    [anon_sym___clrcall] = ACTIONS(2954),
    [anon_sym___stdcall] = ACTIONS(2954),
    [anon_sym___fastcall] = ACTIONS(2954),
    [anon_sym___thiscall] = ACTIONS(2954),
    [anon_sym___vectorcall] = ACTIONS(2954),
    [anon_sym_LBRACE] = ACTIONS(2956),
    [anon_sym_signed] = ACTIONS(2954),
    [anon_sym_unsigned] = ACTIONS(2954),
    [anon_sym_long] = ACTIONS(2954),
    [anon_sym_short] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_static] = ACTIONS(2954),
    [anon_sym_register] = ACTIONS(2954),
    [anon_sym_inline] = ACTIONS(2954),
    [anon_sym___inline] = ACTIONS(2954),
    [anon_sym___inline__] = ACTIONS(2954),
    [anon_sym___forceinline] = ACTIONS(2954),
    [anon_sym_thread_local] = ACTIONS(2954),
    [anon_sym___thread] = ACTIONS(2954),
    [anon_sym_const] = ACTIONS(2954),
    [anon_sym_constexpr] = ACTIONS(2954),
    [anon_sym_volatile] = ACTIONS(2954),
    [anon_sym_restrict] = ACTIONS(2954),
    [anon_sym___restrict__] = ACTIONS(2954),
    [anon_sym__Atomic] = ACTIONS(2954),
    [anon_sym__Noreturn] = ACTIONS(2954),
    [anon_sym_noreturn] = ACTIONS(2954),
    [anon_sym_mutable] = ACTIONS(2954),
    [anon_sym_constinit] = ACTIONS(2954),
    [anon_sym_consteval] = ACTIONS(2954),
    [anon_sym_alignas] = ACTIONS(2954),
    [anon_sym__Alignas] = ACTIONS(2954),
    [sym_primitive_type] = ACTIONS(2954),
    [anon_sym_enum] = ACTIONS(2954),
    [anon_sym_class] = ACTIONS(2954),
    [anon_sym_struct] = ACTIONS(2954),
    [anon_sym_union] = ACTIONS(2954),
    [anon_sym_if] = ACTIONS(2954),
    [anon_sym_else] = ACTIONS(2954),
    [anon_sym_switch] = ACTIONS(2954),
    [anon_sym_case] = ACTIONS(2954),
    [anon_sym_default] = ACTIONS(2954),
    [anon_sym_while] = ACTIONS(2954),
    [anon_sym_do] = ACTIONS(2954),
    [anon_sym_for] = ACTIONS(2954),
    [anon_sym_return] = ACTIONS(2954),
    [anon_sym_break] = ACTIONS(2954),
    [anon_sym_continue] = ACTIONS(2954),
    [anon_sym_goto] = ACTIONS(2954),
    [anon_sym___try] = ACTIONS(2954),
    [anon_sym___leave] = ACTIONS(2954),
    [anon_sym_not] = ACTIONS(2954),
    [anon_sym_compl] = ACTIONS(2954),
    [anon_sym_DASH_DASH] = ACTIONS(2956),
    [anon_sym_PLUS_PLUS] = ACTIONS(2956),
    [anon_sym_sizeof] = ACTIONS(2954),
    [anon_sym___alignof__] = ACTIONS(2954),
    [anon_sym___alignof] = ACTIONS(2954),
    [anon_sym__alignof] = ACTIONS(2954),
    [anon_sym_alignof] = ACTIONS(2954),
    [anon_sym__Alignof] = ACTIONS(2954),
    [anon_sym_offsetof] = ACTIONS(2954),
    [anon_sym__Generic] = ACTIONS(2954),
    [anon_sym_asm] = ACTIONS(2954),
    [anon_sym___asm__] = ACTIONS(2954),
    [sym_number_literal] = ACTIONS(2956),
    [anon_sym_L_SQUOTE] = ACTIONS(2956),
    [anon_sym_u_SQUOTE] = ACTIONS(2956),
    [anon_sym_U_SQUOTE] = ACTIONS(2956),
    [anon_sym_u8_SQUOTE] = ACTIONS(2956),
    [anon_sym_SQUOTE] = ACTIONS(2956),
    [anon_sym_L_DQUOTE] = ACTIONS(2956),
    [anon_sym_u_DQUOTE] = ACTIONS(2956),
    [anon_sym_U_DQUOTE] = ACTIONS(2956),
    [anon_sym_u8_DQUOTE] = ACTIONS(2956),
    [anon_sym_DQUOTE] = ACTIONS(2956),
    [sym_true] = ACTIONS(2954),
    [sym_false] = ACTIONS(2954),
    [anon_sym_NULL] = ACTIONS(2954),
    [anon_sym_nullptr] = ACTIONS(2954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2954),
    [anon_sym_let] = ACTIONS(2954),
    [anon_sym_This] = ACTIONS(2954),
    [anon_sym_decltype] = ACTIONS(2954),
    [sym_virtual] = ACTIONS(2954),
    [anon_sym_explicit] = ACTIONS(2954),
    [anon_sym_typename] = ACTIONS(2954),
    [anon_sym_template] = ACTIONS(2954),
    [anon_sym_operator] = ACTIONS(2954),
    [anon_sym_try] = ACTIONS(2954),
    [anon_sym_delete] = ACTIONS(2954),
    [anon_sym_throw] = ACTIONS(2954),
    [anon_sym_namespace] = ACTIONS(2954),
    [anon_sym_using] = ACTIONS(2954),
    [anon_sym_static_assert] = ACTIONS(2954),
    [anon_sym_concept] = ACTIONS(2954),
    [anon_sym_co_return] = ACTIONS(2954),
    [anon_sym_co_yield] = ACTIONS(2954),
    [anon_sym_R_DQUOTE] = ACTIONS(2956),
    [anon_sym_LR_DQUOTE] = ACTIONS(2956),
    [anon_sym_uR_DQUOTE] = ACTIONS(2956),
    [anon_sym_UR_DQUOTE] = ACTIONS(2956),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2956),
    [anon_sym_co_await] = ACTIONS(2954),
    [anon_sym_new] = ACTIONS(2954),
    [anon_sym_requires] = ACTIONS(2954),
    [sym_this] = ACTIONS(2954),
    [anon_sym_discard] = ACTIONS(2954),
    [anon_sym_precise] = ACTIONS(2954),
    [anon_sym_shared] = ACTIONS(2954),
    [anon_sym_groupshared] = ACTIONS(2954),
    [anon_sym_uniform] = ACTIONS(2954),
    [anon_sym_row_major] = ACTIONS(2954),
    [anon_sym_column_major] = ACTIONS(2954),
    [anon_sym_globallycoherent] = ACTIONS(2954),
    [anon_sym_centroid] = ACTIONS(2954),
    [anon_sym_noperspective] = ACTIONS(2954),
    [anon_sym_nointerpolation] = ACTIONS(2954),
    [anon_sym_sample] = ACTIONS(2954),
    [anon_sym_linear] = ACTIONS(2954),
    [anon_sym_snorm] = ACTIONS(2954),
    [anon_sym_unorm] = ACTIONS(2954),
    [anon_sym_point] = ACTIONS(2954),
    [anon_sym_line] = ACTIONS(2954),
    [anon_sym_triangleadj] = ACTIONS(2954),
    [anon_sym_lineadj] = ACTIONS(2954),
    [anon_sym_triangle] = ACTIONS(2954),
    [anon_sym_cbuffer] = ACTIONS(2954),
    [anon_sym_interface] = ACTIONS(2954),
    [anon_sym_extension] = ACTIONS(2954),
  },
  [301] = {
    [sym_preproc_def] = STATE(371),
    [sym_preproc_function_def] = STATE(371),
    [sym_preproc_call] = STATE(371),
    [sym_preproc_if_in_field_declaration_list] = STATE(371),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(371),
    [sym_type_definition] = STATE(371),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(371),
    [sym_field_declaration] = STATE(371),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(371),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(371),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(371),
    [sym_operator_cast_declaration] = STATE(371),
    [sym_constructor_or_destructor_definition] = STATE(371),
    [sym_constructor_or_destructor_declaration] = STATE(371),
    [sym_friend_declaration] = STATE(371),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(371),
    [sym_alias_declaration] = STATE(371),
    [sym_static_assert_declaration] = STATE(371),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(371),
    [sym_subscript_declaration] = STATE(371),
    [sym_property_declaration] = STATE(371),
    [sym_associatedtype_declaration] = STATE(371),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(371),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(2958),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [302] = {
    [sym_preproc_def] = STATE(371),
    [sym_preproc_function_def] = STATE(371),
    [sym_preproc_call] = STATE(371),
    [sym_preproc_if_in_field_declaration_list] = STATE(371),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(371),
    [sym_type_definition] = STATE(371),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(371),
    [sym_field_declaration] = STATE(371),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(371),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(371),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(371),
    [sym_operator_cast_declaration] = STATE(371),
    [sym_constructor_or_destructor_definition] = STATE(371),
    [sym_constructor_or_destructor_declaration] = STATE(371),
    [sym_friend_declaration] = STATE(371),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(371),
    [sym_alias_declaration] = STATE(371),
    [sym_static_assert_declaration] = STATE(371),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(371),
    [sym_subscript_declaration] = STATE(371),
    [sym_property_declaration] = STATE(371),
    [sym_associatedtype_declaration] = STATE(371),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(371),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(2960),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [303] = {
    [ts_builtin_sym_end] = ACTIONS(2962),
    [sym_identifier] = ACTIONS(2964),
    [aux_sym_preproc_include_token1] = ACTIONS(2964),
    [aux_sym_preproc_def_token1] = ACTIONS(2964),
    [anon_sym_COMMA] = ACTIONS(2962),
    [anon_sym_RPAREN] = ACTIONS(2962),
    [aux_sym_preproc_if_token1] = ACTIONS(2964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2964),
    [sym_preproc_directive] = ACTIONS(2964),
    [anon_sym_LPAREN2] = ACTIONS(2962),
    [anon_sym_BANG] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2964),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_STAR] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym___extension__] = ACTIONS(2964),
    [anon_sym_typedef] = ACTIONS(2964),
    [anon_sym_in] = ACTIONS(2964),
    [anon_sym_out] = ACTIONS(2964),
    [anon_sym_inout] = ACTIONS(2964),
    [anon_sym_extern] = ACTIONS(2964),
    [anon_sym___attribute__] = ACTIONS(2964),
    [anon_sym_COLON_COLON] = ACTIONS(2962),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2962),
    [anon_sym___declspec] = ACTIONS(2964),
    [anon_sym___based] = ACTIONS(2964),
    [anon_sym___cdecl] = ACTIONS(2964),
    [anon_sym___clrcall] = ACTIONS(2964),
    [anon_sym___stdcall] = ACTIONS(2964),
    [anon_sym___fastcall] = ACTIONS(2964),
    [anon_sym___thiscall] = ACTIONS(2964),
    [anon_sym___vectorcall] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_signed] = ACTIONS(2964),
    [anon_sym_unsigned] = ACTIONS(2964),
    [anon_sym_long] = ACTIONS(2964),
    [anon_sym_short] = ACTIONS(2964),
    [anon_sym_LBRACK] = ACTIONS(2964),
    [anon_sym_static] = ACTIONS(2964),
    [anon_sym_register] = ACTIONS(2964),
    [anon_sym_inline] = ACTIONS(2964),
    [anon_sym___inline] = ACTIONS(2964),
    [anon_sym___inline__] = ACTIONS(2964),
    [anon_sym___forceinline] = ACTIONS(2964),
    [anon_sym_thread_local] = ACTIONS(2964),
    [anon_sym___thread] = ACTIONS(2964),
    [anon_sym_const] = ACTIONS(2964),
    [anon_sym_constexpr] = ACTIONS(2964),
    [anon_sym_volatile] = ACTIONS(2964),
    [anon_sym_restrict] = ACTIONS(2964),
    [anon_sym___restrict__] = ACTIONS(2964),
    [anon_sym__Atomic] = ACTIONS(2964),
    [anon_sym__Noreturn] = ACTIONS(2964),
    [anon_sym_noreturn] = ACTIONS(2964),
    [anon_sym_mutable] = ACTIONS(2964),
    [anon_sym_constinit] = ACTIONS(2964),
    [anon_sym_consteval] = ACTIONS(2964),
    [anon_sym_alignas] = ACTIONS(2964),
    [anon_sym__Alignas] = ACTIONS(2964),
    [sym_primitive_type] = ACTIONS(2964),
    [anon_sym_enum] = ACTIONS(2964),
    [anon_sym_class] = ACTIONS(2964),
    [anon_sym_struct] = ACTIONS(2964),
    [anon_sym_union] = ACTIONS(2964),
    [anon_sym_if] = ACTIONS(2964),
    [anon_sym_switch] = ACTIONS(2964),
    [anon_sym_case] = ACTIONS(2964),
    [anon_sym_default] = ACTIONS(2964),
    [anon_sym_while] = ACTIONS(2964),
    [anon_sym_do] = ACTIONS(2964),
    [anon_sym_for] = ACTIONS(2964),
    [anon_sym_return] = ACTIONS(2964),
    [anon_sym_break] = ACTIONS(2964),
    [anon_sym_continue] = ACTIONS(2964),
    [anon_sym_goto] = ACTIONS(2964),
    [anon_sym_not] = ACTIONS(2964),
    [anon_sym_compl] = ACTIONS(2964),
    [anon_sym_DASH_DASH] = ACTIONS(2962),
    [anon_sym_PLUS_PLUS] = ACTIONS(2962),
    [anon_sym_sizeof] = ACTIONS(2964),
    [anon_sym___alignof__] = ACTIONS(2964),
    [anon_sym___alignof] = ACTIONS(2964),
    [anon_sym__alignof] = ACTIONS(2964),
    [anon_sym_alignof] = ACTIONS(2964),
    [anon_sym__Alignof] = ACTIONS(2964),
    [anon_sym_offsetof] = ACTIONS(2964),
    [anon_sym__Generic] = ACTIONS(2964),
    [anon_sym_asm] = ACTIONS(2964),
    [anon_sym___asm__] = ACTIONS(2964),
    [anon_sym_DOT] = ACTIONS(2964),
    [sym_number_literal] = ACTIONS(2962),
    [anon_sym_L_SQUOTE] = ACTIONS(2962),
    [anon_sym_u_SQUOTE] = ACTIONS(2962),
    [anon_sym_U_SQUOTE] = ACTIONS(2962),
    [anon_sym_u8_SQUOTE] = ACTIONS(2962),
    [anon_sym_SQUOTE] = ACTIONS(2962),
    [anon_sym_L_DQUOTE] = ACTIONS(2962),
    [anon_sym_u_DQUOTE] = ACTIONS(2962),
    [anon_sym_U_DQUOTE] = ACTIONS(2962),
    [anon_sym_u8_DQUOTE] = ACTIONS(2962),
    [anon_sym_DQUOTE] = ACTIONS(2962),
    [sym_true] = ACTIONS(2964),
    [sym_false] = ACTIONS(2964),
    [anon_sym_NULL] = ACTIONS(2964),
    [anon_sym_nullptr] = ACTIONS(2964),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2964),
    [anon_sym_let] = ACTIONS(2964),
    [anon_sym_This] = ACTIONS(2964),
    [anon_sym_decltype] = ACTIONS(2964),
    [anon_sym_final] = ACTIONS(2964),
    [anon_sym_override] = ACTIONS(2964),
    [sym_virtual] = ACTIONS(2964),
    [anon_sym_explicit] = ACTIONS(2964),
    [anon_sym_typename] = ACTIONS(2964),
    [anon_sym_template] = ACTIONS(2964),
    [anon_sym_GT2] = ACTIONS(2962),
    [anon_sym_operator] = ACTIONS(2964),
    [anon_sym_try] = ACTIONS(2964),
    [anon_sym_delete] = ACTIONS(2964),
    [anon_sym_throw] = ACTIONS(2964),
    [anon_sym_namespace] = ACTIONS(2964),
    [anon_sym_using] = ACTIONS(2964),
    [anon_sym_static_assert] = ACTIONS(2964),
    [anon_sym_concept] = ACTIONS(2964),
    [anon_sym_co_return] = ACTIONS(2964),
    [anon_sym_co_yield] = ACTIONS(2964),
    [anon_sym_R_DQUOTE] = ACTIONS(2962),
    [anon_sym_LR_DQUOTE] = ACTIONS(2962),
    [anon_sym_uR_DQUOTE] = ACTIONS(2962),
    [anon_sym_UR_DQUOTE] = ACTIONS(2962),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2962),
    [anon_sym_co_await] = ACTIONS(2964),
    [anon_sym_new] = ACTIONS(2964),
    [anon_sym_requires] = ACTIONS(2964),
    [sym_this] = ACTIONS(2964),
    [anon_sym_precise] = ACTIONS(2964),
    [anon_sym_shared] = ACTIONS(2964),
    [anon_sym_groupshared] = ACTIONS(2964),
    [anon_sym_uniform] = ACTIONS(2964),
    [anon_sym_row_major] = ACTIONS(2964),
    [anon_sym_column_major] = ACTIONS(2964),
    [anon_sym_globallycoherent] = ACTIONS(2964),
    [anon_sym_centroid] = ACTIONS(2964),
    [anon_sym_noperspective] = ACTIONS(2964),
    [anon_sym_nointerpolation] = ACTIONS(2964),
    [anon_sym_sample] = ACTIONS(2964),
    [anon_sym_linear] = ACTIONS(2964),
    [anon_sym_snorm] = ACTIONS(2964),
    [anon_sym_unorm] = ACTIONS(2964),
    [anon_sym_point] = ACTIONS(2964),
    [anon_sym_line] = ACTIONS(2964),
    [anon_sym_triangleadj] = ACTIONS(2964),
    [anon_sym_lineadj] = ACTIONS(2964),
    [anon_sym_triangle] = ACTIONS(2964),
    [anon_sym_interface] = ACTIONS(2964),
    [anon_sym_extension] = ACTIONS(2964),
    [anon_sym_where] = ACTIONS(2964),
    [anon_sym___exported] = ACTIONS(2964),
    [anon_sym_import] = ACTIONS(2964),
  },
  [304] = {
    [sym_preproc_def] = STATE(306),
    [sym_preproc_function_def] = STATE(306),
    [sym_preproc_call] = STATE(306),
    [sym_preproc_if_in_field_declaration_list] = STATE(306),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(306),
    [sym_type_definition] = STATE(306),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(306),
    [sym_field_declaration] = STATE(306),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(306),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(306),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(306),
    [sym_operator_cast_declaration] = STATE(306),
    [sym_constructor_or_destructor_definition] = STATE(306),
    [sym_constructor_or_destructor_declaration] = STATE(306),
    [sym_friend_declaration] = STATE(306),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(306),
    [sym_alias_declaration] = STATE(306),
    [sym_static_assert_declaration] = STATE(306),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(306),
    [sym_subscript_declaration] = STATE(306),
    [sym_property_declaration] = STATE(306),
    [sym_associatedtype_declaration] = STATE(306),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(306),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(2966),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [305] = {
    [sym_preproc_def] = STATE(377),
    [sym_preproc_function_def] = STATE(377),
    [sym_preproc_call] = STATE(377),
    [sym_preproc_if_in_field_declaration_list] = STATE(377),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(377),
    [sym_type_definition] = STATE(377),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(377),
    [sym_field_declaration] = STATE(377),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(377),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(377),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(377),
    [sym_operator_cast_declaration] = STATE(377),
    [sym_constructor_or_destructor_definition] = STATE(377),
    [sym_constructor_or_destructor_declaration] = STATE(377),
    [sym_friend_declaration] = STATE(377),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(377),
    [sym_alias_declaration] = STATE(377),
    [sym_static_assert_declaration] = STATE(377),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(377),
    [sym_subscript_declaration] = STATE(377),
    [sym_property_declaration] = STATE(377),
    [sym_associatedtype_declaration] = STATE(377),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(377),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(2968),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [306] = {
    [sym_preproc_def] = STATE(371),
    [sym_preproc_function_def] = STATE(371),
    [sym_preproc_call] = STATE(371),
    [sym_preproc_if_in_field_declaration_list] = STATE(371),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(371),
    [sym_type_definition] = STATE(371),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(371),
    [sym_field_declaration] = STATE(371),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(371),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(371),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(371),
    [sym_operator_cast_declaration] = STATE(371),
    [sym_constructor_or_destructor_definition] = STATE(371),
    [sym_constructor_or_destructor_declaration] = STATE(371),
    [sym_friend_declaration] = STATE(371),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(371),
    [sym_alias_declaration] = STATE(371),
    [sym_static_assert_declaration] = STATE(371),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(371),
    [sym_subscript_declaration] = STATE(371),
    [sym_property_declaration] = STATE(371),
    [sym_associatedtype_declaration] = STATE(371),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(371),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(2970),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [307] = {
    [sym_identifier] = ACTIONS(2972),
    [aux_sym_preproc_include_token1] = ACTIONS(2972),
    [aux_sym_preproc_def_token1] = ACTIONS(2972),
    [aux_sym_preproc_if_token1] = ACTIONS(2972),
    [aux_sym_preproc_if_token2] = ACTIONS(2972),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2972),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2972),
    [aux_sym_preproc_else_token1] = ACTIONS(2972),
    [aux_sym_preproc_elif_token1] = ACTIONS(2972),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2972),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2972),
    [sym_preproc_directive] = ACTIONS(2972),
    [anon_sym_LPAREN2] = ACTIONS(2974),
    [anon_sym_BANG] = ACTIONS(2974),
    [anon_sym_TILDE] = ACTIONS(2974),
    [anon_sym_DASH] = ACTIONS(2972),
    [anon_sym_PLUS] = ACTIONS(2972),
    [anon_sym_STAR] = ACTIONS(2974),
    [anon_sym_AMP_AMP] = ACTIONS(2974),
    [anon_sym_AMP] = ACTIONS(2972),
    [anon_sym_SEMI] = ACTIONS(2974),
    [anon_sym___extension__] = ACTIONS(2972),
    [anon_sym_typedef] = ACTIONS(2972),
    [anon_sym_in] = ACTIONS(2972),
    [anon_sym_out] = ACTIONS(2972),
    [anon_sym_inout] = ACTIONS(2972),
    [anon_sym_extern] = ACTIONS(2972),
    [anon_sym___attribute__] = ACTIONS(2972),
    [anon_sym_COLON_COLON] = ACTIONS(2974),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2974),
    [anon_sym___declspec] = ACTIONS(2972),
    [anon_sym___based] = ACTIONS(2972),
    [anon_sym___cdecl] = ACTIONS(2972),
    [anon_sym___clrcall] = ACTIONS(2972),
    [anon_sym___stdcall] = ACTIONS(2972),
    [anon_sym___fastcall] = ACTIONS(2972),
    [anon_sym___thiscall] = ACTIONS(2972),
    [anon_sym___vectorcall] = ACTIONS(2972),
    [anon_sym_LBRACE] = ACTIONS(2974),
    [anon_sym_signed] = ACTIONS(2972),
    [anon_sym_unsigned] = ACTIONS(2972),
    [anon_sym_long] = ACTIONS(2972),
    [anon_sym_short] = ACTIONS(2972),
    [anon_sym_LBRACK] = ACTIONS(2972),
    [anon_sym_static] = ACTIONS(2972),
    [anon_sym_register] = ACTIONS(2972),
    [anon_sym_inline] = ACTIONS(2972),
    [anon_sym___inline] = ACTIONS(2972),
    [anon_sym___inline__] = ACTIONS(2972),
    [anon_sym___forceinline] = ACTIONS(2972),
    [anon_sym_thread_local] = ACTIONS(2972),
    [anon_sym___thread] = ACTIONS(2972),
    [anon_sym_const] = ACTIONS(2972),
    [anon_sym_constexpr] = ACTIONS(2972),
    [anon_sym_volatile] = ACTIONS(2972),
    [anon_sym_restrict] = ACTIONS(2972),
    [anon_sym___restrict__] = ACTIONS(2972),
    [anon_sym__Atomic] = ACTIONS(2972),
    [anon_sym__Noreturn] = ACTIONS(2972),
    [anon_sym_noreturn] = ACTIONS(2972),
    [anon_sym_mutable] = ACTIONS(2972),
    [anon_sym_constinit] = ACTIONS(2972),
    [anon_sym_consteval] = ACTIONS(2972),
    [anon_sym_alignas] = ACTIONS(2972),
    [anon_sym__Alignas] = ACTIONS(2972),
    [sym_primitive_type] = ACTIONS(2972),
    [anon_sym_enum] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(2972),
    [anon_sym_struct] = ACTIONS(2972),
    [anon_sym_union] = ACTIONS(2972),
    [anon_sym_if] = ACTIONS(2972),
    [anon_sym_else] = ACTIONS(2972),
    [anon_sym_switch] = ACTIONS(2972),
    [anon_sym_case] = ACTIONS(2972),
    [anon_sym_default] = ACTIONS(2972),
    [anon_sym_while] = ACTIONS(2972),
    [anon_sym_do] = ACTIONS(2972),
    [anon_sym_for] = ACTIONS(2972),
    [anon_sym_return] = ACTIONS(2972),
    [anon_sym_break] = ACTIONS(2972),
    [anon_sym_continue] = ACTIONS(2972),
    [anon_sym_goto] = ACTIONS(2972),
    [anon_sym___try] = ACTIONS(2972),
    [anon_sym___leave] = ACTIONS(2972),
    [anon_sym_not] = ACTIONS(2972),
    [anon_sym_compl] = ACTIONS(2972),
    [anon_sym_DASH_DASH] = ACTIONS(2974),
    [anon_sym_PLUS_PLUS] = ACTIONS(2974),
    [anon_sym_sizeof] = ACTIONS(2972),
    [anon_sym___alignof__] = ACTIONS(2972),
    [anon_sym___alignof] = ACTIONS(2972),
    [anon_sym__alignof] = ACTIONS(2972),
    [anon_sym_alignof] = ACTIONS(2972),
    [anon_sym__Alignof] = ACTIONS(2972),
    [anon_sym_offsetof] = ACTIONS(2972),
    [anon_sym__Generic] = ACTIONS(2972),
    [anon_sym_asm] = ACTIONS(2972),
    [anon_sym___asm__] = ACTIONS(2972),
    [sym_number_literal] = ACTIONS(2974),
    [anon_sym_L_SQUOTE] = ACTIONS(2974),
    [anon_sym_u_SQUOTE] = ACTIONS(2974),
    [anon_sym_U_SQUOTE] = ACTIONS(2974),
    [anon_sym_u8_SQUOTE] = ACTIONS(2974),
    [anon_sym_SQUOTE] = ACTIONS(2974),
    [anon_sym_L_DQUOTE] = ACTIONS(2974),
    [anon_sym_u_DQUOTE] = ACTIONS(2974),
    [anon_sym_U_DQUOTE] = ACTIONS(2974),
    [anon_sym_u8_DQUOTE] = ACTIONS(2974),
    [anon_sym_DQUOTE] = ACTIONS(2974),
    [sym_true] = ACTIONS(2972),
    [sym_false] = ACTIONS(2972),
    [anon_sym_NULL] = ACTIONS(2972),
    [anon_sym_nullptr] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2972),
    [anon_sym_let] = ACTIONS(2972),
    [anon_sym_This] = ACTIONS(2972),
    [anon_sym_decltype] = ACTIONS(2972),
    [sym_virtual] = ACTIONS(2972),
    [anon_sym_explicit] = ACTIONS(2972),
    [anon_sym_typename] = ACTIONS(2972),
    [anon_sym_template] = ACTIONS(2972),
    [anon_sym_operator] = ACTIONS(2972),
    [anon_sym_try] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2972),
    [anon_sym_throw] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2972),
    [anon_sym_using] = ACTIONS(2972),
    [anon_sym_static_assert] = ACTIONS(2972),
    [anon_sym_concept] = ACTIONS(2972),
    [anon_sym_co_return] = ACTIONS(2972),
    [anon_sym_co_yield] = ACTIONS(2972),
    [anon_sym_R_DQUOTE] = ACTIONS(2974),
    [anon_sym_LR_DQUOTE] = ACTIONS(2974),
    [anon_sym_uR_DQUOTE] = ACTIONS(2974),
    [anon_sym_UR_DQUOTE] = ACTIONS(2974),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2974),
    [anon_sym_co_await] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2972),
    [anon_sym_requires] = ACTIONS(2972),
    [sym_this] = ACTIONS(2972),
    [anon_sym_discard] = ACTIONS(2972),
    [anon_sym_precise] = ACTIONS(2972),
    [anon_sym_shared] = ACTIONS(2972),
    [anon_sym_groupshared] = ACTIONS(2972),
    [anon_sym_uniform] = ACTIONS(2972),
    [anon_sym_row_major] = ACTIONS(2972),
    [anon_sym_column_major] = ACTIONS(2972),
    [anon_sym_globallycoherent] = ACTIONS(2972),
    [anon_sym_centroid] = ACTIONS(2972),
    [anon_sym_noperspective] = ACTIONS(2972),
    [anon_sym_nointerpolation] = ACTIONS(2972),
    [anon_sym_sample] = ACTIONS(2972),
    [anon_sym_linear] = ACTIONS(2972),
    [anon_sym_snorm] = ACTIONS(2972),
    [anon_sym_unorm] = ACTIONS(2972),
    [anon_sym_point] = ACTIONS(2972),
    [anon_sym_line] = ACTIONS(2972),
    [anon_sym_triangleadj] = ACTIONS(2972),
    [anon_sym_lineadj] = ACTIONS(2972),
    [anon_sym_triangle] = ACTIONS(2972),
    [anon_sym_cbuffer] = ACTIONS(2972),
    [anon_sym_interface] = ACTIONS(2972),
    [anon_sym_extension] = ACTIONS(2972),
  },
  [308] = {
    [sym_preproc_def] = STATE(302),
    [sym_preproc_function_def] = STATE(302),
    [sym_preproc_call] = STATE(302),
    [sym_preproc_if_in_field_declaration_list] = STATE(302),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(302),
    [sym_type_definition] = STATE(302),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(302),
    [sym_field_declaration] = STATE(302),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(302),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(302),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(302),
    [sym_operator_cast_declaration] = STATE(302),
    [sym_constructor_or_destructor_definition] = STATE(302),
    [sym_constructor_or_destructor_declaration] = STATE(302),
    [sym_friend_declaration] = STATE(302),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(302),
    [sym_alias_declaration] = STATE(302),
    [sym_static_assert_declaration] = STATE(302),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(302),
    [sym_subscript_declaration] = STATE(302),
    [sym_property_declaration] = STATE(302),
    [sym_associatedtype_declaration] = STATE(302),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(302),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(2976),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [309] = {
    [sym_identifier] = ACTIONS(2367),
    [aux_sym_preproc_include_token1] = ACTIONS(2367),
    [aux_sym_preproc_def_token1] = ACTIONS(2367),
    [aux_sym_preproc_if_token1] = ACTIONS(2367),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2367),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2367),
    [sym_preproc_directive] = ACTIONS(2367),
    [anon_sym_LPAREN2] = ACTIONS(2365),
    [anon_sym_BANG] = ACTIONS(2365),
    [anon_sym_TILDE] = ACTIONS(2365),
    [anon_sym_DASH] = ACTIONS(2367),
    [anon_sym_PLUS] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2365),
    [anon_sym_AMP_AMP] = ACTIONS(2365),
    [anon_sym_AMP] = ACTIONS(2367),
    [anon_sym_COLON] = ACTIONS(2367),
    [anon_sym_SEMI] = ACTIONS(2365),
    [anon_sym___extension__] = ACTIONS(2367),
    [anon_sym_typedef] = ACTIONS(2367),
    [anon_sym_in] = ACTIONS(2367),
    [anon_sym_out] = ACTIONS(2367),
    [anon_sym_inout] = ACTIONS(2367),
    [anon_sym_extern] = ACTIONS(2367),
    [anon_sym___attribute__] = ACTIONS(2367),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2365),
    [anon_sym___declspec] = ACTIONS(2367),
    [anon_sym___based] = ACTIONS(2367),
    [anon_sym___cdecl] = ACTIONS(2367),
    [anon_sym___clrcall] = ACTIONS(2367),
    [anon_sym___stdcall] = ACTIONS(2367),
    [anon_sym___fastcall] = ACTIONS(2367),
    [anon_sym___thiscall] = ACTIONS(2367),
    [anon_sym___vectorcall] = ACTIONS(2367),
    [anon_sym_LBRACE] = ACTIONS(2365),
    [anon_sym_RBRACE] = ACTIONS(2365),
    [anon_sym_signed] = ACTIONS(2367),
    [anon_sym_unsigned] = ACTIONS(2367),
    [anon_sym_long] = ACTIONS(2367),
    [anon_sym_short] = ACTIONS(2367),
    [anon_sym_LBRACK] = ACTIONS(2367),
    [anon_sym_static] = ACTIONS(2367),
    [anon_sym_register] = ACTIONS(2367),
    [anon_sym_inline] = ACTIONS(2367),
    [anon_sym___inline] = ACTIONS(2367),
    [anon_sym___inline__] = ACTIONS(2367),
    [anon_sym___forceinline] = ACTIONS(2367),
    [anon_sym_thread_local] = ACTIONS(2367),
    [anon_sym___thread] = ACTIONS(2367),
    [anon_sym_const] = ACTIONS(2367),
    [anon_sym_constexpr] = ACTIONS(2367),
    [anon_sym_volatile] = ACTIONS(2367),
    [anon_sym_restrict] = ACTIONS(2367),
    [anon_sym___restrict__] = ACTIONS(2367),
    [anon_sym__Atomic] = ACTIONS(2367),
    [anon_sym__Noreturn] = ACTIONS(2367),
    [anon_sym_noreturn] = ACTIONS(2367),
    [anon_sym_mutable] = ACTIONS(2367),
    [anon_sym_constinit] = ACTIONS(2367),
    [anon_sym_consteval] = ACTIONS(2367),
    [anon_sym_alignas] = ACTIONS(2367),
    [anon_sym__Alignas] = ACTIONS(2367),
    [sym_primitive_type] = ACTIONS(2367),
    [anon_sym_enum] = ACTIONS(2367),
    [anon_sym_class] = ACTIONS(2367),
    [anon_sym_struct] = ACTIONS(2367),
    [anon_sym_union] = ACTIONS(2367),
    [anon_sym_if] = ACTIONS(2367),
    [anon_sym_else] = ACTIONS(2367),
    [anon_sym_switch] = ACTIONS(2367),
    [anon_sym_case] = ACTIONS(2367),
    [anon_sym_default] = ACTIONS(2367),
    [anon_sym_while] = ACTIONS(2367),
    [anon_sym_do] = ACTIONS(2367),
    [anon_sym_for] = ACTIONS(2367),
    [anon_sym_return] = ACTIONS(2367),
    [anon_sym_break] = ACTIONS(2367),
    [anon_sym_continue] = ACTIONS(2367),
    [anon_sym_goto] = ACTIONS(2367),
    [anon_sym___try] = ACTIONS(2367),
    [anon_sym___leave] = ACTIONS(2367),
    [anon_sym_not] = ACTIONS(2367),
    [anon_sym_compl] = ACTIONS(2367),
    [anon_sym_DASH_DASH] = ACTIONS(2365),
    [anon_sym_PLUS_PLUS] = ACTIONS(2365),
    [anon_sym_sizeof] = ACTIONS(2367),
    [anon_sym___alignof__] = ACTIONS(2367),
    [anon_sym___alignof] = ACTIONS(2367),
    [anon_sym__alignof] = ACTIONS(2367),
    [anon_sym_alignof] = ACTIONS(2367),
    [anon_sym__Alignof] = ACTIONS(2367),
    [anon_sym_offsetof] = ACTIONS(2367),
    [anon_sym__Generic] = ACTIONS(2367),
    [anon_sym_asm] = ACTIONS(2367),
    [anon_sym___asm__] = ACTIONS(2367),
    [anon_sym_DOT] = ACTIONS(2367),
    [sym_number_literal] = ACTIONS(2365),
    [anon_sym_L_SQUOTE] = ACTIONS(2365),
    [anon_sym_u_SQUOTE] = ACTIONS(2365),
    [anon_sym_U_SQUOTE] = ACTIONS(2365),
    [anon_sym_u8_SQUOTE] = ACTIONS(2365),
    [anon_sym_SQUOTE] = ACTIONS(2365),
    [anon_sym_L_DQUOTE] = ACTIONS(2365),
    [anon_sym_u_DQUOTE] = ACTIONS(2365),
    [anon_sym_U_DQUOTE] = ACTIONS(2365),
    [anon_sym_u8_DQUOTE] = ACTIONS(2365),
    [anon_sym_DQUOTE] = ACTIONS(2365),
    [sym_true] = ACTIONS(2367),
    [sym_false] = ACTIONS(2367),
    [anon_sym_NULL] = ACTIONS(2367),
    [anon_sym_nullptr] = ACTIONS(2367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2367),
    [anon_sym_let] = ACTIONS(2367),
    [anon_sym_This] = ACTIONS(2367),
    [anon_sym_decltype] = ACTIONS(2367),
    [anon_sym_final] = ACTIONS(2367),
    [anon_sym_override] = ACTIONS(2367),
    [sym_virtual] = ACTIONS(2367),
    [anon_sym_explicit] = ACTIONS(2367),
    [anon_sym_typename] = ACTIONS(2367),
    [anon_sym_template] = ACTIONS(2367),
    [anon_sym_operator] = ACTIONS(2367),
    [anon_sym_try] = ACTIONS(2367),
    [anon_sym_delete] = ACTIONS(2367),
    [anon_sym_throw] = ACTIONS(2367),
    [anon_sym_namespace] = ACTIONS(2367),
    [anon_sym_using] = ACTIONS(2367),
    [anon_sym_static_assert] = ACTIONS(2367),
    [anon_sym_concept] = ACTIONS(2367),
    [anon_sym_co_return] = ACTIONS(2367),
    [anon_sym_co_yield] = ACTIONS(2367),
    [anon_sym_R_DQUOTE] = ACTIONS(2365),
    [anon_sym_LR_DQUOTE] = ACTIONS(2365),
    [anon_sym_uR_DQUOTE] = ACTIONS(2365),
    [anon_sym_UR_DQUOTE] = ACTIONS(2365),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2365),
    [anon_sym_co_await] = ACTIONS(2367),
    [anon_sym_new] = ACTIONS(2367),
    [anon_sym_requires] = ACTIONS(2367),
    [sym_this] = ACTIONS(2367),
    [anon_sym_discard] = ACTIONS(2367),
    [anon_sym_precise] = ACTIONS(2367),
    [anon_sym_shared] = ACTIONS(2367),
    [anon_sym_groupshared] = ACTIONS(2367),
    [anon_sym_uniform] = ACTIONS(2367),
    [anon_sym_row_major] = ACTIONS(2367),
    [anon_sym_column_major] = ACTIONS(2367),
    [anon_sym_globallycoherent] = ACTIONS(2367),
    [anon_sym_centroid] = ACTIONS(2367),
    [anon_sym_noperspective] = ACTIONS(2367),
    [anon_sym_nointerpolation] = ACTIONS(2367),
    [anon_sym_sample] = ACTIONS(2367),
    [anon_sym_linear] = ACTIONS(2367),
    [anon_sym_snorm] = ACTIONS(2367),
    [anon_sym_unorm] = ACTIONS(2367),
    [anon_sym_point] = ACTIONS(2367),
    [anon_sym_line] = ACTIONS(2367),
    [anon_sym_triangleadj] = ACTIONS(2367),
    [anon_sym_lineadj] = ACTIONS(2367),
    [anon_sym_triangle] = ACTIONS(2367),
    [anon_sym_cbuffer] = ACTIONS(2367),
    [anon_sym_interface] = ACTIONS(2367),
    [anon_sym_extension] = ACTIONS(2367),
  },
  [310] = {
    [sym_identifier] = ACTIONS(2978),
    [aux_sym_preproc_include_token1] = ACTIONS(2978),
    [aux_sym_preproc_def_token1] = ACTIONS(2978),
    [aux_sym_preproc_if_token1] = ACTIONS(2978),
    [aux_sym_preproc_if_token2] = ACTIONS(2978),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2978),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2978),
    [aux_sym_preproc_else_token1] = ACTIONS(2978),
    [aux_sym_preproc_elif_token1] = ACTIONS(2978),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2978),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2978),
    [sym_preproc_directive] = ACTIONS(2978),
    [anon_sym_LPAREN2] = ACTIONS(2980),
    [anon_sym_BANG] = ACTIONS(2980),
    [anon_sym_TILDE] = ACTIONS(2980),
    [anon_sym_DASH] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_STAR] = ACTIONS(2980),
    [anon_sym_AMP_AMP] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2978),
    [anon_sym_SEMI] = ACTIONS(2980),
    [anon_sym___extension__] = ACTIONS(2978),
    [anon_sym_typedef] = ACTIONS(2978),
    [anon_sym_in] = ACTIONS(2978),
    [anon_sym_out] = ACTIONS(2978),
    [anon_sym_inout] = ACTIONS(2978),
    [anon_sym_extern] = ACTIONS(2978),
    [anon_sym___attribute__] = ACTIONS(2978),
    [anon_sym_COLON_COLON] = ACTIONS(2980),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2980),
    [anon_sym___declspec] = ACTIONS(2978),
    [anon_sym___based] = ACTIONS(2978),
    [anon_sym___cdecl] = ACTIONS(2978),
    [anon_sym___clrcall] = ACTIONS(2978),
    [anon_sym___stdcall] = ACTIONS(2978),
    [anon_sym___fastcall] = ACTIONS(2978),
    [anon_sym___thiscall] = ACTIONS(2978),
    [anon_sym___vectorcall] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(2980),
    [anon_sym_signed] = ACTIONS(2978),
    [anon_sym_unsigned] = ACTIONS(2978),
    [anon_sym_long] = ACTIONS(2978),
    [anon_sym_short] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_static] = ACTIONS(2978),
    [anon_sym_register] = ACTIONS(2978),
    [anon_sym_inline] = ACTIONS(2978),
    [anon_sym___inline] = ACTIONS(2978),
    [anon_sym___inline__] = ACTIONS(2978),
    [anon_sym___forceinline] = ACTIONS(2978),
    [anon_sym_thread_local] = ACTIONS(2978),
    [anon_sym___thread] = ACTIONS(2978),
    [anon_sym_const] = ACTIONS(2978),
    [anon_sym_constexpr] = ACTIONS(2978),
    [anon_sym_volatile] = ACTIONS(2978),
    [anon_sym_restrict] = ACTIONS(2978),
    [anon_sym___restrict__] = ACTIONS(2978),
    [anon_sym__Atomic] = ACTIONS(2978),
    [anon_sym__Noreturn] = ACTIONS(2978),
    [anon_sym_noreturn] = ACTIONS(2978),
    [anon_sym_mutable] = ACTIONS(2978),
    [anon_sym_constinit] = ACTIONS(2978),
    [anon_sym_consteval] = ACTIONS(2978),
    [anon_sym_alignas] = ACTIONS(2978),
    [anon_sym__Alignas] = ACTIONS(2978),
    [sym_primitive_type] = ACTIONS(2978),
    [anon_sym_enum] = ACTIONS(2978),
    [anon_sym_class] = ACTIONS(2978),
    [anon_sym_struct] = ACTIONS(2978),
    [anon_sym_union] = ACTIONS(2978),
    [anon_sym_if] = ACTIONS(2978),
    [anon_sym_else] = ACTIONS(2978),
    [anon_sym_switch] = ACTIONS(2978),
    [anon_sym_case] = ACTIONS(2978),
    [anon_sym_default] = ACTIONS(2978),
    [anon_sym_while] = ACTIONS(2978),
    [anon_sym_do] = ACTIONS(2978),
    [anon_sym_for] = ACTIONS(2978),
    [anon_sym_return] = ACTIONS(2978),
    [anon_sym_break] = ACTIONS(2978),
    [anon_sym_continue] = ACTIONS(2978),
    [anon_sym_goto] = ACTIONS(2978),
    [anon_sym___try] = ACTIONS(2978),
    [anon_sym___leave] = ACTIONS(2978),
    [anon_sym_not] = ACTIONS(2978),
    [anon_sym_compl] = ACTIONS(2978),
    [anon_sym_DASH_DASH] = ACTIONS(2980),
    [anon_sym_PLUS_PLUS] = ACTIONS(2980),
    [anon_sym_sizeof] = ACTIONS(2978),
    [anon_sym___alignof__] = ACTIONS(2978),
    [anon_sym___alignof] = ACTIONS(2978),
    [anon_sym__alignof] = ACTIONS(2978),
    [anon_sym_alignof] = ACTIONS(2978),
    [anon_sym__Alignof] = ACTIONS(2978),
    [anon_sym_offsetof] = ACTIONS(2978),
    [anon_sym__Generic] = ACTIONS(2978),
    [anon_sym_asm] = ACTIONS(2978),
    [anon_sym___asm__] = ACTIONS(2978),
    [sym_number_literal] = ACTIONS(2980),
    [anon_sym_L_SQUOTE] = ACTIONS(2980),
    [anon_sym_u_SQUOTE] = ACTIONS(2980),
    [anon_sym_U_SQUOTE] = ACTIONS(2980),
    [anon_sym_u8_SQUOTE] = ACTIONS(2980),
    [anon_sym_SQUOTE] = ACTIONS(2980),
    [anon_sym_L_DQUOTE] = ACTIONS(2980),
    [anon_sym_u_DQUOTE] = ACTIONS(2980),
    [anon_sym_U_DQUOTE] = ACTIONS(2980),
    [anon_sym_u8_DQUOTE] = ACTIONS(2980),
    [anon_sym_DQUOTE] = ACTIONS(2980),
    [sym_true] = ACTIONS(2978),
    [sym_false] = ACTIONS(2978),
    [anon_sym_NULL] = ACTIONS(2978),
    [anon_sym_nullptr] = ACTIONS(2978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2978),
    [anon_sym_let] = ACTIONS(2978),
    [anon_sym_This] = ACTIONS(2978),
    [anon_sym_decltype] = ACTIONS(2978),
    [sym_virtual] = ACTIONS(2978),
    [anon_sym_explicit] = ACTIONS(2978),
    [anon_sym_typename] = ACTIONS(2978),
    [anon_sym_template] = ACTIONS(2978),
    [anon_sym_operator] = ACTIONS(2978),
    [anon_sym_try] = ACTIONS(2978),
    [anon_sym_delete] = ACTIONS(2978),
    [anon_sym_throw] = ACTIONS(2978),
    [anon_sym_namespace] = ACTIONS(2978),
    [anon_sym_using] = ACTIONS(2978),
    [anon_sym_static_assert] = ACTIONS(2978),
    [anon_sym_concept] = ACTIONS(2978),
    [anon_sym_co_return] = ACTIONS(2978),
    [anon_sym_co_yield] = ACTIONS(2978),
    [anon_sym_R_DQUOTE] = ACTIONS(2980),
    [anon_sym_LR_DQUOTE] = ACTIONS(2980),
    [anon_sym_uR_DQUOTE] = ACTIONS(2980),
    [anon_sym_UR_DQUOTE] = ACTIONS(2980),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2980),
    [anon_sym_co_await] = ACTIONS(2978),
    [anon_sym_new] = ACTIONS(2978),
    [anon_sym_requires] = ACTIONS(2978),
    [sym_this] = ACTIONS(2978),
    [anon_sym_discard] = ACTIONS(2978),
    [anon_sym_precise] = ACTIONS(2978),
    [anon_sym_shared] = ACTIONS(2978),
    [anon_sym_groupshared] = ACTIONS(2978),
    [anon_sym_uniform] = ACTIONS(2978),
    [anon_sym_row_major] = ACTIONS(2978),
    [anon_sym_column_major] = ACTIONS(2978),
    [anon_sym_globallycoherent] = ACTIONS(2978),
    [anon_sym_centroid] = ACTIONS(2978),
    [anon_sym_noperspective] = ACTIONS(2978),
    [anon_sym_nointerpolation] = ACTIONS(2978),
    [anon_sym_sample] = ACTIONS(2978),
    [anon_sym_linear] = ACTIONS(2978),
    [anon_sym_snorm] = ACTIONS(2978),
    [anon_sym_unorm] = ACTIONS(2978),
    [anon_sym_point] = ACTIONS(2978),
    [anon_sym_line] = ACTIONS(2978),
    [anon_sym_triangleadj] = ACTIONS(2978),
    [anon_sym_lineadj] = ACTIONS(2978),
    [anon_sym_triangle] = ACTIONS(2978),
    [anon_sym_cbuffer] = ACTIONS(2978),
    [anon_sym_interface] = ACTIONS(2978),
    [anon_sym_extension] = ACTIONS(2978),
  },
  [311] = {
    [sym_identifier] = ACTIONS(2491),
    [aux_sym_preproc_include_token1] = ACTIONS(2491),
    [aux_sym_preproc_def_token1] = ACTIONS(2491),
    [aux_sym_preproc_if_token1] = ACTIONS(2491),
    [aux_sym_preproc_if_token2] = ACTIONS(2491),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2491),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2491),
    [aux_sym_preproc_else_token1] = ACTIONS(2491),
    [aux_sym_preproc_elif_token1] = ACTIONS(2491),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2491),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2491),
    [sym_preproc_directive] = ACTIONS(2491),
    [anon_sym_LPAREN2] = ACTIONS(2489),
    [anon_sym_BANG] = ACTIONS(2489),
    [anon_sym_TILDE] = ACTIONS(2489),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(2489),
    [anon_sym_AMP_AMP] = ACTIONS(2489),
    [anon_sym_AMP] = ACTIONS(2491),
    [anon_sym_SEMI] = ACTIONS(2489),
    [anon_sym___extension__] = ACTIONS(2491),
    [anon_sym_typedef] = ACTIONS(2491),
    [anon_sym_in] = ACTIONS(2491),
    [anon_sym_out] = ACTIONS(2491),
    [anon_sym_inout] = ACTIONS(2491),
    [anon_sym_extern] = ACTIONS(2491),
    [anon_sym___attribute__] = ACTIONS(2491),
    [anon_sym_COLON_COLON] = ACTIONS(2489),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2489),
    [anon_sym___declspec] = ACTIONS(2491),
    [anon_sym___based] = ACTIONS(2491),
    [anon_sym___cdecl] = ACTIONS(2491),
    [anon_sym___clrcall] = ACTIONS(2491),
    [anon_sym___stdcall] = ACTIONS(2491),
    [anon_sym___fastcall] = ACTIONS(2491),
    [anon_sym___thiscall] = ACTIONS(2491),
    [anon_sym___vectorcall] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(2489),
    [anon_sym_signed] = ACTIONS(2491),
    [anon_sym_unsigned] = ACTIONS(2491),
    [anon_sym_long] = ACTIONS(2491),
    [anon_sym_short] = ACTIONS(2491),
    [anon_sym_LBRACK] = ACTIONS(2491),
    [anon_sym_static] = ACTIONS(2491),
    [anon_sym_register] = ACTIONS(2491),
    [anon_sym_inline] = ACTIONS(2491),
    [anon_sym___inline] = ACTIONS(2491),
    [anon_sym___inline__] = ACTIONS(2491),
    [anon_sym___forceinline] = ACTIONS(2491),
    [anon_sym_thread_local] = ACTIONS(2491),
    [anon_sym___thread] = ACTIONS(2491),
    [anon_sym_const] = ACTIONS(2491),
    [anon_sym_constexpr] = ACTIONS(2491),
    [anon_sym_volatile] = ACTIONS(2491),
    [anon_sym_restrict] = ACTIONS(2491),
    [anon_sym___restrict__] = ACTIONS(2491),
    [anon_sym__Atomic] = ACTIONS(2491),
    [anon_sym__Noreturn] = ACTIONS(2491),
    [anon_sym_noreturn] = ACTIONS(2491),
    [anon_sym_mutable] = ACTIONS(2491),
    [anon_sym_constinit] = ACTIONS(2491),
    [anon_sym_consteval] = ACTIONS(2491),
    [anon_sym_alignas] = ACTIONS(2491),
    [anon_sym__Alignas] = ACTIONS(2491),
    [sym_primitive_type] = ACTIONS(2491),
    [anon_sym_enum] = ACTIONS(2491),
    [anon_sym_class] = ACTIONS(2491),
    [anon_sym_struct] = ACTIONS(2491),
    [anon_sym_union] = ACTIONS(2491),
    [anon_sym_if] = ACTIONS(2491),
    [anon_sym_else] = ACTIONS(2491),
    [anon_sym_switch] = ACTIONS(2491),
    [anon_sym_case] = ACTIONS(2491),
    [anon_sym_default] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2491),
    [anon_sym_do] = ACTIONS(2491),
    [anon_sym_for] = ACTIONS(2491),
    [anon_sym_return] = ACTIONS(2491),
    [anon_sym_break] = ACTIONS(2491),
    [anon_sym_continue] = ACTIONS(2491),
    [anon_sym_goto] = ACTIONS(2491),
    [anon_sym___try] = ACTIONS(2491),
    [anon_sym___leave] = ACTIONS(2491),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(2489),
    [anon_sym_PLUS_PLUS] = ACTIONS(2489),
    [anon_sym_sizeof] = ACTIONS(2491),
    [anon_sym___alignof__] = ACTIONS(2491),
    [anon_sym___alignof] = ACTIONS(2491),
    [anon_sym__alignof] = ACTIONS(2491),
    [anon_sym_alignof] = ACTIONS(2491),
    [anon_sym__Alignof] = ACTIONS(2491),
    [anon_sym_offsetof] = ACTIONS(2491),
    [anon_sym__Generic] = ACTIONS(2491),
    [anon_sym_asm] = ACTIONS(2491),
    [anon_sym___asm__] = ACTIONS(2491),
    [sym_number_literal] = ACTIONS(2489),
    [anon_sym_L_SQUOTE] = ACTIONS(2489),
    [anon_sym_u_SQUOTE] = ACTIONS(2489),
    [anon_sym_U_SQUOTE] = ACTIONS(2489),
    [anon_sym_u8_SQUOTE] = ACTIONS(2489),
    [anon_sym_SQUOTE] = ACTIONS(2489),
    [anon_sym_L_DQUOTE] = ACTIONS(2489),
    [anon_sym_u_DQUOTE] = ACTIONS(2489),
    [anon_sym_U_DQUOTE] = ACTIONS(2489),
    [anon_sym_u8_DQUOTE] = ACTIONS(2489),
    [anon_sym_DQUOTE] = ACTIONS(2489),
    [sym_true] = ACTIONS(2491),
    [sym_false] = ACTIONS(2491),
    [anon_sym_NULL] = ACTIONS(2491),
    [anon_sym_nullptr] = ACTIONS(2491),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2491),
    [anon_sym_let] = ACTIONS(2491),
    [anon_sym_This] = ACTIONS(2491),
    [anon_sym_decltype] = ACTIONS(2491),
    [sym_virtual] = ACTIONS(2491),
    [anon_sym_explicit] = ACTIONS(2491),
    [anon_sym_typename] = ACTIONS(2491),
    [anon_sym_template] = ACTIONS(2491),
    [anon_sym_operator] = ACTIONS(2491),
    [anon_sym_try] = ACTIONS(2491),
    [anon_sym_delete] = ACTIONS(2491),
    [anon_sym_throw] = ACTIONS(2491),
    [anon_sym_namespace] = ACTIONS(2491),
    [anon_sym_using] = ACTIONS(2491),
    [anon_sym_static_assert] = ACTIONS(2491),
    [anon_sym_concept] = ACTIONS(2491),
    [anon_sym_co_return] = ACTIONS(2491),
    [anon_sym_co_yield] = ACTIONS(2491),
    [anon_sym_R_DQUOTE] = ACTIONS(2489),
    [anon_sym_LR_DQUOTE] = ACTIONS(2489),
    [anon_sym_uR_DQUOTE] = ACTIONS(2489),
    [anon_sym_UR_DQUOTE] = ACTIONS(2489),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2489),
    [anon_sym_co_await] = ACTIONS(2491),
    [anon_sym_new] = ACTIONS(2491),
    [anon_sym_requires] = ACTIONS(2491),
    [sym_this] = ACTIONS(2491),
    [anon_sym_discard] = ACTIONS(2491),
    [anon_sym_precise] = ACTIONS(2491),
    [anon_sym_shared] = ACTIONS(2491),
    [anon_sym_groupshared] = ACTIONS(2491),
    [anon_sym_uniform] = ACTIONS(2491),
    [anon_sym_row_major] = ACTIONS(2491),
    [anon_sym_column_major] = ACTIONS(2491),
    [anon_sym_globallycoherent] = ACTIONS(2491),
    [anon_sym_centroid] = ACTIONS(2491),
    [anon_sym_noperspective] = ACTIONS(2491),
    [anon_sym_nointerpolation] = ACTIONS(2491),
    [anon_sym_sample] = ACTIONS(2491),
    [anon_sym_linear] = ACTIONS(2491),
    [anon_sym_snorm] = ACTIONS(2491),
    [anon_sym_unorm] = ACTIONS(2491),
    [anon_sym_point] = ACTIONS(2491),
    [anon_sym_line] = ACTIONS(2491),
    [anon_sym_triangleadj] = ACTIONS(2491),
    [anon_sym_lineadj] = ACTIONS(2491),
    [anon_sym_triangle] = ACTIONS(2491),
    [anon_sym_cbuffer] = ACTIONS(2491),
    [anon_sym_interface] = ACTIONS(2491),
    [anon_sym_extension] = ACTIONS(2491),
  },
  [312] = {
    [sym_identifier] = ACTIONS(2982),
    [aux_sym_preproc_include_token1] = ACTIONS(2982),
    [aux_sym_preproc_def_token1] = ACTIONS(2982),
    [aux_sym_preproc_if_token1] = ACTIONS(2982),
    [aux_sym_preproc_if_token2] = ACTIONS(2982),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2982),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2982),
    [aux_sym_preproc_else_token1] = ACTIONS(2982),
    [aux_sym_preproc_elif_token1] = ACTIONS(2982),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2982),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2982),
    [sym_preproc_directive] = ACTIONS(2982),
    [anon_sym_LPAREN2] = ACTIONS(2984),
    [anon_sym_BANG] = ACTIONS(2984),
    [anon_sym_TILDE] = ACTIONS(2984),
    [anon_sym_DASH] = ACTIONS(2982),
    [anon_sym_PLUS] = ACTIONS(2982),
    [anon_sym_STAR] = ACTIONS(2984),
    [anon_sym_AMP_AMP] = ACTIONS(2984),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_SEMI] = ACTIONS(2984),
    [anon_sym___extension__] = ACTIONS(2982),
    [anon_sym_typedef] = ACTIONS(2982),
    [anon_sym_in] = ACTIONS(2982),
    [anon_sym_out] = ACTIONS(2982),
    [anon_sym_inout] = ACTIONS(2982),
    [anon_sym_extern] = ACTIONS(2982),
    [anon_sym___attribute__] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2984),
    [anon_sym___declspec] = ACTIONS(2982),
    [anon_sym___based] = ACTIONS(2982),
    [anon_sym___cdecl] = ACTIONS(2982),
    [anon_sym___clrcall] = ACTIONS(2982),
    [anon_sym___stdcall] = ACTIONS(2982),
    [anon_sym___fastcall] = ACTIONS(2982),
    [anon_sym___thiscall] = ACTIONS(2982),
    [anon_sym___vectorcall] = ACTIONS(2982),
    [anon_sym_LBRACE] = ACTIONS(2984),
    [anon_sym_signed] = ACTIONS(2982),
    [anon_sym_unsigned] = ACTIONS(2982),
    [anon_sym_long] = ACTIONS(2982),
    [anon_sym_short] = ACTIONS(2982),
    [anon_sym_LBRACK] = ACTIONS(2982),
    [anon_sym_static] = ACTIONS(2982),
    [anon_sym_register] = ACTIONS(2982),
    [anon_sym_inline] = ACTIONS(2982),
    [anon_sym___inline] = ACTIONS(2982),
    [anon_sym___inline__] = ACTIONS(2982),
    [anon_sym___forceinline] = ACTIONS(2982),
    [anon_sym_thread_local] = ACTIONS(2982),
    [anon_sym___thread] = ACTIONS(2982),
    [anon_sym_const] = ACTIONS(2982),
    [anon_sym_constexpr] = ACTIONS(2982),
    [anon_sym_volatile] = ACTIONS(2982),
    [anon_sym_restrict] = ACTIONS(2982),
    [anon_sym___restrict__] = ACTIONS(2982),
    [anon_sym__Atomic] = ACTIONS(2982),
    [anon_sym__Noreturn] = ACTIONS(2982),
    [anon_sym_noreturn] = ACTIONS(2982),
    [anon_sym_mutable] = ACTIONS(2982),
    [anon_sym_constinit] = ACTIONS(2982),
    [anon_sym_consteval] = ACTIONS(2982),
    [anon_sym_alignas] = ACTIONS(2982),
    [anon_sym__Alignas] = ACTIONS(2982),
    [sym_primitive_type] = ACTIONS(2982),
    [anon_sym_enum] = ACTIONS(2982),
    [anon_sym_class] = ACTIONS(2982),
    [anon_sym_struct] = ACTIONS(2982),
    [anon_sym_union] = ACTIONS(2982),
    [anon_sym_if] = ACTIONS(2982),
    [anon_sym_else] = ACTIONS(2982),
    [anon_sym_switch] = ACTIONS(2982),
    [anon_sym_case] = ACTIONS(2982),
    [anon_sym_default] = ACTIONS(2982),
    [anon_sym_while] = ACTIONS(2982),
    [anon_sym_do] = ACTIONS(2982),
    [anon_sym_for] = ACTIONS(2982),
    [anon_sym_return] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2982),
    [anon_sym_continue] = ACTIONS(2982),
    [anon_sym_goto] = ACTIONS(2982),
    [anon_sym___try] = ACTIONS(2982),
    [anon_sym___leave] = ACTIONS(2982),
    [anon_sym_not] = ACTIONS(2982),
    [anon_sym_compl] = ACTIONS(2982),
    [anon_sym_DASH_DASH] = ACTIONS(2984),
    [anon_sym_PLUS_PLUS] = ACTIONS(2984),
    [anon_sym_sizeof] = ACTIONS(2982),
    [anon_sym___alignof__] = ACTIONS(2982),
    [anon_sym___alignof] = ACTIONS(2982),
    [anon_sym__alignof] = ACTIONS(2982),
    [anon_sym_alignof] = ACTIONS(2982),
    [anon_sym__Alignof] = ACTIONS(2982),
    [anon_sym_offsetof] = ACTIONS(2982),
    [anon_sym__Generic] = ACTIONS(2982),
    [anon_sym_asm] = ACTIONS(2982),
    [anon_sym___asm__] = ACTIONS(2982),
    [sym_number_literal] = ACTIONS(2984),
    [anon_sym_L_SQUOTE] = ACTIONS(2984),
    [anon_sym_u_SQUOTE] = ACTIONS(2984),
    [anon_sym_U_SQUOTE] = ACTIONS(2984),
    [anon_sym_u8_SQUOTE] = ACTIONS(2984),
    [anon_sym_SQUOTE] = ACTIONS(2984),
    [anon_sym_L_DQUOTE] = ACTIONS(2984),
    [anon_sym_u_DQUOTE] = ACTIONS(2984),
    [anon_sym_U_DQUOTE] = ACTIONS(2984),
    [anon_sym_u8_DQUOTE] = ACTIONS(2984),
    [anon_sym_DQUOTE] = ACTIONS(2984),
    [sym_true] = ACTIONS(2982),
    [sym_false] = ACTIONS(2982),
    [anon_sym_NULL] = ACTIONS(2982),
    [anon_sym_nullptr] = ACTIONS(2982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2982),
    [anon_sym_let] = ACTIONS(2982),
    [anon_sym_This] = ACTIONS(2982),
    [anon_sym_decltype] = ACTIONS(2982),
    [sym_virtual] = ACTIONS(2982),
    [anon_sym_explicit] = ACTIONS(2982),
    [anon_sym_typename] = ACTIONS(2982),
    [anon_sym_template] = ACTIONS(2982),
    [anon_sym_operator] = ACTIONS(2982),
    [anon_sym_try] = ACTIONS(2982),
    [anon_sym_delete] = ACTIONS(2982),
    [anon_sym_throw] = ACTIONS(2982),
    [anon_sym_namespace] = ACTIONS(2982),
    [anon_sym_using] = ACTIONS(2982),
    [anon_sym_static_assert] = ACTIONS(2982),
    [anon_sym_concept] = ACTIONS(2982),
    [anon_sym_co_return] = ACTIONS(2982),
    [anon_sym_co_yield] = ACTIONS(2982),
    [anon_sym_R_DQUOTE] = ACTIONS(2984),
    [anon_sym_LR_DQUOTE] = ACTIONS(2984),
    [anon_sym_uR_DQUOTE] = ACTIONS(2984),
    [anon_sym_UR_DQUOTE] = ACTIONS(2984),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2984),
    [anon_sym_co_await] = ACTIONS(2982),
    [anon_sym_new] = ACTIONS(2982),
    [anon_sym_requires] = ACTIONS(2982),
    [sym_this] = ACTIONS(2982),
    [anon_sym_discard] = ACTIONS(2982),
    [anon_sym_precise] = ACTIONS(2982),
    [anon_sym_shared] = ACTIONS(2982),
    [anon_sym_groupshared] = ACTIONS(2982),
    [anon_sym_uniform] = ACTIONS(2982),
    [anon_sym_row_major] = ACTIONS(2982),
    [anon_sym_column_major] = ACTIONS(2982),
    [anon_sym_globallycoherent] = ACTIONS(2982),
    [anon_sym_centroid] = ACTIONS(2982),
    [anon_sym_noperspective] = ACTIONS(2982),
    [anon_sym_nointerpolation] = ACTIONS(2982),
    [anon_sym_sample] = ACTIONS(2982),
    [anon_sym_linear] = ACTIONS(2982),
    [anon_sym_snorm] = ACTIONS(2982),
    [anon_sym_unorm] = ACTIONS(2982),
    [anon_sym_point] = ACTIONS(2982),
    [anon_sym_line] = ACTIONS(2982),
    [anon_sym_triangleadj] = ACTIONS(2982),
    [anon_sym_lineadj] = ACTIONS(2982),
    [anon_sym_triangle] = ACTIONS(2982),
    [anon_sym_cbuffer] = ACTIONS(2982),
    [anon_sym_interface] = ACTIONS(2982),
    [anon_sym_extension] = ACTIONS(2982),
  },
  [313] = {
    [ts_builtin_sym_end] = ACTIONS(2986),
    [sym_identifier] = ACTIONS(2988),
    [aux_sym_preproc_include_token1] = ACTIONS(2988),
    [aux_sym_preproc_def_token1] = ACTIONS(2988),
    [anon_sym_COMMA] = ACTIONS(2986),
    [anon_sym_RPAREN] = ACTIONS(2986),
    [aux_sym_preproc_if_token1] = ACTIONS(2988),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2988),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2988),
    [sym_preproc_directive] = ACTIONS(2988),
    [anon_sym_LPAREN2] = ACTIONS(2986),
    [anon_sym_BANG] = ACTIONS(2986),
    [anon_sym_TILDE] = ACTIONS(2986),
    [anon_sym_DASH] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_STAR] = ACTIONS(2986),
    [anon_sym_AMP_AMP] = ACTIONS(2986),
    [anon_sym_AMP] = ACTIONS(2988),
    [anon_sym_SEMI] = ACTIONS(2986),
    [anon_sym___extension__] = ACTIONS(2988),
    [anon_sym_typedef] = ACTIONS(2988),
    [anon_sym_in] = ACTIONS(2988),
    [anon_sym_out] = ACTIONS(2988),
    [anon_sym_inout] = ACTIONS(2988),
    [anon_sym_extern] = ACTIONS(2988),
    [anon_sym___attribute__] = ACTIONS(2988),
    [anon_sym_COLON_COLON] = ACTIONS(2986),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2986),
    [anon_sym___declspec] = ACTIONS(2988),
    [anon_sym___based] = ACTIONS(2988),
    [anon_sym___cdecl] = ACTIONS(2988),
    [anon_sym___clrcall] = ACTIONS(2988),
    [anon_sym___stdcall] = ACTIONS(2988),
    [anon_sym___fastcall] = ACTIONS(2988),
    [anon_sym___thiscall] = ACTIONS(2988),
    [anon_sym___vectorcall] = ACTIONS(2988),
    [anon_sym_LBRACE] = ACTIONS(2986),
    [anon_sym_signed] = ACTIONS(2988),
    [anon_sym_unsigned] = ACTIONS(2988),
    [anon_sym_long] = ACTIONS(2988),
    [anon_sym_short] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2988),
    [anon_sym_static] = ACTIONS(2988),
    [anon_sym_register] = ACTIONS(2988),
    [anon_sym_inline] = ACTIONS(2988),
    [anon_sym___inline] = ACTIONS(2988),
    [anon_sym___inline__] = ACTIONS(2988),
    [anon_sym___forceinline] = ACTIONS(2988),
    [anon_sym_thread_local] = ACTIONS(2988),
    [anon_sym___thread] = ACTIONS(2988),
    [anon_sym_const] = ACTIONS(2988),
    [anon_sym_constexpr] = ACTIONS(2988),
    [anon_sym_volatile] = ACTIONS(2988),
    [anon_sym_restrict] = ACTIONS(2988),
    [anon_sym___restrict__] = ACTIONS(2988),
    [anon_sym__Atomic] = ACTIONS(2988),
    [anon_sym__Noreturn] = ACTIONS(2988),
    [anon_sym_noreturn] = ACTIONS(2988),
    [anon_sym_mutable] = ACTIONS(2988),
    [anon_sym_constinit] = ACTIONS(2988),
    [anon_sym_consteval] = ACTIONS(2988),
    [anon_sym_alignas] = ACTIONS(2988),
    [anon_sym__Alignas] = ACTIONS(2988),
    [sym_primitive_type] = ACTIONS(2988),
    [anon_sym_enum] = ACTIONS(2988),
    [anon_sym_class] = ACTIONS(2988),
    [anon_sym_struct] = ACTIONS(2988),
    [anon_sym_union] = ACTIONS(2988),
    [anon_sym_if] = ACTIONS(2988),
    [anon_sym_switch] = ACTIONS(2988),
    [anon_sym_case] = ACTIONS(2988),
    [anon_sym_default] = ACTIONS(2988),
    [anon_sym_while] = ACTIONS(2988),
    [anon_sym_do] = ACTIONS(2988),
    [anon_sym_for] = ACTIONS(2988),
    [anon_sym_return] = ACTIONS(2988),
    [anon_sym_break] = ACTIONS(2988),
    [anon_sym_continue] = ACTIONS(2988),
    [anon_sym_goto] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2988),
    [anon_sym_compl] = ACTIONS(2988),
    [anon_sym_DASH_DASH] = ACTIONS(2986),
    [anon_sym_PLUS_PLUS] = ACTIONS(2986),
    [anon_sym_sizeof] = ACTIONS(2988),
    [anon_sym___alignof__] = ACTIONS(2988),
    [anon_sym___alignof] = ACTIONS(2988),
    [anon_sym__alignof] = ACTIONS(2988),
    [anon_sym_alignof] = ACTIONS(2988),
    [anon_sym__Alignof] = ACTIONS(2988),
    [anon_sym_offsetof] = ACTIONS(2988),
    [anon_sym__Generic] = ACTIONS(2988),
    [anon_sym_asm] = ACTIONS(2988),
    [anon_sym___asm__] = ACTIONS(2988),
    [anon_sym_DOT] = ACTIONS(2988),
    [sym_number_literal] = ACTIONS(2986),
    [anon_sym_L_SQUOTE] = ACTIONS(2986),
    [anon_sym_u_SQUOTE] = ACTIONS(2986),
    [anon_sym_U_SQUOTE] = ACTIONS(2986),
    [anon_sym_u8_SQUOTE] = ACTIONS(2986),
    [anon_sym_SQUOTE] = ACTIONS(2986),
    [anon_sym_L_DQUOTE] = ACTIONS(2986),
    [anon_sym_u_DQUOTE] = ACTIONS(2986),
    [anon_sym_U_DQUOTE] = ACTIONS(2986),
    [anon_sym_u8_DQUOTE] = ACTIONS(2986),
    [anon_sym_DQUOTE] = ACTIONS(2986),
    [sym_true] = ACTIONS(2988),
    [sym_false] = ACTIONS(2988),
    [anon_sym_NULL] = ACTIONS(2988),
    [anon_sym_nullptr] = ACTIONS(2988),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2988),
    [anon_sym_let] = ACTIONS(2988),
    [anon_sym_This] = ACTIONS(2988),
    [anon_sym_decltype] = ACTIONS(2988),
    [anon_sym_final] = ACTIONS(2988),
    [anon_sym_override] = ACTIONS(2988),
    [sym_virtual] = ACTIONS(2988),
    [anon_sym_explicit] = ACTIONS(2988),
    [anon_sym_typename] = ACTIONS(2988),
    [anon_sym_template] = ACTIONS(2988),
    [anon_sym_GT2] = ACTIONS(2986),
    [anon_sym_operator] = ACTIONS(2988),
    [anon_sym_try] = ACTIONS(2988),
    [anon_sym_delete] = ACTIONS(2988),
    [anon_sym_throw] = ACTIONS(2988),
    [anon_sym_namespace] = ACTIONS(2988),
    [anon_sym_using] = ACTIONS(2988),
    [anon_sym_static_assert] = ACTIONS(2988),
    [anon_sym_concept] = ACTIONS(2988),
    [anon_sym_co_return] = ACTIONS(2988),
    [anon_sym_co_yield] = ACTIONS(2988),
    [anon_sym_R_DQUOTE] = ACTIONS(2986),
    [anon_sym_LR_DQUOTE] = ACTIONS(2986),
    [anon_sym_uR_DQUOTE] = ACTIONS(2986),
    [anon_sym_UR_DQUOTE] = ACTIONS(2986),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2986),
    [anon_sym_co_await] = ACTIONS(2988),
    [anon_sym_new] = ACTIONS(2988),
    [anon_sym_requires] = ACTIONS(2988),
    [sym_this] = ACTIONS(2988),
    [anon_sym_precise] = ACTIONS(2988),
    [anon_sym_shared] = ACTIONS(2988),
    [anon_sym_groupshared] = ACTIONS(2988),
    [anon_sym_uniform] = ACTIONS(2988),
    [anon_sym_row_major] = ACTIONS(2988),
    [anon_sym_column_major] = ACTIONS(2988),
    [anon_sym_globallycoherent] = ACTIONS(2988),
    [anon_sym_centroid] = ACTIONS(2988),
    [anon_sym_noperspective] = ACTIONS(2988),
    [anon_sym_nointerpolation] = ACTIONS(2988),
    [anon_sym_sample] = ACTIONS(2988),
    [anon_sym_linear] = ACTIONS(2988),
    [anon_sym_snorm] = ACTIONS(2988),
    [anon_sym_unorm] = ACTIONS(2988),
    [anon_sym_point] = ACTIONS(2988),
    [anon_sym_line] = ACTIONS(2988),
    [anon_sym_triangleadj] = ACTIONS(2988),
    [anon_sym_lineadj] = ACTIONS(2988),
    [anon_sym_triangle] = ACTIONS(2988),
    [anon_sym_interface] = ACTIONS(2988),
    [anon_sym_extension] = ACTIONS(2988),
    [anon_sym_where] = ACTIONS(2988),
    [anon_sym___exported] = ACTIONS(2988),
    [anon_sym_import] = ACTIONS(2988),
  },
  [314] = {
    [sym_identifier] = ACTIONS(2228),
    [aux_sym_preproc_include_token1] = ACTIONS(2228),
    [aux_sym_preproc_def_token1] = ACTIONS(2228),
    [aux_sym_preproc_if_token1] = ACTIONS(2228),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2228),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2228),
    [sym_preproc_directive] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_BANG] = ACTIONS(2230),
    [anon_sym_TILDE] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2228),
    [anon_sym_PLUS] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_AMP] = ACTIONS(2228),
    [anon_sym_COLON] = ACTIONS(2228),
    [anon_sym_SEMI] = ACTIONS(2230),
    [anon_sym___extension__] = ACTIONS(2228),
    [anon_sym_typedef] = ACTIONS(2228),
    [anon_sym_in] = ACTIONS(2228),
    [anon_sym_out] = ACTIONS(2228),
    [anon_sym_inout] = ACTIONS(2228),
    [anon_sym_extern] = ACTIONS(2228),
    [anon_sym___attribute__] = ACTIONS(2228),
    [anon_sym_COLON_COLON] = ACTIONS(2230),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2230),
    [anon_sym___declspec] = ACTIONS(2228),
    [anon_sym___based] = ACTIONS(2228),
    [anon_sym___cdecl] = ACTIONS(2228),
    [anon_sym___clrcall] = ACTIONS(2228),
    [anon_sym___stdcall] = ACTIONS(2228),
    [anon_sym___fastcall] = ACTIONS(2228),
    [anon_sym___thiscall] = ACTIONS(2228),
    [anon_sym___vectorcall] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_RBRACE] = ACTIONS(2230),
    [anon_sym_signed] = ACTIONS(2228),
    [anon_sym_unsigned] = ACTIONS(2228),
    [anon_sym_long] = ACTIONS(2228),
    [anon_sym_short] = ACTIONS(2228),
    [anon_sym_LBRACK] = ACTIONS(2228),
    [anon_sym_static] = ACTIONS(2228),
    [anon_sym_register] = ACTIONS(2228),
    [anon_sym_inline] = ACTIONS(2228),
    [anon_sym___inline] = ACTIONS(2228),
    [anon_sym___inline__] = ACTIONS(2228),
    [anon_sym___forceinline] = ACTIONS(2228),
    [anon_sym_thread_local] = ACTIONS(2228),
    [anon_sym___thread] = ACTIONS(2228),
    [anon_sym_const] = ACTIONS(2228),
    [anon_sym_constexpr] = ACTIONS(2228),
    [anon_sym_volatile] = ACTIONS(2228),
    [anon_sym_restrict] = ACTIONS(2228),
    [anon_sym___restrict__] = ACTIONS(2228),
    [anon_sym__Atomic] = ACTIONS(2228),
    [anon_sym__Noreturn] = ACTIONS(2228),
    [anon_sym_noreturn] = ACTIONS(2228),
    [anon_sym_mutable] = ACTIONS(2228),
    [anon_sym_constinit] = ACTIONS(2228),
    [anon_sym_consteval] = ACTIONS(2228),
    [anon_sym_alignas] = ACTIONS(2228),
    [anon_sym__Alignas] = ACTIONS(2228),
    [sym_primitive_type] = ACTIONS(2228),
    [anon_sym_enum] = ACTIONS(2228),
    [anon_sym_class] = ACTIONS(2228),
    [anon_sym_struct] = ACTIONS(2228),
    [anon_sym_union] = ACTIONS(2228),
    [anon_sym_if] = ACTIONS(2228),
    [anon_sym_else] = ACTIONS(2228),
    [anon_sym_switch] = ACTIONS(2228),
    [anon_sym_case] = ACTIONS(2228),
    [anon_sym_default] = ACTIONS(2228),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2228),
    [anon_sym_for] = ACTIONS(2228),
    [anon_sym_return] = ACTIONS(2228),
    [anon_sym_break] = ACTIONS(2228),
    [anon_sym_continue] = ACTIONS(2228),
    [anon_sym_goto] = ACTIONS(2228),
    [anon_sym___try] = ACTIONS(2228),
    [anon_sym___leave] = ACTIONS(2228),
    [anon_sym_not] = ACTIONS(2228),
    [anon_sym_compl] = ACTIONS(2228),
    [anon_sym_DASH_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_PLUS] = ACTIONS(2230),
    [anon_sym_sizeof] = ACTIONS(2228),
    [anon_sym___alignof__] = ACTIONS(2228),
    [anon_sym___alignof] = ACTIONS(2228),
    [anon_sym__alignof] = ACTIONS(2228),
    [anon_sym_alignof] = ACTIONS(2228),
    [anon_sym__Alignof] = ACTIONS(2228),
    [anon_sym_offsetof] = ACTIONS(2228),
    [anon_sym__Generic] = ACTIONS(2228),
    [anon_sym_asm] = ACTIONS(2228),
    [anon_sym___asm__] = ACTIONS(2228),
    [anon_sym_DOT] = ACTIONS(2228),
    [sym_number_literal] = ACTIONS(2230),
    [anon_sym_L_SQUOTE] = ACTIONS(2230),
    [anon_sym_u_SQUOTE] = ACTIONS(2230),
    [anon_sym_U_SQUOTE] = ACTIONS(2230),
    [anon_sym_u8_SQUOTE] = ACTIONS(2230),
    [anon_sym_SQUOTE] = ACTIONS(2230),
    [anon_sym_L_DQUOTE] = ACTIONS(2230),
    [anon_sym_u_DQUOTE] = ACTIONS(2230),
    [anon_sym_U_DQUOTE] = ACTIONS(2230),
    [anon_sym_u8_DQUOTE] = ACTIONS(2230),
    [anon_sym_DQUOTE] = ACTIONS(2230),
    [sym_true] = ACTIONS(2228),
    [sym_false] = ACTIONS(2228),
    [anon_sym_NULL] = ACTIONS(2228),
    [anon_sym_nullptr] = ACTIONS(2228),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(2228),
    [anon_sym_This] = ACTIONS(2228),
    [anon_sym_decltype] = ACTIONS(2228),
    [anon_sym_final] = ACTIONS(2228),
    [anon_sym_override] = ACTIONS(2228),
    [sym_virtual] = ACTIONS(2228),
    [anon_sym_explicit] = ACTIONS(2228),
    [anon_sym_typename] = ACTIONS(2228),
    [anon_sym_template] = ACTIONS(2228),
    [anon_sym_operator] = ACTIONS(2228),
    [anon_sym_try] = ACTIONS(2228),
    [anon_sym_delete] = ACTIONS(2228),
    [anon_sym_throw] = ACTIONS(2228),
    [anon_sym_namespace] = ACTIONS(2228),
    [anon_sym_using] = ACTIONS(2228),
    [anon_sym_static_assert] = ACTIONS(2228),
    [anon_sym_concept] = ACTIONS(2228),
    [anon_sym_co_return] = ACTIONS(2228),
    [anon_sym_co_yield] = ACTIONS(2228),
    [anon_sym_R_DQUOTE] = ACTIONS(2230),
    [anon_sym_LR_DQUOTE] = ACTIONS(2230),
    [anon_sym_uR_DQUOTE] = ACTIONS(2230),
    [anon_sym_UR_DQUOTE] = ACTIONS(2230),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2230),
    [anon_sym_co_await] = ACTIONS(2228),
    [anon_sym_new] = ACTIONS(2228),
    [anon_sym_requires] = ACTIONS(2228),
    [sym_this] = ACTIONS(2228),
    [anon_sym_discard] = ACTIONS(2228),
    [anon_sym_precise] = ACTIONS(2228),
    [anon_sym_shared] = ACTIONS(2228),
    [anon_sym_groupshared] = ACTIONS(2228),
    [anon_sym_uniform] = ACTIONS(2228),
    [anon_sym_row_major] = ACTIONS(2228),
    [anon_sym_column_major] = ACTIONS(2228),
    [anon_sym_globallycoherent] = ACTIONS(2228),
    [anon_sym_centroid] = ACTIONS(2228),
    [anon_sym_noperspective] = ACTIONS(2228),
    [anon_sym_nointerpolation] = ACTIONS(2228),
    [anon_sym_sample] = ACTIONS(2228),
    [anon_sym_linear] = ACTIONS(2228),
    [anon_sym_snorm] = ACTIONS(2228),
    [anon_sym_unorm] = ACTIONS(2228),
    [anon_sym_point] = ACTIONS(2228),
    [anon_sym_line] = ACTIONS(2228),
    [anon_sym_triangleadj] = ACTIONS(2228),
    [anon_sym_lineadj] = ACTIONS(2228),
    [anon_sym_triangle] = ACTIONS(2228),
    [anon_sym_cbuffer] = ACTIONS(2228),
    [anon_sym_interface] = ACTIONS(2228),
    [anon_sym_extension] = ACTIONS(2228),
  },
  [315] = {
    [sym_preproc_def] = STATE(316),
    [sym_preproc_function_def] = STATE(316),
    [sym_preproc_call] = STATE(316),
    [sym_preproc_if_in_field_declaration_list] = STATE(316),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(316),
    [sym_type_definition] = STATE(316),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(316),
    [sym_field_declaration] = STATE(316),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(316),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(316),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(316),
    [sym_operator_cast_declaration] = STATE(316),
    [sym_constructor_or_destructor_definition] = STATE(316),
    [sym_constructor_or_destructor_declaration] = STATE(316),
    [sym_friend_declaration] = STATE(316),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(316),
    [sym_alias_declaration] = STATE(316),
    [sym_static_assert_declaration] = STATE(316),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(316),
    [sym_subscript_declaration] = STATE(316),
    [sym_property_declaration] = STATE(316),
    [sym_associatedtype_declaration] = STATE(316),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(316),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(2990),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [316] = {
    [sym_preproc_def] = STATE(371),
    [sym_preproc_function_def] = STATE(371),
    [sym_preproc_call] = STATE(371),
    [sym_preproc_if_in_field_declaration_list] = STATE(371),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(371),
    [sym_type_definition] = STATE(371),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(371),
    [sym_field_declaration] = STATE(371),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(371),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(371),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(371),
    [sym_operator_cast_declaration] = STATE(371),
    [sym_constructor_or_destructor_definition] = STATE(371),
    [sym_constructor_or_destructor_declaration] = STATE(371),
    [sym_friend_declaration] = STATE(371),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(371),
    [sym_alias_declaration] = STATE(371),
    [sym_static_assert_declaration] = STATE(371),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(371),
    [sym_subscript_declaration] = STATE(371),
    [sym_property_declaration] = STATE(371),
    [sym_associatedtype_declaration] = STATE(371),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(371),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(2992),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [317] = {
    [sym_identifier] = ACTIONS(2232),
    [aux_sym_preproc_include_token1] = ACTIONS(2232),
    [aux_sym_preproc_def_token1] = ACTIONS(2232),
    [aux_sym_preproc_if_token1] = ACTIONS(2232),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2232),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2232),
    [sym_preproc_directive] = ACTIONS(2232),
    [anon_sym_LPAREN2] = ACTIONS(2234),
    [anon_sym_BANG] = ACTIONS(2234),
    [anon_sym_TILDE] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2232),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_AMP_AMP] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2232),
    [anon_sym_COLON] = ACTIONS(2232),
    [anon_sym_SEMI] = ACTIONS(2234),
    [anon_sym___extension__] = ACTIONS(2232),
    [anon_sym_typedef] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2232),
    [anon_sym_out] = ACTIONS(2232),
    [anon_sym_inout] = ACTIONS(2232),
    [anon_sym_extern] = ACTIONS(2232),
    [anon_sym___attribute__] = ACTIONS(2232),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2234),
    [anon_sym___declspec] = ACTIONS(2232),
    [anon_sym___based] = ACTIONS(2232),
    [anon_sym___cdecl] = ACTIONS(2232),
    [anon_sym___clrcall] = ACTIONS(2232),
    [anon_sym___stdcall] = ACTIONS(2232),
    [anon_sym___fastcall] = ACTIONS(2232),
    [anon_sym___thiscall] = ACTIONS(2232),
    [anon_sym___vectorcall] = ACTIONS(2232),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_RBRACE] = ACTIONS(2234),
    [anon_sym_signed] = ACTIONS(2232),
    [anon_sym_unsigned] = ACTIONS(2232),
    [anon_sym_long] = ACTIONS(2232),
    [anon_sym_short] = ACTIONS(2232),
    [anon_sym_LBRACK] = ACTIONS(2232),
    [anon_sym_static] = ACTIONS(2232),
    [anon_sym_register] = ACTIONS(2232),
    [anon_sym_inline] = ACTIONS(2232),
    [anon_sym___inline] = ACTIONS(2232),
    [anon_sym___inline__] = ACTIONS(2232),
    [anon_sym___forceinline] = ACTIONS(2232),
    [anon_sym_thread_local] = ACTIONS(2232),
    [anon_sym___thread] = ACTIONS(2232),
    [anon_sym_const] = ACTIONS(2232),
    [anon_sym_constexpr] = ACTIONS(2232),
    [anon_sym_volatile] = ACTIONS(2232),
    [anon_sym_restrict] = ACTIONS(2232),
    [anon_sym___restrict__] = ACTIONS(2232),
    [anon_sym__Atomic] = ACTIONS(2232),
    [anon_sym__Noreturn] = ACTIONS(2232),
    [anon_sym_noreturn] = ACTIONS(2232),
    [anon_sym_mutable] = ACTIONS(2232),
    [anon_sym_constinit] = ACTIONS(2232),
    [anon_sym_consteval] = ACTIONS(2232),
    [anon_sym_alignas] = ACTIONS(2232),
    [anon_sym__Alignas] = ACTIONS(2232),
    [sym_primitive_type] = ACTIONS(2232),
    [anon_sym_enum] = ACTIONS(2232),
    [anon_sym_class] = ACTIONS(2232),
    [anon_sym_struct] = ACTIONS(2232),
    [anon_sym_union] = ACTIONS(2232),
    [anon_sym_if] = ACTIONS(2232),
    [anon_sym_else] = ACTIONS(2232),
    [anon_sym_switch] = ACTIONS(2232),
    [anon_sym_case] = ACTIONS(2232),
    [anon_sym_default] = ACTIONS(2232),
    [anon_sym_while] = ACTIONS(2232),
    [anon_sym_do] = ACTIONS(2232),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2232),
    [anon_sym_break] = ACTIONS(2232),
    [anon_sym_continue] = ACTIONS(2232),
    [anon_sym_goto] = ACTIONS(2232),
    [anon_sym___try] = ACTIONS(2232),
    [anon_sym___leave] = ACTIONS(2232),
    [anon_sym_not] = ACTIONS(2232),
    [anon_sym_compl] = ACTIONS(2232),
    [anon_sym_DASH_DASH] = ACTIONS(2234),
    [anon_sym_PLUS_PLUS] = ACTIONS(2234),
    [anon_sym_sizeof] = ACTIONS(2232),
    [anon_sym___alignof__] = ACTIONS(2232),
    [anon_sym___alignof] = ACTIONS(2232),
    [anon_sym__alignof] = ACTIONS(2232),
    [anon_sym_alignof] = ACTIONS(2232),
    [anon_sym__Alignof] = ACTIONS(2232),
    [anon_sym_offsetof] = ACTIONS(2232),
    [anon_sym__Generic] = ACTIONS(2232),
    [anon_sym_asm] = ACTIONS(2232),
    [anon_sym___asm__] = ACTIONS(2232),
    [anon_sym_DOT] = ACTIONS(2232),
    [sym_number_literal] = ACTIONS(2234),
    [anon_sym_L_SQUOTE] = ACTIONS(2234),
    [anon_sym_u_SQUOTE] = ACTIONS(2234),
    [anon_sym_U_SQUOTE] = ACTIONS(2234),
    [anon_sym_u8_SQUOTE] = ACTIONS(2234),
    [anon_sym_SQUOTE] = ACTIONS(2234),
    [anon_sym_L_DQUOTE] = ACTIONS(2234),
    [anon_sym_u_DQUOTE] = ACTIONS(2234),
    [anon_sym_U_DQUOTE] = ACTIONS(2234),
    [anon_sym_u8_DQUOTE] = ACTIONS(2234),
    [anon_sym_DQUOTE] = ACTIONS(2234),
    [sym_true] = ACTIONS(2232),
    [sym_false] = ACTIONS(2232),
    [anon_sym_NULL] = ACTIONS(2232),
    [anon_sym_nullptr] = ACTIONS(2232),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2232),
    [anon_sym_let] = ACTIONS(2232),
    [anon_sym_This] = ACTIONS(2232),
    [anon_sym_decltype] = ACTIONS(2232),
    [anon_sym_final] = ACTIONS(2232),
    [anon_sym_override] = ACTIONS(2232),
    [sym_virtual] = ACTIONS(2232),
    [anon_sym_explicit] = ACTIONS(2232),
    [anon_sym_typename] = ACTIONS(2232),
    [anon_sym_template] = ACTIONS(2232),
    [anon_sym_operator] = ACTIONS(2232),
    [anon_sym_try] = ACTIONS(2232),
    [anon_sym_delete] = ACTIONS(2232),
    [anon_sym_throw] = ACTIONS(2232),
    [anon_sym_namespace] = ACTIONS(2232),
    [anon_sym_using] = ACTIONS(2232),
    [anon_sym_static_assert] = ACTIONS(2232),
    [anon_sym_concept] = ACTIONS(2232),
    [anon_sym_co_return] = ACTIONS(2232),
    [anon_sym_co_yield] = ACTIONS(2232),
    [anon_sym_R_DQUOTE] = ACTIONS(2234),
    [anon_sym_LR_DQUOTE] = ACTIONS(2234),
    [anon_sym_uR_DQUOTE] = ACTIONS(2234),
    [anon_sym_UR_DQUOTE] = ACTIONS(2234),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2234),
    [anon_sym_co_await] = ACTIONS(2232),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_requires] = ACTIONS(2232),
    [sym_this] = ACTIONS(2232),
    [anon_sym_discard] = ACTIONS(2232),
    [anon_sym_precise] = ACTIONS(2232),
    [anon_sym_shared] = ACTIONS(2232),
    [anon_sym_groupshared] = ACTIONS(2232),
    [anon_sym_uniform] = ACTIONS(2232),
    [anon_sym_row_major] = ACTIONS(2232),
    [anon_sym_column_major] = ACTIONS(2232),
    [anon_sym_globallycoherent] = ACTIONS(2232),
    [anon_sym_centroid] = ACTIONS(2232),
    [anon_sym_noperspective] = ACTIONS(2232),
    [anon_sym_nointerpolation] = ACTIONS(2232),
    [anon_sym_sample] = ACTIONS(2232),
    [anon_sym_linear] = ACTIONS(2232),
    [anon_sym_snorm] = ACTIONS(2232),
    [anon_sym_unorm] = ACTIONS(2232),
    [anon_sym_point] = ACTIONS(2232),
    [anon_sym_line] = ACTIONS(2232),
    [anon_sym_triangleadj] = ACTIONS(2232),
    [anon_sym_lineadj] = ACTIONS(2232),
    [anon_sym_triangle] = ACTIONS(2232),
    [anon_sym_cbuffer] = ACTIONS(2232),
    [anon_sym_interface] = ACTIONS(2232),
    [anon_sym_extension] = ACTIONS(2232),
  },
  [318] = {
    [ts_builtin_sym_end] = ACTIONS(2994),
    [sym_identifier] = ACTIONS(2996),
    [aux_sym_preproc_include_token1] = ACTIONS(2996),
    [aux_sym_preproc_def_token1] = ACTIONS(2996),
    [anon_sym_COMMA] = ACTIONS(2994),
    [anon_sym_RPAREN] = ACTIONS(2994),
    [aux_sym_preproc_if_token1] = ACTIONS(2996),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2996),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2996),
    [sym_preproc_directive] = ACTIONS(2996),
    [anon_sym_LPAREN2] = ACTIONS(2994),
    [anon_sym_BANG] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [anon_sym_DASH] = ACTIONS(2996),
    [anon_sym_PLUS] = ACTIONS(2996),
    [anon_sym_STAR] = ACTIONS(2994),
    [anon_sym_AMP_AMP] = ACTIONS(2994),
    [anon_sym_AMP] = ACTIONS(2996),
    [anon_sym_SEMI] = ACTIONS(2994),
    [anon_sym___extension__] = ACTIONS(2996),
    [anon_sym_typedef] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(2996),
    [anon_sym_out] = ACTIONS(2996),
    [anon_sym_inout] = ACTIONS(2996),
    [anon_sym_extern] = ACTIONS(2996),
    [anon_sym___attribute__] = ACTIONS(2996),
    [anon_sym_COLON_COLON] = ACTIONS(2994),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2994),
    [anon_sym___declspec] = ACTIONS(2996),
    [anon_sym___based] = ACTIONS(2996),
    [anon_sym___cdecl] = ACTIONS(2996),
    [anon_sym___clrcall] = ACTIONS(2996),
    [anon_sym___stdcall] = ACTIONS(2996),
    [anon_sym___fastcall] = ACTIONS(2996),
    [anon_sym___thiscall] = ACTIONS(2996),
    [anon_sym___vectorcall] = ACTIONS(2996),
    [anon_sym_LBRACE] = ACTIONS(2994),
    [anon_sym_signed] = ACTIONS(2996),
    [anon_sym_unsigned] = ACTIONS(2996),
    [anon_sym_long] = ACTIONS(2996),
    [anon_sym_short] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(2996),
    [anon_sym_static] = ACTIONS(2996),
    [anon_sym_register] = ACTIONS(2996),
    [anon_sym_inline] = ACTIONS(2996),
    [anon_sym___inline] = ACTIONS(2996),
    [anon_sym___inline__] = ACTIONS(2996),
    [anon_sym___forceinline] = ACTIONS(2996),
    [anon_sym_thread_local] = ACTIONS(2996),
    [anon_sym___thread] = ACTIONS(2996),
    [anon_sym_const] = ACTIONS(2996),
    [anon_sym_constexpr] = ACTIONS(2996),
    [anon_sym_volatile] = ACTIONS(2996),
    [anon_sym_restrict] = ACTIONS(2996),
    [anon_sym___restrict__] = ACTIONS(2996),
    [anon_sym__Atomic] = ACTIONS(2996),
    [anon_sym__Noreturn] = ACTIONS(2996),
    [anon_sym_noreturn] = ACTIONS(2996),
    [anon_sym_mutable] = ACTIONS(2996),
    [anon_sym_constinit] = ACTIONS(2996),
    [anon_sym_consteval] = ACTIONS(2996),
    [anon_sym_alignas] = ACTIONS(2996),
    [anon_sym__Alignas] = ACTIONS(2996),
    [sym_primitive_type] = ACTIONS(2996),
    [anon_sym_enum] = ACTIONS(2996),
    [anon_sym_class] = ACTIONS(2996),
    [anon_sym_struct] = ACTIONS(2996),
    [anon_sym_union] = ACTIONS(2996),
    [anon_sym_if] = ACTIONS(2996),
    [anon_sym_switch] = ACTIONS(2996),
    [anon_sym_case] = ACTIONS(2996),
    [anon_sym_default] = ACTIONS(2996),
    [anon_sym_while] = ACTIONS(2996),
    [anon_sym_do] = ACTIONS(2996),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_return] = ACTIONS(2996),
    [anon_sym_break] = ACTIONS(2996),
    [anon_sym_continue] = ACTIONS(2996),
    [anon_sym_goto] = ACTIONS(2996),
    [anon_sym_not] = ACTIONS(2996),
    [anon_sym_compl] = ACTIONS(2996),
    [anon_sym_DASH_DASH] = ACTIONS(2994),
    [anon_sym_PLUS_PLUS] = ACTIONS(2994),
    [anon_sym_sizeof] = ACTIONS(2996),
    [anon_sym___alignof__] = ACTIONS(2996),
    [anon_sym___alignof] = ACTIONS(2996),
    [anon_sym__alignof] = ACTIONS(2996),
    [anon_sym_alignof] = ACTIONS(2996),
    [anon_sym__Alignof] = ACTIONS(2996),
    [anon_sym_offsetof] = ACTIONS(2996),
    [anon_sym__Generic] = ACTIONS(2996),
    [anon_sym_asm] = ACTIONS(2996),
    [anon_sym___asm__] = ACTIONS(2996),
    [anon_sym_DOT] = ACTIONS(2996),
    [sym_number_literal] = ACTIONS(2994),
    [anon_sym_L_SQUOTE] = ACTIONS(2994),
    [anon_sym_u_SQUOTE] = ACTIONS(2994),
    [anon_sym_U_SQUOTE] = ACTIONS(2994),
    [anon_sym_u8_SQUOTE] = ACTIONS(2994),
    [anon_sym_SQUOTE] = ACTIONS(2994),
    [anon_sym_L_DQUOTE] = ACTIONS(2994),
    [anon_sym_u_DQUOTE] = ACTIONS(2994),
    [anon_sym_U_DQUOTE] = ACTIONS(2994),
    [anon_sym_u8_DQUOTE] = ACTIONS(2994),
    [anon_sym_DQUOTE] = ACTIONS(2994),
    [sym_true] = ACTIONS(2996),
    [sym_false] = ACTIONS(2996),
    [anon_sym_NULL] = ACTIONS(2996),
    [anon_sym_nullptr] = ACTIONS(2996),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2996),
    [anon_sym_let] = ACTIONS(2996),
    [anon_sym_This] = ACTIONS(2996),
    [anon_sym_decltype] = ACTIONS(2996),
    [anon_sym_final] = ACTIONS(2996),
    [anon_sym_override] = ACTIONS(2996),
    [sym_virtual] = ACTIONS(2996),
    [anon_sym_explicit] = ACTIONS(2996),
    [anon_sym_typename] = ACTIONS(2996),
    [anon_sym_template] = ACTIONS(2996),
    [anon_sym_GT2] = ACTIONS(2994),
    [anon_sym_operator] = ACTIONS(2996),
    [anon_sym_try] = ACTIONS(2996),
    [anon_sym_delete] = ACTIONS(2996),
    [anon_sym_throw] = ACTIONS(2996),
    [anon_sym_namespace] = ACTIONS(2996),
    [anon_sym_using] = ACTIONS(2996),
    [anon_sym_static_assert] = ACTIONS(2996),
    [anon_sym_concept] = ACTIONS(2996),
    [anon_sym_co_return] = ACTIONS(2996),
    [anon_sym_co_yield] = ACTIONS(2996),
    [anon_sym_R_DQUOTE] = ACTIONS(2994),
    [anon_sym_LR_DQUOTE] = ACTIONS(2994),
    [anon_sym_uR_DQUOTE] = ACTIONS(2994),
    [anon_sym_UR_DQUOTE] = ACTIONS(2994),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2994),
    [anon_sym_co_await] = ACTIONS(2996),
    [anon_sym_new] = ACTIONS(2996),
    [anon_sym_requires] = ACTIONS(2996),
    [sym_this] = ACTIONS(2996),
    [anon_sym_precise] = ACTIONS(2996),
    [anon_sym_shared] = ACTIONS(2996),
    [anon_sym_groupshared] = ACTIONS(2996),
    [anon_sym_uniform] = ACTIONS(2996),
    [anon_sym_row_major] = ACTIONS(2996),
    [anon_sym_column_major] = ACTIONS(2996),
    [anon_sym_globallycoherent] = ACTIONS(2996),
    [anon_sym_centroid] = ACTIONS(2996),
    [anon_sym_noperspective] = ACTIONS(2996),
    [anon_sym_nointerpolation] = ACTIONS(2996),
    [anon_sym_sample] = ACTIONS(2996),
    [anon_sym_linear] = ACTIONS(2996),
    [anon_sym_snorm] = ACTIONS(2996),
    [anon_sym_unorm] = ACTIONS(2996),
    [anon_sym_point] = ACTIONS(2996),
    [anon_sym_line] = ACTIONS(2996),
    [anon_sym_triangleadj] = ACTIONS(2996),
    [anon_sym_lineadj] = ACTIONS(2996),
    [anon_sym_triangle] = ACTIONS(2996),
    [anon_sym_interface] = ACTIONS(2996),
    [anon_sym_extension] = ACTIONS(2996),
    [anon_sym_where] = ACTIONS(2996),
    [anon_sym___exported] = ACTIONS(2996),
    [anon_sym_import] = ACTIONS(2996),
  },
  [319] = {
    [ts_builtin_sym_end] = ACTIONS(2998),
    [sym_identifier] = ACTIONS(3000),
    [aux_sym_preproc_include_token1] = ACTIONS(3000),
    [aux_sym_preproc_def_token1] = ACTIONS(3000),
    [anon_sym_COMMA] = ACTIONS(2998),
    [anon_sym_RPAREN] = ACTIONS(2998),
    [aux_sym_preproc_if_token1] = ACTIONS(3000),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3000),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3000),
    [sym_preproc_directive] = ACTIONS(3000),
    [anon_sym_LPAREN2] = ACTIONS(2998),
    [anon_sym_BANG] = ACTIONS(2998),
    [anon_sym_TILDE] = ACTIONS(2998),
    [anon_sym_DASH] = ACTIONS(3000),
    [anon_sym_PLUS] = ACTIONS(3000),
    [anon_sym_STAR] = ACTIONS(2998),
    [anon_sym_AMP_AMP] = ACTIONS(2998),
    [anon_sym_AMP] = ACTIONS(3000),
    [anon_sym_SEMI] = ACTIONS(2998),
    [anon_sym___extension__] = ACTIONS(3000),
    [anon_sym_typedef] = ACTIONS(3000),
    [anon_sym_in] = ACTIONS(3000),
    [anon_sym_out] = ACTIONS(3000),
    [anon_sym_inout] = ACTIONS(3000),
    [anon_sym_extern] = ACTIONS(3000),
    [anon_sym___attribute__] = ACTIONS(3000),
    [anon_sym_COLON_COLON] = ACTIONS(2998),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2998),
    [anon_sym___declspec] = ACTIONS(3000),
    [anon_sym___based] = ACTIONS(3000),
    [anon_sym___cdecl] = ACTIONS(3000),
    [anon_sym___clrcall] = ACTIONS(3000),
    [anon_sym___stdcall] = ACTIONS(3000),
    [anon_sym___fastcall] = ACTIONS(3000),
    [anon_sym___thiscall] = ACTIONS(3000),
    [anon_sym___vectorcall] = ACTIONS(3000),
    [anon_sym_LBRACE] = ACTIONS(2998),
    [anon_sym_signed] = ACTIONS(3000),
    [anon_sym_unsigned] = ACTIONS(3000),
    [anon_sym_long] = ACTIONS(3000),
    [anon_sym_short] = ACTIONS(3000),
    [anon_sym_LBRACK] = ACTIONS(3000),
    [anon_sym_static] = ACTIONS(3000),
    [anon_sym_register] = ACTIONS(3000),
    [anon_sym_inline] = ACTIONS(3000),
    [anon_sym___inline] = ACTIONS(3000),
    [anon_sym___inline__] = ACTIONS(3000),
    [anon_sym___forceinline] = ACTIONS(3000),
    [anon_sym_thread_local] = ACTIONS(3000),
    [anon_sym___thread] = ACTIONS(3000),
    [anon_sym_const] = ACTIONS(3000),
    [anon_sym_constexpr] = ACTIONS(3000),
    [anon_sym_volatile] = ACTIONS(3000),
    [anon_sym_restrict] = ACTIONS(3000),
    [anon_sym___restrict__] = ACTIONS(3000),
    [anon_sym__Atomic] = ACTIONS(3000),
    [anon_sym__Noreturn] = ACTIONS(3000),
    [anon_sym_noreturn] = ACTIONS(3000),
    [anon_sym_mutable] = ACTIONS(3000),
    [anon_sym_constinit] = ACTIONS(3000),
    [anon_sym_consteval] = ACTIONS(3000),
    [anon_sym_alignas] = ACTIONS(3000),
    [anon_sym__Alignas] = ACTIONS(3000),
    [sym_primitive_type] = ACTIONS(3000),
    [anon_sym_enum] = ACTIONS(3000),
    [anon_sym_class] = ACTIONS(3000),
    [anon_sym_struct] = ACTIONS(3000),
    [anon_sym_union] = ACTIONS(3000),
    [anon_sym_if] = ACTIONS(3000),
    [anon_sym_switch] = ACTIONS(3000),
    [anon_sym_case] = ACTIONS(3000),
    [anon_sym_default] = ACTIONS(3000),
    [anon_sym_while] = ACTIONS(3000),
    [anon_sym_do] = ACTIONS(3000),
    [anon_sym_for] = ACTIONS(3000),
    [anon_sym_return] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3000),
    [anon_sym_continue] = ACTIONS(3000),
    [anon_sym_goto] = ACTIONS(3000),
    [anon_sym_not] = ACTIONS(3000),
    [anon_sym_compl] = ACTIONS(3000),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3000),
    [anon_sym___alignof] = ACTIONS(3000),
    [anon_sym__alignof] = ACTIONS(3000),
    [anon_sym_alignof] = ACTIONS(3000),
    [anon_sym__Alignof] = ACTIONS(3000),
    [anon_sym_offsetof] = ACTIONS(3000),
    [anon_sym__Generic] = ACTIONS(3000),
    [anon_sym_asm] = ACTIONS(3000),
    [anon_sym___asm__] = ACTIONS(3000),
    [anon_sym_DOT] = ACTIONS(3000),
    [sym_number_literal] = ACTIONS(2998),
    [anon_sym_L_SQUOTE] = ACTIONS(2998),
    [anon_sym_u_SQUOTE] = ACTIONS(2998),
    [anon_sym_U_SQUOTE] = ACTIONS(2998),
    [anon_sym_u8_SQUOTE] = ACTIONS(2998),
    [anon_sym_SQUOTE] = ACTIONS(2998),
    [anon_sym_L_DQUOTE] = ACTIONS(2998),
    [anon_sym_u_DQUOTE] = ACTIONS(2998),
    [anon_sym_U_DQUOTE] = ACTIONS(2998),
    [anon_sym_u8_DQUOTE] = ACTIONS(2998),
    [anon_sym_DQUOTE] = ACTIONS(2998),
    [sym_true] = ACTIONS(3000),
    [sym_false] = ACTIONS(3000),
    [anon_sym_NULL] = ACTIONS(3000),
    [anon_sym_nullptr] = ACTIONS(3000),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3000),
    [anon_sym_let] = ACTIONS(3000),
    [anon_sym_This] = ACTIONS(3000),
    [anon_sym_decltype] = ACTIONS(3000),
    [anon_sym_final] = ACTIONS(3000),
    [anon_sym_override] = ACTIONS(3000),
    [sym_virtual] = ACTIONS(3000),
    [anon_sym_explicit] = ACTIONS(3000),
    [anon_sym_typename] = ACTIONS(3000),
    [anon_sym_template] = ACTIONS(3000),
    [anon_sym_GT2] = ACTIONS(2998),
    [anon_sym_operator] = ACTIONS(3000),
    [anon_sym_try] = ACTIONS(3000),
    [anon_sym_delete] = ACTIONS(3000),
    [anon_sym_throw] = ACTIONS(3000),
    [anon_sym_namespace] = ACTIONS(3000),
    [anon_sym_using] = ACTIONS(3000),
    [anon_sym_static_assert] = ACTIONS(3000),
    [anon_sym_concept] = ACTIONS(3000),
    [anon_sym_co_return] = ACTIONS(3000),
    [anon_sym_co_yield] = ACTIONS(3000),
    [anon_sym_R_DQUOTE] = ACTIONS(2998),
    [anon_sym_LR_DQUOTE] = ACTIONS(2998),
    [anon_sym_uR_DQUOTE] = ACTIONS(2998),
    [anon_sym_UR_DQUOTE] = ACTIONS(2998),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2998),
    [anon_sym_co_await] = ACTIONS(3000),
    [anon_sym_new] = ACTIONS(3000),
    [anon_sym_requires] = ACTIONS(3000),
    [sym_this] = ACTIONS(3000),
    [anon_sym_precise] = ACTIONS(3000),
    [anon_sym_shared] = ACTIONS(3000),
    [anon_sym_groupshared] = ACTIONS(3000),
    [anon_sym_uniform] = ACTIONS(3000),
    [anon_sym_row_major] = ACTIONS(3000),
    [anon_sym_column_major] = ACTIONS(3000),
    [anon_sym_globallycoherent] = ACTIONS(3000),
    [anon_sym_centroid] = ACTIONS(3000),
    [anon_sym_noperspective] = ACTIONS(3000),
    [anon_sym_nointerpolation] = ACTIONS(3000),
    [anon_sym_sample] = ACTIONS(3000),
    [anon_sym_linear] = ACTIONS(3000),
    [anon_sym_snorm] = ACTIONS(3000),
    [anon_sym_unorm] = ACTIONS(3000),
    [anon_sym_point] = ACTIONS(3000),
    [anon_sym_line] = ACTIONS(3000),
    [anon_sym_triangleadj] = ACTIONS(3000),
    [anon_sym_lineadj] = ACTIONS(3000),
    [anon_sym_triangle] = ACTIONS(3000),
    [anon_sym_interface] = ACTIONS(3000),
    [anon_sym_extension] = ACTIONS(3000),
    [anon_sym_where] = ACTIONS(3000),
    [anon_sym___exported] = ACTIONS(3000),
    [anon_sym_import] = ACTIONS(3000),
  },
  [320] = {
    [sym_identifier] = ACTIONS(3002),
    [aux_sym_preproc_include_token1] = ACTIONS(3002),
    [aux_sym_preproc_def_token1] = ACTIONS(3002),
    [aux_sym_preproc_if_token1] = ACTIONS(3002),
    [aux_sym_preproc_if_token2] = ACTIONS(3002),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3002),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3002),
    [aux_sym_preproc_else_token1] = ACTIONS(3002),
    [aux_sym_preproc_elif_token1] = ACTIONS(3002),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3002),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3002),
    [sym_preproc_directive] = ACTIONS(3002),
    [anon_sym_LPAREN2] = ACTIONS(3004),
    [anon_sym_BANG] = ACTIONS(3004),
    [anon_sym_TILDE] = ACTIONS(3004),
    [anon_sym_DASH] = ACTIONS(3002),
    [anon_sym_PLUS] = ACTIONS(3002),
    [anon_sym_STAR] = ACTIONS(3004),
    [anon_sym_AMP_AMP] = ACTIONS(3004),
    [anon_sym_AMP] = ACTIONS(3002),
    [anon_sym_SEMI] = ACTIONS(3004),
    [anon_sym___extension__] = ACTIONS(3002),
    [anon_sym_typedef] = ACTIONS(3002),
    [anon_sym_in] = ACTIONS(3002),
    [anon_sym_out] = ACTIONS(3002),
    [anon_sym_inout] = ACTIONS(3002),
    [anon_sym_extern] = ACTIONS(3002),
    [anon_sym___attribute__] = ACTIONS(3002),
    [anon_sym_COLON_COLON] = ACTIONS(3004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3004),
    [anon_sym___declspec] = ACTIONS(3002),
    [anon_sym___based] = ACTIONS(3002),
    [anon_sym___cdecl] = ACTIONS(3002),
    [anon_sym___clrcall] = ACTIONS(3002),
    [anon_sym___stdcall] = ACTIONS(3002),
    [anon_sym___fastcall] = ACTIONS(3002),
    [anon_sym___thiscall] = ACTIONS(3002),
    [anon_sym___vectorcall] = ACTIONS(3002),
    [anon_sym_LBRACE] = ACTIONS(3004),
    [anon_sym_signed] = ACTIONS(3002),
    [anon_sym_unsigned] = ACTIONS(3002),
    [anon_sym_long] = ACTIONS(3002),
    [anon_sym_short] = ACTIONS(3002),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [anon_sym_static] = ACTIONS(3002),
    [anon_sym_register] = ACTIONS(3002),
    [anon_sym_inline] = ACTIONS(3002),
    [anon_sym___inline] = ACTIONS(3002),
    [anon_sym___inline__] = ACTIONS(3002),
    [anon_sym___forceinline] = ACTIONS(3002),
    [anon_sym_thread_local] = ACTIONS(3002),
    [anon_sym___thread] = ACTIONS(3002),
    [anon_sym_const] = ACTIONS(3002),
    [anon_sym_constexpr] = ACTIONS(3002),
    [anon_sym_volatile] = ACTIONS(3002),
    [anon_sym_restrict] = ACTIONS(3002),
    [anon_sym___restrict__] = ACTIONS(3002),
    [anon_sym__Atomic] = ACTIONS(3002),
    [anon_sym__Noreturn] = ACTIONS(3002),
    [anon_sym_noreturn] = ACTIONS(3002),
    [anon_sym_mutable] = ACTIONS(3002),
    [anon_sym_constinit] = ACTIONS(3002),
    [anon_sym_consteval] = ACTIONS(3002),
    [anon_sym_alignas] = ACTIONS(3002),
    [anon_sym__Alignas] = ACTIONS(3002),
    [sym_primitive_type] = ACTIONS(3002),
    [anon_sym_enum] = ACTIONS(3002),
    [anon_sym_class] = ACTIONS(3002),
    [anon_sym_struct] = ACTIONS(3002),
    [anon_sym_union] = ACTIONS(3002),
    [anon_sym_if] = ACTIONS(3002),
    [anon_sym_else] = ACTIONS(3002),
    [anon_sym_switch] = ACTIONS(3002),
    [anon_sym_case] = ACTIONS(3002),
    [anon_sym_default] = ACTIONS(3002),
    [anon_sym_while] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(3002),
    [anon_sym_for] = ACTIONS(3002),
    [anon_sym_return] = ACTIONS(3002),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_continue] = ACTIONS(3002),
    [anon_sym_goto] = ACTIONS(3002),
    [anon_sym___try] = ACTIONS(3002),
    [anon_sym___leave] = ACTIONS(3002),
    [anon_sym_not] = ACTIONS(3002),
    [anon_sym_compl] = ACTIONS(3002),
    [anon_sym_DASH_DASH] = ACTIONS(3004),
    [anon_sym_PLUS_PLUS] = ACTIONS(3004),
    [anon_sym_sizeof] = ACTIONS(3002),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3002),
    [anon_sym__Generic] = ACTIONS(3002),
    [anon_sym_asm] = ACTIONS(3002),
    [anon_sym___asm__] = ACTIONS(3002),
    [sym_number_literal] = ACTIONS(3004),
    [anon_sym_L_SQUOTE] = ACTIONS(3004),
    [anon_sym_u_SQUOTE] = ACTIONS(3004),
    [anon_sym_U_SQUOTE] = ACTIONS(3004),
    [anon_sym_u8_SQUOTE] = ACTIONS(3004),
    [anon_sym_SQUOTE] = ACTIONS(3004),
    [anon_sym_L_DQUOTE] = ACTIONS(3004),
    [anon_sym_u_DQUOTE] = ACTIONS(3004),
    [anon_sym_U_DQUOTE] = ACTIONS(3004),
    [anon_sym_u8_DQUOTE] = ACTIONS(3004),
    [anon_sym_DQUOTE] = ACTIONS(3004),
    [sym_true] = ACTIONS(3002),
    [sym_false] = ACTIONS(3002),
    [anon_sym_NULL] = ACTIONS(3002),
    [anon_sym_nullptr] = ACTIONS(3002),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3002),
    [anon_sym_let] = ACTIONS(3002),
    [anon_sym_This] = ACTIONS(3002),
    [anon_sym_decltype] = ACTIONS(3002),
    [sym_virtual] = ACTIONS(3002),
    [anon_sym_explicit] = ACTIONS(3002),
    [anon_sym_typename] = ACTIONS(3002),
    [anon_sym_template] = ACTIONS(3002),
    [anon_sym_operator] = ACTIONS(3002),
    [anon_sym_try] = ACTIONS(3002),
    [anon_sym_delete] = ACTIONS(3002),
    [anon_sym_throw] = ACTIONS(3002),
    [anon_sym_namespace] = ACTIONS(3002),
    [anon_sym_using] = ACTIONS(3002),
    [anon_sym_static_assert] = ACTIONS(3002),
    [anon_sym_concept] = ACTIONS(3002),
    [anon_sym_co_return] = ACTIONS(3002),
    [anon_sym_co_yield] = ACTIONS(3002),
    [anon_sym_R_DQUOTE] = ACTIONS(3004),
    [anon_sym_LR_DQUOTE] = ACTIONS(3004),
    [anon_sym_uR_DQUOTE] = ACTIONS(3004),
    [anon_sym_UR_DQUOTE] = ACTIONS(3004),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3004),
    [anon_sym_co_await] = ACTIONS(3002),
    [anon_sym_new] = ACTIONS(3002),
    [anon_sym_requires] = ACTIONS(3002),
    [sym_this] = ACTIONS(3002),
    [anon_sym_discard] = ACTIONS(3002),
    [anon_sym_precise] = ACTIONS(3002),
    [anon_sym_shared] = ACTIONS(3002),
    [anon_sym_groupshared] = ACTIONS(3002),
    [anon_sym_uniform] = ACTIONS(3002),
    [anon_sym_row_major] = ACTIONS(3002),
    [anon_sym_column_major] = ACTIONS(3002),
    [anon_sym_globallycoherent] = ACTIONS(3002),
    [anon_sym_centroid] = ACTIONS(3002),
    [anon_sym_noperspective] = ACTIONS(3002),
    [anon_sym_nointerpolation] = ACTIONS(3002),
    [anon_sym_sample] = ACTIONS(3002),
    [anon_sym_linear] = ACTIONS(3002),
    [anon_sym_snorm] = ACTIONS(3002),
    [anon_sym_unorm] = ACTIONS(3002),
    [anon_sym_point] = ACTIONS(3002),
    [anon_sym_line] = ACTIONS(3002),
    [anon_sym_triangleadj] = ACTIONS(3002),
    [anon_sym_lineadj] = ACTIONS(3002),
    [anon_sym_triangle] = ACTIONS(3002),
    [anon_sym_cbuffer] = ACTIONS(3002),
    [anon_sym_interface] = ACTIONS(3002),
    [anon_sym_extension] = ACTIONS(3002),
  },
  [321] = {
    [sym_preproc_def] = STATE(301),
    [sym_preproc_function_def] = STATE(301),
    [sym_preproc_call] = STATE(301),
    [sym_preproc_if_in_field_declaration_list] = STATE(301),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(301),
    [sym_type_definition] = STATE(301),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(301),
    [sym_field_declaration] = STATE(301),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(301),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(301),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(301),
    [sym_operator_cast_declaration] = STATE(301),
    [sym_constructor_or_destructor_definition] = STATE(301),
    [sym_constructor_or_destructor_declaration] = STATE(301),
    [sym_friend_declaration] = STATE(301),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(301),
    [sym_alias_declaration] = STATE(301),
    [sym_static_assert_declaration] = STATE(301),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(301),
    [sym_subscript_declaration] = STATE(301),
    [sym_property_declaration] = STATE(301),
    [sym_associatedtype_declaration] = STATE(301),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(301),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3006),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [322] = {
    [sym_identifier] = ACTIONS(2373),
    [aux_sym_preproc_include_token1] = ACTIONS(2373),
    [aux_sym_preproc_def_token1] = ACTIONS(2373),
    [aux_sym_preproc_if_token1] = ACTIONS(2373),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2373),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2373),
    [sym_preproc_directive] = ACTIONS(2373),
    [anon_sym_LPAREN2] = ACTIONS(2371),
    [anon_sym_BANG] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym___extension__] = ACTIONS(2373),
    [anon_sym_typedef] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_out] = ACTIONS(2373),
    [anon_sym_inout] = ACTIONS(2373),
    [anon_sym_extern] = ACTIONS(2373),
    [anon_sym___attribute__] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2371),
    [anon_sym___declspec] = ACTIONS(2373),
    [anon_sym___based] = ACTIONS(2373),
    [anon_sym___cdecl] = ACTIONS(2373),
    [anon_sym___clrcall] = ACTIONS(2373),
    [anon_sym___stdcall] = ACTIONS(2373),
    [anon_sym___fastcall] = ACTIONS(2373),
    [anon_sym___thiscall] = ACTIONS(2373),
    [anon_sym___vectorcall] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_RBRACE] = ACTIONS(2371),
    [anon_sym_signed] = ACTIONS(2373),
    [anon_sym_unsigned] = ACTIONS(2373),
    [anon_sym_long] = ACTIONS(2373),
    [anon_sym_short] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2373),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_register] = ACTIONS(2373),
    [anon_sym_inline] = ACTIONS(2373),
    [anon_sym___inline] = ACTIONS(2373),
    [anon_sym___inline__] = ACTIONS(2373),
    [anon_sym___forceinline] = ACTIONS(2373),
    [anon_sym_thread_local] = ACTIONS(2373),
    [anon_sym___thread] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym___restrict__] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym__Noreturn] = ACTIONS(2373),
    [anon_sym_noreturn] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_constinit] = ACTIONS(2373),
    [anon_sym_consteval] = ACTIONS(2373),
    [anon_sym_alignas] = ACTIONS(2373),
    [anon_sym__Alignas] = ACTIONS(2373),
    [sym_primitive_type] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_class] = ACTIONS(2373),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_else] = ACTIONS(2373),
    [anon_sym_switch] = ACTIONS(2373),
    [anon_sym_case] = ACTIONS(2373),
    [anon_sym_default] = ACTIONS(2373),
    [anon_sym_while] = ACTIONS(2373),
    [anon_sym_do] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2373),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2373),
    [anon_sym_goto] = ACTIONS(2373),
    [anon_sym___try] = ACTIONS(2373),
    [anon_sym___leave] = ACTIONS(2373),
    [anon_sym_not] = ACTIONS(2373),
    [anon_sym_compl] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_sizeof] = ACTIONS(2373),
    [anon_sym___alignof__] = ACTIONS(2373),
    [anon_sym___alignof] = ACTIONS(2373),
    [anon_sym__alignof] = ACTIONS(2373),
    [anon_sym_alignof] = ACTIONS(2373),
    [anon_sym__Alignof] = ACTIONS(2373),
    [anon_sym_offsetof] = ACTIONS(2373),
    [anon_sym__Generic] = ACTIONS(2373),
    [anon_sym_asm] = ACTIONS(2373),
    [anon_sym___asm__] = ACTIONS(2373),
    [anon_sym_DOT] = ACTIONS(2373),
    [sym_number_literal] = ACTIONS(2371),
    [anon_sym_L_SQUOTE] = ACTIONS(2371),
    [anon_sym_u_SQUOTE] = ACTIONS(2371),
    [anon_sym_U_SQUOTE] = ACTIONS(2371),
    [anon_sym_u8_SQUOTE] = ACTIONS(2371),
    [anon_sym_SQUOTE] = ACTIONS(2371),
    [anon_sym_L_DQUOTE] = ACTIONS(2371),
    [anon_sym_u_DQUOTE] = ACTIONS(2371),
    [anon_sym_U_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8_DQUOTE] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [anon_sym_NULL] = ACTIONS(2373),
    [anon_sym_nullptr] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_This] = ACTIONS(2373),
    [anon_sym_decltype] = ACTIONS(2373),
    [anon_sym_final] = ACTIONS(2373),
    [anon_sym_override] = ACTIONS(2373),
    [sym_virtual] = ACTIONS(2373),
    [anon_sym_explicit] = ACTIONS(2373),
    [anon_sym_typename] = ACTIONS(2373),
    [anon_sym_template] = ACTIONS(2373),
    [anon_sym_operator] = ACTIONS(2373),
    [anon_sym_try] = ACTIONS(2373),
    [anon_sym_delete] = ACTIONS(2373),
    [anon_sym_throw] = ACTIONS(2373),
    [anon_sym_namespace] = ACTIONS(2373),
    [anon_sym_using] = ACTIONS(2373),
    [anon_sym_static_assert] = ACTIONS(2373),
    [anon_sym_concept] = ACTIONS(2373),
    [anon_sym_co_return] = ACTIONS(2373),
    [anon_sym_co_yield] = ACTIONS(2373),
    [anon_sym_R_DQUOTE] = ACTIONS(2371),
    [anon_sym_LR_DQUOTE] = ACTIONS(2371),
    [anon_sym_uR_DQUOTE] = ACTIONS(2371),
    [anon_sym_UR_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2371),
    [anon_sym_co_await] = ACTIONS(2373),
    [anon_sym_new] = ACTIONS(2373),
    [anon_sym_requires] = ACTIONS(2373),
    [sym_this] = ACTIONS(2373),
    [anon_sym_discard] = ACTIONS(2373),
    [anon_sym_precise] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_groupshared] = ACTIONS(2373),
    [anon_sym_uniform] = ACTIONS(2373),
    [anon_sym_row_major] = ACTIONS(2373),
    [anon_sym_column_major] = ACTIONS(2373),
    [anon_sym_globallycoherent] = ACTIONS(2373),
    [anon_sym_centroid] = ACTIONS(2373),
    [anon_sym_noperspective] = ACTIONS(2373),
    [anon_sym_nointerpolation] = ACTIONS(2373),
    [anon_sym_sample] = ACTIONS(2373),
    [anon_sym_linear] = ACTIONS(2373),
    [anon_sym_snorm] = ACTIONS(2373),
    [anon_sym_unorm] = ACTIONS(2373),
    [anon_sym_point] = ACTIONS(2373),
    [anon_sym_line] = ACTIONS(2373),
    [anon_sym_triangleadj] = ACTIONS(2373),
    [anon_sym_lineadj] = ACTIONS(2373),
    [anon_sym_triangle] = ACTIONS(2373),
    [anon_sym_cbuffer] = ACTIONS(2373),
    [anon_sym_interface] = ACTIONS(2373),
    [anon_sym_extension] = ACTIONS(2373),
  },
  [323] = {
    [sym_identifier] = ACTIONS(3008),
    [aux_sym_preproc_include_token1] = ACTIONS(3008),
    [aux_sym_preproc_def_token1] = ACTIONS(3008),
    [aux_sym_preproc_if_token1] = ACTIONS(3008),
    [aux_sym_preproc_if_token2] = ACTIONS(3008),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3008),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3008),
    [aux_sym_preproc_else_token1] = ACTIONS(3008),
    [aux_sym_preproc_elif_token1] = ACTIONS(3008),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3008),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3008),
    [sym_preproc_directive] = ACTIONS(3008),
    [anon_sym_LPAREN2] = ACTIONS(3010),
    [anon_sym_BANG] = ACTIONS(3010),
    [anon_sym_TILDE] = ACTIONS(3010),
    [anon_sym_DASH] = ACTIONS(3008),
    [anon_sym_PLUS] = ACTIONS(3008),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_AMP_AMP] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3008),
    [anon_sym_SEMI] = ACTIONS(3010),
    [anon_sym___extension__] = ACTIONS(3008),
    [anon_sym_typedef] = ACTIONS(3008),
    [anon_sym_in] = ACTIONS(3008),
    [anon_sym_out] = ACTIONS(3008),
    [anon_sym_inout] = ACTIONS(3008),
    [anon_sym_extern] = ACTIONS(3008),
    [anon_sym___attribute__] = ACTIONS(3008),
    [anon_sym_COLON_COLON] = ACTIONS(3010),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3010),
    [anon_sym___declspec] = ACTIONS(3008),
    [anon_sym___based] = ACTIONS(3008),
    [anon_sym___cdecl] = ACTIONS(3008),
    [anon_sym___clrcall] = ACTIONS(3008),
    [anon_sym___stdcall] = ACTIONS(3008),
    [anon_sym___fastcall] = ACTIONS(3008),
    [anon_sym___thiscall] = ACTIONS(3008),
    [anon_sym___vectorcall] = ACTIONS(3008),
    [anon_sym_LBRACE] = ACTIONS(3010),
    [anon_sym_signed] = ACTIONS(3008),
    [anon_sym_unsigned] = ACTIONS(3008),
    [anon_sym_long] = ACTIONS(3008),
    [anon_sym_short] = ACTIONS(3008),
    [anon_sym_LBRACK] = ACTIONS(3008),
    [anon_sym_static] = ACTIONS(3008),
    [anon_sym_register] = ACTIONS(3008),
    [anon_sym_inline] = ACTIONS(3008),
    [anon_sym___inline] = ACTIONS(3008),
    [anon_sym___inline__] = ACTIONS(3008),
    [anon_sym___forceinline] = ACTIONS(3008),
    [anon_sym_thread_local] = ACTIONS(3008),
    [anon_sym___thread] = ACTIONS(3008),
    [anon_sym_const] = ACTIONS(3008),
    [anon_sym_constexpr] = ACTIONS(3008),
    [anon_sym_volatile] = ACTIONS(3008),
    [anon_sym_restrict] = ACTIONS(3008),
    [anon_sym___restrict__] = ACTIONS(3008),
    [anon_sym__Atomic] = ACTIONS(3008),
    [anon_sym__Noreturn] = ACTIONS(3008),
    [anon_sym_noreturn] = ACTIONS(3008),
    [anon_sym_mutable] = ACTIONS(3008),
    [anon_sym_constinit] = ACTIONS(3008),
    [anon_sym_consteval] = ACTIONS(3008),
    [anon_sym_alignas] = ACTIONS(3008),
    [anon_sym__Alignas] = ACTIONS(3008),
    [sym_primitive_type] = ACTIONS(3008),
    [anon_sym_enum] = ACTIONS(3008),
    [anon_sym_class] = ACTIONS(3008),
    [anon_sym_struct] = ACTIONS(3008),
    [anon_sym_union] = ACTIONS(3008),
    [anon_sym_if] = ACTIONS(3008),
    [anon_sym_else] = ACTIONS(3008),
    [anon_sym_switch] = ACTIONS(3008),
    [anon_sym_case] = ACTIONS(3008),
    [anon_sym_default] = ACTIONS(3008),
    [anon_sym_while] = ACTIONS(3008),
    [anon_sym_do] = ACTIONS(3008),
    [anon_sym_for] = ACTIONS(3008),
    [anon_sym_return] = ACTIONS(3008),
    [anon_sym_break] = ACTIONS(3008),
    [anon_sym_continue] = ACTIONS(3008),
    [anon_sym_goto] = ACTIONS(3008),
    [anon_sym___try] = ACTIONS(3008),
    [anon_sym___leave] = ACTIONS(3008),
    [anon_sym_not] = ACTIONS(3008),
    [anon_sym_compl] = ACTIONS(3008),
    [anon_sym_DASH_DASH] = ACTIONS(3010),
    [anon_sym_PLUS_PLUS] = ACTIONS(3010),
    [anon_sym_sizeof] = ACTIONS(3008),
    [anon_sym___alignof__] = ACTIONS(3008),
    [anon_sym___alignof] = ACTIONS(3008),
    [anon_sym__alignof] = ACTIONS(3008),
    [anon_sym_alignof] = ACTIONS(3008),
    [anon_sym__Alignof] = ACTIONS(3008),
    [anon_sym_offsetof] = ACTIONS(3008),
    [anon_sym__Generic] = ACTIONS(3008),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [sym_number_literal] = ACTIONS(3010),
    [anon_sym_L_SQUOTE] = ACTIONS(3010),
    [anon_sym_u_SQUOTE] = ACTIONS(3010),
    [anon_sym_U_SQUOTE] = ACTIONS(3010),
    [anon_sym_u8_SQUOTE] = ACTIONS(3010),
    [anon_sym_SQUOTE] = ACTIONS(3010),
    [anon_sym_L_DQUOTE] = ACTIONS(3010),
    [anon_sym_u_DQUOTE] = ACTIONS(3010),
    [anon_sym_U_DQUOTE] = ACTIONS(3010),
    [anon_sym_u8_DQUOTE] = ACTIONS(3010),
    [anon_sym_DQUOTE] = ACTIONS(3010),
    [sym_true] = ACTIONS(3008),
    [sym_false] = ACTIONS(3008),
    [anon_sym_NULL] = ACTIONS(3008),
    [anon_sym_nullptr] = ACTIONS(3008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3008),
    [anon_sym_let] = ACTIONS(3008),
    [anon_sym_This] = ACTIONS(3008),
    [anon_sym_decltype] = ACTIONS(3008),
    [sym_virtual] = ACTIONS(3008),
    [anon_sym_explicit] = ACTIONS(3008),
    [anon_sym_typename] = ACTIONS(3008),
    [anon_sym_template] = ACTIONS(3008),
    [anon_sym_operator] = ACTIONS(3008),
    [anon_sym_try] = ACTIONS(3008),
    [anon_sym_delete] = ACTIONS(3008),
    [anon_sym_throw] = ACTIONS(3008),
    [anon_sym_namespace] = ACTIONS(3008),
    [anon_sym_using] = ACTIONS(3008),
    [anon_sym_static_assert] = ACTIONS(3008),
    [anon_sym_concept] = ACTIONS(3008),
    [anon_sym_co_return] = ACTIONS(3008),
    [anon_sym_co_yield] = ACTIONS(3008),
    [anon_sym_R_DQUOTE] = ACTIONS(3010),
    [anon_sym_LR_DQUOTE] = ACTIONS(3010),
    [anon_sym_uR_DQUOTE] = ACTIONS(3010),
    [anon_sym_UR_DQUOTE] = ACTIONS(3010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3010),
    [anon_sym_co_await] = ACTIONS(3008),
    [anon_sym_new] = ACTIONS(3008),
    [anon_sym_requires] = ACTIONS(3008),
    [sym_this] = ACTIONS(3008),
    [anon_sym_discard] = ACTIONS(3008),
    [anon_sym_precise] = ACTIONS(3008),
    [anon_sym_shared] = ACTIONS(3008),
    [anon_sym_groupshared] = ACTIONS(3008),
    [anon_sym_uniform] = ACTIONS(3008),
    [anon_sym_row_major] = ACTIONS(3008),
    [anon_sym_column_major] = ACTIONS(3008),
    [anon_sym_globallycoherent] = ACTIONS(3008),
    [anon_sym_centroid] = ACTIONS(3008),
    [anon_sym_noperspective] = ACTIONS(3008),
    [anon_sym_nointerpolation] = ACTIONS(3008),
    [anon_sym_sample] = ACTIONS(3008),
    [anon_sym_linear] = ACTIONS(3008),
    [anon_sym_snorm] = ACTIONS(3008),
    [anon_sym_unorm] = ACTIONS(3008),
    [anon_sym_point] = ACTIONS(3008),
    [anon_sym_line] = ACTIONS(3008),
    [anon_sym_triangleadj] = ACTIONS(3008),
    [anon_sym_lineadj] = ACTIONS(3008),
    [anon_sym_triangle] = ACTIONS(3008),
    [anon_sym_cbuffer] = ACTIONS(3008),
    [anon_sym_interface] = ACTIONS(3008),
    [anon_sym_extension] = ACTIONS(3008),
  },
  [324] = {
    [sym_preproc_def] = STATE(338),
    [sym_preproc_function_def] = STATE(338),
    [sym_preproc_call] = STATE(338),
    [sym_preproc_if_in_field_declaration_list] = STATE(338),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(338),
    [sym_type_definition] = STATE(338),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(338),
    [sym_field_declaration] = STATE(338),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(338),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(338),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(338),
    [sym_operator_cast_declaration] = STATE(338),
    [sym_constructor_or_destructor_definition] = STATE(338),
    [sym_constructor_or_destructor_declaration] = STATE(338),
    [sym_friend_declaration] = STATE(338),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(338),
    [sym_alias_declaration] = STATE(338),
    [sym_static_assert_declaration] = STATE(338),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(338),
    [sym_subscript_declaration] = STATE(338),
    [sym_property_declaration] = STATE(338),
    [sym_associatedtype_declaration] = STATE(338),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(338),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3012),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [325] = {
    [sym_identifier] = ACTIONS(2373),
    [aux_sym_preproc_include_token1] = ACTIONS(2373),
    [aux_sym_preproc_def_token1] = ACTIONS(2373),
    [aux_sym_preproc_if_token1] = ACTIONS(2373),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2373),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2373),
    [sym_preproc_directive] = ACTIONS(2373),
    [anon_sym_LPAREN2] = ACTIONS(2371),
    [anon_sym_BANG] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym___extension__] = ACTIONS(2373),
    [anon_sym_typedef] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_out] = ACTIONS(2373),
    [anon_sym_inout] = ACTIONS(2373),
    [anon_sym_extern] = ACTIONS(2373),
    [anon_sym___attribute__] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2371),
    [anon_sym___declspec] = ACTIONS(2373),
    [anon_sym___based] = ACTIONS(2373),
    [anon_sym___cdecl] = ACTIONS(2373),
    [anon_sym___clrcall] = ACTIONS(2373),
    [anon_sym___stdcall] = ACTIONS(2373),
    [anon_sym___fastcall] = ACTIONS(2373),
    [anon_sym___thiscall] = ACTIONS(2373),
    [anon_sym___vectorcall] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_RBRACE] = ACTIONS(2371),
    [anon_sym_signed] = ACTIONS(2373),
    [anon_sym_unsigned] = ACTIONS(2373),
    [anon_sym_long] = ACTIONS(2373),
    [anon_sym_short] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2373),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_register] = ACTIONS(2373),
    [anon_sym_inline] = ACTIONS(2373),
    [anon_sym___inline] = ACTIONS(2373),
    [anon_sym___inline__] = ACTIONS(2373),
    [anon_sym___forceinline] = ACTIONS(2373),
    [anon_sym_thread_local] = ACTIONS(2373),
    [anon_sym___thread] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym___restrict__] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym__Noreturn] = ACTIONS(2373),
    [anon_sym_noreturn] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_constinit] = ACTIONS(2373),
    [anon_sym_consteval] = ACTIONS(2373),
    [anon_sym_alignas] = ACTIONS(2373),
    [anon_sym__Alignas] = ACTIONS(2373),
    [sym_primitive_type] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_class] = ACTIONS(2373),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_else] = ACTIONS(2373),
    [anon_sym_switch] = ACTIONS(2373),
    [anon_sym_case] = ACTIONS(2373),
    [anon_sym_default] = ACTIONS(2373),
    [anon_sym_while] = ACTIONS(2373),
    [anon_sym_do] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2373),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2373),
    [anon_sym_goto] = ACTIONS(2373),
    [anon_sym___try] = ACTIONS(2373),
    [anon_sym___leave] = ACTIONS(2373),
    [anon_sym_not] = ACTIONS(2373),
    [anon_sym_compl] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_sizeof] = ACTIONS(2373),
    [anon_sym___alignof__] = ACTIONS(2373),
    [anon_sym___alignof] = ACTIONS(2373),
    [anon_sym__alignof] = ACTIONS(2373),
    [anon_sym_alignof] = ACTIONS(2373),
    [anon_sym__Alignof] = ACTIONS(2373),
    [anon_sym_offsetof] = ACTIONS(2373),
    [anon_sym__Generic] = ACTIONS(2373),
    [anon_sym_asm] = ACTIONS(2373),
    [anon_sym___asm__] = ACTIONS(2373),
    [anon_sym_DOT] = ACTIONS(2373),
    [sym_number_literal] = ACTIONS(2371),
    [anon_sym_L_SQUOTE] = ACTIONS(2371),
    [anon_sym_u_SQUOTE] = ACTIONS(2371),
    [anon_sym_U_SQUOTE] = ACTIONS(2371),
    [anon_sym_u8_SQUOTE] = ACTIONS(2371),
    [anon_sym_SQUOTE] = ACTIONS(2371),
    [anon_sym_L_DQUOTE] = ACTIONS(2371),
    [anon_sym_u_DQUOTE] = ACTIONS(2371),
    [anon_sym_U_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8_DQUOTE] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [anon_sym_NULL] = ACTIONS(2373),
    [anon_sym_nullptr] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_This] = ACTIONS(2373),
    [anon_sym_decltype] = ACTIONS(2373),
    [anon_sym_final] = ACTIONS(2373),
    [anon_sym_override] = ACTIONS(2373),
    [sym_virtual] = ACTIONS(2373),
    [anon_sym_explicit] = ACTIONS(2373),
    [anon_sym_typename] = ACTIONS(2373),
    [anon_sym_template] = ACTIONS(2373),
    [anon_sym_operator] = ACTIONS(2373),
    [anon_sym_try] = ACTIONS(2373),
    [anon_sym_delete] = ACTIONS(2373),
    [anon_sym_throw] = ACTIONS(2373),
    [anon_sym_namespace] = ACTIONS(2373),
    [anon_sym_using] = ACTIONS(2373),
    [anon_sym_static_assert] = ACTIONS(2373),
    [anon_sym_concept] = ACTIONS(2373),
    [anon_sym_co_return] = ACTIONS(2373),
    [anon_sym_co_yield] = ACTIONS(2373),
    [anon_sym_R_DQUOTE] = ACTIONS(2371),
    [anon_sym_LR_DQUOTE] = ACTIONS(2371),
    [anon_sym_uR_DQUOTE] = ACTIONS(2371),
    [anon_sym_UR_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2371),
    [anon_sym_co_await] = ACTIONS(2373),
    [anon_sym_new] = ACTIONS(2373),
    [anon_sym_requires] = ACTIONS(2373),
    [sym_this] = ACTIONS(2373),
    [anon_sym_discard] = ACTIONS(2373),
    [anon_sym_precise] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_groupshared] = ACTIONS(2373),
    [anon_sym_uniform] = ACTIONS(2373),
    [anon_sym_row_major] = ACTIONS(2373),
    [anon_sym_column_major] = ACTIONS(2373),
    [anon_sym_globallycoherent] = ACTIONS(2373),
    [anon_sym_centroid] = ACTIONS(2373),
    [anon_sym_noperspective] = ACTIONS(2373),
    [anon_sym_nointerpolation] = ACTIONS(2373),
    [anon_sym_sample] = ACTIONS(2373),
    [anon_sym_linear] = ACTIONS(2373),
    [anon_sym_snorm] = ACTIONS(2373),
    [anon_sym_unorm] = ACTIONS(2373),
    [anon_sym_point] = ACTIONS(2373),
    [anon_sym_line] = ACTIONS(2373),
    [anon_sym_triangleadj] = ACTIONS(2373),
    [anon_sym_lineadj] = ACTIONS(2373),
    [anon_sym_triangle] = ACTIONS(2373),
    [anon_sym_cbuffer] = ACTIONS(2373),
    [anon_sym_interface] = ACTIONS(2373),
    [anon_sym_extension] = ACTIONS(2373),
  },
  [326] = {
    [sym_identifier] = ACTIONS(2373),
    [aux_sym_preproc_include_token1] = ACTIONS(2373),
    [aux_sym_preproc_def_token1] = ACTIONS(2373),
    [aux_sym_preproc_if_token1] = ACTIONS(2373),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2373),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2373),
    [sym_preproc_directive] = ACTIONS(2373),
    [anon_sym_LPAREN2] = ACTIONS(2371),
    [anon_sym_BANG] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym___extension__] = ACTIONS(2373),
    [anon_sym_typedef] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_out] = ACTIONS(2373),
    [anon_sym_inout] = ACTIONS(2373),
    [anon_sym_extern] = ACTIONS(2373),
    [anon_sym___attribute__] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2371),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2371),
    [anon_sym___declspec] = ACTIONS(2373),
    [anon_sym___based] = ACTIONS(2373),
    [anon_sym___cdecl] = ACTIONS(2373),
    [anon_sym___clrcall] = ACTIONS(2373),
    [anon_sym___stdcall] = ACTIONS(2373),
    [anon_sym___fastcall] = ACTIONS(2373),
    [anon_sym___thiscall] = ACTIONS(2373),
    [anon_sym___vectorcall] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_RBRACE] = ACTIONS(2371),
    [anon_sym_signed] = ACTIONS(2373),
    [anon_sym_unsigned] = ACTIONS(2373),
    [anon_sym_long] = ACTIONS(2373),
    [anon_sym_short] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2373),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_register] = ACTIONS(2373),
    [anon_sym_inline] = ACTIONS(2373),
    [anon_sym___inline] = ACTIONS(2373),
    [anon_sym___inline__] = ACTIONS(2373),
    [anon_sym___forceinline] = ACTIONS(2373),
    [anon_sym_thread_local] = ACTIONS(2373),
    [anon_sym___thread] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym___restrict__] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym__Noreturn] = ACTIONS(2373),
    [anon_sym_noreturn] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_constinit] = ACTIONS(2373),
    [anon_sym_consteval] = ACTIONS(2373),
    [anon_sym_alignas] = ACTIONS(2373),
    [anon_sym__Alignas] = ACTIONS(2373),
    [sym_primitive_type] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_class] = ACTIONS(2373),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_else] = ACTIONS(2373),
    [anon_sym_switch] = ACTIONS(2373),
    [anon_sym_case] = ACTIONS(2373),
    [anon_sym_default] = ACTIONS(2373),
    [anon_sym_while] = ACTIONS(2373),
    [anon_sym_do] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2373),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2373),
    [anon_sym_goto] = ACTIONS(2373),
    [anon_sym___try] = ACTIONS(2373),
    [anon_sym___leave] = ACTIONS(2373),
    [anon_sym_not] = ACTIONS(2373),
    [anon_sym_compl] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_sizeof] = ACTIONS(2373),
    [anon_sym___alignof__] = ACTIONS(2373),
    [anon_sym___alignof] = ACTIONS(2373),
    [anon_sym__alignof] = ACTIONS(2373),
    [anon_sym_alignof] = ACTIONS(2373),
    [anon_sym__Alignof] = ACTIONS(2373),
    [anon_sym_offsetof] = ACTIONS(2373),
    [anon_sym__Generic] = ACTIONS(2373),
    [anon_sym_asm] = ACTIONS(2373),
    [anon_sym___asm__] = ACTIONS(2373),
    [anon_sym_DOT] = ACTIONS(2373),
    [sym_number_literal] = ACTIONS(2371),
    [anon_sym_L_SQUOTE] = ACTIONS(2371),
    [anon_sym_u_SQUOTE] = ACTIONS(2371),
    [anon_sym_U_SQUOTE] = ACTIONS(2371),
    [anon_sym_u8_SQUOTE] = ACTIONS(2371),
    [anon_sym_SQUOTE] = ACTIONS(2371),
    [anon_sym_L_DQUOTE] = ACTIONS(2371),
    [anon_sym_u_DQUOTE] = ACTIONS(2371),
    [anon_sym_U_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8_DQUOTE] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [anon_sym_NULL] = ACTIONS(2373),
    [anon_sym_nullptr] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_This] = ACTIONS(2373),
    [anon_sym_decltype] = ACTIONS(2373),
    [anon_sym_final] = ACTIONS(2373),
    [anon_sym_override] = ACTIONS(2373),
    [sym_virtual] = ACTIONS(2373),
    [anon_sym_explicit] = ACTIONS(2373),
    [anon_sym_typename] = ACTIONS(2373),
    [anon_sym_template] = ACTIONS(2373),
    [anon_sym_operator] = ACTIONS(2373),
    [anon_sym_try] = ACTIONS(2373),
    [anon_sym_delete] = ACTIONS(2373),
    [anon_sym_throw] = ACTIONS(2373),
    [anon_sym_namespace] = ACTIONS(2373),
    [anon_sym_using] = ACTIONS(2373),
    [anon_sym_static_assert] = ACTIONS(2373),
    [anon_sym_concept] = ACTIONS(2373),
    [anon_sym_co_return] = ACTIONS(2373),
    [anon_sym_co_yield] = ACTIONS(2373),
    [anon_sym_R_DQUOTE] = ACTIONS(2371),
    [anon_sym_LR_DQUOTE] = ACTIONS(2371),
    [anon_sym_uR_DQUOTE] = ACTIONS(2371),
    [anon_sym_UR_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2371),
    [anon_sym_co_await] = ACTIONS(2373),
    [anon_sym_new] = ACTIONS(2373),
    [anon_sym_requires] = ACTIONS(2373),
    [sym_this] = ACTIONS(2373),
    [anon_sym_discard] = ACTIONS(2373),
    [anon_sym_precise] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_groupshared] = ACTIONS(2373),
    [anon_sym_uniform] = ACTIONS(2373),
    [anon_sym_row_major] = ACTIONS(2373),
    [anon_sym_column_major] = ACTIONS(2373),
    [anon_sym_globallycoherent] = ACTIONS(2373),
    [anon_sym_centroid] = ACTIONS(2373),
    [anon_sym_noperspective] = ACTIONS(2373),
    [anon_sym_nointerpolation] = ACTIONS(2373),
    [anon_sym_sample] = ACTIONS(2373),
    [anon_sym_linear] = ACTIONS(2373),
    [anon_sym_snorm] = ACTIONS(2373),
    [anon_sym_unorm] = ACTIONS(2373),
    [anon_sym_point] = ACTIONS(2373),
    [anon_sym_line] = ACTIONS(2373),
    [anon_sym_triangleadj] = ACTIONS(2373),
    [anon_sym_lineadj] = ACTIONS(2373),
    [anon_sym_triangle] = ACTIONS(2373),
    [anon_sym_cbuffer] = ACTIONS(2373),
    [anon_sym_interface] = ACTIONS(2373),
    [anon_sym_extension] = ACTIONS(2373),
  },
  [327] = {
    [sym_identifier] = ACTIONS(3014),
    [aux_sym_preproc_include_token1] = ACTIONS(3014),
    [aux_sym_preproc_def_token1] = ACTIONS(3014),
    [aux_sym_preproc_if_token1] = ACTIONS(3014),
    [aux_sym_preproc_if_token2] = ACTIONS(3014),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3014),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3014),
    [aux_sym_preproc_else_token1] = ACTIONS(3014),
    [aux_sym_preproc_elif_token1] = ACTIONS(3014),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3014),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3014),
    [sym_preproc_directive] = ACTIONS(3014),
    [anon_sym_LPAREN2] = ACTIONS(3016),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [anon_sym_DASH] = ACTIONS(3014),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_STAR] = ACTIONS(3016),
    [anon_sym_AMP_AMP] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3016),
    [anon_sym___extension__] = ACTIONS(3014),
    [anon_sym_typedef] = ACTIONS(3014),
    [anon_sym_in] = ACTIONS(3014),
    [anon_sym_out] = ACTIONS(3014),
    [anon_sym_inout] = ACTIONS(3014),
    [anon_sym_extern] = ACTIONS(3014),
    [anon_sym___attribute__] = ACTIONS(3014),
    [anon_sym_COLON_COLON] = ACTIONS(3016),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3016),
    [anon_sym___declspec] = ACTIONS(3014),
    [anon_sym___based] = ACTIONS(3014),
    [anon_sym___cdecl] = ACTIONS(3014),
    [anon_sym___clrcall] = ACTIONS(3014),
    [anon_sym___stdcall] = ACTIONS(3014),
    [anon_sym___fastcall] = ACTIONS(3014),
    [anon_sym___thiscall] = ACTIONS(3014),
    [anon_sym___vectorcall] = ACTIONS(3014),
    [anon_sym_LBRACE] = ACTIONS(3016),
    [anon_sym_signed] = ACTIONS(3014),
    [anon_sym_unsigned] = ACTIONS(3014),
    [anon_sym_long] = ACTIONS(3014),
    [anon_sym_short] = ACTIONS(3014),
    [anon_sym_LBRACK] = ACTIONS(3014),
    [anon_sym_static] = ACTIONS(3014),
    [anon_sym_register] = ACTIONS(3014),
    [anon_sym_inline] = ACTIONS(3014),
    [anon_sym___inline] = ACTIONS(3014),
    [anon_sym___inline__] = ACTIONS(3014),
    [anon_sym___forceinline] = ACTIONS(3014),
    [anon_sym_thread_local] = ACTIONS(3014),
    [anon_sym___thread] = ACTIONS(3014),
    [anon_sym_const] = ACTIONS(3014),
    [anon_sym_constexpr] = ACTIONS(3014),
    [anon_sym_volatile] = ACTIONS(3014),
    [anon_sym_restrict] = ACTIONS(3014),
    [anon_sym___restrict__] = ACTIONS(3014),
    [anon_sym__Atomic] = ACTIONS(3014),
    [anon_sym__Noreturn] = ACTIONS(3014),
    [anon_sym_noreturn] = ACTIONS(3014),
    [anon_sym_mutable] = ACTIONS(3014),
    [anon_sym_constinit] = ACTIONS(3014),
    [anon_sym_consteval] = ACTIONS(3014),
    [anon_sym_alignas] = ACTIONS(3014),
    [anon_sym__Alignas] = ACTIONS(3014),
    [sym_primitive_type] = ACTIONS(3014),
    [anon_sym_enum] = ACTIONS(3014),
    [anon_sym_class] = ACTIONS(3014),
    [anon_sym_struct] = ACTIONS(3014),
    [anon_sym_union] = ACTIONS(3014),
    [anon_sym_if] = ACTIONS(3014),
    [anon_sym_else] = ACTIONS(3014),
    [anon_sym_switch] = ACTIONS(3014),
    [anon_sym_case] = ACTIONS(3014),
    [anon_sym_default] = ACTIONS(3014),
    [anon_sym_while] = ACTIONS(3014),
    [anon_sym_do] = ACTIONS(3014),
    [anon_sym_for] = ACTIONS(3014),
    [anon_sym_return] = ACTIONS(3014),
    [anon_sym_break] = ACTIONS(3014),
    [anon_sym_continue] = ACTIONS(3014),
    [anon_sym_goto] = ACTIONS(3014),
    [anon_sym___try] = ACTIONS(3014),
    [anon_sym___leave] = ACTIONS(3014),
    [anon_sym_not] = ACTIONS(3014),
    [anon_sym_compl] = ACTIONS(3014),
    [anon_sym_DASH_DASH] = ACTIONS(3016),
    [anon_sym_PLUS_PLUS] = ACTIONS(3016),
    [anon_sym_sizeof] = ACTIONS(3014),
    [anon_sym___alignof__] = ACTIONS(3014),
    [anon_sym___alignof] = ACTIONS(3014),
    [anon_sym__alignof] = ACTIONS(3014),
    [anon_sym_alignof] = ACTIONS(3014),
    [anon_sym__Alignof] = ACTIONS(3014),
    [anon_sym_offsetof] = ACTIONS(3014),
    [anon_sym__Generic] = ACTIONS(3014),
    [anon_sym_asm] = ACTIONS(3014),
    [anon_sym___asm__] = ACTIONS(3014),
    [sym_number_literal] = ACTIONS(3016),
    [anon_sym_L_SQUOTE] = ACTIONS(3016),
    [anon_sym_u_SQUOTE] = ACTIONS(3016),
    [anon_sym_U_SQUOTE] = ACTIONS(3016),
    [anon_sym_u8_SQUOTE] = ACTIONS(3016),
    [anon_sym_SQUOTE] = ACTIONS(3016),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3014),
    [sym_false] = ACTIONS(3014),
    [anon_sym_NULL] = ACTIONS(3014),
    [anon_sym_nullptr] = ACTIONS(3014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3014),
    [anon_sym_let] = ACTIONS(3014),
    [anon_sym_This] = ACTIONS(3014),
    [anon_sym_decltype] = ACTIONS(3014),
    [sym_virtual] = ACTIONS(3014),
    [anon_sym_explicit] = ACTIONS(3014),
    [anon_sym_typename] = ACTIONS(3014),
    [anon_sym_template] = ACTIONS(3014),
    [anon_sym_operator] = ACTIONS(3014),
    [anon_sym_try] = ACTIONS(3014),
    [anon_sym_delete] = ACTIONS(3014),
    [anon_sym_throw] = ACTIONS(3014),
    [anon_sym_namespace] = ACTIONS(3014),
    [anon_sym_using] = ACTIONS(3014),
    [anon_sym_static_assert] = ACTIONS(3014),
    [anon_sym_concept] = ACTIONS(3014),
    [anon_sym_co_return] = ACTIONS(3014),
    [anon_sym_co_yield] = ACTIONS(3014),
    [anon_sym_R_DQUOTE] = ACTIONS(3016),
    [anon_sym_LR_DQUOTE] = ACTIONS(3016),
    [anon_sym_uR_DQUOTE] = ACTIONS(3016),
    [anon_sym_UR_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3016),
    [anon_sym_co_await] = ACTIONS(3014),
    [anon_sym_new] = ACTIONS(3014),
    [anon_sym_requires] = ACTIONS(3014),
    [sym_this] = ACTIONS(3014),
    [anon_sym_discard] = ACTIONS(3014),
    [anon_sym_precise] = ACTIONS(3014),
    [anon_sym_shared] = ACTIONS(3014),
    [anon_sym_groupshared] = ACTIONS(3014),
    [anon_sym_uniform] = ACTIONS(3014),
    [anon_sym_row_major] = ACTIONS(3014),
    [anon_sym_column_major] = ACTIONS(3014),
    [anon_sym_globallycoherent] = ACTIONS(3014),
    [anon_sym_centroid] = ACTIONS(3014),
    [anon_sym_noperspective] = ACTIONS(3014),
    [anon_sym_nointerpolation] = ACTIONS(3014),
    [anon_sym_sample] = ACTIONS(3014),
    [anon_sym_linear] = ACTIONS(3014),
    [anon_sym_snorm] = ACTIONS(3014),
    [anon_sym_unorm] = ACTIONS(3014),
    [anon_sym_point] = ACTIONS(3014),
    [anon_sym_line] = ACTIONS(3014),
    [anon_sym_triangleadj] = ACTIONS(3014),
    [anon_sym_lineadj] = ACTIONS(3014),
    [anon_sym_triangle] = ACTIONS(3014),
    [anon_sym_cbuffer] = ACTIONS(3014),
    [anon_sym_interface] = ACTIONS(3014),
    [anon_sym_extension] = ACTIONS(3014),
  },
  [328] = {
    [sym_identifier] = ACTIONS(3018),
    [aux_sym_preproc_include_token1] = ACTIONS(3018),
    [aux_sym_preproc_def_token1] = ACTIONS(3018),
    [aux_sym_preproc_if_token1] = ACTIONS(3018),
    [aux_sym_preproc_if_token2] = ACTIONS(3018),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3018),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3018),
    [aux_sym_preproc_else_token1] = ACTIONS(3018),
    [aux_sym_preproc_elif_token1] = ACTIONS(3018),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3018),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3018),
    [sym_preproc_directive] = ACTIONS(3018),
    [anon_sym_LPAREN2] = ACTIONS(3020),
    [anon_sym_BANG] = ACTIONS(3020),
    [anon_sym_TILDE] = ACTIONS(3020),
    [anon_sym_DASH] = ACTIONS(3018),
    [anon_sym_PLUS] = ACTIONS(3018),
    [anon_sym_STAR] = ACTIONS(3020),
    [anon_sym_AMP_AMP] = ACTIONS(3020),
    [anon_sym_AMP] = ACTIONS(3018),
    [anon_sym_SEMI] = ACTIONS(3020),
    [anon_sym___extension__] = ACTIONS(3018),
    [anon_sym_typedef] = ACTIONS(3018),
    [anon_sym_in] = ACTIONS(3018),
    [anon_sym_out] = ACTIONS(3018),
    [anon_sym_inout] = ACTIONS(3018),
    [anon_sym_extern] = ACTIONS(3018),
    [anon_sym___attribute__] = ACTIONS(3018),
    [anon_sym_COLON_COLON] = ACTIONS(3020),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3020),
    [anon_sym___declspec] = ACTIONS(3018),
    [anon_sym___based] = ACTIONS(3018),
    [anon_sym___cdecl] = ACTIONS(3018),
    [anon_sym___clrcall] = ACTIONS(3018),
    [anon_sym___stdcall] = ACTIONS(3018),
    [anon_sym___fastcall] = ACTIONS(3018),
    [anon_sym___thiscall] = ACTIONS(3018),
    [anon_sym___vectorcall] = ACTIONS(3018),
    [anon_sym_LBRACE] = ACTIONS(3020),
    [anon_sym_signed] = ACTIONS(3018),
    [anon_sym_unsigned] = ACTIONS(3018),
    [anon_sym_long] = ACTIONS(3018),
    [anon_sym_short] = ACTIONS(3018),
    [anon_sym_LBRACK] = ACTIONS(3018),
    [anon_sym_static] = ACTIONS(3018),
    [anon_sym_register] = ACTIONS(3018),
    [anon_sym_inline] = ACTIONS(3018),
    [anon_sym___inline] = ACTIONS(3018),
    [anon_sym___inline__] = ACTIONS(3018),
    [anon_sym___forceinline] = ACTIONS(3018),
    [anon_sym_thread_local] = ACTIONS(3018),
    [anon_sym___thread] = ACTIONS(3018),
    [anon_sym_const] = ACTIONS(3018),
    [anon_sym_constexpr] = ACTIONS(3018),
    [anon_sym_volatile] = ACTIONS(3018),
    [anon_sym_restrict] = ACTIONS(3018),
    [anon_sym___restrict__] = ACTIONS(3018),
    [anon_sym__Atomic] = ACTIONS(3018),
    [anon_sym__Noreturn] = ACTIONS(3018),
    [anon_sym_noreturn] = ACTIONS(3018),
    [anon_sym_mutable] = ACTIONS(3018),
    [anon_sym_constinit] = ACTIONS(3018),
    [anon_sym_consteval] = ACTIONS(3018),
    [anon_sym_alignas] = ACTIONS(3018),
    [anon_sym__Alignas] = ACTIONS(3018),
    [sym_primitive_type] = ACTIONS(3018),
    [anon_sym_enum] = ACTIONS(3018),
    [anon_sym_class] = ACTIONS(3018),
    [anon_sym_struct] = ACTIONS(3018),
    [anon_sym_union] = ACTIONS(3018),
    [anon_sym_if] = ACTIONS(3018),
    [anon_sym_else] = ACTIONS(3018),
    [anon_sym_switch] = ACTIONS(3018),
    [anon_sym_case] = ACTIONS(3018),
    [anon_sym_default] = ACTIONS(3018),
    [anon_sym_while] = ACTIONS(3018),
    [anon_sym_do] = ACTIONS(3018),
    [anon_sym_for] = ACTIONS(3018),
    [anon_sym_return] = ACTIONS(3018),
    [anon_sym_break] = ACTIONS(3018),
    [anon_sym_continue] = ACTIONS(3018),
    [anon_sym_goto] = ACTIONS(3018),
    [anon_sym___try] = ACTIONS(3018),
    [anon_sym___leave] = ACTIONS(3018),
    [anon_sym_not] = ACTIONS(3018),
    [anon_sym_compl] = ACTIONS(3018),
    [anon_sym_DASH_DASH] = ACTIONS(3020),
    [anon_sym_PLUS_PLUS] = ACTIONS(3020),
    [anon_sym_sizeof] = ACTIONS(3018),
    [anon_sym___alignof__] = ACTIONS(3018),
    [anon_sym___alignof] = ACTIONS(3018),
    [anon_sym__alignof] = ACTIONS(3018),
    [anon_sym_alignof] = ACTIONS(3018),
    [anon_sym__Alignof] = ACTIONS(3018),
    [anon_sym_offsetof] = ACTIONS(3018),
    [anon_sym__Generic] = ACTIONS(3018),
    [anon_sym_asm] = ACTIONS(3018),
    [anon_sym___asm__] = ACTIONS(3018),
    [sym_number_literal] = ACTIONS(3020),
    [anon_sym_L_SQUOTE] = ACTIONS(3020),
    [anon_sym_u_SQUOTE] = ACTIONS(3020),
    [anon_sym_U_SQUOTE] = ACTIONS(3020),
    [anon_sym_u8_SQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3020),
    [anon_sym_L_DQUOTE] = ACTIONS(3020),
    [anon_sym_u_DQUOTE] = ACTIONS(3020),
    [anon_sym_U_DQUOTE] = ACTIONS(3020),
    [anon_sym_u8_DQUOTE] = ACTIONS(3020),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3018),
    [anon_sym_nullptr] = ACTIONS(3018),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3018),
    [anon_sym_let] = ACTIONS(3018),
    [anon_sym_This] = ACTIONS(3018),
    [anon_sym_decltype] = ACTIONS(3018),
    [sym_virtual] = ACTIONS(3018),
    [anon_sym_explicit] = ACTIONS(3018),
    [anon_sym_typename] = ACTIONS(3018),
    [anon_sym_template] = ACTIONS(3018),
    [anon_sym_operator] = ACTIONS(3018),
    [anon_sym_try] = ACTIONS(3018),
    [anon_sym_delete] = ACTIONS(3018),
    [anon_sym_throw] = ACTIONS(3018),
    [anon_sym_namespace] = ACTIONS(3018),
    [anon_sym_using] = ACTIONS(3018),
    [anon_sym_static_assert] = ACTIONS(3018),
    [anon_sym_concept] = ACTIONS(3018),
    [anon_sym_co_return] = ACTIONS(3018),
    [anon_sym_co_yield] = ACTIONS(3018),
    [anon_sym_R_DQUOTE] = ACTIONS(3020),
    [anon_sym_LR_DQUOTE] = ACTIONS(3020),
    [anon_sym_uR_DQUOTE] = ACTIONS(3020),
    [anon_sym_UR_DQUOTE] = ACTIONS(3020),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3020),
    [anon_sym_co_await] = ACTIONS(3018),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_requires] = ACTIONS(3018),
    [sym_this] = ACTIONS(3018),
    [anon_sym_discard] = ACTIONS(3018),
    [anon_sym_precise] = ACTIONS(3018),
    [anon_sym_shared] = ACTIONS(3018),
    [anon_sym_groupshared] = ACTIONS(3018),
    [anon_sym_uniform] = ACTIONS(3018),
    [anon_sym_row_major] = ACTIONS(3018),
    [anon_sym_column_major] = ACTIONS(3018),
    [anon_sym_globallycoherent] = ACTIONS(3018),
    [anon_sym_centroid] = ACTIONS(3018),
    [anon_sym_noperspective] = ACTIONS(3018),
    [anon_sym_nointerpolation] = ACTIONS(3018),
    [anon_sym_sample] = ACTIONS(3018),
    [anon_sym_linear] = ACTIONS(3018),
    [anon_sym_snorm] = ACTIONS(3018),
    [anon_sym_unorm] = ACTIONS(3018),
    [anon_sym_point] = ACTIONS(3018),
    [anon_sym_line] = ACTIONS(3018),
    [anon_sym_triangleadj] = ACTIONS(3018),
    [anon_sym_lineadj] = ACTIONS(3018),
    [anon_sym_triangle] = ACTIONS(3018),
    [anon_sym_cbuffer] = ACTIONS(3018),
    [anon_sym_interface] = ACTIONS(3018),
    [anon_sym_extension] = ACTIONS(3018),
  },
  [329] = {
    [sym_identifier] = ACTIONS(3022),
    [aux_sym_preproc_include_token1] = ACTIONS(3022),
    [aux_sym_preproc_def_token1] = ACTIONS(3022),
    [aux_sym_preproc_if_token1] = ACTIONS(3022),
    [aux_sym_preproc_if_token2] = ACTIONS(3022),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3022),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3022),
    [aux_sym_preproc_else_token1] = ACTIONS(3022),
    [aux_sym_preproc_elif_token1] = ACTIONS(3022),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3022),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3022),
    [sym_preproc_directive] = ACTIONS(3022),
    [anon_sym_LPAREN2] = ACTIONS(3024),
    [anon_sym_BANG] = ACTIONS(3024),
    [anon_sym_TILDE] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3022),
    [anon_sym_PLUS] = ACTIONS(3022),
    [anon_sym_STAR] = ACTIONS(3024),
    [anon_sym_AMP_AMP] = ACTIONS(3024),
    [anon_sym_AMP] = ACTIONS(3022),
    [anon_sym_SEMI] = ACTIONS(3024),
    [anon_sym___extension__] = ACTIONS(3022),
    [anon_sym_typedef] = ACTIONS(3022),
    [anon_sym_in] = ACTIONS(3022),
    [anon_sym_out] = ACTIONS(3022),
    [anon_sym_inout] = ACTIONS(3022),
    [anon_sym_extern] = ACTIONS(3022),
    [anon_sym___attribute__] = ACTIONS(3022),
    [anon_sym_COLON_COLON] = ACTIONS(3024),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3024),
    [anon_sym___declspec] = ACTIONS(3022),
    [anon_sym___based] = ACTIONS(3022),
    [anon_sym___cdecl] = ACTIONS(3022),
    [anon_sym___clrcall] = ACTIONS(3022),
    [anon_sym___stdcall] = ACTIONS(3022),
    [anon_sym___fastcall] = ACTIONS(3022),
    [anon_sym___thiscall] = ACTIONS(3022),
    [anon_sym___vectorcall] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_signed] = ACTIONS(3022),
    [anon_sym_unsigned] = ACTIONS(3022),
    [anon_sym_long] = ACTIONS(3022),
    [anon_sym_short] = ACTIONS(3022),
    [anon_sym_LBRACK] = ACTIONS(3022),
    [anon_sym_static] = ACTIONS(3022),
    [anon_sym_register] = ACTIONS(3022),
    [anon_sym_inline] = ACTIONS(3022),
    [anon_sym___inline] = ACTIONS(3022),
    [anon_sym___inline__] = ACTIONS(3022),
    [anon_sym___forceinline] = ACTIONS(3022),
    [anon_sym_thread_local] = ACTIONS(3022),
    [anon_sym___thread] = ACTIONS(3022),
    [anon_sym_const] = ACTIONS(3022),
    [anon_sym_constexpr] = ACTIONS(3022),
    [anon_sym_volatile] = ACTIONS(3022),
    [anon_sym_restrict] = ACTIONS(3022),
    [anon_sym___restrict__] = ACTIONS(3022),
    [anon_sym__Atomic] = ACTIONS(3022),
    [anon_sym__Noreturn] = ACTIONS(3022),
    [anon_sym_noreturn] = ACTIONS(3022),
    [anon_sym_mutable] = ACTIONS(3022),
    [anon_sym_constinit] = ACTIONS(3022),
    [anon_sym_consteval] = ACTIONS(3022),
    [anon_sym_alignas] = ACTIONS(3022),
    [anon_sym__Alignas] = ACTIONS(3022),
    [sym_primitive_type] = ACTIONS(3022),
    [anon_sym_enum] = ACTIONS(3022),
    [anon_sym_class] = ACTIONS(3022),
    [anon_sym_struct] = ACTIONS(3022),
    [anon_sym_union] = ACTIONS(3022),
    [anon_sym_if] = ACTIONS(3022),
    [anon_sym_else] = ACTIONS(3022),
    [anon_sym_switch] = ACTIONS(3022),
    [anon_sym_case] = ACTIONS(3022),
    [anon_sym_default] = ACTIONS(3022),
    [anon_sym_while] = ACTIONS(3022),
    [anon_sym_do] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(3022),
    [anon_sym_return] = ACTIONS(3022),
    [anon_sym_break] = ACTIONS(3022),
    [anon_sym_continue] = ACTIONS(3022),
    [anon_sym_goto] = ACTIONS(3022),
    [anon_sym___try] = ACTIONS(3022),
    [anon_sym___leave] = ACTIONS(3022),
    [anon_sym_not] = ACTIONS(3022),
    [anon_sym_compl] = ACTIONS(3022),
    [anon_sym_DASH_DASH] = ACTIONS(3024),
    [anon_sym_PLUS_PLUS] = ACTIONS(3024),
    [anon_sym_sizeof] = ACTIONS(3022),
    [anon_sym___alignof__] = ACTIONS(3022),
    [anon_sym___alignof] = ACTIONS(3022),
    [anon_sym__alignof] = ACTIONS(3022),
    [anon_sym_alignof] = ACTIONS(3022),
    [anon_sym__Alignof] = ACTIONS(3022),
    [anon_sym_offsetof] = ACTIONS(3022),
    [anon_sym__Generic] = ACTIONS(3022),
    [anon_sym_asm] = ACTIONS(3022),
    [anon_sym___asm__] = ACTIONS(3022),
    [sym_number_literal] = ACTIONS(3024),
    [anon_sym_L_SQUOTE] = ACTIONS(3024),
    [anon_sym_u_SQUOTE] = ACTIONS(3024),
    [anon_sym_U_SQUOTE] = ACTIONS(3024),
    [anon_sym_u8_SQUOTE] = ACTIONS(3024),
    [anon_sym_SQUOTE] = ACTIONS(3024),
    [anon_sym_L_DQUOTE] = ACTIONS(3024),
    [anon_sym_u_DQUOTE] = ACTIONS(3024),
    [anon_sym_U_DQUOTE] = ACTIONS(3024),
    [anon_sym_u8_DQUOTE] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3024),
    [sym_true] = ACTIONS(3022),
    [sym_false] = ACTIONS(3022),
    [anon_sym_NULL] = ACTIONS(3022),
    [anon_sym_nullptr] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3022),
    [anon_sym_let] = ACTIONS(3022),
    [anon_sym_This] = ACTIONS(3022),
    [anon_sym_decltype] = ACTIONS(3022),
    [sym_virtual] = ACTIONS(3022),
    [anon_sym_explicit] = ACTIONS(3022),
    [anon_sym_typename] = ACTIONS(3022),
    [anon_sym_template] = ACTIONS(3022),
    [anon_sym_operator] = ACTIONS(3022),
    [anon_sym_try] = ACTIONS(3022),
    [anon_sym_delete] = ACTIONS(3022),
    [anon_sym_throw] = ACTIONS(3022),
    [anon_sym_namespace] = ACTIONS(3022),
    [anon_sym_using] = ACTIONS(3022),
    [anon_sym_static_assert] = ACTIONS(3022),
    [anon_sym_concept] = ACTIONS(3022),
    [anon_sym_co_return] = ACTIONS(3022),
    [anon_sym_co_yield] = ACTIONS(3022),
    [anon_sym_R_DQUOTE] = ACTIONS(3024),
    [anon_sym_LR_DQUOTE] = ACTIONS(3024),
    [anon_sym_uR_DQUOTE] = ACTIONS(3024),
    [anon_sym_UR_DQUOTE] = ACTIONS(3024),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3024),
    [anon_sym_co_await] = ACTIONS(3022),
    [anon_sym_new] = ACTIONS(3022),
    [anon_sym_requires] = ACTIONS(3022),
    [sym_this] = ACTIONS(3022),
    [anon_sym_discard] = ACTIONS(3022),
    [anon_sym_precise] = ACTIONS(3022),
    [anon_sym_shared] = ACTIONS(3022),
    [anon_sym_groupshared] = ACTIONS(3022),
    [anon_sym_uniform] = ACTIONS(3022),
    [anon_sym_row_major] = ACTIONS(3022),
    [anon_sym_column_major] = ACTIONS(3022),
    [anon_sym_globallycoherent] = ACTIONS(3022),
    [anon_sym_centroid] = ACTIONS(3022),
    [anon_sym_noperspective] = ACTIONS(3022),
    [anon_sym_nointerpolation] = ACTIONS(3022),
    [anon_sym_sample] = ACTIONS(3022),
    [anon_sym_linear] = ACTIONS(3022),
    [anon_sym_snorm] = ACTIONS(3022),
    [anon_sym_unorm] = ACTIONS(3022),
    [anon_sym_point] = ACTIONS(3022),
    [anon_sym_line] = ACTIONS(3022),
    [anon_sym_triangleadj] = ACTIONS(3022),
    [anon_sym_lineadj] = ACTIONS(3022),
    [anon_sym_triangle] = ACTIONS(3022),
    [anon_sym_cbuffer] = ACTIONS(3022),
    [anon_sym_interface] = ACTIONS(3022),
    [anon_sym_extension] = ACTIONS(3022),
  },
  [330] = {
    [sym_identifier] = ACTIONS(2363),
    [aux_sym_preproc_include_token1] = ACTIONS(2363),
    [aux_sym_preproc_def_token1] = ACTIONS(2363),
    [aux_sym_preproc_if_token1] = ACTIONS(2363),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2363),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2363),
    [sym_preproc_directive] = ACTIONS(2363),
    [anon_sym_LPAREN2] = ACTIONS(2361),
    [anon_sym_BANG] = ACTIONS(2361),
    [anon_sym_TILDE] = ACTIONS(2361),
    [anon_sym_DASH] = ACTIONS(2363),
    [anon_sym_PLUS] = ACTIONS(2363),
    [anon_sym_STAR] = ACTIONS(2361),
    [anon_sym_AMP_AMP] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(2363),
    [anon_sym_COLON] = ACTIONS(2363),
    [anon_sym_SEMI] = ACTIONS(2361),
    [anon_sym___extension__] = ACTIONS(2363),
    [anon_sym_typedef] = ACTIONS(2363),
    [anon_sym_in] = ACTIONS(2363),
    [anon_sym_out] = ACTIONS(2363),
    [anon_sym_inout] = ACTIONS(2363),
    [anon_sym_extern] = ACTIONS(2363),
    [anon_sym___attribute__] = ACTIONS(2363),
    [anon_sym_COLON_COLON] = ACTIONS(2361),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2361),
    [anon_sym___declspec] = ACTIONS(2363),
    [anon_sym___based] = ACTIONS(2363),
    [anon_sym___cdecl] = ACTIONS(2363),
    [anon_sym___clrcall] = ACTIONS(2363),
    [anon_sym___stdcall] = ACTIONS(2363),
    [anon_sym___fastcall] = ACTIONS(2363),
    [anon_sym___thiscall] = ACTIONS(2363),
    [anon_sym___vectorcall] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_RBRACE] = ACTIONS(2361),
    [anon_sym_signed] = ACTIONS(2363),
    [anon_sym_unsigned] = ACTIONS(2363),
    [anon_sym_long] = ACTIONS(2363),
    [anon_sym_short] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(2363),
    [anon_sym_static] = ACTIONS(2363),
    [anon_sym_register] = ACTIONS(2363),
    [anon_sym_inline] = ACTIONS(2363),
    [anon_sym___inline] = ACTIONS(2363),
    [anon_sym___inline__] = ACTIONS(2363),
    [anon_sym___forceinline] = ACTIONS(2363),
    [anon_sym_thread_local] = ACTIONS(2363),
    [anon_sym___thread] = ACTIONS(2363),
    [anon_sym_const] = ACTIONS(2363),
    [anon_sym_constexpr] = ACTIONS(2363),
    [anon_sym_volatile] = ACTIONS(2363),
    [anon_sym_restrict] = ACTIONS(2363),
    [anon_sym___restrict__] = ACTIONS(2363),
    [anon_sym__Atomic] = ACTIONS(2363),
    [anon_sym__Noreturn] = ACTIONS(2363),
    [anon_sym_noreturn] = ACTIONS(2363),
    [anon_sym_mutable] = ACTIONS(2363),
    [anon_sym_constinit] = ACTIONS(2363),
    [anon_sym_consteval] = ACTIONS(2363),
    [anon_sym_alignas] = ACTIONS(2363),
    [anon_sym__Alignas] = ACTIONS(2363),
    [sym_primitive_type] = ACTIONS(2363),
    [anon_sym_enum] = ACTIONS(2363),
    [anon_sym_class] = ACTIONS(2363),
    [anon_sym_struct] = ACTIONS(2363),
    [anon_sym_union] = ACTIONS(2363),
    [anon_sym_if] = ACTIONS(2363),
    [anon_sym_else] = ACTIONS(2363),
    [anon_sym_switch] = ACTIONS(2363),
    [anon_sym_case] = ACTIONS(2363),
    [anon_sym_default] = ACTIONS(2363),
    [anon_sym_while] = ACTIONS(2363),
    [anon_sym_do] = ACTIONS(2363),
    [anon_sym_for] = ACTIONS(2363),
    [anon_sym_return] = ACTIONS(2363),
    [anon_sym_break] = ACTIONS(2363),
    [anon_sym_continue] = ACTIONS(2363),
    [anon_sym_goto] = ACTIONS(2363),
    [anon_sym___try] = ACTIONS(2363),
    [anon_sym___leave] = ACTIONS(2363),
    [anon_sym_not] = ACTIONS(2363),
    [anon_sym_compl] = ACTIONS(2363),
    [anon_sym_DASH_DASH] = ACTIONS(2361),
    [anon_sym_PLUS_PLUS] = ACTIONS(2361),
    [anon_sym_sizeof] = ACTIONS(2363),
    [anon_sym___alignof__] = ACTIONS(2363),
    [anon_sym___alignof] = ACTIONS(2363),
    [anon_sym__alignof] = ACTIONS(2363),
    [anon_sym_alignof] = ACTIONS(2363),
    [anon_sym__Alignof] = ACTIONS(2363),
    [anon_sym_offsetof] = ACTIONS(2363),
    [anon_sym__Generic] = ACTIONS(2363),
    [anon_sym_asm] = ACTIONS(2363),
    [anon_sym___asm__] = ACTIONS(2363),
    [anon_sym_DOT] = ACTIONS(2363),
    [sym_number_literal] = ACTIONS(2361),
    [anon_sym_L_SQUOTE] = ACTIONS(2361),
    [anon_sym_u_SQUOTE] = ACTIONS(2361),
    [anon_sym_U_SQUOTE] = ACTIONS(2361),
    [anon_sym_u8_SQUOTE] = ACTIONS(2361),
    [anon_sym_SQUOTE] = ACTIONS(2361),
    [anon_sym_L_DQUOTE] = ACTIONS(2361),
    [anon_sym_u_DQUOTE] = ACTIONS(2361),
    [anon_sym_U_DQUOTE] = ACTIONS(2361),
    [anon_sym_u8_DQUOTE] = ACTIONS(2361),
    [anon_sym_DQUOTE] = ACTIONS(2361),
    [sym_true] = ACTIONS(2363),
    [sym_false] = ACTIONS(2363),
    [anon_sym_NULL] = ACTIONS(2363),
    [anon_sym_nullptr] = ACTIONS(2363),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2363),
    [anon_sym_let] = ACTIONS(2363),
    [anon_sym_This] = ACTIONS(2363),
    [anon_sym_decltype] = ACTIONS(2363),
    [anon_sym_final] = ACTIONS(2363),
    [anon_sym_override] = ACTIONS(2363),
    [sym_virtual] = ACTIONS(2363),
    [anon_sym_explicit] = ACTIONS(2363),
    [anon_sym_typename] = ACTIONS(2363),
    [anon_sym_template] = ACTIONS(2363),
    [anon_sym_operator] = ACTIONS(2363),
    [anon_sym_try] = ACTIONS(2363),
    [anon_sym_delete] = ACTIONS(2363),
    [anon_sym_throw] = ACTIONS(2363),
    [anon_sym_namespace] = ACTIONS(2363),
    [anon_sym_using] = ACTIONS(2363),
    [anon_sym_static_assert] = ACTIONS(2363),
    [anon_sym_concept] = ACTIONS(2363),
    [anon_sym_co_return] = ACTIONS(2363),
    [anon_sym_co_yield] = ACTIONS(2363),
    [anon_sym_R_DQUOTE] = ACTIONS(2361),
    [anon_sym_LR_DQUOTE] = ACTIONS(2361),
    [anon_sym_uR_DQUOTE] = ACTIONS(2361),
    [anon_sym_UR_DQUOTE] = ACTIONS(2361),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2361),
    [anon_sym_co_await] = ACTIONS(2363),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_requires] = ACTIONS(2363),
    [sym_this] = ACTIONS(2363),
    [anon_sym_discard] = ACTIONS(2363),
    [anon_sym_precise] = ACTIONS(2363),
    [anon_sym_shared] = ACTIONS(2363),
    [anon_sym_groupshared] = ACTIONS(2363),
    [anon_sym_uniform] = ACTIONS(2363),
    [anon_sym_row_major] = ACTIONS(2363),
    [anon_sym_column_major] = ACTIONS(2363),
    [anon_sym_globallycoherent] = ACTIONS(2363),
    [anon_sym_centroid] = ACTIONS(2363),
    [anon_sym_noperspective] = ACTIONS(2363),
    [anon_sym_nointerpolation] = ACTIONS(2363),
    [anon_sym_sample] = ACTIONS(2363),
    [anon_sym_linear] = ACTIONS(2363),
    [anon_sym_snorm] = ACTIONS(2363),
    [anon_sym_unorm] = ACTIONS(2363),
    [anon_sym_point] = ACTIONS(2363),
    [anon_sym_line] = ACTIONS(2363),
    [anon_sym_triangleadj] = ACTIONS(2363),
    [anon_sym_lineadj] = ACTIONS(2363),
    [anon_sym_triangle] = ACTIONS(2363),
    [anon_sym_cbuffer] = ACTIONS(2363),
    [anon_sym_interface] = ACTIONS(2363),
    [anon_sym_extension] = ACTIONS(2363),
  },
  [331] = {
    [sym_identifier] = ACTIONS(3026),
    [aux_sym_preproc_include_token1] = ACTIONS(3026),
    [aux_sym_preproc_def_token1] = ACTIONS(3026),
    [aux_sym_preproc_if_token1] = ACTIONS(3026),
    [aux_sym_preproc_if_token2] = ACTIONS(3026),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3026),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3026),
    [aux_sym_preproc_else_token1] = ACTIONS(3026),
    [aux_sym_preproc_elif_token1] = ACTIONS(3026),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3026),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3026),
    [sym_preproc_directive] = ACTIONS(3026),
    [anon_sym_LPAREN2] = ACTIONS(3028),
    [anon_sym_BANG] = ACTIONS(3028),
    [anon_sym_TILDE] = ACTIONS(3028),
    [anon_sym_DASH] = ACTIONS(3026),
    [anon_sym_PLUS] = ACTIONS(3026),
    [anon_sym_STAR] = ACTIONS(3028),
    [anon_sym_AMP_AMP] = ACTIONS(3028),
    [anon_sym_AMP] = ACTIONS(3026),
    [anon_sym_SEMI] = ACTIONS(3028),
    [anon_sym___extension__] = ACTIONS(3026),
    [anon_sym_typedef] = ACTIONS(3026),
    [anon_sym_in] = ACTIONS(3026),
    [anon_sym_out] = ACTIONS(3026),
    [anon_sym_inout] = ACTIONS(3026),
    [anon_sym_extern] = ACTIONS(3026),
    [anon_sym___attribute__] = ACTIONS(3026),
    [anon_sym_COLON_COLON] = ACTIONS(3028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3028),
    [anon_sym___declspec] = ACTIONS(3026),
    [anon_sym___based] = ACTIONS(3026),
    [anon_sym___cdecl] = ACTIONS(3026),
    [anon_sym___clrcall] = ACTIONS(3026),
    [anon_sym___stdcall] = ACTIONS(3026),
    [anon_sym___fastcall] = ACTIONS(3026),
    [anon_sym___thiscall] = ACTIONS(3026),
    [anon_sym___vectorcall] = ACTIONS(3026),
    [anon_sym_LBRACE] = ACTIONS(3028),
    [anon_sym_signed] = ACTIONS(3026),
    [anon_sym_unsigned] = ACTIONS(3026),
    [anon_sym_long] = ACTIONS(3026),
    [anon_sym_short] = ACTIONS(3026),
    [anon_sym_LBRACK] = ACTIONS(3026),
    [anon_sym_static] = ACTIONS(3026),
    [anon_sym_register] = ACTIONS(3026),
    [anon_sym_inline] = ACTIONS(3026),
    [anon_sym___inline] = ACTIONS(3026),
    [anon_sym___inline__] = ACTIONS(3026),
    [anon_sym___forceinline] = ACTIONS(3026),
    [anon_sym_thread_local] = ACTIONS(3026),
    [anon_sym___thread] = ACTIONS(3026),
    [anon_sym_const] = ACTIONS(3026),
    [anon_sym_constexpr] = ACTIONS(3026),
    [anon_sym_volatile] = ACTIONS(3026),
    [anon_sym_restrict] = ACTIONS(3026),
    [anon_sym___restrict__] = ACTIONS(3026),
    [anon_sym__Atomic] = ACTIONS(3026),
    [anon_sym__Noreturn] = ACTIONS(3026),
    [anon_sym_noreturn] = ACTIONS(3026),
    [anon_sym_mutable] = ACTIONS(3026),
    [anon_sym_constinit] = ACTIONS(3026),
    [anon_sym_consteval] = ACTIONS(3026),
    [anon_sym_alignas] = ACTIONS(3026),
    [anon_sym__Alignas] = ACTIONS(3026),
    [sym_primitive_type] = ACTIONS(3026),
    [anon_sym_enum] = ACTIONS(3026),
    [anon_sym_class] = ACTIONS(3026),
    [anon_sym_struct] = ACTIONS(3026),
    [anon_sym_union] = ACTIONS(3026),
    [anon_sym_if] = ACTIONS(3026),
    [anon_sym_else] = ACTIONS(3026),
    [anon_sym_switch] = ACTIONS(3026),
    [anon_sym_case] = ACTIONS(3026),
    [anon_sym_default] = ACTIONS(3026),
    [anon_sym_while] = ACTIONS(3026),
    [anon_sym_do] = ACTIONS(3026),
    [anon_sym_for] = ACTIONS(3026),
    [anon_sym_return] = ACTIONS(3026),
    [anon_sym_break] = ACTIONS(3026),
    [anon_sym_continue] = ACTIONS(3026),
    [anon_sym_goto] = ACTIONS(3026),
    [anon_sym___try] = ACTIONS(3026),
    [anon_sym___leave] = ACTIONS(3026),
    [anon_sym_not] = ACTIONS(3026),
    [anon_sym_compl] = ACTIONS(3026),
    [anon_sym_DASH_DASH] = ACTIONS(3028),
    [anon_sym_PLUS_PLUS] = ACTIONS(3028),
    [anon_sym_sizeof] = ACTIONS(3026),
    [anon_sym___alignof__] = ACTIONS(3026),
    [anon_sym___alignof] = ACTIONS(3026),
    [anon_sym__alignof] = ACTIONS(3026),
    [anon_sym_alignof] = ACTIONS(3026),
    [anon_sym__Alignof] = ACTIONS(3026),
    [anon_sym_offsetof] = ACTIONS(3026),
    [anon_sym__Generic] = ACTIONS(3026),
    [anon_sym_asm] = ACTIONS(3026),
    [anon_sym___asm__] = ACTIONS(3026),
    [sym_number_literal] = ACTIONS(3028),
    [anon_sym_L_SQUOTE] = ACTIONS(3028),
    [anon_sym_u_SQUOTE] = ACTIONS(3028),
    [anon_sym_U_SQUOTE] = ACTIONS(3028),
    [anon_sym_u8_SQUOTE] = ACTIONS(3028),
    [anon_sym_SQUOTE] = ACTIONS(3028),
    [anon_sym_L_DQUOTE] = ACTIONS(3028),
    [anon_sym_u_DQUOTE] = ACTIONS(3028),
    [anon_sym_U_DQUOTE] = ACTIONS(3028),
    [anon_sym_u8_DQUOTE] = ACTIONS(3028),
    [anon_sym_DQUOTE] = ACTIONS(3028),
    [sym_true] = ACTIONS(3026),
    [sym_false] = ACTIONS(3026),
    [anon_sym_NULL] = ACTIONS(3026),
    [anon_sym_nullptr] = ACTIONS(3026),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3026),
    [anon_sym_let] = ACTIONS(3026),
    [anon_sym_This] = ACTIONS(3026),
    [anon_sym_decltype] = ACTIONS(3026),
    [sym_virtual] = ACTIONS(3026),
    [anon_sym_explicit] = ACTIONS(3026),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(3026),
    [anon_sym_operator] = ACTIONS(3026),
    [anon_sym_try] = ACTIONS(3026),
    [anon_sym_delete] = ACTIONS(3026),
    [anon_sym_throw] = ACTIONS(3026),
    [anon_sym_namespace] = ACTIONS(3026),
    [anon_sym_using] = ACTIONS(3026),
    [anon_sym_static_assert] = ACTIONS(3026),
    [anon_sym_concept] = ACTIONS(3026),
    [anon_sym_co_return] = ACTIONS(3026),
    [anon_sym_co_yield] = ACTIONS(3026),
    [anon_sym_R_DQUOTE] = ACTIONS(3028),
    [anon_sym_LR_DQUOTE] = ACTIONS(3028),
    [anon_sym_uR_DQUOTE] = ACTIONS(3028),
    [anon_sym_UR_DQUOTE] = ACTIONS(3028),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3028),
    [anon_sym_co_await] = ACTIONS(3026),
    [anon_sym_new] = ACTIONS(3026),
    [anon_sym_requires] = ACTIONS(3026),
    [sym_this] = ACTIONS(3026),
    [anon_sym_discard] = ACTIONS(3026),
    [anon_sym_precise] = ACTIONS(3026),
    [anon_sym_shared] = ACTIONS(3026),
    [anon_sym_groupshared] = ACTIONS(3026),
    [anon_sym_uniform] = ACTIONS(3026),
    [anon_sym_row_major] = ACTIONS(3026),
    [anon_sym_column_major] = ACTIONS(3026),
    [anon_sym_globallycoherent] = ACTIONS(3026),
    [anon_sym_centroid] = ACTIONS(3026),
    [anon_sym_noperspective] = ACTIONS(3026),
    [anon_sym_nointerpolation] = ACTIONS(3026),
    [anon_sym_sample] = ACTIONS(3026),
    [anon_sym_linear] = ACTIONS(3026),
    [anon_sym_snorm] = ACTIONS(3026),
    [anon_sym_unorm] = ACTIONS(3026),
    [anon_sym_point] = ACTIONS(3026),
    [anon_sym_line] = ACTIONS(3026),
    [anon_sym_triangleadj] = ACTIONS(3026),
    [anon_sym_lineadj] = ACTIONS(3026),
    [anon_sym_triangle] = ACTIONS(3026),
    [anon_sym_cbuffer] = ACTIONS(3026),
    [anon_sym_interface] = ACTIONS(3026),
    [anon_sym_extension] = ACTIONS(3026),
  },
  [332] = {
    [sym_identifier] = ACTIONS(3030),
    [aux_sym_preproc_include_token1] = ACTIONS(3030),
    [aux_sym_preproc_def_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token2] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3030),
    [aux_sym_preproc_else_token1] = ACTIONS(3030),
    [aux_sym_preproc_elif_token1] = ACTIONS(3030),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3030),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3030),
    [sym_preproc_directive] = ACTIONS(3030),
    [anon_sym_LPAREN2] = ACTIONS(3032),
    [anon_sym_BANG] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3030),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym___extension__] = ACTIONS(3030),
    [anon_sym_typedef] = ACTIONS(3030),
    [anon_sym_in] = ACTIONS(3030),
    [anon_sym_out] = ACTIONS(3030),
    [anon_sym_inout] = ACTIONS(3030),
    [anon_sym_extern] = ACTIONS(3030),
    [anon_sym___attribute__] = ACTIONS(3030),
    [anon_sym_COLON_COLON] = ACTIONS(3032),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3032),
    [anon_sym___declspec] = ACTIONS(3030),
    [anon_sym___based] = ACTIONS(3030),
    [anon_sym___cdecl] = ACTIONS(3030),
    [anon_sym___clrcall] = ACTIONS(3030),
    [anon_sym___stdcall] = ACTIONS(3030),
    [anon_sym___fastcall] = ACTIONS(3030),
    [anon_sym___thiscall] = ACTIONS(3030),
    [anon_sym___vectorcall] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_signed] = ACTIONS(3030),
    [anon_sym_unsigned] = ACTIONS(3030),
    [anon_sym_long] = ACTIONS(3030),
    [anon_sym_short] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_static] = ACTIONS(3030),
    [anon_sym_register] = ACTIONS(3030),
    [anon_sym_inline] = ACTIONS(3030),
    [anon_sym___inline] = ACTIONS(3030),
    [anon_sym___inline__] = ACTIONS(3030),
    [anon_sym___forceinline] = ACTIONS(3030),
    [anon_sym_thread_local] = ACTIONS(3030),
    [anon_sym___thread] = ACTIONS(3030),
    [anon_sym_const] = ACTIONS(3030),
    [anon_sym_constexpr] = ACTIONS(3030),
    [anon_sym_volatile] = ACTIONS(3030),
    [anon_sym_restrict] = ACTIONS(3030),
    [anon_sym___restrict__] = ACTIONS(3030),
    [anon_sym__Atomic] = ACTIONS(3030),
    [anon_sym__Noreturn] = ACTIONS(3030),
    [anon_sym_noreturn] = ACTIONS(3030),
    [anon_sym_mutable] = ACTIONS(3030),
    [anon_sym_constinit] = ACTIONS(3030),
    [anon_sym_consteval] = ACTIONS(3030),
    [anon_sym_alignas] = ACTIONS(3030),
    [anon_sym__Alignas] = ACTIONS(3030),
    [sym_primitive_type] = ACTIONS(3030),
    [anon_sym_enum] = ACTIONS(3030),
    [anon_sym_class] = ACTIONS(3030),
    [anon_sym_struct] = ACTIONS(3030),
    [anon_sym_union] = ACTIONS(3030),
    [anon_sym_if] = ACTIONS(3030),
    [anon_sym_else] = ACTIONS(3030),
    [anon_sym_switch] = ACTIONS(3030),
    [anon_sym_case] = ACTIONS(3030),
    [anon_sym_default] = ACTIONS(3030),
    [anon_sym_while] = ACTIONS(3030),
    [anon_sym_do] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3030),
    [anon_sym_return] = ACTIONS(3030),
    [anon_sym_break] = ACTIONS(3030),
    [anon_sym_continue] = ACTIONS(3030),
    [anon_sym_goto] = ACTIONS(3030),
    [anon_sym___try] = ACTIONS(3030),
    [anon_sym___leave] = ACTIONS(3030),
    [anon_sym_not] = ACTIONS(3030),
    [anon_sym_compl] = ACTIONS(3030),
    [anon_sym_DASH_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_PLUS] = ACTIONS(3032),
    [anon_sym_sizeof] = ACTIONS(3030),
    [anon_sym___alignof__] = ACTIONS(3030),
    [anon_sym___alignof] = ACTIONS(3030),
    [anon_sym__alignof] = ACTIONS(3030),
    [anon_sym_alignof] = ACTIONS(3030),
    [anon_sym__Alignof] = ACTIONS(3030),
    [anon_sym_offsetof] = ACTIONS(3030),
    [anon_sym__Generic] = ACTIONS(3030),
    [anon_sym_asm] = ACTIONS(3030),
    [anon_sym___asm__] = ACTIONS(3030),
    [sym_number_literal] = ACTIONS(3032),
    [anon_sym_L_SQUOTE] = ACTIONS(3032),
    [anon_sym_u_SQUOTE] = ACTIONS(3032),
    [anon_sym_U_SQUOTE] = ACTIONS(3032),
    [anon_sym_u8_SQUOTE] = ACTIONS(3032),
    [anon_sym_SQUOTE] = ACTIONS(3032),
    [anon_sym_L_DQUOTE] = ACTIONS(3032),
    [anon_sym_u_DQUOTE] = ACTIONS(3032),
    [anon_sym_U_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [sym_true] = ACTIONS(3030),
    [sym_false] = ACTIONS(3030),
    [anon_sym_NULL] = ACTIONS(3030),
    [anon_sym_nullptr] = ACTIONS(3030),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3030),
    [anon_sym_let] = ACTIONS(3030),
    [anon_sym_This] = ACTIONS(3030),
    [anon_sym_decltype] = ACTIONS(3030),
    [sym_virtual] = ACTIONS(3030),
    [anon_sym_explicit] = ACTIONS(3030),
    [anon_sym_typename] = ACTIONS(3030),
    [anon_sym_template] = ACTIONS(3030),
    [anon_sym_operator] = ACTIONS(3030),
    [anon_sym_try] = ACTIONS(3030),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_throw] = ACTIONS(3030),
    [anon_sym_namespace] = ACTIONS(3030),
    [anon_sym_using] = ACTIONS(3030),
    [anon_sym_static_assert] = ACTIONS(3030),
    [anon_sym_concept] = ACTIONS(3030),
    [anon_sym_co_return] = ACTIONS(3030),
    [anon_sym_co_yield] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3030),
    [anon_sym_requires] = ACTIONS(3030),
    [sym_this] = ACTIONS(3030),
    [anon_sym_discard] = ACTIONS(3030),
    [anon_sym_precise] = ACTIONS(3030),
    [anon_sym_shared] = ACTIONS(3030),
    [anon_sym_groupshared] = ACTIONS(3030),
    [anon_sym_uniform] = ACTIONS(3030),
    [anon_sym_row_major] = ACTIONS(3030),
    [anon_sym_column_major] = ACTIONS(3030),
    [anon_sym_globallycoherent] = ACTIONS(3030),
    [anon_sym_centroid] = ACTIONS(3030),
    [anon_sym_noperspective] = ACTIONS(3030),
    [anon_sym_nointerpolation] = ACTIONS(3030),
    [anon_sym_sample] = ACTIONS(3030),
    [anon_sym_linear] = ACTIONS(3030),
    [anon_sym_snorm] = ACTIONS(3030),
    [anon_sym_unorm] = ACTIONS(3030),
    [anon_sym_point] = ACTIONS(3030),
    [anon_sym_line] = ACTIONS(3030),
    [anon_sym_triangleadj] = ACTIONS(3030),
    [anon_sym_lineadj] = ACTIONS(3030),
    [anon_sym_triangle] = ACTIONS(3030),
    [anon_sym_cbuffer] = ACTIONS(3030),
    [anon_sym_interface] = ACTIONS(3030),
    [anon_sym_extension] = ACTIONS(3030),
  },
  [333] = {
    [sym_identifier] = ACTIONS(3034),
    [aux_sym_preproc_include_token1] = ACTIONS(3034),
    [aux_sym_preproc_def_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token2] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3034),
    [aux_sym_preproc_else_token1] = ACTIONS(3034),
    [aux_sym_preproc_elif_token1] = ACTIONS(3034),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_BANG] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3034),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_in] = ACTIONS(3034),
    [anon_sym_out] = ACTIONS(3034),
    [anon_sym_inout] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym___based] = ACTIONS(3034),
    [anon_sym___cdecl] = ACTIONS(3034),
    [anon_sym___clrcall] = ACTIONS(3034),
    [anon_sym___stdcall] = ACTIONS(3034),
    [anon_sym___fastcall] = ACTIONS(3034),
    [anon_sym___thiscall] = ACTIONS(3034),
    [anon_sym___vectorcall] = ACTIONS(3034),
    [anon_sym_LBRACE] = ACTIONS(3036),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [anon_sym_if] = ACTIONS(3034),
    [anon_sym_else] = ACTIONS(3034),
    [anon_sym_switch] = ACTIONS(3034),
    [anon_sym_case] = ACTIONS(3034),
    [anon_sym_default] = ACTIONS(3034),
    [anon_sym_while] = ACTIONS(3034),
    [anon_sym_do] = ACTIONS(3034),
    [anon_sym_for] = ACTIONS(3034),
    [anon_sym_return] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3034),
    [anon_sym_continue] = ACTIONS(3034),
    [anon_sym_goto] = ACTIONS(3034),
    [anon_sym___try] = ACTIONS(3034),
    [anon_sym___leave] = ACTIONS(3034),
    [anon_sym_not] = ACTIONS(3034),
    [anon_sym_compl] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_sizeof] = ACTIONS(3034),
    [anon_sym___alignof__] = ACTIONS(3034),
    [anon_sym___alignof] = ACTIONS(3034),
    [anon_sym__alignof] = ACTIONS(3034),
    [anon_sym_alignof] = ACTIONS(3034),
    [anon_sym__Alignof] = ACTIONS(3034),
    [anon_sym_offsetof] = ACTIONS(3034),
    [anon_sym__Generic] = ACTIONS(3034),
    [anon_sym_asm] = ACTIONS(3034),
    [anon_sym___asm__] = ACTIONS(3034),
    [sym_number_literal] = ACTIONS(3036),
    [anon_sym_L_SQUOTE] = ACTIONS(3036),
    [anon_sym_u_SQUOTE] = ACTIONS(3036),
    [anon_sym_U_SQUOTE] = ACTIONS(3036),
    [anon_sym_u8_SQUOTE] = ACTIONS(3036),
    [anon_sym_SQUOTE] = ACTIONS(3036),
    [anon_sym_L_DQUOTE] = ACTIONS(3036),
    [anon_sym_u_DQUOTE] = ACTIONS(3036),
    [anon_sym_U_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8_DQUOTE] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [sym_true] = ACTIONS(3034),
    [sym_false] = ACTIONS(3034),
    [anon_sym_NULL] = ACTIONS(3034),
    [anon_sym_nullptr] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_This] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [sym_virtual] = ACTIONS(3034),
    [anon_sym_explicit] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_operator] = ACTIONS(3034),
    [anon_sym_try] = ACTIONS(3034),
    [anon_sym_delete] = ACTIONS(3034),
    [anon_sym_throw] = ACTIONS(3034),
    [anon_sym_namespace] = ACTIONS(3034),
    [anon_sym_using] = ACTIONS(3034),
    [anon_sym_static_assert] = ACTIONS(3034),
    [anon_sym_concept] = ACTIONS(3034),
    [anon_sym_co_return] = ACTIONS(3034),
    [anon_sym_co_yield] = ACTIONS(3034),
    [anon_sym_R_DQUOTE] = ACTIONS(3036),
    [anon_sym_LR_DQUOTE] = ACTIONS(3036),
    [anon_sym_uR_DQUOTE] = ACTIONS(3036),
    [anon_sym_UR_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3036),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3034),
    [anon_sym_requires] = ACTIONS(3034),
    [sym_this] = ACTIONS(3034),
    [anon_sym_discard] = ACTIONS(3034),
    [anon_sym_precise] = ACTIONS(3034),
    [anon_sym_shared] = ACTIONS(3034),
    [anon_sym_groupshared] = ACTIONS(3034),
    [anon_sym_uniform] = ACTIONS(3034),
    [anon_sym_row_major] = ACTIONS(3034),
    [anon_sym_column_major] = ACTIONS(3034),
    [anon_sym_globallycoherent] = ACTIONS(3034),
    [anon_sym_centroid] = ACTIONS(3034),
    [anon_sym_noperspective] = ACTIONS(3034),
    [anon_sym_nointerpolation] = ACTIONS(3034),
    [anon_sym_sample] = ACTIONS(3034),
    [anon_sym_linear] = ACTIONS(3034),
    [anon_sym_snorm] = ACTIONS(3034),
    [anon_sym_unorm] = ACTIONS(3034),
    [anon_sym_point] = ACTIONS(3034),
    [anon_sym_line] = ACTIONS(3034),
    [anon_sym_triangleadj] = ACTIONS(3034),
    [anon_sym_lineadj] = ACTIONS(3034),
    [anon_sym_triangle] = ACTIONS(3034),
    [anon_sym_cbuffer] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3034),
    [anon_sym_extension] = ACTIONS(3034),
  },
  [334] = {
    [sym_identifier] = ACTIONS(3038),
    [aux_sym_preproc_include_token1] = ACTIONS(3038),
    [aux_sym_preproc_def_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token2] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3038),
    [aux_sym_preproc_else_token1] = ACTIONS(3038),
    [aux_sym_preproc_elif_token1] = ACTIONS(3038),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3038),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3038),
    [sym_preproc_directive] = ACTIONS(3038),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3038),
    [anon_sym_PLUS] = ACTIONS(3038),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3038),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3038),
    [anon_sym_typedef] = ACTIONS(3038),
    [anon_sym_in] = ACTIONS(3038),
    [anon_sym_out] = ACTIONS(3038),
    [anon_sym_inout] = ACTIONS(3038),
    [anon_sym_extern] = ACTIONS(3038),
    [anon_sym___attribute__] = ACTIONS(3038),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3040),
    [anon_sym___declspec] = ACTIONS(3038),
    [anon_sym___based] = ACTIONS(3038),
    [anon_sym___cdecl] = ACTIONS(3038),
    [anon_sym___clrcall] = ACTIONS(3038),
    [anon_sym___stdcall] = ACTIONS(3038),
    [anon_sym___fastcall] = ACTIONS(3038),
    [anon_sym___thiscall] = ACTIONS(3038),
    [anon_sym___vectorcall] = ACTIONS(3038),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_signed] = ACTIONS(3038),
    [anon_sym_unsigned] = ACTIONS(3038),
    [anon_sym_long] = ACTIONS(3038),
    [anon_sym_short] = ACTIONS(3038),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_static] = ACTIONS(3038),
    [anon_sym_register] = ACTIONS(3038),
    [anon_sym_inline] = ACTIONS(3038),
    [anon_sym___inline] = ACTIONS(3038),
    [anon_sym___inline__] = ACTIONS(3038),
    [anon_sym___forceinline] = ACTIONS(3038),
    [anon_sym_thread_local] = ACTIONS(3038),
    [anon_sym___thread] = ACTIONS(3038),
    [anon_sym_const] = ACTIONS(3038),
    [anon_sym_constexpr] = ACTIONS(3038),
    [anon_sym_volatile] = ACTIONS(3038),
    [anon_sym_restrict] = ACTIONS(3038),
    [anon_sym___restrict__] = ACTIONS(3038),
    [anon_sym__Atomic] = ACTIONS(3038),
    [anon_sym__Noreturn] = ACTIONS(3038),
    [anon_sym_noreturn] = ACTIONS(3038),
    [anon_sym_mutable] = ACTIONS(3038),
    [anon_sym_constinit] = ACTIONS(3038),
    [anon_sym_consteval] = ACTIONS(3038),
    [anon_sym_alignas] = ACTIONS(3038),
    [anon_sym__Alignas] = ACTIONS(3038),
    [sym_primitive_type] = ACTIONS(3038),
    [anon_sym_enum] = ACTIONS(3038),
    [anon_sym_class] = ACTIONS(3038),
    [anon_sym_struct] = ACTIONS(3038),
    [anon_sym_union] = ACTIONS(3038),
    [anon_sym_if] = ACTIONS(3038),
    [anon_sym_else] = ACTIONS(3038),
    [anon_sym_switch] = ACTIONS(3038),
    [anon_sym_case] = ACTIONS(3038),
    [anon_sym_default] = ACTIONS(3038),
    [anon_sym_while] = ACTIONS(3038),
    [anon_sym_do] = ACTIONS(3038),
    [anon_sym_for] = ACTIONS(3038),
    [anon_sym_return] = ACTIONS(3038),
    [anon_sym_break] = ACTIONS(3038),
    [anon_sym_continue] = ACTIONS(3038),
    [anon_sym_goto] = ACTIONS(3038),
    [anon_sym___try] = ACTIONS(3038),
    [anon_sym___leave] = ACTIONS(3038),
    [anon_sym_not] = ACTIONS(3038),
    [anon_sym_compl] = ACTIONS(3038),
    [anon_sym_DASH_DASH] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3040),
    [anon_sym_sizeof] = ACTIONS(3038),
    [anon_sym___alignof__] = ACTIONS(3038),
    [anon_sym___alignof] = ACTIONS(3038),
    [anon_sym__alignof] = ACTIONS(3038),
    [anon_sym_alignof] = ACTIONS(3038),
    [anon_sym__Alignof] = ACTIONS(3038),
    [anon_sym_offsetof] = ACTIONS(3038),
    [anon_sym__Generic] = ACTIONS(3038),
    [anon_sym_asm] = ACTIONS(3038),
    [anon_sym___asm__] = ACTIONS(3038),
    [sym_number_literal] = ACTIONS(3040),
    [anon_sym_L_SQUOTE] = ACTIONS(3040),
    [anon_sym_u_SQUOTE] = ACTIONS(3040),
    [anon_sym_U_SQUOTE] = ACTIONS(3040),
    [anon_sym_u8_SQUOTE] = ACTIONS(3040),
    [anon_sym_SQUOTE] = ACTIONS(3040),
    [anon_sym_L_DQUOTE] = ACTIONS(3040),
    [anon_sym_u_DQUOTE] = ACTIONS(3040),
    [anon_sym_U_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8_DQUOTE] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [sym_true] = ACTIONS(3038),
    [sym_false] = ACTIONS(3038),
    [anon_sym_NULL] = ACTIONS(3038),
    [anon_sym_nullptr] = ACTIONS(3038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3038),
    [anon_sym_let] = ACTIONS(3038),
    [anon_sym_This] = ACTIONS(3038),
    [anon_sym_decltype] = ACTIONS(3038),
    [sym_virtual] = ACTIONS(3038),
    [anon_sym_explicit] = ACTIONS(3038),
    [anon_sym_typename] = ACTIONS(3038),
    [anon_sym_template] = ACTIONS(3038),
    [anon_sym_operator] = ACTIONS(3038),
    [anon_sym_try] = ACTIONS(3038),
    [anon_sym_delete] = ACTIONS(3038),
    [anon_sym_throw] = ACTIONS(3038),
    [anon_sym_namespace] = ACTIONS(3038),
    [anon_sym_using] = ACTIONS(3038),
    [anon_sym_static_assert] = ACTIONS(3038),
    [anon_sym_concept] = ACTIONS(3038),
    [anon_sym_co_return] = ACTIONS(3038),
    [anon_sym_co_yield] = ACTIONS(3038),
    [anon_sym_R_DQUOTE] = ACTIONS(3040),
    [anon_sym_LR_DQUOTE] = ACTIONS(3040),
    [anon_sym_uR_DQUOTE] = ACTIONS(3040),
    [anon_sym_UR_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3040),
    [anon_sym_co_await] = ACTIONS(3038),
    [anon_sym_new] = ACTIONS(3038),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3038),
    [anon_sym_discard] = ACTIONS(3038),
    [anon_sym_precise] = ACTIONS(3038),
    [anon_sym_shared] = ACTIONS(3038),
    [anon_sym_groupshared] = ACTIONS(3038),
    [anon_sym_uniform] = ACTIONS(3038),
    [anon_sym_row_major] = ACTIONS(3038),
    [anon_sym_column_major] = ACTIONS(3038),
    [anon_sym_globallycoherent] = ACTIONS(3038),
    [anon_sym_centroid] = ACTIONS(3038),
    [anon_sym_noperspective] = ACTIONS(3038),
    [anon_sym_nointerpolation] = ACTIONS(3038),
    [anon_sym_sample] = ACTIONS(3038),
    [anon_sym_linear] = ACTIONS(3038),
    [anon_sym_snorm] = ACTIONS(3038),
    [anon_sym_unorm] = ACTIONS(3038),
    [anon_sym_point] = ACTIONS(3038),
    [anon_sym_line] = ACTIONS(3038),
    [anon_sym_triangleadj] = ACTIONS(3038),
    [anon_sym_lineadj] = ACTIONS(3038),
    [anon_sym_triangle] = ACTIONS(3038),
    [anon_sym_cbuffer] = ACTIONS(3038),
    [anon_sym_interface] = ACTIONS(3038),
    [anon_sym_extension] = ACTIONS(3038),
  },
  [335] = {
    [sym_identifier] = ACTIONS(3038),
    [aux_sym_preproc_include_token1] = ACTIONS(3038),
    [aux_sym_preproc_def_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token2] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3038),
    [aux_sym_preproc_else_token1] = ACTIONS(3038),
    [aux_sym_preproc_elif_token1] = ACTIONS(3038),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3038),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3038),
    [sym_preproc_directive] = ACTIONS(3038),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3038),
    [anon_sym_PLUS] = ACTIONS(3038),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3038),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3038),
    [anon_sym_typedef] = ACTIONS(3038),
    [anon_sym_in] = ACTIONS(3038),
    [anon_sym_out] = ACTIONS(3038),
    [anon_sym_inout] = ACTIONS(3038),
    [anon_sym_extern] = ACTIONS(3038),
    [anon_sym___attribute__] = ACTIONS(3038),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3040),
    [anon_sym___declspec] = ACTIONS(3038),
    [anon_sym___based] = ACTIONS(3038),
    [anon_sym___cdecl] = ACTIONS(3038),
    [anon_sym___clrcall] = ACTIONS(3038),
    [anon_sym___stdcall] = ACTIONS(3038),
    [anon_sym___fastcall] = ACTIONS(3038),
    [anon_sym___thiscall] = ACTIONS(3038),
    [anon_sym___vectorcall] = ACTIONS(3038),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_signed] = ACTIONS(3038),
    [anon_sym_unsigned] = ACTIONS(3038),
    [anon_sym_long] = ACTIONS(3038),
    [anon_sym_short] = ACTIONS(3038),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_static] = ACTIONS(3038),
    [anon_sym_register] = ACTIONS(3038),
    [anon_sym_inline] = ACTIONS(3038),
    [anon_sym___inline] = ACTIONS(3038),
    [anon_sym___inline__] = ACTIONS(3038),
    [anon_sym___forceinline] = ACTIONS(3038),
    [anon_sym_thread_local] = ACTIONS(3038),
    [anon_sym___thread] = ACTIONS(3038),
    [anon_sym_const] = ACTIONS(3038),
    [anon_sym_constexpr] = ACTIONS(3038),
    [anon_sym_volatile] = ACTIONS(3038),
    [anon_sym_restrict] = ACTIONS(3038),
    [anon_sym___restrict__] = ACTIONS(3038),
    [anon_sym__Atomic] = ACTIONS(3038),
    [anon_sym__Noreturn] = ACTIONS(3038),
    [anon_sym_noreturn] = ACTIONS(3038),
    [anon_sym_mutable] = ACTIONS(3038),
    [anon_sym_constinit] = ACTIONS(3038),
    [anon_sym_consteval] = ACTIONS(3038),
    [anon_sym_alignas] = ACTIONS(3038),
    [anon_sym__Alignas] = ACTIONS(3038),
    [sym_primitive_type] = ACTIONS(3038),
    [anon_sym_enum] = ACTIONS(3038),
    [anon_sym_class] = ACTIONS(3038),
    [anon_sym_struct] = ACTIONS(3038),
    [anon_sym_union] = ACTIONS(3038),
    [anon_sym_if] = ACTIONS(3038),
    [anon_sym_else] = ACTIONS(3038),
    [anon_sym_switch] = ACTIONS(3038),
    [anon_sym_case] = ACTIONS(3038),
    [anon_sym_default] = ACTIONS(3038),
    [anon_sym_while] = ACTIONS(3038),
    [anon_sym_do] = ACTIONS(3038),
    [anon_sym_for] = ACTIONS(3038),
    [anon_sym_return] = ACTIONS(3038),
    [anon_sym_break] = ACTIONS(3038),
    [anon_sym_continue] = ACTIONS(3038),
    [anon_sym_goto] = ACTIONS(3038),
    [anon_sym___try] = ACTIONS(3038),
    [anon_sym___leave] = ACTIONS(3038),
    [anon_sym_not] = ACTIONS(3038),
    [anon_sym_compl] = ACTIONS(3038),
    [anon_sym_DASH_DASH] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3040),
    [anon_sym_sizeof] = ACTIONS(3038),
    [anon_sym___alignof__] = ACTIONS(3038),
    [anon_sym___alignof] = ACTIONS(3038),
    [anon_sym__alignof] = ACTIONS(3038),
    [anon_sym_alignof] = ACTIONS(3038),
    [anon_sym__Alignof] = ACTIONS(3038),
    [anon_sym_offsetof] = ACTIONS(3038),
    [anon_sym__Generic] = ACTIONS(3038),
    [anon_sym_asm] = ACTIONS(3038),
    [anon_sym___asm__] = ACTIONS(3038),
    [sym_number_literal] = ACTIONS(3040),
    [anon_sym_L_SQUOTE] = ACTIONS(3040),
    [anon_sym_u_SQUOTE] = ACTIONS(3040),
    [anon_sym_U_SQUOTE] = ACTIONS(3040),
    [anon_sym_u8_SQUOTE] = ACTIONS(3040),
    [anon_sym_SQUOTE] = ACTIONS(3040),
    [anon_sym_L_DQUOTE] = ACTIONS(3040),
    [anon_sym_u_DQUOTE] = ACTIONS(3040),
    [anon_sym_U_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8_DQUOTE] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [sym_true] = ACTIONS(3038),
    [sym_false] = ACTIONS(3038),
    [anon_sym_NULL] = ACTIONS(3038),
    [anon_sym_nullptr] = ACTIONS(3038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3038),
    [anon_sym_let] = ACTIONS(3038),
    [anon_sym_This] = ACTIONS(3038),
    [anon_sym_decltype] = ACTIONS(3038),
    [sym_virtual] = ACTIONS(3038),
    [anon_sym_explicit] = ACTIONS(3038),
    [anon_sym_typename] = ACTIONS(3038),
    [anon_sym_template] = ACTIONS(3038),
    [anon_sym_operator] = ACTIONS(3038),
    [anon_sym_try] = ACTIONS(3038),
    [anon_sym_delete] = ACTIONS(3038),
    [anon_sym_throw] = ACTIONS(3038),
    [anon_sym_namespace] = ACTIONS(3038),
    [anon_sym_using] = ACTIONS(3038),
    [anon_sym_static_assert] = ACTIONS(3038),
    [anon_sym_concept] = ACTIONS(3038),
    [anon_sym_co_return] = ACTIONS(3038),
    [anon_sym_co_yield] = ACTIONS(3038),
    [anon_sym_R_DQUOTE] = ACTIONS(3040),
    [anon_sym_LR_DQUOTE] = ACTIONS(3040),
    [anon_sym_uR_DQUOTE] = ACTIONS(3040),
    [anon_sym_UR_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3040),
    [anon_sym_co_await] = ACTIONS(3038),
    [anon_sym_new] = ACTIONS(3038),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3038),
    [anon_sym_discard] = ACTIONS(3038),
    [anon_sym_precise] = ACTIONS(3038),
    [anon_sym_shared] = ACTIONS(3038),
    [anon_sym_groupshared] = ACTIONS(3038),
    [anon_sym_uniform] = ACTIONS(3038),
    [anon_sym_row_major] = ACTIONS(3038),
    [anon_sym_column_major] = ACTIONS(3038),
    [anon_sym_globallycoherent] = ACTIONS(3038),
    [anon_sym_centroid] = ACTIONS(3038),
    [anon_sym_noperspective] = ACTIONS(3038),
    [anon_sym_nointerpolation] = ACTIONS(3038),
    [anon_sym_sample] = ACTIONS(3038),
    [anon_sym_linear] = ACTIONS(3038),
    [anon_sym_snorm] = ACTIONS(3038),
    [anon_sym_unorm] = ACTIONS(3038),
    [anon_sym_point] = ACTIONS(3038),
    [anon_sym_line] = ACTIONS(3038),
    [anon_sym_triangleadj] = ACTIONS(3038),
    [anon_sym_lineadj] = ACTIONS(3038),
    [anon_sym_triangle] = ACTIONS(3038),
    [anon_sym_cbuffer] = ACTIONS(3038),
    [anon_sym_interface] = ACTIONS(3038),
    [anon_sym_extension] = ACTIONS(3038),
  },
  [336] = {
    [sym_preproc_def] = STATE(340),
    [sym_preproc_function_def] = STATE(340),
    [sym_preproc_call] = STATE(340),
    [sym_preproc_if_in_field_declaration_list] = STATE(340),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(340),
    [sym_type_definition] = STATE(340),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(340),
    [sym_field_declaration] = STATE(340),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(340),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(340),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(340),
    [sym_operator_cast_declaration] = STATE(340),
    [sym_constructor_or_destructor_definition] = STATE(340),
    [sym_constructor_or_destructor_declaration] = STATE(340),
    [sym_friend_declaration] = STATE(340),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(340),
    [sym_alias_declaration] = STATE(340),
    [sym_static_assert_declaration] = STATE(340),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(340),
    [sym_subscript_declaration] = STATE(340),
    [sym_property_declaration] = STATE(340),
    [sym_associatedtype_declaration] = STATE(340),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(340),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3042),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [337] = {
    [sym_identifier] = ACTIONS(2210),
    [aux_sym_preproc_include_token1] = ACTIONS(2210),
    [aux_sym_preproc_def_token1] = ACTIONS(2210),
    [aux_sym_preproc_if_token1] = ACTIONS(2210),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2210),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2210),
    [sym_preproc_directive] = ACTIONS(2210),
    [anon_sym_LPAREN2] = ACTIONS(2217),
    [anon_sym_BANG] = ACTIONS(2217),
    [anon_sym_TILDE] = ACTIONS(2217),
    [anon_sym_DASH] = ACTIONS(2210),
    [anon_sym_PLUS] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(2217),
    [anon_sym_AMP_AMP] = ACTIONS(2217),
    [anon_sym_AMP] = ACTIONS(2210),
    [anon_sym_COLON] = ACTIONS(2210),
    [anon_sym_SEMI] = ACTIONS(2217),
    [anon_sym___extension__] = ACTIONS(2210),
    [anon_sym_typedef] = ACTIONS(2210),
    [anon_sym_in] = ACTIONS(2210),
    [anon_sym_out] = ACTIONS(2210),
    [anon_sym_inout] = ACTIONS(2210),
    [anon_sym_extern] = ACTIONS(2210),
    [anon_sym___attribute__] = ACTIONS(2210),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2217),
    [anon_sym___declspec] = ACTIONS(2210),
    [anon_sym___based] = ACTIONS(2210),
    [anon_sym___cdecl] = ACTIONS(2210),
    [anon_sym___clrcall] = ACTIONS(2210),
    [anon_sym___stdcall] = ACTIONS(2210),
    [anon_sym___fastcall] = ACTIONS(2210),
    [anon_sym___thiscall] = ACTIONS(2210),
    [anon_sym___vectorcall] = ACTIONS(2210),
    [anon_sym_LBRACE] = ACTIONS(2217),
    [anon_sym_RBRACE] = ACTIONS(2217),
    [anon_sym_signed] = ACTIONS(2210),
    [anon_sym_unsigned] = ACTIONS(2210),
    [anon_sym_long] = ACTIONS(2210),
    [anon_sym_short] = ACTIONS(2210),
    [anon_sym_LBRACK] = ACTIONS(2210),
    [anon_sym_static] = ACTIONS(2210),
    [anon_sym_register] = ACTIONS(2210),
    [anon_sym_inline] = ACTIONS(2210),
    [anon_sym___inline] = ACTIONS(2210),
    [anon_sym___inline__] = ACTIONS(2210),
    [anon_sym___forceinline] = ACTIONS(2210),
    [anon_sym_thread_local] = ACTIONS(2210),
    [anon_sym___thread] = ACTIONS(2210),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_constexpr] = ACTIONS(2210),
    [anon_sym_volatile] = ACTIONS(2210),
    [anon_sym_restrict] = ACTIONS(2210),
    [anon_sym___restrict__] = ACTIONS(2210),
    [anon_sym__Atomic] = ACTIONS(2210),
    [anon_sym__Noreturn] = ACTIONS(2210),
    [anon_sym_noreturn] = ACTIONS(2210),
    [anon_sym_mutable] = ACTIONS(2210),
    [anon_sym_constinit] = ACTIONS(2210),
    [anon_sym_consteval] = ACTIONS(2210),
    [anon_sym_alignas] = ACTIONS(2210),
    [anon_sym__Alignas] = ACTIONS(2210),
    [sym_primitive_type] = ACTIONS(2210),
    [anon_sym_enum] = ACTIONS(2210),
    [anon_sym_class] = ACTIONS(2210),
    [anon_sym_struct] = ACTIONS(2210),
    [anon_sym_union] = ACTIONS(2210),
    [anon_sym_if] = ACTIONS(2210),
    [anon_sym_else] = ACTIONS(2210),
    [anon_sym_switch] = ACTIONS(2210),
    [anon_sym_case] = ACTIONS(2210),
    [anon_sym_default] = ACTIONS(2210),
    [anon_sym_while] = ACTIONS(2210),
    [anon_sym_do] = ACTIONS(2210),
    [anon_sym_for] = ACTIONS(2210),
    [anon_sym_return] = ACTIONS(2210),
    [anon_sym_break] = ACTIONS(2210),
    [anon_sym_continue] = ACTIONS(2210),
    [anon_sym_goto] = ACTIONS(2210),
    [anon_sym___try] = ACTIONS(2210),
    [anon_sym___leave] = ACTIONS(2210),
    [anon_sym_not] = ACTIONS(2210),
    [anon_sym_compl] = ACTIONS(2210),
    [anon_sym_DASH_DASH] = ACTIONS(2217),
    [anon_sym_PLUS_PLUS] = ACTIONS(2217),
    [anon_sym_sizeof] = ACTIONS(2210),
    [anon_sym___alignof__] = ACTIONS(2210),
    [anon_sym___alignof] = ACTIONS(2210),
    [anon_sym__alignof] = ACTIONS(2210),
    [anon_sym_alignof] = ACTIONS(2210),
    [anon_sym__Alignof] = ACTIONS(2210),
    [anon_sym_offsetof] = ACTIONS(2210),
    [anon_sym__Generic] = ACTIONS(2210),
    [anon_sym_asm] = ACTIONS(2210),
    [anon_sym___asm__] = ACTIONS(2210),
    [anon_sym_DOT] = ACTIONS(2210),
    [sym_number_literal] = ACTIONS(2217),
    [anon_sym_L_SQUOTE] = ACTIONS(2217),
    [anon_sym_u_SQUOTE] = ACTIONS(2217),
    [anon_sym_U_SQUOTE] = ACTIONS(2217),
    [anon_sym_u8_SQUOTE] = ACTIONS(2217),
    [anon_sym_SQUOTE] = ACTIONS(2217),
    [anon_sym_L_DQUOTE] = ACTIONS(2217),
    [anon_sym_u_DQUOTE] = ACTIONS(2217),
    [anon_sym_U_DQUOTE] = ACTIONS(2217),
    [anon_sym_u8_DQUOTE] = ACTIONS(2217),
    [anon_sym_DQUOTE] = ACTIONS(2217),
    [sym_true] = ACTIONS(2210),
    [sym_false] = ACTIONS(2210),
    [anon_sym_NULL] = ACTIONS(2210),
    [anon_sym_nullptr] = ACTIONS(2210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2210),
    [anon_sym_let] = ACTIONS(2210),
    [anon_sym_This] = ACTIONS(2210),
    [anon_sym_decltype] = ACTIONS(2210),
    [anon_sym_final] = ACTIONS(2210),
    [anon_sym_override] = ACTIONS(2210),
    [sym_virtual] = ACTIONS(2210),
    [anon_sym_explicit] = ACTIONS(2210),
    [anon_sym_typename] = ACTIONS(2210),
    [anon_sym_template] = ACTIONS(2210),
    [anon_sym_operator] = ACTIONS(2210),
    [anon_sym_try] = ACTIONS(2210),
    [anon_sym_delete] = ACTIONS(2210),
    [anon_sym_throw] = ACTIONS(2210),
    [anon_sym_namespace] = ACTIONS(2210),
    [anon_sym_using] = ACTIONS(2210),
    [anon_sym_static_assert] = ACTIONS(2210),
    [anon_sym_concept] = ACTIONS(2210),
    [anon_sym_co_return] = ACTIONS(2210),
    [anon_sym_co_yield] = ACTIONS(2210),
    [anon_sym_R_DQUOTE] = ACTIONS(2217),
    [anon_sym_LR_DQUOTE] = ACTIONS(2217),
    [anon_sym_uR_DQUOTE] = ACTIONS(2217),
    [anon_sym_UR_DQUOTE] = ACTIONS(2217),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2217),
    [anon_sym_co_await] = ACTIONS(2210),
    [anon_sym_new] = ACTIONS(2210),
    [anon_sym_requires] = ACTIONS(2210),
    [sym_this] = ACTIONS(2210),
    [anon_sym_discard] = ACTIONS(2210),
    [anon_sym_precise] = ACTIONS(2210),
    [anon_sym_shared] = ACTIONS(2210),
    [anon_sym_groupshared] = ACTIONS(2210),
    [anon_sym_uniform] = ACTIONS(2210),
    [anon_sym_row_major] = ACTIONS(2210),
    [anon_sym_column_major] = ACTIONS(2210),
    [anon_sym_globallycoherent] = ACTIONS(2210),
    [anon_sym_centroid] = ACTIONS(2210),
    [anon_sym_noperspective] = ACTIONS(2210),
    [anon_sym_nointerpolation] = ACTIONS(2210),
    [anon_sym_sample] = ACTIONS(2210),
    [anon_sym_linear] = ACTIONS(2210),
    [anon_sym_snorm] = ACTIONS(2210),
    [anon_sym_unorm] = ACTIONS(2210),
    [anon_sym_point] = ACTIONS(2210),
    [anon_sym_line] = ACTIONS(2210),
    [anon_sym_triangleadj] = ACTIONS(2210),
    [anon_sym_lineadj] = ACTIONS(2210),
    [anon_sym_triangle] = ACTIONS(2210),
    [anon_sym_cbuffer] = ACTIONS(2210),
    [anon_sym_interface] = ACTIONS(2210),
    [anon_sym_extension] = ACTIONS(2210),
  },
  [338] = {
    [sym_preproc_def] = STATE(371),
    [sym_preproc_function_def] = STATE(371),
    [sym_preproc_call] = STATE(371),
    [sym_preproc_if_in_field_declaration_list] = STATE(371),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(371),
    [sym_type_definition] = STATE(371),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(371),
    [sym_field_declaration] = STATE(371),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(371),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(371),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(371),
    [sym_operator_cast_declaration] = STATE(371),
    [sym_constructor_or_destructor_definition] = STATE(371),
    [sym_constructor_or_destructor_declaration] = STATE(371),
    [sym_friend_declaration] = STATE(371),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(371),
    [sym_alias_declaration] = STATE(371),
    [sym_static_assert_declaration] = STATE(371),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(371),
    [sym_subscript_declaration] = STATE(371),
    [sym_property_declaration] = STATE(371),
    [sym_associatedtype_declaration] = STATE(371),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(371),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3044),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [339] = {
    [ts_builtin_sym_end] = ACTIONS(3046),
    [sym_identifier] = ACTIONS(3048),
    [aux_sym_preproc_include_token1] = ACTIONS(3048),
    [aux_sym_preproc_def_token1] = ACTIONS(3048),
    [anon_sym_COMMA] = ACTIONS(3046),
    [anon_sym_RPAREN] = ACTIONS(3046),
    [aux_sym_preproc_if_token1] = ACTIONS(3048),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3048),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3048),
    [sym_preproc_directive] = ACTIONS(3048),
    [anon_sym_LPAREN2] = ACTIONS(3046),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [anon_sym_DASH] = ACTIONS(3048),
    [anon_sym_PLUS] = ACTIONS(3048),
    [anon_sym_STAR] = ACTIONS(3046),
    [anon_sym_AMP_AMP] = ACTIONS(3046),
    [anon_sym_AMP] = ACTIONS(3048),
    [anon_sym_SEMI] = ACTIONS(3046),
    [anon_sym___extension__] = ACTIONS(3048),
    [anon_sym_typedef] = ACTIONS(3048),
    [anon_sym_in] = ACTIONS(3048),
    [anon_sym_out] = ACTIONS(3048),
    [anon_sym_inout] = ACTIONS(3048),
    [anon_sym_extern] = ACTIONS(3048),
    [anon_sym___attribute__] = ACTIONS(3048),
    [anon_sym_COLON_COLON] = ACTIONS(3046),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3046),
    [anon_sym___declspec] = ACTIONS(3048),
    [anon_sym___based] = ACTIONS(3048),
    [anon_sym___cdecl] = ACTIONS(3048),
    [anon_sym___clrcall] = ACTIONS(3048),
    [anon_sym___stdcall] = ACTIONS(3048),
    [anon_sym___fastcall] = ACTIONS(3048),
    [anon_sym___thiscall] = ACTIONS(3048),
    [anon_sym___vectorcall] = ACTIONS(3048),
    [anon_sym_LBRACE] = ACTIONS(3046),
    [anon_sym_signed] = ACTIONS(3048),
    [anon_sym_unsigned] = ACTIONS(3048),
    [anon_sym_long] = ACTIONS(3048),
    [anon_sym_short] = ACTIONS(3048),
    [anon_sym_LBRACK] = ACTIONS(3048),
    [anon_sym_static] = ACTIONS(3048),
    [anon_sym_register] = ACTIONS(3048),
    [anon_sym_inline] = ACTIONS(3048),
    [anon_sym___inline] = ACTIONS(3048),
    [anon_sym___inline__] = ACTIONS(3048),
    [anon_sym___forceinline] = ACTIONS(3048),
    [anon_sym_thread_local] = ACTIONS(3048),
    [anon_sym___thread] = ACTIONS(3048),
    [anon_sym_const] = ACTIONS(3048),
    [anon_sym_constexpr] = ACTIONS(3048),
    [anon_sym_volatile] = ACTIONS(3048),
    [anon_sym_restrict] = ACTIONS(3048),
    [anon_sym___restrict__] = ACTIONS(3048),
    [anon_sym__Atomic] = ACTIONS(3048),
    [anon_sym__Noreturn] = ACTIONS(3048),
    [anon_sym_noreturn] = ACTIONS(3048),
    [anon_sym_mutable] = ACTIONS(3048),
    [anon_sym_constinit] = ACTIONS(3048),
    [anon_sym_consteval] = ACTIONS(3048),
    [anon_sym_alignas] = ACTIONS(3048),
    [anon_sym__Alignas] = ACTIONS(3048),
    [sym_primitive_type] = ACTIONS(3048),
    [anon_sym_enum] = ACTIONS(3048),
    [anon_sym_class] = ACTIONS(3048),
    [anon_sym_struct] = ACTIONS(3048),
    [anon_sym_union] = ACTIONS(3048),
    [anon_sym_if] = ACTIONS(3048),
    [anon_sym_switch] = ACTIONS(3048),
    [anon_sym_case] = ACTIONS(3048),
    [anon_sym_default] = ACTIONS(3048),
    [anon_sym_while] = ACTIONS(3048),
    [anon_sym_do] = ACTIONS(3048),
    [anon_sym_for] = ACTIONS(3048),
    [anon_sym_return] = ACTIONS(3048),
    [anon_sym_break] = ACTIONS(3048),
    [anon_sym_continue] = ACTIONS(3048),
    [anon_sym_goto] = ACTIONS(3048),
    [anon_sym_not] = ACTIONS(3048),
    [anon_sym_compl] = ACTIONS(3048),
    [anon_sym_DASH_DASH] = ACTIONS(3046),
    [anon_sym_PLUS_PLUS] = ACTIONS(3046),
    [anon_sym_sizeof] = ACTIONS(3048),
    [anon_sym___alignof__] = ACTIONS(3048),
    [anon_sym___alignof] = ACTIONS(3048),
    [anon_sym__alignof] = ACTIONS(3048),
    [anon_sym_alignof] = ACTIONS(3048),
    [anon_sym__Alignof] = ACTIONS(3048),
    [anon_sym_offsetof] = ACTIONS(3048),
    [anon_sym__Generic] = ACTIONS(3048),
    [anon_sym_asm] = ACTIONS(3048),
    [anon_sym___asm__] = ACTIONS(3048),
    [anon_sym_DOT] = ACTIONS(3048),
    [sym_number_literal] = ACTIONS(3046),
    [anon_sym_L_SQUOTE] = ACTIONS(3046),
    [anon_sym_u_SQUOTE] = ACTIONS(3046),
    [anon_sym_U_SQUOTE] = ACTIONS(3046),
    [anon_sym_u8_SQUOTE] = ACTIONS(3046),
    [anon_sym_SQUOTE] = ACTIONS(3046),
    [anon_sym_L_DQUOTE] = ACTIONS(3046),
    [anon_sym_u_DQUOTE] = ACTIONS(3046),
    [anon_sym_U_DQUOTE] = ACTIONS(3046),
    [anon_sym_u8_DQUOTE] = ACTIONS(3046),
    [anon_sym_DQUOTE] = ACTIONS(3046),
    [sym_true] = ACTIONS(3048),
    [sym_false] = ACTIONS(3048),
    [anon_sym_NULL] = ACTIONS(3048),
    [anon_sym_nullptr] = ACTIONS(3048),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3048),
    [anon_sym_let] = ACTIONS(3048),
    [anon_sym_This] = ACTIONS(3048),
    [anon_sym_decltype] = ACTIONS(3048),
    [anon_sym_final] = ACTIONS(3048),
    [anon_sym_override] = ACTIONS(3048),
    [sym_virtual] = ACTIONS(3048),
    [anon_sym_explicit] = ACTIONS(3048),
    [anon_sym_typename] = ACTIONS(3048),
    [anon_sym_template] = ACTIONS(3048),
    [anon_sym_GT2] = ACTIONS(3046),
    [anon_sym_operator] = ACTIONS(3048),
    [anon_sym_try] = ACTIONS(3048),
    [anon_sym_delete] = ACTIONS(3048),
    [anon_sym_throw] = ACTIONS(3048),
    [anon_sym_namespace] = ACTIONS(3048),
    [anon_sym_using] = ACTIONS(3048),
    [anon_sym_static_assert] = ACTIONS(3048),
    [anon_sym_concept] = ACTIONS(3048),
    [anon_sym_co_return] = ACTIONS(3048),
    [anon_sym_co_yield] = ACTIONS(3048),
    [anon_sym_R_DQUOTE] = ACTIONS(3046),
    [anon_sym_LR_DQUOTE] = ACTIONS(3046),
    [anon_sym_uR_DQUOTE] = ACTIONS(3046),
    [anon_sym_UR_DQUOTE] = ACTIONS(3046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3046),
    [anon_sym_co_await] = ACTIONS(3048),
    [anon_sym_new] = ACTIONS(3048),
    [anon_sym_requires] = ACTIONS(3048),
    [sym_this] = ACTIONS(3048),
    [anon_sym_precise] = ACTIONS(3048),
    [anon_sym_shared] = ACTIONS(3048),
    [anon_sym_groupshared] = ACTIONS(3048),
    [anon_sym_uniform] = ACTIONS(3048),
    [anon_sym_row_major] = ACTIONS(3048),
    [anon_sym_column_major] = ACTIONS(3048),
    [anon_sym_globallycoherent] = ACTIONS(3048),
    [anon_sym_centroid] = ACTIONS(3048),
    [anon_sym_noperspective] = ACTIONS(3048),
    [anon_sym_nointerpolation] = ACTIONS(3048),
    [anon_sym_sample] = ACTIONS(3048),
    [anon_sym_linear] = ACTIONS(3048),
    [anon_sym_snorm] = ACTIONS(3048),
    [anon_sym_unorm] = ACTIONS(3048),
    [anon_sym_point] = ACTIONS(3048),
    [anon_sym_line] = ACTIONS(3048),
    [anon_sym_triangleadj] = ACTIONS(3048),
    [anon_sym_lineadj] = ACTIONS(3048),
    [anon_sym_triangle] = ACTIONS(3048),
    [anon_sym_interface] = ACTIONS(3048),
    [anon_sym_extension] = ACTIONS(3048),
    [anon_sym_where] = ACTIONS(3048),
    [anon_sym___exported] = ACTIONS(3048),
    [anon_sym_import] = ACTIONS(3048),
  },
  [340] = {
    [sym_preproc_def] = STATE(371),
    [sym_preproc_function_def] = STATE(371),
    [sym_preproc_call] = STATE(371),
    [sym_preproc_if_in_field_declaration_list] = STATE(371),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(371),
    [sym_type_definition] = STATE(371),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(371),
    [sym_field_declaration] = STATE(371),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(371),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(371),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(371),
    [sym_operator_cast_declaration] = STATE(371),
    [sym_constructor_or_destructor_definition] = STATE(371),
    [sym_constructor_or_destructor_declaration] = STATE(371),
    [sym_friend_declaration] = STATE(371),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(371),
    [sym_alias_declaration] = STATE(371),
    [sym_static_assert_declaration] = STATE(371),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(371),
    [sym_subscript_declaration] = STATE(371),
    [sym_property_declaration] = STATE(371),
    [sym_associatedtype_declaration] = STATE(371),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(371),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3050),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [341] = {
    [ts_builtin_sym_end] = ACTIONS(3052),
    [sym_identifier] = ACTIONS(3054),
    [aux_sym_preproc_include_token1] = ACTIONS(3054),
    [aux_sym_preproc_def_token1] = ACTIONS(3054),
    [anon_sym_COMMA] = ACTIONS(3052),
    [anon_sym_RPAREN] = ACTIONS(3052),
    [aux_sym_preproc_if_token1] = ACTIONS(3054),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3054),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3054),
    [sym_preproc_directive] = ACTIONS(3054),
    [anon_sym_LPAREN2] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3052),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3054),
    [anon_sym_PLUS] = ACTIONS(3054),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3054),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym___extension__] = ACTIONS(3054),
    [anon_sym_typedef] = ACTIONS(3054),
    [anon_sym_in] = ACTIONS(3054),
    [anon_sym_out] = ACTIONS(3054),
    [anon_sym_inout] = ACTIONS(3054),
    [anon_sym_extern] = ACTIONS(3054),
    [anon_sym___attribute__] = ACTIONS(3054),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3052),
    [anon_sym___declspec] = ACTIONS(3054),
    [anon_sym___based] = ACTIONS(3054),
    [anon_sym___cdecl] = ACTIONS(3054),
    [anon_sym___clrcall] = ACTIONS(3054),
    [anon_sym___stdcall] = ACTIONS(3054),
    [anon_sym___fastcall] = ACTIONS(3054),
    [anon_sym___thiscall] = ACTIONS(3054),
    [anon_sym___vectorcall] = ACTIONS(3054),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_signed] = ACTIONS(3054),
    [anon_sym_unsigned] = ACTIONS(3054),
    [anon_sym_long] = ACTIONS(3054),
    [anon_sym_short] = ACTIONS(3054),
    [anon_sym_LBRACK] = ACTIONS(3054),
    [anon_sym_static] = ACTIONS(3054),
    [anon_sym_register] = ACTIONS(3054),
    [anon_sym_inline] = ACTIONS(3054),
    [anon_sym___inline] = ACTIONS(3054),
    [anon_sym___inline__] = ACTIONS(3054),
    [anon_sym___forceinline] = ACTIONS(3054),
    [anon_sym_thread_local] = ACTIONS(3054),
    [anon_sym___thread] = ACTIONS(3054),
    [anon_sym_const] = ACTIONS(3054),
    [anon_sym_constexpr] = ACTIONS(3054),
    [anon_sym_volatile] = ACTIONS(3054),
    [anon_sym_restrict] = ACTIONS(3054),
    [anon_sym___restrict__] = ACTIONS(3054),
    [anon_sym__Atomic] = ACTIONS(3054),
    [anon_sym__Noreturn] = ACTIONS(3054),
    [anon_sym_noreturn] = ACTIONS(3054),
    [anon_sym_mutable] = ACTIONS(3054),
    [anon_sym_constinit] = ACTIONS(3054),
    [anon_sym_consteval] = ACTIONS(3054),
    [anon_sym_alignas] = ACTIONS(3054),
    [anon_sym__Alignas] = ACTIONS(3054),
    [sym_primitive_type] = ACTIONS(3054),
    [anon_sym_enum] = ACTIONS(3054),
    [anon_sym_class] = ACTIONS(3054),
    [anon_sym_struct] = ACTIONS(3054),
    [anon_sym_union] = ACTIONS(3054),
    [anon_sym_if] = ACTIONS(3054),
    [anon_sym_switch] = ACTIONS(3054),
    [anon_sym_case] = ACTIONS(3054),
    [anon_sym_default] = ACTIONS(3054),
    [anon_sym_while] = ACTIONS(3054),
    [anon_sym_do] = ACTIONS(3054),
    [anon_sym_for] = ACTIONS(3054),
    [anon_sym_return] = ACTIONS(3054),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_continue] = ACTIONS(3054),
    [anon_sym_goto] = ACTIONS(3054),
    [anon_sym_not] = ACTIONS(3054),
    [anon_sym_compl] = ACTIONS(3054),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_sizeof] = ACTIONS(3054),
    [anon_sym___alignof__] = ACTIONS(3054),
    [anon_sym___alignof] = ACTIONS(3054),
    [anon_sym__alignof] = ACTIONS(3054),
    [anon_sym_alignof] = ACTIONS(3054),
    [anon_sym__Alignof] = ACTIONS(3054),
    [anon_sym_offsetof] = ACTIONS(3054),
    [anon_sym__Generic] = ACTIONS(3054),
    [anon_sym_asm] = ACTIONS(3054),
    [anon_sym___asm__] = ACTIONS(3054),
    [anon_sym_DOT] = ACTIONS(3054),
    [sym_number_literal] = ACTIONS(3052),
    [anon_sym_L_SQUOTE] = ACTIONS(3052),
    [anon_sym_u_SQUOTE] = ACTIONS(3052),
    [anon_sym_U_SQUOTE] = ACTIONS(3052),
    [anon_sym_u8_SQUOTE] = ACTIONS(3052),
    [anon_sym_SQUOTE] = ACTIONS(3052),
    [anon_sym_L_DQUOTE] = ACTIONS(3052),
    [anon_sym_u_DQUOTE] = ACTIONS(3052),
    [anon_sym_U_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8_DQUOTE] = ACTIONS(3052),
    [anon_sym_DQUOTE] = ACTIONS(3052),
    [sym_true] = ACTIONS(3054),
    [sym_false] = ACTIONS(3054),
    [anon_sym_NULL] = ACTIONS(3054),
    [anon_sym_nullptr] = ACTIONS(3054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3054),
    [anon_sym_let] = ACTIONS(3054),
    [anon_sym_This] = ACTIONS(3054),
    [anon_sym_decltype] = ACTIONS(3054),
    [anon_sym_final] = ACTIONS(3054),
    [anon_sym_override] = ACTIONS(3054),
    [sym_virtual] = ACTIONS(3054),
    [anon_sym_explicit] = ACTIONS(3054),
    [anon_sym_typename] = ACTIONS(3054),
    [anon_sym_template] = ACTIONS(3054),
    [anon_sym_GT2] = ACTIONS(3052),
    [anon_sym_operator] = ACTIONS(3054),
    [anon_sym_try] = ACTIONS(3054),
    [anon_sym_delete] = ACTIONS(3054),
    [anon_sym_throw] = ACTIONS(3054),
    [anon_sym_namespace] = ACTIONS(3054),
    [anon_sym_using] = ACTIONS(3054),
    [anon_sym_static_assert] = ACTIONS(3054),
    [anon_sym_concept] = ACTIONS(3054),
    [anon_sym_co_return] = ACTIONS(3054),
    [anon_sym_co_yield] = ACTIONS(3054),
    [anon_sym_R_DQUOTE] = ACTIONS(3052),
    [anon_sym_LR_DQUOTE] = ACTIONS(3052),
    [anon_sym_uR_DQUOTE] = ACTIONS(3052),
    [anon_sym_UR_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3052),
    [anon_sym_co_await] = ACTIONS(3054),
    [anon_sym_new] = ACTIONS(3054),
    [anon_sym_requires] = ACTIONS(3054),
    [sym_this] = ACTIONS(3054),
    [anon_sym_precise] = ACTIONS(3054),
    [anon_sym_shared] = ACTIONS(3054),
    [anon_sym_groupshared] = ACTIONS(3054),
    [anon_sym_uniform] = ACTIONS(3054),
    [anon_sym_row_major] = ACTIONS(3054),
    [anon_sym_column_major] = ACTIONS(3054),
    [anon_sym_globallycoherent] = ACTIONS(3054),
    [anon_sym_centroid] = ACTIONS(3054),
    [anon_sym_noperspective] = ACTIONS(3054),
    [anon_sym_nointerpolation] = ACTIONS(3054),
    [anon_sym_sample] = ACTIONS(3054),
    [anon_sym_linear] = ACTIONS(3054),
    [anon_sym_snorm] = ACTIONS(3054),
    [anon_sym_unorm] = ACTIONS(3054),
    [anon_sym_point] = ACTIONS(3054),
    [anon_sym_line] = ACTIONS(3054),
    [anon_sym_triangleadj] = ACTIONS(3054),
    [anon_sym_lineadj] = ACTIONS(3054),
    [anon_sym_triangle] = ACTIONS(3054),
    [anon_sym_interface] = ACTIONS(3054),
    [anon_sym_extension] = ACTIONS(3054),
    [anon_sym_where] = ACTIONS(3054),
    [anon_sym___exported] = ACTIONS(3054),
    [anon_sym_import] = ACTIONS(3054),
  },
  [342] = {
    [ts_builtin_sym_end] = ACTIONS(3056),
    [sym_identifier] = ACTIONS(3058),
    [aux_sym_preproc_include_token1] = ACTIONS(3058),
    [aux_sym_preproc_def_token1] = ACTIONS(3058),
    [anon_sym_COMMA] = ACTIONS(3056),
    [anon_sym_RPAREN] = ACTIONS(3056),
    [aux_sym_preproc_if_token1] = ACTIONS(3058),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3058),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3058),
    [sym_preproc_directive] = ACTIONS(3058),
    [anon_sym_LPAREN2] = ACTIONS(3056),
    [anon_sym_BANG] = ACTIONS(3056),
    [anon_sym_TILDE] = ACTIONS(3056),
    [anon_sym_DASH] = ACTIONS(3058),
    [anon_sym_PLUS] = ACTIONS(3058),
    [anon_sym_STAR] = ACTIONS(3056),
    [anon_sym_AMP_AMP] = ACTIONS(3056),
    [anon_sym_AMP] = ACTIONS(3058),
    [anon_sym_SEMI] = ACTIONS(3056),
    [anon_sym___extension__] = ACTIONS(3058),
    [anon_sym_typedef] = ACTIONS(3058),
    [anon_sym_in] = ACTIONS(3058),
    [anon_sym_out] = ACTIONS(3058),
    [anon_sym_inout] = ACTIONS(3058),
    [anon_sym_extern] = ACTIONS(3058),
    [anon_sym___attribute__] = ACTIONS(3058),
    [anon_sym_COLON_COLON] = ACTIONS(3056),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3056),
    [anon_sym___declspec] = ACTIONS(3058),
    [anon_sym___based] = ACTIONS(3058),
    [anon_sym___cdecl] = ACTIONS(3058),
    [anon_sym___clrcall] = ACTIONS(3058),
    [anon_sym___stdcall] = ACTIONS(3058),
    [anon_sym___fastcall] = ACTIONS(3058),
    [anon_sym___thiscall] = ACTIONS(3058),
    [anon_sym___vectorcall] = ACTIONS(3058),
    [anon_sym_LBRACE] = ACTIONS(3056),
    [anon_sym_signed] = ACTIONS(3058),
    [anon_sym_unsigned] = ACTIONS(3058),
    [anon_sym_long] = ACTIONS(3058),
    [anon_sym_short] = ACTIONS(3058),
    [anon_sym_LBRACK] = ACTIONS(3058),
    [anon_sym_static] = ACTIONS(3058),
    [anon_sym_register] = ACTIONS(3058),
    [anon_sym_inline] = ACTIONS(3058),
    [anon_sym___inline] = ACTIONS(3058),
    [anon_sym___inline__] = ACTIONS(3058),
    [anon_sym___forceinline] = ACTIONS(3058),
    [anon_sym_thread_local] = ACTIONS(3058),
    [anon_sym___thread] = ACTIONS(3058),
    [anon_sym_const] = ACTIONS(3058),
    [anon_sym_constexpr] = ACTIONS(3058),
    [anon_sym_volatile] = ACTIONS(3058),
    [anon_sym_restrict] = ACTIONS(3058),
    [anon_sym___restrict__] = ACTIONS(3058),
    [anon_sym__Atomic] = ACTIONS(3058),
    [anon_sym__Noreturn] = ACTIONS(3058),
    [anon_sym_noreturn] = ACTIONS(3058),
    [anon_sym_mutable] = ACTIONS(3058),
    [anon_sym_constinit] = ACTIONS(3058),
    [anon_sym_consteval] = ACTIONS(3058),
    [anon_sym_alignas] = ACTIONS(3058),
    [anon_sym__Alignas] = ACTIONS(3058),
    [sym_primitive_type] = ACTIONS(3058),
    [anon_sym_enum] = ACTIONS(3058),
    [anon_sym_class] = ACTIONS(3058),
    [anon_sym_struct] = ACTIONS(3058),
    [anon_sym_union] = ACTIONS(3058),
    [anon_sym_if] = ACTIONS(3058),
    [anon_sym_switch] = ACTIONS(3058),
    [anon_sym_case] = ACTIONS(3058),
    [anon_sym_default] = ACTIONS(3058),
    [anon_sym_while] = ACTIONS(3058),
    [anon_sym_do] = ACTIONS(3058),
    [anon_sym_for] = ACTIONS(3058),
    [anon_sym_return] = ACTIONS(3058),
    [anon_sym_break] = ACTIONS(3058),
    [anon_sym_continue] = ACTIONS(3058),
    [anon_sym_goto] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3058),
    [anon_sym_compl] = ACTIONS(3058),
    [anon_sym_DASH_DASH] = ACTIONS(3056),
    [anon_sym_PLUS_PLUS] = ACTIONS(3056),
    [anon_sym_sizeof] = ACTIONS(3058),
    [anon_sym___alignof__] = ACTIONS(3058),
    [anon_sym___alignof] = ACTIONS(3058),
    [anon_sym__alignof] = ACTIONS(3058),
    [anon_sym_alignof] = ACTIONS(3058),
    [anon_sym__Alignof] = ACTIONS(3058),
    [anon_sym_offsetof] = ACTIONS(3058),
    [anon_sym__Generic] = ACTIONS(3058),
    [anon_sym_asm] = ACTIONS(3058),
    [anon_sym___asm__] = ACTIONS(3058),
    [anon_sym_DOT] = ACTIONS(3058),
    [sym_number_literal] = ACTIONS(3056),
    [anon_sym_L_SQUOTE] = ACTIONS(3056),
    [anon_sym_u_SQUOTE] = ACTIONS(3056),
    [anon_sym_U_SQUOTE] = ACTIONS(3056),
    [anon_sym_u8_SQUOTE] = ACTIONS(3056),
    [anon_sym_SQUOTE] = ACTIONS(3056),
    [anon_sym_L_DQUOTE] = ACTIONS(3056),
    [anon_sym_u_DQUOTE] = ACTIONS(3056),
    [anon_sym_U_DQUOTE] = ACTIONS(3056),
    [anon_sym_u8_DQUOTE] = ACTIONS(3056),
    [anon_sym_DQUOTE] = ACTIONS(3056),
    [sym_true] = ACTIONS(3058),
    [sym_false] = ACTIONS(3058),
    [anon_sym_NULL] = ACTIONS(3058),
    [anon_sym_nullptr] = ACTIONS(3058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3058),
    [anon_sym_let] = ACTIONS(3058),
    [anon_sym_This] = ACTIONS(3058),
    [anon_sym_decltype] = ACTIONS(3058),
    [anon_sym_final] = ACTIONS(3058),
    [anon_sym_override] = ACTIONS(3058),
    [sym_virtual] = ACTIONS(3058),
    [anon_sym_explicit] = ACTIONS(3058),
    [anon_sym_typename] = ACTIONS(3058),
    [anon_sym_template] = ACTIONS(3058),
    [anon_sym_GT2] = ACTIONS(3056),
    [anon_sym_operator] = ACTIONS(3058),
    [anon_sym_try] = ACTIONS(3058),
    [anon_sym_delete] = ACTIONS(3058),
    [anon_sym_throw] = ACTIONS(3058),
    [anon_sym_namespace] = ACTIONS(3058),
    [anon_sym_using] = ACTIONS(3058),
    [anon_sym_static_assert] = ACTIONS(3058),
    [anon_sym_concept] = ACTIONS(3058),
    [anon_sym_co_return] = ACTIONS(3058),
    [anon_sym_co_yield] = ACTIONS(3058),
    [anon_sym_R_DQUOTE] = ACTIONS(3056),
    [anon_sym_LR_DQUOTE] = ACTIONS(3056),
    [anon_sym_uR_DQUOTE] = ACTIONS(3056),
    [anon_sym_UR_DQUOTE] = ACTIONS(3056),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3056),
    [anon_sym_co_await] = ACTIONS(3058),
    [anon_sym_new] = ACTIONS(3058),
    [anon_sym_requires] = ACTIONS(3058),
    [sym_this] = ACTIONS(3058),
    [anon_sym_precise] = ACTIONS(3058),
    [anon_sym_shared] = ACTIONS(3058),
    [anon_sym_groupshared] = ACTIONS(3058),
    [anon_sym_uniform] = ACTIONS(3058),
    [anon_sym_row_major] = ACTIONS(3058),
    [anon_sym_column_major] = ACTIONS(3058),
    [anon_sym_globallycoherent] = ACTIONS(3058),
    [anon_sym_centroid] = ACTIONS(3058),
    [anon_sym_noperspective] = ACTIONS(3058),
    [anon_sym_nointerpolation] = ACTIONS(3058),
    [anon_sym_sample] = ACTIONS(3058),
    [anon_sym_linear] = ACTIONS(3058),
    [anon_sym_snorm] = ACTIONS(3058),
    [anon_sym_unorm] = ACTIONS(3058),
    [anon_sym_point] = ACTIONS(3058),
    [anon_sym_line] = ACTIONS(3058),
    [anon_sym_triangleadj] = ACTIONS(3058),
    [anon_sym_lineadj] = ACTIONS(3058),
    [anon_sym_triangle] = ACTIONS(3058),
    [anon_sym_interface] = ACTIONS(3058),
    [anon_sym_extension] = ACTIONS(3058),
    [anon_sym_where] = ACTIONS(3058),
    [anon_sym___exported] = ACTIONS(3058),
    [anon_sym_import] = ACTIONS(3058),
  },
  [343] = {
    [sym_identifier] = ACTIONS(3034),
    [aux_sym_preproc_include_token1] = ACTIONS(3034),
    [aux_sym_preproc_def_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token2] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3034),
    [aux_sym_preproc_else_token1] = ACTIONS(3034),
    [aux_sym_preproc_elif_token1] = ACTIONS(3034),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_BANG] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3034),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_in] = ACTIONS(3034),
    [anon_sym_out] = ACTIONS(3034),
    [anon_sym_inout] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym___based] = ACTIONS(3034),
    [anon_sym___cdecl] = ACTIONS(3034),
    [anon_sym___clrcall] = ACTIONS(3034),
    [anon_sym___stdcall] = ACTIONS(3034),
    [anon_sym___fastcall] = ACTIONS(3034),
    [anon_sym___thiscall] = ACTIONS(3034),
    [anon_sym___vectorcall] = ACTIONS(3034),
    [anon_sym_LBRACE] = ACTIONS(3036),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [anon_sym_if] = ACTIONS(3034),
    [anon_sym_else] = ACTIONS(3034),
    [anon_sym_switch] = ACTIONS(3034),
    [anon_sym_case] = ACTIONS(3034),
    [anon_sym_default] = ACTIONS(3034),
    [anon_sym_while] = ACTIONS(3034),
    [anon_sym_do] = ACTIONS(3034),
    [anon_sym_for] = ACTIONS(3034),
    [anon_sym_return] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3034),
    [anon_sym_continue] = ACTIONS(3034),
    [anon_sym_goto] = ACTIONS(3034),
    [anon_sym___try] = ACTIONS(3034),
    [anon_sym___leave] = ACTIONS(3034),
    [anon_sym_not] = ACTIONS(3034),
    [anon_sym_compl] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_sizeof] = ACTIONS(3034),
    [anon_sym___alignof__] = ACTIONS(3034),
    [anon_sym___alignof] = ACTIONS(3034),
    [anon_sym__alignof] = ACTIONS(3034),
    [anon_sym_alignof] = ACTIONS(3034),
    [anon_sym__Alignof] = ACTIONS(3034),
    [anon_sym_offsetof] = ACTIONS(3034),
    [anon_sym__Generic] = ACTIONS(3034),
    [anon_sym_asm] = ACTIONS(3034),
    [anon_sym___asm__] = ACTIONS(3034),
    [sym_number_literal] = ACTIONS(3036),
    [anon_sym_L_SQUOTE] = ACTIONS(3036),
    [anon_sym_u_SQUOTE] = ACTIONS(3036),
    [anon_sym_U_SQUOTE] = ACTIONS(3036),
    [anon_sym_u8_SQUOTE] = ACTIONS(3036),
    [anon_sym_SQUOTE] = ACTIONS(3036),
    [anon_sym_L_DQUOTE] = ACTIONS(3036),
    [anon_sym_u_DQUOTE] = ACTIONS(3036),
    [anon_sym_U_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8_DQUOTE] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [sym_true] = ACTIONS(3034),
    [sym_false] = ACTIONS(3034),
    [anon_sym_NULL] = ACTIONS(3034),
    [anon_sym_nullptr] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_This] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [sym_virtual] = ACTIONS(3034),
    [anon_sym_explicit] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_operator] = ACTIONS(3034),
    [anon_sym_try] = ACTIONS(3034),
    [anon_sym_delete] = ACTIONS(3034),
    [anon_sym_throw] = ACTIONS(3034),
    [anon_sym_namespace] = ACTIONS(3034),
    [anon_sym_using] = ACTIONS(3034),
    [anon_sym_static_assert] = ACTIONS(3034),
    [anon_sym_concept] = ACTIONS(3034),
    [anon_sym_co_return] = ACTIONS(3034),
    [anon_sym_co_yield] = ACTIONS(3034),
    [anon_sym_R_DQUOTE] = ACTIONS(3036),
    [anon_sym_LR_DQUOTE] = ACTIONS(3036),
    [anon_sym_uR_DQUOTE] = ACTIONS(3036),
    [anon_sym_UR_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3036),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3034),
    [anon_sym_requires] = ACTIONS(3034),
    [sym_this] = ACTIONS(3034),
    [anon_sym_discard] = ACTIONS(3034),
    [anon_sym_precise] = ACTIONS(3034),
    [anon_sym_shared] = ACTIONS(3034),
    [anon_sym_groupshared] = ACTIONS(3034),
    [anon_sym_uniform] = ACTIONS(3034),
    [anon_sym_row_major] = ACTIONS(3034),
    [anon_sym_column_major] = ACTIONS(3034),
    [anon_sym_globallycoherent] = ACTIONS(3034),
    [anon_sym_centroid] = ACTIONS(3034),
    [anon_sym_noperspective] = ACTIONS(3034),
    [anon_sym_nointerpolation] = ACTIONS(3034),
    [anon_sym_sample] = ACTIONS(3034),
    [anon_sym_linear] = ACTIONS(3034),
    [anon_sym_snorm] = ACTIONS(3034),
    [anon_sym_unorm] = ACTIONS(3034),
    [anon_sym_point] = ACTIONS(3034),
    [anon_sym_line] = ACTIONS(3034),
    [anon_sym_triangleadj] = ACTIONS(3034),
    [anon_sym_lineadj] = ACTIONS(3034),
    [anon_sym_triangle] = ACTIONS(3034),
    [anon_sym_cbuffer] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3034),
    [anon_sym_extension] = ACTIONS(3034),
  },
  [344] = {
    [sym_attribute_specifier] = STATE(687),
    [sym_enumerator_list] = STATE(613),
    [sym__enum_base_clause] = STATE(595),
    [sym_identifier] = ACTIONS(3060),
    [aux_sym_preproc_include_token1] = ACTIONS(3060),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3060),
    [sym_preproc_directive] = ACTIONS(3060),
    [anon_sym_LPAREN2] = ACTIONS(3062),
    [anon_sym_BANG] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3062),
    [anon_sym_DASH] = ACTIONS(3060),
    [anon_sym_PLUS] = ACTIONS(3060),
    [anon_sym_STAR] = ACTIONS(3062),
    [anon_sym_AMP_AMP] = ACTIONS(3062),
    [anon_sym_AMP] = ACTIONS(3060),
    [anon_sym_COLON] = ACTIONS(3064),
    [anon_sym_SEMI] = ACTIONS(3062),
    [anon_sym___extension__] = ACTIONS(3060),
    [anon_sym_typedef] = ACTIONS(3060),
    [anon_sym_in] = ACTIONS(3060),
    [anon_sym_out] = ACTIONS(3060),
    [anon_sym_inout] = ACTIONS(3060),
    [anon_sym_extern] = ACTIONS(3060),
    [anon_sym___attribute__] = ACTIONS(2687),
    [anon_sym_COLON_COLON] = ACTIONS(3062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3062),
    [anon_sym___declspec] = ACTIONS(3060),
    [anon_sym___based] = ACTIONS(3060),
    [anon_sym___cdecl] = ACTIONS(3060),
    [anon_sym___clrcall] = ACTIONS(3060),
    [anon_sym___stdcall] = ACTIONS(3060),
    [anon_sym___fastcall] = ACTIONS(3060),
    [anon_sym___thiscall] = ACTIONS(3060),
    [anon_sym___vectorcall] = ACTIONS(3060),
    [anon_sym_LBRACE] = ACTIONS(3066),
    [anon_sym_RBRACE] = ACTIONS(3062),
    [anon_sym_signed] = ACTIONS(3060),
    [anon_sym_unsigned] = ACTIONS(3060),
    [anon_sym_long] = ACTIONS(3060),
    [anon_sym_short] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(3060),
    [anon_sym_static] = ACTIONS(3060),
    [anon_sym_register] = ACTIONS(3060),
    [anon_sym_inline] = ACTIONS(3060),
    [anon_sym___inline] = ACTIONS(3060),
    [anon_sym___inline__] = ACTIONS(3060),
    [anon_sym___forceinline] = ACTIONS(3060),
    [anon_sym_thread_local] = ACTIONS(3060),
    [anon_sym___thread] = ACTIONS(3060),
    [anon_sym_const] = ACTIONS(3060),
    [anon_sym_constexpr] = ACTIONS(3060),
    [anon_sym_volatile] = ACTIONS(3060),
    [anon_sym_restrict] = ACTIONS(3060),
    [anon_sym___restrict__] = ACTIONS(3060),
    [anon_sym__Atomic] = ACTIONS(3060),
    [anon_sym__Noreturn] = ACTIONS(3060),
    [anon_sym_noreturn] = ACTIONS(3060),
    [anon_sym_mutable] = ACTIONS(3060),
    [anon_sym_constinit] = ACTIONS(3060),
    [anon_sym_consteval] = ACTIONS(3060),
    [anon_sym_alignas] = ACTIONS(3060),
    [anon_sym__Alignas] = ACTIONS(3060),
    [sym_primitive_type] = ACTIONS(3060),
    [anon_sym_enum] = ACTIONS(3060),
    [anon_sym_class] = ACTIONS(3060),
    [anon_sym_struct] = ACTIONS(3060),
    [anon_sym_union] = ACTIONS(3060),
    [anon_sym_if] = ACTIONS(3060),
    [anon_sym_switch] = ACTIONS(3060),
    [anon_sym_case] = ACTIONS(3060),
    [anon_sym_default] = ACTIONS(3060),
    [anon_sym_while] = ACTIONS(3060),
    [anon_sym_do] = ACTIONS(3060),
    [anon_sym_for] = ACTIONS(3060),
    [anon_sym_return] = ACTIONS(3060),
    [anon_sym_break] = ACTIONS(3060),
    [anon_sym_continue] = ACTIONS(3060),
    [anon_sym_goto] = ACTIONS(3060),
    [anon_sym___try] = ACTIONS(3060),
    [anon_sym___leave] = ACTIONS(3060),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_compl] = ACTIONS(3060),
    [anon_sym_DASH_DASH] = ACTIONS(3062),
    [anon_sym_PLUS_PLUS] = ACTIONS(3062),
    [anon_sym_sizeof] = ACTIONS(3060),
    [anon_sym___alignof__] = ACTIONS(3060),
    [anon_sym___alignof] = ACTIONS(3060),
    [anon_sym__alignof] = ACTIONS(3060),
    [anon_sym_alignof] = ACTIONS(3060),
    [anon_sym__Alignof] = ACTIONS(3060),
    [anon_sym_offsetof] = ACTIONS(3060),
    [anon_sym__Generic] = ACTIONS(3060),
    [anon_sym_asm] = ACTIONS(3060),
    [anon_sym___asm__] = ACTIONS(3060),
    [anon_sym_DOT] = ACTIONS(3060),
    [sym_number_literal] = ACTIONS(3062),
    [anon_sym_L_SQUOTE] = ACTIONS(3062),
    [anon_sym_u_SQUOTE] = ACTIONS(3062),
    [anon_sym_U_SQUOTE] = ACTIONS(3062),
    [anon_sym_u8_SQUOTE] = ACTIONS(3062),
    [anon_sym_SQUOTE] = ACTIONS(3062),
    [anon_sym_L_DQUOTE] = ACTIONS(3062),
    [anon_sym_u_DQUOTE] = ACTIONS(3062),
    [anon_sym_U_DQUOTE] = ACTIONS(3062),
    [anon_sym_u8_DQUOTE] = ACTIONS(3062),
    [anon_sym_DQUOTE] = ACTIONS(3062),
    [sym_true] = ACTIONS(3060),
    [sym_false] = ACTIONS(3060),
    [anon_sym_NULL] = ACTIONS(3060),
    [anon_sym_nullptr] = ACTIONS(3060),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3060),
    [anon_sym_let] = ACTIONS(3060),
    [anon_sym_This] = ACTIONS(3060),
    [anon_sym_decltype] = ACTIONS(3060),
    [sym_virtual] = ACTIONS(3060),
    [anon_sym_explicit] = ACTIONS(3060),
    [anon_sym_typename] = ACTIONS(3060),
    [anon_sym_template] = ACTIONS(3060),
    [anon_sym_operator] = ACTIONS(3060),
    [anon_sym_try] = ACTIONS(3060),
    [anon_sym_delete] = ACTIONS(3060),
    [anon_sym_throw] = ACTIONS(3060),
    [anon_sym_namespace] = ACTIONS(3060),
    [anon_sym_using] = ACTIONS(3060),
    [anon_sym_static_assert] = ACTIONS(3060),
    [anon_sym_concept] = ACTIONS(3060),
    [anon_sym_co_return] = ACTIONS(3060),
    [anon_sym_co_yield] = ACTIONS(3060),
    [anon_sym_R_DQUOTE] = ACTIONS(3062),
    [anon_sym_LR_DQUOTE] = ACTIONS(3062),
    [anon_sym_uR_DQUOTE] = ACTIONS(3062),
    [anon_sym_UR_DQUOTE] = ACTIONS(3062),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3062),
    [anon_sym_co_await] = ACTIONS(3060),
    [anon_sym_new] = ACTIONS(3060),
    [anon_sym_requires] = ACTIONS(3060),
    [sym_this] = ACTIONS(3060),
    [anon_sym_discard] = ACTIONS(3060),
    [anon_sym_precise] = ACTIONS(3060),
    [anon_sym_shared] = ACTIONS(3060),
    [anon_sym_groupshared] = ACTIONS(3060),
    [anon_sym_uniform] = ACTIONS(3060),
    [anon_sym_row_major] = ACTIONS(3060),
    [anon_sym_column_major] = ACTIONS(3060),
    [anon_sym_globallycoherent] = ACTIONS(3060),
    [anon_sym_centroid] = ACTIONS(3060),
    [anon_sym_noperspective] = ACTIONS(3060),
    [anon_sym_nointerpolation] = ACTIONS(3060),
    [anon_sym_sample] = ACTIONS(3060),
    [anon_sym_linear] = ACTIONS(3060),
    [anon_sym_snorm] = ACTIONS(3060),
    [anon_sym_unorm] = ACTIONS(3060),
    [anon_sym_point] = ACTIONS(3060),
    [anon_sym_line] = ACTIONS(3060),
    [anon_sym_triangleadj] = ACTIONS(3060),
    [anon_sym_lineadj] = ACTIONS(3060),
    [anon_sym_triangle] = ACTIONS(3060),
    [anon_sym_cbuffer] = ACTIONS(3060),
    [anon_sym_interface] = ACTIONS(3060),
    [anon_sym_extension] = ACTIONS(3060),
  },
  [345] = {
    [sym_identifier] = ACTIONS(2244),
    [aux_sym_preproc_include_token1] = ACTIONS(2244),
    [aux_sym_preproc_def_token1] = ACTIONS(2244),
    [aux_sym_preproc_if_token1] = ACTIONS(2244),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2244),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2244),
    [sym_preproc_directive] = ACTIONS(2244),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2244),
    [anon_sym_PLUS] = ACTIONS(2244),
    [anon_sym_STAR] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_AMP] = ACTIONS(2244),
    [anon_sym_COLON] = ACTIONS(2244),
    [anon_sym_SEMI] = ACTIONS(2246),
    [anon_sym___extension__] = ACTIONS(2244),
    [anon_sym_typedef] = ACTIONS(2244),
    [anon_sym_in] = ACTIONS(2244),
    [anon_sym_out] = ACTIONS(2244),
    [anon_sym_inout] = ACTIONS(2244),
    [anon_sym_extern] = ACTIONS(2244),
    [anon_sym___attribute__] = ACTIONS(2244),
    [anon_sym_COLON_COLON] = ACTIONS(2246),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2246),
    [anon_sym___declspec] = ACTIONS(2244),
    [anon_sym___based] = ACTIONS(2244),
    [anon_sym___cdecl] = ACTIONS(2244),
    [anon_sym___clrcall] = ACTIONS(2244),
    [anon_sym___stdcall] = ACTIONS(2244),
    [anon_sym___fastcall] = ACTIONS(2244),
    [anon_sym___thiscall] = ACTIONS(2244),
    [anon_sym___vectorcall] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_RBRACE] = ACTIONS(2246),
    [anon_sym_signed] = ACTIONS(2244),
    [anon_sym_unsigned] = ACTIONS(2244),
    [anon_sym_long] = ACTIONS(2244),
    [anon_sym_short] = ACTIONS(2244),
    [anon_sym_LBRACK] = ACTIONS(2244),
    [anon_sym_static] = ACTIONS(2244),
    [anon_sym_register] = ACTIONS(2244),
    [anon_sym_inline] = ACTIONS(2244),
    [anon_sym___inline] = ACTIONS(2244),
    [anon_sym___inline__] = ACTIONS(2244),
    [anon_sym___forceinline] = ACTIONS(2244),
    [anon_sym_thread_local] = ACTIONS(2244),
    [anon_sym___thread] = ACTIONS(2244),
    [anon_sym_const] = ACTIONS(2244),
    [anon_sym_constexpr] = ACTIONS(2244),
    [anon_sym_volatile] = ACTIONS(2244),
    [anon_sym_restrict] = ACTIONS(2244),
    [anon_sym___restrict__] = ACTIONS(2244),
    [anon_sym__Atomic] = ACTIONS(2244),
    [anon_sym__Noreturn] = ACTIONS(2244),
    [anon_sym_noreturn] = ACTIONS(2244),
    [anon_sym_mutable] = ACTIONS(2244),
    [anon_sym_constinit] = ACTIONS(2244),
    [anon_sym_consteval] = ACTIONS(2244),
    [anon_sym_alignas] = ACTIONS(2244),
    [anon_sym__Alignas] = ACTIONS(2244),
    [sym_primitive_type] = ACTIONS(2244),
    [anon_sym_enum] = ACTIONS(2244),
    [anon_sym_class] = ACTIONS(2244),
    [anon_sym_struct] = ACTIONS(2244),
    [anon_sym_union] = ACTIONS(2244),
    [anon_sym_if] = ACTIONS(2244),
    [anon_sym_else] = ACTIONS(2244),
    [anon_sym_switch] = ACTIONS(2244),
    [anon_sym_case] = ACTIONS(2244),
    [anon_sym_default] = ACTIONS(2244),
    [anon_sym_while] = ACTIONS(2244),
    [anon_sym_do] = ACTIONS(2244),
    [anon_sym_for] = ACTIONS(2244),
    [anon_sym_return] = ACTIONS(2244),
    [anon_sym_break] = ACTIONS(2244),
    [anon_sym_continue] = ACTIONS(2244),
    [anon_sym_goto] = ACTIONS(2244),
    [anon_sym___try] = ACTIONS(2244),
    [anon_sym___leave] = ACTIONS(2244),
    [anon_sym_not] = ACTIONS(2244),
    [anon_sym_compl] = ACTIONS(2244),
    [anon_sym_DASH_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_PLUS] = ACTIONS(2246),
    [anon_sym_sizeof] = ACTIONS(2244),
    [anon_sym___alignof__] = ACTIONS(2244),
    [anon_sym___alignof] = ACTIONS(2244),
    [anon_sym__alignof] = ACTIONS(2244),
    [anon_sym_alignof] = ACTIONS(2244),
    [anon_sym__Alignof] = ACTIONS(2244),
    [anon_sym_offsetof] = ACTIONS(2244),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2244),
    [anon_sym___asm__] = ACTIONS(2244),
    [anon_sym_DOT] = ACTIONS(2244),
    [sym_number_literal] = ACTIONS(2246),
    [anon_sym_L_SQUOTE] = ACTIONS(2246),
    [anon_sym_u_SQUOTE] = ACTIONS(2246),
    [anon_sym_U_SQUOTE] = ACTIONS(2246),
    [anon_sym_u8_SQUOTE] = ACTIONS(2246),
    [anon_sym_SQUOTE] = ACTIONS(2246),
    [anon_sym_L_DQUOTE] = ACTIONS(2246),
    [anon_sym_u_DQUOTE] = ACTIONS(2246),
    [anon_sym_U_DQUOTE] = ACTIONS(2246),
    [anon_sym_u8_DQUOTE] = ACTIONS(2246),
    [anon_sym_DQUOTE] = ACTIONS(2246),
    [sym_true] = ACTIONS(2244),
    [sym_false] = ACTIONS(2244),
    [anon_sym_NULL] = ACTIONS(2244),
    [anon_sym_nullptr] = ACTIONS(2244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2244),
    [anon_sym_let] = ACTIONS(2244),
    [anon_sym_This] = ACTIONS(2244),
    [anon_sym_decltype] = ACTIONS(2244),
    [anon_sym_final] = ACTIONS(2244),
    [anon_sym_override] = ACTIONS(2244),
    [sym_virtual] = ACTIONS(2244),
    [anon_sym_explicit] = ACTIONS(2244),
    [anon_sym_typename] = ACTIONS(2244),
    [anon_sym_template] = ACTIONS(2244),
    [anon_sym_operator] = ACTIONS(2244),
    [anon_sym_try] = ACTIONS(2244),
    [anon_sym_delete] = ACTIONS(2244),
    [anon_sym_throw] = ACTIONS(2244),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_using] = ACTIONS(2244),
    [anon_sym_static_assert] = ACTIONS(2244),
    [anon_sym_concept] = ACTIONS(2244),
    [anon_sym_co_return] = ACTIONS(2244),
    [anon_sym_co_yield] = ACTIONS(2244),
    [anon_sym_R_DQUOTE] = ACTIONS(2246),
    [anon_sym_LR_DQUOTE] = ACTIONS(2246),
    [anon_sym_uR_DQUOTE] = ACTIONS(2246),
    [anon_sym_UR_DQUOTE] = ACTIONS(2246),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2246),
    [anon_sym_co_await] = ACTIONS(2244),
    [anon_sym_new] = ACTIONS(2244),
    [anon_sym_requires] = ACTIONS(2244),
    [sym_this] = ACTIONS(2244),
    [anon_sym_discard] = ACTIONS(2244),
    [anon_sym_precise] = ACTIONS(2244),
    [anon_sym_shared] = ACTIONS(2244),
    [anon_sym_groupshared] = ACTIONS(2244),
    [anon_sym_uniform] = ACTIONS(2244),
    [anon_sym_row_major] = ACTIONS(2244),
    [anon_sym_column_major] = ACTIONS(2244),
    [anon_sym_globallycoherent] = ACTIONS(2244),
    [anon_sym_centroid] = ACTIONS(2244),
    [anon_sym_noperspective] = ACTIONS(2244),
    [anon_sym_nointerpolation] = ACTIONS(2244),
    [anon_sym_sample] = ACTIONS(2244),
    [anon_sym_linear] = ACTIONS(2244),
    [anon_sym_snorm] = ACTIONS(2244),
    [anon_sym_unorm] = ACTIONS(2244),
    [anon_sym_point] = ACTIONS(2244),
    [anon_sym_line] = ACTIONS(2244),
    [anon_sym_triangleadj] = ACTIONS(2244),
    [anon_sym_lineadj] = ACTIONS(2244),
    [anon_sym_triangle] = ACTIONS(2244),
    [anon_sym_cbuffer] = ACTIONS(2244),
    [anon_sym_interface] = ACTIONS(2244),
    [anon_sym_extension] = ACTIONS(2244),
  },
  [346] = {
    [sym_identifier] = ACTIONS(2252),
    [aux_sym_preproc_include_token1] = ACTIONS(2252),
    [aux_sym_preproc_def_token1] = ACTIONS(2252),
    [aux_sym_preproc_if_token1] = ACTIONS(2252),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2252),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2252),
    [sym_preproc_directive] = ACTIONS(2252),
    [anon_sym_LPAREN2] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2254),
    [anon_sym_TILDE] = ACTIONS(2254),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2254),
    [anon_sym_AMP_AMP] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym_SEMI] = ACTIONS(2254),
    [anon_sym___extension__] = ACTIONS(2252),
    [anon_sym_typedef] = ACTIONS(2252),
    [anon_sym_in] = ACTIONS(2252),
    [anon_sym_out] = ACTIONS(2252),
    [anon_sym_inout] = ACTIONS(2252),
    [anon_sym_extern] = ACTIONS(2252),
    [anon_sym___attribute__] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2254),
    [anon_sym___declspec] = ACTIONS(2252),
    [anon_sym___based] = ACTIONS(2252),
    [anon_sym___cdecl] = ACTIONS(2252),
    [anon_sym___clrcall] = ACTIONS(2252),
    [anon_sym___stdcall] = ACTIONS(2252),
    [anon_sym___fastcall] = ACTIONS(2252),
    [anon_sym___thiscall] = ACTIONS(2252),
    [anon_sym___vectorcall] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_RBRACE] = ACTIONS(2254),
    [anon_sym_signed] = ACTIONS(2252),
    [anon_sym_unsigned] = ACTIONS(2252),
    [anon_sym_long] = ACTIONS(2252),
    [anon_sym_short] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2252),
    [anon_sym_register] = ACTIONS(2252),
    [anon_sym_inline] = ACTIONS(2252),
    [anon_sym___inline] = ACTIONS(2252),
    [anon_sym___inline__] = ACTIONS(2252),
    [anon_sym___forceinline] = ACTIONS(2252),
    [anon_sym_thread_local] = ACTIONS(2252),
    [anon_sym___thread] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2252),
    [anon_sym_constexpr] = ACTIONS(2252),
    [anon_sym_volatile] = ACTIONS(2252),
    [anon_sym_restrict] = ACTIONS(2252),
    [anon_sym___restrict__] = ACTIONS(2252),
    [anon_sym__Atomic] = ACTIONS(2252),
    [anon_sym__Noreturn] = ACTIONS(2252),
    [anon_sym_noreturn] = ACTIONS(2252),
    [anon_sym_mutable] = ACTIONS(2252),
    [anon_sym_constinit] = ACTIONS(2252),
    [anon_sym_consteval] = ACTIONS(2252),
    [anon_sym_alignas] = ACTIONS(2252),
    [anon_sym__Alignas] = ACTIONS(2252),
    [sym_primitive_type] = ACTIONS(2252),
    [anon_sym_enum] = ACTIONS(2252),
    [anon_sym_class] = ACTIONS(2252),
    [anon_sym_struct] = ACTIONS(2252),
    [anon_sym_union] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_else] = ACTIONS(2252),
    [anon_sym_switch] = ACTIONS(2252),
    [anon_sym_case] = ACTIONS(2252),
    [anon_sym_default] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_do] = ACTIONS(2252),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2252),
    [anon_sym_goto] = ACTIONS(2252),
    [anon_sym___try] = ACTIONS(2252),
    [anon_sym___leave] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2252),
    [anon_sym_compl] = ACTIONS(2252),
    [anon_sym_DASH_DASH] = ACTIONS(2254),
    [anon_sym_PLUS_PLUS] = ACTIONS(2254),
    [anon_sym_sizeof] = ACTIONS(2252),
    [anon_sym___alignof__] = ACTIONS(2252),
    [anon_sym___alignof] = ACTIONS(2252),
    [anon_sym__alignof] = ACTIONS(2252),
    [anon_sym_alignof] = ACTIONS(2252),
    [anon_sym__Alignof] = ACTIONS(2252),
    [anon_sym_offsetof] = ACTIONS(2252),
    [anon_sym__Generic] = ACTIONS(2252),
    [anon_sym_asm] = ACTIONS(2252),
    [anon_sym___asm__] = ACTIONS(2252),
    [anon_sym_DOT] = ACTIONS(2252),
    [sym_number_literal] = ACTIONS(2254),
    [anon_sym_L_SQUOTE] = ACTIONS(2254),
    [anon_sym_u_SQUOTE] = ACTIONS(2254),
    [anon_sym_U_SQUOTE] = ACTIONS(2254),
    [anon_sym_u8_SQUOTE] = ACTIONS(2254),
    [anon_sym_SQUOTE] = ACTIONS(2254),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2252),
    [sym_false] = ACTIONS(2252),
    [anon_sym_NULL] = ACTIONS(2252),
    [anon_sym_nullptr] = ACTIONS(2252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_This] = ACTIONS(2252),
    [anon_sym_decltype] = ACTIONS(2252),
    [anon_sym_final] = ACTIONS(2252),
    [anon_sym_override] = ACTIONS(2252),
    [sym_virtual] = ACTIONS(2252),
    [anon_sym_explicit] = ACTIONS(2252),
    [anon_sym_typename] = ACTIONS(2252),
    [anon_sym_template] = ACTIONS(2252),
    [anon_sym_operator] = ACTIONS(2252),
    [anon_sym_try] = ACTIONS(2252),
    [anon_sym_delete] = ACTIONS(2252),
    [anon_sym_throw] = ACTIONS(2252),
    [anon_sym_namespace] = ACTIONS(2252),
    [anon_sym_using] = ACTIONS(2252),
    [anon_sym_static_assert] = ACTIONS(2252),
    [anon_sym_concept] = ACTIONS(2252),
    [anon_sym_co_return] = ACTIONS(2252),
    [anon_sym_co_yield] = ACTIONS(2252),
    [anon_sym_R_DQUOTE] = ACTIONS(2254),
    [anon_sym_LR_DQUOTE] = ACTIONS(2254),
    [anon_sym_uR_DQUOTE] = ACTIONS(2254),
    [anon_sym_UR_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2254),
    [anon_sym_co_await] = ACTIONS(2252),
    [anon_sym_new] = ACTIONS(2252),
    [anon_sym_requires] = ACTIONS(2252),
    [sym_this] = ACTIONS(2252),
    [anon_sym_discard] = ACTIONS(2252),
    [anon_sym_precise] = ACTIONS(2252),
    [anon_sym_shared] = ACTIONS(2252),
    [anon_sym_groupshared] = ACTIONS(2252),
    [anon_sym_uniform] = ACTIONS(2252),
    [anon_sym_row_major] = ACTIONS(2252),
    [anon_sym_column_major] = ACTIONS(2252),
    [anon_sym_globallycoherent] = ACTIONS(2252),
    [anon_sym_centroid] = ACTIONS(2252),
    [anon_sym_noperspective] = ACTIONS(2252),
    [anon_sym_nointerpolation] = ACTIONS(2252),
    [anon_sym_sample] = ACTIONS(2252),
    [anon_sym_linear] = ACTIONS(2252),
    [anon_sym_snorm] = ACTIONS(2252),
    [anon_sym_unorm] = ACTIONS(2252),
    [anon_sym_point] = ACTIONS(2252),
    [anon_sym_line] = ACTIONS(2252),
    [anon_sym_triangleadj] = ACTIONS(2252),
    [anon_sym_lineadj] = ACTIONS(2252),
    [anon_sym_triangle] = ACTIONS(2252),
    [anon_sym_cbuffer] = ACTIONS(2252),
    [anon_sym_interface] = ACTIONS(2252),
    [anon_sym_extension] = ACTIONS(2252),
  },
  [347] = {
    [sym_identifier] = ACTIONS(2190),
    [aux_sym_preproc_include_token1] = ACTIONS(2190),
    [aux_sym_preproc_def_token1] = ACTIONS(2190),
    [aux_sym_preproc_if_token1] = ACTIONS(2190),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2190),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2190),
    [sym_preproc_directive] = ACTIONS(2190),
    [anon_sym_LPAREN2] = ACTIONS(2192),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2190),
    [anon_sym_PLUS] = ACTIONS(2190),
    [anon_sym_STAR] = ACTIONS(2192),
    [anon_sym_AMP_AMP] = ACTIONS(2192),
    [anon_sym_AMP] = ACTIONS(2190),
    [anon_sym_COLON] = ACTIONS(2190),
    [anon_sym_SEMI] = ACTIONS(2192),
    [anon_sym___extension__] = ACTIONS(2190),
    [anon_sym_typedef] = ACTIONS(2190),
    [anon_sym_in] = ACTIONS(2190),
    [anon_sym_out] = ACTIONS(2190),
    [anon_sym_inout] = ACTIONS(2190),
    [anon_sym_extern] = ACTIONS(2190),
    [anon_sym___attribute__] = ACTIONS(2190),
    [anon_sym_COLON_COLON] = ACTIONS(2192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2192),
    [anon_sym___declspec] = ACTIONS(2190),
    [anon_sym___based] = ACTIONS(2190),
    [anon_sym___cdecl] = ACTIONS(2190),
    [anon_sym___clrcall] = ACTIONS(2190),
    [anon_sym___stdcall] = ACTIONS(2190),
    [anon_sym___fastcall] = ACTIONS(2190),
    [anon_sym___thiscall] = ACTIONS(2190),
    [anon_sym___vectorcall] = ACTIONS(2190),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [anon_sym_RBRACE] = ACTIONS(2192),
    [anon_sym_signed] = ACTIONS(2190),
    [anon_sym_unsigned] = ACTIONS(2190),
    [anon_sym_long] = ACTIONS(2190),
    [anon_sym_short] = ACTIONS(2190),
    [anon_sym_LBRACK] = ACTIONS(2190),
    [anon_sym_static] = ACTIONS(2190),
    [anon_sym_register] = ACTIONS(2190),
    [anon_sym_inline] = ACTIONS(2190),
    [anon_sym___inline] = ACTIONS(2190),
    [anon_sym___inline__] = ACTIONS(2190),
    [anon_sym___forceinline] = ACTIONS(2190),
    [anon_sym_thread_local] = ACTIONS(2190),
    [anon_sym___thread] = ACTIONS(2190),
    [anon_sym_const] = ACTIONS(2190),
    [anon_sym_constexpr] = ACTIONS(2190),
    [anon_sym_volatile] = ACTIONS(2190),
    [anon_sym_restrict] = ACTIONS(2190),
    [anon_sym___restrict__] = ACTIONS(2190),
    [anon_sym__Atomic] = ACTIONS(2190),
    [anon_sym__Noreturn] = ACTIONS(2190),
    [anon_sym_noreturn] = ACTIONS(2190),
    [anon_sym_mutable] = ACTIONS(2190),
    [anon_sym_constinit] = ACTIONS(2190),
    [anon_sym_consteval] = ACTIONS(2190),
    [anon_sym_alignas] = ACTIONS(2190),
    [anon_sym__Alignas] = ACTIONS(2190),
    [sym_primitive_type] = ACTIONS(2190),
    [anon_sym_enum] = ACTIONS(2190),
    [anon_sym_class] = ACTIONS(2190),
    [anon_sym_struct] = ACTIONS(2190),
    [anon_sym_union] = ACTIONS(2190),
    [anon_sym_if] = ACTIONS(2190),
    [anon_sym_else] = ACTIONS(2190),
    [anon_sym_switch] = ACTIONS(2190),
    [anon_sym_case] = ACTIONS(2190),
    [anon_sym_default] = ACTIONS(2190),
    [anon_sym_while] = ACTIONS(2190),
    [anon_sym_do] = ACTIONS(2190),
    [anon_sym_for] = ACTIONS(2190),
    [anon_sym_return] = ACTIONS(2190),
    [anon_sym_break] = ACTIONS(2190),
    [anon_sym_continue] = ACTIONS(2190),
    [anon_sym_goto] = ACTIONS(2190),
    [anon_sym___try] = ACTIONS(2190),
    [anon_sym___leave] = ACTIONS(2190),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_compl] = ACTIONS(2190),
    [anon_sym_DASH_DASH] = ACTIONS(2192),
    [anon_sym_PLUS_PLUS] = ACTIONS(2192),
    [anon_sym_sizeof] = ACTIONS(2190),
    [anon_sym___alignof__] = ACTIONS(2190),
    [anon_sym___alignof] = ACTIONS(2190),
    [anon_sym__alignof] = ACTIONS(2190),
    [anon_sym_alignof] = ACTIONS(2190),
    [anon_sym__Alignof] = ACTIONS(2190),
    [anon_sym_offsetof] = ACTIONS(2190),
    [anon_sym__Generic] = ACTIONS(2190),
    [anon_sym_asm] = ACTIONS(2190),
    [anon_sym___asm__] = ACTIONS(2190),
    [anon_sym_DOT] = ACTIONS(2190),
    [sym_number_literal] = ACTIONS(2192),
    [anon_sym_L_SQUOTE] = ACTIONS(2192),
    [anon_sym_u_SQUOTE] = ACTIONS(2192),
    [anon_sym_U_SQUOTE] = ACTIONS(2192),
    [anon_sym_u8_SQUOTE] = ACTIONS(2192),
    [anon_sym_SQUOTE] = ACTIONS(2192),
    [anon_sym_L_DQUOTE] = ACTIONS(2192),
    [anon_sym_u_DQUOTE] = ACTIONS(2192),
    [anon_sym_U_DQUOTE] = ACTIONS(2192),
    [anon_sym_u8_DQUOTE] = ACTIONS(2192),
    [anon_sym_DQUOTE] = ACTIONS(2192),
    [sym_true] = ACTIONS(2190),
    [sym_false] = ACTIONS(2190),
    [anon_sym_NULL] = ACTIONS(2190),
    [anon_sym_nullptr] = ACTIONS(2190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2190),
    [anon_sym_let] = ACTIONS(2190),
    [anon_sym_This] = ACTIONS(2190),
    [anon_sym_decltype] = ACTIONS(2190),
    [anon_sym_final] = ACTIONS(2190),
    [anon_sym_override] = ACTIONS(2190),
    [sym_virtual] = ACTIONS(2190),
    [anon_sym_explicit] = ACTIONS(2190),
    [anon_sym_typename] = ACTIONS(2190),
    [anon_sym_template] = ACTIONS(2190),
    [anon_sym_operator] = ACTIONS(2190),
    [anon_sym_try] = ACTIONS(2190),
    [anon_sym_delete] = ACTIONS(2190),
    [anon_sym_throw] = ACTIONS(2190),
    [anon_sym_namespace] = ACTIONS(2190),
    [anon_sym_using] = ACTIONS(2190),
    [anon_sym_static_assert] = ACTIONS(2190),
    [anon_sym_concept] = ACTIONS(2190),
    [anon_sym_co_return] = ACTIONS(2190),
    [anon_sym_co_yield] = ACTIONS(2190),
    [anon_sym_R_DQUOTE] = ACTIONS(2192),
    [anon_sym_LR_DQUOTE] = ACTIONS(2192),
    [anon_sym_uR_DQUOTE] = ACTIONS(2192),
    [anon_sym_UR_DQUOTE] = ACTIONS(2192),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2192),
    [anon_sym_co_await] = ACTIONS(2190),
    [anon_sym_new] = ACTIONS(2190),
    [anon_sym_requires] = ACTIONS(2190),
    [sym_this] = ACTIONS(2190),
    [anon_sym_discard] = ACTIONS(2190),
    [anon_sym_precise] = ACTIONS(2190),
    [anon_sym_shared] = ACTIONS(2190),
    [anon_sym_groupshared] = ACTIONS(2190),
    [anon_sym_uniform] = ACTIONS(2190),
    [anon_sym_row_major] = ACTIONS(2190),
    [anon_sym_column_major] = ACTIONS(2190),
    [anon_sym_globallycoherent] = ACTIONS(2190),
    [anon_sym_centroid] = ACTIONS(2190),
    [anon_sym_noperspective] = ACTIONS(2190),
    [anon_sym_nointerpolation] = ACTIONS(2190),
    [anon_sym_sample] = ACTIONS(2190),
    [anon_sym_linear] = ACTIONS(2190),
    [anon_sym_snorm] = ACTIONS(2190),
    [anon_sym_unorm] = ACTIONS(2190),
    [anon_sym_point] = ACTIONS(2190),
    [anon_sym_line] = ACTIONS(2190),
    [anon_sym_triangleadj] = ACTIONS(2190),
    [anon_sym_lineadj] = ACTIONS(2190),
    [anon_sym_triangle] = ACTIONS(2190),
    [anon_sym_cbuffer] = ACTIONS(2190),
    [anon_sym_interface] = ACTIONS(2190),
    [anon_sym_extension] = ACTIONS(2190),
  },
  [348] = {
    [sym_identifier] = ACTIONS(3034),
    [aux_sym_preproc_include_token1] = ACTIONS(3034),
    [aux_sym_preproc_def_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token2] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3034),
    [aux_sym_preproc_else_token1] = ACTIONS(3034),
    [aux_sym_preproc_elif_token1] = ACTIONS(3034),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_BANG] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3034),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_in] = ACTIONS(3034),
    [anon_sym_out] = ACTIONS(3034),
    [anon_sym_inout] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym___based] = ACTIONS(3034),
    [anon_sym___cdecl] = ACTIONS(3034),
    [anon_sym___clrcall] = ACTIONS(3034),
    [anon_sym___stdcall] = ACTIONS(3034),
    [anon_sym___fastcall] = ACTIONS(3034),
    [anon_sym___thiscall] = ACTIONS(3034),
    [anon_sym___vectorcall] = ACTIONS(3034),
    [anon_sym_LBRACE] = ACTIONS(3036),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [anon_sym_if] = ACTIONS(3034),
    [anon_sym_else] = ACTIONS(3034),
    [anon_sym_switch] = ACTIONS(3034),
    [anon_sym_case] = ACTIONS(3034),
    [anon_sym_default] = ACTIONS(3034),
    [anon_sym_while] = ACTIONS(3034),
    [anon_sym_do] = ACTIONS(3034),
    [anon_sym_for] = ACTIONS(3034),
    [anon_sym_return] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3034),
    [anon_sym_continue] = ACTIONS(3034),
    [anon_sym_goto] = ACTIONS(3034),
    [anon_sym___try] = ACTIONS(3034),
    [anon_sym___leave] = ACTIONS(3034),
    [anon_sym_not] = ACTIONS(3034),
    [anon_sym_compl] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_sizeof] = ACTIONS(3034),
    [anon_sym___alignof__] = ACTIONS(3034),
    [anon_sym___alignof] = ACTIONS(3034),
    [anon_sym__alignof] = ACTIONS(3034),
    [anon_sym_alignof] = ACTIONS(3034),
    [anon_sym__Alignof] = ACTIONS(3034),
    [anon_sym_offsetof] = ACTIONS(3034),
    [anon_sym__Generic] = ACTIONS(3034),
    [anon_sym_asm] = ACTIONS(3034),
    [anon_sym___asm__] = ACTIONS(3034),
    [sym_number_literal] = ACTIONS(3036),
    [anon_sym_L_SQUOTE] = ACTIONS(3036),
    [anon_sym_u_SQUOTE] = ACTIONS(3036),
    [anon_sym_U_SQUOTE] = ACTIONS(3036),
    [anon_sym_u8_SQUOTE] = ACTIONS(3036),
    [anon_sym_SQUOTE] = ACTIONS(3036),
    [anon_sym_L_DQUOTE] = ACTIONS(3036),
    [anon_sym_u_DQUOTE] = ACTIONS(3036),
    [anon_sym_U_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8_DQUOTE] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [sym_true] = ACTIONS(3034),
    [sym_false] = ACTIONS(3034),
    [anon_sym_NULL] = ACTIONS(3034),
    [anon_sym_nullptr] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_This] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [sym_virtual] = ACTIONS(3034),
    [anon_sym_explicit] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_operator] = ACTIONS(3034),
    [anon_sym_try] = ACTIONS(3034),
    [anon_sym_delete] = ACTIONS(3034),
    [anon_sym_throw] = ACTIONS(3034),
    [anon_sym_namespace] = ACTIONS(3034),
    [anon_sym_using] = ACTIONS(3034),
    [anon_sym_static_assert] = ACTIONS(3034),
    [anon_sym_concept] = ACTIONS(3034),
    [anon_sym_co_return] = ACTIONS(3034),
    [anon_sym_co_yield] = ACTIONS(3034),
    [anon_sym_R_DQUOTE] = ACTIONS(3036),
    [anon_sym_LR_DQUOTE] = ACTIONS(3036),
    [anon_sym_uR_DQUOTE] = ACTIONS(3036),
    [anon_sym_UR_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3036),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3034),
    [anon_sym_requires] = ACTIONS(3034),
    [sym_this] = ACTIONS(3034),
    [anon_sym_discard] = ACTIONS(3034),
    [anon_sym_precise] = ACTIONS(3034),
    [anon_sym_shared] = ACTIONS(3034),
    [anon_sym_groupshared] = ACTIONS(3034),
    [anon_sym_uniform] = ACTIONS(3034),
    [anon_sym_row_major] = ACTIONS(3034),
    [anon_sym_column_major] = ACTIONS(3034),
    [anon_sym_globallycoherent] = ACTIONS(3034),
    [anon_sym_centroid] = ACTIONS(3034),
    [anon_sym_noperspective] = ACTIONS(3034),
    [anon_sym_nointerpolation] = ACTIONS(3034),
    [anon_sym_sample] = ACTIONS(3034),
    [anon_sym_linear] = ACTIONS(3034),
    [anon_sym_snorm] = ACTIONS(3034),
    [anon_sym_unorm] = ACTIONS(3034),
    [anon_sym_point] = ACTIONS(3034),
    [anon_sym_line] = ACTIONS(3034),
    [anon_sym_triangleadj] = ACTIONS(3034),
    [anon_sym_lineadj] = ACTIONS(3034),
    [anon_sym_triangle] = ACTIONS(3034),
    [anon_sym_cbuffer] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3034),
    [anon_sym_extension] = ACTIONS(3034),
  },
  [349] = {
    [ts_builtin_sym_end] = ACTIONS(3068),
    [sym_identifier] = ACTIONS(3070),
    [aux_sym_preproc_include_token1] = ACTIONS(3070),
    [aux_sym_preproc_def_token1] = ACTIONS(3070),
    [anon_sym_COMMA] = ACTIONS(3068),
    [anon_sym_RPAREN] = ACTIONS(3068),
    [aux_sym_preproc_if_token1] = ACTIONS(3070),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3070),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3070),
    [sym_preproc_directive] = ACTIONS(3070),
    [anon_sym_LPAREN2] = ACTIONS(3068),
    [anon_sym_BANG] = ACTIONS(3068),
    [anon_sym_TILDE] = ACTIONS(3068),
    [anon_sym_DASH] = ACTIONS(3070),
    [anon_sym_PLUS] = ACTIONS(3070),
    [anon_sym_STAR] = ACTIONS(3068),
    [anon_sym_AMP_AMP] = ACTIONS(3068),
    [anon_sym_AMP] = ACTIONS(3070),
    [anon_sym_SEMI] = ACTIONS(3068),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3070),
    [anon_sym_in] = ACTIONS(3070),
    [anon_sym_out] = ACTIONS(3070),
    [anon_sym_inout] = ACTIONS(3070),
    [anon_sym_extern] = ACTIONS(3070),
    [anon_sym___attribute__] = ACTIONS(3070),
    [anon_sym_COLON_COLON] = ACTIONS(3068),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3068),
    [anon_sym___declspec] = ACTIONS(3070),
    [anon_sym___based] = ACTIONS(3070),
    [anon_sym___cdecl] = ACTIONS(3070),
    [anon_sym___clrcall] = ACTIONS(3070),
    [anon_sym___stdcall] = ACTIONS(3070),
    [anon_sym___fastcall] = ACTIONS(3070),
    [anon_sym___thiscall] = ACTIONS(3070),
    [anon_sym___vectorcall] = ACTIONS(3070),
    [anon_sym_LBRACE] = ACTIONS(3068),
    [anon_sym_signed] = ACTIONS(3070),
    [anon_sym_unsigned] = ACTIONS(3070),
    [anon_sym_long] = ACTIONS(3070),
    [anon_sym_short] = ACTIONS(3070),
    [anon_sym_LBRACK] = ACTIONS(3070),
    [anon_sym_static] = ACTIONS(3070),
    [anon_sym_register] = ACTIONS(3070),
    [anon_sym_inline] = ACTIONS(3070),
    [anon_sym___inline] = ACTIONS(3070),
    [anon_sym___inline__] = ACTIONS(3070),
    [anon_sym___forceinline] = ACTIONS(3070),
    [anon_sym_thread_local] = ACTIONS(3070),
    [anon_sym___thread] = ACTIONS(3070),
    [anon_sym_const] = ACTIONS(3070),
    [anon_sym_constexpr] = ACTIONS(3070),
    [anon_sym_volatile] = ACTIONS(3070),
    [anon_sym_restrict] = ACTIONS(3070),
    [anon_sym___restrict__] = ACTIONS(3070),
    [anon_sym__Atomic] = ACTIONS(3070),
    [anon_sym__Noreturn] = ACTIONS(3070),
    [anon_sym_noreturn] = ACTIONS(3070),
    [anon_sym_mutable] = ACTIONS(3070),
    [anon_sym_constinit] = ACTIONS(3070),
    [anon_sym_consteval] = ACTIONS(3070),
    [anon_sym_alignas] = ACTIONS(3070),
    [anon_sym__Alignas] = ACTIONS(3070),
    [sym_primitive_type] = ACTIONS(3070),
    [anon_sym_enum] = ACTIONS(3070),
    [anon_sym_class] = ACTIONS(3070),
    [anon_sym_struct] = ACTIONS(3070),
    [anon_sym_union] = ACTIONS(3070),
    [anon_sym_if] = ACTIONS(3070),
    [anon_sym_switch] = ACTIONS(3070),
    [anon_sym_case] = ACTIONS(3070),
    [anon_sym_default] = ACTIONS(3070),
    [anon_sym_while] = ACTIONS(3070),
    [anon_sym_do] = ACTIONS(3070),
    [anon_sym_for] = ACTIONS(3070),
    [anon_sym_return] = ACTIONS(3070),
    [anon_sym_break] = ACTIONS(3070),
    [anon_sym_continue] = ACTIONS(3070),
    [anon_sym_goto] = ACTIONS(3070),
    [anon_sym_not] = ACTIONS(3070),
    [anon_sym_compl] = ACTIONS(3070),
    [anon_sym_DASH_DASH] = ACTIONS(3068),
    [anon_sym_PLUS_PLUS] = ACTIONS(3068),
    [anon_sym_sizeof] = ACTIONS(3070),
    [anon_sym___alignof__] = ACTIONS(3070),
    [anon_sym___alignof] = ACTIONS(3070),
    [anon_sym__alignof] = ACTIONS(3070),
    [anon_sym_alignof] = ACTIONS(3070),
    [anon_sym__Alignof] = ACTIONS(3070),
    [anon_sym_offsetof] = ACTIONS(3070),
    [anon_sym__Generic] = ACTIONS(3070),
    [anon_sym_asm] = ACTIONS(3070),
    [anon_sym___asm__] = ACTIONS(3070),
    [anon_sym_DOT] = ACTIONS(3070),
    [sym_number_literal] = ACTIONS(3068),
    [anon_sym_L_SQUOTE] = ACTIONS(3068),
    [anon_sym_u_SQUOTE] = ACTIONS(3068),
    [anon_sym_U_SQUOTE] = ACTIONS(3068),
    [anon_sym_u8_SQUOTE] = ACTIONS(3068),
    [anon_sym_SQUOTE] = ACTIONS(3068),
    [anon_sym_L_DQUOTE] = ACTIONS(3068),
    [anon_sym_u_DQUOTE] = ACTIONS(3068),
    [anon_sym_U_DQUOTE] = ACTIONS(3068),
    [anon_sym_u8_DQUOTE] = ACTIONS(3068),
    [anon_sym_DQUOTE] = ACTIONS(3068),
    [sym_true] = ACTIONS(3070),
    [sym_false] = ACTIONS(3070),
    [anon_sym_NULL] = ACTIONS(3070),
    [anon_sym_nullptr] = ACTIONS(3070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3070),
    [anon_sym_let] = ACTIONS(3070),
    [anon_sym_This] = ACTIONS(3070),
    [anon_sym_decltype] = ACTIONS(3070),
    [anon_sym_final] = ACTIONS(3070),
    [anon_sym_override] = ACTIONS(3070),
    [sym_virtual] = ACTIONS(3070),
    [anon_sym_explicit] = ACTIONS(3070),
    [anon_sym_typename] = ACTIONS(3070),
    [anon_sym_template] = ACTIONS(3070),
    [anon_sym_GT2] = ACTIONS(3068),
    [anon_sym_operator] = ACTIONS(3070),
    [anon_sym_try] = ACTIONS(3070),
    [anon_sym_delete] = ACTIONS(3070),
    [anon_sym_throw] = ACTIONS(3070),
    [anon_sym_namespace] = ACTIONS(3070),
    [anon_sym_using] = ACTIONS(3070),
    [anon_sym_static_assert] = ACTIONS(3070),
    [anon_sym_concept] = ACTIONS(3070),
    [anon_sym_co_return] = ACTIONS(3070),
    [anon_sym_co_yield] = ACTIONS(3070),
    [anon_sym_R_DQUOTE] = ACTIONS(3068),
    [anon_sym_LR_DQUOTE] = ACTIONS(3068),
    [anon_sym_uR_DQUOTE] = ACTIONS(3068),
    [anon_sym_UR_DQUOTE] = ACTIONS(3068),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3068),
    [anon_sym_co_await] = ACTIONS(3070),
    [anon_sym_new] = ACTIONS(3070),
    [anon_sym_requires] = ACTIONS(3070),
    [sym_this] = ACTIONS(3070),
    [anon_sym_precise] = ACTIONS(3070),
    [anon_sym_shared] = ACTIONS(3070),
    [anon_sym_groupshared] = ACTIONS(3070),
    [anon_sym_uniform] = ACTIONS(3070),
    [anon_sym_row_major] = ACTIONS(3070),
    [anon_sym_column_major] = ACTIONS(3070),
    [anon_sym_globallycoherent] = ACTIONS(3070),
    [anon_sym_centroid] = ACTIONS(3070),
    [anon_sym_noperspective] = ACTIONS(3070),
    [anon_sym_nointerpolation] = ACTIONS(3070),
    [anon_sym_sample] = ACTIONS(3070),
    [anon_sym_linear] = ACTIONS(3070),
    [anon_sym_snorm] = ACTIONS(3070),
    [anon_sym_unorm] = ACTIONS(3070),
    [anon_sym_point] = ACTIONS(3070),
    [anon_sym_line] = ACTIONS(3070),
    [anon_sym_triangleadj] = ACTIONS(3070),
    [anon_sym_lineadj] = ACTIONS(3070),
    [anon_sym_triangle] = ACTIONS(3070),
    [anon_sym_interface] = ACTIONS(3070),
    [anon_sym_extension] = ACTIONS(3070),
    [anon_sym_where] = ACTIONS(3070),
    [anon_sym___exported] = ACTIONS(3070),
    [anon_sym_import] = ACTIONS(3070),
  },
  [350] = {
    [sym_identifier] = ACTIONS(2194),
    [aux_sym_preproc_include_token1] = ACTIONS(2194),
    [aux_sym_preproc_def_token1] = ACTIONS(2194),
    [aux_sym_preproc_if_token1] = ACTIONS(2194),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2194),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2194),
    [sym_preproc_directive] = ACTIONS(2194),
    [anon_sym_LPAREN2] = ACTIONS(2196),
    [anon_sym_BANG] = ACTIONS(2196),
    [anon_sym_TILDE] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2194),
    [anon_sym_PLUS] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(2196),
    [anon_sym_AMP_AMP] = ACTIONS(2196),
    [anon_sym_AMP] = ACTIONS(2194),
    [anon_sym_COLON] = ACTIONS(2194),
    [anon_sym_SEMI] = ACTIONS(2196),
    [anon_sym___extension__] = ACTIONS(2194),
    [anon_sym_typedef] = ACTIONS(2194),
    [anon_sym_in] = ACTIONS(2194),
    [anon_sym_out] = ACTIONS(2194),
    [anon_sym_inout] = ACTIONS(2194),
    [anon_sym_extern] = ACTIONS(2194),
    [anon_sym___attribute__] = ACTIONS(2194),
    [anon_sym_COLON_COLON] = ACTIONS(2196),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2196),
    [anon_sym___declspec] = ACTIONS(2194),
    [anon_sym___based] = ACTIONS(2194),
    [anon_sym___cdecl] = ACTIONS(2194),
    [anon_sym___clrcall] = ACTIONS(2194),
    [anon_sym___stdcall] = ACTIONS(2194),
    [anon_sym___fastcall] = ACTIONS(2194),
    [anon_sym___thiscall] = ACTIONS(2194),
    [anon_sym___vectorcall] = ACTIONS(2194),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_RBRACE] = ACTIONS(2196),
    [anon_sym_signed] = ACTIONS(2194),
    [anon_sym_unsigned] = ACTIONS(2194),
    [anon_sym_long] = ACTIONS(2194),
    [anon_sym_short] = ACTIONS(2194),
    [anon_sym_LBRACK] = ACTIONS(2194),
    [anon_sym_static] = ACTIONS(2194),
    [anon_sym_register] = ACTIONS(2194),
    [anon_sym_inline] = ACTIONS(2194),
    [anon_sym___inline] = ACTIONS(2194),
    [anon_sym___inline__] = ACTIONS(2194),
    [anon_sym___forceinline] = ACTIONS(2194),
    [anon_sym_thread_local] = ACTIONS(2194),
    [anon_sym___thread] = ACTIONS(2194),
    [anon_sym_const] = ACTIONS(2194),
    [anon_sym_constexpr] = ACTIONS(2194),
    [anon_sym_volatile] = ACTIONS(2194),
    [anon_sym_restrict] = ACTIONS(2194),
    [anon_sym___restrict__] = ACTIONS(2194),
    [anon_sym__Atomic] = ACTIONS(2194),
    [anon_sym__Noreturn] = ACTIONS(2194),
    [anon_sym_noreturn] = ACTIONS(2194),
    [anon_sym_mutable] = ACTIONS(2194),
    [anon_sym_constinit] = ACTIONS(2194),
    [anon_sym_consteval] = ACTIONS(2194),
    [anon_sym_alignas] = ACTIONS(2194),
    [anon_sym__Alignas] = ACTIONS(2194),
    [sym_primitive_type] = ACTIONS(2194),
    [anon_sym_enum] = ACTIONS(2194),
    [anon_sym_class] = ACTIONS(2194),
    [anon_sym_struct] = ACTIONS(2194),
    [anon_sym_union] = ACTIONS(2194),
    [anon_sym_if] = ACTIONS(2194),
    [anon_sym_else] = ACTIONS(2194),
    [anon_sym_switch] = ACTIONS(2194),
    [anon_sym_case] = ACTIONS(2194),
    [anon_sym_default] = ACTIONS(2194),
    [anon_sym_while] = ACTIONS(2194),
    [anon_sym_do] = ACTIONS(2194),
    [anon_sym_for] = ACTIONS(2194),
    [anon_sym_return] = ACTIONS(2194),
    [anon_sym_break] = ACTIONS(2194),
    [anon_sym_continue] = ACTIONS(2194),
    [anon_sym_goto] = ACTIONS(2194),
    [anon_sym___try] = ACTIONS(2194),
    [anon_sym___leave] = ACTIONS(2194),
    [anon_sym_not] = ACTIONS(2194),
    [anon_sym_compl] = ACTIONS(2194),
    [anon_sym_DASH_DASH] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2196),
    [anon_sym_sizeof] = ACTIONS(2194),
    [anon_sym___alignof__] = ACTIONS(2194),
    [anon_sym___alignof] = ACTIONS(2194),
    [anon_sym__alignof] = ACTIONS(2194),
    [anon_sym_alignof] = ACTIONS(2194),
    [anon_sym__Alignof] = ACTIONS(2194),
    [anon_sym_offsetof] = ACTIONS(2194),
    [anon_sym__Generic] = ACTIONS(2194),
    [anon_sym_asm] = ACTIONS(2194),
    [anon_sym___asm__] = ACTIONS(2194),
    [anon_sym_DOT] = ACTIONS(2194),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_L_SQUOTE] = ACTIONS(2196),
    [anon_sym_u_SQUOTE] = ACTIONS(2196),
    [anon_sym_U_SQUOTE] = ACTIONS(2196),
    [anon_sym_u8_SQUOTE] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(2196),
    [anon_sym_L_DQUOTE] = ACTIONS(2196),
    [anon_sym_u_DQUOTE] = ACTIONS(2196),
    [anon_sym_U_DQUOTE] = ACTIONS(2196),
    [anon_sym_u8_DQUOTE] = ACTIONS(2196),
    [anon_sym_DQUOTE] = ACTIONS(2196),
    [sym_true] = ACTIONS(2194),
    [sym_false] = ACTIONS(2194),
    [anon_sym_NULL] = ACTIONS(2194),
    [anon_sym_nullptr] = ACTIONS(2194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2194),
    [anon_sym_let] = ACTIONS(2194),
    [anon_sym_This] = ACTIONS(2194),
    [anon_sym_decltype] = ACTIONS(2194),
    [anon_sym_final] = ACTIONS(2194),
    [anon_sym_override] = ACTIONS(2194),
    [sym_virtual] = ACTIONS(2194),
    [anon_sym_explicit] = ACTIONS(2194),
    [anon_sym_typename] = ACTIONS(2194),
    [anon_sym_template] = ACTIONS(2194),
    [anon_sym_operator] = ACTIONS(2194),
    [anon_sym_try] = ACTIONS(2194),
    [anon_sym_delete] = ACTIONS(2194),
    [anon_sym_throw] = ACTIONS(2194),
    [anon_sym_namespace] = ACTIONS(2194),
    [anon_sym_using] = ACTIONS(2194),
    [anon_sym_static_assert] = ACTIONS(2194),
    [anon_sym_concept] = ACTIONS(2194),
    [anon_sym_co_return] = ACTIONS(2194),
    [anon_sym_co_yield] = ACTIONS(2194),
    [anon_sym_R_DQUOTE] = ACTIONS(2196),
    [anon_sym_LR_DQUOTE] = ACTIONS(2196),
    [anon_sym_uR_DQUOTE] = ACTIONS(2196),
    [anon_sym_UR_DQUOTE] = ACTIONS(2196),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2196),
    [anon_sym_co_await] = ACTIONS(2194),
    [anon_sym_new] = ACTIONS(2194),
    [anon_sym_requires] = ACTIONS(2194),
    [sym_this] = ACTIONS(2194),
    [anon_sym_discard] = ACTIONS(2194),
    [anon_sym_precise] = ACTIONS(2194),
    [anon_sym_shared] = ACTIONS(2194),
    [anon_sym_groupshared] = ACTIONS(2194),
    [anon_sym_uniform] = ACTIONS(2194),
    [anon_sym_row_major] = ACTIONS(2194),
    [anon_sym_column_major] = ACTIONS(2194),
    [anon_sym_globallycoherent] = ACTIONS(2194),
    [anon_sym_centroid] = ACTIONS(2194),
    [anon_sym_noperspective] = ACTIONS(2194),
    [anon_sym_nointerpolation] = ACTIONS(2194),
    [anon_sym_sample] = ACTIONS(2194),
    [anon_sym_linear] = ACTIONS(2194),
    [anon_sym_snorm] = ACTIONS(2194),
    [anon_sym_unorm] = ACTIONS(2194),
    [anon_sym_point] = ACTIONS(2194),
    [anon_sym_line] = ACTIONS(2194),
    [anon_sym_triangleadj] = ACTIONS(2194),
    [anon_sym_lineadj] = ACTIONS(2194),
    [anon_sym_triangle] = ACTIONS(2194),
    [anon_sym_cbuffer] = ACTIONS(2194),
    [anon_sym_interface] = ACTIONS(2194),
    [anon_sym_extension] = ACTIONS(2194),
  },
  [351] = {
    [sym_identifier] = ACTIONS(2240),
    [aux_sym_preproc_include_token1] = ACTIONS(2240),
    [aux_sym_preproc_def_token1] = ACTIONS(2240),
    [aux_sym_preproc_if_token1] = ACTIONS(2240),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2240),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2240),
    [sym_preproc_directive] = ACTIONS(2240),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2242),
    [anon_sym_TILDE] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2240),
    [anon_sym_PLUS] = ACTIONS(2240),
    [anon_sym_STAR] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_AMP] = ACTIONS(2240),
    [anon_sym_COLON] = ACTIONS(2240),
    [anon_sym_SEMI] = ACTIONS(2242),
    [anon_sym___extension__] = ACTIONS(2240),
    [anon_sym_typedef] = ACTIONS(2240),
    [anon_sym_in] = ACTIONS(2240),
    [anon_sym_out] = ACTIONS(2240),
    [anon_sym_inout] = ACTIONS(2240),
    [anon_sym_extern] = ACTIONS(2240),
    [anon_sym___attribute__] = ACTIONS(2240),
    [anon_sym_COLON_COLON] = ACTIONS(2242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2242),
    [anon_sym___declspec] = ACTIONS(2240),
    [anon_sym___based] = ACTIONS(2240),
    [anon_sym___cdecl] = ACTIONS(2240),
    [anon_sym___clrcall] = ACTIONS(2240),
    [anon_sym___stdcall] = ACTIONS(2240),
    [anon_sym___fastcall] = ACTIONS(2240),
    [anon_sym___thiscall] = ACTIONS(2240),
    [anon_sym___vectorcall] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_RBRACE] = ACTIONS(2242),
    [anon_sym_signed] = ACTIONS(2240),
    [anon_sym_unsigned] = ACTIONS(2240),
    [anon_sym_long] = ACTIONS(2240),
    [anon_sym_short] = ACTIONS(2240),
    [anon_sym_LBRACK] = ACTIONS(2240),
    [anon_sym_static] = ACTIONS(2240),
    [anon_sym_register] = ACTIONS(2240),
    [anon_sym_inline] = ACTIONS(2240),
    [anon_sym___inline] = ACTIONS(2240),
    [anon_sym___inline__] = ACTIONS(2240),
    [anon_sym___forceinline] = ACTIONS(2240),
    [anon_sym_thread_local] = ACTIONS(2240),
    [anon_sym___thread] = ACTIONS(2240),
    [anon_sym_const] = ACTIONS(2240),
    [anon_sym_constexpr] = ACTIONS(2240),
    [anon_sym_volatile] = ACTIONS(2240),
    [anon_sym_restrict] = ACTIONS(2240),
    [anon_sym___restrict__] = ACTIONS(2240),
    [anon_sym__Atomic] = ACTIONS(2240),
    [anon_sym__Noreturn] = ACTIONS(2240),
    [anon_sym_noreturn] = ACTIONS(2240),
    [anon_sym_mutable] = ACTIONS(2240),
    [anon_sym_constinit] = ACTIONS(2240),
    [anon_sym_consteval] = ACTIONS(2240),
    [anon_sym_alignas] = ACTIONS(2240),
    [anon_sym__Alignas] = ACTIONS(2240),
    [sym_primitive_type] = ACTIONS(2240),
    [anon_sym_enum] = ACTIONS(2240),
    [anon_sym_class] = ACTIONS(2240),
    [anon_sym_struct] = ACTIONS(2240),
    [anon_sym_union] = ACTIONS(2240),
    [anon_sym_if] = ACTIONS(2240),
    [anon_sym_else] = ACTIONS(2240),
    [anon_sym_switch] = ACTIONS(2240),
    [anon_sym_case] = ACTIONS(2240),
    [anon_sym_default] = ACTIONS(2240),
    [anon_sym_while] = ACTIONS(2240),
    [anon_sym_do] = ACTIONS(2240),
    [anon_sym_for] = ACTIONS(2240),
    [anon_sym_return] = ACTIONS(2240),
    [anon_sym_break] = ACTIONS(2240),
    [anon_sym_continue] = ACTIONS(2240),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym___try] = ACTIONS(2240),
    [anon_sym___leave] = ACTIONS(2240),
    [anon_sym_not] = ACTIONS(2240),
    [anon_sym_compl] = ACTIONS(2240),
    [anon_sym_DASH_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_PLUS] = ACTIONS(2242),
    [anon_sym_sizeof] = ACTIONS(2240),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2240),
    [anon_sym__Generic] = ACTIONS(2240),
    [anon_sym_asm] = ACTIONS(2240),
    [anon_sym___asm__] = ACTIONS(2240),
    [anon_sym_DOT] = ACTIONS(2240),
    [sym_number_literal] = ACTIONS(2242),
    [anon_sym_L_SQUOTE] = ACTIONS(2242),
    [anon_sym_u_SQUOTE] = ACTIONS(2242),
    [anon_sym_U_SQUOTE] = ACTIONS(2242),
    [anon_sym_u8_SQUOTE] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(2242),
    [anon_sym_L_DQUOTE] = ACTIONS(2242),
    [anon_sym_u_DQUOTE] = ACTIONS(2242),
    [anon_sym_U_DQUOTE] = ACTIONS(2242),
    [anon_sym_u8_DQUOTE] = ACTIONS(2242),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [sym_true] = ACTIONS(2240),
    [sym_false] = ACTIONS(2240),
    [anon_sym_NULL] = ACTIONS(2240),
    [anon_sym_nullptr] = ACTIONS(2240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2240),
    [anon_sym_let] = ACTIONS(2240),
    [anon_sym_This] = ACTIONS(2240),
    [anon_sym_decltype] = ACTIONS(2240),
    [anon_sym_final] = ACTIONS(2240),
    [anon_sym_override] = ACTIONS(2240),
    [sym_virtual] = ACTIONS(2240),
    [anon_sym_explicit] = ACTIONS(2240),
    [anon_sym_typename] = ACTIONS(2240),
    [anon_sym_template] = ACTIONS(2240),
    [anon_sym_operator] = ACTIONS(2240),
    [anon_sym_try] = ACTIONS(2240),
    [anon_sym_delete] = ACTIONS(2240),
    [anon_sym_throw] = ACTIONS(2240),
    [anon_sym_namespace] = ACTIONS(2240),
    [anon_sym_using] = ACTIONS(2240),
    [anon_sym_static_assert] = ACTIONS(2240),
    [anon_sym_concept] = ACTIONS(2240),
    [anon_sym_co_return] = ACTIONS(2240),
    [anon_sym_co_yield] = ACTIONS(2240),
    [anon_sym_R_DQUOTE] = ACTIONS(2242),
    [anon_sym_LR_DQUOTE] = ACTIONS(2242),
    [anon_sym_uR_DQUOTE] = ACTIONS(2242),
    [anon_sym_UR_DQUOTE] = ACTIONS(2242),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2242),
    [anon_sym_co_await] = ACTIONS(2240),
    [anon_sym_new] = ACTIONS(2240),
    [anon_sym_requires] = ACTIONS(2240),
    [sym_this] = ACTIONS(2240),
    [anon_sym_discard] = ACTIONS(2240),
    [anon_sym_precise] = ACTIONS(2240),
    [anon_sym_shared] = ACTIONS(2240),
    [anon_sym_groupshared] = ACTIONS(2240),
    [anon_sym_uniform] = ACTIONS(2240),
    [anon_sym_row_major] = ACTIONS(2240),
    [anon_sym_column_major] = ACTIONS(2240),
    [anon_sym_globallycoherent] = ACTIONS(2240),
    [anon_sym_centroid] = ACTIONS(2240),
    [anon_sym_noperspective] = ACTIONS(2240),
    [anon_sym_nointerpolation] = ACTIONS(2240),
    [anon_sym_sample] = ACTIONS(2240),
    [anon_sym_linear] = ACTIONS(2240),
    [anon_sym_snorm] = ACTIONS(2240),
    [anon_sym_unorm] = ACTIONS(2240),
    [anon_sym_point] = ACTIONS(2240),
    [anon_sym_line] = ACTIONS(2240),
    [anon_sym_triangleadj] = ACTIONS(2240),
    [anon_sym_lineadj] = ACTIONS(2240),
    [anon_sym_triangle] = ACTIONS(2240),
    [anon_sym_cbuffer] = ACTIONS(2240),
    [anon_sym_interface] = ACTIONS(2240),
    [anon_sym_extension] = ACTIONS(2240),
  },
  [352] = {
    [sym_identifier] = ACTIONS(2202),
    [aux_sym_preproc_include_token1] = ACTIONS(2202),
    [aux_sym_preproc_def_token1] = ACTIONS(2202),
    [aux_sym_preproc_if_token1] = ACTIONS(2202),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2202),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2202),
    [sym_preproc_directive] = ACTIONS(2202),
    [anon_sym_LPAREN2] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2204),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2202),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_STAR] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_AMP] = ACTIONS(2202),
    [anon_sym_COLON] = ACTIONS(2202),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym___extension__] = ACTIONS(2202),
    [anon_sym_typedef] = ACTIONS(2202),
    [anon_sym_in] = ACTIONS(2202),
    [anon_sym_out] = ACTIONS(2202),
    [anon_sym_inout] = ACTIONS(2202),
    [anon_sym_extern] = ACTIONS(2202),
    [anon_sym___attribute__] = ACTIONS(2202),
    [anon_sym_COLON_COLON] = ACTIONS(2204),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2204),
    [anon_sym___declspec] = ACTIONS(2202),
    [anon_sym___based] = ACTIONS(2202),
    [anon_sym___cdecl] = ACTIONS(2202),
    [anon_sym___clrcall] = ACTIONS(2202),
    [anon_sym___stdcall] = ACTIONS(2202),
    [anon_sym___fastcall] = ACTIONS(2202),
    [anon_sym___thiscall] = ACTIONS(2202),
    [anon_sym___vectorcall] = ACTIONS(2202),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_signed] = ACTIONS(2202),
    [anon_sym_unsigned] = ACTIONS(2202),
    [anon_sym_long] = ACTIONS(2202),
    [anon_sym_short] = ACTIONS(2202),
    [anon_sym_LBRACK] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2202),
    [anon_sym_register] = ACTIONS(2202),
    [anon_sym_inline] = ACTIONS(2202),
    [anon_sym___inline] = ACTIONS(2202),
    [anon_sym___inline__] = ACTIONS(2202),
    [anon_sym___forceinline] = ACTIONS(2202),
    [anon_sym_thread_local] = ACTIONS(2202),
    [anon_sym___thread] = ACTIONS(2202),
    [anon_sym_const] = ACTIONS(2202),
    [anon_sym_constexpr] = ACTIONS(2202),
    [anon_sym_volatile] = ACTIONS(2202),
    [anon_sym_restrict] = ACTIONS(2202),
    [anon_sym___restrict__] = ACTIONS(2202),
    [anon_sym__Atomic] = ACTIONS(2202),
    [anon_sym__Noreturn] = ACTIONS(2202),
    [anon_sym_noreturn] = ACTIONS(2202),
    [anon_sym_mutable] = ACTIONS(2202),
    [anon_sym_constinit] = ACTIONS(2202),
    [anon_sym_consteval] = ACTIONS(2202),
    [anon_sym_alignas] = ACTIONS(2202),
    [anon_sym__Alignas] = ACTIONS(2202),
    [sym_primitive_type] = ACTIONS(2202),
    [anon_sym_enum] = ACTIONS(2202),
    [anon_sym_class] = ACTIONS(2202),
    [anon_sym_struct] = ACTIONS(2202),
    [anon_sym_union] = ACTIONS(2202),
    [anon_sym_if] = ACTIONS(2202),
    [anon_sym_else] = ACTIONS(2202),
    [anon_sym_switch] = ACTIONS(2202),
    [anon_sym_case] = ACTIONS(2202),
    [anon_sym_default] = ACTIONS(2202),
    [anon_sym_while] = ACTIONS(2202),
    [anon_sym_do] = ACTIONS(2202),
    [anon_sym_for] = ACTIONS(2202),
    [anon_sym_return] = ACTIONS(2202),
    [anon_sym_break] = ACTIONS(2202),
    [anon_sym_continue] = ACTIONS(2202),
    [anon_sym_goto] = ACTIONS(2202),
    [anon_sym___try] = ACTIONS(2202),
    [anon_sym___leave] = ACTIONS(2202),
    [anon_sym_not] = ACTIONS(2202),
    [anon_sym_compl] = ACTIONS(2202),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_sizeof] = ACTIONS(2202),
    [anon_sym___alignof__] = ACTIONS(2202),
    [anon_sym___alignof] = ACTIONS(2202),
    [anon_sym__alignof] = ACTIONS(2202),
    [anon_sym_alignof] = ACTIONS(2202),
    [anon_sym__Alignof] = ACTIONS(2202),
    [anon_sym_offsetof] = ACTIONS(2202),
    [anon_sym__Generic] = ACTIONS(2202),
    [anon_sym_asm] = ACTIONS(2202),
    [anon_sym___asm__] = ACTIONS(2202),
    [anon_sym_DOT] = ACTIONS(2202),
    [sym_number_literal] = ACTIONS(2204),
    [anon_sym_L_SQUOTE] = ACTIONS(2204),
    [anon_sym_u_SQUOTE] = ACTIONS(2204),
    [anon_sym_U_SQUOTE] = ACTIONS(2204),
    [anon_sym_u8_SQUOTE] = ACTIONS(2204),
    [anon_sym_SQUOTE] = ACTIONS(2204),
    [anon_sym_L_DQUOTE] = ACTIONS(2204),
    [anon_sym_u_DQUOTE] = ACTIONS(2204),
    [anon_sym_U_DQUOTE] = ACTIONS(2204),
    [anon_sym_u8_DQUOTE] = ACTIONS(2204),
    [anon_sym_DQUOTE] = ACTIONS(2204),
    [sym_true] = ACTIONS(2202),
    [sym_false] = ACTIONS(2202),
    [anon_sym_NULL] = ACTIONS(2202),
    [anon_sym_nullptr] = ACTIONS(2202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2202),
    [anon_sym_let] = ACTIONS(2202),
    [anon_sym_This] = ACTIONS(2202),
    [anon_sym_decltype] = ACTIONS(2202),
    [anon_sym_final] = ACTIONS(2202),
    [anon_sym_override] = ACTIONS(2202),
    [sym_virtual] = ACTIONS(2202),
    [anon_sym_explicit] = ACTIONS(2202),
    [anon_sym_typename] = ACTIONS(2202),
    [anon_sym_template] = ACTIONS(2202),
    [anon_sym_operator] = ACTIONS(2202),
    [anon_sym_try] = ACTIONS(2202),
    [anon_sym_delete] = ACTIONS(2202),
    [anon_sym_throw] = ACTIONS(2202),
    [anon_sym_namespace] = ACTIONS(2202),
    [anon_sym_using] = ACTIONS(2202),
    [anon_sym_static_assert] = ACTIONS(2202),
    [anon_sym_concept] = ACTIONS(2202),
    [anon_sym_co_return] = ACTIONS(2202),
    [anon_sym_co_yield] = ACTIONS(2202),
    [anon_sym_R_DQUOTE] = ACTIONS(2204),
    [anon_sym_LR_DQUOTE] = ACTIONS(2204),
    [anon_sym_uR_DQUOTE] = ACTIONS(2204),
    [anon_sym_UR_DQUOTE] = ACTIONS(2204),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2204),
    [anon_sym_co_await] = ACTIONS(2202),
    [anon_sym_new] = ACTIONS(2202),
    [anon_sym_requires] = ACTIONS(2202),
    [sym_this] = ACTIONS(2202),
    [anon_sym_discard] = ACTIONS(2202),
    [anon_sym_precise] = ACTIONS(2202),
    [anon_sym_shared] = ACTIONS(2202),
    [anon_sym_groupshared] = ACTIONS(2202),
    [anon_sym_uniform] = ACTIONS(2202),
    [anon_sym_row_major] = ACTIONS(2202),
    [anon_sym_column_major] = ACTIONS(2202),
    [anon_sym_globallycoherent] = ACTIONS(2202),
    [anon_sym_centroid] = ACTIONS(2202),
    [anon_sym_noperspective] = ACTIONS(2202),
    [anon_sym_nointerpolation] = ACTIONS(2202),
    [anon_sym_sample] = ACTIONS(2202),
    [anon_sym_linear] = ACTIONS(2202),
    [anon_sym_snorm] = ACTIONS(2202),
    [anon_sym_unorm] = ACTIONS(2202),
    [anon_sym_point] = ACTIONS(2202),
    [anon_sym_line] = ACTIONS(2202),
    [anon_sym_triangleadj] = ACTIONS(2202),
    [anon_sym_lineadj] = ACTIONS(2202),
    [anon_sym_triangle] = ACTIONS(2202),
    [anon_sym_cbuffer] = ACTIONS(2202),
    [anon_sym_interface] = ACTIONS(2202),
    [anon_sym_extension] = ACTIONS(2202),
  },
  [353] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(3072),
    [anon_sym_out] = ACTIONS(3072),
    [anon_sym_inout] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym__Alignas] = ACTIONS(3072),
    [sym_primitive_type] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [sym_number_literal] = ACTIONS(3074),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3072),
    [anon_sym_let] = ACTIONS(3072),
    [anon_sym_This] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [sym_virtual] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
    [anon_sym_discard] = ACTIONS(3072),
    [anon_sym_precise] = ACTIONS(3072),
    [anon_sym_shared] = ACTIONS(3072),
    [anon_sym_groupshared] = ACTIONS(3072),
    [anon_sym_uniform] = ACTIONS(3072),
    [anon_sym_row_major] = ACTIONS(3072),
    [anon_sym_column_major] = ACTIONS(3072),
    [anon_sym_globallycoherent] = ACTIONS(3072),
    [anon_sym_centroid] = ACTIONS(3072),
    [anon_sym_noperspective] = ACTIONS(3072),
    [anon_sym_nointerpolation] = ACTIONS(3072),
    [anon_sym_sample] = ACTIONS(3072),
    [anon_sym_linear] = ACTIONS(3072),
    [anon_sym_snorm] = ACTIONS(3072),
    [anon_sym_unorm] = ACTIONS(3072),
    [anon_sym_point] = ACTIONS(3072),
    [anon_sym_line] = ACTIONS(3072),
    [anon_sym_triangleadj] = ACTIONS(3072),
    [anon_sym_lineadj] = ACTIONS(3072),
    [anon_sym_triangle] = ACTIONS(3072),
    [anon_sym_cbuffer] = ACTIONS(3072),
    [anon_sym_interface] = ACTIONS(3072),
    [anon_sym_extension] = ACTIONS(3072),
  },
  [354] = {
    [sym_identifier] = ACTIONS(3076),
    [aux_sym_preproc_include_token1] = ACTIONS(3076),
    [aux_sym_preproc_def_token1] = ACTIONS(3076),
    [aux_sym_preproc_if_token1] = ACTIONS(3076),
    [aux_sym_preproc_if_token2] = ACTIONS(3076),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3076),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3076),
    [aux_sym_preproc_else_token1] = ACTIONS(3076),
    [aux_sym_preproc_elif_token1] = ACTIONS(3076),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3076),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3076),
    [sym_preproc_directive] = ACTIONS(3076),
    [anon_sym_LPAREN2] = ACTIONS(3078),
    [anon_sym_BANG] = ACTIONS(3078),
    [anon_sym_TILDE] = ACTIONS(3078),
    [anon_sym_DASH] = ACTIONS(3076),
    [anon_sym_PLUS] = ACTIONS(3076),
    [anon_sym_STAR] = ACTIONS(3078),
    [anon_sym_AMP_AMP] = ACTIONS(3078),
    [anon_sym_AMP] = ACTIONS(3076),
    [anon_sym_SEMI] = ACTIONS(3078),
    [anon_sym___extension__] = ACTIONS(3076),
    [anon_sym_typedef] = ACTIONS(3076),
    [anon_sym_in] = ACTIONS(3076),
    [anon_sym_out] = ACTIONS(3076),
    [anon_sym_inout] = ACTIONS(3076),
    [anon_sym_extern] = ACTIONS(3076),
    [anon_sym___attribute__] = ACTIONS(3076),
    [anon_sym_COLON_COLON] = ACTIONS(3078),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3078),
    [anon_sym___declspec] = ACTIONS(3076),
    [anon_sym___based] = ACTIONS(3076),
    [anon_sym___cdecl] = ACTIONS(3076),
    [anon_sym___clrcall] = ACTIONS(3076),
    [anon_sym___stdcall] = ACTIONS(3076),
    [anon_sym___fastcall] = ACTIONS(3076),
    [anon_sym___thiscall] = ACTIONS(3076),
    [anon_sym___vectorcall] = ACTIONS(3076),
    [anon_sym_LBRACE] = ACTIONS(3078),
    [anon_sym_signed] = ACTIONS(3076),
    [anon_sym_unsigned] = ACTIONS(3076),
    [anon_sym_long] = ACTIONS(3076),
    [anon_sym_short] = ACTIONS(3076),
    [anon_sym_LBRACK] = ACTIONS(3076),
    [anon_sym_static] = ACTIONS(3076),
    [anon_sym_register] = ACTIONS(3076),
    [anon_sym_inline] = ACTIONS(3076),
    [anon_sym___inline] = ACTIONS(3076),
    [anon_sym___inline__] = ACTIONS(3076),
    [anon_sym___forceinline] = ACTIONS(3076),
    [anon_sym_thread_local] = ACTIONS(3076),
    [anon_sym___thread] = ACTIONS(3076),
    [anon_sym_const] = ACTIONS(3076),
    [anon_sym_constexpr] = ACTIONS(3076),
    [anon_sym_volatile] = ACTIONS(3076),
    [anon_sym_restrict] = ACTIONS(3076),
    [anon_sym___restrict__] = ACTIONS(3076),
    [anon_sym__Atomic] = ACTIONS(3076),
    [anon_sym__Noreturn] = ACTIONS(3076),
    [anon_sym_noreturn] = ACTIONS(3076),
    [anon_sym_mutable] = ACTIONS(3076),
    [anon_sym_constinit] = ACTIONS(3076),
    [anon_sym_consteval] = ACTIONS(3076),
    [anon_sym_alignas] = ACTIONS(3076),
    [anon_sym__Alignas] = ACTIONS(3076),
    [sym_primitive_type] = ACTIONS(3076),
    [anon_sym_enum] = ACTIONS(3076),
    [anon_sym_class] = ACTIONS(3076),
    [anon_sym_struct] = ACTIONS(3076),
    [anon_sym_union] = ACTIONS(3076),
    [anon_sym_if] = ACTIONS(3076),
    [anon_sym_else] = ACTIONS(3076),
    [anon_sym_switch] = ACTIONS(3076),
    [anon_sym_case] = ACTIONS(3076),
    [anon_sym_default] = ACTIONS(3076),
    [anon_sym_while] = ACTIONS(3076),
    [anon_sym_do] = ACTIONS(3076),
    [anon_sym_for] = ACTIONS(3076),
    [anon_sym_return] = ACTIONS(3076),
    [anon_sym_break] = ACTIONS(3076),
    [anon_sym_continue] = ACTIONS(3076),
    [anon_sym_goto] = ACTIONS(3076),
    [anon_sym___try] = ACTIONS(3076),
    [anon_sym___leave] = ACTIONS(3076),
    [anon_sym_not] = ACTIONS(3076),
    [anon_sym_compl] = ACTIONS(3076),
    [anon_sym_DASH_DASH] = ACTIONS(3078),
    [anon_sym_PLUS_PLUS] = ACTIONS(3078),
    [anon_sym_sizeof] = ACTIONS(3076),
    [anon_sym___alignof__] = ACTIONS(3076),
    [anon_sym___alignof] = ACTIONS(3076),
    [anon_sym__alignof] = ACTIONS(3076),
    [anon_sym_alignof] = ACTIONS(3076),
    [anon_sym__Alignof] = ACTIONS(3076),
    [anon_sym_offsetof] = ACTIONS(3076),
    [anon_sym__Generic] = ACTIONS(3076),
    [anon_sym_asm] = ACTIONS(3076),
    [anon_sym___asm__] = ACTIONS(3076),
    [sym_number_literal] = ACTIONS(3078),
    [anon_sym_L_SQUOTE] = ACTIONS(3078),
    [anon_sym_u_SQUOTE] = ACTIONS(3078),
    [anon_sym_U_SQUOTE] = ACTIONS(3078),
    [anon_sym_u8_SQUOTE] = ACTIONS(3078),
    [anon_sym_SQUOTE] = ACTIONS(3078),
    [anon_sym_L_DQUOTE] = ACTIONS(3078),
    [anon_sym_u_DQUOTE] = ACTIONS(3078),
    [anon_sym_U_DQUOTE] = ACTIONS(3078),
    [anon_sym_u8_DQUOTE] = ACTIONS(3078),
    [anon_sym_DQUOTE] = ACTIONS(3078),
    [sym_true] = ACTIONS(3076),
    [sym_false] = ACTIONS(3076),
    [anon_sym_NULL] = ACTIONS(3076),
    [anon_sym_nullptr] = ACTIONS(3076),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3076),
    [anon_sym_let] = ACTIONS(3076),
    [anon_sym_This] = ACTIONS(3076),
    [anon_sym_decltype] = ACTIONS(3076),
    [sym_virtual] = ACTIONS(3076),
    [anon_sym_explicit] = ACTIONS(3076),
    [anon_sym_typename] = ACTIONS(3076),
    [anon_sym_template] = ACTIONS(3076),
    [anon_sym_operator] = ACTIONS(3076),
    [anon_sym_try] = ACTIONS(3076),
    [anon_sym_delete] = ACTIONS(3076),
    [anon_sym_throw] = ACTIONS(3076),
    [anon_sym_namespace] = ACTIONS(3076),
    [anon_sym_using] = ACTIONS(3076),
    [anon_sym_static_assert] = ACTIONS(3076),
    [anon_sym_concept] = ACTIONS(3076),
    [anon_sym_co_return] = ACTIONS(3076),
    [anon_sym_co_yield] = ACTIONS(3076),
    [anon_sym_R_DQUOTE] = ACTIONS(3078),
    [anon_sym_LR_DQUOTE] = ACTIONS(3078),
    [anon_sym_uR_DQUOTE] = ACTIONS(3078),
    [anon_sym_UR_DQUOTE] = ACTIONS(3078),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3078),
    [anon_sym_co_await] = ACTIONS(3076),
    [anon_sym_new] = ACTIONS(3076),
    [anon_sym_requires] = ACTIONS(3076),
    [sym_this] = ACTIONS(3076),
    [anon_sym_discard] = ACTIONS(3076),
    [anon_sym_precise] = ACTIONS(3076),
    [anon_sym_shared] = ACTIONS(3076),
    [anon_sym_groupshared] = ACTIONS(3076),
    [anon_sym_uniform] = ACTIONS(3076),
    [anon_sym_row_major] = ACTIONS(3076),
    [anon_sym_column_major] = ACTIONS(3076),
    [anon_sym_globallycoherent] = ACTIONS(3076),
    [anon_sym_centroid] = ACTIONS(3076),
    [anon_sym_noperspective] = ACTIONS(3076),
    [anon_sym_nointerpolation] = ACTIONS(3076),
    [anon_sym_sample] = ACTIONS(3076),
    [anon_sym_linear] = ACTIONS(3076),
    [anon_sym_snorm] = ACTIONS(3076),
    [anon_sym_unorm] = ACTIONS(3076),
    [anon_sym_point] = ACTIONS(3076),
    [anon_sym_line] = ACTIONS(3076),
    [anon_sym_triangleadj] = ACTIONS(3076),
    [anon_sym_lineadj] = ACTIONS(3076),
    [anon_sym_triangle] = ACTIONS(3076),
    [anon_sym_cbuffer] = ACTIONS(3076),
    [anon_sym_interface] = ACTIONS(3076),
    [anon_sym_extension] = ACTIONS(3076),
  },
  [355] = {
    [ts_builtin_sym_end] = ACTIONS(3080),
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_include_token1] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [anon_sym_COMMA] = ACTIONS(3080),
    [anon_sym_RPAREN] = ACTIONS(3080),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3080),
    [anon_sym_BANG] = ACTIONS(3080),
    [anon_sym_TILDE] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_STAR] = ACTIONS(3080),
    [anon_sym_AMP_AMP] = ACTIONS(3080),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_in] = ACTIONS(3082),
    [anon_sym_out] = ACTIONS(3082),
    [anon_sym_inout] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3080),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3080),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym___cdecl] = ACTIONS(3082),
    [anon_sym___clrcall] = ACTIONS(3082),
    [anon_sym___stdcall] = ACTIONS(3082),
    [anon_sym___fastcall] = ACTIONS(3082),
    [anon_sym___thiscall] = ACTIONS(3082),
    [anon_sym___vectorcall] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3080),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym__Alignas] = ACTIONS(3082),
    [sym_primitive_type] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_case] = ACTIONS(3082),
    [anon_sym_default] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_goto] = ACTIONS(3082),
    [anon_sym_not] = ACTIONS(3082),
    [anon_sym_compl] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3080),
    [anon_sym_PLUS_PLUS] = ACTIONS(3080),
    [anon_sym_sizeof] = ACTIONS(3082),
    [anon_sym___alignof__] = ACTIONS(3082),
    [anon_sym___alignof] = ACTIONS(3082),
    [anon_sym__alignof] = ACTIONS(3082),
    [anon_sym_alignof] = ACTIONS(3082),
    [anon_sym__Alignof] = ACTIONS(3082),
    [anon_sym_offsetof] = ACTIONS(3082),
    [anon_sym__Generic] = ACTIONS(3082),
    [anon_sym_asm] = ACTIONS(3082),
    [anon_sym___asm__] = ACTIONS(3082),
    [anon_sym_DOT] = ACTIONS(3082),
    [sym_number_literal] = ACTIONS(3080),
    [anon_sym_L_SQUOTE] = ACTIONS(3080),
    [anon_sym_u_SQUOTE] = ACTIONS(3080),
    [anon_sym_U_SQUOTE] = ACTIONS(3080),
    [anon_sym_u8_SQUOTE] = ACTIONS(3080),
    [anon_sym_SQUOTE] = ACTIONS(3080),
    [anon_sym_L_DQUOTE] = ACTIONS(3080),
    [anon_sym_u_DQUOTE] = ACTIONS(3080),
    [anon_sym_U_DQUOTE] = ACTIONS(3080),
    [anon_sym_u8_DQUOTE] = ACTIONS(3080),
    [anon_sym_DQUOTE] = ACTIONS(3080),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [anon_sym_NULL] = ACTIONS(3082),
    [anon_sym_nullptr] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3082),
    [anon_sym_let] = ACTIONS(3082),
    [anon_sym_This] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_final] = ACTIONS(3082),
    [anon_sym_override] = ACTIONS(3082),
    [sym_virtual] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_GT2] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_namespace] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
    [anon_sym_concept] = ACTIONS(3082),
    [anon_sym_co_return] = ACTIONS(3082),
    [anon_sym_co_yield] = ACTIONS(3082),
    [anon_sym_R_DQUOTE] = ACTIONS(3080),
    [anon_sym_LR_DQUOTE] = ACTIONS(3080),
    [anon_sym_uR_DQUOTE] = ACTIONS(3080),
    [anon_sym_UR_DQUOTE] = ACTIONS(3080),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3080),
    [anon_sym_co_await] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_requires] = ACTIONS(3082),
    [sym_this] = ACTIONS(3082),
    [anon_sym_precise] = ACTIONS(3082),
    [anon_sym_shared] = ACTIONS(3082),
    [anon_sym_groupshared] = ACTIONS(3082),
    [anon_sym_uniform] = ACTIONS(3082),
    [anon_sym_row_major] = ACTIONS(3082),
    [anon_sym_column_major] = ACTIONS(3082),
    [anon_sym_globallycoherent] = ACTIONS(3082),
    [anon_sym_centroid] = ACTIONS(3082),
    [anon_sym_noperspective] = ACTIONS(3082),
    [anon_sym_nointerpolation] = ACTIONS(3082),
    [anon_sym_sample] = ACTIONS(3082),
    [anon_sym_linear] = ACTIONS(3082),
    [anon_sym_snorm] = ACTIONS(3082),
    [anon_sym_unorm] = ACTIONS(3082),
    [anon_sym_point] = ACTIONS(3082),
    [anon_sym_line] = ACTIONS(3082),
    [anon_sym_triangleadj] = ACTIONS(3082),
    [anon_sym_lineadj] = ACTIONS(3082),
    [anon_sym_triangle] = ACTIONS(3082),
    [anon_sym_interface] = ACTIONS(3082),
    [anon_sym_extension] = ACTIONS(3082),
    [anon_sym_where] = ACTIONS(3082),
    [anon_sym___exported] = ACTIONS(3082),
    [anon_sym_import] = ACTIONS(3082),
  },
  [356] = {
    [sym_identifier] = ACTIONS(3084),
    [aux_sym_preproc_include_token1] = ACTIONS(3084),
    [aux_sym_preproc_def_token1] = ACTIONS(3084),
    [aux_sym_preproc_if_token1] = ACTIONS(3084),
    [aux_sym_preproc_if_token2] = ACTIONS(3084),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3084),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3084),
    [aux_sym_preproc_else_token1] = ACTIONS(3084),
    [aux_sym_preproc_elif_token1] = ACTIONS(3084),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3084),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3084),
    [sym_preproc_directive] = ACTIONS(3084),
    [anon_sym_LPAREN2] = ACTIONS(3086),
    [anon_sym_BANG] = ACTIONS(3086),
    [anon_sym_TILDE] = ACTIONS(3086),
    [anon_sym_DASH] = ACTIONS(3084),
    [anon_sym_PLUS] = ACTIONS(3084),
    [anon_sym_STAR] = ACTIONS(3086),
    [anon_sym_AMP_AMP] = ACTIONS(3086),
    [anon_sym_AMP] = ACTIONS(3084),
    [anon_sym_SEMI] = ACTIONS(3086),
    [anon_sym___extension__] = ACTIONS(3084),
    [anon_sym_typedef] = ACTIONS(3084),
    [anon_sym_in] = ACTIONS(3084),
    [anon_sym_out] = ACTIONS(3084),
    [anon_sym_inout] = ACTIONS(3084),
    [anon_sym_extern] = ACTIONS(3084),
    [anon_sym___attribute__] = ACTIONS(3084),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3086),
    [anon_sym___declspec] = ACTIONS(3084),
    [anon_sym___based] = ACTIONS(3084),
    [anon_sym___cdecl] = ACTIONS(3084),
    [anon_sym___clrcall] = ACTIONS(3084),
    [anon_sym___stdcall] = ACTIONS(3084),
    [anon_sym___fastcall] = ACTIONS(3084),
    [anon_sym___thiscall] = ACTIONS(3084),
    [anon_sym___vectorcall] = ACTIONS(3084),
    [anon_sym_LBRACE] = ACTIONS(3086),
    [anon_sym_signed] = ACTIONS(3084),
    [anon_sym_unsigned] = ACTIONS(3084),
    [anon_sym_long] = ACTIONS(3084),
    [anon_sym_short] = ACTIONS(3084),
    [anon_sym_LBRACK] = ACTIONS(3084),
    [anon_sym_static] = ACTIONS(3084),
    [anon_sym_register] = ACTIONS(3084),
    [anon_sym_inline] = ACTIONS(3084),
    [anon_sym___inline] = ACTIONS(3084),
    [anon_sym___inline__] = ACTIONS(3084),
    [anon_sym___forceinline] = ACTIONS(3084),
    [anon_sym_thread_local] = ACTIONS(3084),
    [anon_sym___thread] = ACTIONS(3084),
    [anon_sym_const] = ACTIONS(3084),
    [anon_sym_constexpr] = ACTIONS(3084),
    [anon_sym_volatile] = ACTIONS(3084),
    [anon_sym_restrict] = ACTIONS(3084),
    [anon_sym___restrict__] = ACTIONS(3084),
    [anon_sym__Atomic] = ACTIONS(3084),
    [anon_sym__Noreturn] = ACTIONS(3084),
    [anon_sym_noreturn] = ACTIONS(3084),
    [anon_sym_mutable] = ACTIONS(3084),
    [anon_sym_constinit] = ACTIONS(3084),
    [anon_sym_consteval] = ACTIONS(3084),
    [anon_sym_alignas] = ACTIONS(3084),
    [anon_sym__Alignas] = ACTIONS(3084),
    [sym_primitive_type] = ACTIONS(3084),
    [anon_sym_enum] = ACTIONS(3084),
    [anon_sym_class] = ACTIONS(3084),
    [anon_sym_struct] = ACTIONS(3084),
    [anon_sym_union] = ACTIONS(3084),
    [anon_sym_if] = ACTIONS(3084),
    [anon_sym_else] = ACTIONS(3084),
    [anon_sym_switch] = ACTIONS(3084),
    [anon_sym_case] = ACTIONS(3084),
    [anon_sym_default] = ACTIONS(3084),
    [anon_sym_while] = ACTIONS(3084),
    [anon_sym_do] = ACTIONS(3084),
    [anon_sym_for] = ACTIONS(3084),
    [anon_sym_return] = ACTIONS(3084),
    [anon_sym_break] = ACTIONS(3084),
    [anon_sym_continue] = ACTIONS(3084),
    [anon_sym_goto] = ACTIONS(3084),
    [anon_sym___try] = ACTIONS(3084),
    [anon_sym___leave] = ACTIONS(3084),
    [anon_sym_not] = ACTIONS(3084),
    [anon_sym_compl] = ACTIONS(3084),
    [anon_sym_DASH_DASH] = ACTIONS(3086),
    [anon_sym_PLUS_PLUS] = ACTIONS(3086),
    [anon_sym_sizeof] = ACTIONS(3084),
    [anon_sym___alignof__] = ACTIONS(3084),
    [anon_sym___alignof] = ACTIONS(3084),
    [anon_sym__alignof] = ACTIONS(3084),
    [anon_sym_alignof] = ACTIONS(3084),
    [anon_sym__Alignof] = ACTIONS(3084),
    [anon_sym_offsetof] = ACTIONS(3084),
    [anon_sym__Generic] = ACTIONS(3084),
    [anon_sym_asm] = ACTIONS(3084),
    [anon_sym___asm__] = ACTIONS(3084),
    [sym_number_literal] = ACTIONS(3086),
    [anon_sym_L_SQUOTE] = ACTIONS(3086),
    [anon_sym_u_SQUOTE] = ACTIONS(3086),
    [anon_sym_U_SQUOTE] = ACTIONS(3086),
    [anon_sym_u8_SQUOTE] = ACTIONS(3086),
    [anon_sym_SQUOTE] = ACTIONS(3086),
    [anon_sym_L_DQUOTE] = ACTIONS(3086),
    [anon_sym_u_DQUOTE] = ACTIONS(3086),
    [anon_sym_U_DQUOTE] = ACTIONS(3086),
    [anon_sym_u8_DQUOTE] = ACTIONS(3086),
    [anon_sym_DQUOTE] = ACTIONS(3086),
    [sym_true] = ACTIONS(3084),
    [sym_false] = ACTIONS(3084),
    [anon_sym_NULL] = ACTIONS(3084),
    [anon_sym_nullptr] = ACTIONS(3084),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3084),
    [anon_sym_let] = ACTIONS(3084),
    [anon_sym_This] = ACTIONS(3084),
    [anon_sym_decltype] = ACTIONS(3084),
    [sym_virtual] = ACTIONS(3084),
    [anon_sym_explicit] = ACTIONS(3084),
    [anon_sym_typename] = ACTIONS(3084),
    [anon_sym_template] = ACTIONS(3084),
    [anon_sym_operator] = ACTIONS(3084),
    [anon_sym_try] = ACTIONS(3084),
    [anon_sym_delete] = ACTIONS(3084),
    [anon_sym_throw] = ACTIONS(3084),
    [anon_sym_namespace] = ACTIONS(3084),
    [anon_sym_using] = ACTIONS(3084),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_concept] = ACTIONS(3084),
    [anon_sym_co_return] = ACTIONS(3084),
    [anon_sym_co_yield] = ACTIONS(3084),
    [anon_sym_R_DQUOTE] = ACTIONS(3086),
    [anon_sym_LR_DQUOTE] = ACTIONS(3086),
    [anon_sym_uR_DQUOTE] = ACTIONS(3086),
    [anon_sym_UR_DQUOTE] = ACTIONS(3086),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3086),
    [anon_sym_co_await] = ACTIONS(3084),
    [anon_sym_new] = ACTIONS(3084),
    [anon_sym_requires] = ACTIONS(3084),
    [sym_this] = ACTIONS(3084),
    [anon_sym_discard] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(3084),
    [anon_sym_shared] = ACTIONS(3084),
    [anon_sym_groupshared] = ACTIONS(3084),
    [anon_sym_uniform] = ACTIONS(3084),
    [anon_sym_row_major] = ACTIONS(3084),
    [anon_sym_column_major] = ACTIONS(3084),
    [anon_sym_globallycoherent] = ACTIONS(3084),
    [anon_sym_centroid] = ACTIONS(3084),
    [anon_sym_noperspective] = ACTIONS(3084),
    [anon_sym_nointerpolation] = ACTIONS(3084),
    [anon_sym_sample] = ACTIONS(3084),
    [anon_sym_linear] = ACTIONS(3084),
    [anon_sym_snorm] = ACTIONS(3084),
    [anon_sym_unorm] = ACTIONS(3084),
    [anon_sym_point] = ACTIONS(3084),
    [anon_sym_line] = ACTIONS(3084),
    [anon_sym_triangleadj] = ACTIONS(3084),
    [anon_sym_lineadj] = ACTIONS(3084),
    [anon_sym_triangle] = ACTIONS(3084),
    [anon_sym_cbuffer] = ACTIONS(3084),
    [anon_sym_interface] = ACTIONS(3084),
    [anon_sym_extension] = ACTIONS(3084),
  },
  [357] = {
    [ts_builtin_sym_end] = ACTIONS(3088),
    [sym_identifier] = ACTIONS(3090),
    [aux_sym_preproc_include_token1] = ACTIONS(3090),
    [aux_sym_preproc_def_token1] = ACTIONS(3090),
    [anon_sym_COMMA] = ACTIONS(3088),
    [anon_sym_RPAREN] = ACTIONS(3088),
    [aux_sym_preproc_if_token1] = ACTIONS(3090),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3090),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3090),
    [sym_preproc_directive] = ACTIONS(3090),
    [anon_sym_LPAREN2] = ACTIONS(3088),
    [anon_sym_BANG] = ACTIONS(3088),
    [anon_sym_TILDE] = ACTIONS(3088),
    [anon_sym_DASH] = ACTIONS(3090),
    [anon_sym_PLUS] = ACTIONS(3090),
    [anon_sym_STAR] = ACTIONS(3088),
    [anon_sym_AMP_AMP] = ACTIONS(3088),
    [anon_sym_AMP] = ACTIONS(3090),
    [anon_sym_SEMI] = ACTIONS(3088),
    [anon_sym___extension__] = ACTIONS(3090),
    [anon_sym_typedef] = ACTIONS(3090),
    [anon_sym_in] = ACTIONS(3090),
    [anon_sym_out] = ACTIONS(3090),
    [anon_sym_inout] = ACTIONS(3090),
    [anon_sym_extern] = ACTIONS(3090),
    [anon_sym___attribute__] = ACTIONS(3090),
    [anon_sym_COLON_COLON] = ACTIONS(3088),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3088),
    [anon_sym___declspec] = ACTIONS(3090),
    [anon_sym___based] = ACTIONS(3090),
    [anon_sym___cdecl] = ACTIONS(3090),
    [anon_sym___clrcall] = ACTIONS(3090),
    [anon_sym___stdcall] = ACTIONS(3090),
    [anon_sym___fastcall] = ACTIONS(3090),
    [anon_sym___thiscall] = ACTIONS(3090),
    [anon_sym___vectorcall] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3088),
    [anon_sym_signed] = ACTIONS(3090),
    [anon_sym_unsigned] = ACTIONS(3090),
    [anon_sym_long] = ACTIONS(3090),
    [anon_sym_short] = ACTIONS(3090),
    [anon_sym_LBRACK] = ACTIONS(3090),
    [anon_sym_static] = ACTIONS(3090),
    [anon_sym_register] = ACTIONS(3090),
    [anon_sym_inline] = ACTIONS(3090),
    [anon_sym___inline] = ACTIONS(3090),
    [anon_sym___inline__] = ACTIONS(3090),
    [anon_sym___forceinline] = ACTIONS(3090),
    [anon_sym_thread_local] = ACTIONS(3090),
    [anon_sym___thread] = ACTIONS(3090),
    [anon_sym_const] = ACTIONS(3090),
    [anon_sym_constexpr] = ACTIONS(3090),
    [anon_sym_volatile] = ACTIONS(3090),
    [anon_sym_restrict] = ACTIONS(3090),
    [anon_sym___restrict__] = ACTIONS(3090),
    [anon_sym__Atomic] = ACTIONS(3090),
    [anon_sym__Noreturn] = ACTIONS(3090),
    [anon_sym_noreturn] = ACTIONS(3090),
    [anon_sym_mutable] = ACTIONS(3090),
    [anon_sym_constinit] = ACTIONS(3090),
    [anon_sym_consteval] = ACTIONS(3090),
    [anon_sym_alignas] = ACTIONS(3090),
    [anon_sym__Alignas] = ACTIONS(3090),
    [sym_primitive_type] = ACTIONS(3090),
    [anon_sym_enum] = ACTIONS(3090),
    [anon_sym_class] = ACTIONS(3090),
    [anon_sym_struct] = ACTIONS(3090),
    [anon_sym_union] = ACTIONS(3090),
    [anon_sym_if] = ACTIONS(3090),
    [anon_sym_switch] = ACTIONS(3090),
    [anon_sym_case] = ACTIONS(3090),
    [anon_sym_default] = ACTIONS(3090),
    [anon_sym_while] = ACTIONS(3090),
    [anon_sym_do] = ACTIONS(3090),
    [anon_sym_for] = ACTIONS(3090),
    [anon_sym_return] = ACTIONS(3090),
    [anon_sym_break] = ACTIONS(3090),
    [anon_sym_continue] = ACTIONS(3090),
    [anon_sym_goto] = ACTIONS(3090),
    [anon_sym_not] = ACTIONS(3090),
    [anon_sym_compl] = ACTIONS(3090),
    [anon_sym_DASH_DASH] = ACTIONS(3088),
    [anon_sym_PLUS_PLUS] = ACTIONS(3088),
    [anon_sym_sizeof] = ACTIONS(3090),
    [anon_sym___alignof__] = ACTIONS(3090),
    [anon_sym___alignof] = ACTIONS(3090),
    [anon_sym__alignof] = ACTIONS(3090),
    [anon_sym_alignof] = ACTIONS(3090),
    [anon_sym__Alignof] = ACTIONS(3090),
    [anon_sym_offsetof] = ACTIONS(3090),
    [anon_sym__Generic] = ACTIONS(3090),
    [anon_sym_asm] = ACTIONS(3090),
    [anon_sym___asm__] = ACTIONS(3090),
    [anon_sym_DOT] = ACTIONS(3090),
    [sym_number_literal] = ACTIONS(3088),
    [anon_sym_L_SQUOTE] = ACTIONS(3088),
    [anon_sym_u_SQUOTE] = ACTIONS(3088),
    [anon_sym_U_SQUOTE] = ACTIONS(3088),
    [anon_sym_u8_SQUOTE] = ACTIONS(3088),
    [anon_sym_SQUOTE] = ACTIONS(3088),
    [anon_sym_L_DQUOTE] = ACTIONS(3088),
    [anon_sym_u_DQUOTE] = ACTIONS(3088),
    [anon_sym_U_DQUOTE] = ACTIONS(3088),
    [anon_sym_u8_DQUOTE] = ACTIONS(3088),
    [anon_sym_DQUOTE] = ACTIONS(3088),
    [sym_true] = ACTIONS(3090),
    [sym_false] = ACTIONS(3090),
    [anon_sym_NULL] = ACTIONS(3090),
    [anon_sym_nullptr] = ACTIONS(3090),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3090),
    [anon_sym_let] = ACTIONS(3090),
    [anon_sym_This] = ACTIONS(3090),
    [anon_sym_decltype] = ACTIONS(3090),
    [anon_sym_final] = ACTIONS(3090),
    [anon_sym_override] = ACTIONS(3090),
    [sym_virtual] = ACTIONS(3090),
    [anon_sym_explicit] = ACTIONS(3090),
    [anon_sym_typename] = ACTIONS(3090),
    [anon_sym_template] = ACTIONS(3090),
    [anon_sym_GT2] = ACTIONS(3088),
    [anon_sym_operator] = ACTIONS(3090),
    [anon_sym_try] = ACTIONS(3090),
    [anon_sym_delete] = ACTIONS(3090),
    [anon_sym_throw] = ACTIONS(3090),
    [anon_sym_namespace] = ACTIONS(3090),
    [anon_sym_using] = ACTIONS(3090),
    [anon_sym_static_assert] = ACTIONS(3090),
    [anon_sym_concept] = ACTIONS(3090),
    [anon_sym_co_return] = ACTIONS(3090),
    [anon_sym_co_yield] = ACTIONS(3090),
    [anon_sym_R_DQUOTE] = ACTIONS(3088),
    [anon_sym_LR_DQUOTE] = ACTIONS(3088),
    [anon_sym_uR_DQUOTE] = ACTIONS(3088),
    [anon_sym_UR_DQUOTE] = ACTIONS(3088),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3088),
    [anon_sym_co_await] = ACTIONS(3090),
    [anon_sym_new] = ACTIONS(3090),
    [anon_sym_requires] = ACTIONS(3090),
    [sym_this] = ACTIONS(3090),
    [anon_sym_precise] = ACTIONS(3090),
    [anon_sym_shared] = ACTIONS(3090),
    [anon_sym_groupshared] = ACTIONS(3090),
    [anon_sym_uniform] = ACTIONS(3090),
    [anon_sym_row_major] = ACTIONS(3090),
    [anon_sym_column_major] = ACTIONS(3090),
    [anon_sym_globallycoherent] = ACTIONS(3090),
    [anon_sym_centroid] = ACTIONS(3090),
    [anon_sym_noperspective] = ACTIONS(3090),
    [anon_sym_nointerpolation] = ACTIONS(3090),
    [anon_sym_sample] = ACTIONS(3090),
    [anon_sym_linear] = ACTIONS(3090),
    [anon_sym_snorm] = ACTIONS(3090),
    [anon_sym_unorm] = ACTIONS(3090),
    [anon_sym_point] = ACTIONS(3090),
    [anon_sym_line] = ACTIONS(3090),
    [anon_sym_triangleadj] = ACTIONS(3090),
    [anon_sym_lineadj] = ACTIONS(3090),
    [anon_sym_triangle] = ACTIONS(3090),
    [anon_sym_interface] = ACTIONS(3090),
    [anon_sym_extension] = ACTIONS(3090),
    [anon_sym_where] = ACTIONS(3090),
    [anon_sym___exported] = ACTIONS(3090),
    [anon_sym_import] = ACTIONS(3090),
  },
  [358] = {
    [ts_builtin_sym_end] = ACTIONS(3052),
    [sym_identifier] = ACTIONS(3054),
    [aux_sym_preproc_include_token1] = ACTIONS(3054),
    [aux_sym_preproc_def_token1] = ACTIONS(3054),
    [anon_sym_COMMA] = ACTIONS(3052),
    [anon_sym_RPAREN] = ACTIONS(3052),
    [aux_sym_preproc_if_token1] = ACTIONS(3054),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3054),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3054),
    [sym_preproc_directive] = ACTIONS(3054),
    [anon_sym_LPAREN2] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3052),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3054),
    [anon_sym_PLUS] = ACTIONS(3054),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3054),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym___extension__] = ACTIONS(3054),
    [anon_sym_typedef] = ACTIONS(3054),
    [anon_sym_in] = ACTIONS(3054),
    [anon_sym_out] = ACTIONS(3054),
    [anon_sym_inout] = ACTIONS(3054),
    [anon_sym_extern] = ACTIONS(3054),
    [anon_sym___attribute__] = ACTIONS(3054),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3052),
    [anon_sym___declspec] = ACTIONS(3054),
    [anon_sym___based] = ACTIONS(3054),
    [anon_sym___cdecl] = ACTIONS(3054),
    [anon_sym___clrcall] = ACTIONS(3054),
    [anon_sym___stdcall] = ACTIONS(3054),
    [anon_sym___fastcall] = ACTIONS(3054),
    [anon_sym___thiscall] = ACTIONS(3054),
    [anon_sym___vectorcall] = ACTIONS(3054),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_signed] = ACTIONS(3054),
    [anon_sym_unsigned] = ACTIONS(3054),
    [anon_sym_long] = ACTIONS(3054),
    [anon_sym_short] = ACTIONS(3054),
    [anon_sym_LBRACK] = ACTIONS(3054),
    [anon_sym_static] = ACTIONS(3054),
    [anon_sym_register] = ACTIONS(3054),
    [anon_sym_inline] = ACTIONS(3054),
    [anon_sym___inline] = ACTIONS(3054),
    [anon_sym___inline__] = ACTIONS(3054),
    [anon_sym___forceinline] = ACTIONS(3054),
    [anon_sym_thread_local] = ACTIONS(3054),
    [anon_sym___thread] = ACTIONS(3054),
    [anon_sym_const] = ACTIONS(3054),
    [anon_sym_constexpr] = ACTIONS(3054),
    [anon_sym_volatile] = ACTIONS(3054),
    [anon_sym_restrict] = ACTIONS(3054),
    [anon_sym___restrict__] = ACTIONS(3054),
    [anon_sym__Atomic] = ACTIONS(3054),
    [anon_sym__Noreturn] = ACTIONS(3054),
    [anon_sym_noreturn] = ACTIONS(3054),
    [anon_sym_mutable] = ACTIONS(3054),
    [anon_sym_constinit] = ACTIONS(3054),
    [anon_sym_consteval] = ACTIONS(3054),
    [anon_sym_alignas] = ACTIONS(3054),
    [anon_sym__Alignas] = ACTIONS(3054),
    [sym_primitive_type] = ACTIONS(3054),
    [anon_sym_enum] = ACTIONS(3054),
    [anon_sym_class] = ACTIONS(3054),
    [anon_sym_struct] = ACTIONS(3054),
    [anon_sym_union] = ACTIONS(3054),
    [anon_sym_if] = ACTIONS(3054),
    [anon_sym_switch] = ACTIONS(3054),
    [anon_sym_case] = ACTIONS(3054),
    [anon_sym_default] = ACTIONS(3054),
    [anon_sym_while] = ACTIONS(3054),
    [anon_sym_do] = ACTIONS(3054),
    [anon_sym_for] = ACTIONS(3054),
    [anon_sym_return] = ACTIONS(3054),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_continue] = ACTIONS(3054),
    [anon_sym_goto] = ACTIONS(3054),
    [anon_sym_not] = ACTIONS(3054),
    [anon_sym_compl] = ACTIONS(3054),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_sizeof] = ACTIONS(3054),
    [anon_sym___alignof__] = ACTIONS(3054),
    [anon_sym___alignof] = ACTIONS(3054),
    [anon_sym__alignof] = ACTIONS(3054),
    [anon_sym_alignof] = ACTIONS(3054),
    [anon_sym__Alignof] = ACTIONS(3054),
    [anon_sym_offsetof] = ACTIONS(3054),
    [anon_sym__Generic] = ACTIONS(3054),
    [anon_sym_asm] = ACTIONS(3054),
    [anon_sym___asm__] = ACTIONS(3054),
    [anon_sym_DOT] = ACTIONS(3054),
    [sym_number_literal] = ACTIONS(3052),
    [anon_sym_L_SQUOTE] = ACTIONS(3052),
    [anon_sym_u_SQUOTE] = ACTIONS(3052),
    [anon_sym_U_SQUOTE] = ACTIONS(3052),
    [anon_sym_u8_SQUOTE] = ACTIONS(3052),
    [anon_sym_SQUOTE] = ACTIONS(3052),
    [anon_sym_L_DQUOTE] = ACTIONS(3052),
    [anon_sym_u_DQUOTE] = ACTIONS(3052),
    [anon_sym_U_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8_DQUOTE] = ACTIONS(3052),
    [anon_sym_DQUOTE] = ACTIONS(3052),
    [sym_true] = ACTIONS(3054),
    [sym_false] = ACTIONS(3054),
    [anon_sym_NULL] = ACTIONS(3054),
    [anon_sym_nullptr] = ACTIONS(3054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3054),
    [anon_sym_let] = ACTIONS(3054),
    [anon_sym_This] = ACTIONS(3054),
    [anon_sym_decltype] = ACTIONS(3054),
    [anon_sym_final] = ACTIONS(3054),
    [anon_sym_override] = ACTIONS(3054),
    [sym_virtual] = ACTIONS(3054),
    [anon_sym_explicit] = ACTIONS(3054),
    [anon_sym_typename] = ACTIONS(3054),
    [anon_sym_template] = ACTIONS(3054),
    [anon_sym_GT2] = ACTIONS(3052),
    [anon_sym_operator] = ACTIONS(3054),
    [anon_sym_try] = ACTIONS(3054),
    [anon_sym_delete] = ACTIONS(3054),
    [anon_sym_throw] = ACTIONS(3054),
    [anon_sym_namespace] = ACTIONS(3054),
    [anon_sym_using] = ACTIONS(3054),
    [anon_sym_static_assert] = ACTIONS(3054),
    [anon_sym_concept] = ACTIONS(3054),
    [anon_sym_co_return] = ACTIONS(3054),
    [anon_sym_co_yield] = ACTIONS(3054),
    [anon_sym_R_DQUOTE] = ACTIONS(3052),
    [anon_sym_LR_DQUOTE] = ACTIONS(3052),
    [anon_sym_uR_DQUOTE] = ACTIONS(3052),
    [anon_sym_UR_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3052),
    [anon_sym_co_await] = ACTIONS(3054),
    [anon_sym_new] = ACTIONS(3054),
    [anon_sym_requires] = ACTIONS(3054),
    [sym_this] = ACTIONS(3054),
    [anon_sym_precise] = ACTIONS(3054),
    [anon_sym_shared] = ACTIONS(3054),
    [anon_sym_groupshared] = ACTIONS(3054),
    [anon_sym_uniform] = ACTIONS(3054),
    [anon_sym_row_major] = ACTIONS(3054),
    [anon_sym_column_major] = ACTIONS(3054),
    [anon_sym_globallycoherent] = ACTIONS(3054),
    [anon_sym_centroid] = ACTIONS(3054),
    [anon_sym_noperspective] = ACTIONS(3054),
    [anon_sym_nointerpolation] = ACTIONS(3054),
    [anon_sym_sample] = ACTIONS(3054),
    [anon_sym_linear] = ACTIONS(3054),
    [anon_sym_snorm] = ACTIONS(3054),
    [anon_sym_unorm] = ACTIONS(3054),
    [anon_sym_point] = ACTIONS(3054),
    [anon_sym_line] = ACTIONS(3054),
    [anon_sym_triangleadj] = ACTIONS(3054),
    [anon_sym_lineadj] = ACTIONS(3054),
    [anon_sym_triangle] = ACTIONS(3054),
    [anon_sym_interface] = ACTIONS(3054),
    [anon_sym_extension] = ACTIONS(3054),
    [anon_sym_where] = ACTIONS(3054),
    [anon_sym___exported] = ACTIONS(3054),
    [anon_sym_import] = ACTIONS(3054),
  },
  [359] = {
    [sym_identifier] = ACTIONS(2206),
    [aux_sym_preproc_include_token1] = ACTIONS(2206),
    [aux_sym_preproc_def_token1] = ACTIONS(2206),
    [aux_sym_preproc_if_token1] = ACTIONS(2206),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2206),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2206),
    [sym_preproc_directive] = ACTIONS(2206),
    [anon_sym_LPAREN2] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2208),
    [anon_sym_TILDE] = ACTIONS(2208),
    [anon_sym_DASH] = ACTIONS(2206),
    [anon_sym_PLUS] = ACTIONS(2206),
    [anon_sym_STAR] = ACTIONS(2208),
    [anon_sym_AMP_AMP] = ACTIONS(2208),
    [anon_sym_AMP] = ACTIONS(2206),
    [anon_sym_COLON] = ACTIONS(2206),
    [anon_sym_SEMI] = ACTIONS(2208),
    [anon_sym___extension__] = ACTIONS(2206),
    [anon_sym_typedef] = ACTIONS(2206),
    [anon_sym_in] = ACTIONS(2206),
    [anon_sym_out] = ACTIONS(2206),
    [anon_sym_inout] = ACTIONS(2206),
    [anon_sym_extern] = ACTIONS(2206),
    [anon_sym___attribute__] = ACTIONS(2206),
    [anon_sym_COLON_COLON] = ACTIONS(2208),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2208),
    [anon_sym___declspec] = ACTIONS(2206),
    [anon_sym___based] = ACTIONS(2206),
    [anon_sym___cdecl] = ACTIONS(2206),
    [anon_sym___clrcall] = ACTIONS(2206),
    [anon_sym___stdcall] = ACTIONS(2206),
    [anon_sym___fastcall] = ACTIONS(2206),
    [anon_sym___thiscall] = ACTIONS(2206),
    [anon_sym___vectorcall] = ACTIONS(2206),
    [anon_sym_LBRACE] = ACTIONS(2208),
    [anon_sym_RBRACE] = ACTIONS(2208),
    [anon_sym_signed] = ACTIONS(2206),
    [anon_sym_unsigned] = ACTIONS(2206),
    [anon_sym_long] = ACTIONS(2206),
    [anon_sym_short] = ACTIONS(2206),
    [anon_sym_LBRACK] = ACTIONS(2206),
    [anon_sym_static] = ACTIONS(2206),
    [anon_sym_register] = ACTIONS(2206),
    [anon_sym_inline] = ACTIONS(2206),
    [anon_sym___inline] = ACTIONS(2206),
    [anon_sym___inline__] = ACTIONS(2206),
    [anon_sym___forceinline] = ACTIONS(2206),
    [anon_sym_thread_local] = ACTIONS(2206),
    [anon_sym___thread] = ACTIONS(2206),
    [anon_sym_const] = ACTIONS(2206),
    [anon_sym_constexpr] = ACTIONS(2206),
    [anon_sym_volatile] = ACTIONS(2206),
    [anon_sym_restrict] = ACTIONS(2206),
    [anon_sym___restrict__] = ACTIONS(2206),
    [anon_sym__Atomic] = ACTIONS(2206),
    [anon_sym__Noreturn] = ACTIONS(2206),
    [anon_sym_noreturn] = ACTIONS(2206),
    [anon_sym_mutable] = ACTIONS(2206),
    [anon_sym_constinit] = ACTIONS(2206),
    [anon_sym_consteval] = ACTIONS(2206),
    [anon_sym_alignas] = ACTIONS(2206),
    [anon_sym__Alignas] = ACTIONS(2206),
    [sym_primitive_type] = ACTIONS(2206),
    [anon_sym_enum] = ACTIONS(2206),
    [anon_sym_class] = ACTIONS(2206),
    [anon_sym_struct] = ACTIONS(2206),
    [anon_sym_union] = ACTIONS(2206),
    [anon_sym_if] = ACTIONS(2206),
    [anon_sym_else] = ACTIONS(2206),
    [anon_sym_switch] = ACTIONS(2206),
    [anon_sym_case] = ACTIONS(2206),
    [anon_sym_default] = ACTIONS(2206),
    [anon_sym_while] = ACTIONS(2206),
    [anon_sym_do] = ACTIONS(2206),
    [anon_sym_for] = ACTIONS(2206),
    [anon_sym_return] = ACTIONS(2206),
    [anon_sym_break] = ACTIONS(2206),
    [anon_sym_continue] = ACTIONS(2206),
    [anon_sym_goto] = ACTIONS(2206),
    [anon_sym___try] = ACTIONS(2206),
    [anon_sym___leave] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_compl] = ACTIONS(2206),
    [anon_sym_DASH_DASH] = ACTIONS(2208),
    [anon_sym_PLUS_PLUS] = ACTIONS(2208),
    [anon_sym_sizeof] = ACTIONS(2206),
    [anon_sym___alignof__] = ACTIONS(2206),
    [anon_sym___alignof] = ACTIONS(2206),
    [anon_sym__alignof] = ACTIONS(2206),
    [anon_sym_alignof] = ACTIONS(2206),
    [anon_sym__Alignof] = ACTIONS(2206),
    [anon_sym_offsetof] = ACTIONS(2206),
    [anon_sym__Generic] = ACTIONS(2206),
    [anon_sym_asm] = ACTIONS(2206),
    [anon_sym___asm__] = ACTIONS(2206),
    [anon_sym_DOT] = ACTIONS(2206),
    [sym_number_literal] = ACTIONS(2208),
    [anon_sym_L_SQUOTE] = ACTIONS(2208),
    [anon_sym_u_SQUOTE] = ACTIONS(2208),
    [anon_sym_U_SQUOTE] = ACTIONS(2208),
    [anon_sym_u8_SQUOTE] = ACTIONS(2208),
    [anon_sym_SQUOTE] = ACTIONS(2208),
    [anon_sym_L_DQUOTE] = ACTIONS(2208),
    [anon_sym_u_DQUOTE] = ACTIONS(2208),
    [anon_sym_U_DQUOTE] = ACTIONS(2208),
    [anon_sym_u8_DQUOTE] = ACTIONS(2208),
    [anon_sym_DQUOTE] = ACTIONS(2208),
    [sym_true] = ACTIONS(2206),
    [sym_false] = ACTIONS(2206),
    [anon_sym_NULL] = ACTIONS(2206),
    [anon_sym_nullptr] = ACTIONS(2206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2206),
    [anon_sym_let] = ACTIONS(2206),
    [anon_sym_This] = ACTIONS(2206),
    [anon_sym_decltype] = ACTIONS(2206),
    [anon_sym_final] = ACTIONS(2206),
    [anon_sym_override] = ACTIONS(2206),
    [sym_virtual] = ACTIONS(2206),
    [anon_sym_explicit] = ACTIONS(2206),
    [anon_sym_typename] = ACTIONS(2206),
    [anon_sym_template] = ACTIONS(2206),
    [anon_sym_operator] = ACTIONS(2206),
    [anon_sym_try] = ACTIONS(2206),
    [anon_sym_delete] = ACTIONS(2206),
    [anon_sym_throw] = ACTIONS(2206),
    [anon_sym_namespace] = ACTIONS(2206),
    [anon_sym_using] = ACTIONS(2206),
    [anon_sym_static_assert] = ACTIONS(2206),
    [anon_sym_concept] = ACTIONS(2206),
    [anon_sym_co_return] = ACTIONS(2206),
    [anon_sym_co_yield] = ACTIONS(2206),
    [anon_sym_R_DQUOTE] = ACTIONS(2208),
    [anon_sym_LR_DQUOTE] = ACTIONS(2208),
    [anon_sym_uR_DQUOTE] = ACTIONS(2208),
    [anon_sym_UR_DQUOTE] = ACTIONS(2208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2208),
    [anon_sym_co_await] = ACTIONS(2206),
    [anon_sym_new] = ACTIONS(2206),
    [anon_sym_requires] = ACTIONS(2206),
    [sym_this] = ACTIONS(2206),
    [anon_sym_discard] = ACTIONS(2206),
    [anon_sym_precise] = ACTIONS(2206),
    [anon_sym_shared] = ACTIONS(2206),
    [anon_sym_groupshared] = ACTIONS(2206),
    [anon_sym_uniform] = ACTIONS(2206),
    [anon_sym_row_major] = ACTIONS(2206),
    [anon_sym_column_major] = ACTIONS(2206),
    [anon_sym_globallycoherent] = ACTIONS(2206),
    [anon_sym_centroid] = ACTIONS(2206),
    [anon_sym_noperspective] = ACTIONS(2206),
    [anon_sym_nointerpolation] = ACTIONS(2206),
    [anon_sym_sample] = ACTIONS(2206),
    [anon_sym_linear] = ACTIONS(2206),
    [anon_sym_snorm] = ACTIONS(2206),
    [anon_sym_unorm] = ACTIONS(2206),
    [anon_sym_point] = ACTIONS(2206),
    [anon_sym_line] = ACTIONS(2206),
    [anon_sym_triangleadj] = ACTIONS(2206),
    [anon_sym_lineadj] = ACTIONS(2206),
    [anon_sym_triangle] = ACTIONS(2206),
    [anon_sym_cbuffer] = ACTIONS(2206),
    [anon_sym_interface] = ACTIONS(2206),
    [anon_sym_extension] = ACTIONS(2206),
  },
  [360] = {
    [sym_identifier] = ACTIONS(3092),
    [aux_sym_preproc_include_token1] = ACTIONS(3092),
    [aux_sym_preproc_def_token1] = ACTIONS(3092),
    [aux_sym_preproc_if_token1] = ACTIONS(3092),
    [aux_sym_preproc_if_token2] = ACTIONS(3092),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3092),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3092),
    [aux_sym_preproc_else_token1] = ACTIONS(3092),
    [aux_sym_preproc_elif_token1] = ACTIONS(3092),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3092),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3092),
    [sym_preproc_directive] = ACTIONS(3092),
    [anon_sym_LPAREN2] = ACTIONS(3094),
    [anon_sym_BANG] = ACTIONS(3094),
    [anon_sym_TILDE] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_STAR] = ACTIONS(3094),
    [anon_sym_AMP_AMP] = ACTIONS(3094),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_SEMI] = ACTIONS(3094),
    [anon_sym___extension__] = ACTIONS(3092),
    [anon_sym_typedef] = ACTIONS(3092),
    [anon_sym_in] = ACTIONS(3092),
    [anon_sym_out] = ACTIONS(3092),
    [anon_sym_inout] = ACTIONS(3092),
    [anon_sym_extern] = ACTIONS(3092),
    [anon_sym___attribute__] = ACTIONS(3092),
    [anon_sym_COLON_COLON] = ACTIONS(3094),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3094),
    [anon_sym___declspec] = ACTIONS(3092),
    [anon_sym___based] = ACTIONS(3092),
    [anon_sym___cdecl] = ACTIONS(3092),
    [anon_sym___clrcall] = ACTIONS(3092),
    [anon_sym___stdcall] = ACTIONS(3092),
    [anon_sym___fastcall] = ACTIONS(3092),
    [anon_sym___thiscall] = ACTIONS(3092),
    [anon_sym___vectorcall] = ACTIONS(3092),
    [anon_sym_LBRACE] = ACTIONS(3094),
    [anon_sym_signed] = ACTIONS(3092),
    [anon_sym_unsigned] = ACTIONS(3092),
    [anon_sym_long] = ACTIONS(3092),
    [anon_sym_short] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_static] = ACTIONS(3092),
    [anon_sym_register] = ACTIONS(3092),
    [anon_sym_inline] = ACTIONS(3092),
    [anon_sym___inline] = ACTIONS(3092),
    [anon_sym___inline__] = ACTIONS(3092),
    [anon_sym___forceinline] = ACTIONS(3092),
    [anon_sym_thread_local] = ACTIONS(3092),
    [anon_sym___thread] = ACTIONS(3092),
    [anon_sym_const] = ACTIONS(3092),
    [anon_sym_constexpr] = ACTIONS(3092),
    [anon_sym_volatile] = ACTIONS(3092),
    [anon_sym_restrict] = ACTIONS(3092),
    [anon_sym___restrict__] = ACTIONS(3092),
    [anon_sym__Atomic] = ACTIONS(3092),
    [anon_sym__Noreturn] = ACTIONS(3092),
    [anon_sym_noreturn] = ACTIONS(3092),
    [anon_sym_mutable] = ACTIONS(3092),
    [anon_sym_constinit] = ACTIONS(3092),
    [anon_sym_consteval] = ACTIONS(3092),
    [anon_sym_alignas] = ACTIONS(3092),
    [anon_sym__Alignas] = ACTIONS(3092),
    [sym_primitive_type] = ACTIONS(3092),
    [anon_sym_enum] = ACTIONS(3092),
    [anon_sym_class] = ACTIONS(3092),
    [anon_sym_struct] = ACTIONS(3092),
    [anon_sym_union] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_else] = ACTIONS(3092),
    [anon_sym_switch] = ACTIONS(3092),
    [anon_sym_case] = ACTIONS(3092),
    [anon_sym_default] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_break] = ACTIONS(3092),
    [anon_sym_continue] = ACTIONS(3092),
    [anon_sym_goto] = ACTIONS(3092),
    [anon_sym___try] = ACTIONS(3092),
    [anon_sym___leave] = ACTIONS(3092),
    [anon_sym_not] = ACTIONS(3092),
    [anon_sym_compl] = ACTIONS(3092),
    [anon_sym_DASH_DASH] = ACTIONS(3094),
    [anon_sym_PLUS_PLUS] = ACTIONS(3094),
    [anon_sym_sizeof] = ACTIONS(3092),
    [anon_sym___alignof__] = ACTIONS(3092),
    [anon_sym___alignof] = ACTIONS(3092),
    [anon_sym__alignof] = ACTIONS(3092),
    [anon_sym_alignof] = ACTIONS(3092),
    [anon_sym__Alignof] = ACTIONS(3092),
    [anon_sym_offsetof] = ACTIONS(3092),
    [anon_sym__Generic] = ACTIONS(3092),
    [anon_sym_asm] = ACTIONS(3092),
    [anon_sym___asm__] = ACTIONS(3092),
    [sym_number_literal] = ACTIONS(3094),
    [anon_sym_L_SQUOTE] = ACTIONS(3094),
    [anon_sym_u_SQUOTE] = ACTIONS(3094),
    [anon_sym_U_SQUOTE] = ACTIONS(3094),
    [anon_sym_u8_SQUOTE] = ACTIONS(3094),
    [anon_sym_SQUOTE] = ACTIONS(3094),
    [anon_sym_L_DQUOTE] = ACTIONS(3094),
    [anon_sym_u_DQUOTE] = ACTIONS(3094),
    [anon_sym_U_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8_DQUOTE] = ACTIONS(3094),
    [anon_sym_DQUOTE] = ACTIONS(3094),
    [sym_true] = ACTIONS(3092),
    [sym_false] = ACTIONS(3092),
    [anon_sym_NULL] = ACTIONS(3092),
    [anon_sym_nullptr] = ACTIONS(3092),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3092),
    [anon_sym_let] = ACTIONS(3092),
    [anon_sym_This] = ACTIONS(3092),
    [anon_sym_decltype] = ACTIONS(3092),
    [sym_virtual] = ACTIONS(3092),
    [anon_sym_explicit] = ACTIONS(3092),
    [anon_sym_typename] = ACTIONS(3092),
    [anon_sym_template] = ACTIONS(3092),
    [anon_sym_operator] = ACTIONS(3092),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_delete] = ACTIONS(3092),
    [anon_sym_throw] = ACTIONS(3092),
    [anon_sym_namespace] = ACTIONS(3092),
    [anon_sym_using] = ACTIONS(3092),
    [anon_sym_static_assert] = ACTIONS(3092),
    [anon_sym_concept] = ACTIONS(3092),
    [anon_sym_co_return] = ACTIONS(3092),
    [anon_sym_co_yield] = ACTIONS(3092),
    [anon_sym_R_DQUOTE] = ACTIONS(3094),
    [anon_sym_LR_DQUOTE] = ACTIONS(3094),
    [anon_sym_uR_DQUOTE] = ACTIONS(3094),
    [anon_sym_UR_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3094),
    [anon_sym_co_await] = ACTIONS(3092),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_requires] = ACTIONS(3092),
    [sym_this] = ACTIONS(3092),
    [anon_sym_discard] = ACTIONS(3092),
    [anon_sym_precise] = ACTIONS(3092),
    [anon_sym_shared] = ACTIONS(3092),
    [anon_sym_groupshared] = ACTIONS(3092),
    [anon_sym_uniform] = ACTIONS(3092),
    [anon_sym_row_major] = ACTIONS(3092),
    [anon_sym_column_major] = ACTIONS(3092),
    [anon_sym_globallycoherent] = ACTIONS(3092),
    [anon_sym_centroid] = ACTIONS(3092),
    [anon_sym_noperspective] = ACTIONS(3092),
    [anon_sym_nointerpolation] = ACTIONS(3092),
    [anon_sym_sample] = ACTIONS(3092),
    [anon_sym_linear] = ACTIONS(3092),
    [anon_sym_snorm] = ACTIONS(3092),
    [anon_sym_unorm] = ACTIONS(3092),
    [anon_sym_point] = ACTIONS(3092),
    [anon_sym_line] = ACTIONS(3092),
    [anon_sym_triangleadj] = ACTIONS(3092),
    [anon_sym_lineadj] = ACTIONS(3092),
    [anon_sym_triangle] = ACTIONS(3092),
    [anon_sym_cbuffer] = ACTIONS(3092),
    [anon_sym_interface] = ACTIONS(3092),
    [anon_sym_extension] = ACTIONS(3092),
  },
  [361] = {
    [ts_builtin_sym_end] = ACTIONS(2740),
    [sym_identifier] = ACTIONS(2742),
    [aux_sym_preproc_include_token1] = ACTIONS(2742),
    [aux_sym_preproc_def_token1] = ACTIONS(2742),
    [anon_sym_COMMA] = ACTIONS(2740),
    [anon_sym_RPAREN] = ACTIONS(2740),
    [aux_sym_preproc_if_token1] = ACTIONS(2742),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2742),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2742),
    [sym_preproc_directive] = ACTIONS(2742),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_BANG] = ACTIONS(2740),
    [anon_sym_TILDE] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2742),
    [anon_sym_PLUS] = ACTIONS(2742),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym___extension__] = ACTIONS(2742),
    [anon_sym_typedef] = ACTIONS(2742),
    [anon_sym_in] = ACTIONS(2742),
    [anon_sym_out] = ACTIONS(2742),
    [anon_sym_inout] = ACTIONS(2742),
    [anon_sym_extern] = ACTIONS(2742),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym_COLON_COLON] = ACTIONS(2740),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2740),
    [anon_sym___declspec] = ACTIONS(2742),
    [anon_sym___based] = ACTIONS(2742),
    [anon_sym___cdecl] = ACTIONS(2742),
    [anon_sym___clrcall] = ACTIONS(2742),
    [anon_sym___stdcall] = ACTIONS(2742),
    [anon_sym___fastcall] = ACTIONS(2742),
    [anon_sym___thiscall] = ACTIONS(2742),
    [anon_sym___vectorcall] = ACTIONS(2742),
    [anon_sym_LBRACE] = ACTIONS(2740),
    [anon_sym_signed] = ACTIONS(2742),
    [anon_sym_unsigned] = ACTIONS(2742),
    [anon_sym_long] = ACTIONS(2742),
    [anon_sym_short] = ACTIONS(2742),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2742),
    [anon_sym_register] = ACTIONS(2742),
    [anon_sym_inline] = ACTIONS(2742),
    [anon_sym___inline] = ACTIONS(2742),
    [anon_sym___inline__] = ACTIONS(2742),
    [anon_sym___forceinline] = ACTIONS(2742),
    [anon_sym_thread_local] = ACTIONS(2742),
    [anon_sym___thread] = ACTIONS(2742),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_constexpr] = ACTIONS(2742),
    [anon_sym_volatile] = ACTIONS(2742),
    [anon_sym_restrict] = ACTIONS(2742),
    [anon_sym___restrict__] = ACTIONS(2742),
    [anon_sym__Atomic] = ACTIONS(2742),
    [anon_sym__Noreturn] = ACTIONS(2742),
    [anon_sym_noreturn] = ACTIONS(2742),
    [anon_sym_mutable] = ACTIONS(2742),
    [anon_sym_constinit] = ACTIONS(2742),
    [anon_sym_consteval] = ACTIONS(2742),
    [anon_sym_alignas] = ACTIONS(2742),
    [anon_sym__Alignas] = ACTIONS(2742),
    [sym_primitive_type] = ACTIONS(2742),
    [anon_sym_enum] = ACTIONS(2742),
    [anon_sym_class] = ACTIONS(2742),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2742),
    [anon_sym_if] = ACTIONS(2742),
    [anon_sym_switch] = ACTIONS(2742),
    [anon_sym_case] = ACTIONS(2742),
    [anon_sym_default] = ACTIONS(2742),
    [anon_sym_while] = ACTIONS(2742),
    [anon_sym_do] = ACTIONS(2742),
    [anon_sym_for] = ACTIONS(2742),
    [anon_sym_return] = ACTIONS(2742),
    [anon_sym_break] = ACTIONS(2742),
    [anon_sym_continue] = ACTIONS(2742),
    [anon_sym_goto] = ACTIONS(2742),
    [anon_sym_not] = ACTIONS(2742),
    [anon_sym_compl] = ACTIONS(2742),
    [anon_sym_DASH_DASH] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2740),
    [anon_sym_sizeof] = ACTIONS(2742),
    [anon_sym___alignof__] = ACTIONS(2742),
    [anon_sym___alignof] = ACTIONS(2742),
    [anon_sym__alignof] = ACTIONS(2742),
    [anon_sym_alignof] = ACTIONS(2742),
    [anon_sym__Alignof] = ACTIONS(2742),
    [anon_sym_offsetof] = ACTIONS(2742),
    [anon_sym__Generic] = ACTIONS(2742),
    [anon_sym_asm] = ACTIONS(2742),
    [anon_sym___asm__] = ACTIONS(2742),
    [anon_sym_DOT] = ACTIONS(2742),
    [sym_number_literal] = ACTIONS(2740),
    [anon_sym_L_SQUOTE] = ACTIONS(2740),
    [anon_sym_u_SQUOTE] = ACTIONS(2740),
    [anon_sym_U_SQUOTE] = ACTIONS(2740),
    [anon_sym_u8_SQUOTE] = ACTIONS(2740),
    [anon_sym_SQUOTE] = ACTIONS(2740),
    [anon_sym_L_DQUOTE] = ACTIONS(2740),
    [anon_sym_u_DQUOTE] = ACTIONS(2740),
    [anon_sym_U_DQUOTE] = ACTIONS(2740),
    [anon_sym_u8_DQUOTE] = ACTIONS(2740),
    [anon_sym_DQUOTE] = ACTIONS(2740),
    [sym_true] = ACTIONS(2742),
    [sym_false] = ACTIONS(2742),
    [anon_sym_NULL] = ACTIONS(2742),
    [anon_sym_nullptr] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
    [anon_sym_decltype] = ACTIONS(2742),
    [anon_sym_final] = ACTIONS(2742),
    [anon_sym_override] = ACTIONS(2742),
    [sym_virtual] = ACTIONS(2742),
    [anon_sym_explicit] = ACTIONS(2742),
    [anon_sym_typename] = ACTIONS(2742),
    [anon_sym_template] = ACTIONS(2742),
    [anon_sym_GT2] = ACTIONS(2740),
    [anon_sym_operator] = ACTIONS(2742),
    [anon_sym_try] = ACTIONS(2742),
    [anon_sym_delete] = ACTIONS(2742),
    [anon_sym_throw] = ACTIONS(2742),
    [anon_sym_namespace] = ACTIONS(2742),
    [anon_sym_using] = ACTIONS(2742),
    [anon_sym_static_assert] = ACTIONS(2742),
    [anon_sym_concept] = ACTIONS(2742),
    [anon_sym_co_return] = ACTIONS(2742),
    [anon_sym_co_yield] = ACTIONS(2742),
    [anon_sym_R_DQUOTE] = ACTIONS(2740),
    [anon_sym_LR_DQUOTE] = ACTIONS(2740),
    [anon_sym_uR_DQUOTE] = ACTIONS(2740),
    [anon_sym_UR_DQUOTE] = ACTIONS(2740),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2740),
    [anon_sym_co_await] = ACTIONS(2742),
    [anon_sym_new] = ACTIONS(2742),
    [anon_sym_requires] = ACTIONS(2742),
    [sym_this] = ACTIONS(2742),
    [anon_sym_precise] = ACTIONS(2742),
    [anon_sym_shared] = ACTIONS(2742),
    [anon_sym_groupshared] = ACTIONS(2742),
    [anon_sym_uniform] = ACTIONS(2742),
    [anon_sym_row_major] = ACTIONS(2742),
    [anon_sym_column_major] = ACTIONS(2742),
    [anon_sym_globallycoherent] = ACTIONS(2742),
    [anon_sym_centroid] = ACTIONS(2742),
    [anon_sym_noperspective] = ACTIONS(2742),
    [anon_sym_nointerpolation] = ACTIONS(2742),
    [anon_sym_sample] = ACTIONS(2742),
    [anon_sym_linear] = ACTIONS(2742),
    [anon_sym_snorm] = ACTIONS(2742),
    [anon_sym_unorm] = ACTIONS(2742),
    [anon_sym_point] = ACTIONS(2742),
    [anon_sym_line] = ACTIONS(2742),
    [anon_sym_triangleadj] = ACTIONS(2742),
    [anon_sym_lineadj] = ACTIONS(2742),
    [anon_sym_triangle] = ACTIONS(2742),
    [anon_sym_interface] = ACTIONS(2742),
    [anon_sym_extension] = ACTIONS(2742),
    [anon_sym_where] = ACTIONS(2742),
    [anon_sym___exported] = ACTIONS(2742),
    [anon_sym_import] = ACTIONS(2742),
  },
  [362] = {
    [sym_identifier] = ACTIONS(2236),
    [aux_sym_preproc_include_token1] = ACTIONS(2236),
    [aux_sym_preproc_def_token1] = ACTIONS(2236),
    [aux_sym_preproc_if_token1] = ACTIONS(2236),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2236),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2236),
    [sym_preproc_directive] = ACTIONS(2236),
    [anon_sym_LPAREN2] = ACTIONS(2238),
    [anon_sym_BANG] = ACTIONS(2238),
    [anon_sym_TILDE] = ACTIONS(2238),
    [anon_sym_DASH] = ACTIONS(2236),
    [anon_sym_PLUS] = ACTIONS(2236),
    [anon_sym_STAR] = ACTIONS(2238),
    [anon_sym_AMP_AMP] = ACTIONS(2238),
    [anon_sym_AMP] = ACTIONS(2236),
    [anon_sym_COLON] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(2238),
    [anon_sym___extension__] = ACTIONS(2236),
    [anon_sym_typedef] = ACTIONS(2236),
    [anon_sym_in] = ACTIONS(2236),
    [anon_sym_out] = ACTIONS(2236),
    [anon_sym_inout] = ACTIONS(2236),
    [anon_sym_extern] = ACTIONS(2236),
    [anon_sym___attribute__] = ACTIONS(2236),
    [anon_sym_COLON_COLON] = ACTIONS(2238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2238),
    [anon_sym___declspec] = ACTIONS(2236),
    [anon_sym___based] = ACTIONS(2236),
    [anon_sym___cdecl] = ACTIONS(2236),
    [anon_sym___clrcall] = ACTIONS(2236),
    [anon_sym___stdcall] = ACTIONS(2236),
    [anon_sym___fastcall] = ACTIONS(2236),
    [anon_sym___thiscall] = ACTIONS(2236),
    [anon_sym___vectorcall] = ACTIONS(2236),
    [anon_sym_LBRACE] = ACTIONS(2238),
    [anon_sym_RBRACE] = ACTIONS(2238),
    [anon_sym_signed] = ACTIONS(2236),
    [anon_sym_unsigned] = ACTIONS(2236),
    [anon_sym_long] = ACTIONS(2236),
    [anon_sym_short] = ACTIONS(2236),
    [anon_sym_LBRACK] = ACTIONS(2236),
    [anon_sym_static] = ACTIONS(2236),
    [anon_sym_register] = ACTIONS(2236),
    [anon_sym_inline] = ACTIONS(2236),
    [anon_sym___inline] = ACTIONS(2236),
    [anon_sym___inline__] = ACTIONS(2236),
    [anon_sym___forceinline] = ACTIONS(2236),
    [anon_sym_thread_local] = ACTIONS(2236),
    [anon_sym___thread] = ACTIONS(2236),
    [anon_sym_const] = ACTIONS(2236),
    [anon_sym_constexpr] = ACTIONS(2236),
    [anon_sym_volatile] = ACTIONS(2236),
    [anon_sym_restrict] = ACTIONS(2236),
    [anon_sym___restrict__] = ACTIONS(2236),
    [anon_sym__Atomic] = ACTIONS(2236),
    [anon_sym__Noreturn] = ACTIONS(2236),
    [anon_sym_noreturn] = ACTIONS(2236),
    [anon_sym_mutable] = ACTIONS(2236),
    [anon_sym_constinit] = ACTIONS(2236),
    [anon_sym_consteval] = ACTIONS(2236),
    [anon_sym_alignas] = ACTIONS(2236),
    [anon_sym__Alignas] = ACTIONS(2236),
    [sym_primitive_type] = ACTIONS(2236),
    [anon_sym_enum] = ACTIONS(2236),
    [anon_sym_class] = ACTIONS(2236),
    [anon_sym_struct] = ACTIONS(2236),
    [anon_sym_union] = ACTIONS(2236),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_else] = ACTIONS(2236),
    [anon_sym_switch] = ACTIONS(2236),
    [anon_sym_case] = ACTIONS(2236),
    [anon_sym_default] = ACTIONS(2236),
    [anon_sym_while] = ACTIONS(2236),
    [anon_sym_do] = ACTIONS(2236),
    [anon_sym_for] = ACTIONS(2236),
    [anon_sym_return] = ACTIONS(2236),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2236),
    [anon_sym_goto] = ACTIONS(2236),
    [anon_sym___try] = ACTIONS(2236),
    [anon_sym___leave] = ACTIONS(2236),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_compl] = ACTIONS(2236),
    [anon_sym_DASH_DASH] = ACTIONS(2238),
    [anon_sym_PLUS_PLUS] = ACTIONS(2238),
    [anon_sym_sizeof] = ACTIONS(2236),
    [anon_sym___alignof__] = ACTIONS(2236),
    [anon_sym___alignof] = ACTIONS(2236),
    [anon_sym__alignof] = ACTIONS(2236),
    [anon_sym_alignof] = ACTIONS(2236),
    [anon_sym__Alignof] = ACTIONS(2236),
    [anon_sym_offsetof] = ACTIONS(2236),
    [anon_sym__Generic] = ACTIONS(2236),
    [anon_sym_asm] = ACTIONS(2236),
    [anon_sym___asm__] = ACTIONS(2236),
    [anon_sym_DOT] = ACTIONS(2236),
    [sym_number_literal] = ACTIONS(2238),
    [anon_sym_L_SQUOTE] = ACTIONS(2238),
    [anon_sym_u_SQUOTE] = ACTIONS(2238),
    [anon_sym_U_SQUOTE] = ACTIONS(2238),
    [anon_sym_u8_SQUOTE] = ACTIONS(2238),
    [anon_sym_SQUOTE] = ACTIONS(2238),
    [anon_sym_L_DQUOTE] = ACTIONS(2238),
    [anon_sym_u_DQUOTE] = ACTIONS(2238),
    [anon_sym_U_DQUOTE] = ACTIONS(2238),
    [anon_sym_u8_DQUOTE] = ACTIONS(2238),
    [anon_sym_DQUOTE] = ACTIONS(2238),
    [sym_true] = ACTIONS(2236),
    [sym_false] = ACTIONS(2236),
    [anon_sym_NULL] = ACTIONS(2236),
    [anon_sym_nullptr] = ACTIONS(2236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2236),
    [anon_sym_let] = ACTIONS(2236),
    [anon_sym_This] = ACTIONS(2236),
    [anon_sym_decltype] = ACTIONS(2236),
    [anon_sym_final] = ACTIONS(2236),
    [anon_sym_override] = ACTIONS(2236),
    [sym_virtual] = ACTIONS(2236),
    [anon_sym_explicit] = ACTIONS(2236),
    [anon_sym_typename] = ACTIONS(2236),
    [anon_sym_template] = ACTIONS(2236),
    [anon_sym_operator] = ACTIONS(2236),
    [anon_sym_try] = ACTIONS(2236),
    [anon_sym_delete] = ACTIONS(2236),
    [anon_sym_throw] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(2236),
    [anon_sym_using] = ACTIONS(2236),
    [anon_sym_static_assert] = ACTIONS(2236),
    [anon_sym_concept] = ACTIONS(2236),
    [anon_sym_co_return] = ACTIONS(2236),
    [anon_sym_co_yield] = ACTIONS(2236),
    [anon_sym_R_DQUOTE] = ACTIONS(2238),
    [anon_sym_LR_DQUOTE] = ACTIONS(2238),
    [anon_sym_uR_DQUOTE] = ACTIONS(2238),
    [anon_sym_UR_DQUOTE] = ACTIONS(2238),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2238),
    [anon_sym_co_await] = ACTIONS(2236),
    [anon_sym_new] = ACTIONS(2236),
    [anon_sym_requires] = ACTIONS(2236),
    [sym_this] = ACTIONS(2236),
    [anon_sym_discard] = ACTIONS(2236),
    [anon_sym_precise] = ACTIONS(2236),
    [anon_sym_shared] = ACTIONS(2236),
    [anon_sym_groupshared] = ACTIONS(2236),
    [anon_sym_uniform] = ACTIONS(2236),
    [anon_sym_row_major] = ACTIONS(2236),
    [anon_sym_column_major] = ACTIONS(2236),
    [anon_sym_globallycoherent] = ACTIONS(2236),
    [anon_sym_centroid] = ACTIONS(2236),
    [anon_sym_noperspective] = ACTIONS(2236),
    [anon_sym_nointerpolation] = ACTIONS(2236),
    [anon_sym_sample] = ACTIONS(2236),
    [anon_sym_linear] = ACTIONS(2236),
    [anon_sym_snorm] = ACTIONS(2236),
    [anon_sym_unorm] = ACTIONS(2236),
    [anon_sym_point] = ACTIONS(2236),
    [anon_sym_line] = ACTIONS(2236),
    [anon_sym_triangleadj] = ACTIONS(2236),
    [anon_sym_lineadj] = ACTIONS(2236),
    [anon_sym_triangle] = ACTIONS(2236),
    [anon_sym_cbuffer] = ACTIONS(2236),
    [anon_sym_interface] = ACTIONS(2236),
    [anon_sym_extension] = ACTIONS(2236),
  },
  [363] = {
    [sym_identifier] = ACTIONS(2224),
    [aux_sym_preproc_include_token1] = ACTIONS(2224),
    [aux_sym_preproc_def_token1] = ACTIONS(2224),
    [aux_sym_preproc_if_token1] = ACTIONS(2224),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2224),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2224),
    [sym_preproc_directive] = ACTIONS(2224),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_BANG] = ACTIONS(2226),
    [anon_sym_TILDE] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_PLUS] = ACTIONS(2224),
    [anon_sym_STAR] = ACTIONS(2226),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_AMP] = ACTIONS(2224),
    [anon_sym_COLON] = ACTIONS(2224),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym___extension__] = ACTIONS(2224),
    [anon_sym_typedef] = ACTIONS(2224),
    [anon_sym_in] = ACTIONS(2224),
    [anon_sym_out] = ACTIONS(2224),
    [anon_sym_inout] = ACTIONS(2224),
    [anon_sym_extern] = ACTIONS(2224),
    [anon_sym___attribute__] = ACTIONS(2224),
    [anon_sym_COLON_COLON] = ACTIONS(2226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2226),
    [anon_sym___declspec] = ACTIONS(2224),
    [anon_sym___based] = ACTIONS(2224),
    [anon_sym___cdecl] = ACTIONS(2224),
    [anon_sym___clrcall] = ACTIONS(2224),
    [anon_sym___stdcall] = ACTIONS(2224),
    [anon_sym___fastcall] = ACTIONS(2224),
    [anon_sym___thiscall] = ACTIONS(2224),
    [anon_sym___vectorcall] = ACTIONS(2224),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_RBRACE] = ACTIONS(2226),
    [anon_sym_signed] = ACTIONS(2224),
    [anon_sym_unsigned] = ACTIONS(2224),
    [anon_sym_long] = ACTIONS(2224),
    [anon_sym_short] = ACTIONS(2224),
    [anon_sym_LBRACK] = ACTIONS(2224),
    [anon_sym_static] = ACTIONS(2224),
    [anon_sym_register] = ACTIONS(2224),
    [anon_sym_inline] = ACTIONS(2224),
    [anon_sym___inline] = ACTIONS(2224),
    [anon_sym___inline__] = ACTIONS(2224),
    [anon_sym___forceinline] = ACTIONS(2224),
    [anon_sym_thread_local] = ACTIONS(2224),
    [anon_sym___thread] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_constexpr] = ACTIONS(2224),
    [anon_sym_volatile] = ACTIONS(2224),
    [anon_sym_restrict] = ACTIONS(2224),
    [anon_sym___restrict__] = ACTIONS(2224),
    [anon_sym__Atomic] = ACTIONS(2224),
    [anon_sym__Noreturn] = ACTIONS(2224),
    [anon_sym_noreturn] = ACTIONS(2224),
    [anon_sym_mutable] = ACTIONS(2224),
    [anon_sym_constinit] = ACTIONS(2224),
    [anon_sym_consteval] = ACTIONS(2224),
    [anon_sym_alignas] = ACTIONS(2224),
    [anon_sym__Alignas] = ACTIONS(2224),
    [sym_primitive_type] = ACTIONS(2224),
    [anon_sym_enum] = ACTIONS(2224),
    [anon_sym_class] = ACTIONS(2224),
    [anon_sym_struct] = ACTIONS(2224),
    [anon_sym_union] = ACTIONS(2224),
    [anon_sym_if] = ACTIONS(2224),
    [anon_sym_else] = ACTIONS(2224),
    [anon_sym_switch] = ACTIONS(2224),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2224),
    [anon_sym_while] = ACTIONS(2224),
    [anon_sym_do] = ACTIONS(2224),
    [anon_sym_for] = ACTIONS(2224),
    [anon_sym_return] = ACTIONS(2224),
    [anon_sym_break] = ACTIONS(2224),
    [anon_sym_continue] = ACTIONS(2224),
    [anon_sym_goto] = ACTIONS(2224),
    [anon_sym___try] = ACTIONS(2224),
    [anon_sym___leave] = ACTIONS(2224),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_compl] = ACTIONS(2224),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_sizeof] = ACTIONS(2224),
    [anon_sym___alignof__] = ACTIONS(2224),
    [anon_sym___alignof] = ACTIONS(2224),
    [anon_sym__alignof] = ACTIONS(2224),
    [anon_sym_alignof] = ACTIONS(2224),
    [anon_sym__Alignof] = ACTIONS(2224),
    [anon_sym_offsetof] = ACTIONS(2224),
    [anon_sym__Generic] = ACTIONS(2224),
    [anon_sym_asm] = ACTIONS(2224),
    [anon_sym___asm__] = ACTIONS(2224),
    [anon_sym_DOT] = ACTIONS(2224),
    [sym_number_literal] = ACTIONS(2226),
    [anon_sym_L_SQUOTE] = ACTIONS(2226),
    [anon_sym_u_SQUOTE] = ACTIONS(2226),
    [anon_sym_U_SQUOTE] = ACTIONS(2226),
    [anon_sym_u8_SQUOTE] = ACTIONS(2226),
    [anon_sym_SQUOTE] = ACTIONS(2226),
    [anon_sym_L_DQUOTE] = ACTIONS(2226),
    [anon_sym_u_DQUOTE] = ACTIONS(2226),
    [anon_sym_U_DQUOTE] = ACTIONS(2226),
    [anon_sym_u8_DQUOTE] = ACTIONS(2226),
    [anon_sym_DQUOTE] = ACTIONS(2226),
    [sym_true] = ACTIONS(2224),
    [sym_false] = ACTIONS(2224),
    [anon_sym_NULL] = ACTIONS(2224),
    [anon_sym_nullptr] = ACTIONS(2224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2224),
    [anon_sym_let] = ACTIONS(2224),
    [anon_sym_This] = ACTIONS(2224),
    [anon_sym_decltype] = ACTIONS(2224),
    [anon_sym_final] = ACTIONS(2224),
    [anon_sym_override] = ACTIONS(2224),
    [sym_virtual] = ACTIONS(2224),
    [anon_sym_explicit] = ACTIONS(2224),
    [anon_sym_typename] = ACTIONS(2224),
    [anon_sym_template] = ACTIONS(2224),
    [anon_sym_operator] = ACTIONS(2224),
    [anon_sym_try] = ACTIONS(2224),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_throw] = ACTIONS(2224),
    [anon_sym_namespace] = ACTIONS(2224),
    [anon_sym_using] = ACTIONS(2224),
    [anon_sym_static_assert] = ACTIONS(2224),
    [anon_sym_concept] = ACTIONS(2224),
    [anon_sym_co_return] = ACTIONS(2224),
    [anon_sym_co_yield] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(2226),
    [anon_sym_LR_DQUOTE] = ACTIONS(2226),
    [anon_sym_uR_DQUOTE] = ACTIONS(2226),
    [anon_sym_UR_DQUOTE] = ACTIONS(2226),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2226),
    [anon_sym_co_await] = ACTIONS(2224),
    [anon_sym_new] = ACTIONS(2224),
    [anon_sym_requires] = ACTIONS(2224),
    [sym_this] = ACTIONS(2224),
    [anon_sym_discard] = ACTIONS(2224),
    [anon_sym_precise] = ACTIONS(2224),
    [anon_sym_shared] = ACTIONS(2224),
    [anon_sym_groupshared] = ACTIONS(2224),
    [anon_sym_uniform] = ACTIONS(2224),
    [anon_sym_row_major] = ACTIONS(2224),
    [anon_sym_column_major] = ACTIONS(2224),
    [anon_sym_globallycoherent] = ACTIONS(2224),
    [anon_sym_centroid] = ACTIONS(2224),
    [anon_sym_noperspective] = ACTIONS(2224),
    [anon_sym_nointerpolation] = ACTIONS(2224),
    [anon_sym_sample] = ACTIONS(2224),
    [anon_sym_linear] = ACTIONS(2224),
    [anon_sym_snorm] = ACTIONS(2224),
    [anon_sym_unorm] = ACTIONS(2224),
    [anon_sym_point] = ACTIONS(2224),
    [anon_sym_line] = ACTIONS(2224),
    [anon_sym_triangleadj] = ACTIONS(2224),
    [anon_sym_lineadj] = ACTIONS(2224),
    [anon_sym_triangle] = ACTIONS(2224),
    [anon_sym_cbuffer] = ACTIONS(2224),
    [anon_sym_interface] = ACTIONS(2224),
    [anon_sym_extension] = ACTIONS(2224),
  },
  [364] = {
    [sym_identifier] = ACTIONS(2186),
    [aux_sym_preproc_include_token1] = ACTIONS(2186),
    [aux_sym_preproc_def_token1] = ACTIONS(2186),
    [aux_sym_preproc_if_token1] = ACTIONS(2186),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2186),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2186),
    [sym_preproc_directive] = ACTIONS(2186),
    [anon_sym_LPAREN2] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2188),
    [anon_sym_TILDE] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2186),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_STAR] = ACTIONS(2188),
    [anon_sym_AMP_AMP] = ACTIONS(2188),
    [anon_sym_AMP] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym___extension__] = ACTIONS(2186),
    [anon_sym_typedef] = ACTIONS(2186),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_out] = ACTIONS(2186),
    [anon_sym_inout] = ACTIONS(2186),
    [anon_sym_extern] = ACTIONS(2186),
    [anon_sym___attribute__] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2188),
    [anon_sym___declspec] = ACTIONS(2186),
    [anon_sym___based] = ACTIONS(2186),
    [anon_sym___cdecl] = ACTIONS(2186),
    [anon_sym___clrcall] = ACTIONS(2186),
    [anon_sym___stdcall] = ACTIONS(2186),
    [anon_sym___fastcall] = ACTIONS(2186),
    [anon_sym___thiscall] = ACTIONS(2186),
    [anon_sym___vectorcall] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_RBRACE] = ACTIONS(2188),
    [anon_sym_signed] = ACTIONS(2186),
    [anon_sym_unsigned] = ACTIONS(2186),
    [anon_sym_long] = ACTIONS(2186),
    [anon_sym_short] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_static] = ACTIONS(2186),
    [anon_sym_register] = ACTIONS(2186),
    [anon_sym_inline] = ACTIONS(2186),
    [anon_sym___inline] = ACTIONS(2186),
    [anon_sym___inline__] = ACTIONS(2186),
    [anon_sym___forceinline] = ACTIONS(2186),
    [anon_sym_thread_local] = ACTIONS(2186),
    [anon_sym___thread] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_constexpr] = ACTIONS(2186),
    [anon_sym_volatile] = ACTIONS(2186),
    [anon_sym_restrict] = ACTIONS(2186),
    [anon_sym___restrict__] = ACTIONS(2186),
    [anon_sym__Atomic] = ACTIONS(2186),
    [anon_sym__Noreturn] = ACTIONS(2186),
    [anon_sym_noreturn] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_constinit] = ACTIONS(2186),
    [anon_sym_consteval] = ACTIONS(2186),
    [anon_sym_alignas] = ACTIONS(2186),
    [anon_sym__Alignas] = ACTIONS(2186),
    [sym_primitive_type] = ACTIONS(2186),
    [anon_sym_enum] = ACTIONS(2186),
    [anon_sym_class] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_union] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_switch] = ACTIONS(2186),
    [anon_sym_case] = ACTIONS(2186),
    [anon_sym_default] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [anon_sym_do] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_break] = ACTIONS(2186),
    [anon_sym_continue] = ACTIONS(2186),
    [anon_sym_goto] = ACTIONS(2186),
    [anon_sym___try] = ACTIONS(2186),
    [anon_sym___leave] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2186),
    [anon_sym_compl] = ACTIONS(2186),
    [anon_sym_DASH_DASH] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2188),
    [anon_sym_sizeof] = ACTIONS(2186),
    [anon_sym___alignof__] = ACTIONS(2186),
    [anon_sym___alignof] = ACTIONS(2186),
    [anon_sym__alignof] = ACTIONS(2186),
    [anon_sym_alignof] = ACTIONS(2186),
    [anon_sym__Alignof] = ACTIONS(2186),
    [anon_sym_offsetof] = ACTIONS(2186),
    [anon_sym__Generic] = ACTIONS(2186),
    [anon_sym_asm] = ACTIONS(2186),
    [anon_sym___asm__] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [sym_number_literal] = ACTIONS(2188),
    [anon_sym_L_SQUOTE] = ACTIONS(2188),
    [anon_sym_u_SQUOTE] = ACTIONS(2188),
    [anon_sym_U_SQUOTE] = ACTIONS(2188),
    [anon_sym_u8_SQUOTE] = ACTIONS(2188),
    [anon_sym_SQUOTE] = ACTIONS(2188),
    [anon_sym_L_DQUOTE] = ACTIONS(2188),
    [anon_sym_u_DQUOTE] = ACTIONS(2188),
    [anon_sym_U_DQUOTE] = ACTIONS(2188),
    [anon_sym_u8_DQUOTE] = ACTIONS(2188),
    [anon_sym_DQUOTE] = ACTIONS(2188),
    [sym_true] = ACTIONS(2186),
    [sym_false] = ACTIONS(2186),
    [anon_sym_NULL] = ACTIONS(2186),
    [anon_sym_nullptr] = ACTIONS(2186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_This] = ACTIONS(2186),
    [anon_sym_decltype] = ACTIONS(2186),
    [anon_sym_final] = ACTIONS(2186),
    [anon_sym_override] = ACTIONS(2186),
    [sym_virtual] = ACTIONS(2186),
    [anon_sym_explicit] = ACTIONS(2186),
    [anon_sym_typename] = ACTIONS(2186),
    [anon_sym_template] = ACTIONS(2186),
    [anon_sym_operator] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_delete] = ACTIONS(2186),
    [anon_sym_throw] = ACTIONS(2186),
    [anon_sym_namespace] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_static_assert] = ACTIONS(2186),
    [anon_sym_concept] = ACTIONS(2186),
    [anon_sym_co_return] = ACTIONS(2186),
    [anon_sym_co_yield] = ACTIONS(2186),
    [anon_sym_R_DQUOTE] = ACTIONS(2188),
    [anon_sym_LR_DQUOTE] = ACTIONS(2188),
    [anon_sym_uR_DQUOTE] = ACTIONS(2188),
    [anon_sym_UR_DQUOTE] = ACTIONS(2188),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2188),
    [anon_sym_co_await] = ACTIONS(2186),
    [anon_sym_new] = ACTIONS(2186),
    [anon_sym_requires] = ACTIONS(2186),
    [sym_this] = ACTIONS(2186),
    [anon_sym_discard] = ACTIONS(2186),
    [anon_sym_precise] = ACTIONS(2186),
    [anon_sym_shared] = ACTIONS(2186),
    [anon_sym_groupshared] = ACTIONS(2186),
    [anon_sym_uniform] = ACTIONS(2186),
    [anon_sym_row_major] = ACTIONS(2186),
    [anon_sym_column_major] = ACTIONS(2186),
    [anon_sym_globallycoherent] = ACTIONS(2186),
    [anon_sym_centroid] = ACTIONS(2186),
    [anon_sym_noperspective] = ACTIONS(2186),
    [anon_sym_nointerpolation] = ACTIONS(2186),
    [anon_sym_sample] = ACTIONS(2186),
    [anon_sym_linear] = ACTIONS(2186),
    [anon_sym_snorm] = ACTIONS(2186),
    [anon_sym_unorm] = ACTIONS(2186),
    [anon_sym_point] = ACTIONS(2186),
    [anon_sym_line] = ACTIONS(2186),
    [anon_sym_triangleadj] = ACTIONS(2186),
    [anon_sym_lineadj] = ACTIONS(2186),
    [anon_sym_triangle] = ACTIONS(2186),
    [anon_sym_cbuffer] = ACTIONS(2186),
    [anon_sym_interface] = ACTIONS(2186),
    [anon_sym_extension] = ACTIONS(2186),
  },
  [365] = {
    [sym_identifier] = ACTIONS(2198),
    [aux_sym_preproc_include_token1] = ACTIONS(2198),
    [aux_sym_preproc_def_token1] = ACTIONS(2198),
    [aux_sym_preproc_if_token1] = ACTIONS(2198),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2198),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2198),
    [sym_preproc_directive] = ACTIONS(2198),
    [anon_sym_LPAREN2] = ACTIONS(2200),
    [anon_sym_BANG] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(2200),
    [anon_sym_AMP_AMP] = ACTIONS(2200),
    [anon_sym_AMP] = ACTIONS(2198),
    [anon_sym_COLON] = ACTIONS(2198),
    [anon_sym_SEMI] = ACTIONS(2200),
    [anon_sym___extension__] = ACTIONS(2198),
    [anon_sym_typedef] = ACTIONS(2198),
    [anon_sym_in] = ACTIONS(2198),
    [anon_sym_out] = ACTIONS(2198),
    [anon_sym_inout] = ACTIONS(2198),
    [anon_sym_extern] = ACTIONS(2198),
    [anon_sym___attribute__] = ACTIONS(2198),
    [anon_sym_COLON_COLON] = ACTIONS(2200),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2200),
    [anon_sym___declspec] = ACTIONS(2198),
    [anon_sym___based] = ACTIONS(2198),
    [anon_sym___cdecl] = ACTIONS(2198),
    [anon_sym___clrcall] = ACTIONS(2198),
    [anon_sym___stdcall] = ACTIONS(2198),
    [anon_sym___fastcall] = ACTIONS(2198),
    [anon_sym___thiscall] = ACTIONS(2198),
    [anon_sym___vectorcall] = ACTIONS(2198),
    [anon_sym_LBRACE] = ACTIONS(2200),
    [anon_sym_RBRACE] = ACTIONS(2200),
    [anon_sym_signed] = ACTIONS(2198),
    [anon_sym_unsigned] = ACTIONS(2198),
    [anon_sym_long] = ACTIONS(2198),
    [anon_sym_short] = ACTIONS(2198),
    [anon_sym_LBRACK] = ACTIONS(2198),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_register] = ACTIONS(2198),
    [anon_sym_inline] = ACTIONS(2198),
    [anon_sym___inline] = ACTIONS(2198),
    [anon_sym___inline__] = ACTIONS(2198),
    [anon_sym___forceinline] = ACTIONS(2198),
    [anon_sym_thread_local] = ACTIONS(2198),
    [anon_sym___thread] = ACTIONS(2198),
    [anon_sym_const] = ACTIONS(2198),
    [anon_sym_constexpr] = ACTIONS(2198),
    [anon_sym_volatile] = ACTIONS(2198),
    [anon_sym_restrict] = ACTIONS(2198),
    [anon_sym___restrict__] = ACTIONS(2198),
    [anon_sym__Atomic] = ACTIONS(2198),
    [anon_sym__Noreturn] = ACTIONS(2198),
    [anon_sym_noreturn] = ACTIONS(2198),
    [anon_sym_mutable] = ACTIONS(2198),
    [anon_sym_constinit] = ACTIONS(2198),
    [anon_sym_consteval] = ACTIONS(2198),
    [anon_sym_alignas] = ACTIONS(2198),
    [anon_sym__Alignas] = ACTIONS(2198),
    [sym_primitive_type] = ACTIONS(2198),
    [anon_sym_enum] = ACTIONS(2198),
    [anon_sym_class] = ACTIONS(2198),
    [anon_sym_struct] = ACTIONS(2198),
    [anon_sym_union] = ACTIONS(2198),
    [anon_sym_if] = ACTIONS(2198),
    [anon_sym_else] = ACTIONS(2198),
    [anon_sym_switch] = ACTIONS(2198),
    [anon_sym_case] = ACTIONS(2198),
    [anon_sym_default] = ACTIONS(2198),
    [anon_sym_while] = ACTIONS(2198),
    [anon_sym_do] = ACTIONS(2198),
    [anon_sym_for] = ACTIONS(2198),
    [anon_sym_return] = ACTIONS(2198),
    [anon_sym_break] = ACTIONS(2198),
    [anon_sym_continue] = ACTIONS(2198),
    [anon_sym_goto] = ACTIONS(2198),
    [anon_sym___try] = ACTIONS(2198),
    [anon_sym___leave] = ACTIONS(2198),
    [anon_sym_not] = ACTIONS(2198),
    [anon_sym_compl] = ACTIONS(2198),
    [anon_sym_DASH_DASH] = ACTIONS(2200),
    [anon_sym_PLUS_PLUS] = ACTIONS(2200),
    [anon_sym_sizeof] = ACTIONS(2198),
    [anon_sym___alignof__] = ACTIONS(2198),
    [anon_sym___alignof] = ACTIONS(2198),
    [anon_sym__alignof] = ACTIONS(2198),
    [anon_sym_alignof] = ACTIONS(2198),
    [anon_sym__Alignof] = ACTIONS(2198),
    [anon_sym_offsetof] = ACTIONS(2198),
    [anon_sym__Generic] = ACTIONS(2198),
    [anon_sym_asm] = ACTIONS(2198),
    [anon_sym___asm__] = ACTIONS(2198),
    [anon_sym_DOT] = ACTIONS(2198),
    [sym_number_literal] = ACTIONS(2200),
    [anon_sym_L_SQUOTE] = ACTIONS(2200),
    [anon_sym_u_SQUOTE] = ACTIONS(2200),
    [anon_sym_U_SQUOTE] = ACTIONS(2200),
    [anon_sym_u8_SQUOTE] = ACTIONS(2200),
    [anon_sym_SQUOTE] = ACTIONS(2200),
    [anon_sym_L_DQUOTE] = ACTIONS(2200),
    [anon_sym_u_DQUOTE] = ACTIONS(2200),
    [anon_sym_U_DQUOTE] = ACTIONS(2200),
    [anon_sym_u8_DQUOTE] = ACTIONS(2200),
    [anon_sym_DQUOTE] = ACTIONS(2200),
    [sym_true] = ACTIONS(2198),
    [sym_false] = ACTIONS(2198),
    [anon_sym_NULL] = ACTIONS(2198),
    [anon_sym_nullptr] = ACTIONS(2198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2198),
    [anon_sym_let] = ACTIONS(2198),
    [anon_sym_This] = ACTIONS(2198),
    [anon_sym_decltype] = ACTIONS(2198),
    [anon_sym_final] = ACTIONS(2198),
    [anon_sym_override] = ACTIONS(2198),
    [sym_virtual] = ACTIONS(2198),
    [anon_sym_explicit] = ACTIONS(2198),
    [anon_sym_typename] = ACTIONS(2198),
    [anon_sym_template] = ACTIONS(2198),
    [anon_sym_operator] = ACTIONS(2198),
    [anon_sym_try] = ACTIONS(2198),
    [anon_sym_delete] = ACTIONS(2198),
    [anon_sym_throw] = ACTIONS(2198),
    [anon_sym_namespace] = ACTIONS(2198),
    [anon_sym_using] = ACTIONS(2198),
    [anon_sym_static_assert] = ACTIONS(2198),
    [anon_sym_concept] = ACTIONS(2198),
    [anon_sym_co_return] = ACTIONS(2198),
    [anon_sym_co_yield] = ACTIONS(2198),
    [anon_sym_R_DQUOTE] = ACTIONS(2200),
    [anon_sym_LR_DQUOTE] = ACTIONS(2200),
    [anon_sym_uR_DQUOTE] = ACTIONS(2200),
    [anon_sym_UR_DQUOTE] = ACTIONS(2200),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2200),
    [anon_sym_co_await] = ACTIONS(2198),
    [anon_sym_new] = ACTIONS(2198),
    [anon_sym_requires] = ACTIONS(2198),
    [sym_this] = ACTIONS(2198),
    [anon_sym_discard] = ACTIONS(2198),
    [anon_sym_precise] = ACTIONS(2198),
    [anon_sym_shared] = ACTIONS(2198),
    [anon_sym_groupshared] = ACTIONS(2198),
    [anon_sym_uniform] = ACTIONS(2198),
    [anon_sym_row_major] = ACTIONS(2198),
    [anon_sym_column_major] = ACTIONS(2198),
    [anon_sym_globallycoherent] = ACTIONS(2198),
    [anon_sym_centroid] = ACTIONS(2198),
    [anon_sym_noperspective] = ACTIONS(2198),
    [anon_sym_nointerpolation] = ACTIONS(2198),
    [anon_sym_sample] = ACTIONS(2198),
    [anon_sym_linear] = ACTIONS(2198),
    [anon_sym_snorm] = ACTIONS(2198),
    [anon_sym_unorm] = ACTIONS(2198),
    [anon_sym_point] = ACTIONS(2198),
    [anon_sym_line] = ACTIONS(2198),
    [anon_sym_triangleadj] = ACTIONS(2198),
    [anon_sym_lineadj] = ACTIONS(2198),
    [anon_sym_triangle] = ACTIONS(2198),
    [anon_sym_cbuffer] = ACTIONS(2198),
    [anon_sym_interface] = ACTIONS(2198),
    [anon_sym_extension] = ACTIONS(2198),
  },
  [366] = {
    [sym_identifier] = ACTIONS(2256),
    [aux_sym_preproc_include_token1] = ACTIONS(2256),
    [aux_sym_preproc_def_token1] = ACTIONS(2256),
    [aux_sym_preproc_if_token1] = ACTIONS(2256),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2256),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2256),
    [sym_preproc_directive] = ACTIONS(2256),
    [anon_sym_LPAREN2] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [anon_sym_DASH] = ACTIONS(2256),
    [anon_sym_PLUS] = ACTIONS(2256),
    [anon_sym_STAR] = ACTIONS(2258),
    [anon_sym_AMP_AMP] = ACTIONS(2258),
    [anon_sym_AMP] = ACTIONS(2256),
    [anon_sym_COLON] = ACTIONS(2256),
    [anon_sym_SEMI] = ACTIONS(2258),
    [anon_sym___extension__] = ACTIONS(2256),
    [anon_sym_typedef] = ACTIONS(2256),
    [anon_sym_in] = ACTIONS(2256),
    [anon_sym_out] = ACTIONS(2256),
    [anon_sym_inout] = ACTIONS(2256),
    [anon_sym_extern] = ACTIONS(2256),
    [anon_sym___attribute__] = ACTIONS(2256),
    [anon_sym_COLON_COLON] = ACTIONS(2258),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2258),
    [anon_sym___declspec] = ACTIONS(2256),
    [anon_sym___based] = ACTIONS(2256),
    [anon_sym___cdecl] = ACTIONS(2256),
    [anon_sym___clrcall] = ACTIONS(2256),
    [anon_sym___stdcall] = ACTIONS(2256),
    [anon_sym___fastcall] = ACTIONS(2256),
    [anon_sym___thiscall] = ACTIONS(2256),
    [anon_sym___vectorcall] = ACTIONS(2256),
    [anon_sym_LBRACE] = ACTIONS(2258),
    [anon_sym_RBRACE] = ACTIONS(2258),
    [anon_sym_signed] = ACTIONS(2256),
    [anon_sym_unsigned] = ACTIONS(2256),
    [anon_sym_long] = ACTIONS(2256),
    [anon_sym_short] = ACTIONS(2256),
    [anon_sym_LBRACK] = ACTIONS(2256),
    [anon_sym_static] = ACTIONS(2256),
    [anon_sym_register] = ACTIONS(2256),
    [anon_sym_inline] = ACTIONS(2256),
    [anon_sym___inline] = ACTIONS(2256),
    [anon_sym___inline__] = ACTIONS(2256),
    [anon_sym___forceinline] = ACTIONS(2256),
    [anon_sym_thread_local] = ACTIONS(2256),
    [anon_sym___thread] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_constexpr] = ACTIONS(2256),
    [anon_sym_volatile] = ACTIONS(2256),
    [anon_sym_restrict] = ACTIONS(2256),
    [anon_sym___restrict__] = ACTIONS(2256),
    [anon_sym__Atomic] = ACTIONS(2256),
    [anon_sym__Noreturn] = ACTIONS(2256),
    [anon_sym_noreturn] = ACTIONS(2256),
    [anon_sym_mutable] = ACTIONS(2256),
    [anon_sym_constinit] = ACTIONS(2256),
    [anon_sym_consteval] = ACTIONS(2256),
    [anon_sym_alignas] = ACTIONS(2256),
    [anon_sym__Alignas] = ACTIONS(2256),
    [sym_primitive_type] = ACTIONS(2256),
    [anon_sym_enum] = ACTIONS(2256),
    [anon_sym_class] = ACTIONS(2256),
    [anon_sym_struct] = ACTIONS(2256),
    [anon_sym_union] = ACTIONS(2256),
    [anon_sym_if] = ACTIONS(2256),
    [anon_sym_else] = ACTIONS(2256),
    [anon_sym_switch] = ACTIONS(2256),
    [anon_sym_case] = ACTIONS(2256),
    [anon_sym_default] = ACTIONS(2256),
    [anon_sym_while] = ACTIONS(2256),
    [anon_sym_do] = ACTIONS(2256),
    [anon_sym_for] = ACTIONS(2256),
    [anon_sym_return] = ACTIONS(2256),
    [anon_sym_break] = ACTIONS(2256),
    [anon_sym_continue] = ACTIONS(2256),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym___try] = ACTIONS(2256),
    [anon_sym___leave] = ACTIONS(2256),
    [anon_sym_not] = ACTIONS(2256),
    [anon_sym_compl] = ACTIONS(2256),
    [anon_sym_DASH_DASH] = ACTIONS(2258),
    [anon_sym_PLUS_PLUS] = ACTIONS(2258),
    [anon_sym_sizeof] = ACTIONS(2256),
    [anon_sym___alignof__] = ACTIONS(2256),
    [anon_sym___alignof] = ACTIONS(2256),
    [anon_sym__alignof] = ACTIONS(2256),
    [anon_sym_alignof] = ACTIONS(2256),
    [anon_sym__Alignof] = ACTIONS(2256),
    [anon_sym_offsetof] = ACTIONS(2256),
    [anon_sym__Generic] = ACTIONS(2256),
    [anon_sym_asm] = ACTIONS(2256),
    [anon_sym___asm__] = ACTIONS(2256),
    [anon_sym_DOT] = ACTIONS(2256),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_L_SQUOTE] = ACTIONS(2258),
    [anon_sym_u_SQUOTE] = ACTIONS(2258),
    [anon_sym_U_SQUOTE] = ACTIONS(2258),
    [anon_sym_u8_SQUOTE] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(2258),
    [anon_sym_L_DQUOTE] = ACTIONS(2258),
    [anon_sym_u_DQUOTE] = ACTIONS(2258),
    [anon_sym_U_DQUOTE] = ACTIONS(2258),
    [anon_sym_u8_DQUOTE] = ACTIONS(2258),
    [anon_sym_DQUOTE] = ACTIONS(2258),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2256),
    [anon_sym_nullptr] = ACTIONS(2256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_This] = ACTIONS(2256),
    [anon_sym_decltype] = ACTIONS(2256),
    [anon_sym_final] = ACTIONS(2256),
    [anon_sym_override] = ACTIONS(2256),
    [sym_virtual] = ACTIONS(2256),
    [anon_sym_explicit] = ACTIONS(2256),
    [anon_sym_typename] = ACTIONS(2256),
    [anon_sym_template] = ACTIONS(2256),
    [anon_sym_operator] = ACTIONS(2256),
    [anon_sym_try] = ACTIONS(2256),
    [anon_sym_delete] = ACTIONS(2256),
    [anon_sym_throw] = ACTIONS(2256),
    [anon_sym_namespace] = ACTIONS(2256),
    [anon_sym_using] = ACTIONS(2256),
    [anon_sym_static_assert] = ACTIONS(2256),
    [anon_sym_concept] = ACTIONS(2256),
    [anon_sym_co_return] = ACTIONS(2256),
    [anon_sym_co_yield] = ACTIONS(2256),
    [anon_sym_R_DQUOTE] = ACTIONS(2258),
    [anon_sym_LR_DQUOTE] = ACTIONS(2258),
    [anon_sym_uR_DQUOTE] = ACTIONS(2258),
    [anon_sym_UR_DQUOTE] = ACTIONS(2258),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2258),
    [anon_sym_co_await] = ACTIONS(2256),
    [anon_sym_new] = ACTIONS(2256),
    [anon_sym_requires] = ACTIONS(2256),
    [sym_this] = ACTIONS(2256),
    [anon_sym_discard] = ACTIONS(2256),
    [anon_sym_precise] = ACTIONS(2256),
    [anon_sym_shared] = ACTIONS(2256),
    [anon_sym_groupshared] = ACTIONS(2256),
    [anon_sym_uniform] = ACTIONS(2256),
    [anon_sym_row_major] = ACTIONS(2256),
    [anon_sym_column_major] = ACTIONS(2256),
    [anon_sym_globallycoherent] = ACTIONS(2256),
    [anon_sym_centroid] = ACTIONS(2256),
    [anon_sym_noperspective] = ACTIONS(2256),
    [anon_sym_nointerpolation] = ACTIONS(2256),
    [anon_sym_sample] = ACTIONS(2256),
    [anon_sym_linear] = ACTIONS(2256),
    [anon_sym_snorm] = ACTIONS(2256),
    [anon_sym_unorm] = ACTIONS(2256),
    [anon_sym_point] = ACTIONS(2256),
    [anon_sym_line] = ACTIONS(2256),
    [anon_sym_triangleadj] = ACTIONS(2256),
    [anon_sym_lineadj] = ACTIONS(2256),
    [anon_sym_triangle] = ACTIONS(2256),
    [anon_sym_cbuffer] = ACTIONS(2256),
    [anon_sym_interface] = ACTIONS(2256),
    [anon_sym_extension] = ACTIONS(2256),
  },
  [367] = {
    [sym_identifier] = ACTIONS(2248),
    [aux_sym_preproc_include_token1] = ACTIONS(2248),
    [aux_sym_preproc_def_token1] = ACTIONS(2248),
    [aux_sym_preproc_if_token1] = ACTIONS(2248),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2248),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2248),
    [sym_preproc_directive] = ACTIONS(2248),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2248),
    [anon_sym_PLUS] = ACTIONS(2248),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2248),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym___extension__] = ACTIONS(2248),
    [anon_sym_typedef] = ACTIONS(2248),
    [anon_sym_in] = ACTIONS(2248),
    [anon_sym_out] = ACTIONS(2248),
    [anon_sym_inout] = ACTIONS(2248),
    [anon_sym_extern] = ACTIONS(2248),
    [anon_sym___attribute__] = ACTIONS(2248),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2250),
    [anon_sym___declspec] = ACTIONS(2248),
    [anon_sym___based] = ACTIONS(2248),
    [anon_sym___cdecl] = ACTIONS(2248),
    [anon_sym___clrcall] = ACTIONS(2248),
    [anon_sym___stdcall] = ACTIONS(2248),
    [anon_sym___fastcall] = ACTIONS(2248),
    [anon_sym___thiscall] = ACTIONS(2248),
    [anon_sym___vectorcall] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_signed] = ACTIONS(2248),
    [anon_sym_unsigned] = ACTIONS(2248),
    [anon_sym_long] = ACTIONS(2248),
    [anon_sym_short] = ACTIONS(2248),
    [anon_sym_LBRACK] = ACTIONS(2248),
    [anon_sym_static] = ACTIONS(2248),
    [anon_sym_register] = ACTIONS(2248),
    [anon_sym_inline] = ACTIONS(2248),
    [anon_sym___inline] = ACTIONS(2248),
    [anon_sym___inline__] = ACTIONS(2248),
    [anon_sym___forceinline] = ACTIONS(2248),
    [anon_sym_thread_local] = ACTIONS(2248),
    [anon_sym___thread] = ACTIONS(2248),
    [anon_sym_const] = ACTIONS(2248),
    [anon_sym_constexpr] = ACTIONS(2248),
    [anon_sym_volatile] = ACTIONS(2248),
    [anon_sym_restrict] = ACTIONS(2248),
    [anon_sym___restrict__] = ACTIONS(2248),
    [anon_sym__Atomic] = ACTIONS(2248),
    [anon_sym__Noreturn] = ACTIONS(2248),
    [anon_sym_noreturn] = ACTIONS(2248),
    [anon_sym_mutable] = ACTIONS(2248),
    [anon_sym_constinit] = ACTIONS(2248),
    [anon_sym_consteval] = ACTIONS(2248),
    [anon_sym_alignas] = ACTIONS(2248),
    [anon_sym__Alignas] = ACTIONS(2248),
    [sym_primitive_type] = ACTIONS(2248),
    [anon_sym_enum] = ACTIONS(2248),
    [anon_sym_class] = ACTIONS(2248),
    [anon_sym_struct] = ACTIONS(2248),
    [anon_sym_union] = ACTIONS(2248),
    [anon_sym_if] = ACTIONS(2248),
    [anon_sym_else] = ACTIONS(2248),
    [anon_sym_switch] = ACTIONS(2248),
    [anon_sym_case] = ACTIONS(2248),
    [anon_sym_default] = ACTIONS(2248),
    [anon_sym_while] = ACTIONS(2248),
    [anon_sym_do] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2248),
    [anon_sym_break] = ACTIONS(2248),
    [anon_sym_continue] = ACTIONS(2248),
    [anon_sym_goto] = ACTIONS(2248),
    [anon_sym___try] = ACTIONS(2248),
    [anon_sym___leave] = ACTIONS(2248),
    [anon_sym_not] = ACTIONS(2248),
    [anon_sym_compl] = ACTIONS(2248),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_sizeof] = ACTIONS(2248),
    [anon_sym___alignof__] = ACTIONS(2248),
    [anon_sym___alignof] = ACTIONS(2248),
    [anon_sym__alignof] = ACTIONS(2248),
    [anon_sym_alignof] = ACTIONS(2248),
    [anon_sym__Alignof] = ACTIONS(2248),
    [anon_sym_offsetof] = ACTIONS(2248),
    [anon_sym__Generic] = ACTIONS(2248),
    [anon_sym_asm] = ACTIONS(2248),
    [anon_sym___asm__] = ACTIONS(2248),
    [anon_sym_DOT] = ACTIONS(2248),
    [sym_number_literal] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2250),
    [anon_sym_u_SQUOTE] = ACTIONS(2250),
    [anon_sym_U_SQUOTE] = ACTIONS(2250),
    [anon_sym_u8_SQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym_L_DQUOTE] = ACTIONS(2250),
    [anon_sym_u_DQUOTE] = ACTIONS(2250),
    [anon_sym_U_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [sym_true] = ACTIONS(2248),
    [sym_false] = ACTIONS(2248),
    [anon_sym_NULL] = ACTIONS(2248),
    [anon_sym_nullptr] = ACTIONS(2248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2248),
    [anon_sym_let] = ACTIONS(2248),
    [anon_sym_This] = ACTIONS(2248),
    [anon_sym_decltype] = ACTIONS(2248),
    [anon_sym_final] = ACTIONS(2248),
    [anon_sym_override] = ACTIONS(2248),
    [sym_virtual] = ACTIONS(2248),
    [anon_sym_explicit] = ACTIONS(2248),
    [anon_sym_typename] = ACTIONS(2248),
    [anon_sym_template] = ACTIONS(2248),
    [anon_sym_operator] = ACTIONS(2248),
    [anon_sym_try] = ACTIONS(2248),
    [anon_sym_delete] = ACTIONS(2248),
    [anon_sym_throw] = ACTIONS(2248),
    [anon_sym_namespace] = ACTIONS(2248),
    [anon_sym_using] = ACTIONS(2248),
    [anon_sym_static_assert] = ACTIONS(2248),
    [anon_sym_concept] = ACTIONS(2248),
    [anon_sym_co_return] = ACTIONS(2248),
    [anon_sym_co_yield] = ACTIONS(2248),
    [anon_sym_R_DQUOTE] = ACTIONS(2250),
    [anon_sym_LR_DQUOTE] = ACTIONS(2250),
    [anon_sym_uR_DQUOTE] = ACTIONS(2250),
    [anon_sym_UR_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2250),
    [anon_sym_co_await] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2248),
    [anon_sym_requires] = ACTIONS(2248),
    [sym_this] = ACTIONS(2248),
    [anon_sym_discard] = ACTIONS(2248),
    [anon_sym_precise] = ACTIONS(2248),
    [anon_sym_shared] = ACTIONS(2248),
    [anon_sym_groupshared] = ACTIONS(2248),
    [anon_sym_uniform] = ACTIONS(2248),
    [anon_sym_row_major] = ACTIONS(2248),
    [anon_sym_column_major] = ACTIONS(2248),
    [anon_sym_globallycoherent] = ACTIONS(2248),
    [anon_sym_centroid] = ACTIONS(2248),
    [anon_sym_noperspective] = ACTIONS(2248),
    [anon_sym_nointerpolation] = ACTIONS(2248),
    [anon_sym_sample] = ACTIONS(2248),
    [anon_sym_linear] = ACTIONS(2248),
    [anon_sym_snorm] = ACTIONS(2248),
    [anon_sym_unorm] = ACTIONS(2248),
    [anon_sym_point] = ACTIONS(2248),
    [anon_sym_line] = ACTIONS(2248),
    [anon_sym_triangleadj] = ACTIONS(2248),
    [anon_sym_lineadj] = ACTIONS(2248),
    [anon_sym_triangle] = ACTIONS(2248),
    [anon_sym_cbuffer] = ACTIONS(2248),
    [anon_sym_interface] = ACTIONS(2248),
    [anon_sym_extension] = ACTIONS(2248),
  },
  [368] = {
    [ts_builtin_sym_end] = ACTIONS(3096),
    [sym_identifier] = ACTIONS(3098),
    [aux_sym_preproc_include_token1] = ACTIONS(3098),
    [aux_sym_preproc_def_token1] = ACTIONS(3098),
    [anon_sym_COMMA] = ACTIONS(3096),
    [anon_sym_RPAREN] = ACTIONS(3096),
    [aux_sym_preproc_if_token1] = ACTIONS(3098),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3098),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3098),
    [sym_preproc_directive] = ACTIONS(3098),
    [anon_sym_LPAREN2] = ACTIONS(3096),
    [anon_sym_BANG] = ACTIONS(3096),
    [anon_sym_TILDE] = ACTIONS(3096),
    [anon_sym_DASH] = ACTIONS(3098),
    [anon_sym_PLUS] = ACTIONS(3098),
    [anon_sym_STAR] = ACTIONS(3096),
    [anon_sym_AMP_AMP] = ACTIONS(3096),
    [anon_sym_AMP] = ACTIONS(3098),
    [anon_sym_SEMI] = ACTIONS(3096),
    [anon_sym___extension__] = ACTIONS(3098),
    [anon_sym_typedef] = ACTIONS(3098),
    [anon_sym_in] = ACTIONS(3098),
    [anon_sym_out] = ACTIONS(3098),
    [anon_sym_inout] = ACTIONS(3098),
    [anon_sym_extern] = ACTIONS(3098),
    [anon_sym___attribute__] = ACTIONS(3098),
    [anon_sym_COLON_COLON] = ACTIONS(3096),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3096),
    [anon_sym___declspec] = ACTIONS(3098),
    [anon_sym___based] = ACTIONS(3098),
    [anon_sym___cdecl] = ACTIONS(3098),
    [anon_sym___clrcall] = ACTIONS(3098),
    [anon_sym___stdcall] = ACTIONS(3098),
    [anon_sym___fastcall] = ACTIONS(3098),
    [anon_sym___thiscall] = ACTIONS(3098),
    [anon_sym___vectorcall] = ACTIONS(3098),
    [anon_sym_LBRACE] = ACTIONS(3096),
    [anon_sym_signed] = ACTIONS(3098),
    [anon_sym_unsigned] = ACTIONS(3098),
    [anon_sym_long] = ACTIONS(3098),
    [anon_sym_short] = ACTIONS(3098),
    [anon_sym_LBRACK] = ACTIONS(3098),
    [anon_sym_static] = ACTIONS(3098),
    [anon_sym_register] = ACTIONS(3098),
    [anon_sym_inline] = ACTIONS(3098),
    [anon_sym___inline] = ACTIONS(3098),
    [anon_sym___inline__] = ACTIONS(3098),
    [anon_sym___forceinline] = ACTIONS(3098),
    [anon_sym_thread_local] = ACTIONS(3098),
    [anon_sym___thread] = ACTIONS(3098),
    [anon_sym_const] = ACTIONS(3098),
    [anon_sym_constexpr] = ACTIONS(3098),
    [anon_sym_volatile] = ACTIONS(3098),
    [anon_sym_restrict] = ACTIONS(3098),
    [anon_sym___restrict__] = ACTIONS(3098),
    [anon_sym__Atomic] = ACTIONS(3098),
    [anon_sym__Noreturn] = ACTIONS(3098),
    [anon_sym_noreturn] = ACTIONS(3098),
    [anon_sym_mutable] = ACTIONS(3098),
    [anon_sym_constinit] = ACTIONS(3098),
    [anon_sym_consteval] = ACTIONS(3098),
    [anon_sym_alignas] = ACTIONS(3098),
    [anon_sym__Alignas] = ACTIONS(3098),
    [sym_primitive_type] = ACTIONS(3098),
    [anon_sym_enum] = ACTIONS(3098),
    [anon_sym_class] = ACTIONS(3098),
    [anon_sym_struct] = ACTIONS(3098),
    [anon_sym_union] = ACTIONS(3098),
    [anon_sym_if] = ACTIONS(3098),
    [anon_sym_switch] = ACTIONS(3098),
    [anon_sym_case] = ACTIONS(3098),
    [anon_sym_default] = ACTIONS(3098),
    [anon_sym_while] = ACTIONS(3098),
    [anon_sym_do] = ACTIONS(3098),
    [anon_sym_for] = ACTIONS(3098),
    [anon_sym_return] = ACTIONS(3098),
    [anon_sym_break] = ACTIONS(3098),
    [anon_sym_continue] = ACTIONS(3098),
    [anon_sym_goto] = ACTIONS(3098),
    [anon_sym_not] = ACTIONS(3098),
    [anon_sym_compl] = ACTIONS(3098),
    [anon_sym_DASH_DASH] = ACTIONS(3096),
    [anon_sym_PLUS_PLUS] = ACTIONS(3096),
    [anon_sym_sizeof] = ACTIONS(3098),
    [anon_sym___alignof__] = ACTIONS(3098),
    [anon_sym___alignof] = ACTIONS(3098),
    [anon_sym__alignof] = ACTIONS(3098),
    [anon_sym_alignof] = ACTIONS(3098),
    [anon_sym__Alignof] = ACTIONS(3098),
    [anon_sym_offsetof] = ACTIONS(3098),
    [anon_sym__Generic] = ACTIONS(3098),
    [anon_sym_asm] = ACTIONS(3098),
    [anon_sym___asm__] = ACTIONS(3098),
    [anon_sym_DOT] = ACTIONS(3098),
    [sym_number_literal] = ACTIONS(3096),
    [anon_sym_L_SQUOTE] = ACTIONS(3096),
    [anon_sym_u_SQUOTE] = ACTIONS(3096),
    [anon_sym_U_SQUOTE] = ACTIONS(3096),
    [anon_sym_u8_SQUOTE] = ACTIONS(3096),
    [anon_sym_SQUOTE] = ACTIONS(3096),
    [anon_sym_L_DQUOTE] = ACTIONS(3096),
    [anon_sym_u_DQUOTE] = ACTIONS(3096),
    [anon_sym_U_DQUOTE] = ACTIONS(3096),
    [anon_sym_u8_DQUOTE] = ACTIONS(3096),
    [anon_sym_DQUOTE] = ACTIONS(3096),
    [sym_true] = ACTIONS(3098),
    [sym_false] = ACTIONS(3098),
    [anon_sym_NULL] = ACTIONS(3098),
    [anon_sym_nullptr] = ACTIONS(3098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3098),
    [anon_sym_let] = ACTIONS(3098),
    [anon_sym_This] = ACTIONS(3098),
    [anon_sym_decltype] = ACTIONS(3098),
    [anon_sym_final] = ACTIONS(3098),
    [anon_sym_override] = ACTIONS(3098),
    [sym_virtual] = ACTIONS(3098),
    [anon_sym_explicit] = ACTIONS(3098),
    [anon_sym_typename] = ACTIONS(3098),
    [anon_sym_template] = ACTIONS(3098),
    [anon_sym_GT2] = ACTIONS(3096),
    [anon_sym_operator] = ACTIONS(3098),
    [anon_sym_try] = ACTIONS(3098),
    [anon_sym_delete] = ACTIONS(3098),
    [anon_sym_throw] = ACTIONS(3098),
    [anon_sym_namespace] = ACTIONS(3098),
    [anon_sym_using] = ACTIONS(3098),
    [anon_sym_static_assert] = ACTIONS(3098),
    [anon_sym_concept] = ACTIONS(3098),
    [anon_sym_co_return] = ACTIONS(3098),
    [anon_sym_co_yield] = ACTIONS(3098),
    [anon_sym_R_DQUOTE] = ACTIONS(3096),
    [anon_sym_LR_DQUOTE] = ACTIONS(3096),
    [anon_sym_uR_DQUOTE] = ACTIONS(3096),
    [anon_sym_UR_DQUOTE] = ACTIONS(3096),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3096),
    [anon_sym_co_await] = ACTIONS(3098),
    [anon_sym_new] = ACTIONS(3098),
    [anon_sym_requires] = ACTIONS(3098),
    [sym_this] = ACTIONS(3098),
    [anon_sym_precise] = ACTIONS(3098),
    [anon_sym_shared] = ACTIONS(3098),
    [anon_sym_groupshared] = ACTIONS(3098),
    [anon_sym_uniform] = ACTIONS(3098),
    [anon_sym_row_major] = ACTIONS(3098),
    [anon_sym_column_major] = ACTIONS(3098),
    [anon_sym_globallycoherent] = ACTIONS(3098),
    [anon_sym_centroid] = ACTIONS(3098),
    [anon_sym_noperspective] = ACTIONS(3098),
    [anon_sym_nointerpolation] = ACTIONS(3098),
    [anon_sym_sample] = ACTIONS(3098),
    [anon_sym_linear] = ACTIONS(3098),
    [anon_sym_snorm] = ACTIONS(3098),
    [anon_sym_unorm] = ACTIONS(3098),
    [anon_sym_point] = ACTIONS(3098),
    [anon_sym_line] = ACTIONS(3098),
    [anon_sym_triangleadj] = ACTIONS(3098),
    [anon_sym_lineadj] = ACTIONS(3098),
    [anon_sym_triangle] = ACTIONS(3098),
    [anon_sym_interface] = ACTIONS(3098),
    [anon_sym_extension] = ACTIONS(3098),
    [anon_sym_where] = ACTIONS(3098),
    [anon_sym___exported] = ACTIONS(3098),
    [anon_sym_import] = ACTIONS(3098),
  },
  [369] = {
    [ts_builtin_sym_end] = ACTIONS(3100),
    [sym_identifier] = ACTIONS(3102),
    [aux_sym_preproc_include_token1] = ACTIONS(3102),
    [aux_sym_preproc_def_token1] = ACTIONS(3102),
    [anon_sym_COMMA] = ACTIONS(3100),
    [anon_sym_RPAREN] = ACTIONS(3100),
    [aux_sym_preproc_if_token1] = ACTIONS(3102),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3102),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3102),
    [sym_preproc_directive] = ACTIONS(3102),
    [anon_sym_LPAREN2] = ACTIONS(3100),
    [anon_sym_BANG] = ACTIONS(3100),
    [anon_sym_TILDE] = ACTIONS(3100),
    [anon_sym_DASH] = ACTIONS(3102),
    [anon_sym_PLUS] = ACTIONS(3102),
    [anon_sym_STAR] = ACTIONS(3100),
    [anon_sym_AMP_AMP] = ACTIONS(3100),
    [anon_sym_AMP] = ACTIONS(3102),
    [anon_sym_SEMI] = ACTIONS(3100),
    [anon_sym___extension__] = ACTIONS(3102),
    [anon_sym_typedef] = ACTIONS(3102),
    [anon_sym_in] = ACTIONS(3102),
    [anon_sym_out] = ACTIONS(3102),
    [anon_sym_inout] = ACTIONS(3102),
    [anon_sym_extern] = ACTIONS(3102),
    [anon_sym___attribute__] = ACTIONS(3102),
    [anon_sym_COLON_COLON] = ACTIONS(3100),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3100),
    [anon_sym___declspec] = ACTIONS(3102),
    [anon_sym___based] = ACTIONS(3102),
    [anon_sym___cdecl] = ACTIONS(3102),
    [anon_sym___clrcall] = ACTIONS(3102),
    [anon_sym___stdcall] = ACTIONS(3102),
    [anon_sym___fastcall] = ACTIONS(3102),
    [anon_sym___thiscall] = ACTIONS(3102),
    [anon_sym___vectorcall] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(3100),
    [anon_sym_signed] = ACTIONS(3102),
    [anon_sym_unsigned] = ACTIONS(3102),
    [anon_sym_long] = ACTIONS(3102),
    [anon_sym_short] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_static] = ACTIONS(3102),
    [anon_sym_register] = ACTIONS(3102),
    [anon_sym_inline] = ACTIONS(3102),
    [anon_sym___inline] = ACTIONS(3102),
    [anon_sym___inline__] = ACTIONS(3102),
    [anon_sym___forceinline] = ACTIONS(3102),
    [anon_sym_thread_local] = ACTIONS(3102),
    [anon_sym___thread] = ACTIONS(3102),
    [anon_sym_const] = ACTIONS(3102),
    [anon_sym_constexpr] = ACTIONS(3102),
    [anon_sym_volatile] = ACTIONS(3102),
    [anon_sym_restrict] = ACTIONS(3102),
    [anon_sym___restrict__] = ACTIONS(3102),
    [anon_sym__Atomic] = ACTIONS(3102),
    [anon_sym__Noreturn] = ACTIONS(3102),
    [anon_sym_noreturn] = ACTIONS(3102),
    [anon_sym_mutable] = ACTIONS(3102),
    [anon_sym_constinit] = ACTIONS(3102),
    [anon_sym_consteval] = ACTIONS(3102),
    [anon_sym_alignas] = ACTIONS(3102),
    [anon_sym__Alignas] = ACTIONS(3102),
    [sym_primitive_type] = ACTIONS(3102),
    [anon_sym_enum] = ACTIONS(3102),
    [anon_sym_class] = ACTIONS(3102),
    [anon_sym_struct] = ACTIONS(3102),
    [anon_sym_union] = ACTIONS(3102),
    [anon_sym_if] = ACTIONS(3102),
    [anon_sym_switch] = ACTIONS(3102),
    [anon_sym_case] = ACTIONS(3102),
    [anon_sym_default] = ACTIONS(3102),
    [anon_sym_while] = ACTIONS(3102),
    [anon_sym_do] = ACTIONS(3102),
    [anon_sym_for] = ACTIONS(3102),
    [anon_sym_return] = ACTIONS(3102),
    [anon_sym_break] = ACTIONS(3102),
    [anon_sym_continue] = ACTIONS(3102),
    [anon_sym_goto] = ACTIONS(3102),
    [anon_sym_not] = ACTIONS(3102),
    [anon_sym_compl] = ACTIONS(3102),
    [anon_sym_DASH_DASH] = ACTIONS(3100),
    [anon_sym_PLUS_PLUS] = ACTIONS(3100),
    [anon_sym_sizeof] = ACTIONS(3102),
    [anon_sym___alignof__] = ACTIONS(3102),
    [anon_sym___alignof] = ACTIONS(3102),
    [anon_sym__alignof] = ACTIONS(3102),
    [anon_sym_alignof] = ACTIONS(3102),
    [anon_sym__Alignof] = ACTIONS(3102),
    [anon_sym_offsetof] = ACTIONS(3102),
    [anon_sym__Generic] = ACTIONS(3102),
    [anon_sym_asm] = ACTIONS(3102),
    [anon_sym___asm__] = ACTIONS(3102),
    [anon_sym_DOT] = ACTIONS(3102),
    [sym_number_literal] = ACTIONS(3100),
    [anon_sym_L_SQUOTE] = ACTIONS(3100),
    [anon_sym_u_SQUOTE] = ACTIONS(3100),
    [anon_sym_U_SQUOTE] = ACTIONS(3100),
    [anon_sym_u8_SQUOTE] = ACTIONS(3100),
    [anon_sym_SQUOTE] = ACTIONS(3100),
    [anon_sym_L_DQUOTE] = ACTIONS(3100),
    [anon_sym_u_DQUOTE] = ACTIONS(3100),
    [anon_sym_U_DQUOTE] = ACTIONS(3100),
    [anon_sym_u8_DQUOTE] = ACTIONS(3100),
    [anon_sym_DQUOTE] = ACTIONS(3100),
    [sym_true] = ACTIONS(3102),
    [sym_false] = ACTIONS(3102),
    [anon_sym_NULL] = ACTIONS(3102),
    [anon_sym_nullptr] = ACTIONS(3102),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3102),
    [anon_sym_let] = ACTIONS(3102),
    [anon_sym_This] = ACTIONS(3102),
    [anon_sym_decltype] = ACTIONS(3102),
    [anon_sym_final] = ACTIONS(3102),
    [anon_sym_override] = ACTIONS(3102),
    [sym_virtual] = ACTIONS(3102),
    [anon_sym_explicit] = ACTIONS(3102),
    [anon_sym_typename] = ACTIONS(3102),
    [anon_sym_template] = ACTIONS(3102),
    [anon_sym_GT2] = ACTIONS(3100),
    [anon_sym_operator] = ACTIONS(3102),
    [anon_sym_try] = ACTIONS(3102),
    [anon_sym_delete] = ACTIONS(3102),
    [anon_sym_throw] = ACTIONS(3102),
    [anon_sym_namespace] = ACTIONS(3102),
    [anon_sym_using] = ACTIONS(3102),
    [anon_sym_static_assert] = ACTIONS(3102),
    [anon_sym_concept] = ACTIONS(3102),
    [anon_sym_co_return] = ACTIONS(3102),
    [anon_sym_co_yield] = ACTIONS(3102),
    [anon_sym_R_DQUOTE] = ACTIONS(3100),
    [anon_sym_LR_DQUOTE] = ACTIONS(3100),
    [anon_sym_uR_DQUOTE] = ACTIONS(3100),
    [anon_sym_UR_DQUOTE] = ACTIONS(3100),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3100),
    [anon_sym_co_await] = ACTIONS(3102),
    [anon_sym_new] = ACTIONS(3102),
    [anon_sym_requires] = ACTIONS(3102),
    [sym_this] = ACTIONS(3102),
    [anon_sym_precise] = ACTIONS(3102),
    [anon_sym_shared] = ACTIONS(3102),
    [anon_sym_groupshared] = ACTIONS(3102),
    [anon_sym_uniform] = ACTIONS(3102),
    [anon_sym_row_major] = ACTIONS(3102),
    [anon_sym_column_major] = ACTIONS(3102),
    [anon_sym_globallycoherent] = ACTIONS(3102),
    [anon_sym_centroid] = ACTIONS(3102),
    [anon_sym_noperspective] = ACTIONS(3102),
    [anon_sym_nointerpolation] = ACTIONS(3102),
    [anon_sym_sample] = ACTIONS(3102),
    [anon_sym_linear] = ACTIONS(3102),
    [anon_sym_snorm] = ACTIONS(3102),
    [anon_sym_unorm] = ACTIONS(3102),
    [anon_sym_point] = ACTIONS(3102),
    [anon_sym_line] = ACTIONS(3102),
    [anon_sym_triangleadj] = ACTIONS(3102),
    [anon_sym_lineadj] = ACTIONS(3102),
    [anon_sym_triangle] = ACTIONS(3102),
    [anon_sym_interface] = ACTIONS(3102),
    [anon_sym_extension] = ACTIONS(3102),
    [anon_sym_where] = ACTIONS(3102),
    [anon_sym___exported] = ACTIONS(3102),
    [anon_sym_import] = ACTIONS(3102),
  },
  [370] = {
    [sym_preproc_def] = STATE(296),
    [sym_preproc_function_def] = STATE(296),
    [sym_preproc_call] = STATE(296),
    [sym_preproc_if_in_field_declaration_list] = STATE(296),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(296),
    [sym_type_definition] = STATE(296),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6811),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7427),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(296),
    [sym_field_declaration] = STATE(296),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2593),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(296),
    [sym_operator_cast] = STATE(8371),
    [sym_inline_method_definition] = STATE(296),
    [sym__constructor_specifiers] = STATE(2593),
    [sym_operator_cast_definition] = STATE(296),
    [sym_operator_cast_declaration] = STATE(296),
    [sym_constructor_or_destructor_definition] = STATE(296),
    [sym_constructor_or_destructor_declaration] = STATE(296),
    [sym_friend_declaration] = STATE(296),
    [sym_access_specifier] = STATE(10305),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(296),
    [sym_alias_declaration] = STATE(296),
    [sym_static_assert_declaration] = STATE(296),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8371),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(296),
    [sym_subscript_declaration] = STATE(296),
    [sym_property_declaration] = STATE(296),
    [sym_associatedtype_declaration] = STATE(296),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(296),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2593),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2912),
    [aux_sym_preproc_if_token1] = ACTIONS(2914),
    [aux_sym_preproc_if_token2] = ACTIONS(3104),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2918),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2918),
    [sym_preproc_directive] = ACTIONS(2920),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2922),
    [anon_sym_typedef] = ACTIONS(2924),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2926),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2928),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2930),
    [anon_sym_static_assert] = ACTIONS(2932),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2934),
    [anon_sym___subscript] = ACTIONS(2936),
    [anon_sym_property] = ACTIONS(2938),
    [anon_sym_associatedtype] = ACTIONS(2940),
  },
  [371] = {
    [sym_preproc_def] = STATE(371),
    [sym_preproc_function_def] = STATE(371),
    [sym_preproc_call] = STATE(371),
    [sym_preproc_if_in_field_declaration_list] = STATE(371),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(371),
    [sym_type_definition] = STATE(371),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(371),
    [sym_field_declaration] = STATE(371),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(371),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(371),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(371),
    [sym_operator_cast_declaration] = STATE(371),
    [sym_constructor_or_destructor_definition] = STATE(371),
    [sym_constructor_or_destructor_declaration] = STATE(371),
    [sym_friend_declaration] = STATE(371),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(371),
    [sym_alias_declaration] = STATE(371),
    [sym_static_assert_declaration] = STATE(371),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(371),
    [sym_subscript_declaration] = STATE(371),
    [sym_property_declaration] = STATE(371),
    [sym_associatedtype_declaration] = STATE(371),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(371),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2540),
    [aux_sym_preproc_def_token1] = ACTIONS(3106),
    [aux_sym_preproc_if_token1] = ACTIONS(3109),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3112),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3112),
    [sym_preproc_directive] = ACTIONS(3115),
    [anon_sym_LPAREN2] = ACTIONS(2557),
    [anon_sym_TILDE] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2566),
    [anon_sym_AMP] = ACTIONS(2569),
    [anon_sym___extension__] = ACTIONS(3118),
    [anon_sym_typedef] = ACTIONS(3121),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_out] = ACTIONS(2578),
    [anon_sym_inout] = ACTIONS(2578),
    [anon_sym_extern] = ACTIONS(2581),
    [anon_sym___attribute__] = ACTIONS(2584),
    [anon_sym_COLON_COLON] = ACTIONS(2587),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2590),
    [anon_sym___declspec] = ACTIONS(2593),
    [anon_sym___based] = ACTIONS(2596),
    [anon_sym_RBRACE] = ACTIONS(3124),
    [anon_sym_signed] = ACTIONS(2599),
    [anon_sym_unsigned] = ACTIONS(2599),
    [anon_sym_long] = ACTIONS(2599),
    [anon_sym_short] = ACTIONS(2599),
    [anon_sym_LBRACK] = ACTIONS(2602),
    [anon_sym_static] = ACTIONS(2581),
    [anon_sym_register] = ACTIONS(2581),
    [anon_sym_inline] = ACTIONS(2581),
    [anon_sym___inline] = ACTIONS(2581),
    [anon_sym___inline__] = ACTIONS(2581),
    [anon_sym___forceinline] = ACTIONS(2581),
    [anon_sym_thread_local] = ACTIONS(2581),
    [anon_sym___thread] = ACTIONS(2581),
    [anon_sym_const] = ACTIONS(2605),
    [anon_sym_constexpr] = ACTIONS(2605),
    [anon_sym_volatile] = ACTIONS(2605),
    [anon_sym_restrict] = ACTIONS(2605),
    [anon_sym___restrict__] = ACTIONS(2605),
    [anon_sym__Atomic] = ACTIONS(2605),
    [anon_sym__Noreturn] = ACTIONS(2605),
    [anon_sym_noreturn] = ACTIONS(2605),
    [anon_sym_mutable] = ACTIONS(2605),
    [anon_sym_constinit] = ACTIONS(2605),
    [anon_sym_consteval] = ACTIONS(2605),
    [anon_sym_alignas] = ACTIONS(2608),
    [anon_sym__Alignas] = ACTIONS(2608),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_enum] = ACTIONS(2614),
    [anon_sym_class] = ACTIONS(2617),
    [anon_sym_struct] = ACTIONS(2620),
    [anon_sym_union] = ACTIONS(2623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2626),
    [anon_sym_let] = ACTIONS(2626),
    [anon_sym_This] = ACTIONS(2626),
    [anon_sym_decltype] = ACTIONS(2629),
    [sym_virtual] = ACTIONS(2578),
    [anon_sym_explicit] = ACTIONS(2632),
    [anon_sym_typename] = ACTIONS(2635),
    [anon_sym_template] = ACTIONS(3126),
    [anon_sym_operator] = ACTIONS(2641),
    [anon_sym_friend] = ACTIONS(3129),
    [anon_sym_public] = ACTIONS(2647),
    [anon_sym_private] = ACTIONS(2647),
    [anon_sym_protected] = ACTIONS(2647),
    [anon_sym_using] = ACTIONS(3132),
    [anon_sym_static_assert] = ACTIONS(3135),
    [anon_sym_precise] = ACTIONS(2656),
    [anon_sym_shared] = ACTIONS(2656),
    [anon_sym_groupshared] = ACTIONS(2656),
    [anon_sym_uniform] = ACTIONS(2656),
    [anon_sym_row_major] = ACTIONS(2656),
    [anon_sym_column_major] = ACTIONS(2656),
    [anon_sym_globallycoherent] = ACTIONS(2656),
    [anon_sym_centroid] = ACTIONS(2656),
    [anon_sym_noperspective] = ACTIONS(2656),
    [anon_sym_nointerpolation] = ACTIONS(2656),
    [anon_sym_sample] = ACTIONS(2656),
    [anon_sym_linear] = ACTIONS(2656),
    [anon_sym_snorm] = ACTIONS(2656),
    [anon_sym_unorm] = ACTIONS(2656),
    [anon_sym_point] = ACTIONS(2656),
    [anon_sym_line] = ACTIONS(2656),
    [anon_sym_triangleadj] = ACTIONS(2656),
    [anon_sym_lineadj] = ACTIONS(2656),
    [anon_sym_triangle] = ACTIONS(2656),
    [anon_sym_interface] = ACTIONS(2659),
    [anon_sym_extension] = ACTIONS(2662),
    [anon_sym___init] = ACTIONS(3138),
    [anon_sym___subscript] = ACTIONS(3141),
    [anon_sym_property] = ACTIONS(3144),
    [anon_sym_associatedtype] = ACTIONS(3147),
  },
  [372] = {
    [ts_builtin_sym_end] = ACTIONS(3150),
    [sym_identifier] = ACTIONS(3152),
    [aux_sym_preproc_include_token1] = ACTIONS(3152),
    [aux_sym_preproc_def_token1] = ACTIONS(3152),
    [anon_sym_COMMA] = ACTIONS(3150),
    [anon_sym_RPAREN] = ACTIONS(3150),
    [aux_sym_preproc_if_token1] = ACTIONS(3152),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3152),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3152),
    [sym_preproc_directive] = ACTIONS(3152),
    [anon_sym_LPAREN2] = ACTIONS(3150),
    [anon_sym_BANG] = ACTIONS(3150),
    [anon_sym_TILDE] = ACTIONS(3150),
    [anon_sym_DASH] = ACTIONS(3152),
    [anon_sym_PLUS] = ACTIONS(3152),
    [anon_sym_STAR] = ACTIONS(3150),
    [anon_sym_AMP_AMP] = ACTIONS(3150),
    [anon_sym_AMP] = ACTIONS(3152),
    [anon_sym_SEMI] = ACTIONS(3150),
    [anon_sym___extension__] = ACTIONS(3152),
    [anon_sym_typedef] = ACTIONS(3152),
    [anon_sym_in] = ACTIONS(3152),
    [anon_sym_out] = ACTIONS(3152),
    [anon_sym_inout] = ACTIONS(3152),
    [anon_sym_extern] = ACTIONS(3152),
    [anon_sym___attribute__] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3150),
    [anon_sym___declspec] = ACTIONS(3152),
    [anon_sym___based] = ACTIONS(3152),
    [anon_sym___cdecl] = ACTIONS(3152),
    [anon_sym___clrcall] = ACTIONS(3152),
    [anon_sym___stdcall] = ACTIONS(3152),
    [anon_sym___fastcall] = ACTIONS(3152),
    [anon_sym___thiscall] = ACTIONS(3152),
    [anon_sym___vectorcall] = ACTIONS(3152),
    [anon_sym_LBRACE] = ACTIONS(3150),
    [anon_sym_signed] = ACTIONS(3152),
    [anon_sym_unsigned] = ACTIONS(3152),
    [anon_sym_long] = ACTIONS(3152),
    [anon_sym_short] = ACTIONS(3152),
    [anon_sym_LBRACK] = ACTIONS(3152),
    [anon_sym_static] = ACTIONS(3152),
    [anon_sym_register] = ACTIONS(3152),
    [anon_sym_inline] = ACTIONS(3152),
    [anon_sym___inline] = ACTIONS(3152),
    [anon_sym___inline__] = ACTIONS(3152),
    [anon_sym___forceinline] = ACTIONS(3152),
    [anon_sym_thread_local] = ACTIONS(3152),
    [anon_sym___thread] = ACTIONS(3152),
    [anon_sym_const] = ACTIONS(3152),
    [anon_sym_constexpr] = ACTIONS(3152),
    [anon_sym_volatile] = ACTIONS(3152),
    [anon_sym_restrict] = ACTIONS(3152),
    [anon_sym___restrict__] = ACTIONS(3152),
    [anon_sym__Atomic] = ACTIONS(3152),
    [anon_sym__Noreturn] = ACTIONS(3152),
    [anon_sym_noreturn] = ACTIONS(3152),
    [anon_sym_mutable] = ACTIONS(3152),
    [anon_sym_constinit] = ACTIONS(3152),
    [anon_sym_consteval] = ACTIONS(3152),
    [anon_sym_alignas] = ACTIONS(3152),
    [anon_sym__Alignas] = ACTIONS(3152),
    [sym_primitive_type] = ACTIONS(3152),
    [anon_sym_enum] = ACTIONS(3152),
    [anon_sym_class] = ACTIONS(3152),
    [anon_sym_struct] = ACTIONS(3152),
    [anon_sym_union] = ACTIONS(3152),
    [anon_sym_if] = ACTIONS(3152),
    [anon_sym_switch] = ACTIONS(3152),
    [anon_sym_case] = ACTIONS(3152),
    [anon_sym_default] = ACTIONS(3152),
    [anon_sym_while] = ACTIONS(3152),
    [anon_sym_do] = ACTIONS(3152),
    [anon_sym_for] = ACTIONS(3152),
    [anon_sym_return] = ACTIONS(3152),
    [anon_sym_break] = ACTIONS(3152),
    [anon_sym_continue] = ACTIONS(3152),
    [anon_sym_goto] = ACTIONS(3152),
    [anon_sym_not] = ACTIONS(3152),
    [anon_sym_compl] = ACTIONS(3152),
    [anon_sym_DASH_DASH] = ACTIONS(3150),
    [anon_sym_PLUS_PLUS] = ACTIONS(3150),
    [anon_sym_sizeof] = ACTIONS(3152),
    [anon_sym___alignof__] = ACTIONS(3152),
    [anon_sym___alignof] = ACTIONS(3152),
    [anon_sym__alignof] = ACTIONS(3152),
    [anon_sym_alignof] = ACTIONS(3152),
    [anon_sym__Alignof] = ACTIONS(3152),
    [anon_sym_offsetof] = ACTIONS(3152),
    [anon_sym__Generic] = ACTIONS(3152),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym_DOT] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3150),
    [anon_sym_L_SQUOTE] = ACTIONS(3150),
    [anon_sym_u_SQUOTE] = ACTIONS(3150),
    [anon_sym_U_SQUOTE] = ACTIONS(3150),
    [anon_sym_u8_SQUOTE] = ACTIONS(3150),
    [anon_sym_SQUOTE] = ACTIONS(3150),
    [anon_sym_L_DQUOTE] = ACTIONS(3150),
    [anon_sym_u_DQUOTE] = ACTIONS(3150),
    [anon_sym_U_DQUOTE] = ACTIONS(3150),
    [anon_sym_u8_DQUOTE] = ACTIONS(3150),
    [anon_sym_DQUOTE] = ACTIONS(3150),
    [sym_true] = ACTIONS(3152),
    [sym_false] = ACTIONS(3152),
    [anon_sym_NULL] = ACTIONS(3152),
    [anon_sym_nullptr] = ACTIONS(3152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3152),
    [anon_sym_let] = ACTIONS(3152),
    [anon_sym_This] = ACTIONS(3152),
    [anon_sym_decltype] = ACTIONS(3152),
    [anon_sym_final] = ACTIONS(3152),
    [anon_sym_override] = ACTIONS(3152),
    [sym_virtual] = ACTIONS(3152),
    [anon_sym_explicit] = ACTIONS(3152),
    [anon_sym_typename] = ACTIONS(3152),
    [anon_sym_template] = ACTIONS(3152),
    [anon_sym_GT2] = ACTIONS(3150),
    [anon_sym_operator] = ACTIONS(3152),
    [anon_sym_try] = ACTIONS(3152),
    [anon_sym_delete] = ACTIONS(3152),
    [anon_sym_throw] = ACTIONS(3152),
    [anon_sym_namespace] = ACTIONS(3152),
    [anon_sym_using] = ACTIONS(3152),
    [anon_sym_static_assert] = ACTIONS(3152),
    [anon_sym_concept] = ACTIONS(3152),
    [anon_sym_co_return] = ACTIONS(3152),
    [anon_sym_co_yield] = ACTIONS(3152),
    [anon_sym_R_DQUOTE] = ACTIONS(3150),
    [anon_sym_LR_DQUOTE] = ACTIONS(3150),
    [anon_sym_uR_DQUOTE] = ACTIONS(3150),
    [anon_sym_UR_DQUOTE] = ACTIONS(3150),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3150),
    [anon_sym_co_await] = ACTIONS(3152),
    [anon_sym_new] = ACTIONS(3152),
    [anon_sym_requires] = ACTIONS(3152),
    [sym_this] = ACTIONS(3152),
    [anon_sym_precise] = ACTIONS(3152),
    [anon_sym_shared] = ACTIONS(3152),
    [anon_sym_groupshared] = ACTIONS(3152),
    [anon_sym_uniform] = ACTIONS(3152),
    [anon_sym_row_major] = ACTIONS(3152),
    [anon_sym_column_major] = ACTIONS(3152),
    [anon_sym_globallycoherent] = ACTIONS(3152),
    [anon_sym_centroid] = ACTIONS(3152),
    [anon_sym_noperspective] = ACTIONS(3152),
    [anon_sym_nointerpolation] = ACTIONS(3152),
    [anon_sym_sample] = ACTIONS(3152),
    [anon_sym_linear] = ACTIONS(3152),
    [anon_sym_snorm] = ACTIONS(3152),
    [anon_sym_unorm] = ACTIONS(3152),
    [anon_sym_point] = ACTIONS(3152),
    [anon_sym_line] = ACTIONS(3152),
    [anon_sym_triangleadj] = ACTIONS(3152),
    [anon_sym_lineadj] = ACTIONS(3152),
    [anon_sym_triangle] = ACTIONS(3152),
    [anon_sym_interface] = ACTIONS(3152),
    [anon_sym_extension] = ACTIONS(3152),
    [anon_sym_where] = ACTIONS(3152),
    [anon_sym___exported] = ACTIONS(3152),
    [anon_sym_import] = ACTIONS(3152),
  },
  [373] = {
    [ts_builtin_sym_end] = ACTIONS(3154),
    [sym_identifier] = ACTIONS(3156),
    [aux_sym_preproc_include_token1] = ACTIONS(3156),
    [aux_sym_preproc_def_token1] = ACTIONS(3156),
    [anon_sym_COMMA] = ACTIONS(3154),
    [anon_sym_RPAREN] = ACTIONS(3154),
    [aux_sym_preproc_if_token1] = ACTIONS(3156),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3156),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3156),
    [sym_preproc_directive] = ACTIONS(3156),
    [anon_sym_LPAREN2] = ACTIONS(3154),
    [anon_sym_BANG] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3154),
    [anon_sym_DASH] = ACTIONS(3156),
    [anon_sym_PLUS] = ACTIONS(3156),
    [anon_sym_STAR] = ACTIONS(3154),
    [anon_sym_AMP_AMP] = ACTIONS(3154),
    [anon_sym_AMP] = ACTIONS(3156),
    [anon_sym_SEMI] = ACTIONS(3154),
    [anon_sym___extension__] = ACTIONS(3156),
    [anon_sym_typedef] = ACTIONS(3156),
    [anon_sym_in] = ACTIONS(3156),
    [anon_sym_out] = ACTIONS(3156),
    [anon_sym_inout] = ACTIONS(3156),
    [anon_sym_extern] = ACTIONS(3156),
    [anon_sym___attribute__] = ACTIONS(3156),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3154),
    [anon_sym___declspec] = ACTIONS(3156),
    [anon_sym___based] = ACTIONS(3156),
    [anon_sym___cdecl] = ACTIONS(3156),
    [anon_sym___clrcall] = ACTIONS(3156),
    [anon_sym___stdcall] = ACTIONS(3156),
    [anon_sym___fastcall] = ACTIONS(3156),
    [anon_sym___thiscall] = ACTIONS(3156),
    [anon_sym___vectorcall] = ACTIONS(3156),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_signed] = ACTIONS(3156),
    [anon_sym_unsigned] = ACTIONS(3156),
    [anon_sym_long] = ACTIONS(3156),
    [anon_sym_short] = ACTIONS(3156),
    [anon_sym_LBRACK] = ACTIONS(3156),
    [anon_sym_static] = ACTIONS(3156),
    [anon_sym_register] = ACTIONS(3156),
    [anon_sym_inline] = ACTIONS(3156),
    [anon_sym___inline] = ACTIONS(3156),
    [anon_sym___inline__] = ACTIONS(3156),
    [anon_sym___forceinline] = ACTIONS(3156),
    [anon_sym_thread_local] = ACTIONS(3156),
    [anon_sym___thread] = ACTIONS(3156),
    [anon_sym_const] = ACTIONS(3156),
    [anon_sym_constexpr] = ACTIONS(3156),
    [anon_sym_volatile] = ACTIONS(3156),
    [anon_sym_restrict] = ACTIONS(3156),
    [anon_sym___restrict__] = ACTIONS(3156),
    [anon_sym__Atomic] = ACTIONS(3156),
    [anon_sym__Noreturn] = ACTIONS(3156),
    [anon_sym_noreturn] = ACTIONS(3156),
    [anon_sym_mutable] = ACTIONS(3156),
    [anon_sym_constinit] = ACTIONS(3156),
    [anon_sym_consteval] = ACTIONS(3156),
    [anon_sym_alignas] = ACTIONS(3156),
    [anon_sym__Alignas] = ACTIONS(3156),
    [sym_primitive_type] = ACTIONS(3156),
    [anon_sym_enum] = ACTIONS(3156),
    [anon_sym_class] = ACTIONS(3156),
    [anon_sym_struct] = ACTIONS(3156),
    [anon_sym_union] = ACTIONS(3156),
    [anon_sym_if] = ACTIONS(3156),
    [anon_sym_switch] = ACTIONS(3156),
    [anon_sym_case] = ACTIONS(3156),
    [anon_sym_default] = ACTIONS(3156),
    [anon_sym_while] = ACTIONS(3156),
    [anon_sym_do] = ACTIONS(3156),
    [anon_sym_for] = ACTIONS(3156),
    [anon_sym_return] = ACTIONS(3156),
    [anon_sym_break] = ACTIONS(3156),
    [anon_sym_continue] = ACTIONS(3156),
    [anon_sym_goto] = ACTIONS(3156),
    [anon_sym_not] = ACTIONS(3156),
    [anon_sym_compl] = ACTIONS(3156),
    [anon_sym_DASH_DASH] = ACTIONS(3154),
    [anon_sym_PLUS_PLUS] = ACTIONS(3154),
    [anon_sym_sizeof] = ACTIONS(3156),
    [anon_sym___alignof__] = ACTIONS(3156),
    [anon_sym___alignof] = ACTIONS(3156),
    [anon_sym__alignof] = ACTIONS(3156),
    [anon_sym_alignof] = ACTIONS(3156),
    [anon_sym__Alignof] = ACTIONS(3156),
    [anon_sym_offsetof] = ACTIONS(3156),
    [anon_sym__Generic] = ACTIONS(3156),
    [anon_sym_asm] = ACTIONS(3156),
    [anon_sym___asm__] = ACTIONS(3156),
    [anon_sym_DOT] = ACTIONS(3156),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3154),
    [anon_sym_u_SQUOTE] = ACTIONS(3154),
    [anon_sym_U_SQUOTE] = ACTIONS(3154),
    [anon_sym_u8_SQUOTE] = ACTIONS(3154),
    [anon_sym_SQUOTE] = ACTIONS(3154),
    [anon_sym_L_DQUOTE] = ACTIONS(3154),
    [anon_sym_u_DQUOTE] = ACTIONS(3154),
    [anon_sym_U_DQUOTE] = ACTIONS(3154),
    [anon_sym_u8_DQUOTE] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [sym_true] = ACTIONS(3156),
    [sym_false] = ACTIONS(3156),
    [anon_sym_NULL] = ACTIONS(3156),
    [anon_sym_nullptr] = ACTIONS(3156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3156),
    [anon_sym_let] = ACTIONS(3156),
    [anon_sym_This] = ACTIONS(3156),
    [anon_sym_decltype] = ACTIONS(3156),
    [anon_sym_final] = ACTIONS(3156),
    [anon_sym_override] = ACTIONS(3156),
    [sym_virtual] = ACTIONS(3156),
    [anon_sym_explicit] = ACTIONS(3156),
    [anon_sym_typename] = ACTIONS(3156),
    [anon_sym_template] = ACTIONS(3156),
    [anon_sym_GT2] = ACTIONS(3154),
    [anon_sym_operator] = ACTIONS(3156),
    [anon_sym_try] = ACTIONS(3156),
    [anon_sym_delete] = ACTIONS(3156),
    [anon_sym_throw] = ACTIONS(3156),
    [anon_sym_namespace] = ACTIONS(3156),
    [anon_sym_using] = ACTIONS(3156),
    [anon_sym_static_assert] = ACTIONS(3156),
    [anon_sym_concept] = ACTIONS(3156),
    [anon_sym_co_return] = ACTIONS(3156),
    [anon_sym_co_yield] = ACTIONS(3156),
    [anon_sym_R_DQUOTE] = ACTIONS(3154),
    [anon_sym_LR_DQUOTE] = ACTIONS(3154),
    [anon_sym_uR_DQUOTE] = ACTIONS(3154),
    [anon_sym_UR_DQUOTE] = ACTIONS(3154),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3154),
    [anon_sym_co_await] = ACTIONS(3156),
    [anon_sym_new] = ACTIONS(3156),
    [anon_sym_requires] = ACTIONS(3156),
    [sym_this] = ACTIONS(3156),
    [anon_sym_precise] = ACTIONS(3156),
    [anon_sym_shared] = ACTIONS(3156),
    [anon_sym_groupshared] = ACTIONS(3156),
    [anon_sym_uniform] = ACTIONS(3156),
    [anon_sym_row_major] = ACTIONS(3156),
    [anon_sym_column_major] = ACTIONS(3156),
    [anon_sym_globallycoherent] = ACTIONS(3156),
    [anon_sym_centroid] = ACTIONS(3156),
    [anon_sym_noperspective] = ACTIONS(3156),
    [anon_sym_nointerpolation] = ACTIONS(3156),
    [anon_sym_sample] = ACTIONS(3156),
    [anon_sym_linear] = ACTIONS(3156),
    [anon_sym_snorm] = ACTIONS(3156),
    [anon_sym_unorm] = ACTIONS(3156),
    [anon_sym_point] = ACTIONS(3156),
    [anon_sym_line] = ACTIONS(3156),
    [anon_sym_triangleadj] = ACTIONS(3156),
    [anon_sym_lineadj] = ACTIONS(3156),
    [anon_sym_triangle] = ACTIONS(3156),
    [anon_sym_interface] = ACTIONS(3156),
    [anon_sym_extension] = ACTIONS(3156),
    [anon_sym_where] = ACTIONS(3156),
    [anon_sym___exported] = ACTIONS(3156),
    [anon_sym_import] = ACTIONS(3156),
  },
  [374] = {
    [sym_identifier] = ACTIONS(3158),
    [aux_sym_preproc_include_token1] = ACTIONS(3158),
    [aux_sym_preproc_def_token1] = ACTIONS(3158),
    [aux_sym_preproc_if_token1] = ACTIONS(3158),
    [aux_sym_preproc_if_token2] = ACTIONS(3158),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3158),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3158),
    [aux_sym_preproc_else_token1] = ACTIONS(3158),
    [aux_sym_preproc_elif_token1] = ACTIONS(3158),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3158),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3158),
    [sym_preproc_directive] = ACTIONS(3158),
    [anon_sym_LPAREN2] = ACTIONS(3160),
    [anon_sym_BANG] = ACTIONS(3160),
    [anon_sym_TILDE] = ACTIONS(3160),
    [anon_sym_DASH] = ACTIONS(3158),
    [anon_sym_PLUS] = ACTIONS(3158),
    [anon_sym_STAR] = ACTIONS(3160),
    [anon_sym_AMP_AMP] = ACTIONS(3160),
    [anon_sym_AMP] = ACTIONS(3158),
    [anon_sym_SEMI] = ACTIONS(3160),
    [anon_sym___extension__] = ACTIONS(3158),
    [anon_sym_typedef] = ACTIONS(3158),
    [anon_sym_in] = ACTIONS(3158),
    [anon_sym_out] = ACTIONS(3158),
    [anon_sym_inout] = ACTIONS(3158),
    [anon_sym_extern] = ACTIONS(3158),
    [anon_sym___attribute__] = ACTIONS(3158),
    [anon_sym_COLON_COLON] = ACTIONS(3160),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3160),
    [anon_sym___declspec] = ACTIONS(3158),
    [anon_sym___based] = ACTIONS(3158),
    [anon_sym___cdecl] = ACTIONS(3158),
    [anon_sym___clrcall] = ACTIONS(3158),
    [anon_sym___stdcall] = ACTIONS(3158),
    [anon_sym___fastcall] = ACTIONS(3158),
    [anon_sym___thiscall] = ACTIONS(3158),
    [anon_sym___vectorcall] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3160),
    [anon_sym_signed] = ACTIONS(3158),
    [anon_sym_unsigned] = ACTIONS(3158),
    [anon_sym_long] = ACTIONS(3158),
    [anon_sym_short] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_static] = ACTIONS(3158),
    [anon_sym_register] = ACTIONS(3158),
    [anon_sym_inline] = ACTIONS(3158),
    [anon_sym___inline] = ACTIONS(3158),
    [anon_sym___inline__] = ACTIONS(3158),
    [anon_sym___forceinline] = ACTIONS(3158),
    [anon_sym_thread_local] = ACTIONS(3158),
    [anon_sym___thread] = ACTIONS(3158),
    [anon_sym_const] = ACTIONS(3158),
    [anon_sym_constexpr] = ACTIONS(3158),
    [anon_sym_volatile] = ACTIONS(3158),
    [anon_sym_restrict] = ACTIONS(3158),
    [anon_sym___restrict__] = ACTIONS(3158),
    [anon_sym__Atomic] = ACTIONS(3158),
    [anon_sym__Noreturn] = ACTIONS(3158),
    [anon_sym_noreturn] = ACTIONS(3158),
    [anon_sym_mutable] = ACTIONS(3158),
    [anon_sym_constinit] = ACTIONS(3158),
    [anon_sym_consteval] = ACTIONS(3158),
    [anon_sym_alignas] = ACTIONS(3158),
    [anon_sym__Alignas] = ACTIONS(3158),
    [sym_primitive_type] = ACTIONS(3158),
    [anon_sym_enum] = ACTIONS(3158),
    [anon_sym_class] = ACTIONS(3158),
    [anon_sym_struct] = ACTIONS(3158),
    [anon_sym_union] = ACTIONS(3158),
    [anon_sym_if] = ACTIONS(3158),
    [anon_sym_else] = ACTIONS(3158),
    [anon_sym_switch] = ACTIONS(3158),
    [anon_sym_case] = ACTIONS(3158),
    [anon_sym_default] = ACTIONS(3158),
    [anon_sym_while] = ACTIONS(3158),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_for] = ACTIONS(3158),
    [anon_sym_return] = ACTIONS(3158),
    [anon_sym_break] = ACTIONS(3158),
    [anon_sym_continue] = ACTIONS(3158),
    [anon_sym_goto] = ACTIONS(3158),
    [anon_sym___try] = ACTIONS(3158),
    [anon_sym___leave] = ACTIONS(3158),
    [anon_sym_not] = ACTIONS(3158),
    [anon_sym_compl] = ACTIONS(3158),
    [anon_sym_DASH_DASH] = ACTIONS(3160),
    [anon_sym_PLUS_PLUS] = ACTIONS(3160),
    [anon_sym_sizeof] = ACTIONS(3158),
    [anon_sym___alignof__] = ACTIONS(3158),
    [anon_sym___alignof] = ACTIONS(3158),
    [anon_sym__alignof] = ACTIONS(3158),
    [anon_sym_alignof] = ACTIONS(3158),
    [anon_sym__Alignof] = ACTIONS(3158),
    [anon_sym_offsetof] = ACTIONS(3158),
    [anon_sym__Generic] = ACTIONS(3158),
    [anon_sym_asm] = ACTIONS(3158),
    [anon_sym___asm__] = ACTIONS(3158),
    [sym_number_literal] = ACTIONS(3160),
    [anon_sym_L_SQUOTE] = ACTIONS(3160),
    [anon_sym_u_SQUOTE] = ACTIONS(3160),
    [anon_sym_U_SQUOTE] = ACTIONS(3160),
    [anon_sym_u8_SQUOTE] = ACTIONS(3160),
    [anon_sym_SQUOTE] = ACTIONS(3160),
    [anon_sym_L_DQUOTE] = ACTIONS(3160),
    [anon_sym_u_DQUOTE] = ACTIONS(3160),
    [anon_sym_U_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8_DQUOTE] = ACTIONS(3160),
    [anon_sym_DQUOTE] = ACTIONS(3160),
    [sym_true] = ACTIONS(3158),
    [sym_false] = ACTIONS(3158),
    [anon_sym_NULL] = ACTIONS(3158),
    [anon_sym_nullptr] = ACTIONS(3158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3158),
    [anon_sym_let] = ACTIONS(3158),
    [anon_sym_This] = ACTIONS(3158),
    [anon_sym_decltype] = ACTIONS(3158),
    [sym_virtual] = ACTIONS(3158),
    [anon_sym_explicit] = ACTIONS(3158),
    [anon_sym_typename] = ACTIONS(3158),
    [anon_sym_template] = ACTIONS(3158),
    [anon_sym_operator] = ACTIONS(3158),
    [anon_sym_try] = ACTIONS(3158),
    [anon_sym_delete] = ACTIONS(3158),
    [anon_sym_throw] = ACTIONS(3158),
    [anon_sym_namespace] = ACTIONS(3158),
    [anon_sym_using] = ACTIONS(3158),
    [anon_sym_static_assert] = ACTIONS(3158),
    [anon_sym_concept] = ACTIONS(3158),
    [anon_sym_co_return] = ACTIONS(3158),
    [anon_sym_co_yield] = ACTIONS(3158),
    [anon_sym_R_DQUOTE] = ACTIONS(3160),
    [anon_sym_LR_DQUOTE] = ACTIONS(3160),
    [anon_sym_uR_DQUOTE] = ACTIONS(3160),
    [anon_sym_UR_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3160),
    [anon_sym_co_await] = ACTIONS(3158),
    [anon_sym_new] = ACTIONS(3158),
    [anon_sym_requires] = ACTIONS(3158),
    [sym_this] = ACTIONS(3158),
    [anon_sym_discard] = ACTIONS(3158),
    [anon_sym_precise] = ACTIONS(3158),
    [anon_sym_shared] = ACTIONS(3158),
    [anon_sym_groupshared] = ACTIONS(3158),
    [anon_sym_uniform] = ACTIONS(3158),
    [anon_sym_row_major] = ACTIONS(3158),
    [anon_sym_column_major] = ACTIONS(3158),
    [anon_sym_globallycoherent] = ACTIONS(3158),
    [anon_sym_centroid] = ACTIONS(3158),
    [anon_sym_noperspective] = ACTIONS(3158),
    [anon_sym_nointerpolation] = ACTIONS(3158),
    [anon_sym_sample] = ACTIONS(3158),
    [anon_sym_linear] = ACTIONS(3158),
    [anon_sym_snorm] = ACTIONS(3158),
    [anon_sym_unorm] = ACTIONS(3158),
    [anon_sym_point] = ACTIONS(3158),
    [anon_sym_line] = ACTIONS(3158),
    [anon_sym_triangleadj] = ACTIONS(3158),
    [anon_sym_lineadj] = ACTIONS(3158),
    [anon_sym_triangle] = ACTIONS(3158),
    [anon_sym_cbuffer] = ACTIONS(3158),
    [anon_sym_interface] = ACTIONS(3158),
    [anon_sym_extension] = ACTIONS(3158),
  },
  [375] = {
    [sym_identifier] = ACTIONS(3162),
    [aux_sym_preproc_include_token1] = ACTIONS(3162),
    [aux_sym_preproc_def_token1] = ACTIONS(3162),
    [aux_sym_preproc_if_token1] = ACTIONS(3162),
    [aux_sym_preproc_if_token2] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3162),
    [aux_sym_preproc_else_token1] = ACTIONS(3162),
    [aux_sym_preproc_elif_token1] = ACTIONS(3162),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3162),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3162),
    [sym_preproc_directive] = ACTIONS(3162),
    [anon_sym_LPAREN2] = ACTIONS(3164),
    [anon_sym_BANG] = ACTIONS(3164),
    [anon_sym_TILDE] = ACTIONS(3164),
    [anon_sym_DASH] = ACTIONS(3162),
    [anon_sym_PLUS] = ACTIONS(3162),
    [anon_sym_STAR] = ACTIONS(3164),
    [anon_sym_AMP_AMP] = ACTIONS(3164),
    [anon_sym_AMP] = ACTIONS(3162),
    [anon_sym_SEMI] = ACTIONS(3164),
    [anon_sym___extension__] = ACTIONS(3162),
    [anon_sym_typedef] = ACTIONS(3162),
    [anon_sym_in] = ACTIONS(3162),
    [anon_sym_out] = ACTIONS(3162),
    [anon_sym_inout] = ACTIONS(3162),
    [anon_sym_extern] = ACTIONS(3162),
    [anon_sym___attribute__] = ACTIONS(3162),
    [anon_sym_COLON_COLON] = ACTIONS(3164),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3164),
    [anon_sym___declspec] = ACTIONS(3162),
    [anon_sym___based] = ACTIONS(3162),
    [anon_sym___cdecl] = ACTIONS(3162),
    [anon_sym___clrcall] = ACTIONS(3162),
    [anon_sym___stdcall] = ACTIONS(3162),
    [anon_sym___fastcall] = ACTIONS(3162),
    [anon_sym___thiscall] = ACTIONS(3162),
    [anon_sym___vectorcall] = ACTIONS(3162),
    [anon_sym_LBRACE] = ACTIONS(3164),
    [anon_sym_signed] = ACTIONS(3162),
    [anon_sym_unsigned] = ACTIONS(3162),
    [anon_sym_long] = ACTIONS(3162),
    [anon_sym_short] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(3162),
    [anon_sym_static] = ACTIONS(3162),
    [anon_sym_register] = ACTIONS(3162),
    [anon_sym_inline] = ACTIONS(3162),
    [anon_sym___inline] = ACTIONS(3162),
    [anon_sym___inline__] = ACTIONS(3162),
    [anon_sym___forceinline] = ACTIONS(3162),
    [anon_sym_thread_local] = ACTIONS(3162),
    [anon_sym___thread] = ACTIONS(3162),
    [anon_sym_const] = ACTIONS(3162),
    [anon_sym_constexpr] = ACTIONS(3162),
    [anon_sym_volatile] = ACTIONS(3162),
    [anon_sym_restrict] = ACTIONS(3162),
    [anon_sym___restrict__] = ACTIONS(3162),
    [anon_sym__Atomic] = ACTIONS(3162),
    [anon_sym__Noreturn] = ACTIONS(3162),
    [anon_sym_noreturn] = ACTIONS(3162),
    [anon_sym_mutable] = ACTIONS(3162),
    [anon_sym_constinit] = ACTIONS(3162),
    [anon_sym_consteval] = ACTIONS(3162),
    [anon_sym_alignas] = ACTIONS(3162),
    [anon_sym__Alignas] = ACTIONS(3162),
    [sym_primitive_type] = ACTIONS(3162),
    [anon_sym_enum] = ACTIONS(3162),
    [anon_sym_class] = ACTIONS(3162),
    [anon_sym_struct] = ACTIONS(3162),
    [anon_sym_union] = ACTIONS(3162),
    [anon_sym_if] = ACTIONS(3162),
    [anon_sym_else] = ACTIONS(3162),
    [anon_sym_switch] = ACTIONS(3162),
    [anon_sym_case] = ACTIONS(3162),
    [anon_sym_default] = ACTIONS(3162),
    [anon_sym_while] = ACTIONS(3162),
    [anon_sym_do] = ACTIONS(3162),
    [anon_sym_for] = ACTIONS(3162),
    [anon_sym_return] = ACTIONS(3162),
    [anon_sym_break] = ACTIONS(3162),
    [anon_sym_continue] = ACTIONS(3162),
    [anon_sym_goto] = ACTIONS(3162),
    [anon_sym___try] = ACTIONS(3162),
    [anon_sym___leave] = ACTIONS(3162),
    [anon_sym_not] = ACTIONS(3162),
    [anon_sym_compl] = ACTIONS(3162),
    [anon_sym_DASH_DASH] = ACTIONS(3164),
    [anon_sym_PLUS_PLUS] = ACTIONS(3164),
    [anon_sym_sizeof] = ACTIONS(3162),
    [anon_sym___alignof__] = ACTIONS(3162),
    [anon_sym___alignof] = ACTIONS(3162),
    [anon_sym__alignof] = ACTIONS(3162),
    [anon_sym_alignof] = ACTIONS(3162),
    [anon_sym__Alignof] = ACTIONS(3162),
    [anon_sym_offsetof] = ACTIONS(3162),
    [anon_sym__Generic] = ACTIONS(3162),
    [anon_sym_asm] = ACTIONS(3162),
    [anon_sym___asm__] = ACTIONS(3162),
    [sym_number_literal] = ACTIONS(3164),
    [anon_sym_L_SQUOTE] = ACTIONS(3164),
    [anon_sym_u_SQUOTE] = ACTIONS(3164),
    [anon_sym_U_SQUOTE] = ACTIONS(3164),
    [anon_sym_u8_SQUOTE] = ACTIONS(3164),
    [anon_sym_SQUOTE] = ACTIONS(3164),
    [anon_sym_L_DQUOTE] = ACTIONS(3164),
    [anon_sym_u_DQUOTE] = ACTIONS(3164),
    [anon_sym_U_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8_DQUOTE] = ACTIONS(3164),
    [anon_sym_DQUOTE] = ACTIONS(3164),
    [sym_true] = ACTIONS(3162),
    [sym_false] = ACTIONS(3162),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3162),
    [anon_sym_let] = ACTIONS(3162),
    [anon_sym_This] = ACTIONS(3162),
    [anon_sym_decltype] = ACTIONS(3162),
    [sym_virtual] = ACTIONS(3162),
    [anon_sym_explicit] = ACTIONS(3162),
    [anon_sym_typename] = ACTIONS(3162),
    [anon_sym_template] = ACTIONS(3162),
    [anon_sym_operator] = ACTIONS(3162),
    [anon_sym_try] = ACTIONS(3162),
    [anon_sym_delete] = ACTIONS(3162),
    [anon_sym_throw] = ACTIONS(3162),
    [anon_sym_namespace] = ACTIONS(3162),
    [anon_sym_using] = ACTIONS(3162),
    [anon_sym_static_assert] = ACTIONS(3162),
    [anon_sym_concept] = ACTIONS(3162),
    [anon_sym_co_return] = ACTIONS(3162),
    [anon_sym_co_yield] = ACTIONS(3162),
    [anon_sym_R_DQUOTE] = ACTIONS(3164),
    [anon_sym_LR_DQUOTE] = ACTIONS(3164),
    [anon_sym_uR_DQUOTE] = ACTIONS(3164),
    [anon_sym_UR_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3164),
    [anon_sym_co_await] = ACTIONS(3162),
    [anon_sym_new] = ACTIONS(3162),
    [anon_sym_requires] = ACTIONS(3162),
    [sym_this] = ACTIONS(3162),
    [anon_sym_discard] = ACTIONS(3162),
    [anon_sym_precise] = ACTIONS(3162),
    [anon_sym_shared] = ACTIONS(3162),
    [anon_sym_groupshared] = ACTIONS(3162),
    [anon_sym_uniform] = ACTIONS(3162),
    [anon_sym_row_major] = ACTIONS(3162),
    [anon_sym_column_major] = ACTIONS(3162),
    [anon_sym_globallycoherent] = ACTIONS(3162),
    [anon_sym_centroid] = ACTIONS(3162),
    [anon_sym_noperspective] = ACTIONS(3162),
    [anon_sym_nointerpolation] = ACTIONS(3162),
    [anon_sym_sample] = ACTIONS(3162),
    [anon_sym_linear] = ACTIONS(3162),
    [anon_sym_snorm] = ACTIONS(3162),
    [anon_sym_unorm] = ACTIONS(3162),
    [anon_sym_point] = ACTIONS(3162),
    [anon_sym_line] = ACTIONS(3162),
    [anon_sym_triangleadj] = ACTIONS(3162),
    [anon_sym_lineadj] = ACTIONS(3162),
    [anon_sym_triangle] = ACTIONS(3162),
    [anon_sym_cbuffer] = ACTIONS(3162),
    [anon_sym_interface] = ACTIONS(3162),
    [anon_sym_extension] = ACTIONS(3162),
  },
  [376] = {
    [sym_preproc_def] = STATE(417),
    [sym_preproc_function_def] = STATE(417),
    [sym_preproc_call] = STATE(417),
    [sym_preproc_if_in_field_declaration_list] = STATE(417),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(417),
    [sym_type_definition] = STATE(417),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(417),
    [sym_field_declaration] = STATE(417),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(417),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(417),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(417),
    [sym_operator_cast_declaration] = STATE(417),
    [sym_constructor_or_destructor_definition] = STATE(417),
    [sym_constructor_or_destructor_declaration] = STATE(417),
    [sym_friend_declaration] = STATE(417),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(417),
    [sym_alias_declaration] = STATE(417),
    [sym_static_assert_declaration] = STATE(417),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(417),
    [sym_subscript_declaration] = STATE(417),
    [sym_property_declaration] = STATE(417),
    [sym_associatedtype_declaration] = STATE(417),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(417),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3166),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [377] = {
    [sym_preproc_def] = STATE(371),
    [sym_preproc_function_def] = STATE(371),
    [sym_preproc_call] = STATE(371),
    [sym_preproc_if_in_field_declaration_list] = STATE(371),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(371),
    [sym_type_definition] = STATE(371),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(371),
    [sym_field_declaration] = STATE(371),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(371),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(371),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(371),
    [sym_operator_cast_declaration] = STATE(371),
    [sym_constructor_or_destructor_definition] = STATE(371),
    [sym_constructor_or_destructor_declaration] = STATE(371),
    [sym_friend_declaration] = STATE(371),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(371),
    [sym_alias_declaration] = STATE(371),
    [sym_static_assert_declaration] = STATE(371),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(371),
    [sym_subscript_declaration] = STATE(371),
    [sym_property_declaration] = STATE(371),
    [sym_associatedtype_declaration] = STATE(371),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(371),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3168),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [378] = {
    [ts_builtin_sym_end] = ACTIONS(3170),
    [sym_identifier] = ACTIONS(3172),
    [aux_sym_preproc_include_token1] = ACTIONS(3172),
    [aux_sym_preproc_def_token1] = ACTIONS(3172),
    [anon_sym_COMMA] = ACTIONS(3170),
    [anon_sym_RPAREN] = ACTIONS(3170),
    [aux_sym_preproc_if_token1] = ACTIONS(3172),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3172),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3172),
    [sym_preproc_directive] = ACTIONS(3172),
    [anon_sym_LPAREN2] = ACTIONS(3170),
    [anon_sym_BANG] = ACTIONS(3170),
    [anon_sym_TILDE] = ACTIONS(3170),
    [anon_sym_DASH] = ACTIONS(3172),
    [anon_sym_PLUS] = ACTIONS(3172),
    [anon_sym_STAR] = ACTIONS(3170),
    [anon_sym_AMP_AMP] = ACTIONS(3170),
    [anon_sym_AMP] = ACTIONS(3172),
    [anon_sym_SEMI] = ACTIONS(3170),
    [anon_sym___extension__] = ACTIONS(3172),
    [anon_sym_typedef] = ACTIONS(3172),
    [anon_sym_in] = ACTIONS(3172),
    [anon_sym_out] = ACTIONS(3172),
    [anon_sym_inout] = ACTIONS(3172),
    [anon_sym_extern] = ACTIONS(3172),
    [anon_sym___attribute__] = ACTIONS(3172),
    [anon_sym_COLON_COLON] = ACTIONS(3170),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3170),
    [anon_sym___declspec] = ACTIONS(3172),
    [anon_sym___based] = ACTIONS(3172),
    [anon_sym___cdecl] = ACTIONS(3172),
    [anon_sym___clrcall] = ACTIONS(3172),
    [anon_sym___stdcall] = ACTIONS(3172),
    [anon_sym___fastcall] = ACTIONS(3172),
    [anon_sym___thiscall] = ACTIONS(3172),
    [anon_sym___vectorcall] = ACTIONS(3172),
    [anon_sym_LBRACE] = ACTIONS(3170),
    [anon_sym_signed] = ACTIONS(3172),
    [anon_sym_unsigned] = ACTIONS(3172),
    [anon_sym_long] = ACTIONS(3172),
    [anon_sym_short] = ACTIONS(3172),
    [anon_sym_LBRACK] = ACTIONS(3172),
    [anon_sym_static] = ACTIONS(3172),
    [anon_sym_register] = ACTIONS(3172),
    [anon_sym_inline] = ACTIONS(3172),
    [anon_sym___inline] = ACTIONS(3172),
    [anon_sym___inline__] = ACTIONS(3172),
    [anon_sym___forceinline] = ACTIONS(3172),
    [anon_sym_thread_local] = ACTIONS(3172),
    [anon_sym___thread] = ACTIONS(3172),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_constexpr] = ACTIONS(3172),
    [anon_sym_volatile] = ACTIONS(3172),
    [anon_sym_restrict] = ACTIONS(3172),
    [anon_sym___restrict__] = ACTIONS(3172),
    [anon_sym__Atomic] = ACTIONS(3172),
    [anon_sym__Noreturn] = ACTIONS(3172),
    [anon_sym_noreturn] = ACTIONS(3172),
    [anon_sym_mutable] = ACTIONS(3172),
    [anon_sym_constinit] = ACTIONS(3172),
    [anon_sym_consteval] = ACTIONS(3172),
    [anon_sym_alignas] = ACTIONS(3172),
    [anon_sym__Alignas] = ACTIONS(3172),
    [sym_primitive_type] = ACTIONS(3172),
    [anon_sym_enum] = ACTIONS(3172),
    [anon_sym_class] = ACTIONS(3172),
    [anon_sym_struct] = ACTIONS(3172),
    [anon_sym_union] = ACTIONS(3172),
    [anon_sym_if] = ACTIONS(3172),
    [anon_sym_switch] = ACTIONS(3172),
    [anon_sym_case] = ACTIONS(3172),
    [anon_sym_default] = ACTIONS(3172),
    [anon_sym_while] = ACTIONS(3172),
    [anon_sym_do] = ACTIONS(3172),
    [anon_sym_for] = ACTIONS(3172),
    [anon_sym_return] = ACTIONS(3172),
    [anon_sym_break] = ACTIONS(3172),
    [anon_sym_continue] = ACTIONS(3172),
    [anon_sym_goto] = ACTIONS(3172),
    [anon_sym_not] = ACTIONS(3172),
    [anon_sym_compl] = ACTIONS(3172),
    [anon_sym_DASH_DASH] = ACTIONS(3170),
    [anon_sym_PLUS_PLUS] = ACTIONS(3170),
    [anon_sym_sizeof] = ACTIONS(3172),
    [anon_sym___alignof__] = ACTIONS(3172),
    [anon_sym___alignof] = ACTIONS(3172),
    [anon_sym__alignof] = ACTIONS(3172),
    [anon_sym_alignof] = ACTIONS(3172),
    [anon_sym__Alignof] = ACTIONS(3172),
    [anon_sym_offsetof] = ACTIONS(3172),
    [anon_sym__Generic] = ACTIONS(3172),
    [anon_sym_asm] = ACTIONS(3172),
    [anon_sym___asm__] = ACTIONS(3172),
    [anon_sym_DOT] = ACTIONS(3172),
    [sym_number_literal] = ACTIONS(3170),
    [anon_sym_L_SQUOTE] = ACTIONS(3170),
    [anon_sym_u_SQUOTE] = ACTIONS(3170),
    [anon_sym_U_SQUOTE] = ACTIONS(3170),
    [anon_sym_u8_SQUOTE] = ACTIONS(3170),
    [anon_sym_SQUOTE] = ACTIONS(3170),
    [anon_sym_L_DQUOTE] = ACTIONS(3170),
    [anon_sym_u_DQUOTE] = ACTIONS(3170),
    [anon_sym_U_DQUOTE] = ACTIONS(3170),
    [anon_sym_u8_DQUOTE] = ACTIONS(3170),
    [anon_sym_DQUOTE] = ACTIONS(3170),
    [sym_true] = ACTIONS(3172),
    [sym_false] = ACTIONS(3172),
    [anon_sym_NULL] = ACTIONS(3172),
    [anon_sym_nullptr] = ACTIONS(3172),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3172),
    [anon_sym_let] = ACTIONS(3172),
    [anon_sym_This] = ACTIONS(3172),
    [anon_sym_decltype] = ACTIONS(3172),
    [anon_sym_final] = ACTIONS(3172),
    [anon_sym_override] = ACTIONS(3172),
    [sym_virtual] = ACTIONS(3172),
    [anon_sym_explicit] = ACTIONS(3172),
    [anon_sym_typename] = ACTIONS(3172),
    [anon_sym_template] = ACTIONS(3172),
    [anon_sym_GT2] = ACTIONS(3170),
    [anon_sym_operator] = ACTIONS(3172),
    [anon_sym_try] = ACTIONS(3172),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_throw] = ACTIONS(3172),
    [anon_sym_namespace] = ACTIONS(3172),
    [anon_sym_using] = ACTIONS(3172),
    [anon_sym_static_assert] = ACTIONS(3172),
    [anon_sym_concept] = ACTIONS(3172),
    [anon_sym_co_return] = ACTIONS(3172),
    [anon_sym_co_yield] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3170),
    [anon_sym_LR_DQUOTE] = ACTIONS(3170),
    [anon_sym_uR_DQUOTE] = ACTIONS(3170),
    [anon_sym_UR_DQUOTE] = ACTIONS(3170),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3170),
    [anon_sym_co_await] = ACTIONS(3172),
    [anon_sym_new] = ACTIONS(3172),
    [anon_sym_requires] = ACTIONS(3172),
    [sym_this] = ACTIONS(3172),
    [anon_sym_precise] = ACTIONS(3172),
    [anon_sym_shared] = ACTIONS(3172),
    [anon_sym_groupshared] = ACTIONS(3172),
    [anon_sym_uniform] = ACTIONS(3172),
    [anon_sym_row_major] = ACTIONS(3172),
    [anon_sym_column_major] = ACTIONS(3172),
    [anon_sym_globallycoherent] = ACTIONS(3172),
    [anon_sym_centroid] = ACTIONS(3172),
    [anon_sym_noperspective] = ACTIONS(3172),
    [anon_sym_nointerpolation] = ACTIONS(3172),
    [anon_sym_sample] = ACTIONS(3172),
    [anon_sym_linear] = ACTIONS(3172),
    [anon_sym_snorm] = ACTIONS(3172),
    [anon_sym_unorm] = ACTIONS(3172),
    [anon_sym_point] = ACTIONS(3172),
    [anon_sym_line] = ACTIONS(3172),
    [anon_sym_triangleadj] = ACTIONS(3172),
    [anon_sym_lineadj] = ACTIONS(3172),
    [anon_sym_triangle] = ACTIONS(3172),
    [anon_sym_interface] = ACTIONS(3172),
    [anon_sym_extension] = ACTIONS(3172),
    [anon_sym_where] = ACTIONS(3172),
    [anon_sym___exported] = ACTIONS(3172),
    [anon_sym_import] = ACTIONS(3172),
  },
  [379] = {
    [ts_builtin_sym_end] = ACTIONS(3174),
    [sym_identifier] = ACTIONS(3176),
    [aux_sym_preproc_include_token1] = ACTIONS(3176),
    [aux_sym_preproc_def_token1] = ACTIONS(3176),
    [anon_sym_COMMA] = ACTIONS(3174),
    [anon_sym_RPAREN] = ACTIONS(3174),
    [aux_sym_preproc_if_token1] = ACTIONS(3176),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3176),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3176),
    [sym_preproc_directive] = ACTIONS(3176),
    [anon_sym_LPAREN2] = ACTIONS(3174),
    [anon_sym_BANG] = ACTIONS(3174),
    [anon_sym_TILDE] = ACTIONS(3174),
    [anon_sym_DASH] = ACTIONS(3176),
    [anon_sym_PLUS] = ACTIONS(3176),
    [anon_sym_STAR] = ACTIONS(3174),
    [anon_sym_AMP_AMP] = ACTIONS(3174),
    [anon_sym_AMP] = ACTIONS(3176),
    [anon_sym_SEMI] = ACTIONS(3174),
    [anon_sym___extension__] = ACTIONS(3176),
    [anon_sym_typedef] = ACTIONS(3176),
    [anon_sym_in] = ACTIONS(3176),
    [anon_sym_out] = ACTIONS(3176),
    [anon_sym_inout] = ACTIONS(3176),
    [anon_sym_extern] = ACTIONS(3176),
    [anon_sym___attribute__] = ACTIONS(3176),
    [anon_sym_COLON_COLON] = ACTIONS(3174),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3174),
    [anon_sym___declspec] = ACTIONS(3176),
    [anon_sym___based] = ACTIONS(3176),
    [anon_sym___cdecl] = ACTIONS(3176),
    [anon_sym___clrcall] = ACTIONS(3176),
    [anon_sym___stdcall] = ACTIONS(3176),
    [anon_sym___fastcall] = ACTIONS(3176),
    [anon_sym___thiscall] = ACTIONS(3176),
    [anon_sym___vectorcall] = ACTIONS(3176),
    [anon_sym_LBRACE] = ACTIONS(3174),
    [anon_sym_signed] = ACTIONS(3176),
    [anon_sym_unsigned] = ACTIONS(3176),
    [anon_sym_long] = ACTIONS(3176),
    [anon_sym_short] = ACTIONS(3176),
    [anon_sym_LBRACK] = ACTIONS(3176),
    [anon_sym_static] = ACTIONS(3176),
    [anon_sym_register] = ACTIONS(3176),
    [anon_sym_inline] = ACTIONS(3176),
    [anon_sym___inline] = ACTIONS(3176),
    [anon_sym___inline__] = ACTIONS(3176),
    [anon_sym___forceinline] = ACTIONS(3176),
    [anon_sym_thread_local] = ACTIONS(3176),
    [anon_sym___thread] = ACTIONS(3176),
    [anon_sym_const] = ACTIONS(3176),
    [anon_sym_constexpr] = ACTIONS(3176),
    [anon_sym_volatile] = ACTIONS(3176),
    [anon_sym_restrict] = ACTIONS(3176),
    [anon_sym___restrict__] = ACTIONS(3176),
    [anon_sym__Atomic] = ACTIONS(3176),
    [anon_sym__Noreturn] = ACTIONS(3176),
    [anon_sym_noreturn] = ACTIONS(3176),
    [anon_sym_mutable] = ACTIONS(3176),
    [anon_sym_constinit] = ACTIONS(3176),
    [anon_sym_consteval] = ACTIONS(3176),
    [anon_sym_alignas] = ACTIONS(3176),
    [anon_sym__Alignas] = ACTIONS(3176),
    [sym_primitive_type] = ACTIONS(3176),
    [anon_sym_enum] = ACTIONS(3176),
    [anon_sym_class] = ACTIONS(3176),
    [anon_sym_struct] = ACTIONS(3176),
    [anon_sym_union] = ACTIONS(3176),
    [anon_sym_if] = ACTIONS(3176),
    [anon_sym_switch] = ACTIONS(3176),
    [anon_sym_case] = ACTIONS(3176),
    [anon_sym_default] = ACTIONS(3176),
    [anon_sym_while] = ACTIONS(3176),
    [anon_sym_do] = ACTIONS(3176),
    [anon_sym_for] = ACTIONS(3176),
    [anon_sym_return] = ACTIONS(3176),
    [anon_sym_break] = ACTIONS(3176),
    [anon_sym_continue] = ACTIONS(3176),
    [anon_sym_goto] = ACTIONS(3176),
    [anon_sym_not] = ACTIONS(3176),
    [anon_sym_compl] = ACTIONS(3176),
    [anon_sym_DASH_DASH] = ACTIONS(3174),
    [anon_sym_PLUS_PLUS] = ACTIONS(3174),
    [anon_sym_sizeof] = ACTIONS(3176),
    [anon_sym___alignof__] = ACTIONS(3176),
    [anon_sym___alignof] = ACTIONS(3176),
    [anon_sym__alignof] = ACTIONS(3176),
    [anon_sym_alignof] = ACTIONS(3176),
    [anon_sym__Alignof] = ACTIONS(3176),
    [anon_sym_offsetof] = ACTIONS(3176),
    [anon_sym__Generic] = ACTIONS(3176),
    [anon_sym_asm] = ACTIONS(3176),
    [anon_sym___asm__] = ACTIONS(3176),
    [anon_sym_DOT] = ACTIONS(3176),
    [sym_number_literal] = ACTIONS(3174),
    [anon_sym_L_SQUOTE] = ACTIONS(3174),
    [anon_sym_u_SQUOTE] = ACTIONS(3174),
    [anon_sym_U_SQUOTE] = ACTIONS(3174),
    [anon_sym_u8_SQUOTE] = ACTIONS(3174),
    [anon_sym_SQUOTE] = ACTIONS(3174),
    [anon_sym_L_DQUOTE] = ACTIONS(3174),
    [anon_sym_u_DQUOTE] = ACTIONS(3174),
    [anon_sym_U_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8_DQUOTE] = ACTIONS(3174),
    [anon_sym_DQUOTE] = ACTIONS(3174),
    [sym_true] = ACTIONS(3176),
    [sym_false] = ACTIONS(3176),
    [anon_sym_NULL] = ACTIONS(3176),
    [anon_sym_nullptr] = ACTIONS(3176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3176),
    [anon_sym_let] = ACTIONS(3176),
    [anon_sym_This] = ACTIONS(3176),
    [anon_sym_decltype] = ACTIONS(3176),
    [anon_sym_final] = ACTIONS(3176),
    [anon_sym_override] = ACTIONS(3176),
    [sym_virtual] = ACTIONS(3176),
    [anon_sym_explicit] = ACTIONS(3176),
    [anon_sym_typename] = ACTIONS(3176),
    [anon_sym_template] = ACTIONS(3176),
    [anon_sym_GT2] = ACTIONS(3174),
    [anon_sym_operator] = ACTIONS(3176),
    [anon_sym_try] = ACTIONS(3176),
    [anon_sym_delete] = ACTIONS(3176),
    [anon_sym_throw] = ACTIONS(3176),
    [anon_sym_namespace] = ACTIONS(3176),
    [anon_sym_using] = ACTIONS(3176),
    [anon_sym_static_assert] = ACTIONS(3176),
    [anon_sym_concept] = ACTIONS(3176),
    [anon_sym_co_return] = ACTIONS(3176),
    [anon_sym_co_yield] = ACTIONS(3176),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3176),
    [anon_sym_requires] = ACTIONS(3176),
    [sym_this] = ACTIONS(3176),
    [anon_sym_precise] = ACTIONS(3176),
    [anon_sym_shared] = ACTIONS(3176),
    [anon_sym_groupshared] = ACTIONS(3176),
    [anon_sym_uniform] = ACTIONS(3176),
    [anon_sym_row_major] = ACTIONS(3176),
    [anon_sym_column_major] = ACTIONS(3176),
    [anon_sym_globallycoherent] = ACTIONS(3176),
    [anon_sym_centroid] = ACTIONS(3176),
    [anon_sym_noperspective] = ACTIONS(3176),
    [anon_sym_nointerpolation] = ACTIONS(3176),
    [anon_sym_sample] = ACTIONS(3176),
    [anon_sym_linear] = ACTIONS(3176),
    [anon_sym_snorm] = ACTIONS(3176),
    [anon_sym_unorm] = ACTIONS(3176),
    [anon_sym_point] = ACTIONS(3176),
    [anon_sym_line] = ACTIONS(3176),
    [anon_sym_triangleadj] = ACTIONS(3176),
    [anon_sym_lineadj] = ACTIONS(3176),
    [anon_sym_triangle] = ACTIONS(3176),
    [anon_sym_interface] = ACTIONS(3176),
    [anon_sym_extension] = ACTIONS(3176),
    [anon_sym_where] = ACTIONS(3176),
    [anon_sym___exported] = ACTIONS(3176),
    [anon_sym_import] = ACTIONS(3176),
  },
  [380] = {
    [sym_identifier] = ACTIONS(3178),
    [aux_sym_preproc_include_token1] = ACTIONS(3178),
    [aux_sym_preproc_def_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token2] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3178),
    [aux_sym_preproc_else_token1] = ACTIONS(3178),
    [aux_sym_preproc_elif_token1] = ACTIONS(3178),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3178),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3178),
    [sym_preproc_directive] = ACTIONS(3178),
    [anon_sym_LPAREN2] = ACTIONS(3180),
    [anon_sym_BANG] = ACTIONS(3180),
    [anon_sym_TILDE] = ACTIONS(3180),
    [anon_sym_DASH] = ACTIONS(3178),
    [anon_sym_PLUS] = ACTIONS(3178),
    [anon_sym_STAR] = ACTIONS(3180),
    [anon_sym_AMP_AMP] = ACTIONS(3180),
    [anon_sym_AMP] = ACTIONS(3178),
    [anon_sym_SEMI] = ACTIONS(3180),
    [anon_sym___extension__] = ACTIONS(3178),
    [anon_sym_typedef] = ACTIONS(3178),
    [anon_sym_in] = ACTIONS(3178),
    [anon_sym_out] = ACTIONS(3178),
    [anon_sym_inout] = ACTIONS(3178),
    [anon_sym_extern] = ACTIONS(3178),
    [anon_sym___attribute__] = ACTIONS(3178),
    [anon_sym_COLON_COLON] = ACTIONS(3180),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3180),
    [anon_sym___declspec] = ACTIONS(3178),
    [anon_sym___based] = ACTIONS(3178),
    [anon_sym___cdecl] = ACTIONS(3178),
    [anon_sym___clrcall] = ACTIONS(3178),
    [anon_sym___stdcall] = ACTIONS(3178),
    [anon_sym___fastcall] = ACTIONS(3178),
    [anon_sym___thiscall] = ACTIONS(3178),
    [anon_sym___vectorcall] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(3180),
    [anon_sym_signed] = ACTIONS(3178),
    [anon_sym_unsigned] = ACTIONS(3178),
    [anon_sym_long] = ACTIONS(3178),
    [anon_sym_short] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(3178),
    [anon_sym_static] = ACTIONS(3178),
    [anon_sym_register] = ACTIONS(3178),
    [anon_sym_inline] = ACTIONS(3178),
    [anon_sym___inline] = ACTIONS(3178),
    [anon_sym___inline__] = ACTIONS(3178),
    [anon_sym___forceinline] = ACTIONS(3178),
    [anon_sym_thread_local] = ACTIONS(3178),
    [anon_sym___thread] = ACTIONS(3178),
    [anon_sym_const] = ACTIONS(3178),
    [anon_sym_constexpr] = ACTIONS(3178),
    [anon_sym_volatile] = ACTIONS(3178),
    [anon_sym_restrict] = ACTIONS(3178),
    [anon_sym___restrict__] = ACTIONS(3178),
    [anon_sym__Atomic] = ACTIONS(3178),
    [anon_sym__Noreturn] = ACTIONS(3178),
    [anon_sym_noreturn] = ACTIONS(3178),
    [anon_sym_mutable] = ACTIONS(3178),
    [anon_sym_constinit] = ACTIONS(3178),
    [anon_sym_consteval] = ACTIONS(3178),
    [anon_sym_alignas] = ACTIONS(3178),
    [anon_sym__Alignas] = ACTIONS(3178),
    [sym_primitive_type] = ACTIONS(3178),
    [anon_sym_enum] = ACTIONS(3178),
    [anon_sym_class] = ACTIONS(3178),
    [anon_sym_struct] = ACTIONS(3178),
    [anon_sym_union] = ACTIONS(3178),
    [anon_sym_if] = ACTIONS(3178),
    [anon_sym_else] = ACTIONS(3178),
    [anon_sym_switch] = ACTIONS(3178),
    [anon_sym_case] = ACTIONS(3178),
    [anon_sym_default] = ACTIONS(3178),
    [anon_sym_while] = ACTIONS(3178),
    [anon_sym_do] = ACTIONS(3178),
    [anon_sym_for] = ACTIONS(3178),
    [anon_sym_return] = ACTIONS(3178),
    [anon_sym_break] = ACTIONS(3178),
    [anon_sym_continue] = ACTIONS(3178),
    [anon_sym_goto] = ACTIONS(3178),
    [anon_sym___try] = ACTIONS(3178),
    [anon_sym___leave] = ACTIONS(3178),
    [anon_sym_not] = ACTIONS(3178),
    [anon_sym_compl] = ACTIONS(3178),
    [anon_sym_DASH_DASH] = ACTIONS(3180),
    [anon_sym_PLUS_PLUS] = ACTIONS(3180),
    [anon_sym_sizeof] = ACTIONS(3178),
    [anon_sym___alignof__] = ACTIONS(3178),
    [anon_sym___alignof] = ACTIONS(3178),
    [anon_sym__alignof] = ACTIONS(3178),
    [anon_sym_alignof] = ACTIONS(3178),
    [anon_sym__Alignof] = ACTIONS(3178),
    [anon_sym_offsetof] = ACTIONS(3178),
    [anon_sym__Generic] = ACTIONS(3178),
    [anon_sym_asm] = ACTIONS(3178),
    [anon_sym___asm__] = ACTIONS(3178),
    [sym_number_literal] = ACTIONS(3180),
    [anon_sym_L_SQUOTE] = ACTIONS(3180),
    [anon_sym_u_SQUOTE] = ACTIONS(3180),
    [anon_sym_U_SQUOTE] = ACTIONS(3180),
    [anon_sym_u8_SQUOTE] = ACTIONS(3180),
    [anon_sym_SQUOTE] = ACTIONS(3180),
    [anon_sym_L_DQUOTE] = ACTIONS(3180),
    [anon_sym_u_DQUOTE] = ACTIONS(3180),
    [anon_sym_U_DQUOTE] = ACTIONS(3180),
    [anon_sym_u8_DQUOTE] = ACTIONS(3180),
    [anon_sym_DQUOTE] = ACTIONS(3180),
    [sym_true] = ACTIONS(3178),
    [sym_false] = ACTIONS(3178),
    [anon_sym_NULL] = ACTIONS(3178),
    [anon_sym_nullptr] = ACTIONS(3178),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3178),
    [anon_sym_let] = ACTIONS(3178),
    [anon_sym_This] = ACTIONS(3178),
    [anon_sym_decltype] = ACTIONS(3178),
    [sym_virtual] = ACTIONS(3178),
    [anon_sym_explicit] = ACTIONS(3178),
    [anon_sym_typename] = ACTIONS(3178),
    [anon_sym_template] = ACTIONS(3178),
    [anon_sym_operator] = ACTIONS(3178),
    [anon_sym_try] = ACTIONS(3178),
    [anon_sym_delete] = ACTIONS(3178),
    [anon_sym_throw] = ACTIONS(3178),
    [anon_sym_namespace] = ACTIONS(3178),
    [anon_sym_using] = ACTIONS(3178),
    [anon_sym_static_assert] = ACTIONS(3178),
    [anon_sym_concept] = ACTIONS(3178),
    [anon_sym_co_return] = ACTIONS(3178),
    [anon_sym_co_yield] = ACTIONS(3178),
    [anon_sym_R_DQUOTE] = ACTIONS(3180),
    [anon_sym_LR_DQUOTE] = ACTIONS(3180),
    [anon_sym_uR_DQUOTE] = ACTIONS(3180),
    [anon_sym_UR_DQUOTE] = ACTIONS(3180),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3180),
    [anon_sym_co_await] = ACTIONS(3178),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3178),
    [sym_this] = ACTIONS(3178),
    [anon_sym_discard] = ACTIONS(3178),
    [anon_sym_precise] = ACTIONS(3178),
    [anon_sym_shared] = ACTIONS(3178),
    [anon_sym_groupshared] = ACTIONS(3178),
    [anon_sym_uniform] = ACTIONS(3178),
    [anon_sym_row_major] = ACTIONS(3178),
    [anon_sym_column_major] = ACTIONS(3178),
    [anon_sym_globallycoherent] = ACTIONS(3178),
    [anon_sym_centroid] = ACTIONS(3178),
    [anon_sym_noperspective] = ACTIONS(3178),
    [anon_sym_nointerpolation] = ACTIONS(3178),
    [anon_sym_sample] = ACTIONS(3178),
    [anon_sym_linear] = ACTIONS(3178),
    [anon_sym_snorm] = ACTIONS(3178),
    [anon_sym_unorm] = ACTIONS(3178),
    [anon_sym_point] = ACTIONS(3178),
    [anon_sym_line] = ACTIONS(3178),
    [anon_sym_triangleadj] = ACTIONS(3178),
    [anon_sym_lineadj] = ACTIONS(3178),
    [anon_sym_triangle] = ACTIONS(3178),
    [anon_sym_cbuffer] = ACTIONS(3178),
    [anon_sym_interface] = ACTIONS(3178),
    [anon_sym_extension] = ACTIONS(3178),
  },
  [381] = {
    [sym_identifier] = ACTIONS(3182),
    [aux_sym_preproc_include_token1] = ACTIONS(3182),
    [aux_sym_preproc_def_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token2] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [aux_sym_preproc_else_token1] = ACTIONS(3182),
    [aux_sym_preproc_elif_token1] = ACTIONS(3182),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3182),
    [sym_preproc_directive] = ACTIONS(3182),
    [anon_sym_LPAREN2] = ACTIONS(3184),
    [anon_sym_BANG] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_DASH] = ACTIONS(3182),
    [anon_sym_PLUS] = ACTIONS(3182),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_AMP_AMP] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3182),
    [anon_sym_SEMI] = ACTIONS(3184),
    [anon_sym___extension__] = ACTIONS(3182),
    [anon_sym_typedef] = ACTIONS(3182),
    [anon_sym_in] = ACTIONS(3182),
    [anon_sym_out] = ACTIONS(3182),
    [anon_sym_inout] = ACTIONS(3182),
    [anon_sym_extern] = ACTIONS(3182),
    [anon_sym___attribute__] = ACTIONS(3182),
    [anon_sym_COLON_COLON] = ACTIONS(3184),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3184),
    [anon_sym___declspec] = ACTIONS(3182),
    [anon_sym___based] = ACTIONS(3182),
    [anon_sym___cdecl] = ACTIONS(3182),
    [anon_sym___clrcall] = ACTIONS(3182),
    [anon_sym___stdcall] = ACTIONS(3182),
    [anon_sym___fastcall] = ACTIONS(3182),
    [anon_sym___thiscall] = ACTIONS(3182),
    [anon_sym___vectorcall] = ACTIONS(3182),
    [anon_sym_LBRACE] = ACTIONS(3184),
    [anon_sym_signed] = ACTIONS(3182),
    [anon_sym_unsigned] = ACTIONS(3182),
    [anon_sym_long] = ACTIONS(3182),
    [anon_sym_short] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3182),
    [anon_sym_register] = ACTIONS(3182),
    [anon_sym_inline] = ACTIONS(3182),
    [anon_sym___inline] = ACTIONS(3182),
    [anon_sym___inline__] = ACTIONS(3182),
    [anon_sym___forceinline] = ACTIONS(3182),
    [anon_sym_thread_local] = ACTIONS(3182),
    [anon_sym___thread] = ACTIONS(3182),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_constexpr] = ACTIONS(3182),
    [anon_sym_volatile] = ACTIONS(3182),
    [anon_sym_restrict] = ACTIONS(3182),
    [anon_sym___restrict__] = ACTIONS(3182),
    [anon_sym__Atomic] = ACTIONS(3182),
    [anon_sym__Noreturn] = ACTIONS(3182),
    [anon_sym_noreturn] = ACTIONS(3182),
    [anon_sym_mutable] = ACTIONS(3182),
    [anon_sym_constinit] = ACTIONS(3182),
    [anon_sym_consteval] = ACTIONS(3182),
    [anon_sym_alignas] = ACTIONS(3182),
    [anon_sym__Alignas] = ACTIONS(3182),
    [sym_primitive_type] = ACTIONS(3182),
    [anon_sym_enum] = ACTIONS(3182),
    [anon_sym_class] = ACTIONS(3182),
    [anon_sym_struct] = ACTIONS(3182),
    [anon_sym_union] = ACTIONS(3182),
    [anon_sym_if] = ACTIONS(3182),
    [anon_sym_else] = ACTIONS(3182),
    [anon_sym_switch] = ACTIONS(3182),
    [anon_sym_case] = ACTIONS(3182),
    [anon_sym_default] = ACTIONS(3182),
    [anon_sym_while] = ACTIONS(3182),
    [anon_sym_do] = ACTIONS(3182),
    [anon_sym_for] = ACTIONS(3182),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_break] = ACTIONS(3182),
    [anon_sym_continue] = ACTIONS(3182),
    [anon_sym_goto] = ACTIONS(3182),
    [anon_sym___try] = ACTIONS(3182),
    [anon_sym___leave] = ACTIONS(3182),
    [anon_sym_not] = ACTIONS(3182),
    [anon_sym_compl] = ACTIONS(3182),
    [anon_sym_DASH_DASH] = ACTIONS(3184),
    [anon_sym_PLUS_PLUS] = ACTIONS(3184),
    [anon_sym_sizeof] = ACTIONS(3182),
    [anon_sym___alignof__] = ACTIONS(3182),
    [anon_sym___alignof] = ACTIONS(3182),
    [anon_sym__alignof] = ACTIONS(3182),
    [anon_sym_alignof] = ACTIONS(3182),
    [anon_sym__Alignof] = ACTIONS(3182),
    [anon_sym_offsetof] = ACTIONS(3182),
    [anon_sym__Generic] = ACTIONS(3182),
    [anon_sym_asm] = ACTIONS(3182),
    [anon_sym___asm__] = ACTIONS(3182),
    [sym_number_literal] = ACTIONS(3184),
    [anon_sym_L_SQUOTE] = ACTIONS(3184),
    [anon_sym_u_SQUOTE] = ACTIONS(3184),
    [anon_sym_U_SQUOTE] = ACTIONS(3184),
    [anon_sym_u8_SQUOTE] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3184),
    [anon_sym_L_DQUOTE] = ACTIONS(3184),
    [anon_sym_u_DQUOTE] = ACTIONS(3184),
    [anon_sym_U_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8_DQUOTE] = ACTIONS(3184),
    [anon_sym_DQUOTE] = ACTIONS(3184),
    [sym_true] = ACTIONS(3182),
    [sym_false] = ACTIONS(3182),
    [anon_sym_NULL] = ACTIONS(3182),
    [anon_sym_nullptr] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3182),
    [anon_sym_let] = ACTIONS(3182),
    [anon_sym_This] = ACTIONS(3182),
    [anon_sym_decltype] = ACTIONS(3182),
    [sym_virtual] = ACTIONS(3182),
    [anon_sym_explicit] = ACTIONS(3182),
    [anon_sym_typename] = ACTIONS(3182),
    [anon_sym_template] = ACTIONS(3182),
    [anon_sym_operator] = ACTIONS(3182),
    [anon_sym_try] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(3182),
    [anon_sym_throw] = ACTIONS(3182),
    [anon_sym_namespace] = ACTIONS(3182),
    [anon_sym_using] = ACTIONS(3182),
    [anon_sym_static_assert] = ACTIONS(3182),
    [anon_sym_concept] = ACTIONS(3182),
    [anon_sym_co_return] = ACTIONS(3182),
    [anon_sym_co_yield] = ACTIONS(3182),
    [anon_sym_R_DQUOTE] = ACTIONS(3184),
    [anon_sym_LR_DQUOTE] = ACTIONS(3184),
    [anon_sym_uR_DQUOTE] = ACTIONS(3184),
    [anon_sym_UR_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3184),
    [anon_sym_co_await] = ACTIONS(3182),
    [anon_sym_new] = ACTIONS(3182),
    [anon_sym_requires] = ACTIONS(3182),
    [sym_this] = ACTIONS(3182),
    [anon_sym_discard] = ACTIONS(3182),
    [anon_sym_precise] = ACTIONS(3182),
    [anon_sym_shared] = ACTIONS(3182),
    [anon_sym_groupshared] = ACTIONS(3182),
    [anon_sym_uniform] = ACTIONS(3182),
    [anon_sym_row_major] = ACTIONS(3182),
    [anon_sym_column_major] = ACTIONS(3182),
    [anon_sym_globallycoherent] = ACTIONS(3182),
    [anon_sym_centroid] = ACTIONS(3182),
    [anon_sym_noperspective] = ACTIONS(3182),
    [anon_sym_nointerpolation] = ACTIONS(3182),
    [anon_sym_sample] = ACTIONS(3182),
    [anon_sym_linear] = ACTIONS(3182),
    [anon_sym_snorm] = ACTIONS(3182),
    [anon_sym_unorm] = ACTIONS(3182),
    [anon_sym_point] = ACTIONS(3182),
    [anon_sym_line] = ACTIONS(3182),
    [anon_sym_triangleadj] = ACTIONS(3182),
    [anon_sym_lineadj] = ACTIONS(3182),
    [anon_sym_triangle] = ACTIONS(3182),
    [anon_sym_cbuffer] = ACTIONS(3182),
    [anon_sym_interface] = ACTIONS(3182),
    [anon_sym_extension] = ACTIONS(3182),
  },
  [382] = {
    [sym_preproc_def] = STATE(371),
    [sym_preproc_function_def] = STATE(371),
    [sym_preproc_call] = STATE(371),
    [sym_preproc_if_in_field_declaration_list] = STATE(371),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(371),
    [sym_type_definition] = STATE(371),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(371),
    [sym_field_declaration] = STATE(371),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(371),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(371),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(371),
    [sym_operator_cast_declaration] = STATE(371),
    [sym_constructor_or_destructor_definition] = STATE(371),
    [sym_constructor_or_destructor_declaration] = STATE(371),
    [sym_friend_declaration] = STATE(371),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(371),
    [sym_alias_declaration] = STATE(371),
    [sym_static_assert_declaration] = STATE(371),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(371),
    [sym_subscript_declaration] = STATE(371),
    [sym_property_declaration] = STATE(371),
    [sym_associatedtype_declaration] = STATE(371),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(371),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3186),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [383] = {
    [sym_identifier] = ACTIONS(3182),
    [aux_sym_preproc_include_token1] = ACTIONS(3182),
    [aux_sym_preproc_def_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token2] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [aux_sym_preproc_else_token1] = ACTIONS(3182),
    [aux_sym_preproc_elif_token1] = ACTIONS(3182),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3182),
    [sym_preproc_directive] = ACTIONS(3182),
    [anon_sym_LPAREN2] = ACTIONS(3184),
    [anon_sym_BANG] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_DASH] = ACTIONS(3182),
    [anon_sym_PLUS] = ACTIONS(3182),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_AMP_AMP] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3182),
    [anon_sym_SEMI] = ACTIONS(3184),
    [anon_sym___extension__] = ACTIONS(3182),
    [anon_sym_typedef] = ACTIONS(3182),
    [anon_sym_in] = ACTIONS(3182),
    [anon_sym_out] = ACTIONS(3182),
    [anon_sym_inout] = ACTIONS(3182),
    [anon_sym_extern] = ACTIONS(3182),
    [anon_sym___attribute__] = ACTIONS(3182),
    [anon_sym_COLON_COLON] = ACTIONS(3184),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3184),
    [anon_sym___declspec] = ACTIONS(3182),
    [anon_sym___based] = ACTIONS(3182),
    [anon_sym___cdecl] = ACTIONS(3182),
    [anon_sym___clrcall] = ACTIONS(3182),
    [anon_sym___stdcall] = ACTIONS(3182),
    [anon_sym___fastcall] = ACTIONS(3182),
    [anon_sym___thiscall] = ACTIONS(3182),
    [anon_sym___vectorcall] = ACTIONS(3182),
    [anon_sym_LBRACE] = ACTIONS(3184),
    [anon_sym_signed] = ACTIONS(3182),
    [anon_sym_unsigned] = ACTIONS(3182),
    [anon_sym_long] = ACTIONS(3182),
    [anon_sym_short] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3182),
    [anon_sym_register] = ACTIONS(3182),
    [anon_sym_inline] = ACTIONS(3182),
    [anon_sym___inline] = ACTIONS(3182),
    [anon_sym___inline__] = ACTIONS(3182),
    [anon_sym___forceinline] = ACTIONS(3182),
    [anon_sym_thread_local] = ACTIONS(3182),
    [anon_sym___thread] = ACTIONS(3182),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_constexpr] = ACTIONS(3182),
    [anon_sym_volatile] = ACTIONS(3182),
    [anon_sym_restrict] = ACTIONS(3182),
    [anon_sym___restrict__] = ACTIONS(3182),
    [anon_sym__Atomic] = ACTIONS(3182),
    [anon_sym__Noreturn] = ACTIONS(3182),
    [anon_sym_noreturn] = ACTIONS(3182),
    [anon_sym_mutable] = ACTIONS(3182),
    [anon_sym_constinit] = ACTIONS(3182),
    [anon_sym_consteval] = ACTIONS(3182),
    [anon_sym_alignas] = ACTIONS(3182),
    [anon_sym__Alignas] = ACTIONS(3182),
    [sym_primitive_type] = ACTIONS(3182),
    [anon_sym_enum] = ACTIONS(3182),
    [anon_sym_class] = ACTIONS(3182),
    [anon_sym_struct] = ACTIONS(3182),
    [anon_sym_union] = ACTIONS(3182),
    [anon_sym_if] = ACTIONS(3182),
    [anon_sym_else] = ACTIONS(3182),
    [anon_sym_switch] = ACTIONS(3182),
    [anon_sym_case] = ACTIONS(3182),
    [anon_sym_default] = ACTIONS(3182),
    [anon_sym_while] = ACTIONS(3182),
    [anon_sym_do] = ACTIONS(3182),
    [anon_sym_for] = ACTIONS(3182),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_break] = ACTIONS(3182),
    [anon_sym_continue] = ACTIONS(3182),
    [anon_sym_goto] = ACTIONS(3182),
    [anon_sym___try] = ACTIONS(3182),
    [anon_sym___leave] = ACTIONS(3182),
    [anon_sym_not] = ACTIONS(3182),
    [anon_sym_compl] = ACTIONS(3182),
    [anon_sym_DASH_DASH] = ACTIONS(3184),
    [anon_sym_PLUS_PLUS] = ACTIONS(3184),
    [anon_sym_sizeof] = ACTIONS(3182),
    [anon_sym___alignof__] = ACTIONS(3182),
    [anon_sym___alignof] = ACTIONS(3182),
    [anon_sym__alignof] = ACTIONS(3182),
    [anon_sym_alignof] = ACTIONS(3182),
    [anon_sym__Alignof] = ACTIONS(3182),
    [anon_sym_offsetof] = ACTIONS(3182),
    [anon_sym__Generic] = ACTIONS(3182),
    [anon_sym_asm] = ACTIONS(3182),
    [anon_sym___asm__] = ACTIONS(3182),
    [sym_number_literal] = ACTIONS(3184),
    [anon_sym_L_SQUOTE] = ACTIONS(3184),
    [anon_sym_u_SQUOTE] = ACTIONS(3184),
    [anon_sym_U_SQUOTE] = ACTIONS(3184),
    [anon_sym_u8_SQUOTE] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3184),
    [anon_sym_L_DQUOTE] = ACTIONS(3184),
    [anon_sym_u_DQUOTE] = ACTIONS(3184),
    [anon_sym_U_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8_DQUOTE] = ACTIONS(3184),
    [anon_sym_DQUOTE] = ACTIONS(3184),
    [sym_true] = ACTIONS(3182),
    [sym_false] = ACTIONS(3182),
    [anon_sym_NULL] = ACTIONS(3182),
    [anon_sym_nullptr] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3182),
    [anon_sym_let] = ACTIONS(3182),
    [anon_sym_This] = ACTIONS(3182),
    [anon_sym_decltype] = ACTIONS(3182),
    [sym_virtual] = ACTIONS(3182),
    [anon_sym_explicit] = ACTIONS(3182),
    [anon_sym_typename] = ACTIONS(3182),
    [anon_sym_template] = ACTIONS(3182),
    [anon_sym_operator] = ACTIONS(3182),
    [anon_sym_try] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(3182),
    [anon_sym_throw] = ACTIONS(3182),
    [anon_sym_namespace] = ACTIONS(3182),
    [anon_sym_using] = ACTIONS(3182),
    [anon_sym_static_assert] = ACTIONS(3182),
    [anon_sym_concept] = ACTIONS(3182),
    [anon_sym_co_return] = ACTIONS(3182),
    [anon_sym_co_yield] = ACTIONS(3182),
    [anon_sym_R_DQUOTE] = ACTIONS(3184),
    [anon_sym_LR_DQUOTE] = ACTIONS(3184),
    [anon_sym_uR_DQUOTE] = ACTIONS(3184),
    [anon_sym_UR_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3184),
    [anon_sym_co_await] = ACTIONS(3182),
    [anon_sym_new] = ACTIONS(3182),
    [anon_sym_requires] = ACTIONS(3182),
    [sym_this] = ACTIONS(3182),
    [anon_sym_discard] = ACTIONS(3182),
    [anon_sym_precise] = ACTIONS(3182),
    [anon_sym_shared] = ACTIONS(3182),
    [anon_sym_groupshared] = ACTIONS(3182),
    [anon_sym_uniform] = ACTIONS(3182),
    [anon_sym_row_major] = ACTIONS(3182),
    [anon_sym_column_major] = ACTIONS(3182),
    [anon_sym_globallycoherent] = ACTIONS(3182),
    [anon_sym_centroid] = ACTIONS(3182),
    [anon_sym_noperspective] = ACTIONS(3182),
    [anon_sym_nointerpolation] = ACTIONS(3182),
    [anon_sym_sample] = ACTIONS(3182),
    [anon_sym_linear] = ACTIONS(3182),
    [anon_sym_snorm] = ACTIONS(3182),
    [anon_sym_unorm] = ACTIONS(3182),
    [anon_sym_point] = ACTIONS(3182),
    [anon_sym_line] = ACTIONS(3182),
    [anon_sym_triangleadj] = ACTIONS(3182),
    [anon_sym_lineadj] = ACTIONS(3182),
    [anon_sym_triangle] = ACTIONS(3182),
    [anon_sym_cbuffer] = ACTIONS(3182),
    [anon_sym_interface] = ACTIONS(3182),
    [anon_sym_extension] = ACTIONS(3182),
  },
  [384] = {
    [sym_preproc_def] = STATE(386),
    [sym_preproc_function_def] = STATE(386),
    [sym_preproc_call] = STATE(386),
    [sym_preproc_if_in_field_declaration_list] = STATE(386),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(386),
    [sym_type_definition] = STATE(386),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(386),
    [sym_field_declaration] = STATE(386),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(386),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(386),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(386),
    [sym_operator_cast_declaration] = STATE(386),
    [sym_constructor_or_destructor_definition] = STATE(386),
    [sym_constructor_or_destructor_declaration] = STATE(386),
    [sym_friend_declaration] = STATE(386),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(386),
    [sym_alias_declaration] = STATE(386),
    [sym_static_assert_declaration] = STATE(386),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(386),
    [sym_subscript_declaration] = STATE(386),
    [sym_property_declaration] = STATE(386),
    [sym_associatedtype_declaration] = STATE(386),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(386),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3188),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [385] = {
    [ts_builtin_sym_end] = ACTIONS(3190),
    [sym_identifier] = ACTIONS(3192),
    [aux_sym_preproc_include_token1] = ACTIONS(3192),
    [aux_sym_preproc_def_token1] = ACTIONS(3192),
    [anon_sym_COMMA] = ACTIONS(3190),
    [anon_sym_RPAREN] = ACTIONS(3190),
    [aux_sym_preproc_if_token1] = ACTIONS(3192),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3192),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3192),
    [sym_preproc_directive] = ACTIONS(3192),
    [anon_sym_LPAREN2] = ACTIONS(3190),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3192),
    [anon_sym_PLUS] = ACTIONS(3192),
    [anon_sym_STAR] = ACTIONS(3190),
    [anon_sym_AMP_AMP] = ACTIONS(3190),
    [anon_sym_AMP] = ACTIONS(3192),
    [anon_sym_SEMI] = ACTIONS(3190),
    [anon_sym___extension__] = ACTIONS(3192),
    [anon_sym_typedef] = ACTIONS(3192),
    [anon_sym_in] = ACTIONS(3192),
    [anon_sym_out] = ACTIONS(3192),
    [anon_sym_inout] = ACTIONS(3192),
    [anon_sym_extern] = ACTIONS(3192),
    [anon_sym___attribute__] = ACTIONS(3192),
    [anon_sym_COLON_COLON] = ACTIONS(3190),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3190),
    [anon_sym___declspec] = ACTIONS(3192),
    [anon_sym___based] = ACTIONS(3192),
    [anon_sym___cdecl] = ACTIONS(3192),
    [anon_sym___clrcall] = ACTIONS(3192),
    [anon_sym___stdcall] = ACTIONS(3192),
    [anon_sym___fastcall] = ACTIONS(3192),
    [anon_sym___thiscall] = ACTIONS(3192),
    [anon_sym___vectorcall] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(3190),
    [anon_sym_signed] = ACTIONS(3192),
    [anon_sym_unsigned] = ACTIONS(3192),
    [anon_sym_long] = ACTIONS(3192),
    [anon_sym_short] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(3192),
    [anon_sym_static] = ACTIONS(3192),
    [anon_sym_register] = ACTIONS(3192),
    [anon_sym_inline] = ACTIONS(3192),
    [anon_sym___inline] = ACTIONS(3192),
    [anon_sym___inline__] = ACTIONS(3192),
    [anon_sym___forceinline] = ACTIONS(3192),
    [anon_sym_thread_local] = ACTIONS(3192),
    [anon_sym___thread] = ACTIONS(3192),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_constexpr] = ACTIONS(3192),
    [anon_sym_volatile] = ACTIONS(3192),
    [anon_sym_restrict] = ACTIONS(3192),
    [anon_sym___restrict__] = ACTIONS(3192),
    [anon_sym__Atomic] = ACTIONS(3192),
    [anon_sym__Noreturn] = ACTIONS(3192),
    [anon_sym_noreturn] = ACTIONS(3192),
    [anon_sym_mutable] = ACTIONS(3192),
    [anon_sym_constinit] = ACTIONS(3192),
    [anon_sym_consteval] = ACTIONS(3192),
    [anon_sym_alignas] = ACTIONS(3192),
    [anon_sym__Alignas] = ACTIONS(3192),
    [sym_primitive_type] = ACTIONS(3192),
    [anon_sym_enum] = ACTIONS(3192),
    [anon_sym_class] = ACTIONS(3192),
    [anon_sym_struct] = ACTIONS(3192),
    [anon_sym_union] = ACTIONS(3192),
    [anon_sym_if] = ACTIONS(3192),
    [anon_sym_switch] = ACTIONS(3192),
    [anon_sym_case] = ACTIONS(3192),
    [anon_sym_default] = ACTIONS(3192),
    [anon_sym_while] = ACTIONS(3192),
    [anon_sym_do] = ACTIONS(3192),
    [anon_sym_for] = ACTIONS(3192),
    [anon_sym_return] = ACTIONS(3192),
    [anon_sym_break] = ACTIONS(3192),
    [anon_sym_continue] = ACTIONS(3192),
    [anon_sym_goto] = ACTIONS(3192),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_compl] = ACTIONS(3192),
    [anon_sym_DASH_DASH] = ACTIONS(3190),
    [anon_sym_PLUS_PLUS] = ACTIONS(3190),
    [anon_sym_sizeof] = ACTIONS(3192),
    [anon_sym___alignof__] = ACTIONS(3192),
    [anon_sym___alignof] = ACTIONS(3192),
    [anon_sym__alignof] = ACTIONS(3192),
    [anon_sym_alignof] = ACTIONS(3192),
    [anon_sym__Alignof] = ACTIONS(3192),
    [anon_sym_offsetof] = ACTIONS(3192),
    [anon_sym__Generic] = ACTIONS(3192),
    [anon_sym_asm] = ACTIONS(3192),
    [anon_sym___asm__] = ACTIONS(3192),
    [anon_sym_DOT] = ACTIONS(3192),
    [sym_number_literal] = ACTIONS(3190),
    [anon_sym_L_SQUOTE] = ACTIONS(3190),
    [anon_sym_u_SQUOTE] = ACTIONS(3190),
    [anon_sym_U_SQUOTE] = ACTIONS(3190),
    [anon_sym_u8_SQUOTE] = ACTIONS(3190),
    [anon_sym_SQUOTE] = ACTIONS(3190),
    [anon_sym_L_DQUOTE] = ACTIONS(3190),
    [anon_sym_u_DQUOTE] = ACTIONS(3190),
    [anon_sym_U_DQUOTE] = ACTIONS(3190),
    [anon_sym_u8_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE] = ACTIONS(3190),
    [sym_true] = ACTIONS(3192),
    [sym_false] = ACTIONS(3192),
    [anon_sym_NULL] = ACTIONS(3192),
    [anon_sym_nullptr] = ACTIONS(3192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3192),
    [anon_sym_let] = ACTIONS(3192),
    [anon_sym_This] = ACTIONS(3192),
    [anon_sym_decltype] = ACTIONS(3192),
    [anon_sym_final] = ACTIONS(3192),
    [anon_sym_override] = ACTIONS(3192),
    [sym_virtual] = ACTIONS(3192),
    [anon_sym_explicit] = ACTIONS(3192),
    [anon_sym_typename] = ACTIONS(3192),
    [anon_sym_template] = ACTIONS(3192),
    [anon_sym_GT2] = ACTIONS(3190),
    [anon_sym_operator] = ACTIONS(3192),
    [anon_sym_try] = ACTIONS(3192),
    [anon_sym_delete] = ACTIONS(3192),
    [anon_sym_throw] = ACTIONS(3192),
    [anon_sym_namespace] = ACTIONS(3192),
    [anon_sym_using] = ACTIONS(3192),
    [anon_sym_static_assert] = ACTIONS(3192),
    [anon_sym_concept] = ACTIONS(3192),
    [anon_sym_co_return] = ACTIONS(3192),
    [anon_sym_co_yield] = ACTIONS(3192),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_LR_DQUOTE] = ACTIONS(3190),
    [anon_sym_uR_DQUOTE] = ACTIONS(3190),
    [anon_sym_UR_DQUOTE] = ACTIONS(3190),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3190),
    [anon_sym_co_await] = ACTIONS(3192),
    [anon_sym_new] = ACTIONS(3192),
    [anon_sym_requires] = ACTIONS(3192),
    [sym_this] = ACTIONS(3192),
    [anon_sym_precise] = ACTIONS(3192),
    [anon_sym_shared] = ACTIONS(3192),
    [anon_sym_groupshared] = ACTIONS(3192),
    [anon_sym_uniform] = ACTIONS(3192),
    [anon_sym_row_major] = ACTIONS(3192),
    [anon_sym_column_major] = ACTIONS(3192),
    [anon_sym_globallycoherent] = ACTIONS(3192),
    [anon_sym_centroid] = ACTIONS(3192),
    [anon_sym_noperspective] = ACTIONS(3192),
    [anon_sym_nointerpolation] = ACTIONS(3192),
    [anon_sym_sample] = ACTIONS(3192),
    [anon_sym_linear] = ACTIONS(3192),
    [anon_sym_snorm] = ACTIONS(3192),
    [anon_sym_unorm] = ACTIONS(3192),
    [anon_sym_point] = ACTIONS(3192),
    [anon_sym_line] = ACTIONS(3192),
    [anon_sym_triangleadj] = ACTIONS(3192),
    [anon_sym_lineadj] = ACTIONS(3192),
    [anon_sym_triangle] = ACTIONS(3192),
    [anon_sym_interface] = ACTIONS(3192),
    [anon_sym_extension] = ACTIONS(3192),
    [anon_sym_where] = ACTIONS(3192),
    [anon_sym___exported] = ACTIONS(3192),
    [anon_sym_import] = ACTIONS(3192),
  },
  [386] = {
    [sym_preproc_def] = STATE(371),
    [sym_preproc_function_def] = STATE(371),
    [sym_preproc_call] = STATE(371),
    [sym_preproc_if_in_field_declaration_list] = STATE(371),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(371),
    [sym_type_definition] = STATE(371),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(371),
    [sym_field_declaration] = STATE(371),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(371),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(371),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(371),
    [sym_operator_cast_declaration] = STATE(371),
    [sym_constructor_or_destructor_definition] = STATE(371),
    [sym_constructor_or_destructor_declaration] = STATE(371),
    [sym_friend_declaration] = STATE(371),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(371),
    [sym_alias_declaration] = STATE(371),
    [sym_static_assert_declaration] = STATE(371),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(371),
    [sym_subscript_declaration] = STATE(371),
    [sym_property_declaration] = STATE(371),
    [sym_associatedtype_declaration] = STATE(371),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(371),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3194),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [387] = {
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_include_token1] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3196),
    [aux_sym_preproc_if_token1] = ACTIONS(3196),
    [aux_sym_preproc_if_token2] = ACTIONS(3196),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3196),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3196),
    [aux_sym_preproc_else_token1] = ACTIONS(3196),
    [aux_sym_preproc_elif_token1] = ACTIONS(3196),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3196),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3196),
    [sym_preproc_directive] = ACTIONS(3196),
    [anon_sym_LPAREN2] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3196),
    [anon_sym_PLUS] = ACTIONS(3196),
    [anon_sym_STAR] = ACTIONS(3198),
    [anon_sym_AMP_AMP] = ACTIONS(3198),
    [anon_sym_AMP] = ACTIONS(3196),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(3196),
    [anon_sym_typedef] = ACTIONS(3196),
    [anon_sym_in] = ACTIONS(3196),
    [anon_sym_out] = ACTIONS(3196),
    [anon_sym_inout] = ACTIONS(3196),
    [anon_sym_extern] = ACTIONS(3196),
    [anon_sym___attribute__] = ACTIONS(3196),
    [anon_sym_COLON_COLON] = ACTIONS(3198),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3198),
    [anon_sym___declspec] = ACTIONS(3196),
    [anon_sym___based] = ACTIONS(3196),
    [anon_sym___cdecl] = ACTIONS(3196),
    [anon_sym___clrcall] = ACTIONS(3196),
    [anon_sym___stdcall] = ACTIONS(3196),
    [anon_sym___fastcall] = ACTIONS(3196),
    [anon_sym___thiscall] = ACTIONS(3196),
    [anon_sym___vectorcall] = ACTIONS(3196),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_signed] = ACTIONS(3196),
    [anon_sym_unsigned] = ACTIONS(3196),
    [anon_sym_long] = ACTIONS(3196),
    [anon_sym_short] = ACTIONS(3196),
    [anon_sym_LBRACK] = ACTIONS(3196),
    [anon_sym_static] = ACTIONS(3196),
    [anon_sym_register] = ACTIONS(3196),
    [anon_sym_inline] = ACTIONS(3196),
    [anon_sym___inline] = ACTIONS(3196),
    [anon_sym___inline__] = ACTIONS(3196),
    [anon_sym___forceinline] = ACTIONS(3196),
    [anon_sym_thread_local] = ACTIONS(3196),
    [anon_sym___thread] = ACTIONS(3196),
    [anon_sym_const] = ACTIONS(3196),
    [anon_sym_constexpr] = ACTIONS(3196),
    [anon_sym_volatile] = ACTIONS(3196),
    [anon_sym_restrict] = ACTIONS(3196),
    [anon_sym___restrict__] = ACTIONS(3196),
    [anon_sym__Atomic] = ACTIONS(3196),
    [anon_sym__Noreturn] = ACTIONS(3196),
    [anon_sym_noreturn] = ACTIONS(3196),
    [anon_sym_mutable] = ACTIONS(3196),
    [anon_sym_constinit] = ACTIONS(3196),
    [anon_sym_consteval] = ACTIONS(3196),
    [anon_sym_alignas] = ACTIONS(3196),
    [anon_sym__Alignas] = ACTIONS(3196),
    [sym_primitive_type] = ACTIONS(3196),
    [anon_sym_enum] = ACTIONS(3196),
    [anon_sym_class] = ACTIONS(3196),
    [anon_sym_struct] = ACTIONS(3196),
    [anon_sym_union] = ACTIONS(3196),
    [anon_sym_if] = ACTIONS(3196),
    [anon_sym_else] = ACTIONS(3196),
    [anon_sym_switch] = ACTIONS(3196),
    [anon_sym_case] = ACTIONS(3196),
    [anon_sym_default] = ACTIONS(3196),
    [anon_sym_while] = ACTIONS(3196),
    [anon_sym_do] = ACTIONS(3196),
    [anon_sym_for] = ACTIONS(3196),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_break] = ACTIONS(3196),
    [anon_sym_continue] = ACTIONS(3196),
    [anon_sym_goto] = ACTIONS(3196),
    [anon_sym___try] = ACTIONS(3196),
    [anon_sym___leave] = ACTIONS(3196),
    [anon_sym_not] = ACTIONS(3196),
    [anon_sym_compl] = ACTIONS(3196),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(3196),
    [anon_sym___alignof] = ACTIONS(3196),
    [anon_sym__alignof] = ACTIONS(3196),
    [anon_sym_alignof] = ACTIONS(3196),
    [anon_sym__Alignof] = ACTIONS(3196),
    [anon_sym_offsetof] = ACTIONS(3196),
    [anon_sym__Generic] = ACTIONS(3196),
    [anon_sym_asm] = ACTIONS(3196),
    [anon_sym___asm__] = ACTIONS(3196),
    [sym_number_literal] = ACTIONS(3198),
    [anon_sym_L_SQUOTE] = ACTIONS(3198),
    [anon_sym_u_SQUOTE] = ACTIONS(3198),
    [anon_sym_U_SQUOTE] = ACTIONS(3198),
    [anon_sym_u8_SQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_L_DQUOTE] = ACTIONS(3198),
    [anon_sym_u_DQUOTE] = ACTIONS(3198),
    [anon_sym_U_DQUOTE] = ACTIONS(3198),
    [anon_sym_u8_DQUOTE] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [sym_true] = ACTIONS(3196),
    [sym_false] = ACTIONS(3196),
    [anon_sym_NULL] = ACTIONS(3196),
    [anon_sym_nullptr] = ACTIONS(3196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3196),
    [anon_sym_let] = ACTIONS(3196),
    [anon_sym_This] = ACTIONS(3196),
    [anon_sym_decltype] = ACTIONS(3196),
    [sym_virtual] = ACTIONS(3196),
    [anon_sym_explicit] = ACTIONS(3196),
    [anon_sym_typename] = ACTIONS(3196),
    [anon_sym_template] = ACTIONS(3196),
    [anon_sym_operator] = ACTIONS(3196),
    [anon_sym_try] = ACTIONS(3196),
    [anon_sym_delete] = ACTIONS(3196),
    [anon_sym_throw] = ACTIONS(3196),
    [anon_sym_namespace] = ACTIONS(3196),
    [anon_sym_using] = ACTIONS(3196),
    [anon_sym_static_assert] = ACTIONS(3196),
    [anon_sym_concept] = ACTIONS(3196),
    [anon_sym_co_return] = ACTIONS(3196),
    [anon_sym_co_yield] = ACTIONS(3196),
    [anon_sym_R_DQUOTE] = ACTIONS(3198),
    [anon_sym_LR_DQUOTE] = ACTIONS(3198),
    [anon_sym_uR_DQUOTE] = ACTIONS(3198),
    [anon_sym_UR_DQUOTE] = ACTIONS(3198),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3198),
    [anon_sym_co_await] = ACTIONS(3196),
    [anon_sym_new] = ACTIONS(3196),
    [anon_sym_requires] = ACTIONS(3196),
    [sym_this] = ACTIONS(3196),
    [anon_sym_discard] = ACTIONS(3196),
    [anon_sym_precise] = ACTIONS(3196),
    [anon_sym_shared] = ACTIONS(3196),
    [anon_sym_groupshared] = ACTIONS(3196),
    [anon_sym_uniform] = ACTIONS(3196),
    [anon_sym_row_major] = ACTIONS(3196),
    [anon_sym_column_major] = ACTIONS(3196),
    [anon_sym_globallycoherent] = ACTIONS(3196),
    [anon_sym_centroid] = ACTIONS(3196),
    [anon_sym_noperspective] = ACTIONS(3196),
    [anon_sym_nointerpolation] = ACTIONS(3196),
    [anon_sym_sample] = ACTIONS(3196),
    [anon_sym_linear] = ACTIONS(3196),
    [anon_sym_snorm] = ACTIONS(3196),
    [anon_sym_unorm] = ACTIONS(3196),
    [anon_sym_point] = ACTIONS(3196),
    [anon_sym_line] = ACTIONS(3196),
    [anon_sym_triangleadj] = ACTIONS(3196),
    [anon_sym_lineadj] = ACTIONS(3196),
    [anon_sym_triangle] = ACTIONS(3196),
    [anon_sym_cbuffer] = ACTIONS(3196),
    [anon_sym_interface] = ACTIONS(3196),
    [anon_sym_extension] = ACTIONS(3196),
  },
  [388] = {
    [ts_builtin_sym_end] = ACTIONS(3200),
    [sym_identifier] = ACTIONS(3202),
    [aux_sym_preproc_include_token1] = ACTIONS(3202),
    [aux_sym_preproc_def_token1] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3200),
    [anon_sym_RPAREN] = ACTIONS(3200),
    [aux_sym_preproc_if_token1] = ACTIONS(3202),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3202),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3202),
    [sym_preproc_directive] = ACTIONS(3202),
    [anon_sym_LPAREN2] = ACTIONS(3200),
    [anon_sym_BANG] = ACTIONS(3200),
    [anon_sym_TILDE] = ACTIONS(3200),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_STAR] = ACTIONS(3200),
    [anon_sym_AMP_AMP] = ACTIONS(3200),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_SEMI] = ACTIONS(3200),
    [anon_sym___extension__] = ACTIONS(3202),
    [anon_sym_typedef] = ACTIONS(3202),
    [anon_sym_in] = ACTIONS(3202),
    [anon_sym_out] = ACTIONS(3202),
    [anon_sym_inout] = ACTIONS(3202),
    [anon_sym_extern] = ACTIONS(3202),
    [anon_sym___attribute__] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3200),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3200),
    [anon_sym___declspec] = ACTIONS(3202),
    [anon_sym___based] = ACTIONS(3202),
    [anon_sym___cdecl] = ACTIONS(3202),
    [anon_sym___clrcall] = ACTIONS(3202),
    [anon_sym___stdcall] = ACTIONS(3202),
    [anon_sym___fastcall] = ACTIONS(3202),
    [anon_sym___thiscall] = ACTIONS(3202),
    [anon_sym___vectorcall] = ACTIONS(3202),
    [anon_sym_LBRACE] = ACTIONS(3200),
    [anon_sym_signed] = ACTIONS(3202),
    [anon_sym_unsigned] = ACTIONS(3202),
    [anon_sym_long] = ACTIONS(3202),
    [anon_sym_short] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_static] = ACTIONS(3202),
    [anon_sym_register] = ACTIONS(3202),
    [anon_sym_inline] = ACTIONS(3202),
    [anon_sym___inline] = ACTIONS(3202),
    [anon_sym___inline__] = ACTIONS(3202),
    [anon_sym___forceinline] = ACTIONS(3202),
    [anon_sym_thread_local] = ACTIONS(3202),
    [anon_sym___thread] = ACTIONS(3202),
    [anon_sym_const] = ACTIONS(3202),
    [anon_sym_constexpr] = ACTIONS(3202),
    [anon_sym_volatile] = ACTIONS(3202),
    [anon_sym_restrict] = ACTIONS(3202),
    [anon_sym___restrict__] = ACTIONS(3202),
    [anon_sym__Atomic] = ACTIONS(3202),
    [anon_sym__Noreturn] = ACTIONS(3202),
    [anon_sym_noreturn] = ACTIONS(3202),
    [anon_sym_mutable] = ACTIONS(3202),
    [anon_sym_constinit] = ACTIONS(3202),
    [anon_sym_consteval] = ACTIONS(3202),
    [anon_sym_alignas] = ACTIONS(3202),
    [anon_sym__Alignas] = ACTIONS(3202),
    [sym_primitive_type] = ACTIONS(3202),
    [anon_sym_enum] = ACTIONS(3202),
    [anon_sym_class] = ACTIONS(3202),
    [anon_sym_struct] = ACTIONS(3202),
    [anon_sym_union] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_switch] = ACTIONS(3202),
    [anon_sym_case] = ACTIONS(3202),
    [anon_sym_default] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_break] = ACTIONS(3202),
    [anon_sym_continue] = ACTIONS(3202),
    [anon_sym_goto] = ACTIONS(3202),
    [anon_sym_not] = ACTIONS(3202),
    [anon_sym_compl] = ACTIONS(3202),
    [anon_sym_DASH_DASH] = ACTIONS(3200),
    [anon_sym_PLUS_PLUS] = ACTIONS(3200),
    [anon_sym_sizeof] = ACTIONS(3202),
    [anon_sym___alignof__] = ACTIONS(3202),
    [anon_sym___alignof] = ACTIONS(3202),
    [anon_sym__alignof] = ACTIONS(3202),
    [anon_sym_alignof] = ACTIONS(3202),
    [anon_sym__Alignof] = ACTIONS(3202),
    [anon_sym_offsetof] = ACTIONS(3202),
    [anon_sym__Generic] = ACTIONS(3202),
    [anon_sym_asm] = ACTIONS(3202),
    [anon_sym___asm__] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(3202),
    [sym_number_literal] = ACTIONS(3200),
    [anon_sym_L_SQUOTE] = ACTIONS(3200),
    [anon_sym_u_SQUOTE] = ACTIONS(3200),
    [anon_sym_U_SQUOTE] = ACTIONS(3200),
    [anon_sym_u8_SQUOTE] = ACTIONS(3200),
    [anon_sym_SQUOTE] = ACTIONS(3200),
    [anon_sym_L_DQUOTE] = ACTIONS(3200),
    [anon_sym_u_DQUOTE] = ACTIONS(3200),
    [anon_sym_U_DQUOTE] = ACTIONS(3200),
    [anon_sym_u8_DQUOTE] = ACTIONS(3200),
    [anon_sym_DQUOTE] = ACTIONS(3200),
    [sym_true] = ACTIONS(3202),
    [sym_false] = ACTIONS(3202),
    [anon_sym_NULL] = ACTIONS(3202),
    [anon_sym_nullptr] = ACTIONS(3202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_This] = ACTIONS(3202),
    [anon_sym_decltype] = ACTIONS(3202),
    [anon_sym_final] = ACTIONS(3202),
    [anon_sym_override] = ACTIONS(3202),
    [sym_virtual] = ACTIONS(3202),
    [anon_sym_explicit] = ACTIONS(3202),
    [anon_sym_typename] = ACTIONS(3202),
    [anon_sym_template] = ACTIONS(3202),
    [anon_sym_GT2] = ACTIONS(3200),
    [anon_sym_operator] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_delete] = ACTIONS(3202),
    [anon_sym_throw] = ACTIONS(3202),
    [anon_sym_namespace] = ACTIONS(3202),
    [anon_sym_using] = ACTIONS(3202),
    [anon_sym_static_assert] = ACTIONS(3202),
    [anon_sym_concept] = ACTIONS(3202),
    [anon_sym_co_return] = ACTIONS(3202),
    [anon_sym_co_yield] = ACTIONS(3202),
    [anon_sym_R_DQUOTE] = ACTIONS(3200),
    [anon_sym_LR_DQUOTE] = ACTIONS(3200),
    [anon_sym_uR_DQUOTE] = ACTIONS(3200),
    [anon_sym_UR_DQUOTE] = ACTIONS(3200),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3200),
    [anon_sym_co_await] = ACTIONS(3202),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_requires] = ACTIONS(3202),
    [sym_this] = ACTIONS(3202),
    [anon_sym_precise] = ACTIONS(3202),
    [anon_sym_shared] = ACTIONS(3202),
    [anon_sym_groupshared] = ACTIONS(3202),
    [anon_sym_uniform] = ACTIONS(3202),
    [anon_sym_row_major] = ACTIONS(3202),
    [anon_sym_column_major] = ACTIONS(3202),
    [anon_sym_globallycoherent] = ACTIONS(3202),
    [anon_sym_centroid] = ACTIONS(3202),
    [anon_sym_noperspective] = ACTIONS(3202),
    [anon_sym_nointerpolation] = ACTIONS(3202),
    [anon_sym_sample] = ACTIONS(3202),
    [anon_sym_linear] = ACTIONS(3202),
    [anon_sym_snorm] = ACTIONS(3202),
    [anon_sym_unorm] = ACTIONS(3202),
    [anon_sym_point] = ACTIONS(3202),
    [anon_sym_line] = ACTIONS(3202),
    [anon_sym_triangleadj] = ACTIONS(3202),
    [anon_sym_lineadj] = ACTIONS(3202),
    [anon_sym_triangle] = ACTIONS(3202),
    [anon_sym_interface] = ACTIONS(3202),
    [anon_sym_extension] = ACTIONS(3202),
    [anon_sym_where] = ACTIONS(3202),
    [anon_sym___exported] = ACTIONS(3202),
    [anon_sym_import] = ACTIONS(3202),
  },
  [389] = {
    [ts_builtin_sym_end] = ACTIONS(3204),
    [sym_identifier] = ACTIONS(3206),
    [aux_sym_preproc_include_token1] = ACTIONS(3206),
    [aux_sym_preproc_def_token1] = ACTIONS(3206),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_RPAREN] = ACTIONS(3204),
    [aux_sym_preproc_if_token1] = ACTIONS(3206),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3206),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3206),
    [sym_preproc_directive] = ACTIONS(3206),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_BANG] = ACTIONS(3204),
    [anon_sym_TILDE] = ACTIONS(3204),
    [anon_sym_DASH] = ACTIONS(3206),
    [anon_sym_PLUS] = ACTIONS(3206),
    [anon_sym_STAR] = ACTIONS(3204),
    [anon_sym_AMP_AMP] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3206),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym___extension__] = ACTIONS(3206),
    [anon_sym_typedef] = ACTIONS(3206),
    [anon_sym_in] = ACTIONS(3206),
    [anon_sym_out] = ACTIONS(3206),
    [anon_sym_inout] = ACTIONS(3206),
    [anon_sym_extern] = ACTIONS(3206),
    [anon_sym___attribute__] = ACTIONS(3206),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3204),
    [anon_sym___declspec] = ACTIONS(3206),
    [anon_sym___based] = ACTIONS(3206),
    [anon_sym___cdecl] = ACTIONS(3206),
    [anon_sym___clrcall] = ACTIONS(3206),
    [anon_sym___stdcall] = ACTIONS(3206),
    [anon_sym___fastcall] = ACTIONS(3206),
    [anon_sym___thiscall] = ACTIONS(3206),
    [anon_sym___vectorcall] = ACTIONS(3206),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_signed] = ACTIONS(3206),
    [anon_sym_unsigned] = ACTIONS(3206),
    [anon_sym_long] = ACTIONS(3206),
    [anon_sym_short] = ACTIONS(3206),
    [anon_sym_LBRACK] = ACTIONS(3206),
    [anon_sym_static] = ACTIONS(3206),
    [anon_sym_register] = ACTIONS(3206),
    [anon_sym_inline] = ACTIONS(3206),
    [anon_sym___inline] = ACTIONS(3206),
    [anon_sym___inline__] = ACTIONS(3206),
    [anon_sym___forceinline] = ACTIONS(3206),
    [anon_sym_thread_local] = ACTIONS(3206),
    [anon_sym___thread] = ACTIONS(3206),
    [anon_sym_const] = ACTIONS(3206),
    [anon_sym_constexpr] = ACTIONS(3206),
    [anon_sym_volatile] = ACTIONS(3206),
    [anon_sym_restrict] = ACTIONS(3206),
    [anon_sym___restrict__] = ACTIONS(3206),
    [anon_sym__Atomic] = ACTIONS(3206),
    [anon_sym__Noreturn] = ACTIONS(3206),
    [anon_sym_noreturn] = ACTIONS(3206),
    [anon_sym_mutable] = ACTIONS(3206),
    [anon_sym_constinit] = ACTIONS(3206),
    [anon_sym_consteval] = ACTIONS(3206),
    [anon_sym_alignas] = ACTIONS(3206),
    [anon_sym__Alignas] = ACTIONS(3206),
    [sym_primitive_type] = ACTIONS(3206),
    [anon_sym_enum] = ACTIONS(3206),
    [anon_sym_class] = ACTIONS(3206),
    [anon_sym_struct] = ACTIONS(3206),
    [anon_sym_union] = ACTIONS(3206),
    [anon_sym_if] = ACTIONS(3206),
    [anon_sym_switch] = ACTIONS(3206),
    [anon_sym_case] = ACTIONS(3206),
    [anon_sym_default] = ACTIONS(3206),
    [anon_sym_while] = ACTIONS(3206),
    [anon_sym_do] = ACTIONS(3206),
    [anon_sym_for] = ACTIONS(3206),
    [anon_sym_return] = ACTIONS(3206),
    [anon_sym_break] = ACTIONS(3206),
    [anon_sym_continue] = ACTIONS(3206),
    [anon_sym_goto] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3206),
    [anon_sym_compl] = ACTIONS(3206),
    [anon_sym_DASH_DASH] = ACTIONS(3204),
    [anon_sym_PLUS_PLUS] = ACTIONS(3204),
    [anon_sym_sizeof] = ACTIONS(3206),
    [anon_sym___alignof__] = ACTIONS(3206),
    [anon_sym___alignof] = ACTIONS(3206),
    [anon_sym__alignof] = ACTIONS(3206),
    [anon_sym_alignof] = ACTIONS(3206),
    [anon_sym__Alignof] = ACTIONS(3206),
    [anon_sym_offsetof] = ACTIONS(3206),
    [anon_sym__Generic] = ACTIONS(3206),
    [anon_sym_asm] = ACTIONS(3206),
    [anon_sym___asm__] = ACTIONS(3206),
    [anon_sym_DOT] = ACTIONS(3206),
    [sym_number_literal] = ACTIONS(3204),
    [anon_sym_L_SQUOTE] = ACTIONS(3204),
    [anon_sym_u_SQUOTE] = ACTIONS(3204),
    [anon_sym_U_SQUOTE] = ACTIONS(3204),
    [anon_sym_u8_SQUOTE] = ACTIONS(3204),
    [anon_sym_SQUOTE] = ACTIONS(3204),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_true] = ACTIONS(3206),
    [sym_false] = ACTIONS(3206),
    [anon_sym_NULL] = ACTIONS(3206),
    [anon_sym_nullptr] = ACTIONS(3206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3206),
    [anon_sym_let] = ACTIONS(3206),
    [anon_sym_This] = ACTIONS(3206),
    [anon_sym_decltype] = ACTIONS(3206),
    [anon_sym_final] = ACTIONS(3206),
    [anon_sym_override] = ACTIONS(3206),
    [sym_virtual] = ACTIONS(3206),
    [anon_sym_explicit] = ACTIONS(3206),
    [anon_sym_typename] = ACTIONS(3206),
    [anon_sym_template] = ACTIONS(3206),
    [anon_sym_GT2] = ACTIONS(3204),
    [anon_sym_operator] = ACTIONS(3206),
    [anon_sym_try] = ACTIONS(3206),
    [anon_sym_delete] = ACTIONS(3206),
    [anon_sym_throw] = ACTIONS(3206),
    [anon_sym_namespace] = ACTIONS(3206),
    [anon_sym_using] = ACTIONS(3206),
    [anon_sym_static_assert] = ACTIONS(3206),
    [anon_sym_concept] = ACTIONS(3206),
    [anon_sym_co_return] = ACTIONS(3206),
    [anon_sym_co_yield] = ACTIONS(3206),
    [anon_sym_R_DQUOTE] = ACTIONS(3204),
    [anon_sym_LR_DQUOTE] = ACTIONS(3204),
    [anon_sym_uR_DQUOTE] = ACTIONS(3204),
    [anon_sym_UR_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3204),
    [anon_sym_co_await] = ACTIONS(3206),
    [anon_sym_new] = ACTIONS(3206),
    [anon_sym_requires] = ACTIONS(3206),
    [sym_this] = ACTIONS(3206),
    [anon_sym_precise] = ACTIONS(3206),
    [anon_sym_shared] = ACTIONS(3206),
    [anon_sym_groupshared] = ACTIONS(3206),
    [anon_sym_uniform] = ACTIONS(3206),
    [anon_sym_row_major] = ACTIONS(3206),
    [anon_sym_column_major] = ACTIONS(3206),
    [anon_sym_globallycoherent] = ACTIONS(3206),
    [anon_sym_centroid] = ACTIONS(3206),
    [anon_sym_noperspective] = ACTIONS(3206),
    [anon_sym_nointerpolation] = ACTIONS(3206),
    [anon_sym_sample] = ACTIONS(3206),
    [anon_sym_linear] = ACTIONS(3206),
    [anon_sym_snorm] = ACTIONS(3206),
    [anon_sym_unorm] = ACTIONS(3206),
    [anon_sym_point] = ACTIONS(3206),
    [anon_sym_line] = ACTIONS(3206),
    [anon_sym_triangleadj] = ACTIONS(3206),
    [anon_sym_lineadj] = ACTIONS(3206),
    [anon_sym_triangle] = ACTIONS(3206),
    [anon_sym_interface] = ACTIONS(3206),
    [anon_sym_extension] = ACTIONS(3206),
    [anon_sym_where] = ACTIONS(3206),
    [anon_sym___exported] = ACTIONS(3206),
    [anon_sym_import] = ACTIONS(3206),
  },
  [390] = {
    [sym_preproc_def] = STATE(371),
    [sym_preproc_function_def] = STATE(371),
    [sym_preproc_call] = STATE(371),
    [sym_preproc_if_in_field_declaration_list] = STATE(371),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(371),
    [sym_type_definition] = STATE(371),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(371),
    [sym_field_declaration] = STATE(371),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(371),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(371),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(371),
    [sym_operator_cast_declaration] = STATE(371),
    [sym_constructor_or_destructor_definition] = STATE(371),
    [sym_constructor_or_destructor_declaration] = STATE(371),
    [sym_friend_declaration] = STATE(371),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(371),
    [sym_alias_declaration] = STATE(371),
    [sym_static_assert_declaration] = STATE(371),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(371),
    [sym_subscript_declaration] = STATE(371),
    [sym_property_declaration] = STATE(371),
    [sym_associatedtype_declaration] = STATE(371),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(371),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3208),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [391] = {
    [sym_identifier] = ACTIONS(3210),
    [aux_sym_preproc_include_token1] = ACTIONS(3210),
    [aux_sym_preproc_def_token1] = ACTIONS(3210),
    [aux_sym_preproc_if_token1] = ACTIONS(3210),
    [aux_sym_preproc_if_token2] = ACTIONS(3210),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3210),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3210),
    [aux_sym_preproc_else_token1] = ACTIONS(3210),
    [aux_sym_preproc_elif_token1] = ACTIONS(3210),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3210),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3210),
    [sym_preproc_directive] = ACTIONS(3210),
    [anon_sym_LPAREN2] = ACTIONS(3212),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3210),
    [anon_sym_PLUS] = ACTIONS(3210),
    [anon_sym_STAR] = ACTIONS(3212),
    [anon_sym_AMP_AMP] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3210),
    [anon_sym_SEMI] = ACTIONS(3212),
    [anon_sym___extension__] = ACTIONS(3210),
    [anon_sym_typedef] = ACTIONS(3210),
    [anon_sym_in] = ACTIONS(3210),
    [anon_sym_out] = ACTIONS(3210),
    [anon_sym_inout] = ACTIONS(3210),
    [anon_sym_extern] = ACTIONS(3210),
    [anon_sym___attribute__] = ACTIONS(3210),
    [anon_sym_COLON_COLON] = ACTIONS(3212),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3212),
    [anon_sym___declspec] = ACTIONS(3210),
    [anon_sym___based] = ACTIONS(3210),
    [anon_sym___cdecl] = ACTIONS(3210),
    [anon_sym___clrcall] = ACTIONS(3210),
    [anon_sym___stdcall] = ACTIONS(3210),
    [anon_sym___fastcall] = ACTIONS(3210),
    [anon_sym___thiscall] = ACTIONS(3210),
    [anon_sym___vectorcall] = ACTIONS(3210),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_signed] = ACTIONS(3210),
    [anon_sym_unsigned] = ACTIONS(3210),
    [anon_sym_long] = ACTIONS(3210),
    [anon_sym_short] = ACTIONS(3210),
    [anon_sym_LBRACK] = ACTIONS(3210),
    [anon_sym_static] = ACTIONS(3210),
    [anon_sym_register] = ACTIONS(3210),
    [anon_sym_inline] = ACTIONS(3210),
    [anon_sym___inline] = ACTIONS(3210),
    [anon_sym___inline__] = ACTIONS(3210),
    [anon_sym___forceinline] = ACTIONS(3210),
    [anon_sym_thread_local] = ACTIONS(3210),
    [anon_sym___thread] = ACTIONS(3210),
    [anon_sym_const] = ACTIONS(3210),
    [anon_sym_constexpr] = ACTIONS(3210),
    [anon_sym_volatile] = ACTIONS(3210),
    [anon_sym_restrict] = ACTIONS(3210),
    [anon_sym___restrict__] = ACTIONS(3210),
    [anon_sym__Atomic] = ACTIONS(3210),
    [anon_sym__Noreturn] = ACTIONS(3210),
    [anon_sym_noreturn] = ACTIONS(3210),
    [anon_sym_mutable] = ACTIONS(3210),
    [anon_sym_constinit] = ACTIONS(3210),
    [anon_sym_consteval] = ACTIONS(3210),
    [anon_sym_alignas] = ACTIONS(3210),
    [anon_sym__Alignas] = ACTIONS(3210),
    [sym_primitive_type] = ACTIONS(3210),
    [anon_sym_enum] = ACTIONS(3210),
    [anon_sym_class] = ACTIONS(3210),
    [anon_sym_struct] = ACTIONS(3210),
    [anon_sym_union] = ACTIONS(3210),
    [anon_sym_if] = ACTIONS(3210),
    [anon_sym_else] = ACTIONS(3210),
    [anon_sym_switch] = ACTIONS(3210),
    [anon_sym_case] = ACTIONS(3210),
    [anon_sym_default] = ACTIONS(3210),
    [anon_sym_while] = ACTIONS(3210),
    [anon_sym_do] = ACTIONS(3210),
    [anon_sym_for] = ACTIONS(3210),
    [anon_sym_return] = ACTIONS(3210),
    [anon_sym_break] = ACTIONS(3210),
    [anon_sym_continue] = ACTIONS(3210),
    [anon_sym_goto] = ACTIONS(3210),
    [anon_sym___try] = ACTIONS(3210),
    [anon_sym___leave] = ACTIONS(3210),
    [anon_sym_not] = ACTIONS(3210),
    [anon_sym_compl] = ACTIONS(3210),
    [anon_sym_DASH_DASH] = ACTIONS(3212),
    [anon_sym_PLUS_PLUS] = ACTIONS(3212),
    [anon_sym_sizeof] = ACTIONS(3210),
    [anon_sym___alignof__] = ACTIONS(3210),
    [anon_sym___alignof] = ACTIONS(3210),
    [anon_sym__alignof] = ACTIONS(3210),
    [anon_sym_alignof] = ACTIONS(3210),
    [anon_sym__Alignof] = ACTIONS(3210),
    [anon_sym_offsetof] = ACTIONS(3210),
    [anon_sym__Generic] = ACTIONS(3210),
    [anon_sym_asm] = ACTIONS(3210),
    [anon_sym___asm__] = ACTIONS(3210),
    [sym_number_literal] = ACTIONS(3212),
    [anon_sym_L_SQUOTE] = ACTIONS(3212),
    [anon_sym_u_SQUOTE] = ACTIONS(3212),
    [anon_sym_U_SQUOTE] = ACTIONS(3212),
    [anon_sym_u8_SQUOTE] = ACTIONS(3212),
    [anon_sym_SQUOTE] = ACTIONS(3212),
    [anon_sym_L_DQUOTE] = ACTIONS(3212),
    [anon_sym_u_DQUOTE] = ACTIONS(3212),
    [anon_sym_U_DQUOTE] = ACTIONS(3212),
    [anon_sym_u8_DQUOTE] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [sym_true] = ACTIONS(3210),
    [sym_false] = ACTIONS(3210),
    [anon_sym_NULL] = ACTIONS(3210),
    [anon_sym_nullptr] = ACTIONS(3210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3210),
    [anon_sym_let] = ACTIONS(3210),
    [anon_sym_This] = ACTIONS(3210),
    [anon_sym_decltype] = ACTIONS(3210),
    [sym_virtual] = ACTIONS(3210),
    [anon_sym_explicit] = ACTIONS(3210),
    [anon_sym_typename] = ACTIONS(3210),
    [anon_sym_template] = ACTIONS(3210),
    [anon_sym_operator] = ACTIONS(3210),
    [anon_sym_try] = ACTIONS(3210),
    [anon_sym_delete] = ACTIONS(3210),
    [anon_sym_throw] = ACTIONS(3210),
    [anon_sym_namespace] = ACTIONS(3210),
    [anon_sym_using] = ACTIONS(3210),
    [anon_sym_static_assert] = ACTIONS(3210),
    [anon_sym_concept] = ACTIONS(3210),
    [anon_sym_co_return] = ACTIONS(3210),
    [anon_sym_co_yield] = ACTIONS(3210),
    [anon_sym_R_DQUOTE] = ACTIONS(3212),
    [anon_sym_LR_DQUOTE] = ACTIONS(3212),
    [anon_sym_uR_DQUOTE] = ACTIONS(3212),
    [anon_sym_UR_DQUOTE] = ACTIONS(3212),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3212),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3210),
    [anon_sym_requires] = ACTIONS(3210),
    [sym_this] = ACTIONS(3210),
    [anon_sym_discard] = ACTIONS(3210),
    [anon_sym_precise] = ACTIONS(3210),
    [anon_sym_shared] = ACTIONS(3210),
    [anon_sym_groupshared] = ACTIONS(3210),
    [anon_sym_uniform] = ACTIONS(3210),
    [anon_sym_row_major] = ACTIONS(3210),
    [anon_sym_column_major] = ACTIONS(3210),
    [anon_sym_globallycoherent] = ACTIONS(3210),
    [anon_sym_centroid] = ACTIONS(3210),
    [anon_sym_noperspective] = ACTIONS(3210),
    [anon_sym_nointerpolation] = ACTIONS(3210),
    [anon_sym_sample] = ACTIONS(3210),
    [anon_sym_linear] = ACTIONS(3210),
    [anon_sym_snorm] = ACTIONS(3210),
    [anon_sym_unorm] = ACTIONS(3210),
    [anon_sym_point] = ACTIONS(3210),
    [anon_sym_line] = ACTIONS(3210),
    [anon_sym_triangleadj] = ACTIONS(3210),
    [anon_sym_lineadj] = ACTIONS(3210),
    [anon_sym_triangle] = ACTIONS(3210),
    [anon_sym_cbuffer] = ACTIONS(3210),
    [anon_sym_interface] = ACTIONS(3210),
    [anon_sym_extension] = ACTIONS(3210),
  },
  [392] = {
    [sym_identifier] = ACTIONS(3214),
    [aux_sym_preproc_include_token1] = ACTIONS(3214),
    [aux_sym_preproc_def_token1] = ACTIONS(3214),
    [aux_sym_preproc_if_token1] = ACTIONS(3214),
    [aux_sym_preproc_if_token2] = ACTIONS(3214),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3214),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3214),
    [aux_sym_preproc_else_token1] = ACTIONS(3214),
    [aux_sym_preproc_elif_token1] = ACTIONS(3214),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3214),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3214),
    [sym_preproc_directive] = ACTIONS(3214),
    [anon_sym_LPAREN2] = ACTIONS(3216),
    [anon_sym_BANG] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_DASH] = ACTIONS(3214),
    [anon_sym_PLUS] = ACTIONS(3214),
    [anon_sym_STAR] = ACTIONS(3216),
    [anon_sym_AMP_AMP] = ACTIONS(3216),
    [anon_sym_AMP] = ACTIONS(3214),
    [anon_sym_SEMI] = ACTIONS(3216),
    [anon_sym___extension__] = ACTIONS(3214),
    [anon_sym_typedef] = ACTIONS(3214),
    [anon_sym_in] = ACTIONS(3214),
    [anon_sym_out] = ACTIONS(3214),
    [anon_sym_inout] = ACTIONS(3214),
    [anon_sym_extern] = ACTIONS(3214),
    [anon_sym___attribute__] = ACTIONS(3214),
    [anon_sym_COLON_COLON] = ACTIONS(3216),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3216),
    [anon_sym___declspec] = ACTIONS(3214),
    [anon_sym___based] = ACTIONS(3214),
    [anon_sym___cdecl] = ACTIONS(3214),
    [anon_sym___clrcall] = ACTIONS(3214),
    [anon_sym___stdcall] = ACTIONS(3214),
    [anon_sym___fastcall] = ACTIONS(3214),
    [anon_sym___thiscall] = ACTIONS(3214),
    [anon_sym___vectorcall] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3216),
    [anon_sym_signed] = ACTIONS(3214),
    [anon_sym_unsigned] = ACTIONS(3214),
    [anon_sym_long] = ACTIONS(3214),
    [anon_sym_short] = ACTIONS(3214),
    [anon_sym_LBRACK] = ACTIONS(3214),
    [anon_sym_static] = ACTIONS(3214),
    [anon_sym_register] = ACTIONS(3214),
    [anon_sym_inline] = ACTIONS(3214),
    [anon_sym___inline] = ACTIONS(3214),
    [anon_sym___inline__] = ACTIONS(3214),
    [anon_sym___forceinline] = ACTIONS(3214),
    [anon_sym_thread_local] = ACTIONS(3214),
    [anon_sym___thread] = ACTIONS(3214),
    [anon_sym_const] = ACTIONS(3214),
    [anon_sym_constexpr] = ACTIONS(3214),
    [anon_sym_volatile] = ACTIONS(3214),
    [anon_sym_restrict] = ACTIONS(3214),
    [anon_sym___restrict__] = ACTIONS(3214),
    [anon_sym__Atomic] = ACTIONS(3214),
    [anon_sym__Noreturn] = ACTIONS(3214),
    [anon_sym_noreturn] = ACTIONS(3214),
    [anon_sym_mutable] = ACTIONS(3214),
    [anon_sym_constinit] = ACTIONS(3214),
    [anon_sym_consteval] = ACTIONS(3214),
    [anon_sym_alignas] = ACTIONS(3214),
    [anon_sym__Alignas] = ACTIONS(3214),
    [sym_primitive_type] = ACTIONS(3214),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3214),
    [anon_sym_struct] = ACTIONS(3214),
    [anon_sym_union] = ACTIONS(3214),
    [anon_sym_if] = ACTIONS(3214),
    [anon_sym_else] = ACTIONS(3214),
    [anon_sym_switch] = ACTIONS(3214),
    [anon_sym_case] = ACTIONS(3214),
    [anon_sym_default] = ACTIONS(3214),
    [anon_sym_while] = ACTIONS(3214),
    [anon_sym_do] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3214),
    [anon_sym_return] = ACTIONS(3214),
    [anon_sym_break] = ACTIONS(3214),
    [anon_sym_continue] = ACTIONS(3214),
    [anon_sym_goto] = ACTIONS(3214),
    [anon_sym___try] = ACTIONS(3214),
    [anon_sym___leave] = ACTIONS(3214),
    [anon_sym_not] = ACTIONS(3214),
    [anon_sym_compl] = ACTIONS(3214),
    [anon_sym_DASH_DASH] = ACTIONS(3216),
    [anon_sym_PLUS_PLUS] = ACTIONS(3216),
    [anon_sym_sizeof] = ACTIONS(3214),
    [anon_sym___alignof__] = ACTIONS(3214),
    [anon_sym___alignof] = ACTIONS(3214),
    [anon_sym__alignof] = ACTIONS(3214),
    [anon_sym_alignof] = ACTIONS(3214),
    [anon_sym__Alignof] = ACTIONS(3214),
    [anon_sym_offsetof] = ACTIONS(3214),
    [anon_sym__Generic] = ACTIONS(3214),
    [anon_sym_asm] = ACTIONS(3214),
    [anon_sym___asm__] = ACTIONS(3214),
    [sym_number_literal] = ACTIONS(3216),
    [anon_sym_L_SQUOTE] = ACTIONS(3216),
    [anon_sym_u_SQUOTE] = ACTIONS(3216),
    [anon_sym_U_SQUOTE] = ACTIONS(3216),
    [anon_sym_u8_SQUOTE] = ACTIONS(3216),
    [anon_sym_SQUOTE] = ACTIONS(3216),
    [anon_sym_L_DQUOTE] = ACTIONS(3216),
    [anon_sym_u_DQUOTE] = ACTIONS(3216),
    [anon_sym_U_DQUOTE] = ACTIONS(3216),
    [anon_sym_u8_DQUOTE] = ACTIONS(3216),
    [anon_sym_DQUOTE] = ACTIONS(3216),
    [sym_true] = ACTIONS(3214),
    [sym_false] = ACTIONS(3214),
    [anon_sym_NULL] = ACTIONS(3214),
    [anon_sym_nullptr] = ACTIONS(3214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3214),
    [anon_sym_let] = ACTIONS(3214),
    [anon_sym_This] = ACTIONS(3214),
    [anon_sym_decltype] = ACTIONS(3214),
    [sym_virtual] = ACTIONS(3214),
    [anon_sym_explicit] = ACTIONS(3214),
    [anon_sym_typename] = ACTIONS(3214),
    [anon_sym_template] = ACTIONS(3214),
    [anon_sym_operator] = ACTIONS(3214),
    [anon_sym_try] = ACTIONS(3214),
    [anon_sym_delete] = ACTIONS(3214),
    [anon_sym_throw] = ACTIONS(3214),
    [anon_sym_namespace] = ACTIONS(3214),
    [anon_sym_using] = ACTIONS(3214),
    [anon_sym_static_assert] = ACTIONS(3214),
    [anon_sym_concept] = ACTIONS(3214),
    [anon_sym_co_return] = ACTIONS(3214),
    [anon_sym_co_yield] = ACTIONS(3214),
    [anon_sym_R_DQUOTE] = ACTIONS(3216),
    [anon_sym_LR_DQUOTE] = ACTIONS(3216),
    [anon_sym_uR_DQUOTE] = ACTIONS(3216),
    [anon_sym_UR_DQUOTE] = ACTIONS(3216),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3216),
    [anon_sym_co_await] = ACTIONS(3214),
    [anon_sym_new] = ACTIONS(3214),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(3214),
    [anon_sym_discard] = ACTIONS(3214),
    [anon_sym_precise] = ACTIONS(3214),
    [anon_sym_shared] = ACTIONS(3214),
    [anon_sym_groupshared] = ACTIONS(3214),
    [anon_sym_uniform] = ACTIONS(3214),
    [anon_sym_row_major] = ACTIONS(3214),
    [anon_sym_column_major] = ACTIONS(3214),
    [anon_sym_globallycoherent] = ACTIONS(3214),
    [anon_sym_centroid] = ACTIONS(3214),
    [anon_sym_noperspective] = ACTIONS(3214),
    [anon_sym_nointerpolation] = ACTIONS(3214),
    [anon_sym_sample] = ACTIONS(3214),
    [anon_sym_linear] = ACTIONS(3214),
    [anon_sym_snorm] = ACTIONS(3214),
    [anon_sym_unorm] = ACTIONS(3214),
    [anon_sym_point] = ACTIONS(3214),
    [anon_sym_line] = ACTIONS(3214),
    [anon_sym_triangleadj] = ACTIONS(3214),
    [anon_sym_lineadj] = ACTIONS(3214),
    [anon_sym_triangle] = ACTIONS(3214),
    [anon_sym_cbuffer] = ACTIONS(3214),
    [anon_sym_interface] = ACTIONS(3214),
    [anon_sym_extension] = ACTIONS(3214),
  },
  [393] = {
    [sym_identifier] = ACTIONS(3218),
    [aux_sym_preproc_include_token1] = ACTIONS(3218),
    [aux_sym_preproc_def_token1] = ACTIONS(3218),
    [aux_sym_preproc_if_token1] = ACTIONS(3218),
    [aux_sym_preproc_if_token2] = ACTIONS(3218),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3218),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3218),
    [aux_sym_preproc_else_token1] = ACTIONS(3218),
    [aux_sym_preproc_elif_token1] = ACTIONS(3218),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3218),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3218),
    [sym_preproc_directive] = ACTIONS(3218),
    [anon_sym_LPAREN2] = ACTIONS(3220),
    [anon_sym_BANG] = ACTIONS(3220),
    [anon_sym_TILDE] = ACTIONS(3220),
    [anon_sym_DASH] = ACTIONS(3218),
    [anon_sym_PLUS] = ACTIONS(3218),
    [anon_sym_STAR] = ACTIONS(3220),
    [anon_sym_AMP_AMP] = ACTIONS(3220),
    [anon_sym_AMP] = ACTIONS(3218),
    [anon_sym_SEMI] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3218),
    [anon_sym_typedef] = ACTIONS(3218),
    [anon_sym_in] = ACTIONS(3218),
    [anon_sym_out] = ACTIONS(3218),
    [anon_sym_inout] = ACTIONS(3218),
    [anon_sym_extern] = ACTIONS(3218),
    [anon_sym___attribute__] = ACTIONS(3218),
    [anon_sym_COLON_COLON] = ACTIONS(3220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3220),
    [anon_sym___declspec] = ACTIONS(3218),
    [anon_sym___based] = ACTIONS(3218),
    [anon_sym___cdecl] = ACTIONS(3218),
    [anon_sym___clrcall] = ACTIONS(3218),
    [anon_sym___stdcall] = ACTIONS(3218),
    [anon_sym___fastcall] = ACTIONS(3218),
    [anon_sym___thiscall] = ACTIONS(3218),
    [anon_sym___vectorcall] = ACTIONS(3218),
    [anon_sym_LBRACE] = ACTIONS(3220),
    [anon_sym_signed] = ACTIONS(3218),
    [anon_sym_unsigned] = ACTIONS(3218),
    [anon_sym_long] = ACTIONS(3218),
    [anon_sym_short] = ACTIONS(3218),
    [anon_sym_LBRACK] = ACTIONS(3218),
    [anon_sym_static] = ACTIONS(3218),
    [anon_sym_register] = ACTIONS(3218),
    [anon_sym_inline] = ACTIONS(3218),
    [anon_sym___inline] = ACTIONS(3218),
    [anon_sym___inline__] = ACTIONS(3218),
    [anon_sym___forceinline] = ACTIONS(3218),
    [anon_sym_thread_local] = ACTIONS(3218),
    [anon_sym___thread] = ACTIONS(3218),
    [anon_sym_const] = ACTIONS(3218),
    [anon_sym_constexpr] = ACTIONS(3218),
    [anon_sym_volatile] = ACTIONS(3218),
    [anon_sym_restrict] = ACTIONS(3218),
    [anon_sym___restrict__] = ACTIONS(3218),
    [anon_sym__Atomic] = ACTIONS(3218),
    [anon_sym__Noreturn] = ACTIONS(3218),
    [anon_sym_noreturn] = ACTIONS(3218),
    [anon_sym_mutable] = ACTIONS(3218),
    [anon_sym_constinit] = ACTIONS(3218),
    [anon_sym_consteval] = ACTIONS(3218),
    [anon_sym_alignas] = ACTIONS(3218),
    [anon_sym__Alignas] = ACTIONS(3218),
    [sym_primitive_type] = ACTIONS(3218),
    [anon_sym_enum] = ACTIONS(3218),
    [anon_sym_class] = ACTIONS(3218),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3218),
    [anon_sym_if] = ACTIONS(3218),
    [anon_sym_else] = ACTIONS(3218),
    [anon_sym_switch] = ACTIONS(3218),
    [anon_sym_case] = ACTIONS(3218),
    [anon_sym_default] = ACTIONS(3218),
    [anon_sym_while] = ACTIONS(3218),
    [anon_sym_do] = ACTIONS(3218),
    [anon_sym_for] = ACTIONS(3218),
    [anon_sym_return] = ACTIONS(3218),
    [anon_sym_break] = ACTIONS(3218),
    [anon_sym_continue] = ACTIONS(3218),
    [anon_sym_goto] = ACTIONS(3218),
    [anon_sym___try] = ACTIONS(3218),
    [anon_sym___leave] = ACTIONS(3218),
    [anon_sym_not] = ACTIONS(3218),
    [anon_sym_compl] = ACTIONS(3218),
    [anon_sym_DASH_DASH] = ACTIONS(3220),
    [anon_sym_PLUS_PLUS] = ACTIONS(3220),
    [anon_sym_sizeof] = ACTIONS(3218),
    [anon_sym___alignof__] = ACTIONS(3218),
    [anon_sym___alignof] = ACTIONS(3218),
    [anon_sym__alignof] = ACTIONS(3218),
    [anon_sym_alignof] = ACTIONS(3218),
    [anon_sym__Alignof] = ACTIONS(3218),
    [anon_sym_offsetof] = ACTIONS(3218),
    [anon_sym__Generic] = ACTIONS(3218),
    [anon_sym_asm] = ACTIONS(3218),
    [anon_sym___asm__] = ACTIONS(3218),
    [sym_number_literal] = ACTIONS(3220),
    [anon_sym_L_SQUOTE] = ACTIONS(3220),
    [anon_sym_u_SQUOTE] = ACTIONS(3220),
    [anon_sym_U_SQUOTE] = ACTIONS(3220),
    [anon_sym_u8_SQUOTE] = ACTIONS(3220),
    [anon_sym_SQUOTE] = ACTIONS(3220),
    [anon_sym_L_DQUOTE] = ACTIONS(3220),
    [anon_sym_u_DQUOTE] = ACTIONS(3220),
    [anon_sym_U_DQUOTE] = ACTIONS(3220),
    [anon_sym_u8_DQUOTE] = ACTIONS(3220),
    [anon_sym_DQUOTE] = ACTIONS(3220),
    [sym_true] = ACTIONS(3218),
    [sym_false] = ACTIONS(3218),
    [anon_sym_NULL] = ACTIONS(3218),
    [anon_sym_nullptr] = ACTIONS(3218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3218),
    [anon_sym_let] = ACTIONS(3218),
    [anon_sym_This] = ACTIONS(3218),
    [anon_sym_decltype] = ACTIONS(3218),
    [sym_virtual] = ACTIONS(3218),
    [anon_sym_explicit] = ACTIONS(3218),
    [anon_sym_typename] = ACTIONS(3218),
    [anon_sym_template] = ACTIONS(3218),
    [anon_sym_operator] = ACTIONS(3218),
    [anon_sym_try] = ACTIONS(3218),
    [anon_sym_delete] = ACTIONS(3218),
    [anon_sym_throw] = ACTIONS(3218),
    [anon_sym_namespace] = ACTIONS(3218),
    [anon_sym_using] = ACTIONS(3218),
    [anon_sym_static_assert] = ACTIONS(3218),
    [anon_sym_concept] = ACTIONS(3218),
    [anon_sym_co_return] = ACTIONS(3218),
    [anon_sym_co_yield] = ACTIONS(3218),
    [anon_sym_R_DQUOTE] = ACTIONS(3220),
    [anon_sym_LR_DQUOTE] = ACTIONS(3220),
    [anon_sym_uR_DQUOTE] = ACTIONS(3220),
    [anon_sym_UR_DQUOTE] = ACTIONS(3220),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3220),
    [anon_sym_co_await] = ACTIONS(3218),
    [anon_sym_new] = ACTIONS(3218),
    [anon_sym_requires] = ACTIONS(3218),
    [sym_this] = ACTIONS(3218),
    [anon_sym_discard] = ACTIONS(3218),
    [anon_sym_precise] = ACTIONS(3218),
    [anon_sym_shared] = ACTIONS(3218),
    [anon_sym_groupshared] = ACTIONS(3218),
    [anon_sym_uniform] = ACTIONS(3218),
    [anon_sym_row_major] = ACTIONS(3218),
    [anon_sym_column_major] = ACTIONS(3218),
    [anon_sym_globallycoherent] = ACTIONS(3218),
    [anon_sym_centroid] = ACTIONS(3218),
    [anon_sym_noperspective] = ACTIONS(3218),
    [anon_sym_nointerpolation] = ACTIONS(3218),
    [anon_sym_sample] = ACTIONS(3218),
    [anon_sym_linear] = ACTIONS(3218),
    [anon_sym_snorm] = ACTIONS(3218),
    [anon_sym_unorm] = ACTIONS(3218),
    [anon_sym_point] = ACTIONS(3218),
    [anon_sym_line] = ACTIONS(3218),
    [anon_sym_triangleadj] = ACTIONS(3218),
    [anon_sym_lineadj] = ACTIONS(3218),
    [anon_sym_triangle] = ACTIONS(3218),
    [anon_sym_cbuffer] = ACTIONS(3218),
    [anon_sym_interface] = ACTIONS(3218),
    [anon_sym_extension] = ACTIONS(3218),
  },
  [394] = {
    [sym_identifier] = ACTIONS(3222),
    [aux_sym_preproc_include_token1] = ACTIONS(3222),
    [aux_sym_preproc_def_token1] = ACTIONS(3222),
    [aux_sym_preproc_if_token1] = ACTIONS(3222),
    [aux_sym_preproc_if_token2] = ACTIONS(3222),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3222),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3222),
    [aux_sym_preproc_else_token1] = ACTIONS(3222),
    [aux_sym_preproc_elif_token1] = ACTIONS(3222),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3222),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3222),
    [sym_preproc_directive] = ACTIONS(3222),
    [anon_sym_LPAREN2] = ACTIONS(3224),
    [anon_sym_BANG] = ACTIONS(3224),
    [anon_sym_TILDE] = ACTIONS(3224),
    [anon_sym_DASH] = ACTIONS(3222),
    [anon_sym_PLUS] = ACTIONS(3222),
    [anon_sym_STAR] = ACTIONS(3224),
    [anon_sym_AMP_AMP] = ACTIONS(3224),
    [anon_sym_AMP] = ACTIONS(3222),
    [anon_sym_SEMI] = ACTIONS(3224),
    [anon_sym___extension__] = ACTIONS(3222),
    [anon_sym_typedef] = ACTIONS(3222),
    [anon_sym_in] = ACTIONS(3222),
    [anon_sym_out] = ACTIONS(3222),
    [anon_sym_inout] = ACTIONS(3222),
    [anon_sym_extern] = ACTIONS(3222),
    [anon_sym___attribute__] = ACTIONS(3222),
    [anon_sym_COLON_COLON] = ACTIONS(3224),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3224),
    [anon_sym___declspec] = ACTIONS(3222),
    [anon_sym___based] = ACTIONS(3222),
    [anon_sym___cdecl] = ACTIONS(3222),
    [anon_sym___clrcall] = ACTIONS(3222),
    [anon_sym___stdcall] = ACTIONS(3222),
    [anon_sym___fastcall] = ACTIONS(3222),
    [anon_sym___thiscall] = ACTIONS(3222),
    [anon_sym___vectorcall] = ACTIONS(3222),
    [anon_sym_LBRACE] = ACTIONS(3224),
    [anon_sym_signed] = ACTIONS(3222),
    [anon_sym_unsigned] = ACTIONS(3222),
    [anon_sym_long] = ACTIONS(3222),
    [anon_sym_short] = ACTIONS(3222),
    [anon_sym_LBRACK] = ACTIONS(3222),
    [anon_sym_static] = ACTIONS(3222),
    [anon_sym_register] = ACTIONS(3222),
    [anon_sym_inline] = ACTIONS(3222),
    [anon_sym___inline] = ACTIONS(3222),
    [anon_sym___inline__] = ACTIONS(3222),
    [anon_sym___forceinline] = ACTIONS(3222),
    [anon_sym_thread_local] = ACTIONS(3222),
    [anon_sym___thread] = ACTIONS(3222),
    [anon_sym_const] = ACTIONS(3222),
    [anon_sym_constexpr] = ACTIONS(3222),
    [anon_sym_volatile] = ACTIONS(3222),
    [anon_sym_restrict] = ACTIONS(3222),
    [anon_sym___restrict__] = ACTIONS(3222),
    [anon_sym__Atomic] = ACTIONS(3222),
    [anon_sym__Noreturn] = ACTIONS(3222),
    [anon_sym_noreturn] = ACTIONS(3222),
    [anon_sym_mutable] = ACTIONS(3222),
    [anon_sym_constinit] = ACTIONS(3222),
    [anon_sym_consteval] = ACTIONS(3222),
    [anon_sym_alignas] = ACTIONS(3222),
    [anon_sym__Alignas] = ACTIONS(3222),
    [sym_primitive_type] = ACTIONS(3222),
    [anon_sym_enum] = ACTIONS(3222),
    [anon_sym_class] = ACTIONS(3222),
    [anon_sym_struct] = ACTIONS(3222),
    [anon_sym_union] = ACTIONS(3222),
    [anon_sym_if] = ACTIONS(3222),
    [anon_sym_else] = ACTIONS(3222),
    [anon_sym_switch] = ACTIONS(3222),
    [anon_sym_case] = ACTIONS(3222),
    [anon_sym_default] = ACTIONS(3222),
    [anon_sym_while] = ACTIONS(3222),
    [anon_sym_do] = ACTIONS(3222),
    [anon_sym_for] = ACTIONS(3222),
    [anon_sym_return] = ACTIONS(3222),
    [anon_sym_break] = ACTIONS(3222),
    [anon_sym_continue] = ACTIONS(3222),
    [anon_sym_goto] = ACTIONS(3222),
    [anon_sym___try] = ACTIONS(3222),
    [anon_sym___leave] = ACTIONS(3222),
    [anon_sym_not] = ACTIONS(3222),
    [anon_sym_compl] = ACTIONS(3222),
    [anon_sym_DASH_DASH] = ACTIONS(3224),
    [anon_sym_PLUS_PLUS] = ACTIONS(3224),
    [anon_sym_sizeof] = ACTIONS(3222),
    [anon_sym___alignof__] = ACTIONS(3222),
    [anon_sym___alignof] = ACTIONS(3222),
    [anon_sym__alignof] = ACTIONS(3222),
    [anon_sym_alignof] = ACTIONS(3222),
    [anon_sym__Alignof] = ACTIONS(3222),
    [anon_sym_offsetof] = ACTIONS(3222),
    [anon_sym__Generic] = ACTIONS(3222),
    [anon_sym_asm] = ACTIONS(3222),
    [anon_sym___asm__] = ACTIONS(3222),
    [sym_number_literal] = ACTIONS(3224),
    [anon_sym_L_SQUOTE] = ACTIONS(3224),
    [anon_sym_u_SQUOTE] = ACTIONS(3224),
    [anon_sym_U_SQUOTE] = ACTIONS(3224),
    [anon_sym_u8_SQUOTE] = ACTIONS(3224),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_L_DQUOTE] = ACTIONS(3224),
    [anon_sym_u_DQUOTE] = ACTIONS(3224),
    [anon_sym_U_DQUOTE] = ACTIONS(3224),
    [anon_sym_u8_DQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3224),
    [sym_true] = ACTIONS(3222),
    [sym_false] = ACTIONS(3222),
    [anon_sym_NULL] = ACTIONS(3222),
    [anon_sym_nullptr] = ACTIONS(3222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3222),
    [anon_sym_let] = ACTIONS(3222),
    [anon_sym_This] = ACTIONS(3222),
    [anon_sym_decltype] = ACTIONS(3222),
    [sym_virtual] = ACTIONS(3222),
    [anon_sym_explicit] = ACTIONS(3222),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3222),
    [anon_sym_operator] = ACTIONS(3222),
    [anon_sym_try] = ACTIONS(3222),
    [anon_sym_delete] = ACTIONS(3222),
    [anon_sym_throw] = ACTIONS(3222),
    [anon_sym_namespace] = ACTIONS(3222),
    [anon_sym_using] = ACTIONS(3222),
    [anon_sym_static_assert] = ACTIONS(3222),
    [anon_sym_concept] = ACTIONS(3222),
    [anon_sym_co_return] = ACTIONS(3222),
    [anon_sym_co_yield] = ACTIONS(3222),
    [anon_sym_R_DQUOTE] = ACTIONS(3224),
    [anon_sym_LR_DQUOTE] = ACTIONS(3224),
    [anon_sym_uR_DQUOTE] = ACTIONS(3224),
    [anon_sym_UR_DQUOTE] = ACTIONS(3224),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3224),
    [anon_sym_co_await] = ACTIONS(3222),
    [anon_sym_new] = ACTIONS(3222),
    [anon_sym_requires] = ACTIONS(3222),
    [sym_this] = ACTIONS(3222),
    [anon_sym_discard] = ACTIONS(3222),
    [anon_sym_precise] = ACTIONS(3222),
    [anon_sym_shared] = ACTIONS(3222),
    [anon_sym_groupshared] = ACTIONS(3222),
    [anon_sym_uniform] = ACTIONS(3222),
    [anon_sym_row_major] = ACTIONS(3222),
    [anon_sym_column_major] = ACTIONS(3222),
    [anon_sym_globallycoherent] = ACTIONS(3222),
    [anon_sym_centroid] = ACTIONS(3222),
    [anon_sym_noperspective] = ACTIONS(3222),
    [anon_sym_nointerpolation] = ACTIONS(3222),
    [anon_sym_sample] = ACTIONS(3222),
    [anon_sym_linear] = ACTIONS(3222),
    [anon_sym_snorm] = ACTIONS(3222),
    [anon_sym_unorm] = ACTIONS(3222),
    [anon_sym_point] = ACTIONS(3222),
    [anon_sym_line] = ACTIONS(3222),
    [anon_sym_triangleadj] = ACTIONS(3222),
    [anon_sym_lineadj] = ACTIONS(3222),
    [anon_sym_triangle] = ACTIONS(3222),
    [anon_sym_cbuffer] = ACTIONS(3222),
    [anon_sym_interface] = ACTIONS(3222),
    [anon_sym_extension] = ACTIONS(3222),
  },
  [395] = {
    [sym_identifier] = ACTIONS(3226),
    [aux_sym_preproc_include_token1] = ACTIONS(3226),
    [aux_sym_preproc_def_token1] = ACTIONS(3226),
    [aux_sym_preproc_if_token1] = ACTIONS(3226),
    [aux_sym_preproc_if_token2] = ACTIONS(3226),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3226),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3226),
    [aux_sym_preproc_else_token1] = ACTIONS(3226),
    [aux_sym_preproc_elif_token1] = ACTIONS(3226),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3226),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3226),
    [sym_preproc_directive] = ACTIONS(3226),
    [anon_sym_LPAREN2] = ACTIONS(3228),
    [anon_sym_BANG] = ACTIONS(3228),
    [anon_sym_TILDE] = ACTIONS(3228),
    [anon_sym_DASH] = ACTIONS(3226),
    [anon_sym_PLUS] = ACTIONS(3226),
    [anon_sym_STAR] = ACTIONS(3228),
    [anon_sym_AMP_AMP] = ACTIONS(3228),
    [anon_sym_AMP] = ACTIONS(3226),
    [anon_sym_SEMI] = ACTIONS(3228),
    [anon_sym___extension__] = ACTIONS(3226),
    [anon_sym_typedef] = ACTIONS(3226),
    [anon_sym_in] = ACTIONS(3226),
    [anon_sym_out] = ACTIONS(3226),
    [anon_sym_inout] = ACTIONS(3226),
    [anon_sym_extern] = ACTIONS(3226),
    [anon_sym___attribute__] = ACTIONS(3226),
    [anon_sym_COLON_COLON] = ACTIONS(3228),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3228),
    [anon_sym___declspec] = ACTIONS(3226),
    [anon_sym___based] = ACTIONS(3226),
    [anon_sym___cdecl] = ACTIONS(3226),
    [anon_sym___clrcall] = ACTIONS(3226),
    [anon_sym___stdcall] = ACTIONS(3226),
    [anon_sym___fastcall] = ACTIONS(3226),
    [anon_sym___thiscall] = ACTIONS(3226),
    [anon_sym___vectorcall] = ACTIONS(3226),
    [anon_sym_LBRACE] = ACTIONS(3228),
    [anon_sym_signed] = ACTIONS(3226),
    [anon_sym_unsigned] = ACTIONS(3226),
    [anon_sym_long] = ACTIONS(3226),
    [anon_sym_short] = ACTIONS(3226),
    [anon_sym_LBRACK] = ACTIONS(3226),
    [anon_sym_static] = ACTIONS(3226),
    [anon_sym_register] = ACTIONS(3226),
    [anon_sym_inline] = ACTIONS(3226),
    [anon_sym___inline] = ACTIONS(3226),
    [anon_sym___inline__] = ACTIONS(3226),
    [anon_sym___forceinline] = ACTIONS(3226),
    [anon_sym_thread_local] = ACTIONS(3226),
    [anon_sym___thread] = ACTIONS(3226),
    [anon_sym_const] = ACTIONS(3226),
    [anon_sym_constexpr] = ACTIONS(3226),
    [anon_sym_volatile] = ACTIONS(3226),
    [anon_sym_restrict] = ACTIONS(3226),
    [anon_sym___restrict__] = ACTIONS(3226),
    [anon_sym__Atomic] = ACTIONS(3226),
    [anon_sym__Noreturn] = ACTIONS(3226),
    [anon_sym_noreturn] = ACTIONS(3226),
    [anon_sym_mutable] = ACTIONS(3226),
    [anon_sym_constinit] = ACTIONS(3226),
    [anon_sym_consteval] = ACTIONS(3226),
    [anon_sym_alignas] = ACTIONS(3226),
    [anon_sym__Alignas] = ACTIONS(3226),
    [sym_primitive_type] = ACTIONS(3226),
    [anon_sym_enum] = ACTIONS(3226),
    [anon_sym_class] = ACTIONS(3226),
    [anon_sym_struct] = ACTIONS(3226),
    [anon_sym_union] = ACTIONS(3226),
    [anon_sym_if] = ACTIONS(3226),
    [anon_sym_else] = ACTIONS(3226),
    [anon_sym_switch] = ACTIONS(3226),
    [anon_sym_case] = ACTIONS(3226),
    [anon_sym_default] = ACTIONS(3226),
    [anon_sym_while] = ACTIONS(3226),
    [anon_sym_do] = ACTIONS(3226),
    [anon_sym_for] = ACTIONS(3226),
    [anon_sym_return] = ACTIONS(3226),
    [anon_sym_break] = ACTIONS(3226),
    [anon_sym_continue] = ACTIONS(3226),
    [anon_sym_goto] = ACTIONS(3226),
    [anon_sym___try] = ACTIONS(3226),
    [anon_sym___leave] = ACTIONS(3226),
    [anon_sym_not] = ACTIONS(3226),
    [anon_sym_compl] = ACTIONS(3226),
    [anon_sym_DASH_DASH] = ACTIONS(3228),
    [anon_sym_PLUS_PLUS] = ACTIONS(3228),
    [anon_sym_sizeof] = ACTIONS(3226),
    [anon_sym___alignof__] = ACTIONS(3226),
    [anon_sym___alignof] = ACTIONS(3226),
    [anon_sym__alignof] = ACTIONS(3226),
    [anon_sym_alignof] = ACTIONS(3226),
    [anon_sym__Alignof] = ACTIONS(3226),
    [anon_sym_offsetof] = ACTIONS(3226),
    [anon_sym__Generic] = ACTIONS(3226),
    [anon_sym_asm] = ACTIONS(3226),
    [anon_sym___asm__] = ACTIONS(3226),
    [sym_number_literal] = ACTIONS(3228),
    [anon_sym_L_SQUOTE] = ACTIONS(3228),
    [anon_sym_u_SQUOTE] = ACTIONS(3228),
    [anon_sym_U_SQUOTE] = ACTIONS(3228),
    [anon_sym_u8_SQUOTE] = ACTIONS(3228),
    [anon_sym_SQUOTE] = ACTIONS(3228),
    [anon_sym_L_DQUOTE] = ACTIONS(3228),
    [anon_sym_u_DQUOTE] = ACTIONS(3228),
    [anon_sym_U_DQUOTE] = ACTIONS(3228),
    [anon_sym_u8_DQUOTE] = ACTIONS(3228),
    [anon_sym_DQUOTE] = ACTIONS(3228),
    [sym_true] = ACTIONS(3226),
    [sym_false] = ACTIONS(3226),
    [anon_sym_NULL] = ACTIONS(3226),
    [anon_sym_nullptr] = ACTIONS(3226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3226),
    [anon_sym_let] = ACTIONS(3226),
    [anon_sym_This] = ACTIONS(3226),
    [anon_sym_decltype] = ACTIONS(3226),
    [sym_virtual] = ACTIONS(3226),
    [anon_sym_explicit] = ACTIONS(3226),
    [anon_sym_typename] = ACTIONS(3226),
    [anon_sym_template] = ACTIONS(3226),
    [anon_sym_operator] = ACTIONS(3226),
    [anon_sym_try] = ACTIONS(3226),
    [anon_sym_delete] = ACTIONS(3226),
    [anon_sym_throw] = ACTIONS(3226),
    [anon_sym_namespace] = ACTIONS(3226),
    [anon_sym_using] = ACTIONS(3226),
    [anon_sym_static_assert] = ACTIONS(3226),
    [anon_sym_concept] = ACTIONS(3226),
    [anon_sym_co_return] = ACTIONS(3226),
    [anon_sym_co_yield] = ACTIONS(3226),
    [anon_sym_R_DQUOTE] = ACTIONS(3228),
    [anon_sym_LR_DQUOTE] = ACTIONS(3228),
    [anon_sym_uR_DQUOTE] = ACTIONS(3228),
    [anon_sym_UR_DQUOTE] = ACTIONS(3228),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3228),
    [anon_sym_co_await] = ACTIONS(3226),
    [anon_sym_new] = ACTIONS(3226),
    [anon_sym_requires] = ACTIONS(3226),
    [sym_this] = ACTIONS(3226),
    [anon_sym_discard] = ACTIONS(3226),
    [anon_sym_precise] = ACTIONS(3226),
    [anon_sym_shared] = ACTIONS(3226),
    [anon_sym_groupshared] = ACTIONS(3226),
    [anon_sym_uniform] = ACTIONS(3226),
    [anon_sym_row_major] = ACTIONS(3226),
    [anon_sym_column_major] = ACTIONS(3226),
    [anon_sym_globallycoherent] = ACTIONS(3226),
    [anon_sym_centroid] = ACTIONS(3226),
    [anon_sym_noperspective] = ACTIONS(3226),
    [anon_sym_nointerpolation] = ACTIONS(3226),
    [anon_sym_sample] = ACTIONS(3226),
    [anon_sym_linear] = ACTIONS(3226),
    [anon_sym_snorm] = ACTIONS(3226),
    [anon_sym_unorm] = ACTIONS(3226),
    [anon_sym_point] = ACTIONS(3226),
    [anon_sym_line] = ACTIONS(3226),
    [anon_sym_triangleadj] = ACTIONS(3226),
    [anon_sym_lineadj] = ACTIONS(3226),
    [anon_sym_triangle] = ACTIONS(3226),
    [anon_sym_cbuffer] = ACTIONS(3226),
    [anon_sym_interface] = ACTIONS(3226),
    [anon_sym_extension] = ACTIONS(3226),
  },
  [396] = {
    [sym_identifier] = ACTIONS(3230),
    [aux_sym_preproc_include_token1] = ACTIONS(3230),
    [aux_sym_preproc_def_token1] = ACTIONS(3230),
    [aux_sym_preproc_if_token1] = ACTIONS(3230),
    [aux_sym_preproc_if_token2] = ACTIONS(3230),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3230),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3230),
    [aux_sym_preproc_else_token1] = ACTIONS(3230),
    [aux_sym_preproc_elif_token1] = ACTIONS(3230),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3230),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3230),
    [sym_preproc_directive] = ACTIONS(3230),
    [anon_sym_LPAREN2] = ACTIONS(3232),
    [anon_sym_BANG] = ACTIONS(3232),
    [anon_sym_TILDE] = ACTIONS(3232),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_STAR] = ACTIONS(3232),
    [anon_sym_AMP_AMP] = ACTIONS(3232),
    [anon_sym_AMP] = ACTIONS(3230),
    [anon_sym_SEMI] = ACTIONS(3232),
    [anon_sym___extension__] = ACTIONS(3230),
    [anon_sym_typedef] = ACTIONS(3230),
    [anon_sym_in] = ACTIONS(3230),
    [anon_sym_out] = ACTIONS(3230),
    [anon_sym_inout] = ACTIONS(3230),
    [anon_sym_extern] = ACTIONS(3230),
    [anon_sym___attribute__] = ACTIONS(3230),
    [anon_sym_COLON_COLON] = ACTIONS(3232),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3232),
    [anon_sym___declspec] = ACTIONS(3230),
    [anon_sym___based] = ACTIONS(3230),
    [anon_sym___cdecl] = ACTIONS(3230),
    [anon_sym___clrcall] = ACTIONS(3230),
    [anon_sym___stdcall] = ACTIONS(3230),
    [anon_sym___fastcall] = ACTIONS(3230),
    [anon_sym___thiscall] = ACTIONS(3230),
    [anon_sym___vectorcall] = ACTIONS(3230),
    [anon_sym_LBRACE] = ACTIONS(3232),
    [anon_sym_signed] = ACTIONS(3230),
    [anon_sym_unsigned] = ACTIONS(3230),
    [anon_sym_long] = ACTIONS(3230),
    [anon_sym_short] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_static] = ACTIONS(3230),
    [anon_sym_register] = ACTIONS(3230),
    [anon_sym_inline] = ACTIONS(3230),
    [anon_sym___inline] = ACTIONS(3230),
    [anon_sym___inline__] = ACTIONS(3230),
    [anon_sym___forceinline] = ACTIONS(3230),
    [anon_sym_thread_local] = ACTIONS(3230),
    [anon_sym___thread] = ACTIONS(3230),
    [anon_sym_const] = ACTIONS(3230),
    [anon_sym_constexpr] = ACTIONS(3230),
    [anon_sym_volatile] = ACTIONS(3230),
    [anon_sym_restrict] = ACTIONS(3230),
    [anon_sym___restrict__] = ACTIONS(3230),
    [anon_sym__Atomic] = ACTIONS(3230),
    [anon_sym__Noreturn] = ACTIONS(3230),
    [anon_sym_noreturn] = ACTIONS(3230),
    [anon_sym_mutable] = ACTIONS(3230),
    [anon_sym_constinit] = ACTIONS(3230),
    [anon_sym_consteval] = ACTIONS(3230),
    [anon_sym_alignas] = ACTIONS(3230),
    [anon_sym__Alignas] = ACTIONS(3230),
    [sym_primitive_type] = ACTIONS(3230),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3230),
    [anon_sym_struct] = ACTIONS(3230),
    [anon_sym_union] = ACTIONS(3230),
    [anon_sym_if] = ACTIONS(3230),
    [anon_sym_else] = ACTIONS(3230),
    [anon_sym_switch] = ACTIONS(3230),
    [anon_sym_case] = ACTIONS(3230),
    [anon_sym_default] = ACTIONS(3230),
    [anon_sym_while] = ACTIONS(3230),
    [anon_sym_do] = ACTIONS(3230),
    [anon_sym_for] = ACTIONS(3230),
    [anon_sym_return] = ACTIONS(3230),
    [anon_sym_break] = ACTIONS(3230),
    [anon_sym_continue] = ACTIONS(3230),
    [anon_sym_goto] = ACTIONS(3230),
    [anon_sym___try] = ACTIONS(3230),
    [anon_sym___leave] = ACTIONS(3230),
    [anon_sym_not] = ACTIONS(3230),
    [anon_sym_compl] = ACTIONS(3230),
    [anon_sym_DASH_DASH] = ACTIONS(3232),
    [anon_sym_PLUS_PLUS] = ACTIONS(3232),
    [anon_sym_sizeof] = ACTIONS(3230),
    [anon_sym___alignof__] = ACTIONS(3230),
    [anon_sym___alignof] = ACTIONS(3230),
    [anon_sym__alignof] = ACTIONS(3230),
    [anon_sym_alignof] = ACTIONS(3230),
    [anon_sym__Alignof] = ACTIONS(3230),
    [anon_sym_offsetof] = ACTIONS(3230),
    [anon_sym__Generic] = ACTIONS(3230),
    [anon_sym_asm] = ACTIONS(3230),
    [anon_sym___asm__] = ACTIONS(3230),
    [sym_number_literal] = ACTIONS(3232),
    [anon_sym_L_SQUOTE] = ACTIONS(3232),
    [anon_sym_u_SQUOTE] = ACTIONS(3232),
    [anon_sym_U_SQUOTE] = ACTIONS(3232),
    [anon_sym_u8_SQUOTE] = ACTIONS(3232),
    [anon_sym_SQUOTE] = ACTIONS(3232),
    [anon_sym_L_DQUOTE] = ACTIONS(3232),
    [anon_sym_u_DQUOTE] = ACTIONS(3232),
    [anon_sym_U_DQUOTE] = ACTIONS(3232),
    [anon_sym_u8_DQUOTE] = ACTIONS(3232),
    [anon_sym_DQUOTE] = ACTIONS(3232),
    [sym_true] = ACTIONS(3230),
    [sym_false] = ACTIONS(3230),
    [anon_sym_NULL] = ACTIONS(3230),
    [anon_sym_nullptr] = ACTIONS(3230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3230),
    [anon_sym_let] = ACTIONS(3230),
    [anon_sym_This] = ACTIONS(3230),
    [anon_sym_decltype] = ACTIONS(3230),
    [sym_virtual] = ACTIONS(3230),
    [anon_sym_explicit] = ACTIONS(3230),
    [anon_sym_typename] = ACTIONS(3230),
    [anon_sym_template] = ACTIONS(3230),
    [anon_sym_operator] = ACTIONS(3230),
    [anon_sym_try] = ACTIONS(3230),
    [anon_sym_delete] = ACTIONS(3230),
    [anon_sym_throw] = ACTIONS(3230),
    [anon_sym_namespace] = ACTIONS(3230),
    [anon_sym_using] = ACTIONS(3230),
    [anon_sym_static_assert] = ACTIONS(3230),
    [anon_sym_concept] = ACTIONS(3230),
    [anon_sym_co_return] = ACTIONS(3230),
    [anon_sym_co_yield] = ACTIONS(3230),
    [anon_sym_R_DQUOTE] = ACTIONS(3232),
    [anon_sym_LR_DQUOTE] = ACTIONS(3232),
    [anon_sym_uR_DQUOTE] = ACTIONS(3232),
    [anon_sym_UR_DQUOTE] = ACTIONS(3232),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3232),
    [anon_sym_co_await] = ACTIONS(3230),
    [anon_sym_new] = ACTIONS(3230),
    [anon_sym_requires] = ACTIONS(3230),
    [sym_this] = ACTIONS(3230),
    [anon_sym_discard] = ACTIONS(3230),
    [anon_sym_precise] = ACTIONS(3230),
    [anon_sym_shared] = ACTIONS(3230),
    [anon_sym_groupshared] = ACTIONS(3230),
    [anon_sym_uniform] = ACTIONS(3230),
    [anon_sym_row_major] = ACTIONS(3230),
    [anon_sym_column_major] = ACTIONS(3230),
    [anon_sym_globallycoherent] = ACTIONS(3230),
    [anon_sym_centroid] = ACTIONS(3230),
    [anon_sym_noperspective] = ACTIONS(3230),
    [anon_sym_nointerpolation] = ACTIONS(3230),
    [anon_sym_sample] = ACTIONS(3230),
    [anon_sym_linear] = ACTIONS(3230),
    [anon_sym_snorm] = ACTIONS(3230),
    [anon_sym_unorm] = ACTIONS(3230),
    [anon_sym_point] = ACTIONS(3230),
    [anon_sym_line] = ACTIONS(3230),
    [anon_sym_triangleadj] = ACTIONS(3230),
    [anon_sym_lineadj] = ACTIONS(3230),
    [anon_sym_triangle] = ACTIONS(3230),
    [anon_sym_cbuffer] = ACTIONS(3230),
    [anon_sym_interface] = ACTIONS(3230),
    [anon_sym_extension] = ACTIONS(3230),
  },
  [397] = {
    [sym_identifier] = ACTIONS(3234),
    [aux_sym_preproc_include_token1] = ACTIONS(3234),
    [aux_sym_preproc_def_token1] = ACTIONS(3234),
    [aux_sym_preproc_if_token1] = ACTIONS(3234),
    [aux_sym_preproc_if_token2] = ACTIONS(3234),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3234),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3234),
    [aux_sym_preproc_else_token1] = ACTIONS(3234),
    [aux_sym_preproc_elif_token1] = ACTIONS(3234),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3234),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3234),
    [sym_preproc_directive] = ACTIONS(3234),
    [anon_sym_LPAREN2] = ACTIONS(3236),
    [anon_sym_BANG] = ACTIONS(3236),
    [anon_sym_TILDE] = ACTIONS(3236),
    [anon_sym_DASH] = ACTIONS(3234),
    [anon_sym_PLUS] = ACTIONS(3234),
    [anon_sym_STAR] = ACTIONS(3236),
    [anon_sym_AMP_AMP] = ACTIONS(3236),
    [anon_sym_AMP] = ACTIONS(3234),
    [anon_sym_SEMI] = ACTIONS(3236),
    [anon_sym___extension__] = ACTIONS(3234),
    [anon_sym_typedef] = ACTIONS(3234),
    [anon_sym_in] = ACTIONS(3234),
    [anon_sym_out] = ACTIONS(3234),
    [anon_sym_inout] = ACTIONS(3234),
    [anon_sym_extern] = ACTIONS(3234),
    [anon_sym___attribute__] = ACTIONS(3234),
    [anon_sym_COLON_COLON] = ACTIONS(3236),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3236),
    [anon_sym___declspec] = ACTIONS(3234),
    [anon_sym___based] = ACTIONS(3234),
    [anon_sym___cdecl] = ACTIONS(3234),
    [anon_sym___clrcall] = ACTIONS(3234),
    [anon_sym___stdcall] = ACTIONS(3234),
    [anon_sym___fastcall] = ACTIONS(3234),
    [anon_sym___thiscall] = ACTIONS(3234),
    [anon_sym___vectorcall] = ACTIONS(3234),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_signed] = ACTIONS(3234),
    [anon_sym_unsigned] = ACTIONS(3234),
    [anon_sym_long] = ACTIONS(3234),
    [anon_sym_short] = ACTIONS(3234),
    [anon_sym_LBRACK] = ACTIONS(3234),
    [anon_sym_static] = ACTIONS(3234),
    [anon_sym_register] = ACTIONS(3234),
    [anon_sym_inline] = ACTIONS(3234),
    [anon_sym___inline] = ACTIONS(3234),
    [anon_sym___inline__] = ACTIONS(3234),
    [anon_sym___forceinline] = ACTIONS(3234),
    [anon_sym_thread_local] = ACTIONS(3234),
    [anon_sym___thread] = ACTIONS(3234),
    [anon_sym_const] = ACTIONS(3234),
    [anon_sym_constexpr] = ACTIONS(3234),
    [anon_sym_volatile] = ACTIONS(3234),
    [anon_sym_restrict] = ACTIONS(3234),
    [anon_sym___restrict__] = ACTIONS(3234),
    [anon_sym__Atomic] = ACTIONS(3234),
    [anon_sym__Noreturn] = ACTIONS(3234),
    [anon_sym_noreturn] = ACTIONS(3234),
    [anon_sym_mutable] = ACTIONS(3234),
    [anon_sym_constinit] = ACTIONS(3234),
    [anon_sym_consteval] = ACTIONS(3234),
    [anon_sym_alignas] = ACTIONS(3234),
    [anon_sym__Alignas] = ACTIONS(3234),
    [sym_primitive_type] = ACTIONS(3234),
    [anon_sym_enum] = ACTIONS(3234),
    [anon_sym_class] = ACTIONS(3234),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3234),
    [anon_sym_if] = ACTIONS(3234),
    [anon_sym_else] = ACTIONS(3234),
    [anon_sym_switch] = ACTIONS(3234),
    [anon_sym_case] = ACTIONS(3234),
    [anon_sym_default] = ACTIONS(3234),
    [anon_sym_while] = ACTIONS(3234),
    [anon_sym_do] = ACTIONS(3234),
    [anon_sym_for] = ACTIONS(3234),
    [anon_sym_return] = ACTIONS(3234),
    [anon_sym_break] = ACTIONS(3234),
    [anon_sym_continue] = ACTIONS(3234),
    [anon_sym_goto] = ACTIONS(3234),
    [anon_sym___try] = ACTIONS(3234),
    [anon_sym___leave] = ACTIONS(3234),
    [anon_sym_not] = ACTIONS(3234),
    [anon_sym_compl] = ACTIONS(3234),
    [anon_sym_DASH_DASH] = ACTIONS(3236),
    [anon_sym_PLUS_PLUS] = ACTIONS(3236),
    [anon_sym_sizeof] = ACTIONS(3234),
    [anon_sym___alignof__] = ACTIONS(3234),
    [anon_sym___alignof] = ACTIONS(3234),
    [anon_sym__alignof] = ACTIONS(3234),
    [anon_sym_alignof] = ACTIONS(3234),
    [anon_sym__Alignof] = ACTIONS(3234),
    [anon_sym_offsetof] = ACTIONS(3234),
    [anon_sym__Generic] = ACTIONS(3234),
    [anon_sym_asm] = ACTIONS(3234),
    [anon_sym___asm__] = ACTIONS(3234),
    [sym_number_literal] = ACTIONS(3236),
    [anon_sym_L_SQUOTE] = ACTIONS(3236),
    [anon_sym_u_SQUOTE] = ACTIONS(3236),
    [anon_sym_U_SQUOTE] = ACTIONS(3236),
    [anon_sym_u8_SQUOTE] = ACTIONS(3236),
    [anon_sym_SQUOTE] = ACTIONS(3236),
    [anon_sym_L_DQUOTE] = ACTIONS(3236),
    [anon_sym_u_DQUOTE] = ACTIONS(3236),
    [anon_sym_U_DQUOTE] = ACTIONS(3236),
    [anon_sym_u8_DQUOTE] = ACTIONS(3236),
    [anon_sym_DQUOTE] = ACTIONS(3236),
    [sym_true] = ACTIONS(3234),
    [sym_false] = ACTIONS(3234),
    [anon_sym_NULL] = ACTIONS(3234),
    [anon_sym_nullptr] = ACTIONS(3234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3234),
    [anon_sym_let] = ACTIONS(3234),
    [anon_sym_This] = ACTIONS(3234),
    [anon_sym_decltype] = ACTIONS(3234),
    [sym_virtual] = ACTIONS(3234),
    [anon_sym_explicit] = ACTIONS(3234),
    [anon_sym_typename] = ACTIONS(3234),
    [anon_sym_template] = ACTIONS(3234),
    [anon_sym_operator] = ACTIONS(3234),
    [anon_sym_try] = ACTIONS(3234),
    [anon_sym_delete] = ACTIONS(3234),
    [anon_sym_throw] = ACTIONS(3234),
    [anon_sym_namespace] = ACTIONS(3234),
    [anon_sym_using] = ACTIONS(3234),
    [anon_sym_static_assert] = ACTIONS(3234),
    [anon_sym_concept] = ACTIONS(3234),
    [anon_sym_co_return] = ACTIONS(3234),
    [anon_sym_co_yield] = ACTIONS(3234),
    [anon_sym_R_DQUOTE] = ACTIONS(3236),
    [anon_sym_LR_DQUOTE] = ACTIONS(3236),
    [anon_sym_uR_DQUOTE] = ACTIONS(3236),
    [anon_sym_UR_DQUOTE] = ACTIONS(3236),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3236),
    [anon_sym_co_await] = ACTIONS(3234),
    [anon_sym_new] = ACTIONS(3234),
    [anon_sym_requires] = ACTIONS(3234),
    [sym_this] = ACTIONS(3234),
    [anon_sym_discard] = ACTIONS(3234),
    [anon_sym_precise] = ACTIONS(3234),
    [anon_sym_shared] = ACTIONS(3234),
    [anon_sym_groupshared] = ACTIONS(3234),
    [anon_sym_uniform] = ACTIONS(3234),
    [anon_sym_row_major] = ACTIONS(3234),
    [anon_sym_column_major] = ACTIONS(3234),
    [anon_sym_globallycoherent] = ACTIONS(3234),
    [anon_sym_centroid] = ACTIONS(3234),
    [anon_sym_noperspective] = ACTIONS(3234),
    [anon_sym_nointerpolation] = ACTIONS(3234),
    [anon_sym_sample] = ACTIONS(3234),
    [anon_sym_linear] = ACTIONS(3234),
    [anon_sym_snorm] = ACTIONS(3234),
    [anon_sym_unorm] = ACTIONS(3234),
    [anon_sym_point] = ACTIONS(3234),
    [anon_sym_line] = ACTIONS(3234),
    [anon_sym_triangleadj] = ACTIONS(3234),
    [anon_sym_lineadj] = ACTIONS(3234),
    [anon_sym_triangle] = ACTIONS(3234),
    [anon_sym_cbuffer] = ACTIONS(3234),
    [anon_sym_interface] = ACTIONS(3234),
    [anon_sym_extension] = ACTIONS(3234),
  },
  [398] = {
    [sym_identifier] = ACTIONS(3238),
    [aux_sym_preproc_include_token1] = ACTIONS(3238),
    [aux_sym_preproc_def_token1] = ACTIONS(3238),
    [aux_sym_preproc_if_token1] = ACTIONS(3238),
    [aux_sym_preproc_if_token2] = ACTIONS(3238),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3238),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3238),
    [aux_sym_preproc_else_token1] = ACTIONS(3238),
    [aux_sym_preproc_elif_token1] = ACTIONS(3238),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3238),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3238),
    [sym_preproc_directive] = ACTIONS(3238),
    [anon_sym_LPAREN2] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3238),
    [anon_sym_PLUS] = ACTIONS(3238),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_AMP_AMP] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(3238),
    [anon_sym_SEMI] = ACTIONS(3240),
    [anon_sym___extension__] = ACTIONS(3238),
    [anon_sym_typedef] = ACTIONS(3238),
    [anon_sym_in] = ACTIONS(3238),
    [anon_sym_out] = ACTIONS(3238),
    [anon_sym_inout] = ACTIONS(3238),
    [anon_sym_extern] = ACTIONS(3238),
    [anon_sym___attribute__] = ACTIONS(3238),
    [anon_sym_COLON_COLON] = ACTIONS(3240),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3240),
    [anon_sym___declspec] = ACTIONS(3238),
    [anon_sym___based] = ACTIONS(3238),
    [anon_sym___cdecl] = ACTIONS(3238),
    [anon_sym___clrcall] = ACTIONS(3238),
    [anon_sym___stdcall] = ACTIONS(3238),
    [anon_sym___fastcall] = ACTIONS(3238),
    [anon_sym___thiscall] = ACTIONS(3238),
    [anon_sym___vectorcall] = ACTIONS(3238),
    [anon_sym_LBRACE] = ACTIONS(3240),
    [anon_sym_signed] = ACTIONS(3238),
    [anon_sym_unsigned] = ACTIONS(3238),
    [anon_sym_long] = ACTIONS(3238),
    [anon_sym_short] = ACTIONS(3238),
    [anon_sym_LBRACK] = ACTIONS(3238),
    [anon_sym_static] = ACTIONS(3238),
    [anon_sym_register] = ACTIONS(3238),
    [anon_sym_inline] = ACTIONS(3238),
    [anon_sym___inline] = ACTIONS(3238),
    [anon_sym___inline__] = ACTIONS(3238),
    [anon_sym___forceinline] = ACTIONS(3238),
    [anon_sym_thread_local] = ACTIONS(3238),
    [anon_sym___thread] = ACTIONS(3238),
    [anon_sym_const] = ACTIONS(3238),
    [anon_sym_constexpr] = ACTIONS(3238),
    [anon_sym_volatile] = ACTIONS(3238),
    [anon_sym_restrict] = ACTIONS(3238),
    [anon_sym___restrict__] = ACTIONS(3238),
    [anon_sym__Atomic] = ACTIONS(3238),
    [anon_sym__Noreturn] = ACTIONS(3238),
    [anon_sym_noreturn] = ACTIONS(3238),
    [anon_sym_mutable] = ACTIONS(3238),
    [anon_sym_constinit] = ACTIONS(3238),
    [anon_sym_consteval] = ACTIONS(3238),
    [anon_sym_alignas] = ACTIONS(3238),
    [anon_sym__Alignas] = ACTIONS(3238),
    [sym_primitive_type] = ACTIONS(3238),
    [anon_sym_enum] = ACTIONS(3238),
    [anon_sym_class] = ACTIONS(3238),
    [anon_sym_struct] = ACTIONS(3238),
    [anon_sym_union] = ACTIONS(3238),
    [anon_sym_if] = ACTIONS(3238),
    [anon_sym_else] = ACTIONS(3238),
    [anon_sym_switch] = ACTIONS(3238),
    [anon_sym_case] = ACTIONS(3238),
    [anon_sym_default] = ACTIONS(3238),
    [anon_sym_while] = ACTIONS(3238),
    [anon_sym_do] = ACTIONS(3238),
    [anon_sym_for] = ACTIONS(3238),
    [anon_sym_return] = ACTIONS(3238),
    [anon_sym_break] = ACTIONS(3238),
    [anon_sym_continue] = ACTIONS(3238),
    [anon_sym_goto] = ACTIONS(3238),
    [anon_sym___try] = ACTIONS(3238),
    [anon_sym___leave] = ACTIONS(3238),
    [anon_sym_not] = ACTIONS(3238),
    [anon_sym_compl] = ACTIONS(3238),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_sizeof] = ACTIONS(3238),
    [anon_sym___alignof__] = ACTIONS(3238),
    [anon_sym___alignof] = ACTIONS(3238),
    [anon_sym__alignof] = ACTIONS(3238),
    [anon_sym_alignof] = ACTIONS(3238),
    [anon_sym__Alignof] = ACTIONS(3238),
    [anon_sym_offsetof] = ACTIONS(3238),
    [anon_sym__Generic] = ACTIONS(3238),
    [anon_sym_asm] = ACTIONS(3238),
    [anon_sym___asm__] = ACTIONS(3238),
    [sym_number_literal] = ACTIONS(3240),
    [anon_sym_L_SQUOTE] = ACTIONS(3240),
    [anon_sym_u_SQUOTE] = ACTIONS(3240),
    [anon_sym_U_SQUOTE] = ACTIONS(3240),
    [anon_sym_u8_SQUOTE] = ACTIONS(3240),
    [anon_sym_SQUOTE] = ACTIONS(3240),
    [anon_sym_L_DQUOTE] = ACTIONS(3240),
    [anon_sym_u_DQUOTE] = ACTIONS(3240),
    [anon_sym_U_DQUOTE] = ACTIONS(3240),
    [anon_sym_u8_DQUOTE] = ACTIONS(3240),
    [anon_sym_DQUOTE] = ACTIONS(3240),
    [sym_true] = ACTIONS(3238),
    [sym_false] = ACTIONS(3238),
    [anon_sym_NULL] = ACTIONS(3238),
    [anon_sym_nullptr] = ACTIONS(3238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3238),
    [anon_sym_let] = ACTIONS(3238),
    [anon_sym_This] = ACTIONS(3238),
    [anon_sym_decltype] = ACTIONS(3238),
    [sym_virtual] = ACTIONS(3238),
    [anon_sym_explicit] = ACTIONS(3238),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3238),
    [anon_sym_operator] = ACTIONS(3238),
    [anon_sym_try] = ACTIONS(3238),
    [anon_sym_delete] = ACTIONS(3238),
    [anon_sym_throw] = ACTIONS(3238),
    [anon_sym_namespace] = ACTIONS(3238),
    [anon_sym_using] = ACTIONS(3238),
    [anon_sym_static_assert] = ACTIONS(3238),
    [anon_sym_concept] = ACTIONS(3238),
    [anon_sym_co_return] = ACTIONS(3238),
    [anon_sym_co_yield] = ACTIONS(3238),
    [anon_sym_R_DQUOTE] = ACTIONS(3240),
    [anon_sym_LR_DQUOTE] = ACTIONS(3240),
    [anon_sym_uR_DQUOTE] = ACTIONS(3240),
    [anon_sym_UR_DQUOTE] = ACTIONS(3240),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3240),
    [anon_sym_co_await] = ACTIONS(3238),
    [anon_sym_new] = ACTIONS(3238),
    [anon_sym_requires] = ACTIONS(3238),
    [sym_this] = ACTIONS(3238),
    [anon_sym_discard] = ACTIONS(3238),
    [anon_sym_precise] = ACTIONS(3238),
    [anon_sym_shared] = ACTIONS(3238),
    [anon_sym_groupshared] = ACTIONS(3238),
    [anon_sym_uniform] = ACTIONS(3238),
    [anon_sym_row_major] = ACTIONS(3238),
    [anon_sym_column_major] = ACTIONS(3238),
    [anon_sym_globallycoherent] = ACTIONS(3238),
    [anon_sym_centroid] = ACTIONS(3238),
    [anon_sym_noperspective] = ACTIONS(3238),
    [anon_sym_nointerpolation] = ACTIONS(3238),
    [anon_sym_sample] = ACTIONS(3238),
    [anon_sym_linear] = ACTIONS(3238),
    [anon_sym_snorm] = ACTIONS(3238),
    [anon_sym_unorm] = ACTIONS(3238),
    [anon_sym_point] = ACTIONS(3238),
    [anon_sym_line] = ACTIONS(3238),
    [anon_sym_triangleadj] = ACTIONS(3238),
    [anon_sym_lineadj] = ACTIONS(3238),
    [anon_sym_triangle] = ACTIONS(3238),
    [anon_sym_cbuffer] = ACTIONS(3238),
    [anon_sym_interface] = ACTIONS(3238),
    [anon_sym_extension] = ACTIONS(3238),
  },
  [399] = {
    [sym_identifier] = ACTIONS(3242),
    [aux_sym_preproc_include_token1] = ACTIONS(3242),
    [aux_sym_preproc_def_token1] = ACTIONS(3242),
    [aux_sym_preproc_if_token1] = ACTIONS(3242),
    [aux_sym_preproc_if_token2] = ACTIONS(3242),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3242),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3242),
    [aux_sym_preproc_else_token1] = ACTIONS(3242),
    [aux_sym_preproc_elif_token1] = ACTIONS(3242),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3242),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3242),
    [sym_preproc_directive] = ACTIONS(3242),
    [anon_sym_LPAREN2] = ACTIONS(3244),
    [anon_sym_BANG] = ACTIONS(3244),
    [anon_sym_TILDE] = ACTIONS(3244),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_STAR] = ACTIONS(3244),
    [anon_sym_AMP_AMP] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_SEMI] = ACTIONS(3244),
    [anon_sym___extension__] = ACTIONS(3242),
    [anon_sym_typedef] = ACTIONS(3242),
    [anon_sym_in] = ACTIONS(3242),
    [anon_sym_out] = ACTIONS(3242),
    [anon_sym_inout] = ACTIONS(3242),
    [anon_sym_extern] = ACTIONS(3242),
    [anon_sym___attribute__] = ACTIONS(3242),
    [anon_sym_COLON_COLON] = ACTIONS(3244),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3244),
    [anon_sym___declspec] = ACTIONS(3242),
    [anon_sym___based] = ACTIONS(3242),
    [anon_sym___cdecl] = ACTIONS(3242),
    [anon_sym___clrcall] = ACTIONS(3242),
    [anon_sym___stdcall] = ACTIONS(3242),
    [anon_sym___fastcall] = ACTIONS(3242),
    [anon_sym___thiscall] = ACTIONS(3242),
    [anon_sym___vectorcall] = ACTIONS(3242),
    [anon_sym_LBRACE] = ACTIONS(3244),
    [anon_sym_signed] = ACTIONS(3242),
    [anon_sym_unsigned] = ACTIONS(3242),
    [anon_sym_long] = ACTIONS(3242),
    [anon_sym_short] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_static] = ACTIONS(3242),
    [anon_sym_register] = ACTIONS(3242),
    [anon_sym_inline] = ACTIONS(3242),
    [anon_sym___inline] = ACTIONS(3242),
    [anon_sym___inline__] = ACTIONS(3242),
    [anon_sym___forceinline] = ACTIONS(3242),
    [anon_sym_thread_local] = ACTIONS(3242),
    [anon_sym___thread] = ACTIONS(3242),
    [anon_sym_const] = ACTIONS(3242),
    [anon_sym_constexpr] = ACTIONS(3242),
    [anon_sym_volatile] = ACTIONS(3242),
    [anon_sym_restrict] = ACTIONS(3242),
    [anon_sym___restrict__] = ACTIONS(3242),
    [anon_sym__Atomic] = ACTIONS(3242),
    [anon_sym__Noreturn] = ACTIONS(3242),
    [anon_sym_noreturn] = ACTIONS(3242),
    [anon_sym_mutable] = ACTIONS(3242),
    [anon_sym_constinit] = ACTIONS(3242),
    [anon_sym_consteval] = ACTIONS(3242),
    [anon_sym_alignas] = ACTIONS(3242),
    [anon_sym__Alignas] = ACTIONS(3242),
    [sym_primitive_type] = ACTIONS(3242),
    [anon_sym_enum] = ACTIONS(3242),
    [anon_sym_class] = ACTIONS(3242),
    [anon_sym_struct] = ACTIONS(3242),
    [anon_sym_union] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_else] = ACTIONS(3242),
    [anon_sym_switch] = ACTIONS(3242),
    [anon_sym_case] = ACTIONS(3242),
    [anon_sym_default] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_break] = ACTIONS(3242),
    [anon_sym_continue] = ACTIONS(3242),
    [anon_sym_goto] = ACTIONS(3242),
    [anon_sym___try] = ACTIONS(3242),
    [anon_sym___leave] = ACTIONS(3242),
    [anon_sym_not] = ACTIONS(3242),
    [anon_sym_compl] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3244),
    [anon_sym_PLUS_PLUS] = ACTIONS(3244),
    [anon_sym_sizeof] = ACTIONS(3242),
    [anon_sym___alignof__] = ACTIONS(3242),
    [anon_sym___alignof] = ACTIONS(3242),
    [anon_sym__alignof] = ACTIONS(3242),
    [anon_sym_alignof] = ACTIONS(3242),
    [anon_sym__Alignof] = ACTIONS(3242),
    [anon_sym_offsetof] = ACTIONS(3242),
    [anon_sym__Generic] = ACTIONS(3242),
    [anon_sym_asm] = ACTIONS(3242),
    [anon_sym___asm__] = ACTIONS(3242),
    [sym_number_literal] = ACTIONS(3244),
    [anon_sym_L_SQUOTE] = ACTIONS(3244),
    [anon_sym_u_SQUOTE] = ACTIONS(3244),
    [anon_sym_U_SQUOTE] = ACTIONS(3244),
    [anon_sym_u8_SQUOTE] = ACTIONS(3244),
    [anon_sym_SQUOTE] = ACTIONS(3244),
    [anon_sym_L_DQUOTE] = ACTIONS(3244),
    [anon_sym_u_DQUOTE] = ACTIONS(3244),
    [anon_sym_U_DQUOTE] = ACTIONS(3244),
    [anon_sym_u8_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE] = ACTIONS(3244),
    [sym_true] = ACTIONS(3242),
    [sym_false] = ACTIONS(3242),
    [anon_sym_NULL] = ACTIONS(3242),
    [anon_sym_nullptr] = ACTIONS(3242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_This] = ACTIONS(3242),
    [anon_sym_decltype] = ACTIONS(3242),
    [sym_virtual] = ACTIONS(3242),
    [anon_sym_explicit] = ACTIONS(3242),
    [anon_sym_typename] = ACTIONS(3242),
    [anon_sym_template] = ACTIONS(3242),
    [anon_sym_operator] = ACTIONS(3242),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_delete] = ACTIONS(3242),
    [anon_sym_throw] = ACTIONS(3242),
    [anon_sym_namespace] = ACTIONS(3242),
    [anon_sym_using] = ACTIONS(3242),
    [anon_sym_static_assert] = ACTIONS(3242),
    [anon_sym_concept] = ACTIONS(3242),
    [anon_sym_co_return] = ACTIONS(3242),
    [anon_sym_co_yield] = ACTIONS(3242),
    [anon_sym_R_DQUOTE] = ACTIONS(3244),
    [anon_sym_LR_DQUOTE] = ACTIONS(3244),
    [anon_sym_uR_DQUOTE] = ACTIONS(3244),
    [anon_sym_UR_DQUOTE] = ACTIONS(3244),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3244),
    [anon_sym_co_await] = ACTIONS(3242),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_requires] = ACTIONS(3242),
    [sym_this] = ACTIONS(3242),
    [anon_sym_discard] = ACTIONS(3242),
    [anon_sym_precise] = ACTIONS(3242),
    [anon_sym_shared] = ACTIONS(3242),
    [anon_sym_groupshared] = ACTIONS(3242),
    [anon_sym_uniform] = ACTIONS(3242),
    [anon_sym_row_major] = ACTIONS(3242),
    [anon_sym_column_major] = ACTIONS(3242),
    [anon_sym_globallycoherent] = ACTIONS(3242),
    [anon_sym_centroid] = ACTIONS(3242),
    [anon_sym_noperspective] = ACTIONS(3242),
    [anon_sym_nointerpolation] = ACTIONS(3242),
    [anon_sym_sample] = ACTIONS(3242),
    [anon_sym_linear] = ACTIONS(3242),
    [anon_sym_snorm] = ACTIONS(3242),
    [anon_sym_unorm] = ACTIONS(3242),
    [anon_sym_point] = ACTIONS(3242),
    [anon_sym_line] = ACTIONS(3242),
    [anon_sym_triangleadj] = ACTIONS(3242),
    [anon_sym_lineadj] = ACTIONS(3242),
    [anon_sym_triangle] = ACTIONS(3242),
    [anon_sym_cbuffer] = ACTIONS(3242),
    [anon_sym_interface] = ACTIONS(3242),
    [anon_sym_extension] = ACTIONS(3242),
  },
  [400] = {
    [sym_identifier] = ACTIONS(2536),
    [aux_sym_preproc_include_token1] = ACTIONS(2536),
    [aux_sym_preproc_def_token1] = ACTIONS(2536),
    [aux_sym_preproc_if_token1] = ACTIONS(2536),
    [aux_sym_preproc_if_token2] = ACTIONS(2536),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2536),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2536),
    [aux_sym_preproc_else_token1] = ACTIONS(2536),
    [aux_sym_preproc_elif_token1] = ACTIONS(2536),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2536),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2536),
    [sym_preproc_directive] = ACTIONS(2536),
    [anon_sym_LPAREN2] = ACTIONS(2534),
    [anon_sym_BANG] = ACTIONS(2534),
    [anon_sym_TILDE] = ACTIONS(2534),
    [anon_sym_DASH] = ACTIONS(2536),
    [anon_sym_PLUS] = ACTIONS(2536),
    [anon_sym_STAR] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
    [anon_sym_SEMI] = ACTIONS(2534),
    [anon_sym___extension__] = ACTIONS(2536),
    [anon_sym_typedef] = ACTIONS(2536),
    [anon_sym_in] = ACTIONS(2536),
    [anon_sym_out] = ACTIONS(2536),
    [anon_sym_inout] = ACTIONS(2536),
    [anon_sym_extern] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(2534),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2534),
    [anon_sym___declspec] = ACTIONS(2536),
    [anon_sym___based] = ACTIONS(2536),
    [anon_sym___cdecl] = ACTIONS(2536),
    [anon_sym___clrcall] = ACTIONS(2536),
    [anon_sym___stdcall] = ACTIONS(2536),
    [anon_sym___fastcall] = ACTIONS(2536),
    [anon_sym___thiscall] = ACTIONS(2536),
    [anon_sym___vectorcall] = ACTIONS(2536),
    [anon_sym_LBRACE] = ACTIONS(2534),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(2536),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_register] = ACTIONS(2536),
    [anon_sym_inline] = ACTIONS(2536),
    [anon_sym___inline] = ACTIONS(2536),
    [anon_sym___inline__] = ACTIONS(2536),
    [anon_sym___forceinline] = ACTIONS(2536),
    [anon_sym_thread_local] = ACTIONS(2536),
    [anon_sym___thread] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2536),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_class] = ACTIONS(2536),
    [anon_sym_struct] = ACTIONS(2536),
    [anon_sym_union] = ACTIONS(2536),
    [anon_sym_if] = ACTIONS(2536),
    [anon_sym_else] = ACTIONS(2536),
    [anon_sym_switch] = ACTIONS(2536),
    [anon_sym_case] = ACTIONS(2536),
    [anon_sym_default] = ACTIONS(2536),
    [anon_sym_while] = ACTIONS(2536),
    [anon_sym_do] = ACTIONS(2536),
    [anon_sym_for] = ACTIONS(2536),
    [anon_sym_return] = ACTIONS(2536),
    [anon_sym_break] = ACTIONS(2536),
    [anon_sym_continue] = ACTIONS(2536),
    [anon_sym_goto] = ACTIONS(2536),
    [anon_sym___try] = ACTIONS(2536),
    [anon_sym___leave] = ACTIONS(2536),
    [anon_sym_not] = ACTIONS(2536),
    [anon_sym_compl] = ACTIONS(2536),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_sizeof] = ACTIONS(2536),
    [anon_sym___alignof__] = ACTIONS(2536),
    [anon_sym___alignof] = ACTIONS(2536),
    [anon_sym__alignof] = ACTIONS(2536),
    [anon_sym_alignof] = ACTIONS(2536),
    [anon_sym__Alignof] = ACTIONS(2536),
    [anon_sym_offsetof] = ACTIONS(2536),
    [anon_sym__Generic] = ACTIONS(2536),
    [anon_sym_asm] = ACTIONS(2536),
    [anon_sym___asm__] = ACTIONS(2536),
    [sym_number_literal] = ACTIONS(2534),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2534),
    [anon_sym_u_DQUOTE] = ACTIONS(2534),
    [anon_sym_U_DQUOTE] = ACTIONS(2534),
    [anon_sym_u8_DQUOTE] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [sym_true] = ACTIONS(2536),
    [sym_false] = ACTIONS(2536),
    [anon_sym_NULL] = ACTIONS(2536),
    [anon_sym_nullptr] = ACTIONS(2536),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2536),
    [anon_sym_let] = ACTIONS(2536),
    [anon_sym_This] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2536),
    [sym_virtual] = ACTIONS(2536),
    [anon_sym_explicit] = ACTIONS(2536),
    [anon_sym_typename] = ACTIONS(2536),
    [anon_sym_template] = ACTIONS(2536),
    [anon_sym_operator] = ACTIONS(2536),
    [anon_sym_try] = ACTIONS(2536),
    [anon_sym_delete] = ACTIONS(2536),
    [anon_sym_throw] = ACTIONS(2536),
    [anon_sym_namespace] = ACTIONS(2536),
    [anon_sym_using] = ACTIONS(2536),
    [anon_sym_static_assert] = ACTIONS(2536),
    [anon_sym_concept] = ACTIONS(2536),
    [anon_sym_co_return] = ACTIONS(2536),
    [anon_sym_co_yield] = ACTIONS(2536),
    [anon_sym_R_DQUOTE] = ACTIONS(2534),
    [anon_sym_LR_DQUOTE] = ACTIONS(2534),
    [anon_sym_uR_DQUOTE] = ACTIONS(2534),
    [anon_sym_UR_DQUOTE] = ACTIONS(2534),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2534),
    [anon_sym_co_await] = ACTIONS(2536),
    [anon_sym_new] = ACTIONS(2536),
    [anon_sym_requires] = ACTIONS(2536),
    [sym_this] = ACTIONS(2536),
    [anon_sym_discard] = ACTIONS(2536),
    [anon_sym_precise] = ACTIONS(2536),
    [anon_sym_shared] = ACTIONS(2536),
    [anon_sym_groupshared] = ACTIONS(2536),
    [anon_sym_uniform] = ACTIONS(2536),
    [anon_sym_row_major] = ACTIONS(2536),
    [anon_sym_column_major] = ACTIONS(2536),
    [anon_sym_globallycoherent] = ACTIONS(2536),
    [anon_sym_centroid] = ACTIONS(2536),
    [anon_sym_noperspective] = ACTIONS(2536),
    [anon_sym_nointerpolation] = ACTIONS(2536),
    [anon_sym_sample] = ACTIONS(2536),
    [anon_sym_linear] = ACTIONS(2536),
    [anon_sym_snorm] = ACTIONS(2536),
    [anon_sym_unorm] = ACTIONS(2536),
    [anon_sym_point] = ACTIONS(2536),
    [anon_sym_line] = ACTIONS(2536),
    [anon_sym_triangleadj] = ACTIONS(2536),
    [anon_sym_lineadj] = ACTIONS(2536),
    [anon_sym_triangle] = ACTIONS(2536),
    [anon_sym_cbuffer] = ACTIONS(2536),
    [anon_sym_interface] = ACTIONS(2536),
    [anon_sym_extension] = ACTIONS(2536),
  },
  [401] = {
    [sym_identifier] = ACTIONS(3246),
    [aux_sym_preproc_include_token1] = ACTIONS(3246),
    [aux_sym_preproc_def_token1] = ACTIONS(3246),
    [aux_sym_preproc_if_token1] = ACTIONS(3246),
    [aux_sym_preproc_if_token2] = ACTIONS(3246),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3246),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3246),
    [aux_sym_preproc_else_token1] = ACTIONS(3246),
    [aux_sym_preproc_elif_token1] = ACTIONS(3246),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3246),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3246),
    [sym_preproc_directive] = ACTIONS(3246),
    [anon_sym_LPAREN2] = ACTIONS(3248),
    [anon_sym_BANG] = ACTIONS(3248),
    [anon_sym_TILDE] = ACTIONS(3248),
    [anon_sym_DASH] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3246),
    [anon_sym_STAR] = ACTIONS(3248),
    [anon_sym_AMP_AMP] = ACTIONS(3248),
    [anon_sym_AMP] = ACTIONS(3246),
    [anon_sym_SEMI] = ACTIONS(3248),
    [anon_sym___extension__] = ACTIONS(3246),
    [anon_sym_typedef] = ACTIONS(3246),
    [anon_sym_in] = ACTIONS(3246),
    [anon_sym_out] = ACTIONS(3246),
    [anon_sym_inout] = ACTIONS(3246),
    [anon_sym_extern] = ACTIONS(3246),
    [anon_sym___attribute__] = ACTIONS(3246),
    [anon_sym_COLON_COLON] = ACTIONS(3248),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3248),
    [anon_sym___declspec] = ACTIONS(3246),
    [anon_sym___based] = ACTIONS(3246),
    [anon_sym___cdecl] = ACTIONS(3246),
    [anon_sym___clrcall] = ACTIONS(3246),
    [anon_sym___stdcall] = ACTIONS(3246),
    [anon_sym___fastcall] = ACTIONS(3246),
    [anon_sym___thiscall] = ACTIONS(3246),
    [anon_sym___vectorcall] = ACTIONS(3246),
    [anon_sym_LBRACE] = ACTIONS(3248),
    [anon_sym_signed] = ACTIONS(3246),
    [anon_sym_unsigned] = ACTIONS(3246),
    [anon_sym_long] = ACTIONS(3246),
    [anon_sym_short] = ACTIONS(3246),
    [anon_sym_LBRACK] = ACTIONS(3246),
    [anon_sym_static] = ACTIONS(3246),
    [anon_sym_register] = ACTIONS(3246),
    [anon_sym_inline] = ACTIONS(3246),
    [anon_sym___inline] = ACTIONS(3246),
    [anon_sym___inline__] = ACTIONS(3246),
    [anon_sym___forceinline] = ACTIONS(3246),
    [anon_sym_thread_local] = ACTIONS(3246),
    [anon_sym___thread] = ACTIONS(3246),
    [anon_sym_const] = ACTIONS(3246),
    [anon_sym_constexpr] = ACTIONS(3246),
    [anon_sym_volatile] = ACTIONS(3246),
    [anon_sym_restrict] = ACTIONS(3246),
    [anon_sym___restrict__] = ACTIONS(3246),
    [anon_sym__Atomic] = ACTIONS(3246),
    [anon_sym__Noreturn] = ACTIONS(3246),
    [anon_sym_noreturn] = ACTIONS(3246),
    [anon_sym_mutable] = ACTIONS(3246),
    [anon_sym_constinit] = ACTIONS(3246),
    [anon_sym_consteval] = ACTIONS(3246),
    [anon_sym_alignas] = ACTIONS(3246),
    [anon_sym__Alignas] = ACTIONS(3246),
    [sym_primitive_type] = ACTIONS(3246),
    [anon_sym_enum] = ACTIONS(3246),
    [anon_sym_class] = ACTIONS(3246),
    [anon_sym_struct] = ACTIONS(3246),
    [anon_sym_union] = ACTIONS(3246),
    [anon_sym_if] = ACTIONS(3246),
    [anon_sym_else] = ACTIONS(3246),
    [anon_sym_switch] = ACTIONS(3246),
    [anon_sym_case] = ACTIONS(3246),
    [anon_sym_default] = ACTIONS(3246),
    [anon_sym_while] = ACTIONS(3246),
    [anon_sym_do] = ACTIONS(3246),
    [anon_sym_for] = ACTIONS(3246),
    [anon_sym_return] = ACTIONS(3246),
    [anon_sym_break] = ACTIONS(3246),
    [anon_sym_continue] = ACTIONS(3246),
    [anon_sym_goto] = ACTIONS(3246),
    [anon_sym___try] = ACTIONS(3246),
    [anon_sym___leave] = ACTIONS(3246),
    [anon_sym_not] = ACTIONS(3246),
    [anon_sym_compl] = ACTIONS(3246),
    [anon_sym_DASH_DASH] = ACTIONS(3248),
    [anon_sym_PLUS_PLUS] = ACTIONS(3248),
    [anon_sym_sizeof] = ACTIONS(3246),
    [anon_sym___alignof__] = ACTIONS(3246),
    [anon_sym___alignof] = ACTIONS(3246),
    [anon_sym__alignof] = ACTIONS(3246),
    [anon_sym_alignof] = ACTIONS(3246),
    [anon_sym__Alignof] = ACTIONS(3246),
    [anon_sym_offsetof] = ACTIONS(3246),
    [anon_sym__Generic] = ACTIONS(3246),
    [anon_sym_asm] = ACTIONS(3246),
    [anon_sym___asm__] = ACTIONS(3246),
    [sym_number_literal] = ACTIONS(3248),
    [anon_sym_L_SQUOTE] = ACTIONS(3248),
    [anon_sym_u_SQUOTE] = ACTIONS(3248),
    [anon_sym_U_SQUOTE] = ACTIONS(3248),
    [anon_sym_u8_SQUOTE] = ACTIONS(3248),
    [anon_sym_SQUOTE] = ACTIONS(3248),
    [anon_sym_L_DQUOTE] = ACTIONS(3248),
    [anon_sym_u_DQUOTE] = ACTIONS(3248),
    [anon_sym_U_DQUOTE] = ACTIONS(3248),
    [anon_sym_u8_DQUOTE] = ACTIONS(3248),
    [anon_sym_DQUOTE] = ACTIONS(3248),
    [sym_true] = ACTIONS(3246),
    [sym_false] = ACTIONS(3246),
    [anon_sym_NULL] = ACTIONS(3246),
    [anon_sym_nullptr] = ACTIONS(3246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3246),
    [anon_sym_let] = ACTIONS(3246),
    [anon_sym_This] = ACTIONS(3246),
    [anon_sym_decltype] = ACTIONS(3246),
    [sym_virtual] = ACTIONS(3246),
    [anon_sym_explicit] = ACTIONS(3246),
    [anon_sym_typename] = ACTIONS(3246),
    [anon_sym_template] = ACTIONS(3246),
    [anon_sym_operator] = ACTIONS(3246),
    [anon_sym_try] = ACTIONS(3246),
    [anon_sym_delete] = ACTIONS(3246),
    [anon_sym_throw] = ACTIONS(3246),
    [anon_sym_namespace] = ACTIONS(3246),
    [anon_sym_using] = ACTIONS(3246),
    [anon_sym_static_assert] = ACTIONS(3246),
    [anon_sym_concept] = ACTIONS(3246),
    [anon_sym_co_return] = ACTIONS(3246),
    [anon_sym_co_yield] = ACTIONS(3246),
    [anon_sym_R_DQUOTE] = ACTIONS(3248),
    [anon_sym_LR_DQUOTE] = ACTIONS(3248),
    [anon_sym_uR_DQUOTE] = ACTIONS(3248),
    [anon_sym_UR_DQUOTE] = ACTIONS(3248),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3248),
    [anon_sym_co_await] = ACTIONS(3246),
    [anon_sym_new] = ACTIONS(3246),
    [anon_sym_requires] = ACTIONS(3246),
    [sym_this] = ACTIONS(3246),
    [anon_sym_discard] = ACTIONS(3246),
    [anon_sym_precise] = ACTIONS(3246),
    [anon_sym_shared] = ACTIONS(3246),
    [anon_sym_groupshared] = ACTIONS(3246),
    [anon_sym_uniform] = ACTIONS(3246),
    [anon_sym_row_major] = ACTIONS(3246),
    [anon_sym_column_major] = ACTIONS(3246),
    [anon_sym_globallycoherent] = ACTIONS(3246),
    [anon_sym_centroid] = ACTIONS(3246),
    [anon_sym_noperspective] = ACTIONS(3246),
    [anon_sym_nointerpolation] = ACTIONS(3246),
    [anon_sym_sample] = ACTIONS(3246),
    [anon_sym_linear] = ACTIONS(3246),
    [anon_sym_snorm] = ACTIONS(3246),
    [anon_sym_unorm] = ACTIONS(3246),
    [anon_sym_point] = ACTIONS(3246),
    [anon_sym_line] = ACTIONS(3246),
    [anon_sym_triangleadj] = ACTIONS(3246),
    [anon_sym_lineadj] = ACTIONS(3246),
    [anon_sym_triangle] = ACTIONS(3246),
    [anon_sym_cbuffer] = ACTIONS(3246),
    [anon_sym_interface] = ACTIONS(3246),
    [anon_sym_extension] = ACTIONS(3246),
  },
  [402] = {
    [sym_identifier] = ACTIONS(3250),
    [aux_sym_preproc_include_token1] = ACTIONS(3250),
    [aux_sym_preproc_def_token1] = ACTIONS(3250),
    [aux_sym_preproc_if_token1] = ACTIONS(3250),
    [aux_sym_preproc_if_token2] = ACTIONS(3250),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3250),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3250),
    [aux_sym_preproc_else_token1] = ACTIONS(3250),
    [aux_sym_preproc_elif_token1] = ACTIONS(3250),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3250),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3250),
    [sym_preproc_directive] = ACTIONS(3250),
    [anon_sym_LPAREN2] = ACTIONS(3252),
    [anon_sym_BANG] = ACTIONS(3252),
    [anon_sym_TILDE] = ACTIONS(3252),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_STAR] = ACTIONS(3252),
    [anon_sym_AMP_AMP] = ACTIONS(3252),
    [anon_sym_AMP] = ACTIONS(3250),
    [anon_sym_SEMI] = ACTIONS(3252),
    [anon_sym___extension__] = ACTIONS(3250),
    [anon_sym_typedef] = ACTIONS(3250),
    [anon_sym_in] = ACTIONS(3250),
    [anon_sym_out] = ACTIONS(3250),
    [anon_sym_inout] = ACTIONS(3250),
    [anon_sym_extern] = ACTIONS(3250),
    [anon_sym___attribute__] = ACTIONS(3250),
    [anon_sym_COLON_COLON] = ACTIONS(3252),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3252),
    [anon_sym___declspec] = ACTIONS(3250),
    [anon_sym___based] = ACTIONS(3250),
    [anon_sym___cdecl] = ACTIONS(3250),
    [anon_sym___clrcall] = ACTIONS(3250),
    [anon_sym___stdcall] = ACTIONS(3250),
    [anon_sym___fastcall] = ACTIONS(3250),
    [anon_sym___thiscall] = ACTIONS(3250),
    [anon_sym___vectorcall] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3252),
    [anon_sym_signed] = ACTIONS(3250),
    [anon_sym_unsigned] = ACTIONS(3250),
    [anon_sym_long] = ACTIONS(3250),
    [anon_sym_short] = ACTIONS(3250),
    [anon_sym_LBRACK] = ACTIONS(3250),
    [anon_sym_static] = ACTIONS(3250),
    [anon_sym_register] = ACTIONS(3250),
    [anon_sym_inline] = ACTIONS(3250),
    [anon_sym___inline] = ACTIONS(3250),
    [anon_sym___inline__] = ACTIONS(3250),
    [anon_sym___forceinline] = ACTIONS(3250),
    [anon_sym_thread_local] = ACTIONS(3250),
    [anon_sym___thread] = ACTIONS(3250),
    [anon_sym_const] = ACTIONS(3250),
    [anon_sym_constexpr] = ACTIONS(3250),
    [anon_sym_volatile] = ACTIONS(3250),
    [anon_sym_restrict] = ACTIONS(3250),
    [anon_sym___restrict__] = ACTIONS(3250),
    [anon_sym__Atomic] = ACTIONS(3250),
    [anon_sym__Noreturn] = ACTIONS(3250),
    [anon_sym_noreturn] = ACTIONS(3250),
    [anon_sym_mutable] = ACTIONS(3250),
    [anon_sym_constinit] = ACTIONS(3250),
    [anon_sym_consteval] = ACTIONS(3250),
    [anon_sym_alignas] = ACTIONS(3250),
    [anon_sym__Alignas] = ACTIONS(3250),
    [sym_primitive_type] = ACTIONS(3250),
    [anon_sym_enum] = ACTIONS(3250),
    [anon_sym_class] = ACTIONS(3250),
    [anon_sym_struct] = ACTIONS(3250),
    [anon_sym_union] = ACTIONS(3250),
    [anon_sym_if] = ACTIONS(3250),
    [anon_sym_else] = ACTIONS(3250),
    [anon_sym_switch] = ACTIONS(3250),
    [anon_sym_case] = ACTIONS(3250),
    [anon_sym_default] = ACTIONS(3250),
    [anon_sym_while] = ACTIONS(3250),
    [anon_sym_do] = ACTIONS(3250),
    [anon_sym_for] = ACTIONS(3250),
    [anon_sym_return] = ACTIONS(3250),
    [anon_sym_break] = ACTIONS(3250),
    [anon_sym_continue] = ACTIONS(3250),
    [anon_sym_goto] = ACTIONS(3250),
    [anon_sym___try] = ACTIONS(3250),
    [anon_sym___leave] = ACTIONS(3250),
    [anon_sym_not] = ACTIONS(3250),
    [anon_sym_compl] = ACTIONS(3250),
    [anon_sym_DASH_DASH] = ACTIONS(3252),
    [anon_sym_PLUS_PLUS] = ACTIONS(3252),
    [anon_sym_sizeof] = ACTIONS(3250),
    [anon_sym___alignof__] = ACTIONS(3250),
    [anon_sym___alignof] = ACTIONS(3250),
    [anon_sym__alignof] = ACTIONS(3250),
    [anon_sym_alignof] = ACTIONS(3250),
    [anon_sym__Alignof] = ACTIONS(3250),
    [anon_sym_offsetof] = ACTIONS(3250),
    [anon_sym__Generic] = ACTIONS(3250),
    [anon_sym_asm] = ACTIONS(3250),
    [anon_sym___asm__] = ACTIONS(3250),
    [sym_number_literal] = ACTIONS(3252),
    [anon_sym_L_SQUOTE] = ACTIONS(3252),
    [anon_sym_u_SQUOTE] = ACTIONS(3252),
    [anon_sym_U_SQUOTE] = ACTIONS(3252),
    [anon_sym_u8_SQUOTE] = ACTIONS(3252),
    [anon_sym_SQUOTE] = ACTIONS(3252),
    [anon_sym_L_DQUOTE] = ACTIONS(3252),
    [anon_sym_u_DQUOTE] = ACTIONS(3252),
    [anon_sym_U_DQUOTE] = ACTIONS(3252),
    [anon_sym_u8_DQUOTE] = ACTIONS(3252),
    [anon_sym_DQUOTE] = ACTIONS(3252),
    [sym_true] = ACTIONS(3250),
    [sym_false] = ACTIONS(3250),
    [anon_sym_NULL] = ACTIONS(3250),
    [anon_sym_nullptr] = ACTIONS(3250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3250),
    [anon_sym_let] = ACTIONS(3250),
    [anon_sym_This] = ACTIONS(3250),
    [anon_sym_decltype] = ACTIONS(3250),
    [sym_virtual] = ACTIONS(3250),
    [anon_sym_explicit] = ACTIONS(3250),
    [anon_sym_typename] = ACTIONS(3250),
    [anon_sym_template] = ACTIONS(3250),
    [anon_sym_operator] = ACTIONS(3250),
    [anon_sym_try] = ACTIONS(3250),
    [anon_sym_delete] = ACTIONS(3250),
    [anon_sym_throw] = ACTIONS(3250),
    [anon_sym_namespace] = ACTIONS(3250),
    [anon_sym_using] = ACTIONS(3250),
    [anon_sym_static_assert] = ACTIONS(3250),
    [anon_sym_concept] = ACTIONS(3250),
    [anon_sym_co_return] = ACTIONS(3250),
    [anon_sym_co_yield] = ACTIONS(3250),
    [anon_sym_R_DQUOTE] = ACTIONS(3252),
    [anon_sym_LR_DQUOTE] = ACTIONS(3252),
    [anon_sym_uR_DQUOTE] = ACTIONS(3252),
    [anon_sym_UR_DQUOTE] = ACTIONS(3252),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3252),
    [anon_sym_co_await] = ACTIONS(3250),
    [anon_sym_new] = ACTIONS(3250),
    [anon_sym_requires] = ACTIONS(3250),
    [sym_this] = ACTIONS(3250),
    [anon_sym_discard] = ACTIONS(3250),
    [anon_sym_precise] = ACTIONS(3250),
    [anon_sym_shared] = ACTIONS(3250),
    [anon_sym_groupshared] = ACTIONS(3250),
    [anon_sym_uniform] = ACTIONS(3250),
    [anon_sym_row_major] = ACTIONS(3250),
    [anon_sym_column_major] = ACTIONS(3250),
    [anon_sym_globallycoherent] = ACTIONS(3250),
    [anon_sym_centroid] = ACTIONS(3250),
    [anon_sym_noperspective] = ACTIONS(3250),
    [anon_sym_nointerpolation] = ACTIONS(3250),
    [anon_sym_sample] = ACTIONS(3250),
    [anon_sym_linear] = ACTIONS(3250),
    [anon_sym_snorm] = ACTIONS(3250),
    [anon_sym_unorm] = ACTIONS(3250),
    [anon_sym_point] = ACTIONS(3250),
    [anon_sym_line] = ACTIONS(3250),
    [anon_sym_triangleadj] = ACTIONS(3250),
    [anon_sym_lineadj] = ACTIONS(3250),
    [anon_sym_triangle] = ACTIONS(3250),
    [anon_sym_cbuffer] = ACTIONS(3250),
    [anon_sym_interface] = ACTIONS(3250),
    [anon_sym_extension] = ACTIONS(3250),
  },
  [403] = {
    [sym_preproc_def] = STATE(408),
    [sym_preproc_function_def] = STATE(408),
    [sym_preproc_call] = STATE(408),
    [sym_preproc_if_in_field_declaration_list] = STATE(408),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(408),
    [sym_type_definition] = STATE(408),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(408),
    [sym_field_declaration] = STATE(408),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(408),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(408),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(408),
    [sym_operator_cast_declaration] = STATE(408),
    [sym_constructor_or_destructor_definition] = STATE(408),
    [sym_constructor_or_destructor_declaration] = STATE(408),
    [sym_friend_declaration] = STATE(408),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(408),
    [sym_alias_declaration] = STATE(408),
    [sym_static_assert_declaration] = STATE(408),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(408),
    [sym_subscript_declaration] = STATE(408),
    [sym_property_declaration] = STATE(408),
    [sym_associatedtype_declaration] = STATE(408),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(408),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3254),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [404] = {
    [sym_preproc_def] = STATE(404),
    [sym_preproc_function_def] = STATE(404),
    [sym_preproc_call] = STATE(404),
    [sym_preproc_if_in_field_declaration_list] = STATE(404),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(404),
    [sym_type_definition] = STATE(404),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6811),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7427),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(404),
    [sym_field_declaration] = STATE(404),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2593),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(404),
    [sym_operator_cast] = STATE(8371),
    [sym_inline_method_definition] = STATE(404),
    [sym__constructor_specifiers] = STATE(2593),
    [sym_operator_cast_definition] = STATE(404),
    [sym_operator_cast_declaration] = STATE(404),
    [sym_constructor_or_destructor_definition] = STATE(404),
    [sym_constructor_or_destructor_declaration] = STATE(404),
    [sym_friend_declaration] = STATE(404),
    [sym_access_specifier] = STATE(10305),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(404),
    [sym_alias_declaration] = STATE(404),
    [sym_static_assert_declaration] = STATE(404),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8371),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(404),
    [sym_subscript_declaration] = STATE(404),
    [sym_property_declaration] = STATE(404),
    [sym_associatedtype_declaration] = STATE(404),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(404),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2593),
    [sym_identifier] = ACTIONS(2540),
    [aux_sym_preproc_def_token1] = ACTIONS(3256),
    [aux_sym_preproc_if_token1] = ACTIONS(3259),
    [aux_sym_preproc_if_token2] = ACTIONS(2549),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3262),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3262),
    [sym_preproc_directive] = ACTIONS(3265),
    [anon_sym_LPAREN2] = ACTIONS(2557),
    [anon_sym_TILDE] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2566),
    [anon_sym_AMP] = ACTIONS(2569),
    [anon_sym___extension__] = ACTIONS(3268),
    [anon_sym_typedef] = ACTIONS(3271),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_out] = ACTIONS(2578),
    [anon_sym_inout] = ACTIONS(2578),
    [anon_sym_extern] = ACTIONS(2581),
    [anon_sym___attribute__] = ACTIONS(2584),
    [anon_sym_COLON_COLON] = ACTIONS(2587),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2590),
    [anon_sym___declspec] = ACTIONS(2593),
    [anon_sym___based] = ACTIONS(2596),
    [anon_sym_signed] = ACTIONS(2599),
    [anon_sym_unsigned] = ACTIONS(2599),
    [anon_sym_long] = ACTIONS(2599),
    [anon_sym_short] = ACTIONS(2599),
    [anon_sym_LBRACK] = ACTIONS(2602),
    [anon_sym_static] = ACTIONS(2581),
    [anon_sym_register] = ACTIONS(2581),
    [anon_sym_inline] = ACTIONS(2581),
    [anon_sym___inline] = ACTIONS(2581),
    [anon_sym___inline__] = ACTIONS(2581),
    [anon_sym___forceinline] = ACTIONS(2581),
    [anon_sym_thread_local] = ACTIONS(2581),
    [anon_sym___thread] = ACTIONS(2581),
    [anon_sym_const] = ACTIONS(2605),
    [anon_sym_constexpr] = ACTIONS(2605),
    [anon_sym_volatile] = ACTIONS(2605),
    [anon_sym_restrict] = ACTIONS(2605),
    [anon_sym___restrict__] = ACTIONS(2605),
    [anon_sym__Atomic] = ACTIONS(2605),
    [anon_sym__Noreturn] = ACTIONS(2605),
    [anon_sym_noreturn] = ACTIONS(2605),
    [anon_sym_mutable] = ACTIONS(2605),
    [anon_sym_constinit] = ACTIONS(2605),
    [anon_sym_consteval] = ACTIONS(2605),
    [anon_sym_alignas] = ACTIONS(2608),
    [anon_sym__Alignas] = ACTIONS(2608),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_enum] = ACTIONS(2614),
    [anon_sym_class] = ACTIONS(2617),
    [anon_sym_struct] = ACTIONS(2620),
    [anon_sym_union] = ACTIONS(2623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2626),
    [anon_sym_let] = ACTIONS(2626),
    [anon_sym_This] = ACTIONS(2626),
    [anon_sym_decltype] = ACTIONS(2629),
    [sym_virtual] = ACTIONS(2578),
    [anon_sym_explicit] = ACTIONS(2632),
    [anon_sym_typename] = ACTIONS(2635),
    [anon_sym_template] = ACTIONS(3274),
    [anon_sym_operator] = ACTIONS(2641),
    [anon_sym_friend] = ACTIONS(3277),
    [anon_sym_public] = ACTIONS(2647),
    [anon_sym_private] = ACTIONS(2647),
    [anon_sym_protected] = ACTIONS(2647),
    [anon_sym_using] = ACTIONS(3280),
    [anon_sym_static_assert] = ACTIONS(3283),
    [anon_sym_precise] = ACTIONS(2656),
    [anon_sym_shared] = ACTIONS(2656),
    [anon_sym_groupshared] = ACTIONS(2656),
    [anon_sym_uniform] = ACTIONS(2656),
    [anon_sym_row_major] = ACTIONS(2656),
    [anon_sym_column_major] = ACTIONS(2656),
    [anon_sym_globallycoherent] = ACTIONS(2656),
    [anon_sym_centroid] = ACTIONS(2656),
    [anon_sym_noperspective] = ACTIONS(2656),
    [anon_sym_nointerpolation] = ACTIONS(2656),
    [anon_sym_sample] = ACTIONS(2656),
    [anon_sym_linear] = ACTIONS(2656),
    [anon_sym_snorm] = ACTIONS(2656),
    [anon_sym_unorm] = ACTIONS(2656),
    [anon_sym_point] = ACTIONS(2656),
    [anon_sym_line] = ACTIONS(2656),
    [anon_sym_triangleadj] = ACTIONS(2656),
    [anon_sym_lineadj] = ACTIONS(2656),
    [anon_sym_triangle] = ACTIONS(2656),
    [anon_sym_interface] = ACTIONS(2659),
    [anon_sym_extension] = ACTIONS(2662),
    [anon_sym___init] = ACTIONS(3286),
    [anon_sym___subscript] = ACTIONS(3289),
    [anon_sym_property] = ACTIONS(3292),
    [anon_sym_associatedtype] = ACTIONS(3295),
  },
  [405] = {
    [ts_builtin_sym_end] = ACTIONS(2740),
    [sym_identifier] = ACTIONS(2742),
    [aux_sym_preproc_include_token1] = ACTIONS(2742),
    [aux_sym_preproc_def_token1] = ACTIONS(2742),
    [anon_sym_COMMA] = ACTIONS(2740),
    [anon_sym_RPAREN] = ACTIONS(2740),
    [aux_sym_preproc_if_token1] = ACTIONS(2742),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2742),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2742),
    [sym_preproc_directive] = ACTIONS(2742),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_BANG] = ACTIONS(2740),
    [anon_sym_TILDE] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2742),
    [anon_sym_PLUS] = ACTIONS(2742),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym___extension__] = ACTIONS(2742),
    [anon_sym_typedef] = ACTIONS(2742),
    [anon_sym_in] = ACTIONS(2742),
    [anon_sym_out] = ACTIONS(2742),
    [anon_sym_inout] = ACTIONS(2742),
    [anon_sym_extern] = ACTIONS(2742),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym_COLON_COLON] = ACTIONS(2740),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2740),
    [anon_sym___declspec] = ACTIONS(2742),
    [anon_sym___based] = ACTIONS(2742),
    [anon_sym___cdecl] = ACTIONS(2742),
    [anon_sym___clrcall] = ACTIONS(2742),
    [anon_sym___stdcall] = ACTIONS(2742),
    [anon_sym___fastcall] = ACTIONS(2742),
    [anon_sym___thiscall] = ACTIONS(2742),
    [anon_sym___vectorcall] = ACTIONS(2742),
    [anon_sym_LBRACE] = ACTIONS(2740),
    [anon_sym_signed] = ACTIONS(2742),
    [anon_sym_unsigned] = ACTIONS(2742),
    [anon_sym_long] = ACTIONS(2742),
    [anon_sym_short] = ACTIONS(2742),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2742),
    [anon_sym_register] = ACTIONS(2742),
    [anon_sym_inline] = ACTIONS(2742),
    [anon_sym___inline] = ACTIONS(2742),
    [anon_sym___inline__] = ACTIONS(2742),
    [anon_sym___forceinline] = ACTIONS(2742),
    [anon_sym_thread_local] = ACTIONS(2742),
    [anon_sym___thread] = ACTIONS(2742),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_constexpr] = ACTIONS(2742),
    [anon_sym_volatile] = ACTIONS(2742),
    [anon_sym_restrict] = ACTIONS(2742),
    [anon_sym___restrict__] = ACTIONS(2742),
    [anon_sym__Atomic] = ACTIONS(2742),
    [anon_sym__Noreturn] = ACTIONS(2742),
    [anon_sym_noreturn] = ACTIONS(2742),
    [anon_sym_mutable] = ACTIONS(2742),
    [anon_sym_constinit] = ACTIONS(2742),
    [anon_sym_consteval] = ACTIONS(2742),
    [anon_sym_alignas] = ACTIONS(2742),
    [anon_sym__Alignas] = ACTIONS(2742),
    [sym_primitive_type] = ACTIONS(2742),
    [anon_sym_enum] = ACTIONS(2742),
    [anon_sym_class] = ACTIONS(2742),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2742),
    [anon_sym_if] = ACTIONS(2742),
    [anon_sym_switch] = ACTIONS(2742),
    [anon_sym_case] = ACTIONS(2742),
    [anon_sym_default] = ACTIONS(2742),
    [anon_sym_while] = ACTIONS(2742),
    [anon_sym_do] = ACTIONS(2742),
    [anon_sym_for] = ACTIONS(2742),
    [anon_sym_return] = ACTIONS(2742),
    [anon_sym_break] = ACTIONS(2742),
    [anon_sym_continue] = ACTIONS(2742),
    [anon_sym_goto] = ACTIONS(2742),
    [anon_sym_not] = ACTIONS(2742),
    [anon_sym_compl] = ACTIONS(2742),
    [anon_sym_DASH_DASH] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2740),
    [anon_sym_sizeof] = ACTIONS(2742),
    [anon_sym___alignof__] = ACTIONS(2742),
    [anon_sym___alignof] = ACTIONS(2742),
    [anon_sym__alignof] = ACTIONS(2742),
    [anon_sym_alignof] = ACTIONS(2742),
    [anon_sym__Alignof] = ACTIONS(2742),
    [anon_sym_offsetof] = ACTIONS(2742),
    [anon_sym__Generic] = ACTIONS(2742),
    [anon_sym_asm] = ACTIONS(2742),
    [anon_sym___asm__] = ACTIONS(2742),
    [anon_sym_DOT] = ACTIONS(2742),
    [sym_number_literal] = ACTIONS(2740),
    [anon_sym_L_SQUOTE] = ACTIONS(2740),
    [anon_sym_u_SQUOTE] = ACTIONS(2740),
    [anon_sym_U_SQUOTE] = ACTIONS(2740),
    [anon_sym_u8_SQUOTE] = ACTIONS(2740),
    [anon_sym_SQUOTE] = ACTIONS(2740),
    [anon_sym_L_DQUOTE] = ACTIONS(2740),
    [anon_sym_u_DQUOTE] = ACTIONS(2740),
    [anon_sym_U_DQUOTE] = ACTIONS(2740),
    [anon_sym_u8_DQUOTE] = ACTIONS(2740),
    [anon_sym_DQUOTE] = ACTIONS(2740),
    [sym_true] = ACTIONS(2742),
    [sym_false] = ACTIONS(2742),
    [anon_sym_NULL] = ACTIONS(2742),
    [anon_sym_nullptr] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
    [anon_sym_decltype] = ACTIONS(2742),
    [anon_sym_final] = ACTIONS(2742),
    [anon_sym_override] = ACTIONS(2742),
    [sym_virtual] = ACTIONS(2742),
    [anon_sym_explicit] = ACTIONS(2742),
    [anon_sym_typename] = ACTIONS(2742),
    [anon_sym_template] = ACTIONS(2742),
    [anon_sym_GT2] = ACTIONS(2740),
    [anon_sym_operator] = ACTIONS(2742),
    [anon_sym_try] = ACTIONS(2742),
    [anon_sym_delete] = ACTIONS(2742),
    [anon_sym_throw] = ACTIONS(2742),
    [anon_sym_namespace] = ACTIONS(2742),
    [anon_sym_using] = ACTIONS(2742),
    [anon_sym_static_assert] = ACTIONS(2742),
    [anon_sym_concept] = ACTIONS(2742),
    [anon_sym_co_return] = ACTIONS(2742),
    [anon_sym_co_yield] = ACTIONS(2742),
    [anon_sym_R_DQUOTE] = ACTIONS(2740),
    [anon_sym_LR_DQUOTE] = ACTIONS(2740),
    [anon_sym_uR_DQUOTE] = ACTIONS(2740),
    [anon_sym_UR_DQUOTE] = ACTIONS(2740),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2740),
    [anon_sym_co_await] = ACTIONS(2742),
    [anon_sym_new] = ACTIONS(2742),
    [anon_sym_requires] = ACTIONS(2742),
    [sym_this] = ACTIONS(2742),
    [anon_sym_precise] = ACTIONS(2742),
    [anon_sym_shared] = ACTIONS(2742),
    [anon_sym_groupshared] = ACTIONS(2742),
    [anon_sym_uniform] = ACTIONS(2742),
    [anon_sym_row_major] = ACTIONS(2742),
    [anon_sym_column_major] = ACTIONS(2742),
    [anon_sym_globallycoherent] = ACTIONS(2742),
    [anon_sym_centroid] = ACTIONS(2742),
    [anon_sym_noperspective] = ACTIONS(2742),
    [anon_sym_nointerpolation] = ACTIONS(2742),
    [anon_sym_sample] = ACTIONS(2742),
    [anon_sym_linear] = ACTIONS(2742),
    [anon_sym_snorm] = ACTIONS(2742),
    [anon_sym_unorm] = ACTIONS(2742),
    [anon_sym_point] = ACTIONS(2742),
    [anon_sym_line] = ACTIONS(2742),
    [anon_sym_triangleadj] = ACTIONS(2742),
    [anon_sym_lineadj] = ACTIONS(2742),
    [anon_sym_triangle] = ACTIONS(2742),
    [anon_sym_interface] = ACTIONS(2742),
    [anon_sym_extension] = ACTIONS(2742),
    [anon_sym_where] = ACTIONS(2742),
    [anon_sym___exported] = ACTIONS(2742),
    [anon_sym_import] = ACTIONS(2742),
  },
  [406] = {
    [sym_identifier] = ACTIONS(3298),
    [aux_sym_preproc_include_token1] = ACTIONS(3298),
    [aux_sym_preproc_def_token1] = ACTIONS(3298),
    [aux_sym_preproc_if_token1] = ACTIONS(3298),
    [aux_sym_preproc_if_token2] = ACTIONS(3298),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3298),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3298),
    [aux_sym_preproc_else_token1] = ACTIONS(3298),
    [aux_sym_preproc_elif_token1] = ACTIONS(3298),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3298),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3298),
    [sym_preproc_directive] = ACTIONS(3298),
    [anon_sym_LPAREN2] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3298),
    [anon_sym_PLUS] = ACTIONS(3298),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_AMP_AMP] = ACTIONS(3300),
    [anon_sym_AMP] = ACTIONS(3298),
    [anon_sym_SEMI] = ACTIONS(3300),
    [anon_sym___extension__] = ACTIONS(3298),
    [anon_sym_typedef] = ACTIONS(3298),
    [anon_sym_in] = ACTIONS(3298),
    [anon_sym_out] = ACTIONS(3298),
    [anon_sym_inout] = ACTIONS(3298),
    [anon_sym_extern] = ACTIONS(3298),
    [anon_sym___attribute__] = ACTIONS(3298),
    [anon_sym_COLON_COLON] = ACTIONS(3300),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3300),
    [anon_sym___declspec] = ACTIONS(3298),
    [anon_sym___based] = ACTIONS(3298),
    [anon_sym___cdecl] = ACTIONS(3298),
    [anon_sym___clrcall] = ACTIONS(3298),
    [anon_sym___stdcall] = ACTIONS(3298),
    [anon_sym___fastcall] = ACTIONS(3298),
    [anon_sym___thiscall] = ACTIONS(3298),
    [anon_sym___vectorcall] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_signed] = ACTIONS(3298),
    [anon_sym_unsigned] = ACTIONS(3298),
    [anon_sym_long] = ACTIONS(3298),
    [anon_sym_short] = ACTIONS(3298),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_static] = ACTIONS(3298),
    [anon_sym_register] = ACTIONS(3298),
    [anon_sym_inline] = ACTIONS(3298),
    [anon_sym___inline] = ACTIONS(3298),
    [anon_sym___inline__] = ACTIONS(3298),
    [anon_sym___forceinline] = ACTIONS(3298),
    [anon_sym_thread_local] = ACTIONS(3298),
    [anon_sym___thread] = ACTIONS(3298),
    [anon_sym_const] = ACTIONS(3298),
    [anon_sym_constexpr] = ACTIONS(3298),
    [anon_sym_volatile] = ACTIONS(3298),
    [anon_sym_restrict] = ACTIONS(3298),
    [anon_sym___restrict__] = ACTIONS(3298),
    [anon_sym__Atomic] = ACTIONS(3298),
    [anon_sym__Noreturn] = ACTIONS(3298),
    [anon_sym_noreturn] = ACTIONS(3298),
    [anon_sym_mutable] = ACTIONS(3298),
    [anon_sym_constinit] = ACTIONS(3298),
    [anon_sym_consteval] = ACTIONS(3298),
    [anon_sym_alignas] = ACTIONS(3298),
    [anon_sym__Alignas] = ACTIONS(3298),
    [sym_primitive_type] = ACTIONS(3298),
    [anon_sym_enum] = ACTIONS(3298),
    [anon_sym_class] = ACTIONS(3298),
    [anon_sym_struct] = ACTIONS(3298),
    [anon_sym_union] = ACTIONS(3298),
    [anon_sym_if] = ACTIONS(3298),
    [anon_sym_else] = ACTIONS(3298),
    [anon_sym_switch] = ACTIONS(3298),
    [anon_sym_case] = ACTIONS(3298),
    [anon_sym_default] = ACTIONS(3298),
    [anon_sym_while] = ACTIONS(3298),
    [anon_sym_do] = ACTIONS(3298),
    [anon_sym_for] = ACTIONS(3298),
    [anon_sym_return] = ACTIONS(3298),
    [anon_sym_break] = ACTIONS(3298),
    [anon_sym_continue] = ACTIONS(3298),
    [anon_sym_goto] = ACTIONS(3298),
    [anon_sym___try] = ACTIONS(3298),
    [anon_sym___leave] = ACTIONS(3298),
    [anon_sym_not] = ACTIONS(3298),
    [anon_sym_compl] = ACTIONS(3298),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_sizeof] = ACTIONS(3298),
    [anon_sym___alignof__] = ACTIONS(3298),
    [anon_sym___alignof] = ACTIONS(3298),
    [anon_sym__alignof] = ACTIONS(3298),
    [anon_sym_alignof] = ACTIONS(3298),
    [anon_sym__Alignof] = ACTIONS(3298),
    [anon_sym_offsetof] = ACTIONS(3298),
    [anon_sym__Generic] = ACTIONS(3298),
    [anon_sym_asm] = ACTIONS(3298),
    [anon_sym___asm__] = ACTIONS(3298),
    [sym_number_literal] = ACTIONS(3300),
    [anon_sym_L_SQUOTE] = ACTIONS(3300),
    [anon_sym_u_SQUOTE] = ACTIONS(3300),
    [anon_sym_U_SQUOTE] = ACTIONS(3300),
    [anon_sym_u8_SQUOTE] = ACTIONS(3300),
    [anon_sym_SQUOTE] = ACTIONS(3300),
    [anon_sym_L_DQUOTE] = ACTIONS(3300),
    [anon_sym_u_DQUOTE] = ACTIONS(3300),
    [anon_sym_U_DQUOTE] = ACTIONS(3300),
    [anon_sym_u8_DQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [sym_true] = ACTIONS(3298),
    [sym_false] = ACTIONS(3298),
    [anon_sym_NULL] = ACTIONS(3298),
    [anon_sym_nullptr] = ACTIONS(3298),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3298),
    [anon_sym_let] = ACTIONS(3298),
    [anon_sym_This] = ACTIONS(3298),
    [anon_sym_decltype] = ACTIONS(3298),
    [sym_virtual] = ACTIONS(3298),
    [anon_sym_explicit] = ACTIONS(3298),
    [anon_sym_typename] = ACTIONS(3298),
    [anon_sym_template] = ACTIONS(3298),
    [anon_sym_operator] = ACTIONS(3298),
    [anon_sym_try] = ACTIONS(3298),
    [anon_sym_delete] = ACTIONS(3298),
    [anon_sym_throw] = ACTIONS(3298),
    [anon_sym_namespace] = ACTIONS(3298),
    [anon_sym_using] = ACTIONS(3298),
    [anon_sym_static_assert] = ACTIONS(3298),
    [anon_sym_concept] = ACTIONS(3298),
    [anon_sym_co_return] = ACTIONS(3298),
    [anon_sym_co_yield] = ACTIONS(3298),
    [anon_sym_R_DQUOTE] = ACTIONS(3300),
    [anon_sym_LR_DQUOTE] = ACTIONS(3300),
    [anon_sym_uR_DQUOTE] = ACTIONS(3300),
    [anon_sym_UR_DQUOTE] = ACTIONS(3300),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3300),
    [anon_sym_co_await] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3298),
    [anon_sym_requires] = ACTIONS(3298),
    [sym_this] = ACTIONS(3298),
    [anon_sym_discard] = ACTIONS(3298),
    [anon_sym_precise] = ACTIONS(3298),
    [anon_sym_shared] = ACTIONS(3298),
    [anon_sym_groupshared] = ACTIONS(3298),
    [anon_sym_uniform] = ACTIONS(3298),
    [anon_sym_row_major] = ACTIONS(3298),
    [anon_sym_column_major] = ACTIONS(3298),
    [anon_sym_globallycoherent] = ACTIONS(3298),
    [anon_sym_centroid] = ACTIONS(3298),
    [anon_sym_noperspective] = ACTIONS(3298),
    [anon_sym_nointerpolation] = ACTIONS(3298),
    [anon_sym_sample] = ACTIONS(3298),
    [anon_sym_linear] = ACTIONS(3298),
    [anon_sym_snorm] = ACTIONS(3298),
    [anon_sym_unorm] = ACTIONS(3298),
    [anon_sym_point] = ACTIONS(3298),
    [anon_sym_line] = ACTIONS(3298),
    [anon_sym_triangleadj] = ACTIONS(3298),
    [anon_sym_lineadj] = ACTIONS(3298),
    [anon_sym_triangle] = ACTIONS(3298),
    [anon_sym_cbuffer] = ACTIONS(3298),
    [anon_sym_interface] = ACTIONS(3298),
    [anon_sym_extension] = ACTIONS(3298),
  },
  [407] = {
    [sym_identifier] = ACTIONS(3302),
    [aux_sym_preproc_include_token1] = ACTIONS(3302),
    [aux_sym_preproc_def_token1] = ACTIONS(3302),
    [aux_sym_preproc_if_token1] = ACTIONS(3302),
    [aux_sym_preproc_if_token2] = ACTIONS(3302),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3302),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3302),
    [aux_sym_preproc_else_token1] = ACTIONS(3302),
    [aux_sym_preproc_elif_token1] = ACTIONS(3302),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3302),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3302),
    [sym_preproc_directive] = ACTIONS(3302),
    [anon_sym_LPAREN2] = ACTIONS(3304),
    [anon_sym_BANG] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_AMP_AMP] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3302),
    [anon_sym_SEMI] = ACTIONS(3304),
    [anon_sym___extension__] = ACTIONS(3302),
    [anon_sym_typedef] = ACTIONS(3302),
    [anon_sym_in] = ACTIONS(3302),
    [anon_sym_out] = ACTIONS(3302),
    [anon_sym_inout] = ACTIONS(3302),
    [anon_sym_extern] = ACTIONS(3302),
    [anon_sym___attribute__] = ACTIONS(3302),
    [anon_sym_COLON_COLON] = ACTIONS(3304),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3304),
    [anon_sym___declspec] = ACTIONS(3302),
    [anon_sym___based] = ACTIONS(3302),
    [anon_sym___cdecl] = ACTIONS(3302),
    [anon_sym___clrcall] = ACTIONS(3302),
    [anon_sym___stdcall] = ACTIONS(3302),
    [anon_sym___fastcall] = ACTIONS(3302),
    [anon_sym___thiscall] = ACTIONS(3302),
    [anon_sym___vectorcall] = ACTIONS(3302),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_signed] = ACTIONS(3302),
    [anon_sym_unsigned] = ACTIONS(3302),
    [anon_sym_long] = ACTIONS(3302),
    [anon_sym_short] = ACTIONS(3302),
    [anon_sym_LBRACK] = ACTIONS(3302),
    [anon_sym_static] = ACTIONS(3302),
    [anon_sym_register] = ACTIONS(3302),
    [anon_sym_inline] = ACTIONS(3302),
    [anon_sym___inline] = ACTIONS(3302),
    [anon_sym___inline__] = ACTIONS(3302),
    [anon_sym___forceinline] = ACTIONS(3302),
    [anon_sym_thread_local] = ACTIONS(3302),
    [anon_sym___thread] = ACTIONS(3302),
    [anon_sym_const] = ACTIONS(3302),
    [anon_sym_constexpr] = ACTIONS(3302),
    [anon_sym_volatile] = ACTIONS(3302),
    [anon_sym_restrict] = ACTIONS(3302),
    [anon_sym___restrict__] = ACTIONS(3302),
    [anon_sym__Atomic] = ACTIONS(3302),
    [anon_sym__Noreturn] = ACTIONS(3302),
    [anon_sym_noreturn] = ACTIONS(3302),
    [anon_sym_mutable] = ACTIONS(3302),
    [anon_sym_constinit] = ACTIONS(3302),
    [anon_sym_consteval] = ACTIONS(3302),
    [anon_sym_alignas] = ACTIONS(3302),
    [anon_sym__Alignas] = ACTIONS(3302),
    [sym_primitive_type] = ACTIONS(3302),
    [anon_sym_enum] = ACTIONS(3302),
    [anon_sym_class] = ACTIONS(3302),
    [anon_sym_struct] = ACTIONS(3302),
    [anon_sym_union] = ACTIONS(3302),
    [anon_sym_if] = ACTIONS(3302),
    [anon_sym_else] = ACTIONS(3302),
    [anon_sym_switch] = ACTIONS(3302),
    [anon_sym_case] = ACTIONS(3302),
    [anon_sym_default] = ACTIONS(3302),
    [anon_sym_while] = ACTIONS(3302),
    [anon_sym_do] = ACTIONS(3302),
    [anon_sym_for] = ACTIONS(3302),
    [anon_sym_return] = ACTIONS(3302),
    [anon_sym_break] = ACTIONS(3302),
    [anon_sym_continue] = ACTIONS(3302),
    [anon_sym_goto] = ACTIONS(3302),
    [anon_sym___try] = ACTIONS(3302),
    [anon_sym___leave] = ACTIONS(3302),
    [anon_sym_not] = ACTIONS(3302),
    [anon_sym_compl] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3304),
    [anon_sym_PLUS_PLUS] = ACTIONS(3304),
    [anon_sym_sizeof] = ACTIONS(3302),
    [anon_sym___alignof__] = ACTIONS(3302),
    [anon_sym___alignof] = ACTIONS(3302),
    [anon_sym__alignof] = ACTIONS(3302),
    [anon_sym_alignof] = ACTIONS(3302),
    [anon_sym__Alignof] = ACTIONS(3302),
    [anon_sym_offsetof] = ACTIONS(3302),
    [anon_sym__Generic] = ACTIONS(3302),
    [anon_sym_asm] = ACTIONS(3302),
    [anon_sym___asm__] = ACTIONS(3302),
    [sym_number_literal] = ACTIONS(3304),
    [anon_sym_L_SQUOTE] = ACTIONS(3304),
    [anon_sym_u_SQUOTE] = ACTIONS(3304),
    [anon_sym_U_SQUOTE] = ACTIONS(3304),
    [anon_sym_u8_SQUOTE] = ACTIONS(3304),
    [anon_sym_SQUOTE] = ACTIONS(3304),
    [anon_sym_L_DQUOTE] = ACTIONS(3304),
    [anon_sym_u_DQUOTE] = ACTIONS(3304),
    [anon_sym_U_DQUOTE] = ACTIONS(3304),
    [anon_sym_u8_DQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [sym_true] = ACTIONS(3302),
    [sym_false] = ACTIONS(3302),
    [anon_sym_NULL] = ACTIONS(3302),
    [anon_sym_nullptr] = ACTIONS(3302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3302),
    [anon_sym_let] = ACTIONS(3302),
    [anon_sym_This] = ACTIONS(3302),
    [anon_sym_decltype] = ACTIONS(3302),
    [sym_virtual] = ACTIONS(3302),
    [anon_sym_explicit] = ACTIONS(3302),
    [anon_sym_typename] = ACTIONS(3302),
    [anon_sym_template] = ACTIONS(3302),
    [anon_sym_operator] = ACTIONS(3302),
    [anon_sym_try] = ACTIONS(3302),
    [anon_sym_delete] = ACTIONS(3302),
    [anon_sym_throw] = ACTIONS(3302),
    [anon_sym_namespace] = ACTIONS(3302),
    [anon_sym_using] = ACTIONS(3302),
    [anon_sym_static_assert] = ACTIONS(3302),
    [anon_sym_concept] = ACTIONS(3302),
    [anon_sym_co_return] = ACTIONS(3302),
    [anon_sym_co_yield] = ACTIONS(3302),
    [anon_sym_R_DQUOTE] = ACTIONS(3304),
    [anon_sym_LR_DQUOTE] = ACTIONS(3304),
    [anon_sym_uR_DQUOTE] = ACTIONS(3304),
    [anon_sym_UR_DQUOTE] = ACTIONS(3304),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3304),
    [anon_sym_co_await] = ACTIONS(3302),
    [anon_sym_new] = ACTIONS(3302),
    [anon_sym_requires] = ACTIONS(3302),
    [sym_this] = ACTIONS(3302),
    [anon_sym_discard] = ACTIONS(3302),
    [anon_sym_precise] = ACTIONS(3302),
    [anon_sym_shared] = ACTIONS(3302),
    [anon_sym_groupshared] = ACTIONS(3302),
    [anon_sym_uniform] = ACTIONS(3302),
    [anon_sym_row_major] = ACTIONS(3302),
    [anon_sym_column_major] = ACTIONS(3302),
    [anon_sym_globallycoherent] = ACTIONS(3302),
    [anon_sym_centroid] = ACTIONS(3302),
    [anon_sym_noperspective] = ACTIONS(3302),
    [anon_sym_nointerpolation] = ACTIONS(3302),
    [anon_sym_sample] = ACTIONS(3302),
    [anon_sym_linear] = ACTIONS(3302),
    [anon_sym_snorm] = ACTIONS(3302),
    [anon_sym_unorm] = ACTIONS(3302),
    [anon_sym_point] = ACTIONS(3302),
    [anon_sym_line] = ACTIONS(3302),
    [anon_sym_triangleadj] = ACTIONS(3302),
    [anon_sym_lineadj] = ACTIONS(3302),
    [anon_sym_triangle] = ACTIONS(3302),
    [anon_sym_cbuffer] = ACTIONS(3302),
    [anon_sym_interface] = ACTIONS(3302),
    [anon_sym_extension] = ACTIONS(3302),
  },
  [408] = {
    [sym_preproc_def] = STATE(371),
    [sym_preproc_function_def] = STATE(371),
    [sym_preproc_call] = STATE(371),
    [sym_preproc_if_in_field_declaration_list] = STATE(371),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(371),
    [sym_type_definition] = STATE(371),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(371),
    [sym_field_declaration] = STATE(371),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(371),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(371),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(371),
    [sym_operator_cast_declaration] = STATE(371),
    [sym_constructor_or_destructor_definition] = STATE(371),
    [sym_constructor_or_destructor_declaration] = STATE(371),
    [sym_friend_declaration] = STATE(371),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(371),
    [sym_alias_declaration] = STATE(371),
    [sym_static_assert_declaration] = STATE(371),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(371),
    [sym_subscript_declaration] = STATE(371),
    [sym_property_declaration] = STATE(371),
    [sym_associatedtype_declaration] = STATE(371),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(371),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3306),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [409] = {
    [sym_preproc_def] = STATE(382),
    [sym_preproc_function_def] = STATE(382),
    [sym_preproc_call] = STATE(382),
    [sym_preproc_if_in_field_declaration_list] = STATE(382),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(382),
    [sym_type_definition] = STATE(382),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(382),
    [sym_field_declaration] = STATE(382),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(382),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(382),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(382),
    [sym_operator_cast_declaration] = STATE(382),
    [sym_constructor_or_destructor_definition] = STATE(382),
    [sym_constructor_or_destructor_declaration] = STATE(382),
    [sym_friend_declaration] = STATE(382),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(382),
    [sym_alias_declaration] = STATE(382),
    [sym_static_assert_declaration] = STATE(382),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(382),
    [sym_subscript_declaration] = STATE(382),
    [sym_property_declaration] = STATE(382),
    [sym_associatedtype_declaration] = STATE(382),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(382),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3308),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [410] = {
    [sym_identifier] = ACTIONS(3310),
    [aux_sym_preproc_include_token1] = ACTIONS(3310),
    [aux_sym_preproc_def_token1] = ACTIONS(3310),
    [aux_sym_preproc_if_token1] = ACTIONS(3310),
    [aux_sym_preproc_if_token2] = ACTIONS(3310),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3310),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3310),
    [aux_sym_preproc_else_token1] = ACTIONS(3310),
    [aux_sym_preproc_elif_token1] = ACTIONS(3310),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3310),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3310),
    [sym_preproc_directive] = ACTIONS(3310),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_BANG] = ACTIONS(3312),
    [anon_sym_TILDE] = ACTIONS(3312),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3312),
    [anon_sym_AMP_AMP] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3310),
    [anon_sym_SEMI] = ACTIONS(3312),
    [anon_sym___extension__] = ACTIONS(3310),
    [anon_sym_typedef] = ACTIONS(3310),
    [anon_sym_in] = ACTIONS(3310),
    [anon_sym_out] = ACTIONS(3310),
    [anon_sym_inout] = ACTIONS(3310),
    [anon_sym_extern] = ACTIONS(3310),
    [anon_sym___attribute__] = ACTIONS(3310),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3312),
    [anon_sym___declspec] = ACTIONS(3310),
    [anon_sym___based] = ACTIONS(3310),
    [anon_sym___cdecl] = ACTIONS(3310),
    [anon_sym___clrcall] = ACTIONS(3310),
    [anon_sym___stdcall] = ACTIONS(3310),
    [anon_sym___fastcall] = ACTIONS(3310),
    [anon_sym___thiscall] = ACTIONS(3310),
    [anon_sym___vectorcall] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3312),
    [anon_sym_signed] = ACTIONS(3310),
    [anon_sym_unsigned] = ACTIONS(3310),
    [anon_sym_long] = ACTIONS(3310),
    [anon_sym_short] = ACTIONS(3310),
    [anon_sym_LBRACK] = ACTIONS(3310),
    [anon_sym_static] = ACTIONS(3310),
    [anon_sym_register] = ACTIONS(3310),
    [anon_sym_inline] = ACTIONS(3310),
    [anon_sym___inline] = ACTIONS(3310),
    [anon_sym___inline__] = ACTIONS(3310),
    [anon_sym___forceinline] = ACTIONS(3310),
    [anon_sym_thread_local] = ACTIONS(3310),
    [anon_sym___thread] = ACTIONS(3310),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_constexpr] = ACTIONS(3310),
    [anon_sym_volatile] = ACTIONS(3310),
    [anon_sym_restrict] = ACTIONS(3310),
    [anon_sym___restrict__] = ACTIONS(3310),
    [anon_sym__Atomic] = ACTIONS(3310),
    [anon_sym__Noreturn] = ACTIONS(3310),
    [anon_sym_noreturn] = ACTIONS(3310),
    [anon_sym_mutable] = ACTIONS(3310),
    [anon_sym_constinit] = ACTIONS(3310),
    [anon_sym_consteval] = ACTIONS(3310),
    [anon_sym_alignas] = ACTIONS(3310),
    [anon_sym__Alignas] = ACTIONS(3310),
    [sym_primitive_type] = ACTIONS(3310),
    [anon_sym_enum] = ACTIONS(3310),
    [anon_sym_class] = ACTIONS(3310),
    [anon_sym_struct] = ACTIONS(3310),
    [anon_sym_union] = ACTIONS(3310),
    [anon_sym_if] = ACTIONS(3310),
    [anon_sym_else] = ACTIONS(3310),
    [anon_sym_switch] = ACTIONS(3310),
    [anon_sym_case] = ACTIONS(3310),
    [anon_sym_default] = ACTIONS(3310),
    [anon_sym_while] = ACTIONS(3310),
    [anon_sym_do] = ACTIONS(3310),
    [anon_sym_for] = ACTIONS(3310),
    [anon_sym_return] = ACTIONS(3310),
    [anon_sym_break] = ACTIONS(3310),
    [anon_sym_continue] = ACTIONS(3310),
    [anon_sym_goto] = ACTIONS(3310),
    [anon_sym___try] = ACTIONS(3310),
    [anon_sym___leave] = ACTIONS(3310),
    [anon_sym_not] = ACTIONS(3310),
    [anon_sym_compl] = ACTIONS(3310),
    [anon_sym_DASH_DASH] = ACTIONS(3312),
    [anon_sym_PLUS_PLUS] = ACTIONS(3312),
    [anon_sym_sizeof] = ACTIONS(3310),
    [anon_sym___alignof__] = ACTIONS(3310),
    [anon_sym___alignof] = ACTIONS(3310),
    [anon_sym__alignof] = ACTIONS(3310),
    [anon_sym_alignof] = ACTIONS(3310),
    [anon_sym__Alignof] = ACTIONS(3310),
    [anon_sym_offsetof] = ACTIONS(3310),
    [anon_sym__Generic] = ACTIONS(3310),
    [anon_sym_asm] = ACTIONS(3310),
    [anon_sym___asm__] = ACTIONS(3310),
    [sym_number_literal] = ACTIONS(3312),
    [anon_sym_L_SQUOTE] = ACTIONS(3312),
    [anon_sym_u_SQUOTE] = ACTIONS(3312),
    [anon_sym_U_SQUOTE] = ACTIONS(3312),
    [anon_sym_u8_SQUOTE] = ACTIONS(3312),
    [anon_sym_SQUOTE] = ACTIONS(3312),
    [anon_sym_L_DQUOTE] = ACTIONS(3312),
    [anon_sym_u_DQUOTE] = ACTIONS(3312),
    [anon_sym_U_DQUOTE] = ACTIONS(3312),
    [anon_sym_u8_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE] = ACTIONS(3312),
    [sym_true] = ACTIONS(3310),
    [sym_false] = ACTIONS(3310),
    [anon_sym_NULL] = ACTIONS(3310),
    [anon_sym_nullptr] = ACTIONS(3310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3310),
    [anon_sym_let] = ACTIONS(3310),
    [anon_sym_This] = ACTIONS(3310),
    [anon_sym_decltype] = ACTIONS(3310),
    [sym_virtual] = ACTIONS(3310),
    [anon_sym_explicit] = ACTIONS(3310),
    [anon_sym_typename] = ACTIONS(3310),
    [anon_sym_template] = ACTIONS(3310),
    [anon_sym_operator] = ACTIONS(3310),
    [anon_sym_try] = ACTIONS(3310),
    [anon_sym_delete] = ACTIONS(3310),
    [anon_sym_throw] = ACTIONS(3310),
    [anon_sym_namespace] = ACTIONS(3310),
    [anon_sym_using] = ACTIONS(3310),
    [anon_sym_static_assert] = ACTIONS(3310),
    [anon_sym_concept] = ACTIONS(3310),
    [anon_sym_co_return] = ACTIONS(3310),
    [anon_sym_co_yield] = ACTIONS(3310),
    [anon_sym_R_DQUOTE] = ACTIONS(3312),
    [anon_sym_LR_DQUOTE] = ACTIONS(3312),
    [anon_sym_uR_DQUOTE] = ACTIONS(3312),
    [anon_sym_UR_DQUOTE] = ACTIONS(3312),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3312),
    [anon_sym_co_await] = ACTIONS(3310),
    [anon_sym_new] = ACTIONS(3310),
    [anon_sym_requires] = ACTIONS(3310),
    [sym_this] = ACTIONS(3310),
    [anon_sym_discard] = ACTIONS(3310),
    [anon_sym_precise] = ACTIONS(3310),
    [anon_sym_shared] = ACTIONS(3310),
    [anon_sym_groupshared] = ACTIONS(3310),
    [anon_sym_uniform] = ACTIONS(3310),
    [anon_sym_row_major] = ACTIONS(3310),
    [anon_sym_column_major] = ACTIONS(3310),
    [anon_sym_globallycoherent] = ACTIONS(3310),
    [anon_sym_centroid] = ACTIONS(3310),
    [anon_sym_noperspective] = ACTIONS(3310),
    [anon_sym_nointerpolation] = ACTIONS(3310),
    [anon_sym_sample] = ACTIONS(3310),
    [anon_sym_linear] = ACTIONS(3310),
    [anon_sym_snorm] = ACTIONS(3310),
    [anon_sym_unorm] = ACTIONS(3310),
    [anon_sym_point] = ACTIONS(3310),
    [anon_sym_line] = ACTIONS(3310),
    [anon_sym_triangleadj] = ACTIONS(3310),
    [anon_sym_lineadj] = ACTIONS(3310),
    [anon_sym_triangle] = ACTIONS(3310),
    [anon_sym_cbuffer] = ACTIONS(3310),
    [anon_sym_interface] = ACTIONS(3310),
    [anon_sym_extension] = ACTIONS(3310),
  },
  [411] = {
    [sym_identifier] = ACTIONS(3314),
    [aux_sym_preproc_include_token1] = ACTIONS(3314),
    [aux_sym_preproc_def_token1] = ACTIONS(3314),
    [aux_sym_preproc_if_token1] = ACTIONS(3314),
    [aux_sym_preproc_if_token2] = ACTIONS(3314),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3314),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3314),
    [aux_sym_preproc_else_token1] = ACTIONS(3314),
    [aux_sym_preproc_elif_token1] = ACTIONS(3314),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3314),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3314),
    [sym_preproc_directive] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3316),
    [anon_sym_BANG] = ACTIONS(3316),
    [anon_sym_TILDE] = ACTIONS(3316),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_STAR] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_SEMI] = ACTIONS(3316),
    [anon_sym___extension__] = ACTIONS(3314),
    [anon_sym_typedef] = ACTIONS(3314),
    [anon_sym_in] = ACTIONS(3314),
    [anon_sym_out] = ACTIONS(3314),
    [anon_sym_inout] = ACTIONS(3314),
    [anon_sym_extern] = ACTIONS(3314),
    [anon_sym___attribute__] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3316),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3316),
    [anon_sym___declspec] = ACTIONS(3314),
    [anon_sym___based] = ACTIONS(3314),
    [anon_sym___cdecl] = ACTIONS(3314),
    [anon_sym___clrcall] = ACTIONS(3314),
    [anon_sym___stdcall] = ACTIONS(3314),
    [anon_sym___fastcall] = ACTIONS(3314),
    [anon_sym___thiscall] = ACTIONS(3314),
    [anon_sym___vectorcall] = ACTIONS(3314),
    [anon_sym_LBRACE] = ACTIONS(3316),
    [anon_sym_signed] = ACTIONS(3314),
    [anon_sym_unsigned] = ACTIONS(3314),
    [anon_sym_long] = ACTIONS(3314),
    [anon_sym_short] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_static] = ACTIONS(3314),
    [anon_sym_register] = ACTIONS(3314),
    [anon_sym_inline] = ACTIONS(3314),
    [anon_sym___inline] = ACTIONS(3314),
    [anon_sym___inline__] = ACTIONS(3314),
    [anon_sym___forceinline] = ACTIONS(3314),
    [anon_sym_thread_local] = ACTIONS(3314),
    [anon_sym___thread] = ACTIONS(3314),
    [anon_sym_const] = ACTIONS(3314),
    [anon_sym_constexpr] = ACTIONS(3314),
    [anon_sym_volatile] = ACTIONS(3314),
    [anon_sym_restrict] = ACTIONS(3314),
    [anon_sym___restrict__] = ACTIONS(3314),
    [anon_sym__Atomic] = ACTIONS(3314),
    [anon_sym__Noreturn] = ACTIONS(3314),
    [anon_sym_noreturn] = ACTIONS(3314),
    [anon_sym_mutable] = ACTIONS(3314),
    [anon_sym_constinit] = ACTIONS(3314),
    [anon_sym_consteval] = ACTIONS(3314),
    [anon_sym_alignas] = ACTIONS(3314),
    [anon_sym__Alignas] = ACTIONS(3314),
    [sym_primitive_type] = ACTIONS(3314),
    [anon_sym_enum] = ACTIONS(3314),
    [anon_sym_class] = ACTIONS(3314),
    [anon_sym_struct] = ACTIONS(3314),
    [anon_sym_union] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_else] = ACTIONS(3314),
    [anon_sym_switch] = ACTIONS(3314),
    [anon_sym_case] = ACTIONS(3314),
    [anon_sym_default] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_break] = ACTIONS(3314),
    [anon_sym_continue] = ACTIONS(3314),
    [anon_sym_goto] = ACTIONS(3314),
    [anon_sym___try] = ACTIONS(3314),
    [anon_sym___leave] = ACTIONS(3314),
    [anon_sym_not] = ACTIONS(3314),
    [anon_sym_compl] = ACTIONS(3314),
    [anon_sym_DASH_DASH] = ACTIONS(3316),
    [anon_sym_PLUS_PLUS] = ACTIONS(3316),
    [anon_sym_sizeof] = ACTIONS(3314),
    [anon_sym___alignof__] = ACTIONS(3314),
    [anon_sym___alignof] = ACTIONS(3314),
    [anon_sym__alignof] = ACTIONS(3314),
    [anon_sym_alignof] = ACTIONS(3314),
    [anon_sym__Alignof] = ACTIONS(3314),
    [anon_sym_offsetof] = ACTIONS(3314),
    [anon_sym__Generic] = ACTIONS(3314),
    [anon_sym_asm] = ACTIONS(3314),
    [anon_sym___asm__] = ACTIONS(3314),
    [sym_number_literal] = ACTIONS(3316),
    [anon_sym_L_SQUOTE] = ACTIONS(3316),
    [anon_sym_u_SQUOTE] = ACTIONS(3316),
    [anon_sym_U_SQUOTE] = ACTIONS(3316),
    [anon_sym_u8_SQUOTE] = ACTIONS(3316),
    [anon_sym_SQUOTE] = ACTIONS(3316),
    [anon_sym_L_DQUOTE] = ACTIONS(3316),
    [anon_sym_u_DQUOTE] = ACTIONS(3316),
    [anon_sym_U_DQUOTE] = ACTIONS(3316),
    [anon_sym_u8_DQUOTE] = ACTIONS(3316),
    [anon_sym_DQUOTE] = ACTIONS(3316),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [anon_sym_NULL] = ACTIONS(3314),
    [anon_sym_nullptr] = ACTIONS(3314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_This] = ACTIONS(3314),
    [anon_sym_decltype] = ACTIONS(3314),
    [sym_virtual] = ACTIONS(3314),
    [anon_sym_explicit] = ACTIONS(3314),
    [anon_sym_typename] = ACTIONS(3314),
    [anon_sym_template] = ACTIONS(3314),
    [anon_sym_operator] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_delete] = ACTIONS(3314),
    [anon_sym_throw] = ACTIONS(3314),
    [anon_sym_namespace] = ACTIONS(3314),
    [anon_sym_using] = ACTIONS(3314),
    [anon_sym_static_assert] = ACTIONS(3314),
    [anon_sym_concept] = ACTIONS(3314),
    [anon_sym_co_return] = ACTIONS(3314),
    [anon_sym_co_yield] = ACTIONS(3314),
    [anon_sym_R_DQUOTE] = ACTIONS(3316),
    [anon_sym_LR_DQUOTE] = ACTIONS(3316),
    [anon_sym_uR_DQUOTE] = ACTIONS(3316),
    [anon_sym_UR_DQUOTE] = ACTIONS(3316),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3316),
    [anon_sym_co_await] = ACTIONS(3314),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_requires] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [anon_sym_discard] = ACTIONS(3314),
    [anon_sym_precise] = ACTIONS(3314),
    [anon_sym_shared] = ACTIONS(3314),
    [anon_sym_groupshared] = ACTIONS(3314),
    [anon_sym_uniform] = ACTIONS(3314),
    [anon_sym_row_major] = ACTIONS(3314),
    [anon_sym_column_major] = ACTIONS(3314),
    [anon_sym_globallycoherent] = ACTIONS(3314),
    [anon_sym_centroid] = ACTIONS(3314),
    [anon_sym_noperspective] = ACTIONS(3314),
    [anon_sym_nointerpolation] = ACTIONS(3314),
    [anon_sym_sample] = ACTIONS(3314),
    [anon_sym_linear] = ACTIONS(3314),
    [anon_sym_snorm] = ACTIONS(3314),
    [anon_sym_unorm] = ACTIONS(3314),
    [anon_sym_point] = ACTIONS(3314),
    [anon_sym_line] = ACTIONS(3314),
    [anon_sym_triangleadj] = ACTIONS(3314),
    [anon_sym_lineadj] = ACTIONS(3314),
    [anon_sym_triangle] = ACTIONS(3314),
    [anon_sym_cbuffer] = ACTIONS(3314),
    [anon_sym_interface] = ACTIONS(3314),
    [anon_sym_extension] = ACTIONS(3314),
  },
  [412] = {
    [sym_identifier] = ACTIONS(3318),
    [aux_sym_preproc_include_token1] = ACTIONS(3318),
    [aux_sym_preproc_def_token1] = ACTIONS(3318),
    [aux_sym_preproc_if_token1] = ACTIONS(3318),
    [aux_sym_preproc_if_token2] = ACTIONS(3318),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3318),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3318),
    [aux_sym_preproc_else_token1] = ACTIONS(3318),
    [aux_sym_preproc_elif_token1] = ACTIONS(3318),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3318),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3318),
    [sym_preproc_directive] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(3320),
    [anon_sym_BANG] = ACTIONS(3320),
    [anon_sym_TILDE] = ACTIONS(3320),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3320),
    [anon_sym_AMP_AMP] = ACTIONS(3320),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_SEMI] = ACTIONS(3320),
    [anon_sym___extension__] = ACTIONS(3318),
    [anon_sym_typedef] = ACTIONS(3318),
    [anon_sym_in] = ACTIONS(3318),
    [anon_sym_out] = ACTIONS(3318),
    [anon_sym_inout] = ACTIONS(3318),
    [anon_sym_extern] = ACTIONS(3318),
    [anon_sym___attribute__] = ACTIONS(3318),
    [anon_sym_COLON_COLON] = ACTIONS(3320),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3320),
    [anon_sym___declspec] = ACTIONS(3318),
    [anon_sym___based] = ACTIONS(3318),
    [anon_sym___cdecl] = ACTIONS(3318),
    [anon_sym___clrcall] = ACTIONS(3318),
    [anon_sym___stdcall] = ACTIONS(3318),
    [anon_sym___fastcall] = ACTIONS(3318),
    [anon_sym___thiscall] = ACTIONS(3318),
    [anon_sym___vectorcall] = ACTIONS(3318),
    [anon_sym_LBRACE] = ACTIONS(3320),
    [anon_sym_signed] = ACTIONS(3318),
    [anon_sym_unsigned] = ACTIONS(3318),
    [anon_sym_long] = ACTIONS(3318),
    [anon_sym_short] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3318),
    [anon_sym_static] = ACTIONS(3318),
    [anon_sym_register] = ACTIONS(3318),
    [anon_sym_inline] = ACTIONS(3318),
    [anon_sym___inline] = ACTIONS(3318),
    [anon_sym___inline__] = ACTIONS(3318),
    [anon_sym___forceinline] = ACTIONS(3318),
    [anon_sym_thread_local] = ACTIONS(3318),
    [anon_sym___thread] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3318),
    [anon_sym_constexpr] = ACTIONS(3318),
    [anon_sym_volatile] = ACTIONS(3318),
    [anon_sym_restrict] = ACTIONS(3318),
    [anon_sym___restrict__] = ACTIONS(3318),
    [anon_sym__Atomic] = ACTIONS(3318),
    [anon_sym__Noreturn] = ACTIONS(3318),
    [anon_sym_noreturn] = ACTIONS(3318),
    [anon_sym_mutable] = ACTIONS(3318),
    [anon_sym_constinit] = ACTIONS(3318),
    [anon_sym_consteval] = ACTIONS(3318),
    [anon_sym_alignas] = ACTIONS(3318),
    [anon_sym__Alignas] = ACTIONS(3318),
    [sym_primitive_type] = ACTIONS(3318),
    [anon_sym_enum] = ACTIONS(3318),
    [anon_sym_class] = ACTIONS(3318),
    [anon_sym_struct] = ACTIONS(3318),
    [anon_sym_union] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_else] = ACTIONS(3318),
    [anon_sym_switch] = ACTIONS(3318),
    [anon_sym_case] = ACTIONS(3318),
    [anon_sym_default] = ACTIONS(3318),
    [anon_sym_while] = ACTIONS(3318),
    [anon_sym_do] = ACTIONS(3318),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_break] = ACTIONS(3318),
    [anon_sym_continue] = ACTIONS(3318),
    [anon_sym_goto] = ACTIONS(3318),
    [anon_sym___try] = ACTIONS(3318),
    [anon_sym___leave] = ACTIONS(3318),
    [anon_sym_not] = ACTIONS(3318),
    [anon_sym_compl] = ACTIONS(3318),
    [anon_sym_DASH_DASH] = ACTIONS(3320),
    [anon_sym_PLUS_PLUS] = ACTIONS(3320),
    [anon_sym_sizeof] = ACTIONS(3318),
    [anon_sym___alignof__] = ACTIONS(3318),
    [anon_sym___alignof] = ACTIONS(3318),
    [anon_sym__alignof] = ACTIONS(3318),
    [anon_sym_alignof] = ACTIONS(3318),
    [anon_sym__Alignof] = ACTIONS(3318),
    [anon_sym_offsetof] = ACTIONS(3318),
    [anon_sym__Generic] = ACTIONS(3318),
    [anon_sym_asm] = ACTIONS(3318),
    [anon_sym___asm__] = ACTIONS(3318),
    [sym_number_literal] = ACTIONS(3320),
    [anon_sym_L_SQUOTE] = ACTIONS(3320),
    [anon_sym_u_SQUOTE] = ACTIONS(3320),
    [anon_sym_U_SQUOTE] = ACTIONS(3320),
    [anon_sym_u8_SQUOTE] = ACTIONS(3320),
    [anon_sym_SQUOTE] = ACTIONS(3320),
    [anon_sym_L_DQUOTE] = ACTIONS(3320),
    [anon_sym_u_DQUOTE] = ACTIONS(3320),
    [anon_sym_U_DQUOTE] = ACTIONS(3320),
    [anon_sym_u8_DQUOTE] = ACTIONS(3320),
    [anon_sym_DQUOTE] = ACTIONS(3320),
    [sym_true] = ACTIONS(3318),
    [sym_false] = ACTIONS(3318),
    [anon_sym_NULL] = ACTIONS(3318),
    [anon_sym_nullptr] = ACTIONS(3318),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3318),
    [anon_sym_let] = ACTIONS(3318),
    [anon_sym_This] = ACTIONS(3318),
    [anon_sym_decltype] = ACTIONS(3318),
    [sym_virtual] = ACTIONS(3318),
    [anon_sym_explicit] = ACTIONS(3318),
    [anon_sym_typename] = ACTIONS(3318),
    [anon_sym_template] = ACTIONS(3318),
    [anon_sym_operator] = ACTIONS(3318),
    [anon_sym_try] = ACTIONS(3318),
    [anon_sym_delete] = ACTIONS(3318),
    [anon_sym_throw] = ACTIONS(3318),
    [anon_sym_namespace] = ACTIONS(3318),
    [anon_sym_using] = ACTIONS(3318),
    [anon_sym_static_assert] = ACTIONS(3318),
    [anon_sym_concept] = ACTIONS(3318),
    [anon_sym_co_return] = ACTIONS(3318),
    [anon_sym_co_yield] = ACTIONS(3318),
    [anon_sym_R_DQUOTE] = ACTIONS(3320),
    [anon_sym_LR_DQUOTE] = ACTIONS(3320),
    [anon_sym_uR_DQUOTE] = ACTIONS(3320),
    [anon_sym_UR_DQUOTE] = ACTIONS(3320),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3320),
    [anon_sym_co_await] = ACTIONS(3318),
    [anon_sym_new] = ACTIONS(3318),
    [anon_sym_requires] = ACTIONS(3318),
    [sym_this] = ACTIONS(3318),
    [anon_sym_discard] = ACTIONS(3318),
    [anon_sym_precise] = ACTIONS(3318),
    [anon_sym_shared] = ACTIONS(3318),
    [anon_sym_groupshared] = ACTIONS(3318),
    [anon_sym_uniform] = ACTIONS(3318),
    [anon_sym_row_major] = ACTIONS(3318),
    [anon_sym_column_major] = ACTIONS(3318),
    [anon_sym_globallycoherent] = ACTIONS(3318),
    [anon_sym_centroid] = ACTIONS(3318),
    [anon_sym_noperspective] = ACTIONS(3318),
    [anon_sym_nointerpolation] = ACTIONS(3318),
    [anon_sym_sample] = ACTIONS(3318),
    [anon_sym_linear] = ACTIONS(3318),
    [anon_sym_snorm] = ACTIONS(3318),
    [anon_sym_unorm] = ACTIONS(3318),
    [anon_sym_point] = ACTIONS(3318),
    [anon_sym_line] = ACTIONS(3318),
    [anon_sym_triangleadj] = ACTIONS(3318),
    [anon_sym_lineadj] = ACTIONS(3318),
    [anon_sym_triangle] = ACTIONS(3318),
    [anon_sym_cbuffer] = ACTIONS(3318),
    [anon_sym_interface] = ACTIONS(3318),
    [anon_sym_extension] = ACTIONS(3318),
  },
  [413] = {
    [sym_identifier] = ACTIONS(3322),
    [aux_sym_preproc_include_token1] = ACTIONS(3322),
    [aux_sym_preproc_def_token1] = ACTIONS(3322),
    [aux_sym_preproc_if_token1] = ACTIONS(3322),
    [aux_sym_preproc_if_token2] = ACTIONS(3322),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3322),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3322),
    [aux_sym_preproc_else_token1] = ACTIONS(3322),
    [aux_sym_preproc_elif_token1] = ACTIONS(3322),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3322),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3322),
    [sym_preproc_directive] = ACTIONS(3322),
    [anon_sym_LPAREN2] = ACTIONS(3324),
    [anon_sym_BANG] = ACTIONS(3324),
    [anon_sym_TILDE] = ACTIONS(3324),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_STAR] = ACTIONS(3324),
    [anon_sym_AMP_AMP] = ACTIONS(3324),
    [anon_sym_AMP] = ACTIONS(3322),
    [anon_sym_SEMI] = ACTIONS(3324),
    [anon_sym___extension__] = ACTIONS(3322),
    [anon_sym_typedef] = ACTIONS(3322),
    [anon_sym_in] = ACTIONS(3322),
    [anon_sym_out] = ACTIONS(3322),
    [anon_sym_inout] = ACTIONS(3322),
    [anon_sym_extern] = ACTIONS(3322),
    [anon_sym___attribute__] = ACTIONS(3322),
    [anon_sym_COLON_COLON] = ACTIONS(3324),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3324),
    [anon_sym___declspec] = ACTIONS(3322),
    [anon_sym___based] = ACTIONS(3322),
    [anon_sym___cdecl] = ACTIONS(3322),
    [anon_sym___clrcall] = ACTIONS(3322),
    [anon_sym___stdcall] = ACTIONS(3322),
    [anon_sym___fastcall] = ACTIONS(3322),
    [anon_sym___thiscall] = ACTIONS(3322),
    [anon_sym___vectorcall] = ACTIONS(3322),
    [anon_sym_LBRACE] = ACTIONS(3324),
    [anon_sym_signed] = ACTIONS(3322),
    [anon_sym_unsigned] = ACTIONS(3322),
    [anon_sym_long] = ACTIONS(3322),
    [anon_sym_short] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_static] = ACTIONS(3322),
    [anon_sym_register] = ACTIONS(3322),
    [anon_sym_inline] = ACTIONS(3322),
    [anon_sym___inline] = ACTIONS(3322),
    [anon_sym___inline__] = ACTIONS(3322),
    [anon_sym___forceinline] = ACTIONS(3322),
    [anon_sym_thread_local] = ACTIONS(3322),
    [anon_sym___thread] = ACTIONS(3322),
    [anon_sym_const] = ACTIONS(3322),
    [anon_sym_constexpr] = ACTIONS(3322),
    [anon_sym_volatile] = ACTIONS(3322),
    [anon_sym_restrict] = ACTIONS(3322),
    [anon_sym___restrict__] = ACTIONS(3322),
    [anon_sym__Atomic] = ACTIONS(3322),
    [anon_sym__Noreturn] = ACTIONS(3322),
    [anon_sym_noreturn] = ACTIONS(3322),
    [anon_sym_mutable] = ACTIONS(3322),
    [anon_sym_constinit] = ACTIONS(3322),
    [anon_sym_consteval] = ACTIONS(3322),
    [anon_sym_alignas] = ACTIONS(3322),
    [anon_sym__Alignas] = ACTIONS(3322),
    [sym_primitive_type] = ACTIONS(3322),
    [anon_sym_enum] = ACTIONS(3322),
    [anon_sym_class] = ACTIONS(3322),
    [anon_sym_struct] = ACTIONS(3322),
    [anon_sym_union] = ACTIONS(3322),
    [anon_sym_if] = ACTIONS(3322),
    [anon_sym_else] = ACTIONS(3322),
    [anon_sym_switch] = ACTIONS(3322),
    [anon_sym_case] = ACTIONS(3322),
    [anon_sym_default] = ACTIONS(3322),
    [anon_sym_while] = ACTIONS(3322),
    [anon_sym_do] = ACTIONS(3322),
    [anon_sym_for] = ACTIONS(3322),
    [anon_sym_return] = ACTIONS(3322),
    [anon_sym_break] = ACTIONS(3322),
    [anon_sym_continue] = ACTIONS(3322),
    [anon_sym_goto] = ACTIONS(3322),
    [anon_sym___try] = ACTIONS(3322),
    [anon_sym___leave] = ACTIONS(3322),
    [anon_sym_not] = ACTIONS(3322),
    [anon_sym_compl] = ACTIONS(3322),
    [anon_sym_DASH_DASH] = ACTIONS(3324),
    [anon_sym_PLUS_PLUS] = ACTIONS(3324),
    [anon_sym_sizeof] = ACTIONS(3322),
    [anon_sym___alignof__] = ACTIONS(3322),
    [anon_sym___alignof] = ACTIONS(3322),
    [anon_sym__alignof] = ACTIONS(3322),
    [anon_sym_alignof] = ACTIONS(3322),
    [anon_sym__Alignof] = ACTIONS(3322),
    [anon_sym_offsetof] = ACTIONS(3322),
    [anon_sym__Generic] = ACTIONS(3322),
    [anon_sym_asm] = ACTIONS(3322),
    [anon_sym___asm__] = ACTIONS(3322),
    [sym_number_literal] = ACTIONS(3324),
    [anon_sym_L_SQUOTE] = ACTIONS(3324),
    [anon_sym_u_SQUOTE] = ACTIONS(3324),
    [anon_sym_U_SQUOTE] = ACTIONS(3324),
    [anon_sym_u8_SQUOTE] = ACTIONS(3324),
    [anon_sym_SQUOTE] = ACTIONS(3324),
    [anon_sym_L_DQUOTE] = ACTIONS(3324),
    [anon_sym_u_DQUOTE] = ACTIONS(3324),
    [anon_sym_U_DQUOTE] = ACTIONS(3324),
    [anon_sym_u8_DQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE] = ACTIONS(3324),
    [sym_true] = ACTIONS(3322),
    [sym_false] = ACTIONS(3322),
    [anon_sym_NULL] = ACTIONS(3322),
    [anon_sym_nullptr] = ACTIONS(3322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3322),
    [anon_sym_let] = ACTIONS(3322),
    [anon_sym_This] = ACTIONS(3322),
    [anon_sym_decltype] = ACTIONS(3322),
    [sym_virtual] = ACTIONS(3322),
    [anon_sym_explicit] = ACTIONS(3322),
    [anon_sym_typename] = ACTIONS(3322),
    [anon_sym_template] = ACTIONS(3322),
    [anon_sym_operator] = ACTIONS(3322),
    [anon_sym_try] = ACTIONS(3322),
    [anon_sym_delete] = ACTIONS(3322),
    [anon_sym_throw] = ACTIONS(3322),
    [anon_sym_namespace] = ACTIONS(3322),
    [anon_sym_using] = ACTIONS(3322),
    [anon_sym_static_assert] = ACTIONS(3322),
    [anon_sym_concept] = ACTIONS(3322),
    [anon_sym_co_return] = ACTIONS(3322),
    [anon_sym_co_yield] = ACTIONS(3322),
    [anon_sym_R_DQUOTE] = ACTIONS(3324),
    [anon_sym_LR_DQUOTE] = ACTIONS(3324),
    [anon_sym_uR_DQUOTE] = ACTIONS(3324),
    [anon_sym_UR_DQUOTE] = ACTIONS(3324),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3324),
    [anon_sym_co_await] = ACTIONS(3322),
    [anon_sym_new] = ACTIONS(3322),
    [anon_sym_requires] = ACTIONS(3322),
    [sym_this] = ACTIONS(3322),
    [anon_sym_discard] = ACTIONS(3322),
    [anon_sym_precise] = ACTIONS(3322),
    [anon_sym_shared] = ACTIONS(3322),
    [anon_sym_groupshared] = ACTIONS(3322),
    [anon_sym_uniform] = ACTIONS(3322),
    [anon_sym_row_major] = ACTIONS(3322),
    [anon_sym_column_major] = ACTIONS(3322),
    [anon_sym_globallycoherent] = ACTIONS(3322),
    [anon_sym_centroid] = ACTIONS(3322),
    [anon_sym_noperspective] = ACTIONS(3322),
    [anon_sym_nointerpolation] = ACTIONS(3322),
    [anon_sym_sample] = ACTIONS(3322),
    [anon_sym_linear] = ACTIONS(3322),
    [anon_sym_snorm] = ACTIONS(3322),
    [anon_sym_unorm] = ACTIONS(3322),
    [anon_sym_point] = ACTIONS(3322),
    [anon_sym_line] = ACTIONS(3322),
    [anon_sym_triangleadj] = ACTIONS(3322),
    [anon_sym_lineadj] = ACTIONS(3322),
    [anon_sym_triangle] = ACTIONS(3322),
    [anon_sym_cbuffer] = ACTIONS(3322),
    [anon_sym_interface] = ACTIONS(3322),
    [anon_sym_extension] = ACTIONS(3322),
  },
  [414] = {
    [sym_preproc_def] = STATE(415),
    [sym_preproc_function_def] = STATE(415),
    [sym_preproc_call] = STATE(415),
    [sym_preproc_if_in_field_declaration_list] = STATE(415),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(415),
    [sym_type_definition] = STATE(415),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(415),
    [sym_field_declaration] = STATE(415),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(415),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(415),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(415),
    [sym_operator_cast_declaration] = STATE(415),
    [sym_constructor_or_destructor_definition] = STATE(415),
    [sym_constructor_or_destructor_declaration] = STATE(415),
    [sym_friend_declaration] = STATE(415),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(415),
    [sym_alias_declaration] = STATE(415),
    [sym_static_assert_declaration] = STATE(415),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(415),
    [sym_subscript_declaration] = STATE(415),
    [sym_property_declaration] = STATE(415),
    [sym_associatedtype_declaration] = STATE(415),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(415),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3326),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [415] = {
    [sym_preproc_def] = STATE(371),
    [sym_preproc_function_def] = STATE(371),
    [sym_preproc_call] = STATE(371),
    [sym_preproc_if_in_field_declaration_list] = STATE(371),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(371),
    [sym_type_definition] = STATE(371),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(371),
    [sym_field_declaration] = STATE(371),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(371),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(371),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(371),
    [sym_operator_cast_declaration] = STATE(371),
    [sym_constructor_or_destructor_definition] = STATE(371),
    [sym_constructor_or_destructor_declaration] = STATE(371),
    [sym_friend_declaration] = STATE(371),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(371),
    [sym_alias_declaration] = STATE(371),
    [sym_static_assert_declaration] = STATE(371),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(371),
    [sym_subscript_declaration] = STATE(371),
    [sym_property_declaration] = STATE(371),
    [sym_associatedtype_declaration] = STATE(371),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(371),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3328),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [416] = {
    [sym_identifier] = ACTIONS(3330),
    [aux_sym_preproc_include_token1] = ACTIONS(3330),
    [aux_sym_preproc_def_token1] = ACTIONS(3330),
    [aux_sym_preproc_if_token1] = ACTIONS(3330),
    [aux_sym_preproc_if_token2] = ACTIONS(3330),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3330),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3330),
    [aux_sym_preproc_else_token1] = ACTIONS(3330),
    [aux_sym_preproc_elif_token1] = ACTIONS(3330),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3330),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3330),
    [sym_preproc_directive] = ACTIONS(3330),
    [anon_sym_LPAREN2] = ACTIONS(3332),
    [anon_sym_BANG] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3332),
    [anon_sym_DASH] = ACTIONS(3330),
    [anon_sym_PLUS] = ACTIONS(3330),
    [anon_sym_STAR] = ACTIONS(3332),
    [anon_sym_AMP_AMP] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(3330),
    [anon_sym_SEMI] = ACTIONS(3332),
    [anon_sym___extension__] = ACTIONS(3330),
    [anon_sym_typedef] = ACTIONS(3330),
    [anon_sym_in] = ACTIONS(3330),
    [anon_sym_out] = ACTIONS(3330),
    [anon_sym_inout] = ACTIONS(3330),
    [anon_sym_extern] = ACTIONS(3330),
    [anon_sym___attribute__] = ACTIONS(3330),
    [anon_sym_COLON_COLON] = ACTIONS(3332),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3332),
    [anon_sym___declspec] = ACTIONS(3330),
    [anon_sym___based] = ACTIONS(3330),
    [anon_sym___cdecl] = ACTIONS(3330),
    [anon_sym___clrcall] = ACTIONS(3330),
    [anon_sym___stdcall] = ACTIONS(3330),
    [anon_sym___fastcall] = ACTIONS(3330),
    [anon_sym___thiscall] = ACTIONS(3330),
    [anon_sym___vectorcall] = ACTIONS(3330),
    [anon_sym_LBRACE] = ACTIONS(3332),
    [anon_sym_signed] = ACTIONS(3330),
    [anon_sym_unsigned] = ACTIONS(3330),
    [anon_sym_long] = ACTIONS(3330),
    [anon_sym_short] = ACTIONS(3330),
    [anon_sym_LBRACK] = ACTIONS(3330),
    [anon_sym_static] = ACTIONS(3330),
    [anon_sym_register] = ACTIONS(3330),
    [anon_sym_inline] = ACTIONS(3330),
    [anon_sym___inline] = ACTIONS(3330),
    [anon_sym___inline__] = ACTIONS(3330),
    [anon_sym___forceinline] = ACTIONS(3330),
    [anon_sym_thread_local] = ACTIONS(3330),
    [anon_sym___thread] = ACTIONS(3330),
    [anon_sym_const] = ACTIONS(3330),
    [anon_sym_constexpr] = ACTIONS(3330),
    [anon_sym_volatile] = ACTIONS(3330),
    [anon_sym_restrict] = ACTIONS(3330),
    [anon_sym___restrict__] = ACTIONS(3330),
    [anon_sym__Atomic] = ACTIONS(3330),
    [anon_sym__Noreturn] = ACTIONS(3330),
    [anon_sym_noreturn] = ACTIONS(3330),
    [anon_sym_mutable] = ACTIONS(3330),
    [anon_sym_constinit] = ACTIONS(3330),
    [anon_sym_consteval] = ACTIONS(3330),
    [anon_sym_alignas] = ACTIONS(3330),
    [anon_sym__Alignas] = ACTIONS(3330),
    [sym_primitive_type] = ACTIONS(3330),
    [anon_sym_enum] = ACTIONS(3330),
    [anon_sym_class] = ACTIONS(3330),
    [anon_sym_struct] = ACTIONS(3330),
    [anon_sym_union] = ACTIONS(3330),
    [anon_sym_if] = ACTIONS(3330),
    [anon_sym_else] = ACTIONS(3330),
    [anon_sym_switch] = ACTIONS(3330),
    [anon_sym_case] = ACTIONS(3330),
    [anon_sym_default] = ACTIONS(3330),
    [anon_sym_while] = ACTIONS(3330),
    [anon_sym_do] = ACTIONS(3330),
    [anon_sym_for] = ACTIONS(3330),
    [anon_sym_return] = ACTIONS(3330),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_continue] = ACTIONS(3330),
    [anon_sym_goto] = ACTIONS(3330),
    [anon_sym___try] = ACTIONS(3330),
    [anon_sym___leave] = ACTIONS(3330),
    [anon_sym_not] = ACTIONS(3330),
    [anon_sym_compl] = ACTIONS(3330),
    [anon_sym_DASH_DASH] = ACTIONS(3332),
    [anon_sym_PLUS_PLUS] = ACTIONS(3332),
    [anon_sym_sizeof] = ACTIONS(3330),
    [anon_sym___alignof__] = ACTIONS(3330),
    [anon_sym___alignof] = ACTIONS(3330),
    [anon_sym__alignof] = ACTIONS(3330),
    [anon_sym_alignof] = ACTIONS(3330),
    [anon_sym__Alignof] = ACTIONS(3330),
    [anon_sym_offsetof] = ACTIONS(3330),
    [anon_sym__Generic] = ACTIONS(3330),
    [anon_sym_asm] = ACTIONS(3330),
    [anon_sym___asm__] = ACTIONS(3330),
    [sym_number_literal] = ACTIONS(3332),
    [anon_sym_L_SQUOTE] = ACTIONS(3332),
    [anon_sym_u_SQUOTE] = ACTIONS(3332),
    [anon_sym_U_SQUOTE] = ACTIONS(3332),
    [anon_sym_u8_SQUOTE] = ACTIONS(3332),
    [anon_sym_SQUOTE] = ACTIONS(3332),
    [anon_sym_L_DQUOTE] = ACTIONS(3332),
    [anon_sym_u_DQUOTE] = ACTIONS(3332),
    [anon_sym_U_DQUOTE] = ACTIONS(3332),
    [anon_sym_u8_DQUOTE] = ACTIONS(3332),
    [anon_sym_DQUOTE] = ACTIONS(3332),
    [sym_true] = ACTIONS(3330),
    [sym_false] = ACTIONS(3330),
    [anon_sym_NULL] = ACTIONS(3330),
    [anon_sym_nullptr] = ACTIONS(3330),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3330),
    [anon_sym_let] = ACTIONS(3330),
    [anon_sym_This] = ACTIONS(3330),
    [anon_sym_decltype] = ACTIONS(3330),
    [sym_virtual] = ACTIONS(3330),
    [anon_sym_explicit] = ACTIONS(3330),
    [anon_sym_typename] = ACTIONS(3330),
    [anon_sym_template] = ACTIONS(3330),
    [anon_sym_operator] = ACTIONS(3330),
    [anon_sym_try] = ACTIONS(3330),
    [anon_sym_delete] = ACTIONS(3330),
    [anon_sym_throw] = ACTIONS(3330),
    [anon_sym_namespace] = ACTIONS(3330),
    [anon_sym_using] = ACTIONS(3330),
    [anon_sym_static_assert] = ACTIONS(3330),
    [anon_sym_concept] = ACTIONS(3330),
    [anon_sym_co_return] = ACTIONS(3330),
    [anon_sym_co_yield] = ACTIONS(3330),
    [anon_sym_R_DQUOTE] = ACTIONS(3332),
    [anon_sym_LR_DQUOTE] = ACTIONS(3332),
    [anon_sym_uR_DQUOTE] = ACTIONS(3332),
    [anon_sym_UR_DQUOTE] = ACTIONS(3332),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3332),
    [anon_sym_co_await] = ACTIONS(3330),
    [anon_sym_new] = ACTIONS(3330),
    [anon_sym_requires] = ACTIONS(3330),
    [sym_this] = ACTIONS(3330),
    [anon_sym_discard] = ACTIONS(3330),
    [anon_sym_precise] = ACTIONS(3330),
    [anon_sym_shared] = ACTIONS(3330),
    [anon_sym_groupshared] = ACTIONS(3330),
    [anon_sym_uniform] = ACTIONS(3330),
    [anon_sym_row_major] = ACTIONS(3330),
    [anon_sym_column_major] = ACTIONS(3330),
    [anon_sym_globallycoherent] = ACTIONS(3330),
    [anon_sym_centroid] = ACTIONS(3330),
    [anon_sym_noperspective] = ACTIONS(3330),
    [anon_sym_nointerpolation] = ACTIONS(3330),
    [anon_sym_sample] = ACTIONS(3330),
    [anon_sym_linear] = ACTIONS(3330),
    [anon_sym_snorm] = ACTIONS(3330),
    [anon_sym_unorm] = ACTIONS(3330),
    [anon_sym_point] = ACTIONS(3330),
    [anon_sym_line] = ACTIONS(3330),
    [anon_sym_triangleadj] = ACTIONS(3330),
    [anon_sym_lineadj] = ACTIONS(3330),
    [anon_sym_triangle] = ACTIONS(3330),
    [anon_sym_cbuffer] = ACTIONS(3330),
    [anon_sym_interface] = ACTIONS(3330),
    [anon_sym_extension] = ACTIONS(3330),
  },
  [417] = {
    [sym_preproc_def] = STATE(371),
    [sym_preproc_function_def] = STATE(371),
    [sym_preproc_call] = STATE(371),
    [sym_preproc_if_in_field_declaration_list] = STATE(371),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(371),
    [sym_type_definition] = STATE(371),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(371),
    [sym_field_declaration] = STATE(371),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(371),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(371),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(371),
    [sym_operator_cast_declaration] = STATE(371),
    [sym_constructor_or_destructor_definition] = STATE(371),
    [sym_constructor_or_destructor_declaration] = STATE(371),
    [sym_friend_declaration] = STATE(371),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(371),
    [sym_alias_declaration] = STATE(371),
    [sym_static_assert_declaration] = STATE(371),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(371),
    [sym_subscript_declaration] = STATE(371),
    [sym_property_declaration] = STATE(371),
    [sym_associatedtype_declaration] = STATE(371),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(371),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3334),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [418] = {
    [ts_builtin_sym_end] = ACTIONS(3336),
    [sym_identifier] = ACTIONS(3338),
    [aux_sym_preproc_include_token1] = ACTIONS(3338),
    [aux_sym_preproc_def_token1] = ACTIONS(3338),
    [anon_sym_COMMA] = ACTIONS(3336),
    [anon_sym_RPAREN] = ACTIONS(3336),
    [aux_sym_preproc_if_token1] = ACTIONS(3338),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3338),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3338),
    [sym_preproc_directive] = ACTIONS(3338),
    [anon_sym_LPAREN2] = ACTIONS(3336),
    [anon_sym_BANG] = ACTIONS(3336),
    [anon_sym_TILDE] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3338),
    [anon_sym_PLUS] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_AMP] = ACTIONS(3338),
    [anon_sym_SEMI] = ACTIONS(3336),
    [anon_sym___extension__] = ACTIONS(3338),
    [anon_sym_typedef] = ACTIONS(3338),
    [anon_sym_in] = ACTIONS(3338),
    [anon_sym_out] = ACTIONS(3338),
    [anon_sym_inout] = ACTIONS(3338),
    [anon_sym_extern] = ACTIONS(3338),
    [anon_sym___attribute__] = ACTIONS(3338),
    [anon_sym_COLON_COLON] = ACTIONS(3336),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3336),
    [anon_sym___declspec] = ACTIONS(3338),
    [anon_sym___based] = ACTIONS(3338),
    [anon_sym___cdecl] = ACTIONS(3338),
    [anon_sym___clrcall] = ACTIONS(3338),
    [anon_sym___stdcall] = ACTIONS(3338),
    [anon_sym___fastcall] = ACTIONS(3338),
    [anon_sym___thiscall] = ACTIONS(3338),
    [anon_sym___vectorcall] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_signed] = ACTIONS(3338),
    [anon_sym_unsigned] = ACTIONS(3338),
    [anon_sym_long] = ACTIONS(3338),
    [anon_sym_short] = ACTIONS(3338),
    [anon_sym_LBRACK] = ACTIONS(3338),
    [anon_sym_static] = ACTIONS(3338),
    [anon_sym_register] = ACTIONS(3338),
    [anon_sym_inline] = ACTIONS(3338),
    [anon_sym___inline] = ACTIONS(3338),
    [anon_sym___inline__] = ACTIONS(3338),
    [anon_sym___forceinline] = ACTIONS(3338),
    [anon_sym_thread_local] = ACTIONS(3338),
    [anon_sym___thread] = ACTIONS(3338),
    [anon_sym_const] = ACTIONS(3338),
    [anon_sym_constexpr] = ACTIONS(3338),
    [anon_sym_volatile] = ACTIONS(3338),
    [anon_sym_restrict] = ACTIONS(3338),
    [anon_sym___restrict__] = ACTIONS(3338),
    [anon_sym__Atomic] = ACTIONS(3338),
    [anon_sym__Noreturn] = ACTIONS(3338),
    [anon_sym_noreturn] = ACTIONS(3338),
    [anon_sym_mutable] = ACTIONS(3338),
    [anon_sym_constinit] = ACTIONS(3338),
    [anon_sym_consteval] = ACTIONS(3338),
    [anon_sym_alignas] = ACTIONS(3338),
    [anon_sym__Alignas] = ACTIONS(3338),
    [sym_primitive_type] = ACTIONS(3338),
    [anon_sym_enum] = ACTIONS(3338),
    [anon_sym_class] = ACTIONS(3338),
    [anon_sym_struct] = ACTIONS(3338),
    [anon_sym_union] = ACTIONS(3338),
    [anon_sym_if] = ACTIONS(3338),
    [anon_sym_switch] = ACTIONS(3338),
    [anon_sym_case] = ACTIONS(3338),
    [anon_sym_default] = ACTIONS(3338),
    [anon_sym_while] = ACTIONS(3338),
    [anon_sym_do] = ACTIONS(3338),
    [anon_sym_for] = ACTIONS(3338),
    [anon_sym_return] = ACTIONS(3338),
    [anon_sym_break] = ACTIONS(3338),
    [anon_sym_continue] = ACTIONS(3338),
    [anon_sym_goto] = ACTIONS(3338),
    [anon_sym_not] = ACTIONS(3338),
    [anon_sym_compl] = ACTIONS(3338),
    [anon_sym_DASH_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_PLUS] = ACTIONS(3336),
    [anon_sym_sizeof] = ACTIONS(3338),
    [anon_sym___alignof__] = ACTIONS(3338),
    [anon_sym___alignof] = ACTIONS(3338),
    [anon_sym__alignof] = ACTIONS(3338),
    [anon_sym_alignof] = ACTIONS(3338),
    [anon_sym__Alignof] = ACTIONS(3338),
    [anon_sym_offsetof] = ACTIONS(3338),
    [anon_sym__Generic] = ACTIONS(3338),
    [anon_sym_asm] = ACTIONS(3338),
    [anon_sym___asm__] = ACTIONS(3338),
    [anon_sym_DOT] = ACTIONS(3338),
    [sym_number_literal] = ACTIONS(3336),
    [anon_sym_L_SQUOTE] = ACTIONS(3336),
    [anon_sym_u_SQUOTE] = ACTIONS(3336),
    [anon_sym_U_SQUOTE] = ACTIONS(3336),
    [anon_sym_u8_SQUOTE] = ACTIONS(3336),
    [anon_sym_SQUOTE] = ACTIONS(3336),
    [anon_sym_L_DQUOTE] = ACTIONS(3336),
    [anon_sym_u_DQUOTE] = ACTIONS(3336),
    [anon_sym_U_DQUOTE] = ACTIONS(3336),
    [anon_sym_u8_DQUOTE] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(3336),
    [sym_true] = ACTIONS(3338),
    [sym_false] = ACTIONS(3338),
    [anon_sym_NULL] = ACTIONS(3338),
    [anon_sym_nullptr] = ACTIONS(3338),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3338),
    [anon_sym_let] = ACTIONS(3338),
    [anon_sym_This] = ACTIONS(3338),
    [anon_sym_decltype] = ACTIONS(3338),
    [anon_sym_final] = ACTIONS(3338),
    [anon_sym_override] = ACTIONS(3338),
    [sym_virtual] = ACTIONS(3338),
    [anon_sym_explicit] = ACTIONS(3338),
    [anon_sym_typename] = ACTIONS(3338),
    [anon_sym_template] = ACTIONS(3338),
    [anon_sym_GT2] = ACTIONS(3336),
    [anon_sym_operator] = ACTIONS(3338),
    [anon_sym_try] = ACTIONS(3338),
    [anon_sym_delete] = ACTIONS(3338),
    [anon_sym_throw] = ACTIONS(3338),
    [anon_sym_namespace] = ACTIONS(3338),
    [anon_sym_using] = ACTIONS(3338),
    [anon_sym_static_assert] = ACTIONS(3338),
    [anon_sym_concept] = ACTIONS(3338),
    [anon_sym_co_return] = ACTIONS(3338),
    [anon_sym_co_yield] = ACTIONS(3338),
    [anon_sym_R_DQUOTE] = ACTIONS(3336),
    [anon_sym_LR_DQUOTE] = ACTIONS(3336),
    [anon_sym_uR_DQUOTE] = ACTIONS(3336),
    [anon_sym_UR_DQUOTE] = ACTIONS(3336),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3336),
    [anon_sym_co_await] = ACTIONS(3338),
    [anon_sym_new] = ACTIONS(3338),
    [anon_sym_requires] = ACTIONS(3338),
    [sym_this] = ACTIONS(3338),
    [anon_sym_precise] = ACTIONS(3338),
    [anon_sym_shared] = ACTIONS(3338),
    [anon_sym_groupshared] = ACTIONS(3338),
    [anon_sym_uniform] = ACTIONS(3338),
    [anon_sym_row_major] = ACTIONS(3338),
    [anon_sym_column_major] = ACTIONS(3338),
    [anon_sym_globallycoherent] = ACTIONS(3338),
    [anon_sym_centroid] = ACTIONS(3338),
    [anon_sym_noperspective] = ACTIONS(3338),
    [anon_sym_nointerpolation] = ACTIONS(3338),
    [anon_sym_sample] = ACTIONS(3338),
    [anon_sym_linear] = ACTIONS(3338),
    [anon_sym_snorm] = ACTIONS(3338),
    [anon_sym_unorm] = ACTIONS(3338),
    [anon_sym_point] = ACTIONS(3338),
    [anon_sym_line] = ACTIONS(3338),
    [anon_sym_triangleadj] = ACTIONS(3338),
    [anon_sym_lineadj] = ACTIONS(3338),
    [anon_sym_triangle] = ACTIONS(3338),
    [anon_sym_interface] = ACTIONS(3338),
    [anon_sym_extension] = ACTIONS(3338),
    [anon_sym_where] = ACTIONS(3338),
    [anon_sym___exported] = ACTIONS(3338),
    [anon_sym_import] = ACTIONS(3338),
  },
  [419] = {
    [sym_identifier] = ACTIONS(3340),
    [aux_sym_preproc_include_token1] = ACTIONS(3340),
    [aux_sym_preproc_def_token1] = ACTIONS(3340),
    [aux_sym_preproc_if_token1] = ACTIONS(3340),
    [aux_sym_preproc_if_token2] = ACTIONS(3340),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3340),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3340),
    [aux_sym_preproc_else_token1] = ACTIONS(3340),
    [aux_sym_preproc_elif_token1] = ACTIONS(3340),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3340),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3340),
    [sym_preproc_directive] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(3342),
    [anon_sym_BANG] = ACTIONS(3342),
    [anon_sym_TILDE] = ACTIONS(3342),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_STAR] = ACTIONS(3342),
    [anon_sym_AMP_AMP] = ACTIONS(3342),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_SEMI] = ACTIONS(3342),
    [anon_sym___extension__] = ACTIONS(3340),
    [anon_sym_typedef] = ACTIONS(3340),
    [anon_sym_in] = ACTIONS(3340),
    [anon_sym_out] = ACTIONS(3340),
    [anon_sym_inout] = ACTIONS(3340),
    [anon_sym_extern] = ACTIONS(3340),
    [anon_sym___attribute__] = ACTIONS(3340),
    [anon_sym_COLON_COLON] = ACTIONS(3342),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3342),
    [anon_sym___declspec] = ACTIONS(3340),
    [anon_sym___based] = ACTIONS(3340),
    [anon_sym___cdecl] = ACTIONS(3340),
    [anon_sym___clrcall] = ACTIONS(3340),
    [anon_sym___stdcall] = ACTIONS(3340),
    [anon_sym___fastcall] = ACTIONS(3340),
    [anon_sym___thiscall] = ACTIONS(3340),
    [anon_sym___vectorcall] = ACTIONS(3340),
    [anon_sym_LBRACE] = ACTIONS(3342),
    [anon_sym_signed] = ACTIONS(3340),
    [anon_sym_unsigned] = ACTIONS(3340),
    [anon_sym_long] = ACTIONS(3340),
    [anon_sym_short] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3340),
    [anon_sym_static] = ACTIONS(3340),
    [anon_sym_register] = ACTIONS(3340),
    [anon_sym_inline] = ACTIONS(3340),
    [anon_sym___inline] = ACTIONS(3340),
    [anon_sym___inline__] = ACTIONS(3340),
    [anon_sym___forceinline] = ACTIONS(3340),
    [anon_sym_thread_local] = ACTIONS(3340),
    [anon_sym___thread] = ACTIONS(3340),
    [anon_sym_const] = ACTIONS(3340),
    [anon_sym_constexpr] = ACTIONS(3340),
    [anon_sym_volatile] = ACTIONS(3340),
    [anon_sym_restrict] = ACTIONS(3340),
    [anon_sym___restrict__] = ACTIONS(3340),
    [anon_sym__Atomic] = ACTIONS(3340),
    [anon_sym__Noreturn] = ACTIONS(3340),
    [anon_sym_noreturn] = ACTIONS(3340),
    [anon_sym_mutable] = ACTIONS(3340),
    [anon_sym_constinit] = ACTIONS(3340),
    [anon_sym_consteval] = ACTIONS(3340),
    [anon_sym_alignas] = ACTIONS(3340),
    [anon_sym__Alignas] = ACTIONS(3340),
    [sym_primitive_type] = ACTIONS(3340),
    [anon_sym_enum] = ACTIONS(3340),
    [anon_sym_class] = ACTIONS(3340),
    [anon_sym_struct] = ACTIONS(3340),
    [anon_sym_union] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_else] = ACTIONS(3340),
    [anon_sym_switch] = ACTIONS(3340),
    [anon_sym_case] = ACTIONS(3340),
    [anon_sym_default] = ACTIONS(3340),
    [anon_sym_while] = ACTIONS(3340),
    [anon_sym_do] = ACTIONS(3340),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_break] = ACTIONS(3340),
    [anon_sym_continue] = ACTIONS(3340),
    [anon_sym_goto] = ACTIONS(3340),
    [anon_sym___try] = ACTIONS(3340),
    [anon_sym___leave] = ACTIONS(3340),
    [anon_sym_not] = ACTIONS(3340),
    [anon_sym_compl] = ACTIONS(3340),
    [anon_sym_DASH_DASH] = ACTIONS(3342),
    [anon_sym_PLUS_PLUS] = ACTIONS(3342),
    [anon_sym_sizeof] = ACTIONS(3340),
    [anon_sym___alignof__] = ACTIONS(3340),
    [anon_sym___alignof] = ACTIONS(3340),
    [anon_sym__alignof] = ACTIONS(3340),
    [anon_sym_alignof] = ACTIONS(3340),
    [anon_sym__Alignof] = ACTIONS(3340),
    [anon_sym_offsetof] = ACTIONS(3340),
    [anon_sym__Generic] = ACTIONS(3340),
    [anon_sym_asm] = ACTIONS(3340),
    [anon_sym___asm__] = ACTIONS(3340),
    [sym_number_literal] = ACTIONS(3342),
    [anon_sym_L_SQUOTE] = ACTIONS(3342),
    [anon_sym_u_SQUOTE] = ACTIONS(3342),
    [anon_sym_U_SQUOTE] = ACTIONS(3342),
    [anon_sym_u8_SQUOTE] = ACTIONS(3342),
    [anon_sym_SQUOTE] = ACTIONS(3342),
    [anon_sym_L_DQUOTE] = ACTIONS(3342),
    [anon_sym_u_DQUOTE] = ACTIONS(3342),
    [anon_sym_U_DQUOTE] = ACTIONS(3342),
    [anon_sym_u8_DQUOTE] = ACTIONS(3342),
    [anon_sym_DQUOTE] = ACTIONS(3342),
    [sym_true] = ACTIONS(3340),
    [sym_false] = ACTIONS(3340),
    [anon_sym_NULL] = ACTIONS(3340),
    [anon_sym_nullptr] = ACTIONS(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3340),
    [anon_sym_let] = ACTIONS(3340),
    [anon_sym_This] = ACTIONS(3340),
    [anon_sym_decltype] = ACTIONS(3340),
    [sym_virtual] = ACTIONS(3340),
    [anon_sym_explicit] = ACTIONS(3340),
    [anon_sym_typename] = ACTIONS(3340),
    [anon_sym_template] = ACTIONS(3340),
    [anon_sym_operator] = ACTIONS(3340),
    [anon_sym_try] = ACTIONS(3340),
    [anon_sym_delete] = ACTIONS(3340),
    [anon_sym_throw] = ACTIONS(3340),
    [anon_sym_namespace] = ACTIONS(3340),
    [anon_sym_using] = ACTIONS(3340),
    [anon_sym_static_assert] = ACTIONS(3340),
    [anon_sym_concept] = ACTIONS(3340),
    [anon_sym_co_return] = ACTIONS(3340),
    [anon_sym_co_yield] = ACTIONS(3340),
    [anon_sym_R_DQUOTE] = ACTIONS(3342),
    [anon_sym_LR_DQUOTE] = ACTIONS(3342),
    [anon_sym_uR_DQUOTE] = ACTIONS(3342),
    [anon_sym_UR_DQUOTE] = ACTIONS(3342),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3342),
    [anon_sym_co_await] = ACTIONS(3340),
    [anon_sym_new] = ACTIONS(3340),
    [anon_sym_requires] = ACTIONS(3340),
    [sym_this] = ACTIONS(3340),
    [anon_sym_discard] = ACTIONS(3340),
    [anon_sym_precise] = ACTIONS(3340),
    [anon_sym_shared] = ACTIONS(3340),
    [anon_sym_groupshared] = ACTIONS(3340),
    [anon_sym_uniform] = ACTIONS(3340),
    [anon_sym_row_major] = ACTIONS(3340),
    [anon_sym_column_major] = ACTIONS(3340),
    [anon_sym_globallycoherent] = ACTIONS(3340),
    [anon_sym_centroid] = ACTIONS(3340),
    [anon_sym_noperspective] = ACTIONS(3340),
    [anon_sym_nointerpolation] = ACTIONS(3340),
    [anon_sym_sample] = ACTIONS(3340),
    [anon_sym_linear] = ACTIONS(3340),
    [anon_sym_snorm] = ACTIONS(3340),
    [anon_sym_unorm] = ACTIONS(3340),
    [anon_sym_point] = ACTIONS(3340),
    [anon_sym_line] = ACTIONS(3340),
    [anon_sym_triangleadj] = ACTIONS(3340),
    [anon_sym_lineadj] = ACTIONS(3340),
    [anon_sym_triangle] = ACTIONS(3340),
    [anon_sym_cbuffer] = ACTIONS(3340),
    [anon_sym_interface] = ACTIONS(3340),
    [anon_sym_extension] = ACTIONS(3340),
  },
  [420] = {
    [sym_identifier] = ACTIONS(3344),
    [aux_sym_preproc_include_token1] = ACTIONS(3344),
    [aux_sym_preproc_def_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token2] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3344),
    [aux_sym_preproc_else_token1] = ACTIONS(3344),
    [aux_sym_preproc_elif_token1] = ACTIONS(3344),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3344),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3344),
    [sym_preproc_directive] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym___extension__] = ACTIONS(3344),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_in] = ACTIONS(3344),
    [anon_sym_out] = ACTIONS(3344),
    [anon_sym_inout] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym___attribute__] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3346),
    [anon_sym___declspec] = ACTIONS(3344),
    [anon_sym___based] = ACTIONS(3344),
    [anon_sym___cdecl] = ACTIONS(3344),
    [anon_sym___clrcall] = ACTIONS(3344),
    [anon_sym___stdcall] = ACTIONS(3344),
    [anon_sym___fastcall] = ACTIONS(3344),
    [anon_sym___thiscall] = ACTIONS(3344),
    [anon_sym___vectorcall] = ACTIONS(3344),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_signed] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym___inline] = ACTIONS(3344),
    [anon_sym___inline__] = ACTIONS(3344),
    [anon_sym___forceinline] = ACTIONS(3344),
    [anon_sym_thread_local] = ACTIONS(3344),
    [anon_sym___thread] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym___restrict__] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym__Noreturn] = ACTIONS(3344),
    [anon_sym_noreturn] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_constinit] = ACTIONS(3344),
    [anon_sym_consteval] = ACTIONS(3344),
    [anon_sym_alignas] = ACTIONS(3344),
    [anon_sym__Alignas] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_class] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_switch] = ACTIONS(3344),
    [anon_sym_case] = ACTIONS(3344),
    [anon_sym_default] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_break] = ACTIONS(3344),
    [anon_sym_continue] = ACTIONS(3344),
    [anon_sym_goto] = ACTIONS(3344),
    [anon_sym___try] = ACTIONS(3344),
    [anon_sym___leave] = ACTIONS(3344),
    [anon_sym_not] = ACTIONS(3344),
    [anon_sym_compl] = ACTIONS(3344),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_sizeof] = ACTIONS(3344),
    [anon_sym___alignof__] = ACTIONS(3344),
    [anon_sym___alignof] = ACTIONS(3344),
    [anon_sym__alignof] = ACTIONS(3344),
    [anon_sym_alignof] = ACTIONS(3344),
    [anon_sym__Alignof] = ACTIONS(3344),
    [anon_sym_offsetof] = ACTIONS(3344),
    [anon_sym__Generic] = ACTIONS(3344),
    [anon_sym_asm] = ACTIONS(3344),
    [anon_sym___asm__] = ACTIONS(3344),
    [sym_number_literal] = ACTIONS(3346),
    [anon_sym_L_SQUOTE] = ACTIONS(3346),
    [anon_sym_u_SQUOTE] = ACTIONS(3346),
    [anon_sym_U_SQUOTE] = ACTIONS(3346),
    [anon_sym_u8_SQUOTE] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_L_DQUOTE] = ACTIONS(3346),
    [anon_sym_u_DQUOTE] = ACTIONS(3346),
    [anon_sym_U_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8_DQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [sym_true] = ACTIONS(3344),
    [sym_false] = ACTIONS(3344),
    [anon_sym_NULL] = ACTIONS(3344),
    [anon_sym_nullptr] = ACTIONS(3344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_This] = ACTIONS(3344),
    [anon_sym_decltype] = ACTIONS(3344),
    [sym_virtual] = ACTIONS(3344),
    [anon_sym_explicit] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_template] = ACTIONS(3344),
    [anon_sym_operator] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_delete] = ACTIONS(3344),
    [anon_sym_throw] = ACTIONS(3344),
    [anon_sym_namespace] = ACTIONS(3344),
    [anon_sym_using] = ACTIONS(3344),
    [anon_sym_static_assert] = ACTIONS(3344),
    [anon_sym_concept] = ACTIONS(3344),
    [anon_sym_co_return] = ACTIONS(3344),
    [anon_sym_co_yield] = ACTIONS(3344),
    [anon_sym_R_DQUOTE] = ACTIONS(3346),
    [anon_sym_LR_DQUOTE] = ACTIONS(3346),
    [anon_sym_uR_DQUOTE] = ACTIONS(3346),
    [anon_sym_UR_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3346),
    [anon_sym_co_await] = ACTIONS(3344),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_requires] = ACTIONS(3344),
    [sym_this] = ACTIONS(3344),
    [anon_sym_discard] = ACTIONS(3344),
    [anon_sym_precise] = ACTIONS(3344),
    [anon_sym_shared] = ACTIONS(3344),
    [anon_sym_groupshared] = ACTIONS(3344),
    [anon_sym_uniform] = ACTIONS(3344),
    [anon_sym_row_major] = ACTIONS(3344),
    [anon_sym_column_major] = ACTIONS(3344),
    [anon_sym_globallycoherent] = ACTIONS(3344),
    [anon_sym_centroid] = ACTIONS(3344),
    [anon_sym_noperspective] = ACTIONS(3344),
    [anon_sym_nointerpolation] = ACTIONS(3344),
    [anon_sym_sample] = ACTIONS(3344),
    [anon_sym_linear] = ACTIONS(3344),
    [anon_sym_snorm] = ACTIONS(3344),
    [anon_sym_unorm] = ACTIONS(3344),
    [anon_sym_point] = ACTIONS(3344),
    [anon_sym_line] = ACTIONS(3344),
    [anon_sym_triangleadj] = ACTIONS(3344),
    [anon_sym_lineadj] = ACTIONS(3344),
    [anon_sym_triangle] = ACTIONS(3344),
    [anon_sym_cbuffer] = ACTIONS(3344),
    [anon_sym_interface] = ACTIONS(3344),
    [anon_sym_extension] = ACTIONS(3344),
  },
  [421] = {
    [sym_attribute_specifier] = STATE(663),
    [sym_enumerator_list] = STATE(639),
    [sym__enum_base_clause] = STATE(603),
    [sym_identifier] = ACTIONS(3348),
    [aux_sym_preproc_include_token1] = ACTIONS(3348),
    [aux_sym_preproc_def_token1] = ACTIONS(3348),
    [aux_sym_preproc_if_token1] = ACTIONS(3348),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3348),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3348),
    [sym_preproc_directive] = ACTIONS(3348),
    [anon_sym_LPAREN2] = ACTIONS(3350),
    [anon_sym_BANG] = ACTIONS(3350),
    [anon_sym_TILDE] = ACTIONS(3350),
    [anon_sym_DASH] = ACTIONS(3348),
    [anon_sym_PLUS] = ACTIONS(3348),
    [anon_sym_STAR] = ACTIONS(3350),
    [anon_sym_AMP_AMP] = ACTIONS(3350),
    [anon_sym_AMP] = ACTIONS(3348),
    [anon_sym_COLON] = ACTIONS(3064),
    [anon_sym_SEMI] = ACTIONS(3350),
    [anon_sym___extension__] = ACTIONS(3348),
    [anon_sym_typedef] = ACTIONS(3348),
    [anon_sym_in] = ACTIONS(3348),
    [anon_sym_out] = ACTIONS(3348),
    [anon_sym_inout] = ACTIONS(3348),
    [anon_sym_extern] = ACTIONS(3348),
    [anon_sym___attribute__] = ACTIONS(2687),
    [anon_sym_COLON_COLON] = ACTIONS(3350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3350),
    [anon_sym___declspec] = ACTIONS(3348),
    [anon_sym___based] = ACTIONS(3348),
    [anon_sym___cdecl] = ACTIONS(3348),
    [anon_sym___clrcall] = ACTIONS(3348),
    [anon_sym___stdcall] = ACTIONS(3348),
    [anon_sym___fastcall] = ACTIONS(3348),
    [anon_sym___thiscall] = ACTIONS(3348),
    [anon_sym___vectorcall] = ACTIONS(3348),
    [anon_sym_LBRACE] = ACTIONS(3066),
    [anon_sym_RBRACE] = ACTIONS(3350),
    [anon_sym_signed] = ACTIONS(3348),
    [anon_sym_unsigned] = ACTIONS(3348),
    [anon_sym_long] = ACTIONS(3348),
    [anon_sym_short] = ACTIONS(3348),
    [anon_sym_LBRACK] = ACTIONS(3348),
    [anon_sym_static] = ACTIONS(3348),
    [anon_sym_register] = ACTIONS(3348),
    [anon_sym_inline] = ACTIONS(3348),
    [anon_sym___inline] = ACTIONS(3348),
    [anon_sym___inline__] = ACTIONS(3348),
    [anon_sym___forceinline] = ACTIONS(3348),
    [anon_sym_thread_local] = ACTIONS(3348),
    [anon_sym___thread] = ACTIONS(3348),
    [anon_sym_const] = ACTIONS(3348),
    [anon_sym_constexpr] = ACTIONS(3348),
    [anon_sym_volatile] = ACTIONS(3348),
    [anon_sym_restrict] = ACTIONS(3348),
    [anon_sym___restrict__] = ACTIONS(3348),
    [anon_sym__Atomic] = ACTIONS(3348),
    [anon_sym__Noreturn] = ACTIONS(3348),
    [anon_sym_noreturn] = ACTIONS(3348),
    [anon_sym_mutable] = ACTIONS(3348),
    [anon_sym_constinit] = ACTIONS(3348),
    [anon_sym_consteval] = ACTIONS(3348),
    [anon_sym_alignas] = ACTIONS(3348),
    [anon_sym__Alignas] = ACTIONS(3348),
    [sym_primitive_type] = ACTIONS(3348),
    [anon_sym_enum] = ACTIONS(3348),
    [anon_sym_class] = ACTIONS(3348),
    [anon_sym_struct] = ACTIONS(3348),
    [anon_sym_union] = ACTIONS(3348),
    [anon_sym_if] = ACTIONS(3348),
    [anon_sym_switch] = ACTIONS(3348),
    [anon_sym_case] = ACTIONS(3348),
    [anon_sym_default] = ACTIONS(3348),
    [anon_sym_while] = ACTIONS(3348),
    [anon_sym_do] = ACTIONS(3348),
    [anon_sym_for] = ACTIONS(3348),
    [anon_sym_return] = ACTIONS(3348),
    [anon_sym_break] = ACTIONS(3348),
    [anon_sym_continue] = ACTIONS(3348),
    [anon_sym_goto] = ACTIONS(3348),
    [anon_sym___try] = ACTIONS(3348),
    [anon_sym___leave] = ACTIONS(3348),
    [anon_sym_not] = ACTIONS(3348),
    [anon_sym_compl] = ACTIONS(3348),
    [anon_sym_DASH_DASH] = ACTIONS(3350),
    [anon_sym_PLUS_PLUS] = ACTIONS(3350),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(3348),
    [anon_sym___alignof] = ACTIONS(3348),
    [anon_sym__alignof] = ACTIONS(3348),
    [anon_sym_alignof] = ACTIONS(3348),
    [anon_sym__Alignof] = ACTIONS(3348),
    [anon_sym_offsetof] = ACTIONS(3348),
    [anon_sym__Generic] = ACTIONS(3348),
    [anon_sym_asm] = ACTIONS(3348),
    [anon_sym___asm__] = ACTIONS(3348),
    [anon_sym_DOT] = ACTIONS(3348),
    [sym_number_literal] = ACTIONS(3350),
    [anon_sym_L_SQUOTE] = ACTIONS(3350),
    [anon_sym_u_SQUOTE] = ACTIONS(3350),
    [anon_sym_U_SQUOTE] = ACTIONS(3350),
    [anon_sym_u8_SQUOTE] = ACTIONS(3350),
    [anon_sym_SQUOTE] = ACTIONS(3350),
    [anon_sym_L_DQUOTE] = ACTIONS(3350),
    [anon_sym_u_DQUOTE] = ACTIONS(3350),
    [anon_sym_U_DQUOTE] = ACTIONS(3350),
    [anon_sym_u8_DQUOTE] = ACTIONS(3350),
    [anon_sym_DQUOTE] = ACTIONS(3350),
    [sym_true] = ACTIONS(3348),
    [sym_false] = ACTIONS(3348),
    [anon_sym_NULL] = ACTIONS(3348),
    [anon_sym_nullptr] = ACTIONS(3348),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3348),
    [anon_sym_let] = ACTIONS(3348),
    [anon_sym_This] = ACTIONS(3348),
    [anon_sym_decltype] = ACTIONS(3348),
    [sym_virtual] = ACTIONS(3348),
    [anon_sym_explicit] = ACTIONS(3348),
    [anon_sym_typename] = ACTIONS(3348),
    [anon_sym_template] = ACTIONS(3348),
    [anon_sym_operator] = ACTIONS(3348),
    [anon_sym_try] = ACTIONS(3348),
    [anon_sym_delete] = ACTIONS(3348),
    [anon_sym_throw] = ACTIONS(3348),
    [anon_sym_namespace] = ACTIONS(3348),
    [anon_sym_using] = ACTIONS(3348),
    [anon_sym_static_assert] = ACTIONS(3348),
    [anon_sym_concept] = ACTIONS(3348),
    [anon_sym_co_return] = ACTIONS(3348),
    [anon_sym_co_yield] = ACTIONS(3348),
    [anon_sym_R_DQUOTE] = ACTIONS(3350),
    [anon_sym_LR_DQUOTE] = ACTIONS(3350),
    [anon_sym_uR_DQUOTE] = ACTIONS(3350),
    [anon_sym_UR_DQUOTE] = ACTIONS(3350),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3350),
    [anon_sym_co_await] = ACTIONS(3348),
    [anon_sym_new] = ACTIONS(3348),
    [anon_sym_requires] = ACTIONS(3348),
    [sym_this] = ACTIONS(3348),
    [anon_sym_discard] = ACTIONS(3348),
    [anon_sym_precise] = ACTIONS(3348),
    [anon_sym_shared] = ACTIONS(3348),
    [anon_sym_groupshared] = ACTIONS(3348),
    [anon_sym_uniform] = ACTIONS(3348),
    [anon_sym_row_major] = ACTIONS(3348),
    [anon_sym_column_major] = ACTIONS(3348),
    [anon_sym_globallycoherent] = ACTIONS(3348),
    [anon_sym_centroid] = ACTIONS(3348),
    [anon_sym_noperspective] = ACTIONS(3348),
    [anon_sym_nointerpolation] = ACTIONS(3348),
    [anon_sym_sample] = ACTIONS(3348),
    [anon_sym_linear] = ACTIONS(3348),
    [anon_sym_snorm] = ACTIONS(3348),
    [anon_sym_unorm] = ACTIONS(3348),
    [anon_sym_point] = ACTIONS(3348),
    [anon_sym_line] = ACTIONS(3348),
    [anon_sym_triangleadj] = ACTIONS(3348),
    [anon_sym_lineadj] = ACTIONS(3348),
    [anon_sym_triangle] = ACTIONS(3348),
    [anon_sym_cbuffer] = ACTIONS(3348),
    [anon_sym_interface] = ACTIONS(3348),
    [anon_sym_extension] = ACTIONS(3348),
  },
  [422] = {
    [sym_identifier] = ACTIONS(3344),
    [aux_sym_preproc_include_token1] = ACTIONS(3344),
    [aux_sym_preproc_def_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token2] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3344),
    [aux_sym_preproc_else_token1] = ACTIONS(3344),
    [aux_sym_preproc_elif_token1] = ACTIONS(3344),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3344),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3344),
    [sym_preproc_directive] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym___extension__] = ACTIONS(3344),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_in] = ACTIONS(3344),
    [anon_sym_out] = ACTIONS(3344),
    [anon_sym_inout] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym___attribute__] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3346),
    [anon_sym___declspec] = ACTIONS(3344),
    [anon_sym___based] = ACTIONS(3344),
    [anon_sym___cdecl] = ACTIONS(3344),
    [anon_sym___clrcall] = ACTIONS(3344),
    [anon_sym___stdcall] = ACTIONS(3344),
    [anon_sym___fastcall] = ACTIONS(3344),
    [anon_sym___thiscall] = ACTIONS(3344),
    [anon_sym___vectorcall] = ACTIONS(3344),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_signed] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym___inline] = ACTIONS(3344),
    [anon_sym___inline__] = ACTIONS(3344),
    [anon_sym___forceinline] = ACTIONS(3344),
    [anon_sym_thread_local] = ACTIONS(3344),
    [anon_sym___thread] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym___restrict__] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym__Noreturn] = ACTIONS(3344),
    [anon_sym_noreturn] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_constinit] = ACTIONS(3344),
    [anon_sym_consteval] = ACTIONS(3344),
    [anon_sym_alignas] = ACTIONS(3344),
    [anon_sym__Alignas] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_class] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_switch] = ACTIONS(3344),
    [anon_sym_case] = ACTIONS(3344),
    [anon_sym_default] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_break] = ACTIONS(3344),
    [anon_sym_continue] = ACTIONS(3344),
    [anon_sym_goto] = ACTIONS(3344),
    [anon_sym___try] = ACTIONS(3344),
    [anon_sym___leave] = ACTIONS(3344),
    [anon_sym_not] = ACTIONS(3344),
    [anon_sym_compl] = ACTIONS(3344),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_sizeof] = ACTIONS(3344),
    [anon_sym___alignof__] = ACTIONS(3344),
    [anon_sym___alignof] = ACTIONS(3344),
    [anon_sym__alignof] = ACTIONS(3344),
    [anon_sym_alignof] = ACTIONS(3344),
    [anon_sym__Alignof] = ACTIONS(3344),
    [anon_sym_offsetof] = ACTIONS(3344),
    [anon_sym__Generic] = ACTIONS(3344),
    [anon_sym_asm] = ACTIONS(3344),
    [anon_sym___asm__] = ACTIONS(3344),
    [sym_number_literal] = ACTIONS(3346),
    [anon_sym_L_SQUOTE] = ACTIONS(3346),
    [anon_sym_u_SQUOTE] = ACTIONS(3346),
    [anon_sym_U_SQUOTE] = ACTIONS(3346),
    [anon_sym_u8_SQUOTE] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_L_DQUOTE] = ACTIONS(3346),
    [anon_sym_u_DQUOTE] = ACTIONS(3346),
    [anon_sym_U_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8_DQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [sym_true] = ACTIONS(3344),
    [sym_false] = ACTIONS(3344),
    [anon_sym_NULL] = ACTIONS(3344),
    [anon_sym_nullptr] = ACTIONS(3344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_This] = ACTIONS(3344),
    [anon_sym_decltype] = ACTIONS(3344),
    [sym_virtual] = ACTIONS(3344),
    [anon_sym_explicit] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_template] = ACTIONS(3344),
    [anon_sym_operator] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_delete] = ACTIONS(3344),
    [anon_sym_throw] = ACTIONS(3344),
    [anon_sym_namespace] = ACTIONS(3344),
    [anon_sym_using] = ACTIONS(3344),
    [anon_sym_static_assert] = ACTIONS(3344),
    [anon_sym_concept] = ACTIONS(3344),
    [anon_sym_co_return] = ACTIONS(3344),
    [anon_sym_co_yield] = ACTIONS(3344),
    [anon_sym_R_DQUOTE] = ACTIONS(3346),
    [anon_sym_LR_DQUOTE] = ACTIONS(3346),
    [anon_sym_uR_DQUOTE] = ACTIONS(3346),
    [anon_sym_UR_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3346),
    [anon_sym_co_await] = ACTIONS(3344),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_requires] = ACTIONS(3344),
    [sym_this] = ACTIONS(3344),
    [anon_sym_discard] = ACTIONS(3344),
    [anon_sym_precise] = ACTIONS(3344),
    [anon_sym_shared] = ACTIONS(3344),
    [anon_sym_groupshared] = ACTIONS(3344),
    [anon_sym_uniform] = ACTIONS(3344),
    [anon_sym_row_major] = ACTIONS(3344),
    [anon_sym_column_major] = ACTIONS(3344),
    [anon_sym_globallycoherent] = ACTIONS(3344),
    [anon_sym_centroid] = ACTIONS(3344),
    [anon_sym_noperspective] = ACTIONS(3344),
    [anon_sym_nointerpolation] = ACTIONS(3344),
    [anon_sym_sample] = ACTIONS(3344),
    [anon_sym_linear] = ACTIONS(3344),
    [anon_sym_snorm] = ACTIONS(3344),
    [anon_sym_unorm] = ACTIONS(3344),
    [anon_sym_point] = ACTIONS(3344),
    [anon_sym_line] = ACTIONS(3344),
    [anon_sym_triangleadj] = ACTIONS(3344),
    [anon_sym_lineadj] = ACTIONS(3344),
    [anon_sym_triangle] = ACTIONS(3344),
    [anon_sym_cbuffer] = ACTIONS(3344),
    [anon_sym_interface] = ACTIONS(3344),
    [anon_sym_extension] = ACTIONS(3344),
  },
  [423] = {
    [sym_identifier] = ACTIONS(3344),
    [aux_sym_preproc_include_token1] = ACTIONS(3344),
    [aux_sym_preproc_def_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token2] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3344),
    [aux_sym_preproc_else_token1] = ACTIONS(3344),
    [aux_sym_preproc_elif_token1] = ACTIONS(3344),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3344),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3344),
    [sym_preproc_directive] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym___extension__] = ACTIONS(3344),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_in] = ACTIONS(3344),
    [anon_sym_out] = ACTIONS(3344),
    [anon_sym_inout] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym___attribute__] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3346),
    [anon_sym___declspec] = ACTIONS(3344),
    [anon_sym___based] = ACTIONS(3344),
    [anon_sym___cdecl] = ACTIONS(3344),
    [anon_sym___clrcall] = ACTIONS(3344),
    [anon_sym___stdcall] = ACTIONS(3344),
    [anon_sym___fastcall] = ACTIONS(3344),
    [anon_sym___thiscall] = ACTIONS(3344),
    [anon_sym___vectorcall] = ACTIONS(3344),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_signed] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym___inline] = ACTIONS(3344),
    [anon_sym___inline__] = ACTIONS(3344),
    [anon_sym___forceinline] = ACTIONS(3344),
    [anon_sym_thread_local] = ACTIONS(3344),
    [anon_sym___thread] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym___restrict__] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym__Noreturn] = ACTIONS(3344),
    [anon_sym_noreturn] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_constinit] = ACTIONS(3344),
    [anon_sym_consteval] = ACTIONS(3344),
    [anon_sym_alignas] = ACTIONS(3344),
    [anon_sym__Alignas] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_class] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_switch] = ACTIONS(3344),
    [anon_sym_case] = ACTIONS(3344),
    [anon_sym_default] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_break] = ACTIONS(3344),
    [anon_sym_continue] = ACTIONS(3344),
    [anon_sym_goto] = ACTIONS(3344),
    [anon_sym___try] = ACTIONS(3344),
    [anon_sym___leave] = ACTIONS(3344),
    [anon_sym_not] = ACTIONS(3344),
    [anon_sym_compl] = ACTIONS(3344),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_sizeof] = ACTIONS(3344),
    [anon_sym___alignof__] = ACTIONS(3344),
    [anon_sym___alignof] = ACTIONS(3344),
    [anon_sym__alignof] = ACTIONS(3344),
    [anon_sym_alignof] = ACTIONS(3344),
    [anon_sym__Alignof] = ACTIONS(3344),
    [anon_sym_offsetof] = ACTIONS(3344),
    [anon_sym__Generic] = ACTIONS(3344),
    [anon_sym_asm] = ACTIONS(3344),
    [anon_sym___asm__] = ACTIONS(3344),
    [sym_number_literal] = ACTIONS(3346),
    [anon_sym_L_SQUOTE] = ACTIONS(3346),
    [anon_sym_u_SQUOTE] = ACTIONS(3346),
    [anon_sym_U_SQUOTE] = ACTIONS(3346),
    [anon_sym_u8_SQUOTE] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_L_DQUOTE] = ACTIONS(3346),
    [anon_sym_u_DQUOTE] = ACTIONS(3346),
    [anon_sym_U_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8_DQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [sym_true] = ACTIONS(3344),
    [sym_false] = ACTIONS(3344),
    [anon_sym_NULL] = ACTIONS(3344),
    [anon_sym_nullptr] = ACTIONS(3344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_This] = ACTIONS(3344),
    [anon_sym_decltype] = ACTIONS(3344),
    [sym_virtual] = ACTIONS(3344),
    [anon_sym_explicit] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_template] = ACTIONS(3344),
    [anon_sym_operator] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_delete] = ACTIONS(3344),
    [anon_sym_throw] = ACTIONS(3344),
    [anon_sym_namespace] = ACTIONS(3344),
    [anon_sym_using] = ACTIONS(3344),
    [anon_sym_static_assert] = ACTIONS(3344),
    [anon_sym_concept] = ACTIONS(3344),
    [anon_sym_co_return] = ACTIONS(3344),
    [anon_sym_co_yield] = ACTIONS(3344),
    [anon_sym_R_DQUOTE] = ACTIONS(3346),
    [anon_sym_LR_DQUOTE] = ACTIONS(3346),
    [anon_sym_uR_DQUOTE] = ACTIONS(3346),
    [anon_sym_UR_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3346),
    [anon_sym_co_await] = ACTIONS(3344),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_requires] = ACTIONS(3344),
    [sym_this] = ACTIONS(3344),
    [anon_sym_discard] = ACTIONS(3344),
    [anon_sym_precise] = ACTIONS(3344),
    [anon_sym_shared] = ACTIONS(3344),
    [anon_sym_groupshared] = ACTIONS(3344),
    [anon_sym_uniform] = ACTIONS(3344),
    [anon_sym_row_major] = ACTIONS(3344),
    [anon_sym_column_major] = ACTIONS(3344),
    [anon_sym_globallycoherent] = ACTIONS(3344),
    [anon_sym_centroid] = ACTIONS(3344),
    [anon_sym_noperspective] = ACTIONS(3344),
    [anon_sym_nointerpolation] = ACTIONS(3344),
    [anon_sym_sample] = ACTIONS(3344),
    [anon_sym_linear] = ACTIONS(3344),
    [anon_sym_snorm] = ACTIONS(3344),
    [anon_sym_unorm] = ACTIONS(3344),
    [anon_sym_point] = ACTIONS(3344),
    [anon_sym_line] = ACTIONS(3344),
    [anon_sym_triangleadj] = ACTIONS(3344),
    [anon_sym_lineadj] = ACTIONS(3344),
    [anon_sym_triangle] = ACTIONS(3344),
    [anon_sym_cbuffer] = ACTIONS(3344),
    [anon_sym_interface] = ACTIONS(3344),
    [anon_sym_extension] = ACTIONS(3344),
  },
  [424] = {
    [sym_preproc_def] = STATE(425),
    [sym_preproc_function_def] = STATE(425),
    [sym_preproc_call] = STATE(425),
    [sym_preproc_if_in_field_declaration_list] = STATE(425),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(425),
    [sym_type_definition] = STATE(425),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(425),
    [sym_field_declaration] = STATE(425),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(425),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(425),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(425),
    [sym_operator_cast_declaration] = STATE(425),
    [sym_constructor_or_destructor_definition] = STATE(425),
    [sym_constructor_or_destructor_declaration] = STATE(425),
    [sym_friend_declaration] = STATE(425),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(425),
    [sym_alias_declaration] = STATE(425),
    [sym_static_assert_declaration] = STATE(425),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(425),
    [sym_subscript_declaration] = STATE(425),
    [sym_property_declaration] = STATE(425),
    [sym_associatedtype_declaration] = STATE(425),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(425),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3352),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [425] = {
    [sym_preproc_def] = STATE(371),
    [sym_preproc_function_def] = STATE(371),
    [sym_preproc_call] = STATE(371),
    [sym_preproc_if_in_field_declaration_list] = STATE(371),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(371),
    [sym_type_definition] = STATE(371),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(371),
    [sym_field_declaration] = STATE(371),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(371),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(371),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(371),
    [sym_operator_cast_declaration] = STATE(371),
    [sym_constructor_or_destructor_definition] = STATE(371),
    [sym_constructor_or_destructor_declaration] = STATE(371),
    [sym_friend_declaration] = STATE(371),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(371),
    [sym_alias_declaration] = STATE(371),
    [sym_static_assert_declaration] = STATE(371),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(371),
    [sym_subscript_declaration] = STATE(371),
    [sym_property_declaration] = STATE(371),
    [sym_associatedtype_declaration] = STATE(371),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(371),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3354),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [426] = {
    [ts_builtin_sym_end] = ACTIONS(3356),
    [sym_identifier] = ACTIONS(3358),
    [aux_sym_preproc_include_token1] = ACTIONS(3358),
    [aux_sym_preproc_def_token1] = ACTIONS(3358),
    [anon_sym_COMMA] = ACTIONS(3356),
    [anon_sym_RPAREN] = ACTIONS(3356),
    [aux_sym_preproc_if_token1] = ACTIONS(3358),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3358),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3358),
    [sym_preproc_directive] = ACTIONS(3358),
    [anon_sym_LPAREN2] = ACTIONS(3356),
    [anon_sym_BANG] = ACTIONS(3356),
    [anon_sym_TILDE] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3358),
    [anon_sym_PLUS] = ACTIONS(3358),
    [anon_sym_STAR] = ACTIONS(3356),
    [anon_sym_AMP_AMP] = ACTIONS(3356),
    [anon_sym_AMP] = ACTIONS(3358),
    [anon_sym_SEMI] = ACTIONS(3356),
    [anon_sym___extension__] = ACTIONS(3358),
    [anon_sym_typedef] = ACTIONS(3358),
    [anon_sym_in] = ACTIONS(3358),
    [anon_sym_out] = ACTIONS(3358),
    [anon_sym_inout] = ACTIONS(3358),
    [anon_sym_extern] = ACTIONS(3358),
    [anon_sym___attribute__] = ACTIONS(3358),
    [anon_sym_COLON_COLON] = ACTIONS(3356),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3356),
    [anon_sym___declspec] = ACTIONS(3358),
    [anon_sym___based] = ACTIONS(3358),
    [anon_sym___cdecl] = ACTIONS(3358),
    [anon_sym___clrcall] = ACTIONS(3358),
    [anon_sym___stdcall] = ACTIONS(3358),
    [anon_sym___fastcall] = ACTIONS(3358),
    [anon_sym___thiscall] = ACTIONS(3358),
    [anon_sym___vectorcall] = ACTIONS(3358),
    [anon_sym_LBRACE] = ACTIONS(3356),
    [anon_sym_signed] = ACTIONS(3358),
    [anon_sym_unsigned] = ACTIONS(3358),
    [anon_sym_long] = ACTIONS(3358),
    [anon_sym_short] = ACTIONS(3358),
    [anon_sym_LBRACK] = ACTIONS(3358),
    [anon_sym_static] = ACTIONS(3358),
    [anon_sym_register] = ACTIONS(3358),
    [anon_sym_inline] = ACTIONS(3358),
    [anon_sym___inline] = ACTIONS(3358),
    [anon_sym___inline__] = ACTIONS(3358),
    [anon_sym___forceinline] = ACTIONS(3358),
    [anon_sym_thread_local] = ACTIONS(3358),
    [anon_sym___thread] = ACTIONS(3358),
    [anon_sym_const] = ACTIONS(3358),
    [anon_sym_constexpr] = ACTIONS(3358),
    [anon_sym_volatile] = ACTIONS(3358),
    [anon_sym_restrict] = ACTIONS(3358),
    [anon_sym___restrict__] = ACTIONS(3358),
    [anon_sym__Atomic] = ACTIONS(3358),
    [anon_sym__Noreturn] = ACTIONS(3358),
    [anon_sym_noreturn] = ACTIONS(3358),
    [anon_sym_mutable] = ACTIONS(3358),
    [anon_sym_constinit] = ACTIONS(3358),
    [anon_sym_consteval] = ACTIONS(3358),
    [anon_sym_alignas] = ACTIONS(3358),
    [anon_sym__Alignas] = ACTIONS(3358),
    [sym_primitive_type] = ACTIONS(3358),
    [anon_sym_enum] = ACTIONS(3358),
    [anon_sym_class] = ACTIONS(3358),
    [anon_sym_struct] = ACTIONS(3358),
    [anon_sym_union] = ACTIONS(3358),
    [anon_sym_if] = ACTIONS(3358),
    [anon_sym_switch] = ACTIONS(3358),
    [anon_sym_case] = ACTIONS(3358),
    [anon_sym_default] = ACTIONS(3358),
    [anon_sym_while] = ACTIONS(3358),
    [anon_sym_do] = ACTIONS(3358),
    [anon_sym_for] = ACTIONS(3358),
    [anon_sym_return] = ACTIONS(3358),
    [anon_sym_break] = ACTIONS(3358),
    [anon_sym_continue] = ACTIONS(3358),
    [anon_sym_goto] = ACTIONS(3358),
    [anon_sym_not] = ACTIONS(3358),
    [anon_sym_compl] = ACTIONS(3358),
    [anon_sym_DASH_DASH] = ACTIONS(3356),
    [anon_sym_PLUS_PLUS] = ACTIONS(3356),
    [anon_sym_sizeof] = ACTIONS(3358),
    [anon_sym___alignof__] = ACTIONS(3358),
    [anon_sym___alignof] = ACTIONS(3358),
    [anon_sym__alignof] = ACTIONS(3358),
    [anon_sym_alignof] = ACTIONS(3358),
    [anon_sym__Alignof] = ACTIONS(3358),
    [anon_sym_offsetof] = ACTIONS(3358),
    [anon_sym__Generic] = ACTIONS(3358),
    [anon_sym_asm] = ACTIONS(3358),
    [anon_sym___asm__] = ACTIONS(3358),
    [anon_sym_DOT] = ACTIONS(3358),
    [sym_number_literal] = ACTIONS(3356),
    [anon_sym_L_SQUOTE] = ACTIONS(3356),
    [anon_sym_u_SQUOTE] = ACTIONS(3356),
    [anon_sym_U_SQUOTE] = ACTIONS(3356),
    [anon_sym_u8_SQUOTE] = ACTIONS(3356),
    [anon_sym_SQUOTE] = ACTIONS(3356),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(3358),
    [sym_false] = ACTIONS(3358),
    [anon_sym_NULL] = ACTIONS(3358),
    [anon_sym_nullptr] = ACTIONS(3358),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3358),
    [anon_sym_let] = ACTIONS(3358),
    [anon_sym_This] = ACTIONS(3358),
    [anon_sym_decltype] = ACTIONS(3358),
    [anon_sym_final] = ACTIONS(3358),
    [anon_sym_override] = ACTIONS(3358),
    [sym_virtual] = ACTIONS(3358),
    [anon_sym_explicit] = ACTIONS(3358),
    [anon_sym_typename] = ACTIONS(3358),
    [anon_sym_template] = ACTIONS(3358),
    [anon_sym_GT2] = ACTIONS(3356),
    [anon_sym_operator] = ACTIONS(3358),
    [anon_sym_try] = ACTIONS(3358),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_throw] = ACTIONS(3358),
    [anon_sym_namespace] = ACTIONS(3358),
    [anon_sym_using] = ACTIONS(3358),
    [anon_sym_static_assert] = ACTIONS(3358),
    [anon_sym_concept] = ACTIONS(3358),
    [anon_sym_co_return] = ACTIONS(3358),
    [anon_sym_co_yield] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3356),
    [anon_sym_LR_DQUOTE] = ACTIONS(3356),
    [anon_sym_uR_DQUOTE] = ACTIONS(3356),
    [anon_sym_UR_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3356),
    [anon_sym_co_await] = ACTIONS(3358),
    [anon_sym_new] = ACTIONS(3358),
    [anon_sym_requires] = ACTIONS(3358),
    [sym_this] = ACTIONS(3358),
    [anon_sym_precise] = ACTIONS(3358),
    [anon_sym_shared] = ACTIONS(3358),
    [anon_sym_groupshared] = ACTIONS(3358),
    [anon_sym_uniform] = ACTIONS(3358),
    [anon_sym_row_major] = ACTIONS(3358),
    [anon_sym_column_major] = ACTIONS(3358),
    [anon_sym_globallycoherent] = ACTIONS(3358),
    [anon_sym_centroid] = ACTIONS(3358),
    [anon_sym_noperspective] = ACTIONS(3358),
    [anon_sym_nointerpolation] = ACTIONS(3358),
    [anon_sym_sample] = ACTIONS(3358),
    [anon_sym_linear] = ACTIONS(3358),
    [anon_sym_snorm] = ACTIONS(3358),
    [anon_sym_unorm] = ACTIONS(3358),
    [anon_sym_point] = ACTIONS(3358),
    [anon_sym_line] = ACTIONS(3358),
    [anon_sym_triangleadj] = ACTIONS(3358),
    [anon_sym_lineadj] = ACTIONS(3358),
    [anon_sym_triangle] = ACTIONS(3358),
    [anon_sym_interface] = ACTIONS(3358),
    [anon_sym_extension] = ACTIONS(3358),
    [anon_sym_where] = ACTIONS(3358),
    [anon_sym___exported] = ACTIONS(3358),
    [anon_sym_import] = ACTIONS(3358),
  },
  [427] = {
    [ts_builtin_sym_end] = ACTIONS(3360),
    [sym_identifier] = ACTIONS(3362),
    [aux_sym_preproc_include_token1] = ACTIONS(3362),
    [aux_sym_preproc_def_token1] = ACTIONS(3362),
    [anon_sym_COMMA] = ACTIONS(3360),
    [anon_sym_RPAREN] = ACTIONS(3360),
    [aux_sym_preproc_if_token1] = ACTIONS(3362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3362),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3362),
    [sym_preproc_directive] = ACTIONS(3362),
    [anon_sym_LPAREN2] = ACTIONS(3360),
    [anon_sym_BANG] = ACTIONS(3360),
    [anon_sym_TILDE] = ACTIONS(3360),
    [anon_sym_DASH] = ACTIONS(3362),
    [anon_sym_PLUS] = ACTIONS(3362),
    [anon_sym_STAR] = ACTIONS(3360),
    [anon_sym_AMP_AMP] = ACTIONS(3360),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_SEMI] = ACTIONS(3360),
    [anon_sym___extension__] = ACTIONS(3362),
    [anon_sym_typedef] = ACTIONS(3362),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3360),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3360),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym___based] = ACTIONS(3362),
    [anon_sym___cdecl] = ACTIONS(3362),
    [anon_sym___clrcall] = ACTIONS(3362),
    [anon_sym___stdcall] = ACTIONS(3362),
    [anon_sym___fastcall] = ACTIONS(3362),
    [anon_sym___thiscall] = ACTIONS(3362),
    [anon_sym___vectorcall] = ACTIONS(3362),
    [anon_sym_LBRACE] = ACTIONS(3360),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(3362),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3362),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [anon_sym_if] = ACTIONS(3362),
    [anon_sym_switch] = ACTIONS(3362),
    [anon_sym_case] = ACTIONS(3362),
    [anon_sym_default] = ACTIONS(3362),
    [anon_sym_while] = ACTIONS(3362),
    [anon_sym_do] = ACTIONS(3362),
    [anon_sym_for] = ACTIONS(3362),
    [anon_sym_return] = ACTIONS(3362),
    [anon_sym_break] = ACTIONS(3362),
    [anon_sym_continue] = ACTIONS(3362),
    [anon_sym_goto] = ACTIONS(3362),
    [anon_sym_not] = ACTIONS(3362),
    [anon_sym_compl] = ACTIONS(3362),
    [anon_sym_DASH_DASH] = ACTIONS(3360),
    [anon_sym_PLUS_PLUS] = ACTIONS(3360),
    [anon_sym_sizeof] = ACTIONS(3362),
    [anon_sym___alignof__] = ACTIONS(3362),
    [anon_sym___alignof] = ACTIONS(3362),
    [anon_sym__alignof] = ACTIONS(3362),
    [anon_sym_alignof] = ACTIONS(3362),
    [anon_sym__Alignof] = ACTIONS(3362),
    [anon_sym_offsetof] = ACTIONS(3362),
    [anon_sym__Generic] = ACTIONS(3362),
    [anon_sym_asm] = ACTIONS(3362),
    [anon_sym___asm__] = ACTIONS(3362),
    [anon_sym_DOT] = ACTIONS(3362),
    [sym_number_literal] = ACTIONS(3360),
    [anon_sym_L_SQUOTE] = ACTIONS(3360),
    [anon_sym_u_SQUOTE] = ACTIONS(3360),
    [anon_sym_U_SQUOTE] = ACTIONS(3360),
    [anon_sym_u8_SQUOTE] = ACTIONS(3360),
    [anon_sym_SQUOTE] = ACTIONS(3360),
    [anon_sym_L_DQUOTE] = ACTIONS(3360),
    [anon_sym_u_DQUOTE] = ACTIONS(3360),
    [anon_sym_U_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8_DQUOTE] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(3360),
    [sym_true] = ACTIONS(3362),
    [sym_false] = ACTIONS(3362),
    [anon_sym_NULL] = ACTIONS(3362),
    [anon_sym_nullptr] = ACTIONS(3362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3362),
    [anon_sym_final] = ACTIONS(3362),
    [anon_sym_override] = ACTIONS(3362),
    [sym_virtual] = ACTIONS(3362),
    [anon_sym_explicit] = ACTIONS(3362),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3362),
    [anon_sym_GT2] = ACTIONS(3360),
    [anon_sym_operator] = ACTIONS(3362),
    [anon_sym_try] = ACTIONS(3362),
    [anon_sym_delete] = ACTIONS(3362),
    [anon_sym_throw] = ACTIONS(3362),
    [anon_sym_namespace] = ACTIONS(3362),
    [anon_sym_using] = ACTIONS(3362),
    [anon_sym_static_assert] = ACTIONS(3362),
    [anon_sym_concept] = ACTIONS(3362),
    [anon_sym_co_return] = ACTIONS(3362),
    [anon_sym_co_yield] = ACTIONS(3362),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(3362),
    [anon_sym_requires] = ACTIONS(3362),
    [sym_this] = ACTIONS(3362),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
    [anon_sym_where] = ACTIONS(3362),
    [anon_sym___exported] = ACTIONS(3362),
    [anon_sym_import] = ACTIONS(3362),
  },
  [428] = {
    [ts_builtin_sym_end] = ACTIONS(3364),
    [sym_identifier] = ACTIONS(3366),
    [aux_sym_preproc_include_token1] = ACTIONS(3366),
    [aux_sym_preproc_def_token1] = ACTIONS(3366),
    [anon_sym_COMMA] = ACTIONS(3364),
    [anon_sym_RPAREN] = ACTIONS(3364),
    [aux_sym_preproc_if_token1] = ACTIONS(3366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3366),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3366),
    [sym_preproc_directive] = ACTIONS(3366),
    [anon_sym_LPAREN2] = ACTIONS(3364),
    [anon_sym_BANG] = ACTIONS(3364),
    [anon_sym_TILDE] = ACTIONS(3364),
    [anon_sym_DASH] = ACTIONS(3366),
    [anon_sym_PLUS] = ACTIONS(3366),
    [anon_sym_STAR] = ACTIONS(3364),
    [anon_sym_AMP_AMP] = ACTIONS(3364),
    [anon_sym_AMP] = ACTIONS(3366),
    [anon_sym_SEMI] = ACTIONS(3364),
    [anon_sym___extension__] = ACTIONS(3366),
    [anon_sym_typedef] = ACTIONS(3366),
    [anon_sym_in] = ACTIONS(3366),
    [anon_sym_out] = ACTIONS(3366),
    [anon_sym_inout] = ACTIONS(3366),
    [anon_sym_extern] = ACTIONS(3366),
    [anon_sym___attribute__] = ACTIONS(3366),
    [anon_sym_COLON_COLON] = ACTIONS(3364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3364),
    [anon_sym___declspec] = ACTIONS(3366),
    [anon_sym___based] = ACTIONS(3366),
    [anon_sym___cdecl] = ACTIONS(3366),
    [anon_sym___clrcall] = ACTIONS(3366),
    [anon_sym___stdcall] = ACTIONS(3366),
    [anon_sym___fastcall] = ACTIONS(3366),
    [anon_sym___thiscall] = ACTIONS(3366),
    [anon_sym___vectorcall] = ACTIONS(3366),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_signed] = ACTIONS(3366),
    [anon_sym_unsigned] = ACTIONS(3366),
    [anon_sym_long] = ACTIONS(3366),
    [anon_sym_short] = ACTIONS(3366),
    [anon_sym_LBRACK] = ACTIONS(3366),
    [anon_sym_static] = ACTIONS(3366),
    [anon_sym_register] = ACTIONS(3366),
    [anon_sym_inline] = ACTIONS(3366),
    [anon_sym___inline] = ACTIONS(3366),
    [anon_sym___inline__] = ACTIONS(3366),
    [anon_sym___forceinline] = ACTIONS(3366),
    [anon_sym_thread_local] = ACTIONS(3366),
    [anon_sym___thread] = ACTIONS(3366),
    [anon_sym_const] = ACTIONS(3366),
    [anon_sym_constexpr] = ACTIONS(3366),
    [anon_sym_volatile] = ACTIONS(3366),
    [anon_sym_restrict] = ACTIONS(3366),
    [anon_sym___restrict__] = ACTIONS(3366),
    [anon_sym__Atomic] = ACTIONS(3366),
    [anon_sym__Noreturn] = ACTIONS(3366),
    [anon_sym_noreturn] = ACTIONS(3366),
    [anon_sym_mutable] = ACTIONS(3366),
    [anon_sym_constinit] = ACTIONS(3366),
    [anon_sym_consteval] = ACTIONS(3366),
    [anon_sym_alignas] = ACTIONS(3366),
    [anon_sym__Alignas] = ACTIONS(3366),
    [sym_primitive_type] = ACTIONS(3366),
    [anon_sym_enum] = ACTIONS(3366),
    [anon_sym_class] = ACTIONS(3366),
    [anon_sym_struct] = ACTIONS(3366),
    [anon_sym_union] = ACTIONS(3366),
    [anon_sym_if] = ACTIONS(3366),
    [anon_sym_switch] = ACTIONS(3366),
    [anon_sym_case] = ACTIONS(3366),
    [anon_sym_default] = ACTIONS(3366),
    [anon_sym_while] = ACTIONS(3366),
    [anon_sym_do] = ACTIONS(3366),
    [anon_sym_for] = ACTIONS(3366),
    [anon_sym_return] = ACTIONS(3366),
    [anon_sym_break] = ACTIONS(3366),
    [anon_sym_continue] = ACTIONS(3366),
    [anon_sym_goto] = ACTIONS(3366),
    [anon_sym_not] = ACTIONS(3366),
    [anon_sym_compl] = ACTIONS(3366),
    [anon_sym_DASH_DASH] = ACTIONS(3364),
    [anon_sym_PLUS_PLUS] = ACTIONS(3364),
    [anon_sym_sizeof] = ACTIONS(3366),
    [anon_sym___alignof__] = ACTIONS(3366),
    [anon_sym___alignof] = ACTIONS(3366),
    [anon_sym__alignof] = ACTIONS(3366),
    [anon_sym_alignof] = ACTIONS(3366),
    [anon_sym__Alignof] = ACTIONS(3366),
    [anon_sym_offsetof] = ACTIONS(3366),
    [anon_sym__Generic] = ACTIONS(3366),
    [anon_sym_asm] = ACTIONS(3366),
    [anon_sym___asm__] = ACTIONS(3366),
    [anon_sym_DOT] = ACTIONS(3366),
    [sym_number_literal] = ACTIONS(3364),
    [anon_sym_L_SQUOTE] = ACTIONS(3364),
    [anon_sym_u_SQUOTE] = ACTIONS(3364),
    [anon_sym_U_SQUOTE] = ACTIONS(3364),
    [anon_sym_u8_SQUOTE] = ACTIONS(3364),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym_L_DQUOTE] = ACTIONS(3364),
    [anon_sym_u_DQUOTE] = ACTIONS(3364),
    [anon_sym_U_DQUOTE] = ACTIONS(3364),
    [anon_sym_u8_DQUOTE] = ACTIONS(3364),
    [anon_sym_DQUOTE] = ACTIONS(3364),
    [sym_true] = ACTIONS(3366),
    [sym_false] = ACTIONS(3366),
    [anon_sym_NULL] = ACTIONS(3366),
    [anon_sym_nullptr] = ACTIONS(3366),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3366),
    [anon_sym_let] = ACTIONS(3366),
    [anon_sym_This] = ACTIONS(3366),
    [anon_sym_decltype] = ACTIONS(3366),
    [anon_sym_final] = ACTIONS(3366),
    [anon_sym_override] = ACTIONS(3366),
    [sym_virtual] = ACTIONS(3366),
    [anon_sym_explicit] = ACTIONS(3366),
    [anon_sym_typename] = ACTIONS(3366),
    [anon_sym_template] = ACTIONS(3366),
    [anon_sym_GT2] = ACTIONS(3364),
    [anon_sym_operator] = ACTIONS(3366),
    [anon_sym_try] = ACTIONS(3366),
    [anon_sym_delete] = ACTIONS(3366),
    [anon_sym_throw] = ACTIONS(3366),
    [anon_sym_namespace] = ACTIONS(3366),
    [anon_sym_using] = ACTIONS(3366),
    [anon_sym_static_assert] = ACTIONS(3366),
    [anon_sym_concept] = ACTIONS(3366),
    [anon_sym_co_return] = ACTIONS(3366),
    [anon_sym_co_yield] = ACTIONS(3366),
    [anon_sym_R_DQUOTE] = ACTIONS(3364),
    [anon_sym_LR_DQUOTE] = ACTIONS(3364),
    [anon_sym_uR_DQUOTE] = ACTIONS(3364),
    [anon_sym_UR_DQUOTE] = ACTIONS(3364),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3364),
    [anon_sym_co_await] = ACTIONS(3366),
    [anon_sym_new] = ACTIONS(3366),
    [anon_sym_requires] = ACTIONS(3366),
    [sym_this] = ACTIONS(3366),
    [anon_sym_precise] = ACTIONS(3366),
    [anon_sym_shared] = ACTIONS(3366),
    [anon_sym_groupshared] = ACTIONS(3366),
    [anon_sym_uniform] = ACTIONS(3366),
    [anon_sym_row_major] = ACTIONS(3366),
    [anon_sym_column_major] = ACTIONS(3366),
    [anon_sym_globallycoherent] = ACTIONS(3366),
    [anon_sym_centroid] = ACTIONS(3366),
    [anon_sym_noperspective] = ACTIONS(3366),
    [anon_sym_nointerpolation] = ACTIONS(3366),
    [anon_sym_sample] = ACTIONS(3366),
    [anon_sym_linear] = ACTIONS(3366),
    [anon_sym_snorm] = ACTIONS(3366),
    [anon_sym_unorm] = ACTIONS(3366),
    [anon_sym_point] = ACTIONS(3366),
    [anon_sym_line] = ACTIONS(3366),
    [anon_sym_triangleadj] = ACTIONS(3366),
    [anon_sym_lineadj] = ACTIONS(3366),
    [anon_sym_triangle] = ACTIONS(3366),
    [anon_sym_interface] = ACTIONS(3366),
    [anon_sym_extension] = ACTIONS(3366),
    [anon_sym_where] = ACTIONS(3366),
    [anon_sym___exported] = ACTIONS(3366),
    [anon_sym_import] = ACTIONS(3366),
  },
  [429] = {
    [sym_identifier] = ACTIONS(3368),
    [aux_sym_preproc_include_token1] = ACTIONS(3368),
    [aux_sym_preproc_def_token1] = ACTIONS(3368),
    [aux_sym_preproc_if_token1] = ACTIONS(3368),
    [aux_sym_preproc_if_token2] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3368),
    [aux_sym_preproc_else_token1] = ACTIONS(3368),
    [aux_sym_preproc_elif_token1] = ACTIONS(3368),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3368),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3368),
    [sym_preproc_directive] = ACTIONS(3368),
    [anon_sym_LPAREN2] = ACTIONS(3370),
    [anon_sym_BANG] = ACTIONS(3370),
    [anon_sym_TILDE] = ACTIONS(3370),
    [anon_sym_DASH] = ACTIONS(3368),
    [anon_sym_PLUS] = ACTIONS(3368),
    [anon_sym_STAR] = ACTIONS(3370),
    [anon_sym_AMP_AMP] = ACTIONS(3370),
    [anon_sym_AMP] = ACTIONS(3368),
    [anon_sym_SEMI] = ACTIONS(3370),
    [anon_sym___extension__] = ACTIONS(3368),
    [anon_sym_typedef] = ACTIONS(3368),
    [anon_sym_in] = ACTIONS(3368),
    [anon_sym_out] = ACTIONS(3368),
    [anon_sym_inout] = ACTIONS(3368),
    [anon_sym_extern] = ACTIONS(3368),
    [anon_sym___attribute__] = ACTIONS(3368),
    [anon_sym_COLON_COLON] = ACTIONS(3370),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3370),
    [anon_sym___declspec] = ACTIONS(3368),
    [anon_sym___based] = ACTIONS(3368),
    [anon_sym___cdecl] = ACTIONS(3368),
    [anon_sym___clrcall] = ACTIONS(3368),
    [anon_sym___stdcall] = ACTIONS(3368),
    [anon_sym___fastcall] = ACTIONS(3368),
    [anon_sym___thiscall] = ACTIONS(3368),
    [anon_sym___vectorcall] = ACTIONS(3368),
    [anon_sym_LBRACE] = ACTIONS(3370),
    [anon_sym_signed] = ACTIONS(3368),
    [anon_sym_unsigned] = ACTIONS(3368),
    [anon_sym_long] = ACTIONS(3368),
    [anon_sym_short] = ACTIONS(3368),
    [anon_sym_LBRACK] = ACTIONS(3368),
    [anon_sym_static] = ACTIONS(3368),
    [anon_sym_register] = ACTIONS(3368),
    [anon_sym_inline] = ACTIONS(3368),
    [anon_sym___inline] = ACTIONS(3368),
    [anon_sym___inline__] = ACTIONS(3368),
    [anon_sym___forceinline] = ACTIONS(3368),
    [anon_sym_thread_local] = ACTIONS(3368),
    [anon_sym___thread] = ACTIONS(3368),
    [anon_sym_const] = ACTIONS(3368),
    [anon_sym_constexpr] = ACTIONS(3368),
    [anon_sym_volatile] = ACTIONS(3368),
    [anon_sym_restrict] = ACTIONS(3368),
    [anon_sym___restrict__] = ACTIONS(3368),
    [anon_sym__Atomic] = ACTIONS(3368),
    [anon_sym__Noreturn] = ACTIONS(3368),
    [anon_sym_noreturn] = ACTIONS(3368),
    [anon_sym_mutable] = ACTIONS(3368),
    [anon_sym_constinit] = ACTIONS(3368),
    [anon_sym_consteval] = ACTIONS(3368),
    [anon_sym_alignas] = ACTIONS(3368),
    [anon_sym__Alignas] = ACTIONS(3368),
    [sym_primitive_type] = ACTIONS(3368),
    [anon_sym_enum] = ACTIONS(3368),
    [anon_sym_class] = ACTIONS(3368),
    [anon_sym_struct] = ACTIONS(3368),
    [anon_sym_union] = ACTIONS(3368),
    [anon_sym_if] = ACTIONS(3368),
    [anon_sym_else] = ACTIONS(3368),
    [anon_sym_switch] = ACTIONS(3368),
    [anon_sym_case] = ACTIONS(3368),
    [anon_sym_default] = ACTIONS(3368),
    [anon_sym_while] = ACTIONS(3368),
    [anon_sym_do] = ACTIONS(3368),
    [anon_sym_for] = ACTIONS(3368),
    [anon_sym_return] = ACTIONS(3368),
    [anon_sym_break] = ACTIONS(3368),
    [anon_sym_continue] = ACTIONS(3368),
    [anon_sym_goto] = ACTIONS(3368),
    [anon_sym___try] = ACTIONS(3368),
    [anon_sym___leave] = ACTIONS(3368),
    [anon_sym_not] = ACTIONS(3368),
    [anon_sym_compl] = ACTIONS(3368),
    [anon_sym_DASH_DASH] = ACTIONS(3370),
    [anon_sym_PLUS_PLUS] = ACTIONS(3370),
    [anon_sym_sizeof] = ACTIONS(3368),
    [anon_sym___alignof__] = ACTIONS(3368),
    [anon_sym___alignof] = ACTIONS(3368),
    [anon_sym__alignof] = ACTIONS(3368),
    [anon_sym_alignof] = ACTIONS(3368),
    [anon_sym__Alignof] = ACTIONS(3368),
    [anon_sym_offsetof] = ACTIONS(3368),
    [anon_sym__Generic] = ACTIONS(3368),
    [anon_sym_asm] = ACTIONS(3368),
    [anon_sym___asm__] = ACTIONS(3368),
    [sym_number_literal] = ACTIONS(3370),
    [anon_sym_L_SQUOTE] = ACTIONS(3370),
    [anon_sym_u_SQUOTE] = ACTIONS(3370),
    [anon_sym_U_SQUOTE] = ACTIONS(3370),
    [anon_sym_u8_SQUOTE] = ACTIONS(3370),
    [anon_sym_SQUOTE] = ACTIONS(3370),
    [anon_sym_L_DQUOTE] = ACTIONS(3370),
    [anon_sym_u_DQUOTE] = ACTIONS(3370),
    [anon_sym_U_DQUOTE] = ACTIONS(3370),
    [anon_sym_u8_DQUOTE] = ACTIONS(3370),
    [anon_sym_DQUOTE] = ACTIONS(3370),
    [sym_true] = ACTIONS(3368),
    [sym_false] = ACTIONS(3368),
    [anon_sym_NULL] = ACTIONS(3368),
    [anon_sym_nullptr] = ACTIONS(3368),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3368),
    [anon_sym_let] = ACTIONS(3368),
    [anon_sym_This] = ACTIONS(3368),
    [anon_sym_decltype] = ACTIONS(3368),
    [sym_virtual] = ACTIONS(3368),
    [anon_sym_explicit] = ACTIONS(3368),
    [anon_sym_typename] = ACTIONS(3368),
    [anon_sym_template] = ACTIONS(3368),
    [anon_sym_operator] = ACTIONS(3368),
    [anon_sym_try] = ACTIONS(3368),
    [anon_sym_delete] = ACTIONS(3368),
    [anon_sym_throw] = ACTIONS(3368),
    [anon_sym_namespace] = ACTIONS(3368),
    [anon_sym_using] = ACTIONS(3368),
    [anon_sym_static_assert] = ACTIONS(3368),
    [anon_sym_concept] = ACTIONS(3368),
    [anon_sym_co_return] = ACTIONS(3368),
    [anon_sym_co_yield] = ACTIONS(3368),
    [anon_sym_R_DQUOTE] = ACTIONS(3370),
    [anon_sym_LR_DQUOTE] = ACTIONS(3370),
    [anon_sym_uR_DQUOTE] = ACTIONS(3370),
    [anon_sym_UR_DQUOTE] = ACTIONS(3370),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3370),
    [anon_sym_co_await] = ACTIONS(3368),
    [anon_sym_new] = ACTIONS(3368),
    [anon_sym_requires] = ACTIONS(3368),
    [sym_this] = ACTIONS(3368),
    [anon_sym_discard] = ACTIONS(3368),
    [anon_sym_precise] = ACTIONS(3368),
    [anon_sym_shared] = ACTIONS(3368),
    [anon_sym_groupshared] = ACTIONS(3368),
    [anon_sym_uniform] = ACTIONS(3368),
    [anon_sym_row_major] = ACTIONS(3368),
    [anon_sym_column_major] = ACTIONS(3368),
    [anon_sym_globallycoherent] = ACTIONS(3368),
    [anon_sym_centroid] = ACTIONS(3368),
    [anon_sym_noperspective] = ACTIONS(3368),
    [anon_sym_nointerpolation] = ACTIONS(3368),
    [anon_sym_sample] = ACTIONS(3368),
    [anon_sym_linear] = ACTIONS(3368),
    [anon_sym_snorm] = ACTIONS(3368),
    [anon_sym_unorm] = ACTIONS(3368),
    [anon_sym_point] = ACTIONS(3368),
    [anon_sym_line] = ACTIONS(3368),
    [anon_sym_triangleadj] = ACTIONS(3368),
    [anon_sym_lineadj] = ACTIONS(3368),
    [anon_sym_triangle] = ACTIONS(3368),
    [anon_sym_cbuffer] = ACTIONS(3368),
    [anon_sym_interface] = ACTIONS(3368),
    [anon_sym_extension] = ACTIONS(3368),
  },
  [430] = {
    [sym_preproc_def] = STATE(371),
    [sym_preproc_function_def] = STATE(371),
    [sym_preproc_call] = STATE(371),
    [sym_preproc_if_in_field_declaration_list] = STATE(371),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(371),
    [sym_type_definition] = STATE(371),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(6764),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2950),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__field_declaration_list_item] = STATE(371),
    [sym_field_declaration] = STATE(371),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(371),
    [sym_operator_cast] = STATE(8480),
    [sym_inline_method_definition] = STATE(371),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(371),
    [sym_operator_cast_declaration] = STATE(371),
    [sym_constructor_or_destructor_definition] = STATE(371),
    [sym_constructor_or_destructor_declaration] = STATE(371),
    [sym_friend_declaration] = STATE(371),
    [sym_access_specifier] = STATE(10108),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_using_declaration] = STATE(371),
    [sym_alias_declaration] = STATE(371),
    [sym_static_assert_declaration] = STATE(371),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6554),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_init_declaration] = STATE(371),
    [sym_subscript_declaration] = STATE(371),
    [sym_property_declaration] = STATE(371),
    [sym_associatedtype_declaration] = STATE(371),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(371),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(2375),
    [aux_sym_preproc_def_token1] = ACTIONS(2868),
    [aux_sym_preproc_if_token1] = ACTIONS(2870),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2872),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2872),
    [sym_preproc_directive] = ACTIONS(2874),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(2876),
    [anon_sym_typedef] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3372),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2886),
    [anon_sym_static_assert] = ACTIONS(2888),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
    [anon_sym___init] = ACTIONS(2890),
    [anon_sym___subscript] = ACTIONS(2892),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_associatedtype] = ACTIONS(2896),
  },
  [431] = {
    [sym_identifier] = ACTIONS(3374),
    [aux_sym_preproc_include_token1] = ACTIONS(3374),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token2] = ACTIONS(3374),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3374),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3374),
    [aux_sym_preproc_else_token1] = ACTIONS(3374),
    [aux_sym_preproc_elif_token1] = ACTIONS(3374),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3374),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3374),
    [sym_preproc_directive] = ACTIONS(3374),
    [anon_sym_LPAREN2] = ACTIONS(3376),
    [anon_sym_BANG] = ACTIONS(3376),
    [anon_sym_TILDE] = ACTIONS(3376),
    [anon_sym_DASH] = ACTIONS(3374),
    [anon_sym_PLUS] = ACTIONS(3374),
    [anon_sym_STAR] = ACTIONS(3376),
    [anon_sym_AMP_AMP] = ACTIONS(3376),
    [anon_sym_AMP] = ACTIONS(3374),
    [anon_sym_SEMI] = ACTIONS(3376),
    [anon_sym___extension__] = ACTIONS(3374),
    [anon_sym_typedef] = ACTIONS(3374),
    [anon_sym_in] = ACTIONS(3374),
    [anon_sym_out] = ACTIONS(3374),
    [anon_sym_inout] = ACTIONS(3374),
    [anon_sym_extern] = ACTIONS(3374),
    [anon_sym___attribute__] = ACTIONS(3374),
    [anon_sym_COLON_COLON] = ACTIONS(3376),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3376),
    [anon_sym___declspec] = ACTIONS(3374),
    [anon_sym___based] = ACTIONS(3374),
    [anon_sym___cdecl] = ACTIONS(3374),
    [anon_sym___clrcall] = ACTIONS(3374),
    [anon_sym___stdcall] = ACTIONS(3374),
    [anon_sym___fastcall] = ACTIONS(3374),
    [anon_sym___thiscall] = ACTIONS(3374),
    [anon_sym___vectorcall] = ACTIONS(3374),
    [anon_sym_LBRACE] = ACTIONS(3376),
    [anon_sym_signed] = ACTIONS(3374),
    [anon_sym_unsigned] = ACTIONS(3374),
    [anon_sym_long] = ACTIONS(3374),
    [anon_sym_short] = ACTIONS(3374),
    [anon_sym_LBRACK] = ACTIONS(3374),
    [anon_sym_static] = ACTIONS(3374),
    [anon_sym_register] = ACTIONS(3374),
    [anon_sym_inline] = ACTIONS(3374),
    [anon_sym___inline] = ACTIONS(3374),
    [anon_sym___inline__] = ACTIONS(3374),
    [anon_sym___forceinline] = ACTIONS(3374),
    [anon_sym_thread_local] = ACTIONS(3374),
    [anon_sym___thread] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3374),
    [anon_sym_constexpr] = ACTIONS(3374),
    [anon_sym_volatile] = ACTIONS(3374),
    [anon_sym_restrict] = ACTIONS(3374),
    [anon_sym___restrict__] = ACTIONS(3374),
    [anon_sym__Atomic] = ACTIONS(3374),
    [anon_sym__Noreturn] = ACTIONS(3374),
    [anon_sym_noreturn] = ACTIONS(3374),
    [anon_sym_mutable] = ACTIONS(3374),
    [anon_sym_constinit] = ACTIONS(3374),
    [anon_sym_consteval] = ACTIONS(3374),
    [anon_sym_alignas] = ACTIONS(3374),
    [anon_sym__Alignas] = ACTIONS(3374),
    [sym_primitive_type] = ACTIONS(3374),
    [anon_sym_enum] = ACTIONS(3374),
    [anon_sym_class] = ACTIONS(3374),
    [anon_sym_struct] = ACTIONS(3374),
    [anon_sym_union] = ACTIONS(3374),
    [anon_sym_if] = ACTIONS(3374),
    [anon_sym_else] = ACTIONS(3374),
    [anon_sym_switch] = ACTIONS(3374),
    [anon_sym_case] = ACTIONS(3374),
    [anon_sym_default] = ACTIONS(3374),
    [anon_sym_while] = ACTIONS(3374),
    [anon_sym_do] = ACTIONS(3374),
    [anon_sym_for] = ACTIONS(3374),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_break] = ACTIONS(3374),
    [anon_sym_continue] = ACTIONS(3374),
    [anon_sym_goto] = ACTIONS(3374),
    [anon_sym___try] = ACTIONS(3374),
    [anon_sym___leave] = ACTIONS(3374),
    [anon_sym_not] = ACTIONS(3374),
    [anon_sym_compl] = ACTIONS(3374),
    [anon_sym_DASH_DASH] = ACTIONS(3376),
    [anon_sym_PLUS_PLUS] = ACTIONS(3376),
    [anon_sym_sizeof] = ACTIONS(3374),
    [anon_sym___alignof__] = ACTIONS(3374),
    [anon_sym___alignof] = ACTIONS(3374),
    [anon_sym__alignof] = ACTIONS(3374),
    [anon_sym_alignof] = ACTIONS(3374),
    [anon_sym__Alignof] = ACTIONS(3374),
    [anon_sym_offsetof] = ACTIONS(3374),
    [anon_sym__Generic] = ACTIONS(3374),
    [anon_sym_asm] = ACTIONS(3374),
    [anon_sym___asm__] = ACTIONS(3374),
    [sym_number_literal] = ACTIONS(3376),
    [anon_sym_L_SQUOTE] = ACTIONS(3376),
    [anon_sym_u_SQUOTE] = ACTIONS(3376),
    [anon_sym_U_SQUOTE] = ACTIONS(3376),
    [anon_sym_u8_SQUOTE] = ACTIONS(3376),
    [anon_sym_SQUOTE] = ACTIONS(3376),
    [anon_sym_L_DQUOTE] = ACTIONS(3376),
    [anon_sym_u_DQUOTE] = ACTIONS(3376),
    [anon_sym_U_DQUOTE] = ACTIONS(3376),
    [anon_sym_u8_DQUOTE] = ACTIONS(3376),
    [anon_sym_DQUOTE] = ACTIONS(3376),
    [sym_true] = ACTIONS(3374),
    [sym_false] = ACTIONS(3374),
    [anon_sym_NULL] = ACTIONS(3374),
    [anon_sym_nullptr] = ACTIONS(3374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3374),
    [anon_sym_let] = ACTIONS(3374),
    [anon_sym_This] = ACTIONS(3374),
    [anon_sym_decltype] = ACTIONS(3374),
    [sym_virtual] = ACTIONS(3374),
    [anon_sym_explicit] = ACTIONS(3374),
    [anon_sym_typename] = ACTIONS(3374),
    [anon_sym_template] = ACTIONS(3374),
    [anon_sym_operator] = ACTIONS(3374),
    [anon_sym_try] = ACTIONS(3374),
    [anon_sym_delete] = ACTIONS(3374),
    [anon_sym_throw] = ACTIONS(3374),
    [anon_sym_namespace] = ACTIONS(3374),
    [anon_sym_using] = ACTIONS(3374),
    [anon_sym_static_assert] = ACTIONS(3374),
    [anon_sym_concept] = ACTIONS(3374),
    [anon_sym_co_return] = ACTIONS(3374),
    [anon_sym_co_yield] = ACTIONS(3374),
    [anon_sym_R_DQUOTE] = ACTIONS(3376),
    [anon_sym_LR_DQUOTE] = ACTIONS(3376),
    [anon_sym_uR_DQUOTE] = ACTIONS(3376),
    [anon_sym_UR_DQUOTE] = ACTIONS(3376),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3376),
    [anon_sym_co_await] = ACTIONS(3374),
    [anon_sym_new] = ACTIONS(3374),
    [anon_sym_requires] = ACTIONS(3374),
    [sym_this] = ACTIONS(3374),
    [anon_sym_discard] = ACTIONS(3374),
    [anon_sym_precise] = ACTIONS(3374),
    [anon_sym_shared] = ACTIONS(3374),
    [anon_sym_groupshared] = ACTIONS(3374),
    [anon_sym_uniform] = ACTIONS(3374),
    [anon_sym_row_major] = ACTIONS(3374),
    [anon_sym_column_major] = ACTIONS(3374),
    [anon_sym_globallycoherent] = ACTIONS(3374),
    [anon_sym_centroid] = ACTIONS(3374),
    [anon_sym_noperspective] = ACTIONS(3374),
    [anon_sym_nointerpolation] = ACTIONS(3374),
    [anon_sym_sample] = ACTIONS(3374),
    [anon_sym_linear] = ACTIONS(3374),
    [anon_sym_snorm] = ACTIONS(3374),
    [anon_sym_unorm] = ACTIONS(3374),
    [anon_sym_point] = ACTIONS(3374),
    [anon_sym_line] = ACTIONS(3374),
    [anon_sym_triangleadj] = ACTIONS(3374),
    [anon_sym_lineadj] = ACTIONS(3374),
    [anon_sym_triangle] = ACTIONS(3374),
    [anon_sym_cbuffer] = ACTIONS(3374),
    [anon_sym_interface] = ACTIONS(3374),
    [anon_sym_extension] = ACTIONS(3374),
  },
  [432] = {
    [ts_builtin_sym_end] = ACTIONS(3336),
    [sym_identifier] = ACTIONS(3338),
    [aux_sym_preproc_include_token1] = ACTIONS(3338),
    [aux_sym_preproc_def_token1] = ACTIONS(3338),
    [anon_sym_COMMA] = ACTIONS(3336),
    [anon_sym_RPAREN] = ACTIONS(3336),
    [aux_sym_preproc_if_token1] = ACTIONS(3338),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3338),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3338),
    [sym_preproc_directive] = ACTIONS(3338),
    [anon_sym_LPAREN2] = ACTIONS(3336),
    [anon_sym_BANG] = ACTIONS(3336),
    [anon_sym_TILDE] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3338),
    [anon_sym_PLUS] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_AMP] = ACTIONS(3338),
    [anon_sym_SEMI] = ACTIONS(3336),
    [anon_sym___extension__] = ACTIONS(3338),
    [anon_sym_typedef] = ACTIONS(3338),
    [anon_sym_in] = ACTIONS(3338),
    [anon_sym_out] = ACTIONS(3338),
    [anon_sym_inout] = ACTIONS(3338),
    [anon_sym_extern] = ACTIONS(3338),
    [anon_sym___attribute__] = ACTIONS(3338),
    [anon_sym_COLON_COLON] = ACTIONS(3336),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3336),
    [anon_sym___declspec] = ACTIONS(3338),
    [anon_sym___based] = ACTIONS(3338),
    [anon_sym___cdecl] = ACTIONS(3338),
    [anon_sym___clrcall] = ACTIONS(3338),
    [anon_sym___stdcall] = ACTIONS(3338),
    [anon_sym___fastcall] = ACTIONS(3338),
    [anon_sym___thiscall] = ACTIONS(3338),
    [anon_sym___vectorcall] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_signed] = ACTIONS(3338),
    [anon_sym_unsigned] = ACTIONS(3338),
    [anon_sym_long] = ACTIONS(3338),
    [anon_sym_short] = ACTIONS(3338),
    [anon_sym_LBRACK] = ACTIONS(3338),
    [anon_sym_static] = ACTIONS(3338),
    [anon_sym_register] = ACTIONS(3338),
    [anon_sym_inline] = ACTIONS(3338),
    [anon_sym___inline] = ACTIONS(3338),
    [anon_sym___inline__] = ACTIONS(3338),
    [anon_sym___forceinline] = ACTIONS(3338),
    [anon_sym_thread_local] = ACTIONS(3338),
    [anon_sym___thread] = ACTIONS(3338),
    [anon_sym_const] = ACTIONS(3338),
    [anon_sym_constexpr] = ACTIONS(3338),
    [anon_sym_volatile] = ACTIONS(3338),
    [anon_sym_restrict] = ACTIONS(3338),
    [anon_sym___restrict__] = ACTIONS(3338),
    [anon_sym__Atomic] = ACTIONS(3338),
    [anon_sym__Noreturn] = ACTIONS(3338),
    [anon_sym_noreturn] = ACTIONS(3338),
    [anon_sym_mutable] = ACTIONS(3338),
    [anon_sym_constinit] = ACTIONS(3338),
    [anon_sym_consteval] = ACTIONS(3338),
    [anon_sym_alignas] = ACTIONS(3338),
    [anon_sym__Alignas] = ACTIONS(3338),
    [sym_primitive_type] = ACTIONS(3338),
    [anon_sym_enum] = ACTIONS(3338),
    [anon_sym_class] = ACTIONS(3338),
    [anon_sym_struct] = ACTIONS(3338),
    [anon_sym_union] = ACTIONS(3338),
    [anon_sym_if] = ACTIONS(3338),
    [anon_sym_switch] = ACTIONS(3338),
    [anon_sym_case] = ACTIONS(3338),
    [anon_sym_default] = ACTIONS(3338),
    [anon_sym_while] = ACTIONS(3338),
    [anon_sym_do] = ACTIONS(3338),
    [anon_sym_for] = ACTIONS(3338),
    [anon_sym_return] = ACTIONS(3338),
    [anon_sym_break] = ACTIONS(3338),
    [anon_sym_continue] = ACTIONS(3338),
    [anon_sym_goto] = ACTIONS(3338),
    [anon_sym_not] = ACTIONS(3338),
    [anon_sym_compl] = ACTIONS(3338),
    [anon_sym_DASH_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_PLUS] = ACTIONS(3336),
    [anon_sym_sizeof] = ACTIONS(3338),
    [anon_sym___alignof__] = ACTIONS(3338),
    [anon_sym___alignof] = ACTIONS(3338),
    [anon_sym__alignof] = ACTIONS(3338),
    [anon_sym_alignof] = ACTIONS(3338),
    [anon_sym__Alignof] = ACTIONS(3338),
    [anon_sym_offsetof] = ACTIONS(3338),
    [anon_sym__Generic] = ACTIONS(3338),
    [anon_sym_asm] = ACTIONS(3338),
    [anon_sym___asm__] = ACTIONS(3338),
    [anon_sym_DOT] = ACTIONS(3338),
    [sym_number_literal] = ACTIONS(3336),
    [anon_sym_L_SQUOTE] = ACTIONS(3336),
    [anon_sym_u_SQUOTE] = ACTIONS(3336),
    [anon_sym_U_SQUOTE] = ACTIONS(3336),
    [anon_sym_u8_SQUOTE] = ACTIONS(3336),
    [anon_sym_SQUOTE] = ACTIONS(3336),
    [anon_sym_L_DQUOTE] = ACTIONS(3336),
    [anon_sym_u_DQUOTE] = ACTIONS(3336),
    [anon_sym_U_DQUOTE] = ACTIONS(3336),
    [anon_sym_u8_DQUOTE] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(3336),
    [sym_true] = ACTIONS(3338),
    [sym_false] = ACTIONS(3338),
    [anon_sym_NULL] = ACTIONS(3338),
    [anon_sym_nullptr] = ACTIONS(3338),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3338),
    [anon_sym_let] = ACTIONS(3338),
    [anon_sym_This] = ACTIONS(3338),
    [anon_sym_decltype] = ACTIONS(3338),
    [anon_sym_final] = ACTIONS(3338),
    [anon_sym_override] = ACTIONS(3338),
    [sym_virtual] = ACTIONS(3338),
    [anon_sym_explicit] = ACTIONS(3338),
    [anon_sym_typename] = ACTIONS(3338),
    [anon_sym_template] = ACTIONS(3338),
    [anon_sym_GT2] = ACTIONS(3336),
    [anon_sym_operator] = ACTIONS(3338),
    [anon_sym_try] = ACTIONS(3338),
    [anon_sym_delete] = ACTIONS(3338),
    [anon_sym_throw] = ACTIONS(3338),
    [anon_sym_namespace] = ACTIONS(3338),
    [anon_sym_using] = ACTIONS(3338),
    [anon_sym_static_assert] = ACTIONS(3338),
    [anon_sym_concept] = ACTIONS(3338),
    [anon_sym_co_return] = ACTIONS(3338),
    [anon_sym_co_yield] = ACTIONS(3338),
    [anon_sym_R_DQUOTE] = ACTIONS(3336),
    [anon_sym_LR_DQUOTE] = ACTIONS(3336),
    [anon_sym_uR_DQUOTE] = ACTIONS(3336),
    [anon_sym_UR_DQUOTE] = ACTIONS(3336),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3336),
    [anon_sym_co_await] = ACTIONS(3338),
    [anon_sym_new] = ACTIONS(3338),
    [anon_sym_requires] = ACTIONS(3338),
    [sym_this] = ACTIONS(3338),
    [anon_sym_precise] = ACTIONS(3338),
    [anon_sym_shared] = ACTIONS(3338),
    [anon_sym_groupshared] = ACTIONS(3338),
    [anon_sym_uniform] = ACTIONS(3338),
    [anon_sym_row_major] = ACTIONS(3338),
    [anon_sym_column_major] = ACTIONS(3338),
    [anon_sym_globallycoherent] = ACTIONS(3338),
    [anon_sym_centroid] = ACTIONS(3338),
    [anon_sym_noperspective] = ACTIONS(3338),
    [anon_sym_nointerpolation] = ACTIONS(3338),
    [anon_sym_sample] = ACTIONS(3338),
    [anon_sym_linear] = ACTIONS(3338),
    [anon_sym_snorm] = ACTIONS(3338),
    [anon_sym_unorm] = ACTIONS(3338),
    [anon_sym_point] = ACTIONS(3338),
    [anon_sym_line] = ACTIONS(3338),
    [anon_sym_triangleadj] = ACTIONS(3338),
    [anon_sym_lineadj] = ACTIONS(3338),
    [anon_sym_triangle] = ACTIONS(3338),
    [anon_sym_interface] = ACTIONS(3338),
    [anon_sym_extension] = ACTIONS(3338),
    [anon_sym_where] = ACTIONS(3338),
    [anon_sym___exported] = ACTIONS(3338),
    [anon_sym_import] = ACTIONS(3338),
  },
  [433] = {
    [sym_identifier] = ACTIONS(3378),
    [aux_sym_preproc_include_token1] = ACTIONS(3378),
    [aux_sym_preproc_def_token1] = ACTIONS(3378),
    [aux_sym_preproc_if_token1] = ACTIONS(3378),
    [aux_sym_preproc_if_token2] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3378),
    [aux_sym_preproc_else_token1] = ACTIONS(3378),
    [aux_sym_preproc_elif_token1] = ACTIONS(3378),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3378),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3378),
    [sym_preproc_directive] = ACTIONS(3378),
    [anon_sym_LPAREN2] = ACTIONS(3380),
    [anon_sym_BANG] = ACTIONS(3380),
    [anon_sym_TILDE] = ACTIONS(3380),
    [anon_sym_DASH] = ACTIONS(3378),
    [anon_sym_PLUS] = ACTIONS(3378),
    [anon_sym_STAR] = ACTIONS(3380),
    [anon_sym_AMP_AMP] = ACTIONS(3380),
    [anon_sym_AMP] = ACTIONS(3378),
    [anon_sym_SEMI] = ACTIONS(3380),
    [anon_sym___extension__] = ACTIONS(3378),
    [anon_sym_typedef] = ACTIONS(3378),
    [anon_sym_in] = ACTIONS(3378),
    [anon_sym_out] = ACTIONS(3378),
    [anon_sym_inout] = ACTIONS(3378),
    [anon_sym_extern] = ACTIONS(3378),
    [anon_sym___attribute__] = ACTIONS(3378),
    [anon_sym_COLON_COLON] = ACTIONS(3380),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3380),
    [anon_sym___declspec] = ACTIONS(3378),
    [anon_sym___based] = ACTIONS(3378),
    [anon_sym___cdecl] = ACTIONS(3378),
    [anon_sym___clrcall] = ACTIONS(3378),
    [anon_sym___stdcall] = ACTIONS(3378),
    [anon_sym___fastcall] = ACTIONS(3378),
    [anon_sym___thiscall] = ACTIONS(3378),
    [anon_sym___vectorcall] = ACTIONS(3378),
    [anon_sym_LBRACE] = ACTIONS(3380),
    [anon_sym_signed] = ACTIONS(3378),
    [anon_sym_unsigned] = ACTIONS(3378),
    [anon_sym_long] = ACTIONS(3378),
    [anon_sym_short] = ACTIONS(3378),
    [anon_sym_LBRACK] = ACTIONS(3378),
    [anon_sym_static] = ACTIONS(3378),
    [anon_sym_register] = ACTIONS(3378),
    [anon_sym_inline] = ACTIONS(3378),
    [anon_sym___inline] = ACTIONS(3378),
    [anon_sym___inline__] = ACTIONS(3378),
    [anon_sym___forceinline] = ACTIONS(3378),
    [anon_sym_thread_local] = ACTIONS(3378),
    [anon_sym___thread] = ACTIONS(3378),
    [anon_sym_const] = ACTIONS(3378),
    [anon_sym_constexpr] = ACTIONS(3378),
    [anon_sym_volatile] = ACTIONS(3378),
    [anon_sym_restrict] = ACTIONS(3378),
    [anon_sym___restrict__] = ACTIONS(3378),
    [anon_sym__Atomic] = ACTIONS(3378),
    [anon_sym__Noreturn] = ACTIONS(3378),
    [anon_sym_noreturn] = ACTIONS(3378),
    [anon_sym_mutable] = ACTIONS(3378),
    [anon_sym_constinit] = ACTIONS(3378),
    [anon_sym_consteval] = ACTIONS(3378),
    [anon_sym_alignas] = ACTIONS(3378),
    [anon_sym__Alignas] = ACTIONS(3378),
    [sym_primitive_type] = ACTIONS(3378),
    [anon_sym_enum] = ACTIONS(3378),
    [anon_sym_class] = ACTIONS(3378),
    [anon_sym_struct] = ACTIONS(3378),
    [anon_sym_union] = ACTIONS(3378),
    [anon_sym_if] = ACTIONS(3378),
    [anon_sym_else] = ACTIONS(3378),
    [anon_sym_switch] = ACTIONS(3378),
    [anon_sym_case] = ACTIONS(3378),
    [anon_sym_default] = ACTIONS(3378),
    [anon_sym_while] = ACTIONS(3378),
    [anon_sym_do] = ACTIONS(3378),
    [anon_sym_for] = ACTIONS(3378),
    [anon_sym_return] = ACTIONS(3378),
    [anon_sym_break] = ACTIONS(3378),
    [anon_sym_continue] = ACTIONS(3378),
    [anon_sym_goto] = ACTIONS(3378),
    [anon_sym___try] = ACTIONS(3378),
    [anon_sym___leave] = ACTIONS(3378),
    [anon_sym_not] = ACTIONS(3378),
    [anon_sym_compl] = ACTIONS(3378),
    [anon_sym_DASH_DASH] = ACTIONS(3380),
    [anon_sym_PLUS_PLUS] = ACTIONS(3380),
    [anon_sym_sizeof] = ACTIONS(3378),
    [anon_sym___alignof__] = ACTIONS(3378),
    [anon_sym___alignof] = ACTIONS(3378),
    [anon_sym__alignof] = ACTIONS(3378),
    [anon_sym_alignof] = ACTIONS(3378),
    [anon_sym__Alignof] = ACTIONS(3378),
    [anon_sym_offsetof] = ACTIONS(3378),
    [anon_sym__Generic] = ACTIONS(3378),
    [anon_sym_asm] = ACTIONS(3378),
    [anon_sym___asm__] = ACTIONS(3378),
    [sym_number_literal] = ACTIONS(3380),
    [anon_sym_L_SQUOTE] = ACTIONS(3380),
    [anon_sym_u_SQUOTE] = ACTIONS(3380),
    [anon_sym_U_SQUOTE] = ACTIONS(3380),
    [anon_sym_u8_SQUOTE] = ACTIONS(3380),
    [anon_sym_SQUOTE] = ACTIONS(3380),
    [anon_sym_L_DQUOTE] = ACTIONS(3380),
    [anon_sym_u_DQUOTE] = ACTIONS(3380),
    [anon_sym_U_DQUOTE] = ACTIONS(3380),
    [anon_sym_u8_DQUOTE] = ACTIONS(3380),
    [anon_sym_DQUOTE] = ACTIONS(3380),
    [sym_true] = ACTIONS(3378),
    [sym_false] = ACTIONS(3378),
    [anon_sym_NULL] = ACTIONS(3378),
    [anon_sym_nullptr] = ACTIONS(3378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3378),
    [anon_sym_let] = ACTIONS(3378),
    [anon_sym_This] = ACTIONS(3378),
    [anon_sym_decltype] = ACTIONS(3378),
    [sym_virtual] = ACTIONS(3378),
    [anon_sym_explicit] = ACTIONS(3378),
    [anon_sym_typename] = ACTIONS(3378),
    [anon_sym_template] = ACTIONS(3378),
    [anon_sym_operator] = ACTIONS(3378),
    [anon_sym_try] = ACTIONS(3378),
    [anon_sym_delete] = ACTIONS(3378),
    [anon_sym_throw] = ACTIONS(3378),
    [anon_sym_namespace] = ACTIONS(3378),
    [anon_sym_using] = ACTIONS(3378),
    [anon_sym_static_assert] = ACTIONS(3378),
    [anon_sym_concept] = ACTIONS(3378),
    [anon_sym_co_return] = ACTIONS(3378),
    [anon_sym_co_yield] = ACTIONS(3378),
    [anon_sym_R_DQUOTE] = ACTIONS(3380),
    [anon_sym_LR_DQUOTE] = ACTIONS(3380),
    [anon_sym_uR_DQUOTE] = ACTIONS(3380),
    [anon_sym_UR_DQUOTE] = ACTIONS(3380),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3380),
    [anon_sym_co_await] = ACTIONS(3378),
    [anon_sym_new] = ACTIONS(3378),
    [anon_sym_requires] = ACTIONS(3378),
    [sym_this] = ACTIONS(3378),
    [anon_sym_discard] = ACTIONS(3378),
    [anon_sym_precise] = ACTIONS(3378),
    [anon_sym_shared] = ACTIONS(3378),
    [anon_sym_groupshared] = ACTIONS(3378),
    [anon_sym_uniform] = ACTIONS(3378),
    [anon_sym_row_major] = ACTIONS(3378),
    [anon_sym_column_major] = ACTIONS(3378),
    [anon_sym_globallycoherent] = ACTIONS(3378),
    [anon_sym_centroid] = ACTIONS(3378),
    [anon_sym_noperspective] = ACTIONS(3378),
    [anon_sym_nointerpolation] = ACTIONS(3378),
    [anon_sym_sample] = ACTIONS(3378),
    [anon_sym_linear] = ACTIONS(3378),
    [anon_sym_snorm] = ACTIONS(3378),
    [anon_sym_unorm] = ACTIONS(3378),
    [anon_sym_point] = ACTIONS(3378),
    [anon_sym_line] = ACTIONS(3378),
    [anon_sym_triangleadj] = ACTIONS(3378),
    [anon_sym_lineadj] = ACTIONS(3378),
    [anon_sym_triangle] = ACTIONS(3378),
    [anon_sym_cbuffer] = ACTIONS(3378),
    [anon_sym_interface] = ACTIONS(3378),
    [anon_sym_extension] = ACTIONS(3378),
  },
  [434] = {
    [ts_builtin_sym_end] = ACTIONS(3382),
    [sym_identifier] = ACTIONS(3384),
    [aux_sym_preproc_include_token1] = ACTIONS(3384),
    [aux_sym_preproc_def_token1] = ACTIONS(3384),
    [anon_sym_COMMA] = ACTIONS(3382),
    [anon_sym_RPAREN] = ACTIONS(3382),
    [aux_sym_preproc_if_token1] = ACTIONS(3384),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3384),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3384),
    [sym_preproc_directive] = ACTIONS(3384),
    [anon_sym_LPAREN2] = ACTIONS(3382),
    [anon_sym_BANG] = ACTIONS(3382),
    [anon_sym_TILDE] = ACTIONS(3382),
    [anon_sym_DASH] = ACTIONS(3384),
    [anon_sym_PLUS] = ACTIONS(3384),
    [anon_sym_STAR] = ACTIONS(3382),
    [anon_sym_AMP_AMP] = ACTIONS(3382),
    [anon_sym_AMP] = ACTIONS(3384),
    [anon_sym_SEMI] = ACTIONS(3382),
    [anon_sym___extension__] = ACTIONS(3384),
    [anon_sym_typedef] = ACTIONS(3384),
    [anon_sym_in] = ACTIONS(3384),
    [anon_sym_out] = ACTIONS(3384),
    [anon_sym_inout] = ACTIONS(3384),
    [anon_sym_extern] = ACTIONS(3384),
    [anon_sym___attribute__] = ACTIONS(3384),
    [anon_sym_COLON_COLON] = ACTIONS(3382),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3382),
    [anon_sym___declspec] = ACTIONS(3384),
    [anon_sym___based] = ACTIONS(3384),
    [anon_sym___cdecl] = ACTIONS(3384),
    [anon_sym___clrcall] = ACTIONS(3384),
    [anon_sym___stdcall] = ACTIONS(3384),
    [anon_sym___fastcall] = ACTIONS(3384),
    [anon_sym___thiscall] = ACTIONS(3384),
    [anon_sym___vectorcall] = ACTIONS(3384),
    [anon_sym_LBRACE] = ACTIONS(3382),
    [anon_sym_signed] = ACTIONS(3384),
    [anon_sym_unsigned] = ACTIONS(3384),
    [anon_sym_long] = ACTIONS(3384),
    [anon_sym_short] = ACTIONS(3384),
    [anon_sym_LBRACK] = ACTIONS(3384),
    [anon_sym_static] = ACTIONS(3384),
    [anon_sym_register] = ACTIONS(3384),
    [anon_sym_inline] = ACTIONS(3384),
    [anon_sym___inline] = ACTIONS(3384),
    [anon_sym___inline__] = ACTIONS(3384),
    [anon_sym___forceinline] = ACTIONS(3384),
    [anon_sym_thread_local] = ACTIONS(3384),
    [anon_sym___thread] = ACTIONS(3384),
    [anon_sym_const] = ACTIONS(3384),
    [anon_sym_constexpr] = ACTIONS(3384),
    [anon_sym_volatile] = ACTIONS(3384),
    [anon_sym_restrict] = ACTIONS(3384),
    [anon_sym___restrict__] = ACTIONS(3384),
    [anon_sym__Atomic] = ACTIONS(3384),
    [anon_sym__Noreturn] = ACTIONS(3384),
    [anon_sym_noreturn] = ACTIONS(3384),
    [anon_sym_mutable] = ACTIONS(3384),
    [anon_sym_constinit] = ACTIONS(3384),
    [anon_sym_consteval] = ACTIONS(3384),
    [anon_sym_alignas] = ACTIONS(3384),
    [anon_sym__Alignas] = ACTIONS(3384),
    [sym_primitive_type] = ACTIONS(3384),
    [anon_sym_enum] = ACTIONS(3384),
    [anon_sym_class] = ACTIONS(3384),
    [anon_sym_struct] = ACTIONS(3384),
    [anon_sym_union] = ACTIONS(3384),
    [anon_sym_if] = ACTIONS(3384),
    [anon_sym_switch] = ACTIONS(3384),
    [anon_sym_case] = ACTIONS(3384),
    [anon_sym_default] = ACTIONS(3384),
    [anon_sym_while] = ACTIONS(3384),
    [anon_sym_do] = ACTIONS(3384),
    [anon_sym_for] = ACTIONS(3384),
    [anon_sym_return] = ACTIONS(3384),
    [anon_sym_break] = ACTIONS(3384),
    [anon_sym_continue] = ACTIONS(3384),
    [anon_sym_goto] = ACTIONS(3384),
    [anon_sym_not] = ACTIONS(3384),
    [anon_sym_compl] = ACTIONS(3384),
    [anon_sym_DASH_DASH] = ACTIONS(3382),
    [anon_sym_PLUS_PLUS] = ACTIONS(3382),
    [anon_sym_sizeof] = ACTIONS(3384),
    [anon_sym___alignof__] = ACTIONS(3384),
    [anon_sym___alignof] = ACTIONS(3384),
    [anon_sym__alignof] = ACTIONS(3384),
    [anon_sym_alignof] = ACTIONS(3384),
    [anon_sym__Alignof] = ACTIONS(3384),
    [anon_sym_offsetof] = ACTIONS(3384),
    [anon_sym__Generic] = ACTIONS(3384),
    [anon_sym_asm] = ACTIONS(3384),
    [anon_sym___asm__] = ACTIONS(3384),
    [anon_sym_DOT] = ACTIONS(3384),
    [sym_number_literal] = ACTIONS(3382),
    [anon_sym_L_SQUOTE] = ACTIONS(3382),
    [anon_sym_u_SQUOTE] = ACTIONS(3382),
    [anon_sym_U_SQUOTE] = ACTIONS(3382),
    [anon_sym_u8_SQUOTE] = ACTIONS(3382),
    [anon_sym_SQUOTE] = ACTIONS(3382),
    [anon_sym_L_DQUOTE] = ACTIONS(3382),
    [anon_sym_u_DQUOTE] = ACTIONS(3382),
    [anon_sym_U_DQUOTE] = ACTIONS(3382),
    [anon_sym_u8_DQUOTE] = ACTIONS(3382),
    [anon_sym_DQUOTE] = ACTIONS(3382),
    [sym_true] = ACTIONS(3384),
    [sym_false] = ACTIONS(3384),
    [anon_sym_NULL] = ACTIONS(3384),
    [anon_sym_nullptr] = ACTIONS(3384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3384),
    [anon_sym_let] = ACTIONS(3384),
    [anon_sym_This] = ACTIONS(3384),
    [anon_sym_decltype] = ACTIONS(3384),
    [anon_sym_final] = ACTIONS(3384),
    [anon_sym_override] = ACTIONS(3384),
    [sym_virtual] = ACTIONS(3384),
    [anon_sym_explicit] = ACTIONS(3384),
    [anon_sym_typename] = ACTIONS(3384),
    [anon_sym_template] = ACTIONS(3384),
    [anon_sym_GT2] = ACTIONS(3382),
    [anon_sym_operator] = ACTIONS(3384),
    [anon_sym_try] = ACTIONS(3384),
    [anon_sym_delete] = ACTIONS(3384),
    [anon_sym_throw] = ACTIONS(3384),
    [anon_sym_namespace] = ACTIONS(3384),
    [anon_sym_using] = ACTIONS(3384),
    [anon_sym_static_assert] = ACTIONS(3384),
    [anon_sym_concept] = ACTIONS(3384),
    [anon_sym_co_return] = ACTIONS(3384),
    [anon_sym_co_yield] = ACTIONS(3384),
    [anon_sym_R_DQUOTE] = ACTIONS(3382),
    [anon_sym_LR_DQUOTE] = ACTIONS(3382),
    [anon_sym_uR_DQUOTE] = ACTIONS(3382),
    [anon_sym_UR_DQUOTE] = ACTIONS(3382),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3382),
    [anon_sym_co_await] = ACTIONS(3384),
    [anon_sym_new] = ACTIONS(3384),
    [anon_sym_requires] = ACTIONS(3384),
    [sym_this] = ACTIONS(3384),
    [anon_sym_precise] = ACTIONS(3384),
    [anon_sym_shared] = ACTIONS(3384),
    [anon_sym_groupshared] = ACTIONS(3384),
    [anon_sym_uniform] = ACTIONS(3384),
    [anon_sym_row_major] = ACTIONS(3384),
    [anon_sym_column_major] = ACTIONS(3384),
    [anon_sym_globallycoherent] = ACTIONS(3384),
    [anon_sym_centroid] = ACTIONS(3384),
    [anon_sym_noperspective] = ACTIONS(3384),
    [anon_sym_nointerpolation] = ACTIONS(3384),
    [anon_sym_sample] = ACTIONS(3384),
    [anon_sym_linear] = ACTIONS(3384),
    [anon_sym_snorm] = ACTIONS(3384),
    [anon_sym_unorm] = ACTIONS(3384),
    [anon_sym_point] = ACTIONS(3384),
    [anon_sym_line] = ACTIONS(3384),
    [anon_sym_triangleadj] = ACTIONS(3384),
    [anon_sym_lineadj] = ACTIONS(3384),
    [anon_sym_triangle] = ACTIONS(3384),
    [anon_sym_interface] = ACTIONS(3384),
    [anon_sym_extension] = ACTIONS(3384),
    [anon_sym_where] = ACTIONS(3384),
    [anon_sym___exported] = ACTIONS(3384),
    [anon_sym_import] = ACTIONS(3384),
  },
  [435] = {
    [ts_builtin_sym_end] = ACTIONS(3386),
    [sym_identifier] = ACTIONS(3388),
    [aux_sym_preproc_include_token1] = ACTIONS(3388),
    [aux_sym_preproc_def_token1] = ACTIONS(3388),
    [anon_sym_COMMA] = ACTIONS(3386),
    [anon_sym_RPAREN] = ACTIONS(3386),
    [aux_sym_preproc_if_token1] = ACTIONS(3388),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3388),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3388),
    [sym_preproc_directive] = ACTIONS(3388),
    [anon_sym_LPAREN2] = ACTIONS(3386),
    [anon_sym_BANG] = ACTIONS(3386),
    [anon_sym_TILDE] = ACTIONS(3386),
    [anon_sym_DASH] = ACTIONS(3388),
    [anon_sym_PLUS] = ACTIONS(3388),
    [anon_sym_STAR] = ACTIONS(3386),
    [anon_sym_AMP_AMP] = ACTIONS(3386),
    [anon_sym_AMP] = ACTIONS(3388),
    [anon_sym_SEMI] = ACTIONS(3386),
    [anon_sym___extension__] = ACTIONS(3388),
    [anon_sym_typedef] = ACTIONS(3388),
    [anon_sym_in] = ACTIONS(3388),
    [anon_sym_out] = ACTIONS(3388),
    [anon_sym_inout] = ACTIONS(3388),
    [anon_sym_extern] = ACTIONS(3388),
    [anon_sym___attribute__] = ACTIONS(3388),
    [anon_sym_COLON_COLON] = ACTIONS(3386),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3386),
    [anon_sym___declspec] = ACTIONS(3388),
    [anon_sym___based] = ACTIONS(3388),
    [anon_sym___cdecl] = ACTIONS(3388),
    [anon_sym___clrcall] = ACTIONS(3388),
    [anon_sym___stdcall] = ACTIONS(3388),
    [anon_sym___fastcall] = ACTIONS(3388),
    [anon_sym___thiscall] = ACTIONS(3388),
    [anon_sym___vectorcall] = ACTIONS(3388),
    [anon_sym_LBRACE] = ACTIONS(3386),
    [anon_sym_signed] = ACTIONS(3388),
    [anon_sym_unsigned] = ACTIONS(3388),
    [anon_sym_long] = ACTIONS(3388),
    [anon_sym_short] = ACTIONS(3388),
    [anon_sym_LBRACK] = ACTIONS(3388),
    [anon_sym_static] = ACTIONS(3388),
    [anon_sym_register] = ACTIONS(3388),
    [anon_sym_inline] = ACTIONS(3388),
    [anon_sym___inline] = ACTIONS(3388),
    [anon_sym___inline__] = ACTIONS(3388),
    [anon_sym___forceinline] = ACTIONS(3388),
    [anon_sym_thread_local] = ACTIONS(3388),
    [anon_sym___thread] = ACTIONS(3388),
    [anon_sym_const] = ACTIONS(3388),
    [anon_sym_constexpr] = ACTIONS(3388),
    [anon_sym_volatile] = ACTIONS(3388),
    [anon_sym_restrict] = ACTIONS(3388),
    [anon_sym___restrict__] = ACTIONS(3388),
    [anon_sym__Atomic] = ACTIONS(3388),
    [anon_sym__Noreturn] = ACTIONS(3388),
    [anon_sym_noreturn] = ACTIONS(3388),
    [anon_sym_mutable] = ACTIONS(3388),
    [anon_sym_constinit] = ACTIONS(3388),
    [anon_sym_consteval] = ACTIONS(3388),
    [anon_sym_alignas] = ACTIONS(3388),
    [anon_sym__Alignas] = ACTIONS(3388),
    [sym_primitive_type] = ACTIONS(3388),
    [anon_sym_enum] = ACTIONS(3388),
    [anon_sym_class] = ACTIONS(3388),
    [anon_sym_struct] = ACTIONS(3388),
    [anon_sym_union] = ACTIONS(3388),
    [anon_sym_if] = ACTIONS(3388),
    [anon_sym_switch] = ACTIONS(3388),
    [anon_sym_case] = ACTIONS(3388),
    [anon_sym_default] = ACTIONS(3388),
    [anon_sym_while] = ACTIONS(3388),
    [anon_sym_do] = ACTIONS(3388),
    [anon_sym_for] = ACTIONS(3388),
    [anon_sym_return] = ACTIONS(3388),
    [anon_sym_break] = ACTIONS(3388),
    [anon_sym_continue] = ACTIONS(3388),
    [anon_sym_goto] = ACTIONS(3388),
    [anon_sym_not] = ACTIONS(3388),
    [anon_sym_compl] = ACTIONS(3388),
    [anon_sym_DASH_DASH] = ACTIONS(3386),
    [anon_sym_PLUS_PLUS] = ACTIONS(3386),
    [anon_sym_sizeof] = ACTIONS(3388),
    [anon_sym___alignof__] = ACTIONS(3388),
    [anon_sym___alignof] = ACTIONS(3388),
    [anon_sym__alignof] = ACTIONS(3388),
    [anon_sym_alignof] = ACTIONS(3388),
    [anon_sym__Alignof] = ACTIONS(3388),
    [anon_sym_offsetof] = ACTIONS(3388),
    [anon_sym__Generic] = ACTIONS(3388),
    [anon_sym_asm] = ACTIONS(3388),
    [anon_sym___asm__] = ACTIONS(3388),
    [anon_sym_DOT] = ACTIONS(3388),
    [sym_number_literal] = ACTIONS(3386),
    [anon_sym_L_SQUOTE] = ACTIONS(3386),
    [anon_sym_u_SQUOTE] = ACTIONS(3386),
    [anon_sym_U_SQUOTE] = ACTIONS(3386),
    [anon_sym_u8_SQUOTE] = ACTIONS(3386),
    [anon_sym_SQUOTE] = ACTIONS(3386),
    [anon_sym_L_DQUOTE] = ACTIONS(3386),
    [anon_sym_u_DQUOTE] = ACTIONS(3386),
    [anon_sym_U_DQUOTE] = ACTIONS(3386),
    [anon_sym_u8_DQUOTE] = ACTIONS(3386),
    [anon_sym_DQUOTE] = ACTIONS(3386),
    [sym_true] = ACTIONS(3388),
    [sym_false] = ACTIONS(3388),
    [anon_sym_NULL] = ACTIONS(3388),
    [anon_sym_nullptr] = ACTIONS(3388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3388),
    [anon_sym_let] = ACTIONS(3388),
    [anon_sym_This] = ACTIONS(3388),
    [anon_sym_decltype] = ACTIONS(3388),
    [anon_sym_final] = ACTIONS(3388),
    [anon_sym_override] = ACTIONS(3388),
    [sym_virtual] = ACTIONS(3388),
    [anon_sym_explicit] = ACTIONS(3388),
    [anon_sym_typename] = ACTIONS(3388),
    [anon_sym_template] = ACTIONS(3388),
    [anon_sym_GT2] = ACTIONS(3386),
    [anon_sym_operator] = ACTIONS(3388),
    [anon_sym_try] = ACTIONS(3388),
    [anon_sym_delete] = ACTIONS(3388),
    [anon_sym_throw] = ACTIONS(3388),
    [anon_sym_namespace] = ACTIONS(3388),
    [anon_sym_using] = ACTIONS(3388),
    [anon_sym_static_assert] = ACTIONS(3388),
    [anon_sym_concept] = ACTIONS(3388),
    [anon_sym_co_return] = ACTIONS(3388),
    [anon_sym_co_yield] = ACTIONS(3388),
    [anon_sym_R_DQUOTE] = ACTIONS(3386),
    [anon_sym_LR_DQUOTE] = ACTIONS(3386),
    [anon_sym_uR_DQUOTE] = ACTIONS(3386),
    [anon_sym_UR_DQUOTE] = ACTIONS(3386),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3386),
    [anon_sym_co_await] = ACTIONS(3388),
    [anon_sym_new] = ACTIONS(3388),
    [anon_sym_requires] = ACTIONS(3388),
    [sym_this] = ACTIONS(3388),
    [anon_sym_precise] = ACTIONS(3388),
    [anon_sym_shared] = ACTIONS(3388),
    [anon_sym_groupshared] = ACTIONS(3388),
    [anon_sym_uniform] = ACTIONS(3388),
    [anon_sym_row_major] = ACTIONS(3388),
    [anon_sym_column_major] = ACTIONS(3388),
    [anon_sym_globallycoherent] = ACTIONS(3388),
    [anon_sym_centroid] = ACTIONS(3388),
    [anon_sym_noperspective] = ACTIONS(3388),
    [anon_sym_nointerpolation] = ACTIONS(3388),
    [anon_sym_sample] = ACTIONS(3388),
    [anon_sym_linear] = ACTIONS(3388),
    [anon_sym_snorm] = ACTIONS(3388),
    [anon_sym_unorm] = ACTIONS(3388),
    [anon_sym_point] = ACTIONS(3388),
    [anon_sym_line] = ACTIONS(3388),
    [anon_sym_triangleadj] = ACTIONS(3388),
    [anon_sym_lineadj] = ACTIONS(3388),
    [anon_sym_triangle] = ACTIONS(3388),
    [anon_sym_interface] = ACTIONS(3388),
    [anon_sym_extension] = ACTIONS(3388),
    [anon_sym_where] = ACTIONS(3388),
    [anon_sym___exported] = ACTIONS(3388),
    [anon_sym_import] = ACTIONS(3388),
  },
  [436] = {
    [ts_builtin_sym_end] = ACTIONS(3336),
    [sym_identifier] = ACTIONS(3338),
    [aux_sym_preproc_include_token1] = ACTIONS(3338),
    [aux_sym_preproc_def_token1] = ACTIONS(3338),
    [anon_sym_COMMA] = ACTIONS(3336),
    [anon_sym_RPAREN] = ACTIONS(3336),
    [aux_sym_preproc_if_token1] = ACTIONS(3338),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3338),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3338),
    [sym_preproc_directive] = ACTIONS(3338),
    [anon_sym_LPAREN2] = ACTIONS(3336),
    [anon_sym_BANG] = ACTIONS(3336),
    [anon_sym_TILDE] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3338),
    [anon_sym_PLUS] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_AMP] = ACTIONS(3338),
    [anon_sym_SEMI] = ACTIONS(3336),
    [anon_sym___extension__] = ACTIONS(3338),
    [anon_sym_typedef] = ACTIONS(3338),
    [anon_sym_in] = ACTIONS(3338),
    [anon_sym_out] = ACTIONS(3338),
    [anon_sym_inout] = ACTIONS(3338),
    [anon_sym_extern] = ACTIONS(3338),
    [anon_sym___attribute__] = ACTIONS(3338),
    [anon_sym_COLON_COLON] = ACTIONS(3336),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3336),
    [anon_sym___declspec] = ACTIONS(3338),
    [anon_sym___based] = ACTIONS(3338),
    [anon_sym___cdecl] = ACTIONS(3338),
    [anon_sym___clrcall] = ACTIONS(3338),
    [anon_sym___stdcall] = ACTIONS(3338),
    [anon_sym___fastcall] = ACTIONS(3338),
    [anon_sym___thiscall] = ACTIONS(3338),
    [anon_sym___vectorcall] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_signed] = ACTIONS(3338),
    [anon_sym_unsigned] = ACTIONS(3338),
    [anon_sym_long] = ACTIONS(3338),
    [anon_sym_short] = ACTIONS(3338),
    [anon_sym_LBRACK] = ACTIONS(3338),
    [anon_sym_static] = ACTIONS(3338),
    [anon_sym_register] = ACTIONS(3338),
    [anon_sym_inline] = ACTIONS(3338),
    [anon_sym___inline] = ACTIONS(3338),
    [anon_sym___inline__] = ACTIONS(3338),
    [anon_sym___forceinline] = ACTIONS(3338),
    [anon_sym_thread_local] = ACTIONS(3338),
    [anon_sym___thread] = ACTIONS(3338),
    [anon_sym_const] = ACTIONS(3338),
    [anon_sym_constexpr] = ACTIONS(3338),
    [anon_sym_volatile] = ACTIONS(3338),
    [anon_sym_restrict] = ACTIONS(3338),
    [anon_sym___restrict__] = ACTIONS(3338),
    [anon_sym__Atomic] = ACTIONS(3338),
    [anon_sym__Noreturn] = ACTIONS(3338),
    [anon_sym_noreturn] = ACTIONS(3338),
    [anon_sym_mutable] = ACTIONS(3338),
    [anon_sym_constinit] = ACTIONS(3338),
    [anon_sym_consteval] = ACTIONS(3338),
    [anon_sym_alignas] = ACTIONS(3338),
    [anon_sym__Alignas] = ACTIONS(3338),
    [sym_primitive_type] = ACTIONS(3338),
    [anon_sym_enum] = ACTIONS(3338),
    [anon_sym_class] = ACTIONS(3338),
    [anon_sym_struct] = ACTIONS(3338),
    [anon_sym_union] = ACTIONS(3338),
    [anon_sym_if] = ACTIONS(3338),
    [anon_sym_switch] = ACTIONS(3338),
    [anon_sym_case] = ACTIONS(3338),
    [anon_sym_default] = ACTIONS(3338),
    [anon_sym_while] = ACTIONS(3338),
    [anon_sym_do] = ACTIONS(3338),
    [anon_sym_for] = ACTIONS(3338),
    [anon_sym_return] = ACTIONS(3338),
    [anon_sym_break] = ACTIONS(3338),
    [anon_sym_continue] = ACTIONS(3338),
    [anon_sym_goto] = ACTIONS(3338),
    [anon_sym_not] = ACTIONS(3338),
    [anon_sym_compl] = ACTIONS(3338),
    [anon_sym_DASH_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_PLUS] = ACTIONS(3336),
    [anon_sym_sizeof] = ACTIONS(3338),
    [anon_sym___alignof__] = ACTIONS(3338),
    [anon_sym___alignof] = ACTIONS(3338),
    [anon_sym__alignof] = ACTIONS(3338),
    [anon_sym_alignof] = ACTIONS(3338),
    [anon_sym__Alignof] = ACTIONS(3338),
    [anon_sym_offsetof] = ACTIONS(3338),
    [anon_sym__Generic] = ACTIONS(3338),
    [anon_sym_asm] = ACTIONS(3338),
    [anon_sym___asm__] = ACTIONS(3338),
    [anon_sym_DOT] = ACTIONS(3338),
    [sym_number_literal] = ACTIONS(3336),
    [anon_sym_L_SQUOTE] = ACTIONS(3336),
    [anon_sym_u_SQUOTE] = ACTIONS(3336),
    [anon_sym_U_SQUOTE] = ACTIONS(3336),
    [anon_sym_u8_SQUOTE] = ACTIONS(3336),
    [anon_sym_SQUOTE] = ACTIONS(3336),
    [anon_sym_L_DQUOTE] = ACTIONS(3336),
    [anon_sym_u_DQUOTE] = ACTIONS(3336),
    [anon_sym_U_DQUOTE] = ACTIONS(3336),
    [anon_sym_u8_DQUOTE] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(3336),
    [sym_true] = ACTIONS(3338),
    [sym_false] = ACTIONS(3338),
    [anon_sym_NULL] = ACTIONS(3338),
    [anon_sym_nullptr] = ACTIONS(3338),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3338),
    [anon_sym_let] = ACTIONS(3338),
    [anon_sym_This] = ACTIONS(3338),
    [anon_sym_decltype] = ACTIONS(3338),
    [anon_sym_final] = ACTIONS(3338),
    [anon_sym_override] = ACTIONS(3338),
    [sym_virtual] = ACTIONS(3338),
    [anon_sym_explicit] = ACTIONS(3338),
    [anon_sym_typename] = ACTIONS(3338),
    [anon_sym_template] = ACTIONS(3338),
    [anon_sym_GT2] = ACTIONS(3336),
    [anon_sym_operator] = ACTIONS(3338),
    [anon_sym_try] = ACTIONS(3338),
    [anon_sym_delete] = ACTIONS(3338),
    [anon_sym_throw] = ACTIONS(3338),
    [anon_sym_namespace] = ACTIONS(3338),
    [anon_sym_using] = ACTIONS(3338),
    [anon_sym_static_assert] = ACTIONS(3338),
    [anon_sym_concept] = ACTIONS(3338),
    [anon_sym_co_return] = ACTIONS(3338),
    [anon_sym_co_yield] = ACTIONS(3338),
    [anon_sym_R_DQUOTE] = ACTIONS(3336),
    [anon_sym_LR_DQUOTE] = ACTIONS(3336),
    [anon_sym_uR_DQUOTE] = ACTIONS(3336),
    [anon_sym_UR_DQUOTE] = ACTIONS(3336),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3336),
    [anon_sym_co_await] = ACTIONS(3338),
    [anon_sym_new] = ACTIONS(3338),
    [anon_sym_requires] = ACTIONS(3338),
    [sym_this] = ACTIONS(3338),
    [anon_sym_precise] = ACTIONS(3338),
    [anon_sym_shared] = ACTIONS(3338),
    [anon_sym_groupshared] = ACTIONS(3338),
    [anon_sym_uniform] = ACTIONS(3338),
    [anon_sym_row_major] = ACTIONS(3338),
    [anon_sym_column_major] = ACTIONS(3338),
    [anon_sym_globallycoherent] = ACTIONS(3338),
    [anon_sym_centroid] = ACTIONS(3338),
    [anon_sym_noperspective] = ACTIONS(3338),
    [anon_sym_nointerpolation] = ACTIONS(3338),
    [anon_sym_sample] = ACTIONS(3338),
    [anon_sym_linear] = ACTIONS(3338),
    [anon_sym_snorm] = ACTIONS(3338),
    [anon_sym_unorm] = ACTIONS(3338),
    [anon_sym_point] = ACTIONS(3338),
    [anon_sym_line] = ACTIONS(3338),
    [anon_sym_triangleadj] = ACTIONS(3338),
    [anon_sym_lineadj] = ACTIONS(3338),
    [anon_sym_triangle] = ACTIONS(3338),
    [anon_sym_interface] = ACTIONS(3338),
    [anon_sym_extension] = ACTIONS(3338),
    [anon_sym_where] = ACTIONS(3338),
    [anon_sym___exported] = ACTIONS(3338),
    [anon_sym_import] = ACTIONS(3338),
  },
  [437] = {
    [ts_builtin_sym_end] = ACTIONS(3390),
    [sym_identifier] = ACTIONS(3392),
    [aux_sym_preproc_include_token1] = ACTIONS(3392),
    [aux_sym_preproc_def_token1] = ACTIONS(3392),
    [anon_sym_COMMA] = ACTIONS(3390),
    [anon_sym_RPAREN] = ACTIONS(3390),
    [aux_sym_preproc_if_token1] = ACTIONS(3392),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3392),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3392),
    [sym_preproc_directive] = ACTIONS(3392),
    [anon_sym_LPAREN2] = ACTIONS(3390),
    [anon_sym_BANG] = ACTIONS(3390),
    [anon_sym_TILDE] = ACTIONS(3390),
    [anon_sym_DASH] = ACTIONS(3392),
    [anon_sym_PLUS] = ACTIONS(3392),
    [anon_sym_STAR] = ACTIONS(3390),
    [anon_sym_AMP_AMP] = ACTIONS(3390),
    [anon_sym_AMP] = ACTIONS(3392),
    [anon_sym_SEMI] = ACTIONS(3390),
    [anon_sym___extension__] = ACTIONS(3392),
    [anon_sym_typedef] = ACTIONS(3392),
    [anon_sym_in] = ACTIONS(3392),
    [anon_sym_out] = ACTIONS(3392),
    [anon_sym_inout] = ACTIONS(3392),
    [anon_sym_extern] = ACTIONS(3392),
    [anon_sym___attribute__] = ACTIONS(3392),
    [anon_sym_COLON_COLON] = ACTIONS(3390),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3390),
    [anon_sym___declspec] = ACTIONS(3392),
    [anon_sym___based] = ACTIONS(3392),
    [anon_sym___cdecl] = ACTIONS(3392),
    [anon_sym___clrcall] = ACTIONS(3392),
    [anon_sym___stdcall] = ACTIONS(3392),
    [anon_sym___fastcall] = ACTIONS(3392),
    [anon_sym___thiscall] = ACTIONS(3392),
    [anon_sym___vectorcall] = ACTIONS(3392),
    [anon_sym_LBRACE] = ACTIONS(3390),
    [anon_sym_signed] = ACTIONS(3392),
    [anon_sym_unsigned] = ACTIONS(3392),
    [anon_sym_long] = ACTIONS(3392),
    [anon_sym_short] = ACTIONS(3392),
    [anon_sym_LBRACK] = ACTIONS(3392),
    [anon_sym_static] = ACTIONS(3392),
    [anon_sym_register] = ACTIONS(3392),
    [anon_sym_inline] = ACTIONS(3392),
    [anon_sym___inline] = ACTIONS(3392),
    [anon_sym___inline__] = ACTIONS(3392),
    [anon_sym___forceinline] = ACTIONS(3392),
    [anon_sym_thread_local] = ACTIONS(3392),
    [anon_sym___thread] = ACTIONS(3392),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_constexpr] = ACTIONS(3392),
    [anon_sym_volatile] = ACTIONS(3392),
    [anon_sym_restrict] = ACTIONS(3392),
    [anon_sym___restrict__] = ACTIONS(3392),
    [anon_sym__Atomic] = ACTIONS(3392),
    [anon_sym__Noreturn] = ACTIONS(3392),
    [anon_sym_noreturn] = ACTIONS(3392),
    [anon_sym_mutable] = ACTIONS(3392),
    [anon_sym_constinit] = ACTIONS(3392),
    [anon_sym_consteval] = ACTIONS(3392),
    [anon_sym_alignas] = ACTIONS(3392),
    [anon_sym__Alignas] = ACTIONS(3392),
    [sym_primitive_type] = ACTIONS(3392),
    [anon_sym_enum] = ACTIONS(3392),
    [anon_sym_class] = ACTIONS(3392),
    [anon_sym_struct] = ACTIONS(3392),
    [anon_sym_union] = ACTIONS(3392),
    [anon_sym_if] = ACTIONS(3392),
    [anon_sym_switch] = ACTIONS(3392),
    [anon_sym_case] = ACTIONS(3392),
    [anon_sym_default] = ACTIONS(3392),
    [anon_sym_while] = ACTIONS(3392),
    [anon_sym_do] = ACTIONS(3392),
    [anon_sym_for] = ACTIONS(3392),
    [anon_sym_return] = ACTIONS(3392),
    [anon_sym_break] = ACTIONS(3392),
    [anon_sym_continue] = ACTIONS(3392),
    [anon_sym_goto] = ACTIONS(3392),
    [anon_sym_not] = ACTIONS(3392),
    [anon_sym_compl] = ACTIONS(3392),
    [anon_sym_DASH_DASH] = ACTIONS(3390),
    [anon_sym_PLUS_PLUS] = ACTIONS(3390),
    [anon_sym_sizeof] = ACTIONS(3392),
    [anon_sym___alignof__] = ACTIONS(3392),
    [anon_sym___alignof] = ACTIONS(3392),
    [anon_sym__alignof] = ACTIONS(3392),
    [anon_sym_alignof] = ACTIONS(3392),
    [anon_sym__Alignof] = ACTIONS(3392),
    [anon_sym_offsetof] = ACTIONS(3392),
    [anon_sym__Generic] = ACTIONS(3392),
    [anon_sym_asm] = ACTIONS(3392),
    [anon_sym___asm__] = ACTIONS(3392),
    [anon_sym_DOT] = ACTIONS(3392),
    [sym_number_literal] = ACTIONS(3390),
    [anon_sym_L_SQUOTE] = ACTIONS(3390),
    [anon_sym_u_SQUOTE] = ACTIONS(3390),
    [anon_sym_U_SQUOTE] = ACTIONS(3390),
    [anon_sym_u8_SQUOTE] = ACTIONS(3390),
    [anon_sym_SQUOTE] = ACTIONS(3390),
    [anon_sym_L_DQUOTE] = ACTIONS(3390),
    [anon_sym_u_DQUOTE] = ACTIONS(3390),
    [anon_sym_U_DQUOTE] = ACTIONS(3390),
    [anon_sym_u8_DQUOTE] = ACTIONS(3390),
    [anon_sym_DQUOTE] = ACTIONS(3390),
    [sym_true] = ACTIONS(3392),
    [sym_false] = ACTIONS(3392),
    [anon_sym_NULL] = ACTIONS(3392),
    [anon_sym_nullptr] = ACTIONS(3392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3392),
    [anon_sym_let] = ACTIONS(3392),
    [anon_sym_This] = ACTIONS(3392),
    [anon_sym_decltype] = ACTIONS(3392),
    [anon_sym_final] = ACTIONS(3392),
    [anon_sym_override] = ACTIONS(3392),
    [sym_virtual] = ACTIONS(3392),
    [anon_sym_explicit] = ACTIONS(3392),
    [anon_sym_typename] = ACTIONS(3392),
    [anon_sym_template] = ACTIONS(3392),
    [anon_sym_GT2] = ACTIONS(3390),
    [anon_sym_operator] = ACTIONS(3392),
    [anon_sym_try] = ACTIONS(3392),
    [anon_sym_delete] = ACTIONS(3392),
    [anon_sym_throw] = ACTIONS(3392),
    [anon_sym_namespace] = ACTIONS(3392),
    [anon_sym_using] = ACTIONS(3392),
    [anon_sym_static_assert] = ACTIONS(3392),
    [anon_sym_concept] = ACTIONS(3392),
    [anon_sym_co_return] = ACTIONS(3392),
    [anon_sym_co_yield] = ACTIONS(3392),
    [anon_sym_R_DQUOTE] = ACTIONS(3390),
    [anon_sym_LR_DQUOTE] = ACTIONS(3390),
    [anon_sym_uR_DQUOTE] = ACTIONS(3390),
    [anon_sym_UR_DQUOTE] = ACTIONS(3390),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3390),
    [anon_sym_co_await] = ACTIONS(3392),
    [anon_sym_new] = ACTIONS(3392),
    [anon_sym_requires] = ACTIONS(3392),
    [sym_this] = ACTIONS(3392),
    [anon_sym_precise] = ACTIONS(3392),
    [anon_sym_shared] = ACTIONS(3392),
    [anon_sym_groupshared] = ACTIONS(3392),
    [anon_sym_uniform] = ACTIONS(3392),
    [anon_sym_row_major] = ACTIONS(3392),
    [anon_sym_column_major] = ACTIONS(3392),
    [anon_sym_globallycoherent] = ACTIONS(3392),
    [anon_sym_centroid] = ACTIONS(3392),
    [anon_sym_noperspective] = ACTIONS(3392),
    [anon_sym_nointerpolation] = ACTIONS(3392),
    [anon_sym_sample] = ACTIONS(3392),
    [anon_sym_linear] = ACTIONS(3392),
    [anon_sym_snorm] = ACTIONS(3392),
    [anon_sym_unorm] = ACTIONS(3392),
    [anon_sym_point] = ACTIONS(3392),
    [anon_sym_line] = ACTIONS(3392),
    [anon_sym_triangleadj] = ACTIONS(3392),
    [anon_sym_lineadj] = ACTIONS(3392),
    [anon_sym_triangle] = ACTIONS(3392),
    [anon_sym_interface] = ACTIONS(3392),
    [anon_sym_extension] = ACTIONS(3392),
    [anon_sym_where] = ACTIONS(3392),
    [anon_sym___exported] = ACTIONS(3392),
    [anon_sym_import] = ACTIONS(3392),
  },
  [438] = {
    [ts_builtin_sym_end] = ACTIONS(3394),
    [sym_identifier] = ACTIONS(3396),
    [aux_sym_preproc_include_token1] = ACTIONS(3396),
    [aux_sym_preproc_def_token1] = ACTIONS(3396),
    [anon_sym_COMMA] = ACTIONS(3394),
    [anon_sym_RPAREN] = ACTIONS(3394),
    [aux_sym_preproc_if_token1] = ACTIONS(3396),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3396),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3396),
    [sym_preproc_directive] = ACTIONS(3396),
    [anon_sym_LPAREN2] = ACTIONS(3394),
    [anon_sym_BANG] = ACTIONS(3394),
    [anon_sym_TILDE] = ACTIONS(3394),
    [anon_sym_DASH] = ACTIONS(3396),
    [anon_sym_PLUS] = ACTIONS(3396),
    [anon_sym_STAR] = ACTIONS(3394),
    [anon_sym_AMP_AMP] = ACTIONS(3394),
    [anon_sym_AMP] = ACTIONS(3396),
    [anon_sym_SEMI] = ACTIONS(3394),
    [anon_sym___extension__] = ACTIONS(3396),
    [anon_sym_typedef] = ACTIONS(3396),
    [anon_sym_in] = ACTIONS(3396),
    [anon_sym_out] = ACTIONS(3396),
    [anon_sym_inout] = ACTIONS(3396),
    [anon_sym_extern] = ACTIONS(3396),
    [anon_sym___attribute__] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(3394),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3394),
    [anon_sym___declspec] = ACTIONS(3396),
    [anon_sym___based] = ACTIONS(3396),
    [anon_sym___cdecl] = ACTIONS(3396),
    [anon_sym___clrcall] = ACTIONS(3396),
    [anon_sym___stdcall] = ACTIONS(3396),
    [anon_sym___fastcall] = ACTIONS(3396),
    [anon_sym___thiscall] = ACTIONS(3396),
    [anon_sym___vectorcall] = ACTIONS(3396),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_signed] = ACTIONS(3396),
    [anon_sym_unsigned] = ACTIONS(3396),
    [anon_sym_long] = ACTIONS(3396),
    [anon_sym_short] = ACTIONS(3396),
    [anon_sym_LBRACK] = ACTIONS(3396),
    [anon_sym_static] = ACTIONS(3396),
    [anon_sym_register] = ACTIONS(3396),
    [anon_sym_inline] = ACTIONS(3396),
    [anon_sym___inline] = ACTIONS(3396),
    [anon_sym___inline__] = ACTIONS(3396),
    [anon_sym___forceinline] = ACTIONS(3396),
    [anon_sym_thread_local] = ACTIONS(3396),
    [anon_sym___thread] = ACTIONS(3396),
    [anon_sym_const] = ACTIONS(3396),
    [anon_sym_constexpr] = ACTIONS(3396),
    [anon_sym_volatile] = ACTIONS(3396),
    [anon_sym_restrict] = ACTIONS(3396),
    [anon_sym___restrict__] = ACTIONS(3396),
    [anon_sym__Atomic] = ACTIONS(3396),
    [anon_sym__Noreturn] = ACTIONS(3396),
    [anon_sym_noreturn] = ACTIONS(3396),
    [anon_sym_mutable] = ACTIONS(3396),
    [anon_sym_constinit] = ACTIONS(3396),
    [anon_sym_consteval] = ACTIONS(3396),
    [anon_sym_alignas] = ACTIONS(3396),
    [anon_sym__Alignas] = ACTIONS(3396),
    [sym_primitive_type] = ACTIONS(3396),
    [anon_sym_enum] = ACTIONS(3396),
    [anon_sym_class] = ACTIONS(3396),
    [anon_sym_struct] = ACTIONS(3396),
    [anon_sym_union] = ACTIONS(3396),
    [anon_sym_if] = ACTIONS(3396),
    [anon_sym_switch] = ACTIONS(3396),
    [anon_sym_case] = ACTIONS(3396),
    [anon_sym_default] = ACTIONS(3396),
    [anon_sym_while] = ACTIONS(3396),
    [anon_sym_do] = ACTIONS(3396),
    [anon_sym_for] = ACTIONS(3396),
    [anon_sym_return] = ACTIONS(3396),
    [anon_sym_break] = ACTIONS(3396),
    [anon_sym_continue] = ACTIONS(3396),
    [anon_sym_goto] = ACTIONS(3396),
    [anon_sym_not] = ACTIONS(3396),
    [anon_sym_compl] = ACTIONS(3396),
    [anon_sym_DASH_DASH] = ACTIONS(3394),
    [anon_sym_PLUS_PLUS] = ACTIONS(3394),
    [anon_sym_sizeof] = ACTIONS(3396),
    [anon_sym___alignof__] = ACTIONS(3396),
    [anon_sym___alignof] = ACTIONS(3396),
    [anon_sym__alignof] = ACTIONS(3396),
    [anon_sym_alignof] = ACTIONS(3396),
    [anon_sym__Alignof] = ACTIONS(3396),
    [anon_sym_offsetof] = ACTIONS(3396),
    [anon_sym__Generic] = ACTIONS(3396),
    [anon_sym_asm] = ACTIONS(3396),
    [anon_sym___asm__] = ACTIONS(3396),
    [anon_sym_DOT] = ACTIONS(3396),
    [sym_number_literal] = ACTIONS(3394),
    [anon_sym_L_SQUOTE] = ACTIONS(3394),
    [anon_sym_u_SQUOTE] = ACTIONS(3394),
    [anon_sym_U_SQUOTE] = ACTIONS(3394),
    [anon_sym_u8_SQUOTE] = ACTIONS(3394),
    [anon_sym_SQUOTE] = ACTIONS(3394),
    [anon_sym_L_DQUOTE] = ACTIONS(3394),
    [anon_sym_u_DQUOTE] = ACTIONS(3394),
    [anon_sym_U_DQUOTE] = ACTIONS(3394),
    [anon_sym_u8_DQUOTE] = ACTIONS(3394),
    [anon_sym_DQUOTE] = ACTIONS(3394),
    [sym_true] = ACTIONS(3396),
    [sym_false] = ACTIONS(3396),
    [anon_sym_NULL] = ACTIONS(3396),
    [anon_sym_nullptr] = ACTIONS(3396),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3396),
    [anon_sym_let] = ACTIONS(3396),
    [anon_sym_This] = ACTIONS(3396),
    [anon_sym_decltype] = ACTIONS(3396),
    [anon_sym_final] = ACTIONS(3396),
    [anon_sym_override] = ACTIONS(3396),
    [sym_virtual] = ACTIONS(3396),
    [anon_sym_explicit] = ACTIONS(3396),
    [anon_sym_typename] = ACTIONS(3396),
    [anon_sym_template] = ACTIONS(3396),
    [anon_sym_GT2] = ACTIONS(3394),
    [anon_sym_operator] = ACTIONS(3396),
    [anon_sym_try] = ACTIONS(3396),
    [anon_sym_delete] = ACTIONS(3396),
    [anon_sym_throw] = ACTIONS(3396),
    [anon_sym_namespace] = ACTIONS(3396),
    [anon_sym_using] = ACTIONS(3396),
    [anon_sym_static_assert] = ACTIONS(3396),
    [anon_sym_concept] = ACTIONS(3396),
    [anon_sym_co_return] = ACTIONS(3396),
    [anon_sym_co_yield] = ACTIONS(3396),
    [anon_sym_R_DQUOTE] = ACTIONS(3394),
    [anon_sym_LR_DQUOTE] = ACTIONS(3394),
    [anon_sym_uR_DQUOTE] = ACTIONS(3394),
    [anon_sym_UR_DQUOTE] = ACTIONS(3394),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3394),
    [anon_sym_co_await] = ACTIONS(3396),
    [anon_sym_new] = ACTIONS(3396),
    [anon_sym_requires] = ACTIONS(3396),
    [sym_this] = ACTIONS(3396),
    [anon_sym_precise] = ACTIONS(3396),
    [anon_sym_shared] = ACTIONS(3396),
    [anon_sym_groupshared] = ACTIONS(3396),
    [anon_sym_uniform] = ACTIONS(3396),
    [anon_sym_row_major] = ACTIONS(3396),
    [anon_sym_column_major] = ACTIONS(3396),
    [anon_sym_globallycoherent] = ACTIONS(3396),
    [anon_sym_centroid] = ACTIONS(3396),
    [anon_sym_noperspective] = ACTIONS(3396),
    [anon_sym_nointerpolation] = ACTIONS(3396),
    [anon_sym_sample] = ACTIONS(3396),
    [anon_sym_linear] = ACTIONS(3396),
    [anon_sym_snorm] = ACTIONS(3396),
    [anon_sym_unorm] = ACTIONS(3396),
    [anon_sym_point] = ACTIONS(3396),
    [anon_sym_line] = ACTIONS(3396),
    [anon_sym_triangleadj] = ACTIONS(3396),
    [anon_sym_lineadj] = ACTIONS(3396),
    [anon_sym_triangle] = ACTIONS(3396),
    [anon_sym_interface] = ACTIONS(3396),
    [anon_sym_extension] = ACTIONS(3396),
    [anon_sym_where] = ACTIONS(3396),
    [anon_sym___exported] = ACTIONS(3396),
    [anon_sym_import] = ACTIONS(3396),
  },
  [439] = {
    [ts_builtin_sym_end] = ACTIONS(3398),
    [sym_identifier] = ACTIONS(3400),
    [aux_sym_preproc_include_token1] = ACTIONS(3400),
    [aux_sym_preproc_def_token1] = ACTIONS(3400),
    [anon_sym_COMMA] = ACTIONS(3398),
    [anon_sym_RPAREN] = ACTIONS(3398),
    [aux_sym_preproc_if_token1] = ACTIONS(3400),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3400),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3400),
    [sym_preproc_directive] = ACTIONS(3400),
    [anon_sym_LPAREN2] = ACTIONS(3398),
    [anon_sym_BANG] = ACTIONS(3398),
    [anon_sym_TILDE] = ACTIONS(3398),
    [anon_sym_DASH] = ACTIONS(3400),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_STAR] = ACTIONS(3398),
    [anon_sym_AMP_AMP] = ACTIONS(3398),
    [anon_sym_AMP] = ACTIONS(3400),
    [anon_sym_SEMI] = ACTIONS(3398),
    [anon_sym___extension__] = ACTIONS(3400),
    [anon_sym_typedef] = ACTIONS(3400),
    [anon_sym_in] = ACTIONS(3400),
    [anon_sym_out] = ACTIONS(3400),
    [anon_sym_inout] = ACTIONS(3400),
    [anon_sym_extern] = ACTIONS(3400),
    [anon_sym___attribute__] = ACTIONS(3400),
    [anon_sym_COLON_COLON] = ACTIONS(3398),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3398),
    [anon_sym___declspec] = ACTIONS(3400),
    [anon_sym___based] = ACTIONS(3400),
    [anon_sym___cdecl] = ACTIONS(3400),
    [anon_sym___clrcall] = ACTIONS(3400),
    [anon_sym___stdcall] = ACTIONS(3400),
    [anon_sym___fastcall] = ACTIONS(3400),
    [anon_sym___thiscall] = ACTIONS(3400),
    [anon_sym___vectorcall] = ACTIONS(3400),
    [anon_sym_LBRACE] = ACTIONS(3398),
    [anon_sym_signed] = ACTIONS(3400),
    [anon_sym_unsigned] = ACTIONS(3400),
    [anon_sym_long] = ACTIONS(3400),
    [anon_sym_short] = ACTIONS(3400),
    [anon_sym_LBRACK] = ACTIONS(3400),
    [anon_sym_static] = ACTIONS(3400),
    [anon_sym_register] = ACTIONS(3400),
    [anon_sym_inline] = ACTIONS(3400),
    [anon_sym___inline] = ACTIONS(3400),
    [anon_sym___inline__] = ACTIONS(3400),
    [anon_sym___forceinline] = ACTIONS(3400),
    [anon_sym_thread_local] = ACTIONS(3400),
    [anon_sym___thread] = ACTIONS(3400),
    [anon_sym_const] = ACTIONS(3400),
    [anon_sym_constexpr] = ACTIONS(3400),
    [anon_sym_volatile] = ACTIONS(3400),
    [anon_sym_restrict] = ACTIONS(3400),
    [anon_sym___restrict__] = ACTIONS(3400),
    [anon_sym__Atomic] = ACTIONS(3400),
    [anon_sym__Noreturn] = ACTIONS(3400),
    [anon_sym_noreturn] = ACTIONS(3400),
    [anon_sym_mutable] = ACTIONS(3400),
    [anon_sym_constinit] = ACTIONS(3400),
    [anon_sym_consteval] = ACTIONS(3400),
    [anon_sym_alignas] = ACTIONS(3400),
    [anon_sym__Alignas] = ACTIONS(3400),
    [sym_primitive_type] = ACTIONS(3400),
    [anon_sym_enum] = ACTIONS(3400),
    [anon_sym_class] = ACTIONS(3400),
    [anon_sym_struct] = ACTIONS(3400),
    [anon_sym_union] = ACTIONS(3400),
    [anon_sym_if] = ACTIONS(3400),
    [anon_sym_switch] = ACTIONS(3400),
    [anon_sym_case] = ACTIONS(3400),
    [anon_sym_default] = ACTIONS(3400),
    [anon_sym_while] = ACTIONS(3400),
    [anon_sym_do] = ACTIONS(3400),
    [anon_sym_for] = ACTIONS(3400),
    [anon_sym_return] = ACTIONS(3400),
    [anon_sym_break] = ACTIONS(3400),
    [anon_sym_continue] = ACTIONS(3400),
    [anon_sym_goto] = ACTIONS(3400),
    [anon_sym_not] = ACTIONS(3400),
    [anon_sym_compl] = ACTIONS(3400),
    [anon_sym_DASH_DASH] = ACTIONS(3398),
    [anon_sym_PLUS_PLUS] = ACTIONS(3398),
    [anon_sym_sizeof] = ACTIONS(3400),
    [anon_sym___alignof__] = ACTIONS(3400),
    [anon_sym___alignof] = ACTIONS(3400),
    [anon_sym__alignof] = ACTIONS(3400),
    [anon_sym_alignof] = ACTIONS(3400),
    [anon_sym__Alignof] = ACTIONS(3400),
    [anon_sym_offsetof] = ACTIONS(3400),
    [anon_sym__Generic] = ACTIONS(3400),
    [anon_sym_asm] = ACTIONS(3400),
    [anon_sym___asm__] = ACTIONS(3400),
    [anon_sym_DOT] = ACTIONS(3400),
    [sym_number_literal] = ACTIONS(3398),
    [anon_sym_L_SQUOTE] = ACTIONS(3398),
    [anon_sym_u_SQUOTE] = ACTIONS(3398),
    [anon_sym_U_SQUOTE] = ACTIONS(3398),
    [anon_sym_u8_SQUOTE] = ACTIONS(3398),
    [anon_sym_SQUOTE] = ACTIONS(3398),
    [anon_sym_L_DQUOTE] = ACTIONS(3398),
    [anon_sym_u_DQUOTE] = ACTIONS(3398),
    [anon_sym_U_DQUOTE] = ACTIONS(3398),
    [anon_sym_u8_DQUOTE] = ACTIONS(3398),
    [anon_sym_DQUOTE] = ACTIONS(3398),
    [sym_true] = ACTIONS(3400),
    [sym_false] = ACTIONS(3400),
    [anon_sym_NULL] = ACTIONS(3400),
    [anon_sym_nullptr] = ACTIONS(3400),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3400),
    [anon_sym_let] = ACTIONS(3400),
    [anon_sym_This] = ACTIONS(3400),
    [anon_sym_decltype] = ACTIONS(3400),
    [anon_sym_final] = ACTIONS(3400),
    [anon_sym_override] = ACTIONS(3400),
    [sym_virtual] = ACTIONS(3400),
    [anon_sym_explicit] = ACTIONS(3400),
    [anon_sym_typename] = ACTIONS(3400),
    [anon_sym_template] = ACTIONS(3400),
    [anon_sym_GT2] = ACTIONS(3398),
    [anon_sym_operator] = ACTIONS(3400),
    [anon_sym_try] = ACTIONS(3400),
    [anon_sym_delete] = ACTIONS(3400),
    [anon_sym_throw] = ACTIONS(3400),
    [anon_sym_namespace] = ACTIONS(3400),
    [anon_sym_using] = ACTIONS(3400),
    [anon_sym_static_assert] = ACTIONS(3400),
    [anon_sym_concept] = ACTIONS(3400),
    [anon_sym_co_return] = ACTIONS(3400),
    [anon_sym_co_yield] = ACTIONS(3400),
    [anon_sym_R_DQUOTE] = ACTIONS(3398),
    [anon_sym_LR_DQUOTE] = ACTIONS(3398),
    [anon_sym_uR_DQUOTE] = ACTIONS(3398),
    [anon_sym_UR_DQUOTE] = ACTIONS(3398),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3398),
    [anon_sym_co_await] = ACTIONS(3400),
    [anon_sym_new] = ACTIONS(3400),
    [anon_sym_requires] = ACTIONS(3400),
    [sym_this] = ACTIONS(3400),
    [anon_sym_precise] = ACTIONS(3400),
    [anon_sym_shared] = ACTIONS(3400),
    [anon_sym_groupshared] = ACTIONS(3400),
    [anon_sym_uniform] = ACTIONS(3400),
    [anon_sym_row_major] = ACTIONS(3400),
    [anon_sym_column_major] = ACTIONS(3400),
    [anon_sym_globallycoherent] = ACTIONS(3400),
    [anon_sym_centroid] = ACTIONS(3400),
    [anon_sym_noperspective] = ACTIONS(3400),
    [anon_sym_nointerpolation] = ACTIONS(3400),
    [anon_sym_sample] = ACTIONS(3400),
    [anon_sym_linear] = ACTIONS(3400),
    [anon_sym_snorm] = ACTIONS(3400),
    [anon_sym_unorm] = ACTIONS(3400),
    [anon_sym_point] = ACTIONS(3400),
    [anon_sym_line] = ACTIONS(3400),
    [anon_sym_triangleadj] = ACTIONS(3400),
    [anon_sym_lineadj] = ACTIONS(3400),
    [anon_sym_triangle] = ACTIONS(3400),
    [anon_sym_interface] = ACTIONS(3400),
    [anon_sym_extension] = ACTIONS(3400),
    [anon_sym_where] = ACTIONS(3400),
    [anon_sym___exported] = ACTIONS(3400),
    [anon_sym_import] = ACTIONS(3400),
  },
  [440] = {
    [ts_builtin_sym_end] = ACTIONS(3402),
    [sym_identifier] = ACTIONS(3404),
    [aux_sym_preproc_include_token1] = ACTIONS(3404),
    [aux_sym_preproc_def_token1] = ACTIONS(3404),
    [anon_sym_COMMA] = ACTIONS(3402),
    [anon_sym_RPAREN] = ACTIONS(3402),
    [aux_sym_preproc_if_token1] = ACTIONS(3404),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3404),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3404),
    [sym_preproc_directive] = ACTIONS(3404),
    [anon_sym_LPAREN2] = ACTIONS(3402),
    [anon_sym_BANG] = ACTIONS(3402),
    [anon_sym_TILDE] = ACTIONS(3402),
    [anon_sym_DASH] = ACTIONS(3404),
    [anon_sym_PLUS] = ACTIONS(3404),
    [anon_sym_STAR] = ACTIONS(3402),
    [anon_sym_AMP_AMP] = ACTIONS(3402),
    [anon_sym_AMP] = ACTIONS(3404),
    [anon_sym_SEMI] = ACTIONS(3402),
    [anon_sym___extension__] = ACTIONS(3404),
    [anon_sym_typedef] = ACTIONS(3404),
    [anon_sym_in] = ACTIONS(3404),
    [anon_sym_out] = ACTIONS(3404),
    [anon_sym_inout] = ACTIONS(3404),
    [anon_sym_extern] = ACTIONS(3404),
    [anon_sym___attribute__] = ACTIONS(3404),
    [anon_sym_COLON_COLON] = ACTIONS(3402),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3402),
    [anon_sym___declspec] = ACTIONS(3404),
    [anon_sym___based] = ACTIONS(3404),
    [anon_sym___cdecl] = ACTIONS(3404),
    [anon_sym___clrcall] = ACTIONS(3404),
    [anon_sym___stdcall] = ACTIONS(3404),
    [anon_sym___fastcall] = ACTIONS(3404),
    [anon_sym___thiscall] = ACTIONS(3404),
    [anon_sym___vectorcall] = ACTIONS(3404),
    [anon_sym_LBRACE] = ACTIONS(3402),
    [anon_sym_signed] = ACTIONS(3404),
    [anon_sym_unsigned] = ACTIONS(3404),
    [anon_sym_long] = ACTIONS(3404),
    [anon_sym_short] = ACTIONS(3404),
    [anon_sym_LBRACK] = ACTIONS(3404),
    [anon_sym_static] = ACTIONS(3404),
    [anon_sym_register] = ACTIONS(3404),
    [anon_sym_inline] = ACTIONS(3404),
    [anon_sym___inline] = ACTIONS(3404),
    [anon_sym___inline__] = ACTIONS(3404),
    [anon_sym___forceinline] = ACTIONS(3404),
    [anon_sym_thread_local] = ACTIONS(3404),
    [anon_sym___thread] = ACTIONS(3404),
    [anon_sym_const] = ACTIONS(3404),
    [anon_sym_constexpr] = ACTIONS(3404),
    [anon_sym_volatile] = ACTIONS(3404),
    [anon_sym_restrict] = ACTIONS(3404),
    [anon_sym___restrict__] = ACTIONS(3404),
    [anon_sym__Atomic] = ACTIONS(3404),
    [anon_sym__Noreturn] = ACTIONS(3404),
    [anon_sym_noreturn] = ACTIONS(3404),
    [anon_sym_mutable] = ACTIONS(3404),
    [anon_sym_constinit] = ACTIONS(3404),
    [anon_sym_consteval] = ACTIONS(3404),
    [anon_sym_alignas] = ACTIONS(3404),
    [anon_sym__Alignas] = ACTIONS(3404),
    [sym_primitive_type] = ACTIONS(3404),
    [anon_sym_enum] = ACTIONS(3404),
    [anon_sym_class] = ACTIONS(3404),
    [anon_sym_struct] = ACTIONS(3404),
    [anon_sym_union] = ACTIONS(3404),
    [anon_sym_if] = ACTIONS(3404),
    [anon_sym_switch] = ACTIONS(3404),
    [anon_sym_case] = ACTIONS(3404),
    [anon_sym_default] = ACTIONS(3404),
    [anon_sym_while] = ACTIONS(3404),
    [anon_sym_do] = ACTIONS(3404),
    [anon_sym_for] = ACTIONS(3404),
    [anon_sym_return] = ACTIONS(3404),
    [anon_sym_break] = ACTIONS(3404),
    [anon_sym_continue] = ACTIONS(3404),
    [anon_sym_goto] = ACTIONS(3404),
    [anon_sym_not] = ACTIONS(3404),
    [anon_sym_compl] = ACTIONS(3404),
    [anon_sym_DASH_DASH] = ACTIONS(3402),
    [anon_sym_PLUS_PLUS] = ACTIONS(3402),
    [anon_sym_sizeof] = ACTIONS(3404),
    [anon_sym___alignof__] = ACTIONS(3404),
    [anon_sym___alignof] = ACTIONS(3404),
    [anon_sym__alignof] = ACTIONS(3404),
    [anon_sym_alignof] = ACTIONS(3404),
    [anon_sym__Alignof] = ACTIONS(3404),
    [anon_sym_offsetof] = ACTIONS(3404),
    [anon_sym__Generic] = ACTIONS(3404),
    [anon_sym_asm] = ACTIONS(3404),
    [anon_sym___asm__] = ACTIONS(3404),
    [anon_sym_DOT] = ACTIONS(3404),
    [sym_number_literal] = ACTIONS(3402),
    [anon_sym_L_SQUOTE] = ACTIONS(3402),
    [anon_sym_u_SQUOTE] = ACTIONS(3402),
    [anon_sym_U_SQUOTE] = ACTIONS(3402),
    [anon_sym_u8_SQUOTE] = ACTIONS(3402),
    [anon_sym_SQUOTE] = ACTIONS(3402),
    [anon_sym_L_DQUOTE] = ACTIONS(3402),
    [anon_sym_u_DQUOTE] = ACTIONS(3402),
    [anon_sym_U_DQUOTE] = ACTIONS(3402),
    [anon_sym_u8_DQUOTE] = ACTIONS(3402),
    [anon_sym_DQUOTE] = ACTIONS(3402),
    [sym_true] = ACTIONS(3404),
    [sym_false] = ACTIONS(3404),
    [anon_sym_NULL] = ACTIONS(3404),
    [anon_sym_nullptr] = ACTIONS(3404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3404),
    [anon_sym_let] = ACTIONS(3404),
    [anon_sym_This] = ACTIONS(3404),
    [anon_sym_decltype] = ACTIONS(3404),
    [anon_sym_final] = ACTIONS(3404),
    [anon_sym_override] = ACTIONS(3404),
    [sym_virtual] = ACTIONS(3404),
    [anon_sym_explicit] = ACTIONS(3404),
    [anon_sym_typename] = ACTIONS(3404),
    [anon_sym_template] = ACTIONS(3404),
    [anon_sym_GT2] = ACTIONS(3402),
    [anon_sym_operator] = ACTIONS(3404),
    [anon_sym_try] = ACTIONS(3404),
    [anon_sym_delete] = ACTIONS(3404),
    [anon_sym_throw] = ACTIONS(3404),
    [anon_sym_namespace] = ACTIONS(3404),
    [anon_sym_using] = ACTIONS(3404),
    [anon_sym_static_assert] = ACTIONS(3404),
    [anon_sym_concept] = ACTIONS(3404),
    [anon_sym_co_return] = ACTIONS(3404),
    [anon_sym_co_yield] = ACTIONS(3404),
    [anon_sym_R_DQUOTE] = ACTIONS(3402),
    [anon_sym_LR_DQUOTE] = ACTIONS(3402),
    [anon_sym_uR_DQUOTE] = ACTIONS(3402),
    [anon_sym_UR_DQUOTE] = ACTIONS(3402),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3402),
    [anon_sym_co_await] = ACTIONS(3404),
    [anon_sym_new] = ACTIONS(3404),
    [anon_sym_requires] = ACTIONS(3404),
    [sym_this] = ACTIONS(3404),
    [anon_sym_precise] = ACTIONS(3404),
    [anon_sym_shared] = ACTIONS(3404),
    [anon_sym_groupshared] = ACTIONS(3404),
    [anon_sym_uniform] = ACTIONS(3404),
    [anon_sym_row_major] = ACTIONS(3404),
    [anon_sym_column_major] = ACTIONS(3404),
    [anon_sym_globallycoherent] = ACTIONS(3404),
    [anon_sym_centroid] = ACTIONS(3404),
    [anon_sym_noperspective] = ACTIONS(3404),
    [anon_sym_nointerpolation] = ACTIONS(3404),
    [anon_sym_sample] = ACTIONS(3404),
    [anon_sym_linear] = ACTIONS(3404),
    [anon_sym_snorm] = ACTIONS(3404),
    [anon_sym_unorm] = ACTIONS(3404),
    [anon_sym_point] = ACTIONS(3404),
    [anon_sym_line] = ACTIONS(3404),
    [anon_sym_triangleadj] = ACTIONS(3404),
    [anon_sym_lineadj] = ACTIONS(3404),
    [anon_sym_triangle] = ACTIONS(3404),
    [anon_sym_interface] = ACTIONS(3404),
    [anon_sym_extension] = ACTIONS(3404),
    [anon_sym_where] = ACTIONS(3404),
    [anon_sym___exported] = ACTIONS(3404),
    [anon_sym_import] = ACTIONS(3404),
  },
  [441] = {
    [sym_identifier] = ACTIONS(3406),
    [aux_sym_preproc_include_token1] = ACTIONS(3406),
    [aux_sym_preproc_def_token1] = ACTIONS(3406),
    [aux_sym_preproc_if_token1] = ACTIONS(3406),
    [aux_sym_preproc_if_token2] = ACTIONS(3406),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3406),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3406),
    [aux_sym_preproc_else_token1] = ACTIONS(3406),
    [aux_sym_preproc_elif_token1] = ACTIONS(3406),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3406),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3406),
    [sym_preproc_directive] = ACTIONS(3406),
    [anon_sym_LPAREN2] = ACTIONS(3408),
    [anon_sym_BANG] = ACTIONS(3408),
    [anon_sym_TILDE] = ACTIONS(3408),
    [anon_sym_DASH] = ACTIONS(3406),
    [anon_sym_PLUS] = ACTIONS(3406),
    [anon_sym_STAR] = ACTIONS(3408),
    [anon_sym_AMP_AMP] = ACTIONS(3408),
    [anon_sym_AMP] = ACTIONS(3406),
    [anon_sym_SEMI] = ACTIONS(3408),
    [anon_sym___extension__] = ACTIONS(3406),
    [anon_sym_typedef] = ACTIONS(3406),
    [anon_sym_in] = ACTIONS(3406),
    [anon_sym_out] = ACTIONS(3406),
    [anon_sym_inout] = ACTIONS(3406),
    [anon_sym_extern] = ACTIONS(3406),
    [anon_sym___attribute__] = ACTIONS(3406),
    [anon_sym_COLON_COLON] = ACTIONS(3408),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3408),
    [anon_sym___declspec] = ACTIONS(3406),
    [anon_sym___based] = ACTIONS(3406),
    [anon_sym___cdecl] = ACTIONS(3406),
    [anon_sym___clrcall] = ACTIONS(3406),
    [anon_sym___stdcall] = ACTIONS(3406),
    [anon_sym___fastcall] = ACTIONS(3406),
    [anon_sym___thiscall] = ACTIONS(3406),
    [anon_sym___vectorcall] = ACTIONS(3406),
    [anon_sym_LBRACE] = ACTIONS(3408),
    [anon_sym_signed] = ACTIONS(3406),
    [anon_sym_unsigned] = ACTIONS(3406),
    [anon_sym_long] = ACTIONS(3406),
    [anon_sym_short] = ACTIONS(3406),
    [anon_sym_LBRACK] = ACTIONS(3406),
    [anon_sym_static] = ACTIONS(3406),
    [anon_sym_register] = ACTIONS(3406),
    [anon_sym_inline] = ACTIONS(3406),
    [anon_sym___inline] = ACTIONS(3406),
    [anon_sym___inline__] = ACTIONS(3406),
    [anon_sym___forceinline] = ACTIONS(3406),
    [anon_sym_thread_local] = ACTIONS(3406),
    [anon_sym___thread] = ACTIONS(3406),
    [anon_sym_const] = ACTIONS(3406),
    [anon_sym_constexpr] = ACTIONS(3406),
    [anon_sym_volatile] = ACTIONS(3406),
    [anon_sym_restrict] = ACTIONS(3406),
    [anon_sym___restrict__] = ACTIONS(3406),
    [anon_sym__Atomic] = ACTIONS(3406),
    [anon_sym__Noreturn] = ACTIONS(3406),
    [anon_sym_noreturn] = ACTIONS(3406),
    [anon_sym_mutable] = ACTIONS(3406),
    [anon_sym_constinit] = ACTIONS(3406),
    [anon_sym_consteval] = ACTIONS(3406),
    [anon_sym_alignas] = ACTIONS(3406),
    [anon_sym__Alignas] = ACTIONS(3406),
    [sym_primitive_type] = ACTIONS(3406),
    [anon_sym_enum] = ACTIONS(3406),
    [anon_sym_class] = ACTIONS(3406),
    [anon_sym_struct] = ACTIONS(3406),
    [anon_sym_union] = ACTIONS(3406),
    [anon_sym_if] = ACTIONS(3406),
    [anon_sym_switch] = ACTIONS(3406),
    [anon_sym_case] = ACTIONS(3406),
    [anon_sym_default] = ACTIONS(3406),
    [anon_sym_while] = ACTIONS(3406),
    [anon_sym_do] = ACTIONS(3406),
    [anon_sym_for] = ACTIONS(3406),
    [anon_sym_return] = ACTIONS(3406),
    [anon_sym_break] = ACTIONS(3406),
    [anon_sym_continue] = ACTIONS(3406),
    [anon_sym_goto] = ACTIONS(3406),
    [anon_sym___try] = ACTIONS(3406),
    [anon_sym___leave] = ACTIONS(3406),
    [anon_sym_not] = ACTIONS(3406),
    [anon_sym_compl] = ACTIONS(3406),
    [anon_sym_DASH_DASH] = ACTIONS(3408),
    [anon_sym_PLUS_PLUS] = ACTIONS(3408),
    [anon_sym_sizeof] = ACTIONS(3406),
    [anon_sym___alignof__] = ACTIONS(3406),
    [anon_sym___alignof] = ACTIONS(3406),
    [anon_sym__alignof] = ACTIONS(3406),
    [anon_sym_alignof] = ACTIONS(3406),
    [anon_sym__Alignof] = ACTIONS(3406),
    [anon_sym_offsetof] = ACTIONS(3406),
    [anon_sym__Generic] = ACTIONS(3406),
    [anon_sym_asm] = ACTIONS(3406),
    [anon_sym___asm__] = ACTIONS(3406),
    [sym_number_literal] = ACTIONS(3408),
    [anon_sym_L_SQUOTE] = ACTIONS(3408),
    [anon_sym_u_SQUOTE] = ACTIONS(3408),
    [anon_sym_U_SQUOTE] = ACTIONS(3408),
    [anon_sym_u8_SQUOTE] = ACTIONS(3408),
    [anon_sym_SQUOTE] = ACTIONS(3408),
    [anon_sym_L_DQUOTE] = ACTIONS(3408),
    [anon_sym_u_DQUOTE] = ACTIONS(3408),
    [anon_sym_U_DQUOTE] = ACTIONS(3408),
    [anon_sym_u8_DQUOTE] = ACTIONS(3408),
    [anon_sym_DQUOTE] = ACTIONS(3408),
    [sym_true] = ACTIONS(3406),
    [sym_false] = ACTIONS(3406),
    [anon_sym_NULL] = ACTIONS(3406),
    [anon_sym_nullptr] = ACTIONS(3406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3406),
    [anon_sym_let] = ACTIONS(3406),
    [anon_sym_This] = ACTIONS(3406),
    [anon_sym_decltype] = ACTIONS(3406),
    [sym_virtual] = ACTIONS(3406),
    [anon_sym_explicit] = ACTIONS(3406),
    [anon_sym_typename] = ACTIONS(3406),
    [anon_sym_template] = ACTIONS(3406),
    [anon_sym_operator] = ACTIONS(3406),
    [anon_sym_try] = ACTIONS(3406),
    [anon_sym_delete] = ACTIONS(3406),
    [anon_sym_throw] = ACTIONS(3406),
    [anon_sym_namespace] = ACTIONS(3406),
    [anon_sym_using] = ACTIONS(3406),
    [anon_sym_static_assert] = ACTIONS(3406),
    [anon_sym_concept] = ACTIONS(3406),
    [anon_sym_co_return] = ACTIONS(3406),
    [anon_sym_co_yield] = ACTIONS(3406),
    [anon_sym_R_DQUOTE] = ACTIONS(3408),
    [anon_sym_LR_DQUOTE] = ACTIONS(3408),
    [anon_sym_uR_DQUOTE] = ACTIONS(3408),
    [anon_sym_UR_DQUOTE] = ACTIONS(3408),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3408),
    [anon_sym_co_await] = ACTIONS(3406),
    [anon_sym_new] = ACTIONS(3406),
    [anon_sym_requires] = ACTIONS(3406),
    [sym_this] = ACTIONS(3406),
    [anon_sym_discard] = ACTIONS(3406),
    [anon_sym_precise] = ACTIONS(3406),
    [anon_sym_shared] = ACTIONS(3406),
    [anon_sym_groupshared] = ACTIONS(3406),
    [anon_sym_uniform] = ACTIONS(3406),
    [anon_sym_row_major] = ACTIONS(3406),
    [anon_sym_column_major] = ACTIONS(3406),
    [anon_sym_globallycoherent] = ACTIONS(3406),
    [anon_sym_centroid] = ACTIONS(3406),
    [anon_sym_noperspective] = ACTIONS(3406),
    [anon_sym_nointerpolation] = ACTIONS(3406),
    [anon_sym_sample] = ACTIONS(3406),
    [anon_sym_linear] = ACTIONS(3406),
    [anon_sym_snorm] = ACTIONS(3406),
    [anon_sym_unorm] = ACTIONS(3406),
    [anon_sym_point] = ACTIONS(3406),
    [anon_sym_line] = ACTIONS(3406),
    [anon_sym_triangleadj] = ACTIONS(3406),
    [anon_sym_lineadj] = ACTIONS(3406),
    [anon_sym_triangle] = ACTIONS(3406),
    [anon_sym_cbuffer] = ACTIONS(3406),
    [anon_sym_interface] = ACTIONS(3406),
    [anon_sym_extension] = ACTIONS(3406),
  },
  [442] = {
    [sym_identifier] = ACTIONS(3410),
    [aux_sym_preproc_include_token1] = ACTIONS(3410),
    [aux_sym_preproc_def_token1] = ACTIONS(3410),
    [aux_sym_preproc_if_token1] = ACTIONS(3410),
    [aux_sym_preproc_if_token2] = ACTIONS(3410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3410),
    [aux_sym_preproc_else_token1] = ACTIONS(3410),
    [aux_sym_preproc_elif_token1] = ACTIONS(3410),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3410),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3410),
    [sym_preproc_directive] = ACTIONS(3410),
    [anon_sym_LPAREN2] = ACTIONS(3412),
    [anon_sym_BANG] = ACTIONS(3412),
    [anon_sym_TILDE] = ACTIONS(3412),
    [anon_sym_DASH] = ACTIONS(3410),
    [anon_sym_PLUS] = ACTIONS(3410),
    [anon_sym_STAR] = ACTIONS(3412),
    [anon_sym_AMP_AMP] = ACTIONS(3412),
    [anon_sym_AMP] = ACTIONS(3410),
    [anon_sym_SEMI] = ACTIONS(3412),
    [anon_sym___extension__] = ACTIONS(3410),
    [anon_sym_typedef] = ACTIONS(3410),
    [anon_sym_in] = ACTIONS(3410),
    [anon_sym_out] = ACTIONS(3410),
    [anon_sym_inout] = ACTIONS(3410),
    [anon_sym_extern] = ACTIONS(3410),
    [anon_sym___attribute__] = ACTIONS(3410),
    [anon_sym_COLON_COLON] = ACTIONS(3412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3412),
    [anon_sym___declspec] = ACTIONS(3410),
    [anon_sym___based] = ACTIONS(3410),
    [anon_sym___cdecl] = ACTIONS(3410),
    [anon_sym___clrcall] = ACTIONS(3410),
    [anon_sym___stdcall] = ACTIONS(3410),
    [anon_sym___fastcall] = ACTIONS(3410),
    [anon_sym___thiscall] = ACTIONS(3410),
    [anon_sym___vectorcall] = ACTIONS(3410),
    [anon_sym_LBRACE] = ACTIONS(3412),
    [anon_sym_signed] = ACTIONS(3410),
    [anon_sym_unsigned] = ACTIONS(3410),
    [anon_sym_long] = ACTIONS(3410),
    [anon_sym_short] = ACTIONS(3410),
    [anon_sym_LBRACK] = ACTIONS(3410),
    [anon_sym_static] = ACTIONS(3410),
    [anon_sym_register] = ACTIONS(3410),
    [anon_sym_inline] = ACTIONS(3410),
    [anon_sym___inline] = ACTIONS(3410),
    [anon_sym___inline__] = ACTIONS(3410),
    [anon_sym___forceinline] = ACTIONS(3410),
    [anon_sym_thread_local] = ACTIONS(3410),
    [anon_sym___thread] = ACTIONS(3410),
    [anon_sym_const] = ACTIONS(3410),
    [anon_sym_constexpr] = ACTIONS(3410),
    [anon_sym_volatile] = ACTIONS(3410),
    [anon_sym_restrict] = ACTIONS(3410),
    [anon_sym___restrict__] = ACTIONS(3410),
    [anon_sym__Atomic] = ACTIONS(3410),
    [anon_sym__Noreturn] = ACTIONS(3410),
    [anon_sym_noreturn] = ACTIONS(3410),
    [anon_sym_mutable] = ACTIONS(3410),
    [anon_sym_constinit] = ACTIONS(3410),
    [anon_sym_consteval] = ACTIONS(3410),
    [anon_sym_alignas] = ACTIONS(3410),
    [anon_sym__Alignas] = ACTIONS(3410),
    [sym_primitive_type] = ACTIONS(3410),
    [anon_sym_enum] = ACTIONS(3410),
    [anon_sym_class] = ACTIONS(3410),
    [anon_sym_struct] = ACTIONS(3410),
    [anon_sym_union] = ACTIONS(3410),
    [anon_sym_if] = ACTIONS(3410),
    [anon_sym_switch] = ACTIONS(3410),
    [anon_sym_case] = ACTIONS(3410),
    [anon_sym_default] = ACTIONS(3410),
    [anon_sym_while] = ACTIONS(3410),
    [anon_sym_do] = ACTIONS(3410),
    [anon_sym_for] = ACTIONS(3410),
    [anon_sym_return] = ACTIONS(3410),
    [anon_sym_break] = ACTIONS(3410),
    [anon_sym_continue] = ACTIONS(3410),
    [anon_sym_goto] = ACTIONS(3410),
    [anon_sym___try] = ACTIONS(3410),
    [anon_sym___leave] = ACTIONS(3410),
    [anon_sym_not] = ACTIONS(3410),
    [anon_sym_compl] = ACTIONS(3410),
    [anon_sym_DASH_DASH] = ACTIONS(3412),
    [anon_sym_PLUS_PLUS] = ACTIONS(3412),
    [anon_sym_sizeof] = ACTIONS(3410),
    [anon_sym___alignof__] = ACTIONS(3410),
    [anon_sym___alignof] = ACTIONS(3410),
    [anon_sym__alignof] = ACTIONS(3410),
    [anon_sym_alignof] = ACTIONS(3410),
    [anon_sym__Alignof] = ACTIONS(3410),
    [anon_sym_offsetof] = ACTIONS(3410),
    [anon_sym__Generic] = ACTIONS(3410),
    [anon_sym_asm] = ACTIONS(3410),
    [anon_sym___asm__] = ACTIONS(3410),
    [sym_number_literal] = ACTIONS(3412),
    [anon_sym_L_SQUOTE] = ACTIONS(3412),
    [anon_sym_u_SQUOTE] = ACTIONS(3412),
    [anon_sym_U_SQUOTE] = ACTIONS(3412),
    [anon_sym_u8_SQUOTE] = ACTIONS(3412),
    [anon_sym_SQUOTE] = ACTIONS(3412),
    [anon_sym_L_DQUOTE] = ACTIONS(3412),
    [anon_sym_u_DQUOTE] = ACTIONS(3412),
    [anon_sym_U_DQUOTE] = ACTIONS(3412),
    [anon_sym_u8_DQUOTE] = ACTIONS(3412),
    [anon_sym_DQUOTE] = ACTIONS(3412),
    [sym_true] = ACTIONS(3410),
    [sym_false] = ACTIONS(3410),
    [anon_sym_NULL] = ACTIONS(3410),
    [anon_sym_nullptr] = ACTIONS(3410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3410),
    [anon_sym_let] = ACTIONS(3410),
    [anon_sym_This] = ACTIONS(3410),
    [anon_sym_decltype] = ACTIONS(3410),
    [sym_virtual] = ACTIONS(3410),
    [anon_sym_explicit] = ACTIONS(3410),
    [anon_sym_typename] = ACTIONS(3410),
    [anon_sym_template] = ACTIONS(3410),
    [anon_sym_operator] = ACTIONS(3410),
    [anon_sym_try] = ACTIONS(3410),
    [anon_sym_delete] = ACTIONS(3410),
    [anon_sym_throw] = ACTIONS(3410),
    [anon_sym_namespace] = ACTIONS(3410),
    [anon_sym_using] = ACTIONS(3410),
    [anon_sym_static_assert] = ACTIONS(3410),
    [anon_sym_concept] = ACTIONS(3410),
    [anon_sym_co_return] = ACTIONS(3410),
    [anon_sym_co_yield] = ACTIONS(3410),
    [anon_sym_R_DQUOTE] = ACTIONS(3412),
    [anon_sym_LR_DQUOTE] = ACTIONS(3412),
    [anon_sym_uR_DQUOTE] = ACTIONS(3412),
    [anon_sym_UR_DQUOTE] = ACTIONS(3412),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3412),
    [anon_sym_co_await] = ACTIONS(3410),
    [anon_sym_new] = ACTIONS(3410),
    [anon_sym_requires] = ACTIONS(3410),
    [sym_this] = ACTIONS(3410),
    [anon_sym_discard] = ACTIONS(3410),
    [anon_sym_precise] = ACTIONS(3410),
    [anon_sym_shared] = ACTIONS(3410),
    [anon_sym_groupshared] = ACTIONS(3410),
    [anon_sym_uniform] = ACTIONS(3410),
    [anon_sym_row_major] = ACTIONS(3410),
    [anon_sym_column_major] = ACTIONS(3410),
    [anon_sym_globallycoherent] = ACTIONS(3410),
    [anon_sym_centroid] = ACTIONS(3410),
    [anon_sym_noperspective] = ACTIONS(3410),
    [anon_sym_nointerpolation] = ACTIONS(3410),
    [anon_sym_sample] = ACTIONS(3410),
    [anon_sym_linear] = ACTIONS(3410),
    [anon_sym_snorm] = ACTIONS(3410),
    [anon_sym_unorm] = ACTIONS(3410),
    [anon_sym_point] = ACTIONS(3410),
    [anon_sym_line] = ACTIONS(3410),
    [anon_sym_triangleadj] = ACTIONS(3410),
    [anon_sym_lineadj] = ACTIONS(3410),
    [anon_sym_triangle] = ACTIONS(3410),
    [anon_sym_cbuffer] = ACTIONS(3410),
    [anon_sym_interface] = ACTIONS(3410),
    [anon_sym_extension] = ACTIONS(3410),
  },
  [443] = {
    [sym_identifier] = ACTIONS(3414),
    [aux_sym_preproc_include_token1] = ACTIONS(3414),
    [aux_sym_preproc_def_token1] = ACTIONS(3414),
    [aux_sym_preproc_if_token1] = ACTIONS(3414),
    [aux_sym_preproc_if_token2] = ACTIONS(3414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3414),
    [aux_sym_preproc_else_token1] = ACTIONS(3414),
    [aux_sym_preproc_elif_token1] = ACTIONS(3414),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3414),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3414),
    [sym_preproc_directive] = ACTIONS(3414),
    [anon_sym_LPAREN2] = ACTIONS(3416),
    [anon_sym_BANG] = ACTIONS(3416),
    [anon_sym_TILDE] = ACTIONS(3416),
    [anon_sym_DASH] = ACTIONS(3414),
    [anon_sym_PLUS] = ACTIONS(3414),
    [anon_sym_STAR] = ACTIONS(3416),
    [anon_sym_AMP_AMP] = ACTIONS(3416),
    [anon_sym_AMP] = ACTIONS(3414),
    [anon_sym_SEMI] = ACTIONS(3416),
    [anon_sym___extension__] = ACTIONS(3414),
    [anon_sym_typedef] = ACTIONS(3414),
    [anon_sym_in] = ACTIONS(3414),
    [anon_sym_out] = ACTIONS(3414),
    [anon_sym_inout] = ACTIONS(3414),
    [anon_sym_extern] = ACTIONS(3414),
    [anon_sym___attribute__] = ACTIONS(3414),
    [anon_sym_COLON_COLON] = ACTIONS(3416),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3416),
    [anon_sym___declspec] = ACTIONS(3414),
    [anon_sym___based] = ACTIONS(3414),
    [anon_sym___cdecl] = ACTIONS(3414),
    [anon_sym___clrcall] = ACTIONS(3414),
    [anon_sym___stdcall] = ACTIONS(3414),
    [anon_sym___fastcall] = ACTIONS(3414),
    [anon_sym___thiscall] = ACTIONS(3414),
    [anon_sym___vectorcall] = ACTIONS(3414),
    [anon_sym_LBRACE] = ACTIONS(3416),
    [anon_sym_signed] = ACTIONS(3414),
    [anon_sym_unsigned] = ACTIONS(3414),
    [anon_sym_long] = ACTIONS(3414),
    [anon_sym_short] = ACTIONS(3414),
    [anon_sym_LBRACK] = ACTIONS(3414),
    [anon_sym_static] = ACTIONS(3414),
    [anon_sym_register] = ACTIONS(3414),
    [anon_sym_inline] = ACTIONS(3414),
    [anon_sym___inline] = ACTIONS(3414),
    [anon_sym___inline__] = ACTIONS(3414),
    [anon_sym___forceinline] = ACTIONS(3414),
    [anon_sym_thread_local] = ACTIONS(3414),
    [anon_sym___thread] = ACTIONS(3414),
    [anon_sym_const] = ACTIONS(3414),
    [anon_sym_constexpr] = ACTIONS(3414),
    [anon_sym_volatile] = ACTIONS(3414),
    [anon_sym_restrict] = ACTIONS(3414),
    [anon_sym___restrict__] = ACTIONS(3414),
    [anon_sym__Atomic] = ACTIONS(3414),
    [anon_sym__Noreturn] = ACTIONS(3414),
    [anon_sym_noreturn] = ACTIONS(3414),
    [anon_sym_mutable] = ACTIONS(3414),
    [anon_sym_constinit] = ACTIONS(3414),
    [anon_sym_consteval] = ACTIONS(3414),
    [anon_sym_alignas] = ACTIONS(3414),
    [anon_sym__Alignas] = ACTIONS(3414),
    [sym_primitive_type] = ACTIONS(3414),
    [anon_sym_enum] = ACTIONS(3414),
    [anon_sym_class] = ACTIONS(3414),
    [anon_sym_struct] = ACTIONS(3414),
    [anon_sym_union] = ACTIONS(3414),
    [anon_sym_if] = ACTIONS(3414),
    [anon_sym_switch] = ACTIONS(3414),
    [anon_sym_case] = ACTIONS(3414),
    [anon_sym_default] = ACTIONS(3414),
    [anon_sym_while] = ACTIONS(3414),
    [anon_sym_do] = ACTIONS(3414),
    [anon_sym_for] = ACTIONS(3414),
    [anon_sym_return] = ACTIONS(3414),
    [anon_sym_break] = ACTIONS(3414),
    [anon_sym_continue] = ACTIONS(3414),
    [anon_sym_goto] = ACTIONS(3414),
    [anon_sym___try] = ACTIONS(3414),
    [anon_sym___leave] = ACTIONS(3414),
    [anon_sym_not] = ACTIONS(3414),
    [anon_sym_compl] = ACTIONS(3414),
    [anon_sym_DASH_DASH] = ACTIONS(3416),
    [anon_sym_PLUS_PLUS] = ACTIONS(3416),
    [anon_sym_sizeof] = ACTIONS(3414),
    [anon_sym___alignof__] = ACTIONS(3414),
    [anon_sym___alignof] = ACTIONS(3414),
    [anon_sym__alignof] = ACTIONS(3414),
    [anon_sym_alignof] = ACTIONS(3414),
    [anon_sym__Alignof] = ACTIONS(3414),
    [anon_sym_offsetof] = ACTIONS(3414),
    [anon_sym__Generic] = ACTIONS(3414),
    [anon_sym_asm] = ACTIONS(3414),
    [anon_sym___asm__] = ACTIONS(3414),
    [sym_number_literal] = ACTIONS(3416),
    [anon_sym_L_SQUOTE] = ACTIONS(3416),
    [anon_sym_u_SQUOTE] = ACTIONS(3416),
    [anon_sym_U_SQUOTE] = ACTIONS(3416),
    [anon_sym_u8_SQUOTE] = ACTIONS(3416),
    [anon_sym_SQUOTE] = ACTIONS(3416),
    [anon_sym_L_DQUOTE] = ACTIONS(3416),
    [anon_sym_u_DQUOTE] = ACTIONS(3416),
    [anon_sym_U_DQUOTE] = ACTIONS(3416),
    [anon_sym_u8_DQUOTE] = ACTIONS(3416),
    [anon_sym_DQUOTE] = ACTIONS(3416),
    [sym_true] = ACTIONS(3414),
    [sym_false] = ACTIONS(3414),
    [anon_sym_NULL] = ACTIONS(3414),
    [anon_sym_nullptr] = ACTIONS(3414),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3414),
    [anon_sym_let] = ACTIONS(3414),
    [anon_sym_This] = ACTIONS(3414),
    [anon_sym_decltype] = ACTIONS(3414),
    [sym_virtual] = ACTIONS(3414),
    [anon_sym_explicit] = ACTIONS(3414),
    [anon_sym_typename] = ACTIONS(3414),
    [anon_sym_template] = ACTIONS(3414),
    [anon_sym_operator] = ACTIONS(3414),
    [anon_sym_try] = ACTIONS(3414),
    [anon_sym_delete] = ACTIONS(3414),
    [anon_sym_throw] = ACTIONS(3414),
    [anon_sym_namespace] = ACTIONS(3414),
    [anon_sym_using] = ACTIONS(3414),
    [anon_sym_static_assert] = ACTIONS(3414),
    [anon_sym_concept] = ACTIONS(3414),
    [anon_sym_co_return] = ACTIONS(3414),
    [anon_sym_co_yield] = ACTIONS(3414),
    [anon_sym_R_DQUOTE] = ACTIONS(3416),
    [anon_sym_LR_DQUOTE] = ACTIONS(3416),
    [anon_sym_uR_DQUOTE] = ACTIONS(3416),
    [anon_sym_UR_DQUOTE] = ACTIONS(3416),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3416),
    [anon_sym_co_await] = ACTIONS(3414),
    [anon_sym_new] = ACTIONS(3414),
    [anon_sym_requires] = ACTIONS(3414),
    [sym_this] = ACTIONS(3414),
    [anon_sym_discard] = ACTIONS(3414),
    [anon_sym_precise] = ACTIONS(3414),
    [anon_sym_shared] = ACTIONS(3414),
    [anon_sym_groupshared] = ACTIONS(3414),
    [anon_sym_uniform] = ACTIONS(3414),
    [anon_sym_row_major] = ACTIONS(3414),
    [anon_sym_column_major] = ACTIONS(3414),
    [anon_sym_globallycoherent] = ACTIONS(3414),
    [anon_sym_centroid] = ACTIONS(3414),
    [anon_sym_noperspective] = ACTIONS(3414),
    [anon_sym_nointerpolation] = ACTIONS(3414),
    [anon_sym_sample] = ACTIONS(3414),
    [anon_sym_linear] = ACTIONS(3414),
    [anon_sym_snorm] = ACTIONS(3414),
    [anon_sym_unorm] = ACTIONS(3414),
    [anon_sym_point] = ACTIONS(3414),
    [anon_sym_line] = ACTIONS(3414),
    [anon_sym_triangleadj] = ACTIONS(3414),
    [anon_sym_lineadj] = ACTIONS(3414),
    [anon_sym_triangle] = ACTIONS(3414),
    [anon_sym_cbuffer] = ACTIONS(3414),
    [anon_sym_interface] = ACTIONS(3414),
    [anon_sym_extension] = ACTIONS(3414),
  },
  [444] = {
    [sym_identifier] = ACTIONS(3418),
    [aux_sym_preproc_include_token1] = ACTIONS(3418),
    [aux_sym_preproc_def_token1] = ACTIONS(3418),
    [aux_sym_preproc_if_token1] = ACTIONS(3418),
    [aux_sym_preproc_if_token2] = ACTIONS(3418),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3418),
    [aux_sym_preproc_else_token1] = ACTIONS(3418),
    [aux_sym_preproc_elif_token1] = ACTIONS(3418),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3418),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3418),
    [sym_preproc_directive] = ACTIONS(3418),
    [anon_sym_LPAREN2] = ACTIONS(3420),
    [anon_sym_BANG] = ACTIONS(3420),
    [anon_sym_TILDE] = ACTIONS(3420),
    [anon_sym_DASH] = ACTIONS(3418),
    [anon_sym_PLUS] = ACTIONS(3418),
    [anon_sym_STAR] = ACTIONS(3420),
    [anon_sym_AMP_AMP] = ACTIONS(3420),
    [anon_sym_AMP] = ACTIONS(3418),
    [anon_sym_SEMI] = ACTIONS(3420),
    [anon_sym___extension__] = ACTIONS(3418),
    [anon_sym_typedef] = ACTIONS(3418),
    [anon_sym_in] = ACTIONS(3418),
    [anon_sym_out] = ACTIONS(3418),
    [anon_sym_inout] = ACTIONS(3418),
    [anon_sym_extern] = ACTIONS(3418),
    [anon_sym___attribute__] = ACTIONS(3418),
    [anon_sym_COLON_COLON] = ACTIONS(3420),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3420),
    [anon_sym___declspec] = ACTIONS(3418),
    [anon_sym___based] = ACTIONS(3418),
    [anon_sym___cdecl] = ACTIONS(3418),
    [anon_sym___clrcall] = ACTIONS(3418),
    [anon_sym___stdcall] = ACTIONS(3418),
    [anon_sym___fastcall] = ACTIONS(3418),
    [anon_sym___thiscall] = ACTIONS(3418),
    [anon_sym___vectorcall] = ACTIONS(3418),
    [anon_sym_LBRACE] = ACTIONS(3420),
    [anon_sym_signed] = ACTIONS(3418),
    [anon_sym_unsigned] = ACTIONS(3418),
    [anon_sym_long] = ACTIONS(3418),
    [anon_sym_short] = ACTIONS(3418),
    [anon_sym_LBRACK] = ACTIONS(3418),
    [anon_sym_static] = ACTIONS(3418),
    [anon_sym_register] = ACTIONS(3418),
    [anon_sym_inline] = ACTIONS(3418),
    [anon_sym___inline] = ACTIONS(3418),
    [anon_sym___inline__] = ACTIONS(3418),
    [anon_sym___forceinline] = ACTIONS(3418),
    [anon_sym_thread_local] = ACTIONS(3418),
    [anon_sym___thread] = ACTIONS(3418),
    [anon_sym_const] = ACTIONS(3418),
    [anon_sym_constexpr] = ACTIONS(3418),
    [anon_sym_volatile] = ACTIONS(3418),
    [anon_sym_restrict] = ACTIONS(3418),
    [anon_sym___restrict__] = ACTIONS(3418),
    [anon_sym__Atomic] = ACTIONS(3418),
    [anon_sym__Noreturn] = ACTIONS(3418),
    [anon_sym_noreturn] = ACTIONS(3418),
    [anon_sym_mutable] = ACTIONS(3418),
    [anon_sym_constinit] = ACTIONS(3418),
    [anon_sym_consteval] = ACTIONS(3418),
    [anon_sym_alignas] = ACTIONS(3418),
    [anon_sym__Alignas] = ACTIONS(3418),
    [sym_primitive_type] = ACTIONS(3418),
    [anon_sym_enum] = ACTIONS(3418),
    [anon_sym_class] = ACTIONS(3418),
    [anon_sym_struct] = ACTIONS(3418),
    [anon_sym_union] = ACTIONS(3418),
    [anon_sym_if] = ACTIONS(3418),
    [anon_sym_switch] = ACTIONS(3418),
    [anon_sym_case] = ACTIONS(3418),
    [anon_sym_default] = ACTIONS(3418),
    [anon_sym_while] = ACTIONS(3418),
    [anon_sym_do] = ACTIONS(3418),
    [anon_sym_for] = ACTIONS(3418),
    [anon_sym_return] = ACTIONS(3418),
    [anon_sym_break] = ACTIONS(3418),
    [anon_sym_continue] = ACTIONS(3418),
    [anon_sym_goto] = ACTIONS(3418),
    [anon_sym___try] = ACTIONS(3418),
    [anon_sym___leave] = ACTIONS(3418),
    [anon_sym_not] = ACTIONS(3418),
    [anon_sym_compl] = ACTIONS(3418),
    [anon_sym_DASH_DASH] = ACTIONS(3420),
    [anon_sym_PLUS_PLUS] = ACTIONS(3420),
    [anon_sym_sizeof] = ACTIONS(3418),
    [anon_sym___alignof__] = ACTIONS(3418),
    [anon_sym___alignof] = ACTIONS(3418),
    [anon_sym__alignof] = ACTIONS(3418),
    [anon_sym_alignof] = ACTIONS(3418),
    [anon_sym__Alignof] = ACTIONS(3418),
    [anon_sym_offsetof] = ACTIONS(3418),
    [anon_sym__Generic] = ACTIONS(3418),
    [anon_sym_asm] = ACTIONS(3418),
    [anon_sym___asm__] = ACTIONS(3418),
    [sym_number_literal] = ACTIONS(3420),
    [anon_sym_L_SQUOTE] = ACTIONS(3420),
    [anon_sym_u_SQUOTE] = ACTIONS(3420),
    [anon_sym_U_SQUOTE] = ACTIONS(3420),
    [anon_sym_u8_SQUOTE] = ACTIONS(3420),
    [anon_sym_SQUOTE] = ACTIONS(3420),
    [anon_sym_L_DQUOTE] = ACTIONS(3420),
    [anon_sym_u_DQUOTE] = ACTIONS(3420),
    [anon_sym_U_DQUOTE] = ACTIONS(3420),
    [anon_sym_u8_DQUOTE] = ACTIONS(3420),
    [anon_sym_DQUOTE] = ACTIONS(3420),
    [sym_true] = ACTIONS(3418),
    [sym_false] = ACTIONS(3418),
    [anon_sym_NULL] = ACTIONS(3418),
    [anon_sym_nullptr] = ACTIONS(3418),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3418),
    [anon_sym_let] = ACTIONS(3418),
    [anon_sym_This] = ACTIONS(3418),
    [anon_sym_decltype] = ACTIONS(3418),
    [sym_virtual] = ACTIONS(3418),
    [anon_sym_explicit] = ACTIONS(3418),
    [anon_sym_typename] = ACTIONS(3418),
    [anon_sym_template] = ACTIONS(3418),
    [anon_sym_operator] = ACTIONS(3418),
    [anon_sym_try] = ACTIONS(3418),
    [anon_sym_delete] = ACTIONS(3418),
    [anon_sym_throw] = ACTIONS(3418),
    [anon_sym_namespace] = ACTIONS(3418),
    [anon_sym_using] = ACTIONS(3418),
    [anon_sym_static_assert] = ACTIONS(3418),
    [anon_sym_concept] = ACTIONS(3418),
    [anon_sym_co_return] = ACTIONS(3418),
    [anon_sym_co_yield] = ACTIONS(3418),
    [anon_sym_R_DQUOTE] = ACTIONS(3420),
    [anon_sym_LR_DQUOTE] = ACTIONS(3420),
    [anon_sym_uR_DQUOTE] = ACTIONS(3420),
    [anon_sym_UR_DQUOTE] = ACTIONS(3420),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3420),
    [anon_sym_co_await] = ACTIONS(3418),
    [anon_sym_new] = ACTIONS(3418),
    [anon_sym_requires] = ACTIONS(3418),
    [sym_this] = ACTIONS(3418),
    [anon_sym_discard] = ACTIONS(3418),
    [anon_sym_precise] = ACTIONS(3418),
    [anon_sym_shared] = ACTIONS(3418),
    [anon_sym_groupshared] = ACTIONS(3418),
    [anon_sym_uniform] = ACTIONS(3418),
    [anon_sym_row_major] = ACTIONS(3418),
    [anon_sym_column_major] = ACTIONS(3418),
    [anon_sym_globallycoherent] = ACTIONS(3418),
    [anon_sym_centroid] = ACTIONS(3418),
    [anon_sym_noperspective] = ACTIONS(3418),
    [anon_sym_nointerpolation] = ACTIONS(3418),
    [anon_sym_sample] = ACTIONS(3418),
    [anon_sym_linear] = ACTIONS(3418),
    [anon_sym_snorm] = ACTIONS(3418),
    [anon_sym_unorm] = ACTIONS(3418),
    [anon_sym_point] = ACTIONS(3418),
    [anon_sym_line] = ACTIONS(3418),
    [anon_sym_triangleadj] = ACTIONS(3418),
    [anon_sym_lineadj] = ACTIONS(3418),
    [anon_sym_triangle] = ACTIONS(3418),
    [anon_sym_cbuffer] = ACTIONS(3418),
    [anon_sym_interface] = ACTIONS(3418),
    [anon_sym_extension] = ACTIONS(3418),
  },
  [445] = {
    [sym_catch_clause] = STATE(445),
    [aux_sym_constructor_try_statement_repeat1] = STATE(445),
    [sym_identifier] = ACTIONS(2731),
    [aux_sym_preproc_include_token1] = ACTIONS(2731),
    [aux_sym_preproc_def_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token2] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(2733),
    [anon_sym_BANG] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2731),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_AMP_AMP] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2731),
    [anon_sym_SEMI] = ACTIONS(2733),
    [anon_sym___extension__] = ACTIONS(2731),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_in] = ACTIONS(2731),
    [anon_sym_out] = ACTIONS(2731),
    [anon_sym_inout] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym___based] = ACTIONS(2731),
    [anon_sym___cdecl] = ACTIONS(2731),
    [anon_sym___clrcall] = ACTIONS(2731),
    [anon_sym___stdcall] = ACTIONS(2731),
    [anon_sym___fastcall] = ACTIONS(2731),
    [anon_sym___thiscall] = ACTIONS(2731),
    [anon_sym___vectorcall] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2733),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym__Alignas] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [anon_sym_if] = ACTIONS(2731),
    [anon_sym_else] = ACTIONS(2731),
    [anon_sym_switch] = ACTIONS(2731),
    [anon_sym_case] = ACTIONS(2731),
    [anon_sym_default] = ACTIONS(2731),
    [anon_sym_while] = ACTIONS(2731),
    [anon_sym_do] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2731),
    [anon_sym_return] = ACTIONS(2731),
    [anon_sym_break] = ACTIONS(2731),
    [anon_sym_continue] = ACTIONS(2731),
    [anon_sym_goto] = ACTIONS(2731),
    [anon_sym___try] = ACTIONS(2731),
    [anon_sym___leave] = ACTIONS(2731),
    [anon_sym_not] = ACTIONS(2731),
    [anon_sym_compl] = ACTIONS(2731),
    [anon_sym_DASH_DASH] = ACTIONS(2733),
    [anon_sym_PLUS_PLUS] = ACTIONS(2733),
    [anon_sym_sizeof] = ACTIONS(2731),
    [anon_sym___alignof__] = ACTIONS(2731),
    [anon_sym___alignof] = ACTIONS(2731),
    [anon_sym__alignof] = ACTIONS(2731),
    [anon_sym_alignof] = ACTIONS(2731),
    [anon_sym__Alignof] = ACTIONS(2731),
    [anon_sym_offsetof] = ACTIONS(2731),
    [anon_sym__Generic] = ACTIONS(2731),
    [anon_sym_asm] = ACTIONS(2731),
    [anon_sym___asm__] = ACTIONS(2731),
    [sym_number_literal] = ACTIONS(2733),
    [anon_sym_L_SQUOTE] = ACTIONS(2733),
    [anon_sym_u_SQUOTE] = ACTIONS(2733),
    [anon_sym_U_SQUOTE] = ACTIONS(2733),
    [anon_sym_u8_SQUOTE] = ACTIONS(2733),
    [anon_sym_SQUOTE] = ACTIONS(2733),
    [anon_sym_L_DQUOTE] = ACTIONS(2733),
    [anon_sym_u_DQUOTE] = ACTIONS(2733),
    [anon_sym_U_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8_DQUOTE] = ACTIONS(2733),
    [anon_sym_DQUOTE] = ACTIONS(2733),
    [sym_true] = ACTIONS(2731),
    [sym_false] = ACTIONS(2731),
    [anon_sym_NULL] = ACTIONS(2731),
    [anon_sym_nullptr] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2731),
    [anon_sym_let] = ACTIONS(2731),
    [anon_sym_This] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(2731),
    [sym_virtual] = ACTIONS(2731),
    [anon_sym_explicit] = ACTIONS(2731),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(2731),
    [anon_sym_operator] = ACTIONS(2731),
    [anon_sym_try] = ACTIONS(2731),
    [anon_sym_delete] = ACTIONS(2731),
    [anon_sym_throw] = ACTIONS(2731),
    [anon_sym_namespace] = ACTIONS(2731),
    [anon_sym_using] = ACTIONS(2731),
    [anon_sym_static_assert] = ACTIONS(2731),
    [anon_sym_concept] = ACTIONS(2731),
    [anon_sym_co_return] = ACTIONS(2731),
    [anon_sym_co_yield] = ACTIONS(2731),
    [anon_sym_catch] = ACTIONS(3422),
    [anon_sym_R_DQUOTE] = ACTIONS(2733),
    [anon_sym_LR_DQUOTE] = ACTIONS(2733),
    [anon_sym_uR_DQUOTE] = ACTIONS(2733),
    [anon_sym_UR_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2733),
    [anon_sym_co_await] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2731),
    [anon_sym_requires] = ACTIONS(2731),
    [sym_this] = ACTIONS(2731),
    [anon_sym_discard] = ACTIONS(2731),
    [anon_sym_precise] = ACTIONS(2731),
    [anon_sym_shared] = ACTIONS(2731),
    [anon_sym_groupshared] = ACTIONS(2731),
    [anon_sym_uniform] = ACTIONS(2731),
    [anon_sym_row_major] = ACTIONS(2731),
    [anon_sym_column_major] = ACTIONS(2731),
    [anon_sym_globallycoherent] = ACTIONS(2731),
    [anon_sym_centroid] = ACTIONS(2731),
    [anon_sym_noperspective] = ACTIONS(2731),
    [anon_sym_nointerpolation] = ACTIONS(2731),
    [anon_sym_sample] = ACTIONS(2731),
    [anon_sym_linear] = ACTIONS(2731),
    [anon_sym_snorm] = ACTIONS(2731),
    [anon_sym_unorm] = ACTIONS(2731),
    [anon_sym_point] = ACTIONS(2731),
    [anon_sym_line] = ACTIONS(2731),
    [anon_sym_triangleadj] = ACTIONS(2731),
    [anon_sym_lineadj] = ACTIONS(2731),
    [anon_sym_triangle] = ACTIONS(2731),
    [anon_sym_cbuffer] = ACTIONS(2731),
    [anon_sym_interface] = ACTIONS(2731),
    [anon_sym_extension] = ACTIONS(2731),
  },
  [446] = {
    [sym_identifier] = ACTIONS(3425),
    [aux_sym_preproc_include_token1] = ACTIONS(3425),
    [aux_sym_preproc_def_token1] = ACTIONS(3425),
    [aux_sym_preproc_if_token1] = ACTIONS(3425),
    [aux_sym_preproc_if_token2] = ACTIONS(3425),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3425),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3425),
    [aux_sym_preproc_else_token1] = ACTIONS(3425),
    [aux_sym_preproc_elif_token1] = ACTIONS(3425),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3425),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3425),
    [sym_preproc_directive] = ACTIONS(3425),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_BANG] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3425),
    [anon_sym_PLUS] = ACTIONS(3425),
    [anon_sym_STAR] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3425),
    [anon_sym_SEMI] = ACTIONS(3427),
    [anon_sym___extension__] = ACTIONS(3425),
    [anon_sym_typedef] = ACTIONS(3425),
    [anon_sym_in] = ACTIONS(3425),
    [anon_sym_out] = ACTIONS(3425),
    [anon_sym_inout] = ACTIONS(3425),
    [anon_sym_extern] = ACTIONS(3425),
    [anon_sym___attribute__] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(3427),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3427),
    [anon_sym___declspec] = ACTIONS(3425),
    [anon_sym___based] = ACTIONS(3425),
    [anon_sym___cdecl] = ACTIONS(3425),
    [anon_sym___clrcall] = ACTIONS(3425),
    [anon_sym___stdcall] = ACTIONS(3425),
    [anon_sym___fastcall] = ACTIONS(3425),
    [anon_sym___thiscall] = ACTIONS(3425),
    [anon_sym___vectorcall] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_signed] = ACTIONS(3425),
    [anon_sym_unsigned] = ACTIONS(3425),
    [anon_sym_long] = ACTIONS(3425),
    [anon_sym_short] = ACTIONS(3425),
    [anon_sym_LBRACK] = ACTIONS(3425),
    [anon_sym_static] = ACTIONS(3425),
    [anon_sym_register] = ACTIONS(3425),
    [anon_sym_inline] = ACTIONS(3425),
    [anon_sym___inline] = ACTIONS(3425),
    [anon_sym___inline__] = ACTIONS(3425),
    [anon_sym___forceinline] = ACTIONS(3425),
    [anon_sym_thread_local] = ACTIONS(3425),
    [anon_sym___thread] = ACTIONS(3425),
    [anon_sym_const] = ACTIONS(3425),
    [anon_sym_constexpr] = ACTIONS(3425),
    [anon_sym_volatile] = ACTIONS(3425),
    [anon_sym_restrict] = ACTIONS(3425),
    [anon_sym___restrict__] = ACTIONS(3425),
    [anon_sym__Atomic] = ACTIONS(3425),
    [anon_sym__Noreturn] = ACTIONS(3425),
    [anon_sym_noreturn] = ACTIONS(3425),
    [anon_sym_mutable] = ACTIONS(3425),
    [anon_sym_constinit] = ACTIONS(3425),
    [anon_sym_consteval] = ACTIONS(3425),
    [anon_sym_alignas] = ACTIONS(3425),
    [anon_sym__Alignas] = ACTIONS(3425),
    [sym_primitive_type] = ACTIONS(3425),
    [anon_sym_enum] = ACTIONS(3425),
    [anon_sym_class] = ACTIONS(3425),
    [anon_sym_struct] = ACTIONS(3425),
    [anon_sym_union] = ACTIONS(3425),
    [anon_sym_if] = ACTIONS(3425),
    [anon_sym_switch] = ACTIONS(3425),
    [anon_sym_case] = ACTIONS(3425),
    [anon_sym_default] = ACTIONS(3425),
    [anon_sym_while] = ACTIONS(3425),
    [anon_sym_do] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3425),
    [anon_sym_return] = ACTIONS(3425),
    [anon_sym_break] = ACTIONS(3425),
    [anon_sym_continue] = ACTIONS(3425),
    [anon_sym_goto] = ACTIONS(3425),
    [anon_sym___try] = ACTIONS(3425),
    [anon_sym___leave] = ACTIONS(3425),
    [anon_sym_not] = ACTIONS(3425),
    [anon_sym_compl] = ACTIONS(3425),
    [anon_sym_DASH_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_PLUS] = ACTIONS(3427),
    [anon_sym_sizeof] = ACTIONS(3425),
    [anon_sym___alignof__] = ACTIONS(3425),
    [anon_sym___alignof] = ACTIONS(3425),
    [anon_sym__alignof] = ACTIONS(3425),
    [anon_sym_alignof] = ACTIONS(3425),
    [anon_sym__Alignof] = ACTIONS(3425),
    [anon_sym_offsetof] = ACTIONS(3425),
    [anon_sym__Generic] = ACTIONS(3425),
    [anon_sym_asm] = ACTIONS(3425),
    [anon_sym___asm__] = ACTIONS(3425),
    [sym_number_literal] = ACTIONS(3427),
    [anon_sym_L_SQUOTE] = ACTIONS(3427),
    [anon_sym_u_SQUOTE] = ACTIONS(3427),
    [anon_sym_U_SQUOTE] = ACTIONS(3427),
    [anon_sym_u8_SQUOTE] = ACTIONS(3427),
    [anon_sym_SQUOTE] = ACTIONS(3427),
    [anon_sym_L_DQUOTE] = ACTIONS(3427),
    [anon_sym_u_DQUOTE] = ACTIONS(3427),
    [anon_sym_U_DQUOTE] = ACTIONS(3427),
    [anon_sym_u8_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [sym_true] = ACTIONS(3425),
    [sym_false] = ACTIONS(3425),
    [anon_sym_NULL] = ACTIONS(3425),
    [anon_sym_nullptr] = ACTIONS(3425),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3425),
    [anon_sym_let] = ACTIONS(3425),
    [anon_sym_This] = ACTIONS(3425),
    [anon_sym_decltype] = ACTIONS(3425),
    [sym_virtual] = ACTIONS(3425),
    [anon_sym_explicit] = ACTIONS(3425),
    [anon_sym_typename] = ACTIONS(3425),
    [anon_sym_template] = ACTIONS(3425),
    [anon_sym_operator] = ACTIONS(3425),
    [anon_sym_try] = ACTIONS(3425),
    [anon_sym_delete] = ACTIONS(3425),
    [anon_sym_throw] = ACTIONS(3425),
    [anon_sym_namespace] = ACTIONS(3425),
    [anon_sym_using] = ACTIONS(3425),
    [anon_sym_static_assert] = ACTIONS(3425),
    [anon_sym_concept] = ACTIONS(3425),
    [anon_sym_co_return] = ACTIONS(3425),
    [anon_sym_co_yield] = ACTIONS(3425),
    [anon_sym_R_DQUOTE] = ACTIONS(3427),
    [anon_sym_LR_DQUOTE] = ACTIONS(3427),
    [anon_sym_uR_DQUOTE] = ACTIONS(3427),
    [anon_sym_UR_DQUOTE] = ACTIONS(3427),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3427),
    [anon_sym_co_await] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_requires] = ACTIONS(3425),
    [sym_this] = ACTIONS(3425),
    [anon_sym_discard] = ACTIONS(3425),
    [anon_sym_precise] = ACTIONS(3425),
    [anon_sym_shared] = ACTIONS(3425),
    [anon_sym_groupshared] = ACTIONS(3425),
    [anon_sym_uniform] = ACTIONS(3425),
    [anon_sym_row_major] = ACTIONS(3425),
    [anon_sym_column_major] = ACTIONS(3425),
    [anon_sym_globallycoherent] = ACTIONS(3425),
    [anon_sym_centroid] = ACTIONS(3425),
    [anon_sym_noperspective] = ACTIONS(3425),
    [anon_sym_nointerpolation] = ACTIONS(3425),
    [anon_sym_sample] = ACTIONS(3425),
    [anon_sym_linear] = ACTIONS(3425),
    [anon_sym_snorm] = ACTIONS(3425),
    [anon_sym_unorm] = ACTIONS(3425),
    [anon_sym_point] = ACTIONS(3425),
    [anon_sym_line] = ACTIONS(3425),
    [anon_sym_triangleadj] = ACTIONS(3425),
    [anon_sym_lineadj] = ACTIONS(3425),
    [anon_sym_triangle] = ACTIONS(3425),
    [anon_sym_cbuffer] = ACTIONS(3425),
    [anon_sym_interface] = ACTIONS(3425),
    [anon_sym_extension] = ACTIONS(3425),
  },
  [447] = {
    [sym_identifier] = ACTIONS(3429),
    [aux_sym_preproc_include_token1] = ACTIONS(3429),
    [aux_sym_preproc_def_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token2] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3429),
    [aux_sym_preproc_else_token1] = ACTIONS(3429),
    [aux_sym_preproc_elif_token1] = ACTIONS(3429),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3429),
    [sym_preproc_directive] = ACTIONS(3429),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_BANG] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym_SEMI] = ACTIONS(3431),
    [anon_sym___extension__] = ACTIONS(3429),
    [anon_sym_typedef] = ACTIONS(3429),
    [anon_sym_in] = ACTIONS(3429),
    [anon_sym_out] = ACTIONS(3429),
    [anon_sym_inout] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym___attribute__] = ACTIONS(3429),
    [anon_sym_COLON_COLON] = ACTIONS(3431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3431),
    [anon_sym___declspec] = ACTIONS(3429),
    [anon_sym___based] = ACTIONS(3429),
    [anon_sym___cdecl] = ACTIONS(3429),
    [anon_sym___clrcall] = ACTIONS(3429),
    [anon_sym___stdcall] = ACTIONS(3429),
    [anon_sym___fastcall] = ACTIONS(3429),
    [anon_sym___thiscall] = ACTIONS(3429),
    [anon_sym___vectorcall] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_signed] = ACTIONS(3429),
    [anon_sym_unsigned] = ACTIONS(3429),
    [anon_sym_long] = ACTIONS(3429),
    [anon_sym_short] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_register] = ACTIONS(3429),
    [anon_sym_inline] = ACTIONS(3429),
    [anon_sym___inline] = ACTIONS(3429),
    [anon_sym___inline__] = ACTIONS(3429),
    [anon_sym___forceinline] = ACTIONS(3429),
    [anon_sym_thread_local] = ACTIONS(3429),
    [anon_sym___thread] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_constexpr] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_restrict] = ACTIONS(3429),
    [anon_sym___restrict__] = ACTIONS(3429),
    [anon_sym__Atomic] = ACTIONS(3429),
    [anon_sym__Noreturn] = ACTIONS(3429),
    [anon_sym_noreturn] = ACTIONS(3429),
    [anon_sym_mutable] = ACTIONS(3429),
    [anon_sym_constinit] = ACTIONS(3429),
    [anon_sym_consteval] = ACTIONS(3429),
    [anon_sym_alignas] = ACTIONS(3429),
    [anon_sym__Alignas] = ACTIONS(3429),
    [sym_primitive_type] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [anon_sym_if] = ACTIONS(3429),
    [anon_sym_switch] = ACTIONS(3429),
    [anon_sym_case] = ACTIONS(3429),
    [anon_sym_default] = ACTIONS(3429),
    [anon_sym_while] = ACTIONS(3429),
    [anon_sym_do] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3429),
    [anon_sym_return] = ACTIONS(3429),
    [anon_sym_break] = ACTIONS(3429),
    [anon_sym_continue] = ACTIONS(3429),
    [anon_sym_goto] = ACTIONS(3429),
    [anon_sym___try] = ACTIONS(3429),
    [anon_sym___leave] = ACTIONS(3429),
    [anon_sym_not] = ACTIONS(3429),
    [anon_sym_compl] = ACTIONS(3429),
    [anon_sym_DASH_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(3431),
    [anon_sym_sizeof] = ACTIONS(3429),
    [anon_sym___alignof__] = ACTIONS(3429),
    [anon_sym___alignof] = ACTIONS(3429),
    [anon_sym__alignof] = ACTIONS(3429),
    [anon_sym_alignof] = ACTIONS(3429),
    [anon_sym__Alignof] = ACTIONS(3429),
    [anon_sym_offsetof] = ACTIONS(3429),
    [anon_sym__Generic] = ACTIONS(3429),
    [anon_sym_asm] = ACTIONS(3429),
    [anon_sym___asm__] = ACTIONS(3429),
    [sym_number_literal] = ACTIONS(3431),
    [anon_sym_L_SQUOTE] = ACTIONS(3431),
    [anon_sym_u_SQUOTE] = ACTIONS(3431),
    [anon_sym_U_SQUOTE] = ACTIONS(3431),
    [anon_sym_u8_SQUOTE] = ACTIONS(3431),
    [anon_sym_SQUOTE] = ACTIONS(3431),
    [anon_sym_L_DQUOTE] = ACTIONS(3431),
    [anon_sym_u_DQUOTE] = ACTIONS(3431),
    [anon_sym_U_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [sym_true] = ACTIONS(3429),
    [sym_false] = ACTIONS(3429),
    [anon_sym_NULL] = ACTIONS(3429),
    [anon_sym_nullptr] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_This] = ACTIONS(3429),
    [anon_sym_decltype] = ACTIONS(3429),
    [sym_virtual] = ACTIONS(3429),
    [anon_sym_explicit] = ACTIONS(3429),
    [anon_sym_typename] = ACTIONS(3429),
    [anon_sym_template] = ACTIONS(3429),
    [anon_sym_operator] = ACTIONS(3429),
    [anon_sym_try] = ACTIONS(3429),
    [anon_sym_delete] = ACTIONS(3429),
    [anon_sym_throw] = ACTIONS(3429),
    [anon_sym_namespace] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_static_assert] = ACTIONS(3429),
    [anon_sym_concept] = ACTIONS(3429),
    [anon_sym_co_return] = ACTIONS(3429),
    [anon_sym_co_yield] = ACTIONS(3429),
    [anon_sym_R_DQUOTE] = ACTIONS(3431),
    [anon_sym_LR_DQUOTE] = ACTIONS(3431),
    [anon_sym_uR_DQUOTE] = ACTIONS(3431),
    [anon_sym_UR_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3431),
    [anon_sym_co_await] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3429),
    [anon_sym_requires] = ACTIONS(3429),
    [sym_this] = ACTIONS(3429),
    [anon_sym_discard] = ACTIONS(3429),
    [anon_sym_precise] = ACTIONS(3429),
    [anon_sym_shared] = ACTIONS(3429),
    [anon_sym_groupshared] = ACTIONS(3429),
    [anon_sym_uniform] = ACTIONS(3429),
    [anon_sym_row_major] = ACTIONS(3429),
    [anon_sym_column_major] = ACTIONS(3429),
    [anon_sym_globallycoherent] = ACTIONS(3429),
    [anon_sym_centroid] = ACTIONS(3429),
    [anon_sym_noperspective] = ACTIONS(3429),
    [anon_sym_nointerpolation] = ACTIONS(3429),
    [anon_sym_sample] = ACTIONS(3429),
    [anon_sym_linear] = ACTIONS(3429),
    [anon_sym_snorm] = ACTIONS(3429),
    [anon_sym_unorm] = ACTIONS(3429),
    [anon_sym_point] = ACTIONS(3429),
    [anon_sym_line] = ACTIONS(3429),
    [anon_sym_triangleadj] = ACTIONS(3429),
    [anon_sym_lineadj] = ACTIONS(3429),
    [anon_sym_triangle] = ACTIONS(3429),
    [anon_sym_cbuffer] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_extension] = ACTIONS(3429),
  },
  [448] = {
    [sym_identifier] = ACTIONS(3433),
    [aux_sym_preproc_include_token1] = ACTIONS(3433),
    [aux_sym_preproc_def_token1] = ACTIONS(3433),
    [aux_sym_preproc_if_token1] = ACTIONS(3433),
    [aux_sym_preproc_if_token2] = ACTIONS(3433),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3433),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3433),
    [aux_sym_preproc_else_token1] = ACTIONS(3433),
    [aux_sym_preproc_elif_token1] = ACTIONS(3433),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3433),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3433),
    [sym_preproc_directive] = ACTIONS(3433),
    [anon_sym_LPAREN2] = ACTIONS(3435),
    [anon_sym_BANG] = ACTIONS(3435),
    [anon_sym_TILDE] = ACTIONS(3435),
    [anon_sym_DASH] = ACTIONS(3433),
    [anon_sym_PLUS] = ACTIONS(3433),
    [anon_sym_STAR] = ACTIONS(3435),
    [anon_sym_AMP_AMP] = ACTIONS(3435),
    [anon_sym_AMP] = ACTIONS(3433),
    [anon_sym_SEMI] = ACTIONS(3435),
    [anon_sym___extension__] = ACTIONS(3433),
    [anon_sym_typedef] = ACTIONS(3433),
    [anon_sym_in] = ACTIONS(3433),
    [anon_sym_out] = ACTIONS(3433),
    [anon_sym_inout] = ACTIONS(3433),
    [anon_sym_extern] = ACTIONS(3433),
    [anon_sym___attribute__] = ACTIONS(3433),
    [anon_sym_COLON_COLON] = ACTIONS(3435),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3435),
    [anon_sym___declspec] = ACTIONS(3433),
    [anon_sym___based] = ACTIONS(3433),
    [anon_sym___cdecl] = ACTIONS(3433),
    [anon_sym___clrcall] = ACTIONS(3433),
    [anon_sym___stdcall] = ACTIONS(3433),
    [anon_sym___fastcall] = ACTIONS(3433),
    [anon_sym___thiscall] = ACTIONS(3433),
    [anon_sym___vectorcall] = ACTIONS(3433),
    [anon_sym_LBRACE] = ACTIONS(3435),
    [anon_sym_signed] = ACTIONS(3433),
    [anon_sym_unsigned] = ACTIONS(3433),
    [anon_sym_long] = ACTIONS(3433),
    [anon_sym_short] = ACTIONS(3433),
    [anon_sym_LBRACK] = ACTIONS(3433),
    [anon_sym_static] = ACTIONS(3433),
    [anon_sym_register] = ACTIONS(3433),
    [anon_sym_inline] = ACTIONS(3433),
    [anon_sym___inline] = ACTIONS(3433),
    [anon_sym___inline__] = ACTIONS(3433),
    [anon_sym___forceinline] = ACTIONS(3433),
    [anon_sym_thread_local] = ACTIONS(3433),
    [anon_sym___thread] = ACTIONS(3433),
    [anon_sym_const] = ACTIONS(3433),
    [anon_sym_constexpr] = ACTIONS(3433),
    [anon_sym_volatile] = ACTIONS(3433),
    [anon_sym_restrict] = ACTIONS(3433),
    [anon_sym___restrict__] = ACTIONS(3433),
    [anon_sym__Atomic] = ACTIONS(3433),
    [anon_sym__Noreturn] = ACTIONS(3433),
    [anon_sym_noreturn] = ACTIONS(3433),
    [anon_sym_mutable] = ACTIONS(3433),
    [anon_sym_constinit] = ACTIONS(3433),
    [anon_sym_consteval] = ACTIONS(3433),
    [anon_sym_alignas] = ACTIONS(3433),
    [anon_sym__Alignas] = ACTIONS(3433),
    [sym_primitive_type] = ACTIONS(3433),
    [anon_sym_enum] = ACTIONS(3433),
    [anon_sym_class] = ACTIONS(3433),
    [anon_sym_struct] = ACTIONS(3433),
    [anon_sym_union] = ACTIONS(3433),
    [anon_sym_if] = ACTIONS(3433),
    [anon_sym_switch] = ACTIONS(3433),
    [anon_sym_case] = ACTIONS(3433),
    [anon_sym_default] = ACTIONS(3433),
    [anon_sym_while] = ACTIONS(3433),
    [anon_sym_do] = ACTIONS(3433),
    [anon_sym_for] = ACTIONS(3433),
    [anon_sym_return] = ACTIONS(3433),
    [anon_sym_break] = ACTIONS(3433),
    [anon_sym_continue] = ACTIONS(3433),
    [anon_sym_goto] = ACTIONS(3433),
    [anon_sym___try] = ACTIONS(3433),
    [anon_sym___leave] = ACTIONS(3433),
    [anon_sym_not] = ACTIONS(3433),
    [anon_sym_compl] = ACTIONS(3433),
    [anon_sym_DASH_DASH] = ACTIONS(3435),
    [anon_sym_PLUS_PLUS] = ACTIONS(3435),
    [anon_sym_sizeof] = ACTIONS(3433),
    [anon_sym___alignof__] = ACTIONS(3433),
    [anon_sym___alignof] = ACTIONS(3433),
    [anon_sym__alignof] = ACTIONS(3433),
    [anon_sym_alignof] = ACTIONS(3433),
    [anon_sym__Alignof] = ACTIONS(3433),
    [anon_sym_offsetof] = ACTIONS(3433),
    [anon_sym__Generic] = ACTIONS(3433),
    [anon_sym_asm] = ACTIONS(3433),
    [anon_sym___asm__] = ACTIONS(3433),
    [sym_number_literal] = ACTIONS(3435),
    [anon_sym_L_SQUOTE] = ACTIONS(3435),
    [anon_sym_u_SQUOTE] = ACTIONS(3435),
    [anon_sym_U_SQUOTE] = ACTIONS(3435),
    [anon_sym_u8_SQUOTE] = ACTIONS(3435),
    [anon_sym_SQUOTE] = ACTIONS(3435),
    [anon_sym_L_DQUOTE] = ACTIONS(3435),
    [anon_sym_u_DQUOTE] = ACTIONS(3435),
    [anon_sym_U_DQUOTE] = ACTIONS(3435),
    [anon_sym_u8_DQUOTE] = ACTIONS(3435),
    [anon_sym_DQUOTE] = ACTIONS(3435),
    [sym_true] = ACTIONS(3433),
    [sym_false] = ACTIONS(3433),
    [anon_sym_NULL] = ACTIONS(3433),
    [anon_sym_nullptr] = ACTIONS(3433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3433),
    [anon_sym_let] = ACTIONS(3433),
    [anon_sym_This] = ACTIONS(3433),
    [anon_sym_decltype] = ACTIONS(3433),
    [sym_virtual] = ACTIONS(3433),
    [anon_sym_explicit] = ACTIONS(3433),
    [anon_sym_typename] = ACTIONS(3433),
    [anon_sym_template] = ACTIONS(3433),
    [anon_sym_operator] = ACTIONS(3433),
    [anon_sym_try] = ACTIONS(3433),
    [anon_sym_delete] = ACTIONS(3433),
    [anon_sym_throw] = ACTIONS(3433),
    [anon_sym_namespace] = ACTIONS(3433),
    [anon_sym_using] = ACTIONS(3433),
    [anon_sym_static_assert] = ACTIONS(3433),
    [anon_sym_concept] = ACTIONS(3433),
    [anon_sym_co_return] = ACTIONS(3433),
    [anon_sym_co_yield] = ACTIONS(3433),
    [anon_sym_R_DQUOTE] = ACTIONS(3435),
    [anon_sym_LR_DQUOTE] = ACTIONS(3435),
    [anon_sym_uR_DQUOTE] = ACTIONS(3435),
    [anon_sym_UR_DQUOTE] = ACTIONS(3435),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3435),
    [anon_sym_co_await] = ACTIONS(3433),
    [anon_sym_new] = ACTIONS(3433),
    [anon_sym_requires] = ACTIONS(3433),
    [sym_this] = ACTIONS(3433),
    [anon_sym_discard] = ACTIONS(3433),
    [anon_sym_precise] = ACTIONS(3433),
    [anon_sym_shared] = ACTIONS(3433),
    [anon_sym_groupshared] = ACTIONS(3433),
    [anon_sym_uniform] = ACTIONS(3433),
    [anon_sym_row_major] = ACTIONS(3433),
    [anon_sym_column_major] = ACTIONS(3433),
    [anon_sym_globallycoherent] = ACTIONS(3433),
    [anon_sym_centroid] = ACTIONS(3433),
    [anon_sym_noperspective] = ACTIONS(3433),
    [anon_sym_nointerpolation] = ACTIONS(3433),
    [anon_sym_sample] = ACTIONS(3433),
    [anon_sym_linear] = ACTIONS(3433),
    [anon_sym_snorm] = ACTIONS(3433),
    [anon_sym_unorm] = ACTIONS(3433),
    [anon_sym_point] = ACTIONS(3433),
    [anon_sym_line] = ACTIONS(3433),
    [anon_sym_triangleadj] = ACTIONS(3433),
    [anon_sym_lineadj] = ACTIONS(3433),
    [anon_sym_triangle] = ACTIONS(3433),
    [anon_sym_cbuffer] = ACTIONS(3433),
    [anon_sym_interface] = ACTIONS(3433),
    [anon_sym_extension] = ACTIONS(3433),
  },
  [449] = {
    [sym_identifier] = ACTIONS(3437),
    [aux_sym_preproc_include_token1] = ACTIONS(3437),
    [aux_sym_preproc_def_token1] = ACTIONS(3437),
    [aux_sym_preproc_if_token1] = ACTIONS(3437),
    [aux_sym_preproc_if_token2] = ACTIONS(3437),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3437),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3437),
    [aux_sym_preproc_else_token1] = ACTIONS(3437),
    [aux_sym_preproc_elif_token1] = ACTIONS(3437),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3437),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3437),
    [sym_preproc_directive] = ACTIONS(3437),
    [anon_sym_LPAREN2] = ACTIONS(3439),
    [anon_sym_BANG] = ACTIONS(3439),
    [anon_sym_TILDE] = ACTIONS(3439),
    [anon_sym_DASH] = ACTIONS(3437),
    [anon_sym_PLUS] = ACTIONS(3437),
    [anon_sym_STAR] = ACTIONS(3439),
    [anon_sym_AMP_AMP] = ACTIONS(3439),
    [anon_sym_AMP] = ACTIONS(3437),
    [anon_sym_SEMI] = ACTIONS(3439),
    [anon_sym___extension__] = ACTIONS(3437),
    [anon_sym_typedef] = ACTIONS(3437),
    [anon_sym_in] = ACTIONS(3437),
    [anon_sym_out] = ACTIONS(3437),
    [anon_sym_inout] = ACTIONS(3437),
    [anon_sym_extern] = ACTIONS(3437),
    [anon_sym___attribute__] = ACTIONS(3437),
    [anon_sym_COLON_COLON] = ACTIONS(3439),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3439),
    [anon_sym___declspec] = ACTIONS(3437),
    [anon_sym___based] = ACTIONS(3437),
    [anon_sym___cdecl] = ACTIONS(3437),
    [anon_sym___clrcall] = ACTIONS(3437),
    [anon_sym___stdcall] = ACTIONS(3437),
    [anon_sym___fastcall] = ACTIONS(3437),
    [anon_sym___thiscall] = ACTIONS(3437),
    [anon_sym___vectorcall] = ACTIONS(3437),
    [anon_sym_LBRACE] = ACTIONS(3439),
    [anon_sym_signed] = ACTIONS(3437),
    [anon_sym_unsigned] = ACTIONS(3437),
    [anon_sym_long] = ACTIONS(3437),
    [anon_sym_short] = ACTIONS(3437),
    [anon_sym_LBRACK] = ACTIONS(3437),
    [anon_sym_static] = ACTIONS(3437),
    [anon_sym_register] = ACTIONS(3437),
    [anon_sym_inline] = ACTIONS(3437),
    [anon_sym___inline] = ACTIONS(3437),
    [anon_sym___inline__] = ACTIONS(3437),
    [anon_sym___forceinline] = ACTIONS(3437),
    [anon_sym_thread_local] = ACTIONS(3437),
    [anon_sym___thread] = ACTIONS(3437),
    [anon_sym_const] = ACTIONS(3437),
    [anon_sym_constexpr] = ACTIONS(3437),
    [anon_sym_volatile] = ACTIONS(3437),
    [anon_sym_restrict] = ACTIONS(3437),
    [anon_sym___restrict__] = ACTIONS(3437),
    [anon_sym__Atomic] = ACTIONS(3437),
    [anon_sym__Noreturn] = ACTIONS(3437),
    [anon_sym_noreturn] = ACTIONS(3437),
    [anon_sym_mutable] = ACTIONS(3437),
    [anon_sym_constinit] = ACTIONS(3437),
    [anon_sym_consteval] = ACTIONS(3437),
    [anon_sym_alignas] = ACTIONS(3437),
    [anon_sym__Alignas] = ACTIONS(3437),
    [sym_primitive_type] = ACTIONS(3437),
    [anon_sym_enum] = ACTIONS(3437),
    [anon_sym_class] = ACTIONS(3437),
    [anon_sym_struct] = ACTIONS(3437),
    [anon_sym_union] = ACTIONS(3437),
    [anon_sym_if] = ACTIONS(3437),
    [anon_sym_switch] = ACTIONS(3437),
    [anon_sym_case] = ACTIONS(3437),
    [anon_sym_default] = ACTIONS(3437),
    [anon_sym_while] = ACTIONS(3437),
    [anon_sym_do] = ACTIONS(3437),
    [anon_sym_for] = ACTIONS(3437),
    [anon_sym_return] = ACTIONS(3437),
    [anon_sym_break] = ACTIONS(3437),
    [anon_sym_continue] = ACTIONS(3437),
    [anon_sym_goto] = ACTIONS(3437),
    [anon_sym___try] = ACTIONS(3437),
    [anon_sym___leave] = ACTIONS(3437),
    [anon_sym_not] = ACTIONS(3437),
    [anon_sym_compl] = ACTIONS(3437),
    [anon_sym_DASH_DASH] = ACTIONS(3439),
    [anon_sym_PLUS_PLUS] = ACTIONS(3439),
    [anon_sym_sizeof] = ACTIONS(3437),
    [anon_sym___alignof__] = ACTIONS(3437),
    [anon_sym___alignof] = ACTIONS(3437),
    [anon_sym__alignof] = ACTIONS(3437),
    [anon_sym_alignof] = ACTIONS(3437),
    [anon_sym__Alignof] = ACTIONS(3437),
    [anon_sym_offsetof] = ACTIONS(3437),
    [anon_sym__Generic] = ACTIONS(3437),
    [anon_sym_asm] = ACTIONS(3437),
    [anon_sym___asm__] = ACTIONS(3437),
    [sym_number_literal] = ACTIONS(3439),
    [anon_sym_L_SQUOTE] = ACTIONS(3439),
    [anon_sym_u_SQUOTE] = ACTIONS(3439),
    [anon_sym_U_SQUOTE] = ACTIONS(3439),
    [anon_sym_u8_SQUOTE] = ACTIONS(3439),
    [anon_sym_SQUOTE] = ACTIONS(3439),
    [anon_sym_L_DQUOTE] = ACTIONS(3439),
    [anon_sym_u_DQUOTE] = ACTIONS(3439),
    [anon_sym_U_DQUOTE] = ACTIONS(3439),
    [anon_sym_u8_DQUOTE] = ACTIONS(3439),
    [anon_sym_DQUOTE] = ACTIONS(3439),
    [sym_true] = ACTIONS(3437),
    [sym_false] = ACTIONS(3437),
    [anon_sym_NULL] = ACTIONS(3437),
    [anon_sym_nullptr] = ACTIONS(3437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3437),
    [anon_sym_let] = ACTIONS(3437),
    [anon_sym_This] = ACTIONS(3437),
    [anon_sym_decltype] = ACTIONS(3437),
    [sym_virtual] = ACTIONS(3437),
    [anon_sym_explicit] = ACTIONS(3437),
    [anon_sym_typename] = ACTIONS(3437),
    [anon_sym_template] = ACTIONS(3437),
    [anon_sym_operator] = ACTIONS(3437),
    [anon_sym_try] = ACTIONS(3437),
    [anon_sym_delete] = ACTIONS(3437),
    [anon_sym_throw] = ACTIONS(3437),
    [anon_sym_namespace] = ACTIONS(3437),
    [anon_sym_using] = ACTIONS(3437),
    [anon_sym_static_assert] = ACTIONS(3437),
    [anon_sym_concept] = ACTIONS(3437),
    [anon_sym_co_return] = ACTIONS(3437),
    [anon_sym_co_yield] = ACTIONS(3437),
    [anon_sym_R_DQUOTE] = ACTIONS(3439),
    [anon_sym_LR_DQUOTE] = ACTIONS(3439),
    [anon_sym_uR_DQUOTE] = ACTIONS(3439),
    [anon_sym_UR_DQUOTE] = ACTIONS(3439),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3439),
    [anon_sym_co_await] = ACTIONS(3437),
    [anon_sym_new] = ACTIONS(3437),
    [anon_sym_requires] = ACTIONS(3437),
    [sym_this] = ACTIONS(3437),
    [anon_sym_discard] = ACTIONS(3437),
    [anon_sym_precise] = ACTIONS(3437),
    [anon_sym_shared] = ACTIONS(3437),
    [anon_sym_groupshared] = ACTIONS(3437),
    [anon_sym_uniform] = ACTIONS(3437),
    [anon_sym_row_major] = ACTIONS(3437),
    [anon_sym_column_major] = ACTIONS(3437),
    [anon_sym_globallycoherent] = ACTIONS(3437),
    [anon_sym_centroid] = ACTIONS(3437),
    [anon_sym_noperspective] = ACTIONS(3437),
    [anon_sym_nointerpolation] = ACTIONS(3437),
    [anon_sym_sample] = ACTIONS(3437),
    [anon_sym_linear] = ACTIONS(3437),
    [anon_sym_snorm] = ACTIONS(3437),
    [anon_sym_unorm] = ACTIONS(3437),
    [anon_sym_point] = ACTIONS(3437),
    [anon_sym_line] = ACTIONS(3437),
    [anon_sym_triangleadj] = ACTIONS(3437),
    [anon_sym_lineadj] = ACTIONS(3437),
    [anon_sym_triangle] = ACTIONS(3437),
    [anon_sym_cbuffer] = ACTIONS(3437),
    [anon_sym_interface] = ACTIONS(3437),
    [anon_sym_extension] = ACTIONS(3437),
  },
  [450] = {
    [sym_identifier] = ACTIONS(3441),
    [aux_sym_preproc_include_token1] = ACTIONS(3441),
    [aux_sym_preproc_def_token1] = ACTIONS(3441),
    [aux_sym_preproc_if_token1] = ACTIONS(3441),
    [aux_sym_preproc_if_token2] = ACTIONS(3441),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3441),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3441),
    [aux_sym_preproc_else_token1] = ACTIONS(3441),
    [aux_sym_preproc_elif_token1] = ACTIONS(3441),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3441),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3441),
    [sym_preproc_directive] = ACTIONS(3441),
    [anon_sym_LPAREN2] = ACTIONS(3443),
    [anon_sym_BANG] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3441),
    [anon_sym_PLUS] = ACTIONS(3441),
    [anon_sym_STAR] = ACTIONS(3443),
    [anon_sym_AMP_AMP] = ACTIONS(3443),
    [anon_sym_AMP] = ACTIONS(3441),
    [anon_sym_SEMI] = ACTIONS(3443),
    [anon_sym___extension__] = ACTIONS(3441),
    [anon_sym_typedef] = ACTIONS(3441),
    [anon_sym_in] = ACTIONS(3441),
    [anon_sym_out] = ACTIONS(3441),
    [anon_sym_inout] = ACTIONS(3441),
    [anon_sym_extern] = ACTIONS(3441),
    [anon_sym___attribute__] = ACTIONS(3441),
    [anon_sym_COLON_COLON] = ACTIONS(3443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3443),
    [anon_sym___declspec] = ACTIONS(3441),
    [anon_sym___based] = ACTIONS(3441),
    [anon_sym___cdecl] = ACTIONS(3441),
    [anon_sym___clrcall] = ACTIONS(3441),
    [anon_sym___stdcall] = ACTIONS(3441),
    [anon_sym___fastcall] = ACTIONS(3441),
    [anon_sym___thiscall] = ACTIONS(3441),
    [anon_sym___vectorcall] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_signed] = ACTIONS(3441),
    [anon_sym_unsigned] = ACTIONS(3441),
    [anon_sym_long] = ACTIONS(3441),
    [anon_sym_short] = ACTIONS(3441),
    [anon_sym_LBRACK] = ACTIONS(3441),
    [anon_sym_static] = ACTIONS(3441),
    [anon_sym_register] = ACTIONS(3441),
    [anon_sym_inline] = ACTIONS(3441),
    [anon_sym___inline] = ACTIONS(3441),
    [anon_sym___inline__] = ACTIONS(3441),
    [anon_sym___forceinline] = ACTIONS(3441),
    [anon_sym_thread_local] = ACTIONS(3441),
    [anon_sym___thread] = ACTIONS(3441),
    [anon_sym_const] = ACTIONS(3441),
    [anon_sym_constexpr] = ACTIONS(3441),
    [anon_sym_volatile] = ACTIONS(3441),
    [anon_sym_restrict] = ACTIONS(3441),
    [anon_sym___restrict__] = ACTIONS(3441),
    [anon_sym__Atomic] = ACTIONS(3441),
    [anon_sym__Noreturn] = ACTIONS(3441),
    [anon_sym_noreturn] = ACTIONS(3441),
    [anon_sym_mutable] = ACTIONS(3441),
    [anon_sym_constinit] = ACTIONS(3441),
    [anon_sym_consteval] = ACTIONS(3441),
    [anon_sym_alignas] = ACTIONS(3441),
    [anon_sym__Alignas] = ACTIONS(3441),
    [sym_primitive_type] = ACTIONS(3441),
    [anon_sym_enum] = ACTIONS(3441),
    [anon_sym_class] = ACTIONS(3441),
    [anon_sym_struct] = ACTIONS(3441),
    [anon_sym_union] = ACTIONS(3441),
    [anon_sym_if] = ACTIONS(3441),
    [anon_sym_switch] = ACTIONS(3441),
    [anon_sym_case] = ACTIONS(3441),
    [anon_sym_default] = ACTIONS(3441),
    [anon_sym_while] = ACTIONS(3441),
    [anon_sym_do] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3441),
    [anon_sym_return] = ACTIONS(3441),
    [anon_sym_break] = ACTIONS(3441),
    [anon_sym_continue] = ACTIONS(3441),
    [anon_sym_goto] = ACTIONS(3441),
    [anon_sym___try] = ACTIONS(3441),
    [anon_sym___leave] = ACTIONS(3441),
    [anon_sym_not] = ACTIONS(3441),
    [anon_sym_compl] = ACTIONS(3441),
    [anon_sym_DASH_DASH] = ACTIONS(3443),
    [anon_sym_PLUS_PLUS] = ACTIONS(3443),
    [anon_sym_sizeof] = ACTIONS(3441),
    [anon_sym___alignof__] = ACTIONS(3441),
    [anon_sym___alignof] = ACTIONS(3441),
    [anon_sym__alignof] = ACTIONS(3441),
    [anon_sym_alignof] = ACTIONS(3441),
    [anon_sym__Alignof] = ACTIONS(3441),
    [anon_sym_offsetof] = ACTIONS(3441),
    [anon_sym__Generic] = ACTIONS(3441),
    [anon_sym_asm] = ACTIONS(3441),
    [anon_sym___asm__] = ACTIONS(3441),
    [sym_number_literal] = ACTIONS(3443),
    [anon_sym_L_SQUOTE] = ACTIONS(3443),
    [anon_sym_u_SQUOTE] = ACTIONS(3443),
    [anon_sym_U_SQUOTE] = ACTIONS(3443),
    [anon_sym_u8_SQUOTE] = ACTIONS(3443),
    [anon_sym_SQUOTE] = ACTIONS(3443),
    [anon_sym_L_DQUOTE] = ACTIONS(3443),
    [anon_sym_u_DQUOTE] = ACTIONS(3443),
    [anon_sym_U_DQUOTE] = ACTIONS(3443),
    [anon_sym_u8_DQUOTE] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3443),
    [sym_true] = ACTIONS(3441),
    [sym_false] = ACTIONS(3441),
    [anon_sym_NULL] = ACTIONS(3441),
    [anon_sym_nullptr] = ACTIONS(3441),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3441),
    [anon_sym_let] = ACTIONS(3441),
    [anon_sym_This] = ACTIONS(3441),
    [anon_sym_decltype] = ACTIONS(3441),
    [sym_virtual] = ACTIONS(3441),
    [anon_sym_explicit] = ACTIONS(3441),
    [anon_sym_typename] = ACTIONS(3441),
    [anon_sym_template] = ACTIONS(3441),
    [anon_sym_operator] = ACTIONS(3441),
    [anon_sym_try] = ACTIONS(3441),
    [anon_sym_delete] = ACTIONS(3441),
    [anon_sym_throw] = ACTIONS(3441),
    [anon_sym_namespace] = ACTIONS(3441),
    [anon_sym_using] = ACTIONS(3441),
    [anon_sym_static_assert] = ACTIONS(3441),
    [anon_sym_concept] = ACTIONS(3441),
    [anon_sym_co_return] = ACTIONS(3441),
    [anon_sym_co_yield] = ACTIONS(3441),
    [anon_sym_R_DQUOTE] = ACTIONS(3443),
    [anon_sym_LR_DQUOTE] = ACTIONS(3443),
    [anon_sym_uR_DQUOTE] = ACTIONS(3443),
    [anon_sym_UR_DQUOTE] = ACTIONS(3443),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3443),
    [anon_sym_co_await] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3441),
    [anon_sym_requires] = ACTIONS(3441),
    [sym_this] = ACTIONS(3441),
    [anon_sym_discard] = ACTIONS(3441),
    [anon_sym_precise] = ACTIONS(3441),
    [anon_sym_shared] = ACTIONS(3441),
    [anon_sym_groupshared] = ACTIONS(3441),
    [anon_sym_uniform] = ACTIONS(3441),
    [anon_sym_row_major] = ACTIONS(3441),
    [anon_sym_column_major] = ACTIONS(3441),
    [anon_sym_globallycoherent] = ACTIONS(3441),
    [anon_sym_centroid] = ACTIONS(3441),
    [anon_sym_noperspective] = ACTIONS(3441),
    [anon_sym_nointerpolation] = ACTIONS(3441),
    [anon_sym_sample] = ACTIONS(3441),
    [anon_sym_linear] = ACTIONS(3441),
    [anon_sym_snorm] = ACTIONS(3441),
    [anon_sym_unorm] = ACTIONS(3441),
    [anon_sym_point] = ACTIONS(3441),
    [anon_sym_line] = ACTIONS(3441),
    [anon_sym_triangleadj] = ACTIONS(3441),
    [anon_sym_lineadj] = ACTIONS(3441),
    [anon_sym_triangle] = ACTIONS(3441),
    [anon_sym_cbuffer] = ACTIONS(3441),
    [anon_sym_interface] = ACTIONS(3441),
    [anon_sym_extension] = ACTIONS(3441),
  },
  [451] = {
    [sym_identifier] = ACTIONS(3445),
    [aux_sym_preproc_include_token1] = ACTIONS(3445),
    [aux_sym_preproc_def_token1] = ACTIONS(3445),
    [aux_sym_preproc_if_token1] = ACTIONS(3445),
    [aux_sym_preproc_if_token2] = ACTIONS(3445),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3445),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3445),
    [aux_sym_preproc_else_token1] = ACTIONS(3445),
    [aux_sym_preproc_elif_token1] = ACTIONS(3445),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3445),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3445),
    [sym_preproc_directive] = ACTIONS(3445),
    [anon_sym_LPAREN2] = ACTIONS(3447),
    [anon_sym_BANG] = ACTIONS(3447),
    [anon_sym_TILDE] = ACTIONS(3447),
    [anon_sym_DASH] = ACTIONS(3445),
    [anon_sym_PLUS] = ACTIONS(3445),
    [anon_sym_STAR] = ACTIONS(3447),
    [anon_sym_AMP_AMP] = ACTIONS(3447),
    [anon_sym_AMP] = ACTIONS(3445),
    [anon_sym_SEMI] = ACTIONS(3447),
    [anon_sym___extension__] = ACTIONS(3445),
    [anon_sym_typedef] = ACTIONS(3445),
    [anon_sym_in] = ACTIONS(3445),
    [anon_sym_out] = ACTIONS(3445),
    [anon_sym_inout] = ACTIONS(3445),
    [anon_sym_extern] = ACTIONS(3445),
    [anon_sym___attribute__] = ACTIONS(3445),
    [anon_sym_COLON_COLON] = ACTIONS(3447),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3447),
    [anon_sym___declspec] = ACTIONS(3445),
    [anon_sym___based] = ACTIONS(3445),
    [anon_sym___cdecl] = ACTIONS(3445),
    [anon_sym___clrcall] = ACTIONS(3445),
    [anon_sym___stdcall] = ACTIONS(3445),
    [anon_sym___fastcall] = ACTIONS(3445),
    [anon_sym___thiscall] = ACTIONS(3445),
    [anon_sym___vectorcall] = ACTIONS(3445),
    [anon_sym_LBRACE] = ACTIONS(3447),
    [anon_sym_signed] = ACTIONS(3445),
    [anon_sym_unsigned] = ACTIONS(3445),
    [anon_sym_long] = ACTIONS(3445),
    [anon_sym_short] = ACTIONS(3445),
    [anon_sym_LBRACK] = ACTIONS(3445),
    [anon_sym_static] = ACTIONS(3445),
    [anon_sym_register] = ACTIONS(3445),
    [anon_sym_inline] = ACTIONS(3445),
    [anon_sym___inline] = ACTIONS(3445),
    [anon_sym___inline__] = ACTIONS(3445),
    [anon_sym___forceinline] = ACTIONS(3445),
    [anon_sym_thread_local] = ACTIONS(3445),
    [anon_sym___thread] = ACTIONS(3445),
    [anon_sym_const] = ACTIONS(3445),
    [anon_sym_constexpr] = ACTIONS(3445),
    [anon_sym_volatile] = ACTIONS(3445),
    [anon_sym_restrict] = ACTIONS(3445),
    [anon_sym___restrict__] = ACTIONS(3445),
    [anon_sym__Atomic] = ACTIONS(3445),
    [anon_sym__Noreturn] = ACTIONS(3445),
    [anon_sym_noreturn] = ACTIONS(3445),
    [anon_sym_mutable] = ACTIONS(3445),
    [anon_sym_constinit] = ACTIONS(3445),
    [anon_sym_consteval] = ACTIONS(3445),
    [anon_sym_alignas] = ACTIONS(3445),
    [anon_sym__Alignas] = ACTIONS(3445),
    [sym_primitive_type] = ACTIONS(3445),
    [anon_sym_enum] = ACTIONS(3445),
    [anon_sym_class] = ACTIONS(3445),
    [anon_sym_struct] = ACTIONS(3445),
    [anon_sym_union] = ACTIONS(3445),
    [anon_sym_if] = ACTIONS(3445),
    [anon_sym_switch] = ACTIONS(3445),
    [anon_sym_case] = ACTIONS(3445),
    [anon_sym_default] = ACTIONS(3445),
    [anon_sym_while] = ACTIONS(3445),
    [anon_sym_do] = ACTIONS(3445),
    [anon_sym_for] = ACTIONS(3445),
    [anon_sym_return] = ACTIONS(3445),
    [anon_sym_break] = ACTIONS(3445),
    [anon_sym_continue] = ACTIONS(3445),
    [anon_sym_goto] = ACTIONS(3445),
    [anon_sym___try] = ACTIONS(3445),
    [anon_sym___leave] = ACTIONS(3445),
    [anon_sym_not] = ACTIONS(3445),
    [anon_sym_compl] = ACTIONS(3445),
    [anon_sym_DASH_DASH] = ACTIONS(3447),
    [anon_sym_PLUS_PLUS] = ACTIONS(3447),
    [anon_sym_sizeof] = ACTIONS(3445),
    [anon_sym___alignof__] = ACTIONS(3445),
    [anon_sym___alignof] = ACTIONS(3445),
    [anon_sym__alignof] = ACTIONS(3445),
    [anon_sym_alignof] = ACTIONS(3445),
    [anon_sym__Alignof] = ACTIONS(3445),
    [anon_sym_offsetof] = ACTIONS(3445),
    [anon_sym__Generic] = ACTIONS(3445),
    [anon_sym_asm] = ACTIONS(3445),
    [anon_sym___asm__] = ACTIONS(3445),
    [sym_number_literal] = ACTIONS(3447),
    [anon_sym_L_SQUOTE] = ACTIONS(3447),
    [anon_sym_u_SQUOTE] = ACTIONS(3447),
    [anon_sym_U_SQUOTE] = ACTIONS(3447),
    [anon_sym_u8_SQUOTE] = ACTIONS(3447),
    [anon_sym_SQUOTE] = ACTIONS(3447),
    [anon_sym_L_DQUOTE] = ACTIONS(3447),
    [anon_sym_u_DQUOTE] = ACTIONS(3447),
    [anon_sym_U_DQUOTE] = ACTIONS(3447),
    [anon_sym_u8_DQUOTE] = ACTIONS(3447),
    [anon_sym_DQUOTE] = ACTIONS(3447),
    [sym_true] = ACTIONS(3445),
    [sym_false] = ACTIONS(3445),
    [anon_sym_NULL] = ACTIONS(3445),
    [anon_sym_nullptr] = ACTIONS(3445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3445),
    [anon_sym_let] = ACTIONS(3445),
    [anon_sym_This] = ACTIONS(3445),
    [anon_sym_decltype] = ACTIONS(3445),
    [sym_virtual] = ACTIONS(3445),
    [anon_sym_explicit] = ACTIONS(3445),
    [anon_sym_typename] = ACTIONS(3445),
    [anon_sym_template] = ACTIONS(3445),
    [anon_sym_operator] = ACTIONS(3445),
    [anon_sym_try] = ACTIONS(3445),
    [anon_sym_delete] = ACTIONS(3445),
    [anon_sym_throw] = ACTIONS(3445),
    [anon_sym_namespace] = ACTIONS(3445),
    [anon_sym_using] = ACTIONS(3445),
    [anon_sym_static_assert] = ACTIONS(3445),
    [anon_sym_concept] = ACTIONS(3445),
    [anon_sym_co_return] = ACTIONS(3445),
    [anon_sym_co_yield] = ACTIONS(3445),
    [anon_sym_R_DQUOTE] = ACTIONS(3447),
    [anon_sym_LR_DQUOTE] = ACTIONS(3447),
    [anon_sym_uR_DQUOTE] = ACTIONS(3447),
    [anon_sym_UR_DQUOTE] = ACTIONS(3447),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3447),
    [anon_sym_co_await] = ACTIONS(3445),
    [anon_sym_new] = ACTIONS(3445),
    [anon_sym_requires] = ACTIONS(3445),
    [sym_this] = ACTIONS(3445),
    [anon_sym_discard] = ACTIONS(3445),
    [anon_sym_precise] = ACTIONS(3445),
    [anon_sym_shared] = ACTIONS(3445),
    [anon_sym_groupshared] = ACTIONS(3445),
    [anon_sym_uniform] = ACTIONS(3445),
    [anon_sym_row_major] = ACTIONS(3445),
    [anon_sym_column_major] = ACTIONS(3445),
    [anon_sym_globallycoherent] = ACTIONS(3445),
    [anon_sym_centroid] = ACTIONS(3445),
    [anon_sym_noperspective] = ACTIONS(3445),
    [anon_sym_nointerpolation] = ACTIONS(3445),
    [anon_sym_sample] = ACTIONS(3445),
    [anon_sym_linear] = ACTIONS(3445),
    [anon_sym_snorm] = ACTIONS(3445),
    [anon_sym_unorm] = ACTIONS(3445),
    [anon_sym_point] = ACTIONS(3445),
    [anon_sym_line] = ACTIONS(3445),
    [anon_sym_triangleadj] = ACTIONS(3445),
    [anon_sym_lineadj] = ACTIONS(3445),
    [anon_sym_triangle] = ACTIONS(3445),
    [anon_sym_cbuffer] = ACTIONS(3445),
    [anon_sym_interface] = ACTIONS(3445),
    [anon_sym_extension] = ACTIONS(3445),
  },
  [452] = {
    [sym_identifier] = ACTIONS(3449),
    [aux_sym_preproc_include_token1] = ACTIONS(3449),
    [aux_sym_preproc_def_token1] = ACTIONS(3449),
    [aux_sym_preproc_if_token1] = ACTIONS(3449),
    [aux_sym_preproc_if_token2] = ACTIONS(3449),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3449),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3449),
    [aux_sym_preproc_else_token1] = ACTIONS(3449),
    [aux_sym_preproc_elif_token1] = ACTIONS(3449),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3449),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3449),
    [sym_preproc_directive] = ACTIONS(3449),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_BANG] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3449),
    [anon_sym_PLUS] = ACTIONS(3449),
    [anon_sym_STAR] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_AMP] = ACTIONS(3449),
    [anon_sym_SEMI] = ACTIONS(3451),
    [anon_sym___extension__] = ACTIONS(3449),
    [anon_sym_typedef] = ACTIONS(3449),
    [anon_sym_in] = ACTIONS(3449),
    [anon_sym_out] = ACTIONS(3449),
    [anon_sym_inout] = ACTIONS(3449),
    [anon_sym_extern] = ACTIONS(3449),
    [anon_sym___attribute__] = ACTIONS(3449),
    [anon_sym_COLON_COLON] = ACTIONS(3451),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3451),
    [anon_sym___declspec] = ACTIONS(3449),
    [anon_sym___based] = ACTIONS(3449),
    [anon_sym___cdecl] = ACTIONS(3449),
    [anon_sym___clrcall] = ACTIONS(3449),
    [anon_sym___stdcall] = ACTIONS(3449),
    [anon_sym___fastcall] = ACTIONS(3449),
    [anon_sym___thiscall] = ACTIONS(3449),
    [anon_sym___vectorcall] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_signed] = ACTIONS(3449),
    [anon_sym_unsigned] = ACTIONS(3449),
    [anon_sym_long] = ACTIONS(3449),
    [anon_sym_short] = ACTIONS(3449),
    [anon_sym_LBRACK] = ACTIONS(3449),
    [anon_sym_static] = ACTIONS(3449),
    [anon_sym_register] = ACTIONS(3449),
    [anon_sym_inline] = ACTIONS(3449),
    [anon_sym___inline] = ACTIONS(3449),
    [anon_sym___inline__] = ACTIONS(3449),
    [anon_sym___forceinline] = ACTIONS(3449),
    [anon_sym_thread_local] = ACTIONS(3449),
    [anon_sym___thread] = ACTIONS(3449),
    [anon_sym_const] = ACTIONS(3449),
    [anon_sym_constexpr] = ACTIONS(3449),
    [anon_sym_volatile] = ACTIONS(3449),
    [anon_sym_restrict] = ACTIONS(3449),
    [anon_sym___restrict__] = ACTIONS(3449),
    [anon_sym__Atomic] = ACTIONS(3449),
    [anon_sym__Noreturn] = ACTIONS(3449),
    [anon_sym_noreturn] = ACTIONS(3449),
    [anon_sym_mutable] = ACTIONS(3449),
    [anon_sym_constinit] = ACTIONS(3449),
    [anon_sym_consteval] = ACTIONS(3449),
    [anon_sym_alignas] = ACTIONS(3449),
    [anon_sym__Alignas] = ACTIONS(3449),
    [sym_primitive_type] = ACTIONS(3449),
    [anon_sym_enum] = ACTIONS(3449),
    [anon_sym_class] = ACTIONS(3449),
    [anon_sym_struct] = ACTIONS(3449),
    [anon_sym_union] = ACTIONS(3449),
    [anon_sym_if] = ACTIONS(3449),
    [anon_sym_switch] = ACTIONS(3449),
    [anon_sym_case] = ACTIONS(3449),
    [anon_sym_default] = ACTIONS(3449),
    [anon_sym_while] = ACTIONS(3449),
    [anon_sym_do] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3449),
    [anon_sym_return] = ACTIONS(3449),
    [anon_sym_break] = ACTIONS(3449),
    [anon_sym_continue] = ACTIONS(3449),
    [anon_sym_goto] = ACTIONS(3449),
    [anon_sym___try] = ACTIONS(3449),
    [anon_sym___leave] = ACTIONS(3449),
    [anon_sym_not] = ACTIONS(3449),
    [anon_sym_compl] = ACTIONS(3449),
    [anon_sym_DASH_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_PLUS] = ACTIONS(3451),
    [anon_sym_sizeof] = ACTIONS(3449),
    [anon_sym___alignof__] = ACTIONS(3449),
    [anon_sym___alignof] = ACTIONS(3449),
    [anon_sym__alignof] = ACTIONS(3449),
    [anon_sym_alignof] = ACTIONS(3449),
    [anon_sym__Alignof] = ACTIONS(3449),
    [anon_sym_offsetof] = ACTIONS(3449),
    [anon_sym__Generic] = ACTIONS(3449),
    [anon_sym_asm] = ACTIONS(3449),
    [anon_sym___asm__] = ACTIONS(3449),
    [sym_number_literal] = ACTIONS(3451),
    [anon_sym_L_SQUOTE] = ACTIONS(3451),
    [anon_sym_u_SQUOTE] = ACTIONS(3451),
    [anon_sym_U_SQUOTE] = ACTIONS(3451),
    [anon_sym_u8_SQUOTE] = ACTIONS(3451),
    [anon_sym_SQUOTE] = ACTIONS(3451),
    [anon_sym_L_DQUOTE] = ACTIONS(3451),
    [anon_sym_u_DQUOTE] = ACTIONS(3451),
    [anon_sym_U_DQUOTE] = ACTIONS(3451),
    [anon_sym_u8_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [sym_true] = ACTIONS(3449),
    [sym_false] = ACTIONS(3449),
    [anon_sym_NULL] = ACTIONS(3449),
    [anon_sym_nullptr] = ACTIONS(3449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3449),
    [anon_sym_let] = ACTIONS(3449),
    [anon_sym_This] = ACTIONS(3449),
    [anon_sym_decltype] = ACTIONS(3449),
    [sym_virtual] = ACTIONS(3449),
    [anon_sym_explicit] = ACTIONS(3449),
    [anon_sym_typename] = ACTIONS(3449),
    [anon_sym_template] = ACTIONS(3449),
    [anon_sym_operator] = ACTIONS(3449),
    [anon_sym_try] = ACTIONS(3449),
    [anon_sym_delete] = ACTIONS(3449),
    [anon_sym_throw] = ACTIONS(3449),
    [anon_sym_namespace] = ACTIONS(3449),
    [anon_sym_using] = ACTIONS(3449),
    [anon_sym_static_assert] = ACTIONS(3449),
    [anon_sym_concept] = ACTIONS(3449),
    [anon_sym_co_return] = ACTIONS(3449),
    [anon_sym_co_yield] = ACTIONS(3449),
    [anon_sym_R_DQUOTE] = ACTIONS(3451),
    [anon_sym_LR_DQUOTE] = ACTIONS(3451),
    [anon_sym_uR_DQUOTE] = ACTIONS(3451),
    [anon_sym_UR_DQUOTE] = ACTIONS(3451),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3451),
    [anon_sym_co_await] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3449),
    [anon_sym_requires] = ACTIONS(3449),
    [sym_this] = ACTIONS(3449),
    [anon_sym_discard] = ACTIONS(3449),
    [anon_sym_precise] = ACTIONS(3449),
    [anon_sym_shared] = ACTIONS(3449),
    [anon_sym_groupshared] = ACTIONS(3449),
    [anon_sym_uniform] = ACTIONS(3449),
    [anon_sym_row_major] = ACTIONS(3449),
    [anon_sym_column_major] = ACTIONS(3449),
    [anon_sym_globallycoherent] = ACTIONS(3449),
    [anon_sym_centroid] = ACTIONS(3449),
    [anon_sym_noperspective] = ACTIONS(3449),
    [anon_sym_nointerpolation] = ACTIONS(3449),
    [anon_sym_sample] = ACTIONS(3449),
    [anon_sym_linear] = ACTIONS(3449),
    [anon_sym_snorm] = ACTIONS(3449),
    [anon_sym_unorm] = ACTIONS(3449),
    [anon_sym_point] = ACTIONS(3449),
    [anon_sym_line] = ACTIONS(3449),
    [anon_sym_triangleadj] = ACTIONS(3449),
    [anon_sym_lineadj] = ACTIONS(3449),
    [anon_sym_triangle] = ACTIONS(3449),
    [anon_sym_cbuffer] = ACTIONS(3449),
    [anon_sym_interface] = ACTIONS(3449),
    [anon_sym_extension] = ACTIONS(3449),
  },
  [453] = {
    [sym_else_clause] = STATE(579),
    [ts_builtin_sym_end] = ACTIONS(2848),
    [sym_identifier] = ACTIONS(2846),
    [aux_sym_preproc_include_token1] = ACTIONS(2846),
    [aux_sym_preproc_def_token1] = ACTIONS(2846),
    [aux_sym_preproc_if_token1] = ACTIONS(2846),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2846),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2846),
    [sym_preproc_directive] = ACTIONS(2846),
    [anon_sym_LPAREN2] = ACTIONS(2848),
    [anon_sym_BANG] = ACTIONS(2848),
    [anon_sym_TILDE] = ACTIONS(2848),
    [anon_sym_DASH] = ACTIONS(2846),
    [anon_sym_PLUS] = ACTIONS(2846),
    [anon_sym_STAR] = ACTIONS(2848),
    [anon_sym_AMP_AMP] = ACTIONS(2848),
    [anon_sym_AMP] = ACTIONS(2846),
    [anon_sym_SEMI] = ACTIONS(2848),
    [anon_sym___extension__] = ACTIONS(2846),
    [anon_sym_typedef] = ACTIONS(2846),
    [anon_sym_in] = ACTIONS(2846),
    [anon_sym_out] = ACTIONS(2846),
    [anon_sym_inout] = ACTIONS(2846),
    [anon_sym_extern] = ACTIONS(2846),
    [anon_sym___attribute__] = ACTIONS(2846),
    [anon_sym_COLON_COLON] = ACTIONS(2848),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2848),
    [anon_sym___declspec] = ACTIONS(2846),
    [anon_sym___based] = ACTIONS(2846),
    [anon_sym___cdecl] = ACTIONS(2846),
    [anon_sym___clrcall] = ACTIONS(2846),
    [anon_sym___stdcall] = ACTIONS(2846),
    [anon_sym___fastcall] = ACTIONS(2846),
    [anon_sym___thiscall] = ACTIONS(2846),
    [anon_sym___vectorcall] = ACTIONS(2846),
    [anon_sym_LBRACE] = ACTIONS(2848),
    [anon_sym_signed] = ACTIONS(2846),
    [anon_sym_unsigned] = ACTIONS(2846),
    [anon_sym_long] = ACTIONS(2846),
    [anon_sym_short] = ACTIONS(2846),
    [anon_sym_LBRACK] = ACTIONS(2846),
    [anon_sym_static] = ACTIONS(2846),
    [anon_sym_register] = ACTIONS(2846),
    [anon_sym_inline] = ACTIONS(2846),
    [anon_sym___inline] = ACTIONS(2846),
    [anon_sym___inline__] = ACTIONS(2846),
    [anon_sym___forceinline] = ACTIONS(2846),
    [anon_sym_thread_local] = ACTIONS(2846),
    [anon_sym___thread] = ACTIONS(2846),
    [anon_sym_const] = ACTIONS(2846),
    [anon_sym_constexpr] = ACTIONS(2846),
    [anon_sym_volatile] = ACTIONS(2846),
    [anon_sym_restrict] = ACTIONS(2846),
    [anon_sym___restrict__] = ACTIONS(2846),
    [anon_sym__Atomic] = ACTIONS(2846),
    [anon_sym__Noreturn] = ACTIONS(2846),
    [anon_sym_noreturn] = ACTIONS(2846),
    [anon_sym_mutable] = ACTIONS(2846),
    [anon_sym_constinit] = ACTIONS(2846),
    [anon_sym_consteval] = ACTIONS(2846),
    [anon_sym_alignas] = ACTIONS(2846),
    [anon_sym__Alignas] = ACTIONS(2846),
    [sym_primitive_type] = ACTIONS(2846),
    [anon_sym_enum] = ACTIONS(2846),
    [anon_sym_class] = ACTIONS(2846),
    [anon_sym_struct] = ACTIONS(2846),
    [anon_sym_union] = ACTIONS(2846),
    [anon_sym_if] = ACTIONS(2846),
    [anon_sym_else] = ACTIONS(3453),
    [anon_sym_switch] = ACTIONS(2846),
    [anon_sym_case] = ACTIONS(2846),
    [anon_sym_default] = ACTIONS(2846),
    [anon_sym_while] = ACTIONS(2846),
    [anon_sym_do] = ACTIONS(2846),
    [anon_sym_for] = ACTIONS(2846),
    [anon_sym_return] = ACTIONS(2846),
    [anon_sym_break] = ACTIONS(2846),
    [anon_sym_continue] = ACTIONS(2846),
    [anon_sym_goto] = ACTIONS(2846),
    [anon_sym___try] = ACTIONS(2846),
    [anon_sym___leave] = ACTIONS(2846),
    [anon_sym_not] = ACTIONS(2846),
    [anon_sym_compl] = ACTIONS(2846),
    [anon_sym_DASH_DASH] = ACTIONS(2848),
    [anon_sym_PLUS_PLUS] = ACTIONS(2848),
    [anon_sym_sizeof] = ACTIONS(2846),
    [anon_sym___alignof__] = ACTIONS(2846),
    [anon_sym___alignof] = ACTIONS(2846),
    [anon_sym__alignof] = ACTIONS(2846),
    [anon_sym_alignof] = ACTIONS(2846),
    [anon_sym__Alignof] = ACTIONS(2846),
    [anon_sym_offsetof] = ACTIONS(2846),
    [anon_sym__Generic] = ACTIONS(2846),
    [anon_sym_asm] = ACTIONS(2846),
    [anon_sym___asm__] = ACTIONS(2846),
    [sym_number_literal] = ACTIONS(2848),
    [anon_sym_L_SQUOTE] = ACTIONS(2848),
    [anon_sym_u_SQUOTE] = ACTIONS(2848),
    [anon_sym_U_SQUOTE] = ACTIONS(2848),
    [anon_sym_u8_SQUOTE] = ACTIONS(2848),
    [anon_sym_SQUOTE] = ACTIONS(2848),
    [anon_sym_L_DQUOTE] = ACTIONS(2848),
    [anon_sym_u_DQUOTE] = ACTIONS(2848),
    [anon_sym_U_DQUOTE] = ACTIONS(2848),
    [anon_sym_u8_DQUOTE] = ACTIONS(2848),
    [anon_sym_DQUOTE] = ACTIONS(2848),
    [sym_true] = ACTIONS(2846),
    [sym_false] = ACTIONS(2846),
    [anon_sym_NULL] = ACTIONS(2846),
    [anon_sym_nullptr] = ACTIONS(2846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2846),
    [anon_sym_let] = ACTIONS(2846),
    [anon_sym_This] = ACTIONS(2846),
    [anon_sym_decltype] = ACTIONS(2846),
    [sym_virtual] = ACTIONS(2846),
    [anon_sym_explicit] = ACTIONS(2846),
    [anon_sym_typename] = ACTIONS(2846),
    [anon_sym_template] = ACTIONS(2846),
    [anon_sym_operator] = ACTIONS(2846),
    [anon_sym_try] = ACTIONS(2846),
    [anon_sym_delete] = ACTIONS(2846),
    [anon_sym_throw] = ACTIONS(2846),
    [anon_sym_namespace] = ACTIONS(2846),
    [anon_sym_using] = ACTIONS(2846),
    [anon_sym_static_assert] = ACTIONS(2846),
    [anon_sym_concept] = ACTIONS(2846),
    [anon_sym_co_return] = ACTIONS(2846),
    [anon_sym_co_yield] = ACTIONS(2846),
    [anon_sym_R_DQUOTE] = ACTIONS(2848),
    [anon_sym_LR_DQUOTE] = ACTIONS(2848),
    [anon_sym_uR_DQUOTE] = ACTIONS(2848),
    [anon_sym_UR_DQUOTE] = ACTIONS(2848),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2848),
    [anon_sym_co_await] = ACTIONS(2846),
    [anon_sym_new] = ACTIONS(2846),
    [anon_sym_requires] = ACTIONS(2846),
    [sym_this] = ACTIONS(2846),
    [anon_sym_discard] = ACTIONS(2846),
    [anon_sym_precise] = ACTIONS(2846),
    [anon_sym_shared] = ACTIONS(2846),
    [anon_sym_groupshared] = ACTIONS(2846),
    [anon_sym_uniform] = ACTIONS(2846),
    [anon_sym_row_major] = ACTIONS(2846),
    [anon_sym_column_major] = ACTIONS(2846),
    [anon_sym_globallycoherent] = ACTIONS(2846),
    [anon_sym_centroid] = ACTIONS(2846),
    [anon_sym_noperspective] = ACTIONS(2846),
    [anon_sym_nointerpolation] = ACTIONS(2846),
    [anon_sym_sample] = ACTIONS(2846),
    [anon_sym_linear] = ACTIONS(2846),
    [anon_sym_snorm] = ACTIONS(2846),
    [anon_sym_unorm] = ACTIONS(2846),
    [anon_sym_point] = ACTIONS(2846),
    [anon_sym_line] = ACTIONS(2846),
    [anon_sym_triangleadj] = ACTIONS(2846),
    [anon_sym_lineadj] = ACTIONS(2846),
    [anon_sym_triangle] = ACTIONS(2846),
    [anon_sym_cbuffer] = ACTIONS(2846),
    [anon_sym_interface] = ACTIONS(2846),
    [anon_sym_extension] = ACTIONS(2846),
    [anon_sym___exported] = ACTIONS(2846),
    [anon_sym_import] = ACTIONS(2846),
  },
  [454] = {
    [sym_identifier] = ACTIONS(3455),
    [aux_sym_preproc_include_token1] = ACTIONS(3455),
    [aux_sym_preproc_def_token1] = ACTIONS(3455),
    [aux_sym_preproc_if_token1] = ACTIONS(3455),
    [aux_sym_preproc_if_token2] = ACTIONS(3455),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3455),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3455),
    [aux_sym_preproc_else_token1] = ACTIONS(3455),
    [aux_sym_preproc_elif_token1] = ACTIONS(3455),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3455),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3455),
    [sym_preproc_directive] = ACTIONS(3455),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_BANG] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3457),
    [anon_sym_DASH] = ACTIONS(3455),
    [anon_sym_PLUS] = ACTIONS(3455),
    [anon_sym_STAR] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3457),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym_SEMI] = ACTIONS(3457),
    [anon_sym___extension__] = ACTIONS(3455),
    [anon_sym_typedef] = ACTIONS(3455),
    [anon_sym_in] = ACTIONS(3455),
    [anon_sym_out] = ACTIONS(3455),
    [anon_sym_inout] = ACTIONS(3455),
    [anon_sym_extern] = ACTIONS(3455),
    [anon_sym___attribute__] = ACTIONS(3455),
    [anon_sym_COLON_COLON] = ACTIONS(3457),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3457),
    [anon_sym___declspec] = ACTIONS(3455),
    [anon_sym___based] = ACTIONS(3455),
    [anon_sym___cdecl] = ACTIONS(3455),
    [anon_sym___clrcall] = ACTIONS(3455),
    [anon_sym___stdcall] = ACTIONS(3455),
    [anon_sym___fastcall] = ACTIONS(3455),
    [anon_sym___thiscall] = ACTIONS(3455),
    [anon_sym___vectorcall] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_signed] = ACTIONS(3455),
    [anon_sym_unsigned] = ACTIONS(3455),
    [anon_sym_long] = ACTIONS(3455),
    [anon_sym_short] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_static] = ACTIONS(3455),
    [anon_sym_register] = ACTIONS(3455),
    [anon_sym_inline] = ACTIONS(3455),
    [anon_sym___inline] = ACTIONS(3455),
    [anon_sym___inline__] = ACTIONS(3455),
    [anon_sym___forceinline] = ACTIONS(3455),
    [anon_sym_thread_local] = ACTIONS(3455),
    [anon_sym___thread] = ACTIONS(3455),
    [anon_sym_const] = ACTIONS(3455),
    [anon_sym_constexpr] = ACTIONS(3455),
    [anon_sym_volatile] = ACTIONS(3455),
    [anon_sym_restrict] = ACTIONS(3455),
    [anon_sym___restrict__] = ACTIONS(3455),
    [anon_sym__Atomic] = ACTIONS(3455),
    [anon_sym__Noreturn] = ACTIONS(3455),
    [anon_sym_noreturn] = ACTIONS(3455),
    [anon_sym_mutable] = ACTIONS(3455),
    [anon_sym_constinit] = ACTIONS(3455),
    [anon_sym_consteval] = ACTIONS(3455),
    [anon_sym_alignas] = ACTIONS(3455),
    [anon_sym__Alignas] = ACTIONS(3455),
    [sym_primitive_type] = ACTIONS(3455),
    [anon_sym_enum] = ACTIONS(3455),
    [anon_sym_class] = ACTIONS(3455),
    [anon_sym_struct] = ACTIONS(3455),
    [anon_sym_union] = ACTIONS(3455),
    [anon_sym_if] = ACTIONS(3455),
    [anon_sym_switch] = ACTIONS(3455),
    [anon_sym_case] = ACTIONS(3455),
    [anon_sym_default] = ACTIONS(3455),
    [anon_sym_while] = ACTIONS(3455),
    [anon_sym_do] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3455),
    [anon_sym_return] = ACTIONS(3455),
    [anon_sym_break] = ACTIONS(3455),
    [anon_sym_continue] = ACTIONS(3455),
    [anon_sym_goto] = ACTIONS(3455),
    [anon_sym___try] = ACTIONS(3455),
    [anon_sym___leave] = ACTIONS(3455),
    [anon_sym_not] = ACTIONS(3455),
    [anon_sym_compl] = ACTIONS(3455),
    [anon_sym_DASH_DASH] = ACTIONS(3457),
    [anon_sym_PLUS_PLUS] = ACTIONS(3457),
    [anon_sym_sizeof] = ACTIONS(3455),
    [anon_sym___alignof__] = ACTIONS(3455),
    [anon_sym___alignof] = ACTIONS(3455),
    [anon_sym__alignof] = ACTIONS(3455),
    [anon_sym_alignof] = ACTIONS(3455),
    [anon_sym__Alignof] = ACTIONS(3455),
    [anon_sym_offsetof] = ACTIONS(3455),
    [anon_sym__Generic] = ACTIONS(3455),
    [anon_sym_asm] = ACTIONS(3455),
    [anon_sym___asm__] = ACTIONS(3455),
    [sym_number_literal] = ACTIONS(3457),
    [anon_sym_L_SQUOTE] = ACTIONS(3457),
    [anon_sym_u_SQUOTE] = ACTIONS(3457),
    [anon_sym_U_SQUOTE] = ACTIONS(3457),
    [anon_sym_u8_SQUOTE] = ACTIONS(3457),
    [anon_sym_SQUOTE] = ACTIONS(3457),
    [anon_sym_L_DQUOTE] = ACTIONS(3457),
    [anon_sym_u_DQUOTE] = ACTIONS(3457),
    [anon_sym_U_DQUOTE] = ACTIONS(3457),
    [anon_sym_u8_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [sym_true] = ACTIONS(3455),
    [sym_false] = ACTIONS(3455),
    [anon_sym_NULL] = ACTIONS(3455),
    [anon_sym_nullptr] = ACTIONS(3455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3455),
    [anon_sym_let] = ACTIONS(3455),
    [anon_sym_This] = ACTIONS(3455),
    [anon_sym_decltype] = ACTIONS(3455),
    [sym_virtual] = ACTIONS(3455),
    [anon_sym_explicit] = ACTIONS(3455),
    [anon_sym_typename] = ACTIONS(3455),
    [anon_sym_template] = ACTIONS(3455),
    [anon_sym_operator] = ACTIONS(3455),
    [anon_sym_try] = ACTIONS(3455),
    [anon_sym_delete] = ACTIONS(3455),
    [anon_sym_throw] = ACTIONS(3455),
    [anon_sym_namespace] = ACTIONS(3455),
    [anon_sym_using] = ACTIONS(3455),
    [anon_sym_static_assert] = ACTIONS(3455),
    [anon_sym_concept] = ACTIONS(3455),
    [anon_sym_co_return] = ACTIONS(3455),
    [anon_sym_co_yield] = ACTIONS(3455),
    [anon_sym_R_DQUOTE] = ACTIONS(3457),
    [anon_sym_LR_DQUOTE] = ACTIONS(3457),
    [anon_sym_uR_DQUOTE] = ACTIONS(3457),
    [anon_sym_UR_DQUOTE] = ACTIONS(3457),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3457),
    [anon_sym_co_await] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_requires] = ACTIONS(3455),
    [sym_this] = ACTIONS(3455),
    [anon_sym_discard] = ACTIONS(3455),
    [anon_sym_precise] = ACTIONS(3455),
    [anon_sym_shared] = ACTIONS(3455),
    [anon_sym_groupshared] = ACTIONS(3455),
    [anon_sym_uniform] = ACTIONS(3455),
    [anon_sym_row_major] = ACTIONS(3455),
    [anon_sym_column_major] = ACTIONS(3455),
    [anon_sym_globallycoherent] = ACTIONS(3455),
    [anon_sym_centroid] = ACTIONS(3455),
    [anon_sym_noperspective] = ACTIONS(3455),
    [anon_sym_nointerpolation] = ACTIONS(3455),
    [anon_sym_sample] = ACTIONS(3455),
    [anon_sym_linear] = ACTIONS(3455),
    [anon_sym_snorm] = ACTIONS(3455),
    [anon_sym_unorm] = ACTIONS(3455),
    [anon_sym_point] = ACTIONS(3455),
    [anon_sym_line] = ACTIONS(3455),
    [anon_sym_triangleadj] = ACTIONS(3455),
    [anon_sym_lineadj] = ACTIONS(3455),
    [anon_sym_triangle] = ACTIONS(3455),
    [anon_sym_cbuffer] = ACTIONS(3455),
    [anon_sym_interface] = ACTIONS(3455),
    [anon_sym_extension] = ACTIONS(3455),
  },
  [455] = {
    [sym_identifier] = ACTIONS(3459),
    [aux_sym_preproc_include_token1] = ACTIONS(3459),
    [aux_sym_preproc_def_token1] = ACTIONS(3459),
    [aux_sym_preproc_if_token1] = ACTIONS(3459),
    [aux_sym_preproc_if_token2] = ACTIONS(3459),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3459),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3459),
    [aux_sym_preproc_else_token1] = ACTIONS(3459),
    [aux_sym_preproc_elif_token1] = ACTIONS(3459),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3459),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3459),
    [sym_preproc_directive] = ACTIONS(3459),
    [anon_sym_LPAREN2] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_TILDE] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3459),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3459),
    [anon_sym_SEMI] = ACTIONS(3461),
    [anon_sym___extension__] = ACTIONS(3459),
    [anon_sym_typedef] = ACTIONS(3459),
    [anon_sym_in] = ACTIONS(3459),
    [anon_sym_out] = ACTIONS(3459),
    [anon_sym_inout] = ACTIONS(3459),
    [anon_sym_extern] = ACTIONS(3459),
    [anon_sym___attribute__] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3461),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3461),
    [anon_sym___declspec] = ACTIONS(3459),
    [anon_sym___based] = ACTIONS(3459),
    [anon_sym___cdecl] = ACTIONS(3459),
    [anon_sym___clrcall] = ACTIONS(3459),
    [anon_sym___stdcall] = ACTIONS(3459),
    [anon_sym___fastcall] = ACTIONS(3459),
    [anon_sym___thiscall] = ACTIONS(3459),
    [anon_sym___vectorcall] = ACTIONS(3459),
    [anon_sym_LBRACE] = ACTIONS(3461),
    [anon_sym_signed] = ACTIONS(3459),
    [anon_sym_unsigned] = ACTIONS(3459),
    [anon_sym_long] = ACTIONS(3459),
    [anon_sym_short] = ACTIONS(3459),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_static] = ACTIONS(3459),
    [anon_sym_register] = ACTIONS(3459),
    [anon_sym_inline] = ACTIONS(3459),
    [anon_sym___inline] = ACTIONS(3459),
    [anon_sym___inline__] = ACTIONS(3459),
    [anon_sym___forceinline] = ACTIONS(3459),
    [anon_sym_thread_local] = ACTIONS(3459),
    [anon_sym___thread] = ACTIONS(3459),
    [anon_sym_const] = ACTIONS(3459),
    [anon_sym_constexpr] = ACTIONS(3459),
    [anon_sym_volatile] = ACTIONS(3459),
    [anon_sym_restrict] = ACTIONS(3459),
    [anon_sym___restrict__] = ACTIONS(3459),
    [anon_sym__Atomic] = ACTIONS(3459),
    [anon_sym__Noreturn] = ACTIONS(3459),
    [anon_sym_noreturn] = ACTIONS(3459),
    [anon_sym_mutable] = ACTIONS(3459),
    [anon_sym_constinit] = ACTIONS(3459),
    [anon_sym_consteval] = ACTIONS(3459),
    [anon_sym_alignas] = ACTIONS(3459),
    [anon_sym__Alignas] = ACTIONS(3459),
    [sym_primitive_type] = ACTIONS(3459),
    [anon_sym_enum] = ACTIONS(3459),
    [anon_sym_class] = ACTIONS(3459),
    [anon_sym_struct] = ACTIONS(3459),
    [anon_sym_union] = ACTIONS(3459),
    [anon_sym_if] = ACTIONS(3459),
    [anon_sym_switch] = ACTIONS(3459),
    [anon_sym_case] = ACTIONS(3459),
    [anon_sym_default] = ACTIONS(3459),
    [anon_sym_while] = ACTIONS(3459),
    [anon_sym_do] = ACTIONS(3459),
    [anon_sym_for] = ACTIONS(3459),
    [anon_sym_return] = ACTIONS(3459),
    [anon_sym_break] = ACTIONS(3459),
    [anon_sym_continue] = ACTIONS(3459),
    [anon_sym_goto] = ACTIONS(3459),
    [anon_sym___try] = ACTIONS(3459),
    [anon_sym___leave] = ACTIONS(3459),
    [anon_sym_not] = ACTIONS(3459),
    [anon_sym_compl] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3461),
    [anon_sym_sizeof] = ACTIONS(3459),
    [anon_sym___alignof__] = ACTIONS(3459),
    [anon_sym___alignof] = ACTIONS(3459),
    [anon_sym__alignof] = ACTIONS(3459),
    [anon_sym_alignof] = ACTIONS(3459),
    [anon_sym__Alignof] = ACTIONS(3459),
    [anon_sym_offsetof] = ACTIONS(3459),
    [anon_sym__Generic] = ACTIONS(3459),
    [anon_sym_asm] = ACTIONS(3459),
    [anon_sym___asm__] = ACTIONS(3459),
    [sym_number_literal] = ACTIONS(3461),
    [anon_sym_L_SQUOTE] = ACTIONS(3461),
    [anon_sym_u_SQUOTE] = ACTIONS(3461),
    [anon_sym_U_SQUOTE] = ACTIONS(3461),
    [anon_sym_u8_SQUOTE] = ACTIONS(3461),
    [anon_sym_SQUOTE] = ACTIONS(3461),
    [anon_sym_L_DQUOTE] = ACTIONS(3461),
    [anon_sym_u_DQUOTE] = ACTIONS(3461),
    [anon_sym_U_DQUOTE] = ACTIONS(3461),
    [anon_sym_u8_DQUOTE] = ACTIONS(3461),
    [anon_sym_DQUOTE] = ACTIONS(3461),
    [sym_true] = ACTIONS(3459),
    [sym_false] = ACTIONS(3459),
    [anon_sym_NULL] = ACTIONS(3459),
    [anon_sym_nullptr] = ACTIONS(3459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3459),
    [anon_sym_let] = ACTIONS(3459),
    [anon_sym_This] = ACTIONS(3459),
    [anon_sym_decltype] = ACTIONS(3459),
    [sym_virtual] = ACTIONS(3459),
    [anon_sym_explicit] = ACTIONS(3459),
    [anon_sym_typename] = ACTIONS(3459),
    [anon_sym_template] = ACTIONS(3459),
    [anon_sym_operator] = ACTIONS(3459),
    [anon_sym_try] = ACTIONS(3459),
    [anon_sym_delete] = ACTIONS(3459),
    [anon_sym_throw] = ACTIONS(3459),
    [anon_sym_namespace] = ACTIONS(3459),
    [anon_sym_using] = ACTIONS(3459),
    [anon_sym_static_assert] = ACTIONS(3459),
    [anon_sym_concept] = ACTIONS(3459),
    [anon_sym_co_return] = ACTIONS(3459),
    [anon_sym_co_yield] = ACTIONS(3459),
    [anon_sym_R_DQUOTE] = ACTIONS(3461),
    [anon_sym_LR_DQUOTE] = ACTIONS(3461),
    [anon_sym_uR_DQUOTE] = ACTIONS(3461),
    [anon_sym_UR_DQUOTE] = ACTIONS(3461),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3461),
    [anon_sym_co_await] = ACTIONS(3459),
    [anon_sym_new] = ACTIONS(3459),
    [anon_sym_requires] = ACTIONS(3459),
    [sym_this] = ACTIONS(3459),
    [anon_sym_discard] = ACTIONS(3459),
    [anon_sym_precise] = ACTIONS(3459),
    [anon_sym_shared] = ACTIONS(3459),
    [anon_sym_groupshared] = ACTIONS(3459),
    [anon_sym_uniform] = ACTIONS(3459),
    [anon_sym_row_major] = ACTIONS(3459),
    [anon_sym_column_major] = ACTIONS(3459),
    [anon_sym_globallycoherent] = ACTIONS(3459),
    [anon_sym_centroid] = ACTIONS(3459),
    [anon_sym_noperspective] = ACTIONS(3459),
    [anon_sym_nointerpolation] = ACTIONS(3459),
    [anon_sym_sample] = ACTIONS(3459),
    [anon_sym_linear] = ACTIONS(3459),
    [anon_sym_snorm] = ACTIONS(3459),
    [anon_sym_unorm] = ACTIONS(3459),
    [anon_sym_point] = ACTIONS(3459),
    [anon_sym_line] = ACTIONS(3459),
    [anon_sym_triangleadj] = ACTIONS(3459),
    [anon_sym_lineadj] = ACTIONS(3459),
    [anon_sym_triangle] = ACTIONS(3459),
    [anon_sym_cbuffer] = ACTIONS(3459),
    [anon_sym_interface] = ACTIONS(3459),
    [anon_sym_extension] = ACTIONS(3459),
  },
  [456] = {
    [sym_identifier] = ACTIONS(2367),
    [aux_sym_preproc_include_token1] = ACTIONS(2367),
    [aux_sym_preproc_def_token1] = ACTIONS(2367),
    [aux_sym_preproc_if_token1] = ACTIONS(2367),
    [aux_sym_preproc_if_token2] = ACTIONS(2367),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2367),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2367),
    [sym_preproc_directive] = ACTIONS(2367),
    [anon_sym_LPAREN2] = ACTIONS(2365),
    [anon_sym_BANG] = ACTIONS(2365),
    [anon_sym_TILDE] = ACTIONS(2365),
    [anon_sym_DASH] = ACTIONS(2367),
    [anon_sym_PLUS] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2365),
    [anon_sym_AMP_AMP] = ACTIONS(2365),
    [anon_sym_AMP] = ACTIONS(2367),
    [anon_sym_COLON] = ACTIONS(2367),
    [anon_sym_SEMI] = ACTIONS(2365),
    [anon_sym___extension__] = ACTIONS(2367),
    [anon_sym_typedef] = ACTIONS(2367),
    [anon_sym_in] = ACTIONS(2367),
    [anon_sym_out] = ACTIONS(2367),
    [anon_sym_inout] = ACTIONS(2367),
    [anon_sym_extern] = ACTIONS(2367),
    [anon_sym___attribute__] = ACTIONS(2367),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2365),
    [anon_sym___declspec] = ACTIONS(2367),
    [anon_sym___based] = ACTIONS(2367),
    [anon_sym___cdecl] = ACTIONS(2367),
    [anon_sym___clrcall] = ACTIONS(2367),
    [anon_sym___stdcall] = ACTIONS(2367),
    [anon_sym___fastcall] = ACTIONS(2367),
    [anon_sym___thiscall] = ACTIONS(2367),
    [anon_sym___vectorcall] = ACTIONS(2367),
    [anon_sym_LBRACE] = ACTIONS(2365),
    [anon_sym_signed] = ACTIONS(2367),
    [anon_sym_unsigned] = ACTIONS(2367),
    [anon_sym_long] = ACTIONS(2367),
    [anon_sym_short] = ACTIONS(2367),
    [anon_sym_LBRACK] = ACTIONS(2367),
    [anon_sym_static] = ACTIONS(2367),
    [anon_sym_register] = ACTIONS(2367),
    [anon_sym_inline] = ACTIONS(2367),
    [anon_sym___inline] = ACTIONS(2367),
    [anon_sym___inline__] = ACTIONS(2367),
    [anon_sym___forceinline] = ACTIONS(2367),
    [anon_sym_thread_local] = ACTIONS(2367),
    [anon_sym___thread] = ACTIONS(2367),
    [anon_sym_const] = ACTIONS(2367),
    [anon_sym_constexpr] = ACTIONS(2367),
    [anon_sym_volatile] = ACTIONS(2367),
    [anon_sym_restrict] = ACTIONS(2367),
    [anon_sym___restrict__] = ACTIONS(2367),
    [anon_sym__Atomic] = ACTIONS(2367),
    [anon_sym__Noreturn] = ACTIONS(2367),
    [anon_sym_noreturn] = ACTIONS(2367),
    [anon_sym_mutable] = ACTIONS(2367),
    [anon_sym_constinit] = ACTIONS(2367),
    [anon_sym_consteval] = ACTIONS(2367),
    [anon_sym_alignas] = ACTIONS(2367),
    [anon_sym__Alignas] = ACTIONS(2367),
    [sym_primitive_type] = ACTIONS(2367),
    [anon_sym_enum] = ACTIONS(2367),
    [anon_sym_class] = ACTIONS(2367),
    [anon_sym_struct] = ACTIONS(2367),
    [anon_sym_union] = ACTIONS(2367),
    [anon_sym_if] = ACTIONS(2367),
    [anon_sym_else] = ACTIONS(2367),
    [anon_sym_switch] = ACTIONS(2367),
    [anon_sym_case] = ACTIONS(2367),
    [anon_sym_default] = ACTIONS(2367),
    [anon_sym_while] = ACTIONS(2367),
    [anon_sym_do] = ACTIONS(2367),
    [anon_sym_for] = ACTIONS(2367),
    [anon_sym_return] = ACTIONS(2367),
    [anon_sym_break] = ACTIONS(2367),
    [anon_sym_continue] = ACTIONS(2367),
    [anon_sym_goto] = ACTIONS(2367),
    [anon_sym___try] = ACTIONS(2367),
    [anon_sym___leave] = ACTIONS(2367),
    [anon_sym_not] = ACTIONS(2367),
    [anon_sym_compl] = ACTIONS(2367),
    [anon_sym_DASH_DASH] = ACTIONS(2365),
    [anon_sym_PLUS_PLUS] = ACTIONS(2365),
    [anon_sym_sizeof] = ACTIONS(2367),
    [anon_sym___alignof__] = ACTIONS(2367),
    [anon_sym___alignof] = ACTIONS(2367),
    [anon_sym__alignof] = ACTIONS(2367),
    [anon_sym_alignof] = ACTIONS(2367),
    [anon_sym__Alignof] = ACTIONS(2367),
    [anon_sym_offsetof] = ACTIONS(2367),
    [anon_sym__Generic] = ACTIONS(2367),
    [anon_sym_asm] = ACTIONS(2367),
    [anon_sym___asm__] = ACTIONS(2367),
    [sym_number_literal] = ACTIONS(2365),
    [anon_sym_L_SQUOTE] = ACTIONS(2365),
    [anon_sym_u_SQUOTE] = ACTIONS(2365),
    [anon_sym_U_SQUOTE] = ACTIONS(2365),
    [anon_sym_u8_SQUOTE] = ACTIONS(2365),
    [anon_sym_SQUOTE] = ACTIONS(2365),
    [anon_sym_L_DQUOTE] = ACTIONS(2365),
    [anon_sym_u_DQUOTE] = ACTIONS(2365),
    [anon_sym_U_DQUOTE] = ACTIONS(2365),
    [anon_sym_u8_DQUOTE] = ACTIONS(2365),
    [anon_sym_DQUOTE] = ACTIONS(2365),
    [sym_true] = ACTIONS(2367),
    [sym_false] = ACTIONS(2367),
    [anon_sym_NULL] = ACTIONS(2367),
    [anon_sym_nullptr] = ACTIONS(2367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2367),
    [anon_sym_let] = ACTIONS(2367),
    [anon_sym_This] = ACTIONS(2367),
    [anon_sym_decltype] = ACTIONS(2367),
    [anon_sym_final] = ACTIONS(2367),
    [anon_sym_override] = ACTIONS(2367),
    [sym_virtual] = ACTIONS(2367),
    [anon_sym_explicit] = ACTIONS(2367),
    [anon_sym_typename] = ACTIONS(2367),
    [anon_sym_template] = ACTIONS(2367),
    [anon_sym_operator] = ACTIONS(2367),
    [anon_sym_try] = ACTIONS(2367),
    [anon_sym_delete] = ACTIONS(2367),
    [anon_sym_throw] = ACTIONS(2367),
    [anon_sym_namespace] = ACTIONS(2367),
    [anon_sym_using] = ACTIONS(2367),
    [anon_sym_static_assert] = ACTIONS(2367),
    [anon_sym_concept] = ACTIONS(2367),
    [anon_sym_co_return] = ACTIONS(2367),
    [anon_sym_co_yield] = ACTIONS(2367),
    [anon_sym_R_DQUOTE] = ACTIONS(2365),
    [anon_sym_LR_DQUOTE] = ACTIONS(2365),
    [anon_sym_uR_DQUOTE] = ACTIONS(2365),
    [anon_sym_UR_DQUOTE] = ACTIONS(2365),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2365),
    [anon_sym_co_await] = ACTIONS(2367),
    [anon_sym_new] = ACTIONS(2367),
    [anon_sym_requires] = ACTIONS(2367),
    [sym_this] = ACTIONS(2367),
    [anon_sym_discard] = ACTIONS(2367),
    [anon_sym_precise] = ACTIONS(2367),
    [anon_sym_shared] = ACTIONS(2367),
    [anon_sym_groupshared] = ACTIONS(2367),
    [anon_sym_uniform] = ACTIONS(2367),
    [anon_sym_row_major] = ACTIONS(2367),
    [anon_sym_column_major] = ACTIONS(2367),
    [anon_sym_globallycoherent] = ACTIONS(2367),
    [anon_sym_centroid] = ACTIONS(2367),
    [anon_sym_noperspective] = ACTIONS(2367),
    [anon_sym_nointerpolation] = ACTIONS(2367),
    [anon_sym_sample] = ACTIONS(2367),
    [anon_sym_linear] = ACTIONS(2367),
    [anon_sym_snorm] = ACTIONS(2367),
    [anon_sym_unorm] = ACTIONS(2367),
    [anon_sym_point] = ACTIONS(2367),
    [anon_sym_line] = ACTIONS(2367),
    [anon_sym_triangleadj] = ACTIONS(2367),
    [anon_sym_lineadj] = ACTIONS(2367),
    [anon_sym_triangle] = ACTIONS(2367),
    [anon_sym_cbuffer] = ACTIONS(2367),
    [anon_sym_interface] = ACTIONS(2367),
    [anon_sym_extension] = ACTIONS(2367),
  },
  [457] = {
    [sym_identifier] = ACTIONS(3463),
    [aux_sym_preproc_include_token1] = ACTIONS(3463),
    [aux_sym_preproc_def_token1] = ACTIONS(3463),
    [aux_sym_preproc_if_token1] = ACTIONS(3463),
    [aux_sym_preproc_if_token2] = ACTIONS(3463),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3463),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3463),
    [aux_sym_preproc_else_token1] = ACTIONS(3463),
    [aux_sym_preproc_elif_token1] = ACTIONS(3463),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3463),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3463),
    [sym_preproc_directive] = ACTIONS(3463),
    [anon_sym_LPAREN2] = ACTIONS(3465),
    [anon_sym_BANG] = ACTIONS(3465),
    [anon_sym_TILDE] = ACTIONS(3465),
    [anon_sym_DASH] = ACTIONS(3463),
    [anon_sym_PLUS] = ACTIONS(3463),
    [anon_sym_STAR] = ACTIONS(3465),
    [anon_sym_AMP_AMP] = ACTIONS(3465),
    [anon_sym_AMP] = ACTIONS(3463),
    [anon_sym_SEMI] = ACTIONS(3465),
    [anon_sym___extension__] = ACTIONS(3463),
    [anon_sym_typedef] = ACTIONS(3463),
    [anon_sym_in] = ACTIONS(3463),
    [anon_sym_out] = ACTIONS(3463),
    [anon_sym_inout] = ACTIONS(3463),
    [anon_sym_extern] = ACTIONS(3463),
    [anon_sym___attribute__] = ACTIONS(3463),
    [anon_sym_COLON_COLON] = ACTIONS(3465),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3465),
    [anon_sym___declspec] = ACTIONS(3463),
    [anon_sym___based] = ACTIONS(3463),
    [anon_sym___cdecl] = ACTIONS(3463),
    [anon_sym___clrcall] = ACTIONS(3463),
    [anon_sym___stdcall] = ACTIONS(3463),
    [anon_sym___fastcall] = ACTIONS(3463),
    [anon_sym___thiscall] = ACTIONS(3463),
    [anon_sym___vectorcall] = ACTIONS(3463),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_signed] = ACTIONS(3463),
    [anon_sym_unsigned] = ACTIONS(3463),
    [anon_sym_long] = ACTIONS(3463),
    [anon_sym_short] = ACTIONS(3463),
    [anon_sym_LBRACK] = ACTIONS(3463),
    [anon_sym_static] = ACTIONS(3463),
    [anon_sym_register] = ACTIONS(3463),
    [anon_sym_inline] = ACTIONS(3463),
    [anon_sym___inline] = ACTIONS(3463),
    [anon_sym___inline__] = ACTIONS(3463),
    [anon_sym___forceinline] = ACTIONS(3463),
    [anon_sym_thread_local] = ACTIONS(3463),
    [anon_sym___thread] = ACTIONS(3463),
    [anon_sym_const] = ACTIONS(3463),
    [anon_sym_constexpr] = ACTIONS(3463),
    [anon_sym_volatile] = ACTIONS(3463),
    [anon_sym_restrict] = ACTIONS(3463),
    [anon_sym___restrict__] = ACTIONS(3463),
    [anon_sym__Atomic] = ACTIONS(3463),
    [anon_sym__Noreturn] = ACTIONS(3463),
    [anon_sym_noreturn] = ACTIONS(3463),
    [anon_sym_mutable] = ACTIONS(3463),
    [anon_sym_constinit] = ACTIONS(3463),
    [anon_sym_consteval] = ACTIONS(3463),
    [anon_sym_alignas] = ACTIONS(3463),
    [anon_sym__Alignas] = ACTIONS(3463),
    [sym_primitive_type] = ACTIONS(3463),
    [anon_sym_enum] = ACTIONS(3463),
    [anon_sym_class] = ACTIONS(3463),
    [anon_sym_struct] = ACTIONS(3463),
    [anon_sym_union] = ACTIONS(3463),
    [anon_sym_if] = ACTIONS(3463),
    [anon_sym_switch] = ACTIONS(3463),
    [anon_sym_case] = ACTIONS(3463),
    [anon_sym_default] = ACTIONS(3463),
    [anon_sym_while] = ACTIONS(3463),
    [anon_sym_do] = ACTIONS(3463),
    [anon_sym_for] = ACTIONS(3463),
    [anon_sym_return] = ACTIONS(3463),
    [anon_sym_break] = ACTIONS(3463),
    [anon_sym_continue] = ACTIONS(3463),
    [anon_sym_goto] = ACTIONS(3463),
    [anon_sym___try] = ACTIONS(3463),
    [anon_sym___leave] = ACTIONS(3463),
    [anon_sym_not] = ACTIONS(3463),
    [anon_sym_compl] = ACTIONS(3463),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(3463),
    [anon_sym___alignof__] = ACTIONS(3463),
    [anon_sym___alignof] = ACTIONS(3463),
    [anon_sym__alignof] = ACTIONS(3463),
    [anon_sym_alignof] = ACTIONS(3463),
    [anon_sym__Alignof] = ACTIONS(3463),
    [anon_sym_offsetof] = ACTIONS(3463),
    [anon_sym__Generic] = ACTIONS(3463),
    [anon_sym_asm] = ACTIONS(3463),
    [anon_sym___asm__] = ACTIONS(3463),
    [sym_number_literal] = ACTIONS(3465),
    [anon_sym_L_SQUOTE] = ACTIONS(3465),
    [anon_sym_u_SQUOTE] = ACTIONS(3465),
    [anon_sym_U_SQUOTE] = ACTIONS(3465),
    [anon_sym_u8_SQUOTE] = ACTIONS(3465),
    [anon_sym_SQUOTE] = ACTIONS(3465),
    [anon_sym_L_DQUOTE] = ACTIONS(3465),
    [anon_sym_u_DQUOTE] = ACTIONS(3465),
    [anon_sym_U_DQUOTE] = ACTIONS(3465),
    [anon_sym_u8_DQUOTE] = ACTIONS(3465),
    [anon_sym_DQUOTE] = ACTIONS(3465),
    [sym_true] = ACTIONS(3463),
    [sym_false] = ACTIONS(3463),
    [anon_sym_NULL] = ACTIONS(3463),
    [anon_sym_nullptr] = ACTIONS(3463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3463),
    [anon_sym_let] = ACTIONS(3463),
    [anon_sym_This] = ACTIONS(3463),
    [anon_sym_decltype] = ACTIONS(3463),
    [sym_virtual] = ACTIONS(3463),
    [anon_sym_explicit] = ACTIONS(3463),
    [anon_sym_typename] = ACTIONS(3463),
    [anon_sym_template] = ACTIONS(3463),
    [anon_sym_operator] = ACTIONS(3463),
    [anon_sym_try] = ACTIONS(3463),
    [anon_sym_delete] = ACTIONS(3463),
    [anon_sym_throw] = ACTIONS(3463),
    [anon_sym_namespace] = ACTIONS(3463),
    [anon_sym_using] = ACTIONS(3463),
    [anon_sym_static_assert] = ACTIONS(3463),
    [anon_sym_concept] = ACTIONS(3463),
    [anon_sym_co_return] = ACTIONS(3463),
    [anon_sym_co_yield] = ACTIONS(3463),
    [anon_sym_R_DQUOTE] = ACTIONS(3465),
    [anon_sym_LR_DQUOTE] = ACTIONS(3465),
    [anon_sym_uR_DQUOTE] = ACTIONS(3465),
    [anon_sym_UR_DQUOTE] = ACTIONS(3465),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3465),
    [anon_sym_co_await] = ACTIONS(3463),
    [anon_sym_new] = ACTIONS(3463),
    [anon_sym_requires] = ACTIONS(3463),
    [sym_this] = ACTIONS(3463),
    [anon_sym_discard] = ACTIONS(3463),
    [anon_sym_precise] = ACTIONS(3463),
    [anon_sym_shared] = ACTIONS(3463),
    [anon_sym_groupshared] = ACTIONS(3463),
    [anon_sym_uniform] = ACTIONS(3463),
    [anon_sym_row_major] = ACTIONS(3463),
    [anon_sym_column_major] = ACTIONS(3463),
    [anon_sym_globallycoherent] = ACTIONS(3463),
    [anon_sym_centroid] = ACTIONS(3463),
    [anon_sym_noperspective] = ACTIONS(3463),
    [anon_sym_nointerpolation] = ACTIONS(3463),
    [anon_sym_sample] = ACTIONS(3463),
    [anon_sym_linear] = ACTIONS(3463),
    [anon_sym_snorm] = ACTIONS(3463),
    [anon_sym_unorm] = ACTIONS(3463),
    [anon_sym_point] = ACTIONS(3463),
    [anon_sym_line] = ACTIONS(3463),
    [anon_sym_triangleadj] = ACTIONS(3463),
    [anon_sym_lineadj] = ACTIONS(3463),
    [anon_sym_triangle] = ACTIONS(3463),
    [anon_sym_cbuffer] = ACTIONS(3463),
    [anon_sym_interface] = ACTIONS(3463),
    [anon_sym_extension] = ACTIONS(3463),
  },
  [458] = {
    [sym_identifier] = ACTIONS(3467),
    [aux_sym_preproc_include_token1] = ACTIONS(3467),
    [aux_sym_preproc_def_token1] = ACTIONS(3467),
    [aux_sym_preproc_if_token1] = ACTIONS(3467),
    [aux_sym_preproc_if_token2] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3467),
    [aux_sym_preproc_else_token1] = ACTIONS(3467),
    [aux_sym_preproc_elif_token1] = ACTIONS(3467),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3467),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3467),
    [sym_preproc_directive] = ACTIONS(3467),
    [anon_sym_LPAREN2] = ACTIONS(3469),
    [anon_sym_BANG] = ACTIONS(3469),
    [anon_sym_TILDE] = ACTIONS(3469),
    [anon_sym_DASH] = ACTIONS(3467),
    [anon_sym_PLUS] = ACTIONS(3467),
    [anon_sym_STAR] = ACTIONS(3469),
    [anon_sym_AMP_AMP] = ACTIONS(3469),
    [anon_sym_AMP] = ACTIONS(3467),
    [anon_sym_SEMI] = ACTIONS(3469),
    [anon_sym___extension__] = ACTIONS(3467),
    [anon_sym_typedef] = ACTIONS(3467),
    [anon_sym_in] = ACTIONS(3467),
    [anon_sym_out] = ACTIONS(3467),
    [anon_sym_inout] = ACTIONS(3467),
    [anon_sym_extern] = ACTIONS(3467),
    [anon_sym___attribute__] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(3469),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3469),
    [anon_sym___declspec] = ACTIONS(3467),
    [anon_sym___based] = ACTIONS(3467),
    [anon_sym___cdecl] = ACTIONS(3467),
    [anon_sym___clrcall] = ACTIONS(3467),
    [anon_sym___stdcall] = ACTIONS(3467),
    [anon_sym___fastcall] = ACTIONS(3467),
    [anon_sym___thiscall] = ACTIONS(3467),
    [anon_sym___vectorcall] = ACTIONS(3467),
    [anon_sym_LBRACE] = ACTIONS(3469),
    [anon_sym_signed] = ACTIONS(3467),
    [anon_sym_unsigned] = ACTIONS(3467),
    [anon_sym_long] = ACTIONS(3467),
    [anon_sym_short] = ACTIONS(3467),
    [anon_sym_LBRACK] = ACTIONS(3467),
    [anon_sym_static] = ACTIONS(3467),
    [anon_sym_register] = ACTIONS(3467),
    [anon_sym_inline] = ACTIONS(3467),
    [anon_sym___inline] = ACTIONS(3467),
    [anon_sym___inline__] = ACTIONS(3467),
    [anon_sym___forceinline] = ACTIONS(3467),
    [anon_sym_thread_local] = ACTIONS(3467),
    [anon_sym___thread] = ACTIONS(3467),
    [anon_sym_const] = ACTIONS(3467),
    [anon_sym_constexpr] = ACTIONS(3467),
    [anon_sym_volatile] = ACTIONS(3467),
    [anon_sym_restrict] = ACTIONS(3467),
    [anon_sym___restrict__] = ACTIONS(3467),
    [anon_sym__Atomic] = ACTIONS(3467),
    [anon_sym__Noreturn] = ACTIONS(3467),
    [anon_sym_noreturn] = ACTIONS(3467),
    [anon_sym_mutable] = ACTIONS(3467),
    [anon_sym_constinit] = ACTIONS(3467),
    [anon_sym_consteval] = ACTIONS(3467),
    [anon_sym_alignas] = ACTIONS(3467),
    [anon_sym__Alignas] = ACTIONS(3467),
    [sym_primitive_type] = ACTIONS(3467),
    [anon_sym_enum] = ACTIONS(3467),
    [anon_sym_class] = ACTIONS(3467),
    [anon_sym_struct] = ACTIONS(3467),
    [anon_sym_union] = ACTIONS(3467),
    [anon_sym_if] = ACTIONS(3467),
    [anon_sym_switch] = ACTIONS(3467),
    [anon_sym_case] = ACTIONS(3467),
    [anon_sym_default] = ACTIONS(3467),
    [anon_sym_while] = ACTIONS(3467),
    [anon_sym_do] = ACTIONS(3467),
    [anon_sym_for] = ACTIONS(3467),
    [anon_sym_return] = ACTIONS(3467),
    [anon_sym_break] = ACTIONS(3467),
    [anon_sym_continue] = ACTIONS(3467),
    [anon_sym_goto] = ACTIONS(3467),
    [anon_sym___try] = ACTIONS(3467),
    [anon_sym___leave] = ACTIONS(3467),
    [anon_sym_not] = ACTIONS(3467),
    [anon_sym_compl] = ACTIONS(3467),
    [anon_sym_DASH_DASH] = ACTIONS(3469),
    [anon_sym_PLUS_PLUS] = ACTIONS(3469),
    [anon_sym_sizeof] = ACTIONS(3467),
    [anon_sym___alignof__] = ACTIONS(3467),
    [anon_sym___alignof] = ACTIONS(3467),
    [anon_sym__alignof] = ACTIONS(3467),
    [anon_sym_alignof] = ACTIONS(3467),
    [anon_sym__Alignof] = ACTIONS(3467),
    [anon_sym_offsetof] = ACTIONS(3467),
    [anon_sym__Generic] = ACTIONS(3467),
    [anon_sym_asm] = ACTIONS(3467),
    [anon_sym___asm__] = ACTIONS(3467),
    [sym_number_literal] = ACTIONS(3469),
    [anon_sym_L_SQUOTE] = ACTIONS(3469),
    [anon_sym_u_SQUOTE] = ACTIONS(3469),
    [anon_sym_U_SQUOTE] = ACTIONS(3469),
    [anon_sym_u8_SQUOTE] = ACTIONS(3469),
    [anon_sym_SQUOTE] = ACTIONS(3469),
    [anon_sym_L_DQUOTE] = ACTIONS(3469),
    [anon_sym_u_DQUOTE] = ACTIONS(3469),
    [anon_sym_U_DQUOTE] = ACTIONS(3469),
    [anon_sym_u8_DQUOTE] = ACTIONS(3469),
    [anon_sym_DQUOTE] = ACTIONS(3469),
    [sym_true] = ACTIONS(3467),
    [sym_false] = ACTIONS(3467),
    [anon_sym_NULL] = ACTIONS(3467),
    [anon_sym_nullptr] = ACTIONS(3467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3467),
    [anon_sym_let] = ACTIONS(3467),
    [anon_sym_This] = ACTIONS(3467),
    [anon_sym_decltype] = ACTIONS(3467),
    [sym_virtual] = ACTIONS(3467),
    [anon_sym_explicit] = ACTIONS(3467),
    [anon_sym_typename] = ACTIONS(3467),
    [anon_sym_template] = ACTIONS(3467),
    [anon_sym_operator] = ACTIONS(3467),
    [anon_sym_try] = ACTIONS(3467),
    [anon_sym_delete] = ACTIONS(3467),
    [anon_sym_throw] = ACTIONS(3467),
    [anon_sym_namespace] = ACTIONS(3467),
    [anon_sym_using] = ACTIONS(3467),
    [anon_sym_static_assert] = ACTIONS(3467),
    [anon_sym_concept] = ACTIONS(3467),
    [anon_sym_co_return] = ACTIONS(3467),
    [anon_sym_co_yield] = ACTIONS(3467),
    [anon_sym_R_DQUOTE] = ACTIONS(3469),
    [anon_sym_LR_DQUOTE] = ACTIONS(3469),
    [anon_sym_uR_DQUOTE] = ACTIONS(3469),
    [anon_sym_UR_DQUOTE] = ACTIONS(3469),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3469),
    [anon_sym_co_await] = ACTIONS(3467),
    [anon_sym_new] = ACTIONS(3467),
    [anon_sym_requires] = ACTIONS(3467),
    [sym_this] = ACTIONS(3467),
    [anon_sym_discard] = ACTIONS(3467),
    [anon_sym_precise] = ACTIONS(3467),
    [anon_sym_shared] = ACTIONS(3467),
    [anon_sym_groupshared] = ACTIONS(3467),
    [anon_sym_uniform] = ACTIONS(3467),
    [anon_sym_row_major] = ACTIONS(3467),
    [anon_sym_column_major] = ACTIONS(3467),
    [anon_sym_globallycoherent] = ACTIONS(3467),
    [anon_sym_centroid] = ACTIONS(3467),
    [anon_sym_noperspective] = ACTIONS(3467),
    [anon_sym_nointerpolation] = ACTIONS(3467),
    [anon_sym_sample] = ACTIONS(3467),
    [anon_sym_linear] = ACTIONS(3467),
    [anon_sym_snorm] = ACTIONS(3467),
    [anon_sym_unorm] = ACTIONS(3467),
    [anon_sym_point] = ACTIONS(3467),
    [anon_sym_line] = ACTIONS(3467),
    [anon_sym_triangleadj] = ACTIONS(3467),
    [anon_sym_lineadj] = ACTIONS(3467),
    [anon_sym_triangle] = ACTIONS(3467),
    [anon_sym_cbuffer] = ACTIONS(3467),
    [anon_sym_interface] = ACTIONS(3467),
    [anon_sym_extension] = ACTIONS(3467),
  },
  [459] = {
    [sym_identifier] = ACTIONS(3471),
    [aux_sym_preproc_include_token1] = ACTIONS(3471),
    [aux_sym_preproc_def_token1] = ACTIONS(3471),
    [aux_sym_preproc_if_token1] = ACTIONS(3471),
    [aux_sym_preproc_if_token2] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3471),
    [aux_sym_preproc_else_token1] = ACTIONS(3471),
    [aux_sym_preproc_elif_token1] = ACTIONS(3471),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3471),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3471),
    [sym_preproc_directive] = ACTIONS(3471),
    [anon_sym_LPAREN2] = ACTIONS(3473),
    [anon_sym_BANG] = ACTIONS(3473),
    [anon_sym_TILDE] = ACTIONS(3473),
    [anon_sym_DASH] = ACTIONS(3471),
    [anon_sym_PLUS] = ACTIONS(3471),
    [anon_sym_STAR] = ACTIONS(3473),
    [anon_sym_AMP_AMP] = ACTIONS(3473),
    [anon_sym_AMP] = ACTIONS(3471),
    [anon_sym_SEMI] = ACTIONS(3473),
    [anon_sym___extension__] = ACTIONS(3471),
    [anon_sym_typedef] = ACTIONS(3471),
    [anon_sym_in] = ACTIONS(3471),
    [anon_sym_out] = ACTIONS(3471),
    [anon_sym_inout] = ACTIONS(3471),
    [anon_sym_extern] = ACTIONS(3471),
    [anon_sym___attribute__] = ACTIONS(3471),
    [anon_sym_COLON_COLON] = ACTIONS(3473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3473),
    [anon_sym___declspec] = ACTIONS(3471),
    [anon_sym___based] = ACTIONS(3471),
    [anon_sym___cdecl] = ACTIONS(3471),
    [anon_sym___clrcall] = ACTIONS(3471),
    [anon_sym___stdcall] = ACTIONS(3471),
    [anon_sym___fastcall] = ACTIONS(3471),
    [anon_sym___thiscall] = ACTIONS(3471),
    [anon_sym___vectorcall] = ACTIONS(3471),
    [anon_sym_LBRACE] = ACTIONS(3473),
    [anon_sym_signed] = ACTIONS(3471),
    [anon_sym_unsigned] = ACTIONS(3471),
    [anon_sym_long] = ACTIONS(3471),
    [anon_sym_short] = ACTIONS(3471),
    [anon_sym_LBRACK] = ACTIONS(3471),
    [anon_sym_static] = ACTIONS(3471),
    [anon_sym_register] = ACTIONS(3471),
    [anon_sym_inline] = ACTIONS(3471),
    [anon_sym___inline] = ACTIONS(3471),
    [anon_sym___inline__] = ACTIONS(3471),
    [anon_sym___forceinline] = ACTIONS(3471),
    [anon_sym_thread_local] = ACTIONS(3471),
    [anon_sym___thread] = ACTIONS(3471),
    [anon_sym_const] = ACTIONS(3471),
    [anon_sym_constexpr] = ACTIONS(3471),
    [anon_sym_volatile] = ACTIONS(3471),
    [anon_sym_restrict] = ACTIONS(3471),
    [anon_sym___restrict__] = ACTIONS(3471),
    [anon_sym__Atomic] = ACTIONS(3471),
    [anon_sym__Noreturn] = ACTIONS(3471),
    [anon_sym_noreturn] = ACTIONS(3471),
    [anon_sym_mutable] = ACTIONS(3471),
    [anon_sym_constinit] = ACTIONS(3471),
    [anon_sym_consteval] = ACTIONS(3471),
    [anon_sym_alignas] = ACTIONS(3471),
    [anon_sym__Alignas] = ACTIONS(3471),
    [sym_primitive_type] = ACTIONS(3471),
    [anon_sym_enum] = ACTIONS(3471),
    [anon_sym_class] = ACTIONS(3471),
    [anon_sym_struct] = ACTIONS(3471),
    [anon_sym_union] = ACTIONS(3471),
    [anon_sym_if] = ACTIONS(3471),
    [anon_sym_switch] = ACTIONS(3471),
    [anon_sym_case] = ACTIONS(3471),
    [anon_sym_default] = ACTIONS(3471),
    [anon_sym_while] = ACTIONS(3471),
    [anon_sym_do] = ACTIONS(3471),
    [anon_sym_for] = ACTIONS(3471),
    [anon_sym_return] = ACTIONS(3471),
    [anon_sym_break] = ACTIONS(3471),
    [anon_sym_continue] = ACTIONS(3471),
    [anon_sym_goto] = ACTIONS(3471),
    [anon_sym___try] = ACTIONS(3471),
    [anon_sym___leave] = ACTIONS(3471),
    [anon_sym_not] = ACTIONS(3471),
    [anon_sym_compl] = ACTIONS(3471),
    [anon_sym_DASH_DASH] = ACTIONS(3473),
    [anon_sym_PLUS_PLUS] = ACTIONS(3473),
    [anon_sym_sizeof] = ACTIONS(3471),
    [anon_sym___alignof__] = ACTIONS(3471),
    [anon_sym___alignof] = ACTIONS(3471),
    [anon_sym__alignof] = ACTIONS(3471),
    [anon_sym_alignof] = ACTIONS(3471),
    [anon_sym__Alignof] = ACTIONS(3471),
    [anon_sym_offsetof] = ACTIONS(3471),
    [anon_sym__Generic] = ACTIONS(3471),
    [anon_sym_asm] = ACTIONS(3471),
    [anon_sym___asm__] = ACTIONS(3471),
    [sym_number_literal] = ACTIONS(3473),
    [anon_sym_L_SQUOTE] = ACTIONS(3473),
    [anon_sym_u_SQUOTE] = ACTIONS(3473),
    [anon_sym_U_SQUOTE] = ACTIONS(3473),
    [anon_sym_u8_SQUOTE] = ACTIONS(3473),
    [anon_sym_SQUOTE] = ACTIONS(3473),
    [anon_sym_L_DQUOTE] = ACTIONS(3473),
    [anon_sym_u_DQUOTE] = ACTIONS(3473),
    [anon_sym_U_DQUOTE] = ACTIONS(3473),
    [anon_sym_u8_DQUOTE] = ACTIONS(3473),
    [anon_sym_DQUOTE] = ACTIONS(3473),
    [sym_true] = ACTIONS(3471),
    [sym_false] = ACTIONS(3471),
    [anon_sym_NULL] = ACTIONS(3471),
    [anon_sym_nullptr] = ACTIONS(3471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3471),
    [anon_sym_let] = ACTIONS(3471),
    [anon_sym_This] = ACTIONS(3471),
    [anon_sym_decltype] = ACTIONS(3471),
    [sym_virtual] = ACTIONS(3471),
    [anon_sym_explicit] = ACTIONS(3471),
    [anon_sym_typename] = ACTIONS(3471),
    [anon_sym_template] = ACTIONS(3471),
    [anon_sym_operator] = ACTIONS(3471),
    [anon_sym_try] = ACTIONS(3471),
    [anon_sym_delete] = ACTIONS(3471),
    [anon_sym_throw] = ACTIONS(3471),
    [anon_sym_namespace] = ACTIONS(3471),
    [anon_sym_using] = ACTIONS(3471),
    [anon_sym_static_assert] = ACTIONS(3471),
    [anon_sym_concept] = ACTIONS(3471),
    [anon_sym_co_return] = ACTIONS(3471),
    [anon_sym_co_yield] = ACTIONS(3471),
    [anon_sym_R_DQUOTE] = ACTIONS(3473),
    [anon_sym_LR_DQUOTE] = ACTIONS(3473),
    [anon_sym_uR_DQUOTE] = ACTIONS(3473),
    [anon_sym_UR_DQUOTE] = ACTIONS(3473),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3473),
    [anon_sym_co_await] = ACTIONS(3471),
    [anon_sym_new] = ACTIONS(3471),
    [anon_sym_requires] = ACTIONS(3471),
    [sym_this] = ACTIONS(3471),
    [anon_sym_discard] = ACTIONS(3471),
    [anon_sym_precise] = ACTIONS(3471),
    [anon_sym_shared] = ACTIONS(3471),
    [anon_sym_groupshared] = ACTIONS(3471),
    [anon_sym_uniform] = ACTIONS(3471),
    [anon_sym_row_major] = ACTIONS(3471),
    [anon_sym_column_major] = ACTIONS(3471),
    [anon_sym_globallycoherent] = ACTIONS(3471),
    [anon_sym_centroid] = ACTIONS(3471),
    [anon_sym_noperspective] = ACTIONS(3471),
    [anon_sym_nointerpolation] = ACTIONS(3471),
    [anon_sym_sample] = ACTIONS(3471),
    [anon_sym_linear] = ACTIONS(3471),
    [anon_sym_snorm] = ACTIONS(3471),
    [anon_sym_unorm] = ACTIONS(3471),
    [anon_sym_point] = ACTIONS(3471),
    [anon_sym_line] = ACTIONS(3471),
    [anon_sym_triangleadj] = ACTIONS(3471),
    [anon_sym_lineadj] = ACTIONS(3471),
    [anon_sym_triangle] = ACTIONS(3471),
    [anon_sym_cbuffer] = ACTIONS(3471),
    [anon_sym_interface] = ACTIONS(3471),
    [anon_sym_extension] = ACTIONS(3471),
  },
  [460] = {
    [sym_identifier] = ACTIONS(2363),
    [aux_sym_preproc_include_token1] = ACTIONS(2363),
    [aux_sym_preproc_def_token1] = ACTIONS(2363),
    [aux_sym_preproc_if_token1] = ACTIONS(2363),
    [aux_sym_preproc_if_token2] = ACTIONS(2363),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2363),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2363),
    [sym_preproc_directive] = ACTIONS(2363),
    [anon_sym_LPAREN2] = ACTIONS(2361),
    [anon_sym_BANG] = ACTIONS(2361),
    [anon_sym_TILDE] = ACTIONS(2361),
    [anon_sym_DASH] = ACTIONS(2363),
    [anon_sym_PLUS] = ACTIONS(2363),
    [anon_sym_STAR] = ACTIONS(2361),
    [anon_sym_AMP_AMP] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(2363),
    [anon_sym_COLON] = ACTIONS(2363),
    [anon_sym_SEMI] = ACTIONS(2361),
    [anon_sym___extension__] = ACTIONS(2363),
    [anon_sym_typedef] = ACTIONS(2363),
    [anon_sym_in] = ACTIONS(2363),
    [anon_sym_out] = ACTIONS(2363),
    [anon_sym_inout] = ACTIONS(2363),
    [anon_sym_extern] = ACTIONS(2363),
    [anon_sym___attribute__] = ACTIONS(2363),
    [anon_sym_COLON_COLON] = ACTIONS(2361),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2361),
    [anon_sym___declspec] = ACTIONS(2363),
    [anon_sym___based] = ACTIONS(2363),
    [anon_sym___cdecl] = ACTIONS(2363),
    [anon_sym___clrcall] = ACTIONS(2363),
    [anon_sym___stdcall] = ACTIONS(2363),
    [anon_sym___fastcall] = ACTIONS(2363),
    [anon_sym___thiscall] = ACTIONS(2363),
    [anon_sym___vectorcall] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_signed] = ACTIONS(2363),
    [anon_sym_unsigned] = ACTIONS(2363),
    [anon_sym_long] = ACTIONS(2363),
    [anon_sym_short] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(2363),
    [anon_sym_static] = ACTIONS(2363),
    [anon_sym_register] = ACTIONS(2363),
    [anon_sym_inline] = ACTIONS(2363),
    [anon_sym___inline] = ACTIONS(2363),
    [anon_sym___inline__] = ACTIONS(2363),
    [anon_sym___forceinline] = ACTIONS(2363),
    [anon_sym_thread_local] = ACTIONS(2363),
    [anon_sym___thread] = ACTIONS(2363),
    [anon_sym_const] = ACTIONS(2363),
    [anon_sym_constexpr] = ACTIONS(2363),
    [anon_sym_volatile] = ACTIONS(2363),
    [anon_sym_restrict] = ACTIONS(2363),
    [anon_sym___restrict__] = ACTIONS(2363),
    [anon_sym__Atomic] = ACTIONS(2363),
    [anon_sym__Noreturn] = ACTIONS(2363),
    [anon_sym_noreturn] = ACTIONS(2363),
    [anon_sym_mutable] = ACTIONS(2363),
    [anon_sym_constinit] = ACTIONS(2363),
    [anon_sym_consteval] = ACTIONS(2363),
    [anon_sym_alignas] = ACTIONS(2363),
    [anon_sym__Alignas] = ACTIONS(2363),
    [sym_primitive_type] = ACTIONS(2363),
    [anon_sym_enum] = ACTIONS(2363),
    [anon_sym_class] = ACTIONS(2363),
    [anon_sym_struct] = ACTIONS(2363),
    [anon_sym_union] = ACTIONS(2363),
    [anon_sym_if] = ACTIONS(2363),
    [anon_sym_else] = ACTIONS(2363),
    [anon_sym_switch] = ACTIONS(2363),
    [anon_sym_case] = ACTIONS(2363),
    [anon_sym_default] = ACTIONS(2363),
    [anon_sym_while] = ACTIONS(2363),
    [anon_sym_do] = ACTIONS(2363),
    [anon_sym_for] = ACTIONS(2363),
    [anon_sym_return] = ACTIONS(2363),
    [anon_sym_break] = ACTIONS(2363),
    [anon_sym_continue] = ACTIONS(2363),
    [anon_sym_goto] = ACTIONS(2363),
    [anon_sym___try] = ACTIONS(2363),
    [anon_sym___leave] = ACTIONS(2363),
    [anon_sym_not] = ACTIONS(2363),
    [anon_sym_compl] = ACTIONS(2363),
    [anon_sym_DASH_DASH] = ACTIONS(2361),
    [anon_sym_PLUS_PLUS] = ACTIONS(2361),
    [anon_sym_sizeof] = ACTIONS(2363),
    [anon_sym___alignof__] = ACTIONS(2363),
    [anon_sym___alignof] = ACTIONS(2363),
    [anon_sym__alignof] = ACTIONS(2363),
    [anon_sym_alignof] = ACTIONS(2363),
    [anon_sym__Alignof] = ACTIONS(2363),
    [anon_sym_offsetof] = ACTIONS(2363),
    [anon_sym__Generic] = ACTIONS(2363),
    [anon_sym_asm] = ACTIONS(2363),
    [anon_sym___asm__] = ACTIONS(2363),
    [sym_number_literal] = ACTIONS(2361),
    [anon_sym_L_SQUOTE] = ACTIONS(2361),
    [anon_sym_u_SQUOTE] = ACTIONS(2361),
    [anon_sym_U_SQUOTE] = ACTIONS(2361),
    [anon_sym_u8_SQUOTE] = ACTIONS(2361),
    [anon_sym_SQUOTE] = ACTIONS(2361),
    [anon_sym_L_DQUOTE] = ACTIONS(2361),
    [anon_sym_u_DQUOTE] = ACTIONS(2361),
    [anon_sym_U_DQUOTE] = ACTIONS(2361),
    [anon_sym_u8_DQUOTE] = ACTIONS(2361),
    [anon_sym_DQUOTE] = ACTIONS(2361),
    [sym_true] = ACTIONS(2363),
    [sym_false] = ACTIONS(2363),
    [anon_sym_NULL] = ACTIONS(2363),
    [anon_sym_nullptr] = ACTIONS(2363),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2363),
    [anon_sym_let] = ACTIONS(2363),
    [anon_sym_This] = ACTIONS(2363),
    [anon_sym_decltype] = ACTIONS(2363),
    [anon_sym_final] = ACTIONS(2363),
    [anon_sym_override] = ACTIONS(2363),
    [sym_virtual] = ACTIONS(2363),
    [anon_sym_explicit] = ACTIONS(2363),
    [anon_sym_typename] = ACTIONS(2363),
    [anon_sym_template] = ACTIONS(2363),
    [anon_sym_operator] = ACTIONS(2363),
    [anon_sym_try] = ACTIONS(2363),
    [anon_sym_delete] = ACTIONS(2363),
    [anon_sym_throw] = ACTIONS(2363),
    [anon_sym_namespace] = ACTIONS(2363),
    [anon_sym_using] = ACTIONS(2363),
    [anon_sym_static_assert] = ACTIONS(2363),
    [anon_sym_concept] = ACTIONS(2363),
    [anon_sym_co_return] = ACTIONS(2363),
    [anon_sym_co_yield] = ACTIONS(2363),
    [anon_sym_R_DQUOTE] = ACTIONS(2361),
    [anon_sym_LR_DQUOTE] = ACTIONS(2361),
    [anon_sym_uR_DQUOTE] = ACTIONS(2361),
    [anon_sym_UR_DQUOTE] = ACTIONS(2361),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2361),
    [anon_sym_co_await] = ACTIONS(2363),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_requires] = ACTIONS(2363),
    [sym_this] = ACTIONS(2363),
    [anon_sym_discard] = ACTIONS(2363),
    [anon_sym_precise] = ACTIONS(2363),
    [anon_sym_shared] = ACTIONS(2363),
    [anon_sym_groupshared] = ACTIONS(2363),
    [anon_sym_uniform] = ACTIONS(2363),
    [anon_sym_row_major] = ACTIONS(2363),
    [anon_sym_column_major] = ACTIONS(2363),
    [anon_sym_globallycoherent] = ACTIONS(2363),
    [anon_sym_centroid] = ACTIONS(2363),
    [anon_sym_noperspective] = ACTIONS(2363),
    [anon_sym_nointerpolation] = ACTIONS(2363),
    [anon_sym_sample] = ACTIONS(2363),
    [anon_sym_linear] = ACTIONS(2363),
    [anon_sym_snorm] = ACTIONS(2363),
    [anon_sym_unorm] = ACTIONS(2363),
    [anon_sym_point] = ACTIONS(2363),
    [anon_sym_line] = ACTIONS(2363),
    [anon_sym_triangleadj] = ACTIONS(2363),
    [anon_sym_lineadj] = ACTIONS(2363),
    [anon_sym_triangle] = ACTIONS(2363),
    [anon_sym_cbuffer] = ACTIONS(2363),
    [anon_sym_interface] = ACTIONS(2363),
    [anon_sym_extension] = ACTIONS(2363),
  },
  [461] = {
    [sym_identifier] = ACTIONS(3475),
    [aux_sym_preproc_include_token1] = ACTIONS(3475),
    [aux_sym_preproc_def_token1] = ACTIONS(3475),
    [aux_sym_preproc_if_token1] = ACTIONS(3475),
    [aux_sym_preproc_if_token2] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3475),
    [aux_sym_preproc_else_token1] = ACTIONS(3475),
    [aux_sym_preproc_elif_token1] = ACTIONS(3475),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3475),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3475),
    [sym_preproc_directive] = ACTIONS(3475),
    [anon_sym_LPAREN2] = ACTIONS(3477),
    [anon_sym_BANG] = ACTIONS(3477),
    [anon_sym_TILDE] = ACTIONS(3477),
    [anon_sym_DASH] = ACTIONS(3475),
    [anon_sym_PLUS] = ACTIONS(3475),
    [anon_sym_STAR] = ACTIONS(3477),
    [anon_sym_AMP_AMP] = ACTIONS(3477),
    [anon_sym_AMP] = ACTIONS(3475),
    [anon_sym_SEMI] = ACTIONS(3477),
    [anon_sym___extension__] = ACTIONS(3475),
    [anon_sym_typedef] = ACTIONS(3475),
    [anon_sym_in] = ACTIONS(3475),
    [anon_sym_out] = ACTIONS(3475),
    [anon_sym_inout] = ACTIONS(3475),
    [anon_sym_extern] = ACTIONS(3475),
    [anon_sym___attribute__] = ACTIONS(3475),
    [anon_sym_COLON_COLON] = ACTIONS(3477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3477),
    [anon_sym___declspec] = ACTIONS(3475),
    [anon_sym___based] = ACTIONS(3475),
    [anon_sym___cdecl] = ACTIONS(3475),
    [anon_sym___clrcall] = ACTIONS(3475),
    [anon_sym___stdcall] = ACTIONS(3475),
    [anon_sym___fastcall] = ACTIONS(3475),
    [anon_sym___thiscall] = ACTIONS(3475),
    [anon_sym___vectorcall] = ACTIONS(3475),
    [anon_sym_LBRACE] = ACTIONS(3477),
    [anon_sym_signed] = ACTIONS(3475),
    [anon_sym_unsigned] = ACTIONS(3475),
    [anon_sym_long] = ACTIONS(3475),
    [anon_sym_short] = ACTIONS(3475),
    [anon_sym_LBRACK] = ACTIONS(3475),
    [anon_sym_static] = ACTIONS(3475),
    [anon_sym_register] = ACTIONS(3475),
    [anon_sym_inline] = ACTIONS(3475),
    [anon_sym___inline] = ACTIONS(3475),
    [anon_sym___inline__] = ACTIONS(3475),
    [anon_sym___forceinline] = ACTIONS(3475),
    [anon_sym_thread_local] = ACTIONS(3475),
    [anon_sym___thread] = ACTIONS(3475),
    [anon_sym_const] = ACTIONS(3475),
    [anon_sym_constexpr] = ACTIONS(3475),
    [anon_sym_volatile] = ACTIONS(3475),
    [anon_sym_restrict] = ACTIONS(3475),
    [anon_sym___restrict__] = ACTIONS(3475),
    [anon_sym__Atomic] = ACTIONS(3475),
    [anon_sym__Noreturn] = ACTIONS(3475),
    [anon_sym_noreturn] = ACTIONS(3475),
    [anon_sym_mutable] = ACTIONS(3475),
    [anon_sym_constinit] = ACTIONS(3475),
    [anon_sym_consteval] = ACTIONS(3475),
    [anon_sym_alignas] = ACTIONS(3475),
    [anon_sym__Alignas] = ACTIONS(3475),
    [sym_primitive_type] = ACTIONS(3475),
    [anon_sym_enum] = ACTIONS(3475),
    [anon_sym_class] = ACTIONS(3475),
    [anon_sym_struct] = ACTIONS(3475),
    [anon_sym_union] = ACTIONS(3475),
    [anon_sym_if] = ACTIONS(3475),
    [anon_sym_switch] = ACTIONS(3475),
    [anon_sym_case] = ACTIONS(3475),
    [anon_sym_default] = ACTIONS(3475),
    [anon_sym_while] = ACTIONS(3475),
    [anon_sym_do] = ACTIONS(3475),
    [anon_sym_for] = ACTIONS(3475),
    [anon_sym_return] = ACTIONS(3475),
    [anon_sym_break] = ACTIONS(3475),
    [anon_sym_continue] = ACTIONS(3475),
    [anon_sym_goto] = ACTIONS(3475),
    [anon_sym___try] = ACTIONS(3475),
    [anon_sym___leave] = ACTIONS(3475),
    [anon_sym_not] = ACTIONS(3475),
    [anon_sym_compl] = ACTIONS(3475),
    [anon_sym_DASH_DASH] = ACTIONS(3477),
    [anon_sym_PLUS_PLUS] = ACTIONS(3477),
    [anon_sym_sizeof] = ACTIONS(3475),
    [anon_sym___alignof__] = ACTIONS(3475),
    [anon_sym___alignof] = ACTIONS(3475),
    [anon_sym__alignof] = ACTIONS(3475),
    [anon_sym_alignof] = ACTIONS(3475),
    [anon_sym__Alignof] = ACTIONS(3475),
    [anon_sym_offsetof] = ACTIONS(3475),
    [anon_sym__Generic] = ACTIONS(3475),
    [anon_sym_asm] = ACTIONS(3475),
    [anon_sym___asm__] = ACTIONS(3475),
    [sym_number_literal] = ACTIONS(3477),
    [anon_sym_L_SQUOTE] = ACTIONS(3477),
    [anon_sym_u_SQUOTE] = ACTIONS(3477),
    [anon_sym_U_SQUOTE] = ACTIONS(3477),
    [anon_sym_u8_SQUOTE] = ACTIONS(3477),
    [anon_sym_SQUOTE] = ACTIONS(3477),
    [anon_sym_L_DQUOTE] = ACTIONS(3477),
    [anon_sym_u_DQUOTE] = ACTIONS(3477),
    [anon_sym_U_DQUOTE] = ACTIONS(3477),
    [anon_sym_u8_DQUOTE] = ACTIONS(3477),
    [anon_sym_DQUOTE] = ACTIONS(3477),
    [sym_true] = ACTIONS(3475),
    [sym_false] = ACTIONS(3475),
    [anon_sym_NULL] = ACTIONS(3475),
    [anon_sym_nullptr] = ACTIONS(3475),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3475),
    [anon_sym_let] = ACTIONS(3475),
    [anon_sym_This] = ACTIONS(3475),
    [anon_sym_decltype] = ACTIONS(3475),
    [sym_virtual] = ACTIONS(3475),
    [anon_sym_explicit] = ACTIONS(3475),
    [anon_sym_typename] = ACTIONS(3475),
    [anon_sym_template] = ACTIONS(3475),
    [anon_sym_operator] = ACTIONS(3475),
    [anon_sym_try] = ACTIONS(3475),
    [anon_sym_delete] = ACTIONS(3475),
    [anon_sym_throw] = ACTIONS(3475),
    [anon_sym_namespace] = ACTIONS(3475),
    [anon_sym_using] = ACTIONS(3475),
    [anon_sym_static_assert] = ACTIONS(3475),
    [anon_sym_concept] = ACTIONS(3475),
    [anon_sym_co_return] = ACTIONS(3475),
    [anon_sym_co_yield] = ACTIONS(3475),
    [anon_sym_R_DQUOTE] = ACTIONS(3477),
    [anon_sym_LR_DQUOTE] = ACTIONS(3477),
    [anon_sym_uR_DQUOTE] = ACTIONS(3477),
    [anon_sym_UR_DQUOTE] = ACTIONS(3477),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3477),
    [anon_sym_co_await] = ACTIONS(3475),
    [anon_sym_new] = ACTIONS(3475),
    [anon_sym_requires] = ACTIONS(3475),
    [sym_this] = ACTIONS(3475),
    [anon_sym_discard] = ACTIONS(3475),
    [anon_sym_precise] = ACTIONS(3475),
    [anon_sym_shared] = ACTIONS(3475),
    [anon_sym_groupshared] = ACTIONS(3475),
    [anon_sym_uniform] = ACTIONS(3475),
    [anon_sym_row_major] = ACTIONS(3475),
    [anon_sym_column_major] = ACTIONS(3475),
    [anon_sym_globallycoherent] = ACTIONS(3475),
    [anon_sym_centroid] = ACTIONS(3475),
    [anon_sym_noperspective] = ACTIONS(3475),
    [anon_sym_nointerpolation] = ACTIONS(3475),
    [anon_sym_sample] = ACTIONS(3475),
    [anon_sym_linear] = ACTIONS(3475),
    [anon_sym_snorm] = ACTIONS(3475),
    [anon_sym_unorm] = ACTIONS(3475),
    [anon_sym_point] = ACTIONS(3475),
    [anon_sym_line] = ACTIONS(3475),
    [anon_sym_triangleadj] = ACTIONS(3475),
    [anon_sym_lineadj] = ACTIONS(3475),
    [anon_sym_triangle] = ACTIONS(3475),
    [anon_sym_cbuffer] = ACTIONS(3475),
    [anon_sym_interface] = ACTIONS(3475),
    [anon_sym_extension] = ACTIONS(3475),
  },
  [462] = {
    [sym_identifier] = ACTIONS(3479),
    [aux_sym_preproc_include_token1] = ACTIONS(3479),
    [aux_sym_preproc_def_token1] = ACTIONS(3479),
    [aux_sym_preproc_if_token1] = ACTIONS(3479),
    [aux_sym_preproc_if_token2] = ACTIONS(3479),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3479),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3479),
    [aux_sym_preproc_else_token1] = ACTIONS(3479),
    [aux_sym_preproc_elif_token1] = ACTIONS(3479),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3479),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3479),
    [sym_preproc_directive] = ACTIONS(3479),
    [anon_sym_LPAREN2] = ACTIONS(3481),
    [anon_sym_BANG] = ACTIONS(3481),
    [anon_sym_TILDE] = ACTIONS(3481),
    [anon_sym_DASH] = ACTIONS(3479),
    [anon_sym_PLUS] = ACTIONS(3479),
    [anon_sym_STAR] = ACTIONS(3481),
    [anon_sym_AMP_AMP] = ACTIONS(3481),
    [anon_sym_AMP] = ACTIONS(3479),
    [anon_sym_SEMI] = ACTIONS(3481),
    [anon_sym___extension__] = ACTIONS(3479),
    [anon_sym_typedef] = ACTIONS(3479),
    [anon_sym_in] = ACTIONS(3479),
    [anon_sym_out] = ACTIONS(3479),
    [anon_sym_inout] = ACTIONS(3479),
    [anon_sym_extern] = ACTIONS(3479),
    [anon_sym___attribute__] = ACTIONS(3479),
    [anon_sym_COLON_COLON] = ACTIONS(3481),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3481),
    [anon_sym___declspec] = ACTIONS(3479),
    [anon_sym___based] = ACTIONS(3479),
    [anon_sym___cdecl] = ACTIONS(3479),
    [anon_sym___clrcall] = ACTIONS(3479),
    [anon_sym___stdcall] = ACTIONS(3479),
    [anon_sym___fastcall] = ACTIONS(3479),
    [anon_sym___thiscall] = ACTIONS(3479),
    [anon_sym___vectorcall] = ACTIONS(3479),
    [anon_sym_LBRACE] = ACTIONS(3481),
    [anon_sym_signed] = ACTIONS(3479),
    [anon_sym_unsigned] = ACTIONS(3479),
    [anon_sym_long] = ACTIONS(3479),
    [anon_sym_short] = ACTIONS(3479),
    [anon_sym_LBRACK] = ACTIONS(3479),
    [anon_sym_static] = ACTIONS(3479),
    [anon_sym_register] = ACTIONS(3479),
    [anon_sym_inline] = ACTIONS(3479),
    [anon_sym___inline] = ACTIONS(3479),
    [anon_sym___inline__] = ACTIONS(3479),
    [anon_sym___forceinline] = ACTIONS(3479),
    [anon_sym_thread_local] = ACTIONS(3479),
    [anon_sym___thread] = ACTIONS(3479),
    [anon_sym_const] = ACTIONS(3479),
    [anon_sym_constexpr] = ACTIONS(3479),
    [anon_sym_volatile] = ACTIONS(3479),
    [anon_sym_restrict] = ACTIONS(3479),
    [anon_sym___restrict__] = ACTIONS(3479),
    [anon_sym__Atomic] = ACTIONS(3479),
    [anon_sym__Noreturn] = ACTIONS(3479),
    [anon_sym_noreturn] = ACTIONS(3479),
    [anon_sym_mutable] = ACTIONS(3479),
    [anon_sym_constinit] = ACTIONS(3479),
    [anon_sym_consteval] = ACTIONS(3479),
    [anon_sym_alignas] = ACTIONS(3479),
    [anon_sym__Alignas] = ACTIONS(3479),
    [sym_primitive_type] = ACTIONS(3479),
    [anon_sym_enum] = ACTIONS(3479),
    [anon_sym_class] = ACTIONS(3479),
    [anon_sym_struct] = ACTIONS(3479),
    [anon_sym_union] = ACTIONS(3479),
    [anon_sym_if] = ACTIONS(3479),
    [anon_sym_switch] = ACTIONS(3479),
    [anon_sym_case] = ACTIONS(3479),
    [anon_sym_default] = ACTIONS(3479),
    [anon_sym_while] = ACTIONS(3479),
    [anon_sym_do] = ACTIONS(3479),
    [anon_sym_for] = ACTIONS(3479),
    [anon_sym_return] = ACTIONS(3479),
    [anon_sym_break] = ACTIONS(3479),
    [anon_sym_continue] = ACTIONS(3479),
    [anon_sym_goto] = ACTIONS(3479),
    [anon_sym___try] = ACTIONS(3479),
    [anon_sym___leave] = ACTIONS(3479),
    [anon_sym_not] = ACTIONS(3479),
    [anon_sym_compl] = ACTIONS(3479),
    [anon_sym_DASH_DASH] = ACTIONS(3481),
    [anon_sym_PLUS_PLUS] = ACTIONS(3481),
    [anon_sym_sizeof] = ACTIONS(3479),
    [anon_sym___alignof__] = ACTIONS(3479),
    [anon_sym___alignof] = ACTIONS(3479),
    [anon_sym__alignof] = ACTIONS(3479),
    [anon_sym_alignof] = ACTIONS(3479),
    [anon_sym__Alignof] = ACTIONS(3479),
    [anon_sym_offsetof] = ACTIONS(3479),
    [anon_sym__Generic] = ACTIONS(3479),
    [anon_sym_asm] = ACTIONS(3479),
    [anon_sym___asm__] = ACTIONS(3479),
    [sym_number_literal] = ACTIONS(3481),
    [anon_sym_L_SQUOTE] = ACTIONS(3481),
    [anon_sym_u_SQUOTE] = ACTIONS(3481),
    [anon_sym_U_SQUOTE] = ACTIONS(3481),
    [anon_sym_u8_SQUOTE] = ACTIONS(3481),
    [anon_sym_SQUOTE] = ACTIONS(3481),
    [anon_sym_L_DQUOTE] = ACTIONS(3481),
    [anon_sym_u_DQUOTE] = ACTIONS(3481),
    [anon_sym_U_DQUOTE] = ACTIONS(3481),
    [anon_sym_u8_DQUOTE] = ACTIONS(3481),
    [anon_sym_DQUOTE] = ACTIONS(3481),
    [sym_true] = ACTIONS(3479),
    [sym_false] = ACTIONS(3479),
    [anon_sym_NULL] = ACTIONS(3479),
    [anon_sym_nullptr] = ACTIONS(3479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3479),
    [anon_sym_let] = ACTIONS(3479),
    [anon_sym_This] = ACTIONS(3479),
    [anon_sym_decltype] = ACTIONS(3479),
    [sym_virtual] = ACTIONS(3479),
    [anon_sym_explicit] = ACTIONS(3479),
    [anon_sym_typename] = ACTIONS(3479),
    [anon_sym_template] = ACTIONS(3479),
    [anon_sym_operator] = ACTIONS(3479),
    [anon_sym_try] = ACTIONS(3479),
    [anon_sym_delete] = ACTIONS(3479),
    [anon_sym_throw] = ACTIONS(3479),
    [anon_sym_namespace] = ACTIONS(3479),
    [anon_sym_using] = ACTIONS(3479),
    [anon_sym_static_assert] = ACTIONS(3479),
    [anon_sym_concept] = ACTIONS(3479),
    [anon_sym_co_return] = ACTIONS(3479),
    [anon_sym_co_yield] = ACTIONS(3479),
    [anon_sym_R_DQUOTE] = ACTIONS(3481),
    [anon_sym_LR_DQUOTE] = ACTIONS(3481),
    [anon_sym_uR_DQUOTE] = ACTIONS(3481),
    [anon_sym_UR_DQUOTE] = ACTIONS(3481),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3481),
    [anon_sym_co_await] = ACTIONS(3479),
    [anon_sym_new] = ACTIONS(3479),
    [anon_sym_requires] = ACTIONS(3479),
    [sym_this] = ACTIONS(3479),
    [anon_sym_discard] = ACTIONS(3479),
    [anon_sym_precise] = ACTIONS(3479),
    [anon_sym_shared] = ACTIONS(3479),
    [anon_sym_groupshared] = ACTIONS(3479),
    [anon_sym_uniform] = ACTIONS(3479),
    [anon_sym_row_major] = ACTIONS(3479),
    [anon_sym_column_major] = ACTIONS(3479),
    [anon_sym_globallycoherent] = ACTIONS(3479),
    [anon_sym_centroid] = ACTIONS(3479),
    [anon_sym_noperspective] = ACTIONS(3479),
    [anon_sym_nointerpolation] = ACTIONS(3479),
    [anon_sym_sample] = ACTIONS(3479),
    [anon_sym_linear] = ACTIONS(3479),
    [anon_sym_snorm] = ACTIONS(3479),
    [anon_sym_unorm] = ACTIONS(3479),
    [anon_sym_point] = ACTIONS(3479),
    [anon_sym_line] = ACTIONS(3479),
    [anon_sym_triangleadj] = ACTIONS(3479),
    [anon_sym_lineadj] = ACTIONS(3479),
    [anon_sym_triangle] = ACTIONS(3479),
    [anon_sym_cbuffer] = ACTIONS(3479),
    [anon_sym_interface] = ACTIONS(3479),
    [anon_sym_extension] = ACTIONS(3479),
  },
  [463] = {
    [sym_template_argument_list] = STATE(2816),
    [aux_sym_sized_type_specifier_repeat1] = STATE(630),
    [sym_identifier] = ACTIONS(3483),
    [aux_sym_preproc_include_token1] = ACTIONS(3483),
    [aux_sym_preproc_def_token1] = ACTIONS(3483),
    [aux_sym_preproc_if_token1] = ACTIONS(3483),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3483),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3483),
    [sym_preproc_directive] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_BANG] = ACTIONS(3485),
    [anon_sym_TILDE] = ACTIONS(3485),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_STAR] = ACTIONS(3485),
    [anon_sym_AMP_AMP] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_LT] = ACTIONS(3487),
    [anon_sym_SEMI] = ACTIONS(3485),
    [anon_sym___extension__] = ACTIONS(3483),
    [anon_sym_typedef] = ACTIONS(3483),
    [anon_sym_in] = ACTIONS(3483),
    [anon_sym_out] = ACTIONS(3483),
    [anon_sym_inout] = ACTIONS(3483),
    [anon_sym_extern] = ACTIONS(3483),
    [anon_sym___attribute__] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3485),
    [anon_sym___declspec] = ACTIONS(3483),
    [anon_sym___based] = ACTIONS(3483),
    [anon_sym___cdecl] = ACTIONS(3483),
    [anon_sym___clrcall] = ACTIONS(3483),
    [anon_sym___stdcall] = ACTIONS(3483),
    [anon_sym___fastcall] = ACTIONS(3483),
    [anon_sym___thiscall] = ACTIONS(3483),
    [anon_sym___vectorcall] = ACTIONS(3483),
    [anon_sym_LBRACE] = ACTIONS(3485),
    [anon_sym_RBRACE] = ACTIONS(3485),
    [anon_sym_signed] = ACTIONS(3483),
    [anon_sym_unsigned] = ACTIONS(3483),
    [anon_sym_long] = ACTIONS(3483),
    [anon_sym_short] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_static] = ACTIONS(3483),
    [anon_sym_register] = ACTIONS(3483),
    [anon_sym_inline] = ACTIONS(3483),
    [anon_sym___inline] = ACTIONS(3483),
    [anon_sym___inline__] = ACTIONS(3483),
    [anon_sym___forceinline] = ACTIONS(3483),
    [anon_sym_thread_local] = ACTIONS(3483),
    [anon_sym___thread] = ACTIONS(3483),
    [anon_sym_const] = ACTIONS(3483),
    [anon_sym_constexpr] = ACTIONS(3483),
    [anon_sym_volatile] = ACTIONS(3483),
    [anon_sym_restrict] = ACTIONS(3483),
    [anon_sym___restrict__] = ACTIONS(3483),
    [anon_sym__Atomic] = ACTIONS(3483),
    [anon_sym__Noreturn] = ACTIONS(3483),
    [anon_sym_noreturn] = ACTIONS(3483),
    [anon_sym_mutable] = ACTIONS(3483),
    [anon_sym_constinit] = ACTIONS(3483),
    [anon_sym_consteval] = ACTIONS(3483),
    [anon_sym_alignas] = ACTIONS(3483),
    [anon_sym__Alignas] = ACTIONS(3483),
    [sym_primitive_type] = ACTIONS(3483),
    [anon_sym_enum] = ACTIONS(3483),
    [anon_sym_class] = ACTIONS(3483),
    [anon_sym_struct] = ACTIONS(3483),
    [anon_sym_union] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_switch] = ACTIONS(3483),
    [anon_sym_case] = ACTIONS(3483),
    [anon_sym_default] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_break] = ACTIONS(3483),
    [anon_sym_continue] = ACTIONS(3483),
    [anon_sym_goto] = ACTIONS(3483),
    [anon_sym___try] = ACTIONS(3483),
    [anon_sym___leave] = ACTIONS(3483),
    [anon_sym_not] = ACTIONS(3483),
    [anon_sym_compl] = ACTIONS(3483),
    [anon_sym_DASH_DASH] = ACTIONS(3485),
    [anon_sym_PLUS_PLUS] = ACTIONS(3485),
    [anon_sym_sizeof] = ACTIONS(3483),
    [anon_sym___alignof__] = ACTIONS(3483),
    [anon_sym___alignof] = ACTIONS(3483),
    [anon_sym__alignof] = ACTIONS(3483),
    [anon_sym_alignof] = ACTIONS(3483),
    [anon_sym__Alignof] = ACTIONS(3483),
    [anon_sym_offsetof] = ACTIONS(3483),
    [anon_sym__Generic] = ACTIONS(3483),
    [anon_sym_asm] = ACTIONS(3483),
    [anon_sym___asm__] = ACTIONS(3483),
    [anon_sym_DOT] = ACTIONS(3483),
    [sym_number_literal] = ACTIONS(3485),
    [anon_sym_L_SQUOTE] = ACTIONS(3485),
    [anon_sym_u_SQUOTE] = ACTIONS(3485),
    [anon_sym_U_SQUOTE] = ACTIONS(3485),
    [anon_sym_u8_SQUOTE] = ACTIONS(3485),
    [anon_sym_SQUOTE] = ACTIONS(3485),
    [anon_sym_L_DQUOTE] = ACTIONS(3485),
    [anon_sym_u_DQUOTE] = ACTIONS(3485),
    [anon_sym_U_DQUOTE] = ACTIONS(3485),
    [anon_sym_u8_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE] = ACTIONS(3485),
    [sym_true] = ACTIONS(3483),
    [sym_false] = ACTIONS(3483),
    [anon_sym_NULL] = ACTIONS(3483),
    [anon_sym_nullptr] = ACTIONS(3483),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_This] = ACTIONS(3483),
    [anon_sym_decltype] = ACTIONS(3483),
    [sym_virtual] = ACTIONS(3483),
    [anon_sym_explicit] = ACTIONS(3483),
    [anon_sym_typename] = ACTIONS(3483),
    [anon_sym_template] = ACTIONS(3483),
    [anon_sym_operator] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_delete] = ACTIONS(3483),
    [anon_sym_throw] = ACTIONS(3483),
    [anon_sym_namespace] = ACTIONS(3483),
    [anon_sym_using] = ACTIONS(3483),
    [anon_sym_static_assert] = ACTIONS(3483),
    [anon_sym_concept] = ACTIONS(3483),
    [anon_sym_co_return] = ACTIONS(3483),
    [anon_sym_co_yield] = ACTIONS(3483),
    [anon_sym_R_DQUOTE] = ACTIONS(3485),
    [anon_sym_LR_DQUOTE] = ACTIONS(3485),
    [anon_sym_uR_DQUOTE] = ACTIONS(3485),
    [anon_sym_UR_DQUOTE] = ACTIONS(3485),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3485),
    [anon_sym_co_await] = ACTIONS(3483),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_requires] = ACTIONS(3483),
    [sym_this] = ACTIONS(3483),
    [anon_sym_discard] = ACTIONS(3483),
    [anon_sym_precise] = ACTIONS(3483),
    [anon_sym_shared] = ACTIONS(3483),
    [anon_sym_groupshared] = ACTIONS(3483),
    [anon_sym_uniform] = ACTIONS(3483),
    [anon_sym_row_major] = ACTIONS(3483),
    [anon_sym_column_major] = ACTIONS(3483),
    [anon_sym_globallycoherent] = ACTIONS(3483),
    [anon_sym_centroid] = ACTIONS(3483),
    [anon_sym_noperspective] = ACTIONS(3483),
    [anon_sym_nointerpolation] = ACTIONS(3483),
    [anon_sym_sample] = ACTIONS(3483),
    [anon_sym_linear] = ACTIONS(3483),
    [anon_sym_snorm] = ACTIONS(3483),
    [anon_sym_unorm] = ACTIONS(3483),
    [anon_sym_point] = ACTIONS(3483),
    [anon_sym_line] = ACTIONS(3483),
    [anon_sym_triangleadj] = ACTIONS(3483),
    [anon_sym_lineadj] = ACTIONS(3483),
    [anon_sym_triangle] = ACTIONS(3483),
    [anon_sym_cbuffer] = ACTIONS(3483),
    [anon_sym_interface] = ACTIONS(3483),
    [anon_sym_extension] = ACTIONS(3483),
  },
  [464] = {
    [sym_identifier] = ACTIONS(3489),
    [aux_sym_preproc_include_token1] = ACTIONS(3489),
    [aux_sym_preproc_def_token1] = ACTIONS(3489),
    [aux_sym_preproc_if_token1] = ACTIONS(3489),
    [aux_sym_preproc_if_token2] = ACTIONS(3489),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3489),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3489),
    [aux_sym_preproc_else_token1] = ACTIONS(3489),
    [aux_sym_preproc_elif_token1] = ACTIONS(3489),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3489),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3489),
    [sym_preproc_directive] = ACTIONS(3489),
    [anon_sym_LPAREN2] = ACTIONS(3491),
    [anon_sym_BANG] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(3489),
    [anon_sym_PLUS] = ACTIONS(3489),
    [anon_sym_STAR] = ACTIONS(3491),
    [anon_sym_AMP_AMP] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3489),
    [anon_sym_SEMI] = ACTIONS(3491),
    [anon_sym___extension__] = ACTIONS(3489),
    [anon_sym_typedef] = ACTIONS(3489),
    [anon_sym_in] = ACTIONS(3489),
    [anon_sym_out] = ACTIONS(3489),
    [anon_sym_inout] = ACTIONS(3489),
    [anon_sym_extern] = ACTIONS(3489),
    [anon_sym___attribute__] = ACTIONS(3489),
    [anon_sym_COLON_COLON] = ACTIONS(3491),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3491),
    [anon_sym___declspec] = ACTIONS(3489),
    [anon_sym___based] = ACTIONS(3489),
    [anon_sym___cdecl] = ACTIONS(3489),
    [anon_sym___clrcall] = ACTIONS(3489),
    [anon_sym___stdcall] = ACTIONS(3489),
    [anon_sym___fastcall] = ACTIONS(3489),
    [anon_sym___thiscall] = ACTIONS(3489),
    [anon_sym___vectorcall] = ACTIONS(3489),
    [anon_sym_LBRACE] = ACTIONS(3491),
    [anon_sym_signed] = ACTIONS(3489),
    [anon_sym_unsigned] = ACTIONS(3489),
    [anon_sym_long] = ACTIONS(3489),
    [anon_sym_short] = ACTIONS(3489),
    [anon_sym_LBRACK] = ACTIONS(3489),
    [anon_sym_static] = ACTIONS(3489),
    [anon_sym_register] = ACTIONS(3489),
    [anon_sym_inline] = ACTIONS(3489),
    [anon_sym___inline] = ACTIONS(3489),
    [anon_sym___inline__] = ACTIONS(3489),
    [anon_sym___forceinline] = ACTIONS(3489),
    [anon_sym_thread_local] = ACTIONS(3489),
    [anon_sym___thread] = ACTIONS(3489),
    [anon_sym_const] = ACTIONS(3489),
    [anon_sym_constexpr] = ACTIONS(3489),
    [anon_sym_volatile] = ACTIONS(3489),
    [anon_sym_restrict] = ACTIONS(3489),
    [anon_sym___restrict__] = ACTIONS(3489),
    [anon_sym__Atomic] = ACTIONS(3489),
    [anon_sym__Noreturn] = ACTIONS(3489),
    [anon_sym_noreturn] = ACTIONS(3489),
    [anon_sym_mutable] = ACTIONS(3489),
    [anon_sym_constinit] = ACTIONS(3489),
    [anon_sym_consteval] = ACTIONS(3489),
    [anon_sym_alignas] = ACTIONS(3489),
    [anon_sym__Alignas] = ACTIONS(3489),
    [sym_primitive_type] = ACTIONS(3489),
    [anon_sym_enum] = ACTIONS(3489),
    [anon_sym_class] = ACTIONS(3489),
    [anon_sym_struct] = ACTIONS(3489),
    [anon_sym_union] = ACTIONS(3489),
    [anon_sym_if] = ACTIONS(3489),
    [anon_sym_switch] = ACTIONS(3489),
    [anon_sym_case] = ACTIONS(3489),
    [anon_sym_default] = ACTIONS(3489),
    [anon_sym_while] = ACTIONS(3489),
    [anon_sym_do] = ACTIONS(3489),
    [anon_sym_for] = ACTIONS(3489),
    [anon_sym_return] = ACTIONS(3489),
    [anon_sym_break] = ACTIONS(3489),
    [anon_sym_continue] = ACTIONS(3489),
    [anon_sym_goto] = ACTIONS(3489),
    [anon_sym___try] = ACTIONS(3489),
    [anon_sym___leave] = ACTIONS(3489),
    [anon_sym_not] = ACTIONS(3489),
    [anon_sym_compl] = ACTIONS(3489),
    [anon_sym_DASH_DASH] = ACTIONS(3491),
    [anon_sym_PLUS_PLUS] = ACTIONS(3491),
    [anon_sym_sizeof] = ACTIONS(3489),
    [anon_sym___alignof__] = ACTIONS(3489),
    [anon_sym___alignof] = ACTIONS(3489),
    [anon_sym__alignof] = ACTIONS(3489),
    [anon_sym_alignof] = ACTIONS(3489),
    [anon_sym__Alignof] = ACTIONS(3489),
    [anon_sym_offsetof] = ACTIONS(3489),
    [anon_sym__Generic] = ACTIONS(3489),
    [anon_sym_asm] = ACTIONS(3489),
    [anon_sym___asm__] = ACTIONS(3489),
    [sym_number_literal] = ACTIONS(3491),
    [anon_sym_L_SQUOTE] = ACTIONS(3491),
    [anon_sym_u_SQUOTE] = ACTIONS(3491),
    [anon_sym_U_SQUOTE] = ACTIONS(3491),
    [anon_sym_u8_SQUOTE] = ACTIONS(3491),
    [anon_sym_SQUOTE] = ACTIONS(3491),
    [anon_sym_L_DQUOTE] = ACTIONS(3491),
    [anon_sym_u_DQUOTE] = ACTIONS(3491),
    [anon_sym_U_DQUOTE] = ACTIONS(3491),
    [anon_sym_u8_DQUOTE] = ACTIONS(3491),
    [anon_sym_DQUOTE] = ACTIONS(3491),
    [sym_true] = ACTIONS(3489),
    [sym_false] = ACTIONS(3489),
    [anon_sym_NULL] = ACTIONS(3489),
    [anon_sym_nullptr] = ACTIONS(3489),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3489),
    [anon_sym_let] = ACTIONS(3489),
    [anon_sym_This] = ACTIONS(3489),
    [anon_sym_decltype] = ACTIONS(3489),
    [sym_virtual] = ACTIONS(3489),
    [anon_sym_explicit] = ACTIONS(3489),
    [anon_sym_typename] = ACTIONS(3489),
    [anon_sym_template] = ACTIONS(3489),
    [anon_sym_operator] = ACTIONS(3489),
    [anon_sym_try] = ACTIONS(3489),
    [anon_sym_delete] = ACTIONS(3489),
    [anon_sym_throw] = ACTIONS(3489),
    [anon_sym_namespace] = ACTIONS(3489),
    [anon_sym_using] = ACTIONS(3489),
    [anon_sym_static_assert] = ACTIONS(3489),
    [anon_sym_concept] = ACTIONS(3489),
    [anon_sym_co_return] = ACTIONS(3489),
    [anon_sym_co_yield] = ACTIONS(3489),
    [anon_sym_R_DQUOTE] = ACTIONS(3491),
    [anon_sym_LR_DQUOTE] = ACTIONS(3491),
    [anon_sym_uR_DQUOTE] = ACTIONS(3491),
    [anon_sym_UR_DQUOTE] = ACTIONS(3491),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3491),
    [anon_sym_co_await] = ACTIONS(3489),
    [anon_sym_new] = ACTIONS(3489),
    [anon_sym_requires] = ACTIONS(3489),
    [sym_this] = ACTIONS(3489),
    [anon_sym_discard] = ACTIONS(3489),
    [anon_sym_precise] = ACTIONS(3489),
    [anon_sym_shared] = ACTIONS(3489),
    [anon_sym_groupshared] = ACTIONS(3489),
    [anon_sym_uniform] = ACTIONS(3489),
    [anon_sym_row_major] = ACTIONS(3489),
    [anon_sym_column_major] = ACTIONS(3489),
    [anon_sym_globallycoherent] = ACTIONS(3489),
    [anon_sym_centroid] = ACTIONS(3489),
    [anon_sym_noperspective] = ACTIONS(3489),
    [anon_sym_nointerpolation] = ACTIONS(3489),
    [anon_sym_sample] = ACTIONS(3489),
    [anon_sym_linear] = ACTIONS(3489),
    [anon_sym_snorm] = ACTIONS(3489),
    [anon_sym_unorm] = ACTIONS(3489),
    [anon_sym_point] = ACTIONS(3489),
    [anon_sym_line] = ACTIONS(3489),
    [anon_sym_triangleadj] = ACTIONS(3489),
    [anon_sym_lineadj] = ACTIONS(3489),
    [anon_sym_triangle] = ACTIONS(3489),
    [anon_sym_cbuffer] = ACTIONS(3489),
    [anon_sym_interface] = ACTIONS(3489),
    [anon_sym_extension] = ACTIONS(3489),
  },
  [465] = {
    [sym_identifier] = ACTIONS(3429),
    [aux_sym_preproc_include_token1] = ACTIONS(3429),
    [aux_sym_preproc_def_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token2] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3429),
    [aux_sym_preproc_else_token1] = ACTIONS(3429),
    [aux_sym_preproc_elif_token1] = ACTIONS(3429),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3429),
    [sym_preproc_directive] = ACTIONS(3429),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_BANG] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym_SEMI] = ACTIONS(3431),
    [anon_sym___extension__] = ACTIONS(3429),
    [anon_sym_typedef] = ACTIONS(3429),
    [anon_sym_in] = ACTIONS(3429),
    [anon_sym_out] = ACTIONS(3429),
    [anon_sym_inout] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym___attribute__] = ACTIONS(3429),
    [anon_sym_COLON_COLON] = ACTIONS(3431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3431),
    [anon_sym___declspec] = ACTIONS(3429),
    [anon_sym___based] = ACTIONS(3429),
    [anon_sym___cdecl] = ACTIONS(3429),
    [anon_sym___clrcall] = ACTIONS(3429),
    [anon_sym___stdcall] = ACTIONS(3429),
    [anon_sym___fastcall] = ACTIONS(3429),
    [anon_sym___thiscall] = ACTIONS(3429),
    [anon_sym___vectorcall] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_signed] = ACTIONS(3429),
    [anon_sym_unsigned] = ACTIONS(3429),
    [anon_sym_long] = ACTIONS(3429),
    [anon_sym_short] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_register] = ACTIONS(3429),
    [anon_sym_inline] = ACTIONS(3429),
    [anon_sym___inline] = ACTIONS(3429),
    [anon_sym___inline__] = ACTIONS(3429),
    [anon_sym___forceinline] = ACTIONS(3429),
    [anon_sym_thread_local] = ACTIONS(3429),
    [anon_sym___thread] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_constexpr] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_restrict] = ACTIONS(3429),
    [anon_sym___restrict__] = ACTIONS(3429),
    [anon_sym__Atomic] = ACTIONS(3429),
    [anon_sym__Noreturn] = ACTIONS(3429),
    [anon_sym_noreturn] = ACTIONS(3429),
    [anon_sym_mutable] = ACTIONS(3429),
    [anon_sym_constinit] = ACTIONS(3429),
    [anon_sym_consteval] = ACTIONS(3429),
    [anon_sym_alignas] = ACTIONS(3429),
    [anon_sym__Alignas] = ACTIONS(3429),
    [sym_primitive_type] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [anon_sym_if] = ACTIONS(3429),
    [anon_sym_switch] = ACTIONS(3429),
    [anon_sym_case] = ACTIONS(3429),
    [anon_sym_default] = ACTIONS(3429),
    [anon_sym_while] = ACTIONS(3429),
    [anon_sym_do] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3429),
    [anon_sym_return] = ACTIONS(3429),
    [anon_sym_break] = ACTIONS(3429),
    [anon_sym_continue] = ACTIONS(3429),
    [anon_sym_goto] = ACTIONS(3429),
    [anon_sym___try] = ACTIONS(3429),
    [anon_sym___leave] = ACTIONS(3429),
    [anon_sym_not] = ACTIONS(3429),
    [anon_sym_compl] = ACTIONS(3429),
    [anon_sym_DASH_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(3431),
    [anon_sym_sizeof] = ACTIONS(3429),
    [anon_sym___alignof__] = ACTIONS(3429),
    [anon_sym___alignof] = ACTIONS(3429),
    [anon_sym__alignof] = ACTIONS(3429),
    [anon_sym_alignof] = ACTIONS(3429),
    [anon_sym__Alignof] = ACTIONS(3429),
    [anon_sym_offsetof] = ACTIONS(3429),
    [anon_sym__Generic] = ACTIONS(3429),
    [anon_sym_asm] = ACTIONS(3429),
    [anon_sym___asm__] = ACTIONS(3429),
    [sym_number_literal] = ACTIONS(3431),
    [anon_sym_L_SQUOTE] = ACTIONS(3431),
    [anon_sym_u_SQUOTE] = ACTIONS(3431),
    [anon_sym_U_SQUOTE] = ACTIONS(3431),
    [anon_sym_u8_SQUOTE] = ACTIONS(3431),
    [anon_sym_SQUOTE] = ACTIONS(3431),
    [anon_sym_L_DQUOTE] = ACTIONS(3431),
    [anon_sym_u_DQUOTE] = ACTIONS(3431),
    [anon_sym_U_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [sym_true] = ACTIONS(3429),
    [sym_false] = ACTIONS(3429),
    [anon_sym_NULL] = ACTIONS(3429),
    [anon_sym_nullptr] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_This] = ACTIONS(3429),
    [anon_sym_decltype] = ACTIONS(3429),
    [sym_virtual] = ACTIONS(3429),
    [anon_sym_explicit] = ACTIONS(3429),
    [anon_sym_typename] = ACTIONS(3429),
    [anon_sym_template] = ACTIONS(3429),
    [anon_sym_operator] = ACTIONS(3429),
    [anon_sym_try] = ACTIONS(3429),
    [anon_sym_delete] = ACTIONS(3429),
    [anon_sym_throw] = ACTIONS(3429),
    [anon_sym_namespace] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_static_assert] = ACTIONS(3429),
    [anon_sym_concept] = ACTIONS(3429),
    [anon_sym_co_return] = ACTIONS(3429),
    [anon_sym_co_yield] = ACTIONS(3429),
    [anon_sym_R_DQUOTE] = ACTIONS(3431),
    [anon_sym_LR_DQUOTE] = ACTIONS(3431),
    [anon_sym_uR_DQUOTE] = ACTIONS(3431),
    [anon_sym_UR_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3431),
    [anon_sym_co_await] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3429),
    [anon_sym_requires] = ACTIONS(3429),
    [sym_this] = ACTIONS(3429),
    [anon_sym_discard] = ACTIONS(3429),
    [anon_sym_precise] = ACTIONS(3429),
    [anon_sym_shared] = ACTIONS(3429),
    [anon_sym_groupshared] = ACTIONS(3429),
    [anon_sym_uniform] = ACTIONS(3429),
    [anon_sym_row_major] = ACTIONS(3429),
    [anon_sym_column_major] = ACTIONS(3429),
    [anon_sym_globallycoherent] = ACTIONS(3429),
    [anon_sym_centroid] = ACTIONS(3429),
    [anon_sym_noperspective] = ACTIONS(3429),
    [anon_sym_nointerpolation] = ACTIONS(3429),
    [anon_sym_sample] = ACTIONS(3429),
    [anon_sym_linear] = ACTIONS(3429),
    [anon_sym_snorm] = ACTIONS(3429),
    [anon_sym_unorm] = ACTIONS(3429),
    [anon_sym_point] = ACTIONS(3429),
    [anon_sym_line] = ACTIONS(3429),
    [anon_sym_triangleadj] = ACTIONS(3429),
    [anon_sym_lineadj] = ACTIONS(3429),
    [anon_sym_triangle] = ACTIONS(3429),
    [anon_sym_cbuffer] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_extension] = ACTIONS(3429),
  },
  [466] = {
    [sym_identifier] = ACTIONS(3429),
    [aux_sym_preproc_include_token1] = ACTIONS(3429),
    [aux_sym_preproc_def_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token2] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3429),
    [aux_sym_preproc_else_token1] = ACTIONS(3429),
    [aux_sym_preproc_elif_token1] = ACTIONS(3429),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3429),
    [sym_preproc_directive] = ACTIONS(3429),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_BANG] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym_SEMI] = ACTIONS(3431),
    [anon_sym___extension__] = ACTIONS(3429),
    [anon_sym_typedef] = ACTIONS(3429),
    [anon_sym_in] = ACTIONS(3429),
    [anon_sym_out] = ACTIONS(3429),
    [anon_sym_inout] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym___attribute__] = ACTIONS(3429),
    [anon_sym_COLON_COLON] = ACTIONS(3431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3431),
    [anon_sym___declspec] = ACTIONS(3429),
    [anon_sym___based] = ACTIONS(3429),
    [anon_sym___cdecl] = ACTIONS(3429),
    [anon_sym___clrcall] = ACTIONS(3429),
    [anon_sym___stdcall] = ACTIONS(3429),
    [anon_sym___fastcall] = ACTIONS(3429),
    [anon_sym___thiscall] = ACTIONS(3429),
    [anon_sym___vectorcall] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_signed] = ACTIONS(3429),
    [anon_sym_unsigned] = ACTIONS(3429),
    [anon_sym_long] = ACTIONS(3429),
    [anon_sym_short] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_register] = ACTIONS(3429),
    [anon_sym_inline] = ACTIONS(3429),
    [anon_sym___inline] = ACTIONS(3429),
    [anon_sym___inline__] = ACTIONS(3429),
    [anon_sym___forceinline] = ACTIONS(3429),
    [anon_sym_thread_local] = ACTIONS(3429),
    [anon_sym___thread] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_constexpr] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_restrict] = ACTIONS(3429),
    [anon_sym___restrict__] = ACTIONS(3429),
    [anon_sym__Atomic] = ACTIONS(3429),
    [anon_sym__Noreturn] = ACTIONS(3429),
    [anon_sym_noreturn] = ACTIONS(3429),
    [anon_sym_mutable] = ACTIONS(3429),
    [anon_sym_constinit] = ACTIONS(3429),
    [anon_sym_consteval] = ACTIONS(3429),
    [anon_sym_alignas] = ACTIONS(3429),
    [anon_sym__Alignas] = ACTIONS(3429),
    [sym_primitive_type] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [anon_sym_if] = ACTIONS(3429),
    [anon_sym_switch] = ACTIONS(3429),
    [anon_sym_case] = ACTIONS(3429),
    [anon_sym_default] = ACTIONS(3429),
    [anon_sym_while] = ACTIONS(3429),
    [anon_sym_do] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3429),
    [anon_sym_return] = ACTIONS(3429),
    [anon_sym_break] = ACTIONS(3429),
    [anon_sym_continue] = ACTIONS(3429),
    [anon_sym_goto] = ACTIONS(3429),
    [anon_sym___try] = ACTIONS(3429),
    [anon_sym___leave] = ACTIONS(3429),
    [anon_sym_not] = ACTIONS(3429),
    [anon_sym_compl] = ACTIONS(3429),
    [anon_sym_DASH_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(3431),
    [anon_sym_sizeof] = ACTIONS(3429),
    [anon_sym___alignof__] = ACTIONS(3429),
    [anon_sym___alignof] = ACTIONS(3429),
    [anon_sym__alignof] = ACTIONS(3429),
    [anon_sym_alignof] = ACTIONS(3429),
    [anon_sym__Alignof] = ACTIONS(3429),
    [anon_sym_offsetof] = ACTIONS(3429),
    [anon_sym__Generic] = ACTIONS(3429),
    [anon_sym_asm] = ACTIONS(3429),
    [anon_sym___asm__] = ACTIONS(3429),
    [sym_number_literal] = ACTIONS(3431),
    [anon_sym_L_SQUOTE] = ACTIONS(3431),
    [anon_sym_u_SQUOTE] = ACTIONS(3431),
    [anon_sym_U_SQUOTE] = ACTIONS(3431),
    [anon_sym_u8_SQUOTE] = ACTIONS(3431),
    [anon_sym_SQUOTE] = ACTIONS(3431),
    [anon_sym_L_DQUOTE] = ACTIONS(3431),
    [anon_sym_u_DQUOTE] = ACTIONS(3431),
    [anon_sym_U_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [sym_true] = ACTIONS(3429),
    [sym_false] = ACTIONS(3429),
    [anon_sym_NULL] = ACTIONS(3429),
    [anon_sym_nullptr] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_This] = ACTIONS(3429),
    [anon_sym_decltype] = ACTIONS(3429),
    [sym_virtual] = ACTIONS(3429),
    [anon_sym_explicit] = ACTIONS(3429),
    [anon_sym_typename] = ACTIONS(3429),
    [anon_sym_template] = ACTIONS(3429),
    [anon_sym_operator] = ACTIONS(3429),
    [anon_sym_try] = ACTIONS(3429),
    [anon_sym_delete] = ACTIONS(3429),
    [anon_sym_throw] = ACTIONS(3429),
    [anon_sym_namespace] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_static_assert] = ACTIONS(3429),
    [anon_sym_concept] = ACTIONS(3429),
    [anon_sym_co_return] = ACTIONS(3429),
    [anon_sym_co_yield] = ACTIONS(3429),
    [anon_sym_R_DQUOTE] = ACTIONS(3431),
    [anon_sym_LR_DQUOTE] = ACTIONS(3431),
    [anon_sym_uR_DQUOTE] = ACTIONS(3431),
    [anon_sym_UR_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3431),
    [anon_sym_co_await] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3429),
    [anon_sym_requires] = ACTIONS(3429),
    [sym_this] = ACTIONS(3429),
    [anon_sym_discard] = ACTIONS(3429),
    [anon_sym_precise] = ACTIONS(3429),
    [anon_sym_shared] = ACTIONS(3429),
    [anon_sym_groupshared] = ACTIONS(3429),
    [anon_sym_uniform] = ACTIONS(3429),
    [anon_sym_row_major] = ACTIONS(3429),
    [anon_sym_column_major] = ACTIONS(3429),
    [anon_sym_globallycoherent] = ACTIONS(3429),
    [anon_sym_centroid] = ACTIONS(3429),
    [anon_sym_noperspective] = ACTIONS(3429),
    [anon_sym_nointerpolation] = ACTIONS(3429),
    [anon_sym_sample] = ACTIONS(3429),
    [anon_sym_linear] = ACTIONS(3429),
    [anon_sym_snorm] = ACTIONS(3429),
    [anon_sym_unorm] = ACTIONS(3429),
    [anon_sym_point] = ACTIONS(3429),
    [anon_sym_line] = ACTIONS(3429),
    [anon_sym_triangleadj] = ACTIONS(3429),
    [anon_sym_lineadj] = ACTIONS(3429),
    [anon_sym_triangle] = ACTIONS(3429),
    [anon_sym_cbuffer] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_extension] = ACTIONS(3429),
  },
  [467] = {
    [sym_identifier] = ACTIONS(3493),
    [aux_sym_preproc_include_token1] = ACTIONS(3493),
    [aux_sym_preproc_def_token1] = ACTIONS(3493),
    [aux_sym_preproc_if_token1] = ACTIONS(3493),
    [aux_sym_preproc_if_token2] = ACTIONS(3493),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3493),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3493),
    [aux_sym_preproc_else_token1] = ACTIONS(3493),
    [aux_sym_preproc_elif_token1] = ACTIONS(3493),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3493),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3493),
    [sym_preproc_directive] = ACTIONS(3493),
    [anon_sym_LPAREN2] = ACTIONS(3495),
    [anon_sym_BANG] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3495),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_PLUS] = ACTIONS(3493),
    [anon_sym_STAR] = ACTIONS(3495),
    [anon_sym_AMP_AMP] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_SEMI] = ACTIONS(3495),
    [anon_sym___extension__] = ACTIONS(3493),
    [anon_sym_typedef] = ACTIONS(3493),
    [anon_sym_in] = ACTIONS(3493),
    [anon_sym_out] = ACTIONS(3493),
    [anon_sym_inout] = ACTIONS(3493),
    [anon_sym_extern] = ACTIONS(3493),
    [anon_sym___attribute__] = ACTIONS(3493),
    [anon_sym_COLON_COLON] = ACTIONS(3495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3495),
    [anon_sym___declspec] = ACTIONS(3493),
    [anon_sym___based] = ACTIONS(3493),
    [anon_sym___cdecl] = ACTIONS(3493),
    [anon_sym___clrcall] = ACTIONS(3493),
    [anon_sym___stdcall] = ACTIONS(3493),
    [anon_sym___fastcall] = ACTIONS(3493),
    [anon_sym___thiscall] = ACTIONS(3493),
    [anon_sym___vectorcall] = ACTIONS(3493),
    [anon_sym_LBRACE] = ACTIONS(3495),
    [anon_sym_signed] = ACTIONS(3493),
    [anon_sym_unsigned] = ACTIONS(3493),
    [anon_sym_long] = ACTIONS(3493),
    [anon_sym_short] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3493),
    [anon_sym_static] = ACTIONS(3493),
    [anon_sym_register] = ACTIONS(3493),
    [anon_sym_inline] = ACTIONS(3493),
    [anon_sym___inline] = ACTIONS(3493),
    [anon_sym___inline__] = ACTIONS(3493),
    [anon_sym___forceinline] = ACTIONS(3493),
    [anon_sym_thread_local] = ACTIONS(3493),
    [anon_sym___thread] = ACTIONS(3493),
    [anon_sym_const] = ACTIONS(3493),
    [anon_sym_constexpr] = ACTIONS(3493),
    [anon_sym_volatile] = ACTIONS(3493),
    [anon_sym_restrict] = ACTIONS(3493),
    [anon_sym___restrict__] = ACTIONS(3493),
    [anon_sym__Atomic] = ACTIONS(3493),
    [anon_sym__Noreturn] = ACTIONS(3493),
    [anon_sym_noreturn] = ACTIONS(3493),
    [anon_sym_mutable] = ACTIONS(3493),
    [anon_sym_constinit] = ACTIONS(3493),
    [anon_sym_consteval] = ACTIONS(3493),
    [anon_sym_alignas] = ACTIONS(3493),
    [anon_sym__Alignas] = ACTIONS(3493),
    [sym_primitive_type] = ACTIONS(3493),
    [anon_sym_enum] = ACTIONS(3493),
    [anon_sym_class] = ACTIONS(3493),
    [anon_sym_struct] = ACTIONS(3493),
    [anon_sym_union] = ACTIONS(3493),
    [anon_sym_if] = ACTIONS(3493),
    [anon_sym_switch] = ACTIONS(3493),
    [anon_sym_case] = ACTIONS(3493),
    [anon_sym_default] = ACTIONS(3493),
    [anon_sym_while] = ACTIONS(3493),
    [anon_sym_do] = ACTIONS(3493),
    [anon_sym_for] = ACTIONS(3493),
    [anon_sym_return] = ACTIONS(3493),
    [anon_sym_break] = ACTIONS(3493),
    [anon_sym_continue] = ACTIONS(3493),
    [anon_sym_goto] = ACTIONS(3493),
    [anon_sym___try] = ACTIONS(3493),
    [anon_sym___leave] = ACTIONS(3493),
    [anon_sym_not] = ACTIONS(3493),
    [anon_sym_compl] = ACTIONS(3493),
    [anon_sym_DASH_DASH] = ACTIONS(3495),
    [anon_sym_PLUS_PLUS] = ACTIONS(3495),
    [anon_sym_sizeof] = ACTIONS(3493),
    [anon_sym___alignof__] = ACTIONS(3493),
    [anon_sym___alignof] = ACTIONS(3493),
    [anon_sym__alignof] = ACTIONS(3493),
    [anon_sym_alignof] = ACTIONS(3493),
    [anon_sym__Alignof] = ACTIONS(3493),
    [anon_sym_offsetof] = ACTIONS(3493),
    [anon_sym__Generic] = ACTIONS(3493),
    [anon_sym_asm] = ACTIONS(3493),
    [anon_sym___asm__] = ACTIONS(3493),
    [sym_number_literal] = ACTIONS(3495),
    [anon_sym_L_SQUOTE] = ACTIONS(3495),
    [anon_sym_u_SQUOTE] = ACTIONS(3495),
    [anon_sym_U_SQUOTE] = ACTIONS(3495),
    [anon_sym_u8_SQUOTE] = ACTIONS(3495),
    [anon_sym_SQUOTE] = ACTIONS(3495),
    [anon_sym_L_DQUOTE] = ACTIONS(3495),
    [anon_sym_u_DQUOTE] = ACTIONS(3495),
    [anon_sym_U_DQUOTE] = ACTIONS(3495),
    [anon_sym_u8_DQUOTE] = ACTIONS(3495),
    [anon_sym_DQUOTE] = ACTIONS(3495),
    [sym_true] = ACTIONS(3493),
    [sym_false] = ACTIONS(3493),
    [anon_sym_NULL] = ACTIONS(3493),
    [anon_sym_nullptr] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3493),
    [anon_sym_let] = ACTIONS(3493),
    [anon_sym_This] = ACTIONS(3493),
    [anon_sym_decltype] = ACTIONS(3493),
    [sym_virtual] = ACTIONS(3493),
    [anon_sym_explicit] = ACTIONS(3493),
    [anon_sym_typename] = ACTIONS(3493),
    [anon_sym_template] = ACTIONS(3493),
    [anon_sym_operator] = ACTIONS(3493),
    [anon_sym_try] = ACTIONS(3493),
    [anon_sym_delete] = ACTIONS(3493),
    [anon_sym_throw] = ACTIONS(3493),
    [anon_sym_namespace] = ACTIONS(3493),
    [anon_sym_using] = ACTIONS(3493),
    [anon_sym_static_assert] = ACTIONS(3493),
    [anon_sym_concept] = ACTIONS(3493),
    [anon_sym_co_return] = ACTIONS(3493),
    [anon_sym_co_yield] = ACTIONS(3493),
    [anon_sym_R_DQUOTE] = ACTIONS(3495),
    [anon_sym_LR_DQUOTE] = ACTIONS(3495),
    [anon_sym_uR_DQUOTE] = ACTIONS(3495),
    [anon_sym_UR_DQUOTE] = ACTIONS(3495),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3495),
    [anon_sym_co_await] = ACTIONS(3493),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_requires] = ACTIONS(3493),
    [sym_this] = ACTIONS(3493),
    [anon_sym_discard] = ACTIONS(3493),
    [anon_sym_precise] = ACTIONS(3493),
    [anon_sym_shared] = ACTIONS(3493),
    [anon_sym_groupshared] = ACTIONS(3493),
    [anon_sym_uniform] = ACTIONS(3493),
    [anon_sym_row_major] = ACTIONS(3493),
    [anon_sym_column_major] = ACTIONS(3493),
    [anon_sym_globallycoherent] = ACTIONS(3493),
    [anon_sym_centroid] = ACTIONS(3493),
    [anon_sym_noperspective] = ACTIONS(3493),
    [anon_sym_nointerpolation] = ACTIONS(3493),
    [anon_sym_sample] = ACTIONS(3493),
    [anon_sym_linear] = ACTIONS(3493),
    [anon_sym_snorm] = ACTIONS(3493),
    [anon_sym_unorm] = ACTIONS(3493),
    [anon_sym_point] = ACTIONS(3493),
    [anon_sym_line] = ACTIONS(3493),
    [anon_sym_triangleadj] = ACTIONS(3493),
    [anon_sym_lineadj] = ACTIONS(3493),
    [anon_sym_triangle] = ACTIONS(3493),
    [anon_sym_cbuffer] = ACTIONS(3493),
    [anon_sym_interface] = ACTIONS(3493),
    [anon_sym_extension] = ACTIONS(3493),
  },
  [468] = {
    [sym_identifier] = ACTIONS(3410),
    [aux_sym_preproc_include_token1] = ACTIONS(3410),
    [aux_sym_preproc_def_token1] = ACTIONS(3410),
    [aux_sym_preproc_if_token1] = ACTIONS(3410),
    [aux_sym_preproc_if_token2] = ACTIONS(3410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3410),
    [aux_sym_preproc_else_token1] = ACTIONS(3410),
    [aux_sym_preproc_elif_token1] = ACTIONS(3410),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3410),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3410),
    [sym_preproc_directive] = ACTIONS(3410),
    [anon_sym_LPAREN2] = ACTIONS(3412),
    [anon_sym_BANG] = ACTIONS(3412),
    [anon_sym_TILDE] = ACTIONS(3412),
    [anon_sym_DASH] = ACTIONS(3410),
    [anon_sym_PLUS] = ACTIONS(3410),
    [anon_sym_STAR] = ACTIONS(3412),
    [anon_sym_AMP_AMP] = ACTIONS(3412),
    [anon_sym_AMP] = ACTIONS(3410),
    [anon_sym_SEMI] = ACTIONS(3412),
    [anon_sym___extension__] = ACTIONS(3410),
    [anon_sym_typedef] = ACTIONS(3410),
    [anon_sym_in] = ACTIONS(3410),
    [anon_sym_out] = ACTIONS(3410),
    [anon_sym_inout] = ACTIONS(3410),
    [anon_sym_extern] = ACTIONS(3410),
    [anon_sym___attribute__] = ACTIONS(3410),
    [anon_sym_COLON_COLON] = ACTIONS(3412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3412),
    [anon_sym___declspec] = ACTIONS(3410),
    [anon_sym___based] = ACTIONS(3410),
    [anon_sym___cdecl] = ACTIONS(3410),
    [anon_sym___clrcall] = ACTIONS(3410),
    [anon_sym___stdcall] = ACTIONS(3410),
    [anon_sym___fastcall] = ACTIONS(3410),
    [anon_sym___thiscall] = ACTIONS(3410),
    [anon_sym___vectorcall] = ACTIONS(3410),
    [anon_sym_LBRACE] = ACTIONS(3412),
    [anon_sym_signed] = ACTIONS(3410),
    [anon_sym_unsigned] = ACTIONS(3410),
    [anon_sym_long] = ACTIONS(3410),
    [anon_sym_short] = ACTIONS(3410),
    [anon_sym_LBRACK] = ACTIONS(3410),
    [anon_sym_static] = ACTIONS(3410),
    [anon_sym_register] = ACTIONS(3410),
    [anon_sym_inline] = ACTIONS(3410),
    [anon_sym___inline] = ACTIONS(3410),
    [anon_sym___inline__] = ACTIONS(3410),
    [anon_sym___forceinline] = ACTIONS(3410),
    [anon_sym_thread_local] = ACTIONS(3410),
    [anon_sym___thread] = ACTIONS(3410),
    [anon_sym_const] = ACTIONS(3410),
    [anon_sym_constexpr] = ACTIONS(3410),
    [anon_sym_volatile] = ACTIONS(3410),
    [anon_sym_restrict] = ACTIONS(3410),
    [anon_sym___restrict__] = ACTIONS(3410),
    [anon_sym__Atomic] = ACTIONS(3410),
    [anon_sym__Noreturn] = ACTIONS(3410),
    [anon_sym_noreturn] = ACTIONS(3410),
    [anon_sym_mutable] = ACTIONS(3410),
    [anon_sym_constinit] = ACTIONS(3410),
    [anon_sym_consteval] = ACTIONS(3410),
    [anon_sym_alignas] = ACTIONS(3410),
    [anon_sym__Alignas] = ACTIONS(3410),
    [sym_primitive_type] = ACTIONS(3410),
    [anon_sym_enum] = ACTIONS(3410),
    [anon_sym_class] = ACTIONS(3410),
    [anon_sym_struct] = ACTIONS(3410),
    [anon_sym_union] = ACTIONS(3410),
    [anon_sym_if] = ACTIONS(3410),
    [anon_sym_switch] = ACTIONS(3410),
    [anon_sym_case] = ACTIONS(3410),
    [anon_sym_default] = ACTIONS(3410),
    [anon_sym_while] = ACTIONS(3410),
    [anon_sym_do] = ACTIONS(3410),
    [anon_sym_for] = ACTIONS(3410),
    [anon_sym_return] = ACTIONS(3410),
    [anon_sym_break] = ACTIONS(3410),
    [anon_sym_continue] = ACTIONS(3410),
    [anon_sym_goto] = ACTIONS(3410),
    [anon_sym___try] = ACTIONS(3410),
    [anon_sym___leave] = ACTIONS(3410),
    [anon_sym_not] = ACTIONS(3410),
    [anon_sym_compl] = ACTIONS(3410),
    [anon_sym_DASH_DASH] = ACTIONS(3412),
    [anon_sym_PLUS_PLUS] = ACTIONS(3412),
    [anon_sym_sizeof] = ACTIONS(3410),
    [anon_sym___alignof__] = ACTIONS(3410),
    [anon_sym___alignof] = ACTIONS(3410),
    [anon_sym__alignof] = ACTIONS(3410),
    [anon_sym_alignof] = ACTIONS(3410),
    [anon_sym__Alignof] = ACTIONS(3410),
    [anon_sym_offsetof] = ACTIONS(3410),
    [anon_sym__Generic] = ACTIONS(3410),
    [anon_sym_asm] = ACTIONS(3410),
    [anon_sym___asm__] = ACTIONS(3410),
    [sym_number_literal] = ACTIONS(3412),
    [anon_sym_L_SQUOTE] = ACTIONS(3412),
    [anon_sym_u_SQUOTE] = ACTIONS(3412),
    [anon_sym_U_SQUOTE] = ACTIONS(3412),
    [anon_sym_u8_SQUOTE] = ACTIONS(3412),
    [anon_sym_SQUOTE] = ACTIONS(3412),
    [anon_sym_L_DQUOTE] = ACTIONS(3412),
    [anon_sym_u_DQUOTE] = ACTIONS(3412),
    [anon_sym_U_DQUOTE] = ACTIONS(3412),
    [anon_sym_u8_DQUOTE] = ACTIONS(3412),
    [anon_sym_DQUOTE] = ACTIONS(3412),
    [sym_true] = ACTIONS(3410),
    [sym_false] = ACTIONS(3410),
    [anon_sym_NULL] = ACTIONS(3410),
    [anon_sym_nullptr] = ACTIONS(3410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3410),
    [anon_sym_let] = ACTIONS(3410),
    [anon_sym_This] = ACTIONS(3410),
    [anon_sym_decltype] = ACTIONS(3410),
    [sym_virtual] = ACTIONS(3410),
    [anon_sym_explicit] = ACTIONS(3410),
    [anon_sym_typename] = ACTIONS(3410),
    [anon_sym_template] = ACTIONS(3410),
    [anon_sym_operator] = ACTIONS(3410),
    [anon_sym_try] = ACTIONS(3410),
    [anon_sym_delete] = ACTIONS(3410),
    [anon_sym_throw] = ACTIONS(3410),
    [anon_sym_namespace] = ACTIONS(3410),
    [anon_sym_using] = ACTIONS(3410),
    [anon_sym_static_assert] = ACTIONS(3410),
    [anon_sym_concept] = ACTIONS(3410),
    [anon_sym_co_return] = ACTIONS(3410),
    [anon_sym_co_yield] = ACTIONS(3410),
    [anon_sym_R_DQUOTE] = ACTIONS(3412),
    [anon_sym_LR_DQUOTE] = ACTIONS(3412),
    [anon_sym_uR_DQUOTE] = ACTIONS(3412),
    [anon_sym_UR_DQUOTE] = ACTIONS(3412),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3412),
    [anon_sym_co_await] = ACTIONS(3410),
    [anon_sym_new] = ACTIONS(3410),
    [anon_sym_requires] = ACTIONS(3410),
    [sym_this] = ACTIONS(3410),
    [anon_sym_discard] = ACTIONS(3410),
    [anon_sym_precise] = ACTIONS(3410),
    [anon_sym_shared] = ACTIONS(3410),
    [anon_sym_groupshared] = ACTIONS(3410),
    [anon_sym_uniform] = ACTIONS(3410),
    [anon_sym_row_major] = ACTIONS(3410),
    [anon_sym_column_major] = ACTIONS(3410),
    [anon_sym_globallycoherent] = ACTIONS(3410),
    [anon_sym_centroid] = ACTIONS(3410),
    [anon_sym_noperspective] = ACTIONS(3410),
    [anon_sym_nointerpolation] = ACTIONS(3410),
    [anon_sym_sample] = ACTIONS(3410),
    [anon_sym_linear] = ACTIONS(3410),
    [anon_sym_snorm] = ACTIONS(3410),
    [anon_sym_unorm] = ACTIONS(3410),
    [anon_sym_point] = ACTIONS(3410),
    [anon_sym_line] = ACTIONS(3410),
    [anon_sym_triangleadj] = ACTIONS(3410),
    [anon_sym_lineadj] = ACTIONS(3410),
    [anon_sym_triangle] = ACTIONS(3410),
    [anon_sym_cbuffer] = ACTIONS(3410),
    [anon_sym_interface] = ACTIONS(3410),
    [anon_sym_extension] = ACTIONS(3410),
  },
  [469] = {
    [sym_identifier] = ACTIONS(3497),
    [aux_sym_preproc_include_token1] = ACTIONS(3497),
    [aux_sym_preproc_def_token1] = ACTIONS(3497),
    [aux_sym_preproc_if_token1] = ACTIONS(3497),
    [aux_sym_preproc_if_token2] = ACTIONS(3497),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3497),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3497),
    [aux_sym_preproc_else_token1] = ACTIONS(3497),
    [aux_sym_preproc_elif_token1] = ACTIONS(3497),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3497),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3497),
    [sym_preproc_directive] = ACTIONS(3497),
    [anon_sym_LPAREN2] = ACTIONS(3499),
    [anon_sym_BANG] = ACTIONS(3499),
    [anon_sym_TILDE] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_STAR] = ACTIONS(3499),
    [anon_sym_AMP_AMP] = ACTIONS(3499),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym_SEMI] = ACTIONS(3499),
    [anon_sym___extension__] = ACTIONS(3497),
    [anon_sym_typedef] = ACTIONS(3497),
    [anon_sym_in] = ACTIONS(3497),
    [anon_sym_out] = ACTIONS(3497),
    [anon_sym_inout] = ACTIONS(3497),
    [anon_sym_extern] = ACTIONS(3497),
    [anon_sym___attribute__] = ACTIONS(3497),
    [anon_sym_COLON_COLON] = ACTIONS(3499),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3499),
    [anon_sym___declspec] = ACTIONS(3497),
    [anon_sym___based] = ACTIONS(3497),
    [anon_sym___cdecl] = ACTIONS(3497),
    [anon_sym___clrcall] = ACTIONS(3497),
    [anon_sym___stdcall] = ACTIONS(3497),
    [anon_sym___fastcall] = ACTIONS(3497),
    [anon_sym___thiscall] = ACTIONS(3497),
    [anon_sym___vectorcall] = ACTIONS(3497),
    [anon_sym_LBRACE] = ACTIONS(3499),
    [anon_sym_signed] = ACTIONS(3497),
    [anon_sym_unsigned] = ACTIONS(3497),
    [anon_sym_long] = ACTIONS(3497),
    [anon_sym_short] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3497),
    [anon_sym_static] = ACTIONS(3497),
    [anon_sym_register] = ACTIONS(3497),
    [anon_sym_inline] = ACTIONS(3497),
    [anon_sym___inline] = ACTIONS(3497),
    [anon_sym___inline__] = ACTIONS(3497),
    [anon_sym___forceinline] = ACTIONS(3497),
    [anon_sym_thread_local] = ACTIONS(3497),
    [anon_sym___thread] = ACTIONS(3497),
    [anon_sym_const] = ACTIONS(3497),
    [anon_sym_constexpr] = ACTIONS(3497),
    [anon_sym_volatile] = ACTIONS(3497),
    [anon_sym_restrict] = ACTIONS(3497),
    [anon_sym___restrict__] = ACTIONS(3497),
    [anon_sym__Atomic] = ACTIONS(3497),
    [anon_sym__Noreturn] = ACTIONS(3497),
    [anon_sym_noreturn] = ACTIONS(3497),
    [anon_sym_mutable] = ACTIONS(3497),
    [anon_sym_constinit] = ACTIONS(3497),
    [anon_sym_consteval] = ACTIONS(3497),
    [anon_sym_alignas] = ACTIONS(3497),
    [anon_sym__Alignas] = ACTIONS(3497),
    [sym_primitive_type] = ACTIONS(3497),
    [anon_sym_enum] = ACTIONS(3497),
    [anon_sym_class] = ACTIONS(3497),
    [anon_sym_struct] = ACTIONS(3497),
    [anon_sym_union] = ACTIONS(3497),
    [anon_sym_if] = ACTIONS(3497),
    [anon_sym_switch] = ACTIONS(3497),
    [anon_sym_case] = ACTIONS(3497),
    [anon_sym_default] = ACTIONS(3497),
    [anon_sym_while] = ACTIONS(3497),
    [anon_sym_do] = ACTIONS(3497),
    [anon_sym_for] = ACTIONS(3497),
    [anon_sym_return] = ACTIONS(3497),
    [anon_sym_break] = ACTIONS(3497),
    [anon_sym_continue] = ACTIONS(3497),
    [anon_sym_goto] = ACTIONS(3497),
    [anon_sym___try] = ACTIONS(3497),
    [anon_sym___leave] = ACTIONS(3497),
    [anon_sym_not] = ACTIONS(3497),
    [anon_sym_compl] = ACTIONS(3497),
    [anon_sym_DASH_DASH] = ACTIONS(3499),
    [anon_sym_PLUS_PLUS] = ACTIONS(3499),
    [anon_sym_sizeof] = ACTIONS(3497),
    [anon_sym___alignof__] = ACTIONS(3497),
    [anon_sym___alignof] = ACTIONS(3497),
    [anon_sym__alignof] = ACTIONS(3497),
    [anon_sym_alignof] = ACTIONS(3497),
    [anon_sym__Alignof] = ACTIONS(3497),
    [anon_sym_offsetof] = ACTIONS(3497),
    [anon_sym__Generic] = ACTIONS(3497),
    [anon_sym_asm] = ACTIONS(3497),
    [anon_sym___asm__] = ACTIONS(3497),
    [sym_number_literal] = ACTIONS(3499),
    [anon_sym_L_SQUOTE] = ACTIONS(3499),
    [anon_sym_u_SQUOTE] = ACTIONS(3499),
    [anon_sym_U_SQUOTE] = ACTIONS(3499),
    [anon_sym_u8_SQUOTE] = ACTIONS(3499),
    [anon_sym_SQUOTE] = ACTIONS(3499),
    [anon_sym_L_DQUOTE] = ACTIONS(3499),
    [anon_sym_u_DQUOTE] = ACTIONS(3499),
    [anon_sym_U_DQUOTE] = ACTIONS(3499),
    [anon_sym_u8_DQUOTE] = ACTIONS(3499),
    [anon_sym_DQUOTE] = ACTIONS(3499),
    [sym_true] = ACTIONS(3497),
    [sym_false] = ACTIONS(3497),
    [anon_sym_NULL] = ACTIONS(3497),
    [anon_sym_nullptr] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3497),
    [anon_sym_let] = ACTIONS(3497),
    [anon_sym_This] = ACTIONS(3497),
    [anon_sym_decltype] = ACTIONS(3497),
    [sym_virtual] = ACTIONS(3497),
    [anon_sym_explicit] = ACTIONS(3497),
    [anon_sym_typename] = ACTIONS(3497),
    [anon_sym_template] = ACTIONS(3497),
    [anon_sym_operator] = ACTIONS(3497),
    [anon_sym_try] = ACTIONS(3497),
    [anon_sym_delete] = ACTIONS(3497),
    [anon_sym_throw] = ACTIONS(3497),
    [anon_sym_namespace] = ACTIONS(3497),
    [anon_sym_using] = ACTIONS(3497),
    [anon_sym_static_assert] = ACTIONS(3497),
    [anon_sym_concept] = ACTIONS(3497),
    [anon_sym_co_return] = ACTIONS(3497),
    [anon_sym_co_yield] = ACTIONS(3497),
    [anon_sym_R_DQUOTE] = ACTIONS(3499),
    [anon_sym_LR_DQUOTE] = ACTIONS(3499),
    [anon_sym_uR_DQUOTE] = ACTIONS(3499),
    [anon_sym_UR_DQUOTE] = ACTIONS(3499),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3499),
    [anon_sym_co_await] = ACTIONS(3497),
    [anon_sym_new] = ACTIONS(3497),
    [anon_sym_requires] = ACTIONS(3497),
    [sym_this] = ACTIONS(3497),
    [anon_sym_discard] = ACTIONS(3497),
    [anon_sym_precise] = ACTIONS(3497),
    [anon_sym_shared] = ACTIONS(3497),
    [anon_sym_groupshared] = ACTIONS(3497),
    [anon_sym_uniform] = ACTIONS(3497),
    [anon_sym_row_major] = ACTIONS(3497),
    [anon_sym_column_major] = ACTIONS(3497),
    [anon_sym_globallycoherent] = ACTIONS(3497),
    [anon_sym_centroid] = ACTIONS(3497),
    [anon_sym_noperspective] = ACTIONS(3497),
    [anon_sym_nointerpolation] = ACTIONS(3497),
    [anon_sym_sample] = ACTIONS(3497),
    [anon_sym_linear] = ACTIONS(3497),
    [anon_sym_snorm] = ACTIONS(3497),
    [anon_sym_unorm] = ACTIONS(3497),
    [anon_sym_point] = ACTIONS(3497),
    [anon_sym_line] = ACTIONS(3497),
    [anon_sym_triangleadj] = ACTIONS(3497),
    [anon_sym_lineadj] = ACTIONS(3497),
    [anon_sym_triangle] = ACTIONS(3497),
    [anon_sym_cbuffer] = ACTIONS(3497),
    [anon_sym_interface] = ACTIONS(3497),
    [anon_sym_extension] = ACTIONS(3497),
  },
  [470] = {
    [sym_identifier] = ACTIONS(3501),
    [aux_sym_preproc_include_token1] = ACTIONS(3501),
    [aux_sym_preproc_def_token1] = ACTIONS(3501),
    [aux_sym_preproc_if_token1] = ACTIONS(3501),
    [aux_sym_preproc_if_token2] = ACTIONS(3501),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3501),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3501),
    [aux_sym_preproc_else_token1] = ACTIONS(3501),
    [aux_sym_preproc_elif_token1] = ACTIONS(3501),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3501),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3501),
    [sym_preproc_directive] = ACTIONS(3501),
    [anon_sym_LPAREN2] = ACTIONS(3503),
    [anon_sym_BANG] = ACTIONS(3503),
    [anon_sym_TILDE] = ACTIONS(3503),
    [anon_sym_DASH] = ACTIONS(3501),
    [anon_sym_PLUS] = ACTIONS(3501),
    [anon_sym_STAR] = ACTIONS(3503),
    [anon_sym_AMP_AMP] = ACTIONS(3503),
    [anon_sym_AMP] = ACTIONS(3501),
    [anon_sym_SEMI] = ACTIONS(3503),
    [anon_sym___extension__] = ACTIONS(3501),
    [anon_sym_typedef] = ACTIONS(3501),
    [anon_sym_in] = ACTIONS(3501),
    [anon_sym_out] = ACTIONS(3501),
    [anon_sym_inout] = ACTIONS(3501),
    [anon_sym_extern] = ACTIONS(3501),
    [anon_sym___attribute__] = ACTIONS(3501),
    [anon_sym_COLON_COLON] = ACTIONS(3503),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3503),
    [anon_sym___declspec] = ACTIONS(3501),
    [anon_sym___based] = ACTIONS(3501),
    [anon_sym___cdecl] = ACTIONS(3501),
    [anon_sym___clrcall] = ACTIONS(3501),
    [anon_sym___stdcall] = ACTIONS(3501),
    [anon_sym___fastcall] = ACTIONS(3501),
    [anon_sym___thiscall] = ACTIONS(3501),
    [anon_sym___vectorcall] = ACTIONS(3501),
    [anon_sym_LBRACE] = ACTIONS(3503),
    [anon_sym_signed] = ACTIONS(3501),
    [anon_sym_unsigned] = ACTIONS(3501),
    [anon_sym_long] = ACTIONS(3501),
    [anon_sym_short] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(3501),
    [anon_sym_static] = ACTIONS(3501),
    [anon_sym_register] = ACTIONS(3501),
    [anon_sym_inline] = ACTIONS(3501),
    [anon_sym___inline] = ACTIONS(3501),
    [anon_sym___inline__] = ACTIONS(3501),
    [anon_sym___forceinline] = ACTIONS(3501),
    [anon_sym_thread_local] = ACTIONS(3501),
    [anon_sym___thread] = ACTIONS(3501),
    [anon_sym_const] = ACTIONS(3501),
    [anon_sym_constexpr] = ACTIONS(3501),
    [anon_sym_volatile] = ACTIONS(3501),
    [anon_sym_restrict] = ACTIONS(3501),
    [anon_sym___restrict__] = ACTIONS(3501),
    [anon_sym__Atomic] = ACTIONS(3501),
    [anon_sym__Noreturn] = ACTIONS(3501),
    [anon_sym_noreturn] = ACTIONS(3501),
    [anon_sym_mutable] = ACTIONS(3501),
    [anon_sym_constinit] = ACTIONS(3501),
    [anon_sym_consteval] = ACTIONS(3501),
    [anon_sym_alignas] = ACTIONS(3501),
    [anon_sym__Alignas] = ACTIONS(3501),
    [sym_primitive_type] = ACTIONS(3501),
    [anon_sym_enum] = ACTIONS(3501),
    [anon_sym_class] = ACTIONS(3501),
    [anon_sym_struct] = ACTIONS(3501),
    [anon_sym_union] = ACTIONS(3501),
    [anon_sym_if] = ACTIONS(3501),
    [anon_sym_switch] = ACTIONS(3501),
    [anon_sym_case] = ACTIONS(3501),
    [anon_sym_default] = ACTIONS(3501),
    [anon_sym_while] = ACTIONS(3501),
    [anon_sym_do] = ACTIONS(3501),
    [anon_sym_for] = ACTIONS(3501),
    [anon_sym_return] = ACTIONS(3501),
    [anon_sym_break] = ACTIONS(3501),
    [anon_sym_continue] = ACTIONS(3501),
    [anon_sym_goto] = ACTIONS(3501),
    [anon_sym___try] = ACTIONS(3501),
    [anon_sym___leave] = ACTIONS(3501),
    [anon_sym_not] = ACTIONS(3501),
    [anon_sym_compl] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(3503),
    [anon_sym_PLUS_PLUS] = ACTIONS(3503),
    [anon_sym_sizeof] = ACTIONS(3501),
    [anon_sym___alignof__] = ACTIONS(3501),
    [anon_sym___alignof] = ACTIONS(3501),
    [anon_sym__alignof] = ACTIONS(3501),
    [anon_sym_alignof] = ACTIONS(3501),
    [anon_sym__Alignof] = ACTIONS(3501),
    [anon_sym_offsetof] = ACTIONS(3501),
    [anon_sym__Generic] = ACTIONS(3501),
    [anon_sym_asm] = ACTIONS(3501),
    [anon_sym___asm__] = ACTIONS(3501),
    [sym_number_literal] = ACTIONS(3503),
    [anon_sym_L_SQUOTE] = ACTIONS(3503),
    [anon_sym_u_SQUOTE] = ACTIONS(3503),
    [anon_sym_U_SQUOTE] = ACTIONS(3503),
    [anon_sym_u8_SQUOTE] = ACTIONS(3503),
    [anon_sym_SQUOTE] = ACTIONS(3503),
    [anon_sym_L_DQUOTE] = ACTIONS(3503),
    [anon_sym_u_DQUOTE] = ACTIONS(3503),
    [anon_sym_U_DQUOTE] = ACTIONS(3503),
    [anon_sym_u8_DQUOTE] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3503),
    [sym_true] = ACTIONS(3501),
    [sym_false] = ACTIONS(3501),
    [anon_sym_NULL] = ACTIONS(3501),
    [anon_sym_nullptr] = ACTIONS(3501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3501),
    [anon_sym_let] = ACTIONS(3501),
    [anon_sym_This] = ACTIONS(3501),
    [anon_sym_decltype] = ACTIONS(3501),
    [sym_virtual] = ACTIONS(3501),
    [anon_sym_explicit] = ACTIONS(3501),
    [anon_sym_typename] = ACTIONS(3501),
    [anon_sym_template] = ACTIONS(3501),
    [anon_sym_operator] = ACTIONS(3501),
    [anon_sym_try] = ACTIONS(3501),
    [anon_sym_delete] = ACTIONS(3501),
    [anon_sym_throw] = ACTIONS(3501),
    [anon_sym_namespace] = ACTIONS(3501),
    [anon_sym_using] = ACTIONS(3501),
    [anon_sym_static_assert] = ACTIONS(3501),
    [anon_sym_concept] = ACTIONS(3501),
    [anon_sym_co_return] = ACTIONS(3501),
    [anon_sym_co_yield] = ACTIONS(3501),
    [anon_sym_R_DQUOTE] = ACTIONS(3503),
    [anon_sym_LR_DQUOTE] = ACTIONS(3503),
    [anon_sym_uR_DQUOTE] = ACTIONS(3503),
    [anon_sym_UR_DQUOTE] = ACTIONS(3503),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3503),
    [anon_sym_co_await] = ACTIONS(3501),
    [anon_sym_new] = ACTIONS(3501),
    [anon_sym_requires] = ACTIONS(3501),
    [sym_this] = ACTIONS(3501),
    [anon_sym_discard] = ACTIONS(3501),
    [anon_sym_precise] = ACTIONS(3501),
    [anon_sym_shared] = ACTIONS(3501),
    [anon_sym_groupshared] = ACTIONS(3501),
    [anon_sym_uniform] = ACTIONS(3501),
    [anon_sym_row_major] = ACTIONS(3501),
    [anon_sym_column_major] = ACTIONS(3501),
    [anon_sym_globallycoherent] = ACTIONS(3501),
    [anon_sym_centroid] = ACTIONS(3501),
    [anon_sym_noperspective] = ACTIONS(3501),
    [anon_sym_nointerpolation] = ACTIONS(3501),
    [anon_sym_sample] = ACTIONS(3501),
    [anon_sym_linear] = ACTIONS(3501),
    [anon_sym_snorm] = ACTIONS(3501),
    [anon_sym_unorm] = ACTIONS(3501),
    [anon_sym_point] = ACTIONS(3501),
    [anon_sym_line] = ACTIONS(3501),
    [anon_sym_triangleadj] = ACTIONS(3501),
    [anon_sym_lineadj] = ACTIONS(3501),
    [anon_sym_triangle] = ACTIONS(3501),
    [anon_sym_cbuffer] = ACTIONS(3501),
    [anon_sym_interface] = ACTIONS(3501),
    [anon_sym_extension] = ACTIONS(3501),
  },
  [471] = {
    [sym_identifier] = ACTIONS(3505),
    [aux_sym_preproc_include_token1] = ACTIONS(3505),
    [aux_sym_preproc_def_token1] = ACTIONS(3505),
    [aux_sym_preproc_if_token1] = ACTIONS(3505),
    [aux_sym_preproc_if_token2] = ACTIONS(3505),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3505),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3505),
    [aux_sym_preproc_else_token1] = ACTIONS(3505),
    [aux_sym_preproc_elif_token1] = ACTIONS(3505),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3505),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3505),
    [sym_preproc_directive] = ACTIONS(3505),
    [anon_sym_LPAREN2] = ACTIONS(3507),
    [anon_sym_BANG] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3505),
    [anon_sym_PLUS] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3507),
    [anon_sym___extension__] = ACTIONS(3505),
    [anon_sym_typedef] = ACTIONS(3505),
    [anon_sym_in] = ACTIONS(3505),
    [anon_sym_out] = ACTIONS(3505),
    [anon_sym_inout] = ACTIONS(3505),
    [anon_sym_extern] = ACTIONS(3505),
    [anon_sym___attribute__] = ACTIONS(3505),
    [anon_sym_COLON_COLON] = ACTIONS(3507),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3507),
    [anon_sym___declspec] = ACTIONS(3505),
    [anon_sym___based] = ACTIONS(3505),
    [anon_sym___cdecl] = ACTIONS(3505),
    [anon_sym___clrcall] = ACTIONS(3505),
    [anon_sym___stdcall] = ACTIONS(3505),
    [anon_sym___fastcall] = ACTIONS(3505),
    [anon_sym___thiscall] = ACTIONS(3505),
    [anon_sym___vectorcall] = ACTIONS(3505),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_signed] = ACTIONS(3505),
    [anon_sym_unsigned] = ACTIONS(3505),
    [anon_sym_long] = ACTIONS(3505),
    [anon_sym_short] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_static] = ACTIONS(3505),
    [anon_sym_register] = ACTIONS(3505),
    [anon_sym_inline] = ACTIONS(3505),
    [anon_sym___inline] = ACTIONS(3505),
    [anon_sym___inline__] = ACTIONS(3505),
    [anon_sym___forceinline] = ACTIONS(3505),
    [anon_sym_thread_local] = ACTIONS(3505),
    [anon_sym___thread] = ACTIONS(3505),
    [anon_sym_const] = ACTIONS(3505),
    [anon_sym_constexpr] = ACTIONS(3505),
    [anon_sym_volatile] = ACTIONS(3505),
    [anon_sym_restrict] = ACTIONS(3505),
    [anon_sym___restrict__] = ACTIONS(3505),
    [anon_sym__Atomic] = ACTIONS(3505),
    [anon_sym__Noreturn] = ACTIONS(3505),
    [anon_sym_noreturn] = ACTIONS(3505),
    [anon_sym_mutable] = ACTIONS(3505),
    [anon_sym_constinit] = ACTIONS(3505),
    [anon_sym_consteval] = ACTIONS(3505),
    [anon_sym_alignas] = ACTIONS(3505),
    [anon_sym__Alignas] = ACTIONS(3505),
    [sym_primitive_type] = ACTIONS(3505),
    [anon_sym_enum] = ACTIONS(3505),
    [anon_sym_class] = ACTIONS(3505),
    [anon_sym_struct] = ACTIONS(3505),
    [anon_sym_union] = ACTIONS(3505),
    [anon_sym_if] = ACTIONS(3505),
    [anon_sym_switch] = ACTIONS(3505),
    [anon_sym_case] = ACTIONS(3505),
    [anon_sym_default] = ACTIONS(3505),
    [anon_sym_while] = ACTIONS(3505),
    [anon_sym_do] = ACTIONS(3505),
    [anon_sym_for] = ACTIONS(3505),
    [anon_sym_return] = ACTIONS(3505),
    [anon_sym_break] = ACTIONS(3505),
    [anon_sym_continue] = ACTIONS(3505),
    [anon_sym_goto] = ACTIONS(3505),
    [anon_sym___try] = ACTIONS(3505),
    [anon_sym___leave] = ACTIONS(3505),
    [anon_sym_not] = ACTIONS(3505),
    [anon_sym_compl] = ACTIONS(3505),
    [anon_sym_DASH_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_PLUS] = ACTIONS(3507),
    [anon_sym_sizeof] = ACTIONS(3505),
    [anon_sym___alignof__] = ACTIONS(3505),
    [anon_sym___alignof] = ACTIONS(3505),
    [anon_sym__alignof] = ACTIONS(3505),
    [anon_sym_alignof] = ACTIONS(3505),
    [anon_sym__Alignof] = ACTIONS(3505),
    [anon_sym_offsetof] = ACTIONS(3505),
    [anon_sym__Generic] = ACTIONS(3505),
    [anon_sym_asm] = ACTIONS(3505),
    [anon_sym___asm__] = ACTIONS(3505),
    [sym_number_literal] = ACTIONS(3507),
    [anon_sym_L_SQUOTE] = ACTIONS(3507),
    [anon_sym_u_SQUOTE] = ACTIONS(3507),
    [anon_sym_U_SQUOTE] = ACTIONS(3507),
    [anon_sym_u8_SQUOTE] = ACTIONS(3507),
    [anon_sym_SQUOTE] = ACTIONS(3507),
    [anon_sym_L_DQUOTE] = ACTIONS(3507),
    [anon_sym_u_DQUOTE] = ACTIONS(3507),
    [anon_sym_U_DQUOTE] = ACTIONS(3507),
    [anon_sym_u8_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [sym_true] = ACTIONS(3505),
    [sym_false] = ACTIONS(3505),
    [anon_sym_NULL] = ACTIONS(3505),
    [anon_sym_nullptr] = ACTIONS(3505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_This] = ACTIONS(3505),
    [anon_sym_decltype] = ACTIONS(3505),
    [sym_virtual] = ACTIONS(3505),
    [anon_sym_explicit] = ACTIONS(3505),
    [anon_sym_typename] = ACTIONS(3505),
    [anon_sym_template] = ACTIONS(3505),
    [anon_sym_operator] = ACTIONS(3505),
    [anon_sym_try] = ACTIONS(3505),
    [anon_sym_delete] = ACTIONS(3505),
    [anon_sym_throw] = ACTIONS(3505),
    [anon_sym_namespace] = ACTIONS(3505),
    [anon_sym_using] = ACTIONS(3505),
    [anon_sym_static_assert] = ACTIONS(3505),
    [anon_sym_concept] = ACTIONS(3505),
    [anon_sym_co_return] = ACTIONS(3505),
    [anon_sym_co_yield] = ACTIONS(3505),
    [anon_sym_R_DQUOTE] = ACTIONS(3507),
    [anon_sym_LR_DQUOTE] = ACTIONS(3507),
    [anon_sym_uR_DQUOTE] = ACTIONS(3507),
    [anon_sym_UR_DQUOTE] = ACTIONS(3507),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3507),
    [anon_sym_co_await] = ACTIONS(3505),
    [anon_sym_new] = ACTIONS(3505),
    [anon_sym_requires] = ACTIONS(3505),
    [sym_this] = ACTIONS(3505),
    [anon_sym_discard] = ACTIONS(3505),
    [anon_sym_precise] = ACTIONS(3505),
    [anon_sym_shared] = ACTIONS(3505),
    [anon_sym_groupshared] = ACTIONS(3505),
    [anon_sym_uniform] = ACTIONS(3505),
    [anon_sym_row_major] = ACTIONS(3505),
    [anon_sym_column_major] = ACTIONS(3505),
    [anon_sym_globallycoherent] = ACTIONS(3505),
    [anon_sym_centroid] = ACTIONS(3505),
    [anon_sym_noperspective] = ACTIONS(3505),
    [anon_sym_nointerpolation] = ACTIONS(3505),
    [anon_sym_sample] = ACTIONS(3505),
    [anon_sym_linear] = ACTIONS(3505),
    [anon_sym_snorm] = ACTIONS(3505),
    [anon_sym_unorm] = ACTIONS(3505),
    [anon_sym_point] = ACTIONS(3505),
    [anon_sym_line] = ACTIONS(3505),
    [anon_sym_triangleadj] = ACTIONS(3505),
    [anon_sym_lineadj] = ACTIONS(3505),
    [anon_sym_triangle] = ACTIONS(3505),
    [anon_sym_cbuffer] = ACTIONS(3505),
    [anon_sym_interface] = ACTIONS(3505),
    [anon_sym_extension] = ACTIONS(3505),
  },
  [472] = {
    [sym_identifier] = ACTIONS(3509),
    [aux_sym_preproc_include_token1] = ACTIONS(3509),
    [aux_sym_preproc_def_token1] = ACTIONS(3509),
    [aux_sym_preproc_if_token1] = ACTIONS(3509),
    [aux_sym_preproc_if_token2] = ACTIONS(3509),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3509),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3509),
    [aux_sym_preproc_else_token1] = ACTIONS(3509),
    [aux_sym_preproc_elif_token1] = ACTIONS(3509),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3509),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3509),
    [sym_preproc_directive] = ACTIONS(3509),
    [anon_sym_LPAREN2] = ACTIONS(3511),
    [anon_sym_BANG] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3509),
    [anon_sym_PLUS] = ACTIONS(3509),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3511),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_SEMI] = ACTIONS(3511),
    [anon_sym___extension__] = ACTIONS(3509),
    [anon_sym_typedef] = ACTIONS(3509),
    [anon_sym_in] = ACTIONS(3509),
    [anon_sym_out] = ACTIONS(3509),
    [anon_sym_inout] = ACTIONS(3509),
    [anon_sym_extern] = ACTIONS(3509),
    [anon_sym___attribute__] = ACTIONS(3509),
    [anon_sym_COLON_COLON] = ACTIONS(3511),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3511),
    [anon_sym___declspec] = ACTIONS(3509),
    [anon_sym___based] = ACTIONS(3509),
    [anon_sym___cdecl] = ACTIONS(3509),
    [anon_sym___clrcall] = ACTIONS(3509),
    [anon_sym___stdcall] = ACTIONS(3509),
    [anon_sym___fastcall] = ACTIONS(3509),
    [anon_sym___thiscall] = ACTIONS(3509),
    [anon_sym___vectorcall] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_signed] = ACTIONS(3509),
    [anon_sym_unsigned] = ACTIONS(3509),
    [anon_sym_long] = ACTIONS(3509),
    [anon_sym_short] = ACTIONS(3509),
    [anon_sym_LBRACK] = ACTIONS(3509),
    [anon_sym_static] = ACTIONS(3509),
    [anon_sym_register] = ACTIONS(3509),
    [anon_sym_inline] = ACTIONS(3509),
    [anon_sym___inline] = ACTIONS(3509),
    [anon_sym___inline__] = ACTIONS(3509),
    [anon_sym___forceinline] = ACTIONS(3509),
    [anon_sym_thread_local] = ACTIONS(3509),
    [anon_sym___thread] = ACTIONS(3509),
    [anon_sym_const] = ACTIONS(3509),
    [anon_sym_constexpr] = ACTIONS(3509),
    [anon_sym_volatile] = ACTIONS(3509),
    [anon_sym_restrict] = ACTIONS(3509),
    [anon_sym___restrict__] = ACTIONS(3509),
    [anon_sym__Atomic] = ACTIONS(3509),
    [anon_sym__Noreturn] = ACTIONS(3509),
    [anon_sym_noreturn] = ACTIONS(3509),
    [anon_sym_mutable] = ACTIONS(3509),
    [anon_sym_constinit] = ACTIONS(3509),
    [anon_sym_consteval] = ACTIONS(3509),
    [anon_sym_alignas] = ACTIONS(3509),
    [anon_sym__Alignas] = ACTIONS(3509),
    [sym_primitive_type] = ACTIONS(3509),
    [anon_sym_enum] = ACTIONS(3509),
    [anon_sym_class] = ACTIONS(3509),
    [anon_sym_struct] = ACTIONS(3509),
    [anon_sym_union] = ACTIONS(3509),
    [anon_sym_if] = ACTIONS(3509),
    [anon_sym_switch] = ACTIONS(3509),
    [anon_sym_case] = ACTIONS(3509),
    [anon_sym_default] = ACTIONS(3509),
    [anon_sym_while] = ACTIONS(3509),
    [anon_sym_do] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3509),
    [anon_sym_return] = ACTIONS(3509),
    [anon_sym_break] = ACTIONS(3509),
    [anon_sym_continue] = ACTIONS(3509),
    [anon_sym_goto] = ACTIONS(3509),
    [anon_sym___try] = ACTIONS(3509),
    [anon_sym___leave] = ACTIONS(3509),
    [anon_sym_not] = ACTIONS(3509),
    [anon_sym_compl] = ACTIONS(3509),
    [anon_sym_DASH_DASH] = ACTIONS(3511),
    [anon_sym_PLUS_PLUS] = ACTIONS(3511),
    [anon_sym_sizeof] = ACTIONS(3509),
    [anon_sym___alignof__] = ACTIONS(3509),
    [anon_sym___alignof] = ACTIONS(3509),
    [anon_sym__alignof] = ACTIONS(3509),
    [anon_sym_alignof] = ACTIONS(3509),
    [anon_sym__Alignof] = ACTIONS(3509),
    [anon_sym_offsetof] = ACTIONS(3509),
    [anon_sym__Generic] = ACTIONS(3509),
    [anon_sym_asm] = ACTIONS(3509),
    [anon_sym___asm__] = ACTIONS(3509),
    [sym_number_literal] = ACTIONS(3511),
    [anon_sym_L_SQUOTE] = ACTIONS(3511),
    [anon_sym_u_SQUOTE] = ACTIONS(3511),
    [anon_sym_U_SQUOTE] = ACTIONS(3511),
    [anon_sym_u8_SQUOTE] = ACTIONS(3511),
    [anon_sym_SQUOTE] = ACTIONS(3511),
    [anon_sym_L_DQUOTE] = ACTIONS(3511),
    [anon_sym_u_DQUOTE] = ACTIONS(3511),
    [anon_sym_U_DQUOTE] = ACTIONS(3511),
    [anon_sym_u8_DQUOTE] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [sym_true] = ACTIONS(3509),
    [sym_false] = ACTIONS(3509),
    [anon_sym_NULL] = ACTIONS(3509),
    [anon_sym_nullptr] = ACTIONS(3509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3509),
    [anon_sym_let] = ACTIONS(3509),
    [anon_sym_This] = ACTIONS(3509),
    [anon_sym_decltype] = ACTIONS(3509),
    [sym_virtual] = ACTIONS(3509),
    [anon_sym_explicit] = ACTIONS(3509),
    [anon_sym_typename] = ACTIONS(3509),
    [anon_sym_template] = ACTIONS(3509),
    [anon_sym_operator] = ACTIONS(3509),
    [anon_sym_try] = ACTIONS(3509),
    [anon_sym_delete] = ACTIONS(3509),
    [anon_sym_throw] = ACTIONS(3509),
    [anon_sym_namespace] = ACTIONS(3509),
    [anon_sym_using] = ACTIONS(3509),
    [anon_sym_static_assert] = ACTIONS(3509),
    [anon_sym_concept] = ACTIONS(3509),
    [anon_sym_co_return] = ACTIONS(3509),
    [anon_sym_co_yield] = ACTIONS(3509),
    [anon_sym_R_DQUOTE] = ACTIONS(3511),
    [anon_sym_LR_DQUOTE] = ACTIONS(3511),
    [anon_sym_uR_DQUOTE] = ACTIONS(3511),
    [anon_sym_UR_DQUOTE] = ACTIONS(3511),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3511),
    [anon_sym_co_await] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3509),
    [anon_sym_requires] = ACTIONS(3509),
    [sym_this] = ACTIONS(3509),
    [anon_sym_discard] = ACTIONS(3509),
    [anon_sym_precise] = ACTIONS(3509),
    [anon_sym_shared] = ACTIONS(3509),
    [anon_sym_groupshared] = ACTIONS(3509),
    [anon_sym_uniform] = ACTIONS(3509),
    [anon_sym_row_major] = ACTIONS(3509),
    [anon_sym_column_major] = ACTIONS(3509),
    [anon_sym_globallycoherent] = ACTIONS(3509),
    [anon_sym_centroid] = ACTIONS(3509),
    [anon_sym_noperspective] = ACTIONS(3509),
    [anon_sym_nointerpolation] = ACTIONS(3509),
    [anon_sym_sample] = ACTIONS(3509),
    [anon_sym_linear] = ACTIONS(3509),
    [anon_sym_snorm] = ACTIONS(3509),
    [anon_sym_unorm] = ACTIONS(3509),
    [anon_sym_point] = ACTIONS(3509),
    [anon_sym_line] = ACTIONS(3509),
    [anon_sym_triangleadj] = ACTIONS(3509),
    [anon_sym_lineadj] = ACTIONS(3509),
    [anon_sym_triangle] = ACTIONS(3509),
    [anon_sym_cbuffer] = ACTIONS(3509),
    [anon_sym_interface] = ACTIONS(3509),
    [anon_sym_extension] = ACTIONS(3509),
  },
  [473] = {
    [sym_identifier] = ACTIONS(3513),
    [aux_sym_preproc_include_token1] = ACTIONS(3513),
    [aux_sym_preproc_def_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token2] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3513),
    [aux_sym_preproc_else_token1] = ACTIONS(3513),
    [aux_sym_preproc_elif_token1] = ACTIONS(3513),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3513),
    [sym_preproc_directive] = ACTIONS(3513),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_BANG] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3513),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3513),
    [anon_sym_SEMI] = ACTIONS(3515),
    [anon_sym___extension__] = ACTIONS(3513),
    [anon_sym_typedef] = ACTIONS(3513),
    [anon_sym_in] = ACTIONS(3513),
    [anon_sym_out] = ACTIONS(3513),
    [anon_sym_inout] = ACTIONS(3513),
    [anon_sym_extern] = ACTIONS(3513),
    [anon_sym___attribute__] = ACTIONS(3513),
    [anon_sym_COLON_COLON] = ACTIONS(3515),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3515),
    [anon_sym___declspec] = ACTIONS(3513),
    [anon_sym___based] = ACTIONS(3513),
    [anon_sym___cdecl] = ACTIONS(3513),
    [anon_sym___clrcall] = ACTIONS(3513),
    [anon_sym___stdcall] = ACTIONS(3513),
    [anon_sym___fastcall] = ACTIONS(3513),
    [anon_sym___thiscall] = ACTIONS(3513),
    [anon_sym___vectorcall] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_signed] = ACTIONS(3513),
    [anon_sym_unsigned] = ACTIONS(3513),
    [anon_sym_long] = ACTIONS(3513),
    [anon_sym_short] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_register] = ACTIONS(3513),
    [anon_sym_inline] = ACTIONS(3513),
    [anon_sym___inline] = ACTIONS(3513),
    [anon_sym___inline__] = ACTIONS(3513),
    [anon_sym___forceinline] = ACTIONS(3513),
    [anon_sym_thread_local] = ACTIONS(3513),
    [anon_sym___thread] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [anon_sym_constexpr] = ACTIONS(3513),
    [anon_sym_volatile] = ACTIONS(3513),
    [anon_sym_restrict] = ACTIONS(3513),
    [anon_sym___restrict__] = ACTIONS(3513),
    [anon_sym__Atomic] = ACTIONS(3513),
    [anon_sym__Noreturn] = ACTIONS(3513),
    [anon_sym_noreturn] = ACTIONS(3513),
    [anon_sym_mutable] = ACTIONS(3513),
    [anon_sym_constinit] = ACTIONS(3513),
    [anon_sym_consteval] = ACTIONS(3513),
    [anon_sym_alignas] = ACTIONS(3513),
    [anon_sym__Alignas] = ACTIONS(3513),
    [sym_primitive_type] = ACTIONS(3513),
    [anon_sym_enum] = ACTIONS(3513),
    [anon_sym_class] = ACTIONS(3513),
    [anon_sym_struct] = ACTIONS(3513),
    [anon_sym_union] = ACTIONS(3513),
    [anon_sym_if] = ACTIONS(3513),
    [anon_sym_switch] = ACTIONS(3513),
    [anon_sym_case] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3513),
    [anon_sym_while] = ACTIONS(3513),
    [anon_sym_do] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3513),
    [anon_sym_return] = ACTIONS(3513),
    [anon_sym_break] = ACTIONS(3513),
    [anon_sym_continue] = ACTIONS(3513),
    [anon_sym_goto] = ACTIONS(3513),
    [anon_sym___try] = ACTIONS(3513),
    [anon_sym___leave] = ACTIONS(3513),
    [anon_sym_not] = ACTIONS(3513),
    [anon_sym_compl] = ACTIONS(3513),
    [anon_sym_DASH_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_PLUS] = ACTIONS(3515),
    [anon_sym_sizeof] = ACTIONS(3513),
    [anon_sym___alignof__] = ACTIONS(3513),
    [anon_sym___alignof] = ACTIONS(3513),
    [anon_sym__alignof] = ACTIONS(3513),
    [anon_sym_alignof] = ACTIONS(3513),
    [anon_sym__Alignof] = ACTIONS(3513),
    [anon_sym_offsetof] = ACTIONS(3513),
    [anon_sym__Generic] = ACTIONS(3513),
    [anon_sym_asm] = ACTIONS(3513),
    [anon_sym___asm__] = ACTIONS(3513),
    [sym_number_literal] = ACTIONS(3515),
    [anon_sym_L_SQUOTE] = ACTIONS(3515),
    [anon_sym_u_SQUOTE] = ACTIONS(3515),
    [anon_sym_U_SQUOTE] = ACTIONS(3515),
    [anon_sym_u8_SQUOTE] = ACTIONS(3515),
    [anon_sym_SQUOTE] = ACTIONS(3515),
    [anon_sym_L_DQUOTE] = ACTIONS(3515),
    [anon_sym_u_DQUOTE] = ACTIONS(3515),
    [anon_sym_U_DQUOTE] = ACTIONS(3515),
    [anon_sym_u8_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [sym_true] = ACTIONS(3513),
    [sym_false] = ACTIONS(3513),
    [anon_sym_NULL] = ACTIONS(3513),
    [anon_sym_nullptr] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3513),
    [anon_sym_let] = ACTIONS(3513),
    [anon_sym_This] = ACTIONS(3513),
    [anon_sym_decltype] = ACTIONS(3513),
    [sym_virtual] = ACTIONS(3513),
    [anon_sym_explicit] = ACTIONS(3513),
    [anon_sym_typename] = ACTIONS(3513),
    [anon_sym_template] = ACTIONS(3513),
    [anon_sym_operator] = ACTIONS(3513),
    [anon_sym_try] = ACTIONS(3513),
    [anon_sym_delete] = ACTIONS(3513),
    [anon_sym_throw] = ACTIONS(3513),
    [anon_sym_namespace] = ACTIONS(3513),
    [anon_sym_using] = ACTIONS(3513),
    [anon_sym_static_assert] = ACTIONS(3513),
    [anon_sym_concept] = ACTIONS(3513),
    [anon_sym_co_return] = ACTIONS(3513),
    [anon_sym_co_yield] = ACTIONS(3513),
    [anon_sym_R_DQUOTE] = ACTIONS(3515),
    [anon_sym_LR_DQUOTE] = ACTIONS(3515),
    [anon_sym_uR_DQUOTE] = ACTIONS(3515),
    [anon_sym_UR_DQUOTE] = ACTIONS(3515),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3515),
    [anon_sym_co_await] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3513),
    [anon_sym_requires] = ACTIONS(3513),
    [sym_this] = ACTIONS(3513),
    [anon_sym_discard] = ACTIONS(3513),
    [anon_sym_precise] = ACTIONS(3513),
    [anon_sym_shared] = ACTIONS(3513),
    [anon_sym_groupshared] = ACTIONS(3513),
    [anon_sym_uniform] = ACTIONS(3513),
    [anon_sym_row_major] = ACTIONS(3513),
    [anon_sym_column_major] = ACTIONS(3513),
    [anon_sym_globallycoherent] = ACTIONS(3513),
    [anon_sym_centroid] = ACTIONS(3513),
    [anon_sym_noperspective] = ACTIONS(3513),
    [anon_sym_nointerpolation] = ACTIONS(3513),
    [anon_sym_sample] = ACTIONS(3513),
    [anon_sym_linear] = ACTIONS(3513),
    [anon_sym_snorm] = ACTIONS(3513),
    [anon_sym_unorm] = ACTIONS(3513),
    [anon_sym_point] = ACTIONS(3513),
    [anon_sym_line] = ACTIONS(3513),
    [anon_sym_triangleadj] = ACTIONS(3513),
    [anon_sym_lineadj] = ACTIONS(3513),
    [anon_sym_triangle] = ACTIONS(3513),
    [anon_sym_cbuffer] = ACTIONS(3513),
    [anon_sym_interface] = ACTIONS(3513),
    [anon_sym_extension] = ACTIONS(3513),
  },
  [474] = {
    [sym_identifier] = ACTIONS(3517),
    [aux_sym_preproc_include_token1] = ACTIONS(3517),
    [aux_sym_preproc_def_token1] = ACTIONS(3517),
    [aux_sym_preproc_if_token1] = ACTIONS(3517),
    [aux_sym_preproc_if_token2] = ACTIONS(3517),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3517),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3517),
    [aux_sym_preproc_else_token1] = ACTIONS(3517),
    [aux_sym_preproc_elif_token1] = ACTIONS(3517),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3517),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3517),
    [sym_preproc_directive] = ACTIONS(3517),
    [anon_sym_LPAREN2] = ACTIONS(3519),
    [anon_sym_BANG] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3517),
    [anon_sym_PLUS] = ACTIONS(3517),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym_SEMI] = ACTIONS(3519),
    [anon_sym___extension__] = ACTIONS(3517),
    [anon_sym_typedef] = ACTIONS(3517),
    [anon_sym_in] = ACTIONS(3517),
    [anon_sym_out] = ACTIONS(3517),
    [anon_sym_inout] = ACTIONS(3517),
    [anon_sym_extern] = ACTIONS(3517),
    [anon_sym___attribute__] = ACTIONS(3517),
    [anon_sym_COLON_COLON] = ACTIONS(3519),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3519),
    [anon_sym___declspec] = ACTIONS(3517),
    [anon_sym___based] = ACTIONS(3517),
    [anon_sym___cdecl] = ACTIONS(3517),
    [anon_sym___clrcall] = ACTIONS(3517),
    [anon_sym___stdcall] = ACTIONS(3517),
    [anon_sym___fastcall] = ACTIONS(3517),
    [anon_sym___thiscall] = ACTIONS(3517),
    [anon_sym___vectorcall] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_signed] = ACTIONS(3517),
    [anon_sym_unsigned] = ACTIONS(3517),
    [anon_sym_long] = ACTIONS(3517),
    [anon_sym_short] = ACTIONS(3517),
    [anon_sym_LBRACK] = ACTIONS(3517),
    [anon_sym_static] = ACTIONS(3517),
    [anon_sym_register] = ACTIONS(3517),
    [anon_sym_inline] = ACTIONS(3517),
    [anon_sym___inline] = ACTIONS(3517),
    [anon_sym___inline__] = ACTIONS(3517),
    [anon_sym___forceinline] = ACTIONS(3517),
    [anon_sym_thread_local] = ACTIONS(3517),
    [anon_sym___thread] = ACTIONS(3517),
    [anon_sym_const] = ACTIONS(3517),
    [anon_sym_constexpr] = ACTIONS(3517),
    [anon_sym_volatile] = ACTIONS(3517),
    [anon_sym_restrict] = ACTIONS(3517),
    [anon_sym___restrict__] = ACTIONS(3517),
    [anon_sym__Atomic] = ACTIONS(3517),
    [anon_sym__Noreturn] = ACTIONS(3517),
    [anon_sym_noreturn] = ACTIONS(3517),
    [anon_sym_mutable] = ACTIONS(3517),
    [anon_sym_constinit] = ACTIONS(3517),
    [anon_sym_consteval] = ACTIONS(3517),
    [anon_sym_alignas] = ACTIONS(3517),
    [anon_sym__Alignas] = ACTIONS(3517),
    [sym_primitive_type] = ACTIONS(3517),
    [anon_sym_enum] = ACTIONS(3517),
    [anon_sym_class] = ACTIONS(3517),
    [anon_sym_struct] = ACTIONS(3517),
    [anon_sym_union] = ACTIONS(3517),
    [anon_sym_if] = ACTIONS(3517),
    [anon_sym_switch] = ACTIONS(3517),
    [anon_sym_case] = ACTIONS(3517),
    [anon_sym_default] = ACTIONS(3517),
    [anon_sym_while] = ACTIONS(3517),
    [anon_sym_do] = ACTIONS(3517),
    [anon_sym_for] = ACTIONS(3517),
    [anon_sym_return] = ACTIONS(3517),
    [anon_sym_break] = ACTIONS(3517),
    [anon_sym_continue] = ACTIONS(3517),
    [anon_sym_goto] = ACTIONS(3517),
    [anon_sym___try] = ACTIONS(3517),
    [anon_sym___leave] = ACTIONS(3517),
    [anon_sym_not] = ACTIONS(3517),
    [anon_sym_compl] = ACTIONS(3517),
    [anon_sym_DASH_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_PLUS] = ACTIONS(3519),
    [anon_sym_sizeof] = ACTIONS(3517),
    [anon_sym___alignof__] = ACTIONS(3517),
    [anon_sym___alignof] = ACTIONS(3517),
    [anon_sym__alignof] = ACTIONS(3517),
    [anon_sym_alignof] = ACTIONS(3517),
    [anon_sym__Alignof] = ACTIONS(3517),
    [anon_sym_offsetof] = ACTIONS(3517),
    [anon_sym__Generic] = ACTIONS(3517),
    [anon_sym_asm] = ACTIONS(3517),
    [anon_sym___asm__] = ACTIONS(3517),
    [sym_number_literal] = ACTIONS(3519),
    [anon_sym_L_SQUOTE] = ACTIONS(3519),
    [anon_sym_u_SQUOTE] = ACTIONS(3519),
    [anon_sym_U_SQUOTE] = ACTIONS(3519),
    [anon_sym_u8_SQUOTE] = ACTIONS(3519),
    [anon_sym_SQUOTE] = ACTIONS(3519),
    [anon_sym_L_DQUOTE] = ACTIONS(3519),
    [anon_sym_u_DQUOTE] = ACTIONS(3519),
    [anon_sym_U_DQUOTE] = ACTIONS(3519),
    [anon_sym_u8_DQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [sym_true] = ACTIONS(3517),
    [sym_false] = ACTIONS(3517),
    [anon_sym_NULL] = ACTIONS(3517),
    [anon_sym_nullptr] = ACTIONS(3517),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3517),
    [anon_sym_let] = ACTIONS(3517),
    [anon_sym_This] = ACTIONS(3517),
    [anon_sym_decltype] = ACTIONS(3517),
    [sym_virtual] = ACTIONS(3517),
    [anon_sym_explicit] = ACTIONS(3517),
    [anon_sym_typename] = ACTIONS(3517),
    [anon_sym_template] = ACTIONS(3517),
    [anon_sym_operator] = ACTIONS(3517),
    [anon_sym_try] = ACTIONS(3517),
    [anon_sym_delete] = ACTIONS(3517),
    [anon_sym_throw] = ACTIONS(3517),
    [anon_sym_namespace] = ACTIONS(3517),
    [anon_sym_using] = ACTIONS(3517),
    [anon_sym_static_assert] = ACTIONS(3517),
    [anon_sym_concept] = ACTIONS(3517),
    [anon_sym_co_return] = ACTIONS(3517),
    [anon_sym_co_yield] = ACTIONS(3517),
    [anon_sym_R_DQUOTE] = ACTIONS(3519),
    [anon_sym_LR_DQUOTE] = ACTIONS(3519),
    [anon_sym_uR_DQUOTE] = ACTIONS(3519),
    [anon_sym_UR_DQUOTE] = ACTIONS(3519),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3519),
    [anon_sym_co_await] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3517),
    [anon_sym_requires] = ACTIONS(3517),
    [sym_this] = ACTIONS(3517),
    [anon_sym_discard] = ACTIONS(3517),
    [anon_sym_precise] = ACTIONS(3517),
    [anon_sym_shared] = ACTIONS(3517),
    [anon_sym_groupshared] = ACTIONS(3517),
    [anon_sym_uniform] = ACTIONS(3517),
    [anon_sym_row_major] = ACTIONS(3517),
    [anon_sym_column_major] = ACTIONS(3517),
    [anon_sym_globallycoherent] = ACTIONS(3517),
    [anon_sym_centroid] = ACTIONS(3517),
    [anon_sym_noperspective] = ACTIONS(3517),
    [anon_sym_nointerpolation] = ACTIONS(3517),
    [anon_sym_sample] = ACTIONS(3517),
    [anon_sym_linear] = ACTIONS(3517),
    [anon_sym_snorm] = ACTIONS(3517),
    [anon_sym_unorm] = ACTIONS(3517),
    [anon_sym_point] = ACTIONS(3517),
    [anon_sym_line] = ACTIONS(3517),
    [anon_sym_triangleadj] = ACTIONS(3517),
    [anon_sym_lineadj] = ACTIONS(3517),
    [anon_sym_triangle] = ACTIONS(3517),
    [anon_sym_cbuffer] = ACTIONS(3517),
    [anon_sym_interface] = ACTIONS(3517),
    [anon_sym_extension] = ACTIONS(3517),
  },
  [475] = {
    [sym_identifier] = ACTIONS(3521),
    [aux_sym_preproc_include_token1] = ACTIONS(3521),
    [aux_sym_preproc_def_token1] = ACTIONS(3521),
    [aux_sym_preproc_if_token1] = ACTIONS(3521),
    [aux_sym_preproc_if_token2] = ACTIONS(3521),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3521),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3521),
    [aux_sym_preproc_else_token1] = ACTIONS(3521),
    [aux_sym_preproc_elif_token1] = ACTIONS(3521),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3521),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3521),
    [sym_preproc_directive] = ACTIONS(3521),
    [anon_sym_LPAREN2] = ACTIONS(3523),
    [anon_sym_BANG] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3521),
    [anon_sym_PLUS] = ACTIONS(3521),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3521),
    [anon_sym_SEMI] = ACTIONS(3523),
    [anon_sym___extension__] = ACTIONS(3521),
    [anon_sym_typedef] = ACTIONS(3521),
    [anon_sym_in] = ACTIONS(3521),
    [anon_sym_out] = ACTIONS(3521),
    [anon_sym_inout] = ACTIONS(3521),
    [anon_sym_extern] = ACTIONS(3521),
    [anon_sym___attribute__] = ACTIONS(3521),
    [anon_sym_COLON_COLON] = ACTIONS(3523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3523),
    [anon_sym___declspec] = ACTIONS(3521),
    [anon_sym___based] = ACTIONS(3521),
    [anon_sym___cdecl] = ACTIONS(3521),
    [anon_sym___clrcall] = ACTIONS(3521),
    [anon_sym___stdcall] = ACTIONS(3521),
    [anon_sym___fastcall] = ACTIONS(3521),
    [anon_sym___thiscall] = ACTIONS(3521),
    [anon_sym___vectorcall] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_signed] = ACTIONS(3521),
    [anon_sym_unsigned] = ACTIONS(3521),
    [anon_sym_long] = ACTIONS(3521),
    [anon_sym_short] = ACTIONS(3521),
    [anon_sym_LBRACK] = ACTIONS(3521),
    [anon_sym_static] = ACTIONS(3521),
    [anon_sym_register] = ACTIONS(3521),
    [anon_sym_inline] = ACTIONS(3521),
    [anon_sym___inline] = ACTIONS(3521),
    [anon_sym___inline__] = ACTIONS(3521),
    [anon_sym___forceinline] = ACTIONS(3521),
    [anon_sym_thread_local] = ACTIONS(3521),
    [anon_sym___thread] = ACTIONS(3521),
    [anon_sym_const] = ACTIONS(3521),
    [anon_sym_constexpr] = ACTIONS(3521),
    [anon_sym_volatile] = ACTIONS(3521),
    [anon_sym_restrict] = ACTIONS(3521),
    [anon_sym___restrict__] = ACTIONS(3521),
    [anon_sym__Atomic] = ACTIONS(3521),
    [anon_sym__Noreturn] = ACTIONS(3521),
    [anon_sym_noreturn] = ACTIONS(3521),
    [anon_sym_mutable] = ACTIONS(3521),
    [anon_sym_constinit] = ACTIONS(3521),
    [anon_sym_consteval] = ACTIONS(3521),
    [anon_sym_alignas] = ACTIONS(3521),
    [anon_sym__Alignas] = ACTIONS(3521),
    [sym_primitive_type] = ACTIONS(3521),
    [anon_sym_enum] = ACTIONS(3521),
    [anon_sym_class] = ACTIONS(3521),
    [anon_sym_struct] = ACTIONS(3521),
    [anon_sym_union] = ACTIONS(3521),
    [anon_sym_if] = ACTIONS(3521),
    [anon_sym_switch] = ACTIONS(3521),
    [anon_sym_case] = ACTIONS(3521),
    [anon_sym_default] = ACTIONS(3521),
    [anon_sym_while] = ACTIONS(3521),
    [anon_sym_do] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3521),
    [anon_sym_return] = ACTIONS(3521),
    [anon_sym_break] = ACTIONS(3521),
    [anon_sym_continue] = ACTIONS(3521),
    [anon_sym_goto] = ACTIONS(3521),
    [anon_sym___try] = ACTIONS(3521),
    [anon_sym___leave] = ACTIONS(3521),
    [anon_sym_not] = ACTIONS(3521),
    [anon_sym_compl] = ACTIONS(3521),
    [anon_sym_DASH_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_PLUS] = ACTIONS(3523),
    [anon_sym_sizeof] = ACTIONS(3521),
    [anon_sym___alignof__] = ACTIONS(3521),
    [anon_sym___alignof] = ACTIONS(3521),
    [anon_sym__alignof] = ACTIONS(3521),
    [anon_sym_alignof] = ACTIONS(3521),
    [anon_sym__Alignof] = ACTIONS(3521),
    [anon_sym_offsetof] = ACTIONS(3521),
    [anon_sym__Generic] = ACTIONS(3521),
    [anon_sym_asm] = ACTIONS(3521),
    [anon_sym___asm__] = ACTIONS(3521),
    [sym_number_literal] = ACTIONS(3523),
    [anon_sym_L_SQUOTE] = ACTIONS(3523),
    [anon_sym_u_SQUOTE] = ACTIONS(3523),
    [anon_sym_U_SQUOTE] = ACTIONS(3523),
    [anon_sym_u8_SQUOTE] = ACTIONS(3523),
    [anon_sym_SQUOTE] = ACTIONS(3523),
    [anon_sym_L_DQUOTE] = ACTIONS(3523),
    [anon_sym_u_DQUOTE] = ACTIONS(3523),
    [anon_sym_U_DQUOTE] = ACTIONS(3523),
    [anon_sym_u8_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [sym_true] = ACTIONS(3521),
    [sym_false] = ACTIONS(3521),
    [anon_sym_NULL] = ACTIONS(3521),
    [anon_sym_nullptr] = ACTIONS(3521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3521),
    [anon_sym_let] = ACTIONS(3521),
    [anon_sym_This] = ACTIONS(3521),
    [anon_sym_decltype] = ACTIONS(3521),
    [sym_virtual] = ACTIONS(3521),
    [anon_sym_explicit] = ACTIONS(3521),
    [anon_sym_typename] = ACTIONS(3521),
    [anon_sym_template] = ACTIONS(3521),
    [anon_sym_operator] = ACTIONS(3521),
    [anon_sym_try] = ACTIONS(3521),
    [anon_sym_delete] = ACTIONS(3521),
    [anon_sym_throw] = ACTIONS(3521),
    [anon_sym_namespace] = ACTIONS(3521),
    [anon_sym_using] = ACTIONS(3521),
    [anon_sym_static_assert] = ACTIONS(3521),
    [anon_sym_concept] = ACTIONS(3521),
    [anon_sym_co_return] = ACTIONS(3521),
    [anon_sym_co_yield] = ACTIONS(3521),
    [anon_sym_R_DQUOTE] = ACTIONS(3523),
    [anon_sym_LR_DQUOTE] = ACTIONS(3523),
    [anon_sym_uR_DQUOTE] = ACTIONS(3523),
    [anon_sym_UR_DQUOTE] = ACTIONS(3523),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3523),
    [anon_sym_co_await] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3521),
    [anon_sym_requires] = ACTIONS(3521),
    [sym_this] = ACTIONS(3521),
    [anon_sym_discard] = ACTIONS(3521),
    [anon_sym_precise] = ACTIONS(3521),
    [anon_sym_shared] = ACTIONS(3521),
    [anon_sym_groupshared] = ACTIONS(3521),
    [anon_sym_uniform] = ACTIONS(3521),
    [anon_sym_row_major] = ACTIONS(3521),
    [anon_sym_column_major] = ACTIONS(3521),
    [anon_sym_globallycoherent] = ACTIONS(3521),
    [anon_sym_centroid] = ACTIONS(3521),
    [anon_sym_noperspective] = ACTIONS(3521),
    [anon_sym_nointerpolation] = ACTIONS(3521),
    [anon_sym_sample] = ACTIONS(3521),
    [anon_sym_linear] = ACTIONS(3521),
    [anon_sym_snorm] = ACTIONS(3521),
    [anon_sym_unorm] = ACTIONS(3521),
    [anon_sym_point] = ACTIONS(3521),
    [anon_sym_line] = ACTIONS(3521),
    [anon_sym_triangleadj] = ACTIONS(3521),
    [anon_sym_lineadj] = ACTIONS(3521),
    [anon_sym_triangle] = ACTIONS(3521),
    [anon_sym_cbuffer] = ACTIONS(3521),
    [anon_sym_interface] = ACTIONS(3521),
    [anon_sym_extension] = ACTIONS(3521),
  },
  [476] = {
    [sym_identifier] = ACTIONS(3525),
    [aux_sym_preproc_include_token1] = ACTIONS(3525),
    [aux_sym_preproc_def_token1] = ACTIONS(3525),
    [aux_sym_preproc_if_token1] = ACTIONS(3525),
    [aux_sym_preproc_if_token2] = ACTIONS(3525),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3525),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3525),
    [aux_sym_preproc_else_token1] = ACTIONS(3525),
    [aux_sym_preproc_elif_token1] = ACTIONS(3525),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3525),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3525),
    [sym_preproc_directive] = ACTIONS(3525),
    [anon_sym_LPAREN2] = ACTIONS(3527),
    [anon_sym_BANG] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3525),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_AMP] = ACTIONS(3525),
    [anon_sym_SEMI] = ACTIONS(3527),
    [anon_sym___extension__] = ACTIONS(3525),
    [anon_sym_typedef] = ACTIONS(3525),
    [anon_sym_in] = ACTIONS(3525),
    [anon_sym_out] = ACTIONS(3525),
    [anon_sym_inout] = ACTIONS(3525),
    [anon_sym_extern] = ACTIONS(3525),
    [anon_sym___attribute__] = ACTIONS(3525),
    [anon_sym_COLON_COLON] = ACTIONS(3527),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3527),
    [anon_sym___declspec] = ACTIONS(3525),
    [anon_sym___based] = ACTIONS(3525),
    [anon_sym___cdecl] = ACTIONS(3525),
    [anon_sym___clrcall] = ACTIONS(3525),
    [anon_sym___stdcall] = ACTIONS(3525),
    [anon_sym___fastcall] = ACTIONS(3525),
    [anon_sym___thiscall] = ACTIONS(3525),
    [anon_sym___vectorcall] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_signed] = ACTIONS(3525),
    [anon_sym_unsigned] = ACTIONS(3525),
    [anon_sym_long] = ACTIONS(3525),
    [anon_sym_short] = ACTIONS(3525),
    [anon_sym_LBRACK] = ACTIONS(3525),
    [anon_sym_static] = ACTIONS(3525),
    [anon_sym_register] = ACTIONS(3525),
    [anon_sym_inline] = ACTIONS(3525),
    [anon_sym___inline] = ACTIONS(3525),
    [anon_sym___inline__] = ACTIONS(3525),
    [anon_sym___forceinline] = ACTIONS(3525),
    [anon_sym_thread_local] = ACTIONS(3525),
    [anon_sym___thread] = ACTIONS(3525),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_constexpr] = ACTIONS(3525),
    [anon_sym_volatile] = ACTIONS(3525),
    [anon_sym_restrict] = ACTIONS(3525),
    [anon_sym___restrict__] = ACTIONS(3525),
    [anon_sym__Atomic] = ACTIONS(3525),
    [anon_sym__Noreturn] = ACTIONS(3525),
    [anon_sym_noreturn] = ACTIONS(3525),
    [anon_sym_mutable] = ACTIONS(3525),
    [anon_sym_constinit] = ACTIONS(3525),
    [anon_sym_consteval] = ACTIONS(3525),
    [anon_sym_alignas] = ACTIONS(3525),
    [anon_sym__Alignas] = ACTIONS(3525),
    [sym_primitive_type] = ACTIONS(3525),
    [anon_sym_enum] = ACTIONS(3525),
    [anon_sym_class] = ACTIONS(3525),
    [anon_sym_struct] = ACTIONS(3525),
    [anon_sym_union] = ACTIONS(3525),
    [anon_sym_if] = ACTIONS(3525),
    [anon_sym_switch] = ACTIONS(3525),
    [anon_sym_case] = ACTIONS(3525),
    [anon_sym_default] = ACTIONS(3525),
    [anon_sym_while] = ACTIONS(3525),
    [anon_sym_do] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3525),
    [anon_sym_return] = ACTIONS(3525),
    [anon_sym_break] = ACTIONS(3525),
    [anon_sym_continue] = ACTIONS(3525),
    [anon_sym_goto] = ACTIONS(3525),
    [anon_sym___try] = ACTIONS(3525),
    [anon_sym___leave] = ACTIONS(3525),
    [anon_sym_not] = ACTIONS(3525),
    [anon_sym_compl] = ACTIONS(3525),
    [anon_sym_DASH_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_PLUS] = ACTIONS(3527),
    [anon_sym_sizeof] = ACTIONS(3525),
    [anon_sym___alignof__] = ACTIONS(3525),
    [anon_sym___alignof] = ACTIONS(3525),
    [anon_sym__alignof] = ACTIONS(3525),
    [anon_sym_alignof] = ACTIONS(3525),
    [anon_sym__Alignof] = ACTIONS(3525),
    [anon_sym_offsetof] = ACTIONS(3525),
    [anon_sym__Generic] = ACTIONS(3525),
    [anon_sym_asm] = ACTIONS(3525),
    [anon_sym___asm__] = ACTIONS(3525),
    [sym_number_literal] = ACTIONS(3527),
    [anon_sym_L_SQUOTE] = ACTIONS(3527),
    [anon_sym_u_SQUOTE] = ACTIONS(3527),
    [anon_sym_U_SQUOTE] = ACTIONS(3527),
    [anon_sym_u8_SQUOTE] = ACTIONS(3527),
    [anon_sym_SQUOTE] = ACTIONS(3527),
    [anon_sym_L_DQUOTE] = ACTIONS(3527),
    [anon_sym_u_DQUOTE] = ACTIONS(3527),
    [anon_sym_U_DQUOTE] = ACTIONS(3527),
    [anon_sym_u8_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [sym_true] = ACTIONS(3525),
    [sym_false] = ACTIONS(3525),
    [anon_sym_NULL] = ACTIONS(3525),
    [anon_sym_nullptr] = ACTIONS(3525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3525),
    [anon_sym_let] = ACTIONS(3525),
    [anon_sym_This] = ACTIONS(3525),
    [anon_sym_decltype] = ACTIONS(3525),
    [sym_virtual] = ACTIONS(3525),
    [anon_sym_explicit] = ACTIONS(3525),
    [anon_sym_typename] = ACTIONS(3525),
    [anon_sym_template] = ACTIONS(3525),
    [anon_sym_operator] = ACTIONS(3525),
    [anon_sym_try] = ACTIONS(3525),
    [anon_sym_delete] = ACTIONS(3525),
    [anon_sym_throw] = ACTIONS(3525),
    [anon_sym_namespace] = ACTIONS(3525),
    [anon_sym_using] = ACTIONS(3525),
    [anon_sym_static_assert] = ACTIONS(3525),
    [anon_sym_concept] = ACTIONS(3525),
    [anon_sym_co_return] = ACTIONS(3525),
    [anon_sym_co_yield] = ACTIONS(3525),
    [anon_sym_R_DQUOTE] = ACTIONS(3527),
    [anon_sym_LR_DQUOTE] = ACTIONS(3527),
    [anon_sym_uR_DQUOTE] = ACTIONS(3527),
    [anon_sym_UR_DQUOTE] = ACTIONS(3527),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3527),
    [anon_sym_co_await] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3525),
    [anon_sym_requires] = ACTIONS(3525),
    [sym_this] = ACTIONS(3525),
    [anon_sym_discard] = ACTIONS(3525),
    [anon_sym_precise] = ACTIONS(3525),
    [anon_sym_shared] = ACTIONS(3525),
    [anon_sym_groupshared] = ACTIONS(3525),
    [anon_sym_uniform] = ACTIONS(3525),
    [anon_sym_row_major] = ACTIONS(3525),
    [anon_sym_column_major] = ACTIONS(3525),
    [anon_sym_globallycoherent] = ACTIONS(3525),
    [anon_sym_centroid] = ACTIONS(3525),
    [anon_sym_noperspective] = ACTIONS(3525),
    [anon_sym_nointerpolation] = ACTIONS(3525),
    [anon_sym_sample] = ACTIONS(3525),
    [anon_sym_linear] = ACTIONS(3525),
    [anon_sym_snorm] = ACTIONS(3525),
    [anon_sym_unorm] = ACTIONS(3525),
    [anon_sym_point] = ACTIONS(3525),
    [anon_sym_line] = ACTIONS(3525),
    [anon_sym_triangleadj] = ACTIONS(3525),
    [anon_sym_lineadj] = ACTIONS(3525),
    [anon_sym_triangle] = ACTIONS(3525),
    [anon_sym_cbuffer] = ACTIONS(3525),
    [anon_sym_interface] = ACTIONS(3525),
    [anon_sym_extension] = ACTIONS(3525),
  },
  [477] = {
    [sym_catch_clause] = STATE(445),
    [aux_sym_constructor_try_statement_repeat1] = STATE(445),
    [sym_identifier] = ACTIONS(2677),
    [aux_sym_preproc_include_token1] = ACTIONS(2677),
    [aux_sym_preproc_def_token1] = ACTIONS(2677),
    [aux_sym_preproc_if_token1] = ACTIONS(2677),
    [aux_sym_preproc_if_token2] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2677),
    [sym_preproc_directive] = ACTIONS(2677),
    [anon_sym_LPAREN2] = ACTIONS(2679),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_DASH] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_STAR] = ACTIONS(2679),
    [anon_sym_AMP_AMP] = ACTIONS(2679),
    [anon_sym_AMP] = ACTIONS(2677),
    [anon_sym_SEMI] = ACTIONS(2679),
    [anon_sym___extension__] = ACTIONS(2677),
    [anon_sym_typedef] = ACTIONS(2677),
    [anon_sym_in] = ACTIONS(2677),
    [anon_sym_out] = ACTIONS(2677),
    [anon_sym_inout] = ACTIONS(2677),
    [anon_sym_extern] = ACTIONS(2677),
    [anon_sym___attribute__] = ACTIONS(2677),
    [anon_sym_COLON_COLON] = ACTIONS(2679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2679),
    [anon_sym___declspec] = ACTIONS(2677),
    [anon_sym___based] = ACTIONS(2677),
    [anon_sym___cdecl] = ACTIONS(2677),
    [anon_sym___clrcall] = ACTIONS(2677),
    [anon_sym___stdcall] = ACTIONS(2677),
    [anon_sym___fastcall] = ACTIONS(2677),
    [anon_sym___thiscall] = ACTIONS(2677),
    [anon_sym___vectorcall] = ACTIONS(2677),
    [anon_sym_LBRACE] = ACTIONS(2679),
    [anon_sym_signed] = ACTIONS(2677),
    [anon_sym_unsigned] = ACTIONS(2677),
    [anon_sym_long] = ACTIONS(2677),
    [anon_sym_short] = ACTIONS(2677),
    [anon_sym_LBRACK] = ACTIONS(2677),
    [anon_sym_static] = ACTIONS(2677),
    [anon_sym_register] = ACTIONS(2677),
    [anon_sym_inline] = ACTIONS(2677),
    [anon_sym___inline] = ACTIONS(2677),
    [anon_sym___inline__] = ACTIONS(2677),
    [anon_sym___forceinline] = ACTIONS(2677),
    [anon_sym_thread_local] = ACTIONS(2677),
    [anon_sym___thread] = ACTIONS(2677),
    [anon_sym_const] = ACTIONS(2677),
    [anon_sym_constexpr] = ACTIONS(2677),
    [anon_sym_volatile] = ACTIONS(2677),
    [anon_sym_restrict] = ACTIONS(2677),
    [anon_sym___restrict__] = ACTIONS(2677),
    [anon_sym__Atomic] = ACTIONS(2677),
    [anon_sym__Noreturn] = ACTIONS(2677),
    [anon_sym_noreturn] = ACTIONS(2677),
    [anon_sym_mutable] = ACTIONS(2677),
    [anon_sym_constinit] = ACTIONS(2677),
    [anon_sym_consteval] = ACTIONS(2677),
    [anon_sym_alignas] = ACTIONS(2677),
    [anon_sym__Alignas] = ACTIONS(2677),
    [sym_primitive_type] = ACTIONS(2677),
    [anon_sym_enum] = ACTIONS(2677),
    [anon_sym_class] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(2677),
    [anon_sym_union] = ACTIONS(2677),
    [anon_sym_if] = ACTIONS(2677),
    [anon_sym_else] = ACTIONS(2677),
    [anon_sym_switch] = ACTIONS(2677),
    [anon_sym_case] = ACTIONS(2677),
    [anon_sym_default] = ACTIONS(2677),
    [anon_sym_while] = ACTIONS(2677),
    [anon_sym_do] = ACTIONS(2677),
    [anon_sym_for] = ACTIONS(2677),
    [anon_sym_return] = ACTIONS(2677),
    [anon_sym_break] = ACTIONS(2677),
    [anon_sym_continue] = ACTIONS(2677),
    [anon_sym_goto] = ACTIONS(2677),
    [anon_sym___try] = ACTIONS(2677),
    [anon_sym___leave] = ACTIONS(2677),
    [anon_sym_not] = ACTIONS(2677),
    [anon_sym_compl] = ACTIONS(2677),
    [anon_sym_DASH_DASH] = ACTIONS(2679),
    [anon_sym_PLUS_PLUS] = ACTIONS(2679),
    [anon_sym_sizeof] = ACTIONS(2677),
    [anon_sym___alignof__] = ACTIONS(2677),
    [anon_sym___alignof] = ACTIONS(2677),
    [anon_sym__alignof] = ACTIONS(2677),
    [anon_sym_alignof] = ACTIONS(2677),
    [anon_sym__Alignof] = ACTIONS(2677),
    [anon_sym_offsetof] = ACTIONS(2677),
    [anon_sym__Generic] = ACTIONS(2677),
    [anon_sym_asm] = ACTIONS(2677),
    [anon_sym___asm__] = ACTIONS(2677),
    [sym_number_literal] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2679),
    [anon_sym_u_SQUOTE] = ACTIONS(2679),
    [anon_sym_U_SQUOTE] = ACTIONS(2679),
    [anon_sym_u8_SQUOTE] = ACTIONS(2679),
    [anon_sym_SQUOTE] = ACTIONS(2679),
    [anon_sym_L_DQUOTE] = ACTIONS(2679),
    [anon_sym_u_DQUOTE] = ACTIONS(2679),
    [anon_sym_U_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8_DQUOTE] = ACTIONS(2679),
    [anon_sym_DQUOTE] = ACTIONS(2679),
    [sym_true] = ACTIONS(2677),
    [sym_false] = ACTIONS(2677),
    [anon_sym_NULL] = ACTIONS(2677),
    [anon_sym_nullptr] = ACTIONS(2677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2677),
    [anon_sym_let] = ACTIONS(2677),
    [anon_sym_This] = ACTIONS(2677),
    [anon_sym_decltype] = ACTIONS(2677),
    [sym_virtual] = ACTIONS(2677),
    [anon_sym_explicit] = ACTIONS(2677),
    [anon_sym_typename] = ACTIONS(2677),
    [anon_sym_template] = ACTIONS(2677),
    [anon_sym_operator] = ACTIONS(2677),
    [anon_sym_try] = ACTIONS(2677),
    [anon_sym_delete] = ACTIONS(2677),
    [anon_sym_throw] = ACTIONS(2677),
    [anon_sym_namespace] = ACTIONS(2677),
    [anon_sym_using] = ACTIONS(2677),
    [anon_sym_static_assert] = ACTIONS(2677),
    [anon_sym_concept] = ACTIONS(2677),
    [anon_sym_co_return] = ACTIONS(2677),
    [anon_sym_co_yield] = ACTIONS(2677),
    [anon_sym_catch] = ACTIONS(3529),
    [anon_sym_R_DQUOTE] = ACTIONS(2679),
    [anon_sym_LR_DQUOTE] = ACTIONS(2679),
    [anon_sym_uR_DQUOTE] = ACTIONS(2679),
    [anon_sym_UR_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2679),
    [anon_sym_co_await] = ACTIONS(2677),
    [anon_sym_new] = ACTIONS(2677),
    [anon_sym_requires] = ACTIONS(2677),
    [sym_this] = ACTIONS(2677),
    [anon_sym_discard] = ACTIONS(2677),
    [anon_sym_precise] = ACTIONS(2677),
    [anon_sym_shared] = ACTIONS(2677),
    [anon_sym_groupshared] = ACTIONS(2677),
    [anon_sym_uniform] = ACTIONS(2677),
    [anon_sym_row_major] = ACTIONS(2677),
    [anon_sym_column_major] = ACTIONS(2677),
    [anon_sym_globallycoherent] = ACTIONS(2677),
    [anon_sym_centroid] = ACTIONS(2677),
    [anon_sym_noperspective] = ACTIONS(2677),
    [anon_sym_nointerpolation] = ACTIONS(2677),
    [anon_sym_sample] = ACTIONS(2677),
    [anon_sym_linear] = ACTIONS(2677),
    [anon_sym_snorm] = ACTIONS(2677),
    [anon_sym_unorm] = ACTIONS(2677),
    [anon_sym_point] = ACTIONS(2677),
    [anon_sym_line] = ACTIONS(2677),
    [anon_sym_triangleadj] = ACTIONS(2677),
    [anon_sym_lineadj] = ACTIONS(2677),
    [anon_sym_triangle] = ACTIONS(2677),
    [anon_sym_cbuffer] = ACTIONS(2677),
    [anon_sym_interface] = ACTIONS(2677),
    [anon_sym_extension] = ACTIONS(2677),
  },
  [478] = {
    [sym_identifier] = ACTIONS(3531),
    [aux_sym_preproc_include_token1] = ACTIONS(3531),
    [aux_sym_preproc_def_token1] = ACTIONS(3531),
    [aux_sym_preproc_if_token1] = ACTIONS(3531),
    [aux_sym_preproc_if_token2] = ACTIONS(3531),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3531),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3531),
    [aux_sym_preproc_else_token1] = ACTIONS(3531),
    [aux_sym_preproc_elif_token1] = ACTIONS(3531),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3531),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3531),
    [sym_preproc_directive] = ACTIONS(3531),
    [anon_sym_LPAREN2] = ACTIONS(3533),
    [anon_sym_BANG] = ACTIONS(3533),
    [anon_sym_TILDE] = ACTIONS(3533),
    [anon_sym_DASH] = ACTIONS(3531),
    [anon_sym_PLUS] = ACTIONS(3531),
    [anon_sym_STAR] = ACTIONS(3533),
    [anon_sym_AMP_AMP] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_SEMI] = ACTIONS(3533),
    [anon_sym___extension__] = ACTIONS(3531),
    [anon_sym_typedef] = ACTIONS(3531),
    [anon_sym_in] = ACTIONS(3531),
    [anon_sym_out] = ACTIONS(3531),
    [anon_sym_inout] = ACTIONS(3531),
    [anon_sym_extern] = ACTIONS(3531),
    [anon_sym___attribute__] = ACTIONS(3531),
    [anon_sym_COLON_COLON] = ACTIONS(3533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3533),
    [anon_sym___declspec] = ACTIONS(3531),
    [anon_sym___based] = ACTIONS(3531),
    [anon_sym___cdecl] = ACTIONS(3531),
    [anon_sym___clrcall] = ACTIONS(3531),
    [anon_sym___stdcall] = ACTIONS(3531),
    [anon_sym___fastcall] = ACTIONS(3531),
    [anon_sym___thiscall] = ACTIONS(3531),
    [anon_sym___vectorcall] = ACTIONS(3531),
    [anon_sym_LBRACE] = ACTIONS(3533),
    [anon_sym_signed] = ACTIONS(3531),
    [anon_sym_unsigned] = ACTIONS(3531),
    [anon_sym_long] = ACTIONS(3531),
    [anon_sym_short] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_static] = ACTIONS(3531),
    [anon_sym_register] = ACTIONS(3531),
    [anon_sym_inline] = ACTIONS(3531),
    [anon_sym___inline] = ACTIONS(3531),
    [anon_sym___inline__] = ACTIONS(3531),
    [anon_sym___forceinline] = ACTIONS(3531),
    [anon_sym_thread_local] = ACTIONS(3531),
    [anon_sym___thread] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3531),
    [anon_sym_constexpr] = ACTIONS(3531),
    [anon_sym_volatile] = ACTIONS(3531),
    [anon_sym_restrict] = ACTIONS(3531),
    [anon_sym___restrict__] = ACTIONS(3531),
    [anon_sym__Atomic] = ACTIONS(3531),
    [anon_sym__Noreturn] = ACTIONS(3531),
    [anon_sym_noreturn] = ACTIONS(3531),
    [anon_sym_mutable] = ACTIONS(3531),
    [anon_sym_constinit] = ACTIONS(3531),
    [anon_sym_consteval] = ACTIONS(3531),
    [anon_sym_alignas] = ACTIONS(3531),
    [anon_sym__Alignas] = ACTIONS(3531),
    [sym_primitive_type] = ACTIONS(3531),
    [anon_sym_enum] = ACTIONS(3531),
    [anon_sym_class] = ACTIONS(3531),
    [anon_sym_struct] = ACTIONS(3531),
    [anon_sym_union] = ACTIONS(3531),
    [anon_sym_if] = ACTIONS(3531),
    [anon_sym_switch] = ACTIONS(3531),
    [anon_sym_case] = ACTIONS(3531),
    [anon_sym_default] = ACTIONS(3531),
    [anon_sym_while] = ACTIONS(3531),
    [anon_sym_do] = ACTIONS(3531),
    [anon_sym_for] = ACTIONS(3531),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_break] = ACTIONS(3531),
    [anon_sym_continue] = ACTIONS(3531),
    [anon_sym_goto] = ACTIONS(3531),
    [anon_sym___try] = ACTIONS(3531),
    [anon_sym___leave] = ACTIONS(3531),
    [anon_sym_not] = ACTIONS(3531),
    [anon_sym_compl] = ACTIONS(3531),
    [anon_sym_DASH_DASH] = ACTIONS(3533),
    [anon_sym_PLUS_PLUS] = ACTIONS(3533),
    [anon_sym_sizeof] = ACTIONS(3531),
    [anon_sym___alignof__] = ACTIONS(3531),
    [anon_sym___alignof] = ACTIONS(3531),
    [anon_sym__alignof] = ACTIONS(3531),
    [anon_sym_alignof] = ACTIONS(3531),
    [anon_sym__Alignof] = ACTIONS(3531),
    [anon_sym_offsetof] = ACTIONS(3531),
    [anon_sym__Generic] = ACTIONS(3531),
    [anon_sym_asm] = ACTIONS(3531),
    [anon_sym___asm__] = ACTIONS(3531),
    [sym_number_literal] = ACTIONS(3533),
    [anon_sym_L_SQUOTE] = ACTIONS(3533),
    [anon_sym_u_SQUOTE] = ACTIONS(3533),
    [anon_sym_U_SQUOTE] = ACTIONS(3533),
    [anon_sym_u8_SQUOTE] = ACTIONS(3533),
    [anon_sym_SQUOTE] = ACTIONS(3533),
    [anon_sym_L_DQUOTE] = ACTIONS(3533),
    [anon_sym_u_DQUOTE] = ACTIONS(3533),
    [anon_sym_U_DQUOTE] = ACTIONS(3533),
    [anon_sym_u8_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE] = ACTIONS(3533),
    [sym_true] = ACTIONS(3531),
    [sym_false] = ACTIONS(3531),
    [anon_sym_NULL] = ACTIONS(3531),
    [anon_sym_nullptr] = ACTIONS(3531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_This] = ACTIONS(3531),
    [anon_sym_decltype] = ACTIONS(3531),
    [sym_virtual] = ACTIONS(3531),
    [anon_sym_explicit] = ACTIONS(3531),
    [anon_sym_typename] = ACTIONS(3531),
    [anon_sym_template] = ACTIONS(3531),
    [anon_sym_operator] = ACTIONS(3531),
    [anon_sym_try] = ACTIONS(3531),
    [anon_sym_delete] = ACTIONS(3531),
    [anon_sym_throw] = ACTIONS(3531),
    [anon_sym_namespace] = ACTIONS(3531),
    [anon_sym_using] = ACTIONS(3531),
    [anon_sym_static_assert] = ACTIONS(3531),
    [anon_sym_concept] = ACTIONS(3531),
    [anon_sym_co_return] = ACTIONS(3531),
    [anon_sym_co_yield] = ACTIONS(3531),
    [anon_sym_R_DQUOTE] = ACTIONS(3533),
    [anon_sym_LR_DQUOTE] = ACTIONS(3533),
    [anon_sym_uR_DQUOTE] = ACTIONS(3533),
    [anon_sym_UR_DQUOTE] = ACTIONS(3533),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3533),
    [anon_sym_co_await] = ACTIONS(3531),
    [anon_sym_new] = ACTIONS(3531),
    [anon_sym_requires] = ACTIONS(3531),
    [sym_this] = ACTIONS(3531),
    [anon_sym_discard] = ACTIONS(3531),
    [anon_sym_precise] = ACTIONS(3531),
    [anon_sym_shared] = ACTIONS(3531),
    [anon_sym_groupshared] = ACTIONS(3531),
    [anon_sym_uniform] = ACTIONS(3531),
    [anon_sym_row_major] = ACTIONS(3531),
    [anon_sym_column_major] = ACTIONS(3531),
    [anon_sym_globallycoherent] = ACTIONS(3531),
    [anon_sym_centroid] = ACTIONS(3531),
    [anon_sym_noperspective] = ACTIONS(3531),
    [anon_sym_nointerpolation] = ACTIONS(3531),
    [anon_sym_sample] = ACTIONS(3531),
    [anon_sym_linear] = ACTIONS(3531),
    [anon_sym_snorm] = ACTIONS(3531),
    [anon_sym_unorm] = ACTIONS(3531),
    [anon_sym_point] = ACTIONS(3531),
    [anon_sym_line] = ACTIONS(3531),
    [anon_sym_triangleadj] = ACTIONS(3531),
    [anon_sym_lineadj] = ACTIONS(3531),
    [anon_sym_triangle] = ACTIONS(3531),
    [anon_sym_cbuffer] = ACTIONS(3531),
    [anon_sym_interface] = ACTIONS(3531),
    [anon_sym_extension] = ACTIONS(3531),
  },
  [479] = {
    [sym_identifier] = ACTIONS(3535),
    [aux_sym_preproc_include_token1] = ACTIONS(3535),
    [aux_sym_preproc_def_token1] = ACTIONS(3535),
    [aux_sym_preproc_if_token1] = ACTIONS(3535),
    [aux_sym_preproc_if_token2] = ACTIONS(3535),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3535),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3535),
    [aux_sym_preproc_else_token1] = ACTIONS(3535),
    [aux_sym_preproc_elif_token1] = ACTIONS(3535),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3535),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3535),
    [sym_preproc_directive] = ACTIONS(3535),
    [anon_sym_LPAREN2] = ACTIONS(3537),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3537),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym___extension__] = ACTIONS(3535),
    [anon_sym_typedef] = ACTIONS(3535),
    [anon_sym_in] = ACTIONS(3535),
    [anon_sym_out] = ACTIONS(3535),
    [anon_sym_inout] = ACTIONS(3535),
    [anon_sym_extern] = ACTIONS(3535),
    [anon_sym___attribute__] = ACTIONS(3535),
    [anon_sym_COLON_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3537),
    [anon_sym___declspec] = ACTIONS(3535),
    [anon_sym___based] = ACTIONS(3535),
    [anon_sym___cdecl] = ACTIONS(3535),
    [anon_sym___clrcall] = ACTIONS(3535),
    [anon_sym___stdcall] = ACTIONS(3535),
    [anon_sym___fastcall] = ACTIONS(3535),
    [anon_sym___thiscall] = ACTIONS(3535),
    [anon_sym___vectorcall] = ACTIONS(3535),
    [anon_sym_LBRACE] = ACTIONS(3537),
    [anon_sym_signed] = ACTIONS(3535),
    [anon_sym_unsigned] = ACTIONS(3535),
    [anon_sym_long] = ACTIONS(3535),
    [anon_sym_short] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_static] = ACTIONS(3535),
    [anon_sym_register] = ACTIONS(3535),
    [anon_sym_inline] = ACTIONS(3535),
    [anon_sym___inline] = ACTIONS(3535),
    [anon_sym___inline__] = ACTIONS(3535),
    [anon_sym___forceinline] = ACTIONS(3535),
    [anon_sym_thread_local] = ACTIONS(3535),
    [anon_sym___thread] = ACTIONS(3535),
    [anon_sym_const] = ACTIONS(3535),
    [anon_sym_constexpr] = ACTIONS(3535),
    [anon_sym_volatile] = ACTIONS(3535),
    [anon_sym_restrict] = ACTIONS(3535),
    [anon_sym___restrict__] = ACTIONS(3535),
    [anon_sym__Atomic] = ACTIONS(3535),
    [anon_sym__Noreturn] = ACTIONS(3535),
    [anon_sym_noreturn] = ACTIONS(3535),
    [anon_sym_mutable] = ACTIONS(3535),
    [anon_sym_constinit] = ACTIONS(3535),
    [anon_sym_consteval] = ACTIONS(3535),
    [anon_sym_alignas] = ACTIONS(3535),
    [anon_sym__Alignas] = ACTIONS(3535),
    [sym_primitive_type] = ACTIONS(3535),
    [anon_sym_enum] = ACTIONS(3535),
    [anon_sym_class] = ACTIONS(3535),
    [anon_sym_struct] = ACTIONS(3535),
    [anon_sym_union] = ACTIONS(3535),
    [anon_sym_if] = ACTIONS(3535),
    [anon_sym_switch] = ACTIONS(3535),
    [anon_sym_case] = ACTIONS(3535),
    [anon_sym_default] = ACTIONS(3535),
    [anon_sym_while] = ACTIONS(3535),
    [anon_sym_do] = ACTIONS(3535),
    [anon_sym_for] = ACTIONS(3535),
    [anon_sym_return] = ACTIONS(3535),
    [anon_sym_break] = ACTIONS(3535),
    [anon_sym_continue] = ACTIONS(3535),
    [anon_sym_goto] = ACTIONS(3535),
    [anon_sym___try] = ACTIONS(3535),
    [anon_sym___leave] = ACTIONS(3535),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_compl] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(3537),
    [anon_sym_PLUS_PLUS] = ACTIONS(3537),
    [anon_sym_sizeof] = ACTIONS(3535),
    [anon_sym___alignof__] = ACTIONS(3535),
    [anon_sym___alignof] = ACTIONS(3535),
    [anon_sym__alignof] = ACTIONS(3535),
    [anon_sym_alignof] = ACTIONS(3535),
    [anon_sym__Alignof] = ACTIONS(3535),
    [anon_sym_offsetof] = ACTIONS(3535),
    [anon_sym__Generic] = ACTIONS(3535),
    [anon_sym_asm] = ACTIONS(3535),
    [anon_sym___asm__] = ACTIONS(3535),
    [sym_number_literal] = ACTIONS(3537),
    [anon_sym_L_SQUOTE] = ACTIONS(3537),
    [anon_sym_u_SQUOTE] = ACTIONS(3537),
    [anon_sym_U_SQUOTE] = ACTIONS(3537),
    [anon_sym_u8_SQUOTE] = ACTIONS(3537),
    [anon_sym_SQUOTE] = ACTIONS(3537),
    [anon_sym_L_DQUOTE] = ACTIONS(3537),
    [anon_sym_u_DQUOTE] = ACTIONS(3537),
    [anon_sym_U_DQUOTE] = ACTIONS(3537),
    [anon_sym_u8_DQUOTE] = ACTIONS(3537),
    [anon_sym_DQUOTE] = ACTIONS(3537),
    [sym_true] = ACTIONS(3535),
    [sym_false] = ACTIONS(3535),
    [anon_sym_NULL] = ACTIONS(3535),
    [anon_sym_nullptr] = ACTIONS(3535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3535),
    [anon_sym_let] = ACTIONS(3535),
    [anon_sym_This] = ACTIONS(3535),
    [anon_sym_decltype] = ACTIONS(3535),
    [sym_virtual] = ACTIONS(3535),
    [anon_sym_explicit] = ACTIONS(3535),
    [anon_sym_typename] = ACTIONS(3535),
    [anon_sym_template] = ACTIONS(3535),
    [anon_sym_operator] = ACTIONS(3535),
    [anon_sym_try] = ACTIONS(3535),
    [anon_sym_delete] = ACTIONS(3535),
    [anon_sym_throw] = ACTIONS(3535),
    [anon_sym_namespace] = ACTIONS(3535),
    [anon_sym_using] = ACTIONS(3535),
    [anon_sym_static_assert] = ACTIONS(3535),
    [anon_sym_concept] = ACTIONS(3535),
    [anon_sym_co_return] = ACTIONS(3535),
    [anon_sym_co_yield] = ACTIONS(3535),
    [anon_sym_R_DQUOTE] = ACTIONS(3537),
    [anon_sym_LR_DQUOTE] = ACTIONS(3537),
    [anon_sym_uR_DQUOTE] = ACTIONS(3537),
    [anon_sym_UR_DQUOTE] = ACTIONS(3537),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3537),
    [anon_sym_co_await] = ACTIONS(3535),
    [anon_sym_new] = ACTIONS(3535),
    [anon_sym_requires] = ACTIONS(3535),
    [sym_this] = ACTIONS(3535),
    [anon_sym_discard] = ACTIONS(3535),
    [anon_sym_precise] = ACTIONS(3535),
    [anon_sym_shared] = ACTIONS(3535),
    [anon_sym_groupshared] = ACTIONS(3535),
    [anon_sym_uniform] = ACTIONS(3535),
    [anon_sym_row_major] = ACTIONS(3535),
    [anon_sym_column_major] = ACTIONS(3535),
    [anon_sym_globallycoherent] = ACTIONS(3535),
    [anon_sym_centroid] = ACTIONS(3535),
    [anon_sym_noperspective] = ACTIONS(3535),
    [anon_sym_nointerpolation] = ACTIONS(3535),
    [anon_sym_sample] = ACTIONS(3535),
    [anon_sym_linear] = ACTIONS(3535),
    [anon_sym_snorm] = ACTIONS(3535),
    [anon_sym_unorm] = ACTIONS(3535),
    [anon_sym_point] = ACTIONS(3535),
    [anon_sym_line] = ACTIONS(3535),
    [anon_sym_triangleadj] = ACTIONS(3535),
    [anon_sym_lineadj] = ACTIONS(3535),
    [anon_sym_triangle] = ACTIONS(3535),
    [anon_sym_cbuffer] = ACTIONS(3535),
    [anon_sym_interface] = ACTIONS(3535),
    [anon_sym_extension] = ACTIONS(3535),
  },
  [480] = {
    [sym_identifier] = ACTIONS(3539),
    [aux_sym_preproc_include_token1] = ACTIONS(3539),
    [aux_sym_preproc_def_token1] = ACTIONS(3539),
    [aux_sym_preproc_if_token1] = ACTIONS(3539),
    [aux_sym_preproc_if_token2] = ACTIONS(3539),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3539),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3539),
    [aux_sym_preproc_else_token1] = ACTIONS(3539),
    [aux_sym_preproc_elif_token1] = ACTIONS(3539),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3539),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3539),
    [sym_preproc_directive] = ACTIONS(3539),
    [anon_sym_LPAREN2] = ACTIONS(3541),
    [anon_sym_BANG] = ACTIONS(3541),
    [anon_sym_TILDE] = ACTIONS(3541),
    [anon_sym_DASH] = ACTIONS(3539),
    [anon_sym_PLUS] = ACTIONS(3539),
    [anon_sym_STAR] = ACTIONS(3541),
    [anon_sym_AMP_AMP] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym_SEMI] = ACTIONS(3541),
    [anon_sym___extension__] = ACTIONS(3539),
    [anon_sym_typedef] = ACTIONS(3539),
    [anon_sym_in] = ACTIONS(3539),
    [anon_sym_out] = ACTIONS(3539),
    [anon_sym_inout] = ACTIONS(3539),
    [anon_sym_extern] = ACTIONS(3539),
    [anon_sym___attribute__] = ACTIONS(3539),
    [anon_sym_COLON_COLON] = ACTIONS(3541),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3541),
    [anon_sym___declspec] = ACTIONS(3539),
    [anon_sym___based] = ACTIONS(3539),
    [anon_sym___cdecl] = ACTIONS(3539),
    [anon_sym___clrcall] = ACTIONS(3539),
    [anon_sym___stdcall] = ACTIONS(3539),
    [anon_sym___fastcall] = ACTIONS(3539),
    [anon_sym___thiscall] = ACTIONS(3539),
    [anon_sym___vectorcall] = ACTIONS(3539),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_signed] = ACTIONS(3539),
    [anon_sym_unsigned] = ACTIONS(3539),
    [anon_sym_long] = ACTIONS(3539),
    [anon_sym_short] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_static] = ACTIONS(3539),
    [anon_sym_register] = ACTIONS(3539),
    [anon_sym_inline] = ACTIONS(3539),
    [anon_sym___inline] = ACTIONS(3539),
    [anon_sym___inline__] = ACTIONS(3539),
    [anon_sym___forceinline] = ACTIONS(3539),
    [anon_sym_thread_local] = ACTIONS(3539),
    [anon_sym___thread] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3539),
    [anon_sym_constexpr] = ACTIONS(3539),
    [anon_sym_volatile] = ACTIONS(3539),
    [anon_sym_restrict] = ACTIONS(3539),
    [anon_sym___restrict__] = ACTIONS(3539),
    [anon_sym__Atomic] = ACTIONS(3539),
    [anon_sym__Noreturn] = ACTIONS(3539),
    [anon_sym_noreturn] = ACTIONS(3539),
    [anon_sym_mutable] = ACTIONS(3539),
    [anon_sym_constinit] = ACTIONS(3539),
    [anon_sym_consteval] = ACTIONS(3539),
    [anon_sym_alignas] = ACTIONS(3539),
    [anon_sym__Alignas] = ACTIONS(3539),
    [sym_primitive_type] = ACTIONS(3539),
    [anon_sym_enum] = ACTIONS(3539),
    [anon_sym_class] = ACTIONS(3539),
    [anon_sym_struct] = ACTIONS(3539),
    [anon_sym_union] = ACTIONS(3539),
    [anon_sym_if] = ACTIONS(3539),
    [anon_sym_switch] = ACTIONS(3539),
    [anon_sym_case] = ACTIONS(3539),
    [anon_sym_default] = ACTIONS(3539),
    [anon_sym_while] = ACTIONS(3539),
    [anon_sym_do] = ACTIONS(3539),
    [anon_sym_for] = ACTIONS(3539),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_break] = ACTIONS(3539),
    [anon_sym_continue] = ACTIONS(3539),
    [anon_sym_goto] = ACTIONS(3539),
    [anon_sym___try] = ACTIONS(3539),
    [anon_sym___leave] = ACTIONS(3539),
    [anon_sym_not] = ACTIONS(3539),
    [anon_sym_compl] = ACTIONS(3539),
    [anon_sym_DASH_DASH] = ACTIONS(3541),
    [anon_sym_PLUS_PLUS] = ACTIONS(3541),
    [anon_sym_sizeof] = ACTIONS(3539),
    [anon_sym___alignof__] = ACTIONS(3539),
    [anon_sym___alignof] = ACTIONS(3539),
    [anon_sym__alignof] = ACTIONS(3539),
    [anon_sym_alignof] = ACTIONS(3539),
    [anon_sym__Alignof] = ACTIONS(3539),
    [anon_sym_offsetof] = ACTIONS(3539),
    [anon_sym__Generic] = ACTIONS(3539),
    [anon_sym_asm] = ACTIONS(3539),
    [anon_sym___asm__] = ACTIONS(3539),
    [sym_number_literal] = ACTIONS(3541),
    [anon_sym_L_SQUOTE] = ACTIONS(3541),
    [anon_sym_u_SQUOTE] = ACTIONS(3541),
    [anon_sym_U_SQUOTE] = ACTIONS(3541),
    [anon_sym_u8_SQUOTE] = ACTIONS(3541),
    [anon_sym_SQUOTE] = ACTIONS(3541),
    [anon_sym_L_DQUOTE] = ACTIONS(3541),
    [anon_sym_u_DQUOTE] = ACTIONS(3541),
    [anon_sym_U_DQUOTE] = ACTIONS(3541),
    [anon_sym_u8_DQUOTE] = ACTIONS(3541),
    [anon_sym_DQUOTE] = ACTIONS(3541),
    [sym_true] = ACTIONS(3539),
    [sym_false] = ACTIONS(3539),
    [anon_sym_NULL] = ACTIONS(3539),
    [anon_sym_nullptr] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_This] = ACTIONS(3539),
    [anon_sym_decltype] = ACTIONS(3539),
    [sym_virtual] = ACTIONS(3539),
    [anon_sym_explicit] = ACTIONS(3539),
    [anon_sym_typename] = ACTIONS(3539),
    [anon_sym_template] = ACTIONS(3539),
    [anon_sym_operator] = ACTIONS(3539),
    [anon_sym_try] = ACTIONS(3539),
    [anon_sym_delete] = ACTIONS(3539),
    [anon_sym_throw] = ACTIONS(3539),
    [anon_sym_namespace] = ACTIONS(3539),
    [anon_sym_using] = ACTIONS(3539),
    [anon_sym_static_assert] = ACTIONS(3539),
    [anon_sym_concept] = ACTIONS(3539),
    [anon_sym_co_return] = ACTIONS(3539),
    [anon_sym_co_yield] = ACTIONS(3539),
    [anon_sym_R_DQUOTE] = ACTIONS(3541),
    [anon_sym_LR_DQUOTE] = ACTIONS(3541),
    [anon_sym_uR_DQUOTE] = ACTIONS(3541),
    [anon_sym_UR_DQUOTE] = ACTIONS(3541),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3541),
    [anon_sym_co_await] = ACTIONS(3539),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_requires] = ACTIONS(3539),
    [sym_this] = ACTIONS(3539),
    [anon_sym_discard] = ACTIONS(3539),
    [anon_sym_precise] = ACTIONS(3539),
    [anon_sym_shared] = ACTIONS(3539),
    [anon_sym_groupshared] = ACTIONS(3539),
    [anon_sym_uniform] = ACTIONS(3539),
    [anon_sym_row_major] = ACTIONS(3539),
    [anon_sym_column_major] = ACTIONS(3539),
    [anon_sym_globallycoherent] = ACTIONS(3539),
    [anon_sym_centroid] = ACTIONS(3539),
    [anon_sym_noperspective] = ACTIONS(3539),
    [anon_sym_nointerpolation] = ACTIONS(3539),
    [anon_sym_sample] = ACTIONS(3539),
    [anon_sym_linear] = ACTIONS(3539),
    [anon_sym_snorm] = ACTIONS(3539),
    [anon_sym_unorm] = ACTIONS(3539),
    [anon_sym_point] = ACTIONS(3539),
    [anon_sym_line] = ACTIONS(3539),
    [anon_sym_triangleadj] = ACTIONS(3539),
    [anon_sym_lineadj] = ACTIONS(3539),
    [anon_sym_triangle] = ACTIONS(3539),
    [anon_sym_cbuffer] = ACTIONS(3539),
    [anon_sym_interface] = ACTIONS(3539),
    [anon_sym_extension] = ACTIONS(3539),
  },
  [481] = {
    [sym_identifier] = ACTIONS(3543),
    [aux_sym_preproc_include_token1] = ACTIONS(3543),
    [aux_sym_preproc_def_token1] = ACTIONS(3543),
    [aux_sym_preproc_if_token1] = ACTIONS(3543),
    [aux_sym_preproc_if_token2] = ACTIONS(3543),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3543),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3543),
    [aux_sym_preproc_else_token1] = ACTIONS(3543),
    [aux_sym_preproc_elif_token1] = ACTIONS(3543),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3543),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3543),
    [sym_preproc_directive] = ACTIONS(3543),
    [anon_sym_LPAREN2] = ACTIONS(3545),
    [anon_sym_BANG] = ACTIONS(3545),
    [anon_sym_TILDE] = ACTIONS(3545),
    [anon_sym_DASH] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(3543),
    [anon_sym_STAR] = ACTIONS(3545),
    [anon_sym_AMP_AMP] = ACTIONS(3545),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_SEMI] = ACTIONS(3545),
    [anon_sym___extension__] = ACTIONS(3543),
    [anon_sym_typedef] = ACTIONS(3543),
    [anon_sym_in] = ACTIONS(3543),
    [anon_sym_out] = ACTIONS(3543),
    [anon_sym_inout] = ACTIONS(3543),
    [anon_sym_extern] = ACTIONS(3543),
    [anon_sym___attribute__] = ACTIONS(3543),
    [anon_sym_COLON_COLON] = ACTIONS(3545),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3545),
    [anon_sym___declspec] = ACTIONS(3543),
    [anon_sym___based] = ACTIONS(3543),
    [anon_sym___cdecl] = ACTIONS(3543),
    [anon_sym___clrcall] = ACTIONS(3543),
    [anon_sym___stdcall] = ACTIONS(3543),
    [anon_sym___fastcall] = ACTIONS(3543),
    [anon_sym___thiscall] = ACTIONS(3543),
    [anon_sym___vectorcall] = ACTIONS(3543),
    [anon_sym_LBRACE] = ACTIONS(3545),
    [anon_sym_signed] = ACTIONS(3543),
    [anon_sym_unsigned] = ACTIONS(3543),
    [anon_sym_long] = ACTIONS(3543),
    [anon_sym_short] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3543),
    [anon_sym_static] = ACTIONS(3543),
    [anon_sym_register] = ACTIONS(3543),
    [anon_sym_inline] = ACTIONS(3543),
    [anon_sym___inline] = ACTIONS(3543),
    [anon_sym___inline__] = ACTIONS(3543),
    [anon_sym___forceinline] = ACTIONS(3543),
    [anon_sym_thread_local] = ACTIONS(3543),
    [anon_sym___thread] = ACTIONS(3543),
    [anon_sym_const] = ACTIONS(3543),
    [anon_sym_constexpr] = ACTIONS(3543),
    [anon_sym_volatile] = ACTIONS(3543),
    [anon_sym_restrict] = ACTIONS(3543),
    [anon_sym___restrict__] = ACTIONS(3543),
    [anon_sym__Atomic] = ACTIONS(3543),
    [anon_sym__Noreturn] = ACTIONS(3543),
    [anon_sym_noreturn] = ACTIONS(3543),
    [anon_sym_mutable] = ACTIONS(3543),
    [anon_sym_constinit] = ACTIONS(3543),
    [anon_sym_consteval] = ACTIONS(3543),
    [anon_sym_alignas] = ACTIONS(3543),
    [anon_sym__Alignas] = ACTIONS(3543),
    [sym_primitive_type] = ACTIONS(3543),
    [anon_sym_enum] = ACTIONS(3543),
    [anon_sym_class] = ACTIONS(3543),
    [anon_sym_struct] = ACTIONS(3543),
    [anon_sym_union] = ACTIONS(3543),
    [anon_sym_if] = ACTIONS(3543),
    [anon_sym_switch] = ACTIONS(3543),
    [anon_sym_case] = ACTIONS(3543),
    [anon_sym_default] = ACTIONS(3543),
    [anon_sym_while] = ACTIONS(3543),
    [anon_sym_do] = ACTIONS(3543),
    [anon_sym_for] = ACTIONS(3543),
    [anon_sym_return] = ACTIONS(3543),
    [anon_sym_break] = ACTIONS(3543),
    [anon_sym_continue] = ACTIONS(3543),
    [anon_sym_goto] = ACTIONS(3543),
    [anon_sym___try] = ACTIONS(3543),
    [anon_sym___leave] = ACTIONS(3543),
    [anon_sym_not] = ACTIONS(3543),
    [anon_sym_compl] = ACTIONS(3543),
    [anon_sym_DASH_DASH] = ACTIONS(3545),
    [anon_sym_PLUS_PLUS] = ACTIONS(3545),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym___alignof__] = ACTIONS(3543),
    [anon_sym___alignof] = ACTIONS(3543),
    [anon_sym__alignof] = ACTIONS(3543),
    [anon_sym_alignof] = ACTIONS(3543),
    [anon_sym__Alignof] = ACTIONS(3543),
    [anon_sym_offsetof] = ACTIONS(3543),
    [anon_sym__Generic] = ACTIONS(3543),
    [anon_sym_asm] = ACTIONS(3543),
    [anon_sym___asm__] = ACTIONS(3543),
    [sym_number_literal] = ACTIONS(3545),
    [anon_sym_L_SQUOTE] = ACTIONS(3545),
    [anon_sym_u_SQUOTE] = ACTIONS(3545),
    [anon_sym_U_SQUOTE] = ACTIONS(3545),
    [anon_sym_u8_SQUOTE] = ACTIONS(3545),
    [anon_sym_SQUOTE] = ACTIONS(3545),
    [anon_sym_L_DQUOTE] = ACTIONS(3545),
    [anon_sym_u_DQUOTE] = ACTIONS(3545),
    [anon_sym_U_DQUOTE] = ACTIONS(3545),
    [anon_sym_u8_DQUOTE] = ACTIONS(3545),
    [anon_sym_DQUOTE] = ACTIONS(3545),
    [sym_true] = ACTIONS(3543),
    [sym_false] = ACTIONS(3543),
    [anon_sym_NULL] = ACTIONS(3543),
    [anon_sym_nullptr] = ACTIONS(3543),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3543),
    [anon_sym_This] = ACTIONS(3543),
    [anon_sym_decltype] = ACTIONS(3543),
    [sym_virtual] = ACTIONS(3543),
    [anon_sym_explicit] = ACTIONS(3543),
    [anon_sym_typename] = ACTIONS(3543),
    [anon_sym_template] = ACTIONS(3543),
    [anon_sym_operator] = ACTIONS(3543),
    [anon_sym_try] = ACTIONS(3543),
    [anon_sym_delete] = ACTIONS(3543),
    [anon_sym_throw] = ACTIONS(3543),
    [anon_sym_namespace] = ACTIONS(3543),
    [anon_sym_using] = ACTIONS(3543),
    [anon_sym_static_assert] = ACTIONS(3543),
    [anon_sym_concept] = ACTIONS(3543),
    [anon_sym_co_return] = ACTIONS(3543),
    [anon_sym_co_yield] = ACTIONS(3543),
    [anon_sym_R_DQUOTE] = ACTIONS(3545),
    [anon_sym_LR_DQUOTE] = ACTIONS(3545),
    [anon_sym_uR_DQUOTE] = ACTIONS(3545),
    [anon_sym_UR_DQUOTE] = ACTIONS(3545),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3545),
    [anon_sym_co_await] = ACTIONS(3543),
    [anon_sym_new] = ACTIONS(3543),
    [anon_sym_requires] = ACTIONS(3543),
    [sym_this] = ACTIONS(3543),
    [anon_sym_discard] = ACTIONS(3543),
    [anon_sym_precise] = ACTIONS(3543),
    [anon_sym_shared] = ACTIONS(3543),
    [anon_sym_groupshared] = ACTIONS(3543),
    [anon_sym_uniform] = ACTIONS(3543),
    [anon_sym_row_major] = ACTIONS(3543),
    [anon_sym_column_major] = ACTIONS(3543),
    [anon_sym_globallycoherent] = ACTIONS(3543),
    [anon_sym_centroid] = ACTIONS(3543),
    [anon_sym_noperspective] = ACTIONS(3543),
    [anon_sym_nointerpolation] = ACTIONS(3543),
    [anon_sym_sample] = ACTIONS(3543),
    [anon_sym_linear] = ACTIONS(3543),
    [anon_sym_snorm] = ACTIONS(3543),
    [anon_sym_unorm] = ACTIONS(3543),
    [anon_sym_point] = ACTIONS(3543),
    [anon_sym_line] = ACTIONS(3543),
    [anon_sym_triangleadj] = ACTIONS(3543),
    [anon_sym_lineadj] = ACTIONS(3543),
    [anon_sym_triangle] = ACTIONS(3543),
    [anon_sym_cbuffer] = ACTIONS(3543),
    [anon_sym_interface] = ACTIONS(3543),
    [anon_sym_extension] = ACTIONS(3543),
  },
  [482] = {
    [sym_identifier] = ACTIONS(3547),
    [aux_sym_preproc_include_token1] = ACTIONS(3547),
    [aux_sym_preproc_def_token1] = ACTIONS(3547),
    [aux_sym_preproc_if_token1] = ACTIONS(3547),
    [aux_sym_preproc_if_token2] = ACTIONS(3547),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3547),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3547),
    [aux_sym_preproc_else_token1] = ACTIONS(3547),
    [aux_sym_preproc_elif_token1] = ACTIONS(3547),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3547),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3547),
    [sym_preproc_directive] = ACTIONS(3547),
    [anon_sym_LPAREN2] = ACTIONS(3549),
    [anon_sym_BANG] = ACTIONS(3549),
    [anon_sym_TILDE] = ACTIONS(3549),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_STAR] = ACTIONS(3549),
    [anon_sym_AMP_AMP] = ACTIONS(3549),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym_SEMI] = ACTIONS(3549),
    [anon_sym___extension__] = ACTIONS(3547),
    [anon_sym_typedef] = ACTIONS(3547),
    [anon_sym_in] = ACTIONS(3547),
    [anon_sym_out] = ACTIONS(3547),
    [anon_sym_inout] = ACTIONS(3547),
    [anon_sym_extern] = ACTIONS(3547),
    [anon_sym___attribute__] = ACTIONS(3547),
    [anon_sym_COLON_COLON] = ACTIONS(3549),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3549),
    [anon_sym___declspec] = ACTIONS(3547),
    [anon_sym___based] = ACTIONS(3547),
    [anon_sym___cdecl] = ACTIONS(3547),
    [anon_sym___clrcall] = ACTIONS(3547),
    [anon_sym___stdcall] = ACTIONS(3547),
    [anon_sym___fastcall] = ACTIONS(3547),
    [anon_sym___thiscall] = ACTIONS(3547),
    [anon_sym___vectorcall] = ACTIONS(3547),
    [anon_sym_LBRACE] = ACTIONS(3549),
    [anon_sym_signed] = ACTIONS(3547),
    [anon_sym_unsigned] = ACTIONS(3547),
    [anon_sym_long] = ACTIONS(3547),
    [anon_sym_short] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_static] = ACTIONS(3547),
    [anon_sym_register] = ACTIONS(3547),
    [anon_sym_inline] = ACTIONS(3547),
    [anon_sym___inline] = ACTIONS(3547),
    [anon_sym___inline__] = ACTIONS(3547),
    [anon_sym___forceinline] = ACTIONS(3547),
    [anon_sym_thread_local] = ACTIONS(3547),
    [anon_sym___thread] = ACTIONS(3547),
    [anon_sym_const] = ACTIONS(3547),
    [anon_sym_constexpr] = ACTIONS(3547),
    [anon_sym_volatile] = ACTIONS(3547),
    [anon_sym_restrict] = ACTIONS(3547),
    [anon_sym___restrict__] = ACTIONS(3547),
    [anon_sym__Atomic] = ACTIONS(3547),
    [anon_sym__Noreturn] = ACTIONS(3547),
    [anon_sym_noreturn] = ACTIONS(3547),
    [anon_sym_mutable] = ACTIONS(3547),
    [anon_sym_constinit] = ACTIONS(3547),
    [anon_sym_consteval] = ACTIONS(3547),
    [anon_sym_alignas] = ACTIONS(3547),
    [anon_sym__Alignas] = ACTIONS(3547),
    [sym_primitive_type] = ACTIONS(3547),
    [anon_sym_enum] = ACTIONS(3547),
    [anon_sym_class] = ACTIONS(3547),
    [anon_sym_struct] = ACTIONS(3547),
    [anon_sym_union] = ACTIONS(3547),
    [anon_sym_if] = ACTIONS(3547),
    [anon_sym_switch] = ACTIONS(3547),
    [anon_sym_case] = ACTIONS(3547),
    [anon_sym_default] = ACTIONS(3547),
    [anon_sym_while] = ACTIONS(3547),
    [anon_sym_do] = ACTIONS(3547),
    [anon_sym_for] = ACTIONS(3547),
    [anon_sym_return] = ACTIONS(3547),
    [anon_sym_break] = ACTIONS(3547),
    [anon_sym_continue] = ACTIONS(3547),
    [anon_sym_goto] = ACTIONS(3547),
    [anon_sym___try] = ACTIONS(3547),
    [anon_sym___leave] = ACTIONS(3547),
    [anon_sym_not] = ACTIONS(3547),
    [anon_sym_compl] = ACTIONS(3547),
    [anon_sym_DASH_DASH] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(3549),
    [anon_sym_sizeof] = ACTIONS(3547),
    [anon_sym___alignof__] = ACTIONS(3547),
    [anon_sym___alignof] = ACTIONS(3547),
    [anon_sym__alignof] = ACTIONS(3547),
    [anon_sym_alignof] = ACTIONS(3547),
    [anon_sym__Alignof] = ACTIONS(3547),
    [anon_sym_offsetof] = ACTIONS(3547),
    [anon_sym__Generic] = ACTIONS(3547),
    [anon_sym_asm] = ACTIONS(3547),
    [anon_sym___asm__] = ACTIONS(3547),
    [sym_number_literal] = ACTIONS(3549),
    [anon_sym_L_SQUOTE] = ACTIONS(3549),
    [anon_sym_u_SQUOTE] = ACTIONS(3549),
    [anon_sym_U_SQUOTE] = ACTIONS(3549),
    [anon_sym_u8_SQUOTE] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [anon_sym_L_DQUOTE] = ACTIONS(3549),
    [anon_sym_u_DQUOTE] = ACTIONS(3549),
    [anon_sym_U_DQUOTE] = ACTIONS(3549),
    [anon_sym_u8_DQUOTE] = ACTIONS(3549),
    [anon_sym_DQUOTE] = ACTIONS(3549),
    [sym_true] = ACTIONS(3547),
    [sym_false] = ACTIONS(3547),
    [anon_sym_NULL] = ACTIONS(3547),
    [anon_sym_nullptr] = ACTIONS(3547),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_This] = ACTIONS(3547),
    [anon_sym_decltype] = ACTIONS(3547),
    [sym_virtual] = ACTIONS(3547),
    [anon_sym_explicit] = ACTIONS(3547),
    [anon_sym_typename] = ACTIONS(3547),
    [anon_sym_template] = ACTIONS(3547),
    [anon_sym_operator] = ACTIONS(3547),
    [anon_sym_try] = ACTIONS(3547),
    [anon_sym_delete] = ACTIONS(3547),
    [anon_sym_throw] = ACTIONS(3547),
    [anon_sym_namespace] = ACTIONS(3547),
    [anon_sym_using] = ACTIONS(3547),
    [anon_sym_static_assert] = ACTIONS(3547),
    [anon_sym_concept] = ACTIONS(3547),
    [anon_sym_co_return] = ACTIONS(3547),
    [anon_sym_co_yield] = ACTIONS(3547),
    [anon_sym_R_DQUOTE] = ACTIONS(3549),
    [anon_sym_LR_DQUOTE] = ACTIONS(3549),
    [anon_sym_uR_DQUOTE] = ACTIONS(3549),
    [anon_sym_UR_DQUOTE] = ACTIONS(3549),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3549),
    [anon_sym_co_await] = ACTIONS(3547),
    [anon_sym_new] = ACTIONS(3547),
    [anon_sym_requires] = ACTIONS(3547),
    [sym_this] = ACTIONS(3547),
    [anon_sym_discard] = ACTIONS(3547),
    [anon_sym_precise] = ACTIONS(3547),
    [anon_sym_shared] = ACTIONS(3547),
    [anon_sym_groupshared] = ACTIONS(3547),
    [anon_sym_uniform] = ACTIONS(3547),
    [anon_sym_row_major] = ACTIONS(3547),
    [anon_sym_column_major] = ACTIONS(3547),
    [anon_sym_globallycoherent] = ACTIONS(3547),
    [anon_sym_centroid] = ACTIONS(3547),
    [anon_sym_noperspective] = ACTIONS(3547),
    [anon_sym_nointerpolation] = ACTIONS(3547),
    [anon_sym_sample] = ACTIONS(3547),
    [anon_sym_linear] = ACTIONS(3547),
    [anon_sym_snorm] = ACTIONS(3547),
    [anon_sym_unorm] = ACTIONS(3547),
    [anon_sym_point] = ACTIONS(3547),
    [anon_sym_line] = ACTIONS(3547),
    [anon_sym_triangleadj] = ACTIONS(3547),
    [anon_sym_lineadj] = ACTIONS(3547),
    [anon_sym_triangle] = ACTIONS(3547),
    [anon_sym_cbuffer] = ACTIONS(3547),
    [anon_sym_interface] = ACTIONS(3547),
    [anon_sym_extension] = ACTIONS(3547),
  },
  [483] = {
    [sym_identifier] = ACTIONS(3551),
    [aux_sym_preproc_include_token1] = ACTIONS(3551),
    [aux_sym_preproc_def_token1] = ACTIONS(3551),
    [aux_sym_preproc_if_token1] = ACTIONS(3551),
    [aux_sym_preproc_if_token2] = ACTIONS(3551),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3551),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3551),
    [aux_sym_preproc_else_token1] = ACTIONS(3551),
    [aux_sym_preproc_elif_token1] = ACTIONS(3551),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3551),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3551),
    [sym_preproc_directive] = ACTIONS(3551),
    [anon_sym_LPAREN2] = ACTIONS(3553),
    [anon_sym_BANG] = ACTIONS(3553),
    [anon_sym_TILDE] = ACTIONS(3553),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_PLUS] = ACTIONS(3551),
    [anon_sym_STAR] = ACTIONS(3553),
    [anon_sym_AMP_AMP] = ACTIONS(3553),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_SEMI] = ACTIONS(3553),
    [anon_sym___extension__] = ACTIONS(3551),
    [anon_sym_typedef] = ACTIONS(3551),
    [anon_sym_in] = ACTIONS(3551),
    [anon_sym_out] = ACTIONS(3551),
    [anon_sym_inout] = ACTIONS(3551),
    [anon_sym_extern] = ACTIONS(3551),
    [anon_sym___attribute__] = ACTIONS(3551),
    [anon_sym_COLON_COLON] = ACTIONS(3553),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3553),
    [anon_sym___declspec] = ACTIONS(3551),
    [anon_sym___based] = ACTIONS(3551),
    [anon_sym___cdecl] = ACTIONS(3551),
    [anon_sym___clrcall] = ACTIONS(3551),
    [anon_sym___stdcall] = ACTIONS(3551),
    [anon_sym___fastcall] = ACTIONS(3551),
    [anon_sym___thiscall] = ACTIONS(3551),
    [anon_sym___vectorcall] = ACTIONS(3551),
    [anon_sym_LBRACE] = ACTIONS(3553),
    [anon_sym_signed] = ACTIONS(3551),
    [anon_sym_unsigned] = ACTIONS(3551),
    [anon_sym_long] = ACTIONS(3551),
    [anon_sym_short] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3551),
    [anon_sym_static] = ACTIONS(3551),
    [anon_sym_register] = ACTIONS(3551),
    [anon_sym_inline] = ACTIONS(3551),
    [anon_sym___inline] = ACTIONS(3551),
    [anon_sym___inline__] = ACTIONS(3551),
    [anon_sym___forceinline] = ACTIONS(3551),
    [anon_sym_thread_local] = ACTIONS(3551),
    [anon_sym___thread] = ACTIONS(3551),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_constexpr] = ACTIONS(3551),
    [anon_sym_volatile] = ACTIONS(3551),
    [anon_sym_restrict] = ACTIONS(3551),
    [anon_sym___restrict__] = ACTIONS(3551),
    [anon_sym__Atomic] = ACTIONS(3551),
    [anon_sym__Noreturn] = ACTIONS(3551),
    [anon_sym_noreturn] = ACTIONS(3551),
    [anon_sym_mutable] = ACTIONS(3551),
    [anon_sym_constinit] = ACTIONS(3551),
    [anon_sym_consteval] = ACTIONS(3551),
    [anon_sym_alignas] = ACTIONS(3551),
    [anon_sym__Alignas] = ACTIONS(3551),
    [sym_primitive_type] = ACTIONS(3551),
    [anon_sym_enum] = ACTIONS(3551),
    [anon_sym_class] = ACTIONS(3551),
    [anon_sym_struct] = ACTIONS(3551),
    [anon_sym_union] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(3551),
    [anon_sym_switch] = ACTIONS(3551),
    [anon_sym_case] = ACTIONS(3551),
    [anon_sym_default] = ACTIONS(3551),
    [anon_sym_while] = ACTIONS(3551),
    [anon_sym_do] = ACTIONS(3551),
    [anon_sym_for] = ACTIONS(3551),
    [anon_sym_return] = ACTIONS(3551),
    [anon_sym_break] = ACTIONS(3551),
    [anon_sym_continue] = ACTIONS(3551),
    [anon_sym_goto] = ACTIONS(3551),
    [anon_sym___try] = ACTIONS(3551),
    [anon_sym___leave] = ACTIONS(3551),
    [anon_sym_not] = ACTIONS(3551),
    [anon_sym_compl] = ACTIONS(3551),
    [anon_sym_DASH_DASH] = ACTIONS(3553),
    [anon_sym_PLUS_PLUS] = ACTIONS(3553),
    [anon_sym_sizeof] = ACTIONS(3551),
    [anon_sym___alignof__] = ACTIONS(3551),
    [anon_sym___alignof] = ACTIONS(3551),
    [anon_sym__alignof] = ACTIONS(3551),
    [anon_sym_alignof] = ACTIONS(3551),
    [anon_sym__Alignof] = ACTIONS(3551),
    [anon_sym_offsetof] = ACTIONS(3551),
    [anon_sym__Generic] = ACTIONS(3551),
    [anon_sym_asm] = ACTIONS(3551),
    [anon_sym___asm__] = ACTIONS(3551),
    [sym_number_literal] = ACTIONS(3553),
    [anon_sym_L_SQUOTE] = ACTIONS(3553),
    [anon_sym_u_SQUOTE] = ACTIONS(3553),
    [anon_sym_U_SQUOTE] = ACTIONS(3553),
    [anon_sym_u8_SQUOTE] = ACTIONS(3553),
    [anon_sym_SQUOTE] = ACTIONS(3553),
    [anon_sym_L_DQUOTE] = ACTIONS(3553),
    [anon_sym_u_DQUOTE] = ACTIONS(3553),
    [anon_sym_U_DQUOTE] = ACTIONS(3553),
    [anon_sym_u8_DQUOTE] = ACTIONS(3553),
    [anon_sym_DQUOTE] = ACTIONS(3553),
    [sym_true] = ACTIONS(3551),
    [sym_false] = ACTIONS(3551),
    [anon_sym_NULL] = ACTIONS(3551),
    [anon_sym_nullptr] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3551),
    [anon_sym_let] = ACTIONS(3551),
    [anon_sym_This] = ACTIONS(3551),
    [anon_sym_decltype] = ACTIONS(3551),
    [sym_virtual] = ACTIONS(3551),
    [anon_sym_explicit] = ACTIONS(3551),
    [anon_sym_typename] = ACTIONS(3551),
    [anon_sym_template] = ACTIONS(3551),
    [anon_sym_operator] = ACTIONS(3551),
    [anon_sym_try] = ACTIONS(3551),
    [anon_sym_delete] = ACTIONS(3551),
    [anon_sym_throw] = ACTIONS(3551),
    [anon_sym_namespace] = ACTIONS(3551),
    [anon_sym_using] = ACTIONS(3551),
    [anon_sym_static_assert] = ACTIONS(3551),
    [anon_sym_concept] = ACTIONS(3551),
    [anon_sym_co_return] = ACTIONS(3551),
    [anon_sym_co_yield] = ACTIONS(3551),
    [anon_sym_R_DQUOTE] = ACTIONS(3553),
    [anon_sym_LR_DQUOTE] = ACTIONS(3553),
    [anon_sym_uR_DQUOTE] = ACTIONS(3553),
    [anon_sym_UR_DQUOTE] = ACTIONS(3553),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3553),
    [anon_sym_co_await] = ACTIONS(3551),
    [anon_sym_new] = ACTIONS(3551),
    [anon_sym_requires] = ACTIONS(3551),
    [sym_this] = ACTIONS(3551),
    [anon_sym_discard] = ACTIONS(3551),
    [anon_sym_precise] = ACTIONS(3551),
    [anon_sym_shared] = ACTIONS(3551),
    [anon_sym_groupshared] = ACTIONS(3551),
    [anon_sym_uniform] = ACTIONS(3551),
    [anon_sym_row_major] = ACTIONS(3551),
    [anon_sym_column_major] = ACTIONS(3551),
    [anon_sym_globallycoherent] = ACTIONS(3551),
    [anon_sym_centroid] = ACTIONS(3551),
    [anon_sym_noperspective] = ACTIONS(3551),
    [anon_sym_nointerpolation] = ACTIONS(3551),
    [anon_sym_sample] = ACTIONS(3551),
    [anon_sym_linear] = ACTIONS(3551),
    [anon_sym_snorm] = ACTIONS(3551),
    [anon_sym_unorm] = ACTIONS(3551),
    [anon_sym_point] = ACTIONS(3551),
    [anon_sym_line] = ACTIONS(3551),
    [anon_sym_triangleadj] = ACTIONS(3551),
    [anon_sym_lineadj] = ACTIONS(3551),
    [anon_sym_triangle] = ACTIONS(3551),
    [anon_sym_cbuffer] = ACTIONS(3551),
    [anon_sym_interface] = ACTIONS(3551),
    [anon_sym_extension] = ACTIONS(3551),
  },
  [484] = {
    [sym_identifier] = ACTIONS(3555),
    [aux_sym_preproc_include_token1] = ACTIONS(3555),
    [aux_sym_preproc_def_token1] = ACTIONS(3555),
    [aux_sym_preproc_if_token1] = ACTIONS(3555),
    [aux_sym_preproc_if_token2] = ACTIONS(3555),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3555),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3555),
    [aux_sym_preproc_else_token1] = ACTIONS(3555),
    [aux_sym_preproc_elif_token1] = ACTIONS(3555),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3555),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3555),
    [sym_preproc_directive] = ACTIONS(3555),
    [anon_sym_LPAREN2] = ACTIONS(3557),
    [anon_sym_BANG] = ACTIONS(3557),
    [anon_sym_TILDE] = ACTIONS(3557),
    [anon_sym_DASH] = ACTIONS(3555),
    [anon_sym_PLUS] = ACTIONS(3555),
    [anon_sym_STAR] = ACTIONS(3557),
    [anon_sym_AMP_AMP] = ACTIONS(3557),
    [anon_sym_AMP] = ACTIONS(3555),
    [anon_sym_SEMI] = ACTIONS(3557),
    [anon_sym___extension__] = ACTIONS(3555),
    [anon_sym_typedef] = ACTIONS(3555),
    [anon_sym_in] = ACTIONS(3555),
    [anon_sym_out] = ACTIONS(3555),
    [anon_sym_inout] = ACTIONS(3555),
    [anon_sym_extern] = ACTIONS(3555),
    [anon_sym___attribute__] = ACTIONS(3555),
    [anon_sym_COLON_COLON] = ACTIONS(3557),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3557),
    [anon_sym___declspec] = ACTIONS(3555),
    [anon_sym___based] = ACTIONS(3555),
    [anon_sym___cdecl] = ACTIONS(3555),
    [anon_sym___clrcall] = ACTIONS(3555),
    [anon_sym___stdcall] = ACTIONS(3555),
    [anon_sym___fastcall] = ACTIONS(3555),
    [anon_sym___thiscall] = ACTIONS(3555),
    [anon_sym___vectorcall] = ACTIONS(3555),
    [anon_sym_LBRACE] = ACTIONS(3557),
    [anon_sym_signed] = ACTIONS(3555),
    [anon_sym_unsigned] = ACTIONS(3555),
    [anon_sym_long] = ACTIONS(3555),
    [anon_sym_short] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3555),
    [anon_sym_static] = ACTIONS(3555),
    [anon_sym_register] = ACTIONS(3555),
    [anon_sym_inline] = ACTIONS(3555),
    [anon_sym___inline] = ACTIONS(3555),
    [anon_sym___inline__] = ACTIONS(3555),
    [anon_sym___forceinline] = ACTIONS(3555),
    [anon_sym_thread_local] = ACTIONS(3555),
    [anon_sym___thread] = ACTIONS(3555),
    [anon_sym_const] = ACTIONS(3555),
    [anon_sym_constexpr] = ACTIONS(3555),
    [anon_sym_volatile] = ACTIONS(3555),
    [anon_sym_restrict] = ACTIONS(3555),
    [anon_sym___restrict__] = ACTIONS(3555),
    [anon_sym__Atomic] = ACTIONS(3555),
    [anon_sym__Noreturn] = ACTIONS(3555),
    [anon_sym_noreturn] = ACTIONS(3555),
    [anon_sym_mutable] = ACTIONS(3555),
    [anon_sym_constinit] = ACTIONS(3555),
    [anon_sym_consteval] = ACTIONS(3555),
    [anon_sym_alignas] = ACTIONS(3555),
    [anon_sym__Alignas] = ACTIONS(3555),
    [sym_primitive_type] = ACTIONS(3555),
    [anon_sym_enum] = ACTIONS(3555),
    [anon_sym_class] = ACTIONS(3555),
    [anon_sym_struct] = ACTIONS(3555),
    [anon_sym_union] = ACTIONS(3555),
    [anon_sym_if] = ACTIONS(3555),
    [anon_sym_switch] = ACTIONS(3555),
    [anon_sym_case] = ACTIONS(3555),
    [anon_sym_default] = ACTIONS(3555),
    [anon_sym_while] = ACTIONS(3555),
    [anon_sym_do] = ACTIONS(3555),
    [anon_sym_for] = ACTIONS(3555),
    [anon_sym_return] = ACTIONS(3555),
    [anon_sym_break] = ACTIONS(3555),
    [anon_sym_continue] = ACTIONS(3555),
    [anon_sym_goto] = ACTIONS(3555),
    [anon_sym___try] = ACTIONS(3555),
    [anon_sym___leave] = ACTIONS(3555),
    [anon_sym_not] = ACTIONS(3555),
    [anon_sym_compl] = ACTIONS(3555),
    [anon_sym_DASH_DASH] = ACTIONS(3557),
    [anon_sym_PLUS_PLUS] = ACTIONS(3557),
    [anon_sym_sizeof] = ACTIONS(3555),
    [anon_sym___alignof__] = ACTIONS(3555),
    [anon_sym___alignof] = ACTIONS(3555),
    [anon_sym__alignof] = ACTIONS(3555),
    [anon_sym_alignof] = ACTIONS(3555),
    [anon_sym__Alignof] = ACTIONS(3555),
    [anon_sym_offsetof] = ACTIONS(3555),
    [anon_sym__Generic] = ACTIONS(3555),
    [anon_sym_asm] = ACTIONS(3555),
    [anon_sym___asm__] = ACTIONS(3555),
    [sym_number_literal] = ACTIONS(3557),
    [anon_sym_L_SQUOTE] = ACTIONS(3557),
    [anon_sym_u_SQUOTE] = ACTIONS(3557),
    [anon_sym_U_SQUOTE] = ACTIONS(3557),
    [anon_sym_u8_SQUOTE] = ACTIONS(3557),
    [anon_sym_SQUOTE] = ACTIONS(3557),
    [anon_sym_L_DQUOTE] = ACTIONS(3557),
    [anon_sym_u_DQUOTE] = ACTIONS(3557),
    [anon_sym_U_DQUOTE] = ACTIONS(3557),
    [anon_sym_u8_DQUOTE] = ACTIONS(3557),
    [anon_sym_DQUOTE] = ACTIONS(3557),
    [sym_true] = ACTIONS(3555),
    [sym_false] = ACTIONS(3555),
    [anon_sym_NULL] = ACTIONS(3555),
    [anon_sym_nullptr] = ACTIONS(3555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3555),
    [anon_sym_let] = ACTIONS(3555),
    [anon_sym_This] = ACTIONS(3555),
    [anon_sym_decltype] = ACTIONS(3555),
    [sym_virtual] = ACTIONS(3555),
    [anon_sym_explicit] = ACTIONS(3555),
    [anon_sym_typename] = ACTIONS(3555),
    [anon_sym_template] = ACTIONS(3555),
    [anon_sym_operator] = ACTIONS(3555),
    [anon_sym_try] = ACTIONS(3555),
    [anon_sym_delete] = ACTIONS(3555),
    [anon_sym_throw] = ACTIONS(3555),
    [anon_sym_namespace] = ACTIONS(3555),
    [anon_sym_using] = ACTIONS(3555),
    [anon_sym_static_assert] = ACTIONS(3555),
    [anon_sym_concept] = ACTIONS(3555),
    [anon_sym_co_return] = ACTIONS(3555),
    [anon_sym_co_yield] = ACTIONS(3555),
    [anon_sym_R_DQUOTE] = ACTIONS(3557),
    [anon_sym_LR_DQUOTE] = ACTIONS(3557),
    [anon_sym_uR_DQUOTE] = ACTIONS(3557),
    [anon_sym_UR_DQUOTE] = ACTIONS(3557),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3557),
    [anon_sym_co_await] = ACTIONS(3555),
    [anon_sym_new] = ACTIONS(3555),
    [anon_sym_requires] = ACTIONS(3555),
    [sym_this] = ACTIONS(3555),
    [anon_sym_discard] = ACTIONS(3555),
    [anon_sym_precise] = ACTIONS(3555),
    [anon_sym_shared] = ACTIONS(3555),
    [anon_sym_groupshared] = ACTIONS(3555),
    [anon_sym_uniform] = ACTIONS(3555),
    [anon_sym_row_major] = ACTIONS(3555),
    [anon_sym_column_major] = ACTIONS(3555),
    [anon_sym_globallycoherent] = ACTIONS(3555),
    [anon_sym_centroid] = ACTIONS(3555),
    [anon_sym_noperspective] = ACTIONS(3555),
    [anon_sym_nointerpolation] = ACTIONS(3555),
    [anon_sym_sample] = ACTIONS(3555),
    [anon_sym_linear] = ACTIONS(3555),
    [anon_sym_snorm] = ACTIONS(3555),
    [anon_sym_unorm] = ACTIONS(3555),
    [anon_sym_point] = ACTIONS(3555),
    [anon_sym_line] = ACTIONS(3555),
    [anon_sym_triangleadj] = ACTIONS(3555),
    [anon_sym_lineadj] = ACTIONS(3555),
    [anon_sym_triangle] = ACTIONS(3555),
    [anon_sym_cbuffer] = ACTIONS(3555),
    [anon_sym_interface] = ACTIONS(3555),
    [anon_sym_extension] = ACTIONS(3555),
  },
  [485] = {
    [sym_identifier] = ACTIONS(3559),
    [aux_sym_preproc_include_token1] = ACTIONS(3559),
    [aux_sym_preproc_def_token1] = ACTIONS(3559),
    [aux_sym_preproc_if_token1] = ACTIONS(3559),
    [aux_sym_preproc_if_token2] = ACTIONS(3559),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3559),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3559),
    [aux_sym_preproc_else_token1] = ACTIONS(3559),
    [aux_sym_preproc_elif_token1] = ACTIONS(3559),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3559),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3559),
    [sym_preproc_directive] = ACTIONS(3559),
    [anon_sym_LPAREN2] = ACTIONS(3561),
    [anon_sym_BANG] = ACTIONS(3561),
    [anon_sym_TILDE] = ACTIONS(3561),
    [anon_sym_DASH] = ACTIONS(3559),
    [anon_sym_PLUS] = ACTIONS(3559),
    [anon_sym_STAR] = ACTIONS(3561),
    [anon_sym_AMP_AMP] = ACTIONS(3561),
    [anon_sym_AMP] = ACTIONS(3559),
    [anon_sym_SEMI] = ACTIONS(3561),
    [anon_sym___extension__] = ACTIONS(3559),
    [anon_sym_typedef] = ACTIONS(3559),
    [anon_sym_in] = ACTIONS(3559),
    [anon_sym_out] = ACTIONS(3559),
    [anon_sym_inout] = ACTIONS(3559),
    [anon_sym_extern] = ACTIONS(3559),
    [anon_sym___attribute__] = ACTIONS(3559),
    [anon_sym_COLON_COLON] = ACTIONS(3561),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3561),
    [anon_sym___declspec] = ACTIONS(3559),
    [anon_sym___based] = ACTIONS(3559),
    [anon_sym___cdecl] = ACTIONS(3559),
    [anon_sym___clrcall] = ACTIONS(3559),
    [anon_sym___stdcall] = ACTIONS(3559),
    [anon_sym___fastcall] = ACTIONS(3559),
    [anon_sym___thiscall] = ACTIONS(3559),
    [anon_sym___vectorcall] = ACTIONS(3559),
    [anon_sym_LBRACE] = ACTIONS(3561),
    [anon_sym_signed] = ACTIONS(3559),
    [anon_sym_unsigned] = ACTIONS(3559),
    [anon_sym_long] = ACTIONS(3559),
    [anon_sym_short] = ACTIONS(3559),
    [anon_sym_LBRACK] = ACTIONS(3559),
    [anon_sym_static] = ACTIONS(3559),
    [anon_sym_register] = ACTIONS(3559),
    [anon_sym_inline] = ACTIONS(3559),
    [anon_sym___inline] = ACTIONS(3559),
    [anon_sym___inline__] = ACTIONS(3559),
    [anon_sym___forceinline] = ACTIONS(3559),
    [anon_sym_thread_local] = ACTIONS(3559),
    [anon_sym___thread] = ACTIONS(3559),
    [anon_sym_const] = ACTIONS(3559),
    [anon_sym_constexpr] = ACTIONS(3559),
    [anon_sym_volatile] = ACTIONS(3559),
    [anon_sym_restrict] = ACTIONS(3559),
    [anon_sym___restrict__] = ACTIONS(3559),
    [anon_sym__Atomic] = ACTIONS(3559),
    [anon_sym__Noreturn] = ACTIONS(3559),
    [anon_sym_noreturn] = ACTIONS(3559),
    [anon_sym_mutable] = ACTIONS(3559),
    [anon_sym_constinit] = ACTIONS(3559),
    [anon_sym_consteval] = ACTIONS(3559),
    [anon_sym_alignas] = ACTIONS(3559),
    [anon_sym__Alignas] = ACTIONS(3559),
    [sym_primitive_type] = ACTIONS(3559),
    [anon_sym_enum] = ACTIONS(3559),
    [anon_sym_class] = ACTIONS(3559),
    [anon_sym_struct] = ACTIONS(3559),
    [anon_sym_union] = ACTIONS(3559),
    [anon_sym_if] = ACTIONS(3559),
    [anon_sym_switch] = ACTIONS(3559),
    [anon_sym_case] = ACTIONS(3559),
    [anon_sym_default] = ACTIONS(3559),
    [anon_sym_while] = ACTIONS(3559),
    [anon_sym_do] = ACTIONS(3559),
    [anon_sym_for] = ACTIONS(3559),
    [anon_sym_return] = ACTIONS(3559),
    [anon_sym_break] = ACTIONS(3559),
    [anon_sym_continue] = ACTIONS(3559),
    [anon_sym_goto] = ACTIONS(3559),
    [anon_sym___try] = ACTIONS(3559),
    [anon_sym___leave] = ACTIONS(3559),
    [anon_sym_not] = ACTIONS(3559),
    [anon_sym_compl] = ACTIONS(3559),
    [anon_sym_DASH_DASH] = ACTIONS(3561),
    [anon_sym_PLUS_PLUS] = ACTIONS(3561),
    [anon_sym_sizeof] = ACTIONS(3559),
    [anon_sym___alignof__] = ACTIONS(3559),
    [anon_sym___alignof] = ACTIONS(3559),
    [anon_sym__alignof] = ACTIONS(3559),
    [anon_sym_alignof] = ACTIONS(3559),
    [anon_sym__Alignof] = ACTIONS(3559),
    [anon_sym_offsetof] = ACTIONS(3559),
    [anon_sym__Generic] = ACTIONS(3559),
    [anon_sym_asm] = ACTIONS(3559),
    [anon_sym___asm__] = ACTIONS(3559),
    [sym_number_literal] = ACTIONS(3561),
    [anon_sym_L_SQUOTE] = ACTIONS(3561),
    [anon_sym_u_SQUOTE] = ACTIONS(3561),
    [anon_sym_U_SQUOTE] = ACTIONS(3561),
    [anon_sym_u8_SQUOTE] = ACTIONS(3561),
    [anon_sym_SQUOTE] = ACTIONS(3561),
    [anon_sym_L_DQUOTE] = ACTIONS(3561),
    [anon_sym_u_DQUOTE] = ACTIONS(3561),
    [anon_sym_U_DQUOTE] = ACTIONS(3561),
    [anon_sym_u8_DQUOTE] = ACTIONS(3561),
    [anon_sym_DQUOTE] = ACTIONS(3561),
    [sym_true] = ACTIONS(3559),
    [sym_false] = ACTIONS(3559),
    [anon_sym_NULL] = ACTIONS(3559),
    [anon_sym_nullptr] = ACTIONS(3559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3559),
    [anon_sym_let] = ACTIONS(3559),
    [anon_sym_This] = ACTIONS(3559),
    [anon_sym_decltype] = ACTIONS(3559),
    [sym_virtual] = ACTIONS(3559),
    [anon_sym_explicit] = ACTIONS(3559),
    [anon_sym_typename] = ACTIONS(3559),
    [anon_sym_template] = ACTIONS(3559),
    [anon_sym_operator] = ACTIONS(3559),
    [anon_sym_try] = ACTIONS(3559),
    [anon_sym_delete] = ACTIONS(3559),
    [anon_sym_throw] = ACTIONS(3559),
    [anon_sym_namespace] = ACTIONS(3559),
    [anon_sym_using] = ACTIONS(3559),
    [anon_sym_static_assert] = ACTIONS(3559),
    [anon_sym_concept] = ACTIONS(3559),
    [anon_sym_co_return] = ACTIONS(3559),
    [anon_sym_co_yield] = ACTIONS(3559),
    [anon_sym_R_DQUOTE] = ACTIONS(3561),
    [anon_sym_LR_DQUOTE] = ACTIONS(3561),
    [anon_sym_uR_DQUOTE] = ACTIONS(3561),
    [anon_sym_UR_DQUOTE] = ACTIONS(3561),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3561),
    [anon_sym_co_await] = ACTIONS(3559),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_requires] = ACTIONS(3559),
    [sym_this] = ACTIONS(3559),
    [anon_sym_discard] = ACTIONS(3559),
    [anon_sym_precise] = ACTIONS(3559),
    [anon_sym_shared] = ACTIONS(3559),
    [anon_sym_groupshared] = ACTIONS(3559),
    [anon_sym_uniform] = ACTIONS(3559),
    [anon_sym_row_major] = ACTIONS(3559),
    [anon_sym_column_major] = ACTIONS(3559),
    [anon_sym_globallycoherent] = ACTIONS(3559),
    [anon_sym_centroid] = ACTIONS(3559),
    [anon_sym_noperspective] = ACTIONS(3559),
    [anon_sym_nointerpolation] = ACTIONS(3559),
    [anon_sym_sample] = ACTIONS(3559),
    [anon_sym_linear] = ACTIONS(3559),
    [anon_sym_snorm] = ACTIONS(3559),
    [anon_sym_unorm] = ACTIONS(3559),
    [anon_sym_point] = ACTIONS(3559),
    [anon_sym_line] = ACTIONS(3559),
    [anon_sym_triangleadj] = ACTIONS(3559),
    [anon_sym_lineadj] = ACTIONS(3559),
    [anon_sym_triangle] = ACTIONS(3559),
    [anon_sym_cbuffer] = ACTIONS(3559),
    [anon_sym_interface] = ACTIONS(3559),
    [anon_sym_extension] = ACTIONS(3559),
  },
  [486] = {
    [sym_identifier] = ACTIONS(3563),
    [aux_sym_preproc_include_token1] = ACTIONS(3563),
    [aux_sym_preproc_def_token1] = ACTIONS(3563),
    [aux_sym_preproc_if_token1] = ACTIONS(3563),
    [aux_sym_preproc_if_token2] = ACTIONS(3563),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3563),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3563),
    [aux_sym_preproc_else_token1] = ACTIONS(3563),
    [aux_sym_preproc_elif_token1] = ACTIONS(3563),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3563),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3563),
    [sym_preproc_directive] = ACTIONS(3563),
    [anon_sym_LPAREN2] = ACTIONS(3565),
    [anon_sym_BANG] = ACTIONS(3565),
    [anon_sym_TILDE] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3563),
    [anon_sym_PLUS] = ACTIONS(3563),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_AMP_AMP] = ACTIONS(3565),
    [anon_sym_AMP] = ACTIONS(3563),
    [anon_sym_SEMI] = ACTIONS(3565),
    [anon_sym___extension__] = ACTIONS(3563),
    [anon_sym_typedef] = ACTIONS(3563),
    [anon_sym_in] = ACTIONS(3563),
    [anon_sym_out] = ACTIONS(3563),
    [anon_sym_inout] = ACTIONS(3563),
    [anon_sym_extern] = ACTIONS(3563),
    [anon_sym___attribute__] = ACTIONS(3563),
    [anon_sym_COLON_COLON] = ACTIONS(3565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3565),
    [anon_sym___declspec] = ACTIONS(3563),
    [anon_sym___based] = ACTIONS(3563),
    [anon_sym___cdecl] = ACTIONS(3563),
    [anon_sym___clrcall] = ACTIONS(3563),
    [anon_sym___stdcall] = ACTIONS(3563),
    [anon_sym___fastcall] = ACTIONS(3563),
    [anon_sym___thiscall] = ACTIONS(3563),
    [anon_sym___vectorcall] = ACTIONS(3563),
    [anon_sym_LBRACE] = ACTIONS(3565),
    [anon_sym_signed] = ACTIONS(3563),
    [anon_sym_unsigned] = ACTIONS(3563),
    [anon_sym_long] = ACTIONS(3563),
    [anon_sym_short] = ACTIONS(3563),
    [anon_sym_LBRACK] = ACTIONS(3563),
    [anon_sym_static] = ACTIONS(3563),
    [anon_sym_register] = ACTIONS(3563),
    [anon_sym_inline] = ACTIONS(3563),
    [anon_sym___inline] = ACTIONS(3563),
    [anon_sym___inline__] = ACTIONS(3563),
    [anon_sym___forceinline] = ACTIONS(3563),
    [anon_sym_thread_local] = ACTIONS(3563),
    [anon_sym___thread] = ACTIONS(3563),
    [anon_sym_const] = ACTIONS(3563),
    [anon_sym_constexpr] = ACTIONS(3563),
    [anon_sym_volatile] = ACTIONS(3563),
    [anon_sym_restrict] = ACTIONS(3563),
    [anon_sym___restrict__] = ACTIONS(3563),
    [anon_sym__Atomic] = ACTIONS(3563),
    [anon_sym__Noreturn] = ACTIONS(3563),
    [anon_sym_noreturn] = ACTIONS(3563),
    [anon_sym_mutable] = ACTIONS(3563),
    [anon_sym_constinit] = ACTIONS(3563),
    [anon_sym_consteval] = ACTIONS(3563),
    [anon_sym_alignas] = ACTIONS(3563),
    [anon_sym__Alignas] = ACTIONS(3563),
    [sym_primitive_type] = ACTIONS(3563),
    [anon_sym_enum] = ACTIONS(3563),
    [anon_sym_class] = ACTIONS(3563),
    [anon_sym_struct] = ACTIONS(3563),
    [anon_sym_union] = ACTIONS(3563),
    [anon_sym_if] = ACTIONS(3563),
    [anon_sym_switch] = ACTIONS(3563),
    [anon_sym_case] = ACTIONS(3563),
    [anon_sym_default] = ACTIONS(3563),
    [anon_sym_while] = ACTIONS(3563),
    [anon_sym_do] = ACTIONS(3563),
    [anon_sym_for] = ACTIONS(3563),
    [anon_sym_return] = ACTIONS(3563),
    [anon_sym_break] = ACTIONS(3563),
    [anon_sym_continue] = ACTIONS(3563),
    [anon_sym_goto] = ACTIONS(3563),
    [anon_sym___try] = ACTIONS(3563),
    [anon_sym___leave] = ACTIONS(3563),
    [anon_sym_not] = ACTIONS(3563),
    [anon_sym_compl] = ACTIONS(3563),
    [anon_sym_DASH_DASH] = ACTIONS(3565),
    [anon_sym_PLUS_PLUS] = ACTIONS(3565),
    [anon_sym_sizeof] = ACTIONS(3563),
    [anon_sym___alignof__] = ACTIONS(3563),
    [anon_sym___alignof] = ACTIONS(3563),
    [anon_sym__alignof] = ACTIONS(3563),
    [anon_sym_alignof] = ACTIONS(3563),
    [anon_sym__Alignof] = ACTIONS(3563),
    [anon_sym_offsetof] = ACTIONS(3563),
    [anon_sym__Generic] = ACTIONS(3563),
    [anon_sym_asm] = ACTIONS(3563),
    [anon_sym___asm__] = ACTIONS(3563),
    [sym_number_literal] = ACTIONS(3565),
    [anon_sym_L_SQUOTE] = ACTIONS(3565),
    [anon_sym_u_SQUOTE] = ACTIONS(3565),
    [anon_sym_U_SQUOTE] = ACTIONS(3565),
    [anon_sym_u8_SQUOTE] = ACTIONS(3565),
    [anon_sym_SQUOTE] = ACTIONS(3565),
    [anon_sym_L_DQUOTE] = ACTIONS(3565),
    [anon_sym_u_DQUOTE] = ACTIONS(3565),
    [anon_sym_U_DQUOTE] = ACTIONS(3565),
    [anon_sym_u8_DQUOTE] = ACTIONS(3565),
    [anon_sym_DQUOTE] = ACTIONS(3565),
    [sym_true] = ACTIONS(3563),
    [sym_false] = ACTIONS(3563),
    [anon_sym_NULL] = ACTIONS(3563),
    [anon_sym_nullptr] = ACTIONS(3563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3563),
    [anon_sym_let] = ACTIONS(3563),
    [anon_sym_This] = ACTIONS(3563),
    [anon_sym_decltype] = ACTIONS(3563),
    [sym_virtual] = ACTIONS(3563),
    [anon_sym_explicit] = ACTIONS(3563),
    [anon_sym_typename] = ACTIONS(3563),
    [anon_sym_template] = ACTIONS(3563),
    [anon_sym_operator] = ACTIONS(3563),
    [anon_sym_try] = ACTIONS(3563),
    [anon_sym_delete] = ACTIONS(3563),
    [anon_sym_throw] = ACTIONS(3563),
    [anon_sym_namespace] = ACTIONS(3563),
    [anon_sym_using] = ACTIONS(3563),
    [anon_sym_static_assert] = ACTIONS(3563),
    [anon_sym_concept] = ACTIONS(3563),
    [anon_sym_co_return] = ACTIONS(3563),
    [anon_sym_co_yield] = ACTIONS(3563),
    [anon_sym_R_DQUOTE] = ACTIONS(3565),
    [anon_sym_LR_DQUOTE] = ACTIONS(3565),
    [anon_sym_uR_DQUOTE] = ACTIONS(3565),
    [anon_sym_UR_DQUOTE] = ACTIONS(3565),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3565),
    [anon_sym_co_await] = ACTIONS(3563),
    [anon_sym_new] = ACTIONS(3563),
    [anon_sym_requires] = ACTIONS(3563),
    [sym_this] = ACTIONS(3563),
    [anon_sym_discard] = ACTIONS(3563),
    [anon_sym_precise] = ACTIONS(3563),
    [anon_sym_shared] = ACTIONS(3563),
    [anon_sym_groupshared] = ACTIONS(3563),
    [anon_sym_uniform] = ACTIONS(3563),
    [anon_sym_row_major] = ACTIONS(3563),
    [anon_sym_column_major] = ACTIONS(3563),
    [anon_sym_globallycoherent] = ACTIONS(3563),
    [anon_sym_centroid] = ACTIONS(3563),
    [anon_sym_noperspective] = ACTIONS(3563),
    [anon_sym_nointerpolation] = ACTIONS(3563),
    [anon_sym_sample] = ACTIONS(3563),
    [anon_sym_linear] = ACTIONS(3563),
    [anon_sym_snorm] = ACTIONS(3563),
    [anon_sym_unorm] = ACTIONS(3563),
    [anon_sym_point] = ACTIONS(3563),
    [anon_sym_line] = ACTIONS(3563),
    [anon_sym_triangleadj] = ACTIONS(3563),
    [anon_sym_lineadj] = ACTIONS(3563),
    [anon_sym_triangle] = ACTIONS(3563),
    [anon_sym_cbuffer] = ACTIONS(3563),
    [anon_sym_interface] = ACTIONS(3563),
    [anon_sym_extension] = ACTIONS(3563),
  },
  [487] = {
    [sym_identifier] = ACTIONS(3429),
    [aux_sym_preproc_include_token1] = ACTIONS(3429),
    [aux_sym_preproc_def_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token2] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3429),
    [aux_sym_preproc_else_token1] = ACTIONS(3429),
    [aux_sym_preproc_elif_token1] = ACTIONS(3429),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3429),
    [sym_preproc_directive] = ACTIONS(3429),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_BANG] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym_SEMI] = ACTIONS(3431),
    [anon_sym___extension__] = ACTIONS(3429),
    [anon_sym_typedef] = ACTIONS(3429),
    [anon_sym_in] = ACTIONS(3429),
    [anon_sym_out] = ACTIONS(3429),
    [anon_sym_inout] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym___attribute__] = ACTIONS(3429),
    [anon_sym_COLON_COLON] = ACTIONS(3431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3431),
    [anon_sym___declspec] = ACTIONS(3429),
    [anon_sym___based] = ACTIONS(3429),
    [anon_sym___cdecl] = ACTIONS(3429),
    [anon_sym___clrcall] = ACTIONS(3429),
    [anon_sym___stdcall] = ACTIONS(3429),
    [anon_sym___fastcall] = ACTIONS(3429),
    [anon_sym___thiscall] = ACTIONS(3429),
    [anon_sym___vectorcall] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_signed] = ACTIONS(3429),
    [anon_sym_unsigned] = ACTIONS(3429),
    [anon_sym_long] = ACTIONS(3429),
    [anon_sym_short] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_register] = ACTIONS(3429),
    [anon_sym_inline] = ACTIONS(3429),
    [anon_sym___inline] = ACTIONS(3429),
    [anon_sym___inline__] = ACTIONS(3429),
    [anon_sym___forceinline] = ACTIONS(3429),
    [anon_sym_thread_local] = ACTIONS(3429),
    [anon_sym___thread] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_constexpr] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_restrict] = ACTIONS(3429),
    [anon_sym___restrict__] = ACTIONS(3429),
    [anon_sym__Atomic] = ACTIONS(3429),
    [anon_sym__Noreturn] = ACTIONS(3429),
    [anon_sym_noreturn] = ACTIONS(3429),
    [anon_sym_mutable] = ACTIONS(3429),
    [anon_sym_constinit] = ACTIONS(3429),
    [anon_sym_consteval] = ACTIONS(3429),
    [anon_sym_alignas] = ACTIONS(3429),
    [anon_sym__Alignas] = ACTIONS(3429),
    [sym_primitive_type] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [anon_sym_if] = ACTIONS(3429),
    [anon_sym_switch] = ACTIONS(3429),
    [anon_sym_case] = ACTIONS(3429),
    [anon_sym_default] = ACTIONS(3429),
    [anon_sym_while] = ACTIONS(3429),
    [anon_sym_do] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3429),
    [anon_sym_return] = ACTIONS(3429),
    [anon_sym_break] = ACTIONS(3429),
    [anon_sym_continue] = ACTIONS(3429),
    [anon_sym_goto] = ACTIONS(3429),
    [anon_sym___try] = ACTIONS(3429),
    [anon_sym___leave] = ACTIONS(3429),
    [anon_sym_not] = ACTIONS(3429),
    [anon_sym_compl] = ACTIONS(3429),
    [anon_sym_DASH_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(3431),
    [anon_sym_sizeof] = ACTIONS(3429),
    [anon_sym___alignof__] = ACTIONS(3429),
    [anon_sym___alignof] = ACTIONS(3429),
    [anon_sym__alignof] = ACTIONS(3429),
    [anon_sym_alignof] = ACTIONS(3429),
    [anon_sym__Alignof] = ACTIONS(3429),
    [anon_sym_offsetof] = ACTIONS(3429),
    [anon_sym__Generic] = ACTIONS(3429),
    [anon_sym_asm] = ACTIONS(3429),
    [anon_sym___asm__] = ACTIONS(3429),
    [sym_number_literal] = ACTIONS(3431),
    [anon_sym_L_SQUOTE] = ACTIONS(3431),
    [anon_sym_u_SQUOTE] = ACTIONS(3431),
    [anon_sym_U_SQUOTE] = ACTIONS(3431),
    [anon_sym_u8_SQUOTE] = ACTIONS(3431),
    [anon_sym_SQUOTE] = ACTIONS(3431),
    [anon_sym_L_DQUOTE] = ACTIONS(3431),
    [anon_sym_u_DQUOTE] = ACTIONS(3431),
    [anon_sym_U_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [sym_true] = ACTIONS(3429),
    [sym_false] = ACTIONS(3429),
    [anon_sym_NULL] = ACTIONS(3429),
    [anon_sym_nullptr] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_This] = ACTIONS(3429),
    [anon_sym_decltype] = ACTIONS(3429),
    [sym_virtual] = ACTIONS(3429),
    [anon_sym_explicit] = ACTIONS(3429),
    [anon_sym_typename] = ACTIONS(3429),
    [anon_sym_template] = ACTIONS(3429),
    [anon_sym_operator] = ACTIONS(3429),
    [anon_sym_try] = ACTIONS(3429),
    [anon_sym_delete] = ACTIONS(3429),
    [anon_sym_throw] = ACTIONS(3429),
    [anon_sym_namespace] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_static_assert] = ACTIONS(3429),
    [anon_sym_concept] = ACTIONS(3429),
    [anon_sym_co_return] = ACTIONS(3429),
    [anon_sym_co_yield] = ACTIONS(3429),
    [anon_sym_R_DQUOTE] = ACTIONS(3431),
    [anon_sym_LR_DQUOTE] = ACTIONS(3431),
    [anon_sym_uR_DQUOTE] = ACTIONS(3431),
    [anon_sym_UR_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3431),
    [anon_sym_co_await] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3429),
    [anon_sym_requires] = ACTIONS(3429),
    [sym_this] = ACTIONS(3429),
    [anon_sym_discard] = ACTIONS(3429),
    [anon_sym_precise] = ACTIONS(3429),
    [anon_sym_shared] = ACTIONS(3429),
    [anon_sym_groupshared] = ACTIONS(3429),
    [anon_sym_uniform] = ACTIONS(3429),
    [anon_sym_row_major] = ACTIONS(3429),
    [anon_sym_column_major] = ACTIONS(3429),
    [anon_sym_globallycoherent] = ACTIONS(3429),
    [anon_sym_centroid] = ACTIONS(3429),
    [anon_sym_noperspective] = ACTIONS(3429),
    [anon_sym_nointerpolation] = ACTIONS(3429),
    [anon_sym_sample] = ACTIONS(3429),
    [anon_sym_linear] = ACTIONS(3429),
    [anon_sym_snorm] = ACTIONS(3429),
    [anon_sym_unorm] = ACTIONS(3429),
    [anon_sym_point] = ACTIONS(3429),
    [anon_sym_line] = ACTIONS(3429),
    [anon_sym_triangleadj] = ACTIONS(3429),
    [anon_sym_lineadj] = ACTIONS(3429),
    [anon_sym_triangle] = ACTIONS(3429),
    [anon_sym_cbuffer] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_extension] = ACTIONS(3429),
  },
  [488] = {
    [sym_identifier] = ACTIONS(3567),
    [aux_sym_preproc_include_token1] = ACTIONS(3567),
    [aux_sym_preproc_def_token1] = ACTIONS(3567),
    [aux_sym_preproc_if_token1] = ACTIONS(3567),
    [aux_sym_preproc_if_token2] = ACTIONS(3567),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3567),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3567),
    [aux_sym_preproc_else_token1] = ACTIONS(3567),
    [aux_sym_preproc_elif_token1] = ACTIONS(3567),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3567),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3567),
    [sym_preproc_directive] = ACTIONS(3567),
    [anon_sym_LPAREN2] = ACTIONS(3569),
    [anon_sym_BANG] = ACTIONS(3569),
    [anon_sym_TILDE] = ACTIONS(3569),
    [anon_sym_DASH] = ACTIONS(3567),
    [anon_sym_PLUS] = ACTIONS(3567),
    [anon_sym_STAR] = ACTIONS(3569),
    [anon_sym_AMP_AMP] = ACTIONS(3569),
    [anon_sym_AMP] = ACTIONS(3567),
    [anon_sym_SEMI] = ACTIONS(3569),
    [anon_sym___extension__] = ACTIONS(3567),
    [anon_sym_typedef] = ACTIONS(3567),
    [anon_sym_in] = ACTIONS(3567),
    [anon_sym_out] = ACTIONS(3567),
    [anon_sym_inout] = ACTIONS(3567),
    [anon_sym_extern] = ACTIONS(3567),
    [anon_sym___attribute__] = ACTIONS(3567),
    [anon_sym_COLON_COLON] = ACTIONS(3569),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3569),
    [anon_sym___declspec] = ACTIONS(3567),
    [anon_sym___based] = ACTIONS(3567),
    [anon_sym___cdecl] = ACTIONS(3567),
    [anon_sym___clrcall] = ACTIONS(3567),
    [anon_sym___stdcall] = ACTIONS(3567),
    [anon_sym___fastcall] = ACTIONS(3567),
    [anon_sym___thiscall] = ACTIONS(3567),
    [anon_sym___vectorcall] = ACTIONS(3567),
    [anon_sym_LBRACE] = ACTIONS(3569),
    [anon_sym_signed] = ACTIONS(3567),
    [anon_sym_unsigned] = ACTIONS(3567),
    [anon_sym_long] = ACTIONS(3567),
    [anon_sym_short] = ACTIONS(3567),
    [anon_sym_LBRACK] = ACTIONS(3567),
    [anon_sym_static] = ACTIONS(3567),
    [anon_sym_register] = ACTIONS(3567),
    [anon_sym_inline] = ACTIONS(3567),
    [anon_sym___inline] = ACTIONS(3567),
    [anon_sym___inline__] = ACTIONS(3567),
    [anon_sym___forceinline] = ACTIONS(3567),
    [anon_sym_thread_local] = ACTIONS(3567),
    [anon_sym___thread] = ACTIONS(3567),
    [anon_sym_const] = ACTIONS(3567),
    [anon_sym_constexpr] = ACTIONS(3567),
    [anon_sym_volatile] = ACTIONS(3567),
    [anon_sym_restrict] = ACTIONS(3567),
    [anon_sym___restrict__] = ACTIONS(3567),
    [anon_sym__Atomic] = ACTIONS(3567),
    [anon_sym__Noreturn] = ACTIONS(3567),
    [anon_sym_noreturn] = ACTIONS(3567),
    [anon_sym_mutable] = ACTIONS(3567),
    [anon_sym_constinit] = ACTIONS(3567),
    [anon_sym_consteval] = ACTIONS(3567),
    [anon_sym_alignas] = ACTIONS(3567),
    [anon_sym__Alignas] = ACTIONS(3567),
    [sym_primitive_type] = ACTIONS(3567),
    [anon_sym_enum] = ACTIONS(3567),
    [anon_sym_class] = ACTIONS(3567),
    [anon_sym_struct] = ACTIONS(3567),
    [anon_sym_union] = ACTIONS(3567),
    [anon_sym_if] = ACTIONS(3567),
    [anon_sym_switch] = ACTIONS(3567),
    [anon_sym_case] = ACTIONS(3567),
    [anon_sym_default] = ACTIONS(3567),
    [anon_sym_while] = ACTIONS(3567),
    [anon_sym_do] = ACTIONS(3567),
    [anon_sym_for] = ACTIONS(3567),
    [anon_sym_return] = ACTIONS(3567),
    [anon_sym_break] = ACTIONS(3567),
    [anon_sym_continue] = ACTIONS(3567),
    [anon_sym_goto] = ACTIONS(3567),
    [anon_sym___try] = ACTIONS(3567),
    [anon_sym___leave] = ACTIONS(3567),
    [anon_sym_not] = ACTIONS(3567),
    [anon_sym_compl] = ACTIONS(3567),
    [anon_sym_DASH_DASH] = ACTIONS(3569),
    [anon_sym_PLUS_PLUS] = ACTIONS(3569),
    [anon_sym_sizeof] = ACTIONS(3567),
    [anon_sym___alignof__] = ACTIONS(3567),
    [anon_sym___alignof] = ACTIONS(3567),
    [anon_sym__alignof] = ACTIONS(3567),
    [anon_sym_alignof] = ACTIONS(3567),
    [anon_sym__Alignof] = ACTIONS(3567),
    [anon_sym_offsetof] = ACTIONS(3567),
    [anon_sym__Generic] = ACTIONS(3567),
    [anon_sym_asm] = ACTIONS(3567),
    [anon_sym___asm__] = ACTIONS(3567),
    [sym_number_literal] = ACTIONS(3569),
    [anon_sym_L_SQUOTE] = ACTIONS(3569),
    [anon_sym_u_SQUOTE] = ACTIONS(3569),
    [anon_sym_U_SQUOTE] = ACTIONS(3569),
    [anon_sym_u8_SQUOTE] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(3569),
    [anon_sym_L_DQUOTE] = ACTIONS(3569),
    [anon_sym_u_DQUOTE] = ACTIONS(3569),
    [anon_sym_U_DQUOTE] = ACTIONS(3569),
    [anon_sym_u8_DQUOTE] = ACTIONS(3569),
    [anon_sym_DQUOTE] = ACTIONS(3569),
    [sym_true] = ACTIONS(3567),
    [sym_false] = ACTIONS(3567),
    [anon_sym_NULL] = ACTIONS(3567),
    [anon_sym_nullptr] = ACTIONS(3567),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3567),
    [anon_sym_let] = ACTIONS(3567),
    [anon_sym_This] = ACTIONS(3567),
    [anon_sym_decltype] = ACTIONS(3567),
    [sym_virtual] = ACTIONS(3567),
    [anon_sym_explicit] = ACTIONS(3567),
    [anon_sym_typename] = ACTIONS(3567),
    [anon_sym_template] = ACTIONS(3567),
    [anon_sym_operator] = ACTIONS(3567),
    [anon_sym_try] = ACTIONS(3567),
    [anon_sym_delete] = ACTIONS(3567),
    [anon_sym_throw] = ACTIONS(3567),
    [anon_sym_namespace] = ACTIONS(3567),
    [anon_sym_using] = ACTIONS(3567),
    [anon_sym_static_assert] = ACTIONS(3567),
    [anon_sym_concept] = ACTIONS(3567),
    [anon_sym_co_return] = ACTIONS(3567),
    [anon_sym_co_yield] = ACTIONS(3567),
    [anon_sym_R_DQUOTE] = ACTIONS(3569),
    [anon_sym_LR_DQUOTE] = ACTIONS(3569),
    [anon_sym_uR_DQUOTE] = ACTIONS(3569),
    [anon_sym_UR_DQUOTE] = ACTIONS(3569),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3569),
    [anon_sym_co_await] = ACTIONS(3567),
    [anon_sym_new] = ACTIONS(3567),
    [anon_sym_requires] = ACTIONS(3567),
    [sym_this] = ACTIONS(3567),
    [anon_sym_discard] = ACTIONS(3567),
    [anon_sym_precise] = ACTIONS(3567),
    [anon_sym_shared] = ACTIONS(3567),
    [anon_sym_groupshared] = ACTIONS(3567),
    [anon_sym_uniform] = ACTIONS(3567),
    [anon_sym_row_major] = ACTIONS(3567),
    [anon_sym_column_major] = ACTIONS(3567),
    [anon_sym_globallycoherent] = ACTIONS(3567),
    [anon_sym_centroid] = ACTIONS(3567),
    [anon_sym_noperspective] = ACTIONS(3567),
    [anon_sym_nointerpolation] = ACTIONS(3567),
    [anon_sym_sample] = ACTIONS(3567),
    [anon_sym_linear] = ACTIONS(3567),
    [anon_sym_snorm] = ACTIONS(3567),
    [anon_sym_unorm] = ACTIONS(3567),
    [anon_sym_point] = ACTIONS(3567),
    [anon_sym_line] = ACTIONS(3567),
    [anon_sym_triangleadj] = ACTIONS(3567),
    [anon_sym_lineadj] = ACTIONS(3567),
    [anon_sym_triangle] = ACTIONS(3567),
    [anon_sym_cbuffer] = ACTIONS(3567),
    [anon_sym_interface] = ACTIONS(3567),
    [anon_sym_extension] = ACTIONS(3567),
  },
  [489] = {
    [sym_identifier] = ACTIONS(3571),
    [aux_sym_preproc_include_token1] = ACTIONS(3571),
    [aux_sym_preproc_def_token1] = ACTIONS(3571),
    [aux_sym_preproc_if_token1] = ACTIONS(3571),
    [aux_sym_preproc_if_token2] = ACTIONS(3571),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3571),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3571),
    [aux_sym_preproc_else_token1] = ACTIONS(3571),
    [aux_sym_preproc_elif_token1] = ACTIONS(3571),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3571),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3571),
    [sym_preproc_directive] = ACTIONS(3571),
    [anon_sym_LPAREN2] = ACTIONS(3573),
    [anon_sym_BANG] = ACTIONS(3573),
    [anon_sym_TILDE] = ACTIONS(3573),
    [anon_sym_DASH] = ACTIONS(3571),
    [anon_sym_PLUS] = ACTIONS(3571),
    [anon_sym_STAR] = ACTIONS(3573),
    [anon_sym_AMP_AMP] = ACTIONS(3573),
    [anon_sym_AMP] = ACTIONS(3571),
    [anon_sym_SEMI] = ACTIONS(3573),
    [anon_sym___extension__] = ACTIONS(3571),
    [anon_sym_typedef] = ACTIONS(3571),
    [anon_sym_in] = ACTIONS(3571),
    [anon_sym_out] = ACTIONS(3571),
    [anon_sym_inout] = ACTIONS(3571),
    [anon_sym_extern] = ACTIONS(3571),
    [anon_sym___attribute__] = ACTIONS(3571),
    [anon_sym_COLON_COLON] = ACTIONS(3573),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3573),
    [anon_sym___declspec] = ACTIONS(3571),
    [anon_sym___based] = ACTIONS(3571),
    [anon_sym___cdecl] = ACTIONS(3571),
    [anon_sym___clrcall] = ACTIONS(3571),
    [anon_sym___stdcall] = ACTIONS(3571),
    [anon_sym___fastcall] = ACTIONS(3571),
    [anon_sym___thiscall] = ACTIONS(3571),
    [anon_sym___vectorcall] = ACTIONS(3571),
    [anon_sym_LBRACE] = ACTIONS(3573),
    [anon_sym_signed] = ACTIONS(3571),
    [anon_sym_unsigned] = ACTIONS(3571),
    [anon_sym_long] = ACTIONS(3571),
    [anon_sym_short] = ACTIONS(3571),
    [anon_sym_LBRACK] = ACTIONS(3571),
    [anon_sym_static] = ACTIONS(3571),
    [anon_sym_register] = ACTIONS(3571),
    [anon_sym_inline] = ACTIONS(3571),
    [anon_sym___inline] = ACTIONS(3571),
    [anon_sym___inline__] = ACTIONS(3571),
    [anon_sym___forceinline] = ACTIONS(3571),
    [anon_sym_thread_local] = ACTIONS(3571),
    [anon_sym___thread] = ACTIONS(3571),
    [anon_sym_const] = ACTIONS(3571),
    [anon_sym_constexpr] = ACTIONS(3571),
    [anon_sym_volatile] = ACTIONS(3571),
    [anon_sym_restrict] = ACTIONS(3571),
    [anon_sym___restrict__] = ACTIONS(3571),
    [anon_sym__Atomic] = ACTIONS(3571),
    [anon_sym__Noreturn] = ACTIONS(3571),
    [anon_sym_noreturn] = ACTIONS(3571),
    [anon_sym_mutable] = ACTIONS(3571),
    [anon_sym_constinit] = ACTIONS(3571),
    [anon_sym_consteval] = ACTIONS(3571),
    [anon_sym_alignas] = ACTIONS(3571),
    [anon_sym__Alignas] = ACTIONS(3571),
    [sym_primitive_type] = ACTIONS(3571),
    [anon_sym_enum] = ACTIONS(3571),
    [anon_sym_class] = ACTIONS(3571),
    [anon_sym_struct] = ACTIONS(3571),
    [anon_sym_union] = ACTIONS(3571),
    [anon_sym_if] = ACTIONS(3571),
    [anon_sym_switch] = ACTIONS(3571),
    [anon_sym_case] = ACTIONS(3571),
    [anon_sym_default] = ACTIONS(3571),
    [anon_sym_while] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(3571),
    [anon_sym_for] = ACTIONS(3571),
    [anon_sym_return] = ACTIONS(3571),
    [anon_sym_break] = ACTIONS(3571),
    [anon_sym_continue] = ACTIONS(3571),
    [anon_sym_goto] = ACTIONS(3571),
    [anon_sym___try] = ACTIONS(3571),
    [anon_sym___leave] = ACTIONS(3571),
    [anon_sym_not] = ACTIONS(3571),
    [anon_sym_compl] = ACTIONS(3571),
    [anon_sym_DASH_DASH] = ACTIONS(3573),
    [anon_sym_PLUS_PLUS] = ACTIONS(3573),
    [anon_sym_sizeof] = ACTIONS(3571),
    [anon_sym___alignof__] = ACTIONS(3571),
    [anon_sym___alignof] = ACTIONS(3571),
    [anon_sym__alignof] = ACTIONS(3571),
    [anon_sym_alignof] = ACTIONS(3571),
    [anon_sym__Alignof] = ACTIONS(3571),
    [anon_sym_offsetof] = ACTIONS(3571),
    [anon_sym__Generic] = ACTIONS(3571),
    [anon_sym_asm] = ACTIONS(3571),
    [anon_sym___asm__] = ACTIONS(3571),
    [sym_number_literal] = ACTIONS(3573),
    [anon_sym_L_SQUOTE] = ACTIONS(3573),
    [anon_sym_u_SQUOTE] = ACTIONS(3573),
    [anon_sym_U_SQUOTE] = ACTIONS(3573),
    [anon_sym_u8_SQUOTE] = ACTIONS(3573),
    [anon_sym_SQUOTE] = ACTIONS(3573),
    [anon_sym_L_DQUOTE] = ACTIONS(3573),
    [anon_sym_u_DQUOTE] = ACTIONS(3573),
    [anon_sym_U_DQUOTE] = ACTIONS(3573),
    [anon_sym_u8_DQUOTE] = ACTIONS(3573),
    [anon_sym_DQUOTE] = ACTIONS(3573),
    [sym_true] = ACTIONS(3571),
    [sym_false] = ACTIONS(3571),
    [anon_sym_NULL] = ACTIONS(3571),
    [anon_sym_nullptr] = ACTIONS(3571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3571),
    [anon_sym_let] = ACTIONS(3571),
    [anon_sym_This] = ACTIONS(3571),
    [anon_sym_decltype] = ACTIONS(3571),
    [sym_virtual] = ACTIONS(3571),
    [anon_sym_explicit] = ACTIONS(3571),
    [anon_sym_typename] = ACTIONS(3571),
    [anon_sym_template] = ACTIONS(3571),
    [anon_sym_operator] = ACTIONS(3571),
    [anon_sym_try] = ACTIONS(3571),
    [anon_sym_delete] = ACTIONS(3571),
    [anon_sym_throw] = ACTIONS(3571),
    [anon_sym_namespace] = ACTIONS(3571),
    [anon_sym_using] = ACTIONS(3571),
    [anon_sym_static_assert] = ACTIONS(3571),
    [anon_sym_concept] = ACTIONS(3571),
    [anon_sym_co_return] = ACTIONS(3571),
    [anon_sym_co_yield] = ACTIONS(3571),
    [anon_sym_R_DQUOTE] = ACTIONS(3573),
    [anon_sym_LR_DQUOTE] = ACTIONS(3573),
    [anon_sym_uR_DQUOTE] = ACTIONS(3573),
    [anon_sym_UR_DQUOTE] = ACTIONS(3573),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3573),
    [anon_sym_co_await] = ACTIONS(3571),
    [anon_sym_new] = ACTIONS(3571),
    [anon_sym_requires] = ACTIONS(3571),
    [sym_this] = ACTIONS(3571),
    [anon_sym_discard] = ACTIONS(3571),
    [anon_sym_precise] = ACTIONS(3571),
    [anon_sym_shared] = ACTIONS(3571),
    [anon_sym_groupshared] = ACTIONS(3571),
    [anon_sym_uniform] = ACTIONS(3571),
    [anon_sym_row_major] = ACTIONS(3571),
    [anon_sym_column_major] = ACTIONS(3571),
    [anon_sym_globallycoherent] = ACTIONS(3571),
    [anon_sym_centroid] = ACTIONS(3571),
    [anon_sym_noperspective] = ACTIONS(3571),
    [anon_sym_nointerpolation] = ACTIONS(3571),
    [anon_sym_sample] = ACTIONS(3571),
    [anon_sym_linear] = ACTIONS(3571),
    [anon_sym_snorm] = ACTIONS(3571),
    [anon_sym_unorm] = ACTIONS(3571),
    [anon_sym_point] = ACTIONS(3571),
    [anon_sym_line] = ACTIONS(3571),
    [anon_sym_triangleadj] = ACTIONS(3571),
    [anon_sym_lineadj] = ACTIONS(3571),
    [anon_sym_triangle] = ACTIONS(3571),
    [anon_sym_cbuffer] = ACTIONS(3571),
    [anon_sym_interface] = ACTIONS(3571),
    [anon_sym_extension] = ACTIONS(3571),
  },
  [490] = {
    [sym_identifier] = ACTIONS(3575),
    [aux_sym_preproc_include_token1] = ACTIONS(3575),
    [aux_sym_preproc_def_token1] = ACTIONS(3575),
    [aux_sym_preproc_if_token1] = ACTIONS(3575),
    [aux_sym_preproc_if_token2] = ACTIONS(3575),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3575),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3575),
    [aux_sym_preproc_else_token1] = ACTIONS(3575),
    [aux_sym_preproc_elif_token1] = ACTIONS(3575),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3575),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3575),
    [sym_preproc_directive] = ACTIONS(3575),
    [anon_sym_LPAREN2] = ACTIONS(3577),
    [anon_sym_BANG] = ACTIONS(3577),
    [anon_sym_TILDE] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3575),
    [anon_sym_PLUS] = ACTIONS(3575),
    [anon_sym_STAR] = ACTIONS(3577),
    [anon_sym_AMP_AMP] = ACTIONS(3577),
    [anon_sym_AMP] = ACTIONS(3575),
    [anon_sym_SEMI] = ACTIONS(3577),
    [anon_sym___extension__] = ACTIONS(3575),
    [anon_sym_typedef] = ACTIONS(3575),
    [anon_sym_in] = ACTIONS(3575),
    [anon_sym_out] = ACTIONS(3575),
    [anon_sym_inout] = ACTIONS(3575),
    [anon_sym_extern] = ACTIONS(3575),
    [anon_sym___attribute__] = ACTIONS(3575),
    [anon_sym_COLON_COLON] = ACTIONS(3577),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3577),
    [anon_sym___declspec] = ACTIONS(3575),
    [anon_sym___based] = ACTIONS(3575),
    [anon_sym___cdecl] = ACTIONS(3575),
    [anon_sym___clrcall] = ACTIONS(3575),
    [anon_sym___stdcall] = ACTIONS(3575),
    [anon_sym___fastcall] = ACTIONS(3575),
    [anon_sym___thiscall] = ACTIONS(3575),
    [anon_sym___vectorcall] = ACTIONS(3575),
    [anon_sym_LBRACE] = ACTIONS(3577),
    [anon_sym_signed] = ACTIONS(3575),
    [anon_sym_unsigned] = ACTIONS(3575),
    [anon_sym_long] = ACTIONS(3575),
    [anon_sym_short] = ACTIONS(3575),
    [anon_sym_LBRACK] = ACTIONS(3575),
    [anon_sym_static] = ACTIONS(3575),
    [anon_sym_register] = ACTIONS(3575),
    [anon_sym_inline] = ACTIONS(3575),
    [anon_sym___inline] = ACTIONS(3575),
    [anon_sym___inline__] = ACTIONS(3575),
    [anon_sym___forceinline] = ACTIONS(3575),
    [anon_sym_thread_local] = ACTIONS(3575),
    [anon_sym___thread] = ACTIONS(3575),
    [anon_sym_const] = ACTIONS(3575),
    [anon_sym_constexpr] = ACTIONS(3575),
    [anon_sym_volatile] = ACTIONS(3575),
    [anon_sym_restrict] = ACTIONS(3575),
    [anon_sym___restrict__] = ACTIONS(3575),
    [anon_sym__Atomic] = ACTIONS(3575),
    [anon_sym__Noreturn] = ACTIONS(3575),
    [anon_sym_noreturn] = ACTIONS(3575),
    [anon_sym_mutable] = ACTIONS(3575),
    [anon_sym_constinit] = ACTIONS(3575),
    [anon_sym_consteval] = ACTIONS(3575),
    [anon_sym_alignas] = ACTIONS(3575),
    [anon_sym__Alignas] = ACTIONS(3575),
    [sym_primitive_type] = ACTIONS(3575),
    [anon_sym_enum] = ACTIONS(3575),
    [anon_sym_class] = ACTIONS(3575),
    [anon_sym_struct] = ACTIONS(3575),
    [anon_sym_union] = ACTIONS(3575),
    [anon_sym_if] = ACTIONS(3575),
    [anon_sym_switch] = ACTIONS(3575),
    [anon_sym_case] = ACTIONS(3575),
    [anon_sym_default] = ACTIONS(3575),
    [anon_sym_while] = ACTIONS(3575),
    [anon_sym_do] = ACTIONS(3575),
    [anon_sym_for] = ACTIONS(3575),
    [anon_sym_return] = ACTIONS(3575),
    [anon_sym_break] = ACTIONS(3575),
    [anon_sym_continue] = ACTIONS(3575),
    [anon_sym_goto] = ACTIONS(3575),
    [anon_sym___try] = ACTIONS(3575),
    [anon_sym___leave] = ACTIONS(3575),
    [anon_sym_not] = ACTIONS(3575),
    [anon_sym_compl] = ACTIONS(3575),
    [anon_sym_DASH_DASH] = ACTIONS(3577),
    [anon_sym_PLUS_PLUS] = ACTIONS(3577),
    [anon_sym_sizeof] = ACTIONS(3575),
    [anon_sym___alignof__] = ACTIONS(3575),
    [anon_sym___alignof] = ACTIONS(3575),
    [anon_sym__alignof] = ACTIONS(3575),
    [anon_sym_alignof] = ACTIONS(3575),
    [anon_sym__Alignof] = ACTIONS(3575),
    [anon_sym_offsetof] = ACTIONS(3575),
    [anon_sym__Generic] = ACTIONS(3575),
    [anon_sym_asm] = ACTIONS(3575),
    [anon_sym___asm__] = ACTIONS(3575),
    [sym_number_literal] = ACTIONS(3577),
    [anon_sym_L_SQUOTE] = ACTIONS(3577),
    [anon_sym_u_SQUOTE] = ACTIONS(3577),
    [anon_sym_U_SQUOTE] = ACTIONS(3577),
    [anon_sym_u8_SQUOTE] = ACTIONS(3577),
    [anon_sym_SQUOTE] = ACTIONS(3577),
    [anon_sym_L_DQUOTE] = ACTIONS(3577),
    [anon_sym_u_DQUOTE] = ACTIONS(3577),
    [anon_sym_U_DQUOTE] = ACTIONS(3577),
    [anon_sym_u8_DQUOTE] = ACTIONS(3577),
    [anon_sym_DQUOTE] = ACTIONS(3577),
    [sym_true] = ACTIONS(3575),
    [sym_false] = ACTIONS(3575),
    [anon_sym_NULL] = ACTIONS(3575),
    [anon_sym_nullptr] = ACTIONS(3575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3575),
    [anon_sym_let] = ACTIONS(3575),
    [anon_sym_This] = ACTIONS(3575),
    [anon_sym_decltype] = ACTIONS(3575),
    [sym_virtual] = ACTIONS(3575),
    [anon_sym_explicit] = ACTIONS(3575),
    [anon_sym_typename] = ACTIONS(3575),
    [anon_sym_template] = ACTIONS(3575),
    [anon_sym_operator] = ACTIONS(3575),
    [anon_sym_try] = ACTIONS(3575),
    [anon_sym_delete] = ACTIONS(3575),
    [anon_sym_throw] = ACTIONS(3575),
    [anon_sym_namespace] = ACTIONS(3575),
    [anon_sym_using] = ACTIONS(3575),
    [anon_sym_static_assert] = ACTIONS(3575),
    [anon_sym_concept] = ACTIONS(3575),
    [anon_sym_co_return] = ACTIONS(3575),
    [anon_sym_co_yield] = ACTIONS(3575),
    [anon_sym_R_DQUOTE] = ACTIONS(3577),
    [anon_sym_LR_DQUOTE] = ACTIONS(3577),
    [anon_sym_uR_DQUOTE] = ACTIONS(3577),
    [anon_sym_UR_DQUOTE] = ACTIONS(3577),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3577),
    [anon_sym_co_await] = ACTIONS(3575),
    [anon_sym_new] = ACTIONS(3575),
    [anon_sym_requires] = ACTIONS(3575),
    [sym_this] = ACTIONS(3575),
    [anon_sym_discard] = ACTIONS(3575),
    [anon_sym_precise] = ACTIONS(3575),
    [anon_sym_shared] = ACTIONS(3575),
    [anon_sym_groupshared] = ACTIONS(3575),
    [anon_sym_uniform] = ACTIONS(3575),
    [anon_sym_row_major] = ACTIONS(3575),
    [anon_sym_column_major] = ACTIONS(3575),
    [anon_sym_globallycoherent] = ACTIONS(3575),
    [anon_sym_centroid] = ACTIONS(3575),
    [anon_sym_noperspective] = ACTIONS(3575),
    [anon_sym_nointerpolation] = ACTIONS(3575),
    [anon_sym_sample] = ACTIONS(3575),
    [anon_sym_linear] = ACTIONS(3575),
    [anon_sym_snorm] = ACTIONS(3575),
    [anon_sym_unorm] = ACTIONS(3575),
    [anon_sym_point] = ACTIONS(3575),
    [anon_sym_line] = ACTIONS(3575),
    [anon_sym_triangleadj] = ACTIONS(3575),
    [anon_sym_lineadj] = ACTIONS(3575),
    [anon_sym_triangle] = ACTIONS(3575),
    [anon_sym_cbuffer] = ACTIONS(3575),
    [anon_sym_interface] = ACTIONS(3575),
    [anon_sym_extension] = ACTIONS(3575),
  },
  [491] = {
    [sym_identifier] = ACTIONS(3579),
    [aux_sym_preproc_include_token1] = ACTIONS(3579),
    [aux_sym_preproc_def_token1] = ACTIONS(3579),
    [aux_sym_preproc_if_token1] = ACTIONS(3579),
    [aux_sym_preproc_if_token2] = ACTIONS(3579),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3579),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3579),
    [aux_sym_preproc_else_token1] = ACTIONS(3579),
    [aux_sym_preproc_elif_token1] = ACTIONS(3579),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3579),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3579),
    [sym_preproc_directive] = ACTIONS(3579),
    [anon_sym_LPAREN2] = ACTIONS(3581),
    [anon_sym_BANG] = ACTIONS(3581),
    [anon_sym_TILDE] = ACTIONS(3581),
    [anon_sym_DASH] = ACTIONS(3579),
    [anon_sym_PLUS] = ACTIONS(3579),
    [anon_sym_STAR] = ACTIONS(3581),
    [anon_sym_AMP_AMP] = ACTIONS(3581),
    [anon_sym_AMP] = ACTIONS(3579),
    [anon_sym_SEMI] = ACTIONS(3581),
    [anon_sym___extension__] = ACTIONS(3579),
    [anon_sym_typedef] = ACTIONS(3579),
    [anon_sym_in] = ACTIONS(3579),
    [anon_sym_out] = ACTIONS(3579),
    [anon_sym_inout] = ACTIONS(3579),
    [anon_sym_extern] = ACTIONS(3579),
    [anon_sym___attribute__] = ACTIONS(3579),
    [anon_sym_COLON_COLON] = ACTIONS(3581),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3581),
    [anon_sym___declspec] = ACTIONS(3579),
    [anon_sym___based] = ACTIONS(3579),
    [anon_sym___cdecl] = ACTIONS(3579),
    [anon_sym___clrcall] = ACTIONS(3579),
    [anon_sym___stdcall] = ACTIONS(3579),
    [anon_sym___fastcall] = ACTIONS(3579),
    [anon_sym___thiscall] = ACTIONS(3579),
    [anon_sym___vectorcall] = ACTIONS(3579),
    [anon_sym_LBRACE] = ACTIONS(3581),
    [anon_sym_signed] = ACTIONS(3579),
    [anon_sym_unsigned] = ACTIONS(3579),
    [anon_sym_long] = ACTIONS(3579),
    [anon_sym_short] = ACTIONS(3579),
    [anon_sym_LBRACK] = ACTIONS(3579),
    [anon_sym_static] = ACTIONS(3579),
    [anon_sym_register] = ACTIONS(3579),
    [anon_sym_inline] = ACTIONS(3579),
    [anon_sym___inline] = ACTIONS(3579),
    [anon_sym___inline__] = ACTIONS(3579),
    [anon_sym___forceinline] = ACTIONS(3579),
    [anon_sym_thread_local] = ACTIONS(3579),
    [anon_sym___thread] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3579),
    [anon_sym_constexpr] = ACTIONS(3579),
    [anon_sym_volatile] = ACTIONS(3579),
    [anon_sym_restrict] = ACTIONS(3579),
    [anon_sym___restrict__] = ACTIONS(3579),
    [anon_sym__Atomic] = ACTIONS(3579),
    [anon_sym__Noreturn] = ACTIONS(3579),
    [anon_sym_noreturn] = ACTIONS(3579),
    [anon_sym_mutable] = ACTIONS(3579),
    [anon_sym_constinit] = ACTIONS(3579),
    [anon_sym_consteval] = ACTIONS(3579),
    [anon_sym_alignas] = ACTIONS(3579),
    [anon_sym__Alignas] = ACTIONS(3579),
    [sym_primitive_type] = ACTIONS(3579),
    [anon_sym_enum] = ACTIONS(3579),
    [anon_sym_class] = ACTIONS(3579),
    [anon_sym_struct] = ACTIONS(3579),
    [anon_sym_union] = ACTIONS(3579),
    [anon_sym_if] = ACTIONS(3579),
    [anon_sym_switch] = ACTIONS(3579),
    [anon_sym_case] = ACTIONS(3579),
    [anon_sym_default] = ACTIONS(3579),
    [anon_sym_while] = ACTIONS(3579),
    [anon_sym_do] = ACTIONS(3579),
    [anon_sym_for] = ACTIONS(3579),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_break] = ACTIONS(3579),
    [anon_sym_continue] = ACTIONS(3579),
    [anon_sym_goto] = ACTIONS(3579),
    [anon_sym___try] = ACTIONS(3579),
    [anon_sym___leave] = ACTIONS(3579),
    [anon_sym_not] = ACTIONS(3579),
    [anon_sym_compl] = ACTIONS(3579),
    [anon_sym_DASH_DASH] = ACTIONS(3581),
    [anon_sym_PLUS_PLUS] = ACTIONS(3581),
    [anon_sym_sizeof] = ACTIONS(3579),
    [anon_sym___alignof__] = ACTIONS(3579),
    [anon_sym___alignof] = ACTIONS(3579),
    [anon_sym__alignof] = ACTIONS(3579),
    [anon_sym_alignof] = ACTIONS(3579),
    [anon_sym__Alignof] = ACTIONS(3579),
    [anon_sym_offsetof] = ACTIONS(3579),
    [anon_sym__Generic] = ACTIONS(3579),
    [anon_sym_asm] = ACTIONS(3579),
    [anon_sym___asm__] = ACTIONS(3579),
    [sym_number_literal] = ACTIONS(3581),
    [anon_sym_L_SQUOTE] = ACTIONS(3581),
    [anon_sym_u_SQUOTE] = ACTIONS(3581),
    [anon_sym_U_SQUOTE] = ACTIONS(3581),
    [anon_sym_u8_SQUOTE] = ACTIONS(3581),
    [anon_sym_SQUOTE] = ACTIONS(3581),
    [anon_sym_L_DQUOTE] = ACTIONS(3581),
    [anon_sym_u_DQUOTE] = ACTIONS(3581),
    [anon_sym_U_DQUOTE] = ACTIONS(3581),
    [anon_sym_u8_DQUOTE] = ACTIONS(3581),
    [anon_sym_DQUOTE] = ACTIONS(3581),
    [sym_true] = ACTIONS(3579),
    [sym_false] = ACTIONS(3579),
    [anon_sym_NULL] = ACTIONS(3579),
    [anon_sym_nullptr] = ACTIONS(3579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3579),
    [anon_sym_let] = ACTIONS(3579),
    [anon_sym_This] = ACTIONS(3579),
    [anon_sym_decltype] = ACTIONS(3579),
    [sym_virtual] = ACTIONS(3579),
    [anon_sym_explicit] = ACTIONS(3579),
    [anon_sym_typename] = ACTIONS(3579),
    [anon_sym_template] = ACTIONS(3579),
    [anon_sym_operator] = ACTIONS(3579),
    [anon_sym_try] = ACTIONS(3579),
    [anon_sym_delete] = ACTIONS(3579),
    [anon_sym_throw] = ACTIONS(3579),
    [anon_sym_namespace] = ACTIONS(3579),
    [anon_sym_using] = ACTIONS(3579),
    [anon_sym_static_assert] = ACTIONS(3579),
    [anon_sym_concept] = ACTIONS(3579),
    [anon_sym_co_return] = ACTIONS(3579),
    [anon_sym_co_yield] = ACTIONS(3579),
    [anon_sym_R_DQUOTE] = ACTIONS(3581),
    [anon_sym_LR_DQUOTE] = ACTIONS(3581),
    [anon_sym_uR_DQUOTE] = ACTIONS(3581),
    [anon_sym_UR_DQUOTE] = ACTIONS(3581),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3581),
    [anon_sym_co_await] = ACTIONS(3579),
    [anon_sym_new] = ACTIONS(3579),
    [anon_sym_requires] = ACTIONS(3579),
    [sym_this] = ACTIONS(3579),
    [anon_sym_discard] = ACTIONS(3579),
    [anon_sym_precise] = ACTIONS(3579),
    [anon_sym_shared] = ACTIONS(3579),
    [anon_sym_groupshared] = ACTIONS(3579),
    [anon_sym_uniform] = ACTIONS(3579),
    [anon_sym_row_major] = ACTIONS(3579),
    [anon_sym_column_major] = ACTIONS(3579),
    [anon_sym_globallycoherent] = ACTIONS(3579),
    [anon_sym_centroid] = ACTIONS(3579),
    [anon_sym_noperspective] = ACTIONS(3579),
    [anon_sym_nointerpolation] = ACTIONS(3579),
    [anon_sym_sample] = ACTIONS(3579),
    [anon_sym_linear] = ACTIONS(3579),
    [anon_sym_snorm] = ACTIONS(3579),
    [anon_sym_unorm] = ACTIONS(3579),
    [anon_sym_point] = ACTIONS(3579),
    [anon_sym_line] = ACTIONS(3579),
    [anon_sym_triangleadj] = ACTIONS(3579),
    [anon_sym_lineadj] = ACTIONS(3579),
    [anon_sym_triangle] = ACTIONS(3579),
    [anon_sym_cbuffer] = ACTIONS(3579),
    [anon_sym_interface] = ACTIONS(3579),
    [anon_sym_extension] = ACTIONS(3579),
  },
  [492] = {
    [ts_builtin_sym_end] = ACTIONS(2844),
    [sym_identifier] = ACTIONS(2842),
    [aux_sym_preproc_include_token1] = ACTIONS(2842),
    [aux_sym_preproc_def_token1] = ACTIONS(2842),
    [aux_sym_preproc_if_token1] = ACTIONS(2842),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2842),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2842),
    [sym_preproc_directive] = ACTIONS(2842),
    [anon_sym_LPAREN2] = ACTIONS(2844),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_TILDE] = ACTIONS(2844),
    [anon_sym_DASH] = ACTIONS(2842),
    [anon_sym_PLUS] = ACTIONS(2842),
    [anon_sym_STAR] = ACTIONS(2844),
    [anon_sym_AMP_AMP] = ACTIONS(2844),
    [anon_sym_AMP] = ACTIONS(2842),
    [anon_sym_SEMI] = ACTIONS(2844),
    [anon_sym___extension__] = ACTIONS(2842),
    [anon_sym_typedef] = ACTIONS(2842),
    [anon_sym_in] = ACTIONS(2842),
    [anon_sym_out] = ACTIONS(2842),
    [anon_sym_inout] = ACTIONS(2842),
    [anon_sym_extern] = ACTIONS(2842),
    [anon_sym___attribute__] = ACTIONS(2842),
    [anon_sym_COLON_COLON] = ACTIONS(2844),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2844),
    [anon_sym___declspec] = ACTIONS(2842),
    [anon_sym___based] = ACTIONS(2842),
    [anon_sym___cdecl] = ACTIONS(2842),
    [anon_sym___clrcall] = ACTIONS(2842),
    [anon_sym___stdcall] = ACTIONS(2842),
    [anon_sym___fastcall] = ACTIONS(2842),
    [anon_sym___thiscall] = ACTIONS(2842),
    [anon_sym___vectorcall] = ACTIONS(2842),
    [anon_sym_LBRACE] = ACTIONS(2844),
    [anon_sym_signed] = ACTIONS(2842),
    [anon_sym_unsigned] = ACTIONS(2842),
    [anon_sym_long] = ACTIONS(2842),
    [anon_sym_short] = ACTIONS(2842),
    [anon_sym_LBRACK] = ACTIONS(2842),
    [anon_sym_static] = ACTIONS(2842),
    [anon_sym_register] = ACTIONS(2842),
    [anon_sym_inline] = ACTIONS(2842),
    [anon_sym___inline] = ACTIONS(2842),
    [anon_sym___inline__] = ACTIONS(2842),
    [anon_sym___forceinline] = ACTIONS(2842),
    [anon_sym_thread_local] = ACTIONS(2842),
    [anon_sym___thread] = ACTIONS(2842),
    [anon_sym_const] = ACTIONS(2842),
    [anon_sym_constexpr] = ACTIONS(2842),
    [anon_sym_volatile] = ACTIONS(2842),
    [anon_sym_restrict] = ACTIONS(2842),
    [anon_sym___restrict__] = ACTIONS(2842),
    [anon_sym__Atomic] = ACTIONS(2842),
    [anon_sym__Noreturn] = ACTIONS(2842),
    [anon_sym_noreturn] = ACTIONS(2842),
    [anon_sym_mutable] = ACTIONS(2842),
    [anon_sym_constinit] = ACTIONS(2842),
    [anon_sym_consteval] = ACTIONS(2842),
    [anon_sym_alignas] = ACTIONS(2842),
    [anon_sym__Alignas] = ACTIONS(2842),
    [sym_primitive_type] = ACTIONS(2842),
    [anon_sym_enum] = ACTIONS(2842),
    [anon_sym_class] = ACTIONS(2842),
    [anon_sym_struct] = ACTIONS(2842),
    [anon_sym_union] = ACTIONS(2842),
    [anon_sym_if] = ACTIONS(2842),
    [anon_sym_else] = ACTIONS(2842),
    [anon_sym_switch] = ACTIONS(2842),
    [anon_sym_case] = ACTIONS(2842),
    [anon_sym_default] = ACTIONS(2842),
    [anon_sym_while] = ACTIONS(2842),
    [anon_sym_do] = ACTIONS(2842),
    [anon_sym_for] = ACTIONS(2842),
    [anon_sym_return] = ACTIONS(2842),
    [anon_sym_break] = ACTIONS(2842),
    [anon_sym_continue] = ACTIONS(2842),
    [anon_sym_goto] = ACTIONS(2842),
    [anon_sym___try] = ACTIONS(2842),
    [anon_sym___leave] = ACTIONS(2842),
    [anon_sym_not] = ACTIONS(2842),
    [anon_sym_compl] = ACTIONS(2842),
    [anon_sym_DASH_DASH] = ACTIONS(2844),
    [anon_sym_PLUS_PLUS] = ACTIONS(2844),
    [anon_sym_sizeof] = ACTIONS(2842),
    [anon_sym___alignof__] = ACTIONS(2842),
    [anon_sym___alignof] = ACTIONS(2842),
    [anon_sym__alignof] = ACTIONS(2842),
    [anon_sym_alignof] = ACTIONS(2842),
    [anon_sym__Alignof] = ACTIONS(2842),
    [anon_sym_offsetof] = ACTIONS(2842),
    [anon_sym__Generic] = ACTIONS(2842),
    [anon_sym_asm] = ACTIONS(2842),
    [anon_sym___asm__] = ACTIONS(2842),
    [sym_number_literal] = ACTIONS(2844),
    [anon_sym_L_SQUOTE] = ACTIONS(2844),
    [anon_sym_u_SQUOTE] = ACTIONS(2844),
    [anon_sym_U_SQUOTE] = ACTIONS(2844),
    [anon_sym_u8_SQUOTE] = ACTIONS(2844),
    [anon_sym_SQUOTE] = ACTIONS(2844),
    [anon_sym_L_DQUOTE] = ACTIONS(2844),
    [anon_sym_u_DQUOTE] = ACTIONS(2844),
    [anon_sym_U_DQUOTE] = ACTIONS(2844),
    [anon_sym_u8_DQUOTE] = ACTIONS(2844),
    [anon_sym_DQUOTE] = ACTIONS(2844),
    [sym_true] = ACTIONS(2842),
    [sym_false] = ACTIONS(2842),
    [anon_sym_NULL] = ACTIONS(2842),
    [anon_sym_nullptr] = ACTIONS(2842),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2842),
    [anon_sym_let] = ACTIONS(2842),
    [anon_sym_This] = ACTIONS(2842),
    [anon_sym_decltype] = ACTIONS(2842),
    [sym_virtual] = ACTIONS(2842),
    [anon_sym_explicit] = ACTIONS(2842),
    [anon_sym_typename] = ACTIONS(2842),
    [anon_sym_template] = ACTIONS(2842),
    [anon_sym_operator] = ACTIONS(2842),
    [anon_sym_try] = ACTIONS(2842),
    [anon_sym_delete] = ACTIONS(2842),
    [anon_sym_throw] = ACTIONS(2842),
    [anon_sym_namespace] = ACTIONS(2842),
    [anon_sym_using] = ACTIONS(2842),
    [anon_sym_static_assert] = ACTIONS(2842),
    [anon_sym_concept] = ACTIONS(2842),
    [anon_sym_co_return] = ACTIONS(2842),
    [anon_sym_co_yield] = ACTIONS(2842),
    [anon_sym_catch] = ACTIONS(2842),
    [anon_sym_R_DQUOTE] = ACTIONS(2844),
    [anon_sym_LR_DQUOTE] = ACTIONS(2844),
    [anon_sym_uR_DQUOTE] = ACTIONS(2844),
    [anon_sym_UR_DQUOTE] = ACTIONS(2844),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2844),
    [anon_sym_co_await] = ACTIONS(2842),
    [anon_sym_new] = ACTIONS(2842),
    [anon_sym_requires] = ACTIONS(2842),
    [sym_this] = ACTIONS(2842),
    [anon_sym_discard] = ACTIONS(2842),
    [anon_sym_precise] = ACTIONS(2842),
    [anon_sym_shared] = ACTIONS(2842),
    [anon_sym_groupshared] = ACTIONS(2842),
    [anon_sym_uniform] = ACTIONS(2842),
    [anon_sym_row_major] = ACTIONS(2842),
    [anon_sym_column_major] = ACTIONS(2842),
    [anon_sym_globallycoherent] = ACTIONS(2842),
    [anon_sym_centroid] = ACTIONS(2842),
    [anon_sym_noperspective] = ACTIONS(2842),
    [anon_sym_nointerpolation] = ACTIONS(2842),
    [anon_sym_sample] = ACTIONS(2842),
    [anon_sym_linear] = ACTIONS(2842),
    [anon_sym_snorm] = ACTIONS(2842),
    [anon_sym_unorm] = ACTIONS(2842),
    [anon_sym_point] = ACTIONS(2842),
    [anon_sym_line] = ACTIONS(2842),
    [anon_sym_triangleadj] = ACTIONS(2842),
    [anon_sym_lineadj] = ACTIONS(2842),
    [anon_sym_triangle] = ACTIONS(2842),
    [anon_sym_cbuffer] = ACTIONS(2842),
    [anon_sym_interface] = ACTIONS(2842),
    [anon_sym_extension] = ACTIONS(2842),
    [anon_sym___exported] = ACTIONS(2842),
    [anon_sym_import] = ACTIONS(2842),
  },
  [493] = {
    [sym_identifier] = ACTIONS(3583),
    [aux_sym_preproc_include_token1] = ACTIONS(3583),
    [aux_sym_preproc_def_token1] = ACTIONS(3583),
    [aux_sym_preproc_if_token1] = ACTIONS(3583),
    [aux_sym_preproc_if_token2] = ACTIONS(3583),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3583),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3583),
    [aux_sym_preproc_else_token1] = ACTIONS(3583),
    [aux_sym_preproc_elif_token1] = ACTIONS(3583),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3583),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3583),
    [sym_preproc_directive] = ACTIONS(3583),
    [anon_sym_LPAREN2] = ACTIONS(3585),
    [anon_sym_BANG] = ACTIONS(3585),
    [anon_sym_TILDE] = ACTIONS(3585),
    [anon_sym_DASH] = ACTIONS(3583),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_STAR] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3583),
    [anon_sym_SEMI] = ACTIONS(3585),
    [anon_sym___extension__] = ACTIONS(3583),
    [anon_sym_typedef] = ACTIONS(3583),
    [anon_sym_in] = ACTIONS(3583),
    [anon_sym_out] = ACTIONS(3583),
    [anon_sym_inout] = ACTIONS(3583),
    [anon_sym_extern] = ACTIONS(3583),
    [anon_sym___attribute__] = ACTIONS(3583),
    [anon_sym_COLON_COLON] = ACTIONS(3585),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3585),
    [anon_sym___declspec] = ACTIONS(3583),
    [anon_sym___based] = ACTIONS(3583),
    [anon_sym___cdecl] = ACTIONS(3583),
    [anon_sym___clrcall] = ACTIONS(3583),
    [anon_sym___stdcall] = ACTIONS(3583),
    [anon_sym___fastcall] = ACTIONS(3583),
    [anon_sym___thiscall] = ACTIONS(3583),
    [anon_sym___vectorcall] = ACTIONS(3583),
    [anon_sym_LBRACE] = ACTIONS(3585),
    [anon_sym_signed] = ACTIONS(3583),
    [anon_sym_unsigned] = ACTIONS(3583),
    [anon_sym_long] = ACTIONS(3583),
    [anon_sym_short] = ACTIONS(3583),
    [anon_sym_LBRACK] = ACTIONS(3583),
    [anon_sym_static] = ACTIONS(3583),
    [anon_sym_register] = ACTIONS(3583),
    [anon_sym_inline] = ACTIONS(3583),
    [anon_sym___inline] = ACTIONS(3583),
    [anon_sym___inline__] = ACTIONS(3583),
    [anon_sym___forceinline] = ACTIONS(3583),
    [anon_sym_thread_local] = ACTIONS(3583),
    [anon_sym___thread] = ACTIONS(3583),
    [anon_sym_const] = ACTIONS(3583),
    [anon_sym_constexpr] = ACTIONS(3583),
    [anon_sym_volatile] = ACTIONS(3583),
    [anon_sym_restrict] = ACTIONS(3583),
    [anon_sym___restrict__] = ACTIONS(3583),
    [anon_sym__Atomic] = ACTIONS(3583),
    [anon_sym__Noreturn] = ACTIONS(3583),
    [anon_sym_noreturn] = ACTIONS(3583),
    [anon_sym_mutable] = ACTIONS(3583),
    [anon_sym_constinit] = ACTIONS(3583),
    [anon_sym_consteval] = ACTIONS(3583),
    [anon_sym_alignas] = ACTIONS(3583),
    [anon_sym__Alignas] = ACTIONS(3583),
    [sym_primitive_type] = ACTIONS(3583),
    [anon_sym_enum] = ACTIONS(3583),
    [anon_sym_class] = ACTIONS(3583),
    [anon_sym_struct] = ACTIONS(3583),
    [anon_sym_union] = ACTIONS(3583),
    [anon_sym_if] = ACTIONS(3583),
    [anon_sym_switch] = ACTIONS(3583),
    [anon_sym_case] = ACTIONS(3583),
    [anon_sym_default] = ACTIONS(3583),
    [anon_sym_while] = ACTIONS(3583),
    [anon_sym_do] = ACTIONS(3583),
    [anon_sym_for] = ACTIONS(3583),
    [anon_sym_return] = ACTIONS(3583),
    [anon_sym_break] = ACTIONS(3583),
    [anon_sym_continue] = ACTIONS(3583),
    [anon_sym_goto] = ACTIONS(3583),
    [anon_sym___try] = ACTIONS(3583),
    [anon_sym___leave] = ACTIONS(3583),
    [anon_sym_not] = ACTIONS(3583),
    [anon_sym_compl] = ACTIONS(3583),
    [anon_sym_DASH_DASH] = ACTIONS(3585),
    [anon_sym_PLUS_PLUS] = ACTIONS(3585),
    [anon_sym_sizeof] = ACTIONS(3583),
    [anon_sym___alignof__] = ACTIONS(3583),
    [anon_sym___alignof] = ACTIONS(3583),
    [anon_sym__alignof] = ACTIONS(3583),
    [anon_sym_alignof] = ACTIONS(3583),
    [anon_sym__Alignof] = ACTIONS(3583),
    [anon_sym_offsetof] = ACTIONS(3583),
    [anon_sym__Generic] = ACTIONS(3583),
    [anon_sym_asm] = ACTIONS(3583),
    [anon_sym___asm__] = ACTIONS(3583),
    [sym_number_literal] = ACTIONS(3585),
    [anon_sym_L_SQUOTE] = ACTIONS(3585),
    [anon_sym_u_SQUOTE] = ACTIONS(3585),
    [anon_sym_U_SQUOTE] = ACTIONS(3585),
    [anon_sym_u8_SQUOTE] = ACTIONS(3585),
    [anon_sym_SQUOTE] = ACTIONS(3585),
    [anon_sym_L_DQUOTE] = ACTIONS(3585),
    [anon_sym_u_DQUOTE] = ACTIONS(3585),
    [anon_sym_U_DQUOTE] = ACTIONS(3585),
    [anon_sym_u8_DQUOTE] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [sym_true] = ACTIONS(3583),
    [sym_false] = ACTIONS(3583),
    [anon_sym_NULL] = ACTIONS(3583),
    [anon_sym_nullptr] = ACTIONS(3583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3583),
    [anon_sym_let] = ACTIONS(3583),
    [anon_sym_This] = ACTIONS(3583),
    [anon_sym_decltype] = ACTIONS(3583),
    [sym_virtual] = ACTIONS(3583),
    [anon_sym_explicit] = ACTIONS(3583),
    [anon_sym_typename] = ACTIONS(3583),
    [anon_sym_template] = ACTIONS(3583),
    [anon_sym_operator] = ACTIONS(3583),
    [anon_sym_try] = ACTIONS(3583),
    [anon_sym_delete] = ACTIONS(3583),
    [anon_sym_throw] = ACTIONS(3583),
    [anon_sym_namespace] = ACTIONS(3583),
    [anon_sym_using] = ACTIONS(3583),
    [anon_sym_static_assert] = ACTIONS(3583),
    [anon_sym_concept] = ACTIONS(3583),
    [anon_sym_co_return] = ACTIONS(3583),
    [anon_sym_co_yield] = ACTIONS(3583),
    [anon_sym_R_DQUOTE] = ACTIONS(3585),
    [anon_sym_LR_DQUOTE] = ACTIONS(3585),
    [anon_sym_uR_DQUOTE] = ACTIONS(3585),
    [anon_sym_UR_DQUOTE] = ACTIONS(3585),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3585),
    [anon_sym_co_await] = ACTIONS(3583),
    [anon_sym_new] = ACTIONS(3583),
    [anon_sym_requires] = ACTIONS(3583),
    [sym_this] = ACTIONS(3583),
    [anon_sym_discard] = ACTIONS(3583),
    [anon_sym_precise] = ACTIONS(3583),
    [anon_sym_shared] = ACTIONS(3583),
    [anon_sym_groupshared] = ACTIONS(3583),
    [anon_sym_uniform] = ACTIONS(3583),
    [anon_sym_row_major] = ACTIONS(3583),
    [anon_sym_column_major] = ACTIONS(3583),
    [anon_sym_globallycoherent] = ACTIONS(3583),
    [anon_sym_centroid] = ACTIONS(3583),
    [anon_sym_noperspective] = ACTIONS(3583),
    [anon_sym_nointerpolation] = ACTIONS(3583),
    [anon_sym_sample] = ACTIONS(3583),
    [anon_sym_linear] = ACTIONS(3583),
    [anon_sym_snorm] = ACTIONS(3583),
    [anon_sym_unorm] = ACTIONS(3583),
    [anon_sym_point] = ACTIONS(3583),
    [anon_sym_line] = ACTIONS(3583),
    [anon_sym_triangleadj] = ACTIONS(3583),
    [anon_sym_lineadj] = ACTIONS(3583),
    [anon_sym_triangle] = ACTIONS(3583),
    [anon_sym_cbuffer] = ACTIONS(3583),
    [anon_sym_interface] = ACTIONS(3583),
    [anon_sym_extension] = ACTIONS(3583),
  },
  [494] = {
    [sym_identifier] = ACTIONS(3587),
    [aux_sym_preproc_include_token1] = ACTIONS(3587),
    [aux_sym_preproc_def_token1] = ACTIONS(3587),
    [aux_sym_preproc_if_token1] = ACTIONS(3587),
    [aux_sym_preproc_if_token2] = ACTIONS(3587),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3587),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3587),
    [aux_sym_preproc_else_token1] = ACTIONS(3587),
    [aux_sym_preproc_elif_token1] = ACTIONS(3587),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3587),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3587),
    [sym_preproc_directive] = ACTIONS(3587),
    [anon_sym_LPAREN2] = ACTIONS(3589),
    [anon_sym_BANG] = ACTIONS(3589),
    [anon_sym_TILDE] = ACTIONS(3589),
    [anon_sym_DASH] = ACTIONS(3587),
    [anon_sym_PLUS] = ACTIONS(3587),
    [anon_sym_STAR] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3587),
    [anon_sym_SEMI] = ACTIONS(3589),
    [anon_sym___extension__] = ACTIONS(3587),
    [anon_sym_typedef] = ACTIONS(3587),
    [anon_sym_in] = ACTIONS(3587),
    [anon_sym_out] = ACTIONS(3587),
    [anon_sym_inout] = ACTIONS(3587),
    [anon_sym_extern] = ACTIONS(3587),
    [anon_sym___attribute__] = ACTIONS(3587),
    [anon_sym_COLON_COLON] = ACTIONS(3589),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3589),
    [anon_sym___declspec] = ACTIONS(3587),
    [anon_sym___based] = ACTIONS(3587),
    [anon_sym___cdecl] = ACTIONS(3587),
    [anon_sym___clrcall] = ACTIONS(3587),
    [anon_sym___stdcall] = ACTIONS(3587),
    [anon_sym___fastcall] = ACTIONS(3587),
    [anon_sym___thiscall] = ACTIONS(3587),
    [anon_sym___vectorcall] = ACTIONS(3587),
    [anon_sym_LBRACE] = ACTIONS(3589),
    [anon_sym_signed] = ACTIONS(3587),
    [anon_sym_unsigned] = ACTIONS(3587),
    [anon_sym_long] = ACTIONS(3587),
    [anon_sym_short] = ACTIONS(3587),
    [anon_sym_LBRACK] = ACTIONS(3587),
    [anon_sym_static] = ACTIONS(3587),
    [anon_sym_register] = ACTIONS(3587),
    [anon_sym_inline] = ACTIONS(3587),
    [anon_sym___inline] = ACTIONS(3587),
    [anon_sym___inline__] = ACTIONS(3587),
    [anon_sym___forceinline] = ACTIONS(3587),
    [anon_sym_thread_local] = ACTIONS(3587),
    [anon_sym___thread] = ACTIONS(3587),
    [anon_sym_const] = ACTIONS(3587),
    [anon_sym_constexpr] = ACTIONS(3587),
    [anon_sym_volatile] = ACTIONS(3587),
    [anon_sym_restrict] = ACTIONS(3587),
    [anon_sym___restrict__] = ACTIONS(3587),
    [anon_sym__Atomic] = ACTIONS(3587),
    [anon_sym__Noreturn] = ACTIONS(3587),
    [anon_sym_noreturn] = ACTIONS(3587),
    [anon_sym_mutable] = ACTIONS(3587),
    [anon_sym_constinit] = ACTIONS(3587),
    [anon_sym_consteval] = ACTIONS(3587),
    [anon_sym_alignas] = ACTIONS(3587),
    [anon_sym__Alignas] = ACTIONS(3587),
    [sym_primitive_type] = ACTIONS(3587),
    [anon_sym_enum] = ACTIONS(3587),
    [anon_sym_class] = ACTIONS(3587),
    [anon_sym_struct] = ACTIONS(3587),
    [anon_sym_union] = ACTIONS(3587),
    [anon_sym_if] = ACTIONS(3587),
    [anon_sym_switch] = ACTIONS(3587),
    [anon_sym_case] = ACTIONS(3587),
    [anon_sym_default] = ACTIONS(3587),
    [anon_sym_while] = ACTIONS(3587),
    [anon_sym_do] = ACTIONS(3587),
    [anon_sym_for] = ACTIONS(3587),
    [anon_sym_return] = ACTIONS(3587),
    [anon_sym_break] = ACTIONS(3587),
    [anon_sym_continue] = ACTIONS(3587),
    [anon_sym_goto] = ACTIONS(3587),
    [anon_sym___try] = ACTIONS(3587),
    [anon_sym___leave] = ACTIONS(3587),
    [anon_sym_not] = ACTIONS(3587),
    [anon_sym_compl] = ACTIONS(3587),
    [anon_sym_DASH_DASH] = ACTIONS(3589),
    [anon_sym_PLUS_PLUS] = ACTIONS(3589),
    [anon_sym_sizeof] = ACTIONS(3587),
    [anon_sym___alignof__] = ACTIONS(3587),
    [anon_sym___alignof] = ACTIONS(3587),
    [anon_sym__alignof] = ACTIONS(3587),
    [anon_sym_alignof] = ACTIONS(3587),
    [anon_sym__Alignof] = ACTIONS(3587),
    [anon_sym_offsetof] = ACTIONS(3587),
    [anon_sym__Generic] = ACTIONS(3587),
    [anon_sym_asm] = ACTIONS(3587),
    [anon_sym___asm__] = ACTIONS(3587),
    [sym_number_literal] = ACTIONS(3589),
    [anon_sym_L_SQUOTE] = ACTIONS(3589),
    [anon_sym_u_SQUOTE] = ACTIONS(3589),
    [anon_sym_U_SQUOTE] = ACTIONS(3589),
    [anon_sym_u8_SQUOTE] = ACTIONS(3589),
    [anon_sym_SQUOTE] = ACTIONS(3589),
    [anon_sym_L_DQUOTE] = ACTIONS(3589),
    [anon_sym_u_DQUOTE] = ACTIONS(3589),
    [anon_sym_U_DQUOTE] = ACTIONS(3589),
    [anon_sym_u8_DQUOTE] = ACTIONS(3589),
    [anon_sym_DQUOTE] = ACTIONS(3589),
    [sym_true] = ACTIONS(3587),
    [sym_false] = ACTIONS(3587),
    [anon_sym_NULL] = ACTIONS(3587),
    [anon_sym_nullptr] = ACTIONS(3587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3587),
    [anon_sym_let] = ACTIONS(3587),
    [anon_sym_This] = ACTIONS(3587),
    [anon_sym_decltype] = ACTIONS(3587),
    [sym_virtual] = ACTIONS(3587),
    [anon_sym_explicit] = ACTIONS(3587),
    [anon_sym_typename] = ACTIONS(3587),
    [anon_sym_template] = ACTIONS(3587),
    [anon_sym_operator] = ACTIONS(3587),
    [anon_sym_try] = ACTIONS(3587),
    [anon_sym_delete] = ACTIONS(3587),
    [anon_sym_throw] = ACTIONS(3587),
    [anon_sym_namespace] = ACTIONS(3587),
    [anon_sym_using] = ACTIONS(3587),
    [anon_sym_static_assert] = ACTIONS(3587),
    [anon_sym_concept] = ACTIONS(3587),
    [anon_sym_co_return] = ACTIONS(3587),
    [anon_sym_co_yield] = ACTIONS(3587),
    [anon_sym_R_DQUOTE] = ACTIONS(3589),
    [anon_sym_LR_DQUOTE] = ACTIONS(3589),
    [anon_sym_uR_DQUOTE] = ACTIONS(3589),
    [anon_sym_UR_DQUOTE] = ACTIONS(3589),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3589),
    [anon_sym_co_await] = ACTIONS(3587),
    [anon_sym_new] = ACTIONS(3587),
    [anon_sym_requires] = ACTIONS(3587),
    [sym_this] = ACTIONS(3587),
    [anon_sym_discard] = ACTIONS(3587),
    [anon_sym_precise] = ACTIONS(3587),
    [anon_sym_shared] = ACTIONS(3587),
    [anon_sym_groupshared] = ACTIONS(3587),
    [anon_sym_uniform] = ACTIONS(3587),
    [anon_sym_row_major] = ACTIONS(3587),
    [anon_sym_column_major] = ACTIONS(3587),
    [anon_sym_globallycoherent] = ACTIONS(3587),
    [anon_sym_centroid] = ACTIONS(3587),
    [anon_sym_noperspective] = ACTIONS(3587),
    [anon_sym_nointerpolation] = ACTIONS(3587),
    [anon_sym_sample] = ACTIONS(3587),
    [anon_sym_linear] = ACTIONS(3587),
    [anon_sym_snorm] = ACTIONS(3587),
    [anon_sym_unorm] = ACTIONS(3587),
    [anon_sym_point] = ACTIONS(3587),
    [anon_sym_line] = ACTIONS(3587),
    [anon_sym_triangleadj] = ACTIONS(3587),
    [anon_sym_lineadj] = ACTIONS(3587),
    [anon_sym_triangle] = ACTIONS(3587),
    [anon_sym_cbuffer] = ACTIONS(3587),
    [anon_sym_interface] = ACTIONS(3587),
    [anon_sym_extension] = ACTIONS(3587),
  },
  [495] = {
    [sym_template_argument_list] = STATE(337),
    [aux_sym_sized_type_specifier_repeat1] = STATE(630),
    [sym_identifier] = ACTIONS(2115),
    [aux_sym_preproc_include_token1] = ACTIONS(2115),
    [aux_sym_preproc_def_token1] = ACTIONS(2115),
    [aux_sym_preproc_if_token1] = ACTIONS(2115),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2115),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2115),
    [sym_preproc_directive] = ACTIONS(2115),
    [anon_sym_LPAREN2] = ACTIONS(2123),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_AMP_AMP] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2115),
    [anon_sym_LT] = ACTIONS(2738),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym___extension__] = ACTIONS(2115),
    [anon_sym_typedef] = ACTIONS(2115),
    [anon_sym_in] = ACTIONS(2115),
    [anon_sym_out] = ACTIONS(2115),
    [anon_sym_inout] = ACTIONS(2115),
    [anon_sym_extern] = ACTIONS(2115),
    [anon_sym___attribute__] = ACTIONS(2115),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2123),
    [anon_sym___declspec] = ACTIONS(2115),
    [anon_sym___based] = ACTIONS(2115),
    [anon_sym___cdecl] = ACTIONS(2115),
    [anon_sym___clrcall] = ACTIONS(2115),
    [anon_sym___stdcall] = ACTIONS(2115),
    [anon_sym___fastcall] = ACTIONS(2115),
    [anon_sym___thiscall] = ACTIONS(2115),
    [anon_sym___vectorcall] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_signed] = ACTIONS(2146),
    [anon_sym_unsigned] = ACTIONS(2146),
    [anon_sym_long] = ACTIONS(2146),
    [anon_sym_short] = ACTIONS(2146),
    [anon_sym_LBRACK] = ACTIONS(2115),
    [anon_sym_static] = ACTIONS(2115),
    [anon_sym_register] = ACTIONS(2115),
    [anon_sym_inline] = ACTIONS(2115),
    [anon_sym___inline] = ACTIONS(2115),
    [anon_sym___inline__] = ACTIONS(2115),
    [anon_sym___forceinline] = ACTIONS(2115),
    [anon_sym_thread_local] = ACTIONS(2115),
    [anon_sym___thread] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(2115),
    [anon_sym_constexpr] = ACTIONS(2115),
    [anon_sym_volatile] = ACTIONS(2115),
    [anon_sym_restrict] = ACTIONS(2115),
    [anon_sym___restrict__] = ACTIONS(2115),
    [anon_sym__Atomic] = ACTIONS(2115),
    [anon_sym__Noreturn] = ACTIONS(2115),
    [anon_sym_noreturn] = ACTIONS(2115),
    [anon_sym_mutable] = ACTIONS(2115),
    [anon_sym_constinit] = ACTIONS(2115),
    [anon_sym_consteval] = ACTIONS(2115),
    [anon_sym_alignas] = ACTIONS(2115),
    [anon_sym__Alignas] = ACTIONS(2115),
    [sym_primitive_type] = ACTIONS(2115),
    [anon_sym_enum] = ACTIONS(2115),
    [anon_sym_class] = ACTIONS(2115),
    [anon_sym_struct] = ACTIONS(2115),
    [anon_sym_union] = ACTIONS(2115),
    [anon_sym_if] = ACTIONS(2115),
    [anon_sym_switch] = ACTIONS(2115),
    [anon_sym_case] = ACTIONS(2115),
    [anon_sym_default] = ACTIONS(2115),
    [anon_sym_while] = ACTIONS(2115),
    [anon_sym_do] = ACTIONS(2115),
    [anon_sym_for] = ACTIONS(2115),
    [anon_sym_return] = ACTIONS(2115),
    [anon_sym_break] = ACTIONS(2115),
    [anon_sym_continue] = ACTIONS(2115),
    [anon_sym_goto] = ACTIONS(2115),
    [anon_sym___try] = ACTIONS(2115),
    [anon_sym___leave] = ACTIONS(2115),
    [anon_sym_not] = ACTIONS(2115),
    [anon_sym_compl] = ACTIONS(2115),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_sizeof] = ACTIONS(2115),
    [anon_sym___alignof__] = ACTIONS(2115),
    [anon_sym___alignof] = ACTIONS(2115),
    [anon_sym__alignof] = ACTIONS(2115),
    [anon_sym_alignof] = ACTIONS(2115),
    [anon_sym__Alignof] = ACTIONS(2115),
    [anon_sym_offsetof] = ACTIONS(2115),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2115),
    [anon_sym___asm__] = ACTIONS(2115),
    [anon_sym_DOT] = ACTIONS(2115),
    [sym_number_literal] = ACTIONS(2123),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2123),
    [anon_sym_u_DQUOTE] = ACTIONS(2123),
    [anon_sym_U_DQUOTE] = ACTIONS(2123),
    [anon_sym_u8_DQUOTE] = ACTIONS(2123),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [sym_true] = ACTIONS(2115),
    [sym_false] = ACTIONS(2115),
    [anon_sym_NULL] = ACTIONS(2115),
    [anon_sym_nullptr] = ACTIONS(2115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2115),
    [anon_sym_let] = ACTIONS(2115),
    [anon_sym_This] = ACTIONS(2115),
    [anon_sym_decltype] = ACTIONS(2115),
    [sym_virtual] = ACTIONS(2115),
    [anon_sym_explicit] = ACTIONS(2115),
    [anon_sym_typename] = ACTIONS(2115),
    [anon_sym_template] = ACTIONS(2115),
    [anon_sym_operator] = ACTIONS(2115),
    [anon_sym_try] = ACTIONS(2115),
    [anon_sym_delete] = ACTIONS(2115),
    [anon_sym_throw] = ACTIONS(2115),
    [anon_sym_namespace] = ACTIONS(2115),
    [anon_sym_using] = ACTIONS(2115),
    [anon_sym_static_assert] = ACTIONS(2115),
    [anon_sym_concept] = ACTIONS(2115),
    [anon_sym_co_return] = ACTIONS(2115),
    [anon_sym_co_yield] = ACTIONS(2115),
    [anon_sym_R_DQUOTE] = ACTIONS(2123),
    [anon_sym_LR_DQUOTE] = ACTIONS(2123),
    [anon_sym_uR_DQUOTE] = ACTIONS(2123),
    [anon_sym_UR_DQUOTE] = ACTIONS(2123),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2123),
    [anon_sym_co_await] = ACTIONS(2115),
    [anon_sym_new] = ACTIONS(2115),
    [anon_sym_requires] = ACTIONS(2115),
    [sym_this] = ACTIONS(2115),
    [anon_sym_discard] = ACTIONS(2115),
    [anon_sym_precise] = ACTIONS(2115),
    [anon_sym_shared] = ACTIONS(2115),
    [anon_sym_groupshared] = ACTIONS(2115),
    [anon_sym_uniform] = ACTIONS(2115),
    [anon_sym_row_major] = ACTIONS(2115),
    [anon_sym_column_major] = ACTIONS(2115),
    [anon_sym_globallycoherent] = ACTIONS(2115),
    [anon_sym_centroid] = ACTIONS(2115),
    [anon_sym_noperspective] = ACTIONS(2115),
    [anon_sym_nointerpolation] = ACTIONS(2115),
    [anon_sym_sample] = ACTIONS(2115),
    [anon_sym_linear] = ACTIONS(2115),
    [anon_sym_snorm] = ACTIONS(2115),
    [anon_sym_unorm] = ACTIONS(2115),
    [anon_sym_point] = ACTIONS(2115),
    [anon_sym_line] = ACTIONS(2115),
    [anon_sym_triangleadj] = ACTIONS(2115),
    [anon_sym_lineadj] = ACTIONS(2115),
    [anon_sym_triangle] = ACTIONS(2115),
    [anon_sym_cbuffer] = ACTIONS(2115),
    [anon_sym_interface] = ACTIONS(2115),
    [anon_sym_extension] = ACTIONS(2115),
  },
  [496] = {
    [sym_identifier] = ACTIONS(3591),
    [aux_sym_preproc_include_token1] = ACTIONS(3591),
    [aux_sym_preproc_def_token1] = ACTIONS(3591),
    [aux_sym_preproc_if_token1] = ACTIONS(3591),
    [aux_sym_preproc_if_token2] = ACTIONS(3591),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3591),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3591),
    [aux_sym_preproc_else_token1] = ACTIONS(3591),
    [aux_sym_preproc_elif_token1] = ACTIONS(3591),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3591),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3591),
    [sym_preproc_directive] = ACTIONS(3591),
    [anon_sym_LPAREN2] = ACTIONS(3594),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [anon_sym_DASH] = ACTIONS(3591),
    [anon_sym_PLUS] = ACTIONS(3591),
    [anon_sym_STAR] = ACTIONS(3594),
    [anon_sym_AMP_AMP] = ACTIONS(3594),
    [anon_sym_AMP] = ACTIONS(3591),
    [anon_sym_SEMI] = ACTIONS(3594),
    [anon_sym___extension__] = ACTIONS(3591),
    [anon_sym_typedef] = ACTIONS(3591),
    [anon_sym_in] = ACTIONS(3591),
    [anon_sym_out] = ACTIONS(3591),
    [anon_sym_inout] = ACTIONS(3591),
    [anon_sym_extern] = ACTIONS(3591),
    [anon_sym___attribute__] = ACTIONS(3591),
    [anon_sym_COLON_COLON] = ACTIONS(3594),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3594),
    [anon_sym___declspec] = ACTIONS(3591),
    [anon_sym___based] = ACTIONS(3591),
    [anon_sym___cdecl] = ACTIONS(3591),
    [anon_sym___clrcall] = ACTIONS(3591),
    [anon_sym___stdcall] = ACTIONS(3591),
    [anon_sym___fastcall] = ACTIONS(3591),
    [anon_sym___thiscall] = ACTIONS(3591),
    [anon_sym___vectorcall] = ACTIONS(3591),
    [anon_sym_LBRACE] = ACTIONS(3594),
    [anon_sym_signed] = ACTIONS(3591),
    [anon_sym_unsigned] = ACTIONS(3591),
    [anon_sym_long] = ACTIONS(3591),
    [anon_sym_short] = ACTIONS(3591),
    [anon_sym_LBRACK] = ACTIONS(3591),
    [anon_sym_static] = ACTIONS(3591),
    [anon_sym_register] = ACTIONS(3591),
    [anon_sym_inline] = ACTIONS(3591),
    [anon_sym___inline] = ACTIONS(3591),
    [anon_sym___inline__] = ACTIONS(3591),
    [anon_sym___forceinline] = ACTIONS(3591),
    [anon_sym_thread_local] = ACTIONS(3591),
    [anon_sym___thread] = ACTIONS(3591),
    [anon_sym_const] = ACTIONS(3591),
    [anon_sym_constexpr] = ACTIONS(3591),
    [anon_sym_volatile] = ACTIONS(3591),
    [anon_sym_restrict] = ACTIONS(3591),
    [anon_sym___restrict__] = ACTIONS(3591),
    [anon_sym__Atomic] = ACTIONS(3591),
    [anon_sym__Noreturn] = ACTIONS(3591),
    [anon_sym_noreturn] = ACTIONS(3591),
    [anon_sym_mutable] = ACTIONS(3591),
    [anon_sym_constinit] = ACTIONS(3591),
    [anon_sym_consteval] = ACTIONS(3591),
    [anon_sym_alignas] = ACTIONS(3591),
    [anon_sym__Alignas] = ACTIONS(3591),
    [sym_primitive_type] = ACTIONS(3591),
    [anon_sym_enum] = ACTIONS(3591),
    [anon_sym_class] = ACTIONS(3591),
    [anon_sym_struct] = ACTIONS(3591),
    [anon_sym_union] = ACTIONS(3591),
    [anon_sym_if] = ACTIONS(3591),
    [anon_sym_switch] = ACTIONS(3591),
    [anon_sym_case] = ACTIONS(3591),
    [anon_sym_default] = ACTIONS(3591),
    [anon_sym_while] = ACTIONS(3591),
    [anon_sym_do] = ACTIONS(3591),
    [anon_sym_for] = ACTIONS(3591),
    [anon_sym_return] = ACTIONS(3591),
    [anon_sym_break] = ACTIONS(3591),
    [anon_sym_continue] = ACTIONS(3591),
    [anon_sym_goto] = ACTIONS(3591),
    [anon_sym___try] = ACTIONS(3591),
    [anon_sym___leave] = ACTIONS(3591),
    [anon_sym_not] = ACTIONS(3591),
    [anon_sym_compl] = ACTIONS(3591),
    [anon_sym_DASH_DASH] = ACTIONS(3594),
    [anon_sym_PLUS_PLUS] = ACTIONS(3594),
    [anon_sym_sizeof] = ACTIONS(3591),
    [anon_sym___alignof__] = ACTIONS(3591),
    [anon_sym___alignof] = ACTIONS(3591),
    [anon_sym__alignof] = ACTIONS(3591),
    [anon_sym_alignof] = ACTIONS(3591),
    [anon_sym__Alignof] = ACTIONS(3591),
    [anon_sym_offsetof] = ACTIONS(3591),
    [anon_sym__Generic] = ACTIONS(3591),
    [anon_sym_asm] = ACTIONS(3591),
    [anon_sym___asm__] = ACTIONS(3591),
    [sym_number_literal] = ACTIONS(3594),
    [anon_sym_L_SQUOTE] = ACTIONS(3594),
    [anon_sym_u_SQUOTE] = ACTIONS(3594),
    [anon_sym_U_SQUOTE] = ACTIONS(3594),
    [anon_sym_u8_SQUOTE] = ACTIONS(3594),
    [anon_sym_SQUOTE] = ACTIONS(3594),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_true] = ACTIONS(3591),
    [sym_false] = ACTIONS(3591),
    [anon_sym_NULL] = ACTIONS(3591),
    [anon_sym_nullptr] = ACTIONS(3591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3591),
    [anon_sym_let] = ACTIONS(3591),
    [anon_sym_This] = ACTIONS(3591),
    [anon_sym_decltype] = ACTIONS(3591),
    [sym_virtual] = ACTIONS(3591),
    [anon_sym_explicit] = ACTIONS(3591),
    [anon_sym_typename] = ACTIONS(3591),
    [anon_sym_template] = ACTIONS(3591),
    [anon_sym_operator] = ACTIONS(3591),
    [anon_sym_try] = ACTIONS(3591),
    [anon_sym_delete] = ACTIONS(3591),
    [anon_sym_throw] = ACTIONS(3591),
    [anon_sym_namespace] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3591),
    [anon_sym_static_assert] = ACTIONS(3591),
    [anon_sym_concept] = ACTIONS(3591),
    [anon_sym_co_return] = ACTIONS(3591),
    [anon_sym_co_yield] = ACTIONS(3591),
    [anon_sym_R_DQUOTE] = ACTIONS(3594),
    [anon_sym_LR_DQUOTE] = ACTIONS(3594),
    [anon_sym_uR_DQUOTE] = ACTIONS(3594),
    [anon_sym_UR_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3594),
    [anon_sym_co_await] = ACTIONS(3591),
    [anon_sym_new] = ACTIONS(3591),
    [anon_sym_requires] = ACTIONS(3591),
    [sym_this] = ACTIONS(3591),
    [anon_sym_discard] = ACTIONS(3591),
    [anon_sym_precise] = ACTIONS(3591),
    [anon_sym_shared] = ACTIONS(3591),
    [anon_sym_groupshared] = ACTIONS(3591),
    [anon_sym_uniform] = ACTIONS(3591),
    [anon_sym_row_major] = ACTIONS(3591),
    [anon_sym_column_major] = ACTIONS(3591),
    [anon_sym_globallycoherent] = ACTIONS(3591),
    [anon_sym_centroid] = ACTIONS(3591),
    [anon_sym_noperspective] = ACTIONS(3591),
    [anon_sym_nointerpolation] = ACTIONS(3591),
    [anon_sym_sample] = ACTIONS(3591),
    [anon_sym_linear] = ACTIONS(3591),
    [anon_sym_snorm] = ACTIONS(3591),
    [anon_sym_unorm] = ACTIONS(3591),
    [anon_sym_point] = ACTIONS(3591),
    [anon_sym_line] = ACTIONS(3591),
    [anon_sym_triangleadj] = ACTIONS(3591),
    [anon_sym_lineadj] = ACTIONS(3591),
    [anon_sym_triangle] = ACTIONS(3591),
    [anon_sym_cbuffer] = ACTIONS(3591),
    [anon_sym_interface] = ACTIONS(3591),
    [anon_sym_extension] = ACTIONS(3591),
  },
  [497] = {
    [sym_identifier] = ACTIONS(3597),
    [aux_sym_preproc_include_token1] = ACTIONS(3597),
    [aux_sym_preproc_def_token1] = ACTIONS(3597),
    [aux_sym_preproc_if_token1] = ACTIONS(3597),
    [aux_sym_preproc_if_token2] = ACTIONS(3597),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3597),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3597),
    [aux_sym_preproc_else_token1] = ACTIONS(3597),
    [aux_sym_preproc_elif_token1] = ACTIONS(3597),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3597),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3597),
    [sym_preproc_directive] = ACTIONS(3597),
    [anon_sym_LPAREN2] = ACTIONS(3599),
    [anon_sym_BANG] = ACTIONS(3599),
    [anon_sym_TILDE] = ACTIONS(3599),
    [anon_sym_DASH] = ACTIONS(3597),
    [anon_sym_PLUS] = ACTIONS(3597),
    [anon_sym_STAR] = ACTIONS(3599),
    [anon_sym_AMP_AMP] = ACTIONS(3599),
    [anon_sym_AMP] = ACTIONS(3597),
    [anon_sym_SEMI] = ACTIONS(3599),
    [anon_sym___extension__] = ACTIONS(3597),
    [anon_sym_typedef] = ACTIONS(3597),
    [anon_sym_in] = ACTIONS(3597),
    [anon_sym_out] = ACTIONS(3597),
    [anon_sym_inout] = ACTIONS(3597),
    [anon_sym_extern] = ACTIONS(3597),
    [anon_sym___attribute__] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3599),
    [anon_sym___declspec] = ACTIONS(3597),
    [anon_sym___based] = ACTIONS(3597),
    [anon_sym___cdecl] = ACTIONS(3597),
    [anon_sym___clrcall] = ACTIONS(3597),
    [anon_sym___stdcall] = ACTIONS(3597),
    [anon_sym___fastcall] = ACTIONS(3597),
    [anon_sym___thiscall] = ACTIONS(3597),
    [anon_sym___vectorcall] = ACTIONS(3597),
    [anon_sym_LBRACE] = ACTIONS(3599),
    [anon_sym_signed] = ACTIONS(3597),
    [anon_sym_unsigned] = ACTIONS(3597),
    [anon_sym_long] = ACTIONS(3597),
    [anon_sym_short] = ACTIONS(3597),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_static] = ACTIONS(3597),
    [anon_sym_register] = ACTIONS(3597),
    [anon_sym_inline] = ACTIONS(3597),
    [anon_sym___inline] = ACTIONS(3597),
    [anon_sym___inline__] = ACTIONS(3597),
    [anon_sym___forceinline] = ACTIONS(3597),
    [anon_sym_thread_local] = ACTIONS(3597),
    [anon_sym___thread] = ACTIONS(3597),
    [anon_sym_const] = ACTIONS(3597),
    [anon_sym_constexpr] = ACTIONS(3597),
    [anon_sym_volatile] = ACTIONS(3597),
    [anon_sym_restrict] = ACTIONS(3597),
    [anon_sym___restrict__] = ACTIONS(3597),
    [anon_sym__Atomic] = ACTIONS(3597),
    [anon_sym__Noreturn] = ACTIONS(3597),
    [anon_sym_noreturn] = ACTIONS(3597),
    [anon_sym_mutable] = ACTIONS(3597),
    [anon_sym_constinit] = ACTIONS(3597),
    [anon_sym_consteval] = ACTIONS(3597),
    [anon_sym_alignas] = ACTIONS(3597),
    [anon_sym__Alignas] = ACTIONS(3597),
    [sym_primitive_type] = ACTIONS(3597),
    [anon_sym_enum] = ACTIONS(3597),
    [anon_sym_class] = ACTIONS(3597),
    [anon_sym_struct] = ACTIONS(3597),
    [anon_sym_union] = ACTIONS(3597),
    [anon_sym_if] = ACTIONS(3597),
    [anon_sym_switch] = ACTIONS(3597),
    [anon_sym_case] = ACTIONS(3597),
    [anon_sym_default] = ACTIONS(3597),
    [anon_sym_while] = ACTIONS(3597),
    [anon_sym_do] = ACTIONS(3597),
    [anon_sym_for] = ACTIONS(3597),
    [anon_sym_return] = ACTIONS(3597),
    [anon_sym_break] = ACTIONS(3597),
    [anon_sym_continue] = ACTIONS(3597),
    [anon_sym_goto] = ACTIONS(3597),
    [anon_sym___try] = ACTIONS(3597),
    [anon_sym___leave] = ACTIONS(3597),
    [anon_sym_not] = ACTIONS(3597),
    [anon_sym_compl] = ACTIONS(3597),
    [anon_sym_DASH_DASH] = ACTIONS(3599),
    [anon_sym_PLUS_PLUS] = ACTIONS(3599),
    [anon_sym_sizeof] = ACTIONS(3597),
    [anon_sym___alignof__] = ACTIONS(3597),
    [anon_sym___alignof] = ACTIONS(3597),
    [anon_sym__alignof] = ACTIONS(3597),
    [anon_sym_alignof] = ACTIONS(3597),
    [anon_sym__Alignof] = ACTIONS(3597),
    [anon_sym_offsetof] = ACTIONS(3597),
    [anon_sym__Generic] = ACTIONS(3597),
    [anon_sym_asm] = ACTIONS(3597),
    [anon_sym___asm__] = ACTIONS(3597),
    [sym_number_literal] = ACTIONS(3599),
    [anon_sym_L_SQUOTE] = ACTIONS(3599),
    [anon_sym_u_SQUOTE] = ACTIONS(3599),
    [anon_sym_U_SQUOTE] = ACTIONS(3599),
    [anon_sym_u8_SQUOTE] = ACTIONS(3599),
    [anon_sym_SQUOTE] = ACTIONS(3599),
    [anon_sym_L_DQUOTE] = ACTIONS(3599),
    [anon_sym_u_DQUOTE] = ACTIONS(3599),
    [anon_sym_U_DQUOTE] = ACTIONS(3599),
    [anon_sym_u8_DQUOTE] = ACTIONS(3599),
    [anon_sym_DQUOTE] = ACTIONS(3599),
    [sym_true] = ACTIONS(3597),
    [sym_false] = ACTIONS(3597),
    [anon_sym_NULL] = ACTIONS(3597),
    [anon_sym_nullptr] = ACTIONS(3597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3597),
    [anon_sym_let] = ACTIONS(3597),
    [anon_sym_This] = ACTIONS(3597),
    [anon_sym_decltype] = ACTIONS(3597),
    [sym_virtual] = ACTIONS(3597),
    [anon_sym_explicit] = ACTIONS(3597),
    [anon_sym_typename] = ACTIONS(3597),
    [anon_sym_template] = ACTIONS(3597),
    [anon_sym_operator] = ACTIONS(3597),
    [anon_sym_try] = ACTIONS(3597),
    [anon_sym_delete] = ACTIONS(3597),
    [anon_sym_throw] = ACTIONS(3597),
    [anon_sym_namespace] = ACTIONS(3597),
    [anon_sym_using] = ACTIONS(3597),
    [anon_sym_static_assert] = ACTIONS(3597),
    [anon_sym_concept] = ACTIONS(3597),
    [anon_sym_co_return] = ACTIONS(3597),
    [anon_sym_co_yield] = ACTIONS(3597),
    [anon_sym_R_DQUOTE] = ACTIONS(3599),
    [anon_sym_LR_DQUOTE] = ACTIONS(3599),
    [anon_sym_uR_DQUOTE] = ACTIONS(3599),
    [anon_sym_UR_DQUOTE] = ACTIONS(3599),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3599),
    [anon_sym_co_await] = ACTIONS(3597),
    [anon_sym_new] = ACTIONS(3597),
    [anon_sym_requires] = ACTIONS(3597),
    [sym_this] = ACTIONS(3597),
    [anon_sym_discard] = ACTIONS(3597),
    [anon_sym_precise] = ACTIONS(3597),
    [anon_sym_shared] = ACTIONS(3597),
    [anon_sym_groupshared] = ACTIONS(3597),
    [anon_sym_uniform] = ACTIONS(3597),
    [anon_sym_row_major] = ACTIONS(3597),
    [anon_sym_column_major] = ACTIONS(3597),
    [anon_sym_globallycoherent] = ACTIONS(3597),
    [anon_sym_centroid] = ACTIONS(3597),
    [anon_sym_noperspective] = ACTIONS(3597),
    [anon_sym_nointerpolation] = ACTIONS(3597),
    [anon_sym_sample] = ACTIONS(3597),
    [anon_sym_linear] = ACTIONS(3597),
    [anon_sym_snorm] = ACTIONS(3597),
    [anon_sym_unorm] = ACTIONS(3597),
    [anon_sym_point] = ACTIONS(3597),
    [anon_sym_line] = ACTIONS(3597),
    [anon_sym_triangleadj] = ACTIONS(3597),
    [anon_sym_lineadj] = ACTIONS(3597),
    [anon_sym_triangle] = ACTIONS(3597),
    [anon_sym_cbuffer] = ACTIONS(3597),
    [anon_sym_interface] = ACTIONS(3597),
    [anon_sym_extension] = ACTIONS(3597),
  },
  [498] = {
    [sym_identifier] = ACTIONS(3601),
    [aux_sym_preproc_include_token1] = ACTIONS(3601),
    [aux_sym_preproc_def_token1] = ACTIONS(3601),
    [aux_sym_preproc_if_token1] = ACTIONS(3601),
    [aux_sym_preproc_if_token2] = ACTIONS(3601),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3601),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3601),
    [aux_sym_preproc_else_token1] = ACTIONS(3601),
    [aux_sym_preproc_elif_token1] = ACTIONS(3601),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3601),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3601),
    [sym_preproc_directive] = ACTIONS(3601),
    [anon_sym_LPAREN2] = ACTIONS(3603),
    [anon_sym_BANG] = ACTIONS(3603),
    [anon_sym_TILDE] = ACTIONS(3603),
    [anon_sym_DASH] = ACTIONS(3601),
    [anon_sym_PLUS] = ACTIONS(3601),
    [anon_sym_STAR] = ACTIONS(3603),
    [anon_sym_AMP_AMP] = ACTIONS(3603),
    [anon_sym_AMP] = ACTIONS(3601),
    [anon_sym_SEMI] = ACTIONS(3603),
    [anon_sym___extension__] = ACTIONS(3601),
    [anon_sym_typedef] = ACTIONS(3601),
    [anon_sym_in] = ACTIONS(3601),
    [anon_sym_out] = ACTIONS(3601),
    [anon_sym_inout] = ACTIONS(3601),
    [anon_sym_extern] = ACTIONS(3601),
    [anon_sym___attribute__] = ACTIONS(3601),
    [anon_sym_COLON_COLON] = ACTIONS(3603),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3603),
    [anon_sym___declspec] = ACTIONS(3601),
    [anon_sym___based] = ACTIONS(3601),
    [anon_sym___cdecl] = ACTIONS(3601),
    [anon_sym___clrcall] = ACTIONS(3601),
    [anon_sym___stdcall] = ACTIONS(3601),
    [anon_sym___fastcall] = ACTIONS(3601),
    [anon_sym___thiscall] = ACTIONS(3601),
    [anon_sym___vectorcall] = ACTIONS(3601),
    [anon_sym_LBRACE] = ACTIONS(3603),
    [anon_sym_signed] = ACTIONS(3601),
    [anon_sym_unsigned] = ACTIONS(3601),
    [anon_sym_long] = ACTIONS(3601),
    [anon_sym_short] = ACTIONS(3601),
    [anon_sym_LBRACK] = ACTIONS(3601),
    [anon_sym_static] = ACTIONS(3601),
    [anon_sym_register] = ACTIONS(3601),
    [anon_sym_inline] = ACTIONS(3601),
    [anon_sym___inline] = ACTIONS(3601),
    [anon_sym___inline__] = ACTIONS(3601),
    [anon_sym___forceinline] = ACTIONS(3601),
    [anon_sym_thread_local] = ACTIONS(3601),
    [anon_sym___thread] = ACTIONS(3601),
    [anon_sym_const] = ACTIONS(3601),
    [anon_sym_constexpr] = ACTIONS(3601),
    [anon_sym_volatile] = ACTIONS(3601),
    [anon_sym_restrict] = ACTIONS(3601),
    [anon_sym___restrict__] = ACTIONS(3601),
    [anon_sym__Atomic] = ACTIONS(3601),
    [anon_sym__Noreturn] = ACTIONS(3601),
    [anon_sym_noreturn] = ACTIONS(3601),
    [anon_sym_mutable] = ACTIONS(3601),
    [anon_sym_constinit] = ACTIONS(3601),
    [anon_sym_consteval] = ACTIONS(3601),
    [anon_sym_alignas] = ACTIONS(3601),
    [anon_sym__Alignas] = ACTIONS(3601),
    [sym_primitive_type] = ACTIONS(3601),
    [anon_sym_enum] = ACTIONS(3601),
    [anon_sym_class] = ACTIONS(3601),
    [anon_sym_struct] = ACTIONS(3601),
    [anon_sym_union] = ACTIONS(3601),
    [anon_sym_if] = ACTIONS(3601),
    [anon_sym_switch] = ACTIONS(3601),
    [anon_sym_case] = ACTIONS(3601),
    [anon_sym_default] = ACTIONS(3601),
    [anon_sym_while] = ACTIONS(3601),
    [anon_sym_do] = ACTIONS(3601),
    [anon_sym_for] = ACTIONS(3601),
    [anon_sym_return] = ACTIONS(3601),
    [anon_sym_break] = ACTIONS(3601),
    [anon_sym_continue] = ACTIONS(3601),
    [anon_sym_goto] = ACTIONS(3601),
    [anon_sym___try] = ACTIONS(3601),
    [anon_sym___leave] = ACTIONS(3601),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_compl] = ACTIONS(3601),
    [anon_sym_DASH_DASH] = ACTIONS(3603),
    [anon_sym_PLUS_PLUS] = ACTIONS(3603),
    [anon_sym_sizeof] = ACTIONS(3601),
    [anon_sym___alignof__] = ACTIONS(3601),
    [anon_sym___alignof] = ACTIONS(3601),
    [anon_sym__alignof] = ACTIONS(3601),
    [anon_sym_alignof] = ACTIONS(3601),
    [anon_sym__Alignof] = ACTIONS(3601),
    [anon_sym_offsetof] = ACTIONS(3601),
    [anon_sym__Generic] = ACTIONS(3601),
    [anon_sym_asm] = ACTIONS(3601),
    [anon_sym___asm__] = ACTIONS(3601),
    [sym_number_literal] = ACTIONS(3603),
    [anon_sym_L_SQUOTE] = ACTIONS(3603),
    [anon_sym_u_SQUOTE] = ACTIONS(3603),
    [anon_sym_U_SQUOTE] = ACTIONS(3603),
    [anon_sym_u8_SQUOTE] = ACTIONS(3603),
    [anon_sym_SQUOTE] = ACTIONS(3603),
    [anon_sym_L_DQUOTE] = ACTIONS(3603),
    [anon_sym_u_DQUOTE] = ACTIONS(3603),
    [anon_sym_U_DQUOTE] = ACTIONS(3603),
    [anon_sym_u8_DQUOTE] = ACTIONS(3603),
    [anon_sym_DQUOTE] = ACTIONS(3603),
    [sym_true] = ACTIONS(3601),
    [sym_false] = ACTIONS(3601),
    [anon_sym_NULL] = ACTIONS(3601),
    [anon_sym_nullptr] = ACTIONS(3601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3601),
    [anon_sym_let] = ACTIONS(3601),
    [anon_sym_This] = ACTIONS(3601),
    [anon_sym_decltype] = ACTIONS(3601),
    [sym_virtual] = ACTIONS(3601),
    [anon_sym_explicit] = ACTIONS(3601),
    [anon_sym_typename] = ACTIONS(3601),
    [anon_sym_template] = ACTIONS(3601),
    [anon_sym_operator] = ACTIONS(3601),
    [anon_sym_try] = ACTIONS(3601),
    [anon_sym_delete] = ACTIONS(3601),
    [anon_sym_throw] = ACTIONS(3601),
    [anon_sym_namespace] = ACTIONS(3601),
    [anon_sym_using] = ACTIONS(3601),
    [anon_sym_static_assert] = ACTIONS(3601),
    [anon_sym_concept] = ACTIONS(3601),
    [anon_sym_co_return] = ACTIONS(3601),
    [anon_sym_co_yield] = ACTIONS(3601),
    [anon_sym_R_DQUOTE] = ACTIONS(3603),
    [anon_sym_LR_DQUOTE] = ACTIONS(3603),
    [anon_sym_uR_DQUOTE] = ACTIONS(3603),
    [anon_sym_UR_DQUOTE] = ACTIONS(3603),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3603),
    [anon_sym_co_await] = ACTIONS(3601),
    [anon_sym_new] = ACTIONS(3601),
    [anon_sym_requires] = ACTIONS(3601),
    [sym_this] = ACTIONS(3601),
    [anon_sym_discard] = ACTIONS(3601),
    [anon_sym_precise] = ACTIONS(3601),
    [anon_sym_shared] = ACTIONS(3601),
    [anon_sym_groupshared] = ACTIONS(3601),
    [anon_sym_uniform] = ACTIONS(3601),
    [anon_sym_row_major] = ACTIONS(3601),
    [anon_sym_column_major] = ACTIONS(3601),
    [anon_sym_globallycoherent] = ACTIONS(3601),
    [anon_sym_centroid] = ACTIONS(3601),
    [anon_sym_noperspective] = ACTIONS(3601),
    [anon_sym_nointerpolation] = ACTIONS(3601),
    [anon_sym_sample] = ACTIONS(3601),
    [anon_sym_linear] = ACTIONS(3601),
    [anon_sym_snorm] = ACTIONS(3601),
    [anon_sym_unorm] = ACTIONS(3601),
    [anon_sym_point] = ACTIONS(3601),
    [anon_sym_line] = ACTIONS(3601),
    [anon_sym_triangleadj] = ACTIONS(3601),
    [anon_sym_lineadj] = ACTIONS(3601),
    [anon_sym_triangle] = ACTIONS(3601),
    [anon_sym_cbuffer] = ACTIONS(3601),
    [anon_sym_interface] = ACTIONS(3601),
    [anon_sym_extension] = ACTIONS(3601),
  },
  [499] = {
    [sym_identifier] = ACTIONS(2248),
    [aux_sym_preproc_include_token1] = ACTIONS(2248),
    [aux_sym_preproc_def_token1] = ACTIONS(2248),
    [aux_sym_preproc_if_token1] = ACTIONS(2248),
    [aux_sym_preproc_if_token2] = ACTIONS(2248),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2248),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2248),
    [sym_preproc_directive] = ACTIONS(2248),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2248),
    [anon_sym_PLUS] = ACTIONS(2248),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2248),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym___extension__] = ACTIONS(2248),
    [anon_sym_typedef] = ACTIONS(2248),
    [anon_sym_in] = ACTIONS(2248),
    [anon_sym_out] = ACTIONS(2248),
    [anon_sym_inout] = ACTIONS(2248),
    [anon_sym_extern] = ACTIONS(2248),
    [anon_sym___attribute__] = ACTIONS(2248),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2250),
    [anon_sym___declspec] = ACTIONS(2248),
    [anon_sym___based] = ACTIONS(2248),
    [anon_sym___cdecl] = ACTIONS(2248),
    [anon_sym___clrcall] = ACTIONS(2248),
    [anon_sym___stdcall] = ACTIONS(2248),
    [anon_sym___fastcall] = ACTIONS(2248),
    [anon_sym___thiscall] = ACTIONS(2248),
    [anon_sym___vectorcall] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_signed] = ACTIONS(2248),
    [anon_sym_unsigned] = ACTIONS(2248),
    [anon_sym_long] = ACTIONS(2248),
    [anon_sym_short] = ACTIONS(2248),
    [anon_sym_LBRACK] = ACTIONS(2248),
    [anon_sym_static] = ACTIONS(2248),
    [anon_sym_register] = ACTIONS(2248),
    [anon_sym_inline] = ACTIONS(2248),
    [anon_sym___inline] = ACTIONS(2248),
    [anon_sym___inline__] = ACTIONS(2248),
    [anon_sym___forceinline] = ACTIONS(2248),
    [anon_sym_thread_local] = ACTIONS(2248),
    [anon_sym___thread] = ACTIONS(2248),
    [anon_sym_const] = ACTIONS(2248),
    [anon_sym_constexpr] = ACTIONS(2248),
    [anon_sym_volatile] = ACTIONS(2248),
    [anon_sym_restrict] = ACTIONS(2248),
    [anon_sym___restrict__] = ACTIONS(2248),
    [anon_sym__Atomic] = ACTIONS(2248),
    [anon_sym__Noreturn] = ACTIONS(2248),
    [anon_sym_noreturn] = ACTIONS(2248),
    [anon_sym_mutable] = ACTIONS(2248),
    [anon_sym_constinit] = ACTIONS(2248),
    [anon_sym_consteval] = ACTIONS(2248),
    [anon_sym_alignas] = ACTIONS(2248),
    [anon_sym__Alignas] = ACTIONS(2248),
    [sym_primitive_type] = ACTIONS(2248),
    [anon_sym_enum] = ACTIONS(2248),
    [anon_sym_class] = ACTIONS(2248),
    [anon_sym_struct] = ACTIONS(2248),
    [anon_sym_union] = ACTIONS(2248),
    [anon_sym_if] = ACTIONS(2248),
    [anon_sym_else] = ACTIONS(2248),
    [anon_sym_switch] = ACTIONS(2248),
    [anon_sym_case] = ACTIONS(2248),
    [anon_sym_default] = ACTIONS(2248),
    [anon_sym_while] = ACTIONS(2248),
    [anon_sym_do] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2248),
    [anon_sym_break] = ACTIONS(2248),
    [anon_sym_continue] = ACTIONS(2248),
    [anon_sym_goto] = ACTIONS(2248),
    [anon_sym___try] = ACTIONS(2248),
    [anon_sym___leave] = ACTIONS(2248),
    [anon_sym_not] = ACTIONS(2248),
    [anon_sym_compl] = ACTIONS(2248),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_sizeof] = ACTIONS(2248),
    [anon_sym___alignof__] = ACTIONS(2248),
    [anon_sym___alignof] = ACTIONS(2248),
    [anon_sym__alignof] = ACTIONS(2248),
    [anon_sym_alignof] = ACTIONS(2248),
    [anon_sym__Alignof] = ACTIONS(2248),
    [anon_sym_offsetof] = ACTIONS(2248),
    [anon_sym__Generic] = ACTIONS(2248),
    [anon_sym_asm] = ACTIONS(2248),
    [anon_sym___asm__] = ACTIONS(2248),
    [sym_number_literal] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2250),
    [anon_sym_u_SQUOTE] = ACTIONS(2250),
    [anon_sym_U_SQUOTE] = ACTIONS(2250),
    [anon_sym_u8_SQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym_L_DQUOTE] = ACTIONS(2250),
    [anon_sym_u_DQUOTE] = ACTIONS(2250),
    [anon_sym_U_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [sym_true] = ACTIONS(2248),
    [sym_false] = ACTIONS(2248),
    [anon_sym_NULL] = ACTIONS(2248),
    [anon_sym_nullptr] = ACTIONS(2248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2248),
    [anon_sym_let] = ACTIONS(2248),
    [anon_sym_This] = ACTIONS(2248),
    [anon_sym_decltype] = ACTIONS(2248),
    [anon_sym_final] = ACTIONS(2248),
    [anon_sym_override] = ACTIONS(2248),
    [sym_virtual] = ACTIONS(2248),
    [anon_sym_explicit] = ACTIONS(2248),
    [anon_sym_typename] = ACTIONS(2248),
    [anon_sym_template] = ACTIONS(2248),
    [anon_sym_operator] = ACTIONS(2248),
    [anon_sym_try] = ACTIONS(2248),
    [anon_sym_delete] = ACTIONS(2248),
    [anon_sym_throw] = ACTIONS(2248),
    [anon_sym_namespace] = ACTIONS(2248),
    [anon_sym_using] = ACTIONS(2248),
    [anon_sym_static_assert] = ACTIONS(2248),
    [anon_sym_concept] = ACTIONS(2248),
    [anon_sym_co_return] = ACTIONS(2248),
    [anon_sym_co_yield] = ACTIONS(2248),
    [anon_sym_R_DQUOTE] = ACTIONS(2250),
    [anon_sym_LR_DQUOTE] = ACTIONS(2250),
    [anon_sym_uR_DQUOTE] = ACTIONS(2250),
    [anon_sym_UR_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2250),
    [anon_sym_co_await] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2248),
    [anon_sym_requires] = ACTIONS(2248),
    [sym_this] = ACTIONS(2248),
    [anon_sym_discard] = ACTIONS(2248),
    [anon_sym_precise] = ACTIONS(2248),
    [anon_sym_shared] = ACTIONS(2248),
    [anon_sym_groupshared] = ACTIONS(2248),
    [anon_sym_uniform] = ACTIONS(2248),
    [anon_sym_row_major] = ACTIONS(2248),
    [anon_sym_column_major] = ACTIONS(2248),
    [anon_sym_globallycoherent] = ACTIONS(2248),
    [anon_sym_centroid] = ACTIONS(2248),
    [anon_sym_noperspective] = ACTIONS(2248),
    [anon_sym_nointerpolation] = ACTIONS(2248),
    [anon_sym_sample] = ACTIONS(2248),
    [anon_sym_linear] = ACTIONS(2248),
    [anon_sym_snorm] = ACTIONS(2248),
    [anon_sym_unorm] = ACTIONS(2248),
    [anon_sym_point] = ACTIONS(2248),
    [anon_sym_line] = ACTIONS(2248),
    [anon_sym_triangleadj] = ACTIONS(2248),
    [anon_sym_lineadj] = ACTIONS(2248),
    [anon_sym_triangle] = ACTIONS(2248),
    [anon_sym_cbuffer] = ACTIONS(2248),
    [anon_sym_interface] = ACTIONS(2248),
    [anon_sym_extension] = ACTIONS(2248),
  },
  [500] = {
    [sym_identifier] = ACTIONS(3605),
    [aux_sym_preproc_include_token1] = ACTIONS(3605),
    [aux_sym_preproc_def_token1] = ACTIONS(3605),
    [aux_sym_preproc_if_token1] = ACTIONS(3605),
    [aux_sym_preproc_if_token2] = ACTIONS(3605),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3605),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3605),
    [aux_sym_preproc_else_token1] = ACTIONS(3605),
    [aux_sym_preproc_elif_token1] = ACTIONS(3605),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3605),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3605),
    [sym_preproc_directive] = ACTIONS(3605),
    [anon_sym_LPAREN2] = ACTIONS(3607),
    [anon_sym_BANG] = ACTIONS(3607),
    [anon_sym_TILDE] = ACTIONS(3607),
    [anon_sym_DASH] = ACTIONS(3605),
    [anon_sym_PLUS] = ACTIONS(3605),
    [anon_sym_STAR] = ACTIONS(3607),
    [anon_sym_AMP_AMP] = ACTIONS(3607),
    [anon_sym_AMP] = ACTIONS(3605),
    [anon_sym_SEMI] = ACTIONS(3607),
    [anon_sym___extension__] = ACTIONS(3605),
    [anon_sym_typedef] = ACTIONS(3605),
    [anon_sym_in] = ACTIONS(3605),
    [anon_sym_out] = ACTIONS(3605),
    [anon_sym_inout] = ACTIONS(3605),
    [anon_sym_extern] = ACTIONS(3605),
    [anon_sym___attribute__] = ACTIONS(3605),
    [anon_sym_COLON_COLON] = ACTIONS(3607),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3607),
    [anon_sym___declspec] = ACTIONS(3605),
    [anon_sym___based] = ACTIONS(3605),
    [anon_sym___cdecl] = ACTIONS(3605),
    [anon_sym___clrcall] = ACTIONS(3605),
    [anon_sym___stdcall] = ACTIONS(3605),
    [anon_sym___fastcall] = ACTIONS(3605),
    [anon_sym___thiscall] = ACTIONS(3605),
    [anon_sym___vectorcall] = ACTIONS(3605),
    [anon_sym_LBRACE] = ACTIONS(3607),
    [anon_sym_signed] = ACTIONS(3605),
    [anon_sym_unsigned] = ACTIONS(3605),
    [anon_sym_long] = ACTIONS(3605),
    [anon_sym_short] = ACTIONS(3605),
    [anon_sym_LBRACK] = ACTIONS(3605),
    [anon_sym_static] = ACTIONS(3605),
    [anon_sym_register] = ACTIONS(3605),
    [anon_sym_inline] = ACTIONS(3605),
    [anon_sym___inline] = ACTIONS(3605),
    [anon_sym___inline__] = ACTIONS(3605),
    [anon_sym___forceinline] = ACTIONS(3605),
    [anon_sym_thread_local] = ACTIONS(3605),
    [anon_sym___thread] = ACTIONS(3605),
    [anon_sym_const] = ACTIONS(3605),
    [anon_sym_constexpr] = ACTIONS(3605),
    [anon_sym_volatile] = ACTIONS(3605),
    [anon_sym_restrict] = ACTIONS(3605),
    [anon_sym___restrict__] = ACTIONS(3605),
    [anon_sym__Atomic] = ACTIONS(3605),
    [anon_sym__Noreturn] = ACTIONS(3605),
    [anon_sym_noreturn] = ACTIONS(3605),
    [anon_sym_mutable] = ACTIONS(3605),
    [anon_sym_constinit] = ACTIONS(3605),
    [anon_sym_consteval] = ACTIONS(3605),
    [anon_sym_alignas] = ACTIONS(3605),
    [anon_sym__Alignas] = ACTIONS(3605),
    [sym_primitive_type] = ACTIONS(3605),
    [anon_sym_enum] = ACTIONS(3605),
    [anon_sym_class] = ACTIONS(3605),
    [anon_sym_struct] = ACTIONS(3605),
    [anon_sym_union] = ACTIONS(3605),
    [anon_sym_if] = ACTIONS(3605),
    [anon_sym_switch] = ACTIONS(3605),
    [anon_sym_case] = ACTIONS(3605),
    [anon_sym_default] = ACTIONS(3605),
    [anon_sym_while] = ACTIONS(3605),
    [anon_sym_do] = ACTIONS(3605),
    [anon_sym_for] = ACTIONS(3605),
    [anon_sym_return] = ACTIONS(3605),
    [anon_sym_break] = ACTIONS(3605),
    [anon_sym_continue] = ACTIONS(3605),
    [anon_sym_goto] = ACTIONS(3605),
    [anon_sym___try] = ACTIONS(3605),
    [anon_sym___leave] = ACTIONS(3605),
    [anon_sym_not] = ACTIONS(3605),
    [anon_sym_compl] = ACTIONS(3605),
    [anon_sym_DASH_DASH] = ACTIONS(3607),
    [anon_sym_PLUS_PLUS] = ACTIONS(3607),
    [anon_sym_sizeof] = ACTIONS(3605),
    [anon_sym___alignof__] = ACTIONS(3605),
    [anon_sym___alignof] = ACTIONS(3605),
    [anon_sym__alignof] = ACTIONS(3605),
    [anon_sym_alignof] = ACTIONS(3605),
    [anon_sym__Alignof] = ACTIONS(3605),
    [anon_sym_offsetof] = ACTIONS(3605),
    [anon_sym__Generic] = ACTIONS(3605),
    [anon_sym_asm] = ACTIONS(3605),
    [anon_sym___asm__] = ACTIONS(3605),
    [sym_number_literal] = ACTIONS(3607),
    [anon_sym_L_SQUOTE] = ACTIONS(3607),
    [anon_sym_u_SQUOTE] = ACTIONS(3607),
    [anon_sym_U_SQUOTE] = ACTIONS(3607),
    [anon_sym_u8_SQUOTE] = ACTIONS(3607),
    [anon_sym_SQUOTE] = ACTIONS(3607),
    [anon_sym_L_DQUOTE] = ACTIONS(3607),
    [anon_sym_u_DQUOTE] = ACTIONS(3607),
    [anon_sym_U_DQUOTE] = ACTIONS(3607),
    [anon_sym_u8_DQUOTE] = ACTIONS(3607),
    [anon_sym_DQUOTE] = ACTIONS(3607),
    [sym_true] = ACTIONS(3605),
    [sym_false] = ACTIONS(3605),
    [anon_sym_NULL] = ACTIONS(3605),
    [anon_sym_nullptr] = ACTIONS(3605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3605),
    [anon_sym_let] = ACTIONS(3605),
    [anon_sym_This] = ACTIONS(3605),
    [anon_sym_decltype] = ACTIONS(3605),
    [sym_virtual] = ACTIONS(3605),
    [anon_sym_explicit] = ACTIONS(3605),
    [anon_sym_typename] = ACTIONS(3605),
    [anon_sym_template] = ACTIONS(3605),
    [anon_sym_operator] = ACTIONS(3605),
    [anon_sym_try] = ACTIONS(3605),
    [anon_sym_delete] = ACTIONS(3605),
    [anon_sym_throw] = ACTIONS(3605),
    [anon_sym_namespace] = ACTIONS(3605),
    [anon_sym_using] = ACTIONS(3605),
    [anon_sym_static_assert] = ACTIONS(3605),
    [anon_sym_concept] = ACTIONS(3605),
    [anon_sym_co_return] = ACTIONS(3605),
    [anon_sym_co_yield] = ACTIONS(3605),
    [anon_sym_R_DQUOTE] = ACTIONS(3607),
    [anon_sym_LR_DQUOTE] = ACTIONS(3607),
    [anon_sym_uR_DQUOTE] = ACTIONS(3607),
    [anon_sym_UR_DQUOTE] = ACTIONS(3607),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3607),
    [anon_sym_co_await] = ACTIONS(3605),
    [anon_sym_new] = ACTIONS(3605),
    [anon_sym_requires] = ACTIONS(3605),
    [sym_this] = ACTIONS(3605),
    [anon_sym_discard] = ACTIONS(3605),
    [anon_sym_precise] = ACTIONS(3605),
    [anon_sym_shared] = ACTIONS(3605),
    [anon_sym_groupshared] = ACTIONS(3605),
    [anon_sym_uniform] = ACTIONS(3605),
    [anon_sym_row_major] = ACTIONS(3605),
    [anon_sym_column_major] = ACTIONS(3605),
    [anon_sym_globallycoherent] = ACTIONS(3605),
    [anon_sym_centroid] = ACTIONS(3605),
    [anon_sym_noperspective] = ACTIONS(3605),
    [anon_sym_nointerpolation] = ACTIONS(3605),
    [anon_sym_sample] = ACTIONS(3605),
    [anon_sym_linear] = ACTIONS(3605),
    [anon_sym_snorm] = ACTIONS(3605),
    [anon_sym_unorm] = ACTIONS(3605),
    [anon_sym_point] = ACTIONS(3605),
    [anon_sym_line] = ACTIONS(3605),
    [anon_sym_triangleadj] = ACTIONS(3605),
    [anon_sym_lineadj] = ACTIONS(3605),
    [anon_sym_triangle] = ACTIONS(3605),
    [anon_sym_cbuffer] = ACTIONS(3605),
    [anon_sym_interface] = ACTIONS(3605),
    [anon_sym_extension] = ACTIONS(3605),
  },
  [501] = {
    [sym_identifier] = ACTIONS(3609),
    [aux_sym_preproc_include_token1] = ACTIONS(3609),
    [aux_sym_preproc_def_token1] = ACTIONS(3609),
    [aux_sym_preproc_if_token1] = ACTIONS(3609),
    [aux_sym_preproc_if_token2] = ACTIONS(3609),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3609),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3609),
    [aux_sym_preproc_else_token1] = ACTIONS(3609),
    [aux_sym_preproc_elif_token1] = ACTIONS(3609),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3609),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3609),
    [sym_preproc_directive] = ACTIONS(3609),
    [anon_sym_LPAREN2] = ACTIONS(3611),
    [anon_sym_BANG] = ACTIONS(3611),
    [anon_sym_TILDE] = ACTIONS(3611),
    [anon_sym_DASH] = ACTIONS(3609),
    [anon_sym_PLUS] = ACTIONS(3609),
    [anon_sym_STAR] = ACTIONS(3611),
    [anon_sym_AMP_AMP] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3609),
    [anon_sym_SEMI] = ACTIONS(3611),
    [anon_sym___extension__] = ACTIONS(3609),
    [anon_sym_typedef] = ACTIONS(3609),
    [anon_sym_in] = ACTIONS(3609),
    [anon_sym_out] = ACTIONS(3609),
    [anon_sym_inout] = ACTIONS(3609),
    [anon_sym_extern] = ACTIONS(3609),
    [anon_sym___attribute__] = ACTIONS(3609),
    [anon_sym_COLON_COLON] = ACTIONS(3611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3611),
    [anon_sym___declspec] = ACTIONS(3609),
    [anon_sym___based] = ACTIONS(3609),
    [anon_sym___cdecl] = ACTIONS(3609),
    [anon_sym___clrcall] = ACTIONS(3609),
    [anon_sym___stdcall] = ACTIONS(3609),
    [anon_sym___fastcall] = ACTIONS(3609),
    [anon_sym___thiscall] = ACTIONS(3609),
    [anon_sym___vectorcall] = ACTIONS(3609),
    [anon_sym_LBRACE] = ACTIONS(3611),
    [anon_sym_signed] = ACTIONS(3609),
    [anon_sym_unsigned] = ACTIONS(3609),
    [anon_sym_long] = ACTIONS(3609),
    [anon_sym_short] = ACTIONS(3609),
    [anon_sym_LBRACK] = ACTIONS(3609),
    [anon_sym_static] = ACTIONS(3609),
    [anon_sym_register] = ACTIONS(3609),
    [anon_sym_inline] = ACTIONS(3609),
    [anon_sym___inline] = ACTIONS(3609),
    [anon_sym___inline__] = ACTIONS(3609),
    [anon_sym___forceinline] = ACTIONS(3609),
    [anon_sym_thread_local] = ACTIONS(3609),
    [anon_sym___thread] = ACTIONS(3609),
    [anon_sym_const] = ACTIONS(3609),
    [anon_sym_constexpr] = ACTIONS(3609),
    [anon_sym_volatile] = ACTIONS(3609),
    [anon_sym_restrict] = ACTIONS(3609),
    [anon_sym___restrict__] = ACTIONS(3609),
    [anon_sym__Atomic] = ACTIONS(3609),
    [anon_sym__Noreturn] = ACTIONS(3609),
    [anon_sym_noreturn] = ACTIONS(3609),
    [anon_sym_mutable] = ACTIONS(3609),
    [anon_sym_constinit] = ACTIONS(3609),
    [anon_sym_consteval] = ACTIONS(3609),
    [anon_sym_alignas] = ACTIONS(3609),
    [anon_sym__Alignas] = ACTIONS(3609),
    [sym_primitive_type] = ACTIONS(3609),
    [anon_sym_enum] = ACTIONS(3609),
    [anon_sym_class] = ACTIONS(3609),
    [anon_sym_struct] = ACTIONS(3609),
    [anon_sym_union] = ACTIONS(3609),
    [anon_sym_if] = ACTIONS(3609),
    [anon_sym_switch] = ACTIONS(3609),
    [anon_sym_case] = ACTIONS(3609),
    [anon_sym_default] = ACTIONS(3609),
    [anon_sym_while] = ACTIONS(3609),
    [anon_sym_do] = ACTIONS(3609),
    [anon_sym_for] = ACTIONS(3609),
    [anon_sym_return] = ACTIONS(3609),
    [anon_sym_break] = ACTIONS(3609),
    [anon_sym_continue] = ACTIONS(3609),
    [anon_sym_goto] = ACTIONS(3609),
    [anon_sym___try] = ACTIONS(3609),
    [anon_sym___leave] = ACTIONS(3609),
    [anon_sym_not] = ACTIONS(3609),
    [anon_sym_compl] = ACTIONS(3609),
    [anon_sym_DASH_DASH] = ACTIONS(3611),
    [anon_sym_PLUS_PLUS] = ACTIONS(3611),
    [anon_sym_sizeof] = ACTIONS(3609),
    [anon_sym___alignof__] = ACTIONS(3609),
    [anon_sym___alignof] = ACTIONS(3609),
    [anon_sym__alignof] = ACTIONS(3609),
    [anon_sym_alignof] = ACTIONS(3609),
    [anon_sym__Alignof] = ACTIONS(3609),
    [anon_sym_offsetof] = ACTIONS(3609),
    [anon_sym__Generic] = ACTIONS(3609),
    [anon_sym_asm] = ACTIONS(3609),
    [anon_sym___asm__] = ACTIONS(3609),
    [sym_number_literal] = ACTIONS(3611),
    [anon_sym_L_SQUOTE] = ACTIONS(3611),
    [anon_sym_u_SQUOTE] = ACTIONS(3611),
    [anon_sym_U_SQUOTE] = ACTIONS(3611),
    [anon_sym_u8_SQUOTE] = ACTIONS(3611),
    [anon_sym_SQUOTE] = ACTIONS(3611),
    [anon_sym_L_DQUOTE] = ACTIONS(3611),
    [anon_sym_u_DQUOTE] = ACTIONS(3611),
    [anon_sym_U_DQUOTE] = ACTIONS(3611),
    [anon_sym_u8_DQUOTE] = ACTIONS(3611),
    [anon_sym_DQUOTE] = ACTIONS(3611),
    [sym_true] = ACTIONS(3609),
    [sym_false] = ACTIONS(3609),
    [anon_sym_NULL] = ACTIONS(3609),
    [anon_sym_nullptr] = ACTIONS(3609),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3609),
    [anon_sym_let] = ACTIONS(3609),
    [anon_sym_This] = ACTIONS(3609),
    [anon_sym_decltype] = ACTIONS(3609),
    [sym_virtual] = ACTIONS(3609),
    [anon_sym_explicit] = ACTIONS(3609),
    [anon_sym_typename] = ACTIONS(3609),
    [anon_sym_template] = ACTIONS(3609),
    [anon_sym_operator] = ACTIONS(3609),
    [anon_sym_try] = ACTIONS(3609),
    [anon_sym_delete] = ACTIONS(3609),
    [anon_sym_throw] = ACTIONS(3609),
    [anon_sym_namespace] = ACTIONS(3609),
    [anon_sym_using] = ACTIONS(3609),
    [anon_sym_static_assert] = ACTIONS(3609),
    [anon_sym_concept] = ACTIONS(3609),
    [anon_sym_co_return] = ACTIONS(3609),
    [anon_sym_co_yield] = ACTIONS(3609),
    [anon_sym_R_DQUOTE] = ACTIONS(3611),
    [anon_sym_LR_DQUOTE] = ACTIONS(3611),
    [anon_sym_uR_DQUOTE] = ACTIONS(3611),
    [anon_sym_UR_DQUOTE] = ACTIONS(3611),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3611),
    [anon_sym_co_await] = ACTIONS(3609),
    [anon_sym_new] = ACTIONS(3609),
    [anon_sym_requires] = ACTIONS(3609),
    [sym_this] = ACTIONS(3609),
    [anon_sym_discard] = ACTIONS(3609),
    [anon_sym_precise] = ACTIONS(3609),
    [anon_sym_shared] = ACTIONS(3609),
    [anon_sym_groupshared] = ACTIONS(3609),
    [anon_sym_uniform] = ACTIONS(3609),
    [anon_sym_row_major] = ACTIONS(3609),
    [anon_sym_column_major] = ACTIONS(3609),
    [anon_sym_globallycoherent] = ACTIONS(3609),
    [anon_sym_centroid] = ACTIONS(3609),
    [anon_sym_noperspective] = ACTIONS(3609),
    [anon_sym_nointerpolation] = ACTIONS(3609),
    [anon_sym_sample] = ACTIONS(3609),
    [anon_sym_linear] = ACTIONS(3609),
    [anon_sym_snorm] = ACTIONS(3609),
    [anon_sym_unorm] = ACTIONS(3609),
    [anon_sym_point] = ACTIONS(3609),
    [anon_sym_line] = ACTIONS(3609),
    [anon_sym_triangleadj] = ACTIONS(3609),
    [anon_sym_lineadj] = ACTIONS(3609),
    [anon_sym_triangle] = ACTIONS(3609),
    [anon_sym_cbuffer] = ACTIONS(3609),
    [anon_sym_interface] = ACTIONS(3609),
    [anon_sym_extension] = ACTIONS(3609),
  },
  [502] = {
    [sym_identifier] = ACTIONS(3613),
    [aux_sym_preproc_include_token1] = ACTIONS(3613),
    [aux_sym_preproc_def_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token2] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3613),
    [aux_sym_preproc_else_token1] = ACTIONS(3613),
    [aux_sym_preproc_elif_token1] = ACTIONS(3613),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3613),
    [sym_preproc_directive] = ACTIONS(3613),
    [anon_sym_LPAREN2] = ACTIONS(3615),
    [anon_sym_BANG] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3613),
    [anon_sym_PLUS] = ACTIONS(3613),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym_SEMI] = ACTIONS(3615),
    [anon_sym___extension__] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3613),
    [anon_sym_in] = ACTIONS(3613),
    [anon_sym_out] = ACTIONS(3613),
    [anon_sym_inout] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym___attribute__] = ACTIONS(3613),
    [anon_sym_COLON_COLON] = ACTIONS(3615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3615),
    [anon_sym___declspec] = ACTIONS(3613),
    [anon_sym___based] = ACTIONS(3613),
    [anon_sym___cdecl] = ACTIONS(3613),
    [anon_sym___clrcall] = ACTIONS(3613),
    [anon_sym___stdcall] = ACTIONS(3613),
    [anon_sym___fastcall] = ACTIONS(3613),
    [anon_sym___thiscall] = ACTIONS(3613),
    [anon_sym___vectorcall] = ACTIONS(3613),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_signed] = ACTIONS(3613),
    [anon_sym_unsigned] = ACTIONS(3613),
    [anon_sym_long] = ACTIONS(3613),
    [anon_sym_short] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_register] = ACTIONS(3613),
    [anon_sym_inline] = ACTIONS(3613),
    [anon_sym___inline] = ACTIONS(3613),
    [anon_sym___inline__] = ACTIONS(3613),
    [anon_sym___forceinline] = ACTIONS(3613),
    [anon_sym_thread_local] = ACTIONS(3613),
    [anon_sym___thread] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_constexpr] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_restrict] = ACTIONS(3613),
    [anon_sym___restrict__] = ACTIONS(3613),
    [anon_sym__Atomic] = ACTIONS(3613),
    [anon_sym__Noreturn] = ACTIONS(3613),
    [anon_sym_noreturn] = ACTIONS(3613),
    [anon_sym_mutable] = ACTIONS(3613),
    [anon_sym_constinit] = ACTIONS(3613),
    [anon_sym_consteval] = ACTIONS(3613),
    [anon_sym_alignas] = ACTIONS(3613),
    [anon_sym__Alignas] = ACTIONS(3613),
    [sym_primitive_type] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_union] = ACTIONS(3613),
    [anon_sym_if] = ACTIONS(3613),
    [anon_sym_switch] = ACTIONS(3613),
    [anon_sym_case] = ACTIONS(3613),
    [anon_sym_default] = ACTIONS(3613),
    [anon_sym_while] = ACTIONS(3613),
    [anon_sym_do] = ACTIONS(3613),
    [anon_sym_for] = ACTIONS(3613),
    [anon_sym_return] = ACTIONS(3613),
    [anon_sym_break] = ACTIONS(3613),
    [anon_sym_continue] = ACTIONS(3613),
    [anon_sym_goto] = ACTIONS(3613),
    [anon_sym___try] = ACTIONS(3613),
    [anon_sym___leave] = ACTIONS(3613),
    [anon_sym_not] = ACTIONS(3613),
    [anon_sym_compl] = ACTIONS(3613),
    [anon_sym_DASH_DASH] = ACTIONS(3615),
    [anon_sym_PLUS_PLUS] = ACTIONS(3615),
    [anon_sym_sizeof] = ACTIONS(3613),
    [anon_sym___alignof__] = ACTIONS(3613),
    [anon_sym___alignof] = ACTIONS(3613),
    [anon_sym__alignof] = ACTIONS(3613),
    [anon_sym_alignof] = ACTIONS(3613),
    [anon_sym__Alignof] = ACTIONS(3613),
    [anon_sym_offsetof] = ACTIONS(3613),
    [anon_sym__Generic] = ACTIONS(3613),
    [anon_sym_asm] = ACTIONS(3613),
    [anon_sym___asm__] = ACTIONS(3613),
    [sym_number_literal] = ACTIONS(3615),
    [anon_sym_L_SQUOTE] = ACTIONS(3615),
    [anon_sym_u_SQUOTE] = ACTIONS(3615),
    [anon_sym_U_SQUOTE] = ACTIONS(3615),
    [anon_sym_u8_SQUOTE] = ACTIONS(3615),
    [anon_sym_SQUOTE] = ACTIONS(3615),
    [anon_sym_L_DQUOTE] = ACTIONS(3615),
    [anon_sym_u_DQUOTE] = ACTIONS(3615),
    [anon_sym_U_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8_DQUOTE] = ACTIONS(3615),
    [anon_sym_DQUOTE] = ACTIONS(3615),
    [sym_true] = ACTIONS(3613),
    [sym_false] = ACTIONS(3613),
    [anon_sym_NULL] = ACTIONS(3613),
    [anon_sym_nullptr] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_This] = ACTIONS(3613),
    [anon_sym_decltype] = ACTIONS(3613),
    [sym_virtual] = ACTIONS(3613),
    [anon_sym_explicit] = ACTIONS(3613),
    [anon_sym_typename] = ACTIONS(3613),
    [anon_sym_template] = ACTIONS(3613),
    [anon_sym_operator] = ACTIONS(3613),
    [anon_sym_try] = ACTIONS(3613),
    [anon_sym_delete] = ACTIONS(3613),
    [anon_sym_throw] = ACTIONS(3613),
    [anon_sym_namespace] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_static_assert] = ACTIONS(3613),
    [anon_sym_concept] = ACTIONS(3613),
    [anon_sym_co_return] = ACTIONS(3613),
    [anon_sym_co_yield] = ACTIONS(3613),
    [anon_sym_R_DQUOTE] = ACTIONS(3615),
    [anon_sym_LR_DQUOTE] = ACTIONS(3615),
    [anon_sym_uR_DQUOTE] = ACTIONS(3615),
    [anon_sym_UR_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3615),
    [anon_sym_co_await] = ACTIONS(3613),
    [anon_sym_new] = ACTIONS(3613),
    [anon_sym_requires] = ACTIONS(3613),
    [sym_this] = ACTIONS(3613),
    [anon_sym_discard] = ACTIONS(3613),
    [anon_sym_precise] = ACTIONS(3613),
    [anon_sym_shared] = ACTIONS(3613),
    [anon_sym_groupshared] = ACTIONS(3613),
    [anon_sym_uniform] = ACTIONS(3613),
    [anon_sym_row_major] = ACTIONS(3613),
    [anon_sym_column_major] = ACTIONS(3613),
    [anon_sym_globallycoherent] = ACTIONS(3613),
    [anon_sym_centroid] = ACTIONS(3613),
    [anon_sym_noperspective] = ACTIONS(3613),
    [anon_sym_nointerpolation] = ACTIONS(3613),
    [anon_sym_sample] = ACTIONS(3613),
    [anon_sym_linear] = ACTIONS(3613),
    [anon_sym_snorm] = ACTIONS(3613),
    [anon_sym_unorm] = ACTIONS(3613),
    [anon_sym_point] = ACTIONS(3613),
    [anon_sym_line] = ACTIONS(3613),
    [anon_sym_triangleadj] = ACTIONS(3613),
    [anon_sym_lineadj] = ACTIONS(3613),
    [anon_sym_triangle] = ACTIONS(3613),
    [anon_sym_cbuffer] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_extension] = ACTIONS(3613),
  },
  [503] = {
    [sym_identifier] = ACTIONS(3613),
    [aux_sym_preproc_include_token1] = ACTIONS(3613),
    [aux_sym_preproc_def_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token2] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3613),
    [aux_sym_preproc_else_token1] = ACTIONS(3613),
    [aux_sym_preproc_elif_token1] = ACTIONS(3613),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3613),
    [sym_preproc_directive] = ACTIONS(3613),
    [anon_sym_LPAREN2] = ACTIONS(3615),
    [anon_sym_BANG] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3613),
    [anon_sym_PLUS] = ACTIONS(3613),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym_SEMI] = ACTIONS(3615),
    [anon_sym___extension__] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3613),
    [anon_sym_in] = ACTIONS(3613),
    [anon_sym_out] = ACTIONS(3613),
    [anon_sym_inout] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym___attribute__] = ACTIONS(3613),
    [anon_sym_COLON_COLON] = ACTIONS(3615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3615),
    [anon_sym___declspec] = ACTIONS(3613),
    [anon_sym___based] = ACTIONS(3613),
    [anon_sym___cdecl] = ACTIONS(3613),
    [anon_sym___clrcall] = ACTIONS(3613),
    [anon_sym___stdcall] = ACTIONS(3613),
    [anon_sym___fastcall] = ACTIONS(3613),
    [anon_sym___thiscall] = ACTIONS(3613),
    [anon_sym___vectorcall] = ACTIONS(3613),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_signed] = ACTIONS(3613),
    [anon_sym_unsigned] = ACTIONS(3613),
    [anon_sym_long] = ACTIONS(3613),
    [anon_sym_short] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_register] = ACTIONS(3613),
    [anon_sym_inline] = ACTIONS(3613),
    [anon_sym___inline] = ACTIONS(3613),
    [anon_sym___inline__] = ACTIONS(3613),
    [anon_sym___forceinline] = ACTIONS(3613),
    [anon_sym_thread_local] = ACTIONS(3613),
    [anon_sym___thread] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_constexpr] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_restrict] = ACTIONS(3613),
    [anon_sym___restrict__] = ACTIONS(3613),
    [anon_sym__Atomic] = ACTIONS(3613),
    [anon_sym__Noreturn] = ACTIONS(3613),
    [anon_sym_noreturn] = ACTIONS(3613),
    [anon_sym_mutable] = ACTIONS(3613),
    [anon_sym_constinit] = ACTIONS(3613),
    [anon_sym_consteval] = ACTIONS(3613),
    [anon_sym_alignas] = ACTIONS(3613),
    [anon_sym__Alignas] = ACTIONS(3613),
    [sym_primitive_type] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_union] = ACTIONS(3613),
    [anon_sym_if] = ACTIONS(3613),
    [anon_sym_switch] = ACTIONS(3613),
    [anon_sym_case] = ACTIONS(3613),
    [anon_sym_default] = ACTIONS(3613),
    [anon_sym_while] = ACTIONS(3613),
    [anon_sym_do] = ACTIONS(3613),
    [anon_sym_for] = ACTIONS(3613),
    [anon_sym_return] = ACTIONS(3613),
    [anon_sym_break] = ACTIONS(3613),
    [anon_sym_continue] = ACTIONS(3613),
    [anon_sym_goto] = ACTIONS(3613),
    [anon_sym___try] = ACTIONS(3613),
    [anon_sym___leave] = ACTIONS(3613),
    [anon_sym_not] = ACTIONS(3613),
    [anon_sym_compl] = ACTIONS(3613),
    [anon_sym_DASH_DASH] = ACTIONS(3615),
    [anon_sym_PLUS_PLUS] = ACTIONS(3615),
    [anon_sym_sizeof] = ACTIONS(3613),
    [anon_sym___alignof__] = ACTIONS(3613),
    [anon_sym___alignof] = ACTIONS(3613),
    [anon_sym__alignof] = ACTIONS(3613),
    [anon_sym_alignof] = ACTIONS(3613),
    [anon_sym__Alignof] = ACTIONS(3613),
    [anon_sym_offsetof] = ACTIONS(3613),
    [anon_sym__Generic] = ACTIONS(3613),
    [anon_sym_asm] = ACTIONS(3613),
    [anon_sym___asm__] = ACTIONS(3613),
    [sym_number_literal] = ACTIONS(3615),
    [anon_sym_L_SQUOTE] = ACTIONS(3615),
    [anon_sym_u_SQUOTE] = ACTIONS(3615),
    [anon_sym_U_SQUOTE] = ACTIONS(3615),
    [anon_sym_u8_SQUOTE] = ACTIONS(3615),
    [anon_sym_SQUOTE] = ACTIONS(3615),
    [anon_sym_L_DQUOTE] = ACTIONS(3615),
    [anon_sym_u_DQUOTE] = ACTIONS(3615),
    [anon_sym_U_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8_DQUOTE] = ACTIONS(3615),
    [anon_sym_DQUOTE] = ACTIONS(3615),
    [sym_true] = ACTIONS(3613),
    [sym_false] = ACTIONS(3613),
    [anon_sym_NULL] = ACTIONS(3613),
    [anon_sym_nullptr] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_This] = ACTIONS(3613),
    [anon_sym_decltype] = ACTIONS(3613),
    [sym_virtual] = ACTIONS(3613),
    [anon_sym_explicit] = ACTIONS(3613),
    [anon_sym_typename] = ACTIONS(3613),
    [anon_sym_template] = ACTIONS(3613),
    [anon_sym_operator] = ACTIONS(3613),
    [anon_sym_try] = ACTIONS(3613),
    [anon_sym_delete] = ACTIONS(3613),
    [anon_sym_throw] = ACTIONS(3613),
    [anon_sym_namespace] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_static_assert] = ACTIONS(3613),
    [anon_sym_concept] = ACTIONS(3613),
    [anon_sym_co_return] = ACTIONS(3613),
    [anon_sym_co_yield] = ACTIONS(3613),
    [anon_sym_R_DQUOTE] = ACTIONS(3615),
    [anon_sym_LR_DQUOTE] = ACTIONS(3615),
    [anon_sym_uR_DQUOTE] = ACTIONS(3615),
    [anon_sym_UR_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3615),
    [anon_sym_co_await] = ACTIONS(3613),
    [anon_sym_new] = ACTIONS(3613),
    [anon_sym_requires] = ACTIONS(3613),
    [sym_this] = ACTIONS(3613),
    [anon_sym_discard] = ACTIONS(3613),
    [anon_sym_precise] = ACTIONS(3613),
    [anon_sym_shared] = ACTIONS(3613),
    [anon_sym_groupshared] = ACTIONS(3613),
    [anon_sym_uniform] = ACTIONS(3613),
    [anon_sym_row_major] = ACTIONS(3613),
    [anon_sym_column_major] = ACTIONS(3613),
    [anon_sym_globallycoherent] = ACTIONS(3613),
    [anon_sym_centroid] = ACTIONS(3613),
    [anon_sym_noperspective] = ACTIONS(3613),
    [anon_sym_nointerpolation] = ACTIONS(3613),
    [anon_sym_sample] = ACTIONS(3613),
    [anon_sym_linear] = ACTIONS(3613),
    [anon_sym_snorm] = ACTIONS(3613),
    [anon_sym_unorm] = ACTIONS(3613),
    [anon_sym_point] = ACTIONS(3613),
    [anon_sym_line] = ACTIONS(3613),
    [anon_sym_triangleadj] = ACTIONS(3613),
    [anon_sym_lineadj] = ACTIONS(3613),
    [anon_sym_triangle] = ACTIONS(3613),
    [anon_sym_cbuffer] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_extension] = ACTIONS(3613),
  },
  [504] = {
    [sym_identifier] = ACTIONS(3617),
    [aux_sym_preproc_include_token1] = ACTIONS(3617),
    [aux_sym_preproc_def_token1] = ACTIONS(3617),
    [aux_sym_preproc_if_token1] = ACTIONS(3617),
    [aux_sym_preproc_if_token2] = ACTIONS(3617),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3617),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3617),
    [aux_sym_preproc_else_token1] = ACTIONS(3617),
    [aux_sym_preproc_elif_token1] = ACTIONS(3617),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3617),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3617),
    [sym_preproc_directive] = ACTIONS(3617),
    [anon_sym_LPAREN2] = ACTIONS(3619),
    [anon_sym_BANG] = ACTIONS(3619),
    [anon_sym_TILDE] = ACTIONS(3619),
    [anon_sym_DASH] = ACTIONS(3617),
    [anon_sym_PLUS] = ACTIONS(3617),
    [anon_sym_STAR] = ACTIONS(3619),
    [anon_sym_AMP_AMP] = ACTIONS(3619),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym_SEMI] = ACTIONS(3619),
    [anon_sym___extension__] = ACTIONS(3617),
    [anon_sym_typedef] = ACTIONS(3617),
    [anon_sym_in] = ACTIONS(3617),
    [anon_sym_out] = ACTIONS(3617),
    [anon_sym_inout] = ACTIONS(3617),
    [anon_sym_extern] = ACTIONS(3617),
    [anon_sym___attribute__] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3619),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3619),
    [anon_sym___declspec] = ACTIONS(3617),
    [anon_sym___based] = ACTIONS(3617),
    [anon_sym___cdecl] = ACTIONS(3617),
    [anon_sym___clrcall] = ACTIONS(3617),
    [anon_sym___stdcall] = ACTIONS(3617),
    [anon_sym___fastcall] = ACTIONS(3617),
    [anon_sym___thiscall] = ACTIONS(3617),
    [anon_sym___vectorcall] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3619),
    [anon_sym_signed] = ACTIONS(3617),
    [anon_sym_unsigned] = ACTIONS(3617),
    [anon_sym_long] = ACTIONS(3617),
    [anon_sym_short] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_static] = ACTIONS(3617),
    [anon_sym_register] = ACTIONS(3617),
    [anon_sym_inline] = ACTIONS(3617),
    [anon_sym___inline] = ACTIONS(3617),
    [anon_sym___inline__] = ACTIONS(3617),
    [anon_sym___forceinline] = ACTIONS(3617),
    [anon_sym_thread_local] = ACTIONS(3617),
    [anon_sym___thread] = ACTIONS(3617),
    [anon_sym_const] = ACTIONS(3617),
    [anon_sym_constexpr] = ACTIONS(3617),
    [anon_sym_volatile] = ACTIONS(3617),
    [anon_sym_restrict] = ACTIONS(3617),
    [anon_sym___restrict__] = ACTIONS(3617),
    [anon_sym__Atomic] = ACTIONS(3617),
    [anon_sym__Noreturn] = ACTIONS(3617),
    [anon_sym_noreturn] = ACTIONS(3617),
    [anon_sym_mutable] = ACTIONS(3617),
    [anon_sym_constinit] = ACTIONS(3617),
    [anon_sym_consteval] = ACTIONS(3617),
    [anon_sym_alignas] = ACTIONS(3617),
    [anon_sym__Alignas] = ACTIONS(3617),
    [sym_primitive_type] = ACTIONS(3617),
    [anon_sym_enum] = ACTIONS(3617),
    [anon_sym_class] = ACTIONS(3617),
    [anon_sym_struct] = ACTIONS(3617),
    [anon_sym_union] = ACTIONS(3617),
    [anon_sym_if] = ACTIONS(3617),
    [anon_sym_switch] = ACTIONS(3617),
    [anon_sym_case] = ACTIONS(3617),
    [anon_sym_default] = ACTIONS(3617),
    [anon_sym_while] = ACTIONS(3617),
    [anon_sym_do] = ACTIONS(3617),
    [anon_sym_for] = ACTIONS(3617),
    [anon_sym_return] = ACTIONS(3617),
    [anon_sym_break] = ACTIONS(3617),
    [anon_sym_continue] = ACTIONS(3617),
    [anon_sym_goto] = ACTIONS(3617),
    [anon_sym___try] = ACTIONS(3617),
    [anon_sym___leave] = ACTIONS(3617),
    [anon_sym_not] = ACTIONS(3617),
    [anon_sym_compl] = ACTIONS(3617),
    [anon_sym_DASH_DASH] = ACTIONS(3619),
    [anon_sym_PLUS_PLUS] = ACTIONS(3619),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(3617),
    [anon_sym___alignof] = ACTIONS(3617),
    [anon_sym__alignof] = ACTIONS(3617),
    [anon_sym_alignof] = ACTIONS(3617),
    [anon_sym__Alignof] = ACTIONS(3617),
    [anon_sym_offsetof] = ACTIONS(3617),
    [anon_sym__Generic] = ACTIONS(3617),
    [anon_sym_asm] = ACTIONS(3617),
    [anon_sym___asm__] = ACTIONS(3617),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3619),
    [anon_sym_u_SQUOTE] = ACTIONS(3619),
    [anon_sym_U_SQUOTE] = ACTIONS(3619),
    [anon_sym_u8_SQUOTE] = ACTIONS(3619),
    [anon_sym_SQUOTE] = ACTIONS(3619),
    [anon_sym_L_DQUOTE] = ACTIONS(3619),
    [anon_sym_u_DQUOTE] = ACTIONS(3619),
    [anon_sym_U_DQUOTE] = ACTIONS(3619),
    [anon_sym_u8_DQUOTE] = ACTIONS(3619),
    [anon_sym_DQUOTE] = ACTIONS(3619),
    [sym_true] = ACTIONS(3617),
    [sym_false] = ACTIONS(3617),
    [anon_sym_NULL] = ACTIONS(3617),
    [anon_sym_nullptr] = ACTIONS(3617),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3617),
    [anon_sym_let] = ACTIONS(3617),
    [anon_sym_This] = ACTIONS(3617),
    [anon_sym_decltype] = ACTIONS(3617),
    [sym_virtual] = ACTIONS(3617),
    [anon_sym_explicit] = ACTIONS(3617),
    [anon_sym_typename] = ACTIONS(3617),
    [anon_sym_template] = ACTIONS(3617),
    [anon_sym_operator] = ACTIONS(3617),
    [anon_sym_try] = ACTIONS(3617),
    [anon_sym_delete] = ACTIONS(3617),
    [anon_sym_throw] = ACTIONS(3617),
    [anon_sym_namespace] = ACTIONS(3617),
    [anon_sym_using] = ACTIONS(3617),
    [anon_sym_static_assert] = ACTIONS(3617),
    [anon_sym_concept] = ACTIONS(3617),
    [anon_sym_co_return] = ACTIONS(3617),
    [anon_sym_co_yield] = ACTIONS(3617),
    [anon_sym_R_DQUOTE] = ACTIONS(3619),
    [anon_sym_LR_DQUOTE] = ACTIONS(3619),
    [anon_sym_uR_DQUOTE] = ACTIONS(3619),
    [anon_sym_UR_DQUOTE] = ACTIONS(3619),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3619),
    [anon_sym_co_await] = ACTIONS(3617),
    [anon_sym_new] = ACTIONS(3617),
    [anon_sym_requires] = ACTIONS(3617),
    [sym_this] = ACTIONS(3617),
    [anon_sym_discard] = ACTIONS(3617),
    [anon_sym_precise] = ACTIONS(3617),
    [anon_sym_shared] = ACTIONS(3617),
    [anon_sym_groupshared] = ACTIONS(3617),
    [anon_sym_uniform] = ACTIONS(3617),
    [anon_sym_row_major] = ACTIONS(3617),
    [anon_sym_column_major] = ACTIONS(3617),
    [anon_sym_globallycoherent] = ACTIONS(3617),
    [anon_sym_centroid] = ACTIONS(3617),
    [anon_sym_noperspective] = ACTIONS(3617),
    [anon_sym_nointerpolation] = ACTIONS(3617),
    [anon_sym_sample] = ACTIONS(3617),
    [anon_sym_linear] = ACTIONS(3617),
    [anon_sym_snorm] = ACTIONS(3617),
    [anon_sym_unorm] = ACTIONS(3617),
    [anon_sym_point] = ACTIONS(3617),
    [anon_sym_line] = ACTIONS(3617),
    [anon_sym_triangleadj] = ACTIONS(3617),
    [anon_sym_lineadj] = ACTIONS(3617),
    [anon_sym_triangle] = ACTIONS(3617),
    [anon_sym_cbuffer] = ACTIONS(3617),
    [anon_sym_interface] = ACTIONS(3617),
    [anon_sym_extension] = ACTIONS(3617),
  },
  [505] = {
    [sym_identifier] = ACTIONS(2373),
    [aux_sym_preproc_include_token1] = ACTIONS(2373),
    [aux_sym_preproc_def_token1] = ACTIONS(2373),
    [aux_sym_preproc_if_token1] = ACTIONS(2373),
    [aux_sym_preproc_if_token2] = ACTIONS(2373),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2373),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2373),
    [sym_preproc_directive] = ACTIONS(2373),
    [anon_sym_LPAREN2] = ACTIONS(2371),
    [anon_sym_BANG] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym___extension__] = ACTIONS(2373),
    [anon_sym_typedef] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_out] = ACTIONS(2373),
    [anon_sym_inout] = ACTIONS(2373),
    [anon_sym_extern] = ACTIONS(2373),
    [anon_sym___attribute__] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2371),
    [anon_sym___declspec] = ACTIONS(2373),
    [anon_sym___based] = ACTIONS(2373),
    [anon_sym___cdecl] = ACTIONS(2373),
    [anon_sym___clrcall] = ACTIONS(2373),
    [anon_sym___stdcall] = ACTIONS(2373),
    [anon_sym___fastcall] = ACTIONS(2373),
    [anon_sym___thiscall] = ACTIONS(2373),
    [anon_sym___vectorcall] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_signed] = ACTIONS(2373),
    [anon_sym_unsigned] = ACTIONS(2373),
    [anon_sym_long] = ACTIONS(2373),
    [anon_sym_short] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2373),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_register] = ACTIONS(2373),
    [anon_sym_inline] = ACTIONS(2373),
    [anon_sym___inline] = ACTIONS(2373),
    [anon_sym___inline__] = ACTIONS(2373),
    [anon_sym___forceinline] = ACTIONS(2373),
    [anon_sym_thread_local] = ACTIONS(2373),
    [anon_sym___thread] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym___restrict__] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym__Noreturn] = ACTIONS(2373),
    [anon_sym_noreturn] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_constinit] = ACTIONS(2373),
    [anon_sym_consteval] = ACTIONS(2373),
    [anon_sym_alignas] = ACTIONS(2373),
    [anon_sym__Alignas] = ACTIONS(2373),
    [sym_primitive_type] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_class] = ACTIONS(2373),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_else] = ACTIONS(2373),
    [anon_sym_switch] = ACTIONS(2373),
    [anon_sym_case] = ACTIONS(2373),
    [anon_sym_default] = ACTIONS(2373),
    [anon_sym_while] = ACTIONS(2373),
    [anon_sym_do] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2373),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2373),
    [anon_sym_goto] = ACTIONS(2373),
    [anon_sym___try] = ACTIONS(2373),
    [anon_sym___leave] = ACTIONS(2373),
    [anon_sym_not] = ACTIONS(2373),
    [anon_sym_compl] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_sizeof] = ACTIONS(2373),
    [anon_sym___alignof__] = ACTIONS(2373),
    [anon_sym___alignof] = ACTIONS(2373),
    [anon_sym__alignof] = ACTIONS(2373),
    [anon_sym_alignof] = ACTIONS(2373),
    [anon_sym__Alignof] = ACTIONS(2373),
    [anon_sym_offsetof] = ACTIONS(2373),
    [anon_sym__Generic] = ACTIONS(2373),
    [anon_sym_asm] = ACTIONS(2373),
    [anon_sym___asm__] = ACTIONS(2373),
    [sym_number_literal] = ACTIONS(2371),
    [anon_sym_L_SQUOTE] = ACTIONS(2371),
    [anon_sym_u_SQUOTE] = ACTIONS(2371),
    [anon_sym_U_SQUOTE] = ACTIONS(2371),
    [anon_sym_u8_SQUOTE] = ACTIONS(2371),
    [anon_sym_SQUOTE] = ACTIONS(2371),
    [anon_sym_L_DQUOTE] = ACTIONS(2371),
    [anon_sym_u_DQUOTE] = ACTIONS(2371),
    [anon_sym_U_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8_DQUOTE] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [anon_sym_NULL] = ACTIONS(2373),
    [anon_sym_nullptr] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_This] = ACTIONS(2373),
    [anon_sym_decltype] = ACTIONS(2373),
    [anon_sym_final] = ACTIONS(2373),
    [anon_sym_override] = ACTIONS(2373),
    [sym_virtual] = ACTIONS(2373),
    [anon_sym_explicit] = ACTIONS(2373),
    [anon_sym_typename] = ACTIONS(2373),
    [anon_sym_template] = ACTIONS(2373),
    [anon_sym_operator] = ACTIONS(2373),
    [anon_sym_try] = ACTIONS(2373),
    [anon_sym_delete] = ACTIONS(2373),
    [anon_sym_throw] = ACTIONS(2373),
    [anon_sym_namespace] = ACTIONS(2373),
    [anon_sym_using] = ACTIONS(2373),
    [anon_sym_static_assert] = ACTIONS(2373),
    [anon_sym_concept] = ACTIONS(2373),
    [anon_sym_co_return] = ACTIONS(2373),
    [anon_sym_co_yield] = ACTIONS(2373),
    [anon_sym_R_DQUOTE] = ACTIONS(2371),
    [anon_sym_LR_DQUOTE] = ACTIONS(2371),
    [anon_sym_uR_DQUOTE] = ACTIONS(2371),
    [anon_sym_UR_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2371),
    [anon_sym_co_await] = ACTIONS(2373),
    [anon_sym_new] = ACTIONS(2373),
    [anon_sym_requires] = ACTIONS(2373),
    [sym_this] = ACTIONS(2373),
    [anon_sym_discard] = ACTIONS(2373),
    [anon_sym_precise] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_groupshared] = ACTIONS(2373),
    [anon_sym_uniform] = ACTIONS(2373),
    [anon_sym_row_major] = ACTIONS(2373),
    [anon_sym_column_major] = ACTIONS(2373),
    [anon_sym_globallycoherent] = ACTIONS(2373),
    [anon_sym_centroid] = ACTIONS(2373),
    [anon_sym_noperspective] = ACTIONS(2373),
    [anon_sym_nointerpolation] = ACTIONS(2373),
    [anon_sym_sample] = ACTIONS(2373),
    [anon_sym_linear] = ACTIONS(2373),
    [anon_sym_snorm] = ACTIONS(2373),
    [anon_sym_unorm] = ACTIONS(2373),
    [anon_sym_point] = ACTIONS(2373),
    [anon_sym_line] = ACTIONS(2373),
    [anon_sym_triangleadj] = ACTIONS(2373),
    [anon_sym_lineadj] = ACTIONS(2373),
    [anon_sym_triangle] = ACTIONS(2373),
    [anon_sym_cbuffer] = ACTIONS(2373),
    [anon_sym_interface] = ACTIONS(2373),
    [anon_sym_extension] = ACTIONS(2373),
  },
  [506] = {
    [sym_identifier] = ACTIONS(2373),
    [aux_sym_preproc_include_token1] = ACTIONS(2373),
    [aux_sym_preproc_def_token1] = ACTIONS(2373),
    [aux_sym_preproc_if_token1] = ACTIONS(2373),
    [aux_sym_preproc_if_token2] = ACTIONS(2373),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2373),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2373),
    [sym_preproc_directive] = ACTIONS(2373),
    [anon_sym_LPAREN2] = ACTIONS(2371),
    [anon_sym_BANG] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym___extension__] = ACTIONS(2373),
    [anon_sym_typedef] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_out] = ACTIONS(2373),
    [anon_sym_inout] = ACTIONS(2373),
    [anon_sym_extern] = ACTIONS(2373),
    [anon_sym___attribute__] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2371),
    [anon_sym___declspec] = ACTIONS(2373),
    [anon_sym___based] = ACTIONS(2373),
    [anon_sym___cdecl] = ACTIONS(2373),
    [anon_sym___clrcall] = ACTIONS(2373),
    [anon_sym___stdcall] = ACTIONS(2373),
    [anon_sym___fastcall] = ACTIONS(2373),
    [anon_sym___thiscall] = ACTIONS(2373),
    [anon_sym___vectorcall] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_signed] = ACTIONS(2373),
    [anon_sym_unsigned] = ACTIONS(2373),
    [anon_sym_long] = ACTIONS(2373),
    [anon_sym_short] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2373),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_register] = ACTIONS(2373),
    [anon_sym_inline] = ACTIONS(2373),
    [anon_sym___inline] = ACTIONS(2373),
    [anon_sym___inline__] = ACTIONS(2373),
    [anon_sym___forceinline] = ACTIONS(2373),
    [anon_sym_thread_local] = ACTIONS(2373),
    [anon_sym___thread] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym___restrict__] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym__Noreturn] = ACTIONS(2373),
    [anon_sym_noreturn] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_constinit] = ACTIONS(2373),
    [anon_sym_consteval] = ACTIONS(2373),
    [anon_sym_alignas] = ACTIONS(2373),
    [anon_sym__Alignas] = ACTIONS(2373),
    [sym_primitive_type] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_class] = ACTIONS(2373),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_else] = ACTIONS(2373),
    [anon_sym_switch] = ACTIONS(2373),
    [anon_sym_case] = ACTIONS(2373),
    [anon_sym_default] = ACTIONS(2373),
    [anon_sym_while] = ACTIONS(2373),
    [anon_sym_do] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2373),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2373),
    [anon_sym_goto] = ACTIONS(2373),
    [anon_sym___try] = ACTIONS(2373),
    [anon_sym___leave] = ACTIONS(2373),
    [anon_sym_not] = ACTIONS(2373),
    [anon_sym_compl] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_sizeof] = ACTIONS(2373),
    [anon_sym___alignof__] = ACTIONS(2373),
    [anon_sym___alignof] = ACTIONS(2373),
    [anon_sym__alignof] = ACTIONS(2373),
    [anon_sym_alignof] = ACTIONS(2373),
    [anon_sym__Alignof] = ACTIONS(2373),
    [anon_sym_offsetof] = ACTIONS(2373),
    [anon_sym__Generic] = ACTIONS(2373),
    [anon_sym_asm] = ACTIONS(2373),
    [anon_sym___asm__] = ACTIONS(2373),
    [sym_number_literal] = ACTIONS(2371),
    [anon_sym_L_SQUOTE] = ACTIONS(2371),
    [anon_sym_u_SQUOTE] = ACTIONS(2371),
    [anon_sym_U_SQUOTE] = ACTIONS(2371),
    [anon_sym_u8_SQUOTE] = ACTIONS(2371),
    [anon_sym_SQUOTE] = ACTIONS(2371),
    [anon_sym_L_DQUOTE] = ACTIONS(2371),
    [anon_sym_u_DQUOTE] = ACTIONS(2371),
    [anon_sym_U_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8_DQUOTE] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [anon_sym_NULL] = ACTIONS(2373),
    [anon_sym_nullptr] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_This] = ACTIONS(2373),
    [anon_sym_decltype] = ACTIONS(2373),
    [anon_sym_final] = ACTIONS(2373),
    [anon_sym_override] = ACTIONS(2373),
    [sym_virtual] = ACTIONS(2373),
    [anon_sym_explicit] = ACTIONS(2373),
    [anon_sym_typename] = ACTIONS(2373),
    [anon_sym_template] = ACTIONS(2373),
    [anon_sym_operator] = ACTIONS(2373),
    [anon_sym_try] = ACTIONS(2373),
    [anon_sym_delete] = ACTIONS(2373),
    [anon_sym_throw] = ACTIONS(2373),
    [anon_sym_namespace] = ACTIONS(2373),
    [anon_sym_using] = ACTIONS(2373),
    [anon_sym_static_assert] = ACTIONS(2373),
    [anon_sym_concept] = ACTIONS(2373),
    [anon_sym_co_return] = ACTIONS(2373),
    [anon_sym_co_yield] = ACTIONS(2373),
    [anon_sym_R_DQUOTE] = ACTIONS(2371),
    [anon_sym_LR_DQUOTE] = ACTIONS(2371),
    [anon_sym_uR_DQUOTE] = ACTIONS(2371),
    [anon_sym_UR_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2371),
    [anon_sym_co_await] = ACTIONS(2373),
    [anon_sym_new] = ACTIONS(2373),
    [anon_sym_requires] = ACTIONS(2373),
    [sym_this] = ACTIONS(2373),
    [anon_sym_discard] = ACTIONS(2373),
    [anon_sym_precise] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_groupshared] = ACTIONS(2373),
    [anon_sym_uniform] = ACTIONS(2373),
    [anon_sym_row_major] = ACTIONS(2373),
    [anon_sym_column_major] = ACTIONS(2373),
    [anon_sym_globallycoherent] = ACTIONS(2373),
    [anon_sym_centroid] = ACTIONS(2373),
    [anon_sym_noperspective] = ACTIONS(2373),
    [anon_sym_nointerpolation] = ACTIONS(2373),
    [anon_sym_sample] = ACTIONS(2373),
    [anon_sym_linear] = ACTIONS(2373),
    [anon_sym_snorm] = ACTIONS(2373),
    [anon_sym_unorm] = ACTIONS(2373),
    [anon_sym_point] = ACTIONS(2373),
    [anon_sym_line] = ACTIONS(2373),
    [anon_sym_triangleadj] = ACTIONS(2373),
    [anon_sym_lineadj] = ACTIONS(2373),
    [anon_sym_triangle] = ACTIONS(2373),
    [anon_sym_cbuffer] = ACTIONS(2373),
    [anon_sym_interface] = ACTIONS(2373),
    [anon_sym_extension] = ACTIONS(2373),
  },
  [507] = {
    [sym_identifier] = ACTIONS(3621),
    [aux_sym_preproc_include_token1] = ACTIONS(3621),
    [aux_sym_preproc_def_token1] = ACTIONS(3621),
    [aux_sym_preproc_if_token1] = ACTIONS(3621),
    [aux_sym_preproc_if_token2] = ACTIONS(3621),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3621),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3621),
    [aux_sym_preproc_else_token1] = ACTIONS(3621),
    [aux_sym_preproc_elif_token1] = ACTIONS(3621),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3621),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3621),
    [sym_preproc_directive] = ACTIONS(3621),
    [anon_sym_LPAREN2] = ACTIONS(3623),
    [anon_sym_BANG] = ACTIONS(3623),
    [anon_sym_TILDE] = ACTIONS(3623),
    [anon_sym_DASH] = ACTIONS(3621),
    [anon_sym_PLUS] = ACTIONS(3621),
    [anon_sym_STAR] = ACTIONS(3623),
    [anon_sym_AMP_AMP] = ACTIONS(3623),
    [anon_sym_AMP] = ACTIONS(3621),
    [anon_sym_SEMI] = ACTIONS(3623),
    [anon_sym___extension__] = ACTIONS(3621),
    [anon_sym_typedef] = ACTIONS(3621),
    [anon_sym_in] = ACTIONS(3621),
    [anon_sym_out] = ACTIONS(3621),
    [anon_sym_inout] = ACTIONS(3621),
    [anon_sym_extern] = ACTIONS(3621),
    [anon_sym___attribute__] = ACTIONS(3621),
    [anon_sym_COLON_COLON] = ACTIONS(3623),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3623),
    [anon_sym___declspec] = ACTIONS(3621),
    [anon_sym___based] = ACTIONS(3621),
    [anon_sym___cdecl] = ACTIONS(3621),
    [anon_sym___clrcall] = ACTIONS(3621),
    [anon_sym___stdcall] = ACTIONS(3621),
    [anon_sym___fastcall] = ACTIONS(3621),
    [anon_sym___thiscall] = ACTIONS(3621),
    [anon_sym___vectorcall] = ACTIONS(3621),
    [anon_sym_LBRACE] = ACTIONS(3623),
    [anon_sym_signed] = ACTIONS(3621),
    [anon_sym_unsigned] = ACTIONS(3621),
    [anon_sym_long] = ACTIONS(3621),
    [anon_sym_short] = ACTIONS(3621),
    [anon_sym_LBRACK] = ACTIONS(3621),
    [anon_sym_static] = ACTIONS(3621),
    [anon_sym_register] = ACTIONS(3621),
    [anon_sym_inline] = ACTIONS(3621),
    [anon_sym___inline] = ACTIONS(3621),
    [anon_sym___inline__] = ACTIONS(3621),
    [anon_sym___forceinline] = ACTIONS(3621),
    [anon_sym_thread_local] = ACTIONS(3621),
    [anon_sym___thread] = ACTIONS(3621),
    [anon_sym_const] = ACTIONS(3621),
    [anon_sym_constexpr] = ACTIONS(3621),
    [anon_sym_volatile] = ACTIONS(3621),
    [anon_sym_restrict] = ACTIONS(3621),
    [anon_sym___restrict__] = ACTIONS(3621),
    [anon_sym__Atomic] = ACTIONS(3621),
    [anon_sym__Noreturn] = ACTIONS(3621),
    [anon_sym_noreturn] = ACTIONS(3621),
    [anon_sym_mutable] = ACTIONS(3621),
    [anon_sym_constinit] = ACTIONS(3621),
    [anon_sym_consteval] = ACTIONS(3621),
    [anon_sym_alignas] = ACTIONS(3621),
    [anon_sym__Alignas] = ACTIONS(3621),
    [sym_primitive_type] = ACTIONS(3621),
    [anon_sym_enum] = ACTIONS(3621),
    [anon_sym_class] = ACTIONS(3621),
    [anon_sym_struct] = ACTIONS(3621),
    [anon_sym_union] = ACTIONS(3621),
    [anon_sym_if] = ACTIONS(3621),
    [anon_sym_switch] = ACTIONS(3621),
    [anon_sym_case] = ACTIONS(3621),
    [anon_sym_default] = ACTIONS(3621),
    [anon_sym_while] = ACTIONS(3621),
    [anon_sym_do] = ACTIONS(3621),
    [anon_sym_for] = ACTIONS(3621),
    [anon_sym_return] = ACTIONS(3621),
    [anon_sym_break] = ACTIONS(3621),
    [anon_sym_continue] = ACTIONS(3621),
    [anon_sym_goto] = ACTIONS(3621),
    [anon_sym___try] = ACTIONS(3621),
    [anon_sym___leave] = ACTIONS(3621),
    [anon_sym_not] = ACTIONS(3621),
    [anon_sym_compl] = ACTIONS(3621),
    [anon_sym_DASH_DASH] = ACTIONS(3623),
    [anon_sym_PLUS_PLUS] = ACTIONS(3623),
    [anon_sym_sizeof] = ACTIONS(3621),
    [anon_sym___alignof__] = ACTIONS(3621),
    [anon_sym___alignof] = ACTIONS(3621),
    [anon_sym__alignof] = ACTIONS(3621),
    [anon_sym_alignof] = ACTIONS(3621),
    [anon_sym__Alignof] = ACTIONS(3621),
    [anon_sym_offsetof] = ACTIONS(3621),
    [anon_sym__Generic] = ACTIONS(3621),
    [anon_sym_asm] = ACTIONS(3621),
    [anon_sym___asm__] = ACTIONS(3621),
    [sym_number_literal] = ACTIONS(3623),
    [anon_sym_L_SQUOTE] = ACTIONS(3623),
    [anon_sym_u_SQUOTE] = ACTIONS(3623),
    [anon_sym_U_SQUOTE] = ACTIONS(3623),
    [anon_sym_u8_SQUOTE] = ACTIONS(3623),
    [anon_sym_SQUOTE] = ACTIONS(3623),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(3621),
    [sym_false] = ACTIONS(3621),
    [anon_sym_NULL] = ACTIONS(3621),
    [anon_sym_nullptr] = ACTIONS(3621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3621),
    [anon_sym_let] = ACTIONS(3621),
    [anon_sym_This] = ACTIONS(3621),
    [anon_sym_decltype] = ACTIONS(3621),
    [sym_virtual] = ACTIONS(3621),
    [anon_sym_explicit] = ACTIONS(3621),
    [anon_sym_typename] = ACTIONS(3621),
    [anon_sym_template] = ACTIONS(3621),
    [anon_sym_operator] = ACTIONS(3621),
    [anon_sym_try] = ACTIONS(3621),
    [anon_sym_delete] = ACTIONS(3621),
    [anon_sym_throw] = ACTIONS(3621),
    [anon_sym_namespace] = ACTIONS(3621),
    [anon_sym_using] = ACTIONS(3621),
    [anon_sym_static_assert] = ACTIONS(3621),
    [anon_sym_concept] = ACTIONS(3621),
    [anon_sym_co_return] = ACTIONS(3621),
    [anon_sym_co_yield] = ACTIONS(3621),
    [anon_sym_R_DQUOTE] = ACTIONS(3623),
    [anon_sym_LR_DQUOTE] = ACTIONS(3623),
    [anon_sym_uR_DQUOTE] = ACTIONS(3623),
    [anon_sym_UR_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3623),
    [anon_sym_co_await] = ACTIONS(3621),
    [anon_sym_new] = ACTIONS(3621),
    [anon_sym_requires] = ACTIONS(3621),
    [sym_this] = ACTIONS(3621),
    [anon_sym_discard] = ACTIONS(3621),
    [anon_sym_precise] = ACTIONS(3621),
    [anon_sym_shared] = ACTIONS(3621),
    [anon_sym_groupshared] = ACTIONS(3621),
    [anon_sym_uniform] = ACTIONS(3621),
    [anon_sym_row_major] = ACTIONS(3621),
    [anon_sym_column_major] = ACTIONS(3621),
    [anon_sym_globallycoherent] = ACTIONS(3621),
    [anon_sym_centroid] = ACTIONS(3621),
    [anon_sym_noperspective] = ACTIONS(3621),
    [anon_sym_nointerpolation] = ACTIONS(3621),
    [anon_sym_sample] = ACTIONS(3621),
    [anon_sym_linear] = ACTIONS(3621),
    [anon_sym_snorm] = ACTIONS(3621),
    [anon_sym_unorm] = ACTIONS(3621),
    [anon_sym_point] = ACTIONS(3621),
    [anon_sym_line] = ACTIONS(3621),
    [anon_sym_triangleadj] = ACTIONS(3621),
    [anon_sym_lineadj] = ACTIONS(3621),
    [anon_sym_triangle] = ACTIONS(3621),
    [anon_sym_cbuffer] = ACTIONS(3621),
    [anon_sym_interface] = ACTIONS(3621),
    [anon_sym_extension] = ACTIONS(3621),
  },
  [508] = {
    [sym_identifier] = ACTIONS(3625),
    [aux_sym_preproc_include_token1] = ACTIONS(3625),
    [aux_sym_preproc_def_token1] = ACTIONS(3625),
    [aux_sym_preproc_if_token1] = ACTIONS(3625),
    [aux_sym_preproc_if_token2] = ACTIONS(3625),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3625),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3625),
    [aux_sym_preproc_else_token1] = ACTIONS(3625),
    [aux_sym_preproc_elif_token1] = ACTIONS(3625),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3625),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3625),
    [sym_preproc_directive] = ACTIONS(3625),
    [anon_sym_LPAREN2] = ACTIONS(3627),
    [anon_sym_BANG] = ACTIONS(3627),
    [anon_sym_TILDE] = ACTIONS(3627),
    [anon_sym_DASH] = ACTIONS(3625),
    [anon_sym_PLUS] = ACTIONS(3625),
    [anon_sym_STAR] = ACTIONS(3627),
    [anon_sym_AMP_AMP] = ACTIONS(3627),
    [anon_sym_AMP] = ACTIONS(3625),
    [anon_sym_SEMI] = ACTIONS(3627),
    [anon_sym___extension__] = ACTIONS(3625),
    [anon_sym_typedef] = ACTIONS(3625),
    [anon_sym_in] = ACTIONS(3625),
    [anon_sym_out] = ACTIONS(3625),
    [anon_sym_inout] = ACTIONS(3625),
    [anon_sym_extern] = ACTIONS(3625),
    [anon_sym___attribute__] = ACTIONS(3625),
    [anon_sym_COLON_COLON] = ACTIONS(3627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3627),
    [anon_sym___declspec] = ACTIONS(3625),
    [anon_sym___based] = ACTIONS(3625),
    [anon_sym___cdecl] = ACTIONS(3625),
    [anon_sym___clrcall] = ACTIONS(3625),
    [anon_sym___stdcall] = ACTIONS(3625),
    [anon_sym___fastcall] = ACTIONS(3625),
    [anon_sym___thiscall] = ACTIONS(3625),
    [anon_sym___vectorcall] = ACTIONS(3625),
    [anon_sym_LBRACE] = ACTIONS(3627),
    [anon_sym_signed] = ACTIONS(3625),
    [anon_sym_unsigned] = ACTIONS(3625),
    [anon_sym_long] = ACTIONS(3625),
    [anon_sym_short] = ACTIONS(3625),
    [anon_sym_LBRACK] = ACTIONS(3625),
    [anon_sym_static] = ACTIONS(3625),
    [anon_sym_register] = ACTIONS(3625),
    [anon_sym_inline] = ACTIONS(3625),
    [anon_sym___inline] = ACTIONS(3625),
    [anon_sym___inline__] = ACTIONS(3625),
    [anon_sym___forceinline] = ACTIONS(3625),
    [anon_sym_thread_local] = ACTIONS(3625),
    [anon_sym___thread] = ACTIONS(3625),
    [anon_sym_const] = ACTIONS(3625),
    [anon_sym_constexpr] = ACTIONS(3625),
    [anon_sym_volatile] = ACTIONS(3625),
    [anon_sym_restrict] = ACTIONS(3625),
    [anon_sym___restrict__] = ACTIONS(3625),
    [anon_sym__Atomic] = ACTIONS(3625),
    [anon_sym__Noreturn] = ACTIONS(3625),
    [anon_sym_noreturn] = ACTIONS(3625),
    [anon_sym_mutable] = ACTIONS(3625),
    [anon_sym_constinit] = ACTIONS(3625),
    [anon_sym_consteval] = ACTIONS(3625),
    [anon_sym_alignas] = ACTIONS(3625),
    [anon_sym__Alignas] = ACTIONS(3625),
    [sym_primitive_type] = ACTIONS(3625),
    [anon_sym_enum] = ACTIONS(3625),
    [anon_sym_class] = ACTIONS(3625),
    [anon_sym_struct] = ACTIONS(3625),
    [anon_sym_union] = ACTIONS(3625),
    [anon_sym_if] = ACTIONS(3625),
    [anon_sym_switch] = ACTIONS(3625),
    [anon_sym_case] = ACTIONS(3625),
    [anon_sym_default] = ACTIONS(3625),
    [anon_sym_while] = ACTIONS(3625),
    [anon_sym_do] = ACTIONS(3625),
    [anon_sym_for] = ACTIONS(3625),
    [anon_sym_return] = ACTIONS(3625),
    [anon_sym_break] = ACTIONS(3625),
    [anon_sym_continue] = ACTIONS(3625),
    [anon_sym_goto] = ACTIONS(3625),
    [anon_sym___try] = ACTIONS(3625),
    [anon_sym___leave] = ACTIONS(3625),
    [anon_sym_not] = ACTIONS(3625),
    [anon_sym_compl] = ACTIONS(3625),
    [anon_sym_DASH_DASH] = ACTIONS(3627),
    [anon_sym_PLUS_PLUS] = ACTIONS(3627),
    [anon_sym_sizeof] = ACTIONS(3625),
    [anon_sym___alignof__] = ACTIONS(3625),
    [anon_sym___alignof] = ACTIONS(3625),
    [anon_sym__alignof] = ACTIONS(3625),
    [anon_sym_alignof] = ACTIONS(3625),
    [anon_sym__Alignof] = ACTIONS(3625),
    [anon_sym_offsetof] = ACTIONS(3625),
    [anon_sym__Generic] = ACTIONS(3625),
    [anon_sym_asm] = ACTIONS(3625),
    [anon_sym___asm__] = ACTIONS(3625),
    [sym_number_literal] = ACTIONS(3627),
    [anon_sym_L_SQUOTE] = ACTIONS(3627),
    [anon_sym_u_SQUOTE] = ACTIONS(3627),
    [anon_sym_U_SQUOTE] = ACTIONS(3627),
    [anon_sym_u8_SQUOTE] = ACTIONS(3627),
    [anon_sym_SQUOTE] = ACTIONS(3627),
    [anon_sym_L_DQUOTE] = ACTIONS(3627),
    [anon_sym_u_DQUOTE] = ACTIONS(3627),
    [anon_sym_U_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8_DQUOTE] = ACTIONS(3627),
    [anon_sym_DQUOTE] = ACTIONS(3627),
    [sym_true] = ACTIONS(3625),
    [sym_false] = ACTIONS(3625),
    [anon_sym_NULL] = ACTIONS(3625),
    [anon_sym_nullptr] = ACTIONS(3625),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3625),
    [anon_sym_let] = ACTIONS(3625),
    [anon_sym_This] = ACTIONS(3625),
    [anon_sym_decltype] = ACTIONS(3625),
    [sym_virtual] = ACTIONS(3625),
    [anon_sym_explicit] = ACTIONS(3625),
    [anon_sym_typename] = ACTIONS(3625),
    [anon_sym_template] = ACTIONS(3625),
    [anon_sym_operator] = ACTIONS(3625),
    [anon_sym_try] = ACTIONS(3625),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_throw] = ACTIONS(3625),
    [anon_sym_namespace] = ACTIONS(3625),
    [anon_sym_using] = ACTIONS(3625),
    [anon_sym_static_assert] = ACTIONS(3625),
    [anon_sym_concept] = ACTIONS(3625),
    [anon_sym_co_return] = ACTIONS(3625),
    [anon_sym_co_yield] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3625),
    [anon_sym_new] = ACTIONS(3625),
    [anon_sym_requires] = ACTIONS(3625),
    [sym_this] = ACTIONS(3625),
    [anon_sym_discard] = ACTIONS(3625),
    [anon_sym_precise] = ACTIONS(3625),
    [anon_sym_shared] = ACTIONS(3625),
    [anon_sym_groupshared] = ACTIONS(3625),
    [anon_sym_uniform] = ACTIONS(3625),
    [anon_sym_row_major] = ACTIONS(3625),
    [anon_sym_column_major] = ACTIONS(3625),
    [anon_sym_globallycoherent] = ACTIONS(3625),
    [anon_sym_centroid] = ACTIONS(3625),
    [anon_sym_noperspective] = ACTIONS(3625),
    [anon_sym_nointerpolation] = ACTIONS(3625),
    [anon_sym_sample] = ACTIONS(3625),
    [anon_sym_linear] = ACTIONS(3625),
    [anon_sym_snorm] = ACTIONS(3625),
    [anon_sym_unorm] = ACTIONS(3625),
    [anon_sym_point] = ACTIONS(3625),
    [anon_sym_line] = ACTIONS(3625),
    [anon_sym_triangleadj] = ACTIONS(3625),
    [anon_sym_lineadj] = ACTIONS(3625),
    [anon_sym_triangle] = ACTIONS(3625),
    [anon_sym_cbuffer] = ACTIONS(3625),
    [anon_sym_interface] = ACTIONS(3625),
    [anon_sym_extension] = ACTIONS(3625),
  },
  [509] = {
    [sym_identifier] = ACTIONS(3629),
    [aux_sym_preproc_include_token1] = ACTIONS(3629),
    [aux_sym_preproc_def_token1] = ACTIONS(3629),
    [aux_sym_preproc_if_token1] = ACTIONS(3629),
    [aux_sym_preproc_if_token2] = ACTIONS(3629),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3629),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3629),
    [aux_sym_preproc_else_token1] = ACTIONS(3629),
    [aux_sym_preproc_elif_token1] = ACTIONS(3629),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3629),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3629),
    [sym_preproc_directive] = ACTIONS(3629),
    [anon_sym_LPAREN2] = ACTIONS(3631),
    [anon_sym_BANG] = ACTIONS(3631),
    [anon_sym_TILDE] = ACTIONS(3631),
    [anon_sym_DASH] = ACTIONS(3629),
    [anon_sym_PLUS] = ACTIONS(3629),
    [anon_sym_STAR] = ACTIONS(3631),
    [anon_sym_AMP_AMP] = ACTIONS(3631),
    [anon_sym_AMP] = ACTIONS(3629),
    [anon_sym_SEMI] = ACTIONS(3631),
    [anon_sym___extension__] = ACTIONS(3629),
    [anon_sym_typedef] = ACTIONS(3629),
    [anon_sym_in] = ACTIONS(3629),
    [anon_sym_out] = ACTIONS(3629),
    [anon_sym_inout] = ACTIONS(3629),
    [anon_sym_extern] = ACTIONS(3629),
    [anon_sym___attribute__] = ACTIONS(3629),
    [anon_sym_COLON_COLON] = ACTIONS(3631),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3631),
    [anon_sym___declspec] = ACTIONS(3629),
    [anon_sym___based] = ACTIONS(3629),
    [anon_sym___cdecl] = ACTIONS(3629),
    [anon_sym___clrcall] = ACTIONS(3629),
    [anon_sym___stdcall] = ACTIONS(3629),
    [anon_sym___fastcall] = ACTIONS(3629),
    [anon_sym___thiscall] = ACTIONS(3629),
    [anon_sym___vectorcall] = ACTIONS(3629),
    [anon_sym_LBRACE] = ACTIONS(3631),
    [anon_sym_signed] = ACTIONS(3629),
    [anon_sym_unsigned] = ACTIONS(3629),
    [anon_sym_long] = ACTIONS(3629),
    [anon_sym_short] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3629),
    [anon_sym_static] = ACTIONS(3629),
    [anon_sym_register] = ACTIONS(3629),
    [anon_sym_inline] = ACTIONS(3629),
    [anon_sym___inline] = ACTIONS(3629),
    [anon_sym___inline__] = ACTIONS(3629),
    [anon_sym___forceinline] = ACTIONS(3629),
    [anon_sym_thread_local] = ACTIONS(3629),
    [anon_sym___thread] = ACTIONS(3629),
    [anon_sym_const] = ACTIONS(3629),
    [anon_sym_constexpr] = ACTIONS(3629),
    [anon_sym_volatile] = ACTIONS(3629),
    [anon_sym_restrict] = ACTIONS(3629),
    [anon_sym___restrict__] = ACTIONS(3629),
    [anon_sym__Atomic] = ACTIONS(3629),
    [anon_sym__Noreturn] = ACTIONS(3629),
    [anon_sym_noreturn] = ACTIONS(3629),
    [anon_sym_mutable] = ACTIONS(3629),
    [anon_sym_constinit] = ACTIONS(3629),
    [anon_sym_consteval] = ACTIONS(3629),
    [anon_sym_alignas] = ACTIONS(3629),
    [anon_sym__Alignas] = ACTIONS(3629),
    [sym_primitive_type] = ACTIONS(3629),
    [anon_sym_enum] = ACTIONS(3629),
    [anon_sym_class] = ACTIONS(3629),
    [anon_sym_struct] = ACTIONS(3629),
    [anon_sym_union] = ACTIONS(3629),
    [anon_sym_if] = ACTIONS(3629),
    [anon_sym_switch] = ACTIONS(3629),
    [anon_sym_case] = ACTIONS(3629),
    [anon_sym_default] = ACTIONS(3629),
    [anon_sym_while] = ACTIONS(3629),
    [anon_sym_do] = ACTIONS(3629),
    [anon_sym_for] = ACTIONS(3629),
    [anon_sym_return] = ACTIONS(3629),
    [anon_sym_break] = ACTIONS(3629),
    [anon_sym_continue] = ACTIONS(3629),
    [anon_sym_goto] = ACTIONS(3629),
    [anon_sym___try] = ACTIONS(3629),
    [anon_sym___leave] = ACTIONS(3629),
    [anon_sym_not] = ACTIONS(3629),
    [anon_sym_compl] = ACTIONS(3629),
    [anon_sym_DASH_DASH] = ACTIONS(3631),
    [anon_sym_PLUS_PLUS] = ACTIONS(3631),
    [anon_sym_sizeof] = ACTIONS(3629),
    [anon_sym___alignof__] = ACTIONS(3629),
    [anon_sym___alignof] = ACTIONS(3629),
    [anon_sym__alignof] = ACTIONS(3629),
    [anon_sym_alignof] = ACTIONS(3629),
    [anon_sym__Alignof] = ACTIONS(3629),
    [anon_sym_offsetof] = ACTIONS(3629),
    [anon_sym__Generic] = ACTIONS(3629),
    [anon_sym_asm] = ACTIONS(3629),
    [anon_sym___asm__] = ACTIONS(3629),
    [sym_number_literal] = ACTIONS(3631),
    [anon_sym_L_SQUOTE] = ACTIONS(3631),
    [anon_sym_u_SQUOTE] = ACTIONS(3631),
    [anon_sym_U_SQUOTE] = ACTIONS(3631),
    [anon_sym_u8_SQUOTE] = ACTIONS(3631),
    [anon_sym_SQUOTE] = ACTIONS(3631),
    [anon_sym_L_DQUOTE] = ACTIONS(3631),
    [anon_sym_u_DQUOTE] = ACTIONS(3631),
    [anon_sym_U_DQUOTE] = ACTIONS(3631),
    [anon_sym_u8_DQUOTE] = ACTIONS(3631),
    [anon_sym_DQUOTE] = ACTIONS(3631),
    [sym_true] = ACTIONS(3629),
    [sym_false] = ACTIONS(3629),
    [anon_sym_NULL] = ACTIONS(3629),
    [anon_sym_nullptr] = ACTIONS(3629),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3629),
    [anon_sym_let] = ACTIONS(3629),
    [anon_sym_This] = ACTIONS(3629),
    [anon_sym_decltype] = ACTIONS(3629),
    [sym_virtual] = ACTIONS(3629),
    [anon_sym_explicit] = ACTIONS(3629),
    [anon_sym_typename] = ACTIONS(3629),
    [anon_sym_template] = ACTIONS(3629),
    [anon_sym_operator] = ACTIONS(3629),
    [anon_sym_try] = ACTIONS(3629),
    [anon_sym_delete] = ACTIONS(3629),
    [anon_sym_throw] = ACTIONS(3629),
    [anon_sym_namespace] = ACTIONS(3629),
    [anon_sym_using] = ACTIONS(3629),
    [anon_sym_static_assert] = ACTIONS(3629),
    [anon_sym_concept] = ACTIONS(3629),
    [anon_sym_co_return] = ACTIONS(3629),
    [anon_sym_co_yield] = ACTIONS(3629),
    [anon_sym_R_DQUOTE] = ACTIONS(3631),
    [anon_sym_LR_DQUOTE] = ACTIONS(3631),
    [anon_sym_uR_DQUOTE] = ACTIONS(3631),
    [anon_sym_UR_DQUOTE] = ACTIONS(3631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3631),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3629),
    [anon_sym_requires] = ACTIONS(3629),
    [sym_this] = ACTIONS(3629),
    [anon_sym_discard] = ACTIONS(3629),
    [anon_sym_precise] = ACTIONS(3629),
    [anon_sym_shared] = ACTIONS(3629),
    [anon_sym_groupshared] = ACTIONS(3629),
    [anon_sym_uniform] = ACTIONS(3629),
    [anon_sym_row_major] = ACTIONS(3629),
    [anon_sym_column_major] = ACTIONS(3629),
    [anon_sym_globallycoherent] = ACTIONS(3629),
    [anon_sym_centroid] = ACTIONS(3629),
    [anon_sym_noperspective] = ACTIONS(3629),
    [anon_sym_nointerpolation] = ACTIONS(3629),
    [anon_sym_sample] = ACTIONS(3629),
    [anon_sym_linear] = ACTIONS(3629),
    [anon_sym_snorm] = ACTIONS(3629),
    [anon_sym_unorm] = ACTIONS(3629),
    [anon_sym_point] = ACTIONS(3629),
    [anon_sym_line] = ACTIONS(3629),
    [anon_sym_triangleadj] = ACTIONS(3629),
    [anon_sym_lineadj] = ACTIONS(3629),
    [anon_sym_triangle] = ACTIONS(3629),
    [anon_sym_cbuffer] = ACTIONS(3629),
    [anon_sym_interface] = ACTIONS(3629),
    [anon_sym_extension] = ACTIONS(3629),
  },
  [510] = {
    [sym_identifier] = ACTIONS(2373),
    [aux_sym_preproc_include_token1] = ACTIONS(2373),
    [aux_sym_preproc_def_token1] = ACTIONS(2373),
    [aux_sym_preproc_if_token1] = ACTIONS(2373),
    [aux_sym_preproc_if_token2] = ACTIONS(2373),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2373),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2373),
    [sym_preproc_directive] = ACTIONS(2373),
    [anon_sym_LPAREN2] = ACTIONS(2371),
    [anon_sym_BANG] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym___extension__] = ACTIONS(2373),
    [anon_sym_typedef] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_out] = ACTIONS(2373),
    [anon_sym_inout] = ACTIONS(2373),
    [anon_sym_extern] = ACTIONS(2373),
    [anon_sym___attribute__] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2371),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2371),
    [anon_sym___declspec] = ACTIONS(2373),
    [anon_sym___based] = ACTIONS(2373),
    [anon_sym___cdecl] = ACTIONS(2373),
    [anon_sym___clrcall] = ACTIONS(2373),
    [anon_sym___stdcall] = ACTIONS(2373),
    [anon_sym___fastcall] = ACTIONS(2373),
    [anon_sym___thiscall] = ACTIONS(2373),
    [anon_sym___vectorcall] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_signed] = ACTIONS(2373),
    [anon_sym_unsigned] = ACTIONS(2373),
    [anon_sym_long] = ACTIONS(2373),
    [anon_sym_short] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2373),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_register] = ACTIONS(2373),
    [anon_sym_inline] = ACTIONS(2373),
    [anon_sym___inline] = ACTIONS(2373),
    [anon_sym___inline__] = ACTIONS(2373),
    [anon_sym___forceinline] = ACTIONS(2373),
    [anon_sym_thread_local] = ACTIONS(2373),
    [anon_sym___thread] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym___restrict__] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym__Noreturn] = ACTIONS(2373),
    [anon_sym_noreturn] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_constinit] = ACTIONS(2373),
    [anon_sym_consteval] = ACTIONS(2373),
    [anon_sym_alignas] = ACTIONS(2373),
    [anon_sym__Alignas] = ACTIONS(2373),
    [sym_primitive_type] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_class] = ACTIONS(2373),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_else] = ACTIONS(2373),
    [anon_sym_switch] = ACTIONS(2373),
    [anon_sym_case] = ACTIONS(2373),
    [anon_sym_default] = ACTIONS(2373),
    [anon_sym_while] = ACTIONS(2373),
    [anon_sym_do] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2373),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2373),
    [anon_sym_goto] = ACTIONS(2373),
    [anon_sym___try] = ACTIONS(2373),
    [anon_sym___leave] = ACTIONS(2373),
    [anon_sym_not] = ACTIONS(2373),
    [anon_sym_compl] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_sizeof] = ACTIONS(2373),
    [anon_sym___alignof__] = ACTIONS(2373),
    [anon_sym___alignof] = ACTIONS(2373),
    [anon_sym__alignof] = ACTIONS(2373),
    [anon_sym_alignof] = ACTIONS(2373),
    [anon_sym__Alignof] = ACTIONS(2373),
    [anon_sym_offsetof] = ACTIONS(2373),
    [anon_sym__Generic] = ACTIONS(2373),
    [anon_sym_asm] = ACTIONS(2373),
    [anon_sym___asm__] = ACTIONS(2373),
    [sym_number_literal] = ACTIONS(2371),
    [anon_sym_L_SQUOTE] = ACTIONS(2371),
    [anon_sym_u_SQUOTE] = ACTIONS(2371),
    [anon_sym_U_SQUOTE] = ACTIONS(2371),
    [anon_sym_u8_SQUOTE] = ACTIONS(2371),
    [anon_sym_SQUOTE] = ACTIONS(2371),
    [anon_sym_L_DQUOTE] = ACTIONS(2371),
    [anon_sym_u_DQUOTE] = ACTIONS(2371),
    [anon_sym_U_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8_DQUOTE] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [anon_sym_NULL] = ACTIONS(2373),
    [anon_sym_nullptr] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_This] = ACTIONS(2373),
    [anon_sym_decltype] = ACTIONS(2373),
    [anon_sym_final] = ACTIONS(2373),
    [anon_sym_override] = ACTIONS(2373),
    [sym_virtual] = ACTIONS(2373),
    [anon_sym_explicit] = ACTIONS(2373),
    [anon_sym_typename] = ACTIONS(2373),
    [anon_sym_template] = ACTIONS(2373),
    [anon_sym_operator] = ACTIONS(2373),
    [anon_sym_try] = ACTIONS(2373),
    [anon_sym_delete] = ACTIONS(2373),
    [anon_sym_throw] = ACTIONS(2373),
    [anon_sym_namespace] = ACTIONS(2373),
    [anon_sym_using] = ACTIONS(2373),
    [anon_sym_static_assert] = ACTIONS(2373),
    [anon_sym_concept] = ACTIONS(2373),
    [anon_sym_co_return] = ACTIONS(2373),
    [anon_sym_co_yield] = ACTIONS(2373),
    [anon_sym_R_DQUOTE] = ACTIONS(2371),
    [anon_sym_LR_DQUOTE] = ACTIONS(2371),
    [anon_sym_uR_DQUOTE] = ACTIONS(2371),
    [anon_sym_UR_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2371),
    [anon_sym_co_await] = ACTIONS(2373),
    [anon_sym_new] = ACTIONS(2373),
    [anon_sym_requires] = ACTIONS(2373),
    [sym_this] = ACTIONS(2373),
    [anon_sym_discard] = ACTIONS(2373),
    [anon_sym_precise] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_groupshared] = ACTIONS(2373),
    [anon_sym_uniform] = ACTIONS(2373),
    [anon_sym_row_major] = ACTIONS(2373),
    [anon_sym_column_major] = ACTIONS(2373),
    [anon_sym_globallycoherent] = ACTIONS(2373),
    [anon_sym_centroid] = ACTIONS(2373),
    [anon_sym_noperspective] = ACTIONS(2373),
    [anon_sym_nointerpolation] = ACTIONS(2373),
    [anon_sym_sample] = ACTIONS(2373),
    [anon_sym_linear] = ACTIONS(2373),
    [anon_sym_snorm] = ACTIONS(2373),
    [anon_sym_unorm] = ACTIONS(2373),
    [anon_sym_point] = ACTIONS(2373),
    [anon_sym_line] = ACTIONS(2373),
    [anon_sym_triangleadj] = ACTIONS(2373),
    [anon_sym_lineadj] = ACTIONS(2373),
    [anon_sym_triangle] = ACTIONS(2373),
    [anon_sym_cbuffer] = ACTIONS(2373),
    [anon_sym_interface] = ACTIONS(2373),
    [anon_sym_extension] = ACTIONS(2373),
  },
  [511] = {
    [sym_identifier] = ACTIONS(3613),
    [aux_sym_preproc_include_token1] = ACTIONS(3613),
    [aux_sym_preproc_def_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token2] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3613),
    [aux_sym_preproc_else_token1] = ACTIONS(3613),
    [aux_sym_preproc_elif_token1] = ACTIONS(3613),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3613),
    [sym_preproc_directive] = ACTIONS(3613),
    [anon_sym_LPAREN2] = ACTIONS(3615),
    [anon_sym_BANG] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3613),
    [anon_sym_PLUS] = ACTIONS(3613),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym_SEMI] = ACTIONS(3615),
    [anon_sym___extension__] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3613),
    [anon_sym_in] = ACTIONS(3613),
    [anon_sym_out] = ACTIONS(3613),
    [anon_sym_inout] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym___attribute__] = ACTIONS(3613),
    [anon_sym_COLON_COLON] = ACTIONS(3615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3615),
    [anon_sym___declspec] = ACTIONS(3613),
    [anon_sym___based] = ACTIONS(3613),
    [anon_sym___cdecl] = ACTIONS(3613),
    [anon_sym___clrcall] = ACTIONS(3613),
    [anon_sym___stdcall] = ACTIONS(3613),
    [anon_sym___fastcall] = ACTIONS(3613),
    [anon_sym___thiscall] = ACTIONS(3613),
    [anon_sym___vectorcall] = ACTIONS(3613),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_signed] = ACTIONS(3613),
    [anon_sym_unsigned] = ACTIONS(3613),
    [anon_sym_long] = ACTIONS(3613),
    [anon_sym_short] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_register] = ACTIONS(3613),
    [anon_sym_inline] = ACTIONS(3613),
    [anon_sym___inline] = ACTIONS(3613),
    [anon_sym___inline__] = ACTIONS(3613),
    [anon_sym___forceinline] = ACTIONS(3613),
    [anon_sym_thread_local] = ACTIONS(3613),
    [anon_sym___thread] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_constexpr] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_restrict] = ACTIONS(3613),
    [anon_sym___restrict__] = ACTIONS(3613),
    [anon_sym__Atomic] = ACTIONS(3613),
    [anon_sym__Noreturn] = ACTIONS(3613),
    [anon_sym_noreturn] = ACTIONS(3613),
    [anon_sym_mutable] = ACTIONS(3613),
    [anon_sym_constinit] = ACTIONS(3613),
    [anon_sym_consteval] = ACTIONS(3613),
    [anon_sym_alignas] = ACTIONS(3613),
    [anon_sym__Alignas] = ACTIONS(3613),
    [sym_primitive_type] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_union] = ACTIONS(3613),
    [anon_sym_if] = ACTIONS(3613),
    [anon_sym_switch] = ACTIONS(3613),
    [anon_sym_case] = ACTIONS(3613),
    [anon_sym_default] = ACTIONS(3613),
    [anon_sym_while] = ACTIONS(3613),
    [anon_sym_do] = ACTIONS(3613),
    [anon_sym_for] = ACTIONS(3613),
    [anon_sym_return] = ACTIONS(3613),
    [anon_sym_break] = ACTIONS(3613),
    [anon_sym_continue] = ACTIONS(3613),
    [anon_sym_goto] = ACTIONS(3613),
    [anon_sym___try] = ACTIONS(3613),
    [anon_sym___leave] = ACTIONS(3613),
    [anon_sym_not] = ACTIONS(3613),
    [anon_sym_compl] = ACTIONS(3613),
    [anon_sym_DASH_DASH] = ACTIONS(3615),
    [anon_sym_PLUS_PLUS] = ACTIONS(3615),
    [anon_sym_sizeof] = ACTIONS(3613),
    [anon_sym___alignof__] = ACTIONS(3613),
    [anon_sym___alignof] = ACTIONS(3613),
    [anon_sym__alignof] = ACTIONS(3613),
    [anon_sym_alignof] = ACTIONS(3613),
    [anon_sym__Alignof] = ACTIONS(3613),
    [anon_sym_offsetof] = ACTIONS(3613),
    [anon_sym__Generic] = ACTIONS(3613),
    [anon_sym_asm] = ACTIONS(3613),
    [anon_sym___asm__] = ACTIONS(3613),
    [sym_number_literal] = ACTIONS(3615),
    [anon_sym_L_SQUOTE] = ACTIONS(3615),
    [anon_sym_u_SQUOTE] = ACTIONS(3615),
    [anon_sym_U_SQUOTE] = ACTIONS(3615),
    [anon_sym_u8_SQUOTE] = ACTIONS(3615),
    [anon_sym_SQUOTE] = ACTIONS(3615),
    [anon_sym_L_DQUOTE] = ACTIONS(3615),
    [anon_sym_u_DQUOTE] = ACTIONS(3615),
    [anon_sym_U_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8_DQUOTE] = ACTIONS(3615),
    [anon_sym_DQUOTE] = ACTIONS(3615),
    [sym_true] = ACTIONS(3613),
    [sym_false] = ACTIONS(3613),
    [anon_sym_NULL] = ACTIONS(3613),
    [anon_sym_nullptr] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_This] = ACTIONS(3613),
    [anon_sym_decltype] = ACTIONS(3613),
    [sym_virtual] = ACTIONS(3613),
    [anon_sym_explicit] = ACTIONS(3613),
    [anon_sym_typename] = ACTIONS(3613),
    [anon_sym_template] = ACTIONS(3613),
    [anon_sym_operator] = ACTIONS(3613),
    [anon_sym_try] = ACTIONS(3613),
    [anon_sym_delete] = ACTIONS(3613),
    [anon_sym_throw] = ACTIONS(3613),
    [anon_sym_namespace] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_static_assert] = ACTIONS(3613),
    [anon_sym_concept] = ACTIONS(3613),
    [anon_sym_co_return] = ACTIONS(3613),
    [anon_sym_co_yield] = ACTIONS(3613),
    [anon_sym_R_DQUOTE] = ACTIONS(3615),
    [anon_sym_LR_DQUOTE] = ACTIONS(3615),
    [anon_sym_uR_DQUOTE] = ACTIONS(3615),
    [anon_sym_UR_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3615),
    [anon_sym_co_await] = ACTIONS(3613),
    [anon_sym_new] = ACTIONS(3613),
    [anon_sym_requires] = ACTIONS(3613),
    [sym_this] = ACTIONS(3613),
    [anon_sym_discard] = ACTIONS(3613),
    [anon_sym_precise] = ACTIONS(3613),
    [anon_sym_shared] = ACTIONS(3613),
    [anon_sym_groupshared] = ACTIONS(3613),
    [anon_sym_uniform] = ACTIONS(3613),
    [anon_sym_row_major] = ACTIONS(3613),
    [anon_sym_column_major] = ACTIONS(3613),
    [anon_sym_globallycoherent] = ACTIONS(3613),
    [anon_sym_centroid] = ACTIONS(3613),
    [anon_sym_noperspective] = ACTIONS(3613),
    [anon_sym_nointerpolation] = ACTIONS(3613),
    [anon_sym_sample] = ACTIONS(3613),
    [anon_sym_linear] = ACTIONS(3613),
    [anon_sym_snorm] = ACTIONS(3613),
    [anon_sym_unorm] = ACTIONS(3613),
    [anon_sym_point] = ACTIONS(3613),
    [anon_sym_line] = ACTIONS(3613),
    [anon_sym_triangleadj] = ACTIONS(3613),
    [anon_sym_lineadj] = ACTIONS(3613),
    [anon_sym_triangle] = ACTIONS(3613),
    [anon_sym_cbuffer] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_extension] = ACTIONS(3613),
  },
  [512] = {
    [sym_identifier] = ACTIONS(3613),
    [aux_sym_preproc_include_token1] = ACTIONS(3613),
    [aux_sym_preproc_def_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token2] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3613),
    [aux_sym_preproc_else_token1] = ACTIONS(3613),
    [aux_sym_preproc_elif_token1] = ACTIONS(3613),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3613),
    [sym_preproc_directive] = ACTIONS(3613),
    [anon_sym_LPAREN2] = ACTIONS(3615),
    [anon_sym_BANG] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3613),
    [anon_sym_PLUS] = ACTIONS(3613),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym_SEMI] = ACTIONS(3615),
    [anon_sym___extension__] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3613),
    [anon_sym_in] = ACTIONS(3613),
    [anon_sym_out] = ACTIONS(3613),
    [anon_sym_inout] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym___attribute__] = ACTIONS(3613),
    [anon_sym_COLON_COLON] = ACTIONS(3615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3615),
    [anon_sym___declspec] = ACTIONS(3613),
    [anon_sym___based] = ACTIONS(3613),
    [anon_sym___cdecl] = ACTIONS(3613),
    [anon_sym___clrcall] = ACTIONS(3613),
    [anon_sym___stdcall] = ACTIONS(3613),
    [anon_sym___fastcall] = ACTIONS(3613),
    [anon_sym___thiscall] = ACTIONS(3613),
    [anon_sym___vectorcall] = ACTIONS(3613),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_signed] = ACTIONS(3613),
    [anon_sym_unsigned] = ACTIONS(3613),
    [anon_sym_long] = ACTIONS(3613),
    [anon_sym_short] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_register] = ACTIONS(3613),
    [anon_sym_inline] = ACTIONS(3613),
    [anon_sym___inline] = ACTIONS(3613),
    [anon_sym___inline__] = ACTIONS(3613),
    [anon_sym___forceinline] = ACTIONS(3613),
    [anon_sym_thread_local] = ACTIONS(3613),
    [anon_sym___thread] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_constexpr] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_restrict] = ACTIONS(3613),
    [anon_sym___restrict__] = ACTIONS(3613),
    [anon_sym__Atomic] = ACTIONS(3613),
    [anon_sym__Noreturn] = ACTIONS(3613),
    [anon_sym_noreturn] = ACTIONS(3613),
    [anon_sym_mutable] = ACTIONS(3613),
    [anon_sym_constinit] = ACTIONS(3613),
    [anon_sym_consteval] = ACTIONS(3613),
    [anon_sym_alignas] = ACTIONS(3613),
    [anon_sym__Alignas] = ACTIONS(3613),
    [sym_primitive_type] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_union] = ACTIONS(3613),
    [anon_sym_if] = ACTIONS(3613),
    [anon_sym_switch] = ACTIONS(3613),
    [anon_sym_case] = ACTIONS(3613),
    [anon_sym_default] = ACTIONS(3613),
    [anon_sym_while] = ACTIONS(3613),
    [anon_sym_do] = ACTIONS(3613),
    [anon_sym_for] = ACTIONS(3613),
    [anon_sym_return] = ACTIONS(3613),
    [anon_sym_break] = ACTIONS(3613),
    [anon_sym_continue] = ACTIONS(3613),
    [anon_sym_goto] = ACTIONS(3613),
    [anon_sym___try] = ACTIONS(3613),
    [anon_sym___leave] = ACTIONS(3613),
    [anon_sym_not] = ACTIONS(3613),
    [anon_sym_compl] = ACTIONS(3613),
    [anon_sym_DASH_DASH] = ACTIONS(3615),
    [anon_sym_PLUS_PLUS] = ACTIONS(3615),
    [anon_sym_sizeof] = ACTIONS(3613),
    [anon_sym___alignof__] = ACTIONS(3613),
    [anon_sym___alignof] = ACTIONS(3613),
    [anon_sym__alignof] = ACTIONS(3613),
    [anon_sym_alignof] = ACTIONS(3613),
    [anon_sym__Alignof] = ACTIONS(3613),
    [anon_sym_offsetof] = ACTIONS(3613),
    [anon_sym__Generic] = ACTIONS(3613),
    [anon_sym_asm] = ACTIONS(3613),
    [anon_sym___asm__] = ACTIONS(3613),
    [sym_number_literal] = ACTIONS(3615),
    [anon_sym_L_SQUOTE] = ACTIONS(3615),
    [anon_sym_u_SQUOTE] = ACTIONS(3615),
    [anon_sym_U_SQUOTE] = ACTIONS(3615),
    [anon_sym_u8_SQUOTE] = ACTIONS(3615),
    [anon_sym_SQUOTE] = ACTIONS(3615),
    [anon_sym_L_DQUOTE] = ACTIONS(3615),
    [anon_sym_u_DQUOTE] = ACTIONS(3615),
    [anon_sym_U_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8_DQUOTE] = ACTIONS(3615),
    [anon_sym_DQUOTE] = ACTIONS(3615),
    [sym_true] = ACTIONS(3613),
    [sym_false] = ACTIONS(3613),
    [anon_sym_NULL] = ACTIONS(3613),
    [anon_sym_nullptr] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_This] = ACTIONS(3613),
    [anon_sym_decltype] = ACTIONS(3613),
    [sym_virtual] = ACTIONS(3613),
    [anon_sym_explicit] = ACTIONS(3613),
    [anon_sym_typename] = ACTIONS(3613),
    [anon_sym_template] = ACTIONS(3613),
    [anon_sym_operator] = ACTIONS(3613),
    [anon_sym_try] = ACTIONS(3613),
    [anon_sym_delete] = ACTIONS(3613),
    [anon_sym_throw] = ACTIONS(3613),
    [anon_sym_namespace] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_static_assert] = ACTIONS(3613),
    [anon_sym_concept] = ACTIONS(3613),
    [anon_sym_co_return] = ACTIONS(3613),
    [anon_sym_co_yield] = ACTIONS(3613),
    [anon_sym_R_DQUOTE] = ACTIONS(3615),
    [anon_sym_LR_DQUOTE] = ACTIONS(3615),
    [anon_sym_uR_DQUOTE] = ACTIONS(3615),
    [anon_sym_UR_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3615),
    [anon_sym_co_await] = ACTIONS(3613),
    [anon_sym_new] = ACTIONS(3613),
    [anon_sym_requires] = ACTIONS(3613),
    [sym_this] = ACTIONS(3613),
    [anon_sym_discard] = ACTIONS(3613),
    [anon_sym_precise] = ACTIONS(3613),
    [anon_sym_shared] = ACTIONS(3613),
    [anon_sym_groupshared] = ACTIONS(3613),
    [anon_sym_uniform] = ACTIONS(3613),
    [anon_sym_row_major] = ACTIONS(3613),
    [anon_sym_column_major] = ACTIONS(3613),
    [anon_sym_globallycoherent] = ACTIONS(3613),
    [anon_sym_centroid] = ACTIONS(3613),
    [anon_sym_noperspective] = ACTIONS(3613),
    [anon_sym_nointerpolation] = ACTIONS(3613),
    [anon_sym_sample] = ACTIONS(3613),
    [anon_sym_linear] = ACTIONS(3613),
    [anon_sym_snorm] = ACTIONS(3613),
    [anon_sym_unorm] = ACTIONS(3613),
    [anon_sym_point] = ACTIONS(3613),
    [anon_sym_line] = ACTIONS(3613),
    [anon_sym_triangleadj] = ACTIONS(3613),
    [anon_sym_lineadj] = ACTIONS(3613),
    [anon_sym_triangle] = ACTIONS(3613),
    [anon_sym_cbuffer] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_extension] = ACTIONS(3613),
  },
  [513] = {
    [sym_identifier] = ACTIONS(3497),
    [aux_sym_preproc_include_token1] = ACTIONS(3497),
    [aux_sym_preproc_def_token1] = ACTIONS(3497),
    [aux_sym_preproc_if_token1] = ACTIONS(3497),
    [aux_sym_preproc_if_token2] = ACTIONS(3497),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3497),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3497),
    [aux_sym_preproc_else_token1] = ACTIONS(3497),
    [aux_sym_preproc_elif_token1] = ACTIONS(3497),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3497),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3497),
    [sym_preproc_directive] = ACTIONS(3497),
    [anon_sym_LPAREN2] = ACTIONS(3499),
    [anon_sym_BANG] = ACTIONS(3499),
    [anon_sym_TILDE] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_STAR] = ACTIONS(3499),
    [anon_sym_AMP_AMP] = ACTIONS(3499),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym_SEMI] = ACTIONS(3499),
    [anon_sym___extension__] = ACTIONS(3497),
    [anon_sym_typedef] = ACTIONS(3497),
    [anon_sym_in] = ACTIONS(3497),
    [anon_sym_out] = ACTIONS(3497),
    [anon_sym_inout] = ACTIONS(3497),
    [anon_sym_extern] = ACTIONS(3497),
    [anon_sym___attribute__] = ACTIONS(3497),
    [anon_sym_COLON_COLON] = ACTIONS(3499),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3499),
    [anon_sym___declspec] = ACTIONS(3497),
    [anon_sym___based] = ACTIONS(3497),
    [anon_sym___cdecl] = ACTIONS(3497),
    [anon_sym___clrcall] = ACTIONS(3497),
    [anon_sym___stdcall] = ACTIONS(3497),
    [anon_sym___fastcall] = ACTIONS(3497),
    [anon_sym___thiscall] = ACTIONS(3497),
    [anon_sym___vectorcall] = ACTIONS(3497),
    [anon_sym_LBRACE] = ACTIONS(3499),
    [anon_sym_signed] = ACTIONS(3497),
    [anon_sym_unsigned] = ACTIONS(3497),
    [anon_sym_long] = ACTIONS(3497),
    [anon_sym_short] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3497),
    [anon_sym_static] = ACTIONS(3497),
    [anon_sym_register] = ACTIONS(3497),
    [anon_sym_inline] = ACTIONS(3497),
    [anon_sym___inline] = ACTIONS(3497),
    [anon_sym___inline__] = ACTIONS(3497),
    [anon_sym___forceinline] = ACTIONS(3497),
    [anon_sym_thread_local] = ACTIONS(3497),
    [anon_sym___thread] = ACTIONS(3497),
    [anon_sym_const] = ACTIONS(3497),
    [anon_sym_constexpr] = ACTIONS(3497),
    [anon_sym_volatile] = ACTIONS(3497),
    [anon_sym_restrict] = ACTIONS(3497),
    [anon_sym___restrict__] = ACTIONS(3497),
    [anon_sym__Atomic] = ACTIONS(3497),
    [anon_sym__Noreturn] = ACTIONS(3497),
    [anon_sym_noreturn] = ACTIONS(3497),
    [anon_sym_mutable] = ACTIONS(3497),
    [anon_sym_constinit] = ACTIONS(3497),
    [anon_sym_consteval] = ACTIONS(3497),
    [anon_sym_alignas] = ACTIONS(3497),
    [anon_sym__Alignas] = ACTIONS(3497),
    [sym_primitive_type] = ACTIONS(3497),
    [anon_sym_enum] = ACTIONS(3497),
    [anon_sym_class] = ACTIONS(3497),
    [anon_sym_struct] = ACTIONS(3497),
    [anon_sym_union] = ACTIONS(3497),
    [anon_sym_if] = ACTIONS(3497),
    [anon_sym_switch] = ACTIONS(3497),
    [anon_sym_case] = ACTIONS(3497),
    [anon_sym_default] = ACTIONS(3497),
    [anon_sym_while] = ACTIONS(3497),
    [anon_sym_do] = ACTIONS(3497),
    [anon_sym_for] = ACTIONS(3497),
    [anon_sym_return] = ACTIONS(3497),
    [anon_sym_break] = ACTIONS(3497),
    [anon_sym_continue] = ACTIONS(3497),
    [anon_sym_goto] = ACTIONS(3497),
    [anon_sym___try] = ACTIONS(3497),
    [anon_sym___leave] = ACTIONS(3497),
    [anon_sym_not] = ACTIONS(3497),
    [anon_sym_compl] = ACTIONS(3497),
    [anon_sym_DASH_DASH] = ACTIONS(3499),
    [anon_sym_PLUS_PLUS] = ACTIONS(3499),
    [anon_sym_sizeof] = ACTIONS(3497),
    [anon_sym___alignof__] = ACTIONS(3497),
    [anon_sym___alignof] = ACTIONS(3497),
    [anon_sym__alignof] = ACTIONS(3497),
    [anon_sym_alignof] = ACTIONS(3497),
    [anon_sym__Alignof] = ACTIONS(3497),
    [anon_sym_offsetof] = ACTIONS(3497),
    [anon_sym__Generic] = ACTIONS(3497),
    [anon_sym_asm] = ACTIONS(3497),
    [anon_sym___asm__] = ACTIONS(3497),
    [sym_number_literal] = ACTIONS(3499),
    [anon_sym_L_SQUOTE] = ACTIONS(3499),
    [anon_sym_u_SQUOTE] = ACTIONS(3499),
    [anon_sym_U_SQUOTE] = ACTIONS(3499),
    [anon_sym_u8_SQUOTE] = ACTIONS(3499),
    [anon_sym_SQUOTE] = ACTIONS(3499),
    [anon_sym_L_DQUOTE] = ACTIONS(3499),
    [anon_sym_u_DQUOTE] = ACTIONS(3499),
    [anon_sym_U_DQUOTE] = ACTIONS(3499),
    [anon_sym_u8_DQUOTE] = ACTIONS(3499),
    [anon_sym_DQUOTE] = ACTIONS(3499),
    [sym_true] = ACTIONS(3497),
    [sym_false] = ACTIONS(3497),
    [anon_sym_NULL] = ACTIONS(3497),
    [anon_sym_nullptr] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3497),
    [anon_sym_let] = ACTIONS(3497),
    [anon_sym_This] = ACTIONS(3497),
    [anon_sym_decltype] = ACTIONS(3497),
    [sym_virtual] = ACTIONS(3497),
    [anon_sym_explicit] = ACTIONS(3497),
    [anon_sym_typename] = ACTIONS(3497),
    [anon_sym_template] = ACTIONS(3497),
    [anon_sym_operator] = ACTIONS(3497),
    [anon_sym_try] = ACTIONS(3497),
    [anon_sym_delete] = ACTIONS(3497),
    [anon_sym_throw] = ACTIONS(3497),
    [anon_sym_namespace] = ACTIONS(3497),
    [anon_sym_using] = ACTIONS(3497),
    [anon_sym_static_assert] = ACTIONS(3497),
    [anon_sym_concept] = ACTIONS(3497),
    [anon_sym_co_return] = ACTIONS(3497),
    [anon_sym_co_yield] = ACTIONS(3497),
    [anon_sym_R_DQUOTE] = ACTIONS(3499),
    [anon_sym_LR_DQUOTE] = ACTIONS(3499),
    [anon_sym_uR_DQUOTE] = ACTIONS(3499),
    [anon_sym_UR_DQUOTE] = ACTIONS(3499),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3499),
    [anon_sym_co_await] = ACTIONS(3497),
    [anon_sym_new] = ACTIONS(3497),
    [anon_sym_requires] = ACTIONS(3497),
    [sym_this] = ACTIONS(3497),
    [anon_sym_discard] = ACTIONS(3497),
    [anon_sym_precise] = ACTIONS(3497),
    [anon_sym_shared] = ACTIONS(3497),
    [anon_sym_groupshared] = ACTIONS(3497),
    [anon_sym_uniform] = ACTIONS(3497),
    [anon_sym_row_major] = ACTIONS(3497),
    [anon_sym_column_major] = ACTIONS(3497),
    [anon_sym_globallycoherent] = ACTIONS(3497),
    [anon_sym_centroid] = ACTIONS(3497),
    [anon_sym_noperspective] = ACTIONS(3497),
    [anon_sym_nointerpolation] = ACTIONS(3497),
    [anon_sym_sample] = ACTIONS(3497),
    [anon_sym_linear] = ACTIONS(3497),
    [anon_sym_snorm] = ACTIONS(3497),
    [anon_sym_unorm] = ACTIONS(3497),
    [anon_sym_point] = ACTIONS(3497),
    [anon_sym_line] = ACTIONS(3497),
    [anon_sym_triangleadj] = ACTIONS(3497),
    [anon_sym_lineadj] = ACTIONS(3497),
    [anon_sym_triangle] = ACTIONS(3497),
    [anon_sym_cbuffer] = ACTIONS(3497),
    [anon_sym_interface] = ACTIONS(3497),
    [anon_sym_extension] = ACTIONS(3497),
  },
  [514] = {
    [sym_identifier] = ACTIONS(2256),
    [aux_sym_preproc_include_token1] = ACTIONS(2256),
    [aux_sym_preproc_def_token1] = ACTIONS(2256),
    [aux_sym_preproc_if_token1] = ACTIONS(2256),
    [aux_sym_preproc_if_token2] = ACTIONS(2256),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2256),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2256),
    [sym_preproc_directive] = ACTIONS(2256),
    [anon_sym_LPAREN2] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [anon_sym_DASH] = ACTIONS(2256),
    [anon_sym_PLUS] = ACTIONS(2256),
    [anon_sym_STAR] = ACTIONS(2258),
    [anon_sym_AMP_AMP] = ACTIONS(2258),
    [anon_sym_AMP] = ACTIONS(2256),
    [anon_sym_COLON] = ACTIONS(2256),
    [anon_sym_SEMI] = ACTIONS(2258),
    [anon_sym___extension__] = ACTIONS(2256),
    [anon_sym_typedef] = ACTIONS(2256),
    [anon_sym_in] = ACTIONS(2256),
    [anon_sym_out] = ACTIONS(2256),
    [anon_sym_inout] = ACTIONS(2256),
    [anon_sym_extern] = ACTIONS(2256),
    [anon_sym___attribute__] = ACTIONS(2256),
    [anon_sym_COLON_COLON] = ACTIONS(2258),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2258),
    [anon_sym___declspec] = ACTIONS(2256),
    [anon_sym___based] = ACTIONS(2256),
    [anon_sym___cdecl] = ACTIONS(2256),
    [anon_sym___clrcall] = ACTIONS(2256),
    [anon_sym___stdcall] = ACTIONS(2256),
    [anon_sym___fastcall] = ACTIONS(2256),
    [anon_sym___thiscall] = ACTIONS(2256),
    [anon_sym___vectorcall] = ACTIONS(2256),
    [anon_sym_LBRACE] = ACTIONS(2258),
    [anon_sym_signed] = ACTIONS(2256),
    [anon_sym_unsigned] = ACTIONS(2256),
    [anon_sym_long] = ACTIONS(2256),
    [anon_sym_short] = ACTIONS(2256),
    [anon_sym_LBRACK] = ACTIONS(2256),
    [anon_sym_static] = ACTIONS(2256),
    [anon_sym_register] = ACTIONS(2256),
    [anon_sym_inline] = ACTIONS(2256),
    [anon_sym___inline] = ACTIONS(2256),
    [anon_sym___inline__] = ACTIONS(2256),
    [anon_sym___forceinline] = ACTIONS(2256),
    [anon_sym_thread_local] = ACTIONS(2256),
    [anon_sym___thread] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_constexpr] = ACTIONS(2256),
    [anon_sym_volatile] = ACTIONS(2256),
    [anon_sym_restrict] = ACTIONS(2256),
    [anon_sym___restrict__] = ACTIONS(2256),
    [anon_sym__Atomic] = ACTIONS(2256),
    [anon_sym__Noreturn] = ACTIONS(2256),
    [anon_sym_noreturn] = ACTIONS(2256),
    [anon_sym_mutable] = ACTIONS(2256),
    [anon_sym_constinit] = ACTIONS(2256),
    [anon_sym_consteval] = ACTIONS(2256),
    [anon_sym_alignas] = ACTIONS(2256),
    [anon_sym__Alignas] = ACTIONS(2256),
    [sym_primitive_type] = ACTIONS(2256),
    [anon_sym_enum] = ACTIONS(2256),
    [anon_sym_class] = ACTIONS(2256),
    [anon_sym_struct] = ACTIONS(2256),
    [anon_sym_union] = ACTIONS(2256),
    [anon_sym_if] = ACTIONS(2256),
    [anon_sym_else] = ACTIONS(2256),
    [anon_sym_switch] = ACTIONS(2256),
    [anon_sym_case] = ACTIONS(2256),
    [anon_sym_default] = ACTIONS(2256),
    [anon_sym_while] = ACTIONS(2256),
    [anon_sym_do] = ACTIONS(2256),
    [anon_sym_for] = ACTIONS(2256),
    [anon_sym_return] = ACTIONS(2256),
    [anon_sym_break] = ACTIONS(2256),
    [anon_sym_continue] = ACTIONS(2256),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym___try] = ACTIONS(2256),
    [anon_sym___leave] = ACTIONS(2256),
    [anon_sym_not] = ACTIONS(2256),
    [anon_sym_compl] = ACTIONS(2256),
    [anon_sym_DASH_DASH] = ACTIONS(2258),
    [anon_sym_PLUS_PLUS] = ACTIONS(2258),
    [anon_sym_sizeof] = ACTIONS(2256),
    [anon_sym___alignof__] = ACTIONS(2256),
    [anon_sym___alignof] = ACTIONS(2256),
    [anon_sym__alignof] = ACTIONS(2256),
    [anon_sym_alignof] = ACTIONS(2256),
    [anon_sym__Alignof] = ACTIONS(2256),
    [anon_sym_offsetof] = ACTIONS(2256),
    [anon_sym__Generic] = ACTIONS(2256),
    [anon_sym_asm] = ACTIONS(2256),
    [anon_sym___asm__] = ACTIONS(2256),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_L_SQUOTE] = ACTIONS(2258),
    [anon_sym_u_SQUOTE] = ACTIONS(2258),
    [anon_sym_U_SQUOTE] = ACTIONS(2258),
    [anon_sym_u8_SQUOTE] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(2258),
    [anon_sym_L_DQUOTE] = ACTIONS(2258),
    [anon_sym_u_DQUOTE] = ACTIONS(2258),
    [anon_sym_U_DQUOTE] = ACTIONS(2258),
    [anon_sym_u8_DQUOTE] = ACTIONS(2258),
    [anon_sym_DQUOTE] = ACTIONS(2258),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2256),
    [anon_sym_nullptr] = ACTIONS(2256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_This] = ACTIONS(2256),
    [anon_sym_decltype] = ACTIONS(2256),
    [anon_sym_final] = ACTIONS(2256),
    [anon_sym_override] = ACTIONS(2256),
    [sym_virtual] = ACTIONS(2256),
    [anon_sym_explicit] = ACTIONS(2256),
    [anon_sym_typename] = ACTIONS(2256),
    [anon_sym_template] = ACTIONS(2256),
    [anon_sym_operator] = ACTIONS(2256),
    [anon_sym_try] = ACTIONS(2256),
    [anon_sym_delete] = ACTIONS(2256),
    [anon_sym_throw] = ACTIONS(2256),
    [anon_sym_namespace] = ACTIONS(2256),
    [anon_sym_using] = ACTIONS(2256),
    [anon_sym_static_assert] = ACTIONS(2256),
    [anon_sym_concept] = ACTIONS(2256),
    [anon_sym_co_return] = ACTIONS(2256),
    [anon_sym_co_yield] = ACTIONS(2256),
    [anon_sym_R_DQUOTE] = ACTIONS(2258),
    [anon_sym_LR_DQUOTE] = ACTIONS(2258),
    [anon_sym_uR_DQUOTE] = ACTIONS(2258),
    [anon_sym_UR_DQUOTE] = ACTIONS(2258),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2258),
    [anon_sym_co_await] = ACTIONS(2256),
    [anon_sym_new] = ACTIONS(2256),
    [anon_sym_requires] = ACTIONS(2256),
    [sym_this] = ACTIONS(2256),
    [anon_sym_discard] = ACTIONS(2256),
    [anon_sym_precise] = ACTIONS(2256),
    [anon_sym_shared] = ACTIONS(2256),
    [anon_sym_groupshared] = ACTIONS(2256),
    [anon_sym_uniform] = ACTIONS(2256),
    [anon_sym_row_major] = ACTIONS(2256),
    [anon_sym_column_major] = ACTIONS(2256),
    [anon_sym_globallycoherent] = ACTIONS(2256),
    [anon_sym_centroid] = ACTIONS(2256),
    [anon_sym_noperspective] = ACTIONS(2256),
    [anon_sym_nointerpolation] = ACTIONS(2256),
    [anon_sym_sample] = ACTIONS(2256),
    [anon_sym_linear] = ACTIONS(2256),
    [anon_sym_snorm] = ACTIONS(2256),
    [anon_sym_unorm] = ACTIONS(2256),
    [anon_sym_point] = ACTIONS(2256),
    [anon_sym_line] = ACTIONS(2256),
    [anon_sym_triangleadj] = ACTIONS(2256),
    [anon_sym_lineadj] = ACTIONS(2256),
    [anon_sym_triangle] = ACTIONS(2256),
    [anon_sym_cbuffer] = ACTIONS(2256),
    [anon_sym_interface] = ACTIONS(2256),
    [anon_sym_extension] = ACTIONS(2256),
  },
  [515] = {
    [sym_identifier] = ACTIONS(3633),
    [aux_sym_preproc_include_token1] = ACTIONS(3633),
    [aux_sym_preproc_def_token1] = ACTIONS(3633),
    [aux_sym_preproc_if_token1] = ACTIONS(3633),
    [aux_sym_preproc_if_token2] = ACTIONS(3633),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3633),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3633),
    [aux_sym_preproc_else_token1] = ACTIONS(3633),
    [aux_sym_preproc_elif_token1] = ACTIONS(3633),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3633),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3633),
    [sym_preproc_directive] = ACTIONS(3633),
    [anon_sym_LPAREN2] = ACTIONS(3635),
    [anon_sym_BANG] = ACTIONS(3635),
    [anon_sym_TILDE] = ACTIONS(3635),
    [anon_sym_DASH] = ACTIONS(3633),
    [anon_sym_PLUS] = ACTIONS(3633),
    [anon_sym_STAR] = ACTIONS(3635),
    [anon_sym_AMP_AMP] = ACTIONS(3635),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym_SEMI] = ACTIONS(3635),
    [anon_sym___extension__] = ACTIONS(3633),
    [anon_sym_typedef] = ACTIONS(3633),
    [anon_sym_in] = ACTIONS(3633),
    [anon_sym_out] = ACTIONS(3633),
    [anon_sym_inout] = ACTIONS(3633),
    [anon_sym_extern] = ACTIONS(3633),
    [anon_sym___attribute__] = ACTIONS(3633),
    [anon_sym_COLON_COLON] = ACTIONS(3635),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3635),
    [anon_sym___declspec] = ACTIONS(3633),
    [anon_sym___based] = ACTIONS(3633),
    [anon_sym___cdecl] = ACTIONS(3633),
    [anon_sym___clrcall] = ACTIONS(3633),
    [anon_sym___stdcall] = ACTIONS(3633),
    [anon_sym___fastcall] = ACTIONS(3633),
    [anon_sym___thiscall] = ACTIONS(3633),
    [anon_sym___vectorcall] = ACTIONS(3633),
    [anon_sym_LBRACE] = ACTIONS(3635),
    [anon_sym_signed] = ACTIONS(3633),
    [anon_sym_unsigned] = ACTIONS(3633),
    [anon_sym_long] = ACTIONS(3633),
    [anon_sym_short] = ACTIONS(3633),
    [anon_sym_LBRACK] = ACTIONS(3633),
    [anon_sym_static] = ACTIONS(3633),
    [anon_sym_register] = ACTIONS(3633),
    [anon_sym_inline] = ACTIONS(3633),
    [anon_sym___inline] = ACTIONS(3633),
    [anon_sym___inline__] = ACTIONS(3633),
    [anon_sym___forceinline] = ACTIONS(3633),
    [anon_sym_thread_local] = ACTIONS(3633),
    [anon_sym___thread] = ACTIONS(3633),
    [anon_sym_const] = ACTIONS(3633),
    [anon_sym_constexpr] = ACTIONS(3633),
    [anon_sym_volatile] = ACTIONS(3633),
    [anon_sym_restrict] = ACTIONS(3633),
    [anon_sym___restrict__] = ACTIONS(3633),
    [anon_sym__Atomic] = ACTIONS(3633),
    [anon_sym__Noreturn] = ACTIONS(3633),
    [anon_sym_noreturn] = ACTIONS(3633),
    [anon_sym_mutable] = ACTIONS(3633),
    [anon_sym_constinit] = ACTIONS(3633),
    [anon_sym_consteval] = ACTIONS(3633),
    [anon_sym_alignas] = ACTIONS(3633),
    [anon_sym__Alignas] = ACTIONS(3633),
    [sym_primitive_type] = ACTIONS(3633),
    [anon_sym_enum] = ACTIONS(3633),
    [anon_sym_class] = ACTIONS(3633),
    [anon_sym_struct] = ACTIONS(3633),
    [anon_sym_union] = ACTIONS(3633),
    [anon_sym_if] = ACTIONS(3633),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_case] = ACTIONS(3633),
    [anon_sym_default] = ACTIONS(3633),
    [anon_sym_while] = ACTIONS(3633),
    [anon_sym_do] = ACTIONS(3633),
    [anon_sym_for] = ACTIONS(3633),
    [anon_sym_return] = ACTIONS(3633),
    [anon_sym_break] = ACTIONS(3633),
    [anon_sym_continue] = ACTIONS(3633),
    [anon_sym_goto] = ACTIONS(3633),
    [anon_sym___try] = ACTIONS(3633),
    [anon_sym___leave] = ACTIONS(3633),
    [anon_sym_not] = ACTIONS(3633),
    [anon_sym_compl] = ACTIONS(3633),
    [anon_sym_DASH_DASH] = ACTIONS(3635),
    [anon_sym_PLUS_PLUS] = ACTIONS(3635),
    [anon_sym_sizeof] = ACTIONS(3633),
    [anon_sym___alignof__] = ACTIONS(3633),
    [anon_sym___alignof] = ACTIONS(3633),
    [anon_sym__alignof] = ACTIONS(3633),
    [anon_sym_alignof] = ACTIONS(3633),
    [anon_sym__Alignof] = ACTIONS(3633),
    [anon_sym_offsetof] = ACTIONS(3633),
    [anon_sym__Generic] = ACTIONS(3633),
    [anon_sym_asm] = ACTIONS(3633),
    [anon_sym___asm__] = ACTIONS(3633),
    [sym_number_literal] = ACTIONS(3635),
    [anon_sym_L_SQUOTE] = ACTIONS(3635),
    [anon_sym_u_SQUOTE] = ACTIONS(3635),
    [anon_sym_U_SQUOTE] = ACTIONS(3635),
    [anon_sym_u8_SQUOTE] = ACTIONS(3635),
    [anon_sym_SQUOTE] = ACTIONS(3635),
    [anon_sym_L_DQUOTE] = ACTIONS(3635),
    [anon_sym_u_DQUOTE] = ACTIONS(3635),
    [anon_sym_U_DQUOTE] = ACTIONS(3635),
    [anon_sym_u8_DQUOTE] = ACTIONS(3635),
    [anon_sym_DQUOTE] = ACTIONS(3635),
    [sym_true] = ACTIONS(3633),
    [sym_false] = ACTIONS(3633),
    [anon_sym_NULL] = ACTIONS(3633),
    [anon_sym_nullptr] = ACTIONS(3633),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3633),
    [anon_sym_let] = ACTIONS(3633),
    [anon_sym_This] = ACTIONS(3633),
    [anon_sym_decltype] = ACTIONS(3633),
    [sym_virtual] = ACTIONS(3633),
    [anon_sym_explicit] = ACTIONS(3633),
    [anon_sym_typename] = ACTIONS(3633),
    [anon_sym_template] = ACTIONS(3633),
    [anon_sym_operator] = ACTIONS(3633),
    [anon_sym_try] = ACTIONS(3633),
    [anon_sym_delete] = ACTIONS(3633),
    [anon_sym_throw] = ACTIONS(3633),
    [anon_sym_namespace] = ACTIONS(3633),
    [anon_sym_using] = ACTIONS(3633),
    [anon_sym_static_assert] = ACTIONS(3633),
    [anon_sym_concept] = ACTIONS(3633),
    [anon_sym_co_return] = ACTIONS(3633),
    [anon_sym_co_yield] = ACTIONS(3633),
    [anon_sym_R_DQUOTE] = ACTIONS(3635),
    [anon_sym_LR_DQUOTE] = ACTIONS(3635),
    [anon_sym_uR_DQUOTE] = ACTIONS(3635),
    [anon_sym_UR_DQUOTE] = ACTIONS(3635),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3635),
    [anon_sym_co_await] = ACTIONS(3633),
    [anon_sym_new] = ACTIONS(3633),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(3633),
    [anon_sym_discard] = ACTIONS(3633),
    [anon_sym_precise] = ACTIONS(3633),
    [anon_sym_shared] = ACTIONS(3633),
    [anon_sym_groupshared] = ACTIONS(3633),
    [anon_sym_uniform] = ACTIONS(3633),
    [anon_sym_row_major] = ACTIONS(3633),
    [anon_sym_column_major] = ACTIONS(3633),
    [anon_sym_globallycoherent] = ACTIONS(3633),
    [anon_sym_centroid] = ACTIONS(3633),
    [anon_sym_noperspective] = ACTIONS(3633),
    [anon_sym_nointerpolation] = ACTIONS(3633),
    [anon_sym_sample] = ACTIONS(3633),
    [anon_sym_linear] = ACTIONS(3633),
    [anon_sym_snorm] = ACTIONS(3633),
    [anon_sym_unorm] = ACTIONS(3633),
    [anon_sym_point] = ACTIONS(3633),
    [anon_sym_line] = ACTIONS(3633),
    [anon_sym_triangleadj] = ACTIONS(3633),
    [anon_sym_lineadj] = ACTIONS(3633),
    [anon_sym_triangle] = ACTIONS(3633),
    [anon_sym_cbuffer] = ACTIONS(3633),
    [anon_sym_interface] = ACTIONS(3633),
    [anon_sym_extension] = ACTIONS(3633),
  },
  [516] = {
    [sym_identifier] = ACTIONS(2198),
    [aux_sym_preproc_include_token1] = ACTIONS(2198),
    [aux_sym_preproc_def_token1] = ACTIONS(2198),
    [aux_sym_preproc_if_token1] = ACTIONS(2198),
    [aux_sym_preproc_if_token2] = ACTIONS(2198),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2198),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2198),
    [sym_preproc_directive] = ACTIONS(2198),
    [anon_sym_LPAREN2] = ACTIONS(2200),
    [anon_sym_BANG] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(2200),
    [anon_sym_AMP_AMP] = ACTIONS(2200),
    [anon_sym_AMP] = ACTIONS(2198),
    [anon_sym_COLON] = ACTIONS(2198),
    [anon_sym_SEMI] = ACTIONS(2200),
    [anon_sym___extension__] = ACTIONS(2198),
    [anon_sym_typedef] = ACTIONS(2198),
    [anon_sym_in] = ACTIONS(2198),
    [anon_sym_out] = ACTIONS(2198),
    [anon_sym_inout] = ACTIONS(2198),
    [anon_sym_extern] = ACTIONS(2198),
    [anon_sym___attribute__] = ACTIONS(2198),
    [anon_sym_COLON_COLON] = ACTIONS(2200),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2200),
    [anon_sym___declspec] = ACTIONS(2198),
    [anon_sym___based] = ACTIONS(2198),
    [anon_sym___cdecl] = ACTIONS(2198),
    [anon_sym___clrcall] = ACTIONS(2198),
    [anon_sym___stdcall] = ACTIONS(2198),
    [anon_sym___fastcall] = ACTIONS(2198),
    [anon_sym___thiscall] = ACTIONS(2198),
    [anon_sym___vectorcall] = ACTIONS(2198),
    [anon_sym_LBRACE] = ACTIONS(2200),
    [anon_sym_signed] = ACTIONS(2198),
    [anon_sym_unsigned] = ACTIONS(2198),
    [anon_sym_long] = ACTIONS(2198),
    [anon_sym_short] = ACTIONS(2198),
    [anon_sym_LBRACK] = ACTIONS(2198),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_register] = ACTIONS(2198),
    [anon_sym_inline] = ACTIONS(2198),
    [anon_sym___inline] = ACTIONS(2198),
    [anon_sym___inline__] = ACTIONS(2198),
    [anon_sym___forceinline] = ACTIONS(2198),
    [anon_sym_thread_local] = ACTIONS(2198),
    [anon_sym___thread] = ACTIONS(2198),
    [anon_sym_const] = ACTIONS(2198),
    [anon_sym_constexpr] = ACTIONS(2198),
    [anon_sym_volatile] = ACTIONS(2198),
    [anon_sym_restrict] = ACTIONS(2198),
    [anon_sym___restrict__] = ACTIONS(2198),
    [anon_sym__Atomic] = ACTIONS(2198),
    [anon_sym__Noreturn] = ACTIONS(2198),
    [anon_sym_noreturn] = ACTIONS(2198),
    [anon_sym_mutable] = ACTIONS(2198),
    [anon_sym_constinit] = ACTIONS(2198),
    [anon_sym_consteval] = ACTIONS(2198),
    [anon_sym_alignas] = ACTIONS(2198),
    [anon_sym__Alignas] = ACTIONS(2198),
    [sym_primitive_type] = ACTIONS(2198),
    [anon_sym_enum] = ACTIONS(2198),
    [anon_sym_class] = ACTIONS(2198),
    [anon_sym_struct] = ACTIONS(2198),
    [anon_sym_union] = ACTIONS(2198),
    [anon_sym_if] = ACTIONS(2198),
    [anon_sym_else] = ACTIONS(2198),
    [anon_sym_switch] = ACTIONS(2198),
    [anon_sym_case] = ACTIONS(2198),
    [anon_sym_default] = ACTIONS(2198),
    [anon_sym_while] = ACTIONS(2198),
    [anon_sym_do] = ACTIONS(2198),
    [anon_sym_for] = ACTIONS(2198),
    [anon_sym_return] = ACTIONS(2198),
    [anon_sym_break] = ACTIONS(2198),
    [anon_sym_continue] = ACTIONS(2198),
    [anon_sym_goto] = ACTIONS(2198),
    [anon_sym___try] = ACTIONS(2198),
    [anon_sym___leave] = ACTIONS(2198),
    [anon_sym_not] = ACTIONS(2198),
    [anon_sym_compl] = ACTIONS(2198),
    [anon_sym_DASH_DASH] = ACTIONS(2200),
    [anon_sym_PLUS_PLUS] = ACTIONS(2200),
    [anon_sym_sizeof] = ACTIONS(2198),
    [anon_sym___alignof__] = ACTIONS(2198),
    [anon_sym___alignof] = ACTIONS(2198),
    [anon_sym__alignof] = ACTIONS(2198),
    [anon_sym_alignof] = ACTIONS(2198),
    [anon_sym__Alignof] = ACTIONS(2198),
    [anon_sym_offsetof] = ACTIONS(2198),
    [anon_sym__Generic] = ACTIONS(2198),
    [anon_sym_asm] = ACTIONS(2198),
    [anon_sym___asm__] = ACTIONS(2198),
    [sym_number_literal] = ACTIONS(2200),
    [anon_sym_L_SQUOTE] = ACTIONS(2200),
    [anon_sym_u_SQUOTE] = ACTIONS(2200),
    [anon_sym_U_SQUOTE] = ACTIONS(2200),
    [anon_sym_u8_SQUOTE] = ACTIONS(2200),
    [anon_sym_SQUOTE] = ACTIONS(2200),
    [anon_sym_L_DQUOTE] = ACTIONS(2200),
    [anon_sym_u_DQUOTE] = ACTIONS(2200),
    [anon_sym_U_DQUOTE] = ACTIONS(2200),
    [anon_sym_u8_DQUOTE] = ACTIONS(2200),
    [anon_sym_DQUOTE] = ACTIONS(2200),
    [sym_true] = ACTIONS(2198),
    [sym_false] = ACTIONS(2198),
    [anon_sym_NULL] = ACTIONS(2198),
    [anon_sym_nullptr] = ACTIONS(2198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2198),
    [anon_sym_let] = ACTIONS(2198),
    [anon_sym_This] = ACTIONS(2198),
    [anon_sym_decltype] = ACTIONS(2198),
    [anon_sym_final] = ACTIONS(2198),
    [anon_sym_override] = ACTIONS(2198),
    [sym_virtual] = ACTIONS(2198),
    [anon_sym_explicit] = ACTIONS(2198),
    [anon_sym_typename] = ACTIONS(2198),
    [anon_sym_template] = ACTIONS(2198),
    [anon_sym_operator] = ACTIONS(2198),
    [anon_sym_try] = ACTIONS(2198),
    [anon_sym_delete] = ACTIONS(2198),
    [anon_sym_throw] = ACTIONS(2198),
    [anon_sym_namespace] = ACTIONS(2198),
    [anon_sym_using] = ACTIONS(2198),
    [anon_sym_static_assert] = ACTIONS(2198),
    [anon_sym_concept] = ACTIONS(2198),
    [anon_sym_co_return] = ACTIONS(2198),
    [anon_sym_co_yield] = ACTIONS(2198),
    [anon_sym_R_DQUOTE] = ACTIONS(2200),
    [anon_sym_LR_DQUOTE] = ACTIONS(2200),
    [anon_sym_uR_DQUOTE] = ACTIONS(2200),
    [anon_sym_UR_DQUOTE] = ACTIONS(2200),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2200),
    [anon_sym_co_await] = ACTIONS(2198),
    [anon_sym_new] = ACTIONS(2198),
    [anon_sym_requires] = ACTIONS(2198),
    [sym_this] = ACTIONS(2198),
    [anon_sym_discard] = ACTIONS(2198),
    [anon_sym_precise] = ACTIONS(2198),
    [anon_sym_shared] = ACTIONS(2198),
    [anon_sym_groupshared] = ACTIONS(2198),
    [anon_sym_uniform] = ACTIONS(2198),
    [anon_sym_row_major] = ACTIONS(2198),
    [anon_sym_column_major] = ACTIONS(2198),
    [anon_sym_globallycoherent] = ACTIONS(2198),
    [anon_sym_centroid] = ACTIONS(2198),
    [anon_sym_noperspective] = ACTIONS(2198),
    [anon_sym_nointerpolation] = ACTIONS(2198),
    [anon_sym_sample] = ACTIONS(2198),
    [anon_sym_linear] = ACTIONS(2198),
    [anon_sym_snorm] = ACTIONS(2198),
    [anon_sym_unorm] = ACTIONS(2198),
    [anon_sym_point] = ACTIONS(2198),
    [anon_sym_line] = ACTIONS(2198),
    [anon_sym_triangleadj] = ACTIONS(2198),
    [anon_sym_lineadj] = ACTIONS(2198),
    [anon_sym_triangle] = ACTIONS(2198),
    [anon_sym_cbuffer] = ACTIONS(2198),
    [anon_sym_interface] = ACTIONS(2198),
    [anon_sym_extension] = ACTIONS(2198),
  },
  [517] = {
    [sym_identifier] = ACTIONS(2186),
    [aux_sym_preproc_include_token1] = ACTIONS(2186),
    [aux_sym_preproc_def_token1] = ACTIONS(2186),
    [aux_sym_preproc_if_token1] = ACTIONS(2186),
    [aux_sym_preproc_if_token2] = ACTIONS(2186),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2186),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2186),
    [sym_preproc_directive] = ACTIONS(2186),
    [anon_sym_LPAREN2] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2188),
    [anon_sym_TILDE] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2186),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_STAR] = ACTIONS(2188),
    [anon_sym_AMP_AMP] = ACTIONS(2188),
    [anon_sym_AMP] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym___extension__] = ACTIONS(2186),
    [anon_sym_typedef] = ACTIONS(2186),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_out] = ACTIONS(2186),
    [anon_sym_inout] = ACTIONS(2186),
    [anon_sym_extern] = ACTIONS(2186),
    [anon_sym___attribute__] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2188),
    [anon_sym___declspec] = ACTIONS(2186),
    [anon_sym___based] = ACTIONS(2186),
    [anon_sym___cdecl] = ACTIONS(2186),
    [anon_sym___clrcall] = ACTIONS(2186),
    [anon_sym___stdcall] = ACTIONS(2186),
    [anon_sym___fastcall] = ACTIONS(2186),
    [anon_sym___thiscall] = ACTIONS(2186),
    [anon_sym___vectorcall] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_signed] = ACTIONS(2186),
    [anon_sym_unsigned] = ACTIONS(2186),
    [anon_sym_long] = ACTIONS(2186),
    [anon_sym_short] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_static] = ACTIONS(2186),
    [anon_sym_register] = ACTIONS(2186),
    [anon_sym_inline] = ACTIONS(2186),
    [anon_sym___inline] = ACTIONS(2186),
    [anon_sym___inline__] = ACTIONS(2186),
    [anon_sym___forceinline] = ACTIONS(2186),
    [anon_sym_thread_local] = ACTIONS(2186),
    [anon_sym___thread] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_constexpr] = ACTIONS(2186),
    [anon_sym_volatile] = ACTIONS(2186),
    [anon_sym_restrict] = ACTIONS(2186),
    [anon_sym___restrict__] = ACTIONS(2186),
    [anon_sym__Atomic] = ACTIONS(2186),
    [anon_sym__Noreturn] = ACTIONS(2186),
    [anon_sym_noreturn] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_constinit] = ACTIONS(2186),
    [anon_sym_consteval] = ACTIONS(2186),
    [anon_sym_alignas] = ACTIONS(2186),
    [anon_sym__Alignas] = ACTIONS(2186),
    [sym_primitive_type] = ACTIONS(2186),
    [anon_sym_enum] = ACTIONS(2186),
    [anon_sym_class] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_union] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_switch] = ACTIONS(2186),
    [anon_sym_case] = ACTIONS(2186),
    [anon_sym_default] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [anon_sym_do] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_break] = ACTIONS(2186),
    [anon_sym_continue] = ACTIONS(2186),
    [anon_sym_goto] = ACTIONS(2186),
    [anon_sym___try] = ACTIONS(2186),
    [anon_sym___leave] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2186),
    [anon_sym_compl] = ACTIONS(2186),
    [anon_sym_DASH_DASH] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2188),
    [anon_sym_sizeof] = ACTIONS(2186),
    [anon_sym___alignof__] = ACTIONS(2186),
    [anon_sym___alignof] = ACTIONS(2186),
    [anon_sym__alignof] = ACTIONS(2186),
    [anon_sym_alignof] = ACTIONS(2186),
    [anon_sym__Alignof] = ACTIONS(2186),
    [anon_sym_offsetof] = ACTIONS(2186),
    [anon_sym__Generic] = ACTIONS(2186),
    [anon_sym_asm] = ACTIONS(2186),
    [anon_sym___asm__] = ACTIONS(2186),
    [sym_number_literal] = ACTIONS(2188),
    [anon_sym_L_SQUOTE] = ACTIONS(2188),
    [anon_sym_u_SQUOTE] = ACTIONS(2188),
    [anon_sym_U_SQUOTE] = ACTIONS(2188),
    [anon_sym_u8_SQUOTE] = ACTIONS(2188),
    [anon_sym_SQUOTE] = ACTIONS(2188),
    [anon_sym_L_DQUOTE] = ACTIONS(2188),
    [anon_sym_u_DQUOTE] = ACTIONS(2188),
    [anon_sym_U_DQUOTE] = ACTIONS(2188),
    [anon_sym_u8_DQUOTE] = ACTIONS(2188),
    [anon_sym_DQUOTE] = ACTIONS(2188),
    [sym_true] = ACTIONS(2186),
    [sym_false] = ACTIONS(2186),
    [anon_sym_NULL] = ACTIONS(2186),
    [anon_sym_nullptr] = ACTIONS(2186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_This] = ACTIONS(2186),
    [anon_sym_decltype] = ACTIONS(2186),
    [anon_sym_final] = ACTIONS(2186),
    [anon_sym_override] = ACTIONS(2186),
    [sym_virtual] = ACTIONS(2186),
    [anon_sym_explicit] = ACTIONS(2186),
    [anon_sym_typename] = ACTIONS(2186),
    [anon_sym_template] = ACTIONS(2186),
    [anon_sym_operator] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_delete] = ACTIONS(2186),
    [anon_sym_throw] = ACTIONS(2186),
    [anon_sym_namespace] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_static_assert] = ACTIONS(2186),
    [anon_sym_concept] = ACTIONS(2186),
    [anon_sym_co_return] = ACTIONS(2186),
    [anon_sym_co_yield] = ACTIONS(2186),
    [anon_sym_R_DQUOTE] = ACTIONS(2188),
    [anon_sym_LR_DQUOTE] = ACTIONS(2188),
    [anon_sym_uR_DQUOTE] = ACTIONS(2188),
    [anon_sym_UR_DQUOTE] = ACTIONS(2188),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2188),
    [anon_sym_co_await] = ACTIONS(2186),
    [anon_sym_new] = ACTIONS(2186),
    [anon_sym_requires] = ACTIONS(2186),
    [sym_this] = ACTIONS(2186),
    [anon_sym_discard] = ACTIONS(2186),
    [anon_sym_precise] = ACTIONS(2186),
    [anon_sym_shared] = ACTIONS(2186),
    [anon_sym_groupshared] = ACTIONS(2186),
    [anon_sym_uniform] = ACTIONS(2186),
    [anon_sym_row_major] = ACTIONS(2186),
    [anon_sym_column_major] = ACTIONS(2186),
    [anon_sym_globallycoherent] = ACTIONS(2186),
    [anon_sym_centroid] = ACTIONS(2186),
    [anon_sym_noperspective] = ACTIONS(2186),
    [anon_sym_nointerpolation] = ACTIONS(2186),
    [anon_sym_sample] = ACTIONS(2186),
    [anon_sym_linear] = ACTIONS(2186),
    [anon_sym_snorm] = ACTIONS(2186),
    [anon_sym_unorm] = ACTIONS(2186),
    [anon_sym_point] = ACTIONS(2186),
    [anon_sym_line] = ACTIONS(2186),
    [anon_sym_triangleadj] = ACTIONS(2186),
    [anon_sym_lineadj] = ACTIONS(2186),
    [anon_sym_triangle] = ACTIONS(2186),
    [anon_sym_cbuffer] = ACTIONS(2186),
    [anon_sym_interface] = ACTIONS(2186),
    [anon_sym_extension] = ACTIONS(2186),
  },
  [518] = {
    [sym_identifier] = ACTIONS(2224),
    [aux_sym_preproc_include_token1] = ACTIONS(2224),
    [aux_sym_preproc_def_token1] = ACTIONS(2224),
    [aux_sym_preproc_if_token1] = ACTIONS(2224),
    [aux_sym_preproc_if_token2] = ACTIONS(2224),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2224),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2224),
    [sym_preproc_directive] = ACTIONS(2224),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_BANG] = ACTIONS(2226),
    [anon_sym_TILDE] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_PLUS] = ACTIONS(2224),
    [anon_sym_STAR] = ACTIONS(2226),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_AMP] = ACTIONS(2224),
    [anon_sym_COLON] = ACTIONS(2224),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym___extension__] = ACTIONS(2224),
    [anon_sym_typedef] = ACTIONS(2224),
    [anon_sym_in] = ACTIONS(2224),
    [anon_sym_out] = ACTIONS(2224),
    [anon_sym_inout] = ACTIONS(2224),
    [anon_sym_extern] = ACTIONS(2224),
    [anon_sym___attribute__] = ACTIONS(2224),
    [anon_sym_COLON_COLON] = ACTIONS(2226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2226),
    [anon_sym___declspec] = ACTIONS(2224),
    [anon_sym___based] = ACTIONS(2224),
    [anon_sym___cdecl] = ACTIONS(2224),
    [anon_sym___clrcall] = ACTIONS(2224),
    [anon_sym___stdcall] = ACTIONS(2224),
    [anon_sym___fastcall] = ACTIONS(2224),
    [anon_sym___thiscall] = ACTIONS(2224),
    [anon_sym___vectorcall] = ACTIONS(2224),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_signed] = ACTIONS(2224),
    [anon_sym_unsigned] = ACTIONS(2224),
    [anon_sym_long] = ACTIONS(2224),
    [anon_sym_short] = ACTIONS(2224),
    [anon_sym_LBRACK] = ACTIONS(2224),
    [anon_sym_static] = ACTIONS(2224),
    [anon_sym_register] = ACTIONS(2224),
    [anon_sym_inline] = ACTIONS(2224),
    [anon_sym___inline] = ACTIONS(2224),
    [anon_sym___inline__] = ACTIONS(2224),
    [anon_sym___forceinline] = ACTIONS(2224),
    [anon_sym_thread_local] = ACTIONS(2224),
    [anon_sym___thread] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_constexpr] = ACTIONS(2224),
    [anon_sym_volatile] = ACTIONS(2224),
    [anon_sym_restrict] = ACTIONS(2224),
    [anon_sym___restrict__] = ACTIONS(2224),
    [anon_sym__Atomic] = ACTIONS(2224),
    [anon_sym__Noreturn] = ACTIONS(2224),
    [anon_sym_noreturn] = ACTIONS(2224),
    [anon_sym_mutable] = ACTIONS(2224),
    [anon_sym_constinit] = ACTIONS(2224),
    [anon_sym_consteval] = ACTIONS(2224),
    [anon_sym_alignas] = ACTIONS(2224),
    [anon_sym__Alignas] = ACTIONS(2224),
    [sym_primitive_type] = ACTIONS(2224),
    [anon_sym_enum] = ACTIONS(2224),
    [anon_sym_class] = ACTIONS(2224),
    [anon_sym_struct] = ACTIONS(2224),
    [anon_sym_union] = ACTIONS(2224),
    [anon_sym_if] = ACTIONS(2224),
    [anon_sym_else] = ACTIONS(2224),
    [anon_sym_switch] = ACTIONS(2224),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2224),
    [anon_sym_while] = ACTIONS(2224),
    [anon_sym_do] = ACTIONS(2224),
    [anon_sym_for] = ACTIONS(2224),
    [anon_sym_return] = ACTIONS(2224),
    [anon_sym_break] = ACTIONS(2224),
    [anon_sym_continue] = ACTIONS(2224),
    [anon_sym_goto] = ACTIONS(2224),
    [anon_sym___try] = ACTIONS(2224),
    [anon_sym___leave] = ACTIONS(2224),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_compl] = ACTIONS(2224),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_sizeof] = ACTIONS(2224),
    [anon_sym___alignof__] = ACTIONS(2224),
    [anon_sym___alignof] = ACTIONS(2224),
    [anon_sym__alignof] = ACTIONS(2224),
    [anon_sym_alignof] = ACTIONS(2224),
    [anon_sym__Alignof] = ACTIONS(2224),
    [anon_sym_offsetof] = ACTIONS(2224),
    [anon_sym__Generic] = ACTIONS(2224),
    [anon_sym_asm] = ACTIONS(2224),
    [anon_sym___asm__] = ACTIONS(2224),
    [sym_number_literal] = ACTIONS(2226),
    [anon_sym_L_SQUOTE] = ACTIONS(2226),
    [anon_sym_u_SQUOTE] = ACTIONS(2226),
    [anon_sym_U_SQUOTE] = ACTIONS(2226),
    [anon_sym_u8_SQUOTE] = ACTIONS(2226),
    [anon_sym_SQUOTE] = ACTIONS(2226),
    [anon_sym_L_DQUOTE] = ACTIONS(2226),
    [anon_sym_u_DQUOTE] = ACTIONS(2226),
    [anon_sym_U_DQUOTE] = ACTIONS(2226),
    [anon_sym_u8_DQUOTE] = ACTIONS(2226),
    [anon_sym_DQUOTE] = ACTIONS(2226),
    [sym_true] = ACTIONS(2224),
    [sym_false] = ACTIONS(2224),
    [anon_sym_NULL] = ACTIONS(2224),
    [anon_sym_nullptr] = ACTIONS(2224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2224),
    [anon_sym_let] = ACTIONS(2224),
    [anon_sym_This] = ACTIONS(2224),
    [anon_sym_decltype] = ACTIONS(2224),
    [anon_sym_final] = ACTIONS(2224),
    [anon_sym_override] = ACTIONS(2224),
    [sym_virtual] = ACTIONS(2224),
    [anon_sym_explicit] = ACTIONS(2224),
    [anon_sym_typename] = ACTIONS(2224),
    [anon_sym_template] = ACTIONS(2224),
    [anon_sym_operator] = ACTIONS(2224),
    [anon_sym_try] = ACTIONS(2224),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_throw] = ACTIONS(2224),
    [anon_sym_namespace] = ACTIONS(2224),
    [anon_sym_using] = ACTIONS(2224),
    [anon_sym_static_assert] = ACTIONS(2224),
    [anon_sym_concept] = ACTIONS(2224),
    [anon_sym_co_return] = ACTIONS(2224),
    [anon_sym_co_yield] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(2226),
    [anon_sym_LR_DQUOTE] = ACTIONS(2226),
    [anon_sym_uR_DQUOTE] = ACTIONS(2226),
    [anon_sym_UR_DQUOTE] = ACTIONS(2226),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2226),
    [anon_sym_co_await] = ACTIONS(2224),
    [anon_sym_new] = ACTIONS(2224),
    [anon_sym_requires] = ACTIONS(2224),
    [sym_this] = ACTIONS(2224),
    [anon_sym_discard] = ACTIONS(2224),
    [anon_sym_precise] = ACTIONS(2224),
    [anon_sym_shared] = ACTIONS(2224),
    [anon_sym_groupshared] = ACTIONS(2224),
    [anon_sym_uniform] = ACTIONS(2224),
    [anon_sym_row_major] = ACTIONS(2224),
    [anon_sym_column_major] = ACTIONS(2224),
    [anon_sym_globallycoherent] = ACTIONS(2224),
    [anon_sym_centroid] = ACTIONS(2224),
    [anon_sym_noperspective] = ACTIONS(2224),
    [anon_sym_nointerpolation] = ACTIONS(2224),
    [anon_sym_sample] = ACTIONS(2224),
    [anon_sym_linear] = ACTIONS(2224),
    [anon_sym_snorm] = ACTIONS(2224),
    [anon_sym_unorm] = ACTIONS(2224),
    [anon_sym_point] = ACTIONS(2224),
    [anon_sym_line] = ACTIONS(2224),
    [anon_sym_triangleadj] = ACTIONS(2224),
    [anon_sym_lineadj] = ACTIONS(2224),
    [anon_sym_triangle] = ACTIONS(2224),
    [anon_sym_cbuffer] = ACTIONS(2224),
    [anon_sym_interface] = ACTIONS(2224),
    [anon_sym_extension] = ACTIONS(2224),
  },
  [519] = {
    [sym_identifier] = ACTIONS(2236),
    [aux_sym_preproc_include_token1] = ACTIONS(2236),
    [aux_sym_preproc_def_token1] = ACTIONS(2236),
    [aux_sym_preproc_if_token1] = ACTIONS(2236),
    [aux_sym_preproc_if_token2] = ACTIONS(2236),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2236),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2236),
    [sym_preproc_directive] = ACTIONS(2236),
    [anon_sym_LPAREN2] = ACTIONS(2238),
    [anon_sym_BANG] = ACTIONS(2238),
    [anon_sym_TILDE] = ACTIONS(2238),
    [anon_sym_DASH] = ACTIONS(2236),
    [anon_sym_PLUS] = ACTIONS(2236),
    [anon_sym_STAR] = ACTIONS(2238),
    [anon_sym_AMP_AMP] = ACTIONS(2238),
    [anon_sym_AMP] = ACTIONS(2236),
    [anon_sym_COLON] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(2238),
    [anon_sym___extension__] = ACTIONS(2236),
    [anon_sym_typedef] = ACTIONS(2236),
    [anon_sym_in] = ACTIONS(2236),
    [anon_sym_out] = ACTIONS(2236),
    [anon_sym_inout] = ACTIONS(2236),
    [anon_sym_extern] = ACTIONS(2236),
    [anon_sym___attribute__] = ACTIONS(2236),
    [anon_sym_COLON_COLON] = ACTIONS(2238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2238),
    [anon_sym___declspec] = ACTIONS(2236),
    [anon_sym___based] = ACTIONS(2236),
    [anon_sym___cdecl] = ACTIONS(2236),
    [anon_sym___clrcall] = ACTIONS(2236),
    [anon_sym___stdcall] = ACTIONS(2236),
    [anon_sym___fastcall] = ACTIONS(2236),
    [anon_sym___thiscall] = ACTIONS(2236),
    [anon_sym___vectorcall] = ACTIONS(2236),
    [anon_sym_LBRACE] = ACTIONS(2238),
    [anon_sym_signed] = ACTIONS(2236),
    [anon_sym_unsigned] = ACTIONS(2236),
    [anon_sym_long] = ACTIONS(2236),
    [anon_sym_short] = ACTIONS(2236),
    [anon_sym_LBRACK] = ACTIONS(2236),
    [anon_sym_static] = ACTIONS(2236),
    [anon_sym_register] = ACTIONS(2236),
    [anon_sym_inline] = ACTIONS(2236),
    [anon_sym___inline] = ACTIONS(2236),
    [anon_sym___inline__] = ACTIONS(2236),
    [anon_sym___forceinline] = ACTIONS(2236),
    [anon_sym_thread_local] = ACTIONS(2236),
    [anon_sym___thread] = ACTIONS(2236),
    [anon_sym_const] = ACTIONS(2236),
    [anon_sym_constexpr] = ACTIONS(2236),
    [anon_sym_volatile] = ACTIONS(2236),
    [anon_sym_restrict] = ACTIONS(2236),
    [anon_sym___restrict__] = ACTIONS(2236),
    [anon_sym__Atomic] = ACTIONS(2236),
    [anon_sym__Noreturn] = ACTIONS(2236),
    [anon_sym_noreturn] = ACTIONS(2236),
    [anon_sym_mutable] = ACTIONS(2236),
    [anon_sym_constinit] = ACTIONS(2236),
    [anon_sym_consteval] = ACTIONS(2236),
    [anon_sym_alignas] = ACTIONS(2236),
    [anon_sym__Alignas] = ACTIONS(2236),
    [sym_primitive_type] = ACTIONS(2236),
    [anon_sym_enum] = ACTIONS(2236),
    [anon_sym_class] = ACTIONS(2236),
    [anon_sym_struct] = ACTIONS(2236),
    [anon_sym_union] = ACTIONS(2236),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_else] = ACTIONS(2236),
    [anon_sym_switch] = ACTIONS(2236),
    [anon_sym_case] = ACTIONS(2236),
    [anon_sym_default] = ACTIONS(2236),
    [anon_sym_while] = ACTIONS(2236),
    [anon_sym_do] = ACTIONS(2236),
    [anon_sym_for] = ACTIONS(2236),
    [anon_sym_return] = ACTIONS(2236),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2236),
    [anon_sym_goto] = ACTIONS(2236),
    [anon_sym___try] = ACTIONS(2236),
    [anon_sym___leave] = ACTIONS(2236),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_compl] = ACTIONS(2236),
    [anon_sym_DASH_DASH] = ACTIONS(2238),
    [anon_sym_PLUS_PLUS] = ACTIONS(2238),
    [anon_sym_sizeof] = ACTIONS(2236),
    [anon_sym___alignof__] = ACTIONS(2236),
    [anon_sym___alignof] = ACTIONS(2236),
    [anon_sym__alignof] = ACTIONS(2236),
    [anon_sym_alignof] = ACTIONS(2236),
    [anon_sym__Alignof] = ACTIONS(2236),
    [anon_sym_offsetof] = ACTIONS(2236),
    [anon_sym__Generic] = ACTIONS(2236),
    [anon_sym_asm] = ACTIONS(2236),
    [anon_sym___asm__] = ACTIONS(2236),
    [sym_number_literal] = ACTIONS(2238),
    [anon_sym_L_SQUOTE] = ACTIONS(2238),
    [anon_sym_u_SQUOTE] = ACTIONS(2238),
    [anon_sym_U_SQUOTE] = ACTIONS(2238),
    [anon_sym_u8_SQUOTE] = ACTIONS(2238),
    [anon_sym_SQUOTE] = ACTIONS(2238),
    [anon_sym_L_DQUOTE] = ACTIONS(2238),
    [anon_sym_u_DQUOTE] = ACTIONS(2238),
    [anon_sym_U_DQUOTE] = ACTIONS(2238),
    [anon_sym_u8_DQUOTE] = ACTIONS(2238),
    [anon_sym_DQUOTE] = ACTIONS(2238),
    [sym_true] = ACTIONS(2236),
    [sym_false] = ACTIONS(2236),
    [anon_sym_NULL] = ACTIONS(2236),
    [anon_sym_nullptr] = ACTIONS(2236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2236),
    [anon_sym_let] = ACTIONS(2236),
    [anon_sym_This] = ACTIONS(2236),
    [anon_sym_decltype] = ACTIONS(2236),
    [anon_sym_final] = ACTIONS(2236),
    [anon_sym_override] = ACTIONS(2236),
    [sym_virtual] = ACTIONS(2236),
    [anon_sym_explicit] = ACTIONS(2236),
    [anon_sym_typename] = ACTIONS(2236),
    [anon_sym_template] = ACTIONS(2236),
    [anon_sym_operator] = ACTIONS(2236),
    [anon_sym_try] = ACTIONS(2236),
    [anon_sym_delete] = ACTIONS(2236),
    [anon_sym_throw] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(2236),
    [anon_sym_using] = ACTIONS(2236),
    [anon_sym_static_assert] = ACTIONS(2236),
    [anon_sym_concept] = ACTIONS(2236),
    [anon_sym_co_return] = ACTIONS(2236),
    [anon_sym_co_yield] = ACTIONS(2236),
    [anon_sym_R_DQUOTE] = ACTIONS(2238),
    [anon_sym_LR_DQUOTE] = ACTIONS(2238),
    [anon_sym_uR_DQUOTE] = ACTIONS(2238),
    [anon_sym_UR_DQUOTE] = ACTIONS(2238),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2238),
    [anon_sym_co_await] = ACTIONS(2236),
    [anon_sym_new] = ACTIONS(2236),
    [anon_sym_requires] = ACTIONS(2236),
    [sym_this] = ACTIONS(2236),
    [anon_sym_discard] = ACTIONS(2236),
    [anon_sym_precise] = ACTIONS(2236),
    [anon_sym_shared] = ACTIONS(2236),
    [anon_sym_groupshared] = ACTIONS(2236),
    [anon_sym_uniform] = ACTIONS(2236),
    [anon_sym_row_major] = ACTIONS(2236),
    [anon_sym_column_major] = ACTIONS(2236),
    [anon_sym_globallycoherent] = ACTIONS(2236),
    [anon_sym_centroid] = ACTIONS(2236),
    [anon_sym_noperspective] = ACTIONS(2236),
    [anon_sym_nointerpolation] = ACTIONS(2236),
    [anon_sym_sample] = ACTIONS(2236),
    [anon_sym_linear] = ACTIONS(2236),
    [anon_sym_snorm] = ACTIONS(2236),
    [anon_sym_unorm] = ACTIONS(2236),
    [anon_sym_point] = ACTIONS(2236),
    [anon_sym_line] = ACTIONS(2236),
    [anon_sym_triangleadj] = ACTIONS(2236),
    [anon_sym_lineadj] = ACTIONS(2236),
    [anon_sym_triangle] = ACTIONS(2236),
    [anon_sym_cbuffer] = ACTIONS(2236),
    [anon_sym_interface] = ACTIONS(2236),
    [anon_sym_extension] = ACTIONS(2236),
  },
  [520] = {
    [sym_identifier] = ACTIONS(3637),
    [aux_sym_preproc_include_token1] = ACTIONS(3637),
    [aux_sym_preproc_def_token1] = ACTIONS(3637),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_if_token2] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3637),
    [aux_sym_preproc_else_token1] = ACTIONS(3637),
    [aux_sym_preproc_elif_token1] = ACTIONS(3637),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3637),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3637),
    [sym_preproc_directive] = ACTIONS(3637),
    [anon_sym_LPAREN2] = ACTIONS(3639),
    [anon_sym_BANG] = ACTIONS(3639),
    [anon_sym_TILDE] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3637),
    [anon_sym_STAR] = ACTIONS(3639),
    [anon_sym_AMP_AMP] = ACTIONS(3639),
    [anon_sym_AMP] = ACTIONS(3637),
    [anon_sym_SEMI] = ACTIONS(3639),
    [anon_sym___extension__] = ACTIONS(3637),
    [anon_sym_typedef] = ACTIONS(3637),
    [anon_sym_in] = ACTIONS(3637),
    [anon_sym_out] = ACTIONS(3637),
    [anon_sym_inout] = ACTIONS(3637),
    [anon_sym_extern] = ACTIONS(3637),
    [anon_sym___attribute__] = ACTIONS(3637),
    [anon_sym_COLON_COLON] = ACTIONS(3639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3639),
    [anon_sym___declspec] = ACTIONS(3637),
    [anon_sym___based] = ACTIONS(3637),
    [anon_sym___cdecl] = ACTIONS(3637),
    [anon_sym___clrcall] = ACTIONS(3637),
    [anon_sym___stdcall] = ACTIONS(3637),
    [anon_sym___fastcall] = ACTIONS(3637),
    [anon_sym___thiscall] = ACTIONS(3637),
    [anon_sym___vectorcall] = ACTIONS(3637),
    [anon_sym_LBRACE] = ACTIONS(3639),
    [anon_sym_signed] = ACTIONS(3637),
    [anon_sym_unsigned] = ACTIONS(3637),
    [anon_sym_long] = ACTIONS(3637),
    [anon_sym_short] = ACTIONS(3637),
    [anon_sym_LBRACK] = ACTIONS(3637),
    [anon_sym_static] = ACTIONS(3637),
    [anon_sym_register] = ACTIONS(3637),
    [anon_sym_inline] = ACTIONS(3637),
    [anon_sym___inline] = ACTIONS(3637),
    [anon_sym___inline__] = ACTIONS(3637),
    [anon_sym___forceinline] = ACTIONS(3637),
    [anon_sym_thread_local] = ACTIONS(3637),
    [anon_sym___thread] = ACTIONS(3637),
    [anon_sym_const] = ACTIONS(3637),
    [anon_sym_constexpr] = ACTIONS(3637),
    [anon_sym_volatile] = ACTIONS(3637),
    [anon_sym_restrict] = ACTIONS(3637),
    [anon_sym___restrict__] = ACTIONS(3637),
    [anon_sym__Atomic] = ACTIONS(3637),
    [anon_sym__Noreturn] = ACTIONS(3637),
    [anon_sym_noreturn] = ACTIONS(3637),
    [anon_sym_mutable] = ACTIONS(3637),
    [anon_sym_constinit] = ACTIONS(3637),
    [anon_sym_consteval] = ACTIONS(3637),
    [anon_sym_alignas] = ACTIONS(3637),
    [anon_sym__Alignas] = ACTIONS(3637),
    [sym_primitive_type] = ACTIONS(3637),
    [anon_sym_enum] = ACTIONS(3637),
    [anon_sym_class] = ACTIONS(3637),
    [anon_sym_struct] = ACTIONS(3637),
    [anon_sym_union] = ACTIONS(3637),
    [anon_sym_if] = ACTIONS(3637),
    [anon_sym_switch] = ACTIONS(3637),
    [anon_sym_case] = ACTIONS(3637),
    [anon_sym_default] = ACTIONS(3637),
    [anon_sym_while] = ACTIONS(3637),
    [anon_sym_do] = ACTIONS(3637),
    [anon_sym_for] = ACTIONS(3637),
    [anon_sym_return] = ACTIONS(3637),
    [anon_sym_break] = ACTIONS(3637),
    [anon_sym_continue] = ACTIONS(3637),
    [anon_sym_goto] = ACTIONS(3637),
    [anon_sym___try] = ACTIONS(3637),
    [anon_sym___leave] = ACTIONS(3637),
    [anon_sym_not] = ACTIONS(3637),
    [anon_sym_compl] = ACTIONS(3637),
    [anon_sym_DASH_DASH] = ACTIONS(3639),
    [anon_sym_PLUS_PLUS] = ACTIONS(3639),
    [anon_sym_sizeof] = ACTIONS(3637),
    [anon_sym___alignof__] = ACTIONS(3637),
    [anon_sym___alignof] = ACTIONS(3637),
    [anon_sym__alignof] = ACTIONS(3637),
    [anon_sym_alignof] = ACTIONS(3637),
    [anon_sym__Alignof] = ACTIONS(3637),
    [anon_sym_offsetof] = ACTIONS(3637),
    [anon_sym__Generic] = ACTIONS(3637),
    [anon_sym_asm] = ACTIONS(3637),
    [anon_sym___asm__] = ACTIONS(3637),
    [sym_number_literal] = ACTIONS(3639),
    [anon_sym_L_SQUOTE] = ACTIONS(3639),
    [anon_sym_u_SQUOTE] = ACTIONS(3639),
    [anon_sym_U_SQUOTE] = ACTIONS(3639),
    [anon_sym_u8_SQUOTE] = ACTIONS(3639),
    [anon_sym_SQUOTE] = ACTIONS(3639),
    [anon_sym_L_DQUOTE] = ACTIONS(3639),
    [anon_sym_u_DQUOTE] = ACTIONS(3639),
    [anon_sym_U_DQUOTE] = ACTIONS(3639),
    [anon_sym_u8_DQUOTE] = ACTIONS(3639),
    [anon_sym_DQUOTE] = ACTIONS(3639),
    [sym_true] = ACTIONS(3637),
    [sym_false] = ACTIONS(3637),
    [anon_sym_NULL] = ACTIONS(3637),
    [anon_sym_nullptr] = ACTIONS(3637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3637),
    [anon_sym_let] = ACTIONS(3637),
    [anon_sym_This] = ACTIONS(3637),
    [anon_sym_decltype] = ACTIONS(3637),
    [sym_virtual] = ACTIONS(3637),
    [anon_sym_explicit] = ACTIONS(3637),
    [anon_sym_typename] = ACTIONS(3637),
    [anon_sym_template] = ACTIONS(3637),
    [anon_sym_operator] = ACTIONS(3637),
    [anon_sym_try] = ACTIONS(3637),
    [anon_sym_delete] = ACTIONS(3637),
    [anon_sym_throw] = ACTIONS(3637),
    [anon_sym_namespace] = ACTIONS(3637),
    [anon_sym_using] = ACTIONS(3637),
    [anon_sym_static_assert] = ACTIONS(3637),
    [anon_sym_concept] = ACTIONS(3637),
    [anon_sym_co_return] = ACTIONS(3637),
    [anon_sym_co_yield] = ACTIONS(3637),
    [anon_sym_R_DQUOTE] = ACTIONS(3639),
    [anon_sym_LR_DQUOTE] = ACTIONS(3639),
    [anon_sym_uR_DQUOTE] = ACTIONS(3639),
    [anon_sym_UR_DQUOTE] = ACTIONS(3639),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3639),
    [anon_sym_co_await] = ACTIONS(3637),
    [anon_sym_new] = ACTIONS(3637),
    [anon_sym_requires] = ACTIONS(3637),
    [sym_this] = ACTIONS(3637),
    [anon_sym_discard] = ACTIONS(3637),
    [anon_sym_precise] = ACTIONS(3637),
    [anon_sym_shared] = ACTIONS(3637),
    [anon_sym_groupshared] = ACTIONS(3637),
    [anon_sym_uniform] = ACTIONS(3637),
    [anon_sym_row_major] = ACTIONS(3637),
    [anon_sym_column_major] = ACTIONS(3637),
    [anon_sym_globallycoherent] = ACTIONS(3637),
    [anon_sym_centroid] = ACTIONS(3637),
    [anon_sym_noperspective] = ACTIONS(3637),
    [anon_sym_nointerpolation] = ACTIONS(3637),
    [anon_sym_sample] = ACTIONS(3637),
    [anon_sym_linear] = ACTIONS(3637),
    [anon_sym_snorm] = ACTIONS(3637),
    [anon_sym_unorm] = ACTIONS(3637),
    [anon_sym_point] = ACTIONS(3637),
    [anon_sym_line] = ACTIONS(3637),
    [anon_sym_triangleadj] = ACTIONS(3637),
    [anon_sym_lineadj] = ACTIONS(3637),
    [anon_sym_triangle] = ACTIONS(3637),
    [anon_sym_cbuffer] = ACTIONS(3637),
    [anon_sym_interface] = ACTIONS(3637),
    [anon_sym_extension] = ACTIONS(3637),
  },
  [521] = {
    [sym_identifier] = ACTIONS(2206),
    [aux_sym_preproc_include_token1] = ACTIONS(2206),
    [aux_sym_preproc_def_token1] = ACTIONS(2206),
    [aux_sym_preproc_if_token1] = ACTIONS(2206),
    [aux_sym_preproc_if_token2] = ACTIONS(2206),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2206),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2206),
    [sym_preproc_directive] = ACTIONS(2206),
    [anon_sym_LPAREN2] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2208),
    [anon_sym_TILDE] = ACTIONS(2208),
    [anon_sym_DASH] = ACTIONS(2206),
    [anon_sym_PLUS] = ACTIONS(2206),
    [anon_sym_STAR] = ACTIONS(2208),
    [anon_sym_AMP_AMP] = ACTIONS(2208),
    [anon_sym_AMP] = ACTIONS(2206),
    [anon_sym_COLON] = ACTIONS(2206),
    [anon_sym_SEMI] = ACTIONS(2208),
    [anon_sym___extension__] = ACTIONS(2206),
    [anon_sym_typedef] = ACTIONS(2206),
    [anon_sym_in] = ACTIONS(2206),
    [anon_sym_out] = ACTIONS(2206),
    [anon_sym_inout] = ACTIONS(2206),
    [anon_sym_extern] = ACTIONS(2206),
    [anon_sym___attribute__] = ACTIONS(2206),
    [anon_sym_COLON_COLON] = ACTIONS(2208),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2208),
    [anon_sym___declspec] = ACTIONS(2206),
    [anon_sym___based] = ACTIONS(2206),
    [anon_sym___cdecl] = ACTIONS(2206),
    [anon_sym___clrcall] = ACTIONS(2206),
    [anon_sym___stdcall] = ACTIONS(2206),
    [anon_sym___fastcall] = ACTIONS(2206),
    [anon_sym___thiscall] = ACTIONS(2206),
    [anon_sym___vectorcall] = ACTIONS(2206),
    [anon_sym_LBRACE] = ACTIONS(2208),
    [anon_sym_signed] = ACTIONS(2206),
    [anon_sym_unsigned] = ACTIONS(2206),
    [anon_sym_long] = ACTIONS(2206),
    [anon_sym_short] = ACTIONS(2206),
    [anon_sym_LBRACK] = ACTIONS(2206),
    [anon_sym_static] = ACTIONS(2206),
    [anon_sym_register] = ACTIONS(2206),
    [anon_sym_inline] = ACTIONS(2206),
    [anon_sym___inline] = ACTIONS(2206),
    [anon_sym___inline__] = ACTIONS(2206),
    [anon_sym___forceinline] = ACTIONS(2206),
    [anon_sym_thread_local] = ACTIONS(2206),
    [anon_sym___thread] = ACTIONS(2206),
    [anon_sym_const] = ACTIONS(2206),
    [anon_sym_constexpr] = ACTIONS(2206),
    [anon_sym_volatile] = ACTIONS(2206),
    [anon_sym_restrict] = ACTIONS(2206),
    [anon_sym___restrict__] = ACTIONS(2206),
    [anon_sym__Atomic] = ACTIONS(2206),
    [anon_sym__Noreturn] = ACTIONS(2206),
    [anon_sym_noreturn] = ACTIONS(2206),
    [anon_sym_mutable] = ACTIONS(2206),
    [anon_sym_constinit] = ACTIONS(2206),
    [anon_sym_consteval] = ACTIONS(2206),
    [anon_sym_alignas] = ACTIONS(2206),
    [anon_sym__Alignas] = ACTIONS(2206),
    [sym_primitive_type] = ACTIONS(2206),
    [anon_sym_enum] = ACTIONS(2206),
    [anon_sym_class] = ACTIONS(2206),
    [anon_sym_struct] = ACTIONS(2206),
    [anon_sym_union] = ACTIONS(2206),
    [anon_sym_if] = ACTIONS(2206),
    [anon_sym_else] = ACTIONS(2206),
    [anon_sym_switch] = ACTIONS(2206),
    [anon_sym_case] = ACTIONS(2206),
    [anon_sym_default] = ACTIONS(2206),
    [anon_sym_while] = ACTIONS(2206),
    [anon_sym_do] = ACTIONS(2206),
    [anon_sym_for] = ACTIONS(2206),
    [anon_sym_return] = ACTIONS(2206),
    [anon_sym_break] = ACTIONS(2206),
    [anon_sym_continue] = ACTIONS(2206),
    [anon_sym_goto] = ACTIONS(2206),
    [anon_sym___try] = ACTIONS(2206),
    [anon_sym___leave] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_compl] = ACTIONS(2206),
    [anon_sym_DASH_DASH] = ACTIONS(2208),
    [anon_sym_PLUS_PLUS] = ACTIONS(2208),
    [anon_sym_sizeof] = ACTIONS(2206),
    [anon_sym___alignof__] = ACTIONS(2206),
    [anon_sym___alignof] = ACTIONS(2206),
    [anon_sym__alignof] = ACTIONS(2206),
    [anon_sym_alignof] = ACTIONS(2206),
    [anon_sym__Alignof] = ACTIONS(2206),
    [anon_sym_offsetof] = ACTIONS(2206),
    [anon_sym__Generic] = ACTIONS(2206),
    [anon_sym_asm] = ACTIONS(2206),
    [anon_sym___asm__] = ACTIONS(2206),
    [sym_number_literal] = ACTIONS(2208),
    [anon_sym_L_SQUOTE] = ACTIONS(2208),
    [anon_sym_u_SQUOTE] = ACTIONS(2208),
    [anon_sym_U_SQUOTE] = ACTIONS(2208),
    [anon_sym_u8_SQUOTE] = ACTIONS(2208),
    [anon_sym_SQUOTE] = ACTIONS(2208),
    [anon_sym_L_DQUOTE] = ACTIONS(2208),
    [anon_sym_u_DQUOTE] = ACTIONS(2208),
    [anon_sym_U_DQUOTE] = ACTIONS(2208),
    [anon_sym_u8_DQUOTE] = ACTIONS(2208),
    [anon_sym_DQUOTE] = ACTIONS(2208),
    [sym_true] = ACTIONS(2206),
    [sym_false] = ACTIONS(2206),
    [anon_sym_NULL] = ACTIONS(2206),
    [anon_sym_nullptr] = ACTIONS(2206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2206),
    [anon_sym_let] = ACTIONS(2206),
    [anon_sym_This] = ACTIONS(2206),
    [anon_sym_decltype] = ACTIONS(2206),
    [anon_sym_final] = ACTIONS(2206),
    [anon_sym_override] = ACTIONS(2206),
    [sym_virtual] = ACTIONS(2206),
    [anon_sym_explicit] = ACTIONS(2206),
    [anon_sym_typename] = ACTIONS(2206),
    [anon_sym_template] = ACTIONS(2206),
    [anon_sym_operator] = ACTIONS(2206),
    [anon_sym_try] = ACTIONS(2206),
    [anon_sym_delete] = ACTIONS(2206),
    [anon_sym_throw] = ACTIONS(2206),
    [anon_sym_namespace] = ACTIONS(2206),
    [anon_sym_using] = ACTIONS(2206),
    [anon_sym_static_assert] = ACTIONS(2206),
    [anon_sym_concept] = ACTIONS(2206),
    [anon_sym_co_return] = ACTIONS(2206),
    [anon_sym_co_yield] = ACTIONS(2206),
    [anon_sym_R_DQUOTE] = ACTIONS(2208),
    [anon_sym_LR_DQUOTE] = ACTIONS(2208),
    [anon_sym_uR_DQUOTE] = ACTIONS(2208),
    [anon_sym_UR_DQUOTE] = ACTIONS(2208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2208),
    [anon_sym_co_await] = ACTIONS(2206),
    [anon_sym_new] = ACTIONS(2206),
    [anon_sym_requires] = ACTIONS(2206),
    [sym_this] = ACTIONS(2206),
    [anon_sym_discard] = ACTIONS(2206),
    [anon_sym_precise] = ACTIONS(2206),
    [anon_sym_shared] = ACTIONS(2206),
    [anon_sym_groupshared] = ACTIONS(2206),
    [anon_sym_uniform] = ACTIONS(2206),
    [anon_sym_row_major] = ACTIONS(2206),
    [anon_sym_column_major] = ACTIONS(2206),
    [anon_sym_globallycoherent] = ACTIONS(2206),
    [anon_sym_centroid] = ACTIONS(2206),
    [anon_sym_noperspective] = ACTIONS(2206),
    [anon_sym_nointerpolation] = ACTIONS(2206),
    [anon_sym_sample] = ACTIONS(2206),
    [anon_sym_linear] = ACTIONS(2206),
    [anon_sym_snorm] = ACTIONS(2206),
    [anon_sym_unorm] = ACTIONS(2206),
    [anon_sym_point] = ACTIONS(2206),
    [anon_sym_line] = ACTIONS(2206),
    [anon_sym_triangleadj] = ACTIONS(2206),
    [anon_sym_lineadj] = ACTIONS(2206),
    [anon_sym_triangle] = ACTIONS(2206),
    [anon_sym_cbuffer] = ACTIONS(2206),
    [anon_sym_interface] = ACTIONS(2206),
    [anon_sym_extension] = ACTIONS(2206),
  },
  [522] = {
    [sym_identifier] = ACTIONS(3641),
    [aux_sym_preproc_include_token1] = ACTIONS(3641),
    [aux_sym_preproc_def_token1] = ACTIONS(3641),
    [aux_sym_preproc_if_token1] = ACTIONS(3641),
    [aux_sym_preproc_if_token2] = ACTIONS(3641),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3641),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3641),
    [aux_sym_preproc_else_token1] = ACTIONS(3641),
    [aux_sym_preproc_elif_token1] = ACTIONS(3641),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3641),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3641),
    [sym_preproc_directive] = ACTIONS(3641),
    [anon_sym_LPAREN2] = ACTIONS(3643),
    [anon_sym_BANG] = ACTIONS(3643),
    [anon_sym_TILDE] = ACTIONS(3643),
    [anon_sym_DASH] = ACTIONS(3641),
    [anon_sym_PLUS] = ACTIONS(3641),
    [anon_sym_STAR] = ACTIONS(3643),
    [anon_sym_AMP_AMP] = ACTIONS(3643),
    [anon_sym_AMP] = ACTIONS(3641),
    [anon_sym_SEMI] = ACTIONS(3643),
    [anon_sym___extension__] = ACTIONS(3641),
    [anon_sym_typedef] = ACTIONS(3641),
    [anon_sym_in] = ACTIONS(3641),
    [anon_sym_out] = ACTIONS(3641),
    [anon_sym_inout] = ACTIONS(3641),
    [anon_sym_extern] = ACTIONS(3641),
    [anon_sym___attribute__] = ACTIONS(3641),
    [anon_sym_COLON_COLON] = ACTIONS(3643),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3643),
    [anon_sym___declspec] = ACTIONS(3641),
    [anon_sym___based] = ACTIONS(3641),
    [anon_sym___cdecl] = ACTIONS(3641),
    [anon_sym___clrcall] = ACTIONS(3641),
    [anon_sym___stdcall] = ACTIONS(3641),
    [anon_sym___fastcall] = ACTIONS(3641),
    [anon_sym___thiscall] = ACTIONS(3641),
    [anon_sym___vectorcall] = ACTIONS(3641),
    [anon_sym_LBRACE] = ACTIONS(3643),
    [anon_sym_signed] = ACTIONS(3641),
    [anon_sym_unsigned] = ACTIONS(3641),
    [anon_sym_long] = ACTIONS(3641),
    [anon_sym_short] = ACTIONS(3641),
    [anon_sym_LBRACK] = ACTIONS(3641),
    [anon_sym_static] = ACTIONS(3641),
    [anon_sym_register] = ACTIONS(3641),
    [anon_sym_inline] = ACTIONS(3641),
    [anon_sym___inline] = ACTIONS(3641),
    [anon_sym___inline__] = ACTIONS(3641),
    [anon_sym___forceinline] = ACTIONS(3641),
    [anon_sym_thread_local] = ACTIONS(3641),
    [anon_sym___thread] = ACTIONS(3641),
    [anon_sym_const] = ACTIONS(3641),
    [anon_sym_constexpr] = ACTIONS(3641),
    [anon_sym_volatile] = ACTIONS(3641),
    [anon_sym_restrict] = ACTIONS(3641),
    [anon_sym___restrict__] = ACTIONS(3641),
    [anon_sym__Atomic] = ACTIONS(3641),
    [anon_sym__Noreturn] = ACTIONS(3641),
    [anon_sym_noreturn] = ACTIONS(3641),
    [anon_sym_mutable] = ACTIONS(3641),
    [anon_sym_constinit] = ACTIONS(3641),
    [anon_sym_consteval] = ACTIONS(3641),
    [anon_sym_alignas] = ACTIONS(3641),
    [anon_sym__Alignas] = ACTIONS(3641),
    [sym_primitive_type] = ACTIONS(3641),
    [anon_sym_enum] = ACTIONS(3641),
    [anon_sym_class] = ACTIONS(3641),
    [anon_sym_struct] = ACTIONS(3641),
    [anon_sym_union] = ACTIONS(3641),
    [anon_sym_if] = ACTIONS(3641),
    [anon_sym_switch] = ACTIONS(3641),
    [anon_sym_case] = ACTIONS(3641),
    [anon_sym_default] = ACTIONS(3641),
    [anon_sym_while] = ACTIONS(3641),
    [anon_sym_do] = ACTIONS(3641),
    [anon_sym_for] = ACTIONS(3641),
    [anon_sym_return] = ACTIONS(3641),
    [anon_sym_break] = ACTIONS(3641),
    [anon_sym_continue] = ACTIONS(3641),
    [anon_sym_goto] = ACTIONS(3641),
    [anon_sym___try] = ACTIONS(3641),
    [anon_sym___leave] = ACTIONS(3641),
    [anon_sym_not] = ACTIONS(3641),
    [anon_sym_compl] = ACTIONS(3641),
    [anon_sym_DASH_DASH] = ACTIONS(3643),
    [anon_sym_PLUS_PLUS] = ACTIONS(3643),
    [anon_sym_sizeof] = ACTIONS(3641),
    [anon_sym___alignof__] = ACTIONS(3641),
    [anon_sym___alignof] = ACTIONS(3641),
    [anon_sym__alignof] = ACTIONS(3641),
    [anon_sym_alignof] = ACTIONS(3641),
    [anon_sym__Alignof] = ACTIONS(3641),
    [anon_sym_offsetof] = ACTIONS(3641),
    [anon_sym__Generic] = ACTIONS(3641),
    [anon_sym_asm] = ACTIONS(3641),
    [anon_sym___asm__] = ACTIONS(3641),
    [sym_number_literal] = ACTIONS(3643),
    [anon_sym_L_SQUOTE] = ACTIONS(3643),
    [anon_sym_u_SQUOTE] = ACTIONS(3643),
    [anon_sym_U_SQUOTE] = ACTIONS(3643),
    [anon_sym_u8_SQUOTE] = ACTIONS(3643),
    [anon_sym_SQUOTE] = ACTIONS(3643),
    [anon_sym_L_DQUOTE] = ACTIONS(3643),
    [anon_sym_u_DQUOTE] = ACTIONS(3643),
    [anon_sym_U_DQUOTE] = ACTIONS(3643),
    [anon_sym_u8_DQUOTE] = ACTIONS(3643),
    [anon_sym_DQUOTE] = ACTIONS(3643),
    [sym_true] = ACTIONS(3641),
    [sym_false] = ACTIONS(3641),
    [anon_sym_NULL] = ACTIONS(3641),
    [anon_sym_nullptr] = ACTIONS(3641),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3641),
    [anon_sym_let] = ACTIONS(3641),
    [anon_sym_This] = ACTIONS(3641),
    [anon_sym_decltype] = ACTIONS(3641),
    [sym_virtual] = ACTIONS(3641),
    [anon_sym_explicit] = ACTIONS(3641),
    [anon_sym_typename] = ACTIONS(3641),
    [anon_sym_template] = ACTIONS(3641),
    [anon_sym_operator] = ACTIONS(3641),
    [anon_sym_try] = ACTIONS(3641),
    [anon_sym_delete] = ACTIONS(3641),
    [anon_sym_throw] = ACTIONS(3641),
    [anon_sym_namespace] = ACTIONS(3641),
    [anon_sym_using] = ACTIONS(3641),
    [anon_sym_static_assert] = ACTIONS(3641),
    [anon_sym_concept] = ACTIONS(3641),
    [anon_sym_co_return] = ACTIONS(3641),
    [anon_sym_co_yield] = ACTIONS(3641),
    [anon_sym_R_DQUOTE] = ACTIONS(3643),
    [anon_sym_LR_DQUOTE] = ACTIONS(3643),
    [anon_sym_uR_DQUOTE] = ACTIONS(3643),
    [anon_sym_UR_DQUOTE] = ACTIONS(3643),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3643),
    [anon_sym_co_await] = ACTIONS(3641),
    [anon_sym_new] = ACTIONS(3641),
    [anon_sym_requires] = ACTIONS(3641),
    [sym_this] = ACTIONS(3641),
    [anon_sym_discard] = ACTIONS(3641),
    [anon_sym_precise] = ACTIONS(3641),
    [anon_sym_shared] = ACTIONS(3641),
    [anon_sym_groupshared] = ACTIONS(3641),
    [anon_sym_uniform] = ACTIONS(3641),
    [anon_sym_row_major] = ACTIONS(3641),
    [anon_sym_column_major] = ACTIONS(3641),
    [anon_sym_globallycoherent] = ACTIONS(3641),
    [anon_sym_centroid] = ACTIONS(3641),
    [anon_sym_noperspective] = ACTIONS(3641),
    [anon_sym_nointerpolation] = ACTIONS(3641),
    [anon_sym_sample] = ACTIONS(3641),
    [anon_sym_linear] = ACTIONS(3641),
    [anon_sym_snorm] = ACTIONS(3641),
    [anon_sym_unorm] = ACTIONS(3641),
    [anon_sym_point] = ACTIONS(3641),
    [anon_sym_line] = ACTIONS(3641),
    [anon_sym_triangleadj] = ACTIONS(3641),
    [anon_sym_lineadj] = ACTIONS(3641),
    [anon_sym_triangle] = ACTIONS(3641),
    [anon_sym_cbuffer] = ACTIONS(3641),
    [anon_sym_interface] = ACTIONS(3641),
    [anon_sym_extension] = ACTIONS(3641),
  },
  [523] = {
    [sym_identifier] = ACTIONS(2202),
    [aux_sym_preproc_include_token1] = ACTIONS(2202),
    [aux_sym_preproc_def_token1] = ACTIONS(2202),
    [aux_sym_preproc_if_token1] = ACTIONS(2202),
    [aux_sym_preproc_if_token2] = ACTIONS(2202),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2202),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2202),
    [sym_preproc_directive] = ACTIONS(2202),
    [anon_sym_LPAREN2] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2204),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2202),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_STAR] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_AMP] = ACTIONS(2202),
    [anon_sym_COLON] = ACTIONS(2202),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym___extension__] = ACTIONS(2202),
    [anon_sym_typedef] = ACTIONS(2202),
    [anon_sym_in] = ACTIONS(2202),
    [anon_sym_out] = ACTIONS(2202),
    [anon_sym_inout] = ACTIONS(2202),
    [anon_sym_extern] = ACTIONS(2202),
    [anon_sym___attribute__] = ACTIONS(2202),
    [anon_sym_COLON_COLON] = ACTIONS(2204),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2204),
    [anon_sym___declspec] = ACTIONS(2202),
    [anon_sym___based] = ACTIONS(2202),
    [anon_sym___cdecl] = ACTIONS(2202),
    [anon_sym___clrcall] = ACTIONS(2202),
    [anon_sym___stdcall] = ACTIONS(2202),
    [anon_sym___fastcall] = ACTIONS(2202),
    [anon_sym___thiscall] = ACTIONS(2202),
    [anon_sym___vectorcall] = ACTIONS(2202),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_signed] = ACTIONS(2202),
    [anon_sym_unsigned] = ACTIONS(2202),
    [anon_sym_long] = ACTIONS(2202),
    [anon_sym_short] = ACTIONS(2202),
    [anon_sym_LBRACK] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2202),
    [anon_sym_register] = ACTIONS(2202),
    [anon_sym_inline] = ACTIONS(2202),
    [anon_sym___inline] = ACTIONS(2202),
    [anon_sym___inline__] = ACTIONS(2202),
    [anon_sym___forceinline] = ACTIONS(2202),
    [anon_sym_thread_local] = ACTIONS(2202),
    [anon_sym___thread] = ACTIONS(2202),
    [anon_sym_const] = ACTIONS(2202),
    [anon_sym_constexpr] = ACTIONS(2202),
    [anon_sym_volatile] = ACTIONS(2202),
    [anon_sym_restrict] = ACTIONS(2202),
    [anon_sym___restrict__] = ACTIONS(2202),
    [anon_sym__Atomic] = ACTIONS(2202),
    [anon_sym__Noreturn] = ACTIONS(2202),
    [anon_sym_noreturn] = ACTIONS(2202),
    [anon_sym_mutable] = ACTIONS(2202),
    [anon_sym_constinit] = ACTIONS(2202),
    [anon_sym_consteval] = ACTIONS(2202),
    [anon_sym_alignas] = ACTIONS(2202),
    [anon_sym__Alignas] = ACTIONS(2202),
    [sym_primitive_type] = ACTIONS(2202),
    [anon_sym_enum] = ACTIONS(2202),
    [anon_sym_class] = ACTIONS(2202),
    [anon_sym_struct] = ACTIONS(2202),
    [anon_sym_union] = ACTIONS(2202),
    [anon_sym_if] = ACTIONS(2202),
    [anon_sym_else] = ACTIONS(2202),
    [anon_sym_switch] = ACTIONS(2202),
    [anon_sym_case] = ACTIONS(2202),
    [anon_sym_default] = ACTIONS(2202),
    [anon_sym_while] = ACTIONS(2202),
    [anon_sym_do] = ACTIONS(2202),
    [anon_sym_for] = ACTIONS(2202),
    [anon_sym_return] = ACTIONS(2202),
    [anon_sym_break] = ACTIONS(2202),
    [anon_sym_continue] = ACTIONS(2202),
    [anon_sym_goto] = ACTIONS(2202),
    [anon_sym___try] = ACTIONS(2202),
    [anon_sym___leave] = ACTIONS(2202),
    [anon_sym_not] = ACTIONS(2202),
    [anon_sym_compl] = ACTIONS(2202),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_sizeof] = ACTIONS(2202),
    [anon_sym___alignof__] = ACTIONS(2202),
    [anon_sym___alignof] = ACTIONS(2202),
    [anon_sym__alignof] = ACTIONS(2202),
    [anon_sym_alignof] = ACTIONS(2202),
    [anon_sym__Alignof] = ACTIONS(2202),
    [anon_sym_offsetof] = ACTIONS(2202),
    [anon_sym__Generic] = ACTIONS(2202),
    [anon_sym_asm] = ACTIONS(2202),
    [anon_sym___asm__] = ACTIONS(2202),
    [sym_number_literal] = ACTIONS(2204),
    [anon_sym_L_SQUOTE] = ACTIONS(2204),
    [anon_sym_u_SQUOTE] = ACTIONS(2204),
    [anon_sym_U_SQUOTE] = ACTIONS(2204),
    [anon_sym_u8_SQUOTE] = ACTIONS(2204),
    [anon_sym_SQUOTE] = ACTIONS(2204),
    [anon_sym_L_DQUOTE] = ACTIONS(2204),
    [anon_sym_u_DQUOTE] = ACTIONS(2204),
    [anon_sym_U_DQUOTE] = ACTIONS(2204),
    [anon_sym_u8_DQUOTE] = ACTIONS(2204),
    [anon_sym_DQUOTE] = ACTIONS(2204),
    [sym_true] = ACTIONS(2202),
    [sym_false] = ACTIONS(2202),
    [anon_sym_NULL] = ACTIONS(2202),
    [anon_sym_nullptr] = ACTIONS(2202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2202),
    [anon_sym_let] = ACTIONS(2202),
    [anon_sym_This] = ACTIONS(2202),
    [anon_sym_decltype] = ACTIONS(2202),
    [anon_sym_final] = ACTIONS(2202),
    [anon_sym_override] = ACTIONS(2202),
    [sym_virtual] = ACTIONS(2202),
    [anon_sym_explicit] = ACTIONS(2202),
    [anon_sym_typename] = ACTIONS(2202),
    [anon_sym_template] = ACTIONS(2202),
    [anon_sym_operator] = ACTIONS(2202),
    [anon_sym_try] = ACTIONS(2202),
    [anon_sym_delete] = ACTIONS(2202),
    [anon_sym_throw] = ACTIONS(2202),
    [anon_sym_namespace] = ACTIONS(2202),
    [anon_sym_using] = ACTIONS(2202),
    [anon_sym_static_assert] = ACTIONS(2202),
    [anon_sym_concept] = ACTIONS(2202),
    [anon_sym_co_return] = ACTIONS(2202),
    [anon_sym_co_yield] = ACTIONS(2202),
    [anon_sym_R_DQUOTE] = ACTIONS(2204),
    [anon_sym_LR_DQUOTE] = ACTIONS(2204),
    [anon_sym_uR_DQUOTE] = ACTIONS(2204),
    [anon_sym_UR_DQUOTE] = ACTIONS(2204),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2204),
    [anon_sym_co_await] = ACTIONS(2202),
    [anon_sym_new] = ACTIONS(2202),
    [anon_sym_requires] = ACTIONS(2202),
    [sym_this] = ACTIONS(2202),
    [anon_sym_discard] = ACTIONS(2202),
    [anon_sym_precise] = ACTIONS(2202),
    [anon_sym_shared] = ACTIONS(2202),
    [anon_sym_groupshared] = ACTIONS(2202),
    [anon_sym_uniform] = ACTIONS(2202),
    [anon_sym_row_major] = ACTIONS(2202),
    [anon_sym_column_major] = ACTIONS(2202),
    [anon_sym_globallycoherent] = ACTIONS(2202),
    [anon_sym_centroid] = ACTIONS(2202),
    [anon_sym_noperspective] = ACTIONS(2202),
    [anon_sym_nointerpolation] = ACTIONS(2202),
    [anon_sym_sample] = ACTIONS(2202),
    [anon_sym_linear] = ACTIONS(2202),
    [anon_sym_snorm] = ACTIONS(2202),
    [anon_sym_unorm] = ACTIONS(2202),
    [anon_sym_point] = ACTIONS(2202),
    [anon_sym_line] = ACTIONS(2202),
    [anon_sym_triangleadj] = ACTIONS(2202),
    [anon_sym_lineadj] = ACTIONS(2202),
    [anon_sym_triangle] = ACTIONS(2202),
    [anon_sym_cbuffer] = ACTIONS(2202),
    [anon_sym_interface] = ACTIONS(2202),
    [anon_sym_extension] = ACTIONS(2202),
  },
  [524] = {
    [sym_identifier] = ACTIONS(3645),
    [aux_sym_preproc_include_token1] = ACTIONS(3645),
    [aux_sym_preproc_def_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token2] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3645),
    [aux_sym_preproc_else_token1] = ACTIONS(3645),
    [aux_sym_preproc_elif_token1] = ACTIONS(3645),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3645),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3645),
    [sym_preproc_directive] = ACTIONS(3645),
    [anon_sym_LPAREN2] = ACTIONS(3647),
    [anon_sym_BANG] = ACTIONS(3647),
    [anon_sym_TILDE] = ACTIONS(3647),
    [anon_sym_DASH] = ACTIONS(3645),
    [anon_sym_PLUS] = ACTIONS(3645),
    [anon_sym_STAR] = ACTIONS(3647),
    [anon_sym_AMP_AMP] = ACTIONS(3647),
    [anon_sym_AMP] = ACTIONS(3645),
    [anon_sym_SEMI] = ACTIONS(3647),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3645),
    [anon_sym_in] = ACTIONS(3645),
    [anon_sym_out] = ACTIONS(3645),
    [anon_sym_inout] = ACTIONS(3645),
    [anon_sym_extern] = ACTIONS(3645),
    [anon_sym___attribute__] = ACTIONS(3645),
    [anon_sym_COLON_COLON] = ACTIONS(3647),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3647),
    [anon_sym___declspec] = ACTIONS(3645),
    [anon_sym___based] = ACTIONS(3645),
    [anon_sym___cdecl] = ACTIONS(3645),
    [anon_sym___clrcall] = ACTIONS(3645),
    [anon_sym___stdcall] = ACTIONS(3645),
    [anon_sym___fastcall] = ACTIONS(3645),
    [anon_sym___thiscall] = ACTIONS(3645),
    [anon_sym___vectorcall] = ACTIONS(3645),
    [anon_sym_LBRACE] = ACTIONS(3647),
    [anon_sym_signed] = ACTIONS(3645),
    [anon_sym_unsigned] = ACTIONS(3645),
    [anon_sym_long] = ACTIONS(3645),
    [anon_sym_short] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_static] = ACTIONS(3645),
    [anon_sym_register] = ACTIONS(3645),
    [anon_sym_inline] = ACTIONS(3645),
    [anon_sym___inline] = ACTIONS(3645),
    [anon_sym___inline__] = ACTIONS(3645),
    [anon_sym___forceinline] = ACTIONS(3645),
    [anon_sym_thread_local] = ACTIONS(3645),
    [anon_sym___thread] = ACTIONS(3645),
    [anon_sym_const] = ACTIONS(3645),
    [anon_sym_constexpr] = ACTIONS(3645),
    [anon_sym_volatile] = ACTIONS(3645),
    [anon_sym_restrict] = ACTIONS(3645),
    [anon_sym___restrict__] = ACTIONS(3645),
    [anon_sym__Atomic] = ACTIONS(3645),
    [anon_sym__Noreturn] = ACTIONS(3645),
    [anon_sym_noreturn] = ACTIONS(3645),
    [anon_sym_mutable] = ACTIONS(3645),
    [anon_sym_constinit] = ACTIONS(3645),
    [anon_sym_consteval] = ACTIONS(3645),
    [anon_sym_alignas] = ACTIONS(3645),
    [anon_sym__Alignas] = ACTIONS(3645),
    [sym_primitive_type] = ACTIONS(3645),
    [anon_sym_enum] = ACTIONS(3645),
    [anon_sym_class] = ACTIONS(3645),
    [anon_sym_struct] = ACTIONS(3645),
    [anon_sym_union] = ACTIONS(3645),
    [anon_sym_if] = ACTIONS(3645),
    [anon_sym_switch] = ACTIONS(3645),
    [anon_sym_case] = ACTIONS(3645),
    [anon_sym_default] = ACTIONS(3645),
    [anon_sym_while] = ACTIONS(3645),
    [anon_sym_do] = ACTIONS(3645),
    [anon_sym_for] = ACTIONS(3645),
    [anon_sym_return] = ACTIONS(3645),
    [anon_sym_break] = ACTIONS(3645),
    [anon_sym_continue] = ACTIONS(3645),
    [anon_sym_goto] = ACTIONS(3645),
    [anon_sym___try] = ACTIONS(3645),
    [anon_sym___leave] = ACTIONS(3645),
    [anon_sym_not] = ACTIONS(3645),
    [anon_sym_compl] = ACTIONS(3645),
    [anon_sym_DASH_DASH] = ACTIONS(3647),
    [anon_sym_PLUS_PLUS] = ACTIONS(3647),
    [anon_sym_sizeof] = ACTIONS(3645),
    [anon_sym___alignof__] = ACTIONS(3645),
    [anon_sym___alignof] = ACTIONS(3645),
    [anon_sym__alignof] = ACTIONS(3645),
    [anon_sym_alignof] = ACTIONS(3645),
    [anon_sym__Alignof] = ACTIONS(3645),
    [anon_sym_offsetof] = ACTIONS(3645),
    [anon_sym__Generic] = ACTIONS(3645),
    [anon_sym_asm] = ACTIONS(3645),
    [anon_sym___asm__] = ACTIONS(3645),
    [sym_number_literal] = ACTIONS(3647),
    [anon_sym_L_SQUOTE] = ACTIONS(3647),
    [anon_sym_u_SQUOTE] = ACTIONS(3647),
    [anon_sym_U_SQUOTE] = ACTIONS(3647),
    [anon_sym_u8_SQUOTE] = ACTIONS(3647),
    [anon_sym_SQUOTE] = ACTIONS(3647),
    [anon_sym_L_DQUOTE] = ACTIONS(3647),
    [anon_sym_u_DQUOTE] = ACTIONS(3647),
    [anon_sym_U_DQUOTE] = ACTIONS(3647),
    [anon_sym_u8_DQUOTE] = ACTIONS(3647),
    [anon_sym_DQUOTE] = ACTIONS(3647),
    [sym_true] = ACTIONS(3645),
    [sym_false] = ACTIONS(3645),
    [anon_sym_NULL] = ACTIONS(3645),
    [anon_sym_nullptr] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3645),
    [anon_sym_let] = ACTIONS(3645),
    [anon_sym_This] = ACTIONS(3645),
    [anon_sym_decltype] = ACTIONS(3645),
    [sym_virtual] = ACTIONS(3645),
    [anon_sym_explicit] = ACTIONS(3645),
    [anon_sym_typename] = ACTIONS(3645),
    [anon_sym_template] = ACTIONS(3645),
    [anon_sym_operator] = ACTIONS(3645),
    [anon_sym_try] = ACTIONS(3645),
    [anon_sym_delete] = ACTIONS(3645),
    [anon_sym_throw] = ACTIONS(3645),
    [anon_sym_namespace] = ACTIONS(3645),
    [anon_sym_using] = ACTIONS(3645),
    [anon_sym_static_assert] = ACTIONS(3645),
    [anon_sym_concept] = ACTIONS(3645),
    [anon_sym_co_return] = ACTIONS(3645),
    [anon_sym_co_yield] = ACTIONS(3645),
    [anon_sym_R_DQUOTE] = ACTIONS(3647),
    [anon_sym_LR_DQUOTE] = ACTIONS(3647),
    [anon_sym_uR_DQUOTE] = ACTIONS(3647),
    [anon_sym_UR_DQUOTE] = ACTIONS(3647),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3647),
    [anon_sym_co_await] = ACTIONS(3645),
    [anon_sym_new] = ACTIONS(3645),
    [anon_sym_requires] = ACTIONS(3645),
    [sym_this] = ACTIONS(3645),
    [anon_sym_discard] = ACTIONS(3645),
    [anon_sym_precise] = ACTIONS(3645),
    [anon_sym_shared] = ACTIONS(3645),
    [anon_sym_groupshared] = ACTIONS(3645),
    [anon_sym_uniform] = ACTIONS(3645),
    [anon_sym_row_major] = ACTIONS(3645),
    [anon_sym_column_major] = ACTIONS(3645),
    [anon_sym_globallycoherent] = ACTIONS(3645),
    [anon_sym_centroid] = ACTIONS(3645),
    [anon_sym_noperspective] = ACTIONS(3645),
    [anon_sym_nointerpolation] = ACTIONS(3645),
    [anon_sym_sample] = ACTIONS(3645),
    [anon_sym_linear] = ACTIONS(3645),
    [anon_sym_snorm] = ACTIONS(3645),
    [anon_sym_unorm] = ACTIONS(3645),
    [anon_sym_point] = ACTIONS(3645),
    [anon_sym_line] = ACTIONS(3645),
    [anon_sym_triangleadj] = ACTIONS(3645),
    [anon_sym_lineadj] = ACTIONS(3645),
    [anon_sym_triangle] = ACTIONS(3645),
    [anon_sym_cbuffer] = ACTIONS(3645),
    [anon_sym_interface] = ACTIONS(3645),
    [anon_sym_extension] = ACTIONS(3645),
  },
  [525] = {
    [sym_identifier] = ACTIONS(3645),
    [aux_sym_preproc_include_token1] = ACTIONS(3645),
    [aux_sym_preproc_def_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token2] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3645),
    [aux_sym_preproc_else_token1] = ACTIONS(3645),
    [aux_sym_preproc_elif_token1] = ACTIONS(3645),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3645),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3645),
    [sym_preproc_directive] = ACTIONS(3645),
    [anon_sym_LPAREN2] = ACTIONS(3647),
    [anon_sym_BANG] = ACTIONS(3647),
    [anon_sym_TILDE] = ACTIONS(3647),
    [anon_sym_DASH] = ACTIONS(3645),
    [anon_sym_PLUS] = ACTIONS(3645),
    [anon_sym_STAR] = ACTIONS(3647),
    [anon_sym_AMP_AMP] = ACTIONS(3647),
    [anon_sym_AMP] = ACTIONS(3645),
    [anon_sym_SEMI] = ACTIONS(3647),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3645),
    [anon_sym_in] = ACTIONS(3645),
    [anon_sym_out] = ACTIONS(3645),
    [anon_sym_inout] = ACTIONS(3645),
    [anon_sym_extern] = ACTIONS(3645),
    [anon_sym___attribute__] = ACTIONS(3645),
    [anon_sym_COLON_COLON] = ACTIONS(3647),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3647),
    [anon_sym___declspec] = ACTIONS(3645),
    [anon_sym___based] = ACTIONS(3645),
    [anon_sym___cdecl] = ACTIONS(3645),
    [anon_sym___clrcall] = ACTIONS(3645),
    [anon_sym___stdcall] = ACTIONS(3645),
    [anon_sym___fastcall] = ACTIONS(3645),
    [anon_sym___thiscall] = ACTIONS(3645),
    [anon_sym___vectorcall] = ACTIONS(3645),
    [anon_sym_LBRACE] = ACTIONS(3647),
    [anon_sym_signed] = ACTIONS(3645),
    [anon_sym_unsigned] = ACTIONS(3645),
    [anon_sym_long] = ACTIONS(3645),
    [anon_sym_short] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_static] = ACTIONS(3645),
    [anon_sym_register] = ACTIONS(3645),
    [anon_sym_inline] = ACTIONS(3645),
    [anon_sym___inline] = ACTIONS(3645),
    [anon_sym___inline__] = ACTIONS(3645),
    [anon_sym___forceinline] = ACTIONS(3645),
    [anon_sym_thread_local] = ACTIONS(3645),
    [anon_sym___thread] = ACTIONS(3645),
    [anon_sym_const] = ACTIONS(3645),
    [anon_sym_constexpr] = ACTIONS(3645),
    [anon_sym_volatile] = ACTIONS(3645),
    [anon_sym_restrict] = ACTIONS(3645),
    [anon_sym___restrict__] = ACTIONS(3645),
    [anon_sym__Atomic] = ACTIONS(3645),
    [anon_sym__Noreturn] = ACTIONS(3645),
    [anon_sym_noreturn] = ACTIONS(3645),
    [anon_sym_mutable] = ACTIONS(3645),
    [anon_sym_constinit] = ACTIONS(3645),
    [anon_sym_consteval] = ACTIONS(3645),
    [anon_sym_alignas] = ACTIONS(3645),
    [anon_sym__Alignas] = ACTIONS(3645),
    [sym_primitive_type] = ACTIONS(3645),
    [anon_sym_enum] = ACTIONS(3645),
    [anon_sym_class] = ACTIONS(3645),
    [anon_sym_struct] = ACTIONS(3645),
    [anon_sym_union] = ACTIONS(3645),
    [anon_sym_if] = ACTIONS(3645),
    [anon_sym_switch] = ACTIONS(3645),
    [anon_sym_case] = ACTIONS(3645),
    [anon_sym_default] = ACTIONS(3645),
    [anon_sym_while] = ACTIONS(3645),
    [anon_sym_do] = ACTIONS(3645),
    [anon_sym_for] = ACTIONS(3645),
    [anon_sym_return] = ACTIONS(3645),
    [anon_sym_break] = ACTIONS(3645),
    [anon_sym_continue] = ACTIONS(3645),
    [anon_sym_goto] = ACTIONS(3645),
    [anon_sym___try] = ACTIONS(3645),
    [anon_sym___leave] = ACTIONS(3645),
    [anon_sym_not] = ACTIONS(3645),
    [anon_sym_compl] = ACTIONS(3645),
    [anon_sym_DASH_DASH] = ACTIONS(3647),
    [anon_sym_PLUS_PLUS] = ACTIONS(3647),
    [anon_sym_sizeof] = ACTIONS(3645),
    [anon_sym___alignof__] = ACTIONS(3645),
    [anon_sym___alignof] = ACTIONS(3645),
    [anon_sym__alignof] = ACTIONS(3645),
    [anon_sym_alignof] = ACTIONS(3645),
    [anon_sym__Alignof] = ACTIONS(3645),
    [anon_sym_offsetof] = ACTIONS(3645),
    [anon_sym__Generic] = ACTIONS(3645),
    [anon_sym_asm] = ACTIONS(3645),
    [anon_sym___asm__] = ACTIONS(3645),
    [sym_number_literal] = ACTIONS(3647),
    [anon_sym_L_SQUOTE] = ACTIONS(3647),
    [anon_sym_u_SQUOTE] = ACTIONS(3647),
    [anon_sym_U_SQUOTE] = ACTIONS(3647),
    [anon_sym_u8_SQUOTE] = ACTIONS(3647),
    [anon_sym_SQUOTE] = ACTIONS(3647),
    [anon_sym_L_DQUOTE] = ACTIONS(3647),
    [anon_sym_u_DQUOTE] = ACTIONS(3647),
    [anon_sym_U_DQUOTE] = ACTIONS(3647),
    [anon_sym_u8_DQUOTE] = ACTIONS(3647),
    [anon_sym_DQUOTE] = ACTIONS(3647),
    [sym_true] = ACTIONS(3645),
    [sym_false] = ACTIONS(3645),
    [anon_sym_NULL] = ACTIONS(3645),
    [anon_sym_nullptr] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3645),
    [anon_sym_let] = ACTIONS(3645),
    [anon_sym_This] = ACTIONS(3645),
    [anon_sym_decltype] = ACTIONS(3645),
    [sym_virtual] = ACTIONS(3645),
    [anon_sym_explicit] = ACTIONS(3645),
    [anon_sym_typename] = ACTIONS(3645),
    [anon_sym_template] = ACTIONS(3645),
    [anon_sym_operator] = ACTIONS(3645),
    [anon_sym_try] = ACTIONS(3645),
    [anon_sym_delete] = ACTIONS(3645),
    [anon_sym_throw] = ACTIONS(3645),
    [anon_sym_namespace] = ACTIONS(3645),
    [anon_sym_using] = ACTIONS(3645),
    [anon_sym_static_assert] = ACTIONS(3645),
    [anon_sym_concept] = ACTIONS(3645),
    [anon_sym_co_return] = ACTIONS(3645),
    [anon_sym_co_yield] = ACTIONS(3645),
    [anon_sym_R_DQUOTE] = ACTIONS(3647),
    [anon_sym_LR_DQUOTE] = ACTIONS(3647),
    [anon_sym_uR_DQUOTE] = ACTIONS(3647),
    [anon_sym_UR_DQUOTE] = ACTIONS(3647),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3647),
    [anon_sym_co_await] = ACTIONS(3645),
    [anon_sym_new] = ACTIONS(3645),
    [anon_sym_requires] = ACTIONS(3645),
    [sym_this] = ACTIONS(3645),
    [anon_sym_discard] = ACTIONS(3645),
    [anon_sym_precise] = ACTIONS(3645),
    [anon_sym_shared] = ACTIONS(3645),
    [anon_sym_groupshared] = ACTIONS(3645),
    [anon_sym_uniform] = ACTIONS(3645),
    [anon_sym_row_major] = ACTIONS(3645),
    [anon_sym_column_major] = ACTIONS(3645),
    [anon_sym_globallycoherent] = ACTIONS(3645),
    [anon_sym_centroid] = ACTIONS(3645),
    [anon_sym_noperspective] = ACTIONS(3645),
    [anon_sym_nointerpolation] = ACTIONS(3645),
    [anon_sym_sample] = ACTIONS(3645),
    [anon_sym_linear] = ACTIONS(3645),
    [anon_sym_snorm] = ACTIONS(3645),
    [anon_sym_unorm] = ACTIONS(3645),
    [anon_sym_point] = ACTIONS(3645),
    [anon_sym_line] = ACTIONS(3645),
    [anon_sym_triangleadj] = ACTIONS(3645),
    [anon_sym_lineadj] = ACTIONS(3645),
    [anon_sym_triangle] = ACTIONS(3645),
    [anon_sym_cbuffer] = ACTIONS(3645),
    [anon_sym_interface] = ACTIONS(3645),
    [anon_sym_extension] = ACTIONS(3645),
  },
  [526] = {
    [sym_identifier] = ACTIONS(2210),
    [aux_sym_preproc_include_token1] = ACTIONS(2210),
    [aux_sym_preproc_def_token1] = ACTIONS(2210),
    [aux_sym_preproc_if_token1] = ACTIONS(2210),
    [aux_sym_preproc_if_token2] = ACTIONS(2210),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2210),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2210),
    [sym_preproc_directive] = ACTIONS(2210),
    [anon_sym_LPAREN2] = ACTIONS(2217),
    [anon_sym_BANG] = ACTIONS(2217),
    [anon_sym_TILDE] = ACTIONS(2217),
    [anon_sym_DASH] = ACTIONS(2210),
    [anon_sym_PLUS] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(2217),
    [anon_sym_AMP_AMP] = ACTIONS(2217),
    [anon_sym_AMP] = ACTIONS(2210),
    [anon_sym_COLON] = ACTIONS(2210),
    [anon_sym_SEMI] = ACTIONS(2217),
    [anon_sym___extension__] = ACTIONS(2210),
    [anon_sym_typedef] = ACTIONS(2210),
    [anon_sym_in] = ACTIONS(2210),
    [anon_sym_out] = ACTIONS(2210),
    [anon_sym_inout] = ACTIONS(2210),
    [anon_sym_extern] = ACTIONS(2210),
    [anon_sym___attribute__] = ACTIONS(2210),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2217),
    [anon_sym___declspec] = ACTIONS(2210),
    [anon_sym___based] = ACTIONS(2210),
    [anon_sym___cdecl] = ACTIONS(2210),
    [anon_sym___clrcall] = ACTIONS(2210),
    [anon_sym___stdcall] = ACTIONS(2210),
    [anon_sym___fastcall] = ACTIONS(2210),
    [anon_sym___thiscall] = ACTIONS(2210),
    [anon_sym___vectorcall] = ACTIONS(2210),
    [anon_sym_LBRACE] = ACTIONS(2217),
    [anon_sym_signed] = ACTIONS(2210),
    [anon_sym_unsigned] = ACTIONS(2210),
    [anon_sym_long] = ACTIONS(2210),
    [anon_sym_short] = ACTIONS(2210),
    [anon_sym_LBRACK] = ACTIONS(2210),
    [anon_sym_static] = ACTIONS(2210),
    [anon_sym_register] = ACTIONS(2210),
    [anon_sym_inline] = ACTIONS(2210),
    [anon_sym___inline] = ACTIONS(2210),
    [anon_sym___inline__] = ACTIONS(2210),
    [anon_sym___forceinline] = ACTIONS(2210),
    [anon_sym_thread_local] = ACTIONS(2210),
    [anon_sym___thread] = ACTIONS(2210),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_constexpr] = ACTIONS(2210),
    [anon_sym_volatile] = ACTIONS(2210),
    [anon_sym_restrict] = ACTIONS(2210),
    [anon_sym___restrict__] = ACTIONS(2210),
    [anon_sym__Atomic] = ACTIONS(2210),
    [anon_sym__Noreturn] = ACTIONS(2210),
    [anon_sym_noreturn] = ACTIONS(2210),
    [anon_sym_mutable] = ACTIONS(2210),
    [anon_sym_constinit] = ACTIONS(2210),
    [anon_sym_consteval] = ACTIONS(2210),
    [anon_sym_alignas] = ACTIONS(2210),
    [anon_sym__Alignas] = ACTIONS(2210),
    [sym_primitive_type] = ACTIONS(2210),
    [anon_sym_enum] = ACTIONS(2210),
    [anon_sym_class] = ACTIONS(2210),
    [anon_sym_struct] = ACTIONS(2210),
    [anon_sym_union] = ACTIONS(2210),
    [anon_sym_if] = ACTIONS(2210),
    [anon_sym_else] = ACTIONS(2210),
    [anon_sym_switch] = ACTIONS(2210),
    [anon_sym_case] = ACTIONS(2210),
    [anon_sym_default] = ACTIONS(2210),
    [anon_sym_while] = ACTIONS(2210),
    [anon_sym_do] = ACTIONS(2210),
    [anon_sym_for] = ACTIONS(2210),
    [anon_sym_return] = ACTIONS(2210),
    [anon_sym_break] = ACTIONS(2210),
    [anon_sym_continue] = ACTIONS(2210),
    [anon_sym_goto] = ACTIONS(2210),
    [anon_sym___try] = ACTIONS(2210),
    [anon_sym___leave] = ACTIONS(2210),
    [anon_sym_not] = ACTIONS(2210),
    [anon_sym_compl] = ACTIONS(2210),
    [anon_sym_DASH_DASH] = ACTIONS(2217),
    [anon_sym_PLUS_PLUS] = ACTIONS(2217),
    [anon_sym_sizeof] = ACTIONS(2210),
    [anon_sym___alignof__] = ACTIONS(2210),
    [anon_sym___alignof] = ACTIONS(2210),
    [anon_sym__alignof] = ACTIONS(2210),
    [anon_sym_alignof] = ACTIONS(2210),
    [anon_sym__Alignof] = ACTIONS(2210),
    [anon_sym_offsetof] = ACTIONS(2210),
    [anon_sym__Generic] = ACTIONS(2210),
    [anon_sym_asm] = ACTIONS(2210),
    [anon_sym___asm__] = ACTIONS(2210),
    [sym_number_literal] = ACTIONS(2217),
    [anon_sym_L_SQUOTE] = ACTIONS(2217),
    [anon_sym_u_SQUOTE] = ACTIONS(2217),
    [anon_sym_U_SQUOTE] = ACTIONS(2217),
    [anon_sym_u8_SQUOTE] = ACTIONS(2217),
    [anon_sym_SQUOTE] = ACTIONS(2217),
    [anon_sym_L_DQUOTE] = ACTIONS(2217),
    [anon_sym_u_DQUOTE] = ACTIONS(2217),
    [anon_sym_U_DQUOTE] = ACTIONS(2217),
    [anon_sym_u8_DQUOTE] = ACTIONS(2217),
    [anon_sym_DQUOTE] = ACTIONS(2217),
    [sym_true] = ACTIONS(2210),
    [sym_false] = ACTIONS(2210),
    [anon_sym_NULL] = ACTIONS(2210),
    [anon_sym_nullptr] = ACTIONS(2210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2210),
    [anon_sym_let] = ACTIONS(2210),
    [anon_sym_This] = ACTIONS(2210),
    [anon_sym_decltype] = ACTIONS(2210),
    [anon_sym_final] = ACTIONS(2210),
    [anon_sym_override] = ACTIONS(2210),
    [sym_virtual] = ACTIONS(2210),
    [anon_sym_explicit] = ACTIONS(2210),
    [anon_sym_typename] = ACTIONS(2210),
    [anon_sym_template] = ACTIONS(2210),
    [anon_sym_operator] = ACTIONS(2210),
    [anon_sym_try] = ACTIONS(2210),
    [anon_sym_delete] = ACTIONS(2210),
    [anon_sym_throw] = ACTIONS(2210),
    [anon_sym_namespace] = ACTIONS(2210),
    [anon_sym_using] = ACTIONS(2210),
    [anon_sym_static_assert] = ACTIONS(2210),
    [anon_sym_concept] = ACTIONS(2210),
    [anon_sym_co_return] = ACTIONS(2210),
    [anon_sym_co_yield] = ACTIONS(2210),
    [anon_sym_R_DQUOTE] = ACTIONS(2217),
    [anon_sym_LR_DQUOTE] = ACTIONS(2217),
    [anon_sym_uR_DQUOTE] = ACTIONS(2217),
    [anon_sym_UR_DQUOTE] = ACTIONS(2217),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2217),
    [anon_sym_co_await] = ACTIONS(2210),
    [anon_sym_new] = ACTIONS(2210),
    [anon_sym_requires] = ACTIONS(2210),
    [sym_this] = ACTIONS(2210),
    [anon_sym_discard] = ACTIONS(2210),
    [anon_sym_precise] = ACTIONS(2210),
    [anon_sym_shared] = ACTIONS(2210),
    [anon_sym_groupshared] = ACTIONS(2210),
    [anon_sym_uniform] = ACTIONS(2210),
    [anon_sym_row_major] = ACTIONS(2210),
    [anon_sym_column_major] = ACTIONS(2210),
    [anon_sym_globallycoherent] = ACTIONS(2210),
    [anon_sym_centroid] = ACTIONS(2210),
    [anon_sym_noperspective] = ACTIONS(2210),
    [anon_sym_nointerpolation] = ACTIONS(2210),
    [anon_sym_sample] = ACTIONS(2210),
    [anon_sym_linear] = ACTIONS(2210),
    [anon_sym_snorm] = ACTIONS(2210),
    [anon_sym_unorm] = ACTIONS(2210),
    [anon_sym_point] = ACTIONS(2210),
    [anon_sym_line] = ACTIONS(2210),
    [anon_sym_triangleadj] = ACTIONS(2210),
    [anon_sym_lineadj] = ACTIONS(2210),
    [anon_sym_triangle] = ACTIONS(2210),
    [anon_sym_cbuffer] = ACTIONS(2210),
    [anon_sym_interface] = ACTIONS(2210),
    [anon_sym_extension] = ACTIONS(2210),
  },
  [527] = {
    [sym_identifier] = ACTIONS(3649),
    [aux_sym_preproc_include_token1] = ACTIONS(3649),
    [aux_sym_preproc_def_token1] = ACTIONS(3649),
    [aux_sym_preproc_if_token1] = ACTIONS(3649),
    [aux_sym_preproc_if_token2] = ACTIONS(3649),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3649),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3649),
    [aux_sym_preproc_else_token1] = ACTIONS(3649),
    [aux_sym_preproc_elif_token1] = ACTIONS(3649),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3649),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3649),
    [sym_preproc_directive] = ACTIONS(3649),
    [anon_sym_LPAREN2] = ACTIONS(3651),
    [anon_sym_BANG] = ACTIONS(3651),
    [anon_sym_TILDE] = ACTIONS(3651),
    [anon_sym_DASH] = ACTIONS(3649),
    [anon_sym_PLUS] = ACTIONS(3649),
    [anon_sym_STAR] = ACTIONS(3651),
    [anon_sym_AMP_AMP] = ACTIONS(3651),
    [anon_sym_AMP] = ACTIONS(3649),
    [anon_sym_SEMI] = ACTIONS(3651),
    [anon_sym___extension__] = ACTIONS(3649),
    [anon_sym_typedef] = ACTIONS(3649),
    [anon_sym_in] = ACTIONS(3649),
    [anon_sym_out] = ACTIONS(3649),
    [anon_sym_inout] = ACTIONS(3649),
    [anon_sym_extern] = ACTIONS(3649),
    [anon_sym___attribute__] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(3651),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3651),
    [anon_sym___declspec] = ACTIONS(3649),
    [anon_sym___based] = ACTIONS(3649),
    [anon_sym___cdecl] = ACTIONS(3649),
    [anon_sym___clrcall] = ACTIONS(3649),
    [anon_sym___stdcall] = ACTIONS(3649),
    [anon_sym___fastcall] = ACTIONS(3649),
    [anon_sym___thiscall] = ACTIONS(3649),
    [anon_sym___vectorcall] = ACTIONS(3649),
    [anon_sym_LBRACE] = ACTIONS(3651),
    [anon_sym_signed] = ACTIONS(3649),
    [anon_sym_unsigned] = ACTIONS(3649),
    [anon_sym_long] = ACTIONS(3649),
    [anon_sym_short] = ACTIONS(3649),
    [anon_sym_LBRACK] = ACTIONS(3649),
    [anon_sym_static] = ACTIONS(3649),
    [anon_sym_register] = ACTIONS(3649),
    [anon_sym_inline] = ACTIONS(3649),
    [anon_sym___inline] = ACTIONS(3649),
    [anon_sym___inline__] = ACTIONS(3649),
    [anon_sym___forceinline] = ACTIONS(3649),
    [anon_sym_thread_local] = ACTIONS(3649),
    [anon_sym___thread] = ACTIONS(3649),
    [anon_sym_const] = ACTIONS(3649),
    [anon_sym_constexpr] = ACTIONS(3649),
    [anon_sym_volatile] = ACTIONS(3649),
    [anon_sym_restrict] = ACTIONS(3649),
    [anon_sym___restrict__] = ACTIONS(3649),
    [anon_sym__Atomic] = ACTIONS(3649),
    [anon_sym__Noreturn] = ACTIONS(3649),
    [anon_sym_noreturn] = ACTIONS(3649),
    [anon_sym_mutable] = ACTIONS(3649),
    [anon_sym_constinit] = ACTIONS(3649),
    [anon_sym_consteval] = ACTIONS(3649),
    [anon_sym_alignas] = ACTIONS(3649),
    [anon_sym__Alignas] = ACTIONS(3649),
    [sym_primitive_type] = ACTIONS(3649),
    [anon_sym_enum] = ACTIONS(3649),
    [anon_sym_class] = ACTIONS(3649),
    [anon_sym_struct] = ACTIONS(3649),
    [anon_sym_union] = ACTIONS(3649),
    [anon_sym_if] = ACTIONS(3649),
    [anon_sym_switch] = ACTIONS(3649),
    [anon_sym_case] = ACTIONS(3649),
    [anon_sym_default] = ACTIONS(3649),
    [anon_sym_while] = ACTIONS(3649),
    [anon_sym_do] = ACTIONS(3649),
    [anon_sym_for] = ACTIONS(3649),
    [anon_sym_return] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3649),
    [anon_sym_continue] = ACTIONS(3649),
    [anon_sym_goto] = ACTIONS(3649),
    [anon_sym___try] = ACTIONS(3649),
    [anon_sym___leave] = ACTIONS(3649),
    [anon_sym_not] = ACTIONS(3649),
    [anon_sym_compl] = ACTIONS(3649),
    [anon_sym_DASH_DASH] = ACTIONS(3651),
    [anon_sym_PLUS_PLUS] = ACTIONS(3651),
    [anon_sym_sizeof] = ACTIONS(3649),
    [anon_sym___alignof__] = ACTIONS(3649),
    [anon_sym___alignof] = ACTIONS(3649),
    [anon_sym__alignof] = ACTIONS(3649),
    [anon_sym_alignof] = ACTIONS(3649),
    [anon_sym__Alignof] = ACTIONS(3649),
    [anon_sym_offsetof] = ACTIONS(3649),
    [anon_sym__Generic] = ACTIONS(3649),
    [anon_sym_asm] = ACTIONS(3649),
    [anon_sym___asm__] = ACTIONS(3649),
    [sym_number_literal] = ACTIONS(3651),
    [anon_sym_L_SQUOTE] = ACTIONS(3651),
    [anon_sym_u_SQUOTE] = ACTIONS(3651),
    [anon_sym_U_SQUOTE] = ACTIONS(3651),
    [anon_sym_u8_SQUOTE] = ACTIONS(3651),
    [anon_sym_SQUOTE] = ACTIONS(3651),
    [anon_sym_L_DQUOTE] = ACTIONS(3651),
    [anon_sym_u_DQUOTE] = ACTIONS(3651),
    [anon_sym_U_DQUOTE] = ACTIONS(3651),
    [anon_sym_u8_DQUOTE] = ACTIONS(3651),
    [anon_sym_DQUOTE] = ACTIONS(3651),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [anon_sym_NULL] = ACTIONS(3649),
    [anon_sym_nullptr] = ACTIONS(3649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3649),
    [anon_sym_let] = ACTIONS(3649),
    [anon_sym_This] = ACTIONS(3649),
    [anon_sym_decltype] = ACTIONS(3649),
    [sym_virtual] = ACTIONS(3649),
    [anon_sym_explicit] = ACTIONS(3649),
    [anon_sym_typename] = ACTIONS(3649),
    [anon_sym_template] = ACTIONS(3649),
    [anon_sym_operator] = ACTIONS(3649),
    [anon_sym_try] = ACTIONS(3649),
    [anon_sym_delete] = ACTIONS(3649),
    [anon_sym_throw] = ACTIONS(3649),
    [anon_sym_namespace] = ACTIONS(3649),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_static_assert] = ACTIONS(3649),
    [anon_sym_concept] = ACTIONS(3649),
    [anon_sym_co_return] = ACTIONS(3649),
    [anon_sym_co_yield] = ACTIONS(3649),
    [anon_sym_R_DQUOTE] = ACTIONS(3651),
    [anon_sym_LR_DQUOTE] = ACTIONS(3651),
    [anon_sym_uR_DQUOTE] = ACTIONS(3651),
    [anon_sym_UR_DQUOTE] = ACTIONS(3651),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3651),
    [anon_sym_co_await] = ACTIONS(3649),
    [anon_sym_new] = ACTIONS(3649),
    [anon_sym_requires] = ACTIONS(3649),
    [sym_this] = ACTIONS(3649),
    [anon_sym_discard] = ACTIONS(3649),
    [anon_sym_precise] = ACTIONS(3649),
    [anon_sym_shared] = ACTIONS(3649),
    [anon_sym_groupshared] = ACTIONS(3649),
    [anon_sym_uniform] = ACTIONS(3649),
    [anon_sym_row_major] = ACTIONS(3649),
    [anon_sym_column_major] = ACTIONS(3649),
    [anon_sym_globallycoherent] = ACTIONS(3649),
    [anon_sym_centroid] = ACTIONS(3649),
    [anon_sym_noperspective] = ACTIONS(3649),
    [anon_sym_nointerpolation] = ACTIONS(3649),
    [anon_sym_sample] = ACTIONS(3649),
    [anon_sym_linear] = ACTIONS(3649),
    [anon_sym_snorm] = ACTIONS(3649),
    [anon_sym_unorm] = ACTIONS(3649),
    [anon_sym_point] = ACTIONS(3649),
    [anon_sym_line] = ACTIONS(3649),
    [anon_sym_triangleadj] = ACTIONS(3649),
    [anon_sym_lineadj] = ACTIONS(3649),
    [anon_sym_triangle] = ACTIONS(3649),
    [anon_sym_cbuffer] = ACTIONS(3649),
    [anon_sym_interface] = ACTIONS(3649),
    [anon_sym_extension] = ACTIONS(3649),
  },
  [528] = {
    [sym_identifier] = ACTIONS(2240),
    [aux_sym_preproc_include_token1] = ACTIONS(2240),
    [aux_sym_preproc_def_token1] = ACTIONS(2240),
    [aux_sym_preproc_if_token1] = ACTIONS(2240),
    [aux_sym_preproc_if_token2] = ACTIONS(2240),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2240),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2240),
    [sym_preproc_directive] = ACTIONS(2240),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2242),
    [anon_sym_TILDE] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2240),
    [anon_sym_PLUS] = ACTIONS(2240),
    [anon_sym_STAR] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_AMP] = ACTIONS(2240),
    [anon_sym_COLON] = ACTIONS(2240),
    [anon_sym_SEMI] = ACTIONS(2242),
    [anon_sym___extension__] = ACTIONS(2240),
    [anon_sym_typedef] = ACTIONS(2240),
    [anon_sym_in] = ACTIONS(2240),
    [anon_sym_out] = ACTIONS(2240),
    [anon_sym_inout] = ACTIONS(2240),
    [anon_sym_extern] = ACTIONS(2240),
    [anon_sym___attribute__] = ACTIONS(2240),
    [anon_sym_COLON_COLON] = ACTIONS(2242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2242),
    [anon_sym___declspec] = ACTIONS(2240),
    [anon_sym___based] = ACTIONS(2240),
    [anon_sym___cdecl] = ACTIONS(2240),
    [anon_sym___clrcall] = ACTIONS(2240),
    [anon_sym___stdcall] = ACTIONS(2240),
    [anon_sym___fastcall] = ACTIONS(2240),
    [anon_sym___thiscall] = ACTIONS(2240),
    [anon_sym___vectorcall] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_signed] = ACTIONS(2240),
    [anon_sym_unsigned] = ACTIONS(2240),
    [anon_sym_long] = ACTIONS(2240),
    [anon_sym_short] = ACTIONS(2240),
    [anon_sym_LBRACK] = ACTIONS(2240),
    [anon_sym_static] = ACTIONS(2240),
    [anon_sym_register] = ACTIONS(2240),
    [anon_sym_inline] = ACTIONS(2240),
    [anon_sym___inline] = ACTIONS(2240),
    [anon_sym___inline__] = ACTIONS(2240),
    [anon_sym___forceinline] = ACTIONS(2240),
    [anon_sym_thread_local] = ACTIONS(2240),
    [anon_sym___thread] = ACTIONS(2240),
    [anon_sym_const] = ACTIONS(2240),
    [anon_sym_constexpr] = ACTIONS(2240),
    [anon_sym_volatile] = ACTIONS(2240),
    [anon_sym_restrict] = ACTIONS(2240),
    [anon_sym___restrict__] = ACTIONS(2240),
    [anon_sym__Atomic] = ACTIONS(2240),
    [anon_sym__Noreturn] = ACTIONS(2240),
    [anon_sym_noreturn] = ACTIONS(2240),
    [anon_sym_mutable] = ACTIONS(2240),
    [anon_sym_constinit] = ACTIONS(2240),
    [anon_sym_consteval] = ACTIONS(2240),
    [anon_sym_alignas] = ACTIONS(2240),
    [anon_sym__Alignas] = ACTIONS(2240),
    [sym_primitive_type] = ACTIONS(2240),
    [anon_sym_enum] = ACTIONS(2240),
    [anon_sym_class] = ACTIONS(2240),
    [anon_sym_struct] = ACTIONS(2240),
    [anon_sym_union] = ACTIONS(2240),
    [anon_sym_if] = ACTIONS(2240),
    [anon_sym_else] = ACTIONS(2240),
    [anon_sym_switch] = ACTIONS(2240),
    [anon_sym_case] = ACTIONS(2240),
    [anon_sym_default] = ACTIONS(2240),
    [anon_sym_while] = ACTIONS(2240),
    [anon_sym_do] = ACTIONS(2240),
    [anon_sym_for] = ACTIONS(2240),
    [anon_sym_return] = ACTIONS(2240),
    [anon_sym_break] = ACTIONS(2240),
    [anon_sym_continue] = ACTIONS(2240),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym___try] = ACTIONS(2240),
    [anon_sym___leave] = ACTIONS(2240),
    [anon_sym_not] = ACTIONS(2240),
    [anon_sym_compl] = ACTIONS(2240),
    [anon_sym_DASH_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_PLUS] = ACTIONS(2242),
    [anon_sym_sizeof] = ACTIONS(2240),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2240),
    [anon_sym__Generic] = ACTIONS(2240),
    [anon_sym_asm] = ACTIONS(2240),
    [anon_sym___asm__] = ACTIONS(2240),
    [sym_number_literal] = ACTIONS(2242),
    [anon_sym_L_SQUOTE] = ACTIONS(2242),
    [anon_sym_u_SQUOTE] = ACTIONS(2242),
    [anon_sym_U_SQUOTE] = ACTIONS(2242),
    [anon_sym_u8_SQUOTE] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(2242),
    [anon_sym_L_DQUOTE] = ACTIONS(2242),
    [anon_sym_u_DQUOTE] = ACTIONS(2242),
    [anon_sym_U_DQUOTE] = ACTIONS(2242),
    [anon_sym_u8_DQUOTE] = ACTIONS(2242),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [sym_true] = ACTIONS(2240),
    [sym_false] = ACTIONS(2240),
    [anon_sym_NULL] = ACTIONS(2240),
    [anon_sym_nullptr] = ACTIONS(2240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2240),
    [anon_sym_let] = ACTIONS(2240),
    [anon_sym_This] = ACTIONS(2240),
    [anon_sym_decltype] = ACTIONS(2240),
    [anon_sym_final] = ACTIONS(2240),
    [anon_sym_override] = ACTIONS(2240),
    [sym_virtual] = ACTIONS(2240),
    [anon_sym_explicit] = ACTIONS(2240),
    [anon_sym_typename] = ACTIONS(2240),
    [anon_sym_template] = ACTIONS(2240),
    [anon_sym_operator] = ACTIONS(2240),
    [anon_sym_try] = ACTIONS(2240),
    [anon_sym_delete] = ACTIONS(2240),
    [anon_sym_throw] = ACTIONS(2240),
    [anon_sym_namespace] = ACTIONS(2240),
    [anon_sym_using] = ACTIONS(2240),
    [anon_sym_static_assert] = ACTIONS(2240),
    [anon_sym_concept] = ACTIONS(2240),
    [anon_sym_co_return] = ACTIONS(2240),
    [anon_sym_co_yield] = ACTIONS(2240),
    [anon_sym_R_DQUOTE] = ACTIONS(2242),
    [anon_sym_LR_DQUOTE] = ACTIONS(2242),
    [anon_sym_uR_DQUOTE] = ACTIONS(2242),
    [anon_sym_UR_DQUOTE] = ACTIONS(2242),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2242),
    [anon_sym_co_await] = ACTIONS(2240),
    [anon_sym_new] = ACTIONS(2240),
    [anon_sym_requires] = ACTIONS(2240),
    [sym_this] = ACTIONS(2240),
    [anon_sym_discard] = ACTIONS(2240),
    [anon_sym_precise] = ACTIONS(2240),
    [anon_sym_shared] = ACTIONS(2240),
    [anon_sym_groupshared] = ACTIONS(2240),
    [anon_sym_uniform] = ACTIONS(2240),
    [anon_sym_row_major] = ACTIONS(2240),
    [anon_sym_column_major] = ACTIONS(2240),
    [anon_sym_globallycoherent] = ACTIONS(2240),
    [anon_sym_centroid] = ACTIONS(2240),
    [anon_sym_noperspective] = ACTIONS(2240),
    [anon_sym_nointerpolation] = ACTIONS(2240),
    [anon_sym_sample] = ACTIONS(2240),
    [anon_sym_linear] = ACTIONS(2240),
    [anon_sym_snorm] = ACTIONS(2240),
    [anon_sym_unorm] = ACTIONS(2240),
    [anon_sym_point] = ACTIONS(2240),
    [anon_sym_line] = ACTIONS(2240),
    [anon_sym_triangleadj] = ACTIONS(2240),
    [anon_sym_lineadj] = ACTIONS(2240),
    [anon_sym_triangle] = ACTIONS(2240),
    [anon_sym_cbuffer] = ACTIONS(2240),
    [anon_sym_interface] = ACTIONS(2240),
    [anon_sym_extension] = ACTIONS(2240),
  },
  [529] = {
    [sym_identifier] = ACTIONS(2194),
    [aux_sym_preproc_include_token1] = ACTIONS(2194),
    [aux_sym_preproc_def_token1] = ACTIONS(2194),
    [aux_sym_preproc_if_token1] = ACTIONS(2194),
    [aux_sym_preproc_if_token2] = ACTIONS(2194),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2194),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2194),
    [sym_preproc_directive] = ACTIONS(2194),
    [anon_sym_LPAREN2] = ACTIONS(2196),
    [anon_sym_BANG] = ACTIONS(2196),
    [anon_sym_TILDE] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2194),
    [anon_sym_PLUS] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(2196),
    [anon_sym_AMP_AMP] = ACTIONS(2196),
    [anon_sym_AMP] = ACTIONS(2194),
    [anon_sym_COLON] = ACTIONS(2194),
    [anon_sym_SEMI] = ACTIONS(2196),
    [anon_sym___extension__] = ACTIONS(2194),
    [anon_sym_typedef] = ACTIONS(2194),
    [anon_sym_in] = ACTIONS(2194),
    [anon_sym_out] = ACTIONS(2194),
    [anon_sym_inout] = ACTIONS(2194),
    [anon_sym_extern] = ACTIONS(2194),
    [anon_sym___attribute__] = ACTIONS(2194),
    [anon_sym_COLON_COLON] = ACTIONS(2196),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2196),
    [anon_sym___declspec] = ACTIONS(2194),
    [anon_sym___based] = ACTIONS(2194),
    [anon_sym___cdecl] = ACTIONS(2194),
    [anon_sym___clrcall] = ACTIONS(2194),
    [anon_sym___stdcall] = ACTIONS(2194),
    [anon_sym___fastcall] = ACTIONS(2194),
    [anon_sym___thiscall] = ACTIONS(2194),
    [anon_sym___vectorcall] = ACTIONS(2194),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_signed] = ACTIONS(2194),
    [anon_sym_unsigned] = ACTIONS(2194),
    [anon_sym_long] = ACTIONS(2194),
    [anon_sym_short] = ACTIONS(2194),
    [anon_sym_LBRACK] = ACTIONS(2194),
    [anon_sym_static] = ACTIONS(2194),
    [anon_sym_register] = ACTIONS(2194),
    [anon_sym_inline] = ACTIONS(2194),
    [anon_sym___inline] = ACTIONS(2194),
    [anon_sym___inline__] = ACTIONS(2194),
    [anon_sym___forceinline] = ACTIONS(2194),
    [anon_sym_thread_local] = ACTIONS(2194),
    [anon_sym___thread] = ACTIONS(2194),
    [anon_sym_const] = ACTIONS(2194),
    [anon_sym_constexpr] = ACTIONS(2194),
    [anon_sym_volatile] = ACTIONS(2194),
    [anon_sym_restrict] = ACTIONS(2194),
    [anon_sym___restrict__] = ACTIONS(2194),
    [anon_sym__Atomic] = ACTIONS(2194),
    [anon_sym__Noreturn] = ACTIONS(2194),
    [anon_sym_noreturn] = ACTIONS(2194),
    [anon_sym_mutable] = ACTIONS(2194),
    [anon_sym_constinit] = ACTIONS(2194),
    [anon_sym_consteval] = ACTIONS(2194),
    [anon_sym_alignas] = ACTIONS(2194),
    [anon_sym__Alignas] = ACTIONS(2194),
    [sym_primitive_type] = ACTIONS(2194),
    [anon_sym_enum] = ACTIONS(2194),
    [anon_sym_class] = ACTIONS(2194),
    [anon_sym_struct] = ACTIONS(2194),
    [anon_sym_union] = ACTIONS(2194),
    [anon_sym_if] = ACTIONS(2194),
    [anon_sym_else] = ACTIONS(2194),
    [anon_sym_switch] = ACTIONS(2194),
    [anon_sym_case] = ACTIONS(2194),
    [anon_sym_default] = ACTIONS(2194),
    [anon_sym_while] = ACTIONS(2194),
    [anon_sym_do] = ACTIONS(2194),
    [anon_sym_for] = ACTIONS(2194),
    [anon_sym_return] = ACTIONS(2194),
    [anon_sym_break] = ACTIONS(2194),
    [anon_sym_continue] = ACTIONS(2194),
    [anon_sym_goto] = ACTIONS(2194),
    [anon_sym___try] = ACTIONS(2194),
    [anon_sym___leave] = ACTIONS(2194),
    [anon_sym_not] = ACTIONS(2194),
    [anon_sym_compl] = ACTIONS(2194),
    [anon_sym_DASH_DASH] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2196),
    [anon_sym_sizeof] = ACTIONS(2194),
    [anon_sym___alignof__] = ACTIONS(2194),
    [anon_sym___alignof] = ACTIONS(2194),
    [anon_sym__alignof] = ACTIONS(2194),
    [anon_sym_alignof] = ACTIONS(2194),
    [anon_sym__Alignof] = ACTIONS(2194),
    [anon_sym_offsetof] = ACTIONS(2194),
    [anon_sym__Generic] = ACTIONS(2194),
    [anon_sym_asm] = ACTIONS(2194),
    [anon_sym___asm__] = ACTIONS(2194),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_L_SQUOTE] = ACTIONS(2196),
    [anon_sym_u_SQUOTE] = ACTIONS(2196),
    [anon_sym_U_SQUOTE] = ACTIONS(2196),
    [anon_sym_u8_SQUOTE] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(2196),
    [anon_sym_L_DQUOTE] = ACTIONS(2196),
    [anon_sym_u_DQUOTE] = ACTIONS(2196),
    [anon_sym_U_DQUOTE] = ACTIONS(2196),
    [anon_sym_u8_DQUOTE] = ACTIONS(2196),
    [anon_sym_DQUOTE] = ACTIONS(2196),
    [sym_true] = ACTIONS(2194),
    [sym_false] = ACTIONS(2194),
    [anon_sym_NULL] = ACTIONS(2194),
    [anon_sym_nullptr] = ACTIONS(2194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2194),
    [anon_sym_let] = ACTIONS(2194),
    [anon_sym_This] = ACTIONS(2194),
    [anon_sym_decltype] = ACTIONS(2194),
    [anon_sym_final] = ACTIONS(2194),
    [anon_sym_override] = ACTIONS(2194),
    [sym_virtual] = ACTIONS(2194),
    [anon_sym_explicit] = ACTIONS(2194),
    [anon_sym_typename] = ACTIONS(2194),
    [anon_sym_template] = ACTIONS(2194),
    [anon_sym_operator] = ACTIONS(2194),
    [anon_sym_try] = ACTIONS(2194),
    [anon_sym_delete] = ACTIONS(2194),
    [anon_sym_throw] = ACTIONS(2194),
    [anon_sym_namespace] = ACTIONS(2194),
    [anon_sym_using] = ACTIONS(2194),
    [anon_sym_static_assert] = ACTIONS(2194),
    [anon_sym_concept] = ACTIONS(2194),
    [anon_sym_co_return] = ACTIONS(2194),
    [anon_sym_co_yield] = ACTIONS(2194),
    [anon_sym_R_DQUOTE] = ACTIONS(2196),
    [anon_sym_LR_DQUOTE] = ACTIONS(2196),
    [anon_sym_uR_DQUOTE] = ACTIONS(2196),
    [anon_sym_UR_DQUOTE] = ACTIONS(2196),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2196),
    [anon_sym_co_await] = ACTIONS(2194),
    [anon_sym_new] = ACTIONS(2194),
    [anon_sym_requires] = ACTIONS(2194),
    [sym_this] = ACTIONS(2194),
    [anon_sym_discard] = ACTIONS(2194),
    [anon_sym_precise] = ACTIONS(2194),
    [anon_sym_shared] = ACTIONS(2194),
    [anon_sym_groupshared] = ACTIONS(2194),
    [anon_sym_uniform] = ACTIONS(2194),
    [anon_sym_row_major] = ACTIONS(2194),
    [anon_sym_column_major] = ACTIONS(2194),
    [anon_sym_globallycoherent] = ACTIONS(2194),
    [anon_sym_centroid] = ACTIONS(2194),
    [anon_sym_noperspective] = ACTIONS(2194),
    [anon_sym_nointerpolation] = ACTIONS(2194),
    [anon_sym_sample] = ACTIONS(2194),
    [anon_sym_linear] = ACTIONS(2194),
    [anon_sym_snorm] = ACTIONS(2194),
    [anon_sym_unorm] = ACTIONS(2194),
    [anon_sym_point] = ACTIONS(2194),
    [anon_sym_line] = ACTIONS(2194),
    [anon_sym_triangleadj] = ACTIONS(2194),
    [anon_sym_lineadj] = ACTIONS(2194),
    [anon_sym_triangle] = ACTIONS(2194),
    [anon_sym_cbuffer] = ACTIONS(2194),
    [anon_sym_interface] = ACTIONS(2194),
    [anon_sym_extension] = ACTIONS(2194),
  },
  [530] = {
    [sym_identifier] = ACTIONS(2190),
    [aux_sym_preproc_include_token1] = ACTIONS(2190),
    [aux_sym_preproc_def_token1] = ACTIONS(2190),
    [aux_sym_preproc_if_token1] = ACTIONS(2190),
    [aux_sym_preproc_if_token2] = ACTIONS(2190),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2190),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2190),
    [sym_preproc_directive] = ACTIONS(2190),
    [anon_sym_LPAREN2] = ACTIONS(2192),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2190),
    [anon_sym_PLUS] = ACTIONS(2190),
    [anon_sym_STAR] = ACTIONS(2192),
    [anon_sym_AMP_AMP] = ACTIONS(2192),
    [anon_sym_AMP] = ACTIONS(2190),
    [anon_sym_COLON] = ACTIONS(2190),
    [anon_sym_SEMI] = ACTIONS(2192),
    [anon_sym___extension__] = ACTIONS(2190),
    [anon_sym_typedef] = ACTIONS(2190),
    [anon_sym_in] = ACTIONS(2190),
    [anon_sym_out] = ACTIONS(2190),
    [anon_sym_inout] = ACTIONS(2190),
    [anon_sym_extern] = ACTIONS(2190),
    [anon_sym___attribute__] = ACTIONS(2190),
    [anon_sym_COLON_COLON] = ACTIONS(2192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2192),
    [anon_sym___declspec] = ACTIONS(2190),
    [anon_sym___based] = ACTIONS(2190),
    [anon_sym___cdecl] = ACTIONS(2190),
    [anon_sym___clrcall] = ACTIONS(2190),
    [anon_sym___stdcall] = ACTIONS(2190),
    [anon_sym___fastcall] = ACTIONS(2190),
    [anon_sym___thiscall] = ACTIONS(2190),
    [anon_sym___vectorcall] = ACTIONS(2190),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [anon_sym_signed] = ACTIONS(2190),
    [anon_sym_unsigned] = ACTIONS(2190),
    [anon_sym_long] = ACTIONS(2190),
    [anon_sym_short] = ACTIONS(2190),
    [anon_sym_LBRACK] = ACTIONS(2190),
    [anon_sym_static] = ACTIONS(2190),
    [anon_sym_register] = ACTIONS(2190),
    [anon_sym_inline] = ACTIONS(2190),
    [anon_sym___inline] = ACTIONS(2190),
    [anon_sym___inline__] = ACTIONS(2190),
    [anon_sym___forceinline] = ACTIONS(2190),
    [anon_sym_thread_local] = ACTIONS(2190),
    [anon_sym___thread] = ACTIONS(2190),
    [anon_sym_const] = ACTIONS(2190),
    [anon_sym_constexpr] = ACTIONS(2190),
    [anon_sym_volatile] = ACTIONS(2190),
    [anon_sym_restrict] = ACTIONS(2190),
    [anon_sym___restrict__] = ACTIONS(2190),
    [anon_sym__Atomic] = ACTIONS(2190),
    [anon_sym__Noreturn] = ACTIONS(2190),
    [anon_sym_noreturn] = ACTIONS(2190),
    [anon_sym_mutable] = ACTIONS(2190),
    [anon_sym_constinit] = ACTIONS(2190),
    [anon_sym_consteval] = ACTIONS(2190),
    [anon_sym_alignas] = ACTIONS(2190),
    [anon_sym__Alignas] = ACTIONS(2190),
    [sym_primitive_type] = ACTIONS(2190),
    [anon_sym_enum] = ACTIONS(2190),
    [anon_sym_class] = ACTIONS(2190),
    [anon_sym_struct] = ACTIONS(2190),
    [anon_sym_union] = ACTIONS(2190),
    [anon_sym_if] = ACTIONS(2190),
    [anon_sym_else] = ACTIONS(2190),
    [anon_sym_switch] = ACTIONS(2190),
    [anon_sym_case] = ACTIONS(2190),
    [anon_sym_default] = ACTIONS(2190),
    [anon_sym_while] = ACTIONS(2190),
    [anon_sym_do] = ACTIONS(2190),
    [anon_sym_for] = ACTIONS(2190),
    [anon_sym_return] = ACTIONS(2190),
    [anon_sym_break] = ACTIONS(2190),
    [anon_sym_continue] = ACTIONS(2190),
    [anon_sym_goto] = ACTIONS(2190),
    [anon_sym___try] = ACTIONS(2190),
    [anon_sym___leave] = ACTIONS(2190),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_compl] = ACTIONS(2190),
    [anon_sym_DASH_DASH] = ACTIONS(2192),
    [anon_sym_PLUS_PLUS] = ACTIONS(2192),
    [anon_sym_sizeof] = ACTIONS(2190),
    [anon_sym___alignof__] = ACTIONS(2190),
    [anon_sym___alignof] = ACTIONS(2190),
    [anon_sym__alignof] = ACTIONS(2190),
    [anon_sym_alignof] = ACTIONS(2190),
    [anon_sym__Alignof] = ACTIONS(2190),
    [anon_sym_offsetof] = ACTIONS(2190),
    [anon_sym__Generic] = ACTIONS(2190),
    [anon_sym_asm] = ACTIONS(2190),
    [anon_sym___asm__] = ACTIONS(2190),
    [sym_number_literal] = ACTIONS(2192),
    [anon_sym_L_SQUOTE] = ACTIONS(2192),
    [anon_sym_u_SQUOTE] = ACTIONS(2192),
    [anon_sym_U_SQUOTE] = ACTIONS(2192),
    [anon_sym_u8_SQUOTE] = ACTIONS(2192),
    [anon_sym_SQUOTE] = ACTIONS(2192),
    [anon_sym_L_DQUOTE] = ACTIONS(2192),
    [anon_sym_u_DQUOTE] = ACTIONS(2192),
    [anon_sym_U_DQUOTE] = ACTIONS(2192),
    [anon_sym_u8_DQUOTE] = ACTIONS(2192),
    [anon_sym_DQUOTE] = ACTIONS(2192),
    [sym_true] = ACTIONS(2190),
    [sym_false] = ACTIONS(2190),
    [anon_sym_NULL] = ACTIONS(2190),
    [anon_sym_nullptr] = ACTIONS(2190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2190),
    [anon_sym_let] = ACTIONS(2190),
    [anon_sym_This] = ACTIONS(2190),
    [anon_sym_decltype] = ACTIONS(2190),
    [anon_sym_final] = ACTIONS(2190),
    [anon_sym_override] = ACTIONS(2190),
    [sym_virtual] = ACTIONS(2190),
    [anon_sym_explicit] = ACTIONS(2190),
    [anon_sym_typename] = ACTIONS(2190),
    [anon_sym_template] = ACTIONS(2190),
    [anon_sym_operator] = ACTIONS(2190),
    [anon_sym_try] = ACTIONS(2190),
    [anon_sym_delete] = ACTIONS(2190),
    [anon_sym_throw] = ACTIONS(2190),
    [anon_sym_namespace] = ACTIONS(2190),
    [anon_sym_using] = ACTIONS(2190),
    [anon_sym_static_assert] = ACTIONS(2190),
    [anon_sym_concept] = ACTIONS(2190),
    [anon_sym_co_return] = ACTIONS(2190),
    [anon_sym_co_yield] = ACTIONS(2190),
    [anon_sym_R_DQUOTE] = ACTIONS(2192),
    [anon_sym_LR_DQUOTE] = ACTIONS(2192),
    [anon_sym_uR_DQUOTE] = ACTIONS(2192),
    [anon_sym_UR_DQUOTE] = ACTIONS(2192),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2192),
    [anon_sym_co_await] = ACTIONS(2190),
    [anon_sym_new] = ACTIONS(2190),
    [anon_sym_requires] = ACTIONS(2190),
    [sym_this] = ACTIONS(2190),
    [anon_sym_discard] = ACTIONS(2190),
    [anon_sym_precise] = ACTIONS(2190),
    [anon_sym_shared] = ACTIONS(2190),
    [anon_sym_groupshared] = ACTIONS(2190),
    [anon_sym_uniform] = ACTIONS(2190),
    [anon_sym_row_major] = ACTIONS(2190),
    [anon_sym_column_major] = ACTIONS(2190),
    [anon_sym_globallycoherent] = ACTIONS(2190),
    [anon_sym_centroid] = ACTIONS(2190),
    [anon_sym_noperspective] = ACTIONS(2190),
    [anon_sym_nointerpolation] = ACTIONS(2190),
    [anon_sym_sample] = ACTIONS(2190),
    [anon_sym_linear] = ACTIONS(2190),
    [anon_sym_snorm] = ACTIONS(2190),
    [anon_sym_unorm] = ACTIONS(2190),
    [anon_sym_point] = ACTIONS(2190),
    [anon_sym_line] = ACTIONS(2190),
    [anon_sym_triangleadj] = ACTIONS(2190),
    [anon_sym_lineadj] = ACTIONS(2190),
    [anon_sym_triangle] = ACTIONS(2190),
    [anon_sym_cbuffer] = ACTIONS(2190),
    [anon_sym_interface] = ACTIONS(2190),
    [anon_sym_extension] = ACTIONS(2190),
  },
  [531] = {
    [sym_catch_clause] = STATE(531),
    [aux_sym_constructor_try_statement_repeat1] = STATE(531),
    [sym_identifier] = ACTIONS(2731),
    [aux_sym_preproc_include_token1] = ACTIONS(2731),
    [aux_sym_preproc_def_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(2733),
    [anon_sym_BANG] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2731),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_AMP_AMP] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2731),
    [anon_sym_SEMI] = ACTIONS(2733),
    [anon_sym___extension__] = ACTIONS(2731),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_in] = ACTIONS(2731),
    [anon_sym_out] = ACTIONS(2731),
    [anon_sym_inout] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym___based] = ACTIONS(2731),
    [anon_sym___cdecl] = ACTIONS(2731),
    [anon_sym___clrcall] = ACTIONS(2731),
    [anon_sym___stdcall] = ACTIONS(2731),
    [anon_sym___fastcall] = ACTIONS(2731),
    [anon_sym___thiscall] = ACTIONS(2731),
    [anon_sym___vectorcall] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2733),
    [anon_sym_RBRACE] = ACTIONS(2733),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym__Alignas] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [anon_sym_if] = ACTIONS(2731),
    [anon_sym_else] = ACTIONS(2731),
    [anon_sym_switch] = ACTIONS(2731),
    [anon_sym_case] = ACTIONS(2731),
    [anon_sym_default] = ACTIONS(2731),
    [anon_sym_while] = ACTIONS(2731),
    [anon_sym_do] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2731),
    [anon_sym_return] = ACTIONS(2731),
    [anon_sym_break] = ACTIONS(2731),
    [anon_sym_continue] = ACTIONS(2731),
    [anon_sym_goto] = ACTIONS(2731),
    [anon_sym___try] = ACTIONS(2731),
    [anon_sym___leave] = ACTIONS(2731),
    [anon_sym_not] = ACTIONS(2731),
    [anon_sym_compl] = ACTIONS(2731),
    [anon_sym_DASH_DASH] = ACTIONS(2733),
    [anon_sym_PLUS_PLUS] = ACTIONS(2733),
    [anon_sym_sizeof] = ACTIONS(2731),
    [anon_sym___alignof__] = ACTIONS(2731),
    [anon_sym___alignof] = ACTIONS(2731),
    [anon_sym__alignof] = ACTIONS(2731),
    [anon_sym_alignof] = ACTIONS(2731),
    [anon_sym__Alignof] = ACTIONS(2731),
    [anon_sym_offsetof] = ACTIONS(2731),
    [anon_sym__Generic] = ACTIONS(2731),
    [anon_sym_asm] = ACTIONS(2731),
    [anon_sym___asm__] = ACTIONS(2731),
    [sym_number_literal] = ACTIONS(2733),
    [anon_sym_L_SQUOTE] = ACTIONS(2733),
    [anon_sym_u_SQUOTE] = ACTIONS(2733),
    [anon_sym_U_SQUOTE] = ACTIONS(2733),
    [anon_sym_u8_SQUOTE] = ACTIONS(2733),
    [anon_sym_SQUOTE] = ACTIONS(2733),
    [anon_sym_L_DQUOTE] = ACTIONS(2733),
    [anon_sym_u_DQUOTE] = ACTIONS(2733),
    [anon_sym_U_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8_DQUOTE] = ACTIONS(2733),
    [anon_sym_DQUOTE] = ACTIONS(2733),
    [sym_true] = ACTIONS(2731),
    [sym_false] = ACTIONS(2731),
    [anon_sym_NULL] = ACTIONS(2731),
    [anon_sym_nullptr] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2731),
    [anon_sym_let] = ACTIONS(2731),
    [anon_sym_This] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(2731),
    [sym_virtual] = ACTIONS(2731),
    [anon_sym_explicit] = ACTIONS(2731),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(2731),
    [anon_sym_operator] = ACTIONS(2731),
    [anon_sym_try] = ACTIONS(2731),
    [anon_sym_delete] = ACTIONS(2731),
    [anon_sym_throw] = ACTIONS(2731),
    [anon_sym_namespace] = ACTIONS(2731),
    [anon_sym_using] = ACTIONS(2731),
    [anon_sym_static_assert] = ACTIONS(2731),
    [anon_sym_concept] = ACTIONS(2731),
    [anon_sym_co_return] = ACTIONS(2731),
    [anon_sym_co_yield] = ACTIONS(2731),
    [anon_sym_catch] = ACTIONS(3653),
    [anon_sym_R_DQUOTE] = ACTIONS(2733),
    [anon_sym_LR_DQUOTE] = ACTIONS(2733),
    [anon_sym_uR_DQUOTE] = ACTIONS(2733),
    [anon_sym_UR_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2733),
    [anon_sym_co_await] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2731),
    [anon_sym_requires] = ACTIONS(2731),
    [sym_this] = ACTIONS(2731),
    [anon_sym_discard] = ACTIONS(2731),
    [anon_sym_precise] = ACTIONS(2731),
    [anon_sym_shared] = ACTIONS(2731),
    [anon_sym_groupshared] = ACTIONS(2731),
    [anon_sym_uniform] = ACTIONS(2731),
    [anon_sym_row_major] = ACTIONS(2731),
    [anon_sym_column_major] = ACTIONS(2731),
    [anon_sym_globallycoherent] = ACTIONS(2731),
    [anon_sym_centroid] = ACTIONS(2731),
    [anon_sym_noperspective] = ACTIONS(2731),
    [anon_sym_nointerpolation] = ACTIONS(2731),
    [anon_sym_sample] = ACTIONS(2731),
    [anon_sym_linear] = ACTIONS(2731),
    [anon_sym_snorm] = ACTIONS(2731),
    [anon_sym_unorm] = ACTIONS(2731),
    [anon_sym_point] = ACTIONS(2731),
    [anon_sym_line] = ACTIONS(2731),
    [anon_sym_triangleadj] = ACTIONS(2731),
    [anon_sym_lineadj] = ACTIONS(2731),
    [anon_sym_triangle] = ACTIONS(2731),
    [anon_sym_cbuffer] = ACTIONS(2731),
    [anon_sym_interface] = ACTIONS(2731),
    [anon_sym_extension] = ACTIONS(2731),
  },
  [532] = {
    [sym_argument_list] = STATE(3305),
    [sym_initializer_list] = STATE(4688),
    [aux_sym_sized_type_specifier_repeat1] = STATE(629),
    [sym_identifier] = ACTIONS(2742),
    [aux_sym_preproc_include_token1] = ACTIONS(2742),
    [aux_sym_preproc_def_token1] = ACTIONS(2742),
    [aux_sym_preproc_if_token1] = ACTIONS(2742),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2742),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2742),
    [sym_preproc_directive] = ACTIONS(2742),
    [anon_sym_LPAREN2] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(2740),
    [anon_sym_TILDE] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2742),
    [anon_sym_PLUS] = ACTIONS(2742),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym___extension__] = ACTIONS(2742),
    [anon_sym_typedef] = ACTIONS(2742),
    [anon_sym_in] = ACTIONS(2742),
    [anon_sym_out] = ACTIONS(2742),
    [anon_sym_inout] = ACTIONS(2742),
    [anon_sym_extern] = ACTIONS(2742),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym_COLON_COLON] = ACTIONS(2740),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2740),
    [anon_sym___declspec] = ACTIONS(2742),
    [anon_sym___based] = ACTIONS(2742),
    [anon_sym___cdecl] = ACTIONS(2742),
    [anon_sym___clrcall] = ACTIONS(2742),
    [anon_sym___stdcall] = ACTIONS(2742),
    [anon_sym___fastcall] = ACTIONS(2742),
    [anon_sym___thiscall] = ACTIONS(2742),
    [anon_sym___vectorcall] = ACTIONS(2742),
    [anon_sym_LBRACE] = ACTIONS(3659),
    [anon_sym_RBRACE] = ACTIONS(2740),
    [anon_sym_signed] = ACTIONS(3662),
    [anon_sym_unsigned] = ACTIONS(3662),
    [anon_sym_long] = ACTIONS(3662),
    [anon_sym_short] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2742),
    [anon_sym_register] = ACTIONS(2742),
    [anon_sym_inline] = ACTIONS(2742),
    [anon_sym___inline] = ACTIONS(2742),
    [anon_sym___inline__] = ACTIONS(2742),
    [anon_sym___forceinline] = ACTIONS(2742),
    [anon_sym_thread_local] = ACTIONS(2742),
    [anon_sym___thread] = ACTIONS(2742),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_constexpr] = ACTIONS(2742),
    [anon_sym_volatile] = ACTIONS(2742),
    [anon_sym_restrict] = ACTIONS(2742),
    [anon_sym___restrict__] = ACTIONS(2742),
    [anon_sym__Atomic] = ACTIONS(2742),
    [anon_sym__Noreturn] = ACTIONS(2742),
    [anon_sym_noreturn] = ACTIONS(2742),
    [anon_sym_mutable] = ACTIONS(2742),
    [anon_sym_constinit] = ACTIONS(2742),
    [anon_sym_consteval] = ACTIONS(2742),
    [anon_sym_alignas] = ACTIONS(2742),
    [anon_sym__Alignas] = ACTIONS(2742),
    [sym_primitive_type] = ACTIONS(2742),
    [anon_sym_enum] = ACTIONS(2742),
    [anon_sym_class] = ACTIONS(2742),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2742),
    [anon_sym_if] = ACTIONS(2742),
    [anon_sym_switch] = ACTIONS(2742),
    [anon_sym_case] = ACTIONS(2742),
    [anon_sym_default] = ACTIONS(2742),
    [anon_sym_while] = ACTIONS(2742),
    [anon_sym_do] = ACTIONS(2742),
    [anon_sym_for] = ACTIONS(2742),
    [anon_sym_return] = ACTIONS(2742),
    [anon_sym_break] = ACTIONS(2742),
    [anon_sym_continue] = ACTIONS(2742),
    [anon_sym_goto] = ACTIONS(2742),
    [anon_sym___try] = ACTIONS(2742),
    [anon_sym___leave] = ACTIONS(2742),
    [anon_sym_not] = ACTIONS(2742),
    [anon_sym_compl] = ACTIONS(2742),
    [anon_sym_DASH_DASH] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2740),
    [anon_sym_sizeof] = ACTIONS(2742),
    [anon_sym___alignof__] = ACTIONS(2742),
    [anon_sym___alignof] = ACTIONS(2742),
    [anon_sym__alignof] = ACTIONS(2742),
    [anon_sym_alignof] = ACTIONS(2742),
    [anon_sym__Alignof] = ACTIONS(2742),
    [anon_sym_offsetof] = ACTIONS(2742),
    [anon_sym__Generic] = ACTIONS(2742),
    [anon_sym_asm] = ACTIONS(2742),
    [anon_sym___asm__] = ACTIONS(2742),
    [anon_sym_DOT] = ACTIONS(2742),
    [sym_number_literal] = ACTIONS(2740),
    [anon_sym_L_SQUOTE] = ACTIONS(2740),
    [anon_sym_u_SQUOTE] = ACTIONS(2740),
    [anon_sym_U_SQUOTE] = ACTIONS(2740),
    [anon_sym_u8_SQUOTE] = ACTIONS(2740),
    [anon_sym_SQUOTE] = ACTIONS(2740),
    [anon_sym_L_DQUOTE] = ACTIONS(2740),
    [anon_sym_u_DQUOTE] = ACTIONS(2740),
    [anon_sym_U_DQUOTE] = ACTIONS(2740),
    [anon_sym_u8_DQUOTE] = ACTIONS(2740),
    [anon_sym_DQUOTE] = ACTIONS(2740),
    [sym_true] = ACTIONS(2742),
    [sym_false] = ACTIONS(2742),
    [anon_sym_NULL] = ACTIONS(2742),
    [anon_sym_nullptr] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
    [anon_sym_decltype] = ACTIONS(2742),
    [sym_virtual] = ACTIONS(2742),
    [anon_sym_explicit] = ACTIONS(2742),
    [anon_sym_typename] = ACTIONS(2742),
    [anon_sym_template] = ACTIONS(2742),
    [anon_sym_operator] = ACTIONS(2742),
    [anon_sym_try] = ACTIONS(2742),
    [anon_sym_delete] = ACTIONS(2742),
    [anon_sym_throw] = ACTIONS(2742),
    [anon_sym_namespace] = ACTIONS(2742),
    [anon_sym_using] = ACTIONS(2742),
    [anon_sym_static_assert] = ACTIONS(2742),
    [anon_sym_concept] = ACTIONS(2742),
    [anon_sym_co_return] = ACTIONS(2742),
    [anon_sym_co_yield] = ACTIONS(2742),
    [anon_sym_R_DQUOTE] = ACTIONS(2740),
    [anon_sym_LR_DQUOTE] = ACTIONS(2740),
    [anon_sym_uR_DQUOTE] = ACTIONS(2740),
    [anon_sym_UR_DQUOTE] = ACTIONS(2740),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2740),
    [anon_sym_co_await] = ACTIONS(2742),
    [anon_sym_new] = ACTIONS(2742),
    [anon_sym_requires] = ACTIONS(2742),
    [sym_this] = ACTIONS(2742),
    [anon_sym_discard] = ACTIONS(2742),
    [anon_sym_precise] = ACTIONS(2742),
    [anon_sym_shared] = ACTIONS(2742),
    [anon_sym_groupshared] = ACTIONS(2742),
    [anon_sym_uniform] = ACTIONS(2742),
    [anon_sym_row_major] = ACTIONS(2742),
    [anon_sym_column_major] = ACTIONS(2742),
    [anon_sym_globallycoherent] = ACTIONS(2742),
    [anon_sym_centroid] = ACTIONS(2742),
    [anon_sym_noperspective] = ACTIONS(2742),
    [anon_sym_nointerpolation] = ACTIONS(2742),
    [anon_sym_sample] = ACTIONS(2742),
    [anon_sym_linear] = ACTIONS(2742),
    [anon_sym_snorm] = ACTIONS(2742),
    [anon_sym_unorm] = ACTIONS(2742),
    [anon_sym_point] = ACTIONS(2742),
    [anon_sym_line] = ACTIONS(2742),
    [anon_sym_triangleadj] = ACTIONS(2742),
    [anon_sym_lineadj] = ACTIONS(2742),
    [anon_sym_triangle] = ACTIONS(2742),
    [anon_sym_cbuffer] = ACTIONS(2742),
    [anon_sym_interface] = ACTIONS(2742),
    [anon_sym_extension] = ACTIONS(2742),
  },
  [533] = {
    [sym_identifier] = ACTIONS(2252),
    [aux_sym_preproc_include_token1] = ACTIONS(2252),
    [aux_sym_preproc_def_token1] = ACTIONS(2252),
    [aux_sym_preproc_if_token1] = ACTIONS(2252),
    [aux_sym_preproc_if_token2] = ACTIONS(2252),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2252),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2252),
    [sym_preproc_directive] = ACTIONS(2252),
    [anon_sym_LPAREN2] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2254),
    [anon_sym_TILDE] = ACTIONS(2254),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2254),
    [anon_sym_AMP_AMP] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym_SEMI] = ACTIONS(2254),
    [anon_sym___extension__] = ACTIONS(2252),
    [anon_sym_typedef] = ACTIONS(2252),
    [anon_sym_in] = ACTIONS(2252),
    [anon_sym_out] = ACTIONS(2252),
    [anon_sym_inout] = ACTIONS(2252),
    [anon_sym_extern] = ACTIONS(2252),
    [anon_sym___attribute__] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2254),
    [anon_sym___declspec] = ACTIONS(2252),
    [anon_sym___based] = ACTIONS(2252),
    [anon_sym___cdecl] = ACTIONS(2252),
    [anon_sym___clrcall] = ACTIONS(2252),
    [anon_sym___stdcall] = ACTIONS(2252),
    [anon_sym___fastcall] = ACTIONS(2252),
    [anon_sym___thiscall] = ACTIONS(2252),
    [anon_sym___vectorcall] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_signed] = ACTIONS(2252),
    [anon_sym_unsigned] = ACTIONS(2252),
    [anon_sym_long] = ACTIONS(2252),
    [anon_sym_short] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2252),
    [anon_sym_register] = ACTIONS(2252),
    [anon_sym_inline] = ACTIONS(2252),
    [anon_sym___inline] = ACTIONS(2252),
    [anon_sym___inline__] = ACTIONS(2252),
    [anon_sym___forceinline] = ACTIONS(2252),
    [anon_sym_thread_local] = ACTIONS(2252),
    [anon_sym___thread] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2252),
    [anon_sym_constexpr] = ACTIONS(2252),
    [anon_sym_volatile] = ACTIONS(2252),
    [anon_sym_restrict] = ACTIONS(2252),
    [anon_sym___restrict__] = ACTIONS(2252),
    [anon_sym__Atomic] = ACTIONS(2252),
    [anon_sym__Noreturn] = ACTIONS(2252),
    [anon_sym_noreturn] = ACTIONS(2252),
    [anon_sym_mutable] = ACTIONS(2252),
    [anon_sym_constinit] = ACTIONS(2252),
    [anon_sym_consteval] = ACTIONS(2252),
    [anon_sym_alignas] = ACTIONS(2252),
    [anon_sym__Alignas] = ACTIONS(2252),
    [sym_primitive_type] = ACTIONS(2252),
    [anon_sym_enum] = ACTIONS(2252),
    [anon_sym_class] = ACTIONS(2252),
    [anon_sym_struct] = ACTIONS(2252),
    [anon_sym_union] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_else] = ACTIONS(2252),
    [anon_sym_switch] = ACTIONS(2252),
    [anon_sym_case] = ACTIONS(2252),
    [anon_sym_default] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_do] = ACTIONS(2252),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2252),
    [anon_sym_goto] = ACTIONS(2252),
    [anon_sym___try] = ACTIONS(2252),
    [anon_sym___leave] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2252),
    [anon_sym_compl] = ACTIONS(2252),
    [anon_sym_DASH_DASH] = ACTIONS(2254),
    [anon_sym_PLUS_PLUS] = ACTIONS(2254),
    [anon_sym_sizeof] = ACTIONS(2252),
    [anon_sym___alignof__] = ACTIONS(2252),
    [anon_sym___alignof] = ACTIONS(2252),
    [anon_sym__alignof] = ACTIONS(2252),
    [anon_sym_alignof] = ACTIONS(2252),
    [anon_sym__Alignof] = ACTIONS(2252),
    [anon_sym_offsetof] = ACTIONS(2252),
    [anon_sym__Generic] = ACTIONS(2252),
    [anon_sym_asm] = ACTIONS(2252),
    [anon_sym___asm__] = ACTIONS(2252),
    [sym_number_literal] = ACTIONS(2254),
    [anon_sym_L_SQUOTE] = ACTIONS(2254),
    [anon_sym_u_SQUOTE] = ACTIONS(2254),
    [anon_sym_U_SQUOTE] = ACTIONS(2254),
    [anon_sym_u8_SQUOTE] = ACTIONS(2254),
    [anon_sym_SQUOTE] = ACTIONS(2254),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2252),
    [sym_false] = ACTIONS(2252),
    [anon_sym_NULL] = ACTIONS(2252),
    [anon_sym_nullptr] = ACTIONS(2252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_This] = ACTIONS(2252),
    [anon_sym_decltype] = ACTIONS(2252),
    [anon_sym_final] = ACTIONS(2252),
    [anon_sym_override] = ACTIONS(2252),
    [sym_virtual] = ACTIONS(2252),
    [anon_sym_explicit] = ACTIONS(2252),
    [anon_sym_typename] = ACTIONS(2252),
    [anon_sym_template] = ACTIONS(2252),
    [anon_sym_operator] = ACTIONS(2252),
    [anon_sym_try] = ACTIONS(2252),
    [anon_sym_delete] = ACTIONS(2252),
    [anon_sym_throw] = ACTIONS(2252),
    [anon_sym_namespace] = ACTIONS(2252),
    [anon_sym_using] = ACTIONS(2252),
    [anon_sym_static_assert] = ACTIONS(2252),
    [anon_sym_concept] = ACTIONS(2252),
    [anon_sym_co_return] = ACTIONS(2252),
    [anon_sym_co_yield] = ACTIONS(2252),
    [anon_sym_R_DQUOTE] = ACTIONS(2254),
    [anon_sym_LR_DQUOTE] = ACTIONS(2254),
    [anon_sym_uR_DQUOTE] = ACTIONS(2254),
    [anon_sym_UR_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2254),
    [anon_sym_co_await] = ACTIONS(2252),
    [anon_sym_new] = ACTIONS(2252),
    [anon_sym_requires] = ACTIONS(2252),
    [sym_this] = ACTIONS(2252),
    [anon_sym_discard] = ACTIONS(2252),
    [anon_sym_precise] = ACTIONS(2252),
    [anon_sym_shared] = ACTIONS(2252),
    [anon_sym_groupshared] = ACTIONS(2252),
    [anon_sym_uniform] = ACTIONS(2252),
    [anon_sym_row_major] = ACTIONS(2252),
    [anon_sym_column_major] = ACTIONS(2252),
    [anon_sym_globallycoherent] = ACTIONS(2252),
    [anon_sym_centroid] = ACTIONS(2252),
    [anon_sym_noperspective] = ACTIONS(2252),
    [anon_sym_nointerpolation] = ACTIONS(2252),
    [anon_sym_sample] = ACTIONS(2252),
    [anon_sym_linear] = ACTIONS(2252),
    [anon_sym_snorm] = ACTIONS(2252),
    [anon_sym_unorm] = ACTIONS(2252),
    [anon_sym_point] = ACTIONS(2252),
    [anon_sym_line] = ACTIONS(2252),
    [anon_sym_triangleadj] = ACTIONS(2252),
    [anon_sym_lineadj] = ACTIONS(2252),
    [anon_sym_triangle] = ACTIONS(2252),
    [anon_sym_cbuffer] = ACTIONS(2252),
    [anon_sym_interface] = ACTIONS(2252),
    [anon_sym_extension] = ACTIONS(2252),
  },
  [534] = {
    [sym_identifier] = ACTIONS(2244),
    [aux_sym_preproc_include_token1] = ACTIONS(2244),
    [aux_sym_preproc_def_token1] = ACTIONS(2244),
    [aux_sym_preproc_if_token1] = ACTIONS(2244),
    [aux_sym_preproc_if_token2] = ACTIONS(2244),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2244),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2244),
    [sym_preproc_directive] = ACTIONS(2244),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2244),
    [anon_sym_PLUS] = ACTIONS(2244),
    [anon_sym_STAR] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_AMP] = ACTIONS(2244),
    [anon_sym_COLON] = ACTIONS(2244),
    [anon_sym_SEMI] = ACTIONS(2246),
    [anon_sym___extension__] = ACTIONS(2244),
    [anon_sym_typedef] = ACTIONS(2244),
    [anon_sym_in] = ACTIONS(2244),
    [anon_sym_out] = ACTIONS(2244),
    [anon_sym_inout] = ACTIONS(2244),
    [anon_sym_extern] = ACTIONS(2244),
    [anon_sym___attribute__] = ACTIONS(2244),
    [anon_sym_COLON_COLON] = ACTIONS(2246),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2246),
    [anon_sym___declspec] = ACTIONS(2244),
    [anon_sym___based] = ACTIONS(2244),
    [anon_sym___cdecl] = ACTIONS(2244),
    [anon_sym___clrcall] = ACTIONS(2244),
    [anon_sym___stdcall] = ACTIONS(2244),
    [anon_sym___fastcall] = ACTIONS(2244),
    [anon_sym___thiscall] = ACTIONS(2244),
    [anon_sym___vectorcall] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_signed] = ACTIONS(2244),
    [anon_sym_unsigned] = ACTIONS(2244),
    [anon_sym_long] = ACTIONS(2244),
    [anon_sym_short] = ACTIONS(2244),
    [anon_sym_LBRACK] = ACTIONS(2244),
    [anon_sym_static] = ACTIONS(2244),
    [anon_sym_register] = ACTIONS(2244),
    [anon_sym_inline] = ACTIONS(2244),
    [anon_sym___inline] = ACTIONS(2244),
    [anon_sym___inline__] = ACTIONS(2244),
    [anon_sym___forceinline] = ACTIONS(2244),
    [anon_sym_thread_local] = ACTIONS(2244),
    [anon_sym___thread] = ACTIONS(2244),
    [anon_sym_const] = ACTIONS(2244),
    [anon_sym_constexpr] = ACTIONS(2244),
    [anon_sym_volatile] = ACTIONS(2244),
    [anon_sym_restrict] = ACTIONS(2244),
    [anon_sym___restrict__] = ACTIONS(2244),
    [anon_sym__Atomic] = ACTIONS(2244),
    [anon_sym__Noreturn] = ACTIONS(2244),
    [anon_sym_noreturn] = ACTIONS(2244),
    [anon_sym_mutable] = ACTIONS(2244),
    [anon_sym_constinit] = ACTIONS(2244),
    [anon_sym_consteval] = ACTIONS(2244),
    [anon_sym_alignas] = ACTIONS(2244),
    [anon_sym__Alignas] = ACTIONS(2244),
    [sym_primitive_type] = ACTIONS(2244),
    [anon_sym_enum] = ACTIONS(2244),
    [anon_sym_class] = ACTIONS(2244),
    [anon_sym_struct] = ACTIONS(2244),
    [anon_sym_union] = ACTIONS(2244),
    [anon_sym_if] = ACTIONS(2244),
    [anon_sym_else] = ACTIONS(2244),
    [anon_sym_switch] = ACTIONS(2244),
    [anon_sym_case] = ACTIONS(2244),
    [anon_sym_default] = ACTIONS(2244),
    [anon_sym_while] = ACTIONS(2244),
    [anon_sym_do] = ACTIONS(2244),
    [anon_sym_for] = ACTIONS(2244),
    [anon_sym_return] = ACTIONS(2244),
    [anon_sym_break] = ACTIONS(2244),
    [anon_sym_continue] = ACTIONS(2244),
    [anon_sym_goto] = ACTIONS(2244),
    [anon_sym___try] = ACTIONS(2244),
    [anon_sym___leave] = ACTIONS(2244),
    [anon_sym_not] = ACTIONS(2244),
    [anon_sym_compl] = ACTIONS(2244),
    [anon_sym_DASH_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_PLUS] = ACTIONS(2246),
    [anon_sym_sizeof] = ACTIONS(2244),
    [anon_sym___alignof__] = ACTIONS(2244),
    [anon_sym___alignof] = ACTIONS(2244),
    [anon_sym__alignof] = ACTIONS(2244),
    [anon_sym_alignof] = ACTIONS(2244),
    [anon_sym__Alignof] = ACTIONS(2244),
    [anon_sym_offsetof] = ACTIONS(2244),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2244),
    [anon_sym___asm__] = ACTIONS(2244),
    [sym_number_literal] = ACTIONS(2246),
    [anon_sym_L_SQUOTE] = ACTIONS(2246),
    [anon_sym_u_SQUOTE] = ACTIONS(2246),
    [anon_sym_U_SQUOTE] = ACTIONS(2246),
    [anon_sym_u8_SQUOTE] = ACTIONS(2246),
    [anon_sym_SQUOTE] = ACTIONS(2246),
    [anon_sym_L_DQUOTE] = ACTIONS(2246),
    [anon_sym_u_DQUOTE] = ACTIONS(2246),
    [anon_sym_U_DQUOTE] = ACTIONS(2246),
    [anon_sym_u8_DQUOTE] = ACTIONS(2246),
    [anon_sym_DQUOTE] = ACTIONS(2246),
    [sym_true] = ACTIONS(2244),
    [sym_false] = ACTIONS(2244),
    [anon_sym_NULL] = ACTIONS(2244),
    [anon_sym_nullptr] = ACTIONS(2244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2244),
    [anon_sym_let] = ACTIONS(2244),
    [anon_sym_This] = ACTIONS(2244),
    [anon_sym_decltype] = ACTIONS(2244),
    [anon_sym_final] = ACTIONS(2244),
    [anon_sym_override] = ACTIONS(2244),
    [sym_virtual] = ACTIONS(2244),
    [anon_sym_explicit] = ACTIONS(2244),
    [anon_sym_typename] = ACTIONS(2244),
    [anon_sym_template] = ACTIONS(2244),
    [anon_sym_operator] = ACTIONS(2244),
    [anon_sym_try] = ACTIONS(2244),
    [anon_sym_delete] = ACTIONS(2244),
    [anon_sym_throw] = ACTIONS(2244),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_using] = ACTIONS(2244),
    [anon_sym_static_assert] = ACTIONS(2244),
    [anon_sym_concept] = ACTIONS(2244),
    [anon_sym_co_return] = ACTIONS(2244),
    [anon_sym_co_yield] = ACTIONS(2244),
    [anon_sym_R_DQUOTE] = ACTIONS(2246),
    [anon_sym_LR_DQUOTE] = ACTIONS(2246),
    [anon_sym_uR_DQUOTE] = ACTIONS(2246),
    [anon_sym_UR_DQUOTE] = ACTIONS(2246),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2246),
    [anon_sym_co_await] = ACTIONS(2244),
    [anon_sym_new] = ACTIONS(2244),
    [anon_sym_requires] = ACTIONS(2244),
    [sym_this] = ACTIONS(2244),
    [anon_sym_discard] = ACTIONS(2244),
    [anon_sym_precise] = ACTIONS(2244),
    [anon_sym_shared] = ACTIONS(2244),
    [anon_sym_groupshared] = ACTIONS(2244),
    [anon_sym_uniform] = ACTIONS(2244),
    [anon_sym_row_major] = ACTIONS(2244),
    [anon_sym_column_major] = ACTIONS(2244),
    [anon_sym_globallycoherent] = ACTIONS(2244),
    [anon_sym_centroid] = ACTIONS(2244),
    [anon_sym_noperspective] = ACTIONS(2244),
    [anon_sym_nointerpolation] = ACTIONS(2244),
    [anon_sym_sample] = ACTIONS(2244),
    [anon_sym_linear] = ACTIONS(2244),
    [anon_sym_snorm] = ACTIONS(2244),
    [anon_sym_unorm] = ACTIONS(2244),
    [anon_sym_point] = ACTIONS(2244),
    [anon_sym_line] = ACTIONS(2244),
    [anon_sym_triangleadj] = ACTIONS(2244),
    [anon_sym_lineadj] = ACTIONS(2244),
    [anon_sym_triangle] = ACTIONS(2244),
    [anon_sym_cbuffer] = ACTIONS(2244),
    [anon_sym_interface] = ACTIONS(2244),
    [anon_sym_extension] = ACTIONS(2244),
  },
  [535] = {
    [sym_identifier] = ACTIONS(2232),
    [aux_sym_preproc_include_token1] = ACTIONS(2232),
    [aux_sym_preproc_def_token1] = ACTIONS(2232),
    [aux_sym_preproc_if_token1] = ACTIONS(2232),
    [aux_sym_preproc_if_token2] = ACTIONS(2232),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2232),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2232),
    [sym_preproc_directive] = ACTIONS(2232),
    [anon_sym_LPAREN2] = ACTIONS(2234),
    [anon_sym_BANG] = ACTIONS(2234),
    [anon_sym_TILDE] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2232),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_AMP_AMP] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2232),
    [anon_sym_COLON] = ACTIONS(2232),
    [anon_sym_SEMI] = ACTIONS(2234),
    [anon_sym___extension__] = ACTIONS(2232),
    [anon_sym_typedef] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2232),
    [anon_sym_out] = ACTIONS(2232),
    [anon_sym_inout] = ACTIONS(2232),
    [anon_sym_extern] = ACTIONS(2232),
    [anon_sym___attribute__] = ACTIONS(2232),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2234),
    [anon_sym___declspec] = ACTIONS(2232),
    [anon_sym___based] = ACTIONS(2232),
    [anon_sym___cdecl] = ACTIONS(2232),
    [anon_sym___clrcall] = ACTIONS(2232),
    [anon_sym___stdcall] = ACTIONS(2232),
    [anon_sym___fastcall] = ACTIONS(2232),
    [anon_sym___thiscall] = ACTIONS(2232),
    [anon_sym___vectorcall] = ACTIONS(2232),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_signed] = ACTIONS(2232),
    [anon_sym_unsigned] = ACTIONS(2232),
    [anon_sym_long] = ACTIONS(2232),
    [anon_sym_short] = ACTIONS(2232),
    [anon_sym_LBRACK] = ACTIONS(2232),
    [anon_sym_static] = ACTIONS(2232),
    [anon_sym_register] = ACTIONS(2232),
    [anon_sym_inline] = ACTIONS(2232),
    [anon_sym___inline] = ACTIONS(2232),
    [anon_sym___inline__] = ACTIONS(2232),
    [anon_sym___forceinline] = ACTIONS(2232),
    [anon_sym_thread_local] = ACTIONS(2232),
    [anon_sym___thread] = ACTIONS(2232),
    [anon_sym_const] = ACTIONS(2232),
    [anon_sym_constexpr] = ACTIONS(2232),
    [anon_sym_volatile] = ACTIONS(2232),
    [anon_sym_restrict] = ACTIONS(2232),
    [anon_sym___restrict__] = ACTIONS(2232),
    [anon_sym__Atomic] = ACTIONS(2232),
    [anon_sym__Noreturn] = ACTIONS(2232),
    [anon_sym_noreturn] = ACTIONS(2232),
    [anon_sym_mutable] = ACTIONS(2232),
    [anon_sym_constinit] = ACTIONS(2232),
    [anon_sym_consteval] = ACTIONS(2232),
    [anon_sym_alignas] = ACTIONS(2232),
    [anon_sym__Alignas] = ACTIONS(2232),
    [sym_primitive_type] = ACTIONS(2232),
    [anon_sym_enum] = ACTIONS(2232),
    [anon_sym_class] = ACTIONS(2232),
    [anon_sym_struct] = ACTIONS(2232),
    [anon_sym_union] = ACTIONS(2232),
    [anon_sym_if] = ACTIONS(2232),
    [anon_sym_else] = ACTIONS(2232),
    [anon_sym_switch] = ACTIONS(2232),
    [anon_sym_case] = ACTIONS(2232),
    [anon_sym_default] = ACTIONS(2232),
    [anon_sym_while] = ACTIONS(2232),
    [anon_sym_do] = ACTIONS(2232),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2232),
    [anon_sym_break] = ACTIONS(2232),
    [anon_sym_continue] = ACTIONS(2232),
    [anon_sym_goto] = ACTIONS(2232),
    [anon_sym___try] = ACTIONS(2232),
    [anon_sym___leave] = ACTIONS(2232),
    [anon_sym_not] = ACTIONS(2232),
    [anon_sym_compl] = ACTIONS(2232),
    [anon_sym_DASH_DASH] = ACTIONS(2234),
    [anon_sym_PLUS_PLUS] = ACTIONS(2234),
    [anon_sym_sizeof] = ACTIONS(2232),
    [anon_sym___alignof__] = ACTIONS(2232),
    [anon_sym___alignof] = ACTIONS(2232),
    [anon_sym__alignof] = ACTIONS(2232),
    [anon_sym_alignof] = ACTIONS(2232),
    [anon_sym__Alignof] = ACTIONS(2232),
    [anon_sym_offsetof] = ACTIONS(2232),
    [anon_sym__Generic] = ACTIONS(2232),
    [anon_sym_asm] = ACTIONS(2232),
    [anon_sym___asm__] = ACTIONS(2232),
    [sym_number_literal] = ACTIONS(2234),
    [anon_sym_L_SQUOTE] = ACTIONS(2234),
    [anon_sym_u_SQUOTE] = ACTIONS(2234),
    [anon_sym_U_SQUOTE] = ACTIONS(2234),
    [anon_sym_u8_SQUOTE] = ACTIONS(2234),
    [anon_sym_SQUOTE] = ACTIONS(2234),
    [anon_sym_L_DQUOTE] = ACTIONS(2234),
    [anon_sym_u_DQUOTE] = ACTIONS(2234),
    [anon_sym_U_DQUOTE] = ACTIONS(2234),
    [anon_sym_u8_DQUOTE] = ACTIONS(2234),
    [anon_sym_DQUOTE] = ACTIONS(2234),
    [sym_true] = ACTIONS(2232),
    [sym_false] = ACTIONS(2232),
    [anon_sym_NULL] = ACTIONS(2232),
    [anon_sym_nullptr] = ACTIONS(2232),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2232),
    [anon_sym_let] = ACTIONS(2232),
    [anon_sym_This] = ACTIONS(2232),
    [anon_sym_decltype] = ACTIONS(2232),
    [anon_sym_final] = ACTIONS(2232),
    [anon_sym_override] = ACTIONS(2232),
    [sym_virtual] = ACTIONS(2232),
    [anon_sym_explicit] = ACTIONS(2232),
    [anon_sym_typename] = ACTIONS(2232),
    [anon_sym_template] = ACTIONS(2232),
    [anon_sym_operator] = ACTIONS(2232),
    [anon_sym_try] = ACTIONS(2232),
    [anon_sym_delete] = ACTIONS(2232),
    [anon_sym_throw] = ACTIONS(2232),
    [anon_sym_namespace] = ACTIONS(2232),
    [anon_sym_using] = ACTIONS(2232),
    [anon_sym_static_assert] = ACTIONS(2232),
    [anon_sym_concept] = ACTIONS(2232),
    [anon_sym_co_return] = ACTIONS(2232),
    [anon_sym_co_yield] = ACTIONS(2232),
    [anon_sym_R_DQUOTE] = ACTIONS(2234),
    [anon_sym_LR_DQUOTE] = ACTIONS(2234),
    [anon_sym_uR_DQUOTE] = ACTIONS(2234),
    [anon_sym_UR_DQUOTE] = ACTIONS(2234),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2234),
    [anon_sym_co_await] = ACTIONS(2232),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_requires] = ACTIONS(2232),
    [sym_this] = ACTIONS(2232),
    [anon_sym_discard] = ACTIONS(2232),
    [anon_sym_precise] = ACTIONS(2232),
    [anon_sym_shared] = ACTIONS(2232),
    [anon_sym_groupshared] = ACTIONS(2232),
    [anon_sym_uniform] = ACTIONS(2232),
    [anon_sym_row_major] = ACTIONS(2232),
    [anon_sym_column_major] = ACTIONS(2232),
    [anon_sym_globallycoherent] = ACTIONS(2232),
    [anon_sym_centroid] = ACTIONS(2232),
    [anon_sym_noperspective] = ACTIONS(2232),
    [anon_sym_nointerpolation] = ACTIONS(2232),
    [anon_sym_sample] = ACTIONS(2232),
    [anon_sym_linear] = ACTIONS(2232),
    [anon_sym_snorm] = ACTIONS(2232),
    [anon_sym_unorm] = ACTIONS(2232),
    [anon_sym_point] = ACTIONS(2232),
    [anon_sym_line] = ACTIONS(2232),
    [anon_sym_triangleadj] = ACTIONS(2232),
    [anon_sym_lineadj] = ACTIONS(2232),
    [anon_sym_triangle] = ACTIONS(2232),
    [anon_sym_cbuffer] = ACTIONS(2232),
    [anon_sym_interface] = ACTIONS(2232),
    [anon_sym_extension] = ACTIONS(2232),
  },
  [536] = {
    [sym_identifier] = ACTIONS(2228),
    [aux_sym_preproc_include_token1] = ACTIONS(2228),
    [aux_sym_preproc_def_token1] = ACTIONS(2228),
    [aux_sym_preproc_if_token1] = ACTIONS(2228),
    [aux_sym_preproc_if_token2] = ACTIONS(2228),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2228),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2228),
    [sym_preproc_directive] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_BANG] = ACTIONS(2230),
    [anon_sym_TILDE] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2228),
    [anon_sym_PLUS] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_AMP] = ACTIONS(2228),
    [anon_sym_COLON] = ACTIONS(2228),
    [anon_sym_SEMI] = ACTIONS(2230),
    [anon_sym___extension__] = ACTIONS(2228),
    [anon_sym_typedef] = ACTIONS(2228),
    [anon_sym_in] = ACTIONS(2228),
    [anon_sym_out] = ACTIONS(2228),
    [anon_sym_inout] = ACTIONS(2228),
    [anon_sym_extern] = ACTIONS(2228),
    [anon_sym___attribute__] = ACTIONS(2228),
    [anon_sym_COLON_COLON] = ACTIONS(2230),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2230),
    [anon_sym___declspec] = ACTIONS(2228),
    [anon_sym___based] = ACTIONS(2228),
    [anon_sym___cdecl] = ACTIONS(2228),
    [anon_sym___clrcall] = ACTIONS(2228),
    [anon_sym___stdcall] = ACTIONS(2228),
    [anon_sym___fastcall] = ACTIONS(2228),
    [anon_sym___thiscall] = ACTIONS(2228),
    [anon_sym___vectorcall] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_signed] = ACTIONS(2228),
    [anon_sym_unsigned] = ACTIONS(2228),
    [anon_sym_long] = ACTIONS(2228),
    [anon_sym_short] = ACTIONS(2228),
    [anon_sym_LBRACK] = ACTIONS(2228),
    [anon_sym_static] = ACTIONS(2228),
    [anon_sym_register] = ACTIONS(2228),
    [anon_sym_inline] = ACTIONS(2228),
    [anon_sym___inline] = ACTIONS(2228),
    [anon_sym___inline__] = ACTIONS(2228),
    [anon_sym___forceinline] = ACTIONS(2228),
    [anon_sym_thread_local] = ACTIONS(2228),
    [anon_sym___thread] = ACTIONS(2228),
    [anon_sym_const] = ACTIONS(2228),
    [anon_sym_constexpr] = ACTIONS(2228),
    [anon_sym_volatile] = ACTIONS(2228),
    [anon_sym_restrict] = ACTIONS(2228),
    [anon_sym___restrict__] = ACTIONS(2228),
    [anon_sym__Atomic] = ACTIONS(2228),
    [anon_sym__Noreturn] = ACTIONS(2228),
    [anon_sym_noreturn] = ACTIONS(2228),
    [anon_sym_mutable] = ACTIONS(2228),
    [anon_sym_constinit] = ACTIONS(2228),
    [anon_sym_consteval] = ACTIONS(2228),
    [anon_sym_alignas] = ACTIONS(2228),
    [anon_sym__Alignas] = ACTIONS(2228),
    [sym_primitive_type] = ACTIONS(2228),
    [anon_sym_enum] = ACTIONS(2228),
    [anon_sym_class] = ACTIONS(2228),
    [anon_sym_struct] = ACTIONS(2228),
    [anon_sym_union] = ACTIONS(2228),
    [anon_sym_if] = ACTIONS(2228),
    [anon_sym_else] = ACTIONS(2228),
    [anon_sym_switch] = ACTIONS(2228),
    [anon_sym_case] = ACTIONS(2228),
    [anon_sym_default] = ACTIONS(2228),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2228),
    [anon_sym_for] = ACTIONS(2228),
    [anon_sym_return] = ACTIONS(2228),
    [anon_sym_break] = ACTIONS(2228),
    [anon_sym_continue] = ACTIONS(2228),
    [anon_sym_goto] = ACTIONS(2228),
    [anon_sym___try] = ACTIONS(2228),
    [anon_sym___leave] = ACTIONS(2228),
    [anon_sym_not] = ACTIONS(2228),
    [anon_sym_compl] = ACTIONS(2228),
    [anon_sym_DASH_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_PLUS] = ACTIONS(2230),
    [anon_sym_sizeof] = ACTIONS(2228),
    [anon_sym___alignof__] = ACTIONS(2228),
    [anon_sym___alignof] = ACTIONS(2228),
    [anon_sym__alignof] = ACTIONS(2228),
    [anon_sym_alignof] = ACTIONS(2228),
    [anon_sym__Alignof] = ACTIONS(2228),
    [anon_sym_offsetof] = ACTIONS(2228),
    [anon_sym__Generic] = ACTIONS(2228),
    [anon_sym_asm] = ACTIONS(2228),
    [anon_sym___asm__] = ACTIONS(2228),
    [sym_number_literal] = ACTIONS(2230),
    [anon_sym_L_SQUOTE] = ACTIONS(2230),
    [anon_sym_u_SQUOTE] = ACTIONS(2230),
    [anon_sym_U_SQUOTE] = ACTIONS(2230),
    [anon_sym_u8_SQUOTE] = ACTIONS(2230),
    [anon_sym_SQUOTE] = ACTIONS(2230),
    [anon_sym_L_DQUOTE] = ACTIONS(2230),
    [anon_sym_u_DQUOTE] = ACTIONS(2230),
    [anon_sym_U_DQUOTE] = ACTIONS(2230),
    [anon_sym_u8_DQUOTE] = ACTIONS(2230),
    [anon_sym_DQUOTE] = ACTIONS(2230),
    [sym_true] = ACTIONS(2228),
    [sym_false] = ACTIONS(2228),
    [anon_sym_NULL] = ACTIONS(2228),
    [anon_sym_nullptr] = ACTIONS(2228),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(2228),
    [anon_sym_This] = ACTIONS(2228),
    [anon_sym_decltype] = ACTIONS(2228),
    [anon_sym_final] = ACTIONS(2228),
    [anon_sym_override] = ACTIONS(2228),
    [sym_virtual] = ACTIONS(2228),
    [anon_sym_explicit] = ACTIONS(2228),
    [anon_sym_typename] = ACTIONS(2228),
    [anon_sym_template] = ACTIONS(2228),
    [anon_sym_operator] = ACTIONS(2228),
    [anon_sym_try] = ACTIONS(2228),
    [anon_sym_delete] = ACTIONS(2228),
    [anon_sym_throw] = ACTIONS(2228),
    [anon_sym_namespace] = ACTIONS(2228),
    [anon_sym_using] = ACTIONS(2228),
    [anon_sym_static_assert] = ACTIONS(2228),
    [anon_sym_concept] = ACTIONS(2228),
    [anon_sym_co_return] = ACTIONS(2228),
    [anon_sym_co_yield] = ACTIONS(2228),
    [anon_sym_R_DQUOTE] = ACTIONS(2230),
    [anon_sym_LR_DQUOTE] = ACTIONS(2230),
    [anon_sym_uR_DQUOTE] = ACTIONS(2230),
    [anon_sym_UR_DQUOTE] = ACTIONS(2230),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2230),
    [anon_sym_co_await] = ACTIONS(2228),
    [anon_sym_new] = ACTIONS(2228),
    [anon_sym_requires] = ACTIONS(2228),
    [sym_this] = ACTIONS(2228),
    [anon_sym_discard] = ACTIONS(2228),
    [anon_sym_precise] = ACTIONS(2228),
    [anon_sym_shared] = ACTIONS(2228),
    [anon_sym_groupshared] = ACTIONS(2228),
    [anon_sym_uniform] = ACTIONS(2228),
    [anon_sym_row_major] = ACTIONS(2228),
    [anon_sym_column_major] = ACTIONS(2228),
    [anon_sym_globallycoherent] = ACTIONS(2228),
    [anon_sym_centroid] = ACTIONS(2228),
    [anon_sym_noperspective] = ACTIONS(2228),
    [anon_sym_nointerpolation] = ACTIONS(2228),
    [anon_sym_sample] = ACTIONS(2228),
    [anon_sym_linear] = ACTIONS(2228),
    [anon_sym_snorm] = ACTIONS(2228),
    [anon_sym_unorm] = ACTIONS(2228),
    [anon_sym_point] = ACTIONS(2228),
    [anon_sym_line] = ACTIONS(2228),
    [anon_sym_triangleadj] = ACTIONS(2228),
    [anon_sym_lineadj] = ACTIONS(2228),
    [anon_sym_triangle] = ACTIONS(2228),
    [anon_sym_cbuffer] = ACTIONS(2228),
    [anon_sym_interface] = ACTIONS(2228),
    [anon_sym_extension] = ACTIONS(2228),
  },
  [537] = {
    [sym_else_clause] = STATE(576),
    [ts_builtin_sym_end] = ACTIONS(2852),
    [sym_identifier] = ACTIONS(2850),
    [aux_sym_preproc_include_token1] = ACTIONS(2850),
    [aux_sym_preproc_def_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token1] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2850),
    [sym_preproc_directive] = ACTIONS(2850),
    [anon_sym_LPAREN2] = ACTIONS(2852),
    [anon_sym_BANG] = ACTIONS(2852),
    [anon_sym_TILDE] = ACTIONS(2852),
    [anon_sym_DASH] = ACTIONS(2850),
    [anon_sym_PLUS] = ACTIONS(2850),
    [anon_sym_STAR] = ACTIONS(2852),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_AMP] = ACTIONS(2850),
    [anon_sym_SEMI] = ACTIONS(2852),
    [anon_sym___extension__] = ACTIONS(2850),
    [anon_sym_typedef] = ACTIONS(2850),
    [anon_sym_in] = ACTIONS(2850),
    [anon_sym_out] = ACTIONS(2850),
    [anon_sym_inout] = ACTIONS(2850),
    [anon_sym_extern] = ACTIONS(2850),
    [anon_sym___attribute__] = ACTIONS(2850),
    [anon_sym_COLON_COLON] = ACTIONS(2852),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2852),
    [anon_sym___declspec] = ACTIONS(2850),
    [anon_sym___based] = ACTIONS(2850),
    [anon_sym___cdecl] = ACTIONS(2850),
    [anon_sym___clrcall] = ACTIONS(2850),
    [anon_sym___stdcall] = ACTIONS(2850),
    [anon_sym___fastcall] = ACTIONS(2850),
    [anon_sym___thiscall] = ACTIONS(2850),
    [anon_sym___vectorcall] = ACTIONS(2850),
    [anon_sym_LBRACE] = ACTIONS(2852),
    [anon_sym_signed] = ACTIONS(2850),
    [anon_sym_unsigned] = ACTIONS(2850),
    [anon_sym_long] = ACTIONS(2850),
    [anon_sym_short] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2850),
    [anon_sym_static] = ACTIONS(2850),
    [anon_sym_register] = ACTIONS(2850),
    [anon_sym_inline] = ACTIONS(2850),
    [anon_sym___inline] = ACTIONS(2850),
    [anon_sym___inline__] = ACTIONS(2850),
    [anon_sym___forceinline] = ACTIONS(2850),
    [anon_sym_thread_local] = ACTIONS(2850),
    [anon_sym___thread] = ACTIONS(2850),
    [anon_sym_const] = ACTIONS(2850),
    [anon_sym_constexpr] = ACTIONS(2850),
    [anon_sym_volatile] = ACTIONS(2850),
    [anon_sym_restrict] = ACTIONS(2850),
    [anon_sym___restrict__] = ACTIONS(2850),
    [anon_sym__Atomic] = ACTIONS(2850),
    [anon_sym__Noreturn] = ACTIONS(2850),
    [anon_sym_noreturn] = ACTIONS(2850),
    [anon_sym_mutable] = ACTIONS(2850),
    [anon_sym_constinit] = ACTIONS(2850),
    [anon_sym_consteval] = ACTIONS(2850),
    [anon_sym_alignas] = ACTIONS(2850),
    [anon_sym__Alignas] = ACTIONS(2850),
    [sym_primitive_type] = ACTIONS(2850),
    [anon_sym_enum] = ACTIONS(2850),
    [anon_sym_class] = ACTIONS(2850),
    [anon_sym_struct] = ACTIONS(2850),
    [anon_sym_union] = ACTIONS(2850),
    [anon_sym_if] = ACTIONS(2850),
    [anon_sym_else] = ACTIONS(3453),
    [anon_sym_switch] = ACTIONS(2850),
    [anon_sym_case] = ACTIONS(2850),
    [anon_sym_default] = ACTIONS(2850),
    [anon_sym_while] = ACTIONS(2850),
    [anon_sym_do] = ACTIONS(2850),
    [anon_sym_for] = ACTIONS(2850),
    [anon_sym_return] = ACTIONS(2850),
    [anon_sym_break] = ACTIONS(2850),
    [anon_sym_continue] = ACTIONS(2850),
    [anon_sym_goto] = ACTIONS(2850),
    [anon_sym___try] = ACTIONS(2850),
    [anon_sym___leave] = ACTIONS(2850),
    [anon_sym_not] = ACTIONS(2850),
    [anon_sym_compl] = ACTIONS(2850),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_sizeof] = ACTIONS(2850),
    [anon_sym___alignof__] = ACTIONS(2850),
    [anon_sym___alignof] = ACTIONS(2850),
    [anon_sym__alignof] = ACTIONS(2850),
    [anon_sym_alignof] = ACTIONS(2850),
    [anon_sym__Alignof] = ACTIONS(2850),
    [anon_sym_offsetof] = ACTIONS(2850),
    [anon_sym__Generic] = ACTIONS(2850),
    [anon_sym_asm] = ACTIONS(2850),
    [anon_sym___asm__] = ACTIONS(2850),
    [sym_number_literal] = ACTIONS(2852),
    [anon_sym_L_SQUOTE] = ACTIONS(2852),
    [anon_sym_u_SQUOTE] = ACTIONS(2852),
    [anon_sym_U_SQUOTE] = ACTIONS(2852),
    [anon_sym_u8_SQUOTE] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2852),
    [anon_sym_L_DQUOTE] = ACTIONS(2852),
    [anon_sym_u_DQUOTE] = ACTIONS(2852),
    [anon_sym_U_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8_DQUOTE] = ACTIONS(2852),
    [anon_sym_DQUOTE] = ACTIONS(2852),
    [sym_true] = ACTIONS(2850),
    [sym_false] = ACTIONS(2850),
    [anon_sym_NULL] = ACTIONS(2850),
    [anon_sym_nullptr] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2850),
    [anon_sym_let] = ACTIONS(2850),
    [anon_sym_This] = ACTIONS(2850),
    [anon_sym_decltype] = ACTIONS(2850),
    [sym_virtual] = ACTIONS(2850),
    [anon_sym_explicit] = ACTIONS(2850),
    [anon_sym_typename] = ACTIONS(2850),
    [anon_sym_template] = ACTIONS(2850),
    [anon_sym_operator] = ACTIONS(2850),
    [anon_sym_try] = ACTIONS(2850),
    [anon_sym_delete] = ACTIONS(2850),
    [anon_sym_throw] = ACTIONS(2850),
    [anon_sym_namespace] = ACTIONS(2850),
    [anon_sym_using] = ACTIONS(2850),
    [anon_sym_static_assert] = ACTIONS(2850),
    [anon_sym_concept] = ACTIONS(2850),
    [anon_sym_co_return] = ACTIONS(2850),
    [anon_sym_co_yield] = ACTIONS(2850),
    [anon_sym_R_DQUOTE] = ACTIONS(2852),
    [anon_sym_LR_DQUOTE] = ACTIONS(2852),
    [anon_sym_uR_DQUOTE] = ACTIONS(2852),
    [anon_sym_UR_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2852),
    [anon_sym_co_await] = ACTIONS(2850),
    [anon_sym_new] = ACTIONS(2850),
    [anon_sym_requires] = ACTIONS(2850),
    [sym_this] = ACTIONS(2850),
    [anon_sym_discard] = ACTIONS(2850),
    [anon_sym_precise] = ACTIONS(2850),
    [anon_sym_shared] = ACTIONS(2850),
    [anon_sym_groupshared] = ACTIONS(2850),
    [anon_sym_uniform] = ACTIONS(2850),
    [anon_sym_row_major] = ACTIONS(2850),
    [anon_sym_column_major] = ACTIONS(2850),
    [anon_sym_globallycoherent] = ACTIONS(2850),
    [anon_sym_centroid] = ACTIONS(2850),
    [anon_sym_noperspective] = ACTIONS(2850),
    [anon_sym_nointerpolation] = ACTIONS(2850),
    [anon_sym_sample] = ACTIONS(2850),
    [anon_sym_linear] = ACTIONS(2850),
    [anon_sym_snorm] = ACTIONS(2850),
    [anon_sym_unorm] = ACTIONS(2850),
    [anon_sym_point] = ACTIONS(2850),
    [anon_sym_line] = ACTIONS(2850),
    [anon_sym_triangleadj] = ACTIONS(2850),
    [anon_sym_lineadj] = ACTIONS(2850),
    [anon_sym_triangle] = ACTIONS(2850),
    [anon_sym_cbuffer] = ACTIONS(2850),
    [anon_sym_interface] = ACTIONS(2850),
    [anon_sym_extension] = ACTIONS(2850),
    [anon_sym___exported] = ACTIONS(2850),
    [anon_sym_import] = ACTIONS(2850),
  },
  [538] = {
    [sym_identifier] = ACTIONS(3665),
    [aux_sym_preproc_include_token1] = ACTIONS(3665),
    [aux_sym_preproc_def_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token2] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3665),
    [aux_sym_preproc_else_token1] = ACTIONS(3665),
    [aux_sym_preproc_elif_token1] = ACTIONS(3665),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3665),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3665),
    [sym_preproc_directive] = ACTIONS(3665),
    [anon_sym_LPAREN2] = ACTIONS(3667),
    [anon_sym_BANG] = ACTIONS(3667),
    [anon_sym_TILDE] = ACTIONS(3667),
    [anon_sym_DASH] = ACTIONS(3665),
    [anon_sym_PLUS] = ACTIONS(3665),
    [anon_sym_STAR] = ACTIONS(3667),
    [anon_sym_AMP_AMP] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym_SEMI] = ACTIONS(3667),
    [anon_sym___extension__] = ACTIONS(3665),
    [anon_sym_typedef] = ACTIONS(3665),
    [anon_sym_in] = ACTIONS(3665),
    [anon_sym_out] = ACTIONS(3665),
    [anon_sym_inout] = ACTIONS(3665),
    [anon_sym_extern] = ACTIONS(3665),
    [anon_sym___attribute__] = ACTIONS(3665),
    [anon_sym_COLON_COLON] = ACTIONS(3667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3667),
    [anon_sym___declspec] = ACTIONS(3665),
    [anon_sym___based] = ACTIONS(3665),
    [anon_sym___cdecl] = ACTIONS(3665),
    [anon_sym___clrcall] = ACTIONS(3665),
    [anon_sym___stdcall] = ACTIONS(3665),
    [anon_sym___fastcall] = ACTIONS(3665),
    [anon_sym___thiscall] = ACTIONS(3665),
    [anon_sym___vectorcall] = ACTIONS(3665),
    [anon_sym_LBRACE] = ACTIONS(3667),
    [anon_sym_signed] = ACTIONS(3665),
    [anon_sym_unsigned] = ACTIONS(3665),
    [anon_sym_long] = ACTIONS(3665),
    [anon_sym_short] = ACTIONS(3665),
    [anon_sym_LBRACK] = ACTIONS(3665),
    [anon_sym_static] = ACTIONS(3665),
    [anon_sym_register] = ACTIONS(3665),
    [anon_sym_inline] = ACTIONS(3665),
    [anon_sym___inline] = ACTIONS(3665),
    [anon_sym___inline__] = ACTIONS(3665),
    [anon_sym___forceinline] = ACTIONS(3665),
    [anon_sym_thread_local] = ACTIONS(3665),
    [anon_sym___thread] = ACTIONS(3665),
    [anon_sym_const] = ACTIONS(3665),
    [anon_sym_constexpr] = ACTIONS(3665),
    [anon_sym_volatile] = ACTIONS(3665),
    [anon_sym_restrict] = ACTIONS(3665),
    [anon_sym___restrict__] = ACTIONS(3665),
    [anon_sym__Atomic] = ACTIONS(3665),
    [anon_sym__Noreturn] = ACTIONS(3665),
    [anon_sym_noreturn] = ACTIONS(3665),
    [anon_sym_mutable] = ACTIONS(3665),
    [anon_sym_constinit] = ACTIONS(3665),
    [anon_sym_consteval] = ACTIONS(3665),
    [anon_sym_alignas] = ACTIONS(3665),
    [anon_sym__Alignas] = ACTIONS(3665),
    [sym_primitive_type] = ACTIONS(3665),
    [anon_sym_enum] = ACTIONS(3665),
    [anon_sym_class] = ACTIONS(3665),
    [anon_sym_struct] = ACTIONS(3665),
    [anon_sym_union] = ACTIONS(3665),
    [anon_sym_if] = ACTIONS(3665),
    [anon_sym_switch] = ACTIONS(3665),
    [anon_sym_case] = ACTIONS(3665),
    [anon_sym_default] = ACTIONS(3665),
    [anon_sym_while] = ACTIONS(3665),
    [anon_sym_do] = ACTIONS(3665),
    [anon_sym_for] = ACTIONS(3665),
    [anon_sym_return] = ACTIONS(3665),
    [anon_sym_break] = ACTIONS(3665),
    [anon_sym_continue] = ACTIONS(3665),
    [anon_sym_goto] = ACTIONS(3665),
    [anon_sym___try] = ACTIONS(3665),
    [anon_sym___leave] = ACTIONS(3665),
    [anon_sym_not] = ACTIONS(3665),
    [anon_sym_compl] = ACTIONS(3665),
    [anon_sym_DASH_DASH] = ACTIONS(3667),
    [anon_sym_PLUS_PLUS] = ACTIONS(3667),
    [anon_sym_sizeof] = ACTIONS(3665),
    [anon_sym___alignof__] = ACTIONS(3665),
    [anon_sym___alignof] = ACTIONS(3665),
    [anon_sym__alignof] = ACTIONS(3665),
    [anon_sym_alignof] = ACTIONS(3665),
    [anon_sym__Alignof] = ACTIONS(3665),
    [anon_sym_offsetof] = ACTIONS(3665),
    [anon_sym__Generic] = ACTIONS(3665),
    [anon_sym_asm] = ACTIONS(3665),
    [anon_sym___asm__] = ACTIONS(3665),
    [sym_number_literal] = ACTIONS(3667),
    [anon_sym_L_SQUOTE] = ACTIONS(3667),
    [anon_sym_u_SQUOTE] = ACTIONS(3667),
    [anon_sym_U_SQUOTE] = ACTIONS(3667),
    [anon_sym_u8_SQUOTE] = ACTIONS(3667),
    [anon_sym_SQUOTE] = ACTIONS(3667),
    [anon_sym_L_DQUOTE] = ACTIONS(3667),
    [anon_sym_u_DQUOTE] = ACTIONS(3667),
    [anon_sym_U_DQUOTE] = ACTIONS(3667),
    [anon_sym_u8_DQUOTE] = ACTIONS(3667),
    [anon_sym_DQUOTE] = ACTIONS(3667),
    [sym_true] = ACTIONS(3665),
    [sym_false] = ACTIONS(3665),
    [anon_sym_NULL] = ACTIONS(3665),
    [anon_sym_nullptr] = ACTIONS(3665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3665),
    [anon_sym_let] = ACTIONS(3665),
    [anon_sym_This] = ACTIONS(3665),
    [anon_sym_decltype] = ACTIONS(3665),
    [sym_virtual] = ACTIONS(3665),
    [anon_sym_explicit] = ACTIONS(3665),
    [anon_sym_typename] = ACTIONS(3665),
    [anon_sym_template] = ACTIONS(3665),
    [anon_sym_operator] = ACTIONS(3665),
    [anon_sym_try] = ACTIONS(3665),
    [anon_sym_delete] = ACTIONS(3665),
    [anon_sym_throw] = ACTIONS(3665),
    [anon_sym_namespace] = ACTIONS(3665),
    [anon_sym_using] = ACTIONS(3665),
    [anon_sym_static_assert] = ACTIONS(3665),
    [anon_sym_concept] = ACTIONS(3665),
    [anon_sym_co_return] = ACTIONS(3665),
    [anon_sym_co_yield] = ACTIONS(3665),
    [anon_sym_R_DQUOTE] = ACTIONS(3667),
    [anon_sym_LR_DQUOTE] = ACTIONS(3667),
    [anon_sym_uR_DQUOTE] = ACTIONS(3667),
    [anon_sym_UR_DQUOTE] = ACTIONS(3667),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3667),
    [anon_sym_co_await] = ACTIONS(3665),
    [anon_sym_new] = ACTIONS(3665),
    [anon_sym_requires] = ACTIONS(3665),
    [sym_this] = ACTIONS(3665),
    [anon_sym_discard] = ACTIONS(3665),
    [anon_sym_precise] = ACTIONS(3665),
    [anon_sym_shared] = ACTIONS(3665),
    [anon_sym_groupshared] = ACTIONS(3665),
    [anon_sym_uniform] = ACTIONS(3665),
    [anon_sym_row_major] = ACTIONS(3665),
    [anon_sym_column_major] = ACTIONS(3665),
    [anon_sym_globallycoherent] = ACTIONS(3665),
    [anon_sym_centroid] = ACTIONS(3665),
    [anon_sym_noperspective] = ACTIONS(3665),
    [anon_sym_nointerpolation] = ACTIONS(3665),
    [anon_sym_sample] = ACTIONS(3665),
    [anon_sym_linear] = ACTIONS(3665),
    [anon_sym_snorm] = ACTIONS(3665),
    [anon_sym_unorm] = ACTIONS(3665),
    [anon_sym_point] = ACTIONS(3665),
    [anon_sym_line] = ACTIONS(3665),
    [anon_sym_triangleadj] = ACTIONS(3665),
    [anon_sym_lineadj] = ACTIONS(3665),
    [anon_sym_triangle] = ACTIONS(3665),
    [anon_sym_cbuffer] = ACTIONS(3665),
    [anon_sym_interface] = ACTIONS(3665),
    [anon_sym_extension] = ACTIONS(3665),
  },
  [539] = {
    [sym_identifier] = ACTIONS(3665),
    [aux_sym_preproc_include_token1] = ACTIONS(3665),
    [aux_sym_preproc_def_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token2] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3665),
    [aux_sym_preproc_else_token1] = ACTIONS(3665),
    [aux_sym_preproc_elif_token1] = ACTIONS(3665),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3665),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3665),
    [sym_preproc_directive] = ACTIONS(3665),
    [anon_sym_LPAREN2] = ACTIONS(3667),
    [anon_sym_BANG] = ACTIONS(3667),
    [anon_sym_TILDE] = ACTIONS(3667),
    [anon_sym_DASH] = ACTIONS(3665),
    [anon_sym_PLUS] = ACTIONS(3665),
    [anon_sym_STAR] = ACTIONS(3667),
    [anon_sym_AMP_AMP] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym_SEMI] = ACTIONS(3667),
    [anon_sym___extension__] = ACTIONS(3665),
    [anon_sym_typedef] = ACTIONS(3665),
    [anon_sym_in] = ACTIONS(3665),
    [anon_sym_out] = ACTIONS(3665),
    [anon_sym_inout] = ACTIONS(3665),
    [anon_sym_extern] = ACTIONS(3665),
    [anon_sym___attribute__] = ACTIONS(3665),
    [anon_sym_COLON_COLON] = ACTIONS(3667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3667),
    [anon_sym___declspec] = ACTIONS(3665),
    [anon_sym___based] = ACTIONS(3665),
    [anon_sym___cdecl] = ACTIONS(3665),
    [anon_sym___clrcall] = ACTIONS(3665),
    [anon_sym___stdcall] = ACTIONS(3665),
    [anon_sym___fastcall] = ACTIONS(3665),
    [anon_sym___thiscall] = ACTIONS(3665),
    [anon_sym___vectorcall] = ACTIONS(3665),
    [anon_sym_LBRACE] = ACTIONS(3667),
    [anon_sym_signed] = ACTIONS(3665),
    [anon_sym_unsigned] = ACTIONS(3665),
    [anon_sym_long] = ACTIONS(3665),
    [anon_sym_short] = ACTIONS(3665),
    [anon_sym_LBRACK] = ACTIONS(3665),
    [anon_sym_static] = ACTIONS(3665),
    [anon_sym_register] = ACTIONS(3665),
    [anon_sym_inline] = ACTIONS(3665),
    [anon_sym___inline] = ACTIONS(3665),
    [anon_sym___inline__] = ACTIONS(3665),
    [anon_sym___forceinline] = ACTIONS(3665),
    [anon_sym_thread_local] = ACTIONS(3665),
    [anon_sym___thread] = ACTIONS(3665),
    [anon_sym_const] = ACTIONS(3665),
    [anon_sym_constexpr] = ACTIONS(3665),
    [anon_sym_volatile] = ACTIONS(3665),
    [anon_sym_restrict] = ACTIONS(3665),
    [anon_sym___restrict__] = ACTIONS(3665),
    [anon_sym__Atomic] = ACTIONS(3665),
    [anon_sym__Noreturn] = ACTIONS(3665),
    [anon_sym_noreturn] = ACTIONS(3665),
    [anon_sym_mutable] = ACTIONS(3665),
    [anon_sym_constinit] = ACTIONS(3665),
    [anon_sym_consteval] = ACTIONS(3665),
    [anon_sym_alignas] = ACTIONS(3665),
    [anon_sym__Alignas] = ACTIONS(3665),
    [sym_primitive_type] = ACTIONS(3665),
    [anon_sym_enum] = ACTIONS(3665),
    [anon_sym_class] = ACTIONS(3665),
    [anon_sym_struct] = ACTIONS(3665),
    [anon_sym_union] = ACTIONS(3665),
    [anon_sym_if] = ACTIONS(3665),
    [anon_sym_switch] = ACTIONS(3665),
    [anon_sym_case] = ACTIONS(3665),
    [anon_sym_default] = ACTIONS(3665),
    [anon_sym_while] = ACTIONS(3665),
    [anon_sym_do] = ACTIONS(3665),
    [anon_sym_for] = ACTIONS(3665),
    [anon_sym_return] = ACTIONS(3665),
    [anon_sym_break] = ACTIONS(3665),
    [anon_sym_continue] = ACTIONS(3665),
    [anon_sym_goto] = ACTIONS(3665),
    [anon_sym___try] = ACTIONS(3665),
    [anon_sym___leave] = ACTIONS(3665),
    [anon_sym_not] = ACTIONS(3665),
    [anon_sym_compl] = ACTIONS(3665),
    [anon_sym_DASH_DASH] = ACTIONS(3667),
    [anon_sym_PLUS_PLUS] = ACTIONS(3667),
    [anon_sym_sizeof] = ACTIONS(3665),
    [anon_sym___alignof__] = ACTIONS(3665),
    [anon_sym___alignof] = ACTIONS(3665),
    [anon_sym__alignof] = ACTIONS(3665),
    [anon_sym_alignof] = ACTIONS(3665),
    [anon_sym__Alignof] = ACTIONS(3665),
    [anon_sym_offsetof] = ACTIONS(3665),
    [anon_sym__Generic] = ACTIONS(3665),
    [anon_sym_asm] = ACTIONS(3665),
    [anon_sym___asm__] = ACTIONS(3665),
    [sym_number_literal] = ACTIONS(3667),
    [anon_sym_L_SQUOTE] = ACTIONS(3667),
    [anon_sym_u_SQUOTE] = ACTIONS(3667),
    [anon_sym_U_SQUOTE] = ACTIONS(3667),
    [anon_sym_u8_SQUOTE] = ACTIONS(3667),
    [anon_sym_SQUOTE] = ACTIONS(3667),
    [anon_sym_L_DQUOTE] = ACTIONS(3667),
    [anon_sym_u_DQUOTE] = ACTIONS(3667),
    [anon_sym_U_DQUOTE] = ACTIONS(3667),
    [anon_sym_u8_DQUOTE] = ACTIONS(3667),
    [anon_sym_DQUOTE] = ACTIONS(3667),
    [sym_true] = ACTIONS(3665),
    [sym_false] = ACTIONS(3665),
    [anon_sym_NULL] = ACTIONS(3665),
    [anon_sym_nullptr] = ACTIONS(3665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3665),
    [anon_sym_let] = ACTIONS(3665),
    [anon_sym_This] = ACTIONS(3665),
    [anon_sym_decltype] = ACTIONS(3665),
    [sym_virtual] = ACTIONS(3665),
    [anon_sym_explicit] = ACTIONS(3665),
    [anon_sym_typename] = ACTIONS(3665),
    [anon_sym_template] = ACTIONS(3665),
    [anon_sym_operator] = ACTIONS(3665),
    [anon_sym_try] = ACTIONS(3665),
    [anon_sym_delete] = ACTIONS(3665),
    [anon_sym_throw] = ACTIONS(3665),
    [anon_sym_namespace] = ACTIONS(3665),
    [anon_sym_using] = ACTIONS(3665),
    [anon_sym_static_assert] = ACTIONS(3665),
    [anon_sym_concept] = ACTIONS(3665),
    [anon_sym_co_return] = ACTIONS(3665),
    [anon_sym_co_yield] = ACTIONS(3665),
    [anon_sym_R_DQUOTE] = ACTIONS(3667),
    [anon_sym_LR_DQUOTE] = ACTIONS(3667),
    [anon_sym_uR_DQUOTE] = ACTIONS(3667),
    [anon_sym_UR_DQUOTE] = ACTIONS(3667),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3667),
    [anon_sym_co_await] = ACTIONS(3665),
    [anon_sym_new] = ACTIONS(3665),
    [anon_sym_requires] = ACTIONS(3665),
    [sym_this] = ACTIONS(3665),
    [anon_sym_discard] = ACTIONS(3665),
    [anon_sym_precise] = ACTIONS(3665),
    [anon_sym_shared] = ACTIONS(3665),
    [anon_sym_groupshared] = ACTIONS(3665),
    [anon_sym_uniform] = ACTIONS(3665),
    [anon_sym_row_major] = ACTIONS(3665),
    [anon_sym_column_major] = ACTIONS(3665),
    [anon_sym_globallycoherent] = ACTIONS(3665),
    [anon_sym_centroid] = ACTIONS(3665),
    [anon_sym_noperspective] = ACTIONS(3665),
    [anon_sym_nointerpolation] = ACTIONS(3665),
    [anon_sym_sample] = ACTIONS(3665),
    [anon_sym_linear] = ACTIONS(3665),
    [anon_sym_snorm] = ACTIONS(3665),
    [anon_sym_unorm] = ACTIONS(3665),
    [anon_sym_point] = ACTIONS(3665),
    [anon_sym_line] = ACTIONS(3665),
    [anon_sym_triangleadj] = ACTIONS(3665),
    [anon_sym_lineadj] = ACTIONS(3665),
    [anon_sym_triangle] = ACTIONS(3665),
    [anon_sym_cbuffer] = ACTIONS(3665),
    [anon_sym_interface] = ACTIONS(3665),
    [anon_sym_extension] = ACTIONS(3665),
  },
  [540] = {
    [sym_identifier] = ACTIONS(3669),
    [aux_sym_preproc_include_token1] = ACTIONS(3669),
    [aux_sym_preproc_def_token1] = ACTIONS(3669),
    [aux_sym_preproc_if_token1] = ACTIONS(3669),
    [aux_sym_preproc_if_token2] = ACTIONS(3669),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3669),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3669),
    [aux_sym_preproc_else_token1] = ACTIONS(3669),
    [aux_sym_preproc_elif_token1] = ACTIONS(3669),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3669),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3669),
    [sym_preproc_directive] = ACTIONS(3669),
    [anon_sym_LPAREN2] = ACTIONS(3671),
    [anon_sym_BANG] = ACTIONS(3671),
    [anon_sym_TILDE] = ACTIONS(3671),
    [anon_sym_DASH] = ACTIONS(3669),
    [anon_sym_PLUS] = ACTIONS(3669),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3671),
    [anon_sym_AMP] = ACTIONS(3669),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym___extension__] = ACTIONS(3669),
    [anon_sym_typedef] = ACTIONS(3669),
    [anon_sym_in] = ACTIONS(3669),
    [anon_sym_out] = ACTIONS(3669),
    [anon_sym_inout] = ACTIONS(3669),
    [anon_sym_extern] = ACTIONS(3669),
    [anon_sym___attribute__] = ACTIONS(3669),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3671),
    [anon_sym___declspec] = ACTIONS(3669),
    [anon_sym___based] = ACTIONS(3669),
    [anon_sym___cdecl] = ACTIONS(3669),
    [anon_sym___clrcall] = ACTIONS(3669),
    [anon_sym___stdcall] = ACTIONS(3669),
    [anon_sym___fastcall] = ACTIONS(3669),
    [anon_sym___thiscall] = ACTIONS(3669),
    [anon_sym___vectorcall] = ACTIONS(3669),
    [anon_sym_LBRACE] = ACTIONS(3671),
    [anon_sym_signed] = ACTIONS(3669),
    [anon_sym_unsigned] = ACTIONS(3669),
    [anon_sym_long] = ACTIONS(3669),
    [anon_sym_short] = ACTIONS(3669),
    [anon_sym_LBRACK] = ACTIONS(3669),
    [anon_sym_static] = ACTIONS(3669),
    [anon_sym_register] = ACTIONS(3669),
    [anon_sym_inline] = ACTIONS(3669),
    [anon_sym___inline] = ACTIONS(3669),
    [anon_sym___inline__] = ACTIONS(3669),
    [anon_sym___forceinline] = ACTIONS(3669),
    [anon_sym_thread_local] = ACTIONS(3669),
    [anon_sym___thread] = ACTIONS(3669),
    [anon_sym_const] = ACTIONS(3669),
    [anon_sym_constexpr] = ACTIONS(3669),
    [anon_sym_volatile] = ACTIONS(3669),
    [anon_sym_restrict] = ACTIONS(3669),
    [anon_sym___restrict__] = ACTIONS(3669),
    [anon_sym__Atomic] = ACTIONS(3669),
    [anon_sym__Noreturn] = ACTIONS(3669),
    [anon_sym_noreturn] = ACTIONS(3669),
    [anon_sym_mutable] = ACTIONS(3669),
    [anon_sym_constinit] = ACTIONS(3669),
    [anon_sym_consteval] = ACTIONS(3669),
    [anon_sym_alignas] = ACTIONS(3669),
    [anon_sym__Alignas] = ACTIONS(3669),
    [sym_primitive_type] = ACTIONS(3669),
    [anon_sym_enum] = ACTIONS(3669),
    [anon_sym_class] = ACTIONS(3669),
    [anon_sym_struct] = ACTIONS(3669),
    [anon_sym_union] = ACTIONS(3669),
    [anon_sym_if] = ACTIONS(3669),
    [anon_sym_switch] = ACTIONS(3669),
    [anon_sym_case] = ACTIONS(3669),
    [anon_sym_default] = ACTIONS(3669),
    [anon_sym_while] = ACTIONS(3669),
    [anon_sym_do] = ACTIONS(3669),
    [anon_sym_for] = ACTIONS(3669),
    [anon_sym_return] = ACTIONS(3669),
    [anon_sym_break] = ACTIONS(3669),
    [anon_sym_continue] = ACTIONS(3669),
    [anon_sym_goto] = ACTIONS(3669),
    [anon_sym___try] = ACTIONS(3669),
    [anon_sym___leave] = ACTIONS(3669),
    [anon_sym_not] = ACTIONS(3669),
    [anon_sym_compl] = ACTIONS(3669),
    [anon_sym_DASH_DASH] = ACTIONS(3671),
    [anon_sym_PLUS_PLUS] = ACTIONS(3671),
    [anon_sym_sizeof] = ACTIONS(3669),
    [anon_sym___alignof__] = ACTIONS(3669),
    [anon_sym___alignof] = ACTIONS(3669),
    [anon_sym__alignof] = ACTIONS(3669),
    [anon_sym_alignof] = ACTIONS(3669),
    [anon_sym__Alignof] = ACTIONS(3669),
    [anon_sym_offsetof] = ACTIONS(3669),
    [anon_sym__Generic] = ACTIONS(3669),
    [anon_sym_asm] = ACTIONS(3669),
    [anon_sym___asm__] = ACTIONS(3669),
    [sym_number_literal] = ACTIONS(3671),
    [anon_sym_L_SQUOTE] = ACTIONS(3671),
    [anon_sym_u_SQUOTE] = ACTIONS(3671),
    [anon_sym_U_SQUOTE] = ACTIONS(3671),
    [anon_sym_u8_SQUOTE] = ACTIONS(3671),
    [anon_sym_SQUOTE] = ACTIONS(3671),
    [anon_sym_L_DQUOTE] = ACTIONS(3671),
    [anon_sym_u_DQUOTE] = ACTIONS(3671),
    [anon_sym_U_DQUOTE] = ACTIONS(3671),
    [anon_sym_u8_DQUOTE] = ACTIONS(3671),
    [anon_sym_DQUOTE] = ACTIONS(3671),
    [sym_true] = ACTIONS(3669),
    [sym_false] = ACTIONS(3669),
    [anon_sym_NULL] = ACTIONS(3669),
    [anon_sym_nullptr] = ACTIONS(3669),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3669),
    [anon_sym_let] = ACTIONS(3669),
    [anon_sym_This] = ACTIONS(3669),
    [anon_sym_decltype] = ACTIONS(3669),
    [sym_virtual] = ACTIONS(3669),
    [anon_sym_explicit] = ACTIONS(3669),
    [anon_sym_typename] = ACTIONS(3669),
    [anon_sym_template] = ACTIONS(3669),
    [anon_sym_operator] = ACTIONS(3669),
    [anon_sym_try] = ACTIONS(3669),
    [anon_sym_delete] = ACTIONS(3669),
    [anon_sym_throw] = ACTIONS(3669),
    [anon_sym_namespace] = ACTIONS(3669),
    [anon_sym_using] = ACTIONS(3669),
    [anon_sym_static_assert] = ACTIONS(3669),
    [anon_sym_concept] = ACTIONS(3669),
    [anon_sym_co_return] = ACTIONS(3669),
    [anon_sym_co_yield] = ACTIONS(3669),
    [anon_sym_R_DQUOTE] = ACTIONS(3671),
    [anon_sym_LR_DQUOTE] = ACTIONS(3671),
    [anon_sym_uR_DQUOTE] = ACTIONS(3671),
    [anon_sym_UR_DQUOTE] = ACTIONS(3671),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3671),
    [anon_sym_co_await] = ACTIONS(3669),
    [anon_sym_new] = ACTIONS(3669),
    [anon_sym_requires] = ACTIONS(3669),
    [sym_this] = ACTIONS(3669),
    [anon_sym_discard] = ACTIONS(3669),
    [anon_sym_precise] = ACTIONS(3669),
    [anon_sym_shared] = ACTIONS(3669),
    [anon_sym_groupshared] = ACTIONS(3669),
    [anon_sym_uniform] = ACTIONS(3669),
    [anon_sym_row_major] = ACTIONS(3669),
    [anon_sym_column_major] = ACTIONS(3669),
    [anon_sym_globallycoherent] = ACTIONS(3669),
    [anon_sym_centroid] = ACTIONS(3669),
    [anon_sym_noperspective] = ACTIONS(3669),
    [anon_sym_nointerpolation] = ACTIONS(3669),
    [anon_sym_sample] = ACTIONS(3669),
    [anon_sym_linear] = ACTIONS(3669),
    [anon_sym_snorm] = ACTIONS(3669),
    [anon_sym_unorm] = ACTIONS(3669),
    [anon_sym_point] = ACTIONS(3669),
    [anon_sym_line] = ACTIONS(3669),
    [anon_sym_triangleadj] = ACTIONS(3669),
    [anon_sym_lineadj] = ACTIONS(3669),
    [anon_sym_triangle] = ACTIONS(3669),
    [anon_sym_cbuffer] = ACTIONS(3669),
    [anon_sym_interface] = ACTIONS(3669),
    [anon_sym_extension] = ACTIONS(3669),
  },
  [541] = {
    [sym_identifier] = ACTIONS(3673),
    [aux_sym_preproc_include_token1] = ACTIONS(3673),
    [aux_sym_preproc_def_token1] = ACTIONS(3673),
    [aux_sym_preproc_if_token1] = ACTIONS(3673),
    [aux_sym_preproc_if_token2] = ACTIONS(3673),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3673),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3673),
    [aux_sym_preproc_else_token1] = ACTIONS(3673),
    [aux_sym_preproc_elif_token1] = ACTIONS(3673),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3673),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3673),
    [sym_preproc_directive] = ACTIONS(3673),
    [anon_sym_LPAREN2] = ACTIONS(3675),
    [anon_sym_BANG] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3673),
    [anon_sym_PLUS] = ACTIONS(3673),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3673),
    [anon_sym_SEMI] = ACTIONS(3675),
    [anon_sym___extension__] = ACTIONS(3673),
    [anon_sym_typedef] = ACTIONS(3673),
    [anon_sym_in] = ACTIONS(3673),
    [anon_sym_out] = ACTIONS(3673),
    [anon_sym_inout] = ACTIONS(3673),
    [anon_sym_extern] = ACTIONS(3673),
    [anon_sym___attribute__] = ACTIONS(3673),
    [anon_sym_COLON_COLON] = ACTIONS(3675),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3675),
    [anon_sym___declspec] = ACTIONS(3673),
    [anon_sym___based] = ACTIONS(3673),
    [anon_sym___cdecl] = ACTIONS(3673),
    [anon_sym___clrcall] = ACTIONS(3673),
    [anon_sym___stdcall] = ACTIONS(3673),
    [anon_sym___fastcall] = ACTIONS(3673),
    [anon_sym___thiscall] = ACTIONS(3673),
    [anon_sym___vectorcall] = ACTIONS(3673),
    [anon_sym_LBRACE] = ACTIONS(3675),
    [anon_sym_signed] = ACTIONS(3673),
    [anon_sym_unsigned] = ACTIONS(3673),
    [anon_sym_long] = ACTIONS(3673),
    [anon_sym_short] = ACTIONS(3673),
    [anon_sym_LBRACK] = ACTIONS(3673),
    [anon_sym_static] = ACTIONS(3673),
    [anon_sym_register] = ACTIONS(3673),
    [anon_sym_inline] = ACTIONS(3673),
    [anon_sym___inline] = ACTIONS(3673),
    [anon_sym___inline__] = ACTIONS(3673),
    [anon_sym___forceinline] = ACTIONS(3673),
    [anon_sym_thread_local] = ACTIONS(3673),
    [anon_sym___thread] = ACTIONS(3673),
    [anon_sym_const] = ACTIONS(3673),
    [anon_sym_constexpr] = ACTIONS(3673),
    [anon_sym_volatile] = ACTIONS(3673),
    [anon_sym_restrict] = ACTIONS(3673),
    [anon_sym___restrict__] = ACTIONS(3673),
    [anon_sym__Atomic] = ACTIONS(3673),
    [anon_sym__Noreturn] = ACTIONS(3673),
    [anon_sym_noreturn] = ACTIONS(3673),
    [anon_sym_mutable] = ACTIONS(3673),
    [anon_sym_constinit] = ACTIONS(3673),
    [anon_sym_consteval] = ACTIONS(3673),
    [anon_sym_alignas] = ACTIONS(3673),
    [anon_sym__Alignas] = ACTIONS(3673),
    [sym_primitive_type] = ACTIONS(3673),
    [anon_sym_enum] = ACTIONS(3673),
    [anon_sym_class] = ACTIONS(3673),
    [anon_sym_struct] = ACTIONS(3673),
    [anon_sym_union] = ACTIONS(3673),
    [anon_sym_if] = ACTIONS(3673),
    [anon_sym_switch] = ACTIONS(3673),
    [anon_sym_case] = ACTIONS(3673),
    [anon_sym_default] = ACTIONS(3673),
    [anon_sym_while] = ACTIONS(3673),
    [anon_sym_do] = ACTIONS(3673),
    [anon_sym_for] = ACTIONS(3673),
    [anon_sym_return] = ACTIONS(3673),
    [anon_sym_break] = ACTIONS(3673),
    [anon_sym_continue] = ACTIONS(3673),
    [anon_sym_goto] = ACTIONS(3673),
    [anon_sym___try] = ACTIONS(3673),
    [anon_sym___leave] = ACTIONS(3673),
    [anon_sym_not] = ACTIONS(3673),
    [anon_sym_compl] = ACTIONS(3673),
    [anon_sym_DASH_DASH] = ACTIONS(3675),
    [anon_sym_PLUS_PLUS] = ACTIONS(3675),
    [anon_sym_sizeof] = ACTIONS(3673),
    [anon_sym___alignof__] = ACTIONS(3673),
    [anon_sym___alignof] = ACTIONS(3673),
    [anon_sym__alignof] = ACTIONS(3673),
    [anon_sym_alignof] = ACTIONS(3673),
    [anon_sym__Alignof] = ACTIONS(3673),
    [anon_sym_offsetof] = ACTIONS(3673),
    [anon_sym__Generic] = ACTIONS(3673),
    [anon_sym_asm] = ACTIONS(3673),
    [anon_sym___asm__] = ACTIONS(3673),
    [sym_number_literal] = ACTIONS(3675),
    [anon_sym_L_SQUOTE] = ACTIONS(3675),
    [anon_sym_u_SQUOTE] = ACTIONS(3675),
    [anon_sym_U_SQUOTE] = ACTIONS(3675),
    [anon_sym_u8_SQUOTE] = ACTIONS(3675),
    [anon_sym_SQUOTE] = ACTIONS(3675),
    [anon_sym_L_DQUOTE] = ACTIONS(3675),
    [anon_sym_u_DQUOTE] = ACTIONS(3675),
    [anon_sym_U_DQUOTE] = ACTIONS(3675),
    [anon_sym_u8_DQUOTE] = ACTIONS(3675),
    [anon_sym_DQUOTE] = ACTIONS(3675),
    [sym_true] = ACTIONS(3673),
    [sym_false] = ACTIONS(3673),
    [anon_sym_NULL] = ACTIONS(3673),
    [anon_sym_nullptr] = ACTIONS(3673),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3673),
    [anon_sym_let] = ACTIONS(3673),
    [anon_sym_This] = ACTIONS(3673),
    [anon_sym_decltype] = ACTIONS(3673),
    [sym_virtual] = ACTIONS(3673),
    [anon_sym_explicit] = ACTIONS(3673),
    [anon_sym_typename] = ACTIONS(3673),
    [anon_sym_template] = ACTIONS(3673),
    [anon_sym_operator] = ACTIONS(3673),
    [anon_sym_try] = ACTIONS(3673),
    [anon_sym_delete] = ACTIONS(3673),
    [anon_sym_throw] = ACTIONS(3673),
    [anon_sym_namespace] = ACTIONS(3673),
    [anon_sym_using] = ACTIONS(3673),
    [anon_sym_static_assert] = ACTIONS(3673),
    [anon_sym_concept] = ACTIONS(3673),
    [anon_sym_co_return] = ACTIONS(3673),
    [anon_sym_co_yield] = ACTIONS(3673),
    [anon_sym_R_DQUOTE] = ACTIONS(3675),
    [anon_sym_LR_DQUOTE] = ACTIONS(3675),
    [anon_sym_uR_DQUOTE] = ACTIONS(3675),
    [anon_sym_UR_DQUOTE] = ACTIONS(3675),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3675),
    [anon_sym_co_await] = ACTIONS(3673),
    [anon_sym_new] = ACTIONS(3673),
    [anon_sym_requires] = ACTIONS(3673),
    [sym_this] = ACTIONS(3673),
    [anon_sym_discard] = ACTIONS(3673),
    [anon_sym_precise] = ACTIONS(3673),
    [anon_sym_shared] = ACTIONS(3673),
    [anon_sym_groupshared] = ACTIONS(3673),
    [anon_sym_uniform] = ACTIONS(3673),
    [anon_sym_row_major] = ACTIONS(3673),
    [anon_sym_column_major] = ACTIONS(3673),
    [anon_sym_globallycoherent] = ACTIONS(3673),
    [anon_sym_centroid] = ACTIONS(3673),
    [anon_sym_noperspective] = ACTIONS(3673),
    [anon_sym_nointerpolation] = ACTIONS(3673),
    [anon_sym_sample] = ACTIONS(3673),
    [anon_sym_linear] = ACTIONS(3673),
    [anon_sym_snorm] = ACTIONS(3673),
    [anon_sym_unorm] = ACTIONS(3673),
    [anon_sym_point] = ACTIONS(3673),
    [anon_sym_line] = ACTIONS(3673),
    [anon_sym_triangleadj] = ACTIONS(3673),
    [anon_sym_lineadj] = ACTIONS(3673),
    [anon_sym_triangle] = ACTIONS(3673),
    [anon_sym_cbuffer] = ACTIONS(3673),
    [anon_sym_interface] = ACTIONS(3673),
    [anon_sym_extension] = ACTIONS(3673),
  },
  [542] = {
    [sym_identifier] = ACTIONS(3677),
    [aux_sym_preproc_include_token1] = ACTIONS(3677),
    [aux_sym_preproc_def_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token2] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3677),
    [aux_sym_preproc_else_token1] = ACTIONS(3677),
    [aux_sym_preproc_elif_token1] = ACTIONS(3677),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3677),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3677),
    [sym_preproc_directive] = ACTIONS(3677),
    [anon_sym_LPAREN2] = ACTIONS(3679),
    [anon_sym_BANG] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3677),
    [anon_sym_PLUS] = ACTIONS(3677),
    [anon_sym_STAR] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_AMP] = ACTIONS(3677),
    [anon_sym_SEMI] = ACTIONS(3679),
    [anon_sym___extension__] = ACTIONS(3677),
    [anon_sym_typedef] = ACTIONS(3677),
    [anon_sym_in] = ACTIONS(3677),
    [anon_sym_out] = ACTIONS(3677),
    [anon_sym_inout] = ACTIONS(3677),
    [anon_sym_extern] = ACTIONS(3677),
    [anon_sym___attribute__] = ACTIONS(3677),
    [anon_sym_COLON_COLON] = ACTIONS(3679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3679),
    [anon_sym___declspec] = ACTIONS(3677),
    [anon_sym___based] = ACTIONS(3677),
    [anon_sym___cdecl] = ACTIONS(3677),
    [anon_sym___clrcall] = ACTIONS(3677),
    [anon_sym___stdcall] = ACTIONS(3677),
    [anon_sym___fastcall] = ACTIONS(3677),
    [anon_sym___thiscall] = ACTIONS(3677),
    [anon_sym___vectorcall] = ACTIONS(3677),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_signed] = ACTIONS(3677),
    [anon_sym_unsigned] = ACTIONS(3677),
    [anon_sym_long] = ACTIONS(3677),
    [anon_sym_short] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3677),
    [anon_sym_static] = ACTIONS(3677),
    [anon_sym_register] = ACTIONS(3677),
    [anon_sym_inline] = ACTIONS(3677),
    [anon_sym___inline] = ACTIONS(3677),
    [anon_sym___inline__] = ACTIONS(3677),
    [anon_sym___forceinline] = ACTIONS(3677),
    [anon_sym_thread_local] = ACTIONS(3677),
    [anon_sym___thread] = ACTIONS(3677),
    [anon_sym_const] = ACTIONS(3677),
    [anon_sym_constexpr] = ACTIONS(3677),
    [anon_sym_volatile] = ACTIONS(3677),
    [anon_sym_restrict] = ACTIONS(3677),
    [anon_sym___restrict__] = ACTIONS(3677),
    [anon_sym__Atomic] = ACTIONS(3677),
    [anon_sym__Noreturn] = ACTIONS(3677),
    [anon_sym_noreturn] = ACTIONS(3677),
    [anon_sym_mutable] = ACTIONS(3677),
    [anon_sym_constinit] = ACTIONS(3677),
    [anon_sym_consteval] = ACTIONS(3677),
    [anon_sym_alignas] = ACTIONS(3677),
    [anon_sym__Alignas] = ACTIONS(3677),
    [sym_primitive_type] = ACTIONS(3677),
    [anon_sym_enum] = ACTIONS(3677),
    [anon_sym_class] = ACTIONS(3677),
    [anon_sym_struct] = ACTIONS(3677),
    [anon_sym_union] = ACTIONS(3677),
    [anon_sym_if] = ACTIONS(3677),
    [anon_sym_switch] = ACTIONS(3677),
    [anon_sym_case] = ACTIONS(3677),
    [anon_sym_default] = ACTIONS(3677),
    [anon_sym_while] = ACTIONS(3677),
    [anon_sym_do] = ACTIONS(3677),
    [anon_sym_for] = ACTIONS(3677),
    [anon_sym_return] = ACTIONS(3677),
    [anon_sym_break] = ACTIONS(3677),
    [anon_sym_continue] = ACTIONS(3677),
    [anon_sym_goto] = ACTIONS(3677),
    [anon_sym___try] = ACTIONS(3677),
    [anon_sym___leave] = ACTIONS(3677),
    [anon_sym_not] = ACTIONS(3677),
    [anon_sym_compl] = ACTIONS(3677),
    [anon_sym_DASH_DASH] = ACTIONS(3679),
    [anon_sym_PLUS_PLUS] = ACTIONS(3679),
    [anon_sym_sizeof] = ACTIONS(3677),
    [anon_sym___alignof__] = ACTIONS(3677),
    [anon_sym___alignof] = ACTIONS(3677),
    [anon_sym__alignof] = ACTIONS(3677),
    [anon_sym_alignof] = ACTIONS(3677),
    [anon_sym__Alignof] = ACTIONS(3677),
    [anon_sym_offsetof] = ACTIONS(3677),
    [anon_sym__Generic] = ACTIONS(3677),
    [anon_sym_asm] = ACTIONS(3677),
    [anon_sym___asm__] = ACTIONS(3677),
    [sym_number_literal] = ACTIONS(3679),
    [anon_sym_L_SQUOTE] = ACTIONS(3679),
    [anon_sym_u_SQUOTE] = ACTIONS(3679),
    [anon_sym_U_SQUOTE] = ACTIONS(3679),
    [anon_sym_u8_SQUOTE] = ACTIONS(3679),
    [anon_sym_SQUOTE] = ACTIONS(3679),
    [anon_sym_L_DQUOTE] = ACTIONS(3679),
    [anon_sym_u_DQUOTE] = ACTIONS(3679),
    [anon_sym_U_DQUOTE] = ACTIONS(3679),
    [anon_sym_u8_DQUOTE] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3679),
    [sym_true] = ACTIONS(3677),
    [sym_false] = ACTIONS(3677),
    [anon_sym_NULL] = ACTIONS(3677),
    [anon_sym_nullptr] = ACTIONS(3677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3677),
    [anon_sym_let] = ACTIONS(3677),
    [anon_sym_This] = ACTIONS(3677),
    [anon_sym_decltype] = ACTIONS(3677),
    [sym_virtual] = ACTIONS(3677),
    [anon_sym_explicit] = ACTIONS(3677),
    [anon_sym_typename] = ACTIONS(3677),
    [anon_sym_template] = ACTIONS(3677),
    [anon_sym_operator] = ACTIONS(3677),
    [anon_sym_try] = ACTIONS(3677),
    [anon_sym_delete] = ACTIONS(3677),
    [anon_sym_throw] = ACTIONS(3677),
    [anon_sym_namespace] = ACTIONS(3677),
    [anon_sym_using] = ACTIONS(3677),
    [anon_sym_static_assert] = ACTIONS(3677),
    [anon_sym_concept] = ACTIONS(3677),
    [anon_sym_co_return] = ACTIONS(3677),
    [anon_sym_co_yield] = ACTIONS(3677),
    [anon_sym_R_DQUOTE] = ACTIONS(3679),
    [anon_sym_LR_DQUOTE] = ACTIONS(3679),
    [anon_sym_uR_DQUOTE] = ACTIONS(3679),
    [anon_sym_UR_DQUOTE] = ACTIONS(3679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3679),
    [anon_sym_co_await] = ACTIONS(3677),
    [anon_sym_new] = ACTIONS(3677),
    [anon_sym_requires] = ACTIONS(3677),
    [sym_this] = ACTIONS(3677),
    [anon_sym_discard] = ACTIONS(3677),
    [anon_sym_precise] = ACTIONS(3677),
    [anon_sym_shared] = ACTIONS(3677),
    [anon_sym_groupshared] = ACTIONS(3677),
    [anon_sym_uniform] = ACTIONS(3677),
    [anon_sym_row_major] = ACTIONS(3677),
    [anon_sym_column_major] = ACTIONS(3677),
    [anon_sym_globallycoherent] = ACTIONS(3677),
    [anon_sym_centroid] = ACTIONS(3677),
    [anon_sym_noperspective] = ACTIONS(3677),
    [anon_sym_nointerpolation] = ACTIONS(3677),
    [anon_sym_sample] = ACTIONS(3677),
    [anon_sym_linear] = ACTIONS(3677),
    [anon_sym_snorm] = ACTIONS(3677),
    [anon_sym_unorm] = ACTIONS(3677),
    [anon_sym_point] = ACTIONS(3677),
    [anon_sym_line] = ACTIONS(3677),
    [anon_sym_triangleadj] = ACTIONS(3677),
    [anon_sym_lineadj] = ACTIONS(3677),
    [anon_sym_triangle] = ACTIONS(3677),
    [anon_sym_cbuffer] = ACTIONS(3677),
    [anon_sym_interface] = ACTIONS(3677),
    [anon_sym_extension] = ACTIONS(3677),
  },
  [543] = {
    [sym_identifier] = ACTIONS(3681),
    [aux_sym_preproc_include_token1] = ACTIONS(3681),
    [aux_sym_preproc_def_token1] = ACTIONS(3681),
    [aux_sym_preproc_if_token1] = ACTIONS(3681),
    [aux_sym_preproc_if_token2] = ACTIONS(3681),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3681),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3681),
    [aux_sym_preproc_else_token1] = ACTIONS(3681),
    [aux_sym_preproc_elif_token1] = ACTIONS(3681),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3681),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3681),
    [sym_preproc_directive] = ACTIONS(3681),
    [anon_sym_LPAREN2] = ACTIONS(3683),
    [anon_sym_BANG] = ACTIONS(3683),
    [anon_sym_TILDE] = ACTIONS(3683),
    [anon_sym_DASH] = ACTIONS(3681),
    [anon_sym_PLUS] = ACTIONS(3681),
    [anon_sym_STAR] = ACTIONS(3683),
    [anon_sym_AMP_AMP] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3681),
    [anon_sym_SEMI] = ACTIONS(3683),
    [anon_sym___extension__] = ACTIONS(3681),
    [anon_sym_typedef] = ACTIONS(3681),
    [anon_sym_in] = ACTIONS(3681),
    [anon_sym_out] = ACTIONS(3681),
    [anon_sym_inout] = ACTIONS(3681),
    [anon_sym_extern] = ACTIONS(3681),
    [anon_sym___attribute__] = ACTIONS(3681),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3683),
    [anon_sym___declspec] = ACTIONS(3681),
    [anon_sym___based] = ACTIONS(3681),
    [anon_sym___cdecl] = ACTIONS(3681),
    [anon_sym___clrcall] = ACTIONS(3681),
    [anon_sym___stdcall] = ACTIONS(3681),
    [anon_sym___fastcall] = ACTIONS(3681),
    [anon_sym___thiscall] = ACTIONS(3681),
    [anon_sym___vectorcall] = ACTIONS(3681),
    [anon_sym_LBRACE] = ACTIONS(3683),
    [anon_sym_signed] = ACTIONS(3681),
    [anon_sym_unsigned] = ACTIONS(3681),
    [anon_sym_long] = ACTIONS(3681),
    [anon_sym_short] = ACTIONS(3681),
    [anon_sym_LBRACK] = ACTIONS(3681),
    [anon_sym_static] = ACTIONS(3681),
    [anon_sym_register] = ACTIONS(3681),
    [anon_sym_inline] = ACTIONS(3681),
    [anon_sym___inline] = ACTIONS(3681),
    [anon_sym___inline__] = ACTIONS(3681),
    [anon_sym___forceinline] = ACTIONS(3681),
    [anon_sym_thread_local] = ACTIONS(3681),
    [anon_sym___thread] = ACTIONS(3681),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_constexpr] = ACTIONS(3681),
    [anon_sym_volatile] = ACTIONS(3681),
    [anon_sym_restrict] = ACTIONS(3681),
    [anon_sym___restrict__] = ACTIONS(3681),
    [anon_sym__Atomic] = ACTIONS(3681),
    [anon_sym__Noreturn] = ACTIONS(3681),
    [anon_sym_noreturn] = ACTIONS(3681),
    [anon_sym_mutable] = ACTIONS(3681),
    [anon_sym_constinit] = ACTIONS(3681),
    [anon_sym_consteval] = ACTIONS(3681),
    [anon_sym_alignas] = ACTIONS(3681),
    [anon_sym__Alignas] = ACTIONS(3681),
    [sym_primitive_type] = ACTIONS(3681),
    [anon_sym_enum] = ACTIONS(3681),
    [anon_sym_class] = ACTIONS(3681),
    [anon_sym_struct] = ACTIONS(3681),
    [anon_sym_union] = ACTIONS(3681),
    [anon_sym_if] = ACTIONS(3681),
    [anon_sym_switch] = ACTIONS(3681),
    [anon_sym_case] = ACTIONS(3681),
    [anon_sym_default] = ACTIONS(3681),
    [anon_sym_while] = ACTIONS(3681),
    [anon_sym_do] = ACTIONS(3681),
    [anon_sym_for] = ACTIONS(3681),
    [anon_sym_return] = ACTIONS(3681),
    [anon_sym_break] = ACTIONS(3681),
    [anon_sym_continue] = ACTIONS(3681),
    [anon_sym_goto] = ACTIONS(3681),
    [anon_sym___try] = ACTIONS(3681),
    [anon_sym___leave] = ACTIONS(3681),
    [anon_sym_not] = ACTIONS(3681),
    [anon_sym_compl] = ACTIONS(3681),
    [anon_sym_DASH_DASH] = ACTIONS(3683),
    [anon_sym_PLUS_PLUS] = ACTIONS(3683),
    [anon_sym_sizeof] = ACTIONS(3681),
    [anon_sym___alignof__] = ACTIONS(3681),
    [anon_sym___alignof] = ACTIONS(3681),
    [anon_sym__alignof] = ACTIONS(3681),
    [anon_sym_alignof] = ACTIONS(3681),
    [anon_sym__Alignof] = ACTIONS(3681),
    [anon_sym_offsetof] = ACTIONS(3681),
    [anon_sym__Generic] = ACTIONS(3681),
    [anon_sym_asm] = ACTIONS(3681),
    [anon_sym___asm__] = ACTIONS(3681),
    [sym_number_literal] = ACTIONS(3683),
    [anon_sym_L_SQUOTE] = ACTIONS(3683),
    [anon_sym_u_SQUOTE] = ACTIONS(3683),
    [anon_sym_U_SQUOTE] = ACTIONS(3683),
    [anon_sym_u8_SQUOTE] = ACTIONS(3683),
    [anon_sym_SQUOTE] = ACTIONS(3683),
    [anon_sym_L_DQUOTE] = ACTIONS(3683),
    [anon_sym_u_DQUOTE] = ACTIONS(3683),
    [anon_sym_U_DQUOTE] = ACTIONS(3683),
    [anon_sym_u8_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE] = ACTIONS(3683),
    [sym_true] = ACTIONS(3681),
    [sym_false] = ACTIONS(3681),
    [anon_sym_NULL] = ACTIONS(3681),
    [anon_sym_nullptr] = ACTIONS(3681),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3681),
    [anon_sym_let] = ACTIONS(3681),
    [anon_sym_This] = ACTIONS(3681),
    [anon_sym_decltype] = ACTIONS(3681),
    [sym_virtual] = ACTIONS(3681),
    [anon_sym_explicit] = ACTIONS(3681),
    [anon_sym_typename] = ACTIONS(3681),
    [anon_sym_template] = ACTIONS(3681),
    [anon_sym_operator] = ACTIONS(3681),
    [anon_sym_try] = ACTIONS(3681),
    [anon_sym_delete] = ACTIONS(3681),
    [anon_sym_throw] = ACTIONS(3681),
    [anon_sym_namespace] = ACTIONS(3681),
    [anon_sym_using] = ACTIONS(3681),
    [anon_sym_static_assert] = ACTIONS(3681),
    [anon_sym_concept] = ACTIONS(3681),
    [anon_sym_co_return] = ACTIONS(3681),
    [anon_sym_co_yield] = ACTIONS(3681),
    [anon_sym_R_DQUOTE] = ACTIONS(3683),
    [anon_sym_LR_DQUOTE] = ACTIONS(3683),
    [anon_sym_uR_DQUOTE] = ACTIONS(3683),
    [anon_sym_UR_DQUOTE] = ACTIONS(3683),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3683),
    [anon_sym_co_await] = ACTIONS(3681),
    [anon_sym_new] = ACTIONS(3681),
    [anon_sym_requires] = ACTIONS(3681),
    [sym_this] = ACTIONS(3681),
    [anon_sym_discard] = ACTIONS(3681),
    [anon_sym_precise] = ACTIONS(3681),
    [anon_sym_shared] = ACTIONS(3681),
    [anon_sym_groupshared] = ACTIONS(3681),
    [anon_sym_uniform] = ACTIONS(3681),
    [anon_sym_row_major] = ACTIONS(3681),
    [anon_sym_column_major] = ACTIONS(3681),
    [anon_sym_globallycoherent] = ACTIONS(3681),
    [anon_sym_centroid] = ACTIONS(3681),
    [anon_sym_noperspective] = ACTIONS(3681),
    [anon_sym_nointerpolation] = ACTIONS(3681),
    [anon_sym_sample] = ACTIONS(3681),
    [anon_sym_linear] = ACTIONS(3681),
    [anon_sym_snorm] = ACTIONS(3681),
    [anon_sym_unorm] = ACTIONS(3681),
    [anon_sym_point] = ACTIONS(3681),
    [anon_sym_line] = ACTIONS(3681),
    [anon_sym_triangleadj] = ACTIONS(3681),
    [anon_sym_lineadj] = ACTIONS(3681),
    [anon_sym_triangle] = ACTIONS(3681),
    [anon_sym_cbuffer] = ACTIONS(3681),
    [anon_sym_interface] = ACTIONS(3681),
    [anon_sym_extension] = ACTIONS(3681),
  },
  [544] = {
    [sym_identifier] = ACTIONS(3685),
    [aux_sym_preproc_include_token1] = ACTIONS(3685),
    [aux_sym_preproc_def_token1] = ACTIONS(3685),
    [aux_sym_preproc_if_token1] = ACTIONS(3685),
    [aux_sym_preproc_if_token2] = ACTIONS(3685),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3685),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3685),
    [aux_sym_preproc_else_token1] = ACTIONS(3685),
    [aux_sym_preproc_elif_token1] = ACTIONS(3685),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3685),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3685),
    [sym_preproc_directive] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3687),
    [anon_sym_BANG] = ACTIONS(3687),
    [anon_sym_TILDE] = ACTIONS(3687),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_STAR] = ACTIONS(3687),
    [anon_sym_AMP_AMP] = ACTIONS(3687),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_SEMI] = ACTIONS(3687),
    [anon_sym___extension__] = ACTIONS(3685),
    [anon_sym_typedef] = ACTIONS(3685),
    [anon_sym_in] = ACTIONS(3685),
    [anon_sym_out] = ACTIONS(3685),
    [anon_sym_inout] = ACTIONS(3685),
    [anon_sym_extern] = ACTIONS(3685),
    [anon_sym___attribute__] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3687),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3687),
    [anon_sym___declspec] = ACTIONS(3685),
    [anon_sym___based] = ACTIONS(3685),
    [anon_sym___cdecl] = ACTIONS(3685),
    [anon_sym___clrcall] = ACTIONS(3685),
    [anon_sym___stdcall] = ACTIONS(3685),
    [anon_sym___fastcall] = ACTIONS(3685),
    [anon_sym___thiscall] = ACTIONS(3685),
    [anon_sym___vectorcall] = ACTIONS(3685),
    [anon_sym_LBRACE] = ACTIONS(3687),
    [anon_sym_signed] = ACTIONS(3685),
    [anon_sym_unsigned] = ACTIONS(3685),
    [anon_sym_long] = ACTIONS(3685),
    [anon_sym_short] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_static] = ACTIONS(3685),
    [anon_sym_register] = ACTIONS(3685),
    [anon_sym_inline] = ACTIONS(3685),
    [anon_sym___inline] = ACTIONS(3685),
    [anon_sym___inline__] = ACTIONS(3685),
    [anon_sym___forceinline] = ACTIONS(3685),
    [anon_sym_thread_local] = ACTIONS(3685),
    [anon_sym___thread] = ACTIONS(3685),
    [anon_sym_const] = ACTIONS(3685),
    [anon_sym_constexpr] = ACTIONS(3685),
    [anon_sym_volatile] = ACTIONS(3685),
    [anon_sym_restrict] = ACTIONS(3685),
    [anon_sym___restrict__] = ACTIONS(3685),
    [anon_sym__Atomic] = ACTIONS(3685),
    [anon_sym__Noreturn] = ACTIONS(3685),
    [anon_sym_noreturn] = ACTIONS(3685),
    [anon_sym_mutable] = ACTIONS(3685),
    [anon_sym_constinit] = ACTIONS(3685),
    [anon_sym_consteval] = ACTIONS(3685),
    [anon_sym_alignas] = ACTIONS(3685),
    [anon_sym__Alignas] = ACTIONS(3685),
    [sym_primitive_type] = ACTIONS(3685),
    [anon_sym_enum] = ACTIONS(3685),
    [anon_sym_class] = ACTIONS(3685),
    [anon_sym_struct] = ACTIONS(3685),
    [anon_sym_union] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_switch] = ACTIONS(3685),
    [anon_sym_case] = ACTIONS(3685),
    [anon_sym_default] = ACTIONS(3685),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_break] = ACTIONS(3685),
    [anon_sym_continue] = ACTIONS(3685),
    [anon_sym_goto] = ACTIONS(3685),
    [anon_sym___try] = ACTIONS(3685),
    [anon_sym___leave] = ACTIONS(3685),
    [anon_sym_not] = ACTIONS(3685),
    [anon_sym_compl] = ACTIONS(3685),
    [anon_sym_DASH_DASH] = ACTIONS(3687),
    [anon_sym_PLUS_PLUS] = ACTIONS(3687),
    [anon_sym_sizeof] = ACTIONS(3685),
    [anon_sym___alignof__] = ACTIONS(3685),
    [anon_sym___alignof] = ACTIONS(3685),
    [anon_sym__alignof] = ACTIONS(3685),
    [anon_sym_alignof] = ACTIONS(3685),
    [anon_sym__Alignof] = ACTIONS(3685),
    [anon_sym_offsetof] = ACTIONS(3685),
    [anon_sym__Generic] = ACTIONS(3685),
    [anon_sym_asm] = ACTIONS(3685),
    [anon_sym___asm__] = ACTIONS(3685),
    [sym_number_literal] = ACTIONS(3687),
    [anon_sym_L_SQUOTE] = ACTIONS(3687),
    [anon_sym_u_SQUOTE] = ACTIONS(3687),
    [anon_sym_U_SQUOTE] = ACTIONS(3687),
    [anon_sym_u8_SQUOTE] = ACTIONS(3687),
    [anon_sym_SQUOTE] = ACTIONS(3687),
    [anon_sym_L_DQUOTE] = ACTIONS(3687),
    [anon_sym_u_DQUOTE] = ACTIONS(3687),
    [anon_sym_U_DQUOTE] = ACTIONS(3687),
    [anon_sym_u8_DQUOTE] = ACTIONS(3687),
    [anon_sym_DQUOTE] = ACTIONS(3687),
    [sym_true] = ACTIONS(3685),
    [sym_false] = ACTIONS(3685),
    [anon_sym_NULL] = ACTIONS(3685),
    [anon_sym_nullptr] = ACTIONS(3685),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_This] = ACTIONS(3685),
    [anon_sym_decltype] = ACTIONS(3685),
    [sym_virtual] = ACTIONS(3685),
    [anon_sym_explicit] = ACTIONS(3685),
    [anon_sym_typename] = ACTIONS(3685),
    [anon_sym_template] = ACTIONS(3685),
    [anon_sym_operator] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_delete] = ACTIONS(3685),
    [anon_sym_throw] = ACTIONS(3685),
    [anon_sym_namespace] = ACTIONS(3685),
    [anon_sym_using] = ACTIONS(3685),
    [anon_sym_static_assert] = ACTIONS(3685),
    [anon_sym_concept] = ACTIONS(3685),
    [anon_sym_co_return] = ACTIONS(3685),
    [anon_sym_co_yield] = ACTIONS(3685),
    [anon_sym_R_DQUOTE] = ACTIONS(3687),
    [anon_sym_LR_DQUOTE] = ACTIONS(3687),
    [anon_sym_uR_DQUOTE] = ACTIONS(3687),
    [anon_sym_UR_DQUOTE] = ACTIONS(3687),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3687),
    [anon_sym_co_await] = ACTIONS(3685),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_requires] = ACTIONS(3685),
    [sym_this] = ACTIONS(3685),
    [anon_sym_discard] = ACTIONS(3685),
    [anon_sym_precise] = ACTIONS(3685),
    [anon_sym_shared] = ACTIONS(3685),
    [anon_sym_groupshared] = ACTIONS(3685),
    [anon_sym_uniform] = ACTIONS(3685),
    [anon_sym_row_major] = ACTIONS(3685),
    [anon_sym_column_major] = ACTIONS(3685),
    [anon_sym_globallycoherent] = ACTIONS(3685),
    [anon_sym_centroid] = ACTIONS(3685),
    [anon_sym_noperspective] = ACTIONS(3685),
    [anon_sym_nointerpolation] = ACTIONS(3685),
    [anon_sym_sample] = ACTIONS(3685),
    [anon_sym_linear] = ACTIONS(3685),
    [anon_sym_snorm] = ACTIONS(3685),
    [anon_sym_unorm] = ACTIONS(3685),
    [anon_sym_point] = ACTIONS(3685),
    [anon_sym_line] = ACTIONS(3685),
    [anon_sym_triangleadj] = ACTIONS(3685),
    [anon_sym_lineadj] = ACTIONS(3685),
    [anon_sym_triangle] = ACTIONS(3685),
    [anon_sym_cbuffer] = ACTIONS(3685),
    [anon_sym_interface] = ACTIONS(3685),
    [anon_sym_extension] = ACTIONS(3685),
  },
  [545] = {
    [sym_else_clause] = STATE(557),
    [ts_builtin_sym_end] = ACTIONS(2838),
    [sym_identifier] = ACTIONS(2836),
    [aux_sym_preproc_include_token1] = ACTIONS(2836),
    [aux_sym_preproc_def_token1] = ACTIONS(2836),
    [aux_sym_preproc_if_token1] = ACTIONS(2836),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2836),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2836),
    [sym_preproc_directive] = ACTIONS(2836),
    [anon_sym_LPAREN2] = ACTIONS(2838),
    [anon_sym_BANG] = ACTIONS(2838),
    [anon_sym_TILDE] = ACTIONS(2838),
    [anon_sym_DASH] = ACTIONS(2836),
    [anon_sym_PLUS] = ACTIONS(2836),
    [anon_sym_STAR] = ACTIONS(2838),
    [anon_sym_AMP_AMP] = ACTIONS(2838),
    [anon_sym_AMP] = ACTIONS(2836),
    [anon_sym_SEMI] = ACTIONS(2838),
    [anon_sym___extension__] = ACTIONS(2836),
    [anon_sym_typedef] = ACTIONS(2836),
    [anon_sym_in] = ACTIONS(2836),
    [anon_sym_out] = ACTIONS(2836),
    [anon_sym_inout] = ACTIONS(2836),
    [anon_sym_extern] = ACTIONS(2836),
    [anon_sym___attribute__] = ACTIONS(2836),
    [anon_sym_COLON_COLON] = ACTIONS(2838),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2838),
    [anon_sym___declspec] = ACTIONS(2836),
    [anon_sym___based] = ACTIONS(2836),
    [anon_sym___cdecl] = ACTIONS(2836),
    [anon_sym___clrcall] = ACTIONS(2836),
    [anon_sym___stdcall] = ACTIONS(2836),
    [anon_sym___fastcall] = ACTIONS(2836),
    [anon_sym___thiscall] = ACTIONS(2836),
    [anon_sym___vectorcall] = ACTIONS(2836),
    [anon_sym_LBRACE] = ACTIONS(2838),
    [anon_sym_signed] = ACTIONS(2836),
    [anon_sym_unsigned] = ACTIONS(2836),
    [anon_sym_long] = ACTIONS(2836),
    [anon_sym_short] = ACTIONS(2836),
    [anon_sym_LBRACK] = ACTIONS(2836),
    [anon_sym_static] = ACTIONS(2836),
    [anon_sym_register] = ACTIONS(2836),
    [anon_sym_inline] = ACTIONS(2836),
    [anon_sym___inline] = ACTIONS(2836),
    [anon_sym___inline__] = ACTIONS(2836),
    [anon_sym___forceinline] = ACTIONS(2836),
    [anon_sym_thread_local] = ACTIONS(2836),
    [anon_sym___thread] = ACTIONS(2836),
    [anon_sym_const] = ACTIONS(2836),
    [anon_sym_constexpr] = ACTIONS(2836),
    [anon_sym_volatile] = ACTIONS(2836),
    [anon_sym_restrict] = ACTIONS(2836),
    [anon_sym___restrict__] = ACTIONS(2836),
    [anon_sym__Atomic] = ACTIONS(2836),
    [anon_sym__Noreturn] = ACTIONS(2836),
    [anon_sym_noreturn] = ACTIONS(2836),
    [anon_sym_mutable] = ACTIONS(2836),
    [anon_sym_constinit] = ACTIONS(2836),
    [anon_sym_consteval] = ACTIONS(2836),
    [anon_sym_alignas] = ACTIONS(2836),
    [anon_sym__Alignas] = ACTIONS(2836),
    [sym_primitive_type] = ACTIONS(2836),
    [anon_sym_enum] = ACTIONS(2836),
    [anon_sym_class] = ACTIONS(2836),
    [anon_sym_struct] = ACTIONS(2836),
    [anon_sym_union] = ACTIONS(2836),
    [anon_sym_if] = ACTIONS(2836),
    [anon_sym_else] = ACTIONS(3453),
    [anon_sym_switch] = ACTIONS(2836),
    [anon_sym_case] = ACTIONS(2836),
    [anon_sym_default] = ACTIONS(2836),
    [anon_sym_while] = ACTIONS(2836),
    [anon_sym_do] = ACTIONS(2836),
    [anon_sym_for] = ACTIONS(2836),
    [anon_sym_return] = ACTIONS(2836),
    [anon_sym_break] = ACTIONS(2836),
    [anon_sym_continue] = ACTIONS(2836),
    [anon_sym_goto] = ACTIONS(2836),
    [anon_sym___try] = ACTIONS(2836),
    [anon_sym___leave] = ACTIONS(2836),
    [anon_sym_not] = ACTIONS(2836),
    [anon_sym_compl] = ACTIONS(2836),
    [anon_sym_DASH_DASH] = ACTIONS(2838),
    [anon_sym_PLUS_PLUS] = ACTIONS(2838),
    [anon_sym_sizeof] = ACTIONS(2836),
    [anon_sym___alignof__] = ACTIONS(2836),
    [anon_sym___alignof] = ACTIONS(2836),
    [anon_sym__alignof] = ACTIONS(2836),
    [anon_sym_alignof] = ACTIONS(2836),
    [anon_sym__Alignof] = ACTIONS(2836),
    [anon_sym_offsetof] = ACTIONS(2836),
    [anon_sym__Generic] = ACTIONS(2836),
    [anon_sym_asm] = ACTIONS(2836),
    [anon_sym___asm__] = ACTIONS(2836),
    [sym_number_literal] = ACTIONS(2838),
    [anon_sym_L_SQUOTE] = ACTIONS(2838),
    [anon_sym_u_SQUOTE] = ACTIONS(2838),
    [anon_sym_U_SQUOTE] = ACTIONS(2838),
    [anon_sym_u8_SQUOTE] = ACTIONS(2838),
    [anon_sym_SQUOTE] = ACTIONS(2838),
    [anon_sym_L_DQUOTE] = ACTIONS(2838),
    [anon_sym_u_DQUOTE] = ACTIONS(2838),
    [anon_sym_U_DQUOTE] = ACTIONS(2838),
    [anon_sym_u8_DQUOTE] = ACTIONS(2838),
    [anon_sym_DQUOTE] = ACTIONS(2838),
    [sym_true] = ACTIONS(2836),
    [sym_false] = ACTIONS(2836),
    [anon_sym_NULL] = ACTIONS(2836),
    [anon_sym_nullptr] = ACTIONS(2836),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2836),
    [anon_sym_let] = ACTIONS(2836),
    [anon_sym_This] = ACTIONS(2836),
    [anon_sym_decltype] = ACTIONS(2836),
    [sym_virtual] = ACTIONS(2836),
    [anon_sym_explicit] = ACTIONS(2836),
    [anon_sym_typename] = ACTIONS(2836),
    [anon_sym_template] = ACTIONS(2836),
    [anon_sym_operator] = ACTIONS(2836),
    [anon_sym_try] = ACTIONS(2836),
    [anon_sym_delete] = ACTIONS(2836),
    [anon_sym_throw] = ACTIONS(2836),
    [anon_sym_namespace] = ACTIONS(2836),
    [anon_sym_using] = ACTIONS(2836),
    [anon_sym_static_assert] = ACTIONS(2836),
    [anon_sym_concept] = ACTIONS(2836),
    [anon_sym_co_return] = ACTIONS(2836),
    [anon_sym_co_yield] = ACTIONS(2836),
    [anon_sym_R_DQUOTE] = ACTIONS(2838),
    [anon_sym_LR_DQUOTE] = ACTIONS(2838),
    [anon_sym_uR_DQUOTE] = ACTIONS(2838),
    [anon_sym_UR_DQUOTE] = ACTIONS(2838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2838),
    [anon_sym_co_await] = ACTIONS(2836),
    [anon_sym_new] = ACTIONS(2836),
    [anon_sym_requires] = ACTIONS(2836),
    [sym_this] = ACTIONS(2836),
    [anon_sym_discard] = ACTIONS(2836),
    [anon_sym_precise] = ACTIONS(2836),
    [anon_sym_shared] = ACTIONS(2836),
    [anon_sym_groupshared] = ACTIONS(2836),
    [anon_sym_uniform] = ACTIONS(2836),
    [anon_sym_row_major] = ACTIONS(2836),
    [anon_sym_column_major] = ACTIONS(2836),
    [anon_sym_globallycoherent] = ACTIONS(2836),
    [anon_sym_centroid] = ACTIONS(2836),
    [anon_sym_noperspective] = ACTIONS(2836),
    [anon_sym_nointerpolation] = ACTIONS(2836),
    [anon_sym_sample] = ACTIONS(2836),
    [anon_sym_linear] = ACTIONS(2836),
    [anon_sym_snorm] = ACTIONS(2836),
    [anon_sym_unorm] = ACTIONS(2836),
    [anon_sym_point] = ACTIONS(2836),
    [anon_sym_line] = ACTIONS(2836),
    [anon_sym_triangleadj] = ACTIONS(2836),
    [anon_sym_lineadj] = ACTIONS(2836),
    [anon_sym_triangle] = ACTIONS(2836),
    [anon_sym_cbuffer] = ACTIONS(2836),
    [anon_sym_interface] = ACTIONS(2836),
    [anon_sym_extension] = ACTIONS(2836),
    [anon_sym___exported] = ACTIONS(2836),
    [anon_sym_import] = ACTIONS(2836),
  },
  [546] = {
    [sym_catch_clause] = STATE(531),
    [aux_sym_constructor_try_statement_repeat1] = STATE(531),
    [sym_identifier] = ACTIONS(2677),
    [aux_sym_preproc_include_token1] = ACTIONS(2677),
    [aux_sym_preproc_def_token1] = ACTIONS(2677),
    [aux_sym_preproc_if_token1] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2677),
    [sym_preproc_directive] = ACTIONS(2677),
    [anon_sym_LPAREN2] = ACTIONS(2679),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_DASH] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_STAR] = ACTIONS(2679),
    [anon_sym_AMP_AMP] = ACTIONS(2679),
    [anon_sym_AMP] = ACTIONS(2677),
    [anon_sym_SEMI] = ACTIONS(2679),
    [anon_sym___extension__] = ACTIONS(2677),
    [anon_sym_typedef] = ACTIONS(2677),
    [anon_sym_in] = ACTIONS(2677),
    [anon_sym_out] = ACTIONS(2677),
    [anon_sym_inout] = ACTIONS(2677),
    [anon_sym_extern] = ACTIONS(2677),
    [anon_sym___attribute__] = ACTIONS(2677),
    [anon_sym_COLON_COLON] = ACTIONS(2679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2679),
    [anon_sym___declspec] = ACTIONS(2677),
    [anon_sym___based] = ACTIONS(2677),
    [anon_sym___cdecl] = ACTIONS(2677),
    [anon_sym___clrcall] = ACTIONS(2677),
    [anon_sym___stdcall] = ACTIONS(2677),
    [anon_sym___fastcall] = ACTIONS(2677),
    [anon_sym___thiscall] = ACTIONS(2677),
    [anon_sym___vectorcall] = ACTIONS(2677),
    [anon_sym_LBRACE] = ACTIONS(2679),
    [anon_sym_RBRACE] = ACTIONS(2679),
    [anon_sym_signed] = ACTIONS(2677),
    [anon_sym_unsigned] = ACTIONS(2677),
    [anon_sym_long] = ACTIONS(2677),
    [anon_sym_short] = ACTIONS(2677),
    [anon_sym_LBRACK] = ACTIONS(2677),
    [anon_sym_static] = ACTIONS(2677),
    [anon_sym_register] = ACTIONS(2677),
    [anon_sym_inline] = ACTIONS(2677),
    [anon_sym___inline] = ACTIONS(2677),
    [anon_sym___inline__] = ACTIONS(2677),
    [anon_sym___forceinline] = ACTIONS(2677),
    [anon_sym_thread_local] = ACTIONS(2677),
    [anon_sym___thread] = ACTIONS(2677),
    [anon_sym_const] = ACTIONS(2677),
    [anon_sym_constexpr] = ACTIONS(2677),
    [anon_sym_volatile] = ACTIONS(2677),
    [anon_sym_restrict] = ACTIONS(2677),
    [anon_sym___restrict__] = ACTIONS(2677),
    [anon_sym__Atomic] = ACTIONS(2677),
    [anon_sym__Noreturn] = ACTIONS(2677),
    [anon_sym_noreturn] = ACTIONS(2677),
    [anon_sym_mutable] = ACTIONS(2677),
    [anon_sym_constinit] = ACTIONS(2677),
    [anon_sym_consteval] = ACTIONS(2677),
    [anon_sym_alignas] = ACTIONS(2677),
    [anon_sym__Alignas] = ACTIONS(2677),
    [sym_primitive_type] = ACTIONS(2677),
    [anon_sym_enum] = ACTIONS(2677),
    [anon_sym_class] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(2677),
    [anon_sym_union] = ACTIONS(2677),
    [anon_sym_if] = ACTIONS(2677),
    [anon_sym_else] = ACTIONS(2677),
    [anon_sym_switch] = ACTIONS(2677),
    [anon_sym_case] = ACTIONS(2677),
    [anon_sym_default] = ACTIONS(2677),
    [anon_sym_while] = ACTIONS(2677),
    [anon_sym_do] = ACTIONS(2677),
    [anon_sym_for] = ACTIONS(2677),
    [anon_sym_return] = ACTIONS(2677),
    [anon_sym_break] = ACTIONS(2677),
    [anon_sym_continue] = ACTIONS(2677),
    [anon_sym_goto] = ACTIONS(2677),
    [anon_sym___try] = ACTIONS(2677),
    [anon_sym___leave] = ACTIONS(2677),
    [anon_sym_not] = ACTIONS(2677),
    [anon_sym_compl] = ACTIONS(2677),
    [anon_sym_DASH_DASH] = ACTIONS(2679),
    [anon_sym_PLUS_PLUS] = ACTIONS(2679),
    [anon_sym_sizeof] = ACTIONS(2677),
    [anon_sym___alignof__] = ACTIONS(2677),
    [anon_sym___alignof] = ACTIONS(2677),
    [anon_sym__alignof] = ACTIONS(2677),
    [anon_sym_alignof] = ACTIONS(2677),
    [anon_sym__Alignof] = ACTIONS(2677),
    [anon_sym_offsetof] = ACTIONS(2677),
    [anon_sym__Generic] = ACTIONS(2677),
    [anon_sym_asm] = ACTIONS(2677),
    [anon_sym___asm__] = ACTIONS(2677),
    [sym_number_literal] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2679),
    [anon_sym_u_SQUOTE] = ACTIONS(2679),
    [anon_sym_U_SQUOTE] = ACTIONS(2679),
    [anon_sym_u8_SQUOTE] = ACTIONS(2679),
    [anon_sym_SQUOTE] = ACTIONS(2679),
    [anon_sym_L_DQUOTE] = ACTIONS(2679),
    [anon_sym_u_DQUOTE] = ACTIONS(2679),
    [anon_sym_U_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8_DQUOTE] = ACTIONS(2679),
    [anon_sym_DQUOTE] = ACTIONS(2679),
    [sym_true] = ACTIONS(2677),
    [sym_false] = ACTIONS(2677),
    [anon_sym_NULL] = ACTIONS(2677),
    [anon_sym_nullptr] = ACTIONS(2677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2677),
    [anon_sym_let] = ACTIONS(2677),
    [anon_sym_This] = ACTIONS(2677),
    [anon_sym_decltype] = ACTIONS(2677),
    [sym_virtual] = ACTIONS(2677),
    [anon_sym_explicit] = ACTIONS(2677),
    [anon_sym_typename] = ACTIONS(2677),
    [anon_sym_template] = ACTIONS(2677),
    [anon_sym_operator] = ACTIONS(2677),
    [anon_sym_try] = ACTIONS(2677),
    [anon_sym_delete] = ACTIONS(2677),
    [anon_sym_throw] = ACTIONS(2677),
    [anon_sym_namespace] = ACTIONS(2677),
    [anon_sym_using] = ACTIONS(2677),
    [anon_sym_static_assert] = ACTIONS(2677),
    [anon_sym_concept] = ACTIONS(2677),
    [anon_sym_co_return] = ACTIONS(2677),
    [anon_sym_co_yield] = ACTIONS(2677),
    [anon_sym_catch] = ACTIONS(3689),
    [anon_sym_R_DQUOTE] = ACTIONS(2679),
    [anon_sym_LR_DQUOTE] = ACTIONS(2679),
    [anon_sym_uR_DQUOTE] = ACTIONS(2679),
    [anon_sym_UR_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2679),
    [anon_sym_co_await] = ACTIONS(2677),
    [anon_sym_new] = ACTIONS(2677),
    [anon_sym_requires] = ACTIONS(2677),
    [sym_this] = ACTIONS(2677),
    [anon_sym_discard] = ACTIONS(2677),
    [anon_sym_precise] = ACTIONS(2677),
    [anon_sym_shared] = ACTIONS(2677),
    [anon_sym_groupshared] = ACTIONS(2677),
    [anon_sym_uniform] = ACTIONS(2677),
    [anon_sym_row_major] = ACTIONS(2677),
    [anon_sym_column_major] = ACTIONS(2677),
    [anon_sym_globallycoherent] = ACTIONS(2677),
    [anon_sym_centroid] = ACTIONS(2677),
    [anon_sym_noperspective] = ACTIONS(2677),
    [anon_sym_nointerpolation] = ACTIONS(2677),
    [anon_sym_sample] = ACTIONS(2677),
    [anon_sym_linear] = ACTIONS(2677),
    [anon_sym_snorm] = ACTIONS(2677),
    [anon_sym_unorm] = ACTIONS(2677),
    [anon_sym_point] = ACTIONS(2677),
    [anon_sym_line] = ACTIONS(2677),
    [anon_sym_triangleadj] = ACTIONS(2677),
    [anon_sym_lineadj] = ACTIONS(2677),
    [anon_sym_triangle] = ACTIONS(2677),
    [anon_sym_cbuffer] = ACTIONS(2677),
    [anon_sym_interface] = ACTIONS(2677),
    [anon_sym_extension] = ACTIONS(2677),
  },
  [547] = {
    [sym_identifier] = ACTIONS(3691),
    [aux_sym_preproc_include_token1] = ACTIONS(3691),
    [aux_sym_preproc_def_token1] = ACTIONS(3691),
    [aux_sym_preproc_if_token1] = ACTIONS(3691),
    [aux_sym_preproc_if_token2] = ACTIONS(3691),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3691),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3691),
    [aux_sym_preproc_else_token1] = ACTIONS(3691),
    [aux_sym_preproc_elif_token1] = ACTIONS(3691),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3691),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3691),
    [sym_preproc_directive] = ACTIONS(3691),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_BANG] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_PLUS] = ACTIONS(3691),
    [anon_sym_STAR] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_AMP] = ACTIONS(3691),
    [anon_sym_SEMI] = ACTIONS(3693),
    [anon_sym___extension__] = ACTIONS(3691),
    [anon_sym_typedef] = ACTIONS(3691),
    [anon_sym_in] = ACTIONS(3691),
    [anon_sym_out] = ACTIONS(3691),
    [anon_sym_inout] = ACTIONS(3691),
    [anon_sym_extern] = ACTIONS(3691),
    [anon_sym___attribute__] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3693),
    [anon_sym___declspec] = ACTIONS(3691),
    [anon_sym___based] = ACTIONS(3691),
    [anon_sym___cdecl] = ACTIONS(3691),
    [anon_sym___clrcall] = ACTIONS(3691),
    [anon_sym___stdcall] = ACTIONS(3691),
    [anon_sym___fastcall] = ACTIONS(3691),
    [anon_sym___thiscall] = ACTIONS(3691),
    [anon_sym___vectorcall] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_signed] = ACTIONS(3691),
    [anon_sym_unsigned] = ACTIONS(3691),
    [anon_sym_long] = ACTIONS(3691),
    [anon_sym_short] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(3691),
    [anon_sym_static] = ACTIONS(3691),
    [anon_sym_register] = ACTIONS(3691),
    [anon_sym_inline] = ACTIONS(3691),
    [anon_sym___inline] = ACTIONS(3691),
    [anon_sym___inline__] = ACTIONS(3691),
    [anon_sym___forceinline] = ACTIONS(3691),
    [anon_sym_thread_local] = ACTIONS(3691),
    [anon_sym___thread] = ACTIONS(3691),
    [anon_sym_const] = ACTIONS(3691),
    [anon_sym_constexpr] = ACTIONS(3691),
    [anon_sym_volatile] = ACTIONS(3691),
    [anon_sym_restrict] = ACTIONS(3691),
    [anon_sym___restrict__] = ACTIONS(3691),
    [anon_sym__Atomic] = ACTIONS(3691),
    [anon_sym__Noreturn] = ACTIONS(3691),
    [anon_sym_noreturn] = ACTIONS(3691),
    [anon_sym_mutable] = ACTIONS(3691),
    [anon_sym_constinit] = ACTIONS(3691),
    [anon_sym_consteval] = ACTIONS(3691),
    [anon_sym_alignas] = ACTIONS(3691),
    [anon_sym__Alignas] = ACTIONS(3691),
    [sym_primitive_type] = ACTIONS(3691),
    [anon_sym_enum] = ACTIONS(3691),
    [anon_sym_class] = ACTIONS(3691),
    [anon_sym_struct] = ACTIONS(3691),
    [anon_sym_union] = ACTIONS(3691),
    [anon_sym_if] = ACTIONS(3691),
    [anon_sym_switch] = ACTIONS(3691),
    [anon_sym_case] = ACTIONS(3691),
    [anon_sym_default] = ACTIONS(3691),
    [anon_sym_while] = ACTIONS(3691),
    [anon_sym_do] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3691),
    [anon_sym_return] = ACTIONS(3691),
    [anon_sym_break] = ACTIONS(3691),
    [anon_sym_continue] = ACTIONS(3691),
    [anon_sym_goto] = ACTIONS(3691),
    [anon_sym___try] = ACTIONS(3691),
    [anon_sym___leave] = ACTIONS(3691),
    [anon_sym_not] = ACTIONS(3691),
    [anon_sym_compl] = ACTIONS(3691),
    [anon_sym_DASH_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_PLUS] = ACTIONS(3693),
    [anon_sym_sizeof] = ACTIONS(3691),
    [anon_sym___alignof__] = ACTIONS(3691),
    [anon_sym___alignof] = ACTIONS(3691),
    [anon_sym__alignof] = ACTIONS(3691),
    [anon_sym_alignof] = ACTIONS(3691),
    [anon_sym__Alignof] = ACTIONS(3691),
    [anon_sym_offsetof] = ACTIONS(3691),
    [anon_sym__Generic] = ACTIONS(3691),
    [anon_sym_asm] = ACTIONS(3691),
    [anon_sym___asm__] = ACTIONS(3691),
    [sym_number_literal] = ACTIONS(3693),
    [anon_sym_L_SQUOTE] = ACTIONS(3693),
    [anon_sym_u_SQUOTE] = ACTIONS(3693),
    [anon_sym_U_SQUOTE] = ACTIONS(3693),
    [anon_sym_u8_SQUOTE] = ACTIONS(3693),
    [anon_sym_SQUOTE] = ACTIONS(3693),
    [anon_sym_L_DQUOTE] = ACTIONS(3693),
    [anon_sym_u_DQUOTE] = ACTIONS(3693),
    [anon_sym_U_DQUOTE] = ACTIONS(3693),
    [anon_sym_u8_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [sym_true] = ACTIONS(3691),
    [sym_false] = ACTIONS(3691),
    [anon_sym_NULL] = ACTIONS(3691),
    [anon_sym_nullptr] = ACTIONS(3691),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3691),
    [anon_sym_let] = ACTIONS(3691),
    [anon_sym_This] = ACTIONS(3691),
    [anon_sym_decltype] = ACTIONS(3691),
    [sym_virtual] = ACTIONS(3691),
    [anon_sym_explicit] = ACTIONS(3691),
    [anon_sym_typename] = ACTIONS(3691),
    [anon_sym_template] = ACTIONS(3691),
    [anon_sym_operator] = ACTIONS(3691),
    [anon_sym_try] = ACTIONS(3691),
    [anon_sym_delete] = ACTIONS(3691),
    [anon_sym_throw] = ACTIONS(3691),
    [anon_sym_namespace] = ACTIONS(3691),
    [anon_sym_using] = ACTIONS(3691),
    [anon_sym_static_assert] = ACTIONS(3691),
    [anon_sym_concept] = ACTIONS(3691),
    [anon_sym_co_return] = ACTIONS(3691),
    [anon_sym_co_yield] = ACTIONS(3691),
    [anon_sym_R_DQUOTE] = ACTIONS(3693),
    [anon_sym_LR_DQUOTE] = ACTIONS(3693),
    [anon_sym_uR_DQUOTE] = ACTIONS(3693),
    [anon_sym_UR_DQUOTE] = ACTIONS(3693),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3693),
    [anon_sym_co_await] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3691),
    [anon_sym_requires] = ACTIONS(3691),
    [sym_this] = ACTIONS(3691),
    [anon_sym_discard] = ACTIONS(3691),
    [anon_sym_precise] = ACTIONS(3691),
    [anon_sym_shared] = ACTIONS(3691),
    [anon_sym_groupshared] = ACTIONS(3691),
    [anon_sym_uniform] = ACTIONS(3691),
    [anon_sym_row_major] = ACTIONS(3691),
    [anon_sym_column_major] = ACTIONS(3691),
    [anon_sym_globallycoherent] = ACTIONS(3691),
    [anon_sym_centroid] = ACTIONS(3691),
    [anon_sym_noperspective] = ACTIONS(3691),
    [anon_sym_nointerpolation] = ACTIONS(3691),
    [anon_sym_sample] = ACTIONS(3691),
    [anon_sym_linear] = ACTIONS(3691),
    [anon_sym_snorm] = ACTIONS(3691),
    [anon_sym_unorm] = ACTIONS(3691),
    [anon_sym_point] = ACTIONS(3691),
    [anon_sym_line] = ACTIONS(3691),
    [anon_sym_triangleadj] = ACTIONS(3691),
    [anon_sym_lineadj] = ACTIONS(3691),
    [anon_sym_triangle] = ACTIONS(3691),
    [anon_sym_cbuffer] = ACTIONS(3691),
    [anon_sym_interface] = ACTIONS(3691),
    [anon_sym_extension] = ACTIONS(3691),
  },
  [548] = {
    [sym_identifier] = ACTIONS(3695),
    [aux_sym_preproc_include_token1] = ACTIONS(3695),
    [aux_sym_preproc_def_token1] = ACTIONS(3695),
    [aux_sym_preproc_if_token1] = ACTIONS(3695),
    [aux_sym_preproc_if_token2] = ACTIONS(3695),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3695),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3695),
    [aux_sym_preproc_else_token1] = ACTIONS(3695),
    [aux_sym_preproc_elif_token1] = ACTIONS(3695),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3695),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3695),
    [sym_preproc_directive] = ACTIONS(3695),
    [anon_sym_LPAREN2] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3697),
    [anon_sym_TILDE] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3695),
    [anon_sym_PLUS] = ACTIONS(3695),
    [anon_sym_STAR] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3697),
    [anon_sym_AMP] = ACTIONS(3695),
    [anon_sym_SEMI] = ACTIONS(3697),
    [anon_sym___extension__] = ACTIONS(3695),
    [anon_sym_typedef] = ACTIONS(3695),
    [anon_sym_in] = ACTIONS(3695),
    [anon_sym_out] = ACTIONS(3695),
    [anon_sym_inout] = ACTIONS(3695),
    [anon_sym_extern] = ACTIONS(3695),
    [anon_sym___attribute__] = ACTIONS(3695),
    [anon_sym_COLON_COLON] = ACTIONS(3697),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3697),
    [anon_sym___declspec] = ACTIONS(3695),
    [anon_sym___based] = ACTIONS(3695),
    [anon_sym___cdecl] = ACTIONS(3695),
    [anon_sym___clrcall] = ACTIONS(3695),
    [anon_sym___stdcall] = ACTIONS(3695),
    [anon_sym___fastcall] = ACTIONS(3695),
    [anon_sym___thiscall] = ACTIONS(3695),
    [anon_sym___vectorcall] = ACTIONS(3695),
    [anon_sym_LBRACE] = ACTIONS(3697),
    [anon_sym_signed] = ACTIONS(3695),
    [anon_sym_unsigned] = ACTIONS(3695),
    [anon_sym_long] = ACTIONS(3695),
    [anon_sym_short] = ACTIONS(3695),
    [anon_sym_LBRACK] = ACTIONS(3695),
    [anon_sym_static] = ACTIONS(3695),
    [anon_sym_register] = ACTIONS(3695),
    [anon_sym_inline] = ACTIONS(3695),
    [anon_sym___inline] = ACTIONS(3695),
    [anon_sym___inline__] = ACTIONS(3695),
    [anon_sym___forceinline] = ACTIONS(3695),
    [anon_sym_thread_local] = ACTIONS(3695),
    [anon_sym___thread] = ACTIONS(3695),
    [anon_sym_const] = ACTIONS(3695),
    [anon_sym_constexpr] = ACTIONS(3695),
    [anon_sym_volatile] = ACTIONS(3695),
    [anon_sym_restrict] = ACTIONS(3695),
    [anon_sym___restrict__] = ACTIONS(3695),
    [anon_sym__Atomic] = ACTIONS(3695),
    [anon_sym__Noreturn] = ACTIONS(3695),
    [anon_sym_noreturn] = ACTIONS(3695),
    [anon_sym_mutable] = ACTIONS(3695),
    [anon_sym_constinit] = ACTIONS(3695),
    [anon_sym_consteval] = ACTIONS(3695),
    [anon_sym_alignas] = ACTIONS(3695),
    [anon_sym__Alignas] = ACTIONS(3695),
    [sym_primitive_type] = ACTIONS(3695),
    [anon_sym_enum] = ACTIONS(3695),
    [anon_sym_class] = ACTIONS(3695),
    [anon_sym_struct] = ACTIONS(3695),
    [anon_sym_union] = ACTIONS(3695),
    [anon_sym_if] = ACTIONS(3695),
    [anon_sym_switch] = ACTIONS(3695),
    [anon_sym_case] = ACTIONS(3695),
    [anon_sym_default] = ACTIONS(3695),
    [anon_sym_while] = ACTIONS(3695),
    [anon_sym_do] = ACTIONS(3695),
    [anon_sym_for] = ACTIONS(3695),
    [anon_sym_return] = ACTIONS(3695),
    [anon_sym_break] = ACTIONS(3695),
    [anon_sym_continue] = ACTIONS(3695),
    [anon_sym_goto] = ACTIONS(3695),
    [anon_sym___try] = ACTIONS(3695),
    [anon_sym___leave] = ACTIONS(3695),
    [anon_sym_not] = ACTIONS(3695),
    [anon_sym_compl] = ACTIONS(3695),
    [anon_sym_DASH_DASH] = ACTIONS(3697),
    [anon_sym_PLUS_PLUS] = ACTIONS(3697),
    [anon_sym_sizeof] = ACTIONS(3695),
    [anon_sym___alignof__] = ACTIONS(3695),
    [anon_sym___alignof] = ACTIONS(3695),
    [anon_sym__alignof] = ACTIONS(3695),
    [anon_sym_alignof] = ACTIONS(3695),
    [anon_sym__Alignof] = ACTIONS(3695),
    [anon_sym_offsetof] = ACTIONS(3695),
    [anon_sym__Generic] = ACTIONS(3695),
    [anon_sym_asm] = ACTIONS(3695),
    [anon_sym___asm__] = ACTIONS(3695),
    [sym_number_literal] = ACTIONS(3697),
    [anon_sym_L_SQUOTE] = ACTIONS(3697),
    [anon_sym_u_SQUOTE] = ACTIONS(3697),
    [anon_sym_U_SQUOTE] = ACTIONS(3697),
    [anon_sym_u8_SQUOTE] = ACTIONS(3697),
    [anon_sym_SQUOTE] = ACTIONS(3697),
    [anon_sym_L_DQUOTE] = ACTIONS(3697),
    [anon_sym_u_DQUOTE] = ACTIONS(3697),
    [anon_sym_U_DQUOTE] = ACTIONS(3697),
    [anon_sym_u8_DQUOTE] = ACTIONS(3697),
    [anon_sym_DQUOTE] = ACTIONS(3697),
    [sym_true] = ACTIONS(3695),
    [sym_false] = ACTIONS(3695),
    [anon_sym_NULL] = ACTIONS(3695),
    [anon_sym_nullptr] = ACTIONS(3695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3695),
    [anon_sym_let] = ACTIONS(3695),
    [anon_sym_This] = ACTIONS(3695),
    [anon_sym_decltype] = ACTIONS(3695),
    [sym_virtual] = ACTIONS(3695),
    [anon_sym_explicit] = ACTIONS(3695),
    [anon_sym_typename] = ACTIONS(3695),
    [anon_sym_template] = ACTIONS(3695),
    [anon_sym_operator] = ACTIONS(3695),
    [anon_sym_try] = ACTIONS(3695),
    [anon_sym_delete] = ACTIONS(3695),
    [anon_sym_throw] = ACTIONS(3695),
    [anon_sym_namespace] = ACTIONS(3695),
    [anon_sym_using] = ACTIONS(3695),
    [anon_sym_static_assert] = ACTIONS(3695),
    [anon_sym_concept] = ACTIONS(3695),
    [anon_sym_co_return] = ACTIONS(3695),
    [anon_sym_co_yield] = ACTIONS(3695),
    [anon_sym_R_DQUOTE] = ACTIONS(3697),
    [anon_sym_LR_DQUOTE] = ACTIONS(3697),
    [anon_sym_uR_DQUOTE] = ACTIONS(3697),
    [anon_sym_UR_DQUOTE] = ACTIONS(3697),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3697),
    [anon_sym_co_await] = ACTIONS(3695),
    [anon_sym_new] = ACTIONS(3695),
    [anon_sym_requires] = ACTIONS(3695),
    [sym_this] = ACTIONS(3695),
    [anon_sym_discard] = ACTIONS(3695),
    [anon_sym_precise] = ACTIONS(3695),
    [anon_sym_shared] = ACTIONS(3695),
    [anon_sym_groupshared] = ACTIONS(3695),
    [anon_sym_uniform] = ACTIONS(3695),
    [anon_sym_row_major] = ACTIONS(3695),
    [anon_sym_column_major] = ACTIONS(3695),
    [anon_sym_globallycoherent] = ACTIONS(3695),
    [anon_sym_centroid] = ACTIONS(3695),
    [anon_sym_noperspective] = ACTIONS(3695),
    [anon_sym_nointerpolation] = ACTIONS(3695),
    [anon_sym_sample] = ACTIONS(3695),
    [anon_sym_linear] = ACTIONS(3695),
    [anon_sym_snorm] = ACTIONS(3695),
    [anon_sym_unorm] = ACTIONS(3695),
    [anon_sym_point] = ACTIONS(3695),
    [anon_sym_line] = ACTIONS(3695),
    [anon_sym_triangleadj] = ACTIONS(3695),
    [anon_sym_lineadj] = ACTIONS(3695),
    [anon_sym_triangle] = ACTIONS(3695),
    [anon_sym_cbuffer] = ACTIONS(3695),
    [anon_sym_interface] = ACTIONS(3695),
    [anon_sym_extension] = ACTIONS(3695),
  },
  [549] = {
    [sym_identifier] = ACTIONS(3699),
    [aux_sym_preproc_include_token1] = ACTIONS(3699),
    [aux_sym_preproc_def_token1] = ACTIONS(3699),
    [aux_sym_preproc_if_token1] = ACTIONS(3699),
    [aux_sym_preproc_if_token2] = ACTIONS(3699),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3699),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3699),
    [aux_sym_preproc_else_token1] = ACTIONS(3699),
    [aux_sym_preproc_elif_token1] = ACTIONS(3699),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3699),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3699),
    [sym_preproc_directive] = ACTIONS(3699),
    [anon_sym_LPAREN2] = ACTIONS(3701),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_TILDE] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_STAR] = ACTIONS(3701),
    [anon_sym_AMP_AMP] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_SEMI] = ACTIONS(3701),
    [anon_sym___extension__] = ACTIONS(3699),
    [anon_sym_typedef] = ACTIONS(3699),
    [anon_sym_in] = ACTIONS(3699),
    [anon_sym_out] = ACTIONS(3699),
    [anon_sym_inout] = ACTIONS(3699),
    [anon_sym_extern] = ACTIONS(3699),
    [anon_sym___attribute__] = ACTIONS(3699),
    [anon_sym_COLON_COLON] = ACTIONS(3701),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3701),
    [anon_sym___declspec] = ACTIONS(3699),
    [anon_sym___based] = ACTIONS(3699),
    [anon_sym___cdecl] = ACTIONS(3699),
    [anon_sym___clrcall] = ACTIONS(3699),
    [anon_sym___stdcall] = ACTIONS(3699),
    [anon_sym___fastcall] = ACTIONS(3699),
    [anon_sym___thiscall] = ACTIONS(3699),
    [anon_sym___vectorcall] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3701),
    [anon_sym_signed] = ACTIONS(3699),
    [anon_sym_unsigned] = ACTIONS(3699),
    [anon_sym_long] = ACTIONS(3699),
    [anon_sym_short] = ACTIONS(3699),
    [anon_sym_LBRACK] = ACTIONS(3699),
    [anon_sym_static] = ACTIONS(3699),
    [anon_sym_register] = ACTIONS(3699),
    [anon_sym_inline] = ACTIONS(3699),
    [anon_sym___inline] = ACTIONS(3699),
    [anon_sym___inline__] = ACTIONS(3699),
    [anon_sym___forceinline] = ACTIONS(3699),
    [anon_sym_thread_local] = ACTIONS(3699),
    [anon_sym___thread] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3699),
    [anon_sym_constexpr] = ACTIONS(3699),
    [anon_sym_volatile] = ACTIONS(3699),
    [anon_sym_restrict] = ACTIONS(3699),
    [anon_sym___restrict__] = ACTIONS(3699),
    [anon_sym__Atomic] = ACTIONS(3699),
    [anon_sym__Noreturn] = ACTIONS(3699),
    [anon_sym_noreturn] = ACTIONS(3699),
    [anon_sym_mutable] = ACTIONS(3699),
    [anon_sym_constinit] = ACTIONS(3699),
    [anon_sym_consteval] = ACTIONS(3699),
    [anon_sym_alignas] = ACTIONS(3699),
    [anon_sym__Alignas] = ACTIONS(3699),
    [sym_primitive_type] = ACTIONS(3699),
    [anon_sym_enum] = ACTIONS(3699),
    [anon_sym_class] = ACTIONS(3699),
    [anon_sym_struct] = ACTIONS(3699),
    [anon_sym_union] = ACTIONS(3699),
    [anon_sym_if] = ACTIONS(3699),
    [anon_sym_switch] = ACTIONS(3699),
    [anon_sym_case] = ACTIONS(3699),
    [anon_sym_default] = ACTIONS(3699),
    [anon_sym_while] = ACTIONS(3699),
    [anon_sym_do] = ACTIONS(3699),
    [anon_sym_for] = ACTIONS(3699),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_break] = ACTIONS(3699),
    [anon_sym_continue] = ACTIONS(3699),
    [anon_sym_goto] = ACTIONS(3699),
    [anon_sym___try] = ACTIONS(3699),
    [anon_sym___leave] = ACTIONS(3699),
    [anon_sym_not] = ACTIONS(3699),
    [anon_sym_compl] = ACTIONS(3699),
    [anon_sym_DASH_DASH] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3701),
    [anon_sym_sizeof] = ACTIONS(3699),
    [anon_sym___alignof__] = ACTIONS(3699),
    [anon_sym___alignof] = ACTIONS(3699),
    [anon_sym__alignof] = ACTIONS(3699),
    [anon_sym_alignof] = ACTIONS(3699),
    [anon_sym__Alignof] = ACTIONS(3699),
    [anon_sym_offsetof] = ACTIONS(3699),
    [anon_sym__Generic] = ACTIONS(3699),
    [anon_sym_asm] = ACTIONS(3699),
    [anon_sym___asm__] = ACTIONS(3699),
    [sym_number_literal] = ACTIONS(3701),
    [anon_sym_L_SQUOTE] = ACTIONS(3701),
    [anon_sym_u_SQUOTE] = ACTIONS(3701),
    [anon_sym_U_SQUOTE] = ACTIONS(3701),
    [anon_sym_u8_SQUOTE] = ACTIONS(3701),
    [anon_sym_SQUOTE] = ACTIONS(3701),
    [anon_sym_L_DQUOTE] = ACTIONS(3701),
    [anon_sym_u_DQUOTE] = ACTIONS(3701),
    [anon_sym_U_DQUOTE] = ACTIONS(3701),
    [anon_sym_u8_DQUOTE] = ACTIONS(3701),
    [anon_sym_DQUOTE] = ACTIONS(3701),
    [sym_true] = ACTIONS(3699),
    [sym_false] = ACTIONS(3699),
    [anon_sym_NULL] = ACTIONS(3699),
    [anon_sym_nullptr] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3699),
    [anon_sym_let] = ACTIONS(3699),
    [anon_sym_This] = ACTIONS(3699),
    [anon_sym_decltype] = ACTIONS(3699),
    [sym_virtual] = ACTIONS(3699),
    [anon_sym_explicit] = ACTIONS(3699),
    [anon_sym_typename] = ACTIONS(3699),
    [anon_sym_template] = ACTIONS(3699),
    [anon_sym_operator] = ACTIONS(3699),
    [anon_sym_try] = ACTIONS(3699),
    [anon_sym_delete] = ACTIONS(3699),
    [anon_sym_throw] = ACTIONS(3699),
    [anon_sym_namespace] = ACTIONS(3699),
    [anon_sym_using] = ACTIONS(3699),
    [anon_sym_static_assert] = ACTIONS(3699),
    [anon_sym_concept] = ACTIONS(3699),
    [anon_sym_co_return] = ACTIONS(3699),
    [anon_sym_co_yield] = ACTIONS(3699),
    [anon_sym_R_DQUOTE] = ACTIONS(3701),
    [anon_sym_LR_DQUOTE] = ACTIONS(3701),
    [anon_sym_uR_DQUOTE] = ACTIONS(3701),
    [anon_sym_UR_DQUOTE] = ACTIONS(3701),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3701),
    [anon_sym_co_await] = ACTIONS(3699),
    [anon_sym_new] = ACTIONS(3699),
    [anon_sym_requires] = ACTIONS(3699),
    [sym_this] = ACTIONS(3699),
    [anon_sym_discard] = ACTIONS(3699),
    [anon_sym_precise] = ACTIONS(3699),
    [anon_sym_shared] = ACTIONS(3699),
    [anon_sym_groupshared] = ACTIONS(3699),
    [anon_sym_uniform] = ACTIONS(3699),
    [anon_sym_row_major] = ACTIONS(3699),
    [anon_sym_column_major] = ACTIONS(3699),
    [anon_sym_globallycoherent] = ACTIONS(3699),
    [anon_sym_centroid] = ACTIONS(3699),
    [anon_sym_noperspective] = ACTIONS(3699),
    [anon_sym_nointerpolation] = ACTIONS(3699),
    [anon_sym_sample] = ACTIONS(3699),
    [anon_sym_linear] = ACTIONS(3699),
    [anon_sym_snorm] = ACTIONS(3699),
    [anon_sym_unorm] = ACTIONS(3699),
    [anon_sym_point] = ACTIONS(3699),
    [anon_sym_line] = ACTIONS(3699),
    [anon_sym_triangleadj] = ACTIONS(3699),
    [anon_sym_lineadj] = ACTIONS(3699),
    [anon_sym_triangle] = ACTIONS(3699),
    [anon_sym_cbuffer] = ACTIONS(3699),
    [anon_sym_interface] = ACTIONS(3699),
    [anon_sym_extension] = ACTIONS(3699),
  },
  [550] = {
    [sym_identifier] = ACTIONS(3703),
    [aux_sym_preproc_include_token1] = ACTIONS(3703),
    [aux_sym_preproc_def_token1] = ACTIONS(3703),
    [aux_sym_preproc_if_token1] = ACTIONS(3703),
    [aux_sym_preproc_if_token2] = ACTIONS(3703),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3703),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3703),
    [aux_sym_preproc_else_token1] = ACTIONS(3703),
    [aux_sym_preproc_elif_token1] = ACTIONS(3703),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3703),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3703),
    [sym_preproc_directive] = ACTIONS(3703),
    [anon_sym_LPAREN2] = ACTIONS(3705),
    [anon_sym_BANG] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3705),
    [anon_sym_DASH] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3703),
    [anon_sym_STAR] = ACTIONS(3705),
    [anon_sym_AMP_AMP] = ACTIONS(3705),
    [anon_sym_AMP] = ACTIONS(3703),
    [anon_sym_SEMI] = ACTIONS(3705),
    [anon_sym___extension__] = ACTIONS(3703),
    [anon_sym_typedef] = ACTIONS(3703),
    [anon_sym_in] = ACTIONS(3703),
    [anon_sym_out] = ACTIONS(3703),
    [anon_sym_inout] = ACTIONS(3703),
    [anon_sym_extern] = ACTIONS(3703),
    [anon_sym___attribute__] = ACTIONS(3703),
    [anon_sym_COLON_COLON] = ACTIONS(3705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3705),
    [anon_sym___declspec] = ACTIONS(3703),
    [anon_sym___based] = ACTIONS(3703),
    [anon_sym___cdecl] = ACTIONS(3703),
    [anon_sym___clrcall] = ACTIONS(3703),
    [anon_sym___stdcall] = ACTIONS(3703),
    [anon_sym___fastcall] = ACTIONS(3703),
    [anon_sym___thiscall] = ACTIONS(3703),
    [anon_sym___vectorcall] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [anon_sym_signed] = ACTIONS(3703),
    [anon_sym_unsigned] = ACTIONS(3703),
    [anon_sym_long] = ACTIONS(3703),
    [anon_sym_short] = ACTIONS(3703),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_static] = ACTIONS(3703),
    [anon_sym_register] = ACTIONS(3703),
    [anon_sym_inline] = ACTIONS(3703),
    [anon_sym___inline] = ACTIONS(3703),
    [anon_sym___inline__] = ACTIONS(3703),
    [anon_sym___forceinline] = ACTIONS(3703),
    [anon_sym_thread_local] = ACTIONS(3703),
    [anon_sym___thread] = ACTIONS(3703),
    [anon_sym_const] = ACTIONS(3703),
    [anon_sym_constexpr] = ACTIONS(3703),
    [anon_sym_volatile] = ACTIONS(3703),
    [anon_sym_restrict] = ACTIONS(3703),
    [anon_sym___restrict__] = ACTIONS(3703),
    [anon_sym__Atomic] = ACTIONS(3703),
    [anon_sym__Noreturn] = ACTIONS(3703),
    [anon_sym_noreturn] = ACTIONS(3703),
    [anon_sym_mutable] = ACTIONS(3703),
    [anon_sym_constinit] = ACTIONS(3703),
    [anon_sym_consteval] = ACTIONS(3703),
    [anon_sym_alignas] = ACTIONS(3703),
    [anon_sym__Alignas] = ACTIONS(3703),
    [sym_primitive_type] = ACTIONS(3703),
    [anon_sym_enum] = ACTIONS(3703),
    [anon_sym_class] = ACTIONS(3703),
    [anon_sym_struct] = ACTIONS(3703),
    [anon_sym_union] = ACTIONS(3703),
    [anon_sym_if] = ACTIONS(3703),
    [anon_sym_switch] = ACTIONS(3703),
    [anon_sym_case] = ACTIONS(3703),
    [anon_sym_default] = ACTIONS(3703),
    [anon_sym_while] = ACTIONS(3703),
    [anon_sym_do] = ACTIONS(3703),
    [anon_sym_for] = ACTIONS(3703),
    [anon_sym_return] = ACTIONS(3703),
    [anon_sym_break] = ACTIONS(3703),
    [anon_sym_continue] = ACTIONS(3703),
    [anon_sym_goto] = ACTIONS(3703),
    [anon_sym___try] = ACTIONS(3703),
    [anon_sym___leave] = ACTIONS(3703),
    [anon_sym_not] = ACTIONS(3703),
    [anon_sym_compl] = ACTIONS(3703),
    [anon_sym_DASH_DASH] = ACTIONS(3705),
    [anon_sym_PLUS_PLUS] = ACTIONS(3705),
    [anon_sym_sizeof] = ACTIONS(3703),
    [anon_sym___alignof__] = ACTIONS(3703),
    [anon_sym___alignof] = ACTIONS(3703),
    [anon_sym__alignof] = ACTIONS(3703),
    [anon_sym_alignof] = ACTIONS(3703),
    [anon_sym__Alignof] = ACTIONS(3703),
    [anon_sym_offsetof] = ACTIONS(3703),
    [anon_sym__Generic] = ACTIONS(3703),
    [anon_sym_asm] = ACTIONS(3703),
    [anon_sym___asm__] = ACTIONS(3703),
    [sym_number_literal] = ACTIONS(3705),
    [anon_sym_L_SQUOTE] = ACTIONS(3705),
    [anon_sym_u_SQUOTE] = ACTIONS(3705),
    [anon_sym_U_SQUOTE] = ACTIONS(3705),
    [anon_sym_u8_SQUOTE] = ACTIONS(3705),
    [anon_sym_SQUOTE] = ACTIONS(3705),
    [anon_sym_L_DQUOTE] = ACTIONS(3705),
    [anon_sym_u_DQUOTE] = ACTIONS(3705),
    [anon_sym_U_DQUOTE] = ACTIONS(3705),
    [anon_sym_u8_DQUOTE] = ACTIONS(3705),
    [anon_sym_DQUOTE] = ACTIONS(3705),
    [sym_true] = ACTIONS(3703),
    [sym_false] = ACTIONS(3703),
    [anon_sym_NULL] = ACTIONS(3703),
    [anon_sym_nullptr] = ACTIONS(3703),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3703),
    [anon_sym_let] = ACTIONS(3703),
    [anon_sym_This] = ACTIONS(3703),
    [anon_sym_decltype] = ACTIONS(3703),
    [sym_virtual] = ACTIONS(3703),
    [anon_sym_explicit] = ACTIONS(3703),
    [anon_sym_typename] = ACTIONS(3703),
    [anon_sym_template] = ACTIONS(3703),
    [anon_sym_operator] = ACTIONS(3703),
    [anon_sym_try] = ACTIONS(3703),
    [anon_sym_delete] = ACTIONS(3703),
    [anon_sym_throw] = ACTIONS(3703),
    [anon_sym_namespace] = ACTIONS(3703),
    [anon_sym_using] = ACTIONS(3703),
    [anon_sym_static_assert] = ACTIONS(3703),
    [anon_sym_concept] = ACTIONS(3703),
    [anon_sym_co_return] = ACTIONS(3703),
    [anon_sym_co_yield] = ACTIONS(3703),
    [anon_sym_R_DQUOTE] = ACTIONS(3705),
    [anon_sym_LR_DQUOTE] = ACTIONS(3705),
    [anon_sym_uR_DQUOTE] = ACTIONS(3705),
    [anon_sym_UR_DQUOTE] = ACTIONS(3705),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3705),
    [anon_sym_co_await] = ACTIONS(3703),
    [anon_sym_new] = ACTIONS(3703),
    [anon_sym_requires] = ACTIONS(3703),
    [sym_this] = ACTIONS(3703),
    [anon_sym_discard] = ACTIONS(3703),
    [anon_sym_precise] = ACTIONS(3703),
    [anon_sym_shared] = ACTIONS(3703),
    [anon_sym_groupshared] = ACTIONS(3703),
    [anon_sym_uniform] = ACTIONS(3703),
    [anon_sym_row_major] = ACTIONS(3703),
    [anon_sym_column_major] = ACTIONS(3703),
    [anon_sym_globallycoherent] = ACTIONS(3703),
    [anon_sym_centroid] = ACTIONS(3703),
    [anon_sym_noperspective] = ACTIONS(3703),
    [anon_sym_nointerpolation] = ACTIONS(3703),
    [anon_sym_sample] = ACTIONS(3703),
    [anon_sym_linear] = ACTIONS(3703),
    [anon_sym_snorm] = ACTIONS(3703),
    [anon_sym_unorm] = ACTIONS(3703),
    [anon_sym_point] = ACTIONS(3703),
    [anon_sym_line] = ACTIONS(3703),
    [anon_sym_triangleadj] = ACTIONS(3703),
    [anon_sym_lineadj] = ACTIONS(3703),
    [anon_sym_triangle] = ACTIONS(3703),
    [anon_sym_cbuffer] = ACTIONS(3703),
    [anon_sym_interface] = ACTIONS(3703),
    [anon_sym_extension] = ACTIONS(3703),
  },
  [551] = {
    [ts_builtin_sym_end] = ACTIONS(3086),
    [sym_identifier] = ACTIONS(3084),
    [aux_sym_preproc_include_token1] = ACTIONS(3084),
    [aux_sym_preproc_def_token1] = ACTIONS(3084),
    [aux_sym_preproc_if_token1] = ACTIONS(3084),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3084),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3084),
    [sym_preproc_directive] = ACTIONS(3084),
    [anon_sym_LPAREN2] = ACTIONS(3086),
    [anon_sym_BANG] = ACTIONS(3086),
    [anon_sym_TILDE] = ACTIONS(3086),
    [anon_sym_DASH] = ACTIONS(3084),
    [anon_sym_PLUS] = ACTIONS(3084),
    [anon_sym_STAR] = ACTIONS(3086),
    [anon_sym_AMP_AMP] = ACTIONS(3086),
    [anon_sym_AMP] = ACTIONS(3084),
    [anon_sym_SEMI] = ACTIONS(3086),
    [anon_sym___extension__] = ACTIONS(3084),
    [anon_sym_typedef] = ACTIONS(3084),
    [anon_sym_in] = ACTIONS(3084),
    [anon_sym_out] = ACTIONS(3084),
    [anon_sym_inout] = ACTIONS(3084),
    [anon_sym_extern] = ACTIONS(3084),
    [anon_sym___attribute__] = ACTIONS(3084),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3086),
    [anon_sym___declspec] = ACTIONS(3084),
    [anon_sym___based] = ACTIONS(3084),
    [anon_sym___cdecl] = ACTIONS(3084),
    [anon_sym___clrcall] = ACTIONS(3084),
    [anon_sym___stdcall] = ACTIONS(3084),
    [anon_sym___fastcall] = ACTIONS(3084),
    [anon_sym___thiscall] = ACTIONS(3084),
    [anon_sym___vectorcall] = ACTIONS(3084),
    [anon_sym_LBRACE] = ACTIONS(3086),
    [anon_sym_signed] = ACTIONS(3084),
    [anon_sym_unsigned] = ACTIONS(3084),
    [anon_sym_long] = ACTIONS(3084),
    [anon_sym_short] = ACTIONS(3084),
    [anon_sym_LBRACK] = ACTIONS(3084),
    [anon_sym_static] = ACTIONS(3084),
    [anon_sym_register] = ACTIONS(3084),
    [anon_sym_inline] = ACTIONS(3084),
    [anon_sym___inline] = ACTIONS(3084),
    [anon_sym___inline__] = ACTIONS(3084),
    [anon_sym___forceinline] = ACTIONS(3084),
    [anon_sym_thread_local] = ACTIONS(3084),
    [anon_sym___thread] = ACTIONS(3084),
    [anon_sym_const] = ACTIONS(3084),
    [anon_sym_constexpr] = ACTIONS(3084),
    [anon_sym_volatile] = ACTIONS(3084),
    [anon_sym_restrict] = ACTIONS(3084),
    [anon_sym___restrict__] = ACTIONS(3084),
    [anon_sym__Atomic] = ACTIONS(3084),
    [anon_sym__Noreturn] = ACTIONS(3084),
    [anon_sym_noreturn] = ACTIONS(3084),
    [anon_sym_mutable] = ACTIONS(3084),
    [anon_sym_constinit] = ACTIONS(3084),
    [anon_sym_consteval] = ACTIONS(3084),
    [anon_sym_alignas] = ACTIONS(3084),
    [anon_sym__Alignas] = ACTIONS(3084),
    [sym_primitive_type] = ACTIONS(3084),
    [anon_sym_enum] = ACTIONS(3084),
    [anon_sym_class] = ACTIONS(3084),
    [anon_sym_struct] = ACTIONS(3084),
    [anon_sym_union] = ACTIONS(3084),
    [anon_sym_if] = ACTIONS(3084),
    [anon_sym_else] = ACTIONS(3084),
    [anon_sym_switch] = ACTIONS(3084),
    [anon_sym_case] = ACTIONS(3084),
    [anon_sym_default] = ACTIONS(3084),
    [anon_sym_while] = ACTIONS(3084),
    [anon_sym_do] = ACTIONS(3084),
    [anon_sym_for] = ACTIONS(3084),
    [anon_sym_return] = ACTIONS(3084),
    [anon_sym_break] = ACTIONS(3084),
    [anon_sym_continue] = ACTIONS(3084),
    [anon_sym_goto] = ACTIONS(3084),
    [anon_sym___try] = ACTIONS(3084),
    [anon_sym___leave] = ACTIONS(3084),
    [anon_sym_not] = ACTIONS(3084),
    [anon_sym_compl] = ACTIONS(3084),
    [anon_sym_DASH_DASH] = ACTIONS(3086),
    [anon_sym_PLUS_PLUS] = ACTIONS(3086),
    [anon_sym_sizeof] = ACTIONS(3084),
    [anon_sym___alignof__] = ACTIONS(3084),
    [anon_sym___alignof] = ACTIONS(3084),
    [anon_sym__alignof] = ACTIONS(3084),
    [anon_sym_alignof] = ACTIONS(3084),
    [anon_sym__Alignof] = ACTIONS(3084),
    [anon_sym_offsetof] = ACTIONS(3084),
    [anon_sym__Generic] = ACTIONS(3084),
    [anon_sym_asm] = ACTIONS(3084),
    [anon_sym___asm__] = ACTIONS(3084),
    [sym_number_literal] = ACTIONS(3086),
    [anon_sym_L_SQUOTE] = ACTIONS(3086),
    [anon_sym_u_SQUOTE] = ACTIONS(3086),
    [anon_sym_U_SQUOTE] = ACTIONS(3086),
    [anon_sym_u8_SQUOTE] = ACTIONS(3086),
    [anon_sym_SQUOTE] = ACTIONS(3086),
    [anon_sym_L_DQUOTE] = ACTIONS(3086),
    [anon_sym_u_DQUOTE] = ACTIONS(3086),
    [anon_sym_U_DQUOTE] = ACTIONS(3086),
    [anon_sym_u8_DQUOTE] = ACTIONS(3086),
    [anon_sym_DQUOTE] = ACTIONS(3086),
    [sym_true] = ACTIONS(3084),
    [sym_false] = ACTIONS(3084),
    [anon_sym_NULL] = ACTIONS(3084),
    [anon_sym_nullptr] = ACTIONS(3084),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3084),
    [anon_sym_let] = ACTIONS(3084),
    [anon_sym_This] = ACTIONS(3084),
    [anon_sym_decltype] = ACTIONS(3084),
    [sym_virtual] = ACTIONS(3084),
    [anon_sym_explicit] = ACTIONS(3084),
    [anon_sym_typename] = ACTIONS(3084),
    [anon_sym_template] = ACTIONS(3084),
    [anon_sym_operator] = ACTIONS(3084),
    [anon_sym_try] = ACTIONS(3084),
    [anon_sym_delete] = ACTIONS(3084),
    [anon_sym_throw] = ACTIONS(3084),
    [anon_sym_namespace] = ACTIONS(3084),
    [anon_sym_using] = ACTIONS(3084),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_concept] = ACTIONS(3084),
    [anon_sym_co_return] = ACTIONS(3084),
    [anon_sym_co_yield] = ACTIONS(3084),
    [anon_sym_R_DQUOTE] = ACTIONS(3086),
    [anon_sym_LR_DQUOTE] = ACTIONS(3086),
    [anon_sym_uR_DQUOTE] = ACTIONS(3086),
    [anon_sym_UR_DQUOTE] = ACTIONS(3086),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3086),
    [anon_sym_co_await] = ACTIONS(3084),
    [anon_sym_new] = ACTIONS(3084),
    [anon_sym_requires] = ACTIONS(3084),
    [sym_this] = ACTIONS(3084),
    [anon_sym_discard] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(3084),
    [anon_sym_shared] = ACTIONS(3084),
    [anon_sym_groupshared] = ACTIONS(3084),
    [anon_sym_uniform] = ACTIONS(3084),
    [anon_sym_row_major] = ACTIONS(3084),
    [anon_sym_column_major] = ACTIONS(3084),
    [anon_sym_globallycoherent] = ACTIONS(3084),
    [anon_sym_centroid] = ACTIONS(3084),
    [anon_sym_noperspective] = ACTIONS(3084),
    [anon_sym_nointerpolation] = ACTIONS(3084),
    [anon_sym_sample] = ACTIONS(3084),
    [anon_sym_linear] = ACTIONS(3084),
    [anon_sym_snorm] = ACTIONS(3084),
    [anon_sym_unorm] = ACTIONS(3084),
    [anon_sym_point] = ACTIONS(3084),
    [anon_sym_line] = ACTIONS(3084),
    [anon_sym_triangleadj] = ACTIONS(3084),
    [anon_sym_lineadj] = ACTIONS(3084),
    [anon_sym_triangle] = ACTIONS(3084),
    [anon_sym_cbuffer] = ACTIONS(3084),
    [anon_sym_interface] = ACTIONS(3084),
    [anon_sym_extension] = ACTIONS(3084),
    [anon_sym___exported] = ACTIONS(3084),
    [anon_sym_import] = ACTIONS(3084),
  },
  [552] = {
    [ts_builtin_sym_end] = ACTIONS(3216),
    [sym_identifier] = ACTIONS(3214),
    [aux_sym_preproc_include_token1] = ACTIONS(3214),
    [aux_sym_preproc_def_token1] = ACTIONS(3214),
    [aux_sym_preproc_if_token1] = ACTIONS(3214),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3214),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3214),
    [sym_preproc_directive] = ACTIONS(3214),
    [anon_sym_LPAREN2] = ACTIONS(3216),
    [anon_sym_BANG] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_DASH] = ACTIONS(3214),
    [anon_sym_PLUS] = ACTIONS(3214),
    [anon_sym_STAR] = ACTIONS(3216),
    [anon_sym_AMP_AMP] = ACTIONS(3216),
    [anon_sym_AMP] = ACTIONS(3214),
    [anon_sym_SEMI] = ACTIONS(3216),
    [anon_sym___extension__] = ACTIONS(3214),
    [anon_sym_typedef] = ACTIONS(3214),
    [anon_sym_in] = ACTIONS(3214),
    [anon_sym_out] = ACTIONS(3214),
    [anon_sym_inout] = ACTIONS(3214),
    [anon_sym_extern] = ACTIONS(3214),
    [anon_sym___attribute__] = ACTIONS(3214),
    [anon_sym_COLON_COLON] = ACTIONS(3216),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3216),
    [anon_sym___declspec] = ACTIONS(3214),
    [anon_sym___based] = ACTIONS(3214),
    [anon_sym___cdecl] = ACTIONS(3214),
    [anon_sym___clrcall] = ACTIONS(3214),
    [anon_sym___stdcall] = ACTIONS(3214),
    [anon_sym___fastcall] = ACTIONS(3214),
    [anon_sym___thiscall] = ACTIONS(3214),
    [anon_sym___vectorcall] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3216),
    [anon_sym_signed] = ACTIONS(3214),
    [anon_sym_unsigned] = ACTIONS(3214),
    [anon_sym_long] = ACTIONS(3214),
    [anon_sym_short] = ACTIONS(3214),
    [anon_sym_LBRACK] = ACTIONS(3214),
    [anon_sym_static] = ACTIONS(3214),
    [anon_sym_register] = ACTIONS(3214),
    [anon_sym_inline] = ACTIONS(3214),
    [anon_sym___inline] = ACTIONS(3214),
    [anon_sym___inline__] = ACTIONS(3214),
    [anon_sym___forceinline] = ACTIONS(3214),
    [anon_sym_thread_local] = ACTIONS(3214),
    [anon_sym___thread] = ACTIONS(3214),
    [anon_sym_const] = ACTIONS(3214),
    [anon_sym_constexpr] = ACTIONS(3214),
    [anon_sym_volatile] = ACTIONS(3214),
    [anon_sym_restrict] = ACTIONS(3214),
    [anon_sym___restrict__] = ACTIONS(3214),
    [anon_sym__Atomic] = ACTIONS(3214),
    [anon_sym__Noreturn] = ACTIONS(3214),
    [anon_sym_noreturn] = ACTIONS(3214),
    [anon_sym_mutable] = ACTIONS(3214),
    [anon_sym_constinit] = ACTIONS(3214),
    [anon_sym_consteval] = ACTIONS(3214),
    [anon_sym_alignas] = ACTIONS(3214),
    [anon_sym__Alignas] = ACTIONS(3214),
    [sym_primitive_type] = ACTIONS(3214),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3214),
    [anon_sym_struct] = ACTIONS(3214),
    [anon_sym_union] = ACTIONS(3214),
    [anon_sym_if] = ACTIONS(3214),
    [anon_sym_else] = ACTIONS(3214),
    [anon_sym_switch] = ACTIONS(3214),
    [anon_sym_case] = ACTIONS(3214),
    [anon_sym_default] = ACTIONS(3214),
    [anon_sym_while] = ACTIONS(3214),
    [anon_sym_do] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3214),
    [anon_sym_return] = ACTIONS(3214),
    [anon_sym_break] = ACTIONS(3214),
    [anon_sym_continue] = ACTIONS(3214),
    [anon_sym_goto] = ACTIONS(3214),
    [anon_sym___try] = ACTIONS(3214),
    [anon_sym___leave] = ACTIONS(3214),
    [anon_sym_not] = ACTIONS(3214),
    [anon_sym_compl] = ACTIONS(3214),
    [anon_sym_DASH_DASH] = ACTIONS(3216),
    [anon_sym_PLUS_PLUS] = ACTIONS(3216),
    [anon_sym_sizeof] = ACTIONS(3214),
    [anon_sym___alignof__] = ACTIONS(3214),
    [anon_sym___alignof] = ACTIONS(3214),
    [anon_sym__alignof] = ACTIONS(3214),
    [anon_sym_alignof] = ACTIONS(3214),
    [anon_sym__Alignof] = ACTIONS(3214),
    [anon_sym_offsetof] = ACTIONS(3214),
    [anon_sym__Generic] = ACTIONS(3214),
    [anon_sym_asm] = ACTIONS(3214),
    [anon_sym___asm__] = ACTIONS(3214),
    [sym_number_literal] = ACTIONS(3216),
    [anon_sym_L_SQUOTE] = ACTIONS(3216),
    [anon_sym_u_SQUOTE] = ACTIONS(3216),
    [anon_sym_U_SQUOTE] = ACTIONS(3216),
    [anon_sym_u8_SQUOTE] = ACTIONS(3216),
    [anon_sym_SQUOTE] = ACTIONS(3216),
    [anon_sym_L_DQUOTE] = ACTIONS(3216),
    [anon_sym_u_DQUOTE] = ACTIONS(3216),
    [anon_sym_U_DQUOTE] = ACTIONS(3216),
    [anon_sym_u8_DQUOTE] = ACTIONS(3216),
    [anon_sym_DQUOTE] = ACTIONS(3216),
    [sym_true] = ACTIONS(3214),
    [sym_false] = ACTIONS(3214),
    [anon_sym_NULL] = ACTIONS(3214),
    [anon_sym_nullptr] = ACTIONS(3214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3214),
    [anon_sym_let] = ACTIONS(3214),
    [anon_sym_This] = ACTIONS(3214),
    [anon_sym_decltype] = ACTIONS(3214),
    [sym_virtual] = ACTIONS(3214),
    [anon_sym_explicit] = ACTIONS(3214),
    [anon_sym_typename] = ACTIONS(3214),
    [anon_sym_template] = ACTIONS(3214),
    [anon_sym_operator] = ACTIONS(3214),
    [anon_sym_try] = ACTIONS(3214),
    [anon_sym_delete] = ACTIONS(3214),
    [anon_sym_throw] = ACTIONS(3214),
    [anon_sym_namespace] = ACTIONS(3214),
    [anon_sym_using] = ACTIONS(3214),
    [anon_sym_static_assert] = ACTIONS(3214),
    [anon_sym_concept] = ACTIONS(3214),
    [anon_sym_co_return] = ACTIONS(3214),
    [anon_sym_co_yield] = ACTIONS(3214),
    [anon_sym_R_DQUOTE] = ACTIONS(3216),
    [anon_sym_LR_DQUOTE] = ACTIONS(3216),
    [anon_sym_uR_DQUOTE] = ACTIONS(3216),
    [anon_sym_UR_DQUOTE] = ACTIONS(3216),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3216),
    [anon_sym_co_await] = ACTIONS(3214),
    [anon_sym_new] = ACTIONS(3214),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(3214),
    [anon_sym_discard] = ACTIONS(3214),
    [anon_sym_precise] = ACTIONS(3214),
    [anon_sym_shared] = ACTIONS(3214),
    [anon_sym_groupshared] = ACTIONS(3214),
    [anon_sym_uniform] = ACTIONS(3214),
    [anon_sym_row_major] = ACTIONS(3214),
    [anon_sym_column_major] = ACTIONS(3214),
    [anon_sym_globallycoherent] = ACTIONS(3214),
    [anon_sym_centroid] = ACTIONS(3214),
    [anon_sym_noperspective] = ACTIONS(3214),
    [anon_sym_nointerpolation] = ACTIONS(3214),
    [anon_sym_sample] = ACTIONS(3214),
    [anon_sym_linear] = ACTIONS(3214),
    [anon_sym_snorm] = ACTIONS(3214),
    [anon_sym_unorm] = ACTIONS(3214),
    [anon_sym_point] = ACTIONS(3214),
    [anon_sym_line] = ACTIONS(3214),
    [anon_sym_triangleadj] = ACTIONS(3214),
    [anon_sym_lineadj] = ACTIONS(3214),
    [anon_sym_triangle] = ACTIONS(3214),
    [anon_sym_cbuffer] = ACTIONS(3214),
    [anon_sym_interface] = ACTIONS(3214),
    [anon_sym_extension] = ACTIONS(3214),
    [anon_sym___exported] = ACTIONS(3214),
    [anon_sym_import] = ACTIONS(3214),
  },
  [553] = {
    [ts_builtin_sym_end] = ACTIONS(3010),
    [sym_identifier] = ACTIONS(3008),
    [aux_sym_preproc_include_token1] = ACTIONS(3008),
    [aux_sym_preproc_def_token1] = ACTIONS(3008),
    [aux_sym_preproc_if_token1] = ACTIONS(3008),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3008),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3008),
    [sym_preproc_directive] = ACTIONS(3008),
    [anon_sym_LPAREN2] = ACTIONS(3010),
    [anon_sym_BANG] = ACTIONS(3010),
    [anon_sym_TILDE] = ACTIONS(3010),
    [anon_sym_DASH] = ACTIONS(3008),
    [anon_sym_PLUS] = ACTIONS(3008),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_AMP_AMP] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3008),
    [anon_sym_SEMI] = ACTIONS(3010),
    [anon_sym___extension__] = ACTIONS(3008),
    [anon_sym_typedef] = ACTIONS(3008),
    [anon_sym_in] = ACTIONS(3008),
    [anon_sym_out] = ACTIONS(3008),
    [anon_sym_inout] = ACTIONS(3008),
    [anon_sym_extern] = ACTIONS(3008),
    [anon_sym___attribute__] = ACTIONS(3008),
    [anon_sym_COLON_COLON] = ACTIONS(3010),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3010),
    [anon_sym___declspec] = ACTIONS(3008),
    [anon_sym___based] = ACTIONS(3008),
    [anon_sym___cdecl] = ACTIONS(3008),
    [anon_sym___clrcall] = ACTIONS(3008),
    [anon_sym___stdcall] = ACTIONS(3008),
    [anon_sym___fastcall] = ACTIONS(3008),
    [anon_sym___thiscall] = ACTIONS(3008),
    [anon_sym___vectorcall] = ACTIONS(3008),
    [anon_sym_LBRACE] = ACTIONS(3010),
    [anon_sym_signed] = ACTIONS(3008),
    [anon_sym_unsigned] = ACTIONS(3008),
    [anon_sym_long] = ACTIONS(3008),
    [anon_sym_short] = ACTIONS(3008),
    [anon_sym_LBRACK] = ACTIONS(3008),
    [anon_sym_static] = ACTIONS(3008),
    [anon_sym_register] = ACTIONS(3008),
    [anon_sym_inline] = ACTIONS(3008),
    [anon_sym___inline] = ACTIONS(3008),
    [anon_sym___inline__] = ACTIONS(3008),
    [anon_sym___forceinline] = ACTIONS(3008),
    [anon_sym_thread_local] = ACTIONS(3008),
    [anon_sym___thread] = ACTIONS(3008),
    [anon_sym_const] = ACTIONS(3008),
    [anon_sym_constexpr] = ACTIONS(3008),
    [anon_sym_volatile] = ACTIONS(3008),
    [anon_sym_restrict] = ACTIONS(3008),
    [anon_sym___restrict__] = ACTIONS(3008),
    [anon_sym__Atomic] = ACTIONS(3008),
    [anon_sym__Noreturn] = ACTIONS(3008),
    [anon_sym_noreturn] = ACTIONS(3008),
    [anon_sym_mutable] = ACTIONS(3008),
    [anon_sym_constinit] = ACTIONS(3008),
    [anon_sym_consteval] = ACTIONS(3008),
    [anon_sym_alignas] = ACTIONS(3008),
    [anon_sym__Alignas] = ACTIONS(3008),
    [sym_primitive_type] = ACTIONS(3008),
    [anon_sym_enum] = ACTIONS(3008),
    [anon_sym_class] = ACTIONS(3008),
    [anon_sym_struct] = ACTIONS(3008),
    [anon_sym_union] = ACTIONS(3008),
    [anon_sym_if] = ACTIONS(3008),
    [anon_sym_else] = ACTIONS(3008),
    [anon_sym_switch] = ACTIONS(3008),
    [anon_sym_case] = ACTIONS(3008),
    [anon_sym_default] = ACTIONS(3008),
    [anon_sym_while] = ACTIONS(3008),
    [anon_sym_do] = ACTIONS(3008),
    [anon_sym_for] = ACTIONS(3008),
    [anon_sym_return] = ACTIONS(3008),
    [anon_sym_break] = ACTIONS(3008),
    [anon_sym_continue] = ACTIONS(3008),
    [anon_sym_goto] = ACTIONS(3008),
    [anon_sym___try] = ACTIONS(3008),
    [anon_sym___leave] = ACTIONS(3008),
    [anon_sym_not] = ACTIONS(3008),
    [anon_sym_compl] = ACTIONS(3008),
    [anon_sym_DASH_DASH] = ACTIONS(3010),
    [anon_sym_PLUS_PLUS] = ACTIONS(3010),
    [anon_sym_sizeof] = ACTIONS(3008),
    [anon_sym___alignof__] = ACTIONS(3008),
    [anon_sym___alignof] = ACTIONS(3008),
    [anon_sym__alignof] = ACTIONS(3008),
    [anon_sym_alignof] = ACTIONS(3008),
    [anon_sym__Alignof] = ACTIONS(3008),
    [anon_sym_offsetof] = ACTIONS(3008),
    [anon_sym__Generic] = ACTIONS(3008),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [sym_number_literal] = ACTIONS(3010),
    [anon_sym_L_SQUOTE] = ACTIONS(3010),
    [anon_sym_u_SQUOTE] = ACTIONS(3010),
    [anon_sym_U_SQUOTE] = ACTIONS(3010),
    [anon_sym_u8_SQUOTE] = ACTIONS(3010),
    [anon_sym_SQUOTE] = ACTIONS(3010),
    [anon_sym_L_DQUOTE] = ACTIONS(3010),
    [anon_sym_u_DQUOTE] = ACTIONS(3010),
    [anon_sym_U_DQUOTE] = ACTIONS(3010),
    [anon_sym_u8_DQUOTE] = ACTIONS(3010),
    [anon_sym_DQUOTE] = ACTIONS(3010),
    [sym_true] = ACTIONS(3008),
    [sym_false] = ACTIONS(3008),
    [anon_sym_NULL] = ACTIONS(3008),
    [anon_sym_nullptr] = ACTIONS(3008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3008),
    [anon_sym_let] = ACTIONS(3008),
    [anon_sym_This] = ACTIONS(3008),
    [anon_sym_decltype] = ACTIONS(3008),
    [sym_virtual] = ACTIONS(3008),
    [anon_sym_explicit] = ACTIONS(3008),
    [anon_sym_typename] = ACTIONS(3008),
    [anon_sym_template] = ACTIONS(3008),
    [anon_sym_operator] = ACTIONS(3008),
    [anon_sym_try] = ACTIONS(3008),
    [anon_sym_delete] = ACTIONS(3008),
    [anon_sym_throw] = ACTIONS(3008),
    [anon_sym_namespace] = ACTIONS(3008),
    [anon_sym_using] = ACTIONS(3008),
    [anon_sym_static_assert] = ACTIONS(3008),
    [anon_sym_concept] = ACTIONS(3008),
    [anon_sym_co_return] = ACTIONS(3008),
    [anon_sym_co_yield] = ACTIONS(3008),
    [anon_sym_R_DQUOTE] = ACTIONS(3010),
    [anon_sym_LR_DQUOTE] = ACTIONS(3010),
    [anon_sym_uR_DQUOTE] = ACTIONS(3010),
    [anon_sym_UR_DQUOTE] = ACTIONS(3010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3010),
    [anon_sym_co_await] = ACTIONS(3008),
    [anon_sym_new] = ACTIONS(3008),
    [anon_sym_requires] = ACTIONS(3008),
    [sym_this] = ACTIONS(3008),
    [anon_sym_discard] = ACTIONS(3008),
    [anon_sym_precise] = ACTIONS(3008),
    [anon_sym_shared] = ACTIONS(3008),
    [anon_sym_groupshared] = ACTIONS(3008),
    [anon_sym_uniform] = ACTIONS(3008),
    [anon_sym_row_major] = ACTIONS(3008),
    [anon_sym_column_major] = ACTIONS(3008),
    [anon_sym_globallycoherent] = ACTIONS(3008),
    [anon_sym_centroid] = ACTIONS(3008),
    [anon_sym_noperspective] = ACTIONS(3008),
    [anon_sym_nointerpolation] = ACTIONS(3008),
    [anon_sym_sample] = ACTIONS(3008),
    [anon_sym_linear] = ACTIONS(3008),
    [anon_sym_snorm] = ACTIONS(3008),
    [anon_sym_unorm] = ACTIONS(3008),
    [anon_sym_point] = ACTIONS(3008),
    [anon_sym_line] = ACTIONS(3008),
    [anon_sym_triangleadj] = ACTIONS(3008),
    [anon_sym_lineadj] = ACTIONS(3008),
    [anon_sym_triangle] = ACTIONS(3008),
    [anon_sym_cbuffer] = ACTIONS(3008),
    [anon_sym_interface] = ACTIONS(3008),
    [anon_sym_extension] = ACTIONS(3008),
    [anon_sym___exported] = ACTIONS(3008),
    [anon_sym_import] = ACTIONS(3008),
  },
  [554] = {
    [ts_builtin_sym_end] = ACTIONS(3016),
    [sym_identifier] = ACTIONS(3014),
    [aux_sym_preproc_include_token1] = ACTIONS(3014),
    [aux_sym_preproc_def_token1] = ACTIONS(3014),
    [aux_sym_preproc_if_token1] = ACTIONS(3014),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3014),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3014),
    [sym_preproc_directive] = ACTIONS(3014),
    [anon_sym_LPAREN2] = ACTIONS(3016),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [anon_sym_DASH] = ACTIONS(3014),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_STAR] = ACTIONS(3016),
    [anon_sym_AMP_AMP] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3016),
    [anon_sym___extension__] = ACTIONS(3014),
    [anon_sym_typedef] = ACTIONS(3014),
    [anon_sym_in] = ACTIONS(3014),
    [anon_sym_out] = ACTIONS(3014),
    [anon_sym_inout] = ACTIONS(3014),
    [anon_sym_extern] = ACTIONS(3014),
    [anon_sym___attribute__] = ACTIONS(3014),
    [anon_sym_COLON_COLON] = ACTIONS(3016),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3016),
    [anon_sym___declspec] = ACTIONS(3014),
    [anon_sym___based] = ACTIONS(3014),
    [anon_sym___cdecl] = ACTIONS(3014),
    [anon_sym___clrcall] = ACTIONS(3014),
    [anon_sym___stdcall] = ACTIONS(3014),
    [anon_sym___fastcall] = ACTIONS(3014),
    [anon_sym___thiscall] = ACTIONS(3014),
    [anon_sym___vectorcall] = ACTIONS(3014),
    [anon_sym_LBRACE] = ACTIONS(3016),
    [anon_sym_signed] = ACTIONS(3014),
    [anon_sym_unsigned] = ACTIONS(3014),
    [anon_sym_long] = ACTIONS(3014),
    [anon_sym_short] = ACTIONS(3014),
    [anon_sym_LBRACK] = ACTIONS(3014),
    [anon_sym_static] = ACTIONS(3014),
    [anon_sym_register] = ACTIONS(3014),
    [anon_sym_inline] = ACTIONS(3014),
    [anon_sym___inline] = ACTIONS(3014),
    [anon_sym___inline__] = ACTIONS(3014),
    [anon_sym___forceinline] = ACTIONS(3014),
    [anon_sym_thread_local] = ACTIONS(3014),
    [anon_sym___thread] = ACTIONS(3014),
    [anon_sym_const] = ACTIONS(3014),
    [anon_sym_constexpr] = ACTIONS(3014),
    [anon_sym_volatile] = ACTIONS(3014),
    [anon_sym_restrict] = ACTIONS(3014),
    [anon_sym___restrict__] = ACTIONS(3014),
    [anon_sym__Atomic] = ACTIONS(3014),
    [anon_sym__Noreturn] = ACTIONS(3014),
    [anon_sym_noreturn] = ACTIONS(3014),
    [anon_sym_mutable] = ACTIONS(3014),
    [anon_sym_constinit] = ACTIONS(3014),
    [anon_sym_consteval] = ACTIONS(3014),
    [anon_sym_alignas] = ACTIONS(3014),
    [anon_sym__Alignas] = ACTIONS(3014),
    [sym_primitive_type] = ACTIONS(3014),
    [anon_sym_enum] = ACTIONS(3014),
    [anon_sym_class] = ACTIONS(3014),
    [anon_sym_struct] = ACTIONS(3014),
    [anon_sym_union] = ACTIONS(3014),
    [anon_sym_if] = ACTIONS(3014),
    [anon_sym_else] = ACTIONS(3014),
    [anon_sym_switch] = ACTIONS(3014),
    [anon_sym_case] = ACTIONS(3014),
    [anon_sym_default] = ACTIONS(3014),
    [anon_sym_while] = ACTIONS(3014),
    [anon_sym_do] = ACTIONS(3014),
    [anon_sym_for] = ACTIONS(3014),
    [anon_sym_return] = ACTIONS(3014),
    [anon_sym_break] = ACTIONS(3014),
    [anon_sym_continue] = ACTIONS(3014),
    [anon_sym_goto] = ACTIONS(3014),
    [anon_sym___try] = ACTIONS(3014),
    [anon_sym___leave] = ACTIONS(3014),
    [anon_sym_not] = ACTIONS(3014),
    [anon_sym_compl] = ACTIONS(3014),
    [anon_sym_DASH_DASH] = ACTIONS(3016),
    [anon_sym_PLUS_PLUS] = ACTIONS(3016),
    [anon_sym_sizeof] = ACTIONS(3014),
    [anon_sym___alignof__] = ACTIONS(3014),
    [anon_sym___alignof] = ACTIONS(3014),
    [anon_sym__alignof] = ACTIONS(3014),
    [anon_sym_alignof] = ACTIONS(3014),
    [anon_sym__Alignof] = ACTIONS(3014),
    [anon_sym_offsetof] = ACTIONS(3014),
    [anon_sym__Generic] = ACTIONS(3014),
    [anon_sym_asm] = ACTIONS(3014),
    [anon_sym___asm__] = ACTIONS(3014),
    [sym_number_literal] = ACTIONS(3016),
    [anon_sym_L_SQUOTE] = ACTIONS(3016),
    [anon_sym_u_SQUOTE] = ACTIONS(3016),
    [anon_sym_U_SQUOTE] = ACTIONS(3016),
    [anon_sym_u8_SQUOTE] = ACTIONS(3016),
    [anon_sym_SQUOTE] = ACTIONS(3016),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3014),
    [sym_false] = ACTIONS(3014),
    [anon_sym_NULL] = ACTIONS(3014),
    [anon_sym_nullptr] = ACTIONS(3014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3014),
    [anon_sym_let] = ACTIONS(3014),
    [anon_sym_This] = ACTIONS(3014),
    [anon_sym_decltype] = ACTIONS(3014),
    [sym_virtual] = ACTIONS(3014),
    [anon_sym_explicit] = ACTIONS(3014),
    [anon_sym_typename] = ACTIONS(3014),
    [anon_sym_template] = ACTIONS(3014),
    [anon_sym_operator] = ACTIONS(3014),
    [anon_sym_try] = ACTIONS(3014),
    [anon_sym_delete] = ACTIONS(3014),
    [anon_sym_throw] = ACTIONS(3014),
    [anon_sym_namespace] = ACTIONS(3014),
    [anon_sym_using] = ACTIONS(3014),
    [anon_sym_static_assert] = ACTIONS(3014),
    [anon_sym_concept] = ACTIONS(3014),
    [anon_sym_co_return] = ACTIONS(3014),
    [anon_sym_co_yield] = ACTIONS(3014),
    [anon_sym_R_DQUOTE] = ACTIONS(3016),
    [anon_sym_LR_DQUOTE] = ACTIONS(3016),
    [anon_sym_uR_DQUOTE] = ACTIONS(3016),
    [anon_sym_UR_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3016),
    [anon_sym_co_await] = ACTIONS(3014),
    [anon_sym_new] = ACTIONS(3014),
    [anon_sym_requires] = ACTIONS(3014),
    [sym_this] = ACTIONS(3014),
    [anon_sym_discard] = ACTIONS(3014),
    [anon_sym_precise] = ACTIONS(3014),
    [anon_sym_shared] = ACTIONS(3014),
    [anon_sym_groupshared] = ACTIONS(3014),
    [anon_sym_uniform] = ACTIONS(3014),
    [anon_sym_row_major] = ACTIONS(3014),
    [anon_sym_column_major] = ACTIONS(3014),
    [anon_sym_globallycoherent] = ACTIONS(3014),
    [anon_sym_centroid] = ACTIONS(3014),
    [anon_sym_noperspective] = ACTIONS(3014),
    [anon_sym_nointerpolation] = ACTIONS(3014),
    [anon_sym_sample] = ACTIONS(3014),
    [anon_sym_linear] = ACTIONS(3014),
    [anon_sym_snorm] = ACTIONS(3014),
    [anon_sym_unorm] = ACTIONS(3014),
    [anon_sym_point] = ACTIONS(3014),
    [anon_sym_line] = ACTIONS(3014),
    [anon_sym_triangleadj] = ACTIONS(3014),
    [anon_sym_lineadj] = ACTIONS(3014),
    [anon_sym_triangle] = ACTIONS(3014),
    [anon_sym_cbuffer] = ACTIONS(3014),
    [anon_sym_interface] = ACTIONS(3014),
    [anon_sym_extension] = ACTIONS(3014),
    [anon_sym___exported] = ACTIONS(3014),
    [anon_sym_import] = ACTIONS(3014),
  },
  [555] = {
    [ts_builtin_sym_end] = ACTIONS(3020),
    [sym_identifier] = ACTIONS(3018),
    [aux_sym_preproc_include_token1] = ACTIONS(3018),
    [aux_sym_preproc_def_token1] = ACTIONS(3018),
    [aux_sym_preproc_if_token1] = ACTIONS(3018),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3018),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3018),
    [sym_preproc_directive] = ACTIONS(3018),
    [anon_sym_LPAREN2] = ACTIONS(3020),
    [anon_sym_BANG] = ACTIONS(3020),
    [anon_sym_TILDE] = ACTIONS(3020),
    [anon_sym_DASH] = ACTIONS(3018),
    [anon_sym_PLUS] = ACTIONS(3018),
    [anon_sym_STAR] = ACTIONS(3020),
    [anon_sym_AMP_AMP] = ACTIONS(3020),
    [anon_sym_AMP] = ACTIONS(3018),
    [anon_sym_SEMI] = ACTIONS(3020),
    [anon_sym___extension__] = ACTIONS(3018),
    [anon_sym_typedef] = ACTIONS(3018),
    [anon_sym_in] = ACTIONS(3018),
    [anon_sym_out] = ACTIONS(3018),
    [anon_sym_inout] = ACTIONS(3018),
    [anon_sym_extern] = ACTIONS(3018),
    [anon_sym___attribute__] = ACTIONS(3018),
    [anon_sym_COLON_COLON] = ACTIONS(3020),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3020),
    [anon_sym___declspec] = ACTIONS(3018),
    [anon_sym___based] = ACTIONS(3018),
    [anon_sym___cdecl] = ACTIONS(3018),
    [anon_sym___clrcall] = ACTIONS(3018),
    [anon_sym___stdcall] = ACTIONS(3018),
    [anon_sym___fastcall] = ACTIONS(3018),
    [anon_sym___thiscall] = ACTIONS(3018),
    [anon_sym___vectorcall] = ACTIONS(3018),
    [anon_sym_LBRACE] = ACTIONS(3020),
    [anon_sym_signed] = ACTIONS(3018),
    [anon_sym_unsigned] = ACTIONS(3018),
    [anon_sym_long] = ACTIONS(3018),
    [anon_sym_short] = ACTIONS(3018),
    [anon_sym_LBRACK] = ACTIONS(3018),
    [anon_sym_static] = ACTIONS(3018),
    [anon_sym_register] = ACTIONS(3018),
    [anon_sym_inline] = ACTIONS(3018),
    [anon_sym___inline] = ACTIONS(3018),
    [anon_sym___inline__] = ACTIONS(3018),
    [anon_sym___forceinline] = ACTIONS(3018),
    [anon_sym_thread_local] = ACTIONS(3018),
    [anon_sym___thread] = ACTIONS(3018),
    [anon_sym_const] = ACTIONS(3018),
    [anon_sym_constexpr] = ACTIONS(3018),
    [anon_sym_volatile] = ACTIONS(3018),
    [anon_sym_restrict] = ACTIONS(3018),
    [anon_sym___restrict__] = ACTIONS(3018),
    [anon_sym__Atomic] = ACTIONS(3018),
    [anon_sym__Noreturn] = ACTIONS(3018),
    [anon_sym_noreturn] = ACTIONS(3018),
    [anon_sym_mutable] = ACTIONS(3018),
    [anon_sym_constinit] = ACTIONS(3018),
    [anon_sym_consteval] = ACTIONS(3018),
    [anon_sym_alignas] = ACTIONS(3018),
    [anon_sym__Alignas] = ACTIONS(3018),
    [sym_primitive_type] = ACTIONS(3018),
    [anon_sym_enum] = ACTIONS(3018),
    [anon_sym_class] = ACTIONS(3018),
    [anon_sym_struct] = ACTIONS(3018),
    [anon_sym_union] = ACTIONS(3018),
    [anon_sym_if] = ACTIONS(3018),
    [anon_sym_else] = ACTIONS(3018),
    [anon_sym_switch] = ACTIONS(3018),
    [anon_sym_case] = ACTIONS(3018),
    [anon_sym_default] = ACTIONS(3018),
    [anon_sym_while] = ACTIONS(3018),
    [anon_sym_do] = ACTIONS(3018),
    [anon_sym_for] = ACTIONS(3018),
    [anon_sym_return] = ACTIONS(3018),
    [anon_sym_break] = ACTIONS(3018),
    [anon_sym_continue] = ACTIONS(3018),
    [anon_sym_goto] = ACTIONS(3018),
    [anon_sym___try] = ACTIONS(3018),
    [anon_sym___leave] = ACTIONS(3018),
    [anon_sym_not] = ACTIONS(3018),
    [anon_sym_compl] = ACTIONS(3018),
    [anon_sym_DASH_DASH] = ACTIONS(3020),
    [anon_sym_PLUS_PLUS] = ACTIONS(3020),
    [anon_sym_sizeof] = ACTIONS(3018),
    [anon_sym___alignof__] = ACTIONS(3018),
    [anon_sym___alignof] = ACTIONS(3018),
    [anon_sym__alignof] = ACTIONS(3018),
    [anon_sym_alignof] = ACTIONS(3018),
    [anon_sym__Alignof] = ACTIONS(3018),
    [anon_sym_offsetof] = ACTIONS(3018),
    [anon_sym__Generic] = ACTIONS(3018),
    [anon_sym_asm] = ACTIONS(3018),
    [anon_sym___asm__] = ACTIONS(3018),
    [sym_number_literal] = ACTIONS(3020),
    [anon_sym_L_SQUOTE] = ACTIONS(3020),
    [anon_sym_u_SQUOTE] = ACTIONS(3020),
    [anon_sym_U_SQUOTE] = ACTIONS(3020),
    [anon_sym_u8_SQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3020),
    [anon_sym_L_DQUOTE] = ACTIONS(3020),
    [anon_sym_u_DQUOTE] = ACTIONS(3020),
    [anon_sym_U_DQUOTE] = ACTIONS(3020),
    [anon_sym_u8_DQUOTE] = ACTIONS(3020),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3018),
    [anon_sym_nullptr] = ACTIONS(3018),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3018),
    [anon_sym_let] = ACTIONS(3018),
    [anon_sym_This] = ACTIONS(3018),
    [anon_sym_decltype] = ACTIONS(3018),
    [sym_virtual] = ACTIONS(3018),
    [anon_sym_explicit] = ACTIONS(3018),
    [anon_sym_typename] = ACTIONS(3018),
    [anon_sym_template] = ACTIONS(3018),
    [anon_sym_operator] = ACTIONS(3018),
    [anon_sym_try] = ACTIONS(3018),
    [anon_sym_delete] = ACTIONS(3018),
    [anon_sym_throw] = ACTIONS(3018),
    [anon_sym_namespace] = ACTIONS(3018),
    [anon_sym_using] = ACTIONS(3018),
    [anon_sym_static_assert] = ACTIONS(3018),
    [anon_sym_concept] = ACTIONS(3018),
    [anon_sym_co_return] = ACTIONS(3018),
    [anon_sym_co_yield] = ACTIONS(3018),
    [anon_sym_R_DQUOTE] = ACTIONS(3020),
    [anon_sym_LR_DQUOTE] = ACTIONS(3020),
    [anon_sym_uR_DQUOTE] = ACTIONS(3020),
    [anon_sym_UR_DQUOTE] = ACTIONS(3020),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3020),
    [anon_sym_co_await] = ACTIONS(3018),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_requires] = ACTIONS(3018),
    [sym_this] = ACTIONS(3018),
    [anon_sym_discard] = ACTIONS(3018),
    [anon_sym_precise] = ACTIONS(3018),
    [anon_sym_shared] = ACTIONS(3018),
    [anon_sym_groupshared] = ACTIONS(3018),
    [anon_sym_uniform] = ACTIONS(3018),
    [anon_sym_row_major] = ACTIONS(3018),
    [anon_sym_column_major] = ACTIONS(3018),
    [anon_sym_globallycoherent] = ACTIONS(3018),
    [anon_sym_centroid] = ACTIONS(3018),
    [anon_sym_noperspective] = ACTIONS(3018),
    [anon_sym_nointerpolation] = ACTIONS(3018),
    [anon_sym_sample] = ACTIONS(3018),
    [anon_sym_linear] = ACTIONS(3018),
    [anon_sym_snorm] = ACTIONS(3018),
    [anon_sym_unorm] = ACTIONS(3018),
    [anon_sym_point] = ACTIONS(3018),
    [anon_sym_line] = ACTIONS(3018),
    [anon_sym_triangleadj] = ACTIONS(3018),
    [anon_sym_lineadj] = ACTIONS(3018),
    [anon_sym_triangle] = ACTIONS(3018),
    [anon_sym_cbuffer] = ACTIONS(3018),
    [anon_sym_interface] = ACTIONS(3018),
    [anon_sym_extension] = ACTIONS(3018),
    [anon_sym___exported] = ACTIONS(3018),
    [anon_sym_import] = ACTIONS(3018),
  },
  [556] = {
    [ts_builtin_sym_end] = ACTIONS(3024),
    [sym_identifier] = ACTIONS(3022),
    [aux_sym_preproc_include_token1] = ACTIONS(3022),
    [aux_sym_preproc_def_token1] = ACTIONS(3022),
    [aux_sym_preproc_if_token1] = ACTIONS(3022),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3022),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3022),
    [sym_preproc_directive] = ACTIONS(3022),
    [anon_sym_LPAREN2] = ACTIONS(3024),
    [anon_sym_BANG] = ACTIONS(3024),
    [anon_sym_TILDE] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3022),
    [anon_sym_PLUS] = ACTIONS(3022),
    [anon_sym_STAR] = ACTIONS(3024),
    [anon_sym_AMP_AMP] = ACTIONS(3024),
    [anon_sym_AMP] = ACTIONS(3022),
    [anon_sym_SEMI] = ACTIONS(3024),
    [anon_sym___extension__] = ACTIONS(3022),
    [anon_sym_typedef] = ACTIONS(3022),
    [anon_sym_in] = ACTIONS(3022),
    [anon_sym_out] = ACTIONS(3022),
    [anon_sym_inout] = ACTIONS(3022),
    [anon_sym_extern] = ACTIONS(3022),
    [anon_sym___attribute__] = ACTIONS(3022),
    [anon_sym_COLON_COLON] = ACTIONS(3024),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3024),
    [anon_sym___declspec] = ACTIONS(3022),
    [anon_sym___based] = ACTIONS(3022),
    [anon_sym___cdecl] = ACTIONS(3022),
    [anon_sym___clrcall] = ACTIONS(3022),
    [anon_sym___stdcall] = ACTIONS(3022),
    [anon_sym___fastcall] = ACTIONS(3022),
    [anon_sym___thiscall] = ACTIONS(3022),
    [anon_sym___vectorcall] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_signed] = ACTIONS(3022),
    [anon_sym_unsigned] = ACTIONS(3022),
    [anon_sym_long] = ACTIONS(3022),
    [anon_sym_short] = ACTIONS(3022),
    [anon_sym_LBRACK] = ACTIONS(3022),
    [anon_sym_static] = ACTIONS(3022),
    [anon_sym_register] = ACTIONS(3022),
    [anon_sym_inline] = ACTIONS(3022),
    [anon_sym___inline] = ACTIONS(3022),
    [anon_sym___inline__] = ACTIONS(3022),
    [anon_sym___forceinline] = ACTIONS(3022),
    [anon_sym_thread_local] = ACTIONS(3022),
    [anon_sym___thread] = ACTIONS(3022),
    [anon_sym_const] = ACTIONS(3022),
    [anon_sym_constexpr] = ACTIONS(3022),
    [anon_sym_volatile] = ACTIONS(3022),
    [anon_sym_restrict] = ACTIONS(3022),
    [anon_sym___restrict__] = ACTIONS(3022),
    [anon_sym__Atomic] = ACTIONS(3022),
    [anon_sym__Noreturn] = ACTIONS(3022),
    [anon_sym_noreturn] = ACTIONS(3022),
    [anon_sym_mutable] = ACTIONS(3022),
    [anon_sym_constinit] = ACTIONS(3022),
    [anon_sym_consteval] = ACTIONS(3022),
    [anon_sym_alignas] = ACTIONS(3022),
    [anon_sym__Alignas] = ACTIONS(3022),
    [sym_primitive_type] = ACTIONS(3022),
    [anon_sym_enum] = ACTIONS(3022),
    [anon_sym_class] = ACTIONS(3022),
    [anon_sym_struct] = ACTIONS(3022),
    [anon_sym_union] = ACTIONS(3022),
    [anon_sym_if] = ACTIONS(3022),
    [anon_sym_else] = ACTIONS(3022),
    [anon_sym_switch] = ACTIONS(3022),
    [anon_sym_case] = ACTIONS(3022),
    [anon_sym_default] = ACTIONS(3022),
    [anon_sym_while] = ACTIONS(3022),
    [anon_sym_do] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(3022),
    [anon_sym_return] = ACTIONS(3022),
    [anon_sym_break] = ACTIONS(3022),
    [anon_sym_continue] = ACTIONS(3022),
    [anon_sym_goto] = ACTIONS(3022),
    [anon_sym___try] = ACTIONS(3022),
    [anon_sym___leave] = ACTIONS(3022),
    [anon_sym_not] = ACTIONS(3022),
    [anon_sym_compl] = ACTIONS(3022),
    [anon_sym_DASH_DASH] = ACTIONS(3024),
    [anon_sym_PLUS_PLUS] = ACTIONS(3024),
    [anon_sym_sizeof] = ACTIONS(3022),
    [anon_sym___alignof__] = ACTIONS(3022),
    [anon_sym___alignof] = ACTIONS(3022),
    [anon_sym__alignof] = ACTIONS(3022),
    [anon_sym_alignof] = ACTIONS(3022),
    [anon_sym__Alignof] = ACTIONS(3022),
    [anon_sym_offsetof] = ACTIONS(3022),
    [anon_sym__Generic] = ACTIONS(3022),
    [anon_sym_asm] = ACTIONS(3022),
    [anon_sym___asm__] = ACTIONS(3022),
    [sym_number_literal] = ACTIONS(3024),
    [anon_sym_L_SQUOTE] = ACTIONS(3024),
    [anon_sym_u_SQUOTE] = ACTIONS(3024),
    [anon_sym_U_SQUOTE] = ACTIONS(3024),
    [anon_sym_u8_SQUOTE] = ACTIONS(3024),
    [anon_sym_SQUOTE] = ACTIONS(3024),
    [anon_sym_L_DQUOTE] = ACTIONS(3024),
    [anon_sym_u_DQUOTE] = ACTIONS(3024),
    [anon_sym_U_DQUOTE] = ACTIONS(3024),
    [anon_sym_u8_DQUOTE] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3024),
    [sym_true] = ACTIONS(3022),
    [sym_false] = ACTIONS(3022),
    [anon_sym_NULL] = ACTIONS(3022),
    [anon_sym_nullptr] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3022),
    [anon_sym_let] = ACTIONS(3022),
    [anon_sym_This] = ACTIONS(3022),
    [anon_sym_decltype] = ACTIONS(3022),
    [sym_virtual] = ACTIONS(3022),
    [anon_sym_explicit] = ACTIONS(3022),
    [anon_sym_typename] = ACTIONS(3022),
    [anon_sym_template] = ACTIONS(3022),
    [anon_sym_operator] = ACTIONS(3022),
    [anon_sym_try] = ACTIONS(3022),
    [anon_sym_delete] = ACTIONS(3022),
    [anon_sym_throw] = ACTIONS(3022),
    [anon_sym_namespace] = ACTIONS(3022),
    [anon_sym_using] = ACTIONS(3022),
    [anon_sym_static_assert] = ACTIONS(3022),
    [anon_sym_concept] = ACTIONS(3022),
    [anon_sym_co_return] = ACTIONS(3022),
    [anon_sym_co_yield] = ACTIONS(3022),
    [anon_sym_R_DQUOTE] = ACTIONS(3024),
    [anon_sym_LR_DQUOTE] = ACTIONS(3024),
    [anon_sym_uR_DQUOTE] = ACTIONS(3024),
    [anon_sym_UR_DQUOTE] = ACTIONS(3024),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3024),
    [anon_sym_co_await] = ACTIONS(3022),
    [anon_sym_new] = ACTIONS(3022),
    [anon_sym_requires] = ACTIONS(3022),
    [sym_this] = ACTIONS(3022),
    [anon_sym_discard] = ACTIONS(3022),
    [anon_sym_precise] = ACTIONS(3022),
    [anon_sym_shared] = ACTIONS(3022),
    [anon_sym_groupshared] = ACTIONS(3022),
    [anon_sym_uniform] = ACTIONS(3022),
    [anon_sym_row_major] = ACTIONS(3022),
    [anon_sym_column_major] = ACTIONS(3022),
    [anon_sym_globallycoherent] = ACTIONS(3022),
    [anon_sym_centroid] = ACTIONS(3022),
    [anon_sym_noperspective] = ACTIONS(3022),
    [anon_sym_nointerpolation] = ACTIONS(3022),
    [anon_sym_sample] = ACTIONS(3022),
    [anon_sym_linear] = ACTIONS(3022),
    [anon_sym_snorm] = ACTIONS(3022),
    [anon_sym_unorm] = ACTIONS(3022),
    [anon_sym_point] = ACTIONS(3022),
    [anon_sym_line] = ACTIONS(3022),
    [anon_sym_triangleadj] = ACTIONS(3022),
    [anon_sym_lineadj] = ACTIONS(3022),
    [anon_sym_triangle] = ACTIONS(3022),
    [anon_sym_cbuffer] = ACTIONS(3022),
    [anon_sym_interface] = ACTIONS(3022),
    [anon_sym_extension] = ACTIONS(3022),
    [anon_sym___exported] = ACTIONS(3022),
    [anon_sym_import] = ACTIONS(3022),
  },
  [557] = {
    [ts_builtin_sym_end] = ACTIONS(3312),
    [sym_identifier] = ACTIONS(3310),
    [aux_sym_preproc_include_token1] = ACTIONS(3310),
    [aux_sym_preproc_def_token1] = ACTIONS(3310),
    [aux_sym_preproc_if_token1] = ACTIONS(3310),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3310),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3310),
    [sym_preproc_directive] = ACTIONS(3310),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_BANG] = ACTIONS(3312),
    [anon_sym_TILDE] = ACTIONS(3312),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3312),
    [anon_sym_AMP_AMP] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3310),
    [anon_sym_SEMI] = ACTIONS(3312),
    [anon_sym___extension__] = ACTIONS(3310),
    [anon_sym_typedef] = ACTIONS(3310),
    [anon_sym_in] = ACTIONS(3310),
    [anon_sym_out] = ACTIONS(3310),
    [anon_sym_inout] = ACTIONS(3310),
    [anon_sym_extern] = ACTIONS(3310),
    [anon_sym___attribute__] = ACTIONS(3310),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3312),
    [anon_sym___declspec] = ACTIONS(3310),
    [anon_sym___based] = ACTIONS(3310),
    [anon_sym___cdecl] = ACTIONS(3310),
    [anon_sym___clrcall] = ACTIONS(3310),
    [anon_sym___stdcall] = ACTIONS(3310),
    [anon_sym___fastcall] = ACTIONS(3310),
    [anon_sym___thiscall] = ACTIONS(3310),
    [anon_sym___vectorcall] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3312),
    [anon_sym_signed] = ACTIONS(3310),
    [anon_sym_unsigned] = ACTIONS(3310),
    [anon_sym_long] = ACTIONS(3310),
    [anon_sym_short] = ACTIONS(3310),
    [anon_sym_LBRACK] = ACTIONS(3310),
    [anon_sym_static] = ACTIONS(3310),
    [anon_sym_register] = ACTIONS(3310),
    [anon_sym_inline] = ACTIONS(3310),
    [anon_sym___inline] = ACTIONS(3310),
    [anon_sym___inline__] = ACTIONS(3310),
    [anon_sym___forceinline] = ACTIONS(3310),
    [anon_sym_thread_local] = ACTIONS(3310),
    [anon_sym___thread] = ACTIONS(3310),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_constexpr] = ACTIONS(3310),
    [anon_sym_volatile] = ACTIONS(3310),
    [anon_sym_restrict] = ACTIONS(3310),
    [anon_sym___restrict__] = ACTIONS(3310),
    [anon_sym__Atomic] = ACTIONS(3310),
    [anon_sym__Noreturn] = ACTIONS(3310),
    [anon_sym_noreturn] = ACTIONS(3310),
    [anon_sym_mutable] = ACTIONS(3310),
    [anon_sym_constinit] = ACTIONS(3310),
    [anon_sym_consteval] = ACTIONS(3310),
    [anon_sym_alignas] = ACTIONS(3310),
    [anon_sym__Alignas] = ACTIONS(3310),
    [sym_primitive_type] = ACTIONS(3310),
    [anon_sym_enum] = ACTIONS(3310),
    [anon_sym_class] = ACTIONS(3310),
    [anon_sym_struct] = ACTIONS(3310),
    [anon_sym_union] = ACTIONS(3310),
    [anon_sym_if] = ACTIONS(3310),
    [anon_sym_else] = ACTIONS(3310),
    [anon_sym_switch] = ACTIONS(3310),
    [anon_sym_case] = ACTIONS(3310),
    [anon_sym_default] = ACTIONS(3310),
    [anon_sym_while] = ACTIONS(3310),
    [anon_sym_do] = ACTIONS(3310),
    [anon_sym_for] = ACTIONS(3310),
    [anon_sym_return] = ACTIONS(3310),
    [anon_sym_break] = ACTIONS(3310),
    [anon_sym_continue] = ACTIONS(3310),
    [anon_sym_goto] = ACTIONS(3310),
    [anon_sym___try] = ACTIONS(3310),
    [anon_sym___leave] = ACTIONS(3310),
    [anon_sym_not] = ACTIONS(3310),
    [anon_sym_compl] = ACTIONS(3310),
    [anon_sym_DASH_DASH] = ACTIONS(3312),
    [anon_sym_PLUS_PLUS] = ACTIONS(3312),
    [anon_sym_sizeof] = ACTIONS(3310),
    [anon_sym___alignof__] = ACTIONS(3310),
    [anon_sym___alignof] = ACTIONS(3310),
    [anon_sym__alignof] = ACTIONS(3310),
    [anon_sym_alignof] = ACTIONS(3310),
    [anon_sym__Alignof] = ACTIONS(3310),
    [anon_sym_offsetof] = ACTIONS(3310),
    [anon_sym__Generic] = ACTIONS(3310),
    [anon_sym_asm] = ACTIONS(3310),
    [anon_sym___asm__] = ACTIONS(3310),
    [sym_number_literal] = ACTIONS(3312),
    [anon_sym_L_SQUOTE] = ACTIONS(3312),
    [anon_sym_u_SQUOTE] = ACTIONS(3312),
    [anon_sym_U_SQUOTE] = ACTIONS(3312),
    [anon_sym_u8_SQUOTE] = ACTIONS(3312),
    [anon_sym_SQUOTE] = ACTIONS(3312),
    [anon_sym_L_DQUOTE] = ACTIONS(3312),
    [anon_sym_u_DQUOTE] = ACTIONS(3312),
    [anon_sym_U_DQUOTE] = ACTIONS(3312),
    [anon_sym_u8_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE] = ACTIONS(3312),
    [sym_true] = ACTIONS(3310),
    [sym_false] = ACTIONS(3310),
    [anon_sym_NULL] = ACTIONS(3310),
    [anon_sym_nullptr] = ACTIONS(3310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3310),
    [anon_sym_let] = ACTIONS(3310),
    [anon_sym_This] = ACTIONS(3310),
    [anon_sym_decltype] = ACTIONS(3310),
    [sym_virtual] = ACTIONS(3310),
    [anon_sym_explicit] = ACTIONS(3310),
    [anon_sym_typename] = ACTIONS(3310),
    [anon_sym_template] = ACTIONS(3310),
    [anon_sym_operator] = ACTIONS(3310),
    [anon_sym_try] = ACTIONS(3310),
    [anon_sym_delete] = ACTIONS(3310),
    [anon_sym_throw] = ACTIONS(3310),
    [anon_sym_namespace] = ACTIONS(3310),
    [anon_sym_using] = ACTIONS(3310),
    [anon_sym_static_assert] = ACTIONS(3310),
    [anon_sym_concept] = ACTIONS(3310),
    [anon_sym_co_return] = ACTIONS(3310),
    [anon_sym_co_yield] = ACTIONS(3310),
    [anon_sym_R_DQUOTE] = ACTIONS(3312),
    [anon_sym_LR_DQUOTE] = ACTIONS(3312),
    [anon_sym_uR_DQUOTE] = ACTIONS(3312),
    [anon_sym_UR_DQUOTE] = ACTIONS(3312),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3312),
    [anon_sym_co_await] = ACTIONS(3310),
    [anon_sym_new] = ACTIONS(3310),
    [anon_sym_requires] = ACTIONS(3310),
    [sym_this] = ACTIONS(3310),
    [anon_sym_discard] = ACTIONS(3310),
    [anon_sym_precise] = ACTIONS(3310),
    [anon_sym_shared] = ACTIONS(3310),
    [anon_sym_groupshared] = ACTIONS(3310),
    [anon_sym_uniform] = ACTIONS(3310),
    [anon_sym_row_major] = ACTIONS(3310),
    [anon_sym_column_major] = ACTIONS(3310),
    [anon_sym_globallycoherent] = ACTIONS(3310),
    [anon_sym_centroid] = ACTIONS(3310),
    [anon_sym_noperspective] = ACTIONS(3310),
    [anon_sym_nointerpolation] = ACTIONS(3310),
    [anon_sym_sample] = ACTIONS(3310),
    [anon_sym_linear] = ACTIONS(3310),
    [anon_sym_snorm] = ACTIONS(3310),
    [anon_sym_unorm] = ACTIONS(3310),
    [anon_sym_point] = ACTIONS(3310),
    [anon_sym_line] = ACTIONS(3310),
    [anon_sym_triangleadj] = ACTIONS(3310),
    [anon_sym_lineadj] = ACTIONS(3310),
    [anon_sym_triangle] = ACTIONS(3310),
    [anon_sym_cbuffer] = ACTIONS(3310),
    [anon_sym_interface] = ACTIONS(3310),
    [anon_sym_extension] = ACTIONS(3310),
    [anon_sym___exported] = ACTIONS(3310),
    [anon_sym_import] = ACTIONS(3310),
  },
  [558] = {
    [ts_builtin_sym_end] = ACTIONS(3160),
    [sym_identifier] = ACTIONS(3158),
    [aux_sym_preproc_include_token1] = ACTIONS(3158),
    [aux_sym_preproc_def_token1] = ACTIONS(3158),
    [aux_sym_preproc_if_token1] = ACTIONS(3158),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3158),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3158),
    [sym_preproc_directive] = ACTIONS(3158),
    [anon_sym_LPAREN2] = ACTIONS(3160),
    [anon_sym_BANG] = ACTIONS(3160),
    [anon_sym_TILDE] = ACTIONS(3160),
    [anon_sym_DASH] = ACTIONS(3158),
    [anon_sym_PLUS] = ACTIONS(3158),
    [anon_sym_STAR] = ACTIONS(3160),
    [anon_sym_AMP_AMP] = ACTIONS(3160),
    [anon_sym_AMP] = ACTIONS(3158),
    [anon_sym_SEMI] = ACTIONS(3160),
    [anon_sym___extension__] = ACTIONS(3158),
    [anon_sym_typedef] = ACTIONS(3158),
    [anon_sym_in] = ACTIONS(3158),
    [anon_sym_out] = ACTIONS(3158),
    [anon_sym_inout] = ACTIONS(3158),
    [anon_sym_extern] = ACTIONS(3158),
    [anon_sym___attribute__] = ACTIONS(3158),
    [anon_sym_COLON_COLON] = ACTIONS(3160),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3160),
    [anon_sym___declspec] = ACTIONS(3158),
    [anon_sym___based] = ACTIONS(3158),
    [anon_sym___cdecl] = ACTIONS(3158),
    [anon_sym___clrcall] = ACTIONS(3158),
    [anon_sym___stdcall] = ACTIONS(3158),
    [anon_sym___fastcall] = ACTIONS(3158),
    [anon_sym___thiscall] = ACTIONS(3158),
    [anon_sym___vectorcall] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3160),
    [anon_sym_signed] = ACTIONS(3158),
    [anon_sym_unsigned] = ACTIONS(3158),
    [anon_sym_long] = ACTIONS(3158),
    [anon_sym_short] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_static] = ACTIONS(3158),
    [anon_sym_register] = ACTIONS(3158),
    [anon_sym_inline] = ACTIONS(3158),
    [anon_sym___inline] = ACTIONS(3158),
    [anon_sym___inline__] = ACTIONS(3158),
    [anon_sym___forceinline] = ACTIONS(3158),
    [anon_sym_thread_local] = ACTIONS(3158),
    [anon_sym___thread] = ACTIONS(3158),
    [anon_sym_const] = ACTIONS(3158),
    [anon_sym_constexpr] = ACTIONS(3158),
    [anon_sym_volatile] = ACTIONS(3158),
    [anon_sym_restrict] = ACTIONS(3158),
    [anon_sym___restrict__] = ACTIONS(3158),
    [anon_sym__Atomic] = ACTIONS(3158),
    [anon_sym__Noreturn] = ACTIONS(3158),
    [anon_sym_noreturn] = ACTIONS(3158),
    [anon_sym_mutable] = ACTIONS(3158),
    [anon_sym_constinit] = ACTIONS(3158),
    [anon_sym_consteval] = ACTIONS(3158),
    [anon_sym_alignas] = ACTIONS(3158),
    [anon_sym__Alignas] = ACTIONS(3158),
    [sym_primitive_type] = ACTIONS(3158),
    [anon_sym_enum] = ACTIONS(3158),
    [anon_sym_class] = ACTIONS(3158),
    [anon_sym_struct] = ACTIONS(3158),
    [anon_sym_union] = ACTIONS(3158),
    [anon_sym_if] = ACTIONS(3158),
    [anon_sym_else] = ACTIONS(3158),
    [anon_sym_switch] = ACTIONS(3158),
    [anon_sym_case] = ACTIONS(3158),
    [anon_sym_default] = ACTIONS(3158),
    [anon_sym_while] = ACTIONS(3158),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_for] = ACTIONS(3158),
    [anon_sym_return] = ACTIONS(3158),
    [anon_sym_break] = ACTIONS(3158),
    [anon_sym_continue] = ACTIONS(3158),
    [anon_sym_goto] = ACTIONS(3158),
    [anon_sym___try] = ACTIONS(3158),
    [anon_sym___leave] = ACTIONS(3158),
    [anon_sym_not] = ACTIONS(3158),
    [anon_sym_compl] = ACTIONS(3158),
    [anon_sym_DASH_DASH] = ACTIONS(3160),
    [anon_sym_PLUS_PLUS] = ACTIONS(3160),
    [anon_sym_sizeof] = ACTIONS(3158),
    [anon_sym___alignof__] = ACTIONS(3158),
    [anon_sym___alignof] = ACTIONS(3158),
    [anon_sym__alignof] = ACTIONS(3158),
    [anon_sym_alignof] = ACTIONS(3158),
    [anon_sym__Alignof] = ACTIONS(3158),
    [anon_sym_offsetof] = ACTIONS(3158),
    [anon_sym__Generic] = ACTIONS(3158),
    [anon_sym_asm] = ACTIONS(3158),
    [anon_sym___asm__] = ACTIONS(3158),
    [sym_number_literal] = ACTIONS(3160),
    [anon_sym_L_SQUOTE] = ACTIONS(3160),
    [anon_sym_u_SQUOTE] = ACTIONS(3160),
    [anon_sym_U_SQUOTE] = ACTIONS(3160),
    [anon_sym_u8_SQUOTE] = ACTIONS(3160),
    [anon_sym_SQUOTE] = ACTIONS(3160),
    [anon_sym_L_DQUOTE] = ACTIONS(3160),
    [anon_sym_u_DQUOTE] = ACTIONS(3160),
    [anon_sym_U_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8_DQUOTE] = ACTIONS(3160),
    [anon_sym_DQUOTE] = ACTIONS(3160),
    [sym_true] = ACTIONS(3158),
    [sym_false] = ACTIONS(3158),
    [anon_sym_NULL] = ACTIONS(3158),
    [anon_sym_nullptr] = ACTIONS(3158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3158),
    [anon_sym_let] = ACTIONS(3158),
    [anon_sym_This] = ACTIONS(3158),
    [anon_sym_decltype] = ACTIONS(3158),
    [sym_virtual] = ACTIONS(3158),
    [anon_sym_explicit] = ACTIONS(3158),
    [anon_sym_typename] = ACTIONS(3158),
    [anon_sym_template] = ACTIONS(3158),
    [anon_sym_operator] = ACTIONS(3158),
    [anon_sym_try] = ACTIONS(3158),
    [anon_sym_delete] = ACTIONS(3158),
    [anon_sym_throw] = ACTIONS(3158),
    [anon_sym_namespace] = ACTIONS(3158),
    [anon_sym_using] = ACTIONS(3158),
    [anon_sym_static_assert] = ACTIONS(3158),
    [anon_sym_concept] = ACTIONS(3158),
    [anon_sym_co_return] = ACTIONS(3158),
    [anon_sym_co_yield] = ACTIONS(3158),
    [anon_sym_R_DQUOTE] = ACTIONS(3160),
    [anon_sym_LR_DQUOTE] = ACTIONS(3160),
    [anon_sym_uR_DQUOTE] = ACTIONS(3160),
    [anon_sym_UR_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3160),
    [anon_sym_co_await] = ACTIONS(3158),
    [anon_sym_new] = ACTIONS(3158),
    [anon_sym_requires] = ACTIONS(3158),
    [sym_this] = ACTIONS(3158),
    [anon_sym_discard] = ACTIONS(3158),
    [anon_sym_precise] = ACTIONS(3158),
    [anon_sym_shared] = ACTIONS(3158),
    [anon_sym_groupshared] = ACTIONS(3158),
    [anon_sym_uniform] = ACTIONS(3158),
    [anon_sym_row_major] = ACTIONS(3158),
    [anon_sym_column_major] = ACTIONS(3158),
    [anon_sym_globallycoherent] = ACTIONS(3158),
    [anon_sym_centroid] = ACTIONS(3158),
    [anon_sym_noperspective] = ACTIONS(3158),
    [anon_sym_nointerpolation] = ACTIONS(3158),
    [anon_sym_sample] = ACTIONS(3158),
    [anon_sym_linear] = ACTIONS(3158),
    [anon_sym_snorm] = ACTIONS(3158),
    [anon_sym_unorm] = ACTIONS(3158),
    [anon_sym_point] = ACTIONS(3158),
    [anon_sym_line] = ACTIONS(3158),
    [anon_sym_triangleadj] = ACTIONS(3158),
    [anon_sym_lineadj] = ACTIONS(3158),
    [anon_sym_triangle] = ACTIONS(3158),
    [anon_sym_cbuffer] = ACTIONS(3158),
    [anon_sym_interface] = ACTIONS(3158),
    [anon_sym_extension] = ACTIONS(3158),
    [anon_sym___exported] = ACTIONS(3158),
    [anon_sym_import] = ACTIONS(3158),
  },
  [559] = {
    [sym_catch_clause] = STATE(531),
    [aux_sym_constructor_try_statement_repeat1] = STATE(531),
    [sym_identifier] = ACTIONS(2830),
    [aux_sym_preproc_include_token1] = ACTIONS(2830),
    [aux_sym_preproc_def_token1] = ACTIONS(2830),
    [aux_sym_preproc_if_token1] = ACTIONS(2830),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2830),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2830),
    [sym_preproc_directive] = ACTIONS(2830),
    [anon_sym_LPAREN2] = ACTIONS(2832),
    [anon_sym_BANG] = ACTIONS(2832),
    [anon_sym_TILDE] = ACTIONS(2832),
    [anon_sym_DASH] = ACTIONS(2830),
    [anon_sym_PLUS] = ACTIONS(2830),
    [anon_sym_STAR] = ACTIONS(2832),
    [anon_sym_AMP_AMP] = ACTIONS(2832),
    [anon_sym_AMP] = ACTIONS(2830),
    [anon_sym_SEMI] = ACTIONS(2832),
    [anon_sym___extension__] = ACTIONS(2830),
    [anon_sym_typedef] = ACTIONS(2830),
    [anon_sym_in] = ACTIONS(2830),
    [anon_sym_out] = ACTIONS(2830),
    [anon_sym_inout] = ACTIONS(2830),
    [anon_sym_extern] = ACTIONS(2830),
    [anon_sym___attribute__] = ACTIONS(2830),
    [anon_sym_COLON_COLON] = ACTIONS(2832),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2832),
    [anon_sym___declspec] = ACTIONS(2830),
    [anon_sym___based] = ACTIONS(2830),
    [anon_sym___cdecl] = ACTIONS(2830),
    [anon_sym___clrcall] = ACTIONS(2830),
    [anon_sym___stdcall] = ACTIONS(2830),
    [anon_sym___fastcall] = ACTIONS(2830),
    [anon_sym___thiscall] = ACTIONS(2830),
    [anon_sym___vectorcall] = ACTIONS(2830),
    [anon_sym_LBRACE] = ACTIONS(2832),
    [anon_sym_RBRACE] = ACTIONS(2832),
    [anon_sym_signed] = ACTIONS(2830),
    [anon_sym_unsigned] = ACTIONS(2830),
    [anon_sym_long] = ACTIONS(2830),
    [anon_sym_short] = ACTIONS(2830),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [anon_sym_static] = ACTIONS(2830),
    [anon_sym_register] = ACTIONS(2830),
    [anon_sym_inline] = ACTIONS(2830),
    [anon_sym___inline] = ACTIONS(2830),
    [anon_sym___inline__] = ACTIONS(2830),
    [anon_sym___forceinline] = ACTIONS(2830),
    [anon_sym_thread_local] = ACTIONS(2830),
    [anon_sym___thread] = ACTIONS(2830),
    [anon_sym_const] = ACTIONS(2830),
    [anon_sym_constexpr] = ACTIONS(2830),
    [anon_sym_volatile] = ACTIONS(2830),
    [anon_sym_restrict] = ACTIONS(2830),
    [anon_sym___restrict__] = ACTIONS(2830),
    [anon_sym__Atomic] = ACTIONS(2830),
    [anon_sym__Noreturn] = ACTIONS(2830),
    [anon_sym_noreturn] = ACTIONS(2830),
    [anon_sym_mutable] = ACTIONS(2830),
    [anon_sym_constinit] = ACTIONS(2830),
    [anon_sym_consteval] = ACTIONS(2830),
    [anon_sym_alignas] = ACTIONS(2830),
    [anon_sym__Alignas] = ACTIONS(2830),
    [sym_primitive_type] = ACTIONS(2830),
    [anon_sym_enum] = ACTIONS(2830),
    [anon_sym_class] = ACTIONS(2830),
    [anon_sym_struct] = ACTIONS(2830),
    [anon_sym_union] = ACTIONS(2830),
    [anon_sym_if] = ACTIONS(2830),
    [anon_sym_switch] = ACTIONS(2830),
    [anon_sym_case] = ACTIONS(2830),
    [anon_sym_default] = ACTIONS(2830),
    [anon_sym_while] = ACTIONS(2830),
    [anon_sym_do] = ACTIONS(2830),
    [anon_sym_for] = ACTIONS(2830),
    [anon_sym_return] = ACTIONS(2830),
    [anon_sym_break] = ACTIONS(2830),
    [anon_sym_continue] = ACTIONS(2830),
    [anon_sym_goto] = ACTIONS(2830),
    [anon_sym___try] = ACTIONS(2830),
    [anon_sym___leave] = ACTIONS(2830),
    [anon_sym_not] = ACTIONS(2830),
    [anon_sym_compl] = ACTIONS(2830),
    [anon_sym_DASH_DASH] = ACTIONS(2832),
    [anon_sym_PLUS_PLUS] = ACTIONS(2832),
    [anon_sym_sizeof] = ACTIONS(2830),
    [anon_sym___alignof__] = ACTIONS(2830),
    [anon_sym___alignof] = ACTIONS(2830),
    [anon_sym__alignof] = ACTIONS(2830),
    [anon_sym_alignof] = ACTIONS(2830),
    [anon_sym__Alignof] = ACTIONS(2830),
    [anon_sym_offsetof] = ACTIONS(2830),
    [anon_sym__Generic] = ACTIONS(2830),
    [anon_sym_asm] = ACTIONS(2830),
    [anon_sym___asm__] = ACTIONS(2830),
    [sym_number_literal] = ACTIONS(2832),
    [anon_sym_L_SQUOTE] = ACTIONS(2832),
    [anon_sym_u_SQUOTE] = ACTIONS(2832),
    [anon_sym_U_SQUOTE] = ACTIONS(2832),
    [anon_sym_u8_SQUOTE] = ACTIONS(2832),
    [anon_sym_SQUOTE] = ACTIONS(2832),
    [anon_sym_L_DQUOTE] = ACTIONS(2832),
    [anon_sym_u_DQUOTE] = ACTIONS(2832),
    [anon_sym_U_DQUOTE] = ACTIONS(2832),
    [anon_sym_u8_DQUOTE] = ACTIONS(2832),
    [anon_sym_DQUOTE] = ACTIONS(2832),
    [sym_true] = ACTIONS(2830),
    [sym_false] = ACTIONS(2830),
    [anon_sym_NULL] = ACTIONS(2830),
    [anon_sym_nullptr] = ACTIONS(2830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2830),
    [anon_sym_let] = ACTIONS(2830),
    [anon_sym_This] = ACTIONS(2830),
    [anon_sym_decltype] = ACTIONS(2830),
    [sym_virtual] = ACTIONS(2830),
    [anon_sym_explicit] = ACTIONS(2830),
    [anon_sym_typename] = ACTIONS(2830),
    [anon_sym_template] = ACTIONS(2830),
    [anon_sym_operator] = ACTIONS(2830),
    [anon_sym_try] = ACTIONS(2830),
    [anon_sym_delete] = ACTIONS(2830),
    [anon_sym_throw] = ACTIONS(2830),
    [anon_sym_namespace] = ACTIONS(2830),
    [anon_sym_using] = ACTIONS(2830),
    [anon_sym_static_assert] = ACTIONS(2830),
    [anon_sym_concept] = ACTIONS(2830),
    [anon_sym_co_return] = ACTIONS(2830),
    [anon_sym_co_yield] = ACTIONS(2830),
    [anon_sym_catch] = ACTIONS(3689),
    [anon_sym_R_DQUOTE] = ACTIONS(2832),
    [anon_sym_LR_DQUOTE] = ACTIONS(2832),
    [anon_sym_uR_DQUOTE] = ACTIONS(2832),
    [anon_sym_UR_DQUOTE] = ACTIONS(2832),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2832),
    [anon_sym_co_await] = ACTIONS(2830),
    [anon_sym_new] = ACTIONS(2830),
    [anon_sym_requires] = ACTIONS(2830),
    [sym_this] = ACTIONS(2830),
    [anon_sym_discard] = ACTIONS(2830),
    [anon_sym_precise] = ACTIONS(2830),
    [anon_sym_shared] = ACTIONS(2830),
    [anon_sym_groupshared] = ACTIONS(2830),
    [anon_sym_uniform] = ACTIONS(2830),
    [anon_sym_row_major] = ACTIONS(2830),
    [anon_sym_column_major] = ACTIONS(2830),
    [anon_sym_globallycoherent] = ACTIONS(2830),
    [anon_sym_centroid] = ACTIONS(2830),
    [anon_sym_noperspective] = ACTIONS(2830),
    [anon_sym_nointerpolation] = ACTIONS(2830),
    [anon_sym_sample] = ACTIONS(2830),
    [anon_sym_linear] = ACTIONS(2830),
    [anon_sym_snorm] = ACTIONS(2830),
    [anon_sym_unorm] = ACTIONS(2830),
    [anon_sym_point] = ACTIONS(2830),
    [anon_sym_line] = ACTIONS(2830),
    [anon_sym_triangleadj] = ACTIONS(2830),
    [anon_sym_lineadj] = ACTIONS(2830),
    [anon_sym_triangle] = ACTIONS(2830),
    [anon_sym_cbuffer] = ACTIONS(2830),
    [anon_sym_interface] = ACTIONS(2830),
    [anon_sym_extension] = ACTIONS(2830),
  },
  [560] = {
    [ts_builtin_sym_end] = ACTIONS(3094),
    [sym_identifier] = ACTIONS(3092),
    [aux_sym_preproc_include_token1] = ACTIONS(3092),
    [aux_sym_preproc_def_token1] = ACTIONS(3092),
    [aux_sym_preproc_if_token1] = ACTIONS(3092),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3092),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3092),
    [sym_preproc_directive] = ACTIONS(3092),
    [anon_sym_LPAREN2] = ACTIONS(3094),
    [anon_sym_BANG] = ACTIONS(3094),
    [anon_sym_TILDE] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_STAR] = ACTIONS(3094),
    [anon_sym_AMP_AMP] = ACTIONS(3094),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_SEMI] = ACTIONS(3094),
    [anon_sym___extension__] = ACTIONS(3092),
    [anon_sym_typedef] = ACTIONS(3092),
    [anon_sym_in] = ACTIONS(3092),
    [anon_sym_out] = ACTIONS(3092),
    [anon_sym_inout] = ACTIONS(3092),
    [anon_sym_extern] = ACTIONS(3092),
    [anon_sym___attribute__] = ACTIONS(3092),
    [anon_sym_COLON_COLON] = ACTIONS(3094),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3094),
    [anon_sym___declspec] = ACTIONS(3092),
    [anon_sym___based] = ACTIONS(3092),
    [anon_sym___cdecl] = ACTIONS(3092),
    [anon_sym___clrcall] = ACTIONS(3092),
    [anon_sym___stdcall] = ACTIONS(3092),
    [anon_sym___fastcall] = ACTIONS(3092),
    [anon_sym___thiscall] = ACTIONS(3092),
    [anon_sym___vectorcall] = ACTIONS(3092),
    [anon_sym_LBRACE] = ACTIONS(3094),
    [anon_sym_signed] = ACTIONS(3092),
    [anon_sym_unsigned] = ACTIONS(3092),
    [anon_sym_long] = ACTIONS(3092),
    [anon_sym_short] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_static] = ACTIONS(3092),
    [anon_sym_register] = ACTIONS(3092),
    [anon_sym_inline] = ACTIONS(3092),
    [anon_sym___inline] = ACTIONS(3092),
    [anon_sym___inline__] = ACTIONS(3092),
    [anon_sym___forceinline] = ACTIONS(3092),
    [anon_sym_thread_local] = ACTIONS(3092),
    [anon_sym___thread] = ACTIONS(3092),
    [anon_sym_const] = ACTIONS(3092),
    [anon_sym_constexpr] = ACTIONS(3092),
    [anon_sym_volatile] = ACTIONS(3092),
    [anon_sym_restrict] = ACTIONS(3092),
    [anon_sym___restrict__] = ACTIONS(3092),
    [anon_sym__Atomic] = ACTIONS(3092),
    [anon_sym__Noreturn] = ACTIONS(3092),
    [anon_sym_noreturn] = ACTIONS(3092),
    [anon_sym_mutable] = ACTIONS(3092),
    [anon_sym_constinit] = ACTIONS(3092),
    [anon_sym_consteval] = ACTIONS(3092),
    [anon_sym_alignas] = ACTIONS(3092),
    [anon_sym__Alignas] = ACTIONS(3092),
    [sym_primitive_type] = ACTIONS(3092),
    [anon_sym_enum] = ACTIONS(3092),
    [anon_sym_class] = ACTIONS(3092),
    [anon_sym_struct] = ACTIONS(3092),
    [anon_sym_union] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_else] = ACTIONS(3092),
    [anon_sym_switch] = ACTIONS(3092),
    [anon_sym_case] = ACTIONS(3092),
    [anon_sym_default] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_break] = ACTIONS(3092),
    [anon_sym_continue] = ACTIONS(3092),
    [anon_sym_goto] = ACTIONS(3092),
    [anon_sym___try] = ACTIONS(3092),
    [anon_sym___leave] = ACTIONS(3092),
    [anon_sym_not] = ACTIONS(3092),
    [anon_sym_compl] = ACTIONS(3092),
    [anon_sym_DASH_DASH] = ACTIONS(3094),
    [anon_sym_PLUS_PLUS] = ACTIONS(3094),
    [anon_sym_sizeof] = ACTIONS(3092),
    [anon_sym___alignof__] = ACTIONS(3092),
    [anon_sym___alignof] = ACTIONS(3092),
    [anon_sym__alignof] = ACTIONS(3092),
    [anon_sym_alignof] = ACTIONS(3092),
    [anon_sym__Alignof] = ACTIONS(3092),
    [anon_sym_offsetof] = ACTIONS(3092),
    [anon_sym__Generic] = ACTIONS(3092),
    [anon_sym_asm] = ACTIONS(3092),
    [anon_sym___asm__] = ACTIONS(3092),
    [sym_number_literal] = ACTIONS(3094),
    [anon_sym_L_SQUOTE] = ACTIONS(3094),
    [anon_sym_u_SQUOTE] = ACTIONS(3094),
    [anon_sym_U_SQUOTE] = ACTIONS(3094),
    [anon_sym_u8_SQUOTE] = ACTIONS(3094),
    [anon_sym_SQUOTE] = ACTIONS(3094),
    [anon_sym_L_DQUOTE] = ACTIONS(3094),
    [anon_sym_u_DQUOTE] = ACTIONS(3094),
    [anon_sym_U_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8_DQUOTE] = ACTIONS(3094),
    [anon_sym_DQUOTE] = ACTIONS(3094),
    [sym_true] = ACTIONS(3092),
    [sym_false] = ACTIONS(3092),
    [anon_sym_NULL] = ACTIONS(3092),
    [anon_sym_nullptr] = ACTIONS(3092),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3092),
    [anon_sym_let] = ACTIONS(3092),
    [anon_sym_This] = ACTIONS(3092),
    [anon_sym_decltype] = ACTIONS(3092),
    [sym_virtual] = ACTIONS(3092),
    [anon_sym_explicit] = ACTIONS(3092),
    [anon_sym_typename] = ACTIONS(3092),
    [anon_sym_template] = ACTIONS(3092),
    [anon_sym_operator] = ACTIONS(3092),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_delete] = ACTIONS(3092),
    [anon_sym_throw] = ACTIONS(3092),
    [anon_sym_namespace] = ACTIONS(3092),
    [anon_sym_using] = ACTIONS(3092),
    [anon_sym_static_assert] = ACTIONS(3092),
    [anon_sym_concept] = ACTIONS(3092),
    [anon_sym_co_return] = ACTIONS(3092),
    [anon_sym_co_yield] = ACTIONS(3092),
    [anon_sym_R_DQUOTE] = ACTIONS(3094),
    [anon_sym_LR_DQUOTE] = ACTIONS(3094),
    [anon_sym_uR_DQUOTE] = ACTIONS(3094),
    [anon_sym_UR_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3094),
    [anon_sym_co_await] = ACTIONS(3092),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_requires] = ACTIONS(3092),
    [sym_this] = ACTIONS(3092),
    [anon_sym_discard] = ACTIONS(3092),
    [anon_sym_precise] = ACTIONS(3092),
    [anon_sym_shared] = ACTIONS(3092),
    [anon_sym_groupshared] = ACTIONS(3092),
    [anon_sym_uniform] = ACTIONS(3092),
    [anon_sym_row_major] = ACTIONS(3092),
    [anon_sym_column_major] = ACTIONS(3092),
    [anon_sym_globallycoherent] = ACTIONS(3092),
    [anon_sym_centroid] = ACTIONS(3092),
    [anon_sym_noperspective] = ACTIONS(3092),
    [anon_sym_nointerpolation] = ACTIONS(3092),
    [anon_sym_sample] = ACTIONS(3092),
    [anon_sym_linear] = ACTIONS(3092),
    [anon_sym_snorm] = ACTIONS(3092),
    [anon_sym_unorm] = ACTIONS(3092),
    [anon_sym_point] = ACTIONS(3092),
    [anon_sym_line] = ACTIONS(3092),
    [anon_sym_triangleadj] = ACTIONS(3092),
    [anon_sym_lineadj] = ACTIONS(3092),
    [anon_sym_triangle] = ACTIONS(3092),
    [anon_sym_cbuffer] = ACTIONS(3092),
    [anon_sym_interface] = ACTIONS(3092),
    [anon_sym_extension] = ACTIONS(3092),
    [anon_sym___exported] = ACTIONS(3092),
    [anon_sym_import] = ACTIONS(3092),
  },
  [561] = {
    [ts_builtin_sym_end] = ACTIONS(3252),
    [sym_identifier] = ACTIONS(3250),
    [aux_sym_preproc_include_token1] = ACTIONS(3250),
    [aux_sym_preproc_def_token1] = ACTIONS(3250),
    [aux_sym_preproc_if_token1] = ACTIONS(3250),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3250),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3250),
    [sym_preproc_directive] = ACTIONS(3250),
    [anon_sym_LPAREN2] = ACTIONS(3252),
    [anon_sym_BANG] = ACTIONS(3252),
    [anon_sym_TILDE] = ACTIONS(3252),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_STAR] = ACTIONS(3252),
    [anon_sym_AMP_AMP] = ACTIONS(3252),
    [anon_sym_AMP] = ACTIONS(3250),
    [anon_sym_SEMI] = ACTIONS(3252),
    [anon_sym___extension__] = ACTIONS(3250),
    [anon_sym_typedef] = ACTIONS(3250),
    [anon_sym_in] = ACTIONS(3250),
    [anon_sym_out] = ACTIONS(3250),
    [anon_sym_inout] = ACTIONS(3250),
    [anon_sym_extern] = ACTIONS(3250),
    [anon_sym___attribute__] = ACTIONS(3250),
    [anon_sym_COLON_COLON] = ACTIONS(3252),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3252),
    [anon_sym___declspec] = ACTIONS(3250),
    [anon_sym___based] = ACTIONS(3250),
    [anon_sym___cdecl] = ACTIONS(3250),
    [anon_sym___clrcall] = ACTIONS(3250),
    [anon_sym___stdcall] = ACTIONS(3250),
    [anon_sym___fastcall] = ACTIONS(3250),
    [anon_sym___thiscall] = ACTIONS(3250),
    [anon_sym___vectorcall] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3252),
    [anon_sym_signed] = ACTIONS(3250),
    [anon_sym_unsigned] = ACTIONS(3250),
    [anon_sym_long] = ACTIONS(3250),
    [anon_sym_short] = ACTIONS(3250),
    [anon_sym_LBRACK] = ACTIONS(3250),
    [anon_sym_static] = ACTIONS(3250),
    [anon_sym_register] = ACTIONS(3250),
    [anon_sym_inline] = ACTIONS(3250),
    [anon_sym___inline] = ACTIONS(3250),
    [anon_sym___inline__] = ACTIONS(3250),
    [anon_sym___forceinline] = ACTIONS(3250),
    [anon_sym_thread_local] = ACTIONS(3250),
    [anon_sym___thread] = ACTIONS(3250),
    [anon_sym_const] = ACTIONS(3250),
    [anon_sym_constexpr] = ACTIONS(3250),
    [anon_sym_volatile] = ACTIONS(3250),
    [anon_sym_restrict] = ACTIONS(3250),
    [anon_sym___restrict__] = ACTIONS(3250),
    [anon_sym__Atomic] = ACTIONS(3250),
    [anon_sym__Noreturn] = ACTIONS(3250),
    [anon_sym_noreturn] = ACTIONS(3250),
    [anon_sym_mutable] = ACTIONS(3250),
    [anon_sym_constinit] = ACTIONS(3250),
    [anon_sym_consteval] = ACTIONS(3250),
    [anon_sym_alignas] = ACTIONS(3250),
    [anon_sym__Alignas] = ACTIONS(3250),
    [sym_primitive_type] = ACTIONS(3250),
    [anon_sym_enum] = ACTIONS(3250),
    [anon_sym_class] = ACTIONS(3250),
    [anon_sym_struct] = ACTIONS(3250),
    [anon_sym_union] = ACTIONS(3250),
    [anon_sym_if] = ACTIONS(3250),
    [anon_sym_else] = ACTIONS(3250),
    [anon_sym_switch] = ACTIONS(3250),
    [anon_sym_case] = ACTIONS(3250),
    [anon_sym_default] = ACTIONS(3250),
    [anon_sym_while] = ACTIONS(3250),
    [anon_sym_do] = ACTIONS(3250),
    [anon_sym_for] = ACTIONS(3250),
    [anon_sym_return] = ACTIONS(3250),
    [anon_sym_break] = ACTIONS(3250),
    [anon_sym_continue] = ACTIONS(3250),
    [anon_sym_goto] = ACTIONS(3250),
    [anon_sym___try] = ACTIONS(3250),
    [anon_sym___leave] = ACTIONS(3250),
    [anon_sym_not] = ACTIONS(3250),
    [anon_sym_compl] = ACTIONS(3250),
    [anon_sym_DASH_DASH] = ACTIONS(3252),
    [anon_sym_PLUS_PLUS] = ACTIONS(3252),
    [anon_sym_sizeof] = ACTIONS(3250),
    [anon_sym___alignof__] = ACTIONS(3250),
    [anon_sym___alignof] = ACTIONS(3250),
    [anon_sym__alignof] = ACTIONS(3250),
    [anon_sym_alignof] = ACTIONS(3250),
    [anon_sym__Alignof] = ACTIONS(3250),
    [anon_sym_offsetof] = ACTIONS(3250),
    [anon_sym__Generic] = ACTIONS(3250),
    [anon_sym_asm] = ACTIONS(3250),
    [anon_sym___asm__] = ACTIONS(3250),
    [sym_number_literal] = ACTIONS(3252),
    [anon_sym_L_SQUOTE] = ACTIONS(3252),
    [anon_sym_u_SQUOTE] = ACTIONS(3252),
    [anon_sym_U_SQUOTE] = ACTIONS(3252),
    [anon_sym_u8_SQUOTE] = ACTIONS(3252),
    [anon_sym_SQUOTE] = ACTIONS(3252),
    [anon_sym_L_DQUOTE] = ACTIONS(3252),
    [anon_sym_u_DQUOTE] = ACTIONS(3252),
    [anon_sym_U_DQUOTE] = ACTIONS(3252),
    [anon_sym_u8_DQUOTE] = ACTIONS(3252),
    [anon_sym_DQUOTE] = ACTIONS(3252),
    [sym_true] = ACTIONS(3250),
    [sym_false] = ACTIONS(3250),
    [anon_sym_NULL] = ACTIONS(3250),
    [anon_sym_nullptr] = ACTIONS(3250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3250),
    [anon_sym_let] = ACTIONS(3250),
    [anon_sym_This] = ACTIONS(3250),
    [anon_sym_decltype] = ACTIONS(3250),
    [sym_virtual] = ACTIONS(3250),
    [anon_sym_explicit] = ACTIONS(3250),
    [anon_sym_typename] = ACTIONS(3250),
    [anon_sym_template] = ACTIONS(3250),
    [anon_sym_operator] = ACTIONS(3250),
    [anon_sym_try] = ACTIONS(3250),
    [anon_sym_delete] = ACTIONS(3250),
    [anon_sym_throw] = ACTIONS(3250),
    [anon_sym_namespace] = ACTIONS(3250),
    [anon_sym_using] = ACTIONS(3250),
    [anon_sym_static_assert] = ACTIONS(3250),
    [anon_sym_concept] = ACTIONS(3250),
    [anon_sym_co_return] = ACTIONS(3250),
    [anon_sym_co_yield] = ACTIONS(3250),
    [anon_sym_R_DQUOTE] = ACTIONS(3252),
    [anon_sym_LR_DQUOTE] = ACTIONS(3252),
    [anon_sym_uR_DQUOTE] = ACTIONS(3252),
    [anon_sym_UR_DQUOTE] = ACTIONS(3252),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3252),
    [anon_sym_co_await] = ACTIONS(3250),
    [anon_sym_new] = ACTIONS(3250),
    [anon_sym_requires] = ACTIONS(3250),
    [sym_this] = ACTIONS(3250),
    [anon_sym_discard] = ACTIONS(3250),
    [anon_sym_precise] = ACTIONS(3250),
    [anon_sym_shared] = ACTIONS(3250),
    [anon_sym_groupshared] = ACTIONS(3250),
    [anon_sym_uniform] = ACTIONS(3250),
    [anon_sym_row_major] = ACTIONS(3250),
    [anon_sym_column_major] = ACTIONS(3250),
    [anon_sym_globallycoherent] = ACTIONS(3250),
    [anon_sym_centroid] = ACTIONS(3250),
    [anon_sym_noperspective] = ACTIONS(3250),
    [anon_sym_nointerpolation] = ACTIONS(3250),
    [anon_sym_sample] = ACTIONS(3250),
    [anon_sym_linear] = ACTIONS(3250),
    [anon_sym_snorm] = ACTIONS(3250),
    [anon_sym_unorm] = ACTIONS(3250),
    [anon_sym_point] = ACTIONS(3250),
    [anon_sym_line] = ACTIONS(3250),
    [anon_sym_triangleadj] = ACTIONS(3250),
    [anon_sym_lineadj] = ACTIONS(3250),
    [anon_sym_triangle] = ACTIONS(3250),
    [anon_sym_cbuffer] = ACTIONS(3250),
    [anon_sym_interface] = ACTIONS(3250),
    [anon_sym_extension] = ACTIONS(3250),
    [anon_sym___exported] = ACTIONS(3250),
    [anon_sym_import] = ACTIONS(3250),
  },
  [562] = {
    [sym_catch_clause] = STATE(445),
    [aux_sym_constructor_try_statement_repeat1] = STATE(445),
    [sym_identifier] = ACTIONS(2830),
    [aux_sym_preproc_include_token1] = ACTIONS(2830),
    [aux_sym_preproc_def_token1] = ACTIONS(2830),
    [aux_sym_preproc_if_token1] = ACTIONS(2830),
    [aux_sym_preproc_if_token2] = ACTIONS(2830),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2830),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2830),
    [sym_preproc_directive] = ACTIONS(2830),
    [anon_sym_LPAREN2] = ACTIONS(2832),
    [anon_sym_BANG] = ACTIONS(2832),
    [anon_sym_TILDE] = ACTIONS(2832),
    [anon_sym_DASH] = ACTIONS(2830),
    [anon_sym_PLUS] = ACTIONS(2830),
    [anon_sym_STAR] = ACTIONS(2832),
    [anon_sym_AMP_AMP] = ACTIONS(2832),
    [anon_sym_AMP] = ACTIONS(2830),
    [anon_sym_SEMI] = ACTIONS(2832),
    [anon_sym___extension__] = ACTIONS(2830),
    [anon_sym_typedef] = ACTIONS(2830),
    [anon_sym_in] = ACTIONS(2830),
    [anon_sym_out] = ACTIONS(2830),
    [anon_sym_inout] = ACTIONS(2830),
    [anon_sym_extern] = ACTIONS(2830),
    [anon_sym___attribute__] = ACTIONS(2830),
    [anon_sym_COLON_COLON] = ACTIONS(2832),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2832),
    [anon_sym___declspec] = ACTIONS(2830),
    [anon_sym___based] = ACTIONS(2830),
    [anon_sym___cdecl] = ACTIONS(2830),
    [anon_sym___clrcall] = ACTIONS(2830),
    [anon_sym___stdcall] = ACTIONS(2830),
    [anon_sym___fastcall] = ACTIONS(2830),
    [anon_sym___thiscall] = ACTIONS(2830),
    [anon_sym___vectorcall] = ACTIONS(2830),
    [anon_sym_LBRACE] = ACTIONS(2832),
    [anon_sym_signed] = ACTIONS(2830),
    [anon_sym_unsigned] = ACTIONS(2830),
    [anon_sym_long] = ACTIONS(2830),
    [anon_sym_short] = ACTIONS(2830),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [anon_sym_static] = ACTIONS(2830),
    [anon_sym_register] = ACTIONS(2830),
    [anon_sym_inline] = ACTIONS(2830),
    [anon_sym___inline] = ACTIONS(2830),
    [anon_sym___inline__] = ACTIONS(2830),
    [anon_sym___forceinline] = ACTIONS(2830),
    [anon_sym_thread_local] = ACTIONS(2830),
    [anon_sym___thread] = ACTIONS(2830),
    [anon_sym_const] = ACTIONS(2830),
    [anon_sym_constexpr] = ACTIONS(2830),
    [anon_sym_volatile] = ACTIONS(2830),
    [anon_sym_restrict] = ACTIONS(2830),
    [anon_sym___restrict__] = ACTIONS(2830),
    [anon_sym__Atomic] = ACTIONS(2830),
    [anon_sym__Noreturn] = ACTIONS(2830),
    [anon_sym_noreturn] = ACTIONS(2830),
    [anon_sym_mutable] = ACTIONS(2830),
    [anon_sym_constinit] = ACTIONS(2830),
    [anon_sym_consteval] = ACTIONS(2830),
    [anon_sym_alignas] = ACTIONS(2830),
    [anon_sym__Alignas] = ACTIONS(2830),
    [sym_primitive_type] = ACTIONS(2830),
    [anon_sym_enum] = ACTIONS(2830),
    [anon_sym_class] = ACTIONS(2830),
    [anon_sym_struct] = ACTIONS(2830),
    [anon_sym_union] = ACTIONS(2830),
    [anon_sym_if] = ACTIONS(2830),
    [anon_sym_switch] = ACTIONS(2830),
    [anon_sym_case] = ACTIONS(2830),
    [anon_sym_default] = ACTIONS(2830),
    [anon_sym_while] = ACTIONS(2830),
    [anon_sym_do] = ACTIONS(2830),
    [anon_sym_for] = ACTIONS(2830),
    [anon_sym_return] = ACTIONS(2830),
    [anon_sym_break] = ACTIONS(2830),
    [anon_sym_continue] = ACTIONS(2830),
    [anon_sym_goto] = ACTIONS(2830),
    [anon_sym___try] = ACTIONS(2830),
    [anon_sym___leave] = ACTIONS(2830),
    [anon_sym_not] = ACTIONS(2830),
    [anon_sym_compl] = ACTIONS(2830),
    [anon_sym_DASH_DASH] = ACTIONS(2832),
    [anon_sym_PLUS_PLUS] = ACTIONS(2832),
    [anon_sym_sizeof] = ACTIONS(2830),
    [anon_sym___alignof__] = ACTIONS(2830),
    [anon_sym___alignof] = ACTIONS(2830),
    [anon_sym__alignof] = ACTIONS(2830),
    [anon_sym_alignof] = ACTIONS(2830),
    [anon_sym__Alignof] = ACTIONS(2830),
    [anon_sym_offsetof] = ACTIONS(2830),
    [anon_sym__Generic] = ACTIONS(2830),
    [anon_sym_asm] = ACTIONS(2830),
    [anon_sym___asm__] = ACTIONS(2830),
    [sym_number_literal] = ACTIONS(2832),
    [anon_sym_L_SQUOTE] = ACTIONS(2832),
    [anon_sym_u_SQUOTE] = ACTIONS(2832),
    [anon_sym_U_SQUOTE] = ACTIONS(2832),
    [anon_sym_u8_SQUOTE] = ACTIONS(2832),
    [anon_sym_SQUOTE] = ACTIONS(2832),
    [anon_sym_L_DQUOTE] = ACTIONS(2832),
    [anon_sym_u_DQUOTE] = ACTIONS(2832),
    [anon_sym_U_DQUOTE] = ACTIONS(2832),
    [anon_sym_u8_DQUOTE] = ACTIONS(2832),
    [anon_sym_DQUOTE] = ACTIONS(2832),
    [sym_true] = ACTIONS(2830),
    [sym_false] = ACTIONS(2830),
    [anon_sym_NULL] = ACTIONS(2830),
    [anon_sym_nullptr] = ACTIONS(2830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2830),
    [anon_sym_let] = ACTIONS(2830),
    [anon_sym_This] = ACTIONS(2830),
    [anon_sym_decltype] = ACTIONS(2830),
    [sym_virtual] = ACTIONS(2830),
    [anon_sym_explicit] = ACTIONS(2830),
    [anon_sym_typename] = ACTIONS(2830),
    [anon_sym_template] = ACTIONS(2830),
    [anon_sym_operator] = ACTIONS(2830),
    [anon_sym_try] = ACTIONS(2830),
    [anon_sym_delete] = ACTIONS(2830),
    [anon_sym_throw] = ACTIONS(2830),
    [anon_sym_namespace] = ACTIONS(2830),
    [anon_sym_using] = ACTIONS(2830),
    [anon_sym_static_assert] = ACTIONS(2830),
    [anon_sym_concept] = ACTIONS(2830),
    [anon_sym_co_return] = ACTIONS(2830),
    [anon_sym_co_yield] = ACTIONS(2830),
    [anon_sym_catch] = ACTIONS(3529),
    [anon_sym_R_DQUOTE] = ACTIONS(2832),
    [anon_sym_LR_DQUOTE] = ACTIONS(2832),
    [anon_sym_uR_DQUOTE] = ACTIONS(2832),
    [anon_sym_UR_DQUOTE] = ACTIONS(2832),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2832),
    [anon_sym_co_await] = ACTIONS(2830),
    [anon_sym_new] = ACTIONS(2830),
    [anon_sym_requires] = ACTIONS(2830),
    [sym_this] = ACTIONS(2830),
    [anon_sym_discard] = ACTIONS(2830),
    [anon_sym_precise] = ACTIONS(2830),
    [anon_sym_shared] = ACTIONS(2830),
    [anon_sym_groupshared] = ACTIONS(2830),
    [anon_sym_uniform] = ACTIONS(2830),
    [anon_sym_row_major] = ACTIONS(2830),
    [anon_sym_column_major] = ACTIONS(2830),
    [anon_sym_globallycoherent] = ACTIONS(2830),
    [anon_sym_centroid] = ACTIONS(2830),
    [anon_sym_noperspective] = ACTIONS(2830),
    [anon_sym_nointerpolation] = ACTIONS(2830),
    [anon_sym_sample] = ACTIONS(2830),
    [anon_sym_linear] = ACTIONS(2830),
    [anon_sym_snorm] = ACTIONS(2830),
    [anon_sym_unorm] = ACTIONS(2830),
    [anon_sym_point] = ACTIONS(2830),
    [anon_sym_line] = ACTIONS(2830),
    [anon_sym_triangleadj] = ACTIONS(2830),
    [anon_sym_lineadj] = ACTIONS(2830),
    [anon_sym_triangle] = ACTIONS(2830),
    [anon_sym_cbuffer] = ACTIONS(2830),
    [anon_sym_interface] = ACTIONS(2830),
    [anon_sym_extension] = ACTIONS(2830),
  },
  [563] = {
    [ts_builtin_sym_end] = ACTIONS(3164),
    [sym_identifier] = ACTIONS(3162),
    [aux_sym_preproc_include_token1] = ACTIONS(3162),
    [aux_sym_preproc_def_token1] = ACTIONS(3162),
    [aux_sym_preproc_if_token1] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3162),
    [sym_preproc_directive] = ACTIONS(3162),
    [anon_sym_LPAREN2] = ACTIONS(3164),
    [anon_sym_BANG] = ACTIONS(3164),
    [anon_sym_TILDE] = ACTIONS(3164),
    [anon_sym_DASH] = ACTIONS(3162),
    [anon_sym_PLUS] = ACTIONS(3162),
    [anon_sym_STAR] = ACTIONS(3164),
    [anon_sym_AMP_AMP] = ACTIONS(3164),
    [anon_sym_AMP] = ACTIONS(3162),
    [anon_sym_SEMI] = ACTIONS(3164),
    [anon_sym___extension__] = ACTIONS(3162),
    [anon_sym_typedef] = ACTIONS(3162),
    [anon_sym_in] = ACTIONS(3162),
    [anon_sym_out] = ACTIONS(3162),
    [anon_sym_inout] = ACTIONS(3162),
    [anon_sym_extern] = ACTIONS(3162),
    [anon_sym___attribute__] = ACTIONS(3162),
    [anon_sym_COLON_COLON] = ACTIONS(3164),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3164),
    [anon_sym___declspec] = ACTIONS(3162),
    [anon_sym___based] = ACTIONS(3162),
    [anon_sym___cdecl] = ACTIONS(3162),
    [anon_sym___clrcall] = ACTIONS(3162),
    [anon_sym___stdcall] = ACTIONS(3162),
    [anon_sym___fastcall] = ACTIONS(3162),
    [anon_sym___thiscall] = ACTIONS(3162),
    [anon_sym___vectorcall] = ACTIONS(3162),
    [anon_sym_LBRACE] = ACTIONS(3164),
    [anon_sym_signed] = ACTIONS(3162),
    [anon_sym_unsigned] = ACTIONS(3162),
    [anon_sym_long] = ACTIONS(3162),
    [anon_sym_short] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(3162),
    [anon_sym_static] = ACTIONS(3162),
    [anon_sym_register] = ACTIONS(3162),
    [anon_sym_inline] = ACTIONS(3162),
    [anon_sym___inline] = ACTIONS(3162),
    [anon_sym___inline__] = ACTIONS(3162),
    [anon_sym___forceinline] = ACTIONS(3162),
    [anon_sym_thread_local] = ACTIONS(3162),
    [anon_sym___thread] = ACTIONS(3162),
    [anon_sym_const] = ACTIONS(3162),
    [anon_sym_constexpr] = ACTIONS(3162),
    [anon_sym_volatile] = ACTIONS(3162),
    [anon_sym_restrict] = ACTIONS(3162),
    [anon_sym___restrict__] = ACTIONS(3162),
    [anon_sym__Atomic] = ACTIONS(3162),
    [anon_sym__Noreturn] = ACTIONS(3162),
    [anon_sym_noreturn] = ACTIONS(3162),
    [anon_sym_mutable] = ACTIONS(3162),
    [anon_sym_constinit] = ACTIONS(3162),
    [anon_sym_consteval] = ACTIONS(3162),
    [anon_sym_alignas] = ACTIONS(3162),
    [anon_sym__Alignas] = ACTIONS(3162),
    [sym_primitive_type] = ACTIONS(3162),
    [anon_sym_enum] = ACTIONS(3162),
    [anon_sym_class] = ACTIONS(3162),
    [anon_sym_struct] = ACTIONS(3162),
    [anon_sym_union] = ACTIONS(3162),
    [anon_sym_if] = ACTIONS(3162),
    [anon_sym_else] = ACTIONS(3162),
    [anon_sym_switch] = ACTIONS(3162),
    [anon_sym_case] = ACTIONS(3162),
    [anon_sym_default] = ACTIONS(3162),
    [anon_sym_while] = ACTIONS(3162),
    [anon_sym_do] = ACTIONS(3162),
    [anon_sym_for] = ACTIONS(3162),
    [anon_sym_return] = ACTIONS(3162),
    [anon_sym_break] = ACTIONS(3162),
    [anon_sym_continue] = ACTIONS(3162),
    [anon_sym_goto] = ACTIONS(3162),
    [anon_sym___try] = ACTIONS(3162),
    [anon_sym___leave] = ACTIONS(3162),
    [anon_sym_not] = ACTIONS(3162),
    [anon_sym_compl] = ACTIONS(3162),
    [anon_sym_DASH_DASH] = ACTIONS(3164),
    [anon_sym_PLUS_PLUS] = ACTIONS(3164),
    [anon_sym_sizeof] = ACTIONS(3162),
    [anon_sym___alignof__] = ACTIONS(3162),
    [anon_sym___alignof] = ACTIONS(3162),
    [anon_sym__alignof] = ACTIONS(3162),
    [anon_sym_alignof] = ACTIONS(3162),
    [anon_sym__Alignof] = ACTIONS(3162),
    [anon_sym_offsetof] = ACTIONS(3162),
    [anon_sym__Generic] = ACTIONS(3162),
    [anon_sym_asm] = ACTIONS(3162),
    [anon_sym___asm__] = ACTIONS(3162),
    [sym_number_literal] = ACTIONS(3164),
    [anon_sym_L_SQUOTE] = ACTIONS(3164),
    [anon_sym_u_SQUOTE] = ACTIONS(3164),
    [anon_sym_U_SQUOTE] = ACTIONS(3164),
    [anon_sym_u8_SQUOTE] = ACTIONS(3164),
    [anon_sym_SQUOTE] = ACTIONS(3164),
    [anon_sym_L_DQUOTE] = ACTIONS(3164),
    [anon_sym_u_DQUOTE] = ACTIONS(3164),
    [anon_sym_U_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8_DQUOTE] = ACTIONS(3164),
    [anon_sym_DQUOTE] = ACTIONS(3164),
    [sym_true] = ACTIONS(3162),
    [sym_false] = ACTIONS(3162),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3162),
    [anon_sym_let] = ACTIONS(3162),
    [anon_sym_This] = ACTIONS(3162),
    [anon_sym_decltype] = ACTIONS(3162),
    [sym_virtual] = ACTIONS(3162),
    [anon_sym_explicit] = ACTIONS(3162),
    [anon_sym_typename] = ACTIONS(3162),
    [anon_sym_template] = ACTIONS(3162),
    [anon_sym_operator] = ACTIONS(3162),
    [anon_sym_try] = ACTIONS(3162),
    [anon_sym_delete] = ACTIONS(3162),
    [anon_sym_throw] = ACTIONS(3162),
    [anon_sym_namespace] = ACTIONS(3162),
    [anon_sym_using] = ACTIONS(3162),
    [anon_sym_static_assert] = ACTIONS(3162),
    [anon_sym_concept] = ACTIONS(3162),
    [anon_sym_co_return] = ACTIONS(3162),
    [anon_sym_co_yield] = ACTIONS(3162),
    [anon_sym_R_DQUOTE] = ACTIONS(3164),
    [anon_sym_LR_DQUOTE] = ACTIONS(3164),
    [anon_sym_uR_DQUOTE] = ACTIONS(3164),
    [anon_sym_UR_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3164),
    [anon_sym_co_await] = ACTIONS(3162),
    [anon_sym_new] = ACTIONS(3162),
    [anon_sym_requires] = ACTIONS(3162),
    [sym_this] = ACTIONS(3162),
    [anon_sym_discard] = ACTIONS(3162),
    [anon_sym_precise] = ACTIONS(3162),
    [anon_sym_shared] = ACTIONS(3162),
    [anon_sym_groupshared] = ACTIONS(3162),
    [anon_sym_uniform] = ACTIONS(3162),
    [anon_sym_row_major] = ACTIONS(3162),
    [anon_sym_column_major] = ACTIONS(3162),
    [anon_sym_globallycoherent] = ACTIONS(3162),
    [anon_sym_centroid] = ACTIONS(3162),
    [anon_sym_noperspective] = ACTIONS(3162),
    [anon_sym_nointerpolation] = ACTIONS(3162),
    [anon_sym_sample] = ACTIONS(3162),
    [anon_sym_linear] = ACTIONS(3162),
    [anon_sym_snorm] = ACTIONS(3162),
    [anon_sym_unorm] = ACTIONS(3162),
    [anon_sym_point] = ACTIONS(3162),
    [anon_sym_line] = ACTIONS(3162),
    [anon_sym_triangleadj] = ACTIONS(3162),
    [anon_sym_lineadj] = ACTIONS(3162),
    [anon_sym_triangle] = ACTIONS(3162),
    [anon_sym_cbuffer] = ACTIONS(3162),
    [anon_sym_interface] = ACTIONS(3162),
    [anon_sym_extension] = ACTIONS(3162),
    [anon_sym___exported] = ACTIONS(3162),
    [anon_sym_import] = ACTIONS(3162),
  },
  [564] = {
    [ts_builtin_sym_end] = ACTIONS(3248),
    [sym_identifier] = ACTIONS(3246),
    [aux_sym_preproc_include_token1] = ACTIONS(3246),
    [aux_sym_preproc_def_token1] = ACTIONS(3246),
    [aux_sym_preproc_if_token1] = ACTIONS(3246),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3246),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3246),
    [sym_preproc_directive] = ACTIONS(3246),
    [anon_sym_LPAREN2] = ACTIONS(3248),
    [anon_sym_BANG] = ACTIONS(3248),
    [anon_sym_TILDE] = ACTIONS(3248),
    [anon_sym_DASH] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3246),
    [anon_sym_STAR] = ACTIONS(3248),
    [anon_sym_AMP_AMP] = ACTIONS(3248),
    [anon_sym_AMP] = ACTIONS(3246),
    [anon_sym_SEMI] = ACTIONS(3248),
    [anon_sym___extension__] = ACTIONS(3246),
    [anon_sym_typedef] = ACTIONS(3246),
    [anon_sym_in] = ACTIONS(3246),
    [anon_sym_out] = ACTIONS(3246),
    [anon_sym_inout] = ACTIONS(3246),
    [anon_sym_extern] = ACTIONS(3246),
    [anon_sym___attribute__] = ACTIONS(3246),
    [anon_sym_COLON_COLON] = ACTIONS(3248),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3248),
    [anon_sym___declspec] = ACTIONS(3246),
    [anon_sym___based] = ACTIONS(3246),
    [anon_sym___cdecl] = ACTIONS(3246),
    [anon_sym___clrcall] = ACTIONS(3246),
    [anon_sym___stdcall] = ACTIONS(3246),
    [anon_sym___fastcall] = ACTIONS(3246),
    [anon_sym___thiscall] = ACTIONS(3246),
    [anon_sym___vectorcall] = ACTIONS(3246),
    [anon_sym_LBRACE] = ACTIONS(3248),
    [anon_sym_signed] = ACTIONS(3246),
    [anon_sym_unsigned] = ACTIONS(3246),
    [anon_sym_long] = ACTIONS(3246),
    [anon_sym_short] = ACTIONS(3246),
    [anon_sym_LBRACK] = ACTIONS(3246),
    [anon_sym_static] = ACTIONS(3246),
    [anon_sym_register] = ACTIONS(3246),
    [anon_sym_inline] = ACTIONS(3246),
    [anon_sym___inline] = ACTIONS(3246),
    [anon_sym___inline__] = ACTIONS(3246),
    [anon_sym___forceinline] = ACTIONS(3246),
    [anon_sym_thread_local] = ACTIONS(3246),
    [anon_sym___thread] = ACTIONS(3246),
    [anon_sym_const] = ACTIONS(3246),
    [anon_sym_constexpr] = ACTIONS(3246),
    [anon_sym_volatile] = ACTIONS(3246),
    [anon_sym_restrict] = ACTIONS(3246),
    [anon_sym___restrict__] = ACTIONS(3246),
    [anon_sym__Atomic] = ACTIONS(3246),
    [anon_sym__Noreturn] = ACTIONS(3246),
    [anon_sym_noreturn] = ACTIONS(3246),
    [anon_sym_mutable] = ACTIONS(3246),
    [anon_sym_constinit] = ACTIONS(3246),
    [anon_sym_consteval] = ACTIONS(3246),
    [anon_sym_alignas] = ACTIONS(3246),
    [anon_sym__Alignas] = ACTIONS(3246),
    [sym_primitive_type] = ACTIONS(3246),
    [anon_sym_enum] = ACTIONS(3246),
    [anon_sym_class] = ACTIONS(3246),
    [anon_sym_struct] = ACTIONS(3246),
    [anon_sym_union] = ACTIONS(3246),
    [anon_sym_if] = ACTIONS(3246),
    [anon_sym_else] = ACTIONS(3246),
    [anon_sym_switch] = ACTIONS(3246),
    [anon_sym_case] = ACTIONS(3246),
    [anon_sym_default] = ACTIONS(3246),
    [anon_sym_while] = ACTIONS(3246),
    [anon_sym_do] = ACTIONS(3246),
    [anon_sym_for] = ACTIONS(3246),
    [anon_sym_return] = ACTIONS(3246),
    [anon_sym_break] = ACTIONS(3246),
    [anon_sym_continue] = ACTIONS(3246),
    [anon_sym_goto] = ACTIONS(3246),
    [anon_sym___try] = ACTIONS(3246),
    [anon_sym___leave] = ACTIONS(3246),
    [anon_sym_not] = ACTIONS(3246),
    [anon_sym_compl] = ACTIONS(3246),
    [anon_sym_DASH_DASH] = ACTIONS(3248),
    [anon_sym_PLUS_PLUS] = ACTIONS(3248),
    [anon_sym_sizeof] = ACTIONS(3246),
    [anon_sym___alignof__] = ACTIONS(3246),
    [anon_sym___alignof] = ACTIONS(3246),
    [anon_sym__alignof] = ACTIONS(3246),
    [anon_sym_alignof] = ACTIONS(3246),
    [anon_sym__Alignof] = ACTIONS(3246),
    [anon_sym_offsetof] = ACTIONS(3246),
    [anon_sym__Generic] = ACTIONS(3246),
    [anon_sym_asm] = ACTIONS(3246),
    [anon_sym___asm__] = ACTIONS(3246),
    [sym_number_literal] = ACTIONS(3248),
    [anon_sym_L_SQUOTE] = ACTIONS(3248),
    [anon_sym_u_SQUOTE] = ACTIONS(3248),
    [anon_sym_U_SQUOTE] = ACTIONS(3248),
    [anon_sym_u8_SQUOTE] = ACTIONS(3248),
    [anon_sym_SQUOTE] = ACTIONS(3248),
    [anon_sym_L_DQUOTE] = ACTIONS(3248),
    [anon_sym_u_DQUOTE] = ACTIONS(3248),
    [anon_sym_U_DQUOTE] = ACTIONS(3248),
    [anon_sym_u8_DQUOTE] = ACTIONS(3248),
    [anon_sym_DQUOTE] = ACTIONS(3248),
    [sym_true] = ACTIONS(3246),
    [sym_false] = ACTIONS(3246),
    [anon_sym_NULL] = ACTIONS(3246),
    [anon_sym_nullptr] = ACTIONS(3246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3246),
    [anon_sym_let] = ACTIONS(3246),
    [anon_sym_This] = ACTIONS(3246),
    [anon_sym_decltype] = ACTIONS(3246),
    [sym_virtual] = ACTIONS(3246),
    [anon_sym_explicit] = ACTIONS(3246),
    [anon_sym_typename] = ACTIONS(3246),
    [anon_sym_template] = ACTIONS(3246),
    [anon_sym_operator] = ACTIONS(3246),
    [anon_sym_try] = ACTIONS(3246),
    [anon_sym_delete] = ACTIONS(3246),
    [anon_sym_throw] = ACTIONS(3246),
    [anon_sym_namespace] = ACTIONS(3246),
    [anon_sym_using] = ACTIONS(3246),
    [anon_sym_static_assert] = ACTIONS(3246),
    [anon_sym_concept] = ACTIONS(3246),
    [anon_sym_co_return] = ACTIONS(3246),
    [anon_sym_co_yield] = ACTIONS(3246),
    [anon_sym_R_DQUOTE] = ACTIONS(3248),
    [anon_sym_LR_DQUOTE] = ACTIONS(3248),
    [anon_sym_uR_DQUOTE] = ACTIONS(3248),
    [anon_sym_UR_DQUOTE] = ACTIONS(3248),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3248),
    [anon_sym_co_await] = ACTIONS(3246),
    [anon_sym_new] = ACTIONS(3246),
    [anon_sym_requires] = ACTIONS(3246),
    [sym_this] = ACTIONS(3246),
    [anon_sym_discard] = ACTIONS(3246),
    [anon_sym_precise] = ACTIONS(3246),
    [anon_sym_shared] = ACTIONS(3246),
    [anon_sym_groupshared] = ACTIONS(3246),
    [anon_sym_uniform] = ACTIONS(3246),
    [anon_sym_row_major] = ACTIONS(3246),
    [anon_sym_column_major] = ACTIONS(3246),
    [anon_sym_globallycoherent] = ACTIONS(3246),
    [anon_sym_centroid] = ACTIONS(3246),
    [anon_sym_noperspective] = ACTIONS(3246),
    [anon_sym_nointerpolation] = ACTIONS(3246),
    [anon_sym_sample] = ACTIONS(3246),
    [anon_sym_linear] = ACTIONS(3246),
    [anon_sym_snorm] = ACTIONS(3246),
    [anon_sym_unorm] = ACTIONS(3246),
    [anon_sym_point] = ACTIONS(3246),
    [anon_sym_line] = ACTIONS(3246),
    [anon_sym_triangleadj] = ACTIONS(3246),
    [anon_sym_lineadj] = ACTIONS(3246),
    [anon_sym_triangle] = ACTIONS(3246),
    [anon_sym_cbuffer] = ACTIONS(3246),
    [anon_sym_interface] = ACTIONS(3246),
    [anon_sym_extension] = ACTIONS(3246),
    [anon_sym___exported] = ACTIONS(3246),
    [anon_sym_import] = ACTIONS(3246),
  },
  [565] = {
    [ts_builtin_sym_end] = ACTIONS(2984),
    [sym_identifier] = ACTIONS(2982),
    [aux_sym_preproc_include_token1] = ACTIONS(2982),
    [aux_sym_preproc_def_token1] = ACTIONS(2982),
    [aux_sym_preproc_if_token1] = ACTIONS(2982),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2982),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2982),
    [sym_preproc_directive] = ACTIONS(2982),
    [anon_sym_LPAREN2] = ACTIONS(2984),
    [anon_sym_BANG] = ACTIONS(2984),
    [anon_sym_TILDE] = ACTIONS(2984),
    [anon_sym_DASH] = ACTIONS(2982),
    [anon_sym_PLUS] = ACTIONS(2982),
    [anon_sym_STAR] = ACTIONS(2984),
    [anon_sym_AMP_AMP] = ACTIONS(2984),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_SEMI] = ACTIONS(2984),
    [anon_sym___extension__] = ACTIONS(2982),
    [anon_sym_typedef] = ACTIONS(2982),
    [anon_sym_in] = ACTIONS(2982),
    [anon_sym_out] = ACTIONS(2982),
    [anon_sym_inout] = ACTIONS(2982),
    [anon_sym_extern] = ACTIONS(2982),
    [anon_sym___attribute__] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2984),
    [anon_sym___declspec] = ACTIONS(2982),
    [anon_sym___based] = ACTIONS(2982),
    [anon_sym___cdecl] = ACTIONS(2982),
    [anon_sym___clrcall] = ACTIONS(2982),
    [anon_sym___stdcall] = ACTIONS(2982),
    [anon_sym___fastcall] = ACTIONS(2982),
    [anon_sym___thiscall] = ACTIONS(2982),
    [anon_sym___vectorcall] = ACTIONS(2982),
    [anon_sym_LBRACE] = ACTIONS(2984),
    [anon_sym_signed] = ACTIONS(2982),
    [anon_sym_unsigned] = ACTIONS(2982),
    [anon_sym_long] = ACTIONS(2982),
    [anon_sym_short] = ACTIONS(2982),
    [anon_sym_LBRACK] = ACTIONS(2982),
    [anon_sym_static] = ACTIONS(2982),
    [anon_sym_register] = ACTIONS(2982),
    [anon_sym_inline] = ACTIONS(2982),
    [anon_sym___inline] = ACTIONS(2982),
    [anon_sym___inline__] = ACTIONS(2982),
    [anon_sym___forceinline] = ACTIONS(2982),
    [anon_sym_thread_local] = ACTIONS(2982),
    [anon_sym___thread] = ACTIONS(2982),
    [anon_sym_const] = ACTIONS(2982),
    [anon_sym_constexpr] = ACTIONS(2982),
    [anon_sym_volatile] = ACTIONS(2982),
    [anon_sym_restrict] = ACTIONS(2982),
    [anon_sym___restrict__] = ACTIONS(2982),
    [anon_sym__Atomic] = ACTIONS(2982),
    [anon_sym__Noreturn] = ACTIONS(2982),
    [anon_sym_noreturn] = ACTIONS(2982),
    [anon_sym_mutable] = ACTIONS(2982),
    [anon_sym_constinit] = ACTIONS(2982),
    [anon_sym_consteval] = ACTIONS(2982),
    [anon_sym_alignas] = ACTIONS(2982),
    [anon_sym__Alignas] = ACTIONS(2982),
    [sym_primitive_type] = ACTIONS(2982),
    [anon_sym_enum] = ACTIONS(2982),
    [anon_sym_class] = ACTIONS(2982),
    [anon_sym_struct] = ACTIONS(2982),
    [anon_sym_union] = ACTIONS(2982),
    [anon_sym_if] = ACTIONS(2982),
    [anon_sym_else] = ACTIONS(2982),
    [anon_sym_switch] = ACTIONS(2982),
    [anon_sym_case] = ACTIONS(2982),
    [anon_sym_default] = ACTIONS(2982),
    [anon_sym_while] = ACTIONS(2982),
    [anon_sym_do] = ACTIONS(2982),
    [anon_sym_for] = ACTIONS(2982),
    [anon_sym_return] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2982),
    [anon_sym_continue] = ACTIONS(2982),
    [anon_sym_goto] = ACTIONS(2982),
    [anon_sym___try] = ACTIONS(2982),
    [anon_sym___leave] = ACTIONS(2982),
    [anon_sym_not] = ACTIONS(2982),
    [anon_sym_compl] = ACTIONS(2982),
    [anon_sym_DASH_DASH] = ACTIONS(2984),
    [anon_sym_PLUS_PLUS] = ACTIONS(2984),
    [anon_sym_sizeof] = ACTIONS(2982),
    [anon_sym___alignof__] = ACTIONS(2982),
    [anon_sym___alignof] = ACTIONS(2982),
    [anon_sym__alignof] = ACTIONS(2982),
    [anon_sym_alignof] = ACTIONS(2982),
    [anon_sym__Alignof] = ACTIONS(2982),
    [anon_sym_offsetof] = ACTIONS(2982),
    [anon_sym__Generic] = ACTIONS(2982),
    [anon_sym_asm] = ACTIONS(2982),
    [anon_sym___asm__] = ACTIONS(2982),
    [sym_number_literal] = ACTIONS(2984),
    [anon_sym_L_SQUOTE] = ACTIONS(2984),
    [anon_sym_u_SQUOTE] = ACTIONS(2984),
    [anon_sym_U_SQUOTE] = ACTIONS(2984),
    [anon_sym_u8_SQUOTE] = ACTIONS(2984),
    [anon_sym_SQUOTE] = ACTIONS(2984),
    [anon_sym_L_DQUOTE] = ACTIONS(2984),
    [anon_sym_u_DQUOTE] = ACTIONS(2984),
    [anon_sym_U_DQUOTE] = ACTIONS(2984),
    [anon_sym_u8_DQUOTE] = ACTIONS(2984),
    [anon_sym_DQUOTE] = ACTIONS(2984),
    [sym_true] = ACTIONS(2982),
    [sym_false] = ACTIONS(2982),
    [anon_sym_NULL] = ACTIONS(2982),
    [anon_sym_nullptr] = ACTIONS(2982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2982),
    [anon_sym_let] = ACTIONS(2982),
    [anon_sym_This] = ACTIONS(2982),
    [anon_sym_decltype] = ACTIONS(2982),
    [sym_virtual] = ACTIONS(2982),
    [anon_sym_explicit] = ACTIONS(2982),
    [anon_sym_typename] = ACTIONS(2982),
    [anon_sym_template] = ACTIONS(2982),
    [anon_sym_operator] = ACTIONS(2982),
    [anon_sym_try] = ACTIONS(2982),
    [anon_sym_delete] = ACTIONS(2982),
    [anon_sym_throw] = ACTIONS(2982),
    [anon_sym_namespace] = ACTIONS(2982),
    [anon_sym_using] = ACTIONS(2982),
    [anon_sym_static_assert] = ACTIONS(2982),
    [anon_sym_concept] = ACTIONS(2982),
    [anon_sym_co_return] = ACTIONS(2982),
    [anon_sym_co_yield] = ACTIONS(2982),
    [anon_sym_R_DQUOTE] = ACTIONS(2984),
    [anon_sym_LR_DQUOTE] = ACTIONS(2984),
    [anon_sym_uR_DQUOTE] = ACTIONS(2984),
    [anon_sym_UR_DQUOTE] = ACTIONS(2984),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2984),
    [anon_sym_co_await] = ACTIONS(2982),
    [anon_sym_new] = ACTIONS(2982),
    [anon_sym_requires] = ACTIONS(2982),
    [sym_this] = ACTIONS(2982),
    [anon_sym_discard] = ACTIONS(2982),
    [anon_sym_precise] = ACTIONS(2982),
    [anon_sym_shared] = ACTIONS(2982),
    [anon_sym_groupshared] = ACTIONS(2982),
    [anon_sym_uniform] = ACTIONS(2982),
    [anon_sym_row_major] = ACTIONS(2982),
    [anon_sym_column_major] = ACTIONS(2982),
    [anon_sym_globallycoherent] = ACTIONS(2982),
    [anon_sym_centroid] = ACTIONS(2982),
    [anon_sym_noperspective] = ACTIONS(2982),
    [anon_sym_nointerpolation] = ACTIONS(2982),
    [anon_sym_sample] = ACTIONS(2982),
    [anon_sym_linear] = ACTIONS(2982),
    [anon_sym_snorm] = ACTIONS(2982),
    [anon_sym_unorm] = ACTIONS(2982),
    [anon_sym_point] = ACTIONS(2982),
    [anon_sym_line] = ACTIONS(2982),
    [anon_sym_triangleadj] = ACTIONS(2982),
    [anon_sym_lineadj] = ACTIONS(2982),
    [anon_sym_triangle] = ACTIONS(2982),
    [anon_sym_cbuffer] = ACTIONS(2982),
    [anon_sym_interface] = ACTIONS(2982),
    [anon_sym_extension] = ACTIONS(2982),
    [anon_sym___exported] = ACTIONS(2982),
    [anon_sym_import] = ACTIONS(2982),
  },
  [566] = {
    [ts_builtin_sym_end] = ACTIONS(3040),
    [sym_identifier] = ACTIONS(3038),
    [aux_sym_preproc_include_token1] = ACTIONS(3038),
    [aux_sym_preproc_def_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3038),
    [sym_preproc_directive] = ACTIONS(3038),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3038),
    [anon_sym_PLUS] = ACTIONS(3038),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3038),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3038),
    [anon_sym_typedef] = ACTIONS(3038),
    [anon_sym_in] = ACTIONS(3038),
    [anon_sym_out] = ACTIONS(3038),
    [anon_sym_inout] = ACTIONS(3038),
    [anon_sym_extern] = ACTIONS(3038),
    [anon_sym___attribute__] = ACTIONS(3038),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3040),
    [anon_sym___declspec] = ACTIONS(3038),
    [anon_sym___based] = ACTIONS(3038),
    [anon_sym___cdecl] = ACTIONS(3038),
    [anon_sym___clrcall] = ACTIONS(3038),
    [anon_sym___stdcall] = ACTIONS(3038),
    [anon_sym___fastcall] = ACTIONS(3038),
    [anon_sym___thiscall] = ACTIONS(3038),
    [anon_sym___vectorcall] = ACTIONS(3038),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_signed] = ACTIONS(3038),
    [anon_sym_unsigned] = ACTIONS(3038),
    [anon_sym_long] = ACTIONS(3038),
    [anon_sym_short] = ACTIONS(3038),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_static] = ACTIONS(3038),
    [anon_sym_register] = ACTIONS(3038),
    [anon_sym_inline] = ACTIONS(3038),
    [anon_sym___inline] = ACTIONS(3038),
    [anon_sym___inline__] = ACTIONS(3038),
    [anon_sym___forceinline] = ACTIONS(3038),
    [anon_sym_thread_local] = ACTIONS(3038),
    [anon_sym___thread] = ACTIONS(3038),
    [anon_sym_const] = ACTIONS(3038),
    [anon_sym_constexpr] = ACTIONS(3038),
    [anon_sym_volatile] = ACTIONS(3038),
    [anon_sym_restrict] = ACTIONS(3038),
    [anon_sym___restrict__] = ACTIONS(3038),
    [anon_sym__Atomic] = ACTIONS(3038),
    [anon_sym__Noreturn] = ACTIONS(3038),
    [anon_sym_noreturn] = ACTIONS(3038),
    [anon_sym_mutable] = ACTIONS(3038),
    [anon_sym_constinit] = ACTIONS(3038),
    [anon_sym_consteval] = ACTIONS(3038),
    [anon_sym_alignas] = ACTIONS(3038),
    [anon_sym__Alignas] = ACTIONS(3038),
    [sym_primitive_type] = ACTIONS(3038),
    [anon_sym_enum] = ACTIONS(3038),
    [anon_sym_class] = ACTIONS(3038),
    [anon_sym_struct] = ACTIONS(3038),
    [anon_sym_union] = ACTIONS(3038),
    [anon_sym_if] = ACTIONS(3038),
    [anon_sym_else] = ACTIONS(3038),
    [anon_sym_switch] = ACTIONS(3038),
    [anon_sym_case] = ACTIONS(3038),
    [anon_sym_default] = ACTIONS(3038),
    [anon_sym_while] = ACTIONS(3038),
    [anon_sym_do] = ACTIONS(3038),
    [anon_sym_for] = ACTIONS(3038),
    [anon_sym_return] = ACTIONS(3038),
    [anon_sym_break] = ACTIONS(3038),
    [anon_sym_continue] = ACTIONS(3038),
    [anon_sym_goto] = ACTIONS(3038),
    [anon_sym___try] = ACTIONS(3038),
    [anon_sym___leave] = ACTIONS(3038),
    [anon_sym_not] = ACTIONS(3038),
    [anon_sym_compl] = ACTIONS(3038),
    [anon_sym_DASH_DASH] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3040),
    [anon_sym_sizeof] = ACTIONS(3038),
    [anon_sym___alignof__] = ACTIONS(3038),
    [anon_sym___alignof] = ACTIONS(3038),
    [anon_sym__alignof] = ACTIONS(3038),
    [anon_sym_alignof] = ACTIONS(3038),
    [anon_sym__Alignof] = ACTIONS(3038),
    [anon_sym_offsetof] = ACTIONS(3038),
    [anon_sym__Generic] = ACTIONS(3038),
    [anon_sym_asm] = ACTIONS(3038),
    [anon_sym___asm__] = ACTIONS(3038),
    [sym_number_literal] = ACTIONS(3040),
    [anon_sym_L_SQUOTE] = ACTIONS(3040),
    [anon_sym_u_SQUOTE] = ACTIONS(3040),
    [anon_sym_U_SQUOTE] = ACTIONS(3040),
    [anon_sym_u8_SQUOTE] = ACTIONS(3040),
    [anon_sym_SQUOTE] = ACTIONS(3040),
    [anon_sym_L_DQUOTE] = ACTIONS(3040),
    [anon_sym_u_DQUOTE] = ACTIONS(3040),
    [anon_sym_U_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8_DQUOTE] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [sym_true] = ACTIONS(3038),
    [sym_false] = ACTIONS(3038),
    [anon_sym_NULL] = ACTIONS(3038),
    [anon_sym_nullptr] = ACTIONS(3038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3038),
    [anon_sym_let] = ACTIONS(3038),
    [anon_sym_This] = ACTIONS(3038),
    [anon_sym_decltype] = ACTIONS(3038),
    [sym_virtual] = ACTIONS(3038),
    [anon_sym_explicit] = ACTIONS(3038),
    [anon_sym_typename] = ACTIONS(3038),
    [anon_sym_template] = ACTIONS(3038),
    [anon_sym_operator] = ACTIONS(3038),
    [anon_sym_try] = ACTIONS(3038),
    [anon_sym_delete] = ACTIONS(3038),
    [anon_sym_throw] = ACTIONS(3038),
    [anon_sym_namespace] = ACTIONS(3038),
    [anon_sym_using] = ACTIONS(3038),
    [anon_sym_static_assert] = ACTIONS(3038),
    [anon_sym_concept] = ACTIONS(3038),
    [anon_sym_co_return] = ACTIONS(3038),
    [anon_sym_co_yield] = ACTIONS(3038),
    [anon_sym_R_DQUOTE] = ACTIONS(3040),
    [anon_sym_LR_DQUOTE] = ACTIONS(3040),
    [anon_sym_uR_DQUOTE] = ACTIONS(3040),
    [anon_sym_UR_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3040),
    [anon_sym_co_await] = ACTIONS(3038),
    [anon_sym_new] = ACTIONS(3038),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3038),
    [anon_sym_discard] = ACTIONS(3038),
    [anon_sym_precise] = ACTIONS(3038),
    [anon_sym_shared] = ACTIONS(3038),
    [anon_sym_groupshared] = ACTIONS(3038),
    [anon_sym_uniform] = ACTIONS(3038),
    [anon_sym_row_major] = ACTIONS(3038),
    [anon_sym_column_major] = ACTIONS(3038),
    [anon_sym_globallycoherent] = ACTIONS(3038),
    [anon_sym_centroid] = ACTIONS(3038),
    [anon_sym_noperspective] = ACTIONS(3038),
    [anon_sym_nointerpolation] = ACTIONS(3038),
    [anon_sym_sample] = ACTIONS(3038),
    [anon_sym_linear] = ACTIONS(3038),
    [anon_sym_snorm] = ACTIONS(3038),
    [anon_sym_unorm] = ACTIONS(3038),
    [anon_sym_point] = ACTIONS(3038),
    [anon_sym_line] = ACTIONS(3038),
    [anon_sym_triangleadj] = ACTIONS(3038),
    [anon_sym_lineadj] = ACTIONS(3038),
    [anon_sym_triangle] = ACTIONS(3038),
    [anon_sym_cbuffer] = ACTIONS(3038),
    [anon_sym_interface] = ACTIONS(3038),
    [anon_sym_extension] = ACTIONS(3038),
    [anon_sym___exported] = ACTIONS(3038),
    [anon_sym_import] = ACTIONS(3038),
  },
  [567] = {
    [ts_builtin_sym_end] = ACTIONS(3198),
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_include_token1] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3196),
    [aux_sym_preproc_if_token1] = ACTIONS(3196),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3196),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3196),
    [sym_preproc_directive] = ACTIONS(3196),
    [anon_sym_LPAREN2] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3196),
    [anon_sym_PLUS] = ACTIONS(3196),
    [anon_sym_STAR] = ACTIONS(3198),
    [anon_sym_AMP_AMP] = ACTIONS(3198),
    [anon_sym_AMP] = ACTIONS(3196),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(3196),
    [anon_sym_typedef] = ACTIONS(3196),
    [anon_sym_in] = ACTIONS(3196),
    [anon_sym_out] = ACTIONS(3196),
    [anon_sym_inout] = ACTIONS(3196),
    [anon_sym_extern] = ACTIONS(3196),
    [anon_sym___attribute__] = ACTIONS(3196),
    [anon_sym_COLON_COLON] = ACTIONS(3198),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3198),
    [anon_sym___declspec] = ACTIONS(3196),
    [anon_sym___based] = ACTIONS(3196),
    [anon_sym___cdecl] = ACTIONS(3196),
    [anon_sym___clrcall] = ACTIONS(3196),
    [anon_sym___stdcall] = ACTIONS(3196),
    [anon_sym___fastcall] = ACTIONS(3196),
    [anon_sym___thiscall] = ACTIONS(3196),
    [anon_sym___vectorcall] = ACTIONS(3196),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_signed] = ACTIONS(3196),
    [anon_sym_unsigned] = ACTIONS(3196),
    [anon_sym_long] = ACTIONS(3196),
    [anon_sym_short] = ACTIONS(3196),
    [anon_sym_LBRACK] = ACTIONS(3196),
    [anon_sym_static] = ACTIONS(3196),
    [anon_sym_register] = ACTIONS(3196),
    [anon_sym_inline] = ACTIONS(3196),
    [anon_sym___inline] = ACTIONS(3196),
    [anon_sym___inline__] = ACTIONS(3196),
    [anon_sym___forceinline] = ACTIONS(3196),
    [anon_sym_thread_local] = ACTIONS(3196),
    [anon_sym___thread] = ACTIONS(3196),
    [anon_sym_const] = ACTIONS(3196),
    [anon_sym_constexpr] = ACTIONS(3196),
    [anon_sym_volatile] = ACTIONS(3196),
    [anon_sym_restrict] = ACTIONS(3196),
    [anon_sym___restrict__] = ACTIONS(3196),
    [anon_sym__Atomic] = ACTIONS(3196),
    [anon_sym__Noreturn] = ACTIONS(3196),
    [anon_sym_noreturn] = ACTIONS(3196),
    [anon_sym_mutable] = ACTIONS(3196),
    [anon_sym_constinit] = ACTIONS(3196),
    [anon_sym_consteval] = ACTIONS(3196),
    [anon_sym_alignas] = ACTIONS(3196),
    [anon_sym__Alignas] = ACTIONS(3196),
    [sym_primitive_type] = ACTIONS(3196),
    [anon_sym_enum] = ACTIONS(3196),
    [anon_sym_class] = ACTIONS(3196),
    [anon_sym_struct] = ACTIONS(3196),
    [anon_sym_union] = ACTIONS(3196),
    [anon_sym_if] = ACTIONS(3196),
    [anon_sym_else] = ACTIONS(3196),
    [anon_sym_switch] = ACTIONS(3196),
    [anon_sym_case] = ACTIONS(3196),
    [anon_sym_default] = ACTIONS(3196),
    [anon_sym_while] = ACTIONS(3196),
    [anon_sym_do] = ACTIONS(3196),
    [anon_sym_for] = ACTIONS(3196),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_break] = ACTIONS(3196),
    [anon_sym_continue] = ACTIONS(3196),
    [anon_sym_goto] = ACTIONS(3196),
    [anon_sym___try] = ACTIONS(3196),
    [anon_sym___leave] = ACTIONS(3196),
    [anon_sym_not] = ACTIONS(3196),
    [anon_sym_compl] = ACTIONS(3196),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(3196),
    [anon_sym___alignof] = ACTIONS(3196),
    [anon_sym__alignof] = ACTIONS(3196),
    [anon_sym_alignof] = ACTIONS(3196),
    [anon_sym__Alignof] = ACTIONS(3196),
    [anon_sym_offsetof] = ACTIONS(3196),
    [anon_sym__Generic] = ACTIONS(3196),
    [anon_sym_asm] = ACTIONS(3196),
    [anon_sym___asm__] = ACTIONS(3196),
    [sym_number_literal] = ACTIONS(3198),
    [anon_sym_L_SQUOTE] = ACTIONS(3198),
    [anon_sym_u_SQUOTE] = ACTIONS(3198),
    [anon_sym_U_SQUOTE] = ACTIONS(3198),
    [anon_sym_u8_SQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_L_DQUOTE] = ACTIONS(3198),
    [anon_sym_u_DQUOTE] = ACTIONS(3198),
    [anon_sym_U_DQUOTE] = ACTIONS(3198),
    [anon_sym_u8_DQUOTE] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [sym_true] = ACTIONS(3196),
    [sym_false] = ACTIONS(3196),
    [anon_sym_NULL] = ACTIONS(3196),
    [anon_sym_nullptr] = ACTIONS(3196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3196),
    [anon_sym_let] = ACTIONS(3196),
    [anon_sym_This] = ACTIONS(3196),
    [anon_sym_decltype] = ACTIONS(3196),
    [sym_virtual] = ACTIONS(3196),
    [anon_sym_explicit] = ACTIONS(3196),
    [anon_sym_typename] = ACTIONS(3196),
    [anon_sym_template] = ACTIONS(3196),
    [anon_sym_operator] = ACTIONS(3196),
    [anon_sym_try] = ACTIONS(3196),
    [anon_sym_delete] = ACTIONS(3196),
    [anon_sym_throw] = ACTIONS(3196),
    [anon_sym_namespace] = ACTIONS(3196),
    [anon_sym_using] = ACTIONS(3196),
    [anon_sym_static_assert] = ACTIONS(3196),
    [anon_sym_concept] = ACTIONS(3196),
    [anon_sym_co_return] = ACTIONS(3196),
    [anon_sym_co_yield] = ACTIONS(3196),
    [anon_sym_R_DQUOTE] = ACTIONS(3198),
    [anon_sym_LR_DQUOTE] = ACTIONS(3198),
    [anon_sym_uR_DQUOTE] = ACTIONS(3198),
    [anon_sym_UR_DQUOTE] = ACTIONS(3198),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3198),
    [anon_sym_co_await] = ACTIONS(3196),
    [anon_sym_new] = ACTIONS(3196),
    [anon_sym_requires] = ACTIONS(3196),
    [sym_this] = ACTIONS(3196),
    [anon_sym_discard] = ACTIONS(3196),
    [anon_sym_precise] = ACTIONS(3196),
    [anon_sym_shared] = ACTIONS(3196),
    [anon_sym_groupshared] = ACTIONS(3196),
    [anon_sym_uniform] = ACTIONS(3196),
    [anon_sym_row_major] = ACTIONS(3196),
    [anon_sym_column_major] = ACTIONS(3196),
    [anon_sym_globallycoherent] = ACTIONS(3196),
    [anon_sym_centroid] = ACTIONS(3196),
    [anon_sym_noperspective] = ACTIONS(3196),
    [anon_sym_nointerpolation] = ACTIONS(3196),
    [anon_sym_sample] = ACTIONS(3196),
    [anon_sym_linear] = ACTIONS(3196),
    [anon_sym_snorm] = ACTIONS(3196),
    [anon_sym_unorm] = ACTIONS(3196),
    [anon_sym_point] = ACTIONS(3196),
    [anon_sym_line] = ACTIONS(3196),
    [anon_sym_triangleadj] = ACTIONS(3196),
    [anon_sym_lineadj] = ACTIONS(3196),
    [anon_sym_triangle] = ACTIONS(3196),
    [anon_sym_cbuffer] = ACTIONS(3196),
    [anon_sym_interface] = ACTIONS(3196),
    [anon_sym_extension] = ACTIONS(3196),
    [anon_sym___exported] = ACTIONS(3196),
    [anon_sym_import] = ACTIONS(3196),
  },
  [568] = {
    [ts_builtin_sym_end] = ACTIONS(3220),
    [sym_identifier] = ACTIONS(3218),
    [aux_sym_preproc_include_token1] = ACTIONS(3218),
    [aux_sym_preproc_def_token1] = ACTIONS(3218),
    [aux_sym_preproc_if_token1] = ACTIONS(3218),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3218),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3218),
    [sym_preproc_directive] = ACTIONS(3218),
    [anon_sym_LPAREN2] = ACTIONS(3220),
    [anon_sym_BANG] = ACTIONS(3220),
    [anon_sym_TILDE] = ACTIONS(3220),
    [anon_sym_DASH] = ACTIONS(3218),
    [anon_sym_PLUS] = ACTIONS(3218),
    [anon_sym_STAR] = ACTIONS(3220),
    [anon_sym_AMP_AMP] = ACTIONS(3220),
    [anon_sym_AMP] = ACTIONS(3218),
    [anon_sym_SEMI] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3218),
    [anon_sym_typedef] = ACTIONS(3218),
    [anon_sym_in] = ACTIONS(3218),
    [anon_sym_out] = ACTIONS(3218),
    [anon_sym_inout] = ACTIONS(3218),
    [anon_sym_extern] = ACTIONS(3218),
    [anon_sym___attribute__] = ACTIONS(3218),
    [anon_sym_COLON_COLON] = ACTIONS(3220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3220),
    [anon_sym___declspec] = ACTIONS(3218),
    [anon_sym___based] = ACTIONS(3218),
    [anon_sym___cdecl] = ACTIONS(3218),
    [anon_sym___clrcall] = ACTIONS(3218),
    [anon_sym___stdcall] = ACTIONS(3218),
    [anon_sym___fastcall] = ACTIONS(3218),
    [anon_sym___thiscall] = ACTIONS(3218),
    [anon_sym___vectorcall] = ACTIONS(3218),
    [anon_sym_LBRACE] = ACTIONS(3220),
    [anon_sym_signed] = ACTIONS(3218),
    [anon_sym_unsigned] = ACTIONS(3218),
    [anon_sym_long] = ACTIONS(3218),
    [anon_sym_short] = ACTIONS(3218),
    [anon_sym_LBRACK] = ACTIONS(3218),
    [anon_sym_static] = ACTIONS(3218),
    [anon_sym_register] = ACTIONS(3218),
    [anon_sym_inline] = ACTIONS(3218),
    [anon_sym___inline] = ACTIONS(3218),
    [anon_sym___inline__] = ACTIONS(3218),
    [anon_sym___forceinline] = ACTIONS(3218),
    [anon_sym_thread_local] = ACTIONS(3218),
    [anon_sym___thread] = ACTIONS(3218),
    [anon_sym_const] = ACTIONS(3218),
    [anon_sym_constexpr] = ACTIONS(3218),
    [anon_sym_volatile] = ACTIONS(3218),
    [anon_sym_restrict] = ACTIONS(3218),
    [anon_sym___restrict__] = ACTIONS(3218),
    [anon_sym__Atomic] = ACTIONS(3218),
    [anon_sym__Noreturn] = ACTIONS(3218),
    [anon_sym_noreturn] = ACTIONS(3218),
    [anon_sym_mutable] = ACTIONS(3218),
    [anon_sym_constinit] = ACTIONS(3218),
    [anon_sym_consteval] = ACTIONS(3218),
    [anon_sym_alignas] = ACTIONS(3218),
    [anon_sym__Alignas] = ACTIONS(3218),
    [sym_primitive_type] = ACTIONS(3218),
    [anon_sym_enum] = ACTIONS(3218),
    [anon_sym_class] = ACTIONS(3218),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3218),
    [anon_sym_if] = ACTIONS(3218),
    [anon_sym_else] = ACTIONS(3218),
    [anon_sym_switch] = ACTIONS(3218),
    [anon_sym_case] = ACTIONS(3218),
    [anon_sym_default] = ACTIONS(3218),
    [anon_sym_while] = ACTIONS(3218),
    [anon_sym_do] = ACTIONS(3218),
    [anon_sym_for] = ACTIONS(3218),
    [anon_sym_return] = ACTIONS(3218),
    [anon_sym_break] = ACTIONS(3218),
    [anon_sym_continue] = ACTIONS(3218),
    [anon_sym_goto] = ACTIONS(3218),
    [anon_sym___try] = ACTIONS(3218),
    [anon_sym___leave] = ACTIONS(3218),
    [anon_sym_not] = ACTIONS(3218),
    [anon_sym_compl] = ACTIONS(3218),
    [anon_sym_DASH_DASH] = ACTIONS(3220),
    [anon_sym_PLUS_PLUS] = ACTIONS(3220),
    [anon_sym_sizeof] = ACTIONS(3218),
    [anon_sym___alignof__] = ACTIONS(3218),
    [anon_sym___alignof] = ACTIONS(3218),
    [anon_sym__alignof] = ACTIONS(3218),
    [anon_sym_alignof] = ACTIONS(3218),
    [anon_sym__Alignof] = ACTIONS(3218),
    [anon_sym_offsetof] = ACTIONS(3218),
    [anon_sym__Generic] = ACTIONS(3218),
    [anon_sym_asm] = ACTIONS(3218),
    [anon_sym___asm__] = ACTIONS(3218),
    [sym_number_literal] = ACTIONS(3220),
    [anon_sym_L_SQUOTE] = ACTIONS(3220),
    [anon_sym_u_SQUOTE] = ACTIONS(3220),
    [anon_sym_U_SQUOTE] = ACTIONS(3220),
    [anon_sym_u8_SQUOTE] = ACTIONS(3220),
    [anon_sym_SQUOTE] = ACTIONS(3220),
    [anon_sym_L_DQUOTE] = ACTIONS(3220),
    [anon_sym_u_DQUOTE] = ACTIONS(3220),
    [anon_sym_U_DQUOTE] = ACTIONS(3220),
    [anon_sym_u8_DQUOTE] = ACTIONS(3220),
    [anon_sym_DQUOTE] = ACTIONS(3220),
    [sym_true] = ACTIONS(3218),
    [sym_false] = ACTIONS(3218),
    [anon_sym_NULL] = ACTIONS(3218),
    [anon_sym_nullptr] = ACTIONS(3218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3218),
    [anon_sym_let] = ACTIONS(3218),
    [anon_sym_This] = ACTIONS(3218),
    [anon_sym_decltype] = ACTIONS(3218),
    [sym_virtual] = ACTIONS(3218),
    [anon_sym_explicit] = ACTIONS(3218),
    [anon_sym_typename] = ACTIONS(3218),
    [anon_sym_template] = ACTIONS(3218),
    [anon_sym_operator] = ACTIONS(3218),
    [anon_sym_try] = ACTIONS(3218),
    [anon_sym_delete] = ACTIONS(3218),
    [anon_sym_throw] = ACTIONS(3218),
    [anon_sym_namespace] = ACTIONS(3218),
    [anon_sym_using] = ACTIONS(3218),
    [anon_sym_static_assert] = ACTIONS(3218),
    [anon_sym_concept] = ACTIONS(3218),
    [anon_sym_co_return] = ACTIONS(3218),
    [anon_sym_co_yield] = ACTIONS(3218),
    [anon_sym_R_DQUOTE] = ACTIONS(3220),
    [anon_sym_LR_DQUOTE] = ACTIONS(3220),
    [anon_sym_uR_DQUOTE] = ACTIONS(3220),
    [anon_sym_UR_DQUOTE] = ACTIONS(3220),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3220),
    [anon_sym_co_await] = ACTIONS(3218),
    [anon_sym_new] = ACTIONS(3218),
    [anon_sym_requires] = ACTIONS(3218),
    [sym_this] = ACTIONS(3218),
    [anon_sym_discard] = ACTIONS(3218),
    [anon_sym_precise] = ACTIONS(3218),
    [anon_sym_shared] = ACTIONS(3218),
    [anon_sym_groupshared] = ACTIONS(3218),
    [anon_sym_uniform] = ACTIONS(3218),
    [anon_sym_row_major] = ACTIONS(3218),
    [anon_sym_column_major] = ACTIONS(3218),
    [anon_sym_globallycoherent] = ACTIONS(3218),
    [anon_sym_centroid] = ACTIONS(3218),
    [anon_sym_noperspective] = ACTIONS(3218),
    [anon_sym_nointerpolation] = ACTIONS(3218),
    [anon_sym_sample] = ACTIONS(3218),
    [anon_sym_linear] = ACTIONS(3218),
    [anon_sym_snorm] = ACTIONS(3218),
    [anon_sym_unorm] = ACTIONS(3218),
    [anon_sym_point] = ACTIONS(3218),
    [anon_sym_line] = ACTIONS(3218),
    [anon_sym_triangleadj] = ACTIONS(3218),
    [anon_sym_lineadj] = ACTIONS(3218),
    [anon_sym_triangle] = ACTIONS(3218),
    [anon_sym_cbuffer] = ACTIONS(3218),
    [anon_sym_interface] = ACTIONS(3218),
    [anon_sym_extension] = ACTIONS(3218),
    [anon_sym___exported] = ACTIONS(3218),
    [anon_sym_import] = ACTIONS(3218),
  },
  [569] = {
    [ts_builtin_sym_end] = ACTIONS(3040),
    [sym_identifier] = ACTIONS(3038),
    [aux_sym_preproc_include_token1] = ACTIONS(3038),
    [aux_sym_preproc_def_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3038),
    [sym_preproc_directive] = ACTIONS(3038),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3038),
    [anon_sym_PLUS] = ACTIONS(3038),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3038),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3038),
    [anon_sym_typedef] = ACTIONS(3038),
    [anon_sym_in] = ACTIONS(3038),
    [anon_sym_out] = ACTIONS(3038),
    [anon_sym_inout] = ACTIONS(3038),
    [anon_sym_extern] = ACTIONS(3038),
    [anon_sym___attribute__] = ACTIONS(3038),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3040),
    [anon_sym___declspec] = ACTIONS(3038),
    [anon_sym___based] = ACTIONS(3038),
    [anon_sym___cdecl] = ACTIONS(3038),
    [anon_sym___clrcall] = ACTIONS(3038),
    [anon_sym___stdcall] = ACTIONS(3038),
    [anon_sym___fastcall] = ACTIONS(3038),
    [anon_sym___thiscall] = ACTIONS(3038),
    [anon_sym___vectorcall] = ACTIONS(3038),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_signed] = ACTIONS(3038),
    [anon_sym_unsigned] = ACTIONS(3038),
    [anon_sym_long] = ACTIONS(3038),
    [anon_sym_short] = ACTIONS(3038),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_static] = ACTIONS(3038),
    [anon_sym_register] = ACTIONS(3038),
    [anon_sym_inline] = ACTIONS(3038),
    [anon_sym___inline] = ACTIONS(3038),
    [anon_sym___inline__] = ACTIONS(3038),
    [anon_sym___forceinline] = ACTIONS(3038),
    [anon_sym_thread_local] = ACTIONS(3038),
    [anon_sym___thread] = ACTIONS(3038),
    [anon_sym_const] = ACTIONS(3038),
    [anon_sym_constexpr] = ACTIONS(3038),
    [anon_sym_volatile] = ACTIONS(3038),
    [anon_sym_restrict] = ACTIONS(3038),
    [anon_sym___restrict__] = ACTIONS(3038),
    [anon_sym__Atomic] = ACTIONS(3038),
    [anon_sym__Noreturn] = ACTIONS(3038),
    [anon_sym_noreturn] = ACTIONS(3038),
    [anon_sym_mutable] = ACTIONS(3038),
    [anon_sym_constinit] = ACTIONS(3038),
    [anon_sym_consteval] = ACTIONS(3038),
    [anon_sym_alignas] = ACTIONS(3038),
    [anon_sym__Alignas] = ACTIONS(3038),
    [sym_primitive_type] = ACTIONS(3038),
    [anon_sym_enum] = ACTIONS(3038),
    [anon_sym_class] = ACTIONS(3038),
    [anon_sym_struct] = ACTIONS(3038),
    [anon_sym_union] = ACTIONS(3038),
    [anon_sym_if] = ACTIONS(3038),
    [anon_sym_else] = ACTIONS(3038),
    [anon_sym_switch] = ACTIONS(3038),
    [anon_sym_case] = ACTIONS(3038),
    [anon_sym_default] = ACTIONS(3038),
    [anon_sym_while] = ACTIONS(3038),
    [anon_sym_do] = ACTIONS(3038),
    [anon_sym_for] = ACTIONS(3038),
    [anon_sym_return] = ACTIONS(3038),
    [anon_sym_break] = ACTIONS(3038),
    [anon_sym_continue] = ACTIONS(3038),
    [anon_sym_goto] = ACTIONS(3038),
    [anon_sym___try] = ACTIONS(3038),
    [anon_sym___leave] = ACTIONS(3038),
    [anon_sym_not] = ACTIONS(3038),
    [anon_sym_compl] = ACTIONS(3038),
    [anon_sym_DASH_DASH] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3040),
    [anon_sym_sizeof] = ACTIONS(3038),
    [anon_sym___alignof__] = ACTIONS(3038),
    [anon_sym___alignof] = ACTIONS(3038),
    [anon_sym__alignof] = ACTIONS(3038),
    [anon_sym_alignof] = ACTIONS(3038),
    [anon_sym__Alignof] = ACTIONS(3038),
    [anon_sym_offsetof] = ACTIONS(3038),
    [anon_sym__Generic] = ACTIONS(3038),
    [anon_sym_asm] = ACTIONS(3038),
    [anon_sym___asm__] = ACTIONS(3038),
    [sym_number_literal] = ACTIONS(3040),
    [anon_sym_L_SQUOTE] = ACTIONS(3040),
    [anon_sym_u_SQUOTE] = ACTIONS(3040),
    [anon_sym_U_SQUOTE] = ACTIONS(3040),
    [anon_sym_u8_SQUOTE] = ACTIONS(3040),
    [anon_sym_SQUOTE] = ACTIONS(3040),
    [anon_sym_L_DQUOTE] = ACTIONS(3040),
    [anon_sym_u_DQUOTE] = ACTIONS(3040),
    [anon_sym_U_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8_DQUOTE] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [sym_true] = ACTIONS(3038),
    [sym_false] = ACTIONS(3038),
    [anon_sym_NULL] = ACTIONS(3038),
    [anon_sym_nullptr] = ACTIONS(3038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3038),
    [anon_sym_let] = ACTIONS(3038),
    [anon_sym_This] = ACTIONS(3038),
    [anon_sym_decltype] = ACTIONS(3038),
    [sym_virtual] = ACTIONS(3038),
    [anon_sym_explicit] = ACTIONS(3038),
    [anon_sym_typename] = ACTIONS(3038),
    [anon_sym_template] = ACTIONS(3038),
    [anon_sym_operator] = ACTIONS(3038),
    [anon_sym_try] = ACTIONS(3038),
    [anon_sym_delete] = ACTIONS(3038),
    [anon_sym_throw] = ACTIONS(3038),
    [anon_sym_namespace] = ACTIONS(3038),
    [anon_sym_using] = ACTIONS(3038),
    [anon_sym_static_assert] = ACTIONS(3038),
    [anon_sym_concept] = ACTIONS(3038),
    [anon_sym_co_return] = ACTIONS(3038),
    [anon_sym_co_yield] = ACTIONS(3038),
    [anon_sym_R_DQUOTE] = ACTIONS(3040),
    [anon_sym_LR_DQUOTE] = ACTIONS(3040),
    [anon_sym_uR_DQUOTE] = ACTIONS(3040),
    [anon_sym_UR_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3040),
    [anon_sym_co_await] = ACTIONS(3038),
    [anon_sym_new] = ACTIONS(3038),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3038),
    [anon_sym_discard] = ACTIONS(3038),
    [anon_sym_precise] = ACTIONS(3038),
    [anon_sym_shared] = ACTIONS(3038),
    [anon_sym_groupshared] = ACTIONS(3038),
    [anon_sym_uniform] = ACTIONS(3038),
    [anon_sym_row_major] = ACTIONS(3038),
    [anon_sym_column_major] = ACTIONS(3038),
    [anon_sym_globallycoherent] = ACTIONS(3038),
    [anon_sym_centroid] = ACTIONS(3038),
    [anon_sym_noperspective] = ACTIONS(3038),
    [anon_sym_nointerpolation] = ACTIONS(3038),
    [anon_sym_sample] = ACTIONS(3038),
    [anon_sym_linear] = ACTIONS(3038),
    [anon_sym_snorm] = ACTIONS(3038),
    [anon_sym_unorm] = ACTIONS(3038),
    [anon_sym_point] = ACTIONS(3038),
    [anon_sym_line] = ACTIONS(3038),
    [anon_sym_triangleadj] = ACTIONS(3038),
    [anon_sym_lineadj] = ACTIONS(3038),
    [anon_sym_triangle] = ACTIONS(3038),
    [anon_sym_cbuffer] = ACTIONS(3038),
    [anon_sym_interface] = ACTIONS(3038),
    [anon_sym_extension] = ACTIONS(3038),
    [anon_sym___exported] = ACTIONS(3038),
    [anon_sym_import] = ACTIONS(3038),
  },
  [570] = {
    [ts_builtin_sym_end] = ACTIONS(3244),
    [sym_identifier] = ACTIONS(3242),
    [aux_sym_preproc_include_token1] = ACTIONS(3242),
    [aux_sym_preproc_def_token1] = ACTIONS(3242),
    [aux_sym_preproc_if_token1] = ACTIONS(3242),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3242),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3242),
    [sym_preproc_directive] = ACTIONS(3242),
    [anon_sym_LPAREN2] = ACTIONS(3244),
    [anon_sym_BANG] = ACTIONS(3244),
    [anon_sym_TILDE] = ACTIONS(3244),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_STAR] = ACTIONS(3244),
    [anon_sym_AMP_AMP] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_SEMI] = ACTIONS(3244),
    [anon_sym___extension__] = ACTIONS(3242),
    [anon_sym_typedef] = ACTIONS(3242),
    [anon_sym_in] = ACTIONS(3242),
    [anon_sym_out] = ACTIONS(3242),
    [anon_sym_inout] = ACTIONS(3242),
    [anon_sym_extern] = ACTIONS(3242),
    [anon_sym___attribute__] = ACTIONS(3242),
    [anon_sym_COLON_COLON] = ACTIONS(3244),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3244),
    [anon_sym___declspec] = ACTIONS(3242),
    [anon_sym___based] = ACTIONS(3242),
    [anon_sym___cdecl] = ACTIONS(3242),
    [anon_sym___clrcall] = ACTIONS(3242),
    [anon_sym___stdcall] = ACTIONS(3242),
    [anon_sym___fastcall] = ACTIONS(3242),
    [anon_sym___thiscall] = ACTIONS(3242),
    [anon_sym___vectorcall] = ACTIONS(3242),
    [anon_sym_LBRACE] = ACTIONS(3244),
    [anon_sym_signed] = ACTIONS(3242),
    [anon_sym_unsigned] = ACTIONS(3242),
    [anon_sym_long] = ACTIONS(3242),
    [anon_sym_short] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_static] = ACTIONS(3242),
    [anon_sym_register] = ACTIONS(3242),
    [anon_sym_inline] = ACTIONS(3242),
    [anon_sym___inline] = ACTIONS(3242),
    [anon_sym___inline__] = ACTIONS(3242),
    [anon_sym___forceinline] = ACTIONS(3242),
    [anon_sym_thread_local] = ACTIONS(3242),
    [anon_sym___thread] = ACTIONS(3242),
    [anon_sym_const] = ACTIONS(3242),
    [anon_sym_constexpr] = ACTIONS(3242),
    [anon_sym_volatile] = ACTIONS(3242),
    [anon_sym_restrict] = ACTIONS(3242),
    [anon_sym___restrict__] = ACTIONS(3242),
    [anon_sym__Atomic] = ACTIONS(3242),
    [anon_sym__Noreturn] = ACTIONS(3242),
    [anon_sym_noreturn] = ACTIONS(3242),
    [anon_sym_mutable] = ACTIONS(3242),
    [anon_sym_constinit] = ACTIONS(3242),
    [anon_sym_consteval] = ACTIONS(3242),
    [anon_sym_alignas] = ACTIONS(3242),
    [anon_sym__Alignas] = ACTIONS(3242),
    [sym_primitive_type] = ACTIONS(3242),
    [anon_sym_enum] = ACTIONS(3242),
    [anon_sym_class] = ACTIONS(3242),
    [anon_sym_struct] = ACTIONS(3242),
    [anon_sym_union] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_else] = ACTIONS(3242),
    [anon_sym_switch] = ACTIONS(3242),
    [anon_sym_case] = ACTIONS(3242),
    [anon_sym_default] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_break] = ACTIONS(3242),
    [anon_sym_continue] = ACTIONS(3242),
    [anon_sym_goto] = ACTIONS(3242),
    [anon_sym___try] = ACTIONS(3242),
    [anon_sym___leave] = ACTIONS(3242),
    [anon_sym_not] = ACTIONS(3242),
    [anon_sym_compl] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3244),
    [anon_sym_PLUS_PLUS] = ACTIONS(3244),
    [anon_sym_sizeof] = ACTIONS(3242),
    [anon_sym___alignof__] = ACTIONS(3242),
    [anon_sym___alignof] = ACTIONS(3242),
    [anon_sym__alignof] = ACTIONS(3242),
    [anon_sym_alignof] = ACTIONS(3242),
    [anon_sym__Alignof] = ACTIONS(3242),
    [anon_sym_offsetof] = ACTIONS(3242),
    [anon_sym__Generic] = ACTIONS(3242),
    [anon_sym_asm] = ACTIONS(3242),
    [anon_sym___asm__] = ACTIONS(3242),
    [sym_number_literal] = ACTIONS(3244),
    [anon_sym_L_SQUOTE] = ACTIONS(3244),
    [anon_sym_u_SQUOTE] = ACTIONS(3244),
    [anon_sym_U_SQUOTE] = ACTIONS(3244),
    [anon_sym_u8_SQUOTE] = ACTIONS(3244),
    [anon_sym_SQUOTE] = ACTIONS(3244),
    [anon_sym_L_DQUOTE] = ACTIONS(3244),
    [anon_sym_u_DQUOTE] = ACTIONS(3244),
    [anon_sym_U_DQUOTE] = ACTIONS(3244),
    [anon_sym_u8_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE] = ACTIONS(3244),
    [sym_true] = ACTIONS(3242),
    [sym_false] = ACTIONS(3242),
    [anon_sym_NULL] = ACTIONS(3242),
    [anon_sym_nullptr] = ACTIONS(3242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_This] = ACTIONS(3242),
    [anon_sym_decltype] = ACTIONS(3242),
    [sym_virtual] = ACTIONS(3242),
    [anon_sym_explicit] = ACTIONS(3242),
    [anon_sym_typename] = ACTIONS(3242),
    [anon_sym_template] = ACTIONS(3242),
    [anon_sym_operator] = ACTIONS(3242),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_delete] = ACTIONS(3242),
    [anon_sym_throw] = ACTIONS(3242),
    [anon_sym_namespace] = ACTIONS(3242),
    [anon_sym_using] = ACTIONS(3242),
    [anon_sym_static_assert] = ACTIONS(3242),
    [anon_sym_concept] = ACTIONS(3242),
    [anon_sym_co_return] = ACTIONS(3242),
    [anon_sym_co_yield] = ACTIONS(3242),
    [anon_sym_R_DQUOTE] = ACTIONS(3244),
    [anon_sym_LR_DQUOTE] = ACTIONS(3244),
    [anon_sym_uR_DQUOTE] = ACTIONS(3244),
    [anon_sym_UR_DQUOTE] = ACTIONS(3244),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3244),
    [anon_sym_co_await] = ACTIONS(3242),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_requires] = ACTIONS(3242),
    [sym_this] = ACTIONS(3242),
    [anon_sym_discard] = ACTIONS(3242),
    [anon_sym_precise] = ACTIONS(3242),
    [anon_sym_shared] = ACTIONS(3242),
    [anon_sym_groupshared] = ACTIONS(3242),
    [anon_sym_uniform] = ACTIONS(3242),
    [anon_sym_row_major] = ACTIONS(3242),
    [anon_sym_column_major] = ACTIONS(3242),
    [anon_sym_globallycoherent] = ACTIONS(3242),
    [anon_sym_centroid] = ACTIONS(3242),
    [anon_sym_noperspective] = ACTIONS(3242),
    [anon_sym_nointerpolation] = ACTIONS(3242),
    [anon_sym_sample] = ACTIONS(3242),
    [anon_sym_linear] = ACTIONS(3242),
    [anon_sym_snorm] = ACTIONS(3242),
    [anon_sym_unorm] = ACTIONS(3242),
    [anon_sym_point] = ACTIONS(3242),
    [anon_sym_line] = ACTIONS(3242),
    [anon_sym_triangleadj] = ACTIONS(3242),
    [anon_sym_lineadj] = ACTIONS(3242),
    [anon_sym_triangle] = ACTIONS(3242),
    [anon_sym_cbuffer] = ACTIONS(3242),
    [anon_sym_interface] = ACTIONS(3242),
    [anon_sym_extension] = ACTIONS(3242),
    [anon_sym___exported] = ACTIONS(3242),
    [anon_sym_import] = ACTIONS(3242),
  },
  [571] = {
    [sym_catch_clause] = STATE(445),
    [aux_sym_constructor_try_statement_repeat1] = STATE(445),
    [sym_identifier] = ACTIONS(2744),
    [aux_sym_preproc_include_token1] = ACTIONS(2744),
    [aux_sym_preproc_def_token1] = ACTIONS(2744),
    [aux_sym_preproc_if_token1] = ACTIONS(2744),
    [aux_sym_preproc_if_token2] = ACTIONS(2744),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2744),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2744),
    [sym_preproc_directive] = ACTIONS(2744),
    [anon_sym_LPAREN2] = ACTIONS(2746),
    [anon_sym_BANG] = ACTIONS(2746),
    [anon_sym_TILDE] = ACTIONS(2746),
    [anon_sym_DASH] = ACTIONS(2744),
    [anon_sym_PLUS] = ACTIONS(2744),
    [anon_sym_STAR] = ACTIONS(2746),
    [anon_sym_AMP_AMP] = ACTIONS(2746),
    [anon_sym_AMP] = ACTIONS(2744),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym___extension__] = ACTIONS(2744),
    [anon_sym_typedef] = ACTIONS(2744),
    [anon_sym_in] = ACTIONS(2744),
    [anon_sym_out] = ACTIONS(2744),
    [anon_sym_inout] = ACTIONS(2744),
    [anon_sym_extern] = ACTIONS(2744),
    [anon_sym___attribute__] = ACTIONS(2744),
    [anon_sym_COLON_COLON] = ACTIONS(2746),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2746),
    [anon_sym___declspec] = ACTIONS(2744),
    [anon_sym___based] = ACTIONS(2744),
    [anon_sym___cdecl] = ACTIONS(2744),
    [anon_sym___clrcall] = ACTIONS(2744),
    [anon_sym___stdcall] = ACTIONS(2744),
    [anon_sym___fastcall] = ACTIONS(2744),
    [anon_sym___thiscall] = ACTIONS(2744),
    [anon_sym___vectorcall] = ACTIONS(2744),
    [anon_sym_LBRACE] = ACTIONS(2746),
    [anon_sym_signed] = ACTIONS(2744),
    [anon_sym_unsigned] = ACTIONS(2744),
    [anon_sym_long] = ACTIONS(2744),
    [anon_sym_short] = ACTIONS(2744),
    [anon_sym_LBRACK] = ACTIONS(2744),
    [anon_sym_static] = ACTIONS(2744),
    [anon_sym_register] = ACTIONS(2744),
    [anon_sym_inline] = ACTIONS(2744),
    [anon_sym___inline] = ACTIONS(2744),
    [anon_sym___inline__] = ACTIONS(2744),
    [anon_sym___forceinline] = ACTIONS(2744),
    [anon_sym_thread_local] = ACTIONS(2744),
    [anon_sym___thread] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_constexpr] = ACTIONS(2744),
    [anon_sym_volatile] = ACTIONS(2744),
    [anon_sym_restrict] = ACTIONS(2744),
    [anon_sym___restrict__] = ACTIONS(2744),
    [anon_sym__Atomic] = ACTIONS(2744),
    [anon_sym__Noreturn] = ACTIONS(2744),
    [anon_sym_noreturn] = ACTIONS(2744),
    [anon_sym_mutable] = ACTIONS(2744),
    [anon_sym_constinit] = ACTIONS(2744),
    [anon_sym_consteval] = ACTIONS(2744),
    [anon_sym_alignas] = ACTIONS(2744),
    [anon_sym__Alignas] = ACTIONS(2744),
    [sym_primitive_type] = ACTIONS(2744),
    [anon_sym_enum] = ACTIONS(2744),
    [anon_sym_class] = ACTIONS(2744),
    [anon_sym_struct] = ACTIONS(2744),
    [anon_sym_union] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2744),
    [anon_sym_switch] = ACTIONS(2744),
    [anon_sym_case] = ACTIONS(2744),
    [anon_sym_default] = ACTIONS(2744),
    [anon_sym_while] = ACTIONS(2744),
    [anon_sym_do] = ACTIONS(2744),
    [anon_sym_for] = ACTIONS(2744),
    [anon_sym_return] = ACTIONS(2744),
    [anon_sym_break] = ACTIONS(2744),
    [anon_sym_continue] = ACTIONS(2744),
    [anon_sym_goto] = ACTIONS(2744),
    [anon_sym___try] = ACTIONS(2744),
    [anon_sym___leave] = ACTIONS(2744),
    [anon_sym_not] = ACTIONS(2744),
    [anon_sym_compl] = ACTIONS(2744),
    [anon_sym_DASH_DASH] = ACTIONS(2746),
    [anon_sym_PLUS_PLUS] = ACTIONS(2746),
    [anon_sym_sizeof] = ACTIONS(2744),
    [anon_sym___alignof__] = ACTIONS(2744),
    [anon_sym___alignof] = ACTIONS(2744),
    [anon_sym__alignof] = ACTIONS(2744),
    [anon_sym_alignof] = ACTIONS(2744),
    [anon_sym__Alignof] = ACTIONS(2744),
    [anon_sym_offsetof] = ACTIONS(2744),
    [anon_sym__Generic] = ACTIONS(2744),
    [anon_sym_asm] = ACTIONS(2744),
    [anon_sym___asm__] = ACTIONS(2744),
    [sym_number_literal] = ACTIONS(2746),
    [anon_sym_L_SQUOTE] = ACTIONS(2746),
    [anon_sym_u_SQUOTE] = ACTIONS(2746),
    [anon_sym_U_SQUOTE] = ACTIONS(2746),
    [anon_sym_u8_SQUOTE] = ACTIONS(2746),
    [anon_sym_SQUOTE] = ACTIONS(2746),
    [anon_sym_L_DQUOTE] = ACTIONS(2746),
    [anon_sym_u_DQUOTE] = ACTIONS(2746),
    [anon_sym_U_DQUOTE] = ACTIONS(2746),
    [anon_sym_u8_DQUOTE] = ACTIONS(2746),
    [anon_sym_DQUOTE] = ACTIONS(2746),
    [sym_true] = ACTIONS(2744),
    [sym_false] = ACTIONS(2744),
    [anon_sym_NULL] = ACTIONS(2744),
    [anon_sym_nullptr] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2744),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_This] = ACTIONS(2744),
    [anon_sym_decltype] = ACTIONS(2744),
    [sym_virtual] = ACTIONS(2744),
    [anon_sym_explicit] = ACTIONS(2744),
    [anon_sym_typename] = ACTIONS(2744),
    [anon_sym_template] = ACTIONS(2744),
    [anon_sym_operator] = ACTIONS(2744),
    [anon_sym_try] = ACTIONS(2744),
    [anon_sym_delete] = ACTIONS(2744),
    [anon_sym_throw] = ACTIONS(2744),
    [anon_sym_namespace] = ACTIONS(2744),
    [anon_sym_using] = ACTIONS(2744),
    [anon_sym_static_assert] = ACTIONS(2744),
    [anon_sym_concept] = ACTIONS(2744),
    [anon_sym_co_return] = ACTIONS(2744),
    [anon_sym_co_yield] = ACTIONS(2744),
    [anon_sym_catch] = ACTIONS(3529),
    [anon_sym_R_DQUOTE] = ACTIONS(2746),
    [anon_sym_LR_DQUOTE] = ACTIONS(2746),
    [anon_sym_uR_DQUOTE] = ACTIONS(2746),
    [anon_sym_UR_DQUOTE] = ACTIONS(2746),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2746),
    [anon_sym_co_await] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(2744),
    [anon_sym_requires] = ACTIONS(2744),
    [sym_this] = ACTIONS(2744),
    [anon_sym_discard] = ACTIONS(2744),
    [anon_sym_precise] = ACTIONS(2744),
    [anon_sym_shared] = ACTIONS(2744),
    [anon_sym_groupshared] = ACTIONS(2744),
    [anon_sym_uniform] = ACTIONS(2744),
    [anon_sym_row_major] = ACTIONS(2744),
    [anon_sym_column_major] = ACTIONS(2744),
    [anon_sym_globallycoherent] = ACTIONS(2744),
    [anon_sym_centroid] = ACTIONS(2744),
    [anon_sym_noperspective] = ACTIONS(2744),
    [anon_sym_nointerpolation] = ACTIONS(2744),
    [anon_sym_sample] = ACTIONS(2744),
    [anon_sym_linear] = ACTIONS(2744),
    [anon_sym_snorm] = ACTIONS(2744),
    [anon_sym_unorm] = ACTIONS(2744),
    [anon_sym_point] = ACTIONS(2744),
    [anon_sym_line] = ACTIONS(2744),
    [anon_sym_triangleadj] = ACTIONS(2744),
    [anon_sym_lineadj] = ACTIONS(2744),
    [anon_sym_triangle] = ACTIONS(2744),
    [anon_sym_cbuffer] = ACTIONS(2744),
    [anon_sym_interface] = ACTIONS(2744),
    [anon_sym_extension] = ACTIONS(2744),
  },
  [572] = {
    [sym_attribute_specifier] = STATE(388),
    [sym_enumerator_list] = STATE(991),
    [sym__enum_base_clause] = STATE(655),
    [ts_builtin_sym_end] = ACTIONS(3062),
    [sym_identifier] = ACTIONS(3060),
    [aux_sym_preproc_include_token1] = ACTIONS(3060),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3060),
    [sym_preproc_directive] = ACTIONS(3060),
    [anon_sym_LPAREN2] = ACTIONS(3062),
    [anon_sym_BANG] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3062),
    [anon_sym_DASH] = ACTIONS(3060),
    [anon_sym_PLUS] = ACTIONS(3060),
    [anon_sym_STAR] = ACTIONS(3062),
    [anon_sym_AMP_AMP] = ACTIONS(3062),
    [anon_sym_AMP] = ACTIONS(3060),
    [anon_sym_COLON] = ACTIONS(3707),
    [anon_sym_SEMI] = ACTIONS(3062),
    [anon_sym___extension__] = ACTIONS(3060),
    [anon_sym_typedef] = ACTIONS(3060),
    [anon_sym_in] = ACTIONS(3060),
    [anon_sym_out] = ACTIONS(3060),
    [anon_sym_inout] = ACTIONS(3060),
    [anon_sym_extern] = ACTIONS(3060),
    [anon_sym___attribute__] = ACTIONS(2861),
    [anon_sym_COLON_COLON] = ACTIONS(3062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3062),
    [anon_sym___declspec] = ACTIONS(3060),
    [anon_sym___based] = ACTIONS(3060),
    [anon_sym___cdecl] = ACTIONS(3060),
    [anon_sym___clrcall] = ACTIONS(3060),
    [anon_sym___stdcall] = ACTIONS(3060),
    [anon_sym___fastcall] = ACTIONS(3060),
    [anon_sym___thiscall] = ACTIONS(3060),
    [anon_sym___vectorcall] = ACTIONS(3060),
    [anon_sym_LBRACE] = ACTIONS(3709),
    [anon_sym_signed] = ACTIONS(3060),
    [anon_sym_unsigned] = ACTIONS(3060),
    [anon_sym_long] = ACTIONS(3060),
    [anon_sym_short] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(3060),
    [anon_sym_static] = ACTIONS(3060),
    [anon_sym_register] = ACTIONS(3060),
    [anon_sym_inline] = ACTIONS(3060),
    [anon_sym___inline] = ACTIONS(3060),
    [anon_sym___inline__] = ACTIONS(3060),
    [anon_sym___forceinline] = ACTIONS(3060),
    [anon_sym_thread_local] = ACTIONS(3060),
    [anon_sym___thread] = ACTIONS(3060),
    [anon_sym_const] = ACTIONS(3060),
    [anon_sym_constexpr] = ACTIONS(3060),
    [anon_sym_volatile] = ACTIONS(3060),
    [anon_sym_restrict] = ACTIONS(3060),
    [anon_sym___restrict__] = ACTIONS(3060),
    [anon_sym__Atomic] = ACTIONS(3060),
    [anon_sym__Noreturn] = ACTIONS(3060),
    [anon_sym_noreturn] = ACTIONS(3060),
    [anon_sym_mutable] = ACTIONS(3060),
    [anon_sym_constinit] = ACTIONS(3060),
    [anon_sym_consteval] = ACTIONS(3060),
    [anon_sym_alignas] = ACTIONS(3060),
    [anon_sym__Alignas] = ACTIONS(3060),
    [sym_primitive_type] = ACTIONS(3060),
    [anon_sym_enum] = ACTIONS(3060),
    [anon_sym_class] = ACTIONS(3060),
    [anon_sym_struct] = ACTIONS(3060),
    [anon_sym_union] = ACTIONS(3060),
    [anon_sym_if] = ACTIONS(3060),
    [anon_sym_switch] = ACTIONS(3060),
    [anon_sym_case] = ACTIONS(3060),
    [anon_sym_default] = ACTIONS(3060),
    [anon_sym_while] = ACTIONS(3060),
    [anon_sym_do] = ACTIONS(3060),
    [anon_sym_for] = ACTIONS(3060),
    [anon_sym_return] = ACTIONS(3060),
    [anon_sym_break] = ACTIONS(3060),
    [anon_sym_continue] = ACTIONS(3060),
    [anon_sym_goto] = ACTIONS(3060),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_compl] = ACTIONS(3060),
    [anon_sym_DASH_DASH] = ACTIONS(3062),
    [anon_sym_PLUS_PLUS] = ACTIONS(3062),
    [anon_sym_sizeof] = ACTIONS(3060),
    [anon_sym___alignof__] = ACTIONS(3060),
    [anon_sym___alignof] = ACTIONS(3060),
    [anon_sym__alignof] = ACTIONS(3060),
    [anon_sym_alignof] = ACTIONS(3060),
    [anon_sym__Alignof] = ACTIONS(3060),
    [anon_sym_offsetof] = ACTIONS(3060),
    [anon_sym__Generic] = ACTIONS(3060),
    [anon_sym_asm] = ACTIONS(3060),
    [anon_sym___asm__] = ACTIONS(3060),
    [anon_sym_DOT] = ACTIONS(3060),
    [sym_number_literal] = ACTIONS(3062),
    [anon_sym_L_SQUOTE] = ACTIONS(3062),
    [anon_sym_u_SQUOTE] = ACTIONS(3062),
    [anon_sym_U_SQUOTE] = ACTIONS(3062),
    [anon_sym_u8_SQUOTE] = ACTIONS(3062),
    [anon_sym_SQUOTE] = ACTIONS(3062),
    [anon_sym_L_DQUOTE] = ACTIONS(3062),
    [anon_sym_u_DQUOTE] = ACTIONS(3062),
    [anon_sym_U_DQUOTE] = ACTIONS(3062),
    [anon_sym_u8_DQUOTE] = ACTIONS(3062),
    [anon_sym_DQUOTE] = ACTIONS(3062),
    [sym_true] = ACTIONS(3060),
    [sym_false] = ACTIONS(3060),
    [anon_sym_NULL] = ACTIONS(3060),
    [anon_sym_nullptr] = ACTIONS(3060),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3060),
    [anon_sym_let] = ACTIONS(3060),
    [anon_sym_This] = ACTIONS(3060),
    [anon_sym_decltype] = ACTIONS(3060),
    [sym_virtual] = ACTIONS(3060),
    [anon_sym_explicit] = ACTIONS(3060),
    [anon_sym_typename] = ACTIONS(3060),
    [anon_sym_template] = ACTIONS(3060),
    [anon_sym_operator] = ACTIONS(3060),
    [anon_sym_try] = ACTIONS(3060),
    [anon_sym_delete] = ACTIONS(3060),
    [anon_sym_throw] = ACTIONS(3060),
    [anon_sym_namespace] = ACTIONS(3060),
    [anon_sym_using] = ACTIONS(3060),
    [anon_sym_static_assert] = ACTIONS(3060),
    [anon_sym_concept] = ACTIONS(3060),
    [anon_sym_co_return] = ACTIONS(3060),
    [anon_sym_co_yield] = ACTIONS(3060),
    [anon_sym_R_DQUOTE] = ACTIONS(3062),
    [anon_sym_LR_DQUOTE] = ACTIONS(3062),
    [anon_sym_uR_DQUOTE] = ACTIONS(3062),
    [anon_sym_UR_DQUOTE] = ACTIONS(3062),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3062),
    [anon_sym_co_await] = ACTIONS(3060),
    [anon_sym_new] = ACTIONS(3060),
    [anon_sym_requires] = ACTIONS(3060),
    [sym_this] = ACTIONS(3060),
    [anon_sym_precise] = ACTIONS(3060),
    [anon_sym_shared] = ACTIONS(3060),
    [anon_sym_groupshared] = ACTIONS(3060),
    [anon_sym_uniform] = ACTIONS(3060),
    [anon_sym_row_major] = ACTIONS(3060),
    [anon_sym_column_major] = ACTIONS(3060),
    [anon_sym_globallycoherent] = ACTIONS(3060),
    [anon_sym_centroid] = ACTIONS(3060),
    [anon_sym_noperspective] = ACTIONS(3060),
    [anon_sym_nointerpolation] = ACTIONS(3060),
    [anon_sym_sample] = ACTIONS(3060),
    [anon_sym_linear] = ACTIONS(3060),
    [anon_sym_snorm] = ACTIONS(3060),
    [anon_sym_unorm] = ACTIONS(3060),
    [anon_sym_point] = ACTIONS(3060),
    [anon_sym_line] = ACTIONS(3060),
    [anon_sym_triangleadj] = ACTIONS(3060),
    [anon_sym_lineadj] = ACTIONS(3060),
    [anon_sym_triangle] = ACTIONS(3060),
    [anon_sym_interface] = ACTIONS(3060),
    [anon_sym_extension] = ACTIONS(3060),
    [anon_sym___exported] = ACTIONS(3060),
    [anon_sym_import] = ACTIONS(3060),
  },
  [573] = {
    [sym_attribute_specifier] = STATE(438),
    [sym_enumerator_list] = STATE(975),
    [sym__enum_base_clause] = STATE(669),
    [ts_builtin_sym_end] = ACTIONS(3350),
    [sym_identifier] = ACTIONS(3348),
    [aux_sym_preproc_include_token1] = ACTIONS(3348),
    [aux_sym_preproc_def_token1] = ACTIONS(3348),
    [aux_sym_preproc_if_token1] = ACTIONS(3348),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3348),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3348),
    [sym_preproc_directive] = ACTIONS(3348),
    [anon_sym_LPAREN2] = ACTIONS(3350),
    [anon_sym_BANG] = ACTIONS(3350),
    [anon_sym_TILDE] = ACTIONS(3350),
    [anon_sym_DASH] = ACTIONS(3348),
    [anon_sym_PLUS] = ACTIONS(3348),
    [anon_sym_STAR] = ACTIONS(3350),
    [anon_sym_AMP_AMP] = ACTIONS(3350),
    [anon_sym_AMP] = ACTIONS(3348),
    [anon_sym_COLON] = ACTIONS(3707),
    [anon_sym_SEMI] = ACTIONS(3350),
    [anon_sym___extension__] = ACTIONS(3348),
    [anon_sym_typedef] = ACTIONS(3348),
    [anon_sym_in] = ACTIONS(3348),
    [anon_sym_out] = ACTIONS(3348),
    [anon_sym_inout] = ACTIONS(3348),
    [anon_sym_extern] = ACTIONS(3348),
    [anon_sym___attribute__] = ACTIONS(2861),
    [anon_sym_COLON_COLON] = ACTIONS(3350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3350),
    [anon_sym___declspec] = ACTIONS(3348),
    [anon_sym___based] = ACTIONS(3348),
    [anon_sym___cdecl] = ACTIONS(3348),
    [anon_sym___clrcall] = ACTIONS(3348),
    [anon_sym___stdcall] = ACTIONS(3348),
    [anon_sym___fastcall] = ACTIONS(3348),
    [anon_sym___thiscall] = ACTIONS(3348),
    [anon_sym___vectorcall] = ACTIONS(3348),
    [anon_sym_LBRACE] = ACTIONS(3709),
    [anon_sym_signed] = ACTIONS(3348),
    [anon_sym_unsigned] = ACTIONS(3348),
    [anon_sym_long] = ACTIONS(3348),
    [anon_sym_short] = ACTIONS(3348),
    [anon_sym_LBRACK] = ACTIONS(3348),
    [anon_sym_static] = ACTIONS(3348),
    [anon_sym_register] = ACTIONS(3348),
    [anon_sym_inline] = ACTIONS(3348),
    [anon_sym___inline] = ACTIONS(3348),
    [anon_sym___inline__] = ACTIONS(3348),
    [anon_sym___forceinline] = ACTIONS(3348),
    [anon_sym_thread_local] = ACTIONS(3348),
    [anon_sym___thread] = ACTIONS(3348),
    [anon_sym_const] = ACTIONS(3348),
    [anon_sym_constexpr] = ACTIONS(3348),
    [anon_sym_volatile] = ACTIONS(3348),
    [anon_sym_restrict] = ACTIONS(3348),
    [anon_sym___restrict__] = ACTIONS(3348),
    [anon_sym__Atomic] = ACTIONS(3348),
    [anon_sym__Noreturn] = ACTIONS(3348),
    [anon_sym_noreturn] = ACTIONS(3348),
    [anon_sym_mutable] = ACTIONS(3348),
    [anon_sym_constinit] = ACTIONS(3348),
    [anon_sym_consteval] = ACTIONS(3348),
    [anon_sym_alignas] = ACTIONS(3348),
    [anon_sym__Alignas] = ACTIONS(3348),
    [sym_primitive_type] = ACTIONS(3348),
    [anon_sym_enum] = ACTIONS(3348),
    [anon_sym_class] = ACTIONS(3348),
    [anon_sym_struct] = ACTIONS(3348),
    [anon_sym_union] = ACTIONS(3348),
    [anon_sym_if] = ACTIONS(3348),
    [anon_sym_switch] = ACTIONS(3348),
    [anon_sym_case] = ACTIONS(3348),
    [anon_sym_default] = ACTIONS(3348),
    [anon_sym_while] = ACTIONS(3348),
    [anon_sym_do] = ACTIONS(3348),
    [anon_sym_for] = ACTIONS(3348),
    [anon_sym_return] = ACTIONS(3348),
    [anon_sym_break] = ACTIONS(3348),
    [anon_sym_continue] = ACTIONS(3348),
    [anon_sym_goto] = ACTIONS(3348),
    [anon_sym_not] = ACTIONS(3348),
    [anon_sym_compl] = ACTIONS(3348),
    [anon_sym_DASH_DASH] = ACTIONS(3350),
    [anon_sym_PLUS_PLUS] = ACTIONS(3350),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(3348),
    [anon_sym___alignof] = ACTIONS(3348),
    [anon_sym__alignof] = ACTIONS(3348),
    [anon_sym_alignof] = ACTIONS(3348),
    [anon_sym__Alignof] = ACTIONS(3348),
    [anon_sym_offsetof] = ACTIONS(3348),
    [anon_sym__Generic] = ACTIONS(3348),
    [anon_sym_asm] = ACTIONS(3348),
    [anon_sym___asm__] = ACTIONS(3348),
    [anon_sym_DOT] = ACTIONS(3348),
    [sym_number_literal] = ACTIONS(3350),
    [anon_sym_L_SQUOTE] = ACTIONS(3350),
    [anon_sym_u_SQUOTE] = ACTIONS(3350),
    [anon_sym_U_SQUOTE] = ACTIONS(3350),
    [anon_sym_u8_SQUOTE] = ACTIONS(3350),
    [anon_sym_SQUOTE] = ACTIONS(3350),
    [anon_sym_L_DQUOTE] = ACTIONS(3350),
    [anon_sym_u_DQUOTE] = ACTIONS(3350),
    [anon_sym_U_DQUOTE] = ACTIONS(3350),
    [anon_sym_u8_DQUOTE] = ACTIONS(3350),
    [anon_sym_DQUOTE] = ACTIONS(3350),
    [sym_true] = ACTIONS(3348),
    [sym_false] = ACTIONS(3348),
    [anon_sym_NULL] = ACTIONS(3348),
    [anon_sym_nullptr] = ACTIONS(3348),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3348),
    [anon_sym_let] = ACTIONS(3348),
    [anon_sym_This] = ACTIONS(3348),
    [anon_sym_decltype] = ACTIONS(3348),
    [sym_virtual] = ACTIONS(3348),
    [anon_sym_explicit] = ACTIONS(3348),
    [anon_sym_typename] = ACTIONS(3348),
    [anon_sym_template] = ACTIONS(3348),
    [anon_sym_operator] = ACTIONS(3348),
    [anon_sym_try] = ACTIONS(3348),
    [anon_sym_delete] = ACTIONS(3348),
    [anon_sym_throw] = ACTIONS(3348),
    [anon_sym_namespace] = ACTIONS(3348),
    [anon_sym_using] = ACTIONS(3348),
    [anon_sym_static_assert] = ACTIONS(3348),
    [anon_sym_concept] = ACTIONS(3348),
    [anon_sym_co_return] = ACTIONS(3348),
    [anon_sym_co_yield] = ACTIONS(3348),
    [anon_sym_R_DQUOTE] = ACTIONS(3350),
    [anon_sym_LR_DQUOTE] = ACTIONS(3350),
    [anon_sym_uR_DQUOTE] = ACTIONS(3350),
    [anon_sym_UR_DQUOTE] = ACTIONS(3350),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3350),
    [anon_sym_co_await] = ACTIONS(3348),
    [anon_sym_new] = ACTIONS(3348),
    [anon_sym_requires] = ACTIONS(3348),
    [sym_this] = ACTIONS(3348),
    [anon_sym_precise] = ACTIONS(3348),
    [anon_sym_shared] = ACTIONS(3348),
    [anon_sym_groupshared] = ACTIONS(3348),
    [anon_sym_uniform] = ACTIONS(3348),
    [anon_sym_row_major] = ACTIONS(3348),
    [anon_sym_column_major] = ACTIONS(3348),
    [anon_sym_globallycoherent] = ACTIONS(3348),
    [anon_sym_centroid] = ACTIONS(3348),
    [anon_sym_noperspective] = ACTIONS(3348),
    [anon_sym_nointerpolation] = ACTIONS(3348),
    [anon_sym_sample] = ACTIONS(3348),
    [anon_sym_linear] = ACTIONS(3348),
    [anon_sym_snorm] = ACTIONS(3348),
    [anon_sym_unorm] = ACTIONS(3348),
    [anon_sym_point] = ACTIONS(3348),
    [anon_sym_line] = ACTIONS(3348),
    [anon_sym_triangleadj] = ACTIONS(3348),
    [anon_sym_lineadj] = ACTIONS(3348),
    [anon_sym_triangle] = ACTIONS(3348),
    [anon_sym_interface] = ACTIONS(3348),
    [anon_sym_extension] = ACTIONS(3348),
    [anon_sym___exported] = ACTIONS(3348),
    [anon_sym_import] = ACTIONS(3348),
  },
  [574] = {
    [ts_builtin_sym_end] = ACTIONS(3316),
    [sym_identifier] = ACTIONS(3314),
    [aux_sym_preproc_include_token1] = ACTIONS(3314),
    [aux_sym_preproc_def_token1] = ACTIONS(3314),
    [aux_sym_preproc_if_token1] = ACTIONS(3314),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3314),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3314),
    [sym_preproc_directive] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3316),
    [anon_sym_BANG] = ACTIONS(3316),
    [anon_sym_TILDE] = ACTIONS(3316),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_STAR] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_SEMI] = ACTIONS(3316),
    [anon_sym___extension__] = ACTIONS(3314),
    [anon_sym_typedef] = ACTIONS(3314),
    [anon_sym_in] = ACTIONS(3314),
    [anon_sym_out] = ACTIONS(3314),
    [anon_sym_inout] = ACTIONS(3314),
    [anon_sym_extern] = ACTIONS(3314),
    [anon_sym___attribute__] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3316),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3316),
    [anon_sym___declspec] = ACTIONS(3314),
    [anon_sym___based] = ACTIONS(3314),
    [anon_sym___cdecl] = ACTIONS(3314),
    [anon_sym___clrcall] = ACTIONS(3314),
    [anon_sym___stdcall] = ACTIONS(3314),
    [anon_sym___fastcall] = ACTIONS(3314),
    [anon_sym___thiscall] = ACTIONS(3314),
    [anon_sym___vectorcall] = ACTIONS(3314),
    [anon_sym_LBRACE] = ACTIONS(3316),
    [anon_sym_signed] = ACTIONS(3314),
    [anon_sym_unsigned] = ACTIONS(3314),
    [anon_sym_long] = ACTIONS(3314),
    [anon_sym_short] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_static] = ACTIONS(3314),
    [anon_sym_register] = ACTIONS(3314),
    [anon_sym_inline] = ACTIONS(3314),
    [anon_sym___inline] = ACTIONS(3314),
    [anon_sym___inline__] = ACTIONS(3314),
    [anon_sym___forceinline] = ACTIONS(3314),
    [anon_sym_thread_local] = ACTIONS(3314),
    [anon_sym___thread] = ACTIONS(3314),
    [anon_sym_const] = ACTIONS(3314),
    [anon_sym_constexpr] = ACTIONS(3314),
    [anon_sym_volatile] = ACTIONS(3314),
    [anon_sym_restrict] = ACTIONS(3314),
    [anon_sym___restrict__] = ACTIONS(3314),
    [anon_sym__Atomic] = ACTIONS(3314),
    [anon_sym__Noreturn] = ACTIONS(3314),
    [anon_sym_noreturn] = ACTIONS(3314),
    [anon_sym_mutable] = ACTIONS(3314),
    [anon_sym_constinit] = ACTIONS(3314),
    [anon_sym_consteval] = ACTIONS(3314),
    [anon_sym_alignas] = ACTIONS(3314),
    [anon_sym__Alignas] = ACTIONS(3314),
    [sym_primitive_type] = ACTIONS(3314),
    [anon_sym_enum] = ACTIONS(3314),
    [anon_sym_class] = ACTIONS(3314),
    [anon_sym_struct] = ACTIONS(3314),
    [anon_sym_union] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_else] = ACTIONS(3314),
    [anon_sym_switch] = ACTIONS(3314),
    [anon_sym_case] = ACTIONS(3314),
    [anon_sym_default] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_break] = ACTIONS(3314),
    [anon_sym_continue] = ACTIONS(3314),
    [anon_sym_goto] = ACTIONS(3314),
    [anon_sym___try] = ACTIONS(3314),
    [anon_sym___leave] = ACTIONS(3314),
    [anon_sym_not] = ACTIONS(3314),
    [anon_sym_compl] = ACTIONS(3314),
    [anon_sym_DASH_DASH] = ACTIONS(3316),
    [anon_sym_PLUS_PLUS] = ACTIONS(3316),
    [anon_sym_sizeof] = ACTIONS(3314),
    [anon_sym___alignof__] = ACTIONS(3314),
    [anon_sym___alignof] = ACTIONS(3314),
    [anon_sym__alignof] = ACTIONS(3314),
    [anon_sym_alignof] = ACTIONS(3314),
    [anon_sym__Alignof] = ACTIONS(3314),
    [anon_sym_offsetof] = ACTIONS(3314),
    [anon_sym__Generic] = ACTIONS(3314),
    [anon_sym_asm] = ACTIONS(3314),
    [anon_sym___asm__] = ACTIONS(3314),
    [sym_number_literal] = ACTIONS(3316),
    [anon_sym_L_SQUOTE] = ACTIONS(3316),
    [anon_sym_u_SQUOTE] = ACTIONS(3316),
    [anon_sym_U_SQUOTE] = ACTIONS(3316),
    [anon_sym_u8_SQUOTE] = ACTIONS(3316),
    [anon_sym_SQUOTE] = ACTIONS(3316),
    [anon_sym_L_DQUOTE] = ACTIONS(3316),
    [anon_sym_u_DQUOTE] = ACTIONS(3316),
    [anon_sym_U_DQUOTE] = ACTIONS(3316),
    [anon_sym_u8_DQUOTE] = ACTIONS(3316),
    [anon_sym_DQUOTE] = ACTIONS(3316),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [anon_sym_NULL] = ACTIONS(3314),
    [anon_sym_nullptr] = ACTIONS(3314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_This] = ACTIONS(3314),
    [anon_sym_decltype] = ACTIONS(3314),
    [sym_virtual] = ACTIONS(3314),
    [anon_sym_explicit] = ACTIONS(3314),
    [anon_sym_typename] = ACTIONS(3314),
    [anon_sym_template] = ACTIONS(3314),
    [anon_sym_operator] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_delete] = ACTIONS(3314),
    [anon_sym_throw] = ACTIONS(3314),
    [anon_sym_namespace] = ACTIONS(3314),
    [anon_sym_using] = ACTIONS(3314),
    [anon_sym_static_assert] = ACTIONS(3314),
    [anon_sym_concept] = ACTIONS(3314),
    [anon_sym_co_return] = ACTIONS(3314),
    [anon_sym_co_yield] = ACTIONS(3314),
    [anon_sym_R_DQUOTE] = ACTIONS(3316),
    [anon_sym_LR_DQUOTE] = ACTIONS(3316),
    [anon_sym_uR_DQUOTE] = ACTIONS(3316),
    [anon_sym_UR_DQUOTE] = ACTIONS(3316),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3316),
    [anon_sym_co_await] = ACTIONS(3314),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_requires] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [anon_sym_discard] = ACTIONS(3314),
    [anon_sym_precise] = ACTIONS(3314),
    [anon_sym_shared] = ACTIONS(3314),
    [anon_sym_groupshared] = ACTIONS(3314),
    [anon_sym_uniform] = ACTIONS(3314),
    [anon_sym_row_major] = ACTIONS(3314),
    [anon_sym_column_major] = ACTIONS(3314),
    [anon_sym_globallycoherent] = ACTIONS(3314),
    [anon_sym_centroid] = ACTIONS(3314),
    [anon_sym_noperspective] = ACTIONS(3314),
    [anon_sym_nointerpolation] = ACTIONS(3314),
    [anon_sym_sample] = ACTIONS(3314),
    [anon_sym_linear] = ACTIONS(3314),
    [anon_sym_snorm] = ACTIONS(3314),
    [anon_sym_unorm] = ACTIONS(3314),
    [anon_sym_point] = ACTIONS(3314),
    [anon_sym_line] = ACTIONS(3314),
    [anon_sym_triangleadj] = ACTIONS(3314),
    [anon_sym_lineadj] = ACTIONS(3314),
    [anon_sym_triangle] = ACTIONS(3314),
    [anon_sym_cbuffer] = ACTIONS(3314),
    [anon_sym_interface] = ACTIONS(3314),
    [anon_sym_extension] = ACTIONS(3314),
    [anon_sym___exported] = ACTIONS(3314),
    [anon_sym_import] = ACTIONS(3314),
  },
  [575] = {
    [ts_builtin_sym_end] = ACTIONS(2900),
    [sym_identifier] = ACTIONS(2898),
    [aux_sym_preproc_include_token1] = ACTIONS(2898),
    [aux_sym_preproc_def_token1] = ACTIONS(2898),
    [aux_sym_preproc_if_token1] = ACTIONS(2898),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2898),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2898),
    [sym_preproc_directive] = ACTIONS(2898),
    [anon_sym_LPAREN2] = ACTIONS(2900),
    [anon_sym_BANG] = ACTIONS(2900),
    [anon_sym_TILDE] = ACTIONS(2900),
    [anon_sym_DASH] = ACTIONS(2898),
    [anon_sym_PLUS] = ACTIONS(2898),
    [anon_sym_STAR] = ACTIONS(2900),
    [anon_sym_AMP_AMP] = ACTIONS(2900),
    [anon_sym_AMP] = ACTIONS(2898),
    [anon_sym_SEMI] = ACTIONS(2900),
    [anon_sym___extension__] = ACTIONS(2898),
    [anon_sym_typedef] = ACTIONS(2898),
    [anon_sym_in] = ACTIONS(2898),
    [anon_sym_out] = ACTIONS(2898),
    [anon_sym_inout] = ACTIONS(2898),
    [anon_sym_extern] = ACTIONS(2898),
    [anon_sym___attribute__] = ACTIONS(2898),
    [anon_sym_COLON_COLON] = ACTIONS(2900),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2900),
    [anon_sym___declspec] = ACTIONS(2898),
    [anon_sym___based] = ACTIONS(2898),
    [anon_sym___cdecl] = ACTIONS(2898),
    [anon_sym___clrcall] = ACTIONS(2898),
    [anon_sym___stdcall] = ACTIONS(2898),
    [anon_sym___fastcall] = ACTIONS(2898),
    [anon_sym___thiscall] = ACTIONS(2898),
    [anon_sym___vectorcall] = ACTIONS(2898),
    [anon_sym_LBRACE] = ACTIONS(2900),
    [anon_sym_signed] = ACTIONS(2898),
    [anon_sym_unsigned] = ACTIONS(2898),
    [anon_sym_long] = ACTIONS(2898),
    [anon_sym_short] = ACTIONS(2898),
    [anon_sym_LBRACK] = ACTIONS(2898),
    [anon_sym_static] = ACTIONS(2898),
    [anon_sym_register] = ACTIONS(2898),
    [anon_sym_inline] = ACTIONS(2898),
    [anon_sym___inline] = ACTIONS(2898),
    [anon_sym___inline__] = ACTIONS(2898),
    [anon_sym___forceinline] = ACTIONS(2898),
    [anon_sym_thread_local] = ACTIONS(2898),
    [anon_sym___thread] = ACTIONS(2898),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_constexpr] = ACTIONS(2898),
    [anon_sym_volatile] = ACTIONS(2898),
    [anon_sym_restrict] = ACTIONS(2898),
    [anon_sym___restrict__] = ACTIONS(2898),
    [anon_sym__Atomic] = ACTIONS(2898),
    [anon_sym__Noreturn] = ACTIONS(2898),
    [anon_sym_noreturn] = ACTIONS(2898),
    [anon_sym_mutable] = ACTIONS(2898),
    [anon_sym_constinit] = ACTIONS(2898),
    [anon_sym_consteval] = ACTIONS(2898),
    [anon_sym_alignas] = ACTIONS(2898),
    [anon_sym__Alignas] = ACTIONS(2898),
    [sym_primitive_type] = ACTIONS(2898),
    [anon_sym_enum] = ACTIONS(2898),
    [anon_sym_class] = ACTIONS(2898),
    [anon_sym_struct] = ACTIONS(2898),
    [anon_sym_union] = ACTIONS(2898),
    [anon_sym_if] = ACTIONS(2898),
    [anon_sym_else] = ACTIONS(2898),
    [anon_sym_switch] = ACTIONS(2898),
    [anon_sym_case] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2898),
    [anon_sym_while] = ACTIONS(2898),
    [anon_sym_do] = ACTIONS(2898),
    [anon_sym_for] = ACTIONS(2898),
    [anon_sym_return] = ACTIONS(2898),
    [anon_sym_break] = ACTIONS(2898),
    [anon_sym_continue] = ACTIONS(2898),
    [anon_sym_goto] = ACTIONS(2898),
    [anon_sym___try] = ACTIONS(2898),
    [anon_sym___leave] = ACTIONS(2898),
    [anon_sym_not] = ACTIONS(2898),
    [anon_sym_compl] = ACTIONS(2898),
    [anon_sym_DASH_DASH] = ACTIONS(2900),
    [anon_sym_PLUS_PLUS] = ACTIONS(2900),
    [anon_sym_sizeof] = ACTIONS(2898),
    [anon_sym___alignof__] = ACTIONS(2898),
    [anon_sym___alignof] = ACTIONS(2898),
    [anon_sym__alignof] = ACTIONS(2898),
    [anon_sym_alignof] = ACTIONS(2898),
    [anon_sym__Alignof] = ACTIONS(2898),
    [anon_sym_offsetof] = ACTIONS(2898),
    [anon_sym__Generic] = ACTIONS(2898),
    [anon_sym_asm] = ACTIONS(2898),
    [anon_sym___asm__] = ACTIONS(2898),
    [sym_number_literal] = ACTIONS(2900),
    [anon_sym_L_SQUOTE] = ACTIONS(2900),
    [anon_sym_u_SQUOTE] = ACTIONS(2900),
    [anon_sym_U_SQUOTE] = ACTIONS(2900),
    [anon_sym_u8_SQUOTE] = ACTIONS(2900),
    [anon_sym_SQUOTE] = ACTIONS(2900),
    [anon_sym_L_DQUOTE] = ACTIONS(2900),
    [anon_sym_u_DQUOTE] = ACTIONS(2900),
    [anon_sym_U_DQUOTE] = ACTIONS(2900),
    [anon_sym_u8_DQUOTE] = ACTIONS(2900),
    [anon_sym_DQUOTE] = ACTIONS(2900),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2898),
    [anon_sym_nullptr] = ACTIONS(2898),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2898),
    [anon_sym_let] = ACTIONS(2898),
    [anon_sym_This] = ACTIONS(2898),
    [anon_sym_decltype] = ACTIONS(2898),
    [sym_virtual] = ACTIONS(2898),
    [anon_sym_explicit] = ACTIONS(2898),
    [anon_sym_typename] = ACTIONS(2898),
    [anon_sym_template] = ACTIONS(2898),
    [anon_sym_operator] = ACTIONS(2898),
    [anon_sym_try] = ACTIONS(2898),
    [anon_sym_delete] = ACTIONS(2898),
    [anon_sym_throw] = ACTIONS(2898),
    [anon_sym_namespace] = ACTIONS(2898),
    [anon_sym_using] = ACTIONS(2898),
    [anon_sym_static_assert] = ACTIONS(2898),
    [anon_sym_concept] = ACTIONS(2898),
    [anon_sym_co_return] = ACTIONS(2898),
    [anon_sym_co_yield] = ACTIONS(2898),
    [anon_sym_R_DQUOTE] = ACTIONS(2900),
    [anon_sym_LR_DQUOTE] = ACTIONS(2900),
    [anon_sym_uR_DQUOTE] = ACTIONS(2900),
    [anon_sym_UR_DQUOTE] = ACTIONS(2900),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2900),
    [anon_sym_co_await] = ACTIONS(2898),
    [anon_sym_new] = ACTIONS(2898),
    [anon_sym_requires] = ACTIONS(2898),
    [sym_this] = ACTIONS(2898),
    [anon_sym_discard] = ACTIONS(2898),
    [anon_sym_precise] = ACTIONS(2898),
    [anon_sym_shared] = ACTIONS(2898),
    [anon_sym_groupshared] = ACTIONS(2898),
    [anon_sym_uniform] = ACTIONS(2898),
    [anon_sym_row_major] = ACTIONS(2898),
    [anon_sym_column_major] = ACTIONS(2898),
    [anon_sym_globallycoherent] = ACTIONS(2898),
    [anon_sym_centroid] = ACTIONS(2898),
    [anon_sym_noperspective] = ACTIONS(2898),
    [anon_sym_nointerpolation] = ACTIONS(2898),
    [anon_sym_sample] = ACTIONS(2898),
    [anon_sym_linear] = ACTIONS(2898),
    [anon_sym_snorm] = ACTIONS(2898),
    [anon_sym_unorm] = ACTIONS(2898),
    [anon_sym_point] = ACTIONS(2898),
    [anon_sym_line] = ACTIONS(2898),
    [anon_sym_triangleadj] = ACTIONS(2898),
    [anon_sym_lineadj] = ACTIONS(2898),
    [anon_sym_triangle] = ACTIONS(2898),
    [anon_sym_cbuffer] = ACTIONS(2898),
    [anon_sym_interface] = ACTIONS(2898),
    [anon_sym_extension] = ACTIONS(2898),
    [anon_sym___exported] = ACTIONS(2898),
    [anon_sym_import] = ACTIONS(2898),
  },
  [576] = {
    [ts_builtin_sym_end] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(3072),
    [anon_sym_out] = ACTIONS(3072),
    [anon_sym_inout] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym__Alignas] = ACTIONS(3072),
    [sym_primitive_type] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [sym_number_literal] = ACTIONS(3074),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3072),
    [anon_sym_let] = ACTIONS(3072),
    [anon_sym_This] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [sym_virtual] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
    [anon_sym_discard] = ACTIONS(3072),
    [anon_sym_precise] = ACTIONS(3072),
    [anon_sym_shared] = ACTIONS(3072),
    [anon_sym_groupshared] = ACTIONS(3072),
    [anon_sym_uniform] = ACTIONS(3072),
    [anon_sym_row_major] = ACTIONS(3072),
    [anon_sym_column_major] = ACTIONS(3072),
    [anon_sym_globallycoherent] = ACTIONS(3072),
    [anon_sym_centroid] = ACTIONS(3072),
    [anon_sym_noperspective] = ACTIONS(3072),
    [anon_sym_nointerpolation] = ACTIONS(3072),
    [anon_sym_sample] = ACTIONS(3072),
    [anon_sym_linear] = ACTIONS(3072),
    [anon_sym_snorm] = ACTIONS(3072),
    [anon_sym_unorm] = ACTIONS(3072),
    [anon_sym_point] = ACTIONS(3072),
    [anon_sym_line] = ACTIONS(3072),
    [anon_sym_triangleadj] = ACTIONS(3072),
    [anon_sym_lineadj] = ACTIONS(3072),
    [anon_sym_triangle] = ACTIONS(3072),
    [anon_sym_cbuffer] = ACTIONS(3072),
    [anon_sym_interface] = ACTIONS(3072),
    [anon_sym_extension] = ACTIONS(3072),
    [anon_sym___exported] = ACTIONS(3072),
    [anon_sym_import] = ACTIONS(3072),
  },
  [577] = {
    [ts_builtin_sym_end] = ACTIONS(3036),
    [sym_identifier] = ACTIONS(3034),
    [aux_sym_preproc_include_token1] = ACTIONS(3034),
    [aux_sym_preproc_def_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_BANG] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3034),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_in] = ACTIONS(3034),
    [anon_sym_out] = ACTIONS(3034),
    [anon_sym_inout] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym___based] = ACTIONS(3034),
    [anon_sym___cdecl] = ACTIONS(3034),
    [anon_sym___clrcall] = ACTIONS(3034),
    [anon_sym___stdcall] = ACTIONS(3034),
    [anon_sym___fastcall] = ACTIONS(3034),
    [anon_sym___thiscall] = ACTIONS(3034),
    [anon_sym___vectorcall] = ACTIONS(3034),
    [anon_sym_LBRACE] = ACTIONS(3036),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [anon_sym_if] = ACTIONS(3034),
    [anon_sym_else] = ACTIONS(3034),
    [anon_sym_switch] = ACTIONS(3034),
    [anon_sym_case] = ACTIONS(3034),
    [anon_sym_default] = ACTIONS(3034),
    [anon_sym_while] = ACTIONS(3034),
    [anon_sym_do] = ACTIONS(3034),
    [anon_sym_for] = ACTIONS(3034),
    [anon_sym_return] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3034),
    [anon_sym_continue] = ACTIONS(3034),
    [anon_sym_goto] = ACTIONS(3034),
    [anon_sym___try] = ACTIONS(3034),
    [anon_sym___leave] = ACTIONS(3034),
    [anon_sym_not] = ACTIONS(3034),
    [anon_sym_compl] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_sizeof] = ACTIONS(3034),
    [anon_sym___alignof__] = ACTIONS(3034),
    [anon_sym___alignof] = ACTIONS(3034),
    [anon_sym__alignof] = ACTIONS(3034),
    [anon_sym_alignof] = ACTIONS(3034),
    [anon_sym__Alignof] = ACTIONS(3034),
    [anon_sym_offsetof] = ACTIONS(3034),
    [anon_sym__Generic] = ACTIONS(3034),
    [anon_sym_asm] = ACTIONS(3034),
    [anon_sym___asm__] = ACTIONS(3034),
    [sym_number_literal] = ACTIONS(3036),
    [anon_sym_L_SQUOTE] = ACTIONS(3036),
    [anon_sym_u_SQUOTE] = ACTIONS(3036),
    [anon_sym_U_SQUOTE] = ACTIONS(3036),
    [anon_sym_u8_SQUOTE] = ACTIONS(3036),
    [anon_sym_SQUOTE] = ACTIONS(3036),
    [anon_sym_L_DQUOTE] = ACTIONS(3036),
    [anon_sym_u_DQUOTE] = ACTIONS(3036),
    [anon_sym_U_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8_DQUOTE] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [sym_true] = ACTIONS(3034),
    [sym_false] = ACTIONS(3034),
    [anon_sym_NULL] = ACTIONS(3034),
    [anon_sym_nullptr] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_This] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [sym_virtual] = ACTIONS(3034),
    [anon_sym_explicit] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_operator] = ACTIONS(3034),
    [anon_sym_try] = ACTIONS(3034),
    [anon_sym_delete] = ACTIONS(3034),
    [anon_sym_throw] = ACTIONS(3034),
    [anon_sym_namespace] = ACTIONS(3034),
    [anon_sym_using] = ACTIONS(3034),
    [anon_sym_static_assert] = ACTIONS(3034),
    [anon_sym_concept] = ACTIONS(3034),
    [anon_sym_co_return] = ACTIONS(3034),
    [anon_sym_co_yield] = ACTIONS(3034),
    [anon_sym_R_DQUOTE] = ACTIONS(3036),
    [anon_sym_LR_DQUOTE] = ACTIONS(3036),
    [anon_sym_uR_DQUOTE] = ACTIONS(3036),
    [anon_sym_UR_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3036),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3034),
    [anon_sym_requires] = ACTIONS(3034),
    [sym_this] = ACTIONS(3034),
    [anon_sym_discard] = ACTIONS(3034),
    [anon_sym_precise] = ACTIONS(3034),
    [anon_sym_shared] = ACTIONS(3034),
    [anon_sym_groupshared] = ACTIONS(3034),
    [anon_sym_uniform] = ACTIONS(3034),
    [anon_sym_row_major] = ACTIONS(3034),
    [anon_sym_column_major] = ACTIONS(3034),
    [anon_sym_globallycoherent] = ACTIONS(3034),
    [anon_sym_centroid] = ACTIONS(3034),
    [anon_sym_noperspective] = ACTIONS(3034),
    [anon_sym_nointerpolation] = ACTIONS(3034),
    [anon_sym_sample] = ACTIONS(3034),
    [anon_sym_linear] = ACTIONS(3034),
    [anon_sym_snorm] = ACTIONS(3034),
    [anon_sym_unorm] = ACTIONS(3034),
    [anon_sym_point] = ACTIONS(3034),
    [anon_sym_line] = ACTIONS(3034),
    [anon_sym_triangleadj] = ACTIONS(3034),
    [anon_sym_lineadj] = ACTIONS(3034),
    [anon_sym_triangle] = ACTIONS(3034),
    [anon_sym_cbuffer] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3034),
    [anon_sym_extension] = ACTIONS(3034),
    [anon_sym___exported] = ACTIONS(3034),
    [anon_sym_import] = ACTIONS(3034),
  },
  [578] = {
    [ts_builtin_sym_end] = ACTIONS(3036),
    [sym_identifier] = ACTIONS(3034),
    [aux_sym_preproc_include_token1] = ACTIONS(3034),
    [aux_sym_preproc_def_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_BANG] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3034),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_in] = ACTIONS(3034),
    [anon_sym_out] = ACTIONS(3034),
    [anon_sym_inout] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym___based] = ACTIONS(3034),
    [anon_sym___cdecl] = ACTIONS(3034),
    [anon_sym___clrcall] = ACTIONS(3034),
    [anon_sym___stdcall] = ACTIONS(3034),
    [anon_sym___fastcall] = ACTIONS(3034),
    [anon_sym___thiscall] = ACTIONS(3034),
    [anon_sym___vectorcall] = ACTIONS(3034),
    [anon_sym_LBRACE] = ACTIONS(3036),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [anon_sym_if] = ACTIONS(3034),
    [anon_sym_else] = ACTIONS(3034),
    [anon_sym_switch] = ACTIONS(3034),
    [anon_sym_case] = ACTIONS(3034),
    [anon_sym_default] = ACTIONS(3034),
    [anon_sym_while] = ACTIONS(3034),
    [anon_sym_do] = ACTIONS(3034),
    [anon_sym_for] = ACTIONS(3034),
    [anon_sym_return] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3034),
    [anon_sym_continue] = ACTIONS(3034),
    [anon_sym_goto] = ACTIONS(3034),
    [anon_sym___try] = ACTIONS(3034),
    [anon_sym___leave] = ACTIONS(3034),
    [anon_sym_not] = ACTIONS(3034),
    [anon_sym_compl] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_sizeof] = ACTIONS(3034),
    [anon_sym___alignof__] = ACTIONS(3034),
    [anon_sym___alignof] = ACTIONS(3034),
    [anon_sym__alignof] = ACTIONS(3034),
    [anon_sym_alignof] = ACTIONS(3034),
    [anon_sym__Alignof] = ACTIONS(3034),
    [anon_sym_offsetof] = ACTIONS(3034),
    [anon_sym__Generic] = ACTIONS(3034),
    [anon_sym_asm] = ACTIONS(3034),
    [anon_sym___asm__] = ACTIONS(3034),
    [sym_number_literal] = ACTIONS(3036),
    [anon_sym_L_SQUOTE] = ACTIONS(3036),
    [anon_sym_u_SQUOTE] = ACTIONS(3036),
    [anon_sym_U_SQUOTE] = ACTIONS(3036),
    [anon_sym_u8_SQUOTE] = ACTIONS(3036),
    [anon_sym_SQUOTE] = ACTIONS(3036),
    [anon_sym_L_DQUOTE] = ACTIONS(3036),
    [anon_sym_u_DQUOTE] = ACTIONS(3036),
    [anon_sym_U_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8_DQUOTE] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [sym_true] = ACTIONS(3034),
    [sym_false] = ACTIONS(3034),
    [anon_sym_NULL] = ACTIONS(3034),
    [anon_sym_nullptr] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_This] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [sym_virtual] = ACTIONS(3034),
    [anon_sym_explicit] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_operator] = ACTIONS(3034),
    [anon_sym_try] = ACTIONS(3034),
    [anon_sym_delete] = ACTIONS(3034),
    [anon_sym_throw] = ACTIONS(3034),
    [anon_sym_namespace] = ACTIONS(3034),
    [anon_sym_using] = ACTIONS(3034),
    [anon_sym_static_assert] = ACTIONS(3034),
    [anon_sym_concept] = ACTIONS(3034),
    [anon_sym_co_return] = ACTIONS(3034),
    [anon_sym_co_yield] = ACTIONS(3034),
    [anon_sym_R_DQUOTE] = ACTIONS(3036),
    [anon_sym_LR_DQUOTE] = ACTIONS(3036),
    [anon_sym_uR_DQUOTE] = ACTIONS(3036),
    [anon_sym_UR_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3036),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3034),
    [anon_sym_requires] = ACTIONS(3034),
    [sym_this] = ACTIONS(3034),
    [anon_sym_discard] = ACTIONS(3034),
    [anon_sym_precise] = ACTIONS(3034),
    [anon_sym_shared] = ACTIONS(3034),
    [anon_sym_groupshared] = ACTIONS(3034),
    [anon_sym_uniform] = ACTIONS(3034),
    [anon_sym_row_major] = ACTIONS(3034),
    [anon_sym_column_major] = ACTIONS(3034),
    [anon_sym_globallycoherent] = ACTIONS(3034),
    [anon_sym_centroid] = ACTIONS(3034),
    [anon_sym_noperspective] = ACTIONS(3034),
    [anon_sym_nointerpolation] = ACTIONS(3034),
    [anon_sym_sample] = ACTIONS(3034),
    [anon_sym_linear] = ACTIONS(3034),
    [anon_sym_snorm] = ACTIONS(3034),
    [anon_sym_unorm] = ACTIONS(3034),
    [anon_sym_point] = ACTIONS(3034),
    [anon_sym_line] = ACTIONS(3034),
    [anon_sym_triangleadj] = ACTIONS(3034),
    [anon_sym_lineadj] = ACTIONS(3034),
    [anon_sym_triangle] = ACTIONS(3034),
    [anon_sym_cbuffer] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3034),
    [anon_sym_extension] = ACTIONS(3034),
    [anon_sym___exported] = ACTIONS(3034),
    [anon_sym_import] = ACTIONS(3034),
  },
  [579] = {
    [ts_builtin_sym_end] = ACTIONS(3304),
    [sym_identifier] = ACTIONS(3302),
    [aux_sym_preproc_include_token1] = ACTIONS(3302),
    [aux_sym_preproc_def_token1] = ACTIONS(3302),
    [aux_sym_preproc_if_token1] = ACTIONS(3302),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3302),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3302),
    [sym_preproc_directive] = ACTIONS(3302),
    [anon_sym_LPAREN2] = ACTIONS(3304),
    [anon_sym_BANG] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_AMP_AMP] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3302),
    [anon_sym_SEMI] = ACTIONS(3304),
    [anon_sym___extension__] = ACTIONS(3302),
    [anon_sym_typedef] = ACTIONS(3302),
    [anon_sym_in] = ACTIONS(3302),
    [anon_sym_out] = ACTIONS(3302),
    [anon_sym_inout] = ACTIONS(3302),
    [anon_sym_extern] = ACTIONS(3302),
    [anon_sym___attribute__] = ACTIONS(3302),
    [anon_sym_COLON_COLON] = ACTIONS(3304),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3304),
    [anon_sym___declspec] = ACTIONS(3302),
    [anon_sym___based] = ACTIONS(3302),
    [anon_sym___cdecl] = ACTIONS(3302),
    [anon_sym___clrcall] = ACTIONS(3302),
    [anon_sym___stdcall] = ACTIONS(3302),
    [anon_sym___fastcall] = ACTIONS(3302),
    [anon_sym___thiscall] = ACTIONS(3302),
    [anon_sym___vectorcall] = ACTIONS(3302),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_signed] = ACTIONS(3302),
    [anon_sym_unsigned] = ACTIONS(3302),
    [anon_sym_long] = ACTIONS(3302),
    [anon_sym_short] = ACTIONS(3302),
    [anon_sym_LBRACK] = ACTIONS(3302),
    [anon_sym_static] = ACTIONS(3302),
    [anon_sym_register] = ACTIONS(3302),
    [anon_sym_inline] = ACTIONS(3302),
    [anon_sym___inline] = ACTIONS(3302),
    [anon_sym___inline__] = ACTIONS(3302),
    [anon_sym___forceinline] = ACTIONS(3302),
    [anon_sym_thread_local] = ACTIONS(3302),
    [anon_sym___thread] = ACTIONS(3302),
    [anon_sym_const] = ACTIONS(3302),
    [anon_sym_constexpr] = ACTIONS(3302),
    [anon_sym_volatile] = ACTIONS(3302),
    [anon_sym_restrict] = ACTIONS(3302),
    [anon_sym___restrict__] = ACTIONS(3302),
    [anon_sym__Atomic] = ACTIONS(3302),
    [anon_sym__Noreturn] = ACTIONS(3302),
    [anon_sym_noreturn] = ACTIONS(3302),
    [anon_sym_mutable] = ACTIONS(3302),
    [anon_sym_constinit] = ACTIONS(3302),
    [anon_sym_consteval] = ACTIONS(3302),
    [anon_sym_alignas] = ACTIONS(3302),
    [anon_sym__Alignas] = ACTIONS(3302),
    [sym_primitive_type] = ACTIONS(3302),
    [anon_sym_enum] = ACTIONS(3302),
    [anon_sym_class] = ACTIONS(3302),
    [anon_sym_struct] = ACTIONS(3302),
    [anon_sym_union] = ACTIONS(3302),
    [anon_sym_if] = ACTIONS(3302),
    [anon_sym_else] = ACTIONS(3302),
    [anon_sym_switch] = ACTIONS(3302),
    [anon_sym_case] = ACTIONS(3302),
    [anon_sym_default] = ACTIONS(3302),
    [anon_sym_while] = ACTIONS(3302),
    [anon_sym_do] = ACTIONS(3302),
    [anon_sym_for] = ACTIONS(3302),
    [anon_sym_return] = ACTIONS(3302),
    [anon_sym_break] = ACTIONS(3302),
    [anon_sym_continue] = ACTIONS(3302),
    [anon_sym_goto] = ACTIONS(3302),
    [anon_sym___try] = ACTIONS(3302),
    [anon_sym___leave] = ACTIONS(3302),
    [anon_sym_not] = ACTIONS(3302),
    [anon_sym_compl] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3304),
    [anon_sym_PLUS_PLUS] = ACTIONS(3304),
    [anon_sym_sizeof] = ACTIONS(3302),
    [anon_sym___alignof__] = ACTIONS(3302),
    [anon_sym___alignof] = ACTIONS(3302),
    [anon_sym__alignof] = ACTIONS(3302),
    [anon_sym_alignof] = ACTIONS(3302),
    [anon_sym__Alignof] = ACTIONS(3302),
    [anon_sym_offsetof] = ACTIONS(3302),
    [anon_sym__Generic] = ACTIONS(3302),
    [anon_sym_asm] = ACTIONS(3302),
    [anon_sym___asm__] = ACTIONS(3302),
    [sym_number_literal] = ACTIONS(3304),
    [anon_sym_L_SQUOTE] = ACTIONS(3304),
    [anon_sym_u_SQUOTE] = ACTIONS(3304),
    [anon_sym_U_SQUOTE] = ACTIONS(3304),
    [anon_sym_u8_SQUOTE] = ACTIONS(3304),
    [anon_sym_SQUOTE] = ACTIONS(3304),
    [anon_sym_L_DQUOTE] = ACTIONS(3304),
    [anon_sym_u_DQUOTE] = ACTIONS(3304),
    [anon_sym_U_DQUOTE] = ACTIONS(3304),
    [anon_sym_u8_DQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [sym_true] = ACTIONS(3302),
    [sym_false] = ACTIONS(3302),
    [anon_sym_NULL] = ACTIONS(3302),
    [anon_sym_nullptr] = ACTIONS(3302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3302),
    [anon_sym_let] = ACTIONS(3302),
    [anon_sym_This] = ACTIONS(3302),
    [anon_sym_decltype] = ACTIONS(3302),
    [sym_virtual] = ACTIONS(3302),
    [anon_sym_explicit] = ACTIONS(3302),
    [anon_sym_typename] = ACTIONS(3302),
    [anon_sym_template] = ACTIONS(3302),
    [anon_sym_operator] = ACTIONS(3302),
    [anon_sym_try] = ACTIONS(3302),
    [anon_sym_delete] = ACTIONS(3302),
    [anon_sym_throw] = ACTIONS(3302),
    [anon_sym_namespace] = ACTIONS(3302),
    [anon_sym_using] = ACTIONS(3302),
    [anon_sym_static_assert] = ACTIONS(3302),
    [anon_sym_concept] = ACTIONS(3302),
    [anon_sym_co_return] = ACTIONS(3302),
    [anon_sym_co_yield] = ACTIONS(3302),
    [anon_sym_R_DQUOTE] = ACTIONS(3304),
    [anon_sym_LR_DQUOTE] = ACTIONS(3304),
    [anon_sym_uR_DQUOTE] = ACTIONS(3304),
    [anon_sym_UR_DQUOTE] = ACTIONS(3304),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3304),
    [anon_sym_co_await] = ACTIONS(3302),
    [anon_sym_new] = ACTIONS(3302),
    [anon_sym_requires] = ACTIONS(3302),
    [sym_this] = ACTIONS(3302),
    [anon_sym_discard] = ACTIONS(3302),
    [anon_sym_precise] = ACTIONS(3302),
    [anon_sym_shared] = ACTIONS(3302),
    [anon_sym_groupshared] = ACTIONS(3302),
    [anon_sym_uniform] = ACTIONS(3302),
    [anon_sym_row_major] = ACTIONS(3302),
    [anon_sym_column_major] = ACTIONS(3302),
    [anon_sym_globallycoherent] = ACTIONS(3302),
    [anon_sym_centroid] = ACTIONS(3302),
    [anon_sym_noperspective] = ACTIONS(3302),
    [anon_sym_nointerpolation] = ACTIONS(3302),
    [anon_sym_sample] = ACTIONS(3302),
    [anon_sym_linear] = ACTIONS(3302),
    [anon_sym_snorm] = ACTIONS(3302),
    [anon_sym_unorm] = ACTIONS(3302),
    [anon_sym_point] = ACTIONS(3302),
    [anon_sym_line] = ACTIONS(3302),
    [anon_sym_triangleadj] = ACTIONS(3302),
    [anon_sym_lineadj] = ACTIONS(3302),
    [anon_sym_triangle] = ACTIONS(3302),
    [anon_sym_cbuffer] = ACTIONS(3302),
    [anon_sym_interface] = ACTIONS(3302),
    [anon_sym_extension] = ACTIONS(3302),
    [anon_sym___exported] = ACTIONS(3302),
    [anon_sym_import] = ACTIONS(3302),
  },
  [580] = {
    [ts_builtin_sym_end] = ACTIONS(3036),
    [sym_identifier] = ACTIONS(3034),
    [aux_sym_preproc_include_token1] = ACTIONS(3034),
    [aux_sym_preproc_def_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_BANG] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3034),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_in] = ACTIONS(3034),
    [anon_sym_out] = ACTIONS(3034),
    [anon_sym_inout] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym___based] = ACTIONS(3034),
    [anon_sym___cdecl] = ACTIONS(3034),
    [anon_sym___clrcall] = ACTIONS(3034),
    [anon_sym___stdcall] = ACTIONS(3034),
    [anon_sym___fastcall] = ACTIONS(3034),
    [anon_sym___thiscall] = ACTIONS(3034),
    [anon_sym___vectorcall] = ACTIONS(3034),
    [anon_sym_LBRACE] = ACTIONS(3036),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [anon_sym_if] = ACTIONS(3034),
    [anon_sym_else] = ACTIONS(3034),
    [anon_sym_switch] = ACTIONS(3034),
    [anon_sym_case] = ACTIONS(3034),
    [anon_sym_default] = ACTIONS(3034),
    [anon_sym_while] = ACTIONS(3034),
    [anon_sym_do] = ACTIONS(3034),
    [anon_sym_for] = ACTIONS(3034),
    [anon_sym_return] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3034),
    [anon_sym_continue] = ACTIONS(3034),
    [anon_sym_goto] = ACTIONS(3034),
    [anon_sym___try] = ACTIONS(3034),
    [anon_sym___leave] = ACTIONS(3034),
    [anon_sym_not] = ACTIONS(3034),
    [anon_sym_compl] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_sizeof] = ACTIONS(3034),
    [anon_sym___alignof__] = ACTIONS(3034),
    [anon_sym___alignof] = ACTIONS(3034),
    [anon_sym__alignof] = ACTIONS(3034),
    [anon_sym_alignof] = ACTIONS(3034),
    [anon_sym__Alignof] = ACTIONS(3034),
    [anon_sym_offsetof] = ACTIONS(3034),
    [anon_sym__Generic] = ACTIONS(3034),
    [anon_sym_asm] = ACTIONS(3034),
    [anon_sym___asm__] = ACTIONS(3034),
    [sym_number_literal] = ACTIONS(3036),
    [anon_sym_L_SQUOTE] = ACTIONS(3036),
    [anon_sym_u_SQUOTE] = ACTIONS(3036),
    [anon_sym_U_SQUOTE] = ACTIONS(3036),
    [anon_sym_u8_SQUOTE] = ACTIONS(3036),
    [anon_sym_SQUOTE] = ACTIONS(3036),
    [anon_sym_L_DQUOTE] = ACTIONS(3036),
    [anon_sym_u_DQUOTE] = ACTIONS(3036),
    [anon_sym_U_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8_DQUOTE] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [sym_true] = ACTIONS(3034),
    [sym_false] = ACTIONS(3034),
    [anon_sym_NULL] = ACTIONS(3034),
    [anon_sym_nullptr] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_This] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [sym_virtual] = ACTIONS(3034),
    [anon_sym_explicit] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_operator] = ACTIONS(3034),
    [anon_sym_try] = ACTIONS(3034),
    [anon_sym_delete] = ACTIONS(3034),
    [anon_sym_throw] = ACTIONS(3034),
    [anon_sym_namespace] = ACTIONS(3034),
    [anon_sym_using] = ACTIONS(3034),
    [anon_sym_static_assert] = ACTIONS(3034),
    [anon_sym_concept] = ACTIONS(3034),
    [anon_sym_co_return] = ACTIONS(3034),
    [anon_sym_co_yield] = ACTIONS(3034),
    [anon_sym_R_DQUOTE] = ACTIONS(3036),
    [anon_sym_LR_DQUOTE] = ACTIONS(3036),
    [anon_sym_uR_DQUOTE] = ACTIONS(3036),
    [anon_sym_UR_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3036),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3034),
    [anon_sym_requires] = ACTIONS(3034),
    [sym_this] = ACTIONS(3034),
    [anon_sym_discard] = ACTIONS(3034),
    [anon_sym_precise] = ACTIONS(3034),
    [anon_sym_shared] = ACTIONS(3034),
    [anon_sym_groupshared] = ACTIONS(3034),
    [anon_sym_uniform] = ACTIONS(3034),
    [anon_sym_row_major] = ACTIONS(3034),
    [anon_sym_column_major] = ACTIONS(3034),
    [anon_sym_globallycoherent] = ACTIONS(3034),
    [anon_sym_centroid] = ACTIONS(3034),
    [anon_sym_noperspective] = ACTIONS(3034),
    [anon_sym_nointerpolation] = ACTIONS(3034),
    [anon_sym_sample] = ACTIONS(3034),
    [anon_sym_linear] = ACTIONS(3034),
    [anon_sym_snorm] = ACTIONS(3034),
    [anon_sym_unorm] = ACTIONS(3034),
    [anon_sym_point] = ACTIONS(3034),
    [anon_sym_line] = ACTIONS(3034),
    [anon_sym_triangleadj] = ACTIONS(3034),
    [anon_sym_lineadj] = ACTIONS(3034),
    [anon_sym_triangle] = ACTIONS(3034),
    [anon_sym_cbuffer] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3034),
    [anon_sym_extension] = ACTIONS(3034),
    [anon_sym___exported] = ACTIONS(3034),
    [anon_sym_import] = ACTIONS(3034),
  },
  [581] = {
    [ts_builtin_sym_end] = ACTIONS(3320),
    [sym_identifier] = ACTIONS(3318),
    [aux_sym_preproc_include_token1] = ACTIONS(3318),
    [aux_sym_preproc_def_token1] = ACTIONS(3318),
    [aux_sym_preproc_if_token1] = ACTIONS(3318),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3318),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3318),
    [sym_preproc_directive] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(3320),
    [anon_sym_BANG] = ACTIONS(3320),
    [anon_sym_TILDE] = ACTIONS(3320),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3320),
    [anon_sym_AMP_AMP] = ACTIONS(3320),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_SEMI] = ACTIONS(3320),
    [anon_sym___extension__] = ACTIONS(3318),
    [anon_sym_typedef] = ACTIONS(3318),
    [anon_sym_in] = ACTIONS(3318),
    [anon_sym_out] = ACTIONS(3318),
    [anon_sym_inout] = ACTIONS(3318),
    [anon_sym_extern] = ACTIONS(3318),
    [anon_sym___attribute__] = ACTIONS(3318),
    [anon_sym_COLON_COLON] = ACTIONS(3320),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3320),
    [anon_sym___declspec] = ACTIONS(3318),
    [anon_sym___based] = ACTIONS(3318),
    [anon_sym___cdecl] = ACTIONS(3318),
    [anon_sym___clrcall] = ACTIONS(3318),
    [anon_sym___stdcall] = ACTIONS(3318),
    [anon_sym___fastcall] = ACTIONS(3318),
    [anon_sym___thiscall] = ACTIONS(3318),
    [anon_sym___vectorcall] = ACTIONS(3318),
    [anon_sym_LBRACE] = ACTIONS(3320),
    [anon_sym_signed] = ACTIONS(3318),
    [anon_sym_unsigned] = ACTIONS(3318),
    [anon_sym_long] = ACTIONS(3318),
    [anon_sym_short] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3318),
    [anon_sym_static] = ACTIONS(3318),
    [anon_sym_register] = ACTIONS(3318),
    [anon_sym_inline] = ACTIONS(3318),
    [anon_sym___inline] = ACTIONS(3318),
    [anon_sym___inline__] = ACTIONS(3318),
    [anon_sym___forceinline] = ACTIONS(3318),
    [anon_sym_thread_local] = ACTIONS(3318),
    [anon_sym___thread] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3318),
    [anon_sym_constexpr] = ACTIONS(3318),
    [anon_sym_volatile] = ACTIONS(3318),
    [anon_sym_restrict] = ACTIONS(3318),
    [anon_sym___restrict__] = ACTIONS(3318),
    [anon_sym__Atomic] = ACTIONS(3318),
    [anon_sym__Noreturn] = ACTIONS(3318),
    [anon_sym_noreturn] = ACTIONS(3318),
    [anon_sym_mutable] = ACTIONS(3318),
    [anon_sym_constinit] = ACTIONS(3318),
    [anon_sym_consteval] = ACTIONS(3318),
    [anon_sym_alignas] = ACTIONS(3318),
    [anon_sym__Alignas] = ACTIONS(3318),
    [sym_primitive_type] = ACTIONS(3318),
    [anon_sym_enum] = ACTIONS(3318),
    [anon_sym_class] = ACTIONS(3318),
    [anon_sym_struct] = ACTIONS(3318),
    [anon_sym_union] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_else] = ACTIONS(3318),
    [anon_sym_switch] = ACTIONS(3318),
    [anon_sym_case] = ACTIONS(3318),
    [anon_sym_default] = ACTIONS(3318),
    [anon_sym_while] = ACTIONS(3318),
    [anon_sym_do] = ACTIONS(3318),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_break] = ACTIONS(3318),
    [anon_sym_continue] = ACTIONS(3318),
    [anon_sym_goto] = ACTIONS(3318),
    [anon_sym___try] = ACTIONS(3318),
    [anon_sym___leave] = ACTIONS(3318),
    [anon_sym_not] = ACTIONS(3318),
    [anon_sym_compl] = ACTIONS(3318),
    [anon_sym_DASH_DASH] = ACTIONS(3320),
    [anon_sym_PLUS_PLUS] = ACTIONS(3320),
    [anon_sym_sizeof] = ACTIONS(3318),
    [anon_sym___alignof__] = ACTIONS(3318),
    [anon_sym___alignof] = ACTIONS(3318),
    [anon_sym__alignof] = ACTIONS(3318),
    [anon_sym_alignof] = ACTIONS(3318),
    [anon_sym__Alignof] = ACTIONS(3318),
    [anon_sym_offsetof] = ACTIONS(3318),
    [anon_sym__Generic] = ACTIONS(3318),
    [anon_sym_asm] = ACTIONS(3318),
    [anon_sym___asm__] = ACTIONS(3318),
    [sym_number_literal] = ACTIONS(3320),
    [anon_sym_L_SQUOTE] = ACTIONS(3320),
    [anon_sym_u_SQUOTE] = ACTIONS(3320),
    [anon_sym_U_SQUOTE] = ACTIONS(3320),
    [anon_sym_u8_SQUOTE] = ACTIONS(3320),
    [anon_sym_SQUOTE] = ACTIONS(3320),
    [anon_sym_L_DQUOTE] = ACTIONS(3320),
    [anon_sym_u_DQUOTE] = ACTIONS(3320),
    [anon_sym_U_DQUOTE] = ACTIONS(3320),
    [anon_sym_u8_DQUOTE] = ACTIONS(3320),
    [anon_sym_DQUOTE] = ACTIONS(3320),
    [sym_true] = ACTIONS(3318),
    [sym_false] = ACTIONS(3318),
    [anon_sym_NULL] = ACTIONS(3318),
    [anon_sym_nullptr] = ACTIONS(3318),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3318),
    [anon_sym_let] = ACTIONS(3318),
    [anon_sym_This] = ACTIONS(3318),
    [anon_sym_decltype] = ACTIONS(3318),
    [sym_virtual] = ACTIONS(3318),
    [anon_sym_explicit] = ACTIONS(3318),
    [anon_sym_typename] = ACTIONS(3318),
    [anon_sym_template] = ACTIONS(3318),
    [anon_sym_operator] = ACTIONS(3318),
    [anon_sym_try] = ACTIONS(3318),
    [anon_sym_delete] = ACTIONS(3318),
    [anon_sym_throw] = ACTIONS(3318),
    [anon_sym_namespace] = ACTIONS(3318),
    [anon_sym_using] = ACTIONS(3318),
    [anon_sym_static_assert] = ACTIONS(3318),
    [anon_sym_concept] = ACTIONS(3318),
    [anon_sym_co_return] = ACTIONS(3318),
    [anon_sym_co_yield] = ACTIONS(3318),
    [anon_sym_R_DQUOTE] = ACTIONS(3320),
    [anon_sym_LR_DQUOTE] = ACTIONS(3320),
    [anon_sym_uR_DQUOTE] = ACTIONS(3320),
    [anon_sym_UR_DQUOTE] = ACTIONS(3320),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3320),
    [anon_sym_co_await] = ACTIONS(3318),
    [anon_sym_new] = ACTIONS(3318),
    [anon_sym_requires] = ACTIONS(3318),
    [sym_this] = ACTIONS(3318),
    [anon_sym_discard] = ACTIONS(3318),
    [anon_sym_precise] = ACTIONS(3318),
    [anon_sym_shared] = ACTIONS(3318),
    [anon_sym_groupshared] = ACTIONS(3318),
    [anon_sym_uniform] = ACTIONS(3318),
    [anon_sym_row_major] = ACTIONS(3318),
    [anon_sym_column_major] = ACTIONS(3318),
    [anon_sym_globallycoherent] = ACTIONS(3318),
    [anon_sym_centroid] = ACTIONS(3318),
    [anon_sym_noperspective] = ACTIONS(3318),
    [anon_sym_nointerpolation] = ACTIONS(3318),
    [anon_sym_sample] = ACTIONS(3318),
    [anon_sym_linear] = ACTIONS(3318),
    [anon_sym_snorm] = ACTIONS(3318),
    [anon_sym_unorm] = ACTIONS(3318),
    [anon_sym_point] = ACTIONS(3318),
    [anon_sym_line] = ACTIONS(3318),
    [anon_sym_triangleadj] = ACTIONS(3318),
    [anon_sym_lineadj] = ACTIONS(3318),
    [anon_sym_triangle] = ACTIONS(3318),
    [anon_sym_cbuffer] = ACTIONS(3318),
    [anon_sym_interface] = ACTIONS(3318),
    [anon_sym_extension] = ACTIONS(3318),
    [anon_sym___exported] = ACTIONS(3318),
    [anon_sym_import] = ACTIONS(3318),
  },
  [582] = {
    [ts_builtin_sym_end] = ACTIONS(3324),
    [sym_identifier] = ACTIONS(3322),
    [aux_sym_preproc_include_token1] = ACTIONS(3322),
    [aux_sym_preproc_def_token1] = ACTIONS(3322),
    [aux_sym_preproc_if_token1] = ACTIONS(3322),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3322),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3322),
    [sym_preproc_directive] = ACTIONS(3322),
    [anon_sym_LPAREN2] = ACTIONS(3324),
    [anon_sym_BANG] = ACTIONS(3324),
    [anon_sym_TILDE] = ACTIONS(3324),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_STAR] = ACTIONS(3324),
    [anon_sym_AMP_AMP] = ACTIONS(3324),
    [anon_sym_AMP] = ACTIONS(3322),
    [anon_sym_SEMI] = ACTIONS(3324),
    [anon_sym___extension__] = ACTIONS(3322),
    [anon_sym_typedef] = ACTIONS(3322),
    [anon_sym_in] = ACTIONS(3322),
    [anon_sym_out] = ACTIONS(3322),
    [anon_sym_inout] = ACTIONS(3322),
    [anon_sym_extern] = ACTIONS(3322),
    [anon_sym___attribute__] = ACTIONS(3322),
    [anon_sym_COLON_COLON] = ACTIONS(3324),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3324),
    [anon_sym___declspec] = ACTIONS(3322),
    [anon_sym___based] = ACTIONS(3322),
    [anon_sym___cdecl] = ACTIONS(3322),
    [anon_sym___clrcall] = ACTIONS(3322),
    [anon_sym___stdcall] = ACTIONS(3322),
    [anon_sym___fastcall] = ACTIONS(3322),
    [anon_sym___thiscall] = ACTIONS(3322),
    [anon_sym___vectorcall] = ACTIONS(3322),
    [anon_sym_LBRACE] = ACTIONS(3324),
    [anon_sym_signed] = ACTIONS(3322),
    [anon_sym_unsigned] = ACTIONS(3322),
    [anon_sym_long] = ACTIONS(3322),
    [anon_sym_short] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_static] = ACTIONS(3322),
    [anon_sym_register] = ACTIONS(3322),
    [anon_sym_inline] = ACTIONS(3322),
    [anon_sym___inline] = ACTIONS(3322),
    [anon_sym___inline__] = ACTIONS(3322),
    [anon_sym___forceinline] = ACTIONS(3322),
    [anon_sym_thread_local] = ACTIONS(3322),
    [anon_sym___thread] = ACTIONS(3322),
    [anon_sym_const] = ACTIONS(3322),
    [anon_sym_constexpr] = ACTIONS(3322),
    [anon_sym_volatile] = ACTIONS(3322),
    [anon_sym_restrict] = ACTIONS(3322),
    [anon_sym___restrict__] = ACTIONS(3322),
    [anon_sym__Atomic] = ACTIONS(3322),
    [anon_sym__Noreturn] = ACTIONS(3322),
    [anon_sym_noreturn] = ACTIONS(3322),
    [anon_sym_mutable] = ACTIONS(3322),
    [anon_sym_constinit] = ACTIONS(3322),
    [anon_sym_consteval] = ACTIONS(3322),
    [anon_sym_alignas] = ACTIONS(3322),
    [anon_sym__Alignas] = ACTIONS(3322),
    [sym_primitive_type] = ACTIONS(3322),
    [anon_sym_enum] = ACTIONS(3322),
    [anon_sym_class] = ACTIONS(3322),
    [anon_sym_struct] = ACTIONS(3322),
    [anon_sym_union] = ACTIONS(3322),
    [anon_sym_if] = ACTIONS(3322),
    [anon_sym_else] = ACTIONS(3322),
    [anon_sym_switch] = ACTIONS(3322),
    [anon_sym_case] = ACTIONS(3322),
    [anon_sym_default] = ACTIONS(3322),
    [anon_sym_while] = ACTIONS(3322),
    [anon_sym_do] = ACTIONS(3322),
    [anon_sym_for] = ACTIONS(3322),
    [anon_sym_return] = ACTIONS(3322),
    [anon_sym_break] = ACTIONS(3322),
    [anon_sym_continue] = ACTIONS(3322),
    [anon_sym_goto] = ACTIONS(3322),
    [anon_sym___try] = ACTIONS(3322),
    [anon_sym___leave] = ACTIONS(3322),
    [anon_sym_not] = ACTIONS(3322),
    [anon_sym_compl] = ACTIONS(3322),
    [anon_sym_DASH_DASH] = ACTIONS(3324),
    [anon_sym_PLUS_PLUS] = ACTIONS(3324),
    [anon_sym_sizeof] = ACTIONS(3322),
    [anon_sym___alignof__] = ACTIONS(3322),
    [anon_sym___alignof] = ACTIONS(3322),
    [anon_sym__alignof] = ACTIONS(3322),
    [anon_sym_alignof] = ACTIONS(3322),
    [anon_sym__Alignof] = ACTIONS(3322),
    [anon_sym_offsetof] = ACTIONS(3322),
    [anon_sym__Generic] = ACTIONS(3322),
    [anon_sym_asm] = ACTIONS(3322),
    [anon_sym___asm__] = ACTIONS(3322),
    [sym_number_literal] = ACTIONS(3324),
    [anon_sym_L_SQUOTE] = ACTIONS(3324),
    [anon_sym_u_SQUOTE] = ACTIONS(3324),
    [anon_sym_U_SQUOTE] = ACTIONS(3324),
    [anon_sym_u8_SQUOTE] = ACTIONS(3324),
    [anon_sym_SQUOTE] = ACTIONS(3324),
    [anon_sym_L_DQUOTE] = ACTIONS(3324),
    [anon_sym_u_DQUOTE] = ACTIONS(3324),
    [anon_sym_U_DQUOTE] = ACTIONS(3324),
    [anon_sym_u8_DQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE] = ACTIONS(3324),
    [sym_true] = ACTIONS(3322),
    [sym_false] = ACTIONS(3322),
    [anon_sym_NULL] = ACTIONS(3322),
    [anon_sym_nullptr] = ACTIONS(3322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3322),
    [anon_sym_let] = ACTIONS(3322),
    [anon_sym_This] = ACTIONS(3322),
    [anon_sym_decltype] = ACTIONS(3322),
    [sym_virtual] = ACTIONS(3322),
    [anon_sym_explicit] = ACTIONS(3322),
    [anon_sym_typename] = ACTIONS(3322),
    [anon_sym_template] = ACTIONS(3322),
    [anon_sym_operator] = ACTIONS(3322),
    [anon_sym_try] = ACTIONS(3322),
    [anon_sym_delete] = ACTIONS(3322),
    [anon_sym_throw] = ACTIONS(3322),
    [anon_sym_namespace] = ACTIONS(3322),
    [anon_sym_using] = ACTIONS(3322),
    [anon_sym_static_assert] = ACTIONS(3322),
    [anon_sym_concept] = ACTIONS(3322),
    [anon_sym_co_return] = ACTIONS(3322),
    [anon_sym_co_yield] = ACTIONS(3322),
    [anon_sym_R_DQUOTE] = ACTIONS(3324),
    [anon_sym_LR_DQUOTE] = ACTIONS(3324),
    [anon_sym_uR_DQUOTE] = ACTIONS(3324),
    [anon_sym_UR_DQUOTE] = ACTIONS(3324),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3324),
    [anon_sym_co_await] = ACTIONS(3322),
    [anon_sym_new] = ACTIONS(3322),
    [anon_sym_requires] = ACTIONS(3322),
    [sym_this] = ACTIONS(3322),
    [anon_sym_discard] = ACTIONS(3322),
    [anon_sym_precise] = ACTIONS(3322),
    [anon_sym_shared] = ACTIONS(3322),
    [anon_sym_groupshared] = ACTIONS(3322),
    [anon_sym_uniform] = ACTIONS(3322),
    [anon_sym_row_major] = ACTIONS(3322),
    [anon_sym_column_major] = ACTIONS(3322),
    [anon_sym_globallycoherent] = ACTIONS(3322),
    [anon_sym_centroid] = ACTIONS(3322),
    [anon_sym_noperspective] = ACTIONS(3322),
    [anon_sym_nointerpolation] = ACTIONS(3322),
    [anon_sym_sample] = ACTIONS(3322),
    [anon_sym_linear] = ACTIONS(3322),
    [anon_sym_snorm] = ACTIONS(3322),
    [anon_sym_unorm] = ACTIONS(3322),
    [anon_sym_point] = ACTIONS(3322),
    [anon_sym_line] = ACTIONS(3322),
    [anon_sym_triangleadj] = ACTIONS(3322),
    [anon_sym_lineadj] = ACTIONS(3322),
    [anon_sym_triangle] = ACTIONS(3322),
    [anon_sym_cbuffer] = ACTIONS(3322),
    [anon_sym_interface] = ACTIONS(3322),
    [anon_sym_extension] = ACTIONS(3322),
    [anon_sym___exported] = ACTIONS(3322),
    [anon_sym_import] = ACTIONS(3322),
  },
  [583] = {
    [ts_builtin_sym_end] = ACTIONS(3078),
    [sym_identifier] = ACTIONS(3076),
    [aux_sym_preproc_include_token1] = ACTIONS(3076),
    [aux_sym_preproc_def_token1] = ACTIONS(3076),
    [aux_sym_preproc_if_token1] = ACTIONS(3076),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3076),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3076),
    [sym_preproc_directive] = ACTIONS(3076),
    [anon_sym_LPAREN2] = ACTIONS(3078),
    [anon_sym_BANG] = ACTIONS(3078),
    [anon_sym_TILDE] = ACTIONS(3078),
    [anon_sym_DASH] = ACTIONS(3076),
    [anon_sym_PLUS] = ACTIONS(3076),
    [anon_sym_STAR] = ACTIONS(3078),
    [anon_sym_AMP_AMP] = ACTIONS(3078),
    [anon_sym_AMP] = ACTIONS(3076),
    [anon_sym_SEMI] = ACTIONS(3078),
    [anon_sym___extension__] = ACTIONS(3076),
    [anon_sym_typedef] = ACTIONS(3076),
    [anon_sym_in] = ACTIONS(3076),
    [anon_sym_out] = ACTIONS(3076),
    [anon_sym_inout] = ACTIONS(3076),
    [anon_sym_extern] = ACTIONS(3076),
    [anon_sym___attribute__] = ACTIONS(3076),
    [anon_sym_COLON_COLON] = ACTIONS(3078),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3078),
    [anon_sym___declspec] = ACTIONS(3076),
    [anon_sym___based] = ACTIONS(3076),
    [anon_sym___cdecl] = ACTIONS(3076),
    [anon_sym___clrcall] = ACTIONS(3076),
    [anon_sym___stdcall] = ACTIONS(3076),
    [anon_sym___fastcall] = ACTIONS(3076),
    [anon_sym___thiscall] = ACTIONS(3076),
    [anon_sym___vectorcall] = ACTIONS(3076),
    [anon_sym_LBRACE] = ACTIONS(3078),
    [anon_sym_signed] = ACTIONS(3076),
    [anon_sym_unsigned] = ACTIONS(3076),
    [anon_sym_long] = ACTIONS(3076),
    [anon_sym_short] = ACTIONS(3076),
    [anon_sym_LBRACK] = ACTIONS(3076),
    [anon_sym_static] = ACTIONS(3076),
    [anon_sym_register] = ACTIONS(3076),
    [anon_sym_inline] = ACTIONS(3076),
    [anon_sym___inline] = ACTIONS(3076),
    [anon_sym___inline__] = ACTIONS(3076),
    [anon_sym___forceinline] = ACTIONS(3076),
    [anon_sym_thread_local] = ACTIONS(3076),
    [anon_sym___thread] = ACTIONS(3076),
    [anon_sym_const] = ACTIONS(3076),
    [anon_sym_constexpr] = ACTIONS(3076),
    [anon_sym_volatile] = ACTIONS(3076),
    [anon_sym_restrict] = ACTIONS(3076),
    [anon_sym___restrict__] = ACTIONS(3076),
    [anon_sym__Atomic] = ACTIONS(3076),
    [anon_sym__Noreturn] = ACTIONS(3076),
    [anon_sym_noreturn] = ACTIONS(3076),
    [anon_sym_mutable] = ACTIONS(3076),
    [anon_sym_constinit] = ACTIONS(3076),
    [anon_sym_consteval] = ACTIONS(3076),
    [anon_sym_alignas] = ACTIONS(3076),
    [anon_sym__Alignas] = ACTIONS(3076),
    [sym_primitive_type] = ACTIONS(3076),
    [anon_sym_enum] = ACTIONS(3076),
    [anon_sym_class] = ACTIONS(3076),
    [anon_sym_struct] = ACTIONS(3076),
    [anon_sym_union] = ACTIONS(3076),
    [anon_sym_if] = ACTIONS(3076),
    [anon_sym_else] = ACTIONS(3076),
    [anon_sym_switch] = ACTIONS(3076),
    [anon_sym_case] = ACTIONS(3076),
    [anon_sym_default] = ACTIONS(3076),
    [anon_sym_while] = ACTIONS(3076),
    [anon_sym_do] = ACTIONS(3076),
    [anon_sym_for] = ACTIONS(3076),
    [anon_sym_return] = ACTIONS(3076),
    [anon_sym_break] = ACTIONS(3076),
    [anon_sym_continue] = ACTIONS(3076),
    [anon_sym_goto] = ACTIONS(3076),
    [anon_sym___try] = ACTIONS(3076),
    [anon_sym___leave] = ACTIONS(3076),
    [anon_sym_not] = ACTIONS(3076),
    [anon_sym_compl] = ACTIONS(3076),
    [anon_sym_DASH_DASH] = ACTIONS(3078),
    [anon_sym_PLUS_PLUS] = ACTIONS(3078),
    [anon_sym_sizeof] = ACTIONS(3076),
    [anon_sym___alignof__] = ACTIONS(3076),
    [anon_sym___alignof] = ACTIONS(3076),
    [anon_sym__alignof] = ACTIONS(3076),
    [anon_sym_alignof] = ACTIONS(3076),
    [anon_sym__Alignof] = ACTIONS(3076),
    [anon_sym_offsetof] = ACTIONS(3076),
    [anon_sym__Generic] = ACTIONS(3076),
    [anon_sym_asm] = ACTIONS(3076),
    [anon_sym___asm__] = ACTIONS(3076),
    [sym_number_literal] = ACTIONS(3078),
    [anon_sym_L_SQUOTE] = ACTIONS(3078),
    [anon_sym_u_SQUOTE] = ACTIONS(3078),
    [anon_sym_U_SQUOTE] = ACTIONS(3078),
    [anon_sym_u8_SQUOTE] = ACTIONS(3078),
    [anon_sym_SQUOTE] = ACTIONS(3078),
    [anon_sym_L_DQUOTE] = ACTIONS(3078),
    [anon_sym_u_DQUOTE] = ACTIONS(3078),
    [anon_sym_U_DQUOTE] = ACTIONS(3078),
    [anon_sym_u8_DQUOTE] = ACTIONS(3078),
    [anon_sym_DQUOTE] = ACTIONS(3078),
    [sym_true] = ACTIONS(3076),
    [sym_false] = ACTIONS(3076),
    [anon_sym_NULL] = ACTIONS(3076),
    [anon_sym_nullptr] = ACTIONS(3076),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3076),
    [anon_sym_let] = ACTIONS(3076),
    [anon_sym_This] = ACTIONS(3076),
    [anon_sym_decltype] = ACTIONS(3076),
    [sym_virtual] = ACTIONS(3076),
    [anon_sym_explicit] = ACTIONS(3076),
    [anon_sym_typename] = ACTIONS(3076),
    [anon_sym_template] = ACTIONS(3076),
    [anon_sym_operator] = ACTIONS(3076),
    [anon_sym_try] = ACTIONS(3076),
    [anon_sym_delete] = ACTIONS(3076),
    [anon_sym_throw] = ACTIONS(3076),
    [anon_sym_namespace] = ACTIONS(3076),
    [anon_sym_using] = ACTIONS(3076),
    [anon_sym_static_assert] = ACTIONS(3076),
    [anon_sym_concept] = ACTIONS(3076),
    [anon_sym_co_return] = ACTIONS(3076),
    [anon_sym_co_yield] = ACTIONS(3076),
    [anon_sym_R_DQUOTE] = ACTIONS(3078),
    [anon_sym_LR_DQUOTE] = ACTIONS(3078),
    [anon_sym_uR_DQUOTE] = ACTIONS(3078),
    [anon_sym_UR_DQUOTE] = ACTIONS(3078),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3078),
    [anon_sym_co_await] = ACTIONS(3076),
    [anon_sym_new] = ACTIONS(3076),
    [anon_sym_requires] = ACTIONS(3076),
    [sym_this] = ACTIONS(3076),
    [anon_sym_discard] = ACTIONS(3076),
    [anon_sym_precise] = ACTIONS(3076),
    [anon_sym_shared] = ACTIONS(3076),
    [anon_sym_groupshared] = ACTIONS(3076),
    [anon_sym_uniform] = ACTIONS(3076),
    [anon_sym_row_major] = ACTIONS(3076),
    [anon_sym_column_major] = ACTIONS(3076),
    [anon_sym_globallycoherent] = ACTIONS(3076),
    [anon_sym_centroid] = ACTIONS(3076),
    [anon_sym_noperspective] = ACTIONS(3076),
    [anon_sym_nointerpolation] = ACTIONS(3076),
    [anon_sym_sample] = ACTIONS(3076),
    [anon_sym_linear] = ACTIONS(3076),
    [anon_sym_snorm] = ACTIONS(3076),
    [anon_sym_unorm] = ACTIONS(3076),
    [anon_sym_point] = ACTIONS(3076),
    [anon_sym_line] = ACTIONS(3076),
    [anon_sym_triangleadj] = ACTIONS(3076),
    [anon_sym_lineadj] = ACTIONS(3076),
    [anon_sym_triangle] = ACTIONS(3076),
    [anon_sym_cbuffer] = ACTIONS(3076),
    [anon_sym_interface] = ACTIONS(3076),
    [anon_sym_extension] = ACTIONS(3076),
    [anon_sym___exported] = ACTIONS(3076),
    [anon_sym_import] = ACTIONS(3076),
  },
  [584] = {
    [ts_builtin_sym_end] = ACTIONS(3332),
    [sym_identifier] = ACTIONS(3330),
    [aux_sym_preproc_include_token1] = ACTIONS(3330),
    [aux_sym_preproc_def_token1] = ACTIONS(3330),
    [aux_sym_preproc_if_token1] = ACTIONS(3330),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3330),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3330),
    [sym_preproc_directive] = ACTIONS(3330),
    [anon_sym_LPAREN2] = ACTIONS(3332),
    [anon_sym_BANG] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3332),
    [anon_sym_DASH] = ACTIONS(3330),
    [anon_sym_PLUS] = ACTIONS(3330),
    [anon_sym_STAR] = ACTIONS(3332),
    [anon_sym_AMP_AMP] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(3330),
    [anon_sym_SEMI] = ACTIONS(3332),
    [anon_sym___extension__] = ACTIONS(3330),
    [anon_sym_typedef] = ACTIONS(3330),
    [anon_sym_in] = ACTIONS(3330),
    [anon_sym_out] = ACTIONS(3330),
    [anon_sym_inout] = ACTIONS(3330),
    [anon_sym_extern] = ACTIONS(3330),
    [anon_sym___attribute__] = ACTIONS(3330),
    [anon_sym_COLON_COLON] = ACTIONS(3332),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3332),
    [anon_sym___declspec] = ACTIONS(3330),
    [anon_sym___based] = ACTIONS(3330),
    [anon_sym___cdecl] = ACTIONS(3330),
    [anon_sym___clrcall] = ACTIONS(3330),
    [anon_sym___stdcall] = ACTIONS(3330),
    [anon_sym___fastcall] = ACTIONS(3330),
    [anon_sym___thiscall] = ACTIONS(3330),
    [anon_sym___vectorcall] = ACTIONS(3330),
    [anon_sym_LBRACE] = ACTIONS(3332),
    [anon_sym_signed] = ACTIONS(3330),
    [anon_sym_unsigned] = ACTIONS(3330),
    [anon_sym_long] = ACTIONS(3330),
    [anon_sym_short] = ACTIONS(3330),
    [anon_sym_LBRACK] = ACTIONS(3330),
    [anon_sym_static] = ACTIONS(3330),
    [anon_sym_register] = ACTIONS(3330),
    [anon_sym_inline] = ACTIONS(3330),
    [anon_sym___inline] = ACTIONS(3330),
    [anon_sym___inline__] = ACTIONS(3330),
    [anon_sym___forceinline] = ACTIONS(3330),
    [anon_sym_thread_local] = ACTIONS(3330),
    [anon_sym___thread] = ACTIONS(3330),
    [anon_sym_const] = ACTIONS(3330),
    [anon_sym_constexpr] = ACTIONS(3330),
    [anon_sym_volatile] = ACTIONS(3330),
    [anon_sym_restrict] = ACTIONS(3330),
    [anon_sym___restrict__] = ACTIONS(3330),
    [anon_sym__Atomic] = ACTIONS(3330),
    [anon_sym__Noreturn] = ACTIONS(3330),
    [anon_sym_noreturn] = ACTIONS(3330),
    [anon_sym_mutable] = ACTIONS(3330),
    [anon_sym_constinit] = ACTIONS(3330),
    [anon_sym_consteval] = ACTIONS(3330),
    [anon_sym_alignas] = ACTIONS(3330),
    [anon_sym__Alignas] = ACTIONS(3330),
    [sym_primitive_type] = ACTIONS(3330),
    [anon_sym_enum] = ACTIONS(3330),
    [anon_sym_class] = ACTIONS(3330),
    [anon_sym_struct] = ACTIONS(3330),
    [anon_sym_union] = ACTIONS(3330),
    [anon_sym_if] = ACTIONS(3330),
    [anon_sym_else] = ACTIONS(3330),
    [anon_sym_switch] = ACTIONS(3330),
    [anon_sym_case] = ACTIONS(3330),
    [anon_sym_default] = ACTIONS(3330),
    [anon_sym_while] = ACTIONS(3330),
    [anon_sym_do] = ACTIONS(3330),
    [anon_sym_for] = ACTIONS(3330),
    [anon_sym_return] = ACTIONS(3330),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_continue] = ACTIONS(3330),
    [anon_sym_goto] = ACTIONS(3330),
    [anon_sym___try] = ACTIONS(3330),
    [anon_sym___leave] = ACTIONS(3330),
    [anon_sym_not] = ACTIONS(3330),
    [anon_sym_compl] = ACTIONS(3330),
    [anon_sym_DASH_DASH] = ACTIONS(3332),
    [anon_sym_PLUS_PLUS] = ACTIONS(3332),
    [anon_sym_sizeof] = ACTIONS(3330),
    [anon_sym___alignof__] = ACTIONS(3330),
    [anon_sym___alignof] = ACTIONS(3330),
    [anon_sym__alignof] = ACTIONS(3330),
    [anon_sym_alignof] = ACTIONS(3330),
    [anon_sym__Alignof] = ACTIONS(3330),
    [anon_sym_offsetof] = ACTIONS(3330),
    [anon_sym__Generic] = ACTIONS(3330),
    [anon_sym_asm] = ACTIONS(3330),
    [anon_sym___asm__] = ACTIONS(3330),
    [sym_number_literal] = ACTIONS(3332),
    [anon_sym_L_SQUOTE] = ACTIONS(3332),
    [anon_sym_u_SQUOTE] = ACTIONS(3332),
    [anon_sym_U_SQUOTE] = ACTIONS(3332),
    [anon_sym_u8_SQUOTE] = ACTIONS(3332),
    [anon_sym_SQUOTE] = ACTIONS(3332),
    [anon_sym_L_DQUOTE] = ACTIONS(3332),
    [anon_sym_u_DQUOTE] = ACTIONS(3332),
    [anon_sym_U_DQUOTE] = ACTIONS(3332),
    [anon_sym_u8_DQUOTE] = ACTIONS(3332),
    [anon_sym_DQUOTE] = ACTIONS(3332),
    [sym_true] = ACTIONS(3330),
    [sym_false] = ACTIONS(3330),
    [anon_sym_NULL] = ACTIONS(3330),
    [anon_sym_nullptr] = ACTIONS(3330),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3330),
    [anon_sym_let] = ACTIONS(3330),
    [anon_sym_This] = ACTIONS(3330),
    [anon_sym_decltype] = ACTIONS(3330),
    [sym_virtual] = ACTIONS(3330),
    [anon_sym_explicit] = ACTIONS(3330),
    [anon_sym_typename] = ACTIONS(3330),
    [anon_sym_template] = ACTIONS(3330),
    [anon_sym_operator] = ACTIONS(3330),
    [anon_sym_try] = ACTIONS(3330),
    [anon_sym_delete] = ACTIONS(3330),
    [anon_sym_throw] = ACTIONS(3330),
    [anon_sym_namespace] = ACTIONS(3330),
    [anon_sym_using] = ACTIONS(3330),
    [anon_sym_static_assert] = ACTIONS(3330),
    [anon_sym_concept] = ACTIONS(3330),
    [anon_sym_co_return] = ACTIONS(3330),
    [anon_sym_co_yield] = ACTIONS(3330),
    [anon_sym_R_DQUOTE] = ACTIONS(3332),
    [anon_sym_LR_DQUOTE] = ACTIONS(3332),
    [anon_sym_uR_DQUOTE] = ACTIONS(3332),
    [anon_sym_UR_DQUOTE] = ACTIONS(3332),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3332),
    [anon_sym_co_await] = ACTIONS(3330),
    [anon_sym_new] = ACTIONS(3330),
    [anon_sym_requires] = ACTIONS(3330),
    [sym_this] = ACTIONS(3330),
    [anon_sym_discard] = ACTIONS(3330),
    [anon_sym_precise] = ACTIONS(3330),
    [anon_sym_shared] = ACTIONS(3330),
    [anon_sym_groupshared] = ACTIONS(3330),
    [anon_sym_uniform] = ACTIONS(3330),
    [anon_sym_row_major] = ACTIONS(3330),
    [anon_sym_column_major] = ACTIONS(3330),
    [anon_sym_globallycoherent] = ACTIONS(3330),
    [anon_sym_centroid] = ACTIONS(3330),
    [anon_sym_noperspective] = ACTIONS(3330),
    [anon_sym_nointerpolation] = ACTIONS(3330),
    [anon_sym_sample] = ACTIONS(3330),
    [anon_sym_linear] = ACTIONS(3330),
    [anon_sym_snorm] = ACTIONS(3330),
    [anon_sym_unorm] = ACTIONS(3330),
    [anon_sym_point] = ACTIONS(3330),
    [anon_sym_line] = ACTIONS(3330),
    [anon_sym_triangleadj] = ACTIONS(3330),
    [anon_sym_lineadj] = ACTIONS(3330),
    [anon_sym_triangle] = ACTIONS(3330),
    [anon_sym_cbuffer] = ACTIONS(3330),
    [anon_sym_interface] = ACTIONS(3330),
    [anon_sym_extension] = ACTIONS(3330),
    [anon_sym___exported] = ACTIONS(3330),
    [anon_sym_import] = ACTIONS(3330),
  },
  [585] = {
    [ts_builtin_sym_end] = ACTIONS(3342),
    [sym_identifier] = ACTIONS(3340),
    [aux_sym_preproc_include_token1] = ACTIONS(3340),
    [aux_sym_preproc_def_token1] = ACTIONS(3340),
    [aux_sym_preproc_if_token1] = ACTIONS(3340),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3340),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3340),
    [sym_preproc_directive] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(3342),
    [anon_sym_BANG] = ACTIONS(3342),
    [anon_sym_TILDE] = ACTIONS(3342),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_STAR] = ACTIONS(3342),
    [anon_sym_AMP_AMP] = ACTIONS(3342),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_SEMI] = ACTIONS(3342),
    [anon_sym___extension__] = ACTIONS(3340),
    [anon_sym_typedef] = ACTIONS(3340),
    [anon_sym_in] = ACTIONS(3340),
    [anon_sym_out] = ACTIONS(3340),
    [anon_sym_inout] = ACTIONS(3340),
    [anon_sym_extern] = ACTIONS(3340),
    [anon_sym___attribute__] = ACTIONS(3340),
    [anon_sym_COLON_COLON] = ACTIONS(3342),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3342),
    [anon_sym___declspec] = ACTIONS(3340),
    [anon_sym___based] = ACTIONS(3340),
    [anon_sym___cdecl] = ACTIONS(3340),
    [anon_sym___clrcall] = ACTIONS(3340),
    [anon_sym___stdcall] = ACTIONS(3340),
    [anon_sym___fastcall] = ACTIONS(3340),
    [anon_sym___thiscall] = ACTIONS(3340),
    [anon_sym___vectorcall] = ACTIONS(3340),
    [anon_sym_LBRACE] = ACTIONS(3342),
    [anon_sym_signed] = ACTIONS(3340),
    [anon_sym_unsigned] = ACTIONS(3340),
    [anon_sym_long] = ACTIONS(3340),
    [anon_sym_short] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3340),
    [anon_sym_static] = ACTIONS(3340),
    [anon_sym_register] = ACTIONS(3340),
    [anon_sym_inline] = ACTIONS(3340),
    [anon_sym___inline] = ACTIONS(3340),
    [anon_sym___inline__] = ACTIONS(3340),
    [anon_sym___forceinline] = ACTIONS(3340),
    [anon_sym_thread_local] = ACTIONS(3340),
    [anon_sym___thread] = ACTIONS(3340),
    [anon_sym_const] = ACTIONS(3340),
    [anon_sym_constexpr] = ACTIONS(3340),
    [anon_sym_volatile] = ACTIONS(3340),
    [anon_sym_restrict] = ACTIONS(3340),
    [anon_sym___restrict__] = ACTIONS(3340),
    [anon_sym__Atomic] = ACTIONS(3340),
    [anon_sym__Noreturn] = ACTIONS(3340),
    [anon_sym_noreturn] = ACTIONS(3340),
    [anon_sym_mutable] = ACTIONS(3340),
    [anon_sym_constinit] = ACTIONS(3340),
    [anon_sym_consteval] = ACTIONS(3340),
    [anon_sym_alignas] = ACTIONS(3340),
    [anon_sym__Alignas] = ACTIONS(3340),
    [sym_primitive_type] = ACTIONS(3340),
    [anon_sym_enum] = ACTIONS(3340),
    [anon_sym_class] = ACTIONS(3340),
    [anon_sym_struct] = ACTIONS(3340),
    [anon_sym_union] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_else] = ACTIONS(3340),
    [anon_sym_switch] = ACTIONS(3340),
    [anon_sym_case] = ACTIONS(3340),
    [anon_sym_default] = ACTIONS(3340),
    [anon_sym_while] = ACTIONS(3340),
    [anon_sym_do] = ACTIONS(3340),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_break] = ACTIONS(3340),
    [anon_sym_continue] = ACTIONS(3340),
    [anon_sym_goto] = ACTIONS(3340),
    [anon_sym___try] = ACTIONS(3340),
    [anon_sym___leave] = ACTIONS(3340),
    [anon_sym_not] = ACTIONS(3340),
    [anon_sym_compl] = ACTIONS(3340),
    [anon_sym_DASH_DASH] = ACTIONS(3342),
    [anon_sym_PLUS_PLUS] = ACTIONS(3342),
    [anon_sym_sizeof] = ACTIONS(3340),
    [anon_sym___alignof__] = ACTIONS(3340),
    [anon_sym___alignof] = ACTIONS(3340),
    [anon_sym__alignof] = ACTIONS(3340),
    [anon_sym_alignof] = ACTIONS(3340),
    [anon_sym__Alignof] = ACTIONS(3340),
    [anon_sym_offsetof] = ACTIONS(3340),
    [anon_sym__Generic] = ACTIONS(3340),
    [anon_sym_asm] = ACTIONS(3340),
    [anon_sym___asm__] = ACTIONS(3340),
    [sym_number_literal] = ACTIONS(3342),
    [anon_sym_L_SQUOTE] = ACTIONS(3342),
    [anon_sym_u_SQUOTE] = ACTIONS(3342),
    [anon_sym_U_SQUOTE] = ACTIONS(3342),
    [anon_sym_u8_SQUOTE] = ACTIONS(3342),
    [anon_sym_SQUOTE] = ACTIONS(3342),
    [anon_sym_L_DQUOTE] = ACTIONS(3342),
    [anon_sym_u_DQUOTE] = ACTIONS(3342),
    [anon_sym_U_DQUOTE] = ACTIONS(3342),
    [anon_sym_u8_DQUOTE] = ACTIONS(3342),
    [anon_sym_DQUOTE] = ACTIONS(3342),
    [sym_true] = ACTIONS(3340),
    [sym_false] = ACTIONS(3340),
    [anon_sym_NULL] = ACTIONS(3340),
    [anon_sym_nullptr] = ACTIONS(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3340),
    [anon_sym_let] = ACTIONS(3340),
    [anon_sym_This] = ACTIONS(3340),
    [anon_sym_decltype] = ACTIONS(3340),
    [sym_virtual] = ACTIONS(3340),
    [anon_sym_explicit] = ACTIONS(3340),
    [anon_sym_typename] = ACTIONS(3340),
    [anon_sym_template] = ACTIONS(3340),
    [anon_sym_operator] = ACTIONS(3340),
    [anon_sym_try] = ACTIONS(3340),
    [anon_sym_delete] = ACTIONS(3340),
    [anon_sym_throw] = ACTIONS(3340),
    [anon_sym_namespace] = ACTIONS(3340),
    [anon_sym_using] = ACTIONS(3340),
    [anon_sym_static_assert] = ACTIONS(3340),
    [anon_sym_concept] = ACTIONS(3340),
    [anon_sym_co_return] = ACTIONS(3340),
    [anon_sym_co_yield] = ACTIONS(3340),
    [anon_sym_R_DQUOTE] = ACTIONS(3342),
    [anon_sym_LR_DQUOTE] = ACTIONS(3342),
    [anon_sym_uR_DQUOTE] = ACTIONS(3342),
    [anon_sym_UR_DQUOTE] = ACTIONS(3342),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3342),
    [anon_sym_co_await] = ACTIONS(3340),
    [anon_sym_new] = ACTIONS(3340),
    [anon_sym_requires] = ACTIONS(3340),
    [sym_this] = ACTIONS(3340),
    [anon_sym_discard] = ACTIONS(3340),
    [anon_sym_precise] = ACTIONS(3340),
    [anon_sym_shared] = ACTIONS(3340),
    [anon_sym_groupshared] = ACTIONS(3340),
    [anon_sym_uniform] = ACTIONS(3340),
    [anon_sym_row_major] = ACTIONS(3340),
    [anon_sym_column_major] = ACTIONS(3340),
    [anon_sym_globallycoherent] = ACTIONS(3340),
    [anon_sym_centroid] = ACTIONS(3340),
    [anon_sym_noperspective] = ACTIONS(3340),
    [anon_sym_nointerpolation] = ACTIONS(3340),
    [anon_sym_sample] = ACTIONS(3340),
    [anon_sym_linear] = ACTIONS(3340),
    [anon_sym_snorm] = ACTIONS(3340),
    [anon_sym_unorm] = ACTIONS(3340),
    [anon_sym_point] = ACTIONS(3340),
    [anon_sym_line] = ACTIONS(3340),
    [anon_sym_triangleadj] = ACTIONS(3340),
    [anon_sym_lineadj] = ACTIONS(3340),
    [anon_sym_triangle] = ACTIONS(3340),
    [anon_sym_cbuffer] = ACTIONS(3340),
    [anon_sym_interface] = ACTIONS(3340),
    [anon_sym_extension] = ACTIONS(3340),
    [anon_sym___exported] = ACTIONS(3340),
    [anon_sym_import] = ACTIONS(3340),
  },
  [586] = {
    [ts_builtin_sym_end] = ACTIONS(3236),
    [sym_identifier] = ACTIONS(3234),
    [aux_sym_preproc_include_token1] = ACTIONS(3234),
    [aux_sym_preproc_def_token1] = ACTIONS(3234),
    [aux_sym_preproc_if_token1] = ACTIONS(3234),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3234),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3234),
    [sym_preproc_directive] = ACTIONS(3234),
    [anon_sym_LPAREN2] = ACTIONS(3236),
    [anon_sym_BANG] = ACTIONS(3236),
    [anon_sym_TILDE] = ACTIONS(3236),
    [anon_sym_DASH] = ACTIONS(3234),
    [anon_sym_PLUS] = ACTIONS(3234),
    [anon_sym_STAR] = ACTIONS(3236),
    [anon_sym_AMP_AMP] = ACTIONS(3236),
    [anon_sym_AMP] = ACTIONS(3234),
    [anon_sym_SEMI] = ACTIONS(3236),
    [anon_sym___extension__] = ACTIONS(3234),
    [anon_sym_typedef] = ACTIONS(3234),
    [anon_sym_in] = ACTIONS(3234),
    [anon_sym_out] = ACTIONS(3234),
    [anon_sym_inout] = ACTIONS(3234),
    [anon_sym_extern] = ACTIONS(3234),
    [anon_sym___attribute__] = ACTIONS(3234),
    [anon_sym_COLON_COLON] = ACTIONS(3236),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3236),
    [anon_sym___declspec] = ACTIONS(3234),
    [anon_sym___based] = ACTIONS(3234),
    [anon_sym___cdecl] = ACTIONS(3234),
    [anon_sym___clrcall] = ACTIONS(3234),
    [anon_sym___stdcall] = ACTIONS(3234),
    [anon_sym___fastcall] = ACTIONS(3234),
    [anon_sym___thiscall] = ACTIONS(3234),
    [anon_sym___vectorcall] = ACTIONS(3234),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_signed] = ACTIONS(3234),
    [anon_sym_unsigned] = ACTIONS(3234),
    [anon_sym_long] = ACTIONS(3234),
    [anon_sym_short] = ACTIONS(3234),
    [anon_sym_LBRACK] = ACTIONS(3234),
    [anon_sym_static] = ACTIONS(3234),
    [anon_sym_register] = ACTIONS(3234),
    [anon_sym_inline] = ACTIONS(3234),
    [anon_sym___inline] = ACTIONS(3234),
    [anon_sym___inline__] = ACTIONS(3234),
    [anon_sym___forceinline] = ACTIONS(3234),
    [anon_sym_thread_local] = ACTIONS(3234),
    [anon_sym___thread] = ACTIONS(3234),
    [anon_sym_const] = ACTIONS(3234),
    [anon_sym_constexpr] = ACTIONS(3234),
    [anon_sym_volatile] = ACTIONS(3234),
    [anon_sym_restrict] = ACTIONS(3234),
    [anon_sym___restrict__] = ACTIONS(3234),
    [anon_sym__Atomic] = ACTIONS(3234),
    [anon_sym__Noreturn] = ACTIONS(3234),
    [anon_sym_noreturn] = ACTIONS(3234),
    [anon_sym_mutable] = ACTIONS(3234),
    [anon_sym_constinit] = ACTIONS(3234),
    [anon_sym_consteval] = ACTIONS(3234),
    [anon_sym_alignas] = ACTIONS(3234),
    [anon_sym__Alignas] = ACTIONS(3234),
    [sym_primitive_type] = ACTIONS(3234),
    [anon_sym_enum] = ACTIONS(3234),
    [anon_sym_class] = ACTIONS(3234),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3234),
    [anon_sym_if] = ACTIONS(3234),
    [anon_sym_else] = ACTIONS(3234),
    [anon_sym_switch] = ACTIONS(3234),
    [anon_sym_case] = ACTIONS(3234),
    [anon_sym_default] = ACTIONS(3234),
    [anon_sym_while] = ACTIONS(3234),
    [anon_sym_do] = ACTIONS(3234),
    [anon_sym_for] = ACTIONS(3234),
    [anon_sym_return] = ACTIONS(3234),
    [anon_sym_break] = ACTIONS(3234),
    [anon_sym_continue] = ACTIONS(3234),
    [anon_sym_goto] = ACTIONS(3234),
    [anon_sym___try] = ACTIONS(3234),
    [anon_sym___leave] = ACTIONS(3234),
    [anon_sym_not] = ACTIONS(3234),
    [anon_sym_compl] = ACTIONS(3234),
    [anon_sym_DASH_DASH] = ACTIONS(3236),
    [anon_sym_PLUS_PLUS] = ACTIONS(3236),
    [anon_sym_sizeof] = ACTIONS(3234),
    [anon_sym___alignof__] = ACTIONS(3234),
    [anon_sym___alignof] = ACTIONS(3234),
    [anon_sym__alignof] = ACTIONS(3234),
    [anon_sym_alignof] = ACTIONS(3234),
    [anon_sym__Alignof] = ACTIONS(3234),
    [anon_sym_offsetof] = ACTIONS(3234),
    [anon_sym__Generic] = ACTIONS(3234),
    [anon_sym_asm] = ACTIONS(3234),
    [anon_sym___asm__] = ACTIONS(3234),
    [sym_number_literal] = ACTIONS(3236),
    [anon_sym_L_SQUOTE] = ACTIONS(3236),
    [anon_sym_u_SQUOTE] = ACTIONS(3236),
    [anon_sym_U_SQUOTE] = ACTIONS(3236),
    [anon_sym_u8_SQUOTE] = ACTIONS(3236),
    [anon_sym_SQUOTE] = ACTIONS(3236),
    [anon_sym_L_DQUOTE] = ACTIONS(3236),
    [anon_sym_u_DQUOTE] = ACTIONS(3236),
    [anon_sym_U_DQUOTE] = ACTIONS(3236),
    [anon_sym_u8_DQUOTE] = ACTIONS(3236),
    [anon_sym_DQUOTE] = ACTIONS(3236),
    [sym_true] = ACTIONS(3234),
    [sym_false] = ACTIONS(3234),
    [anon_sym_NULL] = ACTIONS(3234),
    [anon_sym_nullptr] = ACTIONS(3234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3234),
    [anon_sym_let] = ACTIONS(3234),
    [anon_sym_This] = ACTIONS(3234),
    [anon_sym_decltype] = ACTIONS(3234),
    [sym_virtual] = ACTIONS(3234),
    [anon_sym_explicit] = ACTIONS(3234),
    [anon_sym_typename] = ACTIONS(3234),
    [anon_sym_template] = ACTIONS(3234),
    [anon_sym_operator] = ACTIONS(3234),
    [anon_sym_try] = ACTIONS(3234),
    [anon_sym_delete] = ACTIONS(3234),
    [anon_sym_throw] = ACTIONS(3234),
    [anon_sym_namespace] = ACTIONS(3234),
    [anon_sym_using] = ACTIONS(3234),
    [anon_sym_static_assert] = ACTIONS(3234),
    [anon_sym_concept] = ACTIONS(3234),
    [anon_sym_co_return] = ACTIONS(3234),
    [anon_sym_co_yield] = ACTIONS(3234),
    [anon_sym_R_DQUOTE] = ACTIONS(3236),
    [anon_sym_LR_DQUOTE] = ACTIONS(3236),
    [anon_sym_uR_DQUOTE] = ACTIONS(3236),
    [anon_sym_UR_DQUOTE] = ACTIONS(3236),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3236),
    [anon_sym_co_await] = ACTIONS(3234),
    [anon_sym_new] = ACTIONS(3234),
    [anon_sym_requires] = ACTIONS(3234),
    [sym_this] = ACTIONS(3234),
    [anon_sym_discard] = ACTIONS(3234),
    [anon_sym_precise] = ACTIONS(3234),
    [anon_sym_shared] = ACTIONS(3234),
    [anon_sym_groupshared] = ACTIONS(3234),
    [anon_sym_uniform] = ACTIONS(3234),
    [anon_sym_row_major] = ACTIONS(3234),
    [anon_sym_column_major] = ACTIONS(3234),
    [anon_sym_globallycoherent] = ACTIONS(3234),
    [anon_sym_centroid] = ACTIONS(3234),
    [anon_sym_noperspective] = ACTIONS(3234),
    [anon_sym_nointerpolation] = ACTIONS(3234),
    [anon_sym_sample] = ACTIONS(3234),
    [anon_sym_linear] = ACTIONS(3234),
    [anon_sym_snorm] = ACTIONS(3234),
    [anon_sym_unorm] = ACTIONS(3234),
    [anon_sym_point] = ACTIONS(3234),
    [anon_sym_line] = ACTIONS(3234),
    [anon_sym_triangleadj] = ACTIONS(3234),
    [anon_sym_lineadj] = ACTIONS(3234),
    [anon_sym_triangle] = ACTIONS(3234),
    [anon_sym_cbuffer] = ACTIONS(3234),
    [anon_sym_interface] = ACTIONS(3234),
    [anon_sym_extension] = ACTIONS(3234),
    [anon_sym___exported] = ACTIONS(3234),
    [anon_sym_import] = ACTIONS(3234),
  },
  [587] = {
    [ts_builtin_sym_end] = ACTIONS(3370),
    [sym_identifier] = ACTIONS(3368),
    [aux_sym_preproc_include_token1] = ACTIONS(3368),
    [aux_sym_preproc_def_token1] = ACTIONS(3368),
    [aux_sym_preproc_if_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3368),
    [sym_preproc_directive] = ACTIONS(3368),
    [anon_sym_LPAREN2] = ACTIONS(3370),
    [anon_sym_BANG] = ACTIONS(3370),
    [anon_sym_TILDE] = ACTIONS(3370),
    [anon_sym_DASH] = ACTIONS(3368),
    [anon_sym_PLUS] = ACTIONS(3368),
    [anon_sym_STAR] = ACTIONS(3370),
    [anon_sym_AMP_AMP] = ACTIONS(3370),
    [anon_sym_AMP] = ACTIONS(3368),
    [anon_sym_SEMI] = ACTIONS(3370),
    [anon_sym___extension__] = ACTIONS(3368),
    [anon_sym_typedef] = ACTIONS(3368),
    [anon_sym_in] = ACTIONS(3368),
    [anon_sym_out] = ACTIONS(3368),
    [anon_sym_inout] = ACTIONS(3368),
    [anon_sym_extern] = ACTIONS(3368),
    [anon_sym___attribute__] = ACTIONS(3368),
    [anon_sym_COLON_COLON] = ACTIONS(3370),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3370),
    [anon_sym___declspec] = ACTIONS(3368),
    [anon_sym___based] = ACTIONS(3368),
    [anon_sym___cdecl] = ACTIONS(3368),
    [anon_sym___clrcall] = ACTIONS(3368),
    [anon_sym___stdcall] = ACTIONS(3368),
    [anon_sym___fastcall] = ACTIONS(3368),
    [anon_sym___thiscall] = ACTIONS(3368),
    [anon_sym___vectorcall] = ACTIONS(3368),
    [anon_sym_LBRACE] = ACTIONS(3370),
    [anon_sym_signed] = ACTIONS(3368),
    [anon_sym_unsigned] = ACTIONS(3368),
    [anon_sym_long] = ACTIONS(3368),
    [anon_sym_short] = ACTIONS(3368),
    [anon_sym_LBRACK] = ACTIONS(3368),
    [anon_sym_static] = ACTIONS(3368),
    [anon_sym_register] = ACTIONS(3368),
    [anon_sym_inline] = ACTIONS(3368),
    [anon_sym___inline] = ACTIONS(3368),
    [anon_sym___inline__] = ACTIONS(3368),
    [anon_sym___forceinline] = ACTIONS(3368),
    [anon_sym_thread_local] = ACTIONS(3368),
    [anon_sym___thread] = ACTIONS(3368),
    [anon_sym_const] = ACTIONS(3368),
    [anon_sym_constexpr] = ACTIONS(3368),
    [anon_sym_volatile] = ACTIONS(3368),
    [anon_sym_restrict] = ACTIONS(3368),
    [anon_sym___restrict__] = ACTIONS(3368),
    [anon_sym__Atomic] = ACTIONS(3368),
    [anon_sym__Noreturn] = ACTIONS(3368),
    [anon_sym_noreturn] = ACTIONS(3368),
    [anon_sym_mutable] = ACTIONS(3368),
    [anon_sym_constinit] = ACTIONS(3368),
    [anon_sym_consteval] = ACTIONS(3368),
    [anon_sym_alignas] = ACTIONS(3368),
    [anon_sym__Alignas] = ACTIONS(3368),
    [sym_primitive_type] = ACTIONS(3368),
    [anon_sym_enum] = ACTIONS(3368),
    [anon_sym_class] = ACTIONS(3368),
    [anon_sym_struct] = ACTIONS(3368),
    [anon_sym_union] = ACTIONS(3368),
    [anon_sym_if] = ACTIONS(3368),
    [anon_sym_else] = ACTIONS(3368),
    [anon_sym_switch] = ACTIONS(3368),
    [anon_sym_case] = ACTIONS(3368),
    [anon_sym_default] = ACTIONS(3368),
    [anon_sym_while] = ACTIONS(3368),
    [anon_sym_do] = ACTIONS(3368),
    [anon_sym_for] = ACTIONS(3368),
    [anon_sym_return] = ACTIONS(3368),
    [anon_sym_break] = ACTIONS(3368),
    [anon_sym_continue] = ACTIONS(3368),
    [anon_sym_goto] = ACTIONS(3368),
    [anon_sym___try] = ACTIONS(3368),
    [anon_sym___leave] = ACTIONS(3368),
    [anon_sym_not] = ACTIONS(3368),
    [anon_sym_compl] = ACTIONS(3368),
    [anon_sym_DASH_DASH] = ACTIONS(3370),
    [anon_sym_PLUS_PLUS] = ACTIONS(3370),
    [anon_sym_sizeof] = ACTIONS(3368),
    [anon_sym___alignof__] = ACTIONS(3368),
    [anon_sym___alignof] = ACTIONS(3368),
    [anon_sym__alignof] = ACTIONS(3368),
    [anon_sym_alignof] = ACTIONS(3368),
    [anon_sym__Alignof] = ACTIONS(3368),
    [anon_sym_offsetof] = ACTIONS(3368),
    [anon_sym__Generic] = ACTIONS(3368),
    [anon_sym_asm] = ACTIONS(3368),
    [anon_sym___asm__] = ACTIONS(3368),
    [sym_number_literal] = ACTIONS(3370),
    [anon_sym_L_SQUOTE] = ACTIONS(3370),
    [anon_sym_u_SQUOTE] = ACTIONS(3370),
    [anon_sym_U_SQUOTE] = ACTIONS(3370),
    [anon_sym_u8_SQUOTE] = ACTIONS(3370),
    [anon_sym_SQUOTE] = ACTIONS(3370),
    [anon_sym_L_DQUOTE] = ACTIONS(3370),
    [anon_sym_u_DQUOTE] = ACTIONS(3370),
    [anon_sym_U_DQUOTE] = ACTIONS(3370),
    [anon_sym_u8_DQUOTE] = ACTIONS(3370),
    [anon_sym_DQUOTE] = ACTIONS(3370),
    [sym_true] = ACTIONS(3368),
    [sym_false] = ACTIONS(3368),
    [anon_sym_NULL] = ACTIONS(3368),
    [anon_sym_nullptr] = ACTIONS(3368),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3368),
    [anon_sym_let] = ACTIONS(3368),
    [anon_sym_This] = ACTIONS(3368),
    [anon_sym_decltype] = ACTIONS(3368),
    [sym_virtual] = ACTIONS(3368),
    [anon_sym_explicit] = ACTIONS(3368),
    [anon_sym_typename] = ACTIONS(3368),
    [anon_sym_template] = ACTIONS(3368),
    [anon_sym_operator] = ACTIONS(3368),
    [anon_sym_try] = ACTIONS(3368),
    [anon_sym_delete] = ACTIONS(3368),
    [anon_sym_throw] = ACTIONS(3368),
    [anon_sym_namespace] = ACTIONS(3368),
    [anon_sym_using] = ACTIONS(3368),
    [anon_sym_static_assert] = ACTIONS(3368),
    [anon_sym_concept] = ACTIONS(3368),
    [anon_sym_co_return] = ACTIONS(3368),
    [anon_sym_co_yield] = ACTIONS(3368),
    [anon_sym_R_DQUOTE] = ACTIONS(3370),
    [anon_sym_LR_DQUOTE] = ACTIONS(3370),
    [anon_sym_uR_DQUOTE] = ACTIONS(3370),
    [anon_sym_UR_DQUOTE] = ACTIONS(3370),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3370),
    [anon_sym_co_await] = ACTIONS(3368),
    [anon_sym_new] = ACTIONS(3368),
    [anon_sym_requires] = ACTIONS(3368),
    [sym_this] = ACTIONS(3368),
    [anon_sym_discard] = ACTIONS(3368),
    [anon_sym_precise] = ACTIONS(3368),
    [anon_sym_shared] = ACTIONS(3368),
    [anon_sym_groupshared] = ACTIONS(3368),
    [anon_sym_uniform] = ACTIONS(3368),
    [anon_sym_row_major] = ACTIONS(3368),
    [anon_sym_column_major] = ACTIONS(3368),
    [anon_sym_globallycoherent] = ACTIONS(3368),
    [anon_sym_centroid] = ACTIONS(3368),
    [anon_sym_noperspective] = ACTIONS(3368),
    [anon_sym_nointerpolation] = ACTIONS(3368),
    [anon_sym_sample] = ACTIONS(3368),
    [anon_sym_linear] = ACTIONS(3368),
    [anon_sym_snorm] = ACTIONS(3368),
    [anon_sym_unorm] = ACTIONS(3368),
    [anon_sym_point] = ACTIONS(3368),
    [anon_sym_line] = ACTIONS(3368),
    [anon_sym_triangleadj] = ACTIONS(3368),
    [anon_sym_lineadj] = ACTIONS(3368),
    [anon_sym_triangle] = ACTIONS(3368),
    [anon_sym_cbuffer] = ACTIONS(3368),
    [anon_sym_interface] = ACTIONS(3368),
    [anon_sym_extension] = ACTIONS(3368),
    [anon_sym___exported] = ACTIONS(3368),
    [anon_sym_import] = ACTIONS(3368),
  },
  [588] = {
    [ts_builtin_sym_end] = ACTIONS(3376),
    [sym_identifier] = ACTIONS(3374),
    [aux_sym_preproc_include_token1] = ACTIONS(3374),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3374),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3374),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3374),
    [sym_preproc_directive] = ACTIONS(3374),
    [anon_sym_LPAREN2] = ACTIONS(3376),
    [anon_sym_BANG] = ACTIONS(3376),
    [anon_sym_TILDE] = ACTIONS(3376),
    [anon_sym_DASH] = ACTIONS(3374),
    [anon_sym_PLUS] = ACTIONS(3374),
    [anon_sym_STAR] = ACTIONS(3376),
    [anon_sym_AMP_AMP] = ACTIONS(3376),
    [anon_sym_AMP] = ACTIONS(3374),
    [anon_sym_SEMI] = ACTIONS(3376),
    [anon_sym___extension__] = ACTIONS(3374),
    [anon_sym_typedef] = ACTIONS(3374),
    [anon_sym_in] = ACTIONS(3374),
    [anon_sym_out] = ACTIONS(3374),
    [anon_sym_inout] = ACTIONS(3374),
    [anon_sym_extern] = ACTIONS(3374),
    [anon_sym___attribute__] = ACTIONS(3374),
    [anon_sym_COLON_COLON] = ACTIONS(3376),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3376),
    [anon_sym___declspec] = ACTIONS(3374),
    [anon_sym___based] = ACTIONS(3374),
    [anon_sym___cdecl] = ACTIONS(3374),
    [anon_sym___clrcall] = ACTIONS(3374),
    [anon_sym___stdcall] = ACTIONS(3374),
    [anon_sym___fastcall] = ACTIONS(3374),
    [anon_sym___thiscall] = ACTIONS(3374),
    [anon_sym___vectorcall] = ACTIONS(3374),
    [anon_sym_LBRACE] = ACTIONS(3376),
    [anon_sym_signed] = ACTIONS(3374),
    [anon_sym_unsigned] = ACTIONS(3374),
    [anon_sym_long] = ACTIONS(3374),
    [anon_sym_short] = ACTIONS(3374),
    [anon_sym_LBRACK] = ACTIONS(3374),
    [anon_sym_static] = ACTIONS(3374),
    [anon_sym_register] = ACTIONS(3374),
    [anon_sym_inline] = ACTIONS(3374),
    [anon_sym___inline] = ACTIONS(3374),
    [anon_sym___inline__] = ACTIONS(3374),
    [anon_sym___forceinline] = ACTIONS(3374),
    [anon_sym_thread_local] = ACTIONS(3374),
    [anon_sym___thread] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3374),
    [anon_sym_constexpr] = ACTIONS(3374),
    [anon_sym_volatile] = ACTIONS(3374),
    [anon_sym_restrict] = ACTIONS(3374),
    [anon_sym___restrict__] = ACTIONS(3374),
    [anon_sym__Atomic] = ACTIONS(3374),
    [anon_sym__Noreturn] = ACTIONS(3374),
    [anon_sym_noreturn] = ACTIONS(3374),
    [anon_sym_mutable] = ACTIONS(3374),
    [anon_sym_constinit] = ACTIONS(3374),
    [anon_sym_consteval] = ACTIONS(3374),
    [anon_sym_alignas] = ACTIONS(3374),
    [anon_sym__Alignas] = ACTIONS(3374),
    [sym_primitive_type] = ACTIONS(3374),
    [anon_sym_enum] = ACTIONS(3374),
    [anon_sym_class] = ACTIONS(3374),
    [anon_sym_struct] = ACTIONS(3374),
    [anon_sym_union] = ACTIONS(3374),
    [anon_sym_if] = ACTIONS(3374),
    [anon_sym_else] = ACTIONS(3374),
    [anon_sym_switch] = ACTIONS(3374),
    [anon_sym_case] = ACTIONS(3374),
    [anon_sym_default] = ACTIONS(3374),
    [anon_sym_while] = ACTIONS(3374),
    [anon_sym_do] = ACTIONS(3374),
    [anon_sym_for] = ACTIONS(3374),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_break] = ACTIONS(3374),
    [anon_sym_continue] = ACTIONS(3374),
    [anon_sym_goto] = ACTIONS(3374),
    [anon_sym___try] = ACTIONS(3374),
    [anon_sym___leave] = ACTIONS(3374),
    [anon_sym_not] = ACTIONS(3374),
    [anon_sym_compl] = ACTIONS(3374),
    [anon_sym_DASH_DASH] = ACTIONS(3376),
    [anon_sym_PLUS_PLUS] = ACTIONS(3376),
    [anon_sym_sizeof] = ACTIONS(3374),
    [anon_sym___alignof__] = ACTIONS(3374),
    [anon_sym___alignof] = ACTIONS(3374),
    [anon_sym__alignof] = ACTIONS(3374),
    [anon_sym_alignof] = ACTIONS(3374),
    [anon_sym__Alignof] = ACTIONS(3374),
    [anon_sym_offsetof] = ACTIONS(3374),
    [anon_sym__Generic] = ACTIONS(3374),
    [anon_sym_asm] = ACTIONS(3374),
    [anon_sym___asm__] = ACTIONS(3374),
    [sym_number_literal] = ACTIONS(3376),
    [anon_sym_L_SQUOTE] = ACTIONS(3376),
    [anon_sym_u_SQUOTE] = ACTIONS(3376),
    [anon_sym_U_SQUOTE] = ACTIONS(3376),
    [anon_sym_u8_SQUOTE] = ACTIONS(3376),
    [anon_sym_SQUOTE] = ACTIONS(3376),
    [anon_sym_L_DQUOTE] = ACTIONS(3376),
    [anon_sym_u_DQUOTE] = ACTIONS(3376),
    [anon_sym_U_DQUOTE] = ACTIONS(3376),
    [anon_sym_u8_DQUOTE] = ACTIONS(3376),
    [anon_sym_DQUOTE] = ACTIONS(3376),
    [sym_true] = ACTIONS(3374),
    [sym_false] = ACTIONS(3374),
    [anon_sym_NULL] = ACTIONS(3374),
    [anon_sym_nullptr] = ACTIONS(3374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3374),
    [anon_sym_let] = ACTIONS(3374),
    [anon_sym_This] = ACTIONS(3374),
    [anon_sym_decltype] = ACTIONS(3374),
    [sym_virtual] = ACTIONS(3374),
    [anon_sym_explicit] = ACTIONS(3374),
    [anon_sym_typename] = ACTIONS(3374),
    [anon_sym_template] = ACTIONS(3374),
    [anon_sym_operator] = ACTIONS(3374),
    [anon_sym_try] = ACTIONS(3374),
    [anon_sym_delete] = ACTIONS(3374),
    [anon_sym_throw] = ACTIONS(3374),
    [anon_sym_namespace] = ACTIONS(3374),
    [anon_sym_using] = ACTIONS(3374),
    [anon_sym_static_assert] = ACTIONS(3374),
    [anon_sym_concept] = ACTIONS(3374),
    [anon_sym_co_return] = ACTIONS(3374),
    [anon_sym_co_yield] = ACTIONS(3374),
    [anon_sym_R_DQUOTE] = ACTIONS(3376),
    [anon_sym_LR_DQUOTE] = ACTIONS(3376),
    [anon_sym_uR_DQUOTE] = ACTIONS(3376),
    [anon_sym_UR_DQUOTE] = ACTIONS(3376),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3376),
    [anon_sym_co_await] = ACTIONS(3374),
    [anon_sym_new] = ACTIONS(3374),
    [anon_sym_requires] = ACTIONS(3374),
    [sym_this] = ACTIONS(3374),
    [anon_sym_discard] = ACTIONS(3374),
    [anon_sym_precise] = ACTIONS(3374),
    [anon_sym_shared] = ACTIONS(3374),
    [anon_sym_groupshared] = ACTIONS(3374),
    [anon_sym_uniform] = ACTIONS(3374),
    [anon_sym_row_major] = ACTIONS(3374),
    [anon_sym_column_major] = ACTIONS(3374),
    [anon_sym_globallycoherent] = ACTIONS(3374),
    [anon_sym_centroid] = ACTIONS(3374),
    [anon_sym_noperspective] = ACTIONS(3374),
    [anon_sym_nointerpolation] = ACTIONS(3374),
    [anon_sym_sample] = ACTIONS(3374),
    [anon_sym_linear] = ACTIONS(3374),
    [anon_sym_snorm] = ACTIONS(3374),
    [anon_sym_unorm] = ACTIONS(3374),
    [anon_sym_point] = ACTIONS(3374),
    [anon_sym_line] = ACTIONS(3374),
    [anon_sym_triangleadj] = ACTIONS(3374),
    [anon_sym_lineadj] = ACTIONS(3374),
    [anon_sym_triangle] = ACTIONS(3374),
    [anon_sym_cbuffer] = ACTIONS(3374),
    [anon_sym_interface] = ACTIONS(3374),
    [anon_sym_extension] = ACTIONS(3374),
    [anon_sym___exported] = ACTIONS(3374),
    [anon_sym_import] = ACTIONS(3374),
  },
  [589] = {
    [ts_builtin_sym_end] = ACTIONS(3212),
    [sym_identifier] = ACTIONS(3210),
    [aux_sym_preproc_include_token1] = ACTIONS(3210),
    [aux_sym_preproc_def_token1] = ACTIONS(3210),
    [aux_sym_preproc_if_token1] = ACTIONS(3210),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3210),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3210),
    [sym_preproc_directive] = ACTIONS(3210),
    [anon_sym_LPAREN2] = ACTIONS(3212),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3210),
    [anon_sym_PLUS] = ACTIONS(3210),
    [anon_sym_STAR] = ACTIONS(3212),
    [anon_sym_AMP_AMP] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3210),
    [anon_sym_SEMI] = ACTIONS(3212),
    [anon_sym___extension__] = ACTIONS(3210),
    [anon_sym_typedef] = ACTIONS(3210),
    [anon_sym_in] = ACTIONS(3210),
    [anon_sym_out] = ACTIONS(3210),
    [anon_sym_inout] = ACTIONS(3210),
    [anon_sym_extern] = ACTIONS(3210),
    [anon_sym___attribute__] = ACTIONS(3210),
    [anon_sym_COLON_COLON] = ACTIONS(3212),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3212),
    [anon_sym___declspec] = ACTIONS(3210),
    [anon_sym___based] = ACTIONS(3210),
    [anon_sym___cdecl] = ACTIONS(3210),
    [anon_sym___clrcall] = ACTIONS(3210),
    [anon_sym___stdcall] = ACTIONS(3210),
    [anon_sym___fastcall] = ACTIONS(3210),
    [anon_sym___thiscall] = ACTIONS(3210),
    [anon_sym___vectorcall] = ACTIONS(3210),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_signed] = ACTIONS(3210),
    [anon_sym_unsigned] = ACTIONS(3210),
    [anon_sym_long] = ACTIONS(3210),
    [anon_sym_short] = ACTIONS(3210),
    [anon_sym_LBRACK] = ACTIONS(3210),
    [anon_sym_static] = ACTIONS(3210),
    [anon_sym_register] = ACTIONS(3210),
    [anon_sym_inline] = ACTIONS(3210),
    [anon_sym___inline] = ACTIONS(3210),
    [anon_sym___inline__] = ACTIONS(3210),
    [anon_sym___forceinline] = ACTIONS(3210),
    [anon_sym_thread_local] = ACTIONS(3210),
    [anon_sym___thread] = ACTIONS(3210),
    [anon_sym_const] = ACTIONS(3210),
    [anon_sym_constexpr] = ACTIONS(3210),
    [anon_sym_volatile] = ACTIONS(3210),
    [anon_sym_restrict] = ACTIONS(3210),
    [anon_sym___restrict__] = ACTIONS(3210),
    [anon_sym__Atomic] = ACTIONS(3210),
    [anon_sym__Noreturn] = ACTIONS(3210),
    [anon_sym_noreturn] = ACTIONS(3210),
    [anon_sym_mutable] = ACTIONS(3210),
    [anon_sym_constinit] = ACTIONS(3210),
    [anon_sym_consteval] = ACTIONS(3210),
    [anon_sym_alignas] = ACTIONS(3210),
    [anon_sym__Alignas] = ACTIONS(3210),
    [sym_primitive_type] = ACTIONS(3210),
    [anon_sym_enum] = ACTIONS(3210),
    [anon_sym_class] = ACTIONS(3210),
    [anon_sym_struct] = ACTIONS(3210),
    [anon_sym_union] = ACTIONS(3210),
    [anon_sym_if] = ACTIONS(3210),
    [anon_sym_else] = ACTIONS(3210),
    [anon_sym_switch] = ACTIONS(3210),
    [anon_sym_case] = ACTIONS(3210),
    [anon_sym_default] = ACTIONS(3210),
    [anon_sym_while] = ACTIONS(3210),
    [anon_sym_do] = ACTIONS(3210),
    [anon_sym_for] = ACTIONS(3210),
    [anon_sym_return] = ACTIONS(3210),
    [anon_sym_break] = ACTIONS(3210),
    [anon_sym_continue] = ACTIONS(3210),
    [anon_sym_goto] = ACTIONS(3210),
    [anon_sym___try] = ACTIONS(3210),
    [anon_sym___leave] = ACTIONS(3210),
    [anon_sym_not] = ACTIONS(3210),
    [anon_sym_compl] = ACTIONS(3210),
    [anon_sym_DASH_DASH] = ACTIONS(3212),
    [anon_sym_PLUS_PLUS] = ACTIONS(3212),
    [anon_sym_sizeof] = ACTIONS(3210),
    [anon_sym___alignof__] = ACTIONS(3210),
    [anon_sym___alignof] = ACTIONS(3210),
    [anon_sym__alignof] = ACTIONS(3210),
    [anon_sym_alignof] = ACTIONS(3210),
    [anon_sym__Alignof] = ACTIONS(3210),
    [anon_sym_offsetof] = ACTIONS(3210),
    [anon_sym__Generic] = ACTIONS(3210),
    [anon_sym_asm] = ACTIONS(3210),
    [anon_sym___asm__] = ACTIONS(3210),
    [sym_number_literal] = ACTIONS(3212),
    [anon_sym_L_SQUOTE] = ACTIONS(3212),
    [anon_sym_u_SQUOTE] = ACTIONS(3212),
    [anon_sym_U_SQUOTE] = ACTIONS(3212),
    [anon_sym_u8_SQUOTE] = ACTIONS(3212),
    [anon_sym_SQUOTE] = ACTIONS(3212),
    [anon_sym_L_DQUOTE] = ACTIONS(3212),
    [anon_sym_u_DQUOTE] = ACTIONS(3212),
    [anon_sym_U_DQUOTE] = ACTIONS(3212),
    [anon_sym_u8_DQUOTE] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [sym_true] = ACTIONS(3210),
    [sym_false] = ACTIONS(3210),
    [anon_sym_NULL] = ACTIONS(3210),
    [anon_sym_nullptr] = ACTIONS(3210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3210),
    [anon_sym_let] = ACTIONS(3210),
    [anon_sym_This] = ACTIONS(3210),
    [anon_sym_decltype] = ACTIONS(3210),
    [sym_virtual] = ACTIONS(3210),
    [anon_sym_explicit] = ACTIONS(3210),
    [anon_sym_typename] = ACTIONS(3210),
    [anon_sym_template] = ACTIONS(3210),
    [anon_sym_operator] = ACTIONS(3210),
    [anon_sym_try] = ACTIONS(3210),
    [anon_sym_delete] = ACTIONS(3210),
    [anon_sym_throw] = ACTIONS(3210),
    [anon_sym_namespace] = ACTIONS(3210),
    [anon_sym_using] = ACTIONS(3210),
    [anon_sym_static_assert] = ACTIONS(3210),
    [anon_sym_concept] = ACTIONS(3210),
    [anon_sym_co_return] = ACTIONS(3210),
    [anon_sym_co_yield] = ACTIONS(3210),
    [anon_sym_R_DQUOTE] = ACTIONS(3212),
    [anon_sym_LR_DQUOTE] = ACTIONS(3212),
    [anon_sym_uR_DQUOTE] = ACTIONS(3212),
    [anon_sym_UR_DQUOTE] = ACTIONS(3212),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3212),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3210),
    [anon_sym_requires] = ACTIONS(3210),
    [sym_this] = ACTIONS(3210),
    [anon_sym_discard] = ACTIONS(3210),
    [anon_sym_precise] = ACTIONS(3210),
    [anon_sym_shared] = ACTIONS(3210),
    [anon_sym_groupshared] = ACTIONS(3210),
    [anon_sym_uniform] = ACTIONS(3210),
    [anon_sym_row_major] = ACTIONS(3210),
    [anon_sym_column_major] = ACTIONS(3210),
    [anon_sym_globallycoherent] = ACTIONS(3210),
    [anon_sym_centroid] = ACTIONS(3210),
    [anon_sym_noperspective] = ACTIONS(3210),
    [anon_sym_nointerpolation] = ACTIONS(3210),
    [anon_sym_sample] = ACTIONS(3210),
    [anon_sym_linear] = ACTIONS(3210),
    [anon_sym_snorm] = ACTIONS(3210),
    [anon_sym_unorm] = ACTIONS(3210),
    [anon_sym_point] = ACTIONS(3210),
    [anon_sym_line] = ACTIONS(3210),
    [anon_sym_triangleadj] = ACTIONS(3210),
    [anon_sym_lineadj] = ACTIONS(3210),
    [anon_sym_triangle] = ACTIONS(3210),
    [anon_sym_cbuffer] = ACTIONS(3210),
    [anon_sym_interface] = ACTIONS(3210),
    [anon_sym_extension] = ACTIONS(3210),
    [anon_sym___exported] = ACTIONS(3210),
    [anon_sym_import] = ACTIONS(3210),
  },
  [590] = {
    [ts_builtin_sym_end] = ACTIONS(3032),
    [sym_identifier] = ACTIONS(3030),
    [aux_sym_preproc_include_token1] = ACTIONS(3030),
    [aux_sym_preproc_def_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3030),
    [sym_preproc_directive] = ACTIONS(3030),
    [anon_sym_LPAREN2] = ACTIONS(3032),
    [anon_sym_BANG] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3030),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym___extension__] = ACTIONS(3030),
    [anon_sym_typedef] = ACTIONS(3030),
    [anon_sym_in] = ACTIONS(3030),
    [anon_sym_out] = ACTIONS(3030),
    [anon_sym_inout] = ACTIONS(3030),
    [anon_sym_extern] = ACTIONS(3030),
    [anon_sym___attribute__] = ACTIONS(3030),
    [anon_sym_COLON_COLON] = ACTIONS(3032),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3032),
    [anon_sym___declspec] = ACTIONS(3030),
    [anon_sym___based] = ACTIONS(3030),
    [anon_sym___cdecl] = ACTIONS(3030),
    [anon_sym___clrcall] = ACTIONS(3030),
    [anon_sym___stdcall] = ACTIONS(3030),
    [anon_sym___fastcall] = ACTIONS(3030),
    [anon_sym___thiscall] = ACTIONS(3030),
    [anon_sym___vectorcall] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_signed] = ACTIONS(3030),
    [anon_sym_unsigned] = ACTIONS(3030),
    [anon_sym_long] = ACTIONS(3030),
    [anon_sym_short] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_static] = ACTIONS(3030),
    [anon_sym_register] = ACTIONS(3030),
    [anon_sym_inline] = ACTIONS(3030),
    [anon_sym___inline] = ACTIONS(3030),
    [anon_sym___inline__] = ACTIONS(3030),
    [anon_sym___forceinline] = ACTIONS(3030),
    [anon_sym_thread_local] = ACTIONS(3030),
    [anon_sym___thread] = ACTIONS(3030),
    [anon_sym_const] = ACTIONS(3030),
    [anon_sym_constexpr] = ACTIONS(3030),
    [anon_sym_volatile] = ACTIONS(3030),
    [anon_sym_restrict] = ACTIONS(3030),
    [anon_sym___restrict__] = ACTIONS(3030),
    [anon_sym__Atomic] = ACTIONS(3030),
    [anon_sym__Noreturn] = ACTIONS(3030),
    [anon_sym_noreturn] = ACTIONS(3030),
    [anon_sym_mutable] = ACTIONS(3030),
    [anon_sym_constinit] = ACTIONS(3030),
    [anon_sym_consteval] = ACTIONS(3030),
    [anon_sym_alignas] = ACTIONS(3030),
    [anon_sym__Alignas] = ACTIONS(3030),
    [sym_primitive_type] = ACTIONS(3030),
    [anon_sym_enum] = ACTIONS(3030),
    [anon_sym_class] = ACTIONS(3030),
    [anon_sym_struct] = ACTIONS(3030),
    [anon_sym_union] = ACTIONS(3030),
    [anon_sym_if] = ACTIONS(3030),
    [anon_sym_else] = ACTIONS(3030),
    [anon_sym_switch] = ACTIONS(3030),
    [anon_sym_case] = ACTIONS(3030),
    [anon_sym_default] = ACTIONS(3030),
    [anon_sym_while] = ACTIONS(3030),
    [anon_sym_do] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3030),
    [anon_sym_return] = ACTIONS(3030),
    [anon_sym_break] = ACTIONS(3030),
    [anon_sym_continue] = ACTIONS(3030),
    [anon_sym_goto] = ACTIONS(3030),
    [anon_sym___try] = ACTIONS(3030),
    [anon_sym___leave] = ACTIONS(3030),
    [anon_sym_not] = ACTIONS(3030),
    [anon_sym_compl] = ACTIONS(3030),
    [anon_sym_DASH_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_PLUS] = ACTIONS(3032),
    [anon_sym_sizeof] = ACTIONS(3030),
    [anon_sym___alignof__] = ACTIONS(3030),
    [anon_sym___alignof] = ACTIONS(3030),
    [anon_sym__alignof] = ACTIONS(3030),
    [anon_sym_alignof] = ACTIONS(3030),
    [anon_sym__Alignof] = ACTIONS(3030),
    [anon_sym_offsetof] = ACTIONS(3030),
    [anon_sym__Generic] = ACTIONS(3030),
    [anon_sym_asm] = ACTIONS(3030),
    [anon_sym___asm__] = ACTIONS(3030),
    [sym_number_literal] = ACTIONS(3032),
    [anon_sym_L_SQUOTE] = ACTIONS(3032),
    [anon_sym_u_SQUOTE] = ACTIONS(3032),
    [anon_sym_U_SQUOTE] = ACTIONS(3032),
    [anon_sym_u8_SQUOTE] = ACTIONS(3032),
    [anon_sym_SQUOTE] = ACTIONS(3032),
    [anon_sym_L_DQUOTE] = ACTIONS(3032),
    [anon_sym_u_DQUOTE] = ACTIONS(3032),
    [anon_sym_U_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [sym_true] = ACTIONS(3030),
    [sym_false] = ACTIONS(3030),
    [anon_sym_NULL] = ACTIONS(3030),
    [anon_sym_nullptr] = ACTIONS(3030),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3030),
    [anon_sym_let] = ACTIONS(3030),
    [anon_sym_This] = ACTIONS(3030),
    [anon_sym_decltype] = ACTIONS(3030),
    [sym_virtual] = ACTIONS(3030),
    [anon_sym_explicit] = ACTIONS(3030),
    [anon_sym_typename] = ACTIONS(3030),
    [anon_sym_template] = ACTIONS(3030),
    [anon_sym_operator] = ACTIONS(3030),
    [anon_sym_try] = ACTIONS(3030),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_throw] = ACTIONS(3030),
    [anon_sym_namespace] = ACTIONS(3030),
    [anon_sym_using] = ACTIONS(3030),
    [anon_sym_static_assert] = ACTIONS(3030),
    [anon_sym_concept] = ACTIONS(3030),
    [anon_sym_co_return] = ACTIONS(3030),
    [anon_sym_co_yield] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3030),
    [anon_sym_requires] = ACTIONS(3030),
    [sym_this] = ACTIONS(3030),
    [anon_sym_discard] = ACTIONS(3030),
    [anon_sym_precise] = ACTIONS(3030),
    [anon_sym_shared] = ACTIONS(3030),
    [anon_sym_groupshared] = ACTIONS(3030),
    [anon_sym_uniform] = ACTIONS(3030),
    [anon_sym_row_major] = ACTIONS(3030),
    [anon_sym_column_major] = ACTIONS(3030),
    [anon_sym_globallycoherent] = ACTIONS(3030),
    [anon_sym_centroid] = ACTIONS(3030),
    [anon_sym_noperspective] = ACTIONS(3030),
    [anon_sym_nointerpolation] = ACTIONS(3030),
    [anon_sym_sample] = ACTIONS(3030),
    [anon_sym_linear] = ACTIONS(3030),
    [anon_sym_snorm] = ACTIONS(3030),
    [anon_sym_unorm] = ACTIONS(3030),
    [anon_sym_point] = ACTIONS(3030),
    [anon_sym_line] = ACTIONS(3030),
    [anon_sym_triangleadj] = ACTIONS(3030),
    [anon_sym_lineadj] = ACTIONS(3030),
    [anon_sym_triangle] = ACTIONS(3030),
    [anon_sym_cbuffer] = ACTIONS(3030),
    [anon_sym_interface] = ACTIONS(3030),
    [anon_sym_extension] = ACTIONS(3030),
    [anon_sym___exported] = ACTIONS(3030),
    [anon_sym_import] = ACTIONS(3030),
  },
  [591] = {
    [ts_builtin_sym_end] = ACTIONS(3184),
    [sym_identifier] = ACTIONS(3182),
    [aux_sym_preproc_include_token1] = ACTIONS(3182),
    [aux_sym_preproc_def_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [sym_preproc_directive] = ACTIONS(3182),
    [anon_sym_LPAREN2] = ACTIONS(3184),
    [anon_sym_BANG] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_DASH] = ACTIONS(3182),
    [anon_sym_PLUS] = ACTIONS(3182),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_AMP_AMP] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3182),
    [anon_sym_SEMI] = ACTIONS(3184),
    [anon_sym___extension__] = ACTIONS(3182),
    [anon_sym_typedef] = ACTIONS(3182),
    [anon_sym_in] = ACTIONS(3182),
    [anon_sym_out] = ACTIONS(3182),
    [anon_sym_inout] = ACTIONS(3182),
    [anon_sym_extern] = ACTIONS(3182),
    [anon_sym___attribute__] = ACTIONS(3182),
    [anon_sym_COLON_COLON] = ACTIONS(3184),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3184),
    [anon_sym___declspec] = ACTIONS(3182),
    [anon_sym___based] = ACTIONS(3182),
    [anon_sym___cdecl] = ACTIONS(3182),
    [anon_sym___clrcall] = ACTIONS(3182),
    [anon_sym___stdcall] = ACTIONS(3182),
    [anon_sym___fastcall] = ACTIONS(3182),
    [anon_sym___thiscall] = ACTIONS(3182),
    [anon_sym___vectorcall] = ACTIONS(3182),
    [anon_sym_LBRACE] = ACTIONS(3184),
    [anon_sym_signed] = ACTIONS(3182),
    [anon_sym_unsigned] = ACTIONS(3182),
    [anon_sym_long] = ACTIONS(3182),
    [anon_sym_short] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3182),
    [anon_sym_register] = ACTIONS(3182),
    [anon_sym_inline] = ACTIONS(3182),
    [anon_sym___inline] = ACTIONS(3182),
    [anon_sym___inline__] = ACTIONS(3182),
    [anon_sym___forceinline] = ACTIONS(3182),
    [anon_sym_thread_local] = ACTIONS(3182),
    [anon_sym___thread] = ACTIONS(3182),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_constexpr] = ACTIONS(3182),
    [anon_sym_volatile] = ACTIONS(3182),
    [anon_sym_restrict] = ACTIONS(3182),
    [anon_sym___restrict__] = ACTIONS(3182),
    [anon_sym__Atomic] = ACTIONS(3182),
    [anon_sym__Noreturn] = ACTIONS(3182),
    [anon_sym_noreturn] = ACTIONS(3182),
    [anon_sym_mutable] = ACTIONS(3182),
    [anon_sym_constinit] = ACTIONS(3182),
    [anon_sym_consteval] = ACTIONS(3182),
    [anon_sym_alignas] = ACTIONS(3182),
    [anon_sym__Alignas] = ACTIONS(3182),
    [sym_primitive_type] = ACTIONS(3182),
    [anon_sym_enum] = ACTIONS(3182),
    [anon_sym_class] = ACTIONS(3182),
    [anon_sym_struct] = ACTIONS(3182),
    [anon_sym_union] = ACTIONS(3182),
    [anon_sym_if] = ACTIONS(3182),
    [anon_sym_else] = ACTIONS(3182),
    [anon_sym_switch] = ACTIONS(3182),
    [anon_sym_case] = ACTIONS(3182),
    [anon_sym_default] = ACTIONS(3182),
    [anon_sym_while] = ACTIONS(3182),
    [anon_sym_do] = ACTIONS(3182),
    [anon_sym_for] = ACTIONS(3182),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_break] = ACTIONS(3182),
    [anon_sym_continue] = ACTIONS(3182),
    [anon_sym_goto] = ACTIONS(3182),
    [anon_sym___try] = ACTIONS(3182),
    [anon_sym___leave] = ACTIONS(3182),
    [anon_sym_not] = ACTIONS(3182),
    [anon_sym_compl] = ACTIONS(3182),
    [anon_sym_DASH_DASH] = ACTIONS(3184),
    [anon_sym_PLUS_PLUS] = ACTIONS(3184),
    [anon_sym_sizeof] = ACTIONS(3182),
    [anon_sym___alignof__] = ACTIONS(3182),
    [anon_sym___alignof] = ACTIONS(3182),
    [anon_sym__alignof] = ACTIONS(3182),
    [anon_sym_alignof] = ACTIONS(3182),
    [anon_sym__Alignof] = ACTIONS(3182),
    [anon_sym_offsetof] = ACTIONS(3182),
    [anon_sym__Generic] = ACTIONS(3182),
    [anon_sym_asm] = ACTIONS(3182),
    [anon_sym___asm__] = ACTIONS(3182),
    [sym_number_literal] = ACTIONS(3184),
    [anon_sym_L_SQUOTE] = ACTIONS(3184),
    [anon_sym_u_SQUOTE] = ACTIONS(3184),
    [anon_sym_U_SQUOTE] = ACTIONS(3184),
    [anon_sym_u8_SQUOTE] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3184),
    [anon_sym_L_DQUOTE] = ACTIONS(3184),
    [anon_sym_u_DQUOTE] = ACTIONS(3184),
    [anon_sym_U_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8_DQUOTE] = ACTIONS(3184),
    [anon_sym_DQUOTE] = ACTIONS(3184),
    [sym_true] = ACTIONS(3182),
    [sym_false] = ACTIONS(3182),
    [anon_sym_NULL] = ACTIONS(3182),
    [anon_sym_nullptr] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3182),
    [anon_sym_let] = ACTIONS(3182),
    [anon_sym_This] = ACTIONS(3182),
    [anon_sym_decltype] = ACTIONS(3182),
    [sym_virtual] = ACTIONS(3182),
    [anon_sym_explicit] = ACTIONS(3182),
    [anon_sym_typename] = ACTIONS(3182),
    [anon_sym_template] = ACTIONS(3182),
    [anon_sym_operator] = ACTIONS(3182),
    [anon_sym_try] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(3182),
    [anon_sym_throw] = ACTIONS(3182),
    [anon_sym_namespace] = ACTIONS(3182),
    [anon_sym_using] = ACTIONS(3182),
    [anon_sym_static_assert] = ACTIONS(3182),
    [anon_sym_concept] = ACTIONS(3182),
    [anon_sym_co_return] = ACTIONS(3182),
    [anon_sym_co_yield] = ACTIONS(3182),
    [anon_sym_R_DQUOTE] = ACTIONS(3184),
    [anon_sym_LR_DQUOTE] = ACTIONS(3184),
    [anon_sym_uR_DQUOTE] = ACTIONS(3184),
    [anon_sym_UR_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3184),
    [anon_sym_co_await] = ACTIONS(3182),
    [anon_sym_new] = ACTIONS(3182),
    [anon_sym_requires] = ACTIONS(3182),
    [sym_this] = ACTIONS(3182),
    [anon_sym_discard] = ACTIONS(3182),
    [anon_sym_precise] = ACTIONS(3182),
    [anon_sym_shared] = ACTIONS(3182),
    [anon_sym_groupshared] = ACTIONS(3182),
    [anon_sym_uniform] = ACTIONS(3182),
    [anon_sym_row_major] = ACTIONS(3182),
    [anon_sym_column_major] = ACTIONS(3182),
    [anon_sym_globallycoherent] = ACTIONS(3182),
    [anon_sym_centroid] = ACTIONS(3182),
    [anon_sym_noperspective] = ACTIONS(3182),
    [anon_sym_nointerpolation] = ACTIONS(3182),
    [anon_sym_sample] = ACTIONS(3182),
    [anon_sym_linear] = ACTIONS(3182),
    [anon_sym_snorm] = ACTIONS(3182),
    [anon_sym_unorm] = ACTIONS(3182),
    [anon_sym_point] = ACTIONS(3182),
    [anon_sym_line] = ACTIONS(3182),
    [anon_sym_triangleadj] = ACTIONS(3182),
    [anon_sym_lineadj] = ACTIONS(3182),
    [anon_sym_triangle] = ACTIONS(3182),
    [anon_sym_cbuffer] = ACTIONS(3182),
    [anon_sym_interface] = ACTIONS(3182),
    [anon_sym_extension] = ACTIONS(3182),
    [anon_sym___exported] = ACTIONS(3182),
    [anon_sym_import] = ACTIONS(3182),
  },
  [592] = {
    [ts_builtin_sym_end] = ACTIONS(3028),
    [sym_identifier] = ACTIONS(3026),
    [aux_sym_preproc_include_token1] = ACTIONS(3026),
    [aux_sym_preproc_def_token1] = ACTIONS(3026),
    [aux_sym_preproc_if_token1] = ACTIONS(3026),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3026),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3026),
    [sym_preproc_directive] = ACTIONS(3026),
    [anon_sym_LPAREN2] = ACTIONS(3028),
    [anon_sym_BANG] = ACTIONS(3028),
    [anon_sym_TILDE] = ACTIONS(3028),
    [anon_sym_DASH] = ACTIONS(3026),
    [anon_sym_PLUS] = ACTIONS(3026),
    [anon_sym_STAR] = ACTIONS(3028),
    [anon_sym_AMP_AMP] = ACTIONS(3028),
    [anon_sym_AMP] = ACTIONS(3026),
    [anon_sym_SEMI] = ACTIONS(3028),
    [anon_sym___extension__] = ACTIONS(3026),
    [anon_sym_typedef] = ACTIONS(3026),
    [anon_sym_in] = ACTIONS(3026),
    [anon_sym_out] = ACTIONS(3026),
    [anon_sym_inout] = ACTIONS(3026),
    [anon_sym_extern] = ACTIONS(3026),
    [anon_sym___attribute__] = ACTIONS(3026),
    [anon_sym_COLON_COLON] = ACTIONS(3028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3028),
    [anon_sym___declspec] = ACTIONS(3026),
    [anon_sym___based] = ACTIONS(3026),
    [anon_sym___cdecl] = ACTIONS(3026),
    [anon_sym___clrcall] = ACTIONS(3026),
    [anon_sym___stdcall] = ACTIONS(3026),
    [anon_sym___fastcall] = ACTIONS(3026),
    [anon_sym___thiscall] = ACTIONS(3026),
    [anon_sym___vectorcall] = ACTIONS(3026),
    [anon_sym_LBRACE] = ACTIONS(3028),
    [anon_sym_signed] = ACTIONS(3026),
    [anon_sym_unsigned] = ACTIONS(3026),
    [anon_sym_long] = ACTIONS(3026),
    [anon_sym_short] = ACTIONS(3026),
    [anon_sym_LBRACK] = ACTIONS(3026),
    [anon_sym_static] = ACTIONS(3026),
    [anon_sym_register] = ACTIONS(3026),
    [anon_sym_inline] = ACTIONS(3026),
    [anon_sym___inline] = ACTIONS(3026),
    [anon_sym___inline__] = ACTIONS(3026),
    [anon_sym___forceinline] = ACTIONS(3026),
    [anon_sym_thread_local] = ACTIONS(3026),
    [anon_sym___thread] = ACTIONS(3026),
    [anon_sym_const] = ACTIONS(3026),
    [anon_sym_constexpr] = ACTIONS(3026),
    [anon_sym_volatile] = ACTIONS(3026),
    [anon_sym_restrict] = ACTIONS(3026),
    [anon_sym___restrict__] = ACTIONS(3026),
    [anon_sym__Atomic] = ACTIONS(3026),
    [anon_sym__Noreturn] = ACTIONS(3026),
    [anon_sym_noreturn] = ACTIONS(3026),
    [anon_sym_mutable] = ACTIONS(3026),
    [anon_sym_constinit] = ACTIONS(3026),
    [anon_sym_consteval] = ACTIONS(3026),
    [anon_sym_alignas] = ACTIONS(3026),
    [anon_sym__Alignas] = ACTIONS(3026),
    [sym_primitive_type] = ACTIONS(3026),
    [anon_sym_enum] = ACTIONS(3026),
    [anon_sym_class] = ACTIONS(3026),
    [anon_sym_struct] = ACTIONS(3026),
    [anon_sym_union] = ACTIONS(3026),
    [anon_sym_if] = ACTIONS(3026),
    [anon_sym_else] = ACTIONS(3026),
    [anon_sym_switch] = ACTIONS(3026),
    [anon_sym_case] = ACTIONS(3026),
    [anon_sym_default] = ACTIONS(3026),
    [anon_sym_while] = ACTIONS(3026),
    [anon_sym_do] = ACTIONS(3026),
    [anon_sym_for] = ACTIONS(3026),
    [anon_sym_return] = ACTIONS(3026),
    [anon_sym_break] = ACTIONS(3026),
    [anon_sym_continue] = ACTIONS(3026),
    [anon_sym_goto] = ACTIONS(3026),
    [anon_sym___try] = ACTIONS(3026),
    [anon_sym___leave] = ACTIONS(3026),
    [anon_sym_not] = ACTIONS(3026),
    [anon_sym_compl] = ACTIONS(3026),
    [anon_sym_DASH_DASH] = ACTIONS(3028),
    [anon_sym_PLUS_PLUS] = ACTIONS(3028),
    [anon_sym_sizeof] = ACTIONS(3026),
    [anon_sym___alignof__] = ACTIONS(3026),
    [anon_sym___alignof] = ACTIONS(3026),
    [anon_sym__alignof] = ACTIONS(3026),
    [anon_sym_alignof] = ACTIONS(3026),
    [anon_sym__Alignof] = ACTIONS(3026),
    [anon_sym_offsetof] = ACTIONS(3026),
    [anon_sym__Generic] = ACTIONS(3026),
    [anon_sym_asm] = ACTIONS(3026),
    [anon_sym___asm__] = ACTIONS(3026),
    [sym_number_literal] = ACTIONS(3028),
    [anon_sym_L_SQUOTE] = ACTIONS(3028),
    [anon_sym_u_SQUOTE] = ACTIONS(3028),
    [anon_sym_U_SQUOTE] = ACTIONS(3028),
    [anon_sym_u8_SQUOTE] = ACTIONS(3028),
    [anon_sym_SQUOTE] = ACTIONS(3028),
    [anon_sym_L_DQUOTE] = ACTIONS(3028),
    [anon_sym_u_DQUOTE] = ACTIONS(3028),
    [anon_sym_U_DQUOTE] = ACTIONS(3028),
    [anon_sym_u8_DQUOTE] = ACTIONS(3028),
    [anon_sym_DQUOTE] = ACTIONS(3028),
    [sym_true] = ACTIONS(3026),
    [sym_false] = ACTIONS(3026),
    [anon_sym_NULL] = ACTIONS(3026),
    [anon_sym_nullptr] = ACTIONS(3026),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3026),
    [anon_sym_let] = ACTIONS(3026),
    [anon_sym_This] = ACTIONS(3026),
    [anon_sym_decltype] = ACTIONS(3026),
    [sym_virtual] = ACTIONS(3026),
    [anon_sym_explicit] = ACTIONS(3026),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(3026),
    [anon_sym_operator] = ACTIONS(3026),
    [anon_sym_try] = ACTIONS(3026),
    [anon_sym_delete] = ACTIONS(3026),
    [anon_sym_throw] = ACTIONS(3026),
    [anon_sym_namespace] = ACTIONS(3026),
    [anon_sym_using] = ACTIONS(3026),
    [anon_sym_static_assert] = ACTIONS(3026),
    [anon_sym_concept] = ACTIONS(3026),
    [anon_sym_co_return] = ACTIONS(3026),
    [anon_sym_co_yield] = ACTIONS(3026),
    [anon_sym_R_DQUOTE] = ACTIONS(3028),
    [anon_sym_LR_DQUOTE] = ACTIONS(3028),
    [anon_sym_uR_DQUOTE] = ACTIONS(3028),
    [anon_sym_UR_DQUOTE] = ACTIONS(3028),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3028),
    [anon_sym_co_await] = ACTIONS(3026),
    [anon_sym_new] = ACTIONS(3026),
    [anon_sym_requires] = ACTIONS(3026),
    [sym_this] = ACTIONS(3026),
    [anon_sym_discard] = ACTIONS(3026),
    [anon_sym_precise] = ACTIONS(3026),
    [anon_sym_shared] = ACTIONS(3026),
    [anon_sym_groupshared] = ACTIONS(3026),
    [anon_sym_uniform] = ACTIONS(3026),
    [anon_sym_row_major] = ACTIONS(3026),
    [anon_sym_column_major] = ACTIONS(3026),
    [anon_sym_globallycoherent] = ACTIONS(3026),
    [anon_sym_centroid] = ACTIONS(3026),
    [anon_sym_noperspective] = ACTIONS(3026),
    [anon_sym_nointerpolation] = ACTIONS(3026),
    [anon_sym_sample] = ACTIONS(3026),
    [anon_sym_linear] = ACTIONS(3026),
    [anon_sym_snorm] = ACTIONS(3026),
    [anon_sym_unorm] = ACTIONS(3026),
    [anon_sym_point] = ACTIONS(3026),
    [anon_sym_line] = ACTIONS(3026),
    [anon_sym_triangleadj] = ACTIONS(3026),
    [anon_sym_lineadj] = ACTIONS(3026),
    [anon_sym_triangle] = ACTIONS(3026),
    [anon_sym_cbuffer] = ACTIONS(3026),
    [anon_sym_interface] = ACTIONS(3026),
    [anon_sym_extension] = ACTIONS(3026),
    [anon_sym___exported] = ACTIONS(3026),
    [anon_sym_import] = ACTIONS(3026),
  },
  [593] = {
    [sym_catch_clause] = STATE(531),
    [aux_sym_constructor_try_statement_repeat1] = STATE(531),
    [sym_identifier] = ACTIONS(2744),
    [aux_sym_preproc_include_token1] = ACTIONS(2744),
    [aux_sym_preproc_def_token1] = ACTIONS(2744),
    [aux_sym_preproc_if_token1] = ACTIONS(2744),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2744),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2744),
    [sym_preproc_directive] = ACTIONS(2744),
    [anon_sym_LPAREN2] = ACTIONS(2746),
    [anon_sym_BANG] = ACTIONS(2746),
    [anon_sym_TILDE] = ACTIONS(2746),
    [anon_sym_DASH] = ACTIONS(2744),
    [anon_sym_PLUS] = ACTIONS(2744),
    [anon_sym_STAR] = ACTIONS(2746),
    [anon_sym_AMP_AMP] = ACTIONS(2746),
    [anon_sym_AMP] = ACTIONS(2744),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym___extension__] = ACTIONS(2744),
    [anon_sym_typedef] = ACTIONS(2744),
    [anon_sym_in] = ACTIONS(2744),
    [anon_sym_out] = ACTIONS(2744),
    [anon_sym_inout] = ACTIONS(2744),
    [anon_sym_extern] = ACTIONS(2744),
    [anon_sym___attribute__] = ACTIONS(2744),
    [anon_sym_COLON_COLON] = ACTIONS(2746),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2746),
    [anon_sym___declspec] = ACTIONS(2744),
    [anon_sym___based] = ACTIONS(2744),
    [anon_sym___cdecl] = ACTIONS(2744),
    [anon_sym___clrcall] = ACTIONS(2744),
    [anon_sym___stdcall] = ACTIONS(2744),
    [anon_sym___fastcall] = ACTIONS(2744),
    [anon_sym___thiscall] = ACTIONS(2744),
    [anon_sym___vectorcall] = ACTIONS(2744),
    [anon_sym_LBRACE] = ACTIONS(2746),
    [anon_sym_RBRACE] = ACTIONS(2746),
    [anon_sym_signed] = ACTIONS(2744),
    [anon_sym_unsigned] = ACTIONS(2744),
    [anon_sym_long] = ACTIONS(2744),
    [anon_sym_short] = ACTIONS(2744),
    [anon_sym_LBRACK] = ACTIONS(2744),
    [anon_sym_static] = ACTIONS(2744),
    [anon_sym_register] = ACTIONS(2744),
    [anon_sym_inline] = ACTIONS(2744),
    [anon_sym___inline] = ACTIONS(2744),
    [anon_sym___inline__] = ACTIONS(2744),
    [anon_sym___forceinline] = ACTIONS(2744),
    [anon_sym_thread_local] = ACTIONS(2744),
    [anon_sym___thread] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_constexpr] = ACTIONS(2744),
    [anon_sym_volatile] = ACTIONS(2744),
    [anon_sym_restrict] = ACTIONS(2744),
    [anon_sym___restrict__] = ACTIONS(2744),
    [anon_sym__Atomic] = ACTIONS(2744),
    [anon_sym__Noreturn] = ACTIONS(2744),
    [anon_sym_noreturn] = ACTIONS(2744),
    [anon_sym_mutable] = ACTIONS(2744),
    [anon_sym_constinit] = ACTIONS(2744),
    [anon_sym_consteval] = ACTIONS(2744),
    [anon_sym_alignas] = ACTIONS(2744),
    [anon_sym__Alignas] = ACTIONS(2744),
    [sym_primitive_type] = ACTIONS(2744),
    [anon_sym_enum] = ACTIONS(2744),
    [anon_sym_class] = ACTIONS(2744),
    [anon_sym_struct] = ACTIONS(2744),
    [anon_sym_union] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2744),
    [anon_sym_switch] = ACTIONS(2744),
    [anon_sym_case] = ACTIONS(2744),
    [anon_sym_default] = ACTIONS(2744),
    [anon_sym_while] = ACTIONS(2744),
    [anon_sym_do] = ACTIONS(2744),
    [anon_sym_for] = ACTIONS(2744),
    [anon_sym_return] = ACTIONS(2744),
    [anon_sym_break] = ACTIONS(2744),
    [anon_sym_continue] = ACTIONS(2744),
    [anon_sym_goto] = ACTIONS(2744),
    [anon_sym___try] = ACTIONS(2744),
    [anon_sym___leave] = ACTIONS(2744),
    [anon_sym_not] = ACTIONS(2744),
    [anon_sym_compl] = ACTIONS(2744),
    [anon_sym_DASH_DASH] = ACTIONS(2746),
    [anon_sym_PLUS_PLUS] = ACTIONS(2746),
    [anon_sym_sizeof] = ACTIONS(2744),
    [anon_sym___alignof__] = ACTIONS(2744),
    [anon_sym___alignof] = ACTIONS(2744),
    [anon_sym__alignof] = ACTIONS(2744),
    [anon_sym_alignof] = ACTIONS(2744),
    [anon_sym__Alignof] = ACTIONS(2744),
    [anon_sym_offsetof] = ACTIONS(2744),
    [anon_sym__Generic] = ACTIONS(2744),
    [anon_sym_asm] = ACTIONS(2744),
    [anon_sym___asm__] = ACTIONS(2744),
    [sym_number_literal] = ACTIONS(2746),
    [anon_sym_L_SQUOTE] = ACTIONS(2746),
    [anon_sym_u_SQUOTE] = ACTIONS(2746),
    [anon_sym_U_SQUOTE] = ACTIONS(2746),
    [anon_sym_u8_SQUOTE] = ACTIONS(2746),
    [anon_sym_SQUOTE] = ACTIONS(2746),
    [anon_sym_L_DQUOTE] = ACTIONS(2746),
    [anon_sym_u_DQUOTE] = ACTIONS(2746),
    [anon_sym_U_DQUOTE] = ACTIONS(2746),
    [anon_sym_u8_DQUOTE] = ACTIONS(2746),
    [anon_sym_DQUOTE] = ACTIONS(2746),
    [sym_true] = ACTIONS(2744),
    [sym_false] = ACTIONS(2744),
    [anon_sym_NULL] = ACTIONS(2744),
    [anon_sym_nullptr] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2744),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_This] = ACTIONS(2744),
    [anon_sym_decltype] = ACTIONS(2744),
    [sym_virtual] = ACTIONS(2744),
    [anon_sym_explicit] = ACTIONS(2744),
    [anon_sym_typename] = ACTIONS(2744),
    [anon_sym_template] = ACTIONS(2744),
    [anon_sym_operator] = ACTIONS(2744),
    [anon_sym_try] = ACTIONS(2744),
    [anon_sym_delete] = ACTIONS(2744),
    [anon_sym_throw] = ACTIONS(2744),
    [anon_sym_namespace] = ACTIONS(2744),
    [anon_sym_using] = ACTIONS(2744),
    [anon_sym_static_assert] = ACTIONS(2744),
    [anon_sym_concept] = ACTIONS(2744),
    [anon_sym_co_return] = ACTIONS(2744),
    [anon_sym_co_yield] = ACTIONS(2744),
    [anon_sym_catch] = ACTIONS(3689),
    [anon_sym_R_DQUOTE] = ACTIONS(2746),
    [anon_sym_LR_DQUOTE] = ACTIONS(2746),
    [anon_sym_uR_DQUOTE] = ACTIONS(2746),
    [anon_sym_UR_DQUOTE] = ACTIONS(2746),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2746),
    [anon_sym_co_await] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(2744),
    [anon_sym_requires] = ACTIONS(2744),
    [sym_this] = ACTIONS(2744),
    [anon_sym_discard] = ACTIONS(2744),
    [anon_sym_precise] = ACTIONS(2744),
    [anon_sym_shared] = ACTIONS(2744),
    [anon_sym_groupshared] = ACTIONS(2744),
    [anon_sym_uniform] = ACTIONS(2744),
    [anon_sym_row_major] = ACTIONS(2744),
    [anon_sym_column_major] = ACTIONS(2744),
    [anon_sym_globallycoherent] = ACTIONS(2744),
    [anon_sym_centroid] = ACTIONS(2744),
    [anon_sym_noperspective] = ACTIONS(2744),
    [anon_sym_nointerpolation] = ACTIONS(2744),
    [anon_sym_sample] = ACTIONS(2744),
    [anon_sym_linear] = ACTIONS(2744),
    [anon_sym_snorm] = ACTIONS(2744),
    [anon_sym_unorm] = ACTIONS(2744),
    [anon_sym_point] = ACTIONS(2744),
    [anon_sym_line] = ACTIONS(2744),
    [anon_sym_triangleadj] = ACTIONS(2744),
    [anon_sym_lineadj] = ACTIONS(2744),
    [anon_sym_triangle] = ACTIONS(2744),
    [anon_sym_cbuffer] = ACTIONS(2744),
    [anon_sym_interface] = ACTIONS(2744),
    [anon_sym_extension] = ACTIONS(2744),
  },
  [594] = {
    [ts_builtin_sym_end] = ACTIONS(3004),
    [sym_identifier] = ACTIONS(3002),
    [aux_sym_preproc_include_token1] = ACTIONS(3002),
    [aux_sym_preproc_def_token1] = ACTIONS(3002),
    [aux_sym_preproc_if_token1] = ACTIONS(3002),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3002),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3002),
    [sym_preproc_directive] = ACTIONS(3002),
    [anon_sym_LPAREN2] = ACTIONS(3004),
    [anon_sym_BANG] = ACTIONS(3004),
    [anon_sym_TILDE] = ACTIONS(3004),
    [anon_sym_DASH] = ACTIONS(3002),
    [anon_sym_PLUS] = ACTIONS(3002),
    [anon_sym_STAR] = ACTIONS(3004),
    [anon_sym_AMP_AMP] = ACTIONS(3004),
    [anon_sym_AMP] = ACTIONS(3002),
    [anon_sym_SEMI] = ACTIONS(3004),
    [anon_sym___extension__] = ACTIONS(3002),
    [anon_sym_typedef] = ACTIONS(3002),
    [anon_sym_in] = ACTIONS(3002),
    [anon_sym_out] = ACTIONS(3002),
    [anon_sym_inout] = ACTIONS(3002),
    [anon_sym_extern] = ACTIONS(3002),
    [anon_sym___attribute__] = ACTIONS(3002),
    [anon_sym_COLON_COLON] = ACTIONS(3004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3004),
    [anon_sym___declspec] = ACTIONS(3002),
    [anon_sym___based] = ACTIONS(3002),
    [anon_sym___cdecl] = ACTIONS(3002),
    [anon_sym___clrcall] = ACTIONS(3002),
    [anon_sym___stdcall] = ACTIONS(3002),
    [anon_sym___fastcall] = ACTIONS(3002),
    [anon_sym___thiscall] = ACTIONS(3002),
    [anon_sym___vectorcall] = ACTIONS(3002),
    [anon_sym_LBRACE] = ACTIONS(3004),
    [anon_sym_signed] = ACTIONS(3002),
    [anon_sym_unsigned] = ACTIONS(3002),
    [anon_sym_long] = ACTIONS(3002),
    [anon_sym_short] = ACTIONS(3002),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [anon_sym_static] = ACTIONS(3002),
    [anon_sym_register] = ACTIONS(3002),
    [anon_sym_inline] = ACTIONS(3002),
    [anon_sym___inline] = ACTIONS(3002),
    [anon_sym___inline__] = ACTIONS(3002),
    [anon_sym___forceinline] = ACTIONS(3002),
    [anon_sym_thread_local] = ACTIONS(3002),
    [anon_sym___thread] = ACTIONS(3002),
    [anon_sym_const] = ACTIONS(3002),
    [anon_sym_constexpr] = ACTIONS(3002),
    [anon_sym_volatile] = ACTIONS(3002),
    [anon_sym_restrict] = ACTIONS(3002),
    [anon_sym___restrict__] = ACTIONS(3002),
    [anon_sym__Atomic] = ACTIONS(3002),
    [anon_sym__Noreturn] = ACTIONS(3002),
    [anon_sym_noreturn] = ACTIONS(3002),
    [anon_sym_mutable] = ACTIONS(3002),
    [anon_sym_constinit] = ACTIONS(3002),
    [anon_sym_consteval] = ACTIONS(3002),
    [anon_sym_alignas] = ACTIONS(3002),
    [anon_sym__Alignas] = ACTIONS(3002),
    [sym_primitive_type] = ACTIONS(3002),
    [anon_sym_enum] = ACTIONS(3002),
    [anon_sym_class] = ACTIONS(3002),
    [anon_sym_struct] = ACTIONS(3002),
    [anon_sym_union] = ACTIONS(3002),
    [anon_sym_if] = ACTIONS(3002),
    [anon_sym_else] = ACTIONS(3002),
    [anon_sym_switch] = ACTIONS(3002),
    [anon_sym_case] = ACTIONS(3002),
    [anon_sym_default] = ACTIONS(3002),
    [anon_sym_while] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(3002),
    [anon_sym_for] = ACTIONS(3002),
    [anon_sym_return] = ACTIONS(3002),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_continue] = ACTIONS(3002),
    [anon_sym_goto] = ACTIONS(3002),
    [anon_sym___try] = ACTIONS(3002),
    [anon_sym___leave] = ACTIONS(3002),
    [anon_sym_not] = ACTIONS(3002),
    [anon_sym_compl] = ACTIONS(3002),
    [anon_sym_DASH_DASH] = ACTIONS(3004),
    [anon_sym_PLUS_PLUS] = ACTIONS(3004),
    [anon_sym_sizeof] = ACTIONS(3002),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3002),
    [anon_sym__Generic] = ACTIONS(3002),
    [anon_sym_asm] = ACTIONS(3002),
    [anon_sym___asm__] = ACTIONS(3002),
    [sym_number_literal] = ACTIONS(3004),
    [anon_sym_L_SQUOTE] = ACTIONS(3004),
    [anon_sym_u_SQUOTE] = ACTIONS(3004),
    [anon_sym_U_SQUOTE] = ACTIONS(3004),
    [anon_sym_u8_SQUOTE] = ACTIONS(3004),
    [anon_sym_SQUOTE] = ACTIONS(3004),
    [anon_sym_L_DQUOTE] = ACTIONS(3004),
    [anon_sym_u_DQUOTE] = ACTIONS(3004),
    [anon_sym_U_DQUOTE] = ACTIONS(3004),
    [anon_sym_u8_DQUOTE] = ACTIONS(3004),
    [anon_sym_DQUOTE] = ACTIONS(3004),
    [sym_true] = ACTIONS(3002),
    [sym_false] = ACTIONS(3002),
    [anon_sym_NULL] = ACTIONS(3002),
    [anon_sym_nullptr] = ACTIONS(3002),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3002),
    [anon_sym_let] = ACTIONS(3002),
    [anon_sym_This] = ACTIONS(3002),
    [anon_sym_decltype] = ACTIONS(3002),
    [sym_virtual] = ACTIONS(3002),
    [anon_sym_explicit] = ACTIONS(3002),
    [anon_sym_typename] = ACTIONS(3002),
    [anon_sym_template] = ACTIONS(3002),
    [anon_sym_operator] = ACTIONS(3002),
    [anon_sym_try] = ACTIONS(3002),
    [anon_sym_delete] = ACTIONS(3002),
    [anon_sym_throw] = ACTIONS(3002),
    [anon_sym_namespace] = ACTIONS(3002),
    [anon_sym_using] = ACTIONS(3002),
    [anon_sym_static_assert] = ACTIONS(3002),
    [anon_sym_concept] = ACTIONS(3002),
    [anon_sym_co_return] = ACTIONS(3002),
    [anon_sym_co_yield] = ACTIONS(3002),
    [anon_sym_R_DQUOTE] = ACTIONS(3004),
    [anon_sym_LR_DQUOTE] = ACTIONS(3004),
    [anon_sym_uR_DQUOTE] = ACTIONS(3004),
    [anon_sym_UR_DQUOTE] = ACTIONS(3004),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3004),
    [anon_sym_co_await] = ACTIONS(3002),
    [anon_sym_new] = ACTIONS(3002),
    [anon_sym_requires] = ACTIONS(3002),
    [sym_this] = ACTIONS(3002),
    [anon_sym_discard] = ACTIONS(3002),
    [anon_sym_precise] = ACTIONS(3002),
    [anon_sym_shared] = ACTIONS(3002),
    [anon_sym_groupshared] = ACTIONS(3002),
    [anon_sym_uniform] = ACTIONS(3002),
    [anon_sym_row_major] = ACTIONS(3002),
    [anon_sym_column_major] = ACTIONS(3002),
    [anon_sym_globallycoherent] = ACTIONS(3002),
    [anon_sym_centroid] = ACTIONS(3002),
    [anon_sym_noperspective] = ACTIONS(3002),
    [anon_sym_nointerpolation] = ACTIONS(3002),
    [anon_sym_sample] = ACTIONS(3002),
    [anon_sym_linear] = ACTIONS(3002),
    [anon_sym_snorm] = ACTIONS(3002),
    [anon_sym_unorm] = ACTIONS(3002),
    [anon_sym_point] = ACTIONS(3002),
    [anon_sym_line] = ACTIONS(3002),
    [anon_sym_triangleadj] = ACTIONS(3002),
    [anon_sym_lineadj] = ACTIONS(3002),
    [anon_sym_triangle] = ACTIONS(3002),
    [anon_sym_cbuffer] = ACTIONS(3002),
    [anon_sym_interface] = ACTIONS(3002),
    [anon_sym_extension] = ACTIONS(3002),
    [anon_sym___exported] = ACTIONS(3002),
    [anon_sym_import] = ACTIONS(3002),
  },
  [595] = {
    [sym_attribute_specifier] = STATE(757),
    [sym_enumerator_list] = STATE(620),
    [sym_identifier] = ACTIONS(3711),
    [aux_sym_preproc_include_token1] = ACTIONS(3711),
    [aux_sym_preproc_def_token1] = ACTIONS(3711),
    [aux_sym_preproc_if_token1] = ACTIONS(3711),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3711),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3711),
    [sym_preproc_directive] = ACTIONS(3711),
    [anon_sym_LPAREN2] = ACTIONS(3713),
    [anon_sym_BANG] = ACTIONS(3713),
    [anon_sym_TILDE] = ACTIONS(3713),
    [anon_sym_DASH] = ACTIONS(3711),
    [anon_sym_PLUS] = ACTIONS(3711),
    [anon_sym_STAR] = ACTIONS(3713),
    [anon_sym_AMP_AMP] = ACTIONS(3713),
    [anon_sym_AMP] = ACTIONS(3711),
    [anon_sym_SEMI] = ACTIONS(3713),
    [anon_sym___extension__] = ACTIONS(3711),
    [anon_sym_typedef] = ACTIONS(3711),
    [anon_sym_in] = ACTIONS(3711),
    [anon_sym_out] = ACTIONS(3711),
    [anon_sym_inout] = ACTIONS(3711),
    [anon_sym_extern] = ACTIONS(3711),
    [anon_sym___attribute__] = ACTIONS(2687),
    [anon_sym_COLON_COLON] = ACTIONS(3713),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3713),
    [anon_sym___declspec] = ACTIONS(3711),
    [anon_sym___based] = ACTIONS(3711),
    [anon_sym___cdecl] = ACTIONS(3711),
    [anon_sym___clrcall] = ACTIONS(3711),
    [anon_sym___stdcall] = ACTIONS(3711),
    [anon_sym___fastcall] = ACTIONS(3711),
    [anon_sym___thiscall] = ACTIONS(3711),
    [anon_sym___vectorcall] = ACTIONS(3711),
    [anon_sym_LBRACE] = ACTIONS(3066),
    [anon_sym_RBRACE] = ACTIONS(3713),
    [anon_sym_signed] = ACTIONS(3711),
    [anon_sym_unsigned] = ACTIONS(3711),
    [anon_sym_long] = ACTIONS(3711),
    [anon_sym_short] = ACTIONS(3711),
    [anon_sym_LBRACK] = ACTIONS(3711),
    [anon_sym_static] = ACTIONS(3711),
    [anon_sym_register] = ACTIONS(3711),
    [anon_sym_inline] = ACTIONS(3711),
    [anon_sym___inline] = ACTIONS(3711),
    [anon_sym___inline__] = ACTIONS(3711),
    [anon_sym___forceinline] = ACTIONS(3711),
    [anon_sym_thread_local] = ACTIONS(3711),
    [anon_sym___thread] = ACTIONS(3711),
    [anon_sym_const] = ACTIONS(3711),
    [anon_sym_constexpr] = ACTIONS(3711),
    [anon_sym_volatile] = ACTIONS(3711),
    [anon_sym_restrict] = ACTIONS(3711),
    [anon_sym___restrict__] = ACTIONS(3711),
    [anon_sym__Atomic] = ACTIONS(3711),
    [anon_sym__Noreturn] = ACTIONS(3711),
    [anon_sym_noreturn] = ACTIONS(3711),
    [anon_sym_mutable] = ACTIONS(3711),
    [anon_sym_constinit] = ACTIONS(3711),
    [anon_sym_consteval] = ACTIONS(3711),
    [anon_sym_alignas] = ACTIONS(3711),
    [anon_sym__Alignas] = ACTIONS(3711),
    [sym_primitive_type] = ACTIONS(3711),
    [anon_sym_enum] = ACTIONS(3711),
    [anon_sym_class] = ACTIONS(3711),
    [anon_sym_struct] = ACTIONS(3711),
    [anon_sym_union] = ACTIONS(3711),
    [anon_sym_if] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3711),
    [anon_sym_case] = ACTIONS(3711),
    [anon_sym_default] = ACTIONS(3711),
    [anon_sym_while] = ACTIONS(3711),
    [anon_sym_do] = ACTIONS(3711),
    [anon_sym_for] = ACTIONS(3711),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_break] = ACTIONS(3711),
    [anon_sym_continue] = ACTIONS(3711),
    [anon_sym_goto] = ACTIONS(3711),
    [anon_sym___try] = ACTIONS(3711),
    [anon_sym___leave] = ACTIONS(3711),
    [anon_sym_not] = ACTIONS(3711),
    [anon_sym_compl] = ACTIONS(3711),
    [anon_sym_DASH_DASH] = ACTIONS(3713),
    [anon_sym_PLUS_PLUS] = ACTIONS(3713),
    [anon_sym_sizeof] = ACTIONS(3711),
    [anon_sym___alignof__] = ACTIONS(3711),
    [anon_sym___alignof] = ACTIONS(3711),
    [anon_sym__alignof] = ACTIONS(3711),
    [anon_sym_alignof] = ACTIONS(3711),
    [anon_sym__Alignof] = ACTIONS(3711),
    [anon_sym_offsetof] = ACTIONS(3711),
    [anon_sym__Generic] = ACTIONS(3711),
    [anon_sym_asm] = ACTIONS(3711),
    [anon_sym___asm__] = ACTIONS(3711),
    [anon_sym_DOT] = ACTIONS(3711),
    [sym_number_literal] = ACTIONS(3713),
    [anon_sym_L_SQUOTE] = ACTIONS(3713),
    [anon_sym_u_SQUOTE] = ACTIONS(3713),
    [anon_sym_U_SQUOTE] = ACTIONS(3713),
    [anon_sym_u8_SQUOTE] = ACTIONS(3713),
    [anon_sym_SQUOTE] = ACTIONS(3713),
    [anon_sym_L_DQUOTE] = ACTIONS(3713),
    [anon_sym_u_DQUOTE] = ACTIONS(3713),
    [anon_sym_U_DQUOTE] = ACTIONS(3713),
    [anon_sym_u8_DQUOTE] = ACTIONS(3713),
    [anon_sym_DQUOTE] = ACTIONS(3713),
    [sym_true] = ACTIONS(3711),
    [sym_false] = ACTIONS(3711),
    [anon_sym_NULL] = ACTIONS(3711),
    [anon_sym_nullptr] = ACTIONS(3711),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_This] = ACTIONS(3711),
    [anon_sym_decltype] = ACTIONS(3711),
    [sym_virtual] = ACTIONS(3711),
    [anon_sym_explicit] = ACTIONS(3711),
    [anon_sym_typename] = ACTIONS(3711),
    [anon_sym_template] = ACTIONS(3711),
    [anon_sym_operator] = ACTIONS(3711),
    [anon_sym_try] = ACTIONS(3711),
    [anon_sym_delete] = ACTIONS(3711),
    [anon_sym_throw] = ACTIONS(3711),
    [anon_sym_namespace] = ACTIONS(3711),
    [anon_sym_using] = ACTIONS(3711),
    [anon_sym_static_assert] = ACTIONS(3711),
    [anon_sym_concept] = ACTIONS(3711),
    [anon_sym_co_return] = ACTIONS(3711),
    [anon_sym_co_yield] = ACTIONS(3711),
    [anon_sym_R_DQUOTE] = ACTIONS(3713),
    [anon_sym_LR_DQUOTE] = ACTIONS(3713),
    [anon_sym_uR_DQUOTE] = ACTIONS(3713),
    [anon_sym_UR_DQUOTE] = ACTIONS(3713),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3713),
    [anon_sym_co_await] = ACTIONS(3711),
    [anon_sym_new] = ACTIONS(3711),
    [anon_sym_requires] = ACTIONS(3711),
    [sym_this] = ACTIONS(3711),
    [anon_sym_discard] = ACTIONS(3711),
    [anon_sym_precise] = ACTIONS(3711),
    [anon_sym_shared] = ACTIONS(3711),
    [anon_sym_groupshared] = ACTIONS(3711),
    [anon_sym_uniform] = ACTIONS(3711),
    [anon_sym_row_major] = ACTIONS(3711),
    [anon_sym_column_major] = ACTIONS(3711),
    [anon_sym_globallycoherent] = ACTIONS(3711),
    [anon_sym_centroid] = ACTIONS(3711),
    [anon_sym_noperspective] = ACTIONS(3711),
    [anon_sym_nointerpolation] = ACTIONS(3711),
    [anon_sym_sample] = ACTIONS(3711),
    [anon_sym_linear] = ACTIONS(3711),
    [anon_sym_snorm] = ACTIONS(3711),
    [anon_sym_unorm] = ACTIONS(3711),
    [anon_sym_point] = ACTIONS(3711),
    [anon_sym_line] = ACTIONS(3711),
    [anon_sym_triangleadj] = ACTIONS(3711),
    [anon_sym_lineadj] = ACTIONS(3711),
    [anon_sym_triangle] = ACTIONS(3711),
    [anon_sym_cbuffer] = ACTIONS(3711),
    [anon_sym_interface] = ACTIONS(3711),
    [anon_sym_extension] = ACTIONS(3711),
  },
  [596] = {
    [ts_builtin_sym_end] = ACTIONS(3224),
    [sym_identifier] = ACTIONS(3222),
    [aux_sym_preproc_include_token1] = ACTIONS(3222),
    [aux_sym_preproc_def_token1] = ACTIONS(3222),
    [aux_sym_preproc_if_token1] = ACTIONS(3222),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3222),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3222),
    [sym_preproc_directive] = ACTIONS(3222),
    [anon_sym_LPAREN2] = ACTIONS(3224),
    [anon_sym_BANG] = ACTIONS(3224),
    [anon_sym_TILDE] = ACTIONS(3224),
    [anon_sym_DASH] = ACTIONS(3222),
    [anon_sym_PLUS] = ACTIONS(3222),
    [anon_sym_STAR] = ACTIONS(3224),
    [anon_sym_AMP_AMP] = ACTIONS(3224),
    [anon_sym_AMP] = ACTIONS(3222),
    [anon_sym_SEMI] = ACTIONS(3224),
    [anon_sym___extension__] = ACTIONS(3222),
    [anon_sym_typedef] = ACTIONS(3222),
    [anon_sym_in] = ACTIONS(3222),
    [anon_sym_out] = ACTIONS(3222),
    [anon_sym_inout] = ACTIONS(3222),
    [anon_sym_extern] = ACTIONS(3222),
    [anon_sym___attribute__] = ACTIONS(3222),
    [anon_sym_COLON_COLON] = ACTIONS(3224),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3224),
    [anon_sym___declspec] = ACTIONS(3222),
    [anon_sym___based] = ACTIONS(3222),
    [anon_sym___cdecl] = ACTIONS(3222),
    [anon_sym___clrcall] = ACTIONS(3222),
    [anon_sym___stdcall] = ACTIONS(3222),
    [anon_sym___fastcall] = ACTIONS(3222),
    [anon_sym___thiscall] = ACTIONS(3222),
    [anon_sym___vectorcall] = ACTIONS(3222),
    [anon_sym_LBRACE] = ACTIONS(3224),
    [anon_sym_signed] = ACTIONS(3222),
    [anon_sym_unsigned] = ACTIONS(3222),
    [anon_sym_long] = ACTIONS(3222),
    [anon_sym_short] = ACTIONS(3222),
    [anon_sym_LBRACK] = ACTIONS(3222),
    [anon_sym_static] = ACTIONS(3222),
    [anon_sym_register] = ACTIONS(3222),
    [anon_sym_inline] = ACTIONS(3222),
    [anon_sym___inline] = ACTIONS(3222),
    [anon_sym___inline__] = ACTIONS(3222),
    [anon_sym___forceinline] = ACTIONS(3222),
    [anon_sym_thread_local] = ACTIONS(3222),
    [anon_sym___thread] = ACTIONS(3222),
    [anon_sym_const] = ACTIONS(3222),
    [anon_sym_constexpr] = ACTIONS(3222),
    [anon_sym_volatile] = ACTIONS(3222),
    [anon_sym_restrict] = ACTIONS(3222),
    [anon_sym___restrict__] = ACTIONS(3222),
    [anon_sym__Atomic] = ACTIONS(3222),
    [anon_sym__Noreturn] = ACTIONS(3222),
    [anon_sym_noreturn] = ACTIONS(3222),
    [anon_sym_mutable] = ACTIONS(3222),
    [anon_sym_constinit] = ACTIONS(3222),
    [anon_sym_consteval] = ACTIONS(3222),
    [anon_sym_alignas] = ACTIONS(3222),
    [anon_sym__Alignas] = ACTIONS(3222),
    [sym_primitive_type] = ACTIONS(3222),
    [anon_sym_enum] = ACTIONS(3222),
    [anon_sym_class] = ACTIONS(3222),
    [anon_sym_struct] = ACTIONS(3222),
    [anon_sym_union] = ACTIONS(3222),
    [anon_sym_if] = ACTIONS(3222),
    [anon_sym_else] = ACTIONS(3222),
    [anon_sym_switch] = ACTIONS(3222),
    [anon_sym_case] = ACTIONS(3222),
    [anon_sym_default] = ACTIONS(3222),
    [anon_sym_while] = ACTIONS(3222),
    [anon_sym_do] = ACTIONS(3222),
    [anon_sym_for] = ACTIONS(3222),
    [anon_sym_return] = ACTIONS(3222),
    [anon_sym_break] = ACTIONS(3222),
    [anon_sym_continue] = ACTIONS(3222),
    [anon_sym_goto] = ACTIONS(3222),
    [anon_sym___try] = ACTIONS(3222),
    [anon_sym___leave] = ACTIONS(3222),
    [anon_sym_not] = ACTIONS(3222),
    [anon_sym_compl] = ACTIONS(3222),
    [anon_sym_DASH_DASH] = ACTIONS(3224),
    [anon_sym_PLUS_PLUS] = ACTIONS(3224),
    [anon_sym_sizeof] = ACTIONS(3222),
    [anon_sym___alignof__] = ACTIONS(3222),
    [anon_sym___alignof] = ACTIONS(3222),
    [anon_sym__alignof] = ACTIONS(3222),
    [anon_sym_alignof] = ACTIONS(3222),
    [anon_sym__Alignof] = ACTIONS(3222),
    [anon_sym_offsetof] = ACTIONS(3222),
    [anon_sym__Generic] = ACTIONS(3222),
    [anon_sym_asm] = ACTIONS(3222),
    [anon_sym___asm__] = ACTIONS(3222),
    [sym_number_literal] = ACTIONS(3224),
    [anon_sym_L_SQUOTE] = ACTIONS(3224),
    [anon_sym_u_SQUOTE] = ACTIONS(3224),
    [anon_sym_U_SQUOTE] = ACTIONS(3224),
    [anon_sym_u8_SQUOTE] = ACTIONS(3224),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_L_DQUOTE] = ACTIONS(3224),
    [anon_sym_u_DQUOTE] = ACTIONS(3224),
    [anon_sym_U_DQUOTE] = ACTIONS(3224),
    [anon_sym_u8_DQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3224),
    [sym_true] = ACTIONS(3222),
    [sym_false] = ACTIONS(3222),
    [anon_sym_NULL] = ACTIONS(3222),
    [anon_sym_nullptr] = ACTIONS(3222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3222),
    [anon_sym_let] = ACTIONS(3222),
    [anon_sym_This] = ACTIONS(3222),
    [anon_sym_decltype] = ACTIONS(3222),
    [sym_virtual] = ACTIONS(3222),
    [anon_sym_explicit] = ACTIONS(3222),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3222),
    [anon_sym_operator] = ACTIONS(3222),
    [anon_sym_try] = ACTIONS(3222),
    [anon_sym_delete] = ACTIONS(3222),
    [anon_sym_throw] = ACTIONS(3222),
    [anon_sym_namespace] = ACTIONS(3222),
    [anon_sym_using] = ACTIONS(3222),
    [anon_sym_static_assert] = ACTIONS(3222),
    [anon_sym_concept] = ACTIONS(3222),
    [anon_sym_co_return] = ACTIONS(3222),
    [anon_sym_co_yield] = ACTIONS(3222),
    [anon_sym_R_DQUOTE] = ACTIONS(3224),
    [anon_sym_LR_DQUOTE] = ACTIONS(3224),
    [anon_sym_uR_DQUOTE] = ACTIONS(3224),
    [anon_sym_UR_DQUOTE] = ACTIONS(3224),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3224),
    [anon_sym_co_await] = ACTIONS(3222),
    [anon_sym_new] = ACTIONS(3222),
    [anon_sym_requires] = ACTIONS(3222),
    [sym_this] = ACTIONS(3222),
    [anon_sym_discard] = ACTIONS(3222),
    [anon_sym_precise] = ACTIONS(3222),
    [anon_sym_shared] = ACTIONS(3222),
    [anon_sym_groupshared] = ACTIONS(3222),
    [anon_sym_uniform] = ACTIONS(3222),
    [anon_sym_row_major] = ACTIONS(3222),
    [anon_sym_column_major] = ACTIONS(3222),
    [anon_sym_globallycoherent] = ACTIONS(3222),
    [anon_sym_centroid] = ACTIONS(3222),
    [anon_sym_noperspective] = ACTIONS(3222),
    [anon_sym_nointerpolation] = ACTIONS(3222),
    [anon_sym_sample] = ACTIONS(3222),
    [anon_sym_linear] = ACTIONS(3222),
    [anon_sym_snorm] = ACTIONS(3222),
    [anon_sym_unorm] = ACTIONS(3222),
    [anon_sym_point] = ACTIONS(3222),
    [anon_sym_line] = ACTIONS(3222),
    [anon_sym_triangleadj] = ACTIONS(3222),
    [anon_sym_lineadj] = ACTIONS(3222),
    [anon_sym_triangle] = ACTIONS(3222),
    [anon_sym_cbuffer] = ACTIONS(3222),
    [anon_sym_interface] = ACTIONS(3222),
    [anon_sym_extension] = ACTIONS(3222),
    [anon_sym___exported] = ACTIONS(3222),
    [anon_sym_import] = ACTIONS(3222),
  },
  [597] = {
    [ts_builtin_sym_end] = ACTIONS(3380),
    [sym_identifier] = ACTIONS(3378),
    [aux_sym_preproc_include_token1] = ACTIONS(3378),
    [aux_sym_preproc_def_token1] = ACTIONS(3378),
    [aux_sym_preproc_if_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3378),
    [sym_preproc_directive] = ACTIONS(3378),
    [anon_sym_LPAREN2] = ACTIONS(3380),
    [anon_sym_BANG] = ACTIONS(3380),
    [anon_sym_TILDE] = ACTIONS(3380),
    [anon_sym_DASH] = ACTIONS(3378),
    [anon_sym_PLUS] = ACTIONS(3378),
    [anon_sym_STAR] = ACTIONS(3380),
    [anon_sym_AMP_AMP] = ACTIONS(3380),
    [anon_sym_AMP] = ACTIONS(3378),
    [anon_sym_SEMI] = ACTIONS(3380),
    [anon_sym___extension__] = ACTIONS(3378),
    [anon_sym_typedef] = ACTIONS(3378),
    [anon_sym_in] = ACTIONS(3378),
    [anon_sym_out] = ACTIONS(3378),
    [anon_sym_inout] = ACTIONS(3378),
    [anon_sym_extern] = ACTIONS(3378),
    [anon_sym___attribute__] = ACTIONS(3378),
    [anon_sym_COLON_COLON] = ACTIONS(3380),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3380),
    [anon_sym___declspec] = ACTIONS(3378),
    [anon_sym___based] = ACTIONS(3378),
    [anon_sym___cdecl] = ACTIONS(3378),
    [anon_sym___clrcall] = ACTIONS(3378),
    [anon_sym___stdcall] = ACTIONS(3378),
    [anon_sym___fastcall] = ACTIONS(3378),
    [anon_sym___thiscall] = ACTIONS(3378),
    [anon_sym___vectorcall] = ACTIONS(3378),
    [anon_sym_LBRACE] = ACTIONS(3380),
    [anon_sym_signed] = ACTIONS(3378),
    [anon_sym_unsigned] = ACTIONS(3378),
    [anon_sym_long] = ACTIONS(3378),
    [anon_sym_short] = ACTIONS(3378),
    [anon_sym_LBRACK] = ACTIONS(3378),
    [anon_sym_static] = ACTIONS(3378),
    [anon_sym_register] = ACTIONS(3378),
    [anon_sym_inline] = ACTIONS(3378),
    [anon_sym___inline] = ACTIONS(3378),
    [anon_sym___inline__] = ACTIONS(3378),
    [anon_sym___forceinline] = ACTIONS(3378),
    [anon_sym_thread_local] = ACTIONS(3378),
    [anon_sym___thread] = ACTIONS(3378),
    [anon_sym_const] = ACTIONS(3378),
    [anon_sym_constexpr] = ACTIONS(3378),
    [anon_sym_volatile] = ACTIONS(3378),
    [anon_sym_restrict] = ACTIONS(3378),
    [anon_sym___restrict__] = ACTIONS(3378),
    [anon_sym__Atomic] = ACTIONS(3378),
    [anon_sym__Noreturn] = ACTIONS(3378),
    [anon_sym_noreturn] = ACTIONS(3378),
    [anon_sym_mutable] = ACTIONS(3378),
    [anon_sym_constinit] = ACTIONS(3378),
    [anon_sym_consteval] = ACTIONS(3378),
    [anon_sym_alignas] = ACTIONS(3378),
    [anon_sym__Alignas] = ACTIONS(3378),
    [sym_primitive_type] = ACTIONS(3378),
    [anon_sym_enum] = ACTIONS(3378),
    [anon_sym_class] = ACTIONS(3378),
    [anon_sym_struct] = ACTIONS(3378),
    [anon_sym_union] = ACTIONS(3378),
    [anon_sym_if] = ACTIONS(3378),
    [anon_sym_else] = ACTIONS(3378),
    [anon_sym_switch] = ACTIONS(3378),
    [anon_sym_case] = ACTIONS(3378),
    [anon_sym_default] = ACTIONS(3378),
    [anon_sym_while] = ACTIONS(3378),
    [anon_sym_do] = ACTIONS(3378),
    [anon_sym_for] = ACTIONS(3378),
    [anon_sym_return] = ACTIONS(3378),
    [anon_sym_break] = ACTIONS(3378),
    [anon_sym_continue] = ACTIONS(3378),
    [anon_sym_goto] = ACTIONS(3378),
    [anon_sym___try] = ACTIONS(3378),
    [anon_sym___leave] = ACTIONS(3378),
    [anon_sym_not] = ACTIONS(3378),
    [anon_sym_compl] = ACTIONS(3378),
    [anon_sym_DASH_DASH] = ACTIONS(3380),
    [anon_sym_PLUS_PLUS] = ACTIONS(3380),
    [anon_sym_sizeof] = ACTIONS(3378),
    [anon_sym___alignof__] = ACTIONS(3378),
    [anon_sym___alignof] = ACTIONS(3378),
    [anon_sym__alignof] = ACTIONS(3378),
    [anon_sym_alignof] = ACTIONS(3378),
    [anon_sym__Alignof] = ACTIONS(3378),
    [anon_sym_offsetof] = ACTIONS(3378),
    [anon_sym__Generic] = ACTIONS(3378),
    [anon_sym_asm] = ACTIONS(3378),
    [anon_sym___asm__] = ACTIONS(3378),
    [sym_number_literal] = ACTIONS(3380),
    [anon_sym_L_SQUOTE] = ACTIONS(3380),
    [anon_sym_u_SQUOTE] = ACTIONS(3380),
    [anon_sym_U_SQUOTE] = ACTIONS(3380),
    [anon_sym_u8_SQUOTE] = ACTIONS(3380),
    [anon_sym_SQUOTE] = ACTIONS(3380),
    [anon_sym_L_DQUOTE] = ACTIONS(3380),
    [anon_sym_u_DQUOTE] = ACTIONS(3380),
    [anon_sym_U_DQUOTE] = ACTIONS(3380),
    [anon_sym_u8_DQUOTE] = ACTIONS(3380),
    [anon_sym_DQUOTE] = ACTIONS(3380),
    [sym_true] = ACTIONS(3378),
    [sym_false] = ACTIONS(3378),
    [anon_sym_NULL] = ACTIONS(3378),
    [anon_sym_nullptr] = ACTIONS(3378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3378),
    [anon_sym_let] = ACTIONS(3378),
    [anon_sym_This] = ACTIONS(3378),
    [anon_sym_decltype] = ACTIONS(3378),
    [sym_virtual] = ACTIONS(3378),
    [anon_sym_explicit] = ACTIONS(3378),
    [anon_sym_typename] = ACTIONS(3378),
    [anon_sym_template] = ACTIONS(3378),
    [anon_sym_operator] = ACTIONS(3378),
    [anon_sym_try] = ACTIONS(3378),
    [anon_sym_delete] = ACTIONS(3378),
    [anon_sym_throw] = ACTIONS(3378),
    [anon_sym_namespace] = ACTIONS(3378),
    [anon_sym_using] = ACTIONS(3378),
    [anon_sym_static_assert] = ACTIONS(3378),
    [anon_sym_concept] = ACTIONS(3378),
    [anon_sym_co_return] = ACTIONS(3378),
    [anon_sym_co_yield] = ACTIONS(3378),
    [anon_sym_R_DQUOTE] = ACTIONS(3380),
    [anon_sym_LR_DQUOTE] = ACTIONS(3380),
    [anon_sym_uR_DQUOTE] = ACTIONS(3380),
    [anon_sym_UR_DQUOTE] = ACTIONS(3380),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3380),
    [anon_sym_co_await] = ACTIONS(3378),
    [anon_sym_new] = ACTIONS(3378),
    [anon_sym_requires] = ACTIONS(3378),
    [sym_this] = ACTIONS(3378),
    [anon_sym_discard] = ACTIONS(3378),
    [anon_sym_precise] = ACTIONS(3378),
    [anon_sym_shared] = ACTIONS(3378),
    [anon_sym_groupshared] = ACTIONS(3378),
    [anon_sym_uniform] = ACTIONS(3378),
    [anon_sym_row_major] = ACTIONS(3378),
    [anon_sym_column_major] = ACTIONS(3378),
    [anon_sym_globallycoherent] = ACTIONS(3378),
    [anon_sym_centroid] = ACTIONS(3378),
    [anon_sym_noperspective] = ACTIONS(3378),
    [anon_sym_nointerpolation] = ACTIONS(3378),
    [anon_sym_sample] = ACTIONS(3378),
    [anon_sym_linear] = ACTIONS(3378),
    [anon_sym_snorm] = ACTIONS(3378),
    [anon_sym_unorm] = ACTIONS(3378),
    [anon_sym_point] = ACTIONS(3378),
    [anon_sym_line] = ACTIONS(3378),
    [anon_sym_triangleadj] = ACTIONS(3378),
    [anon_sym_lineadj] = ACTIONS(3378),
    [anon_sym_triangle] = ACTIONS(3378),
    [anon_sym_cbuffer] = ACTIONS(3378),
    [anon_sym_interface] = ACTIONS(3378),
    [anon_sym_extension] = ACTIONS(3378),
    [anon_sym___exported] = ACTIONS(3378),
    [anon_sym_import] = ACTIONS(3378),
  },
  [598] = {
    [ts_builtin_sym_end] = ACTIONS(2980),
    [sym_identifier] = ACTIONS(2978),
    [aux_sym_preproc_include_token1] = ACTIONS(2978),
    [aux_sym_preproc_def_token1] = ACTIONS(2978),
    [aux_sym_preproc_if_token1] = ACTIONS(2978),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2978),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2978),
    [sym_preproc_directive] = ACTIONS(2978),
    [anon_sym_LPAREN2] = ACTIONS(2980),
    [anon_sym_BANG] = ACTIONS(2980),
    [anon_sym_TILDE] = ACTIONS(2980),
    [anon_sym_DASH] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_STAR] = ACTIONS(2980),
    [anon_sym_AMP_AMP] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2978),
    [anon_sym_SEMI] = ACTIONS(2980),
    [anon_sym___extension__] = ACTIONS(2978),
    [anon_sym_typedef] = ACTIONS(2978),
    [anon_sym_in] = ACTIONS(2978),
    [anon_sym_out] = ACTIONS(2978),
    [anon_sym_inout] = ACTIONS(2978),
    [anon_sym_extern] = ACTIONS(2978),
    [anon_sym___attribute__] = ACTIONS(2978),
    [anon_sym_COLON_COLON] = ACTIONS(2980),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2980),
    [anon_sym___declspec] = ACTIONS(2978),
    [anon_sym___based] = ACTIONS(2978),
    [anon_sym___cdecl] = ACTIONS(2978),
    [anon_sym___clrcall] = ACTIONS(2978),
    [anon_sym___stdcall] = ACTIONS(2978),
    [anon_sym___fastcall] = ACTIONS(2978),
    [anon_sym___thiscall] = ACTIONS(2978),
    [anon_sym___vectorcall] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(2980),
    [anon_sym_signed] = ACTIONS(2978),
    [anon_sym_unsigned] = ACTIONS(2978),
    [anon_sym_long] = ACTIONS(2978),
    [anon_sym_short] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_static] = ACTIONS(2978),
    [anon_sym_register] = ACTIONS(2978),
    [anon_sym_inline] = ACTIONS(2978),
    [anon_sym___inline] = ACTIONS(2978),
    [anon_sym___inline__] = ACTIONS(2978),
    [anon_sym___forceinline] = ACTIONS(2978),
    [anon_sym_thread_local] = ACTIONS(2978),
    [anon_sym___thread] = ACTIONS(2978),
    [anon_sym_const] = ACTIONS(2978),
    [anon_sym_constexpr] = ACTIONS(2978),
    [anon_sym_volatile] = ACTIONS(2978),
    [anon_sym_restrict] = ACTIONS(2978),
    [anon_sym___restrict__] = ACTIONS(2978),
    [anon_sym__Atomic] = ACTIONS(2978),
    [anon_sym__Noreturn] = ACTIONS(2978),
    [anon_sym_noreturn] = ACTIONS(2978),
    [anon_sym_mutable] = ACTIONS(2978),
    [anon_sym_constinit] = ACTIONS(2978),
    [anon_sym_consteval] = ACTIONS(2978),
    [anon_sym_alignas] = ACTIONS(2978),
    [anon_sym__Alignas] = ACTIONS(2978),
    [sym_primitive_type] = ACTIONS(2978),
    [anon_sym_enum] = ACTIONS(2978),
    [anon_sym_class] = ACTIONS(2978),
    [anon_sym_struct] = ACTIONS(2978),
    [anon_sym_union] = ACTIONS(2978),
    [anon_sym_if] = ACTIONS(2978),
    [anon_sym_else] = ACTIONS(2978),
    [anon_sym_switch] = ACTIONS(2978),
    [anon_sym_case] = ACTIONS(2978),
    [anon_sym_default] = ACTIONS(2978),
    [anon_sym_while] = ACTIONS(2978),
    [anon_sym_do] = ACTIONS(2978),
    [anon_sym_for] = ACTIONS(2978),
    [anon_sym_return] = ACTIONS(2978),
    [anon_sym_break] = ACTIONS(2978),
    [anon_sym_continue] = ACTIONS(2978),
    [anon_sym_goto] = ACTIONS(2978),
    [anon_sym___try] = ACTIONS(2978),
    [anon_sym___leave] = ACTIONS(2978),
    [anon_sym_not] = ACTIONS(2978),
    [anon_sym_compl] = ACTIONS(2978),
    [anon_sym_DASH_DASH] = ACTIONS(2980),
    [anon_sym_PLUS_PLUS] = ACTIONS(2980),
    [anon_sym_sizeof] = ACTIONS(2978),
    [anon_sym___alignof__] = ACTIONS(2978),
    [anon_sym___alignof] = ACTIONS(2978),
    [anon_sym__alignof] = ACTIONS(2978),
    [anon_sym_alignof] = ACTIONS(2978),
    [anon_sym__Alignof] = ACTIONS(2978),
    [anon_sym_offsetof] = ACTIONS(2978),
    [anon_sym__Generic] = ACTIONS(2978),
    [anon_sym_asm] = ACTIONS(2978),
    [anon_sym___asm__] = ACTIONS(2978),
    [sym_number_literal] = ACTIONS(2980),
    [anon_sym_L_SQUOTE] = ACTIONS(2980),
    [anon_sym_u_SQUOTE] = ACTIONS(2980),
    [anon_sym_U_SQUOTE] = ACTIONS(2980),
    [anon_sym_u8_SQUOTE] = ACTIONS(2980),
    [anon_sym_SQUOTE] = ACTIONS(2980),
    [anon_sym_L_DQUOTE] = ACTIONS(2980),
    [anon_sym_u_DQUOTE] = ACTIONS(2980),
    [anon_sym_U_DQUOTE] = ACTIONS(2980),
    [anon_sym_u8_DQUOTE] = ACTIONS(2980),
    [anon_sym_DQUOTE] = ACTIONS(2980),
    [sym_true] = ACTIONS(2978),
    [sym_false] = ACTIONS(2978),
    [anon_sym_NULL] = ACTIONS(2978),
    [anon_sym_nullptr] = ACTIONS(2978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2978),
    [anon_sym_let] = ACTIONS(2978),
    [anon_sym_This] = ACTIONS(2978),
    [anon_sym_decltype] = ACTIONS(2978),
    [sym_virtual] = ACTIONS(2978),
    [anon_sym_explicit] = ACTIONS(2978),
    [anon_sym_typename] = ACTIONS(2978),
    [anon_sym_template] = ACTIONS(2978),
    [anon_sym_operator] = ACTIONS(2978),
    [anon_sym_try] = ACTIONS(2978),
    [anon_sym_delete] = ACTIONS(2978),
    [anon_sym_throw] = ACTIONS(2978),
    [anon_sym_namespace] = ACTIONS(2978),
    [anon_sym_using] = ACTIONS(2978),
    [anon_sym_static_assert] = ACTIONS(2978),
    [anon_sym_concept] = ACTIONS(2978),
    [anon_sym_co_return] = ACTIONS(2978),
    [anon_sym_co_yield] = ACTIONS(2978),
    [anon_sym_R_DQUOTE] = ACTIONS(2980),
    [anon_sym_LR_DQUOTE] = ACTIONS(2980),
    [anon_sym_uR_DQUOTE] = ACTIONS(2980),
    [anon_sym_UR_DQUOTE] = ACTIONS(2980),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2980),
    [anon_sym_co_await] = ACTIONS(2978),
    [anon_sym_new] = ACTIONS(2978),
    [anon_sym_requires] = ACTIONS(2978),
    [sym_this] = ACTIONS(2978),
    [anon_sym_discard] = ACTIONS(2978),
    [anon_sym_precise] = ACTIONS(2978),
    [anon_sym_shared] = ACTIONS(2978),
    [anon_sym_groupshared] = ACTIONS(2978),
    [anon_sym_uniform] = ACTIONS(2978),
    [anon_sym_row_major] = ACTIONS(2978),
    [anon_sym_column_major] = ACTIONS(2978),
    [anon_sym_globallycoherent] = ACTIONS(2978),
    [anon_sym_centroid] = ACTIONS(2978),
    [anon_sym_noperspective] = ACTIONS(2978),
    [anon_sym_nointerpolation] = ACTIONS(2978),
    [anon_sym_sample] = ACTIONS(2978),
    [anon_sym_linear] = ACTIONS(2978),
    [anon_sym_snorm] = ACTIONS(2978),
    [anon_sym_unorm] = ACTIONS(2978),
    [anon_sym_point] = ACTIONS(2978),
    [anon_sym_line] = ACTIONS(2978),
    [anon_sym_triangleadj] = ACTIONS(2978),
    [anon_sym_lineadj] = ACTIONS(2978),
    [anon_sym_triangle] = ACTIONS(2978),
    [anon_sym_cbuffer] = ACTIONS(2978),
    [anon_sym_interface] = ACTIONS(2978),
    [anon_sym_extension] = ACTIONS(2978),
    [anon_sym___exported] = ACTIONS(2978),
    [anon_sym_import] = ACTIONS(2978),
  },
  [599] = {
    [ts_builtin_sym_end] = ACTIONS(3240),
    [sym_identifier] = ACTIONS(3238),
    [aux_sym_preproc_include_token1] = ACTIONS(3238),
    [aux_sym_preproc_def_token1] = ACTIONS(3238),
    [aux_sym_preproc_if_token1] = ACTIONS(3238),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3238),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3238),
    [sym_preproc_directive] = ACTIONS(3238),
    [anon_sym_LPAREN2] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3238),
    [anon_sym_PLUS] = ACTIONS(3238),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_AMP_AMP] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(3238),
    [anon_sym_SEMI] = ACTIONS(3240),
    [anon_sym___extension__] = ACTIONS(3238),
    [anon_sym_typedef] = ACTIONS(3238),
    [anon_sym_in] = ACTIONS(3238),
    [anon_sym_out] = ACTIONS(3238),
    [anon_sym_inout] = ACTIONS(3238),
    [anon_sym_extern] = ACTIONS(3238),
    [anon_sym___attribute__] = ACTIONS(3238),
    [anon_sym_COLON_COLON] = ACTIONS(3240),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3240),
    [anon_sym___declspec] = ACTIONS(3238),
    [anon_sym___based] = ACTIONS(3238),
    [anon_sym___cdecl] = ACTIONS(3238),
    [anon_sym___clrcall] = ACTIONS(3238),
    [anon_sym___stdcall] = ACTIONS(3238),
    [anon_sym___fastcall] = ACTIONS(3238),
    [anon_sym___thiscall] = ACTIONS(3238),
    [anon_sym___vectorcall] = ACTIONS(3238),
    [anon_sym_LBRACE] = ACTIONS(3240),
    [anon_sym_signed] = ACTIONS(3238),
    [anon_sym_unsigned] = ACTIONS(3238),
    [anon_sym_long] = ACTIONS(3238),
    [anon_sym_short] = ACTIONS(3238),
    [anon_sym_LBRACK] = ACTIONS(3238),
    [anon_sym_static] = ACTIONS(3238),
    [anon_sym_register] = ACTIONS(3238),
    [anon_sym_inline] = ACTIONS(3238),
    [anon_sym___inline] = ACTIONS(3238),
    [anon_sym___inline__] = ACTIONS(3238),
    [anon_sym___forceinline] = ACTIONS(3238),
    [anon_sym_thread_local] = ACTIONS(3238),
    [anon_sym___thread] = ACTIONS(3238),
    [anon_sym_const] = ACTIONS(3238),
    [anon_sym_constexpr] = ACTIONS(3238),
    [anon_sym_volatile] = ACTIONS(3238),
    [anon_sym_restrict] = ACTIONS(3238),
    [anon_sym___restrict__] = ACTIONS(3238),
    [anon_sym__Atomic] = ACTIONS(3238),
    [anon_sym__Noreturn] = ACTIONS(3238),
    [anon_sym_noreturn] = ACTIONS(3238),
    [anon_sym_mutable] = ACTIONS(3238),
    [anon_sym_constinit] = ACTIONS(3238),
    [anon_sym_consteval] = ACTIONS(3238),
    [anon_sym_alignas] = ACTIONS(3238),
    [anon_sym__Alignas] = ACTIONS(3238),
    [sym_primitive_type] = ACTIONS(3238),
    [anon_sym_enum] = ACTIONS(3238),
    [anon_sym_class] = ACTIONS(3238),
    [anon_sym_struct] = ACTIONS(3238),
    [anon_sym_union] = ACTIONS(3238),
    [anon_sym_if] = ACTIONS(3238),
    [anon_sym_else] = ACTIONS(3238),
    [anon_sym_switch] = ACTIONS(3238),
    [anon_sym_case] = ACTIONS(3238),
    [anon_sym_default] = ACTIONS(3238),
    [anon_sym_while] = ACTIONS(3238),
    [anon_sym_do] = ACTIONS(3238),
    [anon_sym_for] = ACTIONS(3238),
    [anon_sym_return] = ACTIONS(3238),
    [anon_sym_break] = ACTIONS(3238),
    [anon_sym_continue] = ACTIONS(3238),
    [anon_sym_goto] = ACTIONS(3238),
    [anon_sym___try] = ACTIONS(3238),
    [anon_sym___leave] = ACTIONS(3238),
    [anon_sym_not] = ACTIONS(3238),
    [anon_sym_compl] = ACTIONS(3238),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_sizeof] = ACTIONS(3238),
    [anon_sym___alignof__] = ACTIONS(3238),
    [anon_sym___alignof] = ACTIONS(3238),
    [anon_sym__alignof] = ACTIONS(3238),
    [anon_sym_alignof] = ACTIONS(3238),
    [anon_sym__Alignof] = ACTIONS(3238),
    [anon_sym_offsetof] = ACTIONS(3238),
    [anon_sym__Generic] = ACTIONS(3238),
    [anon_sym_asm] = ACTIONS(3238),
    [anon_sym___asm__] = ACTIONS(3238),
    [sym_number_literal] = ACTIONS(3240),
    [anon_sym_L_SQUOTE] = ACTIONS(3240),
    [anon_sym_u_SQUOTE] = ACTIONS(3240),
    [anon_sym_U_SQUOTE] = ACTIONS(3240),
    [anon_sym_u8_SQUOTE] = ACTIONS(3240),
    [anon_sym_SQUOTE] = ACTIONS(3240),
    [anon_sym_L_DQUOTE] = ACTIONS(3240),
    [anon_sym_u_DQUOTE] = ACTIONS(3240),
    [anon_sym_U_DQUOTE] = ACTIONS(3240),
    [anon_sym_u8_DQUOTE] = ACTIONS(3240),
    [anon_sym_DQUOTE] = ACTIONS(3240),
    [sym_true] = ACTIONS(3238),
    [sym_false] = ACTIONS(3238),
    [anon_sym_NULL] = ACTIONS(3238),
    [anon_sym_nullptr] = ACTIONS(3238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3238),
    [anon_sym_let] = ACTIONS(3238),
    [anon_sym_This] = ACTIONS(3238),
    [anon_sym_decltype] = ACTIONS(3238),
    [sym_virtual] = ACTIONS(3238),
    [anon_sym_explicit] = ACTIONS(3238),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3238),
    [anon_sym_operator] = ACTIONS(3238),
    [anon_sym_try] = ACTIONS(3238),
    [anon_sym_delete] = ACTIONS(3238),
    [anon_sym_throw] = ACTIONS(3238),
    [anon_sym_namespace] = ACTIONS(3238),
    [anon_sym_using] = ACTIONS(3238),
    [anon_sym_static_assert] = ACTIONS(3238),
    [anon_sym_concept] = ACTIONS(3238),
    [anon_sym_co_return] = ACTIONS(3238),
    [anon_sym_co_yield] = ACTIONS(3238),
    [anon_sym_R_DQUOTE] = ACTIONS(3240),
    [anon_sym_LR_DQUOTE] = ACTIONS(3240),
    [anon_sym_uR_DQUOTE] = ACTIONS(3240),
    [anon_sym_UR_DQUOTE] = ACTIONS(3240),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3240),
    [anon_sym_co_await] = ACTIONS(3238),
    [anon_sym_new] = ACTIONS(3238),
    [anon_sym_requires] = ACTIONS(3238),
    [sym_this] = ACTIONS(3238),
    [anon_sym_discard] = ACTIONS(3238),
    [anon_sym_precise] = ACTIONS(3238),
    [anon_sym_shared] = ACTIONS(3238),
    [anon_sym_groupshared] = ACTIONS(3238),
    [anon_sym_uniform] = ACTIONS(3238),
    [anon_sym_row_major] = ACTIONS(3238),
    [anon_sym_column_major] = ACTIONS(3238),
    [anon_sym_globallycoherent] = ACTIONS(3238),
    [anon_sym_centroid] = ACTIONS(3238),
    [anon_sym_noperspective] = ACTIONS(3238),
    [anon_sym_nointerpolation] = ACTIONS(3238),
    [anon_sym_sample] = ACTIONS(3238),
    [anon_sym_linear] = ACTIONS(3238),
    [anon_sym_snorm] = ACTIONS(3238),
    [anon_sym_unorm] = ACTIONS(3238),
    [anon_sym_point] = ACTIONS(3238),
    [anon_sym_line] = ACTIONS(3238),
    [anon_sym_triangleadj] = ACTIONS(3238),
    [anon_sym_lineadj] = ACTIONS(3238),
    [anon_sym_triangle] = ACTIONS(3238),
    [anon_sym_cbuffer] = ACTIONS(3238),
    [anon_sym_interface] = ACTIONS(3238),
    [anon_sym_extension] = ACTIONS(3238),
    [anon_sym___exported] = ACTIONS(3238),
    [anon_sym_import] = ACTIONS(3238),
  },
  [600] = {
    [ts_builtin_sym_end] = ACTIONS(3180),
    [sym_identifier] = ACTIONS(3178),
    [aux_sym_preproc_include_token1] = ACTIONS(3178),
    [aux_sym_preproc_def_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3178),
    [sym_preproc_directive] = ACTIONS(3178),
    [anon_sym_LPAREN2] = ACTIONS(3180),
    [anon_sym_BANG] = ACTIONS(3180),
    [anon_sym_TILDE] = ACTIONS(3180),
    [anon_sym_DASH] = ACTIONS(3178),
    [anon_sym_PLUS] = ACTIONS(3178),
    [anon_sym_STAR] = ACTIONS(3180),
    [anon_sym_AMP_AMP] = ACTIONS(3180),
    [anon_sym_AMP] = ACTIONS(3178),
    [anon_sym_SEMI] = ACTIONS(3180),
    [anon_sym___extension__] = ACTIONS(3178),
    [anon_sym_typedef] = ACTIONS(3178),
    [anon_sym_in] = ACTIONS(3178),
    [anon_sym_out] = ACTIONS(3178),
    [anon_sym_inout] = ACTIONS(3178),
    [anon_sym_extern] = ACTIONS(3178),
    [anon_sym___attribute__] = ACTIONS(3178),
    [anon_sym_COLON_COLON] = ACTIONS(3180),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3180),
    [anon_sym___declspec] = ACTIONS(3178),
    [anon_sym___based] = ACTIONS(3178),
    [anon_sym___cdecl] = ACTIONS(3178),
    [anon_sym___clrcall] = ACTIONS(3178),
    [anon_sym___stdcall] = ACTIONS(3178),
    [anon_sym___fastcall] = ACTIONS(3178),
    [anon_sym___thiscall] = ACTIONS(3178),
    [anon_sym___vectorcall] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(3180),
    [anon_sym_signed] = ACTIONS(3178),
    [anon_sym_unsigned] = ACTIONS(3178),
    [anon_sym_long] = ACTIONS(3178),
    [anon_sym_short] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(3178),
    [anon_sym_static] = ACTIONS(3178),
    [anon_sym_register] = ACTIONS(3178),
    [anon_sym_inline] = ACTIONS(3178),
    [anon_sym___inline] = ACTIONS(3178),
    [anon_sym___inline__] = ACTIONS(3178),
    [anon_sym___forceinline] = ACTIONS(3178),
    [anon_sym_thread_local] = ACTIONS(3178),
    [anon_sym___thread] = ACTIONS(3178),
    [anon_sym_const] = ACTIONS(3178),
    [anon_sym_constexpr] = ACTIONS(3178),
    [anon_sym_volatile] = ACTIONS(3178),
    [anon_sym_restrict] = ACTIONS(3178),
    [anon_sym___restrict__] = ACTIONS(3178),
    [anon_sym__Atomic] = ACTIONS(3178),
    [anon_sym__Noreturn] = ACTIONS(3178),
    [anon_sym_noreturn] = ACTIONS(3178),
    [anon_sym_mutable] = ACTIONS(3178),
    [anon_sym_constinit] = ACTIONS(3178),
    [anon_sym_consteval] = ACTIONS(3178),
    [anon_sym_alignas] = ACTIONS(3178),
    [anon_sym__Alignas] = ACTIONS(3178),
    [sym_primitive_type] = ACTIONS(3178),
    [anon_sym_enum] = ACTIONS(3178),
    [anon_sym_class] = ACTIONS(3178),
    [anon_sym_struct] = ACTIONS(3178),
    [anon_sym_union] = ACTIONS(3178),
    [anon_sym_if] = ACTIONS(3178),
    [anon_sym_else] = ACTIONS(3178),
    [anon_sym_switch] = ACTIONS(3178),
    [anon_sym_case] = ACTIONS(3178),
    [anon_sym_default] = ACTIONS(3178),
    [anon_sym_while] = ACTIONS(3178),
    [anon_sym_do] = ACTIONS(3178),
    [anon_sym_for] = ACTIONS(3178),
    [anon_sym_return] = ACTIONS(3178),
    [anon_sym_break] = ACTIONS(3178),
    [anon_sym_continue] = ACTIONS(3178),
    [anon_sym_goto] = ACTIONS(3178),
    [anon_sym___try] = ACTIONS(3178),
    [anon_sym___leave] = ACTIONS(3178),
    [anon_sym_not] = ACTIONS(3178),
    [anon_sym_compl] = ACTIONS(3178),
    [anon_sym_DASH_DASH] = ACTIONS(3180),
    [anon_sym_PLUS_PLUS] = ACTIONS(3180),
    [anon_sym_sizeof] = ACTIONS(3178),
    [anon_sym___alignof__] = ACTIONS(3178),
    [anon_sym___alignof] = ACTIONS(3178),
    [anon_sym__alignof] = ACTIONS(3178),
    [anon_sym_alignof] = ACTIONS(3178),
    [anon_sym__Alignof] = ACTIONS(3178),
    [anon_sym_offsetof] = ACTIONS(3178),
    [anon_sym__Generic] = ACTIONS(3178),
    [anon_sym_asm] = ACTIONS(3178),
    [anon_sym___asm__] = ACTIONS(3178),
    [sym_number_literal] = ACTIONS(3180),
    [anon_sym_L_SQUOTE] = ACTIONS(3180),
    [anon_sym_u_SQUOTE] = ACTIONS(3180),
    [anon_sym_U_SQUOTE] = ACTIONS(3180),
    [anon_sym_u8_SQUOTE] = ACTIONS(3180),
    [anon_sym_SQUOTE] = ACTIONS(3180),
    [anon_sym_L_DQUOTE] = ACTIONS(3180),
    [anon_sym_u_DQUOTE] = ACTIONS(3180),
    [anon_sym_U_DQUOTE] = ACTIONS(3180),
    [anon_sym_u8_DQUOTE] = ACTIONS(3180),
    [anon_sym_DQUOTE] = ACTIONS(3180),
    [sym_true] = ACTIONS(3178),
    [sym_false] = ACTIONS(3178),
    [anon_sym_NULL] = ACTIONS(3178),
    [anon_sym_nullptr] = ACTIONS(3178),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3178),
    [anon_sym_let] = ACTIONS(3178),
    [anon_sym_This] = ACTIONS(3178),
    [anon_sym_decltype] = ACTIONS(3178),
    [sym_virtual] = ACTIONS(3178),
    [anon_sym_explicit] = ACTIONS(3178),
    [anon_sym_typename] = ACTIONS(3178),
    [anon_sym_template] = ACTIONS(3178),
    [anon_sym_operator] = ACTIONS(3178),
    [anon_sym_try] = ACTIONS(3178),
    [anon_sym_delete] = ACTIONS(3178),
    [anon_sym_throw] = ACTIONS(3178),
    [anon_sym_namespace] = ACTIONS(3178),
    [anon_sym_using] = ACTIONS(3178),
    [anon_sym_static_assert] = ACTIONS(3178),
    [anon_sym_concept] = ACTIONS(3178),
    [anon_sym_co_return] = ACTIONS(3178),
    [anon_sym_co_yield] = ACTIONS(3178),
    [anon_sym_R_DQUOTE] = ACTIONS(3180),
    [anon_sym_LR_DQUOTE] = ACTIONS(3180),
    [anon_sym_uR_DQUOTE] = ACTIONS(3180),
    [anon_sym_UR_DQUOTE] = ACTIONS(3180),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3180),
    [anon_sym_co_await] = ACTIONS(3178),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3178),
    [sym_this] = ACTIONS(3178),
    [anon_sym_discard] = ACTIONS(3178),
    [anon_sym_precise] = ACTIONS(3178),
    [anon_sym_shared] = ACTIONS(3178),
    [anon_sym_groupshared] = ACTIONS(3178),
    [anon_sym_uniform] = ACTIONS(3178),
    [anon_sym_row_major] = ACTIONS(3178),
    [anon_sym_column_major] = ACTIONS(3178),
    [anon_sym_globallycoherent] = ACTIONS(3178),
    [anon_sym_centroid] = ACTIONS(3178),
    [anon_sym_noperspective] = ACTIONS(3178),
    [anon_sym_nointerpolation] = ACTIONS(3178),
    [anon_sym_sample] = ACTIONS(3178),
    [anon_sym_linear] = ACTIONS(3178),
    [anon_sym_snorm] = ACTIONS(3178),
    [anon_sym_unorm] = ACTIONS(3178),
    [anon_sym_point] = ACTIONS(3178),
    [anon_sym_line] = ACTIONS(3178),
    [anon_sym_triangleadj] = ACTIONS(3178),
    [anon_sym_lineadj] = ACTIONS(3178),
    [anon_sym_triangle] = ACTIONS(3178),
    [anon_sym_cbuffer] = ACTIONS(3178),
    [anon_sym_interface] = ACTIONS(3178),
    [anon_sym_extension] = ACTIONS(3178),
    [anon_sym___exported] = ACTIONS(3178),
    [anon_sym_import] = ACTIONS(3178),
  },
  [601] = {
    [ts_builtin_sym_end] = ACTIONS(3232),
    [sym_identifier] = ACTIONS(3230),
    [aux_sym_preproc_include_token1] = ACTIONS(3230),
    [aux_sym_preproc_def_token1] = ACTIONS(3230),
    [aux_sym_preproc_if_token1] = ACTIONS(3230),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3230),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3230),
    [sym_preproc_directive] = ACTIONS(3230),
    [anon_sym_LPAREN2] = ACTIONS(3232),
    [anon_sym_BANG] = ACTIONS(3232),
    [anon_sym_TILDE] = ACTIONS(3232),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_STAR] = ACTIONS(3232),
    [anon_sym_AMP_AMP] = ACTIONS(3232),
    [anon_sym_AMP] = ACTIONS(3230),
    [anon_sym_SEMI] = ACTIONS(3232),
    [anon_sym___extension__] = ACTIONS(3230),
    [anon_sym_typedef] = ACTIONS(3230),
    [anon_sym_in] = ACTIONS(3230),
    [anon_sym_out] = ACTIONS(3230),
    [anon_sym_inout] = ACTIONS(3230),
    [anon_sym_extern] = ACTIONS(3230),
    [anon_sym___attribute__] = ACTIONS(3230),
    [anon_sym_COLON_COLON] = ACTIONS(3232),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3232),
    [anon_sym___declspec] = ACTIONS(3230),
    [anon_sym___based] = ACTIONS(3230),
    [anon_sym___cdecl] = ACTIONS(3230),
    [anon_sym___clrcall] = ACTIONS(3230),
    [anon_sym___stdcall] = ACTIONS(3230),
    [anon_sym___fastcall] = ACTIONS(3230),
    [anon_sym___thiscall] = ACTIONS(3230),
    [anon_sym___vectorcall] = ACTIONS(3230),
    [anon_sym_LBRACE] = ACTIONS(3232),
    [anon_sym_signed] = ACTIONS(3230),
    [anon_sym_unsigned] = ACTIONS(3230),
    [anon_sym_long] = ACTIONS(3230),
    [anon_sym_short] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_static] = ACTIONS(3230),
    [anon_sym_register] = ACTIONS(3230),
    [anon_sym_inline] = ACTIONS(3230),
    [anon_sym___inline] = ACTIONS(3230),
    [anon_sym___inline__] = ACTIONS(3230),
    [anon_sym___forceinline] = ACTIONS(3230),
    [anon_sym_thread_local] = ACTIONS(3230),
    [anon_sym___thread] = ACTIONS(3230),
    [anon_sym_const] = ACTIONS(3230),
    [anon_sym_constexpr] = ACTIONS(3230),
    [anon_sym_volatile] = ACTIONS(3230),
    [anon_sym_restrict] = ACTIONS(3230),
    [anon_sym___restrict__] = ACTIONS(3230),
    [anon_sym__Atomic] = ACTIONS(3230),
    [anon_sym__Noreturn] = ACTIONS(3230),
    [anon_sym_noreturn] = ACTIONS(3230),
    [anon_sym_mutable] = ACTIONS(3230),
    [anon_sym_constinit] = ACTIONS(3230),
    [anon_sym_consteval] = ACTIONS(3230),
    [anon_sym_alignas] = ACTIONS(3230),
    [anon_sym__Alignas] = ACTIONS(3230),
    [sym_primitive_type] = ACTIONS(3230),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3230),
    [anon_sym_struct] = ACTIONS(3230),
    [anon_sym_union] = ACTIONS(3230),
    [anon_sym_if] = ACTIONS(3230),
    [anon_sym_else] = ACTIONS(3230),
    [anon_sym_switch] = ACTIONS(3230),
    [anon_sym_case] = ACTIONS(3230),
    [anon_sym_default] = ACTIONS(3230),
    [anon_sym_while] = ACTIONS(3230),
    [anon_sym_do] = ACTIONS(3230),
    [anon_sym_for] = ACTIONS(3230),
    [anon_sym_return] = ACTIONS(3230),
    [anon_sym_break] = ACTIONS(3230),
    [anon_sym_continue] = ACTIONS(3230),
    [anon_sym_goto] = ACTIONS(3230),
    [anon_sym___try] = ACTIONS(3230),
    [anon_sym___leave] = ACTIONS(3230),
    [anon_sym_not] = ACTIONS(3230),
    [anon_sym_compl] = ACTIONS(3230),
    [anon_sym_DASH_DASH] = ACTIONS(3232),
    [anon_sym_PLUS_PLUS] = ACTIONS(3232),
    [anon_sym_sizeof] = ACTIONS(3230),
    [anon_sym___alignof__] = ACTIONS(3230),
    [anon_sym___alignof] = ACTIONS(3230),
    [anon_sym__alignof] = ACTIONS(3230),
    [anon_sym_alignof] = ACTIONS(3230),
    [anon_sym__Alignof] = ACTIONS(3230),
    [anon_sym_offsetof] = ACTIONS(3230),
    [anon_sym__Generic] = ACTIONS(3230),
    [anon_sym_asm] = ACTIONS(3230),
    [anon_sym___asm__] = ACTIONS(3230),
    [sym_number_literal] = ACTIONS(3232),
    [anon_sym_L_SQUOTE] = ACTIONS(3232),
    [anon_sym_u_SQUOTE] = ACTIONS(3232),
    [anon_sym_U_SQUOTE] = ACTIONS(3232),
    [anon_sym_u8_SQUOTE] = ACTIONS(3232),
    [anon_sym_SQUOTE] = ACTIONS(3232),
    [anon_sym_L_DQUOTE] = ACTIONS(3232),
    [anon_sym_u_DQUOTE] = ACTIONS(3232),
    [anon_sym_U_DQUOTE] = ACTIONS(3232),
    [anon_sym_u8_DQUOTE] = ACTIONS(3232),
    [anon_sym_DQUOTE] = ACTIONS(3232),
    [sym_true] = ACTIONS(3230),
    [sym_false] = ACTIONS(3230),
    [anon_sym_NULL] = ACTIONS(3230),
    [anon_sym_nullptr] = ACTIONS(3230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3230),
    [anon_sym_let] = ACTIONS(3230),
    [anon_sym_This] = ACTIONS(3230),
    [anon_sym_decltype] = ACTIONS(3230),
    [sym_virtual] = ACTIONS(3230),
    [anon_sym_explicit] = ACTIONS(3230),
    [anon_sym_typename] = ACTIONS(3230),
    [anon_sym_template] = ACTIONS(3230),
    [anon_sym_operator] = ACTIONS(3230),
    [anon_sym_try] = ACTIONS(3230),
    [anon_sym_delete] = ACTIONS(3230),
    [anon_sym_throw] = ACTIONS(3230),
    [anon_sym_namespace] = ACTIONS(3230),
    [anon_sym_using] = ACTIONS(3230),
    [anon_sym_static_assert] = ACTIONS(3230),
    [anon_sym_concept] = ACTIONS(3230),
    [anon_sym_co_return] = ACTIONS(3230),
    [anon_sym_co_yield] = ACTIONS(3230),
    [anon_sym_R_DQUOTE] = ACTIONS(3232),
    [anon_sym_LR_DQUOTE] = ACTIONS(3232),
    [anon_sym_uR_DQUOTE] = ACTIONS(3232),
    [anon_sym_UR_DQUOTE] = ACTIONS(3232),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3232),
    [anon_sym_co_await] = ACTIONS(3230),
    [anon_sym_new] = ACTIONS(3230),
    [anon_sym_requires] = ACTIONS(3230),
    [sym_this] = ACTIONS(3230),
    [anon_sym_discard] = ACTIONS(3230),
    [anon_sym_precise] = ACTIONS(3230),
    [anon_sym_shared] = ACTIONS(3230),
    [anon_sym_groupshared] = ACTIONS(3230),
    [anon_sym_uniform] = ACTIONS(3230),
    [anon_sym_row_major] = ACTIONS(3230),
    [anon_sym_column_major] = ACTIONS(3230),
    [anon_sym_globallycoherent] = ACTIONS(3230),
    [anon_sym_centroid] = ACTIONS(3230),
    [anon_sym_noperspective] = ACTIONS(3230),
    [anon_sym_nointerpolation] = ACTIONS(3230),
    [anon_sym_sample] = ACTIONS(3230),
    [anon_sym_linear] = ACTIONS(3230),
    [anon_sym_snorm] = ACTIONS(3230),
    [anon_sym_unorm] = ACTIONS(3230),
    [anon_sym_point] = ACTIONS(3230),
    [anon_sym_line] = ACTIONS(3230),
    [anon_sym_triangleadj] = ACTIONS(3230),
    [anon_sym_lineadj] = ACTIONS(3230),
    [anon_sym_triangle] = ACTIONS(3230),
    [anon_sym_cbuffer] = ACTIONS(3230),
    [anon_sym_interface] = ACTIONS(3230),
    [anon_sym_extension] = ACTIONS(3230),
    [anon_sym___exported] = ACTIONS(3230),
    [anon_sym_import] = ACTIONS(3230),
  },
  [602] = {
    [ts_builtin_sym_end] = ACTIONS(3228),
    [sym_identifier] = ACTIONS(3226),
    [aux_sym_preproc_include_token1] = ACTIONS(3226),
    [aux_sym_preproc_def_token1] = ACTIONS(3226),
    [aux_sym_preproc_if_token1] = ACTIONS(3226),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3226),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3226),
    [sym_preproc_directive] = ACTIONS(3226),
    [anon_sym_LPAREN2] = ACTIONS(3228),
    [anon_sym_BANG] = ACTIONS(3228),
    [anon_sym_TILDE] = ACTIONS(3228),
    [anon_sym_DASH] = ACTIONS(3226),
    [anon_sym_PLUS] = ACTIONS(3226),
    [anon_sym_STAR] = ACTIONS(3228),
    [anon_sym_AMP_AMP] = ACTIONS(3228),
    [anon_sym_AMP] = ACTIONS(3226),
    [anon_sym_SEMI] = ACTIONS(3228),
    [anon_sym___extension__] = ACTIONS(3226),
    [anon_sym_typedef] = ACTIONS(3226),
    [anon_sym_in] = ACTIONS(3226),
    [anon_sym_out] = ACTIONS(3226),
    [anon_sym_inout] = ACTIONS(3226),
    [anon_sym_extern] = ACTIONS(3226),
    [anon_sym___attribute__] = ACTIONS(3226),
    [anon_sym_COLON_COLON] = ACTIONS(3228),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3228),
    [anon_sym___declspec] = ACTIONS(3226),
    [anon_sym___based] = ACTIONS(3226),
    [anon_sym___cdecl] = ACTIONS(3226),
    [anon_sym___clrcall] = ACTIONS(3226),
    [anon_sym___stdcall] = ACTIONS(3226),
    [anon_sym___fastcall] = ACTIONS(3226),
    [anon_sym___thiscall] = ACTIONS(3226),
    [anon_sym___vectorcall] = ACTIONS(3226),
    [anon_sym_LBRACE] = ACTIONS(3228),
    [anon_sym_signed] = ACTIONS(3226),
    [anon_sym_unsigned] = ACTIONS(3226),
    [anon_sym_long] = ACTIONS(3226),
    [anon_sym_short] = ACTIONS(3226),
    [anon_sym_LBRACK] = ACTIONS(3226),
    [anon_sym_static] = ACTIONS(3226),
    [anon_sym_register] = ACTIONS(3226),
    [anon_sym_inline] = ACTIONS(3226),
    [anon_sym___inline] = ACTIONS(3226),
    [anon_sym___inline__] = ACTIONS(3226),
    [anon_sym___forceinline] = ACTIONS(3226),
    [anon_sym_thread_local] = ACTIONS(3226),
    [anon_sym___thread] = ACTIONS(3226),
    [anon_sym_const] = ACTIONS(3226),
    [anon_sym_constexpr] = ACTIONS(3226),
    [anon_sym_volatile] = ACTIONS(3226),
    [anon_sym_restrict] = ACTIONS(3226),
    [anon_sym___restrict__] = ACTIONS(3226),
    [anon_sym__Atomic] = ACTIONS(3226),
    [anon_sym__Noreturn] = ACTIONS(3226),
    [anon_sym_noreturn] = ACTIONS(3226),
    [anon_sym_mutable] = ACTIONS(3226),
    [anon_sym_constinit] = ACTIONS(3226),
    [anon_sym_consteval] = ACTIONS(3226),
    [anon_sym_alignas] = ACTIONS(3226),
    [anon_sym__Alignas] = ACTIONS(3226),
    [sym_primitive_type] = ACTIONS(3226),
    [anon_sym_enum] = ACTIONS(3226),
    [anon_sym_class] = ACTIONS(3226),
    [anon_sym_struct] = ACTIONS(3226),
    [anon_sym_union] = ACTIONS(3226),
    [anon_sym_if] = ACTIONS(3226),
    [anon_sym_else] = ACTIONS(3226),
    [anon_sym_switch] = ACTIONS(3226),
    [anon_sym_case] = ACTIONS(3226),
    [anon_sym_default] = ACTIONS(3226),
    [anon_sym_while] = ACTIONS(3226),
    [anon_sym_do] = ACTIONS(3226),
    [anon_sym_for] = ACTIONS(3226),
    [anon_sym_return] = ACTIONS(3226),
    [anon_sym_break] = ACTIONS(3226),
    [anon_sym_continue] = ACTIONS(3226),
    [anon_sym_goto] = ACTIONS(3226),
    [anon_sym___try] = ACTIONS(3226),
    [anon_sym___leave] = ACTIONS(3226),
    [anon_sym_not] = ACTIONS(3226),
    [anon_sym_compl] = ACTIONS(3226),
    [anon_sym_DASH_DASH] = ACTIONS(3228),
    [anon_sym_PLUS_PLUS] = ACTIONS(3228),
    [anon_sym_sizeof] = ACTIONS(3226),
    [anon_sym___alignof__] = ACTIONS(3226),
    [anon_sym___alignof] = ACTIONS(3226),
    [anon_sym__alignof] = ACTIONS(3226),
    [anon_sym_alignof] = ACTIONS(3226),
    [anon_sym__Alignof] = ACTIONS(3226),
    [anon_sym_offsetof] = ACTIONS(3226),
    [anon_sym__Generic] = ACTIONS(3226),
    [anon_sym_asm] = ACTIONS(3226),
    [anon_sym___asm__] = ACTIONS(3226),
    [sym_number_literal] = ACTIONS(3228),
    [anon_sym_L_SQUOTE] = ACTIONS(3228),
    [anon_sym_u_SQUOTE] = ACTIONS(3228),
    [anon_sym_U_SQUOTE] = ACTIONS(3228),
    [anon_sym_u8_SQUOTE] = ACTIONS(3228),
    [anon_sym_SQUOTE] = ACTIONS(3228),
    [anon_sym_L_DQUOTE] = ACTIONS(3228),
    [anon_sym_u_DQUOTE] = ACTIONS(3228),
    [anon_sym_U_DQUOTE] = ACTIONS(3228),
    [anon_sym_u8_DQUOTE] = ACTIONS(3228),
    [anon_sym_DQUOTE] = ACTIONS(3228),
    [sym_true] = ACTIONS(3226),
    [sym_false] = ACTIONS(3226),
    [anon_sym_NULL] = ACTIONS(3226),
    [anon_sym_nullptr] = ACTIONS(3226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3226),
    [anon_sym_let] = ACTIONS(3226),
    [anon_sym_This] = ACTIONS(3226),
    [anon_sym_decltype] = ACTIONS(3226),
    [sym_virtual] = ACTIONS(3226),
    [anon_sym_explicit] = ACTIONS(3226),
    [anon_sym_typename] = ACTIONS(3226),
    [anon_sym_template] = ACTIONS(3226),
    [anon_sym_operator] = ACTIONS(3226),
    [anon_sym_try] = ACTIONS(3226),
    [anon_sym_delete] = ACTIONS(3226),
    [anon_sym_throw] = ACTIONS(3226),
    [anon_sym_namespace] = ACTIONS(3226),
    [anon_sym_using] = ACTIONS(3226),
    [anon_sym_static_assert] = ACTIONS(3226),
    [anon_sym_concept] = ACTIONS(3226),
    [anon_sym_co_return] = ACTIONS(3226),
    [anon_sym_co_yield] = ACTIONS(3226),
    [anon_sym_R_DQUOTE] = ACTIONS(3228),
    [anon_sym_LR_DQUOTE] = ACTIONS(3228),
    [anon_sym_uR_DQUOTE] = ACTIONS(3228),
    [anon_sym_UR_DQUOTE] = ACTIONS(3228),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3228),
    [anon_sym_co_await] = ACTIONS(3226),
    [anon_sym_new] = ACTIONS(3226),
    [anon_sym_requires] = ACTIONS(3226),
    [sym_this] = ACTIONS(3226),
    [anon_sym_discard] = ACTIONS(3226),
    [anon_sym_precise] = ACTIONS(3226),
    [anon_sym_shared] = ACTIONS(3226),
    [anon_sym_groupshared] = ACTIONS(3226),
    [anon_sym_uniform] = ACTIONS(3226),
    [anon_sym_row_major] = ACTIONS(3226),
    [anon_sym_column_major] = ACTIONS(3226),
    [anon_sym_globallycoherent] = ACTIONS(3226),
    [anon_sym_centroid] = ACTIONS(3226),
    [anon_sym_noperspective] = ACTIONS(3226),
    [anon_sym_nointerpolation] = ACTIONS(3226),
    [anon_sym_sample] = ACTIONS(3226),
    [anon_sym_linear] = ACTIONS(3226),
    [anon_sym_snorm] = ACTIONS(3226),
    [anon_sym_unorm] = ACTIONS(3226),
    [anon_sym_point] = ACTIONS(3226),
    [anon_sym_line] = ACTIONS(3226),
    [anon_sym_triangleadj] = ACTIONS(3226),
    [anon_sym_lineadj] = ACTIONS(3226),
    [anon_sym_triangle] = ACTIONS(3226),
    [anon_sym_cbuffer] = ACTIONS(3226),
    [anon_sym_interface] = ACTIONS(3226),
    [anon_sym_extension] = ACTIONS(3226),
    [anon_sym___exported] = ACTIONS(3226),
    [anon_sym_import] = ACTIONS(3226),
  },
  [603] = {
    [sym_attribute_specifier] = STATE(665),
    [sym_enumerator_list] = STATE(651),
    [sym_identifier] = ACTIONS(3715),
    [aux_sym_preproc_include_token1] = ACTIONS(3715),
    [aux_sym_preproc_def_token1] = ACTIONS(3715),
    [aux_sym_preproc_if_token1] = ACTIONS(3715),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3715),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3715),
    [sym_preproc_directive] = ACTIONS(3715),
    [anon_sym_LPAREN2] = ACTIONS(3717),
    [anon_sym_BANG] = ACTIONS(3717),
    [anon_sym_TILDE] = ACTIONS(3717),
    [anon_sym_DASH] = ACTIONS(3715),
    [anon_sym_PLUS] = ACTIONS(3715),
    [anon_sym_STAR] = ACTIONS(3717),
    [anon_sym_AMP_AMP] = ACTIONS(3717),
    [anon_sym_AMP] = ACTIONS(3715),
    [anon_sym_SEMI] = ACTIONS(3717),
    [anon_sym___extension__] = ACTIONS(3715),
    [anon_sym_typedef] = ACTIONS(3715),
    [anon_sym_in] = ACTIONS(3715),
    [anon_sym_out] = ACTIONS(3715),
    [anon_sym_inout] = ACTIONS(3715),
    [anon_sym_extern] = ACTIONS(3715),
    [anon_sym___attribute__] = ACTIONS(2687),
    [anon_sym_COLON_COLON] = ACTIONS(3717),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3717),
    [anon_sym___declspec] = ACTIONS(3715),
    [anon_sym___based] = ACTIONS(3715),
    [anon_sym___cdecl] = ACTIONS(3715),
    [anon_sym___clrcall] = ACTIONS(3715),
    [anon_sym___stdcall] = ACTIONS(3715),
    [anon_sym___fastcall] = ACTIONS(3715),
    [anon_sym___thiscall] = ACTIONS(3715),
    [anon_sym___vectorcall] = ACTIONS(3715),
    [anon_sym_LBRACE] = ACTIONS(3066),
    [anon_sym_RBRACE] = ACTIONS(3717),
    [anon_sym_signed] = ACTIONS(3715),
    [anon_sym_unsigned] = ACTIONS(3715),
    [anon_sym_long] = ACTIONS(3715),
    [anon_sym_short] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_static] = ACTIONS(3715),
    [anon_sym_register] = ACTIONS(3715),
    [anon_sym_inline] = ACTIONS(3715),
    [anon_sym___inline] = ACTIONS(3715),
    [anon_sym___inline__] = ACTIONS(3715),
    [anon_sym___forceinline] = ACTIONS(3715),
    [anon_sym_thread_local] = ACTIONS(3715),
    [anon_sym___thread] = ACTIONS(3715),
    [anon_sym_const] = ACTIONS(3715),
    [anon_sym_constexpr] = ACTIONS(3715),
    [anon_sym_volatile] = ACTIONS(3715),
    [anon_sym_restrict] = ACTIONS(3715),
    [anon_sym___restrict__] = ACTIONS(3715),
    [anon_sym__Atomic] = ACTIONS(3715),
    [anon_sym__Noreturn] = ACTIONS(3715),
    [anon_sym_noreturn] = ACTIONS(3715),
    [anon_sym_mutable] = ACTIONS(3715),
    [anon_sym_constinit] = ACTIONS(3715),
    [anon_sym_consteval] = ACTIONS(3715),
    [anon_sym_alignas] = ACTIONS(3715),
    [anon_sym__Alignas] = ACTIONS(3715),
    [sym_primitive_type] = ACTIONS(3715),
    [anon_sym_enum] = ACTIONS(3715),
    [anon_sym_class] = ACTIONS(3715),
    [anon_sym_struct] = ACTIONS(3715),
    [anon_sym_union] = ACTIONS(3715),
    [anon_sym_if] = ACTIONS(3715),
    [anon_sym_switch] = ACTIONS(3715),
    [anon_sym_case] = ACTIONS(3715),
    [anon_sym_default] = ACTIONS(3715),
    [anon_sym_while] = ACTIONS(3715),
    [anon_sym_do] = ACTIONS(3715),
    [anon_sym_for] = ACTIONS(3715),
    [anon_sym_return] = ACTIONS(3715),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_continue] = ACTIONS(3715),
    [anon_sym_goto] = ACTIONS(3715),
    [anon_sym___try] = ACTIONS(3715),
    [anon_sym___leave] = ACTIONS(3715),
    [anon_sym_not] = ACTIONS(3715),
    [anon_sym_compl] = ACTIONS(3715),
    [anon_sym_DASH_DASH] = ACTIONS(3717),
    [anon_sym_PLUS_PLUS] = ACTIONS(3717),
    [anon_sym_sizeof] = ACTIONS(3715),
    [anon_sym___alignof__] = ACTIONS(3715),
    [anon_sym___alignof] = ACTIONS(3715),
    [anon_sym__alignof] = ACTIONS(3715),
    [anon_sym_alignof] = ACTIONS(3715),
    [anon_sym__Alignof] = ACTIONS(3715),
    [anon_sym_offsetof] = ACTIONS(3715),
    [anon_sym__Generic] = ACTIONS(3715),
    [anon_sym_asm] = ACTIONS(3715),
    [anon_sym___asm__] = ACTIONS(3715),
    [anon_sym_DOT] = ACTIONS(3715),
    [sym_number_literal] = ACTIONS(3717),
    [anon_sym_L_SQUOTE] = ACTIONS(3717),
    [anon_sym_u_SQUOTE] = ACTIONS(3717),
    [anon_sym_U_SQUOTE] = ACTIONS(3717),
    [anon_sym_u8_SQUOTE] = ACTIONS(3717),
    [anon_sym_SQUOTE] = ACTIONS(3717),
    [anon_sym_L_DQUOTE] = ACTIONS(3717),
    [anon_sym_u_DQUOTE] = ACTIONS(3717),
    [anon_sym_U_DQUOTE] = ACTIONS(3717),
    [anon_sym_u8_DQUOTE] = ACTIONS(3717),
    [anon_sym_DQUOTE] = ACTIONS(3717),
    [sym_true] = ACTIONS(3715),
    [sym_false] = ACTIONS(3715),
    [anon_sym_NULL] = ACTIONS(3715),
    [anon_sym_nullptr] = ACTIONS(3715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3715),
    [anon_sym_let] = ACTIONS(3715),
    [anon_sym_This] = ACTIONS(3715),
    [anon_sym_decltype] = ACTIONS(3715),
    [sym_virtual] = ACTIONS(3715),
    [anon_sym_explicit] = ACTIONS(3715),
    [anon_sym_typename] = ACTIONS(3715),
    [anon_sym_template] = ACTIONS(3715),
    [anon_sym_operator] = ACTIONS(3715),
    [anon_sym_try] = ACTIONS(3715),
    [anon_sym_delete] = ACTIONS(3715),
    [anon_sym_throw] = ACTIONS(3715),
    [anon_sym_namespace] = ACTIONS(3715),
    [anon_sym_using] = ACTIONS(3715),
    [anon_sym_static_assert] = ACTIONS(3715),
    [anon_sym_concept] = ACTIONS(3715),
    [anon_sym_co_return] = ACTIONS(3715),
    [anon_sym_co_yield] = ACTIONS(3715),
    [anon_sym_R_DQUOTE] = ACTIONS(3717),
    [anon_sym_LR_DQUOTE] = ACTIONS(3717),
    [anon_sym_uR_DQUOTE] = ACTIONS(3717),
    [anon_sym_UR_DQUOTE] = ACTIONS(3717),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3717),
    [anon_sym_co_await] = ACTIONS(3715),
    [anon_sym_new] = ACTIONS(3715),
    [anon_sym_requires] = ACTIONS(3715),
    [sym_this] = ACTIONS(3715),
    [anon_sym_discard] = ACTIONS(3715),
    [anon_sym_precise] = ACTIONS(3715),
    [anon_sym_shared] = ACTIONS(3715),
    [anon_sym_groupshared] = ACTIONS(3715),
    [anon_sym_uniform] = ACTIONS(3715),
    [anon_sym_row_major] = ACTIONS(3715),
    [anon_sym_column_major] = ACTIONS(3715),
    [anon_sym_globallycoherent] = ACTIONS(3715),
    [anon_sym_centroid] = ACTIONS(3715),
    [anon_sym_noperspective] = ACTIONS(3715),
    [anon_sym_nointerpolation] = ACTIONS(3715),
    [anon_sym_sample] = ACTIONS(3715),
    [anon_sym_linear] = ACTIONS(3715),
    [anon_sym_snorm] = ACTIONS(3715),
    [anon_sym_unorm] = ACTIONS(3715),
    [anon_sym_point] = ACTIONS(3715),
    [anon_sym_line] = ACTIONS(3715),
    [anon_sym_triangleadj] = ACTIONS(3715),
    [anon_sym_lineadj] = ACTIONS(3715),
    [anon_sym_triangle] = ACTIONS(3715),
    [anon_sym_cbuffer] = ACTIONS(3715),
    [anon_sym_interface] = ACTIONS(3715),
    [anon_sym_extension] = ACTIONS(3715),
  },
  [604] = {
    [ts_builtin_sym_end] = ACTIONS(3184),
    [sym_identifier] = ACTIONS(3182),
    [aux_sym_preproc_include_token1] = ACTIONS(3182),
    [aux_sym_preproc_def_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [sym_preproc_directive] = ACTIONS(3182),
    [anon_sym_LPAREN2] = ACTIONS(3184),
    [anon_sym_BANG] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_DASH] = ACTIONS(3182),
    [anon_sym_PLUS] = ACTIONS(3182),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_AMP_AMP] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3182),
    [anon_sym_SEMI] = ACTIONS(3184),
    [anon_sym___extension__] = ACTIONS(3182),
    [anon_sym_typedef] = ACTIONS(3182),
    [anon_sym_in] = ACTIONS(3182),
    [anon_sym_out] = ACTIONS(3182),
    [anon_sym_inout] = ACTIONS(3182),
    [anon_sym_extern] = ACTIONS(3182),
    [anon_sym___attribute__] = ACTIONS(3182),
    [anon_sym_COLON_COLON] = ACTIONS(3184),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3184),
    [anon_sym___declspec] = ACTIONS(3182),
    [anon_sym___based] = ACTIONS(3182),
    [anon_sym___cdecl] = ACTIONS(3182),
    [anon_sym___clrcall] = ACTIONS(3182),
    [anon_sym___stdcall] = ACTIONS(3182),
    [anon_sym___fastcall] = ACTIONS(3182),
    [anon_sym___thiscall] = ACTIONS(3182),
    [anon_sym___vectorcall] = ACTIONS(3182),
    [anon_sym_LBRACE] = ACTIONS(3184),
    [anon_sym_signed] = ACTIONS(3182),
    [anon_sym_unsigned] = ACTIONS(3182),
    [anon_sym_long] = ACTIONS(3182),
    [anon_sym_short] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3182),
    [anon_sym_register] = ACTIONS(3182),
    [anon_sym_inline] = ACTIONS(3182),
    [anon_sym___inline] = ACTIONS(3182),
    [anon_sym___inline__] = ACTIONS(3182),
    [anon_sym___forceinline] = ACTIONS(3182),
    [anon_sym_thread_local] = ACTIONS(3182),
    [anon_sym___thread] = ACTIONS(3182),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_constexpr] = ACTIONS(3182),
    [anon_sym_volatile] = ACTIONS(3182),
    [anon_sym_restrict] = ACTIONS(3182),
    [anon_sym___restrict__] = ACTIONS(3182),
    [anon_sym__Atomic] = ACTIONS(3182),
    [anon_sym__Noreturn] = ACTIONS(3182),
    [anon_sym_noreturn] = ACTIONS(3182),
    [anon_sym_mutable] = ACTIONS(3182),
    [anon_sym_constinit] = ACTIONS(3182),
    [anon_sym_consteval] = ACTIONS(3182),
    [anon_sym_alignas] = ACTIONS(3182),
    [anon_sym__Alignas] = ACTIONS(3182),
    [sym_primitive_type] = ACTIONS(3182),
    [anon_sym_enum] = ACTIONS(3182),
    [anon_sym_class] = ACTIONS(3182),
    [anon_sym_struct] = ACTIONS(3182),
    [anon_sym_union] = ACTIONS(3182),
    [anon_sym_if] = ACTIONS(3182),
    [anon_sym_else] = ACTIONS(3182),
    [anon_sym_switch] = ACTIONS(3182),
    [anon_sym_case] = ACTIONS(3182),
    [anon_sym_default] = ACTIONS(3182),
    [anon_sym_while] = ACTIONS(3182),
    [anon_sym_do] = ACTIONS(3182),
    [anon_sym_for] = ACTIONS(3182),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_break] = ACTIONS(3182),
    [anon_sym_continue] = ACTIONS(3182),
    [anon_sym_goto] = ACTIONS(3182),
    [anon_sym___try] = ACTIONS(3182),
    [anon_sym___leave] = ACTIONS(3182),
    [anon_sym_not] = ACTIONS(3182),
    [anon_sym_compl] = ACTIONS(3182),
    [anon_sym_DASH_DASH] = ACTIONS(3184),
    [anon_sym_PLUS_PLUS] = ACTIONS(3184),
    [anon_sym_sizeof] = ACTIONS(3182),
    [anon_sym___alignof__] = ACTIONS(3182),
    [anon_sym___alignof] = ACTIONS(3182),
    [anon_sym__alignof] = ACTIONS(3182),
    [anon_sym_alignof] = ACTIONS(3182),
    [anon_sym__Alignof] = ACTIONS(3182),
    [anon_sym_offsetof] = ACTIONS(3182),
    [anon_sym__Generic] = ACTIONS(3182),
    [anon_sym_asm] = ACTIONS(3182),
    [anon_sym___asm__] = ACTIONS(3182),
    [sym_number_literal] = ACTIONS(3184),
    [anon_sym_L_SQUOTE] = ACTIONS(3184),
    [anon_sym_u_SQUOTE] = ACTIONS(3184),
    [anon_sym_U_SQUOTE] = ACTIONS(3184),
    [anon_sym_u8_SQUOTE] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3184),
    [anon_sym_L_DQUOTE] = ACTIONS(3184),
    [anon_sym_u_DQUOTE] = ACTIONS(3184),
    [anon_sym_U_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8_DQUOTE] = ACTIONS(3184),
    [anon_sym_DQUOTE] = ACTIONS(3184),
    [sym_true] = ACTIONS(3182),
    [sym_false] = ACTIONS(3182),
    [anon_sym_NULL] = ACTIONS(3182),
    [anon_sym_nullptr] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3182),
    [anon_sym_let] = ACTIONS(3182),
    [anon_sym_This] = ACTIONS(3182),
    [anon_sym_decltype] = ACTIONS(3182),
    [sym_virtual] = ACTIONS(3182),
    [anon_sym_explicit] = ACTIONS(3182),
    [anon_sym_typename] = ACTIONS(3182),
    [anon_sym_template] = ACTIONS(3182),
    [anon_sym_operator] = ACTIONS(3182),
    [anon_sym_try] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(3182),
    [anon_sym_throw] = ACTIONS(3182),
    [anon_sym_namespace] = ACTIONS(3182),
    [anon_sym_using] = ACTIONS(3182),
    [anon_sym_static_assert] = ACTIONS(3182),
    [anon_sym_concept] = ACTIONS(3182),
    [anon_sym_co_return] = ACTIONS(3182),
    [anon_sym_co_yield] = ACTIONS(3182),
    [anon_sym_R_DQUOTE] = ACTIONS(3184),
    [anon_sym_LR_DQUOTE] = ACTIONS(3184),
    [anon_sym_uR_DQUOTE] = ACTIONS(3184),
    [anon_sym_UR_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3184),
    [anon_sym_co_await] = ACTIONS(3182),
    [anon_sym_new] = ACTIONS(3182),
    [anon_sym_requires] = ACTIONS(3182),
    [sym_this] = ACTIONS(3182),
    [anon_sym_discard] = ACTIONS(3182),
    [anon_sym_precise] = ACTIONS(3182),
    [anon_sym_shared] = ACTIONS(3182),
    [anon_sym_groupshared] = ACTIONS(3182),
    [anon_sym_uniform] = ACTIONS(3182),
    [anon_sym_row_major] = ACTIONS(3182),
    [anon_sym_column_major] = ACTIONS(3182),
    [anon_sym_globallycoherent] = ACTIONS(3182),
    [anon_sym_centroid] = ACTIONS(3182),
    [anon_sym_noperspective] = ACTIONS(3182),
    [anon_sym_nointerpolation] = ACTIONS(3182),
    [anon_sym_sample] = ACTIONS(3182),
    [anon_sym_linear] = ACTIONS(3182),
    [anon_sym_snorm] = ACTIONS(3182),
    [anon_sym_unorm] = ACTIONS(3182),
    [anon_sym_point] = ACTIONS(3182),
    [anon_sym_line] = ACTIONS(3182),
    [anon_sym_triangleadj] = ACTIONS(3182),
    [anon_sym_lineadj] = ACTIONS(3182),
    [anon_sym_triangle] = ACTIONS(3182),
    [anon_sym_cbuffer] = ACTIONS(3182),
    [anon_sym_interface] = ACTIONS(3182),
    [anon_sym_extension] = ACTIONS(3182),
    [anon_sym___exported] = ACTIONS(3182),
    [anon_sym_import] = ACTIONS(3182),
  },
  [605] = {
    [ts_builtin_sym_end] = ACTIONS(2974),
    [sym_identifier] = ACTIONS(2972),
    [aux_sym_preproc_include_token1] = ACTIONS(2972),
    [aux_sym_preproc_def_token1] = ACTIONS(2972),
    [aux_sym_preproc_if_token1] = ACTIONS(2972),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2972),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2972),
    [sym_preproc_directive] = ACTIONS(2972),
    [anon_sym_LPAREN2] = ACTIONS(2974),
    [anon_sym_BANG] = ACTIONS(2974),
    [anon_sym_TILDE] = ACTIONS(2974),
    [anon_sym_DASH] = ACTIONS(2972),
    [anon_sym_PLUS] = ACTIONS(2972),
    [anon_sym_STAR] = ACTIONS(2974),
    [anon_sym_AMP_AMP] = ACTIONS(2974),
    [anon_sym_AMP] = ACTIONS(2972),
    [anon_sym_SEMI] = ACTIONS(2974),
    [anon_sym___extension__] = ACTIONS(2972),
    [anon_sym_typedef] = ACTIONS(2972),
    [anon_sym_in] = ACTIONS(2972),
    [anon_sym_out] = ACTIONS(2972),
    [anon_sym_inout] = ACTIONS(2972),
    [anon_sym_extern] = ACTIONS(2972),
    [anon_sym___attribute__] = ACTIONS(2972),
    [anon_sym_COLON_COLON] = ACTIONS(2974),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2974),
    [anon_sym___declspec] = ACTIONS(2972),
    [anon_sym___based] = ACTIONS(2972),
    [anon_sym___cdecl] = ACTIONS(2972),
    [anon_sym___clrcall] = ACTIONS(2972),
    [anon_sym___stdcall] = ACTIONS(2972),
    [anon_sym___fastcall] = ACTIONS(2972),
    [anon_sym___thiscall] = ACTIONS(2972),
    [anon_sym___vectorcall] = ACTIONS(2972),
    [anon_sym_LBRACE] = ACTIONS(2974),
    [anon_sym_signed] = ACTIONS(2972),
    [anon_sym_unsigned] = ACTIONS(2972),
    [anon_sym_long] = ACTIONS(2972),
    [anon_sym_short] = ACTIONS(2972),
    [anon_sym_LBRACK] = ACTIONS(2972),
    [anon_sym_static] = ACTIONS(2972),
    [anon_sym_register] = ACTIONS(2972),
    [anon_sym_inline] = ACTIONS(2972),
    [anon_sym___inline] = ACTIONS(2972),
    [anon_sym___inline__] = ACTIONS(2972),
    [anon_sym___forceinline] = ACTIONS(2972),
    [anon_sym_thread_local] = ACTIONS(2972),
    [anon_sym___thread] = ACTIONS(2972),
    [anon_sym_const] = ACTIONS(2972),
    [anon_sym_constexpr] = ACTIONS(2972),
    [anon_sym_volatile] = ACTIONS(2972),
    [anon_sym_restrict] = ACTIONS(2972),
    [anon_sym___restrict__] = ACTIONS(2972),
    [anon_sym__Atomic] = ACTIONS(2972),
    [anon_sym__Noreturn] = ACTIONS(2972),
    [anon_sym_noreturn] = ACTIONS(2972),
    [anon_sym_mutable] = ACTIONS(2972),
    [anon_sym_constinit] = ACTIONS(2972),
    [anon_sym_consteval] = ACTIONS(2972),
    [anon_sym_alignas] = ACTIONS(2972),
    [anon_sym__Alignas] = ACTIONS(2972),
    [sym_primitive_type] = ACTIONS(2972),
    [anon_sym_enum] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(2972),
    [anon_sym_struct] = ACTIONS(2972),
    [anon_sym_union] = ACTIONS(2972),
    [anon_sym_if] = ACTIONS(2972),
    [anon_sym_else] = ACTIONS(2972),
    [anon_sym_switch] = ACTIONS(2972),
    [anon_sym_case] = ACTIONS(2972),
    [anon_sym_default] = ACTIONS(2972),
    [anon_sym_while] = ACTIONS(2972),
    [anon_sym_do] = ACTIONS(2972),
    [anon_sym_for] = ACTIONS(2972),
    [anon_sym_return] = ACTIONS(2972),
    [anon_sym_break] = ACTIONS(2972),
    [anon_sym_continue] = ACTIONS(2972),
    [anon_sym_goto] = ACTIONS(2972),
    [anon_sym___try] = ACTIONS(2972),
    [anon_sym___leave] = ACTIONS(2972),
    [anon_sym_not] = ACTIONS(2972),
    [anon_sym_compl] = ACTIONS(2972),
    [anon_sym_DASH_DASH] = ACTIONS(2974),
    [anon_sym_PLUS_PLUS] = ACTIONS(2974),
    [anon_sym_sizeof] = ACTIONS(2972),
    [anon_sym___alignof__] = ACTIONS(2972),
    [anon_sym___alignof] = ACTIONS(2972),
    [anon_sym__alignof] = ACTIONS(2972),
    [anon_sym_alignof] = ACTIONS(2972),
    [anon_sym__Alignof] = ACTIONS(2972),
    [anon_sym_offsetof] = ACTIONS(2972),
    [anon_sym__Generic] = ACTIONS(2972),
    [anon_sym_asm] = ACTIONS(2972),
    [anon_sym___asm__] = ACTIONS(2972),
    [sym_number_literal] = ACTIONS(2974),
    [anon_sym_L_SQUOTE] = ACTIONS(2974),
    [anon_sym_u_SQUOTE] = ACTIONS(2974),
    [anon_sym_U_SQUOTE] = ACTIONS(2974),
    [anon_sym_u8_SQUOTE] = ACTIONS(2974),
    [anon_sym_SQUOTE] = ACTIONS(2974),
    [anon_sym_L_DQUOTE] = ACTIONS(2974),
    [anon_sym_u_DQUOTE] = ACTIONS(2974),
    [anon_sym_U_DQUOTE] = ACTIONS(2974),
    [anon_sym_u8_DQUOTE] = ACTIONS(2974),
    [anon_sym_DQUOTE] = ACTIONS(2974),
    [sym_true] = ACTIONS(2972),
    [sym_false] = ACTIONS(2972),
    [anon_sym_NULL] = ACTIONS(2972),
    [anon_sym_nullptr] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2972),
    [anon_sym_let] = ACTIONS(2972),
    [anon_sym_This] = ACTIONS(2972),
    [anon_sym_decltype] = ACTIONS(2972),
    [sym_virtual] = ACTIONS(2972),
    [anon_sym_explicit] = ACTIONS(2972),
    [anon_sym_typename] = ACTIONS(2972),
    [anon_sym_template] = ACTIONS(2972),
    [anon_sym_operator] = ACTIONS(2972),
    [anon_sym_try] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2972),
    [anon_sym_throw] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2972),
    [anon_sym_using] = ACTIONS(2972),
    [anon_sym_static_assert] = ACTIONS(2972),
    [anon_sym_concept] = ACTIONS(2972),
    [anon_sym_co_return] = ACTIONS(2972),
    [anon_sym_co_yield] = ACTIONS(2972),
    [anon_sym_R_DQUOTE] = ACTIONS(2974),
    [anon_sym_LR_DQUOTE] = ACTIONS(2974),
    [anon_sym_uR_DQUOTE] = ACTIONS(2974),
    [anon_sym_UR_DQUOTE] = ACTIONS(2974),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2974),
    [anon_sym_co_await] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2972),
    [anon_sym_requires] = ACTIONS(2972),
    [sym_this] = ACTIONS(2972),
    [anon_sym_discard] = ACTIONS(2972),
    [anon_sym_precise] = ACTIONS(2972),
    [anon_sym_shared] = ACTIONS(2972),
    [anon_sym_groupshared] = ACTIONS(2972),
    [anon_sym_uniform] = ACTIONS(2972),
    [anon_sym_row_major] = ACTIONS(2972),
    [anon_sym_column_major] = ACTIONS(2972),
    [anon_sym_globallycoherent] = ACTIONS(2972),
    [anon_sym_centroid] = ACTIONS(2972),
    [anon_sym_noperspective] = ACTIONS(2972),
    [anon_sym_nointerpolation] = ACTIONS(2972),
    [anon_sym_sample] = ACTIONS(2972),
    [anon_sym_linear] = ACTIONS(2972),
    [anon_sym_snorm] = ACTIONS(2972),
    [anon_sym_unorm] = ACTIONS(2972),
    [anon_sym_point] = ACTIONS(2972),
    [anon_sym_line] = ACTIONS(2972),
    [anon_sym_triangleadj] = ACTIONS(2972),
    [anon_sym_lineadj] = ACTIONS(2972),
    [anon_sym_triangle] = ACTIONS(2972),
    [anon_sym_cbuffer] = ACTIONS(2972),
    [anon_sym_interface] = ACTIONS(2972),
    [anon_sym_extension] = ACTIONS(2972),
    [anon_sym___exported] = ACTIONS(2972),
    [anon_sym_import] = ACTIONS(2972),
  },
  [606] = {
    [ts_builtin_sym_end] = ACTIONS(2956),
    [sym_identifier] = ACTIONS(2954),
    [aux_sym_preproc_include_token1] = ACTIONS(2954),
    [aux_sym_preproc_def_token1] = ACTIONS(2954),
    [aux_sym_preproc_if_token1] = ACTIONS(2954),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2954),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2954),
    [sym_preproc_directive] = ACTIONS(2954),
    [anon_sym_LPAREN2] = ACTIONS(2956),
    [anon_sym_BANG] = ACTIONS(2956),
    [anon_sym_TILDE] = ACTIONS(2956),
    [anon_sym_DASH] = ACTIONS(2954),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_STAR] = ACTIONS(2956),
    [anon_sym_AMP_AMP] = ACTIONS(2956),
    [anon_sym_AMP] = ACTIONS(2954),
    [anon_sym_SEMI] = ACTIONS(2956),
    [anon_sym___extension__] = ACTIONS(2954),
    [anon_sym_typedef] = ACTIONS(2954),
    [anon_sym_in] = ACTIONS(2954),
    [anon_sym_out] = ACTIONS(2954),
    [anon_sym_inout] = ACTIONS(2954),
    [anon_sym_extern] = ACTIONS(2954),
    [anon_sym___attribute__] = ACTIONS(2954),
    [anon_sym_COLON_COLON] = ACTIONS(2956),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2956),
    [anon_sym___declspec] = ACTIONS(2954),
    [anon_sym___based] = ACTIONS(2954),
    [anon_sym___cdecl] = ACTIONS(2954),
    [anon_sym___clrcall] = ACTIONS(2954),
    [anon_sym___stdcall] = ACTIONS(2954),
    [anon_sym___fastcall] = ACTIONS(2954),
    [anon_sym___thiscall] = ACTIONS(2954),
    [anon_sym___vectorcall] = ACTIONS(2954),
    [anon_sym_LBRACE] = ACTIONS(2956),
    [anon_sym_signed] = ACTIONS(2954),
    [anon_sym_unsigned] = ACTIONS(2954),
    [anon_sym_long] = ACTIONS(2954),
    [anon_sym_short] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_static] = ACTIONS(2954),
    [anon_sym_register] = ACTIONS(2954),
    [anon_sym_inline] = ACTIONS(2954),
    [anon_sym___inline] = ACTIONS(2954),
    [anon_sym___inline__] = ACTIONS(2954),
    [anon_sym___forceinline] = ACTIONS(2954),
    [anon_sym_thread_local] = ACTIONS(2954),
    [anon_sym___thread] = ACTIONS(2954),
    [anon_sym_const] = ACTIONS(2954),
    [anon_sym_constexpr] = ACTIONS(2954),
    [anon_sym_volatile] = ACTIONS(2954),
    [anon_sym_restrict] = ACTIONS(2954),
    [anon_sym___restrict__] = ACTIONS(2954),
    [anon_sym__Atomic] = ACTIONS(2954),
    [anon_sym__Noreturn] = ACTIONS(2954),
    [anon_sym_noreturn] = ACTIONS(2954),
    [anon_sym_mutable] = ACTIONS(2954),
    [anon_sym_constinit] = ACTIONS(2954),
    [anon_sym_consteval] = ACTIONS(2954),
    [anon_sym_alignas] = ACTIONS(2954),
    [anon_sym__Alignas] = ACTIONS(2954),
    [sym_primitive_type] = ACTIONS(2954),
    [anon_sym_enum] = ACTIONS(2954),
    [anon_sym_class] = ACTIONS(2954),
    [anon_sym_struct] = ACTIONS(2954),
    [anon_sym_union] = ACTIONS(2954),
    [anon_sym_if] = ACTIONS(2954),
    [anon_sym_else] = ACTIONS(2954),
    [anon_sym_switch] = ACTIONS(2954),
    [anon_sym_case] = ACTIONS(2954),
    [anon_sym_default] = ACTIONS(2954),
    [anon_sym_while] = ACTIONS(2954),
    [anon_sym_do] = ACTIONS(2954),
    [anon_sym_for] = ACTIONS(2954),
    [anon_sym_return] = ACTIONS(2954),
    [anon_sym_break] = ACTIONS(2954),
    [anon_sym_continue] = ACTIONS(2954),
    [anon_sym_goto] = ACTIONS(2954),
    [anon_sym___try] = ACTIONS(2954),
    [anon_sym___leave] = ACTIONS(2954),
    [anon_sym_not] = ACTIONS(2954),
    [anon_sym_compl] = ACTIONS(2954),
    [anon_sym_DASH_DASH] = ACTIONS(2956),
    [anon_sym_PLUS_PLUS] = ACTIONS(2956),
    [anon_sym_sizeof] = ACTIONS(2954),
    [anon_sym___alignof__] = ACTIONS(2954),
    [anon_sym___alignof] = ACTIONS(2954),
    [anon_sym__alignof] = ACTIONS(2954),
    [anon_sym_alignof] = ACTIONS(2954),
    [anon_sym__Alignof] = ACTIONS(2954),
    [anon_sym_offsetof] = ACTIONS(2954),
    [anon_sym__Generic] = ACTIONS(2954),
    [anon_sym_asm] = ACTIONS(2954),
    [anon_sym___asm__] = ACTIONS(2954),
    [sym_number_literal] = ACTIONS(2956),
    [anon_sym_L_SQUOTE] = ACTIONS(2956),
    [anon_sym_u_SQUOTE] = ACTIONS(2956),
    [anon_sym_U_SQUOTE] = ACTIONS(2956),
    [anon_sym_u8_SQUOTE] = ACTIONS(2956),
    [anon_sym_SQUOTE] = ACTIONS(2956),
    [anon_sym_L_DQUOTE] = ACTIONS(2956),
    [anon_sym_u_DQUOTE] = ACTIONS(2956),
    [anon_sym_U_DQUOTE] = ACTIONS(2956),
    [anon_sym_u8_DQUOTE] = ACTIONS(2956),
    [anon_sym_DQUOTE] = ACTIONS(2956),
    [sym_true] = ACTIONS(2954),
    [sym_false] = ACTIONS(2954),
    [anon_sym_NULL] = ACTIONS(2954),
    [anon_sym_nullptr] = ACTIONS(2954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2954),
    [anon_sym_let] = ACTIONS(2954),
    [anon_sym_This] = ACTIONS(2954),
    [anon_sym_decltype] = ACTIONS(2954),
    [sym_virtual] = ACTIONS(2954),
    [anon_sym_explicit] = ACTIONS(2954),
    [anon_sym_typename] = ACTIONS(2954),
    [anon_sym_template] = ACTIONS(2954),
    [anon_sym_operator] = ACTIONS(2954),
    [anon_sym_try] = ACTIONS(2954),
    [anon_sym_delete] = ACTIONS(2954),
    [anon_sym_throw] = ACTIONS(2954),
    [anon_sym_namespace] = ACTIONS(2954),
    [anon_sym_using] = ACTIONS(2954),
    [anon_sym_static_assert] = ACTIONS(2954),
    [anon_sym_concept] = ACTIONS(2954),
    [anon_sym_co_return] = ACTIONS(2954),
    [anon_sym_co_yield] = ACTIONS(2954),
    [anon_sym_R_DQUOTE] = ACTIONS(2956),
    [anon_sym_LR_DQUOTE] = ACTIONS(2956),
    [anon_sym_uR_DQUOTE] = ACTIONS(2956),
    [anon_sym_UR_DQUOTE] = ACTIONS(2956),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2956),
    [anon_sym_co_await] = ACTIONS(2954),
    [anon_sym_new] = ACTIONS(2954),
    [anon_sym_requires] = ACTIONS(2954),
    [sym_this] = ACTIONS(2954),
    [anon_sym_discard] = ACTIONS(2954),
    [anon_sym_precise] = ACTIONS(2954),
    [anon_sym_shared] = ACTIONS(2954),
    [anon_sym_groupshared] = ACTIONS(2954),
    [anon_sym_uniform] = ACTIONS(2954),
    [anon_sym_row_major] = ACTIONS(2954),
    [anon_sym_column_major] = ACTIONS(2954),
    [anon_sym_globallycoherent] = ACTIONS(2954),
    [anon_sym_centroid] = ACTIONS(2954),
    [anon_sym_noperspective] = ACTIONS(2954),
    [anon_sym_nointerpolation] = ACTIONS(2954),
    [anon_sym_sample] = ACTIONS(2954),
    [anon_sym_linear] = ACTIONS(2954),
    [anon_sym_snorm] = ACTIONS(2954),
    [anon_sym_unorm] = ACTIONS(2954),
    [anon_sym_point] = ACTIONS(2954),
    [anon_sym_line] = ACTIONS(2954),
    [anon_sym_triangleadj] = ACTIONS(2954),
    [anon_sym_lineadj] = ACTIONS(2954),
    [anon_sym_triangle] = ACTIONS(2954),
    [anon_sym_cbuffer] = ACTIONS(2954),
    [anon_sym_interface] = ACTIONS(2954),
    [anon_sym_extension] = ACTIONS(2954),
    [anon_sym___exported] = ACTIONS(2954),
    [anon_sym_import] = ACTIONS(2954),
  },
  [607] = {
    [ts_builtin_sym_end] = ACTIONS(3346),
    [sym_identifier] = ACTIONS(3344),
    [aux_sym_preproc_include_token1] = ACTIONS(3344),
    [aux_sym_preproc_def_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3344),
    [sym_preproc_directive] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym___extension__] = ACTIONS(3344),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_in] = ACTIONS(3344),
    [anon_sym_out] = ACTIONS(3344),
    [anon_sym_inout] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym___attribute__] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3346),
    [anon_sym___declspec] = ACTIONS(3344),
    [anon_sym___based] = ACTIONS(3344),
    [anon_sym___cdecl] = ACTIONS(3344),
    [anon_sym___clrcall] = ACTIONS(3344),
    [anon_sym___stdcall] = ACTIONS(3344),
    [anon_sym___fastcall] = ACTIONS(3344),
    [anon_sym___thiscall] = ACTIONS(3344),
    [anon_sym___vectorcall] = ACTIONS(3344),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_signed] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym___inline] = ACTIONS(3344),
    [anon_sym___inline__] = ACTIONS(3344),
    [anon_sym___forceinline] = ACTIONS(3344),
    [anon_sym_thread_local] = ACTIONS(3344),
    [anon_sym___thread] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym___restrict__] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym__Noreturn] = ACTIONS(3344),
    [anon_sym_noreturn] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_constinit] = ACTIONS(3344),
    [anon_sym_consteval] = ACTIONS(3344),
    [anon_sym_alignas] = ACTIONS(3344),
    [anon_sym__Alignas] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_class] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_switch] = ACTIONS(3344),
    [anon_sym_case] = ACTIONS(3344),
    [anon_sym_default] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_break] = ACTIONS(3344),
    [anon_sym_continue] = ACTIONS(3344),
    [anon_sym_goto] = ACTIONS(3344),
    [anon_sym___try] = ACTIONS(3344),
    [anon_sym___leave] = ACTIONS(3344),
    [anon_sym_not] = ACTIONS(3344),
    [anon_sym_compl] = ACTIONS(3344),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_sizeof] = ACTIONS(3344),
    [anon_sym___alignof__] = ACTIONS(3344),
    [anon_sym___alignof] = ACTIONS(3344),
    [anon_sym__alignof] = ACTIONS(3344),
    [anon_sym_alignof] = ACTIONS(3344),
    [anon_sym__Alignof] = ACTIONS(3344),
    [anon_sym_offsetof] = ACTIONS(3344),
    [anon_sym__Generic] = ACTIONS(3344),
    [anon_sym_asm] = ACTIONS(3344),
    [anon_sym___asm__] = ACTIONS(3344),
    [sym_number_literal] = ACTIONS(3346),
    [anon_sym_L_SQUOTE] = ACTIONS(3346),
    [anon_sym_u_SQUOTE] = ACTIONS(3346),
    [anon_sym_U_SQUOTE] = ACTIONS(3346),
    [anon_sym_u8_SQUOTE] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_L_DQUOTE] = ACTIONS(3346),
    [anon_sym_u_DQUOTE] = ACTIONS(3346),
    [anon_sym_U_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8_DQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [sym_true] = ACTIONS(3344),
    [sym_false] = ACTIONS(3344),
    [anon_sym_NULL] = ACTIONS(3344),
    [anon_sym_nullptr] = ACTIONS(3344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_This] = ACTIONS(3344),
    [anon_sym_decltype] = ACTIONS(3344),
    [sym_virtual] = ACTIONS(3344),
    [anon_sym_explicit] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_template] = ACTIONS(3344),
    [anon_sym_operator] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_delete] = ACTIONS(3344),
    [anon_sym_throw] = ACTIONS(3344),
    [anon_sym_namespace] = ACTIONS(3344),
    [anon_sym_using] = ACTIONS(3344),
    [anon_sym_static_assert] = ACTIONS(3344),
    [anon_sym_concept] = ACTIONS(3344),
    [anon_sym_co_return] = ACTIONS(3344),
    [anon_sym_co_yield] = ACTIONS(3344),
    [anon_sym_R_DQUOTE] = ACTIONS(3346),
    [anon_sym_LR_DQUOTE] = ACTIONS(3346),
    [anon_sym_uR_DQUOTE] = ACTIONS(3346),
    [anon_sym_UR_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3346),
    [anon_sym_co_await] = ACTIONS(3344),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_requires] = ACTIONS(3344),
    [sym_this] = ACTIONS(3344),
    [anon_sym_discard] = ACTIONS(3344),
    [anon_sym_precise] = ACTIONS(3344),
    [anon_sym_shared] = ACTIONS(3344),
    [anon_sym_groupshared] = ACTIONS(3344),
    [anon_sym_uniform] = ACTIONS(3344),
    [anon_sym_row_major] = ACTIONS(3344),
    [anon_sym_column_major] = ACTIONS(3344),
    [anon_sym_globallycoherent] = ACTIONS(3344),
    [anon_sym_centroid] = ACTIONS(3344),
    [anon_sym_noperspective] = ACTIONS(3344),
    [anon_sym_nointerpolation] = ACTIONS(3344),
    [anon_sym_sample] = ACTIONS(3344),
    [anon_sym_linear] = ACTIONS(3344),
    [anon_sym_snorm] = ACTIONS(3344),
    [anon_sym_unorm] = ACTIONS(3344),
    [anon_sym_point] = ACTIONS(3344),
    [anon_sym_line] = ACTIONS(3344),
    [anon_sym_triangleadj] = ACTIONS(3344),
    [anon_sym_lineadj] = ACTIONS(3344),
    [anon_sym_triangle] = ACTIONS(3344),
    [anon_sym_cbuffer] = ACTIONS(3344),
    [anon_sym_interface] = ACTIONS(3344),
    [anon_sym_extension] = ACTIONS(3344),
    [anon_sym___exported] = ACTIONS(3344),
    [anon_sym_import] = ACTIONS(3344),
  },
  [608] = {
    [ts_builtin_sym_end] = ACTIONS(2952),
    [sym_identifier] = ACTIONS(2950),
    [aux_sym_preproc_include_token1] = ACTIONS(2950),
    [aux_sym_preproc_def_token1] = ACTIONS(2950),
    [aux_sym_preproc_if_token1] = ACTIONS(2950),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2950),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2950),
    [sym_preproc_directive] = ACTIONS(2950),
    [anon_sym_LPAREN2] = ACTIONS(2952),
    [anon_sym_BANG] = ACTIONS(2952),
    [anon_sym_TILDE] = ACTIONS(2952),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_STAR] = ACTIONS(2952),
    [anon_sym_AMP_AMP] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2950),
    [anon_sym_SEMI] = ACTIONS(2952),
    [anon_sym___extension__] = ACTIONS(2950),
    [anon_sym_typedef] = ACTIONS(2950),
    [anon_sym_in] = ACTIONS(2950),
    [anon_sym_out] = ACTIONS(2950),
    [anon_sym_inout] = ACTIONS(2950),
    [anon_sym_extern] = ACTIONS(2950),
    [anon_sym___attribute__] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2952),
    [anon_sym___declspec] = ACTIONS(2950),
    [anon_sym___based] = ACTIONS(2950),
    [anon_sym___cdecl] = ACTIONS(2950),
    [anon_sym___clrcall] = ACTIONS(2950),
    [anon_sym___stdcall] = ACTIONS(2950),
    [anon_sym___fastcall] = ACTIONS(2950),
    [anon_sym___thiscall] = ACTIONS(2950),
    [anon_sym___vectorcall] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2952),
    [anon_sym_signed] = ACTIONS(2950),
    [anon_sym_unsigned] = ACTIONS(2950),
    [anon_sym_long] = ACTIONS(2950),
    [anon_sym_short] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_static] = ACTIONS(2950),
    [anon_sym_register] = ACTIONS(2950),
    [anon_sym_inline] = ACTIONS(2950),
    [anon_sym___inline] = ACTIONS(2950),
    [anon_sym___inline__] = ACTIONS(2950),
    [anon_sym___forceinline] = ACTIONS(2950),
    [anon_sym_thread_local] = ACTIONS(2950),
    [anon_sym___thread] = ACTIONS(2950),
    [anon_sym_const] = ACTIONS(2950),
    [anon_sym_constexpr] = ACTIONS(2950),
    [anon_sym_volatile] = ACTIONS(2950),
    [anon_sym_restrict] = ACTIONS(2950),
    [anon_sym___restrict__] = ACTIONS(2950),
    [anon_sym__Atomic] = ACTIONS(2950),
    [anon_sym__Noreturn] = ACTIONS(2950),
    [anon_sym_noreturn] = ACTIONS(2950),
    [anon_sym_mutable] = ACTIONS(2950),
    [anon_sym_constinit] = ACTIONS(2950),
    [anon_sym_consteval] = ACTIONS(2950),
    [anon_sym_alignas] = ACTIONS(2950),
    [anon_sym__Alignas] = ACTIONS(2950),
    [sym_primitive_type] = ACTIONS(2950),
    [anon_sym_enum] = ACTIONS(2950),
    [anon_sym_class] = ACTIONS(2950),
    [anon_sym_struct] = ACTIONS(2950),
    [anon_sym_union] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_else] = ACTIONS(2950),
    [anon_sym_switch] = ACTIONS(2950),
    [anon_sym_case] = ACTIONS(2950),
    [anon_sym_default] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_break] = ACTIONS(2950),
    [anon_sym_continue] = ACTIONS(2950),
    [anon_sym_goto] = ACTIONS(2950),
    [anon_sym___try] = ACTIONS(2950),
    [anon_sym___leave] = ACTIONS(2950),
    [anon_sym_not] = ACTIONS(2950),
    [anon_sym_compl] = ACTIONS(2950),
    [anon_sym_DASH_DASH] = ACTIONS(2952),
    [anon_sym_PLUS_PLUS] = ACTIONS(2952),
    [anon_sym_sizeof] = ACTIONS(2950),
    [anon_sym___alignof__] = ACTIONS(2950),
    [anon_sym___alignof] = ACTIONS(2950),
    [anon_sym__alignof] = ACTIONS(2950),
    [anon_sym_alignof] = ACTIONS(2950),
    [anon_sym__Alignof] = ACTIONS(2950),
    [anon_sym_offsetof] = ACTIONS(2950),
    [anon_sym__Generic] = ACTIONS(2950),
    [anon_sym_asm] = ACTIONS(2950),
    [anon_sym___asm__] = ACTIONS(2950),
    [sym_number_literal] = ACTIONS(2952),
    [anon_sym_L_SQUOTE] = ACTIONS(2952),
    [anon_sym_u_SQUOTE] = ACTIONS(2952),
    [anon_sym_U_SQUOTE] = ACTIONS(2952),
    [anon_sym_u8_SQUOTE] = ACTIONS(2952),
    [anon_sym_SQUOTE] = ACTIONS(2952),
    [anon_sym_L_DQUOTE] = ACTIONS(2952),
    [anon_sym_u_DQUOTE] = ACTIONS(2952),
    [anon_sym_U_DQUOTE] = ACTIONS(2952),
    [anon_sym_u8_DQUOTE] = ACTIONS(2952),
    [anon_sym_DQUOTE] = ACTIONS(2952),
    [sym_true] = ACTIONS(2950),
    [sym_false] = ACTIONS(2950),
    [anon_sym_NULL] = ACTIONS(2950),
    [anon_sym_nullptr] = ACTIONS(2950),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2950),
    [anon_sym_let] = ACTIONS(2950),
    [anon_sym_This] = ACTIONS(2950),
    [anon_sym_decltype] = ACTIONS(2950),
    [sym_virtual] = ACTIONS(2950),
    [anon_sym_explicit] = ACTIONS(2950),
    [anon_sym_typename] = ACTIONS(2950),
    [anon_sym_template] = ACTIONS(2950),
    [anon_sym_operator] = ACTIONS(2950),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_delete] = ACTIONS(2950),
    [anon_sym_throw] = ACTIONS(2950),
    [anon_sym_namespace] = ACTIONS(2950),
    [anon_sym_using] = ACTIONS(2950),
    [anon_sym_static_assert] = ACTIONS(2950),
    [anon_sym_concept] = ACTIONS(2950),
    [anon_sym_co_return] = ACTIONS(2950),
    [anon_sym_co_yield] = ACTIONS(2950),
    [anon_sym_R_DQUOTE] = ACTIONS(2952),
    [anon_sym_LR_DQUOTE] = ACTIONS(2952),
    [anon_sym_uR_DQUOTE] = ACTIONS(2952),
    [anon_sym_UR_DQUOTE] = ACTIONS(2952),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2952),
    [anon_sym_co_await] = ACTIONS(2950),
    [anon_sym_new] = ACTIONS(2950),
    [anon_sym_requires] = ACTIONS(2950),
    [sym_this] = ACTIONS(2950),
    [anon_sym_discard] = ACTIONS(2950),
    [anon_sym_precise] = ACTIONS(2950),
    [anon_sym_shared] = ACTIONS(2950),
    [anon_sym_groupshared] = ACTIONS(2950),
    [anon_sym_uniform] = ACTIONS(2950),
    [anon_sym_row_major] = ACTIONS(2950),
    [anon_sym_column_major] = ACTIONS(2950),
    [anon_sym_globallycoherent] = ACTIONS(2950),
    [anon_sym_centroid] = ACTIONS(2950),
    [anon_sym_noperspective] = ACTIONS(2950),
    [anon_sym_nointerpolation] = ACTIONS(2950),
    [anon_sym_sample] = ACTIONS(2950),
    [anon_sym_linear] = ACTIONS(2950),
    [anon_sym_snorm] = ACTIONS(2950),
    [anon_sym_unorm] = ACTIONS(2950),
    [anon_sym_point] = ACTIONS(2950),
    [anon_sym_line] = ACTIONS(2950),
    [anon_sym_triangleadj] = ACTIONS(2950),
    [anon_sym_lineadj] = ACTIONS(2950),
    [anon_sym_triangle] = ACTIONS(2950),
    [anon_sym_cbuffer] = ACTIONS(2950),
    [anon_sym_interface] = ACTIONS(2950),
    [anon_sym_extension] = ACTIONS(2950),
    [anon_sym___exported] = ACTIONS(2950),
    [anon_sym_import] = ACTIONS(2950),
  },
  [609] = {
    [ts_builtin_sym_end] = ACTIONS(3346),
    [sym_identifier] = ACTIONS(3344),
    [aux_sym_preproc_include_token1] = ACTIONS(3344),
    [aux_sym_preproc_def_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3344),
    [sym_preproc_directive] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym___extension__] = ACTIONS(3344),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_in] = ACTIONS(3344),
    [anon_sym_out] = ACTIONS(3344),
    [anon_sym_inout] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym___attribute__] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3346),
    [anon_sym___declspec] = ACTIONS(3344),
    [anon_sym___based] = ACTIONS(3344),
    [anon_sym___cdecl] = ACTIONS(3344),
    [anon_sym___clrcall] = ACTIONS(3344),
    [anon_sym___stdcall] = ACTIONS(3344),
    [anon_sym___fastcall] = ACTIONS(3344),
    [anon_sym___thiscall] = ACTIONS(3344),
    [anon_sym___vectorcall] = ACTIONS(3344),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_signed] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym___inline] = ACTIONS(3344),
    [anon_sym___inline__] = ACTIONS(3344),
    [anon_sym___forceinline] = ACTIONS(3344),
    [anon_sym_thread_local] = ACTIONS(3344),
    [anon_sym___thread] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym___restrict__] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym__Noreturn] = ACTIONS(3344),
    [anon_sym_noreturn] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_constinit] = ACTIONS(3344),
    [anon_sym_consteval] = ACTIONS(3344),
    [anon_sym_alignas] = ACTIONS(3344),
    [anon_sym__Alignas] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_class] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_switch] = ACTIONS(3344),
    [anon_sym_case] = ACTIONS(3344),
    [anon_sym_default] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_break] = ACTIONS(3344),
    [anon_sym_continue] = ACTIONS(3344),
    [anon_sym_goto] = ACTIONS(3344),
    [anon_sym___try] = ACTIONS(3344),
    [anon_sym___leave] = ACTIONS(3344),
    [anon_sym_not] = ACTIONS(3344),
    [anon_sym_compl] = ACTIONS(3344),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_sizeof] = ACTIONS(3344),
    [anon_sym___alignof__] = ACTIONS(3344),
    [anon_sym___alignof] = ACTIONS(3344),
    [anon_sym__alignof] = ACTIONS(3344),
    [anon_sym_alignof] = ACTIONS(3344),
    [anon_sym__Alignof] = ACTIONS(3344),
    [anon_sym_offsetof] = ACTIONS(3344),
    [anon_sym__Generic] = ACTIONS(3344),
    [anon_sym_asm] = ACTIONS(3344),
    [anon_sym___asm__] = ACTIONS(3344),
    [sym_number_literal] = ACTIONS(3346),
    [anon_sym_L_SQUOTE] = ACTIONS(3346),
    [anon_sym_u_SQUOTE] = ACTIONS(3346),
    [anon_sym_U_SQUOTE] = ACTIONS(3346),
    [anon_sym_u8_SQUOTE] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_L_DQUOTE] = ACTIONS(3346),
    [anon_sym_u_DQUOTE] = ACTIONS(3346),
    [anon_sym_U_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8_DQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [sym_true] = ACTIONS(3344),
    [sym_false] = ACTIONS(3344),
    [anon_sym_NULL] = ACTIONS(3344),
    [anon_sym_nullptr] = ACTIONS(3344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_This] = ACTIONS(3344),
    [anon_sym_decltype] = ACTIONS(3344),
    [sym_virtual] = ACTIONS(3344),
    [anon_sym_explicit] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_template] = ACTIONS(3344),
    [anon_sym_operator] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_delete] = ACTIONS(3344),
    [anon_sym_throw] = ACTIONS(3344),
    [anon_sym_namespace] = ACTIONS(3344),
    [anon_sym_using] = ACTIONS(3344),
    [anon_sym_static_assert] = ACTIONS(3344),
    [anon_sym_concept] = ACTIONS(3344),
    [anon_sym_co_return] = ACTIONS(3344),
    [anon_sym_co_yield] = ACTIONS(3344),
    [anon_sym_R_DQUOTE] = ACTIONS(3346),
    [anon_sym_LR_DQUOTE] = ACTIONS(3346),
    [anon_sym_uR_DQUOTE] = ACTIONS(3346),
    [anon_sym_UR_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3346),
    [anon_sym_co_await] = ACTIONS(3344),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_requires] = ACTIONS(3344),
    [sym_this] = ACTIONS(3344),
    [anon_sym_discard] = ACTIONS(3344),
    [anon_sym_precise] = ACTIONS(3344),
    [anon_sym_shared] = ACTIONS(3344),
    [anon_sym_groupshared] = ACTIONS(3344),
    [anon_sym_uniform] = ACTIONS(3344),
    [anon_sym_row_major] = ACTIONS(3344),
    [anon_sym_column_major] = ACTIONS(3344),
    [anon_sym_globallycoherent] = ACTIONS(3344),
    [anon_sym_centroid] = ACTIONS(3344),
    [anon_sym_noperspective] = ACTIONS(3344),
    [anon_sym_nointerpolation] = ACTIONS(3344),
    [anon_sym_sample] = ACTIONS(3344),
    [anon_sym_linear] = ACTIONS(3344),
    [anon_sym_snorm] = ACTIONS(3344),
    [anon_sym_unorm] = ACTIONS(3344),
    [anon_sym_point] = ACTIONS(3344),
    [anon_sym_line] = ACTIONS(3344),
    [anon_sym_triangleadj] = ACTIONS(3344),
    [anon_sym_lineadj] = ACTIONS(3344),
    [anon_sym_triangle] = ACTIONS(3344),
    [anon_sym_cbuffer] = ACTIONS(3344),
    [anon_sym_interface] = ACTIONS(3344),
    [anon_sym_extension] = ACTIONS(3344),
    [anon_sym___exported] = ACTIONS(3344),
    [anon_sym_import] = ACTIONS(3344),
  },
  [610] = {
    [ts_builtin_sym_end] = ACTIONS(2904),
    [sym_identifier] = ACTIONS(2902),
    [aux_sym_preproc_include_token1] = ACTIONS(2902),
    [aux_sym_preproc_def_token1] = ACTIONS(2902),
    [aux_sym_preproc_if_token1] = ACTIONS(2902),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2902),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2902),
    [sym_preproc_directive] = ACTIONS(2902),
    [anon_sym_LPAREN2] = ACTIONS(2904),
    [anon_sym_BANG] = ACTIONS(2904),
    [anon_sym_TILDE] = ACTIONS(2904),
    [anon_sym_DASH] = ACTIONS(2902),
    [anon_sym_PLUS] = ACTIONS(2902),
    [anon_sym_STAR] = ACTIONS(2904),
    [anon_sym_AMP_AMP] = ACTIONS(2904),
    [anon_sym_AMP] = ACTIONS(2902),
    [anon_sym_SEMI] = ACTIONS(2904),
    [anon_sym___extension__] = ACTIONS(2902),
    [anon_sym_typedef] = ACTIONS(2902),
    [anon_sym_in] = ACTIONS(2902),
    [anon_sym_out] = ACTIONS(2902),
    [anon_sym_inout] = ACTIONS(2902),
    [anon_sym_extern] = ACTIONS(2902),
    [anon_sym___attribute__] = ACTIONS(2902),
    [anon_sym_COLON_COLON] = ACTIONS(2904),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2904),
    [anon_sym___declspec] = ACTIONS(2902),
    [anon_sym___based] = ACTIONS(2902),
    [anon_sym___cdecl] = ACTIONS(2902),
    [anon_sym___clrcall] = ACTIONS(2902),
    [anon_sym___stdcall] = ACTIONS(2902),
    [anon_sym___fastcall] = ACTIONS(2902),
    [anon_sym___thiscall] = ACTIONS(2902),
    [anon_sym___vectorcall] = ACTIONS(2902),
    [anon_sym_LBRACE] = ACTIONS(2904),
    [anon_sym_signed] = ACTIONS(2902),
    [anon_sym_unsigned] = ACTIONS(2902),
    [anon_sym_long] = ACTIONS(2902),
    [anon_sym_short] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2902),
    [anon_sym_static] = ACTIONS(2902),
    [anon_sym_register] = ACTIONS(2902),
    [anon_sym_inline] = ACTIONS(2902),
    [anon_sym___inline] = ACTIONS(2902),
    [anon_sym___inline__] = ACTIONS(2902),
    [anon_sym___forceinline] = ACTIONS(2902),
    [anon_sym_thread_local] = ACTIONS(2902),
    [anon_sym___thread] = ACTIONS(2902),
    [anon_sym_const] = ACTIONS(2902),
    [anon_sym_constexpr] = ACTIONS(2902),
    [anon_sym_volatile] = ACTIONS(2902),
    [anon_sym_restrict] = ACTIONS(2902),
    [anon_sym___restrict__] = ACTIONS(2902),
    [anon_sym__Atomic] = ACTIONS(2902),
    [anon_sym__Noreturn] = ACTIONS(2902),
    [anon_sym_noreturn] = ACTIONS(2902),
    [anon_sym_mutable] = ACTIONS(2902),
    [anon_sym_constinit] = ACTIONS(2902),
    [anon_sym_consteval] = ACTIONS(2902),
    [anon_sym_alignas] = ACTIONS(2902),
    [anon_sym__Alignas] = ACTIONS(2902),
    [sym_primitive_type] = ACTIONS(2902),
    [anon_sym_enum] = ACTIONS(2902),
    [anon_sym_class] = ACTIONS(2902),
    [anon_sym_struct] = ACTIONS(2902),
    [anon_sym_union] = ACTIONS(2902),
    [anon_sym_if] = ACTIONS(2902),
    [anon_sym_else] = ACTIONS(2902),
    [anon_sym_switch] = ACTIONS(2902),
    [anon_sym_case] = ACTIONS(2902),
    [anon_sym_default] = ACTIONS(2902),
    [anon_sym_while] = ACTIONS(2902),
    [anon_sym_do] = ACTIONS(2902),
    [anon_sym_for] = ACTIONS(2902),
    [anon_sym_return] = ACTIONS(2902),
    [anon_sym_break] = ACTIONS(2902),
    [anon_sym_continue] = ACTIONS(2902),
    [anon_sym_goto] = ACTIONS(2902),
    [anon_sym___try] = ACTIONS(2902),
    [anon_sym___leave] = ACTIONS(2902),
    [anon_sym_not] = ACTIONS(2902),
    [anon_sym_compl] = ACTIONS(2902),
    [anon_sym_DASH_DASH] = ACTIONS(2904),
    [anon_sym_PLUS_PLUS] = ACTIONS(2904),
    [anon_sym_sizeof] = ACTIONS(2902),
    [anon_sym___alignof__] = ACTIONS(2902),
    [anon_sym___alignof] = ACTIONS(2902),
    [anon_sym__alignof] = ACTIONS(2902),
    [anon_sym_alignof] = ACTIONS(2902),
    [anon_sym__Alignof] = ACTIONS(2902),
    [anon_sym_offsetof] = ACTIONS(2902),
    [anon_sym__Generic] = ACTIONS(2902),
    [anon_sym_asm] = ACTIONS(2902),
    [anon_sym___asm__] = ACTIONS(2902),
    [sym_number_literal] = ACTIONS(2904),
    [anon_sym_L_SQUOTE] = ACTIONS(2904),
    [anon_sym_u_SQUOTE] = ACTIONS(2904),
    [anon_sym_U_SQUOTE] = ACTIONS(2904),
    [anon_sym_u8_SQUOTE] = ACTIONS(2904),
    [anon_sym_SQUOTE] = ACTIONS(2904),
    [anon_sym_L_DQUOTE] = ACTIONS(2904),
    [anon_sym_u_DQUOTE] = ACTIONS(2904),
    [anon_sym_U_DQUOTE] = ACTIONS(2904),
    [anon_sym_u8_DQUOTE] = ACTIONS(2904),
    [anon_sym_DQUOTE] = ACTIONS(2904),
    [sym_true] = ACTIONS(2902),
    [sym_false] = ACTIONS(2902),
    [anon_sym_NULL] = ACTIONS(2902),
    [anon_sym_nullptr] = ACTIONS(2902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2902),
    [anon_sym_let] = ACTIONS(2902),
    [anon_sym_This] = ACTIONS(2902),
    [anon_sym_decltype] = ACTIONS(2902),
    [sym_virtual] = ACTIONS(2902),
    [anon_sym_explicit] = ACTIONS(2902),
    [anon_sym_typename] = ACTIONS(2902),
    [anon_sym_template] = ACTIONS(2902),
    [anon_sym_operator] = ACTIONS(2902),
    [anon_sym_try] = ACTIONS(2902),
    [anon_sym_delete] = ACTIONS(2902),
    [anon_sym_throw] = ACTIONS(2902),
    [anon_sym_namespace] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_static_assert] = ACTIONS(2902),
    [anon_sym_concept] = ACTIONS(2902),
    [anon_sym_co_return] = ACTIONS(2902),
    [anon_sym_co_yield] = ACTIONS(2902),
    [anon_sym_R_DQUOTE] = ACTIONS(2904),
    [anon_sym_LR_DQUOTE] = ACTIONS(2904),
    [anon_sym_uR_DQUOTE] = ACTIONS(2904),
    [anon_sym_UR_DQUOTE] = ACTIONS(2904),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2904),
    [anon_sym_co_await] = ACTIONS(2902),
    [anon_sym_new] = ACTIONS(2902),
    [anon_sym_requires] = ACTIONS(2902),
    [sym_this] = ACTIONS(2902),
    [anon_sym_discard] = ACTIONS(2902),
    [anon_sym_precise] = ACTIONS(2902),
    [anon_sym_shared] = ACTIONS(2902),
    [anon_sym_groupshared] = ACTIONS(2902),
    [anon_sym_uniform] = ACTIONS(2902),
    [anon_sym_row_major] = ACTIONS(2902),
    [anon_sym_column_major] = ACTIONS(2902),
    [anon_sym_globallycoherent] = ACTIONS(2902),
    [anon_sym_centroid] = ACTIONS(2902),
    [anon_sym_noperspective] = ACTIONS(2902),
    [anon_sym_nointerpolation] = ACTIONS(2902),
    [anon_sym_sample] = ACTIONS(2902),
    [anon_sym_linear] = ACTIONS(2902),
    [anon_sym_snorm] = ACTIONS(2902),
    [anon_sym_unorm] = ACTIONS(2902),
    [anon_sym_point] = ACTIONS(2902),
    [anon_sym_line] = ACTIONS(2902),
    [anon_sym_triangleadj] = ACTIONS(2902),
    [anon_sym_lineadj] = ACTIONS(2902),
    [anon_sym_triangle] = ACTIONS(2902),
    [anon_sym_cbuffer] = ACTIONS(2902),
    [anon_sym_interface] = ACTIONS(2902),
    [anon_sym_extension] = ACTIONS(2902),
    [anon_sym___exported] = ACTIONS(2902),
    [anon_sym_import] = ACTIONS(2902),
  },
  [611] = {
    [ts_builtin_sym_end] = ACTIONS(3346),
    [sym_identifier] = ACTIONS(3344),
    [aux_sym_preproc_include_token1] = ACTIONS(3344),
    [aux_sym_preproc_def_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3344),
    [sym_preproc_directive] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym___extension__] = ACTIONS(3344),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_in] = ACTIONS(3344),
    [anon_sym_out] = ACTIONS(3344),
    [anon_sym_inout] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym___attribute__] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3346),
    [anon_sym___declspec] = ACTIONS(3344),
    [anon_sym___based] = ACTIONS(3344),
    [anon_sym___cdecl] = ACTIONS(3344),
    [anon_sym___clrcall] = ACTIONS(3344),
    [anon_sym___stdcall] = ACTIONS(3344),
    [anon_sym___fastcall] = ACTIONS(3344),
    [anon_sym___thiscall] = ACTIONS(3344),
    [anon_sym___vectorcall] = ACTIONS(3344),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_signed] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym___inline] = ACTIONS(3344),
    [anon_sym___inline__] = ACTIONS(3344),
    [anon_sym___forceinline] = ACTIONS(3344),
    [anon_sym_thread_local] = ACTIONS(3344),
    [anon_sym___thread] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym___restrict__] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym__Noreturn] = ACTIONS(3344),
    [anon_sym_noreturn] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_constinit] = ACTIONS(3344),
    [anon_sym_consteval] = ACTIONS(3344),
    [anon_sym_alignas] = ACTIONS(3344),
    [anon_sym__Alignas] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_class] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_switch] = ACTIONS(3344),
    [anon_sym_case] = ACTIONS(3344),
    [anon_sym_default] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_break] = ACTIONS(3344),
    [anon_sym_continue] = ACTIONS(3344),
    [anon_sym_goto] = ACTIONS(3344),
    [anon_sym___try] = ACTIONS(3344),
    [anon_sym___leave] = ACTIONS(3344),
    [anon_sym_not] = ACTIONS(3344),
    [anon_sym_compl] = ACTIONS(3344),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_sizeof] = ACTIONS(3344),
    [anon_sym___alignof__] = ACTIONS(3344),
    [anon_sym___alignof] = ACTIONS(3344),
    [anon_sym__alignof] = ACTIONS(3344),
    [anon_sym_alignof] = ACTIONS(3344),
    [anon_sym__Alignof] = ACTIONS(3344),
    [anon_sym_offsetof] = ACTIONS(3344),
    [anon_sym__Generic] = ACTIONS(3344),
    [anon_sym_asm] = ACTIONS(3344),
    [anon_sym___asm__] = ACTIONS(3344),
    [sym_number_literal] = ACTIONS(3346),
    [anon_sym_L_SQUOTE] = ACTIONS(3346),
    [anon_sym_u_SQUOTE] = ACTIONS(3346),
    [anon_sym_U_SQUOTE] = ACTIONS(3346),
    [anon_sym_u8_SQUOTE] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_L_DQUOTE] = ACTIONS(3346),
    [anon_sym_u_DQUOTE] = ACTIONS(3346),
    [anon_sym_U_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8_DQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [sym_true] = ACTIONS(3344),
    [sym_false] = ACTIONS(3344),
    [anon_sym_NULL] = ACTIONS(3344),
    [anon_sym_nullptr] = ACTIONS(3344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_This] = ACTIONS(3344),
    [anon_sym_decltype] = ACTIONS(3344),
    [sym_virtual] = ACTIONS(3344),
    [anon_sym_explicit] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_template] = ACTIONS(3344),
    [anon_sym_operator] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_delete] = ACTIONS(3344),
    [anon_sym_throw] = ACTIONS(3344),
    [anon_sym_namespace] = ACTIONS(3344),
    [anon_sym_using] = ACTIONS(3344),
    [anon_sym_static_assert] = ACTIONS(3344),
    [anon_sym_concept] = ACTIONS(3344),
    [anon_sym_co_return] = ACTIONS(3344),
    [anon_sym_co_yield] = ACTIONS(3344),
    [anon_sym_R_DQUOTE] = ACTIONS(3346),
    [anon_sym_LR_DQUOTE] = ACTIONS(3346),
    [anon_sym_uR_DQUOTE] = ACTIONS(3346),
    [anon_sym_UR_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3346),
    [anon_sym_co_await] = ACTIONS(3344),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_requires] = ACTIONS(3344),
    [sym_this] = ACTIONS(3344),
    [anon_sym_discard] = ACTIONS(3344),
    [anon_sym_precise] = ACTIONS(3344),
    [anon_sym_shared] = ACTIONS(3344),
    [anon_sym_groupshared] = ACTIONS(3344),
    [anon_sym_uniform] = ACTIONS(3344),
    [anon_sym_row_major] = ACTIONS(3344),
    [anon_sym_column_major] = ACTIONS(3344),
    [anon_sym_globallycoherent] = ACTIONS(3344),
    [anon_sym_centroid] = ACTIONS(3344),
    [anon_sym_noperspective] = ACTIONS(3344),
    [anon_sym_nointerpolation] = ACTIONS(3344),
    [anon_sym_sample] = ACTIONS(3344),
    [anon_sym_linear] = ACTIONS(3344),
    [anon_sym_snorm] = ACTIONS(3344),
    [anon_sym_unorm] = ACTIONS(3344),
    [anon_sym_point] = ACTIONS(3344),
    [anon_sym_line] = ACTIONS(3344),
    [anon_sym_triangleadj] = ACTIONS(3344),
    [anon_sym_lineadj] = ACTIONS(3344),
    [anon_sym_triangle] = ACTIONS(3344),
    [anon_sym_cbuffer] = ACTIONS(3344),
    [anon_sym_interface] = ACTIONS(3344),
    [anon_sym_extension] = ACTIONS(3344),
    [anon_sym___exported] = ACTIONS(3344),
    [anon_sym_import] = ACTIONS(3344),
  },
  [612] = {
    [ts_builtin_sym_end] = ACTIONS(3300),
    [sym_identifier] = ACTIONS(3298),
    [aux_sym_preproc_include_token1] = ACTIONS(3298),
    [aux_sym_preproc_def_token1] = ACTIONS(3298),
    [aux_sym_preproc_if_token1] = ACTIONS(3298),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3298),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3298),
    [sym_preproc_directive] = ACTIONS(3298),
    [anon_sym_LPAREN2] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3298),
    [anon_sym_PLUS] = ACTIONS(3298),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_AMP_AMP] = ACTIONS(3300),
    [anon_sym_AMP] = ACTIONS(3298),
    [anon_sym_SEMI] = ACTIONS(3300),
    [anon_sym___extension__] = ACTIONS(3298),
    [anon_sym_typedef] = ACTIONS(3298),
    [anon_sym_in] = ACTIONS(3298),
    [anon_sym_out] = ACTIONS(3298),
    [anon_sym_inout] = ACTIONS(3298),
    [anon_sym_extern] = ACTIONS(3298),
    [anon_sym___attribute__] = ACTIONS(3298),
    [anon_sym_COLON_COLON] = ACTIONS(3300),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3300),
    [anon_sym___declspec] = ACTIONS(3298),
    [anon_sym___based] = ACTIONS(3298),
    [anon_sym___cdecl] = ACTIONS(3298),
    [anon_sym___clrcall] = ACTIONS(3298),
    [anon_sym___stdcall] = ACTIONS(3298),
    [anon_sym___fastcall] = ACTIONS(3298),
    [anon_sym___thiscall] = ACTIONS(3298),
    [anon_sym___vectorcall] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_signed] = ACTIONS(3298),
    [anon_sym_unsigned] = ACTIONS(3298),
    [anon_sym_long] = ACTIONS(3298),
    [anon_sym_short] = ACTIONS(3298),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_static] = ACTIONS(3298),
    [anon_sym_register] = ACTIONS(3298),
    [anon_sym_inline] = ACTIONS(3298),
    [anon_sym___inline] = ACTIONS(3298),
    [anon_sym___inline__] = ACTIONS(3298),
    [anon_sym___forceinline] = ACTIONS(3298),
    [anon_sym_thread_local] = ACTIONS(3298),
    [anon_sym___thread] = ACTIONS(3298),
    [anon_sym_const] = ACTIONS(3298),
    [anon_sym_constexpr] = ACTIONS(3298),
    [anon_sym_volatile] = ACTIONS(3298),
    [anon_sym_restrict] = ACTIONS(3298),
    [anon_sym___restrict__] = ACTIONS(3298),
    [anon_sym__Atomic] = ACTIONS(3298),
    [anon_sym__Noreturn] = ACTIONS(3298),
    [anon_sym_noreturn] = ACTIONS(3298),
    [anon_sym_mutable] = ACTIONS(3298),
    [anon_sym_constinit] = ACTIONS(3298),
    [anon_sym_consteval] = ACTIONS(3298),
    [anon_sym_alignas] = ACTIONS(3298),
    [anon_sym__Alignas] = ACTIONS(3298),
    [sym_primitive_type] = ACTIONS(3298),
    [anon_sym_enum] = ACTIONS(3298),
    [anon_sym_class] = ACTIONS(3298),
    [anon_sym_struct] = ACTIONS(3298),
    [anon_sym_union] = ACTIONS(3298),
    [anon_sym_if] = ACTIONS(3298),
    [anon_sym_else] = ACTIONS(3298),
    [anon_sym_switch] = ACTIONS(3298),
    [anon_sym_case] = ACTIONS(3298),
    [anon_sym_default] = ACTIONS(3298),
    [anon_sym_while] = ACTIONS(3298),
    [anon_sym_do] = ACTIONS(3298),
    [anon_sym_for] = ACTIONS(3298),
    [anon_sym_return] = ACTIONS(3298),
    [anon_sym_break] = ACTIONS(3298),
    [anon_sym_continue] = ACTIONS(3298),
    [anon_sym_goto] = ACTIONS(3298),
    [anon_sym___try] = ACTIONS(3298),
    [anon_sym___leave] = ACTIONS(3298),
    [anon_sym_not] = ACTIONS(3298),
    [anon_sym_compl] = ACTIONS(3298),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_sizeof] = ACTIONS(3298),
    [anon_sym___alignof__] = ACTIONS(3298),
    [anon_sym___alignof] = ACTIONS(3298),
    [anon_sym__alignof] = ACTIONS(3298),
    [anon_sym_alignof] = ACTIONS(3298),
    [anon_sym__Alignof] = ACTIONS(3298),
    [anon_sym_offsetof] = ACTIONS(3298),
    [anon_sym__Generic] = ACTIONS(3298),
    [anon_sym_asm] = ACTIONS(3298),
    [anon_sym___asm__] = ACTIONS(3298),
    [sym_number_literal] = ACTIONS(3300),
    [anon_sym_L_SQUOTE] = ACTIONS(3300),
    [anon_sym_u_SQUOTE] = ACTIONS(3300),
    [anon_sym_U_SQUOTE] = ACTIONS(3300),
    [anon_sym_u8_SQUOTE] = ACTIONS(3300),
    [anon_sym_SQUOTE] = ACTIONS(3300),
    [anon_sym_L_DQUOTE] = ACTIONS(3300),
    [anon_sym_u_DQUOTE] = ACTIONS(3300),
    [anon_sym_U_DQUOTE] = ACTIONS(3300),
    [anon_sym_u8_DQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [sym_true] = ACTIONS(3298),
    [sym_false] = ACTIONS(3298),
    [anon_sym_NULL] = ACTIONS(3298),
    [anon_sym_nullptr] = ACTIONS(3298),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3298),
    [anon_sym_let] = ACTIONS(3298),
    [anon_sym_This] = ACTIONS(3298),
    [anon_sym_decltype] = ACTIONS(3298),
    [sym_virtual] = ACTIONS(3298),
    [anon_sym_explicit] = ACTIONS(3298),
    [anon_sym_typename] = ACTIONS(3298),
    [anon_sym_template] = ACTIONS(3298),
    [anon_sym_operator] = ACTIONS(3298),
    [anon_sym_try] = ACTIONS(3298),
    [anon_sym_delete] = ACTIONS(3298),
    [anon_sym_throw] = ACTIONS(3298),
    [anon_sym_namespace] = ACTIONS(3298),
    [anon_sym_using] = ACTIONS(3298),
    [anon_sym_static_assert] = ACTIONS(3298),
    [anon_sym_concept] = ACTIONS(3298),
    [anon_sym_co_return] = ACTIONS(3298),
    [anon_sym_co_yield] = ACTIONS(3298),
    [anon_sym_R_DQUOTE] = ACTIONS(3300),
    [anon_sym_LR_DQUOTE] = ACTIONS(3300),
    [anon_sym_uR_DQUOTE] = ACTIONS(3300),
    [anon_sym_UR_DQUOTE] = ACTIONS(3300),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3300),
    [anon_sym_co_await] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3298),
    [anon_sym_requires] = ACTIONS(3298),
    [sym_this] = ACTIONS(3298),
    [anon_sym_discard] = ACTIONS(3298),
    [anon_sym_precise] = ACTIONS(3298),
    [anon_sym_shared] = ACTIONS(3298),
    [anon_sym_groupshared] = ACTIONS(3298),
    [anon_sym_uniform] = ACTIONS(3298),
    [anon_sym_row_major] = ACTIONS(3298),
    [anon_sym_column_major] = ACTIONS(3298),
    [anon_sym_globallycoherent] = ACTIONS(3298),
    [anon_sym_centroid] = ACTIONS(3298),
    [anon_sym_noperspective] = ACTIONS(3298),
    [anon_sym_nointerpolation] = ACTIONS(3298),
    [anon_sym_sample] = ACTIONS(3298),
    [anon_sym_linear] = ACTIONS(3298),
    [anon_sym_snorm] = ACTIONS(3298),
    [anon_sym_unorm] = ACTIONS(3298),
    [anon_sym_point] = ACTIONS(3298),
    [anon_sym_line] = ACTIONS(3298),
    [anon_sym_triangleadj] = ACTIONS(3298),
    [anon_sym_lineadj] = ACTIONS(3298),
    [anon_sym_triangle] = ACTIONS(3298),
    [anon_sym_cbuffer] = ACTIONS(3298),
    [anon_sym_interface] = ACTIONS(3298),
    [anon_sym_extension] = ACTIONS(3298),
    [anon_sym___exported] = ACTIONS(3298),
    [anon_sym_import] = ACTIONS(3298),
  },
  [613] = {
    [sym_attribute_specifier] = STATE(754),
    [sym_identifier] = ACTIONS(3719),
    [aux_sym_preproc_include_token1] = ACTIONS(3719),
    [aux_sym_preproc_def_token1] = ACTIONS(3719),
    [aux_sym_preproc_if_token1] = ACTIONS(3719),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3719),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3719),
    [sym_preproc_directive] = ACTIONS(3719),
    [anon_sym_LPAREN2] = ACTIONS(3721),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_TILDE] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3719),
    [anon_sym_SEMI] = ACTIONS(3721),
    [anon_sym___extension__] = ACTIONS(3719),
    [anon_sym_typedef] = ACTIONS(3719),
    [anon_sym_in] = ACTIONS(3719),
    [anon_sym_out] = ACTIONS(3719),
    [anon_sym_inout] = ACTIONS(3719),
    [anon_sym_extern] = ACTIONS(3719),
    [anon_sym___attribute__] = ACTIONS(2687),
    [anon_sym_COLON_COLON] = ACTIONS(3721),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3721),
    [anon_sym___declspec] = ACTIONS(3719),
    [anon_sym___based] = ACTIONS(3719),
    [anon_sym___cdecl] = ACTIONS(3719),
    [anon_sym___clrcall] = ACTIONS(3719),
    [anon_sym___stdcall] = ACTIONS(3719),
    [anon_sym___fastcall] = ACTIONS(3719),
    [anon_sym___thiscall] = ACTIONS(3719),
    [anon_sym___vectorcall] = ACTIONS(3719),
    [anon_sym_LBRACE] = ACTIONS(3721),
    [anon_sym_RBRACE] = ACTIONS(3721),
    [anon_sym_signed] = ACTIONS(3719),
    [anon_sym_unsigned] = ACTIONS(3719),
    [anon_sym_long] = ACTIONS(3719),
    [anon_sym_short] = ACTIONS(3719),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_static] = ACTIONS(3719),
    [anon_sym_register] = ACTIONS(3719),
    [anon_sym_inline] = ACTIONS(3719),
    [anon_sym___inline] = ACTIONS(3719),
    [anon_sym___inline__] = ACTIONS(3719),
    [anon_sym___forceinline] = ACTIONS(3719),
    [anon_sym_thread_local] = ACTIONS(3719),
    [anon_sym___thread] = ACTIONS(3719),
    [anon_sym_const] = ACTIONS(3719),
    [anon_sym_constexpr] = ACTIONS(3719),
    [anon_sym_volatile] = ACTIONS(3719),
    [anon_sym_restrict] = ACTIONS(3719),
    [anon_sym___restrict__] = ACTIONS(3719),
    [anon_sym__Atomic] = ACTIONS(3719),
    [anon_sym__Noreturn] = ACTIONS(3719),
    [anon_sym_noreturn] = ACTIONS(3719),
    [anon_sym_mutable] = ACTIONS(3719),
    [anon_sym_constinit] = ACTIONS(3719),
    [anon_sym_consteval] = ACTIONS(3719),
    [anon_sym_alignas] = ACTIONS(3719),
    [anon_sym__Alignas] = ACTIONS(3719),
    [sym_primitive_type] = ACTIONS(3719),
    [anon_sym_enum] = ACTIONS(3719),
    [anon_sym_class] = ACTIONS(3719),
    [anon_sym_struct] = ACTIONS(3719),
    [anon_sym_union] = ACTIONS(3719),
    [anon_sym_if] = ACTIONS(3719),
    [anon_sym_switch] = ACTIONS(3719),
    [anon_sym_case] = ACTIONS(3719),
    [anon_sym_default] = ACTIONS(3719),
    [anon_sym_while] = ACTIONS(3719),
    [anon_sym_do] = ACTIONS(3719),
    [anon_sym_for] = ACTIONS(3719),
    [anon_sym_return] = ACTIONS(3719),
    [anon_sym_break] = ACTIONS(3719),
    [anon_sym_continue] = ACTIONS(3719),
    [anon_sym_goto] = ACTIONS(3719),
    [anon_sym___try] = ACTIONS(3719),
    [anon_sym___leave] = ACTIONS(3719),
    [anon_sym_not] = ACTIONS(3719),
    [anon_sym_compl] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3721),
    [anon_sym_sizeof] = ACTIONS(3719),
    [anon_sym___alignof__] = ACTIONS(3719),
    [anon_sym___alignof] = ACTIONS(3719),
    [anon_sym__alignof] = ACTIONS(3719),
    [anon_sym_alignof] = ACTIONS(3719),
    [anon_sym__Alignof] = ACTIONS(3719),
    [anon_sym_offsetof] = ACTIONS(3719),
    [anon_sym__Generic] = ACTIONS(3719),
    [anon_sym_asm] = ACTIONS(3719),
    [anon_sym___asm__] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3719),
    [sym_number_literal] = ACTIONS(3721),
    [anon_sym_L_SQUOTE] = ACTIONS(3721),
    [anon_sym_u_SQUOTE] = ACTIONS(3721),
    [anon_sym_U_SQUOTE] = ACTIONS(3721),
    [anon_sym_u8_SQUOTE] = ACTIONS(3721),
    [anon_sym_SQUOTE] = ACTIONS(3721),
    [anon_sym_L_DQUOTE] = ACTIONS(3721),
    [anon_sym_u_DQUOTE] = ACTIONS(3721),
    [anon_sym_U_DQUOTE] = ACTIONS(3721),
    [anon_sym_u8_DQUOTE] = ACTIONS(3721),
    [anon_sym_DQUOTE] = ACTIONS(3721),
    [sym_true] = ACTIONS(3719),
    [sym_false] = ACTIONS(3719),
    [anon_sym_NULL] = ACTIONS(3719),
    [anon_sym_nullptr] = ACTIONS(3719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3719),
    [anon_sym_let] = ACTIONS(3719),
    [anon_sym_This] = ACTIONS(3719),
    [anon_sym_decltype] = ACTIONS(3719),
    [sym_virtual] = ACTIONS(3719),
    [anon_sym_explicit] = ACTIONS(3719),
    [anon_sym_typename] = ACTIONS(3719),
    [anon_sym_template] = ACTIONS(3719),
    [anon_sym_operator] = ACTIONS(3719),
    [anon_sym_try] = ACTIONS(3719),
    [anon_sym_delete] = ACTIONS(3719),
    [anon_sym_throw] = ACTIONS(3719),
    [anon_sym_namespace] = ACTIONS(3719),
    [anon_sym_using] = ACTIONS(3719),
    [anon_sym_static_assert] = ACTIONS(3719),
    [anon_sym_concept] = ACTIONS(3719),
    [anon_sym_co_return] = ACTIONS(3719),
    [anon_sym_co_yield] = ACTIONS(3719),
    [anon_sym_R_DQUOTE] = ACTIONS(3721),
    [anon_sym_LR_DQUOTE] = ACTIONS(3721),
    [anon_sym_uR_DQUOTE] = ACTIONS(3721),
    [anon_sym_UR_DQUOTE] = ACTIONS(3721),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3721),
    [anon_sym_co_await] = ACTIONS(3719),
    [anon_sym_new] = ACTIONS(3719),
    [anon_sym_requires] = ACTIONS(3719),
    [sym_this] = ACTIONS(3719),
    [anon_sym_discard] = ACTIONS(3719),
    [anon_sym_precise] = ACTIONS(3719),
    [anon_sym_shared] = ACTIONS(3719),
    [anon_sym_groupshared] = ACTIONS(3719),
    [anon_sym_uniform] = ACTIONS(3719),
    [anon_sym_row_major] = ACTIONS(3719),
    [anon_sym_column_major] = ACTIONS(3719),
    [anon_sym_globallycoherent] = ACTIONS(3719),
    [anon_sym_centroid] = ACTIONS(3719),
    [anon_sym_noperspective] = ACTIONS(3719),
    [anon_sym_nointerpolation] = ACTIONS(3719),
    [anon_sym_sample] = ACTIONS(3719),
    [anon_sym_linear] = ACTIONS(3719),
    [anon_sym_snorm] = ACTIONS(3719),
    [anon_sym_unorm] = ACTIONS(3719),
    [anon_sym_point] = ACTIONS(3719),
    [anon_sym_line] = ACTIONS(3719),
    [anon_sym_triangleadj] = ACTIONS(3719),
    [anon_sym_lineadj] = ACTIONS(3719),
    [anon_sym_triangle] = ACTIONS(3719),
    [anon_sym_cbuffer] = ACTIONS(3719),
    [anon_sym_interface] = ACTIONS(3719),
    [anon_sym_extension] = ACTIONS(3719),
  },
  [614] = {
    [sym_identifier] = ACTIONS(2536),
    [aux_sym_preproc_include_token1] = ACTIONS(2536),
    [aux_sym_preproc_def_token1] = ACTIONS(2536),
    [aux_sym_preproc_if_token1] = ACTIONS(2536),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2536),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2536),
    [sym_preproc_directive] = ACTIONS(2536),
    [anon_sym_LPAREN2] = ACTIONS(2534),
    [anon_sym_BANG] = ACTIONS(2534),
    [anon_sym_TILDE] = ACTIONS(2534),
    [anon_sym_DASH] = ACTIONS(2536),
    [anon_sym_PLUS] = ACTIONS(2536),
    [anon_sym_STAR] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
    [anon_sym_SEMI] = ACTIONS(2534),
    [anon_sym___extension__] = ACTIONS(2536),
    [anon_sym_typedef] = ACTIONS(2536),
    [anon_sym_in] = ACTIONS(2536),
    [anon_sym_out] = ACTIONS(2536),
    [anon_sym_inout] = ACTIONS(2536),
    [anon_sym_extern] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(2534),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2534),
    [anon_sym___declspec] = ACTIONS(2536),
    [anon_sym___based] = ACTIONS(2536),
    [anon_sym___cdecl] = ACTIONS(2536),
    [anon_sym___clrcall] = ACTIONS(2536),
    [anon_sym___stdcall] = ACTIONS(2536),
    [anon_sym___fastcall] = ACTIONS(2536),
    [anon_sym___thiscall] = ACTIONS(2536),
    [anon_sym___vectorcall] = ACTIONS(2536),
    [anon_sym_LBRACE] = ACTIONS(2534),
    [anon_sym_RBRACE] = ACTIONS(2534),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(2536),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_register] = ACTIONS(2536),
    [anon_sym_inline] = ACTIONS(2536),
    [anon_sym___inline] = ACTIONS(2536),
    [anon_sym___inline__] = ACTIONS(2536),
    [anon_sym___forceinline] = ACTIONS(2536),
    [anon_sym_thread_local] = ACTIONS(2536),
    [anon_sym___thread] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2536),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_class] = ACTIONS(2536),
    [anon_sym_struct] = ACTIONS(2536),
    [anon_sym_union] = ACTIONS(2536),
    [anon_sym_if] = ACTIONS(2536),
    [anon_sym_else] = ACTIONS(2536),
    [anon_sym_switch] = ACTIONS(2536),
    [anon_sym_case] = ACTIONS(2536),
    [anon_sym_default] = ACTIONS(2536),
    [anon_sym_while] = ACTIONS(2536),
    [anon_sym_do] = ACTIONS(2536),
    [anon_sym_for] = ACTIONS(2536),
    [anon_sym_return] = ACTIONS(2536),
    [anon_sym_break] = ACTIONS(2536),
    [anon_sym_continue] = ACTIONS(2536),
    [anon_sym_goto] = ACTIONS(2536),
    [anon_sym___try] = ACTIONS(2536),
    [anon_sym___leave] = ACTIONS(2536),
    [anon_sym_not] = ACTIONS(2536),
    [anon_sym_compl] = ACTIONS(2536),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_sizeof] = ACTIONS(2536),
    [anon_sym___alignof__] = ACTIONS(2536),
    [anon_sym___alignof] = ACTIONS(2536),
    [anon_sym__alignof] = ACTIONS(2536),
    [anon_sym_alignof] = ACTIONS(2536),
    [anon_sym__Alignof] = ACTIONS(2536),
    [anon_sym_offsetof] = ACTIONS(2536),
    [anon_sym__Generic] = ACTIONS(2536),
    [anon_sym_asm] = ACTIONS(2536),
    [anon_sym___asm__] = ACTIONS(2536),
    [anon_sym_DOT] = ACTIONS(2536),
    [sym_number_literal] = ACTIONS(2534),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2534),
    [anon_sym_u_DQUOTE] = ACTIONS(2534),
    [anon_sym_U_DQUOTE] = ACTIONS(2534),
    [anon_sym_u8_DQUOTE] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [sym_true] = ACTIONS(2536),
    [sym_false] = ACTIONS(2536),
    [anon_sym_NULL] = ACTIONS(2536),
    [anon_sym_nullptr] = ACTIONS(2536),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2536),
    [anon_sym_let] = ACTIONS(2536),
    [anon_sym_This] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2536),
    [sym_virtual] = ACTIONS(2536),
    [anon_sym_explicit] = ACTIONS(2536),
    [anon_sym_typename] = ACTIONS(2536),
    [anon_sym_template] = ACTIONS(2536),
    [anon_sym_operator] = ACTIONS(2536),
    [anon_sym_try] = ACTIONS(2536),
    [anon_sym_delete] = ACTIONS(2536),
    [anon_sym_throw] = ACTIONS(2536),
    [anon_sym_namespace] = ACTIONS(2536),
    [anon_sym_using] = ACTIONS(2536),
    [anon_sym_static_assert] = ACTIONS(2536),
    [anon_sym_concept] = ACTIONS(2536),
    [anon_sym_co_return] = ACTIONS(2536),
    [anon_sym_co_yield] = ACTIONS(2536),
    [anon_sym_R_DQUOTE] = ACTIONS(2534),
    [anon_sym_LR_DQUOTE] = ACTIONS(2534),
    [anon_sym_uR_DQUOTE] = ACTIONS(2534),
    [anon_sym_UR_DQUOTE] = ACTIONS(2534),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2534),
    [anon_sym_co_await] = ACTIONS(2536),
    [anon_sym_new] = ACTIONS(2536),
    [anon_sym_requires] = ACTIONS(2536),
    [sym_this] = ACTIONS(2536),
    [anon_sym_discard] = ACTIONS(2536),
    [anon_sym_precise] = ACTIONS(2536),
    [anon_sym_shared] = ACTIONS(2536),
    [anon_sym_groupshared] = ACTIONS(2536),
    [anon_sym_uniform] = ACTIONS(2536),
    [anon_sym_row_major] = ACTIONS(2536),
    [anon_sym_column_major] = ACTIONS(2536),
    [anon_sym_globallycoherent] = ACTIONS(2536),
    [anon_sym_centroid] = ACTIONS(2536),
    [anon_sym_noperspective] = ACTIONS(2536),
    [anon_sym_nointerpolation] = ACTIONS(2536),
    [anon_sym_sample] = ACTIONS(2536),
    [anon_sym_linear] = ACTIONS(2536),
    [anon_sym_snorm] = ACTIONS(2536),
    [anon_sym_unorm] = ACTIONS(2536),
    [anon_sym_point] = ACTIONS(2536),
    [anon_sym_line] = ACTIONS(2536),
    [anon_sym_triangleadj] = ACTIONS(2536),
    [anon_sym_lineadj] = ACTIONS(2536),
    [anon_sym_triangle] = ACTIONS(2536),
    [anon_sym_cbuffer] = ACTIONS(2536),
    [anon_sym_interface] = ACTIONS(2536),
    [anon_sym_extension] = ACTIONS(2536),
  },
  [615] = {
    [sym_else_clause] = STATE(681),
    [sym_identifier] = ACTIONS(2846),
    [aux_sym_preproc_include_token1] = ACTIONS(2846),
    [aux_sym_preproc_def_token1] = ACTIONS(2846),
    [aux_sym_preproc_if_token1] = ACTIONS(2846),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2846),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2846),
    [sym_preproc_directive] = ACTIONS(2846),
    [anon_sym_LPAREN2] = ACTIONS(2848),
    [anon_sym_BANG] = ACTIONS(2848),
    [anon_sym_TILDE] = ACTIONS(2848),
    [anon_sym_DASH] = ACTIONS(2846),
    [anon_sym_PLUS] = ACTIONS(2846),
    [anon_sym_STAR] = ACTIONS(2848),
    [anon_sym_AMP_AMP] = ACTIONS(2848),
    [anon_sym_AMP] = ACTIONS(2846),
    [anon_sym_SEMI] = ACTIONS(2848),
    [anon_sym___extension__] = ACTIONS(2846),
    [anon_sym_typedef] = ACTIONS(2846),
    [anon_sym_in] = ACTIONS(2846),
    [anon_sym_out] = ACTIONS(2846),
    [anon_sym_inout] = ACTIONS(2846),
    [anon_sym_extern] = ACTIONS(2846),
    [anon_sym___attribute__] = ACTIONS(2846),
    [anon_sym_COLON_COLON] = ACTIONS(2848),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2848),
    [anon_sym___declspec] = ACTIONS(2846),
    [anon_sym___based] = ACTIONS(2846),
    [anon_sym___cdecl] = ACTIONS(2846),
    [anon_sym___clrcall] = ACTIONS(2846),
    [anon_sym___stdcall] = ACTIONS(2846),
    [anon_sym___fastcall] = ACTIONS(2846),
    [anon_sym___thiscall] = ACTIONS(2846),
    [anon_sym___vectorcall] = ACTIONS(2846),
    [anon_sym_LBRACE] = ACTIONS(2848),
    [anon_sym_RBRACE] = ACTIONS(2848),
    [anon_sym_signed] = ACTIONS(2846),
    [anon_sym_unsigned] = ACTIONS(2846),
    [anon_sym_long] = ACTIONS(2846),
    [anon_sym_short] = ACTIONS(2846),
    [anon_sym_LBRACK] = ACTIONS(2846),
    [anon_sym_static] = ACTIONS(2846),
    [anon_sym_register] = ACTIONS(2846),
    [anon_sym_inline] = ACTIONS(2846),
    [anon_sym___inline] = ACTIONS(2846),
    [anon_sym___inline__] = ACTIONS(2846),
    [anon_sym___forceinline] = ACTIONS(2846),
    [anon_sym_thread_local] = ACTIONS(2846),
    [anon_sym___thread] = ACTIONS(2846),
    [anon_sym_const] = ACTIONS(2846),
    [anon_sym_constexpr] = ACTIONS(2846),
    [anon_sym_volatile] = ACTIONS(2846),
    [anon_sym_restrict] = ACTIONS(2846),
    [anon_sym___restrict__] = ACTIONS(2846),
    [anon_sym__Atomic] = ACTIONS(2846),
    [anon_sym__Noreturn] = ACTIONS(2846),
    [anon_sym_noreturn] = ACTIONS(2846),
    [anon_sym_mutable] = ACTIONS(2846),
    [anon_sym_constinit] = ACTIONS(2846),
    [anon_sym_consteval] = ACTIONS(2846),
    [anon_sym_alignas] = ACTIONS(2846),
    [anon_sym__Alignas] = ACTIONS(2846),
    [sym_primitive_type] = ACTIONS(2846),
    [anon_sym_enum] = ACTIONS(2846),
    [anon_sym_class] = ACTIONS(2846),
    [anon_sym_struct] = ACTIONS(2846),
    [anon_sym_union] = ACTIONS(2846),
    [anon_sym_if] = ACTIONS(2846),
    [anon_sym_else] = ACTIONS(3723),
    [anon_sym_switch] = ACTIONS(2846),
    [anon_sym_case] = ACTIONS(2846),
    [anon_sym_default] = ACTIONS(2846),
    [anon_sym_while] = ACTIONS(2846),
    [anon_sym_do] = ACTIONS(2846),
    [anon_sym_for] = ACTIONS(2846),
    [anon_sym_return] = ACTIONS(2846),
    [anon_sym_break] = ACTIONS(2846),
    [anon_sym_continue] = ACTIONS(2846),
    [anon_sym_goto] = ACTIONS(2846),
    [anon_sym___try] = ACTIONS(2846),
    [anon_sym___leave] = ACTIONS(2846),
    [anon_sym_not] = ACTIONS(2846),
    [anon_sym_compl] = ACTIONS(2846),
    [anon_sym_DASH_DASH] = ACTIONS(2848),
    [anon_sym_PLUS_PLUS] = ACTIONS(2848),
    [anon_sym_sizeof] = ACTIONS(2846),
    [anon_sym___alignof__] = ACTIONS(2846),
    [anon_sym___alignof] = ACTIONS(2846),
    [anon_sym__alignof] = ACTIONS(2846),
    [anon_sym_alignof] = ACTIONS(2846),
    [anon_sym__Alignof] = ACTIONS(2846),
    [anon_sym_offsetof] = ACTIONS(2846),
    [anon_sym__Generic] = ACTIONS(2846),
    [anon_sym_asm] = ACTIONS(2846),
    [anon_sym___asm__] = ACTIONS(2846),
    [sym_number_literal] = ACTIONS(2848),
    [anon_sym_L_SQUOTE] = ACTIONS(2848),
    [anon_sym_u_SQUOTE] = ACTIONS(2848),
    [anon_sym_U_SQUOTE] = ACTIONS(2848),
    [anon_sym_u8_SQUOTE] = ACTIONS(2848),
    [anon_sym_SQUOTE] = ACTIONS(2848),
    [anon_sym_L_DQUOTE] = ACTIONS(2848),
    [anon_sym_u_DQUOTE] = ACTIONS(2848),
    [anon_sym_U_DQUOTE] = ACTIONS(2848),
    [anon_sym_u8_DQUOTE] = ACTIONS(2848),
    [anon_sym_DQUOTE] = ACTIONS(2848),
    [sym_true] = ACTIONS(2846),
    [sym_false] = ACTIONS(2846),
    [anon_sym_NULL] = ACTIONS(2846),
    [anon_sym_nullptr] = ACTIONS(2846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2846),
    [anon_sym_let] = ACTIONS(2846),
    [anon_sym_This] = ACTIONS(2846),
    [anon_sym_decltype] = ACTIONS(2846),
    [sym_virtual] = ACTIONS(2846),
    [anon_sym_explicit] = ACTIONS(2846),
    [anon_sym_typename] = ACTIONS(2846),
    [anon_sym_template] = ACTIONS(2846),
    [anon_sym_operator] = ACTIONS(2846),
    [anon_sym_try] = ACTIONS(2846),
    [anon_sym_delete] = ACTIONS(2846),
    [anon_sym_throw] = ACTIONS(2846),
    [anon_sym_namespace] = ACTIONS(2846),
    [anon_sym_using] = ACTIONS(2846),
    [anon_sym_static_assert] = ACTIONS(2846),
    [anon_sym_concept] = ACTIONS(2846),
    [anon_sym_co_return] = ACTIONS(2846),
    [anon_sym_co_yield] = ACTIONS(2846),
    [anon_sym_R_DQUOTE] = ACTIONS(2848),
    [anon_sym_LR_DQUOTE] = ACTIONS(2848),
    [anon_sym_uR_DQUOTE] = ACTIONS(2848),
    [anon_sym_UR_DQUOTE] = ACTIONS(2848),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2848),
    [anon_sym_co_await] = ACTIONS(2846),
    [anon_sym_new] = ACTIONS(2846),
    [anon_sym_requires] = ACTIONS(2846),
    [sym_this] = ACTIONS(2846),
    [anon_sym_discard] = ACTIONS(2846),
    [anon_sym_precise] = ACTIONS(2846),
    [anon_sym_shared] = ACTIONS(2846),
    [anon_sym_groupshared] = ACTIONS(2846),
    [anon_sym_uniform] = ACTIONS(2846),
    [anon_sym_row_major] = ACTIONS(2846),
    [anon_sym_column_major] = ACTIONS(2846),
    [anon_sym_globallycoherent] = ACTIONS(2846),
    [anon_sym_centroid] = ACTIONS(2846),
    [anon_sym_noperspective] = ACTIONS(2846),
    [anon_sym_nointerpolation] = ACTIONS(2846),
    [anon_sym_sample] = ACTIONS(2846),
    [anon_sym_linear] = ACTIONS(2846),
    [anon_sym_snorm] = ACTIONS(2846),
    [anon_sym_unorm] = ACTIONS(2846),
    [anon_sym_point] = ACTIONS(2846),
    [anon_sym_line] = ACTIONS(2846),
    [anon_sym_triangleadj] = ACTIONS(2846),
    [anon_sym_lineadj] = ACTIONS(2846),
    [anon_sym_triangle] = ACTIONS(2846),
    [anon_sym_cbuffer] = ACTIONS(2846),
    [anon_sym_interface] = ACTIONS(2846),
    [anon_sym_extension] = ACTIONS(2846),
  },
  [616] = {
    [sym_else_clause] = STATE(793),
    [sym_identifier] = ACTIONS(2850),
    [aux_sym_preproc_include_token1] = ACTIONS(2850),
    [aux_sym_preproc_def_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token1] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2850),
    [sym_preproc_directive] = ACTIONS(2850),
    [anon_sym_LPAREN2] = ACTIONS(2852),
    [anon_sym_BANG] = ACTIONS(2852),
    [anon_sym_TILDE] = ACTIONS(2852),
    [anon_sym_DASH] = ACTIONS(2850),
    [anon_sym_PLUS] = ACTIONS(2850),
    [anon_sym_STAR] = ACTIONS(2852),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_AMP] = ACTIONS(2850),
    [anon_sym_SEMI] = ACTIONS(2852),
    [anon_sym___extension__] = ACTIONS(2850),
    [anon_sym_typedef] = ACTIONS(2850),
    [anon_sym_in] = ACTIONS(2850),
    [anon_sym_out] = ACTIONS(2850),
    [anon_sym_inout] = ACTIONS(2850),
    [anon_sym_extern] = ACTIONS(2850),
    [anon_sym___attribute__] = ACTIONS(2850),
    [anon_sym_COLON_COLON] = ACTIONS(2852),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2852),
    [anon_sym___declspec] = ACTIONS(2850),
    [anon_sym___based] = ACTIONS(2850),
    [anon_sym___cdecl] = ACTIONS(2850),
    [anon_sym___clrcall] = ACTIONS(2850),
    [anon_sym___stdcall] = ACTIONS(2850),
    [anon_sym___fastcall] = ACTIONS(2850),
    [anon_sym___thiscall] = ACTIONS(2850),
    [anon_sym___vectorcall] = ACTIONS(2850),
    [anon_sym_LBRACE] = ACTIONS(2852),
    [anon_sym_RBRACE] = ACTIONS(2852),
    [anon_sym_signed] = ACTIONS(2850),
    [anon_sym_unsigned] = ACTIONS(2850),
    [anon_sym_long] = ACTIONS(2850),
    [anon_sym_short] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2850),
    [anon_sym_static] = ACTIONS(2850),
    [anon_sym_register] = ACTIONS(2850),
    [anon_sym_inline] = ACTIONS(2850),
    [anon_sym___inline] = ACTIONS(2850),
    [anon_sym___inline__] = ACTIONS(2850),
    [anon_sym___forceinline] = ACTIONS(2850),
    [anon_sym_thread_local] = ACTIONS(2850),
    [anon_sym___thread] = ACTIONS(2850),
    [anon_sym_const] = ACTIONS(2850),
    [anon_sym_constexpr] = ACTIONS(2850),
    [anon_sym_volatile] = ACTIONS(2850),
    [anon_sym_restrict] = ACTIONS(2850),
    [anon_sym___restrict__] = ACTIONS(2850),
    [anon_sym__Atomic] = ACTIONS(2850),
    [anon_sym__Noreturn] = ACTIONS(2850),
    [anon_sym_noreturn] = ACTIONS(2850),
    [anon_sym_mutable] = ACTIONS(2850),
    [anon_sym_constinit] = ACTIONS(2850),
    [anon_sym_consteval] = ACTIONS(2850),
    [anon_sym_alignas] = ACTIONS(2850),
    [anon_sym__Alignas] = ACTIONS(2850),
    [sym_primitive_type] = ACTIONS(2850),
    [anon_sym_enum] = ACTIONS(2850),
    [anon_sym_class] = ACTIONS(2850),
    [anon_sym_struct] = ACTIONS(2850),
    [anon_sym_union] = ACTIONS(2850),
    [anon_sym_if] = ACTIONS(2850),
    [anon_sym_else] = ACTIONS(3723),
    [anon_sym_switch] = ACTIONS(2850),
    [anon_sym_case] = ACTIONS(2850),
    [anon_sym_default] = ACTIONS(2850),
    [anon_sym_while] = ACTIONS(2850),
    [anon_sym_do] = ACTIONS(2850),
    [anon_sym_for] = ACTIONS(2850),
    [anon_sym_return] = ACTIONS(2850),
    [anon_sym_break] = ACTIONS(2850),
    [anon_sym_continue] = ACTIONS(2850),
    [anon_sym_goto] = ACTIONS(2850),
    [anon_sym___try] = ACTIONS(2850),
    [anon_sym___leave] = ACTIONS(2850),
    [anon_sym_not] = ACTIONS(2850),
    [anon_sym_compl] = ACTIONS(2850),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_sizeof] = ACTIONS(2850),
    [anon_sym___alignof__] = ACTIONS(2850),
    [anon_sym___alignof] = ACTIONS(2850),
    [anon_sym__alignof] = ACTIONS(2850),
    [anon_sym_alignof] = ACTIONS(2850),
    [anon_sym__Alignof] = ACTIONS(2850),
    [anon_sym_offsetof] = ACTIONS(2850),
    [anon_sym__Generic] = ACTIONS(2850),
    [anon_sym_asm] = ACTIONS(2850),
    [anon_sym___asm__] = ACTIONS(2850),
    [sym_number_literal] = ACTIONS(2852),
    [anon_sym_L_SQUOTE] = ACTIONS(2852),
    [anon_sym_u_SQUOTE] = ACTIONS(2852),
    [anon_sym_U_SQUOTE] = ACTIONS(2852),
    [anon_sym_u8_SQUOTE] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2852),
    [anon_sym_L_DQUOTE] = ACTIONS(2852),
    [anon_sym_u_DQUOTE] = ACTIONS(2852),
    [anon_sym_U_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8_DQUOTE] = ACTIONS(2852),
    [anon_sym_DQUOTE] = ACTIONS(2852),
    [sym_true] = ACTIONS(2850),
    [sym_false] = ACTIONS(2850),
    [anon_sym_NULL] = ACTIONS(2850),
    [anon_sym_nullptr] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2850),
    [anon_sym_let] = ACTIONS(2850),
    [anon_sym_This] = ACTIONS(2850),
    [anon_sym_decltype] = ACTIONS(2850),
    [sym_virtual] = ACTIONS(2850),
    [anon_sym_explicit] = ACTIONS(2850),
    [anon_sym_typename] = ACTIONS(2850),
    [anon_sym_template] = ACTIONS(2850),
    [anon_sym_operator] = ACTIONS(2850),
    [anon_sym_try] = ACTIONS(2850),
    [anon_sym_delete] = ACTIONS(2850),
    [anon_sym_throw] = ACTIONS(2850),
    [anon_sym_namespace] = ACTIONS(2850),
    [anon_sym_using] = ACTIONS(2850),
    [anon_sym_static_assert] = ACTIONS(2850),
    [anon_sym_concept] = ACTIONS(2850),
    [anon_sym_co_return] = ACTIONS(2850),
    [anon_sym_co_yield] = ACTIONS(2850),
    [anon_sym_R_DQUOTE] = ACTIONS(2852),
    [anon_sym_LR_DQUOTE] = ACTIONS(2852),
    [anon_sym_uR_DQUOTE] = ACTIONS(2852),
    [anon_sym_UR_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2852),
    [anon_sym_co_await] = ACTIONS(2850),
    [anon_sym_new] = ACTIONS(2850),
    [anon_sym_requires] = ACTIONS(2850),
    [sym_this] = ACTIONS(2850),
    [anon_sym_discard] = ACTIONS(2850),
    [anon_sym_precise] = ACTIONS(2850),
    [anon_sym_shared] = ACTIONS(2850),
    [anon_sym_groupshared] = ACTIONS(2850),
    [anon_sym_uniform] = ACTIONS(2850),
    [anon_sym_row_major] = ACTIONS(2850),
    [anon_sym_column_major] = ACTIONS(2850),
    [anon_sym_globallycoherent] = ACTIONS(2850),
    [anon_sym_centroid] = ACTIONS(2850),
    [anon_sym_noperspective] = ACTIONS(2850),
    [anon_sym_nointerpolation] = ACTIONS(2850),
    [anon_sym_sample] = ACTIONS(2850),
    [anon_sym_linear] = ACTIONS(2850),
    [anon_sym_snorm] = ACTIONS(2850),
    [anon_sym_unorm] = ACTIONS(2850),
    [anon_sym_point] = ACTIONS(2850),
    [anon_sym_line] = ACTIONS(2850),
    [anon_sym_triangleadj] = ACTIONS(2850),
    [anon_sym_lineadj] = ACTIONS(2850),
    [anon_sym_triangle] = ACTIONS(2850),
    [anon_sym_cbuffer] = ACTIONS(2850),
    [anon_sym_interface] = ACTIONS(2850),
    [anon_sym_extension] = ACTIONS(2850),
  },
  [617] = {
    [sym_attribute_specifier] = STATE(703),
    [sym_identifier] = ACTIONS(3725),
    [aux_sym_preproc_include_token1] = ACTIONS(3725),
    [aux_sym_preproc_def_token1] = ACTIONS(3725),
    [aux_sym_preproc_if_token1] = ACTIONS(3725),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3725),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3725),
    [sym_preproc_directive] = ACTIONS(3725),
    [anon_sym_LPAREN2] = ACTIONS(3727),
    [anon_sym_BANG] = ACTIONS(3727),
    [anon_sym_TILDE] = ACTIONS(3727),
    [anon_sym_DASH] = ACTIONS(3725),
    [anon_sym_PLUS] = ACTIONS(3725),
    [anon_sym_STAR] = ACTIONS(3727),
    [anon_sym_AMP_AMP] = ACTIONS(3727),
    [anon_sym_AMP] = ACTIONS(3725),
    [anon_sym_SEMI] = ACTIONS(3727),
    [anon_sym___extension__] = ACTIONS(3725),
    [anon_sym_typedef] = ACTIONS(3725),
    [anon_sym_in] = ACTIONS(3725),
    [anon_sym_out] = ACTIONS(3725),
    [anon_sym_inout] = ACTIONS(3725),
    [anon_sym_extern] = ACTIONS(3725),
    [anon_sym___attribute__] = ACTIONS(2687),
    [anon_sym_COLON_COLON] = ACTIONS(3727),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3727),
    [anon_sym___declspec] = ACTIONS(3725),
    [anon_sym___based] = ACTIONS(3725),
    [anon_sym___cdecl] = ACTIONS(3725),
    [anon_sym___clrcall] = ACTIONS(3725),
    [anon_sym___stdcall] = ACTIONS(3725),
    [anon_sym___fastcall] = ACTIONS(3725),
    [anon_sym___thiscall] = ACTIONS(3725),
    [anon_sym___vectorcall] = ACTIONS(3725),
    [anon_sym_LBRACE] = ACTIONS(3727),
    [anon_sym_RBRACE] = ACTIONS(3727),
    [anon_sym_signed] = ACTIONS(3725),
    [anon_sym_unsigned] = ACTIONS(3725),
    [anon_sym_long] = ACTIONS(3725),
    [anon_sym_short] = ACTIONS(3725),
    [anon_sym_LBRACK] = ACTIONS(3725),
    [anon_sym_static] = ACTIONS(3725),
    [anon_sym_register] = ACTIONS(3725),
    [anon_sym_inline] = ACTIONS(3725),
    [anon_sym___inline] = ACTIONS(3725),
    [anon_sym___inline__] = ACTIONS(3725),
    [anon_sym___forceinline] = ACTIONS(3725),
    [anon_sym_thread_local] = ACTIONS(3725),
    [anon_sym___thread] = ACTIONS(3725),
    [anon_sym_const] = ACTIONS(3725),
    [anon_sym_constexpr] = ACTIONS(3725),
    [anon_sym_volatile] = ACTIONS(3725),
    [anon_sym_restrict] = ACTIONS(3725),
    [anon_sym___restrict__] = ACTIONS(3725),
    [anon_sym__Atomic] = ACTIONS(3725),
    [anon_sym__Noreturn] = ACTIONS(3725),
    [anon_sym_noreturn] = ACTIONS(3725),
    [anon_sym_mutable] = ACTIONS(3725),
    [anon_sym_constinit] = ACTIONS(3725),
    [anon_sym_consteval] = ACTIONS(3725),
    [anon_sym_alignas] = ACTIONS(3725),
    [anon_sym__Alignas] = ACTIONS(3725),
    [sym_primitive_type] = ACTIONS(3725),
    [anon_sym_enum] = ACTIONS(3725),
    [anon_sym_class] = ACTIONS(3725),
    [anon_sym_struct] = ACTIONS(3725),
    [anon_sym_union] = ACTIONS(3725),
    [anon_sym_if] = ACTIONS(3725),
    [anon_sym_switch] = ACTIONS(3725),
    [anon_sym_case] = ACTIONS(3725),
    [anon_sym_default] = ACTIONS(3725),
    [anon_sym_while] = ACTIONS(3725),
    [anon_sym_do] = ACTIONS(3725),
    [anon_sym_for] = ACTIONS(3725),
    [anon_sym_return] = ACTIONS(3725),
    [anon_sym_break] = ACTIONS(3725),
    [anon_sym_continue] = ACTIONS(3725),
    [anon_sym_goto] = ACTIONS(3725),
    [anon_sym___try] = ACTIONS(3725),
    [anon_sym___leave] = ACTIONS(3725),
    [anon_sym_not] = ACTIONS(3725),
    [anon_sym_compl] = ACTIONS(3725),
    [anon_sym_DASH_DASH] = ACTIONS(3727),
    [anon_sym_PLUS_PLUS] = ACTIONS(3727),
    [anon_sym_sizeof] = ACTIONS(3725),
    [anon_sym___alignof__] = ACTIONS(3725),
    [anon_sym___alignof] = ACTIONS(3725),
    [anon_sym__alignof] = ACTIONS(3725),
    [anon_sym_alignof] = ACTIONS(3725),
    [anon_sym__Alignof] = ACTIONS(3725),
    [anon_sym_offsetof] = ACTIONS(3725),
    [anon_sym__Generic] = ACTIONS(3725),
    [anon_sym_asm] = ACTIONS(3725),
    [anon_sym___asm__] = ACTIONS(3725),
    [anon_sym_DOT] = ACTIONS(3725),
    [sym_number_literal] = ACTIONS(3727),
    [anon_sym_L_SQUOTE] = ACTIONS(3727),
    [anon_sym_u_SQUOTE] = ACTIONS(3727),
    [anon_sym_U_SQUOTE] = ACTIONS(3727),
    [anon_sym_u8_SQUOTE] = ACTIONS(3727),
    [anon_sym_SQUOTE] = ACTIONS(3727),
    [anon_sym_L_DQUOTE] = ACTIONS(3727),
    [anon_sym_u_DQUOTE] = ACTIONS(3727),
    [anon_sym_U_DQUOTE] = ACTIONS(3727),
    [anon_sym_u8_DQUOTE] = ACTIONS(3727),
    [anon_sym_DQUOTE] = ACTIONS(3727),
    [sym_true] = ACTIONS(3725),
    [sym_false] = ACTIONS(3725),
    [anon_sym_NULL] = ACTIONS(3725),
    [anon_sym_nullptr] = ACTIONS(3725),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3725),
    [anon_sym_let] = ACTIONS(3725),
    [anon_sym_This] = ACTIONS(3725),
    [anon_sym_decltype] = ACTIONS(3725),
    [sym_virtual] = ACTIONS(3725),
    [anon_sym_explicit] = ACTIONS(3725),
    [anon_sym_typename] = ACTIONS(3725),
    [anon_sym_template] = ACTIONS(3725),
    [anon_sym_operator] = ACTIONS(3725),
    [anon_sym_try] = ACTIONS(3725),
    [anon_sym_delete] = ACTIONS(3725),
    [anon_sym_throw] = ACTIONS(3725),
    [anon_sym_namespace] = ACTIONS(3725),
    [anon_sym_using] = ACTIONS(3725),
    [anon_sym_static_assert] = ACTIONS(3725),
    [anon_sym_concept] = ACTIONS(3725),
    [anon_sym_co_return] = ACTIONS(3725),
    [anon_sym_co_yield] = ACTIONS(3725),
    [anon_sym_R_DQUOTE] = ACTIONS(3727),
    [anon_sym_LR_DQUOTE] = ACTIONS(3727),
    [anon_sym_uR_DQUOTE] = ACTIONS(3727),
    [anon_sym_UR_DQUOTE] = ACTIONS(3727),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3727),
    [anon_sym_co_await] = ACTIONS(3725),
    [anon_sym_new] = ACTIONS(3725),
    [anon_sym_requires] = ACTIONS(3725),
    [sym_this] = ACTIONS(3725),
    [anon_sym_discard] = ACTIONS(3725),
    [anon_sym_precise] = ACTIONS(3725),
    [anon_sym_shared] = ACTIONS(3725),
    [anon_sym_groupshared] = ACTIONS(3725),
    [anon_sym_uniform] = ACTIONS(3725),
    [anon_sym_row_major] = ACTIONS(3725),
    [anon_sym_column_major] = ACTIONS(3725),
    [anon_sym_globallycoherent] = ACTIONS(3725),
    [anon_sym_centroid] = ACTIONS(3725),
    [anon_sym_noperspective] = ACTIONS(3725),
    [anon_sym_nointerpolation] = ACTIONS(3725),
    [anon_sym_sample] = ACTIONS(3725),
    [anon_sym_linear] = ACTIONS(3725),
    [anon_sym_snorm] = ACTIONS(3725),
    [anon_sym_unorm] = ACTIONS(3725),
    [anon_sym_point] = ACTIONS(3725),
    [anon_sym_line] = ACTIONS(3725),
    [anon_sym_triangleadj] = ACTIONS(3725),
    [anon_sym_lineadj] = ACTIONS(3725),
    [anon_sym_triangle] = ACTIONS(3725),
    [anon_sym_cbuffer] = ACTIONS(3725),
    [anon_sym_interface] = ACTIONS(3725),
    [anon_sym_extension] = ACTIONS(3725),
  },
  [618] = {
    [sym_identifier] = ACTIONS(2355),
    [aux_sym_preproc_include_token1] = ACTIONS(2355),
    [aux_sym_preproc_def_token1] = ACTIONS(2355),
    [aux_sym_preproc_if_token1] = ACTIONS(2355),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2355),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2355),
    [sym_preproc_directive] = ACTIONS(2355),
    [anon_sym_LPAREN2] = ACTIONS(2353),
    [anon_sym_BANG] = ACTIONS(2353),
    [anon_sym_TILDE] = ACTIONS(2353),
    [anon_sym_DASH] = ACTIONS(2355),
    [anon_sym_PLUS] = ACTIONS(2355),
    [anon_sym_STAR] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(2353),
    [anon_sym_AMP] = ACTIONS(2355),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym___extension__] = ACTIONS(2355),
    [anon_sym_typedef] = ACTIONS(2355),
    [anon_sym_in] = ACTIONS(2355),
    [anon_sym_out] = ACTIONS(2355),
    [anon_sym_inout] = ACTIONS(2355),
    [anon_sym_extern] = ACTIONS(2355),
    [anon_sym___attribute__] = ACTIONS(2355),
    [anon_sym_COLON_COLON] = ACTIONS(2353),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2353),
    [anon_sym___declspec] = ACTIONS(2355),
    [anon_sym___based] = ACTIONS(2355),
    [anon_sym___cdecl] = ACTIONS(2355),
    [anon_sym___clrcall] = ACTIONS(2355),
    [anon_sym___stdcall] = ACTIONS(2355),
    [anon_sym___fastcall] = ACTIONS(2355),
    [anon_sym___thiscall] = ACTIONS(2355),
    [anon_sym___vectorcall] = ACTIONS(2355),
    [anon_sym_LBRACE] = ACTIONS(2353),
    [anon_sym_RBRACE] = ACTIONS(2353),
    [anon_sym_signed] = ACTIONS(2355),
    [anon_sym_unsigned] = ACTIONS(2355),
    [anon_sym_long] = ACTIONS(2355),
    [anon_sym_short] = ACTIONS(2355),
    [anon_sym_LBRACK] = ACTIONS(2355),
    [anon_sym_static] = ACTIONS(2355),
    [anon_sym_register] = ACTIONS(2355),
    [anon_sym_inline] = ACTIONS(2355),
    [anon_sym___inline] = ACTIONS(2355),
    [anon_sym___inline__] = ACTIONS(2355),
    [anon_sym___forceinline] = ACTIONS(2355),
    [anon_sym_thread_local] = ACTIONS(2355),
    [anon_sym___thread] = ACTIONS(2355),
    [anon_sym_const] = ACTIONS(2355),
    [anon_sym_constexpr] = ACTIONS(2355),
    [anon_sym_volatile] = ACTIONS(2355),
    [anon_sym_restrict] = ACTIONS(2355),
    [anon_sym___restrict__] = ACTIONS(2355),
    [anon_sym__Atomic] = ACTIONS(2355),
    [anon_sym__Noreturn] = ACTIONS(2355),
    [anon_sym_noreturn] = ACTIONS(2355),
    [anon_sym_mutable] = ACTIONS(2355),
    [anon_sym_constinit] = ACTIONS(2355),
    [anon_sym_consteval] = ACTIONS(2355),
    [anon_sym_alignas] = ACTIONS(2355),
    [anon_sym__Alignas] = ACTIONS(2355),
    [sym_primitive_type] = ACTIONS(2355),
    [anon_sym_enum] = ACTIONS(2355),
    [anon_sym_class] = ACTIONS(2355),
    [anon_sym_struct] = ACTIONS(2355),
    [anon_sym_union] = ACTIONS(2355),
    [anon_sym_if] = ACTIONS(2355),
    [anon_sym_else] = ACTIONS(2355),
    [anon_sym_switch] = ACTIONS(2355),
    [anon_sym_case] = ACTIONS(2355),
    [anon_sym_default] = ACTIONS(2355),
    [anon_sym_while] = ACTIONS(2355),
    [anon_sym_do] = ACTIONS(2355),
    [anon_sym_for] = ACTIONS(2355),
    [anon_sym_return] = ACTIONS(2355),
    [anon_sym_break] = ACTIONS(2355),
    [anon_sym_continue] = ACTIONS(2355),
    [anon_sym_goto] = ACTIONS(2355),
    [anon_sym___try] = ACTIONS(2355),
    [anon_sym___leave] = ACTIONS(2355),
    [anon_sym_not] = ACTIONS(2355),
    [anon_sym_compl] = ACTIONS(2355),
    [anon_sym_DASH_DASH] = ACTIONS(2353),
    [anon_sym_PLUS_PLUS] = ACTIONS(2353),
    [anon_sym_sizeof] = ACTIONS(2355),
    [anon_sym___alignof__] = ACTIONS(2355),
    [anon_sym___alignof] = ACTIONS(2355),
    [anon_sym__alignof] = ACTIONS(2355),
    [anon_sym_alignof] = ACTIONS(2355),
    [anon_sym__Alignof] = ACTIONS(2355),
    [anon_sym_offsetof] = ACTIONS(2355),
    [anon_sym__Generic] = ACTIONS(2355),
    [anon_sym_asm] = ACTIONS(2355),
    [anon_sym___asm__] = ACTIONS(2355),
    [sym_number_literal] = ACTIONS(2353),
    [anon_sym_L_SQUOTE] = ACTIONS(2353),
    [anon_sym_u_SQUOTE] = ACTIONS(2353),
    [anon_sym_U_SQUOTE] = ACTIONS(2353),
    [anon_sym_u8_SQUOTE] = ACTIONS(2353),
    [anon_sym_SQUOTE] = ACTIONS(2353),
    [anon_sym_L_DQUOTE] = ACTIONS(2353),
    [anon_sym_u_DQUOTE] = ACTIONS(2353),
    [anon_sym_U_DQUOTE] = ACTIONS(2353),
    [anon_sym_u8_DQUOTE] = ACTIONS(2353),
    [anon_sym_DQUOTE] = ACTIONS(2353),
    [sym_true] = ACTIONS(2355),
    [sym_false] = ACTIONS(2355),
    [anon_sym_NULL] = ACTIONS(2355),
    [anon_sym_nullptr] = ACTIONS(2355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2355),
    [anon_sym_let] = ACTIONS(2355),
    [anon_sym_This] = ACTIONS(2355),
    [anon_sym_decltype] = ACTIONS(2355),
    [sym_virtual] = ACTIONS(2355),
    [anon_sym_explicit] = ACTIONS(2355),
    [anon_sym_typename] = ACTIONS(2355),
    [anon_sym_template] = ACTIONS(2355),
    [anon_sym_operator] = ACTIONS(2355),
    [anon_sym_try] = ACTIONS(2355),
    [anon_sym_delete] = ACTIONS(2355),
    [anon_sym_throw] = ACTIONS(2355),
    [anon_sym_namespace] = ACTIONS(2355),
    [anon_sym_using] = ACTIONS(2355),
    [anon_sym_static_assert] = ACTIONS(2355),
    [anon_sym_concept] = ACTIONS(2355),
    [anon_sym_co_return] = ACTIONS(2355),
    [anon_sym_co_yield] = ACTIONS(2355),
    [anon_sym_catch] = ACTIONS(2355),
    [anon_sym_R_DQUOTE] = ACTIONS(2353),
    [anon_sym_LR_DQUOTE] = ACTIONS(2353),
    [anon_sym_uR_DQUOTE] = ACTIONS(2353),
    [anon_sym_UR_DQUOTE] = ACTIONS(2353),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2353),
    [anon_sym_co_await] = ACTIONS(2355),
    [anon_sym_new] = ACTIONS(2355),
    [anon_sym_requires] = ACTIONS(2355),
    [sym_this] = ACTIONS(2355),
    [anon_sym_discard] = ACTIONS(2355),
    [anon_sym_precise] = ACTIONS(2355),
    [anon_sym_shared] = ACTIONS(2355),
    [anon_sym_groupshared] = ACTIONS(2355),
    [anon_sym_uniform] = ACTIONS(2355),
    [anon_sym_row_major] = ACTIONS(2355),
    [anon_sym_column_major] = ACTIONS(2355),
    [anon_sym_globallycoherent] = ACTIONS(2355),
    [anon_sym_centroid] = ACTIONS(2355),
    [anon_sym_noperspective] = ACTIONS(2355),
    [anon_sym_nointerpolation] = ACTIONS(2355),
    [anon_sym_sample] = ACTIONS(2355),
    [anon_sym_linear] = ACTIONS(2355),
    [anon_sym_snorm] = ACTIONS(2355),
    [anon_sym_unorm] = ACTIONS(2355),
    [anon_sym_point] = ACTIONS(2355),
    [anon_sym_line] = ACTIONS(2355),
    [anon_sym_triangleadj] = ACTIONS(2355),
    [anon_sym_lineadj] = ACTIONS(2355),
    [anon_sym_triangle] = ACTIONS(2355),
    [anon_sym_cbuffer] = ACTIONS(2355),
    [anon_sym_interface] = ACTIONS(2355),
    [anon_sym_extension] = ACTIONS(2355),
  },
  [619] = {
    [sym_else_clause] = STATE(666),
    [sym_identifier] = ACTIONS(2836),
    [aux_sym_preproc_include_token1] = ACTIONS(2836),
    [aux_sym_preproc_def_token1] = ACTIONS(2836),
    [aux_sym_preproc_if_token1] = ACTIONS(2836),
    [aux_sym_preproc_if_token2] = ACTIONS(2836),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2836),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2836),
    [sym_preproc_directive] = ACTIONS(2836),
    [anon_sym_LPAREN2] = ACTIONS(2838),
    [anon_sym_BANG] = ACTIONS(2838),
    [anon_sym_TILDE] = ACTIONS(2838),
    [anon_sym_DASH] = ACTIONS(2836),
    [anon_sym_PLUS] = ACTIONS(2836),
    [anon_sym_STAR] = ACTIONS(2838),
    [anon_sym_AMP_AMP] = ACTIONS(2838),
    [anon_sym_AMP] = ACTIONS(2836),
    [anon_sym_SEMI] = ACTIONS(2838),
    [anon_sym___extension__] = ACTIONS(2836),
    [anon_sym_typedef] = ACTIONS(2836),
    [anon_sym_in] = ACTIONS(2836),
    [anon_sym_out] = ACTIONS(2836),
    [anon_sym_inout] = ACTIONS(2836),
    [anon_sym_extern] = ACTIONS(2836),
    [anon_sym___attribute__] = ACTIONS(2836),
    [anon_sym_COLON_COLON] = ACTIONS(2838),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2838),
    [anon_sym___declspec] = ACTIONS(2836),
    [anon_sym___based] = ACTIONS(2836),
    [anon_sym___cdecl] = ACTIONS(2836),
    [anon_sym___clrcall] = ACTIONS(2836),
    [anon_sym___stdcall] = ACTIONS(2836),
    [anon_sym___fastcall] = ACTIONS(2836),
    [anon_sym___thiscall] = ACTIONS(2836),
    [anon_sym___vectorcall] = ACTIONS(2836),
    [anon_sym_LBRACE] = ACTIONS(2838),
    [anon_sym_signed] = ACTIONS(2836),
    [anon_sym_unsigned] = ACTIONS(2836),
    [anon_sym_long] = ACTIONS(2836),
    [anon_sym_short] = ACTIONS(2836),
    [anon_sym_LBRACK] = ACTIONS(2836),
    [anon_sym_static] = ACTIONS(2836),
    [anon_sym_register] = ACTIONS(2836),
    [anon_sym_inline] = ACTIONS(2836),
    [anon_sym___inline] = ACTIONS(2836),
    [anon_sym___inline__] = ACTIONS(2836),
    [anon_sym___forceinline] = ACTIONS(2836),
    [anon_sym_thread_local] = ACTIONS(2836),
    [anon_sym___thread] = ACTIONS(2836),
    [anon_sym_const] = ACTIONS(2836),
    [anon_sym_constexpr] = ACTIONS(2836),
    [anon_sym_volatile] = ACTIONS(2836),
    [anon_sym_restrict] = ACTIONS(2836),
    [anon_sym___restrict__] = ACTIONS(2836),
    [anon_sym__Atomic] = ACTIONS(2836),
    [anon_sym__Noreturn] = ACTIONS(2836),
    [anon_sym_noreturn] = ACTIONS(2836),
    [anon_sym_mutable] = ACTIONS(2836),
    [anon_sym_constinit] = ACTIONS(2836),
    [anon_sym_consteval] = ACTIONS(2836),
    [anon_sym_alignas] = ACTIONS(2836),
    [anon_sym__Alignas] = ACTIONS(2836),
    [sym_primitive_type] = ACTIONS(2836),
    [anon_sym_enum] = ACTIONS(2836),
    [anon_sym_class] = ACTIONS(2836),
    [anon_sym_struct] = ACTIONS(2836),
    [anon_sym_union] = ACTIONS(2836),
    [anon_sym_if] = ACTIONS(2836),
    [anon_sym_else] = ACTIONS(3729),
    [anon_sym_switch] = ACTIONS(2836),
    [anon_sym_case] = ACTIONS(2836),
    [anon_sym_default] = ACTIONS(2836),
    [anon_sym_while] = ACTIONS(2836),
    [anon_sym_do] = ACTIONS(2836),
    [anon_sym_for] = ACTIONS(2836),
    [anon_sym_return] = ACTIONS(2836),
    [anon_sym_break] = ACTIONS(2836),
    [anon_sym_continue] = ACTIONS(2836),
    [anon_sym_goto] = ACTIONS(2836),
    [anon_sym___try] = ACTIONS(2836),
    [anon_sym___leave] = ACTIONS(2836),
    [anon_sym_not] = ACTIONS(2836),
    [anon_sym_compl] = ACTIONS(2836),
    [anon_sym_DASH_DASH] = ACTIONS(2838),
    [anon_sym_PLUS_PLUS] = ACTIONS(2838),
    [anon_sym_sizeof] = ACTIONS(2836),
    [anon_sym___alignof__] = ACTIONS(2836),
    [anon_sym___alignof] = ACTIONS(2836),
    [anon_sym__alignof] = ACTIONS(2836),
    [anon_sym_alignof] = ACTIONS(2836),
    [anon_sym__Alignof] = ACTIONS(2836),
    [anon_sym_offsetof] = ACTIONS(2836),
    [anon_sym__Generic] = ACTIONS(2836),
    [anon_sym_asm] = ACTIONS(2836),
    [anon_sym___asm__] = ACTIONS(2836),
    [sym_number_literal] = ACTIONS(2838),
    [anon_sym_L_SQUOTE] = ACTIONS(2838),
    [anon_sym_u_SQUOTE] = ACTIONS(2838),
    [anon_sym_U_SQUOTE] = ACTIONS(2838),
    [anon_sym_u8_SQUOTE] = ACTIONS(2838),
    [anon_sym_SQUOTE] = ACTIONS(2838),
    [anon_sym_L_DQUOTE] = ACTIONS(2838),
    [anon_sym_u_DQUOTE] = ACTIONS(2838),
    [anon_sym_U_DQUOTE] = ACTIONS(2838),
    [anon_sym_u8_DQUOTE] = ACTIONS(2838),
    [anon_sym_DQUOTE] = ACTIONS(2838),
    [sym_true] = ACTIONS(2836),
    [sym_false] = ACTIONS(2836),
    [anon_sym_NULL] = ACTIONS(2836),
    [anon_sym_nullptr] = ACTIONS(2836),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2836),
    [anon_sym_let] = ACTIONS(2836),
    [anon_sym_This] = ACTIONS(2836),
    [anon_sym_decltype] = ACTIONS(2836),
    [sym_virtual] = ACTIONS(2836),
    [anon_sym_explicit] = ACTIONS(2836),
    [anon_sym_typename] = ACTIONS(2836),
    [anon_sym_template] = ACTIONS(2836),
    [anon_sym_operator] = ACTIONS(2836),
    [anon_sym_try] = ACTIONS(2836),
    [anon_sym_delete] = ACTIONS(2836),
    [anon_sym_throw] = ACTIONS(2836),
    [anon_sym_namespace] = ACTIONS(2836),
    [anon_sym_using] = ACTIONS(2836),
    [anon_sym_static_assert] = ACTIONS(2836),
    [anon_sym_concept] = ACTIONS(2836),
    [anon_sym_co_return] = ACTIONS(2836),
    [anon_sym_co_yield] = ACTIONS(2836),
    [anon_sym_R_DQUOTE] = ACTIONS(2838),
    [anon_sym_LR_DQUOTE] = ACTIONS(2838),
    [anon_sym_uR_DQUOTE] = ACTIONS(2838),
    [anon_sym_UR_DQUOTE] = ACTIONS(2838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2838),
    [anon_sym_co_await] = ACTIONS(2836),
    [anon_sym_new] = ACTIONS(2836),
    [anon_sym_requires] = ACTIONS(2836),
    [sym_this] = ACTIONS(2836),
    [anon_sym_discard] = ACTIONS(2836),
    [anon_sym_precise] = ACTIONS(2836),
    [anon_sym_shared] = ACTIONS(2836),
    [anon_sym_groupshared] = ACTIONS(2836),
    [anon_sym_uniform] = ACTIONS(2836),
    [anon_sym_row_major] = ACTIONS(2836),
    [anon_sym_column_major] = ACTIONS(2836),
    [anon_sym_globallycoherent] = ACTIONS(2836),
    [anon_sym_centroid] = ACTIONS(2836),
    [anon_sym_noperspective] = ACTIONS(2836),
    [anon_sym_nointerpolation] = ACTIONS(2836),
    [anon_sym_sample] = ACTIONS(2836),
    [anon_sym_linear] = ACTIONS(2836),
    [anon_sym_snorm] = ACTIONS(2836),
    [anon_sym_unorm] = ACTIONS(2836),
    [anon_sym_point] = ACTIONS(2836),
    [anon_sym_line] = ACTIONS(2836),
    [anon_sym_triangleadj] = ACTIONS(2836),
    [anon_sym_lineadj] = ACTIONS(2836),
    [anon_sym_triangle] = ACTIONS(2836),
    [anon_sym_cbuffer] = ACTIONS(2836),
    [anon_sym_interface] = ACTIONS(2836),
    [anon_sym_extension] = ACTIONS(2836),
  },
  [620] = {
    [sym_attribute_specifier] = STATE(686),
    [sym_identifier] = ACTIONS(3731),
    [aux_sym_preproc_include_token1] = ACTIONS(3731),
    [aux_sym_preproc_def_token1] = ACTIONS(3731),
    [aux_sym_preproc_if_token1] = ACTIONS(3731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3731),
    [sym_preproc_directive] = ACTIONS(3731),
    [anon_sym_LPAREN2] = ACTIONS(3733),
    [anon_sym_BANG] = ACTIONS(3733),
    [anon_sym_TILDE] = ACTIONS(3733),
    [anon_sym_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3731),
    [anon_sym_STAR] = ACTIONS(3733),
    [anon_sym_AMP_AMP] = ACTIONS(3733),
    [anon_sym_AMP] = ACTIONS(3731),
    [anon_sym_SEMI] = ACTIONS(3733),
    [anon_sym___extension__] = ACTIONS(3731),
    [anon_sym_typedef] = ACTIONS(3731),
    [anon_sym_in] = ACTIONS(3731),
    [anon_sym_out] = ACTIONS(3731),
    [anon_sym_inout] = ACTIONS(3731),
    [anon_sym_extern] = ACTIONS(3731),
    [anon_sym___attribute__] = ACTIONS(2687),
    [anon_sym_COLON_COLON] = ACTIONS(3733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3733),
    [anon_sym___declspec] = ACTIONS(3731),
    [anon_sym___based] = ACTIONS(3731),
    [anon_sym___cdecl] = ACTIONS(3731),
    [anon_sym___clrcall] = ACTIONS(3731),
    [anon_sym___stdcall] = ACTIONS(3731),
    [anon_sym___fastcall] = ACTIONS(3731),
    [anon_sym___thiscall] = ACTIONS(3731),
    [anon_sym___vectorcall] = ACTIONS(3731),
    [anon_sym_LBRACE] = ACTIONS(3733),
    [anon_sym_RBRACE] = ACTIONS(3733),
    [anon_sym_signed] = ACTIONS(3731),
    [anon_sym_unsigned] = ACTIONS(3731),
    [anon_sym_long] = ACTIONS(3731),
    [anon_sym_short] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3731),
    [anon_sym_static] = ACTIONS(3731),
    [anon_sym_register] = ACTIONS(3731),
    [anon_sym_inline] = ACTIONS(3731),
    [anon_sym___inline] = ACTIONS(3731),
    [anon_sym___inline__] = ACTIONS(3731),
    [anon_sym___forceinline] = ACTIONS(3731),
    [anon_sym_thread_local] = ACTIONS(3731),
    [anon_sym___thread] = ACTIONS(3731),
    [anon_sym_const] = ACTIONS(3731),
    [anon_sym_constexpr] = ACTIONS(3731),
    [anon_sym_volatile] = ACTIONS(3731),
    [anon_sym_restrict] = ACTIONS(3731),
    [anon_sym___restrict__] = ACTIONS(3731),
    [anon_sym__Atomic] = ACTIONS(3731),
    [anon_sym__Noreturn] = ACTIONS(3731),
    [anon_sym_noreturn] = ACTIONS(3731),
    [anon_sym_mutable] = ACTIONS(3731),
    [anon_sym_constinit] = ACTIONS(3731),
    [anon_sym_consteval] = ACTIONS(3731),
    [anon_sym_alignas] = ACTIONS(3731),
    [anon_sym__Alignas] = ACTIONS(3731),
    [sym_primitive_type] = ACTIONS(3731),
    [anon_sym_enum] = ACTIONS(3731),
    [anon_sym_class] = ACTIONS(3731),
    [anon_sym_struct] = ACTIONS(3731),
    [anon_sym_union] = ACTIONS(3731),
    [anon_sym_if] = ACTIONS(3731),
    [anon_sym_switch] = ACTIONS(3731),
    [anon_sym_case] = ACTIONS(3731),
    [anon_sym_default] = ACTIONS(3731),
    [anon_sym_while] = ACTIONS(3731),
    [anon_sym_do] = ACTIONS(3731),
    [anon_sym_for] = ACTIONS(3731),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_break] = ACTIONS(3731),
    [anon_sym_continue] = ACTIONS(3731),
    [anon_sym_goto] = ACTIONS(3731),
    [anon_sym___try] = ACTIONS(3731),
    [anon_sym___leave] = ACTIONS(3731),
    [anon_sym_not] = ACTIONS(3731),
    [anon_sym_compl] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3733),
    [anon_sym_PLUS_PLUS] = ACTIONS(3733),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3731),
    [anon_sym___alignof] = ACTIONS(3731),
    [anon_sym__alignof] = ACTIONS(3731),
    [anon_sym_alignof] = ACTIONS(3731),
    [anon_sym__Alignof] = ACTIONS(3731),
    [anon_sym_offsetof] = ACTIONS(3731),
    [anon_sym__Generic] = ACTIONS(3731),
    [anon_sym_asm] = ACTIONS(3731),
    [anon_sym___asm__] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3731),
    [sym_number_literal] = ACTIONS(3733),
    [anon_sym_L_SQUOTE] = ACTIONS(3733),
    [anon_sym_u_SQUOTE] = ACTIONS(3733),
    [anon_sym_U_SQUOTE] = ACTIONS(3733),
    [anon_sym_u8_SQUOTE] = ACTIONS(3733),
    [anon_sym_SQUOTE] = ACTIONS(3733),
    [anon_sym_L_DQUOTE] = ACTIONS(3733),
    [anon_sym_u_DQUOTE] = ACTIONS(3733),
    [anon_sym_U_DQUOTE] = ACTIONS(3733),
    [anon_sym_u8_DQUOTE] = ACTIONS(3733),
    [anon_sym_DQUOTE] = ACTIONS(3733),
    [sym_true] = ACTIONS(3731),
    [sym_false] = ACTIONS(3731),
    [anon_sym_NULL] = ACTIONS(3731),
    [anon_sym_nullptr] = ACTIONS(3731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3731),
    [anon_sym_let] = ACTIONS(3731),
    [anon_sym_This] = ACTIONS(3731),
    [anon_sym_decltype] = ACTIONS(3731),
    [sym_virtual] = ACTIONS(3731),
    [anon_sym_explicit] = ACTIONS(3731),
    [anon_sym_typename] = ACTIONS(3731),
    [anon_sym_template] = ACTIONS(3731),
    [anon_sym_operator] = ACTIONS(3731),
    [anon_sym_try] = ACTIONS(3731),
    [anon_sym_delete] = ACTIONS(3731),
    [anon_sym_throw] = ACTIONS(3731),
    [anon_sym_namespace] = ACTIONS(3731),
    [anon_sym_using] = ACTIONS(3731),
    [anon_sym_static_assert] = ACTIONS(3731),
    [anon_sym_concept] = ACTIONS(3731),
    [anon_sym_co_return] = ACTIONS(3731),
    [anon_sym_co_yield] = ACTIONS(3731),
    [anon_sym_R_DQUOTE] = ACTIONS(3733),
    [anon_sym_LR_DQUOTE] = ACTIONS(3733),
    [anon_sym_uR_DQUOTE] = ACTIONS(3733),
    [anon_sym_UR_DQUOTE] = ACTIONS(3733),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3733),
    [anon_sym_co_await] = ACTIONS(3731),
    [anon_sym_new] = ACTIONS(3731),
    [anon_sym_requires] = ACTIONS(3731),
    [sym_this] = ACTIONS(3731),
    [anon_sym_discard] = ACTIONS(3731),
    [anon_sym_precise] = ACTIONS(3731),
    [anon_sym_shared] = ACTIONS(3731),
    [anon_sym_groupshared] = ACTIONS(3731),
    [anon_sym_uniform] = ACTIONS(3731),
    [anon_sym_row_major] = ACTIONS(3731),
    [anon_sym_column_major] = ACTIONS(3731),
    [anon_sym_globallycoherent] = ACTIONS(3731),
    [anon_sym_centroid] = ACTIONS(3731),
    [anon_sym_noperspective] = ACTIONS(3731),
    [anon_sym_nointerpolation] = ACTIONS(3731),
    [anon_sym_sample] = ACTIONS(3731),
    [anon_sym_linear] = ACTIONS(3731),
    [anon_sym_snorm] = ACTIONS(3731),
    [anon_sym_unorm] = ACTIONS(3731),
    [anon_sym_point] = ACTIONS(3731),
    [anon_sym_line] = ACTIONS(3731),
    [anon_sym_triangleadj] = ACTIONS(3731),
    [anon_sym_lineadj] = ACTIONS(3731),
    [anon_sym_triangle] = ACTIONS(3731),
    [anon_sym_cbuffer] = ACTIONS(3731),
    [anon_sym_interface] = ACTIONS(3731),
    [anon_sym_extension] = ACTIONS(3731),
  },
  [621] = {
    [sym_attribute_specifier] = STATE(725),
    [sym_identifier] = ACTIONS(3735),
    [aux_sym_preproc_include_token1] = ACTIONS(3735),
    [aux_sym_preproc_def_token1] = ACTIONS(3735),
    [aux_sym_preproc_if_token1] = ACTIONS(3735),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3735),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3735),
    [sym_preproc_directive] = ACTIONS(3735),
    [anon_sym_LPAREN2] = ACTIONS(3737),
    [anon_sym_BANG] = ACTIONS(3737),
    [anon_sym_TILDE] = ACTIONS(3737),
    [anon_sym_DASH] = ACTIONS(3735),
    [anon_sym_PLUS] = ACTIONS(3735),
    [anon_sym_STAR] = ACTIONS(3737),
    [anon_sym_AMP_AMP] = ACTIONS(3737),
    [anon_sym_AMP] = ACTIONS(3735),
    [anon_sym_SEMI] = ACTIONS(3737),
    [anon_sym___extension__] = ACTIONS(3735),
    [anon_sym_typedef] = ACTIONS(3735),
    [anon_sym_in] = ACTIONS(3735),
    [anon_sym_out] = ACTIONS(3735),
    [anon_sym_inout] = ACTIONS(3735),
    [anon_sym_extern] = ACTIONS(3735),
    [anon_sym___attribute__] = ACTIONS(2687),
    [anon_sym_COLON_COLON] = ACTIONS(3737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3737),
    [anon_sym___declspec] = ACTIONS(3735),
    [anon_sym___based] = ACTIONS(3735),
    [anon_sym___cdecl] = ACTIONS(3735),
    [anon_sym___clrcall] = ACTIONS(3735),
    [anon_sym___stdcall] = ACTIONS(3735),
    [anon_sym___fastcall] = ACTIONS(3735),
    [anon_sym___thiscall] = ACTIONS(3735),
    [anon_sym___vectorcall] = ACTIONS(3735),
    [anon_sym_LBRACE] = ACTIONS(3737),
    [anon_sym_RBRACE] = ACTIONS(3737),
    [anon_sym_signed] = ACTIONS(3735),
    [anon_sym_unsigned] = ACTIONS(3735),
    [anon_sym_long] = ACTIONS(3735),
    [anon_sym_short] = ACTIONS(3735),
    [anon_sym_LBRACK] = ACTIONS(3735),
    [anon_sym_static] = ACTIONS(3735),
    [anon_sym_register] = ACTIONS(3735),
    [anon_sym_inline] = ACTIONS(3735),
    [anon_sym___inline] = ACTIONS(3735),
    [anon_sym___inline__] = ACTIONS(3735),
    [anon_sym___forceinline] = ACTIONS(3735),
    [anon_sym_thread_local] = ACTIONS(3735),
    [anon_sym___thread] = ACTIONS(3735),
    [anon_sym_const] = ACTIONS(3735),
    [anon_sym_constexpr] = ACTIONS(3735),
    [anon_sym_volatile] = ACTIONS(3735),
    [anon_sym_restrict] = ACTIONS(3735),
    [anon_sym___restrict__] = ACTIONS(3735),
    [anon_sym__Atomic] = ACTIONS(3735),
    [anon_sym__Noreturn] = ACTIONS(3735),
    [anon_sym_noreturn] = ACTIONS(3735),
    [anon_sym_mutable] = ACTIONS(3735),
    [anon_sym_constinit] = ACTIONS(3735),
    [anon_sym_consteval] = ACTIONS(3735),
    [anon_sym_alignas] = ACTIONS(3735),
    [anon_sym__Alignas] = ACTIONS(3735),
    [sym_primitive_type] = ACTIONS(3735),
    [anon_sym_enum] = ACTIONS(3735),
    [anon_sym_class] = ACTIONS(3735),
    [anon_sym_struct] = ACTIONS(3735),
    [anon_sym_union] = ACTIONS(3735),
    [anon_sym_if] = ACTIONS(3735),
    [anon_sym_switch] = ACTIONS(3735),
    [anon_sym_case] = ACTIONS(3735),
    [anon_sym_default] = ACTIONS(3735),
    [anon_sym_while] = ACTIONS(3735),
    [anon_sym_do] = ACTIONS(3735),
    [anon_sym_for] = ACTIONS(3735),
    [anon_sym_return] = ACTIONS(3735),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_continue] = ACTIONS(3735),
    [anon_sym_goto] = ACTIONS(3735),
    [anon_sym___try] = ACTIONS(3735),
    [anon_sym___leave] = ACTIONS(3735),
    [anon_sym_not] = ACTIONS(3735),
    [anon_sym_compl] = ACTIONS(3735),
    [anon_sym_DASH_DASH] = ACTIONS(3737),
    [anon_sym_PLUS_PLUS] = ACTIONS(3737),
    [anon_sym_sizeof] = ACTIONS(3735),
    [anon_sym___alignof__] = ACTIONS(3735),
    [anon_sym___alignof] = ACTIONS(3735),
    [anon_sym__alignof] = ACTIONS(3735),
    [anon_sym_alignof] = ACTIONS(3735),
    [anon_sym__Alignof] = ACTIONS(3735),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3735),
    [anon_sym_asm] = ACTIONS(3735),
    [anon_sym___asm__] = ACTIONS(3735),
    [anon_sym_DOT] = ACTIONS(3735),
    [sym_number_literal] = ACTIONS(3737),
    [anon_sym_L_SQUOTE] = ACTIONS(3737),
    [anon_sym_u_SQUOTE] = ACTIONS(3737),
    [anon_sym_U_SQUOTE] = ACTIONS(3737),
    [anon_sym_u8_SQUOTE] = ACTIONS(3737),
    [anon_sym_SQUOTE] = ACTIONS(3737),
    [anon_sym_L_DQUOTE] = ACTIONS(3737),
    [anon_sym_u_DQUOTE] = ACTIONS(3737),
    [anon_sym_U_DQUOTE] = ACTIONS(3737),
    [anon_sym_u8_DQUOTE] = ACTIONS(3737),
    [anon_sym_DQUOTE] = ACTIONS(3737),
    [sym_true] = ACTIONS(3735),
    [sym_false] = ACTIONS(3735),
    [anon_sym_NULL] = ACTIONS(3735),
    [anon_sym_nullptr] = ACTIONS(3735),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3735),
    [anon_sym_let] = ACTIONS(3735),
    [anon_sym_This] = ACTIONS(3735),
    [anon_sym_decltype] = ACTIONS(3735),
    [sym_virtual] = ACTIONS(3735),
    [anon_sym_explicit] = ACTIONS(3735),
    [anon_sym_typename] = ACTIONS(3735),
    [anon_sym_template] = ACTIONS(3735),
    [anon_sym_operator] = ACTIONS(3735),
    [anon_sym_try] = ACTIONS(3735),
    [anon_sym_delete] = ACTIONS(3735),
    [anon_sym_throw] = ACTIONS(3735),
    [anon_sym_namespace] = ACTIONS(3735),
    [anon_sym_using] = ACTIONS(3735),
    [anon_sym_static_assert] = ACTIONS(3735),
    [anon_sym_concept] = ACTIONS(3735),
    [anon_sym_co_return] = ACTIONS(3735),
    [anon_sym_co_yield] = ACTIONS(3735),
    [anon_sym_R_DQUOTE] = ACTIONS(3737),
    [anon_sym_LR_DQUOTE] = ACTIONS(3737),
    [anon_sym_uR_DQUOTE] = ACTIONS(3737),
    [anon_sym_UR_DQUOTE] = ACTIONS(3737),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3737),
    [anon_sym_co_await] = ACTIONS(3735),
    [anon_sym_new] = ACTIONS(3735),
    [anon_sym_requires] = ACTIONS(3735),
    [sym_this] = ACTIONS(3735),
    [anon_sym_discard] = ACTIONS(3735),
    [anon_sym_precise] = ACTIONS(3735),
    [anon_sym_shared] = ACTIONS(3735),
    [anon_sym_groupshared] = ACTIONS(3735),
    [anon_sym_uniform] = ACTIONS(3735),
    [anon_sym_row_major] = ACTIONS(3735),
    [anon_sym_column_major] = ACTIONS(3735),
    [anon_sym_globallycoherent] = ACTIONS(3735),
    [anon_sym_centroid] = ACTIONS(3735),
    [anon_sym_noperspective] = ACTIONS(3735),
    [anon_sym_nointerpolation] = ACTIONS(3735),
    [anon_sym_sample] = ACTIONS(3735),
    [anon_sym_linear] = ACTIONS(3735),
    [anon_sym_snorm] = ACTIONS(3735),
    [anon_sym_unorm] = ACTIONS(3735),
    [anon_sym_point] = ACTIONS(3735),
    [anon_sym_line] = ACTIONS(3735),
    [anon_sym_triangleadj] = ACTIONS(3735),
    [anon_sym_lineadj] = ACTIONS(3735),
    [anon_sym_triangle] = ACTIONS(3735),
    [anon_sym_cbuffer] = ACTIONS(3735),
    [anon_sym_interface] = ACTIONS(3735),
    [anon_sym_extension] = ACTIONS(3735),
  },
  [622] = {
    [sym_identifier] = ACTIONS(2355),
    [aux_sym_preproc_include_token1] = ACTIONS(2355),
    [aux_sym_preproc_def_token1] = ACTIONS(2355),
    [aux_sym_preproc_if_token1] = ACTIONS(2355),
    [aux_sym_preproc_if_token2] = ACTIONS(2355),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2355),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2355),
    [sym_preproc_directive] = ACTIONS(2355),
    [anon_sym_LPAREN2] = ACTIONS(2353),
    [anon_sym_BANG] = ACTIONS(2353),
    [anon_sym_TILDE] = ACTIONS(2353),
    [anon_sym_DASH] = ACTIONS(2355),
    [anon_sym_PLUS] = ACTIONS(2355),
    [anon_sym_STAR] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(2353),
    [anon_sym_AMP] = ACTIONS(2355),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym___extension__] = ACTIONS(2355),
    [anon_sym_typedef] = ACTIONS(2355),
    [anon_sym_in] = ACTIONS(2355),
    [anon_sym_out] = ACTIONS(2355),
    [anon_sym_inout] = ACTIONS(2355),
    [anon_sym_extern] = ACTIONS(2355),
    [anon_sym___attribute__] = ACTIONS(2355),
    [anon_sym_COLON_COLON] = ACTIONS(2353),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2353),
    [anon_sym___declspec] = ACTIONS(2355),
    [anon_sym___based] = ACTIONS(2355),
    [anon_sym___cdecl] = ACTIONS(2355),
    [anon_sym___clrcall] = ACTIONS(2355),
    [anon_sym___stdcall] = ACTIONS(2355),
    [anon_sym___fastcall] = ACTIONS(2355),
    [anon_sym___thiscall] = ACTIONS(2355),
    [anon_sym___vectorcall] = ACTIONS(2355),
    [anon_sym_LBRACE] = ACTIONS(2353),
    [anon_sym_signed] = ACTIONS(2355),
    [anon_sym_unsigned] = ACTIONS(2355),
    [anon_sym_long] = ACTIONS(2355),
    [anon_sym_short] = ACTIONS(2355),
    [anon_sym_LBRACK] = ACTIONS(2355),
    [anon_sym_static] = ACTIONS(2355),
    [anon_sym_register] = ACTIONS(2355),
    [anon_sym_inline] = ACTIONS(2355),
    [anon_sym___inline] = ACTIONS(2355),
    [anon_sym___inline__] = ACTIONS(2355),
    [anon_sym___forceinline] = ACTIONS(2355),
    [anon_sym_thread_local] = ACTIONS(2355),
    [anon_sym___thread] = ACTIONS(2355),
    [anon_sym_const] = ACTIONS(2355),
    [anon_sym_constexpr] = ACTIONS(2355),
    [anon_sym_volatile] = ACTIONS(2355),
    [anon_sym_restrict] = ACTIONS(2355),
    [anon_sym___restrict__] = ACTIONS(2355),
    [anon_sym__Atomic] = ACTIONS(2355),
    [anon_sym__Noreturn] = ACTIONS(2355),
    [anon_sym_noreturn] = ACTIONS(2355),
    [anon_sym_mutable] = ACTIONS(2355),
    [anon_sym_constinit] = ACTIONS(2355),
    [anon_sym_consteval] = ACTIONS(2355),
    [anon_sym_alignas] = ACTIONS(2355),
    [anon_sym__Alignas] = ACTIONS(2355),
    [sym_primitive_type] = ACTIONS(2355),
    [anon_sym_enum] = ACTIONS(2355),
    [anon_sym_class] = ACTIONS(2355),
    [anon_sym_struct] = ACTIONS(2355),
    [anon_sym_union] = ACTIONS(2355),
    [anon_sym_if] = ACTIONS(2355),
    [anon_sym_else] = ACTIONS(2355),
    [anon_sym_switch] = ACTIONS(2355),
    [anon_sym_case] = ACTIONS(2355),
    [anon_sym_default] = ACTIONS(2355),
    [anon_sym_while] = ACTIONS(2355),
    [anon_sym_do] = ACTIONS(2355),
    [anon_sym_for] = ACTIONS(2355),
    [anon_sym_return] = ACTIONS(2355),
    [anon_sym_break] = ACTIONS(2355),
    [anon_sym_continue] = ACTIONS(2355),
    [anon_sym_goto] = ACTIONS(2355),
    [anon_sym___try] = ACTIONS(2355),
    [anon_sym___leave] = ACTIONS(2355),
    [anon_sym_not] = ACTIONS(2355),
    [anon_sym_compl] = ACTIONS(2355),
    [anon_sym_DASH_DASH] = ACTIONS(2353),
    [anon_sym_PLUS_PLUS] = ACTIONS(2353),
    [anon_sym_sizeof] = ACTIONS(2355),
    [anon_sym___alignof__] = ACTIONS(2355),
    [anon_sym___alignof] = ACTIONS(2355),
    [anon_sym__alignof] = ACTIONS(2355),
    [anon_sym_alignof] = ACTIONS(2355),
    [anon_sym__Alignof] = ACTIONS(2355),
    [anon_sym_offsetof] = ACTIONS(2355),
    [anon_sym__Generic] = ACTIONS(2355),
    [anon_sym_asm] = ACTIONS(2355),
    [anon_sym___asm__] = ACTIONS(2355),
    [sym_number_literal] = ACTIONS(2353),
    [anon_sym_L_SQUOTE] = ACTIONS(2353),
    [anon_sym_u_SQUOTE] = ACTIONS(2353),
    [anon_sym_U_SQUOTE] = ACTIONS(2353),
    [anon_sym_u8_SQUOTE] = ACTIONS(2353),
    [anon_sym_SQUOTE] = ACTIONS(2353),
    [anon_sym_L_DQUOTE] = ACTIONS(2353),
    [anon_sym_u_DQUOTE] = ACTIONS(2353),
    [anon_sym_U_DQUOTE] = ACTIONS(2353),
    [anon_sym_u8_DQUOTE] = ACTIONS(2353),
    [anon_sym_DQUOTE] = ACTIONS(2353),
    [sym_true] = ACTIONS(2355),
    [sym_false] = ACTIONS(2355),
    [anon_sym_NULL] = ACTIONS(2355),
    [anon_sym_nullptr] = ACTIONS(2355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2355),
    [anon_sym_let] = ACTIONS(2355),
    [anon_sym_This] = ACTIONS(2355),
    [anon_sym_decltype] = ACTIONS(2355),
    [sym_virtual] = ACTIONS(2355),
    [anon_sym_explicit] = ACTIONS(2355),
    [anon_sym_typename] = ACTIONS(2355),
    [anon_sym_template] = ACTIONS(2355),
    [anon_sym_operator] = ACTIONS(2355),
    [anon_sym_try] = ACTIONS(2355),
    [anon_sym_delete] = ACTIONS(2355),
    [anon_sym_throw] = ACTIONS(2355),
    [anon_sym_namespace] = ACTIONS(2355),
    [anon_sym_using] = ACTIONS(2355),
    [anon_sym_static_assert] = ACTIONS(2355),
    [anon_sym_concept] = ACTIONS(2355),
    [anon_sym_co_return] = ACTIONS(2355),
    [anon_sym_co_yield] = ACTIONS(2355),
    [anon_sym_catch] = ACTIONS(2355),
    [anon_sym_R_DQUOTE] = ACTIONS(2353),
    [anon_sym_LR_DQUOTE] = ACTIONS(2353),
    [anon_sym_uR_DQUOTE] = ACTIONS(2353),
    [anon_sym_UR_DQUOTE] = ACTIONS(2353),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2353),
    [anon_sym_co_await] = ACTIONS(2355),
    [anon_sym_new] = ACTIONS(2355),
    [anon_sym_requires] = ACTIONS(2355),
    [sym_this] = ACTIONS(2355),
    [anon_sym_discard] = ACTIONS(2355),
    [anon_sym_precise] = ACTIONS(2355),
    [anon_sym_shared] = ACTIONS(2355),
    [anon_sym_groupshared] = ACTIONS(2355),
    [anon_sym_uniform] = ACTIONS(2355),
    [anon_sym_row_major] = ACTIONS(2355),
    [anon_sym_column_major] = ACTIONS(2355),
    [anon_sym_globallycoherent] = ACTIONS(2355),
    [anon_sym_centroid] = ACTIONS(2355),
    [anon_sym_noperspective] = ACTIONS(2355),
    [anon_sym_nointerpolation] = ACTIONS(2355),
    [anon_sym_sample] = ACTIONS(2355),
    [anon_sym_linear] = ACTIONS(2355),
    [anon_sym_snorm] = ACTIONS(2355),
    [anon_sym_unorm] = ACTIONS(2355),
    [anon_sym_point] = ACTIONS(2355),
    [anon_sym_line] = ACTIONS(2355),
    [anon_sym_triangleadj] = ACTIONS(2355),
    [anon_sym_lineadj] = ACTIONS(2355),
    [anon_sym_triangle] = ACTIONS(2355),
    [anon_sym_cbuffer] = ACTIONS(2355),
    [anon_sym_interface] = ACTIONS(2355),
    [anon_sym_extension] = ACTIONS(2355),
  },
  [623] = {
    [sym_identifier] = ACTIONS(2842),
    [aux_sym_preproc_include_token1] = ACTIONS(2842),
    [aux_sym_preproc_def_token1] = ACTIONS(2842),
    [aux_sym_preproc_if_token1] = ACTIONS(2842),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2842),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2842),
    [sym_preproc_directive] = ACTIONS(2842),
    [anon_sym_LPAREN2] = ACTIONS(2844),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_TILDE] = ACTIONS(2844),
    [anon_sym_DASH] = ACTIONS(2842),
    [anon_sym_PLUS] = ACTIONS(2842),
    [anon_sym_STAR] = ACTIONS(2844),
    [anon_sym_AMP_AMP] = ACTIONS(2844),
    [anon_sym_AMP] = ACTIONS(2842),
    [anon_sym_SEMI] = ACTIONS(2844),
    [anon_sym___extension__] = ACTIONS(2842),
    [anon_sym_typedef] = ACTIONS(2842),
    [anon_sym_in] = ACTIONS(2842),
    [anon_sym_out] = ACTIONS(2842),
    [anon_sym_inout] = ACTIONS(2842),
    [anon_sym_extern] = ACTIONS(2842),
    [anon_sym___attribute__] = ACTIONS(2842),
    [anon_sym_COLON_COLON] = ACTIONS(2844),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2844),
    [anon_sym___declspec] = ACTIONS(2842),
    [anon_sym___based] = ACTIONS(2842),
    [anon_sym___cdecl] = ACTIONS(2842),
    [anon_sym___clrcall] = ACTIONS(2842),
    [anon_sym___stdcall] = ACTIONS(2842),
    [anon_sym___fastcall] = ACTIONS(2842),
    [anon_sym___thiscall] = ACTIONS(2842),
    [anon_sym___vectorcall] = ACTIONS(2842),
    [anon_sym_LBRACE] = ACTIONS(2844),
    [anon_sym_RBRACE] = ACTIONS(2844),
    [anon_sym_signed] = ACTIONS(2842),
    [anon_sym_unsigned] = ACTIONS(2842),
    [anon_sym_long] = ACTIONS(2842),
    [anon_sym_short] = ACTIONS(2842),
    [anon_sym_LBRACK] = ACTIONS(2842),
    [anon_sym_static] = ACTIONS(2842),
    [anon_sym_register] = ACTIONS(2842),
    [anon_sym_inline] = ACTIONS(2842),
    [anon_sym___inline] = ACTIONS(2842),
    [anon_sym___inline__] = ACTIONS(2842),
    [anon_sym___forceinline] = ACTIONS(2842),
    [anon_sym_thread_local] = ACTIONS(2842),
    [anon_sym___thread] = ACTIONS(2842),
    [anon_sym_const] = ACTIONS(2842),
    [anon_sym_constexpr] = ACTIONS(2842),
    [anon_sym_volatile] = ACTIONS(2842),
    [anon_sym_restrict] = ACTIONS(2842),
    [anon_sym___restrict__] = ACTIONS(2842),
    [anon_sym__Atomic] = ACTIONS(2842),
    [anon_sym__Noreturn] = ACTIONS(2842),
    [anon_sym_noreturn] = ACTIONS(2842),
    [anon_sym_mutable] = ACTIONS(2842),
    [anon_sym_constinit] = ACTIONS(2842),
    [anon_sym_consteval] = ACTIONS(2842),
    [anon_sym_alignas] = ACTIONS(2842),
    [anon_sym__Alignas] = ACTIONS(2842),
    [sym_primitive_type] = ACTIONS(2842),
    [anon_sym_enum] = ACTIONS(2842),
    [anon_sym_class] = ACTIONS(2842),
    [anon_sym_struct] = ACTIONS(2842),
    [anon_sym_union] = ACTIONS(2842),
    [anon_sym_if] = ACTIONS(2842),
    [anon_sym_else] = ACTIONS(2842),
    [anon_sym_switch] = ACTIONS(2842),
    [anon_sym_case] = ACTIONS(2842),
    [anon_sym_default] = ACTIONS(2842),
    [anon_sym_while] = ACTIONS(2842),
    [anon_sym_do] = ACTIONS(2842),
    [anon_sym_for] = ACTIONS(2842),
    [anon_sym_return] = ACTIONS(2842),
    [anon_sym_break] = ACTIONS(2842),
    [anon_sym_continue] = ACTIONS(2842),
    [anon_sym_goto] = ACTIONS(2842),
    [anon_sym___try] = ACTIONS(2842),
    [anon_sym___leave] = ACTIONS(2842),
    [anon_sym_not] = ACTIONS(2842),
    [anon_sym_compl] = ACTIONS(2842),
    [anon_sym_DASH_DASH] = ACTIONS(2844),
    [anon_sym_PLUS_PLUS] = ACTIONS(2844),
    [anon_sym_sizeof] = ACTIONS(2842),
    [anon_sym___alignof__] = ACTIONS(2842),
    [anon_sym___alignof] = ACTIONS(2842),
    [anon_sym__alignof] = ACTIONS(2842),
    [anon_sym_alignof] = ACTIONS(2842),
    [anon_sym__Alignof] = ACTIONS(2842),
    [anon_sym_offsetof] = ACTIONS(2842),
    [anon_sym__Generic] = ACTIONS(2842),
    [anon_sym_asm] = ACTIONS(2842),
    [anon_sym___asm__] = ACTIONS(2842),
    [sym_number_literal] = ACTIONS(2844),
    [anon_sym_L_SQUOTE] = ACTIONS(2844),
    [anon_sym_u_SQUOTE] = ACTIONS(2844),
    [anon_sym_U_SQUOTE] = ACTIONS(2844),
    [anon_sym_u8_SQUOTE] = ACTIONS(2844),
    [anon_sym_SQUOTE] = ACTIONS(2844),
    [anon_sym_L_DQUOTE] = ACTIONS(2844),
    [anon_sym_u_DQUOTE] = ACTIONS(2844),
    [anon_sym_U_DQUOTE] = ACTIONS(2844),
    [anon_sym_u8_DQUOTE] = ACTIONS(2844),
    [anon_sym_DQUOTE] = ACTIONS(2844),
    [sym_true] = ACTIONS(2842),
    [sym_false] = ACTIONS(2842),
    [anon_sym_NULL] = ACTIONS(2842),
    [anon_sym_nullptr] = ACTIONS(2842),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2842),
    [anon_sym_let] = ACTIONS(2842),
    [anon_sym_This] = ACTIONS(2842),
    [anon_sym_decltype] = ACTIONS(2842),
    [sym_virtual] = ACTIONS(2842),
    [anon_sym_explicit] = ACTIONS(2842),
    [anon_sym_typename] = ACTIONS(2842),
    [anon_sym_template] = ACTIONS(2842),
    [anon_sym_operator] = ACTIONS(2842),
    [anon_sym_try] = ACTIONS(2842),
    [anon_sym_delete] = ACTIONS(2842),
    [anon_sym_throw] = ACTIONS(2842),
    [anon_sym_namespace] = ACTIONS(2842),
    [anon_sym_using] = ACTIONS(2842),
    [anon_sym_static_assert] = ACTIONS(2842),
    [anon_sym_concept] = ACTIONS(2842),
    [anon_sym_co_return] = ACTIONS(2842),
    [anon_sym_co_yield] = ACTIONS(2842),
    [anon_sym_catch] = ACTIONS(2842),
    [anon_sym_R_DQUOTE] = ACTIONS(2844),
    [anon_sym_LR_DQUOTE] = ACTIONS(2844),
    [anon_sym_uR_DQUOTE] = ACTIONS(2844),
    [anon_sym_UR_DQUOTE] = ACTIONS(2844),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2844),
    [anon_sym_co_await] = ACTIONS(2842),
    [anon_sym_new] = ACTIONS(2842),
    [anon_sym_requires] = ACTIONS(2842),
    [sym_this] = ACTIONS(2842),
    [anon_sym_discard] = ACTIONS(2842),
    [anon_sym_precise] = ACTIONS(2842),
    [anon_sym_shared] = ACTIONS(2842),
    [anon_sym_groupshared] = ACTIONS(2842),
    [anon_sym_uniform] = ACTIONS(2842),
    [anon_sym_row_major] = ACTIONS(2842),
    [anon_sym_column_major] = ACTIONS(2842),
    [anon_sym_globallycoherent] = ACTIONS(2842),
    [anon_sym_centroid] = ACTIONS(2842),
    [anon_sym_noperspective] = ACTIONS(2842),
    [anon_sym_nointerpolation] = ACTIONS(2842),
    [anon_sym_sample] = ACTIONS(2842),
    [anon_sym_linear] = ACTIONS(2842),
    [anon_sym_snorm] = ACTIONS(2842),
    [anon_sym_unorm] = ACTIONS(2842),
    [anon_sym_point] = ACTIONS(2842),
    [anon_sym_line] = ACTIONS(2842),
    [anon_sym_triangleadj] = ACTIONS(2842),
    [anon_sym_lineadj] = ACTIONS(2842),
    [anon_sym_triangle] = ACTIONS(2842),
    [anon_sym_cbuffer] = ACTIONS(2842),
    [anon_sym_interface] = ACTIONS(2842),
    [anon_sym_extension] = ACTIONS(2842),
  },
  [624] = {
    [sym_argument_list] = STATE(3305),
    [sym_initializer_list] = STATE(4688),
    [aux_sym_sized_type_specifier_repeat1] = STATE(846),
    [ts_builtin_sym_end] = ACTIONS(2740),
    [sym_identifier] = ACTIONS(2742),
    [aux_sym_preproc_include_token1] = ACTIONS(2742),
    [aux_sym_preproc_def_token1] = ACTIONS(2742),
    [aux_sym_preproc_if_token1] = ACTIONS(2742),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2742),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2742),
    [sym_preproc_directive] = ACTIONS(2742),
    [anon_sym_LPAREN2] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(2740),
    [anon_sym_TILDE] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2742),
    [anon_sym_PLUS] = ACTIONS(2742),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym___extension__] = ACTIONS(2742),
    [anon_sym_typedef] = ACTIONS(2742),
    [anon_sym_in] = ACTIONS(2742),
    [anon_sym_out] = ACTIONS(2742),
    [anon_sym_inout] = ACTIONS(2742),
    [anon_sym_extern] = ACTIONS(2742),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym_COLON_COLON] = ACTIONS(2740),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2740),
    [anon_sym___declspec] = ACTIONS(2742),
    [anon_sym___based] = ACTIONS(2742),
    [anon_sym___cdecl] = ACTIONS(2742),
    [anon_sym___clrcall] = ACTIONS(2742),
    [anon_sym___stdcall] = ACTIONS(2742),
    [anon_sym___fastcall] = ACTIONS(2742),
    [anon_sym___thiscall] = ACTIONS(2742),
    [anon_sym___vectorcall] = ACTIONS(2742),
    [anon_sym_LBRACE] = ACTIONS(3659),
    [anon_sym_signed] = ACTIONS(3739),
    [anon_sym_unsigned] = ACTIONS(3739),
    [anon_sym_long] = ACTIONS(3739),
    [anon_sym_short] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2742),
    [anon_sym_register] = ACTIONS(2742),
    [anon_sym_inline] = ACTIONS(2742),
    [anon_sym___inline] = ACTIONS(2742),
    [anon_sym___inline__] = ACTIONS(2742),
    [anon_sym___forceinline] = ACTIONS(2742),
    [anon_sym_thread_local] = ACTIONS(2742),
    [anon_sym___thread] = ACTIONS(2742),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_constexpr] = ACTIONS(2742),
    [anon_sym_volatile] = ACTIONS(2742),
    [anon_sym_restrict] = ACTIONS(2742),
    [anon_sym___restrict__] = ACTIONS(2742),
    [anon_sym__Atomic] = ACTIONS(2742),
    [anon_sym__Noreturn] = ACTIONS(2742),
    [anon_sym_noreturn] = ACTIONS(2742),
    [anon_sym_mutable] = ACTIONS(2742),
    [anon_sym_constinit] = ACTIONS(2742),
    [anon_sym_consteval] = ACTIONS(2742),
    [anon_sym_alignas] = ACTIONS(2742),
    [anon_sym__Alignas] = ACTIONS(2742),
    [sym_primitive_type] = ACTIONS(2742),
    [anon_sym_enum] = ACTIONS(2742),
    [anon_sym_class] = ACTIONS(2742),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2742),
    [anon_sym_if] = ACTIONS(2742),
    [anon_sym_switch] = ACTIONS(2742),
    [anon_sym_case] = ACTIONS(2742),
    [anon_sym_default] = ACTIONS(2742),
    [anon_sym_while] = ACTIONS(2742),
    [anon_sym_do] = ACTIONS(2742),
    [anon_sym_for] = ACTIONS(2742),
    [anon_sym_return] = ACTIONS(2742),
    [anon_sym_break] = ACTIONS(2742),
    [anon_sym_continue] = ACTIONS(2742),
    [anon_sym_goto] = ACTIONS(2742),
    [anon_sym_not] = ACTIONS(2742),
    [anon_sym_compl] = ACTIONS(2742),
    [anon_sym_DASH_DASH] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2740),
    [anon_sym_sizeof] = ACTIONS(2742),
    [anon_sym___alignof__] = ACTIONS(2742),
    [anon_sym___alignof] = ACTIONS(2742),
    [anon_sym__alignof] = ACTIONS(2742),
    [anon_sym_alignof] = ACTIONS(2742),
    [anon_sym__Alignof] = ACTIONS(2742),
    [anon_sym_offsetof] = ACTIONS(2742),
    [anon_sym__Generic] = ACTIONS(2742),
    [anon_sym_asm] = ACTIONS(2742),
    [anon_sym___asm__] = ACTIONS(2742),
    [anon_sym_DOT] = ACTIONS(2742),
    [sym_number_literal] = ACTIONS(2740),
    [anon_sym_L_SQUOTE] = ACTIONS(2740),
    [anon_sym_u_SQUOTE] = ACTIONS(2740),
    [anon_sym_U_SQUOTE] = ACTIONS(2740),
    [anon_sym_u8_SQUOTE] = ACTIONS(2740),
    [anon_sym_SQUOTE] = ACTIONS(2740),
    [anon_sym_L_DQUOTE] = ACTIONS(2740),
    [anon_sym_u_DQUOTE] = ACTIONS(2740),
    [anon_sym_U_DQUOTE] = ACTIONS(2740),
    [anon_sym_u8_DQUOTE] = ACTIONS(2740),
    [anon_sym_DQUOTE] = ACTIONS(2740),
    [sym_true] = ACTIONS(2742),
    [sym_false] = ACTIONS(2742),
    [anon_sym_NULL] = ACTIONS(2742),
    [anon_sym_nullptr] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
    [anon_sym_decltype] = ACTIONS(2742),
    [sym_virtual] = ACTIONS(2742),
    [anon_sym_explicit] = ACTIONS(2742),
    [anon_sym_typename] = ACTIONS(2742),
    [anon_sym_template] = ACTIONS(2742),
    [anon_sym_operator] = ACTIONS(2742),
    [anon_sym_try] = ACTIONS(2742),
    [anon_sym_delete] = ACTIONS(2742),
    [anon_sym_throw] = ACTIONS(2742),
    [anon_sym_namespace] = ACTIONS(2742),
    [anon_sym_using] = ACTIONS(2742),
    [anon_sym_static_assert] = ACTIONS(2742),
    [anon_sym_concept] = ACTIONS(2742),
    [anon_sym_co_return] = ACTIONS(2742),
    [anon_sym_co_yield] = ACTIONS(2742),
    [anon_sym_R_DQUOTE] = ACTIONS(2740),
    [anon_sym_LR_DQUOTE] = ACTIONS(2740),
    [anon_sym_uR_DQUOTE] = ACTIONS(2740),
    [anon_sym_UR_DQUOTE] = ACTIONS(2740),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2740),
    [anon_sym_co_await] = ACTIONS(2742),
    [anon_sym_new] = ACTIONS(2742),
    [anon_sym_requires] = ACTIONS(2742),
    [sym_this] = ACTIONS(2742),
    [anon_sym_precise] = ACTIONS(2742),
    [anon_sym_shared] = ACTIONS(2742),
    [anon_sym_groupshared] = ACTIONS(2742),
    [anon_sym_uniform] = ACTIONS(2742),
    [anon_sym_row_major] = ACTIONS(2742),
    [anon_sym_column_major] = ACTIONS(2742),
    [anon_sym_globallycoherent] = ACTIONS(2742),
    [anon_sym_centroid] = ACTIONS(2742),
    [anon_sym_noperspective] = ACTIONS(2742),
    [anon_sym_nointerpolation] = ACTIONS(2742),
    [anon_sym_sample] = ACTIONS(2742),
    [anon_sym_linear] = ACTIONS(2742),
    [anon_sym_snorm] = ACTIONS(2742),
    [anon_sym_unorm] = ACTIONS(2742),
    [anon_sym_point] = ACTIONS(2742),
    [anon_sym_line] = ACTIONS(2742),
    [anon_sym_triangleadj] = ACTIONS(2742),
    [anon_sym_lineadj] = ACTIONS(2742),
    [anon_sym_triangle] = ACTIONS(2742),
    [anon_sym_interface] = ACTIONS(2742),
    [anon_sym_extension] = ACTIONS(2742),
    [anon_sym___exported] = ACTIONS(2742),
    [anon_sym_import] = ACTIONS(2742),
  },
  [625] = {
    [sym_attribute_specifier] = STATE(697),
    [sym_identifier] = ACTIONS(3742),
    [aux_sym_preproc_include_token1] = ACTIONS(3742),
    [aux_sym_preproc_def_token1] = ACTIONS(3742),
    [aux_sym_preproc_if_token1] = ACTIONS(3742),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3742),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3742),
    [sym_preproc_directive] = ACTIONS(3742),
    [anon_sym_LPAREN2] = ACTIONS(3744),
    [anon_sym_BANG] = ACTIONS(3744),
    [anon_sym_TILDE] = ACTIONS(3744),
    [anon_sym_DASH] = ACTIONS(3742),
    [anon_sym_PLUS] = ACTIONS(3742),
    [anon_sym_STAR] = ACTIONS(3744),
    [anon_sym_AMP_AMP] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(3742),
    [anon_sym_SEMI] = ACTIONS(3744),
    [anon_sym___extension__] = ACTIONS(3742),
    [anon_sym_typedef] = ACTIONS(3742),
    [anon_sym_in] = ACTIONS(3742),
    [anon_sym_out] = ACTIONS(3742),
    [anon_sym_inout] = ACTIONS(3742),
    [anon_sym_extern] = ACTIONS(3742),
    [anon_sym___attribute__] = ACTIONS(2687),
    [anon_sym_COLON_COLON] = ACTIONS(3744),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3744),
    [anon_sym___declspec] = ACTIONS(3742),
    [anon_sym___based] = ACTIONS(3742),
    [anon_sym___cdecl] = ACTIONS(3742),
    [anon_sym___clrcall] = ACTIONS(3742),
    [anon_sym___stdcall] = ACTIONS(3742),
    [anon_sym___fastcall] = ACTIONS(3742),
    [anon_sym___thiscall] = ACTIONS(3742),
    [anon_sym___vectorcall] = ACTIONS(3742),
    [anon_sym_LBRACE] = ACTIONS(3744),
    [anon_sym_RBRACE] = ACTIONS(3744),
    [anon_sym_signed] = ACTIONS(3742),
    [anon_sym_unsigned] = ACTIONS(3742),
    [anon_sym_long] = ACTIONS(3742),
    [anon_sym_short] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(3742),
    [anon_sym_static] = ACTIONS(3742),
    [anon_sym_register] = ACTIONS(3742),
    [anon_sym_inline] = ACTIONS(3742),
    [anon_sym___inline] = ACTIONS(3742),
    [anon_sym___inline__] = ACTIONS(3742),
    [anon_sym___forceinline] = ACTIONS(3742),
    [anon_sym_thread_local] = ACTIONS(3742),
    [anon_sym___thread] = ACTIONS(3742),
    [anon_sym_const] = ACTIONS(3742),
    [anon_sym_constexpr] = ACTIONS(3742),
    [anon_sym_volatile] = ACTIONS(3742),
    [anon_sym_restrict] = ACTIONS(3742),
    [anon_sym___restrict__] = ACTIONS(3742),
    [anon_sym__Atomic] = ACTIONS(3742),
    [anon_sym__Noreturn] = ACTIONS(3742),
    [anon_sym_noreturn] = ACTIONS(3742),
    [anon_sym_mutable] = ACTIONS(3742),
    [anon_sym_constinit] = ACTIONS(3742),
    [anon_sym_consteval] = ACTIONS(3742),
    [anon_sym_alignas] = ACTIONS(3742),
    [anon_sym__Alignas] = ACTIONS(3742),
    [sym_primitive_type] = ACTIONS(3742),
    [anon_sym_enum] = ACTIONS(3742),
    [anon_sym_class] = ACTIONS(3742),
    [anon_sym_struct] = ACTIONS(3742),
    [anon_sym_union] = ACTIONS(3742),
    [anon_sym_if] = ACTIONS(3742),
    [anon_sym_switch] = ACTIONS(3742),
    [anon_sym_case] = ACTIONS(3742),
    [anon_sym_default] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(3742),
    [anon_sym_do] = ACTIONS(3742),
    [anon_sym_for] = ACTIONS(3742),
    [anon_sym_return] = ACTIONS(3742),
    [anon_sym_break] = ACTIONS(3742),
    [anon_sym_continue] = ACTIONS(3742),
    [anon_sym_goto] = ACTIONS(3742),
    [anon_sym___try] = ACTIONS(3742),
    [anon_sym___leave] = ACTIONS(3742),
    [anon_sym_not] = ACTIONS(3742),
    [anon_sym_compl] = ACTIONS(3742),
    [anon_sym_DASH_DASH] = ACTIONS(3744),
    [anon_sym_PLUS_PLUS] = ACTIONS(3744),
    [anon_sym_sizeof] = ACTIONS(3742),
    [anon_sym___alignof__] = ACTIONS(3742),
    [anon_sym___alignof] = ACTIONS(3742),
    [anon_sym__alignof] = ACTIONS(3742),
    [anon_sym_alignof] = ACTIONS(3742),
    [anon_sym__Alignof] = ACTIONS(3742),
    [anon_sym_offsetof] = ACTIONS(3742),
    [anon_sym__Generic] = ACTIONS(3742),
    [anon_sym_asm] = ACTIONS(3742),
    [anon_sym___asm__] = ACTIONS(3742),
    [anon_sym_DOT] = ACTIONS(3742),
    [sym_number_literal] = ACTIONS(3744),
    [anon_sym_L_SQUOTE] = ACTIONS(3744),
    [anon_sym_u_SQUOTE] = ACTIONS(3744),
    [anon_sym_U_SQUOTE] = ACTIONS(3744),
    [anon_sym_u8_SQUOTE] = ACTIONS(3744),
    [anon_sym_SQUOTE] = ACTIONS(3744),
    [anon_sym_L_DQUOTE] = ACTIONS(3744),
    [anon_sym_u_DQUOTE] = ACTIONS(3744),
    [anon_sym_U_DQUOTE] = ACTIONS(3744),
    [anon_sym_u8_DQUOTE] = ACTIONS(3744),
    [anon_sym_DQUOTE] = ACTIONS(3744),
    [sym_true] = ACTIONS(3742),
    [sym_false] = ACTIONS(3742),
    [anon_sym_NULL] = ACTIONS(3742),
    [anon_sym_nullptr] = ACTIONS(3742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3742),
    [anon_sym_let] = ACTIONS(3742),
    [anon_sym_This] = ACTIONS(3742),
    [anon_sym_decltype] = ACTIONS(3742),
    [sym_virtual] = ACTIONS(3742),
    [anon_sym_explicit] = ACTIONS(3742),
    [anon_sym_typename] = ACTIONS(3742),
    [anon_sym_template] = ACTIONS(3742),
    [anon_sym_operator] = ACTIONS(3742),
    [anon_sym_try] = ACTIONS(3742),
    [anon_sym_delete] = ACTIONS(3742),
    [anon_sym_throw] = ACTIONS(3742),
    [anon_sym_namespace] = ACTIONS(3742),
    [anon_sym_using] = ACTIONS(3742),
    [anon_sym_static_assert] = ACTIONS(3742),
    [anon_sym_concept] = ACTIONS(3742),
    [anon_sym_co_return] = ACTIONS(3742),
    [anon_sym_co_yield] = ACTIONS(3742),
    [anon_sym_R_DQUOTE] = ACTIONS(3744),
    [anon_sym_LR_DQUOTE] = ACTIONS(3744),
    [anon_sym_uR_DQUOTE] = ACTIONS(3744),
    [anon_sym_UR_DQUOTE] = ACTIONS(3744),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3744),
    [anon_sym_co_await] = ACTIONS(3742),
    [anon_sym_new] = ACTIONS(3742),
    [anon_sym_requires] = ACTIONS(3742),
    [sym_this] = ACTIONS(3742),
    [anon_sym_discard] = ACTIONS(3742),
    [anon_sym_precise] = ACTIONS(3742),
    [anon_sym_shared] = ACTIONS(3742),
    [anon_sym_groupshared] = ACTIONS(3742),
    [anon_sym_uniform] = ACTIONS(3742),
    [anon_sym_row_major] = ACTIONS(3742),
    [anon_sym_column_major] = ACTIONS(3742),
    [anon_sym_globallycoherent] = ACTIONS(3742),
    [anon_sym_centroid] = ACTIONS(3742),
    [anon_sym_noperspective] = ACTIONS(3742),
    [anon_sym_nointerpolation] = ACTIONS(3742),
    [anon_sym_sample] = ACTIONS(3742),
    [anon_sym_linear] = ACTIONS(3742),
    [anon_sym_snorm] = ACTIONS(3742),
    [anon_sym_unorm] = ACTIONS(3742),
    [anon_sym_point] = ACTIONS(3742),
    [anon_sym_line] = ACTIONS(3742),
    [anon_sym_triangleadj] = ACTIONS(3742),
    [anon_sym_lineadj] = ACTIONS(3742),
    [anon_sym_triangle] = ACTIONS(3742),
    [anon_sym_cbuffer] = ACTIONS(3742),
    [anon_sym_interface] = ACTIONS(3742),
    [anon_sym_extension] = ACTIONS(3742),
  },
  [626] = {
    [sym_attribute_specifier] = STATE(684),
    [sym_identifier] = ACTIONS(3746),
    [aux_sym_preproc_include_token1] = ACTIONS(3746),
    [aux_sym_preproc_def_token1] = ACTIONS(3746),
    [aux_sym_preproc_if_token1] = ACTIONS(3746),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3746),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3746),
    [sym_preproc_directive] = ACTIONS(3746),
    [anon_sym_LPAREN2] = ACTIONS(3748),
    [anon_sym_BANG] = ACTIONS(3748),
    [anon_sym_TILDE] = ACTIONS(3748),
    [anon_sym_DASH] = ACTIONS(3746),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_STAR] = ACTIONS(3748),
    [anon_sym_AMP_AMP] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_SEMI] = ACTIONS(3748),
    [anon_sym___extension__] = ACTIONS(3746),
    [anon_sym_typedef] = ACTIONS(3746),
    [anon_sym_in] = ACTIONS(3746),
    [anon_sym_out] = ACTIONS(3746),
    [anon_sym_inout] = ACTIONS(3746),
    [anon_sym_extern] = ACTIONS(3746),
    [anon_sym___attribute__] = ACTIONS(2687),
    [anon_sym_COLON_COLON] = ACTIONS(3748),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3748),
    [anon_sym___declspec] = ACTIONS(3746),
    [anon_sym___based] = ACTIONS(3746),
    [anon_sym___cdecl] = ACTIONS(3746),
    [anon_sym___clrcall] = ACTIONS(3746),
    [anon_sym___stdcall] = ACTIONS(3746),
    [anon_sym___fastcall] = ACTIONS(3746),
    [anon_sym___thiscall] = ACTIONS(3746),
    [anon_sym___vectorcall] = ACTIONS(3746),
    [anon_sym_LBRACE] = ACTIONS(3748),
    [anon_sym_RBRACE] = ACTIONS(3748),
    [anon_sym_signed] = ACTIONS(3746),
    [anon_sym_unsigned] = ACTIONS(3746),
    [anon_sym_long] = ACTIONS(3746),
    [anon_sym_short] = ACTIONS(3746),
    [anon_sym_LBRACK] = ACTIONS(3746),
    [anon_sym_static] = ACTIONS(3746),
    [anon_sym_register] = ACTIONS(3746),
    [anon_sym_inline] = ACTIONS(3746),
    [anon_sym___inline] = ACTIONS(3746),
    [anon_sym___inline__] = ACTIONS(3746),
    [anon_sym___forceinline] = ACTIONS(3746),
    [anon_sym_thread_local] = ACTIONS(3746),
    [anon_sym___thread] = ACTIONS(3746),
    [anon_sym_const] = ACTIONS(3746),
    [anon_sym_constexpr] = ACTIONS(3746),
    [anon_sym_volatile] = ACTIONS(3746),
    [anon_sym_restrict] = ACTIONS(3746),
    [anon_sym___restrict__] = ACTIONS(3746),
    [anon_sym__Atomic] = ACTIONS(3746),
    [anon_sym__Noreturn] = ACTIONS(3746),
    [anon_sym_noreturn] = ACTIONS(3746),
    [anon_sym_mutable] = ACTIONS(3746),
    [anon_sym_constinit] = ACTIONS(3746),
    [anon_sym_consteval] = ACTIONS(3746),
    [anon_sym_alignas] = ACTIONS(3746),
    [anon_sym__Alignas] = ACTIONS(3746),
    [sym_primitive_type] = ACTIONS(3746),
    [anon_sym_enum] = ACTIONS(3746),
    [anon_sym_class] = ACTIONS(3746),
    [anon_sym_struct] = ACTIONS(3746),
    [anon_sym_union] = ACTIONS(3746),
    [anon_sym_if] = ACTIONS(3746),
    [anon_sym_switch] = ACTIONS(3746),
    [anon_sym_case] = ACTIONS(3746),
    [anon_sym_default] = ACTIONS(3746),
    [anon_sym_while] = ACTIONS(3746),
    [anon_sym_do] = ACTIONS(3746),
    [anon_sym_for] = ACTIONS(3746),
    [anon_sym_return] = ACTIONS(3746),
    [anon_sym_break] = ACTIONS(3746),
    [anon_sym_continue] = ACTIONS(3746),
    [anon_sym_goto] = ACTIONS(3746),
    [anon_sym___try] = ACTIONS(3746),
    [anon_sym___leave] = ACTIONS(3746),
    [anon_sym_not] = ACTIONS(3746),
    [anon_sym_compl] = ACTIONS(3746),
    [anon_sym_DASH_DASH] = ACTIONS(3748),
    [anon_sym_PLUS_PLUS] = ACTIONS(3748),
    [anon_sym_sizeof] = ACTIONS(3746),
    [anon_sym___alignof__] = ACTIONS(3746),
    [anon_sym___alignof] = ACTIONS(3746),
    [anon_sym__alignof] = ACTIONS(3746),
    [anon_sym_alignof] = ACTIONS(3746),
    [anon_sym__Alignof] = ACTIONS(3746),
    [anon_sym_offsetof] = ACTIONS(3746),
    [anon_sym__Generic] = ACTIONS(3746),
    [anon_sym_asm] = ACTIONS(3746),
    [anon_sym___asm__] = ACTIONS(3746),
    [anon_sym_DOT] = ACTIONS(3746),
    [sym_number_literal] = ACTIONS(3748),
    [anon_sym_L_SQUOTE] = ACTIONS(3748),
    [anon_sym_u_SQUOTE] = ACTIONS(3748),
    [anon_sym_U_SQUOTE] = ACTIONS(3748),
    [anon_sym_u8_SQUOTE] = ACTIONS(3748),
    [anon_sym_SQUOTE] = ACTIONS(3748),
    [anon_sym_L_DQUOTE] = ACTIONS(3748),
    [anon_sym_u_DQUOTE] = ACTIONS(3748),
    [anon_sym_U_DQUOTE] = ACTIONS(3748),
    [anon_sym_u8_DQUOTE] = ACTIONS(3748),
    [anon_sym_DQUOTE] = ACTIONS(3748),
    [sym_true] = ACTIONS(3746),
    [sym_false] = ACTIONS(3746),
    [anon_sym_NULL] = ACTIONS(3746),
    [anon_sym_nullptr] = ACTIONS(3746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3746),
    [anon_sym_let] = ACTIONS(3746),
    [anon_sym_This] = ACTIONS(3746),
    [anon_sym_decltype] = ACTIONS(3746),
    [sym_virtual] = ACTIONS(3746),
    [anon_sym_explicit] = ACTIONS(3746),
    [anon_sym_typename] = ACTIONS(3746),
    [anon_sym_template] = ACTIONS(3746),
    [anon_sym_operator] = ACTIONS(3746),
    [anon_sym_try] = ACTIONS(3746),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_throw] = ACTIONS(3746),
    [anon_sym_namespace] = ACTIONS(3746),
    [anon_sym_using] = ACTIONS(3746),
    [anon_sym_static_assert] = ACTIONS(3746),
    [anon_sym_concept] = ACTIONS(3746),
    [anon_sym_co_return] = ACTIONS(3746),
    [anon_sym_co_yield] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(3748),
    [anon_sym_LR_DQUOTE] = ACTIONS(3748),
    [anon_sym_uR_DQUOTE] = ACTIONS(3748),
    [anon_sym_UR_DQUOTE] = ACTIONS(3748),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3748),
    [anon_sym_co_await] = ACTIONS(3746),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3746),
    [sym_this] = ACTIONS(3746),
    [anon_sym_discard] = ACTIONS(3746),
    [anon_sym_precise] = ACTIONS(3746),
    [anon_sym_shared] = ACTIONS(3746),
    [anon_sym_groupshared] = ACTIONS(3746),
    [anon_sym_uniform] = ACTIONS(3746),
    [anon_sym_row_major] = ACTIONS(3746),
    [anon_sym_column_major] = ACTIONS(3746),
    [anon_sym_globallycoherent] = ACTIONS(3746),
    [anon_sym_centroid] = ACTIONS(3746),
    [anon_sym_noperspective] = ACTIONS(3746),
    [anon_sym_nointerpolation] = ACTIONS(3746),
    [anon_sym_sample] = ACTIONS(3746),
    [anon_sym_linear] = ACTIONS(3746),
    [anon_sym_snorm] = ACTIONS(3746),
    [anon_sym_unorm] = ACTIONS(3746),
    [anon_sym_point] = ACTIONS(3746),
    [anon_sym_line] = ACTIONS(3746),
    [anon_sym_triangleadj] = ACTIONS(3746),
    [anon_sym_lineadj] = ACTIONS(3746),
    [anon_sym_triangle] = ACTIONS(3746),
    [anon_sym_cbuffer] = ACTIONS(3746),
    [anon_sym_interface] = ACTIONS(3746),
    [anon_sym_extension] = ACTIONS(3746),
  },
  [627] = {
    [sym_identifier] = ACTIONS(2359),
    [aux_sym_preproc_include_token1] = ACTIONS(2359),
    [aux_sym_preproc_def_token1] = ACTIONS(2359),
    [aux_sym_preproc_if_token1] = ACTIONS(2359),
    [aux_sym_preproc_if_token2] = ACTIONS(2359),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2359),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2359),
    [sym_preproc_directive] = ACTIONS(2359),
    [anon_sym_LPAREN2] = ACTIONS(2357),
    [anon_sym_BANG] = ACTIONS(2357),
    [anon_sym_TILDE] = ACTIONS(2357),
    [anon_sym_DASH] = ACTIONS(2359),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_STAR] = ACTIONS(2357),
    [anon_sym_AMP_AMP] = ACTIONS(2357),
    [anon_sym_AMP] = ACTIONS(2359),
    [anon_sym_SEMI] = ACTIONS(2357),
    [anon_sym___extension__] = ACTIONS(2359),
    [anon_sym_typedef] = ACTIONS(2359),
    [anon_sym_in] = ACTIONS(2359),
    [anon_sym_out] = ACTIONS(2359),
    [anon_sym_inout] = ACTIONS(2359),
    [anon_sym_extern] = ACTIONS(2359),
    [anon_sym___attribute__] = ACTIONS(2359),
    [anon_sym_COLON_COLON] = ACTIONS(2357),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2357),
    [anon_sym___declspec] = ACTIONS(2359),
    [anon_sym___based] = ACTIONS(2359),
    [anon_sym___cdecl] = ACTIONS(2359),
    [anon_sym___clrcall] = ACTIONS(2359),
    [anon_sym___stdcall] = ACTIONS(2359),
    [anon_sym___fastcall] = ACTIONS(2359),
    [anon_sym___thiscall] = ACTIONS(2359),
    [anon_sym___vectorcall] = ACTIONS(2359),
    [anon_sym_LBRACE] = ACTIONS(2357),
    [anon_sym_signed] = ACTIONS(2359),
    [anon_sym_unsigned] = ACTIONS(2359),
    [anon_sym_long] = ACTIONS(2359),
    [anon_sym_short] = ACTIONS(2359),
    [anon_sym_LBRACK] = ACTIONS(2359),
    [anon_sym_static] = ACTIONS(2359),
    [anon_sym_register] = ACTIONS(2359),
    [anon_sym_inline] = ACTIONS(2359),
    [anon_sym___inline] = ACTIONS(2359),
    [anon_sym___inline__] = ACTIONS(2359),
    [anon_sym___forceinline] = ACTIONS(2359),
    [anon_sym_thread_local] = ACTIONS(2359),
    [anon_sym___thread] = ACTIONS(2359),
    [anon_sym_const] = ACTIONS(2359),
    [anon_sym_constexpr] = ACTIONS(2359),
    [anon_sym_volatile] = ACTIONS(2359),
    [anon_sym_restrict] = ACTIONS(2359),
    [anon_sym___restrict__] = ACTIONS(2359),
    [anon_sym__Atomic] = ACTIONS(2359),
    [anon_sym__Noreturn] = ACTIONS(2359),
    [anon_sym_noreturn] = ACTIONS(2359),
    [anon_sym_mutable] = ACTIONS(2359),
    [anon_sym_constinit] = ACTIONS(2359),
    [anon_sym_consteval] = ACTIONS(2359),
    [anon_sym_alignas] = ACTIONS(2359),
    [anon_sym__Alignas] = ACTIONS(2359),
    [sym_primitive_type] = ACTIONS(2359),
    [anon_sym_enum] = ACTIONS(2359),
    [anon_sym_class] = ACTIONS(2359),
    [anon_sym_struct] = ACTIONS(2359),
    [anon_sym_union] = ACTIONS(2359),
    [anon_sym_if] = ACTIONS(2359),
    [anon_sym_else] = ACTIONS(2359),
    [anon_sym_switch] = ACTIONS(2359),
    [anon_sym_case] = ACTIONS(2359),
    [anon_sym_default] = ACTIONS(2359),
    [anon_sym_while] = ACTIONS(2359),
    [anon_sym_do] = ACTIONS(2359),
    [anon_sym_for] = ACTIONS(2359),
    [anon_sym_return] = ACTIONS(2359),
    [anon_sym_break] = ACTIONS(2359),
    [anon_sym_continue] = ACTIONS(2359),
    [anon_sym_goto] = ACTIONS(2359),
    [anon_sym___try] = ACTIONS(2359),
    [anon_sym___leave] = ACTIONS(2359),
    [anon_sym_not] = ACTIONS(2359),
    [anon_sym_compl] = ACTIONS(2359),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
    [anon_sym_sizeof] = ACTIONS(2359),
    [anon_sym___alignof__] = ACTIONS(2359),
    [anon_sym___alignof] = ACTIONS(2359),
    [anon_sym__alignof] = ACTIONS(2359),
    [anon_sym_alignof] = ACTIONS(2359),
    [anon_sym__Alignof] = ACTIONS(2359),
    [anon_sym_offsetof] = ACTIONS(2359),
    [anon_sym__Generic] = ACTIONS(2359),
    [anon_sym_asm] = ACTIONS(2359),
    [anon_sym___asm__] = ACTIONS(2359),
    [sym_number_literal] = ACTIONS(2357),
    [anon_sym_L_SQUOTE] = ACTIONS(2357),
    [anon_sym_u_SQUOTE] = ACTIONS(2357),
    [anon_sym_U_SQUOTE] = ACTIONS(2357),
    [anon_sym_u8_SQUOTE] = ACTIONS(2357),
    [anon_sym_SQUOTE] = ACTIONS(2357),
    [anon_sym_L_DQUOTE] = ACTIONS(2357),
    [anon_sym_u_DQUOTE] = ACTIONS(2357),
    [anon_sym_U_DQUOTE] = ACTIONS(2357),
    [anon_sym_u8_DQUOTE] = ACTIONS(2357),
    [anon_sym_DQUOTE] = ACTIONS(2357),
    [sym_true] = ACTIONS(2359),
    [sym_false] = ACTIONS(2359),
    [anon_sym_NULL] = ACTIONS(2359),
    [anon_sym_nullptr] = ACTIONS(2359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2359),
    [anon_sym_let] = ACTIONS(2359),
    [anon_sym_This] = ACTIONS(2359),
    [anon_sym_decltype] = ACTIONS(2359),
    [sym_virtual] = ACTIONS(2359),
    [anon_sym_explicit] = ACTIONS(2359),
    [anon_sym_typename] = ACTIONS(2359),
    [anon_sym_template] = ACTIONS(2359),
    [anon_sym_operator] = ACTIONS(2359),
    [anon_sym_try] = ACTIONS(2359),
    [anon_sym_delete] = ACTIONS(2359),
    [anon_sym_throw] = ACTIONS(2359),
    [anon_sym_namespace] = ACTIONS(2359),
    [anon_sym_using] = ACTIONS(2359),
    [anon_sym_static_assert] = ACTIONS(2359),
    [anon_sym_concept] = ACTIONS(2359),
    [anon_sym_co_return] = ACTIONS(2359),
    [anon_sym_co_yield] = ACTIONS(2359),
    [anon_sym_catch] = ACTIONS(2359),
    [anon_sym_R_DQUOTE] = ACTIONS(2357),
    [anon_sym_LR_DQUOTE] = ACTIONS(2357),
    [anon_sym_uR_DQUOTE] = ACTIONS(2357),
    [anon_sym_UR_DQUOTE] = ACTIONS(2357),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2357),
    [anon_sym_co_await] = ACTIONS(2359),
    [anon_sym_new] = ACTIONS(2359),
    [anon_sym_requires] = ACTIONS(2359),
    [sym_this] = ACTIONS(2359),
    [anon_sym_discard] = ACTIONS(2359),
    [anon_sym_precise] = ACTIONS(2359),
    [anon_sym_shared] = ACTIONS(2359),
    [anon_sym_groupshared] = ACTIONS(2359),
    [anon_sym_uniform] = ACTIONS(2359),
    [anon_sym_row_major] = ACTIONS(2359),
    [anon_sym_column_major] = ACTIONS(2359),
    [anon_sym_globallycoherent] = ACTIONS(2359),
    [anon_sym_centroid] = ACTIONS(2359),
    [anon_sym_noperspective] = ACTIONS(2359),
    [anon_sym_nointerpolation] = ACTIONS(2359),
    [anon_sym_sample] = ACTIONS(2359),
    [anon_sym_linear] = ACTIONS(2359),
    [anon_sym_snorm] = ACTIONS(2359),
    [anon_sym_unorm] = ACTIONS(2359),
    [anon_sym_point] = ACTIONS(2359),
    [anon_sym_line] = ACTIONS(2359),
    [anon_sym_triangleadj] = ACTIONS(2359),
    [anon_sym_lineadj] = ACTIONS(2359),
    [anon_sym_triangle] = ACTIONS(2359),
    [anon_sym_cbuffer] = ACTIONS(2359),
    [anon_sym_interface] = ACTIONS(2359),
    [anon_sym_extension] = ACTIONS(2359),
  },
  [628] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(629),
    [sym_identifier] = ACTIONS(2742),
    [aux_sym_preproc_include_token1] = ACTIONS(2742),
    [aux_sym_preproc_def_token1] = ACTIONS(2742),
    [aux_sym_preproc_if_token1] = ACTIONS(2742),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2742),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2742),
    [sym_preproc_directive] = ACTIONS(2742),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_BANG] = ACTIONS(2740),
    [anon_sym_TILDE] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2742),
    [anon_sym_PLUS] = ACTIONS(2742),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym___extension__] = ACTIONS(2742),
    [anon_sym_typedef] = ACTIONS(2742),
    [anon_sym_in] = ACTIONS(2742),
    [anon_sym_out] = ACTIONS(2742),
    [anon_sym_inout] = ACTIONS(2742),
    [anon_sym_extern] = ACTIONS(2742),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym_COLON_COLON] = ACTIONS(2740),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2740),
    [anon_sym___declspec] = ACTIONS(2742),
    [anon_sym___based] = ACTIONS(2742),
    [anon_sym___cdecl] = ACTIONS(2742),
    [anon_sym___clrcall] = ACTIONS(2742),
    [anon_sym___stdcall] = ACTIONS(2742),
    [anon_sym___fastcall] = ACTIONS(2742),
    [anon_sym___thiscall] = ACTIONS(2742),
    [anon_sym___vectorcall] = ACTIONS(2742),
    [anon_sym_LBRACE] = ACTIONS(2740),
    [anon_sym_RBRACE] = ACTIONS(2740),
    [anon_sym_signed] = ACTIONS(3662),
    [anon_sym_unsigned] = ACTIONS(3662),
    [anon_sym_long] = ACTIONS(3662),
    [anon_sym_short] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2742),
    [anon_sym_register] = ACTIONS(2742),
    [anon_sym_inline] = ACTIONS(2742),
    [anon_sym___inline] = ACTIONS(2742),
    [anon_sym___inline__] = ACTIONS(2742),
    [anon_sym___forceinline] = ACTIONS(2742),
    [anon_sym_thread_local] = ACTIONS(2742),
    [anon_sym___thread] = ACTIONS(2742),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_constexpr] = ACTIONS(2742),
    [anon_sym_volatile] = ACTIONS(2742),
    [anon_sym_restrict] = ACTIONS(2742),
    [anon_sym___restrict__] = ACTIONS(2742),
    [anon_sym__Atomic] = ACTIONS(2742),
    [anon_sym__Noreturn] = ACTIONS(2742),
    [anon_sym_noreturn] = ACTIONS(2742),
    [anon_sym_mutable] = ACTIONS(2742),
    [anon_sym_constinit] = ACTIONS(2742),
    [anon_sym_consteval] = ACTIONS(2742),
    [anon_sym_alignas] = ACTIONS(2742),
    [anon_sym__Alignas] = ACTIONS(2742),
    [sym_primitive_type] = ACTIONS(2742),
    [anon_sym_enum] = ACTIONS(2742),
    [anon_sym_class] = ACTIONS(2742),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2742),
    [anon_sym_if] = ACTIONS(2742),
    [anon_sym_switch] = ACTIONS(2742),
    [anon_sym_case] = ACTIONS(2742),
    [anon_sym_default] = ACTIONS(2742),
    [anon_sym_while] = ACTIONS(2742),
    [anon_sym_do] = ACTIONS(2742),
    [anon_sym_for] = ACTIONS(2742),
    [anon_sym_return] = ACTIONS(2742),
    [anon_sym_break] = ACTIONS(2742),
    [anon_sym_continue] = ACTIONS(2742),
    [anon_sym_goto] = ACTIONS(2742),
    [anon_sym___try] = ACTIONS(2742),
    [anon_sym___leave] = ACTIONS(2742),
    [anon_sym_not] = ACTIONS(2742),
    [anon_sym_compl] = ACTIONS(2742),
    [anon_sym_DASH_DASH] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2740),
    [anon_sym_sizeof] = ACTIONS(2742),
    [anon_sym___alignof__] = ACTIONS(2742),
    [anon_sym___alignof] = ACTIONS(2742),
    [anon_sym__alignof] = ACTIONS(2742),
    [anon_sym_alignof] = ACTIONS(2742),
    [anon_sym__Alignof] = ACTIONS(2742),
    [anon_sym_offsetof] = ACTIONS(2742),
    [anon_sym__Generic] = ACTIONS(2742),
    [anon_sym_asm] = ACTIONS(2742),
    [anon_sym___asm__] = ACTIONS(2742),
    [anon_sym_DOT] = ACTIONS(2742),
    [sym_number_literal] = ACTIONS(2740),
    [anon_sym_L_SQUOTE] = ACTIONS(2740),
    [anon_sym_u_SQUOTE] = ACTIONS(2740),
    [anon_sym_U_SQUOTE] = ACTIONS(2740),
    [anon_sym_u8_SQUOTE] = ACTIONS(2740),
    [anon_sym_SQUOTE] = ACTIONS(2740),
    [anon_sym_L_DQUOTE] = ACTIONS(2740),
    [anon_sym_u_DQUOTE] = ACTIONS(2740),
    [anon_sym_U_DQUOTE] = ACTIONS(2740),
    [anon_sym_u8_DQUOTE] = ACTIONS(2740),
    [anon_sym_DQUOTE] = ACTIONS(2740),
    [sym_true] = ACTIONS(2742),
    [sym_false] = ACTIONS(2742),
    [anon_sym_NULL] = ACTIONS(2742),
    [anon_sym_nullptr] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
    [anon_sym_decltype] = ACTIONS(2742),
    [sym_virtual] = ACTIONS(2742),
    [anon_sym_explicit] = ACTIONS(2742),
    [anon_sym_typename] = ACTIONS(2742),
    [anon_sym_template] = ACTIONS(2742),
    [anon_sym_operator] = ACTIONS(2742),
    [anon_sym_try] = ACTIONS(2742),
    [anon_sym_delete] = ACTIONS(2742),
    [anon_sym_throw] = ACTIONS(2742),
    [anon_sym_namespace] = ACTIONS(2742),
    [anon_sym_using] = ACTIONS(2742),
    [anon_sym_static_assert] = ACTIONS(2742),
    [anon_sym_concept] = ACTIONS(2742),
    [anon_sym_co_return] = ACTIONS(2742),
    [anon_sym_co_yield] = ACTIONS(2742),
    [anon_sym_R_DQUOTE] = ACTIONS(2740),
    [anon_sym_LR_DQUOTE] = ACTIONS(2740),
    [anon_sym_uR_DQUOTE] = ACTIONS(2740),
    [anon_sym_UR_DQUOTE] = ACTIONS(2740),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2740),
    [anon_sym_co_await] = ACTIONS(2742),
    [anon_sym_new] = ACTIONS(2742),
    [anon_sym_requires] = ACTIONS(2742),
    [sym_this] = ACTIONS(2742),
    [anon_sym_discard] = ACTIONS(2742),
    [anon_sym_precise] = ACTIONS(2742),
    [anon_sym_shared] = ACTIONS(2742),
    [anon_sym_groupshared] = ACTIONS(2742),
    [anon_sym_uniform] = ACTIONS(2742),
    [anon_sym_row_major] = ACTIONS(2742),
    [anon_sym_column_major] = ACTIONS(2742),
    [anon_sym_globallycoherent] = ACTIONS(2742),
    [anon_sym_centroid] = ACTIONS(2742),
    [anon_sym_noperspective] = ACTIONS(2742),
    [anon_sym_nointerpolation] = ACTIONS(2742),
    [anon_sym_sample] = ACTIONS(2742),
    [anon_sym_linear] = ACTIONS(2742),
    [anon_sym_snorm] = ACTIONS(2742),
    [anon_sym_unorm] = ACTIONS(2742),
    [anon_sym_point] = ACTIONS(2742),
    [anon_sym_line] = ACTIONS(2742),
    [anon_sym_triangleadj] = ACTIONS(2742),
    [anon_sym_lineadj] = ACTIONS(2742),
    [anon_sym_triangle] = ACTIONS(2742),
    [anon_sym_cbuffer] = ACTIONS(2742),
    [anon_sym_interface] = ACTIONS(2742),
    [anon_sym_extension] = ACTIONS(2742),
  },
  [629] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(637),
    [sym_identifier] = ACTIONS(3750),
    [aux_sym_preproc_include_token1] = ACTIONS(3750),
    [aux_sym_preproc_def_token1] = ACTIONS(3750),
    [aux_sym_preproc_if_token1] = ACTIONS(3750),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3750),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3750),
    [sym_preproc_directive] = ACTIONS(3750),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3752),
    [anon_sym_TILDE] = ACTIONS(3752),
    [anon_sym_DASH] = ACTIONS(3750),
    [anon_sym_PLUS] = ACTIONS(3750),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_AMP_AMP] = ACTIONS(3752),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_SEMI] = ACTIONS(3752),
    [anon_sym___extension__] = ACTIONS(3750),
    [anon_sym_typedef] = ACTIONS(3750),
    [anon_sym_in] = ACTIONS(3750),
    [anon_sym_out] = ACTIONS(3750),
    [anon_sym_inout] = ACTIONS(3750),
    [anon_sym_extern] = ACTIONS(3750),
    [anon_sym___attribute__] = ACTIONS(3750),
    [anon_sym_COLON_COLON] = ACTIONS(3752),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3752),
    [anon_sym___declspec] = ACTIONS(3750),
    [anon_sym___based] = ACTIONS(3750),
    [anon_sym___cdecl] = ACTIONS(3750),
    [anon_sym___clrcall] = ACTIONS(3750),
    [anon_sym___stdcall] = ACTIONS(3750),
    [anon_sym___fastcall] = ACTIONS(3750),
    [anon_sym___thiscall] = ACTIONS(3750),
    [anon_sym___vectorcall] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(3752),
    [anon_sym_RBRACE] = ACTIONS(3752),
    [anon_sym_signed] = ACTIONS(3754),
    [anon_sym_unsigned] = ACTIONS(3754),
    [anon_sym_long] = ACTIONS(3754),
    [anon_sym_short] = ACTIONS(3754),
    [anon_sym_LBRACK] = ACTIONS(3750),
    [anon_sym_static] = ACTIONS(3750),
    [anon_sym_register] = ACTIONS(3750),
    [anon_sym_inline] = ACTIONS(3750),
    [anon_sym___inline] = ACTIONS(3750),
    [anon_sym___inline__] = ACTIONS(3750),
    [anon_sym___forceinline] = ACTIONS(3750),
    [anon_sym_thread_local] = ACTIONS(3750),
    [anon_sym___thread] = ACTIONS(3750),
    [anon_sym_const] = ACTIONS(3750),
    [anon_sym_constexpr] = ACTIONS(3750),
    [anon_sym_volatile] = ACTIONS(3750),
    [anon_sym_restrict] = ACTIONS(3750),
    [anon_sym___restrict__] = ACTIONS(3750),
    [anon_sym__Atomic] = ACTIONS(3750),
    [anon_sym__Noreturn] = ACTIONS(3750),
    [anon_sym_noreturn] = ACTIONS(3750),
    [anon_sym_mutable] = ACTIONS(3750),
    [anon_sym_constinit] = ACTIONS(3750),
    [anon_sym_consteval] = ACTIONS(3750),
    [anon_sym_alignas] = ACTIONS(3750),
    [anon_sym__Alignas] = ACTIONS(3750),
    [sym_primitive_type] = ACTIONS(3750),
    [anon_sym_enum] = ACTIONS(3750),
    [anon_sym_class] = ACTIONS(3750),
    [anon_sym_struct] = ACTIONS(3750),
    [anon_sym_union] = ACTIONS(3750),
    [anon_sym_if] = ACTIONS(3750),
    [anon_sym_switch] = ACTIONS(3750),
    [anon_sym_case] = ACTIONS(3750),
    [anon_sym_default] = ACTIONS(3750),
    [anon_sym_while] = ACTIONS(3750),
    [anon_sym_do] = ACTIONS(3750),
    [anon_sym_for] = ACTIONS(3750),
    [anon_sym_return] = ACTIONS(3750),
    [anon_sym_break] = ACTIONS(3750),
    [anon_sym_continue] = ACTIONS(3750),
    [anon_sym_goto] = ACTIONS(3750),
    [anon_sym___try] = ACTIONS(3750),
    [anon_sym___leave] = ACTIONS(3750),
    [anon_sym_not] = ACTIONS(3750),
    [anon_sym_compl] = ACTIONS(3750),
    [anon_sym_DASH_DASH] = ACTIONS(3752),
    [anon_sym_PLUS_PLUS] = ACTIONS(3752),
    [anon_sym_sizeof] = ACTIONS(3750),
    [anon_sym___alignof__] = ACTIONS(3750),
    [anon_sym___alignof] = ACTIONS(3750),
    [anon_sym__alignof] = ACTIONS(3750),
    [anon_sym_alignof] = ACTIONS(3750),
    [anon_sym__Alignof] = ACTIONS(3750),
    [anon_sym_offsetof] = ACTIONS(3750),
    [anon_sym__Generic] = ACTIONS(3750),
    [anon_sym_asm] = ACTIONS(3750),
    [anon_sym___asm__] = ACTIONS(3750),
    [anon_sym_DOT] = ACTIONS(3750),
    [sym_number_literal] = ACTIONS(3752),
    [anon_sym_L_SQUOTE] = ACTIONS(3752),
    [anon_sym_u_SQUOTE] = ACTIONS(3752),
    [anon_sym_U_SQUOTE] = ACTIONS(3752),
    [anon_sym_u8_SQUOTE] = ACTIONS(3752),
    [anon_sym_SQUOTE] = ACTIONS(3752),
    [anon_sym_L_DQUOTE] = ACTIONS(3752),
    [anon_sym_u_DQUOTE] = ACTIONS(3752),
    [anon_sym_U_DQUOTE] = ACTIONS(3752),
    [anon_sym_u8_DQUOTE] = ACTIONS(3752),
    [anon_sym_DQUOTE] = ACTIONS(3752),
    [sym_true] = ACTIONS(3750),
    [sym_false] = ACTIONS(3750),
    [anon_sym_NULL] = ACTIONS(3750),
    [anon_sym_nullptr] = ACTIONS(3750),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3750),
    [anon_sym_let] = ACTIONS(3750),
    [anon_sym_This] = ACTIONS(3750),
    [anon_sym_decltype] = ACTIONS(3750),
    [sym_virtual] = ACTIONS(3750),
    [anon_sym_explicit] = ACTIONS(3750),
    [anon_sym_typename] = ACTIONS(3750),
    [anon_sym_template] = ACTIONS(3750),
    [anon_sym_operator] = ACTIONS(3750),
    [anon_sym_try] = ACTIONS(3750),
    [anon_sym_delete] = ACTIONS(3750),
    [anon_sym_throw] = ACTIONS(3750),
    [anon_sym_namespace] = ACTIONS(3750),
    [anon_sym_using] = ACTIONS(3750),
    [anon_sym_static_assert] = ACTIONS(3750),
    [anon_sym_concept] = ACTIONS(3750),
    [anon_sym_co_return] = ACTIONS(3750),
    [anon_sym_co_yield] = ACTIONS(3750),
    [anon_sym_R_DQUOTE] = ACTIONS(3752),
    [anon_sym_LR_DQUOTE] = ACTIONS(3752),
    [anon_sym_uR_DQUOTE] = ACTIONS(3752),
    [anon_sym_UR_DQUOTE] = ACTIONS(3752),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3752),
    [anon_sym_co_await] = ACTIONS(3750),
    [anon_sym_new] = ACTIONS(3750),
    [anon_sym_requires] = ACTIONS(3750),
    [sym_this] = ACTIONS(3750),
    [anon_sym_discard] = ACTIONS(3750),
    [anon_sym_precise] = ACTIONS(3750),
    [anon_sym_shared] = ACTIONS(3750),
    [anon_sym_groupshared] = ACTIONS(3750),
    [anon_sym_uniform] = ACTIONS(3750),
    [anon_sym_row_major] = ACTIONS(3750),
    [anon_sym_column_major] = ACTIONS(3750),
    [anon_sym_globallycoherent] = ACTIONS(3750),
    [anon_sym_centroid] = ACTIONS(3750),
    [anon_sym_noperspective] = ACTIONS(3750),
    [anon_sym_nointerpolation] = ACTIONS(3750),
    [anon_sym_sample] = ACTIONS(3750),
    [anon_sym_linear] = ACTIONS(3750),
    [anon_sym_snorm] = ACTIONS(3750),
    [anon_sym_unorm] = ACTIONS(3750),
    [anon_sym_point] = ACTIONS(3750),
    [anon_sym_line] = ACTIONS(3750),
    [anon_sym_triangleadj] = ACTIONS(3750),
    [anon_sym_lineadj] = ACTIONS(3750),
    [anon_sym_triangle] = ACTIONS(3750),
    [anon_sym_cbuffer] = ACTIONS(3750),
    [anon_sym_interface] = ACTIONS(3750),
    [anon_sym_extension] = ACTIONS(3750),
  },
  [630] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(637),
    [sym_identifier] = ACTIONS(3757),
    [aux_sym_preproc_include_token1] = ACTIONS(3757),
    [aux_sym_preproc_def_token1] = ACTIONS(3757),
    [aux_sym_preproc_if_token1] = ACTIONS(3757),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3757),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3757),
    [sym_preproc_directive] = ACTIONS(3757),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_BANG] = ACTIONS(3759),
    [anon_sym_TILDE] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3757),
    [anon_sym_PLUS] = ACTIONS(3757),
    [anon_sym_STAR] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_AMP] = ACTIONS(3757),
    [anon_sym_SEMI] = ACTIONS(3759),
    [anon_sym___extension__] = ACTIONS(3757),
    [anon_sym_typedef] = ACTIONS(3757),
    [anon_sym_in] = ACTIONS(3757),
    [anon_sym_out] = ACTIONS(3757),
    [anon_sym_inout] = ACTIONS(3757),
    [anon_sym_extern] = ACTIONS(3757),
    [anon_sym___attribute__] = ACTIONS(3757),
    [anon_sym_COLON_COLON] = ACTIONS(3759),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3759),
    [anon_sym___declspec] = ACTIONS(3757),
    [anon_sym___based] = ACTIONS(3757),
    [anon_sym___cdecl] = ACTIONS(3757),
    [anon_sym___clrcall] = ACTIONS(3757),
    [anon_sym___stdcall] = ACTIONS(3757),
    [anon_sym___fastcall] = ACTIONS(3757),
    [anon_sym___thiscall] = ACTIONS(3757),
    [anon_sym___vectorcall] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_RBRACE] = ACTIONS(3759),
    [anon_sym_signed] = ACTIONS(3761),
    [anon_sym_unsigned] = ACTIONS(3761),
    [anon_sym_long] = ACTIONS(3761),
    [anon_sym_short] = ACTIONS(3761),
    [anon_sym_LBRACK] = ACTIONS(3757),
    [anon_sym_static] = ACTIONS(3757),
    [anon_sym_register] = ACTIONS(3757),
    [anon_sym_inline] = ACTIONS(3757),
    [anon_sym___inline] = ACTIONS(3757),
    [anon_sym___inline__] = ACTIONS(3757),
    [anon_sym___forceinline] = ACTIONS(3757),
    [anon_sym_thread_local] = ACTIONS(3757),
    [anon_sym___thread] = ACTIONS(3757),
    [anon_sym_const] = ACTIONS(3757),
    [anon_sym_constexpr] = ACTIONS(3757),
    [anon_sym_volatile] = ACTIONS(3757),
    [anon_sym_restrict] = ACTIONS(3757),
    [anon_sym___restrict__] = ACTIONS(3757),
    [anon_sym__Atomic] = ACTIONS(3757),
    [anon_sym__Noreturn] = ACTIONS(3757),
    [anon_sym_noreturn] = ACTIONS(3757),
    [anon_sym_mutable] = ACTIONS(3757),
    [anon_sym_constinit] = ACTIONS(3757),
    [anon_sym_consteval] = ACTIONS(3757),
    [anon_sym_alignas] = ACTIONS(3757),
    [anon_sym__Alignas] = ACTIONS(3757),
    [sym_primitive_type] = ACTIONS(3757),
    [anon_sym_enum] = ACTIONS(3757),
    [anon_sym_class] = ACTIONS(3757),
    [anon_sym_struct] = ACTIONS(3757),
    [anon_sym_union] = ACTIONS(3757),
    [anon_sym_if] = ACTIONS(3757),
    [anon_sym_switch] = ACTIONS(3757),
    [anon_sym_case] = ACTIONS(3757),
    [anon_sym_default] = ACTIONS(3757),
    [anon_sym_while] = ACTIONS(3757),
    [anon_sym_do] = ACTIONS(3757),
    [anon_sym_for] = ACTIONS(3757),
    [anon_sym_return] = ACTIONS(3757),
    [anon_sym_break] = ACTIONS(3757),
    [anon_sym_continue] = ACTIONS(3757),
    [anon_sym_goto] = ACTIONS(3757),
    [anon_sym___try] = ACTIONS(3757),
    [anon_sym___leave] = ACTIONS(3757),
    [anon_sym_not] = ACTIONS(3757),
    [anon_sym_compl] = ACTIONS(3757),
    [anon_sym_DASH_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_PLUS] = ACTIONS(3759),
    [anon_sym_sizeof] = ACTIONS(3757),
    [anon_sym___alignof__] = ACTIONS(3757),
    [anon_sym___alignof] = ACTIONS(3757),
    [anon_sym__alignof] = ACTIONS(3757),
    [anon_sym_alignof] = ACTIONS(3757),
    [anon_sym__Alignof] = ACTIONS(3757),
    [anon_sym_offsetof] = ACTIONS(3757),
    [anon_sym__Generic] = ACTIONS(3757),
    [anon_sym_asm] = ACTIONS(3757),
    [anon_sym___asm__] = ACTIONS(3757),
    [anon_sym_DOT] = ACTIONS(3757),
    [sym_number_literal] = ACTIONS(3759),
    [anon_sym_L_SQUOTE] = ACTIONS(3759),
    [anon_sym_u_SQUOTE] = ACTIONS(3759),
    [anon_sym_U_SQUOTE] = ACTIONS(3759),
    [anon_sym_u8_SQUOTE] = ACTIONS(3759),
    [anon_sym_SQUOTE] = ACTIONS(3759),
    [anon_sym_L_DQUOTE] = ACTIONS(3759),
    [anon_sym_u_DQUOTE] = ACTIONS(3759),
    [anon_sym_U_DQUOTE] = ACTIONS(3759),
    [anon_sym_u8_DQUOTE] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [sym_true] = ACTIONS(3757),
    [sym_false] = ACTIONS(3757),
    [anon_sym_NULL] = ACTIONS(3757),
    [anon_sym_nullptr] = ACTIONS(3757),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3757),
    [anon_sym_let] = ACTIONS(3757),
    [anon_sym_This] = ACTIONS(3757),
    [anon_sym_decltype] = ACTIONS(3757),
    [sym_virtual] = ACTIONS(3757),
    [anon_sym_explicit] = ACTIONS(3757),
    [anon_sym_typename] = ACTIONS(3757),
    [anon_sym_template] = ACTIONS(3757),
    [anon_sym_operator] = ACTIONS(3757),
    [anon_sym_try] = ACTIONS(3757),
    [anon_sym_delete] = ACTIONS(3757),
    [anon_sym_throw] = ACTIONS(3757),
    [anon_sym_namespace] = ACTIONS(3757),
    [anon_sym_using] = ACTIONS(3757),
    [anon_sym_static_assert] = ACTIONS(3757),
    [anon_sym_concept] = ACTIONS(3757),
    [anon_sym_co_return] = ACTIONS(3757),
    [anon_sym_co_yield] = ACTIONS(3757),
    [anon_sym_R_DQUOTE] = ACTIONS(3759),
    [anon_sym_LR_DQUOTE] = ACTIONS(3759),
    [anon_sym_uR_DQUOTE] = ACTIONS(3759),
    [anon_sym_UR_DQUOTE] = ACTIONS(3759),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3759),
    [anon_sym_co_await] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3757),
    [anon_sym_requires] = ACTIONS(3757),
    [sym_this] = ACTIONS(3757),
    [anon_sym_discard] = ACTIONS(3757),
    [anon_sym_precise] = ACTIONS(3757),
    [anon_sym_shared] = ACTIONS(3757),
    [anon_sym_groupshared] = ACTIONS(3757),
    [anon_sym_uniform] = ACTIONS(3757),
    [anon_sym_row_major] = ACTIONS(3757),
    [anon_sym_column_major] = ACTIONS(3757),
    [anon_sym_globallycoherent] = ACTIONS(3757),
    [anon_sym_centroid] = ACTIONS(3757),
    [anon_sym_noperspective] = ACTIONS(3757),
    [anon_sym_nointerpolation] = ACTIONS(3757),
    [anon_sym_sample] = ACTIONS(3757),
    [anon_sym_linear] = ACTIONS(3757),
    [anon_sym_snorm] = ACTIONS(3757),
    [anon_sym_unorm] = ACTIONS(3757),
    [anon_sym_point] = ACTIONS(3757),
    [anon_sym_line] = ACTIONS(3757),
    [anon_sym_triangleadj] = ACTIONS(3757),
    [anon_sym_lineadj] = ACTIONS(3757),
    [anon_sym_triangle] = ACTIONS(3757),
    [anon_sym_cbuffer] = ACTIONS(3757),
    [anon_sym_interface] = ACTIONS(3757),
    [anon_sym_extension] = ACTIONS(3757),
  },
  [631] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(643),
    [sym_identifier] = ACTIONS(3764),
    [aux_sym_preproc_include_token1] = ACTIONS(3764),
    [aux_sym_preproc_def_token1] = ACTIONS(3764),
    [aux_sym_preproc_if_token1] = ACTIONS(3764),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3764),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3764),
    [sym_preproc_directive] = ACTIONS(3764),
    [anon_sym_LPAREN2] = ACTIONS(3766),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [anon_sym_DASH] = ACTIONS(3764),
    [anon_sym_PLUS] = ACTIONS(3764),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_AMP_AMP] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3764),
    [anon_sym_SEMI] = ACTIONS(3766),
    [anon_sym___extension__] = ACTIONS(3764),
    [anon_sym_typedef] = ACTIONS(3764),
    [anon_sym_in] = ACTIONS(3764),
    [anon_sym_out] = ACTIONS(3764),
    [anon_sym_inout] = ACTIONS(3764),
    [anon_sym_extern] = ACTIONS(3764),
    [anon_sym___attribute__] = ACTIONS(3764),
    [anon_sym_COLON_COLON] = ACTIONS(3766),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3766),
    [anon_sym___declspec] = ACTIONS(3764),
    [anon_sym___based] = ACTIONS(3764),
    [anon_sym___cdecl] = ACTIONS(3764),
    [anon_sym___clrcall] = ACTIONS(3764),
    [anon_sym___stdcall] = ACTIONS(3764),
    [anon_sym___fastcall] = ACTIONS(3764),
    [anon_sym___thiscall] = ACTIONS(3764),
    [anon_sym___vectorcall] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3766),
    [anon_sym_RBRACE] = ACTIONS(3766),
    [anon_sym_signed] = ACTIONS(3768),
    [anon_sym_unsigned] = ACTIONS(3768),
    [anon_sym_long] = ACTIONS(3768),
    [anon_sym_short] = ACTIONS(3768),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_static] = ACTIONS(3764),
    [anon_sym_register] = ACTIONS(3764),
    [anon_sym_inline] = ACTIONS(3764),
    [anon_sym___inline] = ACTIONS(3764),
    [anon_sym___inline__] = ACTIONS(3764),
    [anon_sym___forceinline] = ACTIONS(3764),
    [anon_sym_thread_local] = ACTIONS(3764),
    [anon_sym___thread] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(3764),
    [anon_sym_constexpr] = ACTIONS(3764),
    [anon_sym_volatile] = ACTIONS(3764),
    [anon_sym_restrict] = ACTIONS(3764),
    [anon_sym___restrict__] = ACTIONS(3764),
    [anon_sym__Atomic] = ACTIONS(3764),
    [anon_sym__Noreturn] = ACTIONS(3764),
    [anon_sym_noreturn] = ACTIONS(3764),
    [anon_sym_mutable] = ACTIONS(3764),
    [anon_sym_constinit] = ACTIONS(3764),
    [anon_sym_consteval] = ACTIONS(3764),
    [anon_sym_alignas] = ACTIONS(3764),
    [anon_sym__Alignas] = ACTIONS(3764),
    [sym_primitive_type] = ACTIONS(3764),
    [anon_sym_enum] = ACTIONS(3764),
    [anon_sym_class] = ACTIONS(3764),
    [anon_sym_struct] = ACTIONS(3764),
    [anon_sym_union] = ACTIONS(3764),
    [anon_sym_if] = ACTIONS(3764),
    [anon_sym_switch] = ACTIONS(3764),
    [anon_sym_case] = ACTIONS(3764),
    [anon_sym_default] = ACTIONS(3764),
    [anon_sym_while] = ACTIONS(3764),
    [anon_sym_do] = ACTIONS(3764),
    [anon_sym_for] = ACTIONS(3764),
    [anon_sym_return] = ACTIONS(3764),
    [anon_sym_break] = ACTIONS(3764),
    [anon_sym_continue] = ACTIONS(3764),
    [anon_sym_goto] = ACTIONS(3764),
    [anon_sym___try] = ACTIONS(3764),
    [anon_sym___leave] = ACTIONS(3764),
    [anon_sym_not] = ACTIONS(3764),
    [anon_sym_compl] = ACTIONS(3764),
    [anon_sym_DASH_DASH] = ACTIONS(3766),
    [anon_sym_PLUS_PLUS] = ACTIONS(3766),
    [anon_sym_sizeof] = ACTIONS(3764),
    [anon_sym___alignof__] = ACTIONS(3764),
    [anon_sym___alignof] = ACTIONS(3764),
    [anon_sym__alignof] = ACTIONS(3764),
    [anon_sym_alignof] = ACTIONS(3764),
    [anon_sym__Alignof] = ACTIONS(3764),
    [anon_sym_offsetof] = ACTIONS(3764),
    [anon_sym__Generic] = ACTIONS(3764),
    [anon_sym_asm] = ACTIONS(3764),
    [anon_sym___asm__] = ACTIONS(3764),
    [anon_sym_DOT] = ACTIONS(3764),
    [sym_number_literal] = ACTIONS(3766),
    [anon_sym_L_SQUOTE] = ACTIONS(3766),
    [anon_sym_u_SQUOTE] = ACTIONS(3766),
    [anon_sym_U_SQUOTE] = ACTIONS(3766),
    [anon_sym_u8_SQUOTE] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3766),
    [anon_sym_L_DQUOTE] = ACTIONS(3766),
    [anon_sym_u_DQUOTE] = ACTIONS(3766),
    [anon_sym_U_DQUOTE] = ACTIONS(3766),
    [anon_sym_u8_DQUOTE] = ACTIONS(3766),
    [anon_sym_DQUOTE] = ACTIONS(3766),
    [sym_true] = ACTIONS(3764),
    [sym_false] = ACTIONS(3764),
    [anon_sym_NULL] = ACTIONS(3764),
    [anon_sym_nullptr] = ACTIONS(3764),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3764),
    [anon_sym_let] = ACTIONS(3764),
    [anon_sym_This] = ACTIONS(3764),
    [anon_sym_decltype] = ACTIONS(3764),
    [sym_virtual] = ACTIONS(3764),
    [anon_sym_explicit] = ACTIONS(3764),
    [anon_sym_typename] = ACTIONS(3764),
    [anon_sym_template] = ACTIONS(3764),
    [anon_sym_operator] = ACTIONS(3764),
    [anon_sym_try] = ACTIONS(3764),
    [anon_sym_delete] = ACTIONS(3764),
    [anon_sym_throw] = ACTIONS(3764),
    [anon_sym_namespace] = ACTIONS(3764),
    [anon_sym_using] = ACTIONS(3764),
    [anon_sym_static_assert] = ACTIONS(3764),
    [anon_sym_concept] = ACTIONS(3764),
    [anon_sym_co_return] = ACTIONS(3764),
    [anon_sym_co_yield] = ACTIONS(3764),
    [anon_sym_R_DQUOTE] = ACTIONS(3766),
    [anon_sym_LR_DQUOTE] = ACTIONS(3766),
    [anon_sym_uR_DQUOTE] = ACTIONS(3766),
    [anon_sym_UR_DQUOTE] = ACTIONS(3766),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3766),
    [anon_sym_co_await] = ACTIONS(3764),
    [anon_sym_new] = ACTIONS(3764),
    [anon_sym_requires] = ACTIONS(3764),
    [sym_this] = ACTIONS(3764),
    [anon_sym_discard] = ACTIONS(3764),
    [anon_sym_precise] = ACTIONS(3764),
    [anon_sym_shared] = ACTIONS(3764),
    [anon_sym_groupshared] = ACTIONS(3764),
    [anon_sym_uniform] = ACTIONS(3764),
    [anon_sym_row_major] = ACTIONS(3764),
    [anon_sym_column_major] = ACTIONS(3764),
    [anon_sym_globallycoherent] = ACTIONS(3764),
    [anon_sym_centroid] = ACTIONS(3764),
    [anon_sym_noperspective] = ACTIONS(3764),
    [anon_sym_nointerpolation] = ACTIONS(3764),
    [anon_sym_sample] = ACTIONS(3764),
    [anon_sym_linear] = ACTIONS(3764),
    [anon_sym_snorm] = ACTIONS(3764),
    [anon_sym_unorm] = ACTIONS(3764),
    [anon_sym_point] = ACTIONS(3764),
    [anon_sym_line] = ACTIONS(3764),
    [anon_sym_triangleadj] = ACTIONS(3764),
    [anon_sym_lineadj] = ACTIONS(3764),
    [anon_sym_triangle] = ACTIONS(3764),
    [anon_sym_cbuffer] = ACTIONS(3764),
    [anon_sym_interface] = ACTIONS(3764),
    [anon_sym_extension] = ACTIONS(3764),
  },
  [632] = {
    [sym_identifier] = ACTIONS(2359),
    [aux_sym_preproc_include_token1] = ACTIONS(2359),
    [aux_sym_preproc_def_token1] = ACTIONS(2359),
    [aux_sym_preproc_if_token1] = ACTIONS(2359),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2359),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2359),
    [sym_preproc_directive] = ACTIONS(2359),
    [anon_sym_LPAREN2] = ACTIONS(2357),
    [anon_sym_BANG] = ACTIONS(2357),
    [anon_sym_TILDE] = ACTIONS(2357),
    [anon_sym_DASH] = ACTIONS(2359),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_STAR] = ACTIONS(2357),
    [anon_sym_AMP_AMP] = ACTIONS(2357),
    [anon_sym_AMP] = ACTIONS(2359),
    [anon_sym_SEMI] = ACTIONS(2357),
    [anon_sym___extension__] = ACTIONS(2359),
    [anon_sym_typedef] = ACTIONS(2359),
    [anon_sym_in] = ACTIONS(2359),
    [anon_sym_out] = ACTIONS(2359),
    [anon_sym_inout] = ACTIONS(2359),
    [anon_sym_extern] = ACTIONS(2359),
    [anon_sym___attribute__] = ACTIONS(2359),
    [anon_sym_COLON_COLON] = ACTIONS(2357),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2357),
    [anon_sym___declspec] = ACTIONS(2359),
    [anon_sym___based] = ACTIONS(2359),
    [anon_sym___cdecl] = ACTIONS(2359),
    [anon_sym___clrcall] = ACTIONS(2359),
    [anon_sym___stdcall] = ACTIONS(2359),
    [anon_sym___fastcall] = ACTIONS(2359),
    [anon_sym___thiscall] = ACTIONS(2359),
    [anon_sym___vectorcall] = ACTIONS(2359),
    [anon_sym_LBRACE] = ACTIONS(2357),
    [anon_sym_RBRACE] = ACTIONS(2357),
    [anon_sym_signed] = ACTIONS(2359),
    [anon_sym_unsigned] = ACTIONS(2359),
    [anon_sym_long] = ACTIONS(2359),
    [anon_sym_short] = ACTIONS(2359),
    [anon_sym_LBRACK] = ACTIONS(2359),
    [anon_sym_static] = ACTIONS(2359),
    [anon_sym_register] = ACTIONS(2359),
    [anon_sym_inline] = ACTIONS(2359),
    [anon_sym___inline] = ACTIONS(2359),
    [anon_sym___inline__] = ACTIONS(2359),
    [anon_sym___forceinline] = ACTIONS(2359),
    [anon_sym_thread_local] = ACTIONS(2359),
    [anon_sym___thread] = ACTIONS(2359),
    [anon_sym_const] = ACTIONS(2359),
    [anon_sym_constexpr] = ACTIONS(2359),
    [anon_sym_volatile] = ACTIONS(2359),
    [anon_sym_restrict] = ACTIONS(2359),
    [anon_sym___restrict__] = ACTIONS(2359),
    [anon_sym__Atomic] = ACTIONS(2359),
    [anon_sym__Noreturn] = ACTIONS(2359),
    [anon_sym_noreturn] = ACTIONS(2359),
    [anon_sym_mutable] = ACTIONS(2359),
    [anon_sym_constinit] = ACTIONS(2359),
    [anon_sym_consteval] = ACTIONS(2359),
    [anon_sym_alignas] = ACTIONS(2359),
    [anon_sym__Alignas] = ACTIONS(2359),
    [sym_primitive_type] = ACTIONS(2359),
    [anon_sym_enum] = ACTIONS(2359),
    [anon_sym_class] = ACTIONS(2359),
    [anon_sym_struct] = ACTIONS(2359),
    [anon_sym_union] = ACTIONS(2359),
    [anon_sym_if] = ACTIONS(2359),
    [anon_sym_else] = ACTIONS(2359),
    [anon_sym_switch] = ACTIONS(2359),
    [anon_sym_case] = ACTIONS(2359),
    [anon_sym_default] = ACTIONS(2359),
    [anon_sym_while] = ACTIONS(2359),
    [anon_sym_do] = ACTIONS(2359),
    [anon_sym_for] = ACTIONS(2359),
    [anon_sym_return] = ACTIONS(2359),
    [anon_sym_break] = ACTIONS(2359),
    [anon_sym_continue] = ACTIONS(2359),
    [anon_sym_goto] = ACTIONS(2359),
    [anon_sym___try] = ACTIONS(2359),
    [anon_sym___leave] = ACTIONS(2359),
    [anon_sym_not] = ACTIONS(2359),
    [anon_sym_compl] = ACTIONS(2359),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
    [anon_sym_sizeof] = ACTIONS(2359),
    [anon_sym___alignof__] = ACTIONS(2359),
    [anon_sym___alignof] = ACTIONS(2359),
    [anon_sym__alignof] = ACTIONS(2359),
    [anon_sym_alignof] = ACTIONS(2359),
    [anon_sym__Alignof] = ACTIONS(2359),
    [anon_sym_offsetof] = ACTIONS(2359),
    [anon_sym__Generic] = ACTIONS(2359),
    [anon_sym_asm] = ACTIONS(2359),
    [anon_sym___asm__] = ACTIONS(2359),
    [sym_number_literal] = ACTIONS(2357),
    [anon_sym_L_SQUOTE] = ACTIONS(2357),
    [anon_sym_u_SQUOTE] = ACTIONS(2357),
    [anon_sym_U_SQUOTE] = ACTIONS(2357),
    [anon_sym_u8_SQUOTE] = ACTIONS(2357),
    [anon_sym_SQUOTE] = ACTIONS(2357),
    [anon_sym_L_DQUOTE] = ACTIONS(2357),
    [anon_sym_u_DQUOTE] = ACTIONS(2357),
    [anon_sym_U_DQUOTE] = ACTIONS(2357),
    [anon_sym_u8_DQUOTE] = ACTIONS(2357),
    [anon_sym_DQUOTE] = ACTIONS(2357),
    [sym_true] = ACTIONS(2359),
    [sym_false] = ACTIONS(2359),
    [anon_sym_NULL] = ACTIONS(2359),
    [anon_sym_nullptr] = ACTIONS(2359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2359),
    [anon_sym_let] = ACTIONS(2359),
    [anon_sym_This] = ACTIONS(2359),
    [anon_sym_decltype] = ACTIONS(2359),
    [sym_virtual] = ACTIONS(2359),
    [anon_sym_explicit] = ACTIONS(2359),
    [anon_sym_typename] = ACTIONS(2359),
    [anon_sym_template] = ACTIONS(2359),
    [anon_sym_operator] = ACTIONS(2359),
    [anon_sym_try] = ACTIONS(2359),
    [anon_sym_delete] = ACTIONS(2359),
    [anon_sym_throw] = ACTIONS(2359),
    [anon_sym_namespace] = ACTIONS(2359),
    [anon_sym_using] = ACTIONS(2359),
    [anon_sym_static_assert] = ACTIONS(2359),
    [anon_sym_concept] = ACTIONS(2359),
    [anon_sym_co_return] = ACTIONS(2359),
    [anon_sym_co_yield] = ACTIONS(2359),
    [anon_sym_catch] = ACTIONS(2359),
    [anon_sym_R_DQUOTE] = ACTIONS(2357),
    [anon_sym_LR_DQUOTE] = ACTIONS(2357),
    [anon_sym_uR_DQUOTE] = ACTIONS(2357),
    [anon_sym_UR_DQUOTE] = ACTIONS(2357),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2357),
    [anon_sym_co_await] = ACTIONS(2359),
    [anon_sym_new] = ACTIONS(2359),
    [anon_sym_requires] = ACTIONS(2359),
    [sym_this] = ACTIONS(2359),
    [anon_sym_discard] = ACTIONS(2359),
    [anon_sym_precise] = ACTIONS(2359),
    [anon_sym_shared] = ACTIONS(2359),
    [anon_sym_groupshared] = ACTIONS(2359),
    [anon_sym_uniform] = ACTIONS(2359),
    [anon_sym_row_major] = ACTIONS(2359),
    [anon_sym_column_major] = ACTIONS(2359),
    [anon_sym_globallycoherent] = ACTIONS(2359),
    [anon_sym_centroid] = ACTIONS(2359),
    [anon_sym_noperspective] = ACTIONS(2359),
    [anon_sym_nointerpolation] = ACTIONS(2359),
    [anon_sym_sample] = ACTIONS(2359),
    [anon_sym_linear] = ACTIONS(2359),
    [anon_sym_snorm] = ACTIONS(2359),
    [anon_sym_unorm] = ACTIONS(2359),
    [anon_sym_point] = ACTIONS(2359),
    [anon_sym_line] = ACTIONS(2359),
    [anon_sym_triangleadj] = ACTIONS(2359),
    [anon_sym_lineadj] = ACTIONS(2359),
    [anon_sym_triangle] = ACTIONS(2359),
    [anon_sym_cbuffer] = ACTIONS(2359),
    [anon_sym_interface] = ACTIONS(2359),
    [anon_sym_extension] = ACTIONS(2359),
  },
  [633] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(641),
    [sym_identifier] = ACTIONS(3771),
    [aux_sym_preproc_include_token1] = ACTIONS(3771),
    [aux_sym_preproc_def_token1] = ACTIONS(3771),
    [aux_sym_preproc_if_token1] = ACTIONS(3771),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3771),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3771),
    [sym_preproc_directive] = ACTIONS(3771),
    [anon_sym_LPAREN2] = ACTIONS(3773),
    [anon_sym_BANG] = ACTIONS(3773),
    [anon_sym_TILDE] = ACTIONS(3773),
    [anon_sym_DASH] = ACTIONS(3771),
    [anon_sym_PLUS] = ACTIONS(3771),
    [anon_sym_STAR] = ACTIONS(3773),
    [anon_sym_AMP_AMP] = ACTIONS(3773),
    [anon_sym_AMP] = ACTIONS(3771),
    [anon_sym_SEMI] = ACTIONS(3773),
    [anon_sym___extension__] = ACTIONS(3771),
    [anon_sym_typedef] = ACTIONS(3771),
    [anon_sym_in] = ACTIONS(3771),
    [anon_sym_out] = ACTIONS(3771),
    [anon_sym_inout] = ACTIONS(3771),
    [anon_sym_extern] = ACTIONS(3771),
    [anon_sym___attribute__] = ACTIONS(3771),
    [anon_sym_COLON_COLON] = ACTIONS(3773),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3773),
    [anon_sym___declspec] = ACTIONS(3771),
    [anon_sym___based] = ACTIONS(3771),
    [anon_sym___cdecl] = ACTIONS(3771),
    [anon_sym___clrcall] = ACTIONS(3771),
    [anon_sym___stdcall] = ACTIONS(3771),
    [anon_sym___fastcall] = ACTIONS(3771),
    [anon_sym___thiscall] = ACTIONS(3771),
    [anon_sym___vectorcall] = ACTIONS(3771),
    [anon_sym_LBRACE] = ACTIONS(3773),
    [anon_sym_RBRACE] = ACTIONS(3773),
    [anon_sym_signed] = ACTIONS(3775),
    [anon_sym_unsigned] = ACTIONS(3775),
    [anon_sym_long] = ACTIONS(3775),
    [anon_sym_short] = ACTIONS(3775),
    [anon_sym_LBRACK] = ACTIONS(3771),
    [anon_sym_static] = ACTIONS(3771),
    [anon_sym_register] = ACTIONS(3771),
    [anon_sym_inline] = ACTIONS(3771),
    [anon_sym___inline] = ACTIONS(3771),
    [anon_sym___inline__] = ACTIONS(3771),
    [anon_sym___forceinline] = ACTIONS(3771),
    [anon_sym_thread_local] = ACTIONS(3771),
    [anon_sym___thread] = ACTIONS(3771),
    [anon_sym_const] = ACTIONS(3771),
    [anon_sym_constexpr] = ACTIONS(3771),
    [anon_sym_volatile] = ACTIONS(3771),
    [anon_sym_restrict] = ACTIONS(3771),
    [anon_sym___restrict__] = ACTIONS(3771),
    [anon_sym__Atomic] = ACTIONS(3771),
    [anon_sym__Noreturn] = ACTIONS(3771),
    [anon_sym_noreturn] = ACTIONS(3771),
    [anon_sym_mutable] = ACTIONS(3771),
    [anon_sym_constinit] = ACTIONS(3771),
    [anon_sym_consteval] = ACTIONS(3771),
    [anon_sym_alignas] = ACTIONS(3771),
    [anon_sym__Alignas] = ACTIONS(3771),
    [sym_primitive_type] = ACTIONS(3771),
    [anon_sym_enum] = ACTIONS(3771),
    [anon_sym_class] = ACTIONS(3771),
    [anon_sym_struct] = ACTIONS(3771),
    [anon_sym_union] = ACTIONS(3771),
    [anon_sym_if] = ACTIONS(3771),
    [anon_sym_switch] = ACTIONS(3771),
    [anon_sym_case] = ACTIONS(3771),
    [anon_sym_default] = ACTIONS(3771),
    [anon_sym_while] = ACTIONS(3771),
    [anon_sym_do] = ACTIONS(3771),
    [anon_sym_for] = ACTIONS(3771),
    [anon_sym_return] = ACTIONS(3771),
    [anon_sym_break] = ACTIONS(3771),
    [anon_sym_continue] = ACTIONS(3771),
    [anon_sym_goto] = ACTIONS(3771),
    [anon_sym___try] = ACTIONS(3771),
    [anon_sym___leave] = ACTIONS(3771),
    [anon_sym_not] = ACTIONS(3771),
    [anon_sym_compl] = ACTIONS(3771),
    [anon_sym_DASH_DASH] = ACTIONS(3773),
    [anon_sym_PLUS_PLUS] = ACTIONS(3773),
    [anon_sym_sizeof] = ACTIONS(3771),
    [anon_sym___alignof__] = ACTIONS(3771),
    [anon_sym___alignof] = ACTIONS(3771),
    [anon_sym__alignof] = ACTIONS(3771),
    [anon_sym_alignof] = ACTIONS(3771),
    [anon_sym__Alignof] = ACTIONS(3771),
    [anon_sym_offsetof] = ACTIONS(3771),
    [anon_sym__Generic] = ACTIONS(3771),
    [anon_sym_asm] = ACTIONS(3771),
    [anon_sym___asm__] = ACTIONS(3771),
    [anon_sym_DOT] = ACTIONS(3771),
    [sym_number_literal] = ACTIONS(3773),
    [anon_sym_L_SQUOTE] = ACTIONS(3773),
    [anon_sym_u_SQUOTE] = ACTIONS(3773),
    [anon_sym_U_SQUOTE] = ACTIONS(3773),
    [anon_sym_u8_SQUOTE] = ACTIONS(3773),
    [anon_sym_SQUOTE] = ACTIONS(3773),
    [anon_sym_L_DQUOTE] = ACTIONS(3773),
    [anon_sym_u_DQUOTE] = ACTIONS(3773),
    [anon_sym_U_DQUOTE] = ACTIONS(3773),
    [anon_sym_u8_DQUOTE] = ACTIONS(3773),
    [anon_sym_DQUOTE] = ACTIONS(3773),
    [sym_true] = ACTIONS(3771),
    [sym_false] = ACTIONS(3771),
    [anon_sym_NULL] = ACTIONS(3771),
    [anon_sym_nullptr] = ACTIONS(3771),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3771),
    [anon_sym_let] = ACTIONS(3771),
    [anon_sym_This] = ACTIONS(3771),
    [anon_sym_decltype] = ACTIONS(3771),
    [sym_virtual] = ACTIONS(3771),
    [anon_sym_explicit] = ACTIONS(3771),
    [anon_sym_typename] = ACTIONS(3771),
    [anon_sym_template] = ACTIONS(3771),
    [anon_sym_operator] = ACTIONS(3771),
    [anon_sym_try] = ACTIONS(3771),
    [anon_sym_delete] = ACTIONS(3771),
    [anon_sym_throw] = ACTIONS(3771),
    [anon_sym_namespace] = ACTIONS(3771),
    [anon_sym_using] = ACTIONS(3771),
    [anon_sym_static_assert] = ACTIONS(3771),
    [anon_sym_concept] = ACTIONS(3771),
    [anon_sym_co_return] = ACTIONS(3771),
    [anon_sym_co_yield] = ACTIONS(3771),
    [anon_sym_R_DQUOTE] = ACTIONS(3773),
    [anon_sym_LR_DQUOTE] = ACTIONS(3773),
    [anon_sym_uR_DQUOTE] = ACTIONS(3773),
    [anon_sym_UR_DQUOTE] = ACTIONS(3773),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3773),
    [anon_sym_co_await] = ACTIONS(3771),
    [anon_sym_new] = ACTIONS(3771),
    [anon_sym_requires] = ACTIONS(3771),
    [sym_this] = ACTIONS(3771),
    [anon_sym_discard] = ACTIONS(3771),
    [anon_sym_precise] = ACTIONS(3771),
    [anon_sym_shared] = ACTIONS(3771),
    [anon_sym_groupshared] = ACTIONS(3771),
    [anon_sym_uniform] = ACTIONS(3771),
    [anon_sym_row_major] = ACTIONS(3771),
    [anon_sym_column_major] = ACTIONS(3771),
    [anon_sym_globallycoherent] = ACTIONS(3771),
    [anon_sym_centroid] = ACTIONS(3771),
    [anon_sym_noperspective] = ACTIONS(3771),
    [anon_sym_nointerpolation] = ACTIONS(3771),
    [anon_sym_sample] = ACTIONS(3771),
    [anon_sym_linear] = ACTIONS(3771),
    [anon_sym_snorm] = ACTIONS(3771),
    [anon_sym_unorm] = ACTIONS(3771),
    [anon_sym_point] = ACTIONS(3771),
    [anon_sym_line] = ACTIONS(3771),
    [anon_sym_triangleadj] = ACTIONS(3771),
    [anon_sym_lineadj] = ACTIONS(3771),
    [anon_sym_triangle] = ACTIONS(3771),
    [anon_sym_cbuffer] = ACTIONS(3771),
    [anon_sym_interface] = ACTIONS(3771),
    [anon_sym_extension] = ACTIONS(3771),
  },
  [634] = {
    [sym_identifier] = ACTIONS(2491),
    [aux_sym_preproc_include_token1] = ACTIONS(2491),
    [aux_sym_preproc_def_token1] = ACTIONS(2491),
    [aux_sym_preproc_if_token1] = ACTIONS(2491),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2491),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2491),
    [sym_preproc_directive] = ACTIONS(2491),
    [anon_sym_LPAREN2] = ACTIONS(2489),
    [anon_sym_BANG] = ACTIONS(2489),
    [anon_sym_TILDE] = ACTIONS(2489),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(2489),
    [anon_sym_AMP_AMP] = ACTIONS(2489),
    [anon_sym_AMP] = ACTIONS(2491),
    [anon_sym_SEMI] = ACTIONS(2489),
    [anon_sym___extension__] = ACTIONS(2491),
    [anon_sym_typedef] = ACTIONS(2491),
    [anon_sym_in] = ACTIONS(2491),
    [anon_sym_out] = ACTIONS(2491),
    [anon_sym_inout] = ACTIONS(2491),
    [anon_sym_extern] = ACTIONS(2491),
    [anon_sym___attribute__] = ACTIONS(2491),
    [anon_sym_COLON_COLON] = ACTIONS(2489),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2489),
    [anon_sym___declspec] = ACTIONS(2491),
    [anon_sym___based] = ACTIONS(2491),
    [anon_sym___cdecl] = ACTIONS(2491),
    [anon_sym___clrcall] = ACTIONS(2491),
    [anon_sym___stdcall] = ACTIONS(2491),
    [anon_sym___fastcall] = ACTIONS(2491),
    [anon_sym___thiscall] = ACTIONS(2491),
    [anon_sym___vectorcall] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(2489),
    [anon_sym_RBRACE] = ACTIONS(2489),
    [anon_sym_signed] = ACTIONS(2491),
    [anon_sym_unsigned] = ACTIONS(2491),
    [anon_sym_long] = ACTIONS(2491),
    [anon_sym_short] = ACTIONS(2491),
    [anon_sym_LBRACK] = ACTIONS(2491),
    [anon_sym_static] = ACTIONS(2491),
    [anon_sym_register] = ACTIONS(2491),
    [anon_sym_inline] = ACTIONS(2491),
    [anon_sym___inline] = ACTIONS(2491),
    [anon_sym___inline__] = ACTIONS(2491),
    [anon_sym___forceinline] = ACTIONS(2491),
    [anon_sym_thread_local] = ACTIONS(2491),
    [anon_sym___thread] = ACTIONS(2491),
    [anon_sym_const] = ACTIONS(2491),
    [anon_sym_constexpr] = ACTIONS(2491),
    [anon_sym_volatile] = ACTIONS(2491),
    [anon_sym_restrict] = ACTIONS(2491),
    [anon_sym___restrict__] = ACTIONS(2491),
    [anon_sym__Atomic] = ACTIONS(2491),
    [anon_sym__Noreturn] = ACTIONS(2491),
    [anon_sym_noreturn] = ACTIONS(2491),
    [anon_sym_mutable] = ACTIONS(2491),
    [anon_sym_constinit] = ACTIONS(2491),
    [anon_sym_consteval] = ACTIONS(2491),
    [anon_sym_alignas] = ACTIONS(2491),
    [anon_sym__Alignas] = ACTIONS(2491),
    [sym_primitive_type] = ACTIONS(2491),
    [anon_sym_enum] = ACTIONS(2491),
    [anon_sym_class] = ACTIONS(2491),
    [anon_sym_struct] = ACTIONS(2491),
    [anon_sym_union] = ACTIONS(2491),
    [anon_sym_if] = ACTIONS(2491),
    [anon_sym_else] = ACTIONS(2491),
    [anon_sym_switch] = ACTIONS(2491),
    [anon_sym_case] = ACTIONS(2491),
    [anon_sym_default] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2491),
    [anon_sym_do] = ACTIONS(2491),
    [anon_sym_for] = ACTIONS(2491),
    [anon_sym_return] = ACTIONS(2491),
    [anon_sym_break] = ACTIONS(2491),
    [anon_sym_continue] = ACTIONS(2491),
    [anon_sym_goto] = ACTIONS(2491),
    [anon_sym___try] = ACTIONS(2491),
    [anon_sym___leave] = ACTIONS(2491),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(2489),
    [anon_sym_PLUS_PLUS] = ACTIONS(2489),
    [anon_sym_sizeof] = ACTIONS(2491),
    [anon_sym___alignof__] = ACTIONS(2491),
    [anon_sym___alignof] = ACTIONS(2491),
    [anon_sym__alignof] = ACTIONS(2491),
    [anon_sym_alignof] = ACTIONS(2491),
    [anon_sym__Alignof] = ACTIONS(2491),
    [anon_sym_offsetof] = ACTIONS(2491),
    [anon_sym__Generic] = ACTIONS(2491),
    [anon_sym_asm] = ACTIONS(2491),
    [anon_sym___asm__] = ACTIONS(2491),
    [anon_sym_DOT] = ACTIONS(2491),
    [sym_number_literal] = ACTIONS(2489),
    [anon_sym_L_SQUOTE] = ACTIONS(2489),
    [anon_sym_u_SQUOTE] = ACTIONS(2489),
    [anon_sym_U_SQUOTE] = ACTIONS(2489),
    [anon_sym_u8_SQUOTE] = ACTIONS(2489),
    [anon_sym_SQUOTE] = ACTIONS(2489),
    [anon_sym_L_DQUOTE] = ACTIONS(2489),
    [anon_sym_u_DQUOTE] = ACTIONS(2489),
    [anon_sym_U_DQUOTE] = ACTIONS(2489),
    [anon_sym_u8_DQUOTE] = ACTIONS(2489),
    [anon_sym_DQUOTE] = ACTIONS(2489),
    [sym_true] = ACTIONS(2491),
    [sym_false] = ACTIONS(2491),
    [anon_sym_NULL] = ACTIONS(2491),
    [anon_sym_nullptr] = ACTIONS(2491),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2491),
    [anon_sym_let] = ACTIONS(2491),
    [anon_sym_This] = ACTIONS(2491),
    [anon_sym_decltype] = ACTIONS(2491),
    [sym_virtual] = ACTIONS(2491),
    [anon_sym_explicit] = ACTIONS(2491),
    [anon_sym_typename] = ACTIONS(2491),
    [anon_sym_template] = ACTIONS(2491),
    [anon_sym_operator] = ACTIONS(2491),
    [anon_sym_try] = ACTIONS(2491),
    [anon_sym_delete] = ACTIONS(2491),
    [anon_sym_throw] = ACTIONS(2491),
    [anon_sym_namespace] = ACTIONS(2491),
    [anon_sym_using] = ACTIONS(2491),
    [anon_sym_static_assert] = ACTIONS(2491),
    [anon_sym_concept] = ACTIONS(2491),
    [anon_sym_co_return] = ACTIONS(2491),
    [anon_sym_co_yield] = ACTIONS(2491),
    [anon_sym_R_DQUOTE] = ACTIONS(2489),
    [anon_sym_LR_DQUOTE] = ACTIONS(2489),
    [anon_sym_uR_DQUOTE] = ACTIONS(2489),
    [anon_sym_UR_DQUOTE] = ACTIONS(2489),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2489),
    [anon_sym_co_await] = ACTIONS(2491),
    [anon_sym_new] = ACTIONS(2491),
    [anon_sym_requires] = ACTIONS(2491),
    [sym_this] = ACTIONS(2491),
    [anon_sym_discard] = ACTIONS(2491),
    [anon_sym_precise] = ACTIONS(2491),
    [anon_sym_shared] = ACTIONS(2491),
    [anon_sym_groupshared] = ACTIONS(2491),
    [anon_sym_uniform] = ACTIONS(2491),
    [anon_sym_row_major] = ACTIONS(2491),
    [anon_sym_column_major] = ACTIONS(2491),
    [anon_sym_globallycoherent] = ACTIONS(2491),
    [anon_sym_centroid] = ACTIONS(2491),
    [anon_sym_noperspective] = ACTIONS(2491),
    [anon_sym_nointerpolation] = ACTIONS(2491),
    [anon_sym_sample] = ACTIONS(2491),
    [anon_sym_linear] = ACTIONS(2491),
    [anon_sym_snorm] = ACTIONS(2491),
    [anon_sym_unorm] = ACTIONS(2491),
    [anon_sym_point] = ACTIONS(2491),
    [anon_sym_line] = ACTIONS(2491),
    [anon_sym_triangleadj] = ACTIONS(2491),
    [anon_sym_lineadj] = ACTIONS(2491),
    [anon_sym_triangle] = ACTIONS(2491),
    [anon_sym_cbuffer] = ACTIONS(2491),
    [anon_sym_interface] = ACTIONS(2491),
    [anon_sym_extension] = ACTIONS(2491),
  },
  [635] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(637),
    [sym_identifier] = ACTIONS(3778),
    [aux_sym_preproc_include_token1] = ACTIONS(3778),
    [aux_sym_preproc_def_token1] = ACTIONS(3778),
    [aux_sym_preproc_if_token1] = ACTIONS(3778),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3778),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3778),
    [sym_preproc_directive] = ACTIONS(3778),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_BANG] = ACTIONS(3781),
    [anon_sym_TILDE] = ACTIONS(3781),
    [anon_sym_DASH] = ACTIONS(3778),
    [anon_sym_PLUS] = ACTIONS(3778),
    [anon_sym_STAR] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_SEMI] = ACTIONS(3781),
    [anon_sym___extension__] = ACTIONS(3778),
    [anon_sym_typedef] = ACTIONS(3778),
    [anon_sym_in] = ACTIONS(3778),
    [anon_sym_out] = ACTIONS(3778),
    [anon_sym_inout] = ACTIONS(3778),
    [anon_sym_extern] = ACTIONS(3778),
    [anon_sym___attribute__] = ACTIONS(3778),
    [anon_sym_COLON_COLON] = ACTIONS(3781),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3781),
    [anon_sym___declspec] = ACTIONS(3778),
    [anon_sym___based] = ACTIONS(3778),
    [anon_sym___cdecl] = ACTIONS(3778),
    [anon_sym___clrcall] = ACTIONS(3778),
    [anon_sym___stdcall] = ACTIONS(3778),
    [anon_sym___fastcall] = ACTIONS(3778),
    [anon_sym___thiscall] = ACTIONS(3778),
    [anon_sym___vectorcall] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_RBRACE] = ACTIONS(3781),
    [anon_sym_signed] = ACTIONS(3784),
    [anon_sym_unsigned] = ACTIONS(3784),
    [anon_sym_long] = ACTIONS(3784),
    [anon_sym_short] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3778),
    [anon_sym_static] = ACTIONS(3778),
    [anon_sym_register] = ACTIONS(3778),
    [anon_sym_inline] = ACTIONS(3778),
    [anon_sym___inline] = ACTIONS(3778),
    [anon_sym___inline__] = ACTIONS(3778),
    [anon_sym___forceinline] = ACTIONS(3778),
    [anon_sym_thread_local] = ACTIONS(3778),
    [anon_sym___thread] = ACTIONS(3778),
    [anon_sym_const] = ACTIONS(3778),
    [anon_sym_constexpr] = ACTIONS(3778),
    [anon_sym_volatile] = ACTIONS(3778),
    [anon_sym_restrict] = ACTIONS(3778),
    [anon_sym___restrict__] = ACTIONS(3778),
    [anon_sym__Atomic] = ACTIONS(3778),
    [anon_sym__Noreturn] = ACTIONS(3778),
    [anon_sym_noreturn] = ACTIONS(3778),
    [anon_sym_mutable] = ACTIONS(3778),
    [anon_sym_constinit] = ACTIONS(3778),
    [anon_sym_consteval] = ACTIONS(3778),
    [anon_sym_alignas] = ACTIONS(3778),
    [anon_sym__Alignas] = ACTIONS(3778),
    [sym_primitive_type] = ACTIONS(3778),
    [anon_sym_enum] = ACTIONS(3778),
    [anon_sym_class] = ACTIONS(3778),
    [anon_sym_struct] = ACTIONS(3778),
    [anon_sym_union] = ACTIONS(3778),
    [anon_sym_if] = ACTIONS(3778),
    [anon_sym_switch] = ACTIONS(3778),
    [anon_sym_case] = ACTIONS(3778),
    [anon_sym_default] = ACTIONS(3778),
    [anon_sym_while] = ACTIONS(3778),
    [anon_sym_do] = ACTIONS(3778),
    [anon_sym_for] = ACTIONS(3778),
    [anon_sym_return] = ACTIONS(3778),
    [anon_sym_break] = ACTIONS(3778),
    [anon_sym_continue] = ACTIONS(3778),
    [anon_sym_goto] = ACTIONS(3778),
    [anon_sym___try] = ACTIONS(3778),
    [anon_sym___leave] = ACTIONS(3778),
    [anon_sym_not] = ACTIONS(3778),
    [anon_sym_compl] = ACTIONS(3778),
    [anon_sym_DASH_DASH] = ACTIONS(3781),
    [anon_sym_PLUS_PLUS] = ACTIONS(3781),
    [anon_sym_sizeof] = ACTIONS(3778),
    [anon_sym___alignof__] = ACTIONS(3778),
    [anon_sym___alignof] = ACTIONS(3778),
    [anon_sym__alignof] = ACTIONS(3778),
    [anon_sym_alignof] = ACTIONS(3778),
    [anon_sym__Alignof] = ACTIONS(3778),
    [anon_sym_offsetof] = ACTIONS(3778),
    [anon_sym__Generic] = ACTIONS(3778),
    [anon_sym_asm] = ACTIONS(3778),
    [anon_sym___asm__] = ACTIONS(3778),
    [anon_sym_DOT] = ACTIONS(3778),
    [sym_number_literal] = ACTIONS(3781),
    [anon_sym_L_SQUOTE] = ACTIONS(3781),
    [anon_sym_u_SQUOTE] = ACTIONS(3781),
    [anon_sym_U_SQUOTE] = ACTIONS(3781),
    [anon_sym_u8_SQUOTE] = ACTIONS(3781),
    [anon_sym_SQUOTE] = ACTIONS(3781),
    [anon_sym_L_DQUOTE] = ACTIONS(3781),
    [anon_sym_u_DQUOTE] = ACTIONS(3781),
    [anon_sym_U_DQUOTE] = ACTIONS(3781),
    [anon_sym_u8_DQUOTE] = ACTIONS(3781),
    [anon_sym_DQUOTE] = ACTIONS(3781),
    [sym_true] = ACTIONS(3778),
    [sym_false] = ACTIONS(3778),
    [anon_sym_NULL] = ACTIONS(3778),
    [anon_sym_nullptr] = ACTIONS(3778),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3778),
    [anon_sym_let] = ACTIONS(3778),
    [anon_sym_This] = ACTIONS(3778),
    [anon_sym_decltype] = ACTIONS(3778),
    [sym_virtual] = ACTIONS(3778),
    [anon_sym_explicit] = ACTIONS(3778),
    [anon_sym_typename] = ACTIONS(3778),
    [anon_sym_template] = ACTIONS(3778),
    [anon_sym_operator] = ACTIONS(3778),
    [anon_sym_try] = ACTIONS(3778),
    [anon_sym_delete] = ACTIONS(3778),
    [anon_sym_throw] = ACTIONS(3778),
    [anon_sym_namespace] = ACTIONS(3778),
    [anon_sym_using] = ACTIONS(3778),
    [anon_sym_static_assert] = ACTIONS(3778),
    [anon_sym_concept] = ACTIONS(3778),
    [anon_sym_co_return] = ACTIONS(3778),
    [anon_sym_co_yield] = ACTIONS(3778),
    [anon_sym_R_DQUOTE] = ACTIONS(3781),
    [anon_sym_LR_DQUOTE] = ACTIONS(3781),
    [anon_sym_uR_DQUOTE] = ACTIONS(3781),
    [anon_sym_UR_DQUOTE] = ACTIONS(3781),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3781),
    [anon_sym_co_await] = ACTIONS(3778),
    [anon_sym_new] = ACTIONS(3778),
    [anon_sym_requires] = ACTIONS(3778),
    [sym_this] = ACTIONS(3778),
    [anon_sym_discard] = ACTIONS(3778),
    [anon_sym_precise] = ACTIONS(3778),
    [anon_sym_shared] = ACTIONS(3778),
    [anon_sym_groupshared] = ACTIONS(3778),
    [anon_sym_uniform] = ACTIONS(3778),
    [anon_sym_row_major] = ACTIONS(3778),
    [anon_sym_column_major] = ACTIONS(3778),
    [anon_sym_globallycoherent] = ACTIONS(3778),
    [anon_sym_centroid] = ACTIONS(3778),
    [anon_sym_noperspective] = ACTIONS(3778),
    [anon_sym_nointerpolation] = ACTIONS(3778),
    [anon_sym_sample] = ACTIONS(3778),
    [anon_sym_linear] = ACTIONS(3778),
    [anon_sym_snorm] = ACTIONS(3778),
    [anon_sym_unorm] = ACTIONS(3778),
    [anon_sym_point] = ACTIONS(3778),
    [anon_sym_line] = ACTIONS(3778),
    [anon_sym_triangleadj] = ACTIONS(3778),
    [anon_sym_lineadj] = ACTIONS(3778),
    [anon_sym_triangle] = ACTIONS(3778),
    [anon_sym_cbuffer] = ACTIONS(3778),
    [anon_sym_interface] = ACTIONS(3778),
    [anon_sym_extension] = ACTIONS(3778),
  },
  [636] = {
    [sym_else_clause] = STATE(807),
    [sym_identifier] = ACTIONS(2846),
    [aux_sym_preproc_include_token1] = ACTIONS(2846),
    [aux_sym_preproc_def_token1] = ACTIONS(2846),
    [aux_sym_preproc_if_token1] = ACTIONS(2846),
    [aux_sym_preproc_if_token2] = ACTIONS(2846),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2846),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2846),
    [sym_preproc_directive] = ACTIONS(2846),
    [anon_sym_LPAREN2] = ACTIONS(2848),
    [anon_sym_BANG] = ACTIONS(2848),
    [anon_sym_TILDE] = ACTIONS(2848),
    [anon_sym_DASH] = ACTIONS(2846),
    [anon_sym_PLUS] = ACTIONS(2846),
    [anon_sym_STAR] = ACTIONS(2848),
    [anon_sym_AMP_AMP] = ACTIONS(2848),
    [anon_sym_AMP] = ACTIONS(2846),
    [anon_sym_SEMI] = ACTIONS(2848),
    [anon_sym___extension__] = ACTIONS(2846),
    [anon_sym_typedef] = ACTIONS(2846),
    [anon_sym_in] = ACTIONS(2846),
    [anon_sym_out] = ACTIONS(2846),
    [anon_sym_inout] = ACTIONS(2846),
    [anon_sym_extern] = ACTIONS(2846),
    [anon_sym___attribute__] = ACTIONS(2846),
    [anon_sym_COLON_COLON] = ACTIONS(2848),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2848),
    [anon_sym___declspec] = ACTIONS(2846),
    [anon_sym___based] = ACTIONS(2846),
    [anon_sym___cdecl] = ACTIONS(2846),
    [anon_sym___clrcall] = ACTIONS(2846),
    [anon_sym___stdcall] = ACTIONS(2846),
    [anon_sym___fastcall] = ACTIONS(2846),
    [anon_sym___thiscall] = ACTIONS(2846),
    [anon_sym___vectorcall] = ACTIONS(2846),
    [anon_sym_LBRACE] = ACTIONS(2848),
    [anon_sym_signed] = ACTIONS(2846),
    [anon_sym_unsigned] = ACTIONS(2846),
    [anon_sym_long] = ACTIONS(2846),
    [anon_sym_short] = ACTIONS(2846),
    [anon_sym_LBRACK] = ACTIONS(2846),
    [anon_sym_static] = ACTIONS(2846),
    [anon_sym_register] = ACTIONS(2846),
    [anon_sym_inline] = ACTIONS(2846),
    [anon_sym___inline] = ACTIONS(2846),
    [anon_sym___inline__] = ACTIONS(2846),
    [anon_sym___forceinline] = ACTIONS(2846),
    [anon_sym_thread_local] = ACTIONS(2846),
    [anon_sym___thread] = ACTIONS(2846),
    [anon_sym_const] = ACTIONS(2846),
    [anon_sym_constexpr] = ACTIONS(2846),
    [anon_sym_volatile] = ACTIONS(2846),
    [anon_sym_restrict] = ACTIONS(2846),
    [anon_sym___restrict__] = ACTIONS(2846),
    [anon_sym__Atomic] = ACTIONS(2846),
    [anon_sym__Noreturn] = ACTIONS(2846),
    [anon_sym_noreturn] = ACTIONS(2846),
    [anon_sym_mutable] = ACTIONS(2846),
    [anon_sym_constinit] = ACTIONS(2846),
    [anon_sym_consteval] = ACTIONS(2846),
    [anon_sym_alignas] = ACTIONS(2846),
    [anon_sym__Alignas] = ACTIONS(2846),
    [sym_primitive_type] = ACTIONS(2846),
    [anon_sym_enum] = ACTIONS(2846),
    [anon_sym_class] = ACTIONS(2846),
    [anon_sym_struct] = ACTIONS(2846),
    [anon_sym_union] = ACTIONS(2846),
    [anon_sym_if] = ACTIONS(2846),
    [anon_sym_else] = ACTIONS(3729),
    [anon_sym_switch] = ACTIONS(2846),
    [anon_sym_case] = ACTIONS(2846),
    [anon_sym_default] = ACTIONS(2846),
    [anon_sym_while] = ACTIONS(2846),
    [anon_sym_do] = ACTIONS(2846),
    [anon_sym_for] = ACTIONS(2846),
    [anon_sym_return] = ACTIONS(2846),
    [anon_sym_break] = ACTIONS(2846),
    [anon_sym_continue] = ACTIONS(2846),
    [anon_sym_goto] = ACTIONS(2846),
    [anon_sym___try] = ACTIONS(2846),
    [anon_sym___leave] = ACTIONS(2846),
    [anon_sym_not] = ACTIONS(2846),
    [anon_sym_compl] = ACTIONS(2846),
    [anon_sym_DASH_DASH] = ACTIONS(2848),
    [anon_sym_PLUS_PLUS] = ACTIONS(2848),
    [anon_sym_sizeof] = ACTIONS(2846),
    [anon_sym___alignof__] = ACTIONS(2846),
    [anon_sym___alignof] = ACTIONS(2846),
    [anon_sym__alignof] = ACTIONS(2846),
    [anon_sym_alignof] = ACTIONS(2846),
    [anon_sym__Alignof] = ACTIONS(2846),
    [anon_sym_offsetof] = ACTIONS(2846),
    [anon_sym__Generic] = ACTIONS(2846),
    [anon_sym_asm] = ACTIONS(2846),
    [anon_sym___asm__] = ACTIONS(2846),
    [sym_number_literal] = ACTIONS(2848),
    [anon_sym_L_SQUOTE] = ACTIONS(2848),
    [anon_sym_u_SQUOTE] = ACTIONS(2848),
    [anon_sym_U_SQUOTE] = ACTIONS(2848),
    [anon_sym_u8_SQUOTE] = ACTIONS(2848),
    [anon_sym_SQUOTE] = ACTIONS(2848),
    [anon_sym_L_DQUOTE] = ACTIONS(2848),
    [anon_sym_u_DQUOTE] = ACTIONS(2848),
    [anon_sym_U_DQUOTE] = ACTIONS(2848),
    [anon_sym_u8_DQUOTE] = ACTIONS(2848),
    [anon_sym_DQUOTE] = ACTIONS(2848),
    [sym_true] = ACTIONS(2846),
    [sym_false] = ACTIONS(2846),
    [anon_sym_NULL] = ACTIONS(2846),
    [anon_sym_nullptr] = ACTIONS(2846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2846),
    [anon_sym_let] = ACTIONS(2846),
    [anon_sym_This] = ACTIONS(2846),
    [anon_sym_decltype] = ACTIONS(2846),
    [sym_virtual] = ACTIONS(2846),
    [anon_sym_explicit] = ACTIONS(2846),
    [anon_sym_typename] = ACTIONS(2846),
    [anon_sym_template] = ACTIONS(2846),
    [anon_sym_operator] = ACTIONS(2846),
    [anon_sym_try] = ACTIONS(2846),
    [anon_sym_delete] = ACTIONS(2846),
    [anon_sym_throw] = ACTIONS(2846),
    [anon_sym_namespace] = ACTIONS(2846),
    [anon_sym_using] = ACTIONS(2846),
    [anon_sym_static_assert] = ACTIONS(2846),
    [anon_sym_concept] = ACTIONS(2846),
    [anon_sym_co_return] = ACTIONS(2846),
    [anon_sym_co_yield] = ACTIONS(2846),
    [anon_sym_R_DQUOTE] = ACTIONS(2848),
    [anon_sym_LR_DQUOTE] = ACTIONS(2848),
    [anon_sym_uR_DQUOTE] = ACTIONS(2848),
    [anon_sym_UR_DQUOTE] = ACTIONS(2848),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2848),
    [anon_sym_co_await] = ACTIONS(2846),
    [anon_sym_new] = ACTIONS(2846),
    [anon_sym_requires] = ACTIONS(2846),
    [sym_this] = ACTIONS(2846),
    [anon_sym_discard] = ACTIONS(2846),
    [anon_sym_precise] = ACTIONS(2846),
    [anon_sym_shared] = ACTIONS(2846),
    [anon_sym_groupshared] = ACTIONS(2846),
    [anon_sym_uniform] = ACTIONS(2846),
    [anon_sym_row_major] = ACTIONS(2846),
    [anon_sym_column_major] = ACTIONS(2846),
    [anon_sym_globallycoherent] = ACTIONS(2846),
    [anon_sym_centroid] = ACTIONS(2846),
    [anon_sym_noperspective] = ACTIONS(2846),
    [anon_sym_nointerpolation] = ACTIONS(2846),
    [anon_sym_sample] = ACTIONS(2846),
    [anon_sym_linear] = ACTIONS(2846),
    [anon_sym_snorm] = ACTIONS(2846),
    [anon_sym_unorm] = ACTIONS(2846),
    [anon_sym_point] = ACTIONS(2846),
    [anon_sym_line] = ACTIONS(2846),
    [anon_sym_triangleadj] = ACTIONS(2846),
    [anon_sym_lineadj] = ACTIONS(2846),
    [anon_sym_triangle] = ACTIONS(2846),
    [anon_sym_cbuffer] = ACTIONS(2846),
    [anon_sym_interface] = ACTIONS(2846),
    [anon_sym_extension] = ACTIONS(2846),
  },
  [637] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(637),
    [sym_identifier] = ACTIONS(2856),
    [aux_sym_preproc_include_token1] = ACTIONS(2856),
    [aux_sym_preproc_def_token1] = ACTIONS(2856),
    [aux_sym_preproc_if_token1] = ACTIONS(2856),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2856),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2856),
    [sym_preproc_directive] = ACTIONS(2856),
    [anon_sym_LPAREN2] = ACTIONS(2854),
    [anon_sym_BANG] = ACTIONS(2854),
    [anon_sym_TILDE] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(2856),
    [anon_sym_PLUS] = ACTIONS(2856),
    [anon_sym_STAR] = ACTIONS(2854),
    [anon_sym_AMP_AMP] = ACTIONS(2854),
    [anon_sym_AMP] = ACTIONS(2856),
    [anon_sym_SEMI] = ACTIONS(2854),
    [anon_sym___extension__] = ACTIONS(2856),
    [anon_sym_typedef] = ACTIONS(2856),
    [anon_sym_in] = ACTIONS(2856),
    [anon_sym_out] = ACTIONS(2856),
    [anon_sym_inout] = ACTIONS(2856),
    [anon_sym_extern] = ACTIONS(2856),
    [anon_sym___attribute__] = ACTIONS(2856),
    [anon_sym_COLON_COLON] = ACTIONS(2854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2854),
    [anon_sym___declspec] = ACTIONS(2856),
    [anon_sym___based] = ACTIONS(2856),
    [anon_sym___cdecl] = ACTIONS(2856),
    [anon_sym___clrcall] = ACTIONS(2856),
    [anon_sym___stdcall] = ACTIONS(2856),
    [anon_sym___fastcall] = ACTIONS(2856),
    [anon_sym___thiscall] = ACTIONS(2856),
    [anon_sym___vectorcall] = ACTIONS(2856),
    [anon_sym_LBRACE] = ACTIONS(2854),
    [anon_sym_RBRACE] = ACTIONS(2854),
    [anon_sym_signed] = ACTIONS(3788),
    [anon_sym_unsigned] = ACTIONS(3788),
    [anon_sym_long] = ACTIONS(3788),
    [anon_sym_short] = ACTIONS(3788),
    [anon_sym_LBRACK] = ACTIONS(2856),
    [anon_sym_static] = ACTIONS(2856),
    [anon_sym_register] = ACTIONS(2856),
    [anon_sym_inline] = ACTIONS(2856),
    [anon_sym___inline] = ACTIONS(2856),
    [anon_sym___inline__] = ACTIONS(2856),
    [anon_sym___forceinline] = ACTIONS(2856),
    [anon_sym_thread_local] = ACTIONS(2856),
    [anon_sym___thread] = ACTIONS(2856),
    [anon_sym_const] = ACTIONS(2856),
    [anon_sym_constexpr] = ACTIONS(2856),
    [anon_sym_volatile] = ACTIONS(2856),
    [anon_sym_restrict] = ACTIONS(2856),
    [anon_sym___restrict__] = ACTIONS(2856),
    [anon_sym__Atomic] = ACTIONS(2856),
    [anon_sym__Noreturn] = ACTIONS(2856),
    [anon_sym_noreturn] = ACTIONS(2856),
    [anon_sym_mutable] = ACTIONS(2856),
    [anon_sym_constinit] = ACTIONS(2856),
    [anon_sym_consteval] = ACTIONS(2856),
    [anon_sym_alignas] = ACTIONS(2856),
    [anon_sym__Alignas] = ACTIONS(2856),
    [sym_primitive_type] = ACTIONS(2856),
    [anon_sym_enum] = ACTIONS(2856),
    [anon_sym_class] = ACTIONS(2856),
    [anon_sym_struct] = ACTIONS(2856),
    [anon_sym_union] = ACTIONS(2856),
    [anon_sym_if] = ACTIONS(2856),
    [anon_sym_switch] = ACTIONS(2856),
    [anon_sym_case] = ACTIONS(2856),
    [anon_sym_default] = ACTIONS(2856),
    [anon_sym_while] = ACTIONS(2856),
    [anon_sym_do] = ACTIONS(2856),
    [anon_sym_for] = ACTIONS(2856),
    [anon_sym_return] = ACTIONS(2856),
    [anon_sym_break] = ACTIONS(2856),
    [anon_sym_continue] = ACTIONS(2856),
    [anon_sym_goto] = ACTIONS(2856),
    [anon_sym___try] = ACTIONS(2856),
    [anon_sym___leave] = ACTIONS(2856),
    [anon_sym_not] = ACTIONS(2856),
    [anon_sym_compl] = ACTIONS(2856),
    [anon_sym_DASH_DASH] = ACTIONS(2854),
    [anon_sym_PLUS_PLUS] = ACTIONS(2854),
    [anon_sym_sizeof] = ACTIONS(2856),
    [anon_sym___alignof__] = ACTIONS(2856),
    [anon_sym___alignof] = ACTIONS(2856),
    [anon_sym__alignof] = ACTIONS(2856),
    [anon_sym_alignof] = ACTIONS(2856),
    [anon_sym__Alignof] = ACTIONS(2856),
    [anon_sym_offsetof] = ACTIONS(2856),
    [anon_sym__Generic] = ACTIONS(2856),
    [anon_sym_asm] = ACTIONS(2856),
    [anon_sym___asm__] = ACTIONS(2856),
    [anon_sym_DOT] = ACTIONS(2856),
    [sym_number_literal] = ACTIONS(2854),
    [anon_sym_L_SQUOTE] = ACTIONS(2854),
    [anon_sym_u_SQUOTE] = ACTIONS(2854),
    [anon_sym_U_SQUOTE] = ACTIONS(2854),
    [anon_sym_u8_SQUOTE] = ACTIONS(2854),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [anon_sym_L_DQUOTE] = ACTIONS(2854),
    [anon_sym_u_DQUOTE] = ACTIONS(2854),
    [anon_sym_U_DQUOTE] = ACTIONS(2854),
    [anon_sym_u8_DQUOTE] = ACTIONS(2854),
    [anon_sym_DQUOTE] = ACTIONS(2854),
    [sym_true] = ACTIONS(2856),
    [sym_false] = ACTIONS(2856),
    [anon_sym_NULL] = ACTIONS(2856),
    [anon_sym_nullptr] = ACTIONS(2856),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2856),
    [anon_sym_let] = ACTIONS(2856),
    [anon_sym_This] = ACTIONS(2856),
    [anon_sym_decltype] = ACTIONS(2856),
    [sym_virtual] = ACTIONS(2856),
    [anon_sym_explicit] = ACTIONS(2856),
    [anon_sym_typename] = ACTIONS(2856),
    [anon_sym_template] = ACTIONS(2856),
    [anon_sym_operator] = ACTIONS(2856),
    [anon_sym_try] = ACTIONS(2856),
    [anon_sym_delete] = ACTIONS(2856),
    [anon_sym_throw] = ACTIONS(2856),
    [anon_sym_namespace] = ACTIONS(2856),
    [anon_sym_using] = ACTIONS(2856),
    [anon_sym_static_assert] = ACTIONS(2856),
    [anon_sym_concept] = ACTIONS(2856),
    [anon_sym_co_return] = ACTIONS(2856),
    [anon_sym_co_yield] = ACTIONS(2856),
    [anon_sym_R_DQUOTE] = ACTIONS(2854),
    [anon_sym_LR_DQUOTE] = ACTIONS(2854),
    [anon_sym_uR_DQUOTE] = ACTIONS(2854),
    [anon_sym_UR_DQUOTE] = ACTIONS(2854),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2854),
    [anon_sym_co_await] = ACTIONS(2856),
    [anon_sym_new] = ACTIONS(2856),
    [anon_sym_requires] = ACTIONS(2856),
    [sym_this] = ACTIONS(2856),
    [anon_sym_discard] = ACTIONS(2856),
    [anon_sym_precise] = ACTIONS(2856),
    [anon_sym_shared] = ACTIONS(2856),
    [anon_sym_groupshared] = ACTIONS(2856),
    [anon_sym_uniform] = ACTIONS(2856),
    [anon_sym_row_major] = ACTIONS(2856),
    [anon_sym_column_major] = ACTIONS(2856),
    [anon_sym_globallycoherent] = ACTIONS(2856),
    [anon_sym_centroid] = ACTIONS(2856),
    [anon_sym_noperspective] = ACTIONS(2856),
    [anon_sym_nointerpolation] = ACTIONS(2856),
    [anon_sym_sample] = ACTIONS(2856),
    [anon_sym_linear] = ACTIONS(2856),
    [anon_sym_snorm] = ACTIONS(2856),
    [anon_sym_unorm] = ACTIONS(2856),
    [anon_sym_point] = ACTIONS(2856),
    [anon_sym_line] = ACTIONS(2856),
    [anon_sym_triangleadj] = ACTIONS(2856),
    [anon_sym_lineadj] = ACTIONS(2856),
    [anon_sym_triangle] = ACTIONS(2856),
    [anon_sym_cbuffer] = ACTIONS(2856),
    [anon_sym_interface] = ACTIONS(2856),
    [anon_sym_extension] = ACTIONS(2856),
  },
  [638] = {
    [sym_attribute_specifier] = STATE(801),
    [sym_identifier] = ACTIONS(3791),
    [aux_sym_preproc_include_token1] = ACTIONS(3791),
    [aux_sym_preproc_def_token1] = ACTIONS(3791),
    [aux_sym_preproc_if_token1] = ACTIONS(3791),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3791),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3791),
    [sym_preproc_directive] = ACTIONS(3791),
    [anon_sym_LPAREN2] = ACTIONS(3793),
    [anon_sym_BANG] = ACTIONS(3793),
    [anon_sym_TILDE] = ACTIONS(3793),
    [anon_sym_DASH] = ACTIONS(3791),
    [anon_sym_PLUS] = ACTIONS(3791),
    [anon_sym_STAR] = ACTIONS(3793),
    [anon_sym_AMP_AMP] = ACTIONS(3793),
    [anon_sym_AMP] = ACTIONS(3791),
    [anon_sym_SEMI] = ACTIONS(3793),
    [anon_sym___extension__] = ACTIONS(3791),
    [anon_sym_typedef] = ACTIONS(3791),
    [anon_sym_in] = ACTIONS(3791),
    [anon_sym_out] = ACTIONS(3791),
    [anon_sym_inout] = ACTIONS(3791),
    [anon_sym_extern] = ACTIONS(3791),
    [anon_sym___attribute__] = ACTIONS(2687),
    [anon_sym_COLON_COLON] = ACTIONS(3793),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3793),
    [anon_sym___declspec] = ACTIONS(3791),
    [anon_sym___based] = ACTIONS(3791),
    [anon_sym___cdecl] = ACTIONS(3791),
    [anon_sym___clrcall] = ACTIONS(3791),
    [anon_sym___stdcall] = ACTIONS(3791),
    [anon_sym___fastcall] = ACTIONS(3791),
    [anon_sym___thiscall] = ACTIONS(3791),
    [anon_sym___vectorcall] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(3793),
    [anon_sym_RBRACE] = ACTIONS(3793),
    [anon_sym_signed] = ACTIONS(3791),
    [anon_sym_unsigned] = ACTIONS(3791),
    [anon_sym_long] = ACTIONS(3791),
    [anon_sym_short] = ACTIONS(3791),
    [anon_sym_LBRACK] = ACTIONS(3791),
    [anon_sym_static] = ACTIONS(3791),
    [anon_sym_register] = ACTIONS(3791),
    [anon_sym_inline] = ACTIONS(3791),
    [anon_sym___inline] = ACTIONS(3791),
    [anon_sym___inline__] = ACTIONS(3791),
    [anon_sym___forceinline] = ACTIONS(3791),
    [anon_sym_thread_local] = ACTIONS(3791),
    [anon_sym___thread] = ACTIONS(3791),
    [anon_sym_const] = ACTIONS(3791),
    [anon_sym_constexpr] = ACTIONS(3791),
    [anon_sym_volatile] = ACTIONS(3791),
    [anon_sym_restrict] = ACTIONS(3791),
    [anon_sym___restrict__] = ACTIONS(3791),
    [anon_sym__Atomic] = ACTIONS(3791),
    [anon_sym__Noreturn] = ACTIONS(3791),
    [anon_sym_noreturn] = ACTIONS(3791),
    [anon_sym_mutable] = ACTIONS(3791),
    [anon_sym_constinit] = ACTIONS(3791),
    [anon_sym_consteval] = ACTIONS(3791),
    [anon_sym_alignas] = ACTIONS(3791),
    [anon_sym__Alignas] = ACTIONS(3791),
    [sym_primitive_type] = ACTIONS(3791),
    [anon_sym_enum] = ACTIONS(3791),
    [anon_sym_class] = ACTIONS(3791),
    [anon_sym_struct] = ACTIONS(3791),
    [anon_sym_union] = ACTIONS(3791),
    [anon_sym_if] = ACTIONS(3791),
    [anon_sym_switch] = ACTIONS(3791),
    [anon_sym_case] = ACTIONS(3791),
    [anon_sym_default] = ACTIONS(3791),
    [anon_sym_while] = ACTIONS(3791),
    [anon_sym_do] = ACTIONS(3791),
    [anon_sym_for] = ACTIONS(3791),
    [anon_sym_return] = ACTIONS(3791),
    [anon_sym_break] = ACTIONS(3791),
    [anon_sym_continue] = ACTIONS(3791),
    [anon_sym_goto] = ACTIONS(3791),
    [anon_sym___try] = ACTIONS(3791),
    [anon_sym___leave] = ACTIONS(3791),
    [anon_sym_not] = ACTIONS(3791),
    [anon_sym_compl] = ACTIONS(3791),
    [anon_sym_DASH_DASH] = ACTIONS(3793),
    [anon_sym_PLUS_PLUS] = ACTIONS(3793),
    [anon_sym_sizeof] = ACTIONS(3791),
    [anon_sym___alignof__] = ACTIONS(3791),
    [anon_sym___alignof] = ACTIONS(3791),
    [anon_sym__alignof] = ACTIONS(3791),
    [anon_sym_alignof] = ACTIONS(3791),
    [anon_sym__Alignof] = ACTIONS(3791),
    [anon_sym_offsetof] = ACTIONS(3791),
    [anon_sym__Generic] = ACTIONS(3791),
    [anon_sym_asm] = ACTIONS(3791),
    [anon_sym___asm__] = ACTIONS(3791),
    [anon_sym_DOT] = ACTIONS(3791),
    [sym_number_literal] = ACTIONS(3793),
    [anon_sym_L_SQUOTE] = ACTIONS(3793),
    [anon_sym_u_SQUOTE] = ACTIONS(3793),
    [anon_sym_U_SQUOTE] = ACTIONS(3793),
    [anon_sym_u8_SQUOTE] = ACTIONS(3793),
    [anon_sym_SQUOTE] = ACTIONS(3793),
    [anon_sym_L_DQUOTE] = ACTIONS(3793),
    [anon_sym_u_DQUOTE] = ACTIONS(3793),
    [anon_sym_U_DQUOTE] = ACTIONS(3793),
    [anon_sym_u8_DQUOTE] = ACTIONS(3793),
    [anon_sym_DQUOTE] = ACTIONS(3793),
    [sym_true] = ACTIONS(3791),
    [sym_false] = ACTIONS(3791),
    [anon_sym_NULL] = ACTIONS(3791),
    [anon_sym_nullptr] = ACTIONS(3791),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3791),
    [anon_sym_let] = ACTIONS(3791),
    [anon_sym_This] = ACTIONS(3791),
    [anon_sym_decltype] = ACTIONS(3791),
    [sym_virtual] = ACTIONS(3791),
    [anon_sym_explicit] = ACTIONS(3791),
    [anon_sym_typename] = ACTIONS(3791),
    [anon_sym_template] = ACTIONS(3791),
    [anon_sym_operator] = ACTIONS(3791),
    [anon_sym_try] = ACTIONS(3791),
    [anon_sym_delete] = ACTIONS(3791),
    [anon_sym_throw] = ACTIONS(3791),
    [anon_sym_namespace] = ACTIONS(3791),
    [anon_sym_using] = ACTIONS(3791),
    [anon_sym_static_assert] = ACTIONS(3791),
    [anon_sym_concept] = ACTIONS(3791),
    [anon_sym_co_return] = ACTIONS(3791),
    [anon_sym_co_yield] = ACTIONS(3791),
    [anon_sym_R_DQUOTE] = ACTIONS(3793),
    [anon_sym_LR_DQUOTE] = ACTIONS(3793),
    [anon_sym_uR_DQUOTE] = ACTIONS(3793),
    [anon_sym_UR_DQUOTE] = ACTIONS(3793),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3793),
    [anon_sym_co_await] = ACTIONS(3791),
    [anon_sym_new] = ACTIONS(3791),
    [anon_sym_requires] = ACTIONS(3791),
    [sym_this] = ACTIONS(3791),
    [anon_sym_discard] = ACTIONS(3791),
    [anon_sym_precise] = ACTIONS(3791),
    [anon_sym_shared] = ACTIONS(3791),
    [anon_sym_groupshared] = ACTIONS(3791),
    [anon_sym_uniform] = ACTIONS(3791),
    [anon_sym_row_major] = ACTIONS(3791),
    [anon_sym_column_major] = ACTIONS(3791),
    [anon_sym_globallycoherent] = ACTIONS(3791),
    [anon_sym_centroid] = ACTIONS(3791),
    [anon_sym_noperspective] = ACTIONS(3791),
    [anon_sym_nointerpolation] = ACTIONS(3791),
    [anon_sym_sample] = ACTIONS(3791),
    [anon_sym_linear] = ACTIONS(3791),
    [anon_sym_snorm] = ACTIONS(3791),
    [anon_sym_unorm] = ACTIONS(3791),
    [anon_sym_point] = ACTIONS(3791),
    [anon_sym_line] = ACTIONS(3791),
    [anon_sym_triangleadj] = ACTIONS(3791),
    [anon_sym_lineadj] = ACTIONS(3791),
    [anon_sym_triangle] = ACTIONS(3791),
    [anon_sym_cbuffer] = ACTIONS(3791),
    [anon_sym_interface] = ACTIONS(3791),
    [anon_sym_extension] = ACTIONS(3791),
  },
  [639] = {
    [sym_attribute_specifier] = STATE(658),
    [sym_identifier] = ACTIONS(3795),
    [aux_sym_preproc_include_token1] = ACTIONS(3795),
    [aux_sym_preproc_def_token1] = ACTIONS(3795),
    [aux_sym_preproc_if_token1] = ACTIONS(3795),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3795),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3795),
    [sym_preproc_directive] = ACTIONS(3795),
    [anon_sym_LPAREN2] = ACTIONS(3797),
    [anon_sym_BANG] = ACTIONS(3797),
    [anon_sym_TILDE] = ACTIONS(3797),
    [anon_sym_DASH] = ACTIONS(3795),
    [anon_sym_PLUS] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(3797),
    [anon_sym_AMP_AMP] = ACTIONS(3797),
    [anon_sym_AMP] = ACTIONS(3795),
    [anon_sym_SEMI] = ACTIONS(3797),
    [anon_sym___extension__] = ACTIONS(3795),
    [anon_sym_typedef] = ACTIONS(3795),
    [anon_sym_in] = ACTIONS(3795),
    [anon_sym_out] = ACTIONS(3795),
    [anon_sym_inout] = ACTIONS(3795),
    [anon_sym_extern] = ACTIONS(3795),
    [anon_sym___attribute__] = ACTIONS(2687),
    [anon_sym_COLON_COLON] = ACTIONS(3797),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3797),
    [anon_sym___declspec] = ACTIONS(3795),
    [anon_sym___based] = ACTIONS(3795),
    [anon_sym___cdecl] = ACTIONS(3795),
    [anon_sym___clrcall] = ACTIONS(3795),
    [anon_sym___stdcall] = ACTIONS(3795),
    [anon_sym___fastcall] = ACTIONS(3795),
    [anon_sym___thiscall] = ACTIONS(3795),
    [anon_sym___vectorcall] = ACTIONS(3795),
    [anon_sym_LBRACE] = ACTIONS(3797),
    [anon_sym_RBRACE] = ACTIONS(3797),
    [anon_sym_signed] = ACTIONS(3795),
    [anon_sym_unsigned] = ACTIONS(3795),
    [anon_sym_long] = ACTIONS(3795),
    [anon_sym_short] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3795),
    [anon_sym_static] = ACTIONS(3795),
    [anon_sym_register] = ACTIONS(3795),
    [anon_sym_inline] = ACTIONS(3795),
    [anon_sym___inline] = ACTIONS(3795),
    [anon_sym___inline__] = ACTIONS(3795),
    [anon_sym___forceinline] = ACTIONS(3795),
    [anon_sym_thread_local] = ACTIONS(3795),
    [anon_sym___thread] = ACTIONS(3795),
    [anon_sym_const] = ACTIONS(3795),
    [anon_sym_constexpr] = ACTIONS(3795),
    [anon_sym_volatile] = ACTIONS(3795),
    [anon_sym_restrict] = ACTIONS(3795),
    [anon_sym___restrict__] = ACTIONS(3795),
    [anon_sym__Atomic] = ACTIONS(3795),
    [anon_sym__Noreturn] = ACTIONS(3795),
    [anon_sym_noreturn] = ACTIONS(3795),
    [anon_sym_mutable] = ACTIONS(3795),
    [anon_sym_constinit] = ACTIONS(3795),
    [anon_sym_consteval] = ACTIONS(3795),
    [anon_sym_alignas] = ACTIONS(3795),
    [anon_sym__Alignas] = ACTIONS(3795),
    [sym_primitive_type] = ACTIONS(3795),
    [anon_sym_enum] = ACTIONS(3795),
    [anon_sym_class] = ACTIONS(3795),
    [anon_sym_struct] = ACTIONS(3795),
    [anon_sym_union] = ACTIONS(3795),
    [anon_sym_if] = ACTIONS(3795),
    [anon_sym_switch] = ACTIONS(3795),
    [anon_sym_case] = ACTIONS(3795),
    [anon_sym_default] = ACTIONS(3795),
    [anon_sym_while] = ACTIONS(3795),
    [anon_sym_do] = ACTIONS(3795),
    [anon_sym_for] = ACTIONS(3795),
    [anon_sym_return] = ACTIONS(3795),
    [anon_sym_break] = ACTIONS(3795),
    [anon_sym_continue] = ACTIONS(3795),
    [anon_sym_goto] = ACTIONS(3795),
    [anon_sym___try] = ACTIONS(3795),
    [anon_sym___leave] = ACTIONS(3795),
    [anon_sym_not] = ACTIONS(3795),
    [anon_sym_compl] = ACTIONS(3795),
    [anon_sym_DASH_DASH] = ACTIONS(3797),
    [anon_sym_PLUS_PLUS] = ACTIONS(3797),
    [anon_sym_sizeof] = ACTIONS(3795),
    [anon_sym___alignof__] = ACTIONS(3795),
    [anon_sym___alignof] = ACTIONS(3795),
    [anon_sym__alignof] = ACTIONS(3795),
    [anon_sym_alignof] = ACTIONS(3795),
    [anon_sym__Alignof] = ACTIONS(3795),
    [anon_sym_offsetof] = ACTIONS(3795),
    [anon_sym__Generic] = ACTIONS(3795),
    [anon_sym_asm] = ACTIONS(3795),
    [anon_sym___asm__] = ACTIONS(3795),
    [anon_sym_DOT] = ACTIONS(3795),
    [sym_number_literal] = ACTIONS(3797),
    [anon_sym_L_SQUOTE] = ACTIONS(3797),
    [anon_sym_u_SQUOTE] = ACTIONS(3797),
    [anon_sym_U_SQUOTE] = ACTIONS(3797),
    [anon_sym_u8_SQUOTE] = ACTIONS(3797),
    [anon_sym_SQUOTE] = ACTIONS(3797),
    [anon_sym_L_DQUOTE] = ACTIONS(3797),
    [anon_sym_u_DQUOTE] = ACTIONS(3797),
    [anon_sym_U_DQUOTE] = ACTIONS(3797),
    [anon_sym_u8_DQUOTE] = ACTIONS(3797),
    [anon_sym_DQUOTE] = ACTIONS(3797),
    [sym_true] = ACTIONS(3795),
    [sym_false] = ACTIONS(3795),
    [anon_sym_NULL] = ACTIONS(3795),
    [anon_sym_nullptr] = ACTIONS(3795),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3795),
    [anon_sym_let] = ACTIONS(3795),
    [anon_sym_This] = ACTIONS(3795),
    [anon_sym_decltype] = ACTIONS(3795),
    [sym_virtual] = ACTIONS(3795),
    [anon_sym_explicit] = ACTIONS(3795),
    [anon_sym_typename] = ACTIONS(3795),
    [anon_sym_template] = ACTIONS(3795),
    [anon_sym_operator] = ACTIONS(3795),
    [anon_sym_try] = ACTIONS(3795),
    [anon_sym_delete] = ACTIONS(3795),
    [anon_sym_throw] = ACTIONS(3795),
    [anon_sym_namespace] = ACTIONS(3795),
    [anon_sym_using] = ACTIONS(3795),
    [anon_sym_static_assert] = ACTIONS(3795),
    [anon_sym_concept] = ACTIONS(3795),
    [anon_sym_co_return] = ACTIONS(3795),
    [anon_sym_co_yield] = ACTIONS(3795),
    [anon_sym_R_DQUOTE] = ACTIONS(3797),
    [anon_sym_LR_DQUOTE] = ACTIONS(3797),
    [anon_sym_uR_DQUOTE] = ACTIONS(3797),
    [anon_sym_UR_DQUOTE] = ACTIONS(3797),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3797),
    [anon_sym_co_await] = ACTIONS(3795),
    [anon_sym_new] = ACTIONS(3795),
    [anon_sym_requires] = ACTIONS(3795),
    [sym_this] = ACTIONS(3795),
    [anon_sym_discard] = ACTIONS(3795),
    [anon_sym_precise] = ACTIONS(3795),
    [anon_sym_shared] = ACTIONS(3795),
    [anon_sym_groupshared] = ACTIONS(3795),
    [anon_sym_uniform] = ACTIONS(3795),
    [anon_sym_row_major] = ACTIONS(3795),
    [anon_sym_column_major] = ACTIONS(3795),
    [anon_sym_globallycoherent] = ACTIONS(3795),
    [anon_sym_centroid] = ACTIONS(3795),
    [anon_sym_noperspective] = ACTIONS(3795),
    [anon_sym_nointerpolation] = ACTIONS(3795),
    [anon_sym_sample] = ACTIONS(3795),
    [anon_sym_linear] = ACTIONS(3795),
    [anon_sym_snorm] = ACTIONS(3795),
    [anon_sym_unorm] = ACTIONS(3795),
    [anon_sym_point] = ACTIONS(3795),
    [anon_sym_line] = ACTIONS(3795),
    [anon_sym_triangleadj] = ACTIONS(3795),
    [anon_sym_lineadj] = ACTIONS(3795),
    [anon_sym_triangle] = ACTIONS(3795),
    [anon_sym_cbuffer] = ACTIONS(3795),
    [anon_sym_interface] = ACTIONS(3795),
    [anon_sym_extension] = ACTIONS(3795),
  },
  [640] = {
    [sym_attribute_specifier] = STATE(714),
    [sym_identifier] = ACTIONS(3799),
    [aux_sym_preproc_include_token1] = ACTIONS(3799),
    [aux_sym_preproc_def_token1] = ACTIONS(3799),
    [aux_sym_preproc_if_token1] = ACTIONS(3799),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3799),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3799),
    [sym_preproc_directive] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(3801),
    [anon_sym_BANG] = ACTIONS(3801),
    [anon_sym_TILDE] = ACTIONS(3801),
    [anon_sym_DASH] = ACTIONS(3799),
    [anon_sym_PLUS] = ACTIONS(3799),
    [anon_sym_STAR] = ACTIONS(3801),
    [anon_sym_AMP_AMP] = ACTIONS(3801),
    [anon_sym_AMP] = ACTIONS(3799),
    [anon_sym_SEMI] = ACTIONS(3801),
    [anon_sym___extension__] = ACTIONS(3799),
    [anon_sym_typedef] = ACTIONS(3799),
    [anon_sym_in] = ACTIONS(3799),
    [anon_sym_out] = ACTIONS(3799),
    [anon_sym_inout] = ACTIONS(3799),
    [anon_sym_extern] = ACTIONS(3799),
    [anon_sym___attribute__] = ACTIONS(2687),
    [anon_sym_COLON_COLON] = ACTIONS(3801),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3801),
    [anon_sym___declspec] = ACTIONS(3799),
    [anon_sym___based] = ACTIONS(3799),
    [anon_sym___cdecl] = ACTIONS(3799),
    [anon_sym___clrcall] = ACTIONS(3799),
    [anon_sym___stdcall] = ACTIONS(3799),
    [anon_sym___fastcall] = ACTIONS(3799),
    [anon_sym___thiscall] = ACTIONS(3799),
    [anon_sym___vectorcall] = ACTIONS(3799),
    [anon_sym_LBRACE] = ACTIONS(3801),
    [anon_sym_RBRACE] = ACTIONS(3801),
    [anon_sym_signed] = ACTIONS(3799),
    [anon_sym_unsigned] = ACTIONS(3799),
    [anon_sym_long] = ACTIONS(3799),
    [anon_sym_short] = ACTIONS(3799),
    [anon_sym_LBRACK] = ACTIONS(3799),
    [anon_sym_static] = ACTIONS(3799),
    [anon_sym_register] = ACTIONS(3799),
    [anon_sym_inline] = ACTIONS(3799),
    [anon_sym___inline] = ACTIONS(3799),
    [anon_sym___inline__] = ACTIONS(3799),
    [anon_sym___forceinline] = ACTIONS(3799),
    [anon_sym_thread_local] = ACTIONS(3799),
    [anon_sym___thread] = ACTIONS(3799),
    [anon_sym_const] = ACTIONS(3799),
    [anon_sym_constexpr] = ACTIONS(3799),
    [anon_sym_volatile] = ACTIONS(3799),
    [anon_sym_restrict] = ACTIONS(3799),
    [anon_sym___restrict__] = ACTIONS(3799),
    [anon_sym__Atomic] = ACTIONS(3799),
    [anon_sym__Noreturn] = ACTIONS(3799),
    [anon_sym_noreturn] = ACTIONS(3799),
    [anon_sym_mutable] = ACTIONS(3799),
    [anon_sym_constinit] = ACTIONS(3799),
    [anon_sym_consteval] = ACTIONS(3799),
    [anon_sym_alignas] = ACTIONS(3799),
    [anon_sym__Alignas] = ACTIONS(3799),
    [sym_primitive_type] = ACTIONS(3799),
    [anon_sym_enum] = ACTIONS(3799),
    [anon_sym_class] = ACTIONS(3799),
    [anon_sym_struct] = ACTIONS(3799),
    [anon_sym_union] = ACTIONS(3799),
    [anon_sym_if] = ACTIONS(3799),
    [anon_sym_switch] = ACTIONS(3799),
    [anon_sym_case] = ACTIONS(3799),
    [anon_sym_default] = ACTIONS(3799),
    [anon_sym_while] = ACTIONS(3799),
    [anon_sym_do] = ACTIONS(3799),
    [anon_sym_for] = ACTIONS(3799),
    [anon_sym_return] = ACTIONS(3799),
    [anon_sym_break] = ACTIONS(3799),
    [anon_sym_continue] = ACTIONS(3799),
    [anon_sym_goto] = ACTIONS(3799),
    [anon_sym___try] = ACTIONS(3799),
    [anon_sym___leave] = ACTIONS(3799),
    [anon_sym_not] = ACTIONS(3799),
    [anon_sym_compl] = ACTIONS(3799),
    [anon_sym_DASH_DASH] = ACTIONS(3801),
    [anon_sym_PLUS_PLUS] = ACTIONS(3801),
    [anon_sym_sizeof] = ACTIONS(3799),
    [anon_sym___alignof__] = ACTIONS(3799),
    [anon_sym___alignof] = ACTIONS(3799),
    [anon_sym__alignof] = ACTIONS(3799),
    [anon_sym_alignof] = ACTIONS(3799),
    [anon_sym__Alignof] = ACTIONS(3799),
    [anon_sym_offsetof] = ACTIONS(3799),
    [anon_sym__Generic] = ACTIONS(3799),
    [anon_sym_asm] = ACTIONS(3799),
    [anon_sym___asm__] = ACTIONS(3799),
    [anon_sym_DOT] = ACTIONS(3799),
    [sym_number_literal] = ACTIONS(3801),
    [anon_sym_L_SQUOTE] = ACTIONS(3801),
    [anon_sym_u_SQUOTE] = ACTIONS(3801),
    [anon_sym_U_SQUOTE] = ACTIONS(3801),
    [anon_sym_u8_SQUOTE] = ACTIONS(3801),
    [anon_sym_SQUOTE] = ACTIONS(3801),
    [anon_sym_L_DQUOTE] = ACTIONS(3801),
    [anon_sym_u_DQUOTE] = ACTIONS(3801),
    [anon_sym_U_DQUOTE] = ACTIONS(3801),
    [anon_sym_u8_DQUOTE] = ACTIONS(3801),
    [anon_sym_DQUOTE] = ACTIONS(3801),
    [sym_true] = ACTIONS(3799),
    [sym_false] = ACTIONS(3799),
    [anon_sym_NULL] = ACTIONS(3799),
    [anon_sym_nullptr] = ACTIONS(3799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3799),
    [anon_sym_let] = ACTIONS(3799),
    [anon_sym_This] = ACTIONS(3799),
    [anon_sym_decltype] = ACTIONS(3799),
    [sym_virtual] = ACTIONS(3799),
    [anon_sym_explicit] = ACTIONS(3799),
    [anon_sym_typename] = ACTIONS(3799),
    [anon_sym_template] = ACTIONS(3799),
    [anon_sym_operator] = ACTIONS(3799),
    [anon_sym_try] = ACTIONS(3799),
    [anon_sym_delete] = ACTIONS(3799),
    [anon_sym_throw] = ACTIONS(3799),
    [anon_sym_namespace] = ACTIONS(3799),
    [anon_sym_using] = ACTIONS(3799),
    [anon_sym_static_assert] = ACTIONS(3799),
    [anon_sym_concept] = ACTIONS(3799),
    [anon_sym_co_return] = ACTIONS(3799),
    [anon_sym_co_yield] = ACTIONS(3799),
    [anon_sym_R_DQUOTE] = ACTIONS(3801),
    [anon_sym_LR_DQUOTE] = ACTIONS(3801),
    [anon_sym_uR_DQUOTE] = ACTIONS(3801),
    [anon_sym_UR_DQUOTE] = ACTIONS(3801),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3801),
    [anon_sym_co_await] = ACTIONS(3799),
    [anon_sym_new] = ACTIONS(3799),
    [anon_sym_requires] = ACTIONS(3799),
    [sym_this] = ACTIONS(3799),
    [anon_sym_discard] = ACTIONS(3799),
    [anon_sym_precise] = ACTIONS(3799),
    [anon_sym_shared] = ACTIONS(3799),
    [anon_sym_groupshared] = ACTIONS(3799),
    [anon_sym_uniform] = ACTIONS(3799),
    [anon_sym_row_major] = ACTIONS(3799),
    [anon_sym_column_major] = ACTIONS(3799),
    [anon_sym_globallycoherent] = ACTIONS(3799),
    [anon_sym_centroid] = ACTIONS(3799),
    [anon_sym_noperspective] = ACTIONS(3799),
    [anon_sym_nointerpolation] = ACTIONS(3799),
    [anon_sym_sample] = ACTIONS(3799),
    [anon_sym_linear] = ACTIONS(3799),
    [anon_sym_snorm] = ACTIONS(3799),
    [anon_sym_unorm] = ACTIONS(3799),
    [anon_sym_point] = ACTIONS(3799),
    [anon_sym_line] = ACTIONS(3799),
    [anon_sym_triangleadj] = ACTIONS(3799),
    [anon_sym_lineadj] = ACTIONS(3799),
    [anon_sym_triangle] = ACTIONS(3799),
    [anon_sym_cbuffer] = ACTIONS(3799),
    [anon_sym_interface] = ACTIONS(3799),
    [anon_sym_extension] = ACTIONS(3799),
  },
  [641] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(637),
    [sym_identifier] = ACTIONS(3803),
    [aux_sym_preproc_include_token1] = ACTIONS(3803),
    [aux_sym_preproc_def_token1] = ACTIONS(3803),
    [aux_sym_preproc_if_token1] = ACTIONS(3803),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3803),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3803),
    [sym_preproc_directive] = ACTIONS(3803),
    [anon_sym_LPAREN2] = ACTIONS(3805),
    [anon_sym_BANG] = ACTIONS(3805),
    [anon_sym_TILDE] = ACTIONS(3805),
    [anon_sym_DASH] = ACTIONS(3803),
    [anon_sym_PLUS] = ACTIONS(3803),
    [anon_sym_STAR] = ACTIONS(3805),
    [anon_sym_AMP_AMP] = ACTIONS(3805),
    [anon_sym_AMP] = ACTIONS(3803),
    [anon_sym_SEMI] = ACTIONS(3805),
    [anon_sym___extension__] = ACTIONS(3803),
    [anon_sym_typedef] = ACTIONS(3803),
    [anon_sym_in] = ACTIONS(3803),
    [anon_sym_out] = ACTIONS(3803),
    [anon_sym_inout] = ACTIONS(3803),
    [anon_sym_extern] = ACTIONS(3803),
    [anon_sym___attribute__] = ACTIONS(3803),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3805),
    [anon_sym___declspec] = ACTIONS(3803),
    [anon_sym___based] = ACTIONS(3803),
    [anon_sym___cdecl] = ACTIONS(3803),
    [anon_sym___clrcall] = ACTIONS(3803),
    [anon_sym___stdcall] = ACTIONS(3803),
    [anon_sym___fastcall] = ACTIONS(3803),
    [anon_sym___thiscall] = ACTIONS(3803),
    [anon_sym___vectorcall] = ACTIONS(3803),
    [anon_sym_LBRACE] = ACTIONS(3805),
    [anon_sym_RBRACE] = ACTIONS(3805),
    [anon_sym_signed] = ACTIONS(3807),
    [anon_sym_unsigned] = ACTIONS(3807),
    [anon_sym_long] = ACTIONS(3807),
    [anon_sym_short] = ACTIONS(3807),
    [anon_sym_LBRACK] = ACTIONS(3803),
    [anon_sym_static] = ACTIONS(3803),
    [anon_sym_register] = ACTIONS(3803),
    [anon_sym_inline] = ACTIONS(3803),
    [anon_sym___inline] = ACTIONS(3803),
    [anon_sym___inline__] = ACTIONS(3803),
    [anon_sym___forceinline] = ACTIONS(3803),
    [anon_sym_thread_local] = ACTIONS(3803),
    [anon_sym___thread] = ACTIONS(3803),
    [anon_sym_const] = ACTIONS(3803),
    [anon_sym_constexpr] = ACTIONS(3803),
    [anon_sym_volatile] = ACTIONS(3803),
    [anon_sym_restrict] = ACTIONS(3803),
    [anon_sym___restrict__] = ACTIONS(3803),
    [anon_sym__Atomic] = ACTIONS(3803),
    [anon_sym__Noreturn] = ACTIONS(3803),
    [anon_sym_noreturn] = ACTIONS(3803),
    [anon_sym_mutable] = ACTIONS(3803),
    [anon_sym_constinit] = ACTIONS(3803),
    [anon_sym_consteval] = ACTIONS(3803),
    [anon_sym_alignas] = ACTIONS(3803),
    [anon_sym__Alignas] = ACTIONS(3803),
    [sym_primitive_type] = ACTIONS(3803),
    [anon_sym_enum] = ACTIONS(3803),
    [anon_sym_class] = ACTIONS(3803),
    [anon_sym_struct] = ACTIONS(3803),
    [anon_sym_union] = ACTIONS(3803),
    [anon_sym_if] = ACTIONS(3803),
    [anon_sym_switch] = ACTIONS(3803),
    [anon_sym_case] = ACTIONS(3803),
    [anon_sym_default] = ACTIONS(3803),
    [anon_sym_while] = ACTIONS(3803),
    [anon_sym_do] = ACTIONS(3803),
    [anon_sym_for] = ACTIONS(3803),
    [anon_sym_return] = ACTIONS(3803),
    [anon_sym_break] = ACTIONS(3803),
    [anon_sym_continue] = ACTIONS(3803),
    [anon_sym_goto] = ACTIONS(3803),
    [anon_sym___try] = ACTIONS(3803),
    [anon_sym___leave] = ACTIONS(3803),
    [anon_sym_not] = ACTIONS(3803),
    [anon_sym_compl] = ACTIONS(3803),
    [anon_sym_DASH_DASH] = ACTIONS(3805),
    [anon_sym_PLUS_PLUS] = ACTIONS(3805),
    [anon_sym_sizeof] = ACTIONS(3803),
    [anon_sym___alignof__] = ACTIONS(3803),
    [anon_sym___alignof] = ACTIONS(3803),
    [anon_sym__alignof] = ACTIONS(3803),
    [anon_sym_alignof] = ACTIONS(3803),
    [anon_sym__Alignof] = ACTIONS(3803),
    [anon_sym_offsetof] = ACTIONS(3803),
    [anon_sym__Generic] = ACTIONS(3803),
    [anon_sym_asm] = ACTIONS(3803),
    [anon_sym___asm__] = ACTIONS(3803),
    [anon_sym_DOT] = ACTIONS(3803),
    [sym_number_literal] = ACTIONS(3805),
    [anon_sym_L_SQUOTE] = ACTIONS(3805),
    [anon_sym_u_SQUOTE] = ACTIONS(3805),
    [anon_sym_U_SQUOTE] = ACTIONS(3805),
    [anon_sym_u8_SQUOTE] = ACTIONS(3805),
    [anon_sym_SQUOTE] = ACTIONS(3805),
    [anon_sym_L_DQUOTE] = ACTIONS(3805),
    [anon_sym_u_DQUOTE] = ACTIONS(3805),
    [anon_sym_U_DQUOTE] = ACTIONS(3805),
    [anon_sym_u8_DQUOTE] = ACTIONS(3805),
    [anon_sym_DQUOTE] = ACTIONS(3805),
    [sym_true] = ACTIONS(3803),
    [sym_false] = ACTIONS(3803),
    [anon_sym_NULL] = ACTIONS(3803),
    [anon_sym_nullptr] = ACTIONS(3803),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3803),
    [anon_sym_let] = ACTIONS(3803),
    [anon_sym_This] = ACTIONS(3803),
    [anon_sym_decltype] = ACTIONS(3803),
    [sym_virtual] = ACTIONS(3803),
    [anon_sym_explicit] = ACTIONS(3803),
    [anon_sym_typename] = ACTIONS(3803),
    [anon_sym_template] = ACTIONS(3803),
    [anon_sym_operator] = ACTIONS(3803),
    [anon_sym_try] = ACTIONS(3803),
    [anon_sym_delete] = ACTIONS(3803),
    [anon_sym_throw] = ACTIONS(3803),
    [anon_sym_namespace] = ACTIONS(3803),
    [anon_sym_using] = ACTIONS(3803),
    [anon_sym_static_assert] = ACTIONS(3803),
    [anon_sym_concept] = ACTIONS(3803),
    [anon_sym_co_return] = ACTIONS(3803),
    [anon_sym_co_yield] = ACTIONS(3803),
    [anon_sym_R_DQUOTE] = ACTIONS(3805),
    [anon_sym_LR_DQUOTE] = ACTIONS(3805),
    [anon_sym_uR_DQUOTE] = ACTIONS(3805),
    [anon_sym_UR_DQUOTE] = ACTIONS(3805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3805),
    [anon_sym_co_await] = ACTIONS(3803),
    [anon_sym_new] = ACTIONS(3803),
    [anon_sym_requires] = ACTIONS(3803),
    [sym_this] = ACTIONS(3803),
    [anon_sym_discard] = ACTIONS(3803),
    [anon_sym_precise] = ACTIONS(3803),
    [anon_sym_shared] = ACTIONS(3803),
    [anon_sym_groupshared] = ACTIONS(3803),
    [anon_sym_uniform] = ACTIONS(3803),
    [anon_sym_row_major] = ACTIONS(3803),
    [anon_sym_column_major] = ACTIONS(3803),
    [anon_sym_globallycoherent] = ACTIONS(3803),
    [anon_sym_centroid] = ACTIONS(3803),
    [anon_sym_noperspective] = ACTIONS(3803),
    [anon_sym_nointerpolation] = ACTIONS(3803),
    [anon_sym_sample] = ACTIONS(3803),
    [anon_sym_linear] = ACTIONS(3803),
    [anon_sym_snorm] = ACTIONS(3803),
    [anon_sym_unorm] = ACTIONS(3803),
    [anon_sym_point] = ACTIONS(3803),
    [anon_sym_line] = ACTIONS(3803),
    [anon_sym_triangleadj] = ACTIONS(3803),
    [anon_sym_lineadj] = ACTIONS(3803),
    [anon_sym_triangle] = ACTIONS(3803),
    [anon_sym_cbuffer] = ACTIONS(3803),
    [anon_sym_interface] = ACTIONS(3803),
    [anon_sym_extension] = ACTIONS(3803),
  },
  [642] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(629),
    [sym_identifier] = ACTIONS(3392),
    [aux_sym_preproc_include_token1] = ACTIONS(3392),
    [aux_sym_preproc_def_token1] = ACTIONS(3392),
    [aux_sym_preproc_if_token1] = ACTIONS(3392),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3392),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3392),
    [sym_preproc_directive] = ACTIONS(3392),
    [anon_sym_LPAREN2] = ACTIONS(3390),
    [anon_sym_BANG] = ACTIONS(3390),
    [anon_sym_TILDE] = ACTIONS(3390),
    [anon_sym_DASH] = ACTIONS(3392),
    [anon_sym_PLUS] = ACTIONS(3392),
    [anon_sym_STAR] = ACTIONS(3390),
    [anon_sym_AMP_AMP] = ACTIONS(3390),
    [anon_sym_AMP] = ACTIONS(3392),
    [anon_sym_SEMI] = ACTIONS(3390),
    [anon_sym___extension__] = ACTIONS(3392),
    [anon_sym_typedef] = ACTIONS(3392),
    [anon_sym_in] = ACTIONS(3392),
    [anon_sym_out] = ACTIONS(3392),
    [anon_sym_inout] = ACTIONS(3392),
    [anon_sym_extern] = ACTIONS(3392),
    [anon_sym___attribute__] = ACTIONS(3392),
    [anon_sym_COLON_COLON] = ACTIONS(3390),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3390),
    [anon_sym___declspec] = ACTIONS(3392),
    [anon_sym___based] = ACTIONS(3392),
    [anon_sym___cdecl] = ACTIONS(3392),
    [anon_sym___clrcall] = ACTIONS(3392),
    [anon_sym___stdcall] = ACTIONS(3392),
    [anon_sym___fastcall] = ACTIONS(3392),
    [anon_sym___thiscall] = ACTIONS(3392),
    [anon_sym___vectorcall] = ACTIONS(3392),
    [anon_sym_LBRACE] = ACTIONS(3390),
    [anon_sym_RBRACE] = ACTIONS(3390),
    [anon_sym_signed] = ACTIONS(3392),
    [anon_sym_unsigned] = ACTIONS(3392),
    [anon_sym_long] = ACTIONS(3392),
    [anon_sym_short] = ACTIONS(3392),
    [anon_sym_LBRACK] = ACTIONS(3392),
    [anon_sym_static] = ACTIONS(3392),
    [anon_sym_register] = ACTIONS(3392),
    [anon_sym_inline] = ACTIONS(3392),
    [anon_sym___inline] = ACTIONS(3392),
    [anon_sym___inline__] = ACTIONS(3392),
    [anon_sym___forceinline] = ACTIONS(3392),
    [anon_sym_thread_local] = ACTIONS(3392),
    [anon_sym___thread] = ACTIONS(3392),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_constexpr] = ACTIONS(3392),
    [anon_sym_volatile] = ACTIONS(3392),
    [anon_sym_restrict] = ACTIONS(3392),
    [anon_sym___restrict__] = ACTIONS(3392),
    [anon_sym__Atomic] = ACTIONS(3392),
    [anon_sym__Noreturn] = ACTIONS(3392),
    [anon_sym_noreturn] = ACTIONS(3392),
    [anon_sym_mutable] = ACTIONS(3392),
    [anon_sym_constinit] = ACTIONS(3392),
    [anon_sym_consteval] = ACTIONS(3392),
    [anon_sym_alignas] = ACTIONS(3392),
    [anon_sym__Alignas] = ACTIONS(3392),
    [sym_primitive_type] = ACTIONS(3392),
    [anon_sym_enum] = ACTIONS(3392),
    [anon_sym_class] = ACTIONS(3392),
    [anon_sym_struct] = ACTIONS(3392),
    [anon_sym_union] = ACTIONS(3392),
    [anon_sym_if] = ACTIONS(3392),
    [anon_sym_switch] = ACTIONS(3392),
    [anon_sym_case] = ACTIONS(3392),
    [anon_sym_default] = ACTIONS(3392),
    [anon_sym_while] = ACTIONS(3392),
    [anon_sym_do] = ACTIONS(3392),
    [anon_sym_for] = ACTIONS(3392),
    [anon_sym_return] = ACTIONS(3392),
    [anon_sym_break] = ACTIONS(3392),
    [anon_sym_continue] = ACTIONS(3392),
    [anon_sym_goto] = ACTIONS(3392),
    [anon_sym___try] = ACTIONS(3392),
    [anon_sym___leave] = ACTIONS(3392),
    [anon_sym_not] = ACTIONS(3392),
    [anon_sym_compl] = ACTIONS(3392),
    [anon_sym_DASH_DASH] = ACTIONS(3390),
    [anon_sym_PLUS_PLUS] = ACTIONS(3390),
    [anon_sym_sizeof] = ACTIONS(3392),
    [anon_sym___alignof__] = ACTIONS(3392),
    [anon_sym___alignof] = ACTIONS(3392),
    [anon_sym__alignof] = ACTIONS(3392),
    [anon_sym_alignof] = ACTIONS(3392),
    [anon_sym__Alignof] = ACTIONS(3392),
    [anon_sym_offsetof] = ACTIONS(3392),
    [anon_sym__Generic] = ACTIONS(3392),
    [anon_sym_asm] = ACTIONS(3392),
    [anon_sym___asm__] = ACTIONS(3392),
    [anon_sym_DOT] = ACTIONS(3392),
    [sym_number_literal] = ACTIONS(3390),
    [anon_sym_L_SQUOTE] = ACTIONS(3390),
    [anon_sym_u_SQUOTE] = ACTIONS(3390),
    [anon_sym_U_SQUOTE] = ACTIONS(3390),
    [anon_sym_u8_SQUOTE] = ACTIONS(3390),
    [anon_sym_SQUOTE] = ACTIONS(3390),
    [anon_sym_L_DQUOTE] = ACTIONS(3390),
    [anon_sym_u_DQUOTE] = ACTIONS(3390),
    [anon_sym_U_DQUOTE] = ACTIONS(3390),
    [anon_sym_u8_DQUOTE] = ACTIONS(3390),
    [anon_sym_DQUOTE] = ACTIONS(3390),
    [sym_true] = ACTIONS(3392),
    [sym_false] = ACTIONS(3392),
    [anon_sym_NULL] = ACTIONS(3392),
    [anon_sym_nullptr] = ACTIONS(3392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3392),
    [anon_sym_let] = ACTIONS(3392),
    [anon_sym_This] = ACTIONS(3392),
    [anon_sym_decltype] = ACTIONS(3392),
    [sym_virtual] = ACTIONS(3392),
    [anon_sym_explicit] = ACTIONS(3392),
    [anon_sym_typename] = ACTIONS(3392),
    [anon_sym_template] = ACTIONS(3392),
    [anon_sym_operator] = ACTIONS(3392),
    [anon_sym_try] = ACTIONS(3392),
    [anon_sym_delete] = ACTIONS(3392),
    [anon_sym_throw] = ACTIONS(3392),
    [anon_sym_namespace] = ACTIONS(3392),
    [anon_sym_using] = ACTIONS(3392),
    [anon_sym_static_assert] = ACTIONS(3392),
    [anon_sym_concept] = ACTIONS(3392),
    [anon_sym_co_return] = ACTIONS(3392),
    [anon_sym_co_yield] = ACTIONS(3392),
    [anon_sym_R_DQUOTE] = ACTIONS(3390),
    [anon_sym_LR_DQUOTE] = ACTIONS(3390),
    [anon_sym_uR_DQUOTE] = ACTIONS(3390),
    [anon_sym_UR_DQUOTE] = ACTIONS(3390),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3390),
    [anon_sym_co_await] = ACTIONS(3392),
    [anon_sym_new] = ACTIONS(3392),
    [anon_sym_requires] = ACTIONS(3392),
    [sym_this] = ACTIONS(3392),
    [anon_sym_discard] = ACTIONS(3392),
    [anon_sym_precise] = ACTIONS(3392),
    [anon_sym_shared] = ACTIONS(3392),
    [anon_sym_groupshared] = ACTIONS(3392),
    [anon_sym_uniform] = ACTIONS(3392),
    [anon_sym_row_major] = ACTIONS(3392),
    [anon_sym_column_major] = ACTIONS(3392),
    [anon_sym_globallycoherent] = ACTIONS(3392),
    [anon_sym_centroid] = ACTIONS(3392),
    [anon_sym_noperspective] = ACTIONS(3392),
    [anon_sym_nointerpolation] = ACTIONS(3392),
    [anon_sym_sample] = ACTIONS(3392),
    [anon_sym_linear] = ACTIONS(3392),
    [anon_sym_snorm] = ACTIONS(3392),
    [anon_sym_unorm] = ACTIONS(3392),
    [anon_sym_point] = ACTIONS(3392),
    [anon_sym_line] = ACTIONS(3392),
    [anon_sym_triangleadj] = ACTIONS(3392),
    [anon_sym_lineadj] = ACTIONS(3392),
    [anon_sym_triangle] = ACTIONS(3392),
    [anon_sym_cbuffer] = ACTIONS(3392),
    [anon_sym_interface] = ACTIONS(3392),
    [anon_sym_extension] = ACTIONS(3392),
  },
  [643] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(637),
    [sym_identifier] = ACTIONS(3810),
    [aux_sym_preproc_include_token1] = ACTIONS(3810),
    [aux_sym_preproc_def_token1] = ACTIONS(3810),
    [aux_sym_preproc_if_token1] = ACTIONS(3810),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3810),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3810),
    [sym_preproc_directive] = ACTIONS(3810),
    [anon_sym_LPAREN2] = ACTIONS(3812),
    [anon_sym_BANG] = ACTIONS(3812),
    [anon_sym_TILDE] = ACTIONS(3812),
    [anon_sym_DASH] = ACTIONS(3810),
    [anon_sym_PLUS] = ACTIONS(3810),
    [anon_sym_STAR] = ACTIONS(3812),
    [anon_sym_AMP_AMP] = ACTIONS(3812),
    [anon_sym_AMP] = ACTIONS(3810),
    [anon_sym_SEMI] = ACTIONS(3812),
    [anon_sym___extension__] = ACTIONS(3810),
    [anon_sym_typedef] = ACTIONS(3810),
    [anon_sym_in] = ACTIONS(3810),
    [anon_sym_out] = ACTIONS(3810),
    [anon_sym_inout] = ACTIONS(3810),
    [anon_sym_extern] = ACTIONS(3810),
    [anon_sym___attribute__] = ACTIONS(3810),
    [anon_sym_COLON_COLON] = ACTIONS(3812),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3812),
    [anon_sym___declspec] = ACTIONS(3810),
    [anon_sym___based] = ACTIONS(3810),
    [anon_sym___cdecl] = ACTIONS(3810),
    [anon_sym___clrcall] = ACTIONS(3810),
    [anon_sym___stdcall] = ACTIONS(3810),
    [anon_sym___fastcall] = ACTIONS(3810),
    [anon_sym___thiscall] = ACTIONS(3810),
    [anon_sym___vectorcall] = ACTIONS(3810),
    [anon_sym_LBRACE] = ACTIONS(3812),
    [anon_sym_RBRACE] = ACTIONS(3812),
    [anon_sym_signed] = ACTIONS(3814),
    [anon_sym_unsigned] = ACTIONS(3814),
    [anon_sym_long] = ACTIONS(3814),
    [anon_sym_short] = ACTIONS(3814),
    [anon_sym_LBRACK] = ACTIONS(3810),
    [anon_sym_static] = ACTIONS(3810),
    [anon_sym_register] = ACTIONS(3810),
    [anon_sym_inline] = ACTIONS(3810),
    [anon_sym___inline] = ACTIONS(3810),
    [anon_sym___inline__] = ACTIONS(3810),
    [anon_sym___forceinline] = ACTIONS(3810),
    [anon_sym_thread_local] = ACTIONS(3810),
    [anon_sym___thread] = ACTIONS(3810),
    [anon_sym_const] = ACTIONS(3810),
    [anon_sym_constexpr] = ACTIONS(3810),
    [anon_sym_volatile] = ACTIONS(3810),
    [anon_sym_restrict] = ACTIONS(3810),
    [anon_sym___restrict__] = ACTIONS(3810),
    [anon_sym__Atomic] = ACTIONS(3810),
    [anon_sym__Noreturn] = ACTIONS(3810),
    [anon_sym_noreturn] = ACTIONS(3810),
    [anon_sym_mutable] = ACTIONS(3810),
    [anon_sym_constinit] = ACTIONS(3810),
    [anon_sym_consteval] = ACTIONS(3810),
    [anon_sym_alignas] = ACTIONS(3810),
    [anon_sym__Alignas] = ACTIONS(3810),
    [sym_primitive_type] = ACTIONS(3810),
    [anon_sym_enum] = ACTIONS(3810),
    [anon_sym_class] = ACTIONS(3810),
    [anon_sym_struct] = ACTIONS(3810),
    [anon_sym_union] = ACTIONS(3810),
    [anon_sym_if] = ACTIONS(3810),
    [anon_sym_switch] = ACTIONS(3810),
    [anon_sym_case] = ACTIONS(3810),
    [anon_sym_default] = ACTIONS(3810),
    [anon_sym_while] = ACTIONS(3810),
    [anon_sym_do] = ACTIONS(3810),
    [anon_sym_for] = ACTIONS(3810),
    [anon_sym_return] = ACTIONS(3810),
    [anon_sym_break] = ACTIONS(3810),
    [anon_sym_continue] = ACTIONS(3810),
    [anon_sym_goto] = ACTIONS(3810),
    [anon_sym___try] = ACTIONS(3810),
    [anon_sym___leave] = ACTIONS(3810),
    [anon_sym_not] = ACTIONS(3810),
    [anon_sym_compl] = ACTIONS(3810),
    [anon_sym_DASH_DASH] = ACTIONS(3812),
    [anon_sym_PLUS_PLUS] = ACTIONS(3812),
    [anon_sym_sizeof] = ACTIONS(3810),
    [anon_sym___alignof__] = ACTIONS(3810),
    [anon_sym___alignof] = ACTIONS(3810),
    [anon_sym__alignof] = ACTIONS(3810),
    [anon_sym_alignof] = ACTIONS(3810),
    [anon_sym__Alignof] = ACTIONS(3810),
    [anon_sym_offsetof] = ACTIONS(3810),
    [anon_sym__Generic] = ACTIONS(3810),
    [anon_sym_asm] = ACTIONS(3810),
    [anon_sym___asm__] = ACTIONS(3810),
    [anon_sym_DOT] = ACTIONS(3810),
    [sym_number_literal] = ACTIONS(3812),
    [anon_sym_L_SQUOTE] = ACTIONS(3812),
    [anon_sym_u_SQUOTE] = ACTIONS(3812),
    [anon_sym_U_SQUOTE] = ACTIONS(3812),
    [anon_sym_u8_SQUOTE] = ACTIONS(3812),
    [anon_sym_SQUOTE] = ACTIONS(3812),
    [anon_sym_L_DQUOTE] = ACTIONS(3812),
    [anon_sym_u_DQUOTE] = ACTIONS(3812),
    [anon_sym_U_DQUOTE] = ACTIONS(3812),
    [anon_sym_u8_DQUOTE] = ACTIONS(3812),
    [anon_sym_DQUOTE] = ACTIONS(3812),
    [sym_true] = ACTIONS(3810),
    [sym_false] = ACTIONS(3810),
    [anon_sym_NULL] = ACTIONS(3810),
    [anon_sym_nullptr] = ACTIONS(3810),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3810),
    [anon_sym_let] = ACTIONS(3810),
    [anon_sym_This] = ACTIONS(3810),
    [anon_sym_decltype] = ACTIONS(3810),
    [sym_virtual] = ACTIONS(3810),
    [anon_sym_explicit] = ACTIONS(3810),
    [anon_sym_typename] = ACTIONS(3810),
    [anon_sym_template] = ACTIONS(3810),
    [anon_sym_operator] = ACTIONS(3810),
    [anon_sym_try] = ACTIONS(3810),
    [anon_sym_delete] = ACTIONS(3810),
    [anon_sym_throw] = ACTIONS(3810),
    [anon_sym_namespace] = ACTIONS(3810),
    [anon_sym_using] = ACTIONS(3810),
    [anon_sym_static_assert] = ACTIONS(3810),
    [anon_sym_concept] = ACTIONS(3810),
    [anon_sym_co_return] = ACTIONS(3810),
    [anon_sym_co_yield] = ACTIONS(3810),
    [anon_sym_R_DQUOTE] = ACTIONS(3812),
    [anon_sym_LR_DQUOTE] = ACTIONS(3812),
    [anon_sym_uR_DQUOTE] = ACTIONS(3812),
    [anon_sym_UR_DQUOTE] = ACTIONS(3812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3812),
    [anon_sym_co_await] = ACTIONS(3810),
    [anon_sym_new] = ACTIONS(3810),
    [anon_sym_requires] = ACTIONS(3810),
    [sym_this] = ACTIONS(3810),
    [anon_sym_discard] = ACTIONS(3810),
    [anon_sym_precise] = ACTIONS(3810),
    [anon_sym_shared] = ACTIONS(3810),
    [anon_sym_groupshared] = ACTIONS(3810),
    [anon_sym_uniform] = ACTIONS(3810),
    [anon_sym_row_major] = ACTIONS(3810),
    [anon_sym_column_major] = ACTIONS(3810),
    [anon_sym_globallycoherent] = ACTIONS(3810),
    [anon_sym_centroid] = ACTIONS(3810),
    [anon_sym_noperspective] = ACTIONS(3810),
    [anon_sym_nointerpolation] = ACTIONS(3810),
    [anon_sym_sample] = ACTIONS(3810),
    [anon_sym_linear] = ACTIONS(3810),
    [anon_sym_snorm] = ACTIONS(3810),
    [anon_sym_unorm] = ACTIONS(3810),
    [anon_sym_point] = ACTIONS(3810),
    [anon_sym_line] = ACTIONS(3810),
    [anon_sym_triangleadj] = ACTIONS(3810),
    [anon_sym_lineadj] = ACTIONS(3810),
    [anon_sym_triangle] = ACTIONS(3810),
    [anon_sym_cbuffer] = ACTIONS(3810),
    [anon_sym_interface] = ACTIONS(3810),
    [anon_sym_extension] = ACTIONS(3810),
  },
  [644] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(635),
    [sym_identifier] = ACTIONS(3817),
    [aux_sym_preproc_include_token1] = ACTIONS(3820),
    [aux_sym_preproc_def_token1] = ACTIONS(3820),
    [aux_sym_preproc_if_token1] = ACTIONS(3820),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3820),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3820),
    [sym_preproc_directive] = ACTIONS(3820),
    [anon_sym_LPAREN2] = ACTIONS(3822),
    [anon_sym_BANG] = ACTIONS(3822),
    [anon_sym_TILDE] = ACTIONS(3822),
    [anon_sym_DASH] = ACTIONS(3820),
    [anon_sym_PLUS] = ACTIONS(3820),
    [anon_sym_STAR] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3822),
    [anon_sym_AMP] = ACTIONS(3820),
    [anon_sym_SEMI] = ACTIONS(3822),
    [anon_sym___extension__] = ACTIONS(3820),
    [anon_sym_typedef] = ACTIONS(3820),
    [anon_sym_in] = ACTIONS(3820),
    [anon_sym_out] = ACTIONS(3820),
    [anon_sym_inout] = ACTIONS(3820),
    [anon_sym_extern] = ACTIONS(3820),
    [anon_sym___attribute__] = ACTIONS(3820),
    [anon_sym_COLON_COLON] = ACTIONS(3822),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3822),
    [anon_sym___declspec] = ACTIONS(3820),
    [anon_sym___based] = ACTIONS(3820),
    [anon_sym___cdecl] = ACTIONS(3820),
    [anon_sym___clrcall] = ACTIONS(3820),
    [anon_sym___stdcall] = ACTIONS(3820),
    [anon_sym___fastcall] = ACTIONS(3820),
    [anon_sym___thiscall] = ACTIONS(3820),
    [anon_sym___vectorcall] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3822),
    [anon_sym_RBRACE] = ACTIONS(3822),
    [anon_sym_signed] = ACTIONS(3824),
    [anon_sym_unsigned] = ACTIONS(3824),
    [anon_sym_long] = ACTIONS(3824),
    [anon_sym_short] = ACTIONS(3824),
    [anon_sym_LBRACK] = ACTIONS(3820),
    [anon_sym_static] = ACTIONS(3820),
    [anon_sym_register] = ACTIONS(3820),
    [anon_sym_inline] = ACTIONS(3820),
    [anon_sym___inline] = ACTIONS(3820),
    [anon_sym___inline__] = ACTIONS(3820),
    [anon_sym___forceinline] = ACTIONS(3820),
    [anon_sym_thread_local] = ACTIONS(3820),
    [anon_sym___thread] = ACTIONS(3820),
    [anon_sym_const] = ACTIONS(3820),
    [anon_sym_constexpr] = ACTIONS(3820),
    [anon_sym_volatile] = ACTIONS(3820),
    [anon_sym_restrict] = ACTIONS(3820),
    [anon_sym___restrict__] = ACTIONS(3820),
    [anon_sym__Atomic] = ACTIONS(3820),
    [anon_sym__Noreturn] = ACTIONS(3820),
    [anon_sym_noreturn] = ACTIONS(3820),
    [anon_sym_mutable] = ACTIONS(3820),
    [anon_sym_constinit] = ACTIONS(3820),
    [anon_sym_consteval] = ACTIONS(3820),
    [anon_sym_alignas] = ACTIONS(3820),
    [anon_sym__Alignas] = ACTIONS(3820),
    [sym_primitive_type] = ACTIONS(3827),
    [anon_sym_enum] = ACTIONS(3820),
    [anon_sym_class] = ACTIONS(3820),
    [anon_sym_struct] = ACTIONS(3820),
    [anon_sym_union] = ACTIONS(3820),
    [anon_sym_if] = ACTIONS(3820),
    [anon_sym_switch] = ACTIONS(3820),
    [anon_sym_case] = ACTIONS(3820),
    [anon_sym_default] = ACTIONS(3820),
    [anon_sym_while] = ACTIONS(3820),
    [anon_sym_do] = ACTIONS(3820),
    [anon_sym_for] = ACTIONS(3820),
    [anon_sym_return] = ACTIONS(3820),
    [anon_sym_break] = ACTIONS(3820),
    [anon_sym_continue] = ACTIONS(3820),
    [anon_sym_goto] = ACTIONS(3820),
    [anon_sym___try] = ACTIONS(3820),
    [anon_sym___leave] = ACTIONS(3820),
    [anon_sym_not] = ACTIONS(3820),
    [anon_sym_compl] = ACTIONS(3820),
    [anon_sym_DASH_DASH] = ACTIONS(3822),
    [anon_sym_PLUS_PLUS] = ACTIONS(3822),
    [anon_sym_sizeof] = ACTIONS(3820),
    [anon_sym___alignof__] = ACTIONS(3820),
    [anon_sym___alignof] = ACTIONS(3820),
    [anon_sym__alignof] = ACTIONS(3820),
    [anon_sym_alignof] = ACTIONS(3820),
    [anon_sym__Alignof] = ACTIONS(3820),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3820),
    [anon_sym_asm] = ACTIONS(3820),
    [anon_sym___asm__] = ACTIONS(3820),
    [anon_sym_DOT] = ACTIONS(3820),
    [sym_number_literal] = ACTIONS(3822),
    [anon_sym_L_SQUOTE] = ACTIONS(3822),
    [anon_sym_u_SQUOTE] = ACTIONS(3822),
    [anon_sym_U_SQUOTE] = ACTIONS(3822),
    [anon_sym_u8_SQUOTE] = ACTIONS(3822),
    [anon_sym_SQUOTE] = ACTIONS(3822),
    [anon_sym_L_DQUOTE] = ACTIONS(3822),
    [anon_sym_u_DQUOTE] = ACTIONS(3822),
    [anon_sym_U_DQUOTE] = ACTIONS(3822),
    [anon_sym_u8_DQUOTE] = ACTIONS(3822),
    [anon_sym_DQUOTE] = ACTIONS(3822),
    [sym_true] = ACTIONS(3820),
    [sym_false] = ACTIONS(3820),
    [anon_sym_NULL] = ACTIONS(3820),
    [anon_sym_nullptr] = ACTIONS(3820),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3820),
    [anon_sym_let] = ACTIONS(3820),
    [anon_sym_This] = ACTIONS(3820),
    [anon_sym_decltype] = ACTIONS(3820),
    [sym_virtual] = ACTIONS(3820),
    [anon_sym_explicit] = ACTIONS(3820),
    [anon_sym_typename] = ACTIONS(3820),
    [anon_sym_template] = ACTIONS(3820),
    [anon_sym_operator] = ACTIONS(3820),
    [anon_sym_try] = ACTIONS(3820),
    [anon_sym_delete] = ACTIONS(3820),
    [anon_sym_throw] = ACTIONS(3820),
    [anon_sym_namespace] = ACTIONS(3820),
    [anon_sym_using] = ACTIONS(3820),
    [anon_sym_static_assert] = ACTIONS(3820),
    [anon_sym_concept] = ACTIONS(3820),
    [anon_sym_co_return] = ACTIONS(3820),
    [anon_sym_co_yield] = ACTIONS(3820),
    [anon_sym_R_DQUOTE] = ACTIONS(3822),
    [anon_sym_LR_DQUOTE] = ACTIONS(3822),
    [anon_sym_uR_DQUOTE] = ACTIONS(3822),
    [anon_sym_UR_DQUOTE] = ACTIONS(3822),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3822),
    [anon_sym_co_await] = ACTIONS(3820),
    [anon_sym_new] = ACTIONS(3820),
    [anon_sym_requires] = ACTIONS(3820),
    [sym_this] = ACTIONS(3820),
    [anon_sym_discard] = ACTIONS(3820),
    [anon_sym_precise] = ACTIONS(3820),
    [anon_sym_shared] = ACTIONS(3820),
    [anon_sym_groupshared] = ACTIONS(3820),
    [anon_sym_uniform] = ACTIONS(3820),
    [anon_sym_row_major] = ACTIONS(3820),
    [anon_sym_column_major] = ACTIONS(3820),
    [anon_sym_globallycoherent] = ACTIONS(3820),
    [anon_sym_centroid] = ACTIONS(3820),
    [anon_sym_noperspective] = ACTIONS(3820),
    [anon_sym_nointerpolation] = ACTIONS(3820),
    [anon_sym_sample] = ACTIONS(3820),
    [anon_sym_linear] = ACTIONS(3820),
    [anon_sym_snorm] = ACTIONS(3820),
    [anon_sym_unorm] = ACTIONS(3820),
    [anon_sym_point] = ACTIONS(3820),
    [anon_sym_line] = ACTIONS(3820),
    [anon_sym_triangleadj] = ACTIONS(3820),
    [anon_sym_lineadj] = ACTIONS(3820),
    [anon_sym_triangle] = ACTIONS(3820),
    [anon_sym_cbuffer] = ACTIONS(3820),
    [anon_sym_interface] = ACTIONS(3820),
    [anon_sym_extension] = ACTIONS(3820),
  },
  [645] = {
    [sym_else_clause] = STATE(694),
    [sym_identifier] = ACTIONS(2850),
    [aux_sym_preproc_include_token1] = ACTIONS(2850),
    [aux_sym_preproc_def_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token2] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2850),
    [sym_preproc_directive] = ACTIONS(2850),
    [anon_sym_LPAREN2] = ACTIONS(2852),
    [anon_sym_BANG] = ACTIONS(2852),
    [anon_sym_TILDE] = ACTIONS(2852),
    [anon_sym_DASH] = ACTIONS(2850),
    [anon_sym_PLUS] = ACTIONS(2850),
    [anon_sym_STAR] = ACTIONS(2852),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_AMP] = ACTIONS(2850),
    [anon_sym_SEMI] = ACTIONS(2852),
    [anon_sym___extension__] = ACTIONS(2850),
    [anon_sym_typedef] = ACTIONS(2850),
    [anon_sym_in] = ACTIONS(2850),
    [anon_sym_out] = ACTIONS(2850),
    [anon_sym_inout] = ACTIONS(2850),
    [anon_sym_extern] = ACTIONS(2850),
    [anon_sym___attribute__] = ACTIONS(2850),
    [anon_sym_COLON_COLON] = ACTIONS(2852),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2852),
    [anon_sym___declspec] = ACTIONS(2850),
    [anon_sym___based] = ACTIONS(2850),
    [anon_sym___cdecl] = ACTIONS(2850),
    [anon_sym___clrcall] = ACTIONS(2850),
    [anon_sym___stdcall] = ACTIONS(2850),
    [anon_sym___fastcall] = ACTIONS(2850),
    [anon_sym___thiscall] = ACTIONS(2850),
    [anon_sym___vectorcall] = ACTIONS(2850),
    [anon_sym_LBRACE] = ACTIONS(2852),
    [anon_sym_signed] = ACTIONS(2850),
    [anon_sym_unsigned] = ACTIONS(2850),
    [anon_sym_long] = ACTIONS(2850),
    [anon_sym_short] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2850),
    [anon_sym_static] = ACTIONS(2850),
    [anon_sym_register] = ACTIONS(2850),
    [anon_sym_inline] = ACTIONS(2850),
    [anon_sym___inline] = ACTIONS(2850),
    [anon_sym___inline__] = ACTIONS(2850),
    [anon_sym___forceinline] = ACTIONS(2850),
    [anon_sym_thread_local] = ACTIONS(2850),
    [anon_sym___thread] = ACTIONS(2850),
    [anon_sym_const] = ACTIONS(2850),
    [anon_sym_constexpr] = ACTIONS(2850),
    [anon_sym_volatile] = ACTIONS(2850),
    [anon_sym_restrict] = ACTIONS(2850),
    [anon_sym___restrict__] = ACTIONS(2850),
    [anon_sym__Atomic] = ACTIONS(2850),
    [anon_sym__Noreturn] = ACTIONS(2850),
    [anon_sym_noreturn] = ACTIONS(2850),
    [anon_sym_mutable] = ACTIONS(2850),
    [anon_sym_constinit] = ACTIONS(2850),
    [anon_sym_consteval] = ACTIONS(2850),
    [anon_sym_alignas] = ACTIONS(2850),
    [anon_sym__Alignas] = ACTIONS(2850),
    [sym_primitive_type] = ACTIONS(2850),
    [anon_sym_enum] = ACTIONS(2850),
    [anon_sym_class] = ACTIONS(2850),
    [anon_sym_struct] = ACTIONS(2850),
    [anon_sym_union] = ACTIONS(2850),
    [anon_sym_if] = ACTIONS(2850),
    [anon_sym_else] = ACTIONS(3729),
    [anon_sym_switch] = ACTIONS(2850),
    [anon_sym_case] = ACTIONS(2850),
    [anon_sym_default] = ACTIONS(2850),
    [anon_sym_while] = ACTIONS(2850),
    [anon_sym_do] = ACTIONS(2850),
    [anon_sym_for] = ACTIONS(2850),
    [anon_sym_return] = ACTIONS(2850),
    [anon_sym_break] = ACTIONS(2850),
    [anon_sym_continue] = ACTIONS(2850),
    [anon_sym_goto] = ACTIONS(2850),
    [anon_sym___try] = ACTIONS(2850),
    [anon_sym___leave] = ACTIONS(2850),
    [anon_sym_not] = ACTIONS(2850),
    [anon_sym_compl] = ACTIONS(2850),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_sizeof] = ACTIONS(2850),
    [anon_sym___alignof__] = ACTIONS(2850),
    [anon_sym___alignof] = ACTIONS(2850),
    [anon_sym__alignof] = ACTIONS(2850),
    [anon_sym_alignof] = ACTIONS(2850),
    [anon_sym__Alignof] = ACTIONS(2850),
    [anon_sym_offsetof] = ACTIONS(2850),
    [anon_sym__Generic] = ACTIONS(2850),
    [anon_sym_asm] = ACTIONS(2850),
    [anon_sym___asm__] = ACTIONS(2850),
    [sym_number_literal] = ACTIONS(2852),
    [anon_sym_L_SQUOTE] = ACTIONS(2852),
    [anon_sym_u_SQUOTE] = ACTIONS(2852),
    [anon_sym_U_SQUOTE] = ACTIONS(2852),
    [anon_sym_u8_SQUOTE] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2852),
    [anon_sym_L_DQUOTE] = ACTIONS(2852),
    [anon_sym_u_DQUOTE] = ACTIONS(2852),
    [anon_sym_U_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8_DQUOTE] = ACTIONS(2852),
    [anon_sym_DQUOTE] = ACTIONS(2852),
    [sym_true] = ACTIONS(2850),
    [sym_false] = ACTIONS(2850),
    [anon_sym_NULL] = ACTIONS(2850),
    [anon_sym_nullptr] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2850),
    [anon_sym_let] = ACTIONS(2850),
    [anon_sym_This] = ACTIONS(2850),
    [anon_sym_decltype] = ACTIONS(2850),
    [sym_virtual] = ACTIONS(2850),
    [anon_sym_explicit] = ACTIONS(2850),
    [anon_sym_typename] = ACTIONS(2850),
    [anon_sym_template] = ACTIONS(2850),
    [anon_sym_operator] = ACTIONS(2850),
    [anon_sym_try] = ACTIONS(2850),
    [anon_sym_delete] = ACTIONS(2850),
    [anon_sym_throw] = ACTIONS(2850),
    [anon_sym_namespace] = ACTIONS(2850),
    [anon_sym_using] = ACTIONS(2850),
    [anon_sym_static_assert] = ACTIONS(2850),
    [anon_sym_concept] = ACTIONS(2850),
    [anon_sym_co_return] = ACTIONS(2850),
    [anon_sym_co_yield] = ACTIONS(2850),
    [anon_sym_R_DQUOTE] = ACTIONS(2852),
    [anon_sym_LR_DQUOTE] = ACTIONS(2852),
    [anon_sym_uR_DQUOTE] = ACTIONS(2852),
    [anon_sym_UR_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2852),
    [anon_sym_co_await] = ACTIONS(2850),
    [anon_sym_new] = ACTIONS(2850),
    [anon_sym_requires] = ACTIONS(2850),
    [sym_this] = ACTIONS(2850),
    [anon_sym_discard] = ACTIONS(2850),
    [anon_sym_precise] = ACTIONS(2850),
    [anon_sym_shared] = ACTIONS(2850),
    [anon_sym_groupshared] = ACTIONS(2850),
    [anon_sym_uniform] = ACTIONS(2850),
    [anon_sym_row_major] = ACTIONS(2850),
    [anon_sym_column_major] = ACTIONS(2850),
    [anon_sym_globallycoherent] = ACTIONS(2850),
    [anon_sym_centroid] = ACTIONS(2850),
    [anon_sym_noperspective] = ACTIONS(2850),
    [anon_sym_nointerpolation] = ACTIONS(2850),
    [anon_sym_sample] = ACTIONS(2850),
    [anon_sym_linear] = ACTIONS(2850),
    [anon_sym_snorm] = ACTIONS(2850),
    [anon_sym_unorm] = ACTIONS(2850),
    [anon_sym_point] = ACTIONS(2850),
    [anon_sym_line] = ACTIONS(2850),
    [anon_sym_triangleadj] = ACTIONS(2850),
    [anon_sym_lineadj] = ACTIONS(2850),
    [anon_sym_triangle] = ACTIONS(2850),
    [anon_sym_cbuffer] = ACTIONS(2850),
    [anon_sym_interface] = ACTIONS(2850),
    [anon_sym_extension] = ACTIONS(2850),
  },
  [646] = {
    [sym_template_argument_list] = STATE(212),
    [aux_sym_sized_type_specifier_repeat1] = STATE(874),
    [ts_builtin_sym_end] = ACTIONS(2123),
    [sym_identifier] = ACTIONS(2115),
    [aux_sym_preproc_include_token1] = ACTIONS(2115),
    [aux_sym_preproc_def_token1] = ACTIONS(2115),
    [aux_sym_preproc_if_token1] = ACTIONS(2115),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2115),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2115),
    [sym_preproc_directive] = ACTIONS(2115),
    [anon_sym_LPAREN2] = ACTIONS(2123),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_AMP_AMP] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2115),
    [anon_sym_LT] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym___extension__] = ACTIONS(2115),
    [anon_sym_typedef] = ACTIONS(2115),
    [anon_sym_in] = ACTIONS(2115),
    [anon_sym_out] = ACTIONS(2115),
    [anon_sym_inout] = ACTIONS(2115),
    [anon_sym_extern] = ACTIONS(2115),
    [anon_sym___attribute__] = ACTIONS(2115),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2123),
    [anon_sym___declspec] = ACTIONS(2115),
    [anon_sym___based] = ACTIONS(2115),
    [anon_sym___cdecl] = ACTIONS(2115),
    [anon_sym___clrcall] = ACTIONS(2115),
    [anon_sym___stdcall] = ACTIONS(2115),
    [anon_sym___fastcall] = ACTIONS(2115),
    [anon_sym___thiscall] = ACTIONS(2115),
    [anon_sym___vectorcall] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_signed] = ACTIONS(2167),
    [anon_sym_unsigned] = ACTIONS(2167),
    [anon_sym_long] = ACTIONS(2167),
    [anon_sym_short] = ACTIONS(2167),
    [anon_sym_LBRACK] = ACTIONS(2115),
    [anon_sym_static] = ACTIONS(2115),
    [anon_sym_register] = ACTIONS(2115),
    [anon_sym_inline] = ACTIONS(2115),
    [anon_sym___inline] = ACTIONS(2115),
    [anon_sym___inline__] = ACTIONS(2115),
    [anon_sym___forceinline] = ACTIONS(2115),
    [anon_sym_thread_local] = ACTIONS(2115),
    [anon_sym___thread] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(2115),
    [anon_sym_constexpr] = ACTIONS(2115),
    [anon_sym_volatile] = ACTIONS(2115),
    [anon_sym_restrict] = ACTIONS(2115),
    [anon_sym___restrict__] = ACTIONS(2115),
    [anon_sym__Atomic] = ACTIONS(2115),
    [anon_sym__Noreturn] = ACTIONS(2115),
    [anon_sym_noreturn] = ACTIONS(2115),
    [anon_sym_mutable] = ACTIONS(2115),
    [anon_sym_constinit] = ACTIONS(2115),
    [anon_sym_consteval] = ACTIONS(2115),
    [anon_sym_alignas] = ACTIONS(2115),
    [anon_sym__Alignas] = ACTIONS(2115),
    [sym_primitive_type] = ACTIONS(2115),
    [anon_sym_enum] = ACTIONS(2115),
    [anon_sym_class] = ACTIONS(2115),
    [anon_sym_struct] = ACTIONS(2115),
    [anon_sym_union] = ACTIONS(2115),
    [anon_sym_if] = ACTIONS(2115),
    [anon_sym_switch] = ACTIONS(2115),
    [anon_sym_case] = ACTIONS(2115),
    [anon_sym_default] = ACTIONS(2115),
    [anon_sym_while] = ACTIONS(2115),
    [anon_sym_do] = ACTIONS(2115),
    [anon_sym_for] = ACTIONS(2115),
    [anon_sym_return] = ACTIONS(2115),
    [anon_sym_break] = ACTIONS(2115),
    [anon_sym_continue] = ACTIONS(2115),
    [anon_sym_goto] = ACTIONS(2115),
    [anon_sym_not] = ACTIONS(2115),
    [anon_sym_compl] = ACTIONS(2115),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_sizeof] = ACTIONS(2115),
    [anon_sym___alignof__] = ACTIONS(2115),
    [anon_sym___alignof] = ACTIONS(2115),
    [anon_sym__alignof] = ACTIONS(2115),
    [anon_sym_alignof] = ACTIONS(2115),
    [anon_sym__Alignof] = ACTIONS(2115),
    [anon_sym_offsetof] = ACTIONS(2115),
    [anon_sym__Generic] = ACTIONS(2115),
    [anon_sym_asm] = ACTIONS(2115),
    [anon_sym___asm__] = ACTIONS(2115),
    [anon_sym_DOT] = ACTIONS(2115),
    [sym_number_literal] = ACTIONS(2123),
    [anon_sym_L_SQUOTE] = ACTIONS(2123),
    [anon_sym_u_SQUOTE] = ACTIONS(2123),
    [anon_sym_U_SQUOTE] = ACTIONS(2123),
    [anon_sym_u8_SQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_L_DQUOTE] = ACTIONS(2123),
    [anon_sym_u_DQUOTE] = ACTIONS(2123),
    [anon_sym_U_DQUOTE] = ACTIONS(2123),
    [anon_sym_u8_DQUOTE] = ACTIONS(2123),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [sym_true] = ACTIONS(2115),
    [sym_false] = ACTIONS(2115),
    [anon_sym_NULL] = ACTIONS(2115),
    [anon_sym_nullptr] = ACTIONS(2115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2115),
    [anon_sym_let] = ACTIONS(2115),
    [anon_sym_This] = ACTIONS(2115),
    [anon_sym_decltype] = ACTIONS(2115),
    [sym_virtual] = ACTIONS(2115),
    [anon_sym_explicit] = ACTIONS(2115),
    [anon_sym_typename] = ACTIONS(2115),
    [anon_sym_template] = ACTIONS(2115),
    [anon_sym_operator] = ACTIONS(2115),
    [anon_sym_try] = ACTIONS(2115),
    [anon_sym_delete] = ACTIONS(2115),
    [anon_sym_throw] = ACTIONS(2115),
    [anon_sym_namespace] = ACTIONS(2115),
    [anon_sym_using] = ACTIONS(2115),
    [anon_sym_static_assert] = ACTIONS(2115),
    [anon_sym_concept] = ACTIONS(2115),
    [anon_sym_co_return] = ACTIONS(2115),
    [anon_sym_co_yield] = ACTIONS(2115),
    [anon_sym_R_DQUOTE] = ACTIONS(2123),
    [anon_sym_LR_DQUOTE] = ACTIONS(2123),
    [anon_sym_uR_DQUOTE] = ACTIONS(2123),
    [anon_sym_UR_DQUOTE] = ACTIONS(2123),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2123),
    [anon_sym_co_await] = ACTIONS(2115),
    [anon_sym_new] = ACTIONS(2115),
    [anon_sym_requires] = ACTIONS(2115),
    [sym_this] = ACTIONS(2115),
    [anon_sym_precise] = ACTIONS(2115),
    [anon_sym_shared] = ACTIONS(2115),
    [anon_sym_groupshared] = ACTIONS(2115),
    [anon_sym_uniform] = ACTIONS(2115),
    [anon_sym_row_major] = ACTIONS(2115),
    [anon_sym_column_major] = ACTIONS(2115),
    [anon_sym_globallycoherent] = ACTIONS(2115),
    [anon_sym_centroid] = ACTIONS(2115),
    [anon_sym_noperspective] = ACTIONS(2115),
    [anon_sym_nointerpolation] = ACTIONS(2115),
    [anon_sym_sample] = ACTIONS(2115),
    [anon_sym_linear] = ACTIONS(2115),
    [anon_sym_snorm] = ACTIONS(2115),
    [anon_sym_unorm] = ACTIONS(2115),
    [anon_sym_point] = ACTIONS(2115),
    [anon_sym_line] = ACTIONS(2115),
    [anon_sym_triangleadj] = ACTIONS(2115),
    [anon_sym_lineadj] = ACTIONS(2115),
    [anon_sym_triangle] = ACTIONS(2115),
    [anon_sym_interface] = ACTIONS(2115),
    [anon_sym_extension] = ACTIONS(2115),
    [anon_sym___exported] = ACTIONS(2115),
    [anon_sym_import] = ACTIONS(2115),
  },
  [647] = {
    [sym_attribute_specifier] = STATE(664),
    [sym_identifier] = ACTIONS(3830),
    [aux_sym_preproc_include_token1] = ACTIONS(3830),
    [aux_sym_preproc_def_token1] = ACTIONS(3830),
    [aux_sym_preproc_if_token1] = ACTIONS(3830),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3830),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3830),
    [sym_preproc_directive] = ACTIONS(3830),
    [anon_sym_LPAREN2] = ACTIONS(3832),
    [anon_sym_BANG] = ACTIONS(3832),
    [anon_sym_TILDE] = ACTIONS(3832),
    [anon_sym_DASH] = ACTIONS(3830),
    [anon_sym_PLUS] = ACTIONS(3830),
    [anon_sym_STAR] = ACTIONS(3832),
    [anon_sym_AMP_AMP] = ACTIONS(3832),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_SEMI] = ACTIONS(3832),
    [anon_sym___extension__] = ACTIONS(3830),
    [anon_sym_typedef] = ACTIONS(3830),
    [anon_sym_in] = ACTIONS(3830),
    [anon_sym_out] = ACTIONS(3830),
    [anon_sym_inout] = ACTIONS(3830),
    [anon_sym_extern] = ACTIONS(3830),
    [anon_sym___attribute__] = ACTIONS(2687),
    [anon_sym_COLON_COLON] = ACTIONS(3832),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3832),
    [anon_sym___declspec] = ACTIONS(3830),
    [anon_sym___based] = ACTIONS(3830),
    [anon_sym___cdecl] = ACTIONS(3830),
    [anon_sym___clrcall] = ACTIONS(3830),
    [anon_sym___stdcall] = ACTIONS(3830),
    [anon_sym___fastcall] = ACTIONS(3830),
    [anon_sym___thiscall] = ACTIONS(3830),
    [anon_sym___vectorcall] = ACTIONS(3830),
    [anon_sym_LBRACE] = ACTIONS(3832),
    [anon_sym_RBRACE] = ACTIONS(3832),
    [anon_sym_signed] = ACTIONS(3830),
    [anon_sym_unsigned] = ACTIONS(3830),
    [anon_sym_long] = ACTIONS(3830),
    [anon_sym_short] = ACTIONS(3830),
    [anon_sym_LBRACK] = ACTIONS(3830),
    [anon_sym_static] = ACTIONS(3830),
    [anon_sym_register] = ACTIONS(3830),
    [anon_sym_inline] = ACTIONS(3830),
    [anon_sym___inline] = ACTIONS(3830),
    [anon_sym___inline__] = ACTIONS(3830),
    [anon_sym___forceinline] = ACTIONS(3830),
    [anon_sym_thread_local] = ACTIONS(3830),
    [anon_sym___thread] = ACTIONS(3830),
    [anon_sym_const] = ACTIONS(3830),
    [anon_sym_constexpr] = ACTIONS(3830),
    [anon_sym_volatile] = ACTIONS(3830),
    [anon_sym_restrict] = ACTIONS(3830),
    [anon_sym___restrict__] = ACTIONS(3830),
    [anon_sym__Atomic] = ACTIONS(3830),
    [anon_sym__Noreturn] = ACTIONS(3830),
    [anon_sym_noreturn] = ACTIONS(3830),
    [anon_sym_mutable] = ACTIONS(3830),
    [anon_sym_constinit] = ACTIONS(3830),
    [anon_sym_consteval] = ACTIONS(3830),
    [anon_sym_alignas] = ACTIONS(3830),
    [anon_sym__Alignas] = ACTIONS(3830),
    [sym_primitive_type] = ACTIONS(3830),
    [anon_sym_enum] = ACTIONS(3830),
    [anon_sym_class] = ACTIONS(3830),
    [anon_sym_struct] = ACTIONS(3830),
    [anon_sym_union] = ACTIONS(3830),
    [anon_sym_if] = ACTIONS(3830),
    [anon_sym_switch] = ACTIONS(3830),
    [anon_sym_case] = ACTIONS(3830),
    [anon_sym_default] = ACTIONS(3830),
    [anon_sym_while] = ACTIONS(3830),
    [anon_sym_do] = ACTIONS(3830),
    [anon_sym_for] = ACTIONS(3830),
    [anon_sym_return] = ACTIONS(3830),
    [anon_sym_break] = ACTIONS(3830),
    [anon_sym_continue] = ACTIONS(3830),
    [anon_sym_goto] = ACTIONS(3830),
    [anon_sym___try] = ACTIONS(3830),
    [anon_sym___leave] = ACTIONS(3830),
    [anon_sym_not] = ACTIONS(3830),
    [anon_sym_compl] = ACTIONS(3830),
    [anon_sym_DASH_DASH] = ACTIONS(3832),
    [anon_sym_PLUS_PLUS] = ACTIONS(3832),
    [anon_sym_sizeof] = ACTIONS(3830),
    [anon_sym___alignof__] = ACTIONS(3830),
    [anon_sym___alignof] = ACTIONS(3830),
    [anon_sym__alignof] = ACTIONS(3830),
    [anon_sym_alignof] = ACTIONS(3830),
    [anon_sym__Alignof] = ACTIONS(3830),
    [anon_sym_offsetof] = ACTIONS(3830),
    [anon_sym__Generic] = ACTIONS(3830),
    [anon_sym_asm] = ACTIONS(3830),
    [anon_sym___asm__] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3830),
    [sym_number_literal] = ACTIONS(3832),
    [anon_sym_L_SQUOTE] = ACTIONS(3832),
    [anon_sym_u_SQUOTE] = ACTIONS(3832),
    [anon_sym_U_SQUOTE] = ACTIONS(3832),
    [anon_sym_u8_SQUOTE] = ACTIONS(3832),
    [anon_sym_SQUOTE] = ACTIONS(3832),
    [anon_sym_L_DQUOTE] = ACTIONS(3832),
    [anon_sym_u_DQUOTE] = ACTIONS(3832),
    [anon_sym_U_DQUOTE] = ACTIONS(3832),
    [anon_sym_u8_DQUOTE] = ACTIONS(3832),
    [anon_sym_DQUOTE] = ACTIONS(3832),
    [sym_true] = ACTIONS(3830),
    [sym_false] = ACTIONS(3830),
    [anon_sym_NULL] = ACTIONS(3830),
    [anon_sym_nullptr] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3830),
    [anon_sym_let] = ACTIONS(3830),
    [anon_sym_This] = ACTIONS(3830),
    [anon_sym_decltype] = ACTIONS(3830),
    [sym_virtual] = ACTIONS(3830),
    [anon_sym_explicit] = ACTIONS(3830),
    [anon_sym_typename] = ACTIONS(3830),
    [anon_sym_template] = ACTIONS(3830),
    [anon_sym_operator] = ACTIONS(3830),
    [anon_sym_try] = ACTIONS(3830),
    [anon_sym_delete] = ACTIONS(3830),
    [anon_sym_throw] = ACTIONS(3830),
    [anon_sym_namespace] = ACTIONS(3830),
    [anon_sym_using] = ACTIONS(3830),
    [anon_sym_static_assert] = ACTIONS(3830),
    [anon_sym_concept] = ACTIONS(3830),
    [anon_sym_co_return] = ACTIONS(3830),
    [anon_sym_co_yield] = ACTIONS(3830),
    [anon_sym_R_DQUOTE] = ACTIONS(3832),
    [anon_sym_LR_DQUOTE] = ACTIONS(3832),
    [anon_sym_uR_DQUOTE] = ACTIONS(3832),
    [anon_sym_UR_DQUOTE] = ACTIONS(3832),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3832),
    [anon_sym_co_await] = ACTIONS(3830),
    [anon_sym_new] = ACTIONS(3830),
    [anon_sym_requires] = ACTIONS(3830),
    [sym_this] = ACTIONS(3830),
    [anon_sym_discard] = ACTIONS(3830),
    [anon_sym_precise] = ACTIONS(3830),
    [anon_sym_shared] = ACTIONS(3830),
    [anon_sym_groupshared] = ACTIONS(3830),
    [anon_sym_uniform] = ACTIONS(3830),
    [anon_sym_row_major] = ACTIONS(3830),
    [anon_sym_column_major] = ACTIONS(3830),
    [anon_sym_globallycoherent] = ACTIONS(3830),
    [anon_sym_centroid] = ACTIONS(3830),
    [anon_sym_noperspective] = ACTIONS(3830),
    [anon_sym_nointerpolation] = ACTIONS(3830),
    [anon_sym_sample] = ACTIONS(3830),
    [anon_sym_linear] = ACTIONS(3830),
    [anon_sym_snorm] = ACTIONS(3830),
    [anon_sym_unorm] = ACTIONS(3830),
    [anon_sym_point] = ACTIONS(3830),
    [anon_sym_line] = ACTIONS(3830),
    [anon_sym_triangleadj] = ACTIONS(3830),
    [anon_sym_lineadj] = ACTIONS(3830),
    [anon_sym_triangle] = ACTIONS(3830),
    [anon_sym_cbuffer] = ACTIONS(3830),
    [anon_sym_interface] = ACTIONS(3830),
    [anon_sym_extension] = ACTIONS(3830),
  },
  [648] = {
    [sym_template_argument_list] = STATE(2816),
    [aux_sym_sized_type_specifier_repeat1] = STATE(874),
    [ts_builtin_sym_end] = ACTIONS(3485),
    [sym_identifier] = ACTIONS(3483),
    [aux_sym_preproc_include_token1] = ACTIONS(3483),
    [aux_sym_preproc_def_token1] = ACTIONS(3483),
    [aux_sym_preproc_if_token1] = ACTIONS(3483),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3483),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3483),
    [sym_preproc_directive] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_BANG] = ACTIONS(3485),
    [anon_sym_TILDE] = ACTIONS(3485),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_STAR] = ACTIONS(3485),
    [anon_sym_AMP_AMP] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_LT] = ACTIONS(3487),
    [anon_sym_SEMI] = ACTIONS(3485),
    [anon_sym___extension__] = ACTIONS(3483),
    [anon_sym_typedef] = ACTIONS(3483),
    [anon_sym_in] = ACTIONS(3483),
    [anon_sym_out] = ACTIONS(3483),
    [anon_sym_inout] = ACTIONS(3483),
    [anon_sym_extern] = ACTIONS(3483),
    [anon_sym___attribute__] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3485),
    [anon_sym___declspec] = ACTIONS(3483),
    [anon_sym___based] = ACTIONS(3483),
    [anon_sym___cdecl] = ACTIONS(3483),
    [anon_sym___clrcall] = ACTIONS(3483),
    [anon_sym___stdcall] = ACTIONS(3483),
    [anon_sym___fastcall] = ACTIONS(3483),
    [anon_sym___thiscall] = ACTIONS(3483),
    [anon_sym___vectorcall] = ACTIONS(3483),
    [anon_sym_LBRACE] = ACTIONS(3485),
    [anon_sym_signed] = ACTIONS(3483),
    [anon_sym_unsigned] = ACTIONS(3483),
    [anon_sym_long] = ACTIONS(3483),
    [anon_sym_short] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_static] = ACTIONS(3483),
    [anon_sym_register] = ACTIONS(3483),
    [anon_sym_inline] = ACTIONS(3483),
    [anon_sym___inline] = ACTIONS(3483),
    [anon_sym___inline__] = ACTIONS(3483),
    [anon_sym___forceinline] = ACTIONS(3483),
    [anon_sym_thread_local] = ACTIONS(3483),
    [anon_sym___thread] = ACTIONS(3483),
    [anon_sym_const] = ACTIONS(3483),
    [anon_sym_constexpr] = ACTIONS(3483),
    [anon_sym_volatile] = ACTIONS(3483),
    [anon_sym_restrict] = ACTIONS(3483),
    [anon_sym___restrict__] = ACTIONS(3483),
    [anon_sym__Atomic] = ACTIONS(3483),
    [anon_sym__Noreturn] = ACTIONS(3483),
    [anon_sym_noreturn] = ACTIONS(3483),
    [anon_sym_mutable] = ACTIONS(3483),
    [anon_sym_constinit] = ACTIONS(3483),
    [anon_sym_consteval] = ACTIONS(3483),
    [anon_sym_alignas] = ACTIONS(3483),
    [anon_sym__Alignas] = ACTIONS(3483),
    [sym_primitive_type] = ACTIONS(3483),
    [anon_sym_enum] = ACTIONS(3483),
    [anon_sym_class] = ACTIONS(3483),
    [anon_sym_struct] = ACTIONS(3483),
    [anon_sym_union] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_switch] = ACTIONS(3483),
    [anon_sym_case] = ACTIONS(3483),
    [anon_sym_default] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_break] = ACTIONS(3483),
    [anon_sym_continue] = ACTIONS(3483),
    [anon_sym_goto] = ACTIONS(3483),
    [anon_sym_not] = ACTIONS(3483),
    [anon_sym_compl] = ACTIONS(3483),
    [anon_sym_DASH_DASH] = ACTIONS(3485),
    [anon_sym_PLUS_PLUS] = ACTIONS(3485),
    [anon_sym_sizeof] = ACTIONS(3483),
    [anon_sym___alignof__] = ACTIONS(3483),
    [anon_sym___alignof] = ACTIONS(3483),
    [anon_sym__alignof] = ACTIONS(3483),
    [anon_sym_alignof] = ACTIONS(3483),
    [anon_sym__Alignof] = ACTIONS(3483),
    [anon_sym_offsetof] = ACTIONS(3483),
    [anon_sym__Generic] = ACTIONS(3483),
    [anon_sym_asm] = ACTIONS(3483),
    [anon_sym___asm__] = ACTIONS(3483),
    [anon_sym_DOT] = ACTIONS(3483),
    [sym_number_literal] = ACTIONS(3485),
    [anon_sym_L_SQUOTE] = ACTIONS(3485),
    [anon_sym_u_SQUOTE] = ACTIONS(3485),
    [anon_sym_U_SQUOTE] = ACTIONS(3485),
    [anon_sym_u8_SQUOTE] = ACTIONS(3485),
    [anon_sym_SQUOTE] = ACTIONS(3485),
    [anon_sym_L_DQUOTE] = ACTIONS(3485),
    [anon_sym_u_DQUOTE] = ACTIONS(3485),
    [anon_sym_U_DQUOTE] = ACTIONS(3485),
    [anon_sym_u8_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE] = ACTIONS(3485),
    [sym_true] = ACTIONS(3483),
    [sym_false] = ACTIONS(3483),
    [anon_sym_NULL] = ACTIONS(3483),
    [anon_sym_nullptr] = ACTIONS(3483),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_This] = ACTIONS(3483),
    [anon_sym_decltype] = ACTIONS(3483),
    [sym_virtual] = ACTIONS(3483),
    [anon_sym_explicit] = ACTIONS(3483),
    [anon_sym_typename] = ACTIONS(3483),
    [anon_sym_template] = ACTIONS(3483),
    [anon_sym_operator] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_delete] = ACTIONS(3483),
    [anon_sym_throw] = ACTIONS(3483),
    [anon_sym_namespace] = ACTIONS(3483),
    [anon_sym_using] = ACTIONS(3483),
    [anon_sym_static_assert] = ACTIONS(3483),
    [anon_sym_concept] = ACTIONS(3483),
    [anon_sym_co_return] = ACTIONS(3483),
    [anon_sym_co_yield] = ACTIONS(3483),
    [anon_sym_R_DQUOTE] = ACTIONS(3485),
    [anon_sym_LR_DQUOTE] = ACTIONS(3485),
    [anon_sym_uR_DQUOTE] = ACTIONS(3485),
    [anon_sym_UR_DQUOTE] = ACTIONS(3485),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3485),
    [anon_sym_co_await] = ACTIONS(3483),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_requires] = ACTIONS(3483),
    [sym_this] = ACTIONS(3483),
    [anon_sym_precise] = ACTIONS(3483),
    [anon_sym_shared] = ACTIONS(3483),
    [anon_sym_groupshared] = ACTIONS(3483),
    [anon_sym_uniform] = ACTIONS(3483),
    [anon_sym_row_major] = ACTIONS(3483),
    [anon_sym_column_major] = ACTIONS(3483),
    [anon_sym_globallycoherent] = ACTIONS(3483),
    [anon_sym_centroid] = ACTIONS(3483),
    [anon_sym_noperspective] = ACTIONS(3483),
    [anon_sym_nointerpolation] = ACTIONS(3483),
    [anon_sym_sample] = ACTIONS(3483),
    [anon_sym_linear] = ACTIONS(3483),
    [anon_sym_snorm] = ACTIONS(3483),
    [anon_sym_unorm] = ACTIONS(3483),
    [anon_sym_point] = ACTIONS(3483),
    [anon_sym_line] = ACTIONS(3483),
    [anon_sym_triangleadj] = ACTIONS(3483),
    [anon_sym_lineadj] = ACTIONS(3483),
    [anon_sym_triangle] = ACTIONS(3483),
    [anon_sym_interface] = ACTIONS(3483),
    [anon_sym_extension] = ACTIONS(3483),
    [anon_sym___exported] = ACTIONS(3483),
    [anon_sym_import] = ACTIONS(3483),
  },
  [649] = {
    [sym_identifier] = ACTIONS(2359),
    [aux_sym_preproc_include_token1] = ACTIONS(2359),
    [aux_sym_preproc_def_token1] = ACTIONS(2359),
    [anon_sym_COMMA] = ACTIONS(3834),
    [anon_sym_RPAREN] = ACTIONS(3834),
    [aux_sym_preproc_if_token1] = ACTIONS(2359),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2359),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2359),
    [sym_preproc_directive] = ACTIONS(2359),
    [anon_sym_LPAREN2] = ACTIONS(2357),
    [anon_sym_BANG] = ACTIONS(2357),
    [anon_sym_TILDE] = ACTIONS(2357),
    [anon_sym_DASH] = ACTIONS(2359),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_STAR] = ACTIONS(2357),
    [anon_sym_AMP_AMP] = ACTIONS(2357),
    [anon_sym_AMP] = ACTIONS(2359),
    [anon_sym_SEMI] = ACTIONS(2357),
    [anon_sym___extension__] = ACTIONS(2359),
    [anon_sym_typedef] = ACTIONS(2359),
    [anon_sym_in] = ACTIONS(2359),
    [anon_sym_out] = ACTIONS(2359),
    [anon_sym_inout] = ACTIONS(2359),
    [anon_sym_extern] = ACTIONS(2359),
    [anon_sym___attribute__] = ACTIONS(2359),
    [anon_sym_COLON_COLON] = ACTIONS(2357),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2357),
    [anon_sym___declspec] = ACTIONS(2359),
    [anon_sym___based] = ACTIONS(2359),
    [anon_sym___cdecl] = ACTIONS(2359),
    [anon_sym___clrcall] = ACTIONS(2359),
    [anon_sym___stdcall] = ACTIONS(2359),
    [anon_sym___fastcall] = ACTIONS(2359),
    [anon_sym___thiscall] = ACTIONS(2359),
    [anon_sym___vectorcall] = ACTIONS(2359),
    [anon_sym_LBRACE] = ACTIONS(2357),
    [anon_sym_RBRACE] = ACTIONS(3834),
    [anon_sym_signed] = ACTIONS(2359),
    [anon_sym_unsigned] = ACTIONS(2359),
    [anon_sym_long] = ACTIONS(2359),
    [anon_sym_short] = ACTIONS(2359),
    [anon_sym_LBRACK] = ACTIONS(2359),
    [anon_sym_static] = ACTIONS(2359),
    [anon_sym_register] = ACTIONS(2359),
    [anon_sym_inline] = ACTIONS(2359),
    [anon_sym___inline] = ACTIONS(2359),
    [anon_sym___inline__] = ACTIONS(2359),
    [anon_sym___forceinline] = ACTIONS(2359),
    [anon_sym_thread_local] = ACTIONS(2359),
    [anon_sym___thread] = ACTIONS(2359),
    [anon_sym_const] = ACTIONS(2359),
    [anon_sym_constexpr] = ACTIONS(2359),
    [anon_sym_volatile] = ACTIONS(2359),
    [anon_sym_restrict] = ACTIONS(2359),
    [anon_sym___restrict__] = ACTIONS(2359),
    [anon_sym__Atomic] = ACTIONS(2359),
    [anon_sym__Noreturn] = ACTIONS(2359),
    [anon_sym_noreturn] = ACTIONS(2359),
    [anon_sym_mutable] = ACTIONS(2359),
    [anon_sym_constinit] = ACTIONS(2359),
    [anon_sym_consteval] = ACTIONS(2359),
    [anon_sym_alignas] = ACTIONS(2359),
    [anon_sym__Alignas] = ACTIONS(2359),
    [sym_primitive_type] = ACTIONS(2359),
    [anon_sym_enum] = ACTIONS(2359),
    [anon_sym_class] = ACTIONS(2359),
    [anon_sym_struct] = ACTIONS(2359),
    [anon_sym_union] = ACTIONS(2359),
    [anon_sym_if] = ACTIONS(2359),
    [anon_sym_switch] = ACTIONS(2359),
    [anon_sym_case] = ACTIONS(2359),
    [anon_sym_default] = ACTIONS(2359),
    [anon_sym_while] = ACTIONS(2359),
    [anon_sym_do] = ACTIONS(2359),
    [anon_sym_for] = ACTIONS(2359),
    [anon_sym_return] = ACTIONS(2359),
    [anon_sym_break] = ACTIONS(2359),
    [anon_sym_continue] = ACTIONS(2359),
    [anon_sym_goto] = ACTIONS(2359),
    [anon_sym___try] = ACTIONS(2359),
    [anon_sym___leave] = ACTIONS(2359),
    [anon_sym_not] = ACTIONS(2359),
    [anon_sym_compl] = ACTIONS(2359),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
    [anon_sym_sizeof] = ACTIONS(2359),
    [anon_sym___alignof__] = ACTIONS(2359),
    [anon_sym___alignof] = ACTIONS(2359),
    [anon_sym__alignof] = ACTIONS(2359),
    [anon_sym_alignof] = ACTIONS(2359),
    [anon_sym__Alignof] = ACTIONS(2359),
    [anon_sym_offsetof] = ACTIONS(2359),
    [anon_sym__Generic] = ACTIONS(2359),
    [anon_sym_asm] = ACTIONS(2359),
    [anon_sym___asm__] = ACTIONS(2359),
    [sym_number_literal] = ACTIONS(2357),
    [anon_sym_L_SQUOTE] = ACTIONS(2357),
    [anon_sym_u_SQUOTE] = ACTIONS(2357),
    [anon_sym_U_SQUOTE] = ACTIONS(2357),
    [anon_sym_u8_SQUOTE] = ACTIONS(2357),
    [anon_sym_SQUOTE] = ACTIONS(2357),
    [anon_sym_L_DQUOTE] = ACTIONS(2357),
    [anon_sym_u_DQUOTE] = ACTIONS(2357),
    [anon_sym_U_DQUOTE] = ACTIONS(2357),
    [anon_sym_u8_DQUOTE] = ACTIONS(2357),
    [anon_sym_DQUOTE] = ACTIONS(2357),
    [sym_true] = ACTIONS(2359),
    [sym_false] = ACTIONS(2359),
    [anon_sym_NULL] = ACTIONS(2359),
    [anon_sym_nullptr] = ACTIONS(2359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2359),
    [anon_sym_let] = ACTIONS(2359),
    [anon_sym_This] = ACTIONS(2359),
    [anon_sym_decltype] = ACTIONS(2359),
    [sym_virtual] = ACTIONS(2359),
    [anon_sym_explicit] = ACTIONS(2359),
    [anon_sym_typename] = ACTIONS(2359),
    [anon_sym_template] = ACTIONS(2359),
    [anon_sym_operator] = ACTIONS(2359),
    [anon_sym_try] = ACTIONS(2359),
    [anon_sym_delete] = ACTIONS(2359),
    [anon_sym_throw] = ACTIONS(2359),
    [anon_sym_namespace] = ACTIONS(2359),
    [anon_sym_using] = ACTIONS(2359),
    [anon_sym_static_assert] = ACTIONS(2359),
    [anon_sym_concept] = ACTIONS(2359),
    [anon_sym_co_return] = ACTIONS(2359),
    [anon_sym_co_yield] = ACTIONS(2359),
    [anon_sym_R_DQUOTE] = ACTIONS(2357),
    [anon_sym_LR_DQUOTE] = ACTIONS(2357),
    [anon_sym_uR_DQUOTE] = ACTIONS(2357),
    [anon_sym_UR_DQUOTE] = ACTIONS(2357),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2357),
    [anon_sym_co_await] = ACTIONS(2359),
    [anon_sym_new] = ACTIONS(2359),
    [anon_sym_requires] = ACTIONS(2359),
    [sym_this] = ACTIONS(2359),
    [anon_sym_discard] = ACTIONS(2359),
    [anon_sym_precise] = ACTIONS(2359),
    [anon_sym_shared] = ACTIONS(2359),
    [anon_sym_groupshared] = ACTIONS(2359),
    [anon_sym_uniform] = ACTIONS(2359),
    [anon_sym_row_major] = ACTIONS(2359),
    [anon_sym_column_major] = ACTIONS(2359),
    [anon_sym_globallycoherent] = ACTIONS(2359),
    [anon_sym_centroid] = ACTIONS(2359),
    [anon_sym_noperspective] = ACTIONS(2359),
    [anon_sym_nointerpolation] = ACTIONS(2359),
    [anon_sym_sample] = ACTIONS(2359),
    [anon_sym_linear] = ACTIONS(2359),
    [anon_sym_snorm] = ACTIONS(2359),
    [anon_sym_unorm] = ACTIONS(2359),
    [anon_sym_point] = ACTIONS(2359),
    [anon_sym_line] = ACTIONS(2359),
    [anon_sym_triangleadj] = ACTIONS(2359),
    [anon_sym_lineadj] = ACTIONS(2359),
    [anon_sym_triangle] = ACTIONS(2359),
    [anon_sym_cbuffer] = ACTIONS(2359),
    [anon_sym_interface] = ACTIONS(2359),
    [anon_sym_extension] = ACTIONS(2359),
  },
  [650] = {
    [sym_else_clause] = STATE(732),
    [sym_identifier] = ACTIONS(2836),
    [aux_sym_preproc_include_token1] = ACTIONS(2836),
    [aux_sym_preproc_def_token1] = ACTIONS(2836),
    [aux_sym_preproc_if_token1] = ACTIONS(2836),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2836),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2836),
    [sym_preproc_directive] = ACTIONS(2836),
    [anon_sym_LPAREN2] = ACTIONS(2838),
    [anon_sym_BANG] = ACTIONS(2838),
    [anon_sym_TILDE] = ACTIONS(2838),
    [anon_sym_DASH] = ACTIONS(2836),
    [anon_sym_PLUS] = ACTIONS(2836),
    [anon_sym_STAR] = ACTIONS(2838),
    [anon_sym_AMP_AMP] = ACTIONS(2838),
    [anon_sym_AMP] = ACTIONS(2836),
    [anon_sym_SEMI] = ACTIONS(2838),
    [anon_sym___extension__] = ACTIONS(2836),
    [anon_sym_typedef] = ACTIONS(2836),
    [anon_sym_in] = ACTIONS(2836),
    [anon_sym_out] = ACTIONS(2836),
    [anon_sym_inout] = ACTIONS(2836),
    [anon_sym_extern] = ACTIONS(2836),
    [anon_sym___attribute__] = ACTIONS(2836),
    [anon_sym_COLON_COLON] = ACTIONS(2838),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2838),
    [anon_sym___declspec] = ACTIONS(2836),
    [anon_sym___based] = ACTIONS(2836),
    [anon_sym___cdecl] = ACTIONS(2836),
    [anon_sym___clrcall] = ACTIONS(2836),
    [anon_sym___stdcall] = ACTIONS(2836),
    [anon_sym___fastcall] = ACTIONS(2836),
    [anon_sym___thiscall] = ACTIONS(2836),
    [anon_sym___vectorcall] = ACTIONS(2836),
    [anon_sym_LBRACE] = ACTIONS(2838),
    [anon_sym_RBRACE] = ACTIONS(2838),
    [anon_sym_signed] = ACTIONS(2836),
    [anon_sym_unsigned] = ACTIONS(2836),
    [anon_sym_long] = ACTIONS(2836),
    [anon_sym_short] = ACTIONS(2836),
    [anon_sym_LBRACK] = ACTIONS(2836),
    [anon_sym_static] = ACTIONS(2836),
    [anon_sym_register] = ACTIONS(2836),
    [anon_sym_inline] = ACTIONS(2836),
    [anon_sym___inline] = ACTIONS(2836),
    [anon_sym___inline__] = ACTIONS(2836),
    [anon_sym___forceinline] = ACTIONS(2836),
    [anon_sym_thread_local] = ACTIONS(2836),
    [anon_sym___thread] = ACTIONS(2836),
    [anon_sym_const] = ACTIONS(2836),
    [anon_sym_constexpr] = ACTIONS(2836),
    [anon_sym_volatile] = ACTIONS(2836),
    [anon_sym_restrict] = ACTIONS(2836),
    [anon_sym___restrict__] = ACTIONS(2836),
    [anon_sym__Atomic] = ACTIONS(2836),
    [anon_sym__Noreturn] = ACTIONS(2836),
    [anon_sym_noreturn] = ACTIONS(2836),
    [anon_sym_mutable] = ACTIONS(2836),
    [anon_sym_constinit] = ACTIONS(2836),
    [anon_sym_consteval] = ACTIONS(2836),
    [anon_sym_alignas] = ACTIONS(2836),
    [anon_sym__Alignas] = ACTIONS(2836),
    [sym_primitive_type] = ACTIONS(2836),
    [anon_sym_enum] = ACTIONS(2836),
    [anon_sym_class] = ACTIONS(2836),
    [anon_sym_struct] = ACTIONS(2836),
    [anon_sym_union] = ACTIONS(2836),
    [anon_sym_if] = ACTIONS(2836),
    [anon_sym_else] = ACTIONS(3723),
    [anon_sym_switch] = ACTIONS(2836),
    [anon_sym_case] = ACTIONS(2836),
    [anon_sym_default] = ACTIONS(2836),
    [anon_sym_while] = ACTIONS(2836),
    [anon_sym_do] = ACTIONS(2836),
    [anon_sym_for] = ACTIONS(2836),
    [anon_sym_return] = ACTIONS(2836),
    [anon_sym_break] = ACTIONS(2836),
    [anon_sym_continue] = ACTIONS(2836),
    [anon_sym_goto] = ACTIONS(2836),
    [anon_sym___try] = ACTIONS(2836),
    [anon_sym___leave] = ACTIONS(2836),
    [anon_sym_not] = ACTIONS(2836),
    [anon_sym_compl] = ACTIONS(2836),
    [anon_sym_DASH_DASH] = ACTIONS(2838),
    [anon_sym_PLUS_PLUS] = ACTIONS(2838),
    [anon_sym_sizeof] = ACTIONS(2836),
    [anon_sym___alignof__] = ACTIONS(2836),
    [anon_sym___alignof] = ACTIONS(2836),
    [anon_sym__alignof] = ACTIONS(2836),
    [anon_sym_alignof] = ACTIONS(2836),
    [anon_sym__Alignof] = ACTIONS(2836),
    [anon_sym_offsetof] = ACTIONS(2836),
    [anon_sym__Generic] = ACTIONS(2836),
    [anon_sym_asm] = ACTIONS(2836),
    [anon_sym___asm__] = ACTIONS(2836),
    [sym_number_literal] = ACTIONS(2838),
    [anon_sym_L_SQUOTE] = ACTIONS(2838),
    [anon_sym_u_SQUOTE] = ACTIONS(2838),
    [anon_sym_U_SQUOTE] = ACTIONS(2838),
    [anon_sym_u8_SQUOTE] = ACTIONS(2838),
    [anon_sym_SQUOTE] = ACTIONS(2838),
    [anon_sym_L_DQUOTE] = ACTIONS(2838),
    [anon_sym_u_DQUOTE] = ACTIONS(2838),
    [anon_sym_U_DQUOTE] = ACTIONS(2838),
    [anon_sym_u8_DQUOTE] = ACTIONS(2838),
    [anon_sym_DQUOTE] = ACTIONS(2838),
    [sym_true] = ACTIONS(2836),
    [sym_false] = ACTIONS(2836),
    [anon_sym_NULL] = ACTIONS(2836),
    [anon_sym_nullptr] = ACTIONS(2836),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2836),
    [anon_sym_let] = ACTIONS(2836),
    [anon_sym_This] = ACTIONS(2836),
    [anon_sym_decltype] = ACTIONS(2836),
    [sym_virtual] = ACTIONS(2836),
    [anon_sym_explicit] = ACTIONS(2836),
    [anon_sym_typename] = ACTIONS(2836),
    [anon_sym_template] = ACTIONS(2836),
    [anon_sym_operator] = ACTIONS(2836),
    [anon_sym_try] = ACTIONS(2836),
    [anon_sym_delete] = ACTIONS(2836),
    [anon_sym_throw] = ACTIONS(2836),
    [anon_sym_namespace] = ACTIONS(2836),
    [anon_sym_using] = ACTIONS(2836),
    [anon_sym_static_assert] = ACTIONS(2836),
    [anon_sym_concept] = ACTIONS(2836),
    [anon_sym_co_return] = ACTIONS(2836),
    [anon_sym_co_yield] = ACTIONS(2836),
    [anon_sym_R_DQUOTE] = ACTIONS(2838),
    [anon_sym_LR_DQUOTE] = ACTIONS(2838),
    [anon_sym_uR_DQUOTE] = ACTIONS(2838),
    [anon_sym_UR_DQUOTE] = ACTIONS(2838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2838),
    [anon_sym_co_await] = ACTIONS(2836),
    [anon_sym_new] = ACTIONS(2836),
    [anon_sym_requires] = ACTIONS(2836),
    [sym_this] = ACTIONS(2836),
    [anon_sym_discard] = ACTIONS(2836),
    [anon_sym_precise] = ACTIONS(2836),
    [anon_sym_shared] = ACTIONS(2836),
    [anon_sym_groupshared] = ACTIONS(2836),
    [anon_sym_uniform] = ACTIONS(2836),
    [anon_sym_row_major] = ACTIONS(2836),
    [anon_sym_column_major] = ACTIONS(2836),
    [anon_sym_globallycoherent] = ACTIONS(2836),
    [anon_sym_centroid] = ACTIONS(2836),
    [anon_sym_noperspective] = ACTIONS(2836),
    [anon_sym_nointerpolation] = ACTIONS(2836),
    [anon_sym_sample] = ACTIONS(2836),
    [anon_sym_linear] = ACTIONS(2836),
    [anon_sym_snorm] = ACTIONS(2836),
    [anon_sym_unorm] = ACTIONS(2836),
    [anon_sym_point] = ACTIONS(2836),
    [anon_sym_line] = ACTIONS(2836),
    [anon_sym_triangleadj] = ACTIONS(2836),
    [anon_sym_lineadj] = ACTIONS(2836),
    [anon_sym_triangle] = ACTIONS(2836),
    [anon_sym_cbuffer] = ACTIONS(2836),
    [anon_sym_interface] = ACTIONS(2836),
    [anon_sym_extension] = ACTIONS(2836),
  },
  [651] = {
    [sym_attribute_specifier] = STATE(748),
    [sym_identifier] = ACTIONS(3836),
    [aux_sym_preproc_include_token1] = ACTIONS(3836),
    [aux_sym_preproc_def_token1] = ACTIONS(3836),
    [aux_sym_preproc_if_token1] = ACTIONS(3836),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3836),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3836),
    [sym_preproc_directive] = ACTIONS(3836),
    [anon_sym_LPAREN2] = ACTIONS(3838),
    [anon_sym_BANG] = ACTIONS(3838),
    [anon_sym_TILDE] = ACTIONS(3838),
    [anon_sym_DASH] = ACTIONS(3836),
    [anon_sym_PLUS] = ACTIONS(3836),
    [anon_sym_STAR] = ACTIONS(3838),
    [anon_sym_AMP_AMP] = ACTIONS(3838),
    [anon_sym_AMP] = ACTIONS(3836),
    [anon_sym_SEMI] = ACTIONS(3838),
    [anon_sym___extension__] = ACTIONS(3836),
    [anon_sym_typedef] = ACTIONS(3836),
    [anon_sym_in] = ACTIONS(3836),
    [anon_sym_out] = ACTIONS(3836),
    [anon_sym_inout] = ACTIONS(3836),
    [anon_sym_extern] = ACTIONS(3836),
    [anon_sym___attribute__] = ACTIONS(2687),
    [anon_sym_COLON_COLON] = ACTIONS(3838),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3838),
    [anon_sym___declspec] = ACTIONS(3836),
    [anon_sym___based] = ACTIONS(3836),
    [anon_sym___cdecl] = ACTIONS(3836),
    [anon_sym___clrcall] = ACTIONS(3836),
    [anon_sym___stdcall] = ACTIONS(3836),
    [anon_sym___fastcall] = ACTIONS(3836),
    [anon_sym___thiscall] = ACTIONS(3836),
    [anon_sym___vectorcall] = ACTIONS(3836),
    [anon_sym_LBRACE] = ACTIONS(3838),
    [anon_sym_RBRACE] = ACTIONS(3838),
    [anon_sym_signed] = ACTIONS(3836),
    [anon_sym_unsigned] = ACTIONS(3836),
    [anon_sym_long] = ACTIONS(3836),
    [anon_sym_short] = ACTIONS(3836),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_static] = ACTIONS(3836),
    [anon_sym_register] = ACTIONS(3836),
    [anon_sym_inline] = ACTIONS(3836),
    [anon_sym___inline] = ACTIONS(3836),
    [anon_sym___inline__] = ACTIONS(3836),
    [anon_sym___forceinline] = ACTIONS(3836),
    [anon_sym_thread_local] = ACTIONS(3836),
    [anon_sym___thread] = ACTIONS(3836),
    [anon_sym_const] = ACTIONS(3836),
    [anon_sym_constexpr] = ACTIONS(3836),
    [anon_sym_volatile] = ACTIONS(3836),
    [anon_sym_restrict] = ACTIONS(3836),
    [anon_sym___restrict__] = ACTIONS(3836),
    [anon_sym__Atomic] = ACTIONS(3836),
    [anon_sym__Noreturn] = ACTIONS(3836),
    [anon_sym_noreturn] = ACTIONS(3836),
    [anon_sym_mutable] = ACTIONS(3836),
    [anon_sym_constinit] = ACTIONS(3836),
    [anon_sym_consteval] = ACTIONS(3836),
    [anon_sym_alignas] = ACTIONS(3836),
    [anon_sym__Alignas] = ACTIONS(3836),
    [sym_primitive_type] = ACTIONS(3836),
    [anon_sym_enum] = ACTIONS(3836),
    [anon_sym_class] = ACTIONS(3836),
    [anon_sym_struct] = ACTIONS(3836),
    [anon_sym_union] = ACTIONS(3836),
    [anon_sym_if] = ACTIONS(3836),
    [anon_sym_switch] = ACTIONS(3836),
    [anon_sym_case] = ACTIONS(3836),
    [anon_sym_default] = ACTIONS(3836),
    [anon_sym_while] = ACTIONS(3836),
    [anon_sym_do] = ACTIONS(3836),
    [anon_sym_for] = ACTIONS(3836),
    [anon_sym_return] = ACTIONS(3836),
    [anon_sym_break] = ACTIONS(3836),
    [anon_sym_continue] = ACTIONS(3836),
    [anon_sym_goto] = ACTIONS(3836),
    [anon_sym___try] = ACTIONS(3836),
    [anon_sym___leave] = ACTIONS(3836),
    [anon_sym_not] = ACTIONS(3836),
    [anon_sym_compl] = ACTIONS(3836),
    [anon_sym_DASH_DASH] = ACTIONS(3838),
    [anon_sym_PLUS_PLUS] = ACTIONS(3838),
    [anon_sym_sizeof] = ACTIONS(3836),
    [anon_sym___alignof__] = ACTIONS(3836),
    [anon_sym___alignof] = ACTIONS(3836),
    [anon_sym__alignof] = ACTIONS(3836),
    [anon_sym_alignof] = ACTIONS(3836),
    [anon_sym__Alignof] = ACTIONS(3836),
    [anon_sym_offsetof] = ACTIONS(3836),
    [anon_sym__Generic] = ACTIONS(3836),
    [anon_sym_asm] = ACTIONS(3836),
    [anon_sym___asm__] = ACTIONS(3836),
    [anon_sym_DOT] = ACTIONS(3836),
    [sym_number_literal] = ACTIONS(3838),
    [anon_sym_L_SQUOTE] = ACTIONS(3838),
    [anon_sym_u_SQUOTE] = ACTIONS(3838),
    [anon_sym_U_SQUOTE] = ACTIONS(3838),
    [anon_sym_u8_SQUOTE] = ACTIONS(3838),
    [anon_sym_SQUOTE] = ACTIONS(3838),
    [anon_sym_L_DQUOTE] = ACTIONS(3838),
    [anon_sym_u_DQUOTE] = ACTIONS(3838),
    [anon_sym_U_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8_DQUOTE] = ACTIONS(3838),
    [anon_sym_DQUOTE] = ACTIONS(3838),
    [sym_true] = ACTIONS(3836),
    [sym_false] = ACTIONS(3836),
    [anon_sym_NULL] = ACTIONS(3836),
    [anon_sym_nullptr] = ACTIONS(3836),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3836),
    [anon_sym_let] = ACTIONS(3836),
    [anon_sym_This] = ACTIONS(3836),
    [anon_sym_decltype] = ACTIONS(3836),
    [sym_virtual] = ACTIONS(3836),
    [anon_sym_explicit] = ACTIONS(3836),
    [anon_sym_typename] = ACTIONS(3836),
    [anon_sym_template] = ACTIONS(3836),
    [anon_sym_operator] = ACTIONS(3836),
    [anon_sym_try] = ACTIONS(3836),
    [anon_sym_delete] = ACTIONS(3836),
    [anon_sym_throw] = ACTIONS(3836),
    [anon_sym_namespace] = ACTIONS(3836),
    [anon_sym_using] = ACTIONS(3836),
    [anon_sym_static_assert] = ACTIONS(3836),
    [anon_sym_concept] = ACTIONS(3836),
    [anon_sym_co_return] = ACTIONS(3836),
    [anon_sym_co_yield] = ACTIONS(3836),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [anon_sym_co_await] = ACTIONS(3836),
    [anon_sym_new] = ACTIONS(3836),
    [anon_sym_requires] = ACTIONS(3836),
    [sym_this] = ACTIONS(3836),
    [anon_sym_discard] = ACTIONS(3836),
    [anon_sym_precise] = ACTIONS(3836),
    [anon_sym_shared] = ACTIONS(3836),
    [anon_sym_groupshared] = ACTIONS(3836),
    [anon_sym_uniform] = ACTIONS(3836),
    [anon_sym_row_major] = ACTIONS(3836),
    [anon_sym_column_major] = ACTIONS(3836),
    [anon_sym_globallycoherent] = ACTIONS(3836),
    [anon_sym_centroid] = ACTIONS(3836),
    [anon_sym_noperspective] = ACTIONS(3836),
    [anon_sym_nointerpolation] = ACTIONS(3836),
    [anon_sym_sample] = ACTIONS(3836),
    [anon_sym_linear] = ACTIONS(3836),
    [anon_sym_snorm] = ACTIONS(3836),
    [anon_sym_unorm] = ACTIONS(3836),
    [anon_sym_point] = ACTIONS(3836),
    [anon_sym_line] = ACTIONS(3836),
    [anon_sym_triangleadj] = ACTIONS(3836),
    [anon_sym_lineadj] = ACTIONS(3836),
    [anon_sym_triangle] = ACTIONS(3836),
    [anon_sym_cbuffer] = ACTIONS(3836),
    [anon_sym_interface] = ACTIONS(3836),
    [anon_sym_extension] = ACTIONS(3836),
  },
  [652] = {
    [sym_identifier] = ACTIONS(2842),
    [aux_sym_preproc_include_token1] = ACTIONS(2842),
    [aux_sym_preproc_def_token1] = ACTIONS(2842),
    [aux_sym_preproc_if_token1] = ACTIONS(2842),
    [aux_sym_preproc_if_token2] = ACTIONS(2842),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2842),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2842),
    [sym_preproc_directive] = ACTIONS(2842),
    [anon_sym_LPAREN2] = ACTIONS(2844),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_TILDE] = ACTIONS(2844),
    [anon_sym_DASH] = ACTIONS(2842),
    [anon_sym_PLUS] = ACTIONS(2842),
    [anon_sym_STAR] = ACTIONS(2844),
    [anon_sym_AMP_AMP] = ACTIONS(2844),
    [anon_sym_AMP] = ACTIONS(2842),
    [anon_sym_SEMI] = ACTIONS(2844),
    [anon_sym___extension__] = ACTIONS(2842),
    [anon_sym_typedef] = ACTIONS(2842),
    [anon_sym_in] = ACTIONS(2842),
    [anon_sym_out] = ACTIONS(2842),
    [anon_sym_inout] = ACTIONS(2842),
    [anon_sym_extern] = ACTIONS(2842),
    [anon_sym___attribute__] = ACTIONS(2842),
    [anon_sym_COLON_COLON] = ACTIONS(2844),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2844),
    [anon_sym___declspec] = ACTIONS(2842),
    [anon_sym___based] = ACTIONS(2842),
    [anon_sym___cdecl] = ACTIONS(2842),
    [anon_sym___clrcall] = ACTIONS(2842),
    [anon_sym___stdcall] = ACTIONS(2842),
    [anon_sym___fastcall] = ACTIONS(2842),
    [anon_sym___thiscall] = ACTIONS(2842),
    [anon_sym___vectorcall] = ACTIONS(2842),
    [anon_sym_LBRACE] = ACTIONS(2844),
    [anon_sym_signed] = ACTIONS(2842),
    [anon_sym_unsigned] = ACTIONS(2842),
    [anon_sym_long] = ACTIONS(2842),
    [anon_sym_short] = ACTIONS(2842),
    [anon_sym_LBRACK] = ACTIONS(2842),
    [anon_sym_static] = ACTIONS(2842),
    [anon_sym_register] = ACTIONS(2842),
    [anon_sym_inline] = ACTIONS(2842),
    [anon_sym___inline] = ACTIONS(2842),
    [anon_sym___inline__] = ACTIONS(2842),
    [anon_sym___forceinline] = ACTIONS(2842),
    [anon_sym_thread_local] = ACTIONS(2842),
    [anon_sym___thread] = ACTIONS(2842),
    [anon_sym_const] = ACTIONS(2842),
    [anon_sym_constexpr] = ACTIONS(2842),
    [anon_sym_volatile] = ACTIONS(2842),
    [anon_sym_restrict] = ACTIONS(2842),
    [anon_sym___restrict__] = ACTIONS(2842),
    [anon_sym__Atomic] = ACTIONS(2842),
    [anon_sym__Noreturn] = ACTIONS(2842),
    [anon_sym_noreturn] = ACTIONS(2842),
    [anon_sym_mutable] = ACTIONS(2842),
    [anon_sym_constinit] = ACTIONS(2842),
    [anon_sym_consteval] = ACTIONS(2842),
    [anon_sym_alignas] = ACTIONS(2842),
    [anon_sym__Alignas] = ACTIONS(2842),
    [sym_primitive_type] = ACTIONS(2842),
    [anon_sym_enum] = ACTIONS(2842),
    [anon_sym_class] = ACTIONS(2842),
    [anon_sym_struct] = ACTIONS(2842),
    [anon_sym_union] = ACTIONS(2842),
    [anon_sym_if] = ACTIONS(2842),
    [anon_sym_else] = ACTIONS(2842),
    [anon_sym_switch] = ACTIONS(2842),
    [anon_sym_case] = ACTIONS(2842),
    [anon_sym_default] = ACTIONS(2842),
    [anon_sym_while] = ACTIONS(2842),
    [anon_sym_do] = ACTIONS(2842),
    [anon_sym_for] = ACTIONS(2842),
    [anon_sym_return] = ACTIONS(2842),
    [anon_sym_break] = ACTIONS(2842),
    [anon_sym_continue] = ACTIONS(2842),
    [anon_sym_goto] = ACTIONS(2842),
    [anon_sym___try] = ACTIONS(2842),
    [anon_sym___leave] = ACTIONS(2842),
    [anon_sym_not] = ACTIONS(2842),
    [anon_sym_compl] = ACTIONS(2842),
    [anon_sym_DASH_DASH] = ACTIONS(2844),
    [anon_sym_PLUS_PLUS] = ACTIONS(2844),
    [anon_sym_sizeof] = ACTIONS(2842),
    [anon_sym___alignof__] = ACTIONS(2842),
    [anon_sym___alignof] = ACTIONS(2842),
    [anon_sym__alignof] = ACTIONS(2842),
    [anon_sym_alignof] = ACTIONS(2842),
    [anon_sym__Alignof] = ACTIONS(2842),
    [anon_sym_offsetof] = ACTIONS(2842),
    [anon_sym__Generic] = ACTIONS(2842),
    [anon_sym_asm] = ACTIONS(2842),
    [anon_sym___asm__] = ACTIONS(2842),
    [sym_number_literal] = ACTIONS(2844),
    [anon_sym_L_SQUOTE] = ACTIONS(2844),
    [anon_sym_u_SQUOTE] = ACTIONS(2844),
    [anon_sym_U_SQUOTE] = ACTIONS(2844),
    [anon_sym_u8_SQUOTE] = ACTIONS(2844),
    [anon_sym_SQUOTE] = ACTIONS(2844),
    [anon_sym_L_DQUOTE] = ACTIONS(2844),
    [anon_sym_u_DQUOTE] = ACTIONS(2844),
    [anon_sym_U_DQUOTE] = ACTIONS(2844),
    [anon_sym_u8_DQUOTE] = ACTIONS(2844),
    [anon_sym_DQUOTE] = ACTIONS(2844),
    [sym_true] = ACTIONS(2842),
    [sym_false] = ACTIONS(2842),
    [anon_sym_NULL] = ACTIONS(2842),
    [anon_sym_nullptr] = ACTIONS(2842),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2842),
    [anon_sym_let] = ACTIONS(2842),
    [anon_sym_This] = ACTIONS(2842),
    [anon_sym_decltype] = ACTIONS(2842),
    [sym_virtual] = ACTIONS(2842),
    [anon_sym_explicit] = ACTIONS(2842),
    [anon_sym_typename] = ACTIONS(2842),
    [anon_sym_template] = ACTIONS(2842),
    [anon_sym_operator] = ACTIONS(2842),
    [anon_sym_try] = ACTIONS(2842),
    [anon_sym_delete] = ACTIONS(2842),
    [anon_sym_throw] = ACTIONS(2842),
    [anon_sym_namespace] = ACTIONS(2842),
    [anon_sym_using] = ACTIONS(2842),
    [anon_sym_static_assert] = ACTIONS(2842),
    [anon_sym_concept] = ACTIONS(2842),
    [anon_sym_co_return] = ACTIONS(2842),
    [anon_sym_co_yield] = ACTIONS(2842),
    [anon_sym_catch] = ACTIONS(2842),
    [anon_sym_R_DQUOTE] = ACTIONS(2844),
    [anon_sym_LR_DQUOTE] = ACTIONS(2844),
    [anon_sym_uR_DQUOTE] = ACTIONS(2844),
    [anon_sym_UR_DQUOTE] = ACTIONS(2844),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2844),
    [anon_sym_co_await] = ACTIONS(2842),
    [anon_sym_new] = ACTIONS(2842),
    [anon_sym_requires] = ACTIONS(2842),
    [sym_this] = ACTIONS(2842),
    [anon_sym_discard] = ACTIONS(2842),
    [anon_sym_precise] = ACTIONS(2842),
    [anon_sym_shared] = ACTIONS(2842),
    [anon_sym_groupshared] = ACTIONS(2842),
    [anon_sym_uniform] = ACTIONS(2842),
    [anon_sym_row_major] = ACTIONS(2842),
    [anon_sym_column_major] = ACTIONS(2842),
    [anon_sym_globallycoherent] = ACTIONS(2842),
    [anon_sym_centroid] = ACTIONS(2842),
    [anon_sym_noperspective] = ACTIONS(2842),
    [anon_sym_nointerpolation] = ACTIONS(2842),
    [anon_sym_sample] = ACTIONS(2842),
    [anon_sym_linear] = ACTIONS(2842),
    [anon_sym_snorm] = ACTIONS(2842),
    [anon_sym_unorm] = ACTIONS(2842),
    [anon_sym_point] = ACTIONS(2842),
    [anon_sym_line] = ACTIONS(2842),
    [anon_sym_triangleadj] = ACTIONS(2842),
    [anon_sym_lineadj] = ACTIONS(2842),
    [anon_sym_triangle] = ACTIONS(2842),
    [anon_sym_cbuffer] = ACTIONS(2842),
    [anon_sym_interface] = ACTIONS(2842),
    [anon_sym_extension] = ACTIONS(2842),
  },
  [653] = {
    [sym_attribute_specifier] = STATE(773),
    [sym_identifier] = ACTIONS(3840),
    [aux_sym_preproc_include_token1] = ACTIONS(3840),
    [aux_sym_preproc_def_token1] = ACTIONS(3840),
    [aux_sym_preproc_if_token1] = ACTIONS(3840),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3840),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3840),
    [sym_preproc_directive] = ACTIONS(3840),
    [anon_sym_LPAREN2] = ACTIONS(3842),
    [anon_sym_BANG] = ACTIONS(3842),
    [anon_sym_TILDE] = ACTIONS(3842),
    [anon_sym_DASH] = ACTIONS(3840),
    [anon_sym_PLUS] = ACTIONS(3840),
    [anon_sym_STAR] = ACTIONS(3842),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_AMP] = ACTIONS(3840),
    [anon_sym_SEMI] = ACTIONS(3842),
    [anon_sym___extension__] = ACTIONS(3840),
    [anon_sym_typedef] = ACTIONS(3840),
    [anon_sym_in] = ACTIONS(3840),
    [anon_sym_out] = ACTIONS(3840),
    [anon_sym_inout] = ACTIONS(3840),
    [anon_sym_extern] = ACTIONS(3840),
    [anon_sym___attribute__] = ACTIONS(2687),
    [anon_sym_COLON_COLON] = ACTIONS(3842),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3842),
    [anon_sym___declspec] = ACTIONS(3840),
    [anon_sym___based] = ACTIONS(3840),
    [anon_sym___cdecl] = ACTIONS(3840),
    [anon_sym___clrcall] = ACTIONS(3840),
    [anon_sym___stdcall] = ACTIONS(3840),
    [anon_sym___fastcall] = ACTIONS(3840),
    [anon_sym___thiscall] = ACTIONS(3840),
    [anon_sym___vectorcall] = ACTIONS(3840),
    [anon_sym_LBRACE] = ACTIONS(3842),
    [anon_sym_RBRACE] = ACTIONS(3842),
    [anon_sym_signed] = ACTIONS(3840),
    [anon_sym_unsigned] = ACTIONS(3840),
    [anon_sym_long] = ACTIONS(3840),
    [anon_sym_short] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3840),
    [anon_sym_static] = ACTIONS(3840),
    [anon_sym_register] = ACTIONS(3840),
    [anon_sym_inline] = ACTIONS(3840),
    [anon_sym___inline] = ACTIONS(3840),
    [anon_sym___inline__] = ACTIONS(3840),
    [anon_sym___forceinline] = ACTIONS(3840),
    [anon_sym_thread_local] = ACTIONS(3840),
    [anon_sym___thread] = ACTIONS(3840),
    [anon_sym_const] = ACTIONS(3840),
    [anon_sym_constexpr] = ACTIONS(3840),
    [anon_sym_volatile] = ACTIONS(3840),
    [anon_sym_restrict] = ACTIONS(3840),
    [anon_sym___restrict__] = ACTIONS(3840),
    [anon_sym__Atomic] = ACTIONS(3840),
    [anon_sym__Noreturn] = ACTIONS(3840),
    [anon_sym_noreturn] = ACTIONS(3840),
    [anon_sym_mutable] = ACTIONS(3840),
    [anon_sym_constinit] = ACTIONS(3840),
    [anon_sym_consteval] = ACTIONS(3840),
    [anon_sym_alignas] = ACTIONS(3840),
    [anon_sym__Alignas] = ACTIONS(3840),
    [sym_primitive_type] = ACTIONS(3840),
    [anon_sym_enum] = ACTIONS(3840),
    [anon_sym_class] = ACTIONS(3840),
    [anon_sym_struct] = ACTIONS(3840),
    [anon_sym_union] = ACTIONS(3840),
    [anon_sym_if] = ACTIONS(3840),
    [anon_sym_switch] = ACTIONS(3840),
    [anon_sym_case] = ACTIONS(3840),
    [anon_sym_default] = ACTIONS(3840),
    [anon_sym_while] = ACTIONS(3840),
    [anon_sym_do] = ACTIONS(3840),
    [anon_sym_for] = ACTIONS(3840),
    [anon_sym_return] = ACTIONS(3840),
    [anon_sym_break] = ACTIONS(3840),
    [anon_sym_continue] = ACTIONS(3840),
    [anon_sym_goto] = ACTIONS(3840),
    [anon_sym___try] = ACTIONS(3840),
    [anon_sym___leave] = ACTIONS(3840),
    [anon_sym_not] = ACTIONS(3840),
    [anon_sym_compl] = ACTIONS(3840),
    [anon_sym_DASH_DASH] = ACTIONS(3842),
    [anon_sym_PLUS_PLUS] = ACTIONS(3842),
    [anon_sym_sizeof] = ACTIONS(3840),
    [anon_sym___alignof__] = ACTIONS(3840),
    [anon_sym___alignof] = ACTIONS(3840),
    [anon_sym__alignof] = ACTIONS(3840),
    [anon_sym_alignof] = ACTIONS(3840),
    [anon_sym__Alignof] = ACTIONS(3840),
    [anon_sym_offsetof] = ACTIONS(3840),
    [anon_sym__Generic] = ACTIONS(3840),
    [anon_sym_asm] = ACTIONS(3840),
    [anon_sym___asm__] = ACTIONS(3840),
    [anon_sym_DOT] = ACTIONS(3840),
    [sym_number_literal] = ACTIONS(3842),
    [anon_sym_L_SQUOTE] = ACTIONS(3842),
    [anon_sym_u_SQUOTE] = ACTIONS(3842),
    [anon_sym_U_SQUOTE] = ACTIONS(3842),
    [anon_sym_u8_SQUOTE] = ACTIONS(3842),
    [anon_sym_SQUOTE] = ACTIONS(3842),
    [anon_sym_L_DQUOTE] = ACTIONS(3842),
    [anon_sym_u_DQUOTE] = ACTIONS(3842),
    [anon_sym_U_DQUOTE] = ACTIONS(3842),
    [anon_sym_u8_DQUOTE] = ACTIONS(3842),
    [anon_sym_DQUOTE] = ACTIONS(3842),
    [sym_true] = ACTIONS(3840),
    [sym_false] = ACTIONS(3840),
    [anon_sym_NULL] = ACTIONS(3840),
    [anon_sym_nullptr] = ACTIONS(3840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3840),
    [anon_sym_let] = ACTIONS(3840),
    [anon_sym_This] = ACTIONS(3840),
    [anon_sym_decltype] = ACTIONS(3840),
    [sym_virtual] = ACTIONS(3840),
    [anon_sym_explicit] = ACTIONS(3840),
    [anon_sym_typename] = ACTIONS(3840),
    [anon_sym_template] = ACTIONS(3840),
    [anon_sym_operator] = ACTIONS(3840),
    [anon_sym_try] = ACTIONS(3840),
    [anon_sym_delete] = ACTIONS(3840),
    [anon_sym_throw] = ACTIONS(3840),
    [anon_sym_namespace] = ACTIONS(3840),
    [anon_sym_using] = ACTIONS(3840),
    [anon_sym_static_assert] = ACTIONS(3840),
    [anon_sym_concept] = ACTIONS(3840),
    [anon_sym_co_return] = ACTIONS(3840),
    [anon_sym_co_yield] = ACTIONS(3840),
    [anon_sym_R_DQUOTE] = ACTIONS(3842),
    [anon_sym_LR_DQUOTE] = ACTIONS(3842),
    [anon_sym_uR_DQUOTE] = ACTIONS(3842),
    [anon_sym_UR_DQUOTE] = ACTIONS(3842),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3842),
    [anon_sym_co_await] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3840),
    [anon_sym_requires] = ACTIONS(3840),
    [sym_this] = ACTIONS(3840),
    [anon_sym_discard] = ACTIONS(3840),
    [anon_sym_precise] = ACTIONS(3840),
    [anon_sym_shared] = ACTIONS(3840),
    [anon_sym_groupshared] = ACTIONS(3840),
    [anon_sym_uniform] = ACTIONS(3840),
    [anon_sym_row_major] = ACTIONS(3840),
    [anon_sym_column_major] = ACTIONS(3840),
    [anon_sym_globallycoherent] = ACTIONS(3840),
    [anon_sym_centroid] = ACTIONS(3840),
    [anon_sym_noperspective] = ACTIONS(3840),
    [anon_sym_nointerpolation] = ACTIONS(3840),
    [anon_sym_sample] = ACTIONS(3840),
    [anon_sym_linear] = ACTIONS(3840),
    [anon_sym_snorm] = ACTIONS(3840),
    [anon_sym_unorm] = ACTIONS(3840),
    [anon_sym_point] = ACTIONS(3840),
    [anon_sym_line] = ACTIONS(3840),
    [anon_sym_triangleadj] = ACTIONS(3840),
    [anon_sym_lineadj] = ACTIONS(3840),
    [anon_sym_triangle] = ACTIONS(3840),
    [anon_sym_cbuffer] = ACTIONS(3840),
    [anon_sym_interface] = ACTIONS(3840),
    [anon_sym_extension] = ACTIONS(3840),
  },
  [654] = {
    [sym_identifier] = ACTIONS(2954),
    [aux_sym_preproc_include_token1] = ACTIONS(2954),
    [aux_sym_preproc_def_token1] = ACTIONS(2954),
    [aux_sym_preproc_if_token1] = ACTIONS(2954),
    [aux_sym_preproc_if_token2] = ACTIONS(2954),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2954),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2954),
    [sym_preproc_directive] = ACTIONS(2954),
    [anon_sym_LPAREN2] = ACTIONS(2956),
    [anon_sym_BANG] = ACTIONS(2956),
    [anon_sym_TILDE] = ACTIONS(2956),
    [anon_sym_DASH] = ACTIONS(2954),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_STAR] = ACTIONS(2956),
    [anon_sym_AMP_AMP] = ACTIONS(2956),
    [anon_sym_AMP] = ACTIONS(2954),
    [anon_sym_SEMI] = ACTIONS(2956),
    [anon_sym___extension__] = ACTIONS(2954),
    [anon_sym_typedef] = ACTIONS(2954),
    [anon_sym_in] = ACTIONS(2954),
    [anon_sym_out] = ACTIONS(2954),
    [anon_sym_inout] = ACTIONS(2954),
    [anon_sym_extern] = ACTIONS(2954),
    [anon_sym___attribute__] = ACTIONS(2954),
    [anon_sym_COLON_COLON] = ACTIONS(2956),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2956),
    [anon_sym___declspec] = ACTIONS(2954),
    [anon_sym___based] = ACTIONS(2954),
    [anon_sym___cdecl] = ACTIONS(2954),
    [anon_sym___clrcall] = ACTIONS(2954),
    [anon_sym___stdcall] = ACTIONS(2954),
    [anon_sym___fastcall] = ACTIONS(2954),
    [anon_sym___thiscall] = ACTIONS(2954),
    [anon_sym___vectorcall] = ACTIONS(2954),
    [anon_sym_LBRACE] = ACTIONS(2956),
    [anon_sym_signed] = ACTIONS(2954),
    [anon_sym_unsigned] = ACTIONS(2954),
    [anon_sym_long] = ACTIONS(2954),
    [anon_sym_short] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_static] = ACTIONS(2954),
    [anon_sym_register] = ACTIONS(2954),
    [anon_sym_inline] = ACTIONS(2954),
    [anon_sym___inline] = ACTIONS(2954),
    [anon_sym___inline__] = ACTIONS(2954),
    [anon_sym___forceinline] = ACTIONS(2954),
    [anon_sym_thread_local] = ACTIONS(2954),
    [anon_sym___thread] = ACTIONS(2954),
    [anon_sym_const] = ACTIONS(2954),
    [anon_sym_constexpr] = ACTIONS(2954),
    [anon_sym_volatile] = ACTIONS(2954),
    [anon_sym_restrict] = ACTIONS(2954),
    [anon_sym___restrict__] = ACTIONS(2954),
    [anon_sym__Atomic] = ACTIONS(2954),
    [anon_sym__Noreturn] = ACTIONS(2954),
    [anon_sym_noreturn] = ACTIONS(2954),
    [anon_sym_mutable] = ACTIONS(2954),
    [anon_sym_constinit] = ACTIONS(2954),
    [anon_sym_consteval] = ACTIONS(2954),
    [anon_sym_alignas] = ACTIONS(2954),
    [anon_sym__Alignas] = ACTIONS(2954),
    [sym_primitive_type] = ACTIONS(2954),
    [anon_sym_enum] = ACTIONS(2954),
    [anon_sym_class] = ACTIONS(2954),
    [anon_sym_struct] = ACTIONS(2954),
    [anon_sym_union] = ACTIONS(2954),
    [anon_sym_if] = ACTIONS(2954),
    [anon_sym_else] = ACTIONS(2954),
    [anon_sym_switch] = ACTIONS(2954),
    [anon_sym_case] = ACTIONS(2954),
    [anon_sym_default] = ACTIONS(2954),
    [anon_sym_while] = ACTIONS(2954),
    [anon_sym_do] = ACTIONS(2954),
    [anon_sym_for] = ACTIONS(2954),
    [anon_sym_return] = ACTIONS(2954),
    [anon_sym_break] = ACTIONS(2954),
    [anon_sym_continue] = ACTIONS(2954),
    [anon_sym_goto] = ACTIONS(2954),
    [anon_sym___try] = ACTIONS(2954),
    [anon_sym___leave] = ACTIONS(2954),
    [anon_sym_not] = ACTIONS(2954),
    [anon_sym_compl] = ACTIONS(2954),
    [anon_sym_DASH_DASH] = ACTIONS(2956),
    [anon_sym_PLUS_PLUS] = ACTIONS(2956),
    [anon_sym_sizeof] = ACTIONS(2954),
    [anon_sym___alignof__] = ACTIONS(2954),
    [anon_sym___alignof] = ACTIONS(2954),
    [anon_sym__alignof] = ACTIONS(2954),
    [anon_sym_alignof] = ACTIONS(2954),
    [anon_sym__Alignof] = ACTIONS(2954),
    [anon_sym_offsetof] = ACTIONS(2954),
    [anon_sym__Generic] = ACTIONS(2954),
    [anon_sym_asm] = ACTIONS(2954),
    [anon_sym___asm__] = ACTIONS(2954),
    [sym_number_literal] = ACTIONS(2956),
    [anon_sym_L_SQUOTE] = ACTIONS(2956),
    [anon_sym_u_SQUOTE] = ACTIONS(2956),
    [anon_sym_U_SQUOTE] = ACTIONS(2956),
    [anon_sym_u8_SQUOTE] = ACTIONS(2956),
    [anon_sym_SQUOTE] = ACTIONS(2956),
    [anon_sym_L_DQUOTE] = ACTIONS(2956),
    [anon_sym_u_DQUOTE] = ACTIONS(2956),
    [anon_sym_U_DQUOTE] = ACTIONS(2956),
    [anon_sym_u8_DQUOTE] = ACTIONS(2956),
    [anon_sym_DQUOTE] = ACTIONS(2956),
    [sym_true] = ACTIONS(2954),
    [sym_false] = ACTIONS(2954),
    [anon_sym_NULL] = ACTIONS(2954),
    [anon_sym_nullptr] = ACTIONS(2954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2954),
    [anon_sym_let] = ACTIONS(2954),
    [anon_sym_This] = ACTIONS(2954),
    [anon_sym_decltype] = ACTIONS(2954),
    [sym_virtual] = ACTIONS(2954),
    [anon_sym_explicit] = ACTIONS(2954),
    [anon_sym_typename] = ACTIONS(2954),
    [anon_sym_template] = ACTIONS(2954),
    [anon_sym_operator] = ACTIONS(2954),
    [anon_sym_try] = ACTIONS(2954),
    [anon_sym_delete] = ACTIONS(2954),
    [anon_sym_throw] = ACTIONS(2954),
    [anon_sym_namespace] = ACTIONS(2954),
    [anon_sym_using] = ACTIONS(2954),
    [anon_sym_static_assert] = ACTIONS(2954),
    [anon_sym_concept] = ACTIONS(2954),
    [anon_sym_co_return] = ACTIONS(2954),
    [anon_sym_co_yield] = ACTIONS(2954),
    [anon_sym_R_DQUOTE] = ACTIONS(2956),
    [anon_sym_LR_DQUOTE] = ACTIONS(2956),
    [anon_sym_uR_DQUOTE] = ACTIONS(2956),
    [anon_sym_UR_DQUOTE] = ACTIONS(2956),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2956),
    [anon_sym_co_await] = ACTIONS(2954),
    [anon_sym_new] = ACTIONS(2954),
    [anon_sym_requires] = ACTIONS(2954),
    [sym_this] = ACTIONS(2954),
    [anon_sym_discard] = ACTIONS(2954),
    [anon_sym_precise] = ACTIONS(2954),
    [anon_sym_shared] = ACTIONS(2954),
    [anon_sym_groupshared] = ACTIONS(2954),
    [anon_sym_uniform] = ACTIONS(2954),
    [anon_sym_row_major] = ACTIONS(2954),
    [anon_sym_column_major] = ACTIONS(2954),
    [anon_sym_globallycoherent] = ACTIONS(2954),
    [anon_sym_centroid] = ACTIONS(2954),
    [anon_sym_noperspective] = ACTIONS(2954),
    [anon_sym_nointerpolation] = ACTIONS(2954),
    [anon_sym_sample] = ACTIONS(2954),
    [anon_sym_linear] = ACTIONS(2954),
    [anon_sym_snorm] = ACTIONS(2954),
    [anon_sym_unorm] = ACTIONS(2954),
    [anon_sym_point] = ACTIONS(2954),
    [anon_sym_line] = ACTIONS(2954),
    [anon_sym_triangleadj] = ACTIONS(2954),
    [anon_sym_lineadj] = ACTIONS(2954),
    [anon_sym_triangle] = ACTIONS(2954),
    [anon_sym_cbuffer] = ACTIONS(2954),
    [anon_sym_interface] = ACTIONS(2954),
    [anon_sym_extension] = ACTIONS(2954),
  },
  [655] = {
    [sym_attribute_specifier] = STATE(426),
    [sym_enumerator_list] = STATE(982),
    [ts_builtin_sym_end] = ACTIONS(3713),
    [sym_identifier] = ACTIONS(3711),
    [aux_sym_preproc_include_token1] = ACTIONS(3711),
    [aux_sym_preproc_def_token1] = ACTIONS(3711),
    [aux_sym_preproc_if_token1] = ACTIONS(3711),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3711),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3711),
    [sym_preproc_directive] = ACTIONS(3711),
    [anon_sym_LPAREN2] = ACTIONS(3713),
    [anon_sym_BANG] = ACTIONS(3713),
    [anon_sym_TILDE] = ACTIONS(3713),
    [anon_sym_DASH] = ACTIONS(3711),
    [anon_sym_PLUS] = ACTIONS(3711),
    [anon_sym_STAR] = ACTIONS(3713),
    [anon_sym_AMP_AMP] = ACTIONS(3713),
    [anon_sym_AMP] = ACTIONS(3711),
    [anon_sym_SEMI] = ACTIONS(3713),
    [anon_sym___extension__] = ACTIONS(3711),
    [anon_sym_typedef] = ACTIONS(3711),
    [anon_sym_in] = ACTIONS(3711),
    [anon_sym_out] = ACTIONS(3711),
    [anon_sym_inout] = ACTIONS(3711),
    [anon_sym_extern] = ACTIONS(3711),
    [anon_sym___attribute__] = ACTIONS(2861),
    [anon_sym_COLON_COLON] = ACTIONS(3713),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3713),
    [anon_sym___declspec] = ACTIONS(3711),
    [anon_sym___based] = ACTIONS(3711),
    [anon_sym___cdecl] = ACTIONS(3711),
    [anon_sym___clrcall] = ACTIONS(3711),
    [anon_sym___stdcall] = ACTIONS(3711),
    [anon_sym___fastcall] = ACTIONS(3711),
    [anon_sym___thiscall] = ACTIONS(3711),
    [anon_sym___vectorcall] = ACTIONS(3711),
    [anon_sym_LBRACE] = ACTIONS(3709),
    [anon_sym_signed] = ACTIONS(3711),
    [anon_sym_unsigned] = ACTIONS(3711),
    [anon_sym_long] = ACTIONS(3711),
    [anon_sym_short] = ACTIONS(3711),
    [anon_sym_LBRACK] = ACTIONS(3711),
    [anon_sym_static] = ACTIONS(3711),
    [anon_sym_register] = ACTIONS(3711),
    [anon_sym_inline] = ACTIONS(3711),
    [anon_sym___inline] = ACTIONS(3711),
    [anon_sym___inline__] = ACTIONS(3711),
    [anon_sym___forceinline] = ACTIONS(3711),
    [anon_sym_thread_local] = ACTIONS(3711),
    [anon_sym___thread] = ACTIONS(3711),
    [anon_sym_const] = ACTIONS(3711),
    [anon_sym_constexpr] = ACTIONS(3711),
    [anon_sym_volatile] = ACTIONS(3711),
    [anon_sym_restrict] = ACTIONS(3711),
    [anon_sym___restrict__] = ACTIONS(3711),
    [anon_sym__Atomic] = ACTIONS(3711),
    [anon_sym__Noreturn] = ACTIONS(3711),
    [anon_sym_noreturn] = ACTIONS(3711),
    [anon_sym_mutable] = ACTIONS(3711),
    [anon_sym_constinit] = ACTIONS(3711),
    [anon_sym_consteval] = ACTIONS(3711),
    [anon_sym_alignas] = ACTIONS(3711),
    [anon_sym__Alignas] = ACTIONS(3711),
    [sym_primitive_type] = ACTIONS(3711),
    [anon_sym_enum] = ACTIONS(3711),
    [anon_sym_class] = ACTIONS(3711),
    [anon_sym_struct] = ACTIONS(3711),
    [anon_sym_union] = ACTIONS(3711),
    [anon_sym_if] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3711),
    [anon_sym_case] = ACTIONS(3711),
    [anon_sym_default] = ACTIONS(3711),
    [anon_sym_while] = ACTIONS(3711),
    [anon_sym_do] = ACTIONS(3711),
    [anon_sym_for] = ACTIONS(3711),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_break] = ACTIONS(3711),
    [anon_sym_continue] = ACTIONS(3711),
    [anon_sym_goto] = ACTIONS(3711),
    [anon_sym_not] = ACTIONS(3711),
    [anon_sym_compl] = ACTIONS(3711),
    [anon_sym_DASH_DASH] = ACTIONS(3713),
    [anon_sym_PLUS_PLUS] = ACTIONS(3713),
    [anon_sym_sizeof] = ACTIONS(3711),
    [anon_sym___alignof__] = ACTIONS(3711),
    [anon_sym___alignof] = ACTIONS(3711),
    [anon_sym__alignof] = ACTIONS(3711),
    [anon_sym_alignof] = ACTIONS(3711),
    [anon_sym__Alignof] = ACTIONS(3711),
    [anon_sym_offsetof] = ACTIONS(3711),
    [anon_sym__Generic] = ACTIONS(3711),
    [anon_sym_asm] = ACTIONS(3711),
    [anon_sym___asm__] = ACTIONS(3711),
    [anon_sym_DOT] = ACTIONS(3711),
    [sym_number_literal] = ACTIONS(3713),
    [anon_sym_L_SQUOTE] = ACTIONS(3713),
    [anon_sym_u_SQUOTE] = ACTIONS(3713),
    [anon_sym_U_SQUOTE] = ACTIONS(3713),
    [anon_sym_u8_SQUOTE] = ACTIONS(3713),
    [anon_sym_SQUOTE] = ACTIONS(3713),
    [anon_sym_L_DQUOTE] = ACTIONS(3713),
    [anon_sym_u_DQUOTE] = ACTIONS(3713),
    [anon_sym_U_DQUOTE] = ACTIONS(3713),
    [anon_sym_u8_DQUOTE] = ACTIONS(3713),
    [anon_sym_DQUOTE] = ACTIONS(3713),
    [sym_true] = ACTIONS(3711),
    [sym_false] = ACTIONS(3711),
    [anon_sym_NULL] = ACTIONS(3711),
    [anon_sym_nullptr] = ACTIONS(3711),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_This] = ACTIONS(3711),
    [anon_sym_decltype] = ACTIONS(3711),
    [sym_virtual] = ACTIONS(3711),
    [anon_sym_explicit] = ACTIONS(3711),
    [anon_sym_typename] = ACTIONS(3711),
    [anon_sym_template] = ACTIONS(3711),
    [anon_sym_operator] = ACTIONS(3711),
    [anon_sym_try] = ACTIONS(3711),
    [anon_sym_delete] = ACTIONS(3711),
    [anon_sym_throw] = ACTIONS(3711),
    [anon_sym_namespace] = ACTIONS(3711),
    [anon_sym_using] = ACTIONS(3711),
    [anon_sym_static_assert] = ACTIONS(3711),
    [anon_sym_concept] = ACTIONS(3711),
    [anon_sym_co_return] = ACTIONS(3711),
    [anon_sym_co_yield] = ACTIONS(3711),
    [anon_sym_R_DQUOTE] = ACTIONS(3713),
    [anon_sym_LR_DQUOTE] = ACTIONS(3713),
    [anon_sym_uR_DQUOTE] = ACTIONS(3713),
    [anon_sym_UR_DQUOTE] = ACTIONS(3713),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3713),
    [anon_sym_co_await] = ACTIONS(3711),
    [anon_sym_new] = ACTIONS(3711),
    [anon_sym_requires] = ACTIONS(3711),
    [sym_this] = ACTIONS(3711),
    [anon_sym_precise] = ACTIONS(3711),
    [anon_sym_shared] = ACTIONS(3711),
    [anon_sym_groupshared] = ACTIONS(3711),
    [anon_sym_uniform] = ACTIONS(3711),
    [anon_sym_row_major] = ACTIONS(3711),
    [anon_sym_column_major] = ACTIONS(3711),
    [anon_sym_globallycoherent] = ACTIONS(3711),
    [anon_sym_centroid] = ACTIONS(3711),
    [anon_sym_noperspective] = ACTIONS(3711),
    [anon_sym_nointerpolation] = ACTIONS(3711),
    [anon_sym_sample] = ACTIONS(3711),
    [anon_sym_linear] = ACTIONS(3711),
    [anon_sym_snorm] = ACTIONS(3711),
    [anon_sym_unorm] = ACTIONS(3711),
    [anon_sym_point] = ACTIONS(3711),
    [anon_sym_line] = ACTIONS(3711),
    [anon_sym_triangleadj] = ACTIONS(3711),
    [anon_sym_lineadj] = ACTIONS(3711),
    [anon_sym_triangle] = ACTIONS(3711),
    [anon_sym_interface] = ACTIONS(3711),
    [anon_sym_extension] = ACTIONS(3711),
    [anon_sym___exported] = ACTIONS(3711),
    [anon_sym_import] = ACTIONS(3711),
  },
  [656] = {
    [sym_identifier] = ACTIONS(3222),
    [aux_sym_preproc_include_token1] = ACTIONS(3222),
    [aux_sym_preproc_def_token1] = ACTIONS(3222),
    [aux_sym_preproc_if_token1] = ACTIONS(3222),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3222),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3222),
    [sym_preproc_directive] = ACTIONS(3222),
    [anon_sym_LPAREN2] = ACTIONS(3224),
    [anon_sym_BANG] = ACTIONS(3224),
    [anon_sym_TILDE] = ACTIONS(3224),
    [anon_sym_DASH] = ACTIONS(3222),
    [anon_sym_PLUS] = ACTIONS(3222),
    [anon_sym_STAR] = ACTIONS(3224),
    [anon_sym_AMP_AMP] = ACTIONS(3224),
    [anon_sym_AMP] = ACTIONS(3222),
    [anon_sym_SEMI] = ACTIONS(3224),
    [anon_sym___extension__] = ACTIONS(3222),
    [anon_sym_typedef] = ACTIONS(3222),
    [anon_sym_in] = ACTIONS(3222),
    [anon_sym_out] = ACTIONS(3222),
    [anon_sym_inout] = ACTIONS(3222),
    [anon_sym_extern] = ACTIONS(3222),
    [anon_sym___attribute__] = ACTIONS(3222),
    [anon_sym_COLON_COLON] = ACTIONS(3224),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3224),
    [anon_sym___declspec] = ACTIONS(3222),
    [anon_sym___based] = ACTIONS(3222),
    [anon_sym___cdecl] = ACTIONS(3222),
    [anon_sym___clrcall] = ACTIONS(3222),
    [anon_sym___stdcall] = ACTIONS(3222),
    [anon_sym___fastcall] = ACTIONS(3222),
    [anon_sym___thiscall] = ACTIONS(3222),
    [anon_sym___vectorcall] = ACTIONS(3222),
    [anon_sym_LBRACE] = ACTIONS(3224),
    [anon_sym_RBRACE] = ACTIONS(3224),
    [anon_sym_signed] = ACTIONS(3222),
    [anon_sym_unsigned] = ACTIONS(3222),
    [anon_sym_long] = ACTIONS(3222),
    [anon_sym_short] = ACTIONS(3222),
    [anon_sym_LBRACK] = ACTIONS(3222),
    [anon_sym_static] = ACTIONS(3222),
    [anon_sym_register] = ACTIONS(3222),
    [anon_sym_inline] = ACTIONS(3222),
    [anon_sym___inline] = ACTIONS(3222),
    [anon_sym___inline__] = ACTIONS(3222),
    [anon_sym___forceinline] = ACTIONS(3222),
    [anon_sym_thread_local] = ACTIONS(3222),
    [anon_sym___thread] = ACTIONS(3222),
    [anon_sym_const] = ACTIONS(3222),
    [anon_sym_constexpr] = ACTIONS(3222),
    [anon_sym_volatile] = ACTIONS(3222),
    [anon_sym_restrict] = ACTIONS(3222),
    [anon_sym___restrict__] = ACTIONS(3222),
    [anon_sym__Atomic] = ACTIONS(3222),
    [anon_sym__Noreturn] = ACTIONS(3222),
    [anon_sym_noreturn] = ACTIONS(3222),
    [anon_sym_mutable] = ACTIONS(3222),
    [anon_sym_constinit] = ACTIONS(3222),
    [anon_sym_consteval] = ACTIONS(3222),
    [anon_sym_alignas] = ACTIONS(3222),
    [anon_sym__Alignas] = ACTIONS(3222),
    [sym_primitive_type] = ACTIONS(3222),
    [anon_sym_enum] = ACTIONS(3222),
    [anon_sym_class] = ACTIONS(3222),
    [anon_sym_struct] = ACTIONS(3222),
    [anon_sym_union] = ACTIONS(3222),
    [anon_sym_if] = ACTIONS(3222),
    [anon_sym_else] = ACTIONS(3222),
    [anon_sym_switch] = ACTIONS(3222),
    [anon_sym_case] = ACTIONS(3222),
    [anon_sym_default] = ACTIONS(3222),
    [anon_sym_while] = ACTIONS(3222),
    [anon_sym_do] = ACTIONS(3222),
    [anon_sym_for] = ACTIONS(3222),
    [anon_sym_return] = ACTIONS(3222),
    [anon_sym_break] = ACTIONS(3222),
    [anon_sym_continue] = ACTIONS(3222),
    [anon_sym_goto] = ACTIONS(3222),
    [anon_sym___try] = ACTIONS(3222),
    [anon_sym___leave] = ACTIONS(3222),
    [anon_sym_not] = ACTIONS(3222),
    [anon_sym_compl] = ACTIONS(3222),
    [anon_sym_DASH_DASH] = ACTIONS(3224),
    [anon_sym_PLUS_PLUS] = ACTIONS(3224),
    [anon_sym_sizeof] = ACTIONS(3222),
    [anon_sym___alignof__] = ACTIONS(3222),
    [anon_sym___alignof] = ACTIONS(3222),
    [anon_sym__alignof] = ACTIONS(3222),
    [anon_sym_alignof] = ACTIONS(3222),
    [anon_sym__Alignof] = ACTIONS(3222),
    [anon_sym_offsetof] = ACTIONS(3222),
    [anon_sym__Generic] = ACTIONS(3222),
    [anon_sym_asm] = ACTIONS(3222),
    [anon_sym___asm__] = ACTIONS(3222),
    [sym_number_literal] = ACTIONS(3224),
    [anon_sym_L_SQUOTE] = ACTIONS(3224),
    [anon_sym_u_SQUOTE] = ACTIONS(3224),
    [anon_sym_U_SQUOTE] = ACTIONS(3224),
    [anon_sym_u8_SQUOTE] = ACTIONS(3224),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_L_DQUOTE] = ACTIONS(3224),
    [anon_sym_u_DQUOTE] = ACTIONS(3224),
    [anon_sym_U_DQUOTE] = ACTIONS(3224),
    [anon_sym_u8_DQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3224),
    [sym_true] = ACTIONS(3222),
    [sym_false] = ACTIONS(3222),
    [anon_sym_NULL] = ACTIONS(3222),
    [anon_sym_nullptr] = ACTIONS(3222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3222),
    [anon_sym_let] = ACTIONS(3222),
    [anon_sym_This] = ACTIONS(3222),
    [anon_sym_decltype] = ACTIONS(3222),
    [sym_virtual] = ACTIONS(3222),
    [anon_sym_explicit] = ACTIONS(3222),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3222),
    [anon_sym_operator] = ACTIONS(3222),
    [anon_sym_try] = ACTIONS(3222),
    [anon_sym_delete] = ACTIONS(3222),
    [anon_sym_throw] = ACTIONS(3222),
    [anon_sym_namespace] = ACTIONS(3222),
    [anon_sym_using] = ACTIONS(3222),
    [anon_sym_static_assert] = ACTIONS(3222),
    [anon_sym_concept] = ACTIONS(3222),
    [anon_sym_co_return] = ACTIONS(3222),
    [anon_sym_co_yield] = ACTIONS(3222),
    [anon_sym_R_DQUOTE] = ACTIONS(3224),
    [anon_sym_LR_DQUOTE] = ACTIONS(3224),
    [anon_sym_uR_DQUOTE] = ACTIONS(3224),
    [anon_sym_UR_DQUOTE] = ACTIONS(3224),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3224),
    [anon_sym_co_await] = ACTIONS(3222),
    [anon_sym_new] = ACTIONS(3222),
    [anon_sym_requires] = ACTIONS(3222),
    [sym_this] = ACTIONS(3222),
    [anon_sym_discard] = ACTIONS(3222),
    [anon_sym_precise] = ACTIONS(3222),
    [anon_sym_shared] = ACTIONS(3222),
    [anon_sym_groupshared] = ACTIONS(3222),
    [anon_sym_uniform] = ACTIONS(3222),
    [anon_sym_row_major] = ACTIONS(3222),
    [anon_sym_column_major] = ACTIONS(3222),
    [anon_sym_globallycoherent] = ACTIONS(3222),
    [anon_sym_centroid] = ACTIONS(3222),
    [anon_sym_noperspective] = ACTIONS(3222),
    [anon_sym_nointerpolation] = ACTIONS(3222),
    [anon_sym_sample] = ACTIONS(3222),
    [anon_sym_linear] = ACTIONS(3222),
    [anon_sym_snorm] = ACTIONS(3222),
    [anon_sym_unorm] = ACTIONS(3222),
    [anon_sym_point] = ACTIONS(3222),
    [anon_sym_line] = ACTIONS(3222),
    [anon_sym_triangleadj] = ACTIONS(3222),
    [anon_sym_lineadj] = ACTIONS(3222),
    [anon_sym_triangle] = ACTIONS(3222),
    [anon_sym_cbuffer] = ACTIONS(3222),
    [anon_sym_interface] = ACTIONS(3222),
    [anon_sym_extension] = ACTIONS(3222),
  },
  [657] = {
    [sym_identifier] = ACTIONS(3206),
    [aux_sym_preproc_include_token1] = ACTIONS(3206),
    [aux_sym_preproc_def_token1] = ACTIONS(3206),
    [aux_sym_preproc_if_token1] = ACTIONS(3206),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3206),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3206),
    [sym_preproc_directive] = ACTIONS(3206),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_BANG] = ACTIONS(3204),
    [anon_sym_TILDE] = ACTIONS(3204),
    [anon_sym_DASH] = ACTIONS(3206),
    [anon_sym_PLUS] = ACTIONS(3206),
    [anon_sym_STAR] = ACTIONS(3204),
    [anon_sym_AMP_AMP] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3206),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym___extension__] = ACTIONS(3206),
    [anon_sym_typedef] = ACTIONS(3206),
    [anon_sym_in] = ACTIONS(3206),
    [anon_sym_out] = ACTIONS(3206),
    [anon_sym_inout] = ACTIONS(3206),
    [anon_sym_extern] = ACTIONS(3206),
    [anon_sym___attribute__] = ACTIONS(3206),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3204),
    [anon_sym___declspec] = ACTIONS(3206),
    [anon_sym___based] = ACTIONS(3206),
    [anon_sym___cdecl] = ACTIONS(3206),
    [anon_sym___clrcall] = ACTIONS(3206),
    [anon_sym___stdcall] = ACTIONS(3206),
    [anon_sym___fastcall] = ACTIONS(3206),
    [anon_sym___thiscall] = ACTIONS(3206),
    [anon_sym___vectorcall] = ACTIONS(3206),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_RBRACE] = ACTIONS(3204),
    [anon_sym_signed] = ACTIONS(3206),
    [anon_sym_unsigned] = ACTIONS(3206),
    [anon_sym_long] = ACTIONS(3206),
    [anon_sym_short] = ACTIONS(3206),
    [anon_sym_LBRACK] = ACTIONS(3206),
    [anon_sym_static] = ACTIONS(3206),
    [anon_sym_register] = ACTIONS(3206),
    [anon_sym_inline] = ACTIONS(3206),
    [anon_sym___inline] = ACTIONS(3206),
    [anon_sym___inline__] = ACTIONS(3206),
    [anon_sym___forceinline] = ACTIONS(3206),
    [anon_sym_thread_local] = ACTIONS(3206),
    [anon_sym___thread] = ACTIONS(3206),
    [anon_sym_const] = ACTIONS(3206),
    [anon_sym_constexpr] = ACTIONS(3206),
    [anon_sym_volatile] = ACTIONS(3206),
    [anon_sym_restrict] = ACTIONS(3206),
    [anon_sym___restrict__] = ACTIONS(3206),
    [anon_sym__Atomic] = ACTIONS(3206),
    [anon_sym__Noreturn] = ACTIONS(3206),
    [anon_sym_noreturn] = ACTIONS(3206),
    [anon_sym_mutable] = ACTIONS(3206),
    [anon_sym_constinit] = ACTIONS(3206),
    [anon_sym_consteval] = ACTIONS(3206),
    [anon_sym_alignas] = ACTIONS(3206),
    [anon_sym__Alignas] = ACTIONS(3206),
    [sym_primitive_type] = ACTIONS(3206),
    [anon_sym_enum] = ACTIONS(3206),
    [anon_sym_class] = ACTIONS(3206),
    [anon_sym_struct] = ACTIONS(3206),
    [anon_sym_union] = ACTIONS(3206),
    [anon_sym_if] = ACTIONS(3206),
    [anon_sym_switch] = ACTIONS(3206),
    [anon_sym_case] = ACTIONS(3206),
    [anon_sym_default] = ACTIONS(3206),
    [anon_sym_while] = ACTIONS(3206),
    [anon_sym_do] = ACTIONS(3206),
    [anon_sym_for] = ACTIONS(3206),
    [anon_sym_return] = ACTIONS(3206),
    [anon_sym_break] = ACTIONS(3206),
    [anon_sym_continue] = ACTIONS(3206),
    [anon_sym_goto] = ACTIONS(3206),
    [anon_sym___try] = ACTIONS(3206),
    [anon_sym___leave] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3206),
    [anon_sym_compl] = ACTIONS(3206),
    [anon_sym_DASH_DASH] = ACTIONS(3204),
    [anon_sym_PLUS_PLUS] = ACTIONS(3204),
    [anon_sym_sizeof] = ACTIONS(3206),
    [anon_sym___alignof__] = ACTIONS(3206),
    [anon_sym___alignof] = ACTIONS(3206),
    [anon_sym__alignof] = ACTIONS(3206),
    [anon_sym_alignof] = ACTIONS(3206),
    [anon_sym__Alignof] = ACTIONS(3206),
    [anon_sym_offsetof] = ACTIONS(3206),
    [anon_sym__Generic] = ACTIONS(3206),
    [anon_sym_asm] = ACTIONS(3206),
    [anon_sym___asm__] = ACTIONS(3206),
    [anon_sym_DOT] = ACTIONS(3206),
    [sym_number_literal] = ACTIONS(3204),
    [anon_sym_L_SQUOTE] = ACTIONS(3204),
    [anon_sym_u_SQUOTE] = ACTIONS(3204),
    [anon_sym_U_SQUOTE] = ACTIONS(3204),
    [anon_sym_u8_SQUOTE] = ACTIONS(3204),
    [anon_sym_SQUOTE] = ACTIONS(3204),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_true] = ACTIONS(3206),
    [sym_false] = ACTIONS(3206),
    [anon_sym_NULL] = ACTIONS(3206),
    [anon_sym_nullptr] = ACTIONS(3206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3206),
    [anon_sym_let] = ACTIONS(3206),
    [anon_sym_This] = ACTIONS(3206),
    [anon_sym_decltype] = ACTIONS(3206),
    [sym_virtual] = ACTIONS(3206),
    [anon_sym_explicit] = ACTIONS(3206),
    [anon_sym_typename] = ACTIONS(3206),
    [anon_sym_template] = ACTIONS(3206),
    [anon_sym_operator] = ACTIONS(3206),
    [anon_sym_try] = ACTIONS(3206),
    [anon_sym_delete] = ACTIONS(3206),
    [anon_sym_throw] = ACTIONS(3206),
    [anon_sym_namespace] = ACTIONS(3206),
    [anon_sym_using] = ACTIONS(3206),
    [anon_sym_static_assert] = ACTIONS(3206),
    [anon_sym_concept] = ACTIONS(3206),
    [anon_sym_co_return] = ACTIONS(3206),
    [anon_sym_co_yield] = ACTIONS(3206),
    [anon_sym_R_DQUOTE] = ACTIONS(3204),
    [anon_sym_LR_DQUOTE] = ACTIONS(3204),
    [anon_sym_uR_DQUOTE] = ACTIONS(3204),
    [anon_sym_UR_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3204),
    [anon_sym_co_await] = ACTIONS(3206),
    [anon_sym_new] = ACTIONS(3206),
    [anon_sym_requires] = ACTIONS(3206),
    [sym_this] = ACTIONS(3206),
    [anon_sym_discard] = ACTIONS(3206),
    [anon_sym_precise] = ACTIONS(3206),
    [anon_sym_shared] = ACTIONS(3206),
    [anon_sym_groupshared] = ACTIONS(3206),
    [anon_sym_uniform] = ACTIONS(3206),
    [anon_sym_row_major] = ACTIONS(3206),
    [anon_sym_column_major] = ACTIONS(3206),
    [anon_sym_globallycoherent] = ACTIONS(3206),
    [anon_sym_centroid] = ACTIONS(3206),
    [anon_sym_noperspective] = ACTIONS(3206),
    [anon_sym_nointerpolation] = ACTIONS(3206),
    [anon_sym_sample] = ACTIONS(3206),
    [anon_sym_linear] = ACTIONS(3206),
    [anon_sym_snorm] = ACTIONS(3206),
    [anon_sym_unorm] = ACTIONS(3206),
    [anon_sym_point] = ACTIONS(3206),
    [anon_sym_line] = ACTIONS(3206),
    [anon_sym_triangleadj] = ACTIONS(3206),
    [anon_sym_lineadj] = ACTIONS(3206),
    [anon_sym_triangle] = ACTIONS(3206),
    [anon_sym_cbuffer] = ACTIONS(3206),
    [anon_sym_interface] = ACTIONS(3206),
    [anon_sym_extension] = ACTIONS(3206),
  },
  [658] = {
    [sym_identifier] = ACTIONS(3172),
    [aux_sym_preproc_include_token1] = ACTIONS(3172),
    [aux_sym_preproc_def_token1] = ACTIONS(3172),
    [aux_sym_preproc_if_token1] = ACTIONS(3172),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3172),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3172),
    [sym_preproc_directive] = ACTIONS(3172),
    [anon_sym_LPAREN2] = ACTIONS(3170),
    [anon_sym_BANG] = ACTIONS(3170),
    [anon_sym_TILDE] = ACTIONS(3170),
    [anon_sym_DASH] = ACTIONS(3172),
    [anon_sym_PLUS] = ACTIONS(3172),
    [anon_sym_STAR] = ACTIONS(3170),
    [anon_sym_AMP_AMP] = ACTIONS(3170),
    [anon_sym_AMP] = ACTIONS(3172),
    [anon_sym_SEMI] = ACTIONS(3170),
    [anon_sym___extension__] = ACTIONS(3172),
    [anon_sym_typedef] = ACTIONS(3172),
    [anon_sym_in] = ACTIONS(3172),
    [anon_sym_out] = ACTIONS(3172),
    [anon_sym_inout] = ACTIONS(3172),
    [anon_sym_extern] = ACTIONS(3172),
    [anon_sym___attribute__] = ACTIONS(3172),
    [anon_sym_COLON_COLON] = ACTIONS(3170),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3170),
    [anon_sym___declspec] = ACTIONS(3172),
    [anon_sym___based] = ACTIONS(3172),
    [anon_sym___cdecl] = ACTIONS(3172),
    [anon_sym___clrcall] = ACTIONS(3172),
    [anon_sym___stdcall] = ACTIONS(3172),
    [anon_sym___fastcall] = ACTIONS(3172),
    [anon_sym___thiscall] = ACTIONS(3172),
    [anon_sym___vectorcall] = ACTIONS(3172),
    [anon_sym_LBRACE] = ACTIONS(3170),
    [anon_sym_RBRACE] = ACTIONS(3170),
    [anon_sym_signed] = ACTIONS(3172),
    [anon_sym_unsigned] = ACTIONS(3172),
    [anon_sym_long] = ACTIONS(3172),
    [anon_sym_short] = ACTIONS(3172),
    [anon_sym_LBRACK] = ACTIONS(3172),
    [anon_sym_static] = ACTIONS(3172),
    [anon_sym_register] = ACTIONS(3172),
    [anon_sym_inline] = ACTIONS(3172),
    [anon_sym___inline] = ACTIONS(3172),
    [anon_sym___inline__] = ACTIONS(3172),
    [anon_sym___forceinline] = ACTIONS(3172),
    [anon_sym_thread_local] = ACTIONS(3172),
    [anon_sym___thread] = ACTIONS(3172),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_constexpr] = ACTIONS(3172),
    [anon_sym_volatile] = ACTIONS(3172),
    [anon_sym_restrict] = ACTIONS(3172),
    [anon_sym___restrict__] = ACTIONS(3172),
    [anon_sym__Atomic] = ACTIONS(3172),
    [anon_sym__Noreturn] = ACTIONS(3172),
    [anon_sym_noreturn] = ACTIONS(3172),
    [anon_sym_mutable] = ACTIONS(3172),
    [anon_sym_constinit] = ACTIONS(3172),
    [anon_sym_consteval] = ACTIONS(3172),
    [anon_sym_alignas] = ACTIONS(3172),
    [anon_sym__Alignas] = ACTIONS(3172),
    [sym_primitive_type] = ACTIONS(3172),
    [anon_sym_enum] = ACTIONS(3172),
    [anon_sym_class] = ACTIONS(3172),
    [anon_sym_struct] = ACTIONS(3172),
    [anon_sym_union] = ACTIONS(3172),
    [anon_sym_if] = ACTIONS(3172),
    [anon_sym_switch] = ACTIONS(3172),
    [anon_sym_case] = ACTIONS(3172),
    [anon_sym_default] = ACTIONS(3172),
    [anon_sym_while] = ACTIONS(3172),
    [anon_sym_do] = ACTIONS(3172),
    [anon_sym_for] = ACTIONS(3172),
    [anon_sym_return] = ACTIONS(3172),
    [anon_sym_break] = ACTIONS(3172),
    [anon_sym_continue] = ACTIONS(3172),
    [anon_sym_goto] = ACTIONS(3172),
    [anon_sym___try] = ACTIONS(3172),
    [anon_sym___leave] = ACTIONS(3172),
    [anon_sym_not] = ACTIONS(3172),
    [anon_sym_compl] = ACTIONS(3172),
    [anon_sym_DASH_DASH] = ACTIONS(3170),
    [anon_sym_PLUS_PLUS] = ACTIONS(3170),
    [anon_sym_sizeof] = ACTIONS(3172),
    [anon_sym___alignof__] = ACTIONS(3172),
    [anon_sym___alignof] = ACTIONS(3172),
    [anon_sym__alignof] = ACTIONS(3172),
    [anon_sym_alignof] = ACTIONS(3172),
    [anon_sym__Alignof] = ACTIONS(3172),
    [anon_sym_offsetof] = ACTIONS(3172),
    [anon_sym__Generic] = ACTIONS(3172),
    [anon_sym_asm] = ACTIONS(3172),
    [anon_sym___asm__] = ACTIONS(3172),
    [anon_sym_DOT] = ACTIONS(3172),
    [sym_number_literal] = ACTIONS(3170),
    [anon_sym_L_SQUOTE] = ACTIONS(3170),
    [anon_sym_u_SQUOTE] = ACTIONS(3170),
    [anon_sym_U_SQUOTE] = ACTIONS(3170),
    [anon_sym_u8_SQUOTE] = ACTIONS(3170),
    [anon_sym_SQUOTE] = ACTIONS(3170),
    [anon_sym_L_DQUOTE] = ACTIONS(3170),
    [anon_sym_u_DQUOTE] = ACTIONS(3170),
    [anon_sym_U_DQUOTE] = ACTIONS(3170),
    [anon_sym_u8_DQUOTE] = ACTIONS(3170),
    [anon_sym_DQUOTE] = ACTIONS(3170),
    [sym_true] = ACTIONS(3172),
    [sym_false] = ACTIONS(3172),
    [anon_sym_NULL] = ACTIONS(3172),
    [anon_sym_nullptr] = ACTIONS(3172),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3172),
    [anon_sym_let] = ACTIONS(3172),
    [anon_sym_This] = ACTIONS(3172),
    [anon_sym_decltype] = ACTIONS(3172),
    [sym_virtual] = ACTIONS(3172),
    [anon_sym_explicit] = ACTIONS(3172),
    [anon_sym_typename] = ACTIONS(3172),
    [anon_sym_template] = ACTIONS(3172),
    [anon_sym_operator] = ACTIONS(3172),
    [anon_sym_try] = ACTIONS(3172),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_throw] = ACTIONS(3172),
    [anon_sym_namespace] = ACTIONS(3172),
    [anon_sym_using] = ACTIONS(3172),
    [anon_sym_static_assert] = ACTIONS(3172),
    [anon_sym_concept] = ACTIONS(3172),
    [anon_sym_co_return] = ACTIONS(3172),
    [anon_sym_co_yield] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3170),
    [anon_sym_LR_DQUOTE] = ACTIONS(3170),
    [anon_sym_uR_DQUOTE] = ACTIONS(3170),
    [anon_sym_UR_DQUOTE] = ACTIONS(3170),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3170),
    [anon_sym_co_await] = ACTIONS(3172),
    [anon_sym_new] = ACTIONS(3172),
    [anon_sym_requires] = ACTIONS(3172),
    [sym_this] = ACTIONS(3172),
    [anon_sym_discard] = ACTIONS(3172),
    [anon_sym_precise] = ACTIONS(3172),
    [anon_sym_shared] = ACTIONS(3172),
    [anon_sym_groupshared] = ACTIONS(3172),
    [anon_sym_uniform] = ACTIONS(3172),
    [anon_sym_row_major] = ACTIONS(3172),
    [anon_sym_column_major] = ACTIONS(3172),
    [anon_sym_globallycoherent] = ACTIONS(3172),
    [anon_sym_centroid] = ACTIONS(3172),
    [anon_sym_noperspective] = ACTIONS(3172),
    [anon_sym_nointerpolation] = ACTIONS(3172),
    [anon_sym_sample] = ACTIONS(3172),
    [anon_sym_linear] = ACTIONS(3172),
    [anon_sym_snorm] = ACTIONS(3172),
    [anon_sym_unorm] = ACTIONS(3172),
    [anon_sym_point] = ACTIONS(3172),
    [anon_sym_line] = ACTIONS(3172),
    [anon_sym_triangleadj] = ACTIONS(3172),
    [anon_sym_lineadj] = ACTIONS(3172),
    [anon_sym_triangle] = ACTIONS(3172),
    [anon_sym_cbuffer] = ACTIONS(3172),
    [anon_sym_interface] = ACTIONS(3172),
    [anon_sym_extension] = ACTIONS(3172),
  },
  [659] = {
    [sym_identifier] = ACTIONS(3340),
    [aux_sym_preproc_include_token1] = ACTIONS(3340),
    [aux_sym_preproc_def_token1] = ACTIONS(3340),
    [aux_sym_preproc_if_token1] = ACTIONS(3340),
    [aux_sym_preproc_if_token2] = ACTIONS(3340),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3340),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3340),
    [sym_preproc_directive] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(3342),
    [anon_sym_BANG] = ACTIONS(3342),
    [anon_sym_TILDE] = ACTIONS(3342),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_STAR] = ACTIONS(3342),
    [anon_sym_AMP_AMP] = ACTIONS(3342),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_SEMI] = ACTIONS(3342),
    [anon_sym___extension__] = ACTIONS(3340),
    [anon_sym_typedef] = ACTIONS(3340),
    [anon_sym_in] = ACTIONS(3340),
    [anon_sym_out] = ACTIONS(3340),
    [anon_sym_inout] = ACTIONS(3340),
    [anon_sym_extern] = ACTIONS(3340),
    [anon_sym___attribute__] = ACTIONS(3340),
    [anon_sym_COLON_COLON] = ACTIONS(3342),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3342),
    [anon_sym___declspec] = ACTIONS(3340),
    [anon_sym___based] = ACTIONS(3340),
    [anon_sym___cdecl] = ACTIONS(3340),
    [anon_sym___clrcall] = ACTIONS(3340),
    [anon_sym___stdcall] = ACTIONS(3340),
    [anon_sym___fastcall] = ACTIONS(3340),
    [anon_sym___thiscall] = ACTIONS(3340),
    [anon_sym___vectorcall] = ACTIONS(3340),
    [anon_sym_LBRACE] = ACTIONS(3342),
    [anon_sym_signed] = ACTIONS(3340),
    [anon_sym_unsigned] = ACTIONS(3340),
    [anon_sym_long] = ACTIONS(3340),
    [anon_sym_short] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3340),
    [anon_sym_static] = ACTIONS(3340),
    [anon_sym_register] = ACTIONS(3340),
    [anon_sym_inline] = ACTIONS(3340),
    [anon_sym___inline] = ACTIONS(3340),
    [anon_sym___inline__] = ACTIONS(3340),
    [anon_sym___forceinline] = ACTIONS(3340),
    [anon_sym_thread_local] = ACTIONS(3340),
    [anon_sym___thread] = ACTIONS(3340),
    [anon_sym_const] = ACTIONS(3340),
    [anon_sym_constexpr] = ACTIONS(3340),
    [anon_sym_volatile] = ACTIONS(3340),
    [anon_sym_restrict] = ACTIONS(3340),
    [anon_sym___restrict__] = ACTIONS(3340),
    [anon_sym__Atomic] = ACTIONS(3340),
    [anon_sym__Noreturn] = ACTIONS(3340),
    [anon_sym_noreturn] = ACTIONS(3340),
    [anon_sym_mutable] = ACTIONS(3340),
    [anon_sym_constinit] = ACTIONS(3340),
    [anon_sym_consteval] = ACTIONS(3340),
    [anon_sym_alignas] = ACTIONS(3340),
    [anon_sym__Alignas] = ACTIONS(3340),
    [sym_primitive_type] = ACTIONS(3340),
    [anon_sym_enum] = ACTIONS(3340),
    [anon_sym_class] = ACTIONS(3340),
    [anon_sym_struct] = ACTIONS(3340),
    [anon_sym_union] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_else] = ACTIONS(3340),
    [anon_sym_switch] = ACTIONS(3340),
    [anon_sym_case] = ACTIONS(3340),
    [anon_sym_default] = ACTIONS(3340),
    [anon_sym_while] = ACTIONS(3340),
    [anon_sym_do] = ACTIONS(3340),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_break] = ACTIONS(3340),
    [anon_sym_continue] = ACTIONS(3340),
    [anon_sym_goto] = ACTIONS(3340),
    [anon_sym___try] = ACTIONS(3340),
    [anon_sym___leave] = ACTIONS(3340),
    [anon_sym_not] = ACTIONS(3340),
    [anon_sym_compl] = ACTIONS(3340),
    [anon_sym_DASH_DASH] = ACTIONS(3342),
    [anon_sym_PLUS_PLUS] = ACTIONS(3342),
    [anon_sym_sizeof] = ACTIONS(3340),
    [anon_sym___alignof__] = ACTIONS(3340),
    [anon_sym___alignof] = ACTIONS(3340),
    [anon_sym__alignof] = ACTIONS(3340),
    [anon_sym_alignof] = ACTIONS(3340),
    [anon_sym__Alignof] = ACTIONS(3340),
    [anon_sym_offsetof] = ACTIONS(3340),
    [anon_sym__Generic] = ACTIONS(3340),
    [anon_sym_asm] = ACTIONS(3340),
    [anon_sym___asm__] = ACTIONS(3340),
    [sym_number_literal] = ACTIONS(3342),
    [anon_sym_L_SQUOTE] = ACTIONS(3342),
    [anon_sym_u_SQUOTE] = ACTIONS(3342),
    [anon_sym_U_SQUOTE] = ACTIONS(3342),
    [anon_sym_u8_SQUOTE] = ACTIONS(3342),
    [anon_sym_SQUOTE] = ACTIONS(3342),
    [anon_sym_L_DQUOTE] = ACTIONS(3342),
    [anon_sym_u_DQUOTE] = ACTIONS(3342),
    [anon_sym_U_DQUOTE] = ACTIONS(3342),
    [anon_sym_u8_DQUOTE] = ACTIONS(3342),
    [anon_sym_DQUOTE] = ACTIONS(3342),
    [sym_true] = ACTIONS(3340),
    [sym_false] = ACTIONS(3340),
    [anon_sym_NULL] = ACTIONS(3340),
    [anon_sym_nullptr] = ACTIONS(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3340),
    [anon_sym_let] = ACTIONS(3340),
    [anon_sym_This] = ACTIONS(3340),
    [anon_sym_decltype] = ACTIONS(3340),
    [sym_virtual] = ACTIONS(3340),
    [anon_sym_explicit] = ACTIONS(3340),
    [anon_sym_typename] = ACTIONS(3340),
    [anon_sym_template] = ACTIONS(3340),
    [anon_sym_operator] = ACTIONS(3340),
    [anon_sym_try] = ACTIONS(3340),
    [anon_sym_delete] = ACTIONS(3340),
    [anon_sym_throw] = ACTIONS(3340),
    [anon_sym_namespace] = ACTIONS(3340),
    [anon_sym_using] = ACTIONS(3340),
    [anon_sym_static_assert] = ACTIONS(3340),
    [anon_sym_concept] = ACTIONS(3340),
    [anon_sym_co_return] = ACTIONS(3340),
    [anon_sym_co_yield] = ACTIONS(3340),
    [anon_sym_R_DQUOTE] = ACTIONS(3342),
    [anon_sym_LR_DQUOTE] = ACTIONS(3342),
    [anon_sym_uR_DQUOTE] = ACTIONS(3342),
    [anon_sym_UR_DQUOTE] = ACTIONS(3342),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3342),
    [anon_sym_co_await] = ACTIONS(3340),
    [anon_sym_new] = ACTIONS(3340),
    [anon_sym_requires] = ACTIONS(3340),
    [sym_this] = ACTIONS(3340),
    [anon_sym_discard] = ACTIONS(3340),
    [anon_sym_precise] = ACTIONS(3340),
    [anon_sym_shared] = ACTIONS(3340),
    [anon_sym_groupshared] = ACTIONS(3340),
    [anon_sym_uniform] = ACTIONS(3340),
    [anon_sym_row_major] = ACTIONS(3340),
    [anon_sym_column_major] = ACTIONS(3340),
    [anon_sym_globallycoherent] = ACTIONS(3340),
    [anon_sym_centroid] = ACTIONS(3340),
    [anon_sym_noperspective] = ACTIONS(3340),
    [anon_sym_nointerpolation] = ACTIONS(3340),
    [anon_sym_sample] = ACTIONS(3340),
    [anon_sym_linear] = ACTIONS(3340),
    [anon_sym_snorm] = ACTIONS(3340),
    [anon_sym_unorm] = ACTIONS(3340),
    [anon_sym_point] = ACTIONS(3340),
    [anon_sym_line] = ACTIONS(3340),
    [anon_sym_triangleadj] = ACTIONS(3340),
    [anon_sym_lineadj] = ACTIONS(3340),
    [anon_sym_triangle] = ACTIONS(3340),
    [anon_sym_cbuffer] = ACTIONS(3340),
    [anon_sym_interface] = ACTIONS(3340),
    [anon_sym_extension] = ACTIONS(3340),
  },
  [660] = {
    [sym_identifier] = ACTIONS(3330),
    [aux_sym_preproc_include_token1] = ACTIONS(3330),
    [aux_sym_preproc_def_token1] = ACTIONS(3330),
    [aux_sym_preproc_if_token1] = ACTIONS(3330),
    [aux_sym_preproc_if_token2] = ACTIONS(3330),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3330),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3330),
    [sym_preproc_directive] = ACTIONS(3330),
    [anon_sym_LPAREN2] = ACTIONS(3332),
    [anon_sym_BANG] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3332),
    [anon_sym_DASH] = ACTIONS(3330),
    [anon_sym_PLUS] = ACTIONS(3330),
    [anon_sym_STAR] = ACTIONS(3332),
    [anon_sym_AMP_AMP] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(3330),
    [anon_sym_SEMI] = ACTIONS(3332),
    [anon_sym___extension__] = ACTIONS(3330),
    [anon_sym_typedef] = ACTIONS(3330),
    [anon_sym_in] = ACTIONS(3330),
    [anon_sym_out] = ACTIONS(3330),
    [anon_sym_inout] = ACTIONS(3330),
    [anon_sym_extern] = ACTIONS(3330),
    [anon_sym___attribute__] = ACTIONS(3330),
    [anon_sym_COLON_COLON] = ACTIONS(3332),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3332),
    [anon_sym___declspec] = ACTIONS(3330),
    [anon_sym___based] = ACTIONS(3330),
    [anon_sym___cdecl] = ACTIONS(3330),
    [anon_sym___clrcall] = ACTIONS(3330),
    [anon_sym___stdcall] = ACTIONS(3330),
    [anon_sym___fastcall] = ACTIONS(3330),
    [anon_sym___thiscall] = ACTIONS(3330),
    [anon_sym___vectorcall] = ACTIONS(3330),
    [anon_sym_LBRACE] = ACTIONS(3332),
    [anon_sym_signed] = ACTIONS(3330),
    [anon_sym_unsigned] = ACTIONS(3330),
    [anon_sym_long] = ACTIONS(3330),
    [anon_sym_short] = ACTIONS(3330),
    [anon_sym_LBRACK] = ACTIONS(3330),
    [anon_sym_static] = ACTIONS(3330),
    [anon_sym_register] = ACTIONS(3330),
    [anon_sym_inline] = ACTIONS(3330),
    [anon_sym___inline] = ACTIONS(3330),
    [anon_sym___inline__] = ACTIONS(3330),
    [anon_sym___forceinline] = ACTIONS(3330),
    [anon_sym_thread_local] = ACTIONS(3330),
    [anon_sym___thread] = ACTIONS(3330),
    [anon_sym_const] = ACTIONS(3330),
    [anon_sym_constexpr] = ACTIONS(3330),
    [anon_sym_volatile] = ACTIONS(3330),
    [anon_sym_restrict] = ACTIONS(3330),
    [anon_sym___restrict__] = ACTIONS(3330),
    [anon_sym__Atomic] = ACTIONS(3330),
    [anon_sym__Noreturn] = ACTIONS(3330),
    [anon_sym_noreturn] = ACTIONS(3330),
    [anon_sym_mutable] = ACTIONS(3330),
    [anon_sym_constinit] = ACTIONS(3330),
    [anon_sym_consteval] = ACTIONS(3330),
    [anon_sym_alignas] = ACTIONS(3330),
    [anon_sym__Alignas] = ACTIONS(3330),
    [sym_primitive_type] = ACTIONS(3330),
    [anon_sym_enum] = ACTIONS(3330),
    [anon_sym_class] = ACTIONS(3330),
    [anon_sym_struct] = ACTIONS(3330),
    [anon_sym_union] = ACTIONS(3330),
    [anon_sym_if] = ACTIONS(3330),
    [anon_sym_else] = ACTIONS(3330),
    [anon_sym_switch] = ACTIONS(3330),
    [anon_sym_case] = ACTIONS(3330),
    [anon_sym_default] = ACTIONS(3330),
    [anon_sym_while] = ACTIONS(3330),
    [anon_sym_do] = ACTIONS(3330),
    [anon_sym_for] = ACTIONS(3330),
    [anon_sym_return] = ACTIONS(3330),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_continue] = ACTIONS(3330),
    [anon_sym_goto] = ACTIONS(3330),
    [anon_sym___try] = ACTIONS(3330),
    [anon_sym___leave] = ACTIONS(3330),
    [anon_sym_not] = ACTIONS(3330),
    [anon_sym_compl] = ACTIONS(3330),
    [anon_sym_DASH_DASH] = ACTIONS(3332),
    [anon_sym_PLUS_PLUS] = ACTIONS(3332),
    [anon_sym_sizeof] = ACTIONS(3330),
    [anon_sym___alignof__] = ACTIONS(3330),
    [anon_sym___alignof] = ACTIONS(3330),
    [anon_sym__alignof] = ACTIONS(3330),
    [anon_sym_alignof] = ACTIONS(3330),
    [anon_sym__Alignof] = ACTIONS(3330),
    [anon_sym_offsetof] = ACTIONS(3330),
    [anon_sym__Generic] = ACTIONS(3330),
    [anon_sym_asm] = ACTIONS(3330),
    [anon_sym___asm__] = ACTIONS(3330),
    [sym_number_literal] = ACTIONS(3332),
    [anon_sym_L_SQUOTE] = ACTIONS(3332),
    [anon_sym_u_SQUOTE] = ACTIONS(3332),
    [anon_sym_U_SQUOTE] = ACTIONS(3332),
    [anon_sym_u8_SQUOTE] = ACTIONS(3332),
    [anon_sym_SQUOTE] = ACTIONS(3332),
    [anon_sym_L_DQUOTE] = ACTIONS(3332),
    [anon_sym_u_DQUOTE] = ACTIONS(3332),
    [anon_sym_U_DQUOTE] = ACTIONS(3332),
    [anon_sym_u8_DQUOTE] = ACTIONS(3332),
    [anon_sym_DQUOTE] = ACTIONS(3332),
    [sym_true] = ACTIONS(3330),
    [sym_false] = ACTIONS(3330),
    [anon_sym_NULL] = ACTIONS(3330),
    [anon_sym_nullptr] = ACTIONS(3330),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3330),
    [anon_sym_let] = ACTIONS(3330),
    [anon_sym_This] = ACTIONS(3330),
    [anon_sym_decltype] = ACTIONS(3330),
    [sym_virtual] = ACTIONS(3330),
    [anon_sym_explicit] = ACTIONS(3330),
    [anon_sym_typename] = ACTIONS(3330),
    [anon_sym_template] = ACTIONS(3330),
    [anon_sym_operator] = ACTIONS(3330),
    [anon_sym_try] = ACTIONS(3330),
    [anon_sym_delete] = ACTIONS(3330),
    [anon_sym_throw] = ACTIONS(3330),
    [anon_sym_namespace] = ACTIONS(3330),
    [anon_sym_using] = ACTIONS(3330),
    [anon_sym_static_assert] = ACTIONS(3330),
    [anon_sym_concept] = ACTIONS(3330),
    [anon_sym_co_return] = ACTIONS(3330),
    [anon_sym_co_yield] = ACTIONS(3330),
    [anon_sym_R_DQUOTE] = ACTIONS(3332),
    [anon_sym_LR_DQUOTE] = ACTIONS(3332),
    [anon_sym_uR_DQUOTE] = ACTIONS(3332),
    [anon_sym_UR_DQUOTE] = ACTIONS(3332),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3332),
    [anon_sym_co_await] = ACTIONS(3330),
    [anon_sym_new] = ACTIONS(3330),
    [anon_sym_requires] = ACTIONS(3330),
    [sym_this] = ACTIONS(3330),
    [anon_sym_discard] = ACTIONS(3330),
    [anon_sym_precise] = ACTIONS(3330),
    [anon_sym_shared] = ACTIONS(3330),
    [anon_sym_groupshared] = ACTIONS(3330),
    [anon_sym_uniform] = ACTIONS(3330),
    [anon_sym_row_major] = ACTIONS(3330),
    [anon_sym_column_major] = ACTIONS(3330),
    [anon_sym_globallycoherent] = ACTIONS(3330),
    [anon_sym_centroid] = ACTIONS(3330),
    [anon_sym_noperspective] = ACTIONS(3330),
    [anon_sym_nointerpolation] = ACTIONS(3330),
    [anon_sym_sample] = ACTIONS(3330),
    [anon_sym_linear] = ACTIONS(3330),
    [anon_sym_snorm] = ACTIONS(3330),
    [anon_sym_unorm] = ACTIONS(3330),
    [anon_sym_point] = ACTIONS(3330),
    [anon_sym_line] = ACTIONS(3330),
    [anon_sym_triangleadj] = ACTIONS(3330),
    [anon_sym_lineadj] = ACTIONS(3330),
    [anon_sym_triangle] = ACTIONS(3330),
    [anon_sym_cbuffer] = ACTIONS(3330),
    [anon_sym_interface] = ACTIONS(3330),
    [anon_sym_extension] = ACTIONS(3330),
  },
  [661] = {
    [sym_identifier] = ACTIONS(3322),
    [aux_sym_preproc_include_token1] = ACTIONS(3322),
    [aux_sym_preproc_def_token1] = ACTIONS(3322),
    [aux_sym_preproc_if_token1] = ACTIONS(3322),
    [aux_sym_preproc_if_token2] = ACTIONS(3322),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3322),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3322),
    [sym_preproc_directive] = ACTIONS(3322),
    [anon_sym_LPAREN2] = ACTIONS(3324),
    [anon_sym_BANG] = ACTIONS(3324),
    [anon_sym_TILDE] = ACTIONS(3324),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_STAR] = ACTIONS(3324),
    [anon_sym_AMP_AMP] = ACTIONS(3324),
    [anon_sym_AMP] = ACTIONS(3322),
    [anon_sym_SEMI] = ACTIONS(3324),
    [anon_sym___extension__] = ACTIONS(3322),
    [anon_sym_typedef] = ACTIONS(3322),
    [anon_sym_in] = ACTIONS(3322),
    [anon_sym_out] = ACTIONS(3322),
    [anon_sym_inout] = ACTIONS(3322),
    [anon_sym_extern] = ACTIONS(3322),
    [anon_sym___attribute__] = ACTIONS(3322),
    [anon_sym_COLON_COLON] = ACTIONS(3324),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3324),
    [anon_sym___declspec] = ACTIONS(3322),
    [anon_sym___based] = ACTIONS(3322),
    [anon_sym___cdecl] = ACTIONS(3322),
    [anon_sym___clrcall] = ACTIONS(3322),
    [anon_sym___stdcall] = ACTIONS(3322),
    [anon_sym___fastcall] = ACTIONS(3322),
    [anon_sym___thiscall] = ACTIONS(3322),
    [anon_sym___vectorcall] = ACTIONS(3322),
    [anon_sym_LBRACE] = ACTIONS(3324),
    [anon_sym_signed] = ACTIONS(3322),
    [anon_sym_unsigned] = ACTIONS(3322),
    [anon_sym_long] = ACTIONS(3322),
    [anon_sym_short] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_static] = ACTIONS(3322),
    [anon_sym_register] = ACTIONS(3322),
    [anon_sym_inline] = ACTIONS(3322),
    [anon_sym___inline] = ACTIONS(3322),
    [anon_sym___inline__] = ACTIONS(3322),
    [anon_sym___forceinline] = ACTIONS(3322),
    [anon_sym_thread_local] = ACTIONS(3322),
    [anon_sym___thread] = ACTIONS(3322),
    [anon_sym_const] = ACTIONS(3322),
    [anon_sym_constexpr] = ACTIONS(3322),
    [anon_sym_volatile] = ACTIONS(3322),
    [anon_sym_restrict] = ACTIONS(3322),
    [anon_sym___restrict__] = ACTIONS(3322),
    [anon_sym__Atomic] = ACTIONS(3322),
    [anon_sym__Noreturn] = ACTIONS(3322),
    [anon_sym_noreturn] = ACTIONS(3322),
    [anon_sym_mutable] = ACTIONS(3322),
    [anon_sym_constinit] = ACTIONS(3322),
    [anon_sym_consteval] = ACTIONS(3322),
    [anon_sym_alignas] = ACTIONS(3322),
    [anon_sym__Alignas] = ACTIONS(3322),
    [sym_primitive_type] = ACTIONS(3322),
    [anon_sym_enum] = ACTIONS(3322),
    [anon_sym_class] = ACTIONS(3322),
    [anon_sym_struct] = ACTIONS(3322),
    [anon_sym_union] = ACTIONS(3322),
    [anon_sym_if] = ACTIONS(3322),
    [anon_sym_else] = ACTIONS(3322),
    [anon_sym_switch] = ACTIONS(3322),
    [anon_sym_case] = ACTIONS(3322),
    [anon_sym_default] = ACTIONS(3322),
    [anon_sym_while] = ACTIONS(3322),
    [anon_sym_do] = ACTIONS(3322),
    [anon_sym_for] = ACTIONS(3322),
    [anon_sym_return] = ACTIONS(3322),
    [anon_sym_break] = ACTIONS(3322),
    [anon_sym_continue] = ACTIONS(3322),
    [anon_sym_goto] = ACTIONS(3322),
    [anon_sym___try] = ACTIONS(3322),
    [anon_sym___leave] = ACTIONS(3322),
    [anon_sym_not] = ACTIONS(3322),
    [anon_sym_compl] = ACTIONS(3322),
    [anon_sym_DASH_DASH] = ACTIONS(3324),
    [anon_sym_PLUS_PLUS] = ACTIONS(3324),
    [anon_sym_sizeof] = ACTIONS(3322),
    [anon_sym___alignof__] = ACTIONS(3322),
    [anon_sym___alignof] = ACTIONS(3322),
    [anon_sym__alignof] = ACTIONS(3322),
    [anon_sym_alignof] = ACTIONS(3322),
    [anon_sym__Alignof] = ACTIONS(3322),
    [anon_sym_offsetof] = ACTIONS(3322),
    [anon_sym__Generic] = ACTIONS(3322),
    [anon_sym_asm] = ACTIONS(3322),
    [anon_sym___asm__] = ACTIONS(3322),
    [sym_number_literal] = ACTIONS(3324),
    [anon_sym_L_SQUOTE] = ACTIONS(3324),
    [anon_sym_u_SQUOTE] = ACTIONS(3324),
    [anon_sym_U_SQUOTE] = ACTIONS(3324),
    [anon_sym_u8_SQUOTE] = ACTIONS(3324),
    [anon_sym_SQUOTE] = ACTIONS(3324),
    [anon_sym_L_DQUOTE] = ACTIONS(3324),
    [anon_sym_u_DQUOTE] = ACTIONS(3324),
    [anon_sym_U_DQUOTE] = ACTIONS(3324),
    [anon_sym_u8_DQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE] = ACTIONS(3324),
    [sym_true] = ACTIONS(3322),
    [sym_false] = ACTIONS(3322),
    [anon_sym_NULL] = ACTIONS(3322),
    [anon_sym_nullptr] = ACTIONS(3322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3322),
    [anon_sym_let] = ACTIONS(3322),
    [anon_sym_This] = ACTIONS(3322),
    [anon_sym_decltype] = ACTIONS(3322),
    [sym_virtual] = ACTIONS(3322),
    [anon_sym_explicit] = ACTIONS(3322),
    [anon_sym_typename] = ACTIONS(3322),
    [anon_sym_template] = ACTIONS(3322),
    [anon_sym_operator] = ACTIONS(3322),
    [anon_sym_try] = ACTIONS(3322),
    [anon_sym_delete] = ACTIONS(3322),
    [anon_sym_throw] = ACTIONS(3322),
    [anon_sym_namespace] = ACTIONS(3322),
    [anon_sym_using] = ACTIONS(3322),
    [anon_sym_static_assert] = ACTIONS(3322),
    [anon_sym_concept] = ACTIONS(3322),
    [anon_sym_co_return] = ACTIONS(3322),
    [anon_sym_co_yield] = ACTIONS(3322),
    [anon_sym_R_DQUOTE] = ACTIONS(3324),
    [anon_sym_LR_DQUOTE] = ACTIONS(3324),
    [anon_sym_uR_DQUOTE] = ACTIONS(3324),
    [anon_sym_UR_DQUOTE] = ACTIONS(3324),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3324),
    [anon_sym_co_await] = ACTIONS(3322),
    [anon_sym_new] = ACTIONS(3322),
    [anon_sym_requires] = ACTIONS(3322),
    [sym_this] = ACTIONS(3322),
    [anon_sym_discard] = ACTIONS(3322),
    [anon_sym_precise] = ACTIONS(3322),
    [anon_sym_shared] = ACTIONS(3322),
    [anon_sym_groupshared] = ACTIONS(3322),
    [anon_sym_uniform] = ACTIONS(3322),
    [anon_sym_row_major] = ACTIONS(3322),
    [anon_sym_column_major] = ACTIONS(3322),
    [anon_sym_globallycoherent] = ACTIONS(3322),
    [anon_sym_centroid] = ACTIONS(3322),
    [anon_sym_noperspective] = ACTIONS(3322),
    [anon_sym_nointerpolation] = ACTIONS(3322),
    [anon_sym_sample] = ACTIONS(3322),
    [anon_sym_linear] = ACTIONS(3322),
    [anon_sym_snorm] = ACTIONS(3322),
    [anon_sym_unorm] = ACTIONS(3322),
    [anon_sym_point] = ACTIONS(3322),
    [anon_sym_line] = ACTIONS(3322),
    [anon_sym_triangleadj] = ACTIONS(3322),
    [anon_sym_lineadj] = ACTIONS(3322),
    [anon_sym_triangle] = ACTIONS(3322),
    [anon_sym_cbuffer] = ACTIONS(3322),
    [anon_sym_interface] = ACTIONS(3322),
    [anon_sym_extension] = ACTIONS(3322),
  },
  [662] = {
    [sym_identifier] = ACTIONS(3318),
    [aux_sym_preproc_include_token1] = ACTIONS(3318),
    [aux_sym_preproc_def_token1] = ACTIONS(3318),
    [aux_sym_preproc_if_token1] = ACTIONS(3318),
    [aux_sym_preproc_if_token2] = ACTIONS(3318),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3318),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3318),
    [sym_preproc_directive] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(3320),
    [anon_sym_BANG] = ACTIONS(3320),
    [anon_sym_TILDE] = ACTIONS(3320),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3320),
    [anon_sym_AMP_AMP] = ACTIONS(3320),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_SEMI] = ACTIONS(3320),
    [anon_sym___extension__] = ACTIONS(3318),
    [anon_sym_typedef] = ACTIONS(3318),
    [anon_sym_in] = ACTIONS(3318),
    [anon_sym_out] = ACTIONS(3318),
    [anon_sym_inout] = ACTIONS(3318),
    [anon_sym_extern] = ACTIONS(3318),
    [anon_sym___attribute__] = ACTIONS(3318),
    [anon_sym_COLON_COLON] = ACTIONS(3320),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3320),
    [anon_sym___declspec] = ACTIONS(3318),
    [anon_sym___based] = ACTIONS(3318),
    [anon_sym___cdecl] = ACTIONS(3318),
    [anon_sym___clrcall] = ACTIONS(3318),
    [anon_sym___stdcall] = ACTIONS(3318),
    [anon_sym___fastcall] = ACTIONS(3318),
    [anon_sym___thiscall] = ACTIONS(3318),
    [anon_sym___vectorcall] = ACTIONS(3318),
    [anon_sym_LBRACE] = ACTIONS(3320),
    [anon_sym_signed] = ACTIONS(3318),
    [anon_sym_unsigned] = ACTIONS(3318),
    [anon_sym_long] = ACTIONS(3318),
    [anon_sym_short] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3318),
    [anon_sym_static] = ACTIONS(3318),
    [anon_sym_register] = ACTIONS(3318),
    [anon_sym_inline] = ACTIONS(3318),
    [anon_sym___inline] = ACTIONS(3318),
    [anon_sym___inline__] = ACTIONS(3318),
    [anon_sym___forceinline] = ACTIONS(3318),
    [anon_sym_thread_local] = ACTIONS(3318),
    [anon_sym___thread] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3318),
    [anon_sym_constexpr] = ACTIONS(3318),
    [anon_sym_volatile] = ACTIONS(3318),
    [anon_sym_restrict] = ACTIONS(3318),
    [anon_sym___restrict__] = ACTIONS(3318),
    [anon_sym__Atomic] = ACTIONS(3318),
    [anon_sym__Noreturn] = ACTIONS(3318),
    [anon_sym_noreturn] = ACTIONS(3318),
    [anon_sym_mutable] = ACTIONS(3318),
    [anon_sym_constinit] = ACTIONS(3318),
    [anon_sym_consteval] = ACTIONS(3318),
    [anon_sym_alignas] = ACTIONS(3318),
    [anon_sym__Alignas] = ACTIONS(3318),
    [sym_primitive_type] = ACTIONS(3318),
    [anon_sym_enum] = ACTIONS(3318),
    [anon_sym_class] = ACTIONS(3318),
    [anon_sym_struct] = ACTIONS(3318),
    [anon_sym_union] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_else] = ACTIONS(3318),
    [anon_sym_switch] = ACTIONS(3318),
    [anon_sym_case] = ACTIONS(3318),
    [anon_sym_default] = ACTIONS(3318),
    [anon_sym_while] = ACTIONS(3318),
    [anon_sym_do] = ACTIONS(3318),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_break] = ACTIONS(3318),
    [anon_sym_continue] = ACTIONS(3318),
    [anon_sym_goto] = ACTIONS(3318),
    [anon_sym___try] = ACTIONS(3318),
    [anon_sym___leave] = ACTIONS(3318),
    [anon_sym_not] = ACTIONS(3318),
    [anon_sym_compl] = ACTIONS(3318),
    [anon_sym_DASH_DASH] = ACTIONS(3320),
    [anon_sym_PLUS_PLUS] = ACTIONS(3320),
    [anon_sym_sizeof] = ACTIONS(3318),
    [anon_sym___alignof__] = ACTIONS(3318),
    [anon_sym___alignof] = ACTIONS(3318),
    [anon_sym__alignof] = ACTIONS(3318),
    [anon_sym_alignof] = ACTIONS(3318),
    [anon_sym__Alignof] = ACTIONS(3318),
    [anon_sym_offsetof] = ACTIONS(3318),
    [anon_sym__Generic] = ACTIONS(3318),
    [anon_sym_asm] = ACTIONS(3318),
    [anon_sym___asm__] = ACTIONS(3318),
    [sym_number_literal] = ACTIONS(3320),
    [anon_sym_L_SQUOTE] = ACTIONS(3320),
    [anon_sym_u_SQUOTE] = ACTIONS(3320),
    [anon_sym_U_SQUOTE] = ACTIONS(3320),
    [anon_sym_u8_SQUOTE] = ACTIONS(3320),
    [anon_sym_SQUOTE] = ACTIONS(3320),
    [anon_sym_L_DQUOTE] = ACTIONS(3320),
    [anon_sym_u_DQUOTE] = ACTIONS(3320),
    [anon_sym_U_DQUOTE] = ACTIONS(3320),
    [anon_sym_u8_DQUOTE] = ACTIONS(3320),
    [anon_sym_DQUOTE] = ACTIONS(3320),
    [sym_true] = ACTIONS(3318),
    [sym_false] = ACTIONS(3318),
    [anon_sym_NULL] = ACTIONS(3318),
    [anon_sym_nullptr] = ACTIONS(3318),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3318),
    [anon_sym_let] = ACTIONS(3318),
    [anon_sym_This] = ACTIONS(3318),
    [anon_sym_decltype] = ACTIONS(3318),
    [sym_virtual] = ACTIONS(3318),
    [anon_sym_explicit] = ACTIONS(3318),
    [anon_sym_typename] = ACTIONS(3318),
    [anon_sym_template] = ACTIONS(3318),
    [anon_sym_operator] = ACTIONS(3318),
    [anon_sym_try] = ACTIONS(3318),
    [anon_sym_delete] = ACTIONS(3318),
    [anon_sym_throw] = ACTIONS(3318),
    [anon_sym_namespace] = ACTIONS(3318),
    [anon_sym_using] = ACTIONS(3318),
    [anon_sym_static_assert] = ACTIONS(3318),
    [anon_sym_concept] = ACTIONS(3318),
    [anon_sym_co_return] = ACTIONS(3318),
    [anon_sym_co_yield] = ACTIONS(3318),
    [anon_sym_R_DQUOTE] = ACTIONS(3320),
    [anon_sym_LR_DQUOTE] = ACTIONS(3320),
    [anon_sym_uR_DQUOTE] = ACTIONS(3320),
    [anon_sym_UR_DQUOTE] = ACTIONS(3320),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3320),
    [anon_sym_co_await] = ACTIONS(3318),
    [anon_sym_new] = ACTIONS(3318),
    [anon_sym_requires] = ACTIONS(3318),
    [sym_this] = ACTIONS(3318),
    [anon_sym_discard] = ACTIONS(3318),
    [anon_sym_precise] = ACTIONS(3318),
    [anon_sym_shared] = ACTIONS(3318),
    [anon_sym_groupshared] = ACTIONS(3318),
    [anon_sym_uniform] = ACTIONS(3318),
    [anon_sym_row_major] = ACTIONS(3318),
    [anon_sym_column_major] = ACTIONS(3318),
    [anon_sym_globallycoherent] = ACTIONS(3318),
    [anon_sym_centroid] = ACTIONS(3318),
    [anon_sym_noperspective] = ACTIONS(3318),
    [anon_sym_nointerpolation] = ACTIONS(3318),
    [anon_sym_sample] = ACTIONS(3318),
    [anon_sym_linear] = ACTIONS(3318),
    [anon_sym_snorm] = ACTIONS(3318),
    [anon_sym_unorm] = ACTIONS(3318),
    [anon_sym_point] = ACTIONS(3318),
    [anon_sym_line] = ACTIONS(3318),
    [anon_sym_triangleadj] = ACTIONS(3318),
    [anon_sym_lineadj] = ACTIONS(3318),
    [anon_sym_triangle] = ACTIONS(3318),
    [anon_sym_cbuffer] = ACTIONS(3318),
    [anon_sym_interface] = ACTIONS(3318),
    [anon_sym_extension] = ACTIONS(3318),
  },
  [663] = {
    [sym_identifier] = ACTIONS(3396),
    [aux_sym_preproc_include_token1] = ACTIONS(3396),
    [aux_sym_preproc_def_token1] = ACTIONS(3396),
    [aux_sym_preproc_if_token1] = ACTIONS(3396),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3396),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3396),
    [sym_preproc_directive] = ACTIONS(3396),
    [anon_sym_LPAREN2] = ACTIONS(3394),
    [anon_sym_BANG] = ACTIONS(3394),
    [anon_sym_TILDE] = ACTIONS(3394),
    [anon_sym_DASH] = ACTIONS(3396),
    [anon_sym_PLUS] = ACTIONS(3396),
    [anon_sym_STAR] = ACTIONS(3394),
    [anon_sym_AMP_AMP] = ACTIONS(3394),
    [anon_sym_AMP] = ACTIONS(3396),
    [anon_sym_SEMI] = ACTIONS(3394),
    [anon_sym___extension__] = ACTIONS(3396),
    [anon_sym_typedef] = ACTIONS(3396),
    [anon_sym_in] = ACTIONS(3396),
    [anon_sym_out] = ACTIONS(3396),
    [anon_sym_inout] = ACTIONS(3396),
    [anon_sym_extern] = ACTIONS(3396),
    [anon_sym___attribute__] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(3394),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3394),
    [anon_sym___declspec] = ACTIONS(3396),
    [anon_sym___based] = ACTIONS(3396),
    [anon_sym___cdecl] = ACTIONS(3396),
    [anon_sym___clrcall] = ACTIONS(3396),
    [anon_sym___stdcall] = ACTIONS(3396),
    [anon_sym___fastcall] = ACTIONS(3396),
    [anon_sym___thiscall] = ACTIONS(3396),
    [anon_sym___vectorcall] = ACTIONS(3396),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_RBRACE] = ACTIONS(3394),
    [anon_sym_signed] = ACTIONS(3396),
    [anon_sym_unsigned] = ACTIONS(3396),
    [anon_sym_long] = ACTIONS(3396),
    [anon_sym_short] = ACTIONS(3396),
    [anon_sym_LBRACK] = ACTIONS(3396),
    [anon_sym_static] = ACTIONS(3396),
    [anon_sym_register] = ACTIONS(3396),
    [anon_sym_inline] = ACTIONS(3396),
    [anon_sym___inline] = ACTIONS(3396),
    [anon_sym___inline__] = ACTIONS(3396),
    [anon_sym___forceinline] = ACTIONS(3396),
    [anon_sym_thread_local] = ACTIONS(3396),
    [anon_sym___thread] = ACTIONS(3396),
    [anon_sym_const] = ACTIONS(3396),
    [anon_sym_constexpr] = ACTIONS(3396),
    [anon_sym_volatile] = ACTIONS(3396),
    [anon_sym_restrict] = ACTIONS(3396),
    [anon_sym___restrict__] = ACTIONS(3396),
    [anon_sym__Atomic] = ACTIONS(3396),
    [anon_sym__Noreturn] = ACTIONS(3396),
    [anon_sym_noreturn] = ACTIONS(3396),
    [anon_sym_mutable] = ACTIONS(3396),
    [anon_sym_constinit] = ACTIONS(3396),
    [anon_sym_consteval] = ACTIONS(3396),
    [anon_sym_alignas] = ACTIONS(3396),
    [anon_sym__Alignas] = ACTIONS(3396),
    [sym_primitive_type] = ACTIONS(3396),
    [anon_sym_enum] = ACTIONS(3396),
    [anon_sym_class] = ACTIONS(3396),
    [anon_sym_struct] = ACTIONS(3396),
    [anon_sym_union] = ACTIONS(3396),
    [anon_sym_if] = ACTIONS(3396),
    [anon_sym_switch] = ACTIONS(3396),
    [anon_sym_case] = ACTIONS(3396),
    [anon_sym_default] = ACTIONS(3396),
    [anon_sym_while] = ACTIONS(3396),
    [anon_sym_do] = ACTIONS(3396),
    [anon_sym_for] = ACTIONS(3396),
    [anon_sym_return] = ACTIONS(3396),
    [anon_sym_break] = ACTIONS(3396),
    [anon_sym_continue] = ACTIONS(3396),
    [anon_sym_goto] = ACTIONS(3396),
    [anon_sym___try] = ACTIONS(3396),
    [anon_sym___leave] = ACTIONS(3396),
    [anon_sym_not] = ACTIONS(3396),
    [anon_sym_compl] = ACTIONS(3396),
    [anon_sym_DASH_DASH] = ACTIONS(3394),
    [anon_sym_PLUS_PLUS] = ACTIONS(3394),
    [anon_sym_sizeof] = ACTIONS(3396),
    [anon_sym___alignof__] = ACTIONS(3396),
    [anon_sym___alignof] = ACTIONS(3396),
    [anon_sym__alignof] = ACTIONS(3396),
    [anon_sym_alignof] = ACTIONS(3396),
    [anon_sym__Alignof] = ACTIONS(3396),
    [anon_sym_offsetof] = ACTIONS(3396),
    [anon_sym__Generic] = ACTIONS(3396),
    [anon_sym_asm] = ACTIONS(3396),
    [anon_sym___asm__] = ACTIONS(3396),
    [anon_sym_DOT] = ACTIONS(3396),
    [sym_number_literal] = ACTIONS(3394),
    [anon_sym_L_SQUOTE] = ACTIONS(3394),
    [anon_sym_u_SQUOTE] = ACTIONS(3394),
    [anon_sym_U_SQUOTE] = ACTIONS(3394),
    [anon_sym_u8_SQUOTE] = ACTIONS(3394),
    [anon_sym_SQUOTE] = ACTIONS(3394),
    [anon_sym_L_DQUOTE] = ACTIONS(3394),
    [anon_sym_u_DQUOTE] = ACTIONS(3394),
    [anon_sym_U_DQUOTE] = ACTIONS(3394),
    [anon_sym_u8_DQUOTE] = ACTIONS(3394),
    [anon_sym_DQUOTE] = ACTIONS(3394),
    [sym_true] = ACTIONS(3396),
    [sym_false] = ACTIONS(3396),
    [anon_sym_NULL] = ACTIONS(3396),
    [anon_sym_nullptr] = ACTIONS(3396),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3396),
    [anon_sym_let] = ACTIONS(3396),
    [anon_sym_This] = ACTIONS(3396),
    [anon_sym_decltype] = ACTIONS(3396),
    [sym_virtual] = ACTIONS(3396),
    [anon_sym_explicit] = ACTIONS(3396),
    [anon_sym_typename] = ACTIONS(3396),
    [anon_sym_template] = ACTIONS(3396),
    [anon_sym_operator] = ACTIONS(3396),
    [anon_sym_try] = ACTIONS(3396),
    [anon_sym_delete] = ACTIONS(3396),
    [anon_sym_throw] = ACTIONS(3396),
    [anon_sym_namespace] = ACTIONS(3396),
    [anon_sym_using] = ACTIONS(3396),
    [anon_sym_static_assert] = ACTIONS(3396),
    [anon_sym_concept] = ACTIONS(3396),
    [anon_sym_co_return] = ACTIONS(3396),
    [anon_sym_co_yield] = ACTIONS(3396),
    [anon_sym_R_DQUOTE] = ACTIONS(3394),
    [anon_sym_LR_DQUOTE] = ACTIONS(3394),
    [anon_sym_uR_DQUOTE] = ACTIONS(3394),
    [anon_sym_UR_DQUOTE] = ACTIONS(3394),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3394),
    [anon_sym_co_await] = ACTIONS(3396),
    [anon_sym_new] = ACTIONS(3396),
    [anon_sym_requires] = ACTIONS(3396),
    [sym_this] = ACTIONS(3396),
    [anon_sym_discard] = ACTIONS(3396),
    [anon_sym_precise] = ACTIONS(3396),
    [anon_sym_shared] = ACTIONS(3396),
    [anon_sym_groupshared] = ACTIONS(3396),
    [anon_sym_uniform] = ACTIONS(3396),
    [anon_sym_row_major] = ACTIONS(3396),
    [anon_sym_column_major] = ACTIONS(3396),
    [anon_sym_globallycoherent] = ACTIONS(3396),
    [anon_sym_centroid] = ACTIONS(3396),
    [anon_sym_noperspective] = ACTIONS(3396),
    [anon_sym_nointerpolation] = ACTIONS(3396),
    [anon_sym_sample] = ACTIONS(3396),
    [anon_sym_linear] = ACTIONS(3396),
    [anon_sym_snorm] = ACTIONS(3396),
    [anon_sym_unorm] = ACTIONS(3396),
    [anon_sym_point] = ACTIONS(3396),
    [anon_sym_line] = ACTIONS(3396),
    [anon_sym_triangleadj] = ACTIONS(3396),
    [anon_sym_lineadj] = ACTIONS(3396),
    [anon_sym_triangle] = ACTIONS(3396),
    [anon_sym_cbuffer] = ACTIONS(3396),
    [anon_sym_interface] = ACTIONS(3396),
    [anon_sym_extension] = ACTIONS(3396),
  },
  [664] = {
    [sym_identifier] = ACTIONS(3400),
    [aux_sym_preproc_include_token1] = ACTIONS(3400),
    [aux_sym_preproc_def_token1] = ACTIONS(3400),
    [aux_sym_preproc_if_token1] = ACTIONS(3400),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3400),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3400),
    [sym_preproc_directive] = ACTIONS(3400),
    [anon_sym_LPAREN2] = ACTIONS(3398),
    [anon_sym_BANG] = ACTIONS(3398),
    [anon_sym_TILDE] = ACTIONS(3398),
    [anon_sym_DASH] = ACTIONS(3400),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_STAR] = ACTIONS(3398),
    [anon_sym_AMP_AMP] = ACTIONS(3398),
    [anon_sym_AMP] = ACTIONS(3400),
    [anon_sym_SEMI] = ACTIONS(3398),
    [anon_sym___extension__] = ACTIONS(3400),
    [anon_sym_typedef] = ACTIONS(3400),
    [anon_sym_in] = ACTIONS(3400),
    [anon_sym_out] = ACTIONS(3400),
    [anon_sym_inout] = ACTIONS(3400),
    [anon_sym_extern] = ACTIONS(3400),
    [anon_sym___attribute__] = ACTIONS(3400),
    [anon_sym_COLON_COLON] = ACTIONS(3398),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3398),
    [anon_sym___declspec] = ACTIONS(3400),
    [anon_sym___based] = ACTIONS(3400),
    [anon_sym___cdecl] = ACTIONS(3400),
    [anon_sym___clrcall] = ACTIONS(3400),
    [anon_sym___stdcall] = ACTIONS(3400),
    [anon_sym___fastcall] = ACTIONS(3400),
    [anon_sym___thiscall] = ACTIONS(3400),
    [anon_sym___vectorcall] = ACTIONS(3400),
    [anon_sym_LBRACE] = ACTIONS(3398),
    [anon_sym_RBRACE] = ACTIONS(3398),
    [anon_sym_signed] = ACTIONS(3400),
    [anon_sym_unsigned] = ACTIONS(3400),
    [anon_sym_long] = ACTIONS(3400),
    [anon_sym_short] = ACTIONS(3400),
    [anon_sym_LBRACK] = ACTIONS(3400),
    [anon_sym_static] = ACTIONS(3400),
    [anon_sym_register] = ACTIONS(3400),
    [anon_sym_inline] = ACTIONS(3400),
    [anon_sym___inline] = ACTIONS(3400),
    [anon_sym___inline__] = ACTIONS(3400),
    [anon_sym___forceinline] = ACTIONS(3400),
    [anon_sym_thread_local] = ACTIONS(3400),
    [anon_sym___thread] = ACTIONS(3400),
    [anon_sym_const] = ACTIONS(3400),
    [anon_sym_constexpr] = ACTIONS(3400),
    [anon_sym_volatile] = ACTIONS(3400),
    [anon_sym_restrict] = ACTIONS(3400),
    [anon_sym___restrict__] = ACTIONS(3400),
    [anon_sym__Atomic] = ACTIONS(3400),
    [anon_sym__Noreturn] = ACTIONS(3400),
    [anon_sym_noreturn] = ACTIONS(3400),
    [anon_sym_mutable] = ACTIONS(3400),
    [anon_sym_constinit] = ACTIONS(3400),
    [anon_sym_consteval] = ACTIONS(3400),
    [anon_sym_alignas] = ACTIONS(3400),
    [anon_sym__Alignas] = ACTIONS(3400),
    [sym_primitive_type] = ACTIONS(3400),
    [anon_sym_enum] = ACTIONS(3400),
    [anon_sym_class] = ACTIONS(3400),
    [anon_sym_struct] = ACTIONS(3400),
    [anon_sym_union] = ACTIONS(3400),
    [anon_sym_if] = ACTIONS(3400),
    [anon_sym_switch] = ACTIONS(3400),
    [anon_sym_case] = ACTIONS(3400),
    [anon_sym_default] = ACTIONS(3400),
    [anon_sym_while] = ACTIONS(3400),
    [anon_sym_do] = ACTIONS(3400),
    [anon_sym_for] = ACTIONS(3400),
    [anon_sym_return] = ACTIONS(3400),
    [anon_sym_break] = ACTIONS(3400),
    [anon_sym_continue] = ACTIONS(3400),
    [anon_sym_goto] = ACTIONS(3400),
    [anon_sym___try] = ACTIONS(3400),
    [anon_sym___leave] = ACTIONS(3400),
    [anon_sym_not] = ACTIONS(3400),
    [anon_sym_compl] = ACTIONS(3400),
    [anon_sym_DASH_DASH] = ACTIONS(3398),
    [anon_sym_PLUS_PLUS] = ACTIONS(3398),
    [anon_sym_sizeof] = ACTIONS(3400),
    [anon_sym___alignof__] = ACTIONS(3400),
    [anon_sym___alignof] = ACTIONS(3400),
    [anon_sym__alignof] = ACTIONS(3400),
    [anon_sym_alignof] = ACTIONS(3400),
    [anon_sym__Alignof] = ACTIONS(3400),
    [anon_sym_offsetof] = ACTIONS(3400),
    [anon_sym__Generic] = ACTIONS(3400),
    [anon_sym_asm] = ACTIONS(3400),
    [anon_sym___asm__] = ACTIONS(3400),
    [anon_sym_DOT] = ACTIONS(3400),
    [sym_number_literal] = ACTIONS(3398),
    [anon_sym_L_SQUOTE] = ACTIONS(3398),
    [anon_sym_u_SQUOTE] = ACTIONS(3398),
    [anon_sym_U_SQUOTE] = ACTIONS(3398),
    [anon_sym_u8_SQUOTE] = ACTIONS(3398),
    [anon_sym_SQUOTE] = ACTIONS(3398),
    [anon_sym_L_DQUOTE] = ACTIONS(3398),
    [anon_sym_u_DQUOTE] = ACTIONS(3398),
    [anon_sym_U_DQUOTE] = ACTIONS(3398),
    [anon_sym_u8_DQUOTE] = ACTIONS(3398),
    [anon_sym_DQUOTE] = ACTIONS(3398),
    [sym_true] = ACTIONS(3400),
    [sym_false] = ACTIONS(3400),
    [anon_sym_NULL] = ACTIONS(3400),
    [anon_sym_nullptr] = ACTIONS(3400),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3400),
    [anon_sym_let] = ACTIONS(3400),
    [anon_sym_This] = ACTIONS(3400),
    [anon_sym_decltype] = ACTIONS(3400),
    [sym_virtual] = ACTIONS(3400),
    [anon_sym_explicit] = ACTIONS(3400),
    [anon_sym_typename] = ACTIONS(3400),
    [anon_sym_template] = ACTIONS(3400),
    [anon_sym_operator] = ACTIONS(3400),
    [anon_sym_try] = ACTIONS(3400),
    [anon_sym_delete] = ACTIONS(3400),
    [anon_sym_throw] = ACTIONS(3400),
    [anon_sym_namespace] = ACTIONS(3400),
    [anon_sym_using] = ACTIONS(3400),
    [anon_sym_static_assert] = ACTIONS(3400),
    [anon_sym_concept] = ACTIONS(3400),
    [anon_sym_co_return] = ACTIONS(3400),
    [anon_sym_co_yield] = ACTIONS(3400),
    [anon_sym_R_DQUOTE] = ACTIONS(3398),
    [anon_sym_LR_DQUOTE] = ACTIONS(3398),
    [anon_sym_uR_DQUOTE] = ACTIONS(3398),
    [anon_sym_UR_DQUOTE] = ACTIONS(3398),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3398),
    [anon_sym_co_await] = ACTIONS(3400),
    [anon_sym_new] = ACTIONS(3400),
    [anon_sym_requires] = ACTIONS(3400),
    [sym_this] = ACTIONS(3400),
    [anon_sym_discard] = ACTIONS(3400),
    [anon_sym_precise] = ACTIONS(3400),
    [anon_sym_shared] = ACTIONS(3400),
    [anon_sym_groupshared] = ACTIONS(3400),
    [anon_sym_uniform] = ACTIONS(3400),
    [anon_sym_row_major] = ACTIONS(3400),
    [anon_sym_column_major] = ACTIONS(3400),
    [anon_sym_globallycoherent] = ACTIONS(3400),
    [anon_sym_centroid] = ACTIONS(3400),
    [anon_sym_noperspective] = ACTIONS(3400),
    [anon_sym_nointerpolation] = ACTIONS(3400),
    [anon_sym_sample] = ACTIONS(3400),
    [anon_sym_linear] = ACTIONS(3400),
    [anon_sym_snorm] = ACTIONS(3400),
    [anon_sym_unorm] = ACTIONS(3400),
    [anon_sym_point] = ACTIONS(3400),
    [anon_sym_line] = ACTIONS(3400),
    [anon_sym_triangleadj] = ACTIONS(3400),
    [anon_sym_lineadj] = ACTIONS(3400),
    [anon_sym_triangle] = ACTIONS(3400),
    [anon_sym_cbuffer] = ACTIONS(3400),
    [anon_sym_interface] = ACTIONS(3400),
    [anon_sym_extension] = ACTIONS(3400),
  },
  [665] = {
    [sym_identifier] = ACTIONS(3156),
    [aux_sym_preproc_include_token1] = ACTIONS(3156),
    [aux_sym_preproc_def_token1] = ACTIONS(3156),
    [aux_sym_preproc_if_token1] = ACTIONS(3156),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3156),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3156),
    [sym_preproc_directive] = ACTIONS(3156),
    [anon_sym_LPAREN2] = ACTIONS(3154),
    [anon_sym_BANG] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3154),
    [anon_sym_DASH] = ACTIONS(3156),
    [anon_sym_PLUS] = ACTIONS(3156),
    [anon_sym_STAR] = ACTIONS(3154),
    [anon_sym_AMP_AMP] = ACTIONS(3154),
    [anon_sym_AMP] = ACTIONS(3156),
    [anon_sym_SEMI] = ACTIONS(3154),
    [anon_sym___extension__] = ACTIONS(3156),
    [anon_sym_typedef] = ACTIONS(3156),
    [anon_sym_in] = ACTIONS(3156),
    [anon_sym_out] = ACTIONS(3156),
    [anon_sym_inout] = ACTIONS(3156),
    [anon_sym_extern] = ACTIONS(3156),
    [anon_sym___attribute__] = ACTIONS(3156),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3154),
    [anon_sym___declspec] = ACTIONS(3156),
    [anon_sym___based] = ACTIONS(3156),
    [anon_sym___cdecl] = ACTIONS(3156),
    [anon_sym___clrcall] = ACTIONS(3156),
    [anon_sym___stdcall] = ACTIONS(3156),
    [anon_sym___fastcall] = ACTIONS(3156),
    [anon_sym___thiscall] = ACTIONS(3156),
    [anon_sym___vectorcall] = ACTIONS(3156),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_RBRACE] = ACTIONS(3154),
    [anon_sym_signed] = ACTIONS(3156),
    [anon_sym_unsigned] = ACTIONS(3156),
    [anon_sym_long] = ACTIONS(3156),
    [anon_sym_short] = ACTIONS(3156),
    [anon_sym_LBRACK] = ACTIONS(3156),
    [anon_sym_static] = ACTIONS(3156),
    [anon_sym_register] = ACTIONS(3156),
    [anon_sym_inline] = ACTIONS(3156),
    [anon_sym___inline] = ACTIONS(3156),
    [anon_sym___inline__] = ACTIONS(3156),
    [anon_sym___forceinline] = ACTIONS(3156),
    [anon_sym_thread_local] = ACTIONS(3156),
    [anon_sym___thread] = ACTIONS(3156),
    [anon_sym_const] = ACTIONS(3156),
    [anon_sym_constexpr] = ACTIONS(3156),
    [anon_sym_volatile] = ACTIONS(3156),
    [anon_sym_restrict] = ACTIONS(3156),
    [anon_sym___restrict__] = ACTIONS(3156),
    [anon_sym__Atomic] = ACTIONS(3156),
    [anon_sym__Noreturn] = ACTIONS(3156),
    [anon_sym_noreturn] = ACTIONS(3156),
    [anon_sym_mutable] = ACTIONS(3156),
    [anon_sym_constinit] = ACTIONS(3156),
    [anon_sym_consteval] = ACTIONS(3156),
    [anon_sym_alignas] = ACTIONS(3156),
    [anon_sym__Alignas] = ACTIONS(3156),
    [sym_primitive_type] = ACTIONS(3156),
    [anon_sym_enum] = ACTIONS(3156),
    [anon_sym_class] = ACTIONS(3156),
    [anon_sym_struct] = ACTIONS(3156),
    [anon_sym_union] = ACTIONS(3156),
    [anon_sym_if] = ACTIONS(3156),
    [anon_sym_switch] = ACTIONS(3156),
    [anon_sym_case] = ACTIONS(3156),
    [anon_sym_default] = ACTIONS(3156),
    [anon_sym_while] = ACTIONS(3156),
    [anon_sym_do] = ACTIONS(3156),
    [anon_sym_for] = ACTIONS(3156),
    [anon_sym_return] = ACTIONS(3156),
    [anon_sym_break] = ACTIONS(3156),
    [anon_sym_continue] = ACTIONS(3156),
    [anon_sym_goto] = ACTIONS(3156),
    [anon_sym___try] = ACTIONS(3156),
    [anon_sym___leave] = ACTIONS(3156),
    [anon_sym_not] = ACTIONS(3156),
    [anon_sym_compl] = ACTIONS(3156),
    [anon_sym_DASH_DASH] = ACTIONS(3154),
    [anon_sym_PLUS_PLUS] = ACTIONS(3154),
    [anon_sym_sizeof] = ACTIONS(3156),
    [anon_sym___alignof__] = ACTIONS(3156),
    [anon_sym___alignof] = ACTIONS(3156),
    [anon_sym__alignof] = ACTIONS(3156),
    [anon_sym_alignof] = ACTIONS(3156),
    [anon_sym__Alignof] = ACTIONS(3156),
    [anon_sym_offsetof] = ACTIONS(3156),
    [anon_sym__Generic] = ACTIONS(3156),
    [anon_sym_asm] = ACTIONS(3156),
    [anon_sym___asm__] = ACTIONS(3156),
    [anon_sym_DOT] = ACTIONS(3156),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3154),
    [anon_sym_u_SQUOTE] = ACTIONS(3154),
    [anon_sym_U_SQUOTE] = ACTIONS(3154),
    [anon_sym_u8_SQUOTE] = ACTIONS(3154),
    [anon_sym_SQUOTE] = ACTIONS(3154),
    [anon_sym_L_DQUOTE] = ACTIONS(3154),
    [anon_sym_u_DQUOTE] = ACTIONS(3154),
    [anon_sym_U_DQUOTE] = ACTIONS(3154),
    [anon_sym_u8_DQUOTE] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [sym_true] = ACTIONS(3156),
    [sym_false] = ACTIONS(3156),
    [anon_sym_NULL] = ACTIONS(3156),
    [anon_sym_nullptr] = ACTIONS(3156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3156),
    [anon_sym_let] = ACTIONS(3156),
    [anon_sym_This] = ACTIONS(3156),
    [anon_sym_decltype] = ACTIONS(3156),
    [sym_virtual] = ACTIONS(3156),
    [anon_sym_explicit] = ACTIONS(3156),
    [anon_sym_typename] = ACTIONS(3156),
    [anon_sym_template] = ACTIONS(3156),
    [anon_sym_operator] = ACTIONS(3156),
    [anon_sym_try] = ACTIONS(3156),
    [anon_sym_delete] = ACTIONS(3156),
    [anon_sym_throw] = ACTIONS(3156),
    [anon_sym_namespace] = ACTIONS(3156),
    [anon_sym_using] = ACTIONS(3156),
    [anon_sym_static_assert] = ACTIONS(3156),
    [anon_sym_concept] = ACTIONS(3156),
    [anon_sym_co_return] = ACTIONS(3156),
    [anon_sym_co_yield] = ACTIONS(3156),
    [anon_sym_R_DQUOTE] = ACTIONS(3154),
    [anon_sym_LR_DQUOTE] = ACTIONS(3154),
    [anon_sym_uR_DQUOTE] = ACTIONS(3154),
    [anon_sym_UR_DQUOTE] = ACTIONS(3154),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3154),
    [anon_sym_co_await] = ACTIONS(3156),
    [anon_sym_new] = ACTIONS(3156),
    [anon_sym_requires] = ACTIONS(3156),
    [sym_this] = ACTIONS(3156),
    [anon_sym_discard] = ACTIONS(3156),
    [anon_sym_precise] = ACTIONS(3156),
    [anon_sym_shared] = ACTIONS(3156),
    [anon_sym_groupshared] = ACTIONS(3156),
    [anon_sym_uniform] = ACTIONS(3156),
    [anon_sym_row_major] = ACTIONS(3156),
    [anon_sym_column_major] = ACTIONS(3156),
    [anon_sym_globallycoherent] = ACTIONS(3156),
    [anon_sym_centroid] = ACTIONS(3156),
    [anon_sym_noperspective] = ACTIONS(3156),
    [anon_sym_nointerpolation] = ACTIONS(3156),
    [anon_sym_sample] = ACTIONS(3156),
    [anon_sym_linear] = ACTIONS(3156),
    [anon_sym_snorm] = ACTIONS(3156),
    [anon_sym_unorm] = ACTIONS(3156),
    [anon_sym_point] = ACTIONS(3156),
    [anon_sym_line] = ACTIONS(3156),
    [anon_sym_triangleadj] = ACTIONS(3156),
    [anon_sym_lineadj] = ACTIONS(3156),
    [anon_sym_triangle] = ACTIONS(3156),
    [anon_sym_cbuffer] = ACTIONS(3156),
    [anon_sym_interface] = ACTIONS(3156),
    [anon_sym_extension] = ACTIONS(3156),
  },
  [666] = {
    [sym_identifier] = ACTIONS(3310),
    [aux_sym_preproc_include_token1] = ACTIONS(3310),
    [aux_sym_preproc_def_token1] = ACTIONS(3310),
    [aux_sym_preproc_if_token1] = ACTIONS(3310),
    [aux_sym_preproc_if_token2] = ACTIONS(3310),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3310),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3310),
    [sym_preproc_directive] = ACTIONS(3310),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_BANG] = ACTIONS(3312),
    [anon_sym_TILDE] = ACTIONS(3312),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3312),
    [anon_sym_AMP_AMP] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3310),
    [anon_sym_SEMI] = ACTIONS(3312),
    [anon_sym___extension__] = ACTIONS(3310),
    [anon_sym_typedef] = ACTIONS(3310),
    [anon_sym_in] = ACTIONS(3310),
    [anon_sym_out] = ACTIONS(3310),
    [anon_sym_inout] = ACTIONS(3310),
    [anon_sym_extern] = ACTIONS(3310),
    [anon_sym___attribute__] = ACTIONS(3310),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3312),
    [anon_sym___declspec] = ACTIONS(3310),
    [anon_sym___based] = ACTIONS(3310),
    [anon_sym___cdecl] = ACTIONS(3310),
    [anon_sym___clrcall] = ACTIONS(3310),
    [anon_sym___stdcall] = ACTIONS(3310),
    [anon_sym___fastcall] = ACTIONS(3310),
    [anon_sym___thiscall] = ACTIONS(3310),
    [anon_sym___vectorcall] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3312),
    [anon_sym_signed] = ACTIONS(3310),
    [anon_sym_unsigned] = ACTIONS(3310),
    [anon_sym_long] = ACTIONS(3310),
    [anon_sym_short] = ACTIONS(3310),
    [anon_sym_LBRACK] = ACTIONS(3310),
    [anon_sym_static] = ACTIONS(3310),
    [anon_sym_register] = ACTIONS(3310),
    [anon_sym_inline] = ACTIONS(3310),
    [anon_sym___inline] = ACTIONS(3310),
    [anon_sym___inline__] = ACTIONS(3310),
    [anon_sym___forceinline] = ACTIONS(3310),
    [anon_sym_thread_local] = ACTIONS(3310),
    [anon_sym___thread] = ACTIONS(3310),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_constexpr] = ACTIONS(3310),
    [anon_sym_volatile] = ACTIONS(3310),
    [anon_sym_restrict] = ACTIONS(3310),
    [anon_sym___restrict__] = ACTIONS(3310),
    [anon_sym__Atomic] = ACTIONS(3310),
    [anon_sym__Noreturn] = ACTIONS(3310),
    [anon_sym_noreturn] = ACTIONS(3310),
    [anon_sym_mutable] = ACTIONS(3310),
    [anon_sym_constinit] = ACTIONS(3310),
    [anon_sym_consteval] = ACTIONS(3310),
    [anon_sym_alignas] = ACTIONS(3310),
    [anon_sym__Alignas] = ACTIONS(3310),
    [sym_primitive_type] = ACTIONS(3310),
    [anon_sym_enum] = ACTIONS(3310),
    [anon_sym_class] = ACTIONS(3310),
    [anon_sym_struct] = ACTIONS(3310),
    [anon_sym_union] = ACTIONS(3310),
    [anon_sym_if] = ACTIONS(3310),
    [anon_sym_else] = ACTIONS(3310),
    [anon_sym_switch] = ACTIONS(3310),
    [anon_sym_case] = ACTIONS(3310),
    [anon_sym_default] = ACTIONS(3310),
    [anon_sym_while] = ACTIONS(3310),
    [anon_sym_do] = ACTIONS(3310),
    [anon_sym_for] = ACTIONS(3310),
    [anon_sym_return] = ACTIONS(3310),
    [anon_sym_break] = ACTIONS(3310),
    [anon_sym_continue] = ACTIONS(3310),
    [anon_sym_goto] = ACTIONS(3310),
    [anon_sym___try] = ACTIONS(3310),
    [anon_sym___leave] = ACTIONS(3310),
    [anon_sym_not] = ACTIONS(3310),
    [anon_sym_compl] = ACTIONS(3310),
    [anon_sym_DASH_DASH] = ACTIONS(3312),
    [anon_sym_PLUS_PLUS] = ACTIONS(3312),
    [anon_sym_sizeof] = ACTIONS(3310),
    [anon_sym___alignof__] = ACTIONS(3310),
    [anon_sym___alignof] = ACTIONS(3310),
    [anon_sym__alignof] = ACTIONS(3310),
    [anon_sym_alignof] = ACTIONS(3310),
    [anon_sym__Alignof] = ACTIONS(3310),
    [anon_sym_offsetof] = ACTIONS(3310),
    [anon_sym__Generic] = ACTIONS(3310),
    [anon_sym_asm] = ACTIONS(3310),
    [anon_sym___asm__] = ACTIONS(3310),
    [sym_number_literal] = ACTIONS(3312),
    [anon_sym_L_SQUOTE] = ACTIONS(3312),
    [anon_sym_u_SQUOTE] = ACTIONS(3312),
    [anon_sym_U_SQUOTE] = ACTIONS(3312),
    [anon_sym_u8_SQUOTE] = ACTIONS(3312),
    [anon_sym_SQUOTE] = ACTIONS(3312),
    [anon_sym_L_DQUOTE] = ACTIONS(3312),
    [anon_sym_u_DQUOTE] = ACTIONS(3312),
    [anon_sym_U_DQUOTE] = ACTIONS(3312),
    [anon_sym_u8_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE] = ACTIONS(3312),
    [sym_true] = ACTIONS(3310),
    [sym_false] = ACTIONS(3310),
    [anon_sym_NULL] = ACTIONS(3310),
    [anon_sym_nullptr] = ACTIONS(3310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3310),
    [anon_sym_let] = ACTIONS(3310),
    [anon_sym_This] = ACTIONS(3310),
    [anon_sym_decltype] = ACTIONS(3310),
    [sym_virtual] = ACTIONS(3310),
    [anon_sym_explicit] = ACTIONS(3310),
    [anon_sym_typename] = ACTIONS(3310),
    [anon_sym_template] = ACTIONS(3310),
    [anon_sym_operator] = ACTIONS(3310),
    [anon_sym_try] = ACTIONS(3310),
    [anon_sym_delete] = ACTIONS(3310),
    [anon_sym_throw] = ACTIONS(3310),
    [anon_sym_namespace] = ACTIONS(3310),
    [anon_sym_using] = ACTIONS(3310),
    [anon_sym_static_assert] = ACTIONS(3310),
    [anon_sym_concept] = ACTIONS(3310),
    [anon_sym_co_return] = ACTIONS(3310),
    [anon_sym_co_yield] = ACTIONS(3310),
    [anon_sym_R_DQUOTE] = ACTIONS(3312),
    [anon_sym_LR_DQUOTE] = ACTIONS(3312),
    [anon_sym_uR_DQUOTE] = ACTIONS(3312),
    [anon_sym_UR_DQUOTE] = ACTIONS(3312),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3312),
    [anon_sym_co_await] = ACTIONS(3310),
    [anon_sym_new] = ACTIONS(3310),
    [anon_sym_requires] = ACTIONS(3310),
    [sym_this] = ACTIONS(3310),
    [anon_sym_discard] = ACTIONS(3310),
    [anon_sym_precise] = ACTIONS(3310),
    [anon_sym_shared] = ACTIONS(3310),
    [anon_sym_groupshared] = ACTIONS(3310),
    [anon_sym_uniform] = ACTIONS(3310),
    [anon_sym_row_major] = ACTIONS(3310),
    [anon_sym_column_major] = ACTIONS(3310),
    [anon_sym_globallycoherent] = ACTIONS(3310),
    [anon_sym_centroid] = ACTIONS(3310),
    [anon_sym_noperspective] = ACTIONS(3310),
    [anon_sym_nointerpolation] = ACTIONS(3310),
    [anon_sym_sample] = ACTIONS(3310),
    [anon_sym_linear] = ACTIONS(3310),
    [anon_sym_snorm] = ACTIONS(3310),
    [anon_sym_unorm] = ACTIONS(3310),
    [anon_sym_point] = ACTIONS(3310),
    [anon_sym_line] = ACTIONS(3310),
    [anon_sym_triangleadj] = ACTIONS(3310),
    [anon_sym_lineadj] = ACTIONS(3310),
    [anon_sym_triangle] = ACTIONS(3310),
    [anon_sym_cbuffer] = ACTIONS(3310),
    [anon_sym_interface] = ACTIONS(3310),
    [anon_sym_extension] = ACTIONS(3310),
  },
  [667] = {
    [sym_identifier] = ACTIONS(3250),
    [aux_sym_preproc_include_token1] = ACTIONS(3250),
    [aux_sym_preproc_def_token1] = ACTIONS(3250),
    [aux_sym_preproc_if_token1] = ACTIONS(3250),
    [aux_sym_preproc_if_token2] = ACTIONS(3250),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3250),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3250),
    [sym_preproc_directive] = ACTIONS(3250),
    [anon_sym_LPAREN2] = ACTIONS(3252),
    [anon_sym_BANG] = ACTIONS(3252),
    [anon_sym_TILDE] = ACTIONS(3252),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_STAR] = ACTIONS(3252),
    [anon_sym_AMP_AMP] = ACTIONS(3252),
    [anon_sym_AMP] = ACTIONS(3250),
    [anon_sym_SEMI] = ACTIONS(3252),
    [anon_sym___extension__] = ACTIONS(3250),
    [anon_sym_typedef] = ACTIONS(3250),
    [anon_sym_in] = ACTIONS(3250),
    [anon_sym_out] = ACTIONS(3250),
    [anon_sym_inout] = ACTIONS(3250),
    [anon_sym_extern] = ACTIONS(3250),
    [anon_sym___attribute__] = ACTIONS(3250),
    [anon_sym_COLON_COLON] = ACTIONS(3252),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3252),
    [anon_sym___declspec] = ACTIONS(3250),
    [anon_sym___based] = ACTIONS(3250),
    [anon_sym___cdecl] = ACTIONS(3250),
    [anon_sym___clrcall] = ACTIONS(3250),
    [anon_sym___stdcall] = ACTIONS(3250),
    [anon_sym___fastcall] = ACTIONS(3250),
    [anon_sym___thiscall] = ACTIONS(3250),
    [anon_sym___vectorcall] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3252),
    [anon_sym_signed] = ACTIONS(3250),
    [anon_sym_unsigned] = ACTIONS(3250),
    [anon_sym_long] = ACTIONS(3250),
    [anon_sym_short] = ACTIONS(3250),
    [anon_sym_LBRACK] = ACTIONS(3250),
    [anon_sym_static] = ACTIONS(3250),
    [anon_sym_register] = ACTIONS(3250),
    [anon_sym_inline] = ACTIONS(3250),
    [anon_sym___inline] = ACTIONS(3250),
    [anon_sym___inline__] = ACTIONS(3250),
    [anon_sym___forceinline] = ACTIONS(3250),
    [anon_sym_thread_local] = ACTIONS(3250),
    [anon_sym___thread] = ACTIONS(3250),
    [anon_sym_const] = ACTIONS(3250),
    [anon_sym_constexpr] = ACTIONS(3250),
    [anon_sym_volatile] = ACTIONS(3250),
    [anon_sym_restrict] = ACTIONS(3250),
    [anon_sym___restrict__] = ACTIONS(3250),
    [anon_sym__Atomic] = ACTIONS(3250),
    [anon_sym__Noreturn] = ACTIONS(3250),
    [anon_sym_noreturn] = ACTIONS(3250),
    [anon_sym_mutable] = ACTIONS(3250),
    [anon_sym_constinit] = ACTIONS(3250),
    [anon_sym_consteval] = ACTIONS(3250),
    [anon_sym_alignas] = ACTIONS(3250),
    [anon_sym__Alignas] = ACTIONS(3250),
    [sym_primitive_type] = ACTIONS(3250),
    [anon_sym_enum] = ACTIONS(3250),
    [anon_sym_class] = ACTIONS(3250),
    [anon_sym_struct] = ACTIONS(3250),
    [anon_sym_union] = ACTIONS(3250),
    [anon_sym_if] = ACTIONS(3250),
    [anon_sym_else] = ACTIONS(3250),
    [anon_sym_switch] = ACTIONS(3250),
    [anon_sym_case] = ACTIONS(3250),
    [anon_sym_default] = ACTIONS(3250),
    [anon_sym_while] = ACTIONS(3250),
    [anon_sym_do] = ACTIONS(3250),
    [anon_sym_for] = ACTIONS(3250),
    [anon_sym_return] = ACTIONS(3250),
    [anon_sym_break] = ACTIONS(3250),
    [anon_sym_continue] = ACTIONS(3250),
    [anon_sym_goto] = ACTIONS(3250),
    [anon_sym___try] = ACTIONS(3250),
    [anon_sym___leave] = ACTIONS(3250),
    [anon_sym_not] = ACTIONS(3250),
    [anon_sym_compl] = ACTIONS(3250),
    [anon_sym_DASH_DASH] = ACTIONS(3252),
    [anon_sym_PLUS_PLUS] = ACTIONS(3252),
    [anon_sym_sizeof] = ACTIONS(3250),
    [anon_sym___alignof__] = ACTIONS(3250),
    [anon_sym___alignof] = ACTIONS(3250),
    [anon_sym__alignof] = ACTIONS(3250),
    [anon_sym_alignof] = ACTIONS(3250),
    [anon_sym__Alignof] = ACTIONS(3250),
    [anon_sym_offsetof] = ACTIONS(3250),
    [anon_sym__Generic] = ACTIONS(3250),
    [anon_sym_asm] = ACTIONS(3250),
    [anon_sym___asm__] = ACTIONS(3250),
    [sym_number_literal] = ACTIONS(3252),
    [anon_sym_L_SQUOTE] = ACTIONS(3252),
    [anon_sym_u_SQUOTE] = ACTIONS(3252),
    [anon_sym_U_SQUOTE] = ACTIONS(3252),
    [anon_sym_u8_SQUOTE] = ACTIONS(3252),
    [anon_sym_SQUOTE] = ACTIONS(3252),
    [anon_sym_L_DQUOTE] = ACTIONS(3252),
    [anon_sym_u_DQUOTE] = ACTIONS(3252),
    [anon_sym_U_DQUOTE] = ACTIONS(3252),
    [anon_sym_u8_DQUOTE] = ACTIONS(3252),
    [anon_sym_DQUOTE] = ACTIONS(3252),
    [sym_true] = ACTIONS(3250),
    [sym_false] = ACTIONS(3250),
    [anon_sym_NULL] = ACTIONS(3250),
    [anon_sym_nullptr] = ACTIONS(3250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3250),
    [anon_sym_let] = ACTIONS(3250),
    [anon_sym_This] = ACTIONS(3250),
    [anon_sym_decltype] = ACTIONS(3250),
    [sym_virtual] = ACTIONS(3250),
    [anon_sym_explicit] = ACTIONS(3250),
    [anon_sym_typename] = ACTIONS(3250),
    [anon_sym_template] = ACTIONS(3250),
    [anon_sym_operator] = ACTIONS(3250),
    [anon_sym_try] = ACTIONS(3250),
    [anon_sym_delete] = ACTIONS(3250),
    [anon_sym_throw] = ACTIONS(3250),
    [anon_sym_namespace] = ACTIONS(3250),
    [anon_sym_using] = ACTIONS(3250),
    [anon_sym_static_assert] = ACTIONS(3250),
    [anon_sym_concept] = ACTIONS(3250),
    [anon_sym_co_return] = ACTIONS(3250),
    [anon_sym_co_yield] = ACTIONS(3250),
    [anon_sym_R_DQUOTE] = ACTIONS(3252),
    [anon_sym_LR_DQUOTE] = ACTIONS(3252),
    [anon_sym_uR_DQUOTE] = ACTIONS(3252),
    [anon_sym_UR_DQUOTE] = ACTIONS(3252),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3252),
    [anon_sym_co_await] = ACTIONS(3250),
    [anon_sym_new] = ACTIONS(3250),
    [anon_sym_requires] = ACTIONS(3250),
    [sym_this] = ACTIONS(3250),
    [anon_sym_discard] = ACTIONS(3250),
    [anon_sym_precise] = ACTIONS(3250),
    [anon_sym_shared] = ACTIONS(3250),
    [anon_sym_groupshared] = ACTIONS(3250),
    [anon_sym_uniform] = ACTIONS(3250),
    [anon_sym_row_major] = ACTIONS(3250),
    [anon_sym_column_major] = ACTIONS(3250),
    [anon_sym_globallycoherent] = ACTIONS(3250),
    [anon_sym_centroid] = ACTIONS(3250),
    [anon_sym_noperspective] = ACTIONS(3250),
    [anon_sym_nointerpolation] = ACTIONS(3250),
    [anon_sym_sample] = ACTIONS(3250),
    [anon_sym_linear] = ACTIONS(3250),
    [anon_sym_snorm] = ACTIONS(3250),
    [anon_sym_unorm] = ACTIONS(3250),
    [anon_sym_point] = ACTIONS(3250),
    [anon_sym_line] = ACTIONS(3250),
    [anon_sym_triangleadj] = ACTIONS(3250),
    [anon_sym_lineadj] = ACTIONS(3250),
    [anon_sym_triangle] = ACTIONS(3250),
    [anon_sym_cbuffer] = ACTIONS(3250),
    [anon_sym_interface] = ACTIONS(3250),
    [anon_sym_extension] = ACTIONS(3250),
  },
  [668] = {
    [sym_identifier] = ACTIONS(3246),
    [aux_sym_preproc_include_token1] = ACTIONS(3246),
    [aux_sym_preproc_def_token1] = ACTIONS(3246),
    [aux_sym_preproc_if_token1] = ACTIONS(3246),
    [aux_sym_preproc_if_token2] = ACTIONS(3246),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3246),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3246),
    [sym_preproc_directive] = ACTIONS(3246),
    [anon_sym_LPAREN2] = ACTIONS(3248),
    [anon_sym_BANG] = ACTIONS(3248),
    [anon_sym_TILDE] = ACTIONS(3248),
    [anon_sym_DASH] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3246),
    [anon_sym_STAR] = ACTIONS(3248),
    [anon_sym_AMP_AMP] = ACTIONS(3248),
    [anon_sym_AMP] = ACTIONS(3246),
    [anon_sym_SEMI] = ACTIONS(3248),
    [anon_sym___extension__] = ACTIONS(3246),
    [anon_sym_typedef] = ACTIONS(3246),
    [anon_sym_in] = ACTIONS(3246),
    [anon_sym_out] = ACTIONS(3246),
    [anon_sym_inout] = ACTIONS(3246),
    [anon_sym_extern] = ACTIONS(3246),
    [anon_sym___attribute__] = ACTIONS(3246),
    [anon_sym_COLON_COLON] = ACTIONS(3248),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3248),
    [anon_sym___declspec] = ACTIONS(3246),
    [anon_sym___based] = ACTIONS(3246),
    [anon_sym___cdecl] = ACTIONS(3246),
    [anon_sym___clrcall] = ACTIONS(3246),
    [anon_sym___stdcall] = ACTIONS(3246),
    [anon_sym___fastcall] = ACTIONS(3246),
    [anon_sym___thiscall] = ACTIONS(3246),
    [anon_sym___vectorcall] = ACTIONS(3246),
    [anon_sym_LBRACE] = ACTIONS(3248),
    [anon_sym_signed] = ACTIONS(3246),
    [anon_sym_unsigned] = ACTIONS(3246),
    [anon_sym_long] = ACTIONS(3246),
    [anon_sym_short] = ACTIONS(3246),
    [anon_sym_LBRACK] = ACTIONS(3246),
    [anon_sym_static] = ACTIONS(3246),
    [anon_sym_register] = ACTIONS(3246),
    [anon_sym_inline] = ACTIONS(3246),
    [anon_sym___inline] = ACTIONS(3246),
    [anon_sym___inline__] = ACTIONS(3246),
    [anon_sym___forceinline] = ACTIONS(3246),
    [anon_sym_thread_local] = ACTIONS(3246),
    [anon_sym___thread] = ACTIONS(3246),
    [anon_sym_const] = ACTIONS(3246),
    [anon_sym_constexpr] = ACTIONS(3246),
    [anon_sym_volatile] = ACTIONS(3246),
    [anon_sym_restrict] = ACTIONS(3246),
    [anon_sym___restrict__] = ACTIONS(3246),
    [anon_sym__Atomic] = ACTIONS(3246),
    [anon_sym__Noreturn] = ACTIONS(3246),
    [anon_sym_noreturn] = ACTIONS(3246),
    [anon_sym_mutable] = ACTIONS(3246),
    [anon_sym_constinit] = ACTIONS(3246),
    [anon_sym_consteval] = ACTIONS(3246),
    [anon_sym_alignas] = ACTIONS(3246),
    [anon_sym__Alignas] = ACTIONS(3246),
    [sym_primitive_type] = ACTIONS(3246),
    [anon_sym_enum] = ACTIONS(3246),
    [anon_sym_class] = ACTIONS(3246),
    [anon_sym_struct] = ACTIONS(3246),
    [anon_sym_union] = ACTIONS(3246),
    [anon_sym_if] = ACTIONS(3246),
    [anon_sym_else] = ACTIONS(3246),
    [anon_sym_switch] = ACTIONS(3246),
    [anon_sym_case] = ACTIONS(3246),
    [anon_sym_default] = ACTIONS(3246),
    [anon_sym_while] = ACTIONS(3246),
    [anon_sym_do] = ACTIONS(3246),
    [anon_sym_for] = ACTIONS(3246),
    [anon_sym_return] = ACTIONS(3246),
    [anon_sym_break] = ACTIONS(3246),
    [anon_sym_continue] = ACTIONS(3246),
    [anon_sym_goto] = ACTIONS(3246),
    [anon_sym___try] = ACTIONS(3246),
    [anon_sym___leave] = ACTIONS(3246),
    [anon_sym_not] = ACTIONS(3246),
    [anon_sym_compl] = ACTIONS(3246),
    [anon_sym_DASH_DASH] = ACTIONS(3248),
    [anon_sym_PLUS_PLUS] = ACTIONS(3248),
    [anon_sym_sizeof] = ACTIONS(3246),
    [anon_sym___alignof__] = ACTIONS(3246),
    [anon_sym___alignof] = ACTIONS(3246),
    [anon_sym__alignof] = ACTIONS(3246),
    [anon_sym_alignof] = ACTIONS(3246),
    [anon_sym__Alignof] = ACTIONS(3246),
    [anon_sym_offsetof] = ACTIONS(3246),
    [anon_sym__Generic] = ACTIONS(3246),
    [anon_sym_asm] = ACTIONS(3246),
    [anon_sym___asm__] = ACTIONS(3246),
    [sym_number_literal] = ACTIONS(3248),
    [anon_sym_L_SQUOTE] = ACTIONS(3248),
    [anon_sym_u_SQUOTE] = ACTIONS(3248),
    [anon_sym_U_SQUOTE] = ACTIONS(3248),
    [anon_sym_u8_SQUOTE] = ACTIONS(3248),
    [anon_sym_SQUOTE] = ACTIONS(3248),
    [anon_sym_L_DQUOTE] = ACTIONS(3248),
    [anon_sym_u_DQUOTE] = ACTIONS(3248),
    [anon_sym_U_DQUOTE] = ACTIONS(3248),
    [anon_sym_u8_DQUOTE] = ACTIONS(3248),
    [anon_sym_DQUOTE] = ACTIONS(3248),
    [sym_true] = ACTIONS(3246),
    [sym_false] = ACTIONS(3246),
    [anon_sym_NULL] = ACTIONS(3246),
    [anon_sym_nullptr] = ACTIONS(3246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3246),
    [anon_sym_let] = ACTIONS(3246),
    [anon_sym_This] = ACTIONS(3246),
    [anon_sym_decltype] = ACTIONS(3246),
    [sym_virtual] = ACTIONS(3246),
    [anon_sym_explicit] = ACTIONS(3246),
    [anon_sym_typename] = ACTIONS(3246),
    [anon_sym_template] = ACTIONS(3246),
    [anon_sym_operator] = ACTIONS(3246),
    [anon_sym_try] = ACTIONS(3246),
    [anon_sym_delete] = ACTIONS(3246),
    [anon_sym_throw] = ACTIONS(3246),
    [anon_sym_namespace] = ACTIONS(3246),
    [anon_sym_using] = ACTIONS(3246),
    [anon_sym_static_assert] = ACTIONS(3246),
    [anon_sym_concept] = ACTIONS(3246),
    [anon_sym_co_return] = ACTIONS(3246),
    [anon_sym_co_yield] = ACTIONS(3246),
    [anon_sym_R_DQUOTE] = ACTIONS(3248),
    [anon_sym_LR_DQUOTE] = ACTIONS(3248),
    [anon_sym_uR_DQUOTE] = ACTIONS(3248),
    [anon_sym_UR_DQUOTE] = ACTIONS(3248),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3248),
    [anon_sym_co_await] = ACTIONS(3246),
    [anon_sym_new] = ACTIONS(3246),
    [anon_sym_requires] = ACTIONS(3246),
    [sym_this] = ACTIONS(3246),
    [anon_sym_discard] = ACTIONS(3246),
    [anon_sym_precise] = ACTIONS(3246),
    [anon_sym_shared] = ACTIONS(3246),
    [anon_sym_groupshared] = ACTIONS(3246),
    [anon_sym_uniform] = ACTIONS(3246),
    [anon_sym_row_major] = ACTIONS(3246),
    [anon_sym_column_major] = ACTIONS(3246),
    [anon_sym_globallycoherent] = ACTIONS(3246),
    [anon_sym_centroid] = ACTIONS(3246),
    [anon_sym_noperspective] = ACTIONS(3246),
    [anon_sym_nointerpolation] = ACTIONS(3246),
    [anon_sym_sample] = ACTIONS(3246),
    [anon_sym_linear] = ACTIONS(3246),
    [anon_sym_snorm] = ACTIONS(3246),
    [anon_sym_unorm] = ACTIONS(3246),
    [anon_sym_point] = ACTIONS(3246),
    [anon_sym_line] = ACTIONS(3246),
    [anon_sym_triangleadj] = ACTIONS(3246),
    [anon_sym_lineadj] = ACTIONS(3246),
    [anon_sym_triangle] = ACTIONS(3246),
    [anon_sym_cbuffer] = ACTIONS(3246),
    [anon_sym_interface] = ACTIONS(3246),
    [anon_sym_extension] = ACTIONS(3246),
  },
  [669] = {
    [sym_attribute_specifier] = STATE(373),
    [sym_enumerator_list] = STATE(862),
    [ts_builtin_sym_end] = ACTIONS(3717),
    [sym_identifier] = ACTIONS(3715),
    [aux_sym_preproc_include_token1] = ACTIONS(3715),
    [aux_sym_preproc_def_token1] = ACTIONS(3715),
    [aux_sym_preproc_if_token1] = ACTIONS(3715),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3715),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3715),
    [sym_preproc_directive] = ACTIONS(3715),
    [anon_sym_LPAREN2] = ACTIONS(3717),
    [anon_sym_BANG] = ACTIONS(3717),
    [anon_sym_TILDE] = ACTIONS(3717),
    [anon_sym_DASH] = ACTIONS(3715),
    [anon_sym_PLUS] = ACTIONS(3715),
    [anon_sym_STAR] = ACTIONS(3717),
    [anon_sym_AMP_AMP] = ACTIONS(3717),
    [anon_sym_AMP] = ACTIONS(3715),
    [anon_sym_SEMI] = ACTIONS(3717),
    [anon_sym___extension__] = ACTIONS(3715),
    [anon_sym_typedef] = ACTIONS(3715),
    [anon_sym_in] = ACTIONS(3715),
    [anon_sym_out] = ACTIONS(3715),
    [anon_sym_inout] = ACTIONS(3715),
    [anon_sym_extern] = ACTIONS(3715),
    [anon_sym___attribute__] = ACTIONS(2861),
    [anon_sym_COLON_COLON] = ACTIONS(3717),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3717),
    [anon_sym___declspec] = ACTIONS(3715),
    [anon_sym___based] = ACTIONS(3715),
    [anon_sym___cdecl] = ACTIONS(3715),
    [anon_sym___clrcall] = ACTIONS(3715),
    [anon_sym___stdcall] = ACTIONS(3715),
    [anon_sym___fastcall] = ACTIONS(3715),
    [anon_sym___thiscall] = ACTIONS(3715),
    [anon_sym___vectorcall] = ACTIONS(3715),
    [anon_sym_LBRACE] = ACTIONS(3709),
    [anon_sym_signed] = ACTIONS(3715),
    [anon_sym_unsigned] = ACTIONS(3715),
    [anon_sym_long] = ACTIONS(3715),
    [anon_sym_short] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_static] = ACTIONS(3715),
    [anon_sym_register] = ACTIONS(3715),
    [anon_sym_inline] = ACTIONS(3715),
    [anon_sym___inline] = ACTIONS(3715),
    [anon_sym___inline__] = ACTIONS(3715),
    [anon_sym___forceinline] = ACTIONS(3715),
    [anon_sym_thread_local] = ACTIONS(3715),
    [anon_sym___thread] = ACTIONS(3715),
    [anon_sym_const] = ACTIONS(3715),
    [anon_sym_constexpr] = ACTIONS(3715),
    [anon_sym_volatile] = ACTIONS(3715),
    [anon_sym_restrict] = ACTIONS(3715),
    [anon_sym___restrict__] = ACTIONS(3715),
    [anon_sym__Atomic] = ACTIONS(3715),
    [anon_sym__Noreturn] = ACTIONS(3715),
    [anon_sym_noreturn] = ACTIONS(3715),
    [anon_sym_mutable] = ACTIONS(3715),
    [anon_sym_constinit] = ACTIONS(3715),
    [anon_sym_consteval] = ACTIONS(3715),
    [anon_sym_alignas] = ACTIONS(3715),
    [anon_sym__Alignas] = ACTIONS(3715),
    [sym_primitive_type] = ACTIONS(3715),
    [anon_sym_enum] = ACTIONS(3715),
    [anon_sym_class] = ACTIONS(3715),
    [anon_sym_struct] = ACTIONS(3715),
    [anon_sym_union] = ACTIONS(3715),
    [anon_sym_if] = ACTIONS(3715),
    [anon_sym_switch] = ACTIONS(3715),
    [anon_sym_case] = ACTIONS(3715),
    [anon_sym_default] = ACTIONS(3715),
    [anon_sym_while] = ACTIONS(3715),
    [anon_sym_do] = ACTIONS(3715),
    [anon_sym_for] = ACTIONS(3715),
    [anon_sym_return] = ACTIONS(3715),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_continue] = ACTIONS(3715),
    [anon_sym_goto] = ACTIONS(3715),
    [anon_sym_not] = ACTIONS(3715),
    [anon_sym_compl] = ACTIONS(3715),
    [anon_sym_DASH_DASH] = ACTIONS(3717),
    [anon_sym_PLUS_PLUS] = ACTIONS(3717),
    [anon_sym_sizeof] = ACTIONS(3715),
    [anon_sym___alignof__] = ACTIONS(3715),
    [anon_sym___alignof] = ACTIONS(3715),
    [anon_sym__alignof] = ACTIONS(3715),
    [anon_sym_alignof] = ACTIONS(3715),
    [anon_sym__Alignof] = ACTIONS(3715),
    [anon_sym_offsetof] = ACTIONS(3715),
    [anon_sym__Generic] = ACTIONS(3715),
    [anon_sym_asm] = ACTIONS(3715),
    [anon_sym___asm__] = ACTIONS(3715),
    [anon_sym_DOT] = ACTIONS(3715),
    [sym_number_literal] = ACTIONS(3717),
    [anon_sym_L_SQUOTE] = ACTIONS(3717),
    [anon_sym_u_SQUOTE] = ACTIONS(3717),
    [anon_sym_U_SQUOTE] = ACTIONS(3717),
    [anon_sym_u8_SQUOTE] = ACTIONS(3717),
    [anon_sym_SQUOTE] = ACTIONS(3717),
    [anon_sym_L_DQUOTE] = ACTIONS(3717),
    [anon_sym_u_DQUOTE] = ACTIONS(3717),
    [anon_sym_U_DQUOTE] = ACTIONS(3717),
    [anon_sym_u8_DQUOTE] = ACTIONS(3717),
    [anon_sym_DQUOTE] = ACTIONS(3717),
    [sym_true] = ACTIONS(3715),
    [sym_false] = ACTIONS(3715),
    [anon_sym_NULL] = ACTIONS(3715),
    [anon_sym_nullptr] = ACTIONS(3715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3715),
    [anon_sym_let] = ACTIONS(3715),
    [anon_sym_This] = ACTIONS(3715),
    [anon_sym_decltype] = ACTIONS(3715),
    [sym_virtual] = ACTIONS(3715),
    [anon_sym_explicit] = ACTIONS(3715),
    [anon_sym_typename] = ACTIONS(3715),
    [anon_sym_template] = ACTIONS(3715),
    [anon_sym_operator] = ACTIONS(3715),
    [anon_sym_try] = ACTIONS(3715),
    [anon_sym_delete] = ACTIONS(3715),
    [anon_sym_throw] = ACTIONS(3715),
    [anon_sym_namespace] = ACTIONS(3715),
    [anon_sym_using] = ACTIONS(3715),
    [anon_sym_static_assert] = ACTIONS(3715),
    [anon_sym_concept] = ACTIONS(3715),
    [anon_sym_co_return] = ACTIONS(3715),
    [anon_sym_co_yield] = ACTIONS(3715),
    [anon_sym_R_DQUOTE] = ACTIONS(3717),
    [anon_sym_LR_DQUOTE] = ACTIONS(3717),
    [anon_sym_uR_DQUOTE] = ACTIONS(3717),
    [anon_sym_UR_DQUOTE] = ACTIONS(3717),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3717),
    [anon_sym_co_await] = ACTIONS(3715),
    [anon_sym_new] = ACTIONS(3715),
    [anon_sym_requires] = ACTIONS(3715),
    [sym_this] = ACTIONS(3715),
    [anon_sym_precise] = ACTIONS(3715),
    [anon_sym_shared] = ACTIONS(3715),
    [anon_sym_groupshared] = ACTIONS(3715),
    [anon_sym_uniform] = ACTIONS(3715),
    [anon_sym_row_major] = ACTIONS(3715),
    [anon_sym_column_major] = ACTIONS(3715),
    [anon_sym_globallycoherent] = ACTIONS(3715),
    [anon_sym_centroid] = ACTIONS(3715),
    [anon_sym_noperspective] = ACTIONS(3715),
    [anon_sym_nointerpolation] = ACTIONS(3715),
    [anon_sym_sample] = ACTIONS(3715),
    [anon_sym_linear] = ACTIONS(3715),
    [anon_sym_snorm] = ACTIONS(3715),
    [anon_sym_unorm] = ACTIONS(3715),
    [anon_sym_point] = ACTIONS(3715),
    [anon_sym_line] = ACTIONS(3715),
    [anon_sym_triangleadj] = ACTIONS(3715),
    [anon_sym_lineadj] = ACTIONS(3715),
    [anon_sym_triangle] = ACTIONS(3715),
    [anon_sym_interface] = ACTIONS(3715),
    [anon_sym_extension] = ACTIONS(3715),
    [anon_sym___exported] = ACTIONS(3715),
    [anon_sym_import] = ACTIONS(3715),
  },
  [670] = {
    [sym_identifier] = ACTIONS(3404),
    [aux_sym_preproc_include_token1] = ACTIONS(3404),
    [aux_sym_preproc_def_token1] = ACTIONS(3404),
    [aux_sym_preproc_if_token1] = ACTIONS(3404),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3404),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3404),
    [sym_preproc_directive] = ACTIONS(3404),
    [anon_sym_LPAREN2] = ACTIONS(3402),
    [anon_sym_BANG] = ACTIONS(3402),
    [anon_sym_TILDE] = ACTIONS(3402),
    [anon_sym_DASH] = ACTIONS(3404),
    [anon_sym_PLUS] = ACTIONS(3404),
    [anon_sym_STAR] = ACTIONS(3402),
    [anon_sym_AMP_AMP] = ACTIONS(3402),
    [anon_sym_AMP] = ACTIONS(3404),
    [anon_sym_SEMI] = ACTIONS(3402),
    [anon_sym___extension__] = ACTIONS(3404),
    [anon_sym_typedef] = ACTIONS(3404),
    [anon_sym_in] = ACTIONS(3404),
    [anon_sym_out] = ACTIONS(3404),
    [anon_sym_inout] = ACTIONS(3404),
    [anon_sym_extern] = ACTIONS(3404),
    [anon_sym___attribute__] = ACTIONS(3404),
    [anon_sym_COLON_COLON] = ACTIONS(3402),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3402),
    [anon_sym___declspec] = ACTIONS(3404),
    [anon_sym___based] = ACTIONS(3404),
    [anon_sym___cdecl] = ACTIONS(3404),
    [anon_sym___clrcall] = ACTIONS(3404),
    [anon_sym___stdcall] = ACTIONS(3404),
    [anon_sym___fastcall] = ACTIONS(3404),
    [anon_sym___thiscall] = ACTIONS(3404),
    [anon_sym___vectorcall] = ACTIONS(3404),
    [anon_sym_LBRACE] = ACTIONS(3402),
    [anon_sym_RBRACE] = ACTIONS(3402),
    [anon_sym_signed] = ACTIONS(3404),
    [anon_sym_unsigned] = ACTIONS(3404),
    [anon_sym_long] = ACTIONS(3404),
    [anon_sym_short] = ACTIONS(3404),
    [anon_sym_LBRACK] = ACTIONS(3404),
    [anon_sym_static] = ACTIONS(3404),
    [anon_sym_register] = ACTIONS(3404),
    [anon_sym_inline] = ACTIONS(3404),
    [anon_sym___inline] = ACTIONS(3404),
    [anon_sym___inline__] = ACTIONS(3404),
    [anon_sym___forceinline] = ACTIONS(3404),
    [anon_sym_thread_local] = ACTIONS(3404),
    [anon_sym___thread] = ACTIONS(3404),
    [anon_sym_const] = ACTIONS(3404),
    [anon_sym_constexpr] = ACTIONS(3404),
    [anon_sym_volatile] = ACTIONS(3404),
    [anon_sym_restrict] = ACTIONS(3404),
    [anon_sym___restrict__] = ACTIONS(3404),
    [anon_sym__Atomic] = ACTIONS(3404),
    [anon_sym__Noreturn] = ACTIONS(3404),
    [anon_sym_noreturn] = ACTIONS(3404),
    [anon_sym_mutable] = ACTIONS(3404),
    [anon_sym_constinit] = ACTIONS(3404),
    [anon_sym_consteval] = ACTIONS(3404),
    [anon_sym_alignas] = ACTIONS(3404),
    [anon_sym__Alignas] = ACTIONS(3404),
    [sym_primitive_type] = ACTIONS(3404),
    [anon_sym_enum] = ACTIONS(3404),
    [anon_sym_class] = ACTIONS(3404),
    [anon_sym_struct] = ACTIONS(3404),
    [anon_sym_union] = ACTIONS(3404),
    [anon_sym_if] = ACTIONS(3404),
    [anon_sym_switch] = ACTIONS(3404),
    [anon_sym_case] = ACTIONS(3404),
    [anon_sym_default] = ACTIONS(3404),
    [anon_sym_while] = ACTIONS(3404),
    [anon_sym_do] = ACTIONS(3404),
    [anon_sym_for] = ACTIONS(3404),
    [anon_sym_return] = ACTIONS(3404),
    [anon_sym_break] = ACTIONS(3404),
    [anon_sym_continue] = ACTIONS(3404),
    [anon_sym_goto] = ACTIONS(3404),
    [anon_sym___try] = ACTIONS(3404),
    [anon_sym___leave] = ACTIONS(3404),
    [anon_sym_not] = ACTIONS(3404),
    [anon_sym_compl] = ACTIONS(3404),
    [anon_sym_DASH_DASH] = ACTIONS(3402),
    [anon_sym_PLUS_PLUS] = ACTIONS(3402),
    [anon_sym_sizeof] = ACTIONS(3404),
    [anon_sym___alignof__] = ACTIONS(3404),
    [anon_sym___alignof] = ACTIONS(3404),
    [anon_sym__alignof] = ACTIONS(3404),
    [anon_sym_alignof] = ACTIONS(3404),
    [anon_sym__Alignof] = ACTIONS(3404),
    [anon_sym_offsetof] = ACTIONS(3404),
    [anon_sym__Generic] = ACTIONS(3404),
    [anon_sym_asm] = ACTIONS(3404),
    [anon_sym___asm__] = ACTIONS(3404),
    [anon_sym_DOT] = ACTIONS(3404),
    [sym_number_literal] = ACTIONS(3402),
    [anon_sym_L_SQUOTE] = ACTIONS(3402),
    [anon_sym_u_SQUOTE] = ACTIONS(3402),
    [anon_sym_U_SQUOTE] = ACTIONS(3402),
    [anon_sym_u8_SQUOTE] = ACTIONS(3402),
    [anon_sym_SQUOTE] = ACTIONS(3402),
    [anon_sym_L_DQUOTE] = ACTIONS(3402),
    [anon_sym_u_DQUOTE] = ACTIONS(3402),
    [anon_sym_U_DQUOTE] = ACTIONS(3402),
    [anon_sym_u8_DQUOTE] = ACTIONS(3402),
    [anon_sym_DQUOTE] = ACTIONS(3402),
    [sym_true] = ACTIONS(3404),
    [sym_false] = ACTIONS(3404),
    [anon_sym_NULL] = ACTIONS(3404),
    [anon_sym_nullptr] = ACTIONS(3404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3404),
    [anon_sym_let] = ACTIONS(3404),
    [anon_sym_This] = ACTIONS(3404),
    [anon_sym_decltype] = ACTIONS(3404),
    [sym_virtual] = ACTIONS(3404),
    [anon_sym_explicit] = ACTIONS(3404),
    [anon_sym_typename] = ACTIONS(3404),
    [anon_sym_template] = ACTIONS(3404),
    [anon_sym_operator] = ACTIONS(3404),
    [anon_sym_try] = ACTIONS(3404),
    [anon_sym_delete] = ACTIONS(3404),
    [anon_sym_throw] = ACTIONS(3404),
    [anon_sym_namespace] = ACTIONS(3404),
    [anon_sym_using] = ACTIONS(3404),
    [anon_sym_static_assert] = ACTIONS(3404),
    [anon_sym_concept] = ACTIONS(3404),
    [anon_sym_co_return] = ACTIONS(3404),
    [anon_sym_co_yield] = ACTIONS(3404),
    [anon_sym_R_DQUOTE] = ACTIONS(3402),
    [anon_sym_LR_DQUOTE] = ACTIONS(3402),
    [anon_sym_uR_DQUOTE] = ACTIONS(3402),
    [anon_sym_UR_DQUOTE] = ACTIONS(3402),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3402),
    [anon_sym_co_await] = ACTIONS(3404),
    [anon_sym_new] = ACTIONS(3404),
    [anon_sym_requires] = ACTIONS(3404),
    [sym_this] = ACTIONS(3404),
    [anon_sym_discard] = ACTIONS(3404),
    [anon_sym_precise] = ACTIONS(3404),
    [anon_sym_shared] = ACTIONS(3404),
    [anon_sym_groupshared] = ACTIONS(3404),
    [anon_sym_uniform] = ACTIONS(3404),
    [anon_sym_row_major] = ACTIONS(3404),
    [anon_sym_column_major] = ACTIONS(3404),
    [anon_sym_globallycoherent] = ACTIONS(3404),
    [anon_sym_centroid] = ACTIONS(3404),
    [anon_sym_noperspective] = ACTIONS(3404),
    [anon_sym_nointerpolation] = ACTIONS(3404),
    [anon_sym_sample] = ACTIONS(3404),
    [anon_sym_linear] = ACTIONS(3404),
    [anon_sym_snorm] = ACTIONS(3404),
    [anon_sym_unorm] = ACTIONS(3404),
    [anon_sym_point] = ACTIONS(3404),
    [anon_sym_line] = ACTIONS(3404),
    [anon_sym_triangleadj] = ACTIONS(3404),
    [anon_sym_lineadj] = ACTIONS(3404),
    [anon_sym_triangle] = ACTIONS(3404),
    [anon_sym_cbuffer] = ACTIONS(3404),
    [anon_sym_interface] = ACTIONS(3404),
    [anon_sym_extension] = ACTIONS(3404),
  },
  [671] = {
    [sym_identifier] = ACTIONS(3242),
    [aux_sym_preproc_include_token1] = ACTIONS(3242),
    [aux_sym_preproc_def_token1] = ACTIONS(3242),
    [aux_sym_preproc_if_token1] = ACTIONS(3242),
    [aux_sym_preproc_if_token2] = ACTIONS(3242),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3242),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3242),
    [sym_preproc_directive] = ACTIONS(3242),
    [anon_sym_LPAREN2] = ACTIONS(3244),
    [anon_sym_BANG] = ACTIONS(3244),
    [anon_sym_TILDE] = ACTIONS(3244),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_STAR] = ACTIONS(3244),
    [anon_sym_AMP_AMP] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_SEMI] = ACTIONS(3244),
    [anon_sym___extension__] = ACTIONS(3242),
    [anon_sym_typedef] = ACTIONS(3242),
    [anon_sym_in] = ACTIONS(3242),
    [anon_sym_out] = ACTIONS(3242),
    [anon_sym_inout] = ACTIONS(3242),
    [anon_sym_extern] = ACTIONS(3242),
    [anon_sym___attribute__] = ACTIONS(3242),
    [anon_sym_COLON_COLON] = ACTIONS(3244),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3244),
    [anon_sym___declspec] = ACTIONS(3242),
    [anon_sym___based] = ACTIONS(3242),
    [anon_sym___cdecl] = ACTIONS(3242),
    [anon_sym___clrcall] = ACTIONS(3242),
    [anon_sym___stdcall] = ACTIONS(3242),
    [anon_sym___fastcall] = ACTIONS(3242),
    [anon_sym___thiscall] = ACTIONS(3242),
    [anon_sym___vectorcall] = ACTIONS(3242),
    [anon_sym_LBRACE] = ACTIONS(3244),
    [anon_sym_signed] = ACTIONS(3242),
    [anon_sym_unsigned] = ACTIONS(3242),
    [anon_sym_long] = ACTIONS(3242),
    [anon_sym_short] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_static] = ACTIONS(3242),
    [anon_sym_register] = ACTIONS(3242),
    [anon_sym_inline] = ACTIONS(3242),
    [anon_sym___inline] = ACTIONS(3242),
    [anon_sym___inline__] = ACTIONS(3242),
    [anon_sym___forceinline] = ACTIONS(3242),
    [anon_sym_thread_local] = ACTIONS(3242),
    [anon_sym___thread] = ACTIONS(3242),
    [anon_sym_const] = ACTIONS(3242),
    [anon_sym_constexpr] = ACTIONS(3242),
    [anon_sym_volatile] = ACTIONS(3242),
    [anon_sym_restrict] = ACTIONS(3242),
    [anon_sym___restrict__] = ACTIONS(3242),
    [anon_sym__Atomic] = ACTIONS(3242),
    [anon_sym__Noreturn] = ACTIONS(3242),
    [anon_sym_noreturn] = ACTIONS(3242),
    [anon_sym_mutable] = ACTIONS(3242),
    [anon_sym_constinit] = ACTIONS(3242),
    [anon_sym_consteval] = ACTIONS(3242),
    [anon_sym_alignas] = ACTIONS(3242),
    [anon_sym__Alignas] = ACTIONS(3242),
    [sym_primitive_type] = ACTIONS(3242),
    [anon_sym_enum] = ACTIONS(3242),
    [anon_sym_class] = ACTIONS(3242),
    [anon_sym_struct] = ACTIONS(3242),
    [anon_sym_union] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_else] = ACTIONS(3242),
    [anon_sym_switch] = ACTIONS(3242),
    [anon_sym_case] = ACTIONS(3242),
    [anon_sym_default] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_break] = ACTIONS(3242),
    [anon_sym_continue] = ACTIONS(3242),
    [anon_sym_goto] = ACTIONS(3242),
    [anon_sym___try] = ACTIONS(3242),
    [anon_sym___leave] = ACTIONS(3242),
    [anon_sym_not] = ACTIONS(3242),
    [anon_sym_compl] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3244),
    [anon_sym_PLUS_PLUS] = ACTIONS(3244),
    [anon_sym_sizeof] = ACTIONS(3242),
    [anon_sym___alignof__] = ACTIONS(3242),
    [anon_sym___alignof] = ACTIONS(3242),
    [anon_sym__alignof] = ACTIONS(3242),
    [anon_sym_alignof] = ACTIONS(3242),
    [anon_sym__Alignof] = ACTIONS(3242),
    [anon_sym_offsetof] = ACTIONS(3242),
    [anon_sym__Generic] = ACTIONS(3242),
    [anon_sym_asm] = ACTIONS(3242),
    [anon_sym___asm__] = ACTIONS(3242),
    [sym_number_literal] = ACTIONS(3244),
    [anon_sym_L_SQUOTE] = ACTIONS(3244),
    [anon_sym_u_SQUOTE] = ACTIONS(3244),
    [anon_sym_U_SQUOTE] = ACTIONS(3244),
    [anon_sym_u8_SQUOTE] = ACTIONS(3244),
    [anon_sym_SQUOTE] = ACTIONS(3244),
    [anon_sym_L_DQUOTE] = ACTIONS(3244),
    [anon_sym_u_DQUOTE] = ACTIONS(3244),
    [anon_sym_U_DQUOTE] = ACTIONS(3244),
    [anon_sym_u8_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE] = ACTIONS(3244),
    [sym_true] = ACTIONS(3242),
    [sym_false] = ACTIONS(3242),
    [anon_sym_NULL] = ACTIONS(3242),
    [anon_sym_nullptr] = ACTIONS(3242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_This] = ACTIONS(3242),
    [anon_sym_decltype] = ACTIONS(3242),
    [sym_virtual] = ACTIONS(3242),
    [anon_sym_explicit] = ACTIONS(3242),
    [anon_sym_typename] = ACTIONS(3242),
    [anon_sym_template] = ACTIONS(3242),
    [anon_sym_operator] = ACTIONS(3242),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_delete] = ACTIONS(3242),
    [anon_sym_throw] = ACTIONS(3242),
    [anon_sym_namespace] = ACTIONS(3242),
    [anon_sym_using] = ACTIONS(3242),
    [anon_sym_static_assert] = ACTIONS(3242),
    [anon_sym_concept] = ACTIONS(3242),
    [anon_sym_co_return] = ACTIONS(3242),
    [anon_sym_co_yield] = ACTIONS(3242),
    [anon_sym_R_DQUOTE] = ACTIONS(3244),
    [anon_sym_LR_DQUOTE] = ACTIONS(3244),
    [anon_sym_uR_DQUOTE] = ACTIONS(3244),
    [anon_sym_UR_DQUOTE] = ACTIONS(3244),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3244),
    [anon_sym_co_await] = ACTIONS(3242),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_requires] = ACTIONS(3242),
    [sym_this] = ACTIONS(3242),
    [anon_sym_discard] = ACTIONS(3242),
    [anon_sym_precise] = ACTIONS(3242),
    [anon_sym_shared] = ACTIONS(3242),
    [anon_sym_groupshared] = ACTIONS(3242),
    [anon_sym_uniform] = ACTIONS(3242),
    [anon_sym_row_major] = ACTIONS(3242),
    [anon_sym_column_major] = ACTIONS(3242),
    [anon_sym_globallycoherent] = ACTIONS(3242),
    [anon_sym_centroid] = ACTIONS(3242),
    [anon_sym_noperspective] = ACTIONS(3242),
    [anon_sym_nointerpolation] = ACTIONS(3242),
    [anon_sym_sample] = ACTIONS(3242),
    [anon_sym_linear] = ACTIONS(3242),
    [anon_sym_snorm] = ACTIONS(3242),
    [anon_sym_unorm] = ACTIONS(3242),
    [anon_sym_point] = ACTIONS(3242),
    [anon_sym_line] = ACTIONS(3242),
    [anon_sym_triangleadj] = ACTIONS(3242),
    [anon_sym_lineadj] = ACTIONS(3242),
    [anon_sym_triangle] = ACTIONS(3242),
    [anon_sym_cbuffer] = ACTIONS(3242),
    [anon_sym_interface] = ACTIONS(3242),
    [anon_sym_extension] = ACTIONS(3242),
  },
  [672] = {
    [sym_identifier] = ACTIONS(3030),
    [aux_sym_preproc_include_token1] = ACTIONS(3030),
    [aux_sym_preproc_def_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token2] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3030),
    [sym_preproc_directive] = ACTIONS(3030),
    [anon_sym_LPAREN2] = ACTIONS(3032),
    [anon_sym_BANG] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3030),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym___extension__] = ACTIONS(3030),
    [anon_sym_typedef] = ACTIONS(3030),
    [anon_sym_in] = ACTIONS(3030),
    [anon_sym_out] = ACTIONS(3030),
    [anon_sym_inout] = ACTIONS(3030),
    [anon_sym_extern] = ACTIONS(3030),
    [anon_sym___attribute__] = ACTIONS(3030),
    [anon_sym_COLON_COLON] = ACTIONS(3032),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3032),
    [anon_sym___declspec] = ACTIONS(3030),
    [anon_sym___based] = ACTIONS(3030),
    [anon_sym___cdecl] = ACTIONS(3030),
    [anon_sym___clrcall] = ACTIONS(3030),
    [anon_sym___stdcall] = ACTIONS(3030),
    [anon_sym___fastcall] = ACTIONS(3030),
    [anon_sym___thiscall] = ACTIONS(3030),
    [anon_sym___vectorcall] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_signed] = ACTIONS(3030),
    [anon_sym_unsigned] = ACTIONS(3030),
    [anon_sym_long] = ACTIONS(3030),
    [anon_sym_short] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_static] = ACTIONS(3030),
    [anon_sym_register] = ACTIONS(3030),
    [anon_sym_inline] = ACTIONS(3030),
    [anon_sym___inline] = ACTIONS(3030),
    [anon_sym___inline__] = ACTIONS(3030),
    [anon_sym___forceinline] = ACTIONS(3030),
    [anon_sym_thread_local] = ACTIONS(3030),
    [anon_sym___thread] = ACTIONS(3030),
    [anon_sym_const] = ACTIONS(3030),
    [anon_sym_constexpr] = ACTIONS(3030),
    [anon_sym_volatile] = ACTIONS(3030),
    [anon_sym_restrict] = ACTIONS(3030),
    [anon_sym___restrict__] = ACTIONS(3030),
    [anon_sym__Atomic] = ACTIONS(3030),
    [anon_sym__Noreturn] = ACTIONS(3030),
    [anon_sym_noreturn] = ACTIONS(3030),
    [anon_sym_mutable] = ACTIONS(3030),
    [anon_sym_constinit] = ACTIONS(3030),
    [anon_sym_consteval] = ACTIONS(3030),
    [anon_sym_alignas] = ACTIONS(3030),
    [anon_sym__Alignas] = ACTIONS(3030),
    [sym_primitive_type] = ACTIONS(3030),
    [anon_sym_enum] = ACTIONS(3030),
    [anon_sym_class] = ACTIONS(3030),
    [anon_sym_struct] = ACTIONS(3030),
    [anon_sym_union] = ACTIONS(3030),
    [anon_sym_if] = ACTIONS(3030),
    [anon_sym_else] = ACTIONS(3030),
    [anon_sym_switch] = ACTIONS(3030),
    [anon_sym_case] = ACTIONS(3030),
    [anon_sym_default] = ACTIONS(3030),
    [anon_sym_while] = ACTIONS(3030),
    [anon_sym_do] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3030),
    [anon_sym_return] = ACTIONS(3030),
    [anon_sym_break] = ACTIONS(3030),
    [anon_sym_continue] = ACTIONS(3030),
    [anon_sym_goto] = ACTIONS(3030),
    [anon_sym___try] = ACTIONS(3030),
    [anon_sym___leave] = ACTIONS(3030),
    [anon_sym_not] = ACTIONS(3030),
    [anon_sym_compl] = ACTIONS(3030),
    [anon_sym_DASH_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_PLUS] = ACTIONS(3032),
    [anon_sym_sizeof] = ACTIONS(3030),
    [anon_sym___alignof__] = ACTIONS(3030),
    [anon_sym___alignof] = ACTIONS(3030),
    [anon_sym__alignof] = ACTIONS(3030),
    [anon_sym_alignof] = ACTIONS(3030),
    [anon_sym__Alignof] = ACTIONS(3030),
    [anon_sym_offsetof] = ACTIONS(3030),
    [anon_sym__Generic] = ACTIONS(3030),
    [anon_sym_asm] = ACTIONS(3030),
    [anon_sym___asm__] = ACTIONS(3030),
    [sym_number_literal] = ACTIONS(3032),
    [anon_sym_L_SQUOTE] = ACTIONS(3032),
    [anon_sym_u_SQUOTE] = ACTIONS(3032),
    [anon_sym_U_SQUOTE] = ACTIONS(3032),
    [anon_sym_u8_SQUOTE] = ACTIONS(3032),
    [anon_sym_SQUOTE] = ACTIONS(3032),
    [anon_sym_L_DQUOTE] = ACTIONS(3032),
    [anon_sym_u_DQUOTE] = ACTIONS(3032),
    [anon_sym_U_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [sym_true] = ACTIONS(3030),
    [sym_false] = ACTIONS(3030),
    [anon_sym_NULL] = ACTIONS(3030),
    [anon_sym_nullptr] = ACTIONS(3030),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3030),
    [anon_sym_let] = ACTIONS(3030),
    [anon_sym_This] = ACTIONS(3030),
    [anon_sym_decltype] = ACTIONS(3030),
    [sym_virtual] = ACTIONS(3030),
    [anon_sym_explicit] = ACTIONS(3030),
    [anon_sym_typename] = ACTIONS(3030),
    [anon_sym_template] = ACTIONS(3030),
    [anon_sym_operator] = ACTIONS(3030),
    [anon_sym_try] = ACTIONS(3030),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_throw] = ACTIONS(3030),
    [anon_sym_namespace] = ACTIONS(3030),
    [anon_sym_using] = ACTIONS(3030),
    [anon_sym_static_assert] = ACTIONS(3030),
    [anon_sym_concept] = ACTIONS(3030),
    [anon_sym_co_return] = ACTIONS(3030),
    [anon_sym_co_yield] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3030),
    [anon_sym_requires] = ACTIONS(3030),
    [sym_this] = ACTIONS(3030),
    [anon_sym_discard] = ACTIONS(3030),
    [anon_sym_precise] = ACTIONS(3030),
    [anon_sym_shared] = ACTIONS(3030),
    [anon_sym_groupshared] = ACTIONS(3030),
    [anon_sym_uniform] = ACTIONS(3030),
    [anon_sym_row_major] = ACTIONS(3030),
    [anon_sym_column_major] = ACTIONS(3030),
    [anon_sym_globallycoherent] = ACTIONS(3030),
    [anon_sym_centroid] = ACTIONS(3030),
    [anon_sym_noperspective] = ACTIONS(3030),
    [anon_sym_nointerpolation] = ACTIONS(3030),
    [anon_sym_sample] = ACTIONS(3030),
    [anon_sym_linear] = ACTIONS(3030),
    [anon_sym_snorm] = ACTIONS(3030),
    [anon_sym_unorm] = ACTIONS(3030),
    [anon_sym_point] = ACTIONS(3030),
    [anon_sym_line] = ACTIONS(3030),
    [anon_sym_triangleadj] = ACTIONS(3030),
    [anon_sym_lineadj] = ACTIONS(3030),
    [anon_sym_triangle] = ACTIONS(3030),
    [anon_sym_cbuffer] = ACTIONS(3030),
    [anon_sym_interface] = ACTIONS(3030),
    [anon_sym_extension] = ACTIONS(3030),
  },
  [673] = {
    [sym_identifier] = ACTIONS(3210),
    [aux_sym_preproc_include_token1] = ACTIONS(3210),
    [aux_sym_preproc_def_token1] = ACTIONS(3210),
    [aux_sym_preproc_if_token1] = ACTIONS(3210),
    [aux_sym_preproc_if_token2] = ACTIONS(3210),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3210),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3210),
    [sym_preproc_directive] = ACTIONS(3210),
    [anon_sym_LPAREN2] = ACTIONS(3212),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3210),
    [anon_sym_PLUS] = ACTIONS(3210),
    [anon_sym_STAR] = ACTIONS(3212),
    [anon_sym_AMP_AMP] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3210),
    [anon_sym_SEMI] = ACTIONS(3212),
    [anon_sym___extension__] = ACTIONS(3210),
    [anon_sym_typedef] = ACTIONS(3210),
    [anon_sym_in] = ACTIONS(3210),
    [anon_sym_out] = ACTIONS(3210),
    [anon_sym_inout] = ACTIONS(3210),
    [anon_sym_extern] = ACTIONS(3210),
    [anon_sym___attribute__] = ACTIONS(3210),
    [anon_sym_COLON_COLON] = ACTIONS(3212),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3212),
    [anon_sym___declspec] = ACTIONS(3210),
    [anon_sym___based] = ACTIONS(3210),
    [anon_sym___cdecl] = ACTIONS(3210),
    [anon_sym___clrcall] = ACTIONS(3210),
    [anon_sym___stdcall] = ACTIONS(3210),
    [anon_sym___fastcall] = ACTIONS(3210),
    [anon_sym___thiscall] = ACTIONS(3210),
    [anon_sym___vectorcall] = ACTIONS(3210),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_signed] = ACTIONS(3210),
    [anon_sym_unsigned] = ACTIONS(3210),
    [anon_sym_long] = ACTIONS(3210),
    [anon_sym_short] = ACTIONS(3210),
    [anon_sym_LBRACK] = ACTIONS(3210),
    [anon_sym_static] = ACTIONS(3210),
    [anon_sym_register] = ACTIONS(3210),
    [anon_sym_inline] = ACTIONS(3210),
    [anon_sym___inline] = ACTIONS(3210),
    [anon_sym___inline__] = ACTIONS(3210),
    [anon_sym___forceinline] = ACTIONS(3210),
    [anon_sym_thread_local] = ACTIONS(3210),
    [anon_sym___thread] = ACTIONS(3210),
    [anon_sym_const] = ACTIONS(3210),
    [anon_sym_constexpr] = ACTIONS(3210),
    [anon_sym_volatile] = ACTIONS(3210),
    [anon_sym_restrict] = ACTIONS(3210),
    [anon_sym___restrict__] = ACTIONS(3210),
    [anon_sym__Atomic] = ACTIONS(3210),
    [anon_sym__Noreturn] = ACTIONS(3210),
    [anon_sym_noreturn] = ACTIONS(3210),
    [anon_sym_mutable] = ACTIONS(3210),
    [anon_sym_constinit] = ACTIONS(3210),
    [anon_sym_consteval] = ACTIONS(3210),
    [anon_sym_alignas] = ACTIONS(3210),
    [anon_sym__Alignas] = ACTIONS(3210),
    [sym_primitive_type] = ACTIONS(3210),
    [anon_sym_enum] = ACTIONS(3210),
    [anon_sym_class] = ACTIONS(3210),
    [anon_sym_struct] = ACTIONS(3210),
    [anon_sym_union] = ACTIONS(3210),
    [anon_sym_if] = ACTIONS(3210),
    [anon_sym_else] = ACTIONS(3210),
    [anon_sym_switch] = ACTIONS(3210),
    [anon_sym_case] = ACTIONS(3210),
    [anon_sym_default] = ACTIONS(3210),
    [anon_sym_while] = ACTIONS(3210),
    [anon_sym_do] = ACTIONS(3210),
    [anon_sym_for] = ACTIONS(3210),
    [anon_sym_return] = ACTIONS(3210),
    [anon_sym_break] = ACTIONS(3210),
    [anon_sym_continue] = ACTIONS(3210),
    [anon_sym_goto] = ACTIONS(3210),
    [anon_sym___try] = ACTIONS(3210),
    [anon_sym___leave] = ACTIONS(3210),
    [anon_sym_not] = ACTIONS(3210),
    [anon_sym_compl] = ACTIONS(3210),
    [anon_sym_DASH_DASH] = ACTIONS(3212),
    [anon_sym_PLUS_PLUS] = ACTIONS(3212),
    [anon_sym_sizeof] = ACTIONS(3210),
    [anon_sym___alignof__] = ACTIONS(3210),
    [anon_sym___alignof] = ACTIONS(3210),
    [anon_sym__alignof] = ACTIONS(3210),
    [anon_sym_alignof] = ACTIONS(3210),
    [anon_sym__Alignof] = ACTIONS(3210),
    [anon_sym_offsetof] = ACTIONS(3210),
    [anon_sym__Generic] = ACTIONS(3210),
    [anon_sym_asm] = ACTIONS(3210),
    [anon_sym___asm__] = ACTIONS(3210),
    [sym_number_literal] = ACTIONS(3212),
    [anon_sym_L_SQUOTE] = ACTIONS(3212),
    [anon_sym_u_SQUOTE] = ACTIONS(3212),
    [anon_sym_U_SQUOTE] = ACTIONS(3212),
    [anon_sym_u8_SQUOTE] = ACTIONS(3212),
    [anon_sym_SQUOTE] = ACTIONS(3212),
    [anon_sym_L_DQUOTE] = ACTIONS(3212),
    [anon_sym_u_DQUOTE] = ACTIONS(3212),
    [anon_sym_U_DQUOTE] = ACTIONS(3212),
    [anon_sym_u8_DQUOTE] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [sym_true] = ACTIONS(3210),
    [sym_false] = ACTIONS(3210),
    [anon_sym_NULL] = ACTIONS(3210),
    [anon_sym_nullptr] = ACTIONS(3210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3210),
    [anon_sym_let] = ACTIONS(3210),
    [anon_sym_This] = ACTIONS(3210),
    [anon_sym_decltype] = ACTIONS(3210),
    [sym_virtual] = ACTIONS(3210),
    [anon_sym_explicit] = ACTIONS(3210),
    [anon_sym_typename] = ACTIONS(3210),
    [anon_sym_template] = ACTIONS(3210),
    [anon_sym_operator] = ACTIONS(3210),
    [anon_sym_try] = ACTIONS(3210),
    [anon_sym_delete] = ACTIONS(3210),
    [anon_sym_throw] = ACTIONS(3210),
    [anon_sym_namespace] = ACTIONS(3210),
    [anon_sym_using] = ACTIONS(3210),
    [anon_sym_static_assert] = ACTIONS(3210),
    [anon_sym_concept] = ACTIONS(3210),
    [anon_sym_co_return] = ACTIONS(3210),
    [anon_sym_co_yield] = ACTIONS(3210),
    [anon_sym_R_DQUOTE] = ACTIONS(3212),
    [anon_sym_LR_DQUOTE] = ACTIONS(3212),
    [anon_sym_uR_DQUOTE] = ACTIONS(3212),
    [anon_sym_UR_DQUOTE] = ACTIONS(3212),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3212),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3210),
    [anon_sym_requires] = ACTIONS(3210),
    [sym_this] = ACTIONS(3210),
    [anon_sym_discard] = ACTIONS(3210),
    [anon_sym_precise] = ACTIONS(3210),
    [anon_sym_shared] = ACTIONS(3210),
    [anon_sym_groupshared] = ACTIONS(3210),
    [anon_sym_uniform] = ACTIONS(3210),
    [anon_sym_row_major] = ACTIONS(3210),
    [anon_sym_column_major] = ACTIONS(3210),
    [anon_sym_globallycoherent] = ACTIONS(3210),
    [anon_sym_centroid] = ACTIONS(3210),
    [anon_sym_noperspective] = ACTIONS(3210),
    [anon_sym_nointerpolation] = ACTIONS(3210),
    [anon_sym_sample] = ACTIONS(3210),
    [anon_sym_linear] = ACTIONS(3210),
    [anon_sym_snorm] = ACTIONS(3210),
    [anon_sym_unorm] = ACTIONS(3210),
    [anon_sym_point] = ACTIONS(3210),
    [anon_sym_line] = ACTIONS(3210),
    [anon_sym_triangleadj] = ACTIONS(3210),
    [anon_sym_lineadj] = ACTIONS(3210),
    [anon_sym_triangle] = ACTIONS(3210),
    [anon_sym_cbuffer] = ACTIONS(3210),
    [anon_sym_interface] = ACTIONS(3210),
    [anon_sym_extension] = ACTIONS(3210),
  },
  [674] = {
    [sym_identifier] = ACTIONS(3222),
    [aux_sym_preproc_include_token1] = ACTIONS(3222),
    [aux_sym_preproc_def_token1] = ACTIONS(3222),
    [aux_sym_preproc_if_token1] = ACTIONS(3222),
    [aux_sym_preproc_if_token2] = ACTIONS(3222),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3222),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3222),
    [sym_preproc_directive] = ACTIONS(3222),
    [anon_sym_LPAREN2] = ACTIONS(3224),
    [anon_sym_BANG] = ACTIONS(3224),
    [anon_sym_TILDE] = ACTIONS(3224),
    [anon_sym_DASH] = ACTIONS(3222),
    [anon_sym_PLUS] = ACTIONS(3222),
    [anon_sym_STAR] = ACTIONS(3224),
    [anon_sym_AMP_AMP] = ACTIONS(3224),
    [anon_sym_AMP] = ACTIONS(3222),
    [anon_sym_SEMI] = ACTIONS(3224),
    [anon_sym___extension__] = ACTIONS(3222),
    [anon_sym_typedef] = ACTIONS(3222),
    [anon_sym_in] = ACTIONS(3222),
    [anon_sym_out] = ACTIONS(3222),
    [anon_sym_inout] = ACTIONS(3222),
    [anon_sym_extern] = ACTIONS(3222),
    [anon_sym___attribute__] = ACTIONS(3222),
    [anon_sym_COLON_COLON] = ACTIONS(3224),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3224),
    [anon_sym___declspec] = ACTIONS(3222),
    [anon_sym___based] = ACTIONS(3222),
    [anon_sym___cdecl] = ACTIONS(3222),
    [anon_sym___clrcall] = ACTIONS(3222),
    [anon_sym___stdcall] = ACTIONS(3222),
    [anon_sym___fastcall] = ACTIONS(3222),
    [anon_sym___thiscall] = ACTIONS(3222),
    [anon_sym___vectorcall] = ACTIONS(3222),
    [anon_sym_LBRACE] = ACTIONS(3224),
    [anon_sym_signed] = ACTIONS(3222),
    [anon_sym_unsigned] = ACTIONS(3222),
    [anon_sym_long] = ACTIONS(3222),
    [anon_sym_short] = ACTIONS(3222),
    [anon_sym_LBRACK] = ACTIONS(3222),
    [anon_sym_static] = ACTIONS(3222),
    [anon_sym_register] = ACTIONS(3222),
    [anon_sym_inline] = ACTIONS(3222),
    [anon_sym___inline] = ACTIONS(3222),
    [anon_sym___inline__] = ACTIONS(3222),
    [anon_sym___forceinline] = ACTIONS(3222),
    [anon_sym_thread_local] = ACTIONS(3222),
    [anon_sym___thread] = ACTIONS(3222),
    [anon_sym_const] = ACTIONS(3222),
    [anon_sym_constexpr] = ACTIONS(3222),
    [anon_sym_volatile] = ACTIONS(3222),
    [anon_sym_restrict] = ACTIONS(3222),
    [anon_sym___restrict__] = ACTIONS(3222),
    [anon_sym__Atomic] = ACTIONS(3222),
    [anon_sym__Noreturn] = ACTIONS(3222),
    [anon_sym_noreturn] = ACTIONS(3222),
    [anon_sym_mutable] = ACTIONS(3222),
    [anon_sym_constinit] = ACTIONS(3222),
    [anon_sym_consteval] = ACTIONS(3222),
    [anon_sym_alignas] = ACTIONS(3222),
    [anon_sym__Alignas] = ACTIONS(3222),
    [sym_primitive_type] = ACTIONS(3222),
    [anon_sym_enum] = ACTIONS(3222),
    [anon_sym_class] = ACTIONS(3222),
    [anon_sym_struct] = ACTIONS(3222),
    [anon_sym_union] = ACTIONS(3222),
    [anon_sym_if] = ACTIONS(3222),
    [anon_sym_else] = ACTIONS(3222),
    [anon_sym_switch] = ACTIONS(3222),
    [anon_sym_case] = ACTIONS(3222),
    [anon_sym_default] = ACTIONS(3222),
    [anon_sym_while] = ACTIONS(3222),
    [anon_sym_do] = ACTIONS(3222),
    [anon_sym_for] = ACTIONS(3222),
    [anon_sym_return] = ACTIONS(3222),
    [anon_sym_break] = ACTIONS(3222),
    [anon_sym_continue] = ACTIONS(3222),
    [anon_sym_goto] = ACTIONS(3222),
    [anon_sym___try] = ACTIONS(3222),
    [anon_sym___leave] = ACTIONS(3222),
    [anon_sym_not] = ACTIONS(3222),
    [anon_sym_compl] = ACTIONS(3222),
    [anon_sym_DASH_DASH] = ACTIONS(3224),
    [anon_sym_PLUS_PLUS] = ACTIONS(3224),
    [anon_sym_sizeof] = ACTIONS(3222),
    [anon_sym___alignof__] = ACTIONS(3222),
    [anon_sym___alignof] = ACTIONS(3222),
    [anon_sym__alignof] = ACTIONS(3222),
    [anon_sym_alignof] = ACTIONS(3222),
    [anon_sym__Alignof] = ACTIONS(3222),
    [anon_sym_offsetof] = ACTIONS(3222),
    [anon_sym__Generic] = ACTIONS(3222),
    [anon_sym_asm] = ACTIONS(3222),
    [anon_sym___asm__] = ACTIONS(3222),
    [sym_number_literal] = ACTIONS(3224),
    [anon_sym_L_SQUOTE] = ACTIONS(3224),
    [anon_sym_u_SQUOTE] = ACTIONS(3224),
    [anon_sym_U_SQUOTE] = ACTIONS(3224),
    [anon_sym_u8_SQUOTE] = ACTIONS(3224),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_L_DQUOTE] = ACTIONS(3224),
    [anon_sym_u_DQUOTE] = ACTIONS(3224),
    [anon_sym_U_DQUOTE] = ACTIONS(3224),
    [anon_sym_u8_DQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3224),
    [sym_true] = ACTIONS(3222),
    [sym_false] = ACTIONS(3222),
    [anon_sym_NULL] = ACTIONS(3222),
    [anon_sym_nullptr] = ACTIONS(3222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3222),
    [anon_sym_let] = ACTIONS(3222),
    [anon_sym_This] = ACTIONS(3222),
    [anon_sym_decltype] = ACTIONS(3222),
    [sym_virtual] = ACTIONS(3222),
    [anon_sym_explicit] = ACTIONS(3222),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3222),
    [anon_sym_operator] = ACTIONS(3222),
    [anon_sym_try] = ACTIONS(3222),
    [anon_sym_delete] = ACTIONS(3222),
    [anon_sym_throw] = ACTIONS(3222),
    [anon_sym_namespace] = ACTIONS(3222),
    [anon_sym_using] = ACTIONS(3222),
    [anon_sym_static_assert] = ACTIONS(3222),
    [anon_sym_concept] = ACTIONS(3222),
    [anon_sym_co_return] = ACTIONS(3222),
    [anon_sym_co_yield] = ACTIONS(3222),
    [anon_sym_R_DQUOTE] = ACTIONS(3224),
    [anon_sym_LR_DQUOTE] = ACTIONS(3224),
    [anon_sym_uR_DQUOTE] = ACTIONS(3224),
    [anon_sym_UR_DQUOTE] = ACTIONS(3224),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3224),
    [anon_sym_co_await] = ACTIONS(3222),
    [anon_sym_new] = ACTIONS(3222),
    [anon_sym_requires] = ACTIONS(3222),
    [sym_this] = ACTIONS(3222),
    [anon_sym_discard] = ACTIONS(3222),
    [anon_sym_precise] = ACTIONS(3222),
    [anon_sym_shared] = ACTIONS(3222),
    [anon_sym_groupshared] = ACTIONS(3222),
    [anon_sym_uniform] = ACTIONS(3222),
    [anon_sym_row_major] = ACTIONS(3222),
    [anon_sym_column_major] = ACTIONS(3222),
    [anon_sym_globallycoherent] = ACTIONS(3222),
    [anon_sym_centroid] = ACTIONS(3222),
    [anon_sym_noperspective] = ACTIONS(3222),
    [anon_sym_nointerpolation] = ACTIONS(3222),
    [anon_sym_sample] = ACTIONS(3222),
    [anon_sym_linear] = ACTIONS(3222),
    [anon_sym_snorm] = ACTIONS(3222),
    [anon_sym_unorm] = ACTIONS(3222),
    [anon_sym_point] = ACTIONS(3222),
    [anon_sym_line] = ACTIONS(3222),
    [anon_sym_triangleadj] = ACTIONS(3222),
    [anon_sym_lineadj] = ACTIONS(3222),
    [anon_sym_triangle] = ACTIONS(3222),
    [anon_sym_cbuffer] = ACTIONS(3222),
    [anon_sym_interface] = ACTIONS(3222),
    [anon_sym_extension] = ACTIONS(3222),
  },
  [675] = {
    [sym_identifier] = ACTIONS(3338),
    [aux_sym_preproc_include_token1] = ACTIONS(3338),
    [aux_sym_preproc_def_token1] = ACTIONS(3338),
    [aux_sym_preproc_if_token1] = ACTIONS(3338),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3338),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3338),
    [sym_preproc_directive] = ACTIONS(3338),
    [anon_sym_LPAREN2] = ACTIONS(3336),
    [anon_sym_BANG] = ACTIONS(3336),
    [anon_sym_TILDE] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3338),
    [anon_sym_PLUS] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_AMP] = ACTIONS(3338),
    [anon_sym_SEMI] = ACTIONS(3336),
    [anon_sym___extension__] = ACTIONS(3338),
    [anon_sym_typedef] = ACTIONS(3338),
    [anon_sym_in] = ACTIONS(3338),
    [anon_sym_out] = ACTIONS(3338),
    [anon_sym_inout] = ACTIONS(3338),
    [anon_sym_extern] = ACTIONS(3338),
    [anon_sym___attribute__] = ACTIONS(3338),
    [anon_sym_COLON_COLON] = ACTIONS(3336),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3336),
    [anon_sym___declspec] = ACTIONS(3338),
    [anon_sym___based] = ACTIONS(3338),
    [anon_sym___cdecl] = ACTIONS(3338),
    [anon_sym___clrcall] = ACTIONS(3338),
    [anon_sym___stdcall] = ACTIONS(3338),
    [anon_sym___fastcall] = ACTIONS(3338),
    [anon_sym___thiscall] = ACTIONS(3338),
    [anon_sym___vectorcall] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_RBRACE] = ACTIONS(3336),
    [anon_sym_signed] = ACTIONS(3338),
    [anon_sym_unsigned] = ACTIONS(3338),
    [anon_sym_long] = ACTIONS(3338),
    [anon_sym_short] = ACTIONS(3338),
    [anon_sym_LBRACK] = ACTIONS(3338),
    [anon_sym_static] = ACTIONS(3338),
    [anon_sym_register] = ACTIONS(3338),
    [anon_sym_inline] = ACTIONS(3338),
    [anon_sym___inline] = ACTIONS(3338),
    [anon_sym___inline__] = ACTIONS(3338),
    [anon_sym___forceinline] = ACTIONS(3338),
    [anon_sym_thread_local] = ACTIONS(3338),
    [anon_sym___thread] = ACTIONS(3338),
    [anon_sym_const] = ACTIONS(3338),
    [anon_sym_constexpr] = ACTIONS(3338),
    [anon_sym_volatile] = ACTIONS(3338),
    [anon_sym_restrict] = ACTIONS(3338),
    [anon_sym___restrict__] = ACTIONS(3338),
    [anon_sym__Atomic] = ACTIONS(3338),
    [anon_sym__Noreturn] = ACTIONS(3338),
    [anon_sym_noreturn] = ACTIONS(3338),
    [anon_sym_mutable] = ACTIONS(3338),
    [anon_sym_constinit] = ACTIONS(3338),
    [anon_sym_consteval] = ACTIONS(3338),
    [anon_sym_alignas] = ACTIONS(3338),
    [anon_sym__Alignas] = ACTIONS(3338),
    [sym_primitive_type] = ACTIONS(3338),
    [anon_sym_enum] = ACTIONS(3338),
    [anon_sym_class] = ACTIONS(3338),
    [anon_sym_struct] = ACTIONS(3338),
    [anon_sym_union] = ACTIONS(3338),
    [anon_sym_if] = ACTIONS(3338),
    [anon_sym_switch] = ACTIONS(3338),
    [anon_sym_case] = ACTIONS(3338),
    [anon_sym_default] = ACTIONS(3338),
    [anon_sym_while] = ACTIONS(3338),
    [anon_sym_do] = ACTIONS(3338),
    [anon_sym_for] = ACTIONS(3338),
    [anon_sym_return] = ACTIONS(3338),
    [anon_sym_break] = ACTIONS(3338),
    [anon_sym_continue] = ACTIONS(3338),
    [anon_sym_goto] = ACTIONS(3338),
    [anon_sym___try] = ACTIONS(3338),
    [anon_sym___leave] = ACTIONS(3338),
    [anon_sym_not] = ACTIONS(3338),
    [anon_sym_compl] = ACTIONS(3338),
    [anon_sym_DASH_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_PLUS] = ACTIONS(3336),
    [anon_sym_sizeof] = ACTIONS(3338),
    [anon_sym___alignof__] = ACTIONS(3338),
    [anon_sym___alignof] = ACTIONS(3338),
    [anon_sym__alignof] = ACTIONS(3338),
    [anon_sym_alignof] = ACTIONS(3338),
    [anon_sym__Alignof] = ACTIONS(3338),
    [anon_sym_offsetof] = ACTIONS(3338),
    [anon_sym__Generic] = ACTIONS(3338),
    [anon_sym_asm] = ACTIONS(3338),
    [anon_sym___asm__] = ACTIONS(3338),
    [anon_sym_DOT] = ACTIONS(3338),
    [sym_number_literal] = ACTIONS(3336),
    [anon_sym_L_SQUOTE] = ACTIONS(3336),
    [anon_sym_u_SQUOTE] = ACTIONS(3336),
    [anon_sym_U_SQUOTE] = ACTIONS(3336),
    [anon_sym_u8_SQUOTE] = ACTIONS(3336),
    [anon_sym_SQUOTE] = ACTIONS(3336),
    [anon_sym_L_DQUOTE] = ACTIONS(3336),
    [anon_sym_u_DQUOTE] = ACTIONS(3336),
    [anon_sym_U_DQUOTE] = ACTIONS(3336),
    [anon_sym_u8_DQUOTE] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(3336),
    [sym_true] = ACTIONS(3338),
    [sym_false] = ACTIONS(3338),
    [anon_sym_NULL] = ACTIONS(3338),
    [anon_sym_nullptr] = ACTIONS(3338),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3338),
    [anon_sym_let] = ACTIONS(3338),
    [anon_sym_This] = ACTIONS(3338),
    [anon_sym_decltype] = ACTIONS(3338),
    [sym_virtual] = ACTIONS(3338),
    [anon_sym_explicit] = ACTIONS(3338),
    [anon_sym_typename] = ACTIONS(3338),
    [anon_sym_template] = ACTIONS(3338),
    [anon_sym_operator] = ACTIONS(3338),
    [anon_sym_try] = ACTIONS(3338),
    [anon_sym_delete] = ACTIONS(3338),
    [anon_sym_throw] = ACTIONS(3338),
    [anon_sym_namespace] = ACTIONS(3338),
    [anon_sym_using] = ACTIONS(3338),
    [anon_sym_static_assert] = ACTIONS(3338),
    [anon_sym_concept] = ACTIONS(3338),
    [anon_sym_co_return] = ACTIONS(3338),
    [anon_sym_co_yield] = ACTIONS(3338),
    [anon_sym_R_DQUOTE] = ACTIONS(3336),
    [anon_sym_LR_DQUOTE] = ACTIONS(3336),
    [anon_sym_uR_DQUOTE] = ACTIONS(3336),
    [anon_sym_UR_DQUOTE] = ACTIONS(3336),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3336),
    [anon_sym_co_await] = ACTIONS(3338),
    [anon_sym_new] = ACTIONS(3338),
    [anon_sym_requires] = ACTIONS(3338),
    [sym_this] = ACTIONS(3338),
    [anon_sym_discard] = ACTIONS(3338),
    [anon_sym_precise] = ACTIONS(3338),
    [anon_sym_shared] = ACTIONS(3338),
    [anon_sym_groupshared] = ACTIONS(3338),
    [anon_sym_uniform] = ACTIONS(3338),
    [anon_sym_row_major] = ACTIONS(3338),
    [anon_sym_column_major] = ACTIONS(3338),
    [anon_sym_globallycoherent] = ACTIONS(3338),
    [anon_sym_centroid] = ACTIONS(3338),
    [anon_sym_noperspective] = ACTIONS(3338),
    [anon_sym_nointerpolation] = ACTIONS(3338),
    [anon_sym_sample] = ACTIONS(3338),
    [anon_sym_linear] = ACTIONS(3338),
    [anon_sym_snorm] = ACTIONS(3338),
    [anon_sym_unorm] = ACTIONS(3338),
    [anon_sym_point] = ACTIONS(3338),
    [anon_sym_line] = ACTIONS(3338),
    [anon_sym_triangleadj] = ACTIONS(3338),
    [anon_sym_lineadj] = ACTIONS(3338),
    [anon_sym_triangle] = ACTIONS(3338),
    [anon_sym_cbuffer] = ACTIONS(3338),
    [anon_sym_interface] = ACTIONS(3338),
    [anon_sym_extension] = ACTIONS(3338),
  },
  [676] = {
    [sym_identifier] = ACTIONS(3034),
    [aux_sym_preproc_include_token1] = ACTIONS(3034),
    [aux_sym_preproc_def_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_BANG] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3034),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_in] = ACTIONS(3034),
    [anon_sym_out] = ACTIONS(3034),
    [anon_sym_inout] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym___based] = ACTIONS(3034),
    [anon_sym___cdecl] = ACTIONS(3034),
    [anon_sym___clrcall] = ACTIONS(3034),
    [anon_sym___stdcall] = ACTIONS(3034),
    [anon_sym___fastcall] = ACTIONS(3034),
    [anon_sym___thiscall] = ACTIONS(3034),
    [anon_sym___vectorcall] = ACTIONS(3034),
    [anon_sym_LBRACE] = ACTIONS(3036),
    [anon_sym_RBRACE] = ACTIONS(3036),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [anon_sym_if] = ACTIONS(3034),
    [anon_sym_else] = ACTIONS(3034),
    [anon_sym_switch] = ACTIONS(3034),
    [anon_sym_case] = ACTIONS(3034),
    [anon_sym_default] = ACTIONS(3034),
    [anon_sym_while] = ACTIONS(3034),
    [anon_sym_do] = ACTIONS(3034),
    [anon_sym_for] = ACTIONS(3034),
    [anon_sym_return] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3034),
    [anon_sym_continue] = ACTIONS(3034),
    [anon_sym_goto] = ACTIONS(3034),
    [anon_sym___try] = ACTIONS(3034),
    [anon_sym___leave] = ACTIONS(3034),
    [anon_sym_not] = ACTIONS(3034),
    [anon_sym_compl] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_sizeof] = ACTIONS(3034),
    [anon_sym___alignof__] = ACTIONS(3034),
    [anon_sym___alignof] = ACTIONS(3034),
    [anon_sym__alignof] = ACTIONS(3034),
    [anon_sym_alignof] = ACTIONS(3034),
    [anon_sym__Alignof] = ACTIONS(3034),
    [anon_sym_offsetof] = ACTIONS(3034),
    [anon_sym__Generic] = ACTIONS(3034),
    [anon_sym_asm] = ACTIONS(3034),
    [anon_sym___asm__] = ACTIONS(3034),
    [sym_number_literal] = ACTIONS(3036),
    [anon_sym_L_SQUOTE] = ACTIONS(3036),
    [anon_sym_u_SQUOTE] = ACTIONS(3036),
    [anon_sym_U_SQUOTE] = ACTIONS(3036),
    [anon_sym_u8_SQUOTE] = ACTIONS(3036),
    [anon_sym_SQUOTE] = ACTIONS(3036),
    [anon_sym_L_DQUOTE] = ACTIONS(3036),
    [anon_sym_u_DQUOTE] = ACTIONS(3036),
    [anon_sym_U_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8_DQUOTE] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [sym_true] = ACTIONS(3034),
    [sym_false] = ACTIONS(3034),
    [anon_sym_NULL] = ACTIONS(3034),
    [anon_sym_nullptr] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_This] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [sym_virtual] = ACTIONS(3034),
    [anon_sym_explicit] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_operator] = ACTIONS(3034),
    [anon_sym_try] = ACTIONS(3034),
    [anon_sym_delete] = ACTIONS(3034),
    [anon_sym_throw] = ACTIONS(3034),
    [anon_sym_namespace] = ACTIONS(3034),
    [anon_sym_using] = ACTIONS(3034),
    [anon_sym_static_assert] = ACTIONS(3034),
    [anon_sym_concept] = ACTIONS(3034),
    [anon_sym_co_return] = ACTIONS(3034),
    [anon_sym_co_yield] = ACTIONS(3034),
    [anon_sym_R_DQUOTE] = ACTIONS(3036),
    [anon_sym_LR_DQUOTE] = ACTIONS(3036),
    [anon_sym_uR_DQUOTE] = ACTIONS(3036),
    [anon_sym_UR_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3036),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3034),
    [anon_sym_requires] = ACTIONS(3034),
    [sym_this] = ACTIONS(3034),
    [anon_sym_discard] = ACTIONS(3034),
    [anon_sym_precise] = ACTIONS(3034),
    [anon_sym_shared] = ACTIONS(3034),
    [anon_sym_groupshared] = ACTIONS(3034),
    [anon_sym_uniform] = ACTIONS(3034),
    [anon_sym_row_major] = ACTIONS(3034),
    [anon_sym_column_major] = ACTIONS(3034),
    [anon_sym_globallycoherent] = ACTIONS(3034),
    [anon_sym_centroid] = ACTIONS(3034),
    [anon_sym_noperspective] = ACTIONS(3034),
    [anon_sym_nointerpolation] = ACTIONS(3034),
    [anon_sym_sample] = ACTIONS(3034),
    [anon_sym_linear] = ACTIONS(3034),
    [anon_sym_snorm] = ACTIONS(3034),
    [anon_sym_unorm] = ACTIONS(3034),
    [anon_sym_point] = ACTIONS(3034),
    [anon_sym_line] = ACTIONS(3034),
    [anon_sym_triangleadj] = ACTIONS(3034),
    [anon_sym_lineadj] = ACTIONS(3034),
    [anon_sym_triangle] = ACTIONS(3034),
    [anon_sym_cbuffer] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3034),
    [anon_sym_extension] = ACTIONS(3034),
  },
  [677] = {
    [sym_identifier] = ACTIONS(3026),
    [aux_sym_preproc_include_token1] = ACTIONS(3026),
    [aux_sym_preproc_def_token1] = ACTIONS(3026),
    [aux_sym_preproc_if_token1] = ACTIONS(3026),
    [aux_sym_preproc_if_token2] = ACTIONS(3026),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3026),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3026),
    [sym_preproc_directive] = ACTIONS(3026),
    [anon_sym_LPAREN2] = ACTIONS(3028),
    [anon_sym_BANG] = ACTIONS(3028),
    [anon_sym_TILDE] = ACTIONS(3028),
    [anon_sym_DASH] = ACTIONS(3026),
    [anon_sym_PLUS] = ACTIONS(3026),
    [anon_sym_STAR] = ACTIONS(3028),
    [anon_sym_AMP_AMP] = ACTIONS(3028),
    [anon_sym_AMP] = ACTIONS(3026),
    [anon_sym_SEMI] = ACTIONS(3028),
    [anon_sym___extension__] = ACTIONS(3026),
    [anon_sym_typedef] = ACTIONS(3026),
    [anon_sym_in] = ACTIONS(3026),
    [anon_sym_out] = ACTIONS(3026),
    [anon_sym_inout] = ACTIONS(3026),
    [anon_sym_extern] = ACTIONS(3026),
    [anon_sym___attribute__] = ACTIONS(3026),
    [anon_sym_COLON_COLON] = ACTIONS(3028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3028),
    [anon_sym___declspec] = ACTIONS(3026),
    [anon_sym___based] = ACTIONS(3026),
    [anon_sym___cdecl] = ACTIONS(3026),
    [anon_sym___clrcall] = ACTIONS(3026),
    [anon_sym___stdcall] = ACTIONS(3026),
    [anon_sym___fastcall] = ACTIONS(3026),
    [anon_sym___thiscall] = ACTIONS(3026),
    [anon_sym___vectorcall] = ACTIONS(3026),
    [anon_sym_LBRACE] = ACTIONS(3028),
    [anon_sym_signed] = ACTIONS(3026),
    [anon_sym_unsigned] = ACTIONS(3026),
    [anon_sym_long] = ACTIONS(3026),
    [anon_sym_short] = ACTIONS(3026),
    [anon_sym_LBRACK] = ACTIONS(3026),
    [anon_sym_static] = ACTIONS(3026),
    [anon_sym_register] = ACTIONS(3026),
    [anon_sym_inline] = ACTIONS(3026),
    [anon_sym___inline] = ACTIONS(3026),
    [anon_sym___inline__] = ACTIONS(3026),
    [anon_sym___forceinline] = ACTIONS(3026),
    [anon_sym_thread_local] = ACTIONS(3026),
    [anon_sym___thread] = ACTIONS(3026),
    [anon_sym_const] = ACTIONS(3026),
    [anon_sym_constexpr] = ACTIONS(3026),
    [anon_sym_volatile] = ACTIONS(3026),
    [anon_sym_restrict] = ACTIONS(3026),
    [anon_sym___restrict__] = ACTIONS(3026),
    [anon_sym__Atomic] = ACTIONS(3026),
    [anon_sym__Noreturn] = ACTIONS(3026),
    [anon_sym_noreturn] = ACTIONS(3026),
    [anon_sym_mutable] = ACTIONS(3026),
    [anon_sym_constinit] = ACTIONS(3026),
    [anon_sym_consteval] = ACTIONS(3026),
    [anon_sym_alignas] = ACTIONS(3026),
    [anon_sym__Alignas] = ACTIONS(3026),
    [sym_primitive_type] = ACTIONS(3026),
    [anon_sym_enum] = ACTIONS(3026),
    [anon_sym_class] = ACTIONS(3026),
    [anon_sym_struct] = ACTIONS(3026),
    [anon_sym_union] = ACTIONS(3026),
    [anon_sym_if] = ACTIONS(3026),
    [anon_sym_else] = ACTIONS(3026),
    [anon_sym_switch] = ACTIONS(3026),
    [anon_sym_case] = ACTIONS(3026),
    [anon_sym_default] = ACTIONS(3026),
    [anon_sym_while] = ACTIONS(3026),
    [anon_sym_do] = ACTIONS(3026),
    [anon_sym_for] = ACTIONS(3026),
    [anon_sym_return] = ACTIONS(3026),
    [anon_sym_break] = ACTIONS(3026),
    [anon_sym_continue] = ACTIONS(3026),
    [anon_sym_goto] = ACTIONS(3026),
    [anon_sym___try] = ACTIONS(3026),
    [anon_sym___leave] = ACTIONS(3026),
    [anon_sym_not] = ACTIONS(3026),
    [anon_sym_compl] = ACTIONS(3026),
    [anon_sym_DASH_DASH] = ACTIONS(3028),
    [anon_sym_PLUS_PLUS] = ACTIONS(3028),
    [anon_sym_sizeof] = ACTIONS(3026),
    [anon_sym___alignof__] = ACTIONS(3026),
    [anon_sym___alignof] = ACTIONS(3026),
    [anon_sym__alignof] = ACTIONS(3026),
    [anon_sym_alignof] = ACTIONS(3026),
    [anon_sym__Alignof] = ACTIONS(3026),
    [anon_sym_offsetof] = ACTIONS(3026),
    [anon_sym__Generic] = ACTIONS(3026),
    [anon_sym_asm] = ACTIONS(3026),
    [anon_sym___asm__] = ACTIONS(3026),
    [sym_number_literal] = ACTIONS(3028),
    [anon_sym_L_SQUOTE] = ACTIONS(3028),
    [anon_sym_u_SQUOTE] = ACTIONS(3028),
    [anon_sym_U_SQUOTE] = ACTIONS(3028),
    [anon_sym_u8_SQUOTE] = ACTIONS(3028),
    [anon_sym_SQUOTE] = ACTIONS(3028),
    [anon_sym_L_DQUOTE] = ACTIONS(3028),
    [anon_sym_u_DQUOTE] = ACTIONS(3028),
    [anon_sym_U_DQUOTE] = ACTIONS(3028),
    [anon_sym_u8_DQUOTE] = ACTIONS(3028),
    [anon_sym_DQUOTE] = ACTIONS(3028),
    [sym_true] = ACTIONS(3026),
    [sym_false] = ACTIONS(3026),
    [anon_sym_NULL] = ACTIONS(3026),
    [anon_sym_nullptr] = ACTIONS(3026),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3026),
    [anon_sym_let] = ACTIONS(3026),
    [anon_sym_This] = ACTIONS(3026),
    [anon_sym_decltype] = ACTIONS(3026),
    [sym_virtual] = ACTIONS(3026),
    [anon_sym_explicit] = ACTIONS(3026),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(3026),
    [anon_sym_operator] = ACTIONS(3026),
    [anon_sym_try] = ACTIONS(3026),
    [anon_sym_delete] = ACTIONS(3026),
    [anon_sym_throw] = ACTIONS(3026),
    [anon_sym_namespace] = ACTIONS(3026),
    [anon_sym_using] = ACTIONS(3026),
    [anon_sym_static_assert] = ACTIONS(3026),
    [anon_sym_concept] = ACTIONS(3026),
    [anon_sym_co_return] = ACTIONS(3026),
    [anon_sym_co_yield] = ACTIONS(3026),
    [anon_sym_R_DQUOTE] = ACTIONS(3028),
    [anon_sym_LR_DQUOTE] = ACTIONS(3028),
    [anon_sym_uR_DQUOTE] = ACTIONS(3028),
    [anon_sym_UR_DQUOTE] = ACTIONS(3028),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3028),
    [anon_sym_co_await] = ACTIONS(3026),
    [anon_sym_new] = ACTIONS(3026),
    [anon_sym_requires] = ACTIONS(3026),
    [sym_this] = ACTIONS(3026),
    [anon_sym_discard] = ACTIONS(3026),
    [anon_sym_precise] = ACTIONS(3026),
    [anon_sym_shared] = ACTIONS(3026),
    [anon_sym_groupshared] = ACTIONS(3026),
    [anon_sym_uniform] = ACTIONS(3026),
    [anon_sym_row_major] = ACTIONS(3026),
    [anon_sym_column_major] = ACTIONS(3026),
    [anon_sym_globallycoherent] = ACTIONS(3026),
    [anon_sym_centroid] = ACTIONS(3026),
    [anon_sym_noperspective] = ACTIONS(3026),
    [anon_sym_nointerpolation] = ACTIONS(3026),
    [anon_sym_sample] = ACTIONS(3026),
    [anon_sym_linear] = ACTIONS(3026),
    [anon_sym_snorm] = ACTIONS(3026),
    [anon_sym_unorm] = ACTIONS(3026),
    [anon_sym_point] = ACTIONS(3026),
    [anon_sym_line] = ACTIONS(3026),
    [anon_sym_triangleadj] = ACTIONS(3026),
    [anon_sym_lineadj] = ACTIONS(3026),
    [anon_sym_triangle] = ACTIONS(3026),
    [anon_sym_cbuffer] = ACTIONS(3026),
    [anon_sym_interface] = ACTIONS(3026),
    [anon_sym_extension] = ACTIONS(3026),
  },
  [678] = {
    [sym_identifier] = ACTIONS(3338),
    [aux_sym_preproc_include_token1] = ACTIONS(3338),
    [aux_sym_preproc_def_token1] = ACTIONS(3338),
    [aux_sym_preproc_if_token1] = ACTIONS(3338),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3338),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3338),
    [sym_preproc_directive] = ACTIONS(3338),
    [anon_sym_LPAREN2] = ACTIONS(3336),
    [anon_sym_BANG] = ACTIONS(3336),
    [anon_sym_TILDE] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3338),
    [anon_sym_PLUS] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_AMP] = ACTIONS(3338),
    [anon_sym_SEMI] = ACTIONS(3336),
    [anon_sym___extension__] = ACTIONS(3338),
    [anon_sym_typedef] = ACTIONS(3338),
    [anon_sym_in] = ACTIONS(3338),
    [anon_sym_out] = ACTIONS(3338),
    [anon_sym_inout] = ACTIONS(3338),
    [anon_sym_extern] = ACTIONS(3338),
    [anon_sym___attribute__] = ACTIONS(3338),
    [anon_sym_COLON_COLON] = ACTIONS(3336),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3336),
    [anon_sym___declspec] = ACTIONS(3338),
    [anon_sym___based] = ACTIONS(3338),
    [anon_sym___cdecl] = ACTIONS(3338),
    [anon_sym___clrcall] = ACTIONS(3338),
    [anon_sym___stdcall] = ACTIONS(3338),
    [anon_sym___fastcall] = ACTIONS(3338),
    [anon_sym___thiscall] = ACTIONS(3338),
    [anon_sym___vectorcall] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_RBRACE] = ACTIONS(3336),
    [anon_sym_signed] = ACTIONS(3338),
    [anon_sym_unsigned] = ACTIONS(3338),
    [anon_sym_long] = ACTIONS(3338),
    [anon_sym_short] = ACTIONS(3338),
    [anon_sym_LBRACK] = ACTIONS(3338),
    [anon_sym_static] = ACTIONS(3338),
    [anon_sym_register] = ACTIONS(3338),
    [anon_sym_inline] = ACTIONS(3338),
    [anon_sym___inline] = ACTIONS(3338),
    [anon_sym___inline__] = ACTIONS(3338),
    [anon_sym___forceinline] = ACTIONS(3338),
    [anon_sym_thread_local] = ACTIONS(3338),
    [anon_sym___thread] = ACTIONS(3338),
    [anon_sym_const] = ACTIONS(3338),
    [anon_sym_constexpr] = ACTIONS(3338),
    [anon_sym_volatile] = ACTIONS(3338),
    [anon_sym_restrict] = ACTIONS(3338),
    [anon_sym___restrict__] = ACTIONS(3338),
    [anon_sym__Atomic] = ACTIONS(3338),
    [anon_sym__Noreturn] = ACTIONS(3338),
    [anon_sym_noreturn] = ACTIONS(3338),
    [anon_sym_mutable] = ACTIONS(3338),
    [anon_sym_constinit] = ACTIONS(3338),
    [anon_sym_consteval] = ACTIONS(3338),
    [anon_sym_alignas] = ACTIONS(3338),
    [anon_sym__Alignas] = ACTIONS(3338),
    [sym_primitive_type] = ACTIONS(3338),
    [anon_sym_enum] = ACTIONS(3338),
    [anon_sym_class] = ACTIONS(3338),
    [anon_sym_struct] = ACTIONS(3338),
    [anon_sym_union] = ACTIONS(3338),
    [anon_sym_if] = ACTIONS(3338),
    [anon_sym_switch] = ACTIONS(3338),
    [anon_sym_case] = ACTIONS(3338),
    [anon_sym_default] = ACTIONS(3338),
    [anon_sym_while] = ACTIONS(3338),
    [anon_sym_do] = ACTIONS(3338),
    [anon_sym_for] = ACTIONS(3338),
    [anon_sym_return] = ACTIONS(3338),
    [anon_sym_break] = ACTIONS(3338),
    [anon_sym_continue] = ACTIONS(3338),
    [anon_sym_goto] = ACTIONS(3338),
    [anon_sym___try] = ACTIONS(3338),
    [anon_sym___leave] = ACTIONS(3338),
    [anon_sym_not] = ACTIONS(3338),
    [anon_sym_compl] = ACTIONS(3338),
    [anon_sym_DASH_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_PLUS] = ACTIONS(3336),
    [anon_sym_sizeof] = ACTIONS(3338),
    [anon_sym___alignof__] = ACTIONS(3338),
    [anon_sym___alignof] = ACTIONS(3338),
    [anon_sym__alignof] = ACTIONS(3338),
    [anon_sym_alignof] = ACTIONS(3338),
    [anon_sym__Alignof] = ACTIONS(3338),
    [anon_sym_offsetof] = ACTIONS(3338),
    [anon_sym__Generic] = ACTIONS(3338),
    [anon_sym_asm] = ACTIONS(3338),
    [anon_sym___asm__] = ACTIONS(3338),
    [anon_sym_DOT] = ACTIONS(3338),
    [sym_number_literal] = ACTIONS(3336),
    [anon_sym_L_SQUOTE] = ACTIONS(3336),
    [anon_sym_u_SQUOTE] = ACTIONS(3336),
    [anon_sym_U_SQUOTE] = ACTIONS(3336),
    [anon_sym_u8_SQUOTE] = ACTIONS(3336),
    [anon_sym_SQUOTE] = ACTIONS(3336),
    [anon_sym_L_DQUOTE] = ACTIONS(3336),
    [anon_sym_u_DQUOTE] = ACTIONS(3336),
    [anon_sym_U_DQUOTE] = ACTIONS(3336),
    [anon_sym_u8_DQUOTE] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(3336),
    [sym_true] = ACTIONS(3338),
    [sym_false] = ACTIONS(3338),
    [anon_sym_NULL] = ACTIONS(3338),
    [anon_sym_nullptr] = ACTIONS(3338),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3338),
    [anon_sym_let] = ACTIONS(3338),
    [anon_sym_This] = ACTIONS(3338),
    [anon_sym_decltype] = ACTIONS(3338),
    [sym_virtual] = ACTIONS(3338),
    [anon_sym_explicit] = ACTIONS(3338),
    [anon_sym_typename] = ACTIONS(3338),
    [anon_sym_template] = ACTIONS(3338),
    [anon_sym_operator] = ACTIONS(3338),
    [anon_sym_try] = ACTIONS(3338),
    [anon_sym_delete] = ACTIONS(3338),
    [anon_sym_throw] = ACTIONS(3338),
    [anon_sym_namespace] = ACTIONS(3338),
    [anon_sym_using] = ACTIONS(3338),
    [anon_sym_static_assert] = ACTIONS(3338),
    [anon_sym_concept] = ACTIONS(3338),
    [anon_sym_co_return] = ACTIONS(3338),
    [anon_sym_co_yield] = ACTIONS(3338),
    [anon_sym_R_DQUOTE] = ACTIONS(3336),
    [anon_sym_LR_DQUOTE] = ACTIONS(3336),
    [anon_sym_uR_DQUOTE] = ACTIONS(3336),
    [anon_sym_UR_DQUOTE] = ACTIONS(3336),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3336),
    [anon_sym_co_await] = ACTIONS(3338),
    [anon_sym_new] = ACTIONS(3338),
    [anon_sym_requires] = ACTIONS(3338),
    [sym_this] = ACTIONS(3338),
    [anon_sym_discard] = ACTIONS(3338),
    [anon_sym_precise] = ACTIONS(3338),
    [anon_sym_shared] = ACTIONS(3338),
    [anon_sym_groupshared] = ACTIONS(3338),
    [anon_sym_uniform] = ACTIONS(3338),
    [anon_sym_row_major] = ACTIONS(3338),
    [anon_sym_column_major] = ACTIONS(3338),
    [anon_sym_globallycoherent] = ACTIONS(3338),
    [anon_sym_centroid] = ACTIONS(3338),
    [anon_sym_noperspective] = ACTIONS(3338),
    [anon_sym_nointerpolation] = ACTIONS(3338),
    [anon_sym_sample] = ACTIONS(3338),
    [anon_sym_linear] = ACTIONS(3338),
    [anon_sym_snorm] = ACTIONS(3338),
    [anon_sym_unorm] = ACTIONS(3338),
    [anon_sym_point] = ACTIONS(3338),
    [anon_sym_line] = ACTIONS(3338),
    [anon_sym_triangleadj] = ACTIONS(3338),
    [anon_sym_lineadj] = ACTIONS(3338),
    [anon_sym_triangle] = ACTIONS(3338),
    [anon_sym_cbuffer] = ACTIONS(3338),
    [anon_sym_interface] = ACTIONS(3338),
    [anon_sym_extension] = ACTIONS(3338),
  },
  [679] = {
    [sym_identifier] = ACTIONS(3330),
    [aux_sym_preproc_include_token1] = ACTIONS(3330),
    [aux_sym_preproc_def_token1] = ACTIONS(3330),
    [aux_sym_preproc_if_token1] = ACTIONS(3330),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3330),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3330),
    [sym_preproc_directive] = ACTIONS(3330),
    [anon_sym_LPAREN2] = ACTIONS(3332),
    [anon_sym_BANG] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3332),
    [anon_sym_DASH] = ACTIONS(3330),
    [anon_sym_PLUS] = ACTIONS(3330),
    [anon_sym_STAR] = ACTIONS(3332),
    [anon_sym_AMP_AMP] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(3330),
    [anon_sym_SEMI] = ACTIONS(3332),
    [anon_sym___extension__] = ACTIONS(3330),
    [anon_sym_typedef] = ACTIONS(3330),
    [anon_sym_in] = ACTIONS(3330),
    [anon_sym_out] = ACTIONS(3330),
    [anon_sym_inout] = ACTIONS(3330),
    [anon_sym_extern] = ACTIONS(3330),
    [anon_sym___attribute__] = ACTIONS(3330),
    [anon_sym_COLON_COLON] = ACTIONS(3332),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3332),
    [anon_sym___declspec] = ACTIONS(3330),
    [anon_sym___based] = ACTIONS(3330),
    [anon_sym___cdecl] = ACTIONS(3330),
    [anon_sym___clrcall] = ACTIONS(3330),
    [anon_sym___stdcall] = ACTIONS(3330),
    [anon_sym___fastcall] = ACTIONS(3330),
    [anon_sym___thiscall] = ACTIONS(3330),
    [anon_sym___vectorcall] = ACTIONS(3330),
    [anon_sym_LBRACE] = ACTIONS(3332),
    [anon_sym_RBRACE] = ACTIONS(3332),
    [anon_sym_signed] = ACTIONS(3330),
    [anon_sym_unsigned] = ACTIONS(3330),
    [anon_sym_long] = ACTIONS(3330),
    [anon_sym_short] = ACTIONS(3330),
    [anon_sym_LBRACK] = ACTIONS(3330),
    [anon_sym_static] = ACTIONS(3330),
    [anon_sym_register] = ACTIONS(3330),
    [anon_sym_inline] = ACTIONS(3330),
    [anon_sym___inline] = ACTIONS(3330),
    [anon_sym___inline__] = ACTIONS(3330),
    [anon_sym___forceinline] = ACTIONS(3330),
    [anon_sym_thread_local] = ACTIONS(3330),
    [anon_sym___thread] = ACTIONS(3330),
    [anon_sym_const] = ACTIONS(3330),
    [anon_sym_constexpr] = ACTIONS(3330),
    [anon_sym_volatile] = ACTIONS(3330),
    [anon_sym_restrict] = ACTIONS(3330),
    [anon_sym___restrict__] = ACTIONS(3330),
    [anon_sym__Atomic] = ACTIONS(3330),
    [anon_sym__Noreturn] = ACTIONS(3330),
    [anon_sym_noreturn] = ACTIONS(3330),
    [anon_sym_mutable] = ACTIONS(3330),
    [anon_sym_constinit] = ACTIONS(3330),
    [anon_sym_consteval] = ACTIONS(3330),
    [anon_sym_alignas] = ACTIONS(3330),
    [anon_sym__Alignas] = ACTIONS(3330),
    [sym_primitive_type] = ACTIONS(3330),
    [anon_sym_enum] = ACTIONS(3330),
    [anon_sym_class] = ACTIONS(3330),
    [anon_sym_struct] = ACTIONS(3330),
    [anon_sym_union] = ACTIONS(3330),
    [anon_sym_if] = ACTIONS(3330),
    [anon_sym_else] = ACTIONS(3330),
    [anon_sym_switch] = ACTIONS(3330),
    [anon_sym_case] = ACTIONS(3330),
    [anon_sym_default] = ACTIONS(3330),
    [anon_sym_while] = ACTIONS(3330),
    [anon_sym_do] = ACTIONS(3330),
    [anon_sym_for] = ACTIONS(3330),
    [anon_sym_return] = ACTIONS(3330),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_continue] = ACTIONS(3330),
    [anon_sym_goto] = ACTIONS(3330),
    [anon_sym___try] = ACTIONS(3330),
    [anon_sym___leave] = ACTIONS(3330),
    [anon_sym_not] = ACTIONS(3330),
    [anon_sym_compl] = ACTIONS(3330),
    [anon_sym_DASH_DASH] = ACTIONS(3332),
    [anon_sym_PLUS_PLUS] = ACTIONS(3332),
    [anon_sym_sizeof] = ACTIONS(3330),
    [anon_sym___alignof__] = ACTIONS(3330),
    [anon_sym___alignof] = ACTIONS(3330),
    [anon_sym__alignof] = ACTIONS(3330),
    [anon_sym_alignof] = ACTIONS(3330),
    [anon_sym__Alignof] = ACTIONS(3330),
    [anon_sym_offsetof] = ACTIONS(3330),
    [anon_sym__Generic] = ACTIONS(3330),
    [anon_sym_asm] = ACTIONS(3330),
    [anon_sym___asm__] = ACTIONS(3330),
    [sym_number_literal] = ACTIONS(3332),
    [anon_sym_L_SQUOTE] = ACTIONS(3332),
    [anon_sym_u_SQUOTE] = ACTIONS(3332),
    [anon_sym_U_SQUOTE] = ACTIONS(3332),
    [anon_sym_u8_SQUOTE] = ACTIONS(3332),
    [anon_sym_SQUOTE] = ACTIONS(3332),
    [anon_sym_L_DQUOTE] = ACTIONS(3332),
    [anon_sym_u_DQUOTE] = ACTIONS(3332),
    [anon_sym_U_DQUOTE] = ACTIONS(3332),
    [anon_sym_u8_DQUOTE] = ACTIONS(3332),
    [anon_sym_DQUOTE] = ACTIONS(3332),
    [sym_true] = ACTIONS(3330),
    [sym_false] = ACTIONS(3330),
    [anon_sym_NULL] = ACTIONS(3330),
    [anon_sym_nullptr] = ACTIONS(3330),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3330),
    [anon_sym_let] = ACTIONS(3330),
    [anon_sym_This] = ACTIONS(3330),
    [anon_sym_decltype] = ACTIONS(3330),
    [sym_virtual] = ACTIONS(3330),
    [anon_sym_explicit] = ACTIONS(3330),
    [anon_sym_typename] = ACTIONS(3330),
    [anon_sym_template] = ACTIONS(3330),
    [anon_sym_operator] = ACTIONS(3330),
    [anon_sym_try] = ACTIONS(3330),
    [anon_sym_delete] = ACTIONS(3330),
    [anon_sym_throw] = ACTIONS(3330),
    [anon_sym_namespace] = ACTIONS(3330),
    [anon_sym_using] = ACTIONS(3330),
    [anon_sym_static_assert] = ACTIONS(3330),
    [anon_sym_concept] = ACTIONS(3330),
    [anon_sym_co_return] = ACTIONS(3330),
    [anon_sym_co_yield] = ACTIONS(3330),
    [anon_sym_R_DQUOTE] = ACTIONS(3332),
    [anon_sym_LR_DQUOTE] = ACTIONS(3332),
    [anon_sym_uR_DQUOTE] = ACTIONS(3332),
    [anon_sym_UR_DQUOTE] = ACTIONS(3332),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3332),
    [anon_sym_co_await] = ACTIONS(3330),
    [anon_sym_new] = ACTIONS(3330),
    [anon_sym_requires] = ACTIONS(3330),
    [sym_this] = ACTIONS(3330),
    [anon_sym_discard] = ACTIONS(3330),
    [anon_sym_precise] = ACTIONS(3330),
    [anon_sym_shared] = ACTIONS(3330),
    [anon_sym_groupshared] = ACTIONS(3330),
    [anon_sym_uniform] = ACTIONS(3330),
    [anon_sym_row_major] = ACTIONS(3330),
    [anon_sym_column_major] = ACTIONS(3330),
    [anon_sym_globallycoherent] = ACTIONS(3330),
    [anon_sym_centroid] = ACTIONS(3330),
    [anon_sym_noperspective] = ACTIONS(3330),
    [anon_sym_nointerpolation] = ACTIONS(3330),
    [anon_sym_sample] = ACTIONS(3330),
    [anon_sym_linear] = ACTIONS(3330),
    [anon_sym_snorm] = ACTIONS(3330),
    [anon_sym_unorm] = ACTIONS(3330),
    [anon_sym_point] = ACTIONS(3330),
    [anon_sym_line] = ACTIONS(3330),
    [anon_sym_triangleadj] = ACTIONS(3330),
    [anon_sym_lineadj] = ACTIONS(3330),
    [anon_sym_triangle] = ACTIONS(3330),
    [anon_sym_cbuffer] = ACTIONS(3330),
    [anon_sym_interface] = ACTIONS(3330),
    [anon_sym_extension] = ACTIONS(3330),
  },
  [680] = {
    [sym_identifier] = ACTIONS(3030),
    [aux_sym_preproc_include_token1] = ACTIONS(3030),
    [aux_sym_preproc_def_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3030),
    [sym_preproc_directive] = ACTIONS(3030),
    [anon_sym_LPAREN2] = ACTIONS(3032),
    [anon_sym_BANG] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3030),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym___extension__] = ACTIONS(3030),
    [anon_sym_typedef] = ACTIONS(3030),
    [anon_sym_in] = ACTIONS(3030),
    [anon_sym_out] = ACTIONS(3030),
    [anon_sym_inout] = ACTIONS(3030),
    [anon_sym_extern] = ACTIONS(3030),
    [anon_sym___attribute__] = ACTIONS(3030),
    [anon_sym_COLON_COLON] = ACTIONS(3032),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3032),
    [anon_sym___declspec] = ACTIONS(3030),
    [anon_sym___based] = ACTIONS(3030),
    [anon_sym___cdecl] = ACTIONS(3030),
    [anon_sym___clrcall] = ACTIONS(3030),
    [anon_sym___stdcall] = ACTIONS(3030),
    [anon_sym___fastcall] = ACTIONS(3030),
    [anon_sym___thiscall] = ACTIONS(3030),
    [anon_sym___vectorcall] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_RBRACE] = ACTIONS(3032),
    [anon_sym_signed] = ACTIONS(3030),
    [anon_sym_unsigned] = ACTIONS(3030),
    [anon_sym_long] = ACTIONS(3030),
    [anon_sym_short] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_static] = ACTIONS(3030),
    [anon_sym_register] = ACTIONS(3030),
    [anon_sym_inline] = ACTIONS(3030),
    [anon_sym___inline] = ACTIONS(3030),
    [anon_sym___inline__] = ACTIONS(3030),
    [anon_sym___forceinline] = ACTIONS(3030),
    [anon_sym_thread_local] = ACTIONS(3030),
    [anon_sym___thread] = ACTIONS(3030),
    [anon_sym_const] = ACTIONS(3030),
    [anon_sym_constexpr] = ACTIONS(3030),
    [anon_sym_volatile] = ACTIONS(3030),
    [anon_sym_restrict] = ACTIONS(3030),
    [anon_sym___restrict__] = ACTIONS(3030),
    [anon_sym__Atomic] = ACTIONS(3030),
    [anon_sym__Noreturn] = ACTIONS(3030),
    [anon_sym_noreturn] = ACTIONS(3030),
    [anon_sym_mutable] = ACTIONS(3030),
    [anon_sym_constinit] = ACTIONS(3030),
    [anon_sym_consteval] = ACTIONS(3030),
    [anon_sym_alignas] = ACTIONS(3030),
    [anon_sym__Alignas] = ACTIONS(3030),
    [sym_primitive_type] = ACTIONS(3030),
    [anon_sym_enum] = ACTIONS(3030),
    [anon_sym_class] = ACTIONS(3030),
    [anon_sym_struct] = ACTIONS(3030),
    [anon_sym_union] = ACTIONS(3030),
    [anon_sym_if] = ACTIONS(3030),
    [anon_sym_else] = ACTIONS(3030),
    [anon_sym_switch] = ACTIONS(3030),
    [anon_sym_case] = ACTIONS(3030),
    [anon_sym_default] = ACTIONS(3030),
    [anon_sym_while] = ACTIONS(3030),
    [anon_sym_do] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3030),
    [anon_sym_return] = ACTIONS(3030),
    [anon_sym_break] = ACTIONS(3030),
    [anon_sym_continue] = ACTIONS(3030),
    [anon_sym_goto] = ACTIONS(3030),
    [anon_sym___try] = ACTIONS(3030),
    [anon_sym___leave] = ACTIONS(3030),
    [anon_sym_not] = ACTIONS(3030),
    [anon_sym_compl] = ACTIONS(3030),
    [anon_sym_DASH_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_PLUS] = ACTIONS(3032),
    [anon_sym_sizeof] = ACTIONS(3030),
    [anon_sym___alignof__] = ACTIONS(3030),
    [anon_sym___alignof] = ACTIONS(3030),
    [anon_sym__alignof] = ACTIONS(3030),
    [anon_sym_alignof] = ACTIONS(3030),
    [anon_sym__Alignof] = ACTIONS(3030),
    [anon_sym_offsetof] = ACTIONS(3030),
    [anon_sym__Generic] = ACTIONS(3030),
    [anon_sym_asm] = ACTIONS(3030),
    [anon_sym___asm__] = ACTIONS(3030),
    [sym_number_literal] = ACTIONS(3032),
    [anon_sym_L_SQUOTE] = ACTIONS(3032),
    [anon_sym_u_SQUOTE] = ACTIONS(3032),
    [anon_sym_U_SQUOTE] = ACTIONS(3032),
    [anon_sym_u8_SQUOTE] = ACTIONS(3032),
    [anon_sym_SQUOTE] = ACTIONS(3032),
    [anon_sym_L_DQUOTE] = ACTIONS(3032),
    [anon_sym_u_DQUOTE] = ACTIONS(3032),
    [anon_sym_U_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [sym_true] = ACTIONS(3030),
    [sym_false] = ACTIONS(3030),
    [anon_sym_NULL] = ACTIONS(3030),
    [anon_sym_nullptr] = ACTIONS(3030),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3030),
    [anon_sym_let] = ACTIONS(3030),
    [anon_sym_This] = ACTIONS(3030),
    [anon_sym_decltype] = ACTIONS(3030),
    [sym_virtual] = ACTIONS(3030),
    [anon_sym_explicit] = ACTIONS(3030),
    [anon_sym_typename] = ACTIONS(3030),
    [anon_sym_template] = ACTIONS(3030),
    [anon_sym_operator] = ACTIONS(3030),
    [anon_sym_try] = ACTIONS(3030),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_throw] = ACTIONS(3030),
    [anon_sym_namespace] = ACTIONS(3030),
    [anon_sym_using] = ACTIONS(3030),
    [anon_sym_static_assert] = ACTIONS(3030),
    [anon_sym_concept] = ACTIONS(3030),
    [anon_sym_co_return] = ACTIONS(3030),
    [anon_sym_co_yield] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3030),
    [anon_sym_requires] = ACTIONS(3030),
    [sym_this] = ACTIONS(3030),
    [anon_sym_discard] = ACTIONS(3030),
    [anon_sym_precise] = ACTIONS(3030),
    [anon_sym_shared] = ACTIONS(3030),
    [anon_sym_groupshared] = ACTIONS(3030),
    [anon_sym_uniform] = ACTIONS(3030),
    [anon_sym_row_major] = ACTIONS(3030),
    [anon_sym_column_major] = ACTIONS(3030),
    [anon_sym_globallycoherent] = ACTIONS(3030),
    [anon_sym_centroid] = ACTIONS(3030),
    [anon_sym_noperspective] = ACTIONS(3030),
    [anon_sym_nointerpolation] = ACTIONS(3030),
    [anon_sym_sample] = ACTIONS(3030),
    [anon_sym_linear] = ACTIONS(3030),
    [anon_sym_snorm] = ACTIONS(3030),
    [anon_sym_unorm] = ACTIONS(3030),
    [anon_sym_point] = ACTIONS(3030),
    [anon_sym_line] = ACTIONS(3030),
    [anon_sym_triangleadj] = ACTIONS(3030),
    [anon_sym_lineadj] = ACTIONS(3030),
    [anon_sym_triangle] = ACTIONS(3030),
    [anon_sym_cbuffer] = ACTIONS(3030),
    [anon_sym_interface] = ACTIONS(3030),
    [anon_sym_extension] = ACTIONS(3030),
  },
  [681] = {
    [sym_identifier] = ACTIONS(3302),
    [aux_sym_preproc_include_token1] = ACTIONS(3302),
    [aux_sym_preproc_def_token1] = ACTIONS(3302),
    [aux_sym_preproc_if_token1] = ACTIONS(3302),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3302),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3302),
    [sym_preproc_directive] = ACTIONS(3302),
    [anon_sym_LPAREN2] = ACTIONS(3304),
    [anon_sym_BANG] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_AMP_AMP] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3302),
    [anon_sym_SEMI] = ACTIONS(3304),
    [anon_sym___extension__] = ACTIONS(3302),
    [anon_sym_typedef] = ACTIONS(3302),
    [anon_sym_in] = ACTIONS(3302),
    [anon_sym_out] = ACTIONS(3302),
    [anon_sym_inout] = ACTIONS(3302),
    [anon_sym_extern] = ACTIONS(3302),
    [anon_sym___attribute__] = ACTIONS(3302),
    [anon_sym_COLON_COLON] = ACTIONS(3304),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3304),
    [anon_sym___declspec] = ACTIONS(3302),
    [anon_sym___based] = ACTIONS(3302),
    [anon_sym___cdecl] = ACTIONS(3302),
    [anon_sym___clrcall] = ACTIONS(3302),
    [anon_sym___stdcall] = ACTIONS(3302),
    [anon_sym___fastcall] = ACTIONS(3302),
    [anon_sym___thiscall] = ACTIONS(3302),
    [anon_sym___vectorcall] = ACTIONS(3302),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_RBRACE] = ACTIONS(3304),
    [anon_sym_signed] = ACTIONS(3302),
    [anon_sym_unsigned] = ACTIONS(3302),
    [anon_sym_long] = ACTIONS(3302),
    [anon_sym_short] = ACTIONS(3302),
    [anon_sym_LBRACK] = ACTIONS(3302),
    [anon_sym_static] = ACTIONS(3302),
    [anon_sym_register] = ACTIONS(3302),
    [anon_sym_inline] = ACTIONS(3302),
    [anon_sym___inline] = ACTIONS(3302),
    [anon_sym___inline__] = ACTIONS(3302),
    [anon_sym___forceinline] = ACTIONS(3302),
    [anon_sym_thread_local] = ACTIONS(3302),
    [anon_sym___thread] = ACTIONS(3302),
    [anon_sym_const] = ACTIONS(3302),
    [anon_sym_constexpr] = ACTIONS(3302),
    [anon_sym_volatile] = ACTIONS(3302),
    [anon_sym_restrict] = ACTIONS(3302),
    [anon_sym___restrict__] = ACTIONS(3302),
    [anon_sym__Atomic] = ACTIONS(3302),
    [anon_sym__Noreturn] = ACTIONS(3302),
    [anon_sym_noreturn] = ACTIONS(3302),
    [anon_sym_mutable] = ACTIONS(3302),
    [anon_sym_constinit] = ACTIONS(3302),
    [anon_sym_consteval] = ACTIONS(3302),
    [anon_sym_alignas] = ACTIONS(3302),
    [anon_sym__Alignas] = ACTIONS(3302),
    [sym_primitive_type] = ACTIONS(3302),
    [anon_sym_enum] = ACTIONS(3302),
    [anon_sym_class] = ACTIONS(3302),
    [anon_sym_struct] = ACTIONS(3302),
    [anon_sym_union] = ACTIONS(3302),
    [anon_sym_if] = ACTIONS(3302),
    [anon_sym_else] = ACTIONS(3302),
    [anon_sym_switch] = ACTIONS(3302),
    [anon_sym_case] = ACTIONS(3302),
    [anon_sym_default] = ACTIONS(3302),
    [anon_sym_while] = ACTIONS(3302),
    [anon_sym_do] = ACTIONS(3302),
    [anon_sym_for] = ACTIONS(3302),
    [anon_sym_return] = ACTIONS(3302),
    [anon_sym_break] = ACTIONS(3302),
    [anon_sym_continue] = ACTIONS(3302),
    [anon_sym_goto] = ACTIONS(3302),
    [anon_sym___try] = ACTIONS(3302),
    [anon_sym___leave] = ACTIONS(3302),
    [anon_sym_not] = ACTIONS(3302),
    [anon_sym_compl] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3304),
    [anon_sym_PLUS_PLUS] = ACTIONS(3304),
    [anon_sym_sizeof] = ACTIONS(3302),
    [anon_sym___alignof__] = ACTIONS(3302),
    [anon_sym___alignof] = ACTIONS(3302),
    [anon_sym__alignof] = ACTIONS(3302),
    [anon_sym_alignof] = ACTIONS(3302),
    [anon_sym__Alignof] = ACTIONS(3302),
    [anon_sym_offsetof] = ACTIONS(3302),
    [anon_sym__Generic] = ACTIONS(3302),
    [anon_sym_asm] = ACTIONS(3302),
    [anon_sym___asm__] = ACTIONS(3302),
    [sym_number_literal] = ACTIONS(3304),
    [anon_sym_L_SQUOTE] = ACTIONS(3304),
    [anon_sym_u_SQUOTE] = ACTIONS(3304),
    [anon_sym_U_SQUOTE] = ACTIONS(3304),
    [anon_sym_u8_SQUOTE] = ACTIONS(3304),
    [anon_sym_SQUOTE] = ACTIONS(3304),
    [anon_sym_L_DQUOTE] = ACTIONS(3304),
    [anon_sym_u_DQUOTE] = ACTIONS(3304),
    [anon_sym_U_DQUOTE] = ACTIONS(3304),
    [anon_sym_u8_DQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [sym_true] = ACTIONS(3302),
    [sym_false] = ACTIONS(3302),
    [anon_sym_NULL] = ACTIONS(3302),
    [anon_sym_nullptr] = ACTIONS(3302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3302),
    [anon_sym_let] = ACTIONS(3302),
    [anon_sym_This] = ACTIONS(3302),
    [anon_sym_decltype] = ACTIONS(3302),
    [sym_virtual] = ACTIONS(3302),
    [anon_sym_explicit] = ACTIONS(3302),
    [anon_sym_typename] = ACTIONS(3302),
    [anon_sym_template] = ACTIONS(3302),
    [anon_sym_operator] = ACTIONS(3302),
    [anon_sym_try] = ACTIONS(3302),
    [anon_sym_delete] = ACTIONS(3302),
    [anon_sym_throw] = ACTIONS(3302),
    [anon_sym_namespace] = ACTIONS(3302),
    [anon_sym_using] = ACTIONS(3302),
    [anon_sym_static_assert] = ACTIONS(3302),
    [anon_sym_concept] = ACTIONS(3302),
    [anon_sym_co_return] = ACTIONS(3302),
    [anon_sym_co_yield] = ACTIONS(3302),
    [anon_sym_R_DQUOTE] = ACTIONS(3304),
    [anon_sym_LR_DQUOTE] = ACTIONS(3304),
    [anon_sym_uR_DQUOTE] = ACTIONS(3304),
    [anon_sym_UR_DQUOTE] = ACTIONS(3304),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3304),
    [anon_sym_co_await] = ACTIONS(3302),
    [anon_sym_new] = ACTIONS(3302),
    [anon_sym_requires] = ACTIONS(3302),
    [sym_this] = ACTIONS(3302),
    [anon_sym_discard] = ACTIONS(3302),
    [anon_sym_precise] = ACTIONS(3302),
    [anon_sym_shared] = ACTIONS(3302),
    [anon_sym_groupshared] = ACTIONS(3302),
    [anon_sym_uniform] = ACTIONS(3302),
    [anon_sym_row_major] = ACTIONS(3302),
    [anon_sym_column_major] = ACTIONS(3302),
    [anon_sym_globallycoherent] = ACTIONS(3302),
    [anon_sym_centroid] = ACTIONS(3302),
    [anon_sym_noperspective] = ACTIONS(3302),
    [anon_sym_nointerpolation] = ACTIONS(3302),
    [anon_sym_sample] = ACTIONS(3302),
    [anon_sym_linear] = ACTIONS(3302),
    [anon_sym_snorm] = ACTIONS(3302),
    [anon_sym_unorm] = ACTIONS(3302),
    [anon_sym_point] = ACTIONS(3302),
    [anon_sym_line] = ACTIONS(3302),
    [anon_sym_triangleadj] = ACTIONS(3302),
    [anon_sym_lineadj] = ACTIONS(3302),
    [anon_sym_triangle] = ACTIONS(3302),
    [anon_sym_cbuffer] = ACTIONS(3302),
    [anon_sym_interface] = ACTIONS(3302),
    [anon_sym_extension] = ACTIONS(3302),
  },
  [682] = {
    [sym_identifier] = ACTIONS(3366),
    [aux_sym_preproc_include_token1] = ACTIONS(3366),
    [aux_sym_preproc_def_token1] = ACTIONS(3366),
    [aux_sym_preproc_if_token1] = ACTIONS(3366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3366),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3366),
    [sym_preproc_directive] = ACTIONS(3366),
    [anon_sym_LPAREN2] = ACTIONS(3364),
    [anon_sym_BANG] = ACTIONS(3364),
    [anon_sym_TILDE] = ACTIONS(3364),
    [anon_sym_DASH] = ACTIONS(3366),
    [anon_sym_PLUS] = ACTIONS(3366),
    [anon_sym_STAR] = ACTIONS(3364),
    [anon_sym_AMP_AMP] = ACTIONS(3364),
    [anon_sym_AMP] = ACTIONS(3366),
    [anon_sym_SEMI] = ACTIONS(3364),
    [anon_sym___extension__] = ACTIONS(3366),
    [anon_sym_typedef] = ACTIONS(3366),
    [anon_sym_in] = ACTIONS(3366),
    [anon_sym_out] = ACTIONS(3366),
    [anon_sym_inout] = ACTIONS(3366),
    [anon_sym_extern] = ACTIONS(3366),
    [anon_sym___attribute__] = ACTIONS(3366),
    [anon_sym_COLON_COLON] = ACTIONS(3364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3364),
    [anon_sym___declspec] = ACTIONS(3366),
    [anon_sym___based] = ACTIONS(3366),
    [anon_sym___cdecl] = ACTIONS(3366),
    [anon_sym___clrcall] = ACTIONS(3366),
    [anon_sym___stdcall] = ACTIONS(3366),
    [anon_sym___fastcall] = ACTIONS(3366),
    [anon_sym___thiscall] = ACTIONS(3366),
    [anon_sym___vectorcall] = ACTIONS(3366),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_RBRACE] = ACTIONS(3364),
    [anon_sym_signed] = ACTIONS(3366),
    [anon_sym_unsigned] = ACTIONS(3366),
    [anon_sym_long] = ACTIONS(3366),
    [anon_sym_short] = ACTIONS(3366),
    [anon_sym_LBRACK] = ACTIONS(3366),
    [anon_sym_static] = ACTIONS(3366),
    [anon_sym_register] = ACTIONS(3366),
    [anon_sym_inline] = ACTIONS(3366),
    [anon_sym___inline] = ACTIONS(3366),
    [anon_sym___inline__] = ACTIONS(3366),
    [anon_sym___forceinline] = ACTIONS(3366),
    [anon_sym_thread_local] = ACTIONS(3366),
    [anon_sym___thread] = ACTIONS(3366),
    [anon_sym_const] = ACTIONS(3366),
    [anon_sym_constexpr] = ACTIONS(3366),
    [anon_sym_volatile] = ACTIONS(3366),
    [anon_sym_restrict] = ACTIONS(3366),
    [anon_sym___restrict__] = ACTIONS(3366),
    [anon_sym__Atomic] = ACTIONS(3366),
    [anon_sym__Noreturn] = ACTIONS(3366),
    [anon_sym_noreturn] = ACTIONS(3366),
    [anon_sym_mutable] = ACTIONS(3366),
    [anon_sym_constinit] = ACTIONS(3366),
    [anon_sym_consteval] = ACTIONS(3366),
    [anon_sym_alignas] = ACTIONS(3366),
    [anon_sym__Alignas] = ACTIONS(3366),
    [sym_primitive_type] = ACTIONS(3366),
    [anon_sym_enum] = ACTIONS(3366),
    [anon_sym_class] = ACTIONS(3366),
    [anon_sym_struct] = ACTIONS(3366),
    [anon_sym_union] = ACTIONS(3366),
    [anon_sym_if] = ACTIONS(3366),
    [anon_sym_switch] = ACTIONS(3366),
    [anon_sym_case] = ACTIONS(3366),
    [anon_sym_default] = ACTIONS(3366),
    [anon_sym_while] = ACTIONS(3366),
    [anon_sym_do] = ACTIONS(3366),
    [anon_sym_for] = ACTIONS(3366),
    [anon_sym_return] = ACTIONS(3366),
    [anon_sym_break] = ACTIONS(3366),
    [anon_sym_continue] = ACTIONS(3366),
    [anon_sym_goto] = ACTIONS(3366),
    [anon_sym___try] = ACTIONS(3366),
    [anon_sym___leave] = ACTIONS(3366),
    [anon_sym_not] = ACTIONS(3366),
    [anon_sym_compl] = ACTIONS(3366),
    [anon_sym_DASH_DASH] = ACTIONS(3364),
    [anon_sym_PLUS_PLUS] = ACTIONS(3364),
    [anon_sym_sizeof] = ACTIONS(3366),
    [anon_sym___alignof__] = ACTIONS(3366),
    [anon_sym___alignof] = ACTIONS(3366),
    [anon_sym__alignof] = ACTIONS(3366),
    [anon_sym_alignof] = ACTIONS(3366),
    [anon_sym__Alignof] = ACTIONS(3366),
    [anon_sym_offsetof] = ACTIONS(3366),
    [anon_sym__Generic] = ACTIONS(3366),
    [anon_sym_asm] = ACTIONS(3366),
    [anon_sym___asm__] = ACTIONS(3366),
    [anon_sym_DOT] = ACTIONS(3366),
    [sym_number_literal] = ACTIONS(3364),
    [anon_sym_L_SQUOTE] = ACTIONS(3364),
    [anon_sym_u_SQUOTE] = ACTIONS(3364),
    [anon_sym_U_SQUOTE] = ACTIONS(3364),
    [anon_sym_u8_SQUOTE] = ACTIONS(3364),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym_L_DQUOTE] = ACTIONS(3364),
    [anon_sym_u_DQUOTE] = ACTIONS(3364),
    [anon_sym_U_DQUOTE] = ACTIONS(3364),
    [anon_sym_u8_DQUOTE] = ACTIONS(3364),
    [anon_sym_DQUOTE] = ACTIONS(3364),
    [sym_true] = ACTIONS(3366),
    [sym_false] = ACTIONS(3366),
    [anon_sym_NULL] = ACTIONS(3366),
    [anon_sym_nullptr] = ACTIONS(3366),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3366),
    [anon_sym_let] = ACTIONS(3366),
    [anon_sym_This] = ACTIONS(3366),
    [anon_sym_decltype] = ACTIONS(3366),
    [sym_virtual] = ACTIONS(3366),
    [anon_sym_explicit] = ACTIONS(3366),
    [anon_sym_typename] = ACTIONS(3366),
    [anon_sym_template] = ACTIONS(3366),
    [anon_sym_operator] = ACTIONS(3366),
    [anon_sym_try] = ACTIONS(3366),
    [anon_sym_delete] = ACTIONS(3366),
    [anon_sym_throw] = ACTIONS(3366),
    [anon_sym_namespace] = ACTIONS(3366),
    [anon_sym_using] = ACTIONS(3366),
    [anon_sym_static_assert] = ACTIONS(3366),
    [anon_sym_concept] = ACTIONS(3366),
    [anon_sym_co_return] = ACTIONS(3366),
    [anon_sym_co_yield] = ACTIONS(3366),
    [anon_sym_R_DQUOTE] = ACTIONS(3364),
    [anon_sym_LR_DQUOTE] = ACTIONS(3364),
    [anon_sym_uR_DQUOTE] = ACTIONS(3364),
    [anon_sym_UR_DQUOTE] = ACTIONS(3364),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3364),
    [anon_sym_co_await] = ACTIONS(3366),
    [anon_sym_new] = ACTIONS(3366),
    [anon_sym_requires] = ACTIONS(3366),
    [sym_this] = ACTIONS(3366),
    [anon_sym_discard] = ACTIONS(3366),
    [anon_sym_precise] = ACTIONS(3366),
    [anon_sym_shared] = ACTIONS(3366),
    [anon_sym_groupshared] = ACTIONS(3366),
    [anon_sym_uniform] = ACTIONS(3366),
    [anon_sym_row_major] = ACTIONS(3366),
    [anon_sym_column_major] = ACTIONS(3366),
    [anon_sym_globallycoherent] = ACTIONS(3366),
    [anon_sym_centroid] = ACTIONS(3366),
    [anon_sym_noperspective] = ACTIONS(3366),
    [anon_sym_nointerpolation] = ACTIONS(3366),
    [anon_sym_sample] = ACTIONS(3366),
    [anon_sym_linear] = ACTIONS(3366),
    [anon_sym_snorm] = ACTIONS(3366),
    [anon_sym_unorm] = ACTIONS(3366),
    [anon_sym_point] = ACTIONS(3366),
    [anon_sym_line] = ACTIONS(3366),
    [anon_sym_triangleadj] = ACTIONS(3366),
    [anon_sym_lineadj] = ACTIONS(3366),
    [anon_sym_triangle] = ACTIONS(3366),
    [anon_sym_cbuffer] = ACTIONS(3366),
    [anon_sym_interface] = ACTIONS(3366),
    [anon_sym_extension] = ACTIONS(3366),
  },
  [683] = {
    [sym_identifier] = ACTIONS(3026),
    [aux_sym_preproc_include_token1] = ACTIONS(3026),
    [aux_sym_preproc_def_token1] = ACTIONS(3026),
    [aux_sym_preproc_if_token1] = ACTIONS(3026),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3026),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3026),
    [sym_preproc_directive] = ACTIONS(3026),
    [anon_sym_LPAREN2] = ACTIONS(3028),
    [anon_sym_BANG] = ACTIONS(3028),
    [anon_sym_TILDE] = ACTIONS(3028),
    [anon_sym_DASH] = ACTIONS(3026),
    [anon_sym_PLUS] = ACTIONS(3026),
    [anon_sym_STAR] = ACTIONS(3028),
    [anon_sym_AMP_AMP] = ACTIONS(3028),
    [anon_sym_AMP] = ACTIONS(3026),
    [anon_sym_SEMI] = ACTIONS(3028),
    [anon_sym___extension__] = ACTIONS(3026),
    [anon_sym_typedef] = ACTIONS(3026),
    [anon_sym_in] = ACTIONS(3026),
    [anon_sym_out] = ACTIONS(3026),
    [anon_sym_inout] = ACTIONS(3026),
    [anon_sym_extern] = ACTIONS(3026),
    [anon_sym___attribute__] = ACTIONS(3026),
    [anon_sym_COLON_COLON] = ACTIONS(3028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3028),
    [anon_sym___declspec] = ACTIONS(3026),
    [anon_sym___based] = ACTIONS(3026),
    [anon_sym___cdecl] = ACTIONS(3026),
    [anon_sym___clrcall] = ACTIONS(3026),
    [anon_sym___stdcall] = ACTIONS(3026),
    [anon_sym___fastcall] = ACTIONS(3026),
    [anon_sym___thiscall] = ACTIONS(3026),
    [anon_sym___vectorcall] = ACTIONS(3026),
    [anon_sym_LBRACE] = ACTIONS(3028),
    [anon_sym_RBRACE] = ACTIONS(3028),
    [anon_sym_signed] = ACTIONS(3026),
    [anon_sym_unsigned] = ACTIONS(3026),
    [anon_sym_long] = ACTIONS(3026),
    [anon_sym_short] = ACTIONS(3026),
    [anon_sym_LBRACK] = ACTIONS(3026),
    [anon_sym_static] = ACTIONS(3026),
    [anon_sym_register] = ACTIONS(3026),
    [anon_sym_inline] = ACTIONS(3026),
    [anon_sym___inline] = ACTIONS(3026),
    [anon_sym___inline__] = ACTIONS(3026),
    [anon_sym___forceinline] = ACTIONS(3026),
    [anon_sym_thread_local] = ACTIONS(3026),
    [anon_sym___thread] = ACTIONS(3026),
    [anon_sym_const] = ACTIONS(3026),
    [anon_sym_constexpr] = ACTIONS(3026),
    [anon_sym_volatile] = ACTIONS(3026),
    [anon_sym_restrict] = ACTIONS(3026),
    [anon_sym___restrict__] = ACTIONS(3026),
    [anon_sym__Atomic] = ACTIONS(3026),
    [anon_sym__Noreturn] = ACTIONS(3026),
    [anon_sym_noreturn] = ACTIONS(3026),
    [anon_sym_mutable] = ACTIONS(3026),
    [anon_sym_constinit] = ACTIONS(3026),
    [anon_sym_consteval] = ACTIONS(3026),
    [anon_sym_alignas] = ACTIONS(3026),
    [anon_sym__Alignas] = ACTIONS(3026),
    [sym_primitive_type] = ACTIONS(3026),
    [anon_sym_enum] = ACTIONS(3026),
    [anon_sym_class] = ACTIONS(3026),
    [anon_sym_struct] = ACTIONS(3026),
    [anon_sym_union] = ACTIONS(3026),
    [anon_sym_if] = ACTIONS(3026),
    [anon_sym_else] = ACTIONS(3026),
    [anon_sym_switch] = ACTIONS(3026),
    [anon_sym_case] = ACTIONS(3026),
    [anon_sym_default] = ACTIONS(3026),
    [anon_sym_while] = ACTIONS(3026),
    [anon_sym_do] = ACTIONS(3026),
    [anon_sym_for] = ACTIONS(3026),
    [anon_sym_return] = ACTIONS(3026),
    [anon_sym_break] = ACTIONS(3026),
    [anon_sym_continue] = ACTIONS(3026),
    [anon_sym_goto] = ACTIONS(3026),
    [anon_sym___try] = ACTIONS(3026),
    [anon_sym___leave] = ACTIONS(3026),
    [anon_sym_not] = ACTIONS(3026),
    [anon_sym_compl] = ACTIONS(3026),
    [anon_sym_DASH_DASH] = ACTIONS(3028),
    [anon_sym_PLUS_PLUS] = ACTIONS(3028),
    [anon_sym_sizeof] = ACTIONS(3026),
    [anon_sym___alignof__] = ACTIONS(3026),
    [anon_sym___alignof] = ACTIONS(3026),
    [anon_sym__alignof] = ACTIONS(3026),
    [anon_sym_alignof] = ACTIONS(3026),
    [anon_sym__Alignof] = ACTIONS(3026),
    [anon_sym_offsetof] = ACTIONS(3026),
    [anon_sym__Generic] = ACTIONS(3026),
    [anon_sym_asm] = ACTIONS(3026),
    [anon_sym___asm__] = ACTIONS(3026),
    [sym_number_literal] = ACTIONS(3028),
    [anon_sym_L_SQUOTE] = ACTIONS(3028),
    [anon_sym_u_SQUOTE] = ACTIONS(3028),
    [anon_sym_U_SQUOTE] = ACTIONS(3028),
    [anon_sym_u8_SQUOTE] = ACTIONS(3028),
    [anon_sym_SQUOTE] = ACTIONS(3028),
    [anon_sym_L_DQUOTE] = ACTIONS(3028),
    [anon_sym_u_DQUOTE] = ACTIONS(3028),
    [anon_sym_U_DQUOTE] = ACTIONS(3028),
    [anon_sym_u8_DQUOTE] = ACTIONS(3028),
    [anon_sym_DQUOTE] = ACTIONS(3028),
    [sym_true] = ACTIONS(3026),
    [sym_false] = ACTIONS(3026),
    [anon_sym_NULL] = ACTIONS(3026),
    [anon_sym_nullptr] = ACTIONS(3026),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3026),
    [anon_sym_let] = ACTIONS(3026),
    [anon_sym_This] = ACTIONS(3026),
    [anon_sym_decltype] = ACTIONS(3026),
    [sym_virtual] = ACTIONS(3026),
    [anon_sym_explicit] = ACTIONS(3026),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(3026),
    [anon_sym_operator] = ACTIONS(3026),
    [anon_sym_try] = ACTIONS(3026),
    [anon_sym_delete] = ACTIONS(3026),
    [anon_sym_throw] = ACTIONS(3026),
    [anon_sym_namespace] = ACTIONS(3026),
    [anon_sym_using] = ACTIONS(3026),
    [anon_sym_static_assert] = ACTIONS(3026),
    [anon_sym_concept] = ACTIONS(3026),
    [anon_sym_co_return] = ACTIONS(3026),
    [anon_sym_co_yield] = ACTIONS(3026),
    [anon_sym_R_DQUOTE] = ACTIONS(3028),
    [anon_sym_LR_DQUOTE] = ACTIONS(3028),
    [anon_sym_uR_DQUOTE] = ACTIONS(3028),
    [anon_sym_UR_DQUOTE] = ACTIONS(3028),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3028),
    [anon_sym_co_await] = ACTIONS(3026),
    [anon_sym_new] = ACTIONS(3026),
    [anon_sym_requires] = ACTIONS(3026),
    [sym_this] = ACTIONS(3026),
    [anon_sym_discard] = ACTIONS(3026),
    [anon_sym_precise] = ACTIONS(3026),
    [anon_sym_shared] = ACTIONS(3026),
    [anon_sym_groupshared] = ACTIONS(3026),
    [anon_sym_uniform] = ACTIONS(3026),
    [anon_sym_row_major] = ACTIONS(3026),
    [anon_sym_column_major] = ACTIONS(3026),
    [anon_sym_globallycoherent] = ACTIONS(3026),
    [anon_sym_centroid] = ACTIONS(3026),
    [anon_sym_noperspective] = ACTIONS(3026),
    [anon_sym_nointerpolation] = ACTIONS(3026),
    [anon_sym_sample] = ACTIONS(3026),
    [anon_sym_linear] = ACTIONS(3026),
    [anon_sym_snorm] = ACTIONS(3026),
    [anon_sym_unorm] = ACTIONS(3026),
    [anon_sym_point] = ACTIONS(3026),
    [anon_sym_line] = ACTIONS(3026),
    [anon_sym_triangleadj] = ACTIONS(3026),
    [anon_sym_lineadj] = ACTIONS(3026),
    [anon_sym_triangle] = ACTIONS(3026),
    [anon_sym_cbuffer] = ACTIONS(3026),
    [anon_sym_interface] = ACTIONS(3026),
    [anon_sym_extension] = ACTIONS(3026),
  },
  [684] = {
    [sym_identifier] = ACTIONS(3362),
    [aux_sym_preproc_include_token1] = ACTIONS(3362),
    [aux_sym_preproc_def_token1] = ACTIONS(3362),
    [aux_sym_preproc_if_token1] = ACTIONS(3362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3362),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3362),
    [sym_preproc_directive] = ACTIONS(3362),
    [anon_sym_LPAREN2] = ACTIONS(3360),
    [anon_sym_BANG] = ACTIONS(3360),
    [anon_sym_TILDE] = ACTIONS(3360),
    [anon_sym_DASH] = ACTIONS(3362),
    [anon_sym_PLUS] = ACTIONS(3362),
    [anon_sym_STAR] = ACTIONS(3360),
    [anon_sym_AMP_AMP] = ACTIONS(3360),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_SEMI] = ACTIONS(3360),
    [anon_sym___extension__] = ACTIONS(3362),
    [anon_sym_typedef] = ACTIONS(3362),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3360),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3360),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym___based] = ACTIONS(3362),
    [anon_sym___cdecl] = ACTIONS(3362),
    [anon_sym___clrcall] = ACTIONS(3362),
    [anon_sym___stdcall] = ACTIONS(3362),
    [anon_sym___fastcall] = ACTIONS(3362),
    [anon_sym___thiscall] = ACTIONS(3362),
    [anon_sym___vectorcall] = ACTIONS(3362),
    [anon_sym_LBRACE] = ACTIONS(3360),
    [anon_sym_RBRACE] = ACTIONS(3360),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(3362),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3362),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [anon_sym_if] = ACTIONS(3362),
    [anon_sym_switch] = ACTIONS(3362),
    [anon_sym_case] = ACTIONS(3362),
    [anon_sym_default] = ACTIONS(3362),
    [anon_sym_while] = ACTIONS(3362),
    [anon_sym_do] = ACTIONS(3362),
    [anon_sym_for] = ACTIONS(3362),
    [anon_sym_return] = ACTIONS(3362),
    [anon_sym_break] = ACTIONS(3362),
    [anon_sym_continue] = ACTIONS(3362),
    [anon_sym_goto] = ACTIONS(3362),
    [anon_sym___try] = ACTIONS(3362),
    [anon_sym___leave] = ACTIONS(3362),
    [anon_sym_not] = ACTIONS(3362),
    [anon_sym_compl] = ACTIONS(3362),
    [anon_sym_DASH_DASH] = ACTIONS(3360),
    [anon_sym_PLUS_PLUS] = ACTIONS(3360),
    [anon_sym_sizeof] = ACTIONS(3362),
    [anon_sym___alignof__] = ACTIONS(3362),
    [anon_sym___alignof] = ACTIONS(3362),
    [anon_sym__alignof] = ACTIONS(3362),
    [anon_sym_alignof] = ACTIONS(3362),
    [anon_sym__Alignof] = ACTIONS(3362),
    [anon_sym_offsetof] = ACTIONS(3362),
    [anon_sym__Generic] = ACTIONS(3362),
    [anon_sym_asm] = ACTIONS(3362),
    [anon_sym___asm__] = ACTIONS(3362),
    [anon_sym_DOT] = ACTIONS(3362),
    [sym_number_literal] = ACTIONS(3360),
    [anon_sym_L_SQUOTE] = ACTIONS(3360),
    [anon_sym_u_SQUOTE] = ACTIONS(3360),
    [anon_sym_U_SQUOTE] = ACTIONS(3360),
    [anon_sym_u8_SQUOTE] = ACTIONS(3360),
    [anon_sym_SQUOTE] = ACTIONS(3360),
    [anon_sym_L_DQUOTE] = ACTIONS(3360),
    [anon_sym_u_DQUOTE] = ACTIONS(3360),
    [anon_sym_U_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8_DQUOTE] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(3360),
    [sym_true] = ACTIONS(3362),
    [sym_false] = ACTIONS(3362),
    [anon_sym_NULL] = ACTIONS(3362),
    [anon_sym_nullptr] = ACTIONS(3362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3362),
    [sym_virtual] = ACTIONS(3362),
    [anon_sym_explicit] = ACTIONS(3362),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3362),
    [anon_sym_operator] = ACTIONS(3362),
    [anon_sym_try] = ACTIONS(3362),
    [anon_sym_delete] = ACTIONS(3362),
    [anon_sym_throw] = ACTIONS(3362),
    [anon_sym_namespace] = ACTIONS(3362),
    [anon_sym_using] = ACTIONS(3362),
    [anon_sym_static_assert] = ACTIONS(3362),
    [anon_sym_concept] = ACTIONS(3362),
    [anon_sym_co_return] = ACTIONS(3362),
    [anon_sym_co_yield] = ACTIONS(3362),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(3362),
    [anon_sym_requires] = ACTIONS(3362),
    [sym_this] = ACTIONS(3362),
    [anon_sym_discard] = ACTIONS(3362),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
    [anon_sym_cbuffer] = ACTIONS(3362),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
  },
  [685] = {
    [sym_identifier] = ACTIONS(3338),
    [aux_sym_preproc_include_token1] = ACTIONS(3338),
    [aux_sym_preproc_def_token1] = ACTIONS(3338),
    [aux_sym_preproc_if_token1] = ACTIONS(3338),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3338),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3338),
    [sym_preproc_directive] = ACTIONS(3338),
    [anon_sym_LPAREN2] = ACTIONS(3336),
    [anon_sym_BANG] = ACTIONS(3336),
    [anon_sym_TILDE] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3338),
    [anon_sym_PLUS] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_AMP] = ACTIONS(3338),
    [anon_sym_SEMI] = ACTIONS(3336),
    [anon_sym___extension__] = ACTIONS(3338),
    [anon_sym_typedef] = ACTIONS(3338),
    [anon_sym_in] = ACTIONS(3338),
    [anon_sym_out] = ACTIONS(3338),
    [anon_sym_inout] = ACTIONS(3338),
    [anon_sym_extern] = ACTIONS(3338),
    [anon_sym___attribute__] = ACTIONS(3338),
    [anon_sym_COLON_COLON] = ACTIONS(3336),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3336),
    [anon_sym___declspec] = ACTIONS(3338),
    [anon_sym___based] = ACTIONS(3338),
    [anon_sym___cdecl] = ACTIONS(3338),
    [anon_sym___clrcall] = ACTIONS(3338),
    [anon_sym___stdcall] = ACTIONS(3338),
    [anon_sym___fastcall] = ACTIONS(3338),
    [anon_sym___thiscall] = ACTIONS(3338),
    [anon_sym___vectorcall] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_RBRACE] = ACTIONS(3336),
    [anon_sym_signed] = ACTIONS(3338),
    [anon_sym_unsigned] = ACTIONS(3338),
    [anon_sym_long] = ACTIONS(3338),
    [anon_sym_short] = ACTIONS(3338),
    [anon_sym_LBRACK] = ACTIONS(3338),
    [anon_sym_static] = ACTIONS(3338),
    [anon_sym_register] = ACTIONS(3338),
    [anon_sym_inline] = ACTIONS(3338),
    [anon_sym___inline] = ACTIONS(3338),
    [anon_sym___inline__] = ACTIONS(3338),
    [anon_sym___forceinline] = ACTIONS(3338),
    [anon_sym_thread_local] = ACTIONS(3338),
    [anon_sym___thread] = ACTIONS(3338),
    [anon_sym_const] = ACTIONS(3338),
    [anon_sym_constexpr] = ACTIONS(3338),
    [anon_sym_volatile] = ACTIONS(3338),
    [anon_sym_restrict] = ACTIONS(3338),
    [anon_sym___restrict__] = ACTIONS(3338),
    [anon_sym__Atomic] = ACTIONS(3338),
    [anon_sym__Noreturn] = ACTIONS(3338),
    [anon_sym_noreturn] = ACTIONS(3338),
    [anon_sym_mutable] = ACTIONS(3338),
    [anon_sym_constinit] = ACTIONS(3338),
    [anon_sym_consteval] = ACTIONS(3338),
    [anon_sym_alignas] = ACTIONS(3338),
    [anon_sym__Alignas] = ACTIONS(3338),
    [sym_primitive_type] = ACTIONS(3338),
    [anon_sym_enum] = ACTIONS(3338),
    [anon_sym_class] = ACTIONS(3338),
    [anon_sym_struct] = ACTIONS(3338),
    [anon_sym_union] = ACTIONS(3338),
    [anon_sym_if] = ACTIONS(3338),
    [anon_sym_switch] = ACTIONS(3338),
    [anon_sym_case] = ACTIONS(3338),
    [anon_sym_default] = ACTIONS(3338),
    [anon_sym_while] = ACTIONS(3338),
    [anon_sym_do] = ACTIONS(3338),
    [anon_sym_for] = ACTIONS(3338),
    [anon_sym_return] = ACTIONS(3338),
    [anon_sym_break] = ACTIONS(3338),
    [anon_sym_continue] = ACTIONS(3338),
    [anon_sym_goto] = ACTIONS(3338),
    [anon_sym___try] = ACTIONS(3338),
    [anon_sym___leave] = ACTIONS(3338),
    [anon_sym_not] = ACTIONS(3338),
    [anon_sym_compl] = ACTIONS(3338),
    [anon_sym_DASH_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_PLUS] = ACTIONS(3336),
    [anon_sym_sizeof] = ACTIONS(3338),
    [anon_sym___alignof__] = ACTIONS(3338),
    [anon_sym___alignof] = ACTIONS(3338),
    [anon_sym__alignof] = ACTIONS(3338),
    [anon_sym_alignof] = ACTIONS(3338),
    [anon_sym__Alignof] = ACTIONS(3338),
    [anon_sym_offsetof] = ACTIONS(3338),
    [anon_sym__Generic] = ACTIONS(3338),
    [anon_sym_asm] = ACTIONS(3338),
    [anon_sym___asm__] = ACTIONS(3338),
    [anon_sym_DOT] = ACTIONS(3338),
    [sym_number_literal] = ACTIONS(3336),
    [anon_sym_L_SQUOTE] = ACTIONS(3336),
    [anon_sym_u_SQUOTE] = ACTIONS(3336),
    [anon_sym_U_SQUOTE] = ACTIONS(3336),
    [anon_sym_u8_SQUOTE] = ACTIONS(3336),
    [anon_sym_SQUOTE] = ACTIONS(3336),
    [anon_sym_L_DQUOTE] = ACTIONS(3336),
    [anon_sym_u_DQUOTE] = ACTIONS(3336),
    [anon_sym_U_DQUOTE] = ACTIONS(3336),
    [anon_sym_u8_DQUOTE] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(3336),
    [sym_true] = ACTIONS(3338),
    [sym_false] = ACTIONS(3338),
    [anon_sym_NULL] = ACTIONS(3338),
    [anon_sym_nullptr] = ACTIONS(3338),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3338),
    [anon_sym_let] = ACTIONS(3338),
    [anon_sym_This] = ACTIONS(3338),
    [anon_sym_decltype] = ACTIONS(3338),
    [sym_virtual] = ACTIONS(3338),
    [anon_sym_explicit] = ACTIONS(3338),
    [anon_sym_typename] = ACTIONS(3338),
    [anon_sym_template] = ACTIONS(3338),
    [anon_sym_operator] = ACTIONS(3338),
    [anon_sym_try] = ACTIONS(3338),
    [anon_sym_delete] = ACTIONS(3338),
    [anon_sym_throw] = ACTIONS(3338),
    [anon_sym_namespace] = ACTIONS(3338),
    [anon_sym_using] = ACTIONS(3338),
    [anon_sym_static_assert] = ACTIONS(3338),
    [anon_sym_concept] = ACTIONS(3338),
    [anon_sym_co_return] = ACTIONS(3338),
    [anon_sym_co_yield] = ACTIONS(3338),
    [anon_sym_R_DQUOTE] = ACTIONS(3336),
    [anon_sym_LR_DQUOTE] = ACTIONS(3336),
    [anon_sym_uR_DQUOTE] = ACTIONS(3336),
    [anon_sym_UR_DQUOTE] = ACTIONS(3336),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3336),
    [anon_sym_co_await] = ACTIONS(3338),
    [anon_sym_new] = ACTIONS(3338),
    [anon_sym_requires] = ACTIONS(3338),
    [sym_this] = ACTIONS(3338),
    [anon_sym_discard] = ACTIONS(3338),
    [anon_sym_precise] = ACTIONS(3338),
    [anon_sym_shared] = ACTIONS(3338),
    [anon_sym_groupshared] = ACTIONS(3338),
    [anon_sym_uniform] = ACTIONS(3338),
    [anon_sym_row_major] = ACTIONS(3338),
    [anon_sym_column_major] = ACTIONS(3338),
    [anon_sym_globallycoherent] = ACTIONS(3338),
    [anon_sym_centroid] = ACTIONS(3338),
    [anon_sym_noperspective] = ACTIONS(3338),
    [anon_sym_nointerpolation] = ACTIONS(3338),
    [anon_sym_sample] = ACTIONS(3338),
    [anon_sym_linear] = ACTIONS(3338),
    [anon_sym_snorm] = ACTIONS(3338),
    [anon_sym_unorm] = ACTIONS(3338),
    [anon_sym_point] = ACTIONS(3338),
    [anon_sym_line] = ACTIONS(3338),
    [anon_sym_triangleadj] = ACTIONS(3338),
    [anon_sym_lineadj] = ACTIONS(3338),
    [anon_sym_triangle] = ACTIONS(3338),
    [anon_sym_cbuffer] = ACTIONS(3338),
    [anon_sym_interface] = ACTIONS(3338),
    [anon_sym_extension] = ACTIONS(3338),
  },
  [686] = {
    [sym_identifier] = ACTIONS(3070),
    [aux_sym_preproc_include_token1] = ACTIONS(3070),
    [aux_sym_preproc_def_token1] = ACTIONS(3070),
    [aux_sym_preproc_if_token1] = ACTIONS(3070),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3070),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3070),
    [sym_preproc_directive] = ACTIONS(3070),
    [anon_sym_LPAREN2] = ACTIONS(3068),
    [anon_sym_BANG] = ACTIONS(3068),
    [anon_sym_TILDE] = ACTIONS(3068),
    [anon_sym_DASH] = ACTIONS(3070),
    [anon_sym_PLUS] = ACTIONS(3070),
    [anon_sym_STAR] = ACTIONS(3068),
    [anon_sym_AMP_AMP] = ACTIONS(3068),
    [anon_sym_AMP] = ACTIONS(3070),
    [anon_sym_SEMI] = ACTIONS(3068),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3070),
    [anon_sym_in] = ACTIONS(3070),
    [anon_sym_out] = ACTIONS(3070),
    [anon_sym_inout] = ACTIONS(3070),
    [anon_sym_extern] = ACTIONS(3070),
    [anon_sym___attribute__] = ACTIONS(3070),
    [anon_sym_COLON_COLON] = ACTIONS(3068),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3068),
    [anon_sym___declspec] = ACTIONS(3070),
    [anon_sym___based] = ACTIONS(3070),
    [anon_sym___cdecl] = ACTIONS(3070),
    [anon_sym___clrcall] = ACTIONS(3070),
    [anon_sym___stdcall] = ACTIONS(3070),
    [anon_sym___fastcall] = ACTIONS(3070),
    [anon_sym___thiscall] = ACTIONS(3070),
    [anon_sym___vectorcall] = ACTIONS(3070),
    [anon_sym_LBRACE] = ACTIONS(3068),
    [anon_sym_RBRACE] = ACTIONS(3068),
    [anon_sym_signed] = ACTIONS(3070),
    [anon_sym_unsigned] = ACTIONS(3070),
    [anon_sym_long] = ACTIONS(3070),
    [anon_sym_short] = ACTIONS(3070),
    [anon_sym_LBRACK] = ACTIONS(3070),
    [anon_sym_static] = ACTIONS(3070),
    [anon_sym_register] = ACTIONS(3070),
    [anon_sym_inline] = ACTIONS(3070),
    [anon_sym___inline] = ACTIONS(3070),
    [anon_sym___inline__] = ACTIONS(3070),
    [anon_sym___forceinline] = ACTIONS(3070),
    [anon_sym_thread_local] = ACTIONS(3070),
    [anon_sym___thread] = ACTIONS(3070),
    [anon_sym_const] = ACTIONS(3070),
    [anon_sym_constexpr] = ACTIONS(3070),
    [anon_sym_volatile] = ACTIONS(3070),
    [anon_sym_restrict] = ACTIONS(3070),
    [anon_sym___restrict__] = ACTIONS(3070),
    [anon_sym__Atomic] = ACTIONS(3070),
    [anon_sym__Noreturn] = ACTIONS(3070),
    [anon_sym_noreturn] = ACTIONS(3070),
    [anon_sym_mutable] = ACTIONS(3070),
    [anon_sym_constinit] = ACTIONS(3070),
    [anon_sym_consteval] = ACTIONS(3070),
    [anon_sym_alignas] = ACTIONS(3070),
    [anon_sym__Alignas] = ACTIONS(3070),
    [sym_primitive_type] = ACTIONS(3070),
    [anon_sym_enum] = ACTIONS(3070),
    [anon_sym_class] = ACTIONS(3070),
    [anon_sym_struct] = ACTIONS(3070),
    [anon_sym_union] = ACTIONS(3070),
    [anon_sym_if] = ACTIONS(3070),
    [anon_sym_switch] = ACTIONS(3070),
    [anon_sym_case] = ACTIONS(3070),
    [anon_sym_default] = ACTIONS(3070),
    [anon_sym_while] = ACTIONS(3070),
    [anon_sym_do] = ACTIONS(3070),
    [anon_sym_for] = ACTIONS(3070),
    [anon_sym_return] = ACTIONS(3070),
    [anon_sym_break] = ACTIONS(3070),
    [anon_sym_continue] = ACTIONS(3070),
    [anon_sym_goto] = ACTIONS(3070),
    [anon_sym___try] = ACTIONS(3070),
    [anon_sym___leave] = ACTIONS(3070),
    [anon_sym_not] = ACTIONS(3070),
    [anon_sym_compl] = ACTIONS(3070),
    [anon_sym_DASH_DASH] = ACTIONS(3068),
    [anon_sym_PLUS_PLUS] = ACTIONS(3068),
    [anon_sym_sizeof] = ACTIONS(3070),
    [anon_sym___alignof__] = ACTIONS(3070),
    [anon_sym___alignof] = ACTIONS(3070),
    [anon_sym__alignof] = ACTIONS(3070),
    [anon_sym_alignof] = ACTIONS(3070),
    [anon_sym__Alignof] = ACTIONS(3070),
    [anon_sym_offsetof] = ACTIONS(3070),
    [anon_sym__Generic] = ACTIONS(3070),
    [anon_sym_asm] = ACTIONS(3070),
    [anon_sym___asm__] = ACTIONS(3070),
    [anon_sym_DOT] = ACTIONS(3070),
    [sym_number_literal] = ACTIONS(3068),
    [anon_sym_L_SQUOTE] = ACTIONS(3068),
    [anon_sym_u_SQUOTE] = ACTIONS(3068),
    [anon_sym_U_SQUOTE] = ACTIONS(3068),
    [anon_sym_u8_SQUOTE] = ACTIONS(3068),
    [anon_sym_SQUOTE] = ACTIONS(3068),
    [anon_sym_L_DQUOTE] = ACTIONS(3068),
    [anon_sym_u_DQUOTE] = ACTIONS(3068),
    [anon_sym_U_DQUOTE] = ACTIONS(3068),
    [anon_sym_u8_DQUOTE] = ACTIONS(3068),
    [anon_sym_DQUOTE] = ACTIONS(3068),
    [sym_true] = ACTIONS(3070),
    [sym_false] = ACTIONS(3070),
    [anon_sym_NULL] = ACTIONS(3070),
    [anon_sym_nullptr] = ACTIONS(3070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3070),
    [anon_sym_let] = ACTIONS(3070),
    [anon_sym_This] = ACTIONS(3070),
    [anon_sym_decltype] = ACTIONS(3070),
    [sym_virtual] = ACTIONS(3070),
    [anon_sym_explicit] = ACTIONS(3070),
    [anon_sym_typename] = ACTIONS(3070),
    [anon_sym_template] = ACTIONS(3070),
    [anon_sym_operator] = ACTIONS(3070),
    [anon_sym_try] = ACTIONS(3070),
    [anon_sym_delete] = ACTIONS(3070),
    [anon_sym_throw] = ACTIONS(3070),
    [anon_sym_namespace] = ACTIONS(3070),
    [anon_sym_using] = ACTIONS(3070),
    [anon_sym_static_assert] = ACTIONS(3070),
    [anon_sym_concept] = ACTIONS(3070),
    [anon_sym_co_return] = ACTIONS(3070),
    [anon_sym_co_yield] = ACTIONS(3070),
    [anon_sym_R_DQUOTE] = ACTIONS(3068),
    [anon_sym_LR_DQUOTE] = ACTIONS(3068),
    [anon_sym_uR_DQUOTE] = ACTIONS(3068),
    [anon_sym_UR_DQUOTE] = ACTIONS(3068),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3068),
    [anon_sym_co_await] = ACTIONS(3070),
    [anon_sym_new] = ACTIONS(3070),
    [anon_sym_requires] = ACTIONS(3070),
    [sym_this] = ACTIONS(3070),
    [anon_sym_discard] = ACTIONS(3070),
    [anon_sym_precise] = ACTIONS(3070),
    [anon_sym_shared] = ACTIONS(3070),
    [anon_sym_groupshared] = ACTIONS(3070),
    [anon_sym_uniform] = ACTIONS(3070),
    [anon_sym_row_major] = ACTIONS(3070),
    [anon_sym_column_major] = ACTIONS(3070),
    [anon_sym_globallycoherent] = ACTIONS(3070),
    [anon_sym_centroid] = ACTIONS(3070),
    [anon_sym_noperspective] = ACTIONS(3070),
    [anon_sym_nointerpolation] = ACTIONS(3070),
    [anon_sym_sample] = ACTIONS(3070),
    [anon_sym_linear] = ACTIONS(3070),
    [anon_sym_snorm] = ACTIONS(3070),
    [anon_sym_unorm] = ACTIONS(3070),
    [anon_sym_point] = ACTIONS(3070),
    [anon_sym_line] = ACTIONS(3070),
    [anon_sym_triangleadj] = ACTIONS(3070),
    [anon_sym_lineadj] = ACTIONS(3070),
    [anon_sym_triangle] = ACTIONS(3070),
    [anon_sym_cbuffer] = ACTIONS(3070),
    [anon_sym_interface] = ACTIONS(3070),
    [anon_sym_extension] = ACTIONS(3070),
  },
  [687] = {
    [sym_identifier] = ACTIONS(3202),
    [aux_sym_preproc_include_token1] = ACTIONS(3202),
    [aux_sym_preproc_def_token1] = ACTIONS(3202),
    [aux_sym_preproc_if_token1] = ACTIONS(3202),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3202),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3202),
    [sym_preproc_directive] = ACTIONS(3202),
    [anon_sym_LPAREN2] = ACTIONS(3200),
    [anon_sym_BANG] = ACTIONS(3200),
    [anon_sym_TILDE] = ACTIONS(3200),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_STAR] = ACTIONS(3200),
    [anon_sym_AMP_AMP] = ACTIONS(3200),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_SEMI] = ACTIONS(3200),
    [anon_sym___extension__] = ACTIONS(3202),
    [anon_sym_typedef] = ACTIONS(3202),
    [anon_sym_in] = ACTIONS(3202),
    [anon_sym_out] = ACTIONS(3202),
    [anon_sym_inout] = ACTIONS(3202),
    [anon_sym_extern] = ACTIONS(3202),
    [anon_sym___attribute__] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3200),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3200),
    [anon_sym___declspec] = ACTIONS(3202),
    [anon_sym___based] = ACTIONS(3202),
    [anon_sym___cdecl] = ACTIONS(3202),
    [anon_sym___clrcall] = ACTIONS(3202),
    [anon_sym___stdcall] = ACTIONS(3202),
    [anon_sym___fastcall] = ACTIONS(3202),
    [anon_sym___thiscall] = ACTIONS(3202),
    [anon_sym___vectorcall] = ACTIONS(3202),
    [anon_sym_LBRACE] = ACTIONS(3200),
    [anon_sym_RBRACE] = ACTIONS(3200),
    [anon_sym_signed] = ACTIONS(3202),
    [anon_sym_unsigned] = ACTIONS(3202),
    [anon_sym_long] = ACTIONS(3202),
    [anon_sym_short] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_static] = ACTIONS(3202),
    [anon_sym_register] = ACTIONS(3202),
    [anon_sym_inline] = ACTIONS(3202),
    [anon_sym___inline] = ACTIONS(3202),
    [anon_sym___inline__] = ACTIONS(3202),
    [anon_sym___forceinline] = ACTIONS(3202),
    [anon_sym_thread_local] = ACTIONS(3202),
    [anon_sym___thread] = ACTIONS(3202),
    [anon_sym_const] = ACTIONS(3202),
    [anon_sym_constexpr] = ACTIONS(3202),
    [anon_sym_volatile] = ACTIONS(3202),
    [anon_sym_restrict] = ACTIONS(3202),
    [anon_sym___restrict__] = ACTIONS(3202),
    [anon_sym__Atomic] = ACTIONS(3202),
    [anon_sym__Noreturn] = ACTIONS(3202),
    [anon_sym_noreturn] = ACTIONS(3202),
    [anon_sym_mutable] = ACTIONS(3202),
    [anon_sym_constinit] = ACTIONS(3202),
    [anon_sym_consteval] = ACTIONS(3202),
    [anon_sym_alignas] = ACTIONS(3202),
    [anon_sym__Alignas] = ACTIONS(3202),
    [sym_primitive_type] = ACTIONS(3202),
    [anon_sym_enum] = ACTIONS(3202),
    [anon_sym_class] = ACTIONS(3202),
    [anon_sym_struct] = ACTIONS(3202),
    [anon_sym_union] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_switch] = ACTIONS(3202),
    [anon_sym_case] = ACTIONS(3202),
    [anon_sym_default] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_break] = ACTIONS(3202),
    [anon_sym_continue] = ACTIONS(3202),
    [anon_sym_goto] = ACTIONS(3202),
    [anon_sym___try] = ACTIONS(3202),
    [anon_sym___leave] = ACTIONS(3202),
    [anon_sym_not] = ACTIONS(3202),
    [anon_sym_compl] = ACTIONS(3202),
    [anon_sym_DASH_DASH] = ACTIONS(3200),
    [anon_sym_PLUS_PLUS] = ACTIONS(3200),
    [anon_sym_sizeof] = ACTIONS(3202),
    [anon_sym___alignof__] = ACTIONS(3202),
    [anon_sym___alignof] = ACTIONS(3202),
    [anon_sym__alignof] = ACTIONS(3202),
    [anon_sym_alignof] = ACTIONS(3202),
    [anon_sym__Alignof] = ACTIONS(3202),
    [anon_sym_offsetof] = ACTIONS(3202),
    [anon_sym__Generic] = ACTIONS(3202),
    [anon_sym_asm] = ACTIONS(3202),
    [anon_sym___asm__] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(3202),
    [sym_number_literal] = ACTIONS(3200),
    [anon_sym_L_SQUOTE] = ACTIONS(3200),
    [anon_sym_u_SQUOTE] = ACTIONS(3200),
    [anon_sym_U_SQUOTE] = ACTIONS(3200),
    [anon_sym_u8_SQUOTE] = ACTIONS(3200),
    [anon_sym_SQUOTE] = ACTIONS(3200),
    [anon_sym_L_DQUOTE] = ACTIONS(3200),
    [anon_sym_u_DQUOTE] = ACTIONS(3200),
    [anon_sym_U_DQUOTE] = ACTIONS(3200),
    [anon_sym_u8_DQUOTE] = ACTIONS(3200),
    [anon_sym_DQUOTE] = ACTIONS(3200),
    [sym_true] = ACTIONS(3202),
    [sym_false] = ACTIONS(3202),
    [anon_sym_NULL] = ACTIONS(3202),
    [anon_sym_nullptr] = ACTIONS(3202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_This] = ACTIONS(3202),
    [anon_sym_decltype] = ACTIONS(3202),
    [sym_virtual] = ACTIONS(3202),
    [anon_sym_explicit] = ACTIONS(3202),
    [anon_sym_typename] = ACTIONS(3202),
    [anon_sym_template] = ACTIONS(3202),
    [anon_sym_operator] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_delete] = ACTIONS(3202),
    [anon_sym_throw] = ACTIONS(3202),
    [anon_sym_namespace] = ACTIONS(3202),
    [anon_sym_using] = ACTIONS(3202),
    [anon_sym_static_assert] = ACTIONS(3202),
    [anon_sym_concept] = ACTIONS(3202),
    [anon_sym_co_return] = ACTIONS(3202),
    [anon_sym_co_yield] = ACTIONS(3202),
    [anon_sym_R_DQUOTE] = ACTIONS(3200),
    [anon_sym_LR_DQUOTE] = ACTIONS(3200),
    [anon_sym_uR_DQUOTE] = ACTIONS(3200),
    [anon_sym_UR_DQUOTE] = ACTIONS(3200),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3200),
    [anon_sym_co_await] = ACTIONS(3202),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_requires] = ACTIONS(3202),
    [sym_this] = ACTIONS(3202),
    [anon_sym_discard] = ACTIONS(3202),
    [anon_sym_precise] = ACTIONS(3202),
    [anon_sym_shared] = ACTIONS(3202),
    [anon_sym_groupshared] = ACTIONS(3202),
    [anon_sym_uniform] = ACTIONS(3202),
    [anon_sym_row_major] = ACTIONS(3202),
    [anon_sym_column_major] = ACTIONS(3202),
    [anon_sym_globallycoherent] = ACTIONS(3202),
    [anon_sym_centroid] = ACTIONS(3202),
    [anon_sym_noperspective] = ACTIONS(3202),
    [anon_sym_nointerpolation] = ACTIONS(3202),
    [anon_sym_sample] = ACTIONS(3202),
    [anon_sym_linear] = ACTIONS(3202),
    [anon_sym_snorm] = ACTIONS(3202),
    [anon_sym_unorm] = ACTIONS(3202),
    [anon_sym_point] = ACTIONS(3202),
    [anon_sym_line] = ACTIONS(3202),
    [anon_sym_triangleadj] = ACTIONS(3202),
    [anon_sym_lineadj] = ACTIONS(3202),
    [anon_sym_triangle] = ACTIONS(3202),
    [anon_sym_cbuffer] = ACTIONS(3202),
    [anon_sym_interface] = ACTIONS(3202),
    [anon_sym_extension] = ACTIONS(3202),
  },
  [688] = {
    [sym_identifier] = ACTIONS(3344),
    [aux_sym_preproc_include_token1] = ACTIONS(3344),
    [aux_sym_preproc_def_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3344),
    [sym_preproc_directive] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym___extension__] = ACTIONS(3344),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_in] = ACTIONS(3344),
    [anon_sym_out] = ACTIONS(3344),
    [anon_sym_inout] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym___attribute__] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3346),
    [anon_sym___declspec] = ACTIONS(3344),
    [anon_sym___based] = ACTIONS(3344),
    [anon_sym___cdecl] = ACTIONS(3344),
    [anon_sym___clrcall] = ACTIONS(3344),
    [anon_sym___stdcall] = ACTIONS(3344),
    [anon_sym___fastcall] = ACTIONS(3344),
    [anon_sym___thiscall] = ACTIONS(3344),
    [anon_sym___vectorcall] = ACTIONS(3344),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_RBRACE] = ACTIONS(3346),
    [anon_sym_signed] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym___inline] = ACTIONS(3344),
    [anon_sym___inline__] = ACTIONS(3344),
    [anon_sym___forceinline] = ACTIONS(3344),
    [anon_sym_thread_local] = ACTIONS(3344),
    [anon_sym___thread] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym___restrict__] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym__Noreturn] = ACTIONS(3344),
    [anon_sym_noreturn] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_constinit] = ACTIONS(3344),
    [anon_sym_consteval] = ACTIONS(3344),
    [anon_sym_alignas] = ACTIONS(3344),
    [anon_sym__Alignas] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_class] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_switch] = ACTIONS(3344),
    [anon_sym_case] = ACTIONS(3344),
    [anon_sym_default] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_break] = ACTIONS(3344),
    [anon_sym_continue] = ACTIONS(3344),
    [anon_sym_goto] = ACTIONS(3344),
    [anon_sym___try] = ACTIONS(3344),
    [anon_sym___leave] = ACTIONS(3344),
    [anon_sym_not] = ACTIONS(3344),
    [anon_sym_compl] = ACTIONS(3344),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_sizeof] = ACTIONS(3344),
    [anon_sym___alignof__] = ACTIONS(3344),
    [anon_sym___alignof] = ACTIONS(3344),
    [anon_sym__alignof] = ACTIONS(3344),
    [anon_sym_alignof] = ACTIONS(3344),
    [anon_sym__Alignof] = ACTIONS(3344),
    [anon_sym_offsetof] = ACTIONS(3344),
    [anon_sym__Generic] = ACTIONS(3344),
    [anon_sym_asm] = ACTIONS(3344),
    [anon_sym___asm__] = ACTIONS(3344),
    [sym_number_literal] = ACTIONS(3346),
    [anon_sym_L_SQUOTE] = ACTIONS(3346),
    [anon_sym_u_SQUOTE] = ACTIONS(3346),
    [anon_sym_U_SQUOTE] = ACTIONS(3346),
    [anon_sym_u8_SQUOTE] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_L_DQUOTE] = ACTIONS(3346),
    [anon_sym_u_DQUOTE] = ACTIONS(3346),
    [anon_sym_U_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8_DQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [sym_true] = ACTIONS(3344),
    [sym_false] = ACTIONS(3344),
    [anon_sym_NULL] = ACTIONS(3344),
    [anon_sym_nullptr] = ACTIONS(3344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_This] = ACTIONS(3344),
    [anon_sym_decltype] = ACTIONS(3344),
    [sym_virtual] = ACTIONS(3344),
    [anon_sym_explicit] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_template] = ACTIONS(3344),
    [anon_sym_operator] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_delete] = ACTIONS(3344),
    [anon_sym_throw] = ACTIONS(3344),
    [anon_sym_namespace] = ACTIONS(3344),
    [anon_sym_using] = ACTIONS(3344),
    [anon_sym_static_assert] = ACTIONS(3344),
    [anon_sym_concept] = ACTIONS(3344),
    [anon_sym_co_return] = ACTIONS(3344),
    [anon_sym_co_yield] = ACTIONS(3344),
    [anon_sym_R_DQUOTE] = ACTIONS(3346),
    [anon_sym_LR_DQUOTE] = ACTIONS(3346),
    [anon_sym_uR_DQUOTE] = ACTIONS(3346),
    [anon_sym_UR_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3346),
    [anon_sym_co_await] = ACTIONS(3344),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_requires] = ACTIONS(3344),
    [sym_this] = ACTIONS(3344),
    [anon_sym_discard] = ACTIONS(3344),
    [anon_sym_precise] = ACTIONS(3344),
    [anon_sym_shared] = ACTIONS(3344),
    [anon_sym_groupshared] = ACTIONS(3344),
    [anon_sym_uniform] = ACTIONS(3344),
    [anon_sym_row_major] = ACTIONS(3344),
    [anon_sym_column_major] = ACTIONS(3344),
    [anon_sym_globallycoherent] = ACTIONS(3344),
    [anon_sym_centroid] = ACTIONS(3344),
    [anon_sym_noperspective] = ACTIONS(3344),
    [anon_sym_nointerpolation] = ACTIONS(3344),
    [anon_sym_sample] = ACTIONS(3344),
    [anon_sym_linear] = ACTIONS(3344),
    [anon_sym_snorm] = ACTIONS(3344),
    [anon_sym_unorm] = ACTIONS(3344),
    [anon_sym_point] = ACTIONS(3344),
    [anon_sym_line] = ACTIONS(3344),
    [anon_sym_triangleadj] = ACTIONS(3344),
    [anon_sym_lineadj] = ACTIONS(3344),
    [anon_sym_triangle] = ACTIONS(3344),
    [anon_sym_cbuffer] = ACTIONS(3344),
    [anon_sym_interface] = ACTIONS(3344),
    [anon_sym_extension] = ACTIONS(3344),
  },
  [689] = {
    [sym_identifier] = ACTIONS(3344),
    [aux_sym_preproc_include_token1] = ACTIONS(3344),
    [aux_sym_preproc_def_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3344),
    [sym_preproc_directive] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym___extension__] = ACTIONS(3344),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_in] = ACTIONS(3344),
    [anon_sym_out] = ACTIONS(3344),
    [anon_sym_inout] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym___attribute__] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3346),
    [anon_sym___declspec] = ACTIONS(3344),
    [anon_sym___based] = ACTIONS(3344),
    [anon_sym___cdecl] = ACTIONS(3344),
    [anon_sym___clrcall] = ACTIONS(3344),
    [anon_sym___stdcall] = ACTIONS(3344),
    [anon_sym___fastcall] = ACTIONS(3344),
    [anon_sym___thiscall] = ACTIONS(3344),
    [anon_sym___vectorcall] = ACTIONS(3344),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_RBRACE] = ACTIONS(3346),
    [anon_sym_signed] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym___inline] = ACTIONS(3344),
    [anon_sym___inline__] = ACTIONS(3344),
    [anon_sym___forceinline] = ACTIONS(3344),
    [anon_sym_thread_local] = ACTIONS(3344),
    [anon_sym___thread] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym___restrict__] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym__Noreturn] = ACTIONS(3344),
    [anon_sym_noreturn] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_constinit] = ACTIONS(3344),
    [anon_sym_consteval] = ACTIONS(3344),
    [anon_sym_alignas] = ACTIONS(3344),
    [anon_sym__Alignas] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_class] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_switch] = ACTIONS(3344),
    [anon_sym_case] = ACTIONS(3344),
    [anon_sym_default] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_break] = ACTIONS(3344),
    [anon_sym_continue] = ACTIONS(3344),
    [anon_sym_goto] = ACTIONS(3344),
    [anon_sym___try] = ACTIONS(3344),
    [anon_sym___leave] = ACTIONS(3344),
    [anon_sym_not] = ACTIONS(3344),
    [anon_sym_compl] = ACTIONS(3344),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_sizeof] = ACTIONS(3344),
    [anon_sym___alignof__] = ACTIONS(3344),
    [anon_sym___alignof] = ACTIONS(3344),
    [anon_sym__alignof] = ACTIONS(3344),
    [anon_sym_alignof] = ACTIONS(3344),
    [anon_sym__Alignof] = ACTIONS(3344),
    [anon_sym_offsetof] = ACTIONS(3344),
    [anon_sym__Generic] = ACTIONS(3344),
    [anon_sym_asm] = ACTIONS(3344),
    [anon_sym___asm__] = ACTIONS(3344),
    [sym_number_literal] = ACTIONS(3346),
    [anon_sym_L_SQUOTE] = ACTIONS(3346),
    [anon_sym_u_SQUOTE] = ACTIONS(3346),
    [anon_sym_U_SQUOTE] = ACTIONS(3346),
    [anon_sym_u8_SQUOTE] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_L_DQUOTE] = ACTIONS(3346),
    [anon_sym_u_DQUOTE] = ACTIONS(3346),
    [anon_sym_U_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8_DQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [sym_true] = ACTIONS(3344),
    [sym_false] = ACTIONS(3344),
    [anon_sym_NULL] = ACTIONS(3344),
    [anon_sym_nullptr] = ACTIONS(3344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_This] = ACTIONS(3344),
    [anon_sym_decltype] = ACTIONS(3344),
    [sym_virtual] = ACTIONS(3344),
    [anon_sym_explicit] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_template] = ACTIONS(3344),
    [anon_sym_operator] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_delete] = ACTIONS(3344),
    [anon_sym_throw] = ACTIONS(3344),
    [anon_sym_namespace] = ACTIONS(3344),
    [anon_sym_using] = ACTIONS(3344),
    [anon_sym_static_assert] = ACTIONS(3344),
    [anon_sym_concept] = ACTIONS(3344),
    [anon_sym_co_return] = ACTIONS(3344),
    [anon_sym_co_yield] = ACTIONS(3344),
    [anon_sym_R_DQUOTE] = ACTIONS(3346),
    [anon_sym_LR_DQUOTE] = ACTIONS(3346),
    [anon_sym_uR_DQUOTE] = ACTIONS(3346),
    [anon_sym_UR_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3346),
    [anon_sym_co_await] = ACTIONS(3344),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_requires] = ACTIONS(3344),
    [sym_this] = ACTIONS(3344),
    [anon_sym_discard] = ACTIONS(3344),
    [anon_sym_precise] = ACTIONS(3344),
    [anon_sym_shared] = ACTIONS(3344),
    [anon_sym_groupshared] = ACTIONS(3344),
    [anon_sym_uniform] = ACTIONS(3344),
    [anon_sym_row_major] = ACTIONS(3344),
    [anon_sym_column_major] = ACTIONS(3344),
    [anon_sym_globallycoherent] = ACTIONS(3344),
    [anon_sym_centroid] = ACTIONS(3344),
    [anon_sym_noperspective] = ACTIONS(3344),
    [anon_sym_nointerpolation] = ACTIONS(3344),
    [anon_sym_sample] = ACTIONS(3344),
    [anon_sym_linear] = ACTIONS(3344),
    [anon_sym_snorm] = ACTIONS(3344),
    [anon_sym_unorm] = ACTIONS(3344),
    [anon_sym_point] = ACTIONS(3344),
    [anon_sym_line] = ACTIONS(3344),
    [anon_sym_triangleadj] = ACTIONS(3344),
    [anon_sym_lineadj] = ACTIONS(3344),
    [anon_sym_triangle] = ACTIONS(3344),
    [anon_sym_cbuffer] = ACTIONS(3344),
    [anon_sym_interface] = ACTIONS(3344),
    [anon_sym_extension] = ACTIONS(3344),
  },
  [690] = {
    [sym_identifier] = ACTIONS(3008),
    [aux_sym_preproc_include_token1] = ACTIONS(3008),
    [aux_sym_preproc_def_token1] = ACTIONS(3008),
    [aux_sym_preproc_if_token1] = ACTIONS(3008),
    [aux_sym_preproc_if_token2] = ACTIONS(3008),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3008),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3008),
    [sym_preproc_directive] = ACTIONS(3008),
    [anon_sym_LPAREN2] = ACTIONS(3010),
    [anon_sym_BANG] = ACTIONS(3010),
    [anon_sym_TILDE] = ACTIONS(3010),
    [anon_sym_DASH] = ACTIONS(3008),
    [anon_sym_PLUS] = ACTIONS(3008),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_AMP_AMP] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3008),
    [anon_sym_SEMI] = ACTIONS(3010),
    [anon_sym___extension__] = ACTIONS(3008),
    [anon_sym_typedef] = ACTIONS(3008),
    [anon_sym_in] = ACTIONS(3008),
    [anon_sym_out] = ACTIONS(3008),
    [anon_sym_inout] = ACTIONS(3008),
    [anon_sym_extern] = ACTIONS(3008),
    [anon_sym___attribute__] = ACTIONS(3008),
    [anon_sym_COLON_COLON] = ACTIONS(3010),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3010),
    [anon_sym___declspec] = ACTIONS(3008),
    [anon_sym___based] = ACTIONS(3008),
    [anon_sym___cdecl] = ACTIONS(3008),
    [anon_sym___clrcall] = ACTIONS(3008),
    [anon_sym___stdcall] = ACTIONS(3008),
    [anon_sym___fastcall] = ACTIONS(3008),
    [anon_sym___thiscall] = ACTIONS(3008),
    [anon_sym___vectorcall] = ACTIONS(3008),
    [anon_sym_LBRACE] = ACTIONS(3010),
    [anon_sym_signed] = ACTIONS(3008),
    [anon_sym_unsigned] = ACTIONS(3008),
    [anon_sym_long] = ACTIONS(3008),
    [anon_sym_short] = ACTIONS(3008),
    [anon_sym_LBRACK] = ACTIONS(3008),
    [anon_sym_static] = ACTIONS(3008),
    [anon_sym_register] = ACTIONS(3008),
    [anon_sym_inline] = ACTIONS(3008),
    [anon_sym___inline] = ACTIONS(3008),
    [anon_sym___inline__] = ACTIONS(3008),
    [anon_sym___forceinline] = ACTIONS(3008),
    [anon_sym_thread_local] = ACTIONS(3008),
    [anon_sym___thread] = ACTIONS(3008),
    [anon_sym_const] = ACTIONS(3008),
    [anon_sym_constexpr] = ACTIONS(3008),
    [anon_sym_volatile] = ACTIONS(3008),
    [anon_sym_restrict] = ACTIONS(3008),
    [anon_sym___restrict__] = ACTIONS(3008),
    [anon_sym__Atomic] = ACTIONS(3008),
    [anon_sym__Noreturn] = ACTIONS(3008),
    [anon_sym_noreturn] = ACTIONS(3008),
    [anon_sym_mutable] = ACTIONS(3008),
    [anon_sym_constinit] = ACTIONS(3008),
    [anon_sym_consteval] = ACTIONS(3008),
    [anon_sym_alignas] = ACTIONS(3008),
    [anon_sym__Alignas] = ACTIONS(3008),
    [sym_primitive_type] = ACTIONS(3008),
    [anon_sym_enum] = ACTIONS(3008),
    [anon_sym_class] = ACTIONS(3008),
    [anon_sym_struct] = ACTIONS(3008),
    [anon_sym_union] = ACTIONS(3008),
    [anon_sym_if] = ACTIONS(3008),
    [anon_sym_else] = ACTIONS(3008),
    [anon_sym_switch] = ACTIONS(3008),
    [anon_sym_case] = ACTIONS(3008),
    [anon_sym_default] = ACTIONS(3008),
    [anon_sym_while] = ACTIONS(3008),
    [anon_sym_do] = ACTIONS(3008),
    [anon_sym_for] = ACTIONS(3008),
    [anon_sym_return] = ACTIONS(3008),
    [anon_sym_break] = ACTIONS(3008),
    [anon_sym_continue] = ACTIONS(3008),
    [anon_sym_goto] = ACTIONS(3008),
    [anon_sym___try] = ACTIONS(3008),
    [anon_sym___leave] = ACTIONS(3008),
    [anon_sym_not] = ACTIONS(3008),
    [anon_sym_compl] = ACTIONS(3008),
    [anon_sym_DASH_DASH] = ACTIONS(3010),
    [anon_sym_PLUS_PLUS] = ACTIONS(3010),
    [anon_sym_sizeof] = ACTIONS(3008),
    [anon_sym___alignof__] = ACTIONS(3008),
    [anon_sym___alignof] = ACTIONS(3008),
    [anon_sym__alignof] = ACTIONS(3008),
    [anon_sym_alignof] = ACTIONS(3008),
    [anon_sym__Alignof] = ACTIONS(3008),
    [anon_sym_offsetof] = ACTIONS(3008),
    [anon_sym__Generic] = ACTIONS(3008),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [sym_number_literal] = ACTIONS(3010),
    [anon_sym_L_SQUOTE] = ACTIONS(3010),
    [anon_sym_u_SQUOTE] = ACTIONS(3010),
    [anon_sym_U_SQUOTE] = ACTIONS(3010),
    [anon_sym_u8_SQUOTE] = ACTIONS(3010),
    [anon_sym_SQUOTE] = ACTIONS(3010),
    [anon_sym_L_DQUOTE] = ACTIONS(3010),
    [anon_sym_u_DQUOTE] = ACTIONS(3010),
    [anon_sym_U_DQUOTE] = ACTIONS(3010),
    [anon_sym_u8_DQUOTE] = ACTIONS(3010),
    [anon_sym_DQUOTE] = ACTIONS(3010),
    [sym_true] = ACTIONS(3008),
    [sym_false] = ACTIONS(3008),
    [anon_sym_NULL] = ACTIONS(3008),
    [anon_sym_nullptr] = ACTIONS(3008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3008),
    [anon_sym_let] = ACTIONS(3008),
    [anon_sym_This] = ACTIONS(3008),
    [anon_sym_decltype] = ACTIONS(3008),
    [sym_virtual] = ACTIONS(3008),
    [anon_sym_explicit] = ACTIONS(3008),
    [anon_sym_typename] = ACTIONS(3008),
    [anon_sym_template] = ACTIONS(3008),
    [anon_sym_operator] = ACTIONS(3008),
    [anon_sym_try] = ACTIONS(3008),
    [anon_sym_delete] = ACTIONS(3008),
    [anon_sym_throw] = ACTIONS(3008),
    [anon_sym_namespace] = ACTIONS(3008),
    [anon_sym_using] = ACTIONS(3008),
    [anon_sym_static_assert] = ACTIONS(3008),
    [anon_sym_concept] = ACTIONS(3008),
    [anon_sym_co_return] = ACTIONS(3008),
    [anon_sym_co_yield] = ACTIONS(3008),
    [anon_sym_R_DQUOTE] = ACTIONS(3010),
    [anon_sym_LR_DQUOTE] = ACTIONS(3010),
    [anon_sym_uR_DQUOTE] = ACTIONS(3010),
    [anon_sym_UR_DQUOTE] = ACTIONS(3010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3010),
    [anon_sym_co_await] = ACTIONS(3008),
    [anon_sym_new] = ACTIONS(3008),
    [anon_sym_requires] = ACTIONS(3008),
    [sym_this] = ACTIONS(3008),
    [anon_sym_discard] = ACTIONS(3008),
    [anon_sym_precise] = ACTIONS(3008),
    [anon_sym_shared] = ACTIONS(3008),
    [anon_sym_groupshared] = ACTIONS(3008),
    [anon_sym_uniform] = ACTIONS(3008),
    [anon_sym_row_major] = ACTIONS(3008),
    [anon_sym_column_major] = ACTIONS(3008),
    [anon_sym_globallycoherent] = ACTIONS(3008),
    [anon_sym_centroid] = ACTIONS(3008),
    [anon_sym_noperspective] = ACTIONS(3008),
    [anon_sym_nointerpolation] = ACTIONS(3008),
    [anon_sym_sample] = ACTIONS(3008),
    [anon_sym_linear] = ACTIONS(3008),
    [anon_sym_snorm] = ACTIONS(3008),
    [anon_sym_unorm] = ACTIONS(3008),
    [anon_sym_point] = ACTIONS(3008),
    [anon_sym_line] = ACTIONS(3008),
    [anon_sym_triangleadj] = ACTIONS(3008),
    [anon_sym_lineadj] = ACTIONS(3008),
    [anon_sym_triangle] = ACTIONS(3008),
    [anon_sym_cbuffer] = ACTIONS(3008),
    [anon_sym_interface] = ACTIONS(3008),
    [anon_sym_extension] = ACTIONS(3008),
  },
  [691] = {
    [sym_identifier] = ACTIONS(3014),
    [aux_sym_preproc_include_token1] = ACTIONS(3014),
    [aux_sym_preproc_def_token1] = ACTIONS(3014),
    [aux_sym_preproc_if_token1] = ACTIONS(3014),
    [aux_sym_preproc_if_token2] = ACTIONS(3014),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3014),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3014),
    [sym_preproc_directive] = ACTIONS(3014),
    [anon_sym_LPAREN2] = ACTIONS(3016),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [anon_sym_DASH] = ACTIONS(3014),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_STAR] = ACTIONS(3016),
    [anon_sym_AMP_AMP] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3016),
    [anon_sym___extension__] = ACTIONS(3014),
    [anon_sym_typedef] = ACTIONS(3014),
    [anon_sym_in] = ACTIONS(3014),
    [anon_sym_out] = ACTIONS(3014),
    [anon_sym_inout] = ACTIONS(3014),
    [anon_sym_extern] = ACTIONS(3014),
    [anon_sym___attribute__] = ACTIONS(3014),
    [anon_sym_COLON_COLON] = ACTIONS(3016),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3016),
    [anon_sym___declspec] = ACTIONS(3014),
    [anon_sym___based] = ACTIONS(3014),
    [anon_sym___cdecl] = ACTIONS(3014),
    [anon_sym___clrcall] = ACTIONS(3014),
    [anon_sym___stdcall] = ACTIONS(3014),
    [anon_sym___fastcall] = ACTIONS(3014),
    [anon_sym___thiscall] = ACTIONS(3014),
    [anon_sym___vectorcall] = ACTIONS(3014),
    [anon_sym_LBRACE] = ACTIONS(3016),
    [anon_sym_signed] = ACTIONS(3014),
    [anon_sym_unsigned] = ACTIONS(3014),
    [anon_sym_long] = ACTIONS(3014),
    [anon_sym_short] = ACTIONS(3014),
    [anon_sym_LBRACK] = ACTIONS(3014),
    [anon_sym_static] = ACTIONS(3014),
    [anon_sym_register] = ACTIONS(3014),
    [anon_sym_inline] = ACTIONS(3014),
    [anon_sym___inline] = ACTIONS(3014),
    [anon_sym___inline__] = ACTIONS(3014),
    [anon_sym___forceinline] = ACTIONS(3014),
    [anon_sym_thread_local] = ACTIONS(3014),
    [anon_sym___thread] = ACTIONS(3014),
    [anon_sym_const] = ACTIONS(3014),
    [anon_sym_constexpr] = ACTIONS(3014),
    [anon_sym_volatile] = ACTIONS(3014),
    [anon_sym_restrict] = ACTIONS(3014),
    [anon_sym___restrict__] = ACTIONS(3014),
    [anon_sym__Atomic] = ACTIONS(3014),
    [anon_sym__Noreturn] = ACTIONS(3014),
    [anon_sym_noreturn] = ACTIONS(3014),
    [anon_sym_mutable] = ACTIONS(3014),
    [anon_sym_constinit] = ACTIONS(3014),
    [anon_sym_consteval] = ACTIONS(3014),
    [anon_sym_alignas] = ACTIONS(3014),
    [anon_sym__Alignas] = ACTIONS(3014),
    [sym_primitive_type] = ACTIONS(3014),
    [anon_sym_enum] = ACTIONS(3014),
    [anon_sym_class] = ACTIONS(3014),
    [anon_sym_struct] = ACTIONS(3014),
    [anon_sym_union] = ACTIONS(3014),
    [anon_sym_if] = ACTIONS(3014),
    [anon_sym_else] = ACTIONS(3014),
    [anon_sym_switch] = ACTIONS(3014),
    [anon_sym_case] = ACTIONS(3014),
    [anon_sym_default] = ACTIONS(3014),
    [anon_sym_while] = ACTIONS(3014),
    [anon_sym_do] = ACTIONS(3014),
    [anon_sym_for] = ACTIONS(3014),
    [anon_sym_return] = ACTIONS(3014),
    [anon_sym_break] = ACTIONS(3014),
    [anon_sym_continue] = ACTIONS(3014),
    [anon_sym_goto] = ACTIONS(3014),
    [anon_sym___try] = ACTIONS(3014),
    [anon_sym___leave] = ACTIONS(3014),
    [anon_sym_not] = ACTIONS(3014),
    [anon_sym_compl] = ACTIONS(3014),
    [anon_sym_DASH_DASH] = ACTIONS(3016),
    [anon_sym_PLUS_PLUS] = ACTIONS(3016),
    [anon_sym_sizeof] = ACTIONS(3014),
    [anon_sym___alignof__] = ACTIONS(3014),
    [anon_sym___alignof] = ACTIONS(3014),
    [anon_sym__alignof] = ACTIONS(3014),
    [anon_sym_alignof] = ACTIONS(3014),
    [anon_sym__Alignof] = ACTIONS(3014),
    [anon_sym_offsetof] = ACTIONS(3014),
    [anon_sym__Generic] = ACTIONS(3014),
    [anon_sym_asm] = ACTIONS(3014),
    [anon_sym___asm__] = ACTIONS(3014),
    [sym_number_literal] = ACTIONS(3016),
    [anon_sym_L_SQUOTE] = ACTIONS(3016),
    [anon_sym_u_SQUOTE] = ACTIONS(3016),
    [anon_sym_U_SQUOTE] = ACTIONS(3016),
    [anon_sym_u8_SQUOTE] = ACTIONS(3016),
    [anon_sym_SQUOTE] = ACTIONS(3016),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3014),
    [sym_false] = ACTIONS(3014),
    [anon_sym_NULL] = ACTIONS(3014),
    [anon_sym_nullptr] = ACTIONS(3014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3014),
    [anon_sym_let] = ACTIONS(3014),
    [anon_sym_This] = ACTIONS(3014),
    [anon_sym_decltype] = ACTIONS(3014),
    [sym_virtual] = ACTIONS(3014),
    [anon_sym_explicit] = ACTIONS(3014),
    [anon_sym_typename] = ACTIONS(3014),
    [anon_sym_template] = ACTIONS(3014),
    [anon_sym_operator] = ACTIONS(3014),
    [anon_sym_try] = ACTIONS(3014),
    [anon_sym_delete] = ACTIONS(3014),
    [anon_sym_throw] = ACTIONS(3014),
    [anon_sym_namespace] = ACTIONS(3014),
    [anon_sym_using] = ACTIONS(3014),
    [anon_sym_static_assert] = ACTIONS(3014),
    [anon_sym_concept] = ACTIONS(3014),
    [anon_sym_co_return] = ACTIONS(3014),
    [anon_sym_co_yield] = ACTIONS(3014),
    [anon_sym_R_DQUOTE] = ACTIONS(3016),
    [anon_sym_LR_DQUOTE] = ACTIONS(3016),
    [anon_sym_uR_DQUOTE] = ACTIONS(3016),
    [anon_sym_UR_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3016),
    [anon_sym_co_await] = ACTIONS(3014),
    [anon_sym_new] = ACTIONS(3014),
    [anon_sym_requires] = ACTIONS(3014),
    [sym_this] = ACTIONS(3014),
    [anon_sym_discard] = ACTIONS(3014),
    [anon_sym_precise] = ACTIONS(3014),
    [anon_sym_shared] = ACTIONS(3014),
    [anon_sym_groupshared] = ACTIONS(3014),
    [anon_sym_uniform] = ACTIONS(3014),
    [anon_sym_row_major] = ACTIONS(3014),
    [anon_sym_column_major] = ACTIONS(3014),
    [anon_sym_globallycoherent] = ACTIONS(3014),
    [anon_sym_centroid] = ACTIONS(3014),
    [anon_sym_noperspective] = ACTIONS(3014),
    [anon_sym_nointerpolation] = ACTIONS(3014),
    [anon_sym_sample] = ACTIONS(3014),
    [anon_sym_linear] = ACTIONS(3014),
    [anon_sym_snorm] = ACTIONS(3014),
    [anon_sym_unorm] = ACTIONS(3014),
    [anon_sym_point] = ACTIONS(3014),
    [anon_sym_line] = ACTIONS(3014),
    [anon_sym_triangleadj] = ACTIONS(3014),
    [anon_sym_lineadj] = ACTIONS(3014),
    [anon_sym_triangle] = ACTIONS(3014),
    [anon_sym_cbuffer] = ACTIONS(3014),
    [anon_sym_interface] = ACTIONS(3014),
    [anon_sym_extension] = ACTIONS(3014),
  },
  [692] = {
    [sym_identifier] = ACTIONS(3018),
    [aux_sym_preproc_include_token1] = ACTIONS(3018),
    [aux_sym_preproc_def_token1] = ACTIONS(3018),
    [aux_sym_preproc_if_token1] = ACTIONS(3018),
    [aux_sym_preproc_if_token2] = ACTIONS(3018),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3018),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3018),
    [sym_preproc_directive] = ACTIONS(3018),
    [anon_sym_LPAREN2] = ACTIONS(3020),
    [anon_sym_BANG] = ACTIONS(3020),
    [anon_sym_TILDE] = ACTIONS(3020),
    [anon_sym_DASH] = ACTIONS(3018),
    [anon_sym_PLUS] = ACTIONS(3018),
    [anon_sym_STAR] = ACTIONS(3020),
    [anon_sym_AMP_AMP] = ACTIONS(3020),
    [anon_sym_AMP] = ACTIONS(3018),
    [anon_sym_SEMI] = ACTIONS(3020),
    [anon_sym___extension__] = ACTIONS(3018),
    [anon_sym_typedef] = ACTIONS(3018),
    [anon_sym_in] = ACTIONS(3018),
    [anon_sym_out] = ACTIONS(3018),
    [anon_sym_inout] = ACTIONS(3018),
    [anon_sym_extern] = ACTIONS(3018),
    [anon_sym___attribute__] = ACTIONS(3018),
    [anon_sym_COLON_COLON] = ACTIONS(3020),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3020),
    [anon_sym___declspec] = ACTIONS(3018),
    [anon_sym___based] = ACTIONS(3018),
    [anon_sym___cdecl] = ACTIONS(3018),
    [anon_sym___clrcall] = ACTIONS(3018),
    [anon_sym___stdcall] = ACTIONS(3018),
    [anon_sym___fastcall] = ACTIONS(3018),
    [anon_sym___thiscall] = ACTIONS(3018),
    [anon_sym___vectorcall] = ACTIONS(3018),
    [anon_sym_LBRACE] = ACTIONS(3020),
    [anon_sym_signed] = ACTIONS(3018),
    [anon_sym_unsigned] = ACTIONS(3018),
    [anon_sym_long] = ACTIONS(3018),
    [anon_sym_short] = ACTIONS(3018),
    [anon_sym_LBRACK] = ACTIONS(3018),
    [anon_sym_static] = ACTIONS(3018),
    [anon_sym_register] = ACTIONS(3018),
    [anon_sym_inline] = ACTIONS(3018),
    [anon_sym___inline] = ACTIONS(3018),
    [anon_sym___inline__] = ACTIONS(3018),
    [anon_sym___forceinline] = ACTIONS(3018),
    [anon_sym_thread_local] = ACTIONS(3018),
    [anon_sym___thread] = ACTIONS(3018),
    [anon_sym_const] = ACTIONS(3018),
    [anon_sym_constexpr] = ACTIONS(3018),
    [anon_sym_volatile] = ACTIONS(3018),
    [anon_sym_restrict] = ACTIONS(3018),
    [anon_sym___restrict__] = ACTIONS(3018),
    [anon_sym__Atomic] = ACTIONS(3018),
    [anon_sym__Noreturn] = ACTIONS(3018),
    [anon_sym_noreturn] = ACTIONS(3018),
    [anon_sym_mutable] = ACTIONS(3018),
    [anon_sym_constinit] = ACTIONS(3018),
    [anon_sym_consteval] = ACTIONS(3018),
    [anon_sym_alignas] = ACTIONS(3018),
    [anon_sym__Alignas] = ACTIONS(3018),
    [sym_primitive_type] = ACTIONS(3018),
    [anon_sym_enum] = ACTIONS(3018),
    [anon_sym_class] = ACTIONS(3018),
    [anon_sym_struct] = ACTIONS(3018),
    [anon_sym_union] = ACTIONS(3018),
    [anon_sym_if] = ACTIONS(3018),
    [anon_sym_else] = ACTIONS(3018),
    [anon_sym_switch] = ACTIONS(3018),
    [anon_sym_case] = ACTIONS(3018),
    [anon_sym_default] = ACTIONS(3018),
    [anon_sym_while] = ACTIONS(3018),
    [anon_sym_do] = ACTIONS(3018),
    [anon_sym_for] = ACTIONS(3018),
    [anon_sym_return] = ACTIONS(3018),
    [anon_sym_break] = ACTIONS(3018),
    [anon_sym_continue] = ACTIONS(3018),
    [anon_sym_goto] = ACTIONS(3018),
    [anon_sym___try] = ACTIONS(3018),
    [anon_sym___leave] = ACTIONS(3018),
    [anon_sym_not] = ACTIONS(3018),
    [anon_sym_compl] = ACTIONS(3018),
    [anon_sym_DASH_DASH] = ACTIONS(3020),
    [anon_sym_PLUS_PLUS] = ACTIONS(3020),
    [anon_sym_sizeof] = ACTIONS(3018),
    [anon_sym___alignof__] = ACTIONS(3018),
    [anon_sym___alignof] = ACTIONS(3018),
    [anon_sym__alignof] = ACTIONS(3018),
    [anon_sym_alignof] = ACTIONS(3018),
    [anon_sym__Alignof] = ACTIONS(3018),
    [anon_sym_offsetof] = ACTIONS(3018),
    [anon_sym__Generic] = ACTIONS(3018),
    [anon_sym_asm] = ACTIONS(3018),
    [anon_sym___asm__] = ACTIONS(3018),
    [sym_number_literal] = ACTIONS(3020),
    [anon_sym_L_SQUOTE] = ACTIONS(3020),
    [anon_sym_u_SQUOTE] = ACTIONS(3020),
    [anon_sym_U_SQUOTE] = ACTIONS(3020),
    [anon_sym_u8_SQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3020),
    [anon_sym_L_DQUOTE] = ACTIONS(3020),
    [anon_sym_u_DQUOTE] = ACTIONS(3020),
    [anon_sym_U_DQUOTE] = ACTIONS(3020),
    [anon_sym_u8_DQUOTE] = ACTIONS(3020),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3018),
    [anon_sym_nullptr] = ACTIONS(3018),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3018),
    [anon_sym_let] = ACTIONS(3018),
    [anon_sym_This] = ACTIONS(3018),
    [anon_sym_decltype] = ACTIONS(3018),
    [sym_virtual] = ACTIONS(3018),
    [anon_sym_explicit] = ACTIONS(3018),
    [anon_sym_typename] = ACTIONS(3018),
    [anon_sym_template] = ACTIONS(3018),
    [anon_sym_operator] = ACTIONS(3018),
    [anon_sym_try] = ACTIONS(3018),
    [anon_sym_delete] = ACTIONS(3018),
    [anon_sym_throw] = ACTIONS(3018),
    [anon_sym_namespace] = ACTIONS(3018),
    [anon_sym_using] = ACTIONS(3018),
    [anon_sym_static_assert] = ACTIONS(3018),
    [anon_sym_concept] = ACTIONS(3018),
    [anon_sym_co_return] = ACTIONS(3018),
    [anon_sym_co_yield] = ACTIONS(3018),
    [anon_sym_R_DQUOTE] = ACTIONS(3020),
    [anon_sym_LR_DQUOTE] = ACTIONS(3020),
    [anon_sym_uR_DQUOTE] = ACTIONS(3020),
    [anon_sym_UR_DQUOTE] = ACTIONS(3020),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3020),
    [anon_sym_co_await] = ACTIONS(3018),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_requires] = ACTIONS(3018),
    [sym_this] = ACTIONS(3018),
    [anon_sym_discard] = ACTIONS(3018),
    [anon_sym_precise] = ACTIONS(3018),
    [anon_sym_shared] = ACTIONS(3018),
    [anon_sym_groupshared] = ACTIONS(3018),
    [anon_sym_uniform] = ACTIONS(3018),
    [anon_sym_row_major] = ACTIONS(3018),
    [anon_sym_column_major] = ACTIONS(3018),
    [anon_sym_globallycoherent] = ACTIONS(3018),
    [anon_sym_centroid] = ACTIONS(3018),
    [anon_sym_noperspective] = ACTIONS(3018),
    [anon_sym_nointerpolation] = ACTIONS(3018),
    [anon_sym_sample] = ACTIONS(3018),
    [anon_sym_linear] = ACTIONS(3018),
    [anon_sym_snorm] = ACTIONS(3018),
    [anon_sym_unorm] = ACTIONS(3018),
    [anon_sym_point] = ACTIONS(3018),
    [anon_sym_line] = ACTIONS(3018),
    [anon_sym_triangleadj] = ACTIONS(3018),
    [anon_sym_lineadj] = ACTIONS(3018),
    [anon_sym_triangle] = ACTIONS(3018),
    [anon_sym_cbuffer] = ACTIONS(3018),
    [anon_sym_interface] = ACTIONS(3018),
    [anon_sym_extension] = ACTIONS(3018),
  },
  [693] = {
    [sym_identifier] = ACTIONS(3022),
    [aux_sym_preproc_include_token1] = ACTIONS(3022),
    [aux_sym_preproc_def_token1] = ACTIONS(3022),
    [aux_sym_preproc_if_token1] = ACTIONS(3022),
    [aux_sym_preproc_if_token2] = ACTIONS(3022),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3022),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3022),
    [sym_preproc_directive] = ACTIONS(3022),
    [anon_sym_LPAREN2] = ACTIONS(3024),
    [anon_sym_BANG] = ACTIONS(3024),
    [anon_sym_TILDE] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3022),
    [anon_sym_PLUS] = ACTIONS(3022),
    [anon_sym_STAR] = ACTIONS(3024),
    [anon_sym_AMP_AMP] = ACTIONS(3024),
    [anon_sym_AMP] = ACTIONS(3022),
    [anon_sym_SEMI] = ACTIONS(3024),
    [anon_sym___extension__] = ACTIONS(3022),
    [anon_sym_typedef] = ACTIONS(3022),
    [anon_sym_in] = ACTIONS(3022),
    [anon_sym_out] = ACTIONS(3022),
    [anon_sym_inout] = ACTIONS(3022),
    [anon_sym_extern] = ACTIONS(3022),
    [anon_sym___attribute__] = ACTIONS(3022),
    [anon_sym_COLON_COLON] = ACTIONS(3024),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3024),
    [anon_sym___declspec] = ACTIONS(3022),
    [anon_sym___based] = ACTIONS(3022),
    [anon_sym___cdecl] = ACTIONS(3022),
    [anon_sym___clrcall] = ACTIONS(3022),
    [anon_sym___stdcall] = ACTIONS(3022),
    [anon_sym___fastcall] = ACTIONS(3022),
    [anon_sym___thiscall] = ACTIONS(3022),
    [anon_sym___vectorcall] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_signed] = ACTIONS(3022),
    [anon_sym_unsigned] = ACTIONS(3022),
    [anon_sym_long] = ACTIONS(3022),
    [anon_sym_short] = ACTIONS(3022),
    [anon_sym_LBRACK] = ACTIONS(3022),
    [anon_sym_static] = ACTIONS(3022),
    [anon_sym_register] = ACTIONS(3022),
    [anon_sym_inline] = ACTIONS(3022),
    [anon_sym___inline] = ACTIONS(3022),
    [anon_sym___inline__] = ACTIONS(3022),
    [anon_sym___forceinline] = ACTIONS(3022),
    [anon_sym_thread_local] = ACTIONS(3022),
    [anon_sym___thread] = ACTIONS(3022),
    [anon_sym_const] = ACTIONS(3022),
    [anon_sym_constexpr] = ACTIONS(3022),
    [anon_sym_volatile] = ACTIONS(3022),
    [anon_sym_restrict] = ACTIONS(3022),
    [anon_sym___restrict__] = ACTIONS(3022),
    [anon_sym__Atomic] = ACTIONS(3022),
    [anon_sym__Noreturn] = ACTIONS(3022),
    [anon_sym_noreturn] = ACTIONS(3022),
    [anon_sym_mutable] = ACTIONS(3022),
    [anon_sym_constinit] = ACTIONS(3022),
    [anon_sym_consteval] = ACTIONS(3022),
    [anon_sym_alignas] = ACTIONS(3022),
    [anon_sym__Alignas] = ACTIONS(3022),
    [sym_primitive_type] = ACTIONS(3022),
    [anon_sym_enum] = ACTIONS(3022),
    [anon_sym_class] = ACTIONS(3022),
    [anon_sym_struct] = ACTIONS(3022),
    [anon_sym_union] = ACTIONS(3022),
    [anon_sym_if] = ACTIONS(3022),
    [anon_sym_else] = ACTIONS(3022),
    [anon_sym_switch] = ACTIONS(3022),
    [anon_sym_case] = ACTIONS(3022),
    [anon_sym_default] = ACTIONS(3022),
    [anon_sym_while] = ACTIONS(3022),
    [anon_sym_do] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(3022),
    [anon_sym_return] = ACTIONS(3022),
    [anon_sym_break] = ACTIONS(3022),
    [anon_sym_continue] = ACTIONS(3022),
    [anon_sym_goto] = ACTIONS(3022),
    [anon_sym___try] = ACTIONS(3022),
    [anon_sym___leave] = ACTIONS(3022),
    [anon_sym_not] = ACTIONS(3022),
    [anon_sym_compl] = ACTIONS(3022),
    [anon_sym_DASH_DASH] = ACTIONS(3024),
    [anon_sym_PLUS_PLUS] = ACTIONS(3024),
    [anon_sym_sizeof] = ACTIONS(3022),
    [anon_sym___alignof__] = ACTIONS(3022),
    [anon_sym___alignof] = ACTIONS(3022),
    [anon_sym__alignof] = ACTIONS(3022),
    [anon_sym_alignof] = ACTIONS(3022),
    [anon_sym__Alignof] = ACTIONS(3022),
    [anon_sym_offsetof] = ACTIONS(3022),
    [anon_sym__Generic] = ACTIONS(3022),
    [anon_sym_asm] = ACTIONS(3022),
    [anon_sym___asm__] = ACTIONS(3022),
    [sym_number_literal] = ACTIONS(3024),
    [anon_sym_L_SQUOTE] = ACTIONS(3024),
    [anon_sym_u_SQUOTE] = ACTIONS(3024),
    [anon_sym_U_SQUOTE] = ACTIONS(3024),
    [anon_sym_u8_SQUOTE] = ACTIONS(3024),
    [anon_sym_SQUOTE] = ACTIONS(3024),
    [anon_sym_L_DQUOTE] = ACTIONS(3024),
    [anon_sym_u_DQUOTE] = ACTIONS(3024),
    [anon_sym_U_DQUOTE] = ACTIONS(3024),
    [anon_sym_u8_DQUOTE] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3024),
    [sym_true] = ACTIONS(3022),
    [sym_false] = ACTIONS(3022),
    [anon_sym_NULL] = ACTIONS(3022),
    [anon_sym_nullptr] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3022),
    [anon_sym_let] = ACTIONS(3022),
    [anon_sym_This] = ACTIONS(3022),
    [anon_sym_decltype] = ACTIONS(3022),
    [sym_virtual] = ACTIONS(3022),
    [anon_sym_explicit] = ACTIONS(3022),
    [anon_sym_typename] = ACTIONS(3022),
    [anon_sym_template] = ACTIONS(3022),
    [anon_sym_operator] = ACTIONS(3022),
    [anon_sym_try] = ACTIONS(3022),
    [anon_sym_delete] = ACTIONS(3022),
    [anon_sym_throw] = ACTIONS(3022),
    [anon_sym_namespace] = ACTIONS(3022),
    [anon_sym_using] = ACTIONS(3022),
    [anon_sym_static_assert] = ACTIONS(3022),
    [anon_sym_concept] = ACTIONS(3022),
    [anon_sym_co_return] = ACTIONS(3022),
    [anon_sym_co_yield] = ACTIONS(3022),
    [anon_sym_R_DQUOTE] = ACTIONS(3024),
    [anon_sym_LR_DQUOTE] = ACTIONS(3024),
    [anon_sym_uR_DQUOTE] = ACTIONS(3024),
    [anon_sym_UR_DQUOTE] = ACTIONS(3024),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3024),
    [anon_sym_co_await] = ACTIONS(3022),
    [anon_sym_new] = ACTIONS(3022),
    [anon_sym_requires] = ACTIONS(3022),
    [sym_this] = ACTIONS(3022),
    [anon_sym_discard] = ACTIONS(3022),
    [anon_sym_precise] = ACTIONS(3022),
    [anon_sym_shared] = ACTIONS(3022),
    [anon_sym_groupshared] = ACTIONS(3022),
    [anon_sym_uniform] = ACTIONS(3022),
    [anon_sym_row_major] = ACTIONS(3022),
    [anon_sym_column_major] = ACTIONS(3022),
    [anon_sym_globallycoherent] = ACTIONS(3022),
    [anon_sym_centroid] = ACTIONS(3022),
    [anon_sym_noperspective] = ACTIONS(3022),
    [anon_sym_nointerpolation] = ACTIONS(3022),
    [anon_sym_sample] = ACTIONS(3022),
    [anon_sym_linear] = ACTIONS(3022),
    [anon_sym_snorm] = ACTIONS(3022),
    [anon_sym_unorm] = ACTIONS(3022),
    [anon_sym_point] = ACTIONS(3022),
    [anon_sym_line] = ACTIONS(3022),
    [anon_sym_triangleadj] = ACTIONS(3022),
    [anon_sym_lineadj] = ACTIONS(3022),
    [anon_sym_triangle] = ACTIONS(3022),
    [anon_sym_cbuffer] = ACTIONS(3022),
    [anon_sym_interface] = ACTIONS(3022),
    [anon_sym_extension] = ACTIONS(3022),
  },
  [694] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(3072),
    [anon_sym_out] = ACTIONS(3072),
    [anon_sym_inout] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym__Alignas] = ACTIONS(3072),
    [sym_primitive_type] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [sym_number_literal] = ACTIONS(3074),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3072),
    [anon_sym_let] = ACTIONS(3072),
    [anon_sym_This] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [sym_virtual] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
    [anon_sym_discard] = ACTIONS(3072),
    [anon_sym_precise] = ACTIONS(3072),
    [anon_sym_shared] = ACTIONS(3072),
    [anon_sym_groupshared] = ACTIONS(3072),
    [anon_sym_uniform] = ACTIONS(3072),
    [anon_sym_row_major] = ACTIONS(3072),
    [anon_sym_column_major] = ACTIONS(3072),
    [anon_sym_globallycoherent] = ACTIONS(3072),
    [anon_sym_centroid] = ACTIONS(3072),
    [anon_sym_noperspective] = ACTIONS(3072),
    [anon_sym_nointerpolation] = ACTIONS(3072),
    [anon_sym_sample] = ACTIONS(3072),
    [anon_sym_linear] = ACTIONS(3072),
    [anon_sym_snorm] = ACTIONS(3072),
    [anon_sym_unorm] = ACTIONS(3072),
    [anon_sym_point] = ACTIONS(3072),
    [anon_sym_line] = ACTIONS(3072),
    [anon_sym_triangleadj] = ACTIONS(3072),
    [anon_sym_lineadj] = ACTIONS(3072),
    [anon_sym_triangle] = ACTIONS(3072),
    [anon_sym_cbuffer] = ACTIONS(3072),
    [anon_sym_interface] = ACTIONS(3072),
    [anon_sym_extension] = ACTIONS(3072),
  },
  [695] = {
    [sym_identifier] = ACTIONS(3084),
    [aux_sym_preproc_include_token1] = ACTIONS(3084),
    [aux_sym_preproc_def_token1] = ACTIONS(3084),
    [aux_sym_preproc_if_token1] = ACTIONS(3084),
    [aux_sym_preproc_if_token2] = ACTIONS(3084),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3084),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3084),
    [sym_preproc_directive] = ACTIONS(3084),
    [anon_sym_LPAREN2] = ACTIONS(3086),
    [anon_sym_BANG] = ACTIONS(3086),
    [anon_sym_TILDE] = ACTIONS(3086),
    [anon_sym_DASH] = ACTIONS(3084),
    [anon_sym_PLUS] = ACTIONS(3084),
    [anon_sym_STAR] = ACTIONS(3086),
    [anon_sym_AMP_AMP] = ACTIONS(3086),
    [anon_sym_AMP] = ACTIONS(3084),
    [anon_sym_SEMI] = ACTIONS(3086),
    [anon_sym___extension__] = ACTIONS(3084),
    [anon_sym_typedef] = ACTIONS(3084),
    [anon_sym_in] = ACTIONS(3084),
    [anon_sym_out] = ACTIONS(3084),
    [anon_sym_inout] = ACTIONS(3084),
    [anon_sym_extern] = ACTIONS(3084),
    [anon_sym___attribute__] = ACTIONS(3084),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3086),
    [anon_sym___declspec] = ACTIONS(3084),
    [anon_sym___based] = ACTIONS(3084),
    [anon_sym___cdecl] = ACTIONS(3084),
    [anon_sym___clrcall] = ACTIONS(3084),
    [anon_sym___stdcall] = ACTIONS(3084),
    [anon_sym___fastcall] = ACTIONS(3084),
    [anon_sym___thiscall] = ACTIONS(3084),
    [anon_sym___vectorcall] = ACTIONS(3084),
    [anon_sym_LBRACE] = ACTIONS(3086),
    [anon_sym_signed] = ACTIONS(3084),
    [anon_sym_unsigned] = ACTIONS(3084),
    [anon_sym_long] = ACTIONS(3084),
    [anon_sym_short] = ACTIONS(3084),
    [anon_sym_LBRACK] = ACTIONS(3084),
    [anon_sym_static] = ACTIONS(3084),
    [anon_sym_register] = ACTIONS(3084),
    [anon_sym_inline] = ACTIONS(3084),
    [anon_sym___inline] = ACTIONS(3084),
    [anon_sym___inline__] = ACTIONS(3084),
    [anon_sym___forceinline] = ACTIONS(3084),
    [anon_sym_thread_local] = ACTIONS(3084),
    [anon_sym___thread] = ACTIONS(3084),
    [anon_sym_const] = ACTIONS(3084),
    [anon_sym_constexpr] = ACTIONS(3084),
    [anon_sym_volatile] = ACTIONS(3084),
    [anon_sym_restrict] = ACTIONS(3084),
    [anon_sym___restrict__] = ACTIONS(3084),
    [anon_sym__Atomic] = ACTIONS(3084),
    [anon_sym__Noreturn] = ACTIONS(3084),
    [anon_sym_noreturn] = ACTIONS(3084),
    [anon_sym_mutable] = ACTIONS(3084),
    [anon_sym_constinit] = ACTIONS(3084),
    [anon_sym_consteval] = ACTIONS(3084),
    [anon_sym_alignas] = ACTIONS(3084),
    [anon_sym__Alignas] = ACTIONS(3084),
    [sym_primitive_type] = ACTIONS(3084),
    [anon_sym_enum] = ACTIONS(3084),
    [anon_sym_class] = ACTIONS(3084),
    [anon_sym_struct] = ACTIONS(3084),
    [anon_sym_union] = ACTIONS(3084),
    [anon_sym_if] = ACTIONS(3084),
    [anon_sym_else] = ACTIONS(3084),
    [anon_sym_switch] = ACTIONS(3084),
    [anon_sym_case] = ACTIONS(3084),
    [anon_sym_default] = ACTIONS(3084),
    [anon_sym_while] = ACTIONS(3084),
    [anon_sym_do] = ACTIONS(3084),
    [anon_sym_for] = ACTIONS(3084),
    [anon_sym_return] = ACTIONS(3084),
    [anon_sym_break] = ACTIONS(3084),
    [anon_sym_continue] = ACTIONS(3084),
    [anon_sym_goto] = ACTIONS(3084),
    [anon_sym___try] = ACTIONS(3084),
    [anon_sym___leave] = ACTIONS(3084),
    [anon_sym_not] = ACTIONS(3084),
    [anon_sym_compl] = ACTIONS(3084),
    [anon_sym_DASH_DASH] = ACTIONS(3086),
    [anon_sym_PLUS_PLUS] = ACTIONS(3086),
    [anon_sym_sizeof] = ACTIONS(3084),
    [anon_sym___alignof__] = ACTIONS(3084),
    [anon_sym___alignof] = ACTIONS(3084),
    [anon_sym__alignof] = ACTIONS(3084),
    [anon_sym_alignof] = ACTIONS(3084),
    [anon_sym__Alignof] = ACTIONS(3084),
    [anon_sym_offsetof] = ACTIONS(3084),
    [anon_sym__Generic] = ACTIONS(3084),
    [anon_sym_asm] = ACTIONS(3084),
    [anon_sym___asm__] = ACTIONS(3084),
    [sym_number_literal] = ACTIONS(3086),
    [anon_sym_L_SQUOTE] = ACTIONS(3086),
    [anon_sym_u_SQUOTE] = ACTIONS(3086),
    [anon_sym_U_SQUOTE] = ACTIONS(3086),
    [anon_sym_u8_SQUOTE] = ACTIONS(3086),
    [anon_sym_SQUOTE] = ACTIONS(3086),
    [anon_sym_L_DQUOTE] = ACTIONS(3086),
    [anon_sym_u_DQUOTE] = ACTIONS(3086),
    [anon_sym_U_DQUOTE] = ACTIONS(3086),
    [anon_sym_u8_DQUOTE] = ACTIONS(3086),
    [anon_sym_DQUOTE] = ACTIONS(3086),
    [sym_true] = ACTIONS(3084),
    [sym_false] = ACTIONS(3084),
    [anon_sym_NULL] = ACTIONS(3084),
    [anon_sym_nullptr] = ACTIONS(3084),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3084),
    [anon_sym_let] = ACTIONS(3084),
    [anon_sym_This] = ACTIONS(3084),
    [anon_sym_decltype] = ACTIONS(3084),
    [sym_virtual] = ACTIONS(3084),
    [anon_sym_explicit] = ACTIONS(3084),
    [anon_sym_typename] = ACTIONS(3084),
    [anon_sym_template] = ACTIONS(3084),
    [anon_sym_operator] = ACTIONS(3084),
    [anon_sym_try] = ACTIONS(3084),
    [anon_sym_delete] = ACTIONS(3084),
    [anon_sym_throw] = ACTIONS(3084),
    [anon_sym_namespace] = ACTIONS(3084),
    [anon_sym_using] = ACTIONS(3084),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_concept] = ACTIONS(3084),
    [anon_sym_co_return] = ACTIONS(3084),
    [anon_sym_co_yield] = ACTIONS(3084),
    [anon_sym_R_DQUOTE] = ACTIONS(3086),
    [anon_sym_LR_DQUOTE] = ACTIONS(3086),
    [anon_sym_uR_DQUOTE] = ACTIONS(3086),
    [anon_sym_UR_DQUOTE] = ACTIONS(3086),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3086),
    [anon_sym_co_await] = ACTIONS(3084),
    [anon_sym_new] = ACTIONS(3084),
    [anon_sym_requires] = ACTIONS(3084),
    [sym_this] = ACTIONS(3084),
    [anon_sym_discard] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(3084),
    [anon_sym_shared] = ACTIONS(3084),
    [anon_sym_groupshared] = ACTIONS(3084),
    [anon_sym_uniform] = ACTIONS(3084),
    [anon_sym_row_major] = ACTIONS(3084),
    [anon_sym_column_major] = ACTIONS(3084),
    [anon_sym_globallycoherent] = ACTIONS(3084),
    [anon_sym_centroid] = ACTIONS(3084),
    [anon_sym_noperspective] = ACTIONS(3084),
    [anon_sym_nointerpolation] = ACTIONS(3084),
    [anon_sym_sample] = ACTIONS(3084),
    [anon_sym_linear] = ACTIONS(3084),
    [anon_sym_snorm] = ACTIONS(3084),
    [anon_sym_unorm] = ACTIONS(3084),
    [anon_sym_point] = ACTIONS(3084),
    [anon_sym_line] = ACTIONS(3084),
    [anon_sym_triangleadj] = ACTIONS(3084),
    [anon_sym_lineadj] = ACTIONS(3084),
    [anon_sym_triangle] = ACTIONS(3084),
    [anon_sym_cbuffer] = ACTIONS(3084),
    [anon_sym_interface] = ACTIONS(3084),
    [anon_sym_extension] = ACTIONS(3084),
  },
  [696] = {
    [sym_identifier] = ACTIONS(3344),
    [aux_sym_preproc_include_token1] = ACTIONS(3344),
    [aux_sym_preproc_def_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3344),
    [sym_preproc_directive] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym___extension__] = ACTIONS(3344),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_in] = ACTIONS(3344),
    [anon_sym_out] = ACTIONS(3344),
    [anon_sym_inout] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym___attribute__] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3346),
    [anon_sym___declspec] = ACTIONS(3344),
    [anon_sym___based] = ACTIONS(3344),
    [anon_sym___cdecl] = ACTIONS(3344),
    [anon_sym___clrcall] = ACTIONS(3344),
    [anon_sym___stdcall] = ACTIONS(3344),
    [anon_sym___fastcall] = ACTIONS(3344),
    [anon_sym___thiscall] = ACTIONS(3344),
    [anon_sym___vectorcall] = ACTIONS(3344),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_RBRACE] = ACTIONS(3346),
    [anon_sym_signed] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym___inline] = ACTIONS(3344),
    [anon_sym___inline__] = ACTIONS(3344),
    [anon_sym___forceinline] = ACTIONS(3344),
    [anon_sym_thread_local] = ACTIONS(3344),
    [anon_sym___thread] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym___restrict__] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym__Noreturn] = ACTIONS(3344),
    [anon_sym_noreturn] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_constinit] = ACTIONS(3344),
    [anon_sym_consteval] = ACTIONS(3344),
    [anon_sym_alignas] = ACTIONS(3344),
    [anon_sym__Alignas] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_class] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_switch] = ACTIONS(3344),
    [anon_sym_case] = ACTIONS(3344),
    [anon_sym_default] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_break] = ACTIONS(3344),
    [anon_sym_continue] = ACTIONS(3344),
    [anon_sym_goto] = ACTIONS(3344),
    [anon_sym___try] = ACTIONS(3344),
    [anon_sym___leave] = ACTIONS(3344),
    [anon_sym_not] = ACTIONS(3344),
    [anon_sym_compl] = ACTIONS(3344),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_sizeof] = ACTIONS(3344),
    [anon_sym___alignof__] = ACTIONS(3344),
    [anon_sym___alignof] = ACTIONS(3344),
    [anon_sym__alignof] = ACTIONS(3344),
    [anon_sym_alignof] = ACTIONS(3344),
    [anon_sym__Alignof] = ACTIONS(3344),
    [anon_sym_offsetof] = ACTIONS(3344),
    [anon_sym__Generic] = ACTIONS(3344),
    [anon_sym_asm] = ACTIONS(3344),
    [anon_sym___asm__] = ACTIONS(3344),
    [sym_number_literal] = ACTIONS(3346),
    [anon_sym_L_SQUOTE] = ACTIONS(3346),
    [anon_sym_u_SQUOTE] = ACTIONS(3346),
    [anon_sym_U_SQUOTE] = ACTIONS(3346),
    [anon_sym_u8_SQUOTE] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_L_DQUOTE] = ACTIONS(3346),
    [anon_sym_u_DQUOTE] = ACTIONS(3346),
    [anon_sym_U_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8_DQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [sym_true] = ACTIONS(3344),
    [sym_false] = ACTIONS(3344),
    [anon_sym_NULL] = ACTIONS(3344),
    [anon_sym_nullptr] = ACTIONS(3344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_This] = ACTIONS(3344),
    [anon_sym_decltype] = ACTIONS(3344),
    [sym_virtual] = ACTIONS(3344),
    [anon_sym_explicit] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_template] = ACTIONS(3344),
    [anon_sym_operator] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_delete] = ACTIONS(3344),
    [anon_sym_throw] = ACTIONS(3344),
    [anon_sym_namespace] = ACTIONS(3344),
    [anon_sym_using] = ACTIONS(3344),
    [anon_sym_static_assert] = ACTIONS(3344),
    [anon_sym_concept] = ACTIONS(3344),
    [anon_sym_co_return] = ACTIONS(3344),
    [anon_sym_co_yield] = ACTIONS(3344),
    [anon_sym_R_DQUOTE] = ACTIONS(3346),
    [anon_sym_LR_DQUOTE] = ACTIONS(3346),
    [anon_sym_uR_DQUOTE] = ACTIONS(3346),
    [anon_sym_UR_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3346),
    [anon_sym_co_await] = ACTIONS(3344),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_requires] = ACTIONS(3344),
    [sym_this] = ACTIONS(3344),
    [anon_sym_discard] = ACTIONS(3344),
    [anon_sym_precise] = ACTIONS(3344),
    [anon_sym_shared] = ACTIONS(3344),
    [anon_sym_groupshared] = ACTIONS(3344),
    [anon_sym_uniform] = ACTIONS(3344),
    [anon_sym_row_major] = ACTIONS(3344),
    [anon_sym_column_major] = ACTIONS(3344),
    [anon_sym_globallycoherent] = ACTIONS(3344),
    [anon_sym_centroid] = ACTIONS(3344),
    [anon_sym_noperspective] = ACTIONS(3344),
    [anon_sym_nointerpolation] = ACTIONS(3344),
    [anon_sym_sample] = ACTIONS(3344),
    [anon_sym_linear] = ACTIONS(3344),
    [anon_sym_snorm] = ACTIONS(3344),
    [anon_sym_unorm] = ACTIONS(3344),
    [anon_sym_point] = ACTIONS(3344),
    [anon_sym_line] = ACTIONS(3344),
    [anon_sym_triangleadj] = ACTIONS(3344),
    [anon_sym_lineadj] = ACTIONS(3344),
    [anon_sym_triangle] = ACTIONS(3344),
    [anon_sym_cbuffer] = ACTIONS(3344),
    [anon_sym_interface] = ACTIONS(3344),
    [anon_sym_extension] = ACTIONS(3344),
  },
  [697] = {
    [sym_identifier] = ACTIONS(3192),
    [aux_sym_preproc_include_token1] = ACTIONS(3192),
    [aux_sym_preproc_def_token1] = ACTIONS(3192),
    [aux_sym_preproc_if_token1] = ACTIONS(3192),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3192),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3192),
    [sym_preproc_directive] = ACTIONS(3192),
    [anon_sym_LPAREN2] = ACTIONS(3190),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3192),
    [anon_sym_PLUS] = ACTIONS(3192),
    [anon_sym_STAR] = ACTIONS(3190),
    [anon_sym_AMP_AMP] = ACTIONS(3190),
    [anon_sym_AMP] = ACTIONS(3192),
    [anon_sym_SEMI] = ACTIONS(3190),
    [anon_sym___extension__] = ACTIONS(3192),
    [anon_sym_typedef] = ACTIONS(3192),
    [anon_sym_in] = ACTIONS(3192),
    [anon_sym_out] = ACTIONS(3192),
    [anon_sym_inout] = ACTIONS(3192),
    [anon_sym_extern] = ACTIONS(3192),
    [anon_sym___attribute__] = ACTIONS(3192),
    [anon_sym_COLON_COLON] = ACTIONS(3190),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3190),
    [anon_sym___declspec] = ACTIONS(3192),
    [anon_sym___based] = ACTIONS(3192),
    [anon_sym___cdecl] = ACTIONS(3192),
    [anon_sym___clrcall] = ACTIONS(3192),
    [anon_sym___stdcall] = ACTIONS(3192),
    [anon_sym___fastcall] = ACTIONS(3192),
    [anon_sym___thiscall] = ACTIONS(3192),
    [anon_sym___vectorcall] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(3190),
    [anon_sym_RBRACE] = ACTIONS(3190),
    [anon_sym_signed] = ACTIONS(3192),
    [anon_sym_unsigned] = ACTIONS(3192),
    [anon_sym_long] = ACTIONS(3192),
    [anon_sym_short] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(3192),
    [anon_sym_static] = ACTIONS(3192),
    [anon_sym_register] = ACTIONS(3192),
    [anon_sym_inline] = ACTIONS(3192),
    [anon_sym___inline] = ACTIONS(3192),
    [anon_sym___inline__] = ACTIONS(3192),
    [anon_sym___forceinline] = ACTIONS(3192),
    [anon_sym_thread_local] = ACTIONS(3192),
    [anon_sym___thread] = ACTIONS(3192),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_constexpr] = ACTIONS(3192),
    [anon_sym_volatile] = ACTIONS(3192),
    [anon_sym_restrict] = ACTIONS(3192),
    [anon_sym___restrict__] = ACTIONS(3192),
    [anon_sym__Atomic] = ACTIONS(3192),
    [anon_sym__Noreturn] = ACTIONS(3192),
    [anon_sym_noreturn] = ACTIONS(3192),
    [anon_sym_mutable] = ACTIONS(3192),
    [anon_sym_constinit] = ACTIONS(3192),
    [anon_sym_consteval] = ACTIONS(3192),
    [anon_sym_alignas] = ACTIONS(3192),
    [anon_sym__Alignas] = ACTIONS(3192),
    [sym_primitive_type] = ACTIONS(3192),
    [anon_sym_enum] = ACTIONS(3192),
    [anon_sym_class] = ACTIONS(3192),
    [anon_sym_struct] = ACTIONS(3192),
    [anon_sym_union] = ACTIONS(3192),
    [anon_sym_if] = ACTIONS(3192),
    [anon_sym_switch] = ACTIONS(3192),
    [anon_sym_case] = ACTIONS(3192),
    [anon_sym_default] = ACTIONS(3192),
    [anon_sym_while] = ACTIONS(3192),
    [anon_sym_do] = ACTIONS(3192),
    [anon_sym_for] = ACTIONS(3192),
    [anon_sym_return] = ACTIONS(3192),
    [anon_sym_break] = ACTIONS(3192),
    [anon_sym_continue] = ACTIONS(3192),
    [anon_sym_goto] = ACTIONS(3192),
    [anon_sym___try] = ACTIONS(3192),
    [anon_sym___leave] = ACTIONS(3192),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_compl] = ACTIONS(3192),
    [anon_sym_DASH_DASH] = ACTIONS(3190),
    [anon_sym_PLUS_PLUS] = ACTIONS(3190),
    [anon_sym_sizeof] = ACTIONS(3192),
    [anon_sym___alignof__] = ACTIONS(3192),
    [anon_sym___alignof] = ACTIONS(3192),
    [anon_sym__alignof] = ACTIONS(3192),
    [anon_sym_alignof] = ACTIONS(3192),
    [anon_sym__Alignof] = ACTIONS(3192),
    [anon_sym_offsetof] = ACTIONS(3192),
    [anon_sym__Generic] = ACTIONS(3192),
    [anon_sym_asm] = ACTIONS(3192),
    [anon_sym___asm__] = ACTIONS(3192),
    [anon_sym_DOT] = ACTIONS(3192),
    [sym_number_literal] = ACTIONS(3190),
    [anon_sym_L_SQUOTE] = ACTIONS(3190),
    [anon_sym_u_SQUOTE] = ACTIONS(3190),
    [anon_sym_U_SQUOTE] = ACTIONS(3190),
    [anon_sym_u8_SQUOTE] = ACTIONS(3190),
    [anon_sym_SQUOTE] = ACTIONS(3190),
    [anon_sym_L_DQUOTE] = ACTIONS(3190),
    [anon_sym_u_DQUOTE] = ACTIONS(3190),
    [anon_sym_U_DQUOTE] = ACTIONS(3190),
    [anon_sym_u8_DQUOTE] = ACTIONS(3190),
    [anon_sym_DQUOTE] = ACTIONS(3190),
    [sym_true] = ACTIONS(3192),
    [sym_false] = ACTIONS(3192),
    [anon_sym_NULL] = ACTIONS(3192),
    [anon_sym_nullptr] = ACTIONS(3192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3192),
    [anon_sym_let] = ACTIONS(3192),
    [anon_sym_This] = ACTIONS(3192),
    [anon_sym_decltype] = ACTIONS(3192),
    [sym_virtual] = ACTIONS(3192),
    [anon_sym_explicit] = ACTIONS(3192),
    [anon_sym_typename] = ACTIONS(3192),
    [anon_sym_template] = ACTIONS(3192),
    [anon_sym_operator] = ACTIONS(3192),
    [anon_sym_try] = ACTIONS(3192),
    [anon_sym_delete] = ACTIONS(3192),
    [anon_sym_throw] = ACTIONS(3192),
    [anon_sym_namespace] = ACTIONS(3192),
    [anon_sym_using] = ACTIONS(3192),
    [anon_sym_static_assert] = ACTIONS(3192),
    [anon_sym_concept] = ACTIONS(3192),
    [anon_sym_co_return] = ACTIONS(3192),
    [anon_sym_co_yield] = ACTIONS(3192),
    [anon_sym_R_DQUOTE] = ACTIONS(3190),
    [anon_sym_LR_DQUOTE] = ACTIONS(3190),
    [anon_sym_uR_DQUOTE] = ACTIONS(3190),
    [anon_sym_UR_DQUOTE] = ACTIONS(3190),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3190),
    [anon_sym_co_await] = ACTIONS(3192),
    [anon_sym_new] = ACTIONS(3192),
    [anon_sym_requires] = ACTIONS(3192),
    [sym_this] = ACTIONS(3192),
    [anon_sym_discard] = ACTIONS(3192),
    [anon_sym_precise] = ACTIONS(3192),
    [anon_sym_shared] = ACTIONS(3192),
    [anon_sym_groupshared] = ACTIONS(3192),
    [anon_sym_uniform] = ACTIONS(3192),
    [anon_sym_row_major] = ACTIONS(3192),
    [anon_sym_column_major] = ACTIONS(3192),
    [anon_sym_globallycoherent] = ACTIONS(3192),
    [anon_sym_centroid] = ACTIONS(3192),
    [anon_sym_noperspective] = ACTIONS(3192),
    [anon_sym_nointerpolation] = ACTIONS(3192),
    [anon_sym_sample] = ACTIONS(3192),
    [anon_sym_linear] = ACTIONS(3192),
    [anon_sym_snorm] = ACTIONS(3192),
    [anon_sym_unorm] = ACTIONS(3192),
    [anon_sym_point] = ACTIONS(3192),
    [anon_sym_line] = ACTIONS(3192),
    [anon_sym_triangleadj] = ACTIONS(3192),
    [anon_sym_lineadj] = ACTIONS(3192),
    [anon_sym_triangle] = ACTIONS(3192),
    [anon_sym_cbuffer] = ACTIONS(3192),
    [anon_sym_interface] = ACTIONS(3192),
    [anon_sym_extension] = ACTIONS(3192),
  },
  [698] = {
    [sym_identifier] = ACTIONS(3092),
    [aux_sym_preproc_include_token1] = ACTIONS(3092),
    [aux_sym_preproc_def_token1] = ACTIONS(3092),
    [aux_sym_preproc_if_token1] = ACTIONS(3092),
    [aux_sym_preproc_if_token2] = ACTIONS(3092),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3092),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3092),
    [sym_preproc_directive] = ACTIONS(3092),
    [anon_sym_LPAREN2] = ACTIONS(3094),
    [anon_sym_BANG] = ACTIONS(3094),
    [anon_sym_TILDE] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_STAR] = ACTIONS(3094),
    [anon_sym_AMP_AMP] = ACTIONS(3094),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_SEMI] = ACTIONS(3094),
    [anon_sym___extension__] = ACTIONS(3092),
    [anon_sym_typedef] = ACTIONS(3092),
    [anon_sym_in] = ACTIONS(3092),
    [anon_sym_out] = ACTIONS(3092),
    [anon_sym_inout] = ACTIONS(3092),
    [anon_sym_extern] = ACTIONS(3092),
    [anon_sym___attribute__] = ACTIONS(3092),
    [anon_sym_COLON_COLON] = ACTIONS(3094),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3094),
    [anon_sym___declspec] = ACTIONS(3092),
    [anon_sym___based] = ACTIONS(3092),
    [anon_sym___cdecl] = ACTIONS(3092),
    [anon_sym___clrcall] = ACTIONS(3092),
    [anon_sym___stdcall] = ACTIONS(3092),
    [anon_sym___fastcall] = ACTIONS(3092),
    [anon_sym___thiscall] = ACTIONS(3092),
    [anon_sym___vectorcall] = ACTIONS(3092),
    [anon_sym_LBRACE] = ACTIONS(3094),
    [anon_sym_signed] = ACTIONS(3092),
    [anon_sym_unsigned] = ACTIONS(3092),
    [anon_sym_long] = ACTIONS(3092),
    [anon_sym_short] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_static] = ACTIONS(3092),
    [anon_sym_register] = ACTIONS(3092),
    [anon_sym_inline] = ACTIONS(3092),
    [anon_sym___inline] = ACTIONS(3092),
    [anon_sym___inline__] = ACTIONS(3092),
    [anon_sym___forceinline] = ACTIONS(3092),
    [anon_sym_thread_local] = ACTIONS(3092),
    [anon_sym___thread] = ACTIONS(3092),
    [anon_sym_const] = ACTIONS(3092),
    [anon_sym_constexpr] = ACTIONS(3092),
    [anon_sym_volatile] = ACTIONS(3092),
    [anon_sym_restrict] = ACTIONS(3092),
    [anon_sym___restrict__] = ACTIONS(3092),
    [anon_sym__Atomic] = ACTIONS(3092),
    [anon_sym__Noreturn] = ACTIONS(3092),
    [anon_sym_noreturn] = ACTIONS(3092),
    [anon_sym_mutable] = ACTIONS(3092),
    [anon_sym_constinit] = ACTIONS(3092),
    [anon_sym_consteval] = ACTIONS(3092),
    [anon_sym_alignas] = ACTIONS(3092),
    [anon_sym__Alignas] = ACTIONS(3092),
    [sym_primitive_type] = ACTIONS(3092),
    [anon_sym_enum] = ACTIONS(3092),
    [anon_sym_class] = ACTIONS(3092),
    [anon_sym_struct] = ACTIONS(3092),
    [anon_sym_union] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_else] = ACTIONS(3092),
    [anon_sym_switch] = ACTIONS(3092),
    [anon_sym_case] = ACTIONS(3092),
    [anon_sym_default] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_break] = ACTIONS(3092),
    [anon_sym_continue] = ACTIONS(3092),
    [anon_sym_goto] = ACTIONS(3092),
    [anon_sym___try] = ACTIONS(3092),
    [anon_sym___leave] = ACTIONS(3092),
    [anon_sym_not] = ACTIONS(3092),
    [anon_sym_compl] = ACTIONS(3092),
    [anon_sym_DASH_DASH] = ACTIONS(3094),
    [anon_sym_PLUS_PLUS] = ACTIONS(3094),
    [anon_sym_sizeof] = ACTIONS(3092),
    [anon_sym___alignof__] = ACTIONS(3092),
    [anon_sym___alignof] = ACTIONS(3092),
    [anon_sym__alignof] = ACTIONS(3092),
    [anon_sym_alignof] = ACTIONS(3092),
    [anon_sym__Alignof] = ACTIONS(3092),
    [anon_sym_offsetof] = ACTIONS(3092),
    [anon_sym__Generic] = ACTIONS(3092),
    [anon_sym_asm] = ACTIONS(3092),
    [anon_sym___asm__] = ACTIONS(3092),
    [sym_number_literal] = ACTIONS(3094),
    [anon_sym_L_SQUOTE] = ACTIONS(3094),
    [anon_sym_u_SQUOTE] = ACTIONS(3094),
    [anon_sym_U_SQUOTE] = ACTIONS(3094),
    [anon_sym_u8_SQUOTE] = ACTIONS(3094),
    [anon_sym_SQUOTE] = ACTIONS(3094),
    [anon_sym_L_DQUOTE] = ACTIONS(3094),
    [anon_sym_u_DQUOTE] = ACTIONS(3094),
    [anon_sym_U_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8_DQUOTE] = ACTIONS(3094),
    [anon_sym_DQUOTE] = ACTIONS(3094),
    [sym_true] = ACTIONS(3092),
    [sym_false] = ACTIONS(3092),
    [anon_sym_NULL] = ACTIONS(3092),
    [anon_sym_nullptr] = ACTIONS(3092),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3092),
    [anon_sym_let] = ACTIONS(3092),
    [anon_sym_This] = ACTIONS(3092),
    [anon_sym_decltype] = ACTIONS(3092),
    [sym_virtual] = ACTIONS(3092),
    [anon_sym_explicit] = ACTIONS(3092),
    [anon_sym_typename] = ACTIONS(3092),
    [anon_sym_template] = ACTIONS(3092),
    [anon_sym_operator] = ACTIONS(3092),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_delete] = ACTIONS(3092),
    [anon_sym_throw] = ACTIONS(3092),
    [anon_sym_namespace] = ACTIONS(3092),
    [anon_sym_using] = ACTIONS(3092),
    [anon_sym_static_assert] = ACTIONS(3092),
    [anon_sym_concept] = ACTIONS(3092),
    [anon_sym_co_return] = ACTIONS(3092),
    [anon_sym_co_yield] = ACTIONS(3092),
    [anon_sym_R_DQUOTE] = ACTIONS(3094),
    [anon_sym_LR_DQUOTE] = ACTIONS(3094),
    [anon_sym_uR_DQUOTE] = ACTIONS(3094),
    [anon_sym_UR_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3094),
    [anon_sym_co_await] = ACTIONS(3092),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_requires] = ACTIONS(3092),
    [sym_this] = ACTIONS(3092),
    [anon_sym_discard] = ACTIONS(3092),
    [anon_sym_precise] = ACTIONS(3092),
    [anon_sym_shared] = ACTIONS(3092),
    [anon_sym_groupshared] = ACTIONS(3092),
    [anon_sym_uniform] = ACTIONS(3092),
    [anon_sym_row_major] = ACTIONS(3092),
    [anon_sym_column_major] = ACTIONS(3092),
    [anon_sym_globallycoherent] = ACTIONS(3092),
    [anon_sym_centroid] = ACTIONS(3092),
    [anon_sym_noperspective] = ACTIONS(3092),
    [anon_sym_nointerpolation] = ACTIONS(3092),
    [anon_sym_sample] = ACTIONS(3092),
    [anon_sym_linear] = ACTIONS(3092),
    [anon_sym_snorm] = ACTIONS(3092),
    [anon_sym_unorm] = ACTIONS(3092),
    [anon_sym_point] = ACTIONS(3092),
    [anon_sym_line] = ACTIONS(3092),
    [anon_sym_triangleadj] = ACTIONS(3092),
    [anon_sym_lineadj] = ACTIONS(3092),
    [anon_sym_triangle] = ACTIONS(3092),
    [anon_sym_cbuffer] = ACTIONS(3092),
    [anon_sym_interface] = ACTIONS(3092),
    [anon_sym_extension] = ACTIONS(3092),
  },
  [699] = {
    [sym_identifier] = ACTIONS(3378),
    [aux_sym_preproc_include_token1] = ACTIONS(3378),
    [aux_sym_preproc_def_token1] = ACTIONS(3378),
    [aux_sym_preproc_if_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3378),
    [sym_preproc_directive] = ACTIONS(3378),
    [anon_sym_LPAREN2] = ACTIONS(3380),
    [anon_sym_BANG] = ACTIONS(3380),
    [anon_sym_TILDE] = ACTIONS(3380),
    [anon_sym_DASH] = ACTIONS(3378),
    [anon_sym_PLUS] = ACTIONS(3378),
    [anon_sym_STAR] = ACTIONS(3380),
    [anon_sym_AMP_AMP] = ACTIONS(3380),
    [anon_sym_AMP] = ACTIONS(3378),
    [anon_sym_SEMI] = ACTIONS(3380),
    [anon_sym___extension__] = ACTIONS(3378),
    [anon_sym_typedef] = ACTIONS(3378),
    [anon_sym_in] = ACTIONS(3378),
    [anon_sym_out] = ACTIONS(3378),
    [anon_sym_inout] = ACTIONS(3378),
    [anon_sym_extern] = ACTIONS(3378),
    [anon_sym___attribute__] = ACTIONS(3378),
    [anon_sym_COLON_COLON] = ACTIONS(3380),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3380),
    [anon_sym___declspec] = ACTIONS(3378),
    [anon_sym___based] = ACTIONS(3378),
    [anon_sym___cdecl] = ACTIONS(3378),
    [anon_sym___clrcall] = ACTIONS(3378),
    [anon_sym___stdcall] = ACTIONS(3378),
    [anon_sym___fastcall] = ACTIONS(3378),
    [anon_sym___thiscall] = ACTIONS(3378),
    [anon_sym___vectorcall] = ACTIONS(3378),
    [anon_sym_LBRACE] = ACTIONS(3380),
    [anon_sym_RBRACE] = ACTIONS(3380),
    [anon_sym_signed] = ACTIONS(3378),
    [anon_sym_unsigned] = ACTIONS(3378),
    [anon_sym_long] = ACTIONS(3378),
    [anon_sym_short] = ACTIONS(3378),
    [anon_sym_LBRACK] = ACTIONS(3378),
    [anon_sym_static] = ACTIONS(3378),
    [anon_sym_register] = ACTIONS(3378),
    [anon_sym_inline] = ACTIONS(3378),
    [anon_sym___inline] = ACTIONS(3378),
    [anon_sym___inline__] = ACTIONS(3378),
    [anon_sym___forceinline] = ACTIONS(3378),
    [anon_sym_thread_local] = ACTIONS(3378),
    [anon_sym___thread] = ACTIONS(3378),
    [anon_sym_const] = ACTIONS(3378),
    [anon_sym_constexpr] = ACTIONS(3378),
    [anon_sym_volatile] = ACTIONS(3378),
    [anon_sym_restrict] = ACTIONS(3378),
    [anon_sym___restrict__] = ACTIONS(3378),
    [anon_sym__Atomic] = ACTIONS(3378),
    [anon_sym__Noreturn] = ACTIONS(3378),
    [anon_sym_noreturn] = ACTIONS(3378),
    [anon_sym_mutable] = ACTIONS(3378),
    [anon_sym_constinit] = ACTIONS(3378),
    [anon_sym_consteval] = ACTIONS(3378),
    [anon_sym_alignas] = ACTIONS(3378),
    [anon_sym__Alignas] = ACTIONS(3378),
    [sym_primitive_type] = ACTIONS(3378),
    [anon_sym_enum] = ACTIONS(3378),
    [anon_sym_class] = ACTIONS(3378),
    [anon_sym_struct] = ACTIONS(3378),
    [anon_sym_union] = ACTIONS(3378),
    [anon_sym_if] = ACTIONS(3378),
    [anon_sym_else] = ACTIONS(3378),
    [anon_sym_switch] = ACTIONS(3378),
    [anon_sym_case] = ACTIONS(3378),
    [anon_sym_default] = ACTIONS(3378),
    [anon_sym_while] = ACTIONS(3378),
    [anon_sym_do] = ACTIONS(3378),
    [anon_sym_for] = ACTIONS(3378),
    [anon_sym_return] = ACTIONS(3378),
    [anon_sym_break] = ACTIONS(3378),
    [anon_sym_continue] = ACTIONS(3378),
    [anon_sym_goto] = ACTIONS(3378),
    [anon_sym___try] = ACTIONS(3378),
    [anon_sym___leave] = ACTIONS(3378),
    [anon_sym_not] = ACTIONS(3378),
    [anon_sym_compl] = ACTIONS(3378),
    [anon_sym_DASH_DASH] = ACTIONS(3380),
    [anon_sym_PLUS_PLUS] = ACTIONS(3380),
    [anon_sym_sizeof] = ACTIONS(3378),
    [anon_sym___alignof__] = ACTIONS(3378),
    [anon_sym___alignof] = ACTIONS(3378),
    [anon_sym__alignof] = ACTIONS(3378),
    [anon_sym_alignof] = ACTIONS(3378),
    [anon_sym__Alignof] = ACTIONS(3378),
    [anon_sym_offsetof] = ACTIONS(3378),
    [anon_sym__Generic] = ACTIONS(3378),
    [anon_sym_asm] = ACTIONS(3378),
    [anon_sym___asm__] = ACTIONS(3378),
    [sym_number_literal] = ACTIONS(3380),
    [anon_sym_L_SQUOTE] = ACTIONS(3380),
    [anon_sym_u_SQUOTE] = ACTIONS(3380),
    [anon_sym_U_SQUOTE] = ACTIONS(3380),
    [anon_sym_u8_SQUOTE] = ACTIONS(3380),
    [anon_sym_SQUOTE] = ACTIONS(3380),
    [anon_sym_L_DQUOTE] = ACTIONS(3380),
    [anon_sym_u_DQUOTE] = ACTIONS(3380),
    [anon_sym_U_DQUOTE] = ACTIONS(3380),
    [anon_sym_u8_DQUOTE] = ACTIONS(3380),
    [anon_sym_DQUOTE] = ACTIONS(3380),
    [sym_true] = ACTIONS(3378),
    [sym_false] = ACTIONS(3378),
    [anon_sym_NULL] = ACTIONS(3378),
    [anon_sym_nullptr] = ACTIONS(3378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3378),
    [anon_sym_let] = ACTIONS(3378),
    [anon_sym_This] = ACTIONS(3378),
    [anon_sym_decltype] = ACTIONS(3378),
    [sym_virtual] = ACTIONS(3378),
    [anon_sym_explicit] = ACTIONS(3378),
    [anon_sym_typename] = ACTIONS(3378),
    [anon_sym_template] = ACTIONS(3378),
    [anon_sym_operator] = ACTIONS(3378),
    [anon_sym_try] = ACTIONS(3378),
    [anon_sym_delete] = ACTIONS(3378),
    [anon_sym_throw] = ACTIONS(3378),
    [anon_sym_namespace] = ACTIONS(3378),
    [anon_sym_using] = ACTIONS(3378),
    [anon_sym_static_assert] = ACTIONS(3378),
    [anon_sym_concept] = ACTIONS(3378),
    [anon_sym_co_return] = ACTIONS(3378),
    [anon_sym_co_yield] = ACTIONS(3378),
    [anon_sym_R_DQUOTE] = ACTIONS(3380),
    [anon_sym_LR_DQUOTE] = ACTIONS(3380),
    [anon_sym_uR_DQUOTE] = ACTIONS(3380),
    [anon_sym_UR_DQUOTE] = ACTIONS(3380),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3380),
    [anon_sym_co_await] = ACTIONS(3378),
    [anon_sym_new] = ACTIONS(3378),
    [anon_sym_requires] = ACTIONS(3378),
    [sym_this] = ACTIONS(3378),
    [anon_sym_discard] = ACTIONS(3378),
    [anon_sym_precise] = ACTIONS(3378),
    [anon_sym_shared] = ACTIONS(3378),
    [anon_sym_groupshared] = ACTIONS(3378),
    [anon_sym_uniform] = ACTIONS(3378),
    [anon_sym_row_major] = ACTIONS(3378),
    [anon_sym_column_major] = ACTIONS(3378),
    [anon_sym_globallycoherent] = ACTIONS(3378),
    [anon_sym_centroid] = ACTIONS(3378),
    [anon_sym_noperspective] = ACTIONS(3378),
    [anon_sym_nointerpolation] = ACTIONS(3378),
    [anon_sym_sample] = ACTIONS(3378),
    [anon_sym_linear] = ACTIONS(3378),
    [anon_sym_snorm] = ACTIONS(3378),
    [anon_sym_unorm] = ACTIONS(3378),
    [anon_sym_point] = ACTIONS(3378),
    [anon_sym_line] = ACTIONS(3378),
    [anon_sym_triangleadj] = ACTIONS(3378),
    [anon_sym_lineadj] = ACTIONS(3378),
    [anon_sym_triangle] = ACTIONS(3378),
    [anon_sym_cbuffer] = ACTIONS(3378),
    [anon_sym_interface] = ACTIONS(3378),
    [anon_sym_extension] = ACTIONS(3378),
  },
  [700] = {
    [sym_identifier] = ACTIONS(3176),
    [aux_sym_preproc_include_token1] = ACTIONS(3176),
    [aux_sym_preproc_def_token1] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(3176),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3176),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3176),
    [sym_preproc_directive] = ACTIONS(3176),
    [anon_sym_LPAREN2] = ACTIONS(3174),
    [anon_sym_BANG] = ACTIONS(3174),
    [anon_sym_TILDE] = ACTIONS(3174),
    [anon_sym_DASH] = ACTIONS(3176),
    [anon_sym_PLUS] = ACTIONS(3176),
    [anon_sym_STAR] = ACTIONS(3174),
    [anon_sym_AMP_AMP] = ACTIONS(3174),
    [anon_sym_AMP] = ACTIONS(3176),
    [anon_sym_SEMI] = ACTIONS(3174),
    [anon_sym___extension__] = ACTIONS(3176),
    [anon_sym_typedef] = ACTIONS(3176),
    [anon_sym_in] = ACTIONS(3176),
    [anon_sym_out] = ACTIONS(3176),
    [anon_sym_inout] = ACTIONS(3176),
    [anon_sym_extern] = ACTIONS(3176),
    [anon_sym___attribute__] = ACTIONS(3176),
    [anon_sym_COLON_COLON] = ACTIONS(3174),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3174),
    [anon_sym___declspec] = ACTIONS(3176),
    [anon_sym___based] = ACTIONS(3176),
    [anon_sym___cdecl] = ACTIONS(3176),
    [anon_sym___clrcall] = ACTIONS(3176),
    [anon_sym___stdcall] = ACTIONS(3176),
    [anon_sym___fastcall] = ACTIONS(3176),
    [anon_sym___thiscall] = ACTIONS(3176),
    [anon_sym___vectorcall] = ACTIONS(3176),
    [anon_sym_LBRACE] = ACTIONS(3174),
    [anon_sym_RBRACE] = ACTIONS(3174),
    [anon_sym_signed] = ACTIONS(3176),
    [anon_sym_unsigned] = ACTIONS(3176),
    [anon_sym_long] = ACTIONS(3176),
    [anon_sym_short] = ACTIONS(3176),
    [anon_sym_LBRACK] = ACTIONS(3176),
    [anon_sym_static] = ACTIONS(3176),
    [anon_sym_register] = ACTIONS(3176),
    [anon_sym_inline] = ACTIONS(3176),
    [anon_sym___inline] = ACTIONS(3176),
    [anon_sym___inline__] = ACTIONS(3176),
    [anon_sym___forceinline] = ACTIONS(3176),
    [anon_sym_thread_local] = ACTIONS(3176),
    [anon_sym___thread] = ACTIONS(3176),
    [anon_sym_const] = ACTIONS(3176),
    [anon_sym_constexpr] = ACTIONS(3176),
    [anon_sym_volatile] = ACTIONS(3176),
    [anon_sym_restrict] = ACTIONS(3176),
    [anon_sym___restrict__] = ACTIONS(3176),
    [anon_sym__Atomic] = ACTIONS(3176),
    [anon_sym__Noreturn] = ACTIONS(3176),
    [anon_sym_noreturn] = ACTIONS(3176),
    [anon_sym_mutable] = ACTIONS(3176),
    [anon_sym_constinit] = ACTIONS(3176),
    [anon_sym_consteval] = ACTIONS(3176),
    [anon_sym_alignas] = ACTIONS(3176),
    [anon_sym__Alignas] = ACTIONS(3176),
    [sym_primitive_type] = ACTIONS(3176),
    [anon_sym_enum] = ACTIONS(3176),
    [anon_sym_class] = ACTIONS(3176),
    [anon_sym_struct] = ACTIONS(3176),
    [anon_sym_union] = ACTIONS(3176),
    [anon_sym_if] = ACTIONS(3176),
    [anon_sym_switch] = ACTIONS(3176),
    [anon_sym_case] = ACTIONS(3176),
    [anon_sym_default] = ACTIONS(3176),
    [anon_sym_while] = ACTIONS(3176),
    [anon_sym_do] = ACTIONS(3176),
    [anon_sym_for] = ACTIONS(3176),
    [anon_sym_return] = ACTIONS(3176),
    [anon_sym_break] = ACTIONS(3176),
    [anon_sym_continue] = ACTIONS(3176),
    [anon_sym_goto] = ACTIONS(3176),
    [anon_sym___try] = ACTIONS(3176),
    [anon_sym___leave] = ACTIONS(3176),
    [anon_sym_not] = ACTIONS(3176),
    [anon_sym_compl] = ACTIONS(3176),
    [anon_sym_DASH_DASH] = ACTIONS(3174),
    [anon_sym_PLUS_PLUS] = ACTIONS(3174),
    [anon_sym_sizeof] = ACTIONS(3176),
    [anon_sym___alignof__] = ACTIONS(3176),
    [anon_sym___alignof] = ACTIONS(3176),
    [anon_sym__alignof] = ACTIONS(3176),
    [anon_sym_alignof] = ACTIONS(3176),
    [anon_sym__Alignof] = ACTIONS(3176),
    [anon_sym_offsetof] = ACTIONS(3176),
    [anon_sym__Generic] = ACTIONS(3176),
    [anon_sym_asm] = ACTIONS(3176),
    [anon_sym___asm__] = ACTIONS(3176),
    [anon_sym_DOT] = ACTIONS(3176),
    [sym_number_literal] = ACTIONS(3174),
    [anon_sym_L_SQUOTE] = ACTIONS(3174),
    [anon_sym_u_SQUOTE] = ACTIONS(3174),
    [anon_sym_U_SQUOTE] = ACTIONS(3174),
    [anon_sym_u8_SQUOTE] = ACTIONS(3174),
    [anon_sym_SQUOTE] = ACTIONS(3174),
    [anon_sym_L_DQUOTE] = ACTIONS(3174),
    [anon_sym_u_DQUOTE] = ACTIONS(3174),
    [anon_sym_U_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8_DQUOTE] = ACTIONS(3174),
    [anon_sym_DQUOTE] = ACTIONS(3174),
    [sym_true] = ACTIONS(3176),
    [sym_false] = ACTIONS(3176),
    [anon_sym_NULL] = ACTIONS(3176),
    [anon_sym_nullptr] = ACTIONS(3176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3176),
    [anon_sym_let] = ACTIONS(3176),
    [anon_sym_This] = ACTIONS(3176),
    [anon_sym_decltype] = ACTIONS(3176),
    [sym_virtual] = ACTIONS(3176),
    [anon_sym_explicit] = ACTIONS(3176),
    [anon_sym_typename] = ACTIONS(3176),
    [anon_sym_template] = ACTIONS(3176),
    [anon_sym_operator] = ACTIONS(3176),
    [anon_sym_try] = ACTIONS(3176),
    [anon_sym_delete] = ACTIONS(3176),
    [anon_sym_throw] = ACTIONS(3176),
    [anon_sym_namespace] = ACTIONS(3176),
    [anon_sym_using] = ACTIONS(3176),
    [anon_sym_static_assert] = ACTIONS(3176),
    [anon_sym_concept] = ACTIONS(3176),
    [anon_sym_co_return] = ACTIONS(3176),
    [anon_sym_co_yield] = ACTIONS(3176),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3176),
    [anon_sym_requires] = ACTIONS(3176),
    [sym_this] = ACTIONS(3176),
    [anon_sym_discard] = ACTIONS(3176),
    [anon_sym_precise] = ACTIONS(3176),
    [anon_sym_shared] = ACTIONS(3176),
    [anon_sym_groupshared] = ACTIONS(3176),
    [anon_sym_uniform] = ACTIONS(3176),
    [anon_sym_row_major] = ACTIONS(3176),
    [anon_sym_column_major] = ACTIONS(3176),
    [anon_sym_globallycoherent] = ACTIONS(3176),
    [anon_sym_centroid] = ACTIONS(3176),
    [anon_sym_noperspective] = ACTIONS(3176),
    [anon_sym_nointerpolation] = ACTIONS(3176),
    [anon_sym_sample] = ACTIONS(3176),
    [anon_sym_linear] = ACTIONS(3176),
    [anon_sym_snorm] = ACTIONS(3176),
    [anon_sym_unorm] = ACTIONS(3176),
    [anon_sym_point] = ACTIONS(3176),
    [anon_sym_line] = ACTIONS(3176),
    [anon_sym_triangleadj] = ACTIONS(3176),
    [anon_sym_lineadj] = ACTIONS(3176),
    [anon_sym_triangle] = ACTIONS(3176),
    [anon_sym_cbuffer] = ACTIONS(3176),
    [anon_sym_interface] = ACTIONS(3176),
    [anon_sym_extension] = ACTIONS(3176),
  },
  [701] = {
    [sym_identifier] = ACTIONS(3002),
    [aux_sym_preproc_include_token1] = ACTIONS(3002),
    [aux_sym_preproc_def_token1] = ACTIONS(3002),
    [aux_sym_preproc_if_token1] = ACTIONS(3002),
    [aux_sym_preproc_if_token2] = ACTIONS(3002),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3002),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3002),
    [sym_preproc_directive] = ACTIONS(3002),
    [anon_sym_LPAREN2] = ACTIONS(3004),
    [anon_sym_BANG] = ACTIONS(3004),
    [anon_sym_TILDE] = ACTIONS(3004),
    [anon_sym_DASH] = ACTIONS(3002),
    [anon_sym_PLUS] = ACTIONS(3002),
    [anon_sym_STAR] = ACTIONS(3004),
    [anon_sym_AMP_AMP] = ACTIONS(3004),
    [anon_sym_AMP] = ACTIONS(3002),
    [anon_sym_SEMI] = ACTIONS(3004),
    [anon_sym___extension__] = ACTIONS(3002),
    [anon_sym_typedef] = ACTIONS(3002),
    [anon_sym_in] = ACTIONS(3002),
    [anon_sym_out] = ACTIONS(3002),
    [anon_sym_inout] = ACTIONS(3002),
    [anon_sym_extern] = ACTIONS(3002),
    [anon_sym___attribute__] = ACTIONS(3002),
    [anon_sym_COLON_COLON] = ACTIONS(3004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3004),
    [anon_sym___declspec] = ACTIONS(3002),
    [anon_sym___based] = ACTIONS(3002),
    [anon_sym___cdecl] = ACTIONS(3002),
    [anon_sym___clrcall] = ACTIONS(3002),
    [anon_sym___stdcall] = ACTIONS(3002),
    [anon_sym___fastcall] = ACTIONS(3002),
    [anon_sym___thiscall] = ACTIONS(3002),
    [anon_sym___vectorcall] = ACTIONS(3002),
    [anon_sym_LBRACE] = ACTIONS(3004),
    [anon_sym_signed] = ACTIONS(3002),
    [anon_sym_unsigned] = ACTIONS(3002),
    [anon_sym_long] = ACTIONS(3002),
    [anon_sym_short] = ACTIONS(3002),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [anon_sym_static] = ACTIONS(3002),
    [anon_sym_register] = ACTIONS(3002),
    [anon_sym_inline] = ACTIONS(3002),
    [anon_sym___inline] = ACTIONS(3002),
    [anon_sym___inline__] = ACTIONS(3002),
    [anon_sym___forceinline] = ACTIONS(3002),
    [anon_sym_thread_local] = ACTIONS(3002),
    [anon_sym___thread] = ACTIONS(3002),
    [anon_sym_const] = ACTIONS(3002),
    [anon_sym_constexpr] = ACTIONS(3002),
    [anon_sym_volatile] = ACTIONS(3002),
    [anon_sym_restrict] = ACTIONS(3002),
    [anon_sym___restrict__] = ACTIONS(3002),
    [anon_sym__Atomic] = ACTIONS(3002),
    [anon_sym__Noreturn] = ACTIONS(3002),
    [anon_sym_noreturn] = ACTIONS(3002),
    [anon_sym_mutable] = ACTIONS(3002),
    [anon_sym_constinit] = ACTIONS(3002),
    [anon_sym_consteval] = ACTIONS(3002),
    [anon_sym_alignas] = ACTIONS(3002),
    [anon_sym__Alignas] = ACTIONS(3002),
    [sym_primitive_type] = ACTIONS(3002),
    [anon_sym_enum] = ACTIONS(3002),
    [anon_sym_class] = ACTIONS(3002),
    [anon_sym_struct] = ACTIONS(3002),
    [anon_sym_union] = ACTIONS(3002),
    [anon_sym_if] = ACTIONS(3002),
    [anon_sym_else] = ACTIONS(3002),
    [anon_sym_switch] = ACTIONS(3002),
    [anon_sym_case] = ACTIONS(3002),
    [anon_sym_default] = ACTIONS(3002),
    [anon_sym_while] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(3002),
    [anon_sym_for] = ACTIONS(3002),
    [anon_sym_return] = ACTIONS(3002),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_continue] = ACTIONS(3002),
    [anon_sym_goto] = ACTIONS(3002),
    [anon_sym___try] = ACTIONS(3002),
    [anon_sym___leave] = ACTIONS(3002),
    [anon_sym_not] = ACTIONS(3002),
    [anon_sym_compl] = ACTIONS(3002),
    [anon_sym_DASH_DASH] = ACTIONS(3004),
    [anon_sym_PLUS_PLUS] = ACTIONS(3004),
    [anon_sym_sizeof] = ACTIONS(3002),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3002),
    [anon_sym__Generic] = ACTIONS(3002),
    [anon_sym_asm] = ACTIONS(3002),
    [anon_sym___asm__] = ACTIONS(3002),
    [sym_number_literal] = ACTIONS(3004),
    [anon_sym_L_SQUOTE] = ACTIONS(3004),
    [anon_sym_u_SQUOTE] = ACTIONS(3004),
    [anon_sym_U_SQUOTE] = ACTIONS(3004),
    [anon_sym_u8_SQUOTE] = ACTIONS(3004),
    [anon_sym_SQUOTE] = ACTIONS(3004),
    [anon_sym_L_DQUOTE] = ACTIONS(3004),
    [anon_sym_u_DQUOTE] = ACTIONS(3004),
    [anon_sym_U_DQUOTE] = ACTIONS(3004),
    [anon_sym_u8_DQUOTE] = ACTIONS(3004),
    [anon_sym_DQUOTE] = ACTIONS(3004),
    [sym_true] = ACTIONS(3002),
    [sym_false] = ACTIONS(3002),
    [anon_sym_NULL] = ACTIONS(3002),
    [anon_sym_nullptr] = ACTIONS(3002),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3002),
    [anon_sym_let] = ACTIONS(3002),
    [anon_sym_This] = ACTIONS(3002),
    [anon_sym_decltype] = ACTIONS(3002),
    [sym_virtual] = ACTIONS(3002),
    [anon_sym_explicit] = ACTIONS(3002),
    [anon_sym_typename] = ACTIONS(3002),
    [anon_sym_template] = ACTIONS(3002),
    [anon_sym_operator] = ACTIONS(3002),
    [anon_sym_try] = ACTIONS(3002),
    [anon_sym_delete] = ACTIONS(3002),
    [anon_sym_throw] = ACTIONS(3002),
    [anon_sym_namespace] = ACTIONS(3002),
    [anon_sym_using] = ACTIONS(3002),
    [anon_sym_static_assert] = ACTIONS(3002),
    [anon_sym_concept] = ACTIONS(3002),
    [anon_sym_co_return] = ACTIONS(3002),
    [anon_sym_co_yield] = ACTIONS(3002),
    [anon_sym_R_DQUOTE] = ACTIONS(3004),
    [anon_sym_LR_DQUOTE] = ACTIONS(3004),
    [anon_sym_uR_DQUOTE] = ACTIONS(3004),
    [anon_sym_UR_DQUOTE] = ACTIONS(3004),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3004),
    [anon_sym_co_await] = ACTIONS(3002),
    [anon_sym_new] = ACTIONS(3002),
    [anon_sym_requires] = ACTIONS(3002),
    [sym_this] = ACTIONS(3002),
    [anon_sym_discard] = ACTIONS(3002),
    [anon_sym_precise] = ACTIONS(3002),
    [anon_sym_shared] = ACTIONS(3002),
    [anon_sym_groupshared] = ACTIONS(3002),
    [anon_sym_uniform] = ACTIONS(3002),
    [anon_sym_row_major] = ACTIONS(3002),
    [anon_sym_column_major] = ACTIONS(3002),
    [anon_sym_globallycoherent] = ACTIONS(3002),
    [anon_sym_centroid] = ACTIONS(3002),
    [anon_sym_noperspective] = ACTIONS(3002),
    [anon_sym_nointerpolation] = ACTIONS(3002),
    [anon_sym_sample] = ACTIONS(3002),
    [anon_sym_linear] = ACTIONS(3002),
    [anon_sym_snorm] = ACTIONS(3002),
    [anon_sym_unorm] = ACTIONS(3002),
    [anon_sym_point] = ACTIONS(3002),
    [anon_sym_line] = ACTIONS(3002),
    [anon_sym_triangleadj] = ACTIONS(3002),
    [anon_sym_lineadj] = ACTIONS(3002),
    [anon_sym_triangle] = ACTIONS(3002),
    [anon_sym_cbuffer] = ACTIONS(3002),
    [anon_sym_interface] = ACTIONS(3002),
    [anon_sym_extension] = ACTIONS(3002),
  },
  [702] = {
    [sym_identifier] = ACTIONS(3158),
    [aux_sym_preproc_include_token1] = ACTIONS(3158),
    [aux_sym_preproc_def_token1] = ACTIONS(3158),
    [aux_sym_preproc_if_token1] = ACTIONS(3158),
    [aux_sym_preproc_if_token2] = ACTIONS(3158),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3158),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3158),
    [sym_preproc_directive] = ACTIONS(3158),
    [anon_sym_LPAREN2] = ACTIONS(3160),
    [anon_sym_BANG] = ACTIONS(3160),
    [anon_sym_TILDE] = ACTIONS(3160),
    [anon_sym_DASH] = ACTIONS(3158),
    [anon_sym_PLUS] = ACTIONS(3158),
    [anon_sym_STAR] = ACTIONS(3160),
    [anon_sym_AMP_AMP] = ACTIONS(3160),
    [anon_sym_AMP] = ACTIONS(3158),
    [anon_sym_SEMI] = ACTIONS(3160),
    [anon_sym___extension__] = ACTIONS(3158),
    [anon_sym_typedef] = ACTIONS(3158),
    [anon_sym_in] = ACTIONS(3158),
    [anon_sym_out] = ACTIONS(3158),
    [anon_sym_inout] = ACTIONS(3158),
    [anon_sym_extern] = ACTIONS(3158),
    [anon_sym___attribute__] = ACTIONS(3158),
    [anon_sym_COLON_COLON] = ACTIONS(3160),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3160),
    [anon_sym___declspec] = ACTIONS(3158),
    [anon_sym___based] = ACTIONS(3158),
    [anon_sym___cdecl] = ACTIONS(3158),
    [anon_sym___clrcall] = ACTIONS(3158),
    [anon_sym___stdcall] = ACTIONS(3158),
    [anon_sym___fastcall] = ACTIONS(3158),
    [anon_sym___thiscall] = ACTIONS(3158),
    [anon_sym___vectorcall] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3160),
    [anon_sym_signed] = ACTIONS(3158),
    [anon_sym_unsigned] = ACTIONS(3158),
    [anon_sym_long] = ACTIONS(3158),
    [anon_sym_short] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_static] = ACTIONS(3158),
    [anon_sym_register] = ACTIONS(3158),
    [anon_sym_inline] = ACTIONS(3158),
    [anon_sym___inline] = ACTIONS(3158),
    [anon_sym___inline__] = ACTIONS(3158),
    [anon_sym___forceinline] = ACTIONS(3158),
    [anon_sym_thread_local] = ACTIONS(3158),
    [anon_sym___thread] = ACTIONS(3158),
    [anon_sym_const] = ACTIONS(3158),
    [anon_sym_constexpr] = ACTIONS(3158),
    [anon_sym_volatile] = ACTIONS(3158),
    [anon_sym_restrict] = ACTIONS(3158),
    [anon_sym___restrict__] = ACTIONS(3158),
    [anon_sym__Atomic] = ACTIONS(3158),
    [anon_sym__Noreturn] = ACTIONS(3158),
    [anon_sym_noreturn] = ACTIONS(3158),
    [anon_sym_mutable] = ACTIONS(3158),
    [anon_sym_constinit] = ACTIONS(3158),
    [anon_sym_consteval] = ACTIONS(3158),
    [anon_sym_alignas] = ACTIONS(3158),
    [anon_sym__Alignas] = ACTIONS(3158),
    [sym_primitive_type] = ACTIONS(3158),
    [anon_sym_enum] = ACTIONS(3158),
    [anon_sym_class] = ACTIONS(3158),
    [anon_sym_struct] = ACTIONS(3158),
    [anon_sym_union] = ACTIONS(3158),
    [anon_sym_if] = ACTIONS(3158),
    [anon_sym_else] = ACTIONS(3158),
    [anon_sym_switch] = ACTIONS(3158),
    [anon_sym_case] = ACTIONS(3158),
    [anon_sym_default] = ACTIONS(3158),
    [anon_sym_while] = ACTIONS(3158),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_for] = ACTIONS(3158),
    [anon_sym_return] = ACTIONS(3158),
    [anon_sym_break] = ACTIONS(3158),
    [anon_sym_continue] = ACTIONS(3158),
    [anon_sym_goto] = ACTIONS(3158),
    [anon_sym___try] = ACTIONS(3158),
    [anon_sym___leave] = ACTIONS(3158),
    [anon_sym_not] = ACTIONS(3158),
    [anon_sym_compl] = ACTIONS(3158),
    [anon_sym_DASH_DASH] = ACTIONS(3160),
    [anon_sym_PLUS_PLUS] = ACTIONS(3160),
    [anon_sym_sizeof] = ACTIONS(3158),
    [anon_sym___alignof__] = ACTIONS(3158),
    [anon_sym___alignof] = ACTIONS(3158),
    [anon_sym__alignof] = ACTIONS(3158),
    [anon_sym_alignof] = ACTIONS(3158),
    [anon_sym__Alignof] = ACTIONS(3158),
    [anon_sym_offsetof] = ACTIONS(3158),
    [anon_sym__Generic] = ACTIONS(3158),
    [anon_sym_asm] = ACTIONS(3158),
    [anon_sym___asm__] = ACTIONS(3158),
    [sym_number_literal] = ACTIONS(3160),
    [anon_sym_L_SQUOTE] = ACTIONS(3160),
    [anon_sym_u_SQUOTE] = ACTIONS(3160),
    [anon_sym_U_SQUOTE] = ACTIONS(3160),
    [anon_sym_u8_SQUOTE] = ACTIONS(3160),
    [anon_sym_SQUOTE] = ACTIONS(3160),
    [anon_sym_L_DQUOTE] = ACTIONS(3160),
    [anon_sym_u_DQUOTE] = ACTIONS(3160),
    [anon_sym_U_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8_DQUOTE] = ACTIONS(3160),
    [anon_sym_DQUOTE] = ACTIONS(3160),
    [sym_true] = ACTIONS(3158),
    [sym_false] = ACTIONS(3158),
    [anon_sym_NULL] = ACTIONS(3158),
    [anon_sym_nullptr] = ACTIONS(3158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3158),
    [anon_sym_let] = ACTIONS(3158),
    [anon_sym_This] = ACTIONS(3158),
    [anon_sym_decltype] = ACTIONS(3158),
    [sym_virtual] = ACTIONS(3158),
    [anon_sym_explicit] = ACTIONS(3158),
    [anon_sym_typename] = ACTIONS(3158),
    [anon_sym_template] = ACTIONS(3158),
    [anon_sym_operator] = ACTIONS(3158),
    [anon_sym_try] = ACTIONS(3158),
    [anon_sym_delete] = ACTIONS(3158),
    [anon_sym_throw] = ACTIONS(3158),
    [anon_sym_namespace] = ACTIONS(3158),
    [anon_sym_using] = ACTIONS(3158),
    [anon_sym_static_assert] = ACTIONS(3158),
    [anon_sym_concept] = ACTIONS(3158),
    [anon_sym_co_return] = ACTIONS(3158),
    [anon_sym_co_yield] = ACTIONS(3158),
    [anon_sym_R_DQUOTE] = ACTIONS(3160),
    [anon_sym_LR_DQUOTE] = ACTIONS(3160),
    [anon_sym_uR_DQUOTE] = ACTIONS(3160),
    [anon_sym_UR_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3160),
    [anon_sym_co_await] = ACTIONS(3158),
    [anon_sym_new] = ACTIONS(3158),
    [anon_sym_requires] = ACTIONS(3158),
    [sym_this] = ACTIONS(3158),
    [anon_sym_discard] = ACTIONS(3158),
    [anon_sym_precise] = ACTIONS(3158),
    [anon_sym_shared] = ACTIONS(3158),
    [anon_sym_groupshared] = ACTIONS(3158),
    [anon_sym_uniform] = ACTIONS(3158),
    [anon_sym_row_major] = ACTIONS(3158),
    [anon_sym_column_major] = ACTIONS(3158),
    [anon_sym_globallycoherent] = ACTIONS(3158),
    [anon_sym_centroid] = ACTIONS(3158),
    [anon_sym_noperspective] = ACTIONS(3158),
    [anon_sym_nointerpolation] = ACTIONS(3158),
    [anon_sym_sample] = ACTIONS(3158),
    [anon_sym_linear] = ACTIONS(3158),
    [anon_sym_snorm] = ACTIONS(3158),
    [anon_sym_unorm] = ACTIONS(3158),
    [anon_sym_point] = ACTIONS(3158),
    [anon_sym_line] = ACTIONS(3158),
    [anon_sym_triangleadj] = ACTIONS(3158),
    [anon_sym_lineadj] = ACTIONS(3158),
    [anon_sym_triangle] = ACTIONS(3158),
    [anon_sym_cbuffer] = ACTIONS(3158),
    [anon_sym_interface] = ACTIONS(3158),
    [anon_sym_extension] = ACTIONS(3158),
  },
  [703] = {
    [sym_identifier] = ACTIONS(2948),
    [aux_sym_preproc_include_token1] = ACTIONS(2948),
    [aux_sym_preproc_def_token1] = ACTIONS(2948),
    [aux_sym_preproc_if_token1] = ACTIONS(2948),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2948),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2948),
    [sym_preproc_directive] = ACTIONS(2948),
    [anon_sym_LPAREN2] = ACTIONS(2946),
    [anon_sym_BANG] = ACTIONS(2946),
    [anon_sym_TILDE] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2948),
    [anon_sym_PLUS] = ACTIONS(2948),
    [anon_sym_STAR] = ACTIONS(2946),
    [anon_sym_AMP_AMP] = ACTIONS(2946),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2946),
    [anon_sym___extension__] = ACTIONS(2948),
    [anon_sym_typedef] = ACTIONS(2948),
    [anon_sym_in] = ACTIONS(2948),
    [anon_sym_out] = ACTIONS(2948),
    [anon_sym_inout] = ACTIONS(2948),
    [anon_sym_extern] = ACTIONS(2948),
    [anon_sym___attribute__] = ACTIONS(2948),
    [anon_sym_COLON_COLON] = ACTIONS(2946),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2946),
    [anon_sym___declspec] = ACTIONS(2948),
    [anon_sym___based] = ACTIONS(2948),
    [anon_sym___cdecl] = ACTIONS(2948),
    [anon_sym___clrcall] = ACTIONS(2948),
    [anon_sym___stdcall] = ACTIONS(2948),
    [anon_sym___fastcall] = ACTIONS(2948),
    [anon_sym___thiscall] = ACTIONS(2948),
    [anon_sym___vectorcall] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2946),
    [anon_sym_RBRACE] = ACTIONS(2946),
    [anon_sym_signed] = ACTIONS(2948),
    [anon_sym_unsigned] = ACTIONS(2948),
    [anon_sym_long] = ACTIONS(2948),
    [anon_sym_short] = ACTIONS(2948),
    [anon_sym_LBRACK] = ACTIONS(2948),
    [anon_sym_static] = ACTIONS(2948),
    [anon_sym_register] = ACTIONS(2948),
    [anon_sym_inline] = ACTIONS(2948),
    [anon_sym___inline] = ACTIONS(2948),
    [anon_sym___inline__] = ACTIONS(2948),
    [anon_sym___forceinline] = ACTIONS(2948),
    [anon_sym_thread_local] = ACTIONS(2948),
    [anon_sym___thread] = ACTIONS(2948),
    [anon_sym_const] = ACTIONS(2948),
    [anon_sym_constexpr] = ACTIONS(2948),
    [anon_sym_volatile] = ACTIONS(2948),
    [anon_sym_restrict] = ACTIONS(2948),
    [anon_sym___restrict__] = ACTIONS(2948),
    [anon_sym__Atomic] = ACTIONS(2948),
    [anon_sym__Noreturn] = ACTIONS(2948),
    [anon_sym_noreturn] = ACTIONS(2948),
    [anon_sym_mutable] = ACTIONS(2948),
    [anon_sym_constinit] = ACTIONS(2948),
    [anon_sym_consteval] = ACTIONS(2948),
    [anon_sym_alignas] = ACTIONS(2948),
    [anon_sym__Alignas] = ACTIONS(2948),
    [sym_primitive_type] = ACTIONS(2948),
    [anon_sym_enum] = ACTIONS(2948),
    [anon_sym_class] = ACTIONS(2948),
    [anon_sym_struct] = ACTIONS(2948),
    [anon_sym_union] = ACTIONS(2948),
    [anon_sym_if] = ACTIONS(2948),
    [anon_sym_switch] = ACTIONS(2948),
    [anon_sym_case] = ACTIONS(2948),
    [anon_sym_default] = ACTIONS(2948),
    [anon_sym_while] = ACTIONS(2948),
    [anon_sym_do] = ACTIONS(2948),
    [anon_sym_for] = ACTIONS(2948),
    [anon_sym_return] = ACTIONS(2948),
    [anon_sym_break] = ACTIONS(2948),
    [anon_sym_continue] = ACTIONS(2948),
    [anon_sym_goto] = ACTIONS(2948),
    [anon_sym___try] = ACTIONS(2948),
    [anon_sym___leave] = ACTIONS(2948),
    [anon_sym_not] = ACTIONS(2948),
    [anon_sym_compl] = ACTIONS(2948),
    [anon_sym_DASH_DASH] = ACTIONS(2946),
    [anon_sym_PLUS_PLUS] = ACTIONS(2946),
    [anon_sym_sizeof] = ACTIONS(2948),
    [anon_sym___alignof__] = ACTIONS(2948),
    [anon_sym___alignof] = ACTIONS(2948),
    [anon_sym__alignof] = ACTIONS(2948),
    [anon_sym_alignof] = ACTIONS(2948),
    [anon_sym__Alignof] = ACTIONS(2948),
    [anon_sym_offsetof] = ACTIONS(2948),
    [anon_sym__Generic] = ACTIONS(2948),
    [anon_sym_asm] = ACTIONS(2948),
    [anon_sym___asm__] = ACTIONS(2948),
    [anon_sym_DOT] = ACTIONS(2948),
    [sym_number_literal] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2946),
    [anon_sym_u_SQUOTE] = ACTIONS(2946),
    [anon_sym_U_SQUOTE] = ACTIONS(2946),
    [anon_sym_u8_SQUOTE] = ACTIONS(2946),
    [anon_sym_SQUOTE] = ACTIONS(2946),
    [anon_sym_L_DQUOTE] = ACTIONS(2946),
    [anon_sym_u_DQUOTE] = ACTIONS(2946),
    [anon_sym_U_DQUOTE] = ACTIONS(2946),
    [anon_sym_u8_DQUOTE] = ACTIONS(2946),
    [anon_sym_DQUOTE] = ACTIONS(2946),
    [sym_true] = ACTIONS(2948),
    [sym_false] = ACTIONS(2948),
    [anon_sym_NULL] = ACTIONS(2948),
    [anon_sym_nullptr] = ACTIONS(2948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2948),
    [anon_sym_let] = ACTIONS(2948),
    [anon_sym_This] = ACTIONS(2948),
    [anon_sym_decltype] = ACTIONS(2948),
    [sym_virtual] = ACTIONS(2948),
    [anon_sym_explicit] = ACTIONS(2948),
    [anon_sym_typename] = ACTIONS(2948),
    [anon_sym_template] = ACTIONS(2948),
    [anon_sym_operator] = ACTIONS(2948),
    [anon_sym_try] = ACTIONS(2948),
    [anon_sym_delete] = ACTIONS(2948),
    [anon_sym_throw] = ACTIONS(2948),
    [anon_sym_namespace] = ACTIONS(2948),
    [anon_sym_using] = ACTIONS(2948),
    [anon_sym_static_assert] = ACTIONS(2948),
    [anon_sym_concept] = ACTIONS(2948),
    [anon_sym_co_return] = ACTIONS(2948),
    [anon_sym_co_yield] = ACTIONS(2948),
    [anon_sym_R_DQUOTE] = ACTIONS(2946),
    [anon_sym_LR_DQUOTE] = ACTIONS(2946),
    [anon_sym_uR_DQUOTE] = ACTIONS(2946),
    [anon_sym_UR_DQUOTE] = ACTIONS(2946),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2946),
    [anon_sym_co_await] = ACTIONS(2948),
    [anon_sym_new] = ACTIONS(2948),
    [anon_sym_requires] = ACTIONS(2948),
    [sym_this] = ACTIONS(2948),
    [anon_sym_discard] = ACTIONS(2948),
    [anon_sym_precise] = ACTIONS(2948),
    [anon_sym_shared] = ACTIONS(2948),
    [anon_sym_groupshared] = ACTIONS(2948),
    [anon_sym_uniform] = ACTIONS(2948),
    [anon_sym_row_major] = ACTIONS(2948),
    [anon_sym_column_major] = ACTIONS(2948),
    [anon_sym_globallycoherent] = ACTIONS(2948),
    [anon_sym_centroid] = ACTIONS(2948),
    [anon_sym_noperspective] = ACTIONS(2948),
    [anon_sym_nointerpolation] = ACTIONS(2948),
    [anon_sym_sample] = ACTIONS(2948),
    [anon_sym_linear] = ACTIONS(2948),
    [anon_sym_snorm] = ACTIONS(2948),
    [anon_sym_unorm] = ACTIONS(2948),
    [anon_sym_point] = ACTIONS(2948),
    [anon_sym_line] = ACTIONS(2948),
    [anon_sym_triangleadj] = ACTIONS(2948),
    [anon_sym_lineadj] = ACTIONS(2948),
    [anon_sym_triangle] = ACTIONS(2948),
    [anon_sym_cbuffer] = ACTIONS(2948),
    [anon_sym_interface] = ACTIONS(2948),
    [anon_sym_extension] = ACTIONS(2948),
  },
  [704] = {
    [sym_identifier] = ACTIONS(2536),
    [aux_sym_preproc_include_token1] = ACTIONS(2536),
    [aux_sym_preproc_def_token1] = ACTIONS(2536),
    [aux_sym_preproc_if_token1] = ACTIONS(2536),
    [aux_sym_preproc_if_token2] = ACTIONS(2536),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2536),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2536),
    [sym_preproc_directive] = ACTIONS(2536),
    [anon_sym_LPAREN2] = ACTIONS(2534),
    [anon_sym_BANG] = ACTIONS(2534),
    [anon_sym_TILDE] = ACTIONS(2534),
    [anon_sym_DASH] = ACTIONS(2536),
    [anon_sym_PLUS] = ACTIONS(2536),
    [anon_sym_STAR] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
    [anon_sym_SEMI] = ACTIONS(2534),
    [anon_sym___extension__] = ACTIONS(2536),
    [anon_sym_typedef] = ACTIONS(2536),
    [anon_sym_in] = ACTIONS(2536),
    [anon_sym_out] = ACTIONS(2536),
    [anon_sym_inout] = ACTIONS(2536),
    [anon_sym_extern] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(2534),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2534),
    [anon_sym___declspec] = ACTIONS(2536),
    [anon_sym___based] = ACTIONS(2536),
    [anon_sym___cdecl] = ACTIONS(2536),
    [anon_sym___clrcall] = ACTIONS(2536),
    [anon_sym___stdcall] = ACTIONS(2536),
    [anon_sym___fastcall] = ACTIONS(2536),
    [anon_sym___thiscall] = ACTIONS(2536),
    [anon_sym___vectorcall] = ACTIONS(2536),
    [anon_sym_LBRACE] = ACTIONS(2534),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(2536),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_register] = ACTIONS(2536),
    [anon_sym_inline] = ACTIONS(2536),
    [anon_sym___inline] = ACTIONS(2536),
    [anon_sym___inline__] = ACTIONS(2536),
    [anon_sym___forceinline] = ACTIONS(2536),
    [anon_sym_thread_local] = ACTIONS(2536),
    [anon_sym___thread] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2536),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_class] = ACTIONS(2536),
    [anon_sym_struct] = ACTIONS(2536),
    [anon_sym_union] = ACTIONS(2536),
    [anon_sym_if] = ACTIONS(2536),
    [anon_sym_else] = ACTIONS(2536),
    [anon_sym_switch] = ACTIONS(2536),
    [anon_sym_case] = ACTIONS(2536),
    [anon_sym_default] = ACTIONS(2536),
    [anon_sym_while] = ACTIONS(2536),
    [anon_sym_do] = ACTIONS(2536),
    [anon_sym_for] = ACTIONS(2536),
    [anon_sym_return] = ACTIONS(2536),
    [anon_sym_break] = ACTIONS(2536),
    [anon_sym_continue] = ACTIONS(2536),
    [anon_sym_goto] = ACTIONS(2536),
    [anon_sym___try] = ACTIONS(2536),
    [anon_sym___leave] = ACTIONS(2536),
    [anon_sym_not] = ACTIONS(2536),
    [anon_sym_compl] = ACTIONS(2536),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_sizeof] = ACTIONS(2536),
    [anon_sym___alignof__] = ACTIONS(2536),
    [anon_sym___alignof] = ACTIONS(2536),
    [anon_sym__alignof] = ACTIONS(2536),
    [anon_sym_alignof] = ACTIONS(2536),
    [anon_sym__Alignof] = ACTIONS(2536),
    [anon_sym_offsetof] = ACTIONS(2536),
    [anon_sym__Generic] = ACTIONS(2536),
    [anon_sym_asm] = ACTIONS(2536),
    [anon_sym___asm__] = ACTIONS(2536),
    [sym_number_literal] = ACTIONS(2534),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2534),
    [anon_sym_u_DQUOTE] = ACTIONS(2534),
    [anon_sym_U_DQUOTE] = ACTIONS(2534),
    [anon_sym_u8_DQUOTE] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [sym_true] = ACTIONS(2536),
    [sym_false] = ACTIONS(2536),
    [anon_sym_NULL] = ACTIONS(2536),
    [anon_sym_nullptr] = ACTIONS(2536),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2536),
    [anon_sym_let] = ACTIONS(2536),
    [anon_sym_This] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2536),
    [sym_virtual] = ACTIONS(2536),
    [anon_sym_explicit] = ACTIONS(2536),
    [anon_sym_typename] = ACTIONS(2536),
    [anon_sym_template] = ACTIONS(2536),
    [anon_sym_operator] = ACTIONS(2536),
    [anon_sym_try] = ACTIONS(2536),
    [anon_sym_delete] = ACTIONS(2536),
    [anon_sym_throw] = ACTIONS(2536),
    [anon_sym_namespace] = ACTIONS(2536),
    [anon_sym_using] = ACTIONS(2536),
    [anon_sym_static_assert] = ACTIONS(2536),
    [anon_sym_concept] = ACTIONS(2536),
    [anon_sym_co_return] = ACTIONS(2536),
    [anon_sym_co_yield] = ACTIONS(2536),
    [anon_sym_R_DQUOTE] = ACTIONS(2534),
    [anon_sym_LR_DQUOTE] = ACTIONS(2534),
    [anon_sym_uR_DQUOTE] = ACTIONS(2534),
    [anon_sym_UR_DQUOTE] = ACTIONS(2534),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2534),
    [anon_sym_co_await] = ACTIONS(2536),
    [anon_sym_new] = ACTIONS(2536),
    [anon_sym_requires] = ACTIONS(2536),
    [sym_this] = ACTIONS(2536),
    [anon_sym_discard] = ACTIONS(2536),
    [anon_sym_precise] = ACTIONS(2536),
    [anon_sym_shared] = ACTIONS(2536),
    [anon_sym_groupshared] = ACTIONS(2536),
    [anon_sym_uniform] = ACTIONS(2536),
    [anon_sym_row_major] = ACTIONS(2536),
    [anon_sym_column_major] = ACTIONS(2536),
    [anon_sym_globallycoherent] = ACTIONS(2536),
    [anon_sym_centroid] = ACTIONS(2536),
    [anon_sym_noperspective] = ACTIONS(2536),
    [anon_sym_nointerpolation] = ACTIONS(2536),
    [anon_sym_sample] = ACTIONS(2536),
    [anon_sym_linear] = ACTIONS(2536),
    [anon_sym_snorm] = ACTIONS(2536),
    [anon_sym_unorm] = ACTIONS(2536),
    [anon_sym_point] = ACTIONS(2536),
    [anon_sym_line] = ACTIONS(2536),
    [anon_sym_triangleadj] = ACTIONS(2536),
    [anon_sym_lineadj] = ACTIONS(2536),
    [anon_sym_triangle] = ACTIONS(2536),
    [anon_sym_cbuffer] = ACTIONS(2536),
    [anon_sym_interface] = ACTIONS(2536),
    [anon_sym_extension] = ACTIONS(2536),
  },
  [705] = {
    [sym_identifier] = ACTIONS(2978),
    [aux_sym_preproc_include_token1] = ACTIONS(2978),
    [aux_sym_preproc_def_token1] = ACTIONS(2978),
    [aux_sym_preproc_if_token1] = ACTIONS(2978),
    [aux_sym_preproc_if_token2] = ACTIONS(2978),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2978),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2978),
    [sym_preproc_directive] = ACTIONS(2978),
    [anon_sym_LPAREN2] = ACTIONS(2980),
    [anon_sym_BANG] = ACTIONS(2980),
    [anon_sym_TILDE] = ACTIONS(2980),
    [anon_sym_DASH] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_STAR] = ACTIONS(2980),
    [anon_sym_AMP_AMP] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2978),
    [anon_sym_SEMI] = ACTIONS(2980),
    [anon_sym___extension__] = ACTIONS(2978),
    [anon_sym_typedef] = ACTIONS(2978),
    [anon_sym_in] = ACTIONS(2978),
    [anon_sym_out] = ACTIONS(2978),
    [anon_sym_inout] = ACTIONS(2978),
    [anon_sym_extern] = ACTIONS(2978),
    [anon_sym___attribute__] = ACTIONS(2978),
    [anon_sym_COLON_COLON] = ACTIONS(2980),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2980),
    [anon_sym___declspec] = ACTIONS(2978),
    [anon_sym___based] = ACTIONS(2978),
    [anon_sym___cdecl] = ACTIONS(2978),
    [anon_sym___clrcall] = ACTIONS(2978),
    [anon_sym___stdcall] = ACTIONS(2978),
    [anon_sym___fastcall] = ACTIONS(2978),
    [anon_sym___thiscall] = ACTIONS(2978),
    [anon_sym___vectorcall] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(2980),
    [anon_sym_signed] = ACTIONS(2978),
    [anon_sym_unsigned] = ACTIONS(2978),
    [anon_sym_long] = ACTIONS(2978),
    [anon_sym_short] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_static] = ACTIONS(2978),
    [anon_sym_register] = ACTIONS(2978),
    [anon_sym_inline] = ACTIONS(2978),
    [anon_sym___inline] = ACTIONS(2978),
    [anon_sym___inline__] = ACTIONS(2978),
    [anon_sym___forceinline] = ACTIONS(2978),
    [anon_sym_thread_local] = ACTIONS(2978),
    [anon_sym___thread] = ACTIONS(2978),
    [anon_sym_const] = ACTIONS(2978),
    [anon_sym_constexpr] = ACTIONS(2978),
    [anon_sym_volatile] = ACTIONS(2978),
    [anon_sym_restrict] = ACTIONS(2978),
    [anon_sym___restrict__] = ACTIONS(2978),
    [anon_sym__Atomic] = ACTIONS(2978),
    [anon_sym__Noreturn] = ACTIONS(2978),
    [anon_sym_noreturn] = ACTIONS(2978),
    [anon_sym_mutable] = ACTIONS(2978),
    [anon_sym_constinit] = ACTIONS(2978),
    [anon_sym_consteval] = ACTIONS(2978),
    [anon_sym_alignas] = ACTIONS(2978),
    [anon_sym__Alignas] = ACTIONS(2978),
    [sym_primitive_type] = ACTIONS(2978),
    [anon_sym_enum] = ACTIONS(2978),
    [anon_sym_class] = ACTIONS(2978),
    [anon_sym_struct] = ACTIONS(2978),
    [anon_sym_union] = ACTIONS(2978),
    [anon_sym_if] = ACTIONS(2978),
    [anon_sym_else] = ACTIONS(2978),
    [anon_sym_switch] = ACTIONS(2978),
    [anon_sym_case] = ACTIONS(2978),
    [anon_sym_default] = ACTIONS(2978),
    [anon_sym_while] = ACTIONS(2978),
    [anon_sym_do] = ACTIONS(2978),
    [anon_sym_for] = ACTIONS(2978),
    [anon_sym_return] = ACTIONS(2978),
    [anon_sym_break] = ACTIONS(2978),
    [anon_sym_continue] = ACTIONS(2978),
    [anon_sym_goto] = ACTIONS(2978),
    [anon_sym___try] = ACTIONS(2978),
    [anon_sym___leave] = ACTIONS(2978),
    [anon_sym_not] = ACTIONS(2978),
    [anon_sym_compl] = ACTIONS(2978),
    [anon_sym_DASH_DASH] = ACTIONS(2980),
    [anon_sym_PLUS_PLUS] = ACTIONS(2980),
    [anon_sym_sizeof] = ACTIONS(2978),
    [anon_sym___alignof__] = ACTIONS(2978),
    [anon_sym___alignof] = ACTIONS(2978),
    [anon_sym__alignof] = ACTIONS(2978),
    [anon_sym_alignof] = ACTIONS(2978),
    [anon_sym__Alignof] = ACTIONS(2978),
    [anon_sym_offsetof] = ACTIONS(2978),
    [anon_sym__Generic] = ACTIONS(2978),
    [anon_sym_asm] = ACTIONS(2978),
    [anon_sym___asm__] = ACTIONS(2978),
    [sym_number_literal] = ACTIONS(2980),
    [anon_sym_L_SQUOTE] = ACTIONS(2980),
    [anon_sym_u_SQUOTE] = ACTIONS(2980),
    [anon_sym_U_SQUOTE] = ACTIONS(2980),
    [anon_sym_u8_SQUOTE] = ACTIONS(2980),
    [anon_sym_SQUOTE] = ACTIONS(2980),
    [anon_sym_L_DQUOTE] = ACTIONS(2980),
    [anon_sym_u_DQUOTE] = ACTIONS(2980),
    [anon_sym_U_DQUOTE] = ACTIONS(2980),
    [anon_sym_u8_DQUOTE] = ACTIONS(2980),
    [anon_sym_DQUOTE] = ACTIONS(2980),
    [sym_true] = ACTIONS(2978),
    [sym_false] = ACTIONS(2978),
    [anon_sym_NULL] = ACTIONS(2978),
    [anon_sym_nullptr] = ACTIONS(2978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2978),
    [anon_sym_let] = ACTIONS(2978),
    [anon_sym_This] = ACTIONS(2978),
    [anon_sym_decltype] = ACTIONS(2978),
    [sym_virtual] = ACTIONS(2978),
    [anon_sym_explicit] = ACTIONS(2978),
    [anon_sym_typename] = ACTIONS(2978),
    [anon_sym_template] = ACTIONS(2978),
    [anon_sym_operator] = ACTIONS(2978),
    [anon_sym_try] = ACTIONS(2978),
    [anon_sym_delete] = ACTIONS(2978),
    [anon_sym_throw] = ACTIONS(2978),
    [anon_sym_namespace] = ACTIONS(2978),
    [anon_sym_using] = ACTIONS(2978),
    [anon_sym_static_assert] = ACTIONS(2978),
    [anon_sym_concept] = ACTIONS(2978),
    [anon_sym_co_return] = ACTIONS(2978),
    [anon_sym_co_yield] = ACTIONS(2978),
    [anon_sym_R_DQUOTE] = ACTIONS(2980),
    [anon_sym_LR_DQUOTE] = ACTIONS(2980),
    [anon_sym_uR_DQUOTE] = ACTIONS(2980),
    [anon_sym_UR_DQUOTE] = ACTIONS(2980),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2980),
    [anon_sym_co_await] = ACTIONS(2978),
    [anon_sym_new] = ACTIONS(2978),
    [anon_sym_requires] = ACTIONS(2978),
    [sym_this] = ACTIONS(2978),
    [anon_sym_discard] = ACTIONS(2978),
    [anon_sym_precise] = ACTIONS(2978),
    [anon_sym_shared] = ACTIONS(2978),
    [anon_sym_groupshared] = ACTIONS(2978),
    [anon_sym_uniform] = ACTIONS(2978),
    [anon_sym_row_major] = ACTIONS(2978),
    [anon_sym_column_major] = ACTIONS(2978),
    [anon_sym_globallycoherent] = ACTIONS(2978),
    [anon_sym_centroid] = ACTIONS(2978),
    [anon_sym_noperspective] = ACTIONS(2978),
    [anon_sym_nointerpolation] = ACTIONS(2978),
    [anon_sym_sample] = ACTIONS(2978),
    [anon_sym_linear] = ACTIONS(2978),
    [anon_sym_snorm] = ACTIONS(2978),
    [anon_sym_unorm] = ACTIONS(2978),
    [anon_sym_point] = ACTIONS(2978),
    [anon_sym_line] = ACTIONS(2978),
    [anon_sym_triangleadj] = ACTIONS(2978),
    [anon_sym_lineadj] = ACTIONS(2978),
    [anon_sym_triangle] = ACTIONS(2978),
    [anon_sym_cbuffer] = ACTIONS(2978),
    [anon_sym_interface] = ACTIONS(2978),
    [anon_sym_extension] = ACTIONS(2978),
  },
  [706] = {
    [sym_identifier] = ACTIONS(3058),
    [aux_sym_preproc_include_token1] = ACTIONS(3058),
    [aux_sym_preproc_def_token1] = ACTIONS(3058),
    [aux_sym_preproc_if_token1] = ACTIONS(3058),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3058),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3058),
    [sym_preproc_directive] = ACTIONS(3058),
    [anon_sym_LPAREN2] = ACTIONS(3056),
    [anon_sym_BANG] = ACTIONS(3056),
    [anon_sym_TILDE] = ACTIONS(3056),
    [anon_sym_DASH] = ACTIONS(3058),
    [anon_sym_PLUS] = ACTIONS(3058),
    [anon_sym_STAR] = ACTIONS(3056),
    [anon_sym_AMP_AMP] = ACTIONS(3056),
    [anon_sym_AMP] = ACTIONS(3058),
    [anon_sym_SEMI] = ACTIONS(3056),
    [anon_sym___extension__] = ACTIONS(3058),
    [anon_sym_typedef] = ACTIONS(3058),
    [anon_sym_in] = ACTIONS(3058),
    [anon_sym_out] = ACTIONS(3058),
    [anon_sym_inout] = ACTIONS(3058),
    [anon_sym_extern] = ACTIONS(3058),
    [anon_sym___attribute__] = ACTIONS(3058),
    [anon_sym_COLON_COLON] = ACTIONS(3056),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3056),
    [anon_sym___declspec] = ACTIONS(3058),
    [anon_sym___based] = ACTIONS(3058),
    [anon_sym___cdecl] = ACTIONS(3058),
    [anon_sym___clrcall] = ACTIONS(3058),
    [anon_sym___stdcall] = ACTIONS(3058),
    [anon_sym___fastcall] = ACTIONS(3058),
    [anon_sym___thiscall] = ACTIONS(3058),
    [anon_sym___vectorcall] = ACTIONS(3058),
    [anon_sym_LBRACE] = ACTIONS(3056),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_signed] = ACTIONS(3058),
    [anon_sym_unsigned] = ACTIONS(3058),
    [anon_sym_long] = ACTIONS(3058),
    [anon_sym_short] = ACTIONS(3058),
    [anon_sym_LBRACK] = ACTIONS(3058),
    [anon_sym_static] = ACTIONS(3058),
    [anon_sym_register] = ACTIONS(3058),
    [anon_sym_inline] = ACTIONS(3058),
    [anon_sym___inline] = ACTIONS(3058),
    [anon_sym___inline__] = ACTIONS(3058),
    [anon_sym___forceinline] = ACTIONS(3058),
    [anon_sym_thread_local] = ACTIONS(3058),
    [anon_sym___thread] = ACTIONS(3058),
    [anon_sym_const] = ACTIONS(3058),
    [anon_sym_constexpr] = ACTIONS(3058),
    [anon_sym_volatile] = ACTIONS(3058),
    [anon_sym_restrict] = ACTIONS(3058),
    [anon_sym___restrict__] = ACTIONS(3058),
    [anon_sym__Atomic] = ACTIONS(3058),
    [anon_sym__Noreturn] = ACTIONS(3058),
    [anon_sym_noreturn] = ACTIONS(3058),
    [anon_sym_mutable] = ACTIONS(3058),
    [anon_sym_constinit] = ACTIONS(3058),
    [anon_sym_consteval] = ACTIONS(3058),
    [anon_sym_alignas] = ACTIONS(3058),
    [anon_sym__Alignas] = ACTIONS(3058),
    [sym_primitive_type] = ACTIONS(3058),
    [anon_sym_enum] = ACTIONS(3058),
    [anon_sym_class] = ACTIONS(3058),
    [anon_sym_struct] = ACTIONS(3058),
    [anon_sym_union] = ACTIONS(3058),
    [anon_sym_if] = ACTIONS(3058),
    [anon_sym_switch] = ACTIONS(3058),
    [anon_sym_case] = ACTIONS(3058),
    [anon_sym_default] = ACTIONS(3058),
    [anon_sym_while] = ACTIONS(3058),
    [anon_sym_do] = ACTIONS(3058),
    [anon_sym_for] = ACTIONS(3058),
    [anon_sym_return] = ACTIONS(3058),
    [anon_sym_break] = ACTIONS(3058),
    [anon_sym_continue] = ACTIONS(3058),
    [anon_sym_goto] = ACTIONS(3058),
    [anon_sym___try] = ACTIONS(3058),
    [anon_sym___leave] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3058),
    [anon_sym_compl] = ACTIONS(3058),
    [anon_sym_DASH_DASH] = ACTIONS(3056),
    [anon_sym_PLUS_PLUS] = ACTIONS(3056),
    [anon_sym_sizeof] = ACTIONS(3058),
    [anon_sym___alignof__] = ACTIONS(3058),
    [anon_sym___alignof] = ACTIONS(3058),
    [anon_sym__alignof] = ACTIONS(3058),
    [anon_sym_alignof] = ACTIONS(3058),
    [anon_sym__Alignof] = ACTIONS(3058),
    [anon_sym_offsetof] = ACTIONS(3058),
    [anon_sym__Generic] = ACTIONS(3058),
    [anon_sym_asm] = ACTIONS(3058),
    [anon_sym___asm__] = ACTIONS(3058),
    [anon_sym_DOT] = ACTIONS(3058),
    [sym_number_literal] = ACTIONS(3056),
    [anon_sym_L_SQUOTE] = ACTIONS(3056),
    [anon_sym_u_SQUOTE] = ACTIONS(3056),
    [anon_sym_U_SQUOTE] = ACTIONS(3056),
    [anon_sym_u8_SQUOTE] = ACTIONS(3056),
    [anon_sym_SQUOTE] = ACTIONS(3056),
    [anon_sym_L_DQUOTE] = ACTIONS(3056),
    [anon_sym_u_DQUOTE] = ACTIONS(3056),
    [anon_sym_U_DQUOTE] = ACTIONS(3056),
    [anon_sym_u8_DQUOTE] = ACTIONS(3056),
    [anon_sym_DQUOTE] = ACTIONS(3056),
    [sym_true] = ACTIONS(3058),
    [sym_false] = ACTIONS(3058),
    [anon_sym_NULL] = ACTIONS(3058),
    [anon_sym_nullptr] = ACTIONS(3058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3058),
    [anon_sym_let] = ACTIONS(3058),
    [anon_sym_This] = ACTIONS(3058),
    [anon_sym_decltype] = ACTIONS(3058),
    [sym_virtual] = ACTIONS(3058),
    [anon_sym_explicit] = ACTIONS(3058),
    [anon_sym_typename] = ACTIONS(3058),
    [anon_sym_template] = ACTIONS(3058),
    [anon_sym_operator] = ACTIONS(3058),
    [anon_sym_try] = ACTIONS(3058),
    [anon_sym_delete] = ACTIONS(3058),
    [anon_sym_throw] = ACTIONS(3058),
    [anon_sym_namespace] = ACTIONS(3058),
    [anon_sym_using] = ACTIONS(3058),
    [anon_sym_static_assert] = ACTIONS(3058),
    [anon_sym_concept] = ACTIONS(3058),
    [anon_sym_co_return] = ACTIONS(3058),
    [anon_sym_co_yield] = ACTIONS(3058),
    [anon_sym_R_DQUOTE] = ACTIONS(3056),
    [anon_sym_LR_DQUOTE] = ACTIONS(3056),
    [anon_sym_uR_DQUOTE] = ACTIONS(3056),
    [anon_sym_UR_DQUOTE] = ACTIONS(3056),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3056),
    [anon_sym_co_await] = ACTIONS(3058),
    [anon_sym_new] = ACTIONS(3058),
    [anon_sym_requires] = ACTIONS(3058),
    [sym_this] = ACTIONS(3058),
    [anon_sym_discard] = ACTIONS(3058),
    [anon_sym_precise] = ACTIONS(3058),
    [anon_sym_shared] = ACTIONS(3058),
    [anon_sym_groupshared] = ACTIONS(3058),
    [anon_sym_uniform] = ACTIONS(3058),
    [anon_sym_row_major] = ACTIONS(3058),
    [anon_sym_column_major] = ACTIONS(3058),
    [anon_sym_globallycoherent] = ACTIONS(3058),
    [anon_sym_centroid] = ACTIONS(3058),
    [anon_sym_noperspective] = ACTIONS(3058),
    [anon_sym_nointerpolation] = ACTIONS(3058),
    [anon_sym_sample] = ACTIONS(3058),
    [anon_sym_linear] = ACTIONS(3058),
    [anon_sym_snorm] = ACTIONS(3058),
    [anon_sym_unorm] = ACTIONS(3058),
    [anon_sym_point] = ACTIONS(3058),
    [anon_sym_line] = ACTIONS(3058),
    [anon_sym_triangleadj] = ACTIONS(3058),
    [anon_sym_lineadj] = ACTIONS(3058),
    [anon_sym_triangle] = ACTIONS(3058),
    [anon_sym_cbuffer] = ACTIONS(3058),
    [anon_sym_interface] = ACTIONS(3058),
    [anon_sym_extension] = ACTIONS(3058),
  },
  [707] = {
    [sym_identifier] = ACTIONS(3844),
    [aux_sym_preproc_include_token1] = ACTIONS(3844),
    [aux_sym_preproc_def_token1] = ACTIONS(3844),
    [aux_sym_preproc_if_token1] = ACTIONS(3844),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3844),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3844),
    [sym_preproc_directive] = ACTIONS(3844),
    [anon_sym_LPAREN2] = ACTIONS(3846),
    [anon_sym_BANG] = ACTIONS(3846),
    [anon_sym_TILDE] = ACTIONS(3846),
    [anon_sym_DASH] = ACTIONS(3844),
    [anon_sym_PLUS] = ACTIONS(3844),
    [anon_sym_STAR] = ACTIONS(3846),
    [anon_sym_AMP_AMP] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3844),
    [anon_sym_SEMI] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(3844),
    [anon_sym_typedef] = ACTIONS(3844),
    [anon_sym_in] = ACTIONS(3844),
    [anon_sym_out] = ACTIONS(3844),
    [anon_sym_inout] = ACTIONS(3844),
    [anon_sym_extern] = ACTIONS(3844),
    [anon_sym___attribute__] = ACTIONS(3844),
    [anon_sym_COLON_COLON] = ACTIONS(3846),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3846),
    [anon_sym___declspec] = ACTIONS(3844),
    [anon_sym___based] = ACTIONS(3844),
    [anon_sym___cdecl] = ACTIONS(3844),
    [anon_sym___clrcall] = ACTIONS(3844),
    [anon_sym___stdcall] = ACTIONS(3844),
    [anon_sym___fastcall] = ACTIONS(3844),
    [anon_sym___thiscall] = ACTIONS(3844),
    [anon_sym___vectorcall] = ACTIONS(3844),
    [anon_sym_LBRACE] = ACTIONS(3846),
    [anon_sym_RBRACE] = ACTIONS(3846),
    [anon_sym_signed] = ACTIONS(3844),
    [anon_sym_unsigned] = ACTIONS(3844),
    [anon_sym_long] = ACTIONS(3844),
    [anon_sym_short] = ACTIONS(3844),
    [anon_sym_LBRACK] = ACTIONS(3844),
    [anon_sym_static] = ACTIONS(3844),
    [anon_sym_register] = ACTIONS(3844),
    [anon_sym_inline] = ACTIONS(3844),
    [anon_sym___inline] = ACTIONS(3844),
    [anon_sym___inline__] = ACTIONS(3844),
    [anon_sym___forceinline] = ACTIONS(3844),
    [anon_sym_thread_local] = ACTIONS(3844),
    [anon_sym___thread] = ACTIONS(3844),
    [anon_sym_const] = ACTIONS(3844),
    [anon_sym_constexpr] = ACTIONS(3844),
    [anon_sym_volatile] = ACTIONS(3844),
    [anon_sym_restrict] = ACTIONS(3844),
    [anon_sym___restrict__] = ACTIONS(3844),
    [anon_sym__Atomic] = ACTIONS(3844),
    [anon_sym__Noreturn] = ACTIONS(3844),
    [anon_sym_noreturn] = ACTIONS(3844),
    [anon_sym_mutable] = ACTIONS(3844),
    [anon_sym_constinit] = ACTIONS(3844),
    [anon_sym_consteval] = ACTIONS(3844),
    [anon_sym_alignas] = ACTIONS(3844),
    [anon_sym__Alignas] = ACTIONS(3844),
    [sym_primitive_type] = ACTIONS(3844),
    [anon_sym_enum] = ACTIONS(3844),
    [anon_sym_class] = ACTIONS(3844),
    [anon_sym_struct] = ACTIONS(3844),
    [anon_sym_union] = ACTIONS(3844),
    [anon_sym_if] = ACTIONS(3844),
    [anon_sym_switch] = ACTIONS(3844),
    [anon_sym_case] = ACTIONS(3844),
    [anon_sym_default] = ACTIONS(3844),
    [anon_sym_while] = ACTIONS(3844),
    [anon_sym_do] = ACTIONS(3844),
    [anon_sym_for] = ACTIONS(3844),
    [anon_sym_return] = ACTIONS(3844),
    [anon_sym_break] = ACTIONS(3844),
    [anon_sym_continue] = ACTIONS(3844),
    [anon_sym_goto] = ACTIONS(3844),
    [anon_sym___try] = ACTIONS(3844),
    [anon_sym___leave] = ACTIONS(3844),
    [anon_sym_not] = ACTIONS(3844),
    [anon_sym_compl] = ACTIONS(3844),
    [anon_sym_DASH_DASH] = ACTIONS(3846),
    [anon_sym_PLUS_PLUS] = ACTIONS(3846),
    [anon_sym_sizeof] = ACTIONS(3844),
    [anon_sym___alignof__] = ACTIONS(3844),
    [anon_sym___alignof] = ACTIONS(3844),
    [anon_sym__alignof] = ACTIONS(3844),
    [anon_sym_alignof] = ACTIONS(3844),
    [anon_sym__Alignof] = ACTIONS(3844),
    [anon_sym_offsetof] = ACTIONS(3844),
    [anon_sym__Generic] = ACTIONS(3844),
    [anon_sym_asm] = ACTIONS(3844),
    [anon_sym___asm__] = ACTIONS(3844),
    [anon_sym_DOT] = ACTIONS(3844),
    [sym_number_literal] = ACTIONS(3846),
    [anon_sym_L_SQUOTE] = ACTIONS(3846),
    [anon_sym_u_SQUOTE] = ACTIONS(3846),
    [anon_sym_U_SQUOTE] = ACTIONS(3846),
    [anon_sym_u8_SQUOTE] = ACTIONS(3846),
    [anon_sym_SQUOTE] = ACTIONS(3846),
    [anon_sym_L_DQUOTE] = ACTIONS(3846),
    [anon_sym_u_DQUOTE] = ACTIONS(3846),
    [anon_sym_U_DQUOTE] = ACTIONS(3846),
    [anon_sym_u8_DQUOTE] = ACTIONS(3846),
    [anon_sym_DQUOTE] = ACTIONS(3846),
    [sym_true] = ACTIONS(3844),
    [sym_false] = ACTIONS(3844),
    [anon_sym_NULL] = ACTIONS(3844),
    [anon_sym_nullptr] = ACTIONS(3844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3844),
    [anon_sym_let] = ACTIONS(3844),
    [anon_sym_This] = ACTIONS(3844),
    [anon_sym_decltype] = ACTIONS(3844),
    [sym_virtual] = ACTIONS(3844),
    [anon_sym_explicit] = ACTIONS(3844),
    [anon_sym_typename] = ACTIONS(3844),
    [anon_sym_template] = ACTIONS(3844),
    [anon_sym_operator] = ACTIONS(3844),
    [anon_sym_try] = ACTIONS(3844),
    [anon_sym_delete] = ACTIONS(3844),
    [anon_sym_throw] = ACTIONS(3844),
    [anon_sym_namespace] = ACTIONS(3844),
    [anon_sym_using] = ACTIONS(3844),
    [anon_sym_static_assert] = ACTIONS(3844),
    [anon_sym_concept] = ACTIONS(3844),
    [anon_sym_co_return] = ACTIONS(3844),
    [anon_sym_co_yield] = ACTIONS(3844),
    [anon_sym_R_DQUOTE] = ACTIONS(3846),
    [anon_sym_LR_DQUOTE] = ACTIONS(3846),
    [anon_sym_uR_DQUOTE] = ACTIONS(3846),
    [anon_sym_UR_DQUOTE] = ACTIONS(3846),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3846),
    [anon_sym_co_await] = ACTIONS(3844),
    [anon_sym_new] = ACTIONS(3844),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3844),
    [anon_sym_discard] = ACTIONS(3844),
    [anon_sym_precise] = ACTIONS(3844),
    [anon_sym_shared] = ACTIONS(3844),
    [anon_sym_groupshared] = ACTIONS(3844),
    [anon_sym_uniform] = ACTIONS(3844),
    [anon_sym_row_major] = ACTIONS(3844),
    [anon_sym_column_major] = ACTIONS(3844),
    [anon_sym_globallycoherent] = ACTIONS(3844),
    [anon_sym_centroid] = ACTIONS(3844),
    [anon_sym_noperspective] = ACTIONS(3844),
    [anon_sym_nointerpolation] = ACTIONS(3844),
    [anon_sym_sample] = ACTIONS(3844),
    [anon_sym_linear] = ACTIONS(3844),
    [anon_sym_snorm] = ACTIONS(3844),
    [anon_sym_unorm] = ACTIONS(3844),
    [anon_sym_point] = ACTIONS(3844),
    [anon_sym_line] = ACTIONS(3844),
    [anon_sym_triangleadj] = ACTIONS(3844),
    [anon_sym_lineadj] = ACTIONS(3844),
    [anon_sym_triangle] = ACTIONS(3844),
    [anon_sym_cbuffer] = ACTIONS(3844),
    [anon_sym_interface] = ACTIONS(3844),
    [anon_sym_extension] = ACTIONS(3844),
  },
  [708] = {
    [sym_identifier] = ACTIONS(3374),
    [aux_sym_preproc_include_token1] = ACTIONS(3374),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3374),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3374),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3374),
    [sym_preproc_directive] = ACTIONS(3374),
    [anon_sym_LPAREN2] = ACTIONS(3376),
    [anon_sym_BANG] = ACTIONS(3376),
    [anon_sym_TILDE] = ACTIONS(3376),
    [anon_sym_DASH] = ACTIONS(3374),
    [anon_sym_PLUS] = ACTIONS(3374),
    [anon_sym_STAR] = ACTIONS(3376),
    [anon_sym_AMP_AMP] = ACTIONS(3376),
    [anon_sym_AMP] = ACTIONS(3374),
    [anon_sym_SEMI] = ACTIONS(3376),
    [anon_sym___extension__] = ACTIONS(3374),
    [anon_sym_typedef] = ACTIONS(3374),
    [anon_sym_in] = ACTIONS(3374),
    [anon_sym_out] = ACTIONS(3374),
    [anon_sym_inout] = ACTIONS(3374),
    [anon_sym_extern] = ACTIONS(3374),
    [anon_sym___attribute__] = ACTIONS(3374),
    [anon_sym_COLON_COLON] = ACTIONS(3376),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3376),
    [anon_sym___declspec] = ACTIONS(3374),
    [anon_sym___based] = ACTIONS(3374),
    [anon_sym___cdecl] = ACTIONS(3374),
    [anon_sym___clrcall] = ACTIONS(3374),
    [anon_sym___stdcall] = ACTIONS(3374),
    [anon_sym___fastcall] = ACTIONS(3374),
    [anon_sym___thiscall] = ACTIONS(3374),
    [anon_sym___vectorcall] = ACTIONS(3374),
    [anon_sym_LBRACE] = ACTIONS(3376),
    [anon_sym_RBRACE] = ACTIONS(3376),
    [anon_sym_signed] = ACTIONS(3374),
    [anon_sym_unsigned] = ACTIONS(3374),
    [anon_sym_long] = ACTIONS(3374),
    [anon_sym_short] = ACTIONS(3374),
    [anon_sym_LBRACK] = ACTIONS(3374),
    [anon_sym_static] = ACTIONS(3374),
    [anon_sym_register] = ACTIONS(3374),
    [anon_sym_inline] = ACTIONS(3374),
    [anon_sym___inline] = ACTIONS(3374),
    [anon_sym___inline__] = ACTIONS(3374),
    [anon_sym___forceinline] = ACTIONS(3374),
    [anon_sym_thread_local] = ACTIONS(3374),
    [anon_sym___thread] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3374),
    [anon_sym_constexpr] = ACTIONS(3374),
    [anon_sym_volatile] = ACTIONS(3374),
    [anon_sym_restrict] = ACTIONS(3374),
    [anon_sym___restrict__] = ACTIONS(3374),
    [anon_sym__Atomic] = ACTIONS(3374),
    [anon_sym__Noreturn] = ACTIONS(3374),
    [anon_sym_noreturn] = ACTIONS(3374),
    [anon_sym_mutable] = ACTIONS(3374),
    [anon_sym_constinit] = ACTIONS(3374),
    [anon_sym_consteval] = ACTIONS(3374),
    [anon_sym_alignas] = ACTIONS(3374),
    [anon_sym__Alignas] = ACTIONS(3374),
    [sym_primitive_type] = ACTIONS(3374),
    [anon_sym_enum] = ACTIONS(3374),
    [anon_sym_class] = ACTIONS(3374),
    [anon_sym_struct] = ACTIONS(3374),
    [anon_sym_union] = ACTIONS(3374),
    [anon_sym_if] = ACTIONS(3374),
    [anon_sym_else] = ACTIONS(3374),
    [anon_sym_switch] = ACTIONS(3374),
    [anon_sym_case] = ACTIONS(3374),
    [anon_sym_default] = ACTIONS(3374),
    [anon_sym_while] = ACTIONS(3374),
    [anon_sym_do] = ACTIONS(3374),
    [anon_sym_for] = ACTIONS(3374),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_break] = ACTIONS(3374),
    [anon_sym_continue] = ACTIONS(3374),
    [anon_sym_goto] = ACTIONS(3374),
    [anon_sym___try] = ACTIONS(3374),
    [anon_sym___leave] = ACTIONS(3374),
    [anon_sym_not] = ACTIONS(3374),
    [anon_sym_compl] = ACTIONS(3374),
    [anon_sym_DASH_DASH] = ACTIONS(3376),
    [anon_sym_PLUS_PLUS] = ACTIONS(3376),
    [anon_sym_sizeof] = ACTIONS(3374),
    [anon_sym___alignof__] = ACTIONS(3374),
    [anon_sym___alignof] = ACTIONS(3374),
    [anon_sym__alignof] = ACTIONS(3374),
    [anon_sym_alignof] = ACTIONS(3374),
    [anon_sym__Alignof] = ACTIONS(3374),
    [anon_sym_offsetof] = ACTIONS(3374),
    [anon_sym__Generic] = ACTIONS(3374),
    [anon_sym_asm] = ACTIONS(3374),
    [anon_sym___asm__] = ACTIONS(3374),
    [sym_number_literal] = ACTIONS(3376),
    [anon_sym_L_SQUOTE] = ACTIONS(3376),
    [anon_sym_u_SQUOTE] = ACTIONS(3376),
    [anon_sym_U_SQUOTE] = ACTIONS(3376),
    [anon_sym_u8_SQUOTE] = ACTIONS(3376),
    [anon_sym_SQUOTE] = ACTIONS(3376),
    [anon_sym_L_DQUOTE] = ACTIONS(3376),
    [anon_sym_u_DQUOTE] = ACTIONS(3376),
    [anon_sym_U_DQUOTE] = ACTIONS(3376),
    [anon_sym_u8_DQUOTE] = ACTIONS(3376),
    [anon_sym_DQUOTE] = ACTIONS(3376),
    [sym_true] = ACTIONS(3374),
    [sym_false] = ACTIONS(3374),
    [anon_sym_NULL] = ACTIONS(3374),
    [anon_sym_nullptr] = ACTIONS(3374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3374),
    [anon_sym_let] = ACTIONS(3374),
    [anon_sym_This] = ACTIONS(3374),
    [anon_sym_decltype] = ACTIONS(3374),
    [sym_virtual] = ACTIONS(3374),
    [anon_sym_explicit] = ACTIONS(3374),
    [anon_sym_typename] = ACTIONS(3374),
    [anon_sym_template] = ACTIONS(3374),
    [anon_sym_operator] = ACTIONS(3374),
    [anon_sym_try] = ACTIONS(3374),
    [anon_sym_delete] = ACTIONS(3374),
    [anon_sym_throw] = ACTIONS(3374),
    [anon_sym_namespace] = ACTIONS(3374),
    [anon_sym_using] = ACTIONS(3374),
    [anon_sym_static_assert] = ACTIONS(3374),
    [anon_sym_concept] = ACTIONS(3374),
    [anon_sym_co_return] = ACTIONS(3374),
    [anon_sym_co_yield] = ACTIONS(3374),
    [anon_sym_R_DQUOTE] = ACTIONS(3376),
    [anon_sym_LR_DQUOTE] = ACTIONS(3376),
    [anon_sym_uR_DQUOTE] = ACTIONS(3376),
    [anon_sym_UR_DQUOTE] = ACTIONS(3376),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3376),
    [anon_sym_co_await] = ACTIONS(3374),
    [anon_sym_new] = ACTIONS(3374),
    [anon_sym_requires] = ACTIONS(3374),
    [sym_this] = ACTIONS(3374),
    [anon_sym_discard] = ACTIONS(3374),
    [anon_sym_precise] = ACTIONS(3374),
    [anon_sym_shared] = ACTIONS(3374),
    [anon_sym_groupshared] = ACTIONS(3374),
    [anon_sym_uniform] = ACTIONS(3374),
    [anon_sym_row_major] = ACTIONS(3374),
    [anon_sym_column_major] = ACTIONS(3374),
    [anon_sym_globallycoherent] = ACTIONS(3374),
    [anon_sym_centroid] = ACTIONS(3374),
    [anon_sym_noperspective] = ACTIONS(3374),
    [anon_sym_nointerpolation] = ACTIONS(3374),
    [anon_sym_sample] = ACTIONS(3374),
    [anon_sym_linear] = ACTIONS(3374),
    [anon_sym_snorm] = ACTIONS(3374),
    [anon_sym_unorm] = ACTIONS(3374),
    [anon_sym_point] = ACTIONS(3374),
    [anon_sym_line] = ACTIONS(3374),
    [anon_sym_triangleadj] = ACTIONS(3374),
    [anon_sym_lineadj] = ACTIONS(3374),
    [anon_sym_triangle] = ACTIONS(3374),
    [anon_sym_cbuffer] = ACTIONS(3374),
    [anon_sym_interface] = ACTIONS(3374),
    [anon_sym_extension] = ACTIONS(3374),
  },
  [709] = {
    [sym_identifier] = ACTIONS(3368),
    [aux_sym_preproc_include_token1] = ACTIONS(3368),
    [aux_sym_preproc_def_token1] = ACTIONS(3368),
    [aux_sym_preproc_if_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3368),
    [sym_preproc_directive] = ACTIONS(3368),
    [anon_sym_LPAREN2] = ACTIONS(3370),
    [anon_sym_BANG] = ACTIONS(3370),
    [anon_sym_TILDE] = ACTIONS(3370),
    [anon_sym_DASH] = ACTIONS(3368),
    [anon_sym_PLUS] = ACTIONS(3368),
    [anon_sym_STAR] = ACTIONS(3370),
    [anon_sym_AMP_AMP] = ACTIONS(3370),
    [anon_sym_AMP] = ACTIONS(3368),
    [anon_sym_SEMI] = ACTIONS(3370),
    [anon_sym___extension__] = ACTIONS(3368),
    [anon_sym_typedef] = ACTIONS(3368),
    [anon_sym_in] = ACTIONS(3368),
    [anon_sym_out] = ACTIONS(3368),
    [anon_sym_inout] = ACTIONS(3368),
    [anon_sym_extern] = ACTIONS(3368),
    [anon_sym___attribute__] = ACTIONS(3368),
    [anon_sym_COLON_COLON] = ACTIONS(3370),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3370),
    [anon_sym___declspec] = ACTIONS(3368),
    [anon_sym___based] = ACTIONS(3368),
    [anon_sym___cdecl] = ACTIONS(3368),
    [anon_sym___clrcall] = ACTIONS(3368),
    [anon_sym___stdcall] = ACTIONS(3368),
    [anon_sym___fastcall] = ACTIONS(3368),
    [anon_sym___thiscall] = ACTIONS(3368),
    [anon_sym___vectorcall] = ACTIONS(3368),
    [anon_sym_LBRACE] = ACTIONS(3370),
    [anon_sym_RBRACE] = ACTIONS(3370),
    [anon_sym_signed] = ACTIONS(3368),
    [anon_sym_unsigned] = ACTIONS(3368),
    [anon_sym_long] = ACTIONS(3368),
    [anon_sym_short] = ACTIONS(3368),
    [anon_sym_LBRACK] = ACTIONS(3368),
    [anon_sym_static] = ACTIONS(3368),
    [anon_sym_register] = ACTIONS(3368),
    [anon_sym_inline] = ACTIONS(3368),
    [anon_sym___inline] = ACTIONS(3368),
    [anon_sym___inline__] = ACTIONS(3368),
    [anon_sym___forceinline] = ACTIONS(3368),
    [anon_sym_thread_local] = ACTIONS(3368),
    [anon_sym___thread] = ACTIONS(3368),
    [anon_sym_const] = ACTIONS(3368),
    [anon_sym_constexpr] = ACTIONS(3368),
    [anon_sym_volatile] = ACTIONS(3368),
    [anon_sym_restrict] = ACTIONS(3368),
    [anon_sym___restrict__] = ACTIONS(3368),
    [anon_sym__Atomic] = ACTIONS(3368),
    [anon_sym__Noreturn] = ACTIONS(3368),
    [anon_sym_noreturn] = ACTIONS(3368),
    [anon_sym_mutable] = ACTIONS(3368),
    [anon_sym_constinit] = ACTIONS(3368),
    [anon_sym_consteval] = ACTIONS(3368),
    [anon_sym_alignas] = ACTIONS(3368),
    [anon_sym__Alignas] = ACTIONS(3368),
    [sym_primitive_type] = ACTIONS(3368),
    [anon_sym_enum] = ACTIONS(3368),
    [anon_sym_class] = ACTIONS(3368),
    [anon_sym_struct] = ACTIONS(3368),
    [anon_sym_union] = ACTIONS(3368),
    [anon_sym_if] = ACTIONS(3368),
    [anon_sym_else] = ACTIONS(3368),
    [anon_sym_switch] = ACTIONS(3368),
    [anon_sym_case] = ACTIONS(3368),
    [anon_sym_default] = ACTIONS(3368),
    [anon_sym_while] = ACTIONS(3368),
    [anon_sym_do] = ACTIONS(3368),
    [anon_sym_for] = ACTIONS(3368),
    [anon_sym_return] = ACTIONS(3368),
    [anon_sym_break] = ACTIONS(3368),
    [anon_sym_continue] = ACTIONS(3368),
    [anon_sym_goto] = ACTIONS(3368),
    [anon_sym___try] = ACTIONS(3368),
    [anon_sym___leave] = ACTIONS(3368),
    [anon_sym_not] = ACTIONS(3368),
    [anon_sym_compl] = ACTIONS(3368),
    [anon_sym_DASH_DASH] = ACTIONS(3370),
    [anon_sym_PLUS_PLUS] = ACTIONS(3370),
    [anon_sym_sizeof] = ACTIONS(3368),
    [anon_sym___alignof__] = ACTIONS(3368),
    [anon_sym___alignof] = ACTIONS(3368),
    [anon_sym__alignof] = ACTIONS(3368),
    [anon_sym_alignof] = ACTIONS(3368),
    [anon_sym__Alignof] = ACTIONS(3368),
    [anon_sym_offsetof] = ACTIONS(3368),
    [anon_sym__Generic] = ACTIONS(3368),
    [anon_sym_asm] = ACTIONS(3368),
    [anon_sym___asm__] = ACTIONS(3368),
    [sym_number_literal] = ACTIONS(3370),
    [anon_sym_L_SQUOTE] = ACTIONS(3370),
    [anon_sym_u_SQUOTE] = ACTIONS(3370),
    [anon_sym_U_SQUOTE] = ACTIONS(3370),
    [anon_sym_u8_SQUOTE] = ACTIONS(3370),
    [anon_sym_SQUOTE] = ACTIONS(3370),
    [anon_sym_L_DQUOTE] = ACTIONS(3370),
    [anon_sym_u_DQUOTE] = ACTIONS(3370),
    [anon_sym_U_DQUOTE] = ACTIONS(3370),
    [anon_sym_u8_DQUOTE] = ACTIONS(3370),
    [anon_sym_DQUOTE] = ACTIONS(3370),
    [sym_true] = ACTIONS(3368),
    [sym_false] = ACTIONS(3368),
    [anon_sym_NULL] = ACTIONS(3368),
    [anon_sym_nullptr] = ACTIONS(3368),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3368),
    [anon_sym_let] = ACTIONS(3368),
    [anon_sym_This] = ACTIONS(3368),
    [anon_sym_decltype] = ACTIONS(3368),
    [sym_virtual] = ACTIONS(3368),
    [anon_sym_explicit] = ACTIONS(3368),
    [anon_sym_typename] = ACTIONS(3368),
    [anon_sym_template] = ACTIONS(3368),
    [anon_sym_operator] = ACTIONS(3368),
    [anon_sym_try] = ACTIONS(3368),
    [anon_sym_delete] = ACTIONS(3368),
    [anon_sym_throw] = ACTIONS(3368),
    [anon_sym_namespace] = ACTIONS(3368),
    [anon_sym_using] = ACTIONS(3368),
    [anon_sym_static_assert] = ACTIONS(3368),
    [anon_sym_concept] = ACTIONS(3368),
    [anon_sym_co_return] = ACTIONS(3368),
    [anon_sym_co_yield] = ACTIONS(3368),
    [anon_sym_R_DQUOTE] = ACTIONS(3370),
    [anon_sym_LR_DQUOTE] = ACTIONS(3370),
    [anon_sym_uR_DQUOTE] = ACTIONS(3370),
    [anon_sym_UR_DQUOTE] = ACTIONS(3370),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3370),
    [anon_sym_co_await] = ACTIONS(3368),
    [anon_sym_new] = ACTIONS(3368),
    [anon_sym_requires] = ACTIONS(3368),
    [sym_this] = ACTIONS(3368),
    [anon_sym_discard] = ACTIONS(3368),
    [anon_sym_precise] = ACTIONS(3368),
    [anon_sym_shared] = ACTIONS(3368),
    [anon_sym_groupshared] = ACTIONS(3368),
    [anon_sym_uniform] = ACTIONS(3368),
    [anon_sym_row_major] = ACTIONS(3368),
    [anon_sym_column_major] = ACTIONS(3368),
    [anon_sym_globallycoherent] = ACTIONS(3368),
    [anon_sym_centroid] = ACTIONS(3368),
    [anon_sym_noperspective] = ACTIONS(3368),
    [anon_sym_nointerpolation] = ACTIONS(3368),
    [anon_sym_sample] = ACTIONS(3368),
    [anon_sym_linear] = ACTIONS(3368),
    [anon_sym_snorm] = ACTIONS(3368),
    [anon_sym_unorm] = ACTIONS(3368),
    [anon_sym_point] = ACTIONS(3368),
    [anon_sym_line] = ACTIONS(3368),
    [anon_sym_triangleadj] = ACTIONS(3368),
    [anon_sym_lineadj] = ACTIONS(3368),
    [anon_sym_triangle] = ACTIONS(3368),
    [anon_sym_cbuffer] = ACTIONS(3368),
    [anon_sym_interface] = ACTIONS(3368),
    [anon_sym_extension] = ACTIONS(3368),
  },
  [710] = {
    [sym_identifier] = ACTIONS(2972),
    [aux_sym_preproc_include_token1] = ACTIONS(2972),
    [aux_sym_preproc_def_token1] = ACTIONS(2972),
    [aux_sym_preproc_if_token1] = ACTIONS(2972),
    [aux_sym_preproc_if_token2] = ACTIONS(2972),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2972),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2972),
    [sym_preproc_directive] = ACTIONS(2972),
    [anon_sym_LPAREN2] = ACTIONS(2974),
    [anon_sym_BANG] = ACTIONS(2974),
    [anon_sym_TILDE] = ACTIONS(2974),
    [anon_sym_DASH] = ACTIONS(2972),
    [anon_sym_PLUS] = ACTIONS(2972),
    [anon_sym_STAR] = ACTIONS(2974),
    [anon_sym_AMP_AMP] = ACTIONS(2974),
    [anon_sym_AMP] = ACTIONS(2972),
    [anon_sym_SEMI] = ACTIONS(2974),
    [anon_sym___extension__] = ACTIONS(2972),
    [anon_sym_typedef] = ACTIONS(2972),
    [anon_sym_in] = ACTIONS(2972),
    [anon_sym_out] = ACTIONS(2972),
    [anon_sym_inout] = ACTIONS(2972),
    [anon_sym_extern] = ACTIONS(2972),
    [anon_sym___attribute__] = ACTIONS(2972),
    [anon_sym_COLON_COLON] = ACTIONS(2974),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2974),
    [anon_sym___declspec] = ACTIONS(2972),
    [anon_sym___based] = ACTIONS(2972),
    [anon_sym___cdecl] = ACTIONS(2972),
    [anon_sym___clrcall] = ACTIONS(2972),
    [anon_sym___stdcall] = ACTIONS(2972),
    [anon_sym___fastcall] = ACTIONS(2972),
    [anon_sym___thiscall] = ACTIONS(2972),
    [anon_sym___vectorcall] = ACTIONS(2972),
    [anon_sym_LBRACE] = ACTIONS(2974),
    [anon_sym_signed] = ACTIONS(2972),
    [anon_sym_unsigned] = ACTIONS(2972),
    [anon_sym_long] = ACTIONS(2972),
    [anon_sym_short] = ACTIONS(2972),
    [anon_sym_LBRACK] = ACTIONS(2972),
    [anon_sym_static] = ACTIONS(2972),
    [anon_sym_register] = ACTIONS(2972),
    [anon_sym_inline] = ACTIONS(2972),
    [anon_sym___inline] = ACTIONS(2972),
    [anon_sym___inline__] = ACTIONS(2972),
    [anon_sym___forceinline] = ACTIONS(2972),
    [anon_sym_thread_local] = ACTIONS(2972),
    [anon_sym___thread] = ACTIONS(2972),
    [anon_sym_const] = ACTIONS(2972),
    [anon_sym_constexpr] = ACTIONS(2972),
    [anon_sym_volatile] = ACTIONS(2972),
    [anon_sym_restrict] = ACTIONS(2972),
    [anon_sym___restrict__] = ACTIONS(2972),
    [anon_sym__Atomic] = ACTIONS(2972),
    [anon_sym__Noreturn] = ACTIONS(2972),
    [anon_sym_noreturn] = ACTIONS(2972),
    [anon_sym_mutable] = ACTIONS(2972),
    [anon_sym_constinit] = ACTIONS(2972),
    [anon_sym_consteval] = ACTIONS(2972),
    [anon_sym_alignas] = ACTIONS(2972),
    [anon_sym__Alignas] = ACTIONS(2972),
    [sym_primitive_type] = ACTIONS(2972),
    [anon_sym_enum] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(2972),
    [anon_sym_struct] = ACTIONS(2972),
    [anon_sym_union] = ACTIONS(2972),
    [anon_sym_if] = ACTIONS(2972),
    [anon_sym_else] = ACTIONS(2972),
    [anon_sym_switch] = ACTIONS(2972),
    [anon_sym_case] = ACTIONS(2972),
    [anon_sym_default] = ACTIONS(2972),
    [anon_sym_while] = ACTIONS(2972),
    [anon_sym_do] = ACTIONS(2972),
    [anon_sym_for] = ACTIONS(2972),
    [anon_sym_return] = ACTIONS(2972),
    [anon_sym_break] = ACTIONS(2972),
    [anon_sym_continue] = ACTIONS(2972),
    [anon_sym_goto] = ACTIONS(2972),
    [anon_sym___try] = ACTIONS(2972),
    [anon_sym___leave] = ACTIONS(2972),
    [anon_sym_not] = ACTIONS(2972),
    [anon_sym_compl] = ACTIONS(2972),
    [anon_sym_DASH_DASH] = ACTIONS(2974),
    [anon_sym_PLUS_PLUS] = ACTIONS(2974),
    [anon_sym_sizeof] = ACTIONS(2972),
    [anon_sym___alignof__] = ACTIONS(2972),
    [anon_sym___alignof] = ACTIONS(2972),
    [anon_sym__alignof] = ACTIONS(2972),
    [anon_sym_alignof] = ACTIONS(2972),
    [anon_sym__Alignof] = ACTIONS(2972),
    [anon_sym_offsetof] = ACTIONS(2972),
    [anon_sym__Generic] = ACTIONS(2972),
    [anon_sym_asm] = ACTIONS(2972),
    [anon_sym___asm__] = ACTIONS(2972),
    [sym_number_literal] = ACTIONS(2974),
    [anon_sym_L_SQUOTE] = ACTIONS(2974),
    [anon_sym_u_SQUOTE] = ACTIONS(2974),
    [anon_sym_U_SQUOTE] = ACTIONS(2974),
    [anon_sym_u8_SQUOTE] = ACTIONS(2974),
    [anon_sym_SQUOTE] = ACTIONS(2974),
    [anon_sym_L_DQUOTE] = ACTIONS(2974),
    [anon_sym_u_DQUOTE] = ACTIONS(2974),
    [anon_sym_U_DQUOTE] = ACTIONS(2974),
    [anon_sym_u8_DQUOTE] = ACTIONS(2974),
    [anon_sym_DQUOTE] = ACTIONS(2974),
    [sym_true] = ACTIONS(2972),
    [sym_false] = ACTIONS(2972),
    [anon_sym_NULL] = ACTIONS(2972),
    [anon_sym_nullptr] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2972),
    [anon_sym_let] = ACTIONS(2972),
    [anon_sym_This] = ACTIONS(2972),
    [anon_sym_decltype] = ACTIONS(2972),
    [sym_virtual] = ACTIONS(2972),
    [anon_sym_explicit] = ACTIONS(2972),
    [anon_sym_typename] = ACTIONS(2972),
    [anon_sym_template] = ACTIONS(2972),
    [anon_sym_operator] = ACTIONS(2972),
    [anon_sym_try] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2972),
    [anon_sym_throw] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2972),
    [anon_sym_using] = ACTIONS(2972),
    [anon_sym_static_assert] = ACTIONS(2972),
    [anon_sym_concept] = ACTIONS(2972),
    [anon_sym_co_return] = ACTIONS(2972),
    [anon_sym_co_yield] = ACTIONS(2972),
    [anon_sym_R_DQUOTE] = ACTIONS(2974),
    [anon_sym_LR_DQUOTE] = ACTIONS(2974),
    [anon_sym_uR_DQUOTE] = ACTIONS(2974),
    [anon_sym_UR_DQUOTE] = ACTIONS(2974),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2974),
    [anon_sym_co_await] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2972),
    [anon_sym_requires] = ACTIONS(2972),
    [sym_this] = ACTIONS(2972),
    [anon_sym_discard] = ACTIONS(2972),
    [anon_sym_precise] = ACTIONS(2972),
    [anon_sym_shared] = ACTIONS(2972),
    [anon_sym_groupshared] = ACTIONS(2972),
    [anon_sym_uniform] = ACTIONS(2972),
    [anon_sym_row_major] = ACTIONS(2972),
    [anon_sym_column_major] = ACTIONS(2972),
    [anon_sym_globallycoherent] = ACTIONS(2972),
    [anon_sym_centroid] = ACTIONS(2972),
    [anon_sym_noperspective] = ACTIONS(2972),
    [anon_sym_nointerpolation] = ACTIONS(2972),
    [anon_sym_sample] = ACTIONS(2972),
    [anon_sym_linear] = ACTIONS(2972),
    [anon_sym_snorm] = ACTIONS(2972),
    [anon_sym_unorm] = ACTIONS(2972),
    [anon_sym_point] = ACTIONS(2972),
    [anon_sym_line] = ACTIONS(2972),
    [anon_sym_triangleadj] = ACTIONS(2972),
    [anon_sym_lineadj] = ACTIONS(2972),
    [anon_sym_triangle] = ACTIONS(2972),
    [anon_sym_cbuffer] = ACTIONS(2972),
    [anon_sym_interface] = ACTIONS(2972),
    [anon_sym_extension] = ACTIONS(2972),
  },
  [711] = {
    [sym_identifier] = ACTIONS(2491),
    [aux_sym_preproc_include_token1] = ACTIONS(2491),
    [aux_sym_preproc_def_token1] = ACTIONS(2491),
    [aux_sym_preproc_if_token1] = ACTIONS(2491),
    [aux_sym_preproc_if_token2] = ACTIONS(2491),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2491),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2491),
    [sym_preproc_directive] = ACTIONS(2491),
    [anon_sym_LPAREN2] = ACTIONS(2489),
    [anon_sym_BANG] = ACTIONS(2489),
    [anon_sym_TILDE] = ACTIONS(2489),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(2489),
    [anon_sym_AMP_AMP] = ACTIONS(2489),
    [anon_sym_AMP] = ACTIONS(2491),
    [anon_sym_SEMI] = ACTIONS(2489),
    [anon_sym___extension__] = ACTIONS(2491),
    [anon_sym_typedef] = ACTIONS(2491),
    [anon_sym_in] = ACTIONS(2491),
    [anon_sym_out] = ACTIONS(2491),
    [anon_sym_inout] = ACTIONS(2491),
    [anon_sym_extern] = ACTIONS(2491),
    [anon_sym___attribute__] = ACTIONS(2491),
    [anon_sym_COLON_COLON] = ACTIONS(2489),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2489),
    [anon_sym___declspec] = ACTIONS(2491),
    [anon_sym___based] = ACTIONS(2491),
    [anon_sym___cdecl] = ACTIONS(2491),
    [anon_sym___clrcall] = ACTIONS(2491),
    [anon_sym___stdcall] = ACTIONS(2491),
    [anon_sym___fastcall] = ACTIONS(2491),
    [anon_sym___thiscall] = ACTIONS(2491),
    [anon_sym___vectorcall] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(2489),
    [anon_sym_signed] = ACTIONS(2491),
    [anon_sym_unsigned] = ACTIONS(2491),
    [anon_sym_long] = ACTIONS(2491),
    [anon_sym_short] = ACTIONS(2491),
    [anon_sym_LBRACK] = ACTIONS(2491),
    [anon_sym_static] = ACTIONS(2491),
    [anon_sym_register] = ACTIONS(2491),
    [anon_sym_inline] = ACTIONS(2491),
    [anon_sym___inline] = ACTIONS(2491),
    [anon_sym___inline__] = ACTIONS(2491),
    [anon_sym___forceinline] = ACTIONS(2491),
    [anon_sym_thread_local] = ACTIONS(2491),
    [anon_sym___thread] = ACTIONS(2491),
    [anon_sym_const] = ACTIONS(2491),
    [anon_sym_constexpr] = ACTIONS(2491),
    [anon_sym_volatile] = ACTIONS(2491),
    [anon_sym_restrict] = ACTIONS(2491),
    [anon_sym___restrict__] = ACTIONS(2491),
    [anon_sym__Atomic] = ACTIONS(2491),
    [anon_sym__Noreturn] = ACTIONS(2491),
    [anon_sym_noreturn] = ACTIONS(2491),
    [anon_sym_mutable] = ACTIONS(2491),
    [anon_sym_constinit] = ACTIONS(2491),
    [anon_sym_consteval] = ACTIONS(2491),
    [anon_sym_alignas] = ACTIONS(2491),
    [anon_sym__Alignas] = ACTIONS(2491),
    [sym_primitive_type] = ACTIONS(2491),
    [anon_sym_enum] = ACTIONS(2491),
    [anon_sym_class] = ACTIONS(2491),
    [anon_sym_struct] = ACTIONS(2491),
    [anon_sym_union] = ACTIONS(2491),
    [anon_sym_if] = ACTIONS(2491),
    [anon_sym_else] = ACTIONS(2491),
    [anon_sym_switch] = ACTIONS(2491),
    [anon_sym_case] = ACTIONS(2491),
    [anon_sym_default] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2491),
    [anon_sym_do] = ACTIONS(2491),
    [anon_sym_for] = ACTIONS(2491),
    [anon_sym_return] = ACTIONS(2491),
    [anon_sym_break] = ACTIONS(2491),
    [anon_sym_continue] = ACTIONS(2491),
    [anon_sym_goto] = ACTIONS(2491),
    [anon_sym___try] = ACTIONS(2491),
    [anon_sym___leave] = ACTIONS(2491),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(2489),
    [anon_sym_PLUS_PLUS] = ACTIONS(2489),
    [anon_sym_sizeof] = ACTIONS(2491),
    [anon_sym___alignof__] = ACTIONS(2491),
    [anon_sym___alignof] = ACTIONS(2491),
    [anon_sym__alignof] = ACTIONS(2491),
    [anon_sym_alignof] = ACTIONS(2491),
    [anon_sym__Alignof] = ACTIONS(2491),
    [anon_sym_offsetof] = ACTIONS(2491),
    [anon_sym__Generic] = ACTIONS(2491),
    [anon_sym_asm] = ACTIONS(2491),
    [anon_sym___asm__] = ACTIONS(2491),
    [sym_number_literal] = ACTIONS(2489),
    [anon_sym_L_SQUOTE] = ACTIONS(2489),
    [anon_sym_u_SQUOTE] = ACTIONS(2489),
    [anon_sym_U_SQUOTE] = ACTIONS(2489),
    [anon_sym_u8_SQUOTE] = ACTIONS(2489),
    [anon_sym_SQUOTE] = ACTIONS(2489),
    [anon_sym_L_DQUOTE] = ACTIONS(2489),
    [anon_sym_u_DQUOTE] = ACTIONS(2489),
    [anon_sym_U_DQUOTE] = ACTIONS(2489),
    [anon_sym_u8_DQUOTE] = ACTIONS(2489),
    [anon_sym_DQUOTE] = ACTIONS(2489),
    [sym_true] = ACTIONS(2491),
    [sym_false] = ACTIONS(2491),
    [anon_sym_NULL] = ACTIONS(2491),
    [anon_sym_nullptr] = ACTIONS(2491),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2491),
    [anon_sym_let] = ACTIONS(2491),
    [anon_sym_This] = ACTIONS(2491),
    [anon_sym_decltype] = ACTIONS(2491),
    [sym_virtual] = ACTIONS(2491),
    [anon_sym_explicit] = ACTIONS(2491),
    [anon_sym_typename] = ACTIONS(2491),
    [anon_sym_template] = ACTIONS(2491),
    [anon_sym_operator] = ACTIONS(2491),
    [anon_sym_try] = ACTIONS(2491),
    [anon_sym_delete] = ACTIONS(2491),
    [anon_sym_throw] = ACTIONS(2491),
    [anon_sym_namespace] = ACTIONS(2491),
    [anon_sym_using] = ACTIONS(2491),
    [anon_sym_static_assert] = ACTIONS(2491),
    [anon_sym_concept] = ACTIONS(2491),
    [anon_sym_co_return] = ACTIONS(2491),
    [anon_sym_co_yield] = ACTIONS(2491),
    [anon_sym_R_DQUOTE] = ACTIONS(2489),
    [anon_sym_LR_DQUOTE] = ACTIONS(2489),
    [anon_sym_uR_DQUOTE] = ACTIONS(2489),
    [anon_sym_UR_DQUOTE] = ACTIONS(2489),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2489),
    [anon_sym_co_await] = ACTIONS(2491),
    [anon_sym_new] = ACTIONS(2491),
    [anon_sym_requires] = ACTIONS(2491),
    [sym_this] = ACTIONS(2491),
    [anon_sym_discard] = ACTIONS(2491),
    [anon_sym_precise] = ACTIONS(2491),
    [anon_sym_shared] = ACTIONS(2491),
    [anon_sym_groupshared] = ACTIONS(2491),
    [anon_sym_uniform] = ACTIONS(2491),
    [anon_sym_row_major] = ACTIONS(2491),
    [anon_sym_column_major] = ACTIONS(2491),
    [anon_sym_globallycoherent] = ACTIONS(2491),
    [anon_sym_centroid] = ACTIONS(2491),
    [anon_sym_noperspective] = ACTIONS(2491),
    [anon_sym_nointerpolation] = ACTIONS(2491),
    [anon_sym_sample] = ACTIONS(2491),
    [anon_sym_linear] = ACTIONS(2491),
    [anon_sym_snorm] = ACTIONS(2491),
    [anon_sym_unorm] = ACTIONS(2491),
    [anon_sym_point] = ACTIONS(2491),
    [anon_sym_line] = ACTIONS(2491),
    [anon_sym_triangleadj] = ACTIONS(2491),
    [anon_sym_lineadj] = ACTIONS(2491),
    [anon_sym_triangle] = ACTIONS(2491),
    [anon_sym_cbuffer] = ACTIONS(2491),
    [anon_sym_interface] = ACTIONS(2491),
    [anon_sym_extension] = ACTIONS(2491),
  },
  [712] = {
    [sym_identifier] = ACTIONS(3076),
    [aux_sym_preproc_include_token1] = ACTIONS(3076),
    [aux_sym_preproc_def_token1] = ACTIONS(3076),
    [aux_sym_preproc_if_token1] = ACTIONS(3076),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3076),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3076),
    [sym_preproc_directive] = ACTIONS(3076),
    [anon_sym_LPAREN2] = ACTIONS(3078),
    [anon_sym_BANG] = ACTIONS(3078),
    [anon_sym_TILDE] = ACTIONS(3078),
    [anon_sym_DASH] = ACTIONS(3076),
    [anon_sym_PLUS] = ACTIONS(3076),
    [anon_sym_STAR] = ACTIONS(3078),
    [anon_sym_AMP_AMP] = ACTIONS(3078),
    [anon_sym_AMP] = ACTIONS(3076),
    [anon_sym_SEMI] = ACTIONS(3078),
    [anon_sym___extension__] = ACTIONS(3076),
    [anon_sym_typedef] = ACTIONS(3076),
    [anon_sym_in] = ACTIONS(3076),
    [anon_sym_out] = ACTIONS(3076),
    [anon_sym_inout] = ACTIONS(3076),
    [anon_sym_extern] = ACTIONS(3076),
    [anon_sym___attribute__] = ACTIONS(3076),
    [anon_sym_COLON_COLON] = ACTIONS(3078),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3078),
    [anon_sym___declspec] = ACTIONS(3076),
    [anon_sym___based] = ACTIONS(3076),
    [anon_sym___cdecl] = ACTIONS(3076),
    [anon_sym___clrcall] = ACTIONS(3076),
    [anon_sym___stdcall] = ACTIONS(3076),
    [anon_sym___fastcall] = ACTIONS(3076),
    [anon_sym___thiscall] = ACTIONS(3076),
    [anon_sym___vectorcall] = ACTIONS(3076),
    [anon_sym_LBRACE] = ACTIONS(3078),
    [anon_sym_RBRACE] = ACTIONS(3078),
    [anon_sym_signed] = ACTIONS(3076),
    [anon_sym_unsigned] = ACTIONS(3076),
    [anon_sym_long] = ACTIONS(3076),
    [anon_sym_short] = ACTIONS(3076),
    [anon_sym_LBRACK] = ACTIONS(3076),
    [anon_sym_static] = ACTIONS(3076),
    [anon_sym_register] = ACTIONS(3076),
    [anon_sym_inline] = ACTIONS(3076),
    [anon_sym___inline] = ACTIONS(3076),
    [anon_sym___inline__] = ACTIONS(3076),
    [anon_sym___forceinline] = ACTIONS(3076),
    [anon_sym_thread_local] = ACTIONS(3076),
    [anon_sym___thread] = ACTIONS(3076),
    [anon_sym_const] = ACTIONS(3076),
    [anon_sym_constexpr] = ACTIONS(3076),
    [anon_sym_volatile] = ACTIONS(3076),
    [anon_sym_restrict] = ACTIONS(3076),
    [anon_sym___restrict__] = ACTIONS(3076),
    [anon_sym__Atomic] = ACTIONS(3076),
    [anon_sym__Noreturn] = ACTIONS(3076),
    [anon_sym_noreturn] = ACTIONS(3076),
    [anon_sym_mutable] = ACTIONS(3076),
    [anon_sym_constinit] = ACTIONS(3076),
    [anon_sym_consteval] = ACTIONS(3076),
    [anon_sym_alignas] = ACTIONS(3076),
    [anon_sym__Alignas] = ACTIONS(3076),
    [sym_primitive_type] = ACTIONS(3076),
    [anon_sym_enum] = ACTIONS(3076),
    [anon_sym_class] = ACTIONS(3076),
    [anon_sym_struct] = ACTIONS(3076),
    [anon_sym_union] = ACTIONS(3076),
    [anon_sym_if] = ACTIONS(3076),
    [anon_sym_else] = ACTIONS(3076),
    [anon_sym_switch] = ACTIONS(3076),
    [anon_sym_case] = ACTIONS(3076),
    [anon_sym_default] = ACTIONS(3076),
    [anon_sym_while] = ACTIONS(3076),
    [anon_sym_do] = ACTIONS(3076),
    [anon_sym_for] = ACTIONS(3076),
    [anon_sym_return] = ACTIONS(3076),
    [anon_sym_break] = ACTIONS(3076),
    [anon_sym_continue] = ACTIONS(3076),
    [anon_sym_goto] = ACTIONS(3076),
    [anon_sym___try] = ACTIONS(3076),
    [anon_sym___leave] = ACTIONS(3076),
    [anon_sym_not] = ACTIONS(3076),
    [anon_sym_compl] = ACTIONS(3076),
    [anon_sym_DASH_DASH] = ACTIONS(3078),
    [anon_sym_PLUS_PLUS] = ACTIONS(3078),
    [anon_sym_sizeof] = ACTIONS(3076),
    [anon_sym___alignof__] = ACTIONS(3076),
    [anon_sym___alignof] = ACTIONS(3076),
    [anon_sym__alignof] = ACTIONS(3076),
    [anon_sym_alignof] = ACTIONS(3076),
    [anon_sym__Alignof] = ACTIONS(3076),
    [anon_sym_offsetof] = ACTIONS(3076),
    [anon_sym__Generic] = ACTIONS(3076),
    [anon_sym_asm] = ACTIONS(3076),
    [anon_sym___asm__] = ACTIONS(3076),
    [sym_number_literal] = ACTIONS(3078),
    [anon_sym_L_SQUOTE] = ACTIONS(3078),
    [anon_sym_u_SQUOTE] = ACTIONS(3078),
    [anon_sym_U_SQUOTE] = ACTIONS(3078),
    [anon_sym_u8_SQUOTE] = ACTIONS(3078),
    [anon_sym_SQUOTE] = ACTIONS(3078),
    [anon_sym_L_DQUOTE] = ACTIONS(3078),
    [anon_sym_u_DQUOTE] = ACTIONS(3078),
    [anon_sym_U_DQUOTE] = ACTIONS(3078),
    [anon_sym_u8_DQUOTE] = ACTIONS(3078),
    [anon_sym_DQUOTE] = ACTIONS(3078),
    [sym_true] = ACTIONS(3076),
    [sym_false] = ACTIONS(3076),
    [anon_sym_NULL] = ACTIONS(3076),
    [anon_sym_nullptr] = ACTIONS(3076),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3076),
    [anon_sym_let] = ACTIONS(3076),
    [anon_sym_This] = ACTIONS(3076),
    [anon_sym_decltype] = ACTIONS(3076),
    [sym_virtual] = ACTIONS(3076),
    [anon_sym_explicit] = ACTIONS(3076),
    [anon_sym_typename] = ACTIONS(3076),
    [anon_sym_template] = ACTIONS(3076),
    [anon_sym_operator] = ACTIONS(3076),
    [anon_sym_try] = ACTIONS(3076),
    [anon_sym_delete] = ACTIONS(3076),
    [anon_sym_throw] = ACTIONS(3076),
    [anon_sym_namespace] = ACTIONS(3076),
    [anon_sym_using] = ACTIONS(3076),
    [anon_sym_static_assert] = ACTIONS(3076),
    [anon_sym_concept] = ACTIONS(3076),
    [anon_sym_co_return] = ACTIONS(3076),
    [anon_sym_co_yield] = ACTIONS(3076),
    [anon_sym_R_DQUOTE] = ACTIONS(3078),
    [anon_sym_LR_DQUOTE] = ACTIONS(3078),
    [anon_sym_uR_DQUOTE] = ACTIONS(3078),
    [anon_sym_UR_DQUOTE] = ACTIONS(3078),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3078),
    [anon_sym_co_await] = ACTIONS(3076),
    [anon_sym_new] = ACTIONS(3076),
    [anon_sym_requires] = ACTIONS(3076),
    [sym_this] = ACTIONS(3076),
    [anon_sym_discard] = ACTIONS(3076),
    [anon_sym_precise] = ACTIONS(3076),
    [anon_sym_shared] = ACTIONS(3076),
    [anon_sym_groupshared] = ACTIONS(3076),
    [anon_sym_uniform] = ACTIONS(3076),
    [anon_sym_row_major] = ACTIONS(3076),
    [anon_sym_column_major] = ACTIONS(3076),
    [anon_sym_globallycoherent] = ACTIONS(3076),
    [anon_sym_centroid] = ACTIONS(3076),
    [anon_sym_noperspective] = ACTIONS(3076),
    [anon_sym_nointerpolation] = ACTIONS(3076),
    [anon_sym_sample] = ACTIONS(3076),
    [anon_sym_linear] = ACTIONS(3076),
    [anon_sym_snorm] = ACTIONS(3076),
    [anon_sym_unorm] = ACTIONS(3076),
    [anon_sym_point] = ACTIONS(3076),
    [anon_sym_line] = ACTIONS(3076),
    [anon_sym_triangleadj] = ACTIONS(3076),
    [anon_sym_lineadj] = ACTIONS(3076),
    [anon_sym_triangle] = ACTIONS(3076),
    [anon_sym_cbuffer] = ACTIONS(3076),
    [anon_sym_interface] = ACTIONS(3076),
    [anon_sym_extension] = ACTIONS(3076),
  },
  [713] = {
    [sym_identifier] = ACTIONS(2950),
    [aux_sym_preproc_include_token1] = ACTIONS(2950),
    [aux_sym_preproc_def_token1] = ACTIONS(2950),
    [aux_sym_preproc_if_token1] = ACTIONS(2950),
    [aux_sym_preproc_if_token2] = ACTIONS(2950),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2950),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2950),
    [sym_preproc_directive] = ACTIONS(2950),
    [anon_sym_LPAREN2] = ACTIONS(2952),
    [anon_sym_BANG] = ACTIONS(2952),
    [anon_sym_TILDE] = ACTIONS(2952),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_STAR] = ACTIONS(2952),
    [anon_sym_AMP_AMP] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2950),
    [anon_sym_SEMI] = ACTIONS(2952),
    [anon_sym___extension__] = ACTIONS(2950),
    [anon_sym_typedef] = ACTIONS(2950),
    [anon_sym_in] = ACTIONS(2950),
    [anon_sym_out] = ACTIONS(2950),
    [anon_sym_inout] = ACTIONS(2950),
    [anon_sym_extern] = ACTIONS(2950),
    [anon_sym___attribute__] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2952),
    [anon_sym___declspec] = ACTIONS(2950),
    [anon_sym___based] = ACTIONS(2950),
    [anon_sym___cdecl] = ACTIONS(2950),
    [anon_sym___clrcall] = ACTIONS(2950),
    [anon_sym___stdcall] = ACTIONS(2950),
    [anon_sym___fastcall] = ACTIONS(2950),
    [anon_sym___thiscall] = ACTIONS(2950),
    [anon_sym___vectorcall] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2952),
    [anon_sym_signed] = ACTIONS(2950),
    [anon_sym_unsigned] = ACTIONS(2950),
    [anon_sym_long] = ACTIONS(2950),
    [anon_sym_short] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_static] = ACTIONS(2950),
    [anon_sym_register] = ACTIONS(2950),
    [anon_sym_inline] = ACTIONS(2950),
    [anon_sym___inline] = ACTIONS(2950),
    [anon_sym___inline__] = ACTIONS(2950),
    [anon_sym___forceinline] = ACTIONS(2950),
    [anon_sym_thread_local] = ACTIONS(2950),
    [anon_sym___thread] = ACTIONS(2950),
    [anon_sym_const] = ACTIONS(2950),
    [anon_sym_constexpr] = ACTIONS(2950),
    [anon_sym_volatile] = ACTIONS(2950),
    [anon_sym_restrict] = ACTIONS(2950),
    [anon_sym___restrict__] = ACTIONS(2950),
    [anon_sym__Atomic] = ACTIONS(2950),
    [anon_sym__Noreturn] = ACTIONS(2950),
    [anon_sym_noreturn] = ACTIONS(2950),
    [anon_sym_mutable] = ACTIONS(2950),
    [anon_sym_constinit] = ACTIONS(2950),
    [anon_sym_consteval] = ACTIONS(2950),
    [anon_sym_alignas] = ACTIONS(2950),
    [anon_sym__Alignas] = ACTIONS(2950),
    [sym_primitive_type] = ACTIONS(2950),
    [anon_sym_enum] = ACTIONS(2950),
    [anon_sym_class] = ACTIONS(2950),
    [anon_sym_struct] = ACTIONS(2950),
    [anon_sym_union] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_else] = ACTIONS(2950),
    [anon_sym_switch] = ACTIONS(2950),
    [anon_sym_case] = ACTIONS(2950),
    [anon_sym_default] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_break] = ACTIONS(2950),
    [anon_sym_continue] = ACTIONS(2950),
    [anon_sym_goto] = ACTIONS(2950),
    [anon_sym___try] = ACTIONS(2950),
    [anon_sym___leave] = ACTIONS(2950),
    [anon_sym_not] = ACTIONS(2950),
    [anon_sym_compl] = ACTIONS(2950),
    [anon_sym_DASH_DASH] = ACTIONS(2952),
    [anon_sym_PLUS_PLUS] = ACTIONS(2952),
    [anon_sym_sizeof] = ACTIONS(2950),
    [anon_sym___alignof__] = ACTIONS(2950),
    [anon_sym___alignof] = ACTIONS(2950),
    [anon_sym__alignof] = ACTIONS(2950),
    [anon_sym_alignof] = ACTIONS(2950),
    [anon_sym__Alignof] = ACTIONS(2950),
    [anon_sym_offsetof] = ACTIONS(2950),
    [anon_sym__Generic] = ACTIONS(2950),
    [anon_sym_asm] = ACTIONS(2950),
    [anon_sym___asm__] = ACTIONS(2950),
    [sym_number_literal] = ACTIONS(2952),
    [anon_sym_L_SQUOTE] = ACTIONS(2952),
    [anon_sym_u_SQUOTE] = ACTIONS(2952),
    [anon_sym_U_SQUOTE] = ACTIONS(2952),
    [anon_sym_u8_SQUOTE] = ACTIONS(2952),
    [anon_sym_SQUOTE] = ACTIONS(2952),
    [anon_sym_L_DQUOTE] = ACTIONS(2952),
    [anon_sym_u_DQUOTE] = ACTIONS(2952),
    [anon_sym_U_DQUOTE] = ACTIONS(2952),
    [anon_sym_u8_DQUOTE] = ACTIONS(2952),
    [anon_sym_DQUOTE] = ACTIONS(2952),
    [sym_true] = ACTIONS(2950),
    [sym_false] = ACTIONS(2950),
    [anon_sym_NULL] = ACTIONS(2950),
    [anon_sym_nullptr] = ACTIONS(2950),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2950),
    [anon_sym_let] = ACTIONS(2950),
    [anon_sym_This] = ACTIONS(2950),
    [anon_sym_decltype] = ACTIONS(2950),
    [sym_virtual] = ACTIONS(2950),
    [anon_sym_explicit] = ACTIONS(2950),
    [anon_sym_typename] = ACTIONS(2950),
    [anon_sym_template] = ACTIONS(2950),
    [anon_sym_operator] = ACTIONS(2950),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_delete] = ACTIONS(2950),
    [anon_sym_throw] = ACTIONS(2950),
    [anon_sym_namespace] = ACTIONS(2950),
    [anon_sym_using] = ACTIONS(2950),
    [anon_sym_static_assert] = ACTIONS(2950),
    [anon_sym_concept] = ACTIONS(2950),
    [anon_sym_co_return] = ACTIONS(2950),
    [anon_sym_co_yield] = ACTIONS(2950),
    [anon_sym_R_DQUOTE] = ACTIONS(2952),
    [anon_sym_LR_DQUOTE] = ACTIONS(2952),
    [anon_sym_uR_DQUOTE] = ACTIONS(2952),
    [anon_sym_UR_DQUOTE] = ACTIONS(2952),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2952),
    [anon_sym_co_await] = ACTIONS(2950),
    [anon_sym_new] = ACTIONS(2950),
    [anon_sym_requires] = ACTIONS(2950),
    [sym_this] = ACTIONS(2950),
    [anon_sym_discard] = ACTIONS(2950),
    [anon_sym_precise] = ACTIONS(2950),
    [anon_sym_shared] = ACTIONS(2950),
    [anon_sym_groupshared] = ACTIONS(2950),
    [anon_sym_uniform] = ACTIONS(2950),
    [anon_sym_row_major] = ACTIONS(2950),
    [anon_sym_column_major] = ACTIONS(2950),
    [anon_sym_globallycoherent] = ACTIONS(2950),
    [anon_sym_centroid] = ACTIONS(2950),
    [anon_sym_noperspective] = ACTIONS(2950),
    [anon_sym_nointerpolation] = ACTIONS(2950),
    [anon_sym_sample] = ACTIONS(2950),
    [anon_sym_linear] = ACTIONS(2950),
    [anon_sym_snorm] = ACTIONS(2950),
    [anon_sym_unorm] = ACTIONS(2950),
    [anon_sym_point] = ACTIONS(2950),
    [anon_sym_line] = ACTIONS(2950),
    [anon_sym_triangleadj] = ACTIONS(2950),
    [anon_sym_lineadj] = ACTIONS(2950),
    [anon_sym_triangle] = ACTIONS(2950),
    [anon_sym_cbuffer] = ACTIONS(2950),
    [anon_sym_interface] = ACTIONS(2950),
    [anon_sym_extension] = ACTIONS(2950),
  },
  [714] = {
    [sym_identifier] = ACTIONS(3090),
    [aux_sym_preproc_include_token1] = ACTIONS(3090),
    [aux_sym_preproc_def_token1] = ACTIONS(3090),
    [aux_sym_preproc_if_token1] = ACTIONS(3090),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3090),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3090),
    [sym_preproc_directive] = ACTIONS(3090),
    [anon_sym_LPAREN2] = ACTIONS(3088),
    [anon_sym_BANG] = ACTIONS(3088),
    [anon_sym_TILDE] = ACTIONS(3088),
    [anon_sym_DASH] = ACTIONS(3090),
    [anon_sym_PLUS] = ACTIONS(3090),
    [anon_sym_STAR] = ACTIONS(3088),
    [anon_sym_AMP_AMP] = ACTIONS(3088),
    [anon_sym_AMP] = ACTIONS(3090),
    [anon_sym_SEMI] = ACTIONS(3088),
    [anon_sym___extension__] = ACTIONS(3090),
    [anon_sym_typedef] = ACTIONS(3090),
    [anon_sym_in] = ACTIONS(3090),
    [anon_sym_out] = ACTIONS(3090),
    [anon_sym_inout] = ACTIONS(3090),
    [anon_sym_extern] = ACTIONS(3090),
    [anon_sym___attribute__] = ACTIONS(3090),
    [anon_sym_COLON_COLON] = ACTIONS(3088),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3088),
    [anon_sym___declspec] = ACTIONS(3090),
    [anon_sym___based] = ACTIONS(3090),
    [anon_sym___cdecl] = ACTIONS(3090),
    [anon_sym___clrcall] = ACTIONS(3090),
    [anon_sym___stdcall] = ACTIONS(3090),
    [anon_sym___fastcall] = ACTIONS(3090),
    [anon_sym___thiscall] = ACTIONS(3090),
    [anon_sym___vectorcall] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3088),
    [anon_sym_RBRACE] = ACTIONS(3088),
    [anon_sym_signed] = ACTIONS(3090),
    [anon_sym_unsigned] = ACTIONS(3090),
    [anon_sym_long] = ACTIONS(3090),
    [anon_sym_short] = ACTIONS(3090),
    [anon_sym_LBRACK] = ACTIONS(3090),
    [anon_sym_static] = ACTIONS(3090),
    [anon_sym_register] = ACTIONS(3090),
    [anon_sym_inline] = ACTIONS(3090),
    [anon_sym___inline] = ACTIONS(3090),
    [anon_sym___inline__] = ACTIONS(3090),
    [anon_sym___forceinline] = ACTIONS(3090),
    [anon_sym_thread_local] = ACTIONS(3090),
    [anon_sym___thread] = ACTIONS(3090),
    [anon_sym_const] = ACTIONS(3090),
    [anon_sym_constexpr] = ACTIONS(3090),
    [anon_sym_volatile] = ACTIONS(3090),
    [anon_sym_restrict] = ACTIONS(3090),
    [anon_sym___restrict__] = ACTIONS(3090),
    [anon_sym__Atomic] = ACTIONS(3090),
    [anon_sym__Noreturn] = ACTIONS(3090),
    [anon_sym_noreturn] = ACTIONS(3090),
    [anon_sym_mutable] = ACTIONS(3090),
    [anon_sym_constinit] = ACTIONS(3090),
    [anon_sym_consteval] = ACTIONS(3090),
    [anon_sym_alignas] = ACTIONS(3090),
    [anon_sym__Alignas] = ACTIONS(3090),
    [sym_primitive_type] = ACTIONS(3090),
    [anon_sym_enum] = ACTIONS(3090),
    [anon_sym_class] = ACTIONS(3090),
    [anon_sym_struct] = ACTIONS(3090),
    [anon_sym_union] = ACTIONS(3090),
    [anon_sym_if] = ACTIONS(3090),
    [anon_sym_switch] = ACTIONS(3090),
    [anon_sym_case] = ACTIONS(3090),
    [anon_sym_default] = ACTIONS(3090),
    [anon_sym_while] = ACTIONS(3090),
    [anon_sym_do] = ACTIONS(3090),
    [anon_sym_for] = ACTIONS(3090),
    [anon_sym_return] = ACTIONS(3090),
    [anon_sym_break] = ACTIONS(3090),
    [anon_sym_continue] = ACTIONS(3090),
    [anon_sym_goto] = ACTIONS(3090),
    [anon_sym___try] = ACTIONS(3090),
    [anon_sym___leave] = ACTIONS(3090),
    [anon_sym_not] = ACTIONS(3090),
    [anon_sym_compl] = ACTIONS(3090),
    [anon_sym_DASH_DASH] = ACTIONS(3088),
    [anon_sym_PLUS_PLUS] = ACTIONS(3088),
    [anon_sym_sizeof] = ACTIONS(3090),
    [anon_sym___alignof__] = ACTIONS(3090),
    [anon_sym___alignof] = ACTIONS(3090),
    [anon_sym__alignof] = ACTIONS(3090),
    [anon_sym_alignof] = ACTIONS(3090),
    [anon_sym__Alignof] = ACTIONS(3090),
    [anon_sym_offsetof] = ACTIONS(3090),
    [anon_sym__Generic] = ACTIONS(3090),
    [anon_sym_asm] = ACTIONS(3090),
    [anon_sym___asm__] = ACTIONS(3090),
    [anon_sym_DOT] = ACTIONS(3090),
    [sym_number_literal] = ACTIONS(3088),
    [anon_sym_L_SQUOTE] = ACTIONS(3088),
    [anon_sym_u_SQUOTE] = ACTIONS(3088),
    [anon_sym_U_SQUOTE] = ACTIONS(3088),
    [anon_sym_u8_SQUOTE] = ACTIONS(3088),
    [anon_sym_SQUOTE] = ACTIONS(3088),
    [anon_sym_L_DQUOTE] = ACTIONS(3088),
    [anon_sym_u_DQUOTE] = ACTIONS(3088),
    [anon_sym_U_DQUOTE] = ACTIONS(3088),
    [anon_sym_u8_DQUOTE] = ACTIONS(3088),
    [anon_sym_DQUOTE] = ACTIONS(3088),
    [sym_true] = ACTIONS(3090),
    [sym_false] = ACTIONS(3090),
    [anon_sym_NULL] = ACTIONS(3090),
    [anon_sym_nullptr] = ACTIONS(3090),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3090),
    [anon_sym_let] = ACTIONS(3090),
    [anon_sym_This] = ACTIONS(3090),
    [anon_sym_decltype] = ACTIONS(3090),
    [sym_virtual] = ACTIONS(3090),
    [anon_sym_explicit] = ACTIONS(3090),
    [anon_sym_typename] = ACTIONS(3090),
    [anon_sym_template] = ACTIONS(3090),
    [anon_sym_operator] = ACTIONS(3090),
    [anon_sym_try] = ACTIONS(3090),
    [anon_sym_delete] = ACTIONS(3090),
    [anon_sym_throw] = ACTIONS(3090),
    [anon_sym_namespace] = ACTIONS(3090),
    [anon_sym_using] = ACTIONS(3090),
    [anon_sym_static_assert] = ACTIONS(3090),
    [anon_sym_concept] = ACTIONS(3090),
    [anon_sym_co_return] = ACTIONS(3090),
    [anon_sym_co_yield] = ACTIONS(3090),
    [anon_sym_R_DQUOTE] = ACTIONS(3088),
    [anon_sym_LR_DQUOTE] = ACTIONS(3088),
    [anon_sym_uR_DQUOTE] = ACTIONS(3088),
    [anon_sym_UR_DQUOTE] = ACTIONS(3088),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3088),
    [anon_sym_co_await] = ACTIONS(3090),
    [anon_sym_new] = ACTIONS(3090),
    [anon_sym_requires] = ACTIONS(3090),
    [sym_this] = ACTIONS(3090),
    [anon_sym_discard] = ACTIONS(3090),
    [anon_sym_precise] = ACTIONS(3090),
    [anon_sym_shared] = ACTIONS(3090),
    [anon_sym_groupshared] = ACTIONS(3090),
    [anon_sym_uniform] = ACTIONS(3090),
    [anon_sym_row_major] = ACTIONS(3090),
    [anon_sym_column_major] = ACTIONS(3090),
    [anon_sym_globallycoherent] = ACTIONS(3090),
    [anon_sym_centroid] = ACTIONS(3090),
    [anon_sym_noperspective] = ACTIONS(3090),
    [anon_sym_nointerpolation] = ACTIONS(3090),
    [anon_sym_sample] = ACTIONS(3090),
    [anon_sym_linear] = ACTIONS(3090),
    [anon_sym_snorm] = ACTIONS(3090),
    [anon_sym_unorm] = ACTIONS(3090),
    [anon_sym_point] = ACTIONS(3090),
    [anon_sym_line] = ACTIONS(3090),
    [anon_sym_triangleadj] = ACTIONS(3090),
    [anon_sym_lineadj] = ACTIONS(3090),
    [anon_sym_triangle] = ACTIONS(3090),
    [anon_sym_cbuffer] = ACTIONS(3090),
    [anon_sym_interface] = ACTIONS(3090),
    [anon_sym_extension] = ACTIONS(3090),
  },
  [715] = {
    [sym_identifier] = ACTIONS(2902),
    [aux_sym_preproc_include_token1] = ACTIONS(2902),
    [aux_sym_preproc_def_token1] = ACTIONS(2902),
    [aux_sym_preproc_if_token1] = ACTIONS(2902),
    [aux_sym_preproc_if_token2] = ACTIONS(2902),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2902),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2902),
    [sym_preproc_directive] = ACTIONS(2902),
    [anon_sym_LPAREN2] = ACTIONS(2904),
    [anon_sym_BANG] = ACTIONS(2904),
    [anon_sym_TILDE] = ACTIONS(2904),
    [anon_sym_DASH] = ACTIONS(2902),
    [anon_sym_PLUS] = ACTIONS(2902),
    [anon_sym_STAR] = ACTIONS(2904),
    [anon_sym_AMP_AMP] = ACTIONS(2904),
    [anon_sym_AMP] = ACTIONS(2902),
    [anon_sym_SEMI] = ACTIONS(2904),
    [anon_sym___extension__] = ACTIONS(2902),
    [anon_sym_typedef] = ACTIONS(2902),
    [anon_sym_in] = ACTIONS(2902),
    [anon_sym_out] = ACTIONS(2902),
    [anon_sym_inout] = ACTIONS(2902),
    [anon_sym_extern] = ACTIONS(2902),
    [anon_sym___attribute__] = ACTIONS(2902),
    [anon_sym_COLON_COLON] = ACTIONS(2904),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2904),
    [anon_sym___declspec] = ACTIONS(2902),
    [anon_sym___based] = ACTIONS(2902),
    [anon_sym___cdecl] = ACTIONS(2902),
    [anon_sym___clrcall] = ACTIONS(2902),
    [anon_sym___stdcall] = ACTIONS(2902),
    [anon_sym___fastcall] = ACTIONS(2902),
    [anon_sym___thiscall] = ACTIONS(2902),
    [anon_sym___vectorcall] = ACTIONS(2902),
    [anon_sym_LBRACE] = ACTIONS(2904),
    [anon_sym_signed] = ACTIONS(2902),
    [anon_sym_unsigned] = ACTIONS(2902),
    [anon_sym_long] = ACTIONS(2902),
    [anon_sym_short] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2902),
    [anon_sym_static] = ACTIONS(2902),
    [anon_sym_register] = ACTIONS(2902),
    [anon_sym_inline] = ACTIONS(2902),
    [anon_sym___inline] = ACTIONS(2902),
    [anon_sym___inline__] = ACTIONS(2902),
    [anon_sym___forceinline] = ACTIONS(2902),
    [anon_sym_thread_local] = ACTIONS(2902),
    [anon_sym___thread] = ACTIONS(2902),
    [anon_sym_const] = ACTIONS(2902),
    [anon_sym_constexpr] = ACTIONS(2902),
    [anon_sym_volatile] = ACTIONS(2902),
    [anon_sym_restrict] = ACTIONS(2902),
    [anon_sym___restrict__] = ACTIONS(2902),
    [anon_sym__Atomic] = ACTIONS(2902),
    [anon_sym__Noreturn] = ACTIONS(2902),
    [anon_sym_noreturn] = ACTIONS(2902),
    [anon_sym_mutable] = ACTIONS(2902),
    [anon_sym_constinit] = ACTIONS(2902),
    [anon_sym_consteval] = ACTIONS(2902),
    [anon_sym_alignas] = ACTIONS(2902),
    [anon_sym__Alignas] = ACTIONS(2902),
    [sym_primitive_type] = ACTIONS(2902),
    [anon_sym_enum] = ACTIONS(2902),
    [anon_sym_class] = ACTIONS(2902),
    [anon_sym_struct] = ACTIONS(2902),
    [anon_sym_union] = ACTIONS(2902),
    [anon_sym_if] = ACTIONS(2902),
    [anon_sym_else] = ACTIONS(2902),
    [anon_sym_switch] = ACTIONS(2902),
    [anon_sym_case] = ACTIONS(2902),
    [anon_sym_default] = ACTIONS(2902),
    [anon_sym_while] = ACTIONS(2902),
    [anon_sym_do] = ACTIONS(2902),
    [anon_sym_for] = ACTIONS(2902),
    [anon_sym_return] = ACTIONS(2902),
    [anon_sym_break] = ACTIONS(2902),
    [anon_sym_continue] = ACTIONS(2902),
    [anon_sym_goto] = ACTIONS(2902),
    [anon_sym___try] = ACTIONS(2902),
    [anon_sym___leave] = ACTIONS(2902),
    [anon_sym_not] = ACTIONS(2902),
    [anon_sym_compl] = ACTIONS(2902),
    [anon_sym_DASH_DASH] = ACTIONS(2904),
    [anon_sym_PLUS_PLUS] = ACTIONS(2904),
    [anon_sym_sizeof] = ACTIONS(2902),
    [anon_sym___alignof__] = ACTIONS(2902),
    [anon_sym___alignof] = ACTIONS(2902),
    [anon_sym__alignof] = ACTIONS(2902),
    [anon_sym_alignof] = ACTIONS(2902),
    [anon_sym__Alignof] = ACTIONS(2902),
    [anon_sym_offsetof] = ACTIONS(2902),
    [anon_sym__Generic] = ACTIONS(2902),
    [anon_sym_asm] = ACTIONS(2902),
    [anon_sym___asm__] = ACTIONS(2902),
    [sym_number_literal] = ACTIONS(2904),
    [anon_sym_L_SQUOTE] = ACTIONS(2904),
    [anon_sym_u_SQUOTE] = ACTIONS(2904),
    [anon_sym_U_SQUOTE] = ACTIONS(2904),
    [anon_sym_u8_SQUOTE] = ACTIONS(2904),
    [anon_sym_SQUOTE] = ACTIONS(2904),
    [anon_sym_L_DQUOTE] = ACTIONS(2904),
    [anon_sym_u_DQUOTE] = ACTIONS(2904),
    [anon_sym_U_DQUOTE] = ACTIONS(2904),
    [anon_sym_u8_DQUOTE] = ACTIONS(2904),
    [anon_sym_DQUOTE] = ACTIONS(2904),
    [sym_true] = ACTIONS(2902),
    [sym_false] = ACTIONS(2902),
    [anon_sym_NULL] = ACTIONS(2902),
    [anon_sym_nullptr] = ACTIONS(2902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2902),
    [anon_sym_let] = ACTIONS(2902),
    [anon_sym_This] = ACTIONS(2902),
    [anon_sym_decltype] = ACTIONS(2902),
    [sym_virtual] = ACTIONS(2902),
    [anon_sym_explicit] = ACTIONS(2902),
    [anon_sym_typename] = ACTIONS(2902),
    [anon_sym_template] = ACTIONS(2902),
    [anon_sym_operator] = ACTIONS(2902),
    [anon_sym_try] = ACTIONS(2902),
    [anon_sym_delete] = ACTIONS(2902),
    [anon_sym_throw] = ACTIONS(2902),
    [anon_sym_namespace] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_static_assert] = ACTIONS(2902),
    [anon_sym_concept] = ACTIONS(2902),
    [anon_sym_co_return] = ACTIONS(2902),
    [anon_sym_co_yield] = ACTIONS(2902),
    [anon_sym_R_DQUOTE] = ACTIONS(2904),
    [anon_sym_LR_DQUOTE] = ACTIONS(2904),
    [anon_sym_uR_DQUOTE] = ACTIONS(2904),
    [anon_sym_UR_DQUOTE] = ACTIONS(2904),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2904),
    [anon_sym_co_await] = ACTIONS(2902),
    [anon_sym_new] = ACTIONS(2902),
    [anon_sym_requires] = ACTIONS(2902),
    [sym_this] = ACTIONS(2902),
    [anon_sym_discard] = ACTIONS(2902),
    [anon_sym_precise] = ACTIONS(2902),
    [anon_sym_shared] = ACTIONS(2902),
    [anon_sym_groupshared] = ACTIONS(2902),
    [anon_sym_uniform] = ACTIONS(2902),
    [anon_sym_row_major] = ACTIONS(2902),
    [anon_sym_column_major] = ACTIONS(2902),
    [anon_sym_globallycoherent] = ACTIONS(2902),
    [anon_sym_centroid] = ACTIONS(2902),
    [anon_sym_noperspective] = ACTIONS(2902),
    [anon_sym_nointerpolation] = ACTIONS(2902),
    [anon_sym_sample] = ACTIONS(2902),
    [anon_sym_linear] = ACTIONS(2902),
    [anon_sym_snorm] = ACTIONS(2902),
    [anon_sym_unorm] = ACTIONS(2902),
    [anon_sym_point] = ACTIONS(2902),
    [anon_sym_line] = ACTIONS(2902),
    [anon_sym_triangleadj] = ACTIONS(2902),
    [anon_sym_lineadj] = ACTIONS(2902),
    [anon_sym_triangle] = ACTIONS(2902),
    [anon_sym_cbuffer] = ACTIONS(2902),
    [anon_sym_interface] = ACTIONS(2902),
    [anon_sym_extension] = ACTIONS(2902),
  },
  [716] = {
    [sym_identifier] = ACTIONS(3054),
    [aux_sym_preproc_include_token1] = ACTIONS(3054),
    [aux_sym_preproc_def_token1] = ACTIONS(3054),
    [aux_sym_preproc_if_token1] = ACTIONS(3054),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3054),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3054),
    [sym_preproc_directive] = ACTIONS(3054),
    [anon_sym_LPAREN2] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3052),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3054),
    [anon_sym_PLUS] = ACTIONS(3054),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3054),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym___extension__] = ACTIONS(3054),
    [anon_sym_typedef] = ACTIONS(3054),
    [anon_sym_in] = ACTIONS(3054),
    [anon_sym_out] = ACTIONS(3054),
    [anon_sym_inout] = ACTIONS(3054),
    [anon_sym_extern] = ACTIONS(3054),
    [anon_sym___attribute__] = ACTIONS(3054),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3052),
    [anon_sym___declspec] = ACTIONS(3054),
    [anon_sym___based] = ACTIONS(3054),
    [anon_sym___cdecl] = ACTIONS(3054),
    [anon_sym___clrcall] = ACTIONS(3054),
    [anon_sym___stdcall] = ACTIONS(3054),
    [anon_sym___fastcall] = ACTIONS(3054),
    [anon_sym___thiscall] = ACTIONS(3054),
    [anon_sym___vectorcall] = ACTIONS(3054),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_RBRACE] = ACTIONS(3052),
    [anon_sym_signed] = ACTIONS(3054),
    [anon_sym_unsigned] = ACTIONS(3054),
    [anon_sym_long] = ACTIONS(3054),
    [anon_sym_short] = ACTIONS(3054),
    [anon_sym_LBRACK] = ACTIONS(3054),
    [anon_sym_static] = ACTIONS(3054),
    [anon_sym_register] = ACTIONS(3054),
    [anon_sym_inline] = ACTIONS(3054),
    [anon_sym___inline] = ACTIONS(3054),
    [anon_sym___inline__] = ACTIONS(3054),
    [anon_sym___forceinline] = ACTIONS(3054),
    [anon_sym_thread_local] = ACTIONS(3054),
    [anon_sym___thread] = ACTIONS(3054),
    [anon_sym_const] = ACTIONS(3054),
    [anon_sym_constexpr] = ACTIONS(3054),
    [anon_sym_volatile] = ACTIONS(3054),
    [anon_sym_restrict] = ACTIONS(3054),
    [anon_sym___restrict__] = ACTIONS(3054),
    [anon_sym__Atomic] = ACTIONS(3054),
    [anon_sym__Noreturn] = ACTIONS(3054),
    [anon_sym_noreturn] = ACTIONS(3054),
    [anon_sym_mutable] = ACTIONS(3054),
    [anon_sym_constinit] = ACTIONS(3054),
    [anon_sym_consteval] = ACTIONS(3054),
    [anon_sym_alignas] = ACTIONS(3054),
    [anon_sym__Alignas] = ACTIONS(3054),
    [sym_primitive_type] = ACTIONS(3054),
    [anon_sym_enum] = ACTIONS(3054),
    [anon_sym_class] = ACTIONS(3054),
    [anon_sym_struct] = ACTIONS(3054),
    [anon_sym_union] = ACTIONS(3054),
    [anon_sym_if] = ACTIONS(3054),
    [anon_sym_switch] = ACTIONS(3054),
    [anon_sym_case] = ACTIONS(3054),
    [anon_sym_default] = ACTIONS(3054),
    [anon_sym_while] = ACTIONS(3054),
    [anon_sym_do] = ACTIONS(3054),
    [anon_sym_for] = ACTIONS(3054),
    [anon_sym_return] = ACTIONS(3054),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_continue] = ACTIONS(3054),
    [anon_sym_goto] = ACTIONS(3054),
    [anon_sym___try] = ACTIONS(3054),
    [anon_sym___leave] = ACTIONS(3054),
    [anon_sym_not] = ACTIONS(3054),
    [anon_sym_compl] = ACTIONS(3054),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_sizeof] = ACTIONS(3054),
    [anon_sym___alignof__] = ACTIONS(3054),
    [anon_sym___alignof] = ACTIONS(3054),
    [anon_sym__alignof] = ACTIONS(3054),
    [anon_sym_alignof] = ACTIONS(3054),
    [anon_sym__Alignof] = ACTIONS(3054),
    [anon_sym_offsetof] = ACTIONS(3054),
    [anon_sym__Generic] = ACTIONS(3054),
    [anon_sym_asm] = ACTIONS(3054),
    [anon_sym___asm__] = ACTIONS(3054),
    [anon_sym_DOT] = ACTIONS(3054),
    [sym_number_literal] = ACTIONS(3052),
    [anon_sym_L_SQUOTE] = ACTIONS(3052),
    [anon_sym_u_SQUOTE] = ACTIONS(3052),
    [anon_sym_U_SQUOTE] = ACTIONS(3052),
    [anon_sym_u8_SQUOTE] = ACTIONS(3052),
    [anon_sym_SQUOTE] = ACTIONS(3052),
    [anon_sym_L_DQUOTE] = ACTIONS(3052),
    [anon_sym_u_DQUOTE] = ACTIONS(3052),
    [anon_sym_U_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8_DQUOTE] = ACTIONS(3052),
    [anon_sym_DQUOTE] = ACTIONS(3052),
    [sym_true] = ACTIONS(3054),
    [sym_false] = ACTIONS(3054),
    [anon_sym_NULL] = ACTIONS(3054),
    [anon_sym_nullptr] = ACTIONS(3054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3054),
    [anon_sym_let] = ACTIONS(3054),
    [anon_sym_This] = ACTIONS(3054),
    [anon_sym_decltype] = ACTIONS(3054),
    [sym_virtual] = ACTIONS(3054),
    [anon_sym_explicit] = ACTIONS(3054),
    [anon_sym_typename] = ACTIONS(3054),
    [anon_sym_template] = ACTIONS(3054),
    [anon_sym_operator] = ACTIONS(3054),
    [anon_sym_try] = ACTIONS(3054),
    [anon_sym_delete] = ACTIONS(3054),
    [anon_sym_throw] = ACTIONS(3054),
    [anon_sym_namespace] = ACTIONS(3054),
    [anon_sym_using] = ACTIONS(3054),
    [anon_sym_static_assert] = ACTIONS(3054),
    [anon_sym_concept] = ACTIONS(3054),
    [anon_sym_co_return] = ACTIONS(3054),
    [anon_sym_co_yield] = ACTIONS(3054),
    [anon_sym_R_DQUOTE] = ACTIONS(3052),
    [anon_sym_LR_DQUOTE] = ACTIONS(3052),
    [anon_sym_uR_DQUOTE] = ACTIONS(3052),
    [anon_sym_UR_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3052),
    [anon_sym_co_await] = ACTIONS(3054),
    [anon_sym_new] = ACTIONS(3054),
    [anon_sym_requires] = ACTIONS(3054),
    [sym_this] = ACTIONS(3054),
    [anon_sym_discard] = ACTIONS(3054),
    [anon_sym_precise] = ACTIONS(3054),
    [anon_sym_shared] = ACTIONS(3054),
    [anon_sym_groupshared] = ACTIONS(3054),
    [anon_sym_uniform] = ACTIONS(3054),
    [anon_sym_row_major] = ACTIONS(3054),
    [anon_sym_column_major] = ACTIONS(3054),
    [anon_sym_globallycoherent] = ACTIONS(3054),
    [anon_sym_centroid] = ACTIONS(3054),
    [anon_sym_noperspective] = ACTIONS(3054),
    [anon_sym_nointerpolation] = ACTIONS(3054),
    [anon_sym_sample] = ACTIONS(3054),
    [anon_sym_linear] = ACTIONS(3054),
    [anon_sym_snorm] = ACTIONS(3054),
    [anon_sym_unorm] = ACTIONS(3054),
    [anon_sym_point] = ACTIONS(3054),
    [anon_sym_line] = ACTIONS(3054),
    [anon_sym_triangleadj] = ACTIONS(3054),
    [anon_sym_lineadj] = ACTIONS(3054),
    [anon_sym_triangle] = ACTIONS(3054),
    [anon_sym_cbuffer] = ACTIONS(3054),
    [anon_sym_interface] = ACTIONS(3054),
    [anon_sym_extension] = ACTIONS(3054),
  },
  [717] = {
    [sym_identifier] = ACTIONS(3848),
    [aux_sym_preproc_include_token1] = ACTIONS(3848),
    [aux_sym_preproc_def_token1] = ACTIONS(3848),
    [aux_sym_preproc_if_token1] = ACTIONS(3848),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3848),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3848),
    [sym_preproc_directive] = ACTIONS(3848),
    [anon_sym_LPAREN2] = ACTIONS(3850),
    [anon_sym_BANG] = ACTIONS(3850),
    [anon_sym_TILDE] = ACTIONS(3850),
    [anon_sym_DASH] = ACTIONS(3848),
    [anon_sym_PLUS] = ACTIONS(3848),
    [anon_sym_STAR] = ACTIONS(3850),
    [anon_sym_AMP_AMP] = ACTIONS(3850),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_SEMI] = ACTIONS(3850),
    [anon_sym___extension__] = ACTIONS(3848),
    [anon_sym_typedef] = ACTIONS(3848),
    [anon_sym_in] = ACTIONS(3848),
    [anon_sym_out] = ACTIONS(3848),
    [anon_sym_inout] = ACTIONS(3848),
    [anon_sym_extern] = ACTIONS(3848),
    [anon_sym___attribute__] = ACTIONS(3848),
    [anon_sym_COLON_COLON] = ACTIONS(3850),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3850),
    [anon_sym___declspec] = ACTIONS(3848),
    [anon_sym___based] = ACTIONS(3848),
    [anon_sym___cdecl] = ACTIONS(3848),
    [anon_sym___clrcall] = ACTIONS(3848),
    [anon_sym___stdcall] = ACTIONS(3848),
    [anon_sym___fastcall] = ACTIONS(3848),
    [anon_sym___thiscall] = ACTIONS(3848),
    [anon_sym___vectorcall] = ACTIONS(3848),
    [anon_sym_LBRACE] = ACTIONS(3850),
    [anon_sym_RBRACE] = ACTIONS(3850),
    [anon_sym_signed] = ACTIONS(3848),
    [anon_sym_unsigned] = ACTIONS(3848),
    [anon_sym_long] = ACTIONS(3848),
    [anon_sym_short] = ACTIONS(3848),
    [anon_sym_LBRACK] = ACTIONS(3848),
    [anon_sym_static] = ACTIONS(3848),
    [anon_sym_register] = ACTIONS(3848),
    [anon_sym_inline] = ACTIONS(3848),
    [anon_sym___inline] = ACTIONS(3848),
    [anon_sym___inline__] = ACTIONS(3848),
    [anon_sym___forceinline] = ACTIONS(3848),
    [anon_sym_thread_local] = ACTIONS(3848),
    [anon_sym___thread] = ACTIONS(3848),
    [anon_sym_const] = ACTIONS(3848),
    [anon_sym_constexpr] = ACTIONS(3848),
    [anon_sym_volatile] = ACTIONS(3848),
    [anon_sym_restrict] = ACTIONS(3848),
    [anon_sym___restrict__] = ACTIONS(3848),
    [anon_sym__Atomic] = ACTIONS(3848),
    [anon_sym__Noreturn] = ACTIONS(3848),
    [anon_sym_noreturn] = ACTIONS(3848),
    [anon_sym_mutable] = ACTIONS(3848),
    [anon_sym_constinit] = ACTIONS(3848),
    [anon_sym_consteval] = ACTIONS(3848),
    [anon_sym_alignas] = ACTIONS(3848),
    [anon_sym__Alignas] = ACTIONS(3848),
    [sym_primitive_type] = ACTIONS(3848),
    [anon_sym_enum] = ACTIONS(3848),
    [anon_sym_class] = ACTIONS(3848),
    [anon_sym_struct] = ACTIONS(3848),
    [anon_sym_union] = ACTIONS(3848),
    [anon_sym_if] = ACTIONS(3848),
    [anon_sym_switch] = ACTIONS(3848),
    [anon_sym_case] = ACTIONS(3848),
    [anon_sym_default] = ACTIONS(3848),
    [anon_sym_while] = ACTIONS(3848),
    [anon_sym_do] = ACTIONS(3848),
    [anon_sym_for] = ACTIONS(3848),
    [anon_sym_return] = ACTIONS(3848),
    [anon_sym_break] = ACTIONS(3848),
    [anon_sym_continue] = ACTIONS(3848),
    [anon_sym_goto] = ACTIONS(3848),
    [anon_sym___try] = ACTIONS(3848),
    [anon_sym___leave] = ACTIONS(3848),
    [anon_sym_not] = ACTIONS(3848),
    [anon_sym_compl] = ACTIONS(3848),
    [anon_sym_DASH_DASH] = ACTIONS(3850),
    [anon_sym_PLUS_PLUS] = ACTIONS(3850),
    [anon_sym_sizeof] = ACTIONS(3848),
    [anon_sym___alignof__] = ACTIONS(3848),
    [anon_sym___alignof] = ACTIONS(3848),
    [anon_sym__alignof] = ACTIONS(3848),
    [anon_sym_alignof] = ACTIONS(3848),
    [anon_sym__Alignof] = ACTIONS(3848),
    [anon_sym_offsetof] = ACTIONS(3848),
    [anon_sym__Generic] = ACTIONS(3848),
    [anon_sym_asm] = ACTIONS(3848),
    [anon_sym___asm__] = ACTIONS(3848),
    [anon_sym_DOT] = ACTIONS(2527),
    [sym_number_literal] = ACTIONS(3850),
    [anon_sym_L_SQUOTE] = ACTIONS(3850),
    [anon_sym_u_SQUOTE] = ACTIONS(3850),
    [anon_sym_U_SQUOTE] = ACTIONS(3850),
    [anon_sym_u8_SQUOTE] = ACTIONS(3850),
    [anon_sym_SQUOTE] = ACTIONS(3850),
    [anon_sym_L_DQUOTE] = ACTIONS(3850),
    [anon_sym_u_DQUOTE] = ACTIONS(3850),
    [anon_sym_U_DQUOTE] = ACTIONS(3850),
    [anon_sym_u8_DQUOTE] = ACTIONS(3850),
    [anon_sym_DQUOTE] = ACTIONS(3850),
    [sym_true] = ACTIONS(3848),
    [sym_false] = ACTIONS(3848),
    [anon_sym_NULL] = ACTIONS(3848),
    [anon_sym_nullptr] = ACTIONS(3848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2529),
    [anon_sym_let] = ACTIONS(2529),
    [anon_sym_This] = ACTIONS(2529),
    [anon_sym_decltype] = ACTIONS(3848),
    [sym_virtual] = ACTIONS(3848),
    [anon_sym_explicit] = ACTIONS(3848),
    [anon_sym_typename] = ACTIONS(3848),
    [anon_sym_template] = ACTIONS(3848),
    [anon_sym_operator] = ACTIONS(3848),
    [anon_sym_try] = ACTIONS(3848),
    [anon_sym_delete] = ACTIONS(3848),
    [anon_sym_throw] = ACTIONS(3848),
    [anon_sym_namespace] = ACTIONS(3848),
    [anon_sym_using] = ACTIONS(3848),
    [anon_sym_static_assert] = ACTIONS(3848),
    [anon_sym_concept] = ACTIONS(3848),
    [anon_sym_co_return] = ACTIONS(3848),
    [anon_sym_co_yield] = ACTIONS(3848),
    [anon_sym_R_DQUOTE] = ACTIONS(3850),
    [anon_sym_LR_DQUOTE] = ACTIONS(3850),
    [anon_sym_uR_DQUOTE] = ACTIONS(3850),
    [anon_sym_UR_DQUOTE] = ACTIONS(3850),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3850),
    [anon_sym_co_await] = ACTIONS(3848),
    [anon_sym_new] = ACTIONS(3848),
    [anon_sym_requires] = ACTIONS(3848),
    [sym_this] = ACTIONS(3848),
    [anon_sym_discard] = ACTIONS(3848),
    [anon_sym_precise] = ACTIONS(3848),
    [anon_sym_shared] = ACTIONS(3848),
    [anon_sym_groupshared] = ACTIONS(3848),
    [anon_sym_uniform] = ACTIONS(3848),
    [anon_sym_row_major] = ACTIONS(3848),
    [anon_sym_column_major] = ACTIONS(3848),
    [anon_sym_globallycoherent] = ACTIONS(3848),
    [anon_sym_centroid] = ACTIONS(3848),
    [anon_sym_noperspective] = ACTIONS(3848),
    [anon_sym_nointerpolation] = ACTIONS(3848),
    [anon_sym_sample] = ACTIONS(3848),
    [anon_sym_linear] = ACTIONS(3848),
    [anon_sym_snorm] = ACTIONS(3848),
    [anon_sym_unorm] = ACTIONS(3848),
    [anon_sym_point] = ACTIONS(3848),
    [anon_sym_line] = ACTIONS(3848),
    [anon_sym_triangleadj] = ACTIONS(3848),
    [anon_sym_lineadj] = ACTIONS(3848),
    [anon_sym_triangle] = ACTIONS(3848),
    [anon_sym_cbuffer] = ACTIONS(3848),
    [anon_sym_interface] = ACTIONS(3848),
    [anon_sym_extension] = ACTIONS(3848),
  },
  [718] = {
    [sym_identifier] = ACTIONS(3392),
    [aux_sym_preproc_include_token1] = ACTIONS(3392),
    [aux_sym_preproc_def_token1] = ACTIONS(3392),
    [aux_sym_preproc_if_token1] = ACTIONS(3392),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3392),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3392),
    [sym_preproc_directive] = ACTIONS(3392),
    [anon_sym_LPAREN2] = ACTIONS(3390),
    [anon_sym_BANG] = ACTIONS(3390),
    [anon_sym_TILDE] = ACTIONS(3390),
    [anon_sym_DASH] = ACTIONS(3392),
    [anon_sym_PLUS] = ACTIONS(3392),
    [anon_sym_STAR] = ACTIONS(3390),
    [anon_sym_AMP_AMP] = ACTIONS(3390),
    [anon_sym_AMP] = ACTIONS(3392),
    [anon_sym_SEMI] = ACTIONS(3390),
    [anon_sym___extension__] = ACTIONS(3392),
    [anon_sym_typedef] = ACTIONS(3392),
    [anon_sym_in] = ACTIONS(3392),
    [anon_sym_out] = ACTIONS(3392),
    [anon_sym_inout] = ACTIONS(3392),
    [anon_sym_extern] = ACTIONS(3392),
    [anon_sym___attribute__] = ACTIONS(3392),
    [anon_sym_COLON_COLON] = ACTIONS(3390),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3390),
    [anon_sym___declspec] = ACTIONS(3392),
    [anon_sym___based] = ACTIONS(3392),
    [anon_sym___cdecl] = ACTIONS(3392),
    [anon_sym___clrcall] = ACTIONS(3392),
    [anon_sym___stdcall] = ACTIONS(3392),
    [anon_sym___fastcall] = ACTIONS(3392),
    [anon_sym___thiscall] = ACTIONS(3392),
    [anon_sym___vectorcall] = ACTIONS(3392),
    [anon_sym_LBRACE] = ACTIONS(3390),
    [anon_sym_RBRACE] = ACTIONS(3390),
    [anon_sym_signed] = ACTIONS(3392),
    [anon_sym_unsigned] = ACTIONS(3392),
    [anon_sym_long] = ACTIONS(3392),
    [anon_sym_short] = ACTIONS(3392),
    [anon_sym_LBRACK] = ACTIONS(3392),
    [anon_sym_static] = ACTIONS(3392),
    [anon_sym_register] = ACTIONS(3392),
    [anon_sym_inline] = ACTIONS(3392),
    [anon_sym___inline] = ACTIONS(3392),
    [anon_sym___inline__] = ACTIONS(3392),
    [anon_sym___forceinline] = ACTIONS(3392),
    [anon_sym_thread_local] = ACTIONS(3392),
    [anon_sym___thread] = ACTIONS(3392),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_constexpr] = ACTIONS(3392),
    [anon_sym_volatile] = ACTIONS(3392),
    [anon_sym_restrict] = ACTIONS(3392),
    [anon_sym___restrict__] = ACTIONS(3392),
    [anon_sym__Atomic] = ACTIONS(3392),
    [anon_sym__Noreturn] = ACTIONS(3392),
    [anon_sym_noreturn] = ACTIONS(3392),
    [anon_sym_mutable] = ACTIONS(3392),
    [anon_sym_constinit] = ACTIONS(3392),
    [anon_sym_consteval] = ACTIONS(3392),
    [anon_sym_alignas] = ACTIONS(3392),
    [anon_sym__Alignas] = ACTIONS(3392),
    [sym_primitive_type] = ACTIONS(3392),
    [anon_sym_enum] = ACTIONS(3392),
    [anon_sym_class] = ACTIONS(3392),
    [anon_sym_struct] = ACTIONS(3392),
    [anon_sym_union] = ACTIONS(3392),
    [anon_sym_if] = ACTIONS(3392),
    [anon_sym_switch] = ACTIONS(3392),
    [anon_sym_case] = ACTIONS(3392),
    [anon_sym_default] = ACTIONS(3392),
    [anon_sym_while] = ACTIONS(3392),
    [anon_sym_do] = ACTIONS(3392),
    [anon_sym_for] = ACTIONS(3392),
    [anon_sym_return] = ACTIONS(3392),
    [anon_sym_break] = ACTIONS(3392),
    [anon_sym_continue] = ACTIONS(3392),
    [anon_sym_goto] = ACTIONS(3392),
    [anon_sym___try] = ACTIONS(3392),
    [anon_sym___leave] = ACTIONS(3392),
    [anon_sym_not] = ACTIONS(3392),
    [anon_sym_compl] = ACTIONS(3392),
    [anon_sym_DASH_DASH] = ACTIONS(3390),
    [anon_sym_PLUS_PLUS] = ACTIONS(3390),
    [anon_sym_sizeof] = ACTIONS(3392),
    [anon_sym___alignof__] = ACTIONS(3392),
    [anon_sym___alignof] = ACTIONS(3392),
    [anon_sym__alignof] = ACTIONS(3392),
    [anon_sym_alignof] = ACTIONS(3392),
    [anon_sym__Alignof] = ACTIONS(3392),
    [anon_sym_offsetof] = ACTIONS(3392),
    [anon_sym__Generic] = ACTIONS(3392),
    [anon_sym_asm] = ACTIONS(3392),
    [anon_sym___asm__] = ACTIONS(3392),
    [anon_sym_DOT] = ACTIONS(3392),
    [sym_number_literal] = ACTIONS(3390),
    [anon_sym_L_SQUOTE] = ACTIONS(3390),
    [anon_sym_u_SQUOTE] = ACTIONS(3390),
    [anon_sym_U_SQUOTE] = ACTIONS(3390),
    [anon_sym_u8_SQUOTE] = ACTIONS(3390),
    [anon_sym_SQUOTE] = ACTIONS(3390),
    [anon_sym_L_DQUOTE] = ACTIONS(3390),
    [anon_sym_u_DQUOTE] = ACTIONS(3390),
    [anon_sym_U_DQUOTE] = ACTIONS(3390),
    [anon_sym_u8_DQUOTE] = ACTIONS(3390),
    [anon_sym_DQUOTE] = ACTIONS(3390),
    [sym_true] = ACTIONS(3392),
    [sym_false] = ACTIONS(3392),
    [anon_sym_NULL] = ACTIONS(3392),
    [anon_sym_nullptr] = ACTIONS(3392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3392),
    [anon_sym_let] = ACTIONS(3392),
    [anon_sym_This] = ACTIONS(3392),
    [anon_sym_decltype] = ACTIONS(3392),
    [sym_virtual] = ACTIONS(3392),
    [anon_sym_explicit] = ACTIONS(3392),
    [anon_sym_typename] = ACTIONS(3392),
    [anon_sym_template] = ACTIONS(3392),
    [anon_sym_operator] = ACTIONS(3392),
    [anon_sym_try] = ACTIONS(3392),
    [anon_sym_delete] = ACTIONS(3392),
    [anon_sym_throw] = ACTIONS(3392),
    [anon_sym_namespace] = ACTIONS(3392),
    [anon_sym_using] = ACTIONS(3392),
    [anon_sym_static_assert] = ACTIONS(3392),
    [anon_sym_concept] = ACTIONS(3392),
    [anon_sym_co_return] = ACTIONS(3392),
    [anon_sym_co_yield] = ACTIONS(3392),
    [anon_sym_R_DQUOTE] = ACTIONS(3390),
    [anon_sym_LR_DQUOTE] = ACTIONS(3390),
    [anon_sym_uR_DQUOTE] = ACTIONS(3390),
    [anon_sym_UR_DQUOTE] = ACTIONS(3390),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3390),
    [anon_sym_co_await] = ACTIONS(3392),
    [anon_sym_new] = ACTIONS(3392),
    [anon_sym_requires] = ACTIONS(3392),
    [sym_this] = ACTIONS(3392),
    [anon_sym_discard] = ACTIONS(3392),
    [anon_sym_precise] = ACTIONS(3392),
    [anon_sym_shared] = ACTIONS(3392),
    [anon_sym_groupshared] = ACTIONS(3392),
    [anon_sym_uniform] = ACTIONS(3392),
    [anon_sym_row_major] = ACTIONS(3392),
    [anon_sym_column_major] = ACTIONS(3392),
    [anon_sym_globallycoherent] = ACTIONS(3392),
    [anon_sym_centroid] = ACTIONS(3392),
    [anon_sym_noperspective] = ACTIONS(3392),
    [anon_sym_nointerpolation] = ACTIONS(3392),
    [anon_sym_sample] = ACTIONS(3392),
    [anon_sym_linear] = ACTIONS(3392),
    [anon_sym_snorm] = ACTIONS(3392),
    [anon_sym_unorm] = ACTIONS(3392),
    [anon_sym_point] = ACTIONS(3392),
    [anon_sym_line] = ACTIONS(3392),
    [anon_sym_triangleadj] = ACTIONS(3392),
    [anon_sym_lineadj] = ACTIONS(3392),
    [anon_sym_triangle] = ACTIONS(3392),
    [anon_sym_cbuffer] = ACTIONS(3392),
    [anon_sym_interface] = ACTIONS(3392),
    [anon_sym_extension] = ACTIONS(3392),
  },
  [719] = {
    [sym_identifier] = ACTIONS(3226),
    [aux_sym_preproc_include_token1] = ACTIONS(3226),
    [aux_sym_preproc_def_token1] = ACTIONS(3226),
    [aux_sym_preproc_if_token1] = ACTIONS(3226),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3226),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3226),
    [sym_preproc_directive] = ACTIONS(3226),
    [anon_sym_LPAREN2] = ACTIONS(3228),
    [anon_sym_BANG] = ACTIONS(3228),
    [anon_sym_TILDE] = ACTIONS(3228),
    [anon_sym_DASH] = ACTIONS(3226),
    [anon_sym_PLUS] = ACTIONS(3226),
    [anon_sym_STAR] = ACTIONS(3228),
    [anon_sym_AMP_AMP] = ACTIONS(3228),
    [anon_sym_AMP] = ACTIONS(3226),
    [anon_sym_SEMI] = ACTIONS(3228),
    [anon_sym___extension__] = ACTIONS(3226),
    [anon_sym_typedef] = ACTIONS(3226),
    [anon_sym_in] = ACTIONS(3226),
    [anon_sym_out] = ACTIONS(3226),
    [anon_sym_inout] = ACTIONS(3226),
    [anon_sym_extern] = ACTIONS(3226),
    [anon_sym___attribute__] = ACTIONS(3226),
    [anon_sym_COLON_COLON] = ACTIONS(3228),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3228),
    [anon_sym___declspec] = ACTIONS(3226),
    [anon_sym___based] = ACTIONS(3226),
    [anon_sym___cdecl] = ACTIONS(3226),
    [anon_sym___clrcall] = ACTIONS(3226),
    [anon_sym___stdcall] = ACTIONS(3226),
    [anon_sym___fastcall] = ACTIONS(3226),
    [anon_sym___thiscall] = ACTIONS(3226),
    [anon_sym___vectorcall] = ACTIONS(3226),
    [anon_sym_LBRACE] = ACTIONS(3228),
    [anon_sym_RBRACE] = ACTIONS(3228),
    [anon_sym_signed] = ACTIONS(3226),
    [anon_sym_unsigned] = ACTIONS(3226),
    [anon_sym_long] = ACTIONS(3226),
    [anon_sym_short] = ACTIONS(3226),
    [anon_sym_LBRACK] = ACTIONS(3226),
    [anon_sym_static] = ACTIONS(3226),
    [anon_sym_register] = ACTIONS(3226),
    [anon_sym_inline] = ACTIONS(3226),
    [anon_sym___inline] = ACTIONS(3226),
    [anon_sym___inline__] = ACTIONS(3226),
    [anon_sym___forceinline] = ACTIONS(3226),
    [anon_sym_thread_local] = ACTIONS(3226),
    [anon_sym___thread] = ACTIONS(3226),
    [anon_sym_const] = ACTIONS(3226),
    [anon_sym_constexpr] = ACTIONS(3226),
    [anon_sym_volatile] = ACTIONS(3226),
    [anon_sym_restrict] = ACTIONS(3226),
    [anon_sym___restrict__] = ACTIONS(3226),
    [anon_sym__Atomic] = ACTIONS(3226),
    [anon_sym__Noreturn] = ACTIONS(3226),
    [anon_sym_noreturn] = ACTIONS(3226),
    [anon_sym_mutable] = ACTIONS(3226),
    [anon_sym_constinit] = ACTIONS(3226),
    [anon_sym_consteval] = ACTIONS(3226),
    [anon_sym_alignas] = ACTIONS(3226),
    [anon_sym__Alignas] = ACTIONS(3226),
    [sym_primitive_type] = ACTIONS(3226),
    [anon_sym_enum] = ACTIONS(3226),
    [anon_sym_class] = ACTIONS(3226),
    [anon_sym_struct] = ACTIONS(3226),
    [anon_sym_union] = ACTIONS(3226),
    [anon_sym_if] = ACTIONS(3226),
    [anon_sym_else] = ACTIONS(3226),
    [anon_sym_switch] = ACTIONS(3226),
    [anon_sym_case] = ACTIONS(3226),
    [anon_sym_default] = ACTIONS(3226),
    [anon_sym_while] = ACTIONS(3226),
    [anon_sym_do] = ACTIONS(3226),
    [anon_sym_for] = ACTIONS(3226),
    [anon_sym_return] = ACTIONS(3226),
    [anon_sym_break] = ACTIONS(3226),
    [anon_sym_continue] = ACTIONS(3226),
    [anon_sym_goto] = ACTIONS(3226),
    [anon_sym___try] = ACTIONS(3226),
    [anon_sym___leave] = ACTIONS(3226),
    [anon_sym_not] = ACTIONS(3226),
    [anon_sym_compl] = ACTIONS(3226),
    [anon_sym_DASH_DASH] = ACTIONS(3228),
    [anon_sym_PLUS_PLUS] = ACTIONS(3228),
    [anon_sym_sizeof] = ACTIONS(3226),
    [anon_sym___alignof__] = ACTIONS(3226),
    [anon_sym___alignof] = ACTIONS(3226),
    [anon_sym__alignof] = ACTIONS(3226),
    [anon_sym_alignof] = ACTIONS(3226),
    [anon_sym__Alignof] = ACTIONS(3226),
    [anon_sym_offsetof] = ACTIONS(3226),
    [anon_sym__Generic] = ACTIONS(3226),
    [anon_sym_asm] = ACTIONS(3226),
    [anon_sym___asm__] = ACTIONS(3226),
    [sym_number_literal] = ACTIONS(3228),
    [anon_sym_L_SQUOTE] = ACTIONS(3228),
    [anon_sym_u_SQUOTE] = ACTIONS(3228),
    [anon_sym_U_SQUOTE] = ACTIONS(3228),
    [anon_sym_u8_SQUOTE] = ACTIONS(3228),
    [anon_sym_SQUOTE] = ACTIONS(3228),
    [anon_sym_L_DQUOTE] = ACTIONS(3228),
    [anon_sym_u_DQUOTE] = ACTIONS(3228),
    [anon_sym_U_DQUOTE] = ACTIONS(3228),
    [anon_sym_u8_DQUOTE] = ACTIONS(3228),
    [anon_sym_DQUOTE] = ACTIONS(3228),
    [sym_true] = ACTIONS(3226),
    [sym_false] = ACTIONS(3226),
    [anon_sym_NULL] = ACTIONS(3226),
    [anon_sym_nullptr] = ACTIONS(3226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3226),
    [anon_sym_let] = ACTIONS(3226),
    [anon_sym_This] = ACTIONS(3226),
    [anon_sym_decltype] = ACTIONS(3226),
    [sym_virtual] = ACTIONS(3226),
    [anon_sym_explicit] = ACTIONS(3226),
    [anon_sym_typename] = ACTIONS(3226),
    [anon_sym_template] = ACTIONS(3226),
    [anon_sym_operator] = ACTIONS(3226),
    [anon_sym_try] = ACTIONS(3226),
    [anon_sym_delete] = ACTIONS(3226),
    [anon_sym_throw] = ACTIONS(3226),
    [anon_sym_namespace] = ACTIONS(3226),
    [anon_sym_using] = ACTIONS(3226),
    [anon_sym_static_assert] = ACTIONS(3226),
    [anon_sym_concept] = ACTIONS(3226),
    [anon_sym_co_return] = ACTIONS(3226),
    [anon_sym_co_yield] = ACTIONS(3226),
    [anon_sym_R_DQUOTE] = ACTIONS(3228),
    [anon_sym_LR_DQUOTE] = ACTIONS(3228),
    [anon_sym_uR_DQUOTE] = ACTIONS(3228),
    [anon_sym_UR_DQUOTE] = ACTIONS(3228),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3228),
    [anon_sym_co_await] = ACTIONS(3226),
    [anon_sym_new] = ACTIONS(3226),
    [anon_sym_requires] = ACTIONS(3226),
    [sym_this] = ACTIONS(3226),
    [anon_sym_discard] = ACTIONS(3226),
    [anon_sym_precise] = ACTIONS(3226),
    [anon_sym_shared] = ACTIONS(3226),
    [anon_sym_groupshared] = ACTIONS(3226),
    [anon_sym_uniform] = ACTIONS(3226),
    [anon_sym_row_major] = ACTIONS(3226),
    [anon_sym_column_major] = ACTIONS(3226),
    [anon_sym_globallycoherent] = ACTIONS(3226),
    [anon_sym_centroid] = ACTIONS(3226),
    [anon_sym_noperspective] = ACTIONS(3226),
    [anon_sym_nointerpolation] = ACTIONS(3226),
    [anon_sym_sample] = ACTIONS(3226),
    [anon_sym_linear] = ACTIONS(3226),
    [anon_sym_snorm] = ACTIONS(3226),
    [anon_sym_unorm] = ACTIONS(3226),
    [anon_sym_point] = ACTIONS(3226),
    [anon_sym_line] = ACTIONS(3226),
    [anon_sym_triangleadj] = ACTIONS(3226),
    [anon_sym_lineadj] = ACTIONS(3226),
    [anon_sym_triangle] = ACTIONS(3226),
    [anon_sym_cbuffer] = ACTIONS(3226),
    [anon_sym_interface] = ACTIONS(3226),
    [anon_sym_extension] = ACTIONS(3226),
  },
  [720] = {
    [sym_identifier] = ACTIONS(3034),
    [aux_sym_preproc_include_token1] = ACTIONS(3034),
    [aux_sym_preproc_def_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token2] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_BANG] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3034),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_in] = ACTIONS(3034),
    [anon_sym_out] = ACTIONS(3034),
    [anon_sym_inout] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym___based] = ACTIONS(3034),
    [anon_sym___cdecl] = ACTIONS(3034),
    [anon_sym___clrcall] = ACTIONS(3034),
    [anon_sym___stdcall] = ACTIONS(3034),
    [anon_sym___fastcall] = ACTIONS(3034),
    [anon_sym___thiscall] = ACTIONS(3034),
    [anon_sym___vectorcall] = ACTIONS(3034),
    [anon_sym_LBRACE] = ACTIONS(3036),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [anon_sym_if] = ACTIONS(3034),
    [anon_sym_else] = ACTIONS(3034),
    [anon_sym_switch] = ACTIONS(3034),
    [anon_sym_case] = ACTIONS(3034),
    [anon_sym_default] = ACTIONS(3034),
    [anon_sym_while] = ACTIONS(3034),
    [anon_sym_do] = ACTIONS(3034),
    [anon_sym_for] = ACTIONS(3034),
    [anon_sym_return] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3034),
    [anon_sym_continue] = ACTIONS(3034),
    [anon_sym_goto] = ACTIONS(3034),
    [anon_sym___try] = ACTIONS(3034),
    [anon_sym___leave] = ACTIONS(3034),
    [anon_sym_not] = ACTIONS(3034),
    [anon_sym_compl] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_sizeof] = ACTIONS(3034),
    [anon_sym___alignof__] = ACTIONS(3034),
    [anon_sym___alignof] = ACTIONS(3034),
    [anon_sym__alignof] = ACTIONS(3034),
    [anon_sym_alignof] = ACTIONS(3034),
    [anon_sym__Alignof] = ACTIONS(3034),
    [anon_sym_offsetof] = ACTIONS(3034),
    [anon_sym__Generic] = ACTIONS(3034),
    [anon_sym_asm] = ACTIONS(3034),
    [anon_sym___asm__] = ACTIONS(3034),
    [sym_number_literal] = ACTIONS(3036),
    [anon_sym_L_SQUOTE] = ACTIONS(3036),
    [anon_sym_u_SQUOTE] = ACTIONS(3036),
    [anon_sym_U_SQUOTE] = ACTIONS(3036),
    [anon_sym_u8_SQUOTE] = ACTIONS(3036),
    [anon_sym_SQUOTE] = ACTIONS(3036),
    [anon_sym_L_DQUOTE] = ACTIONS(3036),
    [anon_sym_u_DQUOTE] = ACTIONS(3036),
    [anon_sym_U_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8_DQUOTE] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [sym_true] = ACTIONS(3034),
    [sym_false] = ACTIONS(3034),
    [anon_sym_NULL] = ACTIONS(3034),
    [anon_sym_nullptr] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_This] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [sym_virtual] = ACTIONS(3034),
    [anon_sym_explicit] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_operator] = ACTIONS(3034),
    [anon_sym_try] = ACTIONS(3034),
    [anon_sym_delete] = ACTIONS(3034),
    [anon_sym_throw] = ACTIONS(3034),
    [anon_sym_namespace] = ACTIONS(3034),
    [anon_sym_using] = ACTIONS(3034),
    [anon_sym_static_assert] = ACTIONS(3034),
    [anon_sym_concept] = ACTIONS(3034),
    [anon_sym_co_return] = ACTIONS(3034),
    [anon_sym_co_yield] = ACTIONS(3034),
    [anon_sym_R_DQUOTE] = ACTIONS(3036),
    [anon_sym_LR_DQUOTE] = ACTIONS(3036),
    [anon_sym_uR_DQUOTE] = ACTIONS(3036),
    [anon_sym_UR_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3036),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3034),
    [anon_sym_requires] = ACTIONS(3034),
    [sym_this] = ACTIONS(3034),
    [anon_sym_discard] = ACTIONS(3034),
    [anon_sym_precise] = ACTIONS(3034),
    [anon_sym_shared] = ACTIONS(3034),
    [anon_sym_groupshared] = ACTIONS(3034),
    [anon_sym_uniform] = ACTIONS(3034),
    [anon_sym_row_major] = ACTIONS(3034),
    [anon_sym_column_major] = ACTIONS(3034),
    [anon_sym_globallycoherent] = ACTIONS(3034),
    [anon_sym_centroid] = ACTIONS(3034),
    [anon_sym_noperspective] = ACTIONS(3034),
    [anon_sym_nointerpolation] = ACTIONS(3034),
    [anon_sym_sample] = ACTIONS(3034),
    [anon_sym_linear] = ACTIONS(3034),
    [anon_sym_snorm] = ACTIONS(3034),
    [anon_sym_unorm] = ACTIONS(3034),
    [anon_sym_point] = ACTIONS(3034),
    [anon_sym_line] = ACTIONS(3034),
    [anon_sym_triangleadj] = ACTIONS(3034),
    [anon_sym_lineadj] = ACTIONS(3034),
    [anon_sym_triangle] = ACTIONS(3034),
    [anon_sym_cbuffer] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3034),
    [anon_sym_extension] = ACTIONS(3034),
  },
  [721] = {
    [sym_identifier] = ACTIONS(3034),
    [aux_sym_preproc_include_token1] = ACTIONS(3034),
    [aux_sym_preproc_def_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token2] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_BANG] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3034),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_in] = ACTIONS(3034),
    [anon_sym_out] = ACTIONS(3034),
    [anon_sym_inout] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym___based] = ACTIONS(3034),
    [anon_sym___cdecl] = ACTIONS(3034),
    [anon_sym___clrcall] = ACTIONS(3034),
    [anon_sym___stdcall] = ACTIONS(3034),
    [anon_sym___fastcall] = ACTIONS(3034),
    [anon_sym___thiscall] = ACTIONS(3034),
    [anon_sym___vectorcall] = ACTIONS(3034),
    [anon_sym_LBRACE] = ACTIONS(3036),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [anon_sym_if] = ACTIONS(3034),
    [anon_sym_else] = ACTIONS(3034),
    [anon_sym_switch] = ACTIONS(3034),
    [anon_sym_case] = ACTIONS(3034),
    [anon_sym_default] = ACTIONS(3034),
    [anon_sym_while] = ACTIONS(3034),
    [anon_sym_do] = ACTIONS(3034),
    [anon_sym_for] = ACTIONS(3034),
    [anon_sym_return] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3034),
    [anon_sym_continue] = ACTIONS(3034),
    [anon_sym_goto] = ACTIONS(3034),
    [anon_sym___try] = ACTIONS(3034),
    [anon_sym___leave] = ACTIONS(3034),
    [anon_sym_not] = ACTIONS(3034),
    [anon_sym_compl] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_sizeof] = ACTIONS(3034),
    [anon_sym___alignof__] = ACTIONS(3034),
    [anon_sym___alignof] = ACTIONS(3034),
    [anon_sym__alignof] = ACTIONS(3034),
    [anon_sym_alignof] = ACTIONS(3034),
    [anon_sym__Alignof] = ACTIONS(3034),
    [anon_sym_offsetof] = ACTIONS(3034),
    [anon_sym__Generic] = ACTIONS(3034),
    [anon_sym_asm] = ACTIONS(3034),
    [anon_sym___asm__] = ACTIONS(3034),
    [sym_number_literal] = ACTIONS(3036),
    [anon_sym_L_SQUOTE] = ACTIONS(3036),
    [anon_sym_u_SQUOTE] = ACTIONS(3036),
    [anon_sym_U_SQUOTE] = ACTIONS(3036),
    [anon_sym_u8_SQUOTE] = ACTIONS(3036),
    [anon_sym_SQUOTE] = ACTIONS(3036),
    [anon_sym_L_DQUOTE] = ACTIONS(3036),
    [anon_sym_u_DQUOTE] = ACTIONS(3036),
    [anon_sym_U_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8_DQUOTE] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [sym_true] = ACTIONS(3034),
    [sym_false] = ACTIONS(3034),
    [anon_sym_NULL] = ACTIONS(3034),
    [anon_sym_nullptr] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_This] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [sym_virtual] = ACTIONS(3034),
    [anon_sym_explicit] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_operator] = ACTIONS(3034),
    [anon_sym_try] = ACTIONS(3034),
    [anon_sym_delete] = ACTIONS(3034),
    [anon_sym_throw] = ACTIONS(3034),
    [anon_sym_namespace] = ACTIONS(3034),
    [anon_sym_using] = ACTIONS(3034),
    [anon_sym_static_assert] = ACTIONS(3034),
    [anon_sym_concept] = ACTIONS(3034),
    [anon_sym_co_return] = ACTIONS(3034),
    [anon_sym_co_yield] = ACTIONS(3034),
    [anon_sym_R_DQUOTE] = ACTIONS(3036),
    [anon_sym_LR_DQUOTE] = ACTIONS(3036),
    [anon_sym_uR_DQUOTE] = ACTIONS(3036),
    [anon_sym_UR_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3036),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3034),
    [anon_sym_requires] = ACTIONS(3034),
    [sym_this] = ACTIONS(3034),
    [anon_sym_discard] = ACTIONS(3034),
    [anon_sym_precise] = ACTIONS(3034),
    [anon_sym_shared] = ACTIONS(3034),
    [anon_sym_groupshared] = ACTIONS(3034),
    [anon_sym_uniform] = ACTIONS(3034),
    [anon_sym_row_major] = ACTIONS(3034),
    [anon_sym_column_major] = ACTIONS(3034),
    [anon_sym_globallycoherent] = ACTIONS(3034),
    [anon_sym_centroid] = ACTIONS(3034),
    [anon_sym_noperspective] = ACTIONS(3034),
    [anon_sym_nointerpolation] = ACTIONS(3034),
    [anon_sym_sample] = ACTIONS(3034),
    [anon_sym_linear] = ACTIONS(3034),
    [anon_sym_snorm] = ACTIONS(3034),
    [anon_sym_unorm] = ACTIONS(3034),
    [anon_sym_point] = ACTIONS(3034),
    [anon_sym_line] = ACTIONS(3034),
    [anon_sym_triangleadj] = ACTIONS(3034),
    [anon_sym_lineadj] = ACTIONS(3034),
    [anon_sym_triangle] = ACTIONS(3034),
    [anon_sym_cbuffer] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3034),
    [anon_sym_extension] = ACTIONS(3034),
  },
  [722] = {
    [sym_identifier] = ACTIONS(3034),
    [aux_sym_preproc_include_token1] = ACTIONS(3034),
    [aux_sym_preproc_def_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token2] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_BANG] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3034),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_in] = ACTIONS(3034),
    [anon_sym_out] = ACTIONS(3034),
    [anon_sym_inout] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym___based] = ACTIONS(3034),
    [anon_sym___cdecl] = ACTIONS(3034),
    [anon_sym___clrcall] = ACTIONS(3034),
    [anon_sym___stdcall] = ACTIONS(3034),
    [anon_sym___fastcall] = ACTIONS(3034),
    [anon_sym___thiscall] = ACTIONS(3034),
    [anon_sym___vectorcall] = ACTIONS(3034),
    [anon_sym_LBRACE] = ACTIONS(3036),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [anon_sym_if] = ACTIONS(3034),
    [anon_sym_else] = ACTIONS(3034),
    [anon_sym_switch] = ACTIONS(3034),
    [anon_sym_case] = ACTIONS(3034),
    [anon_sym_default] = ACTIONS(3034),
    [anon_sym_while] = ACTIONS(3034),
    [anon_sym_do] = ACTIONS(3034),
    [anon_sym_for] = ACTIONS(3034),
    [anon_sym_return] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3034),
    [anon_sym_continue] = ACTIONS(3034),
    [anon_sym_goto] = ACTIONS(3034),
    [anon_sym___try] = ACTIONS(3034),
    [anon_sym___leave] = ACTIONS(3034),
    [anon_sym_not] = ACTIONS(3034),
    [anon_sym_compl] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_sizeof] = ACTIONS(3034),
    [anon_sym___alignof__] = ACTIONS(3034),
    [anon_sym___alignof] = ACTIONS(3034),
    [anon_sym__alignof] = ACTIONS(3034),
    [anon_sym_alignof] = ACTIONS(3034),
    [anon_sym__Alignof] = ACTIONS(3034),
    [anon_sym_offsetof] = ACTIONS(3034),
    [anon_sym__Generic] = ACTIONS(3034),
    [anon_sym_asm] = ACTIONS(3034),
    [anon_sym___asm__] = ACTIONS(3034),
    [sym_number_literal] = ACTIONS(3036),
    [anon_sym_L_SQUOTE] = ACTIONS(3036),
    [anon_sym_u_SQUOTE] = ACTIONS(3036),
    [anon_sym_U_SQUOTE] = ACTIONS(3036),
    [anon_sym_u8_SQUOTE] = ACTIONS(3036),
    [anon_sym_SQUOTE] = ACTIONS(3036),
    [anon_sym_L_DQUOTE] = ACTIONS(3036),
    [anon_sym_u_DQUOTE] = ACTIONS(3036),
    [anon_sym_U_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8_DQUOTE] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [sym_true] = ACTIONS(3034),
    [sym_false] = ACTIONS(3034),
    [anon_sym_NULL] = ACTIONS(3034),
    [anon_sym_nullptr] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_This] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [sym_virtual] = ACTIONS(3034),
    [anon_sym_explicit] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_operator] = ACTIONS(3034),
    [anon_sym_try] = ACTIONS(3034),
    [anon_sym_delete] = ACTIONS(3034),
    [anon_sym_throw] = ACTIONS(3034),
    [anon_sym_namespace] = ACTIONS(3034),
    [anon_sym_using] = ACTIONS(3034),
    [anon_sym_static_assert] = ACTIONS(3034),
    [anon_sym_concept] = ACTIONS(3034),
    [anon_sym_co_return] = ACTIONS(3034),
    [anon_sym_co_yield] = ACTIONS(3034),
    [anon_sym_R_DQUOTE] = ACTIONS(3036),
    [anon_sym_LR_DQUOTE] = ACTIONS(3036),
    [anon_sym_uR_DQUOTE] = ACTIONS(3036),
    [anon_sym_UR_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3036),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3034),
    [anon_sym_requires] = ACTIONS(3034),
    [sym_this] = ACTIONS(3034),
    [anon_sym_discard] = ACTIONS(3034),
    [anon_sym_precise] = ACTIONS(3034),
    [anon_sym_shared] = ACTIONS(3034),
    [anon_sym_groupshared] = ACTIONS(3034),
    [anon_sym_uniform] = ACTIONS(3034),
    [anon_sym_row_major] = ACTIONS(3034),
    [anon_sym_column_major] = ACTIONS(3034),
    [anon_sym_globallycoherent] = ACTIONS(3034),
    [anon_sym_centroid] = ACTIONS(3034),
    [anon_sym_noperspective] = ACTIONS(3034),
    [anon_sym_nointerpolation] = ACTIONS(3034),
    [anon_sym_sample] = ACTIONS(3034),
    [anon_sym_linear] = ACTIONS(3034),
    [anon_sym_snorm] = ACTIONS(3034),
    [anon_sym_unorm] = ACTIONS(3034),
    [anon_sym_point] = ACTIONS(3034),
    [anon_sym_line] = ACTIONS(3034),
    [anon_sym_triangleadj] = ACTIONS(3034),
    [anon_sym_lineadj] = ACTIONS(3034),
    [anon_sym_triangle] = ACTIONS(3034),
    [anon_sym_cbuffer] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3034),
    [anon_sym_extension] = ACTIONS(3034),
  },
  [723] = {
    [sym_identifier] = ACTIONS(3340),
    [aux_sym_preproc_include_token1] = ACTIONS(3340),
    [aux_sym_preproc_def_token1] = ACTIONS(3340),
    [aux_sym_preproc_if_token1] = ACTIONS(3340),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3340),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3340),
    [sym_preproc_directive] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(3342),
    [anon_sym_BANG] = ACTIONS(3342),
    [anon_sym_TILDE] = ACTIONS(3342),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_STAR] = ACTIONS(3342),
    [anon_sym_AMP_AMP] = ACTIONS(3342),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_SEMI] = ACTIONS(3342),
    [anon_sym___extension__] = ACTIONS(3340),
    [anon_sym_typedef] = ACTIONS(3340),
    [anon_sym_in] = ACTIONS(3340),
    [anon_sym_out] = ACTIONS(3340),
    [anon_sym_inout] = ACTIONS(3340),
    [anon_sym_extern] = ACTIONS(3340),
    [anon_sym___attribute__] = ACTIONS(3340),
    [anon_sym_COLON_COLON] = ACTIONS(3342),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3342),
    [anon_sym___declspec] = ACTIONS(3340),
    [anon_sym___based] = ACTIONS(3340),
    [anon_sym___cdecl] = ACTIONS(3340),
    [anon_sym___clrcall] = ACTIONS(3340),
    [anon_sym___stdcall] = ACTIONS(3340),
    [anon_sym___fastcall] = ACTIONS(3340),
    [anon_sym___thiscall] = ACTIONS(3340),
    [anon_sym___vectorcall] = ACTIONS(3340),
    [anon_sym_LBRACE] = ACTIONS(3342),
    [anon_sym_RBRACE] = ACTIONS(3342),
    [anon_sym_signed] = ACTIONS(3340),
    [anon_sym_unsigned] = ACTIONS(3340),
    [anon_sym_long] = ACTIONS(3340),
    [anon_sym_short] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3340),
    [anon_sym_static] = ACTIONS(3340),
    [anon_sym_register] = ACTIONS(3340),
    [anon_sym_inline] = ACTIONS(3340),
    [anon_sym___inline] = ACTIONS(3340),
    [anon_sym___inline__] = ACTIONS(3340),
    [anon_sym___forceinline] = ACTIONS(3340),
    [anon_sym_thread_local] = ACTIONS(3340),
    [anon_sym___thread] = ACTIONS(3340),
    [anon_sym_const] = ACTIONS(3340),
    [anon_sym_constexpr] = ACTIONS(3340),
    [anon_sym_volatile] = ACTIONS(3340),
    [anon_sym_restrict] = ACTIONS(3340),
    [anon_sym___restrict__] = ACTIONS(3340),
    [anon_sym__Atomic] = ACTIONS(3340),
    [anon_sym__Noreturn] = ACTIONS(3340),
    [anon_sym_noreturn] = ACTIONS(3340),
    [anon_sym_mutable] = ACTIONS(3340),
    [anon_sym_constinit] = ACTIONS(3340),
    [anon_sym_consteval] = ACTIONS(3340),
    [anon_sym_alignas] = ACTIONS(3340),
    [anon_sym__Alignas] = ACTIONS(3340),
    [sym_primitive_type] = ACTIONS(3340),
    [anon_sym_enum] = ACTIONS(3340),
    [anon_sym_class] = ACTIONS(3340),
    [anon_sym_struct] = ACTIONS(3340),
    [anon_sym_union] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_else] = ACTIONS(3340),
    [anon_sym_switch] = ACTIONS(3340),
    [anon_sym_case] = ACTIONS(3340),
    [anon_sym_default] = ACTIONS(3340),
    [anon_sym_while] = ACTIONS(3340),
    [anon_sym_do] = ACTIONS(3340),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_break] = ACTIONS(3340),
    [anon_sym_continue] = ACTIONS(3340),
    [anon_sym_goto] = ACTIONS(3340),
    [anon_sym___try] = ACTIONS(3340),
    [anon_sym___leave] = ACTIONS(3340),
    [anon_sym_not] = ACTIONS(3340),
    [anon_sym_compl] = ACTIONS(3340),
    [anon_sym_DASH_DASH] = ACTIONS(3342),
    [anon_sym_PLUS_PLUS] = ACTIONS(3342),
    [anon_sym_sizeof] = ACTIONS(3340),
    [anon_sym___alignof__] = ACTIONS(3340),
    [anon_sym___alignof] = ACTIONS(3340),
    [anon_sym__alignof] = ACTIONS(3340),
    [anon_sym_alignof] = ACTIONS(3340),
    [anon_sym__Alignof] = ACTIONS(3340),
    [anon_sym_offsetof] = ACTIONS(3340),
    [anon_sym__Generic] = ACTIONS(3340),
    [anon_sym_asm] = ACTIONS(3340),
    [anon_sym___asm__] = ACTIONS(3340),
    [sym_number_literal] = ACTIONS(3342),
    [anon_sym_L_SQUOTE] = ACTIONS(3342),
    [anon_sym_u_SQUOTE] = ACTIONS(3342),
    [anon_sym_U_SQUOTE] = ACTIONS(3342),
    [anon_sym_u8_SQUOTE] = ACTIONS(3342),
    [anon_sym_SQUOTE] = ACTIONS(3342),
    [anon_sym_L_DQUOTE] = ACTIONS(3342),
    [anon_sym_u_DQUOTE] = ACTIONS(3342),
    [anon_sym_U_DQUOTE] = ACTIONS(3342),
    [anon_sym_u8_DQUOTE] = ACTIONS(3342),
    [anon_sym_DQUOTE] = ACTIONS(3342),
    [sym_true] = ACTIONS(3340),
    [sym_false] = ACTIONS(3340),
    [anon_sym_NULL] = ACTIONS(3340),
    [anon_sym_nullptr] = ACTIONS(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3340),
    [anon_sym_let] = ACTIONS(3340),
    [anon_sym_This] = ACTIONS(3340),
    [anon_sym_decltype] = ACTIONS(3340),
    [sym_virtual] = ACTIONS(3340),
    [anon_sym_explicit] = ACTIONS(3340),
    [anon_sym_typename] = ACTIONS(3340),
    [anon_sym_template] = ACTIONS(3340),
    [anon_sym_operator] = ACTIONS(3340),
    [anon_sym_try] = ACTIONS(3340),
    [anon_sym_delete] = ACTIONS(3340),
    [anon_sym_throw] = ACTIONS(3340),
    [anon_sym_namespace] = ACTIONS(3340),
    [anon_sym_using] = ACTIONS(3340),
    [anon_sym_static_assert] = ACTIONS(3340),
    [anon_sym_concept] = ACTIONS(3340),
    [anon_sym_co_return] = ACTIONS(3340),
    [anon_sym_co_yield] = ACTIONS(3340),
    [anon_sym_R_DQUOTE] = ACTIONS(3342),
    [anon_sym_LR_DQUOTE] = ACTIONS(3342),
    [anon_sym_uR_DQUOTE] = ACTIONS(3342),
    [anon_sym_UR_DQUOTE] = ACTIONS(3342),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3342),
    [anon_sym_co_await] = ACTIONS(3340),
    [anon_sym_new] = ACTIONS(3340),
    [anon_sym_requires] = ACTIONS(3340),
    [sym_this] = ACTIONS(3340),
    [anon_sym_discard] = ACTIONS(3340),
    [anon_sym_precise] = ACTIONS(3340),
    [anon_sym_shared] = ACTIONS(3340),
    [anon_sym_groupshared] = ACTIONS(3340),
    [anon_sym_uniform] = ACTIONS(3340),
    [anon_sym_row_major] = ACTIONS(3340),
    [anon_sym_column_major] = ACTIONS(3340),
    [anon_sym_globallycoherent] = ACTIONS(3340),
    [anon_sym_centroid] = ACTIONS(3340),
    [anon_sym_noperspective] = ACTIONS(3340),
    [anon_sym_nointerpolation] = ACTIONS(3340),
    [anon_sym_sample] = ACTIONS(3340),
    [anon_sym_linear] = ACTIONS(3340),
    [anon_sym_snorm] = ACTIONS(3340),
    [anon_sym_unorm] = ACTIONS(3340),
    [anon_sym_point] = ACTIONS(3340),
    [anon_sym_line] = ACTIONS(3340),
    [anon_sym_triangleadj] = ACTIONS(3340),
    [anon_sym_lineadj] = ACTIONS(3340),
    [anon_sym_triangle] = ACTIONS(3340),
    [anon_sym_cbuffer] = ACTIONS(3340),
    [anon_sym_interface] = ACTIONS(3340),
    [anon_sym_extension] = ACTIONS(3340),
  },
  [724] = {
    [sym_identifier] = ACTIONS(3226),
    [aux_sym_preproc_include_token1] = ACTIONS(3226),
    [aux_sym_preproc_def_token1] = ACTIONS(3226),
    [aux_sym_preproc_if_token1] = ACTIONS(3226),
    [aux_sym_preproc_if_token2] = ACTIONS(3226),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3226),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3226),
    [sym_preproc_directive] = ACTIONS(3226),
    [anon_sym_LPAREN2] = ACTIONS(3228),
    [anon_sym_BANG] = ACTIONS(3228),
    [anon_sym_TILDE] = ACTIONS(3228),
    [anon_sym_DASH] = ACTIONS(3226),
    [anon_sym_PLUS] = ACTIONS(3226),
    [anon_sym_STAR] = ACTIONS(3228),
    [anon_sym_AMP_AMP] = ACTIONS(3228),
    [anon_sym_AMP] = ACTIONS(3226),
    [anon_sym_SEMI] = ACTIONS(3228),
    [anon_sym___extension__] = ACTIONS(3226),
    [anon_sym_typedef] = ACTIONS(3226),
    [anon_sym_in] = ACTIONS(3226),
    [anon_sym_out] = ACTIONS(3226),
    [anon_sym_inout] = ACTIONS(3226),
    [anon_sym_extern] = ACTIONS(3226),
    [anon_sym___attribute__] = ACTIONS(3226),
    [anon_sym_COLON_COLON] = ACTIONS(3228),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3228),
    [anon_sym___declspec] = ACTIONS(3226),
    [anon_sym___based] = ACTIONS(3226),
    [anon_sym___cdecl] = ACTIONS(3226),
    [anon_sym___clrcall] = ACTIONS(3226),
    [anon_sym___stdcall] = ACTIONS(3226),
    [anon_sym___fastcall] = ACTIONS(3226),
    [anon_sym___thiscall] = ACTIONS(3226),
    [anon_sym___vectorcall] = ACTIONS(3226),
    [anon_sym_LBRACE] = ACTIONS(3228),
    [anon_sym_signed] = ACTIONS(3226),
    [anon_sym_unsigned] = ACTIONS(3226),
    [anon_sym_long] = ACTIONS(3226),
    [anon_sym_short] = ACTIONS(3226),
    [anon_sym_LBRACK] = ACTIONS(3226),
    [anon_sym_static] = ACTIONS(3226),
    [anon_sym_register] = ACTIONS(3226),
    [anon_sym_inline] = ACTIONS(3226),
    [anon_sym___inline] = ACTIONS(3226),
    [anon_sym___inline__] = ACTIONS(3226),
    [anon_sym___forceinline] = ACTIONS(3226),
    [anon_sym_thread_local] = ACTIONS(3226),
    [anon_sym___thread] = ACTIONS(3226),
    [anon_sym_const] = ACTIONS(3226),
    [anon_sym_constexpr] = ACTIONS(3226),
    [anon_sym_volatile] = ACTIONS(3226),
    [anon_sym_restrict] = ACTIONS(3226),
    [anon_sym___restrict__] = ACTIONS(3226),
    [anon_sym__Atomic] = ACTIONS(3226),
    [anon_sym__Noreturn] = ACTIONS(3226),
    [anon_sym_noreturn] = ACTIONS(3226),
    [anon_sym_mutable] = ACTIONS(3226),
    [anon_sym_constinit] = ACTIONS(3226),
    [anon_sym_consteval] = ACTIONS(3226),
    [anon_sym_alignas] = ACTIONS(3226),
    [anon_sym__Alignas] = ACTIONS(3226),
    [sym_primitive_type] = ACTIONS(3226),
    [anon_sym_enum] = ACTIONS(3226),
    [anon_sym_class] = ACTIONS(3226),
    [anon_sym_struct] = ACTIONS(3226),
    [anon_sym_union] = ACTIONS(3226),
    [anon_sym_if] = ACTIONS(3226),
    [anon_sym_else] = ACTIONS(3226),
    [anon_sym_switch] = ACTIONS(3226),
    [anon_sym_case] = ACTIONS(3226),
    [anon_sym_default] = ACTIONS(3226),
    [anon_sym_while] = ACTIONS(3226),
    [anon_sym_do] = ACTIONS(3226),
    [anon_sym_for] = ACTIONS(3226),
    [anon_sym_return] = ACTIONS(3226),
    [anon_sym_break] = ACTIONS(3226),
    [anon_sym_continue] = ACTIONS(3226),
    [anon_sym_goto] = ACTIONS(3226),
    [anon_sym___try] = ACTIONS(3226),
    [anon_sym___leave] = ACTIONS(3226),
    [anon_sym_not] = ACTIONS(3226),
    [anon_sym_compl] = ACTIONS(3226),
    [anon_sym_DASH_DASH] = ACTIONS(3228),
    [anon_sym_PLUS_PLUS] = ACTIONS(3228),
    [anon_sym_sizeof] = ACTIONS(3226),
    [anon_sym___alignof__] = ACTIONS(3226),
    [anon_sym___alignof] = ACTIONS(3226),
    [anon_sym__alignof] = ACTIONS(3226),
    [anon_sym_alignof] = ACTIONS(3226),
    [anon_sym__Alignof] = ACTIONS(3226),
    [anon_sym_offsetof] = ACTIONS(3226),
    [anon_sym__Generic] = ACTIONS(3226),
    [anon_sym_asm] = ACTIONS(3226),
    [anon_sym___asm__] = ACTIONS(3226),
    [sym_number_literal] = ACTIONS(3228),
    [anon_sym_L_SQUOTE] = ACTIONS(3228),
    [anon_sym_u_SQUOTE] = ACTIONS(3228),
    [anon_sym_U_SQUOTE] = ACTIONS(3228),
    [anon_sym_u8_SQUOTE] = ACTIONS(3228),
    [anon_sym_SQUOTE] = ACTIONS(3228),
    [anon_sym_L_DQUOTE] = ACTIONS(3228),
    [anon_sym_u_DQUOTE] = ACTIONS(3228),
    [anon_sym_U_DQUOTE] = ACTIONS(3228),
    [anon_sym_u8_DQUOTE] = ACTIONS(3228),
    [anon_sym_DQUOTE] = ACTIONS(3228),
    [sym_true] = ACTIONS(3226),
    [sym_false] = ACTIONS(3226),
    [anon_sym_NULL] = ACTIONS(3226),
    [anon_sym_nullptr] = ACTIONS(3226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3226),
    [anon_sym_let] = ACTIONS(3226),
    [anon_sym_This] = ACTIONS(3226),
    [anon_sym_decltype] = ACTIONS(3226),
    [sym_virtual] = ACTIONS(3226),
    [anon_sym_explicit] = ACTIONS(3226),
    [anon_sym_typename] = ACTIONS(3226),
    [anon_sym_template] = ACTIONS(3226),
    [anon_sym_operator] = ACTIONS(3226),
    [anon_sym_try] = ACTIONS(3226),
    [anon_sym_delete] = ACTIONS(3226),
    [anon_sym_throw] = ACTIONS(3226),
    [anon_sym_namespace] = ACTIONS(3226),
    [anon_sym_using] = ACTIONS(3226),
    [anon_sym_static_assert] = ACTIONS(3226),
    [anon_sym_concept] = ACTIONS(3226),
    [anon_sym_co_return] = ACTIONS(3226),
    [anon_sym_co_yield] = ACTIONS(3226),
    [anon_sym_R_DQUOTE] = ACTIONS(3228),
    [anon_sym_LR_DQUOTE] = ACTIONS(3228),
    [anon_sym_uR_DQUOTE] = ACTIONS(3228),
    [anon_sym_UR_DQUOTE] = ACTIONS(3228),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3228),
    [anon_sym_co_await] = ACTIONS(3226),
    [anon_sym_new] = ACTIONS(3226),
    [anon_sym_requires] = ACTIONS(3226),
    [sym_this] = ACTIONS(3226),
    [anon_sym_discard] = ACTIONS(3226),
    [anon_sym_precise] = ACTIONS(3226),
    [anon_sym_shared] = ACTIONS(3226),
    [anon_sym_groupshared] = ACTIONS(3226),
    [anon_sym_uniform] = ACTIONS(3226),
    [anon_sym_row_major] = ACTIONS(3226),
    [anon_sym_column_major] = ACTIONS(3226),
    [anon_sym_globallycoherent] = ACTIONS(3226),
    [anon_sym_centroid] = ACTIONS(3226),
    [anon_sym_noperspective] = ACTIONS(3226),
    [anon_sym_nointerpolation] = ACTIONS(3226),
    [anon_sym_sample] = ACTIONS(3226),
    [anon_sym_linear] = ACTIONS(3226),
    [anon_sym_snorm] = ACTIONS(3226),
    [anon_sym_unorm] = ACTIONS(3226),
    [anon_sym_point] = ACTIONS(3226),
    [anon_sym_line] = ACTIONS(3226),
    [anon_sym_triangleadj] = ACTIONS(3226),
    [anon_sym_lineadj] = ACTIONS(3226),
    [anon_sym_triangle] = ACTIONS(3226),
    [anon_sym_cbuffer] = ACTIONS(3226),
    [anon_sym_interface] = ACTIONS(3226),
    [anon_sym_extension] = ACTIONS(3226),
  },
  [725] = {
    [sym_identifier] = ACTIONS(3102),
    [aux_sym_preproc_include_token1] = ACTIONS(3102),
    [aux_sym_preproc_def_token1] = ACTIONS(3102),
    [aux_sym_preproc_if_token1] = ACTIONS(3102),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3102),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3102),
    [sym_preproc_directive] = ACTIONS(3102),
    [anon_sym_LPAREN2] = ACTIONS(3100),
    [anon_sym_BANG] = ACTIONS(3100),
    [anon_sym_TILDE] = ACTIONS(3100),
    [anon_sym_DASH] = ACTIONS(3102),
    [anon_sym_PLUS] = ACTIONS(3102),
    [anon_sym_STAR] = ACTIONS(3100),
    [anon_sym_AMP_AMP] = ACTIONS(3100),
    [anon_sym_AMP] = ACTIONS(3102),
    [anon_sym_SEMI] = ACTIONS(3100),
    [anon_sym___extension__] = ACTIONS(3102),
    [anon_sym_typedef] = ACTIONS(3102),
    [anon_sym_in] = ACTIONS(3102),
    [anon_sym_out] = ACTIONS(3102),
    [anon_sym_inout] = ACTIONS(3102),
    [anon_sym_extern] = ACTIONS(3102),
    [anon_sym___attribute__] = ACTIONS(3102),
    [anon_sym_COLON_COLON] = ACTIONS(3100),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3100),
    [anon_sym___declspec] = ACTIONS(3102),
    [anon_sym___based] = ACTIONS(3102),
    [anon_sym___cdecl] = ACTIONS(3102),
    [anon_sym___clrcall] = ACTIONS(3102),
    [anon_sym___stdcall] = ACTIONS(3102),
    [anon_sym___fastcall] = ACTIONS(3102),
    [anon_sym___thiscall] = ACTIONS(3102),
    [anon_sym___vectorcall] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(3100),
    [anon_sym_RBRACE] = ACTIONS(3100),
    [anon_sym_signed] = ACTIONS(3102),
    [anon_sym_unsigned] = ACTIONS(3102),
    [anon_sym_long] = ACTIONS(3102),
    [anon_sym_short] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_static] = ACTIONS(3102),
    [anon_sym_register] = ACTIONS(3102),
    [anon_sym_inline] = ACTIONS(3102),
    [anon_sym___inline] = ACTIONS(3102),
    [anon_sym___inline__] = ACTIONS(3102),
    [anon_sym___forceinline] = ACTIONS(3102),
    [anon_sym_thread_local] = ACTIONS(3102),
    [anon_sym___thread] = ACTIONS(3102),
    [anon_sym_const] = ACTIONS(3102),
    [anon_sym_constexpr] = ACTIONS(3102),
    [anon_sym_volatile] = ACTIONS(3102),
    [anon_sym_restrict] = ACTIONS(3102),
    [anon_sym___restrict__] = ACTIONS(3102),
    [anon_sym__Atomic] = ACTIONS(3102),
    [anon_sym__Noreturn] = ACTIONS(3102),
    [anon_sym_noreturn] = ACTIONS(3102),
    [anon_sym_mutable] = ACTIONS(3102),
    [anon_sym_constinit] = ACTIONS(3102),
    [anon_sym_consteval] = ACTIONS(3102),
    [anon_sym_alignas] = ACTIONS(3102),
    [anon_sym__Alignas] = ACTIONS(3102),
    [sym_primitive_type] = ACTIONS(3102),
    [anon_sym_enum] = ACTIONS(3102),
    [anon_sym_class] = ACTIONS(3102),
    [anon_sym_struct] = ACTIONS(3102),
    [anon_sym_union] = ACTIONS(3102),
    [anon_sym_if] = ACTIONS(3102),
    [anon_sym_switch] = ACTIONS(3102),
    [anon_sym_case] = ACTIONS(3102),
    [anon_sym_default] = ACTIONS(3102),
    [anon_sym_while] = ACTIONS(3102),
    [anon_sym_do] = ACTIONS(3102),
    [anon_sym_for] = ACTIONS(3102),
    [anon_sym_return] = ACTIONS(3102),
    [anon_sym_break] = ACTIONS(3102),
    [anon_sym_continue] = ACTIONS(3102),
    [anon_sym_goto] = ACTIONS(3102),
    [anon_sym___try] = ACTIONS(3102),
    [anon_sym___leave] = ACTIONS(3102),
    [anon_sym_not] = ACTIONS(3102),
    [anon_sym_compl] = ACTIONS(3102),
    [anon_sym_DASH_DASH] = ACTIONS(3100),
    [anon_sym_PLUS_PLUS] = ACTIONS(3100),
    [anon_sym_sizeof] = ACTIONS(3102),
    [anon_sym___alignof__] = ACTIONS(3102),
    [anon_sym___alignof] = ACTIONS(3102),
    [anon_sym__alignof] = ACTIONS(3102),
    [anon_sym_alignof] = ACTIONS(3102),
    [anon_sym__Alignof] = ACTIONS(3102),
    [anon_sym_offsetof] = ACTIONS(3102),
    [anon_sym__Generic] = ACTIONS(3102),
    [anon_sym_asm] = ACTIONS(3102),
    [anon_sym___asm__] = ACTIONS(3102),
    [anon_sym_DOT] = ACTIONS(3102),
    [sym_number_literal] = ACTIONS(3100),
    [anon_sym_L_SQUOTE] = ACTIONS(3100),
    [anon_sym_u_SQUOTE] = ACTIONS(3100),
    [anon_sym_U_SQUOTE] = ACTIONS(3100),
    [anon_sym_u8_SQUOTE] = ACTIONS(3100),
    [anon_sym_SQUOTE] = ACTIONS(3100),
    [anon_sym_L_DQUOTE] = ACTIONS(3100),
    [anon_sym_u_DQUOTE] = ACTIONS(3100),
    [anon_sym_U_DQUOTE] = ACTIONS(3100),
    [anon_sym_u8_DQUOTE] = ACTIONS(3100),
    [anon_sym_DQUOTE] = ACTIONS(3100),
    [sym_true] = ACTIONS(3102),
    [sym_false] = ACTIONS(3102),
    [anon_sym_NULL] = ACTIONS(3102),
    [anon_sym_nullptr] = ACTIONS(3102),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3102),
    [anon_sym_let] = ACTIONS(3102),
    [anon_sym_This] = ACTIONS(3102),
    [anon_sym_decltype] = ACTIONS(3102),
    [sym_virtual] = ACTIONS(3102),
    [anon_sym_explicit] = ACTIONS(3102),
    [anon_sym_typename] = ACTIONS(3102),
    [anon_sym_template] = ACTIONS(3102),
    [anon_sym_operator] = ACTIONS(3102),
    [anon_sym_try] = ACTIONS(3102),
    [anon_sym_delete] = ACTIONS(3102),
    [anon_sym_throw] = ACTIONS(3102),
    [anon_sym_namespace] = ACTIONS(3102),
    [anon_sym_using] = ACTIONS(3102),
    [anon_sym_static_assert] = ACTIONS(3102),
    [anon_sym_concept] = ACTIONS(3102),
    [anon_sym_co_return] = ACTIONS(3102),
    [anon_sym_co_yield] = ACTIONS(3102),
    [anon_sym_R_DQUOTE] = ACTIONS(3100),
    [anon_sym_LR_DQUOTE] = ACTIONS(3100),
    [anon_sym_uR_DQUOTE] = ACTIONS(3100),
    [anon_sym_UR_DQUOTE] = ACTIONS(3100),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3100),
    [anon_sym_co_await] = ACTIONS(3102),
    [anon_sym_new] = ACTIONS(3102),
    [anon_sym_requires] = ACTIONS(3102),
    [sym_this] = ACTIONS(3102),
    [anon_sym_discard] = ACTIONS(3102),
    [anon_sym_precise] = ACTIONS(3102),
    [anon_sym_shared] = ACTIONS(3102),
    [anon_sym_groupshared] = ACTIONS(3102),
    [anon_sym_uniform] = ACTIONS(3102),
    [anon_sym_row_major] = ACTIONS(3102),
    [anon_sym_column_major] = ACTIONS(3102),
    [anon_sym_globallycoherent] = ACTIONS(3102),
    [anon_sym_centroid] = ACTIONS(3102),
    [anon_sym_noperspective] = ACTIONS(3102),
    [anon_sym_nointerpolation] = ACTIONS(3102),
    [anon_sym_sample] = ACTIONS(3102),
    [anon_sym_linear] = ACTIONS(3102),
    [anon_sym_snorm] = ACTIONS(3102),
    [anon_sym_unorm] = ACTIONS(3102),
    [anon_sym_point] = ACTIONS(3102),
    [anon_sym_line] = ACTIONS(3102),
    [anon_sym_triangleadj] = ACTIONS(3102),
    [anon_sym_lineadj] = ACTIONS(3102),
    [anon_sym_triangle] = ACTIONS(3102),
    [anon_sym_cbuffer] = ACTIONS(3102),
    [anon_sym_interface] = ACTIONS(3102),
    [anon_sym_extension] = ACTIONS(3102),
  },
  [726] = {
    [sym_identifier] = ACTIONS(3230),
    [aux_sym_preproc_include_token1] = ACTIONS(3230),
    [aux_sym_preproc_def_token1] = ACTIONS(3230),
    [aux_sym_preproc_if_token1] = ACTIONS(3230),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3230),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3230),
    [sym_preproc_directive] = ACTIONS(3230),
    [anon_sym_LPAREN2] = ACTIONS(3232),
    [anon_sym_BANG] = ACTIONS(3232),
    [anon_sym_TILDE] = ACTIONS(3232),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_STAR] = ACTIONS(3232),
    [anon_sym_AMP_AMP] = ACTIONS(3232),
    [anon_sym_AMP] = ACTIONS(3230),
    [anon_sym_SEMI] = ACTIONS(3232),
    [anon_sym___extension__] = ACTIONS(3230),
    [anon_sym_typedef] = ACTIONS(3230),
    [anon_sym_in] = ACTIONS(3230),
    [anon_sym_out] = ACTIONS(3230),
    [anon_sym_inout] = ACTIONS(3230),
    [anon_sym_extern] = ACTIONS(3230),
    [anon_sym___attribute__] = ACTIONS(3230),
    [anon_sym_COLON_COLON] = ACTIONS(3232),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3232),
    [anon_sym___declspec] = ACTIONS(3230),
    [anon_sym___based] = ACTIONS(3230),
    [anon_sym___cdecl] = ACTIONS(3230),
    [anon_sym___clrcall] = ACTIONS(3230),
    [anon_sym___stdcall] = ACTIONS(3230),
    [anon_sym___fastcall] = ACTIONS(3230),
    [anon_sym___thiscall] = ACTIONS(3230),
    [anon_sym___vectorcall] = ACTIONS(3230),
    [anon_sym_LBRACE] = ACTIONS(3232),
    [anon_sym_RBRACE] = ACTIONS(3232),
    [anon_sym_signed] = ACTIONS(3230),
    [anon_sym_unsigned] = ACTIONS(3230),
    [anon_sym_long] = ACTIONS(3230),
    [anon_sym_short] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_static] = ACTIONS(3230),
    [anon_sym_register] = ACTIONS(3230),
    [anon_sym_inline] = ACTIONS(3230),
    [anon_sym___inline] = ACTIONS(3230),
    [anon_sym___inline__] = ACTIONS(3230),
    [anon_sym___forceinline] = ACTIONS(3230),
    [anon_sym_thread_local] = ACTIONS(3230),
    [anon_sym___thread] = ACTIONS(3230),
    [anon_sym_const] = ACTIONS(3230),
    [anon_sym_constexpr] = ACTIONS(3230),
    [anon_sym_volatile] = ACTIONS(3230),
    [anon_sym_restrict] = ACTIONS(3230),
    [anon_sym___restrict__] = ACTIONS(3230),
    [anon_sym__Atomic] = ACTIONS(3230),
    [anon_sym__Noreturn] = ACTIONS(3230),
    [anon_sym_noreturn] = ACTIONS(3230),
    [anon_sym_mutable] = ACTIONS(3230),
    [anon_sym_constinit] = ACTIONS(3230),
    [anon_sym_consteval] = ACTIONS(3230),
    [anon_sym_alignas] = ACTIONS(3230),
    [anon_sym__Alignas] = ACTIONS(3230),
    [sym_primitive_type] = ACTIONS(3230),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3230),
    [anon_sym_struct] = ACTIONS(3230),
    [anon_sym_union] = ACTIONS(3230),
    [anon_sym_if] = ACTIONS(3230),
    [anon_sym_else] = ACTIONS(3230),
    [anon_sym_switch] = ACTIONS(3230),
    [anon_sym_case] = ACTIONS(3230),
    [anon_sym_default] = ACTIONS(3230),
    [anon_sym_while] = ACTIONS(3230),
    [anon_sym_do] = ACTIONS(3230),
    [anon_sym_for] = ACTIONS(3230),
    [anon_sym_return] = ACTIONS(3230),
    [anon_sym_break] = ACTIONS(3230),
    [anon_sym_continue] = ACTIONS(3230),
    [anon_sym_goto] = ACTIONS(3230),
    [anon_sym___try] = ACTIONS(3230),
    [anon_sym___leave] = ACTIONS(3230),
    [anon_sym_not] = ACTIONS(3230),
    [anon_sym_compl] = ACTIONS(3230),
    [anon_sym_DASH_DASH] = ACTIONS(3232),
    [anon_sym_PLUS_PLUS] = ACTIONS(3232),
    [anon_sym_sizeof] = ACTIONS(3230),
    [anon_sym___alignof__] = ACTIONS(3230),
    [anon_sym___alignof] = ACTIONS(3230),
    [anon_sym__alignof] = ACTIONS(3230),
    [anon_sym_alignof] = ACTIONS(3230),
    [anon_sym__Alignof] = ACTIONS(3230),
    [anon_sym_offsetof] = ACTIONS(3230),
    [anon_sym__Generic] = ACTIONS(3230),
    [anon_sym_asm] = ACTIONS(3230),
    [anon_sym___asm__] = ACTIONS(3230),
    [sym_number_literal] = ACTIONS(3232),
    [anon_sym_L_SQUOTE] = ACTIONS(3232),
    [anon_sym_u_SQUOTE] = ACTIONS(3232),
    [anon_sym_U_SQUOTE] = ACTIONS(3232),
    [anon_sym_u8_SQUOTE] = ACTIONS(3232),
    [anon_sym_SQUOTE] = ACTIONS(3232),
    [anon_sym_L_DQUOTE] = ACTIONS(3232),
    [anon_sym_u_DQUOTE] = ACTIONS(3232),
    [anon_sym_U_DQUOTE] = ACTIONS(3232),
    [anon_sym_u8_DQUOTE] = ACTIONS(3232),
    [anon_sym_DQUOTE] = ACTIONS(3232),
    [sym_true] = ACTIONS(3230),
    [sym_false] = ACTIONS(3230),
    [anon_sym_NULL] = ACTIONS(3230),
    [anon_sym_nullptr] = ACTIONS(3230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3230),
    [anon_sym_let] = ACTIONS(3230),
    [anon_sym_This] = ACTIONS(3230),
    [anon_sym_decltype] = ACTIONS(3230),
    [sym_virtual] = ACTIONS(3230),
    [anon_sym_explicit] = ACTIONS(3230),
    [anon_sym_typename] = ACTIONS(3230),
    [anon_sym_template] = ACTIONS(3230),
    [anon_sym_operator] = ACTIONS(3230),
    [anon_sym_try] = ACTIONS(3230),
    [anon_sym_delete] = ACTIONS(3230),
    [anon_sym_throw] = ACTIONS(3230),
    [anon_sym_namespace] = ACTIONS(3230),
    [anon_sym_using] = ACTIONS(3230),
    [anon_sym_static_assert] = ACTIONS(3230),
    [anon_sym_concept] = ACTIONS(3230),
    [anon_sym_co_return] = ACTIONS(3230),
    [anon_sym_co_yield] = ACTIONS(3230),
    [anon_sym_R_DQUOTE] = ACTIONS(3232),
    [anon_sym_LR_DQUOTE] = ACTIONS(3232),
    [anon_sym_uR_DQUOTE] = ACTIONS(3232),
    [anon_sym_UR_DQUOTE] = ACTIONS(3232),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3232),
    [anon_sym_co_await] = ACTIONS(3230),
    [anon_sym_new] = ACTIONS(3230),
    [anon_sym_requires] = ACTIONS(3230),
    [sym_this] = ACTIONS(3230),
    [anon_sym_discard] = ACTIONS(3230),
    [anon_sym_precise] = ACTIONS(3230),
    [anon_sym_shared] = ACTIONS(3230),
    [anon_sym_groupshared] = ACTIONS(3230),
    [anon_sym_uniform] = ACTIONS(3230),
    [anon_sym_row_major] = ACTIONS(3230),
    [anon_sym_column_major] = ACTIONS(3230),
    [anon_sym_globallycoherent] = ACTIONS(3230),
    [anon_sym_centroid] = ACTIONS(3230),
    [anon_sym_noperspective] = ACTIONS(3230),
    [anon_sym_nointerpolation] = ACTIONS(3230),
    [anon_sym_sample] = ACTIONS(3230),
    [anon_sym_linear] = ACTIONS(3230),
    [anon_sym_snorm] = ACTIONS(3230),
    [anon_sym_unorm] = ACTIONS(3230),
    [anon_sym_point] = ACTIONS(3230),
    [anon_sym_line] = ACTIONS(3230),
    [anon_sym_triangleadj] = ACTIONS(3230),
    [anon_sym_lineadj] = ACTIONS(3230),
    [anon_sym_triangle] = ACTIONS(3230),
    [anon_sym_cbuffer] = ACTIONS(3230),
    [anon_sym_interface] = ACTIONS(3230),
    [anon_sym_extension] = ACTIONS(3230),
  },
  [727] = {
    [sym_identifier] = ACTIONS(3314),
    [aux_sym_preproc_include_token1] = ACTIONS(3314),
    [aux_sym_preproc_def_token1] = ACTIONS(3314),
    [aux_sym_preproc_if_token1] = ACTIONS(3314),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3314),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3314),
    [sym_preproc_directive] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3316),
    [anon_sym_BANG] = ACTIONS(3316),
    [anon_sym_TILDE] = ACTIONS(3316),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_STAR] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_SEMI] = ACTIONS(3316),
    [anon_sym___extension__] = ACTIONS(3314),
    [anon_sym_typedef] = ACTIONS(3314),
    [anon_sym_in] = ACTIONS(3314),
    [anon_sym_out] = ACTIONS(3314),
    [anon_sym_inout] = ACTIONS(3314),
    [anon_sym_extern] = ACTIONS(3314),
    [anon_sym___attribute__] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3316),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3316),
    [anon_sym___declspec] = ACTIONS(3314),
    [anon_sym___based] = ACTIONS(3314),
    [anon_sym___cdecl] = ACTIONS(3314),
    [anon_sym___clrcall] = ACTIONS(3314),
    [anon_sym___stdcall] = ACTIONS(3314),
    [anon_sym___fastcall] = ACTIONS(3314),
    [anon_sym___thiscall] = ACTIONS(3314),
    [anon_sym___vectorcall] = ACTIONS(3314),
    [anon_sym_LBRACE] = ACTIONS(3316),
    [anon_sym_RBRACE] = ACTIONS(3316),
    [anon_sym_signed] = ACTIONS(3314),
    [anon_sym_unsigned] = ACTIONS(3314),
    [anon_sym_long] = ACTIONS(3314),
    [anon_sym_short] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_static] = ACTIONS(3314),
    [anon_sym_register] = ACTIONS(3314),
    [anon_sym_inline] = ACTIONS(3314),
    [anon_sym___inline] = ACTIONS(3314),
    [anon_sym___inline__] = ACTIONS(3314),
    [anon_sym___forceinline] = ACTIONS(3314),
    [anon_sym_thread_local] = ACTIONS(3314),
    [anon_sym___thread] = ACTIONS(3314),
    [anon_sym_const] = ACTIONS(3314),
    [anon_sym_constexpr] = ACTIONS(3314),
    [anon_sym_volatile] = ACTIONS(3314),
    [anon_sym_restrict] = ACTIONS(3314),
    [anon_sym___restrict__] = ACTIONS(3314),
    [anon_sym__Atomic] = ACTIONS(3314),
    [anon_sym__Noreturn] = ACTIONS(3314),
    [anon_sym_noreturn] = ACTIONS(3314),
    [anon_sym_mutable] = ACTIONS(3314),
    [anon_sym_constinit] = ACTIONS(3314),
    [anon_sym_consteval] = ACTIONS(3314),
    [anon_sym_alignas] = ACTIONS(3314),
    [anon_sym__Alignas] = ACTIONS(3314),
    [sym_primitive_type] = ACTIONS(3314),
    [anon_sym_enum] = ACTIONS(3314),
    [anon_sym_class] = ACTIONS(3314),
    [anon_sym_struct] = ACTIONS(3314),
    [anon_sym_union] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_else] = ACTIONS(3314),
    [anon_sym_switch] = ACTIONS(3314),
    [anon_sym_case] = ACTIONS(3314),
    [anon_sym_default] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_break] = ACTIONS(3314),
    [anon_sym_continue] = ACTIONS(3314),
    [anon_sym_goto] = ACTIONS(3314),
    [anon_sym___try] = ACTIONS(3314),
    [anon_sym___leave] = ACTIONS(3314),
    [anon_sym_not] = ACTIONS(3314),
    [anon_sym_compl] = ACTIONS(3314),
    [anon_sym_DASH_DASH] = ACTIONS(3316),
    [anon_sym_PLUS_PLUS] = ACTIONS(3316),
    [anon_sym_sizeof] = ACTIONS(3314),
    [anon_sym___alignof__] = ACTIONS(3314),
    [anon_sym___alignof] = ACTIONS(3314),
    [anon_sym__alignof] = ACTIONS(3314),
    [anon_sym_alignof] = ACTIONS(3314),
    [anon_sym__Alignof] = ACTIONS(3314),
    [anon_sym_offsetof] = ACTIONS(3314),
    [anon_sym__Generic] = ACTIONS(3314),
    [anon_sym_asm] = ACTIONS(3314),
    [anon_sym___asm__] = ACTIONS(3314),
    [sym_number_literal] = ACTIONS(3316),
    [anon_sym_L_SQUOTE] = ACTIONS(3316),
    [anon_sym_u_SQUOTE] = ACTIONS(3316),
    [anon_sym_U_SQUOTE] = ACTIONS(3316),
    [anon_sym_u8_SQUOTE] = ACTIONS(3316),
    [anon_sym_SQUOTE] = ACTIONS(3316),
    [anon_sym_L_DQUOTE] = ACTIONS(3316),
    [anon_sym_u_DQUOTE] = ACTIONS(3316),
    [anon_sym_U_DQUOTE] = ACTIONS(3316),
    [anon_sym_u8_DQUOTE] = ACTIONS(3316),
    [anon_sym_DQUOTE] = ACTIONS(3316),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [anon_sym_NULL] = ACTIONS(3314),
    [anon_sym_nullptr] = ACTIONS(3314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_This] = ACTIONS(3314),
    [anon_sym_decltype] = ACTIONS(3314),
    [sym_virtual] = ACTIONS(3314),
    [anon_sym_explicit] = ACTIONS(3314),
    [anon_sym_typename] = ACTIONS(3314),
    [anon_sym_template] = ACTIONS(3314),
    [anon_sym_operator] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_delete] = ACTIONS(3314),
    [anon_sym_throw] = ACTIONS(3314),
    [anon_sym_namespace] = ACTIONS(3314),
    [anon_sym_using] = ACTIONS(3314),
    [anon_sym_static_assert] = ACTIONS(3314),
    [anon_sym_concept] = ACTIONS(3314),
    [anon_sym_co_return] = ACTIONS(3314),
    [anon_sym_co_yield] = ACTIONS(3314),
    [anon_sym_R_DQUOTE] = ACTIONS(3316),
    [anon_sym_LR_DQUOTE] = ACTIONS(3316),
    [anon_sym_uR_DQUOTE] = ACTIONS(3316),
    [anon_sym_UR_DQUOTE] = ACTIONS(3316),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3316),
    [anon_sym_co_await] = ACTIONS(3314),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_requires] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [anon_sym_discard] = ACTIONS(3314),
    [anon_sym_precise] = ACTIONS(3314),
    [anon_sym_shared] = ACTIONS(3314),
    [anon_sym_groupshared] = ACTIONS(3314),
    [anon_sym_uniform] = ACTIONS(3314),
    [anon_sym_row_major] = ACTIONS(3314),
    [anon_sym_column_major] = ACTIONS(3314),
    [anon_sym_globallycoherent] = ACTIONS(3314),
    [anon_sym_centroid] = ACTIONS(3314),
    [anon_sym_noperspective] = ACTIONS(3314),
    [anon_sym_nointerpolation] = ACTIONS(3314),
    [anon_sym_sample] = ACTIONS(3314),
    [anon_sym_linear] = ACTIONS(3314),
    [anon_sym_snorm] = ACTIONS(3314),
    [anon_sym_unorm] = ACTIONS(3314),
    [anon_sym_point] = ACTIONS(3314),
    [anon_sym_line] = ACTIONS(3314),
    [anon_sym_triangleadj] = ACTIONS(3314),
    [anon_sym_lineadj] = ACTIONS(3314),
    [anon_sym_triangle] = ACTIONS(3314),
    [anon_sym_cbuffer] = ACTIONS(3314),
    [anon_sym_interface] = ACTIONS(3314),
    [anon_sym_extension] = ACTIONS(3314),
  },
  [728] = {
    [sym_identifier] = ACTIONS(3162),
    [aux_sym_preproc_include_token1] = ACTIONS(3162),
    [aux_sym_preproc_def_token1] = ACTIONS(3162),
    [aux_sym_preproc_if_token1] = ACTIONS(3162),
    [aux_sym_preproc_if_token2] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3162),
    [sym_preproc_directive] = ACTIONS(3162),
    [anon_sym_LPAREN2] = ACTIONS(3164),
    [anon_sym_BANG] = ACTIONS(3164),
    [anon_sym_TILDE] = ACTIONS(3164),
    [anon_sym_DASH] = ACTIONS(3162),
    [anon_sym_PLUS] = ACTIONS(3162),
    [anon_sym_STAR] = ACTIONS(3164),
    [anon_sym_AMP_AMP] = ACTIONS(3164),
    [anon_sym_AMP] = ACTIONS(3162),
    [anon_sym_SEMI] = ACTIONS(3164),
    [anon_sym___extension__] = ACTIONS(3162),
    [anon_sym_typedef] = ACTIONS(3162),
    [anon_sym_in] = ACTIONS(3162),
    [anon_sym_out] = ACTIONS(3162),
    [anon_sym_inout] = ACTIONS(3162),
    [anon_sym_extern] = ACTIONS(3162),
    [anon_sym___attribute__] = ACTIONS(3162),
    [anon_sym_COLON_COLON] = ACTIONS(3164),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3164),
    [anon_sym___declspec] = ACTIONS(3162),
    [anon_sym___based] = ACTIONS(3162),
    [anon_sym___cdecl] = ACTIONS(3162),
    [anon_sym___clrcall] = ACTIONS(3162),
    [anon_sym___stdcall] = ACTIONS(3162),
    [anon_sym___fastcall] = ACTIONS(3162),
    [anon_sym___thiscall] = ACTIONS(3162),
    [anon_sym___vectorcall] = ACTIONS(3162),
    [anon_sym_LBRACE] = ACTIONS(3164),
    [anon_sym_signed] = ACTIONS(3162),
    [anon_sym_unsigned] = ACTIONS(3162),
    [anon_sym_long] = ACTIONS(3162),
    [anon_sym_short] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(3162),
    [anon_sym_static] = ACTIONS(3162),
    [anon_sym_register] = ACTIONS(3162),
    [anon_sym_inline] = ACTIONS(3162),
    [anon_sym___inline] = ACTIONS(3162),
    [anon_sym___inline__] = ACTIONS(3162),
    [anon_sym___forceinline] = ACTIONS(3162),
    [anon_sym_thread_local] = ACTIONS(3162),
    [anon_sym___thread] = ACTIONS(3162),
    [anon_sym_const] = ACTIONS(3162),
    [anon_sym_constexpr] = ACTIONS(3162),
    [anon_sym_volatile] = ACTIONS(3162),
    [anon_sym_restrict] = ACTIONS(3162),
    [anon_sym___restrict__] = ACTIONS(3162),
    [anon_sym__Atomic] = ACTIONS(3162),
    [anon_sym__Noreturn] = ACTIONS(3162),
    [anon_sym_noreturn] = ACTIONS(3162),
    [anon_sym_mutable] = ACTIONS(3162),
    [anon_sym_constinit] = ACTIONS(3162),
    [anon_sym_consteval] = ACTIONS(3162),
    [anon_sym_alignas] = ACTIONS(3162),
    [anon_sym__Alignas] = ACTIONS(3162),
    [sym_primitive_type] = ACTIONS(3162),
    [anon_sym_enum] = ACTIONS(3162),
    [anon_sym_class] = ACTIONS(3162),
    [anon_sym_struct] = ACTIONS(3162),
    [anon_sym_union] = ACTIONS(3162),
    [anon_sym_if] = ACTIONS(3162),
    [anon_sym_else] = ACTIONS(3162),
    [anon_sym_switch] = ACTIONS(3162),
    [anon_sym_case] = ACTIONS(3162),
    [anon_sym_default] = ACTIONS(3162),
    [anon_sym_while] = ACTIONS(3162),
    [anon_sym_do] = ACTIONS(3162),
    [anon_sym_for] = ACTIONS(3162),
    [anon_sym_return] = ACTIONS(3162),
    [anon_sym_break] = ACTIONS(3162),
    [anon_sym_continue] = ACTIONS(3162),
    [anon_sym_goto] = ACTIONS(3162),
    [anon_sym___try] = ACTIONS(3162),
    [anon_sym___leave] = ACTIONS(3162),
    [anon_sym_not] = ACTIONS(3162),
    [anon_sym_compl] = ACTIONS(3162),
    [anon_sym_DASH_DASH] = ACTIONS(3164),
    [anon_sym_PLUS_PLUS] = ACTIONS(3164),
    [anon_sym_sizeof] = ACTIONS(3162),
    [anon_sym___alignof__] = ACTIONS(3162),
    [anon_sym___alignof] = ACTIONS(3162),
    [anon_sym__alignof] = ACTIONS(3162),
    [anon_sym_alignof] = ACTIONS(3162),
    [anon_sym__Alignof] = ACTIONS(3162),
    [anon_sym_offsetof] = ACTIONS(3162),
    [anon_sym__Generic] = ACTIONS(3162),
    [anon_sym_asm] = ACTIONS(3162),
    [anon_sym___asm__] = ACTIONS(3162),
    [sym_number_literal] = ACTIONS(3164),
    [anon_sym_L_SQUOTE] = ACTIONS(3164),
    [anon_sym_u_SQUOTE] = ACTIONS(3164),
    [anon_sym_U_SQUOTE] = ACTIONS(3164),
    [anon_sym_u8_SQUOTE] = ACTIONS(3164),
    [anon_sym_SQUOTE] = ACTIONS(3164),
    [anon_sym_L_DQUOTE] = ACTIONS(3164),
    [anon_sym_u_DQUOTE] = ACTIONS(3164),
    [anon_sym_U_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8_DQUOTE] = ACTIONS(3164),
    [anon_sym_DQUOTE] = ACTIONS(3164),
    [sym_true] = ACTIONS(3162),
    [sym_false] = ACTIONS(3162),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3162),
    [anon_sym_let] = ACTIONS(3162),
    [anon_sym_This] = ACTIONS(3162),
    [anon_sym_decltype] = ACTIONS(3162),
    [sym_virtual] = ACTIONS(3162),
    [anon_sym_explicit] = ACTIONS(3162),
    [anon_sym_typename] = ACTIONS(3162),
    [anon_sym_template] = ACTIONS(3162),
    [anon_sym_operator] = ACTIONS(3162),
    [anon_sym_try] = ACTIONS(3162),
    [anon_sym_delete] = ACTIONS(3162),
    [anon_sym_throw] = ACTIONS(3162),
    [anon_sym_namespace] = ACTIONS(3162),
    [anon_sym_using] = ACTIONS(3162),
    [anon_sym_static_assert] = ACTIONS(3162),
    [anon_sym_concept] = ACTIONS(3162),
    [anon_sym_co_return] = ACTIONS(3162),
    [anon_sym_co_yield] = ACTIONS(3162),
    [anon_sym_R_DQUOTE] = ACTIONS(3164),
    [anon_sym_LR_DQUOTE] = ACTIONS(3164),
    [anon_sym_uR_DQUOTE] = ACTIONS(3164),
    [anon_sym_UR_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3164),
    [anon_sym_co_await] = ACTIONS(3162),
    [anon_sym_new] = ACTIONS(3162),
    [anon_sym_requires] = ACTIONS(3162),
    [sym_this] = ACTIONS(3162),
    [anon_sym_discard] = ACTIONS(3162),
    [anon_sym_precise] = ACTIONS(3162),
    [anon_sym_shared] = ACTIONS(3162),
    [anon_sym_groupshared] = ACTIONS(3162),
    [anon_sym_uniform] = ACTIONS(3162),
    [anon_sym_row_major] = ACTIONS(3162),
    [anon_sym_column_major] = ACTIONS(3162),
    [anon_sym_globallycoherent] = ACTIONS(3162),
    [anon_sym_centroid] = ACTIONS(3162),
    [anon_sym_noperspective] = ACTIONS(3162),
    [anon_sym_nointerpolation] = ACTIONS(3162),
    [anon_sym_sample] = ACTIONS(3162),
    [anon_sym_linear] = ACTIONS(3162),
    [anon_sym_snorm] = ACTIONS(3162),
    [anon_sym_unorm] = ACTIONS(3162),
    [anon_sym_point] = ACTIONS(3162),
    [anon_sym_line] = ACTIONS(3162),
    [anon_sym_triangleadj] = ACTIONS(3162),
    [anon_sym_lineadj] = ACTIONS(3162),
    [anon_sym_triangle] = ACTIONS(3162),
    [anon_sym_cbuffer] = ACTIONS(3162),
    [anon_sym_interface] = ACTIONS(3162),
    [anon_sym_extension] = ACTIONS(3162),
  },
  [729] = {
    [sym_expression] = STATE(5339),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10503),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(3852),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(3855),
    [anon_sym___extension__] = ACTIONS(3857),
    [anon_sym_in] = ACTIONS(3857),
    [anon_sym_out] = ACTIONS(3857),
    [anon_sym_inout] = ACTIONS(3857),
    [anon_sym_extern] = ACTIONS(3857),
    [anon_sym___attribute__] = ACTIONS(3857),
    [anon_sym_COLON_COLON] = ACTIONS(3859),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3862),
    [anon_sym___declspec] = ACTIONS(3857),
    [anon_sym_signed] = ACTIONS(3857),
    [anon_sym_unsigned] = ACTIONS(3857),
    [anon_sym_long] = ACTIONS(3857),
    [anon_sym_short] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2273),
    [anon_sym_static] = ACTIONS(3857),
    [anon_sym_register] = ACTIONS(3857),
    [anon_sym_inline] = ACTIONS(3857),
    [anon_sym___inline] = ACTIONS(3857),
    [anon_sym___inline__] = ACTIONS(3857),
    [anon_sym___forceinline] = ACTIONS(3857),
    [anon_sym_thread_local] = ACTIONS(3857),
    [anon_sym___thread] = ACTIONS(3857),
    [anon_sym_const] = ACTIONS(3857),
    [anon_sym_constexpr] = ACTIONS(3857),
    [anon_sym_volatile] = ACTIONS(3857),
    [anon_sym_restrict] = ACTIONS(3857),
    [anon_sym___restrict__] = ACTIONS(3857),
    [anon_sym__Atomic] = ACTIONS(3857),
    [anon_sym__Noreturn] = ACTIONS(3857),
    [anon_sym_noreturn] = ACTIONS(3857),
    [anon_sym_mutable] = ACTIONS(3857),
    [anon_sym_constinit] = ACTIONS(3857),
    [anon_sym_consteval] = ACTIONS(3857),
    [anon_sym_alignas] = ACTIONS(3857),
    [anon_sym__Alignas] = ACTIONS(3857),
    [sym_primitive_type] = ACTIONS(3864),
    [anon_sym_enum] = ACTIONS(3857),
    [anon_sym_class] = ACTIONS(3857),
    [anon_sym_struct] = ACTIONS(3857),
    [anon_sym_union] = ACTIONS(3857),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3857),
    [anon_sym_let] = ACTIONS(3857),
    [anon_sym_This] = ACTIONS(3857),
    [anon_sym_decltype] = ACTIONS(3867),
    [sym_virtual] = ACTIONS(3857),
    [anon_sym_typename] = ACTIONS(3857),
    [anon_sym_template] = ACTIONS(3870),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_precise] = ACTIONS(3857),
    [anon_sym_shared] = ACTIONS(3857),
    [anon_sym_groupshared] = ACTIONS(3857),
    [anon_sym_uniform] = ACTIONS(3857),
    [anon_sym_row_major] = ACTIONS(3857),
    [anon_sym_column_major] = ACTIONS(3857),
    [anon_sym_globallycoherent] = ACTIONS(3857),
    [anon_sym_centroid] = ACTIONS(3857),
    [anon_sym_noperspective] = ACTIONS(3857),
    [anon_sym_nointerpolation] = ACTIONS(3857),
    [anon_sym_sample] = ACTIONS(3857),
    [anon_sym_linear] = ACTIONS(3857),
    [anon_sym_snorm] = ACTIONS(3857),
    [anon_sym_unorm] = ACTIONS(3857),
    [anon_sym_point] = ACTIONS(3857),
    [anon_sym_line] = ACTIONS(3857),
    [anon_sym_triangleadj] = ACTIONS(3857),
    [anon_sym_lineadj] = ACTIONS(3857),
    [anon_sym_triangle] = ACTIONS(3857),
    [anon_sym_interface] = ACTIONS(3857),
    [anon_sym_extension] = ACTIONS(3857),
  },
  [730] = {
    [sym_expression] = STATE(5338),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10498),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(3876),
    [anon_sym___extension__] = ACTIONS(3178),
    [anon_sym_in] = ACTIONS(3178),
    [anon_sym_out] = ACTIONS(3178),
    [anon_sym_inout] = ACTIONS(3178),
    [anon_sym_extern] = ACTIONS(3178),
    [anon_sym___attribute__] = ACTIONS(3178),
    [anon_sym_COLON_COLON] = ACTIONS(3878),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3180),
    [anon_sym___declspec] = ACTIONS(3178),
    [anon_sym_signed] = ACTIONS(3178),
    [anon_sym_unsigned] = ACTIONS(3178),
    [anon_sym_long] = ACTIONS(3178),
    [anon_sym_short] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(2273),
    [anon_sym_static] = ACTIONS(3178),
    [anon_sym_register] = ACTIONS(3178),
    [anon_sym_inline] = ACTIONS(3178),
    [anon_sym___inline] = ACTIONS(3178),
    [anon_sym___inline__] = ACTIONS(3178),
    [anon_sym___forceinline] = ACTIONS(3178),
    [anon_sym_thread_local] = ACTIONS(3178),
    [anon_sym___thread] = ACTIONS(3178),
    [anon_sym_const] = ACTIONS(3178),
    [anon_sym_constexpr] = ACTIONS(3178),
    [anon_sym_volatile] = ACTIONS(3178),
    [anon_sym_restrict] = ACTIONS(3178),
    [anon_sym___restrict__] = ACTIONS(3178),
    [anon_sym__Atomic] = ACTIONS(3178),
    [anon_sym__Noreturn] = ACTIONS(3178),
    [anon_sym_noreturn] = ACTIONS(3178),
    [anon_sym_mutable] = ACTIONS(3178),
    [anon_sym_constinit] = ACTIONS(3178),
    [anon_sym_consteval] = ACTIONS(3178),
    [anon_sym_alignas] = ACTIONS(3178),
    [anon_sym__Alignas] = ACTIONS(3178),
    [sym_primitive_type] = ACTIONS(3881),
    [anon_sym_enum] = ACTIONS(3178),
    [anon_sym_class] = ACTIONS(3178),
    [anon_sym_struct] = ACTIONS(3178),
    [anon_sym_union] = ACTIONS(3178),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3178),
    [anon_sym_let] = ACTIONS(3178),
    [anon_sym_This] = ACTIONS(3178),
    [anon_sym_decltype] = ACTIONS(3884),
    [sym_virtual] = ACTIONS(3178),
    [anon_sym_typename] = ACTIONS(3178),
    [anon_sym_template] = ACTIONS(3887),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_precise] = ACTIONS(3178),
    [anon_sym_shared] = ACTIONS(3178),
    [anon_sym_groupshared] = ACTIONS(3178),
    [anon_sym_uniform] = ACTIONS(3178),
    [anon_sym_row_major] = ACTIONS(3178),
    [anon_sym_column_major] = ACTIONS(3178),
    [anon_sym_globallycoherent] = ACTIONS(3178),
    [anon_sym_centroid] = ACTIONS(3178),
    [anon_sym_noperspective] = ACTIONS(3178),
    [anon_sym_nointerpolation] = ACTIONS(3178),
    [anon_sym_sample] = ACTIONS(3178),
    [anon_sym_linear] = ACTIONS(3178),
    [anon_sym_snorm] = ACTIONS(3178),
    [anon_sym_unorm] = ACTIONS(3178),
    [anon_sym_point] = ACTIONS(3178),
    [anon_sym_line] = ACTIONS(3178),
    [anon_sym_triangleadj] = ACTIONS(3178),
    [anon_sym_lineadj] = ACTIONS(3178),
    [anon_sym_triangle] = ACTIONS(3178),
    [anon_sym_interface] = ACTIONS(3178),
    [anon_sym_extension] = ACTIONS(3178),
  },
  [731] = {
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_include_token1] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3196),
    [aux_sym_preproc_if_token1] = ACTIONS(3196),
    [aux_sym_preproc_if_token2] = ACTIONS(3196),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3196),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3196),
    [sym_preproc_directive] = ACTIONS(3196),
    [anon_sym_LPAREN2] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3196),
    [anon_sym_PLUS] = ACTIONS(3196),
    [anon_sym_STAR] = ACTIONS(3198),
    [anon_sym_AMP_AMP] = ACTIONS(3198),
    [anon_sym_AMP] = ACTIONS(3196),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(3196),
    [anon_sym_typedef] = ACTIONS(3196),
    [anon_sym_in] = ACTIONS(3196),
    [anon_sym_out] = ACTIONS(3196),
    [anon_sym_inout] = ACTIONS(3196),
    [anon_sym_extern] = ACTIONS(3196),
    [anon_sym___attribute__] = ACTIONS(3196),
    [anon_sym_COLON_COLON] = ACTIONS(3198),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3198),
    [anon_sym___declspec] = ACTIONS(3196),
    [anon_sym___based] = ACTIONS(3196),
    [anon_sym___cdecl] = ACTIONS(3196),
    [anon_sym___clrcall] = ACTIONS(3196),
    [anon_sym___stdcall] = ACTIONS(3196),
    [anon_sym___fastcall] = ACTIONS(3196),
    [anon_sym___thiscall] = ACTIONS(3196),
    [anon_sym___vectorcall] = ACTIONS(3196),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_signed] = ACTIONS(3196),
    [anon_sym_unsigned] = ACTIONS(3196),
    [anon_sym_long] = ACTIONS(3196),
    [anon_sym_short] = ACTIONS(3196),
    [anon_sym_LBRACK] = ACTIONS(3196),
    [anon_sym_static] = ACTIONS(3196),
    [anon_sym_register] = ACTIONS(3196),
    [anon_sym_inline] = ACTIONS(3196),
    [anon_sym___inline] = ACTIONS(3196),
    [anon_sym___inline__] = ACTIONS(3196),
    [anon_sym___forceinline] = ACTIONS(3196),
    [anon_sym_thread_local] = ACTIONS(3196),
    [anon_sym___thread] = ACTIONS(3196),
    [anon_sym_const] = ACTIONS(3196),
    [anon_sym_constexpr] = ACTIONS(3196),
    [anon_sym_volatile] = ACTIONS(3196),
    [anon_sym_restrict] = ACTIONS(3196),
    [anon_sym___restrict__] = ACTIONS(3196),
    [anon_sym__Atomic] = ACTIONS(3196),
    [anon_sym__Noreturn] = ACTIONS(3196),
    [anon_sym_noreturn] = ACTIONS(3196),
    [anon_sym_mutable] = ACTIONS(3196),
    [anon_sym_constinit] = ACTIONS(3196),
    [anon_sym_consteval] = ACTIONS(3196),
    [anon_sym_alignas] = ACTIONS(3196),
    [anon_sym__Alignas] = ACTIONS(3196),
    [sym_primitive_type] = ACTIONS(3196),
    [anon_sym_enum] = ACTIONS(3196),
    [anon_sym_class] = ACTIONS(3196),
    [anon_sym_struct] = ACTIONS(3196),
    [anon_sym_union] = ACTIONS(3196),
    [anon_sym_if] = ACTIONS(3196),
    [anon_sym_else] = ACTIONS(3196),
    [anon_sym_switch] = ACTIONS(3196),
    [anon_sym_case] = ACTIONS(3196),
    [anon_sym_default] = ACTIONS(3196),
    [anon_sym_while] = ACTIONS(3196),
    [anon_sym_do] = ACTIONS(3196),
    [anon_sym_for] = ACTIONS(3196),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_break] = ACTIONS(3196),
    [anon_sym_continue] = ACTIONS(3196),
    [anon_sym_goto] = ACTIONS(3196),
    [anon_sym___try] = ACTIONS(3196),
    [anon_sym___leave] = ACTIONS(3196),
    [anon_sym_not] = ACTIONS(3196),
    [anon_sym_compl] = ACTIONS(3196),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(3196),
    [anon_sym___alignof] = ACTIONS(3196),
    [anon_sym__alignof] = ACTIONS(3196),
    [anon_sym_alignof] = ACTIONS(3196),
    [anon_sym__Alignof] = ACTIONS(3196),
    [anon_sym_offsetof] = ACTIONS(3196),
    [anon_sym__Generic] = ACTIONS(3196),
    [anon_sym_asm] = ACTIONS(3196),
    [anon_sym___asm__] = ACTIONS(3196),
    [sym_number_literal] = ACTIONS(3198),
    [anon_sym_L_SQUOTE] = ACTIONS(3198),
    [anon_sym_u_SQUOTE] = ACTIONS(3198),
    [anon_sym_U_SQUOTE] = ACTIONS(3198),
    [anon_sym_u8_SQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_L_DQUOTE] = ACTIONS(3198),
    [anon_sym_u_DQUOTE] = ACTIONS(3198),
    [anon_sym_U_DQUOTE] = ACTIONS(3198),
    [anon_sym_u8_DQUOTE] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [sym_true] = ACTIONS(3196),
    [sym_false] = ACTIONS(3196),
    [anon_sym_NULL] = ACTIONS(3196),
    [anon_sym_nullptr] = ACTIONS(3196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3196),
    [anon_sym_let] = ACTIONS(3196),
    [anon_sym_This] = ACTIONS(3196),
    [anon_sym_decltype] = ACTIONS(3196),
    [sym_virtual] = ACTIONS(3196),
    [anon_sym_explicit] = ACTIONS(3196),
    [anon_sym_typename] = ACTIONS(3196),
    [anon_sym_template] = ACTIONS(3196),
    [anon_sym_operator] = ACTIONS(3196),
    [anon_sym_try] = ACTIONS(3196),
    [anon_sym_delete] = ACTIONS(3196),
    [anon_sym_throw] = ACTIONS(3196),
    [anon_sym_namespace] = ACTIONS(3196),
    [anon_sym_using] = ACTIONS(3196),
    [anon_sym_static_assert] = ACTIONS(3196),
    [anon_sym_concept] = ACTIONS(3196),
    [anon_sym_co_return] = ACTIONS(3196),
    [anon_sym_co_yield] = ACTIONS(3196),
    [anon_sym_R_DQUOTE] = ACTIONS(3198),
    [anon_sym_LR_DQUOTE] = ACTIONS(3198),
    [anon_sym_uR_DQUOTE] = ACTIONS(3198),
    [anon_sym_UR_DQUOTE] = ACTIONS(3198),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3198),
    [anon_sym_co_await] = ACTIONS(3196),
    [anon_sym_new] = ACTIONS(3196),
    [anon_sym_requires] = ACTIONS(3196),
    [sym_this] = ACTIONS(3196),
    [anon_sym_discard] = ACTIONS(3196),
    [anon_sym_precise] = ACTIONS(3196),
    [anon_sym_shared] = ACTIONS(3196),
    [anon_sym_groupshared] = ACTIONS(3196),
    [anon_sym_uniform] = ACTIONS(3196),
    [anon_sym_row_major] = ACTIONS(3196),
    [anon_sym_column_major] = ACTIONS(3196),
    [anon_sym_globallycoherent] = ACTIONS(3196),
    [anon_sym_centroid] = ACTIONS(3196),
    [anon_sym_noperspective] = ACTIONS(3196),
    [anon_sym_nointerpolation] = ACTIONS(3196),
    [anon_sym_sample] = ACTIONS(3196),
    [anon_sym_linear] = ACTIONS(3196),
    [anon_sym_snorm] = ACTIONS(3196),
    [anon_sym_unorm] = ACTIONS(3196),
    [anon_sym_point] = ACTIONS(3196),
    [anon_sym_line] = ACTIONS(3196),
    [anon_sym_triangleadj] = ACTIONS(3196),
    [anon_sym_lineadj] = ACTIONS(3196),
    [anon_sym_triangle] = ACTIONS(3196),
    [anon_sym_cbuffer] = ACTIONS(3196),
    [anon_sym_interface] = ACTIONS(3196),
    [anon_sym_extension] = ACTIONS(3196),
  },
  [732] = {
    [sym_identifier] = ACTIONS(3310),
    [aux_sym_preproc_include_token1] = ACTIONS(3310),
    [aux_sym_preproc_def_token1] = ACTIONS(3310),
    [aux_sym_preproc_if_token1] = ACTIONS(3310),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3310),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3310),
    [sym_preproc_directive] = ACTIONS(3310),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_BANG] = ACTIONS(3312),
    [anon_sym_TILDE] = ACTIONS(3312),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3312),
    [anon_sym_AMP_AMP] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3310),
    [anon_sym_SEMI] = ACTIONS(3312),
    [anon_sym___extension__] = ACTIONS(3310),
    [anon_sym_typedef] = ACTIONS(3310),
    [anon_sym_in] = ACTIONS(3310),
    [anon_sym_out] = ACTIONS(3310),
    [anon_sym_inout] = ACTIONS(3310),
    [anon_sym_extern] = ACTIONS(3310),
    [anon_sym___attribute__] = ACTIONS(3310),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3312),
    [anon_sym___declspec] = ACTIONS(3310),
    [anon_sym___based] = ACTIONS(3310),
    [anon_sym___cdecl] = ACTIONS(3310),
    [anon_sym___clrcall] = ACTIONS(3310),
    [anon_sym___stdcall] = ACTIONS(3310),
    [anon_sym___fastcall] = ACTIONS(3310),
    [anon_sym___thiscall] = ACTIONS(3310),
    [anon_sym___vectorcall] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3312),
    [anon_sym_RBRACE] = ACTIONS(3312),
    [anon_sym_signed] = ACTIONS(3310),
    [anon_sym_unsigned] = ACTIONS(3310),
    [anon_sym_long] = ACTIONS(3310),
    [anon_sym_short] = ACTIONS(3310),
    [anon_sym_LBRACK] = ACTIONS(3310),
    [anon_sym_static] = ACTIONS(3310),
    [anon_sym_register] = ACTIONS(3310),
    [anon_sym_inline] = ACTIONS(3310),
    [anon_sym___inline] = ACTIONS(3310),
    [anon_sym___inline__] = ACTIONS(3310),
    [anon_sym___forceinline] = ACTIONS(3310),
    [anon_sym_thread_local] = ACTIONS(3310),
    [anon_sym___thread] = ACTIONS(3310),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_constexpr] = ACTIONS(3310),
    [anon_sym_volatile] = ACTIONS(3310),
    [anon_sym_restrict] = ACTIONS(3310),
    [anon_sym___restrict__] = ACTIONS(3310),
    [anon_sym__Atomic] = ACTIONS(3310),
    [anon_sym__Noreturn] = ACTIONS(3310),
    [anon_sym_noreturn] = ACTIONS(3310),
    [anon_sym_mutable] = ACTIONS(3310),
    [anon_sym_constinit] = ACTIONS(3310),
    [anon_sym_consteval] = ACTIONS(3310),
    [anon_sym_alignas] = ACTIONS(3310),
    [anon_sym__Alignas] = ACTIONS(3310),
    [sym_primitive_type] = ACTIONS(3310),
    [anon_sym_enum] = ACTIONS(3310),
    [anon_sym_class] = ACTIONS(3310),
    [anon_sym_struct] = ACTIONS(3310),
    [anon_sym_union] = ACTIONS(3310),
    [anon_sym_if] = ACTIONS(3310),
    [anon_sym_else] = ACTIONS(3310),
    [anon_sym_switch] = ACTIONS(3310),
    [anon_sym_case] = ACTIONS(3310),
    [anon_sym_default] = ACTIONS(3310),
    [anon_sym_while] = ACTIONS(3310),
    [anon_sym_do] = ACTIONS(3310),
    [anon_sym_for] = ACTIONS(3310),
    [anon_sym_return] = ACTIONS(3310),
    [anon_sym_break] = ACTIONS(3310),
    [anon_sym_continue] = ACTIONS(3310),
    [anon_sym_goto] = ACTIONS(3310),
    [anon_sym___try] = ACTIONS(3310),
    [anon_sym___leave] = ACTIONS(3310),
    [anon_sym_not] = ACTIONS(3310),
    [anon_sym_compl] = ACTIONS(3310),
    [anon_sym_DASH_DASH] = ACTIONS(3312),
    [anon_sym_PLUS_PLUS] = ACTIONS(3312),
    [anon_sym_sizeof] = ACTIONS(3310),
    [anon_sym___alignof__] = ACTIONS(3310),
    [anon_sym___alignof] = ACTIONS(3310),
    [anon_sym__alignof] = ACTIONS(3310),
    [anon_sym_alignof] = ACTIONS(3310),
    [anon_sym__Alignof] = ACTIONS(3310),
    [anon_sym_offsetof] = ACTIONS(3310),
    [anon_sym__Generic] = ACTIONS(3310),
    [anon_sym_asm] = ACTIONS(3310),
    [anon_sym___asm__] = ACTIONS(3310),
    [sym_number_literal] = ACTIONS(3312),
    [anon_sym_L_SQUOTE] = ACTIONS(3312),
    [anon_sym_u_SQUOTE] = ACTIONS(3312),
    [anon_sym_U_SQUOTE] = ACTIONS(3312),
    [anon_sym_u8_SQUOTE] = ACTIONS(3312),
    [anon_sym_SQUOTE] = ACTIONS(3312),
    [anon_sym_L_DQUOTE] = ACTIONS(3312),
    [anon_sym_u_DQUOTE] = ACTIONS(3312),
    [anon_sym_U_DQUOTE] = ACTIONS(3312),
    [anon_sym_u8_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE] = ACTIONS(3312),
    [sym_true] = ACTIONS(3310),
    [sym_false] = ACTIONS(3310),
    [anon_sym_NULL] = ACTIONS(3310),
    [anon_sym_nullptr] = ACTIONS(3310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3310),
    [anon_sym_let] = ACTIONS(3310),
    [anon_sym_This] = ACTIONS(3310),
    [anon_sym_decltype] = ACTIONS(3310),
    [sym_virtual] = ACTIONS(3310),
    [anon_sym_explicit] = ACTIONS(3310),
    [anon_sym_typename] = ACTIONS(3310),
    [anon_sym_template] = ACTIONS(3310),
    [anon_sym_operator] = ACTIONS(3310),
    [anon_sym_try] = ACTIONS(3310),
    [anon_sym_delete] = ACTIONS(3310),
    [anon_sym_throw] = ACTIONS(3310),
    [anon_sym_namespace] = ACTIONS(3310),
    [anon_sym_using] = ACTIONS(3310),
    [anon_sym_static_assert] = ACTIONS(3310),
    [anon_sym_concept] = ACTIONS(3310),
    [anon_sym_co_return] = ACTIONS(3310),
    [anon_sym_co_yield] = ACTIONS(3310),
    [anon_sym_R_DQUOTE] = ACTIONS(3312),
    [anon_sym_LR_DQUOTE] = ACTIONS(3312),
    [anon_sym_uR_DQUOTE] = ACTIONS(3312),
    [anon_sym_UR_DQUOTE] = ACTIONS(3312),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3312),
    [anon_sym_co_await] = ACTIONS(3310),
    [anon_sym_new] = ACTIONS(3310),
    [anon_sym_requires] = ACTIONS(3310),
    [sym_this] = ACTIONS(3310),
    [anon_sym_discard] = ACTIONS(3310),
    [anon_sym_precise] = ACTIONS(3310),
    [anon_sym_shared] = ACTIONS(3310),
    [anon_sym_groupshared] = ACTIONS(3310),
    [anon_sym_uniform] = ACTIONS(3310),
    [anon_sym_row_major] = ACTIONS(3310),
    [anon_sym_column_major] = ACTIONS(3310),
    [anon_sym_globallycoherent] = ACTIONS(3310),
    [anon_sym_centroid] = ACTIONS(3310),
    [anon_sym_noperspective] = ACTIONS(3310),
    [anon_sym_nointerpolation] = ACTIONS(3310),
    [anon_sym_sample] = ACTIONS(3310),
    [anon_sym_linear] = ACTIONS(3310),
    [anon_sym_snorm] = ACTIONS(3310),
    [anon_sym_unorm] = ACTIONS(3310),
    [anon_sym_point] = ACTIONS(3310),
    [anon_sym_line] = ACTIONS(3310),
    [anon_sym_triangleadj] = ACTIONS(3310),
    [anon_sym_lineadj] = ACTIONS(3310),
    [anon_sym_triangle] = ACTIONS(3310),
    [anon_sym_cbuffer] = ACTIONS(3310),
    [anon_sym_interface] = ACTIONS(3310),
    [anon_sym_extension] = ACTIONS(3310),
  },
  [733] = {
    [sym_identifier] = ACTIONS(2826),
    [aux_sym_preproc_include_token1] = ACTIONS(2826),
    [aux_sym_preproc_def_token1] = ACTIONS(2826),
    [aux_sym_preproc_if_token1] = ACTIONS(2826),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2826),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2826),
    [sym_preproc_directive] = ACTIONS(2826),
    [anon_sym_LPAREN2] = ACTIONS(2824),
    [anon_sym_BANG] = ACTIONS(2824),
    [anon_sym_TILDE] = ACTIONS(2824),
    [anon_sym_DASH] = ACTIONS(2826),
    [anon_sym_PLUS] = ACTIONS(2826),
    [anon_sym_STAR] = ACTIONS(2824),
    [anon_sym_AMP_AMP] = ACTIONS(2824),
    [anon_sym_AMP] = ACTIONS(2826),
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym___extension__] = ACTIONS(2826),
    [anon_sym_typedef] = ACTIONS(2826),
    [anon_sym_in] = ACTIONS(2826),
    [anon_sym_out] = ACTIONS(2826),
    [anon_sym_inout] = ACTIONS(2826),
    [anon_sym_extern] = ACTIONS(2826),
    [anon_sym___attribute__] = ACTIONS(2826),
    [anon_sym_COLON_COLON] = ACTIONS(2824),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2824),
    [anon_sym___declspec] = ACTIONS(2826),
    [anon_sym___based] = ACTIONS(2826),
    [anon_sym___cdecl] = ACTIONS(2826),
    [anon_sym___clrcall] = ACTIONS(2826),
    [anon_sym___stdcall] = ACTIONS(2826),
    [anon_sym___fastcall] = ACTIONS(2826),
    [anon_sym___thiscall] = ACTIONS(2826),
    [anon_sym___vectorcall] = ACTIONS(2826),
    [anon_sym_LBRACE] = ACTIONS(2824),
    [anon_sym_RBRACE] = ACTIONS(2824),
    [anon_sym_signed] = ACTIONS(2826),
    [anon_sym_unsigned] = ACTIONS(2826),
    [anon_sym_long] = ACTIONS(2826),
    [anon_sym_short] = ACTIONS(2826),
    [anon_sym_LBRACK] = ACTIONS(2826),
    [anon_sym_static] = ACTIONS(2826),
    [anon_sym_register] = ACTIONS(2826),
    [anon_sym_inline] = ACTIONS(2826),
    [anon_sym___inline] = ACTIONS(2826),
    [anon_sym___inline__] = ACTIONS(2826),
    [anon_sym___forceinline] = ACTIONS(2826),
    [anon_sym_thread_local] = ACTIONS(2826),
    [anon_sym___thread] = ACTIONS(2826),
    [anon_sym_const] = ACTIONS(2826),
    [anon_sym_constexpr] = ACTIONS(2826),
    [anon_sym_volatile] = ACTIONS(2826),
    [anon_sym_restrict] = ACTIONS(2826),
    [anon_sym___restrict__] = ACTIONS(2826),
    [anon_sym__Atomic] = ACTIONS(2826),
    [anon_sym__Noreturn] = ACTIONS(2826),
    [anon_sym_noreturn] = ACTIONS(2826),
    [anon_sym_mutable] = ACTIONS(2826),
    [anon_sym_constinit] = ACTIONS(2826),
    [anon_sym_consteval] = ACTIONS(2826),
    [anon_sym_alignas] = ACTIONS(2826),
    [anon_sym__Alignas] = ACTIONS(2826),
    [sym_primitive_type] = ACTIONS(2826),
    [anon_sym_enum] = ACTIONS(2826),
    [anon_sym_class] = ACTIONS(2826),
    [anon_sym_struct] = ACTIONS(2826),
    [anon_sym_union] = ACTIONS(2826),
    [anon_sym_if] = ACTIONS(2826),
    [anon_sym_switch] = ACTIONS(2826),
    [anon_sym_case] = ACTIONS(2826),
    [anon_sym_default] = ACTIONS(2826),
    [anon_sym_while] = ACTIONS(2826),
    [anon_sym_do] = ACTIONS(2826),
    [anon_sym_for] = ACTIONS(2826),
    [anon_sym_return] = ACTIONS(2826),
    [anon_sym_break] = ACTIONS(2826),
    [anon_sym_continue] = ACTIONS(2826),
    [anon_sym_goto] = ACTIONS(2826),
    [anon_sym___try] = ACTIONS(2826),
    [anon_sym___leave] = ACTIONS(2826),
    [anon_sym_not] = ACTIONS(2826),
    [anon_sym_compl] = ACTIONS(2826),
    [anon_sym_DASH_DASH] = ACTIONS(2824),
    [anon_sym_PLUS_PLUS] = ACTIONS(2824),
    [anon_sym_sizeof] = ACTIONS(2826),
    [anon_sym___alignof__] = ACTIONS(2826),
    [anon_sym___alignof] = ACTIONS(2826),
    [anon_sym__alignof] = ACTIONS(2826),
    [anon_sym_alignof] = ACTIONS(2826),
    [anon_sym__Alignof] = ACTIONS(2826),
    [anon_sym_offsetof] = ACTIONS(2826),
    [anon_sym__Generic] = ACTIONS(2826),
    [anon_sym_asm] = ACTIONS(2826),
    [anon_sym___asm__] = ACTIONS(2826),
    [anon_sym_DOT] = ACTIONS(2826),
    [sym_number_literal] = ACTIONS(2824),
    [anon_sym_L_SQUOTE] = ACTIONS(2824),
    [anon_sym_u_SQUOTE] = ACTIONS(2824),
    [anon_sym_U_SQUOTE] = ACTIONS(2824),
    [anon_sym_u8_SQUOTE] = ACTIONS(2824),
    [anon_sym_SQUOTE] = ACTIONS(2824),
    [anon_sym_L_DQUOTE] = ACTIONS(2824),
    [anon_sym_u_DQUOTE] = ACTIONS(2824),
    [anon_sym_U_DQUOTE] = ACTIONS(2824),
    [anon_sym_u8_DQUOTE] = ACTIONS(2824),
    [anon_sym_DQUOTE] = ACTIONS(2824),
    [sym_true] = ACTIONS(2826),
    [sym_false] = ACTIONS(2826),
    [anon_sym_NULL] = ACTIONS(2826),
    [anon_sym_nullptr] = ACTIONS(2826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2826),
    [anon_sym_let] = ACTIONS(2826),
    [anon_sym_This] = ACTIONS(2826),
    [anon_sym_decltype] = ACTIONS(2826),
    [sym_virtual] = ACTIONS(2826),
    [anon_sym_explicit] = ACTIONS(2826),
    [anon_sym_typename] = ACTIONS(2826),
    [anon_sym_template] = ACTIONS(2826),
    [anon_sym_operator] = ACTIONS(2826),
    [anon_sym_try] = ACTIONS(2826),
    [anon_sym_delete] = ACTIONS(2826),
    [anon_sym_throw] = ACTIONS(2826),
    [anon_sym_namespace] = ACTIONS(2826),
    [anon_sym_using] = ACTIONS(2826),
    [anon_sym_static_assert] = ACTIONS(2826),
    [anon_sym_concept] = ACTIONS(2826),
    [anon_sym_co_return] = ACTIONS(2826),
    [anon_sym_co_yield] = ACTIONS(2826),
    [anon_sym_R_DQUOTE] = ACTIONS(2824),
    [anon_sym_LR_DQUOTE] = ACTIONS(2824),
    [anon_sym_uR_DQUOTE] = ACTIONS(2824),
    [anon_sym_UR_DQUOTE] = ACTIONS(2824),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2824),
    [anon_sym_co_await] = ACTIONS(2826),
    [anon_sym_new] = ACTIONS(2826),
    [anon_sym_requires] = ACTIONS(2826),
    [sym_this] = ACTIONS(2826),
    [anon_sym_discard] = ACTIONS(2826),
    [anon_sym_precise] = ACTIONS(2826),
    [anon_sym_shared] = ACTIONS(2826),
    [anon_sym_groupshared] = ACTIONS(2826),
    [anon_sym_uniform] = ACTIONS(2826),
    [anon_sym_row_major] = ACTIONS(2826),
    [anon_sym_column_major] = ACTIONS(2826),
    [anon_sym_globallycoherent] = ACTIONS(2826),
    [anon_sym_centroid] = ACTIONS(2826),
    [anon_sym_noperspective] = ACTIONS(2826),
    [anon_sym_nointerpolation] = ACTIONS(2826),
    [anon_sym_sample] = ACTIONS(2826),
    [anon_sym_linear] = ACTIONS(2826),
    [anon_sym_snorm] = ACTIONS(2826),
    [anon_sym_unorm] = ACTIONS(2826),
    [anon_sym_point] = ACTIONS(2826),
    [anon_sym_line] = ACTIONS(2826),
    [anon_sym_triangleadj] = ACTIONS(2826),
    [anon_sym_lineadj] = ACTIONS(2826),
    [anon_sym_triangle] = ACTIONS(2826),
    [anon_sym_cbuffer] = ACTIONS(2826),
    [anon_sym_interface] = ACTIONS(2826),
    [anon_sym_extension] = ACTIONS(2826),
  },
  [734] = {
    [sym_identifier] = ACTIONS(3092),
    [aux_sym_preproc_include_token1] = ACTIONS(3092),
    [aux_sym_preproc_def_token1] = ACTIONS(3092),
    [aux_sym_preproc_if_token1] = ACTIONS(3092),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3092),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3092),
    [sym_preproc_directive] = ACTIONS(3092),
    [anon_sym_LPAREN2] = ACTIONS(3094),
    [anon_sym_BANG] = ACTIONS(3094),
    [anon_sym_TILDE] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_STAR] = ACTIONS(3094),
    [anon_sym_AMP_AMP] = ACTIONS(3094),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_SEMI] = ACTIONS(3094),
    [anon_sym___extension__] = ACTIONS(3092),
    [anon_sym_typedef] = ACTIONS(3092),
    [anon_sym_in] = ACTIONS(3092),
    [anon_sym_out] = ACTIONS(3092),
    [anon_sym_inout] = ACTIONS(3092),
    [anon_sym_extern] = ACTIONS(3092),
    [anon_sym___attribute__] = ACTIONS(3092),
    [anon_sym_COLON_COLON] = ACTIONS(3094),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3094),
    [anon_sym___declspec] = ACTIONS(3092),
    [anon_sym___based] = ACTIONS(3092),
    [anon_sym___cdecl] = ACTIONS(3092),
    [anon_sym___clrcall] = ACTIONS(3092),
    [anon_sym___stdcall] = ACTIONS(3092),
    [anon_sym___fastcall] = ACTIONS(3092),
    [anon_sym___thiscall] = ACTIONS(3092),
    [anon_sym___vectorcall] = ACTIONS(3092),
    [anon_sym_LBRACE] = ACTIONS(3094),
    [anon_sym_RBRACE] = ACTIONS(3094),
    [anon_sym_signed] = ACTIONS(3092),
    [anon_sym_unsigned] = ACTIONS(3092),
    [anon_sym_long] = ACTIONS(3092),
    [anon_sym_short] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_static] = ACTIONS(3092),
    [anon_sym_register] = ACTIONS(3092),
    [anon_sym_inline] = ACTIONS(3092),
    [anon_sym___inline] = ACTIONS(3092),
    [anon_sym___inline__] = ACTIONS(3092),
    [anon_sym___forceinline] = ACTIONS(3092),
    [anon_sym_thread_local] = ACTIONS(3092),
    [anon_sym___thread] = ACTIONS(3092),
    [anon_sym_const] = ACTIONS(3092),
    [anon_sym_constexpr] = ACTIONS(3092),
    [anon_sym_volatile] = ACTIONS(3092),
    [anon_sym_restrict] = ACTIONS(3092),
    [anon_sym___restrict__] = ACTIONS(3092),
    [anon_sym__Atomic] = ACTIONS(3092),
    [anon_sym__Noreturn] = ACTIONS(3092),
    [anon_sym_noreturn] = ACTIONS(3092),
    [anon_sym_mutable] = ACTIONS(3092),
    [anon_sym_constinit] = ACTIONS(3092),
    [anon_sym_consteval] = ACTIONS(3092),
    [anon_sym_alignas] = ACTIONS(3092),
    [anon_sym__Alignas] = ACTIONS(3092),
    [sym_primitive_type] = ACTIONS(3092),
    [anon_sym_enum] = ACTIONS(3092),
    [anon_sym_class] = ACTIONS(3092),
    [anon_sym_struct] = ACTIONS(3092),
    [anon_sym_union] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_else] = ACTIONS(3092),
    [anon_sym_switch] = ACTIONS(3092),
    [anon_sym_case] = ACTIONS(3092),
    [anon_sym_default] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_break] = ACTIONS(3092),
    [anon_sym_continue] = ACTIONS(3092),
    [anon_sym_goto] = ACTIONS(3092),
    [anon_sym___try] = ACTIONS(3092),
    [anon_sym___leave] = ACTIONS(3092),
    [anon_sym_not] = ACTIONS(3092),
    [anon_sym_compl] = ACTIONS(3092),
    [anon_sym_DASH_DASH] = ACTIONS(3094),
    [anon_sym_PLUS_PLUS] = ACTIONS(3094),
    [anon_sym_sizeof] = ACTIONS(3092),
    [anon_sym___alignof__] = ACTIONS(3092),
    [anon_sym___alignof] = ACTIONS(3092),
    [anon_sym__alignof] = ACTIONS(3092),
    [anon_sym_alignof] = ACTIONS(3092),
    [anon_sym__Alignof] = ACTIONS(3092),
    [anon_sym_offsetof] = ACTIONS(3092),
    [anon_sym__Generic] = ACTIONS(3092),
    [anon_sym_asm] = ACTIONS(3092),
    [anon_sym___asm__] = ACTIONS(3092),
    [sym_number_literal] = ACTIONS(3094),
    [anon_sym_L_SQUOTE] = ACTIONS(3094),
    [anon_sym_u_SQUOTE] = ACTIONS(3094),
    [anon_sym_U_SQUOTE] = ACTIONS(3094),
    [anon_sym_u8_SQUOTE] = ACTIONS(3094),
    [anon_sym_SQUOTE] = ACTIONS(3094),
    [anon_sym_L_DQUOTE] = ACTIONS(3094),
    [anon_sym_u_DQUOTE] = ACTIONS(3094),
    [anon_sym_U_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8_DQUOTE] = ACTIONS(3094),
    [anon_sym_DQUOTE] = ACTIONS(3094),
    [sym_true] = ACTIONS(3092),
    [sym_false] = ACTIONS(3092),
    [anon_sym_NULL] = ACTIONS(3092),
    [anon_sym_nullptr] = ACTIONS(3092),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3092),
    [anon_sym_let] = ACTIONS(3092),
    [anon_sym_This] = ACTIONS(3092),
    [anon_sym_decltype] = ACTIONS(3092),
    [sym_virtual] = ACTIONS(3092),
    [anon_sym_explicit] = ACTIONS(3092),
    [anon_sym_typename] = ACTIONS(3092),
    [anon_sym_template] = ACTIONS(3092),
    [anon_sym_operator] = ACTIONS(3092),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_delete] = ACTIONS(3092),
    [anon_sym_throw] = ACTIONS(3092),
    [anon_sym_namespace] = ACTIONS(3092),
    [anon_sym_using] = ACTIONS(3092),
    [anon_sym_static_assert] = ACTIONS(3092),
    [anon_sym_concept] = ACTIONS(3092),
    [anon_sym_co_return] = ACTIONS(3092),
    [anon_sym_co_yield] = ACTIONS(3092),
    [anon_sym_R_DQUOTE] = ACTIONS(3094),
    [anon_sym_LR_DQUOTE] = ACTIONS(3094),
    [anon_sym_uR_DQUOTE] = ACTIONS(3094),
    [anon_sym_UR_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3094),
    [anon_sym_co_await] = ACTIONS(3092),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_requires] = ACTIONS(3092),
    [sym_this] = ACTIONS(3092),
    [anon_sym_discard] = ACTIONS(3092),
    [anon_sym_precise] = ACTIONS(3092),
    [anon_sym_shared] = ACTIONS(3092),
    [anon_sym_groupshared] = ACTIONS(3092),
    [anon_sym_uniform] = ACTIONS(3092),
    [anon_sym_row_major] = ACTIONS(3092),
    [anon_sym_column_major] = ACTIONS(3092),
    [anon_sym_globallycoherent] = ACTIONS(3092),
    [anon_sym_centroid] = ACTIONS(3092),
    [anon_sym_noperspective] = ACTIONS(3092),
    [anon_sym_nointerpolation] = ACTIONS(3092),
    [anon_sym_sample] = ACTIONS(3092),
    [anon_sym_linear] = ACTIONS(3092),
    [anon_sym_snorm] = ACTIONS(3092),
    [anon_sym_unorm] = ACTIONS(3092),
    [anon_sym_point] = ACTIONS(3092),
    [anon_sym_line] = ACTIONS(3092),
    [anon_sym_triangleadj] = ACTIONS(3092),
    [anon_sym_lineadj] = ACTIONS(3092),
    [anon_sym_triangle] = ACTIONS(3092),
    [anon_sym_cbuffer] = ACTIONS(3092),
    [anon_sym_interface] = ACTIONS(3092),
    [anon_sym_extension] = ACTIONS(3092),
  },
  [735] = {
    [sym_identifier] = ACTIONS(3250),
    [aux_sym_preproc_include_token1] = ACTIONS(3250),
    [aux_sym_preproc_def_token1] = ACTIONS(3250),
    [aux_sym_preproc_if_token1] = ACTIONS(3250),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3250),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3250),
    [sym_preproc_directive] = ACTIONS(3250),
    [anon_sym_LPAREN2] = ACTIONS(3252),
    [anon_sym_BANG] = ACTIONS(3252),
    [anon_sym_TILDE] = ACTIONS(3252),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_STAR] = ACTIONS(3252),
    [anon_sym_AMP_AMP] = ACTIONS(3252),
    [anon_sym_AMP] = ACTIONS(3250),
    [anon_sym_SEMI] = ACTIONS(3252),
    [anon_sym___extension__] = ACTIONS(3250),
    [anon_sym_typedef] = ACTIONS(3250),
    [anon_sym_in] = ACTIONS(3250),
    [anon_sym_out] = ACTIONS(3250),
    [anon_sym_inout] = ACTIONS(3250),
    [anon_sym_extern] = ACTIONS(3250),
    [anon_sym___attribute__] = ACTIONS(3250),
    [anon_sym_COLON_COLON] = ACTIONS(3252),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3252),
    [anon_sym___declspec] = ACTIONS(3250),
    [anon_sym___based] = ACTIONS(3250),
    [anon_sym___cdecl] = ACTIONS(3250),
    [anon_sym___clrcall] = ACTIONS(3250),
    [anon_sym___stdcall] = ACTIONS(3250),
    [anon_sym___fastcall] = ACTIONS(3250),
    [anon_sym___thiscall] = ACTIONS(3250),
    [anon_sym___vectorcall] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3252),
    [anon_sym_RBRACE] = ACTIONS(3252),
    [anon_sym_signed] = ACTIONS(3250),
    [anon_sym_unsigned] = ACTIONS(3250),
    [anon_sym_long] = ACTIONS(3250),
    [anon_sym_short] = ACTIONS(3250),
    [anon_sym_LBRACK] = ACTIONS(3250),
    [anon_sym_static] = ACTIONS(3250),
    [anon_sym_register] = ACTIONS(3250),
    [anon_sym_inline] = ACTIONS(3250),
    [anon_sym___inline] = ACTIONS(3250),
    [anon_sym___inline__] = ACTIONS(3250),
    [anon_sym___forceinline] = ACTIONS(3250),
    [anon_sym_thread_local] = ACTIONS(3250),
    [anon_sym___thread] = ACTIONS(3250),
    [anon_sym_const] = ACTIONS(3250),
    [anon_sym_constexpr] = ACTIONS(3250),
    [anon_sym_volatile] = ACTIONS(3250),
    [anon_sym_restrict] = ACTIONS(3250),
    [anon_sym___restrict__] = ACTIONS(3250),
    [anon_sym__Atomic] = ACTIONS(3250),
    [anon_sym__Noreturn] = ACTIONS(3250),
    [anon_sym_noreturn] = ACTIONS(3250),
    [anon_sym_mutable] = ACTIONS(3250),
    [anon_sym_constinit] = ACTIONS(3250),
    [anon_sym_consteval] = ACTIONS(3250),
    [anon_sym_alignas] = ACTIONS(3250),
    [anon_sym__Alignas] = ACTIONS(3250),
    [sym_primitive_type] = ACTIONS(3250),
    [anon_sym_enum] = ACTIONS(3250),
    [anon_sym_class] = ACTIONS(3250),
    [anon_sym_struct] = ACTIONS(3250),
    [anon_sym_union] = ACTIONS(3250),
    [anon_sym_if] = ACTIONS(3250),
    [anon_sym_else] = ACTIONS(3250),
    [anon_sym_switch] = ACTIONS(3250),
    [anon_sym_case] = ACTIONS(3250),
    [anon_sym_default] = ACTIONS(3250),
    [anon_sym_while] = ACTIONS(3250),
    [anon_sym_do] = ACTIONS(3250),
    [anon_sym_for] = ACTIONS(3250),
    [anon_sym_return] = ACTIONS(3250),
    [anon_sym_break] = ACTIONS(3250),
    [anon_sym_continue] = ACTIONS(3250),
    [anon_sym_goto] = ACTIONS(3250),
    [anon_sym___try] = ACTIONS(3250),
    [anon_sym___leave] = ACTIONS(3250),
    [anon_sym_not] = ACTIONS(3250),
    [anon_sym_compl] = ACTIONS(3250),
    [anon_sym_DASH_DASH] = ACTIONS(3252),
    [anon_sym_PLUS_PLUS] = ACTIONS(3252),
    [anon_sym_sizeof] = ACTIONS(3250),
    [anon_sym___alignof__] = ACTIONS(3250),
    [anon_sym___alignof] = ACTIONS(3250),
    [anon_sym__alignof] = ACTIONS(3250),
    [anon_sym_alignof] = ACTIONS(3250),
    [anon_sym__Alignof] = ACTIONS(3250),
    [anon_sym_offsetof] = ACTIONS(3250),
    [anon_sym__Generic] = ACTIONS(3250),
    [anon_sym_asm] = ACTIONS(3250),
    [anon_sym___asm__] = ACTIONS(3250),
    [sym_number_literal] = ACTIONS(3252),
    [anon_sym_L_SQUOTE] = ACTIONS(3252),
    [anon_sym_u_SQUOTE] = ACTIONS(3252),
    [anon_sym_U_SQUOTE] = ACTIONS(3252),
    [anon_sym_u8_SQUOTE] = ACTIONS(3252),
    [anon_sym_SQUOTE] = ACTIONS(3252),
    [anon_sym_L_DQUOTE] = ACTIONS(3252),
    [anon_sym_u_DQUOTE] = ACTIONS(3252),
    [anon_sym_U_DQUOTE] = ACTIONS(3252),
    [anon_sym_u8_DQUOTE] = ACTIONS(3252),
    [anon_sym_DQUOTE] = ACTIONS(3252),
    [sym_true] = ACTIONS(3250),
    [sym_false] = ACTIONS(3250),
    [anon_sym_NULL] = ACTIONS(3250),
    [anon_sym_nullptr] = ACTIONS(3250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3250),
    [anon_sym_let] = ACTIONS(3250),
    [anon_sym_This] = ACTIONS(3250),
    [anon_sym_decltype] = ACTIONS(3250),
    [sym_virtual] = ACTIONS(3250),
    [anon_sym_explicit] = ACTIONS(3250),
    [anon_sym_typename] = ACTIONS(3250),
    [anon_sym_template] = ACTIONS(3250),
    [anon_sym_operator] = ACTIONS(3250),
    [anon_sym_try] = ACTIONS(3250),
    [anon_sym_delete] = ACTIONS(3250),
    [anon_sym_throw] = ACTIONS(3250),
    [anon_sym_namespace] = ACTIONS(3250),
    [anon_sym_using] = ACTIONS(3250),
    [anon_sym_static_assert] = ACTIONS(3250),
    [anon_sym_concept] = ACTIONS(3250),
    [anon_sym_co_return] = ACTIONS(3250),
    [anon_sym_co_yield] = ACTIONS(3250),
    [anon_sym_R_DQUOTE] = ACTIONS(3252),
    [anon_sym_LR_DQUOTE] = ACTIONS(3252),
    [anon_sym_uR_DQUOTE] = ACTIONS(3252),
    [anon_sym_UR_DQUOTE] = ACTIONS(3252),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3252),
    [anon_sym_co_await] = ACTIONS(3250),
    [anon_sym_new] = ACTIONS(3250),
    [anon_sym_requires] = ACTIONS(3250),
    [sym_this] = ACTIONS(3250),
    [anon_sym_discard] = ACTIONS(3250),
    [anon_sym_precise] = ACTIONS(3250),
    [anon_sym_shared] = ACTIONS(3250),
    [anon_sym_groupshared] = ACTIONS(3250),
    [anon_sym_uniform] = ACTIONS(3250),
    [anon_sym_row_major] = ACTIONS(3250),
    [anon_sym_column_major] = ACTIONS(3250),
    [anon_sym_globallycoherent] = ACTIONS(3250),
    [anon_sym_centroid] = ACTIONS(3250),
    [anon_sym_noperspective] = ACTIONS(3250),
    [anon_sym_nointerpolation] = ACTIONS(3250),
    [anon_sym_sample] = ACTIONS(3250),
    [anon_sym_linear] = ACTIONS(3250),
    [anon_sym_snorm] = ACTIONS(3250),
    [anon_sym_unorm] = ACTIONS(3250),
    [anon_sym_point] = ACTIONS(3250),
    [anon_sym_line] = ACTIONS(3250),
    [anon_sym_triangleadj] = ACTIONS(3250),
    [anon_sym_lineadj] = ACTIONS(3250),
    [anon_sym_triangle] = ACTIONS(3250),
    [anon_sym_cbuffer] = ACTIONS(3250),
    [anon_sym_interface] = ACTIONS(3250),
    [anon_sym_extension] = ACTIONS(3250),
  },
  [736] = {
    [sym_identifier] = ACTIONS(2964),
    [aux_sym_preproc_include_token1] = ACTIONS(2964),
    [aux_sym_preproc_def_token1] = ACTIONS(2964),
    [aux_sym_preproc_if_token1] = ACTIONS(2964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2964),
    [sym_preproc_directive] = ACTIONS(2964),
    [anon_sym_LPAREN2] = ACTIONS(2962),
    [anon_sym_BANG] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2964),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_STAR] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym___extension__] = ACTIONS(2964),
    [anon_sym_typedef] = ACTIONS(2964),
    [anon_sym_in] = ACTIONS(2964),
    [anon_sym_out] = ACTIONS(2964),
    [anon_sym_inout] = ACTIONS(2964),
    [anon_sym_extern] = ACTIONS(2964),
    [anon_sym___attribute__] = ACTIONS(2964),
    [anon_sym_COLON_COLON] = ACTIONS(2962),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2962),
    [anon_sym___declspec] = ACTIONS(2964),
    [anon_sym___based] = ACTIONS(2964),
    [anon_sym___cdecl] = ACTIONS(2964),
    [anon_sym___clrcall] = ACTIONS(2964),
    [anon_sym___stdcall] = ACTIONS(2964),
    [anon_sym___fastcall] = ACTIONS(2964),
    [anon_sym___thiscall] = ACTIONS(2964),
    [anon_sym___vectorcall] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_RBRACE] = ACTIONS(2962),
    [anon_sym_signed] = ACTIONS(2964),
    [anon_sym_unsigned] = ACTIONS(2964),
    [anon_sym_long] = ACTIONS(2964),
    [anon_sym_short] = ACTIONS(2964),
    [anon_sym_LBRACK] = ACTIONS(2964),
    [anon_sym_static] = ACTIONS(2964),
    [anon_sym_register] = ACTIONS(2964),
    [anon_sym_inline] = ACTIONS(2964),
    [anon_sym___inline] = ACTIONS(2964),
    [anon_sym___inline__] = ACTIONS(2964),
    [anon_sym___forceinline] = ACTIONS(2964),
    [anon_sym_thread_local] = ACTIONS(2964),
    [anon_sym___thread] = ACTIONS(2964),
    [anon_sym_const] = ACTIONS(2964),
    [anon_sym_constexpr] = ACTIONS(2964),
    [anon_sym_volatile] = ACTIONS(2964),
    [anon_sym_restrict] = ACTIONS(2964),
    [anon_sym___restrict__] = ACTIONS(2964),
    [anon_sym__Atomic] = ACTIONS(2964),
    [anon_sym__Noreturn] = ACTIONS(2964),
    [anon_sym_noreturn] = ACTIONS(2964),
    [anon_sym_mutable] = ACTIONS(2964),
    [anon_sym_constinit] = ACTIONS(2964),
    [anon_sym_consteval] = ACTIONS(2964),
    [anon_sym_alignas] = ACTIONS(2964),
    [anon_sym__Alignas] = ACTIONS(2964),
    [sym_primitive_type] = ACTIONS(2964),
    [anon_sym_enum] = ACTIONS(2964),
    [anon_sym_class] = ACTIONS(2964),
    [anon_sym_struct] = ACTIONS(2964),
    [anon_sym_union] = ACTIONS(2964),
    [anon_sym_if] = ACTIONS(2964),
    [anon_sym_switch] = ACTIONS(2964),
    [anon_sym_case] = ACTIONS(2964),
    [anon_sym_default] = ACTIONS(2964),
    [anon_sym_while] = ACTIONS(2964),
    [anon_sym_do] = ACTIONS(2964),
    [anon_sym_for] = ACTIONS(2964),
    [anon_sym_return] = ACTIONS(2964),
    [anon_sym_break] = ACTIONS(2964),
    [anon_sym_continue] = ACTIONS(2964),
    [anon_sym_goto] = ACTIONS(2964),
    [anon_sym___try] = ACTIONS(2964),
    [anon_sym___leave] = ACTIONS(2964),
    [anon_sym_not] = ACTIONS(2964),
    [anon_sym_compl] = ACTIONS(2964),
    [anon_sym_DASH_DASH] = ACTIONS(2962),
    [anon_sym_PLUS_PLUS] = ACTIONS(2962),
    [anon_sym_sizeof] = ACTIONS(2964),
    [anon_sym___alignof__] = ACTIONS(2964),
    [anon_sym___alignof] = ACTIONS(2964),
    [anon_sym__alignof] = ACTIONS(2964),
    [anon_sym_alignof] = ACTIONS(2964),
    [anon_sym__Alignof] = ACTIONS(2964),
    [anon_sym_offsetof] = ACTIONS(2964),
    [anon_sym__Generic] = ACTIONS(2964),
    [anon_sym_asm] = ACTIONS(2964),
    [anon_sym___asm__] = ACTIONS(2964),
    [anon_sym_DOT] = ACTIONS(2964),
    [sym_number_literal] = ACTIONS(2962),
    [anon_sym_L_SQUOTE] = ACTIONS(2962),
    [anon_sym_u_SQUOTE] = ACTIONS(2962),
    [anon_sym_U_SQUOTE] = ACTIONS(2962),
    [anon_sym_u8_SQUOTE] = ACTIONS(2962),
    [anon_sym_SQUOTE] = ACTIONS(2962),
    [anon_sym_L_DQUOTE] = ACTIONS(2962),
    [anon_sym_u_DQUOTE] = ACTIONS(2962),
    [anon_sym_U_DQUOTE] = ACTIONS(2962),
    [anon_sym_u8_DQUOTE] = ACTIONS(2962),
    [anon_sym_DQUOTE] = ACTIONS(2962),
    [sym_true] = ACTIONS(2964),
    [sym_false] = ACTIONS(2964),
    [anon_sym_NULL] = ACTIONS(2964),
    [anon_sym_nullptr] = ACTIONS(2964),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2964),
    [anon_sym_let] = ACTIONS(2964),
    [anon_sym_This] = ACTIONS(2964),
    [anon_sym_decltype] = ACTIONS(2964),
    [sym_virtual] = ACTIONS(2964),
    [anon_sym_explicit] = ACTIONS(2964),
    [anon_sym_typename] = ACTIONS(2964),
    [anon_sym_template] = ACTIONS(2964),
    [anon_sym_operator] = ACTIONS(2964),
    [anon_sym_try] = ACTIONS(2964),
    [anon_sym_delete] = ACTIONS(2964),
    [anon_sym_throw] = ACTIONS(2964),
    [anon_sym_namespace] = ACTIONS(2964),
    [anon_sym_using] = ACTIONS(2964),
    [anon_sym_static_assert] = ACTIONS(2964),
    [anon_sym_concept] = ACTIONS(2964),
    [anon_sym_co_return] = ACTIONS(2964),
    [anon_sym_co_yield] = ACTIONS(2964),
    [anon_sym_R_DQUOTE] = ACTIONS(2962),
    [anon_sym_LR_DQUOTE] = ACTIONS(2962),
    [anon_sym_uR_DQUOTE] = ACTIONS(2962),
    [anon_sym_UR_DQUOTE] = ACTIONS(2962),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2962),
    [anon_sym_co_await] = ACTIONS(2964),
    [anon_sym_new] = ACTIONS(2964),
    [anon_sym_requires] = ACTIONS(2964),
    [sym_this] = ACTIONS(2964),
    [anon_sym_discard] = ACTIONS(2964),
    [anon_sym_precise] = ACTIONS(2964),
    [anon_sym_shared] = ACTIONS(2964),
    [anon_sym_groupshared] = ACTIONS(2964),
    [anon_sym_uniform] = ACTIONS(2964),
    [anon_sym_row_major] = ACTIONS(2964),
    [anon_sym_column_major] = ACTIONS(2964),
    [anon_sym_globallycoherent] = ACTIONS(2964),
    [anon_sym_centroid] = ACTIONS(2964),
    [anon_sym_noperspective] = ACTIONS(2964),
    [anon_sym_nointerpolation] = ACTIONS(2964),
    [anon_sym_sample] = ACTIONS(2964),
    [anon_sym_linear] = ACTIONS(2964),
    [anon_sym_snorm] = ACTIONS(2964),
    [anon_sym_unorm] = ACTIONS(2964),
    [anon_sym_point] = ACTIONS(2964),
    [anon_sym_line] = ACTIONS(2964),
    [anon_sym_triangleadj] = ACTIONS(2964),
    [anon_sym_lineadj] = ACTIONS(2964),
    [anon_sym_triangle] = ACTIONS(2964),
    [anon_sym_cbuffer] = ACTIONS(2964),
    [anon_sym_interface] = ACTIONS(2964),
    [anon_sym_extension] = ACTIONS(2964),
  },
  [737] = {
    [sym_identifier] = ACTIONS(3246),
    [aux_sym_preproc_include_token1] = ACTIONS(3246),
    [aux_sym_preproc_def_token1] = ACTIONS(3246),
    [aux_sym_preproc_if_token1] = ACTIONS(3246),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3246),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3246),
    [sym_preproc_directive] = ACTIONS(3246),
    [anon_sym_LPAREN2] = ACTIONS(3248),
    [anon_sym_BANG] = ACTIONS(3248),
    [anon_sym_TILDE] = ACTIONS(3248),
    [anon_sym_DASH] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3246),
    [anon_sym_STAR] = ACTIONS(3248),
    [anon_sym_AMP_AMP] = ACTIONS(3248),
    [anon_sym_AMP] = ACTIONS(3246),
    [anon_sym_SEMI] = ACTIONS(3248),
    [anon_sym___extension__] = ACTIONS(3246),
    [anon_sym_typedef] = ACTIONS(3246),
    [anon_sym_in] = ACTIONS(3246),
    [anon_sym_out] = ACTIONS(3246),
    [anon_sym_inout] = ACTIONS(3246),
    [anon_sym_extern] = ACTIONS(3246),
    [anon_sym___attribute__] = ACTIONS(3246),
    [anon_sym_COLON_COLON] = ACTIONS(3248),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3248),
    [anon_sym___declspec] = ACTIONS(3246),
    [anon_sym___based] = ACTIONS(3246),
    [anon_sym___cdecl] = ACTIONS(3246),
    [anon_sym___clrcall] = ACTIONS(3246),
    [anon_sym___stdcall] = ACTIONS(3246),
    [anon_sym___fastcall] = ACTIONS(3246),
    [anon_sym___thiscall] = ACTIONS(3246),
    [anon_sym___vectorcall] = ACTIONS(3246),
    [anon_sym_LBRACE] = ACTIONS(3248),
    [anon_sym_RBRACE] = ACTIONS(3248),
    [anon_sym_signed] = ACTIONS(3246),
    [anon_sym_unsigned] = ACTIONS(3246),
    [anon_sym_long] = ACTIONS(3246),
    [anon_sym_short] = ACTIONS(3246),
    [anon_sym_LBRACK] = ACTIONS(3246),
    [anon_sym_static] = ACTIONS(3246),
    [anon_sym_register] = ACTIONS(3246),
    [anon_sym_inline] = ACTIONS(3246),
    [anon_sym___inline] = ACTIONS(3246),
    [anon_sym___inline__] = ACTIONS(3246),
    [anon_sym___forceinline] = ACTIONS(3246),
    [anon_sym_thread_local] = ACTIONS(3246),
    [anon_sym___thread] = ACTIONS(3246),
    [anon_sym_const] = ACTIONS(3246),
    [anon_sym_constexpr] = ACTIONS(3246),
    [anon_sym_volatile] = ACTIONS(3246),
    [anon_sym_restrict] = ACTIONS(3246),
    [anon_sym___restrict__] = ACTIONS(3246),
    [anon_sym__Atomic] = ACTIONS(3246),
    [anon_sym__Noreturn] = ACTIONS(3246),
    [anon_sym_noreturn] = ACTIONS(3246),
    [anon_sym_mutable] = ACTIONS(3246),
    [anon_sym_constinit] = ACTIONS(3246),
    [anon_sym_consteval] = ACTIONS(3246),
    [anon_sym_alignas] = ACTIONS(3246),
    [anon_sym__Alignas] = ACTIONS(3246),
    [sym_primitive_type] = ACTIONS(3246),
    [anon_sym_enum] = ACTIONS(3246),
    [anon_sym_class] = ACTIONS(3246),
    [anon_sym_struct] = ACTIONS(3246),
    [anon_sym_union] = ACTIONS(3246),
    [anon_sym_if] = ACTIONS(3246),
    [anon_sym_else] = ACTIONS(3246),
    [anon_sym_switch] = ACTIONS(3246),
    [anon_sym_case] = ACTIONS(3246),
    [anon_sym_default] = ACTIONS(3246),
    [anon_sym_while] = ACTIONS(3246),
    [anon_sym_do] = ACTIONS(3246),
    [anon_sym_for] = ACTIONS(3246),
    [anon_sym_return] = ACTIONS(3246),
    [anon_sym_break] = ACTIONS(3246),
    [anon_sym_continue] = ACTIONS(3246),
    [anon_sym_goto] = ACTIONS(3246),
    [anon_sym___try] = ACTIONS(3246),
    [anon_sym___leave] = ACTIONS(3246),
    [anon_sym_not] = ACTIONS(3246),
    [anon_sym_compl] = ACTIONS(3246),
    [anon_sym_DASH_DASH] = ACTIONS(3248),
    [anon_sym_PLUS_PLUS] = ACTIONS(3248),
    [anon_sym_sizeof] = ACTIONS(3246),
    [anon_sym___alignof__] = ACTIONS(3246),
    [anon_sym___alignof] = ACTIONS(3246),
    [anon_sym__alignof] = ACTIONS(3246),
    [anon_sym_alignof] = ACTIONS(3246),
    [anon_sym__Alignof] = ACTIONS(3246),
    [anon_sym_offsetof] = ACTIONS(3246),
    [anon_sym__Generic] = ACTIONS(3246),
    [anon_sym_asm] = ACTIONS(3246),
    [anon_sym___asm__] = ACTIONS(3246),
    [sym_number_literal] = ACTIONS(3248),
    [anon_sym_L_SQUOTE] = ACTIONS(3248),
    [anon_sym_u_SQUOTE] = ACTIONS(3248),
    [anon_sym_U_SQUOTE] = ACTIONS(3248),
    [anon_sym_u8_SQUOTE] = ACTIONS(3248),
    [anon_sym_SQUOTE] = ACTIONS(3248),
    [anon_sym_L_DQUOTE] = ACTIONS(3248),
    [anon_sym_u_DQUOTE] = ACTIONS(3248),
    [anon_sym_U_DQUOTE] = ACTIONS(3248),
    [anon_sym_u8_DQUOTE] = ACTIONS(3248),
    [anon_sym_DQUOTE] = ACTIONS(3248),
    [sym_true] = ACTIONS(3246),
    [sym_false] = ACTIONS(3246),
    [anon_sym_NULL] = ACTIONS(3246),
    [anon_sym_nullptr] = ACTIONS(3246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3246),
    [anon_sym_let] = ACTIONS(3246),
    [anon_sym_This] = ACTIONS(3246),
    [anon_sym_decltype] = ACTIONS(3246),
    [sym_virtual] = ACTIONS(3246),
    [anon_sym_explicit] = ACTIONS(3246),
    [anon_sym_typename] = ACTIONS(3246),
    [anon_sym_template] = ACTIONS(3246),
    [anon_sym_operator] = ACTIONS(3246),
    [anon_sym_try] = ACTIONS(3246),
    [anon_sym_delete] = ACTIONS(3246),
    [anon_sym_throw] = ACTIONS(3246),
    [anon_sym_namespace] = ACTIONS(3246),
    [anon_sym_using] = ACTIONS(3246),
    [anon_sym_static_assert] = ACTIONS(3246),
    [anon_sym_concept] = ACTIONS(3246),
    [anon_sym_co_return] = ACTIONS(3246),
    [anon_sym_co_yield] = ACTIONS(3246),
    [anon_sym_R_DQUOTE] = ACTIONS(3248),
    [anon_sym_LR_DQUOTE] = ACTIONS(3248),
    [anon_sym_uR_DQUOTE] = ACTIONS(3248),
    [anon_sym_UR_DQUOTE] = ACTIONS(3248),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3248),
    [anon_sym_co_await] = ACTIONS(3246),
    [anon_sym_new] = ACTIONS(3246),
    [anon_sym_requires] = ACTIONS(3246),
    [sym_this] = ACTIONS(3246),
    [anon_sym_discard] = ACTIONS(3246),
    [anon_sym_precise] = ACTIONS(3246),
    [anon_sym_shared] = ACTIONS(3246),
    [anon_sym_groupshared] = ACTIONS(3246),
    [anon_sym_uniform] = ACTIONS(3246),
    [anon_sym_row_major] = ACTIONS(3246),
    [anon_sym_column_major] = ACTIONS(3246),
    [anon_sym_globallycoherent] = ACTIONS(3246),
    [anon_sym_centroid] = ACTIONS(3246),
    [anon_sym_noperspective] = ACTIONS(3246),
    [anon_sym_nointerpolation] = ACTIONS(3246),
    [anon_sym_sample] = ACTIONS(3246),
    [anon_sym_linear] = ACTIONS(3246),
    [anon_sym_snorm] = ACTIONS(3246),
    [anon_sym_unorm] = ACTIONS(3246),
    [anon_sym_point] = ACTIONS(3246),
    [anon_sym_line] = ACTIONS(3246),
    [anon_sym_triangleadj] = ACTIONS(3246),
    [anon_sym_lineadj] = ACTIONS(3246),
    [anon_sym_triangle] = ACTIONS(3246),
    [anon_sym_cbuffer] = ACTIONS(3246),
    [anon_sym_interface] = ACTIONS(3246),
    [anon_sym_extension] = ACTIONS(3246),
  },
  [738] = {
    [sym_identifier] = ACTIONS(3242),
    [aux_sym_preproc_include_token1] = ACTIONS(3242),
    [aux_sym_preproc_def_token1] = ACTIONS(3242),
    [aux_sym_preproc_if_token1] = ACTIONS(3242),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3242),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3242),
    [sym_preproc_directive] = ACTIONS(3242),
    [anon_sym_LPAREN2] = ACTIONS(3244),
    [anon_sym_BANG] = ACTIONS(3244),
    [anon_sym_TILDE] = ACTIONS(3244),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_STAR] = ACTIONS(3244),
    [anon_sym_AMP_AMP] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_SEMI] = ACTIONS(3244),
    [anon_sym___extension__] = ACTIONS(3242),
    [anon_sym_typedef] = ACTIONS(3242),
    [anon_sym_in] = ACTIONS(3242),
    [anon_sym_out] = ACTIONS(3242),
    [anon_sym_inout] = ACTIONS(3242),
    [anon_sym_extern] = ACTIONS(3242),
    [anon_sym___attribute__] = ACTIONS(3242),
    [anon_sym_COLON_COLON] = ACTIONS(3244),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3244),
    [anon_sym___declspec] = ACTIONS(3242),
    [anon_sym___based] = ACTIONS(3242),
    [anon_sym___cdecl] = ACTIONS(3242),
    [anon_sym___clrcall] = ACTIONS(3242),
    [anon_sym___stdcall] = ACTIONS(3242),
    [anon_sym___fastcall] = ACTIONS(3242),
    [anon_sym___thiscall] = ACTIONS(3242),
    [anon_sym___vectorcall] = ACTIONS(3242),
    [anon_sym_LBRACE] = ACTIONS(3244),
    [anon_sym_RBRACE] = ACTIONS(3244),
    [anon_sym_signed] = ACTIONS(3242),
    [anon_sym_unsigned] = ACTIONS(3242),
    [anon_sym_long] = ACTIONS(3242),
    [anon_sym_short] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_static] = ACTIONS(3242),
    [anon_sym_register] = ACTIONS(3242),
    [anon_sym_inline] = ACTIONS(3242),
    [anon_sym___inline] = ACTIONS(3242),
    [anon_sym___inline__] = ACTIONS(3242),
    [anon_sym___forceinline] = ACTIONS(3242),
    [anon_sym_thread_local] = ACTIONS(3242),
    [anon_sym___thread] = ACTIONS(3242),
    [anon_sym_const] = ACTIONS(3242),
    [anon_sym_constexpr] = ACTIONS(3242),
    [anon_sym_volatile] = ACTIONS(3242),
    [anon_sym_restrict] = ACTIONS(3242),
    [anon_sym___restrict__] = ACTIONS(3242),
    [anon_sym__Atomic] = ACTIONS(3242),
    [anon_sym__Noreturn] = ACTIONS(3242),
    [anon_sym_noreturn] = ACTIONS(3242),
    [anon_sym_mutable] = ACTIONS(3242),
    [anon_sym_constinit] = ACTIONS(3242),
    [anon_sym_consteval] = ACTIONS(3242),
    [anon_sym_alignas] = ACTIONS(3242),
    [anon_sym__Alignas] = ACTIONS(3242),
    [sym_primitive_type] = ACTIONS(3242),
    [anon_sym_enum] = ACTIONS(3242),
    [anon_sym_class] = ACTIONS(3242),
    [anon_sym_struct] = ACTIONS(3242),
    [anon_sym_union] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_else] = ACTIONS(3242),
    [anon_sym_switch] = ACTIONS(3242),
    [anon_sym_case] = ACTIONS(3242),
    [anon_sym_default] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_break] = ACTIONS(3242),
    [anon_sym_continue] = ACTIONS(3242),
    [anon_sym_goto] = ACTIONS(3242),
    [anon_sym___try] = ACTIONS(3242),
    [anon_sym___leave] = ACTIONS(3242),
    [anon_sym_not] = ACTIONS(3242),
    [anon_sym_compl] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3244),
    [anon_sym_PLUS_PLUS] = ACTIONS(3244),
    [anon_sym_sizeof] = ACTIONS(3242),
    [anon_sym___alignof__] = ACTIONS(3242),
    [anon_sym___alignof] = ACTIONS(3242),
    [anon_sym__alignof] = ACTIONS(3242),
    [anon_sym_alignof] = ACTIONS(3242),
    [anon_sym__Alignof] = ACTIONS(3242),
    [anon_sym_offsetof] = ACTIONS(3242),
    [anon_sym__Generic] = ACTIONS(3242),
    [anon_sym_asm] = ACTIONS(3242),
    [anon_sym___asm__] = ACTIONS(3242),
    [sym_number_literal] = ACTIONS(3244),
    [anon_sym_L_SQUOTE] = ACTIONS(3244),
    [anon_sym_u_SQUOTE] = ACTIONS(3244),
    [anon_sym_U_SQUOTE] = ACTIONS(3244),
    [anon_sym_u8_SQUOTE] = ACTIONS(3244),
    [anon_sym_SQUOTE] = ACTIONS(3244),
    [anon_sym_L_DQUOTE] = ACTIONS(3244),
    [anon_sym_u_DQUOTE] = ACTIONS(3244),
    [anon_sym_U_DQUOTE] = ACTIONS(3244),
    [anon_sym_u8_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE] = ACTIONS(3244),
    [sym_true] = ACTIONS(3242),
    [sym_false] = ACTIONS(3242),
    [anon_sym_NULL] = ACTIONS(3242),
    [anon_sym_nullptr] = ACTIONS(3242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_This] = ACTIONS(3242),
    [anon_sym_decltype] = ACTIONS(3242),
    [sym_virtual] = ACTIONS(3242),
    [anon_sym_explicit] = ACTIONS(3242),
    [anon_sym_typename] = ACTIONS(3242),
    [anon_sym_template] = ACTIONS(3242),
    [anon_sym_operator] = ACTIONS(3242),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_delete] = ACTIONS(3242),
    [anon_sym_throw] = ACTIONS(3242),
    [anon_sym_namespace] = ACTIONS(3242),
    [anon_sym_using] = ACTIONS(3242),
    [anon_sym_static_assert] = ACTIONS(3242),
    [anon_sym_concept] = ACTIONS(3242),
    [anon_sym_co_return] = ACTIONS(3242),
    [anon_sym_co_yield] = ACTIONS(3242),
    [anon_sym_R_DQUOTE] = ACTIONS(3244),
    [anon_sym_LR_DQUOTE] = ACTIONS(3244),
    [anon_sym_uR_DQUOTE] = ACTIONS(3244),
    [anon_sym_UR_DQUOTE] = ACTIONS(3244),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3244),
    [anon_sym_co_await] = ACTIONS(3242),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_requires] = ACTIONS(3242),
    [sym_this] = ACTIONS(3242),
    [anon_sym_discard] = ACTIONS(3242),
    [anon_sym_precise] = ACTIONS(3242),
    [anon_sym_shared] = ACTIONS(3242),
    [anon_sym_groupshared] = ACTIONS(3242),
    [anon_sym_uniform] = ACTIONS(3242),
    [anon_sym_row_major] = ACTIONS(3242),
    [anon_sym_column_major] = ACTIONS(3242),
    [anon_sym_globallycoherent] = ACTIONS(3242),
    [anon_sym_centroid] = ACTIONS(3242),
    [anon_sym_noperspective] = ACTIONS(3242),
    [anon_sym_nointerpolation] = ACTIONS(3242),
    [anon_sym_sample] = ACTIONS(3242),
    [anon_sym_linear] = ACTIONS(3242),
    [anon_sym_snorm] = ACTIONS(3242),
    [anon_sym_unorm] = ACTIONS(3242),
    [anon_sym_point] = ACTIONS(3242),
    [anon_sym_line] = ACTIONS(3242),
    [anon_sym_triangleadj] = ACTIONS(3242),
    [anon_sym_lineadj] = ACTIONS(3242),
    [anon_sym_triangle] = ACTIONS(3242),
    [anon_sym_cbuffer] = ACTIONS(3242),
    [anon_sym_interface] = ACTIONS(3242),
    [anon_sym_extension] = ACTIONS(3242),
  },
  [739] = {
    [sym_identifier] = ACTIONS(3210),
    [aux_sym_preproc_include_token1] = ACTIONS(3210),
    [aux_sym_preproc_def_token1] = ACTIONS(3210),
    [aux_sym_preproc_if_token1] = ACTIONS(3210),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3210),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3210),
    [sym_preproc_directive] = ACTIONS(3210),
    [anon_sym_LPAREN2] = ACTIONS(3212),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3210),
    [anon_sym_PLUS] = ACTIONS(3210),
    [anon_sym_STAR] = ACTIONS(3212),
    [anon_sym_AMP_AMP] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3210),
    [anon_sym_SEMI] = ACTIONS(3212),
    [anon_sym___extension__] = ACTIONS(3210),
    [anon_sym_typedef] = ACTIONS(3210),
    [anon_sym_in] = ACTIONS(3210),
    [anon_sym_out] = ACTIONS(3210),
    [anon_sym_inout] = ACTIONS(3210),
    [anon_sym_extern] = ACTIONS(3210),
    [anon_sym___attribute__] = ACTIONS(3210),
    [anon_sym_COLON_COLON] = ACTIONS(3212),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3212),
    [anon_sym___declspec] = ACTIONS(3210),
    [anon_sym___based] = ACTIONS(3210),
    [anon_sym___cdecl] = ACTIONS(3210),
    [anon_sym___clrcall] = ACTIONS(3210),
    [anon_sym___stdcall] = ACTIONS(3210),
    [anon_sym___fastcall] = ACTIONS(3210),
    [anon_sym___thiscall] = ACTIONS(3210),
    [anon_sym___vectorcall] = ACTIONS(3210),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_RBRACE] = ACTIONS(3212),
    [anon_sym_signed] = ACTIONS(3210),
    [anon_sym_unsigned] = ACTIONS(3210),
    [anon_sym_long] = ACTIONS(3210),
    [anon_sym_short] = ACTIONS(3210),
    [anon_sym_LBRACK] = ACTIONS(3210),
    [anon_sym_static] = ACTIONS(3210),
    [anon_sym_register] = ACTIONS(3210),
    [anon_sym_inline] = ACTIONS(3210),
    [anon_sym___inline] = ACTIONS(3210),
    [anon_sym___inline__] = ACTIONS(3210),
    [anon_sym___forceinline] = ACTIONS(3210),
    [anon_sym_thread_local] = ACTIONS(3210),
    [anon_sym___thread] = ACTIONS(3210),
    [anon_sym_const] = ACTIONS(3210),
    [anon_sym_constexpr] = ACTIONS(3210),
    [anon_sym_volatile] = ACTIONS(3210),
    [anon_sym_restrict] = ACTIONS(3210),
    [anon_sym___restrict__] = ACTIONS(3210),
    [anon_sym__Atomic] = ACTIONS(3210),
    [anon_sym__Noreturn] = ACTIONS(3210),
    [anon_sym_noreturn] = ACTIONS(3210),
    [anon_sym_mutable] = ACTIONS(3210),
    [anon_sym_constinit] = ACTIONS(3210),
    [anon_sym_consteval] = ACTIONS(3210),
    [anon_sym_alignas] = ACTIONS(3210),
    [anon_sym__Alignas] = ACTIONS(3210),
    [sym_primitive_type] = ACTIONS(3210),
    [anon_sym_enum] = ACTIONS(3210),
    [anon_sym_class] = ACTIONS(3210),
    [anon_sym_struct] = ACTIONS(3210),
    [anon_sym_union] = ACTIONS(3210),
    [anon_sym_if] = ACTIONS(3210),
    [anon_sym_else] = ACTIONS(3210),
    [anon_sym_switch] = ACTIONS(3210),
    [anon_sym_case] = ACTIONS(3210),
    [anon_sym_default] = ACTIONS(3210),
    [anon_sym_while] = ACTIONS(3210),
    [anon_sym_do] = ACTIONS(3210),
    [anon_sym_for] = ACTIONS(3210),
    [anon_sym_return] = ACTIONS(3210),
    [anon_sym_break] = ACTIONS(3210),
    [anon_sym_continue] = ACTIONS(3210),
    [anon_sym_goto] = ACTIONS(3210),
    [anon_sym___try] = ACTIONS(3210),
    [anon_sym___leave] = ACTIONS(3210),
    [anon_sym_not] = ACTIONS(3210),
    [anon_sym_compl] = ACTIONS(3210),
    [anon_sym_DASH_DASH] = ACTIONS(3212),
    [anon_sym_PLUS_PLUS] = ACTIONS(3212),
    [anon_sym_sizeof] = ACTIONS(3210),
    [anon_sym___alignof__] = ACTIONS(3210),
    [anon_sym___alignof] = ACTIONS(3210),
    [anon_sym__alignof] = ACTIONS(3210),
    [anon_sym_alignof] = ACTIONS(3210),
    [anon_sym__Alignof] = ACTIONS(3210),
    [anon_sym_offsetof] = ACTIONS(3210),
    [anon_sym__Generic] = ACTIONS(3210),
    [anon_sym_asm] = ACTIONS(3210),
    [anon_sym___asm__] = ACTIONS(3210),
    [sym_number_literal] = ACTIONS(3212),
    [anon_sym_L_SQUOTE] = ACTIONS(3212),
    [anon_sym_u_SQUOTE] = ACTIONS(3212),
    [anon_sym_U_SQUOTE] = ACTIONS(3212),
    [anon_sym_u8_SQUOTE] = ACTIONS(3212),
    [anon_sym_SQUOTE] = ACTIONS(3212),
    [anon_sym_L_DQUOTE] = ACTIONS(3212),
    [anon_sym_u_DQUOTE] = ACTIONS(3212),
    [anon_sym_U_DQUOTE] = ACTIONS(3212),
    [anon_sym_u8_DQUOTE] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [sym_true] = ACTIONS(3210),
    [sym_false] = ACTIONS(3210),
    [anon_sym_NULL] = ACTIONS(3210),
    [anon_sym_nullptr] = ACTIONS(3210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3210),
    [anon_sym_let] = ACTIONS(3210),
    [anon_sym_This] = ACTIONS(3210),
    [anon_sym_decltype] = ACTIONS(3210),
    [sym_virtual] = ACTIONS(3210),
    [anon_sym_explicit] = ACTIONS(3210),
    [anon_sym_typename] = ACTIONS(3210),
    [anon_sym_template] = ACTIONS(3210),
    [anon_sym_operator] = ACTIONS(3210),
    [anon_sym_try] = ACTIONS(3210),
    [anon_sym_delete] = ACTIONS(3210),
    [anon_sym_throw] = ACTIONS(3210),
    [anon_sym_namespace] = ACTIONS(3210),
    [anon_sym_using] = ACTIONS(3210),
    [anon_sym_static_assert] = ACTIONS(3210),
    [anon_sym_concept] = ACTIONS(3210),
    [anon_sym_co_return] = ACTIONS(3210),
    [anon_sym_co_yield] = ACTIONS(3210),
    [anon_sym_R_DQUOTE] = ACTIONS(3212),
    [anon_sym_LR_DQUOTE] = ACTIONS(3212),
    [anon_sym_uR_DQUOTE] = ACTIONS(3212),
    [anon_sym_UR_DQUOTE] = ACTIONS(3212),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3212),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3210),
    [anon_sym_requires] = ACTIONS(3210),
    [sym_this] = ACTIONS(3210),
    [anon_sym_discard] = ACTIONS(3210),
    [anon_sym_precise] = ACTIONS(3210),
    [anon_sym_shared] = ACTIONS(3210),
    [anon_sym_groupshared] = ACTIONS(3210),
    [anon_sym_uniform] = ACTIONS(3210),
    [anon_sym_row_major] = ACTIONS(3210),
    [anon_sym_column_major] = ACTIONS(3210),
    [anon_sym_globallycoherent] = ACTIONS(3210),
    [anon_sym_centroid] = ACTIONS(3210),
    [anon_sym_noperspective] = ACTIONS(3210),
    [anon_sym_nointerpolation] = ACTIONS(3210),
    [anon_sym_sample] = ACTIONS(3210),
    [anon_sym_linear] = ACTIONS(3210),
    [anon_sym_snorm] = ACTIONS(3210),
    [anon_sym_unorm] = ACTIONS(3210),
    [anon_sym_point] = ACTIONS(3210),
    [anon_sym_line] = ACTIONS(3210),
    [anon_sym_triangleadj] = ACTIONS(3210),
    [anon_sym_lineadj] = ACTIONS(3210),
    [anon_sym_triangle] = ACTIONS(3210),
    [anon_sym_cbuffer] = ACTIONS(3210),
    [anon_sym_interface] = ACTIONS(3210),
    [anon_sym_extension] = ACTIONS(3210),
  },
  [740] = {
    [sym_identifier] = ACTIONS(3322),
    [aux_sym_preproc_include_token1] = ACTIONS(3322),
    [aux_sym_preproc_def_token1] = ACTIONS(3322),
    [aux_sym_preproc_if_token1] = ACTIONS(3322),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3322),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3322),
    [sym_preproc_directive] = ACTIONS(3322),
    [anon_sym_LPAREN2] = ACTIONS(3324),
    [anon_sym_BANG] = ACTIONS(3324),
    [anon_sym_TILDE] = ACTIONS(3324),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_STAR] = ACTIONS(3324),
    [anon_sym_AMP_AMP] = ACTIONS(3324),
    [anon_sym_AMP] = ACTIONS(3322),
    [anon_sym_SEMI] = ACTIONS(3324),
    [anon_sym___extension__] = ACTIONS(3322),
    [anon_sym_typedef] = ACTIONS(3322),
    [anon_sym_in] = ACTIONS(3322),
    [anon_sym_out] = ACTIONS(3322),
    [anon_sym_inout] = ACTIONS(3322),
    [anon_sym_extern] = ACTIONS(3322),
    [anon_sym___attribute__] = ACTIONS(3322),
    [anon_sym_COLON_COLON] = ACTIONS(3324),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3324),
    [anon_sym___declspec] = ACTIONS(3322),
    [anon_sym___based] = ACTIONS(3322),
    [anon_sym___cdecl] = ACTIONS(3322),
    [anon_sym___clrcall] = ACTIONS(3322),
    [anon_sym___stdcall] = ACTIONS(3322),
    [anon_sym___fastcall] = ACTIONS(3322),
    [anon_sym___thiscall] = ACTIONS(3322),
    [anon_sym___vectorcall] = ACTIONS(3322),
    [anon_sym_LBRACE] = ACTIONS(3324),
    [anon_sym_RBRACE] = ACTIONS(3324),
    [anon_sym_signed] = ACTIONS(3322),
    [anon_sym_unsigned] = ACTIONS(3322),
    [anon_sym_long] = ACTIONS(3322),
    [anon_sym_short] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_static] = ACTIONS(3322),
    [anon_sym_register] = ACTIONS(3322),
    [anon_sym_inline] = ACTIONS(3322),
    [anon_sym___inline] = ACTIONS(3322),
    [anon_sym___inline__] = ACTIONS(3322),
    [anon_sym___forceinline] = ACTIONS(3322),
    [anon_sym_thread_local] = ACTIONS(3322),
    [anon_sym___thread] = ACTIONS(3322),
    [anon_sym_const] = ACTIONS(3322),
    [anon_sym_constexpr] = ACTIONS(3322),
    [anon_sym_volatile] = ACTIONS(3322),
    [anon_sym_restrict] = ACTIONS(3322),
    [anon_sym___restrict__] = ACTIONS(3322),
    [anon_sym__Atomic] = ACTIONS(3322),
    [anon_sym__Noreturn] = ACTIONS(3322),
    [anon_sym_noreturn] = ACTIONS(3322),
    [anon_sym_mutable] = ACTIONS(3322),
    [anon_sym_constinit] = ACTIONS(3322),
    [anon_sym_consteval] = ACTIONS(3322),
    [anon_sym_alignas] = ACTIONS(3322),
    [anon_sym__Alignas] = ACTIONS(3322),
    [sym_primitive_type] = ACTIONS(3322),
    [anon_sym_enum] = ACTIONS(3322),
    [anon_sym_class] = ACTIONS(3322),
    [anon_sym_struct] = ACTIONS(3322),
    [anon_sym_union] = ACTIONS(3322),
    [anon_sym_if] = ACTIONS(3322),
    [anon_sym_else] = ACTIONS(3322),
    [anon_sym_switch] = ACTIONS(3322),
    [anon_sym_case] = ACTIONS(3322),
    [anon_sym_default] = ACTIONS(3322),
    [anon_sym_while] = ACTIONS(3322),
    [anon_sym_do] = ACTIONS(3322),
    [anon_sym_for] = ACTIONS(3322),
    [anon_sym_return] = ACTIONS(3322),
    [anon_sym_break] = ACTIONS(3322),
    [anon_sym_continue] = ACTIONS(3322),
    [anon_sym_goto] = ACTIONS(3322),
    [anon_sym___try] = ACTIONS(3322),
    [anon_sym___leave] = ACTIONS(3322),
    [anon_sym_not] = ACTIONS(3322),
    [anon_sym_compl] = ACTIONS(3322),
    [anon_sym_DASH_DASH] = ACTIONS(3324),
    [anon_sym_PLUS_PLUS] = ACTIONS(3324),
    [anon_sym_sizeof] = ACTIONS(3322),
    [anon_sym___alignof__] = ACTIONS(3322),
    [anon_sym___alignof] = ACTIONS(3322),
    [anon_sym__alignof] = ACTIONS(3322),
    [anon_sym_alignof] = ACTIONS(3322),
    [anon_sym__Alignof] = ACTIONS(3322),
    [anon_sym_offsetof] = ACTIONS(3322),
    [anon_sym__Generic] = ACTIONS(3322),
    [anon_sym_asm] = ACTIONS(3322),
    [anon_sym___asm__] = ACTIONS(3322),
    [sym_number_literal] = ACTIONS(3324),
    [anon_sym_L_SQUOTE] = ACTIONS(3324),
    [anon_sym_u_SQUOTE] = ACTIONS(3324),
    [anon_sym_U_SQUOTE] = ACTIONS(3324),
    [anon_sym_u8_SQUOTE] = ACTIONS(3324),
    [anon_sym_SQUOTE] = ACTIONS(3324),
    [anon_sym_L_DQUOTE] = ACTIONS(3324),
    [anon_sym_u_DQUOTE] = ACTIONS(3324),
    [anon_sym_U_DQUOTE] = ACTIONS(3324),
    [anon_sym_u8_DQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE] = ACTIONS(3324),
    [sym_true] = ACTIONS(3322),
    [sym_false] = ACTIONS(3322),
    [anon_sym_NULL] = ACTIONS(3322),
    [anon_sym_nullptr] = ACTIONS(3322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3322),
    [anon_sym_let] = ACTIONS(3322),
    [anon_sym_This] = ACTIONS(3322),
    [anon_sym_decltype] = ACTIONS(3322),
    [sym_virtual] = ACTIONS(3322),
    [anon_sym_explicit] = ACTIONS(3322),
    [anon_sym_typename] = ACTIONS(3322),
    [anon_sym_template] = ACTIONS(3322),
    [anon_sym_operator] = ACTIONS(3322),
    [anon_sym_try] = ACTIONS(3322),
    [anon_sym_delete] = ACTIONS(3322),
    [anon_sym_throw] = ACTIONS(3322),
    [anon_sym_namespace] = ACTIONS(3322),
    [anon_sym_using] = ACTIONS(3322),
    [anon_sym_static_assert] = ACTIONS(3322),
    [anon_sym_concept] = ACTIONS(3322),
    [anon_sym_co_return] = ACTIONS(3322),
    [anon_sym_co_yield] = ACTIONS(3322),
    [anon_sym_R_DQUOTE] = ACTIONS(3324),
    [anon_sym_LR_DQUOTE] = ACTIONS(3324),
    [anon_sym_uR_DQUOTE] = ACTIONS(3324),
    [anon_sym_UR_DQUOTE] = ACTIONS(3324),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3324),
    [anon_sym_co_await] = ACTIONS(3322),
    [anon_sym_new] = ACTIONS(3322),
    [anon_sym_requires] = ACTIONS(3322),
    [sym_this] = ACTIONS(3322),
    [anon_sym_discard] = ACTIONS(3322),
    [anon_sym_precise] = ACTIONS(3322),
    [anon_sym_shared] = ACTIONS(3322),
    [anon_sym_groupshared] = ACTIONS(3322),
    [anon_sym_uniform] = ACTIONS(3322),
    [anon_sym_row_major] = ACTIONS(3322),
    [anon_sym_column_major] = ACTIONS(3322),
    [anon_sym_globallycoherent] = ACTIONS(3322),
    [anon_sym_centroid] = ACTIONS(3322),
    [anon_sym_noperspective] = ACTIONS(3322),
    [anon_sym_nointerpolation] = ACTIONS(3322),
    [anon_sym_sample] = ACTIONS(3322),
    [anon_sym_linear] = ACTIONS(3322),
    [anon_sym_snorm] = ACTIONS(3322),
    [anon_sym_unorm] = ACTIONS(3322),
    [anon_sym_point] = ACTIONS(3322),
    [anon_sym_line] = ACTIONS(3322),
    [anon_sym_triangleadj] = ACTIONS(3322),
    [anon_sym_lineadj] = ACTIONS(3322),
    [anon_sym_triangle] = ACTIONS(3322),
    [anon_sym_cbuffer] = ACTIONS(3322),
    [anon_sym_interface] = ACTIONS(3322),
    [anon_sym_extension] = ACTIONS(3322),
  },
  [741] = {
    [sym_identifier] = ACTIONS(2996),
    [aux_sym_preproc_include_token1] = ACTIONS(2996),
    [aux_sym_preproc_def_token1] = ACTIONS(2996),
    [aux_sym_preproc_if_token1] = ACTIONS(2996),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2996),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2996),
    [sym_preproc_directive] = ACTIONS(2996),
    [anon_sym_LPAREN2] = ACTIONS(2994),
    [anon_sym_BANG] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [anon_sym_DASH] = ACTIONS(2996),
    [anon_sym_PLUS] = ACTIONS(2996),
    [anon_sym_STAR] = ACTIONS(2994),
    [anon_sym_AMP_AMP] = ACTIONS(2994),
    [anon_sym_AMP] = ACTIONS(2996),
    [anon_sym_SEMI] = ACTIONS(2994),
    [anon_sym___extension__] = ACTIONS(2996),
    [anon_sym_typedef] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(2996),
    [anon_sym_out] = ACTIONS(2996),
    [anon_sym_inout] = ACTIONS(2996),
    [anon_sym_extern] = ACTIONS(2996),
    [anon_sym___attribute__] = ACTIONS(2996),
    [anon_sym_COLON_COLON] = ACTIONS(2994),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2994),
    [anon_sym___declspec] = ACTIONS(2996),
    [anon_sym___based] = ACTIONS(2996),
    [anon_sym___cdecl] = ACTIONS(2996),
    [anon_sym___clrcall] = ACTIONS(2996),
    [anon_sym___stdcall] = ACTIONS(2996),
    [anon_sym___fastcall] = ACTIONS(2996),
    [anon_sym___thiscall] = ACTIONS(2996),
    [anon_sym___vectorcall] = ACTIONS(2996),
    [anon_sym_LBRACE] = ACTIONS(2994),
    [anon_sym_RBRACE] = ACTIONS(2994),
    [anon_sym_signed] = ACTIONS(2996),
    [anon_sym_unsigned] = ACTIONS(2996),
    [anon_sym_long] = ACTIONS(2996),
    [anon_sym_short] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(2996),
    [anon_sym_static] = ACTIONS(2996),
    [anon_sym_register] = ACTIONS(2996),
    [anon_sym_inline] = ACTIONS(2996),
    [anon_sym___inline] = ACTIONS(2996),
    [anon_sym___inline__] = ACTIONS(2996),
    [anon_sym___forceinline] = ACTIONS(2996),
    [anon_sym_thread_local] = ACTIONS(2996),
    [anon_sym___thread] = ACTIONS(2996),
    [anon_sym_const] = ACTIONS(2996),
    [anon_sym_constexpr] = ACTIONS(2996),
    [anon_sym_volatile] = ACTIONS(2996),
    [anon_sym_restrict] = ACTIONS(2996),
    [anon_sym___restrict__] = ACTIONS(2996),
    [anon_sym__Atomic] = ACTIONS(2996),
    [anon_sym__Noreturn] = ACTIONS(2996),
    [anon_sym_noreturn] = ACTIONS(2996),
    [anon_sym_mutable] = ACTIONS(2996),
    [anon_sym_constinit] = ACTIONS(2996),
    [anon_sym_consteval] = ACTIONS(2996),
    [anon_sym_alignas] = ACTIONS(2996),
    [anon_sym__Alignas] = ACTIONS(2996),
    [sym_primitive_type] = ACTIONS(2996),
    [anon_sym_enum] = ACTIONS(2996),
    [anon_sym_class] = ACTIONS(2996),
    [anon_sym_struct] = ACTIONS(2996),
    [anon_sym_union] = ACTIONS(2996),
    [anon_sym_if] = ACTIONS(2996),
    [anon_sym_switch] = ACTIONS(2996),
    [anon_sym_case] = ACTIONS(2996),
    [anon_sym_default] = ACTIONS(2996),
    [anon_sym_while] = ACTIONS(2996),
    [anon_sym_do] = ACTIONS(2996),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_return] = ACTIONS(2996),
    [anon_sym_break] = ACTIONS(2996),
    [anon_sym_continue] = ACTIONS(2996),
    [anon_sym_goto] = ACTIONS(2996),
    [anon_sym___try] = ACTIONS(2996),
    [anon_sym___leave] = ACTIONS(2996),
    [anon_sym_not] = ACTIONS(2996),
    [anon_sym_compl] = ACTIONS(2996),
    [anon_sym_DASH_DASH] = ACTIONS(2994),
    [anon_sym_PLUS_PLUS] = ACTIONS(2994),
    [anon_sym_sizeof] = ACTIONS(2996),
    [anon_sym___alignof__] = ACTIONS(2996),
    [anon_sym___alignof] = ACTIONS(2996),
    [anon_sym__alignof] = ACTIONS(2996),
    [anon_sym_alignof] = ACTIONS(2996),
    [anon_sym__Alignof] = ACTIONS(2996),
    [anon_sym_offsetof] = ACTIONS(2996),
    [anon_sym__Generic] = ACTIONS(2996),
    [anon_sym_asm] = ACTIONS(2996),
    [anon_sym___asm__] = ACTIONS(2996),
    [anon_sym_DOT] = ACTIONS(2996),
    [sym_number_literal] = ACTIONS(2994),
    [anon_sym_L_SQUOTE] = ACTIONS(2994),
    [anon_sym_u_SQUOTE] = ACTIONS(2994),
    [anon_sym_U_SQUOTE] = ACTIONS(2994),
    [anon_sym_u8_SQUOTE] = ACTIONS(2994),
    [anon_sym_SQUOTE] = ACTIONS(2994),
    [anon_sym_L_DQUOTE] = ACTIONS(2994),
    [anon_sym_u_DQUOTE] = ACTIONS(2994),
    [anon_sym_U_DQUOTE] = ACTIONS(2994),
    [anon_sym_u8_DQUOTE] = ACTIONS(2994),
    [anon_sym_DQUOTE] = ACTIONS(2994),
    [sym_true] = ACTIONS(2996),
    [sym_false] = ACTIONS(2996),
    [anon_sym_NULL] = ACTIONS(2996),
    [anon_sym_nullptr] = ACTIONS(2996),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2996),
    [anon_sym_let] = ACTIONS(2996),
    [anon_sym_This] = ACTIONS(2996),
    [anon_sym_decltype] = ACTIONS(2996),
    [sym_virtual] = ACTIONS(2996),
    [anon_sym_explicit] = ACTIONS(2996),
    [anon_sym_typename] = ACTIONS(2996),
    [anon_sym_template] = ACTIONS(2996),
    [anon_sym_operator] = ACTIONS(2996),
    [anon_sym_try] = ACTIONS(2996),
    [anon_sym_delete] = ACTIONS(2996),
    [anon_sym_throw] = ACTIONS(2996),
    [anon_sym_namespace] = ACTIONS(2996),
    [anon_sym_using] = ACTIONS(2996),
    [anon_sym_static_assert] = ACTIONS(2996),
    [anon_sym_concept] = ACTIONS(2996),
    [anon_sym_co_return] = ACTIONS(2996),
    [anon_sym_co_yield] = ACTIONS(2996),
    [anon_sym_R_DQUOTE] = ACTIONS(2994),
    [anon_sym_LR_DQUOTE] = ACTIONS(2994),
    [anon_sym_uR_DQUOTE] = ACTIONS(2994),
    [anon_sym_UR_DQUOTE] = ACTIONS(2994),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2994),
    [anon_sym_co_await] = ACTIONS(2996),
    [anon_sym_new] = ACTIONS(2996),
    [anon_sym_requires] = ACTIONS(2996),
    [sym_this] = ACTIONS(2996),
    [anon_sym_discard] = ACTIONS(2996),
    [anon_sym_precise] = ACTIONS(2996),
    [anon_sym_shared] = ACTIONS(2996),
    [anon_sym_groupshared] = ACTIONS(2996),
    [anon_sym_uniform] = ACTIONS(2996),
    [anon_sym_row_major] = ACTIONS(2996),
    [anon_sym_column_major] = ACTIONS(2996),
    [anon_sym_globallycoherent] = ACTIONS(2996),
    [anon_sym_centroid] = ACTIONS(2996),
    [anon_sym_noperspective] = ACTIONS(2996),
    [anon_sym_nointerpolation] = ACTIONS(2996),
    [anon_sym_sample] = ACTIONS(2996),
    [anon_sym_linear] = ACTIONS(2996),
    [anon_sym_snorm] = ACTIONS(2996),
    [anon_sym_unorm] = ACTIONS(2996),
    [anon_sym_point] = ACTIONS(2996),
    [anon_sym_line] = ACTIONS(2996),
    [anon_sym_triangleadj] = ACTIONS(2996),
    [anon_sym_lineadj] = ACTIONS(2996),
    [anon_sym_triangle] = ACTIONS(2996),
    [anon_sym_cbuffer] = ACTIONS(2996),
    [anon_sym_interface] = ACTIONS(2996),
    [anon_sym_extension] = ACTIONS(2996),
  },
  [742] = {
    [sym_identifier] = ACTIONS(3318),
    [aux_sym_preproc_include_token1] = ACTIONS(3318),
    [aux_sym_preproc_def_token1] = ACTIONS(3318),
    [aux_sym_preproc_if_token1] = ACTIONS(3318),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3318),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3318),
    [sym_preproc_directive] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(3320),
    [anon_sym_BANG] = ACTIONS(3320),
    [anon_sym_TILDE] = ACTIONS(3320),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3320),
    [anon_sym_AMP_AMP] = ACTIONS(3320),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_SEMI] = ACTIONS(3320),
    [anon_sym___extension__] = ACTIONS(3318),
    [anon_sym_typedef] = ACTIONS(3318),
    [anon_sym_in] = ACTIONS(3318),
    [anon_sym_out] = ACTIONS(3318),
    [anon_sym_inout] = ACTIONS(3318),
    [anon_sym_extern] = ACTIONS(3318),
    [anon_sym___attribute__] = ACTIONS(3318),
    [anon_sym_COLON_COLON] = ACTIONS(3320),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3320),
    [anon_sym___declspec] = ACTIONS(3318),
    [anon_sym___based] = ACTIONS(3318),
    [anon_sym___cdecl] = ACTIONS(3318),
    [anon_sym___clrcall] = ACTIONS(3318),
    [anon_sym___stdcall] = ACTIONS(3318),
    [anon_sym___fastcall] = ACTIONS(3318),
    [anon_sym___thiscall] = ACTIONS(3318),
    [anon_sym___vectorcall] = ACTIONS(3318),
    [anon_sym_LBRACE] = ACTIONS(3320),
    [anon_sym_RBRACE] = ACTIONS(3320),
    [anon_sym_signed] = ACTIONS(3318),
    [anon_sym_unsigned] = ACTIONS(3318),
    [anon_sym_long] = ACTIONS(3318),
    [anon_sym_short] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3318),
    [anon_sym_static] = ACTIONS(3318),
    [anon_sym_register] = ACTIONS(3318),
    [anon_sym_inline] = ACTIONS(3318),
    [anon_sym___inline] = ACTIONS(3318),
    [anon_sym___inline__] = ACTIONS(3318),
    [anon_sym___forceinline] = ACTIONS(3318),
    [anon_sym_thread_local] = ACTIONS(3318),
    [anon_sym___thread] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3318),
    [anon_sym_constexpr] = ACTIONS(3318),
    [anon_sym_volatile] = ACTIONS(3318),
    [anon_sym_restrict] = ACTIONS(3318),
    [anon_sym___restrict__] = ACTIONS(3318),
    [anon_sym__Atomic] = ACTIONS(3318),
    [anon_sym__Noreturn] = ACTIONS(3318),
    [anon_sym_noreturn] = ACTIONS(3318),
    [anon_sym_mutable] = ACTIONS(3318),
    [anon_sym_constinit] = ACTIONS(3318),
    [anon_sym_consteval] = ACTIONS(3318),
    [anon_sym_alignas] = ACTIONS(3318),
    [anon_sym__Alignas] = ACTIONS(3318),
    [sym_primitive_type] = ACTIONS(3318),
    [anon_sym_enum] = ACTIONS(3318),
    [anon_sym_class] = ACTIONS(3318),
    [anon_sym_struct] = ACTIONS(3318),
    [anon_sym_union] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_else] = ACTIONS(3318),
    [anon_sym_switch] = ACTIONS(3318),
    [anon_sym_case] = ACTIONS(3318),
    [anon_sym_default] = ACTIONS(3318),
    [anon_sym_while] = ACTIONS(3318),
    [anon_sym_do] = ACTIONS(3318),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_break] = ACTIONS(3318),
    [anon_sym_continue] = ACTIONS(3318),
    [anon_sym_goto] = ACTIONS(3318),
    [anon_sym___try] = ACTIONS(3318),
    [anon_sym___leave] = ACTIONS(3318),
    [anon_sym_not] = ACTIONS(3318),
    [anon_sym_compl] = ACTIONS(3318),
    [anon_sym_DASH_DASH] = ACTIONS(3320),
    [anon_sym_PLUS_PLUS] = ACTIONS(3320),
    [anon_sym_sizeof] = ACTIONS(3318),
    [anon_sym___alignof__] = ACTIONS(3318),
    [anon_sym___alignof] = ACTIONS(3318),
    [anon_sym__alignof] = ACTIONS(3318),
    [anon_sym_alignof] = ACTIONS(3318),
    [anon_sym__Alignof] = ACTIONS(3318),
    [anon_sym_offsetof] = ACTIONS(3318),
    [anon_sym__Generic] = ACTIONS(3318),
    [anon_sym_asm] = ACTIONS(3318),
    [anon_sym___asm__] = ACTIONS(3318),
    [sym_number_literal] = ACTIONS(3320),
    [anon_sym_L_SQUOTE] = ACTIONS(3320),
    [anon_sym_u_SQUOTE] = ACTIONS(3320),
    [anon_sym_U_SQUOTE] = ACTIONS(3320),
    [anon_sym_u8_SQUOTE] = ACTIONS(3320),
    [anon_sym_SQUOTE] = ACTIONS(3320),
    [anon_sym_L_DQUOTE] = ACTIONS(3320),
    [anon_sym_u_DQUOTE] = ACTIONS(3320),
    [anon_sym_U_DQUOTE] = ACTIONS(3320),
    [anon_sym_u8_DQUOTE] = ACTIONS(3320),
    [anon_sym_DQUOTE] = ACTIONS(3320),
    [sym_true] = ACTIONS(3318),
    [sym_false] = ACTIONS(3318),
    [anon_sym_NULL] = ACTIONS(3318),
    [anon_sym_nullptr] = ACTIONS(3318),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3318),
    [anon_sym_let] = ACTIONS(3318),
    [anon_sym_This] = ACTIONS(3318),
    [anon_sym_decltype] = ACTIONS(3318),
    [sym_virtual] = ACTIONS(3318),
    [anon_sym_explicit] = ACTIONS(3318),
    [anon_sym_typename] = ACTIONS(3318),
    [anon_sym_template] = ACTIONS(3318),
    [anon_sym_operator] = ACTIONS(3318),
    [anon_sym_try] = ACTIONS(3318),
    [anon_sym_delete] = ACTIONS(3318),
    [anon_sym_throw] = ACTIONS(3318),
    [anon_sym_namespace] = ACTIONS(3318),
    [anon_sym_using] = ACTIONS(3318),
    [anon_sym_static_assert] = ACTIONS(3318),
    [anon_sym_concept] = ACTIONS(3318),
    [anon_sym_co_return] = ACTIONS(3318),
    [anon_sym_co_yield] = ACTIONS(3318),
    [anon_sym_R_DQUOTE] = ACTIONS(3320),
    [anon_sym_LR_DQUOTE] = ACTIONS(3320),
    [anon_sym_uR_DQUOTE] = ACTIONS(3320),
    [anon_sym_UR_DQUOTE] = ACTIONS(3320),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3320),
    [anon_sym_co_await] = ACTIONS(3318),
    [anon_sym_new] = ACTIONS(3318),
    [anon_sym_requires] = ACTIONS(3318),
    [sym_this] = ACTIONS(3318),
    [anon_sym_discard] = ACTIONS(3318),
    [anon_sym_precise] = ACTIONS(3318),
    [anon_sym_shared] = ACTIONS(3318),
    [anon_sym_groupshared] = ACTIONS(3318),
    [anon_sym_uniform] = ACTIONS(3318),
    [anon_sym_row_major] = ACTIONS(3318),
    [anon_sym_column_major] = ACTIONS(3318),
    [anon_sym_globallycoherent] = ACTIONS(3318),
    [anon_sym_centroid] = ACTIONS(3318),
    [anon_sym_noperspective] = ACTIONS(3318),
    [anon_sym_nointerpolation] = ACTIONS(3318),
    [anon_sym_sample] = ACTIONS(3318),
    [anon_sym_linear] = ACTIONS(3318),
    [anon_sym_snorm] = ACTIONS(3318),
    [anon_sym_unorm] = ACTIONS(3318),
    [anon_sym_point] = ACTIONS(3318),
    [anon_sym_line] = ACTIONS(3318),
    [anon_sym_triangleadj] = ACTIONS(3318),
    [anon_sym_lineadj] = ACTIONS(3318),
    [anon_sym_triangle] = ACTIONS(3318),
    [anon_sym_cbuffer] = ACTIONS(3318),
    [anon_sym_interface] = ACTIONS(3318),
    [anon_sym_extension] = ACTIONS(3318),
  },
  [743] = {
    [sym_identifier] = ACTIONS(3388),
    [aux_sym_preproc_include_token1] = ACTIONS(3388),
    [aux_sym_preproc_def_token1] = ACTIONS(3388),
    [aux_sym_preproc_if_token1] = ACTIONS(3388),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3388),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3388),
    [sym_preproc_directive] = ACTIONS(3388),
    [anon_sym_LPAREN2] = ACTIONS(3386),
    [anon_sym_BANG] = ACTIONS(3386),
    [anon_sym_TILDE] = ACTIONS(3386),
    [anon_sym_DASH] = ACTIONS(3388),
    [anon_sym_PLUS] = ACTIONS(3388),
    [anon_sym_STAR] = ACTIONS(3386),
    [anon_sym_AMP_AMP] = ACTIONS(3386),
    [anon_sym_AMP] = ACTIONS(3388),
    [anon_sym_SEMI] = ACTIONS(3386),
    [anon_sym___extension__] = ACTIONS(3388),
    [anon_sym_typedef] = ACTIONS(3388),
    [anon_sym_in] = ACTIONS(3388),
    [anon_sym_out] = ACTIONS(3388),
    [anon_sym_inout] = ACTIONS(3388),
    [anon_sym_extern] = ACTIONS(3388),
    [anon_sym___attribute__] = ACTIONS(3388),
    [anon_sym_COLON_COLON] = ACTIONS(3386),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3386),
    [anon_sym___declspec] = ACTIONS(3388),
    [anon_sym___based] = ACTIONS(3388),
    [anon_sym___cdecl] = ACTIONS(3388),
    [anon_sym___clrcall] = ACTIONS(3388),
    [anon_sym___stdcall] = ACTIONS(3388),
    [anon_sym___fastcall] = ACTIONS(3388),
    [anon_sym___thiscall] = ACTIONS(3388),
    [anon_sym___vectorcall] = ACTIONS(3388),
    [anon_sym_LBRACE] = ACTIONS(3386),
    [anon_sym_RBRACE] = ACTIONS(3386),
    [anon_sym_signed] = ACTIONS(3388),
    [anon_sym_unsigned] = ACTIONS(3388),
    [anon_sym_long] = ACTIONS(3388),
    [anon_sym_short] = ACTIONS(3388),
    [anon_sym_LBRACK] = ACTIONS(3388),
    [anon_sym_static] = ACTIONS(3388),
    [anon_sym_register] = ACTIONS(3388),
    [anon_sym_inline] = ACTIONS(3388),
    [anon_sym___inline] = ACTIONS(3388),
    [anon_sym___inline__] = ACTIONS(3388),
    [anon_sym___forceinline] = ACTIONS(3388),
    [anon_sym_thread_local] = ACTIONS(3388),
    [anon_sym___thread] = ACTIONS(3388),
    [anon_sym_const] = ACTIONS(3388),
    [anon_sym_constexpr] = ACTIONS(3388),
    [anon_sym_volatile] = ACTIONS(3388),
    [anon_sym_restrict] = ACTIONS(3388),
    [anon_sym___restrict__] = ACTIONS(3388),
    [anon_sym__Atomic] = ACTIONS(3388),
    [anon_sym__Noreturn] = ACTIONS(3388),
    [anon_sym_noreturn] = ACTIONS(3388),
    [anon_sym_mutable] = ACTIONS(3388),
    [anon_sym_constinit] = ACTIONS(3388),
    [anon_sym_consteval] = ACTIONS(3388),
    [anon_sym_alignas] = ACTIONS(3388),
    [anon_sym__Alignas] = ACTIONS(3388),
    [sym_primitive_type] = ACTIONS(3388),
    [anon_sym_enum] = ACTIONS(3388),
    [anon_sym_class] = ACTIONS(3388),
    [anon_sym_struct] = ACTIONS(3388),
    [anon_sym_union] = ACTIONS(3388),
    [anon_sym_if] = ACTIONS(3388),
    [anon_sym_switch] = ACTIONS(3388),
    [anon_sym_case] = ACTIONS(3388),
    [anon_sym_default] = ACTIONS(3388),
    [anon_sym_while] = ACTIONS(3388),
    [anon_sym_do] = ACTIONS(3388),
    [anon_sym_for] = ACTIONS(3388),
    [anon_sym_return] = ACTIONS(3388),
    [anon_sym_break] = ACTIONS(3388),
    [anon_sym_continue] = ACTIONS(3388),
    [anon_sym_goto] = ACTIONS(3388),
    [anon_sym___try] = ACTIONS(3388),
    [anon_sym___leave] = ACTIONS(3388),
    [anon_sym_not] = ACTIONS(3388),
    [anon_sym_compl] = ACTIONS(3388),
    [anon_sym_DASH_DASH] = ACTIONS(3386),
    [anon_sym_PLUS_PLUS] = ACTIONS(3386),
    [anon_sym_sizeof] = ACTIONS(3388),
    [anon_sym___alignof__] = ACTIONS(3388),
    [anon_sym___alignof] = ACTIONS(3388),
    [anon_sym__alignof] = ACTIONS(3388),
    [anon_sym_alignof] = ACTIONS(3388),
    [anon_sym__Alignof] = ACTIONS(3388),
    [anon_sym_offsetof] = ACTIONS(3388),
    [anon_sym__Generic] = ACTIONS(3388),
    [anon_sym_asm] = ACTIONS(3388),
    [anon_sym___asm__] = ACTIONS(3388),
    [anon_sym_DOT] = ACTIONS(3388),
    [sym_number_literal] = ACTIONS(3386),
    [anon_sym_L_SQUOTE] = ACTIONS(3386),
    [anon_sym_u_SQUOTE] = ACTIONS(3386),
    [anon_sym_U_SQUOTE] = ACTIONS(3386),
    [anon_sym_u8_SQUOTE] = ACTIONS(3386),
    [anon_sym_SQUOTE] = ACTIONS(3386),
    [anon_sym_L_DQUOTE] = ACTIONS(3386),
    [anon_sym_u_DQUOTE] = ACTIONS(3386),
    [anon_sym_U_DQUOTE] = ACTIONS(3386),
    [anon_sym_u8_DQUOTE] = ACTIONS(3386),
    [anon_sym_DQUOTE] = ACTIONS(3386),
    [sym_true] = ACTIONS(3388),
    [sym_false] = ACTIONS(3388),
    [anon_sym_NULL] = ACTIONS(3388),
    [anon_sym_nullptr] = ACTIONS(3388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3388),
    [anon_sym_let] = ACTIONS(3388),
    [anon_sym_This] = ACTIONS(3388),
    [anon_sym_decltype] = ACTIONS(3388),
    [sym_virtual] = ACTIONS(3388),
    [anon_sym_explicit] = ACTIONS(3388),
    [anon_sym_typename] = ACTIONS(3388),
    [anon_sym_template] = ACTIONS(3388),
    [anon_sym_operator] = ACTIONS(3388),
    [anon_sym_try] = ACTIONS(3388),
    [anon_sym_delete] = ACTIONS(3388),
    [anon_sym_throw] = ACTIONS(3388),
    [anon_sym_namespace] = ACTIONS(3388),
    [anon_sym_using] = ACTIONS(3388),
    [anon_sym_static_assert] = ACTIONS(3388),
    [anon_sym_concept] = ACTIONS(3388),
    [anon_sym_co_return] = ACTIONS(3388),
    [anon_sym_co_yield] = ACTIONS(3388),
    [anon_sym_R_DQUOTE] = ACTIONS(3386),
    [anon_sym_LR_DQUOTE] = ACTIONS(3386),
    [anon_sym_uR_DQUOTE] = ACTIONS(3386),
    [anon_sym_UR_DQUOTE] = ACTIONS(3386),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3386),
    [anon_sym_co_await] = ACTIONS(3388),
    [anon_sym_new] = ACTIONS(3388),
    [anon_sym_requires] = ACTIONS(3388),
    [sym_this] = ACTIONS(3388),
    [anon_sym_discard] = ACTIONS(3388),
    [anon_sym_precise] = ACTIONS(3388),
    [anon_sym_shared] = ACTIONS(3388),
    [anon_sym_groupshared] = ACTIONS(3388),
    [anon_sym_uniform] = ACTIONS(3388),
    [anon_sym_row_major] = ACTIONS(3388),
    [anon_sym_column_major] = ACTIONS(3388),
    [anon_sym_globallycoherent] = ACTIONS(3388),
    [anon_sym_centroid] = ACTIONS(3388),
    [anon_sym_noperspective] = ACTIONS(3388),
    [anon_sym_nointerpolation] = ACTIONS(3388),
    [anon_sym_sample] = ACTIONS(3388),
    [anon_sym_linear] = ACTIONS(3388),
    [anon_sym_snorm] = ACTIONS(3388),
    [anon_sym_unorm] = ACTIONS(3388),
    [anon_sym_point] = ACTIONS(3388),
    [anon_sym_line] = ACTIONS(3388),
    [anon_sym_triangleadj] = ACTIONS(3388),
    [anon_sym_lineadj] = ACTIONS(3388),
    [anon_sym_triangle] = ACTIONS(3388),
    [anon_sym_cbuffer] = ACTIONS(3388),
    [anon_sym_interface] = ACTIONS(3388),
    [anon_sym_extension] = ACTIONS(3388),
  },
  [744] = {
    [sym_identifier] = ACTIONS(3890),
    [aux_sym_preproc_include_token1] = ACTIONS(3890),
    [aux_sym_preproc_def_token1] = ACTIONS(3890),
    [aux_sym_preproc_if_token1] = ACTIONS(3890),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3890),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3890),
    [sym_preproc_directive] = ACTIONS(3890),
    [anon_sym_LPAREN2] = ACTIONS(3892),
    [anon_sym_BANG] = ACTIONS(3892),
    [anon_sym_TILDE] = ACTIONS(3892),
    [anon_sym_DASH] = ACTIONS(3890),
    [anon_sym_PLUS] = ACTIONS(3890),
    [anon_sym_STAR] = ACTIONS(3892),
    [anon_sym_AMP_AMP] = ACTIONS(3892),
    [anon_sym_AMP] = ACTIONS(3890),
    [anon_sym_SEMI] = ACTIONS(3892),
    [anon_sym___extension__] = ACTIONS(3890),
    [anon_sym_typedef] = ACTIONS(3890),
    [anon_sym_in] = ACTIONS(3890),
    [anon_sym_out] = ACTIONS(3890),
    [anon_sym_inout] = ACTIONS(3890),
    [anon_sym_extern] = ACTIONS(3890),
    [anon_sym___attribute__] = ACTIONS(3890),
    [anon_sym_COLON_COLON] = ACTIONS(3892),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3892),
    [anon_sym___declspec] = ACTIONS(3890),
    [anon_sym___based] = ACTIONS(3890),
    [anon_sym___cdecl] = ACTIONS(3890),
    [anon_sym___clrcall] = ACTIONS(3890),
    [anon_sym___stdcall] = ACTIONS(3890),
    [anon_sym___fastcall] = ACTIONS(3890),
    [anon_sym___thiscall] = ACTIONS(3890),
    [anon_sym___vectorcall] = ACTIONS(3890),
    [anon_sym_LBRACE] = ACTIONS(3892),
    [anon_sym_RBRACE] = ACTIONS(3892),
    [anon_sym_signed] = ACTIONS(3890),
    [anon_sym_unsigned] = ACTIONS(3890),
    [anon_sym_long] = ACTIONS(3890),
    [anon_sym_short] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3890),
    [anon_sym_static] = ACTIONS(3890),
    [anon_sym_register] = ACTIONS(3890),
    [anon_sym_inline] = ACTIONS(3890),
    [anon_sym___inline] = ACTIONS(3890),
    [anon_sym___inline__] = ACTIONS(3890),
    [anon_sym___forceinline] = ACTIONS(3890),
    [anon_sym_thread_local] = ACTIONS(3890),
    [anon_sym___thread] = ACTIONS(3890),
    [anon_sym_const] = ACTIONS(3890),
    [anon_sym_constexpr] = ACTIONS(3890),
    [anon_sym_volatile] = ACTIONS(3890),
    [anon_sym_restrict] = ACTIONS(3890),
    [anon_sym___restrict__] = ACTIONS(3890),
    [anon_sym__Atomic] = ACTIONS(3890),
    [anon_sym__Noreturn] = ACTIONS(3890),
    [anon_sym_noreturn] = ACTIONS(3890),
    [anon_sym_mutable] = ACTIONS(3890),
    [anon_sym_constinit] = ACTIONS(3890),
    [anon_sym_consteval] = ACTIONS(3890),
    [anon_sym_alignas] = ACTIONS(3890),
    [anon_sym__Alignas] = ACTIONS(3890),
    [sym_primitive_type] = ACTIONS(3890),
    [anon_sym_enum] = ACTIONS(3890),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_struct] = ACTIONS(3890),
    [anon_sym_union] = ACTIONS(3890),
    [anon_sym_if] = ACTIONS(3890),
    [anon_sym_switch] = ACTIONS(3890),
    [anon_sym_case] = ACTIONS(3890),
    [anon_sym_default] = ACTIONS(3890),
    [anon_sym_while] = ACTIONS(3890),
    [anon_sym_do] = ACTIONS(3890),
    [anon_sym_for] = ACTIONS(3890),
    [anon_sym_return] = ACTIONS(3890),
    [anon_sym_break] = ACTIONS(3890),
    [anon_sym_continue] = ACTIONS(3890),
    [anon_sym_goto] = ACTIONS(3890),
    [anon_sym___try] = ACTIONS(3890),
    [anon_sym___leave] = ACTIONS(3890),
    [anon_sym_not] = ACTIONS(3890),
    [anon_sym_compl] = ACTIONS(3890),
    [anon_sym_DASH_DASH] = ACTIONS(3892),
    [anon_sym_PLUS_PLUS] = ACTIONS(3892),
    [anon_sym_sizeof] = ACTIONS(3890),
    [anon_sym___alignof__] = ACTIONS(3890),
    [anon_sym___alignof] = ACTIONS(3890),
    [anon_sym__alignof] = ACTIONS(3890),
    [anon_sym_alignof] = ACTIONS(3890),
    [anon_sym__Alignof] = ACTIONS(3890),
    [anon_sym_offsetof] = ACTIONS(3890),
    [anon_sym__Generic] = ACTIONS(3890),
    [anon_sym_asm] = ACTIONS(3890),
    [anon_sym___asm__] = ACTIONS(3890),
    [anon_sym_DOT] = ACTIONS(2527),
    [sym_number_literal] = ACTIONS(3892),
    [anon_sym_L_SQUOTE] = ACTIONS(3892),
    [anon_sym_u_SQUOTE] = ACTIONS(3892),
    [anon_sym_U_SQUOTE] = ACTIONS(3892),
    [anon_sym_u8_SQUOTE] = ACTIONS(3892),
    [anon_sym_SQUOTE] = ACTIONS(3892),
    [anon_sym_L_DQUOTE] = ACTIONS(3892),
    [anon_sym_u_DQUOTE] = ACTIONS(3892),
    [anon_sym_U_DQUOTE] = ACTIONS(3892),
    [anon_sym_u8_DQUOTE] = ACTIONS(3892),
    [anon_sym_DQUOTE] = ACTIONS(3892),
    [sym_true] = ACTIONS(3890),
    [sym_false] = ACTIONS(3890),
    [anon_sym_NULL] = ACTIONS(3890),
    [anon_sym_nullptr] = ACTIONS(3890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2529),
    [anon_sym_let] = ACTIONS(2529),
    [anon_sym_This] = ACTIONS(2529),
    [anon_sym_decltype] = ACTIONS(3890),
    [sym_virtual] = ACTIONS(3890),
    [anon_sym_explicit] = ACTIONS(3890),
    [anon_sym_typename] = ACTIONS(3890),
    [anon_sym_template] = ACTIONS(3890),
    [anon_sym_operator] = ACTIONS(3890),
    [anon_sym_try] = ACTIONS(3890),
    [anon_sym_delete] = ACTIONS(3890),
    [anon_sym_throw] = ACTIONS(3890),
    [anon_sym_namespace] = ACTIONS(3890),
    [anon_sym_using] = ACTIONS(3890),
    [anon_sym_static_assert] = ACTIONS(3890),
    [anon_sym_concept] = ACTIONS(3890),
    [anon_sym_co_return] = ACTIONS(3890),
    [anon_sym_co_yield] = ACTIONS(3890),
    [anon_sym_R_DQUOTE] = ACTIONS(3892),
    [anon_sym_LR_DQUOTE] = ACTIONS(3892),
    [anon_sym_uR_DQUOTE] = ACTIONS(3892),
    [anon_sym_UR_DQUOTE] = ACTIONS(3892),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3892),
    [anon_sym_co_await] = ACTIONS(3890),
    [anon_sym_new] = ACTIONS(3890),
    [anon_sym_requires] = ACTIONS(3890),
    [sym_this] = ACTIONS(3890),
    [anon_sym_discard] = ACTIONS(3890),
    [anon_sym_precise] = ACTIONS(3890),
    [anon_sym_shared] = ACTIONS(3890),
    [anon_sym_groupshared] = ACTIONS(3890),
    [anon_sym_uniform] = ACTIONS(3890),
    [anon_sym_row_major] = ACTIONS(3890),
    [anon_sym_column_major] = ACTIONS(3890),
    [anon_sym_globallycoherent] = ACTIONS(3890),
    [anon_sym_centroid] = ACTIONS(3890),
    [anon_sym_noperspective] = ACTIONS(3890),
    [anon_sym_nointerpolation] = ACTIONS(3890),
    [anon_sym_sample] = ACTIONS(3890),
    [anon_sym_linear] = ACTIONS(3890),
    [anon_sym_snorm] = ACTIONS(3890),
    [anon_sym_unorm] = ACTIONS(3890),
    [anon_sym_point] = ACTIONS(3890),
    [anon_sym_line] = ACTIONS(3890),
    [anon_sym_triangleadj] = ACTIONS(3890),
    [anon_sym_lineadj] = ACTIONS(3890),
    [anon_sym_triangle] = ACTIONS(3890),
    [anon_sym_cbuffer] = ACTIONS(3890),
    [anon_sym_interface] = ACTIONS(3890),
    [anon_sym_extension] = ACTIONS(3890),
  },
  [745] = {
    [sym_identifier] = ACTIONS(3218),
    [aux_sym_preproc_include_token1] = ACTIONS(3218),
    [aux_sym_preproc_def_token1] = ACTIONS(3218),
    [aux_sym_preproc_if_token1] = ACTIONS(3218),
    [aux_sym_preproc_if_token2] = ACTIONS(3218),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3218),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3218),
    [sym_preproc_directive] = ACTIONS(3218),
    [anon_sym_LPAREN2] = ACTIONS(3220),
    [anon_sym_BANG] = ACTIONS(3220),
    [anon_sym_TILDE] = ACTIONS(3220),
    [anon_sym_DASH] = ACTIONS(3218),
    [anon_sym_PLUS] = ACTIONS(3218),
    [anon_sym_STAR] = ACTIONS(3220),
    [anon_sym_AMP_AMP] = ACTIONS(3220),
    [anon_sym_AMP] = ACTIONS(3218),
    [anon_sym_SEMI] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3218),
    [anon_sym_typedef] = ACTIONS(3218),
    [anon_sym_in] = ACTIONS(3218),
    [anon_sym_out] = ACTIONS(3218),
    [anon_sym_inout] = ACTIONS(3218),
    [anon_sym_extern] = ACTIONS(3218),
    [anon_sym___attribute__] = ACTIONS(3218),
    [anon_sym_COLON_COLON] = ACTIONS(3220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3220),
    [anon_sym___declspec] = ACTIONS(3218),
    [anon_sym___based] = ACTIONS(3218),
    [anon_sym___cdecl] = ACTIONS(3218),
    [anon_sym___clrcall] = ACTIONS(3218),
    [anon_sym___stdcall] = ACTIONS(3218),
    [anon_sym___fastcall] = ACTIONS(3218),
    [anon_sym___thiscall] = ACTIONS(3218),
    [anon_sym___vectorcall] = ACTIONS(3218),
    [anon_sym_LBRACE] = ACTIONS(3220),
    [anon_sym_signed] = ACTIONS(3218),
    [anon_sym_unsigned] = ACTIONS(3218),
    [anon_sym_long] = ACTIONS(3218),
    [anon_sym_short] = ACTIONS(3218),
    [anon_sym_LBRACK] = ACTIONS(3218),
    [anon_sym_static] = ACTIONS(3218),
    [anon_sym_register] = ACTIONS(3218),
    [anon_sym_inline] = ACTIONS(3218),
    [anon_sym___inline] = ACTIONS(3218),
    [anon_sym___inline__] = ACTIONS(3218),
    [anon_sym___forceinline] = ACTIONS(3218),
    [anon_sym_thread_local] = ACTIONS(3218),
    [anon_sym___thread] = ACTIONS(3218),
    [anon_sym_const] = ACTIONS(3218),
    [anon_sym_constexpr] = ACTIONS(3218),
    [anon_sym_volatile] = ACTIONS(3218),
    [anon_sym_restrict] = ACTIONS(3218),
    [anon_sym___restrict__] = ACTIONS(3218),
    [anon_sym__Atomic] = ACTIONS(3218),
    [anon_sym__Noreturn] = ACTIONS(3218),
    [anon_sym_noreturn] = ACTIONS(3218),
    [anon_sym_mutable] = ACTIONS(3218),
    [anon_sym_constinit] = ACTIONS(3218),
    [anon_sym_consteval] = ACTIONS(3218),
    [anon_sym_alignas] = ACTIONS(3218),
    [anon_sym__Alignas] = ACTIONS(3218),
    [sym_primitive_type] = ACTIONS(3218),
    [anon_sym_enum] = ACTIONS(3218),
    [anon_sym_class] = ACTIONS(3218),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3218),
    [anon_sym_if] = ACTIONS(3218),
    [anon_sym_else] = ACTIONS(3218),
    [anon_sym_switch] = ACTIONS(3218),
    [anon_sym_case] = ACTIONS(3218),
    [anon_sym_default] = ACTIONS(3218),
    [anon_sym_while] = ACTIONS(3218),
    [anon_sym_do] = ACTIONS(3218),
    [anon_sym_for] = ACTIONS(3218),
    [anon_sym_return] = ACTIONS(3218),
    [anon_sym_break] = ACTIONS(3218),
    [anon_sym_continue] = ACTIONS(3218),
    [anon_sym_goto] = ACTIONS(3218),
    [anon_sym___try] = ACTIONS(3218),
    [anon_sym___leave] = ACTIONS(3218),
    [anon_sym_not] = ACTIONS(3218),
    [anon_sym_compl] = ACTIONS(3218),
    [anon_sym_DASH_DASH] = ACTIONS(3220),
    [anon_sym_PLUS_PLUS] = ACTIONS(3220),
    [anon_sym_sizeof] = ACTIONS(3218),
    [anon_sym___alignof__] = ACTIONS(3218),
    [anon_sym___alignof] = ACTIONS(3218),
    [anon_sym__alignof] = ACTIONS(3218),
    [anon_sym_alignof] = ACTIONS(3218),
    [anon_sym__Alignof] = ACTIONS(3218),
    [anon_sym_offsetof] = ACTIONS(3218),
    [anon_sym__Generic] = ACTIONS(3218),
    [anon_sym_asm] = ACTIONS(3218),
    [anon_sym___asm__] = ACTIONS(3218),
    [sym_number_literal] = ACTIONS(3220),
    [anon_sym_L_SQUOTE] = ACTIONS(3220),
    [anon_sym_u_SQUOTE] = ACTIONS(3220),
    [anon_sym_U_SQUOTE] = ACTIONS(3220),
    [anon_sym_u8_SQUOTE] = ACTIONS(3220),
    [anon_sym_SQUOTE] = ACTIONS(3220),
    [anon_sym_L_DQUOTE] = ACTIONS(3220),
    [anon_sym_u_DQUOTE] = ACTIONS(3220),
    [anon_sym_U_DQUOTE] = ACTIONS(3220),
    [anon_sym_u8_DQUOTE] = ACTIONS(3220),
    [anon_sym_DQUOTE] = ACTIONS(3220),
    [sym_true] = ACTIONS(3218),
    [sym_false] = ACTIONS(3218),
    [anon_sym_NULL] = ACTIONS(3218),
    [anon_sym_nullptr] = ACTIONS(3218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3218),
    [anon_sym_let] = ACTIONS(3218),
    [anon_sym_This] = ACTIONS(3218),
    [anon_sym_decltype] = ACTIONS(3218),
    [sym_virtual] = ACTIONS(3218),
    [anon_sym_explicit] = ACTIONS(3218),
    [anon_sym_typename] = ACTIONS(3218),
    [anon_sym_template] = ACTIONS(3218),
    [anon_sym_operator] = ACTIONS(3218),
    [anon_sym_try] = ACTIONS(3218),
    [anon_sym_delete] = ACTIONS(3218),
    [anon_sym_throw] = ACTIONS(3218),
    [anon_sym_namespace] = ACTIONS(3218),
    [anon_sym_using] = ACTIONS(3218),
    [anon_sym_static_assert] = ACTIONS(3218),
    [anon_sym_concept] = ACTIONS(3218),
    [anon_sym_co_return] = ACTIONS(3218),
    [anon_sym_co_yield] = ACTIONS(3218),
    [anon_sym_R_DQUOTE] = ACTIONS(3220),
    [anon_sym_LR_DQUOTE] = ACTIONS(3220),
    [anon_sym_uR_DQUOTE] = ACTIONS(3220),
    [anon_sym_UR_DQUOTE] = ACTIONS(3220),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3220),
    [anon_sym_co_await] = ACTIONS(3218),
    [anon_sym_new] = ACTIONS(3218),
    [anon_sym_requires] = ACTIONS(3218),
    [sym_this] = ACTIONS(3218),
    [anon_sym_discard] = ACTIONS(3218),
    [anon_sym_precise] = ACTIONS(3218),
    [anon_sym_shared] = ACTIONS(3218),
    [anon_sym_groupshared] = ACTIONS(3218),
    [anon_sym_uniform] = ACTIONS(3218),
    [anon_sym_row_major] = ACTIONS(3218),
    [anon_sym_column_major] = ACTIONS(3218),
    [anon_sym_globallycoherent] = ACTIONS(3218),
    [anon_sym_centroid] = ACTIONS(3218),
    [anon_sym_noperspective] = ACTIONS(3218),
    [anon_sym_nointerpolation] = ACTIONS(3218),
    [anon_sym_sample] = ACTIONS(3218),
    [anon_sym_linear] = ACTIONS(3218),
    [anon_sym_snorm] = ACTIONS(3218),
    [anon_sym_unorm] = ACTIONS(3218),
    [anon_sym_point] = ACTIONS(3218),
    [anon_sym_line] = ACTIONS(3218),
    [anon_sym_triangleadj] = ACTIONS(3218),
    [anon_sym_lineadj] = ACTIONS(3218),
    [anon_sym_triangle] = ACTIONS(3218),
    [anon_sym_cbuffer] = ACTIONS(3218),
    [anon_sym_interface] = ACTIONS(3218),
    [anon_sym_extension] = ACTIONS(3218),
  },
  [746] = {
    [sym_identifier] = ACTIONS(3034),
    [aux_sym_preproc_include_token1] = ACTIONS(3034),
    [aux_sym_preproc_def_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_BANG] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3034),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_in] = ACTIONS(3034),
    [anon_sym_out] = ACTIONS(3034),
    [anon_sym_inout] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym___based] = ACTIONS(3034),
    [anon_sym___cdecl] = ACTIONS(3034),
    [anon_sym___clrcall] = ACTIONS(3034),
    [anon_sym___stdcall] = ACTIONS(3034),
    [anon_sym___fastcall] = ACTIONS(3034),
    [anon_sym___thiscall] = ACTIONS(3034),
    [anon_sym___vectorcall] = ACTIONS(3034),
    [anon_sym_LBRACE] = ACTIONS(3036),
    [anon_sym_RBRACE] = ACTIONS(3036),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [anon_sym_if] = ACTIONS(3034),
    [anon_sym_else] = ACTIONS(3034),
    [anon_sym_switch] = ACTIONS(3034),
    [anon_sym_case] = ACTIONS(3034),
    [anon_sym_default] = ACTIONS(3034),
    [anon_sym_while] = ACTIONS(3034),
    [anon_sym_do] = ACTIONS(3034),
    [anon_sym_for] = ACTIONS(3034),
    [anon_sym_return] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3034),
    [anon_sym_continue] = ACTIONS(3034),
    [anon_sym_goto] = ACTIONS(3034),
    [anon_sym___try] = ACTIONS(3034),
    [anon_sym___leave] = ACTIONS(3034),
    [anon_sym_not] = ACTIONS(3034),
    [anon_sym_compl] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_sizeof] = ACTIONS(3034),
    [anon_sym___alignof__] = ACTIONS(3034),
    [anon_sym___alignof] = ACTIONS(3034),
    [anon_sym__alignof] = ACTIONS(3034),
    [anon_sym_alignof] = ACTIONS(3034),
    [anon_sym__Alignof] = ACTIONS(3034),
    [anon_sym_offsetof] = ACTIONS(3034),
    [anon_sym__Generic] = ACTIONS(3034),
    [anon_sym_asm] = ACTIONS(3034),
    [anon_sym___asm__] = ACTIONS(3034),
    [sym_number_literal] = ACTIONS(3036),
    [anon_sym_L_SQUOTE] = ACTIONS(3036),
    [anon_sym_u_SQUOTE] = ACTIONS(3036),
    [anon_sym_U_SQUOTE] = ACTIONS(3036),
    [anon_sym_u8_SQUOTE] = ACTIONS(3036),
    [anon_sym_SQUOTE] = ACTIONS(3036),
    [anon_sym_L_DQUOTE] = ACTIONS(3036),
    [anon_sym_u_DQUOTE] = ACTIONS(3036),
    [anon_sym_U_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8_DQUOTE] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [sym_true] = ACTIONS(3034),
    [sym_false] = ACTIONS(3034),
    [anon_sym_NULL] = ACTIONS(3034),
    [anon_sym_nullptr] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_This] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [sym_virtual] = ACTIONS(3034),
    [anon_sym_explicit] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_operator] = ACTIONS(3034),
    [anon_sym_try] = ACTIONS(3034),
    [anon_sym_delete] = ACTIONS(3034),
    [anon_sym_throw] = ACTIONS(3034),
    [anon_sym_namespace] = ACTIONS(3034),
    [anon_sym_using] = ACTIONS(3034),
    [anon_sym_static_assert] = ACTIONS(3034),
    [anon_sym_concept] = ACTIONS(3034),
    [anon_sym_co_return] = ACTIONS(3034),
    [anon_sym_co_yield] = ACTIONS(3034),
    [anon_sym_R_DQUOTE] = ACTIONS(3036),
    [anon_sym_LR_DQUOTE] = ACTIONS(3036),
    [anon_sym_uR_DQUOTE] = ACTIONS(3036),
    [anon_sym_UR_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3036),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3034),
    [anon_sym_requires] = ACTIONS(3034),
    [sym_this] = ACTIONS(3034),
    [anon_sym_discard] = ACTIONS(3034),
    [anon_sym_precise] = ACTIONS(3034),
    [anon_sym_shared] = ACTIONS(3034),
    [anon_sym_groupshared] = ACTIONS(3034),
    [anon_sym_uniform] = ACTIONS(3034),
    [anon_sym_row_major] = ACTIONS(3034),
    [anon_sym_column_major] = ACTIONS(3034),
    [anon_sym_globallycoherent] = ACTIONS(3034),
    [anon_sym_centroid] = ACTIONS(3034),
    [anon_sym_noperspective] = ACTIONS(3034),
    [anon_sym_nointerpolation] = ACTIONS(3034),
    [anon_sym_sample] = ACTIONS(3034),
    [anon_sym_linear] = ACTIONS(3034),
    [anon_sym_snorm] = ACTIONS(3034),
    [anon_sym_unorm] = ACTIONS(3034),
    [anon_sym_point] = ACTIONS(3034),
    [anon_sym_line] = ACTIONS(3034),
    [anon_sym_triangleadj] = ACTIONS(3034),
    [anon_sym_lineadj] = ACTIONS(3034),
    [anon_sym_triangle] = ACTIONS(3034),
    [anon_sym_cbuffer] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3034),
    [anon_sym_extension] = ACTIONS(3034),
  },
  [747] = {
    [sym_identifier] = ACTIONS(3014),
    [aux_sym_preproc_include_token1] = ACTIONS(3014),
    [aux_sym_preproc_def_token1] = ACTIONS(3014),
    [aux_sym_preproc_if_token1] = ACTIONS(3014),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3014),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3014),
    [sym_preproc_directive] = ACTIONS(3014),
    [anon_sym_LPAREN2] = ACTIONS(3016),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [anon_sym_DASH] = ACTIONS(3014),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_STAR] = ACTIONS(3016),
    [anon_sym_AMP_AMP] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3016),
    [anon_sym___extension__] = ACTIONS(3014),
    [anon_sym_typedef] = ACTIONS(3014),
    [anon_sym_in] = ACTIONS(3014),
    [anon_sym_out] = ACTIONS(3014),
    [anon_sym_inout] = ACTIONS(3014),
    [anon_sym_extern] = ACTIONS(3014),
    [anon_sym___attribute__] = ACTIONS(3014),
    [anon_sym_COLON_COLON] = ACTIONS(3016),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3016),
    [anon_sym___declspec] = ACTIONS(3014),
    [anon_sym___based] = ACTIONS(3014),
    [anon_sym___cdecl] = ACTIONS(3014),
    [anon_sym___clrcall] = ACTIONS(3014),
    [anon_sym___stdcall] = ACTIONS(3014),
    [anon_sym___fastcall] = ACTIONS(3014),
    [anon_sym___thiscall] = ACTIONS(3014),
    [anon_sym___vectorcall] = ACTIONS(3014),
    [anon_sym_LBRACE] = ACTIONS(3016),
    [anon_sym_RBRACE] = ACTIONS(3016),
    [anon_sym_signed] = ACTIONS(3014),
    [anon_sym_unsigned] = ACTIONS(3014),
    [anon_sym_long] = ACTIONS(3014),
    [anon_sym_short] = ACTIONS(3014),
    [anon_sym_LBRACK] = ACTIONS(3014),
    [anon_sym_static] = ACTIONS(3014),
    [anon_sym_register] = ACTIONS(3014),
    [anon_sym_inline] = ACTIONS(3014),
    [anon_sym___inline] = ACTIONS(3014),
    [anon_sym___inline__] = ACTIONS(3014),
    [anon_sym___forceinline] = ACTIONS(3014),
    [anon_sym_thread_local] = ACTIONS(3014),
    [anon_sym___thread] = ACTIONS(3014),
    [anon_sym_const] = ACTIONS(3014),
    [anon_sym_constexpr] = ACTIONS(3014),
    [anon_sym_volatile] = ACTIONS(3014),
    [anon_sym_restrict] = ACTIONS(3014),
    [anon_sym___restrict__] = ACTIONS(3014),
    [anon_sym__Atomic] = ACTIONS(3014),
    [anon_sym__Noreturn] = ACTIONS(3014),
    [anon_sym_noreturn] = ACTIONS(3014),
    [anon_sym_mutable] = ACTIONS(3014),
    [anon_sym_constinit] = ACTIONS(3014),
    [anon_sym_consteval] = ACTIONS(3014),
    [anon_sym_alignas] = ACTIONS(3014),
    [anon_sym__Alignas] = ACTIONS(3014),
    [sym_primitive_type] = ACTIONS(3014),
    [anon_sym_enum] = ACTIONS(3014),
    [anon_sym_class] = ACTIONS(3014),
    [anon_sym_struct] = ACTIONS(3014),
    [anon_sym_union] = ACTIONS(3014),
    [anon_sym_if] = ACTIONS(3014),
    [anon_sym_else] = ACTIONS(3014),
    [anon_sym_switch] = ACTIONS(3014),
    [anon_sym_case] = ACTIONS(3014),
    [anon_sym_default] = ACTIONS(3014),
    [anon_sym_while] = ACTIONS(3014),
    [anon_sym_do] = ACTIONS(3014),
    [anon_sym_for] = ACTIONS(3014),
    [anon_sym_return] = ACTIONS(3014),
    [anon_sym_break] = ACTIONS(3014),
    [anon_sym_continue] = ACTIONS(3014),
    [anon_sym_goto] = ACTIONS(3014),
    [anon_sym___try] = ACTIONS(3014),
    [anon_sym___leave] = ACTIONS(3014),
    [anon_sym_not] = ACTIONS(3014),
    [anon_sym_compl] = ACTIONS(3014),
    [anon_sym_DASH_DASH] = ACTIONS(3016),
    [anon_sym_PLUS_PLUS] = ACTIONS(3016),
    [anon_sym_sizeof] = ACTIONS(3014),
    [anon_sym___alignof__] = ACTIONS(3014),
    [anon_sym___alignof] = ACTIONS(3014),
    [anon_sym__alignof] = ACTIONS(3014),
    [anon_sym_alignof] = ACTIONS(3014),
    [anon_sym__Alignof] = ACTIONS(3014),
    [anon_sym_offsetof] = ACTIONS(3014),
    [anon_sym__Generic] = ACTIONS(3014),
    [anon_sym_asm] = ACTIONS(3014),
    [anon_sym___asm__] = ACTIONS(3014),
    [sym_number_literal] = ACTIONS(3016),
    [anon_sym_L_SQUOTE] = ACTIONS(3016),
    [anon_sym_u_SQUOTE] = ACTIONS(3016),
    [anon_sym_U_SQUOTE] = ACTIONS(3016),
    [anon_sym_u8_SQUOTE] = ACTIONS(3016),
    [anon_sym_SQUOTE] = ACTIONS(3016),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3014),
    [sym_false] = ACTIONS(3014),
    [anon_sym_NULL] = ACTIONS(3014),
    [anon_sym_nullptr] = ACTIONS(3014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3014),
    [anon_sym_let] = ACTIONS(3014),
    [anon_sym_This] = ACTIONS(3014),
    [anon_sym_decltype] = ACTIONS(3014),
    [sym_virtual] = ACTIONS(3014),
    [anon_sym_explicit] = ACTIONS(3014),
    [anon_sym_typename] = ACTIONS(3014),
    [anon_sym_template] = ACTIONS(3014),
    [anon_sym_operator] = ACTIONS(3014),
    [anon_sym_try] = ACTIONS(3014),
    [anon_sym_delete] = ACTIONS(3014),
    [anon_sym_throw] = ACTIONS(3014),
    [anon_sym_namespace] = ACTIONS(3014),
    [anon_sym_using] = ACTIONS(3014),
    [anon_sym_static_assert] = ACTIONS(3014),
    [anon_sym_concept] = ACTIONS(3014),
    [anon_sym_co_return] = ACTIONS(3014),
    [anon_sym_co_yield] = ACTIONS(3014),
    [anon_sym_R_DQUOTE] = ACTIONS(3016),
    [anon_sym_LR_DQUOTE] = ACTIONS(3016),
    [anon_sym_uR_DQUOTE] = ACTIONS(3016),
    [anon_sym_UR_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3016),
    [anon_sym_co_await] = ACTIONS(3014),
    [anon_sym_new] = ACTIONS(3014),
    [anon_sym_requires] = ACTIONS(3014),
    [sym_this] = ACTIONS(3014),
    [anon_sym_discard] = ACTIONS(3014),
    [anon_sym_precise] = ACTIONS(3014),
    [anon_sym_shared] = ACTIONS(3014),
    [anon_sym_groupshared] = ACTIONS(3014),
    [anon_sym_uniform] = ACTIONS(3014),
    [anon_sym_row_major] = ACTIONS(3014),
    [anon_sym_column_major] = ACTIONS(3014),
    [anon_sym_globallycoherent] = ACTIONS(3014),
    [anon_sym_centroid] = ACTIONS(3014),
    [anon_sym_noperspective] = ACTIONS(3014),
    [anon_sym_nointerpolation] = ACTIONS(3014),
    [anon_sym_sample] = ACTIONS(3014),
    [anon_sym_linear] = ACTIONS(3014),
    [anon_sym_snorm] = ACTIONS(3014),
    [anon_sym_unorm] = ACTIONS(3014),
    [anon_sym_point] = ACTIONS(3014),
    [anon_sym_line] = ACTIONS(3014),
    [anon_sym_triangleadj] = ACTIONS(3014),
    [anon_sym_lineadj] = ACTIONS(3014),
    [anon_sym_triangle] = ACTIONS(3014),
    [anon_sym_cbuffer] = ACTIONS(3014),
    [anon_sym_interface] = ACTIONS(3014),
    [anon_sym_extension] = ACTIONS(3014),
  },
  [748] = {
    [sym_identifier] = ACTIONS(2944),
    [aux_sym_preproc_include_token1] = ACTIONS(2944),
    [aux_sym_preproc_def_token1] = ACTIONS(2944),
    [aux_sym_preproc_if_token1] = ACTIONS(2944),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2944),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2944),
    [sym_preproc_directive] = ACTIONS(2944),
    [anon_sym_LPAREN2] = ACTIONS(2942),
    [anon_sym_BANG] = ACTIONS(2942),
    [anon_sym_TILDE] = ACTIONS(2942),
    [anon_sym_DASH] = ACTIONS(2944),
    [anon_sym_PLUS] = ACTIONS(2944),
    [anon_sym_STAR] = ACTIONS(2942),
    [anon_sym_AMP_AMP] = ACTIONS(2942),
    [anon_sym_AMP] = ACTIONS(2944),
    [anon_sym_SEMI] = ACTIONS(2942),
    [anon_sym___extension__] = ACTIONS(2944),
    [anon_sym_typedef] = ACTIONS(2944),
    [anon_sym_in] = ACTIONS(2944),
    [anon_sym_out] = ACTIONS(2944),
    [anon_sym_inout] = ACTIONS(2944),
    [anon_sym_extern] = ACTIONS(2944),
    [anon_sym___attribute__] = ACTIONS(2944),
    [anon_sym_COLON_COLON] = ACTIONS(2942),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2942),
    [anon_sym___declspec] = ACTIONS(2944),
    [anon_sym___based] = ACTIONS(2944),
    [anon_sym___cdecl] = ACTIONS(2944),
    [anon_sym___clrcall] = ACTIONS(2944),
    [anon_sym___stdcall] = ACTIONS(2944),
    [anon_sym___fastcall] = ACTIONS(2944),
    [anon_sym___thiscall] = ACTIONS(2944),
    [anon_sym___vectorcall] = ACTIONS(2944),
    [anon_sym_LBRACE] = ACTIONS(2942),
    [anon_sym_RBRACE] = ACTIONS(2942),
    [anon_sym_signed] = ACTIONS(2944),
    [anon_sym_unsigned] = ACTIONS(2944),
    [anon_sym_long] = ACTIONS(2944),
    [anon_sym_short] = ACTIONS(2944),
    [anon_sym_LBRACK] = ACTIONS(2944),
    [anon_sym_static] = ACTIONS(2944),
    [anon_sym_register] = ACTIONS(2944),
    [anon_sym_inline] = ACTIONS(2944),
    [anon_sym___inline] = ACTIONS(2944),
    [anon_sym___inline__] = ACTIONS(2944),
    [anon_sym___forceinline] = ACTIONS(2944),
    [anon_sym_thread_local] = ACTIONS(2944),
    [anon_sym___thread] = ACTIONS(2944),
    [anon_sym_const] = ACTIONS(2944),
    [anon_sym_constexpr] = ACTIONS(2944),
    [anon_sym_volatile] = ACTIONS(2944),
    [anon_sym_restrict] = ACTIONS(2944),
    [anon_sym___restrict__] = ACTIONS(2944),
    [anon_sym__Atomic] = ACTIONS(2944),
    [anon_sym__Noreturn] = ACTIONS(2944),
    [anon_sym_noreturn] = ACTIONS(2944),
    [anon_sym_mutable] = ACTIONS(2944),
    [anon_sym_constinit] = ACTIONS(2944),
    [anon_sym_consteval] = ACTIONS(2944),
    [anon_sym_alignas] = ACTIONS(2944),
    [anon_sym__Alignas] = ACTIONS(2944),
    [sym_primitive_type] = ACTIONS(2944),
    [anon_sym_enum] = ACTIONS(2944),
    [anon_sym_class] = ACTIONS(2944),
    [anon_sym_struct] = ACTIONS(2944),
    [anon_sym_union] = ACTIONS(2944),
    [anon_sym_if] = ACTIONS(2944),
    [anon_sym_switch] = ACTIONS(2944),
    [anon_sym_case] = ACTIONS(2944),
    [anon_sym_default] = ACTIONS(2944),
    [anon_sym_while] = ACTIONS(2944),
    [anon_sym_do] = ACTIONS(2944),
    [anon_sym_for] = ACTIONS(2944),
    [anon_sym_return] = ACTIONS(2944),
    [anon_sym_break] = ACTIONS(2944),
    [anon_sym_continue] = ACTIONS(2944),
    [anon_sym_goto] = ACTIONS(2944),
    [anon_sym___try] = ACTIONS(2944),
    [anon_sym___leave] = ACTIONS(2944),
    [anon_sym_not] = ACTIONS(2944),
    [anon_sym_compl] = ACTIONS(2944),
    [anon_sym_DASH_DASH] = ACTIONS(2942),
    [anon_sym_PLUS_PLUS] = ACTIONS(2942),
    [anon_sym_sizeof] = ACTIONS(2944),
    [anon_sym___alignof__] = ACTIONS(2944),
    [anon_sym___alignof] = ACTIONS(2944),
    [anon_sym__alignof] = ACTIONS(2944),
    [anon_sym_alignof] = ACTIONS(2944),
    [anon_sym__Alignof] = ACTIONS(2944),
    [anon_sym_offsetof] = ACTIONS(2944),
    [anon_sym__Generic] = ACTIONS(2944),
    [anon_sym_asm] = ACTIONS(2944),
    [anon_sym___asm__] = ACTIONS(2944),
    [anon_sym_DOT] = ACTIONS(2944),
    [sym_number_literal] = ACTIONS(2942),
    [anon_sym_L_SQUOTE] = ACTIONS(2942),
    [anon_sym_u_SQUOTE] = ACTIONS(2942),
    [anon_sym_U_SQUOTE] = ACTIONS(2942),
    [anon_sym_u8_SQUOTE] = ACTIONS(2942),
    [anon_sym_SQUOTE] = ACTIONS(2942),
    [anon_sym_L_DQUOTE] = ACTIONS(2942),
    [anon_sym_u_DQUOTE] = ACTIONS(2942),
    [anon_sym_U_DQUOTE] = ACTIONS(2942),
    [anon_sym_u8_DQUOTE] = ACTIONS(2942),
    [anon_sym_DQUOTE] = ACTIONS(2942),
    [sym_true] = ACTIONS(2944),
    [sym_false] = ACTIONS(2944),
    [anon_sym_NULL] = ACTIONS(2944),
    [anon_sym_nullptr] = ACTIONS(2944),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2944),
    [anon_sym_let] = ACTIONS(2944),
    [anon_sym_This] = ACTIONS(2944),
    [anon_sym_decltype] = ACTIONS(2944),
    [sym_virtual] = ACTIONS(2944),
    [anon_sym_explicit] = ACTIONS(2944),
    [anon_sym_typename] = ACTIONS(2944),
    [anon_sym_template] = ACTIONS(2944),
    [anon_sym_operator] = ACTIONS(2944),
    [anon_sym_try] = ACTIONS(2944),
    [anon_sym_delete] = ACTIONS(2944),
    [anon_sym_throw] = ACTIONS(2944),
    [anon_sym_namespace] = ACTIONS(2944),
    [anon_sym_using] = ACTIONS(2944),
    [anon_sym_static_assert] = ACTIONS(2944),
    [anon_sym_concept] = ACTIONS(2944),
    [anon_sym_co_return] = ACTIONS(2944),
    [anon_sym_co_yield] = ACTIONS(2944),
    [anon_sym_R_DQUOTE] = ACTIONS(2942),
    [anon_sym_LR_DQUOTE] = ACTIONS(2942),
    [anon_sym_uR_DQUOTE] = ACTIONS(2942),
    [anon_sym_UR_DQUOTE] = ACTIONS(2942),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2942),
    [anon_sym_co_await] = ACTIONS(2944),
    [anon_sym_new] = ACTIONS(2944),
    [anon_sym_requires] = ACTIONS(2944),
    [sym_this] = ACTIONS(2944),
    [anon_sym_discard] = ACTIONS(2944),
    [anon_sym_precise] = ACTIONS(2944),
    [anon_sym_shared] = ACTIONS(2944),
    [anon_sym_groupshared] = ACTIONS(2944),
    [anon_sym_uniform] = ACTIONS(2944),
    [anon_sym_row_major] = ACTIONS(2944),
    [anon_sym_column_major] = ACTIONS(2944),
    [anon_sym_globallycoherent] = ACTIONS(2944),
    [anon_sym_centroid] = ACTIONS(2944),
    [anon_sym_noperspective] = ACTIONS(2944),
    [anon_sym_nointerpolation] = ACTIONS(2944),
    [anon_sym_sample] = ACTIONS(2944),
    [anon_sym_linear] = ACTIONS(2944),
    [anon_sym_snorm] = ACTIONS(2944),
    [anon_sym_unorm] = ACTIONS(2944),
    [anon_sym_point] = ACTIONS(2944),
    [anon_sym_line] = ACTIONS(2944),
    [anon_sym_triangleadj] = ACTIONS(2944),
    [anon_sym_lineadj] = ACTIONS(2944),
    [anon_sym_triangle] = ACTIONS(2944),
    [anon_sym_cbuffer] = ACTIONS(2944),
    [anon_sym_interface] = ACTIONS(2944),
    [anon_sym_extension] = ACTIONS(2944),
  },
  [749] = {
    [sym_identifier] = ACTIONS(3152),
    [aux_sym_preproc_include_token1] = ACTIONS(3152),
    [aux_sym_preproc_def_token1] = ACTIONS(3152),
    [aux_sym_preproc_if_token1] = ACTIONS(3152),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3152),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3152),
    [sym_preproc_directive] = ACTIONS(3152),
    [anon_sym_LPAREN2] = ACTIONS(3150),
    [anon_sym_BANG] = ACTIONS(3150),
    [anon_sym_TILDE] = ACTIONS(3150),
    [anon_sym_DASH] = ACTIONS(3152),
    [anon_sym_PLUS] = ACTIONS(3152),
    [anon_sym_STAR] = ACTIONS(3150),
    [anon_sym_AMP_AMP] = ACTIONS(3150),
    [anon_sym_AMP] = ACTIONS(3152),
    [anon_sym_SEMI] = ACTIONS(3150),
    [anon_sym___extension__] = ACTIONS(3152),
    [anon_sym_typedef] = ACTIONS(3152),
    [anon_sym_in] = ACTIONS(3152),
    [anon_sym_out] = ACTIONS(3152),
    [anon_sym_inout] = ACTIONS(3152),
    [anon_sym_extern] = ACTIONS(3152),
    [anon_sym___attribute__] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3150),
    [anon_sym___declspec] = ACTIONS(3152),
    [anon_sym___based] = ACTIONS(3152),
    [anon_sym___cdecl] = ACTIONS(3152),
    [anon_sym___clrcall] = ACTIONS(3152),
    [anon_sym___stdcall] = ACTIONS(3152),
    [anon_sym___fastcall] = ACTIONS(3152),
    [anon_sym___thiscall] = ACTIONS(3152),
    [anon_sym___vectorcall] = ACTIONS(3152),
    [anon_sym_LBRACE] = ACTIONS(3150),
    [anon_sym_RBRACE] = ACTIONS(3150),
    [anon_sym_signed] = ACTIONS(3152),
    [anon_sym_unsigned] = ACTIONS(3152),
    [anon_sym_long] = ACTIONS(3152),
    [anon_sym_short] = ACTIONS(3152),
    [anon_sym_LBRACK] = ACTIONS(3152),
    [anon_sym_static] = ACTIONS(3152),
    [anon_sym_register] = ACTIONS(3152),
    [anon_sym_inline] = ACTIONS(3152),
    [anon_sym___inline] = ACTIONS(3152),
    [anon_sym___inline__] = ACTIONS(3152),
    [anon_sym___forceinline] = ACTIONS(3152),
    [anon_sym_thread_local] = ACTIONS(3152),
    [anon_sym___thread] = ACTIONS(3152),
    [anon_sym_const] = ACTIONS(3152),
    [anon_sym_constexpr] = ACTIONS(3152),
    [anon_sym_volatile] = ACTIONS(3152),
    [anon_sym_restrict] = ACTIONS(3152),
    [anon_sym___restrict__] = ACTIONS(3152),
    [anon_sym__Atomic] = ACTIONS(3152),
    [anon_sym__Noreturn] = ACTIONS(3152),
    [anon_sym_noreturn] = ACTIONS(3152),
    [anon_sym_mutable] = ACTIONS(3152),
    [anon_sym_constinit] = ACTIONS(3152),
    [anon_sym_consteval] = ACTIONS(3152),
    [anon_sym_alignas] = ACTIONS(3152),
    [anon_sym__Alignas] = ACTIONS(3152),
    [sym_primitive_type] = ACTIONS(3152),
    [anon_sym_enum] = ACTIONS(3152),
    [anon_sym_class] = ACTIONS(3152),
    [anon_sym_struct] = ACTIONS(3152),
    [anon_sym_union] = ACTIONS(3152),
    [anon_sym_if] = ACTIONS(3152),
    [anon_sym_switch] = ACTIONS(3152),
    [anon_sym_case] = ACTIONS(3152),
    [anon_sym_default] = ACTIONS(3152),
    [anon_sym_while] = ACTIONS(3152),
    [anon_sym_do] = ACTIONS(3152),
    [anon_sym_for] = ACTIONS(3152),
    [anon_sym_return] = ACTIONS(3152),
    [anon_sym_break] = ACTIONS(3152),
    [anon_sym_continue] = ACTIONS(3152),
    [anon_sym_goto] = ACTIONS(3152),
    [anon_sym___try] = ACTIONS(3152),
    [anon_sym___leave] = ACTIONS(3152),
    [anon_sym_not] = ACTIONS(3152),
    [anon_sym_compl] = ACTIONS(3152),
    [anon_sym_DASH_DASH] = ACTIONS(3150),
    [anon_sym_PLUS_PLUS] = ACTIONS(3150),
    [anon_sym_sizeof] = ACTIONS(3152),
    [anon_sym___alignof__] = ACTIONS(3152),
    [anon_sym___alignof] = ACTIONS(3152),
    [anon_sym__alignof] = ACTIONS(3152),
    [anon_sym_alignof] = ACTIONS(3152),
    [anon_sym__Alignof] = ACTIONS(3152),
    [anon_sym_offsetof] = ACTIONS(3152),
    [anon_sym__Generic] = ACTIONS(3152),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym_DOT] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3150),
    [anon_sym_L_SQUOTE] = ACTIONS(3150),
    [anon_sym_u_SQUOTE] = ACTIONS(3150),
    [anon_sym_U_SQUOTE] = ACTIONS(3150),
    [anon_sym_u8_SQUOTE] = ACTIONS(3150),
    [anon_sym_SQUOTE] = ACTIONS(3150),
    [anon_sym_L_DQUOTE] = ACTIONS(3150),
    [anon_sym_u_DQUOTE] = ACTIONS(3150),
    [anon_sym_U_DQUOTE] = ACTIONS(3150),
    [anon_sym_u8_DQUOTE] = ACTIONS(3150),
    [anon_sym_DQUOTE] = ACTIONS(3150),
    [sym_true] = ACTIONS(3152),
    [sym_false] = ACTIONS(3152),
    [anon_sym_NULL] = ACTIONS(3152),
    [anon_sym_nullptr] = ACTIONS(3152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3152),
    [anon_sym_let] = ACTIONS(3152),
    [anon_sym_This] = ACTIONS(3152),
    [anon_sym_decltype] = ACTIONS(3152),
    [sym_virtual] = ACTIONS(3152),
    [anon_sym_explicit] = ACTIONS(3152),
    [anon_sym_typename] = ACTIONS(3152),
    [anon_sym_template] = ACTIONS(3152),
    [anon_sym_operator] = ACTIONS(3152),
    [anon_sym_try] = ACTIONS(3152),
    [anon_sym_delete] = ACTIONS(3152),
    [anon_sym_throw] = ACTIONS(3152),
    [anon_sym_namespace] = ACTIONS(3152),
    [anon_sym_using] = ACTIONS(3152),
    [anon_sym_static_assert] = ACTIONS(3152),
    [anon_sym_concept] = ACTIONS(3152),
    [anon_sym_co_return] = ACTIONS(3152),
    [anon_sym_co_yield] = ACTIONS(3152),
    [anon_sym_R_DQUOTE] = ACTIONS(3150),
    [anon_sym_LR_DQUOTE] = ACTIONS(3150),
    [anon_sym_uR_DQUOTE] = ACTIONS(3150),
    [anon_sym_UR_DQUOTE] = ACTIONS(3150),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3150),
    [anon_sym_co_await] = ACTIONS(3152),
    [anon_sym_new] = ACTIONS(3152),
    [anon_sym_requires] = ACTIONS(3152),
    [sym_this] = ACTIONS(3152),
    [anon_sym_discard] = ACTIONS(3152),
    [anon_sym_precise] = ACTIONS(3152),
    [anon_sym_shared] = ACTIONS(3152),
    [anon_sym_groupshared] = ACTIONS(3152),
    [anon_sym_uniform] = ACTIONS(3152),
    [anon_sym_row_major] = ACTIONS(3152),
    [anon_sym_column_major] = ACTIONS(3152),
    [anon_sym_globallycoherent] = ACTIONS(3152),
    [anon_sym_centroid] = ACTIONS(3152),
    [anon_sym_noperspective] = ACTIONS(3152),
    [anon_sym_nointerpolation] = ACTIONS(3152),
    [anon_sym_sample] = ACTIONS(3152),
    [anon_sym_linear] = ACTIONS(3152),
    [anon_sym_snorm] = ACTIONS(3152),
    [anon_sym_unorm] = ACTIONS(3152),
    [anon_sym_point] = ACTIONS(3152),
    [anon_sym_line] = ACTIONS(3152),
    [anon_sym_triangleadj] = ACTIONS(3152),
    [anon_sym_lineadj] = ACTIONS(3152),
    [anon_sym_triangle] = ACTIONS(3152),
    [anon_sym_cbuffer] = ACTIONS(3152),
    [anon_sym_interface] = ACTIONS(3152),
    [anon_sym_extension] = ACTIONS(3152),
  },
  [750] = {
    [sym_identifier] = ACTIONS(3098),
    [aux_sym_preproc_include_token1] = ACTIONS(3098),
    [aux_sym_preproc_def_token1] = ACTIONS(3098),
    [aux_sym_preproc_if_token1] = ACTIONS(3098),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3098),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3098),
    [sym_preproc_directive] = ACTIONS(3098),
    [anon_sym_LPAREN2] = ACTIONS(3096),
    [anon_sym_BANG] = ACTIONS(3096),
    [anon_sym_TILDE] = ACTIONS(3096),
    [anon_sym_DASH] = ACTIONS(3098),
    [anon_sym_PLUS] = ACTIONS(3098),
    [anon_sym_STAR] = ACTIONS(3096),
    [anon_sym_AMP_AMP] = ACTIONS(3096),
    [anon_sym_AMP] = ACTIONS(3098),
    [anon_sym_SEMI] = ACTIONS(3096),
    [anon_sym___extension__] = ACTIONS(3098),
    [anon_sym_typedef] = ACTIONS(3098),
    [anon_sym_in] = ACTIONS(3098),
    [anon_sym_out] = ACTIONS(3098),
    [anon_sym_inout] = ACTIONS(3098),
    [anon_sym_extern] = ACTIONS(3098),
    [anon_sym___attribute__] = ACTIONS(3098),
    [anon_sym_COLON_COLON] = ACTIONS(3096),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3096),
    [anon_sym___declspec] = ACTIONS(3098),
    [anon_sym___based] = ACTIONS(3098),
    [anon_sym___cdecl] = ACTIONS(3098),
    [anon_sym___clrcall] = ACTIONS(3098),
    [anon_sym___stdcall] = ACTIONS(3098),
    [anon_sym___fastcall] = ACTIONS(3098),
    [anon_sym___thiscall] = ACTIONS(3098),
    [anon_sym___vectorcall] = ACTIONS(3098),
    [anon_sym_LBRACE] = ACTIONS(3096),
    [anon_sym_RBRACE] = ACTIONS(3096),
    [anon_sym_signed] = ACTIONS(3098),
    [anon_sym_unsigned] = ACTIONS(3098),
    [anon_sym_long] = ACTIONS(3098),
    [anon_sym_short] = ACTIONS(3098),
    [anon_sym_LBRACK] = ACTIONS(3098),
    [anon_sym_static] = ACTIONS(3098),
    [anon_sym_register] = ACTIONS(3098),
    [anon_sym_inline] = ACTIONS(3098),
    [anon_sym___inline] = ACTIONS(3098),
    [anon_sym___inline__] = ACTIONS(3098),
    [anon_sym___forceinline] = ACTIONS(3098),
    [anon_sym_thread_local] = ACTIONS(3098),
    [anon_sym___thread] = ACTIONS(3098),
    [anon_sym_const] = ACTIONS(3098),
    [anon_sym_constexpr] = ACTIONS(3098),
    [anon_sym_volatile] = ACTIONS(3098),
    [anon_sym_restrict] = ACTIONS(3098),
    [anon_sym___restrict__] = ACTIONS(3098),
    [anon_sym__Atomic] = ACTIONS(3098),
    [anon_sym__Noreturn] = ACTIONS(3098),
    [anon_sym_noreturn] = ACTIONS(3098),
    [anon_sym_mutable] = ACTIONS(3098),
    [anon_sym_constinit] = ACTIONS(3098),
    [anon_sym_consteval] = ACTIONS(3098),
    [anon_sym_alignas] = ACTIONS(3098),
    [anon_sym__Alignas] = ACTIONS(3098),
    [sym_primitive_type] = ACTIONS(3098),
    [anon_sym_enum] = ACTIONS(3098),
    [anon_sym_class] = ACTIONS(3098),
    [anon_sym_struct] = ACTIONS(3098),
    [anon_sym_union] = ACTIONS(3098),
    [anon_sym_if] = ACTIONS(3098),
    [anon_sym_switch] = ACTIONS(3098),
    [anon_sym_case] = ACTIONS(3098),
    [anon_sym_default] = ACTIONS(3098),
    [anon_sym_while] = ACTIONS(3098),
    [anon_sym_do] = ACTIONS(3098),
    [anon_sym_for] = ACTIONS(3098),
    [anon_sym_return] = ACTIONS(3098),
    [anon_sym_break] = ACTIONS(3098),
    [anon_sym_continue] = ACTIONS(3098),
    [anon_sym_goto] = ACTIONS(3098),
    [anon_sym___try] = ACTIONS(3098),
    [anon_sym___leave] = ACTIONS(3098),
    [anon_sym_not] = ACTIONS(3098),
    [anon_sym_compl] = ACTIONS(3098),
    [anon_sym_DASH_DASH] = ACTIONS(3096),
    [anon_sym_PLUS_PLUS] = ACTIONS(3096),
    [anon_sym_sizeof] = ACTIONS(3098),
    [anon_sym___alignof__] = ACTIONS(3098),
    [anon_sym___alignof] = ACTIONS(3098),
    [anon_sym__alignof] = ACTIONS(3098),
    [anon_sym_alignof] = ACTIONS(3098),
    [anon_sym__Alignof] = ACTIONS(3098),
    [anon_sym_offsetof] = ACTIONS(3098),
    [anon_sym__Generic] = ACTIONS(3098),
    [anon_sym_asm] = ACTIONS(3098),
    [anon_sym___asm__] = ACTIONS(3098),
    [anon_sym_DOT] = ACTIONS(3098),
    [sym_number_literal] = ACTIONS(3096),
    [anon_sym_L_SQUOTE] = ACTIONS(3096),
    [anon_sym_u_SQUOTE] = ACTIONS(3096),
    [anon_sym_U_SQUOTE] = ACTIONS(3096),
    [anon_sym_u8_SQUOTE] = ACTIONS(3096),
    [anon_sym_SQUOTE] = ACTIONS(3096),
    [anon_sym_L_DQUOTE] = ACTIONS(3096),
    [anon_sym_u_DQUOTE] = ACTIONS(3096),
    [anon_sym_U_DQUOTE] = ACTIONS(3096),
    [anon_sym_u8_DQUOTE] = ACTIONS(3096),
    [anon_sym_DQUOTE] = ACTIONS(3096),
    [sym_true] = ACTIONS(3098),
    [sym_false] = ACTIONS(3098),
    [anon_sym_NULL] = ACTIONS(3098),
    [anon_sym_nullptr] = ACTIONS(3098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3098),
    [anon_sym_let] = ACTIONS(3098),
    [anon_sym_This] = ACTIONS(3098),
    [anon_sym_decltype] = ACTIONS(3098),
    [sym_virtual] = ACTIONS(3098),
    [anon_sym_explicit] = ACTIONS(3098),
    [anon_sym_typename] = ACTIONS(3098),
    [anon_sym_template] = ACTIONS(3098),
    [anon_sym_operator] = ACTIONS(3098),
    [anon_sym_try] = ACTIONS(3098),
    [anon_sym_delete] = ACTIONS(3098),
    [anon_sym_throw] = ACTIONS(3098),
    [anon_sym_namespace] = ACTIONS(3098),
    [anon_sym_using] = ACTIONS(3098),
    [anon_sym_static_assert] = ACTIONS(3098),
    [anon_sym_concept] = ACTIONS(3098),
    [anon_sym_co_return] = ACTIONS(3098),
    [anon_sym_co_yield] = ACTIONS(3098),
    [anon_sym_R_DQUOTE] = ACTIONS(3096),
    [anon_sym_LR_DQUOTE] = ACTIONS(3096),
    [anon_sym_uR_DQUOTE] = ACTIONS(3096),
    [anon_sym_UR_DQUOTE] = ACTIONS(3096),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3096),
    [anon_sym_co_await] = ACTIONS(3098),
    [anon_sym_new] = ACTIONS(3098),
    [anon_sym_requires] = ACTIONS(3098),
    [sym_this] = ACTIONS(3098),
    [anon_sym_discard] = ACTIONS(3098),
    [anon_sym_precise] = ACTIONS(3098),
    [anon_sym_shared] = ACTIONS(3098),
    [anon_sym_groupshared] = ACTIONS(3098),
    [anon_sym_uniform] = ACTIONS(3098),
    [anon_sym_row_major] = ACTIONS(3098),
    [anon_sym_column_major] = ACTIONS(3098),
    [anon_sym_globallycoherent] = ACTIONS(3098),
    [anon_sym_centroid] = ACTIONS(3098),
    [anon_sym_noperspective] = ACTIONS(3098),
    [anon_sym_nointerpolation] = ACTIONS(3098),
    [anon_sym_sample] = ACTIONS(3098),
    [anon_sym_linear] = ACTIONS(3098),
    [anon_sym_snorm] = ACTIONS(3098),
    [anon_sym_unorm] = ACTIONS(3098),
    [anon_sym_point] = ACTIONS(3098),
    [anon_sym_line] = ACTIONS(3098),
    [anon_sym_triangleadj] = ACTIONS(3098),
    [anon_sym_lineadj] = ACTIONS(3098),
    [anon_sym_triangle] = ACTIONS(3098),
    [anon_sym_cbuffer] = ACTIONS(3098),
    [anon_sym_interface] = ACTIONS(3098),
    [anon_sym_extension] = ACTIONS(3098),
  },
  [751] = {
    [sym_identifier] = ACTIONS(3048),
    [aux_sym_preproc_include_token1] = ACTIONS(3048),
    [aux_sym_preproc_def_token1] = ACTIONS(3048),
    [aux_sym_preproc_if_token1] = ACTIONS(3048),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3048),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3048),
    [sym_preproc_directive] = ACTIONS(3048),
    [anon_sym_LPAREN2] = ACTIONS(3046),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [anon_sym_DASH] = ACTIONS(3048),
    [anon_sym_PLUS] = ACTIONS(3048),
    [anon_sym_STAR] = ACTIONS(3046),
    [anon_sym_AMP_AMP] = ACTIONS(3046),
    [anon_sym_AMP] = ACTIONS(3048),
    [anon_sym_SEMI] = ACTIONS(3046),
    [anon_sym___extension__] = ACTIONS(3048),
    [anon_sym_typedef] = ACTIONS(3048),
    [anon_sym_in] = ACTIONS(3048),
    [anon_sym_out] = ACTIONS(3048),
    [anon_sym_inout] = ACTIONS(3048),
    [anon_sym_extern] = ACTIONS(3048),
    [anon_sym___attribute__] = ACTIONS(3048),
    [anon_sym_COLON_COLON] = ACTIONS(3046),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3046),
    [anon_sym___declspec] = ACTIONS(3048),
    [anon_sym___based] = ACTIONS(3048),
    [anon_sym___cdecl] = ACTIONS(3048),
    [anon_sym___clrcall] = ACTIONS(3048),
    [anon_sym___stdcall] = ACTIONS(3048),
    [anon_sym___fastcall] = ACTIONS(3048),
    [anon_sym___thiscall] = ACTIONS(3048),
    [anon_sym___vectorcall] = ACTIONS(3048),
    [anon_sym_LBRACE] = ACTIONS(3046),
    [anon_sym_RBRACE] = ACTIONS(3046),
    [anon_sym_signed] = ACTIONS(3048),
    [anon_sym_unsigned] = ACTIONS(3048),
    [anon_sym_long] = ACTIONS(3048),
    [anon_sym_short] = ACTIONS(3048),
    [anon_sym_LBRACK] = ACTIONS(3048),
    [anon_sym_static] = ACTIONS(3048),
    [anon_sym_register] = ACTIONS(3048),
    [anon_sym_inline] = ACTIONS(3048),
    [anon_sym___inline] = ACTIONS(3048),
    [anon_sym___inline__] = ACTIONS(3048),
    [anon_sym___forceinline] = ACTIONS(3048),
    [anon_sym_thread_local] = ACTIONS(3048),
    [anon_sym___thread] = ACTIONS(3048),
    [anon_sym_const] = ACTIONS(3048),
    [anon_sym_constexpr] = ACTIONS(3048),
    [anon_sym_volatile] = ACTIONS(3048),
    [anon_sym_restrict] = ACTIONS(3048),
    [anon_sym___restrict__] = ACTIONS(3048),
    [anon_sym__Atomic] = ACTIONS(3048),
    [anon_sym__Noreturn] = ACTIONS(3048),
    [anon_sym_noreturn] = ACTIONS(3048),
    [anon_sym_mutable] = ACTIONS(3048),
    [anon_sym_constinit] = ACTIONS(3048),
    [anon_sym_consteval] = ACTIONS(3048),
    [anon_sym_alignas] = ACTIONS(3048),
    [anon_sym__Alignas] = ACTIONS(3048),
    [sym_primitive_type] = ACTIONS(3048),
    [anon_sym_enum] = ACTIONS(3048),
    [anon_sym_class] = ACTIONS(3048),
    [anon_sym_struct] = ACTIONS(3048),
    [anon_sym_union] = ACTIONS(3048),
    [anon_sym_if] = ACTIONS(3048),
    [anon_sym_switch] = ACTIONS(3048),
    [anon_sym_case] = ACTIONS(3048),
    [anon_sym_default] = ACTIONS(3048),
    [anon_sym_while] = ACTIONS(3048),
    [anon_sym_do] = ACTIONS(3048),
    [anon_sym_for] = ACTIONS(3048),
    [anon_sym_return] = ACTIONS(3048),
    [anon_sym_break] = ACTIONS(3048),
    [anon_sym_continue] = ACTIONS(3048),
    [anon_sym_goto] = ACTIONS(3048),
    [anon_sym___try] = ACTIONS(3048),
    [anon_sym___leave] = ACTIONS(3048),
    [anon_sym_not] = ACTIONS(3048),
    [anon_sym_compl] = ACTIONS(3048),
    [anon_sym_DASH_DASH] = ACTIONS(3046),
    [anon_sym_PLUS_PLUS] = ACTIONS(3046),
    [anon_sym_sizeof] = ACTIONS(3048),
    [anon_sym___alignof__] = ACTIONS(3048),
    [anon_sym___alignof] = ACTIONS(3048),
    [anon_sym__alignof] = ACTIONS(3048),
    [anon_sym_alignof] = ACTIONS(3048),
    [anon_sym__Alignof] = ACTIONS(3048),
    [anon_sym_offsetof] = ACTIONS(3048),
    [anon_sym__Generic] = ACTIONS(3048),
    [anon_sym_asm] = ACTIONS(3048),
    [anon_sym___asm__] = ACTIONS(3048),
    [anon_sym_DOT] = ACTIONS(3048),
    [sym_number_literal] = ACTIONS(3046),
    [anon_sym_L_SQUOTE] = ACTIONS(3046),
    [anon_sym_u_SQUOTE] = ACTIONS(3046),
    [anon_sym_U_SQUOTE] = ACTIONS(3046),
    [anon_sym_u8_SQUOTE] = ACTIONS(3046),
    [anon_sym_SQUOTE] = ACTIONS(3046),
    [anon_sym_L_DQUOTE] = ACTIONS(3046),
    [anon_sym_u_DQUOTE] = ACTIONS(3046),
    [anon_sym_U_DQUOTE] = ACTIONS(3046),
    [anon_sym_u8_DQUOTE] = ACTIONS(3046),
    [anon_sym_DQUOTE] = ACTIONS(3046),
    [sym_true] = ACTIONS(3048),
    [sym_false] = ACTIONS(3048),
    [anon_sym_NULL] = ACTIONS(3048),
    [anon_sym_nullptr] = ACTIONS(3048),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3048),
    [anon_sym_let] = ACTIONS(3048),
    [anon_sym_This] = ACTIONS(3048),
    [anon_sym_decltype] = ACTIONS(3048),
    [sym_virtual] = ACTIONS(3048),
    [anon_sym_explicit] = ACTIONS(3048),
    [anon_sym_typename] = ACTIONS(3048),
    [anon_sym_template] = ACTIONS(3048),
    [anon_sym_operator] = ACTIONS(3048),
    [anon_sym_try] = ACTIONS(3048),
    [anon_sym_delete] = ACTIONS(3048),
    [anon_sym_throw] = ACTIONS(3048),
    [anon_sym_namespace] = ACTIONS(3048),
    [anon_sym_using] = ACTIONS(3048),
    [anon_sym_static_assert] = ACTIONS(3048),
    [anon_sym_concept] = ACTIONS(3048),
    [anon_sym_co_return] = ACTIONS(3048),
    [anon_sym_co_yield] = ACTIONS(3048),
    [anon_sym_R_DQUOTE] = ACTIONS(3046),
    [anon_sym_LR_DQUOTE] = ACTIONS(3046),
    [anon_sym_uR_DQUOTE] = ACTIONS(3046),
    [anon_sym_UR_DQUOTE] = ACTIONS(3046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3046),
    [anon_sym_co_await] = ACTIONS(3048),
    [anon_sym_new] = ACTIONS(3048),
    [anon_sym_requires] = ACTIONS(3048),
    [sym_this] = ACTIONS(3048),
    [anon_sym_discard] = ACTIONS(3048),
    [anon_sym_precise] = ACTIONS(3048),
    [anon_sym_shared] = ACTIONS(3048),
    [anon_sym_groupshared] = ACTIONS(3048),
    [anon_sym_uniform] = ACTIONS(3048),
    [anon_sym_row_major] = ACTIONS(3048),
    [anon_sym_column_major] = ACTIONS(3048),
    [anon_sym_globallycoherent] = ACTIONS(3048),
    [anon_sym_centroid] = ACTIONS(3048),
    [anon_sym_noperspective] = ACTIONS(3048),
    [anon_sym_nointerpolation] = ACTIONS(3048),
    [anon_sym_sample] = ACTIONS(3048),
    [anon_sym_linear] = ACTIONS(3048),
    [anon_sym_snorm] = ACTIONS(3048),
    [anon_sym_unorm] = ACTIONS(3048),
    [anon_sym_point] = ACTIONS(3048),
    [anon_sym_line] = ACTIONS(3048),
    [anon_sym_triangleadj] = ACTIONS(3048),
    [anon_sym_lineadj] = ACTIONS(3048),
    [anon_sym_triangle] = ACTIONS(3048),
    [anon_sym_cbuffer] = ACTIONS(3048),
    [anon_sym_interface] = ACTIONS(3048),
    [anon_sym_extension] = ACTIONS(3048),
  },
  [752] = {
    [sym_identifier] = ACTIONS(2988),
    [aux_sym_preproc_include_token1] = ACTIONS(2988),
    [aux_sym_preproc_def_token1] = ACTIONS(2988),
    [aux_sym_preproc_if_token1] = ACTIONS(2988),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2988),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2988),
    [sym_preproc_directive] = ACTIONS(2988),
    [anon_sym_LPAREN2] = ACTIONS(2986),
    [anon_sym_BANG] = ACTIONS(2986),
    [anon_sym_TILDE] = ACTIONS(2986),
    [anon_sym_DASH] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_STAR] = ACTIONS(2986),
    [anon_sym_AMP_AMP] = ACTIONS(2986),
    [anon_sym_AMP] = ACTIONS(2988),
    [anon_sym_SEMI] = ACTIONS(2986),
    [anon_sym___extension__] = ACTIONS(2988),
    [anon_sym_typedef] = ACTIONS(2988),
    [anon_sym_in] = ACTIONS(2988),
    [anon_sym_out] = ACTIONS(2988),
    [anon_sym_inout] = ACTIONS(2988),
    [anon_sym_extern] = ACTIONS(2988),
    [anon_sym___attribute__] = ACTIONS(2988),
    [anon_sym_COLON_COLON] = ACTIONS(2986),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2986),
    [anon_sym___declspec] = ACTIONS(2988),
    [anon_sym___based] = ACTIONS(2988),
    [anon_sym___cdecl] = ACTIONS(2988),
    [anon_sym___clrcall] = ACTIONS(2988),
    [anon_sym___stdcall] = ACTIONS(2988),
    [anon_sym___fastcall] = ACTIONS(2988),
    [anon_sym___thiscall] = ACTIONS(2988),
    [anon_sym___vectorcall] = ACTIONS(2988),
    [anon_sym_LBRACE] = ACTIONS(2986),
    [anon_sym_RBRACE] = ACTIONS(2986),
    [anon_sym_signed] = ACTIONS(2988),
    [anon_sym_unsigned] = ACTIONS(2988),
    [anon_sym_long] = ACTIONS(2988),
    [anon_sym_short] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2988),
    [anon_sym_static] = ACTIONS(2988),
    [anon_sym_register] = ACTIONS(2988),
    [anon_sym_inline] = ACTIONS(2988),
    [anon_sym___inline] = ACTIONS(2988),
    [anon_sym___inline__] = ACTIONS(2988),
    [anon_sym___forceinline] = ACTIONS(2988),
    [anon_sym_thread_local] = ACTIONS(2988),
    [anon_sym___thread] = ACTIONS(2988),
    [anon_sym_const] = ACTIONS(2988),
    [anon_sym_constexpr] = ACTIONS(2988),
    [anon_sym_volatile] = ACTIONS(2988),
    [anon_sym_restrict] = ACTIONS(2988),
    [anon_sym___restrict__] = ACTIONS(2988),
    [anon_sym__Atomic] = ACTIONS(2988),
    [anon_sym__Noreturn] = ACTIONS(2988),
    [anon_sym_noreturn] = ACTIONS(2988),
    [anon_sym_mutable] = ACTIONS(2988),
    [anon_sym_constinit] = ACTIONS(2988),
    [anon_sym_consteval] = ACTIONS(2988),
    [anon_sym_alignas] = ACTIONS(2988),
    [anon_sym__Alignas] = ACTIONS(2988),
    [sym_primitive_type] = ACTIONS(2988),
    [anon_sym_enum] = ACTIONS(2988),
    [anon_sym_class] = ACTIONS(2988),
    [anon_sym_struct] = ACTIONS(2988),
    [anon_sym_union] = ACTIONS(2988),
    [anon_sym_if] = ACTIONS(2988),
    [anon_sym_switch] = ACTIONS(2988),
    [anon_sym_case] = ACTIONS(2988),
    [anon_sym_default] = ACTIONS(2988),
    [anon_sym_while] = ACTIONS(2988),
    [anon_sym_do] = ACTIONS(2988),
    [anon_sym_for] = ACTIONS(2988),
    [anon_sym_return] = ACTIONS(2988),
    [anon_sym_break] = ACTIONS(2988),
    [anon_sym_continue] = ACTIONS(2988),
    [anon_sym_goto] = ACTIONS(2988),
    [anon_sym___try] = ACTIONS(2988),
    [anon_sym___leave] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2988),
    [anon_sym_compl] = ACTIONS(2988),
    [anon_sym_DASH_DASH] = ACTIONS(2986),
    [anon_sym_PLUS_PLUS] = ACTIONS(2986),
    [anon_sym_sizeof] = ACTIONS(2988),
    [anon_sym___alignof__] = ACTIONS(2988),
    [anon_sym___alignof] = ACTIONS(2988),
    [anon_sym__alignof] = ACTIONS(2988),
    [anon_sym_alignof] = ACTIONS(2988),
    [anon_sym__Alignof] = ACTIONS(2988),
    [anon_sym_offsetof] = ACTIONS(2988),
    [anon_sym__Generic] = ACTIONS(2988),
    [anon_sym_asm] = ACTIONS(2988),
    [anon_sym___asm__] = ACTIONS(2988),
    [anon_sym_DOT] = ACTIONS(2988),
    [sym_number_literal] = ACTIONS(2986),
    [anon_sym_L_SQUOTE] = ACTIONS(2986),
    [anon_sym_u_SQUOTE] = ACTIONS(2986),
    [anon_sym_U_SQUOTE] = ACTIONS(2986),
    [anon_sym_u8_SQUOTE] = ACTIONS(2986),
    [anon_sym_SQUOTE] = ACTIONS(2986),
    [anon_sym_L_DQUOTE] = ACTIONS(2986),
    [anon_sym_u_DQUOTE] = ACTIONS(2986),
    [anon_sym_U_DQUOTE] = ACTIONS(2986),
    [anon_sym_u8_DQUOTE] = ACTIONS(2986),
    [anon_sym_DQUOTE] = ACTIONS(2986),
    [sym_true] = ACTIONS(2988),
    [sym_false] = ACTIONS(2988),
    [anon_sym_NULL] = ACTIONS(2988),
    [anon_sym_nullptr] = ACTIONS(2988),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2988),
    [anon_sym_let] = ACTIONS(2988),
    [anon_sym_This] = ACTIONS(2988),
    [anon_sym_decltype] = ACTIONS(2988),
    [sym_virtual] = ACTIONS(2988),
    [anon_sym_explicit] = ACTIONS(2988),
    [anon_sym_typename] = ACTIONS(2988),
    [anon_sym_template] = ACTIONS(2988),
    [anon_sym_operator] = ACTIONS(2988),
    [anon_sym_try] = ACTIONS(2988),
    [anon_sym_delete] = ACTIONS(2988),
    [anon_sym_throw] = ACTIONS(2988),
    [anon_sym_namespace] = ACTIONS(2988),
    [anon_sym_using] = ACTIONS(2988),
    [anon_sym_static_assert] = ACTIONS(2988),
    [anon_sym_concept] = ACTIONS(2988),
    [anon_sym_co_return] = ACTIONS(2988),
    [anon_sym_co_yield] = ACTIONS(2988),
    [anon_sym_R_DQUOTE] = ACTIONS(2986),
    [anon_sym_LR_DQUOTE] = ACTIONS(2986),
    [anon_sym_uR_DQUOTE] = ACTIONS(2986),
    [anon_sym_UR_DQUOTE] = ACTIONS(2986),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2986),
    [anon_sym_co_await] = ACTIONS(2988),
    [anon_sym_new] = ACTIONS(2988),
    [anon_sym_requires] = ACTIONS(2988),
    [sym_this] = ACTIONS(2988),
    [anon_sym_discard] = ACTIONS(2988),
    [anon_sym_precise] = ACTIONS(2988),
    [anon_sym_shared] = ACTIONS(2988),
    [anon_sym_groupshared] = ACTIONS(2988),
    [anon_sym_uniform] = ACTIONS(2988),
    [anon_sym_row_major] = ACTIONS(2988),
    [anon_sym_column_major] = ACTIONS(2988),
    [anon_sym_globallycoherent] = ACTIONS(2988),
    [anon_sym_centroid] = ACTIONS(2988),
    [anon_sym_noperspective] = ACTIONS(2988),
    [anon_sym_nointerpolation] = ACTIONS(2988),
    [anon_sym_sample] = ACTIONS(2988),
    [anon_sym_linear] = ACTIONS(2988),
    [anon_sym_snorm] = ACTIONS(2988),
    [anon_sym_unorm] = ACTIONS(2988),
    [anon_sym_point] = ACTIONS(2988),
    [anon_sym_line] = ACTIONS(2988),
    [anon_sym_triangleadj] = ACTIONS(2988),
    [anon_sym_lineadj] = ACTIONS(2988),
    [anon_sym_triangle] = ACTIONS(2988),
    [anon_sym_cbuffer] = ACTIONS(2988),
    [anon_sym_interface] = ACTIONS(2988),
    [anon_sym_extension] = ACTIONS(2988),
  },
  [753] = {
    [sym_identifier] = ACTIONS(3002),
    [aux_sym_preproc_include_token1] = ACTIONS(3002),
    [aux_sym_preproc_def_token1] = ACTIONS(3002),
    [aux_sym_preproc_if_token1] = ACTIONS(3002),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3002),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3002),
    [sym_preproc_directive] = ACTIONS(3002),
    [anon_sym_LPAREN2] = ACTIONS(3004),
    [anon_sym_BANG] = ACTIONS(3004),
    [anon_sym_TILDE] = ACTIONS(3004),
    [anon_sym_DASH] = ACTIONS(3002),
    [anon_sym_PLUS] = ACTIONS(3002),
    [anon_sym_STAR] = ACTIONS(3004),
    [anon_sym_AMP_AMP] = ACTIONS(3004),
    [anon_sym_AMP] = ACTIONS(3002),
    [anon_sym_SEMI] = ACTIONS(3004),
    [anon_sym___extension__] = ACTIONS(3002),
    [anon_sym_typedef] = ACTIONS(3002),
    [anon_sym_in] = ACTIONS(3002),
    [anon_sym_out] = ACTIONS(3002),
    [anon_sym_inout] = ACTIONS(3002),
    [anon_sym_extern] = ACTIONS(3002),
    [anon_sym___attribute__] = ACTIONS(3002),
    [anon_sym_COLON_COLON] = ACTIONS(3004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3004),
    [anon_sym___declspec] = ACTIONS(3002),
    [anon_sym___based] = ACTIONS(3002),
    [anon_sym___cdecl] = ACTIONS(3002),
    [anon_sym___clrcall] = ACTIONS(3002),
    [anon_sym___stdcall] = ACTIONS(3002),
    [anon_sym___fastcall] = ACTIONS(3002),
    [anon_sym___thiscall] = ACTIONS(3002),
    [anon_sym___vectorcall] = ACTIONS(3002),
    [anon_sym_LBRACE] = ACTIONS(3004),
    [anon_sym_RBRACE] = ACTIONS(3004),
    [anon_sym_signed] = ACTIONS(3002),
    [anon_sym_unsigned] = ACTIONS(3002),
    [anon_sym_long] = ACTIONS(3002),
    [anon_sym_short] = ACTIONS(3002),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [anon_sym_static] = ACTIONS(3002),
    [anon_sym_register] = ACTIONS(3002),
    [anon_sym_inline] = ACTIONS(3002),
    [anon_sym___inline] = ACTIONS(3002),
    [anon_sym___inline__] = ACTIONS(3002),
    [anon_sym___forceinline] = ACTIONS(3002),
    [anon_sym_thread_local] = ACTIONS(3002),
    [anon_sym___thread] = ACTIONS(3002),
    [anon_sym_const] = ACTIONS(3002),
    [anon_sym_constexpr] = ACTIONS(3002),
    [anon_sym_volatile] = ACTIONS(3002),
    [anon_sym_restrict] = ACTIONS(3002),
    [anon_sym___restrict__] = ACTIONS(3002),
    [anon_sym__Atomic] = ACTIONS(3002),
    [anon_sym__Noreturn] = ACTIONS(3002),
    [anon_sym_noreturn] = ACTIONS(3002),
    [anon_sym_mutable] = ACTIONS(3002),
    [anon_sym_constinit] = ACTIONS(3002),
    [anon_sym_consteval] = ACTIONS(3002),
    [anon_sym_alignas] = ACTIONS(3002),
    [anon_sym__Alignas] = ACTIONS(3002),
    [sym_primitive_type] = ACTIONS(3002),
    [anon_sym_enum] = ACTIONS(3002),
    [anon_sym_class] = ACTIONS(3002),
    [anon_sym_struct] = ACTIONS(3002),
    [anon_sym_union] = ACTIONS(3002),
    [anon_sym_if] = ACTIONS(3002),
    [anon_sym_else] = ACTIONS(3002),
    [anon_sym_switch] = ACTIONS(3002),
    [anon_sym_case] = ACTIONS(3002),
    [anon_sym_default] = ACTIONS(3002),
    [anon_sym_while] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(3002),
    [anon_sym_for] = ACTIONS(3002),
    [anon_sym_return] = ACTIONS(3002),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_continue] = ACTIONS(3002),
    [anon_sym_goto] = ACTIONS(3002),
    [anon_sym___try] = ACTIONS(3002),
    [anon_sym___leave] = ACTIONS(3002),
    [anon_sym_not] = ACTIONS(3002),
    [anon_sym_compl] = ACTIONS(3002),
    [anon_sym_DASH_DASH] = ACTIONS(3004),
    [anon_sym_PLUS_PLUS] = ACTIONS(3004),
    [anon_sym_sizeof] = ACTIONS(3002),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3002),
    [anon_sym__Generic] = ACTIONS(3002),
    [anon_sym_asm] = ACTIONS(3002),
    [anon_sym___asm__] = ACTIONS(3002),
    [sym_number_literal] = ACTIONS(3004),
    [anon_sym_L_SQUOTE] = ACTIONS(3004),
    [anon_sym_u_SQUOTE] = ACTIONS(3004),
    [anon_sym_U_SQUOTE] = ACTIONS(3004),
    [anon_sym_u8_SQUOTE] = ACTIONS(3004),
    [anon_sym_SQUOTE] = ACTIONS(3004),
    [anon_sym_L_DQUOTE] = ACTIONS(3004),
    [anon_sym_u_DQUOTE] = ACTIONS(3004),
    [anon_sym_U_DQUOTE] = ACTIONS(3004),
    [anon_sym_u8_DQUOTE] = ACTIONS(3004),
    [anon_sym_DQUOTE] = ACTIONS(3004),
    [sym_true] = ACTIONS(3002),
    [sym_false] = ACTIONS(3002),
    [anon_sym_NULL] = ACTIONS(3002),
    [anon_sym_nullptr] = ACTIONS(3002),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3002),
    [anon_sym_let] = ACTIONS(3002),
    [anon_sym_This] = ACTIONS(3002),
    [anon_sym_decltype] = ACTIONS(3002),
    [sym_virtual] = ACTIONS(3002),
    [anon_sym_explicit] = ACTIONS(3002),
    [anon_sym_typename] = ACTIONS(3002),
    [anon_sym_template] = ACTIONS(3002),
    [anon_sym_operator] = ACTIONS(3002),
    [anon_sym_try] = ACTIONS(3002),
    [anon_sym_delete] = ACTIONS(3002),
    [anon_sym_throw] = ACTIONS(3002),
    [anon_sym_namespace] = ACTIONS(3002),
    [anon_sym_using] = ACTIONS(3002),
    [anon_sym_static_assert] = ACTIONS(3002),
    [anon_sym_concept] = ACTIONS(3002),
    [anon_sym_co_return] = ACTIONS(3002),
    [anon_sym_co_yield] = ACTIONS(3002),
    [anon_sym_R_DQUOTE] = ACTIONS(3004),
    [anon_sym_LR_DQUOTE] = ACTIONS(3004),
    [anon_sym_uR_DQUOTE] = ACTIONS(3004),
    [anon_sym_UR_DQUOTE] = ACTIONS(3004),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3004),
    [anon_sym_co_await] = ACTIONS(3002),
    [anon_sym_new] = ACTIONS(3002),
    [anon_sym_requires] = ACTIONS(3002),
    [sym_this] = ACTIONS(3002),
    [anon_sym_discard] = ACTIONS(3002),
    [anon_sym_precise] = ACTIONS(3002),
    [anon_sym_shared] = ACTIONS(3002),
    [anon_sym_groupshared] = ACTIONS(3002),
    [anon_sym_uniform] = ACTIONS(3002),
    [anon_sym_row_major] = ACTIONS(3002),
    [anon_sym_column_major] = ACTIONS(3002),
    [anon_sym_globallycoherent] = ACTIONS(3002),
    [anon_sym_centroid] = ACTIONS(3002),
    [anon_sym_noperspective] = ACTIONS(3002),
    [anon_sym_nointerpolation] = ACTIONS(3002),
    [anon_sym_sample] = ACTIONS(3002),
    [anon_sym_linear] = ACTIONS(3002),
    [anon_sym_snorm] = ACTIONS(3002),
    [anon_sym_unorm] = ACTIONS(3002),
    [anon_sym_point] = ACTIONS(3002),
    [anon_sym_line] = ACTIONS(3002),
    [anon_sym_triangleadj] = ACTIONS(3002),
    [anon_sym_lineadj] = ACTIONS(3002),
    [anon_sym_triangle] = ACTIONS(3002),
    [anon_sym_cbuffer] = ACTIONS(3002),
    [anon_sym_interface] = ACTIONS(3002),
    [anon_sym_extension] = ACTIONS(3002),
  },
  [754] = {
    [sym_identifier] = ACTIONS(3384),
    [aux_sym_preproc_include_token1] = ACTIONS(3384),
    [aux_sym_preproc_def_token1] = ACTIONS(3384),
    [aux_sym_preproc_if_token1] = ACTIONS(3384),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3384),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3384),
    [sym_preproc_directive] = ACTIONS(3384),
    [anon_sym_LPAREN2] = ACTIONS(3382),
    [anon_sym_BANG] = ACTIONS(3382),
    [anon_sym_TILDE] = ACTIONS(3382),
    [anon_sym_DASH] = ACTIONS(3384),
    [anon_sym_PLUS] = ACTIONS(3384),
    [anon_sym_STAR] = ACTIONS(3382),
    [anon_sym_AMP_AMP] = ACTIONS(3382),
    [anon_sym_AMP] = ACTIONS(3384),
    [anon_sym_SEMI] = ACTIONS(3382),
    [anon_sym___extension__] = ACTIONS(3384),
    [anon_sym_typedef] = ACTIONS(3384),
    [anon_sym_in] = ACTIONS(3384),
    [anon_sym_out] = ACTIONS(3384),
    [anon_sym_inout] = ACTIONS(3384),
    [anon_sym_extern] = ACTIONS(3384),
    [anon_sym___attribute__] = ACTIONS(3384),
    [anon_sym_COLON_COLON] = ACTIONS(3382),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3382),
    [anon_sym___declspec] = ACTIONS(3384),
    [anon_sym___based] = ACTIONS(3384),
    [anon_sym___cdecl] = ACTIONS(3384),
    [anon_sym___clrcall] = ACTIONS(3384),
    [anon_sym___stdcall] = ACTIONS(3384),
    [anon_sym___fastcall] = ACTIONS(3384),
    [anon_sym___thiscall] = ACTIONS(3384),
    [anon_sym___vectorcall] = ACTIONS(3384),
    [anon_sym_LBRACE] = ACTIONS(3382),
    [anon_sym_RBRACE] = ACTIONS(3382),
    [anon_sym_signed] = ACTIONS(3384),
    [anon_sym_unsigned] = ACTIONS(3384),
    [anon_sym_long] = ACTIONS(3384),
    [anon_sym_short] = ACTIONS(3384),
    [anon_sym_LBRACK] = ACTIONS(3384),
    [anon_sym_static] = ACTIONS(3384),
    [anon_sym_register] = ACTIONS(3384),
    [anon_sym_inline] = ACTIONS(3384),
    [anon_sym___inline] = ACTIONS(3384),
    [anon_sym___inline__] = ACTIONS(3384),
    [anon_sym___forceinline] = ACTIONS(3384),
    [anon_sym_thread_local] = ACTIONS(3384),
    [anon_sym___thread] = ACTIONS(3384),
    [anon_sym_const] = ACTIONS(3384),
    [anon_sym_constexpr] = ACTIONS(3384),
    [anon_sym_volatile] = ACTIONS(3384),
    [anon_sym_restrict] = ACTIONS(3384),
    [anon_sym___restrict__] = ACTIONS(3384),
    [anon_sym__Atomic] = ACTIONS(3384),
    [anon_sym__Noreturn] = ACTIONS(3384),
    [anon_sym_noreturn] = ACTIONS(3384),
    [anon_sym_mutable] = ACTIONS(3384),
    [anon_sym_constinit] = ACTIONS(3384),
    [anon_sym_consteval] = ACTIONS(3384),
    [anon_sym_alignas] = ACTIONS(3384),
    [anon_sym__Alignas] = ACTIONS(3384),
    [sym_primitive_type] = ACTIONS(3384),
    [anon_sym_enum] = ACTIONS(3384),
    [anon_sym_class] = ACTIONS(3384),
    [anon_sym_struct] = ACTIONS(3384),
    [anon_sym_union] = ACTIONS(3384),
    [anon_sym_if] = ACTIONS(3384),
    [anon_sym_switch] = ACTIONS(3384),
    [anon_sym_case] = ACTIONS(3384),
    [anon_sym_default] = ACTIONS(3384),
    [anon_sym_while] = ACTIONS(3384),
    [anon_sym_do] = ACTIONS(3384),
    [anon_sym_for] = ACTIONS(3384),
    [anon_sym_return] = ACTIONS(3384),
    [anon_sym_break] = ACTIONS(3384),
    [anon_sym_continue] = ACTIONS(3384),
    [anon_sym_goto] = ACTIONS(3384),
    [anon_sym___try] = ACTIONS(3384),
    [anon_sym___leave] = ACTIONS(3384),
    [anon_sym_not] = ACTIONS(3384),
    [anon_sym_compl] = ACTIONS(3384),
    [anon_sym_DASH_DASH] = ACTIONS(3382),
    [anon_sym_PLUS_PLUS] = ACTIONS(3382),
    [anon_sym_sizeof] = ACTIONS(3384),
    [anon_sym___alignof__] = ACTIONS(3384),
    [anon_sym___alignof] = ACTIONS(3384),
    [anon_sym__alignof] = ACTIONS(3384),
    [anon_sym_alignof] = ACTIONS(3384),
    [anon_sym__Alignof] = ACTIONS(3384),
    [anon_sym_offsetof] = ACTIONS(3384),
    [anon_sym__Generic] = ACTIONS(3384),
    [anon_sym_asm] = ACTIONS(3384),
    [anon_sym___asm__] = ACTIONS(3384),
    [anon_sym_DOT] = ACTIONS(3384),
    [sym_number_literal] = ACTIONS(3382),
    [anon_sym_L_SQUOTE] = ACTIONS(3382),
    [anon_sym_u_SQUOTE] = ACTIONS(3382),
    [anon_sym_U_SQUOTE] = ACTIONS(3382),
    [anon_sym_u8_SQUOTE] = ACTIONS(3382),
    [anon_sym_SQUOTE] = ACTIONS(3382),
    [anon_sym_L_DQUOTE] = ACTIONS(3382),
    [anon_sym_u_DQUOTE] = ACTIONS(3382),
    [anon_sym_U_DQUOTE] = ACTIONS(3382),
    [anon_sym_u8_DQUOTE] = ACTIONS(3382),
    [anon_sym_DQUOTE] = ACTIONS(3382),
    [sym_true] = ACTIONS(3384),
    [sym_false] = ACTIONS(3384),
    [anon_sym_NULL] = ACTIONS(3384),
    [anon_sym_nullptr] = ACTIONS(3384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3384),
    [anon_sym_let] = ACTIONS(3384),
    [anon_sym_This] = ACTIONS(3384),
    [anon_sym_decltype] = ACTIONS(3384),
    [sym_virtual] = ACTIONS(3384),
    [anon_sym_explicit] = ACTIONS(3384),
    [anon_sym_typename] = ACTIONS(3384),
    [anon_sym_template] = ACTIONS(3384),
    [anon_sym_operator] = ACTIONS(3384),
    [anon_sym_try] = ACTIONS(3384),
    [anon_sym_delete] = ACTIONS(3384),
    [anon_sym_throw] = ACTIONS(3384),
    [anon_sym_namespace] = ACTIONS(3384),
    [anon_sym_using] = ACTIONS(3384),
    [anon_sym_static_assert] = ACTIONS(3384),
    [anon_sym_concept] = ACTIONS(3384),
    [anon_sym_co_return] = ACTIONS(3384),
    [anon_sym_co_yield] = ACTIONS(3384),
    [anon_sym_R_DQUOTE] = ACTIONS(3382),
    [anon_sym_LR_DQUOTE] = ACTIONS(3382),
    [anon_sym_uR_DQUOTE] = ACTIONS(3382),
    [anon_sym_UR_DQUOTE] = ACTIONS(3382),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3382),
    [anon_sym_co_await] = ACTIONS(3384),
    [anon_sym_new] = ACTIONS(3384),
    [anon_sym_requires] = ACTIONS(3384),
    [sym_this] = ACTIONS(3384),
    [anon_sym_discard] = ACTIONS(3384),
    [anon_sym_precise] = ACTIONS(3384),
    [anon_sym_shared] = ACTIONS(3384),
    [anon_sym_groupshared] = ACTIONS(3384),
    [anon_sym_uniform] = ACTIONS(3384),
    [anon_sym_row_major] = ACTIONS(3384),
    [anon_sym_column_major] = ACTIONS(3384),
    [anon_sym_globallycoherent] = ACTIONS(3384),
    [anon_sym_centroid] = ACTIONS(3384),
    [anon_sym_noperspective] = ACTIONS(3384),
    [anon_sym_nointerpolation] = ACTIONS(3384),
    [anon_sym_sample] = ACTIONS(3384),
    [anon_sym_linear] = ACTIONS(3384),
    [anon_sym_snorm] = ACTIONS(3384),
    [anon_sym_unorm] = ACTIONS(3384),
    [anon_sym_point] = ACTIONS(3384),
    [anon_sym_line] = ACTIONS(3384),
    [anon_sym_triangleadj] = ACTIONS(3384),
    [anon_sym_lineadj] = ACTIONS(3384),
    [anon_sym_triangle] = ACTIONS(3384),
    [anon_sym_cbuffer] = ACTIONS(3384),
    [anon_sym_interface] = ACTIONS(3384),
    [anon_sym_extension] = ACTIONS(3384),
  },
  [755] = {
    [sym_identifier] = ACTIONS(3230),
    [aux_sym_preproc_include_token1] = ACTIONS(3230),
    [aux_sym_preproc_def_token1] = ACTIONS(3230),
    [aux_sym_preproc_if_token1] = ACTIONS(3230),
    [aux_sym_preproc_if_token2] = ACTIONS(3230),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3230),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3230),
    [sym_preproc_directive] = ACTIONS(3230),
    [anon_sym_LPAREN2] = ACTIONS(3232),
    [anon_sym_BANG] = ACTIONS(3232),
    [anon_sym_TILDE] = ACTIONS(3232),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_STAR] = ACTIONS(3232),
    [anon_sym_AMP_AMP] = ACTIONS(3232),
    [anon_sym_AMP] = ACTIONS(3230),
    [anon_sym_SEMI] = ACTIONS(3232),
    [anon_sym___extension__] = ACTIONS(3230),
    [anon_sym_typedef] = ACTIONS(3230),
    [anon_sym_in] = ACTIONS(3230),
    [anon_sym_out] = ACTIONS(3230),
    [anon_sym_inout] = ACTIONS(3230),
    [anon_sym_extern] = ACTIONS(3230),
    [anon_sym___attribute__] = ACTIONS(3230),
    [anon_sym_COLON_COLON] = ACTIONS(3232),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3232),
    [anon_sym___declspec] = ACTIONS(3230),
    [anon_sym___based] = ACTIONS(3230),
    [anon_sym___cdecl] = ACTIONS(3230),
    [anon_sym___clrcall] = ACTIONS(3230),
    [anon_sym___stdcall] = ACTIONS(3230),
    [anon_sym___fastcall] = ACTIONS(3230),
    [anon_sym___thiscall] = ACTIONS(3230),
    [anon_sym___vectorcall] = ACTIONS(3230),
    [anon_sym_LBRACE] = ACTIONS(3232),
    [anon_sym_signed] = ACTIONS(3230),
    [anon_sym_unsigned] = ACTIONS(3230),
    [anon_sym_long] = ACTIONS(3230),
    [anon_sym_short] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_static] = ACTIONS(3230),
    [anon_sym_register] = ACTIONS(3230),
    [anon_sym_inline] = ACTIONS(3230),
    [anon_sym___inline] = ACTIONS(3230),
    [anon_sym___inline__] = ACTIONS(3230),
    [anon_sym___forceinline] = ACTIONS(3230),
    [anon_sym_thread_local] = ACTIONS(3230),
    [anon_sym___thread] = ACTIONS(3230),
    [anon_sym_const] = ACTIONS(3230),
    [anon_sym_constexpr] = ACTIONS(3230),
    [anon_sym_volatile] = ACTIONS(3230),
    [anon_sym_restrict] = ACTIONS(3230),
    [anon_sym___restrict__] = ACTIONS(3230),
    [anon_sym__Atomic] = ACTIONS(3230),
    [anon_sym__Noreturn] = ACTIONS(3230),
    [anon_sym_noreturn] = ACTIONS(3230),
    [anon_sym_mutable] = ACTIONS(3230),
    [anon_sym_constinit] = ACTIONS(3230),
    [anon_sym_consteval] = ACTIONS(3230),
    [anon_sym_alignas] = ACTIONS(3230),
    [anon_sym__Alignas] = ACTIONS(3230),
    [sym_primitive_type] = ACTIONS(3230),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3230),
    [anon_sym_struct] = ACTIONS(3230),
    [anon_sym_union] = ACTIONS(3230),
    [anon_sym_if] = ACTIONS(3230),
    [anon_sym_else] = ACTIONS(3230),
    [anon_sym_switch] = ACTIONS(3230),
    [anon_sym_case] = ACTIONS(3230),
    [anon_sym_default] = ACTIONS(3230),
    [anon_sym_while] = ACTIONS(3230),
    [anon_sym_do] = ACTIONS(3230),
    [anon_sym_for] = ACTIONS(3230),
    [anon_sym_return] = ACTIONS(3230),
    [anon_sym_break] = ACTIONS(3230),
    [anon_sym_continue] = ACTIONS(3230),
    [anon_sym_goto] = ACTIONS(3230),
    [anon_sym___try] = ACTIONS(3230),
    [anon_sym___leave] = ACTIONS(3230),
    [anon_sym_not] = ACTIONS(3230),
    [anon_sym_compl] = ACTIONS(3230),
    [anon_sym_DASH_DASH] = ACTIONS(3232),
    [anon_sym_PLUS_PLUS] = ACTIONS(3232),
    [anon_sym_sizeof] = ACTIONS(3230),
    [anon_sym___alignof__] = ACTIONS(3230),
    [anon_sym___alignof] = ACTIONS(3230),
    [anon_sym__alignof] = ACTIONS(3230),
    [anon_sym_alignof] = ACTIONS(3230),
    [anon_sym__Alignof] = ACTIONS(3230),
    [anon_sym_offsetof] = ACTIONS(3230),
    [anon_sym__Generic] = ACTIONS(3230),
    [anon_sym_asm] = ACTIONS(3230),
    [anon_sym___asm__] = ACTIONS(3230),
    [sym_number_literal] = ACTIONS(3232),
    [anon_sym_L_SQUOTE] = ACTIONS(3232),
    [anon_sym_u_SQUOTE] = ACTIONS(3232),
    [anon_sym_U_SQUOTE] = ACTIONS(3232),
    [anon_sym_u8_SQUOTE] = ACTIONS(3232),
    [anon_sym_SQUOTE] = ACTIONS(3232),
    [anon_sym_L_DQUOTE] = ACTIONS(3232),
    [anon_sym_u_DQUOTE] = ACTIONS(3232),
    [anon_sym_U_DQUOTE] = ACTIONS(3232),
    [anon_sym_u8_DQUOTE] = ACTIONS(3232),
    [anon_sym_DQUOTE] = ACTIONS(3232),
    [sym_true] = ACTIONS(3230),
    [sym_false] = ACTIONS(3230),
    [anon_sym_NULL] = ACTIONS(3230),
    [anon_sym_nullptr] = ACTIONS(3230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3230),
    [anon_sym_let] = ACTIONS(3230),
    [anon_sym_This] = ACTIONS(3230),
    [anon_sym_decltype] = ACTIONS(3230),
    [sym_virtual] = ACTIONS(3230),
    [anon_sym_explicit] = ACTIONS(3230),
    [anon_sym_typename] = ACTIONS(3230),
    [anon_sym_template] = ACTIONS(3230),
    [anon_sym_operator] = ACTIONS(3230),
    [anon_sym_try] = ACTIONS(3230),
    [anon_sym_delete] = ACTIONS(3230),
    [anon_sym_throw] = ACTIONS(3230),
    [anon_sym_namespace] = ACTIONS(3230),
    [anon_sym_using] = ACTIONS(3230),
    [anon_sym_static_assert] = ACTIONS(3230),
    [anon_sym_concept] = ACTIONS(3230),
    [anon_sym_co_return] = ACTIONS(3230),
    [anon_sym_co_yield] = ACTIONS(3230),
    [anon_sym_R_DQUOTE] = ACTIONS(3232),
    [anon_sym_LR_DQUOTE] = ACTIONS(3232),
    [anon_sym_uR_DQUOTE] = ACTIONS(3232),
    [anon_sym_UR_DQUOTE] = ACTIONS(3232),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3232),
    [anon_sym_co_await] = ACTIONS(3230),
    [anon_sym_new] = ACTIONS(3230),
    [anon_sym_requires] = ACTIONS(3230),
    [sym_this] = ACTIONS(3230),
    [anon_sym_discard] = ACTIONS(3230),
    [anon_sym_precise] = ACTIONS(3230),
    [anon_sym_shared] = ACTIONS(3230),
    [anon_sym_groupshared] = ACTIONS(3230),
    [anon_sym_uniform] = ACTIONS(3230),
    [anon_sym_row_major] = ACTIONS(3230),
    [anon_sym_column_major] = ACTIONS(3230),
    [anon_sym_globallycoherent] = ACTIONS(3230),
    [anon_sym_centroid] = ACTIONS(3230),
    [anon_sym_noperspective] = ACTIONS(3230),
    [anon_sym_nointerpolation] = ACTIONS(3230),
    [anon_sym_sample] = ACTIONS(3230),
    [anon_sym_linear] = ACTIONS(3230),
    [anon_sym_snorm] = ACTIONS(3230),
    [anon_sym_unorm] = ACTIONS(3230),
    [anon_sym_point] = ACTIONS(3230),
    [anon_sym_line] = ACTIONS(3230),
    [anon_sym_triangleadj] = ACTIONS(3230),
    [anon_sym_lineadj] = ACTIONS(3230),
    [anon_sym_triangle] = ACTIONS(3230),
    [anon_sym_cbuffer] = ACTIONS(3230),
    [anon_sym_interface] = ACTIONS(3230),
    [anon_sym_extension] = ACTIONS(3230),
  },
  [756] = {
    [sym_identifier] = ACTIONS(3178),
    [aux_sym_preproc_include_token1] = ACTIONS(3178),
    [aux_sym_preproc_def_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token2] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3178),
    [sym_preproc_directive] = ACTIONS(3178),
    [anon_sym_LPAREN2] = ACTIONS(3180),
    [anon_sym_BANG] = ACTIONS(3180),
    [anon_sym_TILDE] = ACTIONS(3180),
    [anon_sym_DASH] = ACTIONS(3178),
    [anon_sym_PLUS] = ACTIONS(3178),
    [anon_sym_STAR] = ACTIONS(3180),
    [anon_sym_AMP_AMP] = ACTIONS(3180),
    [anon_sym_AMP] = ACTIONS(3178),
    [anon_sym_SEMI] = ACTIONS(3180),
    [anon_sym___extension__] = ACTIONS(3178),
    [anon_sym_typedef] = ACTIONS(3178),
    [anon_sym_in] = ACTIONS(3178),
    [anon_sym_out] = ACTIONS(3178),
    [anon_sym_inout] = ACTIONS(3178),
    [anon_sym_extern] = ACTIONS(3178),
    [anon_sym___attribute__] = ACTIONS(3178),
    [anon_sym_COLON_COLON] = ACTIONS(3180),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3180),
    [anon_sym___declspec] = ACTIONS(3178),
    [anon_sym___based] = ACTIONS(3178),
    [anon_sym___cdecl] = ACTIONS(3178),
    [anon_sym___clrcall] = ACTIONS(3178),
    [anon_sym___stdcall] = ACTIONS(3178),
    [anon_sym___fastcall] = ACTIONS(3178),
    [anon_sym___thiscall] = ACTIONS(3178),
    [anon_sym___vectorcall] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(3180),
    [anon_sym_signed] = ACTIONS(3178),
    [anon_sym_unsigned] = ACTIONS(3178),
    [anon_sym_long] = ACTIONS(3178),
    [anon_sym_short] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(3178),
    [anon_sym_static] = ACTIONS(3178),
    [anon_sym_register] = ACTIONS(3178),
    [anon_sym_inline] = ACTIONS(3178),
    [anon_sym___inline] = ACTIONS(3178),
    [anon_sym___inline__] = ACTIONS(3178),
    [anon_sym___forceinline] = ACTIONS(3178),
    [anon_sym_thread_local] = ACTIONS(3178),
    [anon_sym___thread] = ACTIONS(3178),
    [anon_sym_const] = ACTIONS(3178),
    [anon_sym_constexpr] = ACTIONS(3178),
    [anon_sym_volatile] = ACTIONS(3178),
    [anon_sym_restrict] = ACTIONS(3178),
    [anon_sym___restrict__] = ACTIONS(3178),
    [anon_sym__Atomic] = ACTIONS(3178),
    [anon_sym__Noreturn] = ACTIONS(3178),
    [anon_sym_noreturn] = ACTIONS(3178),
    [anon_sym_mutable] = ACTIONS(3178),
    [anon_sym_constinit] = ACTIONS(3178),
    [anon_sym_consteval] = ACTIONS(3178),
    [anon_sym_alignas] = ACTIONS(3178),
    [anon_sym__Alignas] = ACTIONS(3178),
    [sym_primitive_type] = ACTIONS(3178),
    [anon_sym_enum] = ACTIONS(3178),
    [anon_sym_class] = ACTIONS(3178),
    [anon_sym_struct] = ACTIONS(3178),
    [anon_sym_union] = ACTIONS(3178),
    [anon_sym_if] = ACTIONS(3178),
    [anon_sym_else] = ACTIONS(3178),
    [anon_sym_switch] = ACTIONS(3178),
    [anon_sym_case] = ACTIONS(3178),
    [anon_sym_default] = ACTIONS(3178),
    [anon_sym_while] = ACTIONS(3178),
    [anon_sym_do] = ACTIONS(3178),
    [anon_sym_for] = ACTIONS(3178),
    [anon_sym_return] = ACTIONS(3178),
    [anon_sym_break] = ACTIONS(3178),
    [anon_sym_continue] = ACTIONS(3178),
    [anon_sym_goto] = ACTIONS(3178),
    [anon_sym___try] = ACTIONS(3178),
    [anon_sym___leave] = ACTIONS(3178),
    [anon_sym_not] = ACTIONS(3178),
    [anon_sym_compl] = ACTIONS(3178),
    [anon_sym_DASH_DASH] = ACTIONS(3180),
    [anon_sym_PLUS_PLUS] = ACTIONS(3180),
    [anon_sym_sizeof] = ACTIONS(3178),
    [anon_sym___alignof__] = ACTIONS(3178),
    [anon_sym___alignof] = ACTIONS(3178),
    [anon_sym__alignof] = ACTIONS(3178),
    [anon_sym_alignof] = ACTIONS(3178),
    [anon_sym__Alignof] = ACTIONS(3178),
    [anon_sym_offsetof] = ACTIONS(3178),
    [anon_sym__Generic] = ACTIONS(3178),
    [anon_sym_asm] = ACTIONS(3178),
    [anon_sym___asm__] = ACTIONS(3178),
    [sym_number_literal] = ACTIONS(3180),
    [anon_sym_L_SQUOTE] = ACTIONS(3180),
    [anon_sym_u_SQUOTE] = ACTIONS(3180),
    [anon_sym_U_SQUOTE] = ACTIONS(3180),
    [anon_sym_u8_SQUOTE] = ACTIONS(3180),
    [anon_sym_SQUOTE] = ACTIONS(3180),
    [anon_sym_L_DQUOTE] = ACTIONS(3180),
    [anon_sym_u_DQUOTE] = ACTIONS(3180),
    [anon_sym_U_DQUOTE] = ACTIONS(3180),
    [anon_sym_u8_DQUOTE] = ACTIONS(3180),
    [anon_sym_DQUOTE] = ACTIONS(3180),
    [sym_true] = ACTIONS(3178),
    [sym_false] = ACTIONS(3178),
    [anon_sym_NULL] = ACTIONS(3178),
    [anon_sym_nullptr] = ACTIONS(3178),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3178),
    [anon_sym_let] = ACTIONS(3178),
    [anon_sym_This] = ACTIONS(3178),
    [anon_sym_decltype] = ACTIONS(3178),
    [sym_virtual] = ACTIONS(3178),
    [anon_sym_explicit] = ACTIONS(3178),
    [anon_sym_typename] = ACTIONS(3178),
    [anon_sym_template] = ACTIONS(3178),
    [anon_sym_operator] = ACTIONS(3178),
    [anon_sym_try] = ACTIONS(3178),
    [anon_sym_delete] = ACTIONS(3178),
    [anon_sym_throw] = ACTIONS(3178),
    [anon_sym_namespace] = ACTIONS(3178),
    [anon_sym_using] = ACTIONS(3178),
    [anon_sym_static_assert] = ACTIONS(3178),
    [anon_sym_concept] = ACTIONS(3178),
    [anon_sym_co_return] = ACTIONS(3178),
    [anon_sym_co_yield] = ACTIONS(3178),
    [anon_sym_R_DQUOTE] = ACTIONS(3180),
    [anon_sym_LR_DQUOTE] = ACTIONS(3180),
    [anon_sym_uR_DQUOTE] = ACTIONS(3180),
    [anon_sym_UR_DQUOTE] = ACTIONS(3180),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3180),
    [anon_sym_co_await] = ACTIONS(3178),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3178),
    [sym_this] = ACTIONS(3178),
    [anon_sym_discard] = ACTIONS(3178),
    [anon_sym_precise] = ACTIONS(3178),
    [anon_sym_shared] = ACTIONS(3178),
    [anon_sym_groupshared] = ACTIONS(3178),
    [anon_sym_uniform] = ACTIONS(3178),
    [anon_sym_row_major] = ACTIONS(3178),
    [anon_sym_column_major] = ACTIONS(3178),
    [anon_sym_globallycoherent] = ACTIONS(3178),
    [anon_sym_centroid] = ACTIONS(3178),
    [anon_sym_noperspective] = ACTIONS(3178),
    [anon_sym_nointerpolation] = ACTIONS(3178),
    [anon_sym_sample] = ACTIONS(3178),
    [anon_sym_linear] = ACTIONS(3178),
    [anon_sym_snorm] = ACTIONS(3178),
    [anon_sym_unorm] = ACTIONS(3178),
    [anon_sym_point] = ACTIONS(3178),
    [anon_sym_line] = ACTIONS(3178),
    [anon_sym_triangleadj] = ACTIONS(3178),
    [anon_sym_lineadj] = ACTIONS(3178),
    [anon_sym_triangle] = ACTIONS(3178),
    [anon_sym_cbuffer] = ACTIONS(3178),
    [anon_sym_interface] = ACTIONS(3178),
    [anon_sym_extension] = ACTIONS(3178),
  },
  [757] = {
    [sym_identifier] = ACTIONS(3358),
    [aux_sym_preproc_include_token1] = ACTIONS(3358),
    [aux_sym_preproc_def_token1] = ACTIONS(3358),
    [aux_sym_preproc_if_token1] = ACTIONS(3358),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3358),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3358),
    [sym_preproc_directive] = ACTIONS(3358),
    [anon_sym_LPAREN2] = ACTIONS(3356),
    [anon_sym_BANG] = ACTIONS(3356),
    [anon_sym_TILDE] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3358),
    [anon_sym_PLUS] = ACTIONS(3358),
    [anon_sym_STAR] = ACTIONS(3356),
    [anon_sym_AMP_AMP] = ACTIONS(3356),
    [anon_sym_AMP] = ACTIONS(3358),
    [anon_sym_SEMI] = ACTIONS(3356),
    [anon_sym___extension__] = ACTIONS(3358),
    [anon_sym_typedef] = ACTIONS(3358),
    [anon_sym_in] = ACTIONS(3358),
    [anon_sym_out] = ACTIONS(3358),
    [anon_sym_inout] = ACTIONS(3358),
    [anon_sym_extern] = ACTIONS(3358),
    [anon_sym___attribute__] = ACTIONS(3358),
    [anon_sym_COLON_COLON] = ACTIONS(3356),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3356),
    [anon_sym___declspec] = ACTIONS(3358),
    [anon_sym___based] = ACTIONS(3358),
    [anon_sym___cdecl] = ACTIONS(3358),
    [anon_sym___clrcall] = ACTIONS(3358),
    [anon_sym___stdcall] = ACTIONS(3358),
    [anon_sym___fastcall] = ACTIONS(3358),
    [anon_sym___thiscall] = ACTIONS(3358),
    [anon_sym___vectorcall] = ACTIONS(3358),
    [anon_sym_LBRACE] = ACTIONS(3356),
    [anon_sym_RBRACE] = ACTIONS(3356),
    [anon_sym_signed] = ACTIONS(3358),
    [anon_sym_unsigned] = ACTIONS(3358),
    [anon_sym_long] = ACTIONS(3358),
    [anon_sym_short] = ACTIONS(3358),
    [anon_sym_LBRACK] = ACTIONS(3358),
    [anon_sym_static] = ACTIONS(3358),
    [anon_sym_register] = ACTIONS(3358),
    [anon_sym_inline] = ACTIONS(3358),
    [anon_sym___inline] = ACTIONS(3358),
    [anon_sym___inline__] = ACTIONS(3358),
    [anon_sym___forceinline] = ACTIONS(3358),
    [anon_sym_thread_local] = ACTIONS(3358),
    [anon_sym___thread] = ACTIONS(3358),
    [anon_sym_const] = ACTIONS(3358),
    [anon_sym_constexpr] = ACTIONS(3358),
    [anon_sym_volatile] = ACTIONS(3358),
    [anon_sym_restrict] = ACTIONS(3358),
    [anon_sym___restrict__] = ACTIONS(3358),
    [anon_sym__Atomic] = ACTIONS(3358),
    [anon_sym__Noreturn] = ACTIONS(3358),
    [anon_sym_noreturn] = ACTIONS(3358),
    [anon_sym_mutable] = ACTIONS(3358),
    [anon_sym_constinit] = ACTIONS(3358),
    [anon_sym_consteval] = ACTIONS(3358),
    [anon_sym_alignas] = ACTIONS(3358),
    [anon_sym__Alignas] = ACTIONS(3358),
    [sym_primitive_type] = ACTIONS(3358),
    [anon_sym_enum] = ACTIONS(3358),
    [anon_sym_class] = ACTIONS(3358),
    [anon_sym_struct] = ACTIONS(3358),
    [anon_sym_union] = ACTIONS(3358),
    [anon_sym_if] = ACTIONS(3358),
    [anon_sym_switch] = ACTIONS(3358),
    [anon_sym_case] = ACTIONS(3358),
    [anon_sym_default] = ACTIONS(3358),
    [anon_sym_while] = ACTIONS(3358),
    [anon_sym_do] = ACTIONS(3358),
    [anon_sym_for] = ACTIONS(3358),
    [anon_sym_return] = ACTIONS(3358),
    [anon_sym_break] = ACTIONS(3358),
    [anon_sym_continue] = ACTIONS(3358),
    [anon_sym_goto] = ACTIONS(3358),
    [anon_sym___try] = ACTIONS(3358),
    [anon_sym___leave] = ACTIONS(3358),
    [anon_sym_not] = ACTIONS(3358),
    [anon_sym_compl] = ACTIONS(3358),
    [anon_sym_DASH_DASH] = ACTIONS(3356),
    [anon_sym_PLUS_PLUS] = ACTIONS(3356),
    [anon_sym_sizeof] = ACTIONS(3358),
    [anon_sym___alignof__] = ACTIONS(3358),
    [anon_sym___alignof] = ACTIONS(3358),
    [anon_sym__alignof] = ACTIONS(3358),
    [anon_sym_alignof] = ACTIONS(3358),
    [anon_sym__Alignof] = ACTIONS(3358),
    [anon_sym_offsetof] = ACTIONS(3358),
    [anon_sym__Generic] = ACTIONS(3358),
    [anon_sym_asm] = ACTIONS(3358),
    [anon_sym___asm__] = ACTIONS(3358),
    [anon_sym_DOT] = ACTIONS(3358),
    [sym_number_literal] = ACTIONS(3356),
    [anon_sym_L_SQUOTE] = ACTIONS(3356),
    [anon_sym_u_SQUOTE] = ACTIONS(3356),
    [anon_sym_U_SQUOTE] = ACTIONS(3356),
    [anon_sym_u8_SQUOTE] = ACTIONS(3356),
    [anon_sym_SQUOTE] = ACTIONS(3356),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(3358),
    [sym_false] = ACTIONS(3358),
    [anon_sym_NULL] = ACTIONS(3358),
    [anon_sym_nullptr] = ACTIONS(3358),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3358),
    [anon_sym_let] = ACTIONS(3358),
    [anon_sym_This] = ACTIONS(3358),
    [anon_sym_decltype] = ACTIONS(3358),
    [sym_virtual] = ACTIONS(3358),
    [anon_sym_explicit] = ACTIONS(3358),
    [anon_sym_typename] = ACTIONS(3358),
    [anon_sym_template] = ACTIONS(3358),
    [anon_sym_operator] = ACTIONS(3358),
    [anon_sym_try] = ACTIONS(3358),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_throw] = ACTIONS(3358),
    [anon_sym_namespace] = ACTIONS(3358),
    [anon_sym_using] = ACTIONS(3358),
    [anon_sym_static_assert] = ACTIONS(3358),
    [anon_sym_concept] = ACTIONS(3358),
    [anon_sym_co_return] = ACTIONS(3358),
    [anon_sym_co_yield] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3356),
    [anon_sym_LR_DQUOTE] = ACTIONS(3356),
    [anon_sym_uR_DQUOTE] = ACTIONS(3356),
    [anon_sym_UR_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3356),
    [anon_sym_co_await] = ACTIONS(3358),
    [anon_sym_new] = ACTIONS(3358),
    [anon_sym_requires] = ACTIONS(3358),
    [sym_this] = ACTIONS(3358),
    [anon_sym_discard] = ACTIONS(3358),
    [anon_sym_precise] = ACTIONS(3358),
    [anon_sym_shared] = ACTIONS(3358),
    [anon_sym_groupshared] = ACTIONS(3358),
    [anon_sym_uniform] = ACTIONS(3358),
    [anon_sym_row_major] = ACTIONS(3358),
    [anon_sym_column_major] = ACTIONS(3358),
    [anon_sym_globallycoherent] = ACTIONS(3358),
    [anon_sym_centroid] = ACTIONS(3358),
    [anon_sym_noperspective] = ACTIONS(3358),
    [anon_sym_nointerpolation] = ACTIONS(3358),
    [anon_sym_sample] = ACTIONS(3358),
    [anon_sym_linear] = ACTIONS(3358),
    [anon_sym_snorm] = ACTIONS(3358),
    [anon_sym_unorm] = ACTIONS(3358),
    [anon_sym_point] = ACTIONS(3358),
    [anon_sym_line] = ACTIONS(3358),
    [anon_sym_triangleadj] = ACTIONS(3358),
    [anon_sym_lineadj] = ACTIONS(3358),
    [anon_sym_triangle] = ACTIONS(3358),
    [anon_sym_cbuffer] = ACTIONS(3358),
    [anon_sym_interface] = ACTIONS(3358),
    [anon_sym_extension] = ACTIONS(3358),
  },
  [758] = {
    [sym_identifier] = ACTIONS(3238),
    [aux_sym_preproc_include_token1] = ACTIONS(3238),
    [aux_sym_preproc_def_token1] = ACTIONS(3238),
    [aux_sym_preproc_if_token1] = ACTIONS(3238),
    [aux_sym_preproc_if_token2] = ACTIONS(3238),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3238),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3238),
    [sym_preproc_directive] = ACTIONS(3238),
    [anon_sym_LPAREN2] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3238),
    [anon_sym_PLUS] = ACTIONS(3238),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_AMP_AMP] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(3238),
    [anon_sym_SEMI] = ACTIONS(3240),
    [anon_sym___extension__] = ACTIONS(3238),
    [anon_sym_typedef] = ACTIONS(3238),
    [anon_sym_in] = ACTIONS(3238),
    [anon_sym_out] = ACTIONS(3238),
    [anon_sym_inout] = ACTIONS(3238),
    [anon_sym_extern] = ACTIONS(3238),
    [anon_sym___attribute__] = ACTIONS(3238),
    [anon_sym_COLON_COLON] = ACTIONS(3240),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3240),
    [anon_sym___declspec] = ACTIONS(3238),
    [anon_sym___based] = ACTIONS(3238),
    [anon_sym___cdecl] = ACTIONS(3238),
    [anon_sym___clrcall] = ACTIONS(3238),
    [anon_sym___stdcall] = ACTIONS(3238),
    [anon_sym___fastcall] = ACTIONS(3238),
    [anon_sym___thiscall] = ACTIONS(3238),
    [anon_sym___vectorcall] = ACTIONS(3238),
    [anon_sym_LBRACE] = ACTIONS(3240),
    [anon_sym_signed] = ACTIONS(3238),
    [anon_sym_unsigned] = ACTIONS(3238),
    [anon_sym_long] = ACTIONS(3238),
    [anon_sym_short] = ACTIONS(3238),
    [anon_sym_LBRACK] = ACTIONS(3238),
    [anon_sym_static] = ACTIONS(3238),
    [anon_sym_register] = ACTIONS(3238),
    [anon_sym_inline] = ACTIONS(3238),
    [anon_sym___inline] = ACTIONS(3238),
    [anon_sym___inline__] = ACTIONS(3238),
    [anon_sym___forceinline] = ACTIONS(3238),
    [anon_sym_thread_local] = ACTIONS(3238),
    [anon_sym___thread] = ACTIONS(3238),
    [anon_sym_const] = ACTIONS(3238),
    [anon_sym_constexpr] = ACTIONS(3238),
    [anon_sym_volatile] = ACTIONS(3238),
    [anon_sym_restrict] = ACTIONS(3238),
    [anon_sym___restrict__] = ACTIONS(3238),
    [anon_sym__Atomic] = ACTIONS(3238),
    [anon_sym__Noreturn] = ACTIONS(3238),
    [anon_sym_noreturn] = ACTIONS(3238),
    [anon_sym_mutable] = ACTIONS(3238),
    [anon_sym_constinit] = ACTIONS(3238),
    [anon_sym_consteval] = ACTIONS(3238),
    [anon_sym_alignas] = ACTIONS(3238),
    [anon_sym__Alignas] = ACTIONS(3238),
    [sym_primitive_type] = ACTIONS(3238),
    [anon_sym_enum] = ACTIONS(3238),
    [anon_sym_class] = ACTIONS(3238),
    [anon_sym_struct] = ACTIONS(3238),
    [anon_sym_union] = ACTIONS(3238),
    [anon_sym_if] = ACTIONS(3238),
    [anon_sym_else] = ACTIONS(3238),
    [anon_sym_switch] = ACTIONS(3238),
    [anon_sym_case] = ACTIONS(3238),
    [anon_sym_default] = ACTIONS(3238),
    [anon_sym_while] = ACTIONS(3238),
    [anon_sym_do] = ACTIONS(3238),
    [anon_sym_for] = ACTIONS(3238),
    [anon_sym_return] = ACTIONS(3238),
    [anon_sym_break] = ACTIONS(3238),
    [anon_sym_continue] = ACTIONS(3238),
    [anon_sym_goto] = ACTIONS(3238),
    [anon_sym___try] = ACTIONS(3238),
    [anon_sym___leave] = ACTIONS(3238),
    [anon_sym_not] = ACTIONS(3238),
    [anon_sym_compl] = ACTIONS(3238),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_sizeof] = ACTIONS(3238),
    [anon_sym___alignof__] = ACTIONS(3238),
    [anon_sym___alignof] = ACTIONS(3238),
    [anon_sym__alignof] = ACTIONS(3238),
    [anon_sym_alignof] = ACTIONS(3238),
    [anon_sym__Alignof] = ACTIONS(3238),
    [anon_sym_offsetof] = ACTIONS(3238),
    [anon_sym__Generic] = ACTIONS(3238),
    [anon_sym_asm] = ACTIONS(3238),
    [anon_sym___asm__] = ACTIONS(3238),
    [sym_number_literal] = ACTIONS(3240),
    [anon_sym_L_SQUOTE] = ACTIONS(3240),
    [anon_sym_u_SQUOTE] = ACTIONS(3240),
    [anon_sym_U_SQUOTE] = ACTIONS(3240),
    [anon_sym_u8_SQUOTE] = ACTIONS(3240),
    [anon_sym_SQUOTE] = ACTIONS(3240),
    [anon_sym_L_DQUOTE] = ACTIONS(3240),
    [anon_sym_u_DQUOTE] = ACTIONS(3240),
    [anon_sym_U_DQUOTE] = ACTIONS(3240),
    [anon_sym_u8_DQUOTE] = ACTIONS(3240),
    [anon_sym_DQUOTE] = ACTIONS(3240),
    [sym_true] = ACTIONS(3238),
    [sym_false] = ACTIONS(3238),
    [anon_sym_NULL] = ACTIONS(3238),
    [anon_sym_nullptr] = ACTIONS(3238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3238),
    [anon_sym_let] = ACTIONS(3238),
    [anon_sym_This] = ACTIONS(3238),
    [anon_sym_decltype] = ACTIONS(3238),
    [sym_virtual] = ACTIONS(3238),
    [anon_sym_explicit] = ACTIONS(3238),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3238),
    [anon_sym_operator] = ACTIONS(3238),
    [anon_sym_try] = ACTIONS(3238),
    [anon_sym_delete] = ACTIONS(3238),
    [anon_sym_throw] = ACTIONS(3238),
    [anon_sym_namespace] = ACTIONS(3238),
    [anon_sym_using] = ACTIONS(3238),
    [anon_sym_static_assert] = ACTIONS(3238),
    [anon_sym_concept] = ACTIONS(3238),
    [anon_sym_co_return] = ACTIONS(3238),
    [anon_sym_co_yield] = ACTIONS(3238),
    [anon_sym_R_DQUOTE] = ACTIONS(3240),
    [anon_sym_LR_DQUOTE] = ACTIONS(3240),
    [anon_sym_uR_DQUOTE] = ACTIONS(3240),
    [anon_sym_UR_DQUOTE] = ACTIONS(3240),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3240),
    [anon_sym_co_await] = ACTIONS(3238),
    [anon_sym_new] = ACTIONS(3238),
    [anon_sym_requires] = ACTIONS(3238),
    [sym_this] = ACTIONS(3238),
    [anon_sym_discard] = ACTIONS(3238),
    [anon_sym_precise] = ACTIONS(3238),
    [anon_sym_shared] = ACTIONS(3238),
    [anon_sym_groupshared] = ACTIONS(3238),
    [anon_sym_uniform] = ACTIONS(3238),
    [anon_sym_row_major] = ACTIONS(3238),
    [anon_sym_column_major] = ACTIONS(3238),
    [anon_sym_globallycoherent] = ACTIONS(3238),
    [anon_sym_centroid] = ACTIONS(3238),
    [anon_sym_noperspective] = ACTIONS(3238),
    [anon_sym_nointerpolation] = ACTIONS(3238),
    [anon_sym_sample] = ACTIONS(3238),
    [anon_sym_linear] = ACTIONS(3238),
    [anon_sym_snorm] = ACTIONS(3238),
    [anon_sym_unorm] = ACTIONS(3238),
    [anon_sym_point] = ACTIONS(3238),
    [anon_sym_line] = ACTIONS(3238),
    [anon_sym_triangleadj] = ACTIONS(3238),
    [anon_sym_lineadj] = ACTIONS(3238),
    [anon_sym_triangle] = ACTIONS(3238),
    [anon_sym_cbuffer] = ACTIONS(3238),
    [anon_sym_interface] = ACTIONS(3238),
    [anon_sym_extension] = ACTIONS(3238),
  },
  [759] = {
    [sym_identifier] = ACTIONS(3344),
    [aux_sym_preproc_include_token1] = ACTIONS(3344),
    [aux_sym_preproc_def_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token2] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3344),
    [sym_preproc_directive] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym___extension__] = ACTIONS(3344),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_in] = ACTIONS(3344),
    [anon_sym_out] = ACTIONS(3344),
    [anon_sym_inout] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym___attribute__] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3346),
    [anon_sym___declspec] = ACTIONS(3344),
    [anon_sym___based] = ACTIONS(3344),
    [anon_sym___cdecl] = ACTIONS(3344),
    [anon_sym___clrcall] = ACTIONS(3344),
    [anon_sym___stdcall] = ACTIONS(3344),
    [anon_sym___fastcall] = ACTIONS(3344),
    [anon_sym___thiscall] = ACTIONS(3344),
    [anon_sym___vectorcall] = ACTIONS(3344),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_signed] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym___inline] = ACTIONS(3344),
    [anon_sym___inline__] = ACTIONS(3344),
    [anon_sym___forceinline] = ACTIONS(3344),
    [anon_sym_thread_local] = ACTIONS(3344),
    [anon_sym___thread] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym___restrict__] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym__Noreturn] = ACTIONS(3344),
    [anon_sym_noreturn] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_constinit] = ACTIONS(3344),
    [anon_sym_consteval] = ACTIONS(3344),
    [anon_sym_alignas] = ACTIONS(3344),
    [anon_sym__Alignas] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_class] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_switch] = ACTIONS(3344),
    [anon_sym_case] = ACTIONS(3344),
    [anon_sym_default] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_break] = ACTIONS(3344),
    [anon_sym_continue] = ACTIONS(3344),
    [anon_sym_goto] = ACTIONS(3344),
    [anon_sym___try] = ACTIONS(3344),
    [anon_sym___leave] = ACTIONS(3344),
    [anon_sym_not] = ACTIONS(3344),
    [anon_sym_compl] = ACTIONS(3344),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_sizeof] = ACTIONS(3344),
    [anon_sym___alignof__] = ACTIONS(3344),
    [anon_sym___alignof] = ACTIONS(3344),
    [anon_sym__alignof] = ACTIONS(3344),
    [anon_sym_alignof] = ACTIONS(3344),
    [anon_sym__Alignof] = ACTIONS(3344),
    [anon_sym_offsetof] = ACTIONS(3344),
    [anon_sym__Generic] = ACTIONS(3344),
    [anon_sym_asm] = ACTIONS(3344),
    [anon_sym___asm__] = ACTIONS(3344),
    [sym_number_literal] = ACTIONS(3346),
    [anon_sym_L_SQUOTE] = ACTIONS(3346),
    [anon_sym_u_SQUOTE] = ACTIONS(3346),
    [anon_sym_U_SQUOTE] = ACTIONS(3346),
    [anon_sym_u8_SQUOTE] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_L_DQUOTE] = ACTIONS(3346),
    [anon_sym_u_DQUOTE] = ACTIONS(3346),
    [anon_sym_U_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8_DQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [sym_true] = ACTIONS(3344),
    [sym_false] = ACTIONS(3344),
    [anon_sym_NULL] = ACTIONS(3344),
    [anon_sym_nullptr] = ACTIONS(3344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_This] = ACTIONS(3344),
    [anon_sym_decltype] = ACTIONS(3344),
    [sym_virtual] = ACTIONS(3344),
    [anon_sym_explicit] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_template] = ACTIONS(3344),
    [anon_sym_operator] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_delete] = ACTIONS(3344),
    [anon_sym_throw] = ACTIONS(3344),
    [anon_sym_namespace] = ACTIONS(3344),
    [anon_sym_using] = ACTIONS(3344),
    [anon_sym_static_assert] = ACTIONS(3344),
    [anon_sym_concept] = ACTIONS(3344),
    [anon_sym_co_return] = ACTIONS(3344),
    [anon_sym_co_yield] = ACTIONS(3344),
    [anon_sym_R_DQUOTE] = ACTIONS(3346),
    [anon_sym_LR_DQUOTE] = ACTIONS(3346),
    [anon_sym_uR_DQUOTE] = ACTIONS(3346),
    [anon_sym_UR_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3346),
    [anon_sym_co_await] = ACTIONS(3344),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_requires] = ACTIONS(3344),
    [sym_this] = ACTIONS(3344),
    [anon_sym_discard] = ACTIONS(3344),
    [anon_sym_precise] = ACTIONS(3344),
    [anon_sym_shared] = ACTIONS(3344),
    [anon_sym_groupshared] = ACTIONS(3344),
    [anon_sym_uniform] = ACTIONS(3344),
    [anon_sym_row_major] = ACTIONS(3344),
    [anon_sym_column_major] = ACTIONS(3344),
    [anon_sym_globallycoherent] = ACTIONS(3344),
    [anon_sym_centroid] = ACTIONS(3344),
    [anon_sym_noperspective] = ACTIONS(3344),
    [anon_sym_nointerpolation] = ACTIONS(3344),
    [anon_sym_sample] = ACTIONS(3344),
    [anon_sym_linear] = ACTIONS(3344),
    [anon_sym_snorm] = ACTIONS(3344),
    [anon_sym_unorm] = ACTIONS(3344),
    [anon_sym_point] = ACTIONS(3344),
    [anon_sym_line] = ACTIONS(3344),
    [anon_sym_triangleadj] = ACTIONS(3344),
    [anon_sym_lineadj] = ACTIONS(3344),
    [anon_sym_triangle] = ACTIONS(3344),
    [anon_sym_cbuffer] = ACTIONS(3344),
    [anon_sym_interface] = ACTIONS(3344),
    [anon_sym_extension] = ACTIONS(3344),
  },
  [760] = {
    [sym_identifier] = ACTIONS(2742),
    [aux_sym_preproc_include_token1] = ACTIONS(2742),
    [aux_sym_preproc_def_token1] = ACTIONS(2742),
    [aux_sym_preproc_if_token1] = ACTIONS(2742),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2742),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2742),
    [sym_preproc_directive] = ACTIONS(2742),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_BANG] = ACTIONS(2740),
    [anon_sym_TILDE] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2742),
    [anon_sym_PLUS] = ACTIONS(2742),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym___extension__] = ACTIONS(2742),
    [anon_sym_typedef] = ACTIONS(2742),
    [anon_sym_in] = ACTIONS(2742),
    [anon_sym_out] = ACTIONS(2742),
    [anon_sym_inout] = ACTIONS(2742),
    [anon_sym_extern] = ACTIONS(2742),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2740),
    [anon_sym___declspec] = ACTIONS(2742),
    [anon_sym___based] = ACTIONS(2742),
    [anon_sym___cdecl] = ACTIONS(2742),
    [anon_sym___clrcall] = ACTIONS(2742),
    [anon_sym___stdcall] = ACTIONS(2742),
    [anon_sym___fastcall] = ACTIONS(2742),
    [anon_sym___thiscall] = ACTIONS(2742),
    [anon_sym___vectorcall] = ACTIONS(2742),
    [anon_sym_LBRACE] = ACTIONS(2740),
    [anon_sym_RBRACE] = ACTIONS(2740),
    [anon_sym_signed] = ACTIONS(2742),
    [anon_sym_unsigned] = ACTIONS(2742),
    [anon_sym_long] = ACTIONS(2742),
    [anon_sym_short] = ACTIONS(2742),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2742),
    [anon_sym_register] = ACTIONS(2742),
    [anon_sym_inline] = ACTIONS(2742),
    [anon_sym___inline] = ACTIONS(2742),
    [anon_sym___inline__] = ACTIONS(2742),
    [anon_sym___forceinline] = ACTIONS(2742),
    [anon_sym_thread_local] = ACTIONS(2742),
    [anon_sym___thread] = ACTIONS(2742),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_constexpr] = ACTIONS(2742),
    [anon_sym_volatile] = ACTIONS(2742),
    [anon_sym_restrict] = ACTIONS(2742),
    [anon_sym___restrict__] = ACTIONS(2742),
    [anon_sym__Atomic] = ACTIONS(2742),
    [anon_sym__Noreturn] = ACTIONS(2742),
    [anon_sym_noreturn] = ACTIONS(2742),
    [anon_sym_mutable] = ACTIONS(2742),
    [anon_sym_constinit] = ACTIONS(2742),
    [anon_sym_consteval] = ACTIONS(2742),
    [anon_sym_alignas] = ACTIONS(2742),
    [anon_sym__Alignas] = ACTIONS(2742),
    [sym_primitive_type] = ACTIONS(2742),
    [anon_sym_enum] = ACTIONS(2742),
    [anon_sym_class] = ACTIONS(2742),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2742),
    [anon_sym_if] = ACTIONS(2742),
    [anon_sym_switch] = ACTIONS(2742),
    [anon_sym_case] = ACTIONS(2742),
    [anon_sym_default] = ACTIONS(2742),
    [anon_sym_while] = ACTIONS(2742),
    [anon_sym_do] = ACTIONS(2742),
    [anon_sym_for] = ACTIONS(2742),
    [anon_sym_return] = ACTIONS(2742),
    [anon_sym_break] = ACTIONS(2742),
    [anon_sym_continue] = ACTIONS(2742),
    [anon_sym_goto] = ACTIONS(2742),
    [anon_sym___try] = ACTIONS(2742),
    [anon_sym___leave] = ACTIONS(2742),
    [anon_sym_not] = ACTIONS(2742),
    [anon_sym_compl] = ACTIONS(2742),
    [anon_sym_DASH_DASH] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2740),
    [anon_sym_sizeof] = ACTIONS(2742),
    [anon_sym___alignof__] = ACTIONS(2742),
    [anon_sym___alignof] = ACTIONS(2742),
    [anon_sym__alignof] = ACTIONS(2742),
    [anon_sym_alignof] = ACTIONS(2742),
    [anon_sym__Alignof] = ACTIONS(2742),
    [anon_sym_offsetof] = ACTIONS(2742),
    [anon_sym__Generic] = ACTIONS(2742),
    [anon_sym_asm] = ACTIONS(2742),
    [anon_sym___asm__] = ACTIONS(2742),
    [anon_sym_DOT] = ACTIONS(2742),
    [sym_number_literal] = ACTIONS(2740),
    [anon_sym_L_SQUOTE] = ACTIONS(2740),
    [anon_sym_u_SQUOTE] = ACTIONS(2740),
    [anon_sym_U_SQUOTE] = ACTIONS(2740),
    [anon_sym_u8_SQUOTE] = ACTIONS(2740),
    [anon_sym_SQUOTE] = ACTIONS(2740),
    [anon_sym_L_DQUOTE] = ACTIONS(2740),
    [anon_sym_u_DQUOTE] = ACTIONS(2740),
    [anon_sym_U_DQUOTE] = ACTIONS(2740),
    [anon_sym_u8_DQUOTE] = ACTIONS(2740),
    [anon_sym_DQUOTE] = ACTIONS(2740),
    [sym_true] = ACTIONS(2742),
    [sym_false] = ACTIONS(2742),
    [anon_sym_NULL] = ACTIONS(2742),
    [anon_sym_nullptr] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
    [anon_sym_decltype] = ACTIONS(2742),
    [sym_virtual] = ACTIONS(2742),
    [anon_sym_explicit] = ACTIONS(2742),
    [anon_sym_typename] = ACTIONS(2742),
    [anon_sym_template] = ACTIONS(2742),
    [anon_sym_operator] = ACTIONS(2742),
    [anon_sym_try] = ACTIONS(2742),
    [anon_sym_delete] = ACTIONS(2742),
    [anon_sym_throw] = ACTIONS(2742),
    [anon_sym_namespace] = ACTIONS(2742),
    [anon_sym_using] = ACTIONS(2742),
    [anon_sym_static_assert] = ACTIONS(2742),
    [anon_sym_concept] = ACTIONS(2742),
    [anon_sym_co_return] = ACTIONS(2742),
    [anon_sym_co_yield] = ACTIONS(2742),
    [anon_sym_R_DQUOTE] = ACTIONS(2740),
    [anon_sym_LR_DQUOTE] = ACTIONS(2740),
    [anon_sym_uR_DQUOTE] = ACTIONS(2740),
    [anon_sym_UR_DQUOTE] = ACTIONS(2740),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2740),
    [anon_sym_co_await] = ACTIONS(2742),
    [anon_sym_new] = ACTIONS(2742),
    [anon_sym_requires] = ACTIONS(2742),
    [sym_this] = ACTIONS(2742),
    [anon_sym_discard] = ACTIONS(2742),
    [anon_sym_precise] = ACTIONS(2742),
    [anon_sym_shared] = ACTIONS(2742),
    [anon_sym_groupshared] = ACTIONS(2742),
    [anon_sym_uniform] = ACTIONS(2742),
    [anon_sym_row_major] = ACTIONS(2742),
    [anon_sym_column_major] = ACTIONS(2742),
    [anon_sym_globallycoherent] = ACTIONS(2742),
    [anon_sym_centroid] = ACTIONS(2742),
    [anon_sym_noperspective] = ACTIONS(2742),
    [anon_sym_nointerpolation] = ACTIONS(2742),
    [anon_sym_sample] = ACTIONS(2742),
    [anon_sym_linear] = ACTIONS(2742),
    [anon_sym_snorm] = ACTIONS(2742),
    [anon_sym_unorm] = ACTIONS(2742),
    [anon_sym_point] = ACTIONS(2742),
    [anon_sym_line] = ACTIONS(2742),
    [anon_sym_triangleadj] = ACTIONS(2742),
    [anon_sym_lineadj] = ACTIONS(2742),
    [anon_sym_triangle] = ACTIONS(2742),
    [anon_sym_cbuffer] = ACTIONS(2742),
    [anon_sym_interface] = ACTIONS(2742),
    [anon_sym_extension] = ACTIONS(2742),
  },
  [761] = {
    [sym_expression] = STATE(5460),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10522),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(3894),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(3897),
    [anon_sym___extension__] = ACTIONS(3158),
    [anon_sym_in] = ACTIONS(3158),
    [anon_sym_out] = ACTIONS(3158),
    [anon_sym_inout] = ACTIONS(3158),
    [anon_sym_extern] = ACTIONS(3158),
    [anon_sym___attribute__] = ACTIONS(3158),
    [anon_sym_COLON_COLON] = ACTIONS(3899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3160),
    [anon_sym___declspec] = ACTIONS(3158),
    [anon_sym_signed] = ACTIONS(3158),
    [anon_sym_unsigned] = ACTIONS(3158),
    [anon_sym_long] = ACTIONS(3158),
    [anon_sym_short] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(2273),
    [anon_sym_static] = ACTIONS(3158),
    [anon_sym_register] = ACTIONS(3158),
    [anon_sym_inline] = ACTIONS(3158),
    [anon_sym___inline] = ACTIONS(3158),
    [anon_sym___inline__] = ACTIONS(3158),
    [anon_sym___forceinline] = ACTIONS(3158),
    [anon_sym_thread_local] = ACTIONS(3158),
    [anon_sym___thread] = ACTIONS(3158),
    [anon_sym_const] = ACTIONS(3158),
    [anon_sym_constexpr] = ACTIONS(3158),
    [anon_sym_volatile] = ACTIONS(3158),
    [anon_sym_restrict] = ACTIONS(3158),
    [anon_sym___restrict__] = ACTIONS(3158),
    [anon_sym__Atomic] = ACTIONS(3158),
    [anon_sym__Noreturn] = ACTIONS(3158),
    [anon_sym_noreturn] = ACTIONS(3158),
    [anon_sym_mutable] = ACTIONS(3158),
    [anon_sym_constinit] = ACTIONS(3158),
    [anon_sym_consteval] = ACTIONS(3158),
    [anon_sym_alignas] = ACTIONS(3158),
    [anon_sym__Alignas] = ACTIONS(3158),
    [sym_primitive_type] = ACTIONS(3902),
    [anon_sym_enum] = ACTIONS(3158),
    [anon_sym_class] = ACTIONS(3158),
    [anon_sym_struct] = ACTIONS(3158),
    [anon_sym_union] = ACTIONS(3158),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3158),
    [anon_sym_let] = ACTIONS(3158),
    [anon_sym_This] = ACTIONS(3158),
    [anon_sym_decltype] = ACTIONS(3905),
    [sym_virtual] = ACTIONS(3158),
    [anon_sym_typename] = ACTIONS(3158),
    [anon_sym_template] = ACTIONS(3908),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_precise] = ACTIONS(3158),
    [anon_sym_shared] = ACTIONS(3158),
    [anon_sym_groupshared] = ACTIONS(3158),
    [anon_sym_uniform] = ACTIONS(3158),
    [anon_sym_row_major] = ACTIONS(3158),
    [anon_sym_column_major] = ACTIONS(3158),
    [anon_sym_globallycoherent] = ACTIONS(3158),
    [anon_sym_centroid] = ACTIONS(3158),
    [anon_sym_noperspective] = ACTIONS(3158),
    [anon_sym_nointerpolation] = ACTIONS(3158),
    [anon_sym_sample] = ACTIONS(3158),
    [anon_sym_linear] = ACTIONS(3158),
    [anon_sym_snorm] = ACTIONS(3158),
    [anon_sym_unorm] = ACTIONS(3158),
    [anon_sym_point] = ACTIONS(3158),
    [anon_sym_line] = ACTIONS(3158),
    [anon_sym_triangleadj] = ACTIONS(3158),
    [anon_sym_lineadj] = ACTIONS(3158),
    [anon_sym_triangle] = ACTIONS(3158),
    [anon_sym_interface] = ACTIONS(3158),
    [anon_sym_extension] = ACTIONS(3158),
  },
  [762] = {
    [sym_identifier] = ACTIONS(3344),
    [aux_sym_preproc_include_token1] = ACTIONS(3344),
    [aux_sym_preproc_def_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token2] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3344),
    [sym_preproc_directive] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym___extension__] = ACTIONS(3344),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_in] = ACTIONS(3344),
    [anon_sym_out] = ACTIONS(3344),
    [anon_sym_inout] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym___attribute__] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3346),
    [anon_sym___declspec] = ACTIONS(3344),
    [anon_sym___based] = ACTIONS(3344),
    [anon_sym___cdecl] = ACTIONS(3344),
    [anon_sym___clrcall] = ACTIONS(3344),
    [anon_sym___stdcall] = ACTIONS(3344),
    [anon_sym___fastcall] = ACTIONS(3344),
    [anon_sym___thiscall] = ACTIONS(3344),
    [anon_sym___vectorcall] = ACTIONS(3344),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_signed] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym___inline] = ACTIONS(3344),
    [anon_sym___inline__] = ACTIONS(3344),
    [anon_sym___forceinline] = ACTIONS(3344),
    [anon_sym_thread_local] = ACTIONS(3344),
    [anon_sym___thread] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym___restrict__] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym__Noreturn] = ACTIONS(3344),
    [anon_sym_noreturn] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_constinit] = ACTIONS(3344),
    [anon_sym_consteval] = ACTIONS(3344),
    [anon_sym_alignas] = ACTIONS(3344),
    [anon_sym__Alignas] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_class] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_switch] = ACTIONS(3344),
    [anon_sym_case] = ACTIONS(3344),
    [anon_sym_default] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_break] = ACTIONS(3344),
    [anon_sym_continue] = ACTIONS(3344),
    [anon_sym_goto] = ACTIONS(3344),
    [anon_sym___try] = ACTIONS(3344),
    [anon_sym___leave] = ACTIONS(3344),
    [anon_sym_not] = ACTIONS(3344),
    [anon_sym_compl] = ACTIONS(3344),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_sizeof] = ACTIONS(3344),
    [anon_sym___alignof__] = ACTIONS(3344),
    [anon_sym___alignof] = ACTIONS(3344),
    [anon_sym__alignof] = ACTIONS(3344),
    [anon_sym_alignof] = ACTIONS(3344),
    [anon_sym__Alignof] = ACTIONS(3344),
    [anon_sym_offsetof] = ACTIONS(3344),
    [anon_sym__Generic] = ACTIONS(3344),
    [anon_sym_asm] = ACTIONS(3344),
    [anon_sym___asm__] = ACTIONS(3344),
    [sym_number_literal] = ACTIONS(3346),
    [anon_sym_L_SQUOTE] = ACTIONS(3346),
    [anon_sym_u_SQUOTE] = ACTIONS(3346),
    [anon_sym_U_SQUOTE] = ACTIONS(3346),
    [anon_sym_u8_SQUOTE] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_L_DQUOTE] = ACTIONS(3346),
    [anon_sym_u_DQUOTE] = ACTIONS(3346),
    [anon_sym_U_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8_DQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [sym_true] = ACTIONS(3344),
    [sym_false] = ACTIONS(3344),
    [anon_sym_NULL] = ACTIONS(3344),
    [anon_sym_nullptr] = ACTIONS(3344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_This] = ACTIONS(3344),
    [anon_sym_decltype] = ACTIONS(3344),
    [sym_virtual] = ACTIONS(3344),
    [anon_sym_explicit] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_template] = ACTIONS(3344),
    [anon_sym_operator] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_delete] = ACTIONS(3344),
    [anon_sym_throw] = ACTIONS(3344),
    [anon_sym_namespace] = ACTIONS(3344),
    [anon_sym_using] = ACTIONS(3344),
    [anon_sym_static_assert] = ACTIONS(3344),
    [anon_sym_concept] = ACTIONS(3344),
    [anon_sym_co_return] = ACTIONS(3344),
    [anon_sym_co_yield] = ACTIONS(3344),
    [anon_sym_R_DQUOTE] = ACTIONS(3346),
    [anon_sym_LR_DQUOTE] = ACTIONS(3346),
    [anon_sym_uR_DQUOTE] = ACTIONS(3346),
    [anon_sym_UR_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3346),
    [anon_sym_co_await] = ACTIONS(3344),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_requires] = ACTIONS(3344),
    [sym_this] = ACTIONS(3344),
    [anon_sym_discard] = ACTIONS(3344),
    [anon_sym_precise] = ACTIONS(3344),
    [anon_sym_shared] = ACTIONS(3344),
    [anon_sym_groupshared] = ACTIONS(3344),
    [anon_sym_uniform] = ACTIONS(3344),
    [anon_sym_row_major] = ACTIONS(3344),
    [anon_sym_column_major] = ACTIONS(3344),
    [anon_sym_globallycoherent] = ACTIONS(3344),
    [anon_sym_centroid] = ACTIONS(3344),
    [anon_sym_noperspective] = ACTIONS(3344),
    [anon_sym_nointerpolation] = ACTIONS(3344),
    [anon_sym_sample] = ACTIONS(3344),
    [anon_sym_linear] = ACTIONS(3344),
    [anon_sym_snorm] = ACTIONS(3344),
    [anon_sym_unorm] = ACTIONS(3344),
    [anon_sym_point] = ACTIONS(3344),
    [anon_sym_line] = ACTIONS(3344),
    [anon_sym_triangleadj] = ACTIONS(3344),
    [anon_sym_lineadj] = ACTIONS(3344),
    [anon_sym_triangle] = ACTIONS(3344),
    [anon_sym_cbuffer] = ACTIONS(3344),
    [anon_sym_interface] = ACTIONS(3344),
    [anon_sym_extension] = ACTIONS(3344),
  },
  [763] = {
    [sym_identifier] = ACTIONS(3344),
    [aux_sym_preproc_include_token1] = ACTIONS(3344),
    [aux_sym_preproc_def_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token2] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3344),
    [sym_preproc_directive] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym___extension__] = ACTIONS(3344),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_in] = ACTIONS(3344),
    [anon_sym_out] = ACTIONS(3344),
    [anon_sym_inout] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym___attribute__] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3346),
    [anon_sym___declspec] = ACTIONS(3344),
    [anon_sym___based] = ACTIONS(3344),
    [anon_sym___cdecl] = ACTIONS(3344),
    [anon_sym___clrcall] = ACTIONS(3344),
    [anon_sym___stdcall] = ACTIONS(3344),
    [anon_sym___fastcall] = ACTIONS(3344),
    [anon_sym___thiscall] = ACTIONS(3344),
    [anon_sym___vectorcall] = ACTIONS(3344),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_signed] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym___inline] = ACTIONS(3344),
    [anon_sym___inline__] = ACTIONS(3344),
    [anon_sym___forceinline] = ACTIONS(3344),
    [anon_sym_thread_local] = ACTIONS(3344),
    [anon_sym___thread] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym___restrict__] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym__Noreturn] = ACTIONS(3344),
    [anon_sym_noreturn] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_constinit] = ACTIONS(3344),
    [anon_sym_consteval] = ACTIONS(3344),
    [anon_sym_alignas] = ACTIONS(3344),
    [anon_sym__Alignas] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_class] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_switch] = ACTIONS(3344),
    [anon_sym_case] = ACTIONS(3344),
    [anon_sym_default] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_break] = ACTIONS(3344),
    [anon_sym_continue] = ACTIONS(3344),
    [anon_sym_goto] = ACTIONS(3344),
    [anon_sym___try] = ACTIONS(3344),
    [anon_sym___leave] = ACTIONS(3344),
    [anon_sym_not] = ACTIONS(3344),
    [anon_sym_compl] = ACTIONS(3344),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_sizeof] = ACTIONS(3344),
    [anon_sym___alignof__] = ACTIONS(3344),
    [anon_sym___alignof] = ACTIONS(3344),
    [anon_sym__alignof] = ACTIONS(3344),
    [anon_sym_alignof] = ACTIONS(3344),
    [anon_sym__Alignof] = ACTIONS(3344),
    [anon_sym_offsetof] = ACTIONS(3344),
    [anon_sym__Generic] = ACTIONS(3344),
    [anon_sym_asm] = ACTIONS(3344),
    [anon_sym___asm__] = ACTIONS(3344),
    [sym_number_literal] = ACTIONS(3346),
    [anon_sym_L_SQUOTE] = ACTIONS(3346),
    [anon_sym_u_SQUOTE] = ACTIONS(3346),
    [anon_sym_U_SQUOTE] = ACTIONS(3346),
    [anon_sym_u8_SQUOTE] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_L_DQUOTE] = ACTIONS(3346),
    [anon_sym_u_DQUOTE] = ACTIONS(3346),
    [anon_sym_U_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8_DQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [sym_true] = ACTIONS(3344),
    [sym_false] = ACTIONS(3344),
    [anon_sym_NULL] = ACTIONS(3344),
    [anon_sym_nullptr] = ACTIONS(3344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_This] = ACTIONS(3344),
    [anon_sym_decltype] = ACTIONS(3344),
    [sym_virtual] = ACTIONS(3344),
    [anon_sym_explicit] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_template] = ACTIONS(3344),
    [anon_sym_operator] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_delete] = ACTIONS(3344),
    [anon_sym_throw] = ACTIONS(3344),
    [anon_sym_namespace] = ACTIONS(3344),
    [anon_sym_using] = ACTIONS(3344),
    [anon_sym_static_assert] = ACTIONS(3344),
    [anon_sym_concept] = ACTIONS(3344),
    [anon_sym_co_return] = ACTIONS(3344),
    [anon_sym_co_yield] = ACTIONS(3344),
    [anon_sym_R_DQUOTE] = ACTIONS(3346),
    [anon_sym_LR_DQUOTE] = ACTIONS(3346),
    [anon_sym_uR_DQUOTE] = ACTIONS(3346),
    [anon_sym_UR_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3346),
    [anon_sym_co_await] = ACTIONS(3344),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_requires] = ACTIONS(3344),
    [sym_this] = ACTIONS(3344),
    [anon_sym_discard] = ACTIONS(3344),
    [anon_sym_precise] = ACTIONS(3344),
    [anon_sym_shared] = ACTIONS(3344),
    [anon_sym_groupshared] = ACTIONS(3344),
    [anon_sym_uniform] = ACTIONS(3344),
    [anon_sym_row_major] = ACTIONS(3344),
    [anon_sym_column_major] = ACTIONS(3344),
    [anon_sym_globallycoherent] = ACTIONS(3344),
    [anon_sym_centroid] = ACTIONS(3344),
    [anon_sym_noperspective] = ACTIONS(3344),
    [anon_sym_nointerpolation] = ACTIONS(3344),
    [anon_sym_sample] = ACTIONS(3344),
    [anon_sym_linear] = ACTIONS(3344),
    [anon_sym_snorm] = ACTIONS(3344),
    [anon_sym_unorm] = ACTIONS(3344),
    [anon_sym_point] = ACTIONS(3344),
    [anon_sym_line] = ACTIONS(3344),
    [anon_sym_triangleadj] = ACTIONS(3344),
    [anon_sym_lineadj] = ACTIONS(3344),
    [anon_sym_triangle] = ACTIONS(3344),
    [anon_sym_cbuffer] = ACTIONS(3344),
    [anon_sym_interface] = ACTIONS(3344),
    [anon_sym_extension] = ACTIONS(3344),
  },
  [764] = {
    [sym_identifier] = ACTIONS(2982),
    [aux_sym_preproc_include_token1] = ACTIONS(2982),
    [aux_sym_preproc_def_token1] = ACTIONS(2982),
    [aux_sym_preproc_if_token1] = ACTIONS(2982),
    [aux_sym_preproc_if_token2] = ACTIONS(2982),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2982),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2982),
    [sym_preproc_directive] = ACTIONS(2982),
    [anon_sym_LPAREN2] = ACTIONS(2984),
    [anon_sym_BANG] = ACTIONS(2984),
    [anon_sym_TILDE] = ACTIONS(2984),
    [anon_sym_DASH] = ACTIONS(2982),
    [anon_sym_PLUS] = ACTIONS(2982),
    [anon_sym_STAR] = ACTIONS(2984),
    [anon_sym_AMP_AMP] = ACTIONS(2984),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_SEMI] = ACTIONS(2984),
    [anon_sym___extension__] = ACTIONS(2982),
    [anon_sym_typedef] = ACTIONS(2982),
    [anon_sym_in] = ACTIONS(2982),
    [anon_sym_out] = ACTIONS(2982),
    [anon_sym_inout] = ACTIONS(2982),
    [anon_sym_extern] = ACTIONS(2982),
    [anon_sym___attribute__] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2984),
    [anon_sym___declspec] = ACTIONS(2982),
    [anon_sym___based] = ACTIONS(2982),
    [anon_sym___cdecl] = ACTIONS(2982),
    [anon_sym___clrcall] = ACTIONS(2982),
    [anon_sym___stdcall] = ACTIONS(2982),
    [anon_sym___fastcall] = ACTIONS(2982),
    [anon_sym___thiscall] = ACTIONS(2982),
    [anon_sym___vectorcall] = ACTIONS(2982),
    [anon_sym_LBRACE] = ACTIONS(2984),
    [anon_sym_signed] = ACTIONS(2982),
    [anon_sym_unsigned] = ACTIONS(2982),
    [anon_sym_long] = ACTIONS(2982),
    [anon_sym_short] = ACTIONS(2982),
    [anon_sym_LBRACK] = ACTIONS(2982),
    [anon_sym_static] = ACTIONS(2982),
    [anon_sym_register] = ACTIONS(2982),
    [anon_sym_inline] = ACTIONS(2982),
    [anon_sym___inline] = ACTIONS(2982),
    [anon_sym___inline__] = ACTIONS(2982),
    [anon_sym___forceinline] = ACTIONS(2982),
    [anon_sym_thread_local] = ACTIONS(2982),
    [anon_sym___thread] = ACTIONS(2982),
    [anon_sym_const] = ACTIONS(2982),
    [anon_sym_constexpr] = ACTIONS(2982),
    [anon_sym_volatile] = ACTIONS(2982),
    [anon_sym_restrict] = ACTIONS(2982),
    [anon_sym___restrict__] = ACTIONS(2982),
    [anon_sym__Atomic] = ACTIONS(2982),
    [anon_sym__Noreturn] = ACTIONS(2982),
    [anon_sym_noreturn] = ACTIONS(2982),
    [anon_sym_mutable] = ACTIONS(2982),
    [anon_sym_constinit] = ACTIONS(2982),
    [anon_sym_consteval] = ACTIONS(2982),
    [anon_sym_alignas] = ACTIONS(2982),
    [anon_sym__Alignas] = ACTIONS(2982),
    [sym_primitive_type] = ACTIONS(2982),
    [anon_sym_enum] = ACTIONS(2982),
    [anon_sym_class] = ACTIONS(2982),
    [anon_sym_struct] = ACTIONS(2982),
    [anon_sym_union] = ACTIONS(2982),
    [anon_sym_if] = ACTIONS(2982),
    [anon_sym_else] = ACTIONS(2982),
    [anon_sym_switch] = ACTIONS(2982),
    [anon_sym_case] = ACTIONS(2982),
    [anon_sym_default] = ACTIONS(2982),
    [anon_sym_while] = ACTIONS(2982),
    [anon_sym_do] = ACTIONS(2982),
    [anon_sym_for] = ACTIONS(2982),
    [anon_sym_return] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2982),
    [anon_sym_continue] = ACTIONS(2982),
    [anon_sym_goto] = ACTIONS(2982),
    [anon_sym___try] = ACTIONS(2982),
    [anon_sym___leave] = ACTIONS(2982),
    [anon_sym_not] = ACTIONS(2982),
    [anon_sym_compl] = ACTIONS(2982),
    [anon_sym_DASH_DASH] = ACTIONS(2984),
    [anon_sym_PLUS_PLUS] = ACTIONS(2984),
    [anon_sym_sizeof] = ACTIONS(2982),
    [anon_sym___alignof__] = ACTIONS(2982),
    [anon_sym___alignof] = ACTIONS(2982),
    [anon_sym__alignof] = ACTIONS(2982),
    [anon_sym_alignof] = ACTIONS(2982),
    [anon_sym__Alignof] = ACTIONS(2982),
    [anon_sym_offsetof] = ACTIONS(2982),
    [anon_sym__Generic] = ACTIONS(2982),
    [anon_sym_asm] = ACTIONS(2982),
    [anon_sym___asm__] = ACTIONS(2982),
    [sym_number_literal] = ACTIONS(2984),
    [anon_sym_L_SQUOTE] = ACTIONS(2984),
    [anon_sym_u_SQUOTE] = ACTIONS(2984),
    [anon_sym_U_SQUOTE] = ACTIONS(2984),
    [anon_sym_u8_SQUOTE] = ACTIONS(2984),
    [anon_sym_SQUOTE] = ACTIONS(2984),
    [anon_sym_L_DQUOTE] = ACTIONS(2984),
    [anon_sym_u_DQUOTE] = ACTIONS(2984),
    [anon_sym_U_DQUOTE] = ACTIONS(2984),
    [anon_sym_u8_DQUOTE] = ACTIONS(2984),
    [anon_sym_DQUOTE] = ACTIONS(2984),
    [sym_true] = ACTIONS(2982),
    [sym_false] = ACTIONS(2982),
    [anon_sym_NULL] = ACTIONS(2982),
    [anon_sym_nullptr] = ACTIONS(2982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2982),
    [anon_sym_let] = ACTIONS(2982),
    [anon_sym_This] = ACTIONS(2982),
    [anon_sym_decltype] = ACTIONS(2982),
    [sym_virtual] = ACTIONS(2982),
    [anon_sym_explicit] = ACTIONS(2982),
    [anon_sym_typename] = ACTIONS(2982),
    [anon_sym_template] = ACTIONS(2982),
    [anon_sym_operator] = ACTIONS(2982),
    [anon_sym_try] = ACTIONS(2982),
    [anon_sym_delete] = ACTIONS(2982),
    [anon_sym_throw] = ACTIONS(2982),
    [anon_sym_namespace] = ACTIONS(2982),
    [anon_sym_using] = ACTIONS(2982),
    [anon_sym_static_assert] = ACTIONS(2982),
    [anon_sym_concept] = ACTIONS(2982),
    [anon_sym_co_return] = ACTIONS(2982),
    [anon_sym_co_yield] = ACTIONS(2982),
    [anon_sym_R_DQUOTE] = ACTIONS(2984),
    [anon_sym_LR_DQUOTE] = ACTIONS(2984),
    [anon_sym_uR_DQUOTE] = ACTIONS(2984),
    [anon_sym_UR_DQUOTE] = ACTIONS(2984),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2984),
    [anon_sym_co_await] = ACTIONS(2982),
    [anon_sym_new] = ACTIONS(2982),
    [anon_sym_requires] = ACTIONS(2982),
    [sym_this] = ACTIONS(2982),
    [anon_sym_discard] = ACTIONS(2982),
    [anon_sym_precise] = ACTIONS(2982),
    [anon_sym_shared] = ACTIONS(2982),
    [anon_sym_groupshared] = ACTIONS(2982),
    [anon_sym_uniform] = ACTIONS(2982),
    [anon_sym_row_major] = ACTIONS(2982),
    [anon_sym_column_major] = ACTIONS(2982),
    [anon_sym_globallycoherent] = ACTIONS(2982),
    [anon_sym_centroid] = ACTIONS(2982),
    [anon_sym_noperspective] = ACTIONS(2982),
    [anon_sym_nointerpolation] = ACTIONS(2982),
    [anon_sym_sample] = ACTIONS(2982),
    [anon_sym_linear] = ACTIONS(2982),
    [anon_sym_snorm] = ACTIONS(2982),
    [anon_sym_unorm] = ACTIONS(2982),
    [anon_sym_point] = ACTIONS(2982),
    [anon_sym_line] = ACTIONS(2982),
    [anon_sym_triangleadj] = ACTIONS(2982),
    [anon_sym_lineadj] = ACTIONS(2982),
    [anon_sym_triangle] = ACTIONS(2982),
    [anon_sym_cbuffer] = ACTIONS(2982),
    [anon_sym_interface] = ACTIONS(2982),
    [anon_sym_extension] = ACTIONS(2982),
  },
  [765] = {
    [sym_identifier] = ACTIONS(3182),
    [aux_sym_preproc_include_token1] = ACTIONS(3182),
    [aux_sym_preproc_def_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [sym_preproc_directive] = ACTIONS(3182),
    [anon_sym_LPAREN2] = ACTIONS(3184),
    [anon_sym_BANG] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_DASH] = ACTIONS(3182),
    [anon_sym_PLUS] = ACTIONS(3182),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_AMP_AMP] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3182),
    [anon_sym_SEMI] = ACTIONS(3184),
    [anon_sym___extension__] = ACTIONS(3182),
    [anon_sym_typedef] = ACTIONS(3182),
    [anon_sym_in] = ACTIONS(3182),
    [anon_sym_out] = ACTIONS(3182),
    [anon_sym_inout] = ACTIONS(3182),
    [anon_sym_extern] = ACTIONS(3182),
    [anon_sym___attribute__] = ACTIONS(3182),
    [anon_sym_COLON_COLON] = ACTIONS(3184),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3184),
    [anon_sym___declspec] = ACTIONS(3182),
    [anon_sym___based] = ACTIONS(3182),
    [anon_sym___cdecl] = ACTIONS(3182),
    [anon_sym___clrcall] = ACTIONS(3182),
    [anon_sym___stdcall] = ACTIONS(3182),
    [anon_sym___fastcall] = ACTIONS(3182),
    [anon_sym___thiscall] = ACTIONS(3182),
    [anon_sym___vectorcall] = ACTIONS(3182),
    [anon_sym_LBRACE] = ACTIONS(3184),
    [anon_sym_RBRACE] = ACTIONS(3184),
    [anon_sym_signed] = ACTIONS(3182),
    [anon_sym_unsigned] = ACTIONS(3182),
    [anon_sym_long] = ACTIONS(3182),
    [anon_sym_short] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3182),
    [anon_sym_register] = ACTIONS(3182),
    [anon_sym_inline] = ACTIONS(3182),
    [anon_sym___inline] = ACTIONS(3182),
    [anon_sym___inline__] = ACTIONS(3182),
    [anon_sym___forceinline] = ACTIONS(3182),
    [anon_sym_thread_local] = ACTIONS(3182),
    [anon_sym___thread] = ACTIONS(3182),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_constexpr] = ACTIONS(3182),
    [anon_sym_volatile] = ACTIONS(3182),
    [anon_sym_restrict] = ACTIONS(3182),
    [anon_sym___restrict__] = ACTIONS(3182),
    [anon_sym__Atomic] = ACTIONS(3182),
    [anon_sym__Noreturn] = ACTIONS(3182),
    [anon_sym_noreturn] = ACTIONS(3182),
    [anon_sym_mutable] = ACTIONS(3182),
    [anon_sym_constinit] = ACTIONS(3182),
    [anon_sym_consteval] = ACTIONS(3182),
    [anon_sym_alignas] = ACTIONS(3182),
    [anon_sym__Alignas] = ACTIONS(3182),
    [sym_primitive_type] = ACTIONS(3182),
    [anon_sym_enum] = ACTIONS(3182),
    [anon_sym_class] = ACTIONS(3182),
    [anon_sym_struct] = ACTIONS(3182),
    [anon_sym_union] = ACTIONS(3182),
    [anon_sym_if] = ACTIONS(3182),
    [anon_sym_else] = ACTIONS(3182),
    [anon_sym_switch] = ACTIONS(3182),
    [anon_sym_case] = ACTIONS(3182),
    [anon_sym_default] = ACTIONS(3182),
    [anon_sym_while] = ACTIONS(3182),
    [anon_sym_do] = ACTIONS(3182),
    [anon_sym_for] = ACTIONS(3182),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_break] = ACTIONS(3182),
    [anon_sym_continue] = ACTIONS(3182),
    [anon_sym_goto] = ACTIONS(3182),
    [anon_sym___try] = ACTIONS(3182),
    [anon_sym___leave] = ACTIONS(3182),
    [anon_sym_not] = ACTIONS(3182),
    [anon_sym_compl] = ACTIONS(3182),
    [anon_sym_DASH_DASH] = ACTIONS(3184),
    [anon_sym_PLUS_PLUS] = ACTIONS(3184),
    [anon_sym_sizeof] = ACTIONS(3182),
    [anon_sym___alignof__] = ACTIONS(3182),
    [anon_sym___alignof] = ACTIONS(3182),
    [anon_sym__alignof] = ACTIONS(3182),
    [anon_sym_alignof] = ACTIONS(3182),
    [anon_sym__Alignof] = ACTIONS(3182),
    [anon_sym_offsetof] = ACTIONS(3182),
    [anon_sym__Generic] = ACTIONS(3182),
    [anon_sym_asm] = ACTIONS(3182),
    [anon_sym___asm__] = ACTIONS(3182),
    [sym_number_literal] = ACTIONS(3184),
    [anon_sym_L_SQUOTE] = ACTIONS(3184),
    [anon_sym_u_SQUOTE] = ACTIONS(3184),
    [anon_sym_U_SQUOTE] = ACTIONS(3184),
    [anon_sym_u8_SQUOTE] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3184),
    [anon_sym_L_DQUOTE] = ACTIONS(3184),
    [anon_sym_u_DQUOTE] = ACTIONS(3184),
    [anon_sym_U_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8_DQUOTE] = ACTIONS(3184),
    [anon_sym_DQUOTE] = ACTIONS(3184),
    [sym_true] = ACTIONS(3182),
    [sym_false] = ACTIONS(3182),
    [anon_sym_NULL] = ACTIONS(3182),
    [anon_sym_nullptr] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3182),
    [anon_sym_let] = ACTIONS(3182),
    [anon_sym_This] = ACTIONS(3182),
    [anon_sym_decltype] = ACTIONS(3182),
    [sym_virtual] = ACTIONS(3182),
    [anon_sym_explicit] = ACTIONS(3182),
    [anon_sym_typename] = ACTIONS(3182),
    [anon_sym_template] = ACTIONS(3182),
    [anon_sym_operator] = ACTIONS(3182),
    [anon_sym_try] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(3182),
    [anon_sym_throw] = ACTIONS(3182),
    [anon_sym_namespace] = ACTIONS(3182),
    [anon_sym_using] = ACTIONS(3182),
    [anon_sym_static_assert] = ACTIONS(3182),
    [anon_sym_concept] = ACTIONS(3182),
    [anon_sym_co_return] = ACTIONS(3182),
    [anon_sym_co_yield] = ACTIONS(3182),
    [anon_sym_R_DQUOTE] = ACTIONS(3184),
    [anon_sym_LR_DQUOTE] = ACTIONS(3184),
    [anon_sym_uR_DQUOTE] = ACTIONS(3184),
    [anon_sym_UR_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3184),
    [anon_sym_co_await] = ACTIONS(3182),
    [anon_sym_new] = ACTIONS(3182),
    [anon_sym_requires] = ACTIONS(3182),
    [sym_this] = ACTIONS(3182),
    [anon_sym_discard] = ACTIONS(3182),
    [anon_sym_precise] = ACTIONS(3182),
    [anon_sym_shared] = ACTIONS(3182),
    [anon_sym_groupshared] = ACTIONS(3182),
    [anon_sym_uniform] = ACTIONS(3182),
    [anon_sym_row_major] = ACTIONS(3182),
    [anon_sym_column_major] = ACTIONS(3182),
    [anon_sym_globallycoherent] = ACTIONS(3182),
    [anon_sym_centroid] = ACTIONS(3182),
    [anon_sym_noperspective] = ACTIONS(3182),
    [anon_sym_nointerpolation] = ACTIONS(3182),
    [anon_sym_sample] = ACTIONS(3182),
    [anon_sym_linear] = ACTIONS(3182),
    [anon_sym_snorm] = ACTIONS(3182),
    [anon_sym_unorm] = ACTIONS(3182),
    [anon_sym_point] = ACTIONS(3182),
    [anon_sym_line] = ACTIONS(3182),
    [anon_sym_triangleadj] = ACTIONS(3182),
    [anon_sym_lineadj] = ACTIONS(3182),
    [anon_sym_triangle] = ACTIONS(3182),
    [anon_sym_cbuffer] = ACTIONS(3182),
    [anon_sym_interface] = ACTIONS(3182),
    [anon_sym_extension] = ACTIONS(3182),
  },
  [766] = {
    [sym_identifier] = ACTIONS(2742),
    [aux_sym_preproc_include_token1] = ACTIONS(2742),
    [aux_sym_preproc_def_token1] = ACTIONS(2742),
    [aux_sym_preproc_if_token1] = ACTIONS(2742),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2742),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2742),
    [sym_preproc_directive] = ACTIONS(2742),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_BANG] = ACTIONS(2740),
    [anon_sym_TILDE] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2742),
    [anon_sym_PLUS] = ACTIONS(2742),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym___extension__] = ACTIONS(2742),
    [anon_sym_typedef] = ACTIONS(2742),
    [anon_sym_in] = ACTIONS(2742),
    [anon_sym_out] = ACTIONS(2742),
    [anon_sym_inout] = ACTIONS(2742),
    [anon_sym_extern] = ACTIONS(2742),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym_COLON_COLON] = ACTIONS(2740),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2740),
    [anon_sym___declspec] = ACTIONS(2742),
    [anon_sym___based] = ACTIONS(2742),
    [anon_sym___cdecl] = ACTIONS(2742),
    [anon_sym___clrcall] = ACTIONS(2742),
    [anon_sym___stdcall] = ACTIONS(2742),
    [anon_sym___fastcall] = ACTIONS(2742),
    [anon_sym___thiscall] = ACTIONS(2742),
    [anon_sym___vectorcall] = ACTIONS(2742),
    [anon_sym_LBRACE] = ACTIONS(2740),
    [anon_sym_RBRACE] = ACTIONS(2740),
    [anon_sym_signed] = ACTIONS(2742),
    [anon_sym_unsigned] = ACTIONS(2742),
    [anon_sym_long] = ACTIONS(2742),
    [anon_sym_short] = ACTIONS(2742),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2742),
    [anon_sym_register] = ACTIONS(2742),
    [anon_sym_inline] = ACTIONS(2742),
    [anon_sym___inline] = ACTIONS(2742),
    [anon_sym___inline__] = ACTIONS(2742),
    [anon_sym___forceinline] = ACTIONS(2742),
    [anon_sym_thread_local] = ACTIONS(2742),
    [anon_sym___thread] = ACTIONS(2742),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_constexpr] = ACTIONS(2742),
    [anon_sym_volatile] = ACTIONS(2742),
    [anon_sym_restrict] = ACTIONS(2742),
    [anon_sym___restrict__] = ACTIONS(2742),
    [anon_sym__Atomic] = ACTIONS(2742),
    [anon_sym__Noreturn] = ACTIONS(2742),
    [anon_sym_noreturn] = ACTIONS(2742),
    [anon_sym_mutable] = ACTIONS(2742),
    [anon_sym_constinit] = ACTIONS(2742),
    [anon_sym_consteval] = ACTIONS(2742),
    [anon_sym_alignas] = ACTIONS(2742),
    [anon_sym__Alignas] = ACTIONS(2742),
    [sym_primitive_type] = ACTIONS(2742),
    [anon_sym_enum] = ACTIONS(2742),
    [anon_sym_class] = ACTIONS(2742),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2742),
    [anon_sym_if] = ACTIONS(2742),
    [anon_sym_switch] = ACTIONS(2742),
    [anon_sym_case] = ACTIONS(2742),
    [anon_sym_default] = ACTIONS(2742),
    [anon_sym_while] = ACTIONS(2742),
    [anon_sym_do] = ACTIONS(2742),
    [anon_sym_for] = ACTIONS(2742),
    [anon_sym_return] = ACTIONS(2742),
    [anon_sym_break] = ACTIONS(2742),
    [anon_sym_continue] = ACTIONS(2742),
    [anon_sym_goto] = ACTIONS(2742),
    [anon_sym___try] = ACTIONS(2742),
    [anon_sym___leave] = ACTIONS(2742),
    [anon_sym_not] = ACTIONS(2742),
    [anon_sym_compl] = ACTIONS(2742),
    [anon_sym_DASH_DASH] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2740),
    [anon_sym_sizeof] = ACTIONS(2742),
    [anon_sym___alignof__] = ACTIONS(2742),
    [anon_sym___alignof] = ACTIONS(2742),
    [anon_sym__alignof] = ACTIONS(2742),
    [anon_sym_alignof] = ACTIONS(2742),
    [anon_sym__Alignof] = ACTIONS(2742),
    [anon_sym_offsetof] = ACTIONS(2742),
    [anon_sym__Generic] = ACTIONS(2742),
    [anon_sym_asm] = ACTIONS(2742),
    [anon_sym___asm__] = ACTIONS(2742),
    [anon_sym_DOT] = ACTIONS(2742),
    [sym_number_literal] = ACTIONS(2740),
    [anon_sym_L_SQUOTE] = ACTIONS(2740),
    [anon_sym_u_SQUOTE] = ACTIONS(2740),
    [anon_sym_U_SQUOTE] = ACTIONS(2740),
    [anon_sym_u8_SQUOTE] = ACTIONS(2740),
    [anon_sym_SQUOTE] = ACTIONS(2740),
    [anon_sym_L_DQUOTE] = ACTIONS(2740),
    [anon_sym_u_DQUOTE] = ACTIONS(2740),
    [anon_sym_U_DQUOTE] = ACTIONS(2740),
    [anon_sym_u8_DQUOTE] = ACTIONS(2740),
    [anon_sym_DQUOTE] = ACTIONS(2740),
    [sym_true] = ACTIONS(2742),
    [sym_false] = ACTIONS(2742),
    [anon_sym_NULL] = ACTIONS(2742),
    [anon_sym_nullptr] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
    [anon_sym_decltype] = ACTIONS(2742),
    [sym_virtual] = ACTIONS(2742),
    [anon_sym_explicit] = ACTIONS(2742),
    [anon_sym_typename] = ACTIONS(2742),
    [anon_sym_template] = ACTIONS(2742),
    [anon_sym_operator] = ACTIONS(2742),
    [anon_sym_try] = ACTIONS(2742),
    [anon_sym_delete] = ACTIONS(2742),
    [anon_sym_throw] = ACTIONS(2742),
    [anon_sym_namespace] = ACTIONS(2742),
    [anon_sym_using] = ACTIONS(2742),
    [anon_sym_static_assert] = ACTIONS(2742),
    [anon_sym_concept] = ACTIONS(2742),
    [anon_sym_co_return] = ACTIONS(2742),
    [anon_sym_co_yield] = ACTIONS(2742),
    [anon_sym_R_DQUOTE] = ACTIONS(2740),
    [anon_sym_LR_DQUOTE] = ACTIONS(2740),
    [anon_sym_uR_DQUOTE] = ACTIONS(2740),
    [anon_sym_UR_DQUOTE] = ACTIONS(2740),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2740),
    [anon_sym_co_await] = ACTIONS(2742),
    [anon_sym_new] = ACTIONS(2742),
    [anon_sym_requires] = ACTIONS(2742),
    [sym_this] = ACTIONS(2742),
    [anon_sym_discard] = ACTIONS(2742),
    [anon_sym_precise] = ACTIONS(2742),
    [anon_sym_shared] = ACTIONS(2742),
    [anon_sym_groupshared] = ACTIONS(2742),
    [anon_sym_uniform] = ACTIONS(2742),
    [anon_sym_row_major] = ACTIONS(2742),
    [anon_sym_column_major] = ACTIONS(2742),
    [anon_sym_globallycoherent] = ACTIONS(2742),
    [anon_sym_centroid] = ACTIONS(2742),
    [anon_sym_noperspective] = ACTIONS(2742),
    [anon_sym_nointerpolation] = ACTIONS(2742),
    [anon_sym_sample] = ACTIONS(2742),
    [anon_sym_linear] = ACTIONS(2742),
    [anon_sym_snorm] = ACTIONS(2742),
    [anon_sym_unorm] = ACTIONS(2742),
    [anon_sym_point] = ACTIONS(2742),
    [anon_sym_line] = ACTIONS(2742),
    [anon_sym_triangleadj] = ACTIONS(2742),
    [anon_sym_lineadj] = ACTIONS(2742),
    [anon_sym_triangle] = ACTIONS(2742),
    [anon_sym_cbuffer] = ACTIONS(2742),
    [anon_sym_interface] = ACTIONS(2742),
    [anon_sym_extension] = ACTIONS(2742),
  },
  [767] = {
    [sym_identifier] = ACTIONS(3182),
    [aux_sym_preproc_include_token1] = ACTIONS(3182),
    [aux_sym_preproc_def_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [sym_preproc_directive] = ACTIONS(3182),
    [anon_sym_LPAREN2] = ACTIONS(3184),
    [anon_sym_BANG] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_DASH] = ACTIONS(3182),
    [anon_sym_PLUS] = ACTIONS(3182),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_AMP_AMP] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3182),
    [anon_sym_SEMI] = ACTIONS(3184),
    [anon_sym___extension__] = ACTIONS(3182),
    [anon_sym_typedef] = ACTIONS(3182),
    [anon_sym_in] = ACTIONS(3182),
    [anon_sym_out] = ACTIONS(3182),
    [anon_sym_inout] = ACTIONS(3182),
    [anon_sym_extern] = ACTIONS(3182),
    [anon_sym___attribute__] = ACTIONS(3182),
    [anon_sym_COLON_COLON] = ACTIONS(3184),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3184),
    [anon_sym___declspec] = ACTIONS(3182),
    [anon_sym___based] = ACTIONS(3182),
    [anon_sym___cdecl] = ACTIONS(3182),
    [anon_sym___clrcall] = ACTIONS(3182),
    [anon_sym___stdcall] = ACTIONS(3182),
    [anon_sym___fastcall] = ACTIONS(3182),
    [anon_sym___thiscall] = ACTIONS(3182),
    [anon_sym___vectorcall] = ACTIONS(3182),
    [anon_sym_LBRACE] = ACTIONS(3184),
    [anon_sym_RBRACE] = ACTIONS(3184),
    [anon_sym_signed] = ACTIONS(3182),
    [anon_sym_unsigned] = ACTIONS(3182),
    [anon_sym_long] = ACTIONS(3182),
    [anon_sym_short] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3182),
    [anon_sym_register] = ACTIONS(3182),
    [anon_sym_inline] = ACTIONS(3182),
    [anon_sym___inline] = ACTIONS(3182),
    [anon_sym___inline__] = ACTIONS(3182),
    [anon_sym___forceinline] = ACTIONS(3182),
    [anon_sym_thread_local] = ACTIONS(3182),
    [anon_sym___thread] = ACTIONS(3182),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_constexpr] = ACTIONS(3182),
    [anon_sym_volatile] = ACTIONS(3182),
    [anon_sym_restrict] = ACTIONS(3182),
    [anon_sym___restrict__] = ACTIONS(3182),
    [anon_sym__Atomic] = ACTIONS(3182),
    [anon_sym__Noreturn] = ACTIONS(3182),
    [anon_sym_noreturn] = ACTIONS(3182),
    [anon_sym_mutable] = ACTIONS(3182),
    [anon_sym_constinit] = ACTIONS(3182),
    [anon_sym_consteval] = ACTIONS(3182),
    [anon_sym_alignas] = ACTIONS(3182),
    [anon_sym__Alignas] = ACTIONS(3182),
    [sym_primitive_type] = ACTIONS(3182),
    [anon_sym_enum] = ACTIONS(3182),
    [anon_sym_class] = ACTIONS(3182),
    [anon_sym_struct] = ACTIONS(3182),
    [anon_sym_union] = ACTIONS(3182),
    [anon_sym_if] = ACTIONS(3182),
    [anon_sym_else] = ACTIONS(3182),
    [anon_sym_switch] = ACTIONS(3182),
    [anon_sym_case] = ACTIONS(3182),
    [anon_sym_default] = ACTIONS(3182),
    [anon_sym_while] = ACTIONS(3182),
    [anon_sym_do] = ACTIONS(3182),
    [anon_sym_for] = ACTIONS(3182),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_break] = ACTIONS(3182),
    [anon_sym_continue] = ACTIONS(3182),
    [anon_sym_goto] = ACTIONS(3182),
    [anon_sym___try] = ACTIONS(3182),
    [anon_sym___leave] = ACTIONS(3182),
    [anon_sym_not] = ACTIONS(3182),
    [anon_sym_compl] = ACTIONS(3182),
    [anon_sym_DASH_DASH] = ACTIONS(3184),
    [anon_sym_PLUS_PLUS] = ACTIONS(3184),
    [anon_sym_sizeof] = ACTIONS(3182),
    [anon_sym___alignof__] = ACTIONS(3182),
    [anon_sym___alignof] = ACTIONS(3182),
    [anon_sym__alignof] = ACTIONS(3182),
    [anon_sym_alignof] = ACTIONS(3182),
    [anon_sym__Alignof] = ACTIONS(3182),
    [anon_sym_offsetof] = ACTIONS(3182),
    [anon_sym__Generic] = ACTIONS(3182),
    [anon_sym_asm] = ACTIONS(3182),
    [anon_sym___asm__] = ACTIONS(3182),
    [sym_number_literal] = ACTIONS(3184),
    [anon_sym_L_SQUOTE] = ACTIONS(3184),
    [anon_sym_u_SQUOTE] = ACTIONS(3184),
    [anon_sym_U_SQUOTE] = ACTIONS(3184),
    [anon_sym_u8_SQUOTE] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3184),
    [anon_sym_L_DQUOTE] = ACTIONS(3184),
    [anon_sym_u_DQUOTE] = ACTIONS(3184),
    [anon_sym_U_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8_DQUOTE] = ACTIONS(3184),
    [anon_sym_DQUOTE] = ACTIONS(3184),
    [sym_true] = ACTIONS(3182),
    [sym_false] = ACTIONS(3182),
    [anon_sym_NULL] = ACTIONS(3182),
    [anon_sym_nullptr] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3182),
    [anon_sym_let] = ACTIONS(3182),
    [anon_sym_This] = ACTIONS(3182),
    [anon_sym_decltype] = ACTIONS(3182),
    [sym_virtual] = ACTIONS(3182),
    [anon_sym_explicit] = ACTIONS(3182),
    [anon_sym_typename] = ACTIONS(3182),
    [anon_sym_template] = ACTIONS(3182),
    [anon_sym_operator] = ACTIONS(3182),
    [anon_sym_try] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(3182),
    [anon_sym_throw] = ACTIONS(3182),
    [anon_sym_namespace] = ACTIONS(3182),
    [anon_sym_using] = ACTIONS(3182),
    [anon_sym_static_assert] = ACTIONS(3182),
    [anon_sym_concept] = ACTIONS(3182),
    [anon_sym_co_return] = ACTIONS(3182),
    [anon_sym_co_yield] = ACTIONS(3182),
    [anon_sym_R_DQUOTE] = ACTIONS(3184),
    [anon_sym_LR_DQUOTE] = ACTIONS(3184),
    [anon_sym_uR_DQUOTE] = ACTIONS(3184),
    [anon_sym_UR_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3184),
    [anon_sym_co_await] = ACTIONS(3182),
    [anon_sym_new] = ACTIONS(3182),
    [anon_sym_requires] = ACTIONS(3182),
    [sym_this] = ACTIONS(3182),
    [anon_sym_discard] = ACTIONS(3182),
    [anon_sym_precise] = ACTIONS(3182),
    [anon_sym_shared] = ACTIONS(3182),
    [anon_sym_groupshared] = ACTIONS(3182),
    [anon_sym_uniform] = ACTIONS(3182),
    [anon_sym_row_major] = ACTIONS(3182),
    [anon_sym_column_major] = ACTIONS(3182),
    [anon_sym_globallycoherent] = ACTIONS(3182),
    [anon_sym_centroid] = ACTIONS(3182),
    [anon_sym_noperspective] = ACTIONS(3182),
    [anon_sym_nointerpolation] = ACTIONS(3182),
    [anon_sym_sample] = ACTIONS(3182),
    [anon_sym_linear] = ACTIONS(3182),
    [anon_sym_snorm] = ACTIONS(3182),
    [anon_sym_unorm] = ACTIONS(3182),
    [anon_sym_point] = ACTIONS(3182),
    [anon_sym_line] = ACTIONS(3182),
    [anon_sym_triangleadj] = ACTIONS(3182),
    [anon_sym_lineadj] = ACTIONS(3182),
    [anon_sym_triangle] = ACTIONS(3182),
    [anon_sym_cbuffer] = ACTIONS(3182),
    [anon_sym_interface] = ACTIONS(3182),
    [anon_sym_extension] = ACTIONS(3182),
  },
  [768] = {
    [sym_identifier] = ACTIONS(3034),
    [aux_sym_preproc_include_token1] = ACTIONS(3034),
    [aux_sym_preproc_def_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_BANG] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3034),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_in] = ACTIONS(3034),
    [anon_sym_out] = ACTIONS(3034),
    [anon_sym_inout] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym___based] = ACTIONS(3034),
    [anon_sym___cdecl] = ACTIONS(3034),
    [anon_sym___clrcall] = ACTIONS(3034),
    [anon_sym___stdcall] = ACTIONS(3034),
    [anon_sym___fastcall] = ACTIONS(3034),
    [anon_sym___thiscall] = ACTIONS(3034),
    [anon_sym___vectorcall] = ACTIONS(3034),
    [anon_sym_LBRACE] = ACTIONS(3036),
    [anon_sym_RBRACE] = ACTIONS(3036),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [anon_sym_if] = ACTIONS(3034),
    [anon_sym_else] = ACTIONS(3034),
    [anon_sym_switch] = ACTIONS(3034),
    [anon_sym_case] = ACTIONS(3034),
    [anon_sym_default] = ACTIONS(3034),
    [anon_sym_while] = ACTIONS(3034),
    [anon_sym_do] = ACTIONS(3034),
    [anon_sym_for] = ACTIONS(3034),
    [anon_sym_return] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3034),
    [anon_sym_continue] = ACTIONS(3034),
    [anon_sym_goto] = ACTIONS(3034),
    [anon_sym___try] = ACTIONS(3034),
    [anon_sym___leave] = ACTIONS(3034),
    [anon_sym_not] = ACTIONS(3034),
    [anon_sym_compl] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_sizeof] = ACTIONS(3034),
    [anon_sym___alignof__] = ACTIONS(3034),
    [anon_sym___alignof] = ACTIONS(3034),
    [anon_sym__alignof] = ACTIONS(3034),
    [anon_sym_alignof] = ACTIONS(3034),
    [anon_sym__Alignof] = ACTIONS(3034),
    [anon_sym_offsetof] = ACTIONS(3034),
    [anon_sym__Generic] = ACTIONS(3034),
    [anon_sym_asm] = ACTIONS(3034),
    [anon_sym___asm__] = ACTIONS(3034),
    [sym_number_literal] = ACTIONS(3036),
    [anon_sym_L_SQUOTE] = ACTIONS(3036),
    [anon_sym_u_SQUOTE] = ACTIONS(3036),
    [anon_sym_U_SQUOTE] = ACTIONS(3036),
    [anon_sym_u8_SQUOTE] = ACTIONS(3036),
    [anon_sym_SQUOTE] = ACTIONS(3036),
    [anon_sym_L_DQUOTE] = ACTIONS(3036),
    [anon_sym_u_DQUOTE] = ACTIONS(3036),
    [anon_sym_U_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8_DQUOTE] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [sym_true] = ACTIONS(3034),
    [sym_false] = ACTIONS(3034),
    [anon_sym_NULL] = ACTIONS(3034),
    [anon_sym_nullptr] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_This] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [sym_virtual] = ACTIONS(3034),
    [anon_sym_explicit] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_operator] = ACTIONS(3034),
    [anon_sym_try] = ACTIONS(3034),
    [anon_sym_delete] = ACTIONS(3034),
    [anon_sym_throw] = ACTIONS(3034),
    [anon_sym_namespace] = ACTIONS(3034),
    [anon_sym_using] = ACTIONS(3034),
    [anon_sym_static_assert] = ACTIONS(3034),
    [anon_sym_concept] = ACTIONS(3034),
    [anon_sym_co_return] = ACTIONS(3034),
    [anon_sym_co_yield] = ACTIONS(3034),
    [anon_sym_R_DQUOTE] = ACTIONS(3036),
    [anon_sym_LR_DQUOTE] = ACTIONS(3036),
    [anon_sym_uR_DQUOTE] = ACTIONS(3036),
    [anon_sym_UR_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3036),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3034),
    [anon_sym_requires] = ACTIONS(3034),
    [sym_this] = ACTIONS(3034),
    [anon_sym_discard] = ACTIONS(3034),
    [anon_sym_precise] = ACTIONS(3034),
    [anon_sym_shared] = ACTIONS(3034),
    [anon_sym_groupshared] = ACTIONS(3034),
    [anon_sym_uniform] = ACTIONS(3034),
    [anon_sym_row_major] = ACTIONS(3034),
    [anon_sym_column_major] = ACTIONS(3034),
    [anon_sym_globallycoherent] = ACTIONS(3034),
    [anon_sym_centroid] = ACTIONS(3034),
    [anon_sym_noperspective] = ACTIONS(3034),
    [anon_sym_nointerpolation] = ACTIONS(3034),
    [anon_sym_sample] = ACTIONS(3034),
    [anon_sym_linear] = ACTIONS(3034),
    [anon_sym_snorm] = ACTIONS(3034),
    [anon_sym_unorm] = ACTIONS(3034),
    [anon_sym_point] = ACTIONS(3034),
    [anon_sym_line] = ACTIONS(3034),
    [anon_sym_triangleadj] = ACTIONS(3034),
    [anon_sym_lineadj] = ACTIONS(3034),
    [anon_sym_triangle] = ACTIONS(3034),
    [anon_sym_cbuffer] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3034),
    [anon_sym_extension] = ACTIONS(3034),
  },
  [769] = {
    [sym_identifier] = ACTIONS(3000),
    [aux_sym_preproc_include_token1] = ACTIONS(3000),
    [aux_sym_preproc_def_token1] = ACTIONS(3000),
    [aux_sym_preproc_if_token1] = ACTIONS(3000),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3000),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3000),
    [sym_preproc_directive] = ACTIONS(3000),
    [anon_sym_LPAREN2] = ACTIONS(2998),
    [anon_sym_BANG] = ACTIONS(2998),
    [anon_sym_TILDE] = ACTIONS(2998),
    [anon_sym_DASH] = ACTIONS(3000),
    [anon_sym_PLUS] = ACTIONS(3000),
    [anon_sym_STAR] = ACTIONS(2998),
    [anon_sym_AMP_AMP] = ACTIONS(2998),
    [anon_sym_AMP] = ACTIONS(3000),
    [anon_sym_SEMI] = ACTIONS(2998),
    [anon_sym___extension__] = ACTIONS(3000),
    [anon_sym_typedef] = ACTIONS(3000),
    [anon_sym_in] = ACTIONS(3000),
    [anon_sym_out] = ACTIONS(3000),
    [anon_sym_inout] = ACTIONS(3000),
    [anon_sym_extern] = ACTIONS(3000),
    [anon_sym___attribute__] = ACTIONS(3000),
    [anon_sym_COLON_COLON] = ACTIONS(2998),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2998),
    [anon_sym___declspec] = ACTIONS(3000),
    [anon_sym___based] = ACTIONS(3000),
    [anon_sym___cdecl] = ACTIONS(3000),
    [anon_sym___clrcall] = ACTIONS(3000),
    [anon_sym___stdcall] = ACTIONS(3000),
    [anon_sym___fastcall] = ACTIONS(3000),
    [anon_sym___thiscall] = ACTIONS(3000),
    [anon_sym___vectorcall] = ACTIONS(3000),
    [anon_sym_LBRACE] = ACTIONS(2998),
    [anon_sym_RBRACE] = ACTIONS(2998),
    [anon_sym_signed] = ACTIONS(3000),
    [anon_sym_unsigned] = ACTIONS(3000),
    [anon_sym_long] = ACTIONS(3000),
    [anon_sym_short] = ACTIONS(3000),
    [anon_sym_LBRACK] = ACTIONS(3000),
    [anon_sym_static] = ACTIONS(3000),
    [anon_sym_register] = ACTIONS(3000),
    [anon_sym_inline] = ACTIONS(3000),
    [anon_sym___inline] = ACTIONS(3000),
    [anon_sym___inline__] = ACTIONS(3000),
    [anon_sym___forceinline] = ACTIONS(3000),
    [anon_sym_thread_local] = ACTIONS(3000),
    [anon_sym___thread] = ACTIONS(3000),
    [anon_sym_const] = ACTIONS(3000),
    [anon_sym_constexpr] = ACTIONS(3000),
    [anon_sym_volatile] = ACTIONS(3000),
    [anon_sym_restrict] = ACTIONS(3000),
    [anon_sym___restrict__] = ACTIONS(3000),
    [anon_sym__Atomic] = ACTIONS(3000),
    [anon_sym__Noreturn] = ACTIONS(3000),
    [anon_sym_noreturn] = ACTIONS(3000),
    [anon_sym_mutable] = ACTIONS(3000),
    [anon_sym_constinit] = ACTIONS(3000),
    [anon_sym_consteval] = ACTIONS(3000),
    [anon_sym_alignas] = ACTIONS(3000),
    [anon_sym__Alignas] = ACTIONS(3000),
    [sym_primitive_type] = ACTIONS(3000),
    [anon_sym_enum] = ACTIONS(3000),
    [anon_sym_class] = ACTIONS(3000),
    [anon_sym_struct] = ACTIONS(3000),
    [anon_sym_union] = ACTIONS(3000),
    [anon_sym_if] = ACTIONS(3000),
    [anon_sym_switch] = ACTIONS(3000),
    [anon_sym_case] = ACTIONS(3000),
    [anon_sym_default] = ACTIONS(3000),
    [anon_sym_while] = ACTIONS(3000),
    [anon_sym_do] = ACTIONS(3000),
    [anon_sym_for] = ACTIONS(3000),
    [anon_sym_return] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3000),
    [anon_sym_continue] = ACTIONS(3000),
    [anon_sym_goto] = ACTIONS(3000),
    [anon_sym___try] = ACTIONS(3000),
    [anon_sym___leave] = ACTIONS(3000),
    [anon_sym_not] = ACTIONS(3000),
    [anon_sym_compl] = ACTIONS(3000),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_sizeof] = ACTIONS(3000),
    [anon_sym___alignof__] = ACTIONS(3000),
    [anon_sym___alignof] = ACTIONS(3000),
    [anon_sym__alignof] = ACTIONS(3000),
    [anon_sym_alignof] = ACTIONS(3000),
    [anon_sym__Alignof] = ACTIONS(3000),
    [anon_sym_offsetof] = ACTIONS(3000),
    [anon_sym__Generic] = ACTIONS(3000),
    [anon_sym_asm] = ACTIONS(3000),
    [anon_sym___asm__] = ACTIONS(3000),
    [anon_sym_DOT] = ACTIONS(3000),
    [sym_number_literal] = ACTIONS(2998),
    [anon_sym_L_SQUOTE] = ACTIONS(2998),
    [anon_sym_u_SQUOTE] = ACTIONS(2998),
    [anon_sym_U_SQUOTE] = ACTIONS(2998),
    [anon_sym_u8_SQUOTE] = ACTIONS(2998),
    [anon_sym_SQUOTE] = ACTIONS(2998),
    [anon_sym_L_DQUOTE] = ACTIONS(2998),
    [anon_sym_u_DQUOTE] = ACTIONS(2998),
    [anon_sym_U_DQUOTE] = ACTIONS(2998),
    [anon_sym_u8_DQUOTE] = ACTIONS(2998),
    [anon_sym_DQUOTE] = ACTIONS(2998),
    [sym_true] = ACTIONS(3000),
    [sym_false] = ACTIONS(3000),
    [anon_sym_NULL] = ACTIONS(3000),
    [anon_sym_nullptr] = ACTIONS(3000),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3000),
    [anon_sym_let] = ACTIONS(3000),
    [anon_sym_This] = ACTIONS(3000),
    [anon_sym_decltype] = ACTIONS(3000),
    [sym_virtual] = ACTIONS(3000),
    [anon_sym_explicit] = ACTIONS(3000),
    [anon_sym_typename] = ACTIONS(3000),
    [anon_sym_template] = ACTIONS(3000),
    [anon_sym_operator] = ACTIONS(3000),
    [anon_sym_try] = ACTIONS(3000),
    [anon_sym_delete] = ACTIONS(3000),
    [anon_sym_throw] = ACTIONS(3000),
    [anon_sym_namespace] = ACTIONS(3000),
    [anon_sym_using] = ACTIONS(3000),
    [anon_sym_static_assert] = ACTIONS(3000),
    [anon_sym_concept] = ACTIONS(3000),
    [anon_sym_co_return] = ACTIONS(3000),
    [anon_sym_co_yield] = ACTIONS(3000),
    [anon_sym_R_DQUOTE] = ACTIONS(2998),
    [anon_sym_LR_DQUOTE] = ACTIONS(2998),
    [anon_sym_uR_DQUOTE] = ACTIONS(2998),
    [anon_sym_UR_DQUOTE] = ACTIONS(2998),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2998),
    [anon_sym_co_await] = ACTIONS(3000),
    [anon_sym_new] = ACTIONS(3000),
    [anon_sym_requires] = ACTIONS(3000),
    [sym_this] = ACTIONS(3000),
    [anon_sym_discard] = ACTIONS(3000),
    [anon_sym_precise] = ACTIONS(3000),
    [anon_sym_shared] = ACTIONS(3000),
    [anon_sym_groupshared] = ACTIONS(3000),
    [anon_sym_uniform] = ACTIONS(3000),
    [anon_sym_row_major] = ACTIONS(3000),
    [anon_sym_column_major] = ACTIONS(3000),
    [anon_sym_globallycoherent] = ACTIONS(3000),
    [anon_sym_centroid] = ACTIONS(3000),
    [anon_sym_noperspective] = ACTIONS(3000),
    [anon_sym_nointerpolation] = ACTIONS(3000),
    [anon_sym_sample] = ACTIONS(3000),
    [anon_sym_linear] = ACTIONS(3000),
    [anon_sym_snorm] = ACTIONS(3000),
    [anon_sym_unorm] = ACTIONS(3000),
    [anon_sym_point] = ACTIONS(3000),
    [anon_sym_line] = ACTIONS(3000),
    [anon_sym_triangleadj] = ACTIONS(3000),
    [anon_sym_lineadj] = ACTIONS(3000),
    [anon_sym_triangle] = ACTIONS(3000),
    [anon_sym_cbuffer] = ACTIONS(3000),
    [anon_sym_interface] = ACTIONS(3000),
    [anon_sym_extension] = ACTIONS(3000),
  },
  [770] = {
    [sym_identifier] = ACTIONS(2978),
    [aux_sym_preproc_include_token1] = ACTIONS(2978),
    [aux_sym_preproc_def_token1] = ACTIONS(2978),
    [aux_sym_preproc_if_token1] = ACTIONS(2978),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2978),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2978),
    [sym_preproc_directive] = ACTIONS(2978),
    [anon_sym_LPAREN2] = ACTIONS(2980),
    [anon_sym_BANG] = ACTIONS(2980),
    [anon_sym_TILDE] = ACTIONS(2980),
    [anon_sym_DASH] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_STAR] = ACTIONS(2980),
    [anon_sym_AMP_AMP] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2978),
    [anon_sym_SEMI] = ACTIONS(2980),
    [anon_sym___extension__] = ACTIONS(2978),
    [anon_sym_typedef] = ACTIONS(2978),
    [anon_sym_in] = ACTIONS(2978),
    [anon_sym_out] = ACTIONS(2978),
    [anon_sym_inout] = ACTIONS(2978),
    [anon_sym_extern] = ACTIONS(2978),
    [anon_sym___attribute__] = ACTIONS(2978),
    [anon_sym_COLON_COLON] = ACTIONS(2980),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2980),
    [anon_sym___declspec] = ACTIONS(2978),
    [anon_sym___based] = ACTIONS(2978),
    [anon_sym___cdecl] = ACTIONS(2978),
    [anon_sym___clrcall] = ACTIONS(2978),
    [anon_sym___stdcall] = ACTIONS(2978),
    [anon_sym___fastcall] = ACTIONS(2978),
    [anon_sym___thiscall] = ACTIONS(2978),
    [anon_sym___vectorcall] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(2980),
    [anon_sym_RBRACE] = ACTIONS(2980),
    [anon_sym_signed] = ACTIONS(2978),
    [anon_sym_unsigned] = ACTIONS(2978),
    [anon_sym_long] = ACTIONS(2978),
    [anon_sym_short] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_static] = ACTIONS(2978),
    [anon_sym_register] = ACTIONS(2978),
    [anon_sym_inline] = ACTIONS(2978),
    [anon_sym___inline] = ACTIONS(2978),
    [anon_sym___inline__] = ACTIONS(2978),
    [anon_sym___forceinline] = ACTIONS(2978),
    [anon_sym_thread_local] = ACTIONS(2978),
    [anon_sym___thread] = ACTIONS(2978),
    [anon_sym_const] = ACTIONS(2978),
    [anon_sym_constexpr] = ACTIONS(2978),
    [anon_sym_volatile] = ACTIONS(2978),
    [anon_sym_restrict] = ACTIONS(2978),
    [anon_sym___restrict__] = ACTIONS(2978),
    [anon_sym__Atomic] = ACTIONS(2978),
    [anon_sym__Noreturn] = ACTIONS(2978),
    [anon_sym_noreturn] = ACTIONS(2978),
    [anon_sym_mutable] = ACTIONS(2978),
    [anon_sym_constinit] = ACTIONS(2978),
    [anon_sym_consteval] = ACTIONS(2978),
    [anon_sym_alignas] = ACTIONS(2978),
    [anon_sym__Alignas] = ACTIONS(2978),
    [sym_primitive_type] = ACTIONS(2978),
    [anon_sym_enum] = ACTIONS(2978),
    [anon_sym_class] = ACTIONS(2978),
    [anon_sym_struct] = ACTIONS(2978),
    [anon_sym_union] = ACTIONS(2978),
    [anon_sym_if] = ACTIONS(2978),
    [anon_sym_else] = ACTIONS(2978),
    [anon_sym_switch] = ACTIONS(2978),
    [anon_sym_case] = ACTIONS(2978),
    [anon_sym_default] = ACTIONS(2978),
    [anon_sym_while] = ACTIONS(2978),
    [anon_sym_do] = ACTIONS(2978),
    [anon_sym_for] = ACTIONS(2978),
    [anon_sym_return] = ACTIONS(2978),
    [anon_sym_break] = ACTIONS(2978),
    [anon_sym_continue] = ACTIONS(2978),
    [anon_sym_goto] = ACTIONS(2978),
    [anon_sym___try] = ACTIONS(2978),
    [anon_sym___leave] = ACTIONS(2978),
    [anon_sym_not] = ACTIONS(2978),
    [anon_sym_compl] = ACTIONS(2978),
    [anon_sym_DASH_DASH] = ACTIONS(2980),
    [anon_sym_PLUS_PLUS] = ACTIONS(2980),
    [anon_sym_sizeof] = ACTIONS(2978),
    [anon_sym___alignof__] = ACTIONS(2978),
    [anon_sym___alignof] = ACTIONS(2978),
    [anon_sym__alignof] = ACTIONS(2978),
    [anon_sym_alignof] = ACTIONS(2978),
    [anon_sym__Alignof] = ACTIONS(2978),
    [anon_sym_offsetof] = ACTIONS(2978),
    [anon_sym__Generic] = ACTIONS(2978),
    [anon_sym_asm] = ACTIONS(2978),
    [anon_sym___asm__] = ACTIONS(2978),
    [sym_number_literal] = ACTIONS(2980),
    [anon_sym_L_SQUOTE] = ACTIONS(2980),
    [anon_sym_u_SQUOTE] = ACTIONS(2980),
    [anon_sym_U_SQUOTE] = ACTIONS(2980),
    [anon_sym_u8_SQUOTE] = ACTIONS(2980),
    [anon_sym_SQUOTE] = ACTIONS(2980),
    [anon_sym_L_DQUOTE] = ACTIONS(2980),
    [anon_sym_u_DQUOTE] = ACTIONS(2980),
    [anon_sym_U_DQUOTE] = ACTIONS(2980),
    [anon_sym_u8_DQUOTE] = ACTIONS(2980),
    [anon_sym_DQUOTE] = ACTIONS(2980),
    [sym_true] = ACTIONS(2978),
    [sym_false] = ACTIONS(2978),
    [anon_sym_NULL] = ACTIONS(2978),
    [anon_sym_nullptr] = ACTIONS(2978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2978),
    [anon_sym_let] = ACTIONS(2978),
    [anon_sym_This] = ACTIONS(2978),
    [anon_sym_decltype] = ACTIONS(2978),
    [sym_virtual] = ACTIONS(2978),
    [anon_sym_explicit] = ACTIONS(2978),
    [anon_sym_typename] = ACTIONS(2978),
    [anon_sym_template] = ACTIONS(2978),
    [anon_sym_operator] = ACTIONS(2978),
    [anon_sym_try] = ACTIONS(2978),
    [anon_sym_delete] = ACTIONS(2978),
    [anon_sym_throw] = ACTIONS(2978),
    [anon_sym_namespace] = ACTIONS(2978),
    [anon_sym_using] = ACTIONS(2978),
    [anon_sym_static_assert] = ACTIONS(2978),
    [anon_sym_concept] = ACTIONS(2978),
    [anon_sym_co_return] = ACTIONS(2978),
    [anon_sym_co_yield] = ACTIONS(2978),
    [anon_sym_R_DQUOTE] = ACTIONS(2980),
    [anon_sym_LR_DQUOTE] = ACTIONS(2980),
    [anon_sym_uR_DQUOTE] = ACTIONS(2980),
    [anon_sym_UR_DQUOTE] = ACTIONS(2980),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2980),
    [anon_sym_co_await] = ACTIONS(2978),
    [anon_sym_new] = ACTIONS(2978),
    [anon_sym_requires] = ACTIONS(2978),
    [sym_this] = ACTIONS(2978),
    [anon_sym_discard] = ACTIONS(2978),
    [anon_sym_precise] = ACTIONS(2978),
    [anon_sym_shared] = ACTIONS(2978),
    [anon_sym_groupshared] = ACTIONS(2978),
    [anon_sym_uniform] = ACTIONS(2978),
    [anon_sym_row_major] = ACTIONS(2978),
    [anon_sym_column_major] = ACTIONS(2978),
    [anon_sym_globallycoherent] = ACTIONS(2978),
    [anon_sym_centroid] = ACTIONS(2978),
    [anon_sym_noperspective] = ACTIONS(2978),
    [anon_sym_nointerpolation] = ACTIONS(2978),
    [anon_sym_sample] = ACTIONS(2978),
    [anon_sym_linear] = ACTIONS(2978),
    [anon_sym_snorm] = ACTIONS(2978),
    [anon_sym_unorm] = ACTIONS(2978),
    [anon_sym_point] = ACTIONS(2978),
    [anon_sym_line] = ACTIONS(2978),
    [anon_sym_triangleadj] = ACTIONS(2978),
    [anon_sym_lineadj] = ACTIONS(2978),
    [anon_sym_triangle] = ACTIONS(2978),
    [anon_sym_cbuffer] = ACTIONS(2978),
    [anon_sym_interface] = ACTIONS(2978),
    [anon_sym_extension] = ACTIONS(2978),
  },
  [771] = {
    [sym_identifier] = ACTIONS(3378),
    [aux_sym_preproc_include_token1] = ACTIONS(3378),
    [aux_sym_preproc_def_token1] = ACTIONS(3378),
    [aux_sym_preproc_if_token1] = ACTIONS(3378),
    [aux_sym_preproc_if_token2] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3378),
    [sym_preproc_directive] = ACTIONS(3378),
    [anon_sym_LPAREN2] = ACTIONS(3380),
    [anon_sym_BANG] = ACTIONS(3380),
    [anon_sym_TILDE] = ACTIONS(3380),
    [anon_sym_DASH] = ACTIONS(3378),
    [anon_sym_PLUS] = ACTIONS(3378),
    [anon_sym_STAR] = ACTIONS(3380),
    [anon_sym_AMP_AMP] = ACTIONS(3380),
    [anon_sym_AMP] = ACTIONS(3378),
    [anon_sym_SEMI] = ACTIONS(3380),
    [anon_sym___extension__] = ACTIONS(3378),
    [anon_sym_typedef] = ACTIONS(3378),
    [anon_sym_in] = ACTIONS(3378),
    [anon_sym_out] = ACTIONS(3378),
    [anon_sym_inout] = ACTIONS(3378),
    [anon_sym_extern] = ACTIONS(3378),
    [anon_sym___attribute__] = ACTIONS(3378),
    [anon_sym_COLON_COLON] = ACTIONS(3380),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3380),
    [anon_sym___declspec] = ACTIONS(3378),
    [anon_sym___based] = ACTIONS(3378),
    [anon_sym___cdecl] = ACTIONS(3378),
    [anon_sym___clrcall] = ACTIONS(3378),
    [anon_sym___stdcall] = ACTIONS(3378),
    [anon_sym___fastcall] = ACTIONS(3378),
    [anon_sym___thiscall] = ACTIONS(3378),
    [anon_sym___vectorcall] = ACTIONS(3378),
    [anon_sym_LBRACE] = ACTIONS(3380),
    [anon_sym_signed] = ACTIONS(3378),
    [anon_sym_unsigned] = ACTIONS(3378),
    [anon_sym_long] = ACTIONS(3378),
    [anon_sym_short] = ACTIONS(3378),
    [anon_sym_LBRACK] = ACTIONS(3378),
    [anon_sym_static] = ACTIONS(3378),
    [anon_sym_register] = ACTIONS(3378),
    [anon_sym_inline] = ACTIONS(3378),
    [anon_sym___inline] = ACTIONS(3378),
    [anon_sym___inline__] = ACTIONS(3378),
    [anon_sym___forceinline] = ACTIONS(3378),
    [anon_sym_thread_local] = ACTIONS(3378),
    [anon_sym___thread] = ACTIONS(3378),
    [anon_sym_const] = ACTIONS(3378),
    [anon_sym_constexpr] = ACTIONS(3378),
    [anon_sym_volatile] = ACTIONS(3378),
    [anon_sym_restrict] = ACTIONS(3378),
    [anon_sym___restrict__] = ACTIONS(3378),
    [anon_sym__Atomic] = ACTIONS(3378),
    [anon_sym__Noreturn] = ACTIONS(3378),
    [anon_sym_noreturn] = ACTIONS(3378),
    [anon_sym_mutable] = ACTIONS(3378),
    [anon_sym_constinit] = ACTIONS(3378),
    [anon_sym_consteval] = ACTIONS(3378),
    [anon_sym_alignas] = ACTIONS(3378),
    [anon_sym__Alignas] = ACTIONS(3378),
    [sym_primitive_type] = ACTIONS(3378),
    [anon_sym_enum] = ACTIONS(3378),
    [anon_sym_class] = ACTIONS(3378),
    [anon_sym_struct] = ACTIONS(3378),
    [anon_sym_union] = ACTIONS(3378),
    [anon_sym_if] = ACTIONS(3378),
    [anon_sym_else] = ACTIONS(3378),
    [anon_sym_switch] = ACTIONS(3378),
    [anon_sym_case] = ACTIONS(3378),
    [anon_sym_default] = ACTIONS(3378),
    [anon_sym_while] = ACTIONS(3378),
    [anon_sym_do] = ACTIONS(3378),
    [anon_sym_for] = ACTIONS(3378),
    [anon_sym_return] = ACTIONS(3378),
    [anon_sym_break] = ACTIONS(3378),
    [anon_sym_continue] = ACTIONS(3378),
    [anon_sym_goto] = ACTIONS(3378),
    [anon_sym___try] = ACTIONS(3378),
    [anon_sym___leave] = ACTIONS(3378),
    [anon_sym_not] = ACTIONS(3378),
    [anon_sym_compl] = ACTIONS(3378),
    [anon_sym_DASH_DASH] = ACTIONS(3380),
    [anon_sym_PLUS_PLUS] = ACTIONS(3380),
    [anon_sym_sizeof] = ACTIONS(3378),
    [anon_sym___alignof__] = ACTIONS(3378),
    [anon_sym___alignof] = ACTIONS(3378),
    [anon_sym__alignof] = ACTIONS(3378),
    [anon_sym_alignof] = ACTIONS(3378),
    [anon_sym__Alignof] = ACTIONS(3378),
    [anon_sym_offsetof] = ACTIONS(3378),
    [anon_sym__Generic] = ACTIONS(3378),
    [anon_sym_asm] = ACTIONS(3378),
    [anon_sym___asm__] = ACTIONS(3378),
    [sym_number_literal] = ACTIONS(3380),
    [anon_sym_L_SQUOTE] = ACTIONS(3380),
    [anon_sym_u_SQUOTE] = ACTIONS(3380),
    [anon_sym_U_SQUOTE] = ACTIONS(3380),
    [anon_sym_u8_SQUOTE] = ACTIONS(3380),
    [anon_sym_SQUOTE] = ACTIONS(3380),
    [anon_sym_L_DQUOTE] = ACTIONS(3380),
    [anon_sym_u_DQUOTE] = ACTIONS(3380),
    [anon_sym_U_DQUOTE] = ACTIONS(3380),
    [anon_sym_u8_DQUOTE] = ACTIONS(3380),
    [anon_sym_DQUOTE] = ACTIONS(3380),
    [sym_true] = ACTIONS(3378),
    [sym_false] = ACTIONS(3378),
    [anon_sym_NULL] = ACTIONS(3378),
    [anon_sym_nullptr] = ACTIONS(3378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3378),
    [anon_sym_let] = ACTIONS(3378),
    [anon_sym_This] = ACTIONS(3378),
    [anon_sym_decltype] = ACTIONS(3378),
    [sym_virtual] = ACTIONS(3378),
    [anon_sym_explicit] = ACTIONS(3378),
    [anon_sym_typename] = ACTIONS(3378),
    [anon_sym_template] = ACTIONS(3378),
    [anon_sym_operator] = ACTIONS(3378),
    [anon_sym_try] = ACTIONS(3378),
    [anon_sym_delete] = ACTIONS(3378),
    [anon_sym_throw] = ACTIONS(3378),
    [anon_sym_namespace] = ACTIONS(3378),
    [anon_sym_using] = ACTIONS(3378),
    [anon_sym_static_assert] = ACTIONS(3378),
    [anon_sym_concept] = ACTIONS(3378),
    [anon_sym_co_return] = ACTIONS(3378),
    [anon_sym_co_yield] = ACTIONS(3378),
    [anon_sym_R_DQUOTE] = ACTIONS(3380),
    [anon_sym_LR_DQUOTE] = ACTIONS(3380),
    [anon_sym_uR_DQUOTE] = ACTIONS(3380),
    [anon_sym_UR_DQUOTE] = ACTIONS(3380),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3380),
    [anon_sym_co_await] = ACTIONS(3378),
    [anon_sym_new] = ACTIONS(3378),
    [anon_sym_requires] = ACTIONS(3378),
    [sym_this] = ACTIONS(3378),
    [anon_sym_discard] = ACTIONS(3378),
    [anon_sym_precise] = ACTIONS(3378),
    [anon_sym_shared] = ACTIONS(3378),
    [anon_sym_groupshared] = ACTIONS(3378),
    [anon_sym_uniform] = ACTIONS(3378),
    [anon_sym_row_major] = ACTIONS(3378),
    [anon_sym_column_major] = ACTIONS(3378),
    [anon_sym_globallycoherent] = ACTIONS(3378),
    [anon_sym_centroid] = ACTIONS(3378),
    [anon_sym_noperspective] = ACTIONS(3378),
    [anon_sym_nointerpolation] = ACTIONS(3378),
    [anon_sym_sample] = ACTIONS(3378),
    [anon_sym_linear] = ACTIONS(3378),
    [anon_sym_snorm] = ACTIONS(3378),
    [anon_sym_unorm] = ACTIONS(3378),
    [anon_sym_point] = ACTIONS(3378),
    [anon_sym_line] = ACTIONS(3378),
    [anon_sym_triangleadj] = ACTIONS(3378),
    [anon_sym_lineadj] = ACTIONS(3378),
    [anon_sym_triangle] = ACTIONS(3378),
    [anon_sym_cbuffer] = ACTIONS(3378),
    [anon_sym_interface] = ACTIONS(3378),
    [anon_sym_extension] = ACTIONS(3378),
  },
  [772] = {
    [sym_identifier] = ACTIONS(2972),
    [aux_sym_preproc_include_token1] = ACTIONS(2972),
    [aux_sym_preproc_def_token1] = ACTIONS(2972),
    [aux_sym_preproc_if_token1] = ACTIONS(2972),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2972),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2972),
    [sym_preproc_directive] = ACTIONS(2972),
    [anon_sym_LPAREN2] = ACTIONS(2974),
    [anon_sym_BANG] = ACTIONS(2974),
    [anon_sym_TILDE] = ACTIONS(2974),
    [anon_sym_DASH] = ACTIONS(2972),
    [anon_sym_PLUS] = ACTIONS(2972),
    [anon_sym_STAR] = ACTIONS(2974),
    [anon_sym_AMP_AMP] = ACTIONS(2974),
    [anon_sym_AMP] = ACTIONS(2972),
    [anon_sym_SEMI] = ACTIONS(2974),
    [anon_sym___extension__] = ACTIONS(2972),
    [anon_sym_typedef] = ACTIONS(2972),
    [anon_sym_in] = ACTIONS(2972),
    [anon_sym_out] = ACTIONS(2972),
    [anon_sym_inout] = ACTIONS(2972),
    [anon_sym_extern] = ACTIONS(2972),
    [anon_sym___attribute__] = ACTIONS(2972),
    [anon_sym_COLON_COLON] = ACTIONS(2974),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2974),
    [anon_sym___declspec] = ACTIONS(2972),
    [anon_sym___based] = ACTIONS(2972),
    [anon_sym___cdecl] = ACTIONS(2972),
    [anon_sym___clrcall] = ACTIONS(2972),
    [anon_sym___stdcall] = ACTIONS(2972),
    [anon_sym___fastcall] = ACTIONS(2972),
    [anon_sym___thiscall] = ACTIONS(2972),
    [anon_sym___vectorcall] = ACTIONS(2972),
    [anon_sym_LBRACE] = ACTIONS(2974),
    [anon_sym_RBRACE] = ACTIONS(2974),
    [anon_sym_signed] = ACTIONS(2972),
    [anon_sym_unsigned] = ACTIONS(2972),
    [anon_sym_long] = ACTIONS(2972),
    [anon_sym_short] = ACTIONS(2972),
    [anon_sym_LBRACK] = ACTIONS(2972),
    [anon_sym_static] = ACTIONS(2972),
    [anon_sym_register] = ACTIONS(2972),
    [anon_sym_inline] = ACTIONS(2972),
    [anon_sym___inline] = ACTIONS(2972),
    [anon_sym___inline__] = ACTIONS(2972),
    [anon_sym___forceinline] = ACTIONS(2972),
    [anon_sym_thread_local] = ACTIONS(2972),
    [anon_sym___thread] = ACTIONS(2972),
    [anon_sym_const] = ACTIONS(2972),
    [anon_sym_constexpr] = ACTIONS(2972),
    [anon_sym_volatile] = ACTIONS(2972),
    [anon_sym_restrict] = ACTIONS(2972),
    [anon_sym___restrict__] = ACTIONS(2972),
    [anon_sym__Atomic] = ACTIONS(2972),
    [anon_sym__Noreturn] = ACTIONS(2972),
    [anon_sym_noreturn] = ACTIONS(2972),
    [anon_sym_mutable] = ACTIONS(2972),
    [anon_sym_constinit] = ACTIONS(2972),
    [anon_sym_consteval] = ACTIONS(2972),
    [anon_sym_alignas] = ACTIONS(2972),
    [anon_sym__Alignas] = ACTIONS(2972),
    [sym_primitive_type] = ACTIONS(2972),
    [anon_sym_enum] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(2972),
    [anon_sym_struct] = ACTIONS(2972),
    [anon_sym_union] = ACTIONS(2972),
    [anon_sym_if] = ACTIONS(2972),
    [anon_sym_else] = ACTIONS(2972),
    [anon_sym_switch] = ACTIONS(2972),
    [anon_sym_case] = ACTIONS(2972),
    [anon_sym_default] = ACTIONS(2972),
    [anon_sym_while] = ACTIONS(2972),
    [anon_sym_do] = ACTIONS(2972),
    [anon_sym_for] = ACTIONS(2972),
    [anon_sym_return] = ACTIONS(2972),
    [anon_sym_break] = ACTIONS(2972),
    [anon_sym_continue] = ACTIONS(2972),
    [anon_sym_goto] = ACTIONS(2972),
    [anon_sym___try] = ACTIONS(2972),
    [anon_sym___leave] = ACTIONS(2972),
    [anon_sym_not] = ACTIONS(2972),
    [anon_sym_compl] = ACTIONS(2972),
    [anon_sym_DASH_DASH] = ACTIONS(2974),
    [anon_sym_PLUS_PLUS] = ACTIONS(2974),
    [anon_sym_sizeof] = ACTIONS(2972),
    [anon_sym___alignof__] = ACTIONS(2972),
    [anon_sym___alignof] = ACTIONS(2972),
    [anon_sym__alignof] = ACTIONS(2972),
    [anon_sym_alignof] = ACTIONS(2972),
    [anon_sym__Alignof] = ACTIONS(2972),
    [anon_sym_offsetof] = ACTIONS(2972),
    [anon_sym__Generic] = ACTIONS(2972),
    [anon_sym_asm] = ACTIONS(2972),
    [anon_sym___asm__] = ACTIONS(2972),
    [sym_number_literal] = ACTIONS(2974),
    [anon_sym_L_SQUOTE] = ACTIONS(2974),
    [anon_sym_u_SQUOTE] = ACTIONS(2974),
    [anon_sym_U_SQUOTE] = ACTIONS(2974),
    [anon_sym_u8_SQUOTE] = ACTIONS(2974),
    [anon_sym_SQUOTE] = ACTIONS(2974),
    [anon_sym_L_DQUOTE] = ACTIONS(2974),
    [anon_sym_u_DQUOTE] = ACTIONS(2974),
    [anon_sym_U_DQUOTE] = ACTIONS(2974),
    [anon_sym_u8_DQUOTE] = ACTIONS(2974),
    [anon_sym_DQUOTE] = ACTIONS(2974),
    [sym_true] = ACTIONS(2972),
    [sym_false] = ACTIONS(2972),
    [anon_sym_NULL] = ACTIONS(2972),
    [anon_sym_nullptr] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2972),
    [anon_sym_let] = ACTIONS(2972),
    [anon_sym_This] = ACTIONS(2972),
    [anon_sym_decltype] = ACTIONS(2972),
    [sym_virtual] = ACTIONS(2972),
    [anon_sym_explicit] = ACTIONS(2972),
    [anon_sym_typename] = ACTIONS(2972),
    [anon_sym_template] = ACTIONS(2972),
    [anon_sym_operator] = ACTIONS(2972),
    [anon_sym_try] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2972),
    [anon_sym_throw] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2972),
    [anon_sym_using] = ACTIONS(2972),
    [anon_sym_static_assert] = ACTIONS(2972),
    [anon_sym_concept] = ACTIONS(2972),
    [anon_sym_co_return] = ACTIONS(2972),
    [anon_sym_co_yield] = ACTIONS(2972),
    [anon_sym_R_DQUOTE] = ACTIONS(2974),
    [anon_sym_LR_DQUOTE] = ACTIONS(2974),
    [anon_sym_uR_DQUOTE] = ACTIONS(2974),
    [anon_sym_UR_DQUOTE] = ACTIONS(2974),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2974),
    [anon_sym_co_await] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2972),
    [anon_sym_requires] = ACTIONS(2972),
    [sym_this] = ACTIONS(2972),
    [anon_sym_discard] = ACTIONS(2972),
    [anon_sym_precise] = ACTIONS(2972),
    [anon_sym_shared] = ACTIONS(2972),
    [anon_sym_groupshared] = ACTIONS(2972),
    [anon_sym_uniform] = ACTIONS(2972),
    [anon_sym_row_major] = ACTIONS(2972),
    [anon_sym_column_major] = ACTIONS(2972),
    [anon_sym_globallycoherent] = ACTIONS(2972),
    [anon_sym_centroid] = ACTIONS(2972),
    [anon_sym_noperspective] = ACTIONS(2972),
    [anon_sym_nointerpolation] = ACTIONS(2972),
    [anon_sym_sample] = ACTIONS(2972),
    [anon_sym_linear] = ACTIONS(2972),
    [anon_sym_snorm] = ACTIONS(2972),
    [anon_sym_unorm] = ACTIONS(2972),
    [anon_sym_point] = ACTIONS(2972),
    [anon_sym_line] = ACTIONS(2972),
    [anon_sym_triangleadj] = ACTIONS(2972),
    [anon_sym_lineadj] = ACTIONS(2972),
    [anon_sym_triangle] = ACTIONS(2972),
    [anon_sym_cbuffer] = ACTIONS(2972),
    [anon_sym_interface] = ACTIONS(2972),
    [anon_sym_extension] = ACTIONS(2972),
  },
  [773] = {
    [sym_identifier] = ACTIONS(2910),
    [aux_sym_preproc_include_token1] = ACTIONS(2910),
    [aux_sym_preproc_def_token1] = ACTIONS(2910),
    [aux_sym_preproc_if_token1] = ACTIONS(2910),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2910),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2910),
    [sym_preproc_directive] = ACTIONS(2910),
    [anon_sym_LPAREN2] = ACTIONS(2908),
    [anon_sym_BANG] = ACTIONS(2908),
    [anon_sym_TILDE] = ACTIONS(2908),
    [anon_sym_DASH] = ACTIONS(2910),
    [anon_sym_PLUS] = ACTIONS(2910),
    [anon_sym_STAR] = ACTIONS(2908),
    [anon_sym_AMP_AMP] = ACTIONS(2908),
    [anon_sym_AMP] = ACTIONS(2910),
    [anon_sym_SEMI] = ACTIONS(2908),
    [anon_sym___extension__] = ACTIONS(2910),
    [anon_sym_typedef] = ACTIONS(2910),
    [anon_sym_in] = ACTIONS(2910),
    [anon_sym_out] = ACTIONS(2910),
    [anon_sym_inout] = ACTIONS(2910),
    [anon_sym_extern] = ACTIONS(2910),
    [anon_sym___attribute__] = ACTIONS(2910),
    [anon_sym_COLON_COLON] = ACTIONS(2908),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2908),
    [anon_sym___declspec] = ACTIONS(2910),
    [anon_sym___based] = ACTIONS(2910),
    [anon_sym___cdecl] = ACTIONS(2910),
    [anon_sym___clrcall] = ACTIONS(2910),
    [anon_sym___stdcall] = ACTIONS(2910),
    [anon_sym___fastcall] = ACTIONS(2910),
    [anon_sym___thiscall] = ACTIONS(2910),
    [anon_sym___vectorcall] = ACTIONS(2910),
    [anon_sym_LBRACE] = ACTIONS(2908),
    [anon_sym_RBRACE] = ACTIONS(2908),
    [anon_sym_signed] = ACTIONS(2910),
    [anon_sym_unsigned] = ACTIONS(2910),
    [anon_sym_long] = ACTIONS(2910),
    [anon_sym_short] = ACTIONS(2910),
    [anon_sym_LBRACK] = ACTIONS(2910),
    [anon_sym_static] = ACTIONS(2910),
    [anon_sym_register] = ACTIONS(2910),
    [anon_sym_inline] = ACTIONS(2910),
    [anon_sym___inline] = ACTIONS(2910),
    [anon_sym___inline__] = ACTIONS(2910),
    [anon_sym___forceinline] = ACTIONS(2910),
    [anon_sym_thread_local] = ACTIONS(2910),
    [anon_sym___thread] = ACTIONS(2910),
    [anon_sym_const] = ACTIONS(2910),
    [anon_sym_constexpr] = ACTIONS(2910),
    [anon_sym_volatile] = ACTIONS(2910),
    [anon_sym_restrict] = ACTIONS(2910),
    [anon_sym___restrict__] = ACTIONS(2910),
    [anon_sym__Atomic] = ACTIONS(2910),
    [anon_sym__Noreturn] = ACTIONS(2910),
    [anon_sym_noreturn] = ACTIONS(2910),
    [anon_sym_mutable] = ACTIONS(2910),
    [anon_sym_constinit] = ACTIONS(2910),
    [anon_sym_consteval] = ACTIONS(2910),
    [anon_sym_alignas] = ACTIONS(2910),
    [anon_sym__Alignas] = ACTIONS(2910),
    [sym_primitive_type] = ACTIONS(2910),
    [anon_sym_enum] = ACTIONS(2910),
    [anon_sym_class] = ACTIONS(2910),
    [anon_sym_struct] = ACTIONS(2910),
    [anon_sym_union] = ACTIONS(2910),
    [anon_sym_if] = ACTIONS(2910),
    [anon_sym_switch] = ACTIONS(2910),
    [anon_sym_case] = ACTIONS(2910),
    [anon_sym_default] = ACTIONS(2910),
    [anon_sym_while] = ACTIONS(2910),
    [anon_sym_do] = ACTIONS(2910),
    [anon_sym_for] = ACTIONS(2910),
    [anon_sym_return] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2910),
    [anon_sym_continue] = ACTIONS(2910),
    [anon_sym_goto] = ACTIONS(2910),
    [anon_sym___try] = ACTIONS(2910),
    [anon_sym___leave] = ACTIONS(2910),
    [anon_sym_not] = ACTIONS(2910),
    [anon_sym_compl] = ACTIONS(2910),
    [anon_sym_DASH_DASH] = ACTIONS(2908),
    [anon_sym_PLUS_PLUS] = ACTIONS(2908),
    [anon_sym_sizeof] = ACTIONS(2910),
    [anon_sym___alignof__] = ACTIONS(2910),
    [anon_sym___alignof] = ACTIONS(2910),
    [anon_sym__alignof] = ACTIONS(2910),
    [anon_sym_alignof] = ACTIONS(2910),
    [anon_sym__Alignof] = ACTIONS(2910),
    [anon_sym_offsetof] = ACTIONS(2910),
    [anon_sym__Generic] = ACTIONS(2910),
    [anon_sym_asm] = ACTIONS(2910),
    [anon_sym___asm__] = ACTIONS(2910),
    [anon_sym_DOT] = ACTIONS(2910),
    [sym_number_literal] = ACTIONS(2908),
    [anon_sym_L_SQUOTE] = ACTIONS(2908),
    [anon_sym_u_SQUOTE] = ACTIONS(2908),
    [anon_sym_U_SQUOTE] = ACTIONS(2908),
    [anon_sym_u8_SQUOTE] = ACTIONS(2908),
    [anon_sym_SQUOTE] = ACTIONS(2908),
    [anon_sym_L_DQUOTE] = ACTIONS(2908),
    [anon_sym_u_DQUOTE] = ACTIONS(2908),
    [anon_sym_U_DQUOTE] = ACTIONS(2908),
    [anon_sym_u8_DQUOTE] = ACTIONS(2908),
    [anon_sym_DQUOTE] = ACTIONS(2908),
    [sym_true] = ACTIONS(2910),
    [sym_false] = ACTIONS(2910),
    [anon_sym_NULL] = ACTIONS(2910),
    [anon_sym_nullptr] = ACTIONS(2910),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2910),
    [anon_sym_let] = ACTIONS(2910),
    [anon_sym_This] = ACTIONS(2910),
    [anon_sym_decltype] = ACTIONS(2910),
    [sym_virtual] = ACTIONS(2910),
    [anon_sym_explicit] = ACTIONS(2910),
    [anon_sym_typename] = ACTIONS(2910),
    [anon_sym_template] = ACTIONS(2910),
    [anon_sym_operator] = ACTIONS(2910),
    [anon_sym_try] = ACTIONS(2910),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_throw] = ACTIONS(2910),
    [anon_sym_namespace] = ACTIONS(2910),
    [anon_sym_using] = ACTIONS(2910),
    [anon_sym_static_assert] = ACTIONS(2910),
    [anon_sym_concept] = ACTIONS(2910),
    [anon_sym_co_return] = ACTIONS(2910),
    [anon_sym_co_yield] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2908),
    [anon_sym_LR_DQUOTE] = ACTIONS(2908),
    [anon_sym_uR_DQUOTE] = ACTIONS(2908),
    [anon_sym_UR_DQUOTE] = ACTIONS(2908),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2908),
    [anon_sym_co_await] = ACTIONS(2910),
    [anon_sym_new] = ACTIONS(2910),
    [anon_sym_requires] = ACTIONS(2910),
    [sym_this] = ACTIONS(2910),
    [anon_sym_discard] = ACTIONS(2910),
    [anon_sym_precise] = ACTIONS(2910),
    [anon_sym_shared] = ACTIONS(2910),
    [anon_sym_groupshared] = ACTIONS(2910),
    [anon_sym_uniform] = ACTIONS(2910),
    [anon_sym_row_major] = ACTIONS(2910),
    [anon_sym_column_major] = ACTIONS(2910),
    [anon_sym_globallycoherent] = ACTIONS(2910),
    [anon_sym_centroid] = ACTIONS(2910),
    [anon_sym_noperspective] = ACTIONS(2910),
    [anon_sym_nointerpolation] = ACTIONS(2910),
    [anon_sym_sample] = ACTIONS(2910),
    [anon_sym_linear] = ACTIONS(2910),
    [anon_sym_snorm] = ACTIONS(2910),
    [anon_sym_unorm] = ACTIONS(2910),
    [anon_sym_point] = ACTIONS(2910),
    [anon_sym_line] = ACTIONS(2910),
    [anon_sym_triangleadj] = ACTIONS(2910),
    [anon_sym_lineadj] = ACTIONS(2910),
    [anon_sym_triangle] = ACTIONS(2910),
    [anon_sym_cbuffer] = ACTIONS(2910),
    [anon_sym_interface] = ACTIONS(2910),
    [anon_sym_extension] = ACTIONS(2910),
  },
  [774] = {
    [sym_identifier] = ACTIONS(3298),
    [aux_sym_preproc_include_token1] = ACTIONS(3298),
    [aux_sym_preproc_def_token1] = ACTIONS(3298),
    [aux_sym_preproc_if_token1] = ACTIONS(3298),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3298),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3298),
    [sym_preproc_directive] = ACTIONS(3298),
    [anon_sym_LPAREN2] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3298),
    [anon_sym_PLUS] = ACTIONS(3298),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_AMP_AMP] = ACTIONS(3300),
    [anon_sym_AMP] = ACTIONS(3298),
    [anon_sym_SEMI] = ACTIONS(3300),
    [anon_sym___extension__] = ACTIONS(3298),
    [anon_sym_typedef] = ACTIONS(3298),
    [anon_sym_in] = ACTIONS(3298),
    [anon_sym_out] = ACTIONS(3298),
    [anon_sym_inout] = ACTIONS(3298),
    [anon_sym_extern] = ACTIONS(3298),
    [anon_sym___attribute__] = ACTIONS(3298),
    [anon_sym_COLON_COLON] = ACTIONS(3300),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3300),
    [anon_sym___declspec] = ACTIONS(3298),
    [anon_sym___based] = ACTIONS(3298),
    [anon_sym___cdecl] = ACTIONS(3298),
    [anon_sym___clrcall] = ACTIONS(3298),
    [anon_sym___stdcall] = ACTIONS(3298),
    [anon_sym___fastcall] = ACTIONS(3298),
    [anon_sym___thiscall] = ACTIONS(3298),
    [anon_sym___vectorcall] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_RBRACE] = ACTIONS(3300),
    [anon_sym_signed] = ACTIONS(3298),
    [anon_sym_unsigned] = ACTIONS(3298),
    [anon_sym_long] = ACTIONS(3298),
    [anon_sym_short] = ACTIONS(3298),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_static] = ACTIONS(3298),
    [anon_sym_register] = ACTIONS(3298),
    [anon_sym_inline] = ACTIONS(3298),
    [anon_sym___inline] = ACTIONS(3298),
    [anon_sym___inline__] = ACTIONS(3298),
    [anon_sym___forceinline] = ACTIONS(3298),
    [anon_sym_thread_local] = ACTIONS(3298),
    [anon_sym___thread] = ACTIONS(3298),
    [anon_sym_const] = ACTIONS(3298),
    [anon_sym_constexpr] = ACTIONS(3298),
    [anon_sym_volatile] = ACTIONS(3298),
    [anon_sym_restrict] = ACTIONS(3298),
    [anon_sym___restrict__] = ACTIONS(3298),
    [anon_sym__Atomic] = ACTIONS(3298),
    [anon_sym__Noreturn] = ACTIONS(3298),
    [anon_sym_noreturn] = ACTIONS(3298),
    [anon_sym_mutable] = ACTIONS(3298),
    [anon_sym_constinit] = ACTIONS(3298),
    [anon_sym_consteval] = ACTIONS(3298),
    [anon_sym_alignas] = ACTIONS(3298),
    [anon_sym__Alignas] = ACTIONS(3298),
    [sym_primitive_type] = ACTIONS(3298),
    [anon_sym_enum] = ACTIONS(3298),
    [anon_sym_class] = ACTIONS(3298),
    [anon_sym_struct] = ACTIONS(3298),
    [anon_sym_union] = ACTIONS(3298),
    [anon_sym_if] = ACTIONS(3298),
    [anon_sym_else] = ACTIONS(3298),
    [anon_sym_switch] = ACTIONS(3298),
    [anon_sym_case] = ACTIONS(3298),
    [anon_sym_default] = ACTIONS(3298),
    [anon_sym_while] = ACTIONS(3298),
    [anon_sym_do] = ACTIONS(3298),
    [anon_sym_for] = ACTIONS(3298),
    [anon_sym_return] = ACTIONS(3298),
    [anon_sym_break] = ACTIONS(3298),
    [anon_sym_continue] = ACTIONS(3298),
    [anon_sym_goto] = ACTIONS(3298),
    [anon_sym___try] = ACTIONS(3298),
    [anon_sym___leave] = ACTIONS(3298),
    [anon_sym_not] = ACTIONS(3298),
    [anon_sym_compl] = ACTIONS(3298),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_sizeof] = ACTIONS(3298),
    [anon_sym___alignof__] = ACTIONS(3298),
    [anon_sym___alignof] = ACTIONS(3298),
    [anon_sym__alignof] = ACTIONS(3298),
    [anon_sym_alignof] = ACTIONS(3298),
    [anon_sym__Alignof] = ACTIONS(3298),
    [anon_sym_offsetof] = ACTIONS(3298),
    [anon_sym__Generic] = ACTIONS(3298),
    [anon_sym_asm] = ACTIONS(3298),
    [anon_sym___asm__] = ACTIONS(3298),
    [sym_number_literal] = ACTIONS(3300),
    [anon_sym_L_SQUOTE] = ACTIONS(3300),
    [anon_sym_u_SQUOTE] = ACTIONS(3300),
    [anon_sym_U_SQUOTE] = ACTIONS(3300),
    [anon_sym_u8_SQUOTE] = ACTIONS(3300),
    [anon_sym_SQUOTE] = ACTIONS(3300),
    [anon_sym_L_DQUOTE] = ACTIONS(3300),
    [anon_sym_u_DQUOTE] = ACTIONS(3300),
    [anon_sym_U_DQUOTE] = ACTIONS(3300),
    [anon_sym_u8_DQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [sym_true] = ACTIONS(3298),
    [sym_false] = ACTIONS(3298),
    [anon_sym_NULL] = ACTIONS(3298),
    [anon_sym_nullptr] = ACTIONS(3298),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3298),
    [anon_sym_let] = ACTIONS(3298),
    [anon_sym_This] = ACTIONS(3298),
    [anon_sym_decltype] = ACTIONS(3298),
    [sym_virtual] = ACTIONS(3298),
    [anon_sym_explicit] = ACTIONS(3298),
    [anon_sym_typename] = ACTIONS(3298),
    [anon_sym_template] = ACTIONS(3298),
    [anon_sym_operator] = ACTIONS(3298),
    [anon_sym_try] = ACTIONS(3298),
    [anon_sym_delete] = ACTIONS(3298),
    [anon_sym_throw] = ACTIONS(3298),
    [anon_sym_namespace] = ACTIONS(3298),
    [anon_sym_using] = ACTIONS(3298),
    [anon_sym_static_assert] = ACTIONS(3298),
    [anon_sym_concept] = ACTIONS(3298),
    [anon_sym_co_return] = ACTIONS(3298),
    [anon_sym_co_yield] = ACTIONS(3298),
    [anon_sym_R_DQUOTE] = ACTIONS(3300),
    [anon_sym_LR_DQUOTE] = ACTIONS(3300),
    [anon_sym_uR_DQUOTE] = ACTIONS(3300),
    [anon_sym_UR_DQUOTE] = ACTIONS(3300),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3300),
    [anon_sym_co_await] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3298),
    [anon_sym_requires] = ACTIONS(3298),
    [sym_this] = ACTIONS(3298),
    [anon_sym_discard] = ACTIONS(3298),
    [anon_sym_precise] = ACTIONS(3298),
    [anon_sym_shared] = ACTIONS(3298),
    [anon_sym_groupshared] = ACTIONS(3298),
    [anon_sym_uniform] = ACTIONS(3298),
    [anon_sym_row_major] = ACTIONS(3298),
    [anon_sym_column_major] = ACTIONS(3298),
    [anon_sym_globallycoherent] = ACTIONS(3298),
    [anon_sym_centroid] = ACTIONS(3298),
    [anon_sym_noperspective] = ACTIONS(3298),
    [anon_sym_nointerpolation] = ACTIONS(3298),
    [anon_sym_sample] = ACTIONS(3298),
    [anon_sym_linear] = ACTIONS(3298),
    [anon_sym_snorm] = ACTIONS(3298),
    [anon_sym_unorm] = ACTIONS(3298),
    [anon_sym_point] = ACTIONS(3298),
    [anon_sym_line] = ACTIONS(3298),
    [anon_sym_triangleadj] = ACTIONS(3298),
    [anon_sym_lineadj] = ACTIONS(3298),
    [anon_sym_triangle] = ACTIONS(3298),
    [anon_sym_cbuffer] = ACTIONS(3298),
    [anon_sym_interface] = ACTIONS(3298),
    [anon_sym_extension] = ACTIONS(3298),
  },
  [775] = {
    [sym_identifier] = ACTIONS(3196),
    [aux_sym_preproc_include_token1] = ACTIONS(3196),
    [aux_sym_preproc_def_token1] = ACTIONS(3196),
    [aux_sym_preproc_if_token1] = ACTIONS(3196),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3196),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3196),
    [sym_preproc_directive] = ACTIONS(3196),
    [anon_sym_LPAREN2] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3196),
    [anon_sym_PLUS] = ACTIONS(3196),
    [anon_sym_STAR] = ACTIONS(3198),
    [anon_sym_AMP_AMP] = ACTIONS(3198),
    [anon_sym_AMP] = ACTIONS(3196),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(3196),
    [anon_sym_typedef] = ACTIONS(3196),
    [anon_sym_in] = ACTIONS(3196),
    [anon_sym_out] = ACTIONS(3196),
    [anon_sym_inout] = ACTIONS(3196),
    [anon_sym_extern] = ACTIONS(3196),
    [anon_sym___attribute__] = ACTIONS(3196),
    [anon_sym_COLON_COLON] = ACTIONS(3198),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3198),
    [anon_sym___declspec] = ACTIONS(3196),
    [anon_sym___based] = ACTIONS(3196),
    [anon_sym___cdecl] = ACTIONS(3196),
    [anon_sym___clrcall] = ACTIONS(3196),
    [anon_sym___stdcall] = ACTIONS(3196),
    [anon_sym___fastcall] = ACTIONS(3196),
    [anon_sym___thiscall] = ACTIONS(3196),
    [anon_sym___vectorcall] = ACTIONS(3196),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_signed] = ACTIONS(3196),
    [anon_sym_unsigned] = ACTIONS(3196),
    [anon_sym_long] = ACTIONS(3196),
    [anon_sym_short] = ACTIONS(3196),
    [anon_sym_LBRACK] = ACTIONS(3196),
    [anon_sym_static] = ACTIONS(3196),
    [anon_sym_register] = ACTIONS(3196),
    [anon_sym_inline] = ACTIONS(3196),
    [anon_sym___inline] = ACTIONS(3196),
    [anon_sym___inline__] = ACTIONS(3196),
    [anon_sym___forceinline] = ACTIONS(3196),
    [anon_sym_thread_local] = ACTIONS(3196),
    [anon_sym___thread] = ACTIONS(3196),
    [anon_sym_const] = ACTIONS(3196),
    [anon_sym_constexpr] = ACTIONS(3196),
    [anon_sym_volatile] = ACTIONS(3196),
    [anon_sym_restrict] = ACTIONS(3196),
    [anon_sym___restrict__] = ACTIONS(3196),
    [anon_sym__Atomic] = ACTIONS(3196),
    [anon_sym__Noreturn] = ACTIONS(3196),
    [anon_sym_noreturn] = ACTIONS(3196),
    [anon_sym_mutable] = ACTIONS(3196),
    [anon_sym_constinit] = ACTIONS(3196),
    [anon_sym_consteval] = ACTIONS(3196),
    [anon_sym_alignas] = ACTIONS(3196),
    [anon_sym__Alignas] = ACTIONS(3196),
    [sym_primitive_type] = ACTIONS(3196),
    [anon_sym_enum] = ACTIONS(3196),
    [anon_sym_class] = ACTIONS(3196),
    [anon_sym_struct] = ACTIONS(3196),
    [anon_sym_union] = ACTIONS(3196),
    [anon_sym_if] = ACTIONS(3196),
    [anon_sym_else] = ACTIONS(3196),
    [anon_sym_switch] = ACTIONS(3196),
    [anon_sym_case] = ACTIONS(3196),
    [anon_sym_default] = ACTIONS(3196),
    [anon_sym_while] = ACTIONS(3196),
    [anon_sym_do] = ACTIONS(3196),
    [anon_sym_for] = ACTIONS(3196),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_break] = ACTIONS(3196),
    [anon_sym_continue] = ACTIONS(3196),
    [anon_sym_goto] = ACTIONS(3196),
    [anon_sym___try] = ACTIONS(3196),
    [anon_sym___leave] = ACTIONS(3196),
    [anon_sym_not] = ACTIONS(3196),
    [anon_sym_compl] = ACTIONS(3196),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(3196),
    [anon_sym___alignof] = ACTIONS(3196),
    [anon_sym__alignof] = ACTIONS(3196),
    [anon_sym_alignof] = ACTIONS(3196),
    [anon_sym__Alignof] = ACTIONS(3196),
    [anon_sym_offsetof] = ACTIONS(3196),
    [anon_sym__Generic] = ACTIONS(3196),
    [anon_sym_asm] = ACTIONS(3196),
    [anon_sym___asm__] = ACTIONS(3196),
    [sym_number_literal] = ACTIONS(3198),
    [anon_sym_L_SQUOTE] = ACTIONS(3198),
    [anon_sym_u_SQUOTE] = ACTIONS(3198),
    [anon_sym_U_SQUOTE] = ACTIONS(3198),
    [anon_sym_u8_SQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_L_DQUOTE] = ACTIONS(3198),
    [anon_sym_u_DQUOTE] = ACTIONS(3198),
    [anon_sym_U_DQUOTE] = ACTIONS(3198),
    [anon_sym_u8_DQUOTE] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [sym_true] = ACTIONS(3196),
    [sym_false] = ACTIONS(3196),
    [anon_sym_NULL] = ACTIONS(3196),
    [anon_sym_nullptr] = ACTIONS(3196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3196),
    [anon_sym_let] = ACTIONS(3196),
    [anon_sym_This] = ACTIONS(3196),
    [anon_sym_decltype] = ACTIONS(3196),
    [sym_virtual] = ACTIONS(3196),
    [anon_sym_explicit] = ACTIONS(3196),
    [anon_sym_typename] = ACTIONS(3196),
    [anon_sym_template] = ACTIONS(3196),
    [anon_sym_operator] = ACTIONS(3196),
    [anon_sym_try] = ACTIONS(3196),
    [anon_sym_delete] = ACTIONS(3196),
    [anon_sym_throw] = ACTIONS(3196),
    [anon_sym_namespace] = ACTIONS(3196),
    [anon_sym_using] = ACTIONS(3196),
    [anon_sym_static_assert] = ACTIONS(3196),
    [anon_sym_concept] = ACTIONS(3196),
    [anon_sym_co_return] = ACTIONS(3196),
    [anon_sym_co_yield] = ACTIONS(3196),
    [anon_sym_R_DQUOTE] = ACTIONS(3198),
    [anon_sym_LR_DQUOTE] = ACTIONS(3198),
    [anon_sym_uR_DQUOTE] = ACTIONS(3198),
    [anon_sym_UR_DQUOTE] = ACTIONS(3198),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3198),
    [anon_sym_co_await] = ACTIONS(3196),
    [anon_sym_new] = ACTIONS(3196),
    [anon_sym_requires] = ACTIONS(3196),
    [sym_this] = ACTIONS(3196),
    [anon_sym_discard] = ACTIONS(3196),
    [anon_sym_precise] = ACTIONS(3196),
    [anon_sym_shared] = ACTIONS(3196),
    [anon_sym_groupshared] = ACTIONS(3196),
    [anon_sym_uniform] = ACTIONS(3196),
    [anon_sym_row_major] = ACTIONS(3196),
    [anon_sym_column_major] = ACTIONS(3196),
    [anon_sym_globallycoherent] = ACTIONS(3196),
    [anon_sym_centroid] = ACTIONS(3196),
    [anon_sym_noperspective] = ACTIONS(3196),
    [anon_sym_nointerpolation] = ACTIONS(3196),
    [anon_sym_sample] = ACTIONS(3196),
    [anon_sym_linear] = ACTIONS(3196),
    [anon_sym_snorm] = ACTIONS(3196),
    [anon_sym_unorm] = ACTIONS(3196),
    [anon_sym_point] = ACTIONS(3196),
    [anon_sym_line] = ACTIONS(3196),
    [anon_sym_triangleadj] = ACTIONS(3196),
    [anon_sym_lineadj] = ACTIONS(3196),
    [anon_sym_triangle] = ACTIONS(3196),
    [anon_sym_cbuffer] = ACTIONS(3196),
    [anon_sym_interface] = ACTIONS(3196),
    [anon_sym_extension] = ACTIONS(3196),
  },
  [776] = {
    [sym_identifier] = ACTIONS(3234),
    [aux_sym_preproc_include_token1] = ACTIONS(3234),
    [aux_sym_preproc_def_token1] = ACTIONS(3234),
    [aux_sym_preproc_if_token1] = ACTIONS(3234),
    [aux_sym_preproc_if_token2] = ACTIONS(3234),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3234),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3234),
    [sym_preproc_directive] = ACTIONS(3234),
    [anon_sym_LPAREN2] = ACTIONS(3236),
    [anon_sym_BANG] = ACTIONS(3236),
    [anon_sym_TILDE] = ACTIONS(3236),
    [anon_sym_DASH] = ACTIONS(3234),
    [anon_sym_PLUS] = ACTIONS(3234),
    [anon_sym_STAR] = ACTIONS(3236),
    [anon_sym_AMP_AMP] = ACTIONS(3236),
    [anon_sym_AMP] = ACTIONS(3234),
    [anon_sym_SEMI] = ACTIONS(3236),
    [anon_sym___extension__] = ACTIONS(3234),
    [anon_sym_typedef] = ACTIONS(3234),
    [anon_sym_in] = ACTIONS(3234),
    [anon_sym_out] = ACTIONS(3234),
    [anon_sym_inout] = ACTIONS(3234),
    [anon_sym_extern] = ACTIONS(3234),
    [anon_sym___attribute__] = ACTIONS(3234),
    [anon_sym_COLON_COLON] = ACTIONS(3236),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3236),
    [anon_sym___declspec] = ACTIONS(3234),
    [anon_sym___based] = ACTIONS(3234),
    [anon_sym___cdecl] = ACTIONS(3234),
    [anon_sym___clrcall] = ACTIONS(3234),
    [anon_sym___stdcall] = ACTIONS(3234),
    [anon_sym___fastcall] = ACTIONS(3234),
    [anon_sym___thiscall] = ACTIONS(3234),
    [anon_sym___vectorcall] = ACTIONS(3234),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_signed] = ACTIONS(3234),
    [anon_sym_unsigned] = ACTIONS(3234),
    [anon_sym_long] = ACTIONS(3234),
    [anon_sym_short] = ACTIONS(3234),
    [anon_sym_LBRACK] = ACTIONS(3234),
    [anon_sym_static] = ACTIONS(3234),
    [anon_sym_register] = ACTIONS(3234),
    [anon_sym_inline] = ACTIONS(3234),
    [anon_sym___inline] = ACTIONS(3234),
    [anon_sym___inline__] = ACTIONS(3234),
    [anon_sym___forceinline] = ACTIONS(3234),
    [anon_sym_thread_local] = ACTIONS(3234),
    [anon_sym___thread] = ACTIONS(3234),
    [anon_sym_const] = ACTIONS(3234),
    [anon_sym_constexpr] = ACTIONS(3234),
    [anon_sym_volatile] = ACTIONS(3234),
    [anon_sym_restrict] = ACTIONS(3234),
    [anon_sym___restrict__] = ACTIONS(3234),
    [anon_sym__Atomic] = ACTIONS(3234),
    [anon_sym__Noreturn] = ACTIONS(3234),
    [anon_sym_noreturn] = ACTIONS(3234),
    [anon_sym_mutable] = ACTIONS(3234),
    [anon_sym_constinit] = ACTIONS(3234),
    [anon_sym_consteval] = ACTIONS(3234),
    [anon_sym_alignas] = ACTIONS(3234),
    [anon_sym__Alignas] = ACTIONS(3234),
    [sym_primitive_type] = ACTIONS(3234),
    [anon_sym_enum] = ACTIONS(3234),
    [anon_sym_class] = ACTIONS(3234),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3234),
    [anon_sym_if] = ACTIONS(3234),
    [anon_sym_else] = ACTIONS(3234),
    [anon_sym_switch] = ACTIONS(3234),
    [anon_sym_case] = ACTIONS(3234),
    [anon_sym_default] = ACTIONS(3234),
    [anon_sym_while] = ACTIONS(3234),
    [anon_sym_do] = ACTIONS(3234),
    [anon_sym_for] = ACTIONS(3234),
    [anon_sym_return] = ACTIONS(3234),
    [anon_sym_break] = ACTIONS(3234),
    [anon_sym_continue] = ACTIONS(3234),
    [anon_sym_goto] = ACTIONS(3234),
    [anon_sym___try] = ACTIONS(3234),
    [anon_sym___leave] = ACTIONS(3234),
    [anon_sym_not] = ACTIONS(3234),
    [anon_sym_compl] = ACTIONS(3234),
    [anon_sym_DASH_DASH] = ACTIONS(3236),
    [anon_sym_PLUS_PLUS] = ACTIONS(3236),
    [anon_sym_sizeof] = ACTIONS(3234),
    [anon_sym___alignof__] = ACTIONS(3234),
    [anon_sym___alignof] = ACTIONS(3234),
    [anon_sym__alignof] = ACTIONS(3234),
    [anon_sym_alignof] = ACTIONS(3234),
    [anon_sym__Alignof] = ACTIONS(3234),
    [anon_sym_offsetof] = ACTIONS(3234),
    [anon_sym__Generic] = ACTIONS(3234),
    [anon_sym_asm] = ACTIONS(3234),
    [anon_sym___asm__] = ACTIONS(3234),
    [sym_number_literal] = ACTIONS(3236),
    [anon_sym_L_SQUOTE] = ACTIONS(3236),
    [anon_sym_u_SQUOTE] = ACTIONS(3236),
    [anon_sym_U_SQUOTE] = ACTIONS(3236),
    [anon_sym_u8_SQUOTE] = ACTIONS(3236),
    [anon_sym_SQUOTE] = ACTIONS(3236),
    [anon_sym_L_DQUOTE] = ACTIONS(3236),
    [anon_sym_u_DQUOTE] = ACTIONS(3236),
    [anon_sym_U_DQUOTE] = ACTIONS(3236),
    [anon_sym_u8_DQUOTE] = ACTIONS(3236),
    [anon_sym_DQUOTE] = ACTIONS(3236),
    [sym_true] = ACTIONS(3234),
    [sym_false] = ACTIONS(3234),
    [anon_sym_NULL] = ACTIONS(3234),
    [anon_sym_nullptr] = ACTIONS(3234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3234),
    [anon_sym_let] = ACTIONS(3234),
    [anon_sym_This] = ACTIONS(3234),
    [anon_sym_decltype] = ACTIONS(3234),
    [sym_virtual] = ACTIONS(3234),
    [anon_sym_explicit] = ACTIONS(3234),
    [anon_sym_typename] = ACTIONS(3234),
    [anon_sym_template] = ACTIONS(3234),
    [anon_sym_operator] = ACTIONS(3234),
    [anon_sym_try] = ACTIONS(3234),
    [anon_sym_delete] = ACTIONS(3234),
    [anon_sym_throw] = ACTIONS(3234),
    [anon_sym_namespace] = ACTIONS(3234),
    [anon_sym_using] = ACTIONS(3234),
    [anon_sym_static_assert] = ACTIONS(3234),
    [anon_sym_concept] = ACTIONS(3234),
    [anon_sym_co_return] = ACTIONS(3234),
    [anon_sym_co_yield] = ACTIONS(3234),
    [anon_sym_R_DQUOTE] = ACTIONS(3236),
    [anon_sym_LR_DQUOTE] = ACTIONS(3236),
    [anon_sym_uR_DQUOTE] = ACTIONS(3236),
    [anon_sym_UR_DQUOTE] = ACTIONS(3236),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3236),
    [anon_sym_co_await] = ACTIONS(3234),
    [anon_sym_new] = ACTIONS(3234),
    [anon_sym_requires] = ACTIONS(3234),
    [sym_this] = ACTIONS(3234),
    [anon_sym_discard] = ACTIONS(3234),
    [anon_sym_precise] = ACTIONS(3234),
    [anon_sym_shared] = ACTIONS(3234),
    [anon_sym_groupshared] = ACTIONS(3234),
    [anon_sym_uniform] = ACTIONS(3234),
    [anon_sym_row_major] = ACTIONS(3234),
    [anon_sym_column_major] = ACTIONS(3234),
    [anon_sym_globallycoherent] = ACTIONS(3234),
    [anon_sym_centroid] = ACTIONS(3234),
    [anon_sym_noperspective] = ACTIONS(3234),
    [anon_sym_nointerpolation] = ACTIONS(3234),
    [anon_sym_sample] = ACTIONS(3234),
    [anon_sym_linear] = ACTIONS(3234),
    [anon_sym_snorm] = ACTIONS(3234),
    [anon_sym_unorm] = ACTIONS(3234),
    [anon_sym_point] = ACTIONS(3234),
    [anon_sym_line] = ACTIONS(3234),
    [anon_sym_triangleadj] = ACTIONS(3234),
    [anon_sym_lineadj] = ACTIONS(3234),
    [anon_sym_triangle] = ACTIONS(3234),
    [anon_sym_cbuffer] = ACTIONS(3234),
    [anon_sym_interface] = ACTIONS(3234),
    [anon_sym_extension] = ACTIONS(3234),
  },
  [777] = {
    [sym_identifier] = ACTIONS(2954),
    [aux_sym_preproc_include_token1] = ACTIONS(2954),
    [aux_sym_preproc_def_token1] = ACTIONS(2954),
    [aux_sym_preproc_if_token1] = ACTIONS(2954),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2954),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2954),
    [sym_preproc_directive] = ACTIONS(2954),
    [anon_sym_LPAREN2] = ACTIONS(2956),
    [anon_sym_BANG] = ACTIONS(2956),
    [anon_sym_TILDE] = ACTIONS(2956),
    [anon_sym_DASH] = ACTIONS(2954),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_STAR] = ACTIONS(2956),
    [anon_sym_AMP_AMP] = ACTIONS(2956),
    [anon_sym_AMP] = ACTIONS(2954),
    [anon_sym_SEMI] = ACTIONS(2956),
    [anon_sym___extension__] = ACTIONS(2954),
    [anon_sym_typedef] = ACTIONS(2954),
    [anon_sym_in] = ACTIONS(2954),
    [anon_sym_out] = ACTIONS(2954),
    [anon_sym_inout] = ACTIONS(2954),
    [anon_sym_extern] = ACTIONS(2954),
    [anon_sym___attribute__] = ACTIONS(2954),
    [anon_sym_COLON_COLON] = ACTIONS(2956),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2956),
    [anon_sym___declspec] = ACTIONS(2954),
    [anon_sym___based] = ACTIONS(2954),
    [anon_sym___cdecl] = ACTIONS(2954),
    [anon_sym___clrcall] = ACTIONS(2954),
    [anon_sym___stdcall] = ACTIONS(2954),
    [anon_sym___fastcall] = ACTIONS(2954),
    [anon_sym___thiscall] = ACTIONS(2954),
    [anon_sym___vectorcall] = ACTIONS(2954),
    [anon_sym_LBRACE] = ACTIONS(2956),
    [anon_sym_RBRACE] = ACTIONS(2956),
    [anon_sym_signed] = ACTIONS(2954),
    [anon_sym_unsigned] = ACTIONS(2954),
    [anon_sym_long] = ACTIONS(2954),
    [anon_sym_short] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_static] = ACTIONS(2954),
    [anon_sym_register] = ACTIONS(2954),
    [anon_sym_inline] = ACTIONS(2954),
    [anon_sym___inline] = ACTIONS(2954),
    [anon_sym___inline__] = ACTIONS(2954),
    [anon_sym___forceinline] = ACTIONS(2954),
    [anon_sym_thread_local] = ACTIONS(2954),
    [anon_sym___thread] = ACTIONS(2954),
    [anon_sym_const] = ACTIONS(2954),
    [anon_sym_constexpr] = ACTIONS(2954),
    [anon_sym_volatile] = ACTIONS(2954),
    [anon_sym_restrict] = ACTIONS(2954),
    [anon_sym___restrict__] = ACTIONS(2954),
    [anon_sym__Atomic] = ACTIONS(2954),
    [anon_sym__Noreturn] = ACTIONS(2954),
    [anon_sym_noreturn] = ACTIONS(2954),
    [anon_sym_mutable] = ACTIONS(2954),
    [anon_sym_constinit] = ACTIONS(2954),
    [anon_sym_consteval] = ACTIONS(2954),
    [anon_sym_alignas] = ACTIONS(2954),
    [anon_sym__Alignas] = ACTIONS(2954),
    [sym_primitive_type] = ACTIONS(2954),
    [anon_sym_enum] = ACTIONS(2954),
    [anon_sym_class] = ACTIONS(2954),
    [anon_sym_struct] = ACTIONS(2954),
    [anon_sym_union] = ACTIONS(2954),
    [anon_sym_if] = ACTIONS(2954),
    [anon_sym_else] = ACTIONS(2954),
    [anon_sym_switch] = ACTIONS(2954),
    [anon_sym_case] = ACTIONS(2954),
    [anon_sym_default] = ACTIONS(2954),
    [anon_sym_while] = ACTIONS(2954),
    [anon_sym_do] = ACTIONS(2954),
    [anon_sym_for] = ACTIONS(2954),
    [anon_sym_return] = ACTIONS(2954),
    [anon_sym_break] = ACTIONS(2954),
    [anon_sym_continue] = ACTIONS(2954),
    [anon_sym_goto] = ACTIONS(2954),
    [anon_sym___try] = ACTIONS(2954),
    [anon_sym___leave] = ACTIONS(2954),
    [anon_sym_not] = ACTIONS(2954),
    [anon_sym_compl] = ACTIONS(2954),
    [anon_sym_DASH_DASH] = ACTIONS(2956),
    [anon_sym_PLUS_PLUS] = ACTIONS(2956),
    [anon_sym_sizeof] = ACTIONS(2954),
    [anon_sym___alignof__] = ACTIONS(2954),
    [anon_sym___alignof] = ACTIONS(2954),
    [anon_sym__alignof] = ACTIONS(2954),
    [anon_sym_alignof] = ACTIONS(2954),
    [anon_sym__Alignof] = ACTIONS(2954),
    [anon_sym_offsetof] = ACTIONS(2954),
    [anon_sym__Generic] = ACTIONS(2954),
    [anon_sym_asm] = ACTIONS(2954),
    [anon_sym___asm__] = ACTIONS(2954),
    [sym_number_literal] = ACTIONS(2956),
    [anon_sym_L_SQUOTE] = ACTIONS(2956),
    [anon_sym_u_SQUOTE] = ACTIONS(2956),
    [anon_sym_U_SQUOTE] = ACTIONS(2956),
    [anon_sym_u8_SQUOTE] = ACTIONS(2956),
    [anon_sym_SQUOTE] = ACTIONS(2956),
    [anon_sym_L_DQUOTE] = ACTIONS(2956),
    [anon_sym_u_DQUOTE] = ACTIONS(2956),
    [anon_sym_U_DQUOTE] = ACTIONS(2956),
    [anon_sym_u8_DQUOTE] = ACTIONS(2956),
    [anon_sym_DQUOTE] = ACTIONS(2956),
    [sym_true] = ACTIONS(2954),
    [sym_false] = ACTIONS(2954),
    [anon_sym_NULL] = ACTIONS(2954),
    [anon_sym_nullptr] = ACTIONS(2954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2954),
    [anon_sym_let] = ACTIONS(2954),
    [anon_sym_This] = ACTIONS(2954),
    [anon_sym_decltype] = ACTIONS(2954),
    [sym_virtual] = ACTIONS(2954),
    [anon_sym_explicit] = ACTIONS(2954),
    [anon_sym_typename] = ACTIONS(2954),
    [anon_sym_template] = ACTIONS(2954),
    [anon_sym_operator] = ACTIONS(2954),
    [anon_sym_try] = ACTIONS(2954),
    [anon_sym_delete] = ACTIONS(2954),
    [anon_sym_throw] = ACTIONS(2954),
    [anon_sym_namespace] = ACTIONS(2954),
    [anon_sym_using] = ACTIONS(2954),
    [anon_sym_static_assert] = ACTIONS(2954),
    [anon_sym_concept] = ACTIONS(2954),
    [anon_sym_co_return] = ACTIONS(2954),
    [anon_sym_co_yield] = ACTIONS(2954),
    [anon_sym_R_DQUOTE] = ACTIONS(2956),
    [anon_sym_LR_DQUOTE] = ACTIONS(2956),
    [anon_sym_uR_DQUOTE] = ACTIONS(2956),
    [anon_sym_UR_DQUOTE] = ACTIONS(2956),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2956),
    [anon_sym_co_await] = ACTIONS(2954),
    [anon_sym_new] = ACTIONS(2954),
    [anon_sym_requires] = ACTIONS(2954),
    [sym_this] = ACTIONS(2954),
    [anon_sym_discard] = ACTIONS(2954),
    [anon_sym_precise] = ACTIONS(2954),
    [anon_sym_shared] = ACTIONS(2954),
    [anon_sym_groupshared] = ACTIONS(2954),
    [anon_sym_uniform] = ACTIONS(2954),
    [anon_sym_row_major] = ACTIONS(2954),
    [anon_sym_column_major] = ACTIONS(2954),
    [anon_sym_globallycoherent] = ACTIONS(2954),
    [anon_sym_centroid] = ACTIONS(2954),
    [anon_sym_noperspective] = ACTIONS(2954),
    [anon_sym_nointerpolation] = ACTIONS(2954),
    [anon_sym_sample] = ACTIONS(2954),
    [anon_sym_linear] = ACTIONS(2954),
    [anon_sym_snorm] = ACTIONS(2954),
    [anon_sym_unorm] = ACTIONS(2954),
    [anon_sym_point] = ACTIONS(2954),
    [anon_sym_line] = ACTIONS(2954),
    [anon_sym_triangleadj] = ACTIONS(2954),
    [anon_sym_lineadj] = ACTIONS(2954),
    [anon_sym_triangle] = ACTIONS(2954),
    [anon_sym_cbuffer] = ACTIONS(2954),
    [anon_sym_interface] = ACTIONS(2954),
    [anon_sym_extension] = ACTIONS(2954),
  },
  [778] = {
    [sym_identifier] = ACTIONS(3234),
    [aux_sym_preproc_include_token1] = ACTIONS(3234),
    [aux_sym_preproc_def_token1] = ACTIONS(3234),
    [aux_sym_preproc_if_token1] = ACTIONS(3234),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3234),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3234),
    [sym_preproc_directive] = ACTIONS(3234),
    [anon_sym_LPAREN2] = ACTIONS(3236),
    [anon_sym_BANG] = ACTIONS(3236),
    [anon_sym_TILDE] = ACTIONS(3236),
    [anon_sym_DASH] = ACTIONS(3234),
    [anon_sym_PLUS] = ACTIONS(3234),
    [anon_sym_STAR] = ACTIONS(3236),
    [anon_sym_AMP_AMP] = ACTIONS(3236),
    [anon_sym_AMP] = ACTIONS(3234),
    [anon_sym_SEMI] = ACTIONS(3236),
    [anon_sym___extension__] = ACTIONS(3234),
    [anon_sym_typedef] = ACTIONS(3234),
    [anon_sym_in] = ACTIONS(3234),
    [anon_sym_out] = ACTIONS(3234),
    [anon_sym_inout] = ACTIONS(3234),
    [anon_sym_extern] = ACTIONS(3234),
    [anon_sym___attribute__] = ACTIONS(3234),
    [anon_sym_COLON_COLON] = ACTIONS(3236),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3236),
    [anon_sym___declspec] = ACTIONS(3234),
    [anon_sym___based] = ACTIONS(3234),
    [anon_sym___cdecl] = ACTIONS(3234),
    [anon_sym___clrcall] = ACTIONS(3234),
    [anon_sym___stdcall] = ACTIONS(3234),
    [anon_sym___fastcall] = ACTIONS(3234),
    [anon_sym___thiscall] = ACTIONS(3234),
    [anon_sym___vectorcall] = ACTIONS(3234),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_RBRACE] = ACTIONS(3236),
    [anon_sym_signed] = ACTIONS(3234),
    [anon_sym_unsigned] = ACTIONS(3234),
    [anon_sym_long] = ACTIONS(3234),
    [anon_sym_short] = ACTIONS(3234),
    [anon_sym_LBRACK] = ACTIONS(3234),
    [anon_sym_static] = ACTIONS(3234),
    [anon_sym_register] = ACTIONS(3234),
    [anon_sym_inline] = ACTIONS(3234),
    [anon_sym___inline] = ACTIONS(3234),
    [anon_sym___inline__] = ACTIONS(3234),
    [anon_sym___forceinline] = ACTIONS(3234),
    [anon_sym_thread_local] = ACTIONS(3234),
    [anon_sym___thread] = ACTIONS(3234),
    [anon_sym_const] = ACTIONS(3234),
    [anon_sym_constexpr] = ACTIONS(3234),
    [anon_sym_volatile] = ACTIONS(3234),
    [anon_sym_restrict] = ACTIONS(3234),
    [anon_sym___restrict__] = ACTIONS(3234),
    [anon_sym__Atomic] = ACTIONS(3234),
    [anon_sym__Noreturn] = ACTIONS(3234),
    [anon_sym_noreturn] = ACTIONS(3234),
    [anon_sym_mutable] = ACTIONS(3234),
    [anon_sym_constinit] = ACTIONS(3234),
    [anon_sym_consteval] = ACTIONS(3234),
    [anon_sym_alignas] = ACTIONS(3234),
    [anon_sym__Alignas] = ACTIONS(3234),
    [sym_primitive_type] = ACTIONS(3234),
    [anon_sym_enum] = ACTIONS(3234),
    [anon_sym_class] = ACTIONS(3234),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3234),
    [anon_sym_if] = ACTIONS(3234),
    [anon_sym_else] = ACTIONS(3234),
    [anon_sym_switch] = ACTIONS(3234),
    [anon_sym_case] = ACTIONS(3234),
    [anon_sym_default] = ACTIONS(3234),
    [anon_sym_while] = ACTIONS(3234),
    [anon_sym_do] = ACTIONS(3234),
    [anon_sym_for] = ACTIONS(3234),
    [anon_sym_return] = ACTIONS(3234),
    [anon_sym_break] = ACTIONS(3234),
    [anon_sym_continue] = ACTIONS(3234),
    [anon_sym_goto] = ACTIONS(3234),
    [anon_sym___try] = ACTIONS(3234),
    [anon_sym___leave] = ACTIONS(3234),
    [anon_sym_not] = ACTIONS(3234),
    [anon_sym_compl] = ACTIONS(3234),
    [anon_sym_DASH_DASH] = ACTIONS(3236),
    [anon_sym_PLUS_PLUS] = ACTIONS(3236),
    [anon_sym_sizeof] = ACTIONS(3234),
    [anon_sym___alignof__] = ACTIONS(3234),
    [anon_sym___alignof] = ACTIONS(3234),
    [anon_sym__alignof] = ACTIONS(3234),
    [anon_sym_alignof] = ACTIONS(3234),
    [anon_sym__Alignof] = ACTIONS(3234),
    [anon_sym_offsetof] = ACTIONS(3234),
    [anon_sym__Generic] = ACTIONS(3234),
    [anon_sym_asm] = ACTIONS(3234),
    [anon_sym___asm__] = ACTIONS(3234),
    [sym_number_literal] = ACTIONS(3236),
    [anon_sym_L_SQUOTE] = ACTIONS(3236),
    [anon_sym_u_SQUOTE] = ACTIONS(3236),
    [anon_sym_U_SQUOTE] = ACTIONS(3236),
    [anon_sym_u8_SQUOTE] = ACTIONS(3236),
    [anon_sym_SQUOTE] = ACTIONS(3236),
    [anon_sym_L_DQUOTE] = ACTIONS(3236),
    [anon_sym_u_DQUOTE] = ACTIONS(3236),
    [anon_sym_U_DQUOTE] = ACTIONS(3236),
    [anon_sym_u8_DQUOTE] = ACTIONS(3236),
    [anon_sym_DQUOTE] = ACTIONS(3236),
    [sym_true] = ACTIONS(3234),
    [sym_false] = ACTIONS(3234),
    [anon_sym_NULL] = ACTIONS(3234),
    [anon_sym_nullptr] = ACTIONS(3234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3234),
    [anon_sym_let] = ACTIONS(3234),
    [anon_sym_This] = ACTIONS(3234),
    [anon_sym_decltype] = ACTIONS(3234),
    [sym_virtual] = ACTIONS(3234),
    [anon_sym_explicit] = ACTIONS(3234),
    [anon_sym_typename] = ACTIONS(3234),
    [anon_sym_template] = ACTIONS(3234),
    [anon_sym_operator] = ACTIONS(3234),
    [anon_sym_try] = ACTIONS(3234),
    [anon_sym_delete] = ACTIONS(3234),
    [anon_sym_throw] = ACTIONS(3234),
    [anon_sym_namespace] = ACTIONS(3234),
    [anon_sym_using] = ACTIONS(3234),
    [anon_sym_static_assert] = ACTIONS(3234),
    [anon_sym_concept] = ACTIONS(3234),
    [anon_sym_co_return] = ACTIONS(3234),
    [anon_sym_co_yield] = ACTIONS(3234),
    [anon_sym_R_DQUOTE] = ACTIONS(3236),
    [anon_sym_LR_DQUOTE] = ACTIONS(3236),
    [anon_sym_uR_DQUOTE] = ACTIONS(3236),
    [anon_sym_UR_DQUOTE] = ACTIONS(3236),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3236),
    [anon_sym_co_await] = ACTIONS(3234),
    [anon_sym_new] = ACTIONS(3234),
    [anon_sym_requires] = ACTIONS(3234),
    [sym_this] = ACTIONS(3234),
    [anon_sym_discard] = ACTIONS(3234),
    [anon_sym_precise] = ACTIONS(3234),
    [anon_sym_shared] = ACTIONS(3234),
    [anon_sym_groupshared] = ACTIONS(3234),
    [anon_sym_uniform] = ACTIONS(3234),
    [anon_sym_row_major] = ACTIONS(3234),
    [anon_sym_column_major] = ACTIONS(3234),
    [anon_sym_globallycoherent] = ACTIONS(3234),
    [anon_sym_centroid] = ACTIONS(3234),
    [anon_sym_noperspective] = ACTIONS(3234),
    [anon_sym_nointerpolation] = ACTIONS(3234),
    [anon_sym_sample] = ACTIONS(3234),
    [anon_sym_linear] = ACTIONS(3234),
    [anon_sym_snorm] = ACTIONS(3234),
    [anon_sym_unorm] = ACTIONS(3234),
    [anon_sym_point] = ACTIONS(3234),
    [anon_sym_line] = ACTIONS(3234),
    [anon_sym_triangleadj] = ACTIONS(3234),
    [anon_sym_lineadj] = ACTIONS(3234),
    [anon_sym_triangle] = ACTIONS(3234),
    [anon_sym_cbuffer] = ACTIONS(3234),
    [anon_sym_interface] = ACTIONS(3234),
    [anon_sym_extension] = ACTIONS(3234),
  },
  [779] = {
    [sym_identifier] = ACTIONS(3076),
    [aux_sym_preproc_include_token1] = ACTIONS(3076),
    [aux_sym_preproc_def_token1] = ACTIONS(3076),
    [aux_sym_preproc_if_token1] = ACTIONS(3076),
    [aux_sym_preproc_if_token2] = ACTIONS(3076),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3076),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3076),
    [sym_preproc_directive] = ACTIONS(3076),
    [anon_sym_LPAREN2] = ACTIONS(3078),
    [anon_sym_BANG] = ACTIONS(3078),
    [anon_sym_TILDE] = ACTIONS(3078),
    [anon_sym_DASH] = ACTIONS(3076),
    [anon_sym_PLUS] = ACTIONS(3076),
    [anon_sym_STAR] = ACTIONS(3078),
    [anon_sym_AMP_AMP] = ACTIONS(3078),
    [anon_sym_AMP] = ACTIONS(3076),
    [anon_sym_SEMI] = ACTIONS(3078),
    [anon_sym___extension__] = ACTIONS(3076),
    [anon_sym_typedef] = ACTIONS(3076),
    [anon_sym_in] = ACTIONS(3076),
    [anon_sym_out] = ACTIONS(3076),
    [anon_sym_inout] = ACTIONS(3076),
    [anon_sym_extern] = ACTIONS(3076),
    [anon_sym___attribute__] = ACTIONS(3076),
    [anon_sym_COLON_COLON] = ACTIONS(3078),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3078),
    [anon_sym___declspec] = ACTIONS(3076),
    [anon_sym___based] = ACTIONS(3076),
    [anon_sym___cdecl] = ACTIONS(3076),
    [anon_sym___clrcall] = ACTIONS(3076),
    [anon_sym___stdcall] = ACTIONS(3076),
    [anon_sym___fastcall] = ACTIONS(3076),
    [anon_sym___thiscall] = ACTIONS(3076),
    [anon_sym___vectorcall] = ACTIONS(3076),
    [anon_sym_LBRACE] = ACTIONS(3078),
    [anon_sym_signed] = ACTIONS(3076),
    [anon_sym_unsigned] = ACTIONS(3076),
    [anon_sym_long] = ACTIONS(3076),
    [anon_sym_short] = ACTIONS(3076),
    [anon_sym_LBRACK] = ACTIONS(3076),
    [anon_sym_static] = ACTIONS(3076),
    [anon_sym_register] = ACTIONS(3076),
    [anon_sym_inline] = ACTIONS(3076),
    [anon_sym___inline] = ACTIONS(3076),
    [anon_sym___inline__] = ACTIONS(3076),
    [anon_sym___forceinline] = ACTIONS(3076),
    [anon_sym_thread_local] = ACTIONS(3076),
    [anon_sym___thread] = ACTIONS(3076),
    [anon_sym_const] = ACTIONS(3076),
    [anon_sym_constexpr] = ACTIONS(3076),
    [anon_sym_volatile] = ACTIONS(3076),
    [anon_sym_restrict] = ACTIONS(3076),
    [anon_sym___restrict__] = ACTIONS(3076),
    [anon_sym__Atomic] = ACTIONS(3076),
    [anon_sym__Noreturn] = ACTIONS(3076),
    [anon_sym_noreturn] = ACTIONS(3076),
    [anon_sym_mutable] = ACTIONS(3076),
    [anon_sym_constinit] = ACTIONS(3076),
    [anon_sym_consteval] = ACTIONS(3076),
    [anon_sym_alignas] = ACTIONS(3076),
    [anon_sym__Alignas] = ACTIONS(3076),
    [sym_primitive_type] = ACTIONS(3076),
    [anon_sym_enum] = ACTIONS(3076),
    [anon_sym_class] = ACTIONS(3076),
    [anon_sym_struct] = ACTIONS(3076),
    [anon_sym_union] = ACTIONS(3076),
    [anon_sym_if] = ACTIONS(3076),
    [anon_sym_else] = ACTIONS(3076),
    [anon_sym_switch] = ACTIONS(3076),
    [anon_sym_case] = ACTIONS(3076),
    [anon_sym_default] = ACTIONS(3076),
    [anon_sym_while] = ACTIONS(3076),
    [anon_sym_do] = ACTIONS(3076),
    [anon_sym_for] = ACTIONS(3076),
    [anon_sym_return] = ACTIONS(3076),
    [anon_sym_break] = ACTIONS(3076),
    [anon_sym_continue] = ACTIONS(3076),
    [anon_sym_goto] = ACTIONS(3076),
    [anon_sym___try] = ACTIONS(3076),
    [anon_sym___leave] = ACTIONS(3076),
    [anon_sym_not] = ACTIONS(3076),
    [anon_sym_compl] = ACTIONS(3076),
    [anon_sym_DASH_DASH] = ACTIONS(3078),
    [anon_sym_PLUS_PLUS] = ACTIONS(3078),
    [anon_sym_sizeof] = ACTIONS(3076),
    [anon_sym___alignof__] = ACTIONS(3076),
    [anon_sym___alignof] = ACTIONS(3076),
    [anon_sym__alignof] = ACTIONS(3076),
    [anon_sym_alignof] = ACTIONS(3076),
    [anon_sym__Alignof] = ACTIONS(3076),
    [anon_sym_offsetof] = ACTIONS(3076),
    [anon_sym__Generic] = ACTIONS(3076),
    [anon_sym_asm] = ACTIONS(3076),
    [anon_sym___asm__] = ACTIONS(3076),
    [sym_number_literal] = ACTIONS(3078),
    [anon_sym_L_SQUOTE] = ACTIONS(3078),
    [anon_sym_u_SQUOTE] = ACTIONS(3078),
    [anon_sym_U_SQUOTE] = ACTIONS(3078),
    [anon_sym_u8_SQUOTE] = ACTIONS(3078),
    [anon_sym_SQUOTE] = ACTIONS(3078),
    [anon_sym_L_DQUOTE] = ACTIONS(3078),
    [anon_sym_u_DQUOTE] = ACTIONS(3078),
    [anon_sym_U_DQUOTE] = ACTIONS(3078),
    [anon_sym_u8_DQUOTE] = ACTIONS(3078),
    [anon_sym_DQUOTE] = ACTIONS(3078),
    [sym_true] = ACTIONS(3076),
    [sym_false] = ACTIONS(3076),
    [anon_sym_NULL] = ACTIONS(3076),
    [anon_sym_nullptr] = ACTIONS(3076),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3076),
    [anon_sym_let] = ACTIONS(3076),
    [anon_sym_This] = ACTIONS(3076),
    [anon_sym_decltype] = ACTIONS(3076),
    [sym_virtual] = ACTIONS(3076),
    [anon_sym_explicit] = ACTIONS(3076),
    [anon_sym_typename] = ACTIONS(3076),
    [anon_sym_template] = ACTIONS(3076),
    [anon_sym_operator] = ACTIONS(3076),
    [anon_sym_try] = ACTIONS(3076),
    [anon_sym_delete] = ACTIONS(3076),
    [anon_sym_throw] = ACTIONS(3076),
    [anon_sym_namespace] = ACTIONS(3076),
    [anon_sym_using] = ACTIONS(3076),
    [anon_sym_static_assert] = ACTIONS(3076),
    [anon_sym_concept] = ACTIONS(3076),
    [anon_sym_co_return] = ACTIONS(3076),
    [anon_sym_co_yield] = ACTIONS(3076),
    [anon_sym_R_DQUOTE] = ACTIONS(3078),
    [anon_sym_LR_DQUOTE] = ACTIONS(3078),
    [anon_sym_uR_DQUOTE] = ACTIONS(3078),
    [anon_sym_UR_DQUOTE] = ACTIONS(3078),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3078),
    [anon_sym_co_await] = ACTIONS(3076),
    [anon_sym_new] = ACTIONS(3076),
    [anon_sym_requires] = ACTIONS(3076),
    [sym_this] = ACTIONS(3076),
    [anon_sym_discard] = ACTIONS(3076),
    [anon_sym_precise] = ACTIONS(3076),
    [anon_sym_shared] = ACTIONS(3076),
    [anon_sym_groupshared] = ACTIONS(3076),
    [anon_sym_uniform] = ACTIONS(3076),
    [anon_sym_row_major] = ACTIONS(3076),
    [anon_sym_column_major] = ACTIONS(3076),
    [anon_sym_globallycoherent] = ACTIONS(3076),
    [anon_sym_centroid] = ACTIONS(3076),
    [anon_sym_noperspective] = ACTIONS(3076),
    [anon_sym_nointerpolation] = ACTIONS(3076),
    [anon_sym_sample] = ACTIONS(3076),
    [anon_sym_linear] = ACTIONS(3076),
    [anon_sym_snorm] = ACTIONS(3076),
    [anon_sym_unorm] = ACTIONS(3076),
    [anon_sym_point] = ACTIONS(3076),
    [anon_sym_line] = ACTIONS(3076),
    [anon_sym_triangleadj] = ACTIONS(3076),
    [anon_sym_lineadj] = ACTIONS(3076),
    [anon_sym_triangle] = ACTIONS(3076),
    [anon_sym_cbuffer] = ACTIONS(3076),
    [anon_sym_interface] = ACTIONS(3076),
    [anon_sym_extension] = ACTIONS(3076),
  },
  [780] = {
    [sym_identifier] = ACTIONS(3178),
    [aux_sym_preproc_include_token1] = ACTIONS(3178),
    [aux_sym_preproc_def_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3178),
    [sym_preproc_directive] = ACTIONS(3178),
    [anon_sym_LPAREN2] = ACTIONS(3180),
    [anon_sym_BANG] = ACTIONS(3180),
    [anon_sym_TILDE] = ACTIONS(3180),
    [anon_sym_DASH] = ACTIONS(3178),
    [anon_sym_PLUS] = ACTIONS(3178),
    [anon_sym_STAR] = ACTIONS(3180),
    [anon_sym_AMP_AMP] = ACTIONS(3180),
    [anon_sym_AMP] = ACTIONS(3178),
    [anon_sym_SEMI] = ACTIONS(3180),
    [anon_sym___extension__] = ACTIONS(3178),
    [anon_sym_typedef] = ACTIONS(3178),
    [anon_sym_in] = ACTIONS(3178),
    [anon_sym_out] = ACTIONS(3178),
    [anon_sym_inout] = ACTIONS(3178),
    [anon_sym_extern] = ACTIONS(3178),
    [anon_sym___attribute__] = ACTIONS(3178),
    [anon_sym_COLON_COLON] = ACTIONS(3180),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3180),
    [anon_sym___declspec] = ACTIONS(3178),
    [anon_sym___based] = ACTIONS(3178),
    [anon_sym___cdecl] = ACTIONS(3178),
    [anon_sym___clrcall] = ACTIONS(3178),
    [anon_sym___stdcall] = ACTIONS(3178),
    [anon_sym___fastcall] = ACTIONS(3178),
    [anon_sym___thiscall] = ACTIONS(3178),
    [anon_sym___vectorcall] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(3180),
    [anon_sym_RBRACE] = ACTIONS(3180),
    [anon_sym_signed] = ACTIONS(3178),
    [anon_sym_unsigned] = ACTIONS(3178),
    [anon_sym_long] = ACTIONS(3178),
    [anon_sym_short] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(3178),
    [anon_sym_static] = ACTIONS(3178),
    [anon_sym_register] = ACTIONS(3178),
    [anon_sym_inline] = ACTIONS(3178),
    [anon_sym___inline] = ACTIONS(3178),
    [anon_sym___inline__] = ACTIONS(3178),
    [anon_sym___forceinline] = ACTIONS(3178),
    [anon_sym_thread_local] = ACTIONS(3178),
    [anon_sym___thread] = ACTIONS(3178),
    [anon_sym_const] = ACTIONS(3178),
    [anon_sym_constexpr] = ACTIONS(3178),
    [anon_sym_volatile] = ACTIONS(3178),
    [anon_sym_restrict] = ACTIONS(3178),
    [anon_sym___restrict__] = ACTIONS(3178),
    [anon_sym__Atomic] = ACTIONS(3178),
    [anon_sym__Noreturn] = ACTIONS(3178),
    [anon_sym_noreturn] = ACTIONS(3178),
    [anon_sym_mutable] = ACTIONS(3178),
    [anon_sym_constinit] = ACTIONS(3178),
    [anon_sym_consteval] = ACTIONS(3178),
    [anon_sym_alignas] = ACTIONS(3178),
    [anon_sym__Alignas] = ACTIONS(3178),
    [sym_primitive_type] = ACTIONS(3178),
    [anon_sym_enum] = ACTIONS(3178),
    [anon_sym_class] = ACTIONS(3178),
    [anon_sym_struct] = ACTIONS(3178),
    [anon_sym_union] = ACTIONS(3178),
    [anon_sym_if] = ACTIONS(3178),
    [anon_sym_else] = ACTIONS(3178),
    [anon_sym_switch] = ACTIONS(3178),
    [anon_sym_case] = ACTIONS(3178),
    [anon_sym_default] = ACTIONS(3178),
    [anon_sym_while] = ACTIONS(3178),
    [anon_sym_do] = ACTIONS(3178),
    [anon_sym_for] = ACTIONS(3178),
    [anon_sym_return] = ACTIONS(3178),
    [anon_sym_break] = ACTIONS(3178),
    [anon_sym_continue] = ACTIONS(3178),
    [anon_sym_goto] = ACTIONS(3178),
    [anon_sym___try] = ACTIONS(3178),
    [anon_sym___leave] = ACTIONS(3178),
    [anon_sym_not] = ACTIONS(3178),
    [anon_sym_compl] = ACTIONS(3178),
    [anon_sym_DASH_DASH] = ACTIONS(3180),
    [anon_sym_PLUS_PLUS] = ACTIONS(3180),
    [anon_sym_sizeof] = ACTIONS(3178),
    [anon_sym___alignof__] = ACTIONS(3178),
    [anon_sym___alignof] = ACTIONS(3178),
    [anon_sym__alignof] = ACTIONS(3178),
    [anon_sym_alignof] = ACTIONS(3178),
    [anon_sym__Alignof] = ACTIONS(3178),
    [anon_sym_offsetof] = ACTIONS(3178),
    [anon_sym__Generic] = ACTIONS(3178),
    [anon_sym_asm] = ACTIONS(3178),
    [anon_sym___asm__] = ACTIONS(3178),
    [sym_number_literal] = ACTIONS(3180),
    [anon_sym_L_SQUOTE] = ACTIONS(3180),
    [anon_sym_u_SQUOTE] = ACTIONS(3180),
    [anon_sym_U_SQUOTE] = ACTIONS(3180),
    [anon_sym_u8_SQUOTE] = ACTIONS(3180),
    [anon_sym_SQUOTE] = ACTIONS(3180),
    [anon_sym_L_DQUOTE] = ACTIONS(3180),
    [anon_sym_u_DQUOTE] = ACTIONS(3180),
    [anon_sym_U_DQUOTE] = ACTIONS(3180),
    [anon_sym_u8_DQUOTE] = ACTIONS(3180),
    [anon_sym_DQUOTE] = ACTIONS(3180),
    [sym_true] = ACTIONS(3178),
    [sym_false] = ACTIONS(3178),
    [anon_sym_NULL] = ACTIONS(3178),
    [anon_sym_nullptr] = ACTIONS(3178),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3178),
    [anon_sym_let] = ACTIONS(3178),
    [anon_sym_This] = ACTIONS(3178),
    [anon_sym_decltype] = ACTIONS(3178),
    [sym_virtual] = ACTIONS(3178),
    [anon_sym_explicit] = ACTIONS(3178),
    [anon_sym_typename] = ACTIONS(3178),
    [anon_sym_template] = ACTIONS(3178),
    [anon_sym_operator] = ACTIONS(3178),
    [anon_sym_try] = ACTIONS(3178),
    [anon_sym_delete] = ACTIONS(3178),
    [anon_sym_throw] = ACTIONS(3178),
    [anon_sym_namespace] = ACTIONS(3178),
    [anon_sym_using] = ACTIONS(3178),
    [anon_sym_static_assert] = ACTIONS(3178),
    [anon_sym_concept] = ACTIONS(3178),
    [anon_sym_co_return] = ACTIONS(3178),
    [anon_sym_co_yield] = ACTIONS(3178),
    [anon_sym_R_DQUOTE] = ACTIONS(3180),
    [anon_sym_LR_DQUOTE] = ACTIONS(3180),
    [anon_sym_uR_DQUOTE] = ACTIONS(3180),
    [anon_sym_UR_DQUOTE] = ACTIONS(3180),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3180),
    [anon_sym_co_await] = ACTIONS(3178),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3178),
    [sym_this] = ACTIONS(3178),
    [anon_sym_discard] = ACTIONS(3178),
    [anon_sym_precise] = ACTIONS(3178),
    [anon_sym_shared] = ACTIONS(3178),
    [anon_sym_groupshared] = ACTIONS(3178),
    [anon_sym_uniform] = ACTIONS(3178),
    [anon_sym_row_major] = ACTIONS(3178),
    [anon_sym_column_major] = ACTIONS(3178),
    [anon_sym_globallycoherent] = ACTIONS(3178),
    [anon_sym_centroid] = ACTIONS(3178),
    [anon_sym_noperspective] = ACTIONS(3178),
    [anon_sym_nointerpolation] = ACTIONS(3178),
    [anon_sym_sample] = ACTIONS(3178),
    [anon_sym_linear] = ACTIONS(3178),
    [anon_sym_snorm] = ACTIONS(3178),
    [anon_sym_unorm] = ACTIONS(3178),
    [anon_sym_point] = ACTIONS(3178),
    [anon_sym_line] = ACTIONS(3178),
    [anon_sym_triangleadj] = ACTIONS(3178),
    [anon_sym_lineadj] = ACTIONS(3178),
    [anon_sym_triangle] = ACTIONS(3178),
    [anon_sym_cbuffer] = ACTIONS(3178),
    [anon_sym_interface] = ACTIONS(3178),
    [anon_sym_extension] = ACTIONS(3178),
  },
  [781] = {
    [sym_identifier] = ACTIONS(2898),
    [aux_sym_preproc_include_token1] = ACTIONS(2898),
    [aux_sym_preproc_def_token1] = ACTIONS(2898),
    [aux_sym_preproc_if_token1] = ACTIONS(2898),
    [aux_sym_preproc_if_token2] = ACTIONS(2898),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2898),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2898),
    [sym_preproc_directive] = ACTIONS(2898),
    [anon_sym_LPAREN2] = ACTIONS(2900),
    [anon_sym_BANG] = ACTIONS(2900),
    [anon_sym_TILDE] = ACTIONS(2900),
    [anon_sym_DASH] = ACTIONS(2898),
    [anon_sym_PLUS] = ACTIONS(2898),
    [anon_sym_STAR] = ACTIONS(2900),
    [anon_sym_AMP_AMP] = ACTIONS(2900),
    [anon_sym_AMP] = ACTIONS(2898),
    [anon_sym_SEMI] = ACTIONS(2900),
    [anon_sym___extension__] = ACTIONS(2898),
    [anon_sym_typedef] = ACTIONS(2898),
    [anon_sym_in] = ACTIONS(2898),
    [anon_sym_out] = ACTIONS(2898),
    [anon_sym_inout] = ACTIONS(2898),
    [anon_sym_extern] = ACTIONS(2898),
    [anon_sym___attribute__] = ACTIONS(2898),
    [anon_sym_COLON_COLON] = ACTIONS(2900),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2900),
    [anon_sym___declspec] = ACTIONS(2898),
    [anon_sym___based] = ACTIONS(2898),
    [anon_sym___cdecl] = ACTIONS(2898),
    [anon_sym___clrcall] = ACTIONS(2898),
    [anon_sym___stdcall] = ACTIONS(2898),
    [anon_sym___fastcall] = ACTIONS(2898),
    [anon_sym___thiscall] = ACTIONS(2898),
    [anon_sym___vectorcall] = ACTIONS(2898),
    [anon_sym_LBRACE] = ACTIONS(2900),
    [anon_sym_signed] = ACTIONS(2898),
    [anon_sym_unsigned] = ACTIONS(2898),
    [anon_sym_long] = ACTIONS(2898),
    [anon_sym_short] = ACTIONS(2898),
    [anon_sym_LBRACK] = ACTIONS(2898),
    [anon_sym_static] = ACTIONS(2898),
    [anon_sym_register] = ACTIONS(2898),
    [anon_sym_inline] = ACTIONS(2898),
    [anon_sym___inline] = ACTIONS(2898),
    [anon_sym___inline__] = ACTIONS(2898),
    [anon_sym___forceinline] = ACTIONS(2898),
    [anon_sym_thread_local] = ACTIONS(2898),
    [anon_sym___thread] = ACTIONS(2898),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_constexpr] = ACTIONS(2898),
    [anon_sym_volatile] = ACTIONS(2898),
    [anon_sym_restrict] = ACTIONS(2898),
    [anon_sym___restrict__] = ACTIONS(2898),
    [anon_sym__Atomic] = ACTIONS(2898),
    [anon_sym__Noreturn] = ACTIONS(2898),
    [anon_sym_noreturn] = ACTIONS(2898),
    [anon_sym_mutable] = ACTIONS(2898),
    [anon_sym_constinit] = ACTIONS(2898),
    [anon_sym_consteval] = ACTIONS(2898),
    [anon_sym_alignas] = ACTIONS(2898),
    [anon_sym__Alignas] = ACTIONS(2898),
    [sym_primitive_type] = ACTIONS(2898),
    [anon_sym_enum] = ACTIONS(2898),
    [anon_sym_class] = ACTIONS(2898),
    [anon_sym_struct] = ACTIONS(2898),
    [anon_sym_union] = ACTIONS(2898),
    [anon_sym_if] = ACTIONS(2898),
    [anon_sym_else] = ACTIONS(2898),
    [anon_sym_switch] = ACTIONS(2898),
    [anon_sym_case] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2898),
    [anon_sym_while] = ACTIONS(2898),
    [anon_sym_do] = ACTIONS(2898),
    [anon_sym_for] = ACTIONS(2898),
    [anon_sym_return] = ACTIONS(2898),
    [anon_sym_break] = ACTIONS(2898),
    [anon_sym_continue] = ACTIONS(2898),
    [anon_sym_goto] = ACTIONS(2898),
    [anon_sym___try] = ACTIONS(2898),
    [anon_sym___leave] = ACTIONS(2898),
    [anon_sym_not] = ACTIONS(2898),
    [anon_sym_compl] = ACTIONS(2898),
    [anon_sym_DASH_DASH] = ACTIONS(2900),
    [anon_sym_PLUS_PLUS] = ACTIONS(2900),
    [anon_sym_sizeof] = ACTIONS(2898),
    [anon_sym___alignof__] = ACTIONS(2898),
    [anon_sym___alignof] = ACTIONS(2898),
    [anon_sym__alignof] = ACTIONS(2898),
    [anon_sym_alignof] = ACTIONS(2898),
    [anon_sym__Alignof] = ACTIONS(2898),
    [anon_sym_offsetof] = ACTIONS(2898),
    [anon_sym__Generic] = ACTIONS(2898),
    [anon_sym_asm] = ACTIONS(2898),
    [anon_sym___asm__] = ACTIONS(2898),
    [sym_number_literal] = ACTIONS(2900),
    [anon_sym_L_SQUOTE] = ACTIONS(2900),
    [anon_sym_u_SQUOTE] = ACTIONS(2900),
    [anon_sym_U_SQUOTE] = ACTIONS(2900),
    [anon_sym_u8_SQUOTE] = ACTIONS(2900),
    [anon_sym_SQUOTE] = ACTIONS(2900),
    [anon_sym_L_DQUOTE] = ACTIONS(2900),
    [anon_sym_u_DQUOTE] = ACTIONS(2900),
    [anon_sym_U_DQUOTE] = ACTIONS(2900),
    [anon_sym_u8_DQUOTE] = ACTIONS(2900),
    [anon_sym_DQUOTE] = ACTIONS(2900),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2898),
    [anon_sym_nullptr] = ACTIONS(2898),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2898),
    [anon_sym_let] = ACTIONS(2898),
    [anon_sym_This] = ACTIONS(2898),
    [anon_sym_decltype] = ACTIONS(2898),
    [sym_virtual] = ACTIONS(2898),
    [anon_sym_explicit] = ACTIONS(2898),
    [anon_sym_typename] = ACTIONS(2898),
    [anon_sym_template] = ACTIONS(2898),
    [anon_sym_operator] = ACTIONS(2898),
    [anon_sym_try] = ACTIONS(2898),
    [anon_sym_delete] = ACTIONS(2898),
    [anon_sym_throw] = ACTIONS(2898),
    [anon_sym_namespace] = ACTIONS(2898),
    [anon_sym_using] = ACTIONS(2898),
    [anon_sym_static_assert] = ACTIONS(2898),
    [anon_sym_concept] = ACTIONS(2898),
    [anon_sym_co_return] = ACTIONS(2898),
    [anon_sym_co_yield] = ACTIONS(2898),
    [anon_sym_R_DQUOTE] = ACTIONS(2900),
    [anon_sym_LR_DQUOTE] = ACTIONS(2900),
    [anon_sym_uR_DQUOTE] = ACTIONS(2900),
    [anon_sym_UR_DQUOTE] = ACTIONS(2900),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2900),
    [anon_sym_co_await] = ACTIONS(2898),
    [anon_sym_new] = ACTIONS(2898),
    [anon_sym_requires] = ACTIONS(2898),
    [sym_this] = ACTIONS(2898),
    [anon_sym_discard] = ACTIONS(2898),
    [anon_sym_precise] = ACTIONS(2898),
    [anon_sym_shared] = ACTIONS(2898),
    [anon_sym_groupshared] = ACTIONS(2898),
    [anon_sym_uniform] = ACTIONS(2898),
    [anon_sym_row_major] = ACTIONS(2898),
    [anon_sym_column_major] = ACTIONS(2898),
    [anon_sym_globallycoherent] = ACTIONS(2898),
    [anon_sym_centroid] = ACTIONS(2898),
    [anon_sym_noperspective] = ACTIONS(2898),
    [anon_sym_nointerpolation] = ACTIONS(2898),
    [anon_sym_sample] = ACTIONS(2898),
    [anon_sym_linear] = ACTIONS(2898),
    [anon_sym_snorm] = ACTIONS(2898),
    [anon_sym_unorm] = ACTIONS(2898),
    [anon_sym_point] = ACTIONS(2898),
    [anon_sym_line] = ACTIONS(2898),
    [anon_sym_triangleadj] = ACTIONS(2898),
    [anon_sym_lineadj] = ACTIONS(2898),
    [anon_sym_triangle] = ACTIONS(2898),
    [anon_sym_cbuffer] = ACTIONS(2898),
    [anon_sym_interface] = ACTIONS(2898),
    [anon_sym_extension] = ACTIONS(2898),
  },
  [782] = {
    [sym_identifier] = ACTIONS(2950),
    [aux_sym_preproc_include_token1] = ACTIONS(2950),
    [aux_sym_preproc_def_token1] = ACTIONS(2950),
    [aux_sym_preproc_if_token1] = ACTIONS(2950),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2950),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2950),
    [sym_preproc_directive] = ACTIONS(2950),
    [anon_sym_LPAREN2] = ACTIONS(2952),
    [anon_sym_BANG] = ACTIONS(2952),
    [anon_sym_TILDE] = ACTIONS(2952),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_STAR] = ACTIONS(2952),
    [anon_sym_AMP_AMP] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2950),
    [anon_sym_SEMI] = ACTIONS(2952),
    [anon_sym___extension__] = ACTIONS(2950),
    [anon_sym_typedef] = ACTIONS(2950),
    [anon_sym_in] = ACTIONS(2950),
    [anon_sym_out] = ACTIONS(2950),
    [anon_sym_inout] = ACTIONS(2950),
    [anon_sym_extern] = ACTIONS(2950),
    [anon_sym___attribute__] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2952),
    [anon_sym___declspec] = ACTIONS(2950),
    [anon_sym___based] = ACTIONS(2950),
    [anon_sym___cdecl] = ACTIONS(2950),
    [anon_sym___clrcall] = ACTIONS(2950),
    [anon_sym___stdcall] = ACTIONS(2950),
    [anon_sym___fastcall] = ACTIONS(2950),
    [anon_sym___thiscall] = ACTIONS(2950),
    [anon_sym___vectorcall] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2952),
    [anon_sym_RBRACE] = ACTIONS(2952),
    [anon_sym_signed] = ACTIONS(2950),
    [anon_sym_unsigned] = ACTIONS(2950),
    [anon_sym_long] = ACTIONS(2950),
    [anon_sym_short] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_static] = ACTIONS(2950),
    [anon_sym_register] = ACTIONS(2950),
    [anon_sym_inline] = ACTIONS(2950),
    [anon_sym___inline] = ACTIONS(2950),
    [anon_sym___inline__] = ACTIONS(2950),
    [anon_sym___forceinline] = ACTIONS(2950),
    [anon_sym_thread_local] = ACTIONS(2950),
    [anon_sym___thread] = ACTIONS(2950),
    [anon_sym_const] = ACTIONS(2950),
    [anon_sym_constexpr] = ACTIONS(2950),
    [anon_sym_volatile] = ACTIONS(2950),
    [anon_sym_restrict] = ACTIONS(2950),
    [anon_sym___restrict__] = ACTIONS(2950),
    [anon_sym__Atomic] = ACTIONS(2950),
    [anon_sym__Noreturn] = ACTIONS(2950),
    [anon_sym_noreturn] = ACTIONS(2950),
    [anon_sym_mutable] = ACTIONS(2950),
    [anon_sym_constinit] = ACTIONS(2950),
    [anon_sym_consteval] = ACTIONS(2950),
    [anon_sym_alignas] = ACTIONS(2950),
    [anon_sym__Alignas] = ACTIONS(2950),
    [sym_primitive_type] = ACTIONS(2950),
    [anon_sym_enum] = ACTIONS(2950),
    [anon_sym_class] = ACTIONS(2950),
    [anon_sym_struct] = ACTIONS(2950),
    [anon_sym_union] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_else] = ACTIONS(2950),
    [anon_sym_switch] = ACTIONS(2950),
    [anon_sym_case] = ACTIONS(2950),
    [anon_sym_default] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_break] = ACTIONS(2950),
    [anon_sym_continue] = ACTIONS(2950),
    [anon_sym_goto] = ACTIONS(2950),
    [anon_sym___try] = ACTIONS(2950),
    [anon_sym___leave] = ACTIONS(2950),
    [anon_sym_not] = ACTIONS(2950),
    [anon_sym_compl] = ACTIONS(2950),
    [anon_sym_DASH_DASH] = ACTIONS(2952),
    [anon_sym_PLUS_PLUS] = ACTIONS(2952),
    [anon_sym_sizeof] = ACTIONS(2950),
    [anon_sym___alignof__] = ACTIONS(2950),
    [anon_sym___alignof] = ACTIONS(2950),
    [anon_sym__alignof] = ACTIONS(2950),
    [anon_sym_alignof] = ACTIONS(2950),
    [anon_sym__Alignof] = ACTIONS(2950),
    [anon_sym_offsetof] = ACTIONS(2950),
    [anon_sym__Generic] = ACTIONS(2950),
    [anon_sym_asm] = ACTIONS(2950),
    [anon_sym___asm__] = ACTIONS(2950),
    [sym_number_literal] = ACTIONS(2952),
    [anon_sym_L_SQUOTE] = ACTIONS(2952),
    [anon_sym_u_SQUOTE] = ACTIONS(2952),
    [anon_sym_U_SQUOTE] = ACTIONS(2952),
    [anon_sym_u8_SQUOTE] = ACTIONS(2952),
    [anon_sym_SQUOTE] = ACTIONS(2952),
    [anon_sym_L_DQUOTE] = ACTIONS(2952),
    [anon_sym_u_DQUOTE] = ACTIONS(2952),
    [anon_sym_U_DQUOTE] = ACTIONS(2952),
    [anon_sym_u8_DQUOTE] = ACTIONS(2952),
    [anon_sym_DQUOTE] = ACTIONS(2952),
    [sym_true] = ACTIONS(2950),
    [sym_false] = ACTIONS(2950),
    [anon_sym_NULL] = ACTIONS(2950),
    [anon_sym_nullptr] = ACTIONS(2950),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2950),
    [anon_sym_let] = ACTIONS(2950),
    [anon_sym_This] = ACTIONS(2950),
    [anon_sym_decltype] = ACTIONS(2950),
    [sym_virtual] = ACTIONS(2950),
    [anon_sym_explicit] = ACTIONS(2950),
    [anon_sym_typename] = ACTIONS(2950),
    [anon_sym_template] = ACTIONS(2950),
    [anon_sym_operator] = ACTIONS(2950),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_delete] = ACTIONS(2950),
    [anon_sym_throw] = ACTIONS(2950),
    [anon_sym_namespace] = ACTIONS(2950),
    [anon_sym_using] = ACTIONS(2950),
    [anon_sym_static_assert] = ACTIONS(2950),
    [anon_sym_concept] = ACTIONS(2950),
    [anon_sym_co_return] = ACTIONS(2950),
    [anon_sym_co_yield] = ACTIONS(2950),
    [anon_sym_R_DQUOTE] = ACTIONS(2952),
    [anon_sym_LR_DQUOTE] = ACTIONS(2952),
    [anon_sym_uR_DQUOTE] = ACTIONS(2952),
    [anon_sym_UR_DQUOTE] = ACTIONS(2952),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2952),
    [anon_sym_co_await] = ACTIONS(2950),
    [anon_sym_new] = ACTIONS(2950),
    [anon_sym_requires] = ACTIONS(2950),
    [sym_this] = ACTIONS(2950),
    [anon_sym_discard] = ACTIONS(2950),
    [anon_sym_precise] = ACTIONS(2950),
    [anon_sym_shared] = ACTIONS(2950),
    [anon_sym_groupshared] = ACTIONS(2950),
    [anon_sym_uniform] = ACTIONS(2950),
    [anon_sym_row_major] = ACTIONS(2950),
    [anon_sym_column_major] = ACTIONS(2950),
    [anon_sym_globallycoherent] = ACTIONS(2950),
    [anon_sym_centroid] = ACTIONS(2950),
    [anon_sym_noperspective] = ACTIONS(2950),
    [anon_sym_nointerpolation] = ACTIONS(2950),
    [anon_sym_sample] = ACTIONS(2950),
    [anon_sym_linear] = ACTIONS(2950),
    [anon_sym_snorm] = ACTIONS(2950),
    [anon_sym_unorm] = ACTIONS(2950),
    [anon_sym_point] = ACTIONS(2950),
    [anon_sym_line] = ACTIONS(2950),
    [anon_sym_triangleadj] = ACTIONS(2950),
    [anon_sym_lineadj] = ACTIONS(2950),
    [anon_sym_triangle] = ACTIONS(2950),
    [anon_sym_cbuffer] = ACTIONS(2950),
    [anon_sym_interface] = ACTIONS(2950),
    [anon_sym_extension] = ACTIONS(2950),
  },
  [783] = {
    [sym_identifier] = ACTIONS(3182),
    [aux_sym_preproc_include_token1] = ACTIONS(3182),
    [aux_sym_preproc_def_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token2] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [sym_preproc_directive] = ACTIONS(3182),
    [anon_sym_LPAREN2] = ACTIONS(3184),
    [anon_sym_BANG] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_DASH] = ACTIONS(3182),
    [anon_sym_PLUS] = ACTIONS(3182),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_AMP_AMP] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3182),
    [anon_sym_SEMI] = ACTIONS(3184),
    [anon_sym___extension__] = ACTIONS(3182),
    [anon_sym_typedef] = ACTIONS(3182),
    [anon_sym_in] = ACTIONS(3182),
    [anon_sym_out] = ACTIONS(3182),
    [anon_sym_inout] = ACTIONS(3182),
    [anon_sym_extern] = ACTIONS(3182),
    [anon_sym___attribute__] = ACTIONS(3182),
    [anon_sym_COLON_COLON] = ACTIONS(3184),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3184),
    [anon_sym___declspec] = ACTIONS(3182),
    [anon_sym___based] = ACTIONS(3182),
    [anon_sym___cdecl] = ACTIONS(3182),
    [anon_sym___clrcall] = ACTIONS(3182),
    [anon_sym___stdcall] = ACTIONS(3182),
    [anon_sym___fastcall] = ACTIONS(3182),
    [anon_sym___thiscall] = ACTIONS(3182),
    [anon_sym___vectorcall] = ACTIONS(3182),
    [anon_sym_LBRACE] = ACTIONS(3184),
    [anon_sym_signed] = ACTIONS(3182),
    [anon_sym_unsigned] = ACTIONS(3182),
    [anon_sym_long] = ACTIONS(3182),
    [anon_sym_short] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3182),
    [anon_sym_register] = ACTIONS(3182),
    [anon_sym_inline] = ACTIONS(3182),
    [anon_sym___inline] = ACTIONS(3182),
    [anon_sym___inline__] = ACTIONS(3182),
    [anon_sym___forceinline] = ACTIONS(3182),
    [anon_sym_thread_local] = ACTIONS(3182),
    [anon_sym___thread] = ACTIONS(3182),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_constexpr] = ACTIONS(3182),
    [anon_sym_volatile] = ACTIONS(3182),
    [anon_sym_restrict] = ACTIONS(3182),
    [anon_sym___restrict__] = ACTIONS(3182),
    [anon_sym__Atomic] = ACTIONS(3182),
    [anon_sym__Noreturn] = ACTIONS(3182),
    [anon_sym_noreturn] = ACTIONS(3182),
    [anon_sym_mutable] = ACTIONS(3182),
    [anon_sym_constinit] = ACTIONS(3182),
    [anon_sym_consteval] = ACTIONS(3182),
    [anon_sym_alignas] = ACTIONS(3182),
    [anon_sym__Alignas] = ACTIONS(3182),
    [sym_primitive_type] = ACTIONS(3182),
    [anon_sym_enum] = ACTIONS(3182),
    [anon_sym_class] = ACTIONS(3182),
    [anon_sym_struct] = ACTIONS(3182),
    [anon_sym_union] = ACTIONS(3182),
    [anon_sym_if] = ACTIONS(3182),
    [anon_sym_else] = ACTIONS(3182),
    [anon_sym_switch] = ACTIONS(3182),
    [anon_sym_case] = ACTIONS(3182),
    [anon_sym_default] = ACTIONS(3182),
    [anon_sym_while] = ACTIONS(3182),
    [anon_sym_do] = ACTIONS(3182),
    [anon_sym_for] = ACTIONS(3182),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_break] = ACTIONS(3182),
    [anon_sym_continue] = ACTIONS(3182),
    [anon_sym_goto] = ACTIONS(3182),
    [anon_sym___try] = ACTIONS(3182),
    [anon_sym___leave] = ACTIONS(3182),
    [anon_sym_not] = ACTIONS(3182),
    [anon_sym_compl] = ACTIONS(3182),
    [anon_sym_DASH_DASH] = ACTIONS(3184),
    [anon_sym_PLUS_PLUS] = ACTIONS(3184),
    [anon_sym_sizeof] = ACTIONS(3182),
    [anon_sym___alignof__] = ACTIONS(3182),
    [anon_sym___alignof] = ACTIONS(3182),
    [anon_sym__alignof] = ACTIONS(3182),
    [anon_sym_alignof] = ACTIONS(3182),
    [anon_sym__Alignof] = ACTIONS(3182),
    [anon_sym_offsetof] = ACTIONS(3182),
    [anon_sym__Generic] = ACTIONS(3182),
    [anon_sym_asm] = ACTIONS(3182),
    [anon_sym___asm__] = ACTIONS(3182),
    [sym_number_literal] = ACTIONS(3184),
    [anon_sym_L_SQUOTE] = ACTIONS(3184),
    [anon_sym_u_SQUOTE] = ACTIONS(3184),
    [anon_sym_U_SQUOTE] = ACTIONS(3184),
    [anon_sym_u8_SQUOTE] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3184),
    [anon_sym_L_DQUOTE] = ACTIONS(3184),
    [anon_sym_u_DQUOTE] = ACTIONS(3184),
    [anon_sym_U_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8_DQUOTE] = ACTIONS(3184),
    [anon_sym_DQUOTE] = ACTIONS(3184),
    [sym_true] = ACTIONS(3182),
    [sym_false] = ACTIONS(3182),
    [anon_sym_NULL] = ACTIONS(3182),
    [anon_sym_nullptr] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3182),
    [anon_sym_let] = ACTIONS(3182),
    [anon_sym_This] = ACTIONS(3182),
    [anon_sym_decltype] = ACTIONS(3182),
    [sym_virtual] = ACTIONS(3182),
    [anon_sym_explicit] = ACTIONS(3182),
    [anon_sym_typename] = ACTIONS(3182),
    [anon_sym_template] = ACTIONS(3182),
    [anon_sym_operator] = ACTIONS(3182),
    [anon_sym_try] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(3182),
    [anon_sym_throw] = ACTIONS(3182),
    [anon_sym_namespace] = ACTIONS(3182),
    [anon_sym_using] = ACTIONS(3182),
    [anon_sym_static_assert] = ACTIONS(3182),
    [anon_sym_concept] = ACTIONS(3182),
    [anon_sym_co_return] = ACTIONS(3182),
    [anon_sym_co_yield] = ACTIONS(3182),
    [anon_sym_R_DQUOTE] = ACTIONS(3184),
    [anon_sym_LR_DQUOTE] = ACTIONS(3184),
    [anon_sym_uR_DQUOTE] = ACTIONS(3184),
    [anon_sym_UR_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3184),
    [anon_sym_co_await] = ACTIONS(3182),
    [anon_sym_new] = ACTIONS(3182),
    [anon_sym_requires] = ACTIONS(3182),
    [sym_this] = ACTIONS(3182),
    [anon_sym_discard] = ACTIONS(3182),
    [anon_sym_precise] = ACTIONS(3182),
    [anon_sym_shared] = ACTIONS(3182),
    [anon_sym_groupshared] = ACTIONS(3182),
    [anon_sym_uniform] = ACTIONS(3182),
    [anon_sym_row_major] = ACTIONS(3182),
    [anon_sym_column_major] = ACTIONS(3182),
    [anon_sym_globallycoherent] = ACTIONS(3182),
    [anon_sym_centroid] = ACTIONS(3182),
    [anon_sym_noperspective] = ACTIONS(3182),
    [anon_sym_nointerpolation] = ACTIONS(3182),
    [anon_sym_sample] = ACTIONS(3182),
    [anon_sym_linear] = ACTIONS(3182),
    [anon_sym_snorm] = ACTIONS(3182),
    [anon_sym_unorm] = ACTIONS(3182),
    [anon_sym_point] = ACTIONS(3182),
    [anon_sym_line] = ACTIONS(3182),
    [anon_sym_triangleadj] = ACTIONS(3182),
    [anon_sym_lineadj] = ACTIONS(3182),
    [anon_sym_triangle] = ACTIONS(3182),
    [anon_sym_cbuffer] = ACTIONS(3182),
    [anon_sym_interface] = ACTIONS(3182),
    [anon_sym_extension] = ACTIONS(3182),
  },
  [784] = {
    [sym_identifier] = ACTIONS(3182),
    [aux_sym_preproc_include_token1] = ACTIONS(3182),
    [aux_sym_preproc_def_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token2] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [sym_preproc_directive] = ACTIONS(3182),
    [anon_sym_LPAREN2] = ACTIONS(3184),
    [anon_sym_BANG] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_DASH] = ACTIONS(3182),
    [anon_sym_PLUS] = ACTIONS(3182),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_AMP_AMP] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3182),
    [anon_sym_SEMI] = ACTIONS(3184),
    [anon_sym___extension__] = ACTIONS(3182),
    [anon_sym_typedef] = ACTIONS(3182),
    [anon_sym_in] = ACTIONS(3182),
    [anon_sym_out] = ACTIONS(3182),
    [anon_sym_inout] = ACTIONS(3182),
    [anon_sym_extern] = ACTIONS(3182),
    [anon_sym___attribute__] = ACTIONS(3182),
    [anon_sym_COLON_COLON] = ACTIONS(3184),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3184),
    [anon_sym___declspec] = ACTIONS(3182),
    [anon_sym___based] = ACTIONS(3182),
    [anon_sym___cdecl] = ACTIONS(3182),
    [anon_sym___clrcall] = ACTIONS(3182),
    [anon_sym___stdcall] = ACTIONS(3182),
    [anon_sym___fastcall] = ACTIONS(3182),
    [anon_sym___thiscall] = ACTIONS(3182),
    [anon_sym___vectorcall] = ACTIONS(3182),
    [anon_sym_LBRACE] = ACTIONS(3184),
    [anon_sym_signed] = ACTIONS(3182),
    [anon_sym_unsigned] = ACTIONS(3182),
    [anon_sym_long] = ACTIONS(3182),
    [anon_sym_short] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3182),
    [anon_sym_register] = ACTIONS(3182),
    [anon_sym_inline] = ACTIONS(3182),
    [anon_sym___inline] = ACTIONS(3182),
    [anon_sym___inline__] = ACTIONS(3182),
    [anon_sym___forceinline] = ACTIONS(3182),
    [anon_sym_thread_local] = ACTIONS(3182),
    [anon_sym___thread] = ACTIONS(3182),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_constexpr] = ACTIONS(3182),
    [anon_sym_volatile] = ACTIONS(3182),
    [anon_sym_restrict] = ACTIONS(3182),
    [anon_sym___restrict__] = ACTIONS(3182),
    [anon_sym__Atomic] = ACTIONS(3182),
    [anon_sym__Noreturn] = ACTIONS(3182),
    [anon_sym_noreturn] = ACTIONS(3182),
    [anon_sym_mutable] = ACTIONS(3182),
    [anon_sym_constinit] = ACTIONS(3182),
    [anon_sym_consteval] = ACTIONS(3182),
    [anon_sym_alignas] = ACTIONS(3182),
    [anon_sym__Alignas] = ACTIONS(3182),
    [sym_primitive_type] = ACTIONS(3182),
    [anon_sym_enum] = ACTIONS(3182),
    [anon_sym_class] = ACTIONS(3182),
    [anon_sym_struct] = ACTIONS(3182),
    [anon_sym_union] = ACTIONS(3182),
    [anon_sym_if] = ACTIONS(3182),
    [anon_sym_else] = ACTIONS(3182),
    [anon_sym_switch] = ACTIONS(3182),
    [anon_sym_case] = ACTIONS(3182),
    [anon_sym_default] = ACTIONS(3182),
    [anon_sym_while] = ACTIONS(3182),
    [anon_sym_do] = ACTIONS(3182),
    [anon_sym_for] = ACTIONS(3182),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_break] = ACTIONS(3182),
    [anon_sym_continue] = ACTIONS(3182),
    [anon_sym_goto] = ACTIONS(3182),
    [anon_sym___try] = ACTIONS(3182),
    [anon_sym___leave] = ACTIONS(3182),
    [anon_sym_not] = ACTIONS(3182),
    [anon_sym_compl] = ACTIONS(3182),
    [anon_sym_DASH_DASH] = ACTIONS(3184),
    [anon_sym_PLUS_PLUS] = ACTIONS(3184),
    [anon_sym_sizeof] = ACTIONS(3182),
    [anon_sym___alignof__] = ACTIONS(3182),
    [anon_sym___alignof] = ACTIONS(3182),
    [anon_sym__alignof] = ACTIONS(3182),
    [anon_sym_alignof] = ACTIONS(3182),
    [anon_sym__Alignof] = ACTIONS(3182),
    [anon_sym_offsetof] = ACTIONS(3182),
    [anon_sym__Generic] = ACTIONS(3182),
    [anon_sym_asm] = ACTIONS(3182),
    [anon_sym___asm__] = ACTIONS(3182),
    [sym_number_literal] = ACTIONS(3184),
    [anon_sym_L_SQUOTE] = ACTIONS(3184),
    [anon_sym_u_SQUOTE] = ACTIONS(3184),
    [anon_sym_U_SQUOTE] = ACTIONS(3184),
    [anon_sym_u8_SQUOTE] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3184),
    [anon_sym_L_DQUOTE] = ACTIONS(3184),
    [anon_sym_u_DQUOTE] = ACTIONS(3184),
    [anon_sym_U_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8_DQUOTE] = ACTIONS(3184),
    [anon_sym_DQUOTE] = ACTIONS(3184),
    [sym_true] = ACTIONS(3182),
    [sym_false] = ACTIONS(3182),
    [anon_sym_NULL] = ACTIONS(3182),
    [anon_sym_nullptr] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3182),
    [anon_sym_let] = ACTIONS(3182),
    [anon_sym_This] = ACTIONS(3182),
    [anon_sym_decltype] = ACTIONS(3182),
    [sym_virtual] = ACTIONS(3182),
    [anon_sym_explicit] = ACTIONS(3182),
    [anon_sym_typename] = ACTIONS(3182),
    [anon_sym_template] = ACTIONS(3182),
    [anon_sym_operator] = ACTIONS(3182),
    [anon_sym_try] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(3182),
    [anon_sym_throw] = ACTIONS(3182),
    [anon_sym_namespace] = ACTIONS(3182),
    [anon_sym_using] = ACTIONS(3182),
    [anon_sym_static_assert] = ACTIONS(3182),
    [anon_sym_concept] = ACTIONS(3182),
    [anon_sym_co_return] = ACTIONS(3182),
    [anon_sym_co_yield] = ACTIONS(3182),
    [anon_sym_R_DQUOTE] = ACTIONS(3184),
    [anon_sym_LR_DQUOTE] = ACTIONS(3184),
    [anon_sym_uR_DQUOTE] = ACTIONS(3184),
    [anon_sym_UR_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3184),
    [anon_sym_co_await] = ACTIONS(3182),
    [anon_sym_new] = ACTIONS(3182),
    [anon_sym_requires] = ACTIONS(3182),
    [sym_this] = ACTIONS(3182),
    [anon_sym_discard] = ACTIONS(3182),
    [anon_sym_precise] = ACTIONS(3182),
    [anon_sym_shared] = ACTIONS(3182),
    [anon_sym_groupshared] = ACTIONS(3182),
    [anon_sym_uniform] = ACTIONS(3182),
    [anon_sym_row_major] = ACTIONS(3182),
    [anon_sym_column_major] = ACTIONS(3182),
    [anon_sym_globallycoherent] = ACTIONS(3182),
    [anon_sym_centroid] = ACTIONS(3182),
    [anon_sym_noperspective] = ACTIONS(3182),
    [anon_sym_nointerpolation] = ACTIONS(3182),
    [anon_sym_sample] = ACTIONS(3182),
    [anon_sym_linear] = ACTIONS(3182),
    [anon_sym_snorm] = ACTIONS(3182),
    [anon_sym_unorm] = ACTIONS(3182),
    [anon_sym_point] = ACTIONS(3182),
    [anon_sym_line] = ACTIONS(3182),
    [anon_sym_triangleadj] = ACTIONS(3182),
    [anon_sym_lineadj] = ACTIONS(3182),
    [anon_sym_triangle] = ACTIONS(3182),
    [anon_sym_cbuffer] = ACTIONS(3182),
    [anon_sym_interface] = ACTIONS(3182),
    [anon_sym_extension] = ACTIONS(3182),
  },
  [785] = {
    [sym_identifier] = ACTIONS(3214),
    [aux_sym_preproc_include_token1] = ACTIONS(3214),
    [aux_sym_preproc_def_token1] = ACTIONS(3214),
    [aux_sym_preproc_if_token1] = ACTIONS(3214),
    [aux_sym_preproc_if_token2] = ACTIONS(3214),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3214),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3214),
    [sym_preproc_directive] = ACTIONS(3214),
    [anon_sym_LPAREN2] = ACTIONS(3216),
    [anon_sym_BANG] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_DASH] = ACTIONS(3214),
    [anon_sym_PLUS] = ACTIONS(3214),
    [anon_sym_STAR] = ACTIONS(3216),
    [anon_sym_AMP_AMP] = ACTIONS(3216),
    [anon_sym_AMP] = ACTIONS(3214),
    [anon_sym_SEMI] = ACTIONS(3216),
    [anon_sym___extension__] = ACTIONS(3214),
    [anon_sym_typedef] = ACTIONS(3214),
    [anon_sym_in] = ACTIONS(3214),
    [anon_sym_out] = ACTIONS(3214),
    [anon_sym_inout] = ACTIONS(3214),
    [anon_sym_extern] = ACTIONS(3214),
    [anon_sym___attribute__] = ACTIONS(3214),
    [anon_sym_COLON_COLON] = ACTIONS(3216),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3216),
    [anon_sym___declspec] = ACTIONS(3214),
    [anon_sym___based] = ACTIONS(3214),
    [anon_sym___cdecl] = ACTIONS(3214),
    [anon_sym___clrcall] = ACTIONS(3214),
    [anon_sym___stdcall] = ACTIONS(3214),
    [anon_sym___fastcall] = ACTIONS(3214),
    [anon_sym___thiscall] = ACTIONS(3214),
    [anon_sym___vectorcall] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3216),
    [anon_sym_signed] = ACTIONS(3214),
    [anon_sym_unsigned] = ACTIONS(3214),
    [anon_sym_long] = ACTIONS(3214),
    [anon_sym_short] = ACTIONS(3214),
    [anon_sym_LBRACK] = ACTIONS(3214),
    [anon_sym_static] = ACTIONS(3214),
    [anon_sym_register] = ACTIONS(3214),
    [anon_sym_inline] = ACTIONS(3214),
    [anon_sym___inline] = ACTIONS(3214),
    [anon_sym___inline__] = ACTIONS(3214),
    [anon_sym___forceinline] = ACTIONS(3214),
    [anon_sym_thread_local] = ACTIONS(3214),
    [anon_sym___thread] = ACTIONS(3214),
    [anon_sym_const] = ACTIONS(3214),
    [anon_sym_constexpr] = ACTIONS(3214),
    [anon_sym_volatile] = ACTIONS(3214),
    [anon_sym_restrict] = ACTIONS(3214),
    [anon_sym___restrict__] = ACTIONS(3214),
    [anon_sym__Atomic] = ACTIONS(3214),
    [anon_sym__Noreturn] = ACTIONS(3214),
    [anon_sym_noreturn] = ACTIONS(3214),
    [anon_sym_mutable] = ACTIONS(3214),
    [anon_sym_constinit] = ACTIONS(3214),
    [anon_sym_consteval] = ACTIONS(3214),
    [anon_sym_alignas] = ACTIONS(3214),
    [anon_sym__Alignas] = ACTIONS(3214),
    [sym_primitive_type] = ACTIONS(3214),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3214),
    [anon_sym_struct] = ACTIONS(3214),
    [anon_sym_union] = ACTIONS(3214),
    [anon_sym_if] = ACTIONS(3214),
    [anon_sym_else] = ACTIONS(3214),
    [anon_sym_switch] = ACTIONS(3214),
    [anon_sym_case] = ACTIONS(3214),
    [anon_sym_default] = ACTIONS(3214),
    [anon_sym_while] = ACTIONS(3214),
    [anon_sym_do] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3214),
    [anon_sym_return] = ACTIONS(3214),
    [anon_sym_break] = ACTIONS(3214),
    [anon_sym_continue] = ACTIONS(3214),
    [anon_sym_goto] = ACTIONS(3214),
    [anon_sym___try] = ACTIONS(3214),
    [anon_sym___leave] = ACTIONS(3214),
    [anon_sym_not] = ACTIONS(3214),
    [anon_sym_compl] = ACTIONS(3214),
    [anon_sym_DASH_DASH] = ACTIONS(3216),
    [anon_sym_PLUS_PLUS] = ACTIONS(3216),
    [anon_sym_sizeof] = ACTIONS(3214),
    [anon_sym___alignof__] = ACTIONS(3214),
    [anon_sym___alignof] = ACTIONS(3214),
    [anon_sym__alignof] = ACTIONS(3214),
    [anon_sym_alignof] = ACTIONS(3214),
    [anon_sym__Alignof] = ACTIONS(3214),
    [anon_sym_offsetof] = ACTIONS(3214),
    [anon_sym__Generic] = ACTIONS(3214),
    [anon_sym_asm] = ACTIONS(3214),
    [anon_sym___asm__] = ACTIONS(3214),
    [sym_number_literal] = ACTIONS(3216),
    [anon_sym_L_SQUOTE] = ACTIONS(3216),
    [anon_sym_u_SQUOTE] = ACTIONS(3216),
    [anon_sym_U_SQUOTE] = ACTIONS(3216),
    [anon_sym_u8_SQUOTE] = ACTIONS(3216),
    [anon_sym_SQUOTE] = ACTIONS(3216),
    [anon_sym_L_DQUOTE] = ACTIONS(3216),
    [anon_sym_u_DQUOTE] = ACTIONS(3216),
    [anon_sym_U_DQUOTE] = ACTIONS(3216),
    [anon_sym_u8_DQUOTE] = ACTIONS(3216),
    [anon_sym_DQUOTE] = ACTIONS(3216),
    [sym_true] = ACTIONS(3214),
    [sym_false] = ACTIONS(3214),
    [anon_sym_NULL] = ACTIONS(3214),
    [anon_sym_nullptr] = ACTIONS(3214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3214),
    [anon_sym_let] = ACTIONS(3214),
    [anon_sym_This] = ACTIONS(3214),
    [anon_sym_decltype] = ACTIONS(3214),
    [sym_virtual] = ACTIONS(3214),
    [anon_sym_explicit] = ACTIONS(3214),
    [anon_sym_typename] = ACTIONS(3214),
    [anon_sym_template] = ACTIONS(3214),
    [anon_sym_operator] = ACTIONS(3214),
    [anon_sym_try] = ACTIONS(3214),
    [anon_sym_delete] = ACTIONS(3214),
    [anon_sym_throw] = ACTIONS(3214),
    [anon_sym_namespace] = ACTIONS(3214),
    [anon_sym_using] = ACTIONS(3214),
    [anon_sym_static_assert] = ACTIONS(3214),
    [anon_sym_concept] = ACTIONS(3214),
    [anon_sym_co_return] = ACTIONS(3214),
    [anon_sym_co_yield] = ACTIONS(3214),
    [anon_sym_R_DQUOTE] = ACTIONS(3216),
    [anon_sym_LR_DQUOTE] = ACTIONS(3216),
    [anon_sym_uR_DQUOTE] = ACTIONS(3216),
    [anon_sym_UR_DQUOTE] = ACTIONS(3216),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3216),
    [anon_sym_co_await] = ACTIONS(3214),
    [anon_sym_new] = ACTIONS(3214),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(3214),
    [anon_sym_discard] = ACTIONS(3214),
    [anon_sym_precise] = ACTIONS(3214),
    [anon_sym_shared] = ACTIONS(3214),
    [anon_sym_groupshared] = ACTIONS(3214),
    [anon_sym_uniform] = ACTIONS(3214),
    [anon_sym_row_major] = ACTIONS(3214),
    [anon_sym_column_major] = ACTIONS(3214),
    [anon_sym_globallycoherent] = ACTIONS(3214),
    [anon_sym_centroid] = ACTIONS(3214),
    [anon_sym_noperspective] = ACTIONS(3214),
    [anon_sym_nointerpolation] = ACTIONS(3214),
    [anon_sym_sample] = ACTIONS(3214),
    [anon_sym_linear] = ACTIONS(3214),
    [anon_sym_snorm] = ACTIONS(3214),
    [anon_sym_unorm] = ACTIONS(3214),
    [anon_sym_point] = ACTIONS(3214),
    [anon_sym_line] = ACTIONS(3214),
    [anon_sym_triangleadj] = ACTIONS(3214),
    [anon_sym_lineadj] = ACTIONS(3214),
    [anon_sym_triangle] = ACTIONS(3214),
    [anon_sym_cbuffer] = ACTIONS(3214),
    [anon_sym_interface] = ACTIONS(3214),
    [anon_sym_extension] = ACTIONS(3214),
  },
  [786] = {
    [sym_identifier] = ACTIONS(3314),
    [aux_sym_preproc_include_token1] = ACTIONS(3314),
    [aux_sym_preproc_def_token1] = ACTIONS(3314),
    [aux_sym_preproc_if_token1] = ACTIONS(3314),
    [aux_sym_preproc_if_token2] = ACTIONS(3314),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3314),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3314),
    [sym_preproc_directive] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3316),
    [anon_sym_BANG] = ACTIONS(3316),
    [anon_sym_TILDE] = ACTIONS(3316),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_STAR] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_SEMI] = ACTIONS(3316),
    [anon_sym___extension__] = ACTIONS(3314),
    [anon_sym_typedef] = ACTIONS(3314),
    [anon_sym_in] = ACTIONS(3314),
    [anon_sym_out] = ACTIONS(3314),
    [anon_sym_inout] = ACTIONS(3314),
    [anon_sym_extern] = ACTIONS(3314),
    [anon_sym___attribute__] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3316),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3316),
    [anon_sym___declspec] = ACTIONS(3314),
    [anon_sym___based] = ACTIONS(3314),
    [anon_sym___cdecl] = ACTIONS(3314),
    [anon_sym___clrcall] = ACTIONS(3314),
    [anon_sym___stdcall] = ACTIONS(3314),
    [anon_sym___fastcall] = ACTIONS(3314),
    [anon_sym___thiscall] = ACTIONS(3314),
    [anon_sym___vectorcall] = ACTIONS(3314),
    [anon_sym_LBRACE] = ACTIONS(3316),
    [anon_sym_signed] = ACTIONS(3314),
    [anon_sym_unsigned] = ACTIONS(3314),
    [anon_sym_long] = ACTIONS(3314),
    [anon_sym_short] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_static] = ACTIONS(3314),
    [anon_sym_register] = ACTIONS(3314),
    [anon_sym_inline] = ACTIONS(3314),
    [anon_sym___inline] = ACTIONS(3314),
    [anon_sym___inline__] = ACTIONS(3314),
    [anon_sym___forceinline] = ACTIONS(3314),
    [anon_sym_thread_local] = ACTIONS(3314),
    [anon_sym___thread] = ACTIONS(3314),
    [anon_sym_const] = ACTIONS(3314),
    [anon_sym_constexpr] = ACTIONS(3314),
    [anon_sym_volatile] = ACTIONS(3314),
    [anon_sym_restrict] = ACTIONS(3314),
    [anon_sym___restrict__] = ACTIONS(3314),
    [anon_sym__Atomic] = ACTIONS(3314),
    [anon_sym__Noreturn] = ACTIONS(3314),
    [anon_sym_noreturn] = ACTIONS(3314),
    [anon_sym_mutable] = ACTIONS(3314),
    [anon_sym_constinit] = ACTIONS(3314),
    [anon_sym_consteval] = ACTIONS(3314),
    [anon_sym_alignas] = ACTIONS(3314),
    [anon_sym__Alignas] = ACTIONS(3314),
    [sym_primitive_type] = ACTIONS(3314),
    [anon_sym_enum] = ACTIONS(3314),
    [anon_sym_class] = ACTIONS(3314),
    [anon_sym_struct] = ACTIONS(3314),
    [anon_sym_union] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_else] = ACTIONS(3314),
    [anon_sym_switch] = ACTIONS(3314),
    [anon_sym_case] = ACTIONS(3314),
    [anon_sym_default] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_break] = ACTIONS(3314),
    [anon_sym_continue] = ACTIONS(3314),
    [anon_sym_goto] = ACTIONS(3314),
    [anon_sym___try] = ACTIONS(3314),
    [anon_sym___leave] = ACTIONS(3314),
    [anon_sym_not] = ACTIONS(3314),
    [anon_sym_compl] = ACTIONS(3314),
    [anon_sym_DASH_DASH] = ACTIONS(3316),
    [anon_sym_PLUS_PLUS] = ACTIONS(3316),
    [anon_sym_sizeof] = ACTIONS(3314),
    [anon_sym___alignof__] = ACTIONS(3314),
    [anon_sym___alignof] = ACTIONS(3314),
    [anon_sym__alignof] = ACTIONS(3314),
    [anon_sym_alignof] = ACTIONS(3314),
    [anon_sym__Alignof] = ACTIONS(3314),
    [anon_sym_offsetof] = ACTIONS(3314),
    [anon_sym__Generic] = ACTIONS(3314),
    [anon_sym_asm] = ACTIONS(3314),
    [anon_sym___asm__] = ACTIONS(3314),
    [sym_number_literal] = ACTIONS(3316),
    [anon_sym_L_SQUOTE] = ACTIONS(3316),
    [anon_sym_u_SQUOTE] = ACTIONS(3316),
    [anon_sym_U_SQUOTE] = ACTIONS(3316),
    [anon_sym_u8_SQUOTE] = ACTIONS(3316),
    [anon_sym_SQUOTE] = ACTIONS(3316),
    [anon_sym_L_DQUOTE] = ACTIONS(3316),
    [anon_sym_u_DQUOTE] = ACTIONS(3316),
    [anon_sym_U_DQUOTE] = ACTIONS(3316),
    [anon_sym_u8_DQUOTE] = ACTIONS(3316),
    [anon_sym_DQUOTE] = ACTIONS(3316),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [anon_sym_NULL] = ACTIONS(3314),
    [anon_sym_nullptr] = ACTIONS(3314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_This] = ACTIONS(3314),
    [anon_sym_decltype] = ACTIONS(3314),
    [sym_virtual] = ACTIONS(3314),
    [anon_sym_explicit] = ACTIONS(3314),
    [anon_sym_typename] = ACTIONS(3314),
    [anon_sym_template] = ACTIONS(3314),
    [anon_sym_operator] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_delete] = ACTIONS(3314),
    [anon_sym_throw] = ACTIONS(3314),
    [anon_sym_namespace] = ACTIONS(3314),
    [anon_sym_using] = ACTIONS(3314),
    [anon_sym_static_assert] = ACTIONS(3314),
    [anon_sym_concept] = ACTIONS(3314),
    [anon_sym_co_return] = ACTIONS(3314),
    [anon_sym_co_yield] = ACTIONS(3314),
    [anon_sym_R_DQUOTE] = ACTIONS(3316),
    [anon_sym_LR_DQUOTE] = ACTIONS(3316),
    [anon_sym_uR_DQUOTE] = ACTIONS(3316),
    [anon_sym_UR_DQUOTE] = ACTIONS(3316),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3316),
    [anon_sym_co_await] = ACTIONS(3314),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_requires] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [anon_sym_discard] = ACTIONS(3314),
    [anon_sym_precise] = ACTIONS(3314),
    [anon_sym_shared] = ACTIONS(3314),
    [anon_sym_groupshared] = ACTIONS(3314),
    [anon_sym_uniform] = ACTIONS(3314),
    [anon_sym_row_major] = ACTIONS(3314),
    [anon_sym_column_major] = ACTIONS(3314),
    [anon_sym_globallycoherent] = ACTIONS(3314),
    [anon_sym_centroid] = ACTIONS(3314),
    [anon_sym_noperspective] = ACTIONS(3314),
    [anon_sym_nointerpolation] = ACTIONS(3314),
    [anon_sym_sample] = ACTIONS(3314),
    [anon_sym_linear] = ACTIONS(3314),
    [anon_sym_snorm] = ACTIONS(3314),
    [anon_sym_unorm] = ACTIONS(3314),
    [anon_sym_point] = ACTIONS(3314),
    [anon_sym_line] = ACTIONS(3314),
    [anon_sym_triangleadj] = ACTIONS(3314),
    [anon_sym_lineadj] = ACTIONS(3314),
    [anon_sym_triangle] = ACTIONS(3314),
    [anon_sym_cbuffer] = ACTIONS(3314),
    [anon_sym_interface] = ACTIONS(3314),
    [anon_sym_extension] = ACTIONS(3314),
  },
  [787] = {
    [sym_identifier] = ACTIONS(3298),
    [aux_sym_preproc_include_token1] = ACTIONS(3298),
    [aux_sym_preproc_def_token1] = ACTIONS(3298),
    [aux_sym_preproc_if_token1] = ACTIONS(3298),
    [aux_sym_preproc_if_token2] = ACTIONS(3298),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3298),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3298),
    [sym_preproc_directive] = ACTIONS(3298),
    [anon_sym_LPAREN2] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3298),
    [anon_sym_PLUS] = ACTIONS(3298),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_AMP_AMP] = ACTIONS(3300),
    [anon_sym_AMP] = ACTIONS(3298),
    [anon_sym_SEMI] = ACTIONS(3300),
    [anon_sym___extension__] = ACTIONS(3298),
    [anon_sym_typedef] = ACTIONS(3298),
    [anon_sym_in] = ACTIONS(3298),
    [anon_sym_out] = ACTIONS(3298),
    [anon_sym_inout] = ACTIONS(3298),
    [anon_sym_extern] = ACTIONS(3298),
    [anon_sym___attribute__] = ACTIONS(3298),
    [anon_sym_COLON_COLON] = ACTIONS(3300),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3300),
    [anon_sym___declspec] = ACTIONS(3298),
    [anon_sym___based] = ACTIONS(3298),
    [anon_sym___cdecl] = ACTIONS(3298),
    [anon_sym___clrcall] = ACTIONS(3298),
    [anon_sym___stdcall] = ACTIONS(3298),
    [anon_sym___fastcall] = ACTIONS(3298),
    [anon_sym___thiscall] = ACTIONS(3298),
    [anon_sym___vectorcall] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_signed] = ACTIONS(3298),
    [anon_sym_unsigned] = ACTIONS(3298),
    [anon_sym_long] = ACTIONS(3298),
    [anon_sym_short] = ACTIONS(3298),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_static] = ACTIONS(3298),
    [anon_sym_register] = ACTIONS(3298),
    [anon_sym_inline] = ACTIONS(3298),
    [anon_sym___inline] = ACTIONS(3298),
    [anon_sym___inline__] = ACTIONS(3298),
    [anon_sym___forceinline] = ACTIONS(3298),
    [anon_sym_thread_local] = ACTIONS(3298),
    [anon_sym___thread] = ACTIONS(3298),
    [anon_sym_const] = ACTIONS(3298),
    [anon_sym_constexpr] = ACTIONS(3298),
    [anon_sym_volatile] = ACTIONS(3298),
    [anon_sym_restrict] = ACTIONS(3298),
    [anon_sym___restrict__] = ACTIONS(3298),
    [anon_sym__Atomic] = ACTIONS(3298),
    [anon_sym__Noreturn] = ACTIONS(3298),
    [anon_sym_noreturn] = ACTIONS(3298),
    [anon_sym_mutable] = ACTIONS(3298),
    [anon_sym_constinit] = ACTIONS(3298),
    [anon_sym_consteval] = ACTIONS(3298),
    [anon_sym_alignas] = ACTIONS(3298),
    [anon_sym__Alignas] = ACTIONS(3298),
    [sym_primitive_type] = ACTIONS(3298),
    [anon_sym_enum] = ACTIONS(3298),
    [anon_sym_class] = ACTIONS(3298),
    [anon_sym_struct] = ACTIONS(3298),
    [anon_sym_union] = ACTIONS(3298),
    [anon_sym_if] = ACTIONS(3298),
    [anon_sym_else] = ACTIONS(3298),
    [anon_sym_switch] = ACTIONS(3298),
    [anon_sym_case] = ACTIONS(3298),
    [anon_sym_default] = ACTIONS(3298),
    [anon_sym_while] = ACTIONS(3298),
    [anon_sym_do] = ACTIONS(3298),
    [anon_sym_for] = ACTIONS(3298),
    [anon_sym_return] = ACTIONS(3298),
    [anon_sym_break] = ACTIONS(3298),
    [anon_sym_continue] = ACTIONS(3298),
    [anon_sym_goto] = ACTIONS(3298),
    [anon_sym___try] = ACTIONS(3298),
    [anon_sym___leave] = ACTIONS(3298),
    [anon_sym_not] = ACTIONS(3298),
    [anon_sym_compl] = ACTIONS(3298),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_sizeof] = ACTIONS(3298),
    [anon_sym___alignof__] = ACTIONS(3298),
    [anon_sym___alignof] = ACTIONS(3298),
    [anon_sym__alignof] = ACTIONS(3298),
    [anon_sym_alignof] = ACTIONS(3298),
    [anon_sym__Alignof] = ACTIONS(3298),
    [anon_sym_offsetof] = ACTIONS(3298),
    [anon_sym__Generic] = ACTIONS(3298),
    [anon_sym_asm] = ACTIONS(3298),
    [anon_sym___asm__] = ACTIONS(3298),
    [sym_number_literal] = ACTIONS(3300),
    [anon_sym_L_SQUOTE] = ACTIONS(3300),
    [anon_sym_u_SQUOTE] = ACTIONS(3300),
    [anon_sym_U_SQUOTE] = ACTIONS(3300),
    [anon_sym_u8_SQUOTE] = ACTIONS(3300),
    [anon_sym_SQUOTE] = ACTIONS(3300),
    [anon_sym_L_DQUOTE] = ACTIONS(3300),
    [anon_sym_u_DQUOTE] = ACTIONS(3300),
    [anon_sym_U_DQUOTE] = ACTIONS(3300),
    [anon_sym_u8_DQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [sym_true] = ACTIONS(3298),
    [sym_false] = ACTIONS(3298),
    [anon_sym_NULL] = ACTIONS(3298),
    [anon_sym_nullptr] = ACTIONS(3298),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3298),
    [anon_sym_let] = ACTIONS(3298),
    [anon_sym_This] = ACTIONS(3298),
    [anon_sym_decltype] = ACTIONS(3298),
    [sym_virtual] = ACTIONS(3298),
    [anon_sym_explicit] = ACTIONS(3298),
    [anon_sym_typename] = ACTIONS(3298),
    [anon_sym_template] = ACTIONS(3298),
    [anon_sym_operator] = ACTIONS(3298),
    [anon_sym_try] = ACTIONS(3298),
    [anon_sym_delete] = ACTIONS(3298),
    [anon_sym_throw] = ACTIONS(3298),
    [anon_sym_namespace] = ACTIONS(3298),
    [anon_sym_using] = ACTIONS(3298),
    [anon_sym_static_assert] = ACTIONS(3298),
    [anon_sym_concept] = ACTIONS(3298),
    [anon_sym_co_return] = ACTIONS(3298),
    [anon_sym_co_yield] = ACTIONS(3298),
    [anon_sym_R_DQUOTE] = ACTIONS(3300),
    [anon_sym_LR_DQUOTE] = ACTIONS(3300),
    [anon_sym_uR_DQUOTE] = ACTIONS(3300),
    [anon_sym_UR_DQUOTE] = ACTIONS(3300),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3300),
    [anon_sym_co_await] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3298),
    [anon_sym_requires] = ACTIONS(3298),
    [sym_this] = ACTIONS(3298),
    [anon_sym_discard] = ACTIONS(3298),
    [anon_sym_precise] = ACTIONS(3298),
    [anon_sym_shared] = ACTIONS(3298),
    [anon_sym_groupshared] = ACTIONS(3298),
    [anon_sym_uniform] = ACTIONS(3298),
    [anon_sym_row_major] = ACTIONS(3298),
    [anon_sym_column_major] = ACTIONS(3298),
    [anon_sym_globallycoherent] = ACTIONS(3298),
    [anon_sym_centroid] = ACTIONS(3298),
    [anon_sym_noperspective] = ACTIONS(3298),
    [anon_sym_nointerpolation] = ACTIONS(3298),
    [anon_sym_sample] = ACTIONS(3298),
    [anon_sym_linear] = ACTIONS(3298),
    [anon_sym_snorm] = ACTIONS(3298),
    [anon_sym_unorm] = ACTIONS(3298),
    [anon_sym_point] = ACTIONS(3298),
    [anon_sym_line] = ACTIONS(3298),
    [anon_sym_triangleadj] = ACTIONS(3298),
    [anon_sym_lineadj] = ACTIONS(3298),
    [anon_sym_triangle] = ACTIONS(3298),
    [anon_sym_cbuffer] = ACTIONS(3298),
    [anon_sym_interface] = ACTIONS(3298),
    [anon_sym_extension] = ACTIONS(3298),
  },
  [788] = {
    [sym_identifier] = ACTIONS(3214),
    [aux_sym_preproc_include_token1] = ACTIONS(3214),
    [aux_sym_preproc_def_token1] = ACTIONS(3214),
    [aux_sym_preproc_if_token1] = ACTIONS(3214),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3214),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3214),
    [sym_preproc_directive] = ACTIONS(3214),
    [anon_sym_LPAREN2] = ACTIONS(3216),
    [anon_sym_BANG] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_DASH] = ACTIONS(3214),
    [anon_sym_PLUS] = ACTIONS(3214),
    [anon_sym_STAR] = ACTIONS(3216),
    [anon_sym_AMP_AMP] = ACTIONS(3216),
    [anon_sym_AMP] = ACTIONS(3214),
    [anon_sym_SEMI] = ACTIONS(3216),
    [anon_sym___extension__] = ACTIONS(3214),
    [anon_sym_typedef] = ACTIONS(3214),
    [anon_sym_in] = ACTIONS(3214),
    [anon_sym_out] = ACTIONS(3214),
    [anon_sym_inout] = ACTIONS(3214),
    [anon_sym_extern] = ACTIONS(3214),
    [anon_sym___attribute__] = ACTIONS(3214),
    [anon_sym_COLON_COLON] = ACTIONS(3216),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3216),
    [anon_sym___declspec] = ACTIONS(3214),
    [anon_sym___based] = ACTIONS(3214),
    [anon_sym___cdecl] = ACTIONS(3214),
    [anon_sym___clrcall] = ACTIONS(3214),
    [anon_sym___stdcall] = ACTIONS(3214),
    [anon_sym___fastcall] = ACTIONS(3214),
    [anon_sym___thiscall] = ACTIONS(3214),
    [anon_sym___vectorcall] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3216),
    [anon_sym_RBRACE] = ACTIONS(3216),
    [anon_sym_signed] = ACTIONS(3214),
    [anon_sym_unsigned] = ACTIONS(3214),
    [anon_sym_long] = ACTIONS(3214),
    [anon_sym_short] = ACTIONS(3214),
    [anon_sym_LBRACK] = ACTIONS(3214),
    [anon_sym_static] = ACTIONS(3214),
    [anon_sym_register] = ACTIONS(3214),
    [anon_sym_inline] = ACTIONS(3214),
    [anon_sym___inline] = ACTIONS(3214),
    [anon_sym___inline__] = ACTIONS(3214),
    [anon_sym___forceinline] = ACTIONS(3214),
    [anon_sym_thread_local] = ACTIONS(3214),
    [anon_sym___thread] = ACTIONS(3214),
    [anon_sym_const] = ACTIONS(3214),
    [anon_sym_constexpr] = ACTIONS(3214),
    [anon_sym_volatile] = ACTIONS(3214),
    [anon_sym_restrict] = ACTIONS(3214),
    [anon_sym___restrict__] = ACTIONS(3214),
    [anon_sym__Atomic] = ACTIONS(3214),
    [anon_sym__Noreturn] = ACTIONS(3214),
    [anon_sym_noreturn] = ACTIONS(3214),
    [anon_sym_mutable] = ACTIONS(3214),
    [anon_sym_constinit] = ACTIONS(3214),
    [anon_sym_consteval] = ACTIONS(3214),
    [anon_sym_alignas] = ACTIONS(3214),
    [anon_sym__Alignas] = ACTIONS(3214),
    [sym_primitive_type] = ACTIONS(3214),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3214),
    [anon_sym_struct] = ACTIONS(3214),
    [anon_sym_union] = ACTIONS(3214),
    [anon_sym_if] = ACTIONS(3214),
    [anon_sym_else] = ACTIONS(3214),
    [anon_sym_switch] = ACTIONS(3214),
    [anon_sym_case] = ACTIONS(3214),
    [anon_sym_default] = ACTIONS(3214),
    [anon_sym_while] = ACTIONS(3214),
    [anon_sym_do] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3214),
    [anon_sym_return] = ACTIONS(3214),
    [anon_sym_break] = ACTIONS(3214),
    [anon_sym_continue] = ACTIONS(3214),
    [anon_sym_goto] = ACTIONS(3214),
    [anon_sym___try] = ACTIONS(3214),
    [anon_sym___leave] = ACTIONS(3214),
    [anon_sym_not] = ACTIONS(3214),
    [anon_sym_compl] = ACTIONS(3214),
    [anon_sym_DASH_DASH] = ACTIONS(3216),
    [anon_sym_PLUS_PLUS] = ACTIONS(3216),
    [anon_sym_sizeof] = ACTIONS(3214),
    [anon_sym___alignof__] = ACTIONS(3214),
    [anon_sym___alignof] = ACTIONS(3214),
    [anon_sym__alignof] = ACTIONS(3214),
    [anon_sym_alignof] = ACTIONS(3214),
    [anon_sym__Alignof] = ACTIONS(3214),
    [anon_sym_offsetof] = ACTIONS(3214),
    [anon_sym__Generic] = ACTIONS(3214),
    [anon_sym_asm] = ACTIONS(3214),
    [anon_sym___asm__] = ACTIONS(3214),
    [sym_number_literal] = ACTIONS(3216),
    [anon_sym_L_SQUOTE] = ACTIONS(3216),
    [anon_sym_u_SQUOTE] = ACTIONS(3216),
    [anon_sym_U_SQUOTE] = ACTIONS(3216),
    [anon_sym_u8_SQUOTE] = ACTIONS(3216),
    [anon_sym_SQUOTE] = ACTIONS(3216),
    [anon_sym_L_DQUOTE] = ACTIONS(3216),
    [anon_sym_u_DQUOTE] = ACTIONS(3216),
    [anon_sym_U_DQUOTE] = ACTIONS(3216),
    [anon_sym_u8_DQUOTE] = ACTIONS(3216),
    [anon_sym_DQUOTE] = ACTIONS(3216),
    [sym_true] = ACTIONS(3214),
    [sym_false] = ACTIONS(3214),
    [anon_sym_NULL] = ACTIONS(3214),
    [anon_sym_nullptr] = ACTIONS(3214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3214),
    [anon_sym_let] = ACTIONS(3214),
    [anon_sym_This] = ACTIONS(3214),
    [anon_sym_decltype] = ACTIONS(3214),
    [sym_virtual] = ACTIONS(3214),
    [anon_sym_explicit] = ACTIONS(3214),
    [anon_sym_typename] = ACTIONS(3214),
    [anon_sym_template] = ACTIONS(3214),
    [anon_sym_operator] = ACTIONS(3214),
    [anon_sym_try] = ACTIONS(3214),
    [anon_sym_delete] = ACTIONS(3214),
    [anon_sym_throw] = ACTIONS(3214),
    [anon_sym_namespace] = ACTIONS(3214),
    [anon_sym_using] = ACTIONS(3214),
    [anon_sym_static_assert] = ACTIONS(3214),
    [anon_sym_concept] = ACTIONS(3214),
    [anon_sym_co_return] = ACTIONS(3214),
    [anon_sym_co_yield] = ACTIONS(3214),
    [anon_sym_R_DQUOTE] = ACTIONS(3216),
    [anon_sym_LR_DQUOTE] = ACTIONS(3216),
    [anon_sym_uR_DQUOTE] = ACTIONS(3216),
    [anon_sym_UR_DQUOTE] = ACTIONS(3216),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3216),
    [anon_sym_co_await] = ACTIONS(3214),
    [anon_sym_new] = ACTIONS(3214),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(3214),
    [anon_sym_discard] = ACTIONS(3214),
    [anon_sym_precise] = ACTIONS(3214),
    [anon_sym_shared] = ACTIONS(3214),
    [anon_sym_groupshared] = ACTIONS(3214),
    [anon_sym_uniform] = ACTIONS(3214),
    [anon_sym_row_major] = ACTIONS(3214),
    [anon_sym_column_major] = ACTIONS(3214),
    [anon_sym_globallycoherent] = ACTIONS(3214),
    [anon_sym_centroid] = ACTIONS(3214),
    [anon_sym_noperspective] = ACTIONS(3214),
    [anon_sym_nointerpolation] = ACTIONS(3214),
    [anon_sym_sample] = ACTIONS(3214),
    [anon_sym_linear] = ACTIONS(3214),
    [anon_sym_snorm] = ACTIONS(3214),
    [anon_sym_unorm] = ACTIONS(3214),
    [anon_sym_point] = ACTIONS(3214),
    [anon_sym_line] = ACTIONS(3214),
    [anon_sym_triangleadj] = ACTIONS(3214),
    [anon_sym_lineadj] = ACTIONS(3214),
    [anon_sym_triangle] = ACTIONS(3214),
    [anon_sym_cbuffer] = ACTIONS(3214),
    [anon_sym_interface] = ACTIONS(3214),
    [anon_sym_extension] = ACTIONS(3214),
  },
  [789] = {
    [sym_identifier] = ACTIONS(2742),
    [aux_sym_preproc_include_token1] = ACTIONS(2742),
    [aux_sym_preproc_def_token1] = ACTIONS(2742),
    [aux_sym_preproc_if_token1] = ACTIONS(2742),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2742),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2742),
    [sym_preproc_directive] = ACTIONS(2742),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_BANG] = ACTIONS(2740),
    [anon_sym_TILDE] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2742),
    [anon_sym_PLUS] = ACTIONS(2742),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym___extension__] = ACTIONS(2742),
    [anon_sym_typedef] = ACTIONS(2742),
    [anon_sym_in] = ACTIONS(2742),
    [anon_sym_out] = ACTIONS(2742),
    [anon_sym_inout] = ACTIONS(2742),
    [anon_sym_extern] = ACTIONS(2742),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym_COLON_COLON] = ACTIONS(2740),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2740),
    [anon_sym___declspec] = ACTIONS(2742),
    [anon_sym___based] = ACTIONS(2742),
    [anon_sym___cdecl] = ACTIONS(2742),
    [anon_sym___clrcall] = ACTIONS(2742),
    [anon_sym___stdcall] = ACTIONS(2742),
    [anon_sym___fastcall] = ACTIONS(2742),
    [anon_sym___thiscall] = ACTIONS(2742),
    [anon_sym___vectorcall] = ACTIONS(2742),
    [anon_sym_LBRACE] = ACTIONS(3911),
    [anon_sym_RBRACE] = ACTIONS(2740),
    [anon_sym_signed] = ACTIONS(2742),
    [anon_sym_unsigned] = ACTIONS(2742),
    [anon_sym_long] = ACTIONS(2742),
    [anon_sym_short] = ACTIONS(2742),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2742),
    [anon_sym_register] = ACTIONS(2742),
    [anon_sym_inline] = ACTIONS(2742),
    [anon_sym___inline] = ACTIONS(2742),
    [anon_sym___inline__] = ACTIONS(2742),
    [anon_sym___forceinline] = ACTIONS(2742),
    [anon_sym_thread_local] = ACTIONS(2742),
    [anon_sym___thread] = ACTIONS(2742),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_constexpr] = ACTIONS(2742),
    [anon_sym_volatile] = ACTIONS(2742),
    [anon_sym_restrict] = ACTIONS(2742),
    [anon_sym___restrict__] = ACTIONS(2742),
    [anon_sym__Atomic] = ACTIONS(2742),
    [anon_sym__Noreturn] = ACTIONS(2742),
    [anon_sym_noreturn] = ACTIONS(2742),
    [anon_sym_mutable] = ACTIONS(2742),
    [anon_sym_constinit] = ACTIONS(2742),
    [anon_sym_consteval] = ACTIONS(2742),
    [anon_sym_alignas] = ACTIONS(2742),
    [anon_sym__Alignas] = ACTIONS(2742),
    [sym_primitive_type] = ACTIONS(2742),
    [anon_sym_enum] = ACTIONS(2742),
    [anon_sym_class] = ACTIONS(2742),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2742),
    [anon_sym_if] = ACTIONS(2742),
    [anon_sym_switch] = ACTIONS(2742),
    [anon_sym_case] = ACTIONS(2742),
    [anon_sym_default] = ACTIONS(2742),
    [anon_sym_while] = ACTIONS(2742),
    [anon_sym_do] = ACTIONS(2742),
    [anon_sym_for] = ACTIONS(2742),
    [anon_sym_return] = ACTIONS(2742),
    [anon_sym_break] = ACTIONS(2742),
    [anon_sym_continue] = ACTIONS(2742),
    [anon_sym_goto] = ACTIONS(2742),
    [anon_sym___try] = ACTIONS(2742),
    [anon_sym___leave] = ACTIONS(2742),
    [anon_sym_not] = ACTIONS(2742),
    [anon_sym_compl] = ACTIONS(2742),
    [anon_sym_DASH_DASH] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2740),
    [anon_sym_sizeof] = ACTIONS(2742),
    [anon_sym___alignof__] = ACTIONS(2742),
    [anon_sym___alignof] = ACTIONS(2742),
    [anon_sym__alignof] = ACTIONS(2742),
    [anon_sym_alignof] = ACTIONS(2742),
    [anon_sym__Alignof] = ACTIONS(2742),
    [anon_sym_offsetof] = ACTIONS(2742),
    [anon_sym__Generic] = ACTIONS(2742),
    [anon_sym_asm] = ACTIONS(2742),
    [anon_sym___asm__] = ACTIONS(2742),
    [anon_sym_DOT] = ACTIONS(2742),
    [sym_number_literal] = ACTIONS(2740),
    [anon_sym_L_SQUOTE] = ACTIONS(2740),
    [anon_sym_u_SQUOTE] = ACTIONS(2740),
    [anon_sym_U_SQUOTE] = ACTIONS(2740),
    [anon_sym_u8_SQUOTE] = ACTIONS(2740),
    [anon_sym_SQUOTE] = ACTIONS(2740),
    [anon_sym_L_DQUOTE] = ACTIONS(2740),
    [anon_sym_u_DQUOTE] = ACTIONS(2740),
    [anon_sym_U_DQUOTE] = ACTIONS(2740),
    [anon_sym_u8_DQUOTE] = ACTIONS(2740),
    [anon_sym_DQUOTE] = ACTIONS(2740),
    [sym_true] = ACTIONS(2742),
    [sym_false] = ACTIONS(2742),
    [anon_sym_NULL] = ACTIONS(2742),
    [anon_sym_nullptr] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
    [anon_sym_decltype] = ACTIONS(2742),
    [sym_virtual] = ACTIONS(2742),
    [anon_sym_explicit] = ACTIONS(2742),
    [anon_sym_typename] = ACTIONS(2742),
    [anon_sym_template] = ACTIONS(2742),
    [anon_sym_operator] = ACTIONS(2742),
    [anon_sym_try] = ACTIONS(2742),
    [anon_sym_delete] = ACTIONS(2742),
    [anon_sym_throw] = ACTIONS(2742),
    [anon_sym_namespace] = ACTIONS(2742),
    [anon_sym_using] = ACTIONS(2742),
    [anon_sym_static_assert] = ACTIONS(2742),
    [anon_sym_concept] = ACTIONS(2742),
    [anon_sym_co_return] = ACTIONS(2742),
    [anon_sym_co_yield] = ACTIONS(2742),
    [anon_sym_R_DQUOTE] = ACTIONS(2740),
    [anon_sym_LR_DQUOTE] = ACTIONS(2740),
    [anon_sym_uR_DQUOTE] = ACTIONS(2740),
    [anon_sym_UR_DQUOTE] = ACTIONS(2740),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2740),
    [anon_sym_co_await] = ACTIONS(2742),
    [anon_sym_new] = ACTIONS(2742),
    [anon_sym_requires] = ACTIONS(2742),
    [sym_this] = ACTIONS(2742),
    [anon_sym_discard] = ACTIONS(2742),
    [anon_sym_precise] = ACTIONS(2742),
    [anon_sym_shared] = ACTIONS(2742),
    [anon_sym_groupshared] = ACTIONS(2742),
    [anon_sym_uniform] = ACTIONS(2742),
    [anon_sym_row_major] = ACTIONS(2742),
    [anon_sym_column_major] = ACTIONS(2742),
    [anon_sym_globallycoherent] = ACTIONS(2742),
    [anon_sym_centroid] = ACTIONS(2742),
    [anon_sym_noperspective] = ACTIONS(2742),
    [anon_sym_nointerpolation] = ACTIONS(2742),
    [anon_sym_sample] = ACTIONS(2742),
    [anon_sym_linear] = ACTIONS(2742),
    [anon_sym_snorm] = ACTIONS(2742),
    [anon_sym_unorm] = ACTIONS(2742),
    [anon_sym_point] = ACTIONS(2742),
    [anon_sym_line] = ACTIONS(2742),
    [anon_sym_triangleadj] = ACTIONS(2742),
    [anon_sym_lineadj] = ACTIONS(2742),
    [anon_sym_triangle] = ACTIONS(2742),
    [anon_sym_cbuffer] = ACTIONS(2742),
    [anon_sym_interface] = ACTIONS(2742),
    [anon_sym_extension] = ACTIONS(2742),
  },
  [790] = {
    [sym_identifier] = ACTIONS(2898),
    [aux_sym_preproc_include_token1] = ACTIONS(2898),
    [aux_sym_preproc_def_token1] = ACTIONS(2898),
    [aux_sym_preproc_if_token1] = ACTIONS(2898),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2898),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2898),
    [sym_preproc_directive] = ACTIONS(2898),
    [anon_sym_LPAREN2] = ACTIONS(2900),
    [anon_sym_BANG] = ACTIONS(2900),
    [anon_sym_TILDE] = ACTIONS(2900),
    [anon_sym_DASH] = ACTIONS(2898),
    [anon_sym_PLUS] = ACTIONS(2898),
    [anon_sym_STAR] = ACTIONS(2900),
    [anon_sym_AMP_AMP] = ACTIONS(2900),
    [anon_sym_AMP] = ACTIONS(2898),
    [anon_sym_SEMI] = ACTIONS(2900),
    [anon_sym___extension__] = ACTIONS(2898),
    [anon_sym_typedef] = ACTIONS(2898),
    [anon_sym_in] = ACTIONS(2898),
    [anon_sym_out] = ACTIONS(2898),
    [anon_sym_inout] = ACTIONS(2898),
    [anon_sym_extern] = ACTIONS(2898),
    [anon_sym___attribute__] = ACTIONS(2898),
    [anon_sym_COLON_COLON] = ACTIONS(2900),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2900),
    [anon_sym___declspec] = ACTIONS(2898),
    [anon_sym___based] = ACTIONS(2898),
    [anon_sym___cdecl] = ACTIONS(2898),
    [anon_sym___clrcall] = ACTIONS(2898),
    [anon_sym___stdcall] = ACTIONS(2898),
    [anon_sym___fastcall] = ACTIONS(2898),
    [anon_sym___thiscall] = ACTIONS(2898),
    [anon_sym___vectorcall] = ACTIONS(2898),
    [anon_sym_LBRACE] = ACTIONS(2900),
    [anon_sym_RBRACE] = ACTIONS(2900),
    [anon_sym_signed] = ACTIONS(2898),
    [anon_sym_unsigned] = ACTIONS(2898),
    [anon_sym_long] = ACTIONS(2898),
    [anon_sym_short] = ACTIONS(2898),
    [anon_sym_LBRACK] = ACTIONS(2898),
    [anon_sym_static] = ACTIONS(2898),
    [anon_sym_register] = ACTIONS(2898),
    [anon_sym_inline] = ACTIONS(2898),
    [anon_sym___inline] = ACTIONS(2898),
    [anon_sym___inline__] = ACTIONS(2898),
    [anon_sym___forceinline] = ACTIONS(2898),
    [anon_sym_thread_local] = ACTIONS(2898),
    [anon_sym___thread] = ACTIONS(2898),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_constexpr] = ACTIONS(2898),
    [anon_sym_volatile] = ACTIONS(2898),
    [anon_sym_restrict] = ACTIONS(2898),
    [anon_sym___restrict__] = ACTIONS(2898),
    [anon_sym__Atomic] = ACTIONS(2898),
    [anon_sym__Noreturn] = ACTIONS(2898),
    [anon_sym_noreturn] = ACTIONS(2898),
    [anon_sym_mutable] = ACTIONS(2898),
    [anon_sym_constinit] = ACTIONS(2898),
    [anon_sym_consteval] = ACTIONS(2898),
    [anon_sym_alignas] = ACTIONS(2898),
    [anon_sym__Alignas] = ACTIONS(2898),
    [sym_primitive_type] = ACTIONS(2898),
    [anon_sym_enum] = ACTIONS(2898),
    [anon_sym_class] = ACTIONS(2898),
    [anon_sym_struct] = ACTIONS(2898),
    [anon_sym_union] = ACTIONS(2898),
    [anon_sym_if] = ACTIONS(2898),
    [anon_sym_else] = ACTIONS(2898),
    [anon_sym_switch] = ACTIONS(2898),
    [anon_sym_case] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2898),
    [anon_sym_while] = ACTIONS(2898),
    [anon_sym_do] = ACTIONS(2898),
    [anon_sym_for] = ACTIONS(2898),
    [anon_sym_return] = ACTIONS(2898),
    [anon_sym_break] = ACTIONS(2898),
    [anon_sym_continue] = ACTIONS(2898),
    [anon_sym_goto] = ACTIONS(2898),
    [anon_sym___try] = ACTIONS(2898),
    [anon_sym___leave] = ACTIONS(2898),
    [anon_sym_not] = ACTIONS(2898),
    [anon_sym_compl] = ACTIONS(2898),
    [anon_sym_DASH_DASH] = ACTIONS(2900),
    [anon_sym_PLUS_PLUS] = ACTIONS(2900),
    [anon_sym_sizeof] = ACTIONS(2898),
    [anon_sym___alignof__] = ACTIONS(2898),
    [anon_sym___alignof] = ACTIONS(2898),
    [anon_sym__alignof] = ACTIONS(2898),
    [anon_sym_alignof] = ACTIONS(2898),
    [anon_sym__Alignof] = ACTIONS(2898),
    [anon_sym_offsetof] = ACTIONS(2898),
    [anon_sym__Generic] = ACTIONS(2898),
    [anon_sym_asm] = ACTIONS(2898),
    [anon_sym___asm__] = ACTIONS(2898),
    [sym_number_literal] = ACTIONS(2900),
    [anon_sym_L_SQUOTE] = ACTIONS(2900),
    [anon_sym_u_SQUOTE] = ACTIONS(2900),
    [anon_sym_U_SQUOTE] = ACTIONS(2900),
    [anon_sym_u8_SQUOTE] = ACTIONS(2900),
    [anon_sym_SQUOTE] = ACTIONS(2900),
    [anon_sym_L_DQUOTE] = ACTIONS(2900),
    [anon_sym_u_DQUOTE] = ACTIONS(2900),
    [anon_sym_U_DQUOTE] = ACTIONS(2900),
    [anon_sym_u8_DQUOTE] = ACTIONS(2900),
    [anon_sym_DQUOTE] = ACTIONS(2900),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2898),
    [anon_sym_nullptr] = ACTIONS(2898),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2898),
    [anon_sym_let] = ACTIONS(2898),
    [anon_sym_This] = ACTIONS(2898),
    [anon_sym_decltype] = ACTIONS(2898),
    [sym_virtual] = ACTIONS(2898),
    [anon_sym_explicit] = ACTIONS(2898),
    [anon_sym_typename] = ACTIONS(2898),
    [anon_sym_template] = ACTIONS(2898),
    [anon_sym_operator] = ACTIONS(2898),
    [anon_sym_try] = ACTIONS(2898),
    [anon_sym_delete] = ACTIONS(2898),
    [anon_sym_throw] = ACTIONS(2898),
    [anon_sym_namespace] = ACTIONS(2898),
    [anon_sym_using] = ACTIONS(2898),
    [anon_sym_static_assert] = ACTIONS(2898),
    [anon_sym_concept] = ACTIONS(2898),
    [anon_sym_co_return] = ACTIONS(2898),
    [anon_sym_co_yield] = ACTIONS(2898),
    [anon_sym_R_DQUOTE] = ACTIONS(2900),
    [anon_sym_LR_DQUOTE] = ACTIONS(2900),
    [anon_sym_uR_DQUOTE] = ACTIONS(2900),
    [anon_sym_UR_DQUOTE] = ACTIONS(2900),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2900),
    [anon_sym_co_await] = ACTIONS(2898),
    [anon_sym_new] = ACTIONS(2898),
    [anon_sym_requires] = ACTIONS(2898),
    [sym_this] = ACTIONS(2898),
    [anon_sym_discard] = ACTIONS(2898),
    [anon_sym_precise] = ACTIONS(2898),
    [anon_sym_shared] = ACTIONS(2898),
    [anon_sym_groupshared] = ACTIONS(2898),
    [anon_sym_uniform] = ACTIONS(2898),
    [anon_sym_row_major] = ACTIONS(2898),
    [anon_sym_column_major] = ACTIONS(2898),
    [anon_sym_globallycoherent] = ACTIONS(2898),
    [anon_sym_centroid] = ACTIONS(2898),
    [anon_sym_noperspective] = ACTIONS(2898),
    [anon_sym_nointerpolation] = ACTIONS(2898),
    [anon_sym_sample] = ACTIONS(2898),
    [anon_sym_linear] = ACTIONS(2898),
    [anon_sym_snorm] = ACTIONS(2898),
    [anon_sym_unorm] = ACTIONS(2898),
    [anon_sym_point] = ACTIONS(2898),
    [anon_sym_line] = ACTIONS(2898),
    [anon_sym_triangleadj] = ACTIONS(2898),
    [anon_sym_lineadj] = ACTIONS(2898),
    [anon_sym_triangle] = ACTIONS(2898),
    [anon_sym_cbuffer] = ACTIONS(2898),
    [anon_sym_interface] = ACTIONS(2898),
    [anon_sym_extension] = ACTIONS(2898),
  },
  [791] = {
    [sym_identifier] = ACTIONS(3374),
    [aux_sym_preproc_include_token1] = ACTIONS(3374),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token2] = ACTIONS(3374),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3374),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3374),
    [sym_preproc_directive] = ACTIONS(3374),
    [anon_sym_LPAREN2] = ACTIONS(3376),
    [anon_sym_BANG] = ACTIONS(3376),
    [anon_sym_TILDE] = ACTIONS(3376),
    [anon_sym_DASH] = ACTIONS(3374),
    [anon_sym_PLUS] = ACTIONS(3374),
    [anon_sym_STAR] = ACTIONS(3376),
    [anon_sym_AMP_AMP] = ACTIONS(3376),
    [anon_sym_AMP] = ACTIONS(3374),
    [anon_sym_SEMI] = ACTIONS(3376),
    [anon_sym___extension__] = ACTIONS(3374),
    [anon_sym_typedef] = ACTIONS(3374),
    [anon_sym_in] = ACTIONS(3374),
    [anon_sym_out] = ACTIONS(3374),
    [anon_sym_inout] = ACTIONS(3374),
    [anon_sym_extern] = ACTIONS(3374),
    [anon_sym___attribute__] = ACTIONS(3374),
    [anon_sym_COLON_COLON] = ACTIONS(3376),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3376),
    [anon_sym___declspec] = ACTIONS(3374),
    [anon_sym___based] = ACTIONS(3374),
    [anon_sym___cdecl] = ACTIONS(3374),
    [anon_sym___clrcall] = ACTIONS(3374),
    [anon_sym___stdcall] = ACTIONS(3374),
    [anon_sym___fastcall] = ACTIONS(3374),
    [anon_sym___thiscall] = ACTIONS(3374),
    [anon_sym___vectorcall] = ACTIONS(3374),
    [anon_sym_LBRACE] = ACTIONS(3376),
    [anon_sym_signed] = ACTIONS(3374),
    [anon_sym_unsigned] = ACTIONS(3374),
    [anon_sym_long] = ACTIONS(3374),
    [anon_sym_short] = ACTIONS(3374),
    [anon_sym_LBRACK] = ACTIONS(3374),
    [anon_sym_static] = ACTIONS(3374),
    [anon_sym_register] = ACTIONS(3374),
    [anon_sym_inline] = ACTIONS(3374),
    [anon_sym___inline] = ACTIONS(3374),
    [anon_sym___inline__] = ACTIONS(3374),
    [anon_sym___forceinline] = ACTIONS(3374),
    [anon_sym_thread_local] = ACTIONS(3374),
    [anon_sym___thread] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3374),
    [anon_sym_constexpr] = ACTIONS(3374),
    [anon_sym_volatile] = ACTIONS(3374),
    [anon_sym_restrict] = ACTIONS(3374),
    [anon_sym___restrict__] = ACTIONS(3374),
    [anon_sym__Atomic] = ACTIONS(3374),
    [anon_sym__Noreturn] = ACTIONS(3374),
    [anon_sym_noreturn] = ACTIONS(3374),
    [anon_sym_mutable] = ACTIONS(3374),
    [anon_sym_constinit] = ACTIONS(3374),
    [anon_sym_consteval] = ACTIONS(3374),
    [anon_sym_alignas] = ACTIONS(3374),
    [anon_sym__Alignas] = ACTIONS(3374),
    [sym_primitive_type] = ACTIONS(3374),
    [anon_sym_enum] = ACTIONS(3374),
    [anon_sym_class] = ACTIONS(3374),
    [anon_sym_struct] = ACTIONS(3374),
    [anon_sym_union] = ACTIONS(3374),
    [anon_sym_if] = ACTIONS(3374),
    [anon_sym_else] = ACTIONS(3374),
    [anon_sym_switch] = ACTIONS(3374),
    [anon_sym_case] = ACTIONS(3374),
    [anon_sym_default] = ACTIONS(3374),
    [anon_sym_while] = ACTIONS(3374),
    [anon_sym_do] = ACTIONS(3374),
    [anon_sym_for] = ACTIONS(3374),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_break] = ACTIONS(3374),
    [anon_sym_continue] = ACTIONS(3374),
    [anon_sym_goto] = ACTIONS(3374),
    [anon_sym___try] = ACTIONS(3374),
    [anon_sym___leave] = ACTIONS(3374),
    [anon_sym_not] = ACTIONS(3374),
    [anon_sym_compl] = ACTIONS(3374),
    [anon_sym_DASH_DASH] = ACTIONS(3376),
    [anon_sym_PLUS_PLUS] = ACTIONS(3376),
    [anon_sym_sizeof] = ACTIONS(3374),
    [anon_sym___alignof__] = ACTIONS(3374),
    [anon_sym___alignof] = ACTIONS(3374),
    [anon_sym__alignof] = ACTIONS(3374),
    [anon_sym_alignof] = ACTIONS(3374),
    [anon_sym__Alignof] = ACTIONS(3374),
    [anon_sym_offsetof] = ACTIONS(3374),
    [anon_sym__Generic] = ACTIONS(3374),
    [anon_sym_asm] = ACTIONS(3374),
    [anon_sym___asm__] = ACTIONS(3374),
    [sym_number_literal] = ACTIONS(3376),
    [anon_sym_L_SQUOTE] = ACTIONS(3376),
    [anon_sym_u_SQUOTE] = ACTIONS(3376),
    [anon_sym_U_SQUOTE] = ACTIONS(3376),
    [anon_sym_u8_SQUOTE] = ACTIONS(3376),
    [anon_sym_SQUOTE] = ACTIONS(3376),
    [anon_sym_L_DQUOTE] = ACTIONS(3376),
    [anon_sym_u_DQUOTE] = ACTIONS(3376),
    [anon_sym_U_DQUOTE] = ACTIONS(3376),
    [anon_sym_u8_DQUOTE] = ACTIONS(3376),
    [anon_sym_DQUOTE] = ACTIONS(3376),
    [sym_true] = ACTIONS(3374),
    [sym_false] = ACTIONS(3374),
    [anon_sym_NULL] = ACTIONS(3374),
    [anon_sym_nullptr] = ACTIONS(3374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3374),
    [anon_sym_let] = ACTIONS(3374),
    [anon_sym_This] = ACTIONS(3374),
    [anon_sym_decltype] = ACTIONS(3374),
    [sym_virtual] = ACTIONS(3374),
    [anon_sym_explicit] = ACTIONS(3374),
    [anon_sym_typename] = ACTIONS(3374),
    [anon_sym_template] = ACTIONS(3374),
    [anon_sym_operator] = ACTIONS(3374),
    [anon_sym_try] = ACTIONS(3374),
    [anon_sym_delete] = ACTIONS(3374),
    [anon_sym_throw] = ACTIONS(3374),
    [anon_sym_namespace] = ACTIONS(3374),
    [anon_sym_using] = ACTIONS(3374),
    [anon_sym_static_assert] = ACTIONS(3374),
    [anon_sym_concept] = ACTIONS(3374),
    [anon_sym_co_return] = ACTIONS(3374),
    [anon_sym_co_yield] = ACTIONS(3374),
    [anon_sym_R_DQUOTE] = ACTIONS(3376),
    [anon_sym_LR_DQUOTE] = ACTIONS(3376),
    [anon_sym_uR_DQUOTE] = ACTIONS(3376),
    [anon_sym_UR_DQUOTE] = ACTIONS(3376),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3376),
    [anon_sym_co_await] = ACTIONS(3374),
    [anon_sym_new] = ACTIONS(3374),
    [anon_sym_requires] = ACTIONS(3374),
    [sym_this] = ACTIONS(3374),
    [anon_sym_discard] = ACTIONS(3374),
    [anon_sym_precise] = ACTIONS(3374),
    [anon_sym_shared] = ACTIONS(3374),
    [anon_sym_groupshared] = ACTIONS(3374),
    [anon_sym_uniform] = ACTIONS(3374),
    [anon_sym_row_major] = ACTIONS(3374),
    [anon_sym_column_major] = ACTIONS(3374),
    [anon_sym_globallycoherent] = ACTIONS(3374),
    [anon_sym_centroid] = ACTIONS(3374),
    [anon_sym_noperspective] = ACTIONS(3374),
    [anon_sym_nointerpolation] = ACTIONS(3374),
    [anon_sym_sample] = ACTIONS(3374),
    [anon_sym_linear] = ACTIONS(3374),
    [anon_sym_snorm] = ACTIONS(3374),
    [anon_sym_unorm] = ACTIONS(3374),
    [anon_sym_point] = ACTIONS(3374),
    [anon_sym_line] = ACTIONS(3374),
    [anon_sym_triangleadj] = ACTIONS(3374),
    [anon_sym_lineadj] = ACTIONS(3374),
    [anon_sym_triangle] = ACTIONS(3374),
    [anon_sym_cbuffer] = ACTIONS(3374),
    [anon_sym_interface] = ACTIONS(3374),
    [anon_sym_extension] = ACTIONS(3374),
  },
  [792] = {
    [sym_identifier] = ACTIONS(3084),
    [aux_sym_preproc_include_token1] = ACTIONS(3084),
    [aux_sym_preproc_def_token1] = ACTIONS(3084),
    [aux_sym_preproc_if_token1] = ACTIONS(3084),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3084),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3084),
    [sym_preproc_directive] = ACTIONS(3084),
    [anon_sym_LPAREN2] = ACTIONS(3086),
    [anon_sym_BANG] = ACTIONS(3086),
    [anon_sym_TILDE] = ACTIONS(3086),
    [anon_sym_DASH] = ACTIONS(3084),
    [anon_sym_PLUS] = ACTIONS(3084),
    [anon_sym_STAR] = ACTIONS(3086),
    [anon_sym_AMP_AMP] = ACTIONS(3086),
    [anon_sym_AMP] = ACTIONS(3084),
    [anon_sym_SEMI] = ACTIONS(3086),
    [anon_sym___extension__] = ACTIONS(3084),
    [anon_sym_typedef] = ACTIONS(3084),
    [anon_sym_in] = ACTIONS(3084),
    [anon_sym_out] = ACTIONS(3084),
    [anon_sym_inout] = ACTIONS(3084),
    [anon_sym_extern] = ACTIONS(3084),
    [anon_sym___attribute__] = ACTIONS(3084),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3086),
    [anon_sym___declspec] = ACTIONS(3084),
    [anon_sym___based] = ACTIONS(3084),
    [anon_sym___cdecl] = ACTIONS(3084),
    [anon_sym___clrcall] = ACTIONS(3084),
    [anon_sym___stdcall] = ACTIONS(3084),
    [anon_sym___fastcall] = ACTIONS(3084),
    [anon_sym___thiscall] = ACTIONS(3084),
    [anon_sym___vectorcall] = ACTIONS(3084),
    [anon_sym_LBRACE] = ACTIONS(3086),
    [anon_sym_RBRACE] = ACTIONS(3086),
    [anon_sym_signed] = ACTIONS(3084),
    [anon_sym_unsigned] = ACTIONS(3084),
    [anon_sym_long] = ACTIONS(3084),
    [anon_sym_short] = ACTIONS(3084),
    [anon_sym_LBRACK] = ACTIONS(3084),
    [anon_sym_static] = ACTIONS(3084),
    [anon_sym_register] = ACTIONS(3084),
    [anon_sym_inline] = ACTIONS(3084),
    [anon_sym___inline] = ACTIONS(3084),
    [anon_sym___inline__] = ACTIONS(3084),
    [anon_sym___forceinline] = ACTIONS(3084),
    [anon_sym_thread_local] = ACTIONS(3084),
    [anon_sym___thread] = ACTIONS(3084),
    [anon_sym_const] = ACTIONS(3084),
    [anon_sym_constexpr] = ACTIONS(3084),
    [anon_sym_volatile] = ACTIONS(3084),
    [anon_sym_restrict] = ACTIONS(3084),
    [anon_sym___restrict__] = ACTIONS(3084),
    [anon_sym__Atomic] = ACTIONS(3084),
    [anon_sym__Noreturn] = ACTIONS(3084),
    [anon_sym_noreturn] = ACTIONS(3084),
    [anon_sym_mutable] = ACTIONS(3084),
    [anon_sym_constinit] = ACTIONS(3084),
    [anon_sym_consteval] = ACTIONS(3084),
    [anon_sym_alignas] = ACTIONS(3084),
    [anon_sym__Alignas] = ACTIONS(3084),
    [sym_primitive_type] = ACTIONS(3084),
    [anon_sym_enum] = ACTIONS(3084),
    [anon_sym_class] = ACTIONS(3084),
    [anon_sym_struct] = ACTIONS(3084),
    [anon_sym_union] = ACTIONS(3084),
    [anon_sym_if] = ACTIONS(3084),
    [anon_sym_else] = ACTIONS(3084),
    [anon_sym_switch] = ACTIONS(3084),
    [anon_sym_case] = ACTIONS(3084),
    [anon_sym_default] = ACTIONS(3084),
    [anon_sym_while] = ACTIONS(3084),
    [anon_sym_do] = ACTIONS(3084),
    [anon_sym_for] = ACTIONS(3084),
    [anon_sym_return] = ACTIONS(3084),
    [anon_sym_break] = ACTIONS(3084),
    [anon_sym_continue] = ACTIONS(3084),
    [anon_sym_goto] = ACTIONS(3084),
    [anon_sym___try] = ACTIONS(3084),
    [anon_sym___leave] = ACTIONS(3084),
    [anon_sym_not] = ACTIONS(3084),
    [anon_sym_compl] = ACTIONS(3084),
    [anon_sym_DASH_DASH] = ACTIONS(3086),
    [anon_sym_PLUS_PLUS] = ACTIONS(3086),
    [anon_sym_sizeof] = ACTIONS(3084),
    [anon_sym___alignof__] = ACTIONS(3084),
    [anon_sym___alignof] = ACTIONS(3084),
    [anon_sym__alignof] = ACTIONS(3084),
    [anon_sym_alignof] = ACTIONS(3084),
    [anon_sym__Alignof] = ACTIONS(3084),
    [anon_sym_offsetof] = ACTIONS(3084),
    [anon_sym__Generic] = ACTIONS(3084),
    [anon_sym_asm] = ACTIONS(3084),
    [anon_sym___asm__] = ACTIONS(3084),
    [sym_number_literal] = ACTIONS(3086),
    [anon_sym_L_SQUOTE] = ACTIONS(3086),
    [anon_sym_u_SQUOTE] = ACTIONS(3086),
    [anon_sym_U_SQUOTE] = ACTIONS(3086),
    [anon_sym_u8_SQUOTE] = ACTIONS(3086),
    [anon_sym_SQUOTE] = ACTIONS(3086),
    [anon_sym_L_DQUOTE] = ACTIONS(3086),
    [anon_sym_u_DQUOTE] = ACTIONS(3086),
    [anon_sym_U_DQUOTE] = ACTIONS(3086),
    [anon_sym_u8_DQUOTE] = ACTIONS(3086),
    [anon_sym_DQUOTE] = ACTIONS(3086),
    [sym_true] = ACTIONS(3084),
    [sym_false] = ACTIONS(3084),
    [anon_sym_NULL] = ACTIONS(3084),
    [anon_sym_nullptr] = ACTIONS(3084),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3084),
    [anon_sym_let] = ACTIONS(3084),
    [anon_sym_This] = ACTIONS(3084),
    [anon_sym_decltype] = ACTIONS(3084),
    [sym_virtual] = ACTIONS(3084),
    [anon_sym_explicit] = ACTIONS(3084),
    [anon_sym_typename] = ACTIONS(3084),
    [anon_sym_template] = ACTIONS(3084),
    [anon_sym_operator] = ACTIONS(3084),
    [anon_sym_try] = ACTIONS(3084),
    [anon_sym_delete] = ACTIONS(3084),
    [anon_sym_throw] = ACTIONS(3084),
    [anon_sym_namespace] = ACTIONS(3084),
    [anon_sym_using] = ACTIONS(3084),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_concept] = ACTIONS(3084),
    [anon_sym_co_return] = ACTIONS(3084),
    [anon_sym_co_yield] = ACTIONS(3084),
    [anon_sym_R_DQUOTE] = ACTIONS(3086),
    [anon_sym_LR_DQUOTE] = ACTIONS(3086),
    [anon_sym_uR_DQUOTE] = ACTIONS(3086),
    [anon_sym_UR_DQUOTE] = ACTIONS(3086),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3086),
    [anon_sym_co_await] = ACTIONS(3084),
    [anon_sym_new] = ACTIONS(3084),
    [anon_sym_requires] = ACTIONS(3084),
    [sym_this] = ACTIONS(3084),
    [anon_sym_discard] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(3084),
    [anon_sym_shared] = ACTIONS(3084),
    [anon_sym_groupshared] = ACTIONS(3084),
    [anon_sym_uniform] = ACTIONS(3084),
    [anon_sym_row_major] = ACTIONS(3084),
    [anon_sym_column_major] = ACTIONS(3084),
    [anon_sym_globallycoherent] = ACTIONS(3084),
    [anon_sym_centroid] = ACTIONS(3084),
    [anon_sym_noperspective] = ACTIONS(3084),
    [anon_sym_nointerpolation] = ACTIONS(3084),
    [anon_sym_sample] = ACTIONS(3084),
    [anon_sym_linear] = ACTIONS(3084),
    [anon_sym_snorm] = ACTIONS(3084),
    [anon_sym_unorm] = ACTIONS(3084),
    [anon_sym_point] = ACTIONS(3084),
    [anon_sym_line] = ACTIONS(3084),
    [anon_sym_triangleadj] = ACTIONS(3084),
    [anon_sym_lineadj] = ACTIONS(3084),
    [anon_sym_triangle] = ACTIONS(3084),
    [anon_sym_cbuffer] = ACTIONS(3084),
    [anon_sym_interface] = ACTIONS(3084),
    [anon_sym_extension] = ACTIONS(3084),
  },
  [793] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(3072),
    [anon_sym_out] = ACTIONS(3072),
    [anon_sym_inout] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym__Alignas] = ACTIONS(3072),
    [sym_primitive_type] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [sym_number_literal] = ACTIONS(3074),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3072),
    [anon_sym_let] = ACTIONS(3072),
    [anon_sym_This] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [sym_virtual] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
    [anon_sym_discard] = ACTIONS(3072),
    [anon_sym_precise] = ACTIONS(3072),
    [anon_sym_shared] = ACTIONS(3072),
    [anon_sym_groupshared] = ACTIONS(3072),
    [anon_sym_uniform] = ACTIONS(3072),
    [anon_sym_row_major] = ACTIONS(3072),
    [anon_sym_column_major] = ACTIONS(3072),
    [anon_sym_globallycoherent] = ACTIONS(3072),
    [anon_sym_centroid] = ACTIONS(3072),
    [anon_sym_noperspective] = ACTIONS(3072),
    [anon_sym_nointerpolation] = ACTIONS(3072),
    [anon_sym_sample] = ACTIONS(3072),
    [anon_sym_linear] = ACTIONS(3072),
    [anon_sym_snorm] = ACTIONS(3072),
    [anon_sym_unorm] = ACTIONS(3072),
    [anon_sym_point] = ACTIONS(3072),
    [anon_sym_line] = ACTIONS(3072),
    [anon_sym_triangleadj] = ACTIONS(3072),
    [anon_sym_lineadj] = ACTIONS(3072),
    [anon_sym_triangle] = ACTIONS(3072),
    [anon_sym_cbuffer] = ACTIONS(3072),
    [anon_sym_interface] = ACTIONS(3072),
    [anon_sym_extension] = ACTIONS(3072),
  },
  [794] = {
    [sym_identifier] = ACTIONS(2742),
    [aux_sym_preproc_include_token1] = ACTIONS(2742),
    [aux_sym_preproc_def_token1] = ACTIONS(2742),
    [aux_sym_preproc_if_token1] = ACTIONS(2742),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2742),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2742),
    [sym_preproc_directive] = ACTIONS(2742),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_BANG] = ACTIONS(2740),
    [anon_sym_TILDE] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2742),
    [anon_sym_PLUS] = ACTIONS(2742),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym___extension__] = ACTIONS(2742),
    [anon_sym_typedef] = ACTIONS(2742),
    [anon_sym_in] = ACTIONS(2742),
    [anon_sym_out] = ACTIONS(2742),
    [anon_sym_inout] = ACTIONS(2742),
    [anon_sym_extern] = ACTIONS(2742),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2740),
    [anon_sym___declspec] = ACTIONS(2742),
    [anon_sym___based] = ACTIONS(2742),
    [anon_sym___cdecl] = ACTIONS(2742),
    [anon_sym___clrcall] = ACTIONS(2742),
    [anon_sym___stdcall] = ACTIONS(2742),
    [anon_sym___fastcall] = ACTIONS(2742),
    [anon_sym___thiscall] = ACTIONS(2742),
    [anon_sym___vectorcall] = ACTIONS(2742),
    [anon_sym_LBRACE] = ACTIONS(3911),
    [anon_sym_RBRACE] = ACTIONS(2740),
    [anon_sym_signed] = ACTIONS(2742),
    [anon_sym_unsigned] = ACTIONS(2742),
    [anon_sym_long] = ACTIONS(2742),
    [anon_sym_short] = ACTIONS(2742),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2742),
    [anon_sym_register] = ACTIONS(2742),
    [anon_sym_inline] = ACTIONS(2742),
    [anon_sym___inline] = ACTIONS(2742),
    [anon_sym___inline__] = ACTIONS(2742),
    [anon_sym___forceinline] = ACTIONS(2742),
    [anon_sym_thread_local] = ACTIONS(2742),
    [anon_sym___thread] = ACTIONS(2742),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_constexpr] = ACTIONS(2742),
    [anon_sym_volatile] = ACTIONS(2742),
    [anon_sym_restrict] = ACTIONS(2742),
    [anon_sym___restrict__] = ACTIONS(2742),
    [anon_sym__Atomic] = ACTIONS(2742),
    [anon_sym__Noreturn] = ACTIONS(2742),
    [anon_sym_noreturn] = ACTIONS(2742),
    [anon_sym_mutable] = ACTIONS(2742),
    [anon_sym_constinit] = ACTIONS(2742),
    [anon_sym_consteval] = ACTIONS(2742),
    [anon_sym_alignas] = ACTIONS(2742),
    [anon_sym__Alignas] = ACTIONS(2742),
    [sym_primitive_type] = ACTIONS(2742),
    [anon_sym_enum] = ACTIONS(2742),
    [anon_sym_class] = ACTIONS(2742),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2742),
    [anon_sym_if] = ACTIONS(2742),
    [anon_sym_switch] = ACTIONS(2742),
    [anon_sym_case] = ACTIONS(2742),
    [anon_sym_default] = ACTIONS(2742),
    [anon_sym_while] = ACTIONS(2742),
    [anon_sym_do] = ACTIONS(2742),
    [anon_sym_for] = ACTIONS(2742),
    [anon_sym_return] = ACTIONS(2742),
    [anon_sym_break] = ACTIONS(2742),
    [anon_sym_continue] = ACTIONS(2742),
    [anon_sym_goto] = ACTIONS(2742),
    [anon_sym___try] = ACTIONS(2742),
    [anon_sym___leave] = ACTIONS(2742),
    [anon_sym_not] = ACTIONS(2742),
    [anon_sym_compl] = ACTIONS(2742),
    [anon_sym_DASH_DASH] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2740),
    [anon_sym_sizeof] = ACTIONS(2742),
    [anon_sym___alignof__] = ACTIONS(2742),
    [anon_sym___alignof] = ACTIONS(2742),
    [anon_sym__alignof] = ACTIONS(2742),
    [anon_sym_alignof] = ACTIONS(2742),
    [anon_sym__Alignof] = ACTIONS(2742),
    [anon_sym_offsetof] = ACTIONS(2742),
    [anon_sym__Generic] = ACTIONS(2742),
    [anon_sym_asm] = ACTIONS(2742),
    [anon_sym___asm__] = ACTIONS(2742),
    [anon_sym_DOT] = ACTIONS(2742),
    [sym_number_literal] = ACTIONS(2740),
    [anon_sym_L_SQUOTE] = ACTIONS(2740),
    [anon_sym_u_SQUOTE] = ACTIONS(2740),
    [anon_sym_U_SQUOTE] = ACTIONS(2740),
    [anon_sym_u8_SQUOTE] = ACTIONS(2740),
    [anon_sym_SQUOTE] = ACTIONS(2740),
    [anon_sym_L_DQUOTE] = ACTIONS(2740),
    [anon_sym_u_DQUOTE] = ACTIONS(2740),
    [anon_sym_U_DQUOTE] = ACTIONS(2740),
    [anon_sym_u8_DQUOTE] = ACTIONS(2740),
    [anon_sym_DQUOTE] = ACTIONS(2740),
    [sym_true] = ACTIONS(2742),
    [sym_false] = ACTIONS(2742),
    [anon_sym_NULL] = ACTIONS(2742),
    [anon_sym_nullptr] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
    [anon_sym_decltype] = ACTIONS(2742),
    [sym_virtual] = ACTIONS(2742),
    [anon_sym_explicit] = ACTIONS(2742),
    [anon_sym_typename] = ACTIONS(2742),
    [anon_sym_template] = ACTIONS(2742),
    [anon_sym_operator] = ACTIONS(2742),
    [anon_sym_try] = ACTIONS(2742),
    [anon_sym_delete] = ACTIONS(2742),
    [anon_sym_throw] = ACTIONS(2742),
    [anon_sym_namespace] = ACTIONS(2742),
    [anon_sym_using] = ACTIONS(2742),
    [anon_sym_static_assert] = ACTIONS(2742),
    [anon_sym_concept] = ACTIONS(2742),
    [anon_sym_co_return] = ACTIONS(2742),
    [anon_sym_co_yield] = ACTIONS(2742),
    [anon_sym_R_DQUOTE] = ACTIONS(2740),
    [anon_sym_LR_DQUOTE] = ACTIONS(2740),
    [anon_sym_uR_DQUOTE] = ACTIONS(2740),
    [anon_sym_UR_DQUOTE] = ACTIONS(2740),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2740),
    [anon_sym_co_await] = ACTIONS(2742),
    [anon_sym_new] = ACTIONS(2742),
    [anon_sym_requires] = ACTIONS(2742),
    [sym_this] = ACTIONS(2742),
    [anon_sym_discard] = ACTIONS(2742),
    [anon_sym_precise] = ACTIONS(2742),
    [anon_sym_shared] = ACTIONS(2742),
    [anon_sym_groupshared] = ACTIONS(2742),
    [anon_sym_uniform] = ACTIONS(2742),
    [anon_sym_row_major] = ACTIONS(2742),
    [anon_sym_column_major] = ACTIONS(2742),
    [anon_sym_globallycoherent] = ACTIONS(2742),
    [anon_sym_centroid] = ACTIONS(2742),
    [anon_sym_noperspective] = ACTIONS(2742),
    [anon_sym_nointerpolation] = ACTIONS(2742),
    [anon_sym_sample] = ACTIONS(2742),
    [anon_sym_linear] = ACTIONS(2742),
    [anon_sym_snorm] = ACTIONS(2742),
    [anon_sym_unorm] = ACTIONS(2742),
    [anon_sym_point] = ACTIONS(2742),
    [anon_sym_line] = ACTIONS(2742),
    [anon_sym_triangleadj] = ACTIONS(2742),
    [anon_sym_lineadj] = ACTIONS(2742),
    [anon_sym_triangle] = ACTIONS(2742),
    [anon_sym_cbuffer] = ACTIONS(2742),
    [anon_sym_interface] = ACTIONS(2742),
    [anon_sym_extension] = ACTIONS(2742),
  },
  [795] = {
    [sym_identifier] = ACTIONS(3038),
    [aux_sym_preproc_include_token1] = ACTIONS(3038),
    [aux_sym_preproc_def_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3038),
    [sym_preproc_directive] = ACTIONS(3038),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3038),
    [anon_sym_PLUS] = ACTIONS(3038),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3038),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3038),
    [anon_sym_typedef] = ACTIONS(3038),
    [anon_sym_in] = ACTIONS(3038),
    [anon_sym_out] = ACTIONS(3038),
    [anon_sym_inout] = ACTIONS(3038),
    [anon_sym_extern] = ACTIONS(3038),
    [anon_sym___attribute__] = ACTIONS(3038),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3040),
    [anon_sym___declspec] = ACTIONS(3038),
    [anon_sym___based] = ACTIONS(3038),
    [anon_sym___cdecl] = ACTIONS(3038),
    [anon_sym___clrcall] = ACTIONS(3038),
    [anon_sym___stdcall] = ACTIONS(3038),
    [anon_sym___fastcall] = ACTIONS(3038),
    [anon_sym___thiscall] = ACTIONS(3038),
    [anon_sym___vectorcall] = ACTIONS(3038),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_RBRACE] = ACTIONS(3040),
    [anon_sym_signed] = ACTIONS(3038),
    [anon_sym_unsigned] = ACTIONS(3038),
    [anon_sym_long] = ACTIONS(3038),
    [anon_sym_short] = ACTIONS(3038),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_static] = ACTIONS(3038),
    [anon_sym_register] = ACTIONS(3038),
    [anon_sym_inline] = ACTIONS(3038),
    [anon_sym___inline] = ACTIONS(3038),
    [anon_sym___inline__] = ACTIONS(3038),
    [anon_sym___forceinline] = ACTIONS(3038),
    [anon_sym_thread_local] = ACTIONS(3038),
    [anon_sym___thread] = ACTIONS(3038),
    [anon_sym_const] = ACTIONS(3038),
    [anon_sym_constexpr] = ACTIONS(3038),
    [anon_sym_volatile] = ACTIONS(3038),
    [anon_sym_restrict] = ACTIONS(3038),
    [anon_sym___restrict__] = ACTIONS(3038),
    [anon_sym__Atomic] = ACTIONS(3038),
    [anon_sym__Noreturn] = ACTIONS(3038),
    [anon_sym_noreturn] = ACTIONS(3038),
    [anon_sym_mutable] = ACTIONS(3038),
    [anon_sym_constinit] = ACTIONS(3038),
    [anon_sym_consteval] = ACTIONS(3038),
    [anon_sym_alignas] = ACTIONS(3038),
    [anon_sym__Alignas] = ACTIONS(3038),
    [sym_primitive_type] = ACTIONS(3038),
    [anon_sym_enum] = ACTIONS(3038),
    [anon_sym_class] = ACTIONS(3038),
    [anon_sym_struct] = ACTIONS(3038),
    [anon_sym_union] = ACTIONS(3038),
    [anon_sym_if] = ACTIONS(3038),
    [anon_sym_else] = ACTIONS(3038),
    [anon_sym_switch] = ACTIONS(3038),
    [anon_sym_case] = ACTIONS(3038),
    [anon_sym_default] = ACTIONS(3038),
    [anon_sym_while] = ACTIONS(3038),
    [anon_sym_do] = ACTIONS(3038),
    [anon_sym_for] = ACTIONS(3038),
    [anon_sym_return] = ACTIONS(3038),
    [anon_sym_break] = ACTIONS(3038),
    [anon_sym_continue] = ACTIONS(3038),
    [anon_sym_goto] = ACTIONS(3038),
    [anon_sym___try] = ACTIONS(3038),
    [anon_sym___leave] = ACTIONS(3038),
    [anon_sym_not] = ACTIONS(3038),
    [anon_sym_compl] = ACTIONS(3038),
    [anon_sym_DASH_DASH] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3040),
    [anon_sym_sizeof] = ACTIONS(3038),
    [anon_sym___alignof__] = ACTIONS(3038),
    [anon_sym___alignof] = ACTIONS(3038),
    [anon_sym__alignof] = ACTIONS(3038),
    [anon_sym_alignof] = ACTIONS(3038),
    [anon_sym__Alignof] = ACTIONS(3038),
    [anon_sym_offsetof] = ACTIONS(3038),
    [anon_sym__Generic] = ACTIONS(3038),
    [anon_sym_asm] = ACTIONS(3038),
    [anon_sym___asm__] = ACTIONS(3038),
    [sym_number_literal] = ACTIONS(3040),
    [anon_sym_L_SQUOTE] = ACTIONS(3040),
    [anon_sym_u_SQUOTE] = ACTIONS(3040),
    [anon_sym_U_SQUOTE] = ACTIONS(3040),
    [anon_sym_u8_SQUOTE] = ACTIONS(3040),
    [anon_sym_SQUOTE] = ACTIONS(3040),
    [anon_sym_L_DQUOTE] = ACTIONS(3040),
    [anon_sym_u_DQUOTE] = ACTIONS(3040),
    [anon_sym_U_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8_DQUOTE] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [sym_true] = ACTIONS(3038),
    [sym_false] = ACTIONS(3038),
    [anon_sym_NULL] = ACTIONS(3038),
    [anon_sym_nullptr] = ACTIONS(3038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3038),
    [anon_sym_let] = ACTIONS(3038),
    [anon_sym_This] = ACTIONS(3038),
    [anon_sym_decltype] = ACTIONS(3038),
    [sym_virtual] = ACTIONS(3038),
    [anon_sym_explicit] = ACTIONS(3038),
    [anon_sym_typename] = ACTIONS(3038),
    [anon_sym_template] = ACTIONS(3038),
    [anon_sym_operator] = ACTIONS(3038),
    [anon_sym_try] = ACTIONS(3038),
    [anon_sym_delete] = ACTIONS(3038),
    [anon_sym_throw] = ACTIONS(3038),
    [anon_sym_namespace] = ACTIONS(3038),
    [anon_sym_using] = ACTIONS(3038),
    [anon_sym_static_assert] = ACTIONS(3038),
    [anon_sym_concept] = ACTIONS(3038),
    [anon_sym_co_return] = ACTIONS(3038),
    [anon_sym_co_yield] = ACTIONS(3038),
    [anon_sym_R_DQUOTE] = ACTIONS(3040),
    [anon_sym_LR_DQUOTE] = ACTIONS(3040),
    [anon_sym_uR_DQUOTE] = ACTIONS(3040),
    [anon_sym_UR_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3040),
    [anon_sym_co_await] = ACTIONS(3038),
    [anon_sym_new] = ACTIONS(3038),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3038),
    [anon_sym_discard] = ACTIONS(3038),
    [anon_sym_precise] = ACTIONS(3038),
    [anon_sym_shared] = ACTIONS(3038),
    [anon_sym_groupshared] = ACTIONS(3038),
    [anon_sym_uniform] = ACTIONS(3038),
    [anon_sym_row_major] = ACTIONS(3038),
    [anon_sym_column_major] = ACTIONS(3038),
    [anon_sym_globallycoherent] = ACTIONS(3038),
    [anon_sym_centroid] = ACTIONS(3038),
    [anon_sym_noperspective] = ACTIONS(3038),
    [anon_sym_nointerpolation] = ACTIONS(3038),
    [anon_sym_sample] = ACTIONS(3038),
    [anon_sym_linear] = ACTIONS(3038),
    [anon_sym_snorm] = ACTIONS(3038),
    [anon_sym_unorm] = ACTIONS(3038),
    [anon_sym_point] = ACTIONS(3038),
    [anon_sym_line] = ACTIONS(3038),
    [anon_sym_triangleadj] = ACTIONS(3038),
    [anon_sym_lineadj] = ACTIONS(3038),
    [anon_sym_triangle] = ACTIONS(3038),
    [anon_sym_cbuffer] = ACTIONS(3038),
    [anon_sym_interface] = ACTIONS(3038),
    [anon_sym_extension] = ACTIONS(3038),
  },
  [796] = {
    [sym_identifier] = ACTIONS(3038),
    [aux_sym_preproc_include_token1] = ACTIONS(3038),
    [aux_sym_preproc_def_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3038),
    [sym_preproc_directive] = ACTIONS(3038),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3038),
    [anon_sym_PLUS] = ACTIONS(3038),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3038),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3038),
    [anon_sym_typedef] = ACTIONS(3038),
    [anon_sym_in] = ACTIONS(3038),
    [anon_sym_out] = ACTIONS(3038),
    [anon_sym_inout] = ACTIONS(3038),
    [anon_sym_extern] = ACTIONS(3038),
    [anon_sym___attribute__] = ACTIONS(3038),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3040),
    [anon_sym___declspec] = ACTIONS(3038),
    [anon_sym___based] = ACTIONS(3038),
    [anon_sym___cdecl] = ACTIONS(3038),
    [anon_sym___clrcall] = ACTIONS(3038),
    [anon_sym___stdcall] = ACTIONS(3038),
    [anon_sym___fastcall] = ACTIONS(3038),
    [anon_sym___thiscall] = ACTIONS(3038),
    [anon_sym___vectorcall] = ACTIONS(3038),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_RBRACE] = ACTIONS(3040),
    [anon_sym_signed] = ACTIONS(3038),
    [anon_sym_unsigned] = ACTIONS(3038),
    [anon_sym_long] = ACTIONS(3038),
    [anon_sym_short] = ACTIONS(3038),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_static] = ACTIONS(3038),
    [anon_sym_register] = ACTIONS(3038),
    [anon_sym_inline] = ACTIONS(3038),
    [anon_sym___inline] = ACTIONS(3038),
    [anon_sym___inline__] = ACTIONS(3038),
    [anon_sym___forceinline] = ACTIONS(3038),
    [anon_sym_thread_local] = ACTIONS(3038),
    [anon_sym___thread] = ACTIONS(3038),
    [anon_sym_const] = ACTIONS(3038),
    [anon_sym_constexpr] = ACTIONS(3038),
    [anon_sym_volatile] = ACTIONS(3038),
    [anon_sym_restrict] = ACTIONS(3038),
    [anon_sym___restrict__] = ACTIONS(3038),
    [anon_sym__Atomic] = ACTIONS(3038),
    [anon_sym__Noreturn] = ACTIONS(3038),
    [anon_sym_noreturn] = ACTIONS(3038),
    [anon_sym_mutable] = ACTIONS(3038),
    [anon_sym_constinit] = ACTIONS(3038),
    [anon_sym_consteval] = ACTIONS(3038),
    [anon_sym_alignas] = ACTIONS(3038),
    [anon_sym__Alignas] = ACTIONS(3038),
    [sym_primitive_type] = ACTIONS(3038),
    [anon_sym_enum] = ACTIONS(3038),
    [anon_sym_class] = ACTIONS(3038),
    [anon_sym_struct] = ACTIONS(3038),
    [anon_sym_union] = ACTIONS(3038),
    [anon_sym_if] = ACTIONS(3038),
    [anon_sym_else] = ACTIONS(3038),
    [anon_sym_switch] = ACTIONS(3038),
    [anon_sym_case] = ACTIONS(3038),
    [anon_sym_default] = ACTIONS(3038),
    [anon_sym_while] = ACTIONS(3038),
    [anon_sym_do] = ACTIONS(3038),
    [anon_sym_for] = ACTIONS(3038),
    [anon_sym_return] = ACTIONS(3038),
    [anon_sym_break] = ACTIONS(3038),
    [anon_sym_continue] = ACTIONS(3038),
    [anon_sym_goto] = ACTIONS(3038),
    [anon_sym___try] = ACTIONS(3038),
    [anon_sym___leave] = ACTIONS(3038),
    [anon_sym_not] = ACTIONS(3038),
    [anon_sym_compl] = ACTIONS(3038),
    [anon_sym_DASH_DASH] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3040),
    [anon_sym_sizeof] = ACTIONS(3038),
    [anon_sym___alignof__] = ACTIONS(3038),
    [anon_sym___alignof] = ACTIONS(3038),
    [anon_sym__alignof] = ACTIONS(3038),
    [anon_sym_alignof] = ACTIONS(3038),
    [anon_sym__Alignof] = ACTIONS(3038),
    [anon_sym_offsetof] = ACTIONS(3038),
    [anon_sym__Generic] = ACTIONS(3038),
    [anon_sym_asm] = ACTIONS(3038),
    [anon_sym___asm__] = ACTIONS(3038),
    [sym_number_literal] = ACTIONS(3040),
    [anon_sym_L_SQUOTE] = ACTIONS(3040),
    [anon_sym_u_SQUOTE] = ACTIONS(3040),
    [anon_sym_U_SQUOTE] = ACTIONS(3040),
    [anon_sym_u8_SQUOTE] = ACTIONS(3040),
    [anon_sym_SQUOTE] = ACTIONS(3040),
    [anon_sym_L_DQUOTE] = ACTIONS(3040),
    [anon_sym_u_DQUOTE] = ACTIONS(3040),
    [anon_sym_U_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8_DQUOTE] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [sym_true] = ACTIONS(3038),
    [sym_false] = ACTIONS(3038),
    [anon_sym_NULL] = ACTIONS(3038),
    [anon_sym_nullptr] = ACTIONS(3038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3038),
    [anon_sym_let] = ACTIONS(3038),
    [anon_sym_This] = ACTIONS(3038),
    [anon_sym_decltype] = ACTIONS(3038),
    [sym_virtual] = ACTIONS(3038),
    [anon_sym_explicit] = ACTIONS(3038),
    [anon_sym_typename] = ACTIONS(3038),
    [anon_sym_template] = ACTIONS(3038),
    [anon_sym_operator] = ACTIONS(3038),
    [anon_sym_try] = ACTIONS(3038),
    [anon_sym_delete] = ACTIONS(3038),
    [anon_sym_throw] = ACTIONS(3038),
    [anon_sym_namespace] = ACTIONS(3038),
    [anon_sym_using] = ACTIONS(3038),
    [anon_sym_static_assert] = ACTIONS(3038),
    [anon_sym_concept] = ACTIONS(3038),
    [anon_sym_co_return] = ACTIONS(3038),
    [anon_sym_co_yield] = ACTIONS(3038),
    [anon_sym_R_DQUOTE] = ACTIONS(3040),
    [anon_sym_LR_DQUOTE] = ACTIONS(3040),
    [anon_sym_uR_DQUOTE] = ACTIONS(3040),
    [anon_sym_UR_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3040),
    [anon_sym_co_await] = ACTIONS(3038),
    [anon_sym_new] = ACTIONS(3038),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3038),
    [anon_sym_discard] = ACTIONS(3038),
    [anon_sym_precise] = ACTIONS(3038),
    [anon_sym_shared] = ACTIONS(3038),
    [anon_sym_groupshared] = ACTIONS(3038),
    [anon_sym_uniform] = ACTIONS(3038),
    [anon_sym_row_major] = ACTIONS(3038),
    [anon_sym_column_major] = ACTIONS(3038),
    [anon_sym_globallycoherent] = ACTIONS(3038),
    [anon_sym_centroid] = ACTIONS(3038),
    [anon_sym_noperspective] = ACTIONS(3038),
    [anon_sym_nointerpolation] = ACTIONS(3038),
    [anon_sym_sample] = ACTIONS(3038),
    [anon_sym_linear] = ACTIONS(3038),
    [anon_sym_snorm] = ACTIONS(3038),
    [anon_sym_unorm] = ACTIONS(3038),
    [anon_sym_point] = ACTIONS(3038),
    [anon_sym_line] = ACTIONS(3038),
    [anon_sym_triangleadj] = ACTIONS(3038),
    [anon_sym_lineadj] = ACTIONS(3038),
    [anon_sym_triangle] = ACTIONS(3038),
    [anon_sym_cbuffer] = ACTIONS(3038),
    [anon_sym_interface] = ACTIONS(3038),
    [anon_sym_extension] = ACTIONS(3038),
  },
  [797] = {
    [sym_identifier] = ACTIONS(3238),
    [aux_sym_preproc_include_token1] = ACTIONS(3238),
    [aux_sym_preproc_def_token1] = ACTIONS(3238),
    [aux_sym_preproc_if_token1] = ACTIONS(3238),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3238),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3238),
    [sym_preproc_directive] = ACTIONS(3238),
    [anon_sym_LPAREN2] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3238),
    [anon_sym_PLUS] = ACTIONS(3238),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_AMP_AMP] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(3238),
    [anon_sym_SEMI] = ACTIONS(3240),
    [anon_sym___extension__] = ACTIONS(3238),
    [anon_sym_typedef] = ACTIONS(3238),
    [anon_sym_in] = ACTIONS(3238),
    [anon_sym_out] = ACTIONS(3238),
    [anon_sym_inout] = ACTIONS(3238),
    [anon_sym_extern] = ACTIONS(3238),
    [anon_sym___attribute__] = ACTIONS(3238),
    [anon_sym_COLON_COLON] = ACTIONS(3240),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3240),
    [anon_sym___declspec] = ACTIONS(3238),
    [anon_sym___based] = ACTIONS(3238),
    [anon_sym___cdecl] = ACTIONS(3238),
    [anon_sym___clrcall] = ACTIONS(3238),
    [anon_sym___stdcall] = ACTIONS(3238),
    [anon_sym___fastcall] = ACTIONS(3238),
    [anon_sym___thiscall] = ACTIONS(3238),
    [anon_sym___vectorcall] = ACTIONS(3238),
    [anon_sym_LBRACE] = ACTIONS(3240),
    [anon_sym_RBRACE] = ACTIONS(3240),
    [anon_sym_signed] = ACTIONS(3238),
    [anon_sym_unsigned] = ACTIONS(3238),
    [anon_sym_long] = ACTIONS(3238),
    [anon_sym_short] = ACTIONS(3238),
    [anon_sym_LBRACK] = ACTIONS(3238),
    [anon_sym_static] = ACTIONS(3238),
    [anon_sym_register] = ACTIONS(3238),
    [anon_sym_inline] = ACTIONS(3238),
    [anon_sym___inline] = ACTIONS(3238),
    [anon_sym___inline__] = ACTIONS(3238),
    [anon_sym___forceinline] = ACTIONS(3238),
    [anon_sym_thread_local] = ACTIONS(3238),
    [anon_sym___thread] = ACTIONS(3238),
    [anon_sym_const] = ACTIONS(3238),
    [anon_sym_constexpr] = ACTIONS(3238),
    [anon_sym_volatile] = ACTIONS(3238),
    [anon_sym_restrict] = ACTIONS(3238),
    [anon_sym___restrict__] = ACTIONS(3238),
    [anon_sym__Atomic] = ACTIONS(3238),
    [anon_sym__Noreturn] = ACTIONS(3238),
    [anon_sym_noreturn] = ACTIONS(3238),
    [anon_sym_mutable] = ACTIONS(3238),
    [anon_sym_constinit] = ACTIONS(3238),
    [anon_sym_consteval] = ACTIONS(3238),
    [anon_sym_alignas] = ACTIONS(3238),
    [anon_sym__Alignas] = ACTIONS(3238),
    [sym_primitive_type] = ACTIONS(3238),
    [anon_sym_enum] = ACTIONS(3238),
    [anon_sym_class] = ACTIONS(3238),
    [anon_sym_struct] = ACTIONS(3238),
    [anon_sym_union] = ACTIONS(3238),
    [anon_sym_if] = ACTIONS(3238),
    [anon_sym_else] = ACTIONS(3238),
    [anon_sym_switch] = ACTIONS(3238),
    [anon_sym_case] = ACTIONS(3238),
    [anon_sym_default] = ACTIONS(3238),
    [anon_sym_while] = ACTIONS(3238),
    [anon_sym_do] = ACTIONS(3238),
    [anon_sym_for] = ACTIONS(3238),
    [anon_sym_return] = ACTIONS(3238),
    [anon_sym_break] = ACTIONS(3238),
    [anon_sym_continue] = ACTIONS(3238),
    [anon_sym_goto] = ACTIONS(3238),
    [anon_sym___try] = ACTIONS(3238),
    [anon_sym___leave] = ACTIONS(3238),
    [anon_sym_not] = ACTIONS(3238),
    [anon_sym_compl] = ACTIONS(3238),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_sizeof] = ACTIONS(3238),
    [anon_sym___alignof__] = ACTIONS(3238),
    [anon_sym___alignof] = ACTIONS(3238),
    [anon_sym__alignof] = ACTIONS(3238),
    [anon_sym_alignof] = ACTIONS(3238),
    [anon_sym__Alignof] = ACTIONS(3238),
    [anon_sym_offsetof] = ACTIONS(3238),
    [anon_sym__Generic] = ACTIONS(3238),
    [anon_sym_asm] = ACTIONS(3238),
    [anon_sym___asm__] = ACTIONS(3238),
    [sym_number_literal] = ACTIONS(3240),
    [anon_sym_L_SQUOTE] = ACTIONS(3240),
    [anon_sym_u_SQUOTE] = ACTIONS(3240),
    [anon_sym_U_SQUOTE] = ACTIONS(3240),
    [anon_sym_u8_SQUOTE] = ACTIONS(3240),
    [anon_sym_SQUOTE] = ACTIONS(3240),
    [anon_sym_L_DQUOTE] = ACTIONS(3240),
    [anon_sym_u_DQUOTE] = ACTIONS(3240),
    [anon_sym_U_DQUOTE] = ACTIONS(3240),
    [anon_sym_u8_DQUOTE] = ACTIONS(3240),
    [anon_sym_DQUOTE] = ACTIONS(3240),
    [sym_true] = ACTIONS(3238),
    [sym_false] = ACTIONS(3238),
    [anon_sym_NULL] = ACTIONS(3238),
    [anon_sym_nullptr] = ACTIONS(3238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3238),
    [anon_sym_let] = ACTIONS(3238),
    [anon_sym_This] = ACTIONS(3238),
    [anon_sym_decltype] = ACTIONS(3238),
    [sym_virtual] = ACTIONS(3238),
    [anon_sym_explicit] = ACTIONS(3238),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3238),
    [anon_sym_operator] = ACTIONS(3238),
    [anon_sym_try] = ACTIONS(3238),
    [anon_sym_delete] = ACTIONS(3238),
    [anon_sym_throw] = ACTIONS(3238),
    [anon_sym_namespace] = ACTIONS(3238),
    [anon_sym_using] = ACTIONS(3238),
    [anon_sym_static_assert] = ACTIONS(3238),
    [anon_sym_concept] = ACTIONS(3238),
    [anon_sym_co_return] = ACTIONS(3238),
    [anon_sym_co_yield] = ACTIONS(3238),
    [anon_sym_R_DQUOTE] = ACTIONS(3240),
    [anon_sym_LR_DQUOTE] = ACTIONS(3240),
    [anon_sym_uR_DQUOTE] = ACTIONS(3240),
    [anon_sym_UR_DQUOTE] = ACTIONS(3240),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3240),
    [anon_sym_co_await] = ACTIONS(3238),
    [anon_sym_new] = ACTIONS(3238),
    [anon_sym_requires] = ACTIONS(3238),
    [sym_this] = ACTIONS(3238),
    [anon_sym_discard] = ACTIONS(3238),
    [anon_sym_precise] = ACTIONS(3238),
    [anon_sym_shared] = ACTIONS(3238),
    [anon_sym_groupshared] = ACTIONS(3238),
    [anon_sym_uniform] = ACTIONS(3238),
    [anon_sym_row_major] = ACTIONS(3238),
    [anon_sym_column_major] = ACTIONS(3238),
    [anon_sym_globallycoherent] = ACTIONS(3238),
    [anon_sym_centroid] = ACTIONS(3238),
    [anon_sym_noperspective] = ACTIONS(3238),
    [anon_sym_nointerpolation] = ACTIONS(3238),
    [anon_sym_sample] = ACTIONS(3238),
    [anon_sym_linear] = ACTIONS(3238),
    [anon_sym_snorm] = ACTIONS(3238),
    [anon_sym_unorm] = ACTIONS(3238),
    [anon_sym_point] = ACTIONS(3238),
    [anon_sym_line] = ACTIONS(3238),
    [anon_sym_triangleadj] = ACTIONS(3238),
    [anon_sym_lineadj] = ACTIONS(3238),
    [anon_sym_triangle] = ACTIONS(3238),
    [anon_sym_cbuffer] = ACTIONS(3238),
    [anon_sym_interface] = ACTIONS(3238),
    [anon_sym_extension] = ACTIONS(3238),
  },
  [798] = {
    [sym_identifier] = ACTIONS(3054),
    [aux_sym_preproc_include_token1] = ACTIONS(3054),
    [aux_sym_preproc_def_token1] = ACTIONS(3054),
    [aux_sym_preproc_if_token1] = ACTIONS(3054),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3054),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3054),
    [sym_preproc_directive] = ACTIONS(3054),
    [anon_sym_LPAREN2] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3052),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3054),
    [anon_sym_PLUS] = ACTIONS(3054),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3054),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym___extension__] = ACTIONS(3054),
    [anon_sym_typedef] = ACTIONS(3054),
    [anon_sym_in] = ACTIONS(3054),
    [anon_sym_out] = ACTIONS(3054),
    [anon_sym_inout] = ACTIONS(3054),
    [anon_sym_extern] = ACTIONS(3054),
    [anon_sym___attribute__] = ACTIONS(3054),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3052),
    [anon_sym___declspec] = ACTIONS(3054),
    [anon_sym___based] = ACTIONS(3054),
    [anon_sym___cdecl] = ACTIONS(3054),
    [anon_sym___clrcall] = ACTIONS(3054),
    [anon_sym___stdcall] = ACTIONS(3054),
    [anon_sym___fastcall] = ACTIONS(3054),
    [anon_sym___thiscall] = ACTIONS(3054),
    [anon_sym___vectorcall] = ACTIONS(3054),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_RBRACE] = ACTIONS(3052),
    [anon_sym_signed] = ACTIONS(3054),
    [anon_sym_unsigned] = ACTIONS(3054),
    [anon_sym_long] = ACTIONS(3054),
    [anon_sym_short] = ACTIONS(3054),
    [anon_sym_LBRACK] = ACTIONS(3054),
    [anon_sym_static] = ACTIONS(3054),
    [anon_sym_register] = ACTIONS(3054),
    [anon_sym_inline] = ACTIONS(3054),
    [anon_sym___inline] = ACTIONS(3054),
    [anon_sym___inline__] = ACTIONS(3054),
    [anon_sym___forceinline] = ACTIONS(3054),
    [anon_sym_thread_local] = ACTIONS(3054),
    [anon_sym___thread] = ACTIONS(3054),
    [anon_sym_const] = ACTIONS(3054),
    [anon_sym_constexpr] = ACTIONS(3054),
    [anon_sym_volatile] = ACTIONS(3054),
    [anon_sym_restrict] = ACTIONS(3054),
    [anon_sym___restrict__] = ACTIONS(3054),
    [anon_sym__Atomic] = ACTIONS(3054),
    [anon_sym__Noreturn] = ACTIONS(3054),
    [anon_sym_noreturn] = ACTIONS(3054),
    [anon_sym_mutable] = ACTIONS(3054),
    [anon_sym_constinit] = ACTIONS(3054),
    [anon_sym_consteval] = ACTIONS(3054),
    [anon_sym_alignas] = ACTIONS(3054),
    [anon_sym__Alignas] = ACTIONS(3054),
    [sym_primitive_type] = ACTIONS(3054),
    [anon_sym_enum] = ACTIONS(3054),
    [anon_sym_class] = ACTIONS(3054),
    [anon_sym_struct] = ACTIONS(3054),
    [anon_sym_union] = ACTIONS(3054),
    [anon_sym_if] = ACTIONS(3054),
    [anon_sym_switch] = ACTIONS(3054),
    [anon_sym_case] = ACTIONS(3054),
    [anon_sym_default] = ACTIONS(3054),
    [anon_sym_while] = ACTIONS(3054),
    [anon_sym_do] = ACTIONS(3054),
    [anon_sym_for] = ACTIONS(3054),
    [anon_sym_return] = ACTIONS(3054),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_continue] = ACTIONS(3054),
    [anon_sym_goto] = ACTIONS(3054),
    [anon_sym___try] = ACTIONS(3054),
    [anon_sym___leave] = ACTIONS(3054),
    [anon_sym_not] = ACTIONS(3054),
    [anon_sym_compl] = ACTIONS(3054),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_sizeof] = ACTIONS(3054),
    [anon_sym___alignof__] = ACTIONS(3054),
    [anon_sym___alignof] = ACTIONS(3054),
    [anon_sym__alignof] = ACTIONS(3054),
    [anon_sym_alignof] = ACTIONS(3054),
    [anon_sym__Alignof] = ACTIONS(3054),
    [anon_sym_offsetof] = ACTIONS(3054),
    [anon_sym__Generic] = ACTIONS(3054),
    [anon_sym_asm] = ACTIONS(3054),
    [anon_sym___asm__] = ACTIONS(3054),
    [anon_sym_DOT] = ACTIONS(3054),
    [sym_number_literal] = ACTIONS(3052),
    [anon_sym_L_SQUOTE] = ACTIONS(3052),
    [anon_sym_u_SQUOTE] = ACTIONS(3052),
    [anon_sym_U_SQUOTE] = ACTIONS(3052),
    [anon_sym_u8_SQUOTE] = ACTIONS(3052),
    [anon_sym_SQUOTE] = ACTIONS(3052),
    [anon_sym_L_DQUOTE] = ACTIONS(3052),
    [anon_sym_u_DQUOTE] = ACTIONS(3052),
    [anon_sym_U_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8_DQUOTE] = ACTIONS(3052),
    [anon_sym_DQUOTE] = ACTIONS(3052),
    [sym_true] = ACTIONS(3054),
    [sym_false] = ACTIONS(3054),
    [anon_sym_NULL] = ACTIONS(3054),
    [anon_sym_nullptr] = ACTIONS(3054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3054),
    [anon_sym_let] = ACTIONS(3054),
    [anon_sym_This] = ACTIONS(3054),
    [anon_sym_decltype] = ACTIONS(3054),
    [sym_virtual] = ACTIONS(3054),
    [anon_sym_explicit] = ACTIONS(3054),
    [anon_sym_typename] = ACTIONS(3054),
    [anon_sym_template] = ACTIONS(3054),
    [anon_sym_operator] = ACTIONS(3054),
    [anon_sym_try] = ACTIONS(3054),
    [anon_sym_delete] = ACTIONS(3054),
    [anon_sym_throw] = ACTIONS(3054),
    [anon_sym_namespace] = ACTIONS(3054),
    [anon_sym_using] = ACTIONS(3054),
    [anon_sym_static_assert] = ACTIONS(3054),
    [anon_sym_concept] = ACTIONS(3054),
    [anon_sym_co_return] = ACTIONS(3054),
    [anon_sym_co_yield] = ACTIONS(3054),
    [anon_sym_R_DQUOTE] = ACTIONS(3052),
    [anon_sym_LR_DQUOTE] = ACTIONS(3052),
    [anon_sym_uR_DQUOTE] = ACTIONS(3052),
    [anon_sym_UR_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3052),
    [anon_sym_co_await] = ACTIONS(3054),
    [anon_sym_new] = ACTIONS(3054),
    [anon_sym_requires] = ACTIONS(3054),
    [sym_this] = ACTIONS(3054),
    [anon_sym_discard] = ACTIONS(3054),
    [anon_sym_precise] = ACTIONS(3054),
    [anon_sym_shared] = ACTIONS(3054),
    [anon_sym_groupshared] = ACTIONS(3054),
    [anon_sym_uniform] = ACTIONS(3054),
    [anon_sym_row_major] = ACTIONS(3054),
    [anon_sym_column_major] = ACTIONS(3054),
    [anon_sym_globallycoherent] = ACTIONS(3054),
    [anon_sym_centroid] = ACTIONS(3054),
    [anon_sym_noperspective] = ACTIONS(3054),
    [anon_sym_nointerpolation] = ACTIONS(3054),
    [anon_sym_sample] = ACTIONS(3054),
    [anon_sym_linear] = ACTIONS(3054),
    [anon_sym_snorm] = ACTIONS(3054),
    [anon_sym_unorm] = ACTIONS(3054),
    [anon_sym_point] = ACTIONS(3054),
    [anon_sym_line] = ACTIONS(3054),
    [anon_sym_triangleadj] = ACTIONS(3054),
    [anon_sym_lineadj] = ACTIONS(3054),
    [anon_sym_triangle] = ACTIONS(3054),
    [anon_sym_cbuffer] = ACTIONS(3054),
    [anon_sym_interface] = ACTIONS(3054),
    [anon_sym_extension] = ACTIONS(3054),
  },
  [799] = {
    [sym_identifier] = ACTIONS(3022),
    [aux_sym_preproc_include_token1] = ACTIONS(3022),
    [aux_sym_preproc_def_token1] = ACTIONS(3022),
    [aux_sym_preproc_if_token1] = ACTIONS(3022),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3022),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3022),
    [sym_preproc_directive] = ACTIONS(3022),
    [anon_sym_LPAREN2] = ACTIONS(3024),
    [anon_sym_BANG] = ACTIONS(3024),
    [anon_sym_TILDE] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3022),
    [anon_sym_PLUS] = ACTIONS(3022),
    [anon_sym_STAR] = ACTIONS(3024),
    [anon_sym_AMP_AMP] = ACTIONS(3024),
    [anon_sym_AMP] = ACTIONS(3022),
    [anon_sym_SEMI] = ACTIONS(3024),
    [anon_sym___extension__] = ACTIONS(3022),
    [anon_sym_typedef] = ACTIONS(3022),
    [anon_sym_in] = ACTIONS(3022),
    [anon_sym_out] = ACTIONS(3022),
    [anon_sym_inout] = ACTIONS(3022),
    [anon_sym_extern] = ACTIONS(3022),
    [anon_sym___attribute__] = ACTIONS(3022),
    [anon_sym_COLON_COLON] = ACTIONS(3024),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3024),
    [anon_sym___declspec] = ACTIONS(3022),
    [anon_sym___based] = ACTIONS(3022),
    [anon_sym___cdecl] = ACTIONS(3022),
    [anon_sym___clrcall] = ACTIONS(3022),
    [anon_sym___stdcall] = ACTIONS(3022),
    [anon_sym___fastcall] = ACTIONS(3022),
    [anon_sym___thiscall] = ACTIONS(3022),
    [anon_sym___vectorcall] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_RBRACE] = ACTIONS(3024),
    [anon_sym_signed] = ACTIONS(3022),
    [anon_sym_unsigned] = ACTIONS(3022),
    [anon_sym_long] = ACTIONS(3022),
    [anon_sym_short] = ACTIONS(3022),
    [anon_sym_LBRACK] = ACTIONS(3022),
    [anon_sym_static] = ACTIONS(3022),
    [anon_sym_register] = ACTIONS(3022),
    [anon_sym_inline] = ACTIONS(3022),
    [anon_sym___inline] = ACTIONS(3022),
    [anon_sym___inline__] = ACTIONS(3022),
    [anon_sym___forceinline] = ACTIONS(3022),
    [anon_sym_thread_local] = ACTIONS(3022),
    [anon_sym___thread] = ACTIONS(3022),
    [anon_sym_const] = ACTIONS(3022),
    [anon_sym_constexpr] = ACTIONS(3022),
    [anon_sym_volatile] = ACTIONS(3022),
    [anon_sym_restrict] = ACTIONS(3022),
    [anon_sym___restrict__] = ACTIONS(3022),
    [anon_sym__Atomic] = ACTIONS(3022),
    [anon_sym__Noreturn] = ACTIONS(3022),
    [anon_sym_noreturn] = ACTIONS(3022),
    [anon_sym_mutable] = ACTIONS(3022),
    [anon_sym_constinit] = ACTIONS(3022),
    [anon_sym_consteval] = ACTIONS(3022),
    [anon_sym_alignas] = ACTIONS(3022),
    [anon_sym__Alignas] = ACTIONS(3022),
    [sym_primitive_type] = ACTIONS(3022),
    [anon_sym_enum] = ACTIONS(3022),
    [anon_sym_class] = ACTIONS(3022),
    [anon_sym_struct] = ACTIONS(3022),
    [anon_sym_union] = ACTIONS(3022),
    [anon_sym_if] = ACTIONS(3022),
    [anon_sym_else] = ACTIONS(3022),
    [anon_sym_switch] = ACTIONS(3022),
    [anon_sym_case] = ACTIONS(3022),
    [anon_sym_default] = ACTIONS(3022),
    [anon_sym_while] = ACTIONS(3022),
    [anon_sym_do] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(3022),
    [anon_sym_return] = ACTIONS(3022),
    [anon_sym_break] = ACTIONS(3022),
    [anon_sym_continue] = ACTIONS(3022),
    [anon_sym_goto] = ACTIONS(3022),
    [anon_sym___try] = ACTIONS(3022),
    [anon_sym___leave] = ACTIONS(3022),
    [anon_sym_not] = ACTIONS(3022),
    [anon_sym_compl] = ACTIONS(3022),
    [anon_sym_DASH_DASH] = ACTIONS(3024),
    [anon_sym_PLUS_PLUS] = ACTIONS(3024),
    [anon_sym_sizeof] = ACTIONS(3022),
    [anon_sym___alignof__] = ACTIONS(3022),
    [anon_sym___alignof] = ACTIONS(3022),
    [anon_sym__alignof] = ACTIONS(3022),
    [anon_sym_alignof] = ACTIONS(3022),
    [anon_sym__Alignof] = ACTIONS(3022),
    [anon_sym_offsetof] = ACTIONS(3022),
    [anon_sym__Generic] = ACTIONS(3022),
    [anon_sym_asm] = ACTIONS(3022),
    [anon_sym___asm__] = ACTIONS(3022),
    [sym_number_literal] = ACTIONS(3024),
    [anon_sym_L_SQUOTE] = ACTIONS(3024),
    [anon_sym_u_SQUOTE] = ACTIONS(3024),
    [anon_sym_U_SQUOTE] = ACTIONS(3024),
    [anon_sym_u8_SQUOTE] = ACTIONS(3024),
    [anon_sym_SQUOTE] = ACTIONS(3024),
    [anon_sym_L_DQUOTE] = ACTIONS(3024),
    [anon_sym_u_DQUOTE] = ACTIONS(3024),
    [anon_sym_U_DQUOTE] = ACTIONS(3024),
    [anon_sym_u8_DQUOTE] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3024),
    [sym_true] = ACTIONS(3022),
    [sym_false] = ACTIONS(3022),
    [anon_sym_NULL] = ACTIONS(3022),
    [anon_sym_nullptr] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3022),
    [anon_sym_let] = ACTIONS(3022),
    [anon_sym_This] = ACTIONS(3022),
    [anon_sym_decltype] = ACTIONS(3022),
    [sym_virtual] = ACTIONS(3022),
    [anon_sym_explicit] = ACTIONS(3022),
    [anon_sym_typename] = ACTIONS(3022),
    [anon_sym_template] = ACTIONS(3022),
    [anon_sym_operator] = ACTIONS(3022),
    [anon_sym_try] = ACTIONS(3022),
    [anon_sym_delete] = ACTIONS(3022),
    [anon_sym_throw] = ACTIONS(3022),
    [anon_sym_namespace] = ACTIONS(3022),
    [anon_sym_using] = ACTIONS(3022),
    [anon_sym_static_assert] = ACTIONS(3022),
    [anon_sym_concept] = ACTIONS(3022),
    [anon_sym_co_return] = ACTIONS(3022),
    [anon_sym_co_yield] = ACTIONS(3022),
    [anon_sym_R_DQUOTE] = ACTIONS(3024),
    [anon_sym_LR_DQUOTE] = ACTIONS(3024),
    [anon_sym_uR_DQUOTE] = ACTIONS(3024),
    [anon_sym_UR_DQUOTE] = ACTIONS(3024),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3024),
    [anon_sym_co_await] = ACTIONS(3022),
    [anon_sym_new] = ACTIONS(3022),
    [anon_sym_requires] = ACTIONS(3022),
    [sym_this] = ACTIONS(3022),
    [anon_sym_discard] = ACTIONS(3022),
    [anon_sym_precise] = ACTIONS(3022),
    [anon_sym_shared] = ACTIONS(3022),
    [anon_sym_groupshared] = ACTIONS(3022),
    [anon_sym_uniform] = ACTIONS(3022),
    [anon_sym_row_major] = ACTIONS(3022),
    [anon_sym_column_major] = ACTIONS(3022),
    [anon_sym_globallycoherent] = ACTIONS(3022),
    [anon_sym_centroid] = ACTIONS(3022),
    [anon_sym_noperspective] = ACTIONS(3022),
    [anon_sym_nointerpolation] = ACTIONS(3022),
    [anon_sym_sample] = ACTIONS(3022),
    [anon_sym_linear] = ACTIONS(3022),
    [anon_sym_snorm] = ACTIONS(3022),
    [anon_sym_unorm] = ACTIONS(3022),
    [anon_sym_point] = ACTIONS(3022),
    [anon_sym_line] = ACTIONS(3022),
    [anon_sym_triangleadj] = ACTIONS(3022),
    [anon_sym_lineadj] = ACTIONS(3022),
    [anon_sym_triangle] = ACTIONS(3022),
    [anon_sym_cbuffer] = ACTIONS(3022),
    [anon_sym_interface] = ACTIONS(3022),
    [anon_sym_extension] = ACTIONS(3022),
  },
  [800] = {
    [sym_identifier] = ACTIONS(3008),
    [aux_sym_preproc_include_token1] = ACTIONS(3008),
    [aux_sym_preproc_def_token1] = ACTIONS(3008),
    [aux_sym_preproc_if_token1] = ACTIONS(3008),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3008),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3008),
    [sym_preproc_directive] = ACTIONS(3008),
    [anon_sym_LPAREN2] = ACTIONS(3010),
    [anon_sym_BANG] = ACTIONS(3010),
    [anon_sym_TILDE] = ACTIONS(3010),
    [anon_sym_DASH] = ACTIONS(3008),
    [anon_sym_PLUS] = ACTIONS(3008),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_AMP_AMP] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3008),
    [anon_sym_SEMI] = ACTIONS(3010),
    [anon_sym___extension__] = ACTIONS(3008),
    [anon_sym_typedef] = ACTIONS(3008),
    [anon_sym_in] = ACTIONS(3008),
    [anon_sym_out] = ACTIONS(3008),
    [anon_sym_inout] = ACTIONS(3008),
    [anon_sym_extern] = ACTIONS(3008),
    [anon_sym___attribute__] = ACTIONS(3008),
    [anon_sym_COLON_COLON] = ACTIONS(3010),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3010),
    [anon_sym___declspec] = ACTIONS(3008),
    [anon_sym___based] = ACTIONS(3008),
    [anon_sym___cdecl] = ACTIONS(3008),
    [anon_sym___clrcall] = ACTIONS(3008),
    [anon_sym___stdcall] = ACTIONS(3008),
    [anon_sym___fastcall] = ACTIONS(3008),
    [anon_sym___thiscall] = ACTIONS(3008),
    [anon_sym___vectorcall] = ACTIONS(3008),
    [anon_sym_LBRACE] = ACTIONS(3010),
    [anon_sym_RBRACE] = ACTIONS(3010),
    [anon_sym_signed] = ACTIONS(3008),
    [anon_sym_unsigned] = ACTIONS(3008),
    [anon_sym_long] = ACTIONS(3008),
    [anon_sym_short] = ACTIONS(3008),
    [anon_sym_LBRACK] = ACTIONS(3008),
    [anon_sym_static] = ACTIONS(3008),
    [anon_sym_register] = ACTIONS(3008),
    [anon_sym_inline] = ACTIONS(3008),
    [anon_sym___inline] = ACTIONS(3008),
    [anon_sym___inline__] = ACTIONS(3008),
    [anon_sym___forceinline] = ACTIONS(3008),
    [anon_sym_thread_local] = ACTIONS(3008),
    [anon_sym___thread] = ACTIONS(3008),
    [anon_sym_const] = ACTIONS(3008),
    [anon_sym_constexpr] = ACTIONS(3008),
    [anon_sym_volatile] = ACTIONS(3008),
    [anon_sym_restrict] = ACTIONS(3008),
    [anon_sym___restrict__] = ACTIONS(3008),
    [anon_sym__Atomic] = ACTIONS(3008),
    [anon_sym__Noreturn] = ACTIONS(3008),
    [anon_sym_noreturn] = ACTIONS(3008),
    [anon_sym_mutable] = ACTIONS(3008),
    [anon_sym_constinit] = ACTIONS(3008),
    [anon_sym_consteval] = ACTIONS(3008),
    [anon_sym_alignas] = ACTIONS(3008),
    [anon_sym__Alignas] = ACTIONS(3008),
    [sym_primitive_type] = ACTIONS(3008),
    [anon_sym_enum] = ACTIONS(3008),
    [anon_sym_class] = ACTIONS(3008),
    [anon_sym_struct] = ACTIONS(3008),
    [anon_sym_union] = ACTIONS(3008),
    [anon_sym_if] = ACTIONS(3008),
    [anon_sym_else] = ACTIONS(3008),
    [anon_sym_switch] = ACTIONS(3008),
    [anon_sym_case] = ACTIONS(3008),
    [anon_sym_default] = ACTIONS(3008),
    [anon_sym_while] = ACTIONS(3008),
    [anon_sym_do] = ACTIONS(3008),
    [anon_sym_for] = ACTIONS(3008),
    [anon_sym_return] = ACTIONS(3008),
    [anon_sym_break] = ACTIONS(3008),
    [anon_sym_continue] = ACTIONS(3008),
    [anon_sym_goto] = ACTIONS(3008),
    [anon_sym___try] = ACTIONS(3008),
    [anon_sym___leave] = ACTIONS(3008),
    [anon_sym_not] = ACTIONS(3008),
    [anon_sym_compl] = ACTIONS(3008),
    [anon_sym_DASH_DASH] = ACTIONS(3010),
    [anon_sym_PLUS_PLUS] = ACTIONS(3010),
    [anon_sym_sizeof] = ACTIONS(3008),
    [anon_sym___alignof__] = ACTIONS(3008),
    [anon_sym___alignof] = ACTIONS(3008),
    [anon_sym__alignof] = ACTIONS(3008),
    [anon_sym_alignof] = ACTIONS(3008),
    [anon_sym__Alignof] = ACTIONS(3008),
    [anon_sym_offsetof] = ACTIONS(3008),
    [anon_sym__Generic] = ACTIONS(3008),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [sym_number_literal] = ACTIONS(3010),
    [anon_sym_L_SQUOTE] = ACTIONS(3010),
    [anon_sym_u_SQUOTE] = ACTIONS(3010),
    [anon_sym_U_SQUOTE] = ACTIONS(3010),
    [anon_sym_u8_SQUOTE] = ACTIONS(3010),
    [anon_sym_SQUOTE] = ACTIONS(3010),
    [anon_sym_L_DQUOTE] = ACTIONS(3010),
    [anon_sym_u_DQUOTE] = ACTIONS(3010),
    [anon_sym_U_DQUOTE] = ACTIONS(3010),
    [anon_sym_u8_DQUOTE] = ACTIONS(3010),
    [anon_sym_DQUOTE] = ACTIONS(3010),
    [sym_true] = ACTIONS(3008),
    [sym_false] = ACTIONS(3008),
    [anon_sym_NULL] = ACTIONS(3008),
    [anon_sym_nullptr] = ACTIONS(3008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3008),
    [anon_sym_let] = ACTIONS(3008),
    [anon_sym_This] = ACTIONS(3008),
    [anon_sym_decltype] = ACTIONS(3008),
    [sym_virtual] = ACTIONS(3008),
    [anon_sym_explicit] = ACTIONS(3008),
    [anon_sym_typename] = ACTIONS(3008),
    [anon_sym_template] = ACTIONS(3008),
    [anon_sym_operator] = ACTIONS(3008),
    [anon_sym_try] = ACTIONS(3008),
    [anon_sym_delete] = ACTIONS(3008),
    [anon_sym_throw] = ACTIONS(3008),
    [anon_sym_namespace] = ACTIONS(3008),
    [anon_sym_using] = ACTIONS(3008),
    [anon_sym_static_assert] = ACTIONS(3008),
    [anon_sym_concept] = ACTIONS(3008),
    [anon_sym_co_return] = ACTIONS(3008),
    [anon_sym_co_yield] = ACTIONS(3008),
    [anon_sym_R_DQUOTE] = ACTIONS(3010),
    [anon_sym_LR_DQUOTE] = ACTIONS(3010),
    [anon_sym_uR_DQUOTE] = ACTIONS(3010),
    [anon_sym_UR_DQUOTE] = ACTIONS(3010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3010),
    [anon_sym_co_await] = ACTIONS(3008),
    [anon_sym_new] = ACTIONS(3008),
    [anon_sym_requires] = ACTIONS(3008),
    [sym_this] = ACTIONS(3008),
    [anon_sym_discard] = ACTIONS(3008),
    [anon_sym_precise] = ACTIONS(3008),
    [anon_sym_shared] = ACTIONS(3008),
    [anon_sym_groupshared] = ACTIONS(3008),
    [anon_sym_uniform] = ACTIONS(3008),
    [anon_sym_row_major] = ACTIONS(3008),
    [anon_sym_column_major] = ACTIONS(3008),
    [anon_sym_globallycoherent] = ACTIONS(3008),
    [anon_sym_centroid] = ACTIONS(3008),
    [anon_sym_noperspective] = ACTIONS(3008),
    [anon_sym_nointerpolation] = ACTIONS(3008),
    [anon_sym_sample] = ACTIONS(3008),
    [anon_sym_linear] = ACTIONS(3008),
    [anon_sym_snorm] = ACTIONS(3008),
    [anon_sym_unorm] = ACTIONS(3008),
    [anon_sym_point] = ACTIONS(3008),
    [anon_sym_line] = ACTIONS(3008),
    [anon_sym_triangleadj] = ACTIONS(3008),
    [anon_sym_lineadj] = ACTIONS(3008),
    [anon_sym_triangle] = ACTIONS(3008),
    [anon_sym_cbuffer] = ACTIONS(3008),
    [anon_sym_interface] = ACTIONS(3008),
    [anon_sym_extension] = ACTIONS(3008),
  },
  [801] = {
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_include_token1] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3080),
    [anon_sym_BANG] = ACTIONS(3080),
    [anon_sym_TILDE] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_STAR] = ACTIONS(3080),
    [anon_sym_AMP_AMP] = ACTIONS(3080),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_in] = ACTIONS(3082),
    [anon_sym_out] = ACTIONS(3082),
    [anon_sym_inout] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3080),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3080),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym___cdecl] = ACTIONS(3082),
    [anon_sym___clrcall] = ACTIONS(3082),
    [anon_sym___stdcall] = ACTIONS(3082),
    [anon_sym___fastcall] = ACTIONS(3082),
    [anon_sym___thiscall] = ACTIONS(3082),
    [anon_sym___vectorcall] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3080),
    [anon_sym_RBRACE] = ACTIONS(3080),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym__Alignas] = ACTIONS(3082),
    [sym_primitive_type] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_case] = ACTIONS(3082),
    [anon_sym_default] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_goto] = ACTIONS(3082),
    [anon_sym___try] = ACTIONS(3082),
    [anon_sym___leave] = ACTIONS(3082),
    [anon_sym_not] = ACTIONS(3082),
    [anon_sym_compl] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3080),
    [anon_sym_PLUS_PLUS] = ACTIONS(3080),
    [anon_sym_sizeof] = ACTIONS(3082),
    [anon_sym___alignof__] = ACTIONS(3082),
    [anon_sym___alignof] = ACTIONS(3082),
    [anon_sym__alignof] = ACTIONS(3082),
    [anon_sym_alignof] = ACTIONS(3082),
    [anon_sym__Alignof] = ACTIONS(3082),
    [anon_sym_offsetof] = ACTIONS(3082),
    [anon_sym__Generic] = ACTIONS(3082),
    [anon_sym_asm] = ACTIONS(3082),
    [anon_sym___asm__] = ACTIONS(3082),
    [anon_sym_DOT] = ACTIONS(3082),
    [sym_number_literal] = ACTIONS(3080),
    [anon_sym_L_SQUOTE] = ACTIONS(3080),
    [anon_sym_u_SQUOTE] = ACTIONS(3080),
    [anon_sym_U_SQUOTE] = ACTIONS(3080),
    [anon_sym_u8_SQUOTE] = ACTIONS(3080),
    [anon_sym_SQUOTE] = ACTIONS(3080),
    [anon_sym_L_DQUOTE] = ACTIONS(3080),
    [anon_sym_u_DQUOTE] = ACTIONS(3080),
    [anon_sym_U_DQUOTE] = ACTIONS(3080),
    [anon_sym_u8_DQUOTE] = ACTIONS(3080),
    [anon_sym_DQUOTE] = ACTIONS(3080),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [anon_sym_NULL] = ACTIONS(3082),
    [anon_sym_nullptr] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3082),
    [anon_sym_let] = ACTIONS(3082),
    [anon_sym_This] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [sym_virtual] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_namespace] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
    [anon_sym_concept] = ACTIONS(3082),
    [anon_sym_co_return] = ACTIONS(3082),
    [anon_sym_co_yield] = ACTIONS(3082),
    [anon_sym_R_DQUOTE] = ACTIONS(3080),
    [anon_sym_LR_DQUOTE] = ACTIONS(3080),
    [anon_sym_uR_DQUOTE] = ACTIONS(3080),
    [anon_sym_UR_DQUOTE] = ACTIONS(3080),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3080),
    [anon_sym_co_await] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_requires] = ACTIONS(3082),
    [sym_this] = ACTIONS(3082),
    [anon_sym_discard] = ACTIONS(3082),
    [anon_sym_precise] = ACTIONS(3082),
    [anon_sym_shared] = ACTIONS(3082),
    [anon_sym_groupshared] = ACTIONS(3082),
    [anon_sym_uniform] = ACTIONS(3082),
    [anon_sym_row_major] = ACTIONS(3082),
    [anon_sym_column_major] = ACTIONS(3082),
    [anon_sym_globallycoherent] = ACTIONS(3082),
    [anon_sym_centroid] = ACTIONS(3082),
    [anon_sym_noperspective] = ACTIONS(3082),
    [anon_sym_nointerpolation] = ACTIONS(3082),
    [anon_sym_sample] = ACTIONS(3082),
    [anon_sym_linear] = ACTIONS(3082),
    [anon_sym_snorm] = ACTIONS(3082),
    [anon_sym_unorm] = ACTIONS(3082),
    [anon_sym_point] = ACTIONS(3082),
    [anon_sym_line] = ACTIONS(3082),
    [anon_sym_triangleadj] = ACTIONS(3082),
    [anon_sym_lineadj] = ACTIONS(3082),
    [anon_sym_triangle] = ACTIONS(3082),
    [anon_sym_cbuffer] = ACTIONS(3082),
    [anon_sym_interface] = ACTIONS(3082),
    [anon_sym_extension] = ACTIONS(3082),
  },
  [802] = {
    [sym_identifier] = ACTIONS(3018),
    [aux_sym_preproc_include_token1] = ACTIONS(3018),
    [aux_sym_preproc_def_token1] = ACTIONS(3018),
    [aux_sym_preproc_if_token1] = ACTIONS(3018),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3018),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3018),
    [sym_preproc_directive] = ACTIONS(3018),
    [anon_sym_LPAREN2] = ACTIONS(3020),
    [anon_sym_BANG] = ACTIONS(3020),
    [anon_sym_TILDE] = ACTIONS(3020),
    [anon_sym_DASH] = ACTIONS(3018),
    [anon_sym_PLUS] = ACTIONS(3018),
    [anon_sym_STAR] = ACTIONS(3020),
    [anon_sym_AMP_AMP] = ACTIONS(3020),
    [anon_sym_AMP] = ACTIONS(3018),
    [anon_sym_SEMI] = ACTIONS(3020),
    [anon_sym___extension__] = ACTIONS(3018),
    [anon_sym_typedef] = ACTIONS(3018),
    [anon_sym_in] = ACTIONS(3018),
    [anon_sym_out] = ACTIONS(3018),
    [anon_sym_inout] = ACTIONS(3018),
    [anon_sym_extern] = ACTIONS(3018),
    [anon_sym___attribute__] = ACTIONS(3018),
    [anon_sym_COLON_COLON] = ACTIONS(3020),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3020),
    [anon_sym___declspec] = ACTIONS(3018),
    [anon_sym___based] = ACTIONS(3018),
    [anon_sym___cdecl] = ACTIONS(3018),
    [anon_sym___clrcall] = ACTIONS(3018),
    [anon_sym___stdcall] = ACTIONS(3018),
    [anon_sym___fastcall] = ACTIONS(3018),
    [anon_sym___thiscall] = ACTIONS(3018),
    [anon_sym___vectorcall] = ACTIONS(3018),
    [anon_sym_LBRACE] = ACTIONS(3020),
    [anon_sym_RBRACE] = ACTIONS(3020),
    [anon_sym_signed] = ACTIONS(3018),
    [anon_sym_unsigned] = ACTIONS(3018),
    [anon_sym_long] = ACTIONS(3018),
    [anon_sym_short] = ACTIONS(3018),
    [anon_sym_LBRACK] = ACTIONS(3018),
    [anon_sym_static] = ACTIONS(3018),
    [anon_sym_register] = ACTIONS(3018),
    [anon_sym_inline] = ACTIONS(3018),
    [anon_sym___inline] = ACTIONS(3018),
    [anon_sym___inline__] = ACTIONS(3018),
    [anon_sym___forceinline] = ACTIONS(3018),
    [anon_sym_thread_local] = ACTIONS(3018),
    [anon_sym___thread] = ACTIONS(3018),
    [anon_sym_const] = ACTIONS(3018),
    [anon_sym_constexpr] = ACTIONS(3018),
    [anon_sym_volatile] = ACTIONS(3018),
    [anon_sym_restrict] = ACTIONS(3018),
    [anon_sym___restrict__] = ACTIONS(3018),
    [anon_sym__Atomic] = ACTIONS(3018),
    [anon_sym__Noreturn] = ACTIONS(3018),
    [anon_sym_noreturn] = ACTIONS(3018),
    [anon_sym_mutable] = ACTIONS(3018),
    [anon_sym_constinit] = ACTIONS(3018),
    [anon_sym_consteval] = ACTIONS(3018),
    [anon_sym_alignas] = ACTIONS(3018),
    [anon_sym__Alignas] = ACTIONS(3018),
    [sym_primitive_type] = ACTIONS(3018),
    [anon_sym_enum] = ACTIONS(3018),
    [anon_sym_class] = ACTIONS(3018),
    [anon_sym_struct] = ACTIONS(3018),
    [anon_sym_union] = ACTIONS(3018),
    [anon_sym_if] = ACTIONS(3018),
    [anon_sym_else] = ACTIONS(3018),
    [anon_sym_switch] = ACTIONS(3018),
    [anon_sym_case] = ACTIONS(3018),
    [anon_sym_default] = ACTIONS(3018),
    [anon_sym_while] = ACTIONS(3018),
    [anon_sym_do] = ACTIONS(3018),
    [anon_sym_for] = ACTIONS(3018),
    [anon_sym_return] = ACTIONS(3018),
    [anon_sym_break] = ACTIONS(3018),
    [anon_sym_continue] = ACTIONS(3018),
    [anon_sym_goto] = ACTIONS(3018),
    [anon_sym___try] = ACTIONS(3018),
    [anon_sym___leave] = ACTIONS(3018),
    [anon_sym_not] = ACTIONS(3018),
    [anon_sym_compl] = ACTIONS(3018),
    [anon_sym_DASH_DASH] = ACTIONS(3020),
    [anon_sym_PLUS_PLUS] = ACTIONS(3020),
    [anon_sym_sizeof] = ACTIONS(3018),
    [anon_sym___alignof__] = ACTIONS(3018),
    [anon_sym___alignof] = ACTIONS(3018),
    [anon_sym__alignof] = ACTIONS(3018),
    [anon_sym_alignof] = ACTIONS(3018),
    [anon_sym__Alignof] = ACTIONS(3018),
    [anon_sym_offsetof] = ACTIONS(3018),
    [anon_sym__Generic] = ACTIONS(3018),
    [anon_sym_asm] = ACTIONS(3018),
    [anon_sym___asm__] = ACTIONS(3018),
    [sym_number_literal] = ACTIONS(3020),
    [anon_sym_L_SQUOTE] = ACTIONS(3020),
    [anon_sym_u_SQUOTE] = ACTIONS(3020),
    [anon_sym_U_SQUOTE] = ACTIONS(3020),
    [anon_sym_u8_SQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3020),
    [anon_sym_L_DQUOTE] = ACTIONS(3020),
    [anon_sym_u_DQUOTE] = ACTIONS(3020),
    [anon_sym_U_DQUOTE] = ACTIONS(3020),
    [anon_sym_u8_DQUOTE] = ACTIONS(3020),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3018),
    [anon_sym_nullptr] = ACTIONS(3018),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3018),
    [anon_sym_let] = ACTIONS(3018),
    [anon_sym_This] = ACTIONS(3018),
    [anon_sym_decltype] = ACTIONS(3018),
    [sym_virtual] = ACTIONS(3018),
    [anon_sym_explicit] = ACTIONS(3018),
    [anon_sym_typename] = ACTIONS(3018),
    [anon_sym_template] = ACTIONS(3018),
    [anon_sym_operator] = ACTIONS(3018),
    [anon_sym_try] = ACTIONS(3018),
    [anon_sym_delete] = ACTIONS(3018),
    [anon_sym_throw] = ACTIONS(3018),
    [anon_sym_namespace] = ACTIONS(3018),
    [anon_sym_using] = ACTIONS(3018),
    [anon_sym_static_assert] = ACTIONS(3018),
    [anon_sym_concept] = ACTIONS(3018),
    [anon_sym_co_return] = ACTIONS(3018),
    [anon_sym_co_yield] = ACTIONS(3018),
    [anon_sym_R_DQUOTE] = ACTIONS(3020),
    [anon_sym_LR_DQUOTE] = ACTIONS(3020),
    [anon_sym_uR_DQUOTE] = ACTIONS(3020),
    [anon_sym_UR_DQUOTE] = ACTIONS(3020),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3020),
    [anon_sym_co_await] = ACTIONS(3018),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_requires] = ACTIONS(3018),
    [sym_this] = ACTIONS(3018),
    [anon_sym_discard] = ACTIONS(3018),
    [anon_sym_precise] = ACTIONS(3018),
    [anon_sym_shared] = ACTIONS(3018),
    [anon_sym_groupshared] = ACTIONS(3018),
    [anon_sym_uniform] = ACTIONS(3018),
    [anon_sym_row_major] = ACTIONS(3018),
    [anon_sym_column_major] = ACTIONS(3018),
    [anon_sym_globallycoherent] = ACTIONS(3018),
    [anon_sym_centroid] = ACTIONS(3018),
    [anon_sym_noperspective] = ACTIONS(3018),
    [anon_sym_nointerpolation] = ACTIONS(3018),
    [anon_sym_sample] = ACTIONS(3018),
    [anon_sym_linear] = ACTIONS(3018),
    [anon_sym_snorm] = ACTIONS(3018),
    [anon_sym_unorm] = ACTIONS(3018),
    [anon_sym_point] = ACTIONS(3018),
    [anon_sym_line] = ACTIONS(3018),
    [anon_sym_triangleadj] = ACTIONS(3018),
    [anon_sym_lineadj] = ACTIONS(3018),
    [anon_sym_triangle] = ACTIONS(3018),
    [anon_sym_cbuffer] = ACTIONS(3018),
    [anon_sym_interface] = ACTIONS(3018),
    [anon_sym_extension] = ACTIONS(3018),
  },
  [803] = {
    [sym_identifier] = ACTIONS(3038),
    [aux_sym_preproc_include_token1] = ACTIONS(3038),
    [aux_sym_preproc_def_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token2] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3038),
    [sym_preproc_directive] = ACTIONS(3038),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3038),
    [anon_sym_PLUS] = ACTIONS(3038),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3038),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3038),
    [anon_sym_typedef] = ACTIONS(3038),
    [anon_sym_in] = ACTIONS(3038),
    [anon_sym_out] = ACTIONS(3038),
    [anon_sym_inout] = ACTIONS(3038),
    [anon_sym_extern] = ACTIONS(3038),
    [anon_sym___attribute__] = ACTIONS(3038),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3040),
    [anon_sym___declspec] = ACTIONS(3038),
    [anon_sym___based] = ACTIONS(3038),
    [anon_sym___cdecl] = ACTIONS(3038),
    [anon_sym___clrcall] = ACTIONS(3038),
    [anon_sym___stdcall] = ACTIONS(3038),
    [anon_sym___fastcall] = ACTIONS(3038),
    [anon_sym___thiscall] = ACTIONS(3038),
    [anon_sym___vectorcall] = ACTIONS(3038),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_signed] = ACTIONS(3038),
    [anon_sym_unsigned] = ACTIONS(3038),
    [anon_sym_long] = ACTIONS(3038),
    [anon_sym_short] = ACTIONS(3038),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_static] = ACTIONS(3038),
    [anon_sym_register] = ACTIONS(3038),
    [anon_sym_inline] = ACTIONS(3038),
    [anon_sym___inline] = ACTIONS(3038),
    [anon_sym___inline__] = ACTIONS(3038),
    [anon_sym___forceinline] = ACTIONS(3038),
    [anon_sym_thread_local] = ACTIONS(3038),
    [anon_sym___thread] = ACTIONS(3038),
    [anon_sym_const] = ACTIONS(3038),
    [anon_sym_constexpr] = ACTIONS(3038),
    [anon_sym_volatile] = ACTIONS(3038),
    [anon_sym_restrict] = ACTIONS(3038),
    [anon_sym___restrict__] = ACTIONS(3038),
    [anon_sym__Atomic] = ACTIONS(3038),
    [anon_sym__Noreturn] = ACTIONS(3038),
    [anon_sym_noreturn] = ACTIONS(3038),
    [anon_sym_mutable] = ACTIONS(3038),
    [anon_sym_constinit] = ACTIONS(3038),
    [anon_sym_consteval] = ACTIONS(3038),
    [anon_sym_alignas] = ACTIONS(3038),
    [anon_sym__Alignas] = ACTIONS(3038),
    [sym_primitive_type] = ACTIONS(3038),
    [anon_sym_enum] = ACTIONS(3038),
    [anon_sym_class] = ACTIONS(3038),
    [anon_sym_struct] = ACTIONS(3038),
    [anon_sym_union] = ACTIONS(3038),
    [anon_sym_if] = ACTIONS(3038),
    [anon_sym_else] = ACTIONS(3038),
    [anon_sym_switch] = ACTIONS(3038),
    [anon_sym_case] = ACTIONS(3038),
    [anon_sym_default] = ACTIONS(3038),
    [anon_sym_while] = ACTIONS(3038),
    [anon_sym_do] = ACTIONS(3038),
    [anon_sym_for] = ACTIONS(3038),
    [anon_sym_return] = ACTIONS(3038),
    [anon_sym_break] = ACTIONS(3038),
    [anon_sym_continue] = ACTIONS(3038),
    [anon_sym_goto] = ACTIONS(3038),
    [anon_sym___try] = ACTIONS(3038),
    [anon_sym___leave] = ACTIONS(3038),
    [anon_sym_not] = ACTIONS(3038),
    [anon_sym_compl] = ACTIONS(3038),
    [anon_sym_DASH_DASH] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3040),
    [anon_sym_sizeof] = ACTIONS(3038),
    [anon_sym___alignof__] = ACTIONS(3038),
    [anon_sym___alignof] = ACTIONS(3038),
    [anon_sym__alignof] = ACTIONS(3038),
    [anon_sym_alignof] = ACTIONS(3038),
    [anon_sym__Alignof] = ACTIONS(3038),
    [anon_sym_offsetof] = ACTIONS(3038),
    [anon_sym__Generic] = ACTIONS(3038),
    [anon_sym_asm] = ACTIONS(3038),
    [anon_sym___asm__] = ACTIONS(3038),
    [sym_number_literal] = ACTIONS(3040),
    [anon_sym_L_SQUOTE] = ACTIONS(3040),
    [anon_sym_u_SQUOTE] = ACTIONS(3040),
    [anon_sym_U_SQUOTE] = ACTIONS(3040),
    [anon_sym_u8_SQUOTE] = ACTIONS(3040),
    [anon_sym_SQUOTE] = ACTIONS(3040),
    [anon_sym_L_DQUOTE] = ACTIONS(3040),
    [anon_sym_u_DQUOTE] = ACTIONS(3040),
    [anon_sym_U_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8_DQUOTE] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [sym_true] = ACTIONS(3038),
    [sym_false] = ACTIONS(3038),
    [anon_sym_NULL] = ACTIONS(3038),
    [anon_sym_nullptr] = ACTIONS(3038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3038),
    [anon_sym_let] = ACTIONS(3038),
    [anon_sym_This] = ACTIONS(3038),
    [anon_sym_decltype] = ACTIONS(3038),
    [sym_virtual] = ACTIONS(3038),
    [anon_sym_explicit] = ACTIONS(3038),
    [anon_sym_typename] = ACTIONS(3038),
    [anon_sym_template] = ACTIONS(3038),
    [anon_sym_operator] = ACTIONS(3038),
    [anon_sym_try] = ACTIONS(3038),
    [anon_sym_delete] = ACTIONS(3038),
    [anon_sym_throw] = ACTIONS(3038),
    [anon_sym_namespace] = ACTIONS(3038),
    [anon_sym_using] = ACTIONS(3038),
    [anon_sym_static_assert] = ACTIONS(3038),
    [anon_sym_concept] = ACTIONS(3038),
    [anon_sym_co_return] = ACTIONS(3038),
    [anon_sym_co_yield] = ACTIONS(3038),
    [anon_sym_R_DQUOTE] = ACTIONS(3040),
    [anon_sym_LR_DQUOTE] = ACTIONS(3040),
    [anon_sym_uR_DQUOTE] = ACTIONS(3040),
    [anon_sym_UR_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3040),
    [anon_sym_co_await] = ACTIONS(3038),
    [anon_sym_new] = ACTIONS(3038),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3038),
    [anon_sym_discard] = ACTIONS(3038),
    [anon_sym_precise] = ACTIONS(3038),
    [anon_sym_shared] = ACTIONS(3038),
    [anon_sym_groupshared] = ACTIONS(3038),
    [anon_sym_uniform] = ACTIONS(3038),
    [anon_sym_row_major] = ACTIONS(3038),
    [anon_sym_column_major] = ACTIONS(3038),
    [anon_sym_globallycoherent] = ACTIONS(3038),
    [anon_sym_centroid] = ACTIONS(3038),
    [anon_sym_noperspective] = ACTIONS(3038),
    [anon_sym_nointerpolation] = ACTIONS(3038),
    [anon_sym_sample] = ACTIONS(3038),
    [anon_sym_linear] = ACTIONS(3038),
    [anon_sym_snorm] = ACTIONS(3038),
    [anon_sym_unorm] = ACTIONS(3038),
    [anon_sym_point] = ACTIONS(3038),
    [anon_sym_line] = ACTIONS(3038),
    [anon_sym_triangleadj] = ACTIONS(3038),
    [anon_sym_lineadj] = ACTIONS(3038),
    [anon_sym_triangle] = ACTIONS(3038),
    [anon_sym_cbuffer] = ACTIONS(3038),
    [anon_sym_interface] = ACTIONS(3038),
    [anon_sym_extension] = ACTIONS(3038),
  },
  [804] = {
    [sym_identifier] = ACTIONS(3162),
    [aux_sym_preproc_include_token1] = ACTIONS(3162),
    [aux_sym_preproc_def_token1] = ACTIONS(3162),
    [aux_sym_preproc_if_token1] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3162),
    [sym_preproc_directive] = ACTIONS(3162),
    [anon_sym_LPAREN2] = ACTIONS(3164),
    [anon_sym_BANG] = ACTIONS(3164),
    [anon_sym_TILDE] = ACTIONS(3164),
    [anon_sym_DASH] = ACTIONS(3162),
    [anon_sym_PLUS] = ACTIONS(3162),
    [anon_sym_STAR] = ACTIONS(3164),
    [anon_sym_AMP_AMP] = ACTIONS(3164),
    [anon_sym_AMP] = ACTIONS(3162),
    [anon_sym_SEMI] = ACTIONS(3164),
    [anon_sym___extension__] = ACTIONS(3162),
    [anon_sym_typedef] = ACTIONS(3162),
    [anon_sym_in] = ACTIONS(3162),
    [anon_sym_out] = ACTIONS(3162),
    [anon_sym_inout] = ACTIONS(3162),
    [anon_sym_extern] = ACTIONS(3162),
    [anon_sym___attribute__] = ACTIONS(3162),
    [anon_sym_COLON_COLON] = ACTIONS(3164),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3164),
    [anon_sym___declspec] = ACTIONS(3162),
    [anon_sym___based] = ACTIONS(3162),
    [anon_sym___cdecl] = ACTIONS(3162),
    [anon_sym___clrcall] = ACTIONS(3162),
    [anon_sym___stdcall] = ACTIONS(3162),
    [anon_sym___fastcall] = ACTIONS(3162),
    [anon_sym___thiscall] = ACTIONS(3162),
    [anon_sym___vectorcall] = ACTIONS(3162),
    [anon_sym_LBRACE] = ACTIONS(3164),
    [anon_sym_RBRACE] = ACTIONS(3164),
    [anon_sym_signed] = ACTIONS(3162),
    [anon_sym_unsigned] = ACTIONS(3162),
    [anon_sym_long] = ACTIONS(3162),
    [anon_sym_short] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(3162),
    [anon_sym_static] = ACTIONS(3162),
    [anon_sym_register] = ACTIONS(3162),
    [anon_sym_inline] = ACTIONS(3162),
    [anon_sym___inline] = ACTIONS(3162),
    [anon_sym___inline__] = ACTIONS(3162),
    [anon_sym___forceinline] = ACTIONS(3162),
    [anon_sym_thread_local] = ACTIONS(3162),
    [anon_sym___thread] = ACTIONS(3162),
    [anon_sym_const] = ACTIONS(3162),
    [anon_sym_constexpr] = ACTIONS(3162),
    [anon_sym_volatile] = ACTIONS(3162),
    [anon_sym_restrict] = ACTIONS(3162),
    [anon_sym___restrict__] = ACTIONS(3162),
    [anon_sym__Atomic] = ACTIONS(3162),
    [anon_sym__Noreturn] = ACTIONS(3162),
    [anon_sym_noreturn] = ACTIONS(3162),
    [anon_sym_mutable] = ACTIONS(3162),
    [anon_sym_constinit] = ACTIONS(3162),
    [anon_sym_consteval] = ACTIONS(3162),
    [anon_sym_alignas] = ACTIONS(3162),
    [anon_sym__Alignas] = ACTIONS(3162),
    [sym_primitive_type] = ACTIONS(3162),
    [anon_sym_enum] = ACTIONS(3162),
    [anon_sym_class] = ACTIONS(3162),
    [anon_sym_struct] = ACTIONS(3162),
    [anon_sym_union] = ACTIONS(3162),
    [anon_sym_if] = ACTIONS(3162),
    [anon_sym_else] = ACTIONS(3162),
    [anon_sym_switch] = ACTIONS(3162),
    [anon_sym_case] = ACTIONS(3162),
    [anon_sym_default] = ACTIONS(3162),
    [anon_sym_while] = ACTIONS(3162),
    [anon_sym_do] = ACTIONS(3162),
    [anon_sym_for] = ACTIONS(3162),
    [anon_sym_return] = ACTIONS(3162),
    [anon_sym_break] = ACTIONS(3162),
    [anon_sym_continue] = ACTIONS(3162),
    [anon_sym_goto] = ACTIONS(3162),
    [anon_sym___try] = ACTIONS(3162),
    [anon_sym___leave] = ACTIONS(3162),
    [anon_sym_not] = ACTIONS(3162),
    [anon_sym_compl] = ACTIONS(3162),
    [anon_sym_DASH_DASH] = ACTIONS(3164),
    [anon_sym_PLUS_PLUS] = ACTIONS(3164),
    [anon_sym_sizeof] = ACTIONS(3162),
    [anon_sym___alignof__] = ACTIONS(3162),
    [anon_sym___alignof] = ACTIONS(3162),
    [anon_sym__alignof] = ACTIONS(3162),
    [anon_sym_alignof] = ACTIONS(3162),
    [anon_sym__Alignof] = ACTIONS(3162),
    [anon_sym_offsetof] = ACTIONS(3162),
    [anon_sym__Generic] = ACTIONS(3162),
    [anon_sym_asm] = ACTIONS(3162),
    [anon_sym___asm__] = ACTIONS(3162),
    [sym_number_literal] = ACTIONS(3164),
    [anon_sym_L_SQUOTE] = ACTIONS(3164),
    [anon_sym_u_SQUOTE] = ACTIONS(3164),
    [anon_sym_U_SQUOTE] = ACTIONS(3164),
    [anon_sym_u8_SQUOTE] = ACTIONS(3164),
    [anon_sym_SQUOTE] = ACTIONS(3164),
    [anon_sym_L_DQUOTE] = ACTIONS(3164),
    [anon_sym_u_DQUOTE] = ACTIONS(3164),
    [anon_sym_U_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8_DQUOTE] = ACTIONS(3164),
    [anon_sym_DQUOTE] = ACTIONS(3164),
    [sym_true] = ACTIONS(3162),
    [sym_false] = ACTIONS(3162),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3162),
    [anon_sym_let] = ACTIONS(3162),
    [anon_sym_This] = ACTIONS(3162),
    [anon_sym_decltype] = ACTIONS(3162),
    [sym_virtual] = ACTIONS(3162),
    [anon_sym_explicit] = ACTIONS(3162),
    [anon_sym_typename] = ACTIONS(3162),
    [anon_sym_template] = ACTIONS(3162),
    [anon_sym_operator] = ACTIONS(3162),
    [anon_sym_try] = ACTIONS(3162),
    [anon_sym_delete] = ACTIONS(3162),
    [anon_sym_throw] = ACTIONS(3162),
    [anon_sym_namespace] = ACTIONS(3162),
    [anon_sym_using] = ACTIONS(3162),
    [anon_sym_static_assert] = ACTIONS(3162),
    [anon_sym_concept] = ACTIONS(3162),
    [anon_sym_co_return] = ACTIONS(3162),
    [anon_sym_co_yield] = ACTIONS(3162),
    [anon_sym_R_DQUOTE] = ACTIONS(3164),
    [anon_sym_LR_DQUOTE] = ACTIONS(3164),
    [anon_sym_uR_DQUOTE] = ACTIONS(3164),
    [anon_sym_UR_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3164),
    [anon_sym_co_await] = ACTIONS(3162),
    [anon_sym_new] = ACTIONS(3162),
    [anon_sym_requires] = ACTIONS(3162),
    [sym_this] = ACTIONS(3162),
    [anon_sym_discard] = ACTIONS(3162),
    [anon_sym_precise] = ACTIONS(3162),
    [anon_sym_shared] = ACTIONS(3162),
    [anon_sym_groupshared] = ACTIONS(3162),
    [anon_sym_uniform] = ACTIONS(3162),
    [anon_sym_row_major] = ACTIONS(3162),
    [anon_sym_column_major] = ACTIONS(3162),
    [anon_sym_globallycoherent] = ACTIONS(3162),
    [anon_sym_centroid] = ACTIONS(3162),
    [anon_sym_noperspective] = ACTIONS(3162),
    [anon_sym_nointerpolation] = ACTIONS(3162),
    [anon_sym_sample] = ACTIONS(3162),
    [anon_sym_linear] = ACTIONS(3162),
    [anon_sym_snorm] = ACTIONS(3162),
    [anon_sym_unorm] = ACTIONS(3162),
    [anon_sym_point] = ACTIONS(3162),
    [anon_sym_line] = ACTIONS(3162),
    [anon_sym_triangleadj] = ACTIONS(3162),
    [anon_sym_lineadj] = ACTIONS(3162),
    [anon_sym_triangle] = ACTIONS(3162),
    [anon_sym_cbuffer] = ACTIONS(3162),
    [anon_sym_interface] = ACTIONS(3162),
    [anon_sym_extension] = ACTIONS(3162),
  },
  [805] = {
    [sym_identifier] = ACTIONS(2742),
    [aux_sym_preproc_include_token1] = ACTIONS(2742),
    [aux_sym_preproc_def_token1] = ACTIONS(2742),
    [aux_sym_preproc_if_token1] = ACTIONS(2742),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2742),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2742),
    [sym_preproc_directive] = ACTIONS(2742),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_BANG] = ACTIONS(2740),
    [anon_sym_TILDE] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2742),
    [anon_sym_PLUS] = ACTIONS(2742),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym___extension__] = ACTIONS(2742),
    [anon_sym_typedef] = ACTIONS(2742),
    [anon_sym_in] = ACTIONS(2742),
    [anon_sym_out] = ACTIONS(2742),
    [anon_sym_inout] = ACTIONS(2742),
    [anon_sym_extern] = ACTIONS(2742),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym_COLON_COLON] = ACTIONS(2740),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2740),
    [anon_sym___declspec] = ACTIONS(2742),
    [anon_sym___based] = ACTIONS(2742),
    [anon_sym___cdecl] = ACTIONS(2742),
    [anon_sym___clrcall] = ACTIONS(2742),
    [anon_sym___stdcall] = ACTIONS(2742),
    [anon_sym___fastcall] = ACTIONS(2742),
    [anon_sym___thiscall] = ACTIONS(2742),
    [anon_sym___vectorcall] = ACTIONS(2742),
    [anon_sym_LBRACE] = ACTIONS(2740),
    [anon_sym_RBRACE] = ACTIONS(2740),
    [anon_sym_signed] = ACTIONS(2742),
    [anon_sym_unsigned] = ACTIONS(2742),
    [anon_sym_long] = ACTIONS(2742),
    [anon_sym_short] = ACTIONS(2742),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2742),
    [anon_sym_register] = ACTIONS(2742),
    [anon_sym_inline] = ACTIONS(2742),
    [anon_sym___inline] = ACTIONS(2742),
    [anon_sym___inline__] = ACTIONS(2742),
    [anon_sym___forceinline] = ACTIONS(2742),
    [anon_sym_thread_local] = ACTIONS(2742),
    [anon_sym___thread] = ACTIONS(2742),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_constexpr] = ACTIONS(2742),
    [anon_sym_volatile] = ACTIONS(2742),
    [anon_sym_restrict] = ACTIONS(2742),
    [anon_sym___restrict__] = ACTIONS(2742),
    [anon_sym__Atomic] = ACTIONS(2742),
    [anon_sym__Noreturn] = ACTIONS(2742),
    [anon_sym_noreturn] = ACTIONS(2742),
    [anon_sym_mutable] = ACTIONS(2742),
    [anon_sym_constinit] = ACTIONS(2742),
    [anon_sym_consteval] = ACTIONS(2742),
    [anon_sym_alignas] = ACTIONS(2742),
    [anon_sym__Alignas] = ACTIONS(2742),
    [sym_primitive_type] = ACTIONS(2742),
    [anon_sym_enum] = ACTIONS(2742),
    [anon_sym_class] = ACTIONS(2742),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2742),
    [anon_sym_if] = ACTIONS(2742),
    [anon_sym_switch] = ACTIONS(2742),
    [anon_sym_case] = ACTIONS(2742),
    [anon_sym_default] = ACTIONS(2742),
    [anon_sym_while] = ACTIONS(2742),
    [anon_sym_do] = ACTIONS(2742),
    [anon_sym_for] = ACTIONS(2742),
    [anon_sym_return] = ACTIONS(2742),
    [anon_sym_break] = ACTIONS(2742),
    [anon_sym_continue] = ACTIONS(2742),
    [anon_sym_goto] = ACTIONS(2742),
    [anon_sym___try] = ACTIONS(2742),
    [anon_sym___leave] = ACTIONS(2742),
    [anon_sym_not] = ACTIONS(2742),
    [anon_sym_compl] = ACTIONS(2742),
    [anon_sym_DASH_DASH] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2740),
    [anon_sym_sizeof] = ACTIONS(2742),
    [anon_sym___alignof__] = ACTIONS(2742),
    [anon_sym___alignof] = ACTIONS(2742),
    [anon_sym__alignof] = ACTIONS(2742),
    [anon_sym_alignof] = ACTIONS(2742),
    [anon_sym__Alignof] = ACTIONS(2742),
    [anon_sym_offsetof] = ACTIONS(2742),
    [anon_sym__Generic] = ACTIONS(2742),
    [anon_sym_asm] = ACTIONS(2742),
    [anon_sym___asm__] = ACTIONS(2742),
    [anon_sym_DOT] = ACTIONS(2742),
    [sym_number_literal] = ACTIONS(2740),
    [anon_sym_L_SQUOTE] = ACTIONS(2740),
    [anon_sym_u_SQUOTE] = ACTIONS(2740),
    [anon_sym_U_SQUOTE] = ACTIONS(2740),
    [anon_sym_u8_SQUOTE] = ACTIONS(2740),
    [anon_sym_SQUOTE] = ACTIONS(2740),
    [anon_sym_L_DQUOTE] = ACTIONS(2740),
    [anon_sym_u_DQUOTE] = ACTIONS(2740),
    [anon_sym_U_DQUOTE] = ACTIONS(2740),
    [anon_sym_u8_DQUOTE] = ACTIONS(2740),
    [anon_sym_DQUOTE] = ACTIONS(2740),
    [sym_true] = ACTIONS(2742),
    [sym_false] = ACTIONS(2742),
    [anon_sym_NULL] = ACTIONS(2742),
    [anon_sym_nullptr] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
    [anon_sym_decltype] = ACTIONS(2742),
    [sym_virtual] = ACTIONS(2742),
    [anon_sym_explicit] = ACTIONS(2742),
    [anon_sym_typename] = ACTIONS(2742),
    [anon_sym_template] = ACTIONS(2742),
    [anon_sym_operator] = ACTIONS(2742),
    [anon_sym_try] = ACTIONS(2742),
    [anon_sym_delete] = ACTIONS(2742),
    [anon_sym_throw] = ACTIONS(2742),
    [anon_sym_namespace] = ACTIONS(2742),
    [anon_sym_using] = ACTIONS(2742),
    [anon_sym_static_assert] = ACTIONS(2742),
    [anon_sym_concept] = ACTIONS(2742),
    [anon_sym_co_return] = ACTIONS(2742),
    [anon_sym_co_yield] = ACTIONS(2742),
    [anon_sym_R_DQUOTE] = ACTIONS(2740),
    [anon_sym_LR_DQUOTE] = ACTIONS(2740),
    [anon_sym_uR_DQUOTE] = ACTIONS(2740),
    [anon_sym_UR_DQUOTE] = ACTIONS(2740),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2740),
    [anon_sym_co_await] = ACTIONS(2742),
    [anon_sym_new] = ACTIONS(2742),
    [anon_sym_requires] = ACTIONS(2742),
    [sym_this] = ACTIONS(2742),
    [anon_sym_discard] = ACTIONS(2742),
    [anon_sym_precise] = ACTIONS(2742),
    [anon_sym_shared] = ACTIONS(2742),
    [anon_sym_groupshared] = ACTIONS(2742),
    [anon_sym_uniform] = ACTIONS(2742),
    [anon_sym_row_major] = ACTIONS(2742),
    [anon_sym_column_major] = ACTIONS(2742),
    [anon_sym_globallycoherent] = ACTIONS(2742),
    [anon_sym_centroid] = ACTIONS(2742),
    [anon_sym_noperspective] = ACTIONS(2742),
    [anon_sym_nointerpolation] = ACTIONS(2742),
    [anon_sym_sample] = ACTIONS(2742),
    [anon_sym_linear] = ACTIONS(2742),
    [anon_sym_snorm] = ACTIONS(2742),
    [anon_sym_unorm] = ACTIONS(2742),
    [anon_sym_point] = ACTIONS(2742),
    [anon_sym_line] = ACTIONS(2742),
    [anon_sym_triangleadj] = ACTIONS(2742),
    [anon_sym_lineadj] = ACTIONS(2742),
    [anon_sym_triangle] = ACTIONS(2742),
    [anon_sym_cbuffer] = ACTIONS(2742),
    [anon_sym_interface] = ACTIONS(2742),
    [anon_sym_extension] = ACTIONS(2742),
  },
  [806] = {
    [sym_identifier] = ACTIONS(3218),
    [aux_sym_preproc_include_token1] = ACTIONS(3218),
    [aux_sym_preproc_def_token1] = ACTIONS(3218),
    [aux_sym_preproc_if_token1] = ACTIONS(3218),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3218),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3218),
    [sym_preproc_directive] = ACTIONS(3218),
    [anon_sym_LPAREN2] = ACTIONS(3220),
    [anon_sym_BANG] = ACTIONS(3220),
    [anon_sym_TILDE] = ACTIONS(3220),
    [anon_sym_DASH] = ACTIONS(3218),
    [anon_sym_PLUS] = ACTIONS(3218),
    [anon_sym_STAR] = ACTIONS(3220),
    [anon_sym_AMP_AMP] = ACTIONS(3220),
    [anon_sym_AMP] = ACTIONS(3218),
    [anon_sym_SEMI] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3218),
    [anon_sym_typedef] = ACTIONS(3218),
    [anon_sym_in] = ACTIONS(3218),
    [anon_sym_out] = ACTIONS(3218),
    [anon_sym_inout] = ACTIONS(3218),
    [anon_sym_extern] = ACTIONS(3218),
    [anon_sym___attribute__] = ACTIONS(3218),
    [anon_sym_COLON_COLON] = ACTIONS(3220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3220),
    [anon_sym___declspec] = ACTIONS(3218),
    [anon_sym___based] = ACTIONS(3218),
    [anon_sym___cdecl] = ACTIONS(3218),
    [anon_sym___clrcall] = ACTIONS(3218),
    [anon_sym___stdcall] = ACTIONS(3218),
    [anon_sym___fastcall] = ACTIONS(3218),
    [anon_sym___thiscall] = ACTIONS(3218),
    [anon_sym___vectorcall] = ACTIONS(3218),
    [anon_sym_LBRACE] = ACTIONS(3220),
    [anon_sym_RBRACE] = ACTIONS(3220),
    [anon_sym_signed] = ACTIONS(3218),
    [anon_sym_unsigned] = ACTIONS(3218),
    [anon_sym_long] = ACTIONS(3218),
    [anon_sym_short] = ACTIONS(3218),
    [anon_sym_LBRACK] = ACTIONS(3218),
    [anon_sym_static] = ACTIONS(3218),
    [anon_sym_register] = ACTIONS(3218),
    [anon_sym_inline] = ACTIONS(3218),
    [anon_sym___inline] = ACTIONS(3218),
    [anon_sym___inline__] = ACTIONS(3218),
    [anon_sym___forceinline] = ACTIONS(3218),
    [anon_sym_thread_local] = ACTIONS(3218),
    [anon_sym___thread] = ACTIONS(3218),
    [anon_sym_const] = ACTIONS(3218),
    [anon_sym_constexpr] = ACTIONS(3218),
    [anon_sym_volatile] = ACTIONS(3218),
    [anon_sym_restrict] = ACTIONS(3218),
    [anon_sym___restrict__] = ACTIONS(3218),
    [anon_sym__Atomic] = ACTIONS(3218),
    [anon_sym__Noreturn] = ACTIONS(3218),
    [anon_sym_noreturn] = ACTIONS(3218),
    [anon_sym_mutable] = ACTIONS(3218),
    [anon_sym_constinit] = ACTIONS(3218),
    [anon_sym_consteval] = ACTIONS(3218),
    [anon_sym_alignas] = ACTIONS(3218),
    [anon_sym__Alignas] = ACTIONS(3218),
    [sym_primitive_type] = ACTIONS(3218),
    [anon_sym_enum] = ACTIONS(3218),
    [anon_sym_class] = ACTIONS(3218),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3218),
    [anon_sym_if] = ACTIONS(3218),
    [anon_sym_else] = ACTIONS(3218),
    [anon_sym_switch] = ACTIONS(3218),
    [anon_sym_case] = ACTIONS(3218),
    [anon_sym_default] = ACTIONS(3218),
    [anon_sym_while] = ACTIONS(3218),
    [anon_sym_do] = ACTIONS(3218),
    [anon_sym_for] = ACTIONS(3218),
    [anon_sym_return] = ACTIONS(3218),
    [anon_sym_break] = ACTIONS(3218),
    [anon_sym_continue] = ACTIONS(3218),
    [anon_sym_goto] = ACTIONS(3218),
    [anon_sym___try] = ACTIONS(3218),
    [anon_sym___leave] = ACTIONS(3218),
    [anon_sym_not] = ACTIONS(3218),
    [anon_sym_compl] = ACTIONS(3218),
    [anon_sym_DASH_DASH] = ACTIONS(3220),
    [anon_sym_PLUS_PLUS] = ACTIONS(3220),
    [anon_sym_sizeof] = ACTIONS(3218),
    [anon_sym___alignof__] = ACTIONS(3218),
    [anon_sym___alignof] = ACTIONS(3218),
    [anon_sym__alignof] = ACTIONS(3218),
    [anon_sym_alignof] = ACTIONS(3218),
    [anon_sym__Alignof] = ACTIONS(3218),
    [anon_sym_offsetof] = ACTIONS(3218),
    [anon_sym__Generic] = ACTIONS(3218),
    [anon_sym_asm] = ACTIONS(3218),
    [anon_sym___asm__] = ACTIONS(3218),
    [sym_number_literal] = ACTIONS(3220),
    [anon_sym_L_SQUOTE] = ACTIONS(3220),
    [anon_sym_u_SQUOTE] = ACTIONS(3220),
    [anon_sym_U_SQUOTE] = ACTIONS(3220),
    [anon_sym_u8_SQUOTE] = ACTIONS(3220),
    [anon_sym_SQUOTE] = ACTIONS(3220),
    [anon_sym_L_DQUOTE] = ACTIONS(3220),
    [anon_sym_u_DQUOTE] = ACTIONS(3220),
    [anon_sym_U_DQUOTE] = ACTIONS(3220),
    [anon_sym_u8_DQUOTE] = ACTIONS(3220),
    [anon_sym_DQUOTE] = ACTIONS(3220),
    [sym_true] = ACTIONS(3218),
    [sym_false] = ACTIONS(3218),
    [anon_sym_NULL] = ACTIONS(3218),
    [anon_sym_nullptr] = ACTIONS(3218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3218),
    [anon_sym_let] = ACTIONS(3218),
    [anon_sym_This] = ACTIONS(3218),
    [anon_sym_decltype] = ACTIONS(3218),
    [sym_virtual] = ACTIONS(3218),
    [anon_sym_explicit] = ACTIONS(3218),
    [anon_sym_typename] = ACTIONS(3218),
    [anon_sym_template] = ACTIONS(3218),
    [anon_sym_operator] = ACTIONS(3218),
    [anon_sym_try] = ACTIONS(3218),
    [anon_sym_delete] = ACTIONS(3218),
    [anon_sym_throw] = ACTIONS(3218),
    [anon_sym_namespace] = ACTIONS(3218),
    [anon_sym_using] = ACTIONS(3218),
    [anon_sym_static_assert] = ACTIONS(3218),
    [anon_sym_concept] = ACTIONS(3218),
    [anon_sym_co_return] = ACTIONS(3218),
    [anon_sym_co_yield] = ACTIONS(3218),
    [anon_sym_R_DQUOTE] = ACTIONS(3220),
    [anon_sym_LR_DQUOTE] = ACTIONS(3220),
    [anon_sym_uR_DQUOTE] = ACTIONS(3220),
    [anon_sym_UR_DQUOTE] = ACTIONS(3220),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3220),
    [anon_sym_co_await] = ACTIONS(3218),
    [anon_sym_new] = ACTIONS(3218),
    [anon_sym_requires] = ACTIONS(3218),
    [sym_this] = ACTIONS(3218),
    [anon_sym_discard] = ACTIONS(3218),
    [anon_sym_precise] = ACTIONS(3218),
    [anon_sym_shared] = ACTIONS(3218),
    [anon_sym_groupshared] = ACTIONS(3218),
    [anon_sym_uniform] = ACTIONS(3218),
    [anon_sym_row_major] = ACTIONS(3218),
    [anon_sym_column_major] = ACTIONS(3218),
    [anon_sym_globallycoherent] = ACTIONS(3218),
    [anon_sym_centroid] = ACTIONS(3218),
    [anon_sym_noperspective] = ACTIONS(3218),
    [anon_sym_nointerpolation] = ACTIONS(3218),
    [anon_sym_sample] = ACTIONS(3218),
    [anon_sym_linear] = ACTIONS(3218),
    [anon_sym_snorm] = ACTIONS(3218),
    [anon_sym_unorm] = ACTIONS(3218),
    [anon_sym_point] = ACTIONS(3218),
    [anon_sym_line] = ACTIONS(3218),
    [anon_sym_triangleadj] = ACTIONS(3218),
    [anon_sym_lineadj] = ACTIONS(3218),
    [anon_sym_triangle] = ACTIONS(3218),
    [anon_sym_cbuffer] = ACTIONS(3218),
    [anon_sym_interface] = ACTIONS(3218),
    [anon_sym_extension] = ACTIONS(3218),
  },
  [807] = {
    [sym_identifier] = ACTIONS(3302),
    [aux_sym_preproc_include_token1] = ACTIONS(3302),
    [aux_sym_preproc_def_token1] = ACTIONS(3302),
    [aux_sym_preproc_if_token1] = ACTIONS(3302),
    [aux_sym_preproc_if_token2] = ACTIONS(3302),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3302),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3302),
    [sym_preproc_directive] = ACTIONS(3302),
    [anon_sym_LPAREN2] = ACTIONS(3304),
    [anon_sym_BANG] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_AMP_AMP] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3302),
    [anon_sym_SEMI] = ACTIONS(3304),
    [anon_sym___extension__] = ACTIONS(3302),
    [anon_sym_typedef] = ACTIONS(3302),
    [anon_sym_in] = ACTIONS(3302),
    [anon_sym_out] = ACTIONS(3302),
    [anon_sym_inout] = ACTIONS(3302),
    [anon_sym_extern] = ACTIONS(3302),
    [anon_sym___attribute__] = ACTIONS(3302),
    [anon_sym_COLON_COLON] = ACTIONS(3304),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3304),
    [anon_sym___declspec] = ACTIONS(3302),
    [anon_sym___based] = ACTIONS(3302),
    [anon_sym___cdecl] = ACTIONS(3302),
    [anon_sym___clrcall] = ACTIONS(3302),
    [anon_sym___stdcall] = ACTIONS(3302),
    [anon_sym___fastcall] = ACTIONS(3302),
    [anon_sym___thiscall] = ACTIONS(3302),
    [anon_sym___vectorcall] = ACTIONS(3302),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_signed] = ACTIONS(3302),
    [anon_sym_unsigned] = ACTIONS(3302),
    [anon_sym_long] = ACTIONS(3302),
    [anon_sym_short] = ACTIONS(3302),
    [anon_sym_LBRACK] = ACTIONS(3302),
    [anon_sym_static] = ACTIONS(3302),
    [anon_sym_register] = ACTIONS(3302),
    [anon_sym_inline] = ACTIONS(3302),
    [anon_sym___inline] = ACTIONS(3302),
    [anon_sym___inline__] = ACTIONS(3302),
    [anon_sym___forceinline] = ACTIONS(3302),
    [anon_sym_thread_local] = ACTIONS(3302),
    [anon_sym___thread] = ACTIONS(3302),
    [anon_sym_const] = ACTIONS(3302),
    [anon_sym_constexpr] = ACTIONS(3302),
    [anon_sym_volatile] = ACTIONS(3302),
    [anon_sym_restrict] = ACTIONS(3302),
    [anon_sym___restrict__] = ACTIONS(3302),
    [anon_sym__Atomic] = ACTIONS(3302),
    [anon_sym__Noreturn] = ACTIONS(3302),
    [anon_sym_noreturn] = ACTIONS(3302),
    [anon_sym_mutable] = ACTIONS(3302),
    [anon_sym_constinit] = ACTIONS(3302),
    [anon_sym_consteval] = ACTIONS(3302),
    [anon_sym_alignas] = ACTIONS(3302),
    [anon_sym__Alignas] = ACTIONS(3302),
    [sym_primitive_type] = ACTIONS(3302),
    [anon_sym_enum] = ACTIONS(3302),
    [anon_sym_class] = ACTIONS(3302),
    [anon_sym_struct] = ACTIONS(3302),
    [anon_sym_union] = ACTIONS(3302),
    [anon_sym_if] = ACTIONS(3302),
    [anon_sym_else] = ACTIONS(3302),
    [anon_sym_switch] = ACTIONS(3302),
    [anon_sym_case] = ACTIONS(3302),
    [anon_sym_default] = ACTIONS(3302),
    [anon_sym_while] = ACTIONS(3302),
    [anon_sym_do] = ACTIONS(3302),
    [anon_sym_for] = ACTIONS(3302),
    [anon_sym_return] = ACTIONS(3302),
    [anon_sym_break] = ACTIONS(3302),
    [anon_sym_continue] = ACTIONS(3302),
    [anon_sym_goto] = ACTIONS(3302),
    [anon_sym___try] = ACTIONS(3302),
    [anon_sym___leave] = ACTIONS(3302),
    [anon_sym_not] = ACTIONS(3302),
    [anon_sym_compl] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3304),
    [anon_sym_PLUS_PLUS] = ACTIONS(3304),
    [anon_sym_sizeof] = ACTIONS(3302),
    [anon_sym___alignof__] = ACTIONS(3302),
    [anon_sym___alignof] = ACTIONS(3302),
    [anon_sym__alignof] = ACTIONS(3302),
    [anon_sym_alignof] = ACTIONS(3302),
    [anon_sym__Alignof] = ACTIONS(3302),
    [anon_sym_offsetof] = ACTIONS(3302),
    [anon_sym__Generic] = ACTIONS(3302),
    [anon_sym_asm] = ACTIONS(3302),
    [anon_sym___asm__] = ACTIONS(3302),
    [sym_number_literal] = ACTIONS(3304),
    [anon_sym_L_SQUOTE] = ACTIONS(3304),
    [anon_sym_u_SQUOTE] = ACTIONS(3304),
    [anon_sym_U_SQUOTE] = ACTIONS(3304),
    [anon_sym_u8_SQUOTE] = ACTIONS(3304),
    [anon_sym_SQUOTE] = ACTIONS(3304),
    [anon_sym_L_DQUOTE] = ACTIONS(3304),
    [anon_sym_u_DQUOTE] = ACTIONS(3304),
    [anon_sym_U_DQUOTE] = ACTIONS(3304),
    [anon_sym_u8_DQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [sym_true] = ACTIONS(3302),
    [sym_false] = ACTIONS(3302),
    [anon_sym_NULL] = ACTIONS(3302),
    [anon_sym_nullptr] = ACTIONS(3302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3302),
    [anon_sym_let] = ACTIONS(3302),
    [anon_sym_This] = ACTIONS(3302),
    [anon_sym_decltype] = ACTIONS(3302),
    [sym_virtual] = ACTIONS(3302),
    [anon_sym_explicit] = ACTIONS(3302),
    [anon_sym_typename] = ACTIONS(3302),
    [anon_sym_template] = ACTIONS(3302),
    [anon_sym_operator] = ACTIONS(3302),
    [anon_sym_try] = ACTIONS(3302),
    [anon_sym_delete] = ACTIONS(3302),
    [anon_sym_throw] = ACTIONS(3302),
    [anon_sym_namespace] = ACTIONS(3302),
    [anon_sym_using] = ACTIONS(3302),
    [anon_sym_static_assert] = ACTIONS(3302),
    [anon_sym_concept] = ACTIONS(3302),
    [anon_sym_co_return] = ACTIONS(3302),
    [anon_sym_co_yield] = ACTIONS(3302),
    [anon_sym_R_DQUOTE] = ACTIONS(3304),
    [anon_sym_LR_DQUOTE] = ACTIONS(3304),
    [anon_sym_uR_DQUOTE] = ACTIONS(3304),
    [anon_sym_UR_DQUOTE] = ACTIONS(3304),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3304),
    [anon_sym_co_await] = ACTIONS(3302),
    [anon_sym_new] = ACTIONS(3302),
    [anon_sym_requires] = ACTIONS(3302),
    [sym_this] = ACTIONS(3302),
    [anon_sym_discard] = ACTIONS(3302),
    [anon_sym_precise] = ACTIONS(3302),
    [anon_sym_shared] = ACTIONS(3302),
    [anon_sym_groupshared] = ACTIONS(3302),
    [anon_sym_uniform] = ACTIONS(3302),
    [anon_sym_row_major] = ACTIONS(3302),
    [anon_sym_column_major] = ACTIONS(3302),
    [anon_sym_globallycoherent] = ACTIONS(3302),
    [anon_sym_centroid] = ACTIONS(3302),
    [anon_sym_noperspective] = ACTIONS(3302),
    [anon_sym_nointerpolation] = ACTIONS(3302),
    [anon_sym_sample] = ACTIONS(3302),
    [anon_sym_linear] = ACTIONS(3302),
    [anon_sym_snorm] = ACTIONS(3302),
    [anon_sym_unorm] = ACTIONS(3302),
    [anon_sym_point] = ACTIONS(3302),
    [anon_sym_line] = ACTIONS(3302),
    [anon_sym_triangleadj] = ACTIONS(3302),
    [anon_sym_lineadj] = ACTIONS(3302),
    [anon_sym_triangle] = ACTIONS(3302),
    [anon_sym_cbuffer] = ACTIONS(3302),
    [anon_sym_interface] = ACTIONS(3302),
    [anon_sym_extension] = ACTIONS(3302),
  },
  [808] = {
    [sym_identifier] = ACTIONS(3038),
    [aux_sym_preproc_include_token1] = ACTIONS(3038),
    [aux_sym_preproc_def_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token2] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3038),
    [sym_preproc_directive] = ACTIONS(3038),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3038),
    [anon_sym_PLUS] = ACTIONS(3038),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3038),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3038),
    [anon_sym_typedef] = ACTIONS(3038),
    [anon_sym_in] = ACTIONS(3038),
    [anon_sym_out] = ACTIONS(3038),
    [anon_sym_inout] = ACTIONS(3038),
    [anon_sym_extern] = ACTIONS(3038),
    [anon_sym___attribute__] = ACTIONS(3038),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3040),
    [anon_sym___declspec] = ACTIONS(3038),
    [anon_sym___based] = ACTIONS(3038),
    [anon_sym___cdecl] = ACTIONS(3038),
    [anon_sym___clrcall] = ACTIONS(3038),
    [anon_sym___stdcall] = ACTIONS(3038),
    [anon_sym___fastcall] = ACTIONS(3038),
    [anon_sym___thiscall] = ACTIONS(3038),
    [anon_sym___vectorcall] = ACTIONS(3038),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_signed] = ACTIONS(3038),
    [anon_sym_unsigned] = ACTIONS(3038),
    [anon_sym_long] = ACTIONS(3038),
    [anon_sym_short] = ACTIONS(3038),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_static] = ACTIONS(3038),
    [anon_sym_register] = ACTIONS(3038),
    [anon_sym_inline] = ACTIONS(3038),
    [anon_sym___inline] = ACTIONS(3038),
    [anon_sym___inline__] = ACTIONS(3038),
    [anon_sym___forceinline] = ACTIONS(3038),
    [anon_sym_thread_local] = ACTIONS(3038),
    [anon_sym___thread] = ACTIONS(3038),
    [anon_sym_const] = ACTIONS(3038),
    [anon_sym_constexpr] = ACTIONS(3038),
    [anon_sym_volatile] = ACTIONS(3038),
    [anon_sym_restrict] = ACTIONS(3038),
    [anon_sym___restrict__] = ACTIONS(3038),
    [anon_sym__Atomic] = ACTIONS(3038),
    [anon_sym__Noreturn] = ACTIONS(3038),
    [anon_sym_noreturn] = ACTIONS(3038),
    [anon_sym_mutable] = ACTIONS(3038),
    [anon_sym_constinit] = ACTIONS(3038),
    [anon_sym_consteval] = ACTIONS(3038),
    [anon_sym_alignas] = ACTIONS(3038),
    [anon_sym__Alignas] = ACTIONS(3038),
    [sym_primitive_type] = ACTIONS(3038),
    [anon_sym_enum] = ACTIONS(3038),
    [anon_sym_class] = ACTIONS(3038),
    [anon_sym_struct] = ACTIONS(3038),
    [anon_sym_union] = ACTIONS(3038),
    [anon_sym_if] = ACTIONS(3038),
    [anon_sym_else] = ACTIONS(3038),
    [anon_sym_switch] = ACTIONS(3038),
    [anon_sym_case] = ACTIONS(3038),
    [anon_sym_default] = ACTIONS(3038),
    [anon_sym_while] = ACTIONS(3038),
    [anon_sym_do] = ACTIONS(3038),
    [anon_sym_for] = ACTIONS(3038),
    [anon_sym_return] = ACTIONS(3038),
    [anon_sym_break] = ACTIONS(3038),
    [anon_sym_continue] = ACTIONS(3038),
    [anon_sym_goto] = ACTIONS(3038),
    [anon_sym___try] = ACTIONS(3038),
    [anon_sym___leave] = ACTIONS(3038),
    [anon_sym_not] = ACTIONS(3038),
    [anon_sym_compl] = ACTIONS(3038),
    [anon_sym_DASH_DASH] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3040),
    [anon_sym_sizeof] = ACTIONS(3038),
    [anon_sym___alignof__] = ACTIONS(3038),
    [anon_sym___alignof] = ACTIONS(3038),
    [anon_sym__alignof] = ACTIONS(3038),
    [anon_sym_alignof] = ACTIONS(3038),
    [anon_sym__Alignof] = ACTIONS(3038),
    [anon_sym_offsetof] = ACTIONS(3038),
    [anon_sym__Generic] = ACTIONS(3038),
    [anon_sym_asm] = ACTIONS(3038),
    [anon_sym___asm__] = ACTIONS(3038),
    [sym_number_literal] = ACTIONS(3040),
    [anon_sym_L_SQUOTE] = ACTIONS(3040),
    [anon_sym_u_SQUOTE] = ACTIONS(3040),
    [anon_sym_U_SQUOTE] = ACTIONS(3040),
    [anon_sym_u8_SQUOTE] = ACTIONS(3040),
    [anon_sym_SQUOTE] = ACTIONS(3040),
    [anon_sym_L_DQUOTE] = ACTIONS(3040),
    [anon_sym_u_DQUOTE] = ACTIONS(3040),
    [anon_sym_U_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8_DQUOTE] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [sym_true] = ACTIONS(3038),
    [sym_false] = ACTIONS(3038),
    [anon_sym_NULL] = ACTIONS(3038),
    [anon_sym_nullptr] = ACTIONS(3038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3038),
    [anon_sym_let] = ACTIONS(3038),
    [anon_sym_This] = ACTIONS(3038),
    [anon_sym_decltype] = ACTIONS(3038),
    [sym_virtual] = ACTIONS(3038),
    [anon_sym_explicit] = ACTIONS(3038),
    [anon_sym_typename] = ACTIONS(3038),
    [anon_sym_template] = ACTIONS(3038),
    [anon_sym_operator] = ACTIONS(3038),
    [anon_sym_try] = ACTIONS(3038),
    [anon_sym_delete] = ACTIONS(3038),
    [anon_sym_throw] = ACTIONS(3038),
    [anon_sym_namespace] = ACTIONS(3038),
    [anon_sym_using] = ACTIONS(3038),
    [anon_sym_static_assert] = ACTIONS(3038),
    [anon_sym_concept] = ACTIONS(3038),
    [anon_sym_co_return] = ACTIONS(3038),
    [anon_sym_co_yield] = ACTIONS(3038),
    [anon_sym_R_DQUOTE] = ACTIONS(3040),
    [anon_sym_LR_DQUOTE] = ACTIONS(3040),
    [anon_sym_uR_DQUOTE] = ACTIONS(3040),
    [anon_sym_UR_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3040),
    [anon_sym_co_await] = ACTIONS(3038),
    [anon_sym_new] = ACTIONS(3038),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3038),
    [anon_sym_discard] = ACTIONS(3038),
    [anon_sym_precise] = ACTIONS(3038),
    [anon_sym_shared] = ACTIONS(3038),
    [anon_sym_groupshared] = ACTIONS(3038),
    [anon_sym_uniform] = ACTIONS(3038),
    [anon_sym_row_major] = ACTIONS(3038),
    [anon_sym_column_major] = ACTIONS(3038),
    [anon_sym_globallycoherent] = ACTIONS(3038),
    [anon_sym_centroid] = ACTIONS(3038),
    [anon_sym_noperspective] = ACTIONS(3038),
    [anon_sym_nointerpolation] = ACTIONS(3038),
    [anon_sym_sample] = ACTIONS(3038),
    [anon_sym_linear] = ACTIONS(3038),
    [anon_sym_snorm] = ACTIONS(3038),
    [anon_sym_unorm] = ACTIONS(3038),
    [anon_sym_point] = ACTIONS(3038),
    [anon_sym_line] = ACTIONS(3038),
    [anon_sym_triangleadj] = ACTIONS(3038),
    [anon_sym_lineadj] = ACTIONS(3038),
    [anon_sym_triangle] = ACTIONS(3038),
    [anon_sym_cbuffer] = ACTIONS(3038),
    [anon_sym_interface] = ACTIONS(3038),
    [anon_sym_extension] = ACTIONS(3038),
  },
  [809] = {
    [sym_identifier] = ACTIONS(2902),
    [aux_sym_preproc_include_token1] = ACTIONS(2902),
    [aux_sym_preproc_def_token1] = ACTIONS(2902),
    [aux_sym_preproc_if_token1] = ACTIONS(2902),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2902),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2902),
    [sym_preproc_directive] = ACTIONS(2902),
    [anon_sym_LPAREN2] = ACTIONS(2904),
    [anon_sym_BANG] = ACTIONS(2904),
    [anon_sym_TILDE] = ACTIONS(2904),
    [anon_sym_DASH] = ACTIONS(2902),
    [anon_sym_PLUS] = ACTIONS(2902),
    [anon_sym_STAR] = ACTIONS(2904),
    [anon_sym_AMP_AMP] = ACTIONS(2904),
    [anon_sym_AMP] = ACTIONS(2902),
    [anon_sym_SEMI] = ACTIONS(2904),
    [anon_sym___extension__] = ACTIONS(2902),
    [anon_sym_typedef] = ACTIONS(2902),
    [anon_sym_in] = ACTIONS(2902),
    [anon_sym_out] = ACTIONS(2902),
    [anon_sym_inout] = ACTIONS(2902),
    [anon_sym_extern] = ACTIONS(2902),
    [anon_sym___attribute__] = ACTIONS(2902),
    [anon_sym_COLON_COLON] = ACTIONS(2904),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2904),
    [anon_sym___declspec] = ACTIONS(2902),
    [anon_sym___based] = ACTIONS(2902),
    [anon_sym___cdecl] = ACTIONS(2902),
    [anon_sym___clrcall] = ACTIONS(2902),
    [anon_sym___stdcall] = ACTIONS(2902),
    [anon_sym___fastcall] = ACTIONS(2902),
    [anon_sym___thiscall] = ACTIONS(2902),
    [anon_sym___vectorcall] = ACTIONS(2902),
    [anon_sym_LBRACE] = ACTIONS(2904),
    [anon_sym_RBRACE] = ACTIONS(2904),
    [anon_sym_signed] = ACTIONS(2902),
    [anon_sym_unsigned] = ACTIONS(2902),
    [anon_sym_long] = ACTIONS(2902),
    [anon_sym_short] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2902),
    [anon_sym_static] = ACTIONS(2902),
    [anon_sym_register] = ACTIONS(2902),
    [anon_sym_inline] = ACTIONS(2902),
    [anon_sym___inline] = ACTIONS(2902),
    [anon_sym___inline__] = ACTIONS(2902),
    [anon_sym___forceinline] = ACTIONS(2902),
    [anon_sym_thread_local] = ACTIONS(2902),
    [anon_sym___thread] = ACTIONS(2902),
    [anon_sym_const] = ACTIONS(2902),
    [anon_sym_constexpr] = ACTIONS(2902),
    [anon_sym_volatile] = ACTIONS(2902),
    [anon_sym_restrict] = ACTIONS(2902),
    [anon_sym___restrict__] = ACTIONS(2902),
    [anon_sym__Atomic] = ACTIONS(2902),
    [anon_sym__Noreturn] = ACTIONS(2902),
    [anon_sym_noreturn] = ACTIONS(2902),
    [anon_sym_mutable] = ACTIONS(2902),
    [anon_sym_constinit] = ACTIONS(2902),
    [anon_sym_consteval] = ACTIONS(2902),
    [anon_sym_alignas] = ACTIONS(2902),
    [anon_sym__Alignas] = ACTIONS(2902),
    [sym_primitive_type] = ACTIONS(2902),
    [anon_sym_enum] = ACTIONS(2902),
    [anon_sym_class] = ACTIONS(2902),
    [anon_sym_struct] = ACTIONS(2902),
    [anon_sym_union] = ACTIONS(2902),
    [anon_sym_if] = ACTIONS(2902),
    [anon_sym_else] = ACTIONS(2902),
    [anon_sym_switch] = ACTIONS(2902),
    [anon_sym_case] = ACTIONS(2902),
    [anon_sym_default] = ACTIONS(2902),
    [anon_sym_while] = ACTIONS(2902),
    [anon_sym_do] = ACTIONS(2902),
    [anon_sym_for] = ACTIONS(2902),
    [anon_sym_return] = ACTIONS(2902),
    [anon_sym_break] = ACTIONS(2902),
    [anon_sym_continue] = ACTIONS(2902),
    [anon_sym_goto] = ACTIONS(2902),
    [anon_sym___try] = ACTIONS(2902),
    [anon_sym___leave] = ACTIONS(2902),
    [anon_sym_not] = ACTIONS(2902),
    [anon_sym_compl] = ACTIONS(2902),
    [anon_sym_DASH_DASH] = ACTIONS(2904),
    [anon_sym_PLUS_PLUS] = ACTIONS(2904),
    [anon_sym_sizeof] = ACTIONS(2902),
    [anon_sym___alignof__] = ACTIONS(2902),
    [anon_sym___alignof] = ACTIONS(2902),
    [anon_sym__alignof] = ACTIONS(2902),
    [anon_sym_alignof] = ACTIONS(2902),
    [anon_sym__Alignof] = ACTIONS(2902),
    [anon_sym_offsetof] = ACTIONS(2902),
    [anon_sym__Generic] = ACTIONS(2902),
    [anon_sym_asm] = ACTIONS(2902),
    [anon_sym___asm__] = ACTIONS(2902),
    [sym_number_literal] = ACTIONS(2904),
    [anon_sym_L_SQUOTE] = ACTIONS(2904),
    [anon_sym_u_SQUOTE] = ACTIONS(2904),
    [anon_sym_U_SQUOTE] = ACTIONS(2904),
    [anon_sym_u8_SQUOTE] = ACTIONS(2904),
    [anon_sym_SQUOTE] = ACTIONS(2904),
    [anon_sym_L_DQUOTE] = ACTIONS(2904),
    [anon_sym_u_DQUOTE] = ACTIONS(2904),
    [anon_sym_U_DQUOTE] = ACTIONS(2904),
    [anon_sym_u8_DQUOTE] = ACTIONS(2904),
    [anon_sym_DQUOTE] = ACTIONS(2904),
    [sym_true] = ACTIONS(2902),
    [sym_false] = ACTIONS(2902),
    [anon_sym_NULL] = ACTIONS(2902),
    [anon_sym_nullptr] = ACTIONS(2902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2902),
    [anon_sym_let] = ACTIONS(2902),
    [anon_sym_This] = ACTIONS(2902),
    [anon_sym_decltype] = ACTIONS(2902),
    [sym_virtual] = ACTIONS(2902),
    [anon_sym_explicit] = ACTIONS(2902),
    [anon_sym_typename] = ACTIONS(2902),
    [anon_sym_template] = ACTIONS(2902),
    [anon_sym_operator] = ACTIONS(2902),
    [anon_sym_try] = ACTIONS(2902),
    [anon_sym_delete] = ACTIONS(2902),
    [anon_sym_throw] = ACTIONS(2902),
    [anon_sym_namespace] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_static_assert] = ACTIONS(2902),
    [anon_sym_concept] = ACTIONS(2902),
    [anon_sym_co_return] = ACTIONS(2902),
    [anon_sym_co_yield] = ACTIONS(2902),
    [anon_sym_R_DQUOTE] = ACTIONS(2904),
    [anon_sym_LR_DQUOTE] = ACTIONS(2904),
    [anon_sym_uR_DQUOTE] = ACTIONS(2904),
    [anon_sym_UR_DQUOTE] = ACTIONS(2904),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2904),
    [anon_sym_co_await] = ACTIONS(2902),
    [anon_sym_new] = ACTIONS(2902),
    [anon_sym_requires] = ACTIONS(2902),
    [sym_this] = ACTIONS(2902),
    [anon_sym_discard] = ACTIONS(2902),
    [anon_sym_precise] = ACTIONS(2902),
    [anon_sym_shared] = ACTIONS(2902),
    [anon_sym_groupshared] = ACTIONS(2902),
    [anon_sym_uniform] = ACTIONS(2902),
    [anon_sym_row_major] = ACTIONS(2902),
    [anon_sym_column_major] = ACTIONS(2902),
    [anon_sym_globallycoherent] = ACTIONS(2902),
    [anon_sym_centroid] = ACTIONS(2902),
    [anon_sym_noperspective] = ACTIONS(2902),
    [anon_sym_nointerpolation] = ACTIONS(2902),
    [anon_sym_sample] = ACTIONS(2902),
    [anon_sym_linear] = ACTIONS(2902),
    [anon_sym_snorm] = ACTIONS(2902),
    [anon_sym_unorm] = ACTIONS(2902),
    [anon_sym_point] = ACTIONS(2902),
    [anon_sym_line] = ACTIONS(2902),
    [anon_sym_triangleadj] = ACTIONS(2902),
    [anon_sym_lineadj] = ACTIONS(2902),
    [anon_sym_triangle] = ACTIONS(2902),
    [anon_sym_cbuffer] = ACTIONS(2902),
    [anon_sym_interface] = ACTIONS(2902),
    [anon_sym_extension] = ACTIONS(2902),
  },
  [810] = {
    [sym_identifier] = ACTIONS(3158),
    [aux_sym_preproc_include_token1] = ACTIONS(3158),
    [aux_sym_preproc_def_token1] = ACTIONS(3158),
    [aux_sym_preproc_if_token1] = ACTIONS(3158),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3158),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3158),
    [sym_preproc_directive] = ACTIONS(3158),
    [anon_sym_LPAREN2] = ACTIONS(3160),
    [anon_sym_BANG] = ACTIONS(3160),
    [anon_sym_TILDE] = ACTIONS(3160),
    [anon_sym_DASH] = ACTIONS(3158),
    [anon_sym_PLUS] = ACTIONS(3158),
    [anon_sym_STAR] = ACTIONS(3160),
    [anon_sym_AMP_AMP] = ACTIONS(3160),
    [anon_sym_AMP] = ACTIONS(3158),
    [anon_sym_SEMI] = ACTIONS(3160),
    [anon_sym___extension__] = ACTIONS(3158),
    [anon_sym_typedef] = ACTIONS(3158),
    [anon_sym_in] = ACTIONS(3158),
    [anon_sym_out] = ACTIONS(3158),
    [anon_sym_inout] = ACTIONS(3158),
    [anon_sym_extern] = ACTIONS(3158),
    [anon_sym___attribute__] = ACTIONS(3158),
    [anon_sym_COLON_COLON] = ACTIONS(3160),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3160),
    [anon_sym___declspec] = ACTIONS(3158),
    [anon_sym___based] = ACTIONS(3158),
    [anon_sym___cdecl] = ACTIONS(3158),
    [anon_sym___clrcall] = ACTIONS(3158),
    [anon_sym___stdcall] = ACTIONS(3158),
    [anon_sym___fastcall] = ACTIONS(3158),
    [anon_sym___thiscall] = ACTIONS(3158),
    [anon_sym___vectorcall] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3160),
    [anon_sym_RBRACE] = ACTIONS(3160),
    [anon_sym_signed] = ACTIONS(3158),
    [anon_sym_unsigned] = ACTIONS(3158),
    [anon_sym_long] = ACTIONS(3158),
    [anon_sym_short] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_static] = ACTIONS(3158),
    [anon_sym_register] = ACTIONS(3158),
    [anon_sym_inline] = ACTIONS(3158),
    [anon_sym___inline] = ACTIONS(3158),
    [anon_sym___inline__] = ACTIONS(3158),
    [anon_sym___forceinline] = ACTIONS(3158),
    [anon_sym_thread_local] = ACTIONS(3158),
    [anon_sym___thread] = ACTIONS(3158),
    [anon_sym_const] = ACTIONS(3158),
    [anon_sym_constexpr] = ACTIONS(3158),
    [anon_sym_volatile] = ACTIONS(3158),
    [anon_sym_restrict] = ACTIONS(3158),
    [anon_sym___restrict__] = ACTIONS(3158),
    [anon_sym__Atomic] = ACTIONS(3158),
    [anon_sym__Noreturn] = ACTIONS(3158),
    [anon_sym_noreturn] = ACTIONS(3158),
    [anon_sym_mutable] = ACTIONS(3158),
    [anon_sym_constinit] = ACTIONS(3158),
    [anon_sym_consteval] = ACTIONS(3158),
    [anon_sym_alignas] = ACTIONS(3158),
    [anon_sym__Alignas] = ACTIONS(3158),
    [sym_primitive_type] = ACTIONS(3158),
    [anon_sym_enum] = ACTIONS(3158),
    [anon_sym_class] = ACTIONS(3158),
    [anon_sym_struct] = ACTIONS(3158),
    [anon_sym_union] = ACTIONS(3158),
    [anon_sym_if] = ACTIONS(3158),
    [anon_sym_else] = ACTIONS(3158),
    [anon_sym_switch] = ACTIONS(3158),
    [anon_sym_case] = ACTIONS(3158),
    [anon_sym_default] = ACTIONS(3158),
    [anon_sym_while] = ACTIONS(3158),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_for] = ACTIONS(3158),
    [anon_sym_return] = ACTIONS(3158),
    [anon_sym_break] = ACTIONS(3158),
    [anon_sym_continue] = ACTIONS(3158),
    [anon_sym_goto] = ACTIONS(3158),
    [anon_sym___try] = ACTIONS(3158),
    [anon_sym___leave] = ACTIONS(3158),
    [anon_sym_not] = ACTIONS(3158),
    [anon_sym_compl] = ACTIONS(3158),
    [anon_sym_DASH_DASH] = ACTIONS(3160),
    [anon_sym_PLUS_PLUS] = ACTIONS(3160),
    [anon_sym_sizeof] = ACTIONS(3158),
    [anon_sym___alignof__] = ACTIONS(3158),
    [anon_sym___alignof] = ACTIONS(3158),
    [anon_sym__alignof] = ACTIONS(3158),
    [anon_sym_alignof] = ACTIONS(3158),
    [anon_sym__Alignof] = ACTIONS(3158),
    [anon_sym_offsetof] = ACTIONS(3158),
    [anon_sym__Generic] = ACTIONS(3158),
    [anon_sym_asm] = ACTIONS(3158),
    [anon_sym___asm__] = ACTIONS(3158),
    [sym_number_literal] = ACTIONS(3160),
    [anon_sym_L_SQUOTE] = ACTIONS(3160),
    [anon_sym_u_SQUOTE] = ACTIONS(3160),
    [anon_sym_U_SQUOTE] = ACTIONS(3160),
    [anon_sym_u8_SQUOTE] = ACTIONS(3160),
    [anon_sym_SQUOTE] = ACTIONS(3160),
    [anon_sym_L_DQUOTE] = ACTIONS(3160),
    [anon_sym_u_DQUOTE] = ACTIONS(3160),
    [anon_sym_U_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8_DQUOTE] = ACTIONS(3160),
    [anon_sym_DQUOTE] = ACTIONS(3160),
    [sym_true] = ACTIONS(3158),
    [sym_false] = ACTIONS(3158),
    [anon_sym_NULL] = ACTIONS(3158),
    [anon_sym_nullptr] = ACTIONS(3158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3158),
    [anon_sym_let] = ACTIONS(3158),
    [anon_sym_This] = ACTIONS(3158),
    [anon_sym_decltype] = ACTIONS(3158),
    [sym_virtual] = ACTIONS(3158),
    [anon_sym_explicit] = ACTIONS(3158),
    [anon_sym_typename] = ACTIONS(3158),
    [anon_sym_template] = ACTIONS(3158),
    [anon_sym_operator] = ACTIONS(3158),
    [anon_sym_try] = ACTIONS(3158),
    [anon_sym_delete] = ACTIONS(3158),
    [anon_sym_throw] = ACTIONS(3158),
    [anon_sym_namespace] = ACTIONS(3158),
    [anon_sym_using] = ACTIONS(3158),
    [anon_sym_static_assert] = ACTIONS(3158),
    [anon_sym_concept] = ACTIONS(3158),
    [anon_sym_co_return] = ACTIONS(3158),
    [anon_sym_co_yield] = ACTIONS(3158),
    [anon_sym_R_DQUOTE] = ACTIONS(3160),
    [anon_sym_LR_DQUOTE] = ACTIONS(3160),
    [anon_sym_uR_DQUOTE] = ACTIONS(3160),
    [anon_sym_UR_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3160),
    [anon_sym_co_await] = ACTIONS(3158),
    [anon_sym_new] = ACTIONS(3158),
    [anon_sym_requires] = ACTIONS(3158),
    [sym_this] = ACTIONS(3158),
    [anon_sym_discard] = ACTIONS(3158),
    [anon_sym_precise] = ACTIONS(3158),
    [anon_sym_shared] = ACTIONS(3158),
    [anon_sym_groupshared] = ACTIONS(3158),
    [anon_sym_uniform] = ACTIONS(3158),
    [anon_sym_row_major] = ACTIONS(3158),
    [anon_sym_column_major] = ACTIONS(3158),
    [anon_sym_globallycoherent] = ACTIONS(3158),
    [anon_sym_centroid] = ACTIONS(3158),
    [anon_sym_noperspective] = ACTIONS(3158),
    [anon_sym_nointerpolation] = ACTIONS(3158),
    [anon_sym_sample] = ACTIONS(3158),
    [anon_sym_linear] = ACTIONS(3158),
    [anon_sym_snorm] = ACTIONS(3158),
    [anon_sym_unorm] = ACTIONS(3158),
    [anon_sym_point] = ACTIONS(3158),
    [anon_sym_line] = ACTIONS(3158),
    [anon_sym_triangleadj] = ACTIONS(3158),
    [anon_sym_lineadj] = ACTIONS(3158),
    [anon_sym_triangle] = ACTIONS(3158),
    [anon_sym_cbuffer] = ACTIONS(3158),
    [anon_sym_interface] = ACTIONS(3158),
    [anon_sym_extension] = ACTIONS(3158),
  },
  [811] = {
    [sym_identifier] = ACTIONS(2982),
    [aux_sym_preproc_include_token1] = ACTIONS(2982),
    [aux_sym_preproc_def_token1] = ACTIONS(2982),
    [aux_sym_preproc_if_token1] = ACTIONS(2982),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2982),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2982),
    [sym_preproc_directive] = ACTIONS(2982),
    [anon_sym_LPAREN2] = ACTIONS(2984),
    [anon_sym_BANG] = ACTIONS(2984),
    [anon_sym_TILDE] = ACTIONS(2984),
    [anon_sym_DASH] = ACTIONS(2982),
    [anon_sym_PLUS] = ACTIONS(2982),
    [anon_sym_STAR] = ACTIONS(2984),
    [anon_sym_AMP_AMP] = ACTIONS(2984),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_SEMI] = ACTIONS(2984),
    [anon_sym___extension__] = ACTIONS(2982),
    [anon_sym_typedef] = ACTIONS(2982),
    [anon_sym_in] = ACTIONS(2982),
    [anon_sym_out] = ACTIONS(2982),
    [anon_sym_inout] = ACTIONS(2982),
    [anon_sym_extern] = ACTIONS(2982),
    [anon_sym___attribute__] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2984),
    [anon_sym___declspec] = ACTIONS(2982),
    [anon_sym___based] = ACTIONS(2982),
    [anon_sym___cdecl] = ACTIONS(2982),
    [anon_sym___clrcall] = ACTIONS(2982),
    [anon_sym___stdcall] = ACTIONS(2982),
    [anon_sym___fastcall] = ACTIONS(2982),
    [anon_sym___thiscall] = ACTIONS(2982),
    [anon_sym___vectorcall] = ACTIONS(2982),
    [anon_sym_LBRACE] = ACTIONS(2984),
    [anon_sym_RBRACE] = ACTIONS(2984),
    [anon_sym_signed] = ACTIONS(2982),
    [anon_sym_unsigned] = ACTIONS(2982),
    [anon_sym_long] = ACTIONS(2982),
    [anon_sym_short] = ACTIONS(2982),
    [anon_sym_LBRACK] = ACTIONS(2982),
    [anon_sym_static] = ACTIONS(2982),
    [anon_sym_register] = ACTIONS(2982),
    [anon_sym_inline] = ACTIONS(2982),
    [anon_sym___inline] = ACTIONS(2982),
    [anon_sym___inline__] = ACTIONS(2982),
    [anon_sym___forceinline] = ACTIONS(2982),
    [anon_sym_thread_local] = ACTIONS(2982),
    [anon_sym___thread] = ACTIONS(2982),
    [anon_sym_const] = ACTIONS(2982),
    [anon_sym_constexpr] = ACTIONS(2982),
    [anon_sym_volatile] = ACTIONS(2982),
    [anon_sym_restrict] = ACTIONS(2982),
    [anon_sym___restrict__] = ACTIONS(2982),
    [anon_sym__Atomic] = ACTIONS(2982),
    [anon_sym__Noreturn] = ACTIONS(2982),
    [anon_sym_noreturn] = ACTIONS(2982),
    [anon_sym_mutable] = ACTIONS(2982),
    [anon_sym_constinit] = ACTIONS(2982),
    [anon_sym_consteval] = ACTIONS(2982),
    [anon_sym_alignas] = ACTIONS(2982),
    [anon_sym__Alignas] = ACTIONS(2982),
    [sym_primitive_type] = ACTIONS(2982),
    [anon_sym_enum] = ACTIONS(2982),
    [anon_sym_class] = ACTIONS(2982),
    [anon_sym_struct] = ACTIONS(2982),
    [anon_sym_union] = ACTIONS(2982),
    [anon_sym_if] = ACTIONS(2982),
    [anon_sym_else] = ACTIONS(2982),
    [anon_sym_switch] = ACTIONS(2982),
    [anon_sym_case] = ACTIONS(2982),
    [anon_sym_default] = ACTIONS(2982),
    [anon_sym_while] = ACTIONS(2982),
    [anon_sym_do] = ACTIONS(2982),
    [anon_sym_for] = ACTIONS(2982),
    [anon_sym_return] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2982),
    [anon_sym_continue] = ACTIONS(2982),
    [anon_sym_goto] = ACTIONS(2982),
    [anon_sym___try] = ACTIONS(2982),
    [anon_sym___leave] = ACTIONS(2982),
    [anon_sym_not] = ACTIONS(2982),
    [anon_sym_compl] = ACTIONS(2982),
    [anon_sym_DASH_DASH] = ACTIONS(2984),
    [anon_sym_PLUS_PLUS] = ACTIONS(2984),
    [anon_sym_sizeof] = ACTIONS(2982),
    [anon_sym___alignof__] = ACTIONS(2982),
    [anon_sym___alignof] = ACTIONS(2982),
    [anon_sym__alignof] = ACTIONS(2982),
    [anon_sym_alignof] = ACTIONS(2982),
    [anon_sym__Alignof] = ACTIONS(2982),
    [anon_sym_offsetof] = ACTIONS(2982),
    [anon_sym__Generic] = ACTIONS(2982),
    [anon_sym_asm] = ACTIONS(2982),
    [anon_sym___asm__] = ACTIONS(2982),
    [sym_number_literal] = ACTIONS(2984),
    [anon_sym_L_SQUOTE] = ACTIONS(2984),
    [anon_sym_u_SQUOTE] = ACTIONS(2984),
    [anon_sym_U_SQUOTE] = ACTIONS(2984),
    [anon_sym_u8_SQUOTE] = ACTIONS(2984),
    [anon_sym_SQUOTE] = ACTIONS(2984),
    [anon_sym_L_DQUOTE] = ACTIONS(2984),
    [anon_sym_u_DQUOTE] = ACTIONS(2984),
    [anon_sym_U_DQUOTE] = ACTIONS(2984),
    [anon_sym_u8_DQUOTE] = ACTIONS(2984),
    [anon_sym_DQUOTE] = ACTIONS(2984),
    [sym_true] = ACTIONS(2982),
    [sym_false] = ACTIONS(2982),
    [anon_sym_NULL] = ACTIONS(2982),
    [anon_sym_nullptr] = ACTIONS(2982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2982),
    [anon_sym_let] = ACTIONS(2982),
    [anon_sym_This] = ACTIONS(2982),
    [anon_sym_decltype] = ACTIONS(2982),
    [sym_virtual] = ACTIONS(2982),
    [anon_sym_explicit] = ACTIONS(2982),
    [anon_sym_typename] = ACTIONS(2982),
    [anon_sym_template] = ACTIONS(2982),
    [anon_sym_operator] = ACTIONS(2982),
    [anon_sym_try] = ACTIONS(2982),
    [anon_sym_delete] = ACTIONS(2982),
    [anon_sym_throw] = ACTIONS(2982),
    [anon_sym_namespace] = ACTIONS(2982),
    [anon_sym_using] = ACTIONS(2982),
    [anon_sym_static_assert] = ACTIONS(2982),
    [anon_sym_concept] = ACTIONS(2982),
    [anon_sym_co_return] = ACTIONS(2982),
    [anon_sym_co_yield] = ACTIONS(2982),
    [anon_sym_R_DQUOTE] = ACTIONS(2984),
    [anon_sym_LR_DQUOTE] = ACTIONS(2984),
    [anon_sym_uR_DQUOTE] = ACTIONS(2984),
    [anon_sym_UR_DQUOTE] = ACTIONS(2984),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2984),
    [anon_sym_co_await] = ACTIONS(2982),
    [anon_sym_new] = ACTIONS(2982),
    [anon_sym_requires] = ACTIONS(2982),
    [sym_this] = ACTIONS(2982),
    [anon_sym_discard] = ACTIONS(2982),
    [anon_sym_precise] = ACTIONS(2982),
    [anon_sym_shared] = ACTIONS(2982),
    [anon_sym_groupshared] = ACTIONS(2982),
    [anon_sym_uniform] = ACTIONS(2982),
    [anon_sym_row_major] = ACTIONS(2982),
    [anon_sym_column_major] = ACTIONS(2982),
    [anon_sym_globallycoherent] = ACTIONS(2982),
    [anon_sym_centroid] = ACTIONS(2982),
    [anon_sym_noperspective] = ACTIONS(2982),
    [anon_sym_nointerpolation] = ACTIONS(2982),
    [anon_sym_sample] = ACTIONS(2982),
    [anon_sym_linear] = ACTIONS(2982),
    [anon_sym_snorm] = ACTIONS(2982),
    [anon_sym_unorm] = ACTIONS(2982),
    [anon_sym_point] = ACTIONS(2982),
    [anon_sym_line] = ACTIONS(2982),
    [anon_sym_triangleadj] = ACTIONS(2982),
    [anon_sym_lineadj] = ACTIONS(2982),
    [anon_sym_triangle] = ACTIONS(2982),
    [anon_sym_cbuffer] = ACTIONS(2982),
    [anon_sym_interface] = ACTIONS(2982),
    [anon_sym_extension] = ACTIONS(2982),
  },
  [812] = {
    [sym_identifier] = ACTIONS(3368),
    [aux_sym_preproc_include_token1] = ACTIONS(3368),
    [aux_sym_preproc_def_token1] = ACTIONS(3368),
    [aux_sym_preproc_if_token1] = ACTIONS(3368),
    [aux_sym_preproc_if_token2] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3368),
    [sym_preproc_directive] = ACTIONS(3368),
    [anon_sym_LPAREN2] = ACTIONS(3370),
    [anon_sym_BANG] = ACTIONS(3370),
    [anon_sym_TILDE] = ACTIONS(3370),
    [anon_sym_DASH] = ACTIONS(3368),
    [anon_sym_PLUS] = ACTIONS(3368),
    [anon_sym_STAR] = ACTIONS(3370),
    [anon_sym_AMP_AMP] = ACTIONS(3370),
    [anon_sym_AMP] = ACTIONS(3368),
    [anon_sym_SEMI] = ACTIONS(3370),
    [anon_sym___extension__] = ACTIONS(3368),
    [anon_sym_typedef] = ACTIONS(3368),
    [anon_sym_in] = ACTIONS(3368),
    [anon_sym_out] = ACTIONS(3368),
    [anon_sym_inout] = ACTIONS(3368),
    [anon_sym_extern] = ACTIONS(3368),
    [anon_sym___attribute__] = ACTIONS(3368),
    [anon_sym_COLON_COLON] = ACTIONS(3370),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3370),
    [anon_sym___declspec] = ACTIONS(3368),
    [anon_sym___based] = ACTIONS(3368),
    [anon_sym___cdecl] = ACTIONS(3368),
    [anon_sym___clrcall] = ACTIONS(3368),
    [anon_sym___stdcall] = ACTIONS(3368),
    [anon_sym___fastcall] = ACTIONS(3368),
    [anon_sym___thiscall] = ACTIONS(3368),
    [anon_sym___vectorcall] = ACTIONS(3368),
    [anon_sym_LBRACE] = ACTIONS(3370),
    [anon_sym_signed] = ACTIONS(3368),
    [anon_sym_unsigned] = ACTIONS(3368),
    [anon_sym_long] = ACTIONS(3368),
    [anon_sym_short] = ACTIONS(3368),
    [anon_sym_LBRACK] = ACTIONS(3368),
    [anon_sym_static] = ACTIONS(3368),
    [anon_sym_register] = ACTIONS(3368),
    [anon_sym_inline] = ACTIONS(3368),
    [anon_sym___inline] = ACTIONS(3368),
    [anon_sym___inline__] = ACTIONS(3368),
    [anon_sym___forceinline] = ACTIONS(3368),
    [anon_sym_thread_local] = ACTIONS(3368),
    [anon_sym___thread] = ACTIONS(3368),
    [anon_sym_const] = ACTIONS(3368),
    [anon_sym_constexpr] = ACTIONS(3368),
    [anon_sym_volatile] = ACTIONS(3368),
    [anon_sym_restrict] = ACTIONS(3368),
    [anon_sym___restrict__] = ACTIONS(3368),
    [anon_sym__Atomic] = ACTIONS(3368),
    [anon_sym__Noreturn] = ACTIONS(3368),
    [anon_sym_noreturn] = ACTIONS(3368),
    [anon_sym_mutable] = ACTIONS(3368),
    [anon_sym_constinit] = ACTIONS(3368),
    [anon_sym_consteval] = ACTIONS(3368),
    [anon_sym_alignas] = ACTIONS(3368),
    [anon_sym__Alignas] = ACTIONS(3368),
    [sym_primitive_type] = ACTIONS(3368),
    [anon_sym_enum] = ACTIONS(3368),
    [anon_sym_class] = ACTIONS(3368),
    [anon_sym_struct] = ACTIONS(3368),
    [anon_sym_union] = ACTIONS(3368),
    [anon_sym_if] = ACTIONS(3368),
    [anon_sym_else] = ACTIONS(3368),
    [anon_sym_switch] = ACTIONS(3368),
    [anon_sym_case] = ACTIONS(3368),
    [anon_sym_default] = ACTIONS(3368),
    [anon_sym_while] = ACTIONS(3368),
    [anon_sym_do] = ACTIONS(3368),
    [anon_sym_for] = ACTIONS(3368),
    [anon_sym_return] = ACTIONS(3368),
    [anon_sym_break] = ACTIONS(3368),
    [anon_sym_continue] = ACTIONS(3368),
    [anon_sym_goto] = ACTIONS(3368),
    [anon_sym___try] = ACTIONS(3368),
    [anon_sym___leave] = ACTIONS(3368),
    [anon_sym_not] = ACTIONS(3368),
    [anon_sym_compl] = ACTIONS(3368),
    [anon_sym_DASH_DASH] = ACTIONS(3370),
    [anon_sym_PLUS_PLUS] = ACTIONS(3370),
    [anon_sym_sizeof] = ACTIONS(3368),
    [anon_sym___alignof__] = ACTIONS(3368),
    [anon_sym___alignof] = ACTIONS(3368),
    [anon_sym__alignof] = ACTIONS(3368),
    [anon_sym_alignof] = ACTIONS(3368),
    [anon_sym__Alignof] = ACTIONS(3368),
    [anon_sym_offsetof] = ACTIONS(3368),
    [anon_sym__Generic] = ACTIONS(3368),
    [anon_sym_asm] = ACTIONS(3368),
    [anon_sym___asm__] = ACTIONS(3368),
    [sym_number_literal] = ACTIONS(3370),
    [anon_sym_L_SQUOTE] = ACTIONS(3370),
    [anon_sym_u_SQUOTE] = ACTIONS(3370),
    [anon_sym_U_SQUOTE] = ACTIONS(3370),
    [anon_sym_u8_SQUOTE] = ACTIONS(3370),
    [anon_sym_SQUOTE] = ACTIONS(3370),
    [anon_sym_L_DQUOTE] = ACTIONS(3370),
    [anon_sym_u_DQUOTE] = ACTIONS(3370),
    [anon_sym_U_DQUOTE] = ACTIONS(3370),
    [anon_sym_u8_DQUOTE] = ACTIONS(3370),
    [anon_sym_DQUOTE] = ACTIONS(3370),
    [sym_true] = ACTIONS(3368),
    [sym_false] = ACTIONS(3368),
    [anon_sym_NULL] = ACTIONS(3368),
    [anon_sym_nullptr] = ACTIONS(3368),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3368),
    [anon_sym_let] = ACTIONS(3368),
    [anon_sym_This] = ACTIONS(3368),
    [anon_sym_decltype] = ACTIONS(3368),
    [sym_virtual] = ACTIONS(3368),
    [anon_sym_explicit] = ACTIONS(3368),
    [anon_sym_typename] = ACTIONS(3368),
    [anon_sym_template] = ACTIONS(3368),
    [anon_sym_operator] = ACTIONS(3368),
    [anon_sym_try] = ACTIONS(3368),
    [anon_sym_delete] = ACTIONS(3368),
    [anon_sym_throw] = ACTIONS(3368),
    [anon_sym_namespace] = ACTIONS(3368),
    [anon_sym_using] = ACTIONS(3368),
    [anon_sym_static_assert] = ACTIONS(3368),
    [anon_sym_concept] = ACTIONS(3368),
    [anon_sym_co_return] = ACTIONS(3368),
    [anon_sym_co_yield] = ACTIONS(3368),
    [anon_sym_R_DQUOTE] = ACTIONS(3370),
    [anon_sym_LR_DQUOTE] = ACTIONS(3370),
    [anon_sym_uR_DQUOTE] = ACTIONS(3370),
    [anon_sym_UR_DQUOTE] = ACTIONS(3370),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3370),
    [anon_sym_co_await] = ACTIONS(3368),
    [anon_sym_new] = ACTIONS(3368),
    [anon_sym_requires] = ACTIONS(3368),
    [sym_this] = ACTIONS(3368),
    [anon_sym_discard] = ACTIONS(3368),
    [anon_sym_precise] = ACTIONS(3368),
    [anon_sym_shared] = ACTIONS(3368),
    [anon_sym_groupshared] = ACTIONS(3368),
    [anon_sym_uniform] = ACTIONS(3368),
    [anon_sym_row_major] = ACTIONS(3368),
    [anon_sym_column_major] = ACTIONS(3368),
    [anon_sym_globallycoherent] = ACTIONS(3368),
    [anon_sym_centroid] = ACTIONS(3368),
    [anon_sym_noperspective] = ACTIONS(3368),
    [anon_sym_nointerpolation] = ACTIONS(3368),
    [anon_sym_sample] = ACTIONS(3368),
    [anon_sym_linear] = ACTIONS(3368),
    [anon_sym_snorm] = ACTIONS(3368),
    [anon_sym_unorm] = ACTIONS(3368),
    [anon_sym_point] = ACTIONS(3368),
    [anon_sym_line] = ACTIONS(3368),
    [anon_sym_triangleadj] = ACTIONS(3368),
    [anon_sym_lineadj] = ACTIONS(3368),
    [anon_sym_triangle] = ACTIONS(3368),
    [anon_sym_cbuffer] = ACTIONS(3368),
    [anon_sym_interface] = ACTIONS(3368),
    [anon_sym_extension] = ACTIONS(3368),
  },
  [813] = {
    [sym_identifier] = ACTIONS(3551),
    [aux_sym_preproc_include_token1] = ACTIONS(3551),
    [aux_sym_preproc_def_token1] = ACTIONS(3551),
    [aux_sym_preproc_if_token1] = ACTIONS(3551),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3551),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3551),
    [sym_preproc_directive] = ACTIONS(3551),
    [anon_sym_LPAREN2] = ACTIONS(3553),
    [anon_sym_BANG] = ACTIONS(3553),
    [anon_sym_TILDE] = ACTIONS(3553),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_PLUS] = ACTIONS(3551),
    [anon_sym_STAR] = ACTIONS(3553),
    [anon_sym_AMP_AMP] = ACTIONS(3553),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_SEMI] = ACTIONS(3553),
    [anon_sym___extension__] = ACTIONS(3551),
    [anon_sym_typedef] = ACTIONS(3551),
    [anon_sym_in] = ACTIONS(3551),
    [anon_sym_out] = ACTIONS(3551),
    [anon_sym_inout] = ACTIONS(3551),
    [anon_sym_extern] = ACTIONS(3551),
    [anon_sym___attribute__] = ACTIONS(3551),
    [anon_sym_COLON_COLON] = ACTIONS(3553),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3553),
    [anon_sym___declspec] = ACTIONS(3551),
    [anon_sym___based] = ACTIONS(3551),
    [anon_sym___cdecl] = ACTIONS(3551),
    [anon_sym___clrcall] = ACTIONS(3551),
    [anon_sym___stdcall] = ACTIONS(3551),
    [anon_sym___fastcall] = ACTIONS(3551),
    [anon_sym___thiscall] = ACTIONS(3551),
    [anon_sym___vectorcall] = ACTIONS(3551),
    [anon_sym_LBRACE] = ACTIONS(3553),
    [anon_sym_RBRACE] = ACTIONS(3553),
    [anon_sym_signed] = ACTIONS(3551),
    [anon_sym_unsigned] = ACTIONS(3551),
    [anon_sym_long] = ACTIONS(3551),
    [anon_sym_short] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3551),
    [anon_sym_static] = ACTIONS(3551),
    [anon_sym_register] = ACTIONS(3551),
    [anon_sym_inline] = ACTIONS(3551),
    [anon_sym___inline] = ACTIONS(3551),
    [anon_sym___inline__] = ACTIONS(3551),
    [anon_sym___forceinline] = ACTIONS(3551),
    [anon_sym_thread_local] = ACTIONS(3551),
    [anon_sym___thread] = ACTIONS(3551),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_constexpr] = ACTIONS(3551),
    [anon_sym_volatile] = ACTIONS(3551),
    [anon_sym_restrict] = ACTIONS(3551),
    [anon_sym___restrict__] = ACTIONS(3551),
    [anon_sym__Atomic] = ACTIONS(3551),
    [anon_sym__Noreturn] = ACTIONS(3551),
    [anon_sym_noreturn] = ACTIONS(3551),
    [anon_sym_mutable] = ACTIONS(3551),
    [anon_sym_constinit] = ACTIONS(3551),
    [anon_sym_consteval] = ACTIONS(3551),
    [anon_sym_alignas] = ACTIONS(3551),
    [anon_sym__Alignas] = ACTIONS(3551),
    [sym_primitive_type] = ACTIONS(3551),
    [anon_sym_enum] = ACTIONS(3551),
    [anon_sym_class] = ACTIONS(3551),
    [anon_sym_struct] = ACTIONS(3551),
    [anon_sym_union] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(3551),
    [anon_sym_switch] = ACTIONS(3551),
    [anon_sym_case] = ACTIONS(3551),
    [anon_sym_default] = ACTIONS(3551),
    [anon_sym_while] = ACTIONS(3551),
    [anon_sym_do] = ACTIONS(3551),
    [anon_sym_for] = ACTIONS(3551),
    [anon_sym_return] = ACTIONS(3551),
    [anon_sym_break] = ACTIONS(3551),
    [anon_sym_continue] = ACTIONS(3551),
    [anon_sym_goto] = ACTIONS(3551),
    [anon_sym___try] = ACTIONS(3551),
    [anon_sym___leave] = ACTIONS(3551),
    [anon_sym_not] = ACTIONS(3551),
    [anon_sym_compl] = ACTIONS(3551),
    [anon_sym_DASH_DASH] = ACTIONS(3553),
    [anon_sym_PLUS_PLUS] = ACTIONS(3553),
    [anon_sym_sizeof] = ACTIONS(3551),
    [anon_sym___alignof__] = ACTIONS(3551),
    [anon_sym___alignof] = ACTIONS(3551),
    [anon_sym__alignof] = ACTIONS(3551),
    [anon_sym_alignof] = ACTIONS(3551),
    [anon_sym__Alignof] = ACTIONS(3551),
    [anon_sym_offsetof] = ACTIONS(3551),
    [anon_sym__Generic] = ACTIONS(3551),
    [anon_sym_asm] = ACTIONS(3551),
    [anon_sym___asm__] = ACTIONS(3551),
    [sym_number_literal] = ACTIONS(3553),
    [anon_sym_L_SQUOTE] = ACTIONS(3553),
    [anon_sym_u_SQUOTE] = ACTIONS(3553),
    [anon_sym_U_SQUOTE] = ACTIONS(3553),
    [anon_sym_u8_SQUOTE] = ACTIONS(3553),
    [anon_sym_SQUOTE] = ACTIONS(3553),
    [anon_sym_L_DQUOTE] = ACTIONS(3553),
    [anon_sym_u_DQUOTE] = ACTIONS(3553),
    [anon_sym_U_DQUOTE] = ACTIONS(3553),
    [anon_sym_u8_DQUOTE] = ACTIONS(3553),
    [anon_sym_DQUOTE] = ACTIONS(3553),
    [sym_true] = ACTIONS(3551),
    [sym_false] = ACTIONS(3551),
    [anon_sym_NULL] = ACTIONS(3551),
    [anon_sym_nullptr] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3551),
    [anon_sym_let] = ACTIONS(3551),
    [anon_sym_This] = ACTIONS(3551),
    [anon_sym_decltype] = ACTIONS(3551),
    [sym_virtual] = ACTIONS(3551),
    [anon_sym_explicit] = ACTIONS(3551),
    [anon_sym_typename] = ACTIONS(3551),
    [anon_sym_template] = ACTIONS(3551),
    [anon_sym_operator] = ACTIONS(3551),
    [anon_sym_try] = ACTIONS(3551),
    [anon_sym_delete] = ACTIONS(3551),
    [anon_sym_throw] = ACTIONS(3551),
    [anon_sym_namespace] = ACTIONS(3551),
    [anon_sym_using] = ACTIONS(3551),
    [anon_sym_static_assert] = ACTIONS(3551),
    [anon_sym_concept] = ACTIONS(3551),
    [anon_sym_co_return] = ACTIONS(3551),
    [anon_sym_co_yield] = ACTIONS(3551),
    [anon_sym_R_DQUOTE] = ACTIONS(3553),
    [anon_sym_LR_DQUOTE] = ACTIONS(3553),
    [anon_sym_uR_DQUOTE] = ACTIONS(3553),
    [anon_sym_UR_DQUOTE] = ACTIONS(3553),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3553),
    [anon_sym_co_await] = ACTIONS(3551),
    [anon_sym_new] = ACTIONS(3551),
    [anon_sym_requires] = ACTIONS(3551),
    [sym_this] = ACTIONS(3551),
    [anon_sym_discard] = ACTIONS(3551),
    [anon_sym_precise] = ACTIONS(3551),
    [anon_sym_shared] = ACTIONS(3551),
    [anon_sym_groupshared] = ACTIONS(3551),
    [anon_sym_uniform] = ACTIONS(3551),
    [anon_sym_row_major] = ACTIONS(3551),
    [anon_sym_column_major] = ACTIONS(3551),
    [anon_sym_globallycoherent] = ACTIONS(3551),
    [anon_sym_centroid] = ACTIONS(3551),
    [anon_sym_noperspective] = ACTIONS(3551),
    [anon_sym_nointerpolation] = ACTIONS(3551),
    [anon_sym_sample] = ACTIONS(3551),
    [anon_sym_linear] = ACTIONS(3551),
    [anon_sym_snorm] = ACTIONS(3551),
    [anon_sym_unorm] = ACTIONS(3551),
    [anon_sym_point] = ACTIONS(3551),
    [anon_sym_line] = ACTIONS(3551),
    [anon_sym_triangleadj] = ACTIONS(3551),
    [anon_sym_lineadj] = ACTIONS(3551),
    [anon_sym_triangle] = ACTIONS(3551),
    [anon_sym_cbuffer] = ACTIONS(3551),
    [anon_sym_interface] = ACTIONS(3551),
    [anon_sym_extension] = ACTIONS(3551),
  },
  [814] = {
    [sym_identifier] = ACTIONS(3645),
    [aux_sym_preproc_include_token1] = ACTIONS(3645),
    [aux_sym_preproc_def_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token2] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3645),
    [sym_preproc_directive] = ACTIONS(3645),
    [anon_sym_LPAREN2] = ACTIONS(3647),
    [anon_sym_BANG] = ACTIONS(3647),
    [anon_sym_TILDE] = ACTIONS(3647),
    [anon_sym_DASH] = ACTIONS(3645),
    [anon_sym_PLUS] = ACTIONS(3645),
    [anon_sym_STAR] = ACTIONS(3647),
    [anon_sym_AMP_AMP] = ACTIONS(3647),
    [anon_sym_AMP] = ACTIONS(3645),
    [anon_sym_SEMI] = ACTIONS(3647),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3645),
    [anon_sym_in] = ACTIONS(3645),
    [anon_sym_out] = ACTIONS(3645),
    [anon_sym_inout] = ACTIONS(3645),
    [anon_sym_extern] = ACTIONS(3645),
    [anon_sym___attribute__] = ACTIONS(3645),
    [anon_sym_COLON_COLON] = ACTIONS(3647),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3647),
    [anon_sym___declspec] = ACTIONS(3645),
    [anon_sym___based] = ACTIONS(3645),
    [anon_sym___cdecl] = ACTIONS(3645),
    [anon_sym___clrcall] = ACTIONS(3645),
    [anon_sym___stdcall] = ACTIONS(3645),
    [anon_sym___fastcall] = ACTIONS(3645),
    [anon_sym___thiscall] = ACTIONS(3645),
    [anon_sym___vectorcall] = ACTIONS(3645),
    [anon_sym_LBRACE] = ACTIONS(3647),
    [anon_sym_signed] = ACTIONS(3645),
    [anon_sym_unsigned] = ACTIONS(3645),
    [anon_sym_long] = ACTIONS(3645),
    [anon_sym_short] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_static] = ACTIONS(3645),
    [anon_sym_register] = ACTIONS(3645),
    [anon_sym_inline] = ACTIONS(3645),
    [anon_sym___inline] = ACTIONS(3645),
    [anon_sym___inline__] = ACTIONS(3645),
    [anon_sym___forceinline] = ACTIONS(3645),
    [anon_sym_thread_local] = ACTIONS(3645),
    [anon_sym___thread] = ACTIONS(3645),
    [anon_sym_const] = ACTIONS(3645),
    [anon_sym_constexpr] = ACTIONS(3645),
    [anon_sym_volatile] = ACTIONS(3645),
    [anon_sym_restrict] = ACTIONS(3645),
    [anon_sym___restrict__] = ACTIONS(3645),
    [anon_sym__Atomic] = ACTIONS(3645),
    [anon_sym__Noreturn] = ACTIONS(3645),
    [anon_sym_noreturn] = ACTIONS(3645),
    [anon_sym_mutable] = ACTIONS(3645),
    [anon_sym_constinit] = ACTIONS(3645),
    [anon_sym_consteval] = ACTIONS(3645),
    [anon_sym_alignas] = ACTIONS(3645),
    [anon_sym__Alignas] = ACTIONS(3645),
    [sym_primitive_type] = ACTIONS(3645),
    [anon_sym_enum] = ACTIONS(3645),
    [anon_sym_class] = ACTIONS(3645),
    [anon_sym_struct] = ACTIONS(3645),
    [anon_sym_union] = ACTIONS(3645),
    [anon_sym_if] = ACTIONS(3645),
    [anon_sym_switch] = ACTIONS(3645),
    [anon_sym_case] = ACTIONS(3645),
    [anon_sym_default] = ACTIONS(3645),
    [anon_sym_while] = ACTIONS(3645),
    [anon_sym_do] = ACTIONS(3645),
    [anon_sym_for] = ACTIONS(3645),
    [anon_sym_return] = ACTIONS(3645),
    [anon_sym_break] = ACTIONS(3645),
    [anon_sym_continue] = ACTIONS(3645),
    [anon_sym_goto] = ACTIONS(3645),
    [anon_sym___try] = ACTIONS(3645),
    [anon_sym___leave] = ACTIONS(3645),
    [anon_sym_not] = ACTIONS(3645),
    [anon_sym_compl] = ACTIONS(3645),
    [anon_sym_DASH_DASH] = ACTIONS(3647),
    [anon_sym_PLUS_PLUS] = ACTIONS(3647),
    [anon_sym_sizeof] = ACTIONS(3645),
    [anon_sym___alignof__] = ACTIONS(3645),
    [anon_sym___alignof] = ACTIONS(3645),
    [anon_sym__alignof] = ACTIONS(3645),
    [anon_sym_alignof] = ACTIONS(3645),
    [anon_sym__Alignof] = ACTIONS(3645),
    [anon_sym_offsetof] = ACTIONS(3645),
    [anon_sym__Generic] = ACTIONS(3645),
    [anon_sym_asm] = ACTIONS(3645),
    [anon_sym___asm__] = ACTIONS(3645),
    [sym_number_literal] = ACTIONS(3647),
    [anon_sym_L_SQUOTE] = ACTIONS(3647),
    [anon_sym_u_SQUOTE] = ACTIONS(3647),
    [anon_sym_U_SQUOTE] = ACTIONS(3647),
    [anon_sym_u8_SQUOTE] = ACTIONS(3647),
    [anon_sym_SQUOTE] = ACTIONS(3647),
    [anon_sym_L_DQUOTE] = ACTIONS(3647),
    [anon_sym_u_DQUOTE] = ACTIONS(3647),
    [anon_sym_U_DQUOTE] = ACTIONS(3647),
    [anon_sym_u8_DQUOTE] = ACTIONS(3647),
    [anon_sym_DQUOTE] = ACTIONS(3647),
    [sym_true] = ACTIONS(3645),
    [sym_false] = ACTIONS(3645),
    [anon_sym_NULL] = ACTIONS(3645),
    [anon_sym_nullptr] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3645),
    [anon_sym_let] = ACTIONS(3645),
    [anon_sym_This] = ACTIONS(3645),
    [anon_sym_decltype] = ACTIONS(3645),
    [sym_virtual] = ACTIONS(3645),
    [anon_sym_explicit] = ACTIONS(3645),
    [anon_sym_typename] = ACTIONS(3645),
    [anon_sym_template] = ACTIONS(3645),
    [anon_sym_operator] = ACTIONS(3645),
    [anon_sym_try] = ACTIONS(3645),
    [anon_sym_delete] = ACTIONS(3645),
    [anon_sym_throw] = ACTIONS(3645),
    [anon_sym_namespace] = ACTIONS(3645),
    [anon_sym_using] = ACTIONS(3645),
    [anon_sym_static_assert] = ACTIONS(3645),
    [anon_sym_concept] = ACTIONS(3645),
    [anon_sym_co_return] = ACTIONS(3645),
    [anon_sym_co_yield] = ACTIONS(3645),
    [anon_sym_R_DQUOTE] = ACTIONS(3647),
    [anon_sym_LR_DQUOTE] = ACTIONS(3647),
    [anon_sym_uR_DQUOTE] = ACTIONS(3647),
    [anon_sym_UR_DQUOTE] = ACTIONS(3647),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3647),
    [anon_sym_co_await] = ACTIONS(3645),
    [anon_sym_new] = ACTIONS(3645),
    [anon_sym_requires] = ACTIONS(3645),
    [sym_this] = ACTIONS(3645),
    [anon_sym_discard] = ACTIONS(3645),
    [anon_sym_precise] = ACTIONS(3645),
    [anon_sym_shared] = ACTIONS(3645),
    [anon_sym_groupshared] = ACTIONS(3645),
    [anon_sym_uniform] = ACTIONS(3645),
    [anon_sym_row_major] = ACTIONS(3645),
    [anon_sym_column_major] = ACTIONS(3645),
    [anon_sym_globallycoherent] = ACTIONS(3645),
    [anon_sym_centroid] = ACTIONS(3645),
    [anon_sym_noperspective] = ACTIONS(3645),
    [anon_sym_nointerpolation] = ACTIONS(3645),
    [anon_sym_sample] = ACTIONS(3645),
    [anon_sym_linear] = ACTIONS(3645),
    [anon_sym_snorm] = ACTIONS(3645),
    [anon_sym_unorm] = ACTIONS(3645),
    [anon_sym_point] = ACTIONS(3645),
    [anon_sym_line] = ACTIONS(3645),
    [anon_sym_triangleadj] = ACTIONS(3645),
    [anon_sym_lineadj] = ACTIONS(3645),
    [anon_sym_triangle] = ACTIONS(3645),
    [anon_sym_cbuffer] = ACTIONS(3645),
    [anon_sym_interface] = ACTIONS(3645),
    [anon_sym_extension] = ACTIONS(3645),
  },
  [815] = {
    [sym_identifier] = ACTIONS(3497),
    [aux_sym_preproc_include_token1] = ACTIONS(3497),
    [aux_sym_preproc_def_token1] = ACTIONS(3497),
    [aux_sym_preproc_if_token1] = ACTIONS(3497),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3497),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3497),
    [sym_preproc_directive] = ACTIONS(3497),
    [anon_sym_LPAREN2] = ACTIONS(3499),
    [anon_sym_BANG] = ACTIONS(3499),
    [anon_sym_TILDE] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_STAR] = ACTIONS(3499),
    [anon_sym_AMP_AMP] = ACTIONS(3499),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym_SEMI] = ACTIONS(3499),
    [anon_sym___extension__] = ACTIONS(3497),
    [anon_sym_typedef] = ACTIONS(3497),
    [anon_sym_in] = ACTIONS(3497),
    [anon_sym_out] = ACTIONS(3497),
    [anon_sym_inout] = ACTIONS(3497),
    [anon_sym_extern] = ACTIONS(3497),
    [anon_sym___attribute__] = ACTIONS(3497),
    [anon_sym_COLON_COLON] = ACTIONS(3499),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3499),
    [anon_sym___declspec] = ACTIONS(3497),
    [anon_sym___based] = ACTIONS(3497),
    [anon_sym___cdecl] = ACTIONS(3497),
    [anon_sym___clrcall] = ACTIONS(3497),
    [anon_sym___stdcall] = ACTIONS(3497),
    [anon_sym___fastcall] = ACTIONS(3497),
    [anon_sym___thiscall] = ACTIONS(3497),
    [anon_sym___vectorcall] = ACTIONS(3497),
    [anon_sym_LBRACE] = ACTIONS(3499),
    [anon_sym_RBRACE] = ACTIONS(3499),
    [anon_sym_signed] = ACTIONS(3497),
    [anon_sym_unsigned] = ACTIONS(3497),
    [anon_sym_long] = ACTIONS(3497),
    [anon_sym_short] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3497),
    [anon_sym_static] = ACTIONS(3497),
    [anon_sym_register] = ACTIONS(3497),
    [anon_sym_inline] = ACTIONS(3497),
    [anon_sym___inline] = ACTIONS(3497),
    [anon_sym___inline__] = ACTIONS(3497),
    [anon_sym___forceinline] = ACTIONS(3497),
    [anon_sym_thread_local] = ACTIONS(3497),
    [anon_sym___thread] = ACTIONS(3497),
    [anon_sym_const] = ACTIONS(3497),
    [anon_sym_constexpr] = ACTIONS(3497),
    [anon_sym_volatile] = ACTIONS(3497),
    [anon_sym_restrict] = ACTIONS(3497),
    [anon_sym___restrict__] = ACTIONS(3497),
    [anon_sym__Atomic] = ACTIONS(3497),
    [anon_sym__Noreturn] = ACTIONS(3497),
    [anon_sym_noreturn] = ACTIONS(3497),
    [anon_sym_mutable] = ACTIONS(3497),
    [anon_sym_constinit] = ACTIONS(3497),
    [anon_sym_consteval] = ACTIONS(3497),
    [anon_sym_alignas] = ACTIONS(3497),
    [anon_sym__Alignas] = ACTIONS(3497),
    [sym_primitive_type] = ACTIONS(3497),
    [anon_sym_enum] = ACTIONS(3497),
    [anon_sym_class] = ACTIONS(3497),
    [anon_sym_struct] = ACTIONS(3497),
    [anon_sym_union] = ACTIONS(3497),
    [anon_sym_if] = ACTIONS(3497),
    [anon_sym_switch] = ACTIONS(3497),
    [anon_sym_case] = ACTIONS(3497),
    [anon_sym_default] = ACTIONS(3497),
    [anon_sym_while] = ACTIONS(3497),
    [anon_sym_do] = ACTIONS(3497),
    [anon_sym_for] = ACTIONS(3497),
    [anon_sym_return] = ACTIONS(3497),
    [anon_sym_break] = ACTIONS(3497),
    [anon_sym_continue] = ACTIONS(3497),
    [anon_sym_goto] = ACTIONS(3497),
    [anon_sym___try] = ACTIONS(3497),
    [anon_sym___leave] = ACTIONS(3497),
    [anon_sym_not] = ACTIONS(3497),
    [anon_sym_compl] = ACTIONS(3497),
    [anon_sym_DASH_DASH] = ACTIONS(3499),
    [anon_sym_PLUS_PLUS] = ACTIONS(3499),
    [anon_sym_sizeof] = ACTIONS(3497),
    [anon_sym___alignof__] = ACTIONS(3497),
    [anon_sym___alignof] = ACTIONS(3497),
    [anon_sym__alignof] = ACTIONS(3497),
    [anon_sym_alignof] = ACTIONS(3497),
    [anon_sym__Alignof] = ACTIONS(3497),
    [anon_sym_offsetof] = ACTIONS(3497),
    [anon_sym__Generic] = ACTIONS(3497),
    [anon_sym_asm] = ACTIONS(3497),
    [anon_sym___asm__] = ACTIONS(3497),
    [sym_number_literal] = ACTIONS(3499),
    [anon_sym_L_SQUOTE] = ACTIONS(3499),
    [anon_sym_u_SQUOTE] = ACTIONS(3499),
    [anon_sym_U_SQUOTE] = ACTIONS(3499),
    [anon_sym_u8_SQUOTE] = ACTIONS(3499),
    [anon_sym_SQUOTE] = ACTIONS(3499),
    [anon_sym_L_DQUOTE] = ACTIONS(3499),
    [anon_sym_u_DQUOTE] = ACTIONS(3499),
    [anon_sym_U_DQUOTE] = ACTIONS(3499),
    [anon_sym_u8_DQUOTE] = ACTIONS(3499),
    [anon_sym_DQUOTE] = ACTIONS(3499),
    [sym_true] = ACTIONS(3497),
    [sym_false] = ACTIONS(3497),
    [anon_sym_NULL] = ACTIONS(3497),
    [anon_sym_nullptr] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3497),
    [anon_sym_let] = ACTIONS(3497),
    [anon_sym_This] = ACTIONS(3497),
    [anon_sym_decltype] = ACTIONS(3497),
    [sym_virtual] = ACTIONS(3497),
    [anon_sym_explicit] = ACTIONS(3497),
    [anon_sym_typename] = ACTIONS(3497),
    [anon_sym_template] = ACTIONS(3497),
    [anon_sym_operator] = ACTIONS(3497),
    [anon_sym_try] = ACTIONS(3497),
    [anon_sym_delete] = ACTIONS(3497),
    [anon_sym_throw] = ACTIONS(3497),
    [anon_sym_namespace] = ACTIONS(3497),
    [anon_sym_using] = ACTIONS(3497),
    [anon_sym_static_assert] = ACTIONS(3497),
    [anon_sym_concept] = ACTIONS(3497),
    [anon_sym_co_return] = ACTIONS(3497),
    [anon_sym_co_yield] = ACTIONS(3497),
    [anon_sym_R_DQUOTE] = ACTIONS(3499),
    [anon_sym_LR_DQUOTE] = ACTIONS(3499),
    [anon_sym_uR_DQUOTE] = ACTIONS(3499),
    [anon_sym_UR_DQUOTE] = ACTIONS(3499),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3499),
    [anon_sym_co_await] = ACTIONS(3497),
    [anon_sym_new] = ACTIONS(3497),
    [anon_sym_requires] = ACTIONS(3497),
    [sym_this] = ACTIONS(3497),
    [anon_sym_discard] = ACTIONS(3497),
    [anon_sym_precise] = ACTIONS(3497),
    [anon_sym_shared] = ACTIONS(3497),
    [anon_sym_groupshared] = ACTIONS(3497),
    [anon_sym_uniform] = ACTIONS(3497),
    [anon_sym_row_major] = ACTIONS(3497),
    [anon_sym_column_major] = ACTIONS(3497),
    [anon_sym_globallycoherent] = ACTIONS(3497),
    [anon_sym_centroid] = ACTIONS(3497),
    [anon_sym_noperspective] = ACTIONS(3497),
    [anon_sym_nointerpolation] = ACTIONS(3497),
    [anon_sym_sample] = ACTIONS(3497),
    [anon_sym_linear] = ACTIONS(3497),
    [anon_sym_snorm] = ACTIONS(3497),
    [anon_sym_unorm] = ACTIONS(3497),
    [anon_sym_point] = ACTIONS(3497),
    [anon_sym_line] = ACTIONS(3497),
    [anon_sym_triangleadj] = ACTIONS(3497),
    [anon_sym_lineadj] = ACTIONS(3497),
    [anon_sym_triangle] = ACTIONS(3497),
    [anon_sym_cbuffer] = ACTIONS(3497),
    [anon_sym_interface] = ACTIONS(3497),
    [anon_sym_extension] = ACTIONS(3497),
  },
  [816] = {
    [sym_identifier] = ACTIONS(3497),
    [aux_sym_preproc_include_token1] = ACTIONS(3497),
    [aux_sym_preproc_def_token1] = ACTIONS(3497),
    [aux_sym_preproc_if_token1] = ACTIONS(3497),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3497),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3497),
    [sym_preproc_directive] = ACTIONS(3497),
    [anon_sym_LPAREN2] = ACTIONS(3499),
    [anon_sym_BANG] = ACTIONS(3499),
    [anon_sym_TILDE] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_STAR] = ACTIONS(3499),
    [anon_sym_AMP_AMP] = ACTIONS(3499),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym_SEMI] = ACTIONS(3499),
    [anon_sym___extension__] = ACTIONS(3497),
    [anon_sym_typedef] = ACTIONS(3497),
    [anon_sym_in] = ACTIONS(3497),
    [anon_sym_out] = ACTIONS(3497),
    [anon_sym_inout] = ACTIONS(3497),
    [anon_sym_extern] = ACTIONS(3497),
    [anon_sym___attribute__] = ACTIONS(3497),
    [anon_sym_COLON_COLON] = ACTIONS(3499),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3499),
    [anon_sym___declspec] = ACTIONS(3497),
    [anon_sym___based] = ACTIONS(3497),
    [anon_sym___cdecl] = ACTIONS(3497),
    [anon_sym___clrcall] = ACTIONS(3497),
    [anon_sym___stdcall] = ACTIONS(3497),
    [anon_sym___fastcall] = ACTIONS(3497),
    [anon_sym___thiscall] = ACTIONS(3497),
    [anon_sym___vectorcall] = ACTIONS(3497),
    [anon_sym_LBRACE] = ACTIONS(3499),
    [anon_sym_RBRACE] = ACTIONS(3499),
    [anon_sym_signed] = ACTIONS(3497),
    [anon_sym_unsigned] = ACTIONS(3497),
    [anon_sym_long] = ACTIONS(3497),
    [anon_sym_short] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3497),
    [anon_sym_static] = ACTIONS(3497),
    [anon_sym_register] = ACTIONS(3497),
    [anon_sym_inline] = ACTIONS(3497),
    [anon_sym___inline] = ACTIONS(3497),
    [anon_sym___inline__] = ACTIONS(3497),
    [anon_sym___forceinline] = ACTIONS(3497),
    [anon_sym_thread_local] = ACTIONS(3497),
    [anon_sym___thread] = ACTIONS(3497),
    [anon_sym_const] = ACTIONS(3497),
    [anon_sym_constexpr] = ACTIONS(3497),
    [anon_sym_volatile] = ACTIONS(3497),
    [anon_sym_restrict] = ACTIONS(3497),
    [anon_sym___restrict__] = ACTIONS(3497),
    [anon_sym__Atomic] = ACTIONS(3497),
    [anon_sym__Noreturn] = ACTIONS(3497),
    [anon_sym_noreturn] = ACTIONS(3497),
    [anon_sym_mutable] = ACTIONS(3497),
    [anon_sym_constinit] = ACTIONS(3497),
    [anon_sym_consteval] = ACTIONS(3497),
    [anon_sym_alignas] = ACTIONS(3497),
    [anon_sym__Alignas] = ACTIONS(3497),
    [sym_primitive_type] = ACTIONS(3497),
    [anon_sym_enum] = ACTIONS(3497),
    [anon_sym_class] = ACTIONS(3497),
    [anon_sym_struct] = ACTIONS(3497),
    [anon_sym_union] = ACTIONS(3497),
    [anon_sym_if] = ACTIONS(3497),
    [anon_sym_switch] = ACTIONS(3497),
    [anon_sym_case] = ACTIONS(3497),
    [anon_sym_default] = ACTIONS(3497),
    [anon_sym_while] = ACTIONS(3497),
    [anon_sym_do] = ACTIONS(3497),
    [anon_sym_for] = ACTIONS(3497),
    [anon_sym_return] = ACTIONS(3497),
    [anon_sym_break] = ACTIONS(3497),
    [anon_sym_continue] = ACTIONS(3497),
    [anon_sym_goto] = ACTIONS(3497),
    [anon_sym___try] = ACTIONS(3497),
    [anon_sym___leave] = ACTIONS(3497),
    [anon_sym_not] = ACTIONS(3497),
    [anon_sym_compl] = ACTIONS(3497),
    [anon_sym_DASH_DASH] = ACTIONS(3499),
    [anon_sym_PLUS_PLUS] = ACTIONS(3499),
    [anon_sym_sizeof] = ACTIONS(3497),
    [anon_sym___alignof__] = ACTIONS(3497),
    [anon_sym___alignof] = ACTIONS(3497),
    [anon_sym__alignof] = ACTIONS(3497),
    [anon_sym_alignof] = ACTIONS(3497),
    [anon_sym__Alignof] = ACTIONS(3497),
    [anon_sym_offsetof] = ACTIONS(3497),
    [anon_sym__Generic] = ACTIONS(3497),
    [anon_sym_asm] = ACTIONS(3497),
    [anon_sym___asm__] = ACTIONS(3497),
    [sym_number_literal] = ACTIONS(3499),
    [anon_sym_L_SQUOTE] = ACTIONS(3499),
    [anon_sym_u_SQUOTE] = ACTIONS(3499),
    [anon_sym_U_SQUOTE] = ACTIONS(3499),
    [anon_sym_u8_SQUOTE] = ACTIONS(3499),
    [anon_sym_SQUOTE] = ACTIONS(3499),
    [anon_sym_L_DQUOTE] = ACTIONS(3499),
    [anon_sym_u_DQUOTE] = ACTIONS(3499),
    [anon_sym_U_DQUOTE] = ACTIONS(3499),
    [anon_sym_u8_DQUOTE] = ACTIONS(3499),
    [anon_sym_DQUOTE] = ACTIONS(3499),
    [sym_true] = ACTIONS(3497),
    [sym_false] = ACTIONS(3497),
    [anon_sym_NULL] = ACTIONS(3497),
    [anon_sym_nullptr] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3497),
    [anon_sym_let] = ACTIONS(3497),
    [anon_sym_This] = ACTIONS(3497),
    [anon_sym_decltype] = ACTIONS(3497),
    [sym_virtual] = ACTIONS(3497),
    [anon_sym_explicit] = ACTIONS(3497),
    [anon_sym_typename] = ACTIONS(3497),
    [anon_sym_template] = ACTIONS(3497),
    [anon_sym_operator] = ACTIONS(3497),
    [anon_sym_try] = ACTIONS(3497),
    [anon_sym_delete] = ACTIONS(3497),
    [anon_sym_throw] = ACTIONS(3497),
    [anon_sym_namespace] = ACTIONS(3497),
    [anon_sym_using] = ACTIONS(3497),
    [anon_sym_static_assert] = ACTIONS(3497),
    [anon_sym_concept] = ACTIONS(3497),
    [anon_sym_co_return] = ACTIONS(3497),
    [anon_sym_co_yield] = ACTIONS(3497),
    [anon_sym_R_DQUOTE] = ACTIONS(3499),
    [anon_sym_LR_DQUOTE] = ACTIONS(3499),
    [anon_sym_uR_DQUOTE] = ACTIONS(3499),
    [anon_sym_UR_DQUOTE] = ACTIONS(3499),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3499),
    [anon_sym_co_await] = ACTIONS(3497),
    [anon_sym_new] = ACTIONS(3497),
    [anon_sym_requires] = ACTIONS(3497),
    [sym_this] = ACTIONS(3497),
    [anon_sym_discard] = ACTIONS(3497),
    [anon_sym_precise] = ACTIONS(3497),
    [anon_sym_shared] = ACTIONS(3497),
    [anon_sym_groupshared] = ACTIONS(3497),
    [anon_sym_uniform] = ACTIONS(3497),
    [anon_sym_row_major] = ACTIONS(3497),
    [anon_sym_column_major] = ACTIONS(3497),
    [anon_sym_globallycoherent] = ACTIONS(3497),
    [anon_sym_centroid] = ACTIONS(3497),
    [anon_sym_noperspective] = ACTIONS(3497),
    [anon_sym_nointerpolation] = ACTIONS(3497),
    [anon_sym_sample] = ACTIONS(3497),
    [anon_sym_linear] = ACTIONS(3497),
    [anon_sym_snorm] = ACTIONS(3497),
    [anon_sym_unorm] = ACTIONS(3497),
    [anon_sym_point] = ACTIONS(3497),
    [anon_sym_line] = ACTIONS(3497),
    [anon_sym_triangleadj] = ACTIONS(3497),
    [anon_sym_lineadj] = ACTIONS(3497),
    [anon_sym_triangle] = ACTIONS(3497),
    [anon_sym_cbuffer] = ACTIONS(3497),
    [anon_sym_interface] = ACTIONS(3497),
    [anon_sym_extension] = ACTIONS(3497),
  },
  [817] = {
    [sym_identifier] = ACTIONS(3613),
    [aux_sym_preproc_include_token1] = ACTIONS(3613),
    [aux_sym_preproc_def_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3613),
    [sym_preproc_directive] = ACTIONS(3613),
    [anon_sym_LPAREN2] = ACTIONS(3615),
    [anon_sym_BANG] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3613),
    [anon_sym_PLUS] = ACTIONS(3613),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym_SEMI] = ACTIONS(3615),
    [anon_sym___extension__] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3613),
    [anon_sym_in] = ACTIONS(3613),
    [anon_sym_out] = ACTIONS(3613),
    [anon_sym_inout] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym___attribute__] = ACTIONS(3613),
    [anon_sym_COLON_COLON] = ACTIONS(3615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3615),
    [anon_sym___declspec] = ACTIONS(3613),
    [anon_sym___based] = ACTIONS(3613),
    [anon_sym___cdecl] = ACTIONS(3613),
    [anon_sym___clrcall] = ACTIONS(3613),
    [anon_sym___stdcall] = ACTIONS(3613),
    [anon_sym___fastcall] = ACTIONS(3613),
    [anon_sym___thiscall] = ACTIONS(3613),
    [anon_sym___vectorcall] = ACTIONS(3613),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_RBRACE] = ACTIONS(3615),
    [anon_sym_signed] = ACTIONS(3613),
    [anon_sym_unsigned] = ACTIONS(3613),
    [anon_sym_long] = ACTIONS(3613),
    [anon_sym_short] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_register] = ACTIONS(3613),
    [anon_sym_inline] = ACTIONS(3613),
    [anon_sym___inline] = ACTIONS(3613),
    [anon_sym___inline__] = ACTIONS(3613),
    [anon_sym___forceinline] = ACTIONS(3613),
    [anon_sym_thread_local] = ACTIONS(3613),
    [anon_sym___thread] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_constexpr] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_restrict] = ACTIONS(3613),
    [anon_sym___restrict__] = ACTIONS(3613),
    [anon_sym__Atomic] = ACTIONS(3613),
    [anon_sym__Noreturn] = ACTIONS(3613),
    [anon_sym_noreturn] = ACTIONS(3613),
    [anon_sym_mutable] = ACTIONS(3613),
    [anon_sym_constinit] = ACTIONS(3613),
    [anon_sym_consteval] = ACTIONS(3613),
    [anon_sym_alignas] = ACTIONS(3613),
    [anon_sym__Alignas] = ACTIONS(3613),
    [sym_primitive_type] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_union] = ACTIONS(3613),
    [anon_sym_if] = ACTIONS(3613),
    [anon_sym_switch] = ACTIONS(3613),
    [anon_sym_case] = ACTIONS(3613),
    [anon_sym_default] = ACTIONS(3613),
    [anon_sym_while] = ACTIONS(3613),
    [anon_sym_do] = ACTIONS(3613),
    [anon_sym_for] = ACTIONS(3613),
    [anon_sym_return] = ACTIONS(3613),
    [anon_sym_break] = ACTIONS(3613),
    [anon_sym_continue] = ACTIONS(3613),
    [anon_sym_goto] = ACTIONS(3613),
    [anon_sym___try] = ACTIONS(3613),
    [anon_sym___leave] = ACTIONS(3613),
    [anon_sym_not] = ACTIONS(3613),
    [anon_sym_compl] = ACTIONS(3613),
    [anon_sym_DASH_DASH] = ACTIONS(3615),
    [anon_sym_PLUS_PLUS] = ACTIONS(3615),
    [anon_sym_sizeof] = ACTIONS(3613),
    [anon_sym___alignof__] = ACTIONS(3613),
    [anon_sym___alignof] = ACTIONS(3613),
    [anon_sym__alignof] = ACTIONS(3613),
    [anon_sym_alignof] = ACTIONS(3613),
    [anon_sym__Alignof] = ACTIONS(3613),
    [anon_sym_offsetof] = ACTIONS(3613),
    [anon_sym__Generic] = ACTIONS(3613),
    [anon_sym_asm] = ACTIONS(3613),
    [anon_sym___asm__] = ACTIONS(3613),
    [sym_number_literal] = ACTIONS(3615),
    [anon_sym_L_SQUOTE] = ACTIONS(3615),
    [anon_sym_u_SQUOTE] = ACTIONS(3615),
    [anon_sym_U_SQUOTE] = ACTIONS(3615),
    [anon_sym_u8_SQUOTE] = ACTIONS(3615),
    [anon_sym_SQUOTE] = ACTIONS(3615),
    [anon_sym_L_DQUOTE] = ACTIONS(3615),
    [anon_sym_u_DQUOTE] = ACTIONS(3615),
    [anon_sym_U_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8_DQUOTE] = ACTIONS(3615),
    [anon_sym_DQUOTE] = ACTIONS(3615),
    [sym_true] = ACTIONS(3613),
    [sym_false] = ACTIONS(3613),
    [anon_sym_NULL] = ACTIONS(3613),
    [anon_sym_nullptr] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_This] = ACTIONS(3613),
    [anon_sym_decltype] = ACTIONS(3613),
    [sym_virtual] = ACTIONS(3613),
    [anon_sym_explicit] = ACTIONS(3613),
    [anon_sym_typename] = ACTIONS(3613),
    [anon_sym_template] = ACTIONS(3613),
    [anon_sym_operator] = ACTIONS(3613),
    [anon_sym_try] = ACTIONS(3613),
    [anon_sym_delete] = ACTIONS(3613),
    [anon_sym_throw] = ACTIONS(3613),
    [anon_sym_namespace] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_static_assert] = ACTIONS(3613),
    [anon_sym_concept] = ACTIONS(3613),
    [anon_sym_co_return] = ACTIONS(3613),
    [anon_sym_co_yield] = ACTIONS(3613),
    [anon_sym_R_DQUOTE] = ACTIONS(3615),
    [anon_sym_LR_DQUOTE] = ACTIONS(3615),
    [anon_sym_uR_DQUOTE] = ACTIONS(3615),
    [anon_sym_UR_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3615),
    [anon_sym_co_await] = ACTIONS(3613),
    [anon_sym_new] = ACTIONS(3613),
    [anon_sym_requires] = ACTIONS(3613),
    [sym_this] = ACTIONS(3613),
    [anon_sym_discard] = ACTIONS(3613),
    [anon_sym_precise] = ACTIONS(3613),
    [anon_sym_shared] = ACTIONS(3613),
    [anon_sym_groupshared] = ACTIONS(3613),
    [anon_sym_uniform] = ACTIONS(3613),
    [anon_sym_row_major] = ACTIONS(3613),
    [anon_sym_column_major] = ACTIONS(3613),
    [anon_sym_globallycoherent] = ACTIONS(3613),
    [anon_sym_centroid] = ACTIONS(3613),
    [anon_sym_noperspective] = ACTIONS(3613),
    [anon_sym_nointerpolation] = ACTIONS(3613),
    [anon_sym_sample] = ACTIONS(3613),
    [anon_sym_linear] = ACTIONS(3613),
    [anon_sym_snorm] = ACTIONS(3613),
    [anon_sym_unorm] = ACTIONS(3613),
    [anon_sym_point] = ACTIONS(3613),
    [anon_sym_line] = ACTIONS(3613),
    [anon_sym_triangleadj] = ACTIONS(3613),
    [anon_sym_lineadj] = ACTIONS(3613),
    [anon_sym_triangle] = ACTIONS(3613),
    [anon_sym_cbuffer] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_extension] = ACTIONS(3613),
  },
  [818] = {
    [sym_identifier] = ACTIONS(3613),
    [aux_sym_preproc_include_token1] = ACTIONS(3613),
    [aux_sym_preproc_def_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3613),
    [sym_preproc_directive] = ACTIONS(3613),
    [anon_sym_LPAREN2] = ACTIONS(3615),
    [anon_sym_BANG] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3613),
    [anon_sym_PLUS] = ACTIONS(3613),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym_SEMI] = ACTIONS(3615),
    [anon_sym___extension__] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3613),
    [anon_sym_in] = ACTIONS(3613),
    [anon_sym_out] = ACTIONS(3613),
    [anon_sym_inout] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym___attribute__] = ACTIONS(3613),
    [anon_sym_COLON_COLON] = ACTIONS(3615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3615),
    [anon_sym___declspec] = ACTIONS(3613),
    [anon_sym___based] = ACTIONS(3613),
    [anon_sym___cdecl] = ACTIONS(3613),
    [anon_sym___clrcall] = ACTIONS(3613),
    [anon_sym___stdcall] = ACTIONS(3613),
    [anon_sym___fastcall] = ACTIONS(3613),
    [anon_sym___thiscall] = ACTIONS(3613),
    [anon_sym___vectorcall] = ACTIONS(3613),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_RBRACE] = ACTIONS(3615),
    [anon_sym_signed] = ACTIONS(3613),
    [anon_sym_unsigned] = ACTIONS(3613),
    [anon_sym_long] = ACTIONS(3613),
    [anon_sym_short] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_register] = ACTIONS(3613),
    [anon_sym_inline] = ACTIONS(3613),
    [anon_sym___inline] = ACTIONS(3613),
    [anon_sym___inline__] = ACTIONS(3613),
    [anon_sym___forceinline] = ACTIONS(3613),
    [anon_sym_thread_local] = ACTIONS(3613),
    [anon_sym___thread] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_constexpr] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_restrict] = ACTIONS(3613),
    [anon_sym___restrict__] = ACTIONS(3613),
    [anon_sym__Atomic] = ACTIONS(3613),
    [anon_sym__Noreturn] = ACTIONS(3613),
    [anon_sym_noreturn] = ACTIONS(3613),
    [anon_sym_mutable] = ACTIONS(3613),
    [anon_sym_constinit] = ACTIONS(3613),
    [anon_sym_consteval] = ACTIONS(3613),
    [anon_sym_alignas] = ACTIONS(3613),
    [anon_sym__Alignas] = ACTIONS(3613),
    [sym_primitive_type] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_union] = ACTIONS(3613),
    [anon_sym_if] = ACTIONS(3613),
    [anon_sym_switch] = ACTIONS(3613),
    [anon_sym_case] = ACTIONS(3613),
    [anon_sym_default] = ACTIONS(3613),
    [anon_sym_while] = ACTIONS(3613),
    [anon_sym_do] = ACTIONS(3613),
    [anon_sym_for] = ACTIONS(3613),
    [anon_sym_return] = ACTIONS(3613),
    [anon_sym_break] = ACTIONS(3613),
    [anon_sym_continue] = ACTIONS(3613),
    [anon_sym_goto] = ACTIONS(3613),
    [anon_sym___try] = ACTIONS(3613),
    [anon_sym___leave] = ACTIONS(3613),
    [anon_sym_not] = ACTIONS(3613),
    [anon_sym_compl] = ACTIONS(3613),
    [anon_sym_DASH_DASH] = ACTIONS(3615),
    [anon_sym_PLUS_PLUS] = ACTIONS(3615),
    [anon_sym_sizeof] = ACTIONS(3613),
    [anon_sym___alignof__] = ACTIONS(3613),
    [anon_sym___alignof] = ACTIONS(3613),
    [anon_sym__alignof] = ACTIONS(3613),
    [anon_sym_alignof] = ACTIONS(3613),
    [anon_sym__Alignof] = ACTIONS(3613),
    [anon_sym_offsetof] = ACTIONS(3613),
    [anon_sym__Generic] = ACTIONS(3613),
    [anon_sym_asm] = ACTIONS(3613),
    [anon_sym___asm__] = ACTIONS(3613),
    [sym_number_literal] = ACTIONS(3615),
    [anon_sym_L_SQUOTE] = ACTIONS(3615),
    [anon_sym_u_SQUOTE] = ACTIONS(3615),
    [anon_sym_U_SQUOTE] = ACTIONS(3615),
    [anon_sym_u8_SQUOTE] = ACTIONS(3615),
    [anon_sym_SQUOTE] = ACTIONS(3615),
    [anon_sym_L_DQUOTE] = ACTIONS(3615),
    [anon_sym_u_DQUOTE] = ACTIONS(3615),
    [anon_sym_U_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8_DQUOTE] = ACTIONS(3615),
    [anon_sym_DQUOTE] = ACTIONS(3615),
    [sym_true] = ACTIONS(3613),
    [sym_false] = ACTIONS(3613),
    [anon_sym_NULL] = ACTIONS(3613),
    [anon_sym_nullptr] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_This] = ACTIONS(3613),
    [anon_sym_decltype] = ACTIONS(3613),
    [sym_virtual] = ACTIONS(3613),
    [anon_sym_explicit] = ACTIONS(3613),
    [anon_sym_typename] = ACTIONS(3613),
    [anon_sym_template] = ACTIONS(3613),
    [anon_sym_operator] = ACTIONS(3613),
    [anon_sym_try] = ACTIONS(3613),
    [anon_sym_delete] = ACTIONS(3613),
    [anon_sym_throw] = ACTIONS(3613),
    [anon_sym_namespace] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_static_assert] = ACTIONS(3613),
    [anon_sym_concept] = ACTIONS(3613),
    [anon_sym_co_return] = ACTIONS(3613),
    [anon_sym_co_yield] = ACTIONS(3613),
    [anon_sym_R_DQUOTE] = ACTIONS(3615),
    [anon_sym_LR_DQUOTE] = ACTIONS(3615),
    [anon_sym_uR_DQUOTE] = ACTIONS(3615),
    [anon_sym_UR_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3615),
    [anon_sym_co_await] = ACTIONS(3613),
    [anon_sym_new] = ACTIONS(3613),
    [anon_sym_requires] = ACTIONS(3613),
    [sym_this] = ACTIONS(3613),
    [anon_sym_discard] = ACTIONS(3613),
    [anon_sym_precise] = ACTIONS(3613),
    [anon_sym_shared] = ACTIONS(3613),
    [anon_sym_groupshared] = ACTIONS(3613),
    [anon_sym_uniform] = ACTIONS(3613),
    [anon_sym_row_major] = ACTIONS(3613),
    [anon_sym_column_major] = ACTIONS(3613),
    [anon_sym_globallycoherent] = ACTIONS(3613),
    [anon_sym_centroid] = ACTIONS(3613),
    [anon_sym_noperspective] = ACTIONS(3613),
    [anon_sym_nointerpolation] = ACTIONS(3613),
    [anon_sym_sample] = ACTIONS(3613),
    [anon_sym_linear] = ACTIONS(3613),
    [anon_sym_snorm] = ACTIONS(3613),
    [anon_sym_unorm] = ACTIONS(3613),
    [anon_sym_point] = ACTIONS(3613),
    [anon_sym_line] = ACTIONS(3613),
    [anon_sym_triangleadj] = ACTIONS(3613),
    [anon_sym_lineadj] = ACTIONS(3613),
    [anon_sym_triangle] = ACTIONS(3613),
    [anon_sym_cbuffer] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_extension] = ACTIONS(3613),
  },
  [819] = {
    [sym_identifier] = ACTIONS(3703),
    [aux_sym_preproc_include_token1] = ACTIONS(3703),
    [aux_sym_preproc_def_token1] = ACTIONS(3703),
    [aux_sym_preproc_if_token1] = ACTIONS(3703),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3703),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3703),
    [sym_preproc_directive] = ACTIONS(3703),
    [anon_sym_LPAREN2] = ACTIONS(3705),
    [anon_sym_BANG] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3705),
    [anon_sym_DASH] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3703),
    [anon_sym_STAR] = ACTIONS(3705),
    [anon_sym_AMP_AMP] = ACTIONS(3705),
    [anon_sym_AMP] = ACTIONS(3703),
    [anon_sym_SEMI] = ACTIONS(3705),
    [anon_sym___extension__] = ACTIONS(3703),
    [anon_sym_typedef] = ACTIONS(3703),
    [anon_sym_in] = ACTIONS(3703),
    [anon_sym_out] = ACTIONS(3703),
    [anon_sym_inout] = ACTIONS(3703),
    [anon_sym_extern] = ACTIONS(3703),
    [anon_sym___attribute__] = ACTIONS(3703),
    [anon_sym_COLON_COLON] = ACTIONS(3705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3705),
    [anon_sym___declspec] = ACTIONS(3703),
    [anon_sym___based] = ACTIONS(3703),
    [anon_sym___cdecl] = ACTIONS(3703),
    [anon_sym___clrcall] = ACTIONS(3703),
    [anon_sym___stdcall] = ACTIONS(3703),
    [anon_sym___fastcall] = ACTIONS(3703),
    [anon_sym___thiscall] = ACTIONS(3703),
    [anon_sym___vectorcall] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [anon_sym_RBRACE] = ACTIONS(3705),
    [anon_sym_signed] = ACTIONS(3703),
    [anon_sym_unsigned] = ACTIONS(3703),
    [anon_sym_long] = ACTIONS(3703),
    [anon_sym_short] = ACTIONS(3703),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_static] = ACTIONS(3703),
    [anon_sym_register] = ACTIONS(3703),
    [anon_sym_inline] = ACTIONS(3703),
    [anon_sym___inline] = ACTIONS(3703),
    [anon_sym___inline__] = ACTIONS(3703),
    [anon_sym___forceinline] = ACTIONS(3703),
    [anon_sym_thread_local] = ACTIONS(3703),
    [anon_sym___thread] = ACTIONS(3703),
    [anon_sym_const] = ACTIONS(3703),
    [anon_sym_constexpr] = ACTIONS(3703),
    [anon_sym_volatile] = ACTIONS(3703),
    [anon_sym_restrict] = ACTIONS(3703),
    [anon_sym___restrict__] = ACTIONS(3703),
    [anon_sym__Atomic] = ACTIONS(3703),
    [anon_sym__Noreturn] = ACTIONS(3703),
    [anon_sym_noreturn] = ACTIONS(3703),
    [anon_sym_mutable] = ACTIONS(3703),
    [anon_sym_constinit] = ACTIONS(3703),
    [anon_sym_consteval] = ACTIONS(3703),
    [anon_sym_alignas] = ACTIONS(3703),
    [anon_sym__Alignas] = ACTIONS(3703),
    [sym_primitive_type] = ACTIONS(3703),
    [anon_sym_enum] = ACTIONS(3703),
    [anon_sym_class] = ACTIONS(3703),
    [anon_sym_struct] = ACTIONS(3703),
    [anon_sym_union] = ACTIONS(3703),
    [anon_sym_if] = ACTIONS(3703),
    [anon_sym_switch] = ACTIONS(3703),
    [anon_sym_case] = ACTIONS(3703),
    [anon_sym_default] = ACTIONS(3703),
    [anon_sym_while] = ACTIONS(3703),
    [anon_sym_do] = ACTIONS(3703),
    [anon_sym_for] = ACTIONS(3703),
    [anon_sym_return] = ACTIONS(3703),
    [anon_sym_break] = ACTIONS(3703),
    [anon_sym_continue] = ACTIONS(3703),
    [anon_sym_goto] = ACTIONS(3703),
    [anon_sym___try] = ACTIONS(3703),
    [anon_sym___leave] = ACTIONS(3703),
    [anon_sym_not] = ACTIONS(3703),
    [anon_sym_compl] = ACTIONS(3703),
    [anon_sym_DASH_DASH] = ACTIONS(3705),
    [anon_sym_PLUS_PLUS] = ACTIONS(3705),
    [anon_sym_sizeof] = ACTIONS(3703),
    [anon_sym___alignof__] = ACTIONS(3703),
    [anon_sym___alignof] = ACTIONS(3703),
    [anon_sym__alignof] = ACTIONS(3703),
    [anon_sym_alignof] = ACTIONS(3703),
    [anon_sym__Alignof] = ACTIONS(3703),
    [anon_sym_offsetof] = ACTIONS(3703),
    [anon_sym__Generic] = ACTIONS(3703),
    [anon_sym_asm] = ACTIONS(3703),
    [anon_sym___asm__] = ACTIONS(3703),
    [sym_number_literal] = ACTIONS(3705),
    [anon_sym_L_SQUOTE] = ACTIONS(3705),
    [anon_sym_u_SQUOTE] = ACTIONS(3705),
    [anon_sym_U_SQUOTE] = ACTIONS(3705),
    [anon_sym_u8_SQUOTE] = ACTIONS(3705),
    [anon_sym_SQUOTE] = ACTIONS(3705),
    [anon_sym_L_DQUOTE] = ACTIONS(3705),
    [anon_sym_u_DQUOTE] = ACTIONS(3705),
    [anon_sym_U_DQUOTE] = ACTIONS(3705),
    [anon_sym_u8_DQUOTE] = ACTIONS(3705),
    [anon_sym_DQUOTE] = ACTIONS(3705),
    [sym_true] = ACTIONS(3703),
    [sym_false] = ACTIONS(3703),
    [anon_sym_NULL] = ACTIONS(3703),
    [anon_sym_nullptr] = ACTIONS(3703),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3703),
    [anon_sym_let] = ACTIONS(3703),
    [anon_sym_This] = ACTIONS(3703),
    [anon_sym_decltype] = ACTIONS(3703),
    [sym_virtual] = ACTIONS(3703),
    [anon_sym_explicit] = ACTIONS(3703),
    [anon_sym_typename] = ACTIONS(3703),
    [anon_sym_template] = ACTIONS(3703),
    [anon_sym_operator] = ACTIONS(3703),
    [anon_sym_try] = ACTIONS(3703),
    [anon_sym_delete] = ACTIONS(3703),
    [anon_sym_throw] = ACTIONS(3703),
    [anon_sym_namespace] = ACTIONS(3703),
    [anon_sym_using] = ACTIONS(3703),
    [anon_sym_static_assert] = ACTIONS(3703),
    [anon_sym_concept] = ACTIONS(3703),
    [anon_sym_co_return] = ACTIONS(3703),
    [anon_sym_co_yield] = ACTIONS(3703),
    [anon_sym_R_DQUOTE] = ACTIONS(3705),
    [anon_sym_LR_DQUOTE] = ACTIONS(3705),
    [anon_sym_uR_DQUOTE] = ACTIONS(3705),
    [anon_sym_UR_DQUOTE] = ACTIONS(3705),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3705),
    [anon_sym_co_await] = ACTIONS(3703),
    [anon_sym_new] = ACTIONS(3703),
    [anon_sym_requires] = ACTIONS(3703),
    [sym_this] = ACTIONS(3703),
    [anon_sym_discard] = ACTIONS(3703),
    [anon_sym_precise] = ACTIONS(3703),
    [anon_sym_shared] = ACTIONS(3703),
    [anon_sym_groupshared] = ACTIONS(3703),
    [anon_sym_uniform] = ACTIONS(3703),
    [anon_sym_row_major] = ACTIONS(3703),
    [anon_sym_column_major] = ACTIONS(3703),
    [anon_sym_globallycoherent] = ACTIONS(3703),
    [anon_sym_centroid] = ACTIONS(3703),
    [anon_sym_noperspective] = ACTIONS(3703),
    [anon_sym_nointerpolation] = ACTIONS(3703),
    [anon_sym_sample] = ACTIONS(3703),
    [anon_sym_linear] = ACTIONS(3703),
    [anon_sym_snorm] = ACTIONS(3703),
    [anon_sym_unorm] = ACTIONS(3703),
    [anon_sym_point] = ACTIONS(3703),
    [anon_sym_line] = ACTIONS(3703),
    [anon_sym_triangleadj] = ACTIONS(3703),
    [anon_sym_lineadj] = ACTIONS(3703),
    [anon_sym_triangle] = ACTIONS(3703),
    [anon_sym_cbuffer] = ACTIONS(3703),
    [anon_sym_interface] = ACTIONS(3703),
    [anon_sym_extension] = ACTIONS(3703),
  },
  [820] = {
    [sym_identifier] = ACTIONS(3463),
    [aux_sym_preproc_include_token1] = ACTIONS(3463),
    [aux_sym_preproc_def_token1] = ACTIONS(3463),
    [aux_sym_preproc_if_token1] = ACTIONS(3463),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3463),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3463),
    [sym_preproc_directive] = ACTIONS(3463),
    [anon_sym_LPAREN2] = ACTIONS(3465),
    [anon_sym_BANG] = ACTIONS(3465),
    [anon_sym_TILDE] = ACTIONS(3465),
    [anon_sym_DASH] = ACTIONS(3463),
    [anon_sym_PLUS] = ACTIONS(3463),
    [anon_sym_STAR] = ACTIONS(3465),
    [anon_sym_AMP_AMP] = ACTIONS(3465),
    [anon_sym_AMP] = ACTIONS(3463),
    [anon_sym_SEMI] = ACTIONS(3465),
    [anon_sym___extension__] = ACTIONS(3463),
    [anon_sym_typedef] = ACTIONS(3463),
    [anon_sym_in] = ACTIONS(3463),
    [anon_sym_out] = ACTIONS(3463),
    [anon_sym_inout] = ACTIONS(3463),
    [anon_sym_extern] = ACTIONS(3463),
    [anon_sym___attribute__] = ACTIONS(3463),
    [anon_sym_COLON_COLON] = ACTIONS(3465),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3465),
    [anon_sym___declspec] = ACTIONS(3463),
    [anon_sym___based] = ACTIONS(3463),
    [anon_sym___cdecl] = ACTIONS(3463),
    [anon_sym___clrcall] = ACTIONS(3463),
    [anon_sym___stdcall] = ACTIONS(3463),
    [anon_sym___fastcall] = ACTIONS(3463),
    [anon_sym___thiscall] = ACTIONS(3463),
    [anon_sym___vectorcall] = ACTIONS(3463),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_RBRACE] = ACTIONS(3465),
    [anon_sym_signed] = ACTIONS(3463),
    [anon_sym_unsigned] = ACTIONS(3463),
    [anon_sym_long] = ACTIONS(3463),
    [anon_sym_short] = ACTIONS(3463),
    [anon_sym_LBRACK] = ACTIONS(3463),
    [anon_sym_static] = ACTIONS(3463),
    [anon_sym_register] = ACTIONS(3463),
    [anon_sym_inline] = ACTIONS(3463),
    [anon_sym___inline] = ACTIONS(3463),
    [anon_sym___inline__] = ACTIONS(3463),
    [anon_sym___forceinline] = ACTIONS(3463),
    [anon_sym_thread_local] = ACTIONS(3463),
    [anon_sym___thread] = ACTIONS(3463),
    [anon_sym_const] = ACTIONS(3463),
    [anon_sym_constexpr] = ACTIONS(3463),
    [anon_sym_volatile] = ACTIONS(3463),
    [anon_sym_restrict] = ACTIONS(3463),
    [anon_sym___restrict__] = ACTIONS(3463),
    [anon_sym__Atomic] = ACTIONS(3463),
    [anon_sym__Noreturn] = ACTIONS(3463),
    [anon_sym_noreturn] = ACTIONS(3463),
    [anon_sym_mutable] = ACTIONS(3463),
    [anon_sym_constinit] = ACTIONS(3463),
    [anon_sym_consteval] = ACTIONS(3463),
    [anon_sym_alignas] = ACTIONS(3463),
    [anon_sym__Alignas] = ACTIONS(3463),
    [sym_primitive_type] = ACTIONS(3463),
    [anon_sym_enum] = ACTIONS(3463),
    [anon_sym_class] = ACTIONS(3463),
    [anon_sym_struct] = ACTIONS(3463),
    [anon_sym_union] = ACTIONS(3463),
    [anon_sym_if] = ACTIONS(3463),
    [anon_sym_switch] = ACTIONS(3463),
    [anon_sym_case] = ACTIONS(3463),
    [anon_sym_default] = ACTIONS(3463),
    [anon_sym_while] = ACTIONS(3463),
    [anon_sym_do] = ACTIONS(3463),
    [anon_sym_for] = ACTIONS(3463),
    [anon_sym_return] = ACTIONS(3463),
    [anon_sym_break] = ACTIONS(3463),
    [anon_sym_continue] = ACTIONS(3463),
    [anon_sym_goto] = ACTIONS(3463),
    [anon_sym___try] = ACTIONS(3463),
    [anon_sym___leave] = ACTIONS(3463),
    [anon_sym_not] = ACTIONS(3463),
    [anon_sym_compl] = ACTIONS(3463),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(3463),
    [anon_sym___alignof__] = ACTIONS(3463),
    [anon_sym___alignof] = ACTIONS(3463),
    [anon_sym__alignof] = ACTIONS(3463),
    [anon_sym_alignof] = ACTIONS(3463),
    [anon_sym__Alignof] = ACTIONS(3463),
    [anon_sym_offsetof] = ACTIONS(3463),
    [anon_sym__Generic] = ACTIONS(3463),
    [anon_sym_asm] = ACTIONS(3463),
    [anon_sym___asm__] = ACTIONS(3463),
    [sym_number_literal] = ACTIONS(3465),
    [anon_sym_L_SQUOTE] = ACTIONS(3465),
    [anon_sym_u_SQUOTE] = ACTIONS(3465),
    [anon_sym_U_SQUOTE] = ACTIONS(3465),
    [anon_sym_u8_SQUOTE] = ACTIONS(3465),
    [anon_sym_SQUOTE] = ACTIONS(3465),
    [anon_sym_L_DQUOTE] = ACTIONS(3465),
    [anon_sym_u_DQUOTE] = ACTIONS(3465),
    [anon_sym_U_DQUOTE] = ACTIONS(3465),
    [anon_sym_u8_DQUOTE] = ACTIONS(3465),
    [anon_sym_DQUOTE] = ACTIONS(3465),
    [sym_true] = ACTIONS(3463),
    [sym_false] = ACTIONS(3463),
    [anon_sym_NULL] = ACTIONS(3463),
    [anon_sym_nullptr] = ACTIONS(3463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3463),
    [anon_sym_let] = ACTIONS(3463),
    [anon_sym_This] = ACTIONS(3463),
    [anon_sym_decltype] = ACTIONS(3463),
    [sym_virtual] = ACTIONS(3463),
    [anon_sym_explicit] = ACTIONS(3463),
    [anon_sym_typename] = ACTIONS(3463),
    [anon_sym_template] = ACTIONS(3463),
    [anon_sym_operator] = ACTIONS(3463),
    [anon_sym_try] = ACTIONS(3463),
    [anon_sym_delete] = ACTIONS(3463),
    [anon_sym_throw] = ACTIONS(3463),
    [anon_sym_namespace] = ACTIONS(3463),
    [anon_sym_using] = ACTIONS(3463),
    [anon_sym_static_assert] = ACTIONS(3463),
    [anon_sym_concept] = ACTIONS(3463),
    [anon_sym_co_return] = ACTIONS(3463),
    [anon_sym_co_yield] = ACTIONS(3463),
    [anon_sym_R_DQUOTE] = ACTIONS(3465),
    [anon_sym_LR_DQUOTE] = ACTIONS(3465),
    [anon_sym_uR_DQUOTE] = ACTIONS(3465),
    [anon_sym_UR_DQUOTE] = ACTIONS(3465),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3465),
    [anon_sym_co_await] = ACTIONS(3463),
    [anon_sym_new] = ACTIONS(3463),
    [anon_sym_requires] = ACTIONS(3463),
    [sym_this] = ACTIONS(3463),
    [anon_sym_discard] = ACTIONS(3463),
    [anon_sym_precise] = ACTIONS(3463),
    [anon_sym_shared] = ACTIONS(3463),
    [anon_sym_groupshared] = ACTIONS(3463),
    [anon_sym_uniform] = ACTIONS(3463),
    [anon_sym_row_major] = ACTIONS(3463),
    [anon_sym_column_major] = ACTIONS(3463),
    [anon_sym_globallycoherent] = ACTIONS(3463),
    [anon_sym_centroid] = ACTIONS(3463),
    [anon_sym_noperspective] = ACTIONS(3463),
    [anon_sym_nointerpolation] = ACTIONS(3463),
    [anon_sym_sample] = ACTIONS(3463),
    [anon_sym_linear] = ACTIONS(3463),
    [anon_sym_snorm] = ACTIONS(3463),
    [anon_sym_unorm] = ACTIONS(3463),
    [anon_sym_point] = ACTIONS(3463),
    [anon_sym_line] = ACTIONS(3463),
    [anon_sym_triangleadj] = ACTIONS(3463),
    [anon_sym_lineadj] = ACTIONS(3463),
    [anon_sym_triangle] = ACTIONS(3463),
    [anon_sym_cbuffer] = ACTIONS(3463),
    [anon_sym_interface] = ACTIONS(3463),
    [anon_sym_extension] = ACTIONS(3463),
  },
  [821] = {
    [sym_identifier] = ACTIONS(3493),
    [aux_sym_preproc_include_token1] = ACTIONS(3493),
    [aux_sym_preproc_def_token1] = ACTIONS(3493),
    [aux_sym_preproc_if_token1] = ACTIONS(3493),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3493),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3493),
    [sym_preproc_directive] = ACTIONS(3493),
    [anon_sym_LPAREN2] = ACTIONS(3495),
    [anon_sym_BANG] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3495),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_PLUS] = ACTIONS(3493),
    [anon_sym_STAR] = ACTIONS(3495),
    [anon_sym_AMP_AMP] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_SEMI] = ACTIONS(3495),
    [anon_sym___extension__] = ACTIONS(3493),
    [anon_sym_typedef] = ACTIONS(3493),
    [anon_sym_in] = ACTIONS(3493),
    [anon_sym_out] = ACTIONS(3493),
    [anon_sym_inout] = ACTIONS(3493),
    [anon_sym_extern] = ACTIONS(3493),
    [anon_sym___attribute__] = ACTIONS(3493),
    [anon_sym_COLON_COLON] = ACTIONS(3495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3495),
    [anon_sym___declspec] = ACTIONS(3493),
    [anon_sym___based] = ACTIONS(3493),
    [anon_sym___cdecl] = ACTIONS(3493),
    [anon_sym___clrcall] = ACTIONS(3493),
    [anon_sym___stdcall] = ACTIONS(3493),
    [anon_sym___fastcall] = ACTIONS(3493),
    [anon_sym___thiscall] = ACTIONS(3493),
    [anon_sym___vectorcall] = ACTIONS(3493),
    [anon_sym_LBRACE] = ACTIONS(3495),
    [anon_sym_RBRACE] = ACTIONS(3495),
    [anon_sym_signed] = ACTIONS(3493),
    [anon_sym_unsigned] = ACTIONS(3493),
    [anon_sym_long] = ACTIONS(3493),
    [anon_sym_short] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3493),
    [anon_sym_static] = ACTIONS(3493),
    [anon_sym_register] = ACTIONS(3493),
    [anon_sym_inline] = ACTIONS(3493),
    [anon_sym___inline] = ACTIONS(3493),
    [anon_sym___inline__] = ACTIONS(3493),
    [anon_sym___forceinline] = ACTIONS(3493),
    [anon_sym_thread_local] = ACTIONS(3493),
    [anon_sym___thread] = ACTIONS(3493),
    [anon_sym_const] = ACTIONS(3493),
    [anon_sym_constexpr] = ACTIONS(3493),
    [anon_sym_volatile] = ACTIONS(3493),
    [anon_sym_restrict] = ACTIONS(3493),
    [anon_sym___restrict__] = ACTIONS(3493),
    [anon_sym__Atomic] = ACTIONS(3493),
    [anon_sym__Noreturn] = ACTIONS(3493),
    [anon_sym_noreturn] = ACTIONS(3493),
    [anon_sym_mutable] = ACTIONS(3493),
    [anon_sym_constinit] = ACTIONS(3493),
    [anon_sym_consteval] = ACTIONS(3493),
    [anon_sym_alignas] = ACTIONS(3493),
    [anon_sym__Alignas] = ACTIONS(3493),
    [sym_primitive_type] = ACTIONS(3493),
    [anon_sym_enum] = ACTIONS(3493),
    [anon_sym_class] = ACTIONS(3493),
    [anon_sym_struct] = ACTIONS(3493),
    [anon_sym_union] = ACTIONS(3493),
    [anon_sym_if] = ACTIONS(3493),
    [anon_sym_switch] = ACTIONS(3493),
    [anon_sym_case] = ACTIONS(3493),
    [anon_sym_default] = ACTIONS(3493),
    [anon_sym_while] = ACTIONS(3493),
    [anon_sym_do] = ACTIONS(3493),
    [anon_sym_for] = ACTIONS(3493),
    [anon_sym_return] = ACTIONS(3493),
    [anon_sym_break] = ACTIONS(3493),
    [anon_sym_continue] = ACTIONS(3493),
    [anon_sym_goto] = ACTIONS(3493),
    [anon_sym___try] = ACTIONS(3493),
    [anon_sym___leave] = ACTIONS(3493),
    [anon_sym_not] = ACTIONS(3493),
    [anon_sym_compl] = ACTIONS(3493),
    [anon_sym_DASH_DASH] = ACTIONS(3495),
    [anon_sym_PLUS_PLUS] = ACTIONS(3495),
    [anon_sym_sizeof] = ACTIONS(3493),
    [anon_sym___alignof__] = ACTIONS(3493),
    [anon_sym___alignof] = ACTIONS(3493),
    [anon_sym__alignof] = ACTIONS(3493),
    [anon_sym_alignof] = ACTIONS(3493),
    [anon_sym__Alignof] = ACTIONS(3493),
    [anon_sym_offsetof] = ACTIONS(3493),
    [anon_sym__Generic] = ACTIONS(3493),
    [anon_sym_asm] = ACTIONS(3493),
    [anon_sym___asm__] = ACTIONS(3493),
    [sym_number_literal] = ACTIONS(3495),
    [anon_sym_L_SQUOTE] = ACTIONS(3495),
    [anon_sym_u_SQUOTE] = ACTIONS(3495),
    [anon_sym_U_SQUOTE] = ACTIONS(3495),
    [anon_sym_u8_SQUOTE] = ACTIONS(3495),
    [anon_sym_SQUOTE] = ACTIONS(3495),
    [anon_sym_L_DQUOTE] = ACTIONS(3495),
    [anon_sym_u_DQUOTE] = ACTIONS(3495),
    [anon_sym_U_DQUOTE] = ACTIONS(3495),
    [anon_sym_u8_DQUOTE] = ACTIONS(3495),
    [anon_sym_DQUOTE] = ACTIONS(3495),
    [sym_true] = ACTIONS(3493),
    [sym_false] = ACTIONS(3493),
    [anon_sym_NULL] = ACTIONS(3493),
    [anon_sym_nullptr] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3493),
    [anon_sym_let] = ACTIONS(3493),
    [anon_sym_This] = ACTIONS(3493),
    [anon_sym_decltype] = ACTIONS(3493),
    [sym_virtual] = ACTIONS(3493),
    [anon_sym_explicit] = ACTIONS(3493),
    [anon_sym_typename] = ACTIONS(3493),
    [anon_sym_template] = ACTIONS(3493),
    [anon_sym_operator] = ACTIONS(3493),
    [anon_sym_try] = ACTIONS(3493),
    [anon_sym_delete] = ACTIONS(3493),
    [anon_sym_throw] = ACTIONS(3493),
    [anon_sym_namespace] = ACTIONS(3493),
    [anon_sym_using] = ACTIONS(3493),
    [anon_sym_static_assert] = ACTIONS(3493),
    [anon_sym_concept] = ACTIONS(3493),
    [anon_sym_co_return] = ACTIONS(3493),
    [anon_sym_co_yield] = ACTIONS(3493),
    [anon_sym_R_DQUOTE] = ACTIONS(3495),
    [anon_sym_LR_DQUOTE] = ACTIONS(3495),
    [anon_sym_uR_DQUOTE] = ACTIONS(3495),
    [anon_sym_UR_DQUOTE] = ACTIONS(3495),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3495),
    [anon_sym_co_await] = ACTIONS(3493),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_requires] = ACTIONS(3493),
    [sym_this] = ACTIONS(3493),
    [anon_sym_discard] = ACTIONS(3493),
    [anon_sym_precise] = ACTIONS(3493),
    [anon_sym_shared] = ACTIONS(3493),
    [anon_sym_groupshared] = ACTIONS(3493),
    [anon_sym_uniform] = ACTIONS(3493),
    [anon_sym_row_major] = ACTIONS(3493),
    [anon_sym_column_major] = ACTIONS(3493),
    [anon_sym_globallycoherent] = ACTIONS(3493),
    [anon_sym_centroid] = ACTIONS(3493),
    [anon_sym_noperspective] = ACTIONS(3493),
    [anon_sym_nointerpolation] = ACTIONS(3493),
    [anon_sym_sample] = ACTIONS(3493),
    [anon_sym_linear] = ACTIONS(3493),
    [anon_sym_snorm] = ACTIONS(3493),
    [anon_sym_unorm] = ACTIONS(3493),
    [anon_sym_point] = ACTIONS(3493),
    [anon_sym_line] = ACTIONS(3493),
    [anon_sym_triangleadj] = ACTIONS(3493),
    [anon_sym_lineadj] = ACTIONS(3493),
    [anon_sym_triangle] = ACTIONS(3493),
    [anon_sym_cbuffer] = ACTIONS(3493),
    [anon_sym_interface] = ACTIONS(3493),
    [anon_sym_extension] = ACTIONS(3493),
  },
  [822] = {
    [sym_attribute_specifier] = STATE(295),
    [ts_builtin_sym_end] = ACTIONS(3842),
    [sym_identifier] = ACTIONS(3840),
    [aux_sym_preproc_include_token1] = ACTIONS(3840),
    [aux_sym_preproc_def_token1] = ACTIONS(3840),
    [aux_sym_preproc_if_token1] = ACTIONS(3840),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3840),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3840),
    [sym_preproc_directive] = ACTIONS(3840),
    [anon_sym_LPAREN2] = ACTIONS(3842),
    [anon_sym_BANG] = ACTIONS(3842),
    [anon_sym_TILDE] = ACTIONS(3842),
    [anon_sym_DASH] = ACTIONS(3840),
    [anon_sym_PLUS] = ACTIONS(3840),
    [anon_sym_STAR] = ACTIONS(3842),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_AMP] = ACTIONS(3840),
    [anon_sym_SEMI] = ACTIONS(3842),
    [anon_sym___extension__] = ACTIONS(3840),
    [anon_sym_typedef] = ACTIONS(3840),
    [anon_sym_in] = ACTIONS(3840),
    [anon_sym_out] = ACTIONS(3840),
    [anon_sym_inout] = ACTIONS(3840),
    [anon_sym_extern] = ACTIONS(3840),
    [anon_sym___attribute__] = ACTIONS(2861),
    [anon_sym_COLON_COLON] = ACTIONS(3842),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3842),
    [anon_sym___declspec] = ACTIONS(3840),
    [anon_sym___based] = ACTIONS(3840),
    [anon_sym___cdecl] = ACTIONS(3840),
    [anon_sym___clrcall] = ACTIONS(3840),
    [anon_sym___stdcall] = ACTIONS(3840),
    [anon_sym___fastcall] = ACTIONS(3840),
    [anon_sym___thiscall] = ACTIONS(3840),
    [anon_sym___vectorcall] = ACTIONS(3840),
    [anon_sym_LBRACE] = ACTIONS(3842),
    [anon_sym_signed] = ACTIONS(3840),
    [anon_sym_unsigned] = ACTIONS(3840),
    [anon_sym_long] = ACTIONS(3840),
    [anon_sym_short] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3840),
    [anon_sym_static] = ACTIONS(3840),
    [anon_sym_register] = ACTIONS(3840),
    [anon_sym_inline] = ACTIONS(3840),
    [anon_sym___inline] = ACTIONS(3840),
    [anon_sym___inline__] = ACTIONS(3840),
    [anon_sym___forceinline] = ACTIONS(3840),
    [anon_sym_thread_local] = ACTIONS(3840),
    [anon_sym___thread] = ACTIONS(3840),
    [anon_sym_const] = ACTIONS(3840),
    [anon_sym_constexpr] = ACTIONS(3840),
    [anon_sym_volatile] = ACTIONS(3840),
    [anon_sym_restrict] = ACTIONS(3840),
    [anon_sym___restrict__] = ACTIONS(3840),
    [anon_sym__Atomic] = ACTIONS(3840),
    [anon_sym__Noreturn] = ACTIONS(3840),
    [anon_sym_noreturn] = ACTIONS(3840),
    [anon_sym_mutable] = ACTIONS(3840),
    [anon_sym_constinit] = ACTIONS(3840),
    [anon_sym_consteval] = ACTIONS(3840),
    [anon_sym_alignas] = ACTIONS(3840),
    [anon_sym__Alignas] = ACTIONS(3840),
    [sym_primitive_type] = ACTIONS(3840),
    [anon_sym_enum] = ACTIONS(3840),
    [anon_sym_class] = ACTIONS(3840),
    [anon_sym_struct] = ACTIONS(3840),
    [anon_sym_union] = ACTIONS(3840),
    [anon_sym_if] = ACTIONS(3840),
    [anon_sym_switch] = ACTIONS(3840),
    [anon_sym_case] = ACTIONS(3840),
    [anon_sym_default] = ACTIONS(3840),
    [anon_sym_while] = ACTIONS(3840),
    [anon_sym_do] = ACTIONS(3840),
    [anon_sym_for] = ACTIONS(3840),
    [anon_sym_return] = ACTIONS(3840),
    [anon_sym_break] = ACTIONS(3840),
    [anon_sym_continue] = ACTIONS(3840),
    [anon_sym_goto] = ACTIONS(3840),
    [anon_sym_not] = ACTIONS(3840),
    [anon_sym_compl] = ACTIONS(3840),
    [anon_sym_DASH_DASH] = ACTIONS(3842),
    [anon_sym_PLUS_PLUS] = ACTIONS(3842),
    [anon_sym_sizeof] = ACTIONS(3840),
    [anon_sym___alignof__] = ACTIONS(3840),
    [anon_sym___alignof] = ACTIONS(3840),
    [anon_sym__alignof] = ACTIONS(3840),
    [anon_sym_alignof] = ACTIONS(3840),
    [anon_sym__Alignof] = ACTIONS(3840),
    [anon_sym_offsetof] = ACTIONS(3840),
    [anon_sym__Generic] = ACTIONS(3840),
    [anon_sym_asm] = ACTIONS(3840),
    [anon_sym___asm__] = ACTIONS(3840),
    [anon_sym_DOT] = ACTIONS(3840),
    [sym_number_literal] = ACTIONS(3842),
    [anon_sym_L_SQUOTE] = ACTIONS(3842),
    [anon_sym_u_SQUOTE] = ACTIONS(3842),
    [anon_sym_U_SQUOTE] = ACTIONS(3842),
    [anon_sym_u8_SQUOTE] = ACTIONS(3842),
    [anon_sym_SQUOTE] = ACTIONS(3842),
    [anon_sym_L_DQUOTE] = ACTIONS(3842),
    [anon_sym_u_DQUOTE] = ACTIONS(3842),
    [anon_sym_U_DQUOTE] = ACTIONS(3842),
    [anon_sym_u8_DQUOTE] = ACTIONS(3842),
    [anon_sym_DQUOTE] = ACTIONS(3842),
    [sym_true] = ACTIONS(3840),
    [sym_false] = ACTIONS(3840),
    [anon_sym_NULL] = ACTIONS(3840),
    [anon_sym_nullptr] = ACTIONS(3840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3840),
    [anon_sym_let] = ACTIONS(3840),
    [anon_sym_This] = ACTIONS(3840),
    [anon_sym_decltype] = ACTIONS(3840),
    [sym_virtual] = ACTIONS(3840),
    [anon_sym_explicit] = ACTIONS(3840),
    [anon_sym_typename] = ACTIONS(3840),
    [anon_sym_template] = ACTIONS(3840),
    [anon_sym_operator] = ACTIONS(3840),
    [anon_sym_try] = ACTIONS(3840),
    [anon_sym_delete] = ACTIONS(3840),
    [anon_sym_throw] = ACTIONS(3840),
    [anon_sym_namespace] = ACTIONS(3840),
    [anon_sym_using] = ACTIONS(3840),
    [anon_sym_static_assert] = ACTIONS(3840),
    [anon_sym_concept] = ACTIONS(3840),
    [anon_sym_co_return] = ACTIONS(3840),
    [anon_sym_co_yield] = ACTIONS(3840),
    [anon_sym_R_DQUOTE] = ACTIONS(3842),
    [anon_sym_LR_DQUOTE] = ACTIONS(3842),
    [anon_sym_uR_DQUOTE] = ACTIONS(3842),
    [anon_sym_UR_DQUOTE] = ACTIONS(3842),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3842),
    [anon_sym_co_await] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3840),
    [anon_sym_requires] = ACTIONS(3840),
    [sym_this] = ACTIONS(3840),
    [anon_sym_precise] = ACTIONS(3840),
    [anon_sym_shared] = ACTIONS(3840),
    [anon_sym_groupshared] = ACTIONS(3840),
    [anon_sym_uniform] = ACTIONS(3840),
    [anon_sym_row_major] = ACTIONS(3840),
    [anon_sym_column_major] = ACTIONS(3840),
    [anon_sym_globallycoherent] = ACTIONS(3840),
    [anon_sym_centroid] = ACTIONS(3840),
    [anon_sym_noperspective] = ACTIONS(3840),
    [anon_sym_nointerpolation] = ACTIONS(3840),
    [anon_sym_sample] = ACTIONS(3840),
    [anon_sym_linear] = ACTIONS(3840),
    [anon_sym_snorm] = ACTIONS(3840),
    [anon_sym_unorm] = ACTIONS(3840),
    [anon_sym_point] = ACTIONS(3840),
    [anon_sym_line] = ACTIONS(3840),
    [anon_sym_triangleadj] = ACTIONS(3840),
    [anon_sym_lineadj] = ACTIONS(3840),
    [anon_sym_triangle] = ACTIONS(3840),
    [anon_sym_interface] = ACTIONS(3840),
    [anon_sym_extension] = ACTIONS(3840),
    [anon_sym___exported] = ACTIONS(3840),
    [anon_sym_import] = ACTIONS(3840),
  },
  [823] = {
    [sym_identifier] = ACTIONS(3669),
    [aux_sym_preproc_include_token1] = ACTIONS(3669),
    [aux_sym_preproc_def_token1] = ACTIONS(3669),
    [aux_sym_preproc_if_token1] = ACTIONS(3669),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3669),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3669),
    [sym_preproc_directive] = ACTIONS(3669),
    [anon_sym_LPAREN2] = ACTIONS(3671),
    [anon_sym_BANG] = ACTIONS(3671),
    [anon_sym_TILDE] = ACTIONS(3671),
    [anon_sym_DASH] = ACTIONS(3669),
    [anon_sym_PLUS] = ACTIONS(3669),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3671),
    [anon_sym_AMP] = ACTIONS(3669),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym___extension__] = ACTIONS(3669),
    [anon_sym_typedef] = ACTIONS(3669),
    [anon_sym_in] = ACTIONS(3669),
    [anon_sym_out] = ACTIONS(3669),
    [anon_sym_inout] = ACTIONS(3669),
    [anon_sym_extern] = ACTIONS(3669),
    [anon_sym___attribute__] = ACTIONS(3669),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3671),
    [anon_sym___declspec] = ACTIONS(3669),
    [anon_sym___based] = ACTIONS(3669),
    [anon_sym___cdecl] = ACTIONS(3669),
    [anon_sym___clrcall] = ACTIONS(3669),
    [anon_sym___stdcall] = ACTIONS(3669),
    [anon_sym___fastcall] = ACTIONS(3669),
    [anon_sym___thiscall] = ACTIONS(3669),
    [anon_sym___vectorcall] = ACTIONS(3669),
    [anon_sym_LBRACE] = ACTIONS(3671),
    [anon_sym_RBRACE] = ACTIONS(3671),
    [anon_sym_signed] = ACTIONS(3669),
    [anon_sym_unsigned] = ACTIONS(3669),
    [anon_sym_long] = ACTIONS(3669),
    [anon_sym_short] = ACTIONS(3669),
    [anon_sym_LBRACK] = ACTIONS(3669),
    [anon_sym_static] = ACTIONS(3669),
    [anon_sym_register] = ACTIONS(3669),
    [anon_sym_inline] = ACTIONS(3669),
    [anon_sym___inline] = ACTIONS(3669),
    [anon_sym___inline__] = ACTIONS(3669),
    [anon_sym___forceinline] = ACTIONS(3669),
    [anon_sym_thread_local] = ACTIONS(3669),
    [anon_sym___thread] = ACTIONS(3669),
    [anon_sym_const] = ACTIONS(3669),
    [anon_sym_constexpr] = ACTIONS(3669),
    [anon_sym_volatile] = ACTIONS(3669),
    [anon_sym_restrict] = ACTIONS(3669),
    [anon_sym___restrict__] = ACTIONS(3669),
    [anon_sym__Atomic] = ACTIONS(3669),
    [anon_sym__Noreturn] = ACTIONS(3669),
    [anon_sym_noreturn] = ACTIONS(3669),
    [anon_sym_mutable] = ACTIONS(3669),
    [anon_sym_constinit] = ACTIONS(3669),
    [anon_sym_consteval] = ACTIONS(3669),
    [anon_sym_alignas] = ACTIONS(3669),
    [anon_sym__Alignas] = ACTIONS(3669),
    [sym_primitive_type] = ACTIONS(3669),
    [anon_sym_enum] = ACTIONS(3669),
    [anon_sym_class] = ACTIONS(3669),
    [anon_sym_struct] = ACTIONS(3669),
    [anon_sym_union] = ACTIONS(3669),
    [anon_sym_if] = ACTIONS(3669),
    [anon_sym_switch] = ACTIONS(3669),
    [anon_sym_case] = ACTIONS(3669),
    [anon_sym_default] = ACTIONS(3669),
    [anon_sym_while] = ACTIONS(3669),
    [anon_sym_do] = ACTIONS(3669),
    [anon_sym_for] = ACTIONS(3669),
    [anon_sym_return] = ACTIONS(3669),
    [anon_sym_break] = ACTIONS(3669),
    [anon_sym_continue] = ACTIONS(3669),
    [anon_sym_goto] = ACTIONS(3669),
    [anon_sym___try] = ACTIONS(3669),
    [anon_sym___leave] = ACTIONS(3669),
    [anon_sym_not] = ACTIONS(3669),
    [anon_sym_compl] = ACTIONS(3669),
    [anon_sym_DASH_DASH] = ACTIONS(3671),
    [anon_sym_PLUS_PLUS] = ACTIONS(3671),
    [anon_sym_sizeof] = ACTIONS(3669),
    [anon_sym___alignof__] = ACTIONS(3669),
    [anon_sym___alignof] = ACTIONS(3669),
    [anon_sym__alignof] = ACTIONS(3669),
    [anon_sym_alignof] = ACTIONS(3669),
    [anon_sym__Alignof] = ACTIONS(3669),
    [anon_sym_offsetof] = ACTIONS(3669),
    [anon_sym__Generic] = ACTIONS(3669),
    [anon_sym_asm] = ACTIONS(3669),
    [anon_sym___asm__] = ACTIONS(3669),
    [sym_number_literal] = ACTIONS(3671),
    [anon_sym_L_SQUOTE] = ACTIONS(3671),
    [anon_sym_u_SQUOTE] = ACTIONS(3671),
    [anon_sym_U_SQUOTE] = ACTIONS(3671),
    [anon_sym_u8_SQUOTE] = ACTIONS(3671),
    [anon_sym_SQUOTE] = ACTIONS(3671),
    [anon_sym_L_DQUOTE] = ACTIONS(3671),
    [anon_sym_u_DQUOTE] = ACTIONS(3671),
    [anon_sym_U_DQUOTE] = ACTIONS(3671),
    [anon_sym_u8_DQUOTE] = ACTIONS(3671),
    [anon_sym_DQUOTE] = ACTIONS(3671),
    [sym_true] = ACTIONS(3669),
    [sym_false] = ACTIONS(3669),
    [anon_sym_NULL] = ACTIONS(3669),
    [anon_sym_nullptr] = ACTIONS(3669),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3669),
    [anon_sym_let] = ACTIONS(3669),
    [anon_sym_This] = ACTIONS(3669),
    [anon_sym_decltype] = ACTIONS(3669),
    [sym_virtual] = ACTIONS(3669),
    [anon_sym_explicit] = ACTIONS(3669),
    [anon_sym_typename] = ACTIONS(3669),
    [anon_sym_template] = ACTIONS(3669),
    [anon_sym_operator] = ACTIONS(3669),
    [anon_sym_try] = ACTIONS(3669),
    [anon_sym_delete] = ACTIONS(3669),
    [anon_sym_throw] = ACTIONS(3669),
    [anon_sym_namespace] = ACTIONS(3669),
    [anon_sym_using] = ACTIONS(3669),
    [anon_sym_static_assert] = ACTIONS(3669),
    [anon_sym_concept] = ACTIONS(3669),
    [anon_sym_co_return] = ACTIONS(3669),
    [anon_sym_co_yield] = ACTIONS(3669),
    [anon_sym_R_DQUOTE] = ACTIONS(3671),
    [anon_sym_LR_DQUOTE] = ACTIONS(3671),
    [anon_sym_uR_DQUOTE] = ACTIONS(3671),
    [anon_sym_UR_DQUOTE] = ACTIONS(3671),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3671),
    [anon_sym_co_await] = ACTIONS(3669),
    [anon_sym_new] = ACTIONS(3669),
    [anon_sym_requires] = ACTIONS(3669),
    [sym_this] = ACTIONS(3669),
    [anon_sym_discard] = ACTIONS(3669),
    [anon_sym_precise] = ACTIONS(3669),
    [anon_sym_shared] = ACTIONS(3669),
    [anon_sym_groupshared] = ACTIONS(3669),
    [anon_sym_uniform] = ACTIONS(3669),
    [anon_sym_row_major] = ACTIONS(3669),
    [anon_sym_column_major] = ACTIONS(3669),
    [anon_sym_globallycoherent] = ACTIONS(3669),
    [anon_sym_centroid] = ACTIONS(3669),
    [anon_sym_noperspective] = ACTIONS(3669),
    [anon_sym_nointerpolation] = ACTIONS(3669),
    [anon_sym_sample] = ACTIONS(3669),
    [anon_sym_linear] = ACTIONS(3669),
    [anon_sym_snorm] = ACTIONS(3669),
    [anon_sym_unorm] = ACTIONS(3669),
    [anon_sym_point] = ACTIONS(3669),
    [anon_sym_line] = ACTIONS(3669),
    [anon_sym_triangleadj] = ACTIONS(3669),
    [anon_sym_lineadj] = ACTIONS(3669),
    [anon_sym_triangle] = ACTIONS(3669),
    [anon_sym_cbuffer] = ACTIONS(3669),
    [anon_sym_interface] = ACTIONS(3669),
    [anon_sym_extension] = ACTIONS(3669),
  },
  [824] = {
    [sym_identifier] = ACTIONS(3645),
    [aux_sym_preproc_include_token1] = ACTIONS(3645),
    [aux_sym_preproc_def_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token1] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3645),
    [sym_preproc_directive] = ACTIONS(3645),
    [anon_sym_LPAREN2] = ACTIONS(3647),
    [anon_sym_BANG] = ACTIONS(3647),
    [anon_sym_TILDE] = ACTIONS(3647),
    [anon_sym_DASH] = ACTIONS(3645),
    [anon_sym_PLUS] = ACTIONS(3645),
    [anon_sym_STAR] = ACTIONS(3647),
    [anon_sym_AMP_AMP] = ACTIONS(3647),
    [anon_sym_AMP] = ACTIONS(3645),
    [anon_sym_SEMI] = ACTIONS(3647),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3645),
    [anon_sym_in] = ACTIONS(3645),
    [anon_sym_out] = ACTIONS(3645),
    [anon_sym_inout] = ACTIONS(3645),
    [anon_sym_extern] = ACTIONS(3645),
    [anon_sym___attribute__] = ACTIONS(3645),
    [anon_sym_COLON_COLON] = ACTIONS(3647),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3647),
    [anon_sym___declspec] = ACTIONS(3645),
    [anon_sym___based] = ACTIONS(3645),
    [anon_sym___cdecl] = ACTIONS(3645),
    [anon_sym___clrcall] = ACTIONS(3645),
    [anon_sym___stdcall] = ACTIONS(3645),
    [anon_sym___fastcall] = ACTIONS(3645),
    [anon_sym___thiscall] = ACTIONS(3645),
    [anon_sym___vectorcall] = ACTIONS(3645),
    [anon_sym_LBRACE] = ACTIONS(3647),
    [anon_sym_RBRACE] = ACTIONS(3647),
    [anon_sym_signed] = ACTIONS(3645),
    [anon_sym_unsigned] = ACTIONS(3645),
    [anon_sym_long] = ACTIONS(3645),
    [anon_sym_short] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_static] = ACTIONS(3645),
    [anon_sym_register] = ACTIONS(3645),
    [anon_sym_inline] = ACTIONS(3645),
    [anon_sym___inline] = ACTIONS(3645),
    [anon_sym___inline__] = ACTIONS(3645),
    [anon_sym___forceinline] = ACTIONS(3645),
    [anon_sym_thread_local] = ACTIONS(3645),
    [anon_sym___thread] = ACTIONS(3645),
    [anon_sym_const] = ACTIONS(3645),
    [anon_sym_constexpr] = ACTIONS(3645),
    [anon_sym_volatile] = ACTIONS(3645),
    [anon_sym_restrict] = ACTIONS(3645),
    [anon_sym___restrict__] = ACTIONS(3645),
    [anon_sym__Atomic] = ACTIONS(3645),
    [anon_sym__Noreturn] = ACTIONS(3645),
    [anon_sym_noreturn] = ACTIONS(3645),
    [anon_sym_mutable] = ACTIONS(3645),
    [anon_sym_constinit] = ACTIONS(3645),
    [anon_sym_consteval] = ACTIONS(3645),
    [anon_sym_alignas] = ACTIONS(3645),
    [anon_sym__Alignas] = ACTIONS(3645),
    [sym_primitive_type] = ACTIONS(3645),
    [anon_sym_enum] = ACTIONS(3645),
    [anon_sym_class] = ACTIONS(3645),
    [anon_sym_struct] = ACTIONS(3645),
    [anon_sym_union] = ACTIONS(3645),
    [anon_sym_if] = ACTIONS(3645),
    [anon_sym_switch] = ACTIONS(3645),
    [anon_sym_case] = ACTIONS(3645),
    [anon_sym_default] = ACTIONS(3645),
    [anon_sym_while] = ACTIONS(3645),
    [anon_sym_do] = ACTIONS(3645),
    [anon_sym_for] = ACTIONS(3645),
    [anon_sym_return] = ACTIONS(3645),
    [anon_sym_break] = ACTIONS(3645),
    [anon_sym_continue] = ACTIONS(3645),
    [anon_sym_goto] = ACTIONS(3645),
    [anon_sym___try] = ACTIONS(3645),
    [anon_sym___leave] = ACTIONS(3645),
    [anon_sym_not] = ACTIONS(3645),
    [anon_sym_compl] = ACTIONS(3645),
    [anon_sym_DASH_DASH] = ACTIONS(3647),
    [anon_sym_PLUS_PLUS] = ACTIONS(3647),
    [anon_sym_sizeof] = ACTIONS(3645),
    [anon_sym___alignof__] = ACTIONS(3645),
    [anon_sym___alignof] = ACTIONS(3645),
    [anon_sym__alignof] = ACTIONS(3645),
    [anon_sym_alignof] = ACTIONS(3645),
    [anon_sym__Alignof] = ACTIONS(3645),
    [anon_sym_offsetof] = ACTIONS(3645),
    [anon_sym__Generic] = ACTIONS(3645),
    [anon_sym_asm] = ACTIONS(3645),
    [anon_sym___asm__] = ACTIONS(3645),
    [sym_number_literal] = ACTIONS(3647),
    [anon_sym_L_SQUOTE] = ACTIONS(3647),
    [anon_sym_u_SQUOTE] = ACTIONS(3647),
    [anon_sym_U_SQUOTE] = ACTIONS(3647),
    [anon_sym_u8_SQUOTE] = ACTIONS(3647),
    [anon_sym_SQUOTE] = ACTIONS(3647),
    [anon_sym_L_DQUOTE] = ACTIONS(3647),
    [anon_sym_u_DQUOTE] = ACTIONS(3647),
    [anon_sym_U_DQUOTE] = ACTIONS(3647),
    [anon_sym_u8_DQUOTE] = ACTIONS(3647),
    [anon_sym_DQUOTE] = ACTIONS(3647),
    [sym_true] = ACTIONS(3645),
    [sym_false] = ACTIONS(3645),
    [anon_sym_NULL] = ACTIONS(3645),
    [anon_sym_nullptr] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3645),
    [anon_sym_let] = ACTIONS(3645),
    [anon_sym_This] = ACTIONS(3645),
    [anon_sym_decltype] = ACTIONS(3645),
    [sym_virtual] = ACTIONS(3645),
    [anon_sym_explicit] = ACTIONS(3645),
    [anon_sym_typename] = ACTIONS(3645),
    [anon_sym_template] = ACTIONS(3645),
    [anon_sym_operator] = ACTIONS(3645),
    [anon_sym_try] = ACTIONS(3645),
    [anon_sym_delete] = ACTIONS(3645),
    [anon_sym_throw] = ACTIONS(3645),
    [anon_sym_namespace] = ACTIONS(3645),
    [anon_sym_using] = ACTIONS(3645),
    [anon_sym_static_assert] = ACTIONS(3645),
    [anon_sym_concept] = ACTIONS(3645),
    [anon_sym_co_return] = ACTIONS(3645),
    [anon_sym_co_yield] = ACTIONS(3645),
    [anon_sym_R_DQUOTE] = ACTIONS(3647),
    [anon_sym_LR_DQUOTE] = ACTIONS(3647),
    [anon_sym_uR_DQUOTE] = ACTIONS(3647),
    [anon_sym_UR_DQUOTE] = ACTIONS(3647),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3647),
    [anon_sym_co_await] = ACTIONS(3645),
    [anon_sym_new] = ACTIONS(3645),
    [anon_sym_requires] = ACTIONS(3645),
    [sym_this] = ACTIONS(3645),
    [anon_sym_discard] = ACTIONS(3645),
    [anon_sym_precise] = ACTIONS(3645),
    [anon_sym_shared] = ACTIONS(3645),
    [anon_sym_groupshared] = ACTIONS(3645),
    [anon_sym_uniform] = ACTIONS(3645),
    [anon_sym_row_major] = ACTIONS(3645),
    [anon_sym_column_major] = ACTIONS(3645),
    [anon_sym_globallycoherent] = ACTIONS(3645),
    [anon_sym_centroid] = ACTIONS(3645),
    [anon_sym_noperspective] = ACTIONS(3645),
    [anon_sym_nointerpolation] = ACTIONS(3645),
    [anon_sym_sample] = ACTIONS(3645),
    [anon_sym_linear] = ACTIONS(3645),
    [anon_sym_snorm] = ACTIONS(3645),
    [anon_sym_unorm] = ACTIONS(3645),
    [anon_sym_point] = ACTIONS(3645),
    [anon_sym_line] = ACTIONS(3645),
    [anon_sym_triangleadj] = ACTIONS(3645),
    [anon_sym_lineadj] = ACTIONS(3645),
    [anon_sym_triangle] = ACTIONS(3645),
    [anon_sym_cbuffer] = ACTIONS(3645),
    [anon_sym_interface] = ACTIONS(3645),
    [anon_sym_extension] = ACTIONS(3645),
  },
  [825] = {
    [sym_identifier] = ACTIONS(3645),
    [aux_sym_preproc_include_token1] = ACTIONS(3645),
    [aux_sym_preproc_def_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token1] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3645),
    [sym_preproc_directive] = ACTIONS(3645),
    [anon_sym_LPAREN2] = ACTIONS(3647),
    [anon_sym_BANG] = ACTIONS(3647),
    [anon_sym_TILDE] = ACTIONS(3647),
    [anon_sym_DASH] = ACTIONS(3645),
    [anon_sym_PLUS] = ACTIONS(3645),
    [anon_sym_STAR] = ACTIONS(3647),
    [anon_sym_AMP_AMP] = ACTIONS(3647),
    [anon_sym_AMP] = ACTIONS(3645),
    [anon_sym_SEMI] = ACTIONS(3647),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3645),
    [anon_sym_in] = ACTIONS(3645),
    [anon_sym_out] = ACTIONS(3645),
    [anon_sym_inout] = ACTIONS(3645),
    [anon_sym_extern] = ACTIONS(3645),
    [anon_sym___attribute__] = ACTIONS(3645),
    [anon_sym_COLON_COLON] = ACTIONS(3647),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3647),
    [anon_sym___declspec] = ACTIONS(3645),
    [anon_sym___based] = ACTIONS(3645),
    [anon_sym___cdecl] = ACTIONS(3645),
    [anon_sym___clrcall] = ACTIONS(3645),
    [anon_sym___stdcall] = ACTIONS(3645),
    [anon_sym___fastcall] = ACTIONS(3645),
    [anon_sym___thiscall] = ACTIONS(3645),
    [anon_sym___vectorcall] = ACTIONS(3645),
    [anon_sym_LBRACE] = ACTIONS(3647),
    [anon_sym_RBRACE] = ACTIONS(3647),
    [anon_sym_signed] = ACTIONS(3645),
    [anon_sym_unsigned] = ACTIONS(3645),
    [anon_sym_long] = ACTIONS(3645),
    [anon_sym_short] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_static] = ACTIONS(3645),
    [anon_sym_register] = ACTIONS(3645),
    [anon_sym_inline] = ACTIONS(3645),
    [anon_sym___inline] = ACTIONS(3645),
    [anon_sym___inline__] = ACTIONS(3645),
    [anon_sym___forceinline] = ACTIONS(3645),
    [anon_sym_thread_local] = ACTIONS(3645),
    [anon_sym___thread] = ACTIONS(3645),
    [anon_sym_const] = ACTIONS(3645),
    [anon_sym_constexpr] = ACTIONS(3645),
    [anon_sym_volatile] = ACTIONS(3645),
    [anon_sym_restrict] = ACTIONS(3645),
    [anon_sym___restrict__] = ACTIONS(3645),
    [anon_sym__Atomic] = ACTIONS(3645),
    [anon_sym__Noreturn] = ACTIONS(3645),
    [anon_sym_noreturn] = ACTIONS(3645),
    [anon_sym_mutable] = ACTIONS(3645),
    [anon_sym_constinit] = ACTIONS(3645),
    [anon_sym_consteval] = ACTIONS(3645),
    [anon_sym_alignas] = ACTIONS(3645),
    [anon_sym__Alignas] = ACTIONS(3645),
    [sym_primitive_type] = ACTIONS(3645),
    [anon_sym_enum] = ACTIONS(3645),
    [anon_sym_class] = ACTIONS(3645),
    [anon_sym_struct] = ACTIONS(3645),
    [anon_sym_union] = ACTIONS(3645),
    [anon_sym_if] = ACTIONS(3645),
    [anon_sym_switch] = ACTIONS(3645),
    [anon_sym_case] = ACTIONS(3645),
    [anon_sym_default] = ACTIONS(3645),
    [anon_sym_while] = ACTIONS(3645),
    [anon_sym_do] = ACTIONS(3645),
    [anon_sym_for] = ACTIONS(3645),
    [anon_sym_return] = ACTIONS(3645),
    [anon_sym_break] = ACTIONS(3645),
    [anon_sym_continue] = ACTIONS(3645),
    [anon_sym_goto] = ACTIONS(3645),
    [anon_sym___try] = ACTIONS(3645),
    [anon_sym___leave] = ACTIONS(3645),
    [anon_sym_not] = ACTIONS(3645),
    [anon_sym_compl] = ACTIONS(3645),
    [anon_sym_DASH_DASH] = ACTIONS(3647),
    [anon_sym_PLUS_PLUS] = ACTIONS(3647),
    [anon_sym_sizeof] = ACTIONS(3645),
    [anon_sym___alignof__] = ACTIONS(3645),
    [anon_sym___alignof] = ACTIONS(3645),
    [anon_sym__alignof] = ACTIONS(3645),
    [anon_sym_alignof] = ACTIONS(3645),
    [anon_sym__Alignof] = ACTIONS(3645),
    [anon_sym_offsetof] = ACTIONS(3645),
    [anon_sym__Generic] = ACTIONS(3645),
    [anon_sym_asm] = ACTIONS(3645),
    [anon_sym___asm__] = ACTIONS(3645),
    [sym_number_literal] = ACTIONS(3647),
    [anon_sym_L_SQUOTE] = ACTIONS(3647),
    [anon_sym_u_SQUOTE] = ACTIONS(3647),
    [anon_sym_U_SQUOTE] = ACTIONS(3647),
    [anon_sym_u8_SQUOTE] = ACTIONS(3647),
    [anon_sym_SQUOTE] = ACTIONS(3647),
    [anon_sym_L_DQUOTE] = ACTIONS(3647),
    [anon_sym_u_DQUOTE] = ACTIONS(3647),
    [anon_sym_U_DQUOTE] = ACTIONS(3647),
    [anon_sym_u8_DQUOTE] = ACTIONS(3647),
    [anon_sym_DQUOTE] = ACTIONS(3647),
    [sym_true] = ACTIONS(3645),
    [sym_false] = ACTIONS(3645),
    [anon_sym_NULL] = ACTIONS(3645),
    [anon_sym_nullptr] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3645),
    [anon_sym_let] = ACTIONS(3645),
    [anon_sym_This] = ACTIONS(3645),
    [anon_sym_decltype] = ACTIONS(3645),
    [sym_virtual] = ACTIONS(3645),
    [anon_sym_explicit] = ACTIONS(3645),
    [anon_sym_typename] = ACTIONS(3645),
    [anon_sym_template] = ACTIONS(3645),
    [anon_sym_operator] = ACTIONS(3645),
    [anon_sym_try] = ACTIONS(3645),
    [anon_sym_delete] = ACTIONS(3645),
    [anon_sym_throw] = ACTIONS(3645),
    [anon_sym_namespace] = ACTIONS(3645),
    [anon_sym_using] = ACTIONS(3645),
    [anon_sym_static_assert] = ACTIONS(3645),
    [anon_sym_concept] = ACTIONS(3645),
    [anon_sym_co_return] = ACTIONS(3645),
    [anon_sym_co_yield] = ACTIONS(3645),
    [anon_sym_R_DQUOTE] = ACTIONS(3647),
    [anon_sym_LR_DQUOTE] = ACTIONS(3647),
    [anon_sym_uR_DQUOTE] = ACTIONS(3647),
    [anon_sym_UR_DQUOTE] = ACTIONS(3647),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3647),
    [anon_sym_co_await] = ACTIONS(3645),
    [anon_sym_new] = ACTIONS(3645),
    [anon_sym_requires] = ACTIONS(3645),
    [sym_this] = ACTIONS(3645),
    [anon_sym_discard] = ACTIONS(3645),
    [anon_sym_precise] = ACTIONS(3645),
    [anon_sym_shared] = ACTIONS(3645),
    [anon_sym_groupshared] = ACTIONS(3645),
    [anon_sym_uniform] = ACTIONS(3645),
    [anon_sym_row_major] = ACTIONS(3645),
    [anon_sym_column_major] = ACTIONS(3645),
    [anon_sym_globallycoherent] = ACTIONS(3645),
    [anon_sym_centroid] = ACTIONS(3645),
    [anon_sym_noperspective] = ACTIONS(3645),
    [anon_sym_nointerpolation] = ACTIONS(3645),
    [anon_sym_sample] = ACTIONS(3645),
    [anon_sym_linear] = ACTIONS(3645),
    [anon_sym_snorm] = ACTIONS(3645),
    [anon_sym_unorm] = ACTIONS(3645),
    [anon_sym_point] = ACTIONS(3645),
    [anon_sym_line] = ACTIONS(3645),
    [anon_sym_triangleadj] = ACTIONS(3645),
    [anon_sym_lineadj] = ACTIONS(3645),
    [anon_sym_triangle] = ACTIONS(3645),
    [anon_sym_cbuffer] = ACTIONS(3645),
    [anon_sym_interface] = ACTIONS(3645),
    [anon_sym_extension] = ACTIONS(3645),
  },
  [826] = {
    [sym_identifier] = ACTIONS(3703),
    [aux_sym_preproc_include_token1] = ACTIONS(3703),
    [aux_sym_preproc_def_token1] = ACTIONS(3703),
    [aux_sym_preproc_if_token1] = ACTIONS(3703),
    [aux_sym_preproc_if_token2] = ACTIONS(3703),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3703),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3703),
    [sym_preproc_directive] = ACTIONS(3703),
    [anon_sym_LPAREN2] = ACTIONS(3705),
    [anon_sym_BANG] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3705),
    [anon_sym_DASH] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3703),
    [anon_sym_STAR] = ACTIONS(3705),
    [anon_sym_AMP_AMP] = ACTIONS(3705),
    [anon_sym_AMP] = ACTIONS(3703),
    [anon_sym_SEMI] = ACTIONS(3705),
    [anon_sym___extension__] = ACTIONS(3703),
    [anon_sym_typedef] = ACTIONS(3703),
    [anon_sym_in] = ACTIONS(3703),
    [anon_sym_out] = ACTIONS(3703),
    [anon_sym_inout] = ACTIONS(3703),
    [anon_sym_extern] = ACTIONS(3703),
    [anon_sym___attribute__] = ACTIONS(3703),
    [anon_sym_COLON_COLON] = ACTIONS(3705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3705),
    [anon_sym___declspec] = ACTIONS(3703),
    [anon_sym___based] = ACTIONS(3703),
    [anon_sym___cdecl] = ACTIONS(3703),
    [anon_sym___clrcall] = ACTIONS(3703),
    [anon_sym___stdcall] = ACTIONS(3703),
    [anon_sym___fastcall] = ACTIONS(3703),
    [anon_sym___thiscall] = ACTIONS(3703),
    [anon_sym___vectorcall] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [anon_sym_signed] = ACTIONS(3703),
    [anon_sym_unsigned] = ACTIONS(3703),
    [anon_sym_long] = ACTIONS(3703),
    [anon_sym_short] = ACTIONS(3703),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_static] = ACTIONS(3703),
    [anon_sym_register] = ACTIONS(3703),
    [anon_sym_inline] = ACTIONS(3703),
    [anon_sym___inline] = ACTIONS(3703),
    [anon_sym___inline__] = ACTIONS(3703),
    [anon_sym___forceinline] = ACTIONS(3703),
    [anon_sym_thread_local] = ACTIONS(3703),
    [anon_sym___thread] = ACTIONS(3703),
    [anon_sym_const] = ACTIONS(3703),
    [anon_sym_constexpr] = ACTIONS(3703),
    [anon_sym_volatile] = ACTIONS(3703),
    [anon_sym_restrict] = ACTIONS(3703),
    [anon_sym___restrict__] = ACTIONS(3703),
    [anon_sym__Atomic] = ACTIONS(3703),
    [anon_sym__Noreturn] = ACTIONS(3703),
    [anon_sym_noreturn] = ACTIONS(3703),
    [anon_sym_mutable] = ACTIONS(3703),
    [anon_sym_constinit] = ACTIONS(3703),
    [anon_sym_consteval] = ACTIONS(3703),
    [anon_sym_alignas] = ACTIONS(3703),
    [anon_sym__Alignas] = ACTIONS(3703),
    [sym_primitive_type] = ACTIONS(3703),
    [anon_sym_enum] = ACTIONS(3703),
    [anon_sym_class] = ACTIONS(3703),
    [anon_sym_struct] = ACTIONS(3703),
    [anon_sym_union] = ACTIONS(3703),
    [anon_sym_if] = ACTIONS(3703),
    [anon_sym_switch] = ACTIONS(3703),
    [anon_sym_case] = ACTIONS(3703),
    [anon_sym_default] = ACTIONS(3703),
    [anon_sym_while] = ACTIONS(3703),
    [anon_sym_do] = ACTIONS(3703),
    [anon_sym_for] = ACTIONS(3703),
    [anon_sym_return] = ACTIONS(3703),
    [anon_sym_break] = ACTIONS(3703),
    [anon_sym_continue] = ACTIONS(3703),
    [anon_sym_goto] = ACTIONS(3703),
    [anon_sym___try] = ACTIONS(3703),
    [anon_sym___leave] = ACTIONS(3703),
    [anon_sym_not] = ACTIONS(3703),
    [anon_sym_compl] = ACTIONS(3703),
    [anon_sym_DASH_DASH] = ACTIONS(3705),
    [anon_sym_PLUS_PLUS] = ACTIONS(3705),
    [anon_sym_sizeof] = ACTIONS(3703),
    [anon_sym___alignof__] = ACTIONS(3703),
    [anon_sym___alignof] = ACTIONS(3703),
    [anon_sym__alignof] = ACTIONS(3703),
    [anon_sym_alignof] = ACTIONS(3703),
    [anon_sym__Alignof] = ACTIONS(3703),
    [anon_sym_offsetof] = ACTIONS(3703),
    [anon_sym__Generic] = ACTIONS(3703),
    [anon_sym_asm] = ACTIONS(3703),
    [anon_sym___asm__] = ACTIONS(3703),
    [sym_number_literal] = ACTIONS(3705),
    [anon_sym_L_SQUOTE] = ACTIONS(3705),
    [anon_sym_u_SQUOTE] = ACTIONS(3705),
    [anon_sym_U_SQUOTE] = ACTIONS(3705),
    [anon_sym_u8_SQUOTE] = ACTIONS(3705),
    [anon_sym_SQUOTE] = ACTIONS(3705),
    [anon_sym_L_DQUOTE] = ACTIONS(3705),
    [anon_sym_u_DQUOTE] = ACTIONS(3705),
    [anon_sym_U_DQUOTE] = ACTIONS(3705),
    [anon_sym_u8_DQUOTE] = ACTIONS(3705),
    [anon_sym_DQUOTE] = ACTIONS(3705),
    [sym_true] = ACTIONS(3703),
    [sym_false] = ACTIONS(3703),
    [anon_sym_NULL] = ACTIONS(3703),
    [anon_sym_nullptr] = ACTIONS(3703),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3703),
    [anon_sym_let] = ACTIONS(3703),
    [anon_sym_This] = ACTIONS(3703),
    [anon_sym_decltype] = ACTIONS(3703),
    [sym_virtual] = ACTIONS(3703),
    [anon_sym_explicit] = ACTIONS(3703),
    [anon_sym_typename] = ACTIONS(3703),
    [anon_sym_template] = ACTIONS(3703),
    [anon_sym_operator] = ACTIONS(3703),
    [anon_sym_try] = ACTIONS(3703),
    [anon_sym_delete] = ACTIONS(3703),
    [anon_sym_throw] = ACTIONS(3703),
    [anon_sym_namespace] = ACTIONS(3703),
    [anon_sym_using] = ACTIONS(3703),
    [anon_sym_static_assert] = ACTIONS(3703),
    [anon_sym_concept] = ACTIONS(3703),
    [anon_sym_co_return] = ACTIONS(3703),
    [anon_sym_co_yield] = ACTIONS(3703),
    [anon_sym_R_DQUOTE] = ACTIONS(3705),
    [anon_sym_LR_DQUOTE] = ACTIONS(3705),
    [anon_sym_uR_DQUOTE] = ACTIONS(3705),
    [anon_sym_UR_DQUOTE] = ACTIONS(3705),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3705),
    [anon_sym_co_await] = ACTIONS(3703),
    [anon_sym_new] = ACTIONS(3703),
    [anon_sym_requires] = ACTIONS(3703),
    [sym_this] = ACTIONS(3703),
    [anon_sym_discard] = ACTIONS(3703),
    [anon_sym_precise] = ACTIONS(3703),
    [anon_sym_shared] = ACTIONS(3703),
    [anon_sym_groupshared] = ACTIONS(3703),
    [anon_sym_uniform] = ACTIONS(3703),
    [anon_sym_row_major] = ACTIONS(3703),
    [anon_sym_column_major] = ACTIONS(3703),
    [anon_sym_globallycoherent] = ACTIONS(3703),
    [anon_sym_centroid] = ACTIONS(3703),
    [anon_sym_noperspective] = ACTIONS(3703),
    [anon_sym_nointerpolation] = ACTIONS(3703),
    [anon_sym_sample] = ACTIONS(3703),
    [anon_sym_linear] = ACTIONS(3703),
    [anon_sym_snorm] = ACTIONS(3703),
    [anon_sym_unorm] = ACTIONS(3703),
    [anon_sym_point] = ACTIONS(3703),
    [anon_sym_line] = ACTIONS(3703),
    [anon_sym_triangleadj] = ACTIONS(3703),
    [anon_sym_lineadj] = ACTIONS(3703),
    [anon_sym_triangle] = ACTIONS(3703),
    [anon_sym_cbuffer] = ACTIONS(3703),
    [anon_sym_interface] = ACTIONS(3703),
    [anon_sym_extension] = ACTIONS(3703),
  },
  [827] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(285),
    [ts_builtin_sym_end] = ACTIONS(3812),
    [sym_identifier] = ACTIONS(3810),
    [aux_sym_preproc_include_token1] = ACTIONS(3810),
    [aux_sym_preproc_def_token1] = ACTIONS(3810),
    [aux_sym_preproc_if_token1] = ACTIONS(3810),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3810),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3810),
    [sym_preproc_directive] = ACTIONS(3810),
    [anon_sym_LPAREN2] = ACTIONS(3812),
    [anon_sym_BANG] = ACTIONS(3812),
    [anon_sym_TILDE] = ACTIONS(3812),
    [anon_sym_DASH] = ACTIONS(3810),
    [anon_sym_PLUS] = ACTIONS(3810),
    [anon_sym_STAR] = ACTIONS(3812),
    [anon_sym_AMP_AMP] = ACTIONS(3812),
    [anon_sym_AMP] = ACTIONS(3810),
    [anon_sym_SEMI] = ACTIONS(3812),
    [anon_sym___extension__] = ACTIONS(3810),
    [anon_sym_typedef] = ACTIONS(3810),
    [anon_sym_in] = ACTIONS(3810),
    [anon_sym_out] = ACTIONS(3810),
    [anon_sym_inout] = ACTIONS(3810),
    [anon_sym_extern] = ACTIONS(3810),
    [anon_sym___attribute__] = ACTIONS(3810),
    [anon_sym_COLON_COLON] = ACTIONS(3812),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3812),
    [anon_sym___declspec] = ACTIONS(3810),
    [anon_sym___based] = ACTIONS(3810),
    [anon_sym___cdecl] = ACTIONS(3810),
    [anon_sym___clrcall] = ACTIONS(3810),
    [anon_sym___stdcall] = ACTIONS(3810),
    [anon_sym___fastcall] = ACTIONS(3810),
    [anon_sym___thiscall] = ACTIONS(3810),
    [anon_sym___vectorcall] = ACTIONS(3810),
    [anon_sym_LBRACE] = ACTIONS(3812),
    [anon_sym_signed] = ACTIONS(3914),
    [anon_sym_unsigned] = ACTIONS(3914),
    [anon_sym_long] = ACTIONS(3914),
    [anon_sym_short] = ACTIONS(3914),
    [anon_sym_LBRACK] = ACTIONS(3810),
    [anon_sym_static] = ACTIONS(3810),
    [anon_sym_register] = ACTIONS(3810),
    [anon_sym_inline] = ACTIONS(3810),
    [anon_sym___inline] = ACTIONS(3810),
    [anon_sym___inline__] = ACTIONS(3810),
    [anon_sym___forceinline] = ACTIONS(3810),
    [anon_sym_thread_local] = ACTIONS(3810),
    [anon_sym___thread] = ACTIONS(3810),
    [anon_sym_const] = ACTIONS(3810),
    [anon_sym_constexpr] = ACTIONS(3810),
    [anon_sym_volatile] = ACTIONS(3810),
    [anon_sym_restrict] = ACTIONS(3810),
    [anon_sym___restrict__] = ACTIONS(3810),
    [anon_sym__Atomic] = ACTIONS(3810),
    [anon_sym__Noreturn] = ACTIONS(3810),
    [anon_sym_noreturn] = ACTIONS(3810),
    [anon_sym_mutable] = ACTIONS(3810),
    [anon_sym_constinit] = ACTIONS(3810),
    [anon_sym_consteval] = ACTIONS(3810),
    [anon_sym_alignas] = ACTIONS(3810),
    [anon_sym__Alignas] = ACTIONS(3810),
    [sym_primitive_type] = ACTIONS(3810),
    [anon_sym_enum] = ACTIONS(3810),
    [anon_sym_class] = ACTIONS(3810),
    [anon_sym_struct] = ACTIONS(3810),
    [anon_sym_union] = ACTIONS(3810),
    [anon_sym_if] = ACTIONS(3810),
    [anon_sym_switch] = ACTIONS(3810),
    [anon_sym_case] = ACTIONS(3810),
    [anon_sym_default] = ACTIONS(3810),
    [anon_sym_while] = ACTIONS(3810),
    [anon_sym_do] = ACTIONS(3810),
    [anon_sym_for] = ACTIONS(3810),
    [anon_sym_return] = ACTIONS(3810),
    [anon_sym_break] = ACTIONS(3810),
    [anon_sym_continue] = ACTIONS(3810),
    [anon_sym_goto] = ACTIONS(3810),
    [anon_sym_not] = ACTIONS(3810),
    [anon_sym_compl] = ACTIONS(3810),
    [anon_sym_DASH_DASH] = ACTIONS(3812),
    [anon_sym_PLUS_PLUS] = ACTIONS(3812),
    [anon_sym_sizeof] = ACTIONS(3810),
    [anon_sym___alignof__] = ACTIONS(3810),
    [anon_sym___alignof] = ACTIONS(3810),
    [anon_sym__alignof] = ACTIONS(3810),
    [anon_sym_alignof] = ACTIONS(3810),
    [anon_sym__Alignof] = ACTIONS(3810),
    [anon_sym_offsetof] = ACTIONS(3810),
    [anon_sym__Generic] = ACTIONS(3810),
    [anon_sym_asm] = ACTIONS(3810),
    [anon_sym___asm__] = ACTIONS(3810),
    [anon_sym_DOT] = ACTIONS(3810),
    [sym_number_literal] = ACTIONS(3812),
    [anon_sym_L_SQUOTE] = ACTIONS(3812),
    [anon_sym_u_SQUOTE] = ACTIONS(3812),
    [anon_sym_U_SQUOTE] = ACTIONS(3812),
    [anon_sym_u8_SQUOTE] = ACTIONS(3812),
    [anon_sym_SQUOTE] = ACTIONS(3812),
    [anon_sym_L_DQUOTE] = ACTIONS(3812),
    [anon_sym_u_DQUOTE] = ACTIONS(3812),
    [anon_sym_U_DQUOTE] = ACTIONS(3812),
    [anon_sym_u8_DQUOTE] = ACTIONS(3812),
    [anon_sym_DQUOTE] = ACTIONS(3812),
    [sym_true] = ACTIONS(3810),
    [sym_false] = ACTIONS(3810),
    [anon_sym_NULL] = ACTIONS(3810),
    [anon_sym_nullptr] = ACTIONS(3810),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3810),
    [anon_sym_let] = ACTIONS(3810),
    [anon_sym_This] = ACTIONS(3810),
    [anon_sym_decltype] = ACTIONS(3810),
    [sym_virtual] = ACTIONS(3810),
    [anon_sym_explicit] = ACTIONS(3810),
    [anon_sym_typename] = ACTIONS(3810),
    [anon_sym_template] = ACTIONS(3810),
    [anon_sym_operator] = ACTIONS(3810),
    [anon_sym_try] = ACTIONS(3810),
    [anon_sym_delete] = ACTIONS(3810),
    [anon_sym_throw] = ACTIONS(3810),
    [anon_sym_namespace] = ACTIONS(3810),
    [anon_sym_using] = ACTIONS(3810),
    [anon_sym_static_assert] = ACTIONS(3810),
    [anon_sym_concept] = ACTIONS(3810),
    [anon_sym_co_return] = ACTIONS(3810),
    [anon_sym_co_yield] = ACTIONS(3810),
    [anon_sym_R_DQUOTE] = ACTIONS(3812),
    [anon_sym_LR_DQUOTE] = ACTIONS(3812),
    [anon_sym_uR_DQUOTE] = ACTIONS(3812),
    [anon_sym_UR_DQUOTE] = ACTIONS(3812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3812),
    [anon_sym_co_await] = ACTIONS(3810),
    [anon_sym_new] = ACTIONS(3810),
    [anon_sym_requires] = ACTIONS(3810),
    [sym_this] = ACTIONS(3810),
    [anon_sym_precise] = ACTIONS(3810),
    [anon_sym_shared] = ACTIONS(3810),
    [anon_sym_groupshared] = ACTIONS(3810),
    [anon_sym_uniform] = ACTIONS(3810),
    [anon_sym_row_major] = ACTIONS(3810),
    [anon_sym_column_major] = ACTIONS(3810),
    [anon_sym_globallycoherent] = ACTIONS(3810),
    [anon_sym_centroid] = ACTIONS(3810),
    [anon_sym_noperspective] = ACTIONS(3810),
    [anon_sym_nointerpolation] = ACTIONS(3810),
    [anon_sym_sample] = ACTIONS(3810),
    [anon_sym_linear] = ACTIONS(3810),
    [anon_sym_snorm] = ACTIONS(3810),
    [anon_sym_unorm] = ACTIONS(3810),
    [anon_sym_point] = ACTIONS(3810),
    [anon_sym_line] = ACTIONS(3810),
    [anon_sym_triangleadj] = ACTIONS(3810),
    [anon_sym_lineadj] = ACTIONS(3810),
    [anon_sym_triangle] = ACTIONS(3810),
    [anon_sym_interface] = ACTIONS(3810),
    [anon_sym_extension] = ACTIONS(3810),
    [anon_sym___exported] = ACTIONS(3810),
    [anon_sym_import] = ACTIONS(3810),
  },
  [828] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(285),
    [ts_builtin_sym_end] = ACTIONS(3805),
    [sym_identifier] = ACTIONS(3803),
    [aux_sym_preproc_include_token1] = ACTIONS(3803),
    [aux_sym_preproc_def_token1] = ACTIONS(3803),
    [aux_sym_preproc_if_token1] = ACTIONS(3803),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3803),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3803),
    [sym_preproc_directive] = ACTIONS(3803),
    [anon_sym_LPAREN2] = ACTIONS(3805),
    [anon_sym_BANG] = ACTIONS(3805),
    [anon_sym_TILDE] = ACTIONS(3805),
    [anon_sym_DASH] = ACTIONS(3803),
    [anon_sym_PLUS] = ACTIONS(3803),
    [anon_sym_STAR] = ACTIONS(3805),
    [anon_sym_AMP_AMP] = ACTIONS(3805),
    [anon_sym_AMP] = ACTIONS(3803),
    [anon_sym_SEMI] = ACTIONS(3805),
    [anon_sym___extension__] = ACTIONS(3803),
    [anon_sym_typedef] = ACTIONS(3803),
    [anon_sym_in] = ACTIONS(3803),
    [anon_sym_out] = ACTIONS(3803),
    [anon_sym_inout] = ACTIONS(3803),
    [anon_sym_extern] = ACTIONS(3803),
    [anon_sym___attribute__] = ACTIONS(3803),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3805),
    [anon_sym___declspec] = ACTIONS(3803),
    [anon_sym___based] = ACTIONS(3803),
    [anon_sym___cdecl] = ACTIONS(3803),
    [anon_sym___clrcall] = ACTIONS(3803),
    [anon_sym___stdcall] = ACTIONS(3803),
    [anon_sym___fastcall] = ACTIONS(3803),
    [anon_sym___thiscall] = ACTIONS(3803),
    [anon_sym___vectorcall] = ACTIONS(3803),
    [anon_sym_LBRACE] = ACTIONS(3805),
    [anon_sym_signed] = ACTIONS(3917),
    [anon_sym_unsigned] = ACTIONS(3917),
    [anon_sym_long] = ACTIONS(3917),
    [anon_sym_short] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(3803),
    [anon_sym_static] = ACTIONS(3803),
    [anon_sym_register] = ACTIONS(3803),
    [anon_sym_inline] = ACTIONS(3803),
    [anon_sym___inline] = ACTIONS(3803),
    [anon_sym___inline__] = ACTIONS(3803),
    [anon_sym___forceinline] = ACTIONS(3803),
    [anon_sym_thread_local] = ACTIONS(3803),
    [anon_sym___thread] = ACTIONS(3803),
    [anon_sym_const] = ACTIONS(3803),
    [anon_sym_constexpr] = ACTIONS(3803),
    [anon_sym_volatile] = ACTIONS(3803),
    [anon_sym_restrict] = ACTIONS(3803),
    [anon_sym___restrict__] = ACTIONS(3803),
    [anon_sym__Atomic] = ACTIONS(3803),
    [anon_sym__Noreturn] = ACTIONS(3803),
    [anon_sym_noreturn] = ACTIONS(3803),
    [anon_sym_mutable] = ACTIONS(3803),
    [anon_sym_constinit] = ACTIONS(3803),
    [anon_sym_consteval] = ACTIONS(3803),
    [anon_sym_alignas] = ACTIONS(3803),
    [anon_sym__Alignas] = ACTIONS(3803),
    [sym_primitive_type] = ACTIONS(3803),
    [anon_sym_enum] = ACTIONS(3803),
    [anon_sym_class] = ACTIONS(3803),
    [anon_sym_struct] = ACTIONS(3803),
    [anon_sym_union] = ACTIONS(3803),
    [anon_sym_if] = ACTIONS(3803),
    [anon_sym_switch] = ACTIONS(3803),
    [anon_sym_case] = ACTIONS(3803),
    [anon_sym_default] = ACTIONS(3803),
    [anon_sym_while] = ACTIONS(3803),
    [anon_sym_do] = ACTIONS(3803),
    [anon_sym_for] = ACTIONS(3803),
    [anon_sym_return] = ACTIONS(3803),
    [anon_sym_break] = ACTIONS(3803),
    [anon_sym_continue] = ACTIONS(3803),
    [anon_sym_goto] = ACTIONS(3803),
    [anon_sym_not] = ACTIONS(3803),
    [anon_sym_compl] = ACTIONS(3803),
    [anon_sym_DASH_DASH] = ACTIONS(3805),
    [anon_sym_PLUS_PLUS] = ACTIONS(3805),
    [anon_sym_sizeof] = ACTIONS(3803),
    [anon_sym___alignof__] = ACTIONS(3803),
    [anon_sym___alignof] = ACTIONS(3803),
    [anon_sym__alignof] = ACTIONS(3803),
    [anon_sym_alignof] = ACTIONS(3803),
    [anon_sym__Alignof] = ACTIONS(3803),
    [anon_sym_offsetof] = ACTIONS(3803),
    [anon_sym__Generic] = ACTIONS(3803),
    [anon_sym_asm] = ACTIONS(3803),
    [anon_sym___asm__] = ACTIONS(3803),
    [anon_sym_DOT] = ACTIONS(3803),
    [sym_number_literal] = ACTIONS(3805),
    [anon_sym_L_SQUOTE] = ACTIONS(3805),
    [anon_sym_u_SQUOTE] = ACTIONS(3805),
    [anon_sym_U_SQUOTE] = ACTIONS(3805),
    [anon_sym_u8_SQUOTE] = ACTIONS(3805),
    [anon_sym_SQUOTE] = ACTIONS(3805),
    [anon_sym_L_DQUOTE] = ACTIONS(3805),
    [anon_sym_u_DQUOTE] = ACTIONS(3805),
    [anon_sym_U_DQUOTE] = ACTIONS(3805),
    [anon_sym_u8_DQUOTE] = ACTIONS(3805),
    [anon_sym_DQUOTE] = ACTIONS(3805),
    [sym_true] = ACTIONS(3803),
    [sym_false] = ACTIONS(3803),
    [anon_sym_NULL] = ACTIONS(3803),
    [anon_sym_nullptr] = ACTIONS(3803),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3803),
    [anon_sym_let] = ACTIONS(3803),
    [anon_sym_This] = ACTIONS(3803),
    [anon_sym_decltype] = ACTIONS(3803),
    [sym_virtual] = ACTIONS(3803),
    [anon_sym_explicit] = ACTIONS(3803),
    [anon_sym_typename] = ACTIONS(3803),
    [anon_sym_template] = ACTIONS(3803),
    [anon_sym_operator] = ACTIONS(3803),
    [anon_sym_try] = ACTIONS(3803),
    [anon_sym_delete] = ACTIONS(3803),
    [anon_sym_throw] = ACTIONS(3803),
    [anon_sym_namespace] = ACTIONS(3803),
    [anon_sym_using] = ACTIONS(3803),
    [anon_sym_static_assert] = ACTIONS(3803),
    [anon_sym_concept] = ACTIONS(3803),
    [anon_sym_co_return] = ACTIONS(3803),
    [anon_sym_co_yield] = ACTIONS(3803),
    [anon_sym_R_DQUOTE] = ACTIONS(3805),
    [anon_sym_LR_DQUOTE] = ACTIONS(3805),
    [anon_sym_uR_DQUOTE] = ACTIONS(3805),
    [anon_sym_UR_DQUOTE] = ACTIONS(3805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3805),
    [anon_sym_co_await] = ACTIONS(3803),
    [anon_sym_new] = ACTIONS(3803),
    [anon_sym_requires] = ACTIONS(3803),
    [sym_this] = ACTIONS(3803),
    [anon_sym_precise] = ACTIONS(3803),
    [anon_sym_shared] = ACTIONS(3803),
    [anon_sym_groupshared] = ACTIONS(3803),
    [anon_sym_uniform] = ACTIONS(3803),
    [anon_sym_row_major] = ACTIONS(3803),
    [anon_sym_column_major] = ACTIONS(3803),
    [anon_sym_globallycoherent] = ACTIONS(3803),
    [anon_sym_centroid] = ACTIONS(3803),
    [anon_sym_noperspective] = ACTIONS(3803),
    [anon_sym_nointerpolation] = ACTIONS(3803),
    [anon_sym_sample] = ACTIONS(3803),
    [anon_sym_linear] = ACTIONS(3803),
    [anon_sym_snorm] = ACTIONS(3803),
    [anon_sym_unorm] = ACTIONS(3803),
    [anon_sym_point] = ACTIONS(3803),
    [anon_sym_line] = ACTIONS(3803),
    [anon_sym_triangleadj] = ACTIONS(3803),
    [anon_sym_lineadj] = ACTIONS(3803),
    [anon_sym_triangle] = ACTIONS(3803),
    [anon_sym_interface] = ACTIONS(3803),
    [anon_sym_extension] = ACTIONS(3803),
    [anon_sym___exported] = ACTIONS(3803),
    [anon_sym_import] = ACTIONS(3803),
  },
  [829] = {
    [sym_identifier] = ACTIONS(3637),
    [aux_sym_preproc_include_token1] = ACTIONS(3637),
    [aux_sym_preproc_def_token1] = ACTIONS(3637),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_if_token2] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3637),
    [sym_preproc_directive] = ACTIONS(3637),
    [anon_sym_LPAREN2] = ACTIONS(3639),
    [anon_sym_BANG] = ACTIONS(3639),
    [anon_sym_TILDE] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3637),
    [anon_sym_STAR] = ACTIONS(3639),
    [anon_sym_AMP_AMP] = ACTIONS(3639),
    [anon_sym_AMP] = ACTIONS(3637),
    [anon_sym_SEMI] = ACTIONS(3639),
    [anon_sym___extension__] = ACTIONS(3637),
    [anon_sym_typedef] = ACTIONS(3637),
    [anon_sym_in] = ACTIONS(3637),
    [anon_sym_out] = ACTIONS(3637),
    [anon_sym_inout] = ACTIONS(3637),
    [anon_sym_extern] = ACTIONS(3637),
    [anon_sym___attribute__] = ACTIONS(3637),
    [anon_sym_COLON_COLON] = ACTIONS(3639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3639),
    [anon_sym___declspec] = ACTIONS(3637),
    [anon_sym___based] = ACTIONS(3637),
    [anon_sym___cdecl] = ACTIONS(3637),
    [anon_sym___clrcall] = ACTIONS(3637),
    [anon_sym___stdcall] = ACTIONS(3637),
    [anon_sym___fastcall] = ACTIONS(3637),
    [anon_sym___thiscall] = ACTIONS(3637),
    [anon_sym___vectorcall] = ACTIONS(3637),
    [anon_sym_LBRACE] = ACTIONS(3639),
    [anon_sym_signed] = ACTIONS(3637),
    [anon_sym_unsigned] = ACTIONS(3637),
    [anon_sym_long] = ACTIONS(3637),
    [anon_sym_short] = ACTIONS(3637),
    [anon_sym_LBRACK] = ACTIONS(3637),
    [anon_sym_static] = ACTIONS(3637),
    [anon_sym_register] = ACTIONS(3637),
    [anon_sym_inline] = ACTIONS(3637),
    [anon_sym___inline] = ACTIONS(3637),
    [anon_sym___inline__] = ACTIONS(3637),
    [anon_sym___forceinline] = ACTIONS(3637),
    [anon_sym_thread_local] = ACTIONS(3637),
    [anon_sym___thread] = ACTIONS(3637),
    [anon_sym_const] = ACTIONS(3637),
    [anon_sym_constexpr] = ACTIONS(3637),
    [anon_sym_volatile] = ACTIONS(3637),
    [anon_sym_restrict] = ACTIONS(3637),
    [anon_sym___restrict__] = ACTIONS(3637),
    [anon_sym__Atomic] = ACTIONS(3637),
    [anon_sym__Noreturn] = ACTIONS(3637),
    [anon_sym_noreturn] = ACTIONS(3637),
    [anon_sym_mutable] = ACTIONS(3637),
    [anon_sym_constinit] = ACTIONS(3637),
    [anon_sym_consteval] = ACTIONS(3637),
    [anon_sym_alignas] = ACTIONS(3637),
    [anon_sym__Alignas] = ACTIONS(3637),
    [sym_primitive_type] = ACTIONS(3637),
    [anon_sym_enum] = ACTIONS(3637),
    [anon_sym_class] = ACTIONS(3637),
    [anon_sym_struct] = ACTIONS(3637),
    [anon_sym_union] = ACTIONS(3637),
    [anon_sym_if] = ACTIONS(3637),
    [anon_sym_switch] = ACTIONS(3637),
    [anon_sym_case] = ACTIONS(3637),
    [anon_sym_default] = ACTIONS(3637),
    [anon_sym_while] = ACTIONS(3637),
    [anon_sym_do] = ACTIONS(3637),
    [anon_sym_for] = ACTIONS(3637),
    [anon_sym_return] = ACTIONS(3637),
    [anon_sym_break] = ACTIONS(3637),
    [anon_sym_continue] = ACTIONS(3637),
    [anon_sym_goto] = ACTIONS(3637),
    [anon_sym___try] = ACTIONS(3637),
    [anon_sym___leave] = ACTIONS(3637),
    [anon_sym_not] = ACTIONS(3637),
    [anon_sym_compl] = ACTIONS(3637),
    [anon_sym_DASH_DASH] = ACTIONS(3639),
    [anon_sym_PLUS_PLUS] = ACTIONS(3639),
    [anon_sym_sizeof] = ACTIONS(3637),
    [anon_sym___alignof__] = ACTIONS(3637),
    [anon_sym___alignof] = ACTIONS(3637),
    [anon_sym__alignof] = ACTIONS(3637),
    [anon_sym_alignof] = ACTIONS(3637),
    [anon_sym__Alignof] = ACTIONS(3637),
    [anon_sym_offsetof] = ACTIONS(3637),
    [anon_sym__Generic] = ACTIONS(3637),
    [anon_sym_asm] = ACTIONS(3637),
    [anon_sym___asm__] = ACTIONS(3637),
    [sym_number_literal] = ACTIONS(3639),
    [anon_sym_L_SQUOTE] = ACTIONS(3639),
    [anon_sym_u_SQUOTE] = ACTIONS(3639),
    [anon_sym_U_SQUOTE] = ACTIONS(3639),
    [anon_sym_u8_SQUOTE] = ACTIONS(3639),
    [anon_sym_SQUOTE] = ACTIONS(3639),
    [anon_sym_L_DQUOTE] = ACTIONS(3639),
    [anon_sym_u_DQUOTE] = ACTIONS(3639),
    [anon_sym_U_DQUOTE] = ACTIONS(3639),
    [anon_sym_u8_DQUOTE] = ACTIONS(3639),
    [anon_sym_DQUOTE] = ACTIONS(3639),
    [sym_true] = ACTIONS(3637),
    [sym_false] = ACTIONS(3637),
    [anon_sym_NULL] = ACTIONS(3637),
    [anon_sym_nullptr] = ACTIONS(3637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3637),
    [anon_sym_let] = ACTIONS(3637),
    [anon_sym_This] = ACTIONS(3637),
    [anon_sym_decltype] = ACTIONS(3637),
    [sym_virtual] = ACTIONS(3637),
    [anon_sym_explicit] = ACTIONS(3637),
    [anon_sym_typename] = ACTIONS(3637),
    [anon_sym_template] = ACTIONS(3637),
    [anon_sym_operator] = ACTIONS(3637),
    [anon_sym_try] = ACTIONS(3637),
    [anon_sym_delete] = ACTIONS(3637),
    [anon_sym_throw] = ACTIONS(3637),
    [anon_sym_namespace] = ACTIONS(3637),
    [anon_sym_using] = ACTIONS(3637),
    [anon_sym_static_assert] = ACTIONS(3637),
    [anon_sym_concept] = ACTIONS(3637),
    [anon_sym_co_return] = ACTIONS(3637),
    [anon_sym_co_yield] = ACTIONS(3637),
    [anon_sym_R_DQUOTE] = ACTIONS(3639),
    [anon_sym_LR_DQUOTE] = ACTIONS(3639),
    [anon_sym_uR_DQUOTE] = ACTIONS(3639),
    [anon_sym_UR_DQUOTE] = ACTIONS(3639),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3639),
    [anon_sym_co_await] = ACTIONS(3637),
    [anon_sym_new] = ACTIONS(3637),
    [anon_sym_requires] = ACTIONS(3637),
    [sym_this] = ACTIONS(3637),
    [anon_sym_discard] = ACTIONS(3637),
    [anon_sym_precise] = ACTIONS(3637),
    [anon_sym_shared] = ACTIONS(3637),
    [anon_sym_groupshared] = ACTIONS(3637),
    [anon_sym_uniform] = ACTIONS(3637),
    [anon_sym_row_major] = ACTIONS(3637),
    [anon_sym_column_major] = ACTIONS(3637),
    [anon_sym_globallycoherent] = ACTIONS(3637),
    [anon_sym_centroid] = ACTIONS(3637),
    [anon_sym_noperspective] = ACTIONS(3637),
    [anon_sym_nointerpolation] = ACTIONS(3637),
    [anon_sym_sample] = ACTIONS(3637),
    [anon_sym_linear] = ACTIONS(3637),
    [anon_sym_snorm] = ACTIONS(3637),
    [anon_sym_unorm] = ACTIONS(3637),
    [anon_sym_point] = ACTIONS(3637),
    [anon_sym_line] = ACTIONS(3637),
    [anon_sym_triangleadj] = ACTIONS(3637),
    [anon_sym_lineadj] = ACTIONS(3637),
    [anon_sym_triangle] = ACTIONS(3637),
    [anon_sym_cbuffer] = ACTIONS(3637),
    [anon_sym_interface] = ACTIONS(3637),
    [anon_sym_extension] = ACTIONS(3637),
  },
  [830] = {
    [sym_identifier] = ACTIONS(3637),
    [aux_sym_preproc_include_token1] = ACTIONS(3637),
    [aux_sym_preproc_def_token1] = ACTIONS(3637),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3637),
    [sym_preproc_directive] = ACTIONS(3637),
    [anon_sym_LPAREN2] = ACTIONS(3639),
    [anon_sym_BANG] = ACTIONS(3639),
    [anon_sym_TILDE] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3637),
    [anon_sym_STAR] = ACTIONS(3639),
    [anon_sym_AMP_AMP] = ACTIONS(3639),
    [anon_sym_AMP] = ACTIONS(3637),
    [anon_sym_SEMI] = ACTIONS(3639),
    [anon_sym___extension__] = ACTIONS(3637),
    [anon_sym_typedef] = ACTIONS(3637),
    [anon_sym_in] = ACTIONS(3637),
    [anon_sym_out] = ACTIONS(3637),
    [anon_sym_inout] = ACTIONS(3637),
    [anon_sym_extern] = ACTIONS(3637),
    [anon_sym___attribute__] = ACTIONS(3637),
    [anon_sym_COLON_COLON] = ACTIONS(3639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3639),
    [anon_sym___declspec] = ACTIONS(3637),
    [anon_sym___based] = ACTIONS(3637),
    [anon_sym___cdecl] = ACTIONS(3637),
    [anon_sym___clrcall] = ACTIONS(3637),
    [anon_sym___stdcall] = ACTIONS(3637),
    [anon_sym___fastcall] = ACTIONS(3637),
    [anon_sym___thiscall] = ACTIONS(3637),
    [anon_sym___vectorcall] = ACTIONS(3637),
    [anon_sym_LBRACE] = ACTIONS(3639),
    [anon_sym_RBRACE] = ACTIONS(3639),
    [anon_sym_signed] = ACTIONS(3637),
    [anon_sym_unsigned] = ACTIONS(3637),
    [anon_sym_long] = ACTIONS(3637),
    [anon_sym_short] = ACTIONS(3637),
    [anon_sym_LBRACK] = ACTIONS(3637),
    [anon_sym_static] = ACTIONS(3637),
    [anon_sym_register] = ACTIONS(3637),
    [anon_sym_inline] = ACTIONS(3637),
    [anon_sym___inline] = ACTIONS(3637),
    [anon_sym___inline__] = ACTIONS(3637),
    [anon_sym___forceinline] = ACTIONS(3637),
    [anon_sym_thread_local] = ACTIONS(3637),
    [anon_sym___thread] = ACTIONS(3637),
    [anon_sym_const] = ACTIONS(3637),
    [anon_sym_constexpr] = ACTIONS(3637),
    [anon_sym_volatile] = ACTIONS(3637),
    [anon_sym_restrict] = ACTIONS(3637),
    [anon_sym___restrict__] = ACTIONS(3637),
    [anon_sym__Atomic] = ACTIONS(3637),
    [anon_sym__Noreturn] = ACTIONS(3637),
    [anon_sym_noreturn] = ACTIONS(3637),
    [anon_sym_mutable] = ACTIONS(3637),
    [anon_sym_constinit] = ACTIONS(3637),
    [anon_sym_consteval] = ACTIONS(3637),
    [anon_sym_alignas] = ACTIONS(3637),
    [anon_sym__Alignas] = ACTIONS(3637),
    [sym_primitive_type] = ACTIONS(3637),
    [anon_sym_enum] = ACTIONS(3637),
    [anon_sym_class] = ACTIONS(3637),
    [anon_sym_struct] = ACTIONS(3637),
    [anon_sym_union] = ACTIONS(3637),
    [anon_sym_if] = ACTIONS(3637),
    [anon_sym_switch] = ACTIONS(3637),
    [anon_sym_case] = ACTIONS(3637),
    [anon_sym_default] = ACTIONS(3637),
    [anon_sym_while] = ACTIONS(3637),
    [anon_sym_do] = ACTIONS(3637),
    [anon_sym_for] = ACTIONS(3637),
    [anon_sym_return] = ACTIONS(3637),
    [anon_sym_break] = ACTIONS(3637),
    [anon_sym_continue] = ACTIONS(3637),
    [anon_sym_goto] = ACTIONS(3637),
    [anon_sym___try] = ACTIONS(3637),
    [anon_sym___leave] = ACTIONS(3637),
    [anon_sym_not] = ACTIONS(3637),
    [anon_sym_compl] = ACTIONS(3637),
    [anon_sym_DASH_DASH] = ACTIONS(3639),
    [anon_sym_PLUS_PLUS] = ACTIONS(3639),
    [anon_sym_sizeof] = ACTIONS(3637),
    [anon_sym___alignof__] = ACTIONS(3637),
    [anon_sym___alignof] = ACTIONS(3637),
    [anon_sym__alignof] = ACTIONS(3637),
    [anon_sym_alignof] = ACTIONS(3637),
    [anon_sym__Alignof] = ACTIONS(3637),
    [anon_sym_offsetof] = ACTIONS(3637),
    [anon_sym__Generic] = ACTIONS(3637),
    [anon_sym_asm] = ACTIONS(3637),
    [anon_sym___asm__] = ACTIONS(3637),
    [sym_number_literal] = ACTIONS(3639),
    [anon_sym_L_SQUOTE] = ACTIONS(3639),
    [anon_sym_u_SQUOTE] = ACTIONS(3639),
    [anon_sym_U_SQUOTE] = ACTIONS(3639),
    [anon_sym_u8_SQUOTE] = ACTIONS(3639),
    [anon_sym_SQUOTE] = ACTIONS(3639),
    [anon_sym_L_DQUOTE] = ACTIONS(3639),
    [anon_sym_u_DQUOTE] = ACTIONS(3639),
    [anon_sym_U_DQUOTE] = ACTIONS(3639),
    [anon_sym_u8_DQUOTE] = ACTIONS(3639),
    [anon_sym_DQUOTE] = ACTIONS(3639),
    [sym_true] = ACTIONS(3637),
    [sym_false] = ACTIONS(3637),
    [anon_sym_NULL] = ACTIONS(3637),
    [anon_sym_nullptr] = ACTIONS(3637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3637),
    [anon_sym_let] = ACTIONS(3637),
    [anon_sym_This] = ACTIONS(3637),
    [anon_sym_decltype] = ACTIONS(3637),
    [sym_virtual] = ACTIONS(3637),
    [anon_sym_explicit] = ACTIONS(3637),
    [anon_sym_typename] = ACTIONS(3637),
    [anon_sym_template] = ACTIONS(3637),
    [anon_sym_operator] = ACTIONS(3637),
    [anon_sym_try] = ACTIONS(3637),
    [anon_sym_delete] = ACTIONS(3637),
    [anon_sym_throw] = ACTIONS(3637),
    [anon_sym_namespace] = ACTIONS(3637),
    [anon_sym_using] = ACTIONS(3637),
    [anon_sym_static_assert] = ACTIONS(3637),
    [anon_sym_concept] = ACTIONS(3637),
    [anon_sym_co_return] = ACTIONS(3637),
    [anon_sym_co_yield] = ACTIONS(3637),
    [anon_sym_R_DQUOTE] = ACTIONS(3639),
    [anon_sym_LR_DQUOTE] = ACTIONS(3639),
    [anon_sym_uR_DQUOTE] = ACTIONS(3639),
    [anon_sym_UR_DQUOTE] = ACTIONS(3639),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3639),
    [anon_sym_co_await] = ACTIONS(3637),
    [anon_sym_new] = ACTIONS(3637),
    [anon_sym_requires] = ACTIONS(3637),
    [sym_this] = ACTIONS(3637),
    [anon_sym_discard] = ACTIONS(3637),
    [anon_sym_precise] = ACTIONS(3637),
    [anon_sym_shared] = ACTIONS(3637),
    [anon_sym_groupshared] = ACTIONS(3637),
    [anon_sym_uniform] = ACTIONS(3637),
    [anon_sym_row_major] = ACTIONS(3637),
    [anon_sym_column_major] = ACTIONS(3637),
    [anon_sym_globallycoherent] = ACTIONS(3637),
    [anon_sym_centroid] = ACTIONS(3637),
    [anon_sym_noperspective] = ACTIONS(3637),
    [anon_sym_nointerpolation] = ACTIONS(3637),
    [anon_sym_sample] = ACTIONS(3637),
    [anon_sym_linear] = ACTIONS(3637),
    [anon_sym_snorm] = ACTIONS(3637),
    [anon_sym_unorm] = ACTIONS(3637),
    [anon_sym_point] = ACTIONS(3637),
    [anon_sym_line] = ACTIONS(3637),
    [anon_sym_triangleadj] = ACTIONS(3637),
    [anon_sym_lineadj] = ACTIONS(3637),
    [anon_sym_triangle] = ACTIONS(3637),
    [anon_sym_cbuffer] = ACTIONS(3637),
    [anon_sym_interface] = ACTIONS(3637),
    [anon_sym_extension] = ACTIONS(3637),
  },
  [831] = {
    [sym_identifier] = ACTIONS(3406),
    [aux_sym_preproc_include_token1] = ACTIONS(3406),
    [aux_sym_preproc_def_token1] = ACTIONS(3406),
    [aux_sym_preproc_if_token1] = ACTIONS(3406),
    [aux_sym_preproc_if_token2] = ACTIONS(3406),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3406),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3406),
    [sym_preproc_directive] = ACTIONS(3406),
    [anon_sym_LPAREN2] = ACTIONS(3408),
    [anon_sym_BANG] = ACTIONS(3408),
    [anon_sym_TILDE] = ACTIONS(3408),
    [anon_sym_DASH] = ACTIONS(3406),
    [anon_sym_PLUS] = ACTIONS(3406),
    [anon_sym_STAR] = ACTIONS(3408),
    [anon_sym_AMP_AMP] = ACTIONS(3408),
    [anon_sym_AMP] = ACTIONS(3406),
    [anon_sym_SEMI] = ACTIONS(3408),
    [anon_sym___extension__] = ACTIONS(3406),
    [anon_sym_typedef] = ACTIONS(3406),
    [anon_sym_in] = ACTIONS(3406),
    [anon_sym_out] = ACTIONS(3406),
    [anon_sym_inout] = ACTIONS(3406),
    [anon_sym_extern] = ACTIONS(3406),
    [anon_sym___attribute__] = ACTIONS(3406),
    [anon_sym_COLON_COLON] = ACTIONS(3408),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3408),
    [anon_sym___declspec] = ACTIONS(3406),
    [anon_sym___based] = ACTIONS(3406),
    [anon_sym___cdecl] = ACTIONS(3406),
    [anon_sym___clrcall] = ACTIONS(3406),
    [anon_sym___stdcall] = ACTIONS(3406),
    [anon_sym___fastcall] = ACTIONS(3406),
    [anon_sym___thiscall] = ACTIONS(3406),
    [anon_sym___vectorcall] = ACTIONS(3406),
    [anon_sym_LBRACE] = ACTIONS(3408),
    [anon_sym_signed] = ACTIONS(3406),
    [anon_sym_unsigned] = ACTIONS(3406),
    [anon_sym_long] = ACTIONS(3406),
    [anon_sym_short] = ACTIONS(3406),
    [anon_sym_LBRACK] = ACTIONS(3406),
    [anon_sym_static] = ACTIONS(3406),
    [anon_sym_register] = ACTIONS(3406),
    [anon_sym_inline] = ACTIONS(3406),
    [anon_sym___inline] = ACTIONS(3406),
    [anon_sym___inline__] = ACTIONS(3406),
    [anon_sym___forceinline] = ACTIONS(3406),
    [anon_sym_thread_local] = ACTIONS(3406),
    [anon_sym___thread] = ACTIONS(3406),
    [anon_sym_const] = ACTIONS(3406),
    [anon_sym_constexpr] = ACTIONS(3406),
    [anon_sym_volatile] = ACTIONS(3406),
    [anon_sym_restrict] = ACTIONS(3406),
    [anon_sym___restrict__] = ACTIONS(3406),
    [anon_sym__Atomic] = ACTIONS(3406),
    [anon_sym__Noreturn] = ACTIONS(3406),
    [anon_sym_noreturn] = ACTIONS(3406),
    [anon_sym_mutable] = ACTIONS(3406),
    [anon_sym_constinit] = ACTIONS(3406),
    [anon_sym_consteval] = ACTIONS(3406),
    [anon_sym_alignas] = ACTIONS(3406),
    [anon_sym__Alignas] = ACTIONS(3406),
    [sym_primitive_type] = ACTIONS(3406),
    [anon_sym_enum] = ACTIONS(3406),
    [anon_sym_class] = ACTIONS(3406),
    [anon_sym_struct] = ACTIONS(3406),
    [anon_sym_union] = ACTIONS(3406),
    [anon_sym_if] = ACTIONS(3406),
    [anon_sym_switch] = ACTIONS(3406),
    [anon_sym_case] = ACTIONS(3406),
    [anon_sym_default] = ACTIONS(3406),
    [anon_sym_while] = ACTIONS(3406),
    [anon_sym_do] = ACTIONS(3406),
    [anon_sym_for] = ACTIONS(3406),
    [anon_sym_return] = ACTIONS(3406),
    [anon_sym_break] = ACTIONS(3406),
    [anon_sym_continue] = ACTIONS(3406),
    [anon_sym_goto] = ACTIONS(3406),
    [anon_sym___try] = ACTIONS(3406),
    [anon_sym___leave] = ACTIONS(3406),
    [anon_sym_not] = ACTIONS(3406),
    [anon_sym_compl] = ACTIONS(3406),
    [anon_sym_DASH_DASH] = ACTIONS(3408),
    [anon_sym_PLUS_PLUS] = ACTIONS(3408),
    [anon_sym_sizeof] = ACTIONS(3406),
    [anon_sym___alignof__] = ACTIONS(3406),
    [anon_sym___alignof] = ACTIONS(3406),
    [anon_sym__alignof] = ACTIONS(3406),
    [anon_sym_alignof] = ACTIONS(3406),
    [anon_sym__Alignof] = ACTIONS(3406),
    [anon_sym_offsetof] = ACTIONS(3406),
    [anon_sym__Generic] = ACTIONS(3406),
    [anon_sym_asm] = ACTIONS(3406),
    [anon_sym___asm__] = ACTIONS(3406),
    [sym_number_literal] = ACTIONS(3408),
    [anon_sym_L_SQUOTE] = ACTIONS(3408),
    [anon_sym_u_SQUOTE] = ACTIONS(3408),
    [anon_sym_U_SQUOTE] = ACTIONS(3408),
    [anon_sym_u8_SQUOTE] = ACTIONS(3408),
    [anon_sym_SQUOTE] = ACTIONS(3408),
    [anon_sym_L_DQUOTE] = ACTIONS(3408),
    [anon_sym_u_DQUOTE] = ACTIONS(3408),
    [anon_sym_U_DQUOTE] = ACTIONS(3408),
    [anon_sym_u8_DQUOTE] = ACTIONS(3408),
    [anon_sym_DQUOTE] = ACTIONS(3408),
    [sym_true] = ACTIONS(3406),
    [sym_false] = ACTIONS(3406),
    [anon_sym_NULL] = ACTIONS(3406),
    [anon_sym_nullptr] = ACTIONS(3406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3406),
    [anon_sym_let] = ACTIONS(3406),
    [anon_sym_This] = ACTIONS(3406),
    [anon_sym_decltype] = ACTIONS(3406),
    [sym_virtual] = ACTIONS(3406),
    [anon_sym_explicit] = ACTIONS(3406),
    [anon_sym_typename] = ACTIONS(3406),
    [anon_sym_template] = ACTIONS(3406),
    [anon_sym_operator] = ACTIONS(3406),
    [anon_sym_try] = ACTIONS(3406),
    [anon_sym_delete] = ACTIONS(3406),
    [anon_sym_throw] = ACTIONS(3406),
    [anon_sym_namespace] = ACTIONS(3406),
    [anon_sym_using] = ACTIONS(3406),
    [anon_sym_static_assert] = ACTIONS(3406),
    [anon_sym_concept] = ACTIONS(3406),
    [anon_sym_co_return] = ACTIONS(3406),
    [anon_sym_co_yield] = ACTIONS(3406),
    [anon_sym_R_DQUOTE] = ACTIONS(3408),
    [anon_sym_LR_DQUOTE] = ACTIONS(3408),
    [anon_sym_uR_DQUOTE] = ACTIONS(3408),
    [anon_sym_UR_DQUOTE] = ACTIONS(3408),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3408),
    [anon_sym_co_await] = ACTIONS(3406),
    [anon_sym_new] = ACTIONS(3406),
    [anon_sym_requires] = ACTIONS(3406),
    [sym_this] = ACTIONS(3406),
    [anon_sym_discard] = ACTIONS(3406),
    [anon_sym_precise] = ACTIONS(3406),
    [anon_sym_shared] = ACTIONS(3406),
    [anon_sym_groupshared] = ACTIONS(3406),
    [anon_sym_uniform] = ACTIONS(3406),
    [anon_sym_row_major] = ACTIONS(3406),
    [anon_sym_column_major] = ACTIONS(3406),
    [anon_sym_globallycoherent] = ACTIONS(3406),
    [anon_sym_centroid] = ACTIONS(3406),
    [anon_sym_noperspective] = ACTIONS(3406),
    [anon_sym_nointerpolation] = ACTIONS(3406),
    [anon_sym_sample] = ACTIONS(3406),
    [anon_sym_linear] = ACTIONS(3406),
    [anon_sym_snorm] = ACTIONS(3406),
    [anon_sym_unorm] = ACTIONS(3406),
    [anon_sym_point] = ACTIONS(3406),
    [anon_sym_line] = ACTIONS(3406),
    [anon_sym_triangleadj] = ACTIONS(3406),
    [anon_sym_lineadj] = ACTIONS(3406),
    [anon_sym_triangle] = ACTIONS(3406),
    [anon_sym_cbuffer] = ACTIONS(3406),
    [anon_sym_interface] = ACTIONS(3406),
    [anon_sym_extension] = ACTIONS(3406),
  },
  [832] = {
    [sym_identifier] = ACTIONS(3535),
    [aux_sym_preproc_include_token1] = ACTIONS(3535),
    [aux_sym_preproc_def_token1] = ACTIONS(3535),
    [aux_sym_preproc_if_token1] = ACTIONS(3535),
    [aux_sym_preproc_if_token2] = ACTIONS(3535),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3535),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3535),
    [sym_preproc_directive] = ACTIONS(3535),
    [anon_sym_LPAREN2] = ACTIONS(3537),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3537),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym___extension__] = ACTIONS(3535),
    [anon_sym_typedef] = ACTIONS(3535),
    [anon_sym_in] = ACTIONS(3535),
    [anon_sym_out] = ACTIONS(3535),
    [anon_sym_inout] = ACTIONS(3535),
    [anon_sym_extern] = ACTIONS(3535),
    [anon_sym___attribute__] = ACTIONS(3535),
    [anon_sym_COLON_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3537),
    [anon_sym___declspec] = ACTIONS(3535),
    [anon_sym___based] = ACTIONS(3535),
    [anon_sym___cdecl] = ACTIONS(3535),
    [anon_sym___clrcall] = ACTIONS(3535),
    [anon_sym___stdcall] = ACTIONS(3535),
    [anon_sym___fastcall] = ACTIONS(3535),
    [anon_sym___thiscall] = ACTIONS(3535),
    [anon_sym___vectorcall] = ACTIONS(3535),
    [anon_sym_LBRACE] = ACTIONS(3537),
    [anon_sym_signed] = ACTIONS(3535),
    [anon_sym_unsigned] = ACTIONS(3535),
    [anon_sym_long] = ACTIONS(3535),
    [anon_sym_short] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_static] = ACTIONS(3535),
    [anon_sym_register] = ACTIONS(3535),
    [anon_sym_inline] = ACTIONS(3535),
    [anon_sym___inline] = ACTIONS(3535),
    [anon_sym___inline__] = ACTIONS(3535),
    [anon_sym___forceinline] = ACTIONS(3535),
    [anon_sym_thread_local] = ACTIONS(3535),
    [anon_sym___thread] = ACTIONS(3535),
    [anon_sym_const] = ACTIONS(3535),
    [anon_sym_constexpr] = ACTIONS(3535),
    [anon_sym_volatile] = ACTIONS(3535),
    [anon_sym_restrict] = ACTIONS(3535),
    [anon_sym___restrict__] = ACTIONS(3535),
    [anon_sym__Atomic] = ACTIONS(3535),
    [anon_sym__Noreturn] = ACTIONS(3535),
    [anon_sym_noreturn] = ACTIONS(3535),
    [anon_sym_mutable] = ACTIONS(3535),
    [anon_sym_constinit] = ACTIONS(3535),
    [anon_sym_consteval] = ACTIONS(3535),
    [anon_sym_alignas] = ACTIONS(3535),
    [anon_sym__Alignas] = ACTIONS(3535),
    [sym_primitive_type] = ACTIONS(3535),
    [anon_sym_enum] = ACTIONS(3535),
    [anon_sym_class] = ACTIONS(3535),
    [anon_sym_struct] = ACTIONS(3535),
    [anon_sym_union] = ACTIONS(3535),
    [anon_sym_if] = ACTIONS(3535),
    [anon_sym_switch] = ACTIONS(3535),
    [anon_sym_case] = ACTIONS(3535),
    [anon_sym_default] = ACTIONS(3535),
    [anon_sym_while] = ACTIONS(3535),
    [anon_sym_do] = ACTIONS(3535),
    [anon_sym_for] = ACTIONS(3535),
    [anon_sym_return] = ACTIONS(3535),
    [anon_sym_break] = ACTIONS(3535),
    [anon_sym_continue] = ACTIONS(3535),
    [anon_sym_goto] = ACTIONS(3535),
    [anon_sym___try] = ACTIONS(3535),
    [anon_sym___leave] = ACTIONS(3535),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_compl] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(3537),
    [anon_sym_PLUS_PLUS] = ACTIONS(3537),
    [anon_sym_sizeof] = ACTIONS(3535),
    [anon_sym___alignof__] = ACTIONS(3535),
    [anon_sym___alignof] = ACTIONS(3535),
    [anon_sym__alignof] = ACTIONS(3535),
    [anon_sym_alignof] = ACTIONS(3535),
    [anon_sym__Alignof] = ACTIONS(3535),
    [anon_sym_offsetof] = ACTIONS(3535),
    [anon_sym__Generic] = ACTIONS(3535),
    [anon_sym_asm] = ACTIONS(3535),
    [anon_sym___asm__] = ACTIONS(3535),
    [sym_number_literal] = ACTIONS(3537),
    [anon_sym_L_SQUOTE] = ACTIONS(3537),
    [anon_sym_u_SQUOTE] = ACTIONS(3537),
    [anon_sym_U_SQUOTE] = ACTIONS(3537),
    [anon_sym_u8_SQUOTE] = ACTIONS(3537),
    [anon_sym_SQUOTE] = ACTIONS(3537),
    [anon_sym_L_DQUOTE] = ACTIONS(3537),
    [anon_sym_u_DQUOTE] = ACTIONS(3537),
    [anon_sym_U_DQUOTE] = ACTIONS(3537),
    [anon_sym_u8_DQUOTE] = ACTIONS(3537),
    [anon_sym_DQUOTE] = ACTIONS(3537),
    [sym_true] = ACTIONS(3535),
    [sym_false] = ACTIONS(3535),
    [anon_sym_NULL] = ACTIONS(3535),
    [anon_sym_nullptr] = ACTIONS(3535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3535),
    [anon_sym_let] = ACTIONS(3535),
    [anon_sym_This] = ACTIONS(3535),
    [anon_sym_decltype] = ACTIONS(3535),
    [sym_virtual] = ACTIONS(3535),
    [anon_sym_explicit] = ACTIONS(3535),
    [anon_sym_typename] = ACTIONS(3535),
    [anon_sym_template] = ACTIONS(3535),
    [anon_sym_operator] = ACTIONS(3535),
    [anon_sym_try] = ACTIONS(3535),
    [anon_sym_delete] = ACTIONS(3535),
    [anon_sym_throw] = ACTIONS(3535),
    [anon_sym_namespace] = ACTIONS(3535),
    [anon_sym_using] = ACTIONS(3535),
    [anon_sym_static_assert] = ACTIONS(3535),
    [anon_sym_concept] = ACTIONS(3535),
    [anon_sym_co_return] = ACTIONS(3535),
    [anon_sym_co_yield] = ACTIONS(3535),
    [anon_sym_R_DQUOTE] = ACTIONS(3537),
    [anon_sym_LR_DQUOTE] = ACTIONS(3537),
    [anon_sym_uR_DQUOTE] = ACTIONS(3537),
    [anon_sym_UR_DQUOTE] = ACTIONS(3537),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3537),
    [anon_sym_co_await] = ACTIONS(3535),
    [anon_sym_new] = ACTIONS(3535),
    [anon_sym_requires] = ACTIONS(3535),
    [sym_this] = ACTIONS(3535),
    [anon_sym_discard] = ACTIONS(3535),
    [anon_sym_precise] = ACTIONS(3535),
    [anon_sym_shared] = ACTIONS(3535),
    [anon_sym_groupshared] = ACTIONS(3535),
    [anon_sym_uniform] = ACTIONS(3535),
    [anon_sym_row_major] = ACTIONS(3535),
    [anon_sym_column_major] = ACTIONS(3535),
    [anon_sym_globallycoherent] = ACTIONS(3535),
    [anon_sym_centroid] = ACTIONS(3535),
    [anon_sym_noperspective] = ACTIONS(3535),
    [anon_sym_nointerpolation] = ACTIONS(3535),
    [anon_sym_sample] = ACTIONS(3535),
    [anon_sym_linear] = ACTIONS(3535),
    [anon_sym_snorm] = ACTIONS(3535),
    [anon_sym_unorm] = ACTIONS(3535),
    [anon_sym_point] = ACTIONS(3535),
    [anon_sym_line] = ACTIONS(3535),
    [anon_sym_triangleadj] = ACTIONS(3535),
    [anon_sym_lineadj] = ACTIONS(3535),
    [anon_sym_triangle] = ACTIONS(3535),
    [anon_sym_cbuffer] = ACTIONS(3535),
    [anon_sym_interface] = ACTIONS(3535),
    [anon_sym_extension] = ACTIONS(3535),
  },
  [833] = {
    [sym_identifier] = ACTIONS(3665),
    [aux_sym_preproc_include_token1] = ACTIONS(3665),
    [aux_sym_preproc_def_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3665),
    [sym_preproc_directive] = ACTIONS(3665),
    [anon_sym_LPAREN2] = ACTIONS(3667),
    [anon_sym_BANG] = ACTIONS(3667),
    [anon_sym_TILDE] = ACTIONS(3667),
    [anon_sym_DASH] = ACTIONS(3665),
    [anon_sym_PLUS] = ACTIONS(3665),
    [anon_sym_STAR] = ACTIONS(3667),
    [anon_sym_AMP_AMP] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym_SEMI] = ACTIONS(3667),
    [anon_sym___extension__] = ACTIONS(3665),
    [anon_sym_typedef] = ACTIONS(3665),
    [anon_sym_in] = ACTIONS(3665),
    [anon_sym_out] = ACTIONS(3665),
    [anon_sym_inout] = ACTIONS(3665),
    [anon_sym_extern] = ACTIONS(3665),
    [anon_sym___attribute__] = ACTIONS(3665),
    [anon_sym_COLON_COLON] = ACTIONS(3667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3667),
    [anon_sym___declspec] = ACTIONS(3665),
    [anon_sym___based] = ACTIONS(3665),
    [anon_sym___cdecl] = ACTIONS(3665),
    [anon_sym___clrcall] = ACTIONS(3665),
    [anon_sym___stdcall] = ACTIONS(3665),
    [anon_sym___fastcall] = ACTIONS(3665),
    [anon_sym___thiscall] = ACTIONS(3665),
    [anon_sym___vectorcall] = ACTIONS(3665),
    [anon_sym_LBRACE] = ACTIONS(3667),
    [anon_sym_RBRACE] = ACTIONS(3667),
    [anon_sym_signed] = ACTIONS(3665),
    [anon_sym_unsigned] = ACTIONS(3665),
    [anon_sym_long] = ACTIONS(3665),
    [anon_sym_short] = ACTIONS(3665),
    [anon_sym_LBRACK] = ACTIONS(3665),
    [anon_sym_static] = ACTIONS(3665),
    [anon_sym_register] = ACTIONS(3665),
    [anon_sym_inline] = ACTIONS(3665),
    [anon_sym___inline] = ACTIONS(3665),
    [anon_sym___inline__] = ACTIONS(3665),
    [anon_sym___forceinline] = ACTIONS(3665),
    [anon_sym_thread_local] = ACTIONS(3665),
    [anon_sym___thread] = ACTIONS(3665),
    [anon_sym_const] = ACTIONS(3665),
    [anon_sym_constexpr] = ACTIONS(3665),
    [anon_sym_volatile] = ACTIONS(3665),
    [anon_sym_restrict] = ACTIONS(3665),
    [anon_sym___restrict__] = ACTIONS(3665),
    [anon_sym__Atomic] = ACTIONS(3665),
    [anon_sym__Noreturn] = ACTIONS(3665),
    [anon_sym_noreturn] = ACTIONS(3665),
    [anon_sym_mutable] = ACTIONS(3665),
    [anon_sym_constinit] = ACTIONS(3665),
    [anon_sym_consteval] = ACTIONS(3665),
    [anon_sym_alignas] = ACTIONS(3665),
    [anon_sym__Alignas] = ACTIONS(3665),
    [sym_primitive_type] = ACTIONS(3665),
    [anon_sym_enum] = ACTIONS(3665),
    [anon_sym_class] = ACTIONS(3665),
    [anon_sym_struct] = ACTIONS(3665),
    [anon_sym_union] = ACTIONS(3665),
    [anon_sym_if] = ACTIONS(3665),
    [anon_sym_switch] = ACTIONS(3665),
    [anon_sym_case] = ACTIONS(3665),
    [anon_sym_default] = ACTIONS(3665),
    [anon_sym_while] = ACTIONS(3665),
    [anon_sym_do] = ACTIONS(3665),
    [anon_sym_for] = ACTIONS(3665),
    [anon_sym_return] = ACTIONS(3665),
    [anon_sym_break] = ACTIONS(3665),
    [anon_sym_continue] = ACTIONS(3665),
    [anon_sym_goto] = ACTIONS(3665),
    [anon_sym___try] = ACTIONS(3665),
    [anon_sym___leave] = ACTIONS(3665),
    [anon_sym_not] = ACTIONS(3665),
    [anon_sym_compl] = ACTIONS(3665),
    [anon_sym_DASH_DASH] = ACTIONS(3667),
    [anon_sym_PLUS_PLUS] = ACTIONS(3667),
    [anon_sym_sizeof] = ACTIONS(3665),
    [anon_sym___alignof__] = ACTIONS(3665),
    [anon_sym___alignof] = ACTIONS(3665),
    [anon_sym__alignof] = ACTIONS(3665),
    [anon_sym_alignof] = ACTIONS(3665),
    [anon_sym__Alignof] = ACTIONS(3665),
    [anon_sym_offsetof] = ACTIONS(3665),
    [anon_sym__Generic] = ACTIONS(3665),
    [anon_sym_asm] = ACTIONS(3665),
    [anon_sym___asm__] = ACTIONS(3665),
    [sym_number_literal] = ACTIONS(3667),
    [anon_sym_L_SQUOTE] = ACTIONS(3667),
    [anon_sym_u_SQUOTE] = ACTIONS(3667),
    [anon_sym_U_SQUOTE] = ACTIONS(3667),
    [anon_sym_u8_SQUOTE] = ACTIONS(3667),
    [anon_sym_SQUOTE] = ACTIONS(3667),
    [anon_sym_L_DQUOTE] = ACTIONS(3667),
    [anon_sym_u_DQUOTE] = ACTIONS(3667),
    [anon_sym_U_DQUOTE] = ACTIONS(3667),
    [anon_sym_u8_DQUOTE] = ACTIONS(3667),
    [anon_sym_DQUOTE] = ACTIONS(3667),
    [sym_true] = ACTIONS(3665),
    [sym_false] = ACTIONS(3665),
    [anon_sym_NULL] = ACTIONS(3665),
    [anon_sym_nullptr] = ACTIONS(3665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3665),
    [anon_sym_let] = ACTIONS(3665),
    [anon_sym_This] = ACTIONS(3665),
    [anon_sym_decltype] = ACTIONS(3665),
    [sym_virtual] = ACTIONS(3665),
    [anon_sym_explicit] = ACTIONS(3665),
    [anon_sym_typename] = ACTIONS(3665),
    [anon_sym_template] = ACTIONS(3665),
    [anon_sym_operator] = ACTIONS(3665),
    [anon_sym_try] = ACTIONS(3665),
    [anon_sym_delete] = ACTIONS(3665),
    [anon_sym_throw] = ACTIONS(3665),
    [anon_sym_namespace] = ACTIONS(3665),
    [anon_sym_using] = ACTIONS(3665),
    [anon_sym_static_assert] = ACTIONS(3665),
    [anon_sym_concept] = ACTIONS(3665),
    [anon_sym_co_return] = ACTIONS(3665),
    [anon_sym_co_yield] = ACTIONS(3665),
    [anon_sym_R_DQUOTE] = ACTIONS(3667),
    [anon_sym_LR_DQUOTE] = ACTIONS(3667),
    [anon_sym_uR_DQUOTE] = ACTIONS(3667),
    [anon_sym_UR_DQUOTE] = ACTIONS(3667),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3667),
    [anon_sym_co_await] = ACTIONS(3665),
    [anon_sym_new] = ACTIONS(3665),
    [anon_sym_requires] = ACTIONS(3665),
    [sym_this] = ACTIONS(3665),
    [anon_sym_discard] = ACTIONS(3665),
    [anon_sym_precise] = ACTIONS(3665),
    [anon_sym_shared] = ACTIONS(3665),
    [anon_sym_groupshared] = ACTIONS(3665),
    [anon_sym_uniform] = ACTIONS(3665),
    [anon_sym_row_major] = ACTIONS(3665),
    [anon_sym_column_major] = ACTIONS(3665),
    [anon_sym_globallycoherent] = ACTIONS(3665),
    [anon_sym_centroid] = ACTIONS(3665),
    [anon_sym_noperspective] = ACTIONS(3665),
    [anon_sym_nointerpolation] = ACTIONS(3665),
    [anon_sym_sample] = ACTIONS(3665),
    [anon_sym_linear] = ACTIONS(3665),
    [anon_sym_snorm] = ACTIONS(3665),
    [anon_sym_unorm] = ACTIONS(3665),
    [anon_sym_point] = ACTIONS(3665),
    [anon_sym_line] = ACTIONS(3665),
    [anon_sym_triangleadj] = ACTIONS(3665),
    [anon_sym_lineadj] = ACTIONS(3665),
    [anon_sym_triangle] = ACTIONS(3665),
    [anon_sym_cbuffer] = ACTIONS(3665),
    [anon_sym_interface] = ACTIONS(3665),
    [anon_sym_extension] = ACTIONS(3665),
  },
  [834] = {
    [sym_identifier] = ACTIONS(3591),
    [aux_sym_preproc_include_token1] = ACTIONS(3591),
    [aux_sym_preproc_def_token1] = ACTIONS(3591),
    [aux_sym_preproc_if_token1] = ACTIONS(3591),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3591),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3591),
    [sym_preproc_directive] = ACTIONS(3591),
    [anon_sym_LPAREN2] = ACTIONS(3594),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [anon_sym_DASH] = ACTIONS(3591),
    [anon_sym_PLUS] = ACTIONS(3591),
    [anon_sym_STAR] = ACTIONS(3594),
    [anon_sym_AMP_AMP] = ACTIONS(3594),
    [anon_sym_AMP] = ACTIONS(3591),
    [anon_sym_SEMI] = ACTIONS(3594),
    [anon_sym___extension__] = ACTIONS(3591),
    [anon_sym_typedef] = ACTIONS(3591),
    [anon_sym_in] = ACTIONS(3591),
    [anon_sym_out] = ACTIONS(3591),
    [anon_sym_inout] = ACTIONS(3591),
    [anon_sym_extern] = ACTIONS(3591),
    [anon_sym___attribute__] = ACTIONS(3591),
    [anon_sym_COLON_COLON] = ACTIONS(3594),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3594),
    [anon_sym___declspec] = ACTIONS(3591),
    [anon_sym___based] = ACTIONS(3591),
    [anon_sym___cdecl] = ACTIONS(3591),
    [anon_sym___clrcall] = ACTIONS(3591),
    [anon_sym___stdcall] = ACTIONS(3591),
    [anon_sym___fastcall] = ACTIONS(3591),
    [anon_sym___thiscall] = ACTIONS(3591),
    [anon_sym___vectorcall] = ACTIONS(3591),
    [anon_sym_LBRACE] = ACTIONS(3594),
    [anon_sym_RBRACE] = ACTIONS(3594),
    [anon_sym_signed] = ACTIONS(3591),
    [anon_sym_unsigned] = ACTIONS(3591),
    [anon_sym_long] = ACTIONS(3591),
    [anon_sym_short] = ACTIONS(3591),
    [anon_sym_LBRACK] = ACTIONS(3591),
    [anon_sym_static] = ACTIONS(3591),
    [anon_sym_register] = ACTIONS(3591),
    [anon_sym_inline] = ACTIONS(3591),
    [anon_sym___inline] = ACTIONS(3591),
    [anon_sym___inline__] = ACTIONS(3591),
    [anon_sym___forceinline] = ACTIONS(3591),
    [anon_sym_thread_local] = ACTIONS(3591),
    [anon_sym___thread] = ACTIONS(3591),
    [anon_sym_const] = ACTIONS(3591),
    [anon_sym_constexpr] = ACTIONS(3591),
    [anon_sym_volatile] = ACTIONS(3591),
    [anon_sym_restrict] = ACTIONS(3591),
    [anon_sym___restrict__] = ACTIONS(3591),
    [anon_sym__Atomic] = ACTIONS(3591),
    [anon_sym__Noreturn] = ACTIONS(3591),
    [anon_sym_noreturn] = ACTIONS(3591),
    [anon_sym_mutable] = ACTIONS(3591),
    [anon_sym_constinit] = ACTIONS(3591),
    [anon_sym_consteval] = ACTIONS(3591),
    [anon_sym_alignas] = ACTIONS(3591),
    [anon_sym__Alignas] = ACTIONS(3591),
    [sym_primitive_type] = ACTIONS(3591),
    [anon_sym_enum] = ACTIONS(3591),
    [anon_sym_class] = ACTIONS(3591),
    [anon_sym_struct] = ACTIONS(3591),
    [anon_sym_union] = ACTIONS(3591),
    [anon_sym_if] = ACTIONS(3591),
    [anon_sym_switch] = ACTIONS(3591),
    [anon_sym_case] = ACTIONS(3591),
    [anon_sym_default] = ACTIONS(3591),
    [anon_sym_while] = ACTIONS(3591),
    [anon_sym_do] = ACTIONS(3591),
    [anon_sym_for] = ACTIONS(3591),
    [anon_sym_return] = ACTIONS(3591),
    [anon_sym_break] = ACTIONS(3591),
    [anon_sym_continue] = ACTIONS(3591),
    [anon_sym_goto] = ACTIONS(3591),
    [anon_sym___try] = ACTIONS(3591),
    [anon_sym___leave] = ACTIONS(3591),
    [anon_sym_not] = ACTIONS(3591),
    [anon_sym_compl] = ACTIONS(3591),
    [anon_sym_DASH_DASH] = ACTIONS(3594),
    [anon_sym_PLUS_PLUS] = ACTIONS(3594),
    [anon_sym_sizeof] = ACTIONS(3591),
    [anon_sym___alignof__] = ACTIONS(3591),
    [anon_sym___alignof] = ACTIONS(3591),
    [anon_sym__alignof] = ACTIONS(3591),
    [anon_sym_alignof] = ACTIONS(3591),
    [anon_sym__Alignof] = ACTIONS(3591),
    [anon_sym_offsetof] = ACTIONS(3591),
    [anon_sym__Generic] = ACTIONS(3591),
    [anon_sym_asm] = ACTIONS(3591),
    [anon_sym___asm__] = ACTIONS(3591),
    [sym_number_literal] = ACTIONS(3594),
    [anon_sym_L_SQUOTE] = ACTIONS(3594),
    [anon_sym_u_SQUOTE] = ACTIONS(3594),
    [anon_sym_U_SQUOTE] = ACTIONS(3594),
    [anon_sym_u8_SQUOTE] = ACTIONS(3594),
    [anon_sym_SQUOTE] = ACTIONS(3594),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_true] = ACTIONS(3591),
    [sym_false] = ACTIONS(3591),
    [anon_sym_NULL] = ACTIONS(3591),
    [anon_sym_nullptr] = ACTIONS(3591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3591),
    [anon_sym_let] = ACTIONS(3591),
    [anon_sym_This] = ACTIONS(3591),
    [anon_sym_decltype] = ACTIONS(3591),
    [sym_virtual] = ACTIONS(3591),
    [anon_sym_explicit] = ACTIONS(3591),
    [anon_sym_typename] = ACTIONS(3591),
    [anon_sym_template] = ACTIONS(3591),
    [anon_sym_operator] = ACTIONS(3591),
    [anon_sym_try] = ACTIONS(3591),
    [anon_sym_delete] = ACTIONS(3591),
    [anon_sym_throw] = ACTIONS(3591),
    [anon_sym_namespace] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3591),
    [anon_sym_static_assert] = ACTIONS(3591),
    [anon_sym_concept] = ACTIONS(3591),
    [anon_sym_co_return] = ACTIONS(3591),
    [anon_sym_co_yield] = ACTIONS(3591),
    [anon_sym_R_DQUOTE] = ACTIONS(3594),
    [anon_sym_LR_DQUOTE] = ACTIONS(3594),
    [anon_sym_uR_DQUOTE] = ACTIONS(3594),
    [anon_sym_UR_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3594),
    [anon_sym_co_await] = ACTIONS(3591),
    [anon_sym_new] = ACTIONS(3591),
    [anon_sym_requires] = ACTIONS(3591),
    [sym_this] = ACTIONS(3591),
    [anon_sym_discard] = ACTIONS(3591),
    [anon_sym_precise] = ACTIONS(3591),
    [anon_sym_shared] = ACTIONS(3591),
    [anon_sym_groupshared] = ACTIONS(3591),
    [anon_sym_uniform] = ACTIONS(3591),
    [anon_sym_row_major] = ACTIONS(3591),
    [anon_sym_column_major] = ACTIONS(3591),
    [anon_sym_globallycoherent] = ACTIONS(3591),
    [anon_sym_centroid] = ACTIONS(3591),
    [anon_sym_noperspective] = ACTIONS(3591),
    [anon_sym_nointerpolation] = ACTIONS(3591),
    [anon_sym_sample] = ACTIONS(3591),
    [anon_sym_linear] = ACTIONS(3591),
    [anon_sym_snorm] = ACTIONS(3591),
    [anon_sym_unorm] = ACTIONS(3591),
    [anon_sym_point] = ACTIONS(3591),
    [anon_sym_line] = ACTIONS(3591),
    [anon_sym_triangleadj] = ACTIONS(3591),
    [anon_sym_lineadj] = ACTIONS(3591),
    [anon_sym_triangle] = ACTIONS(3591),
    [anon_sym_cbuffer] = ACTIONS(3591),
    [anon_sym_interface] = ACTIONS(3591),
    [anon_sym_extension] = ACTIONS(3591),
  },
  [835] = {
    [sym_identifier] = ACTIONS(3437),
    [aux_sym_preproc_include_token1] = ACTIONS(3437),
    [aux_sym_preproc_def_token1] = ACTIONS(3437),
    [aux_sym_preproc_if_token1] = ACTIONS(3437),
    [aux_sym_preproc_if_token2] = ACTIONS(3437),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3437),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3437),
    [sym_preproc_directive] = ACTIONS(3437),
    [anon_sym_LPAREN2] = ACTIONS(3439),
    [anon_sym_BANG] = ACTIONS(3439),
    [anon_sym_TILDE] = ACTIONS(3439),
    [anon_sym_DASH] = ACTIONS(3437),
    [anon_sym_PLUS] = ACTIONS(3437),
    [anon_sym_STAR] = ACTIONS(3439),
    [anon_sym_AMP_AMP] = ACTIONS(3439),
    [anon_sym_AMP] = ACTIONS(3437),
    [anon_sym_SEMI] = ACTIONS(3439),
    [anon_sym___extension__] = ACTIONS(3437),
    [anon_sym_typedef] = ACTIONS(3437),
    [anon_sym_in] = ACTIONS(3437),
    [anon_sym_out] = ACTIONS(3437),
    [anon_sym_inout] = ACTIONS(3437),
    [anon_sym_extern] = ACTIONS(3437),
    [anon_sym___attribute__] = ACTIONS(3437),
    [anon_sym_COLON_COLON] = ACTIONS(3439),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3439),
    [anon_sym___declspec] = ACTIONS(3437),
    [anon_sym___based] = ACTIONS(3437),
    [anon_sym___cdecl] = ACTIONS(3437),
    [anon_sym___clrcall] = ACTIONS(3437),
    [anon_sym___stdcall] = ACTIONS(3437),
    [anon_sym___fastcall] = ACTIONS(3437),
    [anon_sym___thiscall] = ACTIONS(3437),
    [anon_sym___vectorcall] = ACTIONS(3437),
    [anon_sym_LBRACE] = ACTIONS(3439),
    [anon_sym_signed] = ACTIONS(3437),
    [anon_sym_unsigned] = ACTIONS(3437),
    [anon_sym_long] = ACTIONS(3437),
    [anon_sym_short] = ACTIONS(3437),
    [anon_sym_LBRACK] = ACTIONS(3437),
    [anon_sym_static] = ACTIONS(3437),
    [anon_sym_register] = ACTIONS(3437),
    [anon_sym_inline] = ACTIONS(3437),
    [anon_sym___inline] = ACTIONS(3437),
    [anon_sym___inline__] = ACTIONS(3437),
    [anon_sym___forceinline] = ACTIONS(3437),
    [anon_sym_thread_local] = ACTIONS(3437),
    [anon_sym___thread] = ACTIONS(3437),
    [anon_sym_const] = ACTIONS(3437),
    [anon_sym_constexpr] = ACTIONS(3437),
    [anon_sym_volatile] = ACTIONS(3437),
    [anon_sym_restrict] = ACTIONS(3437),
    [anon_sym___restrict__] = ACTIONS(3437),
    [anon_sym__Atomic] = ACTIONS(3437),
    [anon_sym__Noreturn] = ACTIONS(3437),
    [anon_sym_noreturn] = ACTIONS(3437),
    [anon_sym_mutable] = ACTIONS(3437),
    [anon_sym_constinit] = ACTIONS(3437),
    [anon_sym_consteval] = ACTIONS(3437),
    [anon_sym_alignas] = ACTIONS(3437),
    [anon_sym__Alignas] = ACTIONS(3437),
    [sym_primitive_type] = ACTIONS(3437),
    [anon_sym_enum] = ACTIONS(3437),
    [anon_sym_class] = ACTIONS(3437),
    [anon_sym_struct] = ACTIONS(3437),
    [anon_sym_union] = ACTIONS(3437),
    [anon_sym_if] = ACTIONS(3437),
    [anon_sym_switch] = ACTIONS(3437),
    [anon_sym_case] = ACTIONS(3437),
    [anon_sym_default] = ACTIONS(3437),
    [anon_sym_while] = ACTIONS(3437),
    [anon_sym_do] = ACTIONS(3437),
    [anon_sym_for] = ACTIONS(3437),
    [anon_sym_return] = ACTIONS(3437),
    [anon_sym_break] = ACTIONS(3437),
    [anon_sym_continue] = ACTIONS(3437),
    [anon_sym_goto] = ACTIONS(3437),
    [anon_sym___try] = ACTIONS(3437),
    [anon_sym___leave] = ACTIONS(3437),
    [anon_sym_not] = ACTIONS(3437),
    [anon_sym_compl] = ACTIONS(3437),
    [anon_sym_DASH_DASH] = ACTIONS(3439),
    [anon_sym_PLUS_PLUS] = ACTIONS(3439),
    [anon_sym_sizeof] = ACTIONS(3437),
    [anon_sym___alignof__] = ACTIONS(3437),
    [anon_sym___alignof] = ACTIONS(3437),
    [anon_sym__alignof] = ACTIONS(3437),
    [anon_sym_alignof] = ACTIONS(3437),
    [anon_sym__Alignof] = ACTIONS(3437),
    [anon_sym_offsetof] = ACTIONS(3437),
    [anon_sym__Generic] = ACTIONS(3437),
    [anon_sym_asm] = ACTIONS(3437),
    [anon_sym___asm__] = ACTIONS(3437),
    [sym_number_literal] = ACTIONS(3439),
    [anon_sym_L_SQUOTE] = ACTIONS(3439),
    [anon_sym_u_SQUOTE] = ACTIONS(3439),
    [anon_sym_U_SQUOTE] = ACTIONS(3439),
    [anon_sym_u8_SQUOTE] = ACTIONS(3439),
    [anon_sym_SQUOTE] = ACTIONS(3439),
    [anon_sym_L_DQUOTE] = ACTIONS(3439),
    [anon_sym_u_DQUOTE] = ACTIONS(3439),
    [anon_sym_U_DQUOTE] = ACTIONS(3439),
    [anon_sym_u8_DQUOTE] = ACTIONS(3439),
    [anon_sym_DQUOTE] = ACTIONS(3439),
    [sym_true] = ACTIONS(3437),
    [sym_false] = ACTIONS(3437),
    [anon_sym_NULL] = ACTIONS(3437),
    [anon_sym_nullptr] = ACTIONS(3437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3437),
    [anon_sym_let] = ACTIONS(3437),
    [anon_sym_This] = ACTIONS(3437),
    [anon_sym_decltype] = ACTIONS(3437),
    [sym_virtual] = ACTIONS(3437),
    [anon_sym_explicit] = ACTIONS(3437),
    [anon_sym_typename] = ACTIONS(3437),
    [anon_sym_template] = ACTIONS(3437),
    [anon_sym_operator] = ACTIONS(3437),
    [anon_sym_try] = ACTIONS(3437),
    [anon_sym_delete] = ACTIONS(3437),
    [anon_sym_throw] = ACTIONS(3437),
    [anon_sym_namespace] = ACTIONS(3437),
    [anon_sym_using] = ACTIONS(3437),
    [anon_sym_static_assert] = ACTIONS(3437),
    [anon_sym_concept] = ACTIONS(3437),
    [anon_sym_co_return] = ACTIONS(3437),
    [anon_sym_co_yield] = ACTIONS(3437),
    [anon_sym_R_DQUOTE] = ACTIONS(3439),
    [anon_sym_LR_DQUOTE] = ACTIONS(3439),
    [anon_sym_uR_DQUOTE] = ACTIONS(3439),
    [anon_sym_UR_DQUOTE] = ACTIONS(3439),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3439),
    [anon_sym_co_await] = ACTIONS(3437),
    [anon_sym_new] = ACTIONS(3437),
    [anon_sym_requires] = ACTIONS(3437),
    [sym_this] = ACTIONS(3437),
    [anon_sym_discard] = ACTIONS(3437),
    [anon_sym_precise] = ACTIONS(3437),
    [anon_sym_shared] = ACTIONS(3437),
    [anon_sym_groupshared] = ACTIONS(3437),
    [anon_sym_uniform] = ACTIONS(3437),
    [anon_sym_row_major] = ACTIONS(3437),
    [anon_sym_column_major] = ACTIONS(3437),
    [anon_sym_globallycoherent] = ACTIONS(3437),
    [anon_sym_centroid] = ACTIONS(3437),
    [anon_sym_noperspective] = ACTIONS(3437),
    [anon_sym_nointerpolation] = ACTIONS(3437),
    [anon_sym_sample] = ACTIONS(3437),
    [anon_sym_linear] = ACTIONS(3437),
    [anon_sym_snorm] = ACTIONS(3437),
    [anon_sym_unorm] = ACTIONS(3437),
    [anon_sym_point] = ACTIONS(3437),
    [anon_sym_line] = ACTIONS(3437),
    [anon_sym_triangleadj] = ACTIONS(3437),
    [anon_sym_lineadj] = ACTIONS(3437),
    [anon_sym_triangle] = ACTIONS(3437),
    [anon_sym_cbuffer] = ACTIONS(3437),
    [anon_sym_interface] = ACTIONS(3437),
    [anon_sym_extension] = ACTIONS(3437),
  },
  [836] = {
    [sym_identifier] = ACTIONS(3695),
    [aux_sym_preproc_include_token1] = ACTIONS(3695),
    [aux_sym_preproc_def_token1] = ACTIONS(3695),
    [aux_sym_preproc_if_token1] = ACTIONS(3695),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3695),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3695),
    [sym_preproc_directive] = ACTIONS(3695),
    [anon_sym_LPAREN2] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3697),
    [anon_sym_TILDE] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3695),
    [anon_sym_PLUS] = ACTIONS(3695),
    [anon_sym_STAR] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3697),
    [anon_sym_AMP] = ACTIONS(3695),
    [anon_sym_SEMI] = ACTIONS(3697),
    [anon_sym___extension__] = ACTIONS(3695),
    [anon_sym_typedef] = ACTIONS(3695),
    [anon_sym_in] = ACTIONS(3695),
    [anon_sym_out] = ACTIONS(3695),
    [anon_sym_inout] = ACTIONS(3695),
    [anon_sym_extern] = ACTIONS(3695),
    [anon_sym___attribute__] = ACTIONS(3695),
    [anon_sym_COLON_COLON] = ACTIONS(3697),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3697),
    [anon_sym___declspec] = ACTIONS(3695),
    [anon_sym___based] = ACTIONS(3695),
    [anon_sym___cdecl] = ACTIONS(3695),
    [anon_sym___clrcall] = ACTIONS(3695),
    [anon_sym___stdcall] = ACTIONS(3695),
    [anon_sym___fastcall] = ACTIONS(3695),
    [anon_sym___thiscall] = ACTIONS(3695),
    [anon_sym___vectorcall] = ACTIONS(3695),
    [anon_sym_LBRACE] = ACTIONS(3697),
    [anon_sym_RBRACE] = ACTIONS(3697),
    [anon_sym_signed] = ACTIONS(3695),
    [anon_sym_unsigned] = ACTIONS(3695),
    [anon_sym_long] = ACTIONS(3695),
    [anon_sym_short] = ACTIONS(3695),
    [anon_sym_LBRACK] = ACTIONS(3695),
    [anon_sym_static] = ACTIONS(3695),
    [anon_sym_register] = ACTIONS(3695),
    [anon_sym_inline] = ACTIONS(3695),
    [anon_sym___inline] = ACTIONS(3695),
    [anon_sym___inline__] = ACTIONS(3695),
    [anon_sym___forceinline] = ACTIONS(3695),
    [anon_sym_thread_local] = ACTIONS(3695),
    [anon_sym___thread] = ACTIONS(3695),
    [anon_sym_const] = ACTIONS(3695),
    [anon_sym_constexpr] = ACTIONS(3695),
    [anon_sym_volatile] = ACTIONS(3695),
    [anon_sym_restrict] = ACTIONS(3695),
    [anon_sym___restrict__] = ACTIONS(3695),
    [anon_sym__Atomic] = ACTIONS(3695),
    [anon_sym__Noreturn] = ACTIONS(3695),
    [anon_sym_noreturn] = ACTIONS(3695),
    [anon_sym_mutable] = ACTIONS(3695),
    [anon_sym_constinit] = ACTIONS(3695),
    [anon_sym_consteval] = ACTIONS(3695),
    [anon_sym_alignas] = ACTIONS(3695),
    [anon_sym__Alignas] = ACTIONS(3695),
    [sym_primitive_type] = ACTIONS(3695),
    [anon_sym_enum] = ACTIONS(3695),
    [anon_sym_class] = ACTIONS(3695),
    [anon_sym_struct] = ACTIONS(3695),
    [anon_sym_union] = ACTIONS(3695),
    [anon_sym_if] = ACTIONS(3695),
    [anon_sym_switch] = ACTIONS(3695),
    [anon_sym_case] = ACTIONS(3695),
    [anon_sym_default] = ACTIONS(3695),
    [anon_sym_while] = ACTIONS(3695),
    [anon_sym_do] = ACTIONS(3695),
    [anon_sym_for] = ACTIONS(3695),
    [anon_sym_return] = ACTIONS(3695),
    [anon_sym_break] = ACTIONS(3695),
    [anon_sym_continue] = ACTIONS(3695),
    [anon_sym_goto] = ACTIONS(3695),
    [anon_sym___try] = ACTIONS(3695),
    [anon_sym___leave] = ACTIONS(3695),
    [anon_sym_not] = ACTIONS(3695),
    [anon_sym_compl] = ACTIONS(3695),
    [anon_sym_DASH_DASH] = ACTIONS(3697),
    [anon_sym_PLUS_PLUS] = ACTIONS(3697),
    [anon_sym_sizeof] = ACTIONS(3695),
    [anon_sym___alignof__] = ACTIONS(3695),
    [anon_sym___alignof] = ACTIONS(3695),
    [anon_sym__alignof] = ACTIONS(3695),
    [anon_sym_alignof] = ACTIONS(3695),
    [anon_sym__Alignof] = ACTIONS(3695),
    [anon_sym_offsetof] = ACTIONS(3695),
    [anon_sym__Generic] = ACTIONS(3695),
    [anon_sym_asm] = ACTIONS(3695),
    [anon_sym___asm__] = ACTIONS(3695),
    [sym_number_literal] = ACTIONS(3697),
    [anon_sym_L_SQUOTE] = ACTIONS(3697),
    [anon_sym_u_SQUOTE] = ACTIONS(3697),
    [anon_sym_U_SQUOTE] = ACTIONS(3697),
    [anon_sym_u8_SQUOTE] = ACTIONS(3697),
    [anon_sym_SQUOTE] = ACTIONS(3697),
    [anon_sym_L_DQUOTE] = ACTIONS(3697),
    [anon_sym_u_DQUOTE] = ACTIONS(3697),
    [anon_sym_U_DQUOTE] = ACTIONS(3697),
    [anon_sym_u8_DQUOTE] = ACTIONS(3697),
    [anon_sym_DQUOTE] = ACTIONS(3697),
    [sym_true] = ACTIONS(3695),
    [sym_false] = ACTIONS(3695),
    [anon_sym_NULL] = ACTIONS(3695),
    [anon_sym_nullptr] = ACTIONS(3695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3695),
    [anon_sym_let] = ACTIONS(3695),
    [anon_sym_This] = ACTIONS(3695),
    [anon_sym_decltype] = ACTIONS(3695),
    [sym_virtual] = ACTIONS(3695),
    [anon_sym_explicit] = ACTIONS(3695),
    [anon_sym_typename] = ACTIONS(3695),
    [anon_sym_template] = ACTIONS(3695),
    [anon_sym_operator] = ACTIONS(3695),
    [anon_sym_try] = ACTIONS(3695),
    [anon_sym_delete] = ACTIONS(3695),
    [anon_sym_throw] = ACTIONS(3695),
    [anon_sym_namespace] = ACTIONS(3695),
    [anon_sym_using] = ACTIONS(3695),
    [anon_sym_static_assert] = ACTIONS(3695),
    [anon_sym_concept] = ACTIONS(3695),
    [anon_sym_co_return] = ACTIONS(3695),
    [anon_sym_co_yield] = ACTIONS(3695),
    [anon_sym_R_DQUOTE] = ACTIONS(3697),
    [anon_sym_LR_DQUOTE] = ACTIONS(3697),
    [anon_sym_uR_DQUOTE] = ACTIONS(3697),
    [anon_sym_UR_DQUOTE] = ACTIONS(3697),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3697),
    [anon_sym_co_await] = ACTIONS(3695),
    [anon_sym_new] = ACTIONS(3695),
    [anon_sym_requires] = ACTIONS(3695),
    [sym_this] = ACTIONS(3695),
    [anon_sym_discard] = ACTIONS(3695),
    [anon_sym_precise] = ACTIONS(3695),
    [anon_sym_shared] = ACTIONS(3695),
    [anon_sym_groupshared] = ACTIONS(3695),
    [anon_sym_uniform] = ACTIONS(3695),
    [anon_sym_row_major] = ACTIONS(3695),
    [anon_sym_column_major] = ACTIONS(3695),
    [anon_sym_globallycoherent] = ACTIONS(3695),
    [anon_sym_centroid] = ACTIONS(3695),
    [anon_sym_noperspective] = ACTIONS(3695),
    [anon_sym_nointerpolation] = ACTIONS(3695),
    [anon_sym_sample] = ACTIONS(3695),
    [anon_sym_linear] = ACTIONS(3695),
    [anon_sym_snorm] = ACTIONS(3695),
    [anon_sym_unorm] = ACTIONS(3695),
    [anon_sym_point] = ACTIONS(3695),
    [anon_sym_line] = ACTIONS(3695),
    [anon_sym_triangleadj] = ACTIONS(3695),
    [anon_sym_lineadj] = ACTIONS(3695),
    [anon_sym_triangle] = ACTIONS(3695),
    [anon_sym_cbuffer] = ACTIONS(3695),
    [anon_sym_interface] = ACTIONS(3695),
    [anon_sym_extension] = ACTIONS(3695),
  },
  [837] = {
    [sym_identifier] = ACTIONS(3613),
    [aux_sym_preproc_include_token1] = ACTIONS(3613),
    [aux_sym_preproc_def_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3613),
    [sym_preproc_directive] = ACTIONS(3613),
    [anon_sym_LPAREN2] = ACTIONS(3615),
    [anon_sym_BANG] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3613),
    [anon_sym_PLUS] = ACTIONS(3613),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym_SEMI] = ACTIONS(3615),
    [anon_sym___extension__] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3613),
    [anon_sym_in] = ACTIONS(3613),
    [anon_sym_out] = ACTIONS(3613),
    [anon_sym_inout] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym___attribute__] = ACTIONS(3613),
    [anon_sym_COLON_COLON] = ACTIONS(3615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3615),
    [anon_sym___declspec] = ACTIONS(3613),
    [anon_sym___based] = ACTIONS(3613),
    [anon_sym___cdecl] = ACTIONS(3613),
    [anon_sym___clrcall] = ACTIONS(3613),
    [anon_sym___stdcall] = ACTIONS(3613),
    [anon_sym___fastcall] = ACTIONS(3613),
    [anon_sym___thiscall] = ACTIONS(3613),
    [anon_sym___vectorcall] = ACTIONS(3613),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_RBRACE] = ACTIONS(3615),
    [anon_sym_signed] = ACTIONS(3613),
    [anon_sym_unsigned] = ACTIONS(3613),
    [anon_sym_long] = ACTIONS(3613),
    [anon_sym_short] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_register] = ACTIONS(3613),
    [anon_sym_inline] = ACTIONS(3613),
    [anon_sym___inline] = ACTIONS(3613),
    [anon_sym___inline__] = ACTIONS(3613),
    [anon_sym___forceinline] = ACTIONS(3613),
    [anon_sym_thread_local] = ACTIONS(3613),
    [anon_sym___thread] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_constexpr] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_restrict] = ACTIONS(3613),
    [anon_sym___restrict__] = ACTIONS(3613),
    [anon_sym__Atomic] = ACTIONS(3613),
    [anon_sym__Noreturn] = ACTIONS(3613),
    [anon_sym_noreturn] = ACTIONS(3613),
    [anon_sym_mutable] = ACTIONS(3613),
    [anon_sym_constinit] = ACTIONS(3613),
    [anon_sym_consteval] = ACTIONS(3613),
    [anon_sym_alignas] = ACTIONS(3613),
    [anon_sym__Alignas] = ACTIONS(3613),
    [sym_primitive_type] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_union] = ACTIONS(3613),
    [anon_sym_if] = ACTIONS(3613),
    [anon_sym_switch] = ACTIONS(3613),
    [anon_sym_case] = ACTIONS(3613),
    [anon_sym_default] = ACTIONS(3613),
    [anon_sym_while] = ACTIONS(3613),
    [anon_sym_do] = ACTIONS(3613),
    [anon_sym_for] = ACTIONS(3613),
    [anon_sym_return] = ACTIONS(3613),
    [anon_sym_break] = ACTIONS(3613),
    [anon_sym_continue] = ACTIONS(3613),
    [anon_sym_goto] = ACTIONS(3613),
    [anon_sym___try] = ACTIONS(3613),
    [anon_sym___leave] = ACTIONS(3613),
    [anon_sym_not] = ACTIONS(3613),
    [anon_sym_compl] = ACTIONS(3613),
    [anon_sym_DASH_DASH] = ACTIONS(3615),
    [anon_sym_PLUS_PLUS] = ACTIONS(3615),
    [anon_sym_sizeof] = ACTIONS(3613),
    [anon_sym___alignof__] = ACTIONS(3613),
    [anon_sym___alignof] = ACTIONS(3613),
    [anon_sym__alignof] = ACTIONS(3613),
    [anon_sym_alignof] = ACTIONS(3613),
    [anon_sym__Alignof] = ACTIONS(3613),
    [anon_sym_offsetof] = ACTIONS(3613),
    [anon_sym__Generic] = ACTIONS(3613),
    [anon_sym_asm] = ACTIONS(3613),
    [anon_sym___asm__] = ACTIONS(3613),
    [sym_number_literal] = ACTIONS(3615),
    [anon_sym_L_SQUOTE] = ACTIONS(3615),
    [anon_sym_u_SQUOTE] = ACTIONS(3615),
    [anon_sym_U_SQUOTE] = ACTIONS(3615),
    [anon_sym_u8_SQUOTE] = ACTIONS(3615),
    [anon_sym_SQUOTE] = ACTIONS(3615),
    [anon_sym_L_DQUOTE] = ACTIONS(3615),
    [anon_sym_u_DQUOTE] = ACTIONS(3615),
    [anon_sym_U_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8_DQUOTE] = ACTIONS(3615),
    [anon_sym_DQUOTE] = ACTIONS(3615),
    [sym_true] = ACTIONS(3613),
    [sym_false] = ACTIONS(3613),
    [anon_sym_NULL] = ACTIONS(3613),
    [anon_sym_nullptr] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_This] = ACTIONS(3613),
    [anon_sym_decltype] = ACTIONS(3613),
    [sym_virtual] = ACTIONS(3613),
    [anon_sym_explicit] = ACTIONS(3613),
    [anon_sym_typename] = ACTIONS(3613),
    [anon_sym_template] = ACTIONS(3613),
    [anon_sym_operator] = ACTIONS(3613),
    [anon_sym_try] = ACTIONS(3613),
    [anon_sym_delete] = ACTIONS(3613),
    [anon_sym_throw] = ACTIONS(3613),
    [anon_sym_namespace] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_static_assert] = ACTIONS(3613),
    [anon_sym_concept] = ACTIONS(3613),
    [anon_sym_co_return] = ACTIONS(3613),
    [anon_sym_co_yield] = ACTIONS(3613),
    [anon_sym_R_DQUOTE] = ACTIONS(3615),
    [anon_sym_LR_DQUOTE] = ACTIONS(3615),
    [anon_sym_uR_DQUOTE] = ACTIONS(3615),
    [anon_sym_UR_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3615),
    [anon_sym_co_await] = ACTIONS(3613),
    [anon_sym_new] = ACTIONS(3613),
    [anon_sym_requires] = ACTIONS(3613),
    [sym_this] = ACTIONS(3613),
    [anon_sym_discard] = ACTIONS(3613),
    [anon_sym_precise] = ACTIONS(3613),
    [anon_sym_shared] = ACTIONS(3613),
    [anon_sym_groupshared] = ACTIONS(3613),
    [anon_sym_uniform] = ACTIONS(3613),
    [anon_sym_row_major] = ACTIONS(3613),
    [anon_sym_column_major] = ACTIONS(3613),
    [anon_sym_globallycoherent] = ACTIONS(3613),
    [anon_sym_centroid] = ACTIONS(3613),
    [anon_sym_noperspective] = ACTIONS(3613),
    [anon_sym_nointerpolation] = ACTIONS(3613),
    [anon_sym_sample] = ACTIONS(3613),
    [anon_sym_linear] = ACTIONS(3613),
    [anon_sym_snorm] = ACTIONS(3613),
    [anon_sym_unorm] = ACTIONS(3613),
    [anon_sym_point] = ACTIONS(3613),
    [anon_sym_line] = ACTIONS(3613),
    [anon_sym_triangleadj] = ACTIONS(3613),
    [anon_sym_lineadj] = ACTIONS(3613),
    [anon_sym_triangle] = ACTIONS(3613),
    [anon_sym_cbuffer] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_extension] = ACTIONS(3613),
  },
  [838] = {
    [sym_identifier] = ACTIONS(3613),
    [aux_sym_preproc_include_token1] = ACTIONS(3613),
    [aux_sym_preproc_def_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3613),
    [sym_preproc_directive] = ACTIONS(3613),
    [anon_sym_LPAREN2] = ACTIONS(3615),
    [anon_sym_BANG] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3613),
    [anon_sym_PLUS] = ACTIONS(3613),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym_SEMI] = ACTIONS(3615),
    [anon_sym___extension__] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3613),
    [anon_sym_in] = ACTIONS(3613),
    [anon_sym_out] = ACTIONS(3613),
    [anon_sym_inout] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym___attribute__] = ACTIONS(3613),
    [anon_sym_COLON_COLON] = ACTIONS(3615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3615),
    [anon_sym___declspec] = ACTIONS(3613),
    [anon_sym___based] = ACTIONS(3613),
    [anon_sym___cdecl] = ACTIONS(3613),
    [anon_sym___clrcall] = ACTIONS(3613),
    [anon_sym___stdcall] = ACTIONS(3613),
    [anon_sym___fastcall] = ACTIONS(3613),
    [anon_sym___thiscall] = ACTIONS(3613),
    [anon_sym___vectorcall] = ACTIONS(3613),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_RBRACE] = ACTIONS(3615),
    [anon_sym_signed] = ACTIONS(3613),
    [anon_sym_unsigned] = ACTIONS(3613),
    [anon_sym_long] = ACTIONS(3613),
    [anon_sym_short] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_register] = ACTIONS(3613),
    [anon_sym_inline] = ACTIONS(3613),
    [anon_sym___inline] = ACTIONS(3613),
    [anon_sym___inline__] = ACTIONS(3613),
    [anon_sym___forceinline] = ACTIONS(3613),
    [anon_sym_thread_local] = ACTIONS(3613),
    [anon_sym___thread] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_constexpr] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_restrict] = ACTIONS(3613),
    [anon_sym___restrict__] = ACTIONS(3613),
    [anon_sym__Atomic] = ACTIONS(3613),
    [anon_sym__Noreturn] = ACTIONS(3613),
    [anon_sym_noreturn] = ACTIONS(3613),
    [anon_sym_mutable] = ACTIONS(3613),
    [anon_sym_constinit] = ACTIONS(3613),
    [anon_sym_consteval] = ACTIONS(3613),
    [anon_sym_alignas] = ACTIONS(3613),
    [anon_sym__Alignas] = ACTIONS(3613),
    [sym_primitive_type] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_union] = ACTIONS(3613),
    [anon_sym_if] = ACTIONS(3613),
    [anon_sym_switch] = ACTIONS(3613),
    [anon_sym_case] = ACTIONS(3613),
    [anon_sym_default] = ACTIONS(3613),
    [anon_sym_while] = ACTIONS(3613),
    [anon_sym_do] = ACTIONS(3613),
    [anon_sym_for] = ACTIONS(3613),
    [anon_sym_return] = ACTIONS(3613),
    [anon_sym_break] = ACTIONS(3613),
    [anon_sym_continue] = ACTIONS(3613),
    [anon_sym_goto] = ACTIONS(3613),
    [anon_sym___try] = ACTIONS(3613),
    [anon_sym___leave] = ACTIONS(3613),
    [anon_sym_not] = ACTIONS(3613),
    [anon_sym_compl] = ACTIONS(3613),
    [anon_sym_DASH_DASH] = ACTIONS(3615),
    [anon_sym_PLUS_PLUS] = ACTIONS(3615),
    [anon_sym_sizeof] = ACTIONS(3613),
    [anon_sym___alignof__] = ACTIONS(3613),
    [anon_sym___alignof] = ACTIONS(3613),
    [anon_sym__alignof] = ACTIONS(3613),
    [anon_sym_alignof] = ACTIONS(3613),
    [anon_sym__Alignof] = ACTIONS(3613),
    [anon_sym_offsetof] = ACTIONS(3613),
    [anon_sym__Generic] = ACTIONS(3613),
    [anon_sym_asm] = ACTIONS(3613),
    [anon_sym___asm__] = ACTIONS(3613),
    [sym_number_literal] = ACTIONS(3615),
    [anon_sym_L_SQUOTE] = ACTIONS(3615),
    [anon_sym_u_SQUOTE] = ACTIONS(3615),
    [anon_sym_U_SQUOTE] = ACTIONS(3615),
    [anon_sym_u8_SQUOTE] = ACTIONS(3615),
    [anon_sym_SQUOTE] = ACTIONS(3615),
    [anon_sym_L_DQUOTE] = ACTIONS(3615),
    [anon_sym_u_DQUOTE] = ACTIONS(3615),
    [anon_sym_U_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8_DQUOTE] = ACTIONS(3615),
    [anon_sym_DQUOTE] = ACTIONS(3615),
    [sym_true] = ACTIONS(3613),
    [sym_false] = ACTIONS(3613),
    [anon_sym_NULL] = ACTIONS(3613),
    [anon_sym_nullptr] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_This] = ACTIONS(3613),
    [anon_sym_decltype] = ACTIONS(3613),
    [sym_virtual] = ACTIONS(3613),
    [anon_sym_explicit] = ACTIONS(3613),
    [anon_sym_typename] = ACTIONS(3613),
    [anon_sym_template] = ACTIONS(3613),
    [anon_sym_operator] = ACTIONS(3613),
    [anon_sym_try] = ACTIONS(3613),
    [anon_sym_delete] = ACTIONS(3613),
    [anon_sym_throw] = ACTIONS(3613),
    [anon_sym_namespace] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_static_assert] = ACTIONS(3613),
    [anon_sym_concept] = ACTIONS(3613),
    [anon_sym_co_return] = ACTIONS(3613),
    [anon_sym_co_yield] = ACTIONS(3613),
    [anon_sym_R_DQUOTE] = ACTIONS(3615),
    [anon_sym_LR_DQUOTE] = ACTIONS(3615),
    [anon_sym_uR_DQUOTE] = ACTIONS(3615),
    [anon_sym_UR_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3615),
    [anon_sym_co_await] = ACTIONS(3613),
    [anon_sym_new] = ACTIONS(3613),
    [anon_sym_requires] = ACTIONS(3613),
    [sym_this] = ACTIONS(3613),
    [anon_sym_discard] = ACTIONS(3613),
    [anon_sym_precise] = ACTIONS(3613),
    [anon_sym_shared] = ACTIONS(3613),
    [anon_sym_groupshared] = ACTIONS(3613),
    [anon_sym_uniform] = ACTIONS(3613),
    [anon_sym_row_major] = ACTIONS(3613),
    [anon_sym_column_major] = ACTIONS(3613),
    [anon_sym_globallycoherent] = ACTIONS(3613),
    [anon_sym_centroid] = ACTIONS(3613),
    [anon_sym_noperspective] = ACTIONS(3613),
    [anon_sym_nointerpolation] = ACTIONS(3613),
    [anon_sym_sample] = ACTIONS(3613),
    [anon_sym_linear] = ACTIONS(3613),
    [anon_sym_snorm] = ACTIONS(3613),
    [anon_sym_unorm] = ACTIONS(3613),
    [anon_sym_point] = ACTIONS(3613),
    [anon_sym_line] = ACTIONS(3613),
    [anon_sym_triangleadj] = ACTIONS(3613),
    [anon_sym_lineadj] = ACTIONS(3613),
    [anon_sym_triangle] = ACTIONS(3613),
    [anon_sym_cbuffer] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_extension] = ACTIONS(3613),
  },
  [839] = {
    [sym_identifier] = ACTIONS(3691),
    [aux_sym_preproc_include_token1] = ACTIONS(3691),
    [aux_sym_preproc_def_token1] = ACTIONS(3691),
    [aux_sym_preproc_if_token1] = ACTIONS(3691),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3691),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3691),
    [sym_preproc_directive] = ACTIONS(3691),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_BANG] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_PLUS] = ACTIONS(3691),
    [anon_sym_STAR] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_AMP] = ACTIONS(3691),
    [anon_sym_SEMI] = ACTIONS(3693),
    [anon_sym___extension__] = ACTIONS(3691),
    [anon_sym_typedef] = ACTIONS(3691),
    [anon_sym_in] = ACTIONS(3691),
    [anon_sym_out] = ACTIONS(3691),
    [anon_sym_inout] = ACTIONS(3691),
    [anon_sym_extern] = ACTIONS(3691),
    [anon_sym___attribute__] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3693),
    [anon_sym___declspec] = ACTIONS(3691),
    [anon_sym___based] = ACTIONS(3691),
    [anon_sym___cdecl] = ACTIONS(3691),
    [anon_sym___clrcall] = ACTIONS(3691),
    [anon_sym___stdcall] = ACTIONS(3691),
    [anon_sym___fastcall] = ACTIONS(3691),
    [anon_sym___thiscall] = ACTIONS(3691),
    [anon_sym___vectorcall] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_RBRACE] = ACTIONS(3693),
    [anon_sym_signed] = ACTIONS(3691),
    [anon_sym_unsigned] = ACTIONS(3691),
    [anon_sym_long] = ACTIONS(3691),
    [anon_sym_short] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(3691),
    [anon_sym_static] = ACTIONS(3691),
    [anon_sym_register] = ACTIONS(3691),
    [anon_sym_inline] = ACTIONS(3691),
    [anon_sym___inline] = ACTIONS(3691),
    [anon_sym___inline__] = ACTIONS(3691),
    [anon_sym___forceinline] = ACTIONS(3691),
    [anon_sym_thread_local] = ACTIONS(3691),
    [anon_sym___thread] = ACTIONS(3691),
    [anon_sym_const] = ACTIONS(3691),
    [anon_sym_constexpr] = ACTIONS(3691),
    [anon_sym_volatile] = ACTIONS(3691),
    [anon_sym_restrict] = ACTIONS(3691),
    [anon_sym___restrict__] = ACTIONS(3691),
    [anon_sym__Atomic] = ACTIONS(3691),
    [anon_sym__Noreturn] = ACTIONS(3691),
    [anon_sym_noreturn] = ACTIONS(3691),
    [anon_sym_mutable] = ACTIONS(3691),
    [anon_sym_constinit] = ACTIONS(3691),
    [anon_sym_consteval] = ACTIONS(3691),
    [anon_sym_alignas] = ACTIONS(3691),
    [anon_sym__Alignas] = ACTIONS(3691),
    [sym_primitive_type] = ACTIONS(3691),
    [anon_sym_enum] = ACTIONS(3691),
    [anon_sym_class] = ACTIONS(3691),
    [anon_sym_struct] = ACTIONS(3691),
    [anon_sym_union] = ACTIONS(3691),
    [anon_sym_if] = ACTIONS(3691),
    [anon_sym_switch] = ACTIONS(3691),
    [anon_sym_case] = ACTIONS(3691),
    [anon_sym_default] = ACTIONS(3691),
    [anon_sym_while] = ACTIONS(3691),
    [anon_sym_do] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3691),
    [anon_sym_return] = ACTIONS(3691),
    [anon_sym_break] = ACTIONS(3691),
    [anon_sym_continue] = ACTIONS(3691),
    [anon_sym_goto] = ACTIONS(3691),
    [anon_sym___try] = ACTIONS(3691),
    [anon_sym___leave] = ACTIONS(3691),
    [anon_sym_not] = ACTIONS(3691),
    [anon_sym_compl] = ACTIONS(3691),
    [anon_sym_DASH_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_PLUS] = ACTIONS(3693),
    [anon_sym_sizeof] = ACTIONS(3691),
    [anon_sym___alignof__] = ACTIONS(3691),
    [anon_sym___alignof] = ACTIONS(3691),
    [anon_sym__alignof] = ACTIONS(3691),
    [anon_sym_alignof] = ACTIONS(3691),
    [anon_sym__Alignof] = ACTIONS(3691),
    [anon_sym_offsetof] = ACTIONS(3691),
    [anon_sym__Generic] = ACTIONS(3691),
    [anon_sym_asm] = ACTIONS(3691),
    [anon_sym___asm__] = ACTIONS(3691),
    [sym_number_literal] = ACTIONS(3693),
    [anon_sym_L_SQUOTE] = ACTIONS(3693),
    [anon_sym_u_SQUOTE] = ACTIONS(3693),
    [anon_sym_U_SQUOTE] = ACTIONS(3693),
    [anon_sym_u8_SQUOTE] = ACTIONS(3693),
    [anon_sym_SQUOTE] = ACTIONS(3693),
    [anon_sym_L_DQUOTE] = ACTIONS(3693),
    [anon_sym_u_DQUOTE] = ACTIONS(3693),
    [anon_sym_U_DQUOTE] = ACTIONS(3693),
    [anon_sym_u8_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [sym_true] = ACTIONS(3691),
    [sym_false] = ACTIONS(3691),
    [anon_sym_NULL] = ACTIONS(3691),
    [anon_sym_nullptr] = ACTIONS(3691),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3691),
    [anon_sym_let] = ACTIONS(3691),
    [anon_sym_This] = ACTIONS(3691),
    [anon_sym_decltype] = ACTIONS(3691),
    [sym_virtual] = ACTIONS(3691),
    [anon_sym_explicit] = ACTIONS(3691),
    [anon_sym_typename] = ACTIONS(3691),
    [anon_sym_template] = ACTIONS(3691),
    [anon_sym_operator] = ACTIONS(3691),
    [anon_sym_try] = ACTIONS(3691),
    [anon_sym_delete] = ACTIONS(3691),
    [anon_sym_throw] = ACTIONS(3691),
    [anon_sym_namespace] = ACTIONS(3691),
    [anon_sym_using] = ACTIONS(3691),
    [anon_sym_static_assert] = ACTIONS(3691),
    [anon_sym_concept] = ACTIONS(3691),
    [anon_sym_co_return] = ACTIONS(3691),
    [anon_sym_co_yield] = ACTIONS(3691),
    [anon_sym_R_DQUOTE] = ACTIONS(3693),
    [anon_sym_LR_DQUOTE] = ACTIONS(3693),
    [anon_sym_uR_DQUOTE] = ACTIONS(3693),
    [anon_sym_UR_DQUOTE] = ACTIONS(3693),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3693),
    [anon_sym_co_await] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3691),
    [anon_sym_requires] = ACTIONS(3691),
    [sym_this] = ACTIONS(3691),
    [anon_sym_discard] = ACTIONS(3691),
    [anon_sym_precise] = ACTIONS(3691),
    [anon_sym_shared] = ACTIONS(3691),
    [anon_sym_groupshared] = ACTIONS(3691),
    [anon_sym_uniform] = ACTIONS(3691),
    [anon_sym_row_major] = ACTIONS(3691),
    [anon_sym_column_major] = ACTIONS(3691),
    [anon_sym_globallycoherent] = ACTIONS(3691),
    [anon_sym_centroid] = ACTIONS(3691),
    [anon_sym_noperspective] = ACTIONS(3691),
    [anon_sym_nointerpolation] = ACTIONS(3691),
    [anon_sym_sample] = ACTIONS(3691),
    [anon_sym_linear] = ACTIONS(3691),
    [anon_sym_snorm] = ACTIONS(3691),
    [anon_sym_unorm] = ACTIONS(3691),
    [anon_sym_point] = ACTIONS(3691),
    [anon_sym_line] = ACTIONS(3691),
    [anon_sym_triangleadj] = ACTIONS(3691),
    [anon_sym_lineadj] = ACTIONS(3691),
    [anon_sym_triangle] = ACTIONS(3691),
    [anon_sym_cbuffer] = ACTIONS(3691),
    [anon_sym_interface] = ACTIONS(3691),
    [anon_sym_extension] = ACTIONS(3691),
  },
  [840] = {
    [sym_identifier] = ACTIONS(3433),
    [aux_sym_preproc_include_token1] = ACTIONS(3433),
    [aux_sym_preproc_def_token1] = ACTIONS(3433),
    [aux_sym_preproc_if_token1] = ACTIONS(3433),
    [aux_sym_preproc_if_token2] = ACTIONS(3433),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3433),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3433),
    [sym_preproc_directive] = ACTIONS(3433),
    [anon_sym_LPAREN2] = ACTIONS(3435),
    [anon_sym_BANG] = ACTIONS(3435),
    [anon_sym_TILDE] = ACTIONS(3435),
    [anon_sym_DASH] = ACTIONS(3433),
    [anon_sym_PLUS] = ACTIONS(3433),
    [anon_sym_STAR] = ACTIONS(3435),
    [anon_sym_AMP_AMP] = ACTIONS(3435),
    [anon_sym_AMP] = ACTIONS(3433),
    [anon_sym_SEMI] = ACTIONS(3435),
    [anon_sym___extension__] = ACTIONS(3433),
    [anon_sym_typedef] = ACTIONS(3433),
    [anon_sym_in] = ACTIONS(3433),
    [anon_sym_out] = ACTIONS(3433),
    [anon_sym_inout] = ACTIONS(3433),
    [anon_sym_extern] = ACTIONS(3433),
    [anon_sym___attribute__] = ACTIONS(3433),
    [anon_sym_COLON_COLON] = ACTIONS(3435),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3435),
    [anon_sym___declspec] = ACTIONS(3433),
    [anon_sym___based] = ACTIONS(3433),
    [anon_sym___cdecl] = ACTIONS(3433),
    [anon_sym___clrcall] = ACTIONS(3433),
    [anon_sym___stdcall] = ACTIONS(3433),
    [anon_sym___fastcall] = ACTIONS(3433),
    [anon_sym___thiscall] = ACTIONS(3433),
    [anon_sym___vectorcall] = ACTIONS(3433),
    [anon_sym_LBRACE] = ACTIONS(3435),
    [anon_sym_signed] = ACTIONS(3433),
    [anon_sym_unsigned] = ACTIONS(3433),
    [anon_sym_long] = ACTIONS(3433),
    [anon_sym_short] = ACTIONS(3433),
    [anon_sym_LBRACK] = ACTIONS(3433),
    [anon_sym_static] = ACTIONS(3433),
    [anon_sym_register] = ACTIONS(3433),
    [anon_sym_inline] = ACTIONS(3433),
    [anon_sym___inline] = ACTIONS(3433),
    [anon_sym___inline__] = ACTIONS(3433),
    [anon_sym___forceinline] = ACTIONS(3433),
    [anon_sym_thread_local] = ACTIONS(3433),
    [anon_sym___thread] = ACTIONS(3433),
    [anon_sym_const] = ACTIONS(3433),
    [anon_sym_constexpr] = ACTIONS(3433),
    [anon_sym_volatile] = ACTIONS(3433),
    [anon_sym_restrict] = ACTIONS(3433),
    [anon_sym___restrict__] = ACTIONS(3433),
    [anon_sym__Atomic] = ACTIONS(3433),
    [anon_sym__Noreturn] = ACTIONS(3433),
    [anon_sym_noreturn] = ACTIONS(3433),
    [anon_sym_mutable] = ACTIONS(3433),
    [anon_sym_constinit] = ACTIONS(3433),
    [anon_sym_consteval] = ACTIONS(3433),
    [anon_sym_alignas] = ACTIONS(3433),
    [anon_sym__Alignas] = ACTIONS(3433),
    [sym_primitive_type] = ACTIONS(3433),
    [anon_sym_enum] = ACTIONS(3433),
    [anon_sym_class] = ACTIONS(3433),
    [anon_sym_struct] = ACTIONS(3433),
    [anon_sym_union] = ACTIONS(3433),
    [anon_sym_if] = ACTIONS(3433),
    [anon_sym_switch] = ACTIONS(3433),
    [anon_sym_case] = ACTIONS(3433),
    [anon_sym_default] = ACTIONS(3433),
    [anon_sym_while] = ACTIONS(3433),
    [anon_sym_do] = ACTIONS(3433),
    [anon_sym_for] = ACTIONS(3433),
    [anon_sym_return] = ACTIONS(3433),
    [anon_sym_break] = ACTIONS(3433),
    [anon_sym_continue] = ACTIONS(3433),
    [anon_sym_goto] = ACTIONS(3433),
    [anon_sym___try] = ACTIONS(3433),
    [anon_sym___leave] = ACTIONS(3433),
    [anon_sym_not] = ACTIONS(3433),
    [anon_sym_compl] = ACTIONS(3433),
    [anon_sym_DASH_DASH] = ACTIONS(3435),
    [anon_sym_PLUS_PLUS] = ACTIONS(3435),
    [anon_sym_sizeof] = ACTIONS(3433),
    [anon_sym___alignof__] = ACTIONS(3433),
    [anon_sym___alignof] = ACTIONS(3433),
    [anon_sym__alignof] = ACTIONS(3433),
    [anon_sym_alignof] = ACTIONS(3433),
    [anon_sym__Alignof] = ACTIONS(3433),
    [anon_sym_offsetof] = ACTIONS(3433),
    [anon_sym__Generic] = ACTIONS(3433),
    [anon_sym_asm] = ACTIONS(3433),
    [anon_sym___asm__] = ACTIONS(3433),
    [sym_number_literal] = ACTIONS(3435),
    [anon_sym_L_SQUOTE] = ACTIONS(3435),
    [anon_sym_u_SQUOTE] = ACTIONS(3435),
    [anon_sym_U_SQUOTE] = ACTIONS(3435),
    [anon_sym_u8_SQUOTE] = ACTIONS(3435),
    [anon_sym_SQUOTE] = ACTIONS(3435),
    [anon_sym_L_DQUOTE] = ACTIONS(3435),
    [anon_sym_u_DQUOTE] = ACTIONS(3435),
    [anon_sym_U_DQUOTE] = ACTIONS(3435),
    [anon_sym_u8_DQUOTE] = ACTIONS(3435),
    [anon_sym_DQUOTE] = ACTIONS(3435),
    [sym_true] = ACTIONS(3433),
    [sym_false] = ACTIONS(3433),
    [anon_sym_NULL] = ACTIONS(3433),
    [anon_sym_nullptr] = ACTIONS(3433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3433),
    [anon_sym_let] = ACTIONS(3433),
    [anon_sym_This] = ACTIONS(3433),
    [anon_sym_decltype] = ACTIONS(3433),
    [sym_virtual] = ACTIONS(3433),
    [anon_sym_explicit] = ACTIONS(3433),
    [anon_sym_typename] = ACTIONS(3433),
    [anon_sym_template] = ACTIONS(3433),
    [anon_sym_operator] = ACTIONS(3433),
    [anon_sym_try] = ACTIONS(3433),
    [anon_sym_delete] = ACTIONS(3433),
    [anon_sym_throw] = ACTIONS(3433),
    [anon_sym_namespace] = ACTIONS(3433),
    [anon_sym_using] = ACTIONS(3433),
    [anon_sym_static_assert] = ACTIONS(3433),
    [anon_sym_concept] = ACTIONS(3433),
    [anon_sym_co_return] = ACTIONS(3433),
    [anon_sym_co_yield] = ACTIONS(3433),
    [anon_sym_R_DQUOTE] = ACTIONS(3435),
    [anon_sym_LR_DQUOTE] = ACTIONS(3435),
    [anon_sym_uR_DQUOTE] = ACTIONS(3435),
    [anon_sym_UR_DQUOTE] = ACTIONS(3435),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3435),
    [anon_sym_co_await] = ACTIONS(3433),
    [anon_sym_new] = ACTIONS(3433),
    [anon_sym_requires] = ACTIONS(3433),
    [sym_this] = ACTIONS(3433),
    [anon_sym_discard] = ACTIONS(3433),
    [anon_sym_precise] = ACTIONS(3433),
    [anon_sym_shared] = ACTIONS(3433),
    [anon_sym_groupshared] = ACTIONS(3433),
    [anon_sym_uniform] = ACTIONS(3433),
    [anon_sym_row_major] = ACTIONS(3433),
    [anon_sym_column_major] = ACTIONS(3433),
    [anon_sym_globallycoherent] = ACTIONS(3433),
    [anon_sym_centroid] = ACTIONS(3433),
    [anon_sym_noperspective] = ACTIONS(3433),
    [anon_sym_nointerpolation] = ACTIONS(3433),
    [anon_sym_sample] = ACTIONS(3433),
    [anon_sym_linear] = ACTIONS(3433),
    [anon_sym_snorm] = ACTIONS(3433),
    [anon_sym_unorm] = ACTIONS(3433),
    [anon_sym_point] = ACTIONS(3433),
    [anon_sym_line] = ACTIONS(3433),
    [anon_sym_triangleadj] = ACTIONS(3433),
    [anon_sym_lineadj] = ACTIONS(3433),
    [anon_sym_triangle] = ACTIONS(3433),
    [anon_sym_cbuffer] = ACTIONS(3433),
    [anon_sym_interface] = ACTIONS(3433),
    [anon_sym_extension] = ACTIONS(3433),
  },
  [841] = {
    [sym_identifier] = ACTIONS(3418),
    [aux_sym_preproc_include_token1] = ACTIONS(3418),
    [aux_sym_preproc_def_token1] = ACTIONS(3418),
    [aux_sym_preproc_if_token1] = ACTIONS(3418),
    [aux_sym_preproc_if_token2] = ACTIONS(3418),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3418),
    [sym_preproc_directive] = ACTIONS(3418),
    [anon_sym_LPAREN2] = ACTIONS(3420),
    [anon_sym_BANG] = ACTIONS(3420),
    [anon_sym_TILDE] = ACTIONS(3420),
    [anon_sym_DASH] = ACTIONS(3418),
    [anon_sym_PLUS] = ACTIONS(3418),
    [anon_sym_STAR] = ACTIONS(3420),
    [anon_sym_AMP_AMP] = ACTIONS(3420),
    [anon_sym_AMP] = ACTIONS(3418),
    [anon_sym_SEMI] = ACTIONS(3420),
    [anon_sym___extension__] = ACTIONS(3418),
    [anon_sym_typedef] = ACTIONS(3418),
    [anon_sym_in] = ACTIONS(3418),
    [anon_sym_out] = ACTIONS(3418),
    [anon_sym_inout] = ACTIONS(3418),
    [anon_sym_extern] = ACTIONS(3418),
    [anon_sym___attribute__] = ACTIONS(3418),
    [anon_sym_COLON_COLON] = ACTIONS(3420),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3420),
    [anon_sym___declspec] = ACTIONS(3418),
    [anon_sym___based] = ACTIONS(3418),
    [anon_sym___cdecl] = ACTIONS(3418),
    [anon_sym___clrcall] = ACTIONS(3418),
    [anon_sym___stdcall] = ACTIONS(3418),
    [anon_sym___fastcall] = ACTIONS(3418),
    [anon_sym___thiscall] = ACTIONS(3418),
    [anon_sym___vectorcall] = ACTIONS(3418),
    [anon_sym_LBRACE] = ACTIONS(3420),
    [anon_sym_signed] = ACTIONS(3418),
    [anon_sym_unsigned] = ACTIONS(3418),
    [anon_sym_long] = ACTIONS(3418),
    [anon_sym_short] = ACTIONS(3418),
    [anon_sym_LBRACK] = ACTIONS(3418),
    [anon_sym_static] = ACTIONS(3418),
    [anon_sym_register] = ACTIONS(3418),
    [anon_sym_inline] = ACTIONS(3418),
    [anon_sym___inline] = ACTIONS(3418),
    [anon_sym___inline__] = ACTIONS(3418),
    [anon_sym___forceinline] = ACTIONS(3418),
    [anon_sym_thread_local] = ACTIONS(3418),
    [anon_sym___thread] = ACTIONS(3418),
    [anon_sym_const] = ACTIONS(3418),
    [anon_sym_constexpr] = ACTIONS(3418),
    [anon_sym_volatile] = ACTIONS(3418),
    [anon_sym_restrict] = ACTIONS(3418),
    [anon_sym___restrict__] = ACTIONS(3418),
    [anon_sym__Atomic] = ACTIONS(3418),
    [anon_sym__Noreturn] = ACTIONS(3418),
    [anon_sym_noreturn] = ACTIONS(3418),
    [anon_sym_mutable] = ACTIONS(3418),
    [anon_sym_constinit] = ACTIONS(3418),
    [anon_sym_consteval] = ACTIONS(3418),
    [anon_sym_alignas] = ACTIONS(3418),
    [anon_sym__Alignas] = ACTIONS(3418),
    [sym_primitive_type] = ACTIONS(3418),
    [anon_sym_enum] = ACTIONS(3418),
    [anon_sym_class] = ACTIONS(3418),
    [anon_sym_struct] = ACTIONS(3418),
    [anon_sym_union] = ACTIONS(3418),
    [anon_sym_if] = ACTIONS(3418),
    [anon_sym_switch] = ACTIONS(3418),
    [anon_sym_case] = ACTIONS(3418),
    [anon_sym_default] = ACTIONS(3418),
    [anon_sym_while] = ACTIONS(3418),
    [anon_sym_do] = ACTIONS(3418),
    [anon_sym_for] = ACTIONS(3418),
    [anon_sym_return] = ACTIONS(3418),
    [anon_sym_break] = ACTIONS(3418),
    [anon_sym_continue] = ACTIONS(3418),
    [anon_sym_goto] = ACTIONS(3418),
    [anon_sym___try] = ACTIONS(3418),
    [anon_sym___leave] = ACTIONS(3418),
    [anon_sym_not] = ACTIONS(3418),
    [anon_sym_compl] = ACTIONS(3418),
    [anon_sym_DASH_DASH] = ACTIONS(3420),
    [anon_sym_PLUS_PLUS] = ACTIONS(3420),
    [anon_sym_sizeof] = ACTIONS(3418),
    [anon_sym___alignof__] = ACTIONS(3418),
    [anon_sym___alignof] = ACTIONS(3418),
    [anon_sym__alignof] = ACTIONS(3418),
    [anon_sym_alignof] = ACTIONS(3418),
    [anon_sym__Alignof] = ACTIONS(3418),
    [anon_sym_offsetof] = ACTIONS(3418),
    [anon_sym__Generic] = ACTIONS(3418),
    [anon_sym_asm] = ACTIONS(3418),
    [anon_sym___asm__] = ACTIONS(3418),
    [sym_number_literal] = ACTIONS(3420),
    [anon_sym_L_SQUOTE] = ACTIONS(3420),
    [anon_sym_u_SQUOTE] = ACTIONS(3420),
    [anon_sym_U_SQUOTE] = ACTIONS(3420),
    [anon_sym_u8_SQUOTE] = ACTIONS(3420),
    [anon_sym_SQUOTE] = ACTIONS(3420),
    [anon_sym_L_DQUOTE] = ACTIONS(3420),
    [anon_sym_u_DQUOTE] = ACTIONS(3420),
    [anon_sym_U_DQUOTE] = ACTIONS(3420),
    [anon_sym_u8_DQUOTE] = ACTIONS(3420),
    [anon_sym_DQUOTE] = ACTIONS(3420),
    [sym_true] = ACTIONS(3418),
    [sym_false] = ACTIONS(3418),
    [anon_sym_NULL] = ACTIONS(3418),
    [anon_sym_nullptr] = ACTIONS(3418),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3418),
    [anon_sym_let] = ACTIONS(3418),
    [anon_sym_This] = ACTIONS(3418),
    [anon_sym_decltype] = ACTIONS(3418),
    [sym_virtual] = ACTIONS(3418),
    [anon_sym_explicit] = ACTIONS(3418),
    [anon_sym_typename] = ACTIONS(3418),
    [anon_sym_template] = ACTIONS(3418),
    [anon_sym_operator] = ACTIONS(3418),
    [anon_sym_try] = ACTIONS(3418),
    [anon_sym_delete] = ACTIONS(3418),
    [anon_sym_throw] = ACTIONS(3418),
    [anon_sym_namespace] = ACTIONS(3418),
    [anon_sym_using] = ACTIONS(3418),
    [anon_sym_static_assert] = ACTIONS(3418),
    [anon_sym_concept] = ACTIONS(3418),
    [anon_sym_co_return] = ACTIONS(3418),
    [anon_sym_co_yield] = ACTIONS(3418),
    [anon_sym_R_DQUOTE] = ACTIONS(3420),
    [anon_sym_LR_DQUOTE] = ACTIONS(3420),
    [anon_sym_uR_DQUOTE] = ACTIONS(3420),
    [anon_sym_UR_DQUOTE] = ACTIONS(3420),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3420),
    [anon_sym_co_await] = ACTIONS(3418),
    [anon_sym_new] = ACTIONS(3418),
    [anon_sym_requires] = ACTIONS(3418),
    [sym_this] = ACTIONS(3418),
    [anon_sym_discard] = ACTIONS(3418),
    [anon_sym_precise] = ACTIONS(3418),
    [anon_sym_shared] = ACTIONS(3418),
    [anon_sym_groupshared] = ACTIONS(3418),
    [anon_sym_uniform] = ACTIONS(3418),
    [anon_sym_row_major] = ACTIONS(3418),
    [anon_sym_column_major] = ACTIONS(3418),
    [anon_sym_globallycoherent] = ACTIONS(3418),
    [anon_sym_centroid] = ACTIONS(3418),
    [anon_sym_noperspective] = ACTIONS(3418),
    [anon_sym_nointerpolation] = ACTIONS(3418),
    [anon_sym_sample] = ACTIONS(3418),
    [anon_sym_linear] = ACTIONS(3418),
    [anon_sym_snorm] = ACTIONS(3418),
    [anon_sym_unorm] = ACTIONS(3418),
    [anon_sym_point] = ACTIONS(3418),
    [anon_sym_line] = ACTIONS(3418),
    [anon_sym_triangleadj] = ACTIONS(3418),
    [anon_sym_lineadj] = ACTIONS(3418),
    [anon_sym_triangle] = ACTIONS(3418),
    [anon_sym_cbuffer] = ACTIONS(3418),
    [anon_sym_interface] = ACTIONS(3418),
    [anon_sym_extension] = ACTIONS(3418),
  },
  [842] = {
    [sym_identifier] = ACTIONS(3467),
    [aux_sym_preproc_include_token1] = ACTIONS(3467),
    [aux_sym_preproc_def_token1] = ACTIONS(3467),
    [aux_sym_preproc_if_token1] = ACTIONS(3467),
    [aux_sym_preproc_if_token2] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3467),
    [sym_preproc_directive] = ACTIONS(3467),
    [anon_sym_LPAREN2] = ACTIONS(3469),
    [anon_sym_BANG] = ACTIONS(3469),
    [anon_sym_TILDE] = ACTIONS(3469),
    [anon_sym_DASH] = ACTIONS(3467),
    [anon_sym_PLUS] = ACTIONS(3467),
    [anon_sym_STAR] = ACTIONS(3469),
    [anon_sym_AMP_AMP] = ACTIONS(3469),
    [anon_sym_AMP] = ACTIONS(3467),
    [anon_sym_SEMI] = ACTIONS(3469),
    [anon_sym___extension__] = ACTIONS(3467),
    [anon_sym_typedef] = ACTIONS(3467),
    [anon_sym_in] = ACTIONS(3467),
    [anon_sym_out] = ACTIONS(3467),
    [anon_sym_inout] = ACTIONS(3467),
    [anon_sym_extern] = ACTIONS(3467),
    [anon_sym___attribute__] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(3469),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3469),
    [anon_sym___declspec] = ACTIONS(3467),
    [anon_sym___based] = ACTIONS(3467),
    [anon_sym___cdecl] = ACTIONS(3467),
    [anon_sym___clrcall] = ACTIONS(3467),
    [anon_sym___stdcall] = ACTIONS(3467),
    [anon_sym___fastcall] = ACTIONS(3467),
    [anon_sym___thiscall] = ACTIONS(3467),
    [anon_sym___vectorcall] = ACTIONS(3467),
    [anon_sym_LBRACE] = ACTIONS(3469),
    [anon_sym_signed] = ACTIONS(3467),
    [anon_sym_unsigned] = ACTIONS(3467),
    [anon_sym_long] = ACTIONS(3467),
    [anon_sym_short] = ACTIONS(3467),
    [anon_sym_LBRACK] = ACTIONS(3467),
    [anon_sym_static] = ACTIONS(3467),
    [anon_sym_register] = ACTIONS(3467),
    [anon_sym_inline] = ACTIONS(3467),
    [anon_sym___inline] = ACTIONS(3467),
    [anon_sym___inline__] = ACTIONS(3467),
    [anon_sym___forceinline] = ACTIONS(3467),
    [anon_sym_thread_local] = ACTIONS(3467),
    [anon_sym___thread] = ACTIONS(3467),
    [anon_sym_const] = ACTIONS(3467),
    [anon_sym_constexpr] = ACTIONS(3467),
    [anon_sym_volatile] = ACTIONS(3467),
    [anon_sym_restrict] = ACTIONS(3467),
    [anon_sym___restrict__] = ACTIONS(3467),
    [anon_sym__Atomic] = ACTIONS(3467),
    [anon_sym__Noreturn] = ACTIONS(3467),
    [anon_sym_noreturn] = ACTIONS(3467),
    [anon_sym_mutable] = ACTIONS(3467),
    [anon_sym_constinit] = ACTIONS(3467),
    [anon_sym_consteval] = ACTIONS(3467),
    [anon_sym_alignas] = ACTIONS(3467),
    [anon_sym__Alignas] = ACTIONS(3467),
    [sym_primitive_type] = ACTIONS(3467),
    [anon_sym_enum] = ACTIONS(3467),
    [anon_sym_class] = ACTIONS(3467),
    [anon_sym_struct] = ACTIONS(3467),
    [anon_sym_union] = ACTIONS(3467),
    [anon_sym_if] = ACTIONS(3467),
    [anon_sym_switch] = ACTIONS(3467),
    [anon_sym_case] = ACTIONS(3467),
    [anon_sym_default] = ACTIONS(3467),
    [anon_sym_while] = ACTIONS(3467),
    [anon_sym_do] = ACTIONS(3467),
    [anon_sym_for] = ACTIONS(3467),
    [anon_sym_return] = ACTIONS(3467),
    [anon_sym_break] = ACTIONS(3467),
    [anon_sym_continue] = ACTIONS(3467),
    [anon_sym_goto] = ACTIONS(3467),
    [anon_sym___try] = ACTIONS(3467),
    [anon_sym___leave] = ACTIONS(3467),
    [anon_sym_not] = ACTIONS(3467),
    [anon_sym_compl] = ACTIONS(3467),
    [anon_sym_DASH_DASH] = ACTIONS(3469),
    [anon_sym_PLUS_PLUS] = ACTIONS(3469),
    [anon_sym_sizeof] = ACTIONS(3467),
    [anon_sym___alignof__] = ACTIONS(3467),
    [anon_sym___alignof] = ACTIONS(3467),
    [anon_sym__alignof] = ACTIONS(3467),
    [anon_sym_alignof] = ACTIONS(3467),
    [anon_sym__Alignof] = ACTIONS(3467),
    [anon_sym_offsetof] = ACTIONS(3467),
    [anon_sym__Generic] = ACTIONS(3467),
    [anon_sym_asm] = ACTIONS(3467),
    [anon_sym___asm__] = ACTIONS(3467),
    [sym_number_literal] = ACTIONS(3469),
    [anon_sym_L_SQUOTE] = ACTIONS(3469),
    [anon_sym_u_SQUOTE] = ACTIONS(3469),
    [anon_sym_U_SQUOTE] = ACTIONS(3469),
    [anon_sym_u8_SQUOTE] = ACTIONS(3469),
    [anon_sym_SQUOTE] = ACTIONS(3469),
    [anon_sym_L_DQUOTE] = ACTIONS(3469),
    [anon_sym_u_DQUOTE] = ACTIONS(3469),
    [anon_sym_U_DQUOTE] = ACTIONS(3469),
    [anon_sym_u8_DQUOTE] = ACTIONS(3469),
    [anon_sym_DQUOTE] = ACTIONS(3469),
    [sym_true] = ACTIONS(3467),
    [sym_false] = ACTIONS(3467),
    [anon_sym_NULL] = ACTIONS(3467),
    [anon_sym_nullptr] = ACTIONS(3467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3467),
    [anon_sym_let] = ACTIONS(3467),
    [anon_sym_This] = ACTIONS(3467),
    [anon_sym_decltype] = ACTIONS(3467),
    [sym_virtual] = ACTIONS(3467),
    [anon_sym_explicit] = ACTIONS(3467),
    [anon_sym_typename] = ACTIONS(3467),
    [anon_sym_template] = ACTIONS(3467),
    [anon_sym_operator] = ACTIONS(3467),
    [anon_sym_try] = ACTIONS(3467),
    [anon_sym_delete] = ACTIONS(3467),
    [anon_sym_throw] = ACTIONS(3467),
    [anon_sym_namespace] = ACTIONS(3467),
    [anon_sym_using] = ACTIONS(3467),
    [anon_sym_static_assert] = ACTIONS(3467),
    [anon_sym_concept] = ACTIONS(3467),
    [anon_sym_co_return] = ACTIONS(3467),
    [anon_sym_co_yield] = ACTIONS(3467),
    [anon_sym_R_DQUOTE] = ACTIONS(3469),
    [anon_sym_LR_DQUOTE] = ACTIONS(3469),
    [anon_sym_uR_DQUOTE] = ACTIONS(3469),
    [anon_sym_UR_DQUOTE] = ACTIONS(3469),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3469),
    [anon_sym_co_await] = ACTIONS(3467),
    [anon_sym_new] = ACTIONS(3467),
    [anon_sym_requires] = ACTIONS(3467),
    [sym_this] = ACTIONS(3467),
    [anon_sym_discard] = ACTIONS(3467),
    [anon_sym_precise] = ACTIONS(3467),
    [anon_sym_shared] = ACTIONS(3467),
    [anon_sym_groupshared] = ACTIONS(3467),
    [anon_sym_uniform] = ACTIONS(3467),
    [anon_sym_row_major] = ACTIONS(3467),
    [anon_sym_column_major] = ACTIONS(3467),
    [anon_sym_globallycoherent] = ACTIONS(3467),
    [anon_sym_centroid] = ACTIONS(3467),
    [anon_sym_noperspective] = ACTIONS(3467),
    [anon_sym_nointerpolation] = ACTIONS(3467),
    [anon_sym_sample] = ACTIONS(3467),
    [anon_sym_linear] = ACTIONS(3467),
    [anon_sym_snorm] = ACTIONS(3467),
    [anon_sym_unorm] = ACTIONS(3467),
    [anon_sym_point] = ACTIONS(3467),
    [anon_sym_line] = ACTIONS(3467),
    [anon_sym_triangleadj] = ACTIONS(3467),
    [anon_sym_lineadj] = ACTIONS(3467),
    [anon_sym_triangle] = ACTIONS(3467),
    [anon_sym_cbuffer] = ACTIONS(3467),
    [anon_sym_interface] = ACTIONS(3467),
    [anon_sym_extension] = ACTIONS(3467),
  },
  [843] = {
    [sym_identifier] = ACTIONS(3471),
    [aux_sym_preproc_include_token1] = ACTIONS(3471),
    [aux_sym_preproc_def_token1] = ACTIONS(3471),
    [aux_sym_preproc_if_token1] = ACTIONS(3471),
    [aux_sym_preproc_if_token2] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3471),
    [sym_preproc_directive] = ACTIONS(3471),
    [anon_sym_LPAREN2] = ACTIONS(3473),
    [anon_sym_BANG] = ACTIONS(3473),
    [anon_sym_TILDE] = ACTIONS(3473),
    [anon_sym_DASH] = ACTIONS(3471),
    [anon_sym_PLUS] = ACTIONS(3471),
    [anon_sym_STAR] = ACTIONS(3473),
    [anon_sym_AMP_AMP] = ACTIONS(3473),
    [anon_sym_AMP] = ACTIONS(3471),
    [anon_sym_SEMI] = ACTIONS(3473),
    [anon_sym___extension__] = ACTIONS(3471),
    [anon_sym_typedef] = ACTIONS(3471),
    [anon_sym_in] = ACTIONS(3471),
    [anon_sym_out] = ACTIONS(3471),
    [anon_sym_inout] = ACTIONS(3471),
    [anon_sym_extern] = ACTIONS(3471),
    [anon_sym___attribute__] = ACTIONS(3471),
    [anon_sym_COLON_COLON] = ACTIONS(3473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3473),
    [anon_sym___declspec] = ACTIONS(3471),
    [anon_sym___based] = ACTIONS(3471),
    [anon_sym___cdecl] = ACTIONS(3471),
    [anon_sym___clrcall] = ACTIONS(3471),
    [anon_sym___stdcall] = ACTIONS(3471),
    [anon_sym___fastcall] = ACTIONS(3471),
    [anon_sym___thiscall] = ACTIONS(3471),
    [anon_sym___vectorcall] = ACTIONS(3471),
    [anon_sym_LBRACE] = ACTIONS(3473),
    [anon_sym_signed] = ACTIONS(3471),
    [anon_sym_unsigned] = ACTIONS(3471),
    [anon_sym_long] = ACTIONS(3471),
    [anon_sym_short] = ACTIONS(3471),
    [anon_sym_LBRACK] = ACTIONS(3471),
    [anon_sym_static] = ACTIONS(3471),
    [anon_sym_register] = ACTIONS(3471),
    [anon_sym_inline] = ACTIONS(3471),
    [anon_sym___inline] = ACTIONS(3471),
    [anon_sym___inline__] = ACTIONS(3471),
    [anon_sym___forceinline] = ACTIONS(3471),
    [anon_sym_thread_local] = ACTIONS(3471),
    [anon_sym___thread] = ACTIONS(3471),
    [anon_sym_const] = ACTIONS(3471),
    [anon_sym_constexpr] = ACTIONS(3471),
    [anon_sym_volatile] = ACTIONS(3471),
    [anon_sym_restrict] = ACTIONS(3471),
    [anon_sym___restrict__] = ACTIONS(3471),
    [anon_sym__Atomic] = ACTIONS(3471),
    [anon_sym__Noreturn] = ACTIONS(3471),
    [anon_sym_noreturn] = ACTIONS(3471),
    [anon_sym_mutable] = ACTIONS(3471),
    [anon_sym_constinit] = ACTIONS(3471),
    [anon_sym_consteval] = ACTIONS(3471),
    [anon_sym_alignas] = ACTIONS(3471),
    [anon_sym__Alignas] = ACTIONS(3471),
    [sym_primitive_type] = ACTIONS(3471),
    [anon_sym_enum] = ACTIONS(3471),
    [anon_sym_class] = ACTIONS(3471),
    [anon_sym_struct] = ACTIONS(3471),
    [anon_sym_union] = ACTIONS(3471),
    [anon_sym_if] = ACTIONS(3471),
    [anon_sym_switch] = ACTIONS(3471),
    [anon_sym_case] = ACTIONS(3471),
    [anon_sym_default] = ACTIONS(3471),
    [anon_sym_while] = ACTIONS(3471),
    [anon_sym_do] = ACTIONS(3471),
    [anon_sym_for] = ACTIONS(3471),
    [anon_sym_return] = ACTIONS(3471),
    [anon_sym_break] = ACTIONS(3471),
    [anon_sym_continue] = ACTIONS(3471),
    [anon_sym_goto] = ACTIONS(3471),
    [anon_sym___try] = ACTIONS(3471),
    [anon_sym___leave] = ACTIONS(3471),
    [anon_sym_not] = ACTIONS(3471),
    [anon_sym_compl] = ACTIONS(3471),
    [anon_sym_DASH_DASH] = ACTIONS(3473),
    [anon_sym_PLUS_PLUS] = ACTIONS(3473),
    [anon_sym_sizeof] = ACTIONS(3471),
    [anon_sym___alignof__] = ACTIONS(3471),
    [anon_sym___alignof] = ACTIONS(3471),
    [anon_sym__alignof] = ACTIONS(3471),
    [anon_sym_alignof] = ACTIONS(3471),
    [anon_sym__Alignof] = ACTIONS(3471),
    [anon_sym_offsetof] = ACTIONS(3471),
    [anon_sym__Generic] = ACTIONS(3471),
    [anon_sym_asm] = ACTIONS(3471),
    [anon_sym___asm__] = ACTIONS(3471),
    [sym_number_literal] = ACTIONS(3473),
    [anon_sym_L_SQUOTE] = ACTIONS(3473),
    [anon_sym_u_SQUOTE] = ACTIONS(3473),
    [anon_sym_U_SQUOTE] = ACTIONS(3473),
    [anon_sym_u8_SQUOTE] = ACTIONS(3473),
    [anon_sym_SQUOTE] = ACTIONS(3473),
    [anon_sym_L_DQUOTE] = ACTIONS(3473),
    [anon_sym_u_DQUOTE] = ACTIONS(3473),
    [anon_sym_U_DQUOTE] = ACTIONS(3473),
    [anon_sym_u8_DQUOTE] = ACTIONS(3473),
    [anon_sym_DQUOTE] = ACTIONS(3473),
    [sym_true] = ACTIONS(3471),
    [sym_false] = ACTIONS(3471),
    [anon_sym_NULL] = ACTIONS(3471),
    [anon_sym_nullptr] = ACTIONS(3471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3471),
    [anon_sym_let] = ACTIONS(3471),
    [anon_sym_This] = ACTIONS(3471),
    [anon_sym_decltype] = ACTIONS(3471),
    [sym_virtual] = ACTIONS(3471),
    [anon_sym_explicit] = ACTIONS(3471),
    [anon_sym_typename] = ACTIONS(3471),
    [anon_sym_template] = ACTIONS(3471),
    [anon_sym_operator] = ACTIONS(3471),
    [anon_sym_try] = ACTIONS(3471),
    [anon_sym_delete] = ACTIONS(3471),
    [anon_sym_throw] = ACTIONS(3471),
    [anon_sym_namespace] = ACTIONS(3471),
    [anon_sym_using] = ACTIONS(3471),
    [anon_sym_static_assert] = ACTIONS(3471),
    [anon_sym_concept] = ACTIONS(3471),
    [anon_sym_co_return] = ACTIONS(3471),
    [anon_sym_co_yield] = ACTIONS(3471),
    [anon_sym_R_DQUOTE] = ACTIONS(3473),
    [anon_sym_LR_DQUOTE] = ACTIONS(3473),
    [anon_sym_uR_DQUOTE] = ACTIONS(3473),
    [anon_sym_UR_DQUOTE] = ACTIONS(3473),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3473),
    [anon_sym_co_await] = ACTIONS(3471),
    [anon_sym_new] = ACTIONS(3471),
    [anon_sym_requires] = ACTIONS(3471),
    [sym_this] = ACTIONS(3471),
    [anon_sym_discard] = ACTIONS(3471),
    [anon_sym_precise] = ACTIONS(3471),
    [anon_sym_shared] = ACTIONS(3471),
    [anon_sym_groupshared] = ACTIONS(3471),
    [anon_sym_uniform] = ACTIONS(3471),
    [anon_sym_row_major] = ACTIONS(3471),
    [anon_sym_column_major] = ACTIONS(3471),
    [anon_sym_globallycoherent] = ACTIONS(3471),
    [anon_sym_centroid] = ACTIONS(3471),
    [anon_sym_noperspective] = ACTIONS(3471),
    [anon_sym_nointerpolation] = ACTIONS(3471),
    [anon_sym_sample] = ACTIONS(3471),
    [anon_sym_linear] = ACTIONS(3471),
    [anon_sym_snorm] = ACTIONS(3471),
    [anon_sym_unorm] = ACTIONS(3471),
    [anon_sym_point] = ACTIONS(3471),
    [anon_sym_line] = ACTIONS(3471),
    [anon_sym_triangleadj] = ACTIONS(3471),
    [anon_sym_lineadj] = ACTIONS(3471),
    [anon_sym_triangle] = ACTIONS(3471),
    [anon_sym_cbuffer] = ACTIONS(3471),
    [anon_sym_interface] = ACTIONS(3471),
    [anon_sym_extension] = ACTIONS(3471),
  },
  [844] = {
    [sym_identifier] = ACTIONS(3489),
    [aux_sym_preproc_include_token1] = ACTIONS(3489),
    [aux_sym_preproc_def_token1] = ACTIONS(3489),
    [aux_sym_preproc_if_token1] = ACTIONS(3489),
    [aux_sym_preproc_if_token2] = ACTIONS(3489),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3489),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3489),
    [sym_preproc_directive] = ACTIONS(3489),
    [anon_sym_LPAREN2] = ACTIONS(3491),
    [anon_sym_BANG] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(3489),
    [anon_sym_PLUS] = ACTIONS(3489),
    [anon_sym_STAR] = ACTIONS(3491),
    [anon_sym_AMP_AMP] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3489),
    [anon_sym_SEMI] = ACTIONS(3491),
    [anon_sym___extension__] = ACTIONS(3489),
    [anon_sym_typedef] = ACTIONS(3489),
    [anon_sym_in] = ACTIONS(3489),
    [anon_sym_out] = ACTIONS(3489),
    [anon_sym_inout] = ACTIONS(3489),
    [anon_sym_extern] = ACTIONS(3489),
    [anon_sym___attribute__] = ACTIONS(3489),
    [anon_sym_COLON_COLON] = ACTIONS(3491),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3491),
    [anon_sym___declspec] = ACTIONS(3489),
    [anon_sym___based] = ACTIONS(3489),
    [anon_sym___cdecl] = ACTIONS(3489),
    [anon_sym___clrcall] = ACTIONS(3489),
    [anon_sym___stdcall] = ACTIONS(3489),
    [anon_sym___fastcall] = ACTIONS(3489),
    [anon_sym___thiscall] = ACTIONS(3489),
    [anon_sym___vectorcall] = ACTIONS(3489),
    [anon_sym_LBRACE] = ACTIONS(3491),
    [anon_sym_signed] = ACTIONS(3489),
    [anon_sym_unsigned] = ACTIONS(3489),
    [anon_sym_long] = ACTIONS(3489),
    [anon_sym_short] = ACTIONS(3489),
    [anon_sym_LBRACK] = ACTIONS(3489),
    [anon_sym_static] = ACTIONS(3489),
    [anon_sym_register] = ACTIONS(3489),
    [anon_sym_inline] = ACTIONS(3489),
    [anon_sym___inline] = ACTIONS(3489),
    [anon_sym___inline__] = ACTIONS(3489),
    [anon_sym___forceinline] = ACTIONS(3489),
    [anon_sym_thread_local] = ACTIONS(3489),
    [anon_sym___thread] = ACTIONS(3489),
    [anon_sym_const] = ACTIONS(3489),
    [anon_sym_constexpr] = ACTIONS(3489),
    [anon_sym_volatile] = ACTIONS(3489),
    [anon_sym_restrict] = ACTIONS(3489),
    [anon_sym___restrict__] = ACTIONS(3489),
    [anon_sym__Atomic] = ACTIONS(3489),
    [anon_sym__Noreturn] = ACTIONS(3489),
    [anon_sym_noreturn] = ACTIONS(3489),
    [anon_sym_mutable] = ACTIONS(3489),
    [anon_sym_constinit] = ACTIONS(3489),
    [anon_sym_consteval] = ACTIONS(3489),
    [anon_sym_alignas] = ACTIONS(3489),
    [anon_sym__Alignas] = ACTIONS(3489),
    [sym_primitive_type] = ACTIONS(3489),
    [anon_sym_enum] = ACTIONS(3489),
    [anon_sym_class] = ACTIONS(3489),
    [anon_sym_struct] = ACTIONS(3489),
    [anon_sym_union] = ACTIONS(3489),
    [anon_sym_if] = ACTIONS(3489),
    [anon_sym_switch] = ACTIONS(3489),
    [anon_sym_case] = ACTIONS(3489),
    [anon_sym_default] = ACTIONS(3489),
    [anon_sym_while] = ACTIONS(3489),
    [anon_sym_do] = ACTIONS(3489),
    [anon_sym_for] = ACTIONS(3489),
    [anon_sym_return] = ACTIONS(3489),
    [anon_sym_break] = ACTIONS(3489),
    [anon_sym_continue] = ACTIONS(3489),
    [anon_sym_goto] = ACTIONS(3489),
    [anon_sym___try] = ACTIONS(3489),
    [anon_sym___leave] = ACTIONS(3489),
    [anon_sym_not] = ACTIONS(3489),
    [anon_sym_compl] = ACTIONS(3489),
    [anon_sym_DASH_DASH] = ACTIONS(3491),
    [anon_sym_PLUS_PLUS] = ACTIONS(3491),
    [anon_sym_sizeof] = ACTIONS(3489),
    [anon_sym___alignof__] = ACTIONS(3489),
    [anon_sym___alignof] = ACTIONS(3489),
    [anon_sym__alignof] = ACTIONS(3489),
    [anon_sym_alignof] = ACTIONS(3489),
    [anon_sym__Alignof] = ACTIONS(3489),
    [anon_sym_offsetof] = ACTIONS(3489),
    [anon_sym__Generic] = ACTIONS(3489),
    [anon_sym_asm] = ACTIONS(3489),
    [anon_sym___asm__] = ACTIONS(3489),
    [sym_number_literal] = ACTIONS(3491),
    [anon_sym_L_SQUOTE] = ACTIONS(3491),
    [anon_sym_u_SQUOTE] = ACTIONS(3491),
    [anon_sym_U_SQUOTE] = ACTIONS(3491),
    [anon_sym_u8_SQUOTE] = ACTIONS(3491),
    [anon_sym_SQUOTE] = ACTIONS(3491),
    [anon_sym_L_DQUOTE] = ACTIONS(3491),
    [anon_sym_u_DQUOTE] = ACTIONS(3491),
    [anon_sym_U_DQUOTE] = ACTIONS(3491),
    [anon_sym_u8_DQUOTE] = ACTIONS(3491),
    [anon_sym_DQUOTE] = ACTIONS(3491),
    [sym_true] = ACTIONS(3489),
    [sym_false] = ACTIONS(3489),
    [anon_sym_NULL] = ACTIONS(3489),
    [anon_sym_nullptr] = ACTIONS(3489),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3489),
    [anon_sym_let] = ACTIONS(3489),
    [anon_sym_This] = ACTIONS(3489),
    [anon_sym_decltype] = ACTIONS(3489),
    [sym_virtual] = ACTIONS(3489),
    [anon_sym_explicit] = ACTIONS(3489),
    [anon_sym_typename] = ACTIONS(3489),
    [anon_sym_template] = ACTIONS(3489),
    [anon_sym_operator] = ACTIONS(3489),
    [anon_sym_try] = ACTIONS(3489),
    [anon_sym_delete] = ACTIONS(3489),
    [anon_sym_throw] = ACTIONS(3489),
    [anon_sym_namespace] = ACTIONS(3489),
    [anon_sym_using] = ACTIONS(3489),
    [anon_sym_static_assert] = ACTIONS(3489),
    [anon_sym_concept] = ACTIONS(3489),
    [anon_sym_co_return] = ACTIONS(3489),
    [anon_sym_co_yield] = ACTIONS(3489),
    [anon_sym_R_DQUOTE] = ACTIONS(3491),
    [anon_sym_LR_DQUOTE] = ACTIONS(3491),
    [anon_sym_uR_DQUOTE] = ACTIONS(3491),
    [anon_sym_UR_DQUOTE] = ACTIONS(3491),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3491),
    [anon_sym_co_await] = ACTIONS(3489),
    [anon_sym_new] = ACTIONS(3489),
    [anon_sym_requires] = ACTIONS(3489),
    [sym_this] = ACTIONS(3489),
    [anon_sym_discard] = ACTIONS(3489),
    [anon_sym_precise] = ACTIONS(3489),
    [anon_sym_shared] = ACTIONS(3489),
    [anon_sym_groupshared] = ACTIONS(3489),
    [anon_sym_uniform] = ACTIONS(3489),
    [anon_sym_row_major] = ACTIONS(3489),
    [anon_sym_column_major] = ACTIONS(3489),
    [anon_sym_globallycoherent] = ACTIONS(3489),
    [anon_sym_centroid] = ACTIONS(3489),
    [anon_sym_noperspective] = ACTIONS(3489),
    [anon_sym_nointerpolation] = ACTIONS(3489),
    [anon_sym_sample] = ACTIONS(3489),
    [anon_sym_linear] = ACTIONS(3489),
    [anon_sym_snorm] = ACTIONS(3489),
    [anon_sym_unorm] = ACTIONS(3489),
    [anon_sym_point] = ACTIONS(3489),
    [anon_sym_line] = ACTIONS(3489),
    [anon_sym_triangleadj] = ACTIONS(3489),
    [anon_sym_lineadj] = ACTIONS(3489),
    [anon_sym_triangle] = ACTIONS(3489),
    [anon_sym_cbuffer] = ACTIONS(3489),
    [anon_sym_interface] = ACTIONS(3489),
    [anon_sym_extension] = ACTIONS(3489),
  },
  [845] = {
    [sym_identifier] = ACTIONS(3601),
    [aux_sym_preproc_include_token1] = ACTIONS(3601),
    [aux_sym_preproc_def_token1] = ACTIONS(3601),
    [aux_sym_preproc_if_token1] = ACTIONS(3601),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3601),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3601),
    [sym_preproc_directive] = ACTIONS(3601),
    [anon_sym_LPAREN2] = ACTIONS(3603),
    [anon_sym_BANG] = ACTIONS(3603),
    [anon_sym_TILDE] = ACTIONS(3603),
    [anon_sym_DASH] = ACTIONS(3601),
    [anon_sym_PLUS] = ACTIONS(3601),
    [anon_sym_STAR] = ACTIONS(3603),
    [anon_sym_AMP_AMP] = ACTIONS(3603),
    [anon_sym_AMP] = ACTIONS(3601),
    [anon_sym_SEMI] = ACTIONS(3603),
    [anon_sym___extension__] = ACTIONS(3601),
    [anon_sym_typedef] = ACTIONS(3601),
    [anon_sym_in] = ACTIONS(3601),
    [anon_sym_out] = ACTIONS(3601),
    [anon_sym_inout] = ACTIONS(3601),
    [anon_sym_extern] = ACTIONS(3601),
    [anon_sym___attribute__] = ACTIONS(3601),
    [anon_sym_COLON_COLON] = ACTIONS(3603),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3603),
    [anon_sym___declspec] = ACTIONS(3601),
    [anon_sym___based] = ACTIONS(3601),
    [anon_sym___cdecl] = ACTIONS(3601),
    [anon_sym___clrcall] = ACTIONS(3601),
    [anon_sym___stdcall] = ACTIONS(3601),
    [anon_sym___fastcall] = ACTIONS(3601),
    [anon_sym___thiscall] = ACTIONS(3601),
    [anon_sym___vectorcall] = ACTIONS(3601),
    [anon_sym_LBRACE] = ACTIONS(3603),
    [anon_sym_RBRACE] = ACTIONS(3603),
    [anon_sym_signed] = ACTIONS(3601),
    [anon_sym_unsigned] = ACTIONS(3601),
    [anon_sym_long] = ACTIONS(3601),
    [anon_sym_short] = ACTIONS(3601),
    [anon_sym_LBRACK] = ACTIONS(3601),
    [anon_sym_static] = ACTIONS(3601),
    [anon_sym_register] = ACTIONS(3601),
    [anon_sym_inline] = ACTIONS(3601),
    [anon_sym___inline] = ACTIONS(3601),
    [anon_sym___inline__] = ACTIONS(3601),
    [anon_sym___forceinline] = ACTIONS(3601),
    [anon_sym_thread_local] = ACTIONS(3601),
    [anon_sym___thread] = ACTIONS(3601),
    [anon_sym_const] = ACTIONS(3601),
    [anon_sym_constexpr] = ACTIONS(3601),
    [anon_sym_volatile] = ACTIONS(3601),
    [anon_sym_restrict] = ACTIONS(3601),
    [anon_sym___restrict__] = ACTIONS(3601),
    [anon_sym__Atomic] = ACTIONS(3601),
    [anon_sym__Noreturn] = ACTIONS(3601),
    [anon_sym_noreturn] = ACTIONS(3601),
    [anon_sym_mutable] = ACTIONS(3601),
    [anon_sym_constinit] = ACTIONS(3601),
    [anon_sym_consteval] = ACTIONS(3601),
    [anon_sym_alignas] = ACTIONS(3601),
    [anon_sym__Alignas] = ACTIONS(3601),
    [sym_primitive_type] = ACTIONS(3601),
    [anon_sym_enum] = ACTIONS(3601),
    [anon_sym_class] = ACTIONS(3601),
    [anon_sym_struct] = ACTIONS(3601),
    [anon_sym_union] = ACTIONS(3601),
    [anon_sym_if] = ACTIONS(3601),
    [anon_sym_switch] = ACTIONS(3601),
    [anon_sym_case] = ACTIONS(3601),
    [anon_sym_default] = ACTIONS(3601),
    [anon_sym_while] = ACTIONS(3601),
    [anon_sym_do] = ACTIONS(3601),
    [anon_sym_for] = ACTIONS(3601),
    [anon_sym_return] = ACTIONS(3601),
    [anon_sym_break] = ACTIONS(3601),
    [anon_sym_continue] = ACTIONS(3601),
    [anon_sym_goto] = ACTIONS(3601),
    [anon_sym___try] = ACTIONS(3601),
    [anon_sym___leave] = ACTIONS(3601),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_compl] = ACTIONS(3601),
    [anon_sym_DASH_DASH] = ACTIONS(3603),
    [anon_sym_PLUS_PLUS] = ACTIONS(3603),
    [anon_sym_sizeof] = ACTIONS(3601),
    [anon_sym___alignof__] = ACTIONS(3601),
    [anon_sym___alignof] = ACTIONS(3601),
    [anon_sym__alignof] = ACTIONS(3601),
    [anon_sym_alignof] = ACTIONS(3601),
    [anon_sym__Alignof] = ACTIONS(3601),
    [anon_sym_offsetof] = ACTIONS(3601),
    [anon_sym__Generic] = ACTIONS(3601),
    [anon_sym_asm] = ACTIONS(3601),
    [anon_sym___asm__] = ACTIONS(3601),
    [sym_number_literal] = ACTIONS(3603),
    [anon_sym_L_SQUOTE] = ACTIONS(3603),
    [anon_sym_u_SQUOTE] = ACTIONS(3603),
    [anon_sym_U_SQUOTE] = ACTIONS(3603),
    [anon_sym_u8_SQUOTE] = ACTIONS(3603),
    [anon_sym_SQUOTE] = ACTIONS(3603),
    [anon_sym_L_DQUOTE] = ACTIONS(3603),
    [anon_sym_u_DQUOTE] = ACTIONS(3603),
    [anon_sym_U_DQUOTE] = ACTIONS(3603),
    [anon_sym_u8_DQUOTE] = ACTIONS(3603),
    [anon_sym_DQUOTE] = ACTIONS(3603),
    [sym_true] = ACTIONS(3601),
    [sym_false] = ACTIONS(3601),
    [anon_sym_NULL] = ACTIONS(3601),
    [anon_sym_nullptr] = ACTIONS(3601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3601),
    [anon_sym_let] = ACTIONS(3601),
    [anon_sym_This] = ACTIONS(3601),
    [anon_sym_decltype] = ACTIONS(3601),
    [sym_virtual] = ACTIONS(3601),
    [anon_sym_explicit] = ACTIONS(3601),
    [anon_sym_typename] = ACTIONS(3601),
    [anon_sym_template] = ACTIONS(3601),
    [anon_sym_operator] = ACTIONS(3601),
    [anon_sym_try] = ACTIONS(3601),
    [anon_sym_delete] = ACTIONS(3601),
    [anon_sym_throw] = ACTIONS(3601),
    [anon_sym_namespace] = ACTIONS(3601),
    [anon_sym_using] = ACTIONS(3601),
    [anon_sym_static_assert] = ACTIONS(3601),
    [anon_sym_concept] = ACTIONS(3601),
    [anon_sym_co_return] = ACTIONS(3601),
    [anon_sym_co_yield] = ACTIONS(3601),
    [anon_sym_R_DQUOTE] = ACTIONS(3603),
    [anon_sym_LR_DQUOTE] = ACTIONS(3603),
    [anon_sym_uR_DQUOTE] = ACTIONS(3603),
    [anon_sym_UR_DQUOTE] = ACTIONS(3603),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3603),
    [anon_sym_co_await] = ACTIONS(3601),
    [anon_sym_new] = ACTIONS(3601),
    [anon_sym_requires] = ACTIONS(3601),
    [sym_this] = ACTIONS(3601),
    [anon_sym_discard] = ACTIONS(3601),
    [anon_sym_precise] = ACTIONS(3601),
    [anon_sym_shared] = ACTIONS(3601),
    [anon_sym_groupshared] = ACTIONS(3601),
    [anon_sym_uniform] = ACTIONS(3601),
    [anon_sym_row_major] = ACTIONS(3601),
    [anon_sym_column_major] = ACTIONS(3601),
    [anon_sym_globallycoherent] = ACTIONS(3601),
    [anon_sym_centroid] = ACTIONS(3601),
    [anon_sym_noperspective] = ACTIONS(3601),
    [anon_sym_nointerpolation] = ACTIONS(3601),
    [anon_sym_sample] = ACTIONS(3601),
    [anon_sym_linear] = ACTIONS(3601),
    [anon_sym_snorm] = ACTIONS(3601),
    [anon_sym_unorm] = ACTIONS(3601),
    [anon_sym_point] = ACTIONS(3601),
    [anon_sym_line] = ACTIONS(3601),
    [anon_sym_triangleadj] = ACTIONS(3601),
    [anon_sym_lineadj] = ACTIONS(3601),
    [anon_sym_triangle] = ACTIONS(3601),
    [anon_sym_cbuffer] = ACTIONS(3601),
    [anon_sym_interface] = ACTIONS(3601),
    [anon_sym_extension] = ACTIONS(3601),
  },
  [846] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(285),
    [ts_builtin_sym_end] = ACTIONS(3752),
    [sym_identifier] = ACTIONS(3750),
    [aux_sym_preproc_include_token1] = ACTIONS(3750),
    [aux_sym_preproc_def_token1] = ACTIONS(3750),
    [aux_sym_preproc_if_token1] = ACTIONS(3750),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3750),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3750),
    [sym_preproc_directive] = ACTIONS(3750),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3752),
    [anon_sym_TILDE] = ACTIONS(3752),
    [anon_sym_DASH] = ACTIONS(3750),
    [anon_sym_PLUS] = ACTIONS(3750),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_AMP_AMP] = ACTIONS(3752),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_SEMI] = ACTIONS(3752),
    [anon_sym___extension__] = ACTIONS(3750),
    [anon_sym_typedef] = ACTIONS(3750),
    [anon_sym_in] = ACTIONS(3750),
    [anon_sym_out] = ACTIONS(3750),
    [anon_sym_inout] = ACTIONS(3750),
    [anon_sym_extern] = ACTIONS(3750),
    [anon_sym___attribute__] = ACTIONS(3750),
    [anon_sym_COLON_COLON] = ACTIONS(3752),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3752),
    [anon_sym___declspec] = ACTIONS(3750),
    [anon_sym___based] = ACTIONS(3750),
    [anon_sym___cdecl] = ACTIONS(3750),
    [anon_sym___clrcall] = ACTIONS(3750),
    [anon_sym___stdcall] = ACTIONS(3750),
    [anon_sym___fastcall] = ACTIONS(3750),
    [anon_sym___thiscall] = ACTIONS(3750),
    [anon_sym___vectorcall] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(3752),
    [anon_sym_signed] = ACTIONS(3920),
    [anon_sym_unsigned] = ACTIONS(3920),
    [anon_sym_long] = ACTIONS(3920),
    [anon_sym_short] = ACTIONS(3920),
    [anon_sym_LBRACK] = ACTIONS(3750),
    [anon_sym_static] = ACTIONS(3750),
    [anon_sym_register] = ACTIONS(3750),
    [anon_sym_inline] = ACTIONS(3750),
    [anon_sym___inline] = ACTIONS(3750),
    [anon_sym___inline__] = ACTIONS(3750),
    [anon_sym___forceinline] = ACTIONS(3750),
    [anon_sym_thread_local] = ACTIONS(3750),
    [anon_sym___thread] = ACTIONS(3750),
    [anon_sym_const] = ACTIONS(3750),
    [anon_sym_constexpr] = ACTIONS(3750),
    [anon_sym_volatile] = ACTIONS(3750),
    [anon_sym_restrict] = ACTIONS(3750),
    [anon_sym___restrict__] = ACTIONS(3750),
    [anon_sym__Atomic] = ACTIONS(3750),
    [anon_sym__Noreturn] = ACTIONS(3750),
    [anon_sym_noreturn] = ACTIONS(3750),
    [anon_sym_mutable] = ACTIONS(3750),
    [anon_sym_constinit] = ACTIONS(3750),
    [anon_sym_consteval] = ACTIONS(3750),
    [anon_sym_alignas] = ACTIONS(3750),
    [anon_sym__Alignas] = ACTIONS(3750),
    [sym_primitive_type] = ACTIONS(3750),
    [anon_sym_enum] = ACTIONS(3750),
    [anon_sym_class] = ACTIONS(3750),
    [anon_sym_struct] = ACTIONS(3750),
    [anon_sym_union] = ACTIONS(3750),
    [anon_sym_if] = ACTIONS(3750),
    [anon_sym_switch] = ACTIONS(3750),
    [anon_sym_case] = ACTIONS(3750),
    [anon_sym_default] = ACTIONS(3750),
    [anon_sym_while] = ACTIONS(3750),
    [anon_sym_do] = ACTIONS(3750),
    [anon_sym_for] = ACTIONS(3750),
    [anon_sym_return] = ACTIONS(3750),
    [anon_sym_break] = ACTIONS(3750),
    [anon_sym_continue] = ACTIONS(3750),
    [anon_sym_goto] = ACTIONS(3750),
    [anon_sym_not] = ACTIONS(3750),
    [anon_sym_compl] = ACTIONS(3750),
    [anon_sym_DASH_DASH] = ACTIONS(3752),
    [anon_sym_PLUS_PLUS] = ACTIONS(3752),
    [anon_sym_sizeof] = ACTIONS(3750),
    [anon_sym___alignof__] = ACTIONS(3750),
    [anon_sym___alignof] = ACTIONS(3750),
    [anon_sym__alignof] = ACTIONS(3750),
    [anon_sym_alignof] = ACTIONS(3750),
    [anon_sym__Alignof] = ACTIONS(3750),
    [anon_sym_offsetof] = ACTIONS(3750),
    [anon_sym__Generic] = ACTIONS(3750),
    [anon_sym_asm] = ACTIONS(3750),
    [anon_sym___asm__] = ACTIONS(3750),
    [anon_sym_DOT] = ACTIONS(3750),
    [sym_number_literal] = ACTIONS(3752),
    [anon_sym_L_SQUOTE] = ACTIONS(3752),
    [anon_sym_u_SQUOTE] = ACTIONS(3752),
    [anon_sym_U_SQUOTE] = ACTIONS(3752),
    [anon_sym_u8_SQUOTE] = ACTIONS(3752),
    [anon_sym_SQUOTE] = ACTIONS(3752),
    [anon_sym_L_DQUOTE] = ACTIONS(3752),
    [anon_sym_u_DQUOTE] = ACTIONS(3752),
    [anon_sym_U_DQUOTE] = ACTIONS(3752),
    [anon_sym_u8_DQUOTE] = ACTIONS(3752),
    [anon_sym_DQUOTE] = ACTIONS(3752),
    [sym_true] = ACTIONS(3750),
    [sym_false] = ACTIONS(3750),
    [anon_sym_NULL] = ACTIONS(3750),
    [anon_sym_nullptr] = ACTIONS(3750),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3750),
    [anon_sym_let] = ACTIONS(3750),
    [anon_sym_This] = ACTIONS(3750),
    [anon_sym_decltype] = ACTIONS(3750),
    [sym_virtual] = ACTIONS(3750),
    [anon_sym_explicit] = ACTIONS(3750),
    [anon_sym_typename] = ACTIONS(3750),
    [anon_sym_template] = ACTIONS(3750),
    [anon_sym_operator] = ACTIONS(3750),
    [anon_sym_try] = ACTIONS(3750),
    [anon_sym_delete] = ACTIONS(3750),
    [anon_sym_throw] = ACTIONS(3750),
    [anon_sym_namespace] = ACTIONS(3750),
    [anon_sym_using] = ACTIONS(3750),
    [anon_sym_static_assert] = ACTIONS(3750),
    [anon_sym_concept] = ACTIONS(3750),
    [anon_sym_co_return] = ACTIONS(3750),
    [anon_sym_co_yield] = ACTIONS(3750),
    [anon_sym_R_DQUOTE] = ACTIONS(3752),
    [anon_sym_LR_DQUOTE] = ACTIONS(3752),
    [anon_sym_uR_DQUOTE] = ACTIONS(3752),
    [anon_sym_UR_DQUOTE] = ACTIONS(3752),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3752),
    [anon_sym_co_await] = ACTIONS(3750),
    [anon_sym_new] = ACTIONS(3750),
    [anon_sym_requires] = ACTIONS(3750),
    [sym_this] = ACTIONS(3750),
    [anon_sym_precise] = ACTIONS(3750),
    [anon_sym_shared] = ACTIONS(3750),
    [anon_sym_groupshared] = ACTIONS(3750),
    [anon_sym_uniform] = ACTIONS(3750),
    [anon_sym_row_major] = ACTIONS(3750),
    [anon_sym_column_major] = ACTIONS(3750),
    [anon_sym_globallycoherent] = ACTIONS(3750),
    [anon_sym_centroid] = ACTIONS(3750),
    [anon_sym_noperspective] = ACTIONS(3750),
    [anon_sym_nointerpolation] = ACTIONS(3750),
    [anon_sym_sample] = ACTIONS(3750),
    [anon_sym_linear] = ACTIONS(3750),
    [anon_sym_snorm] = ACTIONS(3750),
    [anon_sym_unorm] = ACTIONS(3750),
    [anon_sym_point] = ACTIONS(3750),
    [anon_sym_line] = ACTIONS(3750),
    [anon_sym_triangleadj] = ACTIONS(3750),
    [anon_sym_lineadj] = ACTIONS(3750),
    [anon_sym_triangle] = ACTIONS(3750),
    [anon_sym_interface] = ACTIONS(3750),
    [anon_sym_extension] = ACTIONS(3750),
    [anon_sym___exported] = ACTIONS(3750),
    [anon_sym_import] = ACTIONS(3750),
  },
  [847] = {
    [sym_identifier] = ACTIONS(3535),
    [aux_sym_preproc_include_token1] = ACTIONS(3535),
    [aux_sym_preproc_def_token1] = ACTIONS(3535),
    [aux_sym_preproc_if_token1] = ACTIONS(3535),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3535),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3535),
    [sym_preproc_directive] = ACTIONS(3535),
    [anon_sym_LPAREN2] = ACTIONS(3537),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3537),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym___extension__] = ACTIONS(3535),
    [anon_sym_typedef] = ACTIONS(3535),
    [anon_sym_in] = ACTIONS(3535),
    [anon_sym_out] = ACTIONS(3535),
    [anon_sym_inout] = ACTIONS(3535),
    [anon_sym_extern] = ACTIONS(3535),
    [anon_sym___attribute__] = ACTIONS(3535),
    [anon_sym_COLON_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3537),
    [anon_sym___declspec] = ACTIONS(3535),
    [anon_sym___based] = ACTIONS(3535),
    [anon_sym___cdecl] = ACTIONS(3535),
    [anon_sym___clrcall] = ACTIONS(3535),
    [anon_sym___stdcall] = ACTIONS(3535),
    [anon_sym___fastcall] = ACTIONS(3535),
    [anon_sym___thiscall] = ACTIONS(3535),
    [anon_sym___vectorcall] = ACTIONS(3535),
    [anon_sym_LBRACE] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_signed] = ACTIONS(3535),
    [anon_sym_unsigned] = ACTIONS(3535),
    [anon_sym_long] = ACTIONS(3535),
    [anon_sym_short] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_static] = ACTIONS(3535),
    [anon_sym_register] = ACTIONS(3535),
    [anon_sym_inline] = ACTIONS(3535),
    [anon_sym___inline] = ACTIONS(3535),
    [anon_sym___inline__] = ACTIONS(3535),
    [anon_sym___forceinline] = ACTIONS(3535),
    [anon_sym_thread_local] = ACTIONS(3535),
    [anon_sym___thread] = ACTIONS(3535),
    [anon_sym_const] = ACTIONS(3535),
    [anon_sym_constexpr] = ACTIONS(3535),
    [anon_sym_volatile] = ACTIONS(3535),
    [anon_sym_restrict] = ACTIONS(3535),
    [anon_sym___restrict__] = ACTIONS(3535),
    [anon_sym__Atomic] = ACTIONS(3535),
    [anon_sym__Noreturn] = ACTIONS(3535),
    [anon_sym_noreturn] = ACTIONS(3535),
    [anon_sym_mutable] = ACTIONS(3535),
    [anon_sym_constinit] = ACTIONS(3535),
    [anon_sym_consteval] = ACTIONS(3535),
    [anon_sym_alignas] = ACTIONS(3535),
    [anon_sym__Alignas] = ACTIONS(3535),
    [sym_primitive_type] = ACTIONS(3535),
    [anon_sym_enum] = ACTIONS(3535),
    [anon_sym_class] = ACTIONS(3535),
    [anon_sym_struct] = ACTIONS(3535),
    [anon_sym_union] = ACTIONS(3535),
    [anon_sym_if] = ACTIONS(3535),
    [anon_sym_switch] = ACTIONS(3535),
    [anon_sym_case] = ACTIONS(3535),
    [anon_sym_default] = ACTIONS(3535),
    [anon_sym_while] = ACTIONS(3535),
    [anon_sym_do] = ACTIONS(3535),
    [anon_sym_for] = ACTIONS(3535),
    [anon_sym_return] = ACTIONS(3535),
    [anon_sym_break] = ACTIONS(3535),
    [anon_sym_continue] = ACTIONS(3535),
    [anon_sym_goto] = ACTIONS(3535),
    [anon_sym___try] = ACTIONS(3535),
    [anon_sym___leave] = ACTIONS(3535),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_compl] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(3537),
    [anon_sym_PLUS_PLUS] = ACTIONS(3537),
    [anon_sym_sizeof] = ACTIONS(3535),
    [anon_sym___alignof__] = ACTIONS(3535),
    [anon_sym___alignof] = ACTIONS(3535),
    [anon_sym__alignof] = ACTIONS(3535),
    [anon_sym_alignof] = ACTIONS(3535),
    [anon_sym__Alignof] = ACTIONS(3535),
    [anon_sym_offsetof] = ACTIONS(3535),
    [anon_sym__Generic] = ACTIONS(3535),
    [anon_sym_asm] = ACTIONS(3535),
    [anon_sym___asm__] = ACTIONS(3535),
    [sym_number_literal] = ACTIONS(3537),
    [anon_sym_L_SQUOTE] = ACTIONS(3537),
    [anon_sym_u_SQUOTE] = ACTIONS(3537),
    [anon_sym_U_SQUOTE] = ACTIONS(3537),
    [anon_sym_u8_SQUOTE] = ACTIONS(3537),
    [anon_sym_SQUOTE] = ACTIONS(3537),
    [anon_sym_L_DQUOTE] = ACTIONS(3537),
    [anon_sym_u_DQUOTE] = ACTIONS(3537),
    [anon_sym_U_DQUOTE] = ACTIONS(3537),
    [anon_sym_u8_DQUOTE] = ACTIONS(3537),
    [anon_sym_DQUOTE] = ACTIONS(3537),
    [sym_true] = ACTIONS(3535),
    [sym_false] = ACTIONS(3535),
    [anon_sym_NULL] = ACTIONS(3535),
    [anon_sym_nullptr] = ACTIONS(3535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3535),
    [anon_sym_let] = ACTIONS(3535),
    [anon_sym_This] = ACTIONS(3535),
    [anon_sym_decltype] = ACTIONS(3535),
    [sym_virtual] = ACTIONS(3535),
    [anon_sym_explicit] = ACTIONS(3535),
    [anon_sym_typename] = ACTIONS(3535),
    [anon_sym_template] = ACTIONS(3535),
    [anon_sym_operator] = ACTIONS(3535),
    [anon_sym_try] = ACTIONS(3535),
    [anon_sym_delete] = ACTIONS(3535),
    [anon_sym_throw] = ACTIONS(3535),
    [anon_sym_namespace] = ACTIONS(3535),
    [anon_sym_using] = ACTIONS(3535),
    [anon_sym_static_assert] = ACTIONS(3535),
    [anon_sym_concept] = ACTIONS(3535),
    [anon_sym_co_return] = ACTIONS(3535),
    [anon_sym_co_yield] = ACTIONS(3535),
    [anon_sym_R_DQUOTE] = ACTIONS(3537),
    [anon_sym_LR_DQUOTE] = ACTIONS(3537),
    [anon_sym_uR_DQUOTE] = ACTIONS(3537),
    [anon_sym_UR_DQUOTE] = ACTIONS(3537),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3537),
    [anon_sym_co_await] = ACTIONS(3535),
    [anon_sym_new] = ACTIONS(3535),
    [anon_sym_requires] = ACTIONS(3535),
    [sym_this] = ACTIONS(3535),
    [anon_sym_discard] = ACTIONS(3535),
    [anon_sym_precise] = ACTIONS(3535),
    [anon_sym_shared] = ACTIONS(3535),
    [anon_sym_groupshared] = ACTIONS(3535),
    [anon_sym_uniform] = ACTIONS(3535),
    [anon_sym_row_major] = ACTIONS(3535),
    [anon_sym_column_major] = ACTIONS(3535),
    [anon_sym_globallycoherent] = ACTIONS(3535),
    [anon_sym_centroid] = ACTIONS(3535),
    [anon_sym_noperspective] = ACTIONS(3535),
    [anon_sym_nointerpolation] = ACTIONS(3535),
    [anon_sym_sample] = ACTIONS(3535),
    [anon_sym_linear] = ACTIONS(3535),
    [anon_sym_snorm] = ACTIONS(3535),
    [anon_sym_unorm] = ACTIONS(3535),
    [anon_sym_point] = ACTIONS(3535),
    [anon_sym_line] = ACTIONS(3535),
    [anon_sym_triangleadj] = ACTIONS(3535),
    [anon_sym_lineadj] = ACTIONS(3535),
    [anon_sym_triangle] = ACTIONS(3535),
    [anon_sym_cbuffer] = ACTIONS(3535),
    [anon_sym_interface] = ACTIONS(3535),
    [anon_sym_extension] = ACTIONS(3535),
  },
  [848] = {
    [sym_identifier] = ACTIONS(3406),
    [aux_sym_preproc_include_token1] = ACTIONS(3406),
    [aux_sym_preproc_def_token1] = ACTIONS(3406),
    [aux_sym_preproc_if_token1] = ACTIONS(3406),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3406),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3406),
    [sym_preproc_directive] = ACTIONS(3406),
    [anon_sym_LPAREN2] = ACTIONS(3408),
    [anon_sym_BANG] = ACTIONS(3408),
    [anon_sym_TILDE] = ACTIONS(3408),
    [anon_sym_DASH] = ACTIONS(3406),
    [anon_sym_PLUS] = ACTIONS(3406),
    [anon_sym_STAR] = ACTIONS(3408),
    [anon_sym_AMP_AMP] = ACTIONS(3408),
    [anon_sym_AMP] = ACTIONS(3406),
    [anon_sym_SEMI] = ACTIONS(3408),
    [anon_sym___extension__] = ACTIONS(3406),
    [anon_sym_typedef] = ACTIONS(3406),
    [anon_sym_in] = ACTIONS(3406),
    [anon_sym_out] = ACTIONS(3406),
    [anon_sym_inout] = ACTIONS(3406),
    [anon_sym_extern] = ACTIONS(3406),
    [anon_sym___attribute__] = ACTIONS(3406),
    [anon_sym_COLON_COLON] = ACTIONS(3408),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3408),
    [anon_sym___declspec] = ACTIONS(3406),
    [anon_sym___based] = ACTIONS(3406),
    [anon_sym___cdecl] = ACTIONS(3406),
    [anon_sym___clrcall] = ACTIONS(3406),
    [anon_sym___stdcall] = ACTIONS(3406),
    [anon_sym___fastcall] = ACTIONS(3406),
    [anon_sym___thiscall] = ACTIONS(3406),
    [anon_sym___vectorcall] = ACTIONS(3406),
    [anon_sym_LBRACE] = ACTIONS(3408),
    [anon_sym_RBRACE] = ACTIONS(3408),
    [anon_sym_signed] = ACTIONS(3406),
    [anon_sym_unsigned] = ACTIONS(3406),
    [anon_sym_long] = ACTIONS(3406),
    [anon_sym_short] = ACTIONS(3406),
    [anon_sym_LBRACK] = ACTIONS(3406),
    [anon_sym_static] = ACTIONS(3406),
    [anon_sym_register] = ACTIONS(3406),
    [anon_sym_inline] = ACTIONS(3406),
    [anon_sym___inline] = ACTIONS(3406),
    [anon_sym___inline__] = ACTIONS(3406),
    [anon_sym___forceinline] = ACTIONS(3406),
    [anon_sym_thread_local] = ACTIONS(3406),
    [anon_sym___thread] = ACTIONS(3406),
    [anon_sym_const] = ACTIONS(3406),
    [anon_sym_constexpr] = ACTIONS(3406),
    [anon_sym_volatile] = ACTIONS(3406),
    [anon_sym_restrict] = ACTIONS(3406),
    [anon_sym___restrict__] = ACTIONS(3406),
    [anon_sym__Atomic] = ACTIONS(3406),
    [anon_sym__Noreturn] = ACTIONS(3406),
    [anon_sym_noreturn] = ACTIONS(3406),
    [anon_sym_mutable] = ACTIONS(3406),
    [anon_sym_constinit] = ACTIONS(3406),
    [anon_sym_consteval] = ACTIONS(3406),
    [anon_sym_alignas] = ACTIONS(3406),
    [anon_sym__Alignas] = ACTIONS(3406),
    [sym_primitive_type] = ACTIONS(3406),
    [anon_sym_enum] = ACTIONS(3406),
    [anon_sym_class] = ACTIONS(3406),
    [anon_sym_struct] = ACTIONS(3406),
    [anon_sym_union] = ACTIONS(3406),
    [anon_sym_if] = ACTIONS(3406),
    [anon_sym_switch] = ACTIONS(3406),
    [anon_sym_case] = ACTIONS(3406),
    [anon_sym_default] = ACTIONS(3406),
    [anon_sym_while] = ACTIONS(3406),
    [anon_sym_do] = ACTIONS(3406),
    [anon_sym_for] = ACTIONS(3406),
    [anon_sym_return] = ACTIONS(3406),
    [anon_sym_break] = ACTIONS(3406),
    [anon_sym_continue] = ACTIONS(3406),
    [anon_sym_goto] = ACTIONS(3406),
    [anon_sym___try] = ACTIONS(3406),
    [anon_sym___leave] = ACTIONS(3406),
    [anon_sym_not] = ACTIONS(3406),
    [anon_sym_compl] = ACTIONS(3406),
    [anon_sym_DASH_DASH] = ACTIONS(3408),
    [anon_sym_PLUS_PLUS] = ACTIONS(3408),
    [anon_sym_sizeof] = ACTIONS(3406),
    [anon_sym___alignof__] = ACTIONS(3406),
    [anon_sym___alignof] = ACTIONS(3406),
    [anon_sym__alignof] = ACTIONS(3406),
    [anon_sym_alignof] = ACTIONS(3406),
    [anon_sym__Alignof] = ACTIONS(3406),
    [anon_sym_offsetof] = ACTIONS(3406),
    [anon_sym__Generic] = ACTIONS(3406),
    [anon_sym_asm] = ACTIONS(3406),
    [anon_sym___asm__] = ACTIONS(3406),
    [sym_number_literal] = ACTIONS(3408),
    [anon_sym_L_SQUOTE] = ACTIONS(3408),
    [anon_sym_u_SQUOTE] = ACTIONS(3408),
    [anon_sym_U_SQUOTE] = ACTIONS(3408),
    [anon_sym_u8_SQUOTE] = ACTIONS(3408),
    [anon_sym_SQUOTE] = ACTIONS(3408),
    [anon_sym_L_DQUOTE] = ACTIONS(3408),
    [anon_sym_u_DQUOTE] = ACTIONS(3408),
    [anon_sym_U_DQUOTE] = ACTIONS(3408),
    [anon_sym_u8_DQUOTE] = ACTIONS(3408),
    [anon_sym_DQUOTE] = ACTIONS(3408),
    [sym_true] = ACTIONS(3406),
    [sym_false] = ACTIONS(3406),
    [anon_sym_NULL] = ACTIONS(3406),
    [anon_sym_nullptr] = ACTIONS(3406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3406),
    [anon_sym_let] = ACTIONS(3406),
    [anon_sym_This] = ACTIONS(3406),
    [anon_sym_decltype] = ACTIONS(3406),
    [sym_virtual] = ACTIONS(3406),
    [anon_sym_explicit] = ACTIONS(3406),
    [anon_sym_typename] = ACTIONS(3406),
    [anon_sym_template] = ACTIONS(3406),
    [anon_sym_operator] = ACTIONS(3406),
    [anon_sym_try] = ACTIONS(3406),
    [anon_sym_delete] = ACTIONS(3406),
    [anon_sym_throw] = ACTIONS(3406),
    [anon_sym_namespace] = ACTIONS(3406),
    [anon_sym_using] = ACTIONS(3406),
    [anon_sym_static_assert] = ACTIONS(3406),
    [anon_sym_concept] = ACTIONS(3406),
    [anon_sym_co_return] = ACTIONS(3406),
    [anon_sym_co_yield] = ACTIONS(3406),
    [anon_sym_R_DQUOTE] = ACTIONS(3408),
    [anon_sym_LR_DQUOTE] = ACTIONS(3408),
    [anon_sym_uR_DQUOTE] = ACTIONS(3408),
    [anon_sym_UR_DQUOTE] = ACTIONS(3408),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3408),
    [anon_sym_co_await] = ACTIONS(3406),
    [anon_sym_new] = ACTIONS(3406),
    [anon_sym_requires] = ACTIONS(3406),
    [sym_this] = ACTIONS(3406),
    [anon_sym_discard] = ACTIONS(3406),
    [anon_sym_precise] = ACTIONS(3406),
    [anon_sym_shared] = ACTIONS(3406),
    [anon_sym_groupshared] = ACTIONS(3406),
    [anon_sym_uniform] = ACTIONS(3406),
    [anon_sym_row_major] = ACTIONS(3406),
    [anon_sym_column_major] = ACTIONS(3406),
    [anon_sym_globallycoherent] = ACTIONS(3406),
    [anon_sym_centroid] = ACTIONS(3406),
    [anon_sym_noperspective] = ACTIONS(3406),
    [anon_sym_nointerpolation] = ACTIONS(3406),
    [anon_sym_sample] = ACTIONS(3406),
    [anon_sym_linear] = ACTIONS(3406),
    [anon_sym_snorm] = ACTIONS(3406),
    [anon_sym_unorm] = ACTIONS(3406),
    [anon_sym_point] = ACTIONS(3406),
    [anon_sym_line] = ACTIONS(3406),
    [anon_sym_triangleadj] = ACTIONS(3406),
    [anon_sym_lineadj] = ACTIONS(3406),
    [anon_sym_triangle] = ACTIONS(3406),
    [anon_sym_cbuffer] = ACTIONS(3406),
    [anon_sym_interface] = ACTIONS(3406),
    [anon_sym_extension] = ACTIONS(3406),
  },
  [849] = {
    [sym_identifier] = ACTIONS(3583),
    [aux_sym_preproc_include_token1] = ACTIONS(3583),
    [aux_sym_preproc_def_token1] = ACTIONS(3583),
    [aux_sym_preproc_if_token1] = ACTIONS(3583),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3583),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3583),
    [sym_preproc_directive] = ACTIONS(3583),
    [anon_sym_LPAREN2] = ACTIONS(3585),
    [anon_sym_BANG] = ACTIONS(3585),
    [anon_sym_TILDE] = ACTIONS(3585),
    [anon_sym_DASH] = ACTIONS(3583),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_STAR] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3583),
    [anon_sym_SEMI] = ACTIONS(3585),
    [anon_sym___extension__] = ACTIONS(3583),
    [anon_sym_typedef] = ACTIONS(3583),
    [anon_sym_in] = ACTIONS(3583),
    [anon_sym_out] = ACTIONS(3583),
    [anon_sym_inout] = ACTIONS(3583),
    [anon_sym_extern] = ACTIONS(3583),
    [anon_sym___attribute__] = ACTIONS(3583),
    [anon_sym_COLON_COLON] = ACTIONS(3585),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3585),
    [anon_sym___declspec] = ACTIONS(3583),
    [anon_sym___based] = ACTIONS(3583),
    [anon_sym___cdecl] = ACTIONS(3583),
    [anon_sym___clrcall] = ACTIONS(3583),
    [anon_sym___stdcall] = ACTIONS(3583),
    [anon_sym___fastcall] = ACTIONS(3583),
    [anon_sym___thiscall] = ACTIONS(3583),
    [anon_sym___vectorcall] = ACTIONS(3583),
    [anon_sym_LBRACE] = ACTIONS(3585),
    [anon_sym_RBRACE] = ACTIONS(3585),
    [anon_sym_signed] = ACTIONS(3583),
    [anon_sym_unsigned] = ACTIONS(3583),
    [anon_sym_long] = ACTIONS(3583),
    [anon_sym_short] = ACTIONS(3583),
    [anon_sym_LBRACK] = ACTIONS(3583),
    [anon_sym_static] = ACTIONS(3583),
    [anon_sym_register] = ACTIONS(3583),
    [anon_sym_inline] = ACTIONS(3583),
    [anon_sym___inline] = ACTIONS(3583),
    [anon_sym___inline__] = ACTIONS(3583),
    [anon_sym___forceinline] = ACTIONS(3583),
    [anon_sym_thread_local] = ACTIONS(3583),
    [anon_sym___thread] = ACTIONS(3583),
    [anon_sym_const] = ACTIONS(3583),
    [anon_sym_constexpr] = ACTIONS(3583),
    [anon_sym_volatile] = ACTIONS(3583),
    [anon_sym_restrict] = ACTIONS(3583),
    [anon_sym___restrict__] = ACTIONS(3583),
    [anon_sym__Atomic] = ACTIONS(3583),
    [anon_sym__Noreturn] = ACTIONS(3583),
    [anon_sym_noreturn] = ACTIONS(3583),
    [anon_sym_mutable] = ACTIONS(3583),
    [anon_sym_constinit] = ACTIONS(3583),
    [anon_sym_consteval] = ACTIONS(3583),
    [anon_sym_alignas] = ACTIONS(3583),
    [anon_sym__Alignas] = ACTIONS(3583),
    [sym_primitive_type] = ACTIONS(3583),
    [anon_sym_enum] = ACTIONS(3583),
    [anon_sym_class] = ACTIONS(3583),
    [anon_sym_struct] = ACTIONS(3583),
    [anon_sym_union] = ACTIONS(3583),
    [anon_sym_if] = ACTIONS(3583),
    [anon_sym_switch] = ACTIONS(3583),
    [anon_sym_case] = ACTIONS(3583),
    [anon_sym_default] = ACTIONS(3583),
    [anon_sym_while] = ACTIONS(3583),
    [anon_sym_do] = ACTIONS(3583),
    [anon_sym_for] = ACTIONS(3583),
    [anon_sym_return] = ACTIONS(3583),
    [anon_sym_break] = ACTIONS(3583),
    [anon_sym_continue] = ACTIONS(3583),
    [anon_sym_goto] = ACTIONS(3583),
    [anon_sym___try] = ACTIONS(3583),
    [anon_sym___leave] = ACTIONS(3583),
    [anon_sym_not] = ACTIONS(3583),
    [anon_sym_compl] = ACTIONS(3583),
    [anon_sym_DASH_DASH] = ACTIONS(3585),
    [anon_sym_PLUS_PLUS] = ACTIONS(3585),
    [anon_sym_sizeof] = ACTIONS(3583),
    [anon_sym___alignof__] = ACTIONS(3583),
    [anon_sym___alignof] = ACTIONS(3583),
    [anon_sym__alignof] = ACTIONS(3583),
    [anon_sym_alignof] = ACTIONS(3583),
    [anon_sym__Alignof] = ACTIONS(3583),
    [anon_sym_offsetof] = ACTIONS(3583),
    [anon_sym__Generic] = ACTIONS(3583),
    [anon_sym_asm] = ACTIONS(3583),
    [anon_sym___asm__] = ACTIONS(3583),
    [sym_number_literal] = ACTIONS(3585),
    [anon_sym_L_SQUOTE] = ACTIONS(3585),
    [anon_sym_u_SQUOTE] = ACTIONS(3585),
    [anon_sym_U_SQUOTE] = ACTIONS(3585),
    [anon_sym_u8_SQUOTE] = ACTIONS(3585),
    [anon_sym_SQUOTE] = ACTIONS(3585),
    [anon_sym_L_DQUOTE] = ACTIONS(3585),
    [anon_sym_u_DQUOTE] = ACTIONS(3585),
    [anon_sym_U_DQUOTE] = ACTIONS(3585),
    [anon_sym_u8_DQUOTE] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [sym_true] = ACTIONS(3583),
    [sym_false] = ACTIONS(3583),
    [anon_sym_NULL] = ACTIONS(3583),
    [anon_sym_nullptr] = ACTIONS(3583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3583),
    [anon_sym_let] = ACTIONS(3583),
    [anon_sym_This] = ACTIONS(3583),
    [anon_sym_decltype] = ACTIONS(3583),
    [sym_virtual] = ACTIONS(3583),
    [anon_sym_explicit] = ACTIONS(3583),
    [anon_sym_typename] = ACTIONS(3583),
    [anon_sym_template] = ACTIONS(3583),
    [anon_sym_operator] = ACTIONS(3583),
    [anon_sym_try] = ACTIONS(3583),
    [anon_sym_delete] = ACTIONS(3583),
    [anon_sym_throw] = ACTIONS(3583),
    [anon_sym_namespace] = ACTIONS(3583),
    [anon_sym_using] = ACTIONS(3583),
    [anon_sym_static_assert] = ACTIONS(3583),
    [anon_sym_concept] = ACTIONS(3583),
    [anon_sym_co_return] = ACTIONS(3583),
    [anon_sym_co_yield] = ACTIONS(3583),
    [anon_sym_R_DQUOTE] = ACTIONS(3585),
    [anon_sym_LR_DQUOTE] = ACTIONS(3585),
    [anon_sym_uR_DQUOTE] = ACTIONS(3585),
    [anon_sym_UR_DQUOTE] = ACTIONS(3585),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3585),
    [anon_sym_co_await] = ACTIONS(3583),
    [anon_sym_new] = ACTIONS(3583),
    [anon_sym_requires] = ACTIONS(3583),
    [sym_this] = ACTIONS(3583),
    [anon_sym_discard] = ACTIONS(3583),
    [anon_sym_precise] = ACTIONS(3583),
    [anon_sym_shared] = ACTIONS(3583),
    [anon_sym_groupshared] = ACTIONS(3583),
    [anon_sym_uniform] = ACTIONS(3583),
    [anon_sym_row_major] = ACTIONS(3583),
    [anon_sym_column_major] = ACTIONS(3583),
    [anon_sym_globallycoherent] = ACTIONS(3583),
    [anon_sym_centroid] = ACTIONS(3583),
    [anon_sym_noperspective] = ACTIONS(3583),
    [anon_sym_nointerpolation] = ACTIONS(3583),
    [anon_sym_sample] = ACTIONS(3583),
    [anon_sym_linear] = ACTIONS(3583),
    [anon_sym_snorm] = ACTIONS(3583),
    [anon_sym_unorm] = ACTIONS(3583),
    [anon_sym_point] = ACTIONS(3583),
    [anon_sym_line] = ACTIONS(3583),
    [anon_sym_triangleadj] = ACTIONS(3583),
    [anon_sym_lineadj] = ACTIONS(3583),
    [anon_sym_triangle] = ACTIONS(3583),
    [anon_sym_cbuffer] = ACTIONS(3583),
    [anon_sym_interface] = ACTIONS(3583),
    [anon_sym_extension] = ACTIONS(3583),
  },
  [850] = {
    [sym_identifier] = ACTIONS(3579),
    [aux_sym_preproc_include_token1] = ACTIONS(3579),
    [aux_sym_preproc_def_token1] = ACTIONS(3579),
    [aux_sym_preproc_if_token1] = ACTIONS(3579),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3579),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3579),
    [sym_preproc_directive] = ACTIONS(3579),
    [anon_sym_LPAREN2] = ACTIONS(3581),
    [anon_sym_BANG] = ACTIONS(3581),
    [anon_sym_TILDE] = ACTIONS(3581),
    [anon_sym_DASH] = ACTIONS(3579),
    [anon_sym_PLUS] = ACTIONS(3579),
    [anon_sym_STAR] = ACTIONS(3581),
    [anon_sym_AMP_AMP] = ACTIONS(3581),
    [anon_sym_AMP] = ACTIONS(3579),
    [anon_sym_SEMI] = ACTIONS(3581),
    [anon_sym___extension__] = ACTIONS(3579),
    [anon_sym_typedef] = ACTIONS(3579),
    [anon_sym_in] = ACTIONS(3579),
    [anon_sym_out] = ACTIONS(3579),
    [anon_sym_inout] = ACTIONS(3579),
    [anon_sym_extern] = ACTIONS(3579),
    [anon_sym___attribute__] = ACTIONS(3579),
    [anon_sym_COLON_COLON] = ACTIONS(3581),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3581),
    [anon_sym___declspec] = ACTIONS(3579),
    [anon_sym___based] = ACTIONS(3579),
    [anon_sym___cdecl] = ACTIONS(3579),
    [anon_sym___clrcall] = ACTIONS(3579),
    [anon_sym___stdcall] = ACTIONS(3579),
    [anon_sym___fastcall] = ACTIONS(3579),
    [anon_sym___thiscall] = ACTIONS(3579),
    [anon_sym___vectorcall] = ACTIONS(3579),
    [anon_sym_LBRACE] = ACTIONS(3581),
    [anon_sym_RBRACE] = ACTIONS(3581),
    [anon_sym_signed] = ACTIONS(3579),
    [anon_sym_unsigned] = ACTIONS(3579),
    [anon_sym_long] = ACTIONS(3579),
    [anon_sym_short] = ACTIONS(3579),
    [anon_sym_LBRACK] = ACTIONS(3579),
    [anon_sym_static] = ACTIONS(3579),
    [anon_sym_register] = ACTIONS(3579),
    [anon_sym_inline] = ACTIONS(3579),
    [anon_sym___inline] = ACTIONS(3579),
    [anon_sym___inline__] = ACTIONS(3579),
    [anon_sym___forceinline] = ACTIONS(3579),
    [anon_sym_thread_local] = ACTIONS(3579),
    [anon_sym___thread] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3579),
    [anon_sym_constexpr] = ACTIONS(3579),
    [anon_sym_volatile] = ACTIONS(3579),
    [anon_sym_restrict] = ACTIONS(3579),
    [anon_sym___restrict__] = ACTIONS(3579),
    [anon_sym__Atomic] = ACTIONS(3579),
    [anon_sym__Noreturn] = ACTIONS(3579),
    [anon_sym_noreturn] = ACTIONS(3579),
    [anon_sym_mutable] = ACTIONS(3579),
    [anon_sym_constinit] = ACTIONS(3579),
    [anon_sym_consteval] = ACTIONS(3579),
    [anon_sym_alignas] = ACTIONS(3579),
    [anon_sym__Alignas] = ACTIONS(3579),
    [sym_primitive_type] = ACTIONS(3579),
    [anon_sym_enum] = ACTIONS(3579),
    [anon_sym_class] = ACTIONS(3579),
    [anon_sym_struct] = ACTIONS(3579),
    [anon_sym_union] = ACTIONS(3579),
    [anon_sym_if] = ACTIONS(3579),
    [anon_sym_switch] = ACTIONS(3579),
    [anon_sym_case] = ACTIONS(3579),
    [anon_sym_default] = ACTIONS(3579),
    [anon_sym_while] = ACTIONS(3579),
    [anon_sym_do] = ACTIONS(3579),
    [anon_sym_for] = ACTIONS(3579),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_break] = ACTIONS(3579),
    [anon_sym_continue] = ACTIONS(3579),
    [anon_sym_goto] = ACTIONS(3579),
    [anon_sym___try] = ACTIONS(3579),
    [anon_sym___leave] = ACTIONS(3579),
    [anon_sym_not] = ACTIONS(3579),
    [anon_sym_compl] = ACTIONS(3579),
    [anon_sym_DASH_DASH] = ACTIONS(3581),
    [anon_sym_PLUS_PLUS] = ACTIONS(3581),
    [anon_sym_sizeof] = ACTIONS(3579),
    [anon_sym___alignof__] = ACTIONS(3579),
    [anon_sym___alignof] = ACTIONS(3579),
    [anon_sym__alignof] = ACTIONS(3579),
    [anon_sym_alignof] = ACTIONS(3579),
    [anon_sym__Alignof] = ACTIONS(3579),
    [anon_sym_offsetof] = ACTIONS(3579),
    [anon_sym__Generic] = ACTIONS(3579),
    [anon_sym_asm] = ACTIONS(3579),
    [anon_sym___asm__] = ACTIONS(3579),
    [sym_number_literal] = ACTIONS(3581),
    [anon_sym_L_SQUOTE] = ACTIONS(3581),
    [anon_sym_u_SQUOTE] = ACTIONS(3581),
    [anon_sym_U_SQUOTE] = ACTIONS(3581),
    [anon_sym_u8_SQUOTE] = ACTIONS(3581),
    [anon_sym_SQUOTE] = ACTIONS(3581),
    [anon_sym_L_DQUOTE] = ACTIONS(3581),
    [anon_sym_u_DQUOTE] = ACTIONS(3581),
    [anon_sym_U_DQUOTE] = ACTIONS(3581),
    [anon_sym_u8_DQUOTE] = ACTIONS(3581),
    [anon_sym_DQUOTE] = ACTIONS(3581),
    [sym_true] = ACTIONS(3579),
    [sym_false] = ACTIONS(3579),
    [anon_sym_NULL] = ACTIONS(3579),
    [anon_sym_nullptr] = ACTIONS(3579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3579),
    [anon_sym_let] = ACTIONS(3579),
    [anon_sym_This] = ACTIONS(3579),
    [anon_sym_decltype] = ACTIONS(3579),
    [sym_virtual] = ACTIONS(3579),
    [anon_sym_explicit] = ACTIONS(3579),
    [anon_sym_typename] = ACTIONS(3579),
    [anon_sym_template] = ACTIONS(3579),
    [anon_sym_operator] = ACTIONS(3579),
    [anon_sym_try] = ACTIONS(3579),
    [anon_sym_delete] = ACTIONS(3579),
    [anon_sym_throw] = ACTIONS(3579),
    [anon_sym_namespace] = ACTIONS(3579),
    [anon_sym_using] = ACTIONS(3579),
    [anon_sym_static_assert] = ACTIONS(3579),
    [anon_sym_concept] = ACTIONS(3579),
    [anon_sym_co_return] = ACTIONS(3579),
    [anon_sym_co_yield] = ACTIONS(3579),
    [anon_sym_R_DQUOTE] = ACTIONS(3581),
    [anon_sym_LR_DQUOTE] = ACTIONS(3581),
    [anon_sym_uR_DQUOTE] = ACTIONS(3581),
    [anon_sym_UR_DQUOTE] = ACTIONS(3581),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3581),
    [anon_sym_co_await] = ACTIONS(3579),
    [anon_sym_new] = ACTIONS(3579),
    [anon_sym_requires] = ACTIONS(3579),
    [sym_this] = ACTIONS(3579),
    [anon_sym_discard] = ACTIONS(3579),
    [anon_sym_precise] = ACTIONS(3579),
    [anon_sym_shared] = ACTIONS(3579),
    [anon_sym_groupshared] = ACTIONS(3579),
    [anon_sym_uniform] = ACTIONS(3579),
    [anon_sym_row_major] = ACTIONS(3579),
    [anon_sym_column_major] = ACTIONS(3579),
    [anon_sym_globallycoherent] = ACTIONS(3579),
    [anon_sym_centroid] = ACTIONS(3579),
    [anon_sym_noperspective] = ACTIONS(3579),
    [anon_sym_nointerpolation] = ACTIONS(3579),
    [anon_sym_sample] = ACTIONS(3579),
    [anon_sym_linear] = ACTIONS(3579),
    [anon_sym_snorm] = ACTIONS(3579),
    [anon_sym_unorm] = ACTIONS(3579),
    [anon_sym_point] = ACTIONS(3579),
    [anon_sym_line] = ACTIONS(3579),
    [anon_sym_triangleadj] = ACTIONS(3579),
    [anon_sym_lineadj] = ACTIONS(3579),
    [anon_sym_triangle] = ACTIONS(3579),
    [anon_sym_cbuffer] = ACTIONS(3579),
    [anon_sym_interface] = ACTIONS(3579),
    [anon_sym_extension] = ACTIONS(3579),
  },
  [851] = {
    [sym_identifier] = ACTIONS(3591),
    [aux_sym_preproc_include_token1] = ACTIONS(3591),
    [aux_sym_preproc_def_token1] = ACTIONS(3591),
    [aux_sym_preproc_if_token1] = ACTIONS(3591),
    [aux_sym_preproc_if_token2] = ACTIONS(3591),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3591),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3591),
    [sym_preproc_directive] = ACTIONS(3591),
    [anon_sym_LPAREN2] = ACTIONS(3594),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [anon_sym_DASH] = ACTIONS(3591),
    [anon_sym_PLUS] = ACTIONS(3591),
    [anon_sym_STAR] = ACTIONS(3594),
    [anon_sym_AMP_AMP] = ACTIONS(3594),
    [anon_sym_AMP] = ACTIONS(3591),
    [anon_sym_SEMI] = ACTIONS(3594),
    [anon_sym___extension__] = ACTIONS(3591),
    [anon_sym_typedef] = ACTIONS(3591),
    [anon_sym_in] = ACTIONS(3591),
    [anon_sym_out] = ACTIONS(3591),
    [anon_sym_inout] = ACTIONS(3591),
    [anon_sym_extern] = ACTIONS(3591),
    [anon_sym___attribute__] = ACTIONS(3591),
    [anon_sym_COLON_COLON] = ACTIONS(3594),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3594),
    [anon_sym___declspec] = ACTIONS(3591),
    [anon_sym___based] = ACTIONS(3591),
    [anon_sym___cdecl] = ACTIONS(3591),
    [anon_sym___clrcall] = ACTIONS(3591),
    [anon_sym___stdcall] = ACTIONS(3591),
    [anon_sym___fastcall] = ACTIONS(3591),
    [anon_sym___thiscall] = ACTIONS(3591),
    [anon_sym___vectorcall] = ACTIONS(3591),
    [anon_sym_LBRACE] = ACTIONS(3594),
    [anon_sym_signed] = ACTIONS(3591),
    [anon_sym_unsigned] = ACTIONS(3591),
    [anon_sym_long] = ACTIONS(3591),
    [anon_sym_short] = ACTIONS(3591),
    [anon_sym_LBRACK] = ACTIONS(3591),
    [anon_sym_static] = ACTIONS(3591),
    [anon_sym_register] = ACTIONS(3591),
    [anon_sym_inline] = ACTIONS(3591),
    [anon_sym___inline] = ACTIONS(3591),
    [anon_sym___inline__] = ACTIONS(3591),
    [anon_sym___forceinline] = ACTIONS(3591),
    [anon_sym_thread_local] = ACTIONS(3591),
    [anon_sym___thread] = ACTIONS(3591),
    [anon_sym_const] = ACTIONS(3591),
    [anon_sym_constexpr] = ACTIONS(3591),
    [anon_sym_volatile] = ACTIONS(3591),
    [anon_sym_restrict] = ACTIONS(3591),
    [anon_sym___restrict__] = ACTIONS(3591),
    [anon_sym__Atomic] = ACTIONS(3591),
    [anon_sym__Noreturn] = ACTIONS(3591),
    [anon_sym_noreturn] = ACTIONS(3591),
    [anon_sym_mutable] = ACTIONS(3591),
    [anon_sym_constinit] = ACTIONS(3591),
    [anon_sym_consteval] = ACTIONS(3591),
    [anon_sym_alignas] = ACTIONS(3591),
    [anon_sym__Alignas] = ACTIONS(3591),
    [sym_primitive_type] = ACTIONS(3591),
    [anon_sym_enum] = ACTIONS(3591),
    [anon_sym_class] = ACTIONS(3591),
    [anon_sym_struct] = ACTIONS(3591),
    [anon_sym_union] = ACTIONS(3591),
    [anon_sym_if] = ACTIONS(3591),
    [anon_sym_switch] = ACTIONS(3591),
    [anon_sym_case] = ACTIONS(3591),
    [anon_sym_default] = ACTIONS(3591),
    [anon_sym_while] = ACTIONS(3591),
    [anon_sym_do] = ACTIONS(3591),
    [anon_sym_for] = ACTIONS(3591),
    [anon_sym_return] = ACTIONS(3591),
    [anon_sym_break] = ACTIONS(3591),
    [anon_sym_continue] = ACTIONS(3591),
    [anon_sym_goto] = ACTIONS(3591),
    [anon_sym___try] = ACTIONS(3591),
    [anon_sym___leave] = ACTIONS(3591),
    [anon_sym_not] = ACTIONS(3591),
    [anon_sym_compl] = ACTIONS(3591),
    [anon_sym_DASH_DASH] = ACTIONS(3594),
    [anon_sym_PLUS_PLUS] = ACTIONS(3594),
    [anon_sym_sizeof] = ACTIONS(3591),
    [anon_sym___alignof__] = ACTIONS(3591),
    [anon_sym___alignof] = ACTIONS(3591),
    [anon_sym__alignof] = ACTIONS(3591),
    [anon_sym_alignof] = ACTIONS(3591),
    [anon_sym__Alignof] = ACTIONS(3591),
    [anon_sym_offsetof] = ACTIONS(3591),
    [anon_sym__Generic] = ACTIONS(3591),
    [anon_sym_asm] = ACTIONS(3591),
    [anon_sym___asm__] = ACTIONS(3591),
    [sym_number_literal] = ACTIONS(3594),
    [anon_sym_L_SQUOTE] = ACTIONS(3594),
    [anon_sym_u_SQUOTE] = ACTIONS(3594),
    [anon_sym_U_SQUOTE] = ACTIONS(3594),
    [anon_sym_u8_SQUOTE] = ACTIONS(3594),
    [anon_sym_SQUOTE] = ACTIONS(3594),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_true] = ACTIONS(3591),
    [sym_false] = ACTIONS(3591),
    [anon_sym_NULL] = ACTIONS(3591),
    [anon_sym_nullptr] = ACTIONS(3591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3591),
    [anon_sym_let] = ACTIONS(3591),
    [anon_sym_This] = ACTIONS(3591),
    [anon_sym_decltype] = ACTIONS(3591),
    [sym_virtual] = ACTIONS(3591),
    [anon_sym_explicit] = ACTIONS(3591),
    [anon_sym_typename] = ACTIONS(3591),
    [anon_sym_template] = ACTIONS(3591),
    [anon_sym_operator] = ACTIONS(3591),
    [anon_sym_try] = ACTIONS(3591),
    [anon_sym_delete] = ACTIONS(3591),
    [anon_sym_throw] = ACTIONS(3591),
    [anon_sym_namespace] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3591),
    [anon_sym_static_assert] = ACTIONS(3591),
    [anon_sym_concept] = ACTIONS(3591),
    [anon_sym_co_return] = ACTIONS(3591),
    [anon_sym_co_yield] = ACTIONS(3591),
    [anon_sym_R_DQUOTE] = ACTIONS(3594),
    [anon_sym_LR_DQUOTE] = ACTIONS(3594),
    [anon_sym_uR_DQUOTE] = ACTIONS(3594),
    [anon_sym_UR_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3594),
    [anon_sym_co_await] = ACTIONS(3591),
    [anon_sym_new] = ACTIONS(3591),
    [anon_sym_requires] = ACTIONS(3591),
    [sym_this] = ACTIONS(3591),
    [anon_sym_discard] = ACTIONS(3591),
    [anon_sym_precise] = ACTIONS(3591),
    [anon_sym_shared] = ACTIONS(3591),
    [anon_sym_groupshared] = ACTIONS(3591),
    [anon_sym_uniform] = ACTIONS(3591),
    [anon_sym_row_major] = ACTIONS(3591),
    [anon_sym_column_major] = ACTIONS(3591),
    [anon_sym_globallycoherent] = ACTIONS(3591),
    [anon_sym_centroid] = ACTIONS(3591),
    [anon_sym_noperspective] = ACTIONS(3591),
    [anon_sym_nointerpolation] = ACTIONS(3591),
    [anon_sym_sample] = ACTIONS(3591),
    [anon_sym_linear] = ACTIONS(3591),
    [anon_sym_snorm] = ACTIONS(3591),
    [anon_sym_unorm] = ACTIONS(3591),
    [anon_sym_point] = ACTIONS(3591),
    [anon_sym_line] = ACTIONS(3591),
    [anon_sym_triangleadj] = ACTIONS(3591),
    [anon_sym_lineadj] = ACTIONS(3591),
    [anon_sym_triangle] = ACTIONS(3591),
    [anon_sym_cbuffer] = ACTIONS(3591),
    [anon_sym_interface] = ACTIONS(3591),
    [anon_sym_extension] = ACTIONS(3591),
  },
  [852] = {
    [sym_attribute_specifier] = STATE(385),
    [ts_builtin_sym_end] = ACTIONS(3744),
    [sym_identifier] = ACTIONS(3742),
    [aux_sym_preproc_include_token1] = ACTIONS(3742),
    [aux_sym_preproc_def_token1] = ACTIONS(3742),
    [aux_sym_preproc_if_token1] = ACTIONS(3742),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3742),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3742),
    [sym_preproc_directive] = ACTIONS(3742),
    [anon_sym_LPAREN2] = ACTIONS(3744),
    [anon_sym_BANG] = ACTIONS(3744),
    [anon_sym_TILDE] = ACTIONS(3744),
    [anon_sym_DASH] = ACTIONS(3742),
    [anon_sym_PLUS] = ACTIONS(3742),
    [anon_sym_STAR] = ACTIONS(3744),
    [anon_sym_AMP_AMP] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(3742),
    [anon_sym_SEMI] = ACTIONS(3744),
    [anon_sym___extension__] = ACTIONS(3742),
    [anon_sym_typedef] = ACTIONS(3742),
    [anon_sym_in] = ACTIONS(3742),
    [anon_sym_out] = ACTIONS(3742),
    [anon_sym_inout] = ACTIONS(3742),
    [anon_sym_extern] = ACTIONS(3742),
    [anon_sym___attribute__] = ACTIONS(2861),
    [anon_sym_COLON_COLON] = ACTIONS(3744),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3744),
    [anon_sym___declspec] = ACTIONS(3742),
    [anon_sym___based] = ACTIONS(3742),
    [anon_sym___cdecl] = ACTIONS(3742),
    [anon_sym___clrcall] = ACTIONS(3742),
    [anon_sym___stdcall] = ACTIONS(3742),
    [anon_sym___fastcall] = ACTIONS(3742),
    [anon_sym___thiscall] = ACTIONS(3742),
    [anon_sym___vectorcall] = ACTIONS(3742),
    [anon_sym_LBRACE] = ACTIONS(3744),
    [anon_sym_signed] = ACTIONS(3742),
    [anon_sym_unsigned] = ACTIONS(3742),
    [anon_sym_long] = ACTIONS(3742),
    [anon_sym_short] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(3742),
    [anon_sym_static] = ACTIONS(3742),
    [anon_sym_register] = ACTIONS(3742),
    [anon_sym_inline] = ACTIONS(3742),
    [anon_sym___inline] = ACTIONS(3742),
    [anon_sym___inline__] = ACTIONS(3742),
    [anon_sym___forceinline] = ACTIONS(3742),
    [anon_sym_thread_local] = ACTIONS(3742),
    [anon_sym___thread] = ACTIONS(3742),
    [anon_sym_const] = ACTIONS(3742),
    [anon_sym_constexpr] = ACTIONS(3742),
    [anon_sym_volatile] = ACTIONS(3742),
    [anon_sym_restrict] = ACTIONS(3742),
    [anon_sym___restrict__] = ACTIONS(3742),
    [anon_sym__Atomic] = ACTIONS(3742),
    [anon_sym__Noreturn] = ACTIONS(3742),
    [anon_sym_noreturn] = ACTIONS(3742),
    [anon_sym_mutable] = ACTIONS(3742),
    [anon_sym_constinit] = ACTIONS(3742),
    [anon_sym_consteval] = ACTIONS(3742),
    [anon_sym_alignas] = ACTIONS(3742),
    [anon_sym__Alignas] = ACTIONS(3742),
    [sym_primitive_type] = ACTIONS(3742),
    [anon_sym_enum] = ACTIONS(3742),
    [anon_sym_class] = ACTIONS(3742),
    [anon_sym_struct] = ACTIONS(3742),
    [anon_sym_union] = ACTIONS(3742),
    [anon_sym_if] = ACTIONS(3742),
    [anon_sym_switch] = ACTIONS(3742),
    [anon_sym_case] = ACTIONS(3742),
    [anon_sym_default] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(3742),
    [anon_sym_do] = ACTIONS(3742),
    [anon_sym_for] = ACTIONS(3742),
    [anon_sym_return] = ACTIONS(3742),
    [anon_sym_break] = ACTIONS(3742),
    [anon_sym_continue] = ACTIONS(3742),
    [anon_sym_goto] = ACTIONS(3742),
    [anon_sym_not] = ACTIONS(3742),
    [anon_sym_compl] = ACTIONS(3742),
    [anon_sym_DASH_DASH] = ACTIONS(3744),
    [anon_sym_PLUS_PLUS] = ACTIONS(3744),
    [anon_sym_sizeof] = ACTIONS(3742),
    [anon_sym___alignof__] = ACTIONS(3742),
    [anon_sym___alignof] = ACTIONS(3742),
    [anon_sym__alignof] = ACTIONS(3742),
    [anon_sym_alignof] = ACTIONS(3742),
    [anon_sym__Alignof] = ACTIONS(3742),
    [anon_sym_offsetof] = ACTIONS(3742),
    [anon_sym__Generic] = ACTIONS(3742),
    [anon_sym_asm] = ACTIONS(3742),
    [anon_sym___asm__] = ACTIONS(3742),
    [anon_sym_DOT] = ACTIONS(3742),
    [sym_number_literal] = ACTIONS(3744),
    [anon_sym_L_SQUOTE] = ACTIONS(3744),
    [anon_sym_u_SQUOTE] = ACTIONS(3744),
    [anon_sym_U_SQUOTE] = ACTIONS(3744),
    [anon_sym_u8_SQUOTE] = ACTIONS(3744),
    [anon_sym_SQUOTE] = ACTIONS(3744),
    [anon_sym_L_DQUOTE] = ACTIONS(3744),
    [anon_sym_u_DQUOTE] = ACTIONS(3744),
    [anon_sym_U_DQUOTE] = ACTIONS(3744),
    [anon_sym_u8_DQUOTE] = ACTIONS(3744),
    [anon_sym_DQUOTE] = ACTIONS(3744),
    [sym_true] = ACTIONS(3742),
    [sym_false] = ACTIONS(3742),
    [anon_sym_NULL] = ACTIONS(3742),
    [anon_sym_nullptr] = ACTIONS(3742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3742),
    [anon_sym_let] = ACTIONS(3742),
    [anon_sym_This] = ACTIONS(3742),
    [anon_sym_decltype] = ACTIONS(3742),
    [sym_virtual] = ACTIONS(3742),
    [anon_sym_explicit] = ACTIONS(3742),
    [anon_sym_typename] = ACTIONS(3742),
    [anon_sym_template] = ACTIONS(3742),
    [anon_sym_operator] = ACTIONS(3742),
    [anon_sym_try] = ACTIONS(3742),
    [anon_sym_delete] = ACTIONS(3742),
    [anon_sym_throw] = ACTIONS(3742),
    [anon_sym_namespace] = ACTIONS(3742),
    [anon_sym_using] = ACTIONS(3742),
    [anon_sym_static_assert] = ACTIONS(3742),
    [anon_sym_concept] = ACTIONS(3742),
    [anon_sym_co_return] = ACTIONS(3742),
    [anon_sym_co_yield] = ACTIONS(3742),
    [anon_sym_R_DQUOTE] = ACTIONS(3744),
    [anon_sym_LR_DQUOTE] = ACTIONS(3744),
    [anon_sym_uR_DQUOTE] = ACTIONS(3744),
    [anon_sym_UR_DQUOTE] = ACTIONS(3744),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3744),
    [anon_sym_co_await] = ACTIONS(3742),
    [anon_sym_new] = ACTIONS(3742),
    [anon_sym_requires] = ACTIONS(3742),
    [sym_this] = ACTIONS(3742),
    [anon_sym_precise] = ACTIONS(3742),
    [anon_sym_shared] = ACTIONS(3742),
    [anon_sym_groupshared] = ACTIONS(3742),
    [anon_sym_uniform] = ACTIONS(3742),
    [anon_sym_row_major] = ACTIONS(3742),
    [anon_sym_column_major] = ACTIONS(3742),
    [anon_sym_globallycoherent] = ACTIONS(3742),
    [anon_sym_centroid] = ACTIONS(3742),
    [anon_sym_noperspective] = ACTIONS(3742),
    [anon_sym_nointerpolation] = ACTIONS(3742),
    [anon_sym_sample] = ACTIONS(3742),
    [anon_sym_linear] = ACTIONS(3742),
    [anon_sym_snorm] = ACTIONS(3742),
    [anon_sym_unorm] = ACTIONS(3742),
    [anon_sym_point] = ACTIONS(3742),
    [anon_sym_line] = ACTIONS(3742),
    [anon_sym_triangleadj] = ACTIONS(3742),
    [anon_sym_lineadj] = ACTIONS(3742),
    [anon_sym_triangle] = ACTIONS(3742),
    [anon_sym_interface] = ACTIONS(3742),
    [anon_sym_extension] = ACTIONS(3742),
    [anon_sym___exported] = ACTIONS(3742),
    [anon_sym_import] = ACTIONS(3742),
  },
  [853] = {
    [sym_identifier] = ACTIONS(3501),
    [aux_sym_preproc_include_token1] = ACTIONS(3501),
    [aux_sym_preproc_def_token1] = ACTIONS(3501),
    [aux_sym_preproc_if_token1] = ACTIONS(3501),
    [aux_sym_preproc_if_token2] = ACTIONS(3501),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3501),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3501),
    [sym_preproc_directive] = ACTIONS(3501),
    [anon_sym_LPAREN2] = ACTIONS(3503),
    [anon_sym_BANG] = ACTIONS(3503),
    [anon_sym_TILDE] = ACTIONS(3503),
    [anon_sym_DASH] = ACTIONS(3501),
    [anon_sym_PLUS] = ACTIONS(3501),
    [anon_sym_STAR] = ACTIONS(3503),
    [anon_sym_AMP_AMP] = ACTIONS(3503),
    [anon_sym_AMP] = ACTIONS(3501),
    [anon_sym_SEMI] = ACTIONS(3503),
    [anon_sym___extension__] = ACTIONS(3501),
    [anon_sym_typedef] = ACTIONS(3501),
    [anon_sym_in] = ACTIONS(3501),
    [anon_sym_out] = ACTIONS(3501),
    [anon_sym_inout] = ACTIONS(3501),
    [anon_sym_extern] = ACTIONS(3501),
    [anon_sym___attribute__] = ACTIONS(3501),
    [anon_sym_COLON_COLON] = ACTIONS(3503),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3503),
    [anon_sym___declspec] = ACTIONS(3501),
    [anon_sym___based] = ACTIONS(3501),
    [anon_sym___cdecl] = ACTIONS(3501),
    [anon_sym___clrcall] = ACTIONS(3501),
    [anon_sym___stdcall] = ACTIONS(3501),
    [anon_sym___fastcall] = ACTIONS(3501),
    [anon_sym___thiscall] = ACTIONS(3501),
    [anon_sym___vectorcall] = ACTIONS(3501),
    [anon_sym_LBRACE] = ACTIONS(3503),
    [anon_sym_signed] = ACTIONS(3501),
    [anon_sym_unsigned] = ACTIONS(3501),
    [anon_sym_long] = ACTIONS(3501),
    [anon_sym_short] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(3501),
    [anon_sym_static] = ACTIONS(3501),
    [anon_sym_register] = ACTIONS(3501),
    [anon_sym_inline] = ACTIONS(3501),
    [anon_sym___inline] = ACTIONS(3501),
    [anon_sym___inline__] = ACTIONS(3501),
    [anon_sym___forceinline] = ACTIONS(3501),
    [anon_sym_thread_local] = ACTIONS(3501),
    [anon_sym___thread] = ACTIONS(3501),
    [anon_sym_const] = ACTIONS(3501),
    [anon_sym_constexpr] = ACTIONS(3501),
    [anon_sym_volatile] = ACTIONS(3501),
    [anon_sym_restrict] = ACTIONS(3501),
    [anon_sym___restrict__] = ACTIONS(3501),
    [anon_sym__Atomic] = ACTIONS(3501),
    [anon_sym__Noreturn] = ACTIONS(3501),
    [anon_sym_noreturn] = ACTIONS(3501),
    [anon_sym_mutable] = ACTIONS(3501),
    [anon_sym_constinit] = ACTIONS(3501),
    [anon_sym_consteval] = ACTIONS(3501),
    [anon_sym_alignas] = ACTIONS(3501),
    [anon_sym__Alignas] = ACTIONS(3501),
    [sym_primitive_type] = ACTIONS(3501),
    [anon_sym_enum] = ACTIONS(3501),
    [anon_sym_class] = ACTIONS(3501),
    [anon_sym_struct] = ACTIONS(3501),
    [anon_sym_union] = ACTIONS(3501),
    [anon_sym_if] = ACTIONS(3501),
    [anon_sym_switch] = ACTIONS(3501),
    [anon_sym_case] = ACTIONS(3501),
    [anon_sym_default] = ACTIONS(3501),
    [anon_sym_while] = ACTIONS(3501),
    [anon_sym_do] = ACTIONS(3501),
    [anon_sym_for] = ACTIONS(3501),
    [anon_sym_return] = ACTIONS(3501),
    [anon_sym_break] = ACTIONS(3501),
    [anon_sym_continue] = ACTIONS(3501),
    [anon_sym_goto] = ACTIONS(3501),
    [anon_sym___try] = ACTIONS(3501),
    [anon_sym___leave] = ACTIONS(3501),
    [anon_sym_not] = ACTIONS(3501),
    [anon_sym_compl] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(3503),
    [anon_sym_PLUS_PLUS] = ACTIONS(3503),
    [anon_sym_sizeof] = ACTIONS(3501),
    [anon_sym___alignof__] = ACTIONS(3501),
    [anon_sym___alignof] = ACTIONS(3501),
    [anon_sym__alignof] = ACTIONS(3501),
    [anon_sym_alignof] = ACTIONS(3501),
    [anon_sym__Alignof] = ACTIONS(3501),
    [anon_sym_offsetof] = ACTIONS(3501),
    [anon_sym__Generic] = ACTIONS(3501),
    [anon_sym_asm] = ACTIONS(3501),
    [anon_sym___asm__] = ACTIONS(3501),
    [sym_number_literal] = ACTIONS(3503),
    [anon_sym_L_SQUOTE] = ACTIONS(3503),
    [anon_sym_u_SQUOTE] = ACTIONS(3503),
    [anon_sym_U_SQUOTE] = ACTIONS(3503),
    [anon_sym_u8_SQUOTE] = ACTIONS(3503),
    [anon_sym_SQUOTE] = ACTIONS(3503),
    [anon_sym_L_DQUOTE] = ACTIONS(3503),
    [anon_sym_u_DQUOTE] = ACTIONS(3503),
    [anon_sym_U_DQUOTE] = ACTIONS(3503),
    [anon_sym_u8_DQUOTE] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3503),
    [sym_true] = ACTIONS(3501),
    [sym_false] = ACTIONS(3501),
    [anon_sym_NULL] = ACTIONS(3501),
    [anon_sym_nullptr] = ACTIONS(3501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3501),
    [anon_sym_let] = ACTIONS(3501),
    [anon_sym_This] = ACTIONS(3501),
    [anon_sym_decltype] = ACTIONS(3501),
    [sym_virtual] = ACTIONS(3501),
    [anon_sym_explicit] = ACTIONS(3501),
    [anon_sym_typename] = ACTIONS(3501),
    [anon_sym_template] = ACTIONS(3501),
    [anon_sym_operator] = ACTIONS(3501),
    [anon_sym_try] = ACTIONS(3501),
    [anon_sym_delete] = ACTIONS(3501),
    [anon_sym_throw] = ACTIONS(3501),
    [anon_sym_namespace] = ACTIONS(3501),
    [anon_sym_using] = ACTIONS(3501),
    [anon_sym_static_assert] = ACTIONS(3501),
    [anon_sym_concept] = ACTIONS(3501),
    [anon_sym_co_return] = ACTIONS(3501),
    [anon_sym_co_yield] = ACTIONS(3501),
    [anon_sym_R_DQUOTE] = ACTIONS(3503),
    [anon_sym_LR_DQUOTE] = ACTIONS(3503),
    [anon_sym_uR_DQUOTE] = ACTIONS(3503),
    [anon_sym_UR_DQUOTE] = ACTIONS(3503),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3503),
    [anon_sym_co_await] = ACTIONS(3501),
    [anon_sym_new] = ACTIONS(3501),
    [anon_sym_requires] = ACTIONS(3501),
    [sym_this] = ACTIONS(3501),
    [anon_sym_discard] = ACTIONS(3501),
    [anon_sym_precise] = ACTIONS(3501),
    [anon_sym_shared] = ACTIONS(3501),
    [anon_sym_groupshared] = ACTIONS(3501),
    [anon_sym_uniform] = ACTIONS(3501),
    [anon_sym_row_major] = ACTIONS(3501),
    [anon_sym_column_major] = ACTIONS(3501),
    [anon_sym_globallycoherent] = ACTIONS(3501),
    [anon_sym_centroid] = ACTIONS(3501),
    [anon_sym_noperspective] = ACTIONS(3501),
    [anon_sym_nointerpolation] = ACTIONS(3501),
    [anon_sym_sample] = ACTIONS(3501),
    [anon_sym_linear] = ACTIONS(3501),
    [anon_sym_snorm] = ACTIONS(3501),
    [anon_sym_unorm] = ACTIONS(3501),
    [anon_sym_point] = ACTIONS(3501),
    [anon_sym_line] = ACTIONS(3501),
    [anon_sym_triangleadj] = ACTIONS(3501),
    [anon_sym_lineadj] = ACTIONS(3501),
    [anon_sym_triangle] = ACTIONS(3501),
    [anon_sym_cbuffer] = ACTIONS(3501),
    [anon_sym_interface] = ACTIONS(3501),
    [anon_sym_extension] = ACTIONS(3501),
  },
  [854] = {
    [sym_identifier] = ACTIONS(3505),
    [aux_sym_preproc_include_token1] = ACTIONS(3505),
    [aux_sym_preproc_def_token1] = ACTIONS(3505),
    [aux_sym_preproc_if_token1] = ACTIONS(3505),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3505),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3505),
    [sym_preproc_directive] = ACTIONS(3505),
    [anon_sym_LPAREN2] = ACTIONS(3507),
    [anon_sym_BANG] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3505),
    [anon_sym_PLUS] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3507),
    [anon_sym___extension__] = ACTIONS(3505),
    [anon_sym_typedef] = ACTIONS(3505),
    [anon_sym_in] = ACTIONS(3505),
    [anon_sym_out] = ACTIONS(3505),
    [anon_sym_inout] = ACTIONS(3505),
    [anon_sym_extern] = ACTIONS(3505),
    [anon_sym___attribute__] = ACTIONS(3505),
    [anon_sym_COLON_COLON] = ACTIONS(3507),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3507),
    [anon_sym___declspec] = ACTIONS(3505),
    [anon_sym___based] = ACTIONS(3505),
    [anon_sym___cdecl] = ACTIONS(3505),
    [anon_sym___clrcall] = ACTIONS(3505),
    [anon_sym___stdcall] = ACTIONS(3505),
    [anon_sym___fastcall] = ACTIONS(3505),
    [anon_sym___thiscall] = ACTIONS(3505),
    [anon_sym___vectorcall] = ACTIONS(3505),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_RBRACE] = ACTIONS(3507),
    [anon_sym_signed] = ACTIONS(3505),
    [anon_sym_unsigned] = ACTIONS(3505),
    [anon_sym_long] = ACTIONS(3505),
    [anon_sym_short] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_static] = ACTIONS(3505),
    [anon_sym_register] = ACTIONS(3505),
    [anon_sym_inline] = ACTIONS(3505),
    [anon_sym___inline] = ACTIONS(3505),
    [anon_sym___inline__] = ACTIONS(3505),
    [anon_sym___forceinline] = ACTIONS(3505),
    [anon_sym_thread_local] = ACTIONS(3505),
    [anon_sym___thread] = ACTIONS(3505),
    [anon_sym_const] = ACTIONS(3505),
    [anon_sym_constexpr] = ACTIONS(3505),
    [anon_sym_volatile] = ACTIONS(3505),
    [anon_sym_restrict] = ACTIONS(3505),
    [anon_sym___restrict__] = ACTIONS(3505),
    [anon_sym__Atomic] = ACTIONS(3505),
    [anon_sym__Noreturn] = ACTIONS(3505),
    [anon_sym_noreturn] = ACTIONS(3505),
    [anon_sym_mutable] = ACTIONS(3505),
    [anon_sym_constinit] = ACTIONS(3505),
    [anon_sym_consteval] = ACTIONS(3505),
    [anon_sym_alignas] = ACTIONS(3505),
    [anon_sym__Alignas] = ACTIONS(3505),
    [sym_primitive_type] = ACTIONS(3505),
    [anon_sym_enum] = ACTIONS(3505),
    [anon_sym_class] = ACTIONS(3505),
    [anon_sym_struct] = ACTIONS(3505),
    [anon_sym_union] = ACTIONS(3505),
    [anon_sym_if] = ACTIONS(3505),
    [anon_sym_switch] = ACTIONS(3505),
    [anon_sym_case] = ACTIONS(3505),
    [anon_sym_default] = ACTIONS(3505),
    [anon_sym_while] = ACTIONS(3505),
    [anon_sym_do] = ACTIONS(3505),
    [anon_sym_for] = ACTIONS(3505),
    [anon_sym_return] = ACTIONS(3505),
    [anon_sym_break] = ACTIONS(3505),
    [anon_sym_continue] = ACTIONS(3505),
    [anon_sym_goto] = ACTIONS(3505),
    [anon_sym___try] = ACTIONS(3505),
    [anon_sym___leave] = ACTIONS(3505),
    [anon_sym_not] = ACTIONS(3505),
    [anon_sym_compl] = ACTIONS(3505),
    [anon_sym_DASH_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_PLUS] = ACTIONS(3507),
    [anon_sym_sizeof] = ACTIONS(3505),
    [anon_sym___alignof__] = ACTIONS(3505),
    [anon_sym___alignof] = ACTIONS(3505),
    [anon_sym__alignof] = ACTIONS(3505),
    [anon_sym_alignof] = ACTIONS(3505),
    [anon_sym__Alignof] = ACTIONS(3505),
    [anon_sym_offsetof] = ACTIONS(3505),
    [anon_sym__Generic] = ACTIONS(3505),
    [anon_sym_asm] = ACTIONS(3505),
    [anon_sym___asm__] = ACTIONS(3505),
    [sym_number_literal] = ACTIONS(3507),
    [anon_sym_L_SQUOTE] = ACTIONS(3507),
    [anon_sym_u_SQUOTE] = ACTIONS(3507),
    [anon_sym_U_SQUOTE] = ACTIONS(3507),
    [anon_sym_u8_SQUOTE] = ACTIONS(3507),
    [anon_sym_SQUOTE] = ACTIONS(3507),
    [anon_sym_L_DQUOTE] = ACTIONS(3507),
    [anon_sym_u_DQUOTE] = ACTIONS(3507),
    [anon_sym_U_DQUOTE] = ACTIONS(3507),
    [anon_sym_u8_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [sym_true] = ACTIONS(3505),
    [sym_false] = ACTIONS(3505),
    [anon_sym_NULL] = ACTIONS(3505),
    [anon_sym_nullptr] = ACTIONS(3505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_This] = ACTIONS(3505),
    [anon_sym_decltype] = ACTIONS(3505),
    [sym_virtual] = ACTIONS(3505),
    [anon_sym_explicit] = ACTIONS(3505),
    [anon_sym_typename] = ACTIONS(3505),
    [anon_sym_template] = ACTIONS(3505),
    [anon_sym_operator] = ACTIONS(3505),
    [anon_sym_try] = ACTIONS(3505),
    [anon_sym_delete] = ACTIONS(3505),
    [anon_sym_throw] = ACTIONS(3505),
    [anon_sym_namespace] = ACTIONS(3505),
    [anon_sym_using] = ACTIONS(3505),
    [anon_sym_static_assert] = ACTIONS(3505),
    [anon_sym_concept] = ACTIONS(3505),
    [anon_sym_co_return] = ACTIONS(3505),
    [anon_sym_co_yield] = ACTIONS(3505),
    [anon_sym_R_DQUOTE] = ACTIONS(3507),
    [anon_sym_LR_DQUOTE] = ACTIONS(3507),
    [anon_sym_uR_DQUOTE] = ACTIONS(3507),
    [anon_sym_UR_DQUOTE] = ACTIONS(3507),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3507),
    [anon_sym_co_await] = ACTIONS(3505),
    [anon_sym_new] = ACTIONS(3505),
    [anon_sym_requires] = ACTIONS(3505),
    [sym_this] = ACTIONS(3505),
    [anon_sym_discard] = ACTIONS(3505),
    [anon_sym_precise] = ACTIONS(3505),
    [anon_sym_shared] = ACTIONS(3505),
    [anon_sym_groupshared] = ACTIONS(3505),
    [anon_sym_uniform] = ACTIONS(3505),
    [anon_sym_row_major] = ACTIONS(3505),
    [anon_sym_column_major] = ACTIONS(3505),
    [anon_sym_globallycoherent] = ACTIONS(3505),
    [anon_sym_centroid] = ACTIONS(3505),
    [anon_sym_noperspective] = ACTIONS(3505),
    [anon_sym_nointerpolation] = ACTIONS(3505),
    [anon_sym_sample] = ACTIONS(3505),
    [anon_sym_linear] = ACTIONS(3505),
    [anon_sym_snorm] = ACTIONS(3505),
    [anon_sym_unorm] = ACTIONS(3505),
    [anon_sym_point] = ACTIONS(3505),
    [anon_sym_line] = ACTIONS(3505),
    [anon_sym_triangleadj] = ACTIONS(3505),
    [anon_sym_lineadj] = ACTIONS(3505),
    [anon_sym_triangle] = ACTIONS(3505),
    [anon_sym_cbuffer] = ACTIONS(3505),
    [anon_sym_interface] = ACTIONS(3505),
    [anon_sym_extension] = ACTIONS(3505),
  },
  [855] = {
    [sym_attribute_specifier] = STATE(427),
    [ts_builtin_sym_end] = ACTIONS(3748),
    [sym_identifier] = ACTIONS(3746),
    [aux_sym_preproc_include_token1] = ACTIONS(3746),
    [aux_sym_preproc_def_token1] = ACTIONS(3746),
    [aux_sym_preproc_if_token1] = ACTIONS(3746),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3746),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3746),
    [sym_preproc_directive] = ACTIONS(3746),
    [anon_sym_LPAREN2] = ACTIONS(3748),
    [anon_sym_BANG] = ACTIONS(3748),
    [anon_sym_TILDE] = ACTIONS(3748),
    [anon_sym_DASH] = ACTIONS(3746),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_STAR] = ACTIONS(3748),
    [anon_sym_AMP_AMP] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_SEMI] = ACTIONS(3748),
    [anon_sym___extension__] = ACTIONS(3746),
    [anon_sym_typedef] = ACTIONS(3746),
    [anon_sym_in] = ACTIONS(3746),
    [anon_sym_out] = ACTIONS(3746),
    [anon_sym_inout] = ACTIONS(3746),
    [anon_sym_extern] = ACTIONS(3746),
    [anon_sym___attribute__] = ACTIONS(2861),
    [anon_sym_COLON_COLON] = ACTIONS(3748),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3748),
    [anon_sym___declspec] = ACTIONS(3746),
    [anon_sym___based] = ACTIONS(3746),
    [anon_sym___cdecl] = ACTIONS(3746),
    [anon_sym___clrcall] = ACTIONS(3746),
    [anon_sym___stdcall] = ACTIONS(3746),
    [anon_sym___fastcall] = ACTIONS(3746),
    [anon_sym___thiscall] = ACTIONS(3746),
    [anon_sym___vectorcall] = ACTIONS(3746),
    [anon_sym_LBRACE] = ACTIONS(3748),
    [anon_sym_signed] = ACTIONS(3746),
    [anon_sym_unsigned] = ACTIONS(3746),
    [anon_sym_long] = ACTIONS(3746),
    [anon_sym_short] = ACTIONS(3746),
    [anon_sym_LBRACK] = ACTIONS(3746),
    [anon_sym_static] = ACTIONS(3746),
    [anon_sym_register] = ACTIONS(3746),
    [anon_sym_inline] = ACTIONS(3746),
    [anon_sym___inline] = ACTIONS(3746),
    [anon_sym___inline__] = ACTIONS(3746),
    [anon_sym___forceinline] = ACTIONS(3746),
    [anon_sym_thread_local] = ACTIONS(3746),
    [anon_sym___thread] = ACTIONS(3746),
    [anon_sym_const] = ACTIONS(3746),
    [anon_sym_constexpr] = ACTIONS(3746),
    [anon_sym_volatile] = ACTIONS(3746),
    [anon_sym_restrict] = ACTIONS(3746),
    [anon_sym___restrict__] = ACTIONS(3746),
    [anon_sym__Atomic] = ACTIONS(3746),
    [anon_sym__Noreturn] = ACTIONS(3746),
    [anon_sym_noreturn] = ACTIONS(3746),
    [anon_sym_mutable] = ACTIONS(3746),
    [anon_sym_constinit] = ACTIONS(3746),
    [anon_sym_consteval] = ACTIONS(3746),
    [anon_sym_alignas] = ACTIONS(3746),
    [anon_sym__Alignas] = ACTIONS(3746),
    [sym_primitive_type] = ACTIONS(3746),
    [anon_sym_enum] = ACTIONS(3746),
    [anon_sym_class] = ACTIONS(3746),
    [anon_sym_struct] = ACTIONS(3746),
    [anon_sym_union] = ACTIONS(3746),
    [anon_sym_if] = ACTIONS(3746),
    [anon_sym_switch] = ACTIONS(3746),
    [anon_sym_case] = ACTIONS(3746),
    [anon_sym_default] = ACTIONS(3746),
    [anon_sym_while] = ACTIONS(3746),
    [anon_sym_do] = ACTIONS(3746),
    [anon_sym_for] = ACTIONS(3746),
    [anon_sym_return] = ACTIONS(3746),
    [anon_sym_break] = ACTIONS(3746),
    [anon_sym_continue] = ACTIONS(3746),
    [anon_sym_goto] = ACTIONS(3746),
    [anon_sym_not] = ACTIONS(3746),
    [anon_sym_compl] = ACTIONS(3746),
    [anon_sym_DASH_DASH] = ACTIONS(3748),
    [anon_sym_PLUS_PLUS] = ACTIONS(3748),
    [anon_sym_sizeof] = ACTIONS(3746),
    [anon_sym___alignof__] = ACTIONS(3746),
    [anon_sym___alignof] = ACTIONS(3746),
    [anon_sym__alignof] = ACTIONS(3746),
    [anon_sym_alignof] = ACTIONS(3746),
    [anon_sym__Alignof] = ACTIONS(3746),
    [anon_sym_offsetof] = ACTIONS(3746),
    [anon_sym__Generic] = ACTIONS(3746),
    [anon_sym_asm] = ACTIONS(3746),
    [anon_sym___asm__] = ACTIONS(3746),
    [anon_sym_DOT] = ACTIONS(3746),
    [sym_number_literal] = ACTIONS(3748),
    [anon_sym_L_SQUOTE] = ACTIONS(3748),
    [anon_sym_u_SQUOTE] = ACTIONS(3748),
    [anon_sym_U_SQUOTE] = ACTIONS(3748),
    [anon_sym_u8_SQUOTE] = ACTIONS(3748),
    [anon_sym_SQUOTE] = ACTIONS(3748),
    [anon_sym_L_DQUOTE] = ACTIONS(3748),
    [anon_sym_u_DQUOTE] = ACTIONS(3748),
    [anon_sym_U_DQUOTE] = ACTIONS(3748),
    [anon_sym_u8_DQUOTE] = ACTIONS(3748),
    [anon_sym_DQUOTE] = ACTIONS(3748),
    [sym_true] = ACTIONS(3746),
    [sym_false] = ACTIONS(3746),
    [anon_sym_NULL] = ACTIONS(3746),
    [anon_sym_nullptr] = ACTIONS(3746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3746),
    [anon_sym_let] = ACTIONS(3746),
    [anon_sym_This] = ACTIONS(3746),
    [anon_sym_decltype] = ACTIONS(3746),
    [sym_virtual] = ACTIONS(3746),
    [anon_sym_explicit] = ACTIONS(3746),
    [anon_sym_typename] = ACTIONS(3746),
    [anon_sym_template] = ACTIONS(3746),
    [anon_sym_operator] = ACTIONS(3746),
    [anon_sym_try] = ACTIONS(3746),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_throw] = ACTIONS(3746),
    [anon_sym_namespace] = ACTIONS(3746),
    [anon_sym_using] = ACTIONS(3746),
    [anon_sym_static_assert] = ACTIONS(3746),
    [anon_sym_concept] = ACTIONS(3746),
    [anon_sym_co_return] = ACTIONS(3746),
    [anon_sym_co_yield] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(3748),
    [anon_sym_LR_DQUOTE] = ACTIONS(3748),
    [anon_sym_uR_DQUOTE] = ACTIONS(3748),
    [anon_sym_UR_DQUOTE] = ACTIONS(3748),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3748),
    [anon_sym_co_await] = ACTIONS(3746),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3746),
    [sym_this] = ACTIONS(3746),
    [anon_sym_precise] = ACTIONS(3746),
    [anon_sym_shared] = ACTIONS(3746),
    [anon_sym_groupshared] = ACTIONS(3746),
    [anon_sym_uniform] = ACTIONS(3746),
    [anon_sym_row_major] = ACTIONS(3746),
    [anon_sym_column_major] = ACTIONS(3746),
    [anon_sym_globallycoherent] = ACTIONS(3746),
    [anon_sym_centroid] = ACTIONS(3746),
    [anon_sym_noperspective] = ACTIONS(3746),
    [anon_sym_nointerpolation] = ACTIONS(3746),
    [anon_sym_sample] = ACTIONS(3746),
    [anon_sym_linear] = ACTIONS(3746),
    [anon_sym_snorm] = ACTIONS(3746),
    [anon_sym_unorm] = ACTIONS(3746),
    [anon_sym_point] = ACTIONS(3746),
    [anon_sym_line] = ACTIONS(3746),
    [anon_sym_triangleadj] = ACTIONS(3746),
    [anon_sym_lineadj] = ACTIONS(3746),
    [anon_sym_triangle] = ACTIONS(3746),
    [anon_sym_interface] = ACTIONS(3746),
    [anon_sym_extension] = ACTIONS(3746),
    [anon_sym___exported] = ACTIONS(3746),
    [anon_sym_import] = ACTIONS(3746),
  },
  [856] = {
    [sym_identifier] = ACTIONS(3669),
    [aux_sym_preproc_include_token1] = ACTIONS(3669),
    [aux_sym_preproc_def_token1] = ACTIONS(3669),
    [aux_sym_preproc_if_token1] = ACTIONS(3669),
    [aux_sym_preproc_if_token2] = ACTIONS(3669),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3669),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3669),
    [sym_preproc_directive] = ACTIONS(3669),
    [anon_sym_LPAREN2] = ACTIONS(3671),
    [anon_sym_BANG] = ACTIONS(3671),
    [anon_sym_TILDE] = ACTIONS(3671),
    [anon_sym_DASH] = ACTIONS(3669),
    [anon_sym_PLUS] = ACTIONS(3669),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3671),
    [anon_sym_AMP] = ACTIONS(3669),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym___extension__] = ACTIONS(3669),
    [anon_sym_typedef] = ACTIONS(3669),
    [anon_sym_in] = ACTIONS(3669),
    [anon_sym_out] = ACTIONS(3669),
    [anon_sym_inout] = ACTIONS(3669),
    [anon_sym_extern] = ACTIONS(3669),
    [anon_sym___attribute__] = ACTIONS(3669),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3671),
    [anon_sym___declspec] = ACTIONS(3669),
    [anon_sym___based] = ACTIONS(3669),
    [anon_sym___cdecl] = ACTIONS(3669),
    [anon_sym___clrcall] = ACTIONS(3669),
    [anon_sym___stdcall] = ACTIONS(3669),
    [anon_sym___fastcall] = ACTIONS(3669),
    [anon_sym___thiscall] = ACTIONS(3669),
    [anon_sym___vectorcall] = ACTIONS(3669),
    [anon_sym_LBRACE] = ACTIONS(3671),
    [anon_sym_signed] = ACTIONS(3669),
    [anon_sym_unsigned] = ACTIONS(3669),
    [anon_sym_long] = ACTIONS(3669),
    [anon_sym_short] = ACTIONS(3669),
    [anon_sym_LBRACK] = ACTIONS(3669),
    [anon_sym_static] = ACTIONS(3669),
    [anon_sym_register] = ACTIONS(3669),
    [anon_sym_inline] = ACTIONS(3669),
    [anon_sym___inline] = ACTIONS(3669),
    [anon_sym___inline__] = ACTIONS(3669),
    [anon_sym___forceinline] = ACTIONS(3669),
    [anon_sym_thread_local] = ACTIONS(3669),
    [anon_sym___thread] = ACTIONS(3669),
    [anon_sym_const] = ACTIONS(3669),
    [anon_sym_constexpr] = ACTIONS(3669),
    [anon_sym_volatile] = ACTIONS(3669),
    [anon_sym_restrict] = ACTIONS(3669),
    [anon_sym___restrict__] = ACTIONS(3669),
    [anon_sym__Atomic] = ACTIONS(3669),
    [anon_sym__Noreturn] = ACTIONS(3669),
    [anon_sym_noreturn] = ACTIONS(3669),
    [anon_sym_mutable] = ACTIONS(3669),
    [anon_sym_constinit] = ACTIONS(3669),
    [anon_sym_consteval] = ACTIONS(3669),
    [anon_sym_alignas] = ACTIONS(3669),
    [anon_sym__Alignas] = ACTIONS(3669),
    [sym_primitive_type] = ACTIONS(3669),
    [anon_sym_enum] = ACTIONS(3669),
    [anon_sym_class] = ACTIONS(3669),
    [anon_sym_struct] = ACTIONS(3669),
    [anon_sym_union] = ACTIONS(3669),
    [anon_sym_if] = ACTIONS(3669),
    [anon_sym_switch] = ACTIONS(3669),
    [anon_sym_case] = ACTIONS(3669),
    [anon_sym_default] = ACTIONS(3669),
    [anon_sym_while] = ACTIONS(3669),
    [anon_sym_do] = ACTIONS(3669),
    [anon_sym_for] = ACTIONS(3669),
    [anon_sym_return] = ACTIONS(3669),
    [anon_sym_break] = ACTIONS(3669),
    [anon_sym_continue] = ACTIONS(3669),
    [anon_sym_goto] = ACTIONS(3669),
    [anon_sym___try] = ACTIONS(3669),
    [anon_sym___leave] = ACTIONS(3669),
    [anon_sym_not] = ACTIONS(3669),
    [anon_sym_compl] = ACTIONS(3669),
    [anon_sym_DASH_DASH] = ACTIONS(3671),
    [anon_sym_PLUS_PLUS] = ACTIONS(3671),
    [anon_sym_sizeof] = ACTIONS(3669),
    [anon_sym___alignof__] = ACTIONS(3669),
    [anon_sym___alignof] = ACTIONS(3669),
    [anon_sym__alignof] = ACTIONS(3669),
    [anon_sym_alignof] = ACTIONS(3669),
    [anon_sym__Alignof] = ACTIONS(3669),
    [anon_sym_offsetof] = ACTIONS(3669),
    [anon_sym__Generic] = ACTIONS(3669),
    [anon_sym_asm] = ACTIONS(3669),
    [anon_sym___asm__] = ACTIONS(3669),
    [sym_number_literal] = ACTIONS(3671),
    [anon_sym_L_SQUOTE] = ACTIONS(3671),
    [anon_sym_u_SQUOTE] = ACTIONS(3671),
    [anon_sym_U_SQUOTE] = ACTIONS(3671),
    [anon_sym_u8_SQUOTE] = ACTIONS(3671),
    [anon_sym_SQUOTE] = ACTIONS(3671),
    [anon_sym_L_DQUOTE] = ACTIONS(3671),
    [anon_sym_u_DQUOTE] = ACTIONS(3671),
    [anon_sym_U_DQUOTE] = ACTIONS(3671),
    [anon_sym_u8_DQUOTE] = ACTIONS(3671),
    [anon_sym_DQUOTE] = ACTIONS(3671),
    [sym_true] = ACTIONS(3669),
    [sym_false] = ACTIONS(3669),
    [anon_sym_NULL] = ACTIONS(3669),
    [anon_sym_nullptr] = ACTIONS(3669),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3669),
    [anon_sym_let] = ACTIONS(3669),
    [anon_sym_This] = ACTIONS(3669),
    [anon_sym_decltype] = ACTIONS(3669),
    [sym_virtual] = ACTIONS(3669),
    [anon_sym_explicit] = ACTIONS(3669),
    [anon_sym_typename] = ACTIONS(3669),
    [anon_sym_template] = ACTIONS(3669),
    [anon_sym_operator] = ACTIONS(3669),
    [anon_sym_try] = ACTIONS(3669),
    [anon_sym_delete] = ACTIONS(3669),
    [anon_sym_throw] = ACTIONS(3669),
    [anon_sym_namespace] = ACTIONS(3669),
    [anon_sym_using] = ACTIONS(3669),
    [anon_sym_static_assert] = ACTIONS(3669),
    [anon_sym_concept] = ACTIONS(3669),
    [anon_sym_co_return] = ACTIONS(3669),
    [anon_sym_co_yield] = ACTIONS(3669),
    [anon_sym_R_DQUOTE] = ACTIONS(3671),
    [anon_sym_LR_DQUOTE] = ACTIONS(3671),
    [anon_sym_uR_DQUOTE] = ACTIONS(3671),
    [anon_sym_UR_DQUOTE] = ACTIONS(3671),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3671),
    [anon_sym_co_await] = ACTIONS(3669),
    [anon_sym_new] = ACTIONS(3669),
    [anon_sym_requires] = ACTIONS(3669),
    [sym_this] = ACTIONS(3669),
    [anon_sym_discard] = ACTIONS(3669),
    [anon_sym_precise] = ACTIONS(3669),
    [anon_sym_shared] = ACTIONS(3669),
    [anon_sym_groupshared] = ACTIONS(3669),
    [anon_sym_uniform] = ACTIONS(3669),
    [anon_sym_row_major] = ACTIONS(3669),
    [anon_sym_column_major] = ACTIONS(3669),
    [anon_sym_globallycoherent] = ACTIONS(3669),
    [anon_sym_centroid] = ACTIONS(3669),
    [anon_sym_noperspective] = ACTIONS(3669),
    [anon_sym_nointerpolation] = ACTIONS(3669),
    [anon_sym_sample] = ACTIONS(3669),
    [anon_sym_linear] = ACTIONS(3669),
    [anon_sym_snorm] = ACTIONS(3669),
    [anon_sym_unorm] = ACTIONS(3669),
    [anon_sym_point] = ACTIONS(3669),
    [anon_sym_line] = ACTIONS(3669),
    [anon_sym_triangleadj] = ACTIONS(3669),
    [anon_sym_lineadj] = ACTIONS(3669),
    [anon_sym_triangle] = ACTIONS(3669),
    [anon_sym_cbuffer] = ACTIONS(3669),
    [anon_sym_interface] = ACTIONS(3669),
    [anon_sym_extension] = ACTIONS(3669),
  },
  [857] = {
    [sym_identifier] = ACTIONS(3479),
    [aux_sym_preproc_include_token1] = ACTIONS(3479),
    [aux_sym_preproc_def_token1] = ACTIONS(3479),
    [aux_sym_preproc_if_token1] = ACTIONS(3479),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3479),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3479),
    [sym_preproc_directive] = ACTIONS(3479),
    [anon_sym_LPAREN2] = ACTIONS(3481),
    [anon_sym_BANG] = ACTIONS(3481),
    [anon_sym_TILDE] = ACTIONS(3481),
    [anon_sym_DASH] = ACTIONS(3479),
    [anon_sym_PLUS] = ACTIONS(3479),
    [anon_sym_STAR] = ACTIONS(3481),
    [anon_sym_AMP_AMP] = ACTIONS(3481),
    [anon_sym_AMP] = ACTIONS(3479),
    [anon_sym_SEMI] = ACTIONS(3481),
    [anon_sym___extension__] = ACTIONS(3479),
    [anon_sym_typedef] = ACTIONS(3479),
    [anon_sym_in] = ACTIONS(3479),
    [anon_sym_out] = ACTIONS(3479),
    [anon_sym_inout] = ACTIONS(3479),
    [anon_sym_extern] = ACTIONS(3479),
    [anon_sym___attribute__] = ACTIONS(3479),
    [anon_sym_COLON_COLON] = ACTIONS(3481),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3481),
    [anon_sym___declspec] = ACTIONS(3479),
    [anon_sym___based] = ACTIONS(3479),
    [anon_sym___cdecl] = ACTIONS(3479),
    [anon_sym___clrcall] = ACTIONS(3479),
    [anon_sym___stdcall] = ACTIONS(3479),
    [anon_sym___fastcall] = ACTIONS(3479),
    [anon_sym___thiscall] = ACTIONS(3479),
    [anon_sym___vectorcall] = ACTIONS(3479),
    [anon_sym_LBRACE] = ACTIONS(3481),
    [anon_sym_RBRACE] = ACTIONS(3481),
    [anon_sym_signed] = ACTIONS(3479),
    [anon_sym_unsigned] = ACTIONS(3479),
    [anon_sym_long] = ACTIONS(3479),
    [anon_sym_short] = ACTIONS(3479),
    [anon_sym_LBRACK] = ACTIONS(3479),
    [anon_sym_static] = ACTIONS(3479),
    [anon_sym_register] = ACTIONS(3479),
    [anon_sym_inline] = ACTIONS(3479),
    [anon_sym___inline] = ACTIONS(3479),
    [anon_sym___inline__] = ACTIONS(3479),
    [anon_sym___forceinline] = ACTIONS(3479),
    [anon_sym_thread_local] = ACTIONS(3479),
    [anon_sym___thread] = ACTIONS(3479),
    [anon_sym_const] = ACTIONS(3479),
    [anon_sym_constexpr] = ACTIONS(3479),
    [anon_sym_volatile] = ACTIONS(3479),
    [anon_sym_restrict] = ACTIONS(3479),
    [anon_sym___restrict__] = ACTIONS(3479),
    [anon_sym__Atomic] = ACTIONS(3479),
    [anon_sym__Noreturn] = ACTIONS(3479),
    [anon_sym_noreturn] = ACTIONS(3479),
    [anon_sym_mutable] = ACTIONS(3479),
    [anon_sym_constinit] = ACTIONS(3479),
    [anon_sym_consteval] = ACTIONS(3479),
    [anon_sym_alignas] = ACTIONS(3479),
    [anon_sym__Alignas] = ACTIONS(3479),
    [sym_primitive_type] = ACTIONS(3479),
    [anon_sym_enum] = ACTIONS(3479),
    [anon_sym_class] = ACTIONS(3479),
    [anon_sym_struct] = ACTIONS(3479),
    [anon_sym_union] = ACTIONS(3479),
    [anon_sym_if] = ACTIONS(3479),
    [anon_sym_switch] = ACTIONS(3479),
    [anon_sym_case] = ACTIONS(3479),
    [anon_sym_default] = ACTIONS(3479),
    [anon_sym_while] = ACTIONS(3479),
    [anon_sym_do] = ACTIONS(3479),
    [anon_sym_for] = ACTIONS(3479),
    [anon_sym_return] = ACTIONS(3479),
    [anon_sym_break] = ACTIONS(3479),
    [anon_sym_continue] = ACTIONS(3479),
    [anon_sym_goto] = ACTIONS(3479),
    [anon_sym___try] = ACTIONS(3479),
    [anon_sym___leave] = ACTIONS(3479),
    [anon_sym_not] = ACTIONS(3479),
    [anon_sym_compl] = ACTIONS(3479),
    [anon_sym_DASH_DASH] = ACTIONS(3481),
    [anon_sym_PLUS_PLUS] = ACTIONS(3481),
    [anon_sym_sizeof] = ACTIONS(3479),
    [anon_sym___alignof__] = ACTIONS(3479),
    [anon_sym___alignof] = ACTIONS(3479),
    [anon_sym__alignof] = ACTIONS(3479),
    [anon_sym_alignof] = ACTIONS(3479),
    [anon_sym__Alignof] = ACTIONS(3479),
    [anon_sym_offsetof] = ACTIONS(3479),
    [anon_sym__Generic] = ACTIONS(3479),
    [anon_sym_asm] = ACTIONS(3479),
    [anon_sym___asm__] = ACTIONS(3479),
    [sym_number_literal] = ACTIONS(3481),
    [anon_sym_L_SQUOTE] = ACTIONS(3481),
    [anon_sym_u_SQUOTE] = ACTIONS(3481),
    [anon_sym_U_SQUOTE] = ACTIONS(3481),
    [anon_sym_u8_SQUOTE] = ACTIONS(3481),
    [anon_sym_SQUOTE] = ACTIONS(3481),
    [anon_sym_L_DQUOTE] = ACTIONS(3481),
    [anon_sym_u_DQUOTE] = ACTIONS(3481),
    [anon_sym_U_DQUOTE] = ACTIONS(3481),
    [anon_sym_u8_DQUOTE] = ACTIONS(3481),
    [anon_sym_DQUOTE] = ACTIONS(3481),
    [sym_true] = ACTIONS(3479),
    [sym_false] = ACTIONS(3479),
    [anon_sym_NULL] = ACTIONS(3479),
    [anon_sym_nullptr] = ACTIONS(3479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3479),
    [anon_sym_let] = ACTIONS(3479),
    [anon_sym_This] = ACTIONS(3479),
    [anon_sym_decltype] = ACTIONS(3479),
    [sym_virtual] = ACTIONS(3479),
    [anon_sym_explicit] = ACTIONS(3479),
    [anon_sym_typename] = ACTIONS(3479),
    [anon_sym_template] = ACTIONS(3479),
    [anon_sym_operator] = ACTIONS(3479),
    [anon_sym_try] = ACTIONS(3479),
    [anon_sym_delete] = ACTIONS(3479),
    [anon_sym_throw] = ACTIONS(3479),
    [anon_sym_namespace] = ACTIONS(3479),
    [anon_sym_using] = ACTIONS(3479),
    [anon_sym_static_assert] = ACTIONS(3479),
    [anon_sym_concept] = ACTIONS(3479),
    [anon_sym_co_return] = ACTIONS(3479),
    [anon_sym_co_yield] = ACTIONS(3479),
    [anon_sym_R_DQUOTE] = ACTIONS(3481),
    [anon_sym_LR_DQUOTE] = ACTIONS(3481),
    [anon_sym_uR_DQUOTE] = ACTIONS(3481),
    [anon_sym_UR_DQUOTE] = ACTIONS(3481),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3481),
    [anon_sym_co_await] = ACTIONS(3479),
    [anon_sym_new] = ACTIONS(3479),
    [anon_sym_requires] = ACTIONS(3479),
    [sym_this] = ACTIONS(3479),
    [anon_sym_discard] = ACTIONS(3479),
    [anon_sym_precise] = ACTIONS(3479),
    [anon_sym_shared] = ACTIONS(3479),
    [anon_sym_groupshared] = ACTIONS(3479),
    [anon_sym_uniform] = ACTIONS(3479),
    [anon_sym_row_major] = ACTIONS(3479),
    [anon_sym_column_major] = ACTIONS(3479),
    [anon_sym_globallycoherent] = ACTIONS(3479),
    [anon_sym_centroid] = ACTIONS(3479),
    [anon_sym_noperspective] = ACTIONS(3479),
    [anon_sym_nointerpolation] = ACTIONS(3479),
    [anon_sym_sample] = ACTIONS(3479),
    [anon_sym_linear] = ACTIONS(3479),
    [anon_sym_snorm] = ACTIONS(3479),
    [anon_sym_unorm] = ACTIONS(3479),
    [anon_sym_point] = ACTIONS(3479),
    [anon_sym_line] = ACTIONS(3479),
    [anon_sym_triangleadj] = ACTIONS(3479),
    [anon_sym_lineadj] = ACTIONS(3479),
    [anon_sym_triangle] = ACTIONS(3479),
    [anon_sym_cbuffer] = ACTIONS(3479),
    [anon_sym_interface] = ACTIONS(3479),
    [anon_sym_extension] = ACTIONS(3479),
  },
  [858] = {
    [sym_identifier] = ACTIONS(3513),
    [aux_sym_preproc_include_token1] = ACTIONS(3513),
    [aux_sym_preproc_def_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token2] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3513),
    [sym_preproc_directive] = ACTIONS(3513),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_BANG] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3513),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3513),
    [anon_sym_SEMI] = ACTIONS(3515),
    [anon_sym___extension__] = ACTIONS(3513),
    [anon_sym_typedef] = ACTIONS(3513),
    [anon_sym_in] = ACTIONS(3513),
    [anon_sym_out] = ACTIONS(3513),
    [anon_sym_inout] = ACTIONS(3513),
    [anon_sym_extern] = ACTIONS(3513),
    [anon_sym___attribute__] = ACTIONS(3513),
    [anon_sym_COLON_COLON] = ACTIONS(3515),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3515),
    [anon_sym___declspec] = ACTIONS(3513),
    [anon_sym___based] = ACTIONS(3513),
    [anon_sym___cdecl] = ACTIONS(3513),
    [anon_sym___clrcall] = ACTIONS(3513),
    [anon_sym___stdcall] = ACTIONS(3513),
    [anon_sym___fastcall] = ACTIONS(3513),
    [anon_sym___thiscall] = ACTIONS(3513),
    [anon_sym___vectorcall] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_signed] = ACTIONS(3513),
    [anon_sym_unsigned] = ACTIONS(3513),
    [anon_sym_long] = ACTIONS(3513),
    [anon_sym_short] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_register] = ACTIONS(3513),
    [anon_sym_inline] = ACTIONS(3513),
    [anon_sym___inline] = ACTIONS(3513),
    [anon_sym___inline__] = ACTIONS(3513),
    [anon_sym___forceinline] = ACTIONS(3513),
    [anon_sym_thread_local] = ACTIONS(3513),
    [anon_sym___thread] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [anon_sym_constexpr] = ACTIONS(3513),
    [anon_sym_volatile] = ACTIONS(3513),
    [anon_sym_restrict] = ACTIONS(3513),
    [anon_sym___restrict__] = ACTIONS(3513),
    [anon_sym__Atomic] = ACTIONS(3513),
    [anon_sym__Noreturn] = ACTIONS(3513),
    [anon_sym_noreturn] = ACTIONS(3513),
    [anon_sym_mutable] = ACTIONS(3513),
    [anon_sym_constinit] = ACTIONS(3513),
    [anon_sym_consteval] = ACTIONS(3513),
    [anon_sym_alignas] = ACTIONS(3513),
    [anon_sym__Alignas] = ACTIONS(3513),
    [sym_primitive_type] = ACTIONS(3513),
    [anon_sym_enum] = ACTIONS(3513),
    [anon_sym_class] = ACTIONS(3513),
    [anon_sym_struct] = ACTIONS(3513),
    [anon_sym_union] = ACTIONS(3513),
    [anon_sym_if] = ACTIONS(3513),
    [anon_sym_switch] = ACTIONS(3513),
    [anon_sym_case] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3513),
    [anon_sym_while] = ACTIONS(3513),
    [anon_sym_do] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3513),
    [anon_sym_return] = ACTIONS(3513),
    [anon_sym_break] = ACTIONS(3513),
    [anon_sym_continue] = ACTIONS(3513),
    [anon_sym_goto] = ACTIONS(3513),
    [anon_sym___try] = ACTIONS(3513),
    [anon_sym___leave] = ACTIONS(3513),
    [anon_sym_not] = ACTIONS(3513),
    [anon_sym_compl] = ACTIONS(3513),
    [anon_sym_DASH_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_PLUS] = ACTIONS(3515),
    [anon_sym_sizeof] = ACTIONS(3513),
    [anon_sym___alignof__] = ACTIONS(3513),
    [anon_sym___alignof] = ACTIONS(3513),
    [anon_sym__alignof] = ACTIONS(3513),
    [anon_sym_alignof] = ACTIONS(3513),
    [anon_sym__Alignof] = ACTIONS(3513),
    [anon_sym_offsetof] = ACTIONS(3513),
    [anon_sym__Generic] = ACTIONS(3513),
    [anon_sym_asm] = ACTIONS(3513),
    [anon_sym___asm__] = ACTIONS(3513),
    [sym_number_literal] = ACTIONS(3515),
    [anon_sym_L_SQUOTE] = ACTIONS(3515),
    [anon_sym_u_SQUOTE] = ACTIONS(3515),
    [anon_sym_U_SQUOTE] = ACTIONS(3515),
    [anon_sym_u8_SQUOTE] = ACTIONS(3515),
    [anon_sym_SQUOTE] = ACTIONS(3515),
    [anon_sym_L_DQUOTE] = ACTIONS(3515),
    [anon_sym_u_DQUOTE] = ACTIONS(3515),
    [anon_sym_U_DQUOTE] = ACTIONS(3515),
    [anon_sym_u8_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [sym_true] = ACTIONS(3513),
    [sym_false] = ACTIONS(3513),
    [anon_sym_NULL] = ACTIONS(3513),
    [anon_sym_nullptr] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3513),
    [anon_sym_let] = ACTIONS(3513),
    [anon_sym_This] = ACTIONS(3513),
    [anon_sym_decltype] = ACTIONS(3513),
    [sym_virtual] = ACTIONS(3513),
    [anon_sym_explicit] = ACTIONS(3513),
    [anon_sym_typename] = ACTIONS(3513),
    [anon_sym_template] = ACTIONS(3513),
    [anon_sym_operator] = ACTIONS(3513),
    [anon_sym_try] = ACTIONS(3513),
    [anon_sym_delete] = ACTIONS(3513),
    [anon_sym_throw] = ACTIONS(3513),
    [anon_sym_namespace] = ACTIONS(3513),
    [anon_sym_using] = ACTIONS(3513),
    [anon_sym_static_assert] = ACTIONS(3513),
    [anon_sym_concept] = ACTIONS(3513),
    [anon_sym_co_return] = ACTIONS(3513),
    [anon_sym_co_yield] = ACTIONS(3513),
    [anon_sym_R_DQUOTE] = ACTIONS(3515),
    [anon_sym_LR_DQUOTE] = ACTIONS(3515),
    [anon_sym_uR_DQUOTE] = ACTIONS(3515),
    [anon_sym_UR_DQUOTE] = ACTIONS(3515),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3515),
    [anon_sym_co_await] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3513),
    [anon_sym_requires] = ACTIONS(3513),
    [sym_this] = ACTIONS(3513),
    [anon_sym_discard] = ACTIONS(3513),
    [anon_sym_precise] = ACTIONS(3513),
    [anon_sym_shared] = ACTIONS(3513),
    [anon_sym_groupshared] = ACTIONS(3513),
    [anon_sym_uniform] = ACTIONS(3513),
    [anon_sym_row_major] = ACTIONS(3513),
    [anon_sym_column_major] = ACTIONS(3513),
    [anon_sym_globallycoherent] = ACTIONS(3513),
    [anon_sym_centroid] = ACTIONS(3513),
    [anon_sym_noperspective] = ACTIONS(3513),
    [anon_sym_nointerpolation] = ACTIONS(3513),
    [anon_sym_sample] = ACTIONS(3513),
    [anon_sym_linear] = ACTIONS(3513),
    [anon_sym_snorm] = ACTIONS(3513),
    [anon_sym_unorm] = ACTIONS(3513),
    [anon_sym_point] = ACTIONS(3513),
    [anon_sym_line] = ACTIONS(3513),
    [anon_sym_triangleadj] = ACTIONS(3513),
    [anon_sym_lineadj] = ACTIONS(3513),
    [anon_sym_triangle] = ACTIONS(3513),
    [anon_sym_cbuffer] = ACTIONS(3513),
    [anon_sym_interface] = ACTIONS(3513),
    [anon_sym_extension] = ACTIONS(3513),
  },
  [859] = {
    [sym_identifier] = ACTIONS(3475),
    [aux_sym_preproc_include_token1] = ACTIONS(3475),
    [aux_sym_preproc_def_token1] = ACTIONS(3475),
    [aux_sym_preproc_if_token1] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3475),
    [sym_preproc_directive] = ACTIONS(3475),
    [anon_sym_LPAREN2] = ACTIONS(3477),
    [anon_sym_BANG] = ACTIONS(3477),
    [anon_sym_TILDE] = ACTIONS(3477),
    [anon_sym_DASH] = ACTIONS(3475),
    [anon_sym_PLUS] = ACTIONS(3475),
    [anon_sym_STAR] = ACTIONS(3477),
    [anon_sym_AMP_AMP] = ACTIONS(3477),
    [anon_sym_AMP] = ACTIONS(3475),
    [anon_sym_SEMI] = ACTIONS(3477),
    [anon_sym___extension__] = ACTIONS(3475),
    [anon_sym_typedef] = ACTIONS(3475),
    [anon_sym_in] = ACTIONS(3475),
    [anon_sym_out] = ACTIONS(3475),
    [anon_sym_inout] = ACTIONS(3475),
    [anon_sym_extern] = ACTIONS(3475),
    [anon_sym___attribute__] = ACTIONS(3475),
    [anon_sym_COLON_COLON] = ACTIONS(3477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3477),
    [anon_sym___declspec] = ACTIONS(3475),
    [anon_sym___based] = ACTIONS(3475),
    [anon_sym___cdecl] = ACTIONS(3475),
    [anon_sym___clrcall] = ACTIONS(3475),
    [anon_sym___stdcall] = ACTIONS(3475),
    [anon_sym___fastcall] = ACTIONS(3475),
    [anon_sym___thiscall] = ACTIONS(3475),
    [anon_sym___vectorcall] = ACTIONS(3475),
    [anon_sym_LBRACE] = ACTIONS(3477),
    [anon_sym_RBRACE] = ACTIONS(3477),
    [anon_sym_signed] = ACTIONS(3475),
    [anon_sym_unsigned] = ACTIONS(3475),
    [anon_sym_long] = ACTIONS(3475),
    [anon_sym_short] = ACTIONS(3475),
    [anon_sym_LBRACK] = ACTIONS(3475),
    [anon_sym_static] = ACTIONS(3475),
    [anon_sym_register] = ACTIONS(3475),
    [anon_sym_inline] = ACTIONS(3475),
    [anon_sym___inline] = ACTIONS(3475),
    [anon_sym___inline__] = ACTIONS(3475),
    [anon_sym___forceinline] = ACTIONS(3475),
    [anon_sym_thread_local] = ACTIONS(3475),
    [anon_sym___thread] = ACTIONS(3475),
    [anon_sym_const] = ACTIONS(3475),
    [anon_sym_constexpr] = ACTIONS(3475),
    [anon_sym_volatile] = ACTIONS(3475),
    [anon_sym_restrict] = ACTIONS(3475),
    [anon_sym___restrict__] = ACTIONS(3475),
    [anon_sym__Atomic] = ACTIONS(3475),
    [anon_sym__Noreturn] = ACTIONS(3475),
    [anon_sym_noreturn] = ACTIONS(3475),
    [anon_sym_mutable] = ACTIONS(3475),
    [anon_sym_constinit] = ACTIONS(3475),
    [anon_sym_consteval] = ACTIONS(3475),
    [anon_sym_alignas] = ACTIONS(3475),
    [anon_sym__Alignas] = ACTIONS(3475),
    [sym_primitive_type] = ACTIONS(3475),
    [anon_sym_enum] = ACTIONS(3475),
    [anon_sym_class] = ACTIONS(3475),
    [anon_sym_struct] = ACTIONS(3475),
    [anon_sym_union] = ACTIONS(3475),
    [anon_sym_if] = ACTIONS(3475),
    [anon_sym_switch] = ACTIONS(3475),
    [anon_sym_case] = ACTIONS(3475),
    [anon_sym_default] = ACTIONS(3475),
    [anon_sym_while] = ACTIONS(3475),
    [anon_sym_do] = ACTIONS(3475),
    [anon_sym_for] = ACTIONS(3475),
    [anon_sym_return] = ACTIONS(3475),
    [anon_sym_break] = ACTIONS(3475),
    [anon_sym_continue] = ACTIONS(3475),
    [anon_sym_goto] = ACTIONS(3475),
    [anon_sym___try] = ACTIONS(3475),
    [anon_sym___leave] = ACTIONS(3475),
    [anon_sym_not] = ACTIONS(3475),
    [anon_sym_compl] = ACTIONS(3475),
    [anon_sym_DASH_DASH] = ACTIONS(3477),
    [anon_sym_PLUS_PLUS] = ACTIONS(3477),
    [anon_sym_sizeof] = ACTIONS(3475),
    [anon_sym___alignof__] = ACTIONS(3475),
    [anon_sym___alignof] = ACTIONS(3475),
    [anon_sym__alignof] = ACTIONS(3475),
    [anon_sym_alignof] = ACTIONS(3475),
    [anon_sym__Alignof] = ACTIONS(3475),
    [anon_sym_offsetof] = ACTIONS(3475),
    [anon_sym__Generic] = ACTIONS(3475),
    [anon_sym_asm] = ACTIONS(3475),
    [anon_sym___asm__] = ACTIONS(3475),
    [sym_number_literal] = ACTIONS(3477),
    [anon_sym_L_SQUOTE] = ACTIONS(3477),
    [anon_sym_u_SQUOTE] = ACTIONS(3477),
    [anon_sym_U_SQUOTE] = ACTIONS(3477),
    [anon_sym_u8_SQUOTE] = ACTIONS(3477),
    [anon_sym_SQUOTE] = ACTIONS(3477),
    [anon_sym_L_DQUOTE] = ACTIONS(3477),
    [anon_sym_u_DQUOTE] = ACTIONS(3477),
    [anon_sym_U_DQUOTE] = ACTIONS(3477),
    [anon_sym_u8_DQUOTE] = ACTIONS(3477),
    [anon_sym_DQUOTE] = ACTIONS(3477),
    [sym_true] = ACTIONS(3475),
    [sym_false] = ACTIONS(3475),
    [anon_sym_NULL] = ACTIONS(3475),
    [anon_sym_nullptr] = ACTIONS(3475),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3475),
    [anon_sym_let] = ACTIONS(3475),
    [anon_sym_This] = ACTIONS(3475),
    [anon_sym_decltype] = ACTIONS(3475),
    [sym_virtual] = ACTIONS(3475),
    [anon_sym_explicit] = ACTIONS(3475),
    [anon_sym_typename] = ACTIONS(3475),
    [anon_sym_template] = ACTIONS(3475),
    [anon_sym_operator] = ACTIONS(3475),
    [anon_sym_try] = ACTIONS(3475),
    [anon_sym_delete] = ACTIONS(3475),
    [anon_sym_throw] = ACTIONS(3475),
    [anon_sym_namespace] = ACTIONS(3475),
    [anon_sym_using] = ACTIONS(3475),
    [anon_sym_static_assert] = ACTIONS(3475),
    [anon_sym_concept] = ACTIONS(3475),
    [anon_sym_co_return] = ACTIONS(3475),
    [anon_sym_co_yield] = ACTIONS(3475),
    [anon_sym_R_DQUOTE] = ACTIONS(3477),
    [anon_sym_LR_DQUOTE] = ACTIONS(3477),
    [anon_sym_uR_DQUOTE] = ACTIONS(3477),
    [anon_sym_UR_DQUOTE] = ACTIONS(3477),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3477),
    [anon_sym_co_await] = ACTIONS(3475),
    [anon_sym_new] = ACTIONS(3475),
    [anon_sym_requires] = ACTIONS(3475),
    [sym_this] = ACTIONS(3475),
    [anon_sym_discard] = ACTIONS(3475),
    [anon_sym_precise] = ACTIONS(3475),
    [anon_sym_shared] = ACTIONS(3475),
    [anon_sym_groupshared] = ACTIONS(3475),
    [anon_sym_uniform] = ACTIONS(3475),
    [anon_sym_row_major] = ACTIONS(3475),
    [anon_sym_column_major] = ACTIONS(3475),
    [anon_sym_globallycoherent] = ACTIONS(3475),
    [anon_sym_centroid] = ACTIONS(3475),
    [anon_sym_noperspective] = ACTIONS(3475),
    [anon_sym_nointerpolation] = ACTIONS(3475),
    [anon_sym_sample] = ACTIONS(3475),
    [anon_sym_linear] = ACTIONS(3475),
    [anon_sym_snorm] = ACTIONS(3475),
    [anon_sym_unorm] = ACTIONS(3475),
    [anon_sym_point] = ACTIONS(3475),
    [anon_sym_line] = ACTIONS(3475),
    [anon_sym_triangleadj] = ACTIONS(3475),
    [anon_sym_lineadj] = ACTIONS(3475),
    [anon_sym_triangle] = ACTIONS(3475),
    [anon_sym_cbuffer] = ACTIONS(3475),
    [anon_sym_interface] = ACTIONS(3475),
    [anon_sym_extension] = ACTIONS(3475),
  },
  [860] = {
    [sym_identifier] = ACTIONS(3685),
    [aux_sym_preproc_include_token1] = ACTIONS(3685),
    [aux_sym_preproc_def_token1] = ACTIONS(3685),
    [aux_sym_preproc_if_token1] = ACTIONS(3685),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3685),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3685),
    [sym_preproc_directive] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3687),
    [anon_sym_BANG] = ACTIONS(3687),
    [anon_sym_TILDE] = ACTIONS(3687),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_STAR] = ACTIONS(3687),
    [anon_sym_AMP_AMP] = ACTIONS(3687),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_SEMI] = ACTIONS(3687),
    [anon_sym___extension__] = ACTIONS(3685),
    [anon_sym_typedef] = ACTIONS(3685),
    [anon_sym_in] = ACTIONS(3685),
    [anon_sym_out] = ACTIONS(3685),
    [anon_sym_inout] = ACTIONS(3685),
    [anon_sym_extern] = ACTIONS(3685),
    [anon_sym___attribute__] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3687),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3687),
    [anon_sym___declspec] = ACTIONS(3685),
    [anon_sym___based] = ACTIONS(3685),
    [anon_sym___cdecl] = ACTIONS(3685),
    [anon_sym___clrcall] = ACTIONS(3685),
    [anon_sym___stdcall] = ACTIONS(3685),
    [anon_sym___fastcall] = ACTIONS(3685),
    [anon_sym___thiscall] = ACTIONS(3685),
    [anon_sym___vectorcall] = ACTIONS(3685),
    [anon_sym_LBRACE] = ACTIONS(3687),
    [anon_sym_RBRACE] = ACTIONS(3687),
    [anon_sym_signed] = ACTIONS(3685),
    [anon_sym_unsigned] = ACTIONS(3685),
    [anon_sym_long] = ACTIONS(3685),
    [anon_sym_short] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_static] = ACTIONS(3685),
    [anon_sym_register] = ACTIONS(3685),
    [anon_sym_inline] = ACTIONS(3685),
    [anon_sym___inline] = ACTIONS(3685),
    [anon_sym___inline__] = ACTIONS(3685),
    [anon_sym___forceinline] = ACTIONS(3685),
    [anon_sym_thread_local] = ACTIONS(3685),
    [anon_sym___thread] = ACTIONS(3685),
    [anon_sym_const] = ACTIONS(3685),
    [anon_sym_constexpr] = ACTIONS(3685),
    [anon_sym_volatile] = ACTIONS(3685),
    [anon_sym_restrict] = ACTIONS(3685),
    [anon_sym___restrict__] = ACTIONS(3685),
    [anon_sym__Atomic] = ACTIONS(3685),
    [anon_sym__Noreturn] = ACTIONS(3685),
    [anon_sym_noreturn] = ACTIONS(3685),
    [anon_sym_mutable] = ACTIONS(3685),
    [anon_sym_constinit] = ACTIONS(3685),
    [anon_sym_consteval] = ACTIONS(3685),
    [anon_sym_alignas] = ACTIONS(3685),
    [anon_sym__Alignas] = ACTIONS(3685),
    [sym_primitive_type] = ACTIONS(3685),
    [anon_sym_enum] = ACTIONS(3685),
    [anon_sym_class] = ACTIONS(3685),
    [anon_sym_struct] = ACTIONS(3685),
    [anon_sym_union] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_switch] = ACTIONS(3685),
    [anon_sym_case] = ACTIONS(3685),
    [anon_sym_default] = ACTIONS(3685),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_break] = ACTIONS(3685),
    [anon_sym_continue] = ACTIONS(3685),
    [anon_sym_goto] = ACTIONS(3685),
    [anon_sym___try] = ACTIONS(3685),
    [anon_sym___leave] = ACTIONS(3685),
    [anon_sym_not] = ACTIONS(3685),
    [anon_sym_compl] = ACTIONS(3685),
    [anon_sym_DASH_DASH] = ACTIONS(3687),
    [anon_sym_PLUS_PLUS] = ACTIONS(3687),
    [anon_sym_sizeof] = ACTIONS(3685),
    [anon_sym___alignof__] = ACTIONS(3685),
    [anon_sym___alignof] = ACTIONS(3685),
    [anon_sym__alignof] = ACTIONS(3685),
    [anon_sym_alignof] = ACTIONS(3685),
    [anon_sym__Alignof] = ACTIONS(3685),
    [anon_sym_offsetof] = ACTIONS(3685),
    [anon_sym__Generic] = ACTIONS(3685),
    [anon_sym_asm] = ACTIONS(3685),
    [anon_sym___asm__] = ACTIONS(3685),
    [sym_number_literal] = ACTIONS(3687),
    [anon_sym_L_SQUOTE] = ACTIONS(3687),
    [anon_sym_u_SQUOTE] = ACTIONS(3687),
    [anon_sym_U_SQUOTE] = ACTIONS(3687),
    [anon_sym_u8_SQUOTE] = ACTIONS(3687),
    [anon_sym_SQUOTE] = ACTIONS(3687),
    [anon_sym_L_DQUOTE] = ACTIONS(3687),
    [anon_sym_u_DQUOTE] = ACTIONS(3687),
    [anon_sym_U_DQUOTE] = ACTIONS(3687),
    [anon_sym_u8_DQUOTE] = ACTIONS(3687),
    [anon_sym_DQUOTE] = ACTIONS(3687),
    [sym_true] = ACTIONS(3685),
    [sym_false] = ACTIONS(3685),
    [anon_sym_NULL] = ACTIONS(3685),
    [anon_sym_nullptr] = ACTIONS(3685),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_This] = ACTIONS(3685),
    [anon_sym_decltype] = ACTIONS(3685),
    [sym_virtual] = ACTIONS(3685),
    [anon_sym_explicit] = ACTIONS(3685),
    [anon_sym_typename] = ACTIONS(3685),
    [anon_sym_template] = ACTIONS(3685),
    [anon_sym_operator] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_delete] = ACTIONS(3685),
    [anon_sym_throw] = ACTIONS(3685),
    [anon_sym_namespace] = ACTIONS(3685),
    [anon_sym_using] = ACTIONS(3685),
    [anon_sym_static_assert] = ACTIONS(3685),
    [anon_sym_concept] = ACTIONS(3685),
    [anon_sym_co_return] = ACTIONS(3685),
    [anon_sym_co_yield] = ACTIONS(3685),
    [anon_sym_R_DQUOTE] = ACTIONS(3687),
    [anon_sym_LR_DQUOTE] = ACTIONS(3687),
    [anon_sym_uR_DQUOTE] = ACTIONS(3687),
    [anon_sym_UR_DQUOTE] = ACTIONS(3687),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3687),
    [anon_sym_co_await] = ACTIONS(3685),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_requires] = ACTIONS(3685),
    [sym_this] = ACTIONS(3685),
    [anon_sym_discard] = ACTIONS(3685),
    [anon_sym_precise] = ACTIONS(3685),
    [anon_sym_shared] = ACTIONS(3685),
    [anon_sym_groupshared] = ACTIONS(3685),
    [anon_sym_uniform] = ACTIONS(3685),
    [anon_sym_row_major] = ACTIONS(3685),
    [anon_sym_column_major] = ACTIONS(3685),
    [anon_sym_globallycoherent] = ACTIONS(3685),
    [anon_sym_centroid] = ACTIONS(3685),
    [anon_sym_noperspective] = ACTIONS(3685),
    [anon_sym_nointerpolation] = ACTIONS(3685),
    [anon_sym_sample] = ACTIONS(3685),
    [anon_sym_linear] = ACTIONS(3685),
    [anon_sym_snorm] = ACTIONS(3685),
    [anon_sym_unorm] = ACTIONS(3685),
    [anon_sym_point] = ACTIONS(3685),
    [anon_sym_line] = ACTIONS(3685),
    [anon_sym_triangleadj] = ACTIONS(3685),
    [anon_sym_lineadj] = ACTIONS(3685),
    [anon_sym_triangle] = ACTIONS(3685),
    [anon_sym_cbuffer] = ACTIONS(3685),
    [anon_sym_interface] = ACTIONS(3685),
    [anon_sym_extension] = ACTIONS(3685),
  },
  [861] = {
    [sym_identifier] = ACTIONS(3681),
    [aux_sym_preproc_include_token1] = ACTIONS(3681),
    [aux_sym_preproc_def_token1] = ACTIONS(3681),
    [aux_sym_preproc_if_token1] = ACTIONS(3681),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3681),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3681),
    [sym_preproc_directive] = ACTIONS(3681),
    [anon_sym_LPAREN2] = ACTIONS(3683),
    [anon_sym_BANG] = ACTIONS(3683),
    [anon_sym_TILDE] = ACTIONS(3683),
    [anon_sym_DASH] = ACTIONS(3681),
    [anon_sym_PLUS] = ACTIONS(3681),
    [anon_sym_STAR] = ACTIONS(3683),
    [anon_sym_AMP_AMP] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3681),
    [anon_sym_SEMI] = ACTIONS(3683),
    [anon_sym___extension__] = ACTIONS(3681),
    [anon_sym_typedef] = ACTIONS(3681),
    [anon_sym_in] = ACTIONS(3681),
    [anon_sym_out] = ACTIONS(3681),
    [anon_sym_inout] = ACTIONS(3681),
    [anon_sym_extern] = ACTIONS(3681),
    [anon_sym___attribute__] = ACTIONS(3681),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3683),
    [anon_sym___declspec] = ACTIONS(3681),
    [anon_sym___based] = ACTIONS(3681),
    [anon_sym___cdecl] = ACTIONS(3681),
    [anon_sym___clrcall] = ACTIONS(3681),
    [anon_sym___stdcall] = ACTIONS(3681),
    [anon_sym___fastcall] = ACTIONS(3681),
    [anon_sym___thiscall] = ACTIONS(3681),
    [anon_sym___vectorcall] = ACTIONS(3681),
    [anon_sym_LBRACE] = ACTIONS(3683),
    [anon_sym_RBRACE] = ACTIONS(3683),
    [anon_sym_signed] = ACTIONS(3681),
    [anon_sym_unsigned] = ACTIONS(3681),
    [anon_sym_long] = ACTIONS(3681),
    [anon_sym_short] = ACTIONS(3681),
    [anon_sym_LBRACK] = ACTIONS(3681),
    [anon_sym_static] = ACTIONS(3681),
    [anon_sym_register] = ACTIONS(3681),
    [anon_sym_inline] = ACTIONS(3681),
    [anon_sym___inline] = ACTIONS(3681),
    [anon_sym___inline__] = ACTIONS(3681),
    [anon_sym___forceinline] = ACTIONS(3681),
    [anon_sym_thread_local] = ACTIONS(3681),
    [anon_sym___thread] = ACTIONS(3681),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_constexpr] = ACTIONS(3681),
    [anon_sym_volatile] = ACTIONS(3681),
    [anon_sym_restrict] = ACTIONS(3681),
    [anon_sym___restrict__] = ACTIONS(3681),
    [anon_sym__Atomic] = ACTIONS(3681),
    [anon_sym__Noreturn] = ACTIONS(3681),
    [anon_sym_noreturn] = ACTIONS(3681),
    [anon_sym_mutable] = ACTIONS(3681),
    [anon_sym_constinit] = ACTIONS(3681),
    [anon_sym_consteval] = ACTIONS(3681),
    [anon_sym_alignas] = ACTIONS(3681),
    [anon_sym__Alignas] = ACTIONS(3681),
    [sym_primitive_type] = ACTIONS(3681),
    [anon_sym_enum] = ACTIONS(3681),
    [anon_sym_class] = ACTIONS(3681),
    [anon_sym_struct] = ACTIONS(3681),
    [anon_sym_union] = ACTIONS(3681),
    [anon_sym_if] = ACTIONS(3681),
    [anon_sym_switch] = ACTIONS(3681),
    [anon_sym_case] = ACTIONS(3681),
    [anon_sym_default] = ACTIONS(3681),
    [anon_sym_while] = ACTIONS(3681),
    [anon_sym_do] = ACTIONS(3681),
    [anon_sym_for] = ACTIONS(3681),
    [anon_sym_return] = ACTIONS(3681),
    [anon_sym_break] = ACTIONS(3681),
    [anon_sym_continue] = ACTIONS(3681),
    [anon_sym_goto] = ACTIONS(3681),
    [anon_sym___try] = ACTIONS(3681),
    [anon_sym___leave] = ACTIONS(3681),
    [anon_sym_not] = ACTIONS(3681),
    [anon_sym_compl] = ACTIONS(3681),
    [anon_sym_DASH_DASH] = ACTIONS(3683),
    [anon_sym_PLUS_PLUS] = ACTIONS(3683),
    [anon_sym_sizeof] = ACTIONS(3681),
    [anon_sym___alignof__] = ACTIONS(3681),
    [anon_sym___alignof] = ACTIONS(3681),
    [anon_sym__alignof] = ACTIONS(3681),
    [anon_sym_alignof] = ACTIONS(3681),
    [anon_sym__Alignof] = ACTIONS(3681),
    [anon_sym_offsetof] = ACTIONS(3681),
    [anon_sym__Generic] = ACTIONS(3681),
    [anon_sym_asm] = ACTIONS(3681),
    [anon_sym___asm__] = ACTIONS(3681),
    [sym_number_literal] = ACTIONS(3683),
    [anon_sym_L_SQUOTE] = ACTIONS(3683),
    [anon_sym_u_SQUOTE] = ACTIONS(3683),
    [anon_sym_U_SQUOTE] = ACTIONS(3683),
    [anon_sym_u8_SQUOTE] = ACTIONS(3683),
    [anon_sym_SQUOTE] = ACTIONS(3683),
    [anon_sym_L_DQUOTE] = ACTIONS(3683),
    [anon_sym_u_DQUOTE] = ACTIONS(3683),
    [anon_sym_U_DQUOTE] = ACTIONS(3683),
    [anon_sym_u8_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE] = ACTIONS(3683),
    [sym_true] = ACTIONS(3681),
    [sym_false] = ACTIONS(3681),
    [anon_sym_NULL] = ACTIONS(3681),
    [anon_sym_nullptr] = ACTIONS(3681),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3681),
    [anon_sym_let] = ACTIONS(3681),
    [anon_sym_This] = ACTIONS(3681),
    [anon_sym_decltype] = ACTIONS(3681),
    [sym_virtual] = ACTIONS(3681),
    [anon_sym_explicit] = ACTIONS(3681),
    [anon_sym_typename] = ACTIONS(3681),
    [anon_sym_template] = ACTIONS(3681),
    [anon_sym_operator] = ACTIONS(3681),
    [anon_sym_try] = ACTIONS(3681),
    [anon_sym_delete] = ACTIONS(3681),
    [anon_sym_throw] = ACTIONS(3681),
    [anon_sym_namespace] = ACTIONS(3681),
    [anon_sym_using] = ACTIONS(3681),
    [anon_sym_static_assert] = ACTIONS(3681),
    [anon_sym_concept] = ACTIONS(3681),
    [anon_sym_co_return] = ACTIONS(3681),
    [anon_sym_co_yield] = ACTIONS(3681),
    [anon_sym_R_DQUOTE] = ACTIONS(3683),
    [anon_sym_LR_DQUOTE] = ACTIONS(3683),
    [anon_sym_uR_DQUOTE] = ACTIONS(3683),
    [anon_sym_UR_DQUOTE] = ACTIONS(3683),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3683),
    [anon_sym_co_await] = ACTIONS(3681),
    [anon_sym_new] = ACTIONS(3681),
    [anon_sym_requires] = ACTIONS(3681),
    [sym_this] = ACTIONS(3681),
    [anon_sym_discard] = ACTIONS(3681),
    [anon_sym_precise] = ACTIONS(3681),
    [anon_sym_shared] = ACTIONS(3681),
    [anon_sym_groupshared] = ACTIONS(3681),
    [anon_sym_uniform] = ACTIONS(3681),
    [anon_sym_row_major] = ACTIONS(3681),
    [anon_sym_column_major] = ACTIONS(3681),
    [anon_sym_globallycoherent] = ACTIONS(3681),
    [anon_sym_centroid] = ACTIONS(3681),
    [anon_sym_noperspective] = ACTIONS(3681),
    [anon_sym_nointerpolation] = ACTIONS(3681),
    [anon_sym_sample] = ACTIONS(3681),
    [anon_sym_linear] = ACTIONS(3681),
    [anon_sym_snorm] = ACTIONS(3681),
    [anon_sym_unorm] = ACTIONS(3681),
    [anon_sym_point] = ACTIONS(3681),
    [anon_sym_line] = ACTIONS(3681),
    [anon_sym_triangleadj] = ACTIONS(3681),
    [anon_sym_lineadj] = ACTIONS(3681),
    [anon_sym_triangle] = ACTIONS(3681),
    [anon_sym_cbuffer] = ACTIONS(3681),
    [anon_sym_interface] = ACTIONS(3681),
    [anon_sym_extension] = ACTIONS(3681),
  },
  [862] = {
    [sym_attribute_specifier] = STATE(297),
    [ts_builtin_sym_end] = ACTIONS(3838),
    [sym_identifier] = ACTIONS(3836),
    [aux_sym_preproc_include_token1] = ACTIONS(3836),
    [aux_sym_preproc_def_token1] = ACTIONS(3836),
    [aux_sym_preproc_if_token1] = ACTIONS(3836),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3836),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3836),
    [sym_preproc_directive] = ACTIONS(3836),
    [anon_sym_LPAREN2] = ACTIONS(3838),
    [anon_sym_BANG] = ACTIONS(3838),
    [anon_sym_TILDE] = ACTIONS(3838),
    [anon_sym_DASH] = ACTIONS(3836),
    [anon_sym_PLUS] = ACTIONS(3836),
    [anon_sym_STAR] = ACTIONS(3838),
    [anon_sym_AMP_AMP] = ACTIONS(3838),
    [anon_sym_AMP] = ACTIONS(3836),
    [anon_sym_SEMI] = ACTIONS(3838),
    [anon_sym___extension__] = ACTIONS(3836),
    [anon_sym_typedef] = ACTIONS(3836),
    [anon_sym_in] = ACTIONS(3836),
    [anon_sym_out] = ACTIONS(3836),
    [anon_sym_inout] = ACTIONS(3836),
    [anon_sym_extern] = ACTIONS(3836),
    [anon_sym___attribute__] = ACTIONS(2861),
    [anon_sym_COLON_COLON] = ACTIONS(3838),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3838),
    [anon_sym___declspec] = ACTIONS(3836),
    [anon_sym___based] = ACTIONS(3836),
    [anon_sym___cdecl] = ACTIONS(3836),
    [anon_sym___clrcall] = ACTIONS(3836),
    [anon_sym___stdcall] = ACTIONS(3836),
    [anon_sym___fastcall] = ACTIONS(3836),
    [anon_sym___thiscall] = ACTIONS(3836),
    [anon_sym___vectorcall] = ACTIONS(3836),
    [anon_sym_LBRACE] = ACTIONS(3838),
    [anon_sym_signed] = ACTIONS(3836),
    [anon_sym_unsigned] = ACTIONS(3836),
    [anon_sym_long] = ACTIONS(3836),
    [anon_sym_short] = ACTIONS(3836),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_static] = ACTIONS(3836),
    [anon_sym_register] = ACTIONS(3836),
    [anon_sym_inline] = ACTIONS(3836),
    [anon_sym___inline] = ACTIONS(3836),
    [anon_sym___inline__] = ACTIONS(3836),
    [anon_sym___forceinline] = ACTIONS(3836),
    [anon_sym_thread_local] = ACTIONS(3836),
    [anon_sym___thread] = ACTIONS(3836),
    [anon_sym_const] = ACTIONS(3836),
    [anon_sym_constexpr] = ACTIONS(3836),
    [anon_sym_volatile] = ACTIONS(3836),
    [anon_sym_restrict] = ACTIONS(3836),
    [anon_sym___restrict__] = ACTIONS(3836),
    [anon_sym__Atomic] = ACTIONS(3836),
    [anon_sym__Noreturn] = ACTIONS(3836),
    [anon_sym_noreturn] = ACTIONS(3836),
    [anon_sym_mutable] = ACTIONS(3836),
    [anon_sym_constinit] = ACTIONS(3836),
    [anon_sym_consteval] = ACTIONS(3836),
    [anon_sym_alignas] = ACTIONS(3836),
    [anon_sym__Alignas] = ACTIONS(3836),
    [sym_primitive_type] = ACTIONS(3836),
    [anon_sym_enum] = ACTIONS(3836),
    [anon_sym_class] = ACTIONS(3836),
    [anon_sym_struct] = ACTIONS(3836),
    [anon_sym_union] = ACTIONS(3836),
    [anon_sym_if] = ACTIONS(3836),
    [anon_sym_switch] = ACTIONS(3836),
    [anon_sym_case] = ACTIONS(3836),
    [anon_sym_default] = ACTIONS(3836),
    [anon_sym_while] = ACTIONS(3836),
    [anon_sym_do] = ACTIONS(3836),
    [anon_sym_for] = ACTIONS(3836),
    [anon_sym_return] = ACTIONS(3836),
    [anon_sym_break] = ACTIONS(3836),
    [anon_sym_continue] = ACTIONS(3836),
    [anon_sym_goto] = ACTIONS(3836),
    [anon_sym_not] = ACTIONS(3836),
    [anon_sym_compl] = ACTIONS(3836),
    [anon_sym_DASH_DASH] = ACTIONS(3838),
    [anon_sym_PLUS_PLUS] = ACTIONS(3838),
    [anon_sym_sizeof] = ACTIONS(3836),
    [anon_sym___alignof__] = ACTIONS(3836),
    [anon_sym___alignof] = ACTIONS(3836),
    [anon_sym__alignof] = ACTIONS(3836),
    [anon_sym_alignof] = ACTIONS(3836),
    [anon_sym__Alignof] = ACTIONS(3836),
    [anon_sym_offsetof] = ACTIONS(3836),
    [anon_sym__Generic] = ACTIONS(3836),
    [anon_sym_asm] = ACTIONS(3836),
    [anon_sym___asm__] = ACTIONS(3836),
    [anon_sym_DOT] = ACTIONS(3836),
    [sym_number_literal] = ACTIONS(3838),
    [anon_sym_L_SQUOTE] = ACTIONS(3838),
    [anon_sym_u_SQUOTE] = ACTIONS(3838),
    [anon_sym_U_SQUOTE] = ACTIONS(3838),
    [anon_sym_u8_SQUOTE] = ACTIONS(3838),
    [anon_sym_SQUOTE] = ACTIONS(3838),
    [anon_sym_L_DQUOTE] = ACTIONS(3838),
    [anon_sym_u_DQUOTE] = ACTIONS(3838),
    [anon_sym_U_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8_DQUOTE] = ACTIONS(3838),
    [anon_sym_DQUOTE] = ACTIONS(3838),
    [sym_true] = ACTIONS(3836),
    [sym_false] = ACTIONS(3836),
    [anon_sym_NULL] = ACTIONS(3836),
    [anon_sym_nullptr] = ACTIONS(3836),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3836),
    [anon_sym_let] = ACTIONS(3836),
    [anon_sym_This] = ACTIONS(3836),
    [anon_sym_decltype] = ACTIONS(3836),
    [sym_virtual] = ACTIONS(3836),
    [anon_sym_explicit] = ACTIONS(3836),
    [anon_sym_typename] = ACTIONS(3836),
    [anon_sym_template] = ACTIONS(3836),
    [anon_sym_operator] = ACTIONS(3836),
    [anon_sym_try] = ACTIONS(3836),
    [anon_sym_delete] = ACTIONS(3836),
    [anon_sym_throw] = ACTIONS(3836),
    [anon_sym_namespace] = ACTIONS(3836),
    [anon_sym_using] = ACTIONS(3836),
    [anon_sym_static_assert] = ACTIONS(3836),
    [anon_sym_concept] = ACTIONS(3836),
    [anon_sym_co_return] = ACTIONS(3836),
    [anon_sym_co_yield] = ACTIONS(3836),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [anon_sym_co_await] = ACTIONS(3836),
    [anon_sym_new] = ACTIONS(3836),
    [anon_sym_requires] = ACTIONS(3836),
    [sym_this] = ACTIONS(3836),
    [anon_sym_precise] = ACTIONS(3836),
    [anon_sym_shared] = ACTIONS(3836),
    [anon_sym_groupshared] = ACTIONS(3836),
    [anon_sym_uniform] = ACTIONS(3836),
    [anon_sym_row_major] = ACTIONS(3836),
    [anon_sym_column_major] = ACTIONS(3836),
    [anon_sym_globallycoherent] = ACTIONS(3836),
    [anon_sym_centroid] = ACTIONS(3836),
    [anon_sym_noperspective] = ACTIONS(3836),
    [anon_sym_nointerpolation] = ACTIONS(3836),
    [anon_sym_sample] = ACTIONS(3836),
    [anon_sym_linear] = ACTIONS(3836),
    [anon_sym_snorm] = ACTIONS(3836),
    [anon_sym_unorm] = ACTIONS(3836),
    [anon_sym_point] = ACTIONS(3836),
    [anon_sym_line] = ACTIONS(3836),
    [anon_sym_triangleadj] = ACTIONS(3836),
    [anon_sym_lineadj] = ACTIONS(3836),
    [anon_sym_triangle] = ACTIONS(3836),
    [anon_sym_interface] = ACTIONS(3836),
    [anon_sym_extension] = ACTIONS(3836),
    [anon_sym___exported] = ACTIONS(3836),
    [anon_sym_import] = ACTIONS(3836),
  },
  [863] = {
    [sym_identifier] = ACTIONS(3641),
    [aux_sym_preproc_include_token1] = ACTIONS(3641),
    [aux_sym_preproc_def_token1] = ACTIONS(3641),
    [aux_sym_preproc_if_token1] = ACTIONS(3641),
    [aux_sym_preproc_if_token2] = ACTIONS(3641),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3641),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3641),
    [sym_preproc_directive] = ACTIONS(3641),
    [anon_sym_LPAREN2] = ACTIONS(3643),
    [anon_sym_BANG] = ACTIONS(3643),
    [anon_sym_TILDE] = ACTIONS(3643),
    [anon_sym_DASH] = ACTIONS(3641),
    [anon_sym_PLUS] = ACTIONS(3641),
    [anon_sym_STAR] = ACTIONS(3643),
    [anon_sym_AMP_AMP] = ACTIONS(3643),
    [anon_sym_AMP] = ACTIONS(3641),
    [anon_sym_SEMI] = ACTIONS(3643),
    [anon_sym___extension__] = ACTIONS(3641),
    [anon_sym_typedef] = ACTIONS(3641),
    [anon_sym_in] = ACTIONS(3641),
    [anon_sym_out] = ACTIONS(3641),
    [anon_sym_inout] = ACTIONS(3641),
    [anon_sym_extern] = ACTIONS(3641),
    [anon_sym___attribute__] = ACTIONS(3641),
    [anon_sym_COLON_COLON] = ACTIONS(3643),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3643),
    [anon_sym___declspec] = ACTIONS(3641),
    [anon_sym___based] = ACTIONS(3641),
    [anon_sym___cdecl] = ACTIONS(3641),
    [anon_sym___clrcall] = ACTIONS(3641),
    [anon_sym___stdcall] = ACTIONS(3641),
    [anon_sym___fastcall] = ACTIONS(3641),
    [anon_sym___thiscall] = ACTIONS(3641),
    [anon_sym___vectorcall] = ACTIONS(3641),
    [anon_sym_LBRACE] = ACTIONS(3643),
    [anon_sym_signed] = ACTIONS(3641),
    [anon_sym_unsigned] = ACTIONS(3641),
    [anon_sym_long] = ACTIONS(3641),
    [anon_sym_short] = ACTIONS(3641),
    [anon_sym_LBRACK] = ACTIONS(3641),
    [anon_sym_static] = ACTIONS(3641),
    [anon_sym_register] = ACTIONS(3641),
    [anon_sym_inline] = ACTIONS(3641),
    [anon_sym___inline] = ACTIONS(3641),
    [anon_sym___inline__] = ACTIONS(3641),
    [anon_sym___forceinline] = ACTIONS(3641),
    [anon_sym_thread_local] = ACTIONS(3641),
    [anon_sym___thread] = ACTIONS(3641),
    [anon_sym_const] = ACTIONS(3641),
    [anon_sym_constexpr] = ACTIONS(3641),
    [anon_sym_volatile] = ACTIONS(3641),
    [anon_sym_restrict] = ACTIONS(3641),
    [anon_sym___restrict__] = ACTIONS(3641),
    [anon_sym__Atomic] = ACTIONS(3641),
    [anon_sym__Noreturn] = ACTIONS(3641),
    [anon_sym_noreturn] = ACTIONS(3641),
    [anon_sym_mutable] = ACTIONS(3641),
    [anon_sym_constinit] = ACTIONS(3641),
    [anon_sym_consteval] = ACTIONS(3641),
    [anon_sym_alignas] = ACTIONS(3641),
    [anon_sym__Alignas] = ACTIONS(3641),
    [sym_primitive_type] = ACTIONS(3641),
    [anon_sym_enum] = ACTIONS(3641),
    [anon_sym_class] = ACTIONS(3641),
    [anon_sym_struct] = ACTIONS(3641),
    [anon_sym_union] = ACTIONS(3641),
    [anon_sym_if] = ACTIONS(3641),
    [anon_sym_switch] = ACTIONS(3641),
    [anon_sym_case] = ACTIONS(3641),
    [anon_sym_default] = ACTIONS(3641),
    [anon_sym_while] = ACTIONS(3641),
    [anon_sym_do] = ACTIONS(3641),
    [anon_sym_for] = ACTIONS(3641),
    [anon_sym_return] = ACTIONS(3641),
    [anon_sym_break] = ACTIONS(3641),
    [anon_sym_continue] = ACTIONS(3641),
    [anon_sym_goto] = ACTIONS(3641),
    [anon_sym___try] = ACTIONS(3641),
    [anon_sym___leave] = ACTIONS(3641),
    [anon_sym_not] = ACTIONS(3641),
    [anon_sym_compl] = ACTIONS(3641),
    [anon_sym_DASH_DASH] = ACTIONS(3643),
    [anon_sym_PLUS_PLUS] = ACTIONS(3643),
    [anon_sym_sizeof] = ACTIONS(3641),
    [anon_sym___alignof__] = ACTIONS(3641),
    [anon_sym___alignof] = ACTIONS(3641),
    [anon_sym__alignof] = ACTIONS(3641),
    [anon_sym_alignof] = ACTIONS(3641),
    [anon_sym__Alignof] = ACTIONS(3641),
    [anon_sym_offsetof] = ACTIONS(3641),
    [anon_sym__Generic] = ACTIONS(3641),
    [anon_sym_asm] = ACTIONS(3641),
    [anon_sym___asm__] = ACTIONS(3641),
    [sym_number_literal] = ACTIONS(3643),
    [anon_sym_L_SQUOTE] = ACTIONS(3643),
    [anon_sym_u_SQUOTE] = ACTIONS(3643),
    [anon_sym_U_SQUOTE] = ACTIONS(3643),
    [anon_sym_u8_SQUOTE] = ACTIONS(3643),
    [anon_sym_SQUOTE] = ACTIONS(3643),
    [anon_sym_L_DQUOTE] = ACTIONS(3643),
    [anon_sym_u_DQUOTE] = ACTIONS(3643),
    [anon_sym_U_DQUOTE] = ACTIONS(3643),
    [anon_sym_u8_DQUOTE] = ACTIONS(3643),
    [anon_sym_DQUOTE] = ACTIONS(3643),
    [sym_true] = ACTIONS(3641),
    [sym_false] = ACTIONS(3641),
    [anon_sym_NULL] = ACTIONS(3641),
    [anon_sym_nullptr] = ACTIONS(3641),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3641),
    [anon_sym_let] = ACTIONS(3641),
    [anon_sym_This] = ACTIONS(3641),
    [anon_sym_decltype] = ACTIONS(3641),
    [sym_virtual] = ACTIONS(3641),
    [anon_sym_explicit] = ACTIONS(3641),
    [anon_sym_typename] = ACTIONS(3641),
    [anon_sym_template] = ACTIONS(3641),
    [anon_sym_operator] = ACTIONS(3641),
    [anon_sym_try] = ACTIONS(3641),
    [anon_sym_delete] = ACTIONS(3641),
    [anon_sym_throw] = ACTIONS(3641),
    [anon_sym_namespace] = ACTIONS(3641),
    [anon_sym_using] = ACTIONS(3641),
    [anon_sym_static_assert] = ACTIONS(3641),
    [anon_sym_concept] = ACTIONS(3641),
    [anon_sym_co_return] = ACTIONS(3641),
    [anon_sym_co_yield] = ACTIONS(3641),
    [anon_sym_R_DQUOTE] = ACTIONS(3643),
    [anon_sym_LR_DQUOTE] = ACTIONS(3643),
    [anon_sym_uR_DQUOTE] = ACTIONS(3643),
    [anon_sym_UR_DQUOTE] = ACTIONS(3643),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3643),
    [anon_sym_co_await] = ACTIONS(3641),
    [anon_sym_new] = ACTIONS(3641),
    [anon_sym_requires] = ACTIONS(3641),
    [sym_this] = ACTIONS(3641),
    [anon_sym_discard] = ACTIONS(3641),
    [anon_sym_precise] = ACTIONS(3641),
    [anon_sym_shared] = ACTIONS(3641),
    [anon_sym_groupshared] = ACTIONS(3641),
    [anon_sym_uniform] = ACTIONS(3641),
    [anon_sym_row_major] = ACTIONS(3641),
    [anon_sym_column_major] = ACTIONS(3641),
    [anon_sym_globallycoherent] = ACTIONS(3641),
    [anon_sym_centroid] = ACTIONS(3641),
    [anon_sym_noperspective] = ACTIONS(3641),
    [anon_sym_nointerpolation] = ACTIONS(3641),
    [anon_sym_sample] = ACTIONS(3641),
    [anon_sym_linear] = ACTIONS(3641),
    [anon_sym_snorm] = ACTIONS(3641),
    [anon_sym_unorm] = ACTIONS(3641),
    [anon_sym_point] = ACTIONS(3641),
    [anon_sym_line] = ACTIONS(3641),
    [anon_sym_triangleadj] = ACTIONS(3641),
    [anon_sym_lineadj] = ACTIONS(3641),
    [anon_sym_triangle] = ACTIONS(3641),
    [anon_sym_cbuffer] = ACTIONS(3641),
    [anon_sym_interface] = ACTIONS(3641),
    [anon_sym_extension] = ACTIONS(3641),
  },
  [864] = {
    [sym_identifier] = ACTIONS(3665),
    [aux_sym_preproc_include_token1] = ACTIONS(3665),
    [aux_sym_preproc_def_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3665),
    [sym_preproc_directive] = ACTIONS(3665),
    [anon_sym_LPAREN2] = ACTIONS(3667),
    [anon_sym_BANG] = ACTIONS(3667),
    [anon_sym_TILDE] = ACTIONS(3667),
    [anon_sym_DASH] = ACTIONS(3665),
    [anon_sym_PLUS] = ACTIONS(3665),
    [anon_sym_STAR] = ACTIONS(3667),
    [anon_sym_AMP_AMP] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym_SEMI] = ACTIONS(3667),
    [anon_sym___extension__] = ACTIONS(3665),
    [anon_sym_typedef] = ACTIONS(3665),
    [anon_sym_in] = ACTIONS(3665),
    [anon_sym_out] = ACTIONS(3665),
    [anon_sym_inout] = ACTIONS(3665),
    [anon_sym_extern] = ACTIONS(3665),
    [anon_sym___attribute__] = ACTIONS(3665),
    [anon_sym_COLON_COLON] = ACTIONS(3667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3667),
    [anon_sym___declspec] = ACTIONS(3665),
    [anon_sym___based] = ACTIONS(3665),
    [anon_sym___cdecl] = ACTIONS(3665),
    [anon_sym___clrcall] = ACTIONS(3665),
    [anon_sym___stdcall] = ACTIONS(3665),
    [anon_sym___fastcall] = ACTIONS(3665),
    [anon_sym___thiscall] = ACTIONS(3665),
    [anon_sym___vectorcall] = ACTIONS(3665),
    [anon_sym_LBRACE] = ACTIONS(3667),
    [anon_sym_RBRACE] = ACTIONS(3667),
    [anon_sym_signed] = ACTIONS(3665),
    [anon_sym_unsigned] = ACTIONS(3665),
    [anon_sym_long] = ACTIONS(3665),
    [anon_sym_short] = ACTIONS(3665),
    [anon_sym_LBRACK] = ACTIONS(3665),
    [anon_sym_static] = ACTIONS(3665),
    [anon_sym_register] = ACTIONS(3665),
    [anon_sym_inline] = ACTIONS(3665),
    [anon_sym___inline] = ACTIONS(3665),
    [anon_sym___inline__] = ACTIONS(3665),
    [anon_sym___forceinline] = ACTIONS(3665),
    [anon_sym_thread_local] = ACTIONS(3665),
    [anon_sym___thread] = ACTIONS(3665),
    [anon_sym_const] = ACTIONS(3665),
    [anon_sym_constexpr] = ACTIONS(3665),
    [anon_sym_volatile] = ACTIONS(3665),
    [anon_sym_restrict] = ACTIONS(3665),
    [anon_sym___restrict__] = ACTIONS(3665),
    [anon_sym__Atomic] = ACTIONS(3665),
    [anon_sym__Noreturn] = ACTIONS(3665),
    [anon_sym_noreturn] = ACTIONS(3665),
    [anon_sym_mutable] = ACTIONS(3665),
    [anon_sym_constinit] = ACTIONS(3665),
    [anon_sym_consteval] = ACTIONS(3665),
    [anon_sym_alignas] = ACTIONS(3665),
    [anon_sym__Alignas] = ACTIONS(3665),
    [sym_primitive_type] = ACTIONS(3665),
    [anon_sym_enum] = ACTIONS(3665),
    [anon_sym_class] = ACTIONS(3665),
    [anon_sym_struct] = ACTIONS(3665),
    [anon_sym_union] = ACTIONS(3665),
    [anon_sym_if] = ACTIONS(3665),
    [anon_sym_switch] = ACTIONS(3665),
    [anon_sym_case] = ACTIONS(3665),
    [anon_sym_default] = ACTIONS(3665),
    [anon_sym_while] = ACTIONS(3665),
    [anon_sym_do] = ACTIONS(3665),
    [anon_sym_for] = ACTIONS(3665),
    [anon_sym_return] = ACTIONS(3665),
    [anon_sym_break] = ACTIONS(3665),
    [anon_sym_continue] = ACTIONS(3665),
    [anon_sym_goto] = ACTIONS(3665),
    [anon_sym___try] = ACTIONS(3665),
    [anon_sym___leave] = ACTIONS(3665),
    [anon_sym_not] = ACTIONS(3665),
    [anon_sym_compl] = ACTIONS(3665),
    [anon_sym_DASH_DASH] = ACTIONS(3667),
    [anon_sym_PLUS_PLUS] = ACTIONS(3667),
    [anon_sym_sizeof] = ACTIONS(3665),
    [anon_sym___alignof__] = ACTIONS(3665),
    [anon_sym___alignof] = ACTIONS(3665),
    [anon_sym__alignof] = ACTIONS(3665),
    [anon_sym_alignof] = ACTIONS(3665),
    [anon_sym__Alignof] = ACTIONS(3665),
    [anon_sym_offsetof] = ACTIONS(3665),
    [anon_sym__Generic] = ACTIONS(3665),
    [anon_sym_asm] = ACTIONS(3665),
    [anon_sym___asm__] = ACTIONS(3665),
    [sym_number_literal] = ACTIONS(3667),
    [anon_sym_L_SQUOTE] = ACTIONS(3667),
    [anon_sym_u_SQUOTE] = ACTIONS(3667),
    [anon_sym_U_SQUOTE] = ACTIONS(3667),
    [anon_sym_u8_SQUOTE] = ACTIONS(3667),
    [anon_sym_SQUOTE] = ACTIONS(3667),
    [anon_sym_L_DQUOTE] = ACTIONS(3667),
    [anon_sym_u_DQUOTE] = ACTIONS(3667),
    [anon_sym_U_DQUOTE] = ACTIONS(3667),
    [anon_sym_u8_DQUOTE] = ACTIONS(3667),
    [anon_sym_DQUOTE] = ACTIONS(3667),
    [sym_true] = ACTIONS(3665),
    [sym_false] = ACTIONS(3665),
    [anon_sym_NULL] = ACTIONS(3665),
    [anon_sym_nullptr] = ACTIONS(3665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3665),
    [anon_sym_let] = ACTIONS(3665),
    [anon_sym_This] = ACTIONS(3665),
    [anon_sym_decltype] = ACTIONS(3665),
    [sym_virtual] = ACTIONS(3665),
    [anon_sym_explicit] = ACTIONS(3665),
    [anon_sym_typename] = ACTIONS(3665),
    [anon_sym_template] = ACTIONS(3665),
    [anon_sym_operator] = ACTIONS(3665),
    [anon_sym_try] = ACTIONS(3665),
    [anon_sym_delete] = ACTIONS(3665),
    [anon_sym_throw] = ACTIONS(3665),
    [anon_sym_namespace] = ACTIONS(3665),
    [anon_sym_using] = ACTIONS(3665),
    [anon_sym_static_assert] = ACTIONS(3665),
    [anon_sym_concept] = ACTIONS(3665),
    [anon_sym_co_return] = ACTIONS(3665),
    [anon_sym_co_yield] = ACTIONS(3665),
    [anon_sym_R_DQUOTE] = ACTIONS(3667),
    [anon_sym_LR_DQUOTE] = ACTIONS(3667),
    [anon_sym_uR_DQUOTE] = ACTIONS(3667),
    [anon_sym_UR_DQUOTE] = ACTIONS(3667),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3667),
    [anon_sym_co_await] = ACTIONS(3665),
    [anon_sym_new] = ACTIONS(3665),
    [anon_sym_requires] = ACTIONS(3665),
    [sym_this] = ACTIONS(3665),
    [anon_sym_discard] = ACTIONS(3665),
    [anon_sym_precise] = ACTIONS(3665),
    [anon_sym_shared] = ACTIONS(3665),
    [anon_sym_groupshared] = ACTIONS(3665),
    [anon_sym_uniform] = ACTIONS(3665),
    [anon_sym_row_major] = ACTIONS(3665),
    [anon_sym_column_major] = ACTIONS(3665),
    [anon_sym_globallycoherent] = ACTIONS(3665),
    [anon_sym_centroid] = ACTIONS(3665),
    [anon_sym_noperspective] = ACTIONS(3665),
    [anon_sym_nointerpolation] = ACTIONS(3665),
    [anon_sym_sample] = ACTIONS(3665),
    [anon_sym_linear] = ACTIONS(3665),
    [anon_sym_snorm] = ACTIONS(3665),
    [anon_sym_unorm] = ACTIONS(3665),
    [anon_sym_point] = ACTIONS(3665),
    [anon_sym_line] = ACTIONS(3665),
    [anon_sym_triangleadj] = ACTIONS(3665),
    [anon_sym_lineadj] = ACTIONS(3665),
    [anon_sym_triangle] = ACTIONS(3665),
    [anon_sym_cbuffer] = ACTIONS(3665),
    [anon_sym_interface] = ACTIONS(3665),
    [anon_sym_extension] = ACTIONS(3665),
  },
  [865] = {
    [sym_identifier] = ACTIONS(3587),
    [aux_sym_preproc_include_token1] = ACTIONS(3587),
    [aux_sym_preproc_def_token1] = ACTIONS(3587),
    [aux_sym_preproc_if_token1] = ACTIONS(3587),
    [aux_sym_preproc_if_token2] = ACTIONS(3587),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3587),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3587),
    [sym_preproc_directive] = ACTIONS(3587),
    [anon_sym_LPAREN2] = ACTIONS(3589),
    [anon_sym_BANG] = ACTIONS(3589),
    [anon_sym_TILDE] = ACTIONS(3589),
    [anon_sym_DASH] = ACTIONS(3587),
    [anon_sym_PLUS] = ACTIONS(3587),
    [anon_sym_STAR] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3587),
    [anon_sym_SEMI] = ACTIONS(3589),
    [anon_sym___extension__] = ACTIONS(3587),
    [anon_sym_typedef] = ACTIONS(3587),
    [anon_sym_in] = ACTIONS(3587),
    [anon_sym_out] = ACTIONS(3587),
    [anon_sym_inout] = ACTIONS(3587),
    [anon_sym_extern] = ACTIONS(3587),
    [anon_sym___attribute__] = ACTIONS(3587),
    [anon_sym_COLON_COLON] = ACTIONS(3589),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3589),
    [anon_sym___declspec] = ACTIONS(3587),
    [anon_sym___based] = ACTIONS(3587),
    [anon_sym___cdecl] = ACTIONS(3587),
    [anon_sym___clrcall] = ACTIONS(3587),
    [anon_sym___stdcall] = ACTIONS(3587),
    [anon_sym___fastcall] = ACTIONS(3587),
    [anon_sym___thiscall] = ACTIONS(3587),
    [anon_sym___vectorcall] = ACTIONS(3587),
    [anon_sym_LBRACE] = ACTIONS(3589),
    [anon_sym_signed] = ACTIONS(3587),
    [anon_sym_unsigned] = ACTIONS(3587),
    [anon_sym_long] = ACTIONS(3587),
    [anon_sym_short] = ACTIONS(3587),
    [anon_sym_LBRACK] = ACTIONS(3587),
    [anon_sym_static] = ACTIONS(3587),
    [anon_sym_register] = ACTIONS(3587),
    [anon_sym_inline] = ACTIONS(3587),
    [anon_sym___inline] = ACTIONS(3587),
    [anon_sym___inline__] = ACTIONS(3587),
    [anon_sym___forceinline] = ACTIONS(3587),
    [anon_sym_thread_local] = ACTIONS(3587),
    [anon_sym___thread] = ACTIONS(3587),
    [anon_sym_const] = ACTIONS(3587),
    [anon_sym_constexpr] = ACTIONS(3587),
    [anon_sym_volatile] = ACTIONS(3587),
    [anon_sym_restrict] = ACTIONS(3587),
    [anon_sym___restrict__] = ACTIONS(3587),
    [anon_sym__Atomic] = ACTIONS(3587),
    [anon_sym__Noreturn] = ACTIONS(3587),
    [anon_sym_noreturn] = ACTIONS(3587),
    [anon_sym_mutable] = ACTIONS(3587),
    [anon_sym_constinit] = ACTIONS(3587),
    [anon_sym_consteval] = ACTIONS(3587),
    [anon_sym_alignas] = ACTIONS(3587),
    [anon_sym__Alignas] = ACTIONS(3587),
    [sym_primitive_type] = ACTIONS(3587),
    [anon_sym_enum] = ACTIONS(3587),
    [anon_sym_class] = ACTIONS(3587),
    [anon_sym_struct] = ACTIONS(3587),
    [anon_sym_union] = ACTIONS(3587),
    [anon_sym_if] = ACTIONS(3587),
    [anon_sym_switch] = ACTIONS(3587),
    [anon_sym_case] = ACTIONS(3587),
    [anon_sym_default] = ACTIONS(3587),
    [anon_sym_while] = ACTIONS(3587),
    [anon_sym_do] = ACTIONS(3587),
    [anon_sym_for] = ACTIONS(3587),
    [anon_sym_return] = ACTIONS(3587),
    [anon_sym_break] = ACTIONS(3587),
    [anon_sym_continue] = ACTIONS(3587),
    [anon_sym_goto] = ACTIONS(3587),
    [anon_sym___try] = ACTIONS(3587),
    [anon_sym___leave] = ACTIONS(3587),
    [anon_sym_not] = ACTIONS(3587),
    [anon_sym_compl] = ACTIONS(3587),
    [anon_sym_DASH_DASH] = ACTIONS(3589),
    [anon_sym_PLUS_PLUS] = ACTIONS(3589),
    [anon_sym_sizeof] = ACTIONS(3587),
    [anon_sym___alignof__] = ACTIONS(3587),
    [anon_sym___alignof] = ACTIONS(3587),
    [anon_sym__alignof] = ACTIONS(3587),
    [anon_sym_alignof] = ACTIONS(3587),
    [anon_sym__Alignof] = ACTIONS(3587),
    [anon_sym_offsetof] = ACTIONS(3587),
    [anon_sym__Generic] = ACTIONS(3587),
    [anon_sym_asm] = ACTIONS(3587),
    [anon_sym___asm__] = ACTIONS(3587),
    [sym_number_literal] = ACTIONS(3589),
    [anon_sym_L_SQUOTE] = ACTIONS(3589),
    [anon_sym_u_SQUOTE] = ACTIONS(3589),
    [anon_sym_U_SQUOTE] = ACTIONS(3589),
    [anon_sym_u8_SQUOTE] = ACTIONS(3589),
    [anon_sym_SQUOTE] = ACTIONS(3589),
    [anon_sym_L_DQUOTE] = ACTIONS(3589),
    [anon_sym_u_DQUOTE] = ACTIONS(3589),
    [anon_sym_U_DQUOTE] = ACTIONS(3589),
    [anon_sym_u8_DQUOTE] = ACTIONS(3589),
    [anon_sym_DQUOTE] = ACTIONS(3589),
    [sym_true] = ACTIONS(3587),
    [sym_false] = ACTIONS(3587),
    [anon_sym_NULL] = ACTIONS(3587),
    [anon_sym_nullptr] = ACTIONS(3587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3587),
    [anon_sym_let] = ACTIONS(3587),
    [anon_sym_This] = ACTIONS(3587),
    [anon_sym_decltype] = ACTIONS(3587),
    [sym_virtual] = ACTIONS(3587),
    [anon_sym_explicit] = ACTIONS(3587),
    [anon_sym_typename] = ACTIONS(3587),
    [anon_sym_template] = ACTIONS(3587),
    [anon_sym_operator] = ACTIONS(3587),
    [anon_sym_try] = ACTIONS(3587),
    [anon_sym_delete] = ACTIONS(3587),
    [anon_sym_throw] = ACTIONS(3587),
    [anon_sym_namespace] = ACTIONS(3587),
    [anon_sym_using] = ACTIONS(3587),
    [anon_sym_static_assert] = ACTIONS(3587),
    [anon_sym_concept] = ACTIONS(3587),
    [anon_sym_co_return] = ACTIONS(3587),
    [anon_sym_co_yield] = ACTIONS(3587),
    [anon_sym_R_DQUOTE] = ACTIONS(3589),
    [anon_sym_LR_DQUOTE] = ACTIONS(3589),
    [anon_sym_uR_DQUOTE] = ACTIONS(3589),
    [anon_sym_UR_DQUOTE] = ACTIONS(3589),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3589),
    [anon_sym_co_await] = ACTIONS(3587),
    [anon_sym_new] = ACTIONS(3587),
    [anon_sym_requires] = ACTIONS(3587),
    [sym_this] = ACTIONS(3587),
    [anon_sym_discard] = ACTIONS(3587),
    [anon_sym_precise] = ACTIONS(3587),
    [anon_sym_shared] = ACTIONS(3587),
    [anon_sym_groupshared] = ACTIONS(3587),
    [anon_sym_uniform] = ACTIONS(3587),
    [anon_sym_row_major] = ACTIONS(3587),
    [anon_sym_column_major] = ACTIONS(3587),
    [anon_sym_globallycoherent] = ACTIONS(3587),
    [anon_sym_centroid] = ACTIONS(3587),
    [anon_sym_noperspective] = ACTIONS(3587),
    [anon_sym_nointerpolation] = ACTIONS(3587),
    [anon_sym_sample] = ACTIONS(3587),
    [anon_sym_linear] = ACTIONS(3587),
    [anon_sym_snorm] = ACTIONS(3587),
    [anon_sym_unorm] = ACTIONS(3587),
    [anon_sym_point] = ACTIONS(3587),
    [anon_sym_line] = ACTIONS(3587),
    [anon_sym_triangleadj] = ACTIONS(3587),
    [anon_sym_lineadj] = ACTIONS(3587),
    [anon_sym_triangle] = ACTIONS(3587),
    [anon_sym_cbuffer] = ACTIONS(3587),
    [anon_sym_interface] = ACTIONS(3587),
    [anon_sym_extension] = ACTIONS(3587),
  },
  [866] = {
    [sym_identifier] = ACTIONS(3605),
    [aux_sym_preproc_include_token1] = ACTIONS(3605),
    [aux_sym_preproc_def_token1] = ACTIONS(3605),
    [aux_sym_preproc_if_token1] = ACTIONS(3605),
    [aux_sym_preproc_if_token2] = ACTIONS(3605),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3605),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3605),
    [sym_preproc_directive] = ACTIONS(3605),
    [anon_sym_LPAREN2] = ACTIONS(3607),
    [anon_sym_BANG] = ACTIONS(3607),
    [anon_sym_TILDE] = ACTIONS(3607),
    [anon_sym_DASH] = ACTIONS(3605),
    [anon_sym_PLUS] = ACTIONS(3605),
    [anon_sym_STAR] = ACTIONS(3607),
    [anon_sym_AMP_AMP] = ACTIONS(3607),
    [anon_sym_AMP] = ACTIONS(3605),
    [anon_sym_SEMI] = ACTIONS(3607),
    [anon_sym___extension__] = ACTIONS(3605),
    [anon_sym_typedef] = ACTIONS(3605),
    [anon_sym_in] = ACTIONS(3605),
    [anon_sym_out] = ACTIONS(3605),
    [anon_sym_inout] = ACTIONS(3605),
    [anon_sym_extern] = ACTIONS(3605),
    [anon_sym___attribute__] = ACTIONS(3605),
    [anon_sym_COLON_COLON] = ACTIONS(3607),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3607),
    [anon_sym___declspec] = ACTIONS(3605),
    [anon_sym___based] = ACTIONS(3605),
    [anon_sym___cdecl] = ACTIONS(3605),
    [anon_sym___clrcall] = ACTIONS(3605),
    [anon_sym___stdcall] = ACTIONS(3605),
    [anon_sym___fastcall] = ACTIONS(3605),
    [anon_sym___thiscall] = ACTIONS(3605),
    [anon_sym___vectorcall] = ACTIONS(3605),
    [anon_sym_LBRACE] = ACTIONS(3607),
    [anon_sym_signed] = ACTIONS(3605),
    [anon_sym_unsigned] = ACTIONS(3605),
    [anon_sym_long] = ACTIONS(3605),
    [anon_sym_short] = ACTIONS(3605),
    [anon_sym_LBRACK] = ACTIONS(3605),
    [anon_sym_static] = ACTIONS(3605),
    [anon_sym_register] = ACTIONS(3605),
    [anon_sym_inline] = ACTIONS(3605),
    [anon_sym___inline] = ACTIONS(3605),
    [anon_sym___inline__] = ACTIONS(3605),
    [anon_sym___forceinline] = ACTIONS(3605),
    [anon_sym_thread_local] = ACTIONS(3605),
    [anon_sym___thread] = ACTIONS(3605),
    [anon_sym_const] = ACTIONS(3605),
    [anon_sym_constexpr] = ACTIONS(3605),
    [anon_sym_volatile] = ACTIONS(3605),
    [anon_sym_restrict] = ACTIONS(3605),
    [anon_sym___restrict__] = ACTIONS(3605),
    [anon_sym__Atomic] = ACTIONS(3605),
    [anon_sym__Noreturn] = ACTIONS(3605),
    [anon_sym_noreturn] = ACTIONS(3605),
    [anon_sym_mutable] = ACTIONS(3605),
    [anon_sym_constinit] = ACTIONS(3605),
    [anon_sym_consteval] = ACTIONS(3605),
    [anon_sym_alignas] = ACTIONS(3605),
    [anon_sym__Alignas] = ACTIONS(3605),
    [sym_primitive_type] = ACTIONS(3605),
    [anon_sym_enum] = ACTIONS(3605),
    [anon_sym_class] = ACTIONS(3605),
    [anon_sym_struct] = ACTIONS(3605),
    [anon_sym_union] = ACTIONS(3605),
    [anon_sym_if] = ACTIONS(3605),
    [anon_sym_switch] = ACTIONS(3605),
    [anon_sym_case] = ACTIONS(3605),
    [anon_sym_default] = ACTIONS(3605),
    [anon_sym_while] = ACTIONS(3605),
    [anon_sym_do] = ACTIONS(3605),
    [anon_sym_for] = ACTIONS(3605),
    [anon_sym_return] = ACTIONS(3605),
    [anon_sym_break] = ACTIONS(3605),
    [anon_sym_continue] = ACTIONS(3605),
    [anon_sym_goto] = ACTIONS(3605),
    [anon_sym___try] = ACTIONS(3605),
    [anon_sym___leave] = ACTIONS(3605),
    [anon_sym_not] = ACTIONS(3605),
    [anon_sym_compl] = ACTIONS(3605),
    [anon_sym_DASH_DASH] = ACTIONS(3607),
    [anon_sym_PLUS_PLUS] = ACTIONS(3607),
    [anon_sym_sizeof] = ACTIONS(3605),
    [anon_sym___alignof__] = ACTIONS(3605),
    [anon_sym___alignof] = ACTIONS(3605),
    [anon_sym__alignof] = ACTIONS(3605),
    [anon_sym_alignof] = ACTIONS(3605),
    [anon_sym__Alignof] = ACTIONS(3605),
    [anon_sym_offsetof] = ACTIONS(3605),
    [anon_sym__Generic] = ACTIONS(3605),
    [anon_sym_asm] = ACTIONS(3605),
    [anon_sym___asm__] = ACTIONS(3605),
    [sym_number_literal] = ACTIONS(3607),
    [anon_sym_L_SQUOTE] = ACTIONS(3607),
    [anon_sym_u_SQUOTE] = ACTIONS(3607),
    [anon_sym_U_SQUOTE] = ACTIONS(3607),
    [anon_sym_u8_SQUOTE] = ACTIONS(3607),
    [anon_sym_SQUOTE] = ACTIONS(3607),
    [anon_sym_L_DQUOTE] = ACTIONS(3607),
    [anon_sym_u_DQUOTE] = ACTIONS(3607),
    [anon_sym_U_DQUOTE] = ACTIONS(3607),
    [anon_sym_u8_DQUOTE] = ACTIONS(3607),
    [anon_sym_DQUOTE] = ACTIONS(3607),
    [sym_true] = ACTIONS(3605),
    [sym_false] = ACTIONS(3605),
    [anon_sym_NULL] = ACTIONS(3605),
    [anon_sym_nullptr] = ACTIONS(3605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3605),
    [anon_sym_let] = ACTIONS(3605),
    [anon_sym_This] = ACTIONS(3605),
    [anon_sym_decltype] = ACTIONS(3605),
    [sym_virtual] = ACTIONS(3605),
    [anon_sym_explicit] = ACTIONS(3605),
    [anon_sym_typename] = ACTIONS(3605),
    [anon_sym_template] = ACTIONS(3605),
    [anon_sym_operator] = ACTIONS(3605),
    [anon_sym_try] = ACTIONS(3605),
    [anon_sym_delete] = ACTIONS(3605),
    [anon_sym_throw] = ACTIONS(3605),
    [anon_sym_namespace] = ACTIONS(3605),
    [anon_sym_using] = ACTIONS(3605),
    [anon_sym_static_assert] = ACTIONS(3605),
    [anon_sym_concept] = ACTIONS(3605),
    [anon_sym_co_return] = ACTIONS(3605),
    [anon_sym_co_yield] = ACTIONS(3605),
    [anon_sym_R_DQUOTE] = ACTIONS(3607),
    [anon_sym_LR_DQUOTE] = ACTIONS(3607),
    [anon_sym_uR_DQUOTE] = ACTIONS(3607),
    [anon_sym_UR_DQUOTE] = ACTIONS(3607),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3607),
    [anon_sym_co_await] = ACTIONS(3605),
    [anon_sym_new] = ACTIONS(3605),
    [anon_sym_requires] = ACTIONS(3605),
    [sym_this] = ACTIONS(3605),
    [anon_sym_discard] = ACTIONS(3605),
    [anon_sym_precise] = ACTIONS(3605),
    [anon_sym_shared] = ACTIONS(3605),
    [anon_sym_groupshared] = ACTIONS(3605),
    [anon_sym_uniform] = ACTIONS(3605),
    [anon_sym_row_major] = ACTIONS(3605),
    [anon_sym_column_major] = ACTIONS(3605),
    [anon_sym_globallycoherent] = ACTIONS(3605),
    [anon_sym_centroid] = ACTIONS(3605),
    [anon_sym_noperspective] = ACTIONS(3605),
    [anon_sym_nointerpolation] = ACTIONS(3605),
    [anon_sym_sample] = ACTIONS(3605),
    [anon_sym_linear] = ACTIONS(3605),
    [anon_sym_snorm] = ACTIONS(3605),
    [anon_sym_unorm] = ACTIONS(3605),
    [anon_sym_point] = ACTIONS(3605),
    [anon_sym_line] = ACTIONS(3605),
    [anon_sym_triangleadj] = ACTIONS(3605),
    [anon_sym_lineadj] = ACTIONS(3605),
    [anon_sym_triangle] = ACTIONS(3605),
    [anon_sym_cbuffer] = ACTIONS(3605),
    [anon_sym_interface] = ACTIONS(3605),
    [anon_sym_extension] = ACTIONS(3605),
  },
  [867] = {
    [sym_identifier] = ACTIONS(3609),
    [aux_sym_preproc_include_token1] = ACTIONS(3609),
    [aux_sym_preproc_def_token1] = ACTIONS(3609),
    [aux_sym_preproc_if_token1] = ACTIONS(3609),
    [aux_sym_preproc_if_token2] = ACTIONS(3609),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3609),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3609),
    [sym_preproc_directive] = ACTIONS(3609),
    [anon_sym_LPAREN2] = ACTIONS(3611),
    [anon_sym_BANG] = ACTIONS(3611),
    [anon_sym_TILDE] = ACTIONS(3611),
    [anon_sym_DASH] = ACTIONS(3609),
    [anon_sym_PLUS] = ACTIONS(3609),
    [anon_sym_STAR] = ACTIONS(3611),
    [anon_sym_AMP_AMP] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3609),
    [anon_sym_SEMI] = ACTIONS(3611),
    [anon_sym___extension__] = ACTIONS(3609),
    [anon_sym_typedef] = ACTIONS(3609),
    [anon_sym_in] = ACTIONS(3609),
    [anon_sym_out] = ACTIONS(3609),
    [anon_sym_inout] = ACTIONS(3609),
    [anon_sym_extern] = ACTIONS(3609),
    [anon_sym___attribute__] = ACTIONS(3609),
    [anon_sym_COLON_COLON] = ACTIONS(3611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3611),
    [anon_sym___declspec] = ACTIONS(3609),
    [anon_sym___based] = ACTIONS(3609),
    [anon_sym___cdecl] = ACTIONS(3609),
    [anon_sym___clrcall] = ACTIONS(3609),
    [anon_sym___stdcall] = ACTIONS(3609),
    [anon_sym___fastcall] = ACTIONS(3609),
    [anon_sym___thiscall] = ACTIONS(3609),
    [anon_sym___vectorcall] = ACTIONS(3609),
    [anon_sym_LBRACE] = ACTIONS(3611),
    [anon_sym_signed] = ACTIONS(3609),
    [anon_sym_unsigned] = ACTIONS(3609),
    [anon_sym_long] = ACTIONS(3609),
    [anon_sym_short] = ACTIONS(3609),
    [anon_sym_LBRACK] = ACTIONS(3609),
    [anon_sym_static] = ACTIONS(3609),
    [anon_sym_register] = ACTIONS(3609),
    [anon_sym_inline] = ACTIONS(3609),
    [anon_sym___inline] = ACTIONS(3609),
    [anon_sym___inline__] = ACTIONS(3609),
    [anon_sym___forceinline] = ACTIONS(3609),
    [anon_sym_thread_local] = ACTIONS(3609),
    [anon_sym___thread] = ACTIONS(3609),
    [anon_sym_const] = ACTIONS(3609),
    [anon_sym_constexpr] = ACTIONS(3609),
    [anon_sym_volatile] = ACTIONS(3609),
    [anon_sym_restrict] = ACTIONS(3609),
    [anon_sym___restrict__] = ACTIONS(3609),
    [anon_sym__Atomic] = ACTIONS(3609),
    [anon_sym__Noreturn] = ACTIONS(3609),
    [anon_sym_noreturn] = ACTIONS(3609),
    [anon_sym_mutable] = ACTIONS(3609),
    [anon_sym_constinit] = ACTIONS(3609),
    [anon_sym_consteval] = ACTIONS(3609),
    [anon_sym_alignas] = ACTIONS(3609),
    [anon_sym__Alignas] = ACTIONS(3609),
    [sym_primitive_type] = ACTIONS(3609),
    [anon_sym_enum] = ACTIONS(3609),
    [anon_sym_class] = ACTIONS(3609),
    [anon_sym_struct] = ACTIONS(3609),
    [anon_sym_union] = ACTIONS(3609),
    [anon_sym_if] = ACTIONS(3609),
    [anon_sym_switch] = ACTIONS(3609),
    [anon_sym_case] = ACTIONS(3609),
    [anon_sym_default] = ACTIONS(3609),
    [anon_sym_while] = ACTIONS(3609),
    [anon_sym_do] = ACTIONS(3609),
    [anon_sym_for] = ACTIONS(3609),
    [anon_sym_return] = ACTIONS(3609),
    [anon_sym_break] = ACTIONS(3609),
    [anon_sym_continue] = ACTIONS(3609),
    [anon_sym_goto] = ACTIONS(3609),
    [anon_sym___try] = ACTIONS(3609),
    [anon_sym___leave] = ACTIONS(3609),
    [anon_sym_not] = ACTIONS(3609),
    [anon_sym_compl] = ACTIONS(3609),
    [anon_sym_DASH_DASH] = ACTIONS(3611),
    [anon_sym_PLUS_PLUS] = ACTIONS(3611),
    [anon_sym_sizeof] = ACTIONS(3609),
    [anon_sym___alignof__] = ACTIONS(3609),
    [anon_sym___alignof] = ACTIONS(3609),
    [anon_sym__alignof] = ACTIONS(3609),
    [anon_sym_alignof] = ACTIONS(3609),
    [anon_sym__Alignof] = ACTIONS(3609),
    [anon_sym_offsetof] = ACTIONS(3609),
    [anon_sym__Generic] = ACTIONS(3609),
    [anon_sym_asm] = ACTIONS(3609),
    [anon_sym___asm__] = ACTIONS(3609),
    [sym_number_literal] = ACTIONS(3611),
    [anon_sym_L_SQUOTE] = ACTIONS(3611),
    [anon_sym_u_SQUOTE] = ACTIONS(3611),
    [anon_sym_U_SQUOTE] = ACTIONS(3611),
    [anon_sym_u8_SQUOTE] = ACTIONS(3611),
    [anon_sym_SQUOTE] = ACTIONS(3611),
    [anon_sym_L_DQUOTE] = ACTIONS(3611),
    [anon_sym_u_DQUOTE] = ACTIONS(3611),
    [anon_sym_U_DQUOTE] = ACTIONS(3611),
    [anon_sym_u8_DQUOTE] = ACTIONS(3611),
    [anon_sym_DQUOTE] = ACTIONS(3611),
    [sym_true] = ACTIONS(3609),
    [sym_false] = ACTIONS(3609),
    [anon_sym_NULL] = ACTIONS(3609),
    [anon_sym_nullptr] = ACTIONS(3609),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3609),
    [anon_sym_let] = ACTIONS(3609),
    [anon_sym_This] = ACTIONS(3609),
    [anon_sym_decltype] = ACTIONS(3609),
    [sym_virtual] = ACTIONS(3609),
    [anon_sym_explicit] = ACTIONS(3609),
    [anon_sym_typename] = ACTIONS(3609),
    [anon_sym_template] = ACTIONS(3609),
    [anon_sym_operator] = ACTIONS(3609),
    [anon_sym_try] = ACTIONS(3609),
    [anon_sym_delete] = ACTIONS(3609),
    [anon_sym_throw] = ACTIONS(3609),
    [anon_sym_namespace] = ACTIONS(3609),
    [anon_sym_using] = ACTIONS(3609),
    [anon_sym_static_assert] = ACTIONS(3609),
    [anon_sym_concept] = ACTIONS(3609),
    [anon_sym_co_return] = ACTIONS(3609),
    [anon_sym_co_yield] = ACTIONS(3609),
    [anon_sym_R_DQUOTE] = ACTIONS(3611),
    [anon_sym_LR_DQUOTE] = ACTIONS(3611),
    [anon_sym_uR_DQUOTE] = ACTIONS(3611),
    [anon_sym_UR_DQUOTE] = ACTIONS(3611),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3611),
    [anon_sym_co_await] = ACTIONS(3609),
    [anon_sym_new] = ACTIONS(3609),
    [anon_sym_requires] = ACTIONS(3609),
    [sym_this] = ACTIONS(3609),
    [anon_sym_discard] = ACTIONS(3609),
    [anon_sym_precise] = ACTIONS(3609),
    [anon_sym_shared] = ACTIONS(3609),
    [anon_sym_groupshared] = ACTIONS(3609),
    [anon_sym_uniform] = ACTIONS(3609),
    [anon_sym_row_major] = ACTIONS(3609),
    [anon_sym_column_major] = ACTIONS(3609),
    [anon_sym_globallycoherent] = ACTIONS(3609),
    [anon_sym_centroid] = ACTIONS(3609),
    [anon_sym_noperspective] = ACTIONS(3609),
    [anon_sym_nointerpolation] = ACTIONS(3609),
    [anon_sym_sample] = ACTIONS(3609),
    [anon_sym_linear] = ACTIONS(3609),
    [anon_sym_snorm] = ACTIONS(3609),
    [anon_sym_unorm] = ACTIONS(3609),
    [anon_sym_point] = ACTIONS(3609),
    [anon_sym_line] = ACTIONS(3609),
    [anon_sym_triangleadj] = ACTIONS(3609),
    [anon_sym_lineadj] = ACTIONS(3609),
    [anon_sym_triangle] = ACTIONS(3609),
    [anon_sym_cbuffer] = ACTIONS(3609),
    [anon_sym_interface] = ACTIONS(3609),
    [anon_sym_extension] = ACTIONS(3609),
  },
  [868] = {
    [sym_identifier] = ACTIONS(3617),
    [aux_sym_preproc_include_token1] = ACTIONS(3617),
    [aux_sym_preproc_def_token1] = ACTIONS(3617),
    [aux_sym_preproc_if_token1] = ACTIONS(3617),
    [aux_sym_preproc_if_token2] = ACTIONS(3617),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3617),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3617),
    [sym_preproc_directive] = ACTIONS(3617),
    [anon_sym_LPAREN2] = ACTIONS(3619),
    [anon_sym_BANG] = ACTIONS(3619),
    [anon_sym_TILDE] = ACTIONS(3619),
    [anon_sym_DASH] = ACTIONS(3617),
    [anon_sym_PLUS] = ACTIONS(3617),
    [anon_sym_STAR] = ACTIONS(3619),
    [anon_sym_AMP_AMP] = ACTIONS(3619),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym_SEMI] = ACTIONS(3619),
    [anon_sym___extension__] = ACTIONS(3617),
    [anon_sym_typedef] = ACTIONS(3617),
    [anon_sym_in] = ACTIONS(3617),
    [anon_sym_out] = ACTIONS(3617),
    [anon_sym_inout] = ACTIONS(3617),
    [anon_sym_extern] = ACTIONS(3617),
    [anon_sym___attribute__] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3619),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3619),
    [anon_sym___declspec] = ACTIONS(3617),
    [anon_sym___based] = ACTIONS(3617),
    [anon_sym___cdecl] = ACTIONS(3617),
    [anon_sym___clrcall] = ACTIONS(3617),
    [anon_sym___stdcall] = ACTIONS(3617),
    [anon_sym___fastcall] = ACTIONS(3617),
    [anon_sym___thiscall] = ACTIONS(3617),
    [anon_sym___vectorcall] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3619),
    [anon_sym_signed] = ACTIONS(3617),
    [anon_sym_unsigned] = ACTIONS(3617),
    [anon_sym_long] = ACTIONS(3617),
    [anon_sym_short] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_static] = ACTIONS(3617),
    [anon_sym_register] = ACTIONS(3617),
    [anon_sym_inline] = ACTIONS(3617),
    [anon_sym___inline] = ACTIONS(3617),
    [anon_sym___inline__] = ACTIONS(3617),
    [anon_sym___forceinline] = ACTIONS(3617),
    [anon_sym_thread_local] = ACTIONS(3617),
    [anon_sym___thread] = ACTIONS(3617),
    [anon_sym_const] = ACTIONS(3617),
    [anon_sym_constexpr] = ACTIONS(3617),
    [anon_sym_volatile] = ACTIONS(3617),
    [anon_sym_restrict] = ACTIONS(3617),
    [anon_sym___restrict__] = ACTIONS(3617),
    [anon_sym__Atomic] = ACTIONS(3617),
    [anon_sym__Noreturn] = ACTIONS(3617),
    [anon_sym_noreturn] = ACTIONS(3617),
    [anon_sym_mutable] = ACTIONS(3617),
    [anon_sym_constinit] = ACTIONS(3617),
    [anon_sym_consteval] = ACTIONS(3617),
    [anon_sym_alignas] = ACTIONS(3617),
    [anon_sym__Alignas] = ACTIONS(3617),
    [sym_primitive_type] = ACTIONS(3617),
    [anon_sym_enum] = ACTIONS(3617),
    [anon_sym_class] = ACTIONS(3617),
    [anon_sym_struct] = ACTIONS(3617),
    [anon_sym_union] = ACTIONS(3617),
    [anon_sym_if] = ACTIONS(3617),
    [anon_sym_switch] = ACTIONS(3617),
    [anon_sym_case] = ACTIONS(3617),
    [anon_sym_default] = ACTIONS(3617),
    [anon_sym_while] = ACTIONS(3617),
    [anon_sym_do] = ACTIONS(3617),
    [anon_sym_for] = ACTIONS(3617),
    [anon_sym_return] = ACTIONS(3617),
    [anon_sym_break] = ACTIONS(3617),
    [anon_sym_continue] = ACTIONS(3617),
    [anon_sym_goto] = ACTIONS(3617),
    [anon_sym___try] = ACTIONS(3617),
    [anon_sym___leave] = ACTIONS(3617),
    [anon_sym_not] = ACTIONS(3617),
    [anon_sym_compl] = ACTIONS(3617),
    [anon_sym_DASH_DASH] = ACTIONS(3619),
    [anon_sym_PLUS_PLUS] = ACTIONS(3619),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(3617),
    [anon_sym___alignof] = ACTIONS(3617),
    [anon_sym__alignof] = ACTIONS(3617),
    [anon_sym_alignof] = ACTIONS(3617),
    [anon_sym__Alignof] = ACTIONS(3617),
    [anon_sym_offsetof] = ACTIONS(3617),
    [anon_sym__Generic] = ACTIONS(3617),
    [anon_sym_asm] = ACTIONS(3617),
    [anon_sym___asm__] = ACTIONS(3617),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3619),
    [anon_sym_u_SQUOTE] = ACTIONS(3619),
    [anon_sym_U_SQUOTE] = ACTIONS(3619),
    [anon_sym_u8_SQUOTE] = ACTIONS(3619),
    [anon_sym_SQUOTE] = ACTIONS(3619),
    [anon_sym_L_DQUOTE] = ACTIONS(3619),
    [anon_sym_u_DQUOTE] = ACTIONS(3619),
    [anon_sym_U_DQUOTE] = ACTIONS(3619),
    [anon_sym_u8_DQUOTE] = ACTIONS(3619),
    [anon_sym_DQUOTE] = ACTIONS(3619),
    [sym_true] = ACTIONS(3617),
    [sym_false] = ACTIONS(3617),
    [anon_sym_NULL] = ACTIONS(3617),
    [anon_sym_nullptr] = ACTIONS(3617),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3617),
    [anon_sym_let] = ACTIONS(3617),
    [anon_sym_This] = ACTIONS(3617),
    [anon_sym_decltype] = ACTIONS(3617),
    [sym_virtual] = ACTIONS(3617),
    [anon_sym_explicit] = ACTIONS(3617),
    [anon_sym_typename] = ACTIONS(3617),
    [anon_sym_template] = ACTIONS(3617),
    [anon_sym_operator] = ACTIONS(3617),
    [anon_sym_try] = ACTIONS(3617),
    [anon_sym_delete] = ACTIONS(3617),
    [anon_sym_throw] = ACTIONS(3617),
    [anon_sym_namespace] = ACTIONS(3617),
    [anon_sym_using] = ACTIONS(3617),
    [anon_sym_static_assert] = ACTIONS(3617),
    [anon_sym_concept] = ACTIONS(3617),
    [anon_sym_co_return] = ACTIONS(3617),
    [anon_sym_co_yield] = ACTIONS(3617),
    [anon_sym_R_DQUOTE] = ACTIONS(3619),
    [anon_sym_LR_DQUOTE] = ACTIONS(3619),
    [anon_sym_uR_DQUOTE] = ACTIONS(3619),
    [anon_sym_UR_DQUOTE] = ACTIONS(3619),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3619),
    [anon_sym_co_await] = ACTIONS(3617),
    [anon_sym_new] = ACTIONS(3617),
    [anon_sym_requires] = ACTIONS(3617),
    [sym_this] = ACTIONS(3617),
    [anon_sym_discard] = ACTIONS(3617),
    [anon_sym_precise] = ACTIONS(3617),
    [anon_sym_shared] = ACTIONS(3617),
    [anon_sym_groupshared] = ACTIONS(3617),
    [anon_sym_uniform] = ACTIONS(3617),
    [anon_sym_row_major] = ACTIONS(3617),
    [anon_sym_column_major] = ACTIONS(3617),
    [anon_sym_globallycoherent] = ACTIONS(3617),
    [anon_sym_centroid] = ACTIONS(3617),
    [anon_sym_noperspective] = ACTIONS(3617),
    [anon_sym_nointerpolation] = ACTIONS(3617),
    [anon_sym_sample] = ACTIONS(3617),
    [anon_sym_linear] = ACTIONS(3617),
    [anon_sym_snorm] = ACTIONS(3617),
    [anon_sym_unorm] = ACTIONS(3617),
    [anon_sym_point] = ACTIONS(3617),
    [anon_sym_line] = ACTIONS(3617),
    [anon_sym_triangleadj] = ACTIONS(3617),
    [anon_sym_lineadj] = ACTIONS(3617),
    [anon_sym_triangle] = ACTIONS(3617),
    [anon_sym_cbuffer] = ACTIONS(3617),
    [anon_sym_interface] = ACTIONS(3617),
    [anon_sym_extension] = ACTIONS(3617),
  },
  [869] = {
    [sym_identifier] = ACTIONS(3621),
    [aux_sym_preproc_include_token1] = ACTIONS(3621),
    [aux_sym_preproc_def_token1] = ACTIONS(3621),
    [aux_sym_preproc_if_token1] = ACTIONS(3621),
    [aux_sym_preproc_if_token2] = ACTIONS(3621),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3621),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3621),
    [sym_preproc_directive] = ACTIONS(3621),
    [anon_sym_LPAREN2] = ACTIONS(3623),
    [anon_sym_BANG] = ACTIONS(3623),
    [anon_sym_TILDE] = ACTIONS(3623),
    [anon_sym_DASH] = ACTIONS(3621),
    [anon_sym_PLUS] = ACTIONS(3621),
    [anon_sym_STAR] = ACTIONS(3623),
    [anon_sym_AMP_AMP] = ACTIONS(3623),
    [anon_sym_AMP] = ACTIONS(3621),
    [anon_sym_SEMI] = ACTIONS(3623),
    [anon_sym___extension__] = ACTIONS(3621),
    [anon_sym_typedef] = ACTIONS(3621),
    [anon_sym_in] = ACTIONS(3621),
    [anon_sym_out] = ACTIONS(3621),
    [anon_sym_inout] = ACTIONS(3621),
    [anon_sym_extern] = ACTIONS(3621),
    [anon_sym___attribute__] = ACTIONS(3621),
    [anon_sym_COLON_COLON] = ACTIONS(3623),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3623),
    [anon_sym___declspec] = ACTIONS(3621),
    [anon_sym___based] = ACTIONS(3621),
    [anon_sym___cdecl] = ACTIONS(3621),
    [anon_sym___clrcall] = ACTIONS(3621),
    [anon_sym___stdcall] = ACTIONS(3621),
    [anon_sym___fastcall] = ACTIONS(3621),
    [anon_sym___thiscall] = ACTIONS(3621),
    [anon_sym___vectorcall] = ACTIONS(3621),
    [anon_sym_LBRACE] = ACTIONS(3623),
    [anon_sym_signed] = ACTIONS(3621),
    [anon_sym_unsigned] = ACTIONS(3621),
    [anon_sym_long] = ACTIONS(3621),
    [anon_sym_short] = ACTIONS(3621),
    [anon_sym_LBRACK] = ACTIONS(3621),
    [anon_sym_static] = ACTIONS(3621),
    [anon_sym_register] = ACTIONS(3621),
    [anon_sym_inline] = ACTIONS(3621),
    [anon_sym___inline] = ACTIONS(3621),
    [anon_sym___inline__] = ACTIONS(3621),
    [anon_sym___forceinline] = ACTIONS(3621),
    [anon_sym_thread_local] = ACTIONS(3621),
    [anon_sym___thread] = ACTIONS(3621),
    [anon_sym_const] = ACTIONS(3621),
    [anon_sym_constexpr] = ACTIONS(3621),
    [anon_sym_volatile] = ACTIONS(3621),
    [anon_sym_restrict] = ACTIONS(3621),
    [anon_sym___restrict__] = ACTIONS(3621),
    [anon_sym__Atomic] = ACTIONS(3621),
    [anon_sym__Noreturn] = ACTIONS(3621),
    [anon_sym_noreturn] = ACTIONS(3621),
    [anon_sym_mutable] = ACTIONS(3621),
    [anon_sym_constinit] = ACTIONS(3621),
    [anon_sym_consteval] = ACTIONS(3621),
    [anon_sym_alignas] = ACTIONS(3621),
    [anon_sym__Alignas] = ACTIONS(3621),
    [sym_primitive_type] = ACTIONS(3621),
    [anon_sym_enum] = ACTIONS(3621),
    [anon_sym_class] = ACTIONS(3621),
    [anon_sym_struct] = ACTIONS(3621),
    [anon_sym_union] = ACTIONS(3621),
    [anon_sym_if] = ACTIONS(3621),
    [anon_sym_switch] = ACTIONS(3621),
    [anon_sym_case] = ACTIONS(3621),
    [anon_sym_default] = ACTIONS(3621),
    [anon_sym_while] = ACTIONS(3621),
    [anon_sym_do] = ACTIONS(3621),
    [anon_sym_for] = ACTIONS(3621),
    [anon_sym_return] = ACTIONS(3621),
    [anon_sym_break] = ACTIONS(3621),
    [anon_sym_continue] = ACTIONS(3621),
    [anon_sym_goto] = ACTIONS(3621),
    [anon_sym___try] = ACTIONS(3621),
    [anon_sym___leave] = ACTIONS(3621),
    [anon_sym_not] = ACTIONS(3621),
    [anon_sym_compl] = ACTIONS(3621),
    [anon_sym_DASH_DASH] = ACTIONS(3623),
    [anon_sym_PLUS_PLUS] = ACTIONS(3623),
    [anon_sym_sizeof] = ACTIONS(3621),
    [anon_sym___alignof__] = ACTIONS(3621),
    [anon_sym___alignof] = ACTIONS(3621),
    [anon_sym__alignof] = ACTIONS(3621),
    [anon_sym_alignof] = ACTIONS(3621),
    [anon_sym__Alignof] = ACTIONS(3621),
    [anon_sym_offsetof] = ACTIONS(3621),
    [anon_sym__Generic] = ACTIONS(3621),
    [anon_sym_asm] = ACTIONS(3621),
    [anon_sym___asm__] = ACTIONS(3621),
    [sym_number_literal] = ACTIONS(3623),
    [anon_sym_L_SQUOTE] = ACTIONS(3623),
    [anon_sym_u_SQUOTE] = ACTIONS(3623),
    [anon_sym_U_SQUOTE] = ACTIONS(3623),
    [anon_sym_u8_SQUOTE] = ACTIONS(3623),
    [anon_sym_SQUOTE] = ACTIONS(3623),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(3621),
    [sym_false] = ACTIONS(3621),
    [anon_sym_NULL] = ACTIONS(3621),
    [anon_sym_nullptr] = ACTIONS(3621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3621),
    [anon_sym_let] = ACTIONS(3621),
    [anon_sym_This] = ACTIONS(3621),
    [anon_sym_decltype] = ACTIONS(3621),
    [sym_virtual] = ACTIONS(3621),
    [anon_sym_explicit] = ACTIONS(3621),
    [anon_sym_typename] = ACTIONS(3621),
    [anon_sym_template] = ACTIONS(3621),
    [anon_sym_operator] = ACTIONS(3621),
    [anon_sym_try] = ACTIONS(3621),
    [anon_sym_delete] = ACTIONS(3621),
    [anon_sym_throw] = ACTIONS(3621),
    [anon_sym_namespace] = ACTIONS(3621),
    [anon_sym_using] = ACTIONS(3621),
    [anon_sym_static_assert] = ACTIONS(3621),
    [anon_sym_concept] = ACTIONS(3621),
    [anon_sym_co_return] = ACTIONS(3621),
    [anon_sym_co_yield] = ACTIONS(3621),
    [anon_sym_R_DQUOTE] = ACTIONS(3623),
    [anon_sym_LR_DQUOTE] = ACTIONS(3623),
    [anon_sym_uR_DQUOTE] = ACTIONS(3623),
    [anon_sym_UR_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3623),
    [anon_sym_co_await] = ACTIONS(3621),
    [anon_sym_new] = ACTIONS(3621),
    [anon_sym_requires] = ACTIONS(3621),
    [sym_this] = ACTIONS(3621),
    [anon_sym_discard] = ACTIONS(3621),
    [anon_sym_precise] = ACTIONS(3621),
    [anon_sym_shared] = ACTIONS(3621),
    [anon_sym_groupshared] = ACTIONS(3621),
    [anon_sym_uniform] = ACTIONS(3621),
    [anon_sym_row_major] = ACTIONS(3621),
    [anon_sym_column_major] = ACTIONS(3621),
    [anon_sym_globallycoherent] = ACTIONS(3621),
    [anon_sym_centroid] = ACTIONS(3621),
    [anon_sym_noperspective] = ACTIONS(3621),
    [anon_sym_nointerpolation] = ACTIONS(3621),
    [anon_sym_sample] = ACTIONS(3621),
    [anon_sym_linear] = ACTIONS(3621),
    [anon_sym_snorm] = ACTIONS(3621),
    [anon_sym_unorm] = ACTIONS(3621),
    [anon_sym_point] = ACTIONS(3621),
    [anon_sym_line] = ACTIONS(3621),
    [anon_sym_triangleadj] = ACTIONS(3621),
    [anon_sym_lineadj] = ACTIONS(3621),
    [anon_sym_triangle] = ACTIONS(3621),
    [anon_sym_cbuffer] = ACTIONS(3621),
    [anon_sym_interface] = ACTIONS(3621),
    [anon_sym_extension] = ACTIONS(3621),
  },
  [870] = {
    [sym_identifier] = ACTIONS(3625),
    [aux_sym_preproc_include_token1] = ACTIONS(3625),
    [aux_sym_preproc_def_token1] = ACTIONS(3625),
    [aux_sym_preproc_if_token1] = ACTIONS(3625),
    [aux_sym_preproc_if_token2] = ACTIONS(3625),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3625),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3625),
    [sym_preproc_directive] = ACTIONS(3625),
    [anon_sym_LPAREN2] = ACTIONS(3627),
    [anon_sym_BANG] = ACTIONS(3627),
    [anon_sym_TILDE] = ACTIONS(3627),
    [anon_sym_DASH] = ACTIONS(3625),
    [anon_sym_PLUS] = ACTIONS(3625),
    [anon_sym_STAR] = ACTIONS(3627),
    [anon_sym_AMP_AMP] = ACTIONS(3627),
    [anon_sym_AMP] = ACTIONS(3625),
    [anon_sym_SEMI] = ACTIONS(3627),
    [anon_sym___extension__] = ACTIONS(3625),
    [anon_sym_typedef] = ACTIONS(3625),
    [anon_sym_in] = ACTIONS(3625),
    [anon_sym_out] = ACTIONS(3625),
    [anon_sym_inout] = ACTIONS(3625),
    [anon_sym_extern] = ACTIONS(3625),
    [anon_sym___attribute__] = ACTIONS(3625),
    [anon_sym_COLON_COLON] = ACTIONS(3627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3627),
    [anon_sym___declspec] = ACTIONS(3625),
    [anon_sym___based] = ACTIONS(3625),
    [anon_sym___cdecl] = ACTIONS(3625),
    [anon_sym___clrcall] = ACTIONS(3625),
    [anon_sym___stdcall] = ACTIONS(3625),
    [anon_sym___fastcall] = ACTIONS(3625),
    [anon_sym___thiscall] = ACTIONS(3625),
    [anon_sym___vectorcall] = ACTIONS(3625),
    [anon_sym_LBRACE] = ACTIONS(3627),
    [anon_sym_signed] = ACTIONS(3625),
    [anon_sym_unsigned] = ACTIONS(3625),
    [anon_sym_long] = ACTIONS(3625),
    [anon_sym_short] = ACTIONS(3625),
    [anon_sym_LBRACK] = ACTIONS(3625),
    [anon_sym_static] = ACTIONS(3625),
    [anon_sym_register] = ACTIONS(3625),
    [anon_sym_inline] = ACTIONS(3625),
    [anon_sym___inline] = ACTIONS(3625),
    [anon_sym___inline__] = ACTIONS(3625),
    [anon_sym___forceinline] = ACTIONS(3625),
    [anon_sym_thread_local] = ACTIONS(3625),
    [anon_sym___thread] = ACTIONS(3625),
    [anon_sym_const] = ACTIONS(3625),
    [anon_sym_constexpr] = ACTIONS(3625),
    [anon_sym_volatile] = ACTIONS(3625),
    [anon_sym_restrict] = ACTIONS(3625),
    [anon_sym___restrict__] = ACTIONS(3625),
    [anon_sym__Atomic] = ACTIONS(3625),
    [anon_sym__Noreturn] = ACTIONS(3625),
    [anon_sym_noreturn] = ACTIONS(3625),
    [anon_sym_mutable] = ACTIONS(3625),
    [anon_sym_constinit] = ACTIONS(3625),
    [anon_sym_consteval] = ACTIONS(3625),
    [anon_sym_alignas] = ACTIONS(3625),
    [anon_sym__Alignas] = ACTIONS(3625),
    [sym_primitive_type] = ACTIONS(3625),
    [anon_sym_enum] = ACTIONS(3625),
    [anon_sym_class] = ACTIONS(3625),
    [anon_sym_struct] = ACTIONS(3625),
    [anon_sym_union] = ACTIONS(3625),
    [anon_sym_if] = ACTIONS(3625),
    [anon_sym_switch] = ACTIONS(3625),
    [anon_sym_case] = ACTIONS(3625),
    [anon_sym_default] = ACTIONS(3625),
    [anon_sym_while] = ACTIONS(3625),
    [anon_sym_do] = ACTIONS(3625),
    [anon_sym_for] = ACTIONS(3625),
    [anon_sym_return] = ACTIONS(3625),
    [anon_sym_break] = ACTIONS(3625),
    [anon_sym_continue] = ACTIONS(3625),
    [anon_sym_goto] = ACTIONS(3625),
    [anon_sym___try] = ACTIONS(3625),
    [anon_sym___leave] = ACTIONS(3625),
    [anon_sym_not] = ACTIONS(3625),
    [anon_sym_compl] = ACTIONS(3625),
    [anon_sym_DASH_DASH] = ACTIONS(3627),
    [anon_sym_PLUS_PLUS] = ACTIONS(3627),
    [anon_sym_sizeof] = ACTIONS(3625),
    [anon_sym___alignof__] = ACTIONS(3625),
    [anon_sym___alignof] = ACTIONS(3625),
    [anon_sym__alignof] = ACTIONS(3625),
    [anon_sym_alignof] = ACTIONS(3625),
    [anon_sym__Alignof] = ACTIONS(3625),
    [anon_sym_offsetof] = ACTIONS(3625),
    [anon_sym__Generic] = ACTIONS(3625),
    [anon_sym_asm] = ACTIONS(3625),
    [anon_sym___asm__] = ACTIONS(3625),
    [sym_number_literal] = ACTIONS(3627),
    [anon_sym_L_SQUOTE] = ACTIONS(3627),
    [anon_sym_u_SQUOTE] = ACTIONS(3627),
    [anon_sym_U_SQUOTE] = ACTIONS(3627),
    [anon_sym_u8_SQUOTE] = ACTIONS(3627),
    [anon_sym_SQUOTE] = ACTIONS(3627),
    [anon_sym_L_DQUOTE] = ACTIONS(3627),
    [anon_sym_u_DQUOTE] = ACTIONS(3627),
    [anon_sym_U_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8_DQUOTE] = ACTIONS(3627),
    [anon_sym_DQUOTE] = ACTIONS(3627),
    [sym_true] = ACTIONS(3625),
    [sym_false] = ACTIONS(3625),
    [anon_sym_NULL] = ACTIONS(3625),
    [anon_sym_nullptr] = ACTIONS(3625),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3625),
    [anon_sym_let] = ACTIONS(3625),
    [anon_sym_This] = ACTIONS(3625),
    [anon_sym_decltype] = ACTIONS(3625),
    [sym_virtual] = ACTIONS(3625),
    [anon_sym_explicit] = ACTIONS(3625),
    [anon_sym_typename] = ACTIONS(3625),
    [anon_sym_template] = ACTIONS(3625),
    [anon_sym_operator] = ACTIONS(3625),
    [anon_sym_try] = ACTIONS(3625),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_throw] = ACTIONS(3625),
    [anon_sym_namespace] = ACTIONS(3625),
    [anon_sym_using] = ACTIONS(3625),
    [anon_sym_static_assert] = ACTIONS(3625),
    [anon_sym_concept] = ACTIONS(3625),
    [anon_sym_co_return] = ACTIONS(3625),
    [anon_sym_co_yield] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3625),
    [anon_sym_new] = ACTIONS(3625),
    [anon_sym_requires] = ACTIONS(3625),
    [sym_this] = ACTIONS(3625),
    [anon_sym_discard] = ACTIONS(3625),
    [anon_sym_precise] = ACTIONS(3625),
    [anon_sym_shared] = ACTIONS(3625),
    [anon_sym_groupshared] = ACTIONS(3625),
    [anon_sym_uniform] = ACTIONS(3625),
    [anon_sym_row_major] = ACTIONS(3625),
    [anon_sym_column_major] = ACTIONS(3625),
    [anon_sym_globallycoherent] = ACTIONS(3625),
    [anon_sym_centroid] = ACTIONS(3625),
    [anon_sym_noperspective] = ACTIONS(3625),
    [anon_sym_nointerpolation] = ACTIONS(3625),
    [anon_sym_sample] = ACTIONS(3625),
    [anon_sym_linear] = ACTIONS(3625),
    [anon_sym_snorm] = ACTIONS(3625),
    [anon_sym_unorm] = ACTIONS(3625),
    [anon_sym_point] = ACTIONS(3625),
    [anon_sym_line] = ACTIONS(3625),
    [anon_sym_triangleadj] = ACTIONS(3625),
    [anon_sym_lineadj] = ACTIONS(3625),
    [anon_sym_triangle] = ACTIONS(3625),
    [anon_sym_cbuffer] = ACTIONS(3625),
    [anon_sym_interface] = ACTIONS(3625),
    [anon_sym_extension] = ACTIONS(3625),
  },
  [871] = {
    [sym_identifier] = ACTIONS(3497),
    [aux_sym_preproc_include_token1] = ACTIONS(3497),
    [aux_sym_preproc_def_token1] = ACTIONS(3497),
    [aux_sym_preproc_if_token1] = ACTIONS(3497),
    [aux_sym_preproc_if_token2] = ACTIONS(3497),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3497),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3497),
    [sym_preproc_directive] = ACTIONS(3497),
    [anon_sym_LPAREN2] = ACTIONS(3499),
    [anon_sym_BANG] = ACTIONS(3499),
    [anon_sym_TILDE] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_STAR] = ACTIONS(3499),
    [anon_sym_AMP_AMP] = ACTIONS(3499),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym_SEMI] = ACTIONS(3499),
    [anon_sym___extension__] = ACTIONS(3497),
    [anon_sym_typedef] = ACTIONS(3497),
    [anon_sym_in] = ACTIONS(3497),
    [anon_sym_out] = ACTIONS(3497),
    [anon_sym_inout] = ACTIONS(3497),
    [anon_sym_extern] = ACTIONS(3497),
    [anon_sym___attribute__] = ACTIONS(3497),
    [anon_sym_COLON_COLON] = ACTIONS(3499),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3499),
    [anon_sym___declspec] = ACTIONS(3497),
    [anon_sym___based] = ACTIONS(3497),
    [anon_sym___cdecl] = ACTIONS(3497),
    [anon_sym___clrcall] = ACTIONS(3497),
    [anon_sym___stdcall] = ACTIONS(3497),
    [anon_sym___fastcall] = ACTIONS(3497),
    [anon_sym___thiscall] = ACTIONS(3497),
    [anon_sym___vectorcall] = ACTIONS(3497),
    [anon_sym_LBRACE] = ACTIONS(3499),
    [anon_sym_signed] = ACTIONS(3497),
    [anon_sym_unsigned] = ACTIONS(3497),
    [anon_sym_long] = ACTIONS(3497),
    [anon_sym_short] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3497),
    [anon_sym_static] = ACTIONS(3497),
    [anon_sym_register] = ACTIONS(3497),
    [anon_sym_inline] = ACTIONS(3497),
    [anon_sym___inline] = ACTIONS(3497),
    [anon_sym___inline__] = ACTIONS(3497),
    [anon_sym___forceinline] = ACTIONS(3497),
    [anon_sym_thread_local] = ACTIONS(3497),
    [anon_sym___thread] = ACTIONS(3497),
    [anon_sym_const] = ACTIONS(3497),
    [anon_sym_constexpr] = ACTIONS(3497),
    [anon_sym_volatile] = ACTIONS(3497),
    [anon_sym_restrict] = ACTIONS(3497),
    [anon_sym___restrict__] = ACTIONS(3497),
    [anon_sym__Atomic] = ACTIONS(3497),
    [anon_sym__Noreturn] = ACTIONS(3497),
    [anon_sym_noreturn] = ACTIONS(3497),
    [anon_sym_mutable] = ACTIONS(3497),
    [anon_sym_constinit] = ACTIONS(3497),
    [anon_sym_consteval] = ACTIONS(3497),
    [anon_sym_alignas] = ACTIONS(3497),
    [anon_sym__Alignas] = ACTIONS(3497),
    [sym_primitive_type] = ACTIONS(3497),
    [anon_sym_enum] = ACTIONS(3497),
    [anon_sym_class] = ACTIONS(3497),
    [anon_sym_struct] = ACTIONS(3497),
    [anon_sym_union] = ACTIONS(3497),
    [anon_sym_if] = ACTIONS(3497),
    [anon_sym_switch] = ACTIONS(3497),
    [anon_sym_case] = ACTIONS(3497),
    [anon_sym_default] = ACTIONS(3497),
    [anon_sym_while] = ACTIONS(3497),
    [anon_sym_do] = ACTIONS(3497),
    [anon_sym_for] = ACTIONS(3497),
    [anon_sym_return] = ACTIONS(3497),
    [anon_sym_break] = ACTIONS(3497),
    [anon_sym_continue] = ACTIONS(3497),
    [anon_sym_goto] = ACTIONS(3497),
    [anon_sym___try] = ACTIONS(3497),
    [anon_sym___leave] = ACTIONS(3497),
    [anon_sym_not] = ACTIONS(3497),
    [anon_sym_compl] = ACTIONS(3497),
    [anon_sym_DASH_DASH] = ACTIONS(3499),
    [anon_sym_PLUS_PLUS] = ACTIONS(3499),
    [anon_sym_sizeof] = ACTIONS(3497),
    [anon_sym___alignof__] = ACTIONS(3497),
    [anon_sym___alignof] = ACTIONS(3497),
    [anon_sym__alignof] = ACTIONS(3497),
    [anon_sym_alignof] = ACTIONS(3497),
    [anon_sym__Alignof] = ACTIONS(3497),
    [anon_sym_offsetof] = ACTIONS(3497),
    [anon_sym__Generic] = ACTIONS(3497),
    [anon_sym_asm] = ACTIONS(3497),
    [anon_sym___asm__] = ACTIONS(3497),
    [sym_number_literal] = ACTIONS(3499),
    [anon_sym_L_SQUOTE] = ACTIONS(3499),
    [anon_sym_u_SQUOTE] = ACTIONS(3499),
    [anon_sym_U_SQUOTE] = ACTIONS(3499),
    [anon_sym_u8_SQUOTE] = ACTIONS(3499),
    [anon_sym_SQUOTE] = ACTIONS(3499),
    [anon_sym_L_DQUOTE] = ACTIONS(3499),
    [anon_sym_u_DQUOTE] = ACTIONS(3499),
    [anon_sym_U_DQUOTE] = ACTIONS(3499),
    [anon_sym_u8_DQUOTE] = ACTIONS(3499),
    [anon_sym_DQUOTE] = ACTIONS(3499),
    [sym_true] = ACTIONS(3497),
    [sym_false] = ACTIONS(3497),
    [anon_sym_NULL] = ACTIONS(3497),
    [anon_sym_nullptr] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3497),
    [anon_sym_let] = ACTIONS(3497),
    [anon_sym_This] = ACTIONS(3497),
    [anon_sym_decltype] = ACTIONS(3497),
    [sym_virtual] = ACTIONS(3497),
    [anon_sym_explicit] = ACTIONS(3497),
    [anon_sym_typename] = ACTIONS(3497),
    [anon_sym_template] = ACTIONS(3497),
    [anon_sym_operator] = ACTIONS(3497),
    [anon_sym_try] = ACTIONS(3497),
    [anon_sym_delete] = ACTIONS(3497),
    [anon_sym_throw] = ACTIONS(3497),
    [anon_sym_namespace] = ACTIONS(3497),
    [anon_sym_using] = ACTIONS(3497),
    [anon_sym_static_assert] = ACTIONS(3497),
    [anon_sym_concept] = ACTIONS(3497),
    [anon_sym_co_return] = ACTIONS(3497),
    [anon_sym_co_yield] = ACTIONS(3497),
    [anon_sym_R_DQUOTE] = ACTIONS(3499),
    [anon_sym_LR_DQUOTE] = ACTIONS(3499),
    [anon_sym_uR_DQUOTE] = ACTIONS(3499),
    [anon_sym_UR_DQUOTE] = ACTIONS(3499),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3499),
    [anon_sym_co_await] = ACTIONS(3497),
    [anon_sym_new] = ACTIONS(3497),
    [anon_sym_requires] = ACTIONS(3497),
    [sym_this] = ACTIONS(3497),
    [anon_sym_discard] = ACTIONS(3497),
    [anon_sym_precise] = ACTIONS(3497),
    [anon_sym_shared] = ACTIONS(3497),
    [anon_sym_groupshared] = ACTIONS(3497),
    [anon_sym_uniform] = ACTIONS(3497),
    [anon_sym_row_major] = ACTIONS(3497),
    [anon_sym_column_major] = ACTIONS(3497),
    [anon_sym_globallycoherent] = ACTIONS(3497),
    [anon_sym_centroid] = ACTIONS(3497),
    [anon_sym_noperspective] = ACTIONS(3497),
    [anon_sym_nointerpolation] = ACTIONS(3497),
    [anon_sym_sample] = ACTIONS(3497),
    [anon_sym_linear] = ACTIONS(3497),
    [anon_sym_snorm] = ACTIONS(3497),
    [anon_sym_unorm] = ACTIONS(3497),
    [anon_sym_point] = ACTIONS(3497),
    [anon_sym_line] = ACTIONS(3497),
    [anon_sym_triangleadj] = ACTIONS(3497),
    [anon_sym_lineadj] = ACTIONS(3497),
    [anon_sym_triangle] = ACTIONS(3497),
    [anon_sym_cbuffer] = ACTIONS(3497),
    [anon_sym_interface] = ACTIONS(3497),
    [anon_sym_extension] = ACTIONS(3497),
  },
  [872] = {
    [sym_identifier] = ACTIONS(3525),
    [aux_sym_preproc_include_token1] = ACTIONS(3525),
    [aux_sym_preproc_def_token1] = ACTIONS(3525),
    [aux_sym_preproc_if_token1] = ACTIONS(3525),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3525),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3525),
    [sym_preproc_directive] = ACTIONS(3525),
    [anon_sym_LPAREN2] = ACTIONS(3527),
    [anon_sym_BANG] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3525),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_AMP] = ACTIONS(3525),
    [anon_sym_SEMI] = ACTIONS(3527),
    [anon_sym___extension__] = ACTIONS(3525),
    [anon_sym_typedef] = ACTIONS(3525),
    [anon_sym_in] = ACTIONS(3525),
    [anon_sym_out] = ACTIONS(3525),
    [anon_sym_inout] = ACTIONS(3525),
    [anon_sym_extern] = ACTIONS(3525),
    [anon_sym___attribute__] = ACTIONS(3525),
    [anon_sym_COLON_COLON] = ACTIONS(3527),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3527),
    [anon_sym___declspec] = ACTIONS(3525),
    [anon_sym___based] = ACTIONS(3525),
    [anon_sym___cdecl] = ACTIONS(3525),
    [anon_sym___clrcall] = ACTIONS(3525),
    [anon_sym___stdcall] = ACTIONS(3525),
    [anon_sym___fastcall] = ACTIONS(3525),
    [anon_sym___thiscall] = ACTIONS(3525),
    [anon_sym___vectorcall] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_RBRACE] = ACTIONS(3527),
    [anon_sym_signed] = ACTIONS(3525),
    [anon_sym_unsigned] = ACTIONS(3525),
    [anon_sym_long] = ACTIONS(3525),
    [anon_sym_short] = ACTIONS(3525),
    [anon_sym_LBRACK] = ACTIONS(3525),
    [anon_sym_static] = ACTIONS(3525),
    [anon_sym_register] = ACTIONS(3525),
    [anon_sym_inline] = ACTIONS(3525),
    [anon_sym___inline] = ACTIONS(3525),
    [anon_sym___inline__] = ACTIONS(3525),
    [anon_sym___forceinline] = ACTIONS(3525),
    [anon_sym_thread_local] = ACTIONS(3525),
    [anon_sym___thread] = ACTIONS(3525),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_constexpr] = ACTIONS(3525),
    [anon_sym_volatile] = ACTIONS(3525),
    [anon_sym_restrict] = ACTIONS(3525),
    [anon_sym___restrict__] = ACTIONS(3525),
    [anon_sym__Atomic] = ACTIONS(3525),
    [anon_sym__Noreturn] = ACTIONS(3525),
    [anon_sym_noreturn] = ACTIONS(3525),
    [anon_sym_mutable] = ACTIONS(3525),
    [anon_sym_constinit] = ACTIONS(3525),
    [anon_sym_consteval] = ACTIONS(3525),
    [anon_sym_alignas] = ACTIONS(3525),
    [anon_sym__Alignas] = ACTIONS(3525),
    [sym_primitive_type] = ACTIONS(3525),
    [anon_sym_enum] = ACTIONS(3525),
    [anon_sym_class] = ACTIONS(3525),
    [anon_sym_struct] = ACTIONS(3525),
    [anon_sym_union] = ACTIONS(3525),
    [anon_sym_if] = ACTIONS(3525),
    [anon_sym_switch] = ACTIONS(3525),
    [anon_sym_case] = ACTIONS(3525),
    [anon_sym_default] = ACTIONS(3525),
    [anon_sym_while] = ACTIONS(3525),
    [anon_sym_do] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3525),
    [anon_sym_return] = ACTIONS(3525),
    [anon_sym_break] = ACTIONS(3525),
    [anon_sym_continue] = ACTIONS(3525),
    [anon_sym_goto] = ACTIONS(3525),
    [anon_sym___try] = ACTIONS(3525),
    [anon_sym___leave] = ACTIONS(3525),
    [anon_sym_not] = ACTIONS(3525),
    [anon_sym_compl] = ACTIONS(3525),
    [anon_sym_DASH_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_PLUS] = ACTIONS(3527),
    [anon_sym_sizeof] = ACTIONS(3525),
    [anon_sym___alignof__] = ACTIONS(3525),
    [anon_sym___alignof] = ACTIONS(3525),
    [anon_sym__alignof] = ACTIONS(3525),
    [anon_sym_alignof] = ACTIONS(3525),
    [anon_sym__Alignof] = ACTIONS(3525),
    [anon_sym_offsetof] = ACTIONS(3525),
    [anon_sym__Generic] = ACTIONS(3525),
    [anon_sym_asm] = ACTIONS(3525),
    [anon_sym___asm__] = ACTIONS(3525),
    [sym_number_literal] = ACTIONS(3527),
    [anon_sym_L_SQUOTE] = ACTIONS(3527),
    [anon_sym_u_SQUOTE] = ACTIONS(3527),
    [anon_sym_U_SQUOTE] = ACTIONS(3527),
    [anon_sym_u8_SQUOTE] = ACTIONS(3527),
    [anon_sym_SQUOTE] = ACTIONS(3527),
    [anon_sym_L_DQUOTE] = ACTIONS(3527),
    [anon_sym_u_DQUOTE] = ACTIONS(3527),
    [anon_sym_U_DQUOTE] = ACTIONS(3527),
    [anon_sym_u8_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [sym_true] = ACTIONS(3525),
    [sym_false] = ACTIONS(3525),
    [anon_sym_NULL] = ACTIONS(3525),
    [anon_sym_nullptr] = ACTIONS(3525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3525),
    [anon_sym_let] = ACTIONS(3525),
    [anon_sym_This] = ACTIONS(3525),
    [anon_sym_decltype] = ACTIONS(3525),
    [sym_virtual] = ACTIONS(3525),
    [anon_sym_explicit] = ACTIONS(3525),
    [anon_sym_typename] = ACTIONS(3525),
    [anon_sym_template] = ACTIONS(3525),
    [anon_sym_operator] = ACTIONS(3525),
    [anon_sym_try] = ACTIONS(3525),
    [anon_sym_delete] = ACTIONS(3525),
    [anon_sym_throw] = ACTIONS(3525),
    [anon_sym_namespace] = ACTIONS(3525),
    [anon_sym_using] = ACTIONS(3525),
    [anon_sym_static_assert] = ACTIONS(3525),
    [anon_sym_concept] = ACTIONS(3525),
    [anon_sym_co_return] = ACTIONS(3525),
    [anon_sym_co_yield] = ACTIONS(3525),
    [anon_sym_R_DQUOTE] = ACTIONS(3527),
    [anon_sym_LR_DQUOTE] = ACTIONS(3527),
    [anon_sym_uR_DQUOTE] = ACTIONS(3527),
    [anon_sym_UR_DQUOTE] = ACTIONS(3527),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3527),
    [anon_sym_co_await] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3525),
    [anon_sym_requires] = ACTIONS(3525),
    [sym_this] = ACTIONS(3525),
    [anon_sym_discard] = ACTIONS(3525),
    [anon_sym_precise] = ACTIONS(3525),
    [anon_sym_shared] = ACTIONS(3525),
    [anon_sym_groupshared] = ACTIONS(3525),
    [anon_sym_uniform] = ACTIONS(3525),
    [anon_sym_row_major] = ACTIONS(3525),
    [anon_sym_column_major] = ACTIONS(3525),
    [anon_sym_globallycoherent] = ACTIONS(3525),
    [anon_sym_centroid] = ACTIONS(3525),
    [anon_sym_noperspective] = ACTIONS(3525),
    [anon_sym_nointerpolation] = ACTIONS(3525),
    [anon_sym_sample] = ACTIONS(3525),
    [anon_sym_linear] = ACTIONS(3525),
    [anon_sym_snorm] = ACTIONS(3525),
    [anon_sym_unorm] = ACTIONS(3525),
    [anon_sym_point] = ACTIONS(3525),
    [anon_sym_line] = ACTIONS(3525),
    [anon_sym_triangleadj] = ACTIONS(3525),
    [anon_sym_lineadj] = ACTIONS(3525),
    [anon_sym_triangle] = ACTIONS(3525),
    [anon_sym_cbuffer] = ACTIONS(3525),
    [anon_sym_interface] = ACTIONS(3525),
    [anon_sym_extension] = ACTIONS(3525),
  },
  [873] = {
    [sym_identifier] = ACTIONS(3521),
    [aux_sym_preproc_include_token1] = ACTIONS(3521),
    [aux_sym_preproc_def_token1] = ACTIONS(3521),
    [aux_sym_preproc_if_token1] = ACTIONS(3521),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3521),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3521),
    [sym_preproc_directive] = ACTIONS(3521),
    [anon_sym_LPAREN2] = ACTIONS(3523),
    [anon_sym_BANG] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3521),
    [anon_sym_PLUS] = ACTIONS(3521),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3521),
    [anon_sym_SEMI] = ACTIONS(3523),
    [anon_sym___extension__] = ACTIONS(3521),
    [anon_sym_typedef] = ACTIONS(3521),
    [anon_sym_in] = ACTIONS(3521),
    [anon_sym_out] = ACTIONS(3521),
    [anon_sym_inout] = ACTIONS(3521),
    [anon_sym_extern] = ACTIONS(3521),
    [anon_sym___attribute__] = ACTIONS(3521),
    [anon_sym_COLON_COLON] = ACTIONS(3523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3523),
    [anon_sym___declspec] = ACTIONS(3521),
    [anon_sym___based] = ACTIONS(3521),
    [anon_sym___cdecl] = ACTIONS(3521),
    [anon_sym___clrcall] = ACTIONS(3521),
    [anon_sym___stdcall] = ACTIONS(3521),
    [anon_sym___fastcall] = ACTIONS(3521),
    [anon_sym___thiscall] = ACTIONS(3521),
    [anon_sym___vectorcall] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_RBRACE] = ACTIONS(3523),
    [anon_sym_signed] = ACTIONS(3521),
    [anon_sym_unsigned] = ACTIONS(3521),
    [anon_sym_long] = ACTIONS(3521),
    [anon_sym_short] = ACTIONS(3521),
    [anon_sym_LBRACK] = ACTIONS(3521),
    [anon_sym_static] = ACTIONS(3521),
    [anon_sym_register] = ACTIONS(3521),
    [anon_sym_inline] = ACTIONS(3521),
    [anon_sym___inline] = ACTIONS(3521),
    [anon_sym___inline__] = ACTIONS(3521),
    [anon_sym___forceinline] = ACTIONS(3521),
    [anon_sym_thread_local] = ACTIONS(3521),
    [anon_sym___thread] = ACTIONS(3521),
    [anon_sym_const] = ACTIONS(3521),
    [anon_sym_constexpr] = ACTIONS(3521),
    [anon_sym_volatile] = ACTIONS(3521),
    [anon_sym_restrict] = ACTIONS(3521),
    [anon_sym___restrict__] = ACTIONS(3521),
    [anon_sym__Atomic] = ACTIONS(3521),
    [anon_sym__Noreturn] = ACTIONS(3521),
    [anon_sym_noreturn] = ACTIONS(3521),
    [anon_sym_mutable] = ACTIONS(3521),
    [anon_sym_constinit] = ACTIONS(3521),
    [anon_sym_consteval] = ACTIONS(3521),
    [anon_sym_alignas] = ACTIONS(3521),
    [anon_sym__Alignas] = ACTIONS(3521),
    [sym_primitive_type] = ACTIONS(3521),
    [anon_sym_enum] = ACTIONS(3521),
    [anon_sym_class] = ACTIONS(3521),
    [anon_sym_struct] = ACTIONS(3521),
    [anon_sym_union] = ACTIONS(3521),
    [anon_sym_if] = ACTIONS(3521),
    [anon_sym_switch] = ACTIONS(3521),
    [anon_sym_case] = ACTIONS(3521),
    [anon_sym_default] = ACTIONS(3521),
    [anon_sym_while] = ACTIONS(3521),
    [anon_sym_do] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3521),
    [anon_sym_return] = ACTIONS(3521),
    [anon_sym_break] = ACTIONS(3521),
    [anon_sym_continue] = ACTIONS(3521),
    [anon_sym_goto] = ACTIONS(3521),
    [anon_sym___try] = ACTIONS(3521),
    [anon_sym___leave] = ACTIONS(3521),
    [anon_sym_not] = ACTIONS(3521),
    [anon_sym_compl] = ACTIONS(3521),
    [anon_sym_DASH_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_PLUS] = ACTIONS(3523),
    [anon_sym_sizeof] = ACTIONS(3521),
    [anon_sym___alignof__] = ACTIONS(3521),
    [anon_sym___alignof] = ACTIONS(3521),
    [anon_sym__alignof] = ACTIONS(3521),
    [anon_sym_alignof] = ACTIONS(3521),
    [anon_sym__Alignof] = ACTIONS(3521),
    [anon_sym_offsetof] = ACTIONS(3521),
    [anon_sym__Generic] = ACTIONS(3521),
    [anon_sym_asm] = ACTIONS(3521),
    [anon_sym___asm__] = ACTIONS(3521),
    [sym_number_literal] = ACTIONS(3523),
    [anon_sym_L_SQUOTE] = ACTIONS(3523),
    [anon_sym_u_SQUOTE] = ACTIONS(3523),
    [anon_sym_U_SQUOTE] = ACTIONS(3523),
    [anon_sym_u8_SQUOTE] = ACTIONS(3523),
    [anon_sym_SQUOTE] = ACTIONS(3523),
    [anon_sym_L_DQUOTE] = ACTIONS(3523),
    [anon_sym_u_DQUOTE] = ACTIONS(3523),
    [anon_sym_U_DQUOTE] = ACTIONS(3523),
    [anon_sym_u8_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [sym_true] = ACTIONS(3521),
    [sym_false] = ACTIONS(3521),
    [anon_sym_NULL] = ACTIONS(3521),
    [anon_sym_nullptr] = ACTIONS(3521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3521),
    [anon_sym_let] = ACTIONS(3521),
    [anon_sym_This] = ACTIONS(3521),
    [anon_sym_decltype] = ACTIONS(3521),
    [sym_virtual] = ACTIONS(3521),
    [anon_sym_explicit] = ACTIONS(3521),
    [anon_sym_typename] = ACTIONS(3521),
    [anon_sym_template] = ACTIONS(3521),
    [anon_sym_operator] = ACTIONS(3521),
    [anon_sym_try] = ACTIONS(3521),
    [anon_sym_delete] = ACTIONS(3521),
    [anon_sym_throw] = ACTIONS(3521),
    [anon_sym_namespace] = ACTIONS(3521),
    [anon_sym_using] = ACTIONS(3521),
    [anon_sym_static_assert] = ACTIONS(3521),
    [anon_sym_concept] = ACTIONS(3521),
    [anon_sym_co_return] = ACTIONS(3521),
    [anon_sym_co_yield] = ACTIONS(3521),
    [anon_sym_R_DQUOTE] = ACTIONS(3523),
    [anon_sym_LR_DQUOTE] = ACTIONS(3523),
    [anon_sym_uR_DQUOTE] = ACTIONS(3523),
    [anon_sym_UR_DQUOTE] = ACTIONS(3523),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3523),
    [anon_sym_co_await] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3521),
    [anon_sym_requires] = ACTIONS(3521),
    [sym_this] = ACTIONS(3521),
    [anon_sym_discard] = ACTIONS(3521),
    [anon_sym_precise] = ACTIONS(3521),
    [anon_sym_shared] = ACTIONS(3521),
    [anon_sym_groupshared] = ACTIONS(3521),
    [anon_sym_uniform] = ACTIONS(3521),
    [anon_sym_row_major] = ACTIONS(3521),
    [anon_sym_column_major] = ACTIONS(3521),
    [anon_sym_globallycoherent] = ACTIONS(3521),
    [anon_sym_centroid] = ACTIONS(3521),
    [anon_sym_noperspective] = ACTIONS(3521),
    [anon_sym_nointerpolation] = ACTIONS(3521),
    [anon_sym_sample] = ACTIONS(3521),
    [anon_sym_linear] = ACTIONS(3521),
    [anon_sym_snorm] = ACTIONS(3521),
    [anon_sym_unorm] = ACTIONS(3521),
    [anon_sym_point] = ACTIONS(3521),
    [anon_sym_line] = ACTIONS(3521),
    [anon_sym_triangleadj] = ACTIONS(3521),
    [anon_sym_lineadj] = ACTIONS(3521),
    [anon_sym_triangle] = ACTIONS(3521),
    [anon_sym_cbuffer] = ACTIONS(3521),
    [anon_sym_interface] = ACTIONS(3521),
    [anon_sym_extension] = ACTIONS(3521),
  },
  [874] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(285),
    [ts_builtin_sym_end] = ACTIONS(3759),
    [sym_identifier] = ACTIONS(3757),
    [aux_sym_preproc_include_token1] = ACTIONS(3757),
    [aux_sym_preproc_def_token1] = ACTIONS(3757),
    [aux_sym_preproc_if_token1] = ACTIONS(3757),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3757),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3757),
    [sym_preproc_directive] = ACTIONS(3757),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_BANG] = ACTIONS(3759),
    [anon_sym_TILDE] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3757),
    [anon_sym_PLUS] = ACTIONS(3757),
    [anon_sym_STAR] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_AMP] = ACTIONS(3757),
    [anon_sym_SEMI] = ACTIONS(3759),
    [anon_sym___extension__] = ACTIONS(3757),
    [anon_sym_typedef] = ACTIONS(3757),
    [anon_sym_in] = ACTIONS(3757),
    [anon_sym_out] = ACTIONS(3757),
    [anon_sym_inout] = ACTIONS(3757),
    [anon_sym_extern] = ACTIONS(3757),
    [anon_sym___attribute__] = ACTIONS(3757),
    [anon_sym_COLON_COLON] = ACTIONS(3759),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3759),
    [anon_sym___declspec] = ACTIONS(3757),
    [anon_sym___based] = ACTIONS(3757),
    [anon_sym___cdecl] = ACTIONS(3757),
    [anon_sym___clrcall] = ACTIONS(3757),
    [anon_sym___stdcall] = ACTIONS(3757),
    [anon_sym___fastcall] = ACTIONS(3757),
    [anon_sym___thiscall] = ACTIONS(3757),
    [anon_sym___vectorcall] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_signed] = ACTIONS(3923),
    [anon_sym_unsigned] = ACTIONS(3923),
    [anon_sym_long] = ACTIONS(3923),
    [anon_sym_short] = ACTIONS(3923),
    [anon_sym_LBRACK] = ACTIONS(3757),
    [anon_sym_static] = ACTIONS(3757),
    [anon_sym_register] = ACTIONS(3757),
    [anon_sym_inline] = ACTIONS(3757),
    [anon_sym___inline] = ACTIONS(3757),
    [anon_sym___inline__] = ACTIONS(3757),
    [anon_sym___forceinline] = ACTIONS(3757),
    [anon_sym_thread_local] = ACTIONS(3757),
    [anon_sym___thread] = ACTIONS(3757),
    [anon_sym_const] = ACTIONS(3757),
    [anon_sym_constexpr] = ACTIONS(3757),
    [anon_sym_volatile] = ACTIONS(3757),
    [anon_sym_restrict] = ACTIONS(3757),
    [anon_sym___restrict__] = ACTIONS(3757),
    [anon_sym__Atomic] = ACTIONS(3757),
    [anon_sym__Noreturn] = ACTIONS(3757),
    [anon_sym_noreturn] = ACTIONS(3757),
    [anon_sym_mutable] = ACTIONS(3757),
    [anon_sym_constinit] = ACTIONS(3757),
    [anon_sym_consteval] = ACTIONS(3757),
    [anon_sym_alignas] = ACTIONS(3757),
    [anon_sym__Alignas] = ACTIONS(3757),
    [sym_primitive_type] = ACTIONS(3757),
    [anon_sym_enum] = ACTIONS(3757),
    [anon_sym_class] = ACTIONS(3757),
    [anon_sym_struct] = ACTIONS(3757),
    [anon_sym_union] = ACTIONS(3757),
    [anon_sym_if] = ACTIONS(3757),
    [anon_sym_switch] = ACTIONS(3757),
    [anon_sym_case] = ACTIONS(3757),
    [anon_sym_default] = ACTIONS(3757),
    [anon_sym_while] = ACTIONS(3757),
    [anon_sym_do] = ACTIONS(3757),
    [anon_sym_for] = ACTIONS(3757),
    [anon_sym_return] = ACTIONS(3757),
    [anon_sym_break] = ACTIONS(3757),
    [anon_sym_continue] = ACTIONS(3757),
    [anon_sym_goto] = ACTIONS(3757),
    [anon_sym_not] = ACTIONS(3757),
    [anon_sym_compl] = ACTIONS(3757),
    [anon_sym_DASH_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_PLUS] = ACTIONS(3759),
    [anon_sym_sizeof] = ACTIONS(3757),
    [anon_sym___alignof__] = ACTIONS(3757),
    [anon_sym___alignof] = ACTIONS(3757),
    [anon_sym__alignof] = ACTIONS(3757),
    [anon_sym_alignof] = ACTIONS(3757),
    [anon_sym__Alignof] = ACTIONS(3757),
    [anon_sym_offsetof] = ACTIONS(3757),
    [anon_sym__Generic] = ACTIONS(3757),
    [anon_sym_asm] = ACTIONS(3757),
    [anon_sym___asm__] = ACTIONS(3757),
    [anon_sym_DOT] = ACTIONS(3757),
    [sym_number_literal] = ACTIONS(3759),
    [anon_sym_L_SQUOTE] = ACTIONS(3759),
    [anon_sym_u_SQUOTE] = ACTIONS(3759),
    [anon_sym_U_SQUOTE] = ACTIONS(3759),
    [anon_sym_u8_SQUOTE] = ACTIONS(3759),
    [anon_sym_SQUOTE] = ACTIONS(3759),
    [anon_sym_L_DQUOTE] = ACTIONS(3759),
    [anon_sym_u_DQUOTE] = ACTIONS(3759),
    [anon_sym_U_DQUOTE] = ACTIONS(3759),
    [anon_sym_u8_DQUOTE] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [sym_true] = ACTIONS(3757),
    [sym_false] = ACTIONS(3757),
    [anon_sym_NULL] = ACTIONS(3757),
    [anon_sym_nullptr] = ACTIONS(3757),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3757),
    [anon_sym_let] = ACTIONS(3757),
    [anon_sym_This] = ACTIONS(3757),
    [anon_sym_decltype] = ACTIONS(3757),
    [sym_virtual] = ACTIONS(3757),
    [anon_sym_explicit] = ACTIONS(3757),
    [anon_sym_typename] = ACTIONS(3757),
    [anon_sym_template] = ACTIONS(3757),
    [anon_sym_operator] = ACTIONS(3757),
    [anon_sym_try] = ACTIONS(3757),
    [anon_sym_delete] = ACTIONS(3757),
    [anon_sym_throw] = ACTIONS(3757),
    [anon_sym_namespace] = ACTIONS(3757),
    [anon_sym_using] = ACTIONS(3757),
    [anon_sym_static_assert] = ACTIONS(3757),
    [anon_sym_concept] = ACTIONS(3757),
    [anon_sym_co_return] = ACTIONS(3757),
    [anon_sym_co_yield] = ACTIONS(3757),
    [anon_sym_R_DQUOTE] = ACTIONS(3759),
    [anon_sym_LR_DQUOTE] = ACTIONS(3759),
    [anon_sym_uR_DQUOTE] = ACTIONS(3759),
    [anon_sym_UR_DQUOTE] = ACTIONS(3759),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3759),
    [anon_sym_co_await] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3757),
    [anon_sym_requires] = ACTIONS(3757),
    [sym_this] = ACTIONS(3757),
    [anon_sym_precise] = ACTIONS(3757),
    [anon_sym_shared] = ACTIONS(3757),
    [anon_sym_groupshared] = ACTIONS(3757),
    [anon_sym_uniform] = ACTIONS(3757),
    [anon_sym_row_major] = ACTIONS(3757),
    [anon_sym_column_major] = ACTIONS(3757),
    [anon_sym_globallycoherent] = ACTIONS(3757),
    [anon_sym_centroid] = ACTIONS(3757),
    [anon_sym_noperspective] = ACTIONS(3757),
    [anon_sym_nointerpolation] = ACTIONS(3757),
    [anon_sym_sample] = ACTIONS(3757),
    [anon_sym_linear] = ACTIONS(3757),
    [anon_sym_snorm] = ACTIONS(3757),
    [anon_sym_unorm] = ACTIONS(3757),
    [anon_sym_point] = ACTIONS(3757),
    [anon_sym_line] = ACTIONS(3757),
    [anon_sym_triangleadj] = ACTIONS(3757),
    [anon_sym_lineadj] = ACTIONS(3757),
    [anon_sym_triangle] = ACTIONS(3757),
    [anon_sym_interface] = ACTIONS(3757),
    [anon_sym_extension] = ACTIONS(3757),
    [anon_sym___exported] = ACTIONS(3757),
    [anon_sym_import] = ACTIONS(3757),
  },
  [875] = {
    [sym_identifier] = ACTIONS(3539),
    [aux_sym_preproc_include_token1] = ACTIONS(3539),
    [aux_sym_preproc_def_token1] = ACTIONS(3539),
    [aux_sym_preproc_if_token1] = ACTIONS(3539),
    [aux_sym_preproc_if_token2] = ACTIONS(3539),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3539),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3539),
    [sym_preproc_directive] = ACTIONS(3539),
    [anon_sym_LPAREN2] = ACTIONS(3541),
    [anon_sym_BANG] = ACTIONS(3541),
    [anon_sym_TILDE] = ACTIONS(3541),
    [anon_sym_DASH] = ACTIONS(3539),
    [anon_sym_PLUS] = ACTIONS(3539),
    [anon_sym_STAR] = ACTIONS(3541),
    [anon_sym_AMP_AMP] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym_SEMI] = ACTIONS(3541),
    [anon_sym___extension__] = ACTIONS(3539),
    [anon_sym_typedef] = ACTIONS(3539),
    [anon_sym_in] = ACTIONS(3539),
    [anon_sym_out] = ACTIONS(3539),
    [anon_sym_inout] = ACTIONS(3539),
    [anon_sym_extern] = ACTIONS(3539),
    [anon_sym___attribute__] = ACTIONS(3539),
    [anon_sym_COLON_COLON] = ACTIONS(3541),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3541),
    [anon_sym___declspec] = ACTIONS(3539),
    [anon_sym___based] = ACTIONS(3539),
    [anon_sym___cdecl] = ACTIONS(3539),
    [anon_sym___clrcall] = ACTIONS(3539),
    [anon_sym___stdcall] = ACTIONS(3539),
    [anon_sym___fastcall] = ACTIONS(3539),
    [anon_sym___thiscall] = ACTIONS(3539),
    [anon_sym___vectorcall] = ACTIONS(3539),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_signed] = ACTIONS(3539),
    [anon_sym_unsigned] = ACTIONS(3539),
    [anon_sym_long] = ACTIONS(3539),
    [anon_sym_short] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_static] = ACTIONS(3539),
    [anon_sym_register] = ACTIONS(3539),
    [anon_sym_inline] = ACTIONS(3539),
    [anon_sym___inline] = ACTIONS(3539),
    [anon_sym___inline__] = ACTIONS(3539),
    [anon_sym___forceinline] = ACTIONS(3539),
    [anon_sym_thread_local] = ACTIONS(3539),
    [anon_sym___thread] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3539),
    [anon_sym_constexpr] = ACTIONS(3539),
    [anon_sym_volatile] = ACTIONS(3539),
    [anon_sym_restrict] = ACTIONS(3539),
    [anon_sym___restrict__] = ACTIONS(3539),
    [anon_sym__Atomic] = ACTIONS(3539),
    [anon_sym__Noreturn] = ACTIONS(3539),
    [anon_sym_noreturn] = ACTIONS(3539),
    [anon_sym_mutable] = ACTIONS(3539),
    [anon_sym_constinit] = ACTIONS(3539),
    [anon_sym_consteval] = ACTIONS(3539),
    [anon_sym_alignas] = ACTIONS(3539),
    [anon_sym__Alignas] = ACTIONS(3539),
    [sym_primitive_type] = ACTIONS(3539),
    [anon_sym_enum] = ACTIONS(3539),
    [anon_sym_class] = ACTIONS(3539),
    [anon_sym_struct] = ACTIONS(3539),
    [anon_sym_union] = ACTIONS(3539),
    [anon_sym_if] = ACTIONS(3539),
    [anon_sym_switch] = ACTIONS(3539),
    [anon_sym_case] = ACTIONS(3539),
    [anon_sym_default] = ACTIONS(3539),
    [anon_sym_while] = ACTIONS(3539),
    [anon_sym_do] = ACTIONS(3539),
    [anon_sym_for] = ACTIONS(3539),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_break] = ACTIONS(3539),
    [anon_sym_continue] = ACTIONS(3539),
    [anon_sym_goto] = ACTIONS(3539),
    [anon_sym___try] = ACTIONS(3539),
    [anon_sym___leave] = ACTIONS(3539),
    [anon_sym_not] = ACTIONS(3539),
    [anon_sym_compl] = ACTIONS(3539),
    [anon_sym_DASH_DASH] = ACTIONS(3541),
    [anon_sym_PLUS_PLUS] = ACTIONS(3541),
    [anon_sym_sizeof] = ACTIONS(3539),
    [anon_sym___alignof__] = ACTIONS(3539),
    [anon_sym___alignof] = ACTIONS(3539),
    [anon_sym__alignof] = ACTIONS(3539),
    [anon_sym_alignof] = ACTIONS(3539),
    [anon_sym__Alignof] = ACTIONS(3539),
    [anon_sym_offsetof] = ACTIONS(3539),
    [anon_sym__Generic] = ACTIONS(3539),
    [anon_sym_asm] = ACTIONS(3539),
    [anon_sym___asm__] = ACTIONS(3539),
    [sym_number_literal] = ACTIONS(3541),
    [anon_sym_L_SQUOTE] = ACTIONS(3541),
    [anon_sym_u_SQUOTE] = ACTIONS(3541),
    [anon_sym_U_SQUOTE] = ACTIONS(3541),
    [anon_sym_u8_SQUOTE] = ACTIONS(3541),
    [anon_sym_SQUOTE] = ACTIONS(3541),
    [anon_sym_L_DQUOTE] = ACTIONS(3541),
    [anon_sym_u_DQUOTE] = ACTIONS(3541),
    [anon_sym_U_DQUOTE] = ACTIONS(3541),
    [anon_sym_u8_DQUOTE] = ACTIONS(3541),
    [anon_sym_DQUOTE] = ACTIONS(3541),
    [sym_true] = ACTIONS(3539),
    [sym_false] = ACTIONS(3539),
    [anon_sym_NULL] = ACTIONS(3539),
    [anon_sym_nullptr] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_This] = ACTIONS(3539),
    [anon_sym_decltype] = ACTIONS(3539),
    [sym_virtual] = ACTIONS(3539),
    [anon_sym_explicit] = ACTIONS(3539),
    [anon_sym_typename] = ACTIONS(3539),
    [anon_sym_template] = ACTIONS(3539),
    [anon_sym_operator] = ACTIONS(3539),
    [anon_sym_try] = ACTIONS(3539),
    [anon_sym_delete] = ACTIONS(3539),
    [anon_sym_throw] = ACTIONS(3539),
    [anon_sym_namespace] = ACTIONS(3539),
    [anon_sym_using] = ACTIONS(3539),
    [anon_sym_static_assert] = ACTIONS(3539),
    [anon_sym_concept] = ACTIONS(3539),
    [anon_sym_co_return] = ACTIONS(3539),
    [anon_sym_co_yield] = ACTIONS(3539),
    [anon_sym_R_DQUOTE] = ACTIONS(3541),
    [anon_sym_LR_DQUOTE] = ACTIONS(3541),
    [anon_sym_uR_DQUOTE] = ACTIONS(3541),
    [anon_sym_UR_DQUOTE] = ACTIONS(3541),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3541),
    [anon_sym_co_await] = ACTIONS(3539),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_requires] = ACTIONS(3539),
    [sym_this] = ACTIONS(3539),
    [anon_sym_discard] = ACTIONS(3539),
    [anon_sym_precise] = ACTIONS(3539),
    [anon_sym_shared] = ACTIONS(3539),
    [anon_sym_groupshared] = ACTIONS(3539),
    [anon_sym_uniform] = ACTIONS(3539),
    [anon_sym_row_major] = ACTIONS(3539),
    [anon_sym_column_major] = ACTIONS(3539),
    [anon_sym_globallycoherent] = ACTIONS(3539),
    [anon_sym_centroid] = ACTIONS(3539),
    [anon_sym_noperspective] = ACTIONS(3539),
    [anon_sym_nointerpolation] = ACTIONS(3539),
    [anon_sym_sample] = ACTIONS(3539),
    [anon_sym_linear] = ACTIONS(3539),
    [anon_sym_snorm] = ACTIONS(3539),
    [anon_sym_unorm] = ACTIONS(3539),
    [anon_sym_point] = ACTIONS(3539),
    [anon_sym_line] = ACTIONS(3539),
    [anon_sym_triangleadj] = ACTIONS(3539),
    [anon_sym_lineadj] = ACTIONS(3539),
    [anon_sym_triangle] = ACTIONS(3539),
    [anon_sym_cbuffer] = ACTIONS(3539),
    [anon_sym_interface] = ACTIONS(3539),
    [anon_sym_extension] = ACTIONS(3539),
  },
  [876] = {
    [sym_identifier] = ACTIONS(3649),
    [aux_sym_preproc_include_token1] = ACTIONS(3649),
    [aux_sym_preproc_def_token1] = ACTIONS(3649),
    [aux_sym_preproc_if_token1] = ACTIONS(3649),
    [aux_sym_preproc_if_token2] = ACTIONS(3649),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3649),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3649),
    [sym_preproc_directive] = ACTIONS(3649),
    [anon_sym_LPAREN2] = ACTIONS(3651),
    [anon_sym_BANG] = ACTIONS(3651),
    [anon_sym_TILDE] = ACTIONS(3651),
    [anon_sym_DASH] = ACTIONS(3649),
    [anon_sym_PLUS] = ACTIONS(3649),
    [anon_sym_STAR] = ACTIONS(3651),
    [anon_sym_AMP_AMP] = ACTIONS(3651),
    [anon_sym_AMP] = ACTIONS(3649),
    [anon_sym_SEMI] = ACTIONS(3651),
    [anon_sym___extension__] = ACTIONS(3649),
    [anon_sym_typedef] = ACTIONS(3649),
    [anon_sym_in] = ACTIONS(3649),
    [anon_sym_out] = ACTIONS(3649),
    [anon_sym_inout] = ACTIONS(3649),
    [anon_sym_extern] = ACTIONS(3649),
    [anon_sym___attribute__] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(3651),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3651),
    [anon_sym___declspec] = ACTIONS(3649),
    [anon_sym___based] = ACTIONS(3649),
    [anon_sym___cdecl] = ACTIONS(3649),
    [anon_sym___clrcall] = ACTIONS(3649),
    [anon_sym___stdcall] = ACTIONS(3649),
    [anon_sym___fastcall] = ACTIONS(3649),
    [anon_sym___thiscall] = ACTIONS(3649),
    [anon_sym___vectorcall] = ACTIONS(3649),
    [anon_sym_LBRACE] = ACTIONS(3651),
    [anon_sym_signed] = ACTIONS(3649),
    [anon_sym_unsigned] = ACTIONS(3649),
    [anon_sym_long] = ACTIONS(3649),
    [anon_sym_short] = ACTIONS(3649),
    [anon_sym_LBRACK] = ACTIONS(3649),
    [anon_sym_static] = ACTIONS(3649),
    [anon_sym_register] = ACTIONS(3649),
    [anon_sym_inline] = ACTIONS(3649),
    [anon_sym___inline] = ACTIONS(3649),
    [anon_sym___inline__] = ACTIONS(3649),
    [anon_sym___forceinline] = ACTIONS(3649),
    [anon_sym_thread_local] = ACTIONS(3649),
    [anon_sym___thread] = ACTIONS(3649),
    [anon_sym_const] = ACTIONS(3649),
    [anon_sym_constexpr] = ACTIONS(3649),
    [anon_sym_volatile] = ACTIONS(3649),
    [anon_sym_restrict] = ACTIONS(3649),
    [anon_sym___restrict__] = ACTIONS(3649),
    [anon_sym__Atomic] = ACTIONS(3649),
    [anon_sym__Noreturn] = ACTIONS(3649),
    [anon_sym_noreturn] = ACTIONS(3649),
    [anon_sym_mutable] = ACTIONS(3649),
    [anon_sym_constinit] = ACTIONS(3649),
    [anon_sym_consteval] = ACTIONS(3649),
    [anon_sym_alignas] = ACTIONS(3649),
    [anon_sym__Alignas] = ACTIONS(3649),
    [sym_primitive_type] = ACTIONS(3649),
    [anon_sym_enum] = ACTIONS(3649),
    [anon_sym_class] = ACTIONS(3649),
    [anon_sym_struct] = ACTIONS(3649),
    [anon_sym_union] = ACTIONS(3649),
    [anon_sym_if] = ACTIONS(3649),
    [anon_sym_switch] = ACTIONS(3649),
    [anon_sym_case] = ACTIONS(3649),
    [anon_sym_default] = ACTIONS(3649),
    [anon_sym_while] = ACTIONS(3649),
    [anon_sym_do] = ACTIONS(3649),
    [anon_sym_for] = ACTIONS(3649),
    [anon_sym_return] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3649),
    [anon_sym_continue] = ACTIONS(3649),
    [anon_sym_goto] = ACTIONS(3649),
    [anon_sym___try] = ACTIONS(3649),
    [anon_sym___leave] = ACTIONS(3649),
    [anon_sym_not] = ACTIONS(3649),
    [anon_sym_compl] = ACTIONS(3649),
    [anon_sym_DASH_DASH] = ACTIONS(3651),
    [anon_sym_PLUS_PLUS] = ACTIONS(3651),
    [anon_sym_sizeof] = ACTIONS(3649),
    [anon_sym___alignof__] = ACTIONS(3649),
    [anon_sym___alignof] = ACTIONS(3649),
    [anon_sym__alignof] = ACTIONS(3649),
    [anon_sym_alignof] = ACTIONS(3649),
    [anon_sym__Alignof] = ACTIONS(3649),
    [anon_sym_offsetof] = ACTIONS(3649),
    [anon_sym__Generic] = ACTIONS(3649),
    [anon_sym_asm] = ACTIONS(3649),
    [anon_sym___asm__] = ACTIONS(3649),
    [sym_number_literal] = ACTIONS(3651),
    [anon_sym_L_SQUOTE] = ACTIONS(3651),
    [anon_sym_u_SQUOTE] = ACTIONS(3651),
    [anon_sym_U_SQUOTE] = ACTIONS(3651),
    [anon_sym_u8_SQUOTE] = ACTIONS(3651),
    [anon_sym_SQUOTE] = ACTIONS(3651),
    [anon_sym_L_DQUOTE] = ACTIONS(3651),
    [anon_sym_u_DQUOTE] = ACTIONS(3651),
    [anon_sym_U_DQUOTE] = ACTIONS(3651),
    [anon_sym_u8_DQUOTE] = ACTIONS(3651),
    [anon_sym_DQUOTE] = ACTIONS(3651),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [anon_sym_NULL] = ACTIONS(3649),
    [anon_sym_nullptr] = ACTIONS(3649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3649),
    [anon_sym_let] = ACTIONS(3649),
    [anon_sym_This] = ACTIONS(3649),
    [anon_sym_decltype] = ACTIONS(3649),
    [sym_virtual] = ACTIONS(3649),
    [anon_sym_explicit] = ACTIONS(3649),
    [anon_sym_typename] = ACTIONS(3649),
    [anon_sym_template] = ACTIONS(3649),
    [anon_sym_operator] = ACTIONS(3649),
    [anon_sym_try] = ACTIONS(3649),
    [anon_sym_delete] = ACTIONS(3649),
    [anon_sym_throw] = ACTIONS(3649),
    [anon_sym_namespace] = ACTIONS(3649),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_static_assert] = ACTIONS(3649),
    [anon_sym_concept] = ACTIONS(3649),
    [anon_sym_co_return] = ACTIONS(3649),
    [anon_sym_co_yield] = ACTIONS(3649),
    [anon_sym_R_DQUOTE] = ACTIONS(3651),
    [anon_sym_LR_DQUOTE] = ACTIONS(3651),
    [anon_sym_uR_DQUOTE] = ACTIONS(3651),
    [anon_sym_UR_DQUOTE] = ACTIONS(3651),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3651),
    [anon_sym_co_await] = ACTIONS(3649),
    [anon_sym_new] = ACTIONS(3649),
    [anon_sym_requires] = ACTIONS(3649),
    [sym_this] = ACTIONS(3649),
    [anon_sym_discard] = ACTIONS(3649),
    [anon_sym_precise] = ACTIONS(3649),
    [anon_sym_shared] = ACTIONS(3649),
    [anon_sym_groupshared] = ACTIONS(3649),
    [anon_sym_uniform] = ACTIONS(3649),
    [anon_sym_row_major] = ACTIONS(3649),
    [anon_sym_column_major] = ACTIONS(3649),
    [anon_sym_globallycoherent] = ACTIONS(3649),
    [anon_sym_centroid] = ACTIONS(3649),
    [anon_sym_noperspective] = ACTIONS(3649),
    [anon_sym_nointerpolation] = ACTIONS(3649),
    [anon_sym_sample] = ACTIONS(3649),
    [anon_sym_linear] = ACTIONS(3649),
    [anon_sym_snorm] = ACTIONS(3649),
    [anon_sym_unorm] = ACTIONS(3649),
    [anon_sym_point] = ACTIONS(3649),
    [anon_sym_line] = ACTIONS(3649),
    [anon_sym_triangleadj] = ACTIONS(3649),
    [anon_sym_lineadj] = ACTIONS(3649),
    [anon_sym_triangle] = ACTIONS(3649),
    [anon_sym_cbuffer] = ACTIONS(3649),
    [anon_sym_interface] = ACTIONS(3649),
    [anon_sym_extension] = ACTIONS(3649),
  },
  [877] = {
    [sym_identifier] = ACTIONS(3673),
    [aux_sym_preproc_include_token1] = ACTIONS(3673),
    [aux_sym_preproc_def_token1] = ACTIONS(3673),
    [aux_sym_preproc_if_token1] = ACTIONS(3673),
    [aux_sym_preproc_if_token2] = ACTIONS(3673),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3673),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3673),
    [sym_preproc_directive] = ACTIONS(3673),
    [anon_sym_LPAREN2] = ACTIONS(3675),
    [anon_sym_BANG] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3673),
    [anon_sym_PLUS] = ACTIONS(3673),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3673),
    [anon_sym_SEMI] = ACTIONS(3675),
    [anon_sym___extension__] = ACTIONS(3673),
    [anon_sym_typedef] = ACTIONS(3673),
    [anon_sym_in] = ACTIONS(3673),
    [anon_sym_out] = ACTIONS(3673),
    [anon_sym_inout] = ACTIONS(3673),
    [anon_sym_extern] = ACTIONS(3673),
    [anon_sym___attribute__] = ACTIONS(3673),
    [anon_sym_COLON_COLON] = ACTIONS(3675),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3675),
    [anon_sym___declspec] = ACTIONS(3673),
    [anon_sym___based] = ACTIONS(3673),
    [anon_sym___cdecl] = ACTIONS(3673),
    [anon_sym___clrcall] = ACTIONS(3673),
    [anon_sym___stdcall] = ACTIONS(3673),
    [anon_sym___fastcall] = ACTIONS(3673),
    [anon_sym___thiscall] = ACTIONS(3673),
    [anon_sym___vectorcall] = ACTIONS(3673),
    [anon_sym_LBRACE] = ACTIONS(3675),
    [anon_sym_signed] = ACTIONS(3673),
    [anon_sym_unsigned] = ACTIONS(3673),
    [anon_sym_long] = ACTIONS(3673),
    [anon_sym_short] = ACTIONS(3673),
    [anon_sym_LBRACK] = ACTIONS(3673),
    [anon_sym_static] = ACTIONS(3673),
    [anon_sym_register] = ACTIONS(3673),
    [anon_sym_inline] = ACTIONS(3673),
    [anon_sym___inline] = ACTIONS(3673),
    [anon_sym___inline__] = ACTIONS(3673),
    [anon_sym___forceinline] = ACTIONS(3673),
    [anon_sym_thread_local] = ACTIONS(3673),
    [anon_sym___thread] = ACTIONS(3673),
    [anon_sym_const] = ACTIONS(3673),
    [anon_sym_constexpr] = ACTIONS(3673),
    [anon_sym_volatile] = ACTIONS(3673),
    [anon_sym_restrict] = ACTIONS(3673),
    [anon_sym___restrict__] = ACTIONS(3673),
    [anon_sym__Atomic] = ACTIONS(3673),
    [anon_sym__Noreturn] = ACTIONS(3673),
    [anon_sym_noreturn] = ACTIONS(3673),
    [anon_sym_mutable] = ACTIONS(3673),
    [anon_sym_constinit] = ACTIONS(3673),
    [anon_sym_consteval] = ACTIONS(3673),
    [anon_sym_alignas] = ACTIONS(3673),
    [anon_sym__Alignas] = ACTIONS(3673),
    [sym_primitive_type] = ACTIONS(3673),
    [anon_sym_enum] = ACTIONS(3673),
    [anon_sym_class] = ACTIONS(3673),
    [anon_sym_struct] = ACTIONS(3673),
    [anon_sym_union] = ACTIONS(3673),
    [anon_sym_if] = ACTIONS(3673),
    [anon_sym_switch] = ACTIONS(3673),
    [anon_sym_case] = ACTIONS(3673),
    [anon_sym_default] = ACTIONS(3673),
    [anon_sym_while] = ACTIONS(3673),
    [anon_sym_do] = ACTIONS(3673),
    [anon_sym_for] = ACTIONS(3673),
    [anon_sym_return] = ACTIONS(3673),
    [anon_sym_break] = ACTIONS(3673),
    [anon_sym_continue] = ACTIONS(3673),
    [anon_sym_goto] = ACTIONS(3673),
    [anon_sym___try] = ACTIONS(3673),
    [anon_sym___leave] = ACTIONS(3673),
    [anon_sym_not] = ACTIONS(3673),
    [anon_sym_compl] = ACTIONS(3673),
    [anon_sym_DASH_DASH] = ACTIONS(3675),
    [anon_sym_PLUS_PLUS] = ACTIONS(3675),
    [anon_sym_sizeof] = ACTIONS(3673),
    [anon_sym___alignof__] = ACTIONS(3673),
    [anon_sym___alignof] = ACTIONS(3673),
    [anon_sym__alignof] = ACTIONS(3673),
    [anon_sym_alignof] = ACTIONS(3673),
    [anon_sym__Alignof] = ACTIONS(3673),
    [anon_sym_offsetof] = ACTIONS(3673),
    [anon_sym__Generic] = ACTIONS(3673),
    [anon_sym_asm] = ACTIONS(3673),
    [anon_sym___asm__] = ACTIONS(3673),
    [sym_number_literal] = ACTIONS(3675),
    [anon_sym_L_SQUOTE] = ACTIONS(3675),
    [anon_sym_u_SQUOTE] = ACTIONS(3675),
    [anon_sym_U_SQUOTE] = ACTIONS(3675),
    [anon_sym_u8_SQUOTE] = ACTIONS(3675),
    [anon_sym_SQUOTE] = ACTIONS(3675),
    [anon_sym_L_DQUOTE] = ACTIONS(3675),
    [anon_sym_u_DQUOTE] = ACTIONS(3675),
    [anon_sym_U_DQUOTE] = ACTIONS(3675),
    [anon_sym_u8_DQUOTE] = ACTIONS(3675),
    [anon_sym_DQUOTE] = ACTIONS(3675),
    [sym_true] = ACTIONS(3673),
    [sym_false] = ACTIONS(3673),
    [anon_sym_NULL] = ACTIONS(3673),
    [anon_sym_nullptr] = ACTIONS(3673),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3673),
    [anon_sym_let] = ACTIONS(3673),
    [anon_sym_This] = ACTIONS(3673),
    [anon_sym_decltype] = ACTIONS(3673),
    [sym_virtual] = ACTIONS(3673),
    [anon_sym_explicit] = ACTIONS(3673),
    [anon_sym_typename] = ACTIONS(3673),
    [anon_sym_template] = ACTIONS(3673),
    [anon_sym_operator] = ACTIONS(3673),
    [anon_sym_try] = ACTIONS(3673),
    [anon_sym_delete] = ACTIONS(3673),
    [anon_sym_throw] = ACTIONS(3673),
    [anon_sym_namespace] = ACTIONS(3673),
    [anon_sym_using] = ACTIONS(3673),
    [anon_sym_static_assert] = ACTIONS(3673),
    [anon_sym_concept] = ACTIONS(3673),
    [anon_sym_co_return] = ACTIONS(3673),
    [anon_sym_co_yield] = ACTIONS(3673),
    [anon_sym_R_DQUOTE] = ACTIONS(3675),
    [anon_sym_LR_DQUOTE] = ACTIONS(3675),
    [anon_sym_uR_DQUOTE] = ACTIONS(3675),
    [anon_sym_UR_DQUOTE] = ACTIONS(3675),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3675),
    [anon_sym_co_await] = ACTIONS(3673),
    [anon_sym_new] = ACTIONS(3673),
    [anon_sym_requires] = ACTIONS(3673),
    [sym_this] = ACTIONS(3673),
    [anon_sym_discard] = ACTIONS(3673),
    [anon_sym_precise] = ACTIONS(3673),
    [anon_sym_shared] = ACTIONS(3673),
    [anon_sym_groupshared] = ACTIONS(3673),
    [anon_sym_uniform] = ACTIONS(3673),
    [anon_sym_row_major] = ACTIONS(3673),
    [anon_sym_column_major] = ACTIONS(3673),
    [anon_sym_globallycoherent] = ACTIONS(3673),
    [anon_sym_centroid] = ACTIONS(3673),
    [anon_sym_noperspective] = ACTIONS(3673),
    [anon_sym_nointerpolation] = ACTIONS(3673),
    [anon_sym_sample] = ACTIONS(3673),
    [anon_sym_linear] = ACTIONS(3673),
    [anon_sym_snorm] = ACTIONS(3673),
    [anon_sym_unorm] = ACTIONS(3673),
    [anon_sym_point] = ACTIONS(3673),
    [anon_sym_line] = ACTIONS(3673),
    [anon_sym_triangleadj] = ACTIONS(3673),
    [anon_sym_lineadj] = ACTIONS(3673),
    [anon_sym_triangle] = ACTIONS(3673),
    [anon_sym_cbuffer] = ACTIONS(3673),
    [anon_sym_interface] = ACTIONS(3673),
    [anon_sym_extension] = ACTIONS(3673),
  },
  [878] = {
    [sym_identifier] = ACTIONS(3691),
    [aux_sym_preproc_include_token1] = ACTIONS(3691),
    [aux_sym_preproc_def_token1] = ACTIONS(3691),
    [aux_sym_preproc_if_token1] = ACTIONS(3691),
    [aux_sym_preproc_if_token2] = ACTIONS(3691),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3691),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3691),
    [sym_preproc_directive] = ACTIONS(3691),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_BANG] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_PLUS] = ACTIONS(3691),
    [anon_sym_STAR] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_AMP] = ACTIONS(3691),
    [anon_sym_SEMI] = ACTIONS(3693),
    [anon_sym___extension__] = ACTIONS(3691),
    [anon_sym_typedef] = ACTIONS(3691),
    [anon_sym_in] = ACTIONS(3691),
    [anon_sym_out] = ACTIONS(3691),
    [anon_sym_inout] = ACTIONS(3691),
    [anon_sym_extern] = ACTIONS(3691),
    [anon_sym___attribute__] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3693),
    [anon_sym___declspec] = ACTIONS(3691),
    [anon_sym___based] = ACTIONS(3691),
    [anon_sym___cdecl] = ACTIONS(3691),
    [anon_sym___clrcall] = ACTIONS(3691),
    [anon_sym___stdcall] = ACTIONS(3691),
    [anon_sym___fastcall] = ACTIONS(3691),
    [anon_sym___thiscall] = ACTIONS(3691),
    [anon_sym___vectorcall] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_signed] = ACTIONS(3691),
    [anon_sym_unsigned] = ACTIONS(3691),
    [anon_sym_long] = ACTIONS(3691),
    [anon_sym_short] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(3691),
    [anon_sym_static] = ACTIONS(3691),
    [anon_sym_register] = ACTIONS(3691),
    [anon_sym_inline] = ACTIONS(3691),
    [anon_sym___inline] = ACTIONS(3691),
    [anon_sym___inline__] = ACTIONS(3691),
    [anon_sym___forceinline] = ACTIONS(3691),
    [anon_sym_thread_local] = ACTIONS(3691),
    [anon_sym___thread] = ACTIONS(3691),
    [anon_sym_const] = ACTIONS(3691),
    [anon_sym_constexpr] = ACTIONS(3691),
    [anon_sym_volatile] = ACTIONS(3691),
    [anon_sym_restrict] = ACTIONS(3691),
    [anon_sym___restrict__] = ACTIONS(3691),
    [anon_sym__Atomic] = ACTIONS(3691),
    [anon_sym__Noreturn] = ACTIONS(3691),
    [anon_sym_noreturn] = ACTIONS(3691),
    [anon_sym_mutable] = ACTIONS(3691),
    [anon_sym_constinit] = ACTIONS(3691),
    [anon_sym_consteval] = ACTIONS(3691),
    [anon_sym_alignas] = ACTIONS(3691),
    [anon_sym__Alignas] = ACTIONS(3691),
    [sym_primitive_type] = ACTIONS(3691),
    [anon_sym_enum] = ACTIONS(3691),
    [anon_sym_class] = ACTIONS(3691),
    [anon_sym_struct] = ACTIONS(3691),
    [anon_sym_union] = ACTIONS(3691),
    [anon_sym_if] = ACTIONS(3691),
    [anon_sym_switch] = ACTIONS(3691),
    [anon_sym_case] = ACTIONS(3691),
    [anon_sym_default] = ACTIONS(3691),
    [anon_sym_while] = ACTIONS(3691),
    [anon_sym_do] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3691),
    [anon_sym_return] = ACTIONS(3691),
    [anon_sym_break] = ACTIONS(3691),
    [anon_sym_continue] = ACTIONS(3691),
    [anon_sym_goto] = ACTIONS(3691),
    [anon_sym___try] = ACTIONS(3691),
    [anon_sym___leave] = ACTIONS(3691),
    [anon_sym_not] = ACTIONS(3691),
    [anon_sym_compl] = ACTIONS(3691),
    [anon_sym_DASH_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_PLUS] = ACTIONS(3693),
    [anon_sym_sizeof] = ACTIONS(3691),
    [anon_sym___alignof__] = ACTIONS(3691),
    [anon_sym___alignof] = ACTIONS(3691),
    [anon_sym__alignof] = ACTIONS(3691),
    [anon_sym_alignof] = ACTIONS(3691),
    [anon_sym__Alignof] = ACTIONS(3691),
    [anon_sym_offsetof] = ACTIONS(3691),
    [anon_sym__Generic] = ACTIONS(3691),
    [anon_sym_asm] = ACTIONS(3691),
    [anon_sym___asm__] = ACTIONS(3691),
    [sym_number_literal] = ACTIONS(3693),
    [anon_sym_L_SQUOTE] = ACTIONS(3693),
    [anon_sym_u_SQUOTE] = ACTIONS(3693),
    [anon_sym_U_SQUOTE] = ACTIONS(3693),
    [anon_sym_u8_SQUOTE] = ACTIONS(3693),
    [anon_sym_SQUOTE] = ACTIONS(3693),
    [anon_sym_L_DQUOTE] = ACTIONS(3693),
    [anon_sym_u_DQUOTE] = ACTIONS(3693),
    [anon_sym_U_DQUOTE] = ACTIONS(3693),
    [anon_sym_u8_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [sym_true] = ACTIONS(3691),
    [sym_false] = ACTIONS(3691),
    [anon_sym_NULL] = ACTIONS(3691),
    [anon_sym_nullptr] = ACTIONS(3691),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3691),
    [anon_sym_let] = ACTIONS(3691),
    [anon_sym_This] = ACTIONS(3691),
    [anon_sym_decltype] = ACTIONS(3691),
    [sym_virtual] = ACTIONS(3691),
    [anon_sym_explicit] = ACTIONS(3691),
    [anon_sym_typename] = ACTIONS(3691),
    [anon_sym_template] = ACTIONS(3691),
    [anon_sym_operator] = ACTIONS(3691),
    [anon_sym_try] = ACTIONS(3691),
    [anon_sym_delete] = ACTIONS(3691),
    [anon_sym_throw] = ACTIONS(3691),
    [anon_sym_namespace] = ACTIONS(3691),
    [anon_sym_using] = ACTIONS(3691),
    [anon_sym_static_assert] = ACTIONS(3691),
    [anon_sym_concept] = ACTIONS(3691),
    [anon_sym_co_return] = ACTIONS(3691),
    [anon_sym_co_yield] = ACTIONS(3691),
    [anon_sym_R_DQUOTE] = ACTIONS(3693),
    [anon_sym_LR_DQUOTE] = ACTIONS(3693),
    [anon_sym_uR_DQUOTE] = ACTIONS(3693),
    [anon_sym_UR_DQUOTE] = ACTIONS(3693),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3693),
    [anon_sym_co_await] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3691),
    [anon_sym_requires] = ACTIONS(3691),
    [sym_this] = ACTIONS(3691),
    [anon_sym_discard] = ACTIONS(3691),
    [anon_sym_precise] = ACTIONS(3691),
    [anon_sym_shared] = ACTIONS(3691),
    [anon_sym_groupshared] = ACTIONS(3691),
    [anon_sym_uniform] = ACTIONS(3691),
    [anon_sym_row_major] = ACTIONS(3691),
    [anon_sym_column_major] = ACTIONS(3691),
    [anon_sym_globallycoherent] = ACTIONS(3691),
    [anon_sym_centroid] = ACTIONS(3691),
    [anon_sym_noperspective] = ACTIONS(3691),
    [anon_sym_nointerpolation] = ACTIONS(3691),
    [anon_sym_sample] = ACTIONS(3691),
    [anon_sym_linear] = ACTIONS(3691),
    [anon_sym_snorm] = ACTIONS(3691),
    [anon_sym_unorm] = ACTIONS(3691),
    [anon_sym_point] = ACTIONS(3691),
    [anon_sym_line] = ACTIONS(3691),
    [anon_sym_triangleadj] = ACTIONS(3691),
    [anon_sym_lineadj] = ACTIONS(3691),
    [anon_sym_triangle] = ACTIONS(3691),
    [anon_sym_cbuffer] = ACTIONS(3691),
    [anon_sym_interface] = ACTIONS(3691),
    [anon_sym_extension] = ACTIONS(3691),
  },
  [879] = {
    [sym_identifier] = ACTIONS(3505),
    [aux_sym_preproc_include_token1] = ACTIONS(3505),
    [aux_sym_preproc_def_token1] = ACTIONS(3505),
    [aux_sym_preproc_if_token1] = ACTIONS(3505),
    [aux_sym_preproc_if_token2] = ACTIONS(3505),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3505),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3505),
    [sym_preproc_directive] = ACTIONS(3505),
    [anon_sym_LPAREN2] = ACTIONS(3507),
    [anon_sym_BANG] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3505),
    [anon_sym_PLUS] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3507),
    [anon_sym___extension__] = ACTIONS(3505),
    [anon_sym_typedef] = ACTIONS(3505),
    [anon_sym_in] = ACTIONS(3505),
    [anon_sym_out] = ACTIONS(3505),
    [anon_sym_inout] = ACTIONS(3505),
    [anon_sym_extern] = ACTIONS(3505),
    [anon_sym___attribute__] = ACTIONS(3505),
    [anon_sym_COLON_COLON] = ACTIONS(3507),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3507),
    [anon_sym___declspec] = ACTIONS(3505),
    [anon_sym___based] = ACTIONS(3505),
    [anon_sym___cdecl] = ACTIONS(3505),
    [anon_sym___clrcall] = ACTIONS(3505),
    [anon_sym___stdcall] = ACTIONS(3505),
    [anon_sym___fastcall] = ACTIONS(3505),
    [anon_sym___thiscall] = ACTIONS(3505),
    [anon_sym___vectorcall] = ACTIONS(3505),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_signed] = ACTIONS(3505),
    [anon_sym_unsigned] = ACTIONS(3505),
    [anon_sym_long] = ACTIONS(3505),
    [anon_sym_short] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_static] = ACTIONS(3505),
    [anon_sym_register] = ACTIONS(3505),
    [anon_sym_inline] = ACTIONS(3505),
    [anon_sym___inline] = ACTIONS(3505),
    [anon_sym___inline__] = ACTIONS(3505),
    [anon_sym___forceinline] = ACTIONS(3505),
    [anon_sym_thread_local] = ACTIONS(3505),
    [anon_sym___thread] = ACTIONS(3505),
    [anon_sym_const] = ACTIONS(3505),
    [anon_sym_constexpr] = ACTIONS(3505),
    [anon_sym_volatile] = ACTIONS(3505),
    [anon_sym_restrict] = ACTIONS(3505),
    [anon_sym___restrict__] = ACTIONS(3505),
    [anon_sym__Atomic] = ACTIONS(3505),
    [anon_sym__Noreturn] = ACTIONS(3505),
    [anon_sym_noreturn] = ACTIONS(3505),
    [anon_sym_mutable] = ACTIONS(3505),
    [anon_sym_constinit] = ACTIONS(3505),
    [anon_sym_consteval] = ACTIONS(3505),
    [anon_sym_alignas] = ACTIONS(3505),
    [anon_sym__Alignas] = ACTIONS(3505),
    [sym_primitive_type] = ACTIONS(3505),
    [anon_sym_enum] = ACTIONS(3505),
    [anon_sym_class] = ACTIONS(3505),
    [anon_sym_struct] = ACTIONS(3505),
    [anon_sym_union] = ACTIONS(3505),
    [anon_sym_if] = ACTIONS(3505),
    [anon_sym_switch] = ACTIONS(3505),
    [anon_sym_case] = ACTIONS(3505),
    [anon_sym_default] = ACTIONS(3505),
    [anon_sym_while] = ACTIONS(3505),
    [anon_sym_do] = ACTIONS(3505),
    [anon_sym_for] = ACTIONS(3505),
    [anon_sym_return] = ACTIONS(3505),
    [anon_sym_break] = ACTIONS(3505),
    [anon_sym_continue] = ACTIONS(3505),
    [anon_sym_goto] = ACTIONS(3505),
    [anon_sym___try] = ACTIONS(3505),
    [anon_sym___leave] = ACTIONS(3505),
    [anon_sym_not] = ACTIONS(3505),
    [anon_sym_compl] = ACTIONS(3505),
    [anon_sym_DASH_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_PLUS] = ACTIONS(3507),
    [anon_sym_sizeof] = ACTIONS(3505),
    [anon_sym___alignof__] = ACTIONS(3505),
    [anon_sym___alignof] = ACTIONS(3505),
    [anon_sym__alignof] = ACTIONS(3505),
    [anon_sym_alignof] = ACTIONS(3505),
    [anon_sym__Alignof] = ACTIONS(3505),
    [anon_sym_offsetof] = ACTIONS(3505),
    [anon_sym__Generic] = ACTIONS(3505),
    [anon_sym_asm] = ACTIONS(3505),
    [anon_sym___asm__] = ACTIONS(3505),
    [sym_number_literal] = ACTIONS(3507),
    [anon_sym_L_SQUOTE] = ACTIONS(3507),
    [anon_sym_u_SQUOTE] = ACTIONS(3507),
    [anon_sym_U_SQUOTE] = ACTIONS(3507),
    [anon_sym_u8_SQUOTE] = ACTIONS(3507),
    [anon_sym_SQUOTE] = ACTIONS(3507),
    [anon_sym_L_DQUOTE] = ACTIONS(3507),
    [anon_sym_u_DQUOTE] = ACTIONS(3507),
    [anon_sym_U_DQUOTE] = ACTIONS(3507),
    [anon_sym_u8_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [sym_true] = ACTIONS(3505),
    [sym_false] = ACTIONS(3505),
    [anon_sym_NULL] = ACTIONS(3505),
    [anon_sym_nullptr] = ACTIONS(3505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_This] = ACTIONS(3505),
    [anon_sym_decltype] = ACTIONS(3505),
    [sym_virtual] = ACTIONS(3505),
    [anon_sym_explicit] = ACTIONS(3505),
    [anon_sym_typename] = ACTIONS(3505),
    [anon_sym_template] = ACTIONS(3505),
    [anon_sym_operator] = ACTIONS(3505),
    [anon_sym_try] = ACTIONS(3505),
    [anon_sym_delete] = ACTIONS(3505),
    [anon_sym_throw] = ACTIONS(3505),
    [anon_sym_namespace] = ACTIONS(3505),
    [anon_sym_using] = ACTIONS(3505),
    [anon_sym_static_assert] = ACTIONS(3505),
    [anon_sym_concept] = ACTIONS(3505),
    [anon_sym_co_return] = ACTIONS(3505),
    [anon_sym_co_yield] = ACTIONS(3505),
    [anon_sym_R_DQUOTE] = ACTIONS(3507),
    [anon_sym_LR_DQUOTE] = ACTIONS(3507),
    [anon_sym_uR_DQUOTE] = ACTIONS(3507),
    [anon_sym_UR_DQUOTE] = ACTIONS(3507),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3507),
    [anon_sym_co_await] = ACTIONS(3505),
    [anon_sym_new] = ACTIONS(3505),
    [anon_sym_requires] = ACTIONS(3505),
    [sym_this] = ACTIONS(3505),
    [anon_sym_discard] = ACTIONS(3505),
    [anon_sym_precise] = ACTIONS(3505),
    [anon_sym_shared] = ACTIONS(3505),
    [anon_sym_groupshared] = ACTIONS(3505),
    [anon_sym_uniform] = ACTIONS(3505),
    [anon_sym_row_major] = ACTIONS(3505),
    [anon_sym_column_major] = ACTIONS(3505),
    [anon_sym_globallycoherent] = ACTIONS(3505),
    [anon_sym_centroid] = ACTIONS(3505),
    [anon_sym_noperspective] = ACTIONS(3505),
    [anon_sym_nointerpolation] = ACTIONS(3505),
    [anon_sym_sample] = ACTIONS(3505),
    [anon_sym_linear] = ACTIONS(3505),
    [anon_sym_snorm] = ACTIONS(3505),
    [anon_sym_unorm] = ACTIONS(3505),
    [anon_sym_point] = ACTIONS(3505),
    [anon_sym_line] = ACTIONS(3505),
    [anon_sym_triangleadj] = ACTIONS(3505),
    [anon_sym_lineadj] = ACTIONS(3505),
    [anon_sym_triangle] = ACTIONS(3505),
    [anon_sym_cbuffer] = ACTIONS(3505),
    [anon_sym_interface] = ACTIONS(3505),
    [anon_sym_extension] = ACTIONS(3505),
  },
  [880] = {
    [sym_identifier] = ACTIONS(3475),
    [aux_sym_preproc_include_token1] = ACTIONS(3475),
    [aux_sym_preproc_def_token1] = ACTIONS(3475),
    [aux_sym_preproc_if_token1] = ACTIONS(3475),
    [aux_sym_preproc_if_token2] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3475),
    [sym_preproc_directive] = ACTIONS(3475),
    [anon_sym_LPAREN2] = ACTIONS(3477),
    [anon_sym_BANG] = ACTIONS(3477),
    [anon_sym_TILDE] = ACTIONS(3477),
    [anon_sym_DASH] = ACTIONS(3475),
    [anon_sym_PLUS] = ACTIONS(3475),
    [anon_sym_STAR] = ACTIONS(3477),
    [anon_sym_AMP_AMP] = ACTIONS(3477),
    [anon_sym_AMP] = ACTIONS(3475),
    [anon_sym_SEMI] = ACTIONS(3477),
    [anon_sym___extension__] = ACTIONS(3475),
    [anon_sym_typedef] = ACTIONS(3475),
    [anon_sym_in] = ACTIONS(3475),
    [anon_sym_out] = ACTIONS(3475),
    [anon_sym_inout] = ACTIONS(3475),
    [anon_sym_extern] = ACTIONS(3475),
    [anon_sym___attribute__] = ACTIONS(3475),
    [anon_sym_COLON_COLON] = ACTIONS(3477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3477),
    [anon_sym___declspec] = ACTIONS(3475),
    [anon_sym___based] = ACTIONS(3475),
    [anon_sym___cdecl] = ACTIONS(3475),
    [anon_sym___clrcall] = ACTIONS(3475),
    [anon_sym___stdcall] = ACTIONS(3475),
    [anon_sym___fastcall] = ACTIONS(3475),
    [anon_sym___thiscall] = ACTIONS(3475),
    [anon_sym___vectorcall] = ACTIONS(3475),
    [anon_sym_LBRACE] = ACTIONS(3477),
    [anon_sym_signed] = ACTIONS(3475),
    [anon_sym_unsigned] = ACTIONS(3475),
    [anon_sym_long] = ACTIONS(3475),
    [anon_sym_short] = ACTIONS(3475),
    [anon_sym_LBRACK] = ACTIONS(3475),
    [anon_sym_static] = ACTIONS(3475),
    [anon_sym_register] = ACTIONS(3475),
    [anon_sym_inline] = ACTIONS(3475),
    [anon_sym___inline] = ACTIONS(3475),
    [anon_sym___inline__] = ACTIONS(3475),
    [anon_sym___forceinline] = ACTIONS(3475),
    [anon_sym_thread_local] = ACTIONS(3475),
    [anon_sym___thread] = ACTIONS(3475),
    [anon_sym_const] = ACTIONS(3475),
    [anon_sym_constexpr] = ACTIONS(3475),
    [anon_sym_volatile] = ACTIONS(3475),
    [anon_sym_restrict] = ACTIONS(3475),
    [anon_sym___restrict__] = ACTIONS(3475),
    [anon_sym__Atomic] = ACTIONS(3475),
    [anon_sym__Noreturn] = ACTIONS(3475),
    [anon_sym_noreturn] = ACTIONS(3475),
    [anon_sym_mutable] = ACTIONS(3475),
    [anon_sym_constinit] = ACTIONS(3475),
    [anon_sym_consteval] = ACTIONS(3475),
    [anon_sym_alignas] = ACTIONS(3475),
    [anon_sym__Alignas] = ACTIONS(3475),
    [sym_primitive_type] = ACTIONS(3475),
    [anon_sym_enum] = ACTIONS(3475),
    [anon_sym_class] = ACTIONS(3475),
    [anon_sym_struct] = ACTIONS(3475),
    [anon_sym_union] = ACTIONS(3475),
    [anon_sym_if] = ACTIONS(3475),
    [anon_sym_switch] = ACTIONS(3475),
    [anon_sym_case] = ACTIONS(3475),
    [anon_sym_default] = ACTIONS(3475),
    [anon_sym_while] = ACTIONS(3475),
    [anon_sym_do] = ACTIONS(3475),
    [anon_sym_for] = ACTIONS(3475),
    [anon_sym_return] = ACTIONS(3475),
    [anon_sym_break] = ACTIONS(3475),
    [anon_sym_continue] = ACTIONS(3475),
    [anon_sym_goto] = ACTIONS(3475),
    [anon_sym___try] = ACTIONS(3475),
    [anon_sym___leave] = ACTIONS(3475),
    [anon_sym_not] = ACTIONS(3475),
    [anon_sym_compl] = ACTIONS(3475),
    [anon_sym_DASH_DASH] = ACTIONS(3477),
    [anon_sym_PLUS_PLUS] = ACTIONS(3477),
    [anon_sym_sizeof] = ACTIONS(3475),
    [anon_sym___alignof__] = ACTIONS(3475),
    [anon_sym___alignof] = ACTIONS(3475),
    [anon_sym__alignof] = ACTIONS(3475),
    [anon_sym_alignof] = ACTIONS(3475),
    [anon_sym__Alignof] = ACTIONS(3475),
    [anon_sym_offsetof] = ACTIONS(3475),
    [anon_sym__Generic] = ACTIONS(3475),
    [anon_sym_asm] = ACTIONS(3475),
    [anon_sym___asm__] = ACTIONS(3475),
    [sym_number_literal] = ACTIONS(3477),
    [anon_sym_L_SQUOTE] = ACTIONS(3477),
    [anon_sym_u_SQUOTE] = ACTIONS(3477),
    [anon_sym_U_SQUOTE] = ACTIONS(3477),
    [anon_sym_u8_SQUOTE] = ACTIONS(3477),
    [anon_sym_SQUOTE] = ACTIONS(3477),
    [anon_sym_L_DQUOTE] = ACTIONS(3477),
    [anon_sym_u_DQUOTE] = ACTIONS(3477),
    [anon_sym_U_DQUOTE] = ACTIONS(3477),
    [anon_sym_u8_DQUOTE] = ACTIONS(3477),
    [anon_sym_DQUOTE] = ACTIONS(3477),
    [sym_true] = ACTIONS(3475),
    [sym_false] = ACTIONS(3475),
    [anon_sym_NULL] = ACTIONS(3475),
    [anon_sym_nullptr] = ACTIONS(3475),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3475),
    [anon_sym_let] = ACTIONS(3475),
    [anon_sym_This] = ACTIONS(3475),
    [anon_sym_decltype] = ACTIONS(3475),
    [sym_virtual] = ACTIONS(3475),
    [anon_sym_explicit] = ACTIONS(3475),
    [anon_sym_typename] = ACTIONS(3475),
    [anon_sym_template] = ACTIONS(3475),
    [anon_sym_operator] = ACTIONS(3475),
    [anon_sym_try] = ACTIONS(3475),
    [anon_sym_delete] = ACTIONS(3475),
    [anon_sym_throw] = ACTIONS(3475),
    [anon_sym_namespace] = ACTIONS(3475),
    [anon_sym_using] = ACTIONS(3475),
    [anon_sym_static_assert] = ACTIONS(3475),
    [anon_sym_concept] = ACTIONS(3475),
    [anon_sym_co_return] = ACTIONS(3475),
    [anon_sym_co_yield] = ACTIONS(3475),
    [anon_sym_R_DQUOTE] = ACTIONS(3477),
    [anon_sym_LR_DQUOTE] = ACTIONS(3477),
    [anon_sym_uR_DQUOTE] = ACTIONS(3477),
    [anon_sym_UR_DQUOTE] = ACTIONS(3477),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3477),
    [anon_sym_co_await] = ACTIONS(3475),
    [anon_sym_new] = ACTIONS(3475),
    [anon_sym_requires] = ACTIONS(3475),
    [sym_this] = ACTIONS(3475),
    [anon_sym_discard] = ACTIONS(3475),
    [anon_sym_precise] = ACTIONS(3475),
    [anon_sym_shared] = ACTIONS(3475),
    [anon_sym_groupshared] = ACTIONS(3475),
    [anon_sym_uniform] = ACTIONS(3475),
    [anon_sym_row_major] = ACTIONS(3475),
    [anon_sym_column_major] = ACTIONS(3475),
    [anon_sym_globallycoherent] = ACTIONS(3475),
    [anon_sym_centroid] = ACTIONS(3475),
    [anon_sym_noperspective] = ACTIONS(3475),
    [anon_sym_nointerpolation] = ACTIONS(3475),
    [anon_sym_sample] = ACTIONS(3475),
    [anon_sym_linear] = ACTIONS(3475),
    [anon_sym_snorm] = ACTIONS(3475),
    [anon_sym_unorm] = ACTIONS(3475),
    [anon_sym_point] = ACTIONS(3475),
    [anon_sym_line] = ACTIONS(3475),
    [anon_sym_triangleadj] = ACTIONS(3475),
    [anon_sym_lineadj] = ACTIONS(3475),
    [anon_sym_triangle] = ACTIONS(3475),
    [anon_sym_cbuffer] = ACTIONS(3475),
    [anon_sym_interface] = ACTIONS(3475),
    [anon_sym_extension] = ACTIONS(3475),
  },
  [881] = {
    [sym_identifier] = ACTIONS(3459),
    [aux_sym_preproc_include_token1] = ACTIONS(3459),
    [aux_sym_preproc_def_token1] = ACTIONS(3459),
    [aux_sym_preproc_if_token1] = ACTIONS(3459),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3459),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3459),
    [sym_preproc_directive] = ACTIONS(3459),
    [anon_sym_LPAREN2] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_TILDE] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3459),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3459),
    [anon_sym_SEMI] = ACTIONS(3461),
    [anon_sym___extension__] = ACTIONS(3459),
    [anon_sym_typedef] = ACTIONS(3459),
    [anon_sym_in] = ACTIONS(3459),
    [anon_sym_out] = ACTIONS(3459),
    [anon_sym_inout] = ACTIONS(3459),
    [anon_sym_extern] = ACTIONS(3459),
    [anon_sym___attribute__] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3461),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3461),
    [anon_sym___declspec] = ACTIONS(3459),
    [anon_sym___based] = ACTIONS(3459),
    [anon_sym___cdecl] = ACTIONS(3459),
    [anon_sym___clrcall] = ACTIONS(3459),
    [anon_sym___stdcall] = ACTIONS(3459),
    [anon_sym___fastcall] = ACTIONS(3459),
    [anon_sym___thiscall] = ACTIONS(3459),
    [anon_sym___vectorcall] = ACTIONS(3459),
    [anon_sym_LBRACE] = ACTIONS(3461),
    [anon_sym_RBRACE] = ACTIONS(3461),
    [anon_sym_signed] = ACTIONS(3459),
    [anon_sym_unsigned] = ACTIONS(3459),
    [anon_sym_long] = ACTIONS(3459),
    [anon_sym_short] = ACTIONS(3459),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_static] = ACTIONS(3459),
    [anon_sym_register] = ACTIONS(3459),
    [anon_sym_inline] = ACTIONS(3459),
    [anon_sym___inline] = ACTIONS(3459),
    [anon_sym___inline__] = ACTIONS(3459),
    [anon_sym___forceinline] = ACTIONS(3459),
    [anon_sym_thread_local] = ACTIONS(3459),
    [anon_sym___thread] = ACTIONS(3459),
    [anon_sym_const] = ACTIONS(3459),
    [anon_sym_constexpr] = ACTIONS(3459),
    [anon_sym_volatile] = ACTIONS(3459),
    [anon_sym_restrict] = ACTIONS(3459),
    [anon_sym___restrict__] = ACTIONS(3459),
    [anon_sym__Atomic] = ACTIONS(3459),
    [anon_sym__Noreturn] = ACTIONS(3459),
    [anon_sym_noreturn] = ACTIONS(3459),
    [anon_sym_mutable] = ACTIONS(3459),
    [anon_sym_constinit] = ACTIONS(3459),
    [anon_sym_consteval] = ACTIONS(3459),
    [anon_sym_alignas] = ACTIONS(3459),
    [anon_sym__Alignas] = ACTIONS(3459),
    [sym_primitive_type] = ACTIONS(3459),
    [anon_sym_enum] = ACTIONS(3459),
    [anon_sym_class] = ACTIONS(3459),
    [anon_sym_struct] = ACTIONS(3459),
    [anon_sym_union] = ACTIONS(3459),
    [anon_sym_if] = ACTIONS(3459),
    [anon_sym_switch] = ACTIONS(3459),
    [anon_sym_case] = ACTIONS(3459),
    [anon_sym_default] = ACTIONS(3459),
    [anon_sym_while] = ACTIONS(3459),
    [anon_sym_do] = ACTIONS(3459),
    [anon_sym_for] = ACTIONS(3459),
    [anon_sym_return] = ACTIONS(3459),
    [anon_sym_break] = ACTIONS(3459),
    [anon_sym_continue] = ACTIONS(3459),
    [anon_sym_goto] = ACTIONS(3459),
    [anon_sym___try] = ACTIONS(3459),
    [anon_sym___leave] = ACTIONS(3459),
    [anon_sym_not] = ACTIONS(3459),
    [anon_sym_compl] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3461),
    [anon_sym_sizeof] = ACTIONS(3459),
    [anon_sym___alignof__] = ACTIONS(3459),
    [anon_sym___alignof] = ACTIONS(3459),
    [anon_sym__alignof] = ACTIONS(3459),
    [anon_sym_alignof] = ACTIONS(3459),
    [anon_sym__Alignof] = ACTIONS(3459),
    [anon_sym_offsetof] = ACTIONS(3459),
    [anon_sym__Generic] = ACTIONS(3459),
    [anon_sym_asm] = ACTIONS(3459),
    [anon_sym___asm__] = ACTIONS(3459),
    [sym_number_literal] = ACTIONS(3461),
    [anon_sym_L_SQUOTE] = ACTIONS(3461),
    [anon_sym_u_SQUOTE] = ACTIONS(3461),
    [anon_sym_U_SQUOTE] = ACTIONS(3461),
    [anon_sym_u8_SQUOTE] = ACTIONS(3461),
    [anon_sym_SQUOTE] = ACTIONS(3461),
    [anon_sym_L_DQUOTE] = ACTIONS(3461),
    [anon_sym_u_DQUOTE] = ACTIONS(3461),
    [anon_sym_U_DQUOTE] = ACTIONS(3461),
    [anon_sym_u8_DQUOTE] = ACTIONS(3461),
    [anon_sym_DQUOTE] = ACTIONS(3461),
    [sym_true] = ACTIONS(3459),
    [sym_false] = ACTIONS(3459),
    [anon_sym_NULL] = ACTIONS(3459),
    [anon_sym_nullptr] = ACTIONS(3459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3459),
    [anon_sym_let] = ACTIONS(3459),
    [anon_sym_This] = ACTIONS(3459),
    [anon_sym_decltype] = ACTIONS(3459),
    [sym_virtual] = ACTIONS(3459),
    [anon_sym_explicit] = ACTIONS(3459),
    [anon_sym_typename] = ACTIONS(3459),
    [anon_sym_template] = ACTIONS(3459),
    [anon_sym_operator] = ACTIONS(3459),
    [anon_sym_try] = ACTIONS(3459),
    [anon_sym_delete] = ACTIONS(3459),
    [anon_sym_throw] = ACTIONS(3459),
    [anon_sym_namespace] = ACTIONS(3459),
    [anon_sym_using] = ACTIONS(3459),
    [anon_sym_static_assert] = ACTIONS(3459),
    [anon_sym_concept] = ACTIONS(3459),
    [anon_sym_co_return] = ACTIONS(3459),
    [anon_sym_co_yield] = ACTIONS(3459),
    [anon_sym_R_DQUOTE] = ACTIONS(3461),
    [anon_sym_LR_DQUOTE] = ACTIONS(3461),
    [anon_sym_uR_DQUOTE] = ACTIONS(3461),
    [anon_sym_UR_DQUOTE] = ACTIONS(3461),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3461),
    [anon_sym_co_await] = ACTIONS(3459),
    [anon_sym_new] = ACTIONS(3459),
    [anon_sym_requires] = ACTIONS(3459),
    [sym_this] = ACTIONS(3459),
    [anon_sym_discard] = ACTIONS(3459),
    [anon_sym_precise] = ACTIONS(3459),
    [anon_sym_shared] = ACTIONS(3459),
    [anon_sym_groupshared] = ACTIONS(3459),
    [anon_sym_uniform] = ACTIONS(3459),
    [anon_sym_row_major] = ACTIONS(3459),
    [anon_sym_column_major] = ACTIONS(3459),
    [anon_sym_globallycoherent] = ACTIONS(3459),
    [anon_sym_centroid] = ACTIONS(3459),
    [anon_sym_noperspective] = ACTIONS(3459),
    [anon_sym_nointerpolation] = ACTIONS(3459),
    [anon_sym_sample] = ACTIONS(3459),
    [anon_sym_linear] = ACTIONS(3459),
    [anon_sym_snorm] = ACTIONS(3459),
    [anon_sym_unorm] = ACTIONS(3459),
    [anon_sym_point] = ACTIONS(3459),
    [anon_sym_line] = ACTIONS(3459),
    [anon_sym_triangleadj] = ACTIONS(3459),
    [anon_sym_lineadj] = ACTIONS(3459),
    [anon_sym_triangle] = ACTIONS(3459),
    [anon_sym_cbuffer] = ACTIONS(3459),
    [anon_sym_interface] = ACTIONS(3459),
    [anon_sym_extension] = ACTIONS(3459),
  },
  [882] = {
    [sym_identifier] = ACTIONS(3455),
    [aux_sym_preproc_include_token1] = ACTIONS(3455),
    [aux_sym_preproc_def_token1] = ACTIONS(3455),
    [aux_sym_preproc_if_token1] = ACTIONS(3455),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3455),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3455),
    [sym_preproc_directive] = ACTIONS(3455),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_BANG] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3457),
    [anon_sym_DASH] = ACTIONS(3455),
    [anon_sym_PLUS] = ACTIONS(3455),
    [anon_sym_STAR] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3457),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym_SEMI] = ACTIONS(3457),
    [anon_sym___extension__] = ACTIONS(3455),
    [anon_sym_typedef] = ACTIONS(3455),
    [anon_sym_in] = ACTIONS(3455),
    [anon_sym_out] = ACTIONS(3455),
    [anon_sym_inout] = ACTIONS(3455),
    [anon_sym_extern] = ACTIONS(3455),
    [anon_sym___attribute__] = ACTIONS(3455),
    [anon_sym_COLON_COLON] = ACTIONS(3457),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3457),
    [anon_sym___declspec] = ACTIONS(3455),
    [anon_sym___based] = ACTIONS(3455),
    [anon_sym___cdecl] = ACTIONS(3455),
    [anon_sym___clrcall] = ACTIONS(3455),
    [anon_sym___stdcall] = ACTIONS(3455),
    [anon_sym___fastcall] = ACTIONS(3455),
    [anon_sym___thiscall] = ACTIONS(3455),
    [anon_sym___vectorcall] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_RBRACE] = ACTIONS(3457),
    [anon_sym_signed] = ACTIONS(3455),
    [anon_sym_unsigned] = ACTIONS(3455),
    [anon_sym_long] = ACTIONS(3455),
    [anon_sym_short] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_static] = ACTIONS(3455),
    [anon_sym_register] = ACTIONS(3455),
    [anon_sym_inline] = ACTIONS(3455),
    [anon_sym___inline] = ACTIONS(3455),
    [anon_sym___inline__] = ACTIONS(3455),
    [anon_sym___forceinline] = ACTIONS(3455),
    [anon_sym_thread_local] = ACTIONS(3455),
    [anon_sym___thread] = ACTIONS(3455),
    [anon_sym_const] = ACTIONS(3455),
    [anon_sym_constexpr] = ACTIONS(3455),
    [anon_sym_volatile] = ACTIONS(3455),
    [anon_sym_restrict] = ACTIONS(3455),
    [anon_sym___restrict__] = ACTIONS(3455),
    [anon_sym__Atomic] = ACTIONS(3455),
    [anon_sym__Noreturn] = ACTIONS(3455),
    [anon_sym_noreturn] = ACTIONS(3455),
    [anon_sym_mutable] = ACTIONS(3455),
    [anon_sym_constinit] = ACTIONS(3455),
    [anon_sym_consteval] = ACTIONS(3455),
    [anon_sym_alignas] = ACTIONS(3455),
    [anon_sym__Alignas] = ACTIONS(3455),
    [sym_primitive_type] = ACTIONS(3455),
    [anon_sym_enum] = ACTIONS(3455),
    [anon_sym_class] = ACTIONS(3455),
    [anon_sym_struct] = ACTIONS(3455),
    [anon_sym_union] = ACTIONS(3455),
    [anon_sym_if] = ACTIONS(3455),
    [anon_sym_switch] = ACTIONS(3455),
    [anon_sym_case] = ACTIONS(3455),
    [anon_sym_default] = ACTIONS(3455),
    [anon_sym_while] = ACTIONS(3455),
    [anon_sym_do] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3455),
    [anon_sym_return] = ACTIONS(3455),
    [anon_sym_break] = ACTIONS(3455),
    [anon_sym_continue] = ACTIONS(3455),
    [anon_sym_goto] = ACTIONS(3455),
    [anon_sym___try] = ACTIONS(3455),
    [anon_sym___leave] = ACTIONS(3455),
    [anon_sym_not] = ACTIONS(3455),
    [anon_sym_compl] = ACTIONS(3455),
    [anon_sym_DASH_DASH] = ACTIONS(3457),
    [anon_sym_PLUS_PLUS] = ACTIONS(3457),
    [anon_sym_sizeof] = ACTIONS(3455),
    [anon_sym___alignof__] = ACTIONS(3455),
    [anon_sym___alignof] = ACTIONS(3455),
    [anon_sym__alignof] = ACTIONS(3455),
    [anon_sym_alignof] = ACTIONS(3455),
    [anon_sym__Alignof] = ACTIONS(3455),
    [anon_sym_offsetof] = ACTIONS(3455),
    [anon_sym__Generic] = ACTIONS(3455),
    [anon_sym_asm] = ACTIONS(3455),
    [anon_sym___asm__] = ACTIONS(3455),
    [sym_number_literal] = ACTIONS(3457),
    [anon_sym_L_SQUOTE] = ACTIONS(3457),
    [anon_sym_u_SQUOTE] = ACTIONS(3457),
    [anon_sym_U_SQUOTE] = ACTIONS(3457),
    [anon_sym_u8_SQUOTE] = ACTIONS(3457),
    [anon_sym_SQUOTE] = ACTIONS(3457),
    [anon_sym_L_DQUOTE] = ACTIONS(3457),
    [anon_sym_u_DQUOTE] = ACTIONS(3457),
    [anon_sym_U_DQUOTE] = ACTIONS(3457),
    [anon_sym_u8_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [sym_true] = ACTIONS(3455),
    [sym_false] = ACTIONS(3455),
    [anon_sym_NULL] = ACTIONS(3455),
    [anon_sym_nullptr] = ACTIONS(3455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3455),
    [anon_sym_let] = ACTIONS(3455),
    [anon_sym_This] = ACTIONS(3455),
    [anon_sym_decltype] = ACTIONS(3455),
    [sym_virtual] = ACTIONS(3455),
    [anon_sym_explicit] = ACTIONS(3455),
    [anon_sym_typename] = ACTIONS(3455),
    [anon_sym_template] = ACTIONS(3455),
    [anon_sym_operator] = ACTIONS(3455),
    [anon_sym_try] = ACTIONS(3455),
    [anon_sym_delete] = ACTIONS(3455),
    [anon_sym_throw] = ACTIONS(3455),
    [anon_sym_namespace] = ACTIONS(3455),
    [anon_sym_using] = ACTIONS(3455),
    [anon_sym_static_assert] = ACTIONS(3455),
    [anon_sym_concept] = ACTIONS(3455),
    [anon_sym_co_return] = ACTIONS(3455),
    [anon_sym_co_yield] = ACTIONS(3455),
    [anon_sym_R_DQUOTE] = ACTIONS(3457),
    [anon_sym_LR_DQUOTE] = ACTIONS(3457),
    [anon_sym_uR_DQUOTE] = ACTIONS(3457),
    [anon_sym_UR_DQUOTE] = ACTIONS(3457),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3457),
    [anon_sym_co_await] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_requires] = ACTIONS(3455),
    [sym_this] = ACTIONS(3455),
    [anon_sym_discard] = ACTIONS(3455),
    [anon_sym_precise] = ACTIONS(3455),
    [anon_sym_shared] = ACTIONS(3455),
    [anon_sym_groupshared] = ACTIONS(3455),
    [anon_sym_uniform] = ACTIONS(3455),
    [anon_sym_row_major] = ACTIONS(3455),
    [anon_sym_column_major] = ACTIONS(3455),
    [anon_sym_globallycoherent] = ACTIONS(3455),
    [anon_sym_centroid] = ACTIONS(3455),
    [anon_sym_noperspective] = ACTIONS(3455),
    [anon_sym_nointerpolation] = ACTIONS(3455),
    [anon_sym_sample] = ACTIONS(3455),
    [anon_sym_linear] = ACTIONS(3455),
    [anon_sym_snorm] = ACTIONS(3455),
    [anon_sym_unorm] = ACTIONS(3455),
    [anon_sym_point] = ACTIONS(3455),
    [anon_sym_line] = ACTIONS(3455),
    [anon_sym_triangleadj] = ACTIONS(3455),
    [anon_sym_lineadj] = ACTIONS(3455),
    [anon_sym_triangle] = ACTIONS(3455),
    [anon_sym_cbuffer] = ACTIONS(3455),
    [anon_sym_interface] = ACTIONS(3455),
    [anon_sym_extension] = ACTIONS(3455),
  },
  [883] = {
    [sym_identifier] = ACTIONS(3449),
    [aux_sym_preproc_include_token1] = ACTIONS(3449),
    [aux_sym_preproc_def_token1] = ACTIONS(3449),
    [aux_sym_preproc_if_token1] = ACTIONS(3449),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3449),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3449),
    [sym_preproc_directive] = ACTIONS(3449),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_BANG] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3449),
    [anon_sym_PLUS] = ACTIONS(3449),
    [anon_sym_STAR] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_AMP] = ACTIONS(3449),
    [anon_sym_SEMI] = ACTIONS(3451),
    [anon_sym___extension__] = ACTIONS(3449),
    [anon_sym_typedef] = ACTIONS(3449),
    [anon_sym_in] = ACTIONS(3449),
    [anon_sym_out] = ACTIONS(3449),
    [anon_sym_inout] = ACTIONS(3449),
    [anon_sym_extern] = ACTIONS(3449),
    [anon_sym___attribute__] = ACTIONS(3449),
    [anon_sym_COLON_COLON] = ACTIONS(3451),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3451),
    [anon_sym___declspec] = ACTIONS(3449),
    [anon_sym___based] = ACTIONS(3449),
    [anon_sym___cdecl] = ACTIONS(3449),
    [anon_sym___clrcall] = ACTIONS(3449),
    [anon_sym___stdcall] = ACTIONS(3449),
    [anon_sym___fastcall] = ACTIONS(3449),
    [anon_sym___thiscall] = ACTIONS(3449),
    [anon_sym___vectorcall] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_RBRACE] = ACTIONS(3451),
    [anon_sym_signed] = ACTIONS(3449),
    [anon_sym_unsigned] = ACTIONS(3449),
    [anon_sym_long] = ACTIONS(3449),
    [anon_sym_short] = ACTIONS(3449),
    [anon_sym_LBRACK] = ACTIONS(3449),
    [anon_sym_static] = ACTIONS(3449),
    [anon_sym_register] = ACTIONS(3449),
    [anon_sym_inline] = ACTIONS(3449),
    [anon_sym___inline] = ACTIONS(3449),
    [anon_sym___inline__] = ACTIONS(3449),
    [anon_sym___forceinline] = ACTIONS(3449),
    [anon_sym_thread_local] = ACTIONS(3449),
    [anon_sym___thread] = ACTIONS(3449),
    [anon_sym_const] = ACTIONS(3449),
    [anon_sym_constexpr] = ACTIONS(3449),
    [anon_sym_volatile] = ACTIONS(3449),
    [anon_sym_restrict] = ACTIONS(3449),
    [anon_sym___restrict__] = ACTIONS(3449),
    [anon_sym__Atomic] = ACTIONS(3449),
    [anon_sym__Noreturn] = ACTIONS(3449),
    [anon_sym_noreturn] = ACTIONS(3449),
    [anon_sym_mutable] = ACTIONS(3449),
    [anon_sym_constinit] = ACTIONS(3449),
    [anon_sym_consteval] = ACTIONS(3449),
    [anon_sym_alignas] = ACTIONS(3449),
    [anon_sym__Alignas] = ACTIONS(3449),
    [sym_primitive_type] = ACTIONS(3449),
    [anon_sym_enum] = ACTIONS(3449),
    [anon_sym_class] = ACTIONS(3449),
    [anon_sym_struct] = ACTIONS(3449),
    [anon_sym_union] = ACTIONS(3449),
    [anon_sym_if] = ACTIONS(3449),
    [anon_sym_switch] = ACTIONS(3449),
    [anon_sym_case] = ACTIONS(3449),
    [anon_sym_default] = ACTIONS(3449),
    [anon_sym_while] = ACTIONS(3449),
    [anon_sym_do] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3449),
    [anon_sym_return] = ACTIONS(3449),
    [anon_sym_break] = ACTIONS(3449),
    [anon_sym_continue] = ACTIONS(3449),
    [anon_sym_goto] = ACTIONS(3449),
    [anon_sym___try] = ACTIONS(3449),
    [anon_sym___leave] = ACTIONS(3449),
    [anon_sym_not] = ACTIONS(3449),
    [anon_sym_compl] = ACTIONS(3449),
    [anon_sym_DASH_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_PLUS] = ACTIONS(3451),
    [anon_sym_sizeof] = ACTIONS(3449),
    [anon_sym___alignof__] = ACTIONS(3449),
    [anon_sym___alignof] = ACTIONS(3449),
    [anon_sym__alignof] = ACTIONS(3449),
    [anon_sym_alignof] = ACTIONS(3449),
    [anon_sym__Alignof] = ACTIONS(3449),
    [anon_sym_offsetof] = ACTIONS(3449),
    [anon_sym__Generic] = ACTIONS(3449),
    [anon_sym_asm] = ACTIONS(3449),
    [anon_sym___asm__] = ACTIONS(3449),
    [sym_number_literal] = ACTIONS(3451),
    [anon_sym_L_SQUOTE] = ACTIONS(3451),
    [anon_sym_u_SQUOTE] = ACTIONS(3451),
    [anon_sym_U_SQUOTE] = ACTIONS(3451),
    [anon_sym_u8_SQUOTE] = ACTIONS(3451),
    [anon_sym_SQUOTE] = ACTIONS(3451),
    [anon_sym_L_DQUOTE] = ACTIONS(3451),
    [anon_sym_u_DQUOTE] = ACTIONS(3451),
    [anon_sym_U_DQUOTE] = ACTIONS(3451),
    [anon_sym_u8_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [sym_true] = ACTIONS(3449),
    [sym_false] = ACTIONS(3449),
    [anon_sym_NULL] = ACTIONS(3449),
    [anon_sym_nullptr] = ACTIONS(3449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3449),
    [anon_sym_let] = ACTIONS(3449),
    [anon_sym_This] = ACTIONS(3449),
    [anon_sym_decltype] = ACTIONS(3449),
    [sym_virtual] = ACTIONS(3449),
    [anon_sym_explicit] = ACTIONS(3449),
    [anon_sym_typename] = ACTIONS(3449),
    [anon_sym_template] = ACTIONS(3449),
    [anon_sym_operator] = ACTIONS(3449),
    [anon_sym_try] = ACTIONS(3449),
    [anon_sym_delete] = ACTIONS(3449),
    [anon_sym_throw] = ACTIONS(3449),
    [anon_sym_namespace] = ACTIONS(3449),
    [anon_sym_using] = ACTIONS(3449),
    [anon_sym_static_assert] = ACTIONS(3449),
    [anon_sym_concept] = ACTIONS(3449),
    [anon_sym_co_return] = ACTIONS(3449),
    [anon_sym_co_yield] = ACTIONS(3449),
    [anon_sym_R_DQUOTE] = ACTIONS(3451),
    [anon_sym_LR_DQUOTE] = ACTIONS(3451),
    [anon_sym_uR_DQUOTE] = ACTIONS(3451),
    [anon_sym_UR_DQUOTE] = ACTIONS(3451),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3451),
    [anon_sym_co_await] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3449),
    [anon_sym_requires] = ACTIONS(3449),
    [sym_this] = ACTIONS(3449),
    [anon_sym_discard] = ACTIONS(3449),
    [anon_sym_precise] = ACTIONS(3449),
    [anon_sym_shared] = ACTIONS(3449),
    [anon_sym_groupshared] = ACTIONS(3449),
    [anon_sym_uniform] = ACTIONS(3449),
    [anon_sym_row_major] = ACTIONS(3449),
    [anon_sym_column_major] = ACTIONS(3449),
    [anon_sym_globallycoherent] = ACTIONS(3449),
    [anon_sym_centroid] = ACTIONS(3449),
    [anon_sym_noperspective] = ACTIONS(3449),
    [anon_sym_nointerpolation] = ACTIONS(3449),
    [anon_sym_sample] = ACTIONS(3449),
    [anon_sym_linear] = ACTIONS(3449),
    [anon_sym_snorm] = ACTIONS(3449),
    [anon_sym_unorm] = ACTIONS(3449),
    [anon_sym_point] = ACTIONS(3449),
    [anon_sym_line] = ACTIONS(3449),
    [anon_sym_triangleadj] = ACTIONS(3449),
    [anon_sym_lineadj] = ACTIONS(3449),
    [anon_sym_triangle] = ACTIONS(3449),
    [anon_sym_cbuffer] = ACTIONS(3449),
    [anon_sym_interface] = ACTIONS(3449),
    [anon_sym_extension] = ACTIONS(3449),
  },
  [884] = {
    [sym_identifier] = ACTIONS(3677),
    [aux_sym_preproc_include_token1] = ACTIONS(3677),
    [aux_sym_preproc_def_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token1] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3677),
    [sym_preproc_directive] = ACTIONS(3677),
    [anon_sym_LPAREN2] = ACTIONS(3679),
    [anon_sym_BANG] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3677),
    [anon_sym_PLUS] = ACTIONS(3677),
    [anon_sym_STAR] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_AMP] = ACTIONS(3677),
    [anon_sym_SEMI] = ACTIONS(3679),
    [anon_sym___extension__] = ACTIONS(3677),
    [anon_sym_typedef] = ACTIONS(3677),
    [anon_sym_in] = ACTIONS(3677),
    [anon_sym_out] = ACTIONS(3677),
    [anon_sym_inout] = ACTIONS(3677),
    [anon_sym_extern] = ACTIONS(3677),
    [anon_sym___attribute__] = ACTIONS(3677),
    [anon_sym_COLON_COLON] = ACTIONS(3679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3679),
    [anon_sym___declspec] = ACTIONS(3677),
    [anon_sym___based] = ACTIONS(3677),
    [anon_sym___cdecl] = ACTIONS(3677),
    [anon_sym___clrcall] = ACTIONS(3677),
    [anon_sym___stdcall] = ACTIONS(3677),
    [anon_sym___fastcall] = ACTIONS(3677),
    [anon_sym___thiscall] = ACTIONS(3677),
    [anon_sym___vectorcall] = ACTIONS(3677),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_RBRACE] = ACTIONS(3679),
    [anon_sym_signed] = ACTIONS(3677),
    [anon_sym_unsigned] = ACTIONS(3677),
    [anon_sym_long] = ACTIONS(3677),
    [anon_sym_short] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3677),
    [anon_sym_static] = ACTIONS(3677),
    [anon_sym_register] = ACTIONS(3677),
    [anon_sym_inline] = ACTIONS(3677),
    [anon_sym___inline] = ACTIONS(3677),
    [anon_sym___inline__] = ACTIONS(3677),
    [anon_sym___forceinline] = ACTIONS(3677),
    [anon_sym_thread_local] = ACTIONS(3677),
    [anon_sym___thread] = ACTIONS(3677),
    [anon_sym_const] = ACTIONS(3677),
    [anon_sym_constexpr] = ACTIONS(3677),
    [anon_sym_volatile] = ACTIONS(3677),
    [anon_sym_restrict] = ACTIONS(3677),
    [anon_sym___restrict__] = ACTIONS(3677),
    [anon_sym__Atomic] = ACTIONS(3677),
    [anon_sym__Noreturn] = ACTIONS(3677),
    [anon_sym_noreturn] = ACTIONS(3677),
    [anon_sym_mutable] = ACTIONS(3677),
    [anon_sym_constinit] = ACTIONS(3677),
    [anon_sym_consteval] = ACTIONS(3677),
    [anon_sym_alignas] = ACTIONS(3677),
    [anon_sym__Alignas] = ACTIONS(3677),
    [sym_primitive_type] = ACTIONS(3677),
    [anon_sym_enum] = ACTIONS(3677),
    [anon_sym_class] = ACTIONS(3677),
    [anon_sym_struct] = ACTIONS(3677),
    [anon_sym_union] = ACTIONS(3677),
    [anon_sym_if] = ACTIONS(3677),
    [anon_sym_switch] = ACTIONS(3677),
    [anon_sym_case] = ACTIONS(3677),
    [anon_sym_default] = ACTIONS(3677),
    [anon_sym_while] = ACTIONS(3677),
    [anon_sym_do] = ACTIONS(3677),
    [anon_sym_for] = ACTIONS(3677),
    [anon_sym_return] = ACTIONS(3677),
    [anon_sym_break] = ACTIONS(3677),
    [anon_sym_continue] = ACTIONS(3677),
    [anon_sym_goto] = ACTIONS(3677),
    [anon_sym___try] = ACTIONS(3677),
    [anon_sym___leave] = ACTIONS(3677),
    [anon_sym_not] = ACTIONS(3677),
    [anon_sym_compl] = ACTIONS(3677),
    [anon_sym_DASH_DASH] = ACTIONS(3679),
    [anon_sym_PLUS_PLUS] = ACTIONS(3679),
    [anon_sym_sizeof] = ACTIONS(3677),
    [anon_sym___alignof__] = ACTIONS(3677),
    [anon_sym___alignof] = ACTIONS(3677),
    [anon_sym__alignof] = ACTIONS(3677),
    [anon_sym_alignof] = ACTIONS(3677),
    [anon_sym__Alignof] = ACTIONS(3677),
    [anon_sym_offsetof] = ACTIONS(3677),
    [anon_sym__Generic] = ACTIONS(3677),
    [anon_sym_asm] = ACTIONS(3677),
    [anon_sym___asm__] = ACTIONS(3677),
    [sym_number_literal] = ACTIONS(3679),
    [anon_sym_L_SQUOTE] = ACTIONS(3679),
    [anon_sym_u_SQUOTE] = ACTIONS(3679),
    [anon_sym_U_SQUOTE] = ACTIONS(3679),
    [anon_sym_u8_SQUOTE] = ACTIONS(3679),
    [anon_sym_SQUOTE] = ACTIONS(3679),
    [anon_sym_L_DQUOTE] = ACTIONS(3679),
    [anon_sym_u_DQUOTE] = ACTIONS(3679),
    [anon_sym_U_DQUOTE] = ACTIONS(3679),
    [anon_sym_u8_DQUOTE] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3679),
    [sym_true] = ACTIONS(3677),
    [sym_false] = ACTIONS(3677),
    [anon_sym_NULL] = ACTIONS(3677),
    [anon_sym_nullptr] = ACTIONS(3677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3677),
    [anon_sym_let] = ACTIONS(3677),
    [anon_sym_This] = ACTIONS(3677),
    [anon_sym_decltype] = ACTIONS(3677),
    [sym_virtual] = ACTIONS(3677),
    [anon_sym_explicit] = ACTIONS(3677),
    [anon_sym_typename] = ACTIONS(3677),
    [anon_sym_template] = ACTIONS(3677),
    [anon_sym_operator] = ACTIONS(3677),
    [anon_sym_try] = ACTIONS(3677),
    [anon_sym_delete] = ACTIONS(3677),
    [anon_sym_throw] = ACTIONS(3677),
    [anon_sym_namespace] = ACTIONS(3677),
    [anon_sym_using] = ACTIONS(3677),
    [anon_sym_static_assert] = ACTIONS(3677),
    [anon_sym_concept] = ACTIONS(3677),
    [anon_sym_co_return] = ACTIONS(3677),
    [anon_sym_co_yield] = ACTIONS(3677),
    [anon_sym_R_DQUOTE] = ACTIONS(3679),
    [anon_sym_LR_DQUOTE] = ACTIONS(3679),
    [anon_sym_uR_DQUOTE] = ACTIONS(3679),
    [anon_sym_UR_DQUOTE] = ACTIONS(3679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3679),
    [anon_sym_co_await] = ACTIONS(3677),
    [anon_sym_new] = ACTIONS(3677),
    [anon_sym_requires] = ACTIONS(3677),
    [sym_this] = ACTIONS(3677),
    [anon_sym_discard] = ACTIONS(3677),
    [anon_sym_precise] = ACTIONS(3677),
    [anon_sym_shared] = ACTIONS(3677),
    [anon_sym_groupshared] = ACTIONS(3677),
    [anon_sym_uniform] = ACTIONS(3677),
    [anon_sym_row_major] = ACTIONS(3677),
    [anon_sym_column_major] = ACTIONS(3677),
    [anon_sym_globallycoherent] = ACTIONS(3677),
    [anon_sym_centroid] = ACTIONS(3677),
    [anon_sym_noperspective] = ACTIONS(3677),
    [anon_sym_nointerpolation] = ACTIONS(3677),
    [anon_sym_sample] = ACTIONS(3677),
    [anon_sym_linear] = ACTIONS(3677),
    [anon_sym_snorm] = ACTIONS(3677),
    [anon_sym_unorm] = ACTIONS(3677),
    [anon_sym_point] = ACTIONS(3677),
    [anon_sym_line] = ACTIONS(3677),
    [anon_sym_triangleadj] = ACTIONS(3677),
    [anon_sym_lineadj] = ACTIONS(3677),
    [anon_sym_triangle] = ACTIONS(3677),
    [anon_sym_cbuffer] = ACTIONS(3677),
    [anon_sym_interface] = ACTIONS(3677),
    [anon_sym_extension] = ACTIONS(3677),
  },
  [885] = {
    [sym_identifier] = ACTIONS(3437),
    [aux_sym_preproc_include_token1] = ACTIONS(3437),
    [aux_sym_preproc_def_token1] = ACTIONS(3437),
    [aux_sym_preproc_if_token1] = ACTIONS(3437),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3437),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3437),
    [sym_preproc_directive] = ACTIONS(3437),
    [anon_sym_LPAREN2] = ACTIONS(3439),
    [anon_sym_BANG] = ACTIONS(3439),
    [anon_sym_TILDE] = ACTIONS(3439),
    [anon_sym_DASH] = ACTIONS(3437),
    [anon_sym_PLUS] = ACTIONS(3437),
    [anon_sym_STAR] = ACTIONS(3439),
    [anon_sym_AMP_AMP] = ACTIONS(3439),
    [anon_sym_AMP] = ACTIONS(3437),
    [anon_sym_SEMI] = ACTIONS(3439),
    [anon_sym___extension__] = ACTIONS(3437),
    [anon_sym_typedef] = ACTIONS(3437),
    [anon_sym_in] = ACTIONS(3437),
    [anon_sym_out] = ACTIONS(3437),
    [anon_sym_inout] = ACTIONS(3437),
    [anon_sym_extern] = ACTIONS(3437),
    [anon_sym___attribute__] = ACTIONS(3437),
    [anon_sym_COLON_COLON] = ACTIONS(3439),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3439),
    [anon_sym___declspec] = ACTIONS(3437),
    [anon_sym___based] = ACTIONS(3437),
    [anon_sym___cdecl] = ACTIONS(3437),
    [anon_sym___clrcall] = ACTIONS(3437),
    [anon_sym___stdcall] = ACTIONS(3437),
    [anon_sym___fastcall] = ACTIONS(3437),
    [anon_sym___thiscall] = ACTIONS(3437),
    [anon_sym___vectorcall] = ACTIONS(3437),
    [anon_sym_LBRACE] = ACTIONS(3439),
    [anon_sym_RBRACE] = ACTIONS(3439),
    [anon_sym_signed] = ACTIONS(3437),
    [anon_sym_unsigned] = ACTIONS(3437),
    [anon_sym_long] = ACTIONS(3437),
    [anon_sym_short] = ACTIONS(3437),
    [anon_sym_LBRACK] = ACTIONS(3437),
    [anon_sym_static] = ACTIONS(3437),
    [anon_sym_register] = ACTIONS(3437),
    [anon_sym_inline] = ACTIONS(3437),
    [anon_sym___inline] = ACTIONS(3437),
    [anon_sym___inline__] = ACTIONS(3437),
    [anon_sym___forceinline] = ACTIONS(3437),
    [anon_sym_thread_local] = ACTIONS(3437),
    [anon_sym___thread] = ACTIONS(3437),
    [anon_sym_const] = ACTIONS(3437),
    [anon_sym_constexpr] = ACTIONS(3437),
    [anon_sym_volatile] = ACTIONS(3437),
    [anon_sym_restrict] = ACTIONS(3437),
    [anon_sym___restrict__] = ACTIONS(3437),
    [anon_sym__Atomic] = ACTIONS(3437),
    [anon_sym__Noreturn] = ACTIONS(3437),
    [anon_sym_noreturn] = ACTIONS(3437),
    [anon_sym_mutable] = ACTIONS(3437),
    [anon_sym_constinit] = ACTIONS(3437),
    [anon_sym_consteval] = ACTIONS(3437),
    [anon_sym_alignas] = ACTIONS(3437),
    [anon_sym__Alignas] = ACTIONS(3437),
    [sym_primitive_type] = ACTIONS(3437),
    [anon_sym_enum] = ACTIONS(3437),
    [anon_sym_class] = ACTIONS(3437),
    [anon_sym_struct] = ACTIONS(3437),
    [anon_sym_union] = ACTIONS(3437),
    [anon_sym_if] = ACTIONS(3437),
    [anon_sym_switch] = ACTIONS(3437),
    [anon_sym_case] = ACTIONS(3437),
    [anon_sym_default] = ACTIONS(3437),
    [anon_sym_while] = ACTIONS(3437),
    [anon_sym_do] = ACTIONS(3437),
    [anon_sym_for] = ACTIONS(3437),
    [anon_sym_return] = ACTIONS(3437),
    [anon_sym_break] = ACTIONS(3437),
    [anon_sym_continue] = ACTIONS(3437),
    [anon_sym_goto] = ACTIONS(3437),
    [anon_sym___try] = ACTIONS(3437),
    [anon_sym___leave] = ACTIONS(3437),
    [anon_sym_not] = ACTIONS(3437),
    [anon_sym_compl] = ACTIONS(3437),
    [anon_sym_DASH_DASH] = ACTIONS(3439),
    [anon_sym_PLUS_PLUS] = ACTIONS(3439),
    [anon_sym_sizeof] = ACTIONS(3437),
    [anon_sym___alignof__] = ACTIONS(3437),
    [anon_sym___alignof] = ACTIONS(3437),
    [anon_sym__alignof] = ACTIONS(3437),
    [anon_sym_alignof] = ACTIONS(3437),
    [anon_sym__Alignof] = ACTIONS(3437),
    [anon_sym_offsetof] = ACTIONS(3437),
    [anon_sym__Generic] = ACTIONS(3437),
    [anon_sym_asm] = ACTIONS(3437),
    [anon_sym___asm__] = ACTIONS(3437),
    [sym_number_literal] = ACTIONS(3439),
    [anon_sym_L_SQUOTE] = ACTIONS(3439),
    [anon_sym_u_SQUOTE] = ACTIONS(3439),
    [anon_sym_U_SQUOTE] = ACTIONS(3439),
    [anon_sym_u8_SQUOTE] = ACTIONS(3439),
    [anon_sym_SQUOTE] = ACTIONS(3439),
    [anon_sym_L_DQUOTE] = ACTIONS(3439),
    [anon_sym_u_DQUOTE] = ACTIONS(3439),
    [anon_sym_U_DQUOTE] = ACTIONS(3439),
    [anon_sym_u8_DQUOTE] = ACTIONS(3439),
    [anon_sym_DQUOTE] = ACTIONS(3439),
    [sym_true] = ACTIONS(3437),
    [sym_false] = ACTIONS(3437),
    [anon_sym_NULL] = ACTIONS(3437),
    [anon_sym_nullptr] = ACTIONS(3437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3437),
    [anon_sym_let] = ACTIONS(3437),
    [anon_sym_This] = ACTIONS(3437),
    [anon_sym_decltype] = ACTIONS(3437),
    [sym_virtual] = ACTIONS(3437),
    [anon_sym_explicit] = ACTIONS(3437),
    [anon_sym_typename] = ACTIONS(3437),
    [anon_sym_template] = ACTIONS(3437),
    [anon_sym_operator] = ACTIONS(3437),
    [anon_sym_try] = ACTIONS(3437),
    [anon_sym_delete] = ACTIONS(3437),
    [anon_sym_throw] = ACTIONS(3437),
    [anon_sym_namespace] = ACTIONS(3437),
    [anon_sym_using] = ACTIONS(3437),
    [anon_sym_static_assert] = ACTIONS(3437),
    [anon_sym_concept] = ACTIONS(3437),
    [anon_sym_co_return] = ACTIONS(3437),
    [anon_sym_co_yield] = ACTIONS(3437),
    [anon_sym_R_DQUOTE] = ACTIONS(3439),
    [anon_sym_LR_DQUOTE] = ACTIONS(3439),
    [anon_sym_uR_DQUOTE] = ACTIONS(3439),
    [anon_sym_UR_DQUOTE] = ACTIONS(3439),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3439),
    [anon_sym_co_await] = ACTIONS(3437),
    [anon_sym_new] = ACTIONS(3437),
    [anon_sym_requires] = ACTIONS(3437),
    [sym_this] = ACTIONS(3437),
    [anon_sym_discard] = ACTIONS(3437),
    [anon_sym_precise] = ACTIONS(3437),
    [anon_sym_shared] = ACTIONS(3437),
    [anon_sym_groupshared] = ACTIONS(3437),
    [anon_sym_uniform] = ACTIONS(3437),
    [anon_sym_row_major] = ACTIONS(3437),
    [anon_sym_column_major] = ACTIONS(3437),
    [anon_sym_globallycoherent] = ACTIONS(3437),
    [anon_sym_centroid] = ACTIONS(3437),
    [anon_sym_noperspective] = ACTIONS(3437),
    [anon_sym_nointerpolation] = ACTIONS(3437),
    [anon_sym_sample] = ACTIONS(3437),
    [anon_sym_linear] = ACTIONS(3437),
    [anon_sym_snorm] = ACTIONS(3437),
    [anon_sym_unorm] = ACTIONS(3437),
    [anon_sym_point] = ACTIONS(3437),
    [anon_sym_line] = ACTIONS(3437),
    [anon_sym_triangleadj] = ACTIONS(3437),
    [anon_sym_lineadj] = ACTIONS(3437),
    [anon_sym_triangle] = ACTIONS(3437),
    [anon_sym_cbuffer] = ACTIONS(3437),
    [anon_sym_interface] = ACTIONS(3437),
    [anon_sym_extension] = ACTIONS(3437),
  },
  [886] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(935),
    [ts_builtin_sym_end] = ACTIONS(3822),
    [sym_identifier] = ACTIONS(3926),
    [aux_sym_preproc_include_token1] = ACTIONS(3820),
    [aux_sym_preproc_def_token1] = ACTIONS(3820),
    [aux_sym_preproc_if_token1] = ACTIONS(3820),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3820),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3820),
    [sym_preproc_directive] = ACTIONS(3820),
    [anon_sym_LPAREN2] = ACTIONS(3822),
    [anon_sym_BANG] = ACTIONS(3822),
    [anon_sym_TILDE] = ACTIONS(3822),
    [anon_sym_DASH] = ACTIONS(3820),
    [anon_sym_PLUS] = ACTIONS(3820),
    [anon_sym_STAR] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3822),
    [anon_sym_AMP] = ACTIONS(3820),
    [anon_sym_SEMI] = ACTIONS(3822),
    [anon_sym___extension__] = ACTIONS(3820),
    [anon_sym_typedef] = ACTIONS(3820),
    [anon_sym_in] = ACTIONS(3820),
    [anon_sym_out] = ACTIONS(3820),
    [anon_sym_inout] = ACTIONS(3820),
    [anon_sym_extern] = ACTIONS(3820),
    [anon_sym___attribute__] = ACTIONS(3820),
    [anon_sym_COLON_COLON] = ACTIONS(3822),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3822),
    [anon_sym___declspec] = ACTIONS(3820),
    [anon_sym___based] = ACTIONS(3820),
    [anon_sym___cdecl] = ACTIONS(3820),
    [anon_sym___clrcall] = ACTIONS(3820),
    [anon_sym___stdcall] = ACTIONS(3820),
    [anon_sym___fastcall] = ACTIONS(3820),
    [anon_sym___thiscall] = ACTIONS(3820),
    [anon_sym___vectorcall] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3822),
    [anon_sym_signed] = ACTIONS(3929),
    [anon_sym_unsigned] = ACTIONS(3929),
    [anon_sym_long] = ACTIONS(3929),
    [anon_sym_short] = ACTIONS(3929),
    [anon_sym_LBRACK] = ACTIONS(3820),
    [anon_sym_static] = ACTIONS(3820),
    [anon_sym_register] = ACTIONS(3820),
    [anon_sym_inline] = ACTIONS(3820),
    [anon_sym___inline] = ACTIONS(3820),
    [anon_sym___inline__] = ACTIONS(3820),
    [anon_sym___forceinline] = ACTIONS(3820),
    [anon_sym_thread_local] = ACTIONS(3820),
    [anon_sym___thread] = ACTIONS(3820),
    [anon_sym_const] = ACTIONS(3820),
    [anon_sym_constexpr] = ACTIONS(3820),
    [anon_sym_volatile] = ACTIONS(3820),
    [anon_sym_restrict] = ACTIONS(3820),
    [anon_sym___restrict__] = ACTIONS(3820),
    [anon_sym__Atomic] = ACTIONS(3820),
    [anon_sym__Noreturn] = ACTIONS(3820),
    [anon_sym_noreturn] = ACTIONS(3820),
    [anon_sym_mutable] = ACTIONS(3820),
    [anon_sym_constinit] = ACTIONS(3820),
    [anon_sym_consteval] = ACTIONS(3820),
    [anon_sym_alignas] = ACTIONS(3820),
    [anon_sym__Alignas] = ACTIONS(3820),
    [sym_primitive_type] = ACTIONS(3932),
    [anon_sym_enum] = ACTIONS(3820),
    [anon_sym_class] = ACTIONS(3820),
    [anon_sym_struct] = ACTIONS(3820),
    [anon_sym_union] = ACTIONS(3820),
    [anon_sym_if] = ACTIONS(3820),
    [anon_sym_switch] = ACTIONS(3820),
    [anon_sym_case] = ACTIONS(3820),
    [anon_sym_default] = ACTIONS(3820),
    [anon_sym_while] = ACTIONS(3820),
    [anon_sym_do] = ACTIONS(3820),
    [anon_sym_for] = ACTIONS(3820),
    [anon_sym_return] = ACTIONS(3820),
    [anon_sym_break] = ACTIONS(3820),
    [anon_sym_continue] = ACTIONS(3820),
    [anon_sym_goto] = ACTIONS(3820),
    [anon_sym_not] = ACTIONS(3820),
    [anon_sym_compl] = ACTIONS(3820),
    [anon_sym_DASH_DASH] = ACTIONS(3822),
    [anon_sym_PLUS_PLUS] = ACTIONS(3822),
    [anon_sym_sizeof] = ACTIONS(3820),
    [anon_sym___alignof__] = ACTIONS(3820),
    [anon_sym___alignof] = ACTIONS(3820),
    [anon_sym__alignof] = ACTIONS(3820),
    [anon_sym_alignof] = ACTIONS(3820),
    [anon_sym__Alignof] = ACTIONS(3820),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3820),
    [anon_sym_asm] = ACTIONS(3820),
    [anon_sym___asm__] = ACTIONS(3820),
    [anon_sym_DOT] = ACTIONS(3820),
    [sym_number_literal] = ACTIONS(3822),
    [anon_sym_L_SQUOTE] = ACTIONS(3822),
    [anon_sym_u_SQUOTE] = ACTIONS(3822),
    [anon_sym_U_SQUOTE] = ACTIONS(3822),
    [anon_sym_u8_SQUOTE] = ACTIONS(3822),
    [anon_sym_SQUOTE] = ACTIONS(3822),
    [anon_sym_L_DQUOTE] = ACTIONS(3822),
    [anon_sym_u_DQUOTE] = ACTIONS(3822),
    [anon_sym_U_DQUOTE] = ACTIONS(3822),
    [anon_sym_u8_DQUOTE] = ACTIONS(3822),
    [anon_sym_DQUOTE] = ACTIONS(3822),
    [sym_true] = ACTIONS(3820),
    [sym_false] = ACTIONS(3820),
    [anon_sym_NULL] = ACTIONS(3820),
    [anon_sym_nullptr] = ACTIONS(3820),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3820),
    [anon_sym_let] = ACTIONS(3820),
    [anon_sym_This] = ACTIONS(3820),
    [anon_sym_decltype] = ACTIONS(3820),
    [sym_virtual] = ACTIONS(3820),
    [anon_sym_explicit] = ACTIONS(3820),
    [anon_sym_typename] = ACTIONS(3820),
    [anon_sym_template] = ACTIONS(3820),
    [anon_sym_operator] = ACTIONS(3820),
    [anon_sym_try] = ACTIONS(3820),
    [anon_sym_delete] = ACTIONS(3820),
    [anon_sym_throw] = ACTIONS(3820),
    [anon_sym_namespace] = ACTIONS(3820),
    [anon_sym_using] = ACTIONS(3820),
    [anon_sym_static_assert] = ACTIONS(3820),
    [anon_sym_concept] = ACTIONS(3820),
    [anon_sym_co_return] = ACTIONS(3820),
    [anon_sym_co_yield] = ACTIONS(3820),
    [anon_sym_R_DQUOTE] = ACTIONS(3822),
    [anon_sym_LR_DQUOTE] = ACTIONS(3822),
    [anon_sym_uR_DQUOTE] = ACTIONS(3822),
    [anon_sym_UR_DQUOTE] = ACTIONS(3822),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3822),
    [anon_sym_co_await] = ACTIONS(3820),
    [anon_sym_new] = ACTIONS(3820),
    [anon_sym_requires] = ACTIONS(3820),
    [sym_this] = ACTIONS(3820),
    [anon_sym_precise] = ACTIONS(3820),
    [anon_sym_shared] = ACTIONS(3820),
    [anon_sym_groupshared] = ACTIONS(3820),
    [anon_sym_uniform] = ACTIONS(3820),
    [anon_sym_row_major] = ACTIONS(3820),
    [anon_sym_column_major] = ACTIONS(3820),
    [anon_sym_globallycoherent] = ACTIONS(3820),
    [anon_sym_centroid] = ACTIONS(3820),
    [anon_sym_noperspective] = ACTIONS(3820),
    [anon_sym_nointerpolation] = ACTIONS(3820),
    [anon_sym_sample] = ACTIONS(3820),
    [anon_sym_linear] = ACTIONS(3820),
    [anon_sym_snorm] = ACTIONS(3820),
    [anon_sym_unorm] = ACTIONS(3820),
    [anon_sym_point] = ACTIONS(3820),
    [anon_sym_line] = ACTIONS(3820),
    [anon_sym_triangleadj] = ACTIONS(3820),
    [anon_sym_lineadj] = ACTIONS(3820),
    [anon_sym_triangle] = ACTIONS(3820),
    [anon_sym_interface] = ACTIONS(3820),
    [anon_sym_extension] = ACTIONS(3820),
    [anon_sym___exported] = ACTIONS(3820),
    [anon_sym_import] = ACTIONS(3820),
  },
  [887] = {
    [sym_identifier] = ACTIONS(3433),
    [aux_sym_preproc_include_token1] = ACTIONS(3433),
    [aux_sym_preproc_def_token1] = ACTIONS(3433),
    [aux_sym_preproc_if_token1] = ACTIONS(3433),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3433),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3433),
    [sym_preproc_directive] = ACTIONS(3433),
    [anon_sym_LPAREN2] = ACTIONS(3435),
    [anon_sym_BANG] = ACTIONS(3435),
    [anon_sym_TILDE] = ACTIONS(3435),
    [anon_sym_DASH] = ACTIONS(3433),
    [anon_sym_PLUS] = ACTIONS(3433),
    [anon_sym_STAR] = ACTIONS(3435),
    [anon_sym_AMP_AMP] = ACTIONS(3435),
    [anon_sym_AMP] = ACTIONS(3433),
    [anon_sym_SEMI] = ACTIONS(3435),
    [anon_sym___extension__] = ACTIONS(3433),
    [anon_sym_typedef] = ACTIONS(3433),
    [anon_sym_in] = ACTIONS(3433),
    [anon_sym_out] = ACTIONS(3433),
    [anon_sym_inout] = ACTIONS(3433),
    [anon_sym_extern] = ACTIONS(3433),
    [anon_sym___attribute__] = ACTIONS(3433),
    [anon_sym_COLON_COLON] = ACTIONS(3435),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3435),
    [anon_sym___declspec] = ACTIONS(3433),
    [anon_sym___based] = ACTIONS(3433),
    [anon_sym___cdecl] = ACTIONS(3433),
    [anon_sym___clrcall] = ACTIONS(3433),
    [anon_sym___stdcall] = ACTIONS(3433),
    [anon_sym___fastcall] = ACTIONS(3433),
    [anon_sym___thiscall] = ACTIONS(3433),
    [anon_sym___vectorcall] = ACTIONS(3433),
    [anon_sym_LBRACE] = ACTIONS(3435),
    [anon_sym_RBRACE] = ACTIONS(3435),
    [anon_sym_signed] = ACTIONS(3433),
    [anon_sym_unsigned] = ACTIONS(3433),
    [anon_sym_long] = ACTIONS(3433),
    [anon_sym_short] = ACTIONS(3433),
    [anon_sym_LBRACK] = ACTIONS(3433),
    [anon_sym_static] = ACTIONS(3433),
    [anon_sym_register] = ACTIONS(3433),
    [anon_sym_inline] = ACTIONS(3433),
    [anon_sym___inline] = ACTIONS(3433),
    [anon_sym___inline__] = ACTIONS(3433),
    [anon_sym___forceinline] = ACTIONS(3433),
    [anon_sym_thread_local] = ACTIONS(3433),
    [anon_sym___thread] = ACTIONS(3433),
    [anon_sym_const] = ACTIONS(3433),
    [anon_sym_constexpr] = ACTIONS(3433),
    [anon_sym_volatile] = ACTIONS(3433),
    [anon_sym_restrict] = ACTIONS(3433),
    [anon_sym___restrict__] = ACTIONS(3433),
    [anon_sym__Atomic] = ACTIONS(3433),
    [anon_sym__Noreturn] = ACTIONS(3433),
    [anon_sym_noreturn] = ACTIONS(3433),
    [anon_sym_mutable] = ACTIONS(3433),
    [anon_sym_constinit] = ACTIONS(3433),
    [anon_sym_consteval] = ACTIONS(3433),
    [anon_sym_alignas] = ACTIONS(3433),
    [anon_sym__Alignas] = ACTIONS(3433),
    [sym_primitive_type] = ACTIONS(3433),
    [anon_sym_enum] = ACTIONS(3433),
    [anon_sym_class] = ACTIONS(3433),
    [anon_sym_struct] = ACTIONS(3433),
    [anon_sym_union] = ACTIONS(3433),
    [anon_sym_if] = ACTIONS(3433),
    [anon_sym_switch] = ACTIONS(3433),
    [anon_sym_case] = ACTIONS(3433),
    [anon_sym_default] = ACTIONS(3433),
    [anon_sym_while] = ACTIONS(3433),
    [anon_sym_do] = ACTIONS(3433),
    [anon_sym_for] = ACTIONS(3433),
    [anon_sym_return] = ACTIONS(3433),
    [anon_sym_break] = ACTIONS(3433),
    [anon_sym_continue] = ACTIONS(3433),
    [anon_sym_goto] = ACTIONS(3433),
    [anon_sym___try] = ACTIONS(3433),
    [anon_sym___leave] = ACTIONS(3433),
    [anon_sym_not] = ACTIONS(3433),
    [anon_sym_compl] = ACTIONS(3433),
    [anon_sym_DASH_DASH] = ACTIONS(3435),
    [anon_sym_PLUS_PLUS] = ACTIONS(3435),
    [anon_sym_sizeof] = ACTIONS(3433),
    [anon_sym___alignof__] = ACTIONS(3433),
    [anon_sym___alignof] = ACTIONS(3433),
    [anon_sym__alignof] = ACTIONS(3433),
    [anon_sym_alignof] = ACTIONS(3433),
    [anon_sym__Alignof] = ACTIONS(3433),
    [anon_sym_offsetof] = ACTIONS(3433),
    [anon_sym__Generic] = ACTIONS(3433),
    [anon_sym_asm] = ACTIONS(3433),
    [anon_sym___asm__] = ACTIONS(3433),
    [sym_number_literal] = ACTIONS(3435),
    [anon_sym_L_SQUOTE] = ACTIONS(3435),
    [anon_sym_u_SQUOTE] = ACTIONS(3435),
    [anon_sym_U_SQUOTE] = ACTIONS(3435),
    [anon_sym_u8_SQUOTE] = ACTIONS(3435),
    [anon_sym_SQUOTE] = ACTIONS(3435),
    [anon_sym_L_DQUOTE] = ACTIONS(3435),
    [anon_sym_u_DQUOTE] = ACTIONS(3435),
    [anon_sym_U_DQUOTE] = ACTIONS(3435),
    [anon_sym_u8_DQUOTE] = ACTIONS(3435),
    [anon_sym_DQUOTE] = ACTIONS(3435),
    [sym_true] = ACTIONS(3433),
    [sym_false] = ACTIONS(3433),
    [anon_sym_NULL] = ACTIONS(3433),
    [anon_sym_nullptr] = ACTIONS(3433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3433),
    [anon_sym_let] = ACTIONS(3433),
    [anon_sym_This] = ACTIONS(3433),
    [anon_sym_decltype] = ACTIONS(3433),
    [sym_virtual] = ACTIONS(3433),
    [anon_sym_explicit] = ACTIONS(3433),
    [anon_sym_typename] = ACTIONS(3433),
    [anon_sym_template] = ACTIONS(3433),
    [anon_sym_operator] = ACTIONS(3433),
    [anon_sym_try] = ACTIONS(3433),
    [anon_sym_delete] = ACTIONS(3433),
    [anon_sym_throw] = ACTIONS(3433),
    [anon_sym_namespace] = ACTIONS(3433),
    [anon_sym_using] = ACTIONS(3433),
    [anon_sym_static_assert] = ACTIONS(3433),
    [anon_sym_concept] = ACTIONS(3433),
    [anon_sym_co_return] = ACTIONS(3433),
    [anon_sym_co_yield] = ACTIONS(3433),
    [anon_sym_R_DQUOTE] = ACTIONS(3435),
    [anon_sym_LR_DQUOTE] = ACTIONS(3435),
    [anon_sym_uR_DQUOTE] = ACTIONS(3435),
    [anon_sym_UR_DQUOTE] = ACTIONS(3435),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3435),
    [anon_sym_co_await] = ACTIONS(3433),
    [anon_sym_new] = ACTIONS(3433),
    [anon_sym_requires] = ACTIONS(3433),
    [sym_this] = ACTIONS(3433),
    [anon_sym_discard] = ACTIONS(3433),
    [anon_sym_precise] = ACTIONS(3433),
    [anon_sym_shared] = ACTIONS(3433),
    [anon_sym_groupshared] = ACTIONS(3433),
    [anon_sym_uniform] = ACTIONS(3433),
    [anon_sym_row_major] = ACTIONS(3433),
    [anon_sym_column_major] = ACTIONS(3433),
    [anon_sym_globallycoherent] = ACTIONS(3433),
    [anon_sym_centroid] = ACTIONS(3433),
    [anon_sym_noperspective] = ACTIONS(3433),
    [anon_sym_nointerpolation] = ACTIONS(3433),
    [anon_sym_sample] = ACTIONS(3433),
    [anon_sym_linear] = ACTIONS(3433),
    [anon_sym_snorm] = ACTIONS(3433),
    [anon_sym_unorm] = ACTIONS(3433),
    [anon_sym_point] = ACTIONS(3433),
    [anon_sym_line] = ACTIONS(3433),
    [anon_sym_triangleadj] = ACTIONS(3433),
    [anon_sym_lineadj] = ACTIONS(3433),
    [anon_sym_triangle] = ACTIONS(3433),
    [anon_sym_cbuffer] = ACTIONS(3433),
    [anon_sym_interface] = ACTIONS(3433),
    [anon_sym_extension] = ACTIONS(3433),
  },
  [888] = {
    [sym_identifier] = ACTIONS(3429),
    [aux_sym_preproc_include_token1] = ACTIONS(3429),
    [aux_sym_preproc_def_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3429),
    [sym_preproc_directive] = ACTIONS(3429),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_BANG] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym_SEMI] = ACTIONS(3431),
    [anon_sym___extension__] = ACTIONS(3429),
    [anon_sym_typedef] = ACTIONS(3429),
    [anon_sym_in] = ACTIONS(3429),
    [anon_sym_out] = ACTIONS(3429),
    [anon_sym_inout] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym___attribute__] = ACTIONS(3429),
    [anon_sym_COLON_COLON] = ACTIONS(3431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3431),
    [anon_sym___declspec] = ACTIONS(3429),
    [anon_sym___based] = ACTIONS(3429),
    [anon_sym___cdecl] = ACTIONS(3429),
    [anon_sym___clrcall] = ACTIONS(3429),
    [anon_sym___stdcall] = ACTIONS(3429),
    [anon_sym___fastcall] = ACTIONS(3429),
    [anon_sym___thiscall] = ACTIONS(3429),
    [anon_sym___vectorcall] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_RBRACE] = ACTIONS(3431),
    [anon_sym_signed] = ACTIONS(3429),
    [anon_sym_unsigned] = ACTIONS(3429),
    [anon_sym_long] = ACTIONS(3429),
    [anon_sym_short] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_register] = ACTIONS(3429),
    [anon_sym_inline] = ACTIONS(3429),
    [anon_sym___inline] = ACTIONS(3429),
    [anon_sym___inline__] = ACTIONS(3429),
    [anon_sym___forceinline] = ACTIONS(3429),
    [anon_sym_thread_local] = ACTIONS(3429),
    [anon_sym___thread] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_constexpr] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_restrict] = ACTIONS(3429),
    [anon_sym___restrict__] = ACTIONS(3429),
    [anon_sym__Atomic] = ACTIONS(3429),
    [anon_sym__Noreturn] = ACTIONS(3429),
    [anon_sym_noreturn] = ACTIONS(3429),
    [anon_sym_mutable] = ACTIONS(3429),
    [anon_sym_constinit] = ACTIONS(3429),
    [anon_sym_consteval] = ACTIONS(3429),
    [anon_sym_alignas] = ACTIONS(3429),
    [anon_sym__Alignas] = ACTIONS(3429),
    [sym_primitive_type] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [anon_sym_if] = ACTIONS(3429),
    [anon_sym_switch] = ACTIONS(3429),
    [anon_sym_case] = ACTIONS(3429),
    [anon_sym_default] = ACTIONS(3429),
    [anon_sym_while] = ACTIONS(3429),
    [anon_sym_do] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3429),
    [anon_sym_return] = ACTIONS(3429),
    [anon_sym_break] = ACTIONS(3429),
    [anon_sym_continue] = ACTIONS(3429),
    [anon_sym_goto] = ACTIONS(3429),
    [anon_sym___try] = ACTIONS(3429),
    [anon_sym___leave] = ACTIONS(3429),
    [anon_sym_not] = ACTIONS(3429),
    [anon_sym_compl] = ACTIONS(3429),
    [anon_sym_DASH_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(3431),
    [anon_sym_sizeof] = ACTIONS(3429),
    [anon_sym___alignof__] = ACTIONS(3429),
    [anon_sym___alignof] = ACTIONS(3429),
    [anon_sym__alignof] = ACTIONS(3429),
    [anon_sym_alignof] = ACTIONS(3429),
    [anon_sym__Alignof] = ACTIONS(3429),
    [anon_sym_offsetof] = ACTIONS(3429),
    [anon_sym__Generic] = ACTIONS(3429),
    [anon_sym_asm] = ACTIONS(3429),
    [anon_sym___asm__] = ACTIONS(3429),
    [sym_number_literal] = ACTIONS(3431),
    [anon_sym_L_SQUOTE] = ACTIONS(3431),
    [anon_sym_u_SQUOTE] = ACTIONS(3431),
    [anon_sym_U_SQUOTE] = ACTIONS(3431),
    [anon_sym_u8_SQUOTE] = ACTIONS(3431),
    [anon_sym_SQUOTE] = ACTIONS(3431),
    [anon_sym_L_DQUOTE] = ACTIONS(3431),
    [anon_sym_u_DQUOTE] = ACTIONS(3431),
    [anon_sym_U_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [sym_true] = ACTIONS(3429),
    [sym_false] = ACTIONS(3429),
    [anon_sym_NULL] = ACTIONS(3429),
    [anon_sym_nullptr] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_This] = ACTIONS(3429),
    [anon_sym_decltype] = ACTIONS(3429),
    [sym_virtual] = ACTIONS(3429),
    [anon_sym_explicit] = ACTIONS(3429),
    [anon_sym_typename] = ACTIONS(3429),
    [anon_sym_template] = ACTIONS(3429),
    [anon_sym_operator] = ACTIONS(3429),
    [anon_sym_try] = ACTIONS(3429),
    [anon_sym_delete] = ACTIONS(3429),
    [anon_sym_throw] = ACTIONS(3429),
    [anon_sym_namespace] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_static_assert] = ACTIONS(3429),
    [anon_sym_concept] = ACTIONS(3429),
    [anon_sym_co_return] = ACTIONS(3429),
    [anon_sym_co_yield] = ACTIONS(3429),
    [anon_sym_R_DQUOTE] = ACTIONS(3431),
    [anon_sym_LR_DQUOTE] = ACTIONS(3431),
    [anon_sym_uR_DQUOTE] = ACTIONS(3431),
    [anon_sym_UR_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3431),
    [anon_sym_co_await] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3429),
    [anon_sym_requires] = ACTIONS(3429),
    [sym_this] = ACTIONS(3429),
    [anon_sym_discard] = ACTIONS(3429),
    [anon_sym_precise] = ACTIONS(3429),
    [anon_sym_shared] = ACTIONS(3429),
    [anon_sym_groupshared] = ACTIONS(3429),
    [anon_sym_uniform] = ACTIONS(3429),
    [anon_sym_row_major] = ACTIONS(3429),
    [anon_sym_column_major] = ACTIONS(3429),
    [anon_sym_globallycoherent] = ACTIONS(3429),
    [anon_sym_centroid] = ACTIONS(3429),
    [anon_sym_noperspective] = ACTIONS(3429),
    [anon_sym_nointerpolation] = ACTIONS(3429),
    [anon_sym_sample] = ACTIONS(3429),
    [anon_sym_linear] = ACTIONS(3429),
    [anon_sym_snorm] = ACTIONS(3429),
    [anon_sym_unorm] = ACTIONS(3429),
    [anon_sym_point] = ACTIONS(3429),
    [anon_sym_line] = ACTIONS(3429),
    [anon_sym_triangleadj] = ACTIONS(3429),
    [anon_sym_lineadj] = ACTIONS(3429),
    [anon_sym_triangle] = ACTIONS(3429),
    [anon_sym_cbuffer] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_extension] = ACTIONS(3429),
  },
  [889] = {
    [sym_identifier] = ACTIONS(3429),
    [aux_sym_preproc_include_token1] = ACTIONS(3429),
    [aux_sym_preproc_def_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3429),
    [sym_preproc_directive] = ACTIONS(3429),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_BANG] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym_SEMI] = ACTIONS(3431),
    [anon_sym___extension__] = ACTIONS(3429),
    [anon_sym_typedef] = ACTIONS(3429),
    [anon_sym_in] = ACTIONS(3429),
    [anon_sym_out] = ACTIONS(3429),
    [anon_sym_inout] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym___attribute__] = ACTIONS(3429),
    [anon_sym_COLON_COLON] = ACTIONS(3431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3431),
    [anon_sym___declspec] = ACTIONS(3429),
    [anon_sym___based] = ACTIONS(3429),
    [anon_sym___cdecl] = ACTIONS(3429),
    [anon_sym___clrcall] = ACTIONS(3429),
    [anon_sym___stdcall] = ACTIONS(3429),
    [anon_sym___fastcall] = ACTIONS(3429),
    [anon_sym___thiscall] = ACTIONS(3429),
    [anon_sym___vectorcall] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_RBRACE] = ACTIONS(3431),
    [anon_sym_signed] = ACTIONS(3429),
    [anon_sym_unsigned] = ACTIONS(3429),
    [anon_sym_long] = ACTIONS(3429),
    [anon_sym_short] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_register] = ACTIONS(3429),
    [anon_sym_inline] = ACTIONS(3429),
    [anon_sym___inline] = ACTIONS(3429),
    [anon_sym___inline__] = ACTIONS(3429),
    [anon_sym___forceinline] = ACTIONS(3429),
    [anon_sym_thread_local] = ACTIONS(3429),
    [anon_sym___thread] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_constexpr] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_restrict] = ACTIONS(3429),
    [anon_sym___restrict__] = ACTIONS(3429),
    [anon_sym__Atomic] = ACTIONS(3429),
    [anon_sym__Noreturn] = ACTIONS(3429),
    [anon_sym_noreturn] = ACTIONS(3429),
    [anon_sym_mutable] = ACTIONS(3429),
    [anon_sym_constinit] = ACTIONS(3429),
    [anon_sym_consteval] = ACTIONS(3429),
    [anon_sym_alignas] = ACTIONS(3429),
    [anon_sym__Alignas] = ACTIONS(3429),
    [sym_primitive_type] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [anon_sym_if] = ACTIONS(3429),
    [anon_sym_switch] = ACTIONS(3429),
    [anon_sym_case] = ACTIONS(3429),
    [anon_sym_default] = ACTIONS(3429),
    [anon_sym_while] = ACTIONS(3429),
    [anon_sym_do] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3429),
    [anon_sym_return] = ACTIONS(3429),
    [anon_sym_break] = ACTIONS(3429),
    [anon_sym_continue] = ACTIONS(3429),
    [anon_sym_goto] = ACTIONS(3429),
    [anon_sym___try] = ACTIONS(3429),
    [anon_sym___leave] = ACTIONS(3429),
    [anon_sym_not] = ACTIONS(3429),
    [anon_sym_compl] = ACTIONS(3429),
    [anon_sym_DASH_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(3431),
    [anon_sym_sizeof] = ACTIONS(3429),
    [anon_sym___alignof__] = ACTIONS(3429),
    [anon_sym___alignof] = ACTIONS(3429),
    [anon_sym__alignof] = ACTIONS(3429),
    [anon_sym_alignof] = ACTIONS(3429),
    [anon_sym__Alignof] = ACTIONS(3429),
    [anon_sym_offsetof] = ACTIONS(3429),
    [anon_sym__Generic] = ACTIONS(3429),
    [anon_sym_asm] = ACTIONS(3429),
    [anon_sym___asm__] = ACTIONS(3429),
    [sym_number_literal] = ACTIONS(3431),
    [anon_sym_L_SQUOTE] = ACTIONS(3431),
    [anon_sym_u_SQUOTE] = ACTIONS(3431),
    [anon_sym_U_SQUOTE] = ACTIONS(3431),
    [anon_sym_u8_SQUOTE] = ACTIONS(3431),
    [anon_sym_SQUOTE] = ACTIONS(3431),
    [anon_sym_L_DQUOTE] = ACTIONS(3431),
    [anon_sym_u_DQUOTE] = ACTIONS(3431),
    [anon_sym_U_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [sym_true] = ACTIONS(3429),
    [sym_false] = ACTIONS(3429),
    [anon_sym_NULL] = ACTIONS(3429),
    [anon_sym_nullptr] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_This] = ACTIONS(3429),
    [anon_sym_decltype] = ACTIONS(3429),
    [sym_virtual] = ACTIONS(3429),
    [anon_sym_explicit] = ACTIONS(3429),
    [anon_sym_typename] = ACTIONS(3429),
    [anon_sym_template] = ACTIONS(3429),
    [anon_sym_operator] = ACTIONS(3429),
    [anon_sym_try] = ACTIONS(3429),
    [anon_sym_delete] = ACTIONS(3429),
    [anon_sym_throw] = ACTIONS(3429),
    [anon_sym_namespace] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_static_assert] = ACTIONS(3429),
    [anon_sym_concept] = ACTIONS(3429),
    [anon_sym_co_return] = ACTIONS(3429),
    [anon_sym_co_yield] = ACTIONS(3429),
    [anon_sym_R_DQUOTE] = ACTIONS(3431),
    [anon_sym_LR_DQUOTE] = ACTIONS(3431),
    [anon_sym_uR_DQUOTE] = ACTIONS(3431),
    [anon_sym_UR_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3431),
    [anon_sym_co_await] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3429),
    [anon_sym_requires] = ACTIONS(3429),
    [sym_this] = ACTIONS(3429),
    [anon_sym_discard] = ACTIONS(3429),
    [anon_sym_precise] = ACTIONS(3429),
    [anon_sym_shared] = ACTIONS(3429),
    [anon_sym_groupshared] = ACTIONS(3429),
    [anon_sym_uniform] = ACTIONS(3429),
    [anon_sym_row_major] = ACTIONS(3429),
    [anon_sym_column_major] = ACTIONS(3429),
    [anon_sym_globallycoherent] = ACTIONS(3429),
    [anon_sym_centroid] = ACTIONS(3429),
    [anon_sym_noperspective] = ACTIONS(3429),
    [anon_sym_nointerpolation] = ACTIONS(3429),
    [anon_sym_sample] = ACTIONS(3429),
    [anon_sym_linear] = ACTIONS(3429),
    [anon_sym_snorm] = ACTIONS(3429),
    [anon_sym_unorm] = ACTIONS(3429),
    [anon_sym_point] = ACTIONS(3429),
    [anon_sym_line] = ACTIONS(3429),
    [anon_sym_triangleadj] = ACTIONS(3429),
    [anon_sym_lineadj] = ACTIONS(3429),
    [anon_sym_triangle] = ACTIONS(3429),
    [anon_sym_cbuffer] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_extension] = ACTIONS(3429),
  },
  [890] = {
    [sym_identifier] = ACTIONS(3673),
    [aux_sym_preproc_include_token1] = ACTIONS(3673),
    [aux_sym_preproc_def_token1] = ACTIONS(3673),
    [aux_sym_preproc_if_token1] = ACTIONS(3673),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3673),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3673),
    [sym_preproc_directive] = ACTIONS(3673),
    [anon_sym_LPAREN2] = ACTIONS(3675),
    [anon_sym_BANG] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3673),
    [anon_sym_PLUS] = ACTIONS(3673),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3673),
    [anon_sym_SEMI] = ACTIONS(3675),
    [anon_sym___extension__] = ACTIONS(3673),
    [anon_sym_typedef] = ACTIONS(3673),
    [anon_sym_in] = ACTIONS(3673),
    [anon_sym_out] = ACTIONS(3673),
    [anon_sym_inout] = ACTIONS(3673),
    [anon_sym_extern] = ACTIONS(3673),
    [anon_sym___attribute__] = ACTIONS(3673),
    [anon_sym_COLON_COLON] = ACTIONS(3675),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3675),
    [anon_sym___declspec] = ACTIONS(3673),
    [anon_sym___based] = ACTIONS(3673),
    [anon_sym___cdecl] = ACTIONS(3673),
    [anon_sym___clrcall] = ACTIONS(3673),
    [anon_sym___stdcall] = ACTIONS(3673),
    [anon_sym___fastcall] = ACTIONS(3673),
    [anon_sym___thiscall] = ACTIONS(3673),
    [anon_sym___vectorcall] = ACTIONS(3673),
    [anon_sym_LBRACE] = ACTIONS(3675),
    [anon_sym_RBRACE] = ACTIONS(3675),
    [anon_sym_signed] = ACTIONS(3673),
    [anon_sym_unsigned] = ACTIONS(3673),
    [anon_sym_long] = ACTIONS(3673),
    [anon_sym_short] = ACTIONS(3673),
    [anon_sym_LBRACK] = ACTIONS(3673),
    [anon_sym_static] = ACTIONS(3673),
    [anon_sym_register] = ACTIONS(3673),
    [anon_sym_inline] = ACTIONS(3673),
    [anon_sym___inline] = ACTIONS(3673),
    [anon_sym___inline__] = ACTIONS(3673),
    [anon_sym___forceinline] = ACTIONS(3673),
    [anon_sym_thread_local] = ACTIONS(3673),
    [anon_sym___thread] = ACTIONS(3673),
    [anon_sym_const] = ACTIONS(3673),
    [anon_sym_constexpr] = ACTIONS(3673),
    [anon_sym_volatile] = ACTIONS(3673),
    [anon_sym_restrict] = ACTIONS(3673),
    [anon_sym___restrict__] = ACTIONS(3673),
    [anon_sym__Atomic] = ACTIONS(3673),
    [anon_sym__Noreturn] = ACTIONS(3673),
    [anon_sym_noreturn] = ACTIONS(3673),
    [anon_sym_mutable] = ACTIONS(3673),
    [anon_sym_constinit] = ACTIONS(3673),
    [anon_sym_consteval] = ACTIONS(3673),
    [anon_sym_alignas] = ACTIONS(3673),
    [anon_sym__Alignas] = ACTIONS(3673),
    [sym_primitive_type] = ACTIONS(3673),
    [anon_sym_enum] = ACTIONS(3673),
    [anon_sym_class] = ACTIONS(3673),
    [anon_sym_struct] = ACTIONS(3673),
    [anon_sym_union] = ACTIONS(3673),
    [anon_sym_if] = ACTIONS(3673),
    [anon_sym_switch] = ACTIONS(3673),
    [anon_sym_case] = ACTIONS(3673),
    [anon_sym_default] = ACTIONS(3673),
    [anon_sym_while] = ACTIONS(3673),
    [anon_sym_do] = ACTIONS(3673),
    [anon_sym_for] = ACTIONS(3673),
    [anon_sym_return] = ACTIONS(3673),
    [anon_sym_break] = ACTIONS(3673),
    [anon_sym_continue] = ACTIONS(3673),
    [anon_sym_goto] = ACTIONS(3673),
    [anon_sym___try] = ACTIONS(3673),
    [anon_sym___leave] = ACTIONS(3673),
    [anon_sym_not] = ACTIONS(3673),
    [anon_sym_compl] = ACTIONS(3673),
    [anon_sym_DASH_DASH] = ACTIONS(3675),
    [anon_sym_PLUS_PLUS] = ACTIONS(3675),
    [anon_sym_sizeof] = ACTIONS(3673),
    [anon_sym___alignof__] = ACTIONS(3673),
    [anon_sym___alignof] = ACTIONS(3673),
    [anon_sym__alignof] = ACTIONS(3673),
    [anon_sym_alignof] = ACTIONS(3673),
    [anon_sym__Alignof] = ACTIONS(3673),
    [anon_sym_offsetof] = ACTIONS(3673),
    [anon_sym__Generic] = ACTIONS(3673),
    [anon_sym_asm] = ACTIONS(3673),
    [anon_sym___asm__] = ACTIONS(3673),
    [sym_number_literal] = ACTIONS(3675),
    [anon_sym_L_SQUOTE] = ACTIONS(3675),
    [anon_sym_u_SQUOTE] = ACTIONS(3675),
    [anon_sym_U_SQUOTE] = ACTIONS(3675),
    [anon_sym_u8_SQUOTE] = ACTIONS(3675),
    [anon_sym_SQUOTE] = ACTIONS(3675),
    [anon_sym_L_DQUOTE] = ACTIONS(3675),
    [anon_sym_u_DQUOTE] = ACTIONS(3675),
    [anon_sym_U_DQUOTE] = ACTIONS(3675),
    [anon_sym_u8_DQUOTE] = ACTIONS(3675),
    [anon_sym_DQUOTE] = ACTIONS(3675),
    [sym_true] = ACTIONS(3673),
    [sym_false] = ACTIONS(3673),
    [anon_sym_NULL] = ACTIONS(3673),
    [anon_sym_nullptr] = ACTIONS(3673),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3673),
    [anon_sym_let] = ACTIONS(3673),
    [anon_sym_This] = ACTIONS(3673),
    [anon_sym_decltype] = ACTIONS(3673),
    [sym_virtual] = ACTIONS(3673),
    [anon_sym_explicit] = ACTIONS(3673),
    [anon_sym_typename] = ACTIONS(3673),
    [anon_sym_template] = ACTIONS(3673),
    [anon_sym_operator] = ACTIONS(3673),
    [anon_sym_try] = ACTIONS(3673),
    [anon_sym_delete] = ACTIONS(3673),
    [anon_sym_throw] = ACTIONS(3673),
    [anon_sym_namespace] = ACTIONS(3673),
    [anon_sym_using] = ACTIONS(3673),
    [anon_sym_static_assert] = ACTIONS(3673),
    [anon_sym_concept] = ACTIONS(3673),
    [anon_sym_co_return] = ACTIONS(3673),
    [anon_sym_co_yield] = ACTIONS(3673),
    [anon_sym_R_DQUOTE] = ACTIONS(3675),
    [anon_sym_LR_DQUOTE] = ACTIONS(3675),
    [anon_sym_uR_DQUOTE] = ACTIONS(3675),
    [anon_sym_UR_DQUOTE] = ACTIONS(3675),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3675),
    [anon_sym_co_await] = ACTIONS(3673),
    [anon_sym_new] = ACTIONS(3673),
    [anon_sym_requires] = ACTIONS(3673),
    [sym_this] = ACTIONS(3673),
    [anon_sym_discard] = ACTIONS(3673),
    [anon_sym_precise] = ACTIONS(3673),
    [anon_sym_shared] = ACTIONS(3673),
    [anon_sym_groupshared] = ACTIONS(3673),
    [anon_sym_uniform] = ACTIONS(3673),
    [anon_sym_row_major] = ACTIONS(3673),
    [anon_sym_column_major] = ACTIONS(3673),
    [anon_sym_globallycoherent] = ACTIONS(3673),
    [anon_sym_centroid] = ACTIONS(3673),
    [anon_sym_noperspective] = ACTIONS(3673),
    [anon_sym_nointerpolation] = ACTIONS(3673),
    [anon_sym_sample] = ACTIONS(3673),
    [anon_sym_linear] = ACTIONS(3673),
    [anon_sym_snorm] = ACTIONS(3673),
    [anon_sym_unorm] = ACTIONS(3673),
    [anon_sym_point] = ACTIONS(3673),
    [anon_sym_line] = ACTIONS(3673),
    [anon_sym_triangleadj] = ACTIONS(3673),
    [anon_sym_lineadj] = ACTIONS(3673),
    [anon_sym_triangle] = ACTIONS(3673),
    [anon_sym_cbuffer] = ACTIONS(3673),
    [anon_sym_interface] = ACTIONS(3673),
    [anon_sym_extension] = ACTIONS(3673),
  },
  [891] = {
    [sym_identifier] = ACTIONS(3425),
    [aux_sym_preproc_include_token1] = ACTIONS(3425),
    [aux_sym_preproc_def_token1] = ACTIONS(3425),
    [aux_sym_preproc_if_token1] = ACTIONS(3425),
    [aux_sym_preproc_if_token2] = ACTIONS(3425),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3425),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3425),
    [sym_preproc_directive] = ACTIONS(3425),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_BANG] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3425),
    [anon_sym_PLUS] = ACTIONS(3425),
    [anon_sym_STAR] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3425),
    [anon_sym_SEMI] = ACTIONS(3427),
    [anon_sym___extension__] = ACTIONS(3425),
    [anon_sym_typedef] = ACTIONS(3425),
    [anon_sym_in] = ACTIONS(3425),
    [anon_sym_out] = ACTIONS(3425),
    [anon_sym_inout] = ACTIONS(3425),
    [anon_sym_extern] = ACTIONS(3425),
    [anon_sym___attribute__] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(3427),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3427),
    [anon_sym___declspec] = ACTIONS(3425),
    [anon_sym___based] = ACTIONS(3425),
    [anon_sym___cdecl] = ACTIONS(3425),
    [anon_sym___clrcall] = ACTIONS(3425),
    [anon_sym___stdcall] = ACTIONS(3425),
    [anon_sym___fastcall] = ACTIONS(3425),
    [anon_sym___thiscall] = ACTIONS(3425),
    [anon_sym___vectorcall] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_signed] = ACTIONS(3425),
    [anon_sym_unsigned] = ACTIONS(3425),
    [anon_sym_long] = ACTIONS(3425),
    [anon_sym_short] = ACTIONS(3425),
    [anon_sym_LBRACK] = ACTIONS(3425),
    [anon_sym_static] = ACTIONS(3425),
    [anon_sym_register] = ACTIONS(3425),
    [anon_sym_inline] = ACTIONS(3425),
    [anon_sym___inline] = ACTIONS(3425),
    [anon_sym___inline__] = ACTIONS(3425),
    [anon_sym___forceinline] = ACTIONS(3425),
    [anon_sym_thread_local] = ACTIONS(3425),
    [anon_sym___thread] = ACTIONS(3425),
    [anon_sym_const] = ACTIONS(3425),
    [anon_sym_constexpr] = ACTIONS(3425),
    [anon_sym_volatile] = ACTIONS(3425),
    [anon_sym_restrict] = ACTIONS(3425),
    [anon_sym___restrict__] = ACTIONS(3425),
    [anon_sym__Atomic] = ACTIONS(3425),
    [anon_sym__Noreturn] = ACTIONS(3425),
    [anon_sym_noreturn] = ACTIONS(3425),
    [anon_sym_mutable] = ACTIONS(3425),
    [anon_sym_constinit] = ACTIONS(3425),
    [anon_sym_consteval] = ACTIONS(3425),
    [anon_sym_alignas] = ACTIONS(3425),
    [anon_sym__Alignas] = ACTIONS(3425),
    [sym_primitive_type] = ACTIONS(3425),
    [anon_sym_enum] = ACTIONS(3425),
    [anon_sym_class] = ACTIONS(3425),
    [anon_sym_struct] = ACTIONS(3425),
    [anon_sym_union] = ACTIONS(3425),
    [anon_sym_if] = ACTIONS(3425),
    [anon_sym_switch] = ACTIONS(3425),
    [anon_sym_case] = ACTIONS(3425),
    [anon_sym_default] = ACTIONS(3425),
    [anon_sym_while] = ACTIONS(3425),
    [anon_sym_do] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3425),
    [anon_sym_return] = ACTIONS(3425),
    [anon_sym_break] = ACTIONS(3425),
    [anon_sym_continue] = ACTIONS(3425),
    [anon_sym_goto] = ACTIONS(3425),
    [anon_sym___try] = ACTIONS(3425),
    [anon_sym___leave] = ACTIONS(3425),
    [anon_sym_not] = ACTIONS(3425),
    [anon_sym_compl] = ACTIONS(3425),
    [anon_sym_DASH_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_PLUS] = ACTIONS(3427),
    [anon_sym_sizeof] = ACTIONS(3425),
    [anon_sym___alignof__] = ACTIONS(3425),
    [anon_sym___alignof] = ACTIONS(3425),
    [anon_sym__alignof] = ACTIONS(3425),
    [anon_sym_alignof] = ACTIONS(3425),
    [anon_sym__Alignof] = ACTIONS(3425),
    [anon_sym_offsetof] = ACTIONS(3425),
    [anon_sym__Generic] = ACTIONS(3425),
    [anon_sym_asm] = ACTIONS(3425),
    [anon_sym___asm__] = ACTIONS(3425),
    [sym_number_literal] = ACTIONS(3427),
    [anon_sym_L_SQUOTE] = ACTIONS(3427),
    [anon_sym_u_SQUOTE] = ACTIONS(3427),
    [anon_sym_U_SQUOTE] = ACTIONS(3427),
    [anon_sym_u8_SQUOTE] = ACTIONS(3427),
    [anon_sym_SQUOTE] = ACTIONS(3427),
    [anon_sym_L_DQUOTE] = ACTIONS(3427),
    [anon_sym_u_DQUOTE] = ACTIONS(3427),
    [anon_sym_U_DQUOTE] = ACTIONS(3427),
    [anon_sym_u8_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [sym_true] = ACTIONS(3425),
    [sym_false] = ACTIONS(3425),
    [anon_sym_NULL] = ACTIONS(3425),
    [anon_sym_nullptr] = ACTIONS(3425),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3425),
    [anon_sym_let] = ACTIONS(3425),
    [anon_sym_This] = ACTIONS(3425),
    [anon_sym_decltype] = ACTIONS(3425),
    [sym_virtual] = ACTIONS(3425),
    [anon_sym_explicit] = ACTIONS(3425),
    [anon_sym_typename] = ACTIONS(3425),
    [anon_sym_template] = ACTIONS(3425),
    [anon_sym_operator] = ACTIONS(3425),
    [anon_sym_try] = ACTIONS(3425),
    [anon_sym_delete] = ACTIONS(3425),
    [anon_sym_throw] = ACTIONS(3425),
    [anon_sym_namespace] = ACTIONS(3425),
    [anon_sym_using] = ACTIONS(3425),
    [anon_sym_static_assert] = ACTIONS(3425),
    [anon_sym_concept] = ACTIONS(3425),
    [anon_sym_co_return] = ACTIONS(3425),
    [anon_sym_co_yield] = ACTIONS(3425),
    [anon_sym_R_DQUOTE] = ACTIONS(3427),
    [anon_sym_LR_DQUOTE] = ACTIONS(3427),
    [anon_sym_uR_DQUOTE] = ACTIONS(3427),
    [anon_sym_UR_DQUOTE] = ACTIONS(3427),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3427),
    [anon_sym_co_await] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_requires] = ACTIONS(3425),
    [sym_this] = ACTIONS(3425),
    [anon_sym_discard] = ACTIONS(3425),
    [anon_sym_precise] = ACTIONS(3425),
    [anon_sym_shared] = ACTIONS(3425),
    [anon_sym_groupshared] = ACTIONS(3425),
    [anon_sym_uniform] = ACTIONS(3425),
    [anon_sym_row_major] = ACTIONS(3425),
    [anon_sym_column_major] = ACTIONS(3425),
    [anon_sym_globallycoherent] = ACTIONS(3425),
    [anon_sym_centroid] = ACTIONS(3425),
    [anon_sym_noperspective] = ACTIONS(3425),
    [anon_sym_nointerpolation] = ACTIONS(3425),
    [anon_sym_sample] = ACTIONS(3425),
    [anon_sym_linear] = ACTIONS(3425),
    [anon_sym_snorm] = ACTIONS(3425),
    [anon_sym_unorm] = ACTIONS(3425),
    [anon_sym_point] = ACTIONS(3425),
    [anon_sym_line] = ACTIONS(3425),
    [anon_sym_triangleadj] = ACTIONS(3425),
    [anon_sym_lineadj] = ACTIONS(3425),
    [anon_sym_triangle] = ACTIONS(3425),
    [anon_sym_cbuffer] = ACTIONS(3425),
    [anon_sym_interface] = ACTIONS(3425),
    [anon_sym_extension] = ACTIONS(3425),
  },
  [892] = {
    [sym_identifier] = ACTIONS(3463),
    [aux_sym_preproc_include_token1] = ACTIONS(3463),
    [aux_sym_preproc_def_token1] = ACTIONS(3463),
    [aux_sym_preproc_if_token1] = ACTIONS(3463),
    [aux_sym_preproc_if_token2] = ACTIONS(3463),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3463),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3463),
    [sym_preproc_directive] = ACTIONS(3463),
    [anon_sym_LPAREN2] = ACTIONS(3465),
    [anon_sym_BANG] = ACTIONS(3465),
    [anon_sym_TILDE] = ACTIONS(3465),
    [anon_sym_DASH] = ACTIONS(3463),
    [anon_sym_PLUS] = ACTIONS(3463),
    [anon_sym_STAR] = ACTIONS(3465),
    [anon_sym_AMP_AMP] = ACTIONS(3465),
    [anon_sym_AMP] = ACTIONS(3463),
    [anon_sym_SEMI] = ACTIONS(3465),
    [anon_sym___extension__] = ACTIONS(3463),
    [anon_sym_typedef] = ACTIONS(3463),
    [anon_sym_in] = ACTIONS(3463),
    [anon_sym_out] = ACTIONS(3463),
    [anon_sym_inout] = ACTIONS(3463),
    [anon_sym_extern] = ACTIONS(3463),
    [anon_sym___attribute__] = ACTIONS(3463),
    [anon_sym_COLON_COLON] = ACTIONS(3465),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3465),
    [anon_sym___declspec] = ACTIONS(3463),
    [anon_sym___based] = ACTIONS(3463),
    [anon_sym___cdecl] = ACTIONS(3463),
    [anon_sym___clrcall] = ACTIONS(3463),
    [anon_sym___stdcall] = ACTIONS(3463),
    [anon_sym___fastcall] = ACTIONS(3463),
    [anon_sym___thiscall] = ACTIONS(3463),
    [anon_sym___vectorcall] = ACTIONS(3463),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_signed] = ACTIONS(3463),
    [anon_sym_unsigned] = ACTIONS(3463),
    [anon_sym_long] = ACTIONS(3463),
    [anon_sym_short] = ACTIONS(3463),
    [anon_sym_LBRACK] = ACTIONS(3463),
    [anon_sym_static] = ACTIONS(3463),
    [anon_sym_register] = ACTIONS(3463),
    [anon_sym_inline] = ACTIONS(3463),
    [anon_sym___inline] = ACTIONS(3463),
    [anon_sym___inline__] = ACTIONS(3463),
    [anon_sym___forceinline] = ACTIONS(3463),
    [anon_sym_thread_local] = ACTIONS(3463),
    [anon_sym___thread] = ACTIONS(3463),
    [anon_sym_const] = ACTIONS(3463),
    [anon_sym_constexpr] = ACTIONS(3463),
    [anon_sym_volatile] = ACTIONS(3463),
    [anon_sym_restrict] = ACTIONS(3463),
    [anon_sym___restrict__] = ACTIONS(3463),
    [anon_sym__Atomic] = ACTIONS(3463),
    [anon_sym__Noreturn] = ACTIONS(3463),
    [anon_sym_noreturn] = ACTIONS(3463),
    [anon_sym_mutable] = ACTIONS(3463),
    [anon_sym_constinit] = ACTIONS(3463),
    [anon_sym_consteval] = ACTIONS(3463),
    [anon_sym_alignas] = ACTIONS(3463),
    [anon_sym__Alignas] = ACTIONS(3463),
    [sym_primitive_type] = ACTIONS(3463),
    [anon_sym_enum] = ACTIONS(3463),
    [anon_sym_class] = ACTIONS(3463),
    [anon_sym_struct] = ACTIONS(3463),
    [anon_sym_union] = ACTIONS(3463),
    [anon_sym_if] = ACTIONS(3463),
    [anon_sym_switch] = ACTIONS(3463),
    [anon_sym_case] = ACTIONS(3463),
    [anon_sym_default] = ACTIONS(3463),
    [anon_sym_while] = ACTIONS(3463),
    [anon_sym_do] = ACTIONS(3463),
    [anon_sym_for] = ACTIONS(3463),
    [anon_sym_return] = ACTIONS(3463),
    [anon_sym_break] = ACTIONS(3463),
    [anon_sym_continue] = ACTIONS(3463),
    [anon_sym_goto] = ACTIONS(3463),
    [anon_sym___try] = ACTIONS(3463),
    [anon_sym___leave] = ACTIONS(3463),
    [anon_sym_not] = ACTIONS(3463),
    [anon_sym_compl] = ACTIONS(3463),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(3463),
    [anon_sym___alignof__] = ACTIONS(3463),
    [anon_sym___alignof] = ACTIONS(3463),
    [anon_sym__alignof] = ACTIONS(3463),
    [anon_sym_alignof] = ACTIONS(3463),
    [anon_sym__Alignof] = ACTIONS(3463),
    [anon_sym_offsetof] = ACTIONS(3463),
    [anon_sym__Generic] = ACTIONS(3463),
    [anon_sym_asm] = ACTIONS(3463),
    [anon_sym___asm__] = ACTIONS(3463),
    [sym_number_literal] = ACTIONS(3465),
    [anon_sym_L_SQUOTE] = ACTIONS(3465),
    [anon_sym_u_SQUOTE] = ACTIONS(3465),
    [anon_sym_U_SQUOTE] = ACTIONS(3465),
    [anon_sym_u8_SQUOTE] = ACTIONS(3465),
    [anon_sym_SQUOTE] = ACTIONS(3465),
    [anon_sym_L_DQUOTE] = ACTIONS(3465),
    [anon_sym_u_DQUOTE] = ACTIONS(3465),
    [anon_sym_U_DQUOTE] = ACTIONS(3465),
    [anon_sym_u8_DQUOTE] = ACTIONS(3465),
    [anon_sym_DQUOTE] = ACTIONS(3465),
    [sym_true] = ACTIONS(3463),
    [sym_false] = ACTIONS(3463),
    [anon_sym_NULL] = ACTIONS(3463),
    [anon_sym_nullptr] = ACTIONS(3463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3463),
    [anon_sym_let] = ACTIONS(3463),
    [anon_sym_This] = ACTIONS(3463),
    [anon_sym_decltype] = ACTIONS(3463),
    [sym_virtual] = ACTIONS(3463),
    [anon_sym_explicit] = ACTIONS(3463),
    [anon_sym_typename] = ACTIONS(3463),
    [anon_sym_template] = ACTIONS(3463),
    [anon_sym_operator] = ACTIONS(3463),
    [anon_sym_try] = ACTIONS(3463),
    [anon_sym_delete] = ACTIONS(3463),
    [anon_sym_throw] = ACTIONS(3463),
    [anon_sym_namespace] = ACTIONS(3463),
    [anon_sym_using] = ACTIONS(3463),
    [anon_sym_static_assert] = ACTIONS(3463),
    [anon_sym_concept] = ACTIONS(3463),
    [anon_sym_co_return] = ACTIONS(3463),
    [anon_sym_co_yield] = ACTIONS(3463),
    [anon_sym_R_DQUOTE] = ACTIONS(3465),
    [anon_sym_LR_DQUOTE] = ACTIONS(3465),
    [anon_sym_uR_DQUOTE] = ACTIONS(3465),
    [anon_sym_UR_DQUOTE] = ACTIONS(3465),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3465),
    [anon_sym_co_await] = ACTIONS(3463),
    [anon_sym_new] = ACTIONS(3463),
    [anon_sym_requires] = ACTIONS(3463),
    [sym_this] = ACTIONS(3463),
    [anon_sym_discard] = ACTIONS(3463),
    [anon_sym_precise] = ACTIONS(3463),
    [anon_sym_shared] = ACTIONS(3463),
    [anon_sym_groupshared] = ACTIONS(3463),
    [anon_sym_uniform] = ACTIONS(3463),
    [anon_sym_row_major] = ACTIONS(3463),
    [anon_sym_column_major] = ACTIONS(3463),
    [anon_sym_globallycoherent] = ACTIONS(3463),
    [anon_sym_centroid] = ACTIONS(3463),
    [anon_sym_noperspective] = ACTIONS(3463),
    [anon_sym_nointerpolation] = ACTIONS(3463),
    [anon_sym_sample] = ACTIONS(3463),
    [anon_sym_linear] = ACTIONS(3463),
    [anon_sym_snorm] = ACTIONS(3463),
    [anon_sym_unorm] = ACTIONS(3463),
    [anon_sym_point] = ACTIONS(3463),
    [anon_sym_line] = ACTIONS(3463),
    [anon_sym_triangleadj] = ACTIONS(3463),
    [anon_sym_lineadj] = ACTIONS(3463),
    [anon_sym_triangle] = ACTIONS(3463),
    [anon_sym_cbuffer] = ACTIONS(3463),
    [anon_sym_interface] = ACTIONS(3463),
    [anon_sym_extension] = ACTIONS(3463),
  },
  [893] = {
    [sym_identifier] = ACTIONS(3418),
    [aux_sym_preproc_include_token1] = ACTIONS(3418),
    [aux_sym_preproc_def_token1] = ACTIONS(3418),
    [aux_sym_preproc_if_token1] = ACTIONS(3418),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3418),
    [sym_preproc_directive] = ACTIONS(3418),
    [anon_sym_LPAREN2] = ACTIONS(3420),
    [anon_sym_BANG] = ACTIONS(3420),
    [anon_sym_TILDE] = ACTIONS(3420),
    [anon_sym_DASH] = ACTIONS(3418),
    [anon_sym_PLUS] = ACTIONS(3418),
    [anon_sym_STAR] = ACTIONS(3420),
    [anon_sym_AMP_AMP] = ACTIONS(3420),
    [anon_sym_AMP] = ACTIONS(3418),
    [anon_sym_SEMI] = ACTIONS(3420),
    [anon_sym___extension__] = ACTIONS(3418),
    [anon_sym_typedef] = ACTIONS(3418),
    [anon_sym_in] = ACTIONS(3418),
    [anon_sym_out] = ACTIONS(3418),
    [anon_sym_inout] = ACTIONS(3418),
    [anon_sym_extern] = ACTIONS(3418),
    [anon_sym___attribute__] = ACTIONS(3418),
    [anon_sym_COLON_COLON] = ACTIONS(3420),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3420),
    [anon_sym___declspec] = ACTIONS(3418),
    [anon_sym___based] = ACTIONS(3418),
    [anon_sym___cdecl] = ACTIONS(3418),
    [anon_sym___clrcall] = ACTIONS(3418),
    [anon_sym___stdcall] = ACTIONS(3418),
    [anon_sym___fastcall] = ACTIONS(3418),
    [anon_sym___thiscall] = ACTIONS(3418),
    [anon_sym___vectorcall] = ACTIONS(3418),
    [anon_sym_LBRACE] = ACTIONS(3420),
    [anon_sym_RBRACE] = ACTIONS(3420),
    [anon_sym_signed] = ACTIONS(3418),
    [anon_sym_unsigned] = ACTIONS(3418),
    [anon_sym_long] = ACTIONS(3418),
    [anon_sym_short] = ACTIONS(3418),
    [anon_sym_LBRACK] = ACTIONS(3418),
    [anon_sym_static] = ACTIONS(3418),
    [anon_sym_register] = ACTIONS(3418),
    [anon_sym_inline] = ACTIONS(3418),
    [anon_sym___inline] = ACTIONS(3418),
    [anon_sym___inline__] = ACTIONS(3418),
    [anon_sym___forceinline] = ACTIONS(3418),
    [anon_sym_thread_local] = ACTIONS(3418),
    [anon_sym___thread] = ACTIONS(3418),
    [anon_sym_const] = ACTIONS(3418),
    [anon_sym_constexpr] = ACTIONS(3418),
    [anon_sym_volatile] = ACTIONS(3418),
    [anon_sym_restrict] = ACTIONS(3418),
    [anon_sym___restrict__] = ACTIONS(3418),
    [anon_sym__Atomic] = ACTIONS(3418),
    [anon_sym__Noreturn] = ACTIONS(3418),
    [anon_sym_noreturn] = ACTIONS(3418),
    [anon_sym_mutable] = ACTIONS(3418),
    [anon_sym_constinit] = ACTIONS(3418),
    [anon_sym_consteval] = ACTIONS(3418),
    [anon_sym_alignas] = ACTIONS(3418),
    [anon_sym__Alignas] = ACTIONS(3418),
    [sym_primitive_type] = ACTIONS(3418),
    [anon_sym_enum] = ACTIONS(3418),
    [anon_sym_class] = ACTIONS(3418),
    [anon_sym_struct] = ACTIONS(3418),
    [anon_sym_union] = ACTIONS(3418),
    [anon_sym_if] = ACTIONS(3418),
    [anon_sym_switch] = ACTIONS(3418),
    [anon_sym_case] = ACTIONS(3418),
    [anon_sym_default] = ACTIONS(3418),
    [anon_sym_while] = ACTIONS(3418),
    [anon_sym_do] = ACTIONS(3418),
    [anon_sym_for] = ACTIONS(3418),
    [anon_sym_return] = ACTIONS(3418),
    [anon_sym_break] = ACTIONS(3418),
    [anon_sym_continue] = ACTIONS(3418),
    [anon_sym_goto] = ACTIONS(3418),
    [anon_sym___try] = ACTIONS(3418),
    [anon_sym___leave] = ACTIONS(3418),
    [anon_sym_not] = ACTIONS(3418),
    [anon_sym_compl] = ACTIONS(3418),
    [anon_sym_DASH_DASH] = ACTIONS(3420),
    [anon_sym_PLUS_PLUS] = ACTIONS(3420),
    [anon_sym_sizeof] = ACTIONS(3418),
    [anon_sym___alignof__] = ACTIONS(3418),
    [anon_sym___alignof] = ACTIONS(3418),
    [anon_sym__alignof] = ACTIONS(3418),
    [anon_sym_alignof] = ACTIONS(3418),
    [anon_sym__Alignof] = ACTIONS(3418),
    [anon_sym_offsetof] = ACTIONS(3418),
    [anon_sym__Generic] = ACTIONS(3418),
    [anon_sym_asm] = ACTIONS(3418),
    [anon_sym___asm__] = ACTIONS(3418),
    [sym_number_literal] = ACTIONS(3420),
    [anon_sym_L_SQUOTE] = ACTIONS(3420),
    [anon_sym_u_SQUOTE] = ACTIONS(3420),
    [anon_sym_U_SQUOTE] = ACTIONS(3420),
    [anon_sym_u8_SQUOTE] = ACTIONS(3420),
    [anon_sym_SQUOTE] = ACTIONS(3420),
    [anon_sym_L_DQUOTE] = ACTIONS(3420),
    [anon_sym_u_DQUOTE] = ACTIONS(3420),
    [anon_sym_U_DQUOTE] = ACTIONS(3420),
    [anon_sym_u8_DQUOTE] = ACTIONS(3420),
    [anon_sym_DQUOTE] = ACTIONS(3420),
    [sym_true] = ACTIONS(3418),
    [sym_false] = ACTIONS(3418),
    [anon_sym_NULL] = ACTIONS(3418),
    [anon_sym_nullptr] = ACTIONS(3418),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3418),
    [anon_sym_let] = ACTIONS(3418),
    [anon_sym_This] = ACTIONS(3418),
    [anon_sym_decltype] = ACTIONS(3418),
    [sym_virtual] = ACTIONS(3418),
    [anon_sym_explicit] = ACTIONS(3418),
    [anon_sym_typename] = ACTIONS(3418),
    [anon_sym_template] = ACTIONS(3418),
    [anon_sym_operator] = ACTIONS(3418),
    [anon_sym_try] = ACTIONS(3418),
    [anon_sym_delete] = ACTIONS(3418),
    [anon_sym_throw] = ACTIONS(3418),
    [anon_sym_namespace] = ACTIONS(3418),
    [anon_sym_using] = ACTIONS(3418),
    [anon_sym_static_assert] = ACTIONS(3418),
    [anon_sym_concept] = ACTIONS(3418),
    [anon_sym_co_return] = ACTIONS(3418),
    [anon_sym_co_yield] = ACTIONS(3418),
    [anon_sym_R_DQUOTE] = ACTIONS(3420),
    [anon_sym_LR_DQUOTE] = ACTIONS(3420),
    [anon_sym_uR_DQUOTE] = ACTIONS(3420),
    [anon_sym_UR_DQUOTE] = ACTIONS(3420),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3420),
    [anon_sym_co_await] = ACTIONS(3418),
    [anon_sym_new] = ACTIONS(3418),
    [anon_sym_requires] = ACTIONS(3418),
    [sym_this] = ACTIONS(3418),
    [anon_sym_discard] = ACTIONS(3418),
    [anon_sym_precise] = ACTIONS(3418),
    [anon_sym_shared] = ACTIONS(3418),
    [anon_sym_groupshared] = ACTIONS(3418),
    [anon_sym_uniform] = ACTIONS(3418),
    [anon_sym_row_major] = ACTIONS(3418),
    [anon_sym_column_major] = ACTIONS(3418),
    [anon_sym_globallycoherent] = ACTIONS(3418),
    [anon_sym_centroid] = ACTIONS(3418),
    [anon_sym_noperspective] = ACTIONS(3418),
    [anon_sym_nointerpolation] = ACTIONS(3418),
    [anon_sym_sample] = ACTIONS(3418),
    [anon_sym_linear] = ACTIONS(3418),
    [anon_sym_snorm] = ACTIONS(3418),
    [anon_sym_unorm] = ACTIONS(3418),
    [anon_sym_point] = ACTIONS(3418),
    [anon_sym_line] = ACTIONS(3418),
    [anon_sym_triangleadj] = ACTIONS(3418),
    [anon_sym_lineadj] = ACTIONS(3418),
    [anon_sym_triangle] = ACTIONS(3418),
    [anon_sym_cbuffer] = ACTIONS(3418),
    [anon_sym_interface] = ACTIONS(3418),
    [anon_sym_extension] = ACTIONS(3418),
  },
  [894] = {
    [sym_identifier] = ACTIONS(3414),
    [aux_sym_preproc_include_token1] = ACTIONS(3414),
    [aux_sym_preproc_def_token1] = ACTIONS(3414),
    [aux_sym_preproc_if_token1] = ACTIONS(3414),
    [aux_sym_preproc_if_token2] = ACTIONS(3414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3414),
    [sym_preproc_directive] = ACTIONS(3414),
    [anon_sym_LPAREN2] = ACTIONS(3416),
    [anon_sym_BANG] = ACTIONS(3416),
    [anon_sym_TILDE] = ACTIONS(3416),
    [anon_sym_DASH] = ACTIONS(3414),
    [anon_sym_PLUS] = ACTIONS(3414),
    [anon_sym_STAR] = ACTIONS(3416),
    [anon_sym_AMP_AMP] = ACTIONS(3416),
    [anon_sym_AMP] = ACTIONS(3414),
    [anon_sym_SEMI] = ACTIONS(3416),
    [anon_sym___extension__] = ACTIONS(3414),
    [anon_sym_typedef] = ACTIONS(3414),
    [anon_sym_in] = ACTIONS(3414),
    [anon_sym_out] = ACTIONS(3414),
    [anon_sym_inout] = ACTIONS(3414),
    [anon_sym_extern] = ACTIONS(3414),
    [anon_sym___attribute__] = ACTIONS(3414),
    [anon_sym_COLON_COLON] = ACTIONS(3416),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3416),
    [anon_sym___declspec] = ACTIONS(3414),
    [anon_sym___based] = ACTIONS(3414),
    [anon_sym___cdecl] = ACTIONS(3414),
    [anon_sym___clrcall] = ACTIONS(3414),
    [anon_sym___stdcall] = ACTIONS(3414),
    [anon_sym___fastcall] = ACTIONS(3414),
    [anon_sym___thiscall] = ACTIONS(3414),
    [anon_sym___vectorcall] = ACTIONS(3414),
    [anon_sym_LBRACE] = ACTIONS(3416),
    [anon_sym_signed] = ACTIONS(3414),
    [anon_sym_unsigned] = ACTIONS(3414),
    [anon_sym_long] = ACTIONS(3414),
    [anon_sym_short] = ACTIONS(3414),
    [anon_sym_LBRACK] = ACTIONS(3414),
    [anon_sym_static] = ACTIONS(3414),
    [anon_sym_register] = ACTIONS(3414),
    [anon_sym_inline] = ACTIONS(3414),
    [anon_sym___inline] = ACTIONS(3414),
    [anon_sym___inline__] = ACTIONS(3414),
    [anon_sym___forceinline] = ACTIONS(3414),
    [anon_sym_thread_local] = ACTIONS(3414),
    [anon_sym___thread] = ACTIONS(3414),
    [anon_sym_const] = ACTIONS(3414),
    [anon_sym_constexpr] = ACTIONS(3414),
    [anon_sym_volatile] = ACTIONS(3414),
    [anon_sym_restrict] = ACTIONS(3414),
    [anon_sym___restrict__] = ACTIONS(3414),
    [anon_sym__Atomic] = ACTIONS(3414),
    [anon_sym__Noreturn] = ACTIONS(3414),
    [anon_sym_noreturn] = ACTIONS(3414),
    [anon_sym_mutable] = ACTIONS(3414),
    [anon_sym_constinit] = ACTIONS(3414),
    [anon_sym_consteval] = ACTIONS(3414),
    [anon_sym_alignas] = ACTIONS(3414),
    [anon_sym__Alignas] = ACTIONS(3414),
    [sym_primitive_type] = ACTIONS(3414),
    [anon_sym_enum] = ACTIONS(3414),
    [anon_sym_class] = ACTIONS(3414),
    [anon_sym_struct] = ACTIONS(3414),
    [anon_sym_union] = ACTIONS(3414),
    [anon_sym_if] = ACTIONS(3414),
    [anon_sym_switch] = ACTIONS(3414),
    [anon_sym_case] = ACTIONS(3414),
    [anon_sym_default] = ACTIONS(3414),
    [anon_sym_while] = ACTIONS(3414),
    [anon_sym_do] = ACTIONS(3414),
    [anon_sym_for] = ACTIONS(3414),
    [anon_sym_return] = ACTIONS(3414),
    [anon_sym_break] = ACTIONS(3414),
    [anon_sym_continue] = ACTIONS(3414),
    [anon_sym_goto] = ACTIONS(3414),
    [anon_sym___try] = ACTIONS(3414),
    [anon_sym___leave] = ACTIONS(3414),
    [anon_sym_not] = ACTIONS(3414),
    [anon_sym_compl] = ACTIONS(3414),
    [anon_sym_DASH_DASH] = ACTIONS(3416),
    [anon_sym_PLUS_PLUS] = ACTIONS(3416),
    [anon_sym_sizeof] = ACTIONS(3414),
    [anon_sym___alignof__] = ACTIONS(3414),
    [anon_sym___alignof] = ACTIONS(3414),
    [anon_sym__alignof] = ACTIONS(3414),
    [anon_sym_alignof] = ACTIONS(3414),
    [anon_sym__Alignof] = ACTIONS(3414),
    [anon_sym_offsetof] = ACTIONS(3414),
    [anon_sym__Generic] = ACTIONS(3414),
    [anon_sym_asm] = ACTIONS(3414),
    [anon_sym___asm__] = ACTIONS(3414),
    [sym_number_literal] = ACTIONS(3416),
    [anon_sym_L_SQUOTE] = ACTIONS(3416),
    [anon_sym_u_SQUOTE] = ACTIONS(3416),
    [anon_sym_U_SQUOTE] = ACTIONS(3416),
    [anon_sym_u8_SQUOTE] = ACTIONS(3416),
    [anon_sym_SQUOTE] = ACTIONS(3416),
    [anon_sym_L_DQUOTE] = ACTIONS(3416),
    [anon_sym_u_DQUOTE] = ACTIONS(3416),
    [anon_sym_U_DQUOTE] = ACTIONS(3416),
    [anon_sym_u8_DQUOTE] = ACTIONS(3416),
    [anon_sym_DQUOTE] = ACTIONS(3416),
    [sym_true] = ACTIONS(3414),
    [sym_false] = ACTIONS(3414),
    [anon_sym_NULL] = ACTIONS(3414),
    [anon_sym_nullptr] = ACTIONS(3414),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3414),
    [anon_sym_let] = ACTIONS(3414),
    [anon_sym_This] = ACTIONS(3414),
    [anon_sym_decltype] = ACTIONS(3414),
    [sym_virtual] = ACTIONS(3414),
    [anon_sym_explicit] = ACTIONS(3414),
    [anon_sym_typename] = ACTIONS(3414),
    [anon_sym_template] = ACTIONS(3414),
    [anon_sym_operator] = ACTIONS(3414),
    [anon_sym_try] = ACTIONS(3414),
    [anon_sym_delete] = ACTIONS(3414),
    [anon_sym_throw] = ACTIONS(3414),
    [anon_sym_namespace] = ACTIONS(3414),
    [anon_sym_using] = ACTIONS(3414),
    [anon_sym_static_assert] = ACTIONS(3414),
    [anon_sym_concept] = ACTIONS(3414),
    [anon_sym_co_return] = ACTIONS(3414),
    [anon_sym_co_yield] = ACTIONS(3414),
    [anon_sym_R_DQUOTE] = ACTIONS(3416),
    [anon_sym_LR_DQUOTE] = ACTIONS(3416),
    [anon_sym_uR_DQUOTE] = ACTIONS(3416),
    [anon_sym_UR_DQUOTE] = ACTIONS(3416),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3416),
    [anon_sym_co_await] = ACTIONS(3414),
    [anon_sym_new] = ACTIONS(3414),
    [anon_sym_requires] = ACTIONS(3414),
    [sym_this] = ACTIONS(3414),
    [anon_sym_discard] = ACTIONS(3414),
    [anon_sym_precise] = ACTIONS(3414),
    [anon_sym_shared] = ACTIONS(3414),
    [anon_sym_groupshared] = ACTIONS(3414),
    [anon_sym_uniform] = ACTIONS(3414),
    [anon_sym_row_major] = ACTIONS(3414),
    [anon_sym_column_major] = ACTIONS(3414),
    [anon_sym_globallycoherent] = ACTIONS(3414),
    [anon_sym_centroid] = ACTIONS(3414),
    [anon_sym_noperspective] = ACTIONS(3414),
    [anon_sym_nointerpolation] = ACTIONS(3414),
    [anon_sym_sample] = ACTIONS(3414),
    [anon_sym_linear] = ACTIONS(3414),
    [anon_sym_snorm] = ACTIONS(3414),
    [anon_sym_unorm] = ACTIONS(3414),
    [anon_sym_point] = ACTIONS(3414),
    [anon_sym_line] = ACTIONS(3414),
    [anon_sym_triangleadj] = ACTIONS(3414),
    [anon_sym_lineadj] = ACTIONS(3414),
    [anon_sym_triangle] = ACTIONS(3414),
    [anon_sym_cbuffer] = ACTIONS(3414),
    [anon_sym_interface] = ACTIONS(3414),
    [anon_sym_extension] = ACTIONS(3414),
  },
  [895] = {
    [sym_identifier] = ACTIONS(3547),
    [aux_sym_preproc_include_token1] = ACTIONS(3547),
    [aux_sym_preproc_def_token1] = ACTIONS(3547),
    [aux_sym_preproc_if_token1] = ACTIONS(3547),
    [aux_sym_preproc_if_token2] = ACTIONS(3547),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3547),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3547),
    [sym_preproc_directive] = ACTIONS(3547),
    [anon_sym_LPAREN2] = ACTIONS(3549),
    [anon_sym_BANG] = ACTIONS(3549),
    [anon_sym_TILDE] = ACTIONS(3549),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_STAR] = ACTIONS(3549),
    [anon_sym_AMP_AMP] = ACTIONS(3549),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym_SEMI] = ACTIONS(3549),
    [anon_sym___extension__] = ACTIONS(3547),
    [anon_sym_typedef] = ACTIONS(3547),
    [anon_sym_in] = ACTIONS(3547),
    [anon_sym_out] = ACTIONS(3547),
    [anon_sym_inout] = ACTIONS(3547),
    [anon_sym_extern] = ACTIONS(3547),
    [anon_sym___attribute__] = ACTIONS(3547),
    [anon_sym_COLON_COLON] = ACTIONS(3549),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3549),
    [anon_sym___declspec] = ACTIONS(3547),
    [anon_sym___based] = ACTIONS(3547),
    [anon_sym___cdecl] = ACTIONS(3547),
    [anon_sym___clrcall] = ACTIONS(3547),
    [anon_sym___stdcall] = ACTIONS(3547),
    [anon_sym___fastcall] = ACTIONS(3547),
    [anon_sym___thiscall] = ACTIONS(3547),
    [anon_sym___vectorcall] = ACTIONS(3547),
    [anon_sym_LBRACE] = ACTIONS(3549),
    [anon_sym_signed] = ACTIONS(3547),
    [anon_sym_unsigned] = ACTIONS(3547),
    [anon_sym_long] = ACTIONS(3547),
    [anon_sym_short] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_static] = ACTIONS(3547),
    [anon_sym_register] = ACTIONS(3547),
    [anon_sym_inline] = ACTIONS(3547),
    [anon_sym___inline] = ACTIONS(3547),
    [anon_sym___inline__] = ACTIONS(3547),
    [anon_sym___forceinline] = ACTIONS(3547),
    [anon_sym_thread_local] = ACTIONS(3547),
    [anon_sym___thread] = ACTIONS(3547),
    [anon_sym_const] = ACTIONS(3547),
    [anon_sym_constexpr] = ACTIONS(3547),
    [anon_sym_volatile] = ACTIONS(3547),
    [anon_sym_restrict] = ACTIONS(3547),
    [anon_sym___restrict__] = ACTIONS(3547),
    [anon_sym__Atomic] = ACTIONS(3547),
    [anon_sym__Noreturn] = ACTIONS(3547),
    [anon_sym_noreturn] = ACTIONS(3547),
    [anon_sym_mutable] = ACTIONS(3547),
    [anon_sym_constinit] = ACTIONS(3547),
    [anon_sym_consteval] = ACTIONS(3547),
    [anon_sym_alignas] = ACTIONS(3547),
    [anon_sym__Alignas] = ACTIONS(3547),
    [sym_primitive_type] = ACTIONS(3547),
    [anon_sym_enum] = ACTIONS(3547),
    [anon_sym_class] = ACTIONS(3547),
    [anon_sym_struct] = ACTIONS(3547),
    [anon_sym_union] = ACTIONS(3547),
    [anon_sym_if] = ACTIONS(3547),
    [anon_sym_switch] = ACTIONS(3547),
    [anon_sym_case] = ACTIONS(3547),
    [anon_sym_default] = ACTIONS(3547),
    [anon_sym_while] = ACTIONS(3547),
    [anon_sym_do] = ACTIONS(3547),
    [anon_sym_for] = ACTIONS(3547),
    [anon_sym_return] = ACTIONS(3547),
    [anon_sym_break] = ACTIONS(3547),
    [anon_sym_continue] = ACTIONS(3547),
    [anon_sym_goto] = ACTIONS(3547),
    [anon_sym___try] = ACTIONS(3547),
    [anon_sym___leave] = ACTIONS(3547),
    [anon_sym_not] = ACTIONS(3547),
    [anon_sym_compl] = ACTIONS(3547),
    [anon_sym_DASH_DASH] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(3549),
    [anon_sym_sizeof] = ACTIONS(3547),
    [anon_sym___alignof__] = ACTIONS(3547),
    [anon_sym___alignof] = ACTIONS(3547),
    [anon_sym__alignof] = ACTIONS(3547),
    [anon_sym_alignof] = ACTIONS(3547),
    [anon_sym__Alignof] = ACTIONS(3547),
    [anon_sym_offsetof] = ACTIONS(3547),
    [anon_sym__Generic] = ACTIONS(3547),
    [anon_sym_asm] = ACTIONS(3547),
    [anon_sym___asm__] = ACTIONS(3547),
    [sym_number_literal] = ACTIONS(3549),
    [anon_sym_L_SQUOTE] = ACTIONS(3549),
    [anon_sym_u_SQUOTE] = ACTIONS(3549),
    [anon_sym_U_SQUOTE] = ACTIONS(3549),
    [anon_sym_u8_SQUOTE] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [anon_sym_L_DQUOTE] = ACTIONS(3549),
    [anon_sym_u_DQUOTE] = ACTIONS(3549),
    [anon_sym_U_DQUOTE] = ACTIONS(3549),
    [anon_sym_u8_DQUOTE] = ACTIONS(3549),
    [anon_sym_DQUOTE] = ACTIONS(3549),
    [sym_true] = ACTIONS(3547),
    [sym_false] = ACTIONS(3547),
    [anon_sym_NULL] = ACTIONS(3547),
    [anon_sym_nullptr] = ACTIONS(3547),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_This] = ACTIONS(3547),
    [anon_sym_decltype] = ACTIONS(3547),
    [sym_virtual] = ACTIONS(3547),
    [anon_sym_explicit] = ACTIONS(3547),
    [anon_sym_typename] = ACTIONS(3547),
    [anon_sym_template] = ACTIONS(3547),
    [anon_sym_operator] = ACTIONS(3547),
    [anon_sym_try] = ACTIONS(3547),
    [anon_sym_delete] = ACTIONS(3547),
    [anon_sym_throw] = ACTIONS(3547),
    [anon_sym_namespace] = ACTIONS(3547),
    [anon_sym_using] = ACTIONS(3547),
    [anon_sym_static_assert] = ACTIONS(3547),
    [anon_sym_concept] = ACTIONS(3547),
    [anon_sym_co_return] = ACTIONS(3547),
    [anon_sym_co_yield] = ACTIONS(3547),
    [anon_sym_R_DQUOTE] = ACTIONS(3549),
    [anon_sym_LR_DQUOTE] = ACTIONS(3549),
    [anon_sym_uR_DQUOTE] = ACTIONS(3549),
    [anon_sym_UR_DQUOTE] = ACTIONS(3549),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3549),
    [anon_sym_co_await] = ACTIONS(3547),
    [anon_sym_new] = ACTIONS(3547),
    [anon_sym_requires] = ACTIONS(3547),
    [sym_this] = ACTIONS(3547),
    [anon_sym_discard] = ACTIONS(3547),
    [anon_sym_precise] = ACTIONS(3547),
    [anon_sym_shared] = ACTIONS(3547),
    [anon_sym_groupshared] = ACTIONS(3547),
    [anon_sym_uniform] = ACTIONS(3547),
    [anon_sym_row_major] = ACTIONS(3547),
    [anon_sym_column_major] = ACTIONS(3547),
    [anon_sym_globallycoherent] = ACTIONS(3547),
    [anon_sym_centroid] = ACTIONS(3547),
    [anon_sym_noperspective] = ACTIONS(3547),
    [anon_sym_nointerpolation] = ACTIONS(3547),
    [anon_sym_sample] = ACTIONS(3547),
    [anon_sym_linear] = ACTIONS(3547),
    [anon_sym_snorm] = ACTIONS(3547),
    [anon_sym_unorm] = ACTIONS(3547),
    [anon_sym_point] = ACTIONS(3547),
    [anon_sym_line] = ACTIONS(3547),
    [anon_sym_triangleadj] = ACTIONS(3547),
    [anon_sym_lineadj] = ACTIONS(3547),
    [anon_sym_triangle] = ACTIONS(3547),
    [anon_sym_cbuffer] = ACTIONS(3547),
    [anon_sym_interface] = ACTIONS(3547),
    [anon_sym_extension] = ACTIONS(3547),
  },
  [896] = {
    [sym_identifier] = ACTIONS(3467),
    [aux_sym_preproc_include_token1] = ACTIONS(3467),
    [aux_sym_preproc_def_token1] = ACTIONS(3467),
    [aux_sym_preproc_if_token1] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3467),
    [sym_preproc_directive] = ACTIONS(3467),
    [anon_sym_LPAREN2] = ACTIONS(3469),
    [anon_sym_BANG] = ACTIONS(3469),
    [anon_sym_TILDE] = ACTIONS(3469),
    [anon_sym_DASH] = ACTIONS(3467),
    [anon_sym_PLUS] = ACTIONS(3467),
    [anon_sym_STAR] = ACTIONS(3469),
    [anon_sym_AMP_AMP] = ACTIONS(3469),
    [anon_sym_AMP] = ACTIONS(3467),
    [anon_sym_SEMI] = ACTIONS(3469),
    [anon_sym___extension__] = ACTIONS(3467),
    [anon_sym_typedef] = ACTIONS(3467),
    [anon_sym_in] = ACTIONS(3467),
    [anon_sym_out] = ACTIONS(3467),
    [anon_sym_inout] = ACTIONS(3467),
    [anon_sym_extern] = ACTIONS(3467),
    [anon_sym___attribute__] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(3469),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3469),
    [anon_sym___declspec] = ACTIONS(3467),
    [anon_sym___based] = ACTIONS(3467),
    [anon_sym___cdecl] = ACTIONS(3467),
    [anon_sym___clrcall] = ACTIONS(3467),
    [anon_sym___stdcall] = ACTIONS(3467),
    [anon_sym___fastcall] = ACTIONS(3467),
    [anon_sym___thiscall] = ACTIONS(3467),
    [anon_sym___vectorcall] = ACTIONS(3467),
    [anon_sym_LBRACE] = ACTIONS(3469),
    [anon_sym_RBRACE] = ACTIONS(3469),
    [anon_sym_signed] = ACTIONS(3467),
    [anon_sym_unsigned] = ACTIONS(3467),
    [anon_sym_long] = ACTIONS(3467),
    [anon_sym_short] = ACTIONS(3467),
    [anon_sym_LBRACK] = ACTIONS(3467),
    [anon_sym_static] = ACTIONS(3467),
    [anon_sym_register] = ACTIONS(3467),
    [anon_sym_inline] = ACTIONS(3467),
    [anon_sym___inline] = ACTIONS(3467),
    [anon_sym___inline__] = ACTIONS(3467),
    [anon_sym___forceinline] = ACTIONS(3467),
    [anon_sym_thread_local] = ACTIONS(3467),
    [anon_sym___thread] = ACTIONS(3467),
    [anon_sym_const] = ACTIONS(3467),
    [anon_sym_constexpr] = ACTIONS(3467),
    [anon_sym_volatile] = ACTIONS(3467),
    [anon_sym_restrict] = ACTIONS(3467),
    [anon_sym___restrict__] = ACTIONS(3467),
    [anon_sym__Atomic] = ACTIONS(3467),
    [anon_sym__Noreturn] = ACTIONS(3467),
    [anon_sym_noreturn] = ACTIONS(3467),
    [anon_sym_mutable] = ACTIONS(3467),
    [anon_sym_constinit] = ACTIONS(3467),
    [anon_sym_consteval] = ACTIONS(3467),
    [anon_sym_alignas] = ACTIONS(3467),
    [anon_sym__Alignas] = ACTIONS(3467),
    [sym_primitive_type] = ACTIONS(3467),
    [anon_sym_enum] = ACTIONS(3467),
    [anon_sym_class] = ACTIONS(3467),
    [anon_sym_struct] = ACTIONS(3467),
    [anon_sym_union] = ACTIONS(3467),
    [anon_sym_if] = ACTIONS(3467),
    [anon_sym_switch] = ACTIONS(3467),
    [anon_sym_case] = ACTIONS(3467),
    [anon_sym_default] = ACTIONS(3467),
    [anon_sym_while] = ACTIONS(3467),
    [anon_sym_do] = ACTIONS(3467),
    [anon_sym_for] = ACTIONS(3467),
    [anon_sym_return] = ACTIONS(3467),
    [anon_sym_break] = ACTIONS(3467),
    [anon_sym_continue] = ACTIONS(3467),
    [anon_sym_goto] = ACTIONS(3467),
    [anon_sym___try] = ACTIONS(3467),
    [anon_sym___leave] = ACTIONS(3467),
    [anon_sym_not] = ACTIONS(3467),
    [anon_sym_compl] = ACTIONS(3467),
    [anon_sym_DASH_DASH] = ACTIONS(3469),
    [anon_sym_PLUS_PLUS] = ACTIONS(3469),
    [anon_sym_sizeof] = ACTIONS(3467),
    [anon_sym___alignof__] = ACTIONS(3467),
    [anon_sym___alignof] = ACTIONS(3467),
    [anon_sym__alignof] = ACTIONS(3467),
    [anon_sym_alignof] = ACTIONS(3467),
    [anon_sym__Alignof] = ACTIONS(3467),
    [anon_sym_offsetof] = ACTIONS(3467),
    [anon_sym__Generic] = ACTIONS(3467),
    [anon_sym_asm] = ACTIONS(3467),
    [anon_sym___asm__] = ACTIONS(3467),
    [sym_number_literal] = ACTIONS(3469),
    [anon_sym_L_SQUOTE] = ACTIONS(3469),
    [anon_sym_u_SQUOTE] = ACTIONS(3469),
    [anon_sym_U_SQUOTE] = ACTIONS(3469),
    [anon_sym_u8_SQUOTE] = ACTIONS(3469),
    [anon_sym_SQUOTE] = ACTIONS(3469),
    [anon_sym_L_DQUOTE] = ACTIONS(3469),
    [anon_sym_u_DQUOTE] = ACTIONS(3469),
    [anon_sym_U_DQUOTE] = ACTIONS(3469),
    [anon_sym_u8_DQUOTE] = ACTIONS(3469),
    [anon_sym_DQUOTE] = ACTIONS(3469),
    [sym_true] = ACTIONS(3467),
    [sym_false] = ACTIONS(3467),
    [anon_sym_NULL] = ACTIONS(3467),
    [anon_sym_nullptr] = ACTIONS(3467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3467),
    [anon_sym_let] = ACTIONS(3467),
    [anon_sym_This] = ACTIONS(3467),
    [anon_sym_decltype] = ACTIONS(3467),
    [sym_virtual] = ACTIONS(3467),
    [anon_sym_explicit] = ACTIONS(3467),
    [anon_sym_typename] = ACTIONS(3467),
    [anon_sym_template] = ACTIONS(3467),
    [anon_sym_operator] = ACTIONS(3467),
    [anon_sym_try] = ACTIONS(3467),
    [anon_sym_delete] = ACTIONS(3467),
    [anon_sym_throw] = ACTIONS(3467),
    [anon_sym_namespace] = ACTIONS(3467),
    [anon_sym_using] = ACTIONS(3467),
    [anon_sym_static_assert] = ACTIONS(3467),
    [anon_sym_concept] = ACTIONS(3467),
    [anon_sym_co_return] = ACTIONS(3467),
    [anon_sym_co_yield] = ACTIONS(3467),
    [anon_sym_R_DQUOTE] = ACTIONS(3469),
    [anon_sym_LR_DQUOTE] = ACTIONS(3469),
    [anon_sym_uR_DQUOTE] = ACTIONS(3469),
    [anon_sym_UR_DQUOTE] = ACTIONS(3469),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3469),
    [anon_sym_co_await] = ACTIONS(3467),
    [anon_sym_new] = ACTIONS(3467),
    [anon_sym_requires] = ACTIONS(3467),
    [sym_this] = ACTIONS(3467),
    [anon_sym_discard] = ACTIONS(3467),
    [anon_sym_precise] = ACTIONS(3467),
    [anon_sym_shared] = ACTIONS(3467),
    [anon_sym_groupshared] = ACTIONS(3467),
    [anon_sym_uniform] = ACTIONS(3467),
    [anon_sym_row_major] = ACTIONS(3467),
    [anon_sym_column_major] = ACTIONS(3467),
    [anon_sym_globallycoherent] = ACTIONS(3467),
    [anon_sym_centroid] = ACTIONS(3467),
    [anon_sym_noperspective] = ACTIONS(3467),
    [anon_sym_nointerpolation] = ACTIONS(3467),
    [anon_sym_sample] = ACTIONS(3467),
    [anon_sym_linear] = ACTIONS(3467),
    [anon_sym_snorm] = ACTIONS(3467),
    [anon_sym_unorm] = ACTIONS(3467),
    [anon_sym_point] = ACTIONS(3467),
    [anon_sym_line] = ACTIONS(3467),
    [anon_sym_triangleadj] = ACTIONS(3467),
    [anon_sym_lineadj] = ACTIONS(3467),
    [anon_sym_triangle] = ACTIONS(3467),
    [anon_sym_cbuffer] = ACTIONS(3467),
    [anon_sym_interface] = ACTIONS(3467),
    [anon_sym_extension] = ACTIONS(3467),
  },
  [897] = {
    [sym_identifier] = ACTIONS(3555),
    [aux_sym_preproc_include_token1] = ACTIONS(3555),
    [aux_sym_preproc_def_token1] = ACTIONS(3555),
    [aux_sym_preproc_if_token1] = ACTIONS(3555),
    [aux_sym_preproc_if_token2] = ACTIONS(3555),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3555),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3555),
    [sym_preproc_directive] = ACTIONS(3555),
    [anon_sym_LPAREN2] = ACTIONS(3557),
    [anon_sym_BANG] = ACTIONS(3557),
    [anon_sym_TILDE] = ACTIONS(3557),
    [anon_sym_DASH] = ACTIONS(3555),
    [anon_sym_PLUS] = ACTIONS(3555),
    [anon_sym_STAR] = ACTIONS(3557),
    [anon_sym_AMP_AMP] = ACTIONS(3557),
    [anon_sym_AMP] = ACTIONS(3555),
    [anon_sym_SEMI] = ACTIONS(3557),
    [anon_sym___extension__] = ACTIONS(3555),
    [anon_sym_typedef] = ACTIONS(3555),
    [anon_sym_in] = ACTIONS(3555),
    [anon_sym_out] = ACTIONS(3555),
    [anon_sym_inout] = ACTIONS(3555),
    [anon_sym_extern] = ACTIONS(3555),
    [anon_sym___attribute__] = ACTIONS(3555),
    [anon_sym_COLON_COLON] = ACTIONS(3557),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3557),
    [anon_sym___declspec] = ACTIONS(3555),
    [anon_sym___based] = ACTIONS(3555),
    [anon_sym___cdecl] = ACTIONS(3555),
    [anon_sym___clrcall] = ACTIONS(3555),
    [anon_sym___stdcall] = ACTIONS(3555),
    [anon_sym___fastcall] = ACTIONS(3555),
    [anon_sym___thiscall] = ACTIONS(3555),
    [anon_sym___vectorcall] = ACTIONS(3555),
    [anon_sym_LBRACE] = ACTIONS(3557),
    [anon_sym_signed] = ACTIONS(3555),
    [anon_sym_unsigned] = ACTIONS(3555),
    [anon_sym_long] = ACTIONS(3555),
    [anon_sym_short] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3555),
    [anon_sym_static] = ACTIONS(3555),
    [anon_sym_register] = ACTIONS(3555),
    [anon_sym_inline] = ACTIONS(3555),
    [anon_sym___inline] = ACTIONS(3555),
    [anon_sym___inline__] = ACTIONS(3555),
    [anon_sym___forceinline] = ACTIONS(3555),
    [anon_sym_thread_local] = ACTIONS(3555),
    [anon_sym___thread] = ACTIONS(3555),
    [anon_sym_const] = ACTIONS(3555),
    [anon_sym_constexpr] = ACTIONS(3555),
    [anon_sym_volatile] = ACTIONS(3555),
    [anon_sym_restrict] = ACTIONS(3555),
    [anon_sym___restrict__] = ACTIONS(3555),
    [anon_sym__Atomic] = ACTIONS(3555),
    [anon_sym__Noreturn] = ACTIONS(3555),
    [anon_sym_noreturn] = ACTIONS(3555),
    [anon_sym_mutable] = ACTIONS(3555),
    [anon_sym_constinit] = ACTIONS(3555),
    [anon_sym_consteval] = ACTIONS(3555),
    [anon_sym_alignas] = ACTIONS(3555),
    [anon_sym__Alignas] = ACTIONS(3555),
    [sym_primitive_type] = ACTIONS(3555),
    [anon_sym_enum] = ACTIONS(3555),
    [anon_sym_class] = ACTIONS(3555),
    [anon_sym_struct] = ACTIONS(3555),
    [anon_sym_union] = ACTIONS(3555),
    [anon_sym_if] = ACTIONS(3555),
    [anon_sym_switch] = ACTIONS(3555),
    [anon_sym_case] = ACTIONS(3555),
    [anon_sym_default] = ACTIONS(3555),
    [anon_sym_while] = ACTIONS(3555),
    [anon_sym_do] = ACTIONS(3555),
    [anon_sym_for] = ACTIONS(3555),
    [anon_sym_return] = ACTIONS(3555),
    [anon_sym_break] = ACTIONS(3555),
    [anon_sym_continue] = ACTIONS(3555),
    [anon_sym_goto] = ACTIONS(3555),
    [anon_sym___try] = ACTIONS(3555),
    [anon_sym___leave] = ACTIONS(3555),
    [anon_sym_not] = ACTIONS(3555),
    [anon_sym_compl] = ACTIONS(3555),
    [anon_sym_DASH_DASH] = ACTIONS(3557),
    [anon_sym_PLUS_PLUS] = ACTIONS(3557),
    [anon_sym_sizeof] = ACTIONS(3555),
    [anon_sym___alignof__] = ACTIONS(3555),
    [anon_sym___alignof] = ACTIONS(3555),
    [anon_sym__alignof] = ACTIONS(3555),
    [anon_sym_alignof] = ACTIONS(3555),
    [anon_sym__Alignof] = ACTIONS(3555),
    [anon_sym_offsetof] = ACTIONS(3555),
    [anon_sym__Generic] = ACTIONS(3555),
    [anon_sym_asm] = ACTIONS(3555),
    [anon_sym___asm__] = ACTIONS(3555),
    [sym_number_literal] = ACTIONS(3557),
    [anon_sym_L_SQUOTE] = ACTIONS(3557),
    [anon_sym_u_SQUOTE] = ACTIONS(3557),
    [anon_sym_U_SQUOTE] = ACTIONS(3557),
    [anon_sym_u8_SQUOTE] = ACTIONS(3557),
    [anon_sym_SQUOTE] = ACTIONS(3557),
    [anon_sym_L_DQUOTE] = ACTIONS(3557),
    [anon_sym_u_DQUOTE] = ACTIONS(3557),
    [anon_sym_U_DQUOTE] = ACTIONS(3557),
    [anon_sym_u8_DQUOTE] = ACTIONS(3557),
    [anon_sym_DQUOTE] = ACTIONS(3557),
    [sym_true] = ACTIONS(3555),
    [sym_false] = ACTIONS(3555),
    [anon_sym_NULL] = ACTIONS(3555),
    [anon_sym_nullptr] = ACTIONS(3555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3555),
    [anon_sym_let] = ACTIONS(3555),
    [anon_sym_This] = ACTIONS(3555),
    [anon_sym_decltype] = ACTIONS(3555),
    [sym_virtual] = ACTIONS(3555),
    [anon_sym_explicit] = ACTIONS(3555),
    [anon_sym_typename] = ACTIONS(3555),
    [anon_sym_template] = ACTIONS(3555),
    [anon_sym_operator] = ACTIONS(3555),
    [anon_sym_try] = ACTIONS(3555),
    [anon_sym_delete] = ACTIONS(3555),
    [anon_sym_throw] = ACTIONS(3555),
    [anon_sym_namespace] = ACTIONS(3555),
    [anon_sym_using] = ACTIONS(3555),
    [anon_sym_static_assert] = ACTIONS(3555),
    [anon_sym_concept] = ACTIONS(3555),
    [anon_sym_co_return] = ACTIONS(3555),
    [anon_sym_co_yield] = ACTIONS(3555),
    [anon_sym_R_DQUOTE] = ACTIONS(3557),
    [anon_sym_LR_DQUOTE] = ACTIONS(3557),
    [anon_sym_uR_DQUOTE] = ACTIONS(3557),
    [anon_sym_UR_DQUOTE] = ACTIONS(3557),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3557),
    [anon_sym_co_await] = ACTIONS(3555),
    [anon_sym_new] = ACTIONS(3555),
    [anon_sym_requires] = ACTIONS(3555),
    [sym_this] = ACTIONS(3555),
    [anon_sym_discard] = ACTIONS(3555),
    [anon_sym_precise] = ACTIONS(3555),
    [anon_sym_shared] = ACTIONS(3555),
    [anon_sym_groupshared] = ACTIONS(3555),
    [anon_sym_uniform] = ACTIONS(3555),
    [anon_sym_row_major] = ACTIONS(3555),
    [anon_sym_column_major] = ACTIONS(3555),
    [anon_sym_globallycoherent] = ACTIONS(3555),
    [anon_sym_centroid] = ACTIONS(3555),
    [anon_sym_noperspective] = ACTIONS(3555),
    [anon_sym_nointerpolation] = ACTIONS(3555),
    [anon_sym_sample] = ACTIONS(3555),
    [anon_sym_linear] = ACTIONS(3555),
    [anon_sym_snorm] = ACTIONS(3555),
    [anon_sym_unorm] = ACTIONS(3555),
    [anon_sym_point] = ACTIONS(3555),
    [anon_sym_line] = ACTIONS(3555),
    [anon_sym_triangleadj] = ACTIONS(3555),
    [anon_sym_lineadj] = ACTIONS(3555),
    [anon_sym_triangle] = ACTIONS(3555),
    [anon_sym_cbuffer] = ACTIONS(3555),
    [anon_sym_interface] = ACTIONS(3555),
    [anon_sym_extension] = ACTIONS(3555),
  },
  [898] = {
    [sym_identifier] = ACTIONS(3471),
    [aux_sym_preproc_include_token1] = ACTIONS(3471),
    [aux_sym_preproc_def_token1] = ACTIONS(3471),
    [aux_sym_preproc_if_token1] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3471),
    [sym_preproc_directive] = ACTIONS(3471),
    [anon_sym_LPAREN2] = ACTIONS(3473),
    [anon_sym_BANG] = ACTIONS(3473),
    [anon_sym_TILDE] = ACTIONS(3473),
    [anon_sym_DASH] = ACTIONS(3471),
    [anon_sym_PLUS] = ACTIONS(3471),
    [anon_sym_STAR] = ACTIONS(3473),
    [anon_sym_AMP_AMP] = ACTIONS(3473),
    [anon_sym_AMP] = ACTIONS(3471),
    [anon_sym_SEMI] = ACTIONS(3473),
    [anon_sym___extension__] = ACTIONS(3471),
    [anon_sym_typedef] = ACTIONS(3471),
    [anon_sym_in] = ACTIONS(3471),
    [anon_sym_out] = ACTIONS(3471),
    [anon_sym_inout] = ACTIONS(3471),
    [anon_sym_extern] = ACTIONS(3471),
    [anon_sym___attribute__] = ACTIONS(3471),
    [anon_sym_COLON_COLON] = ACTIONS(3473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3473),
    [anon_sym___declspec] = ACTIONS(3471),
    [anon_sym___based] = ACTIONS(3471),
    [anon_sym___cdecl] = ACTIONS(3471),
    [anon_sym___clrcall] = ACTIONS(3471),
    [anon_sym___stdcall] = ACTIONS(3471),
    [anon_sym___fastcall] = ACTIONS(3471),
    [anon_sym___thiscall] = ACTIONS(3471),
    [anon_sym___vectorcall] = ACTIONS(3471),
    [anon_sym_LBRACE] = ACTIONS(3473),
    [anon_sym_RBRACE] = ACTIONS(3473),
    [anon_sym_signed] = ACTIONS(3471),
    [anon_sym_unsigned] = ACTIONS(3471),
    [anon_sym_long] = ACTIONS(3471),
    [anon_sym_short] = ACTIONS(3471),
    [anon_sym_LBRACK] = ACTIONS(3471),
    [anon_sym_static] = ACTIONS(3471),
    [anon_sym_register] = ACTIONS(3471),
    [anon_sym_inline] = ACTIONS(3471),
    [anon_sym___inline] = ACTIONS(3471),
    [anon_sym___inline__] = ACTIONS(3471),
    [anon_sym___forceinline] = ACTIONS(3471),
    [anon_sym_thread_local] = ACTIONS(3471),
    [anon_sym___thread] = ACTIONS(3471),
    [anon_sym_const] = ACTIONS(3471),
    [anon_sym_constexpr] = ACTIONS(3471),
    [anon_sym_volatile] = ACTIONS(3471),
    [anon_sym_restrict] = ACTIONS(3471),
    [anon_sym___restrict__] = ACTIONS(3471),
    [anon_sym__Atomic] = ACTIONS(3471),
    [anon_sym__Noreturn] = ACTIONS(3471),
    [anon_sym_noreturn] = ACTIONS(3471),
    [anon_sym_mutable] = ACTIONS(3471),
    [anon_sym_constinit] = ACTIONS(3471),
    [anon_sym_consteval] = ACTIONS(3471),
    [anon_sym_alignas] = ACTIONS(3471),
    [anon_sym__Alignas] = ACTIONS(3471),
    [sym_primitive_type] = ACTIONS(3471),
    [anon_sym_enum] = ACTIONS(3471),
    [anon_sym_class] = ACTIONS(3471),
    [anon_sym_struct] = ACTIONS(3471),
    [anon_sym_union] = ACTIONS(3471),
    [anon_sym_if] = ACTIONS(3471),
    [anon_sym_switch] = ACTIONS(3471),
    [anon_sym_case] = ACTIONS(3471),
    [anon_sym_default] = ACTIONS(3471),
    [anon_sym_while] = ACTIONS(3471),
    [anon_sym_do] = ACTIONS(3471),
    [anon_sym_for] = ACTIONS(3471),
    [anon_sym_return] = ACTIONS(3471),
    [anon_sym_break] = ACTIONS(3471),
    [anon_sym_continue] = ACTIONS(3471),
    [anon_sym_goto] = ACTIONS(3471),
    [anon_sym___try] = ACTIONS(3471),
    [anon_sym___leave] = ACTIONS(3471),
    [anon_sym_not] = ACTIONS(3471),
    [anon_sym_compl] = ACTIONS(3471),
    [anon_sym_DASH_DASH] = ACTIONS(3473),
    [anon_sym_PLUS_PLUS] = ACTIONS(3473),
    [anon_sym_sizeof] = ACTIONS(3471),
    [anon_sym___alignof__] = ACTIONS(3471),
    [anon_sym___alignof] = ACTIONS(3471),
    [anon_sym__alignof] = ACTIONS(3471),
    [anon_sym_alignof] = ACTIONS(3471),
    [anon_sym__Alignof] = ACTIONS(3471),
    [anon_sym_offsetof] = ACTIONS(3471),
    [anon_sym__Generic] = ACTIONS(3471),
    [anon_sym_asm] = ACTIONS(3471),
    [anon_sym___asm__] = ACTIONS(3471),
    [sym_number_literal] = ACTIONS(3473),
    [anon_sym_L_SQUOTE] = ACTIONS(3473),
    [anon_sym_u_SQUOTE] = ACTIONS(3473),
    [anon_sym_U_SQUOTE] = ACTIONS(3473),
    [anon_sym_u8_SQUOTE] = ACTIONS(3473),
    [anon_sym_SQUOTE] = ACTIONS(3473),
    [anon_sym_L_DQUOTE] = ACTIONS(3473),
    [anon_sym_u_DQUOTE] = ACTIONS(3473),
    [anon_sym_U_DQUOTE] = ACTIONS(3473),
    [anon_sym_u8_DQUOTE] = ACTIONS(3473),
    [anon_sym_DQUOTE] = ACTIONS(3473),
    [sym_true] = ACTIONS(3471),
    [sym_false] = ACTIONS(3471),
    [anon_sym_NULL] = ACTIONS(3471),
    [anon_sym_nullptr] = ACTIONS(3471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3471),
    [anon_sym_let] = ACTIONS(3471),
    [anon_sym_This] = ACTIONS(3471),
    [anon_sym_decltype] = ACTIONS(3471),
    [sym_virtual] = ACTIONS(3471),
    [anon_sym_explicit] = ACTIONS(3471),
    [anon_sym_typename] = ACTIONS(3471),
    [anon_sym_template] = ACTIONS(3471),
    [anon_sym_operator] = ACTIONS(3471),
    [anon_sym_try] = ACTIONS(3471),
    [anon_sym_delete] = ACTIONS(3471),
    [anon_sym_throw] = ACTIONS(3471),
    [anon_sym_namespace] = ACTIONS(3471),
    [anon_sym_using] = ACTIONS(3471),
    [anon_sym_static_assert] = ACTIONS(3471),
    [anon_sym_concept] = ACTIONS(3471),
    [anon_sym_co_return] = ACTIONS(3471),
    [anon_sym_co_yield] = ACTIONS(3471),
    [anon_sym_R_DQUOTE] = ACTIONS(3473),
    [anon_sym_LR_DQUOTE] = ACTIONS(3473),
    [anon_sym_uR_DQUOTE] = ACTIONS(3473),
    [anon_sym_UR_DQUOTE] = ACTIONS(3473),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3473),
    [anon_sym_co_await] = ACTIONS(3471),
    [anon_sym_new] = ACTIONS(3471),
    [anon_sym_requires] = ACTIONS(3471),
    [sym_this] = ACTIONS(3471),
    [anon_sym_discard] = ACTIONS(3471),
    [anon_sym_precise] = ACTIONS(3471),
    [anon_sym_shared] = ACTIONS(3471),
    [anon_sym_groupshared] = ACTIONS(3471),
    [anon_sym_uniform] = ACTIONS(3471),
    [anon_sym_row_major] = ACTIONS(3471),
    [anon_sym_column_major] = ACTIONS(3471),
    [anon_sym_globallycoherent] = ACTIONS(3471),
    [anon_sym_centroid] = ACTIONS(3471),
    [anon_sym_noperspective] = ACTIONS(3471),
    [anon_sym_nointerpolation] = ACTIONS(3471),
    [anon_sym_sample] = ACTIONS(3471),
    [anon_sym_linear] = ACTIONS(3471),
    [anon_sym_snorm] = ACTIONS(3471),
    [anon_sym_unorm] = ACTIONS(3471),
    [anon_sym_point] = ACTIONS(3471),
    [anon_sym_line] = ACTIONS(3471),
    [anon_sym_triangleadj] = ACTIONS(3471),
    [anon_sym_lineadj] = ACTIONS(3471),
    [anon_sym_triangle] = ACTIONS(3471),
    [anon_sym_cbuffer] = ACTIONS(3471),
    [anon_sym_interface] = ACTIONS(3471),
    [anon_sym_extension] = ACTIONS(3471),
  },
  [899] = {
    [sym_identifier] = ACTIONS(3489),
    [aux_sym_preproc_include_token1] = ACTIONS(3489),
    [aux_sym_preproc_def_token1] = ACTIONS(3489),
    [aux_sym_preproc_if_token1] = ACTIONS(3489),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3489),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3489),
    [sym_preproc_directive] = ACTIONS(3489),
    [anon_sym_LPAREN2] = ACTIONS(3491),
    [anon_sym_BANG] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(3489),
    [anon_sym_PLUS] = ACTIONS(3489),
    [anon_sym_STAR] = ACTIONS(3491),
    [anon_sym_AMP_AMP] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3489),
    [anon_sym_SEMI] = ACTIONS(3491),
    [anon_sym___extension__] = ACTIONS(3489),
    [anon_sym_typedef] = ACTIONS(3489),
    [anon_sym_in] = ACTIONS(3489),
    [anon_sym_out] = ACTIONS(3489),
    [anon_sym_inout] = ACTIONS(3489),
    [anon_sym_extern] = ACTIONS(3489),
    [anon_sym___attribute__] = ACTIONS(3489),
    [anon_sym_COLON_COLON] = ACTIONS(3491),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3491),
    [anon_sym___declspec] = ACTIONS(3489),
    [anon_sym___based] = ACTIONS(3489),
    [anon_sym___cdecl] = ACTIONS(3489),
    [anon_sym___clrcall] = ACTIONS(3489),
    [anon_sym___stdcall] = ACTIONS(3489),
    [anon_sym___fastcall] = ACTIONS(3489),
    [anon_sym___thiscall] = ACTIONS(3489),
    [anon_sym___vectorcall] = ACTIONS(3489),
    [anon_sym_LBRACE] = ACTIONS(3491),
    [anon_sym_RBRACE] = ACTIONS(3491),
    [anon_sym_signed] = ACTIONS(3489),
    [anon_sym_unsigned] = ACTIONS(3489),
    [anon_sym_long] = ACTIONS(3489),
    [anon_sym_short] = ACTIONS(3489),
    [anon_sym_LBRACK] = ACTIONS(3489),
    [anon_sym_static] = ACTIONS(3489),
    [anon_sym_register] = ACTIONS(3489),
    [anon_sym_inline] = ACTIONS(3489),
    [anon_sym___inline] = ACTIONS(3489),
    [anon_sym___inline__] = ACTIONS(3489),
    [anon_sym___forceinline] = ACTIONS(3489),
    [anon_sym_thread_local] = ACTIONS(3489),
    [anon_sym___thread] = ACTIONS(3489),
    [anon_sym_const] = ACTIONS(3489),
    [anon_sym_constexpr] = ACTIONS(3489),
    [anon_sym_volatile] = ACTIONS(3489),
    [anon_sym_restrict] = ACTIONS(3489),
    [anon_sym___restrict__] = ACTIONS(3489),
    [anon_sym__Atomic] = ACTIONS(3489),
    [anon_sym__Noreturn] = ACTIONS(3489),
    [anon_sym_noreturn] = ACTIONS(3489),
    [anon_sym_mutable] = ACTIONS(3489),
    [anon_sym_constinit] = ACTIONS(3489),
    [anon_sym_consteval] = ACTIONS(3489),
    [anon_sym_alignas] = ACTIONS(3489),
    [anon_sym__Alignas] = ACTIONS(3489),
    [sym_primitive_type] = ACTIONS(3489),
    [anon_sym_enum] = ACTIONS(3489),
    [anon_sym_class] = ACTIONS(3489),
    [anon_sym_struct] = ACTIONS(3489),
    [anon_sym_union] = ACTIONS(3489),
    [anon_sym_if] = ACTIONS(3489),
    [anon_sym_switch] = ACTIONS(3489),
    [anon_sym_case] = ACTIONS(3489),
    [anon_sym_default] = ACTIONS(3489),
    [anon_sym_while] = ACTIONS(3489),
    [anon_sym_do] = ACTIONS(3489),
    [anon_sym_for] = ACTIONS(3489),
    [anon_sym_return] = ACTIONS(3489),
    [anon_sym_break] = ACTIONS(3489),
    [anon_sym_continue] = ACTIONS(3489),
    [anon_sym_goto] = ACTIONS(3489),
    [anon_sym___try] = ACTIONS(3489),
    [anon_sym___leave] = ACTIONS(3489),
    [anon_sym_not] = ACTIONS(3489),
    [anon_sym_compl] = ACTIONS(3489),
    [anon_sym_DASH_DASH] = ACTIONS(3491),
    [anon_sym_PLUS_PLUS] = ACTIONS(3491),
    [anon_sym_sizeof] = ACTIONS(3489),
    [anon_sym___alignof__] = ACTIONS(3489),
    [anon_sym___alignof] = ACTIONS(3489),
    [anon_sym__alignof] = ACTIONS(3489),
    [anon_sym_alignof] = ACTIONS(3489),
    [anon_sym__Alignof] = ACTIONS(3489),
    [anon_sym_offsetof] = ACTIONS(3489),
    [anon_sym__Generic] = ACTIONS(3489),
    [anon_sym_asm] = ACTIONS(3489),
    [anon_sym___asm__] = ACTIONS(3489),
    [sym_number_literal] = ACTIONS(3491),
    [anon_sym_L_SQUOTE] = ACTIONS(3491),
    [anon_sym_u_SQUOTE] = ACTIONS(3491),
    [anon_sym_U_SQUOTE] = ACTIONS(3491),
    [anon_sym_u8_SQUOTE] = ACTIONS(3491),
    [anon_sym_SQUOTE] = ACTIONS(3491),
    [anon_sym_L_DQUOTE] = ACTIONS(3491),
    [anon_sym_u_DQUOTE] = ACTIONS(3491),
    [anon_sym_U_DQUOTE] = ACTIONS(3491),
    [anon_sym_u8_DQUOTE] = ACTIONS(3491),
    [anon_sym_DQUOTE] = ACTIONS(3491),
    [sym_true] = ACTIONS(3489),
    [sym_false] = ACTIONS(3489),
    [anon_sym_NULL] = ACTIONS(3489),
    [anon_sym_nullptr] = ACTIONS(3489),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3489),
    [anon_sym_let] = ACTIONS(3489),
    [anon_sym_This] = ACTIONS(3489),
    [anon_sym_decltype] = ACTIONS(3489),
    [sym_virtual] = ACTIONS(3489),
    [anon_sym_explicit] = ACTIONS(3489),
    [anon_sym_typename] = ACTIONS(3489),
    [anon_sym_template] = ACTIONS(3489),
    [anon_sym_operator] = ACTIONS(3489),
    [anon_sym_try] = ACTIONS(3489),
    [anon_sym_delete] = ACTIONS(3489),
    [anon_sym_throw] = ACTIONS(3489),
    [anon_sym_namespace] = ACTIONS(3489),
    [anon_sym_using] = ACTIONS(3489),
    [anon_sym_static_assert] = ACTIONS(3489),
    [anon_sym_concept] = ACTIONS(3489),
    [anon_sym_co_return] = ACTIONS(3489),
    [anon_sym_co_yield] = ACTIONS(3489),
    [anon_sym_R_DQUOTE] = ACTIONS(3491),
    [anon_sym_LR_DQUOTE] = ACTIONS(3491),
    [anon_sym_uR_DQUOTE] = ACTIONS(3491),
    [anon_sym_UR_DQUOTE] = ACTIONS(3491),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3491),
    [anon_sym_co_await] = ACTIONS(3489),
    [anon_sym_new] = ACTIONS(3489),
    [anon_sym_requires] = ACTIONS(3489),
    [sym_this] = ACTIONS(3489),
    [anon_sym_discard] = ACTIONS(3489),
    [anon_sym_precise] = ACTIONS(3489),
    [anon_sym_shared] = ACTIONS(3489),
    [anon_sym_groupshared] = ACTIONS(3489),
    [anon_sym_uniform] = ACTIONS(3489),
    [anon_sym_row_major] = ACTIONS(3489),
    [anon_sym_column_major] = ACTIONS(3489),
    [anon_sym_globallycoherent] = ACTIONS(3489),
    [anon_sym_centroid] = ACTIONS(3489),
    [anon_sym_noperspective] = ACTIONS(3489),
    [anon_sym_nointerpolation] = ACTIONS(3489),
    [anon_sym_sample] = ACTIONS(3489),
    [anon_sym_linear] = ACTIONS(3489),
    [anon_sym_snorm] = ACTIONS(3489),
    [anon_sym_unorm] = ACTIONS(3489),
    [anon_sym_point] = ACTIONS(3489),
    [anon_sym_line] = ACTIONS(3489),
    [anon_sym_triangleadj] = ACTIONS(3489),
    [anon_sym_lineadj] = ACTIONS(3489),
    [anon_sym_triangle] = ACTIONS(3489),
    [anon_sym_cbuffer] = ACTIONS(3489),
    [anon_sym_interface] = ACTIONS(3489),
    [anon_sym_extension] = ACTIONS(3489),
  },
  [900] = {
    [sym_catch_clause] = STATE(290),
    [aux_sym_constructor_try_statement_repeat1] = STATE(290),
    [ts_builtin_sym_end] = ACTIONS(2746),
    [sym_identifier] = ACTIONS(2744),
    [aux_sym_preproc_include_token1] = ACTIONS(2744),
    [aux_sym_preproc_def_token1] = ACTIONS(2744),
    [aux_sym_preproc_if_token1] = ACTIONS(2744),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2744),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2744),
    [sym_preproc_directive] = ACTIONS(2744),
    [anon_sym_LPAREN2] = ACTIONS(2746),
    [anon_sym_BANG] = ACTIONS(2746),
    [anon_sym_TILDE] = ACTIONS(2746),
    [anon_sym_DASH] = ACTIONS(2744),
    [anon_sym_PLUS] = ACTIONS(2744),
    [anon_sym_STAR] = ACTIONS(2746),
    [anon_sym_AMP_AMP] = ACTIONS(2746),
    [anon_sym_AMP] = ACTIONS(2744),
    [anon_sym___extension__] = ACTIONS(2744),
    [anon_sym_typedef] = ACTIONS(2744),
    [anon_sym_in] = ACTIONS(2744),
    [anon_sym_out] = ACTIONS(2744),
    [anon_sym_inout] = ACTIONS(2744),
    [anon_sym_extern] = ACTIONS(2744),
    [anon_sym___attribute__] = ACTIONS(2744),
    [anon_sym_COLON_COLON] = ACTIONS(2746),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2746),
    [anon_sym___declspec] = ACTIONS(2744),
    [anon_sym___based] = ACTIONS(2744),
    [anon_sym___cdecl] = ACTIONS(2744),
    [anon_sym___clrcall] = ACTIONS(2744),
    [anon_sym___stdcall] = ACTIONS(2744),
    [anon_sym___fastcall] = ACTIONS(2744),
    [anon_sym___thiscall] = ACTIONS(2744),
    [anon_sym___vectorcall] = ACTIONS(2744),
    [anon_sym_LBRACE] = ACTIONS(2746),
    [anon_sym_signed] = ACTIONS(2744),
    [anon_sym_unsigned] = ACTIONS(2744),
    [anon_sym_long] = ACTIONS(2744),
    [anon_sym_short] = ACTIONS(2744),
    [anon_sym_LBRACK] = ACTIONS(2744),
    [anon_sym_static] = ACTIONS(2744),
    [anon_sym_register] = ACTIONS(2744),
    [anon_sym_inline] = ACTIONS(2744),
    [anon_sym___inline] = ACTIONS(2744),
    [anon_sym___inline__] = ACTIONS(2744),
    [anon_sym___forceinline] = ACTIONS(2744),
    [anon_sym_thread_local] = ACTIONS(2744),
    [anon_sym___thread] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_constexpr] = ACTIONS(2744),
    [anon_sym_volatile] = ACTIONS(2744),
    [anon_sym_restrict] = ACTIONS(2744),
    [anon_sym___restrict__] = ACTIONS(2744),
    [anon_sym__Atomic] = ACTIONS(2744),
    [anon_sym__Noreturn] = ACTIONS(2744),
    [anon_sym_noreturn] = ACTIONS(2744),
    [anon_sym_mutable] = ACTIONS(2744),
    [anon_sym_constinit] = ACTIONS(2744),
    [anon_sym_consteval] = ACTIONS(2744),
    [anon_sym_alignas] = ACTIONS(2744),
    [anon_sym__Alignas] = ACTIONS(2744),
    [sym_primitive_type] = ACTIONS(2744),
    [anon_sym_enum] = ACTIONS(2744),
    [anon_sym_class] = ACTIONS(2744),
    [anon_sym_struct] = ACTIONS(2744),
    [anon_sym_union] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2744),
    [anon_sym_switch] = ACTIONS(2744),
    [anon_sym_case] = ACTIONS(2744),
    [anon_sym_default] = ACTIONS(2744),
    [anon_sym_while] = ACTIONS(2744),
    [anon_sym_do] = ACTIONS(2744),
    [anon_sym_for] = ACTIONS(2744),
    [anon_sym_return] = ACTIONS(2744),
    [anon_sym_break] = ACTIONS(2744),
    [anon_sym_continue] = ACTIONS(2744),
    [anon_sym_goto] = ACTIONS(2744),
    [anon_sym_not] = ACTIONS(2744),
    [anon_sym_compl] = ACTIONS(2744),
    [anon_sym_DASH_DASH] = ACTIONS(2746),
    [anon_sym_PLUS_PLUS] = ACTIONS(2746),
    [anon_sym_sizeof] = ACTIONS(2744),
    [anon_sym___alignof__] = ACTIONS(2744),
    [anon_sym___alignof] = ACTIONS(2744),
    [anon_sym__alignof] = ACTIONS(2744),
    [anon_sym_alignof] = ACTIONS(2744),
    [anon_sym__Alignof] = ACTIONS(2744),
    [anon_sym_offsetof] = ACTIONS(2744),
    [anon_sym__Generic] = ACTIONS(2744),
    [anon_sym_asm] = ACTIONS(2744),
    [anon_sym___asm__] = ACTIONS(2744),
    [sym_number_literal] = ACTIONS(2746),
    [anon_sym_L_SQUOTE] = ACTIONS(2746),
    [anon_sym_u_SQUOTE] = ACTIONS(2746),
    [anon_sym_U_SQUOTE] = ACTIONS(2746),
    [anon_sym_u8_SQUOTE] = ACTIONS(2746),
    [anon_sym_SQUOTE] = ACTIONS(2746),
    [anon_sym_L_DQUOTE] = ACTIONS(2746),
    [anon_sym_u_DQUOTE] = ACTIONS(2746),
    [anon_sym_U_DQUOTE] = ACTIONS(2746),
    [anon_sym_u8_DQUOTE] = ACTIONS(2746),
    [anon_sym_DQUOTE] = ACTIONS(2746),
    [sym_true] = ACTIONS(2744),
    [sym_false] = ACTIONS(2744),
    [anon_sym_NULL] = ACTIONS(2744),
    [anon_sym_nullptr] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2744),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_This] = ACTIONS(2744),
    [anon_sym_decltype] = ACTIONS(2744),
    [sym_virtual] = ACTIONS(2744),
    [anon_sym_explicit] = ACTIONS(2744),
    [anon_sym_typename] = ACTIONS(2744),
    [anon_sym_template] = ACTIONS(2744),
    [anon_sym_operator] = ACTIONS(2744),
    [anon_sym_try] = ACTIONS(2744),
    [anon_sym_delete] = ACTIONS(2744),
    [anon_sym_throw] = ACTIONS(2744),
    [anon_sym_namespace] = ACTIONS(2744),
    [anon_sym_using] = ACTIONS(2744),
    [anon_sym_static_assert] = ACTIONS(2744),
    [anon_sym_concept] = ACTIONS(2744),
    [anon_sym_co_return] = ACTIONS(2744),
    [anon_sym_co_yield] = ACTIONS(2744),
    [anon_sym_catch] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2746),
    [anon_sym_LR_DQUOTE] = ACTIONS(2746),
    [anon_sym_uR_DQUOTE] = ACTIONS(2746),
    [anon_sym_UR_DQUOTE] = ACTIONS(2746),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2746),
    [anon_sym_co_await] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(2744),
    [anon_sym_requires] = ACTIONS(2744),
    [sym_this] = ACTIONS(2744),
    [anon_sym_precise] = ACTIONS(2744),
    [anon_sym_shared] = ACTIONS(2744),
    [anon_sym_groupshared] = ACTIONS(2744),
    [anon_sym_uniform] = ACTIONS(2744),
    [anon_sym_row_major] = ACTIONS(2744),
    [anon_sym_column_major] = ACTIONS(2744),
    [anon_sym_globallycoherent] = ACTIONS(2744),
    [anon_sym_centroid] = ACTIONS(2744),
    [anon_sym_noperspective] = ACTIONS(2744),
    [anon_sym_nointerpolation] = ACTIONS(2744),
    [anon_sym_sample] = ACTIONS(2744),
    [anon_sym_linear] = ACTIONS(2744),
    [anon_sym_snorm] = ACTIONS(2744),
    [anon_sym_unorm] = ACTIONS(2744),
    [anon_sym_point] = ACTIONS(2744),
    [anon_sym_line] = ACTIONS(2744),
    [anon_sym_triangleadj] = ACTIONS(2744),
    [anon_sym_lineadj] = ACTIONS(2744),
    [anon_sym_triangle] = ACTIONS(2744),
    [anon_sym_interface] = ACTIONS(2744),
    [anon_sym_extension] = ACTIONS(2744),
    [anon_sym___exported] = ACTIONS(2744),
    [anon_sym_import] = ACTIONS(2744),
  },
  [901] = {
    [sym_identifier] = ACTIONS(3629),
    [aux_sym_preproc_include_token1] = ACTIONS(3629),
    [aux_sym_preproc_def_token1] = ACTIONS(3629),
    [aux_sym_preproc_if_token1] = ACTIONS(3629),
    [aux_sym_preproc_if_token2] = ACTIONS(3629),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3629),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3629),
    [sym_preproc_directive] = ACTIONS(3629),
    [anon_sym_LPAREN2] = ACTIONS(3631),
    [anon_sym_BANG] = ACTIONS(3631),
    [anon_sym_TILDE] = ACTIONS(3631),
    [anon_sym_DASH] = ACTIONS(3629),
    [anon_sym_PLUS] = ACTIONS(3629),
    [anon_sym_STAR] = ACTIONS(3631),
    [anon_sym_AMP_AMP] = ACTIONS(3631),
    [anon_sym_AMP] = ACTIONS(3629),
    [anon_sym_SEMI] = ACTIONS(3631),
    [anon_sym___extension__] = ACTIONS(3629),
    [anon_sym_typedef] = ACTIONS(3629),
    [anon_sym_in] = ACTIONS(3629),
    [anon_sym_out] = ACTIONS(3629),
    [anon_sym_inout] = ACTIONS(3629),
    [anon_sym_extern] = ACTIONS(3629),
    [anon_sym___attribute__] = ACTIONS(3629),
    [anon_sym_COLON_COLON] = ACTIONS(3631),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3631),
    [anon_sym___declspec] = ACTIONS(3629),
    [anon_sym___based] = ACTIONS(3629),
    [anon_sym___cdecl] = ACTIONS(3629),
    [anon_sym___clrcall] = ACTIONS(3629),
    [anon_sym___stdcall] = ACTIONS(3629),
    [anon_sym___fastcall] = ACTIONS(3629),
    [anon_sym___thiscall] = ACTIONS(3629),
    [anon_sym___vectorcall] = ACTIONS(3629),
    [anon_sym_LBRACE] = ACTIONS(3631),
    [anon_sym_signed] = ACTIONS(3629),
    [anon_sym_unsigned] = ACTIONS(3629),
    [anon_sym_long] = ACTIONS(3629),
    [anon_sym_short] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3629),
    [anon_sym_static] = ACTIONS(3629),
    [anon_sym_register] = ACTIONS(3629),
    [anon_sym_inline] = ACTIONS(3629),
    [anon_sym___inline] = ACTIONS(3629),
    [anon_sym___inline__] = ACTIONS(3629),
    [anon_sym___forceinline] = ACTIONS(3629),
    [anon_sym_thread_local] = ACTIONS(3629),
    [anon_sym___thread] = ACTIONS(3629),
    [anon_sym_const] = ACTIONS(3629),
    [anon_sym_constexpr] = ACTIONS(3629),
    [anon_sym_volatile] = ACTIONS(3629),
    [anon_sym_restrict] = ACTIONS(3629),
    [anon_sym___restrict__] = ACTIONS(3629),
    [anon_sym__Atomic] = ACTIONS(3629),
    [anon_sym__Noreturn] = ACTIONS(3629),
    [anon_sym_noreturn] = ACTIONS(3629),
    [anon_sym_mutable] = ACTIONS(3629),
    [anon_sym_constinit] = ACTIONS(3629),
    [anon_sym_consteval] = ACTIONS(3629),
    [anon_sym_alignas] = ACTIONS(3629),
    [anon_sym__Alignas] = ACTIONS(3629),
    [sym_primitive_type] = ACTIONS(3629),
    [anon_sym_enum] = ACTIONS(3629),
    [anon_sym_class] = ACTIONS(3629),
    [anon_sym_struct] = ACTIONS(3629),
    [anon_sym_union] = ACTIONS(3629),
    [anon_sym_if] = ACTIONS(3629),
    [anon_sym_switch] = ACTIONS(3629),
    [anon_sym_case] = ACTIONS(3629),
    [anon_sym_default] = ACTIONS(3629),
    [anon_sym_while] = ACTIONS(3629),
    [anon_sym_do] = ACTIONS(3629),
    [anon_sym_for] = ACTIONS(3629),
    [anon_sym_return] = ACTIONS(3629),
    [anon_sym_break] = ACTIONS(3629),
    [anon_sym_continue] = ACTIONS(3629),
    [anon_sym_goto] = ACTIONS(3629),
    [anon_sym___try] = ACTIONS(3629),
    [anon_sym___leave] = ACTIONS(3629),
    [anon_sym_not] = ACTIONS(3629),
    [anon_sym_compl] = ACTIONS(3629),
    [anon_sym_DASH_DASH] = ACTIONS(3631),
    [anon_sym_PLUS_PLUS] = ACTIONS(3631),
    [anon_sym_sizeof] = ACTIONS(3629),
    [anon_sym___alignof__] = ACTIONS(3629),
    [anon_sym___alignof] = ACTIONS(3629),
    [anon_sym__alignof] = ACTIONS(3629),
    [anon_sym_alignof] = ACTIONS(3629),
    [anon_sym__Alignof] = ACTIONS(3629),
    [anon_sym_offsetof] = ACTIONS(3629),
    [anon_sym__Generic] = ACTIONS(3629),
    [anon_sym_asm] = ACTIONS(3629),
    [anon_sym___asm__] = ACTIONS(3629),
    [sym_number_literal] = ACTIONS(3631),
    [anon_sym_L_SQUOTE] = ACTIONS(3631),
    [anon_sym_u_SQUOTE] = ACTIONS(3631),
    [anon_sym_U_SQUOTE] = ACTIONS(3631),
    [anon_sym_u8_SQUOTE] = ACTIONS(3631),
    [anon_sym_SQUOTE] = ACTIONS(3631),
    [anon_sym_L_DQUOTE] = ACTIONS(3631),
    [anon_sym_u_DQUOTE] = ACTIONS(3631),
    [anon_sym_U_DQUOTE] = ACTIONS(3631),
    [anon_sym_u8_DQUOTE] = ACTIONS(3631),
    [anon_sym_DQUOTE] = ACTIONS(3631),
    [sym_true] = ACTIONS(3629),
    [sym_false] = ACTIONS(3629),
    [anon_sym_NULL] = ACTIONS(3629),
    [anon_sym_nullptr] = ACTIONS(3629),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3629),
    [anon_sym_let] = ACTIONS(3629),
    [anon_sym_This] = ACTIONS(3629),
    [anon_sym_decltype] = ACTIONS(3629),
    [sym_virtual] = ACTIONS(3629),
    [anon_sym_explicit] = ACTIONS(3629),
    [anon_sym_typename] = ACTIONS(3629),
    [anon_sym_template] = ACTIONS(3629),
    [anon_sym_operator] = ACTIONS(3629),
    [anon_sym_try] = ACTIONS(3629),
    [anon_sym_delete] = ACTIONS(3629),
    [anon_sym_throw] = ACTIONS(3629),
    [anon_sym_namespace] = ACTIONS(3629),
    [anon_sym_using] = ACTIONS(3629),
    [anon_sym_static_assert] = ACTIONS(3629),
    [anon_sym_concept] = ACTIONS(3629),
    [anon_sym_co_return] = ACTIONS(3629),
    [anon_sym_co_yield] = ACTIONS(3629),
    [anon_sym_R_DQUOTE] = ACTIONS(3631),
    [anon_sym_LR_DQUOTE] = ACTIONS(3631),
    [anon_sym_uR_DQUOTE] = ACTIONS(3631),
    [anon_sym_UR_DQUOTE] = ACTIONS(3631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3631),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3629),
    [anon_sym_requires] = ACTIONS(3629),
    [sym_this] = ACTIONS(3629),
    [anon_sym_discard] = ACTIONS(3629),
    [anon_sym_precise] = ACTIONS(3629),
    [anon_sym_shared] = ACTIONS(3629),
    [anon_sym_groupshared] = ACTIONS(3629),
    [anon_sym_uniform] = ACTIONS(3629),
    [anon_sym_row_major] = ACTIONS(3629),
    [anon_sym_column_major] = ACTIONS(3629),
    [anon_sym_globallycoherent] = ACTIONS(3629),
    [anon_sym_centroid] = ACTIONS(3629),
    [anon_sym_noperspective] = ACTIONS(3629),
    [anon_sym_nointerpolation] = ACTIONS(3629),
    [anon_sym_sample] = ACTIONS(3629),
    [anon_sym_linear] = ACTIONS(3629),
    [anon_sym_snorm] = ACTIONS(3629),
    [anon_sym_unorm] = ACTIONS(3629),
    [anon_sym_point] = ACTIONS(3629),
    [anon_sym_line] = ACTIONS(3629),
    [anon_sym_triangleadj] = ACTIONS(3629),
    [anon_sym_lineadj] = ACTIONS(3629),
    [anon_sym_triangle] = ACTIONS(3629),
    [anon_sym_cbuffer] = ACTIONS(3629),
    [anon_sym_interface] = ACTIONS(3629),
    [anon_sym_extension] = ACTIONS(3629),
  },
  [902] = {
    [sym_attribute_specifier] = STATE(369),
    [ts_builtin_sym_end] = ACTIONS(3737),
    [sym_identifier] = ACTIONS(3735),
    [aux_sym_preproc_include_token1] = ACTIONS(3735),
    [aux_sym_preproc_def_token1] = ACTIONS(3735),
    [aux_sym_preproc_if_token1] = ACTIONS(3735),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3735),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3735),
    [sym_preproc_directive] = ACTIONS(3735),
    [anon_sym_LPAREN2] = ACTIONS(3737),
    [anon_sym_BANG] = ACTIONS(3737),
    [anon_sym_TILDE] = ACTIONS(3737),
    [anon_sym_DASH] = ACTIONS(3735),
    [anon_sym_PLUS] = ACTIONS(3735),
    [anon_sym_STAR] = ACTIONS(3737),
    [anon_sym_AMP_AMP] = ACTIONS(3737),
    [anon_sym_AMP] = ACTIONS(3735),
    [anon_sym_SEMI] = ACTIONS(3737),
    [anon_sym___extension__] = ACTIONS(3735),
    [anon_sym_typedef] = ACTIONS(3735),
    [anon_sym_in] = ACTIONS(3735),
    [anon_sym_out] = ACTIONS(3735),
    [anon_sym_inout] = ACTIONS(3735),
    [anon_sym_extern] = ACTIONS(3735),
    [anon_sym___attribute__] = ACTIONS(2861),
    [anon_sym_COLON_COLON] = ACTIONS(3737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3737),
    [anon_sym___declspec] = ACTIONS(3735),
    [anon_sym___based] = ACTIONS(3735),
    [anon_sym___cdecl] = ACTIONS(3735),
    [anon_sym___clrcall] = ACTIONS(3735),
    [anon_sym___stdcall] = ACTIONS(3735),
    [anon_sym___fastcall] = ACTIONS(3735),
    [anon_sym___thiscall] = ACTIONS(3735),
    [anon_sym___vectorcall] = ACTIONS(3735),
    [anon_sym_LBRACE] = ACTIONS(3737),
    [anon_sym_signed] = ACTIONS(3735),
    [anon_sym_unsigned] = ACTIONS(3735),
    [anon_sym_long] = ACTIONS(3735),
    [anon_sym_short] = ACTIONS(3735),
    [anon_sym_LBRACK] = ACTIONS(3735),
    [anon_sym_static] = ACTIONS(3735),
    [anon_sym_register] = ACTIONS(3735),
    [anon_sym_inline] = ACTIONS(3735),
    [anon_sym___inline] = ACTIONS(3735),
    [anon_sym___inline__] = ACTIONS(3735),
    [anon_sym___forceinline] = ACTIONS(3735),
    [anon_sym_thread_local] = ACTIONS(3735),
    [anon_sym___thread] = ACTIONS(3735),
    [anon_sym_const] = ACTIONS(3735),
    [anon_sym_constexpr] = ACTIONS(3735),
    [anon_sym_volatile] = ACTIONS(3735),
    [anon_sym_restrict] = ACTIONS(3735),
    [anon_sym___restrict__] = ACTIONS(3735),
    [anon_sym__Atomic] = ACTIONS(3735),
    [anon_sym__Noreturn] = ACTIONS(3735),
    [anon_sym_noreturn] = ACTIONS(3735),
    [anon_sym_mutable] = ACTIONS(3735),
    [anon_sym_constinit] = ACTIONS(3735),
    [anon_sym_consteval] = ACTIONS(3735),
    [anon_sym_alignas] = ACTIONS(3735),
    [anon_sym__Alignas] = ACTIONS(3735),
    [sym_primitive_type] = ACTIONS(3735),
    [anon_sym_enum] = ACTIONS(3735),
    [anon_sym_class] = ACTIONS(3735),
    [anon_sym_struct] = ACTIONS(3735),
    [anon_sym_union] = ACTIONS(3735),
    [anon_sym_if] = ACTIONS(3735),
    [anon_sym_switch] = ACTIONS(3735),
    [anon_sym_case] = ACTIONS(3735),
    [anon_sym_default] = ACTIONS(3735),
    [anon_sym_while] = ACTIONS(3735),
    [anon_sym_do] = ACTIONS(3735),
    [anon_sym_for] = ACTIONS(3735),
    [anon_sym_return] = ACTIONS(3735),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_continue] = ACTIONS(3735),
    [anon_sym_goto] = ACTIONS(3735),
    [anon_sym_not] = ACTIONS(3735),
    [anon_sym_compl] = ACTIONS(3735),
    [anon_sym_DASH_DASH] = ACTIONS(3737),
    [anon_sym_PLUS_PLUS] = ACTIONS(3737),
    [anon_sym_sizeof] = ACTIONS(3735),
    [anon_sym___alignof__] = ACTIONS(3735),
    [anon_sym___alignof] = ACTIONS(3735),
    [anon_sym__alignof] = ACTIONS(3735),
    [anon_sym_alignof] = ACTIONS(3735),
    [anon_sym__Alignof] = ACTIONS(3735),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3735),
    [anon_sym_asm] = ACTIONS(3735),
    [anon_sym___asm__] = ACTIONS(3735),
    [anon_sym_DOT] = ACTIONS(3735),
    [sym_number_literal] = ACTIONS(3737),
    [anon_sym_L_SQUOTE] = ACTIONS(3737),
    [anon_sym_u_SQUOTE] = ACTIONS(3737),
    [anon_sym_U_SQUOTE] = ACTIONS(3737),
    [anon_sym_u8_SQUOTE] = ACTIONS(3737),
    [anon_sym_SQUOTE] = ACTIONS(3737),
    [anon_sym_L_DQUOTE] = ACTIONS(3737),
    [anon_sym_u_DQUOTE] = ACTIONS(3737),
    [anon_sym_U_DQUOTE] = ACTIONS(3737),
    [anon_sym_u8_DQUOTE] = ACTIONS(3737),
    [anon_sym_DQUOTE] = ACTIONS(3737),
    [sym_true] = ACTIONS(3735),
    [sym_false] = ACTIONS(3735),
    [anon_sym_NULL] = ACTIONS(3735),
    [anon_sym_nullptr] = ACTIONS(3735),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3735),
    [anon_sym_let] = ACTIONS(3735),
    [anon_sym_This] = ACTIONS(3735),
    [anon_sym_decltype] = ACTIONS(3735),
    [sym_virtual] = ACTIONS(3735),
    [anon_sym_explicit] = ACTIONS(3735),
    [anon_sym_typename] = ACTIONS(3735),
    [anon_sym_template] = ACTIONS(3735),
    [anon_sym_operator] = ACTIONS(3735),
    [anon_sym_try] = ACTIONS(3735),
    [anon_sym_delete] = ACTIONS(3735),
    [anon_sym_throw] = ACTIONS(3735),
    [anon_sym_namespace] = ACTIONS(3735),
    [anon_sym_using] = ACTIONS(3735),
    [anon_sym_static_assert] = ACTIONS(3735),
    [anon_sym_concept] = ACTIONS(3735),
    [anon_sym_co_return] = ACTIONS(3735),
    [anon_sym_co_yield] = ACTIONS(3735),
    [anon_sym_R_DQUOTE] = ACTIONS(3737),
    [anon_sym_LR_DQUOTE] = ACTIONS(3737),
    [anon_sym_uR_DQUOTE] = ACTIONS(3737),
    [anon_sym_UR_DQUOTE] = ACTIONS(3737),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3737),
    [anon_sym_co_await] = ACTIONS(3735),
    [anon_sym_new] = ACTIONS(3735),
    [anon_sym_requires] = ACTIONS(3735),
    [sym_this] = ACTIONS(3735),
    [anon_sym_precise] = ACTIONS(3735),
    [anon_sym_shared] = ACTIONS(3735),
    [anon_sym_groupshared] = ACTIONS(3735),
    [anon_sym_uniform] = ACTIONS(3735),
    [anon_sym_row_major] = ACTIONS(3735),
    [anon_sym_column_major] = ACTIONS(3735),
    [anon_sym_globallycoherent] = ACTIONS(3735),
    [anon_sym_centroid] = ACTIONS(3735),
    [anon_sym_noperspective] = ACTIONS(3735),
    [anon_sym_nointerpolation] = ACTIONS(3735),
    [anon_sym_sample] = ACTIONS(3735),
    [anon_sym_linear] = ACTIONS(3735),
    [anon_sym_snorm] = ACTIONS(3735),
    [anon_sym_unorm] = ACTIONS(3735),
    [anon_sym_point] = ACTIONS(3735),
    [anon_sym_line] = ACTIONS(3735),
    [anon_sym_triangleadj] = ACTIONS(3735),
    [anon_sym_lineadj] = ACTIONS(3735),
    [anon_sym_triangle] = ACTIONS(3735),
    [anon_sym_interface] = ACTIONS(3735),
    [anon_sym_extension] = ACTIONS(3735),
    [anon_sym___exported] = ACTIONS(3735),
    [anon_sym_import] = ACTIONS(3735),
  },
  [903] = {
    [sym_identifier] = ACTIONS(3633),
    [aux_sym_preproc_include_token1] = ACTIONS(3633),
    [aux_sym_preproc_def_token1] = ACTIONS(3633),
    [aux_sym_preproc_if_token1] = ACTIONS(3633),
    [aux_sym_preproc_if_token2] = ACTIONS(3633),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3633),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3633),
    [sym_preproc_directive] = ACTIONS(3633),
    [anon_sym_LPAREN2] = ACTIONS(3635),
    [anon_sym_BANG] = ACTIONS(3635),
    [anon_sym_TILDE] = ACTIONS(3635),
    [anon_sym_DASH] = ACTIONS(3633),
    [anon_sym_PLUS] = ACTIONS(3633),
    [anon_sym_STAR] = ACTIONS(3635),
    [anon_sym_AMP_AMP] = ACTIONS(3635),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym_SEMI] = ACTIONS(3635),
    [anon_sym___extension__] = ACTIONS(3633),
    [anon_sym_typedef] = ACTIONS(3633),
    [anon_sym_in] = ACTIONS(3633),
    [anon_sym_out] = ACTIONS(3633),
    [anon_sym_inout] = ACTIONS(3633),
    [anon_sym_extern] = ACTIONS(3633),
    [anon_sym___attribute__] = ACTIONS(3633),
    [anon_sym_COLON_COLON] = ACTIONS(3635),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3635),
    [anon_sym___declspec] = ACTIONS(3633),
    [anon_sym___based] = ACTIONS(3633),
    [anon_sym___cdecl] = ACTIONS(3633),
    [anon_sym___clrcall] = ACTIONS(3633),
    [anon_sym___stdcall] = ACTIONS(3633),
    [anon_sym___fastcall] = ACTIONS(3633),
    [anon_sym___thiscall] = ACTIONS(3633),
    [anon_sym___vectorcall] = ACTIONS(3633),
    [anon_sym_LBRACE] = ACTIONS(3635),
    [anon_sym_signed] = ACTIONS(3633),
    [anon_sym_unsigned] = ACTIONS(3633),
    [anon_sym_long] = ACTIONS(3633),
    [anon_sym_short] = ACTIONS(3633),
    [anon_sym_LBRACK] = ACTIONS(3633),
    [anon_sym_static] = ACTIONS(3633),
    [anon_sym_register] = ACTIONS(3633),
    [anon_sym_inline] = ACTIONS(3633),
    [anon_sym___inline] = ACTIONS(3633),
    [anon_sym___inline__] = ACTIONS(3633),
    [anon_sym___forceinline] = ACTIONS(3633),
    [anon_sym_thread_local] = ACTIONS(3633),
    [anon_sym___thread] = ACTIONS(3633),
    [anon_sym_const] = ACTIONS(3633),
    [anon_sym_constexpr] = ACTIONS(3633),
    [anon_sym_volatile] = ACTIONS(3633),
    [anon_sym_restrict] = ACTIONS(3633),
    [anon_sym___restrict__] = ACTIONS(3633),
    [anon_sym__Atomic] = ACTIONS(3633),
    [anon_sym__Noreturn] = ACTIONS(3633),
    [anon_sym_noreturn] = ACTIONS(3633),
    [anon_sym_mutable] = ACTIONS(3633),
    [anon_sym_constinit] = ACTIONS(3633),
    [anon_sym_consteval] = ACTIONS(3633),
    [anon_sym_alignas] = ACTIONS(3633),
    [anon_sym__Alignas] = ACTIONS(3633),
    [sym_primitive_type] = ACTIONS(3633),
    [anon_sym_enum] = ACTIONS(3633),
    [anon_sym_class] = ACTIONS(3633),
    [anon_sym_struct] = ACTIONS(3633),
    [anon_sym_union] = ACTIONS(3633),
    [anon_sym_if] = ACTIONS(3633),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_case] = ACTIONS(3633),
    [anon_sym_default] = ACTIONS(3633),
    [anon_sym_while] = ACTIONS(3633),
    [anon_sym_do] = ACTIONS(3633),
    [anon_sym_for] = ACTIONS(3633),
    [anon_sym_return] = ACTIONS(3633),
    [anon_sym_break] = ACTIONS(3633),
    [anon_sym_continue] = ACTIONS(3633),
    [anon_sym_goto] = ACTIONS(3633),
    [anon_sym___try] = ACTIONS(3633),
    [anon_sym___leave] = ACTIONS(3633),
    [anon_sym_not] = ACTIONS(3633),
    [anon_sym_compl] = ACTIONS(3633),
    [anon_sym_DASH_DASH] = ACTIONS(3635),
    [anon_sym_PLUS_PLUS] = ACTIONS(3635),
    [anon_sym_sizeof] = ACTIONS(3633),
    [anon_sym___alignof__] = ACTIONS(3633),
    [anon_sym___alignof] = ACTIONS(3633),
    [anon_sym__alignof] = ACTIONS(3633),
    [anon_sym_alignof] = ACTIONS(3633),
    [anon_sym__Alignof] = ACTIONS(3633),
    [anon_sym_offsetof] = ACTIONS(3633),
    [anon_sym__Generic] = ACTIONS(3633),
    [anon_sym_asm] = ACTIONS(3633),
    [anon_sym___asm__] = ACTIONS(3633),
    [sym_number_literal] = ACTIONS(3635),
    [anon_sym_L_SQUOTE] = ACTIONS(3635),
    [anon_sym_u_SQUOTE] = ACTIONS(3635),
    [anon_sym_U_SQUOTE] = ACTIONS(3635),
    [anon_sym_u8_SQUOTE] = ACTIONS(3635),
    [anon_sym_SQUOTE] = ACTIONS(3635),
    [anon_sym_L_DQUOTE] = ACTIONS(3635),
    [anon_sym_u_DQUOTE] = ACTIONS(3635),
    [anon_sym_U_DQUOTE] = ACTIONS(3635),
    [anon_sym_u8_DQUOTE] = ACTIONS(3635),
    [anon_sym_DQUOTE] = ACTIONS(3635),
    [sym_true] = ACTIONS(3633),
    [sym_false] = ACTIONS(3633),
    [anon_sym_NULL] = ACTIONS(3633),
    [anon_sym_nullptr] = ACTIONS(3633),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3633),
    [anon_sym_let] = ACTIONS(3633),
    [anon_sym_This] = ACTIONS(3633),
    [anon_sym_decltype] = ACTIONS(3633),
    [sym_virtual] = ACTIONS(3633),
    [anon_sym_explicit] = ACTIONS(3633),
    [anon_sym_typename] = ACTIONS(3633),
    [anon_sym_template] = ACTIONS(3633),
    [anon_sym_operator] = ACTIONS(3633),
    [anon_sym_try] = ACTIONS(3633),
    [anon_sym_delete] = ACTIONS(3633),
    [anon_sym_throw] = ACTIONS(3633),
    [anon_sym_namespace] = ACTIONS(3633),
    [anon_sym_using] = ACTIONS(3633),
    [anon_sym_static_assert] = ACTIONS(3633),
    [anon_sym_concept] = ACTIONS(3633),
    [anon_sym_co_return] = ACTIONS(3633),
    [anon_sym_co_yield] = ACTIONS(3633),
    [anon_sym_R_DQUOTE] = ACTIONS(3635),
    [anon_sym_LR_DQUOTE] = ACTIONS(3635),
    [anon_sym_uR_DQUOTE] = ACTIONS(3635),
    [anon_sym_UR_DQUOTE] = ACTIONS(3635),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3635),
    [anon_sym_co_await] = ACTIONS(3633),
    [anon_sym_new] = ACTIONS(3633),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(3633),
    [anon_sym_discard] = ACTIONS(3633),
    [anon_sym_precise] = ACTIONS(3633),
    [anon_sym_shared] = ACTIONS(3633),
    [anon_sym_groupshared] = ACTIONS(3633),
    [anon_sym_uniform] = ACTIONS(3633),
    [anon_sym_row_major] = ACTIONS(3633),
    [anon_sym_column_major] = ACTIONS(3633),
    [anon_sym_globallycoherent] = ACTIONS(3633),
    [anon_sym_centroid] = ACTIONS(3633),
    [anon_sym_noperspective] = ACTIONS(3633),
    [anon_sym_nointerpolation] = ACTIONS(3633),
    [anon_sym_sample] = ACTIONS(3633),
    [anon_sym_linear] = ACTIONS(3633),
    [anon_sym_snorm] = ACTIONS(3633),
    [anon_sym_unorm] = ACTIONS(3633),
    [anon_sym_point] = ACTIONS(3633),
    [anon_sym_line] = ACTIONS(3633),
    [anon_sym_triangleadj] = ACTIONS(3633),
    [anon_sym_lineadj] = ACTIONS(3633),
    [anon_sym_triangle] = ACTIONS(3633),
    [anon_sym_cbuffer] = ACTIONS(3633),
    [anon_sym_interface] = ACTIONS(3633),
    [anon_sym_extension] = ACTIONS(3633),
  },
  [904] = {
    [sym_identifier] = ACTIONS(3429),
    [aux_sym_preproc_include_token1] = ACTIONS(3429),
    [aux_sym_preproc_def_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3429),
    [sym_preproc_directive] = ACTIONS(3429),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_BANG] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym_SEMI] = ACTIONS(3431),
    [anon_sym___extension__] = ACTIONS(3429),
    [anon_sym_typedef] = ACTIONS(3429),
    [anon_sym_in] = ACTIONS(3429),
    [anon_sym_out] = ACTIONS(3429),
    [anon_sym_inout] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym___attribute__] = ACTIONS(3429),
    [anon_sym_COLON_COLON] = ACTIONS(3431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3431),
    [anon_sym___declspec] = ACTIONS(3429),
    [anon_sym___based] = ACTIONS(3429),
    [anon_sym___cdecl] = ACTIONS(3429),
    [anon_sym___clrcall] = ACTIONS(3429),
    [anon_sym___stdcall] = ACTIONS(3429),
    [anon_sym___fastcall] = ACTIONS(3429),
    [anon_sym___thiscall] = ACTIONS(3429),
    [anon_sym___vectorcall] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_RBRACE] = ACTIONS(3431),
    [anon_sym_signed] = ACTIONS(3429),
    [anon_sym_unsigned] = ACTIONS(3429),
    [anon_sym_long] = ACTIONS(3429),
    [anon_sym_short] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_register] = ACTIONS(3429),
    [anon_sym_inline] = ACTIONS(3429),
    [anon_sym___inline] = ACTIONS(3429),
    [anon_sym___inline__] = ACTIONS(3429),
    [anon_sym___forceinline] = ACTIONS(3429),
    [anon_sym_thread_local] = ACTIONS(3429),
    [anon_sym___thread] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_constexpr] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_restrict] = ACTIONS(3429),
    [anon_sym___restrict__] = ACTIONS(3429),
    [anon_sym__Atomic] = ACTIONS(3429),
    [anon_sym__Noreturn] = ACTIONS(3429),
    [anon_sym_noreturn] = ACTIONS(3429),
    [anon_sym_mutable] = ACTIONS(3429),
    [anon_sym_constinit] = ACTIONS(3429),
    [anon_sym_consteval] = ACTIONS(3429),
    [anon_sym_alignas] = ACTIONS(3429),
    [anon_sym__Alignas] = ACTIONS(3429),
    [sym_primitive_type] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [anon_sym_if] = ACTIONS(3429),
    [anon_sym_switch] = ACTIONS(3429),
    [anon_sym_case] = ACTIONS(3429),
    [anon_sym_default] = ACTIONS(3429),
    [anon_sym_while] = ACTIONS(3429),
    [anon_sym_do] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3429),
    [anon_sym_return] = ACTIONS(3429),
    [anon_sym_break] = ACTIONS(3429),
    [anon_sym_continue] = ACTIONS(3429),
    [anon_sym_goto] = ACTIONS(3429),
    [anon_sym___try] = ACTIONS(3429),
    [anon_sym___leave] = ACTIONS(3429),
    [anon_sym_not] = ACTIONS(3429),
    [anon_sym_compl] = ACTIONS(3429),
    [anon_sym_DASH_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(3431),
    [anon_sym_sizeof] = ACTIONS(3429),
    [anon_sym___alignof__] = ACTIONS(3429),
    [anon_sym___alignof] = ACTIONS(3429),
    [anon_sym__alignof] = ACTIONS(3429),
    [anon_sym_alignof] = ACTIONS(3429),
    [anon_sym__Alignof] = ACTIONS(3429),
    [anon_sym_offsetof] = ACTIONS(3429),
    [anon_sym__Generic] = ACTIONS(3429),
    [anon_sym_asm] = ACTIONS(3429),
    [anon_sym___asm__] = ACTIONS(3429),
    [sym_number_literal] = ACTIONS(3431),
    [anon_sym_L_SQUOTE] = ACTIONS(3431),
    [anon_sym_u_SQUOTE] = ACTIONS(3431),
    [anon_sym_U_SQUOTE] = ACTIONS(3431),
    [anon_sym_u8_SQUOTE] = ACTIONS(3431),
    [anon_sym_SQUOTE] = ACTIONS(3431),
    [anon_sym_L_DQUOTE] = ACTIONS(3431),
    [anon_sym_u_DQUOTE] = ACTIONS(3431),
    [anon_sym_U_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [sym_true] = ACTIONS(3429),
    [sym_false] = ACTIONS(3429),
    [anon_sym_NULL] = ACTIONS(3429),
    [anon_sym_nullptr] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_This] = ACTIONS(3429),
    [anon_sym_decltype] = ACTIONS(3429),
    [sym_virtual] = ACTIONS(3429),
    [anon_sym_explicit] = ACTIONS(3429),
    [anon_sym_typename] = ACTIONS(3429),
    [anon_sym_template] = ACTIONS(3429),
    [anon_sym_operator] = ACTIONS(3429),
    [anon_sym_try] = ACTIONS(3429),
    [anon_sym_delete] = ACTIONS(3429),
    [anon_sym_throw] = ACTIONS(3429),
    [anon_sym_namespace] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_static_assert] = ACTIONS(3429),
    [anon_sym_concept] = ACTIONS(3429),
    [anon_sym_co_return] = ACTIONS(3429),
    [anon_sym_co_yield] = ACTIONS(3429),
    [anon_sym_R_DQUOTE] = ACTIONS(3431),
    [anon_sym_LR_DQUOTE] = ACTIONS(3431),
    [anon_sym_uR_DQUOTE] = ACTIONS(3431),
    [anon_sym_UR_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3431),
    [anon_sym_co_await] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3429),
    [anon_sym_requires] = ACTIONS(3429),
    [sym_this] = ACTIONS(3429),
    [anon_sym_discard] = ACTIONS(3429),
    [anon_sym_precise] = ACTIONS(3429),
    [anon_sym_shared] = ACTIONS(3429),
    [anon_sym_groupshared] = ACTIONS(3429),
    [anon_sym_uniform] = ACTIONS(3429),
    [anon_sym_row_major] = ACTIONS(3429),
    [anon_sym_column_major] = ACTIONS(3429),
    [anon_sym_globallycoherent] = ACTIONS(3429),
    [anon_sym_centroid] = ACTIONS(3429),
    [anon_sym_noperspective] = ACTIONS(3429),
    [anon_sym_nointerpolation] = ACTIONS(3429),
    [anon_sym_sample] = ACTIONS(3429),
    [anon_sym_linear] = ACTIONS(3429),
    [anon_sym_snorm] = ACTIONS(3429),
    [anon_sym_unorm] = ACTIONS(3429),
    [anon_sym_point] = ACTIONS(3429),
    [anon_sym_line] = ACTIONS(3429),
    [anon_sym_triangleadj] = ACTIONS(3429),
    [anon_sym_lineadj] = ACTIONS(3429),
    [anon_sym_triangle] = ACTIONS(3429),
    [anon_sym_cbuffer] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_extension] = ACTIONS(3429),
  },
  [905] = {
    [sym_identifier] = ACTIONS(3429),
    [aux_sym_preproc_include_token1] = ACTIONS(3429),
    [aux_sym_preproc_def_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3429),
    [sym_preproc_directive] = ACTIONS(3429),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_BANG] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym_SEMI] = ACTIONS(3431),
    [anon_sym___extension__] = ACTIONS(3429),
    [anon_sym_typedef] = ACTIONS(3429),
    [anon_sym_in] = ACTIONS(3429),
    [anon_sym_out] = ACTIONS(3429),
    [anon_sym_inout] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym___attribute__] = ACTIONS(3429),
    [anon_sym_COLON_COLON] = ACTIONS(3431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3431),
    [anon_sym___declspec] = ACTIONS(3429),
    [anon_sym___based] = ACTIONS(3429),
    [anon_sym___cdecl] = ACTIONS(3429),
    [anon_sym___clrcall] = ACTIONS(3429),
    [anon_sym___stdcall] = ACTIONS(3429),
    [anon_sym___fastcall] = ACTIONS(3429),
    [anon_sym___thiscall] = ACTIONS(3429),
    [anon_sym___vectorcall] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_RBRACE] = ACTIONS(3431),
    [anon_sym_signed] = ACTIONS(3429),
    [anon_sym_unsigned] = ACTIONS(3429),
    [anon_sym_long] = ACTIONS(3429),
    [anon_sym_short] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_register] = ACTIONS(3429),
    [anon_sym_inline] = ACTIONS(3429),
    [anon_sym___inline] = ACTIONS(3429),
    [anon_sym___inline__] = ACTIONS(3429),
    [anon_sym___forceinline] = ACTIONS(3429),
    [anon_sym_thread_local] = ACTIONS(3429),
    [anon_sym___thread] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_constexpr] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_restrict] = ACTIONS(3429),
    [anon_sym___restrict__] = ACTIONS(3429),
    [anon_sym__Atomic] = ACTIONS(3429),
    [anon_sym__Noreturn] = ACTIONS(3429),
    [anon_sym_noreturn] = ACTIONS(3429),
    [anon_sym_mutable] = ACTIONS(3429),
    [anon_sym_constinit] = ACTIONS(3429),
    [anon_sym_consteval] = ACTIONS(3429),
    [anon_sym_alignas] = ACTIONS(3429),
    [anon_sym__Alignas] = ACTIONS(3429),
    [sym_primitive_type] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [anon_sym_if] = ACTIONS(3429),
    [anon_sym_switch] = ACTIONS(3429),
    [anon_sym_case] = ACTIONS(3429),
    [anon_sym_default] = ACTIONS(3429),
    [anon_sym_while] = ACTIONS(3429),
    [anon_sym_do] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3429),
    [anon_sym_return] = ACTIONS(3429),
    [anon_sym_break] = ACTIONS(3429),
    [anon_sym_continue] = ACTIONS(3429),
    [anon_sym_goto] = ACTIONS(3429),
    [anon_sym___try] = ACTIONS(3429),
    [anon_sym___leave] = ACTIONS(3429),
    [anon_sym_not] = ACTIONS(3429),
    [anon_sym_compl] = ACTIONS(3429),
    [anon_sym_DASH_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(3431),
    [anon_sym_sizeof] = ACTIONS(3429),
    [anon_sym___alignof__] = ACTIONS(3429),
    [anon_sym___alignof] = ACTIONS(3429),
    [anon_sym__alignof] = ACTIONS(3429),
    [anon_sym_alignof] = ACTIONS(3429),
    [anon_sym__Alignof] = ACTIONS(3429),
    [anon_sym_offsetof] = ACTIONS(3429),
    [anon_sym__Generic] = ACTIONS(3429),
    [anon_sym_asm] = ACTIONS(3429),
    [anon_sym___asm__] = ACTIONS(3429),
    [sym_number_literal] = ACTIONS(3431),
    [anon_sym_L_SQUOTE] = ACTIONS(3431),
    [anon_sym_u_SQUOTE] = ACTIONS(3431),
    [anon_sym_U_SQUOTE] = ACTIONS(3431),
    [anon_sym_u8_SQUOTE] = ACTIONS(3431),
    [anon_sym_SQUOTE] = ACTIONS(3431),
    [anon_sym_L_DQUOTE] = ACTIONS(3431),
    [anon_sym_u_DQUOTE] = ACTIONS(3431),
    [anon_sym_U_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [sym_true] = ACTIONS(3429),
    [sym_false] = ACTIONS(3429),
    [anon_sym_NULL] = ACTIONS(3429),
    [anon_sym_nullptr] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_This] = ACTIONS(3429),
    [anon_sym_decltype] = ACTIONS(3429),
    [sym_virtual] = ACTIONS(3429),
    [anon_sym_explicit] = ACTIONS(3429),
    [anon_sym_typename] = ACTIONS(3429),
    [anon_sym_template] = ACTIONS(3429),
    [anon_sym_operator] = ACTIONS(3429),
    [anon_sym_try] = ACTIONS(3429),
    [anon_sym_delete] = ACTIONS(3429),
    [anon_sym_throw] = ACTIONS(3429),
    [anon_sym_namespace] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_static_assert] = ACTIONS(3429),
    [anon_sym_concept] = ACTIONS(3429),
    [anon_sym_co_return] = ACTIONS(3429),
    [anon_sym_co_yield] = ACTIONS(3429),
    [anon_sym_R_DQUOTE] = ACTIONS(3431),
    [anon_sym_LR_DQUOTE] = ACTIONS(3431),
    [anon_sym_uR_DQUOTE] = ACTIONS(3431),
    [anon_sym_UR_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3431),
    [anon_sym_co_await] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3429),
    [anon_sym_requires] = ACTIONS(3429),
    [sym_this] = ACTIONS(3429),
    [anon_sym_discard] = ACTIONS(3429),
    [anon_sym_precise] = ACTIONS(3429),
    [anon_sym_shared] = ACTIONS(3429),
    [anon_sym_groupshared] = ACTIONS(3429),
    [anon_sym_uniform] = ACTIONS(3429),
    [anon_sym_row_major] = ACTIONS(3429),
    [anon_sym_column_major] = ACTIONS(3429),
    [anon_sym_globallycoherent] = ACTIONS(3429),
    [anon_sym_centroid] = ACTIONS(3429),
    [anon_sym_noperspective] = ACTIONS(3429),
    [anon_sym_nointerpolation] = ACTIONS(3429),
    [anon_sym_sample] = ACTIONS(3429),
    [anon_sym_linear] = ACTIONS(3429),
    [anon_sym_snorm] = ACTIONS(3429),
    [anon_sym_unorm] = ACTIONS(3429),
    [anon_sym_point] = ACTIONS(3429),
    [anon_sym_line] = ACTIONS(3429),
    [anon_sym_triangleadj] = ACTIONS(3429),
    [anon_sym_lineadj] = ACTIONS(3429),
    [anon_sym_triangle] = ACTIONS(3429),
    [anon_sym_cbuffer] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_extension] = ACTIONS(3429),
  },
  [906] = {
    [sym_identifier] = ACTIONS(3699),
    [aux_sym_preproc_include_token1] = ACTIONS(3699),
    [aux_sym_preproc_def_token1] = ACTIONS(3699),
    [aux_sym_preproc_if_token1] = ACTIONS(3699),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3699),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3699),
    [sym_preproc_directive] = ACTIONS(3699),
    [anon_sym_LPAREN2] = ACTIONS(3701),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_TILDE] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_STAR] = ACTIONS(3701),
    [anon_sym_AMP_AMP] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_SEMI] = ACTIONS(3701),
    [anon_sym___extension__] = ACTIONS(3699),
    [anon_sym_typedef] = ACTIONS(3699),
    [anon_sym_in] = ACTIONS(3699),
    [anon_sym_out] = ACTIONS(3699),
    [anon_sym_inout] = ACTIONS(3699),
    [anon_sym_extern] = ACTIONS(3699),
    [anon_sym___attribute__] = ACTIONS(3699),
    [anon_sym_COLON_COLON] = ACTIONS(3701),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3701),
    [anon_sym___declspec] = ACTIONS(3699),
    [anon_sym___based] = ACTIONS(3699),
    [anon_sym___cdecl] = ACTIONS(3699),
    [anon_sym___clrcall] = ACTIONS(3699),
    [anon_sym___stdcall] = ACTIONS(3699),
    [anon_sym___fastcall] = ACTIONS(3699),
    [anon_sym___thiscall] = ACTIONS(3699),
    [anon_sym___vectorcall] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3701),
    [anon_sym_RBRACE] = ACTIONS(3701),
    [anon_sym_signed] = ACTIONS(3699),
    [anon_sym_unsigned] = ACTIONS(3699),
    [anon_sym_long] = ACTIONS(3699),
    [anon_sym_short] = ACTIONS(3699),
    [anon_sym_LBRACK] = ACTIONS(3699),
    [anon_sym_static] = ACTIONS(3699),
    [anon_sym_register] = ACTIONS(3699),
    [anon_sym_inline] = ACTIONS(3699),
    [anon_sym___inline] = ACTIONS(3699),
    [anon_sym___inline__] = ACTIONS(3699),
    [anon_sym___forceinline] = ACTIONS(3699),
    [anon_sym_thread_local] = ACTIONS(3699),
    [anon_sym___thread] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3699),
    [anon_sym_constexpr] = ACTIONS(3699),
    [anon_sym_volatile] = ACTIONS(3699),
    [anon_sym_restrict] = ACTIONS(3699),
    [anon_sym___restrict__] = ACTIONS(3699),
    [anon_sym__Atomic] = ACTIONS(3699),
    [anon_sym__Noreturn] = ACTIONS(3699),
    [anon_sym_noreturn] = ACTIONS(3699),
    [anon_sym_mutable] = ACTIONS(3699),
    [anon_sym_constinit] = ACTIONS(3699),
    [anon_sym_consteval] = ACTIONS(3699),
    [anon_sym_alignas] = ACTIONS(3699),
    [anon_sym__Alignas] = ACTIONS(3699),
    [sym_primitive_type] = ACTIONS(3699),
    [anon_sym_enum] = ACTIONS(3699),
    [anon_sym_class] = ACTIONS(3699),
    [anon_sym_struct] = ACTIONS(3699),
    [anon_sym_union] = ACTIONS(3699),
    [anon_sym_if] = ACTIONS(3699),
    [anon_sym_switch] = ACTIONS(3699),
    [anon_sym_case] = ACTIONS(3699),
    [anon_sym_default] = ACTIONS(3699),
    [anon_sym_while] = ACTIONS(3699),
    [anon_sym_do] = ACTIONS(3699),
    [anon_sym_for] = ACTIONS(3699),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_break] = ACTIONS(3699),
    [anon_sym_continue] = ACTIONS(3699),
    [anon_sym_goto] = ACTIONS(3699),
    [anon_sym___try] = ACTIONS(3699),
    [anon_sym___leave] = ACTIONS(3699),
    [anon_sym_not] = ACTIONS(3699),
    [anon_sym_compl] = ACTIONS(3699),
    [anon_sym_DASH_DASH] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3701),
    [anon_sym_sizeof] = ACTIONS(3699),
    [anon_sym___alignof__] = ACTIONS(3699),
    [anon_sym___alignof] = ACTIONS(3699),
    [anon_sym__alignof] = ACTIONS(3699),
    [anon_sym_alignof] = ACTIONS(3699),
    [anon_sym__Alignof] = ACTIONS(3699),
    [anon_sym_offsetof] = ACTIONS(3699),
    [anon_sym__Generic] = ACTIONS(3699),
    [anon_sym_asm] = ACTIONS(3699),
    [anon_sym___asm__] = ACTIONS(3699),
    [sym_number_literal] = ACTIONS(3701),
    [anon_sym_L_SQUOTE] = ACTIONS(3701),
    [anon_sym_u_SQUOTE] = ACTIONS(3701),
    [anon_sym_U_SQUOTE] = ACTIONS(3701),
    [anon_sym_u8_SQUOTE] = ACTIONS(3701),
    [anon_sym_SQUOTE] = ACTIONS(3701),
    [anon_sym_L_DQUOTE] = ACTIONS(3701),
    [anon_sym_u_DQUOTE] = ACTIONS(3701),
    [anon_sym_U_DQUOTE] = ACTIONS(3701),
    [anon_sym_u8_DQUOTE] = ACTIONS(3701),
    [anon_sym_DQUOTE] = ACTIONS(3701),
    [sym_true] = ACTIONS(3699),
    [sym_false] = ACTIONS(3699),
    [anon_sym_NULL] = ACTIONS(3699),
    [anon_sym_nullptr] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3699),
    [anon_sym_let] = ACTIONS(3699),
    [anon_sym_This] = ACTIONS(3699),
    [anon_sym_decltype] = ACTIONS(3699),
    [sym_virtual] = ACTIONS(3699),
    [anon_sym_explicit] = ACTIONS(3699),
    [anon_sym_typename] = ACTIONS(3699),
    [anon_sym_template] = ACTIONS(3699),
    [anon_sym_operator] = ACTIONS(3699),
    [anon_sym_try] = ACTIONS(3699),
    [anon_sym_delete] = ACTIONS(3699),
    [anon_sym_throw] = ACTIONS(3699),
    [anon_sym_namespace] = ACTIONS(3699),
    [anon_sym_using] = ACTIONS(3699),
    [anon_sym_static_assert] = ACTIONS(3699),
    [anon_sym_concept] = ACTIONS(3699),
    [anon_sym_co_return] = ACTIONS(3699),
    [anon_sym_co_yield] = ACTIONS(3699),
    [anon_sym_R_DQUOTE] = ACTIONS(3701),
    [anon_sym_LR_DQUOTE] = ACTIONS(3701),
    [anon_sym_uR_DQUOTE] = ACTIONS(3701),
    [anon_sym_UR_DQUOTE] = ACTIONS(3701),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3701),
    [anon_sym_co_await] = ACTIONS(3699),
    [anon_sym_new] = ACTIONS(3699),
    [anon_sym_requires] = ACTIONS(3699),
    [sym_this] = ACTIONS(3699),
    [anon_sym_discard] = ACTIONS(3699),
    [anon_sym_precise] = ACTIONS(3699),
    [anon_sym_shared] = ACTIONS(3699),
    [anon_sym_groupshared] = ACTIONS(3699),
    [anon_sym_uniform] = ACTIONS(3699),
    [anon_sym_row_major] = ACTIONS(3699),
    [anon_sym_column_major] = ACTIONS(3699),
    [anon_sym_globallycoherent] = ACTIONS(3699),
    [anon_sym_centroid] = ACTIONS(3699),
    [anon_sym_noperspective] = ACTIONS(3699),
    [anon_sym_nointerpolation] = ACTIONS(3699),
    [anon_sym_sample] = ACTIONS(3699),
    [anon_sym_linear] = ACTIONS(3699),
    [anon_sym_snorm] = ACTIONS(3699),
    [anon_sym_unorm] = ACTIONS(3699),
    [anon_sym_point] = ACTIONS(3699),
    [anon_sym_line] = ACTIONS(3699),
    [anon_sym_triangleadj] = ACTIONS(3699),
    [anon_sym_lineadj] = ACTIONS(3699),
    [anon_sym_triangle] = ACTIONS(3699),
    [anon_sym_cbuffer] = ACTIONS(3699),
    [anon_sym_interface] = ACTIONS(3699),
    [anon_sym_extension] = ACTIONS(3699),
  },
  [907] = {
    [sym_identifier] = ACTIONS(3645),
    [aux_sym_preproc_include_token1] = ACTIONS(3645),
    [aux_sym_preproc_def_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token2] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3645),
    [sym_preproc_directive] = ACTIONS(3645),
    [anon_sym_LPAREN2] = ACTIONS(3647),
    [anon_sym_BANG] = ACTIONS(3647),
    [anon_sym_TILDE] = ACTIONS(3647),
    [anon_sym_DASH] = ACTIONS(3645),
    [anon_sym_PLUS] = ACTIONS(3645),
    [anon_sym_STAR] = ACTIONS(3647),
    [anon_sym_AMP_AMP] = ACTIONS(3647),
    [anon_sym_AMP] = ACTIONS(3645),
    [anon_sym_SEMI] = ACTIONS(3647),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3645),
    [anon_sym_in] = ACTIONS(3645),
    [anon_sym_out] = ACTIONS(3645),
    [anon_sym_inout] = ACTIONS(3645),
    [anon_sym_extern] = ACTIONS(3645),
    [anon_sym___attribute__] = ACTIONS(3645),
    [anon_sym_COLON_COLON] = ACTIONS(3647),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3647),
    [anon_sym___declspec] = ACTIONS(3645),
    [anon_sym___based] = ACTIONS(3645),
    [anon_sym___cdecl] = ACTIONS(3645),
    [anon_sym___clrcall] = ACTIONS(3645),
    [anon_sym___stdcall] = ACTIONS(3645),
    [anon_sym___fastcall] = ACTIONS(3645),
    [anon_sym___thiscall] = ACTIONS(3645),
    [anon_sym___vectorcall] = ACTIONS(3645),
    [anon_sym_LBRACE] = ACTIONS(3647),
    [anon_sym_signed] = ACTIONS(3645),
    [anon_sym_unsigned] = ACTIONS(3645),
    [anon_sym_long] = ACTIONS(3645),
    [anon_sym_short] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_static] = ACTIONS(3645),
    [anon_sym_register] = ACTIONS(3645),
    [anon_sym_inline] = ACTIONS(3645),
    [anon_sym___inline] = ACTIONS(3645),
    [anon_sym___inline__] = ACTIONS(3645),
    [anon_sym___forceinline] = ACTIONS(3645),
    [anon_sym_thread_local] = ACTIONS(3645),
    [anon_sym___thread] = ACTIONS(3645),
    [anon_sym_const] = ACTIONS(3645),
    [anon_sym_constexpr] = ACTIONS(3645),
    [anon_sym_volatile] = ACTIONS(3645),
    [anon_sym_restrict] = ACTIONS(3645),
    [anon_sym___restrict__] = ACTIONS(3645),
    [anon_sym__Atomic] = ACTIONS(3645),
    [anon_sym__Noreturn] = ACTIONS(3645),
    [anon_sym_noreturn] = ACTIONS(3645),
    [anon_sym_mutable] = ACTIONS(3645),
    [anon_sym_constinit] = ACTIONS(3645),
    [anon_sym_consteval] = ACTIONS(3645),
    [anon_sym_alignas] = ACTIONS(3645),
    [anon_sym__Alignas] = ACTIONS(3645),
    [sym_primitive_type] = ACTIONS(3645),
    [anon_sym_enum] = ACTIONS(3645),
    [anon_sym_class] = ACTIONS(3645),
    [anon_sym_struct] = ACTIONS(3645),
    [anon_sym_union] = ACTIONS(3645),
    [anon_sym_if] = ACTIONS(3645),
    [anon_sym_switch] = ACTIONS(3645),
    [anon_sym_case] = ACTIONS(3645),
    [anon_sym_default] = ACTIONS(3645),
    [anon_sym_while] = ACTIONS(3645),
    [anon_sym_do] = ACTIONS(3645),
    [anon_sym_for] = ACTIONS(3645),
    [anon_sym_return] = ACTIONS(3645),
    [anon_sym_break] = ACTIONS(3645),
    [anon_sym_continue] = ACTIONS(3645),
    [anon_sym_goto] = ACTIONS(3645),
    [anon_sym___try] = ACTIONS(3645),
    [anon_sym___leave] = ACTIONS(3645),
    [anon_sym_not] = ACTIONS(3645),
    [anon_sym_compl] = ACTIONS(3645),
    [anon_sym_DASH_DASH] = ACTIONS(3647),
    [anon_sym_PLUS_PLUS] = ACTIONS(3647),
    [anon_sym_sizeof] = ACTIONS(3645),
    [anon_sym___alignof__] = ACTIONS(3645),
    [anon_sym___alignof] = ACTIONS(3645),
    [anon_sym__alignof] = ACTIONS(3645),
    [anon_sym_alignof] = ACTIONS(3645),
    [anon_sym__Alignof] = ACTIONS(3645),
    [anon_sym_offsetof] = ACTIONS(3645),
    [anon_sym__Generic] = ACTIONS(3645),
    [anon_sym_asm] = ACTIONS(3645),
    [anon_sym___asm__] = ACTIONS(3645),
    [sym_number_literal] = ACTIONS(3647),
    [anon_sym_L_SQUOTE] = ACTIONS(3647),
    [anon_sym_u_SQUOTE] = ACTIONS(3647),
    [anon_sym_U_SQUOTE] = ACTIONS(3647),
    [anon_sym_u8_SQUOTE] = ACTIONS(3647),
    [anon_sym_SQUOTE] = ACTIONS(3647),
    [anon_sym_L_DQUOTE] = ACTIONS(3647),
    [anon_sym_u_DQUOTE] = ACTIONS(3647),
    [anon_sym_U_DQUOTE] = ACTIONS(3647),
    [anon_sym_u8_DQUOTE] = ACTIONS(3647),
    [anon_sym_DQUOTE] = ACTIONS(3647),
    [sym_true] = ACTIONS(3645),
    [sym_false] = ACTIONS(3645),
    [anon_sym_NULL] = ACTIONS(3645),
    [anon_sym_nullptr] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3645),
    [anon_sym_let] = ACTIONS(3645),
    [anon_sym_This] = ACTIONS(3645),
    [anon_sym_decltype] = ACTIONS(3645),
    [sym_virtual] = ACTIONS(3645),
    [anon_sym_explicit] = ACTIONS(3645),
    [anon_sym_typename] = ACTIONS(3645),
    [anon_sym_template] = ACTIONS(3645),
    [anon_sym_operator] = ACTIONS(3645),
    [anon_sym_try] = ACTIONS(3645),
    [anon_sym_delete] = ACTIONS(3645),
    [anon_sym_throw] = ACTIONS(3645),
    [anon_sym_namespace] = ACTIONS(3645),
    [anon_sym_using] = ACTIONS(3645),
    [anon_sym_static_assert] = ACTIONS(3645),
    [anon_sym_concept] = ACTIONS(3645),
    [anon_sym_co_return] = ACTIONS(3645),
    [anon_sym_co_yield] = ACTIONS(3645),
    [anon_sym_R_DQUOTE] = ACTIONS(3647),
    [anon_sym_LR_DQUOTE] = ACTIONS(3647),
    [anon_sym_uR_DQUOTE] = ACTIONS(3647),
    [anon_sym_UR_DQUOTE] = ACTIONS(3647),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3647),
    [anon_sym_co_await] = ACTIONS(3645),
    [anon_sym_new] = ACTIONS(3645),
    [anon_sym_requires] = ACTIONS(3645),
    [sym_this] = ACTIONS(3645),
    [anon_sym_discard] = ACTIONS(3645),
    [anon_sym_precise] = ACTIONS(3645),
    [anon_sym_shared] = ACTIONS(3645),
    [anon_sym_groupshared] = ACTIONS(3645),
    [anon_sym_uniform] = ACTIONS(3645),
    [anon_sym_row_major] = ACTIONS(3645),
    [anon_sym_column_major] = ACTIONS(3645),
    [anon_sym_globallycoherent] = ACTIONS(3645),
    [anon_sym_centroid] = ACTIONS(3645),
    [anon_sym_noperspective] = ACTIONS(3645),
    [anon_sym_nointerpolation] = ACTIONS(3645),
    [anon_sym_sample] = ACTIONS(3645),
    [anon_sym_linear] = ACTIONS(3645),
    [anon_sym_snorm] = ACTIONS(3645),
    [anon_sym_unorm] = ACTIONS(3645),
    [anon_sym_point] = ACTIONS(3645),
    [anon_sym_line] = ACTIONS(3645),
    [anon_sym_triangleadj] = ACTIONS(3645),
    [anon_sym_lineadj] = ACTIONS(3645),
    [anon_sym_triangle] = ACTIONS(3645),
    [anon_sym_cbuffer] = ACTIONS(3645),
    [anon_sym_interface] = ACTIONS(3645),
    [anon_sym_extension] = ACTIONS(3645),
  },
  [908] = {
    [sym_identifier] = ACTIONS(3699),
    [aux_sym_preproc_include_token1] = ACTIONS(3699),
    [aux_sym_preproc_def_token1] = ACTIONS(3699),
    [aux_sym_preproc_if_token1] = ACTIONS(3699),
    [aux_sym_preproc_if_token2] = ACTIONS(3699),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3699),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3699),
    [sym_preproc_directive] = ACTIONS(3699),
    [anon_sym_LPAREN2] = ACTIONS(3701),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_TILDE] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_STAR] = ACTIONS(3701),
    [anon_sym_AMP_AMP] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_SEMI] = ACTIONS(3701),
    [anon_sym___extension__] = ACTIONS(3699),
    [anon_sym_typedef] = ACTIONS(3699),
    [anon_sym_in] = ACTIONS(3699),
    [anon_sym_out] = ACTIONS(3699),
    [anon_sym_inout] = ACTIONS(3699),
    [anon_sym_extern] = ACTIONS(3699),
    [anon_sym___attribute__] = ACTIONS(3699),
    [anon_sym_COLON_COLON] = ACTIONS(3701),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3701),
    [anon_sym___declspec] = ACTIONS(3699),
    [anon_sym___based] = ACTIONS(3699),
    [anon_sym___cdecl] = ACTIONS(3699),
    [anon_sym___clrcall] = ACTIONS(3699),
    [anon_sym___stdcall] = ACTIONS(3699),
    [anon_sym___fastcall] = ACTIONS(3699),
    [anon_sym___thiscall] = ACTIONS(3699),
    [anon_sym___vectorcall] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3701),
    [anon_sym_signed] = ACTIONS(3699),
    [anon_sym_unsigned] = ACTIONS(3699),
    [anon_sym_long] = ACTIONS(3699),
    [anon_sym_short] = ACTIONS(3699),
    [anon_sym_LBRACK] = ACTIONS(3699),
    [anon_sym_static] = ACTIONS(3699),
    [anon_sym_register] = ACTIONS(3699),
    [anon_sym_inline] = ACTIONS(3699),
    [anon_sym___inline] = ACTIONS(3699),
    [anon_sym___inline__] = ACTIONS(3699),
    [anon_sym___forceinline] = ACTIONS(3699),
    [anon_sym_thread_local] = ACTIONS(3699),
    [anon_sym___thread] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3699),
    [anon_sym_constexpr] = ACTIONS(3699),
    [anon_sym_volatile] = ACTIONS(3699),
    [anon_sym_restrict] = ACTIONS(3699),
    [anon_sym___restrict__] = ACTIONS(3699),
    [anon_sym__Atomic] = ACTIONS(3699),
    [anon_sym__Noreturn] = ACTIONS(3699),
    [anon_sym_noreturn] = ACTIONS(3699),
    [anon_sym_mutable] = ACTIONS(3699),
    [anon_sym_constinit] = ACTIONS(3699),
    [anon_sym_consteval] = ACTIONS(3699),
    [anon_sym_alignas] = ACTIONS(3699),
    [anon_sym__Alignas] = ACTIONS(3699),
    [sym_primitive_type] = ACTIONS(3699),
    [anon_sym_enum] = ACTIONS(3699),
    [anon_sym_class] = ACTIONS(3699),
    [anon_sym_struct] = ACTIONS(3699),
    [anon_sym_union] = ACTIONS(3699),
    [anon_sym_if] = ACTIONS(3699),
    [anon_sym_switch] = ACTIONS(3699),
    [anon_sym_case] = ACTIONS(3699),
    [anon_sym_default] = ACTIONS(3699),
    [anon_sym_while] = ACTIONS(3699),
    [anon_sym_do] = ACTIONS(3699),
    [anon_sym_for] = ACTIONS(3699),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_break] = ACTIONS(3699),
    [anon_sym_continue] = ACTIONS(3699),
    [anon_sym_goto] = ACTIONS(3699),
    [anon_sym___try] = ACTIONS(3699),
    [anon_sym___leave] = ACTIONS(3699),
    [anon_sym_not] = ACTIONS(3699),
    [anon_sym_compl] = ACTIONS(3699),
    [anon_sym_DASH_DASH] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3701),
    [anon_sym_sizeof] = ACTIONS(3699),
    [anon_sym___alignof__] = ACTIONS(3699),
    [anon_sym___alignof] = ACTIONS(3699),
    [anon_sym__alignof] = ACTIONS(3699),
    [anon_sym_alignof] = ACTIONS(3699),
    [anon_sym__Alignof] = ACTIONS(3699),
    [anon_sym_offsetof] = ACTIONS(3699),
    [anon_sym__Generic] = ACTIONS(3699),
    [anon_sym_asm] = ACTIONS(3699),
    [anon_sym___asm__] = ACTIONS(3699),
    [sym_number_literal] = ACTIONS(3701),
    [anon_sym_L_SQUOTE] = ACTIONS(3701),
    [anon_sym_u_SQUOTE] = ACTIONS(3701),
    [anon_sym_U_SQUOTE] = ACTIONS(3701),
    [anon_sym_u8_SQUOTE] = ACTIONS(3701),
    [anon_sym_SQUOTE] = ACTIONS(3701),
    [anon_sym_L_DQUOTE] = ACTIONS(3701),
    [anon_sym_u_DQUOTE] = ACTIONS(3701),
    [anon_sym_U_DQUOTE] = ACTIONS(3701),
    [anon_sym_u8_DQUOTE] = ACTIONS(3701),
    [anon_sym_DQUOTE] = ACTIONS(3701),
    [sym_true] = ACTIONS(3699),
    [sym_false] = ACTIONS(3699),
    [anon_sym_NULL] = ACTIONS(3699),
    [anon_sym_nullptr] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3699),
    [anon_sym_let] = ACTIONS(3699),
    [anon_sym_This] = ACTIONS(3699),
    [anon_sym_decltype] = ACTIONS(3699),
    [sym_virtual] = ACTIONS(3699),
    [anon_sym_explicit] = ACTIONS(3699),
    [anon_sym_typename] = ACTIONS(3699),
    [anon_sym_template] = ACTIONS(3699),
    [anon_sym_operator] = ACTIONS(3699),
    [anon_sym_try] = ACTIONS(3699),
    [anon_sym_delete] = ACTIONS(3699),
    [anon_sym_throw] = ACTIONS(3699),
    [anon_sym_namespace] = ACTIONS(3699),
    [anon_sym_using] = ACTIONS(3699),
    [anon_sym_static_assert] = ACTIONS(3699),
    [anon_sym_concept] = ACTIONS(3699),
    [anon_sym_co_return] = ACTIONS(3699),
    [anon_sym_co_yield] = ACTIONS(3699),
    [anon_sym_R_DQUOTE] = ACTIONS(3701),
    [anon_sym_LR_DQUOTE] = ACTIONS(3701),
    [anon_sym_uR_DQUOTE] = ACTIONS(3701),
    [anon_sym_UR_DQUOTE] = ACTIONS(3701),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3701),
    [anon_sym_co_await] = ACTIONS(3699),
    [anon_sym_new] = ACTIONS(3699),
    [anon_sym_requires] = ACTIONS(3699),
    [sym_this] = ACTIONS(3699),
    [anon_sym_discard] = ACTIONS(3699),
    [anon_sym_precise] = ACTIONS(3699),
    [anon_sym_shared] = ACTIONS(3699),
    [anon_sym_groupshared] = ACTIONS(3699),
    [anon_sym_uniform] = ACTIONS(3699),
    [anon_sym_row_major] = ACTIONS(3699),
    [anon_sym_column_major] = ACTIONS(3699),
    [anon_sym_globallycoherent] = ACTIONS(3699),
    [anon_sym_centroid] = ACTIONS(3699),
    [anon_sym_noperspective] = ACTIONS(3699),
    [anon_sym_nointerpolation] = ACTIONS(3699),
    [anon_sym_sample] = ACTIONS(3699),
    [anon_sym_linear] = ACTIONS(3699),
    [anon_sym_snorm] = ACTIONS(3699),
    [anon_sym_unorm] = ACTIONS(3699),
    [anon_sym_point] = ACTIONS(3699),
    [anon_sym_line] = ACTIONS(3699),
    [anon_sym_triangleadj] = ACTIONS(3699),
    [anon_sym_lineadj] = ACTIONS(3699),
    [anon_sym_triangle] = ACTIONS(3699),
    [anon_sym_cbuffer] = ACTIONS(3699),
    [anon_sym_interface] = ACTIONS(3699),
    [anon_sym_extension] = ACTIONS(3699),
  },
  [909] = {
    [sym_identifier] = ACTIONS(3410),
    [aux_sym_preproc_include_token1] = ACTIONS(3410),
    [aux_sym_preproc_def_token1] = ACTIONS(3410),
    [aux_sym_preproc_if_token1] = ACTIONS(3410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3410),
    [sym_preproc_directive] = ACTIONS(3410),
    [anon_sym_LPAREN2] = ACTIONS(3412),
    [anon_sym_BANG] = ACTIONS(3412),
    [anon_sym_TILDE] = ACTIONS(3412),
    [anon_sym_DASH] = ACTIONS(3410),
    [anon_sym_PLUS] = ACTIONS(3410),
    [anon_sym_STAR] = ACTIONS(3412),
    [anon_sym_AMP_AMP] = ACTIONS(3412),
    [anon_sym_AMP] = ACTIONS(3410),
    [anon_sym_SEMI] = ACTIONS(3412),
    [anon_sym___extension__] = ACTIONS(3410),
    [anon_sym_typedef] = ACTIONS(3410),
    [anon_sym_in] = ACTIONS(3410),
    [anon_sym_out] = ACTIONS(3410),
    [anon_sym_inout] = ACTIONS(3410),
    [anon_sym_extern] = ACTIONS(3410),
    [anon_sym___attribute__] = ACTIONS(3410),
    [anon_sym_COLON_COLON] = ACTIONS(3412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3412),
    [anon_sym___declspec] = ACTIONS(3410),
    [anon_sym___based] = ACTIONS(3410),
    [anon_sym___cdecl] = ACTIONS(3410),
    [anon_sym___clrcall] = ACTIONS(3410),
    [anon_sym___stdcall] = ACTIONS(3410),
    [anon_sym___fastcall] = ACTIONS(3410),
    [anon_sym___thiscall] = ACTIONS(3410),
    [anon_sym___vectorcall] = ACTIONS(3410),
    [anon_sym_LBRACE] = ACTIONS(3412),
    [anon_sym_RBRACE] = ACTIONS(3412),
    [anon_sym_signed] = ACTIONS(3410),
    [anon_sym_unsigned] = ACTIONS(3410),
    [anon_sym_long] = ACTIONS(3410),
    [anon_sym_short] = ACTIONS(3410),
    [anon_sym_LBRACK] = ACTIONS(3410),
    [anon_sym_static] = ACTIONS(3410),
    [anon_sym_register] = ACTIONS(3410),
    [anon_sym_inline] = ACTIONS(3410),
    [anon_sym___inline] = ACTIONS(3410),
    [anon_sym___inline__] = ACTIONS(3410),
    [anon_sym___forceinline] = ACTIONS(3410),
    [anon_sym_thread_local] = ACTIONS(3410),
    [anon_sym___thread] = ACTIONS(3410),
    [anon_sym_const] = ACTIONS(3410),
    [anon_sym_constexpr] = ACTIONS(3410),
    [anon_sym_volatile] = ACTIONS(3410),
    [anon_sym_restrict] = ACTIONS(3410),
    [anon_sym___restrict__] = ACTIONS(3410),
    [anon_sym__Atomic] = ACTIONS(3410),
    [anon_sym__Noreturn] = ACTIONS(3410),
    [anon_sym_noreturn] = ACTIONS(3410),
    [anon_sym_mutable] = ACTIONS(3410),
    [anon_sym_constinit] = ACTIONS(3410),
    [anon_sym_consteval] = ACTIONS(3410),
    [anon_sym_alignas] = ACTIONS(3410),
    [anon_sym__Alignas] = ACTIONS(3410),
    [sym_primitive_type] = ACTIONS(3410),
    [anon_sym_enum] = ACTIONS(3410),
    [anon_sym_class] = ACTIONS(3410),
    [anon_sym_struct] = ACTIONS(3410),
    [anon_sym_union] = ACTIONS(3410),
    [anon_sym_if] = ACTIONS(3410),
    [anon_sym_switch] = ACTIONS(3410),
    [anon_sym_case] = ACTIONS(3410),
    [anon_sym_default] = ACTIONS(3410),
    [anon_sym_while] = ACTIONS(3410),
    [anon_sym_do] = ACTIONS(3410),
    [anon_sym_for] = ACTIONS(3410),
    [anon_sym_return] = ACTIONS(3410),
    [anon_sym_break] = ACTIONS(3410),
    [anon_sym_continue] = ACTIONS(3410),
    [anon_sym_goto] = ACTIONS(3410),
    [anon_sym___try] = ACTIONS(3410),
    [anon_sym___leave] = ACTIONS(3410),
    [anon_sym_not] = ACTIONS(3410),
    [anon_sym_compl] = ACTIONS(3410),
    [anon_sym_DASH_DASH] = ACTIONS(3412),
    [anon_sym_PLUS_PLUS] = ACTIONS(3412),
    [anon_sym_sizeof] = ACTIONS(3410),
    [anon_sym___alignof__] = ACTIONS(3410),
    [anon_sym___alignof] = ACTIONS(3410),
    [anon_sym__alignof] = ACTIONS(3410),
    [anon_sym_alignof] = ACTIONS(3410),
    [anon_sym__Alignof] = ACTIONS(3410),
    [anon_sym_offsetof] = ACTIONS(3410),
    [anon_sym__Generic] = ACTIONS(3410),
    [anon_sym_asm] = ACTIONS(3410),
    [anon_sym___asm__] = ACTIONS(3410),
    [sym_number_literal] = ACTIONS(3412),
    [anon_sym_L_SQUOTE] = ACTIONS(3412),
    [anon_sym_u_SQUOTE] = ACTIONS(3412),
    [anon_sym_U_SQUOTE] = ACTIONS(3412),
    [anon_sym_u8_SQUOTE] = ACTIONS(3412),
    [anon_sym_SQUOTE] = ACTIONS(3412),
    [anon_sym_L_DQUOTE] = ACTIONS(3412),
    [anon_sym_u_DQUOTE] = ACTIONS(3412),
    [anon_sym_U_DQUOTE] = ACTIONS(3412),
    [anon_sym_u8_DQUOTE] = ACTIONS(3412),
    [anon_sym_DQUOTE] = ACTIONS(3412),
    [sym_true] = ACTIONS(3410),
    [sym_false] = ACTIONS(3410),
    [anon_sym_NULL] = ACTIONS(3410),
    [anon_sym_nullptr] = ACTIONS(3410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3410),
    [anon_sym_let] = ACTIONS(3410),
    [anon_sym_This] = ACTIONS(3410),
    [anon_sym_decltype] = ACTIONS(3410),
    [sym_virtual] = ACTIONS(3410),
    [anon_sym_explicit] = ACTIONS(3410),
    [anon_sym_typename] = ACTIONS(3410),
    [anon_sym_template] = ACTIONS(3410),
    [anon_sym_operator] = ACTIONS(3410),
    [anon_sym_try] = ACTIONS(3410),
    [anon_sym_delete] = ACTIONS(3410),
    [anon_sym_throw] = ACTIONS(3410),
    [anon_sym_namespace] = ACTIONS(3410),
    [anon_sym_using] = ACTIONS(3410),
    [anon_sym_static_assert] = ACTIONS(3410),
    [anon_sym_concept] = ACTIONS(3410),
    [anon_sym_co_return] = ACTIONS(3410),
    [anon_sym_co_yield] = ACTIONS(3410),
    [anon_sym_R_DQUOTE] = ACTIONS(3412),
    [anon_sym_LR_DQUOTE] = ACTIONS(3412),
    [anon_sym_uR_DQUOTE] = ACTIONS(3412),
    [anon_sym_UR_DQUOTE] = ACTIONS(3412),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3412),
    [anon_sym_co_await] = ACTIONS(3410),
    [anon_sym_new] = ACTIONS(3410),
    [anon_sym_requires] = ACTIONS(3410),
    [sym_this] = ACTIONS(3410),
    [anon_sym_discard] = ACTIONS(3410),
    [anon_sym_precise] = ACTIONS(3410),
    [anon_sym_shared] = ACTIONS(3410),
    [anon_sym_groupshared] = ACTIONS(3410),
    [anon_sym_uniform] = ACTIONS(3410),
    [anon_sym_row_major] = ACTIONS(3410),
    [anon_sym_column_major] = ACTIONS(3410),
    [anon_sym_globallycoherent] = ACTIONS(3410),
    [anon_sym_centroid] = ACTIONS(3410),
    [anon_sym_noperspective] = ACTIONS(3410),
    [anon_sym_nointerpolation] = ACTIONS(3410),
    [anon_sym_sample] = ACTIONS(3410),
    [anon_sym_linear] = ACTIONS(3410),
    [anon_sym_snorm] = ACTIONS(3410),
    [anon_sym_unorm] = ACTIONS(3410),
    [anon_sym_point] = ACTIONS(3410),
    [anon_sym_line] = ACTIONS(3410),
    [anon_sym_triangleadj] = ACTIONS(3410),
    [anon_sym_lineadj] = ACTIONS(3410),
    [anon_sym_triangle] = ACTIONS(3410),
    [anon_sym_cbuffer] = ACTIONS(3410),
    [anon_sym_interface] = ACTIONS(3410),
    [anon_sym_extension] = ACTIONS(3410),
  },
  [910] = {
    [sym_identifier] = ACTIONS(3410),
    [aux_sym_preproc_include_token1] = ACTIONS(3410),
    [aux_sym_preproc_def_token1] = ACTIONS(3410),
    [aux_sym_preproc_if_token1] = ACTIONS(3410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3410),
    [sym_preproc_directive] = ACTIONS(3410),
    [anon_sym_LPAREN2] = ACTIONS(3412),
    [anon_sym_BANG] = ACTIONS(3412),
    [anon_sym_TILDE] = ACTIONS(3412),
    [anon_sym_DASH] = ACTIONS(3410),
    [anon_sym_PLUS] = ACTIONS(3410),
    [anon_sym_STAR] = ACTIONS(3412),
    [anon_sym_AMP_AMP] = ACTIONS(3412),
    [anon_sym_AMP] = ACTIONS(3410),
    [anon_sym_SEMI] = ACTIONS(3412),
    [anon_sym___extension__] = ACTIONS(3410),
    [anon_sym_typedef] = ACTIONS(3410),
    [anon_sym_in] = ACTIONS(3410),
    [anon_sym_out] = ACTIONS(3410),
    [anon_sym_inout] = ACTIONS(3410),
    [anon_sym_extern] = ACTIONS(3410),
    [anon_sym___attribute__] = ACTIONS(3410),
    [anon_sym_COLON_COLON] = ACTIONS(3412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3412),
    [anon_sym___declspec] = ACTIONS(3410),
    [anon_sym___based] = ACTIONS(3410),
    [anon_sym___cdecl] = ACTIONS(3410),
    [anon_sym___clrcall] = ACTIONS(3410),
    [anon_sym___stdcall] = ACTIONS(3410),
    [anon_sym___fastcall] = ACTIONS(3410),
    [anon_sym___thiscall] = ACTIONS(3410),
    [anon_sym___vectorcall] = ACTIONS(3410),
    [anon_sym_LBRACE] = ACTIONS(3412),
    [anon_sym_RBRACE] = ACTIONS(3412),
    [anon_sym_signed] = ACTIONS(3410),
    [anon_sym_unsigned] = ACTIONS(3410),
    [anon_sym_long] = ACTIONS(3410),
    [anon_sym_short] = ACTIONS(3410),
    [anon_sym_LBRACK] = ACTIONS(3410),
    [anon_sym_static] = ACTIONS(3410),
    [anon_sym_register] = ACTIONS(3410),
    [anon_sym_inline] = ACTIONS(3410),
    [anon_sym___inline] = ACTIONS(3410),
    [anon_sym___inline__] = ACTIONS(3410),
    [anon_sym___forceinline] = ACTIONS(3410),
    [anon_sym_thread_local] = ACTIONS(3410),
    [anon_sym___thread] = ACTIONS(3410),
    [anon_sym_const] = ACTIONS(3410),
    [anon_sym_constexpr] = ACTIONS(3410),
    [anon_sym_volatile] = ACTIONS(3410),
    [anon_sym_restrict] = ACTIONS(3410),
    [anon_sym___restrict__] = ACTIONS(3410),
    [anon_sym__Atomic] = ACTIONS(3410),
    [anon_sym__Noreturn] = ACTIONS(3410),
    [anon_sym_noreturn] = ACTIONS(3410),
    [anon_sym_mutable] = ACTIONS(3410),
    [anon_sym_constinit] = ACTIONS(3410),
    [anon_sym_consteval] = ACTIONS(3410),
    [anon_sym_alignas] = ACTIONS(3410),
    [anon_sym__Alignas] = ACTIONS(3410),
    [sym_primitive_type] = ACTIONS(3410),
    [anon_sym_enum] = ACTIONS(3410),
    [anon_sym_class] = ACTIONS(3410),
    [anon_sym_struct] = ACTIONS(3410),
    [anon_sym_union] = ACTIONS(3410),
    [anon_sym_if] = ACTIONS(3410),
    [anon_sym_switch] = ACTIONS(3410),
    [anon_sym_case] = ACTIONS(3410),
    [anon_sym_default] = ACTIONS(3410),
    [anon_sym_while] = ACTIONS(3410),
    [anon_sym_do] = ACTIONS(3410),
    [anon_sym_for] = ACTIONS(3410),
    [anon_sym_return] = ACTIONS(3410),
    [anon_sym_break] = ACTIONS(3410),
    [anon_sym_continue] = ACTIONS(3410),
    [anon_sym_goto] = ACTIONS(3410),
    [anon_sym___try] = ACTIONS(3410),
    [anon_sym___leave] = ACTIONS(3410),
    [anon_sym_not] = ACTIONS(3410),
    [anon_sym_compl] = ACTIONS(3410),
    [anon_sym_DASH_DASH] = ACTIONS(3412),
    [anon_sym_PLUS_PLUS] = ACTIONS(3412),
    [anon_sym_sizeof] = ACTIONS(3410),
    [anon_sym___alignof__] = ACTIONS(3410),
    [anon_sym___alignof] = ACTIONS(3410),
    [anon_sym__alignof] = ACTIONS(3410),
    [anon_sym_alignof] = ACTIONS(3410),
    [anon_sym__Alignof] = ACTIONS(3410),
    [anon_sym_offsetof] = ACTIONS(3410),
    [anon_sym__Generic] = ACTIONS(3410),
    [anon_sym_asm] = ACTIONS(3410),
    [anon_sym___asm__] = ACTIONS(3410),
    [sym_number_literal] = ACTIONS(3412),
    [anon_sym_L_SQUOTE] = ACTIONS(3412),
    [anon_sym_u_SQUOTE] = ACTIONS(3412),
    [anon_sym_U_SQUOTE] = ACTIONS(3412),
    [anon_sym_u8_SQUOTE] = ACTIONS(3412),
    [anon_sym_SQUOTE] = ACTIONS(3412),
    [anon_sym_L_DQUOTE] = ACTIONS(3412),
    [anon_sym_u_DQUOTE] = ACTIONS(3412),
    [anon_sym_U_DQUOTE] = ACTIONS(3412),
    [anon_sym_u8_DQUOTE] = ACTIONS(3412),
    [anon_sym_DQUOTE] = ACTIONS(3412),
    [sym_true] = ACTIONS(3410),
    [sym_false] = ACTIONS(3410),
    [anon_sym_NULL] = ACTIONS(3410),
    [anon_sym_nullptr] = ACTIONS(3410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3410),
    [anon_sym_let] = ACTIONS(3410),
    [anon_sym_This] = ACTIONS(3410),
    [anon_sym_decltype] = ACTIONS(3410),
    [sym_virtual] = ACTIONS(3410),
    [anon_sym_explicit] = ACTIONS(3410),
    [anon_sym_typename] = ACTIONS(3410),
    [anon_sym_template] = ACTIONS(3410),
    [anon_sym_operator] = ACTIONS(3410),
    [anon_sym_try] = ACTIONS(3410),
    [anon_sym_delete] = ACTIONS(3410),
    [anon_sym_throw] = ACTIONS(3410),
    [anon_sym_namespace] = ACTIONS(3410),
    [anon_sym_using] = ACTIONS(3410),
    [anon_sym_static_assert] = ACTIONS(3410),
    [anon_sym_concept] = ACTIONS(3410),
    [anon_sym_co_return] = ACTIONS(3410),
    [anon_sym_co_yield] = ACTIONS(3410),
    [anon_sym_R_DQUOTE] = ACTIONS(3412),
    [anon_sym_LR_DQUOTE] = ACTIONS(3412),
    [anon_sym_uR_DQUOTE] = ACTIONS(3412),
    [anon_sym_UR_DQUOTE] = ACTIONS(3412),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3412),
    [anon_sym_co_await] = ACTIONS(3410),
    [anon_sym_new] = ACTIONS(3410),
    [anon_sym_requires] = ACTIONS(3410),
    [sym_this] = ACTIONS(3410),
    [anon_sym_discard] = ACTIONS(3410),
    [anon_sym_precise] = ACTIONS(3410),
    [anon_sym_shared] = ACTIONS(3410),
    [anon_sym_groupshared] = ACTIONS(3410),
    [anon_sym_uniform] = ACTIONS(3410),
    [anon_sym_row_major] = ACTIONS(3410),
    [anon_sym_column_major] = ACTIONS(3410),
    [anon_sym_globallycoherent] = ACTIONS(3410),
    [anon_sym_centroid] = ACTIONS(3410),
    [anon_sym_noperspective] = ACTIONS(3410),
    [anon_sym_nointerpolation] = ACTIONS(3410),
    [anon_sym_sample] = ACTIONS(3410),
    [anon_sym_linear] = ACTIONS(3410),
    [anon_sym_snorm] = ACTIONS(3410),
    [anon_sym_unorm] = ACTIONS(3410),
    [anon_sym_point] = ACTIONS(3410),
    [anon_sym_line] = ACTIONS(3410),
    [anon_sym_triangleadj] = ACTIONS(3410),
    [anon_sym_lineadj] = ACTIONS(3410),
    [anon_sym_triangle] = ACTIONS(3410),
    [anon_sym_cbuffer] = ACTIONS(3410),
    [anon_sym_interface] = ACTIONS(3410),
    [anon_sym_extension] = ACTIONS(3410),
  },
  [911] = {
    [sym_identifier] = ACTIONS(3501),
    [aux_sym_preproc_include_token1] = ACTIONS(3501),
    [aux_sym_preproc_def_token1] = ACTIONS(3501),
    [aux_sym_preproc_if_token1] = ACTIONS(3501),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3501),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3501),
    [sym_preproc_directive] = ACTIONS(3501),
    [anon_sym_LPAREN2] = ACTIONS(3503),
    [anon_sym_BANG] = ACTIONS(3503),
    [anon_sym_TILDE] = ACTIONS(3503),
    [anon_sym_DASH] = ACTIONS(3501),
    [anon_sym_PLUS] = ACTIONS(3501),
    [anon_sym_STAR] = ACTIONS(3503),
    [anon_sym_AMP_AMP] = ACTIONS(3503),
    [anon_sym_AMP] = ACTIONS(3501),
    [anon_sym_SEMI] = ACTIONS(3503),
    [anon_sym___extension__] = ACTIONS(3501),
    [anon_sym_typedef] = ACTIONS(3501),
    [anon_sym_in] = ACTIONS(3501),
    [anon_sym_out] = ACTIONS(3501),
    [anon_sym_inout] = ACTIONS(3501),
    [anon_sym_extern] = ACTIONS(3501),
    [anon_sym___attribute__] = ACTIONS(3501),
    [anon_sym_COLON_COLON] = ACTIONS(3503),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3503),
    [anon_sym___declspec] = ACTIONS(3501),
    [anon_sym___based] = ACTIONS(3501),
    [anon_sym___cdecl] = ACTIONS(3501),
    [anon_sym___clrcall] = ACTIONS(3501),
    [anon_sym___stdcall] = ACTIONS(3501),
    [anon_sym___fastcall] = ACTIONS(3501),
    [anon_sym___thiscall] = ACTIONS(3501),
    [anon_sym___vectorcall] = ACTIONS(3501),
    [anon_sym_LBRACE] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(3503),
    [anon_sym_signed] = ACTIONS(3501),
    [anon_sym_unsigned] = ACTIONS(3501),
    [anon_sym_long] = ACTIONS(3501),
    [anon_sym_short] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(3501),
    [anon_sym_static] = ACTIONS(3501),
    [anon_sym_register] = ACTIONS(3501),
    [anon_sym_inline] = ACTIONS(3501),
    [anon_sym___inline] = ACTIONS(3501),
    [anon_sym___inline__] = ACTIONS(3501),
    [anon_sym___forceinline] = ACTIONS(3501),
    [anon_sym_thread_local] = ACTIONS(3501),
    [anon_sym___thread] = ACTIONS(3501),
    [anon_sym_const] = ACTIONS(3501),
    [anon_sym_constexpr] = ACTIONS(3501),
    [anon_sym_volatile] = ACTIONS(3501),
    [anon_sym_restrict] = ACTIONS(3501),
    [anon_sym___restrict__] = ACTIONS(3501),
    [anon_sym__Atomic] = ACTIONS(3501),
    [anon_sym__Noreturn] = ACTIONS(3501),
    [anon_sym_noreturn] = ACTIONS(3501),
    [anon_sym_mutable] = ACTIONS(3501),
    [anon_sym_constinit] = ACTIONS(3501),
    [anon_sym_consteval] = ACTIONS(3501),
    [anon_sym_alignas] = ACTIONS(3501),
    [anon_sym__Alignas] = ACTIONS(3501),
    [sym_primitive_type] = ACTIONS(3501),
    [anon_sym_enum] = ACTIONS(3501),
    [anon_sym_class] = ACTIONS(3501),
    [anon_sym_struct] = ACTIONS(3501),
    [anon_sym_union] = ACTIONS(3501),
    [anon_sym_if] = ACTIONS(3501),
    [anon_sym_switch] = ACTIONS(3501),
    [anon_sym_case] = ACTIONS(3501),
    [anon_sym_default] = ACTIONS(3501),
    [anon_sym_while] = ACTIONS(3501),
    [anon_sym_do] = ACTIONS(3501),
    [anon_sym_for] = ACTIONS(3501),
    [anon_sym_return] = ACTIONS(3501),
    [anon_sym_break] = ACTIONS(3501),
    [anon_sym_continue] = ACTIONS(3501),
    [anon_sym_goto] = ACTIONS(3501),
    [anon_sym___try] = ACTIONS(3501),
    [anon_sym___leave] = ACTIONS(3501),
    [anon_sym_not] = ACTIONS(3501),
    [anon_sym_compl] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(3503),
    [anon_sym_PLUS_PLUS] = ACTIONS(3503),
    [anon_sym_sizeof] = ACTIONS(3501),
    [anon_sym___alignof__] = ACTIONS(3501),
    [anon_sym___alignof] = ACTIONS(3501),
    [anon_sym__alignof] = ACTIONS(3501),
    [anon_sym_alignof] = ACTIONS(3501),
    [anon_sym__Alignof] = ACTIONS(3501),
    [anon_sym_offsetof] = ACTIONS(3501),
    [anon_sym__Generic] = ACTIONS(3501),
    [anon_sym_asm] = ACTIONS(3501),
    [anon_sym___asm__] = ACTIONS(3501),
    [sym_number_literal] = ACTIONS(3503),
    [anon_sym_L_SQUOTE] = ACTIONS(3503),
    [anon_sym_u_SQUOTE] = ACTIONS(3503),
    [anon_sym_U_SQUOTE] = ACTIONS(3503),
    [anon_sym_u8_SQUOTE] = ACTIONS(3503),
    [anon_sym_SQUOTE] = ACTIONS(3503),
    [anon_sym_L_DQUOTE] = ACTIONS(3503),
    [anon_sym_u_DQUOTE] = ACTIONS(3503),
    [anon_sym_U_DQUOTE] = ACTIONS(3503),
    [anon_sym_u8_DQUOTE] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3503),
    [sym_true] = ACTIONS(3501),
    [sym_false] = ACTIONS(3501),
    [anon_sym_NULL] = ACTIONS(3501),
    [anon_sym_nullptr] = ACTIONS(3501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3501),
    [anon_sym_let] = ACTIONS(3501),
    [anon_sym_This] = ACTIONS(3501),
    [anon_sym_decltype] = ACTIONS(3501),
    [sym_virtual] = ACTIONS(3501),
    [anon_sym_explicit] = ACTIONS(3501),
    [anon_sym_typename] = ACTIONS(3501),
    [anon_sym_template] = ACTIONS(3501),
    [anon_sym_operator] = ACTIONS(3501),
    [anon_sym_try] = ACTIONS(3501),
    [anon_sym_delete] = ACTIONS(3501),
    [anon_sym_throw] = ACTIONS(3501),
    [anon_sym_namespace] = ACTIONS(3501),
    [anon_sym_using] = ACTIONS(3501),
    [anon_sym_static_assert] = ACTIONS(3501),
    [anon_sym_concept] = ACTIONS(3501),
    [anon_sym_co_return] = ACTIONS(3501),
    [anon_sym_co_yield] = ACTIONS(3501),
    [anon_sym_R_DQUOTE] = ACTIONS(3503),
    [anon_sym_LR_DQUOTE] = ACTIONS(3503),
    [anon_sym_uR_DQUOTE] = ACTIONS(3503),
    [anon_sym_UR_DQUOTE] = ACTIONS(3503),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3503),
    [anon_sym_co_await] = ACTIONS(3501),
    [anon_sym_new] = ACTIONS(3501),
    [anon_sym_requires] = ACTIONS(3501),
    [sym_this] = ACTIONS(3501),
    [anon_sym_discard] = ACTIONS(3501),
    [anon_sym_precise] = ACTIONS(3501),
    [anon_sym_shared] = ACTIONS(3501),
    [anon_sym_groupshared] = ACTIONS(3501),
    [anon_sym_uniform] = ACTIONS(3501),
    [anon_sym_row_major] = ACTIONS(3501),
    [anon_sym_column_major] = ACTIONS(3501),
    [anon_sym_globallycoherent] = ACTIONS(3501),
    [anon_sym_centroid] = ACTIONS(3501),
    [anon_sym_noperspective] = ACTIONS(3501),
    [anon_sym_nointerpolation] = ACTIONS(3501),
    [anon_sym_sample] = ACTIONS(3501),
    [anon_sym_linear] = ACTIONS(3501),
    [anon_sym_snorm] = ACTIONS(3501),
    [anon_sym_unorm] = ACTIONS(3501),
    [anon_sym_point] = ACTIONS(3501),
    [anon_sym_line] = ACTIONS(3501),
    [anon_sym_triangleadj] = ACTIONS(3501),
    [anon_sym_lineadj] = ACTIONS(3501),
    [anon_sym_triangle] = ACTIONS(3501),
    [anon_sym_cbuffer] = ACTIONS(3501),
    [anon_sym_interface] = ACTIONS(3501),
    [anon_sym_extension] = ACTIONS(3501),
  },
  [912] = {
    [sym_identifier] = ACTIONS(3509),
    [aux_sym_preproc_include_token1] = ACTIONS(3509),
    [aux_sym_preproc_def_token1] = ACTIONS(3509),
    [aux_sym_preproc_if_token1] = ACTIONS(3509),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3509),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3509),
    [sym_preproc_directive] = ACTIONS(3509),
    [anon_sym_LPAREN2] = ACTIONS(3511),
    [anon_sym_BANG] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3509),
    [anon_sym_PLUS] = ACTIONS(3509),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3511),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_SEMI] = ACTIONS(3511),
    [anon_sym___extension__] = ACTIONS(3509),
    [anon_sym_typedef] = ACTIONS(3509),
    [anon_sym_in] = ACTIONS(3509),
    [anon_sym_out] = ACTIONS(3509),
    [anon_sym_inout] = ACTIONS(3509),
    [anon_sym_extern] = ACTIONS(3509),
    [anon_sym___attribute__] = ACTIONS(3509),
    [anon_sym_COLON_COLON] = ACTIONS(3511),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3511),
    [anon_sym___declspec] = ACTIONS(3509),
    [anon_sym___based] = ACTIONS(3509),
    [anon_sym___cdecl] = ACTIONS(3509),
    [anon_sym___clrcall] = ACTIONS(3509),
    [anon_sym___stdcall] = ACTIONS(3509),
    [anon_sym___fastcall] = ACTIONS(3509),
    [anon_sym___thiscall] = ACTIONS(3509),
    [anon_sym___vectorcall] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_RBRACE] = ACTIONS(3511),
    [anon_sym_signed] = ACTIONS(3509),
    [anon_sym_unsigned] = ACTIONS(3509),
    [anon_sym_long] = ACTIONS(3509),
    [anon_sym_short] = ACTIONS(3509),
    [anon_sym_LBRACK] = ACTIONS(3509),
    [anon_sym_static] = ACTIONS(3509),
    [anon_sym_register] = ACTIONS(3509),
    [anon_sym_inline] = ACTIONS(3509),
    [anon_sym___inline] = ACTIONS(3509),
    [anon_sym___inline__] = ACTIONS(3509),
    [anon_sym___forceinline] = ACTIONS(3509),
    [anon_sym_thread_local] = ACTIONS(3509),
    [anon_sym___thread] = ACTIONS(3509),
    [anon_sym_const] = ACTIONS(3509),
    [anon_sym_constexpr] = ACTIONS(3509),
    [anon_sym_volatile] = ACTIONS(3509),
    [anon_sym_restrict] = ACTIONS(3509),
    [anon_sym___restrict__] = ACTIONS(3509),
    [anon_sym__Atomic] = ACTIONS(3509),
    [anon_sym__Noreturn] = ACTIONS(3509),
    [anon_sym_noreturn] = ACTIONS(3509),
    [anon_sym_mutable] = ACTIONS(3509),
    [anon_sym_constinit] = ACTIONS(3509),
    [anon_sym_consteval] = ACTIONS(3509),
    [anon_sym_alignas] = ACTIONS(3509),
    [anon_sym__Alignas] = ACTIONS(3509),
    [sym_primitive_type] = ACTIONS(3509),
    [anon_sym_enum] = ACTIONS(3509),
    [anon_sym_class] = ACTIONS(3509),
    [anon_sym_struct] = ACTIONS(3509),
    [anon_sym_union] = ACTIONS(3509),
    [anon_sym_if] = ACTIONS(3509),
    [anon_sym_switch] = ACTIONS(3509),
    [anon_sym_case] = ACTIONS(3509),
    [anon_sym_default] = ACTIONS(3509),
    [anon_sym_while] = ACTIONS(3509),
    [anon_sym_do] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3509),
    [anon_sym_return] = ACTIONS(3509),
    [anon_sym_break] = ACTIONS(3509),
    [anon_sym_continue] = ACTIONS(3509),
    [anon_sym_goto] = ACTIONS(3509),
    [anon_sym___try] = ACTIONS(3509),
    [anon_sym___leave] = ACTIONS(3509),
    [anon_sym_not] = ACTIONS(3509),
    [anon_sym_compl] = ACTIONS(3509),
    [anon_sym_DASH_DASH] = ACTIONS(3511),
    [anon_sym_PLUS_PLUS] = ACTIONS(3511),
    [anon_sym_sizeof] = ACTIONS(3509),
    [anon_sym___alignof__] = ACTIONS(3509),
    [anon_sym___alignof] = ACTIONS(3509),
    [anon_sym__alignof] = ACTIONS(3509),
    [anon_sym_alignof] = ACTIONS(3509),
    [anon_sym__Alignof] = ACTIONS(3509),
    [anon_sym_offsetof] = ACTIONS(3509),
    [anon_sym__Generic] = ACTIONS(3509),
    [anon_sym_asm] = ACTIONS(3509),
    [anon_sym___asm__] = ACTIONS(3509),
    [sym_number_literal] = ACTIONS(3511),
    [anon_sym_L_SQUOTE] = ACTIONS(3511),
    [anon_sym_u_SQUOTE] = ACTIONS(3511),
    [anon_sym_U_SQUOTE] = ACTIONS(3511),
    [anon_sym_u8_SQUOTE] = ACTIONS(3511),
    [anon_sym_SQUOTE] = ACTIONS(3511),
    [anon_sym_L_DQUOTE] = ACTIONS(3511),
    [anon_sym_u_DQUOTE] = ACTIONS(3511),
    [anon_sym_U_DQUOTE] = ACTIONS(3511),
    [anon_sym_u8_DQUOTE] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [sym_true] = ACTIONS(3509),
    [sym_false] = ACTIONS(3509),
    [anon_sym_NULL] = ACTIONS(3509),
    [anon_sym_nullptr] = ACTIONS(3509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3509),
    [anon_sym_let] = ACTIONS(3509),
    [anon_sym_This] = ACTIONS(3509),
    [anon_sym_decltype] = ACTIONS(3509),
    [sym_virtual] = ACTIONS(3509),
    [anon_sym_explicit] = ACTIONS(3509),
    [anon_sym_typename] = ACTIONS(3509),
    [anon_sym_template] = ACTIONS(3509),
    [anon_sym_operator] = ACTIONS(3509),
    [anon_sym_try] = ACTIONS(3509),
    [anon_sym_delete] = ACTIONS(3509),
    [anon_sym_throw] = ACTIONS(3509),
    [anon_sym_namespace] = ACTIONS(3509),
    [anon_sym_using] = ACTIONS(3509),
    [anon_sym_static_assert] = ACTIONS(3509),
    [anon_sym_concept] = ACTIONS(3509),
    [anon_sym_co_return] = ACTIONS(3509),
    [anon_sym_co_yield] = ACTIONS(3509),
    [anon_sym_R_DQUOTE] = ACTIONS(3511),
    [anon_sym_LR_DQUOTE] = ACTIONS(3511),
    [anon_sym_uR_DQUOTE] = ACTIONS(3511),
    [anon_sym_UR_DQUOTE] = ACTIONS(3511),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3511),
    [anon_sym_co_await] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3509),
    [anon_sym_requires] = ACTIONS(3509),
    [sym_this] = ACTIONS(3509),
    [anon_sym_discard] = ACTIONS(3509),
    [anon_sym_precise] = ACTIONS(3509),
    [anon_sym_shared] = ACTIONS(3509),
    [anon_sym_groupshared] = ACTIONS(3509),
    [anon_sym_uniform] = ACTIONS(3509),
    [anon_sym_row_major] = ACTIONS(3509),
    [anon_sym_column_major] = ACTIONS(3509),
    [anon_sym_globallycoherent] = ACTIONS(3509),
    [anon_sym_centroid] = ACTIONS(3509),
    [anon_sym_noperspective] = ACTIONS(3509),
    [anon_sym_nointerpolation] = ACTIONS(3509),
    [anon_sym_sample] = ACTIONS(3509),
    [anon_sym_linear] = ACTIONS(3509),
    [anon_sym_snorm] = ACTIONS(3509),
    [anon_sym_unorm] = ACTIONS(3509),
    [anon_sym_point] = ACTIONS(3509),
    [anon_sym_line] = ACTIONS(3509),
    [anon_sym_triangleadj] = ACTIONS(3509),
    [anon_sym_lineadj] = ACTIONS(3509),
    [anon_sym_triangle] = ACTIONS(3509),
    [anon_sym_cbuffer] = ACTIONS(3509),
    [anon_sym_interface] = ACTIONS(3509),
    [anon_sym_extension] = ACTIONS(3509),
  },
  [913] = {
    [sym_identifier] = ACTIONS(3633),
    [aux_sym_preproc_include_token1] = ACTIONS(3633),
    [aux_sym_preproc_def_token1] = ACTIONS(3633),
    [aux_sym_preproc_if_token1] = ACTIONS(3633),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3633),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3633),
    [sym_preproc_directive] = ACTIONS(3633),
    [anon_sym_LPAREN2] = ACTIONS(3635),
    [anon_sym_BANG] = ACTIONS(3635),
    [anon_sym_TILDE] = ACTIONS(3635),
    [anon_sym_DASH] = ACTIONS(3633),
    [anon_sym_PLUS] = ACTIONS(3633),
    [anon_sym_STAR] = ACTIONS(3635),
    [anon_sym_AMP_AMP] = ACTIONS(3635),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym_SEMI] = ACTIONS(3635),
    [anon_sym___extension__] = ACTIONS(3633),
    [anon_sym_typedef] = ACTIONS(3633),
    [anon_sym_in] = ACTIONS(3633),
    [anon_sym_out] = ACTIONS(3633),
    [anon_sym_inout] = ACTIONS(3633),
    [anon_sym_extern] = ACTIONS(3633),
    [anon_sym___attribute__] = ACTIONS(3633),
    [anon_sym_COLON_COLON] = ACTIONS(3635),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3635),
    [anon_sym___declspec] = ACTIONS(3633),
    [anon_sym___based] = ACTIONS(3633),
    [anon_sym___cdecl] = ACTIONS(3633),
    [anon_sym___clrcall] = ACTIONS(3633),
    [anon_sym___stdcall] = ACTIONS(3633),
    [anon_sym___fastcall] = ACTIONS(3633),
    [anon_sym___thiscall] = ACTIONS(3633),
    [anon_sym___vectorcall] = ACTIONS(3633),
    [anon_sym_LBRACE] = ACTIONS(3635),
    [anon_sym_RBRACE] = ACTIONS(3635),
    [anon_sym_signed] = ACTIONS(3633),
    [anon_sym_unsigned] = ACTIONS(3633),
    [anon_sym_long] = ACTIONS(3633),
    [anon_sym_short] = ACTIONS(3633),
    [anon_sym_LBRACK] = ACTIONS(3633),
    [anon_sym_static] = ACTIONS(3633),
    [anon_sym_register] = ACTIONS(3633),
    [anon_sym_inline] = ACTIONS(3633),
    [anon_sym___inline] = ACTIONS(3633),
    [anon_sym___inline__] = ACTIONS(3633),
    [anon_sym___forceinline] = ACTIONS(3633),
    [anon_sym_thread_local] = ACTIONS(3633),
    [anon_sym___thread] = ACTIONS(3633),
    [anon_sym_const] = ACTIONS(3633),
    [anon_sym_constexpr] = ACTIONS(3633),
    [anon_sym_volatile] = ACTIONS(3633),
    [anon_sym_restrict] = ACTIONS(3633),
    [anon_sym___restrict__] = ACTIONS(3633),
    [anon_sym__Atomic] = ACTIONS(3633),
    [anon_sym__Noreturn] = ACTIONS(3633),
    [anon_sym_noreturn] = ACTIONS(3633),
    [anon_sym_mutable] = ACTIONS(3633),
    [anon_sym_constinit] = ACTIONS(3633),
    [anon_sym_consteval] = ACTIONS(3633),
    [anon_sym_alignas] = ACTIONS(3633),
    [anon_sym__Alignas] = ACTIONS(3633),
    [sym_primitive_type] = ACTIONS(3633),
    [anon_sym_enum] = ACTIONS(3633),
    [anon_sym_class] = ACTIONS(3633),
    [anon_sym_struct] = ACTIONS(3633),
    [anon_sym_union] = ACTIONS(3633),
    [anon_sym_if] = ACTIONS(3633),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_case] = ACTIONS(3633),
    [anon_sym_default] = ACTIONS(3633),
    [anon_sym_while] = ACTIONS(3633),
    [anon_sym_do] = ACTIONS(3633),
    [anon_sym_for] = ACTIONS(3633),
    [anon_sym_return] = ACTIONS(3633),
    [anon_sym_break] = ACTIONS(3633),
    [anon_sym_continue] = ACTIONS(3633),
    [anon_sym_goto] = ACTIONS(3633),
    [anon_sym___try] = ACTIONS(3633),
    [anon_sym___leave] = ACTIONS(3633),
    [anon_sym_not] = ACTIONS(3633),
    [anon_sym_compl] = ACTIONS(3633),
    [anon_sym_DASH_DASH] = ACTIONS(3635),
    [anon_sym_PLUS_PLUS] = ACTIONS(3635),
    [anon_sym_sizeof] = ACTIONS(3633),
    [anon_sym___alignof__] = ACTIONS(3633),
    [anon_sym___alignof] = ACTIONS(3633),
    [anon_sym__alignof] = ACTIONS(3633),
    [anon_sym_alignof] = ACTIONS(3633),
    [anon_sym__Alignof] = ACTIONS(3633),
    [anon_sym_offsetof] = ACTIONS(3633),
    [anon_sym__Generic] = ACTIONS(3633),
    [anon_sym_asm] = ACTIONS(3633),
    [anon_sym___asm__] = ACTIONS(3633),
    [sym_number_literal] = ACTIONS(3635),
    [anon_sym_L_SQUOTE] = ACTIONS(3635),
    [anon_sym_u_SQUOTE] = ACTIONS(3635),
    [anon_sym_U_SQUOTE] = ACTIONS(3635),
    [anon_sym_u8_SQUOTE] = ACTIONS(3635),
    [anon_sym_SQUOTE] = ACTIONS(3635),
    [anon_sym_L_DQUOTE] = ACTIONS(3635),
    [anon_sym_u_DQUOTE] = ACTIONS(3635),
    [anon_sym_U_DQUOTE] = ACTIONS(3635),
    [anon_sym_u8_DQUOTE] = ACTIONS(3635),
    [anon_sym_DQUOTE] = ACTIONS(3635),
    [sym_true] = ACTIONS(3633),
    [sym_false] = ACTIONS(3633),
    [anon_sym_NULL] = ACTIONS(3633),
    [anon_sym_nullptr] = ACTIONS(3633),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3633),
    [anon_sym_let] = ACTIONS(3633),
    [anon_sym_This] = ACTIONS(3633),
    [anon_sym_decltype] = ACTIONS(3633),
    [sym_virtual] = ACTIONS(3633),
    [anon_sym_explicit] = ACTIONS(3633),
    [anon_sym_typename] = ACTIONS(3633),
    [anon_sym_template] = ACTIONS(3633),
    [anon_sym_operator] = ACTIONS(3633),
    [anon_sym_try] = ACTIONS(3633),
    [anon_sym_delete] = ACTIONS(3633),
    [anon_sym_throw] = ACTIONS(3633),
    [anon_sym_namespace] = ACTIONS(3633),
    [anon_sym_using] = ACTIONS(3633),
    [anon_sym_static_assert] = ACTIONS(3633),
    [anon_sym_concept] = ACTIONS(3633),
    [anon_sym_co_return] = ACTIONS(3633),
    [anon_sym_co_yield] = ACTIONS(3633),
    [anon_sym_R_DQUOTE] = ACTIONS(3635),
    [anon_sym_LR_DQUOTE] = ACTIONS(3635),
    [anon_sym_uR_DQUOTE] = ACTIONS(3635),
    [anon_sym_UR_DQUOTE] = ACTIONS(3635),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3635),
    [anon_sym_co_await] = ACTIONS(3633),
    [anon_sym_new] = ACTIONS(3633),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(3633),
    [anon_sym_discard] = ACTIONS(3633),
    [anon_sym_precise] = ACTIONS(3633),
    [anon_sym_shared] = ACTIONS(3633),
    [anon_sym_groupshared] = ACTIONS(3633),
    [anon_sym_uniform] = ACTIONS(3633),
    [anon_sym_row_major] = ACTIONS(3633),
    [anon_sym_column_major] = ACTIONS(3633),
    [anon_sym_globallycoherent] = ACTIONS(3633),
    [anon_sym_centroid] = ACTIONS(3633),
    [anon_sym_noperspective] = ACTIONS(3633),
    [anon_sym_nointerpolation] = ACTIONS(3633),
    [anon_sym_sample] = ACTIONS(3633),
    [anon_sym_linear] = ACTIONS(3633),
    [anon_sym_snorm] = ACTIONS(3633),
    [anon_sym_unorm] = ACTIONS(3633),
    [anon_sym_point] = ACTIONS(3633),
    [anon_sym_line] = ACTIONS(3633),
    [anon_sym_triangleadj] = ACTIONS(3633),
    [anon_sym_lineadj] = ACTIONS(3633),
    [anon_sym_triangle] = ACTIONS(3633),
    [anon_sym_cbuffer] = ACTIONS(3633),
    [anon_sym_interface] = ACTIONS(3633),
    [anon_sym_extension] = ACTIONS(3633),
  },
  [914] = {
    [sym_identifier] = ACTIONS(3425),
    [aux_sym_preproc_include_token1] = ACTIONS(3425),
    [aux_sym_preproc_def_token1] = ACTIONS(3425),
    [aux_sym_preproc_if_token1] = ACTIONS(3425),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3425),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3425),
    [sym_preproc_directive] = ACTIONS(3425),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_BANG] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3425),
    [anon_sym_PLUS] = ACTIONS(3425),
    [anon_sym_STAR] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3425),
    [anon_sym_SEMI] = ACTIONS(3427),
    [anon_sym___extension__] = ACTIONS(3425),
    [anon_sym_typedef] = ACTIONS(3425),
    [anon_sym_in] = ACTIONS(3425),
    [anon_sym_out] = ACTIONS(3425),
    [anon_sym_inout] = ACTIONS(3425),
    [anon_sym_extern] = ACTIONS(3425),
    [anon_sym___attribute__] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(3427),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3427),
    [anon_sym___declspec] = ACTIONS(3425),
    [anon_sym___based] = ACTIONS(3425),
    [anon_sym___cdecl] = ACTIONS(3425),
    [anon_sym___clrcall] = ACTIONS(3425),
    [anon_sym___stdcall] = ACTIONS(3425),
    [anon_sym___fastcall] = ACTIONS(3425),
    [anon_sym___thiscall] = ACTIONS(3425),
    [anon_sym___vectorcall] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_RBRACE] = ACTIONS(3427),
    [anon_sym_signed] = ACTIONS(3425),
    [anon_sym_unsigned] = ACTIONS(3425),
    [anon_sym_long] = ACTIONS(3425),
    [anon_sym_short] = ACTIONS(3425),
    [anon_sym_LBRACK] = ACTIONS(3425),
    [anon_sym_static] = ACTIONS(3425),
    [anon_sym_register] = ACTIONS(3425),
    [anon_sym_inline] = ACTIONS(3425),
    [anon_sym___inline] = ACTIONS(3425),
    [anon_sym___inline__] = ACTIONS(3425),
    [anon_sym___forceinline] = ACTIONS(3425),
    [anon_sym_thread_local] = ACTIONS(3425),
    [anon_sym___thread] = ACTIONS(3425),
    [anon_sym_const] = ACTIONS(3425),
    [anon_sym_constexpr] = ACTIONS(3425),
    [anon_sym_volatile] = ACTIONS(3425),
    [anon_sym_restrict] = ACTIONS(3425),
    [anon_sym___restrict__] = ACTIONS(3425),
    [anon_sym__Atomic] = ACTIONS(3425),
    [anon_sym__Noreturn] = ACTIONS(3425),
    [anon_sym_noreturn] = ACTIONS(3425),
    [anon_sym_mutable] = ACTIONS(3425),
    [anon_sym_constinit] = ACTIONS(3425),
    [anon_sym_consteval] = ACTIONS(3425),
    [anon_sym_alignas] = ACTIONS(3425),
    [anon_sym__Alignas] = ACTIONS(3425),
    [sym_primitive_type] = ACTIONS(3425),
    [anon_sym_enum] = ACTIONS(3425),
    [anon_sym_class] = ACTIONS(3425),
    [anon_sym_struct] = ACTIONS(3425),
    [anon_sym_union] = ACTIONS(3425),
    [anon_sym_if] = ACTIONS(3425),
    [anon_sym_switch] = ACTIONS(3425),
    [anon_sym_case] = ACTIONS(3425),
    [anon_sym_default] = ACTIONS(3425),
    [anon_sym_while] = ACTIONS(3425),
    [anon_sym_do] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3425),
    [anon_sym_return] = ACTIONS(3425),
    [anon_sym_break] = ACTIONS(3425),
    [anon_sym_continue] = ACTIONS(3425),
    [anon_sym_goto] = ACTIONS(3425),
    [anon_sym___try] = ACTIONS(3425),
    [anon_sym___leave] = ACTIONS(3425),
    [anon_sym_not] = ACTIONS(3425),
    [anon_sym_compl] = ACTIONS(3425),
    [anon_sym_DASH_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_PLUS] = ACTIONS(3427),
    [anon_sym_sizeof] = ACTIONS(3425),
    [anon_sym___alignof__] = ACTIONS(3425),
    [anon_sym___alignof] = ACTIONS(3425),
    [anon_sym__alignof] = ACTIONS(3425),
    [anon_sym_alignof] = ACTIONS(3425),
    [anon_sym__Alignof] = ACTIONS(3425),
    [anon_sym_offsetof] = ACTIONS(3425),
    [anon_sym__Generic] = ACTIONS(3425),
    [anon_sym_asm] = ACTIONS(3425),
    [anon_sym___asm__] = ACTIONS(3425),
    [sym_number_literal] = ACTIONS(3427),
    [anon_sym_L_SQUOTE] = ACTIONS(3427),
    [anon_sym_u_SQUOTE] = ACTIONS(3427),
    [anon_sym_U_SQUOTE] = ACTIONS(3427),
    [anon_sym_u8_SQUOTE] = ACTIONS(3427),
    [anon_sym_SQUOTE] = ACTIONS(3427),
    [anon_sym_L_DQUOTE] = ACTIONS(3427),
    [anon_sym_u_DQUOTE] = ACTIONS(3427),
    [anon_sym_U_DQUOTE] = ACTIONS(3427),
    [anon_sym_u8_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [sym_true] = ACTIONS(3425),
    [sym_false] = ACTIONS(3425),
    [anon_sym_NULL] = ACTIONS(3425),
    [anon_sym_nullptr] = ACTIONS(3425),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3425),
    [anon_sym_let] = ACTIONS(3425),
    [anon_sym_This] = ACTIONS(3425),
    [anon_sym_decltype] = ACTIONS(3425),
    [sym_virtual] = ACTIONS(3425),
    [anon_sym_explicit] = ACTIONS(3425),
    [anon_sym_typename] = ACTIONS(3425),
    [anon_sym_template] = ACTIONS(3425),
    [anon_sym_operator] = ACTIONS(3425),
    [anon_sym_try] = ACTIONS(3425),
    [anon_sym_delete] = ACTIONS(3425),
    [anon_sym_throw] = ACTIONS(3425),
    [anon_sym_namespace] = ACTIONS(3425),
    [anon_sym_using] = ACTIONS(3425),
    [anon_sym_static_assert] = ACTIONS(3425),
    [anon_sym_concept] = ACTIONS(3425),
    [anon_sym_co_return] = ACTIONS(3425),
    [anon_sym_co_yield] = ACTIONS(3425),
    [anon_sym_R_DQUOTE] = ACTIONS(3427),
    [anon_sym_LR_DQUOTE] = ACTIONS(3427),
    [anon_sym_uR_DQUOTE] = ACTIONS(3427),
    [anon_sym_UR_DQUOTE] = ACTIONS(3427),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3427),
    [anon_sym_co_await] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_requires] = ACTIONS(3425),
    [sym_this] = ACTIONS(3425),
    [anon_sym_discard] = ACTIONS(3425),
    [anon_sym_precise] = ACTIONS(3425),
    [anon_sym_shared] = ACTIONS(3425),
    [anon_sym_groupshared] = ACTIONS(3425),
    [anon_sym_uniform] = ACTIONS(3425),
    [anon_sym_row_major] = ACTIONS(3425),
    [anon_sym_column_major] = ACTIONS(3425),
    [anon_sym_globallycoherent] = ACTIONS(3425),
    [anon_sym_centroid] = ACTIONS(3425),
    [anon_sym_noperspective] = ACTIONS(3425),
    [anon_sym_nointerpolation] = ACTIONS(3425),
    [anon_sym_sample] = ACTIONS(3425),
    [anon_sym_linear] = ACTIONS(3425),
    [anon_sym_snorm] = ACTIONS(3425),
    [anon_sym_unorm] = ACTIONS(3425),
    [anon_sym_point] = ACTIONS(3425),
    [anon_sym_line] = ACTIONS(3425),
    [anon_sym_triangleadj] = ACTIONS(3425),
    [anon_sym_lineadj] = ACTIONS(3425),
    [anon_sym_triangle] = ACTIONS(3425),
    [anon_sym_cbuffer] = ACTIONS(3425),
    [anon_sym_interface] = ACTIONS(3425),
    [anon_sym_extension] = ACTIONS(3425),
  },
  [915] = {
    [sym_identifier] = ACTIONS(3513),
    [aux_sym_preproc_include_token1] = ACTIONS(3513),
    [aux_sym_preproc_def_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3513),
    [sym_preproc_directive] = ACTIONS(3513),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_BANG] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3513),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3513),
    [anon_sym_SEMI] = ACTIONS(3515),
    [anon_sym___extension__] = ACTIONS(3513),
    [anon_sym_typedef] = ACTIONS(3513),
    [anon_sym_in] = ACTIONS(3513),
    [anon_sym_out] = ACTIONS(3513),
    [anon_sym_inout] = ACTIONS(3513),
    [anon_sym_extern] = ACTIONS(3513),
    [anon_sym___attribute__] = ACTIONS(3513),
    [anon_sym_COLON_COLON] = ACTIONS(3515),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3515),
    [anon_sym___declspec] = ACTIONS(3513),
    [anon_sym___based] = ACTIONS(3513),
    [anon_sym___cdecl] = ACTIONS(3513),
    [anon_sym___clrcall] = ACTIONS(3513),
    [anon_sym___stdcall] = ACTIONS(3513),
    [anon_sym___fastcall] = ACTIONS(3513),
    [anon_sym___thiscall] = ACTIONS(3513),
    [anon_sym___vectorcall] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_RBRACE] = ACTIONS(3515),
    [anon_sym_signed] = ACTIONS(3513),
    [anon_sym_unsigned] = ACTIONS(3513),
    [anon_sym_long] = ACTIONS(3513),
    [anon_sym_short] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_register] = ACTIONS(3513),
    [anon_sym_inline] = ACTIONS(3513),
    [anon_sym___inline] = ACTIONS(3513),
    [anon_sym___inline__] = ACTIONS(3513),
    [anon_sym___forceinline] = ACTIONS(3513),
    [anon_sym_thread_local] = ACTIONS(3513),
    [anon_sym___thread] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [anon_sym_constexpr] = ACTIONS(3513),
    [anon_sym_volatile] = ACTIONS(3513),
    [anon_sym_restrict] = ACTIONS(3513),
    [anon_sym___restrict__] = ACTIONS(3513),
    [anon_sym__Atomic] = ACTIONS(3513),
    [anon_sym__Noreturn] = ACTIONS(3513),
    [anon_sym_noreturn] = ACTIONS(3513),
    [anon_sym_mutable] = ACTIONS(3513),
    [anon_sym_constinit] = ACTIONS(3513),
    [anon_sym_consteval] = ACTIONS(3513),
    [anon_sym_alignas] = ACTIONS(3513),
    [anon_sym__Alignas] = ACTIONS(3513),
    [sym_primitive_type] = ACTIONS(3513),
    [anon_sym_enum] = ACTIONS(3513),
    [anon_sym_class] = ACTIONS(3513),
    [anon_sym_struct] = ACTIONS(3513),
    [anon_sym_union] = ACTIONS(3513),
    [anon_sym_if] = ACTIONS(3513),
    [anon_sym_switch] = ACTIONS(3513),
    [anon_sym_case] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3513),
    [anon_sym_while] = ACTIONS(3513),
    [anon_sym_do] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3513),
    [anon_sym_return] = ACTIONS(3513),
    [anon_sym_break] = ACTIONS(3513),
    [anon_sym_continue] = ACTIONS(3513),
    [anon_sym_goto] = ACTIONS(3513),
    [anon_sym___try] = ACTIONS(3513),
    [anon_sym___leave] = ACTIONS(3513),
    [anon_sym_not] = ACTIONS(3513),
    [anon_sym_compl] = ACTIONS(3513),
    [anon_sym_DASH_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_PLUS] = ACTIONS(3515),
    [anon_sym_sizeof] = ACTIONS(3513),
    [anon_sym___alignof__] = ACTIONS(3513),
    [anon_sym___alignof] = ACTIONS(3513),
    [anon_sym__alignof] = ACTIONS(3513),
    [anon_sym_alignof] = ACTIONS(3513),
    [anon_sym__Alignof] = ACTIONS(3513),
    [anon_sym_offsetof] = ACTIONS(3513),
    [anon_sym__Generic] = ACTIONS(3513),
    [anon_sym_asm] = ACTIONS(3513),
    [anon_sym___asm__] = ACTIONS(3513),
    [sym_number_literal] = ACTIONS(3515),
    [anon_sym_L_SQUOTE] = ACTIONS(3515),
    [anon_sym_u_SQUOTE] = ACTIONS(3515),
    [anon_sym_U_SQUOTE] = ACTIONS(3515),
    [anon_sym_u8_SQUOTE] = ACTIONS(3515),
    [anon_sym_SQUOTE] = ACTIONS(3515),
    [anon_sym_L_DQUOTE] = ACTIONS(3515),
    [anon_sym_u_DQUOTE] = ACTIONS(3515),
    [anon_sym_U_DQUOTE] = ACTIONS(3515),
    [anon_sym_u8_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [sym_true] = ACTIONS(3513),
    [sym_false] = ACTIONS(3513),
    [anon_sym_NULL] = ACTIONS(3513),
    [anon_sym_nullptr] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3513),
    [anon_sym_let] = ACTIONS(3513),
    [anon_sym_This] = ACTIONS(3513),
    [anon_sym_decltype] = ACTIONS(3513),
    [sym_virtual] = ACTIONS(3513),
    [anon_sym_explicit] = ACTIONS(3513),
    [anon_sym_typename] = ACTIONS(3513),
    [anon_sym_template] = ACTIONS(3513),
    [anon_sym_operator] = ACTIONS(3513),
    [anon_sym_try] = ACTIONS(3513),
    [anon_sym_delete] = ACTIONS(3513),
    [anon_sym_throw] = ACTIONS(3513),
    [anon_sym_namespace] = ACTIONS(3513),
    [anon_sym_using] = ACTIONS(3513),
    [anon_sym_static_assert] = ACTIONS(3513),
    [anon_sym_concept] = ACTIONS(3513),
    [anon_sym_co_return] = ACTIONS(3513),
    [anon_sym_co_yield] = ACTIONS(3513),
    [anon_sym_R_DQUOTE] = ACTIONS(3515),
    [anon_sym_LR_DQUOTE] = ACTIONS(3515),
    [anon_sym_uR_DQUOTE] = ACTIONS(3515),
    [anon_sym_UR_DQUOTE] = ACTIONS(3515),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3515),
    [anon_sym_co_await] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3513),
    [anon_sym_requires] = ACTIONS(3513),
    [sym_this] = ACTIONS(3513),
    [anon_sym_discard] = ACTIONS(3513),
    [anon_sym_precise] = ACTIONS(3513),
    [anon_sym_shared] = ACTIONS(3513),
    [anon_sym_groupshared] = ACTIONS(3513),
    [anon_sym_uniform] = ACTIONS(3513),
    [anon_sym_row_major] = ACTIONS(3513),
    [anon_sym_column_major] = ACTIONS(3513),
    [anon_sym_globallycoherent] = ACTIONS(3513),
    [anon_sym_centroid] = ACTIONS(3513),
    [anon_sym_noperspective] = ACTIONS(3513),
    [anon_sym_nointerpolation] = ACTIONS(3513),
    [anon_sym_sample] = ACTIONS(3513),
    [anon_sym_linear] = ACTIONS(3513),
    [anon_sym_snorm] = ACTIONS(3513),
    [anon_sym_unorm] = ACTIONS(3513),
    [anon_sym_point] = ACTIONS(3513),
    [anon_sym_line] = ACTIONS(3513),
    [anon_sym_triangleadj] = ACTIONS(3513),
    [anon_sym_lineadj] = ACTIONS(3513),
    [anon_sym_triangle] = ACTIONS(3513),
    [anon_sym_cbuffer] = ACTIONS(3513),
    [anon_sym_interface] = ACTIONS(3513),
    [anon_sym_extension] = ACTIONS(3513),
  },
  [916] = {
    [sym_identifier] = ACTIONS(3517),
    [aux_sym_preproc_include_token1] = ACTIONS(3517),
    [aux_sym_preproc_def_token1] = ACTIONS(3517),
    [aux_sym_preproc_if_token1] = ACTIONS(3517),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3517),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3517),
    [sym_preproc_directive] = ACTIONS(3517),
    [anon_sym_LPAREN2] = ACTIONS(3519),
    [anon_sym_BANG] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3517),
    [anon_sym_PLUS] = ACTIONS(3517),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym_SEMI] = ACTIONS(3519),
    [anon_sym___extension__] = ACTIONS(3517),
    [anon_sym_typedef] = ACTIONS(3517),
    [anon_sym_in] = ACTIONS(3517),
    [anon_sym_out] = ACTIONS(3517),
    [anon_sym_inout] = ACTIONS(3517),
    [anon_sym_extern] = ACTIONS(3517),
    [anon_sym___attribute__] = ACTIONS(3517),
    [anon_sym_COLON_COLON] = ACTIONS(3519),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3519),
    [anon_sym___declspec] = ACTIONS(3517),
    [anon_sym___based] = ACTIONS(3517),
    [anon_sym___cdecl] = ACTIONS(3517),
    [anon_sym___clrcall] = ACTIONS(3517),
    [anon_sym___stdcall] = ACTIONS(3517),
    [anon_sym___fastcall] = ACTIONS(3517),
    [anon_sym___thiscall] = ACTIONS(3517),
    [anon_sym___vectorcall] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_RBRACE] = ACTIONS(3519),
    [anon_sym_signed] = ACTIONS(3517),
    [anon_sym_unsigned] = ACTIONS(3517),
    [anon_sym_long] = ACTIONS(3517),
    [anon_sym_short] = ACTIONS(3517),
    [anon_sym_LBRACK] = ACTIONS(3517),
    [anon_sym_static] = ACTIONS(3517),
    [anon_sym_register] = ACTIONS(3517),
    [anon_sym_inline] = ACTIONS(3517),
    [anon_sym___inline] = ACTIONS(3517),
    [anon_sym___inline__] = ACTIONS(3517),
    [anon_sym___forceinline] = ACTIONS(3517),
    [anon_sym_thread_local] = ACTIONS(3517),
    [anon_sym___thread] = ACTIONS(3517),
    [anon_sym_const] = ACTIONS(3517),
    [anon_sym_constexpr] = ACTIONS(3517),
    [anon_sym_volatile] = ACTIONS(3517),
    [anon_sym_restrict] = ACTIONS(3517),
    [anon_sym___restrict__] = ACTIONS(3517),
    [anon_sym__Atomic] = ACTIONS(3517),
    [anon_sym__Noreturn] = ACTIONS(3517),
    [anon_sym_noreturn] = ACTIONS(3517),
    [anon_sym_mutable] = ACTIONS(3517),
    [anon_sym_constinit] = ACTIONS(3517),
    [anon_sym_consteval] = ACTIONS(3517),
    [anon_sym_alignas] = ACTIONS(3517),
    [anon_sym__Alignas] = ACTIONS(3517),
    [sym_primitive_type] = ACTIONS(3517),
    [anon_sym_enum] = ACTIONS(3517),
    [anon_sym_class] = ACTIONS(3517),
    [anon_sym_struct] = ACTIONS(3517),
    [anon_sym_union] = ACTIONS(3517),
    [anon_sym_if] = ACTIONS(3517),
    [anon_sym_switch] = ACTIONS(3517),
    [anon_sym_case] = ACTIONS(3517),
    [anon_sym_default] = ACTIONS(3517),
    [anon_sym_while] = ACTIONS(3517),
    [anon_sym_do] = ACTIONS(3517),
    [anon_sym_for] = ACTIONS(3517),
    [anon_sym_return] = ACTIONS(3517),
    [anon_sym_break] = ACTIONS(3517),
    [anon_sym_continue] = ACTIONS(3517),
    [anon_sym_goto] = ACTIONS(3517),
    [anon_sym___try] = ACTIONS(3517),
    [anon_sym___leave] = ACTIONS(3517),
    [anon_sym_not] = ACTIONS(3517),
    [anon_sym_compl] = ACTIONS(3517),
    [anon_sym_DASH_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_PLUS] = ACTIONS(3519),
    [anon_sym_sizeof] = ACTIONS(3517),
    [anon_sym___alignof__] = ACTIONS(3517),
    [anon_sym___alignof] = ACTIONS(3517),
    [anon_sym__alignof] = ACTIONS(3517),
    [anon_sym_alignof] = ACTIONS(3517),
    [anon_sym__Alignof] = ACTIONS(3517),
    [anon_sym_offsetof] = ACTIONS(3517),
    [anon_sym__Generic] = ACTIONS(3517),
    [anon_sym_asm] = ACTIONS(3517),
    [anon_sym___asm__] = ACTIONS(3517),
    [sym_number_literal] = ACTIONS(3519),
    [anon_sym_L_SQUOTE] = ACTIONS(3519),
    [anon_sym_u_SQUOTE] = ACTIONS(3519),
    [anon_sym_U_SQUOTE] = ACTIONS(3519),
    [anon_sym_u8_SQUOTE] = ACTIONS(3519),
    [anon_sym_SQUOTE] = ACTIONS(3519),
    [anon_sym_L_DQUOTE] = ACTIONS(3519),
    [anon_sym_u_DQUOTE] = ACTIONS(3519),
    [anon_sym_U_DQUOTE] = ACTIONS(3519),
    [anon_sym_u8_DQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [sym_true] = ACTIONS(3517),
    [sym_false] = ACTIONS(3517),
    [anon_sym_NULL] = ACTIONS(3517),
    [anon_sym_nullptr] = ACTIONS(3517),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3517),
    [anon_sym_let] = ACTIONS(3517),
    [anon_sym_This] = ACTIONS(3517),
    [anon_sym_decltype] = ACTIONS(3517),
    [sym_virtual] = ACTIONS(3517),
    [anon_sym_explicit] = ACTIONS(3517),
    [anon_sym_typename] = ACTIONS(3517),
    [anon_sym_template] = ACTIONS(3517),
    [anon_sym_operator] = ACTIONS(3517),
    [anon_sym_try] = ACTIONS(3517),
    [anon_sym_delete] = ACTIONS(3517),
    [anon_sym_throw] = ACTIONS(3517),
    [anon_sym_namespace] = ACTIONS(3517),
    [anon_sym_using] = ACTIONS(3517),
    [anon_sym_static_assert] = ACTIONS(3517),
    [anon_sym_concept] = ACTIONS(3517),
    [anon_sym_co_return] = ACTIONS(3517),
    [anon_sym_co_yield] = ACTIONS(3517),
    [anon_sym_R_DQUOTE] = ACTIONS(3519),
    [anon_sym_LR_DQUOTE] = ACTIONS(3519),
    [anon_sym_uR_DQUOTE] = ACTIONS(3519),
    [anon_sym_UR_DQUOTE] = ACTIONS(3519),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3519),
    [anon_sym_co_await] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3517),
    [anon_sym_requires] = ACTIONS(3517),
    [sym_this] = ACTIONS(3517),
    [anon_sym_discard] = ACTIONS(3517),
    [anon_sym_precise] = ACTIONS(3517),
    [anon_sym_shared] = ACTIONS(3517),
    [anon_sym_groupshared] = ACTIONS(3517),
    [anon_sym_uniform] = ACTIONS(3517),
    [anon_sym_row_major] = ACTIONS(3517),
    [anon_sym_column_major] = ACTIONS(3517),
    [anon_sym_globallycoherent] = ACTIONS(3517),
    [anon_sym_centroid] = ACTIONS(3517),
    [anon_sym_noperspective] = ACTIONS(3517),
    [anon_sym_nointerpolation] = ACTIONS(3517),
    [anon_sym_sample] = ACTIONS(3517),
    [anon_sym_linear] = ACTIONS(3517),
    [anon_sym_snorm] = ACTIONS(3517),
    [anon_sym_unorm] = ACTIONS(3517),
    [anon_sym_point] = ACTIONS(3517),
    [anon_sym_line] = ACTIONS(3517),
    [anon_sym_triangleadj] = ACTIONS(3517),
    [anon_sym_lineadj] = ACTIONS(3517),
    [anon_sym_triangle] = ACTIONS(3517),
    [anon_sym_cbuffer] = ACTIONS(3517),
    [anon_sym_interface] = ACTIONS(3517),
    [anon_sym_extension] = ACTIONS(3517),
  },
  [917] = {
    [sym_identifier] = ACTIONS(3414),
    [aux_sym_preproc_include_token1] = ACTIONS(3414),
    [aux_sym_preproc_def_token1] = ACTIONS(3414),
    [aux_sym_preproc_if_token1] = ACTIONS(3414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3414),
    [sym_preproc_directive] = ACTIONS(3414),
    [anon_sym_LPAREN2] = ACTIONS(3416),
    [anon_sym_BANG] = ACTIONS(3416),
    [anon_sym_TILDE] = ACTIONS(3416),
    [anon_sym_DASH] = ACTIONS(3414),
    [anon_sym_PLUS] = ACTIONS(3414),
    [anon_sym_STAR] = ACTIONS(3416),
    [anon_sym_AMP_AMP] = ACTIONS(3416),
    [anon_sym_AMP] = ACTIONS(3414),
    [anon_sym_SEMI] = ACTIONS(3416),
    [anon_sym___extension__] = ACTIONS(3414),
    [anon_sym_typedef] = ACTIONS(3414),
    [anon_sym_in] = ACTIONS(3414),
    [anon_sym_out] = ACTIONS(3414),
    [anon_sym_inout] = ACTIONS(3414),
    [anon_sym_extern] = ACTIONS(3414),
    [anon_sym___attribute__] = ACTIONS(3414),
    [anon_sym_COLON_COLON] = ACTIONS(3416),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3416),
    [anon_sym___declspec] = ACTIONS(3414),
    [anon_sym___based] = ACTIONS(3414),
    [anon_sym___cdecl] = ACTIONS(3414),
    [anon_sym___clrcall] = ACTIONS(3414),
    [anon_sym___stdcall] = ACTIONS(3414),
    [anon_sym___fastcall] = ACTIONS(3414),
    [anon_sym___thiscall] = ACTIONS(3414),
    [anon_sym___vectorcall] = ACTIONS(3414),
    [anon_sym_LBRACE] = ACTIONS(3416),
    [anon_sym_RBRACE] = ACTIONS(3416),
    [anon_sym_signed] = ACTIONS(3414),
    [anon_sym_unsigned] = ACTIONS(3414),
    [anon_sym_long] = ACTIONS(3414),
    [anon_sym_short] = ACTIONS(3414),
    [anon_sym_LBRACK] = ACTIONS(3414),
    [anon_sym_static] = ACTIONS(3414),
    [anon_sym_register] = ACTIONS(3414),
    [anon_sym_inline] = ACTIONS(3414),
    [anon_sym___inline] = ACTIONS(3414),
    [anon_sym___inline__] = ACTIONS(3414),
    [anon_sym___forceinline] = ACTIONS(3414),
    [anon_sym_thread_local] = ACTIONS(3414),
    [anon_sym___thread] = ACTIONS(3414),
    [anon_sym_const] = ACTIONS(3414),
    [anon_sym_constexpr] = ACTIONS(3414),
    [anon_sym_volatile] = ACTIONS(3414),
    [anon_sym_restrict] = ACTIONS(3414),
    [anon_sym___restrict__] = ACTIONS(3414),
    [anon_sym__Atomic] = ACTIONS(3414),
    [anon_sym__Noreturn] = ACTIONS(3414),
    [anon_sym_noreturn] = ACTIONS(3414),
    [anon_sym_mutable] = ACTIONS(3414),
    [anon_sym_constinit] = ACTIONS(3414),
    [anon_sym_consteval] = ACTIONS(3414),
    [anon_sym_alignas] = ACTIONS(3414),
    [anon_sym__Alignas] = ACTIONS(3414),
    [sym_primitive_type] = ACTIONS(3414),
    [anon_sym_enum] = ACTIONS(3414),
    [anon_sym_class] = ACTIONS(3414),
    [anon_sym_struct] = ACTIONS(3414),
    [anon_sym_union] = ACTIONS(3414),
    [anon_sym_if] = ACTIONS(3414),
    [anon_sym_switch] = ACTIONS(3414),
    [anon_sym_case] = ACTIONS(3414),
    [anon_sym_default] = ACTIONS(3414),
    [anon_sym_while] = ACTIONS(3414),
    [anon_sym_do] = ACTIONS(3414),
    [anon_sym_for] = ACTIONS(3414),
    [anon_sym_return] = ACTIONS(3414),
    [anon_sym_break] = ACTIONS(3414),
    [anon_sym_continue] = ACTIONS(3414),
    [anon_sym_goto] = ACTIONS(3414),
    [anon_sym___try] = ACTIONS(3414),
    [anon_sym___leave] = ACTIONS(3414),
    [anon_sym_not] = ACTIONS(3414),
    [anon_sym_compl] = ACTIONS(3414),
    [anon_sym_DASH_DASH] = ACTIONS(3416),
    [anon_sym_PLUS_PLUS] = ACTIONS(3416),
    [anon_sym_sizeof] = ACTIONS(3414),
    [anon_sym___alignof__] = ACTIONS(3414),
    [anon_sym___alignof] = ACTIONS(3414),
    [anon_sym__alignof] = ACTIONS(3414),
    [anon_sym_alignof] = ACTIONS(3414),
    [anon_sym__Alignof] = ACTIONS(3414),
    [anon_sym_offsetof] = ACTIONS(3414),
    [anon_sym__Generic] = ACTIONS(3414),
    [anon_sym_asm] = ACTIONS(3414),
    [anon_sym___asm__] = ACTIONS(3414),
    [sym_number_literal] = ACTIONS(3416),
    [anon_sym_L_SQUOTE] = ACTIONS(3416),
    [anon_sym_u_SQUOTE] = ACTIONS(3416),
    [anon_sym_U_SQUOTE] = ACTIONS(3416),
    [anon_sym_u8_SQUOTE] = ACTIONS(3416),
    [anon_sym_SQUOTE] = ACTIONS(3416),
    [anon_sym_L_DQUOTE] = ACTIONS(3416),
    [anon_sym_u_DQUOTE] = ACTIONS(3416),
    [anon_sym_U_DQUOTE] = ACTIONS(3416),
    [anon_sym_u8_DQUOTE] = ACTIONS(3416),
    [anon_sym_DQUOTE] = ACTIONS(3416),
    [sym_true] = ACTIONS(3414),
    [sym_false] = ACTIONS(3414),
    [anon_sym_NULL] = ACTIONS(3414),
    [anon_sym_nullptr] = ACTIONS(3414),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3414),
    [anon_sym_let] = ACTIONS(3414),
    [anon_sym_This] = ACTIONS(3414),
    [anon_sym_decltype] = ACTIONS(3414),
    [sym_virtual] = ACTIONS(3414),
    [anon_sym_explicit] = ACTIONS(3414),
    [anon_sym_typename] = ACTIONS(3414),
    [anon_sym_template] = ACTIONS(3414),
    [anon_sym_operator] = ACTIONS(3414),
    [anon_sym_try] = ACTIONS(3414),
    [anon_sym_delete] = ACTIONS(3414),
    [anon_sym_throw] = ACTIONS(3414),
    [anon_sym_namespace] = ACTIONS(3414),
    [anon_sym_using] = ACTIONS(3414),
    [anon_sym_static_assert] = ACTIONS(3414),
    [anon_sym_concept] = ACTIONS(3414),
    [anon_sym_co_return] = ACTIONS(3414),
    [anon_sym_co_yield] = ACTIONS(3414),
    [anon_sym_R_DQUOTE] = ACTIONS(3416),
    [anon_sym_LR_DQUOTE] = ACTIONS(3416),
    [anon_sym_uR_DQUOTE] = ACTIONS(3416),
    [anon_sym_UR_DQUOTE] = ACTIONS(3416),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3416),
    [anon_sym_co_await] = ACTIONS(3414),
    [anon_sym_new] = ACTIONS(3414),
    [anon_sym_requires] = ACTIONS(3414),
    [sym_this] = ACTIONS(3414),
    [anon_sym_discard] = ACTIONS(3414),
    [anon_sym_precise] = ACTIONS(3414),
    [anon_sym_shared] = ACTIONS(3414),
    [anon_sym_groupshared] = ACTIONS(3414),
    [anon_sym_uniform] = ACTIONS(3414),
    [anon_sym_row_major] = ACTIONS(3414),
    [anon_sym_column_major] = ACTIONS(3414),
    [anon_sym_globallycoherent] = ACTIONS(3414),
    [anon_sym_centroid] = ACTIONS(3414),
    [anon_sym_noperspective] = ACTIONS(3414),
    [anon_sym_nointerpolation] = ACTIONS(3414),
    [anon_sym_sample] = ACTIONS(3414),
    [anon_sym_linear] = ACTIONS(3414),
    [anon_sym_snorm] = ACTIONS(3414),
    [anon_sym_unorm] = ACTIONS(3414),
    [anon_sym_point] = ACTIONS(3414),
    [anon_sym_line] = ACTIONS(3414),
    [anon_sym_triangleadj] = ACTIONS(3414),
    [anon_sym_lineadj] = ACTIONS(3414),
    [anon_sym_triangle] = ACTIONS(3414),
    [anon_sym_cbuffer] = ACTIONS(3414),
    [anon_sym_interface] = ACTIONS(3414),
    [anon_sym_extension] = ACTIONS(3414),
  },
  [918] = {
    [sym_attribute_specifier] = STATE(298),
    [ts_builtin_sym_end] = ACTIONS(3727),
    [sym_identifier] = ACTIONS(3725),
    [aux_sym_preproc_include_token1] = ACTIONS(3725),
    [aux_sym_preproc_def_token1] = ACTIONS(3725),
    [aux_sym_preproc_if_token1] = ACTIONS(3725),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3725),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3725),
    [sym_preproc_directive] = ACTIONS(3725),
    [anon_sym_LPAREN2] = ACTIONS(3727),
    [anon_sym_BANG] = ACTIONS(3727),
    [anon_sym_TILDE] = ACTIONS(3727),
    [anon_sym_DASH] = ACTIONS(3725),
    [anon_sym_PLUS] = ACTIONS(3725),
    [anon_sym_STAR] = ACTIONS(3727),
    [anon_sym_AMP_AMP] = ACTIONS(3727),
    [anon_sym_AMP] = ACTIONS(3725),
    [anon_sym_SEMI] = ACTIONS(3727),
    [anon_sym___extension__] = ACTIONS(3725),
    [anon_sym_typedef] = ACTIONS(3725),
    [anon_sym_in] = ACTIONS(3725),
    [anon_sym_out] = ACTIONS(3725),
    [anon_sym_inout] = ACTIONS(3725),
    [anon_sym_extern] = ACTIONS(3725),
    [anon_sym___attribute__] = ACTIONS(2861),
    [anon_sym_COLON_COLON] = ACTIONS(3727),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3727),
    [anon_sym___declspec] = ACTIONS(3725),
    [anon_sym___based] = ACTIONS(3725),
    [anon_sym___cdecl] = ACTIONS(3725),
    [anon_sym___clrcall] = ACTIONS(3725),
    [anon_sym___stdcall] = ACTIONS(3725),
    [anon_sym___fastcall] = ACTIONS(3725),
    [anon_sym___thiscall] = ACTIONS(3725),
    [anon_sym___vectorcall] = ACTIONS(3725),
    [anon_sym_LBRACE] = ACTIONS(3727),
    [anon_sym_signed] = ACTIONS(3725),
    [anon_sym_unsigned] = ACTIONS(3725),
    [anon_sym_long] = ACTIONS(3725),
    [anon_sym_short] = ACTIONS(3725),
    [anon_sym_LBRACK] = ACTIONS(3725),
    [anon_sym_static] = ACTIONS(3725),
    [anon_sym_register] = ACTIONS(3725),
    [anon_sym_inline] = ACTIONS(3725),
    [anon_sym___inline] = ACTIONS(3725),
    [anon_sym___inline__] = ACTIONS(3725),
    [anon_sym___forceinline] = ACTIONS(3725),
    [anon_sym_thread_local] = ACTIONS(3725),
    [anon_sym___thread] = ACTIONS(3725),
    [anon_sym_const] = ACTIONS(3725),
    [anon_sym_constexpr] = ACTIONS(3725),
    [anon_sym_volatile] = ACTIONS(3725),
    [anon_sym_restrict] = ACTIONS(3725),
    [anon_sym___restrict__] = ACTIONS(3725),
    [anon_sym__Atomic] = ACTIONS(3725),
    [anon_sym__Noreturn] = ACTIONS(3725),
    [anon_sym_noreturn] = ACTIONS(3725),
    [anon_sym_mutable] = ACTIONS(3725),
    [anon_sym_constinit] = ACTIONS(3725),
    [anon_sym_consteval] = ACTIONS(3725),
    [anon_sym_alignas] = ACTIONS(3725),
    [anon_sym__Alignas] = ACTIONS(3725),
    [sym_primitive_type] = ACTIONS(3725),
    [anon_sym_enum] = ACTIONS(3725),
    [anon_sym_class] = ACTIONS(3725),
    [anon_sym_struct] = ACTIONS(3725),
    [anon_sym_union] = ACTIONS(3725),
    [anon_sym_if] = ACTIONS(3725),
    [anon_sym_switch] = ACTIONS(3725),
    [anon_sym_case] = ACTIONS(3725),
    [anon_sym_default] = ACTIONS(3725),
    [anon_sym_while] = ACTIONS(3725),
    [anon_sym_do] = ACTIONS(3725),
    [anon_sym_for] = ACTIONS(3725),
    [anon_sym_return] = ACTIONS(3725),
    [anon_sym_break] = ACTIONS(3725),
    [anon_sym_continue] = ACTIONS(3725),
    [anon_sym_goto] = ACTIONS(3725),
    [anon_sym_not] = ACTIONS(3725),
    [anon_sym_compl] = ACTIONS(3725),
    [anon_sym_DASH_DASH] = ACTIONS(3727),
    [anon_sym_PLUS_PLUS] = ACTIONS(3727),
    [anon_sym_sizeof] = ACTIONS(3725),
    [anon_sym___alignof__] = ACTIONS(3725),
    [anon_sym___alignof] = ACTIONS(3725),
    [anon_sym__alignof] = ACTIONS(3725),
    [anon_sym_alignof] = ACTIONS(3725),
    [anon_sym__Alignof] = ACTIONS(3725),
    [anon_sym_offsetof] = ACTIONS(3725),
    [anon_sym__Generic] = ACTIONS(3725),
    [anon_sym_asm] = ACTIONS(3725),
    [anon_sym___asm__] = ACTIONS(3725),
    [anon_sym_DOT] = ACTIONS(3725),
    [sym_number_literal] = ACTIONS(3727),
    [anon_sym_L_SQUOTE] = ACTIONS(3727),
    [anon_sym_u_SQUOTE] = ACTIONS(3727),
    [anon_sym_U_SQUOTE] = ACTIONS(3727),
    [anon_sym_u8_SQUOTE] = ACTIONS(3727),
    [anon_sym_SQUOTE] = ACTIONS(3727),
    [anon_sym_L_DQUOTE] = ACTIONS(3727),
    [anon_sym_u_DQUOTE] = ACTIONS(3727),
    [anon_sym_U_DQUOTE] = ACTIONS(3727),
    [anon_sym_u8_DQUOTE] = ACTIONS(3727),
    [anon_sym_DQUOTE] = ACTIONS(3727),
    [sym_true] = ACTIONS(3725),
    [sym_false] = ACTIONS(3725),
    [anon_sym_NULL] = ACTIONS(3725),
    [anon_sym_nullptr] = ACTIONS(3725),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3725),
    [anon_sym_let] = ACTIONS(3725),
    [anon_sym_This] = ACTIONS(3725),
    [anon_sym_decltype] = ACTIONS(3725),
    [sym_virtual] = ACTIONS(3725),
    [anon_sym_explicit] = ACTIONS(3725),
    [anon_sym_typename] = ACTIONS(3725),
    [anon_sym_template] = ACTIONS(3725),
    [anon_sym_operator] = ACTIONS(3725),
    [anon_sym_try] = ACTIONS(3725),
    [anon_sym_delete] = ACTIONS(3725),
    [anon_sym_throw] = ACTIONS(3725),
    [anon_sym_namespace] = ACTIONS(3725),
    [anon_sym_using] = ACTIONS(3725),
    [anon_sym_static_assert] = ACTIONS(3725),
    [anon_sym_concept] = ACTIONS(3725),
    [anon_sym_co_return] = ACTIONS(3725),
    [anon_sym_co_yield] = ACTIONS(3725),
    [anon_sym_R_DQUOTE] = ACTIONS(3727),
    [anon_sym_LR_DQUOTE] = ACTIONS(3727),
    [anon_sym_uR_DQUOTE] = ACTIONS(3727),
    [anon_sym_UR_DQUOTE] = ACTIONS(3727),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3727),
    [anon_sym_co_await] = ACTIONS(3725),
    [anon_sym_new] = ACTIONS(3725),
    [anon_sym_requires] = ACTIONS(3725),
    [sym_this] = ACTIONS(3725),
    [anon_sym_precise] = ACTIONS(3725),
    [anon_sym_shared] = ACTIONS(3725),
    [anon_sym_groupshared] = ACTIONS(3725),
    [anon_sym_uniform] = ACTIONS(3725),
    [anon_sym_row_major] = ACTIONS(3725),
    [anon_sym_column_major] = ACTIONS(3725),
    [anon_sym_globallycoherent] = ACTIONS(3725),
    [anon_sym_centroid] = ACTIONS(3725),
    [anon_sym_noperspective] = ACTIONS(3725),
    [anon_sym_nointerpolation] = ACTIONS(3725),
    [anon_sym_sample] = ACTIONS(3725),
    [anon_sym_linear] = ACTIONS(3725),
    [anon_sym_snorm] = ACTIONS(3725),
    [anon_sym_unorm] = ACTIONS(3725),
    [anon_sym_point] = ACTIONS(3725),
    [anon_sym_line] = ACTIONS(3725),
    [anon_sym_triangleadj] = ACTIONS(3725),
    [anon_sym_lineadj] = ACTIONS(3725),
    [anon_sym_triangle] = ACTIONS(3725),
    [anon_sym_interface] = ACTIONS(3725),
    [anon_sym_extension] = ACTIONS(3725),
    [anon_sym___exported] = ACTIONS(3725),
    [anon_sym_import] = ACTIONS(3725),
  },
  [919] = {
    [sym_identifier] = ACTIONS(3497),
    [aux_sym_preproc_include_token1] = ACTIONS(3497),
    [aux_sym_preproc_def_token1] = ACTIONS(3497),
    [aux_sym_preproc_if_token1] = ACTIONS(3497),
    [aux_sym_preproc_if_token2] = ACTIONS(3497),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3497),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3497),
    [sym_preproc_directive] = ACTIONS(3497),
    [anon_sym_LPAREN2] = ACTIONS(3499),
    [anon_sym_BANG] = ACTIONS(3499),
    [anon_sym_TILDE] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_STAR] = ACTIONS(3499),
    [anon_sym_AMP_AMP] = ACTIONS(3499),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym_SEMI] = ACTIONS(3499),
    [anon_sym___extension__] = ACTIONS(3497),
    [anon_sym_typedef] = ACTIONS(3497),
    [anon_sym_in] = ACTIONS(3497),
    [anon_sym_out] = ACTIONS(3497),
    [anon_sym_inout] = ACTIONS(3497),
    [anon_sym_extern] = ACTIONS(3497),
    [anon_sym___attribute__] = ACTIONS(3497),
    [anon_sym_COLON_COLON] = ACTIONS(3499),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3499),
    [anon_sym___declspec] = ACTIONS(3497),
    [anon_sym___based] = ACTIONS(3497),
    [anon_sym___cdecl] = ACTIONS(3497),
    [anon_sym___clrcall] = ACTIONS(3497),
    [anon_sym___stdcall] = ACTIONS(3497),
    [anon_sym___fastcall] = ACTIONS(3497),
    [anon_sym___thiscall] = ACTIONS(3497),
    [anon_sym___vectorcall] = ACTIONS(3497),
    [anon_sym_LBRACE] = ACTIONS(3499),
    [anon_sym_signed] = ACTIONS(3497),
    [anon_sym_unsigned] = ACTIONS(3497),
    [anon_sym_long] = ACTIONS(3497),
    [anon_sym_short] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3497),
    [anon_sym_static] = ACTIONS(3497),
    [anon_sym_register] = ACTIONS(3497),
    [anon_sym_inline] = ACTIONS(3497),
    [anon_sym___inline] = ACTIONS(3497),
    [anon_sym___inline__] = ACTIONS(3497),
    [anon_sym___forceinline] = ACTIONS(3497),
    [anon_sym_thread_local] = ACTIONS(3497),
    [anon_sym___thread] = ACTIONS(3497),
    [anon_sym_const] = ACTIONS(3497),
    [anon_sym_constexpr] = ACTIONS(3497),
    [anon_sym_volatile] = ACTIONS(3497),
    [anon_sym_restrict] = ACTIONS(3497),
    [anon_sym___restrict__] = ACTIONS(3497),
    [anon_sym__Atomic] = ACTIONS(3497),
    [anon_sym__Noreturn] = ACTIONS(3497),
    [anon_sym_noreturn] = ACTIONS(3497),
    [anon_sym_mutable] = ACTIONS(3497),
    [anon_sym_constinit] = ACTIONS(3497),
    [anon_sym_consteval] = ACTIONS(3497),
    [anon_sym_alignas] = ACTIONS(3497),
    [anon_sym__Alignas] = ACTIONS(3497),
    [sym_primitive_type] = ACTIONS(3497),
    [anon_sym_enum] = ACTIONS(3497),
    [anon_sym_class] = ACTIONS(3497),
    [anon_sym_struct] = ACTIONS(3497),
    [anon_sym_union] = ACTIONS(3497),
    [anon_sym_if] = ACTIONS(3497),
    [anon_sym_switch] = ACTIONS(3497),
    [anon_sym_case] = ACTIONS(3497),
    [anon_sym_default] = ACTIONS(3497),
    [anon_sym_while] = ACTIONS(3497),
    [anon_sym_do] = ACTIONS(3497),
    [anon_sym_for] = ACTIONS(3497),
    [anon_sym_return] = ACTIONS(3497),
    [anon_sym_break] = ACTIONS(3497),
    [anon_sym_continue] = ACTIONS(3497),
    [anon_sym_goto] = ACTIONS(3497),
    [anon_sym___try] = ACTIONS(3497),
    [anon_sym___leave] = ACTIONS(3497),
    [anon_sym_not] = ACTIONS(3497),
    [anon_sym_compl] = ACTIONS(3497),
    [anon_sym_DASH_DASH] = ACTIONS(3499),
    [anon_sym_PLUS_PLUS] = ACTIONS(3499),
    [anon_sym_sizeof] = ACTIONS(3497),
    [anon_sym___alignof__] = ACTIONS(3497),
    [anon_sym___alignof] = ACTIONS(3497),
    [anon_sym__alignof] = ACTIONS(3497),
    [anon_sym_alignof] = ACTIONS(3497),
    [anon_sym__Alignof] = ACTIONS(3497),
    [anon_sym_offsetof] = ACTIONS(3497),
    [anon_sym__Generic] = ACTIONS(3497),
    [anon_sym_asm] = ACTIONS(3497),
    [anon_sym___asm__] = ACTIONS(3497),
    [sym_number_literal] = ACTIONS(3499),
    [anon_sym_L_SQUOTE] = ACTIONS(3499),
    [anon_sym_u_SQUOTE] = ACTIONS(3499),
    [anon_sym_U_SQUOTE] = ACTIONS(3499),
    [anon_sym_u8_SQUOTE] = ACTIONS(3499),
    [anon_sym_SQUOTE] = ACTIONS(3499),
    [anon_sym_L_DQUOTE] = ACTIONS(3499),
    [anon_sym_u_DQUOTE] = ACTIONS(3499),
    [anon_sym_U_DQUOTE] = ACTIONS(3499),
    [anon_sym_u8_DQUOTE] = ACTIONS(3499),
    [anon_sym_DQUOTE] = ACTIONS(3499),
    [sym_true] = ACTIONS(3497),
    [sym_false] = ACTIONS(3497),
    [anon_sym_NULL] = ACTIONS(3497),
    [anon_sym_nullptr] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3497),
    [anon_sym_let] = ACTIONS(3497),
    [anon_sym_This] = ACTIONS(3497),
    [anon_sym_decltype] = ACTIONS(3497),
    [sym_virtual] = ACTIONS(3497),
    [anon_sym_explicit] = ACTIONS(3497),
    [anon_sym_typename] = ACTIONS(3497),
    [anon_sym_template] = ACTIONS(3497),
    [anon_sym_operator] = ACTIONS(3497),
    [anon_sym_try] = ACTIONS(3497),
    [anon_sym_delete] = ACTIONS(3497),
    [anon_sym_throw] = ACTIONS(3497),
    [anon_sym_namespace] = ACTIONS(3497),
    [anon_sym_using] = ACTIONS(3497),
    [anon_sym_static_assert] = ACTIONS(3497),
    [anon_sym_concept] = ACTIONS(3497),
    [anon_sym_co_return] = ACTIONS(3497),
    [anon_sym_co_yield] = ACTIONS(3497),
    [anon_sym_R_DQUOTE] = ACTIONS(3499),
    [anon_sym_LR_DQUOTE] = ACTIONS(3499),
    [anon_sym_uR_DQUOTE] = ACTIONS(3499),
    [anon_sym_UR_DQUOTE] = ACTIONS(3499),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3499),
    [anon_sym_co_await] = ACTIONS(3497),
    [anon_sym_new] = ACTIONS(3497),
    [anon_sym_requires] = ACTIONS(3497),
    [sym_this] = ACTIONS(3497),
    [anon_sym_discard] = ACTIONS(3497),
    [anon_sym_precise] = ACTIONS(3497),
    [anon_sym_shared] = ACTIONS(3497),
    [anon_sym_groupshared] = ACTIONS(3497),
    [anon_sym_uniform] = ACTIONS(3497),
    [anon_sym_row_major] = ACTIONS(3497),
    [anon_sym_column_major] = ACTIONS(3497),
    [anon_sym_globallycoherent] = ACTIONS(3497),
    [anon_sym_centroid] = ACTIONS(3497),
    [anon_sym_noperspective] = ACTIONS(3497),
    [anon_sym_nointerpolation] = ACTIONS(3497),
    [anon_sym_sample] = ACTIONS(3497),
    [anon_sym_linear] = ACTIONS(3497),
    [anon_sym_snorm] = ACTIONS(3497),
    [anon_sym_unorm] = ACTIONS(3497),
    [anon_sym_point] = ACTIONS(3497),
    [anon_sym_line] = ACTIONS(3497),
    [anon_sym_triangleadj] = ACTIONS(3497),
    [anon_sym_lineadj] = ACTIONS(3497),
    [anon_sym_triangle] = ACTIONS(3497),
    [anon_sym_cbuffer] = ACTIONS(3497),
    [anon_sym_interface] = ACTIONS(3497),
    [anon_sym_extension] = ACTIONS(3497),
  },
  [920] = {
    [sym_identifier] = ACTIONS(3613),
    [aux_sym_preproc_include_token1] = ACTIONS(3613),
    [aux_sym_preproc_def_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token2] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3613),
    [sym_preproc_directive] = ACTIONS(3613),
    [anon_sym_LPAREN2] = ACTIONS(3615),
    [anon_sym_BANG] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3613),
    [anon_sym_PLUS] = ACTIONS(3613),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym_SEMI] = ACTIONS(3615),
    [anon_sym___extension__] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3613),
    [anon_sym_in] = ACTIONS(3613),
    [anon_sym_out] = ACTIONS(3613),
    [anon_sym_inout] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym___attribute__] = ACTIONS(3613),
    [anon_sym_COLON_COLON] = ACTIONS(3615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3615),
    [anon_sym___declspec] = ACTIONS(3613),
    [anon_sym___based] = ACTIONS(3613),
    [anon_sym___cdecl] = ACTIONS(3613),
    [anon_sym___clrcall] = ACTIONS(3613),
    [anon_sym___stdcall] = ACTIONS(3613),
    [anon_sym___fastcall] = ACTIONS(3613),
    [anon_sym___thiscall] = ACTIONS(3613),
    [anon_sym___vectorcall] = ACTIONS(3613),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_signed] = ACTIONS(3613),
    [anon_sym_unsigned] = ACTIONS(3613),
    [anon_sym_long] = ACTIONS(3613),
    [anon_sym_short] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_register] = ACTIONS(3613),
    [anon_sym_inline] = ACTIONS(3613),
    [anon_sym___inline] = ACTIONS(3613),
    [anon_sym___inline__] = ACTIONS(3613),
    [anon_sym___forceinline] = ACTIONS(3613),
    [anon_sym_thread_local] = ACTIONS(3613),
    [anon_sym___thread] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_constexpr] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_restrict] = ACTIONS(3613),
    [anon_sym___restrict__] = ACTIONS(3613),
    [anon_sym__Atomic] = ACTIONS(3613),
    [anon_sym__Noreturn] = ACTIONS(3613),
    [anon_sym_noreturn] = ACTIONS(3613),
    [anon_sym_mutable] = ACTIONS(3613),
    [anon_sym_constinit] = ACTIONS(3613),
    [anon_sym_consteval] = ACTIONS(3613),
    [anon_sym_alignas] = ACTIONS(3613),
    [anon_sym__Alignas] = ACTIONS(3613),
    [sym_primitive_type] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_union] = ACTIONS(3613),
    [anon_sym_if] = ACTIONS(3613),
    [anon_sym_switch] = ACTIONS(3613),
    [anon_sym_case] = ACTIONS(3613),
    [anon_sym_default] = ACTIONS(3613),
    [anon_sym_while] = ACTIONS(3613),
    [anon_sym_do] = ACTIONS(3613),
    [anon_sym_for] = ACTIONS(3613),
    [anon_sym_return] = ACTIONS(3613),
    [anon_sym_break] = ACTIONS(3613),
    [anon_sym_continue] = ACTIONS(3613),
    [anon_sym_goto] = ACTIONS(3613),
    [anon_sym___try] = ACTIONS(3613),
    [anon_sym___leave] = ACTIONS(3613),
    [anon_sym_not] = ACTIONS(3613),
    [anon_sym_compl] = ACTIONS(3613),
    [anon_sym_DASH_DASH] = ACTIONS(3615),
    [anon_sym_PLUS_PLUS] = ACTIONS(3615),
    [anon_sym_sizeof] = ACTIONS(3613),
    [anon_sym___alignof__] = ACTIONS(3613),
    [anon_sym___alignof] = ACTIONS(3613),
    [anon_sym__alignof] = ACTIONS(3613),
    [anon_sym_alignof] = ACTIONS(3613),
    [anon_sym__Alignof] = ACTIONS(3613),
    [anon_sym_offsetof] = ACTIONS(3613),
    [anon_sym__Generic] = ACTIONS(3613),
    [anon_sym_asm] = ACTIONS(3613),
    [anon_sym___asm__] = ACTIONS(3613),
    [sym_number_literal] = ACTIONS(3615),
    [anon_sym_L_SQUOTE] = ACTIONS(3615),
    [anon_sym_u_SQUOTE] = ACTIONS(3615),
    [anon_sym_U_SQUOTE] = ACTIONS(3615),
    [anon_sym_u8_SQUOTE] = ACTIONS(3615),
    [anon_sym_SQUOTE] = ACTIONS(3615),
    [anon_sym_L_DQUOTE] = ACTIONS(3615),
    [anon_sym_u_DQUOTE] = ACTIONS(3615),
    [anon_sym_U_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8_DQUOTE] = ACTIONS(3615),
    [anon_sym_DQUOTE] = ACTIONS(3615),
    [sym_true] = ACTIONS(3613),
    [sym_false] = ACTIONS(3613),
    [anon_sym_NULL] = ACTIONS(3613),
    [anon_sym_nullptr] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_This] = ACTIONS(3613),
    [anon_sym_decltype] = ACTIONS(3613),
    [sym_virtual] = ACTIONS(3613),
    [anon_sym_explicit] = ACTIONS(3613),
    [anon_sym_typename] = ACTIONS(3613),
    [anon_sym_template] = ACTIONS(3613),
    [anon_sym_operator] = ACTIONS(3613),
    [anon_sym_try] = ACTIONS(3613),
    [anon_sym_delete] = ACTIONS(3613),
    [anon_sym_throw] = ACTIONS(3613),
    [anon_sym_namespace] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_static_assert] = ACTIONS(3613),
    [anon_sym_concept] = ACTIONS(3613),
    [anon_sym_co_return] = ACTIONS(3613),
    [anon_sym_co_yield] = ACTIONS(3613),
    [anon_sym_R_DQUOTE] = ACTIONS(3615),
    [anon_sym_LR_DQUOTE] = ACTIONS(3615),
    [anon_sym_uR_DQUOTE] = ACTIONS(3615),
    [anon_sym_UR_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3615),
    [anon_sym_co_await] = ACTIONS(3613),
    [anon_sym_new] = ACTIONS(3613),
    [anon_sym_requires] = ACTIONS(3613),
    [sym_this] = ACTIONS(3613),
    [anon_sym_discard] = ACTIONS(3613),
    [anon_sym_precise] = ACTIONS(3613),
    [anon_sym_shared] = ACTIONS(3613),
    [anon_sym_groupshared] = ACTIONS(3613),
    [anon_sym_uniform] = ACTIONS(3613),
    [anon_sym_row_major] = ACTIONS(3613),
    [anon_sym_column_major] = ACTIONS(3613),
    [anon_sym_globallycoherent] = ACTIONS(3613),
    [anon_sym_centroid] = ACTIONS(3613),
    [anon_sym_noperspective] = ACTIONS(3613),
    [anon_sym_nointerpolation] = ACTIONS(3613),
    [anon_sym_sample] = ACTIONS(3613),
    [anon_sym_linear] = ACTIONS(3613),
    [anon_sym_snorm] = ACTIONS(3613),
    [anon_sym_unorm] = ACTIONS(3613),
    [anon_sym_point] = ACTIONS(3613),
    [anon_sym_line] = ACTIONS(3613),
    [anon_sym_triangleadj] = ACTIONS(3613),
    [anon_sym_lineadj] = ACTIONS(3613),
    [anon_sym_triangle] = ACTIONS(3613),
    [anon_sym_cbuffer] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_extension] = ACTIONS(3613),
  },
  [921] = {
    [sym_identifier] = ACTIONS(3613),
    [aux_sym_preproc_include_token1] = ACTIONS(3613),
    [aux_sym_preproc_def_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token2] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3613),
    [sym_preproc_directive] = ACTIONS(3613),
    [anon_sym_LPAREN2] = ACTIONS(3615),
    [anon_sym_BANG] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3613),
    [anon_sym_PLUS] = ACTIONS(3613),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym_SEMI] = ACTIONS(3615),
    [anon_sym___extension__] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3613),
    [anon_sym_in] = ACTIONS(3613),
    [anon_sym_out] = ACTIONS(3613),
    [anon_sym_inout] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym___attribute__] = ACTIONS(3613),
    [anon_sym_COLON_COLON] = ACTIONS(3615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3615),
    [anon_sym___declspec] = ACTIONS(3613),
    [anon_sym___based] = ACTIONS(3613),
    [anon_sym___cdecl] = ACTIONS(3613),
    [anon_sym___clrcall] = ACTIONS(3613),
    [anon_sym___stdcall] = ACTIONS(3613),
    [anon_sym___fastcall] = ACTIONS(3613),
    [anon_sym___thiscall] = ACTIONS(3613),
    [anon_sym___vectorcall] = ACTIONS(3613),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_signed] = ACTIONS(3613),
    [anon_sym_unsigned] = ACTIONS(3613),
    [anon_sym_long] = ACTIONS(3613),
    [anon_sym_short] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_register] = ACTIONS(3613),
    [anon_sym_inline] = ACTIONS(3613),
    [anon_sym___inline] = ACTIONS(3613),
    [anon_sym___inline__] = ACTIONS(3613),
    [anon_sym___forceinline] = ACTIONS(3613),
    [anon_sym_thread_local] = ACTIONS(3613),
    [anon_sym___thread] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_constexpr] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_restrict] = ACTIONS(3613),
    [anon_sym___restrict__] = ACTIONS(3613),
    [anon_sym__Atomic] = ACTIONS(3613),
    [anon_sym__Noreturn] = ACTIONS(3613),
    [anon_sym_noreturn] = ACTIONS(3613),
    [anon_sym_mutable] = ACTIONS(3613),
    [anon_sym_constinit] = ACTIONS(3613),
    [anon_sym_consteval] = ACTIONS(3613),
    [anon_sym_alignas] = ACTIONS(3613),
    [anon_sym__Alignas] = ACTIONS(3613),
    [sym_primitive_type] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_union] = ACTIONS(3613),
    [anon_sym_if] = ACTIONS(3613),
    [anon_sym_switch] = ACTIONS(3613),
    [anon_sym_case] = ACTIONS(3613),
    [anon_sym_default] = ACTIONS(3613),
    [anon_sym_while] = ACTIONS(3613),
    [anon_sym_do] = ACTIONS(3613),
    [anon_sym_for] = ACTIONS(3613),
    [anon_sym_return] = ACTIONS(3613),
    [anon_sym_break] = ACTIONS(3613),
    [anon_sym_continue] = ACTIONS(3613),
    [anon_sym_goto] = ACTIONS(3613),
    [anon_sym___try] = ACTIONS(3613),
    [anon_sym___leave] = ACTIONS(3613),
    [anon_sym_not] = ACTIONS(3613),
    [anon_sym_compl] = ACTIONS(3613),
    [anon_sym_DASH_DASH] = ACTIONS(3615),
    [anon_sym_PLUS_PLUS] = ACTIONS(3615),
    [anon_sym_sizeof] = ACTIONS(3613),
    [anon_sym___alignof__] = ACTIONS(3613),
    [anon_sym___alignof] = ACTIONS(3613),
    [anon_sym__alignof] = ACTIONS(3613),
    [anon_sym_alignof] = ACTIONS(3613),
    [anon_sym__Alignof] = ACTIONS(3613),
    [anon_sym_offsetof] = ACTIONS(3613),
    [anon_sym__Generic] = ACTIONS(3613),
    [anon_sym_asm] = ACTIONS(3613),
    [anon_sym___asm__] = ACTIONS(3613),
    [sym_number_literal] = ACTIONS(3615),
    [anon_sym_L_SQUOTE] = ACTIONS(3615),
    [anon_sym_u_SQUOTE] = ACTIONS(3615),
    [anon_sym_U_SQUOTE] = ACTIONS(3615),
    [anon_sym_u8_SQUOTE] = ACTIONS(3615),
    [anon_sym_SQUOTE] = ACTIONS(3615),
    [anon_sym_L_DQUOTE] = ACTIONS(3615),
    [anon_sym_u_DQUOTE] = ACTIONS(3615),
    [anon_sym_U_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8_DQUOTE] = ACTIONS(3615),
    [anon_sym_DQUOTE] = ACTIONS(3615),
    [sym_true] = ACTIONS(3613),
    [sym_false] = ACTIONS(3613),
    [anon_sym_NULL] = ACTIONS(3613),
    [anon_sym_nullptr] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_This] = ACTIONS(3613),
    [anon_sym_decltype] = ACTIONS(3613),
    [sym_virtual] = ACTIONS(3613),
    [anon_sym_explicit] = ACTIONS(3613),
    [anon_sym_typename] = ACTIONS(3613),
    [anon_sym_template] = ACTIONS(3613),
    [anon_sym_operator] = ACTIONS(3613),
    [anon_sym_try] = ACTIONS(3613),
    [anon_sym_delete] = ACTIONS(3613),
    [anon_sym_throw] = ACTIONS(3613),
    [anon_sym_namespace] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_static_assert] = ACTIONS(3613),
    [anon_sym_concept] = ACTIONS(3613),
    [anon_sym_co_return] = ACTIONS(3613),
    [anon_sym_co_yield] = ACTIONS(3613),
    [anon_sym_R_DQUOTE] = ACTIONS(3615),
    [anon_sym_LR_DQUOTE] = ACTIONS(3615),
    [anon_sym_uR_DQUOTE] = ACTIONS(3615),
    [anon_sym_UR_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3615),
    [anon_sym_co_await] = ACTIONS(3613),
    [anon_sym_new] = ACTIONS(3613),
    [anon_sym_requires] = ACTIONS(3613),
    [sym_this] = ACTIONS(3613),
    [anon_sym_discard] = ACTIONS(3613),
    [anon_sym_precise] = ACTIONS(3613),
    [anon_sym_shared] = ACTIONS(3613),
    [anon_sym_groupshared] = ACTIONS(3613),
    [anon_sym_uniform] = ACTIONS(3613),
    [anon_sym_row_major] = ACTIONS(3613),
    [anon_sym_column_major] = ACTIONS(3613),
    [anon_sym_globallycoherent] = ACTIONS(3613),
    [anon_sym_centroid] = ACTIONS(3613),
    [anon_sym_noperspective] = ACTIONS(3613),
    [anon_sym_nointerpolation] = ACTIONS(3613),
    [anon_sym_sample] = ACTIONS(3613),
    [anon_sym_linear] = ACTIONS(3613),
    [anon_sym_snorm] = ACTIONS(3613),
    [anon_sym_unorm] = ACTIONS(3613),
    [anon_sym_point] = ACTIONS(3613),
    [anon_sym_line] = ACTIONS(3613),
    [anon_sym_triangleadj] = ACTIONS(3613),
    [anon_sym_lineadj] = ACTIONS(3613),
    [anon_sym_triangle] = ACTIONS(3613),
    [anon_sym_cbuffer] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_extension] = ACTIONS(3613),
  },
  [922] = {
    [sym_identifier] = ACTIONS(3539),
    [aux_sym_preproc_include_token1] = ACTIONS(3539),
    [aux_sym_preproc_def_token1] = ACTIONS(3539),
    [aux_sym_preproc_if_token1] = ACTIONS(3539),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3539),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3539),
    [sym_preproc_directive] = ACTIONS(3539),
    [anon_sym_LPAREN2] = ACTIONS(3541),
    [anon_sym_BANG] = ACTIONS(3541),
    [anon_sym_TILDE] = ACTIONS(3541),
    [anon_sym_DASH] = ACTIONS(3539),
    [anon_sym_PLUS] = ACTIONS(3539),
    [anon_sym_STAR] = ACTIONS(3541),
    [anon_sym_AMP_AMP] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym_SEMI] = ACTIONS(3541),
    [anon_sym___extension__] = ACTIONS(3539),
    [anon_sym_typedef] = ACTIONS(3539),
    [anon_sym_in] = ACTIONS(3539),
    [anon_sym_out] = ACTIONS(3539),
    [anon_sym_inout] = ACTIONS(3539),
    [anon_sym_extern] = ACTIONS(3539),
    [anon_sym___attribute__] = ACTIONS(3539),
    [anon_sym_COLON_COLON] = ACTIONS(3541),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3541),
    [anon_sym___declspec] = ACTIONS(3539),
    [anon_sym___based] = ACTIONS(3539),
    [anon_sym___cdecl] = ACTIONS(3539),
    [anon_sym___clrcall] = ACTIONS(3539),
    [anon_sym___stdcall] = ACTIONS(3539),
    [anon_sym___fastcall] = ACTIONS(3539),
    [anon_sym___thiscall] = ACTIONS(3539),
    [anon_sym___vectorcall] = ACTIONS(3539),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(3541),
    [anon_sym_signed] = ACTIONS(3539),
    [anon_sym_unsigned] = ACTIONS(3539),
    [anon_sym_long] = ACTIONS(3539),
    [anon_sym_short] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_static] = ACTIONS(3539),
    [anon_sym_register] = ACTIONS(3539),
    [anon_sym_inline] = ACTIONS(3539),
    [anon_sym___inline] = ACTIONS(3539),
    [anon_sym___inline__] = ACTIONS(3539),
    [anon_sym___forceinline] = ACTIONS(3539),
    [anon_sym_thread_local] = ACTIONS(3539),
    [anon_sym___thread] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3539),
    [anon_sym_constexpr] = ACTIONS(3539),
    [anon_sym_volatile] = ACTIONS(3539),
    [anon_sym_restrict] = ACTIONS(3539),
    [anon_sym___restrict__] = ACTIONS(3539),
    [anon_sym__Atomic] = ACTIONS(3539),
    [anon_sym__Noreturn] = ACTIONS(3539),
    [anon_sym_noreturn] = ACTIONS(3539),
    [anon_sym_mutable] = ACTIONS(3539),
    [anon_sym_constinit] = ACTIONS(3539),
    [anon_sym_consteval] = ACTIONS(3539),
    [anon_sym_alignas] = ACTIONS(3539),
    [anon_sym__Alignas] = ACTIONS(3539),
    [sym_primitive_type] = ACTIONS(3539),
    [anon_sym_enum] = ACTIONS(3539),
    [anon_sym_class] = ACTIONS(3539),
    [anon_sym_struct] = ACTIONS(3539),
    [anon_sym_union] = ACTIONS(3539),
    [anon_sym_if] = ACTIONS(3539),
    [anon_sym_switch] = ACTIONS(3539),
    [anon_sym_case] = ACTIONS(3539),
    [anon_sym_default] = ACTIONS(3539),
    [anon_sym_while] = ACTIONS(3539),
    [anon_sym_do] = ACTIONS(3539),
    [anon_sym_for] = ACTIONS(3539),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_break] = ACTIONS(3539),
    [anon_sym_continue] = ACTIONS(3539),
    [anon_sym_goto] = ACTIONS(3539),
    [anon_sym___try] = ACTIONS(3539),
    [anon_sym___leave] = ACTIONS(3539),
    [anon_sym_not] = ACTIONS(3539),
    [anon_sym_compl] = ACTIONS(3539),
    [anon_sym_DASH_DASH] = ACTIONS(3541),
    [anon_sym_PLUS_PLUS] = ACTIONS(3541),
    [anon_sym_sizeof] = ACTIONS(3539),
    [anon_sym___alignof__] = ACTIONS(3539),
    [anon_sym___alignof] = ACTIONS(3539),
    [anon_sym__alignof] = ACTIONS(3539),
    [anon_sym_alignof] = ACTIONS(3539),
    [anon_sym__Alignof] = ACTIONS(3539),
    [anon_sym_offsetof] = ACTIONS(3539),
    [anon_sym__Generic] = ACTIONS(3539),
    [anon_sym_asm] = ACTIONS(3539),
    [anon_sym___asm__] = ACTIONS(3539),
    [sym_number_literal] = ACTIONS(3541),
    [anon_sym_L_SQUOTE] = ACTIONS(3541),
    [anon_sym_u_SQUOTE] = ACTIONS(3541),
    [anon_sym_U_SQUOTE] = ACTIONS(3541),
    [anon_sym_u8_SQUOTE] = ACTIONS(3541),
    [anon_sym_SQUOTE] = ACTIONS(3541),
    [anon_sym_L_DQUOTE] = ACTIONS(3541),
    [anon_sym_u_DQUOTE] = ACTIONS(3541),
    [anon_sym_U_DQUOTE] = ACTIONS(3541),
    [anon_sym_u8_DQUOTE] = ACTIONS(3541),
    [anon_sym_DQUOTE] = ACTIONS(3541),
    [sym_true] = ACTIONS(3539),
    [sym_false] = ACTIONS(3539),
    [anon_sym_NULL] = ACTIONS(3539),
    [anon_sym_nullptr] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_This] = ACTIONS(3539),
    [anon_sym_decltype] = ACTIONS(3539),
    [sym_virtual] = ACTIONS(3539),
    [anon_sym_explicit] = ACTIONS(3539),
    [anon_sym_typename] = ACTIONS(3539),
    [anon_sym_template] = ACTIONS(3539),
    [anon_sym_operator] = ACTIONS(3539),
    [anon_sym_try] = ACTIONS(3539),
    [anon_sym_delete] = ACTIONS(3539),
    [anon_sym_throw] = ACTIONS(3539),
    [anon_sym_namespace] = ACTIONS(3539),
    [anon_sym_using] = ACTIONS(3539),
    [anon_sym_static_assert] = ACTIONS(3539),
    [anon_sym_concept] = ACTIONS(3539),
    [anon_sym_co_return] = ACTIONS(3539),
    [anon_sym_co_yield] = ACTIONS(3539),
    [anon_sym_R_DQUOTE] = ACTIONS(3541),
    [anon_sym_LR_DQUOTE] = ACTIONS(3541),
    [anon_sym_uR_DQUOTE] = ACTIONS(3541),
    [anon_sym_UR_DQUOTE] = ACTIONS(3541),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3541),
    [anon_sym_co_await] = ACTIONS(3539),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_requires] = ACTIONS(3539),
    [sym_this] = ACTIONS(3539),
    [anon_sym_discard] = ACTIONS(3539),
    [anon_sym_precise] = ACTIONS(3539),
    [anon_sym_shared] = ACTIONS(3539),
    [anon_sym_groupshared] = ACTIONS(3539),
    [anon_sym_uniform] = ACTIONS(3539),
    [anon_sym_row_major] = ACTIONS(3539),
    [anon_sym_column_major] = ACTIONS(3539),
    [anon_sym_globallycoherent] = ACTIONS(3539),
    [anon_sym_centroid] = ACTIONS(3539),
    [anon_sym_noperspective] = ACTIONS(3539),
    [anon_sym_nointerpolation] = ACTIONS(3539),
    [anon_sym_sample] = ACTIONS(3539),
    [anon_sym_linear] = ACTIONS(3539),
    [anon_sym_snorm] = ACTIONS(3539),
    [anon_sym_unorm] = ACTIONS(3539),
    [anon_sym_point] = ACTIONS(3539),
    [anon_sym_line] = ACTIONS(3539),
    [anon_sym_triangleadj] = ACTIONS(3539),
    [anon_sym_lineadj] = ACTIONS(3539),
    [anon_sym_triangle] = ACTIONS(3539),
    [anon_sym_cbuffer] = ACTIONS(3539),
    [anon_sym_interface] = ACTIONS(3539),
    [anon_sym_extension] = ACTIONS(3539),
  },
  [923] = {
    [sym_catch_clause] = STATE(290),
    [aux_sym_constructor_try_statement_repeat1] = STATE(290),
    [ts_builtin_sym_end] = ACTIONS(2832),
    [sym_identifier] = ACTIONS(2830),
    [aux_sym_preproc_include_token1] = ACTIONS(2830),
    [aux_sym_preproc_def_token1] = ACTIONS(2830),
    [aux_sym_preproc_if_token1] = ACTIONS(2830),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2830),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2830),
    [sym_preproc_directive] = ACTIONS(2830),
    [anon_sym_LPAREN2] = ACTIONS(2832),
    [anon_sym_BANG] = ACTIONS(2832),
    [anon_sym_TILDE] = ACTIONS(2832),
    [anon_sym_DASH] = ACTIONS(2830),
    [anon_sym_PLUS] = ACTIONS(2830),
    [anon_sym_STAR] = ACTIONS(2832),
    [anon_sym_AMP_AMP] = ACTIONS(2832),
    [anon_sym_AMP] = ACTIONS(2830),
    [anon_sym___extension__] = ACTIONS(2830),
    [anon_sym_typedef] = ACTIONS(2830),
    [anon_sym_in] = ACTIONS(2830),
    [anon_sym_out] = ACTIONS(2830),
    [anon_sym_inout] = ACTIONS(2830),
    [anon_sym_extern] = ACTIONS(2830),
    [anon_sym___attribute__] = ACTIONS(2830),
    [anon_sym_COLON_COLON] = ACTIONS(2832),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2832),
    [anon_sym___declspec] = ACTIONS(2830),
    [anon_sym___based] = ACTIONS(2830),
    [anon_sym___cdecl] = ACTIONS(2830),
    [anon_sym___clrcall] = ACTIONS(2830),
    [anon_sym___stdcall] = ACTIONS(2830),
    [anon_sym___fastcall] = ACTIONS(2830),
    [anon_sym___thiscall] = ACTIONS(2830),
    [anon_sym___vectorcall] = ACTIONS(2830),
    [anon_sym_LBRACE] = ACTIONS(2832),
    [anon_sym_signed] = ACTIONS(2830),
    [anon_sym_unsigned] = ACTIONS(2830),
    [anon_sym_long] = ACTIONS(2830),
    [anon_sym_short] = ACTIONS(2830),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [anon_sym_static] = ACTIONS(2830),
    [anon_sym_register] = ACTIONS(2830),
    [anon_sym_inline] = ACTIONS(2830),
    [anon_sym___inline] = ACTIONS(2830),
    [anon_sym___inline__] = ACTIONS(2830),
    [anon_sym___forceinline] = ACTIONS(2830),
    [anon_sym_thread_local] = ACTIONS(2830),
    [anon_sym___thread] = ACTIONS(2830),
    [anon_sym_const] = ACTIONS(2830),
    [anon_sym_constexpr] = ACTIONS(2830),
    [anon_sym_volatile] = ACTIONS(2830),
    [anon_sym_restrict] = ACTIONS(2830),
    [anon_sym___restrict__] = ACTIONS(2830),
    [anon_sym__Atomic] = ACTIONS(2830),
    [anon_sym__Noreturn] = ACTIONS(2830),
    [anon_sym_noreturn] = ACTIONS(2830),
    [anon_sym_mutable] = ACTIONS(2830),
    [anon_sym_constinit] = ACTIONS(2830),
    [anon_sym_consteval] = ACTIONS(2830),
    [anon_sym_alignas] = ACTIONS(2830),
    [anon_sym__Alignas] = ACTIONS(2830),
    [sym_primitive_type] = ACTIONS(2830),
    [anon_sym_enum] = ACTIONS(2830),
    [anon_sym_class] = ACTIONS(2830),
    [anon_sym_struct] = ACTIONS(2830),
    [anon_sym_union] = ACTIONS(2830),
    [anon_sym_if] = ACTIONS(2830),
    [anon_sym_switch] = ACTIONS(2830),
    [anon_sym_case] = ACTIONS(2830),
    [anon_sym_default] = ACTIONS(2830),
    [anon_sym_while] = ACTIONS(2830),
    [anon_sym_do] = ACTIONS(2830),
    [anon_sym_for] = ACTIONS(2830),
    [anon_sym_return] = ACTIONS(2830),
    [anon_sym_break] = ACTIONS(2830),
    [anon_sym_continue] = ACTIONS(2830),
    [anon_sym_goto] = ACTIONS(2830),
    [anon_sym_not] = ACTIONS(2830),
    [anon_sym_compl] = ACTIONS(2830),
    [anon_sym_DASH_DASH] = ACTIONS(2832),
    [anon_sym_PLUS_PLUS] = ACTIONS(2832),
    [anon_sym_sizeof] = ACTIONS(2830),
    [anon_sym___alignof__] = ACTIONS(2830),
    [anon_sym___alignof] = ACTIONS(2830),
    [anon_sym__alignof] = ACTIONS(2830),
    [anon_sym_alignof] = ACTIONS(2830),
    [anon_sym__Alignof] = ACTIONS(2830),
    [anon_sym_offsetof] = ACTIONS(2830),
    [anon_sym__Generic] = ACTIONS(2830),
    [anon_sym_asm] = ACTIONS(2830),
    [anon_sym___asm__] = ACTIONS(2830),
    [sym_number_literal] = ACTIONS(2832),
    [anon_sym_L_SQUOTE] = ACTIONS(2832),
    [anon_sym_u_SQUOTE] = ACTIONS(2832),
    [anon_sym_U_SQUOTE] = ACTIONS(2832),
    [anon_sym_u8_SQUOTE] = ACTIONS(2832),
    [anon_sym_SQUOTE] = ACTIONS(2832),
    [anon_sym_L_DQUOTE] = ACTIONS(2832),
    [anon_sym_u_DQUOTE] = ACTIONS(2832),
    [anon_sym_U_DQUOTE] = ACTIONS(2832),
    [anon_sym_u8_DQUOTE] = ACTIONS(2832),
    [anon_sym_DQUOTE] = ACTIONS(2832),
    [sym_true] = ACTIONS(2830),
    [sym_false] = ACTIONS(2830),
    [anon_sym_NULL] = ACTIONS(2830),
    [anon_sym_nullptr] = ACTIONS(2830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2830),
    [anon_sym_let] = ACTIONS(2830),
    [anon_sym_This] = ACTIONS(2830),
    [anon_sym_decltype] = ACTIONS(2830),
    [sym_virtual] = ACTIONS(2830),
    [anon_sym_explicit] = ACTIONS(2830),
    [anon_sym_typename] = ACTIONS(2830),
    [anon_sym_template] = ACTIONS(2830),
    [anon_sym_operator] = ACTIONS(2830),
    [anon_sym_try] = ACTIONS(2830),
    [anon_sym_delete] = ACTIONS(2830),
    [anon_sym_throw] = ACTIONS(2830),
    [anon_sym_namespace] = ACTIONS(2830),
    [anon_sym_using] = ACTIONS(2830),
    [anon_sym_static_assert] = ACTIONS(2830),
    [anon_sym_concept] = ACTIONS(2830),
    [anon_sym_co_return] = ACTIONS(2830),
    [anon_sym_co_yield] = ACTIONS(2830),
    [anon_sym_catch] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2832),
    [anon_sym_LR_DQUOTE] = ACTIONS(2832),
    [anon_sym_uR_DQUOTE] = ACTIONS(2832),
    [anon_sym_UR_DQUOTE] = ACTIONS(2832),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2832),
    [anon_sym_co_await] = ACTIONS(2830),
    [anon_sym_new] = ACTIONS(2830),
    [anon_sym_requires] = ACTIONS(2830),
    [sym_this] = ACTIONS(2830),
    [anon_sym_precise] = ACTIONS(2830),
    [anon_sym_shared] = ACTIONS(2830),
    [anon_sym_groupshared] = ACTIONS(2830),
    [anon_sym_uniform] = ACTIONS(2830),
    [anon_sym_row_major] = ACTIONS(2830),
    [anon_sym_column_major] = ACTIONS(2830),
    [anon_sym_globallycoherent] = ACTIONS(2830),
    [anon_sym_centroid] = ACTIONS(2830),
    [anon_sym_noperspective] = ACTIONS(2830),
    [anon_sym_nointerpolation] = ACTIONS(2830),
    [anon_sym_sample] = ACTIONS(2830),
    [anon_sym_linear] = ACTIONS(2830),
    [anon_sym_snorm] = ACTIONS(2830),
    [anon_sym_unorm] = ACTIONS(2830),
    [anon_sym_point] = ACTIONS(2830),
    [anon_sym_line] = ACTIONS(2830),
    [anon_sym_triangleadj] = ACTIONS(2830),
    [anon_sym_lineadj] = ACTIONS(2830),
    [anon_sym_triangle] = ACTIONS(2830),
    [anon_sym_interface] = ACTIONS(2830),
    [anon_sym_extension] = ACTIONS(2830),
    [anon_sym___exported] = ACTIONS(2830),
    [anon_sym_import] = ACTIONS(2830),
  },
  [924] = {
    [sym_identifier] = ACTIONS(3547),
    [aux_sym_preproc_include_token1] = ACTIONS(3547),
    [aux_sym_preproc_def_token1] = ACTIONS(3547),
    [aux_sym_preproc_if_token1] = ACTIONS(3547),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3547),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3547),
    [sym_preproc_directive] = ACTIONS(3547),
    [anon_sym_LPAREN2] = ACTIONS(3549),
    [anon_sym_BANG] = ACTIONS(3549),
    [anon_sym_TILDE] = ACTIONS(3549),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_STAR] = ACTIONS(3549),
    [anon_sym_AMP_AMP] = ACTIONS(3549),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym_SEMI] = ACTIONS(3549),
    [anon_sym___extension__] = ACTIONS(3547),
    [anon_sym_typedef] = ACTIONS(3547),
    [anon_sym_in] = ACTIONS(3547),
    [anon_sym_out] = ACTIONS(3547),
    [anon_sym_inout] = ACTIONS(3547),
    [anon_sym_extern] = ACTIONS(3547),
    [anon_sym___attribute__] = ACTIONS(3547),
    [anon_sym_COLON_COLON] = ACTIONS(3549),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3549),
    [anon_sym___declspec] = ACTIONS(3547),
    [anon_sym___based] = ACTIONS(3547),
    [anon_sym___cdecl] = ACTIONS(3547),
    [anon_sym___clrcall] = ACTIONS(3547),
    [anon_sym___stdcall] = ACTIONS(3547),
    [anon_sym___fastcall] = ACTIONS(3547),
    [anon_sym___thiscall] = ACTIONS(3547),
    [anon_sym___vectorcall] = ACTIONS(3547),
    [anon_sym_LBRACE] = ACTIONS(3549),
    [anon_sym_RBRACE] = ACTIONS(3549),
    [anon_sym_signed] = ACTIONS(3547),
    [anon_sym_unsigned] = ACTIONS(3547),
    [anon_sym_long] = ACTIONS(3547),
    [anon_sym_short] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_static] = ACTIONS(3547),
    [anon_sym_register] = ACTIONS(3547),
    [anon_sym_inline] = ACTIONS(3547),
    [anon_sym___inline] = ACTIONS(3547),
    [anon_sym___inline__] = ACTIONS(3547),
    [anon_sym___forceinline] = ACTIONS(3547),
    [anon_sym_thread_local] = ACTIONS(3547),
    [anon_sym___thread] = ACTIONS(3547),
    [anon_sym_const] = ACTIONS(3547),
    [anon_sym_constexpr] = ACTIONS(3547),
    [anon_sym_volatile] = ACTIONS(3547),
    [anon_sym_restrict] = ACTIONS(3547),
    [anon_sym___restrict__] = ACTIONS(3547),
    [anon_sym__Atomic] = ACTIONS(3547),
    [anon_sym__Noreturn] = ACTIONS(3547),
    [anon_sym_noreturn] = ACTIONS(3547),
    [anon_sym_mutable] = ACTIONS(3547),
    [anon_sym_constinit] = ACTIONS(3547),
    [anon_sym_consteval] = ACTIONS(3547),
    [anon_sym_alignas] = ACTIONS(3547),
    [anon_sym__Alignas] = ACTIONS(3547),
    [sym_primitive_type] = ACTIONS(3547),
    [anon_sym_enum] = ACTIONS(3547),
    [anon_sym_class] = ACTIONS(3547),
    [anon_sym_struct] = ACTIONS(3547),
    [anon_sym_union] = ACTIONS(3547),
    [anon_sym_if] = ACTIONS(3547),
    [anon_sym_switch] = ACTIONS(3547),
    [anon_sym_case] = ACTIONS(3547),
    [anon_sym_default] = ACTIONS(3547),
    [anon_sym_while] = ACTIONS(3547),
    [anon_sym_do] = ACTIONS(3547),
    [anon_sym_for] = ACTIONS(3547),
    [anon_sym_return] = ACTIONS(3547),
    [anon_sym_break] = ACTIONS(3547),
    [anon_sym_continue] = ACTIONS(3547),
    [anon_sym_goto] = ACTIONS(3547),
    [anon_sym___try] = ACTIONS(3547),
    [anon_sym___leave] = ACTIONS(3547),
    [anon_sym_not] = ACTIONS(3547),
    [anon_sym_compl] = ACTIONS(3547),
    [anon_sym_DASH_DASH] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(3549),
    [anon_sym_sizeof] = ACTIONS(3547),
    [anon_sym___alignof__] = ACTIONS(3547),
    [anon_sym___alignof] = ACTIONS(3547),
    [anon_sym__alignof] = ACTIONS(3547),
    [anon_sym_alignof] = ACTIONS(3547),
    [anon_sym__Alignof] = ACTIONS(3547),
    [anon_sym_offsetof] = ACTIONS(3547),
    [anon_sym__Generic] = ACTIONS(3547),
    [anon_sym_asm] = ACTIONS(3547),
    [anon_sym___asm__] = ACTIONS(3547),
    [sym_number_literal] = ACTIONS(3549),
    [anon_sym_L_SQUOTE] = ACTIONS(3549),
    [anon_sym_u_SQUOTE] = ACTIONS(3549),
    [anon_sym_U_SQUOTE] = ACTIONS(3549),
    [anon_sym_u8_SQUOTE] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [anon_sym_L_DQUOTE] = ACTIONS(3549),
    [anon_sym_u_DQUOTE] = ACTIONS(3549),
    [anon_sym_U_DQUOTE] = ACTIONS(3549),
    [anon_sym_u8_DQUOTE] = ACTIONS(3549),
    [anon_sym_DQUOTE] = ACTIONS(3549),
    [sym_true] = ACTIONS(3547),
    [sym_false] = ACTIONS(3547),
    [anon_sym_NULL] = ACTIONS(3547),
    [anon_sym_nullptr] = ACTIONS(3547),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_This] = ACTIONS(3547),
    [anon_sym_decltype] = ACTIONS(3547),
    [sym_virtual] = ACTIONS(3547),
    [anon_sym_explicit] = ACTIONS(3547),
    [anon_sym_typename] = ACTIONS(3547),
    [anon_sym_template] = ACTIONS(3547),
    [anon_sym_operator] = ACTIONS(3547),
    [anon_sym_try] = ACTIONS(3547),
    [anon_sym_delete] = ACTIONS(3547),
    [anon_sym_throw] = ACTIONS(3547),
    [anon_sym_namespace] = ACTIONS(3547),
    [anon_sym_using] = ACTIONS(3547),
    [anon_sym_static_assert] = ACTIONS(3547),
    [anon_sym_concept] = ACTIONS(3547),
    [anon_sym_co_return] = ACTIONS(3547),
    [anon_sym_co_yield] = ACTIONS(3547),
    [anon_sym_R_DQUOTE] = ACTIONS(3549),
    [anon_sym_LR_DQUOTE] = ACTIONS(3549),
    [anon_sym_uR_DQUOTE] = ACTIONS(3549),
    [anon_sym_UR_DQUOTE] = ACTIONS(3549),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3549),
    [anon_sym_co_await] = ACTIONS(3547),
    [anon_sym_new] = ACTIONS(3547),
    [anon_sym_requires] = ACTIONS(3547),
    [sym_this] = ACTIONS(3547),
    [anon_sym_discard] = ACTIONS(3547),
    [anon_sym_precise] = ACTIONS(3547),
    [anon_sym_shared] = ACTIONS(3547),
    [anon_sym_groupshared] = ACTIONS(3547),
    [anon_sym_uniform] = ACTIONS(3547),
    [anon_sym_row_major] = ACTIONS(3547),
    [anon_sym_column_major] = ACTIONS(3547),
    [anon_sym_globallycoherent] = ACTIONS(3547),
    [anon_sym_centroid] = ACTIONS(3547),
    [anon_sym_noperspective] = ACTIONS(3547),
    [anon_sym_nointerpolation] = ACTIONS(3547),
    [anon_sym_sample] = ACTIONS(3547),
    [anon_sym_linear] = ACTIONS(3547),
    [anon_sym_snorm] = ACTIONS(3547),
    [anon_sym_unorm] = ACTIONS(3547),
    [anon_sym_point] = ACTIONS(3547),
    [anon_sym_line] = ACTIONS(3547),
    [anon_sym_triangleadj] = ACTIONS(3547),
    [anon_sym_lineadj] = ACTIONS(3547),
    [anon_sym_triangle] = ACTIONS(3547),
    [anon_sym_cbuffer] = ACTIONS(3547),
    [anon_sym_interface] = ACTIONS(3547),
    [anon_sym_extension] = ACTIONS(3547),
  },
  [925] = {
    [sym_identifier] = ACTIONS(3613),
    [aux_sym_preproc_include_token1] = ACTIONS(3613),
    [aux_sym_preproc_def_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token2] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3613),
    [sym_preproc_directive] = ACTIONS(3613),
    [anon_sym_LPAREN2] = ACTIONS(3615),
    [anon_sym_BANG] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3613),
    [anon_sym_PLUS] = ACTIONS(3613),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym_SEMI] = ACTIONS(3615),
    [anon_sym___extension__] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3613),
    [anon_sym_in] = ACTIONS(3613),
    [anon_sym_out] = ACTIONS(3613),
    [anon_sym_inout] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym___attribute__] = ACTIONS(3613),
    [anon_sym_COLON_COLON] = ACTIONS(3615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3615),
    [anon_sym___declspec] = ACTIONS(3613),
    [anon_sym___based] = ACTIONS(3613),
    [anon_sym___cdecl] = ACTIONS(3613),
    [anon_sym___clrcall] = ACTIONS(3613),
    [anon_sym___stdcall] = ACTIONS(3613),
    [anon_sym___fastcall] = ACTIONS(3613),
    [anon_sym___thiscall] = ACTIONS(3613),
    [anon_sym___vectorcall] = ACTIONS(3613),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_signed] = ACTIONS(3613),
    [anon_sym_unsigned] = ACTIONS(3613),
    [anon_sym_long] = ACTIONS(3613),
    [anon_sym_short] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_register] = ACTIONS(3613),
    [anon_sym_inline] = ACTIONS(3613),
    [anon_sym___inline] = ACTIONS(3613),
    [anon_sym___inline__] = ACTIONS(3613),
    [anon_sym___forceinline] = ACTIONS(3613),
    [anon_sym_thread_local] = ACTIONS(3613),
    [anon_sym___thread] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_constexpr] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_restrict] = ACTIONS(3613),
    [anon_sym___restrict__] = ACTIONS(3613),
    [anon_sym__Atomic] = ACTIONS(3613),
    [anon_sym__Noreturn] = ACTIONS(3613),
    [anon_sym_noreturn] = ACTIONS(3613),
    [anon_sym_mutable] = ACTIONS(3613),
    [anon_sym_constinit] = ACTIONS(3613),
    [anon_sym_consteval] = ACTIONS(3613),
    [anon_sym_alignas] = ACTIONS(3613),
    [anon_sym__Alignas] = ACTIONS(3613),
    [sym_primitive_type] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_union] = ACTIONS(3613),
    [anon_sym_if] = ACTIONS(3613),
    [anon_sym_switch] = ACTIONS(3613),
    [anon_sym_case] = ACTIONS(3613),
    [anon_sym_default] = ACTIONS(3613),
    [anon_sym_while] = ACTIONS(3613),
    [anon_sym_do] = ACTIONS(3613),
    [anon_sym_for] = ACTIONS(3613),
    [anon_sym_return] = ACTIONS(3613),
    [anon_sym_break] = ACTIONS(3613),
    [anon_sym_continue] = ACTIONS(3613),
    [anon_sym_goto] = ACTIONS(3613),
    [anon_sym___try] = ACTIONS(3613),
    [anon_sym___leave] = ACTIONS(3613),
    [anon_sym_not] = ACTIONS(3613),
    [anon_sym_compl] = ACTIONS(3613),
    [anon_sym_DASH_DASH] = ACTIONS(3615),
    [anon_sym_PLUS_PLUS] = ACTIONS(3615),
    [anon_sym_sizeof] = ACTIONS(3613),
    [anon_sym___alignof__] = ACTIONS(3613),
    [anon_sym___alignof] = ACTIONS(3613),
    [anon_sym__alignof] = ACTIONS(3613),
    [anon_sym_alignof] = ACTIONS(3613),
    [anon_sym__Alignof] = ACTIONS(3613),
    [anon_sym_offsetof] = ACTIONS(3613),
    [anon_sym__Generic] = ACTIONS(3613),
    [anon_sym_asm] = ACTIONS(3613),
    [anon_sym___asm__] = ACTIONS(3613),
    [sym_number_literal] = ACTIONS(3615),
    [anon_sym_L_SQUOTE] = ACTIONS(3615),
    [anon_sym_u_SQUOTE] = ACTIONS(3615),
    [anon_sym_U_SQUOTE] = ACTIONS(3615),
    [anon_sym_u8_SQUOTE] = ACTIONS(3615),
    [anon_sym_SQUOTE] = ACTIONS(3615),
    [anon_sym_L_DQUOTE] = ACTIONS(3615),
    [anon_sym_u_DQUOTE] = ACTIONS(3615),
    [anon_sym_U_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8_DQUOTE] = ACTIONS(3615),
    [anon_sym_DQUOTE] = ACTIONS(3615),
    [sym_true] = ACTIONS(3613),
    [sym_false] = ACTIONS(3613),
    [anon_sym_NULL] = ACTIONS(3613),
    [anon_sym_nullptr] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_This] = ACTIONS(3613),
    [anon_sym_decltype] = ACTIONS(3613),
    [sym_virtual] = ACTIONS(3613),
    [anon_sym_explicit] = ACTIONS(3613),
    [anon_sym_typename] = ACTIONS(3613),
    [anon_sym_template] = ACTIONS(3613),
    [anon_sym_operator] = ACTIONS(3613),
    [anon_sym_try] = ACTIONS(3613),
    [anon_sym_delete] = ACTIONS(3613),
    [anon_sym_throw] = ACTIONS(3613),
    [anon_sym_namespace] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_static_assert] = ACTIONS(3613),
    [anon_sym_concept] = ACTIONS(3613),
    [anon_sym_co_return] = ACTIONS(3613),
    [anon_sym_co_yield] = ACTIONS(3613),
    [anon_sym_R_DQUOTE] = ACTIONS(3615),
    [anon_sym_LR_DQUOTE] = ACTIONS(3615),
    [anon_sym_uR_DQUOTE] = ACTIONS(3615),
    [anon_sym_UR_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3615),
    [anon_sym_co_await] = ACTIONS(3613),
    [anon_sym_new] = ACTIONS(3613),
    [anon_sym_requires] = ACTIONS(3613),
    [sym_this] = ACTIONS(3613),
    [anon_sym_discard] = ACTIONS(3613),
    [anon_sym_precise] = ACTIONS(3613),
    [anon_sym_shared] = ACTIONS(3613),
    [anon_sym_groupshared] = ACTIONS(3613),
    [anon_sym_uniform] = ACTIONS(3613),
    [anon_sym_row_major] = ACTIONS(3613),
    [anon_sym_column_major] = ACTIONS(3613),
    [anon_sym_globallycoherent] = ACTIONS(3613),
    [anon_sym_centroid] = ACTIONS(3613),
    [anon_sym_noperspective] = ACTIONS(3613),
    [anon_sym_nointerpolation] = ACTIONS(3613),
    [anon_sym_sample] = ACTIONS(3613),
    [anon_sym_linear] = ACTIONS(3613),
    [anon_sym_snorm] = ACTIONS(3613),
    [anon_sym_unorm] = ACTIONS(3613),
    [anon_sym_point] = ACTIONS(3613),
    [anon_sym_line] = ACTIONS(3613),
    [anon_sym_triangleadj] = ACTIONS(3613),
    [anon_sym_lineadj] = ACTIONS(3613),
    [anon_sym_triangle] = ACTIONS(3613),
    [anon_sym_cbuffer] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_extension] = ACTIONS(3613),
  },
  [926] = {
    [sym_identifier] = ACTIONS(3613),
    [aux_sym_preproc_include_token1] = ACTIONS(3613),
    [aux_sym_preproc_def_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token2] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3613),
    [sym_preproc_directive] = ACTIONS(3613),
    [anon_sym_LPAREN2] = ACTIONS(3615),
    [anon_sym_BANG] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3613),
    [anon_sym_PLUS] = ACTIONS(3613),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym_SEMI] = ACTIONS(3615),
    [anon_sym___extension__] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3613),
    [anon_sym_in] = ACTIONS(3613),
    [anon_sym_out] = ACTIONS(3613),
    [anon_sym_inout] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym___attribute__] = ACTIONS(3613),
    [anon_sym_COLON_COLON] = ACTIONS(3615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3615),
    [anon_sym___declspec] = ACTIONS(3613),
    [anon_sym___based] = ACTIONS(3613),
    [anon_sym___cdecl] = ACTIONS(3613),
    [anon_sym___clrcall] = ACTIONS(3613),
    [anon_sym___stdcall] = ACTIONS(3613),
    [anon_sym___fastcall] = ACTIONS(3613),
    [anon_sym___thiscall] = ACTIONS(3613),
    [anon_sym___vectorcall] = ACTIONS(3613),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_signed] = ACTIONS(3613),
    [anon_sym_unsigned] = ACTIONS(3613),
    [anon_sym_long] = ACTIONS(3613),
    [anon_sym_short] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_register] = ACTIONS(3613),
    [anon_sym_inline] = ACTIONS(3613),
    [anon_sym___inline] = ACTIONS(3613),
    [anon_sym___inline__] = ACTIONS(3613),
    [anon_sym___forceinline] = ACTIONS(3613),
    [anon_sym_thread_local] = ACTIONS(3613),
    [anon_sym___thread] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_constexpr] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_restrict] = ACTIONS(3613),
    [anon_sym___restrict__] = ACTIONS(3613),
    [anon_sym__Atomic] = ACTIONS(3613),
    [anon_sym__Noreturn] = ACTIONS(3613),
    [anon_sym_noreturn] = ACTIONS(3613),
    [anon_sym_mutable] = ACTIONS(3613),
    [anon_sym_constinit] = ACTIONS(3613),
    [anon_sym_consteval] = ACTIONS(3613),
    [anon_sym_alignas] = ACTIONS(3613),
    [anon_sym__Alignas] = ACTIONS(3613),
    [sym_primitive_type] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_union] = ACTIONS(3613),
    [anon_sym_if] = ACTIONS(3613),
    [anon_sym_switch] = ACTIONS(3613),
    [anon_sym_case] = ACTIONS(3613),
    [anon_sym_default] = ACTIONS(3613),
    [anon_sym_while] = ACTIONS(3613),
    [anon_sym_do] = ACTIONS(3613),
    [anon_sym_for] = ACTIONS(3613),
    [anon_sym_return] = ACTIONS(3613),
    [anon_sym_break] = ACTIONS(3613),
    [anon_sym_continue] = ACTIONS(3613),
    [anon_sym_goto] = ACTIONS(3613),
    [anon_sym___try] = ACTIONS(3613),
    [anon_sym___leave] = ACTIONS(3613),
    [anon_sym_not] = ACTIONS(3613),
    [anon_sym_compl] = ACTIONS(3613),
    [anon_sym_DASH_DASH] = ACTIONS(3615),
    [anon_sym_PLUS_PLUS] = ACTIONS(3615),
    [anon_sym_sizeof] = ACTIONS(3613),
    [anon_sym___alignof__] = ACTIONS(3613),
    [anon_sym___alignof] = ACTIONS(3613),
    [anon_sym__alignof] = ACTIONS(3613),
    [anon_sym_alignof] = ACTIONS(3613),
    [anon_sym__Alignof] = ACTIONS(3613),
    [anon_sym_offsetof] = ACTIONS(3613),
    [anon_sym__Generic] = ACTIONS(3613),
    [anon_sym_asm] = ACTIONS(3613),
    [anon_sym___asm__] = ACTIONS(3613),
    [sym_number_literal] = ACTIONS(3615),
    [anon_sym_L_SQUOTE] = ACTIONS(3615),
    [anon_sym_u_SQUOTE] = ACTIONS(3615),
    [anon_sym_U_SQUOTE] = ACTIONS(3615),
    [anon_sym_u8_SQUOTE] = ACTIONS(3615),
    [anon_sym_SQUOTE] = ACTIONS(3615),
    [anon_sym_L_DQUOTE] = ACTIONS(3615),
    [anon_sym_u_DQUOTE] = ACTIONS(3615),
    [anon_sym_U_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8_DQUOTE] = ACTIONS(3615),
    [anon_sym_DQUOTE] = ACTIONS(3615),
    [sym_true] = ACTIONS(3613),
    [sym_false] = ACTIONS(3613),
    [anon_sym_NULL] = ACTIONS(3613),
    [anon_sym_nullptr] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_This] = ACTIONS(3613),
    [anon_sym_decltype] = ACTIONS(3613),
    [sym_virtual] = ACTIONS(3613),
    [anon_sym_explicit] = ACTIONS(3613),
    [anon_sym_typename] = ACTIONS(3613),
    [anon_sym_template] = ACTIONS(3613),
    [anon_sym_operator] = ACTIONS(3613),
    [anon_sym_try] = ACTIONS(3613),
    [anon_sym_delete] = ACTIONS(3613),
    [anon_sym_throw] = ACTIONS(3613),
    [anon_sym_namespace] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_static_assert] = ACTIONS(3613),
    [anon_sym_concept] = ACTIONS(3613),
    [anon_sym_co_return] = ACTIONS(3613),
    [anon_sym_co_yield] = ACTIONS(3613),
    [anon_sym_R_DQUOTE] = ACTIONS(3615),
    [anon_sym_LR_DQUOTE] = ACTIONS(3615),
    [anon_sym_uR_DQUOTE] = ACTIONS(3615),
    [anon_sym_UR_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3615),
    [anon_sym_co_await] = ACTIONS(3613),
    [anon_sym_new] = ACTIONS(3613),
    [anon_sym_requires] = ACTIONS(3613),
    [sym_this] = ACTIONS(3613),
    [anon_sym_discard] = ACTIONS(3613),
    [anon_sym_precise] = ACTIONS(3613),
    [anon_sym_shared] = ACTIONS(3613),
    [anon_sym_groupshared] = ACTIONS(3613),
    [anon_sym_uniform] = ACTIONS(3613),
    [anon_sym_row_major] = ACTIONS(3613),
    [anon_sym_column_major] = ACTIONS(3613),
    [anon_sym_globallycoherent] = ACTIONS(3613),
    [anon_sym_centroid] = ACTIONS(3613),
    [anon_sym_noperspective] = ACTIONS(3613),
    [anon_sym_nointerpolation] = ACTIONS(3613),
    [anon_sym_sample] = ACTIONS(3613),
    [anon_sym_linear] = ACTIONS(3613),
    [anon_sym_snorm] = ACTIONS(3613),
    [anon_sym_unorm] = ACTIONS(3613),
    [anon_sym_point] = ACTIONS(3613),
    [anon_sym_line] = ACTIONS(3613),
    [anon_sym_triangleadj] = ACTIONS(3613),
    [anon_sym_lineadj] = ACTIONS(3613),
    [anon_sym_triangle] = ACTIONS(3613),
    [anon_sym_cbuffer] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_extension] = ACTIONS(3613),
  },
  [927] = {
    [sym_identifier] = ACTIONS(3601),
    [aux_sym_preproc_include_token1] = ACTIONS(3601),
    [aux_sym_preproc_def_token1] = ACTIONS(3601),
    [aux_sym_preproc_if_token1] = ACTIONS(3601),
    [aux_sym_preproc_if_token2] = ACTIONS(3601),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3601),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3601),
    [sym_preproc_directive] = ACTIONS(3601),
    [anon_sym_LPAREN2] = ACTIONS(3603),
    [anon_sym_BANG] = ACTIONS(3603),
    [anon_sym_TILDE] = ACTIONS(3603),
    [anon_sym_DASH] = ACTIONS(3601),
    [anon_sym_PLUS] = ACTIONS(3601),
    [anon_sym_STAR] = ACTIONS(3603),
    [anon_sym_AMP_AMP] = ACTIONS(3603),
    [anon_sym_AMP] = ACTIONS(3601),
    [anon_sym_SEMI] = ACTIONS(3603),
    [anon_sym___extension__] = ACTIONS(3601),
    [anon_sym_typedef] = ACTIONS(3601),
    [anon_sym_in] = ACTIONS(3601),
    [anon_sym_out] = ACTIONS(3601),
    [anon_sym_inout] = ACTIONS(3601),
    [anon_sym_extern] = ACTIONS(3601),
    [anon_sym___attribute__] = ACTIONS(3601),
    [anon_sym_COLON_COLON] = ACTIONS(3603),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3603),
    [anon_sym___declspec] = ACTIONS(3601),
    [anon_sym___based] = ACTIONS(3601),
    [anon_sym___cdecl] = ACTIONS(3601),
    [anon_sym___clrcall] = ACTIONS(3601),
    [anon_sym___stdcall] = ACTIONS(3601),
    [anon_sym___fastcall] = ACTIONS(3601),
    [anon_sym___thiscall] = ACTIONS(3601),
    [anon_sym___vectorcall] = ACTIONS(3601),
    [anon_sym_LBRACE] = ACTIONS(3603),
    [anon_sym_signed] = ACTIONS(3601),
    [anon_sym_unsigned] = ACTIONS(3601),
    [anon_sym_long] = ACTIONS(3601),
    [anon_sym_short] = ACTIONS(3601),
    [anon_sym_LBRACK] = ACTIONS(3601),
    [anon_sym_static] = ACTIONS(3601),
    [anon_sym_register] = ACTIONS(3601),
    [anon_sym_inline] = ACTIONS(3601),
    [anon_sym___inline] = ACTIONS(3601),
    [anon_sym___inline__] = ACTIONS(3601),
    [anon_sym___forceinline] = ACTIONS(3601),
    [anon_sym_thread_local] = ACTIONS(3601),
    [anon_sym___thread] = ACTIONS(3601),
    [anon_sym_const] = ACTIONS(3601),
    [anon_sym_constexpr] = ACTIONS(3601),
    [anon_sym_volatile] = ACTIONS(3601),
    [anon_sym_restrict] = ACTIONS(3601),
    [anon_sym___restrict__] = ACTIONS(3601),
    [anon_sym__Atomic] = ACTIONS(3601),
    [anon_sym__Noreturn] = ACTIONS(3601),
    [anon_sym_noreturn] = ACTIONS(3601),
    [anon_sym_mutable] = ACTIONS(3601),
    [anon_sym_constinit] = ACTIONS(3601),
    [anon_sym_consteval] = ACTIONS(3601),
    [anon_sym_alignas] = ACTIONS(3601),
    [anon_sym__Alignas] = ACTIONS(3601),
    [sym_primitive_type] = ACTIONS(3601),
    [anon_sym_enum] = ACTIONS(3601),
    [anon_sym_class] = ACTIONS(3601),
    [anon_sym_struct] = ACTIONS(3601),
    [anon_sym_union] = ACTIONS(3601),
    [anon_sym_if] = ACTIONS(3601),
    [anon_sym_switch] = ACTIONS(3601),
    [anon_sym_case] = ACTIONS(3601),
    [anon_sym_default] = ACTIONS(3601),
    [anon_sym_while] = ACTIONS(3601),
    [anon_sym_do] = ACTIONS(3601),
    [anon_sym_for] = ACTIONS(3601),
    [anon_sym_return] = ACTIONS(3601),
    [anon_sym_break] = ACTIONS(3601),
    [anon_sym_continue] = ACTIONS(3601),
    [anon_sym_goto] = ACTIONS(3601),
    [anon_sym___try] = ACTIONS(3601),
    [anon_sym___leave] = ACTIONS(3601),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_compl] = ACTIONS(3601),
    [anon_sym_DASH_DASH] = ACTIONS(3603),
    [anon_sym_PLUS_PLUS] = ACTIONS(3603),
    [anon_sym_sizeof] = ACTIONS(3601),
    [anon_sym___alignof__] = ACTIONS(3601),
    [anon_sym___alignof] = ACTIONS(3601),
    [anon_sym__alignof] = ACTIONS(3601),
    [anon_sym_alignof] = ACTIONS(3601),
    [anon_sym__Alignof] = ACTIONS(3601),
    [anon_sym_offsetof] = ACTIONS(3601),
    [anon_sym__Generic] = ACTIONS(3601),
    [anon_sym_asm] = ACTIONS(3601),
    [anon_sym___asm__] = ACTIONS(3601),
    [sym_number_literal] = ACTIONS(3603),
    [anon_sym_L_SQUOTE] = ACTIONS(3603),
    [anon_sym_u_SQUOTE] = ACTIONS(3603),
    [anon_sym_U_SQUOTE] = ACTIONS(3603),
    [anon_sym_u8_SQUOTE] = ACTIONS(3603),
    [anon_sym_SQUOTE] = ACTIONS(3603),
    [anon_sym_L_DQUOTE] = ACTIONS(3603),
    [anon_sym_u_DQUOTE] = ACTIONS(3603),
    [anon_sym_U_DQUOTE] = ACTIONS(3603),
    [anon_sym_u8_DQUOTE] = ACTIONS(3603),
    [anon_sym_DQUOTE] = ACTIONS(3603),
    [sym_true] = ACTIONS(3601),
    [sym_false] = ACTIONS(3601),
    [anon_sym_NULL] = ACTIONS(3601),
    [anon_sym_nullptr] = ACTIONS(3601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3601),
    [anon_sym_let] = ACTIONS(3601),
    [anon_sym_This] = ACTIONS(3601),
    [anon_sym_decltype] = ACTIONS(3601),
    [sym_virtual] = ACTIONS(3601),
    [anon_sym_explicit] = ACTIONS(3601),
    [anon_sym_typename] = ACTIONS(3601),
    [anon_sym_template] = ACTIONS(3601),
    [anon_sym_operator] = ACTIONS(3601),
    [anon_sym_try] = ACTIONS(3601),
    [anon_sym_delete] = ACTIONS(3601),
    [anon_sym_throw] = ACTIONS(3601),
    [anon_sym_namespace] = ACTIONS(3601),
    [anon_sym_using] = ACTIONS(3601),
    [anon_sym_static_assert] = ACTIONS(3601),
    [anon_sym_concept] = ACTIONS(3601),
    [anon_sym_co_return] = ACTIONS(3601),
    [anon_sym_co_yield] = ACTIONS(3601),
    [anon_sym_R_DQUOTE] = ACTIONS(3603),
    [anon_sym_LR_DQUOTE] = ACTIONS(3603),
    [anon_sym_uR_DQUOTE] = ACTIONS(3603),
    [anon_sym_UR_DQUOTE] = ACTIONS(3603),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3603),
    [anon_sym_co_await] = ACTIONS(3601),
    [anon_sym_new] = ACTIONS(3601),
    [anon_sym_requires] = ACTIONS(3601),
    [sym_this] = ACTIONS(3601),
    [anon_sym_discard] = ACTIONS(3601),
    [anon_sym_precise] = ACTIONS(3601),
    [anon_sym_shared] = ACTIONS(3601),
    [anon_sym_groupshared] = ACTIONS(3601),
    [anon_sym_uniform] = ACTIONS(3601),
    [anon_sym_row_major] = ACTIONS(3601),
    [anon_sym_column_major] = ACTIONS(3601),
    [anon_sym_globallycoherent] = ACTIONS(3601),
    [anon_sym_centroid] = ACTIONS(3601),
    [anon_sym_noperspective] = ACTIONS(3601),
    [anon_sym_nointerpolation] = ACTIONS(3601),
    [anon_sym_sample] = ACTIONS(3601),
    [anon_sym_linear] = ACTIONS(3601),
    [anon_sym_snorm] = ACTIONS(3601),
    [anon_sym_unorm] = ACTIONS(3601),
    [anon_sym_point] = ACTIONS(3601),
    [anon_sym_line] = ACTIONS(3601),
    [anon_sym_triangleadj] = ACTIONS(3601),
    [anon_sym_lineadj] = ACTIONS(3601),
    [anon_sym_triangle] = ACTIONS(3601),
    [anon_sym_cbuffer] = ACTIONS(3601),
    [anon_sym_interface] = ACTIONS(3601),
    [anon_sym_extension] = ACTIONS(3601),
  },
  [928] = {
    [sym_identifier] = ACTIONS(3583),
    [aux_sym_preproc_include_token1] = ACTIONS(3583),
    [aux_sym_preproc_def_token1] = ACTIONS(3583),
    [aux_sym_preproc_if_token1] = ACTIONS(3583),
    [aux_sym_preproc_if_token2] = ACTIONS(3583),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3583),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3583),
    [sym_preproc_directive] = ACTIONS(3583),
    [anon_sym_LPAREN2] = ACTIONS(3585),
    [anon_sym_BANG] = ACTIONS(3585),
    [anon_sym_TILDE] = ACTIONS(3585),
    [anon_sym_DASH] = ACTIONS(3583),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_STAR] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3583),
    [anon_sym_SEMI] = ACTIONS(3585),
    [anon_sym___extension__] = ACTIONS(3583),
    [anon_sym_typedef] = ACTIONS(3583),
    [anon_sym_in] = ACTIONS(3583),
    [anon_sym_out] = ACTIONS(3583),
    [anon_sym_inout] = ACTIONS(3583),
    [anon_sym_extern] = ACTIONS(3583),
    [anon_sym___attribute__] = ACTIONS(3583),
    [anon_sym_COLON_COLON] = ACTIONS(3585),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3585),
    [anon_sym___declspec] = ACTIONS(3583),
    [anon_sym___based] = ACTIONS(3583),
    [anon_sym___cdecl] = ACTIONS(3583),
    [anon_sym___clrcall] = ACTIONS(3583),
    [anon_sym___stdcall] = ACTIONS(3583),
    [anon_sym___fastcall] = ACTIONS(3583),
    [anon_sym___thiscall] = ACTIONS(3583),
    [anon_sym___vectorcall] = ACTIONS(3583),
    [anon_sym_LBRACE] = ACTIONS(3585),
    [anon_sym_signed] = ACTIONS(3583),
    [anon_sym_unsigned] = ACTIONS(3583),
    [anon_sym_long] = ACTIONS(3583),
    [anon_sym_short] = ACTIONS(3583),
    [anon_sym_LBRACK] = ACTIONS(3583),
    [anon_sym_static] = ACTIONS(3583),
    [anon_sym_register] = ACTIONS(3583),
    [anon_sym_inline] = ACTIONS(3583),
    [anon_sym___inline] = ACTIONS(3583),
    [anon_sym___inline__] = ACTIONS(3583),
    [anon_sym___forceinline] = ACTIONS(3583),
    [anon_sym_thread_local] = ACTIONS(3583),
    [anon_sym___thread] = ACTIONS(3583),
    [anon_sym_const] = ACTIONS(3583),
    [anon_sym_constexpr] = ACTIONS(3583),
    [anon_sym_volatile] = ACTIONS(3583),
    [anon_sym_restrict] = ACTIONS(3583),
    [anon_sym___restrict__] = ACTIONS(3583),
    [anon_sym__Atomic] = ACTIONS(3583),
    [anon_sym__Noreturn] = ACTIONS(3583),
    [anon_sym_noreturn] = ACTIONS(3583),
    [anon_sym_mutable] = ACTIONS(3583),
    [anon_sym_constinit] = ACTIONS(3583),
    [anon_sym_consteval] = ACTIONS(3583),
    [anon_sym_alignas] = ACTIONS(3583),
    [anon_sym__Alignas] = ACTIONS(3583),
    [sym_primitive_type] = ACTIONS(3583),
    [anon_sym_enum] = ACTIONS(3583),
    [anon_sym_class] = ACTIONS(3583),
    [anon_sym_struct] = ACTIONS(3583),
    [anon_sym_union] = ACTIONS(3583),
    [anon_sym_if] = ACTIONS(3583),
    [anon_sym_switch] = ACTIONS(3583),
    [anon_sym_case] = ACTIONS(3583),
    [anon_sym_default] = ACTIONS(3583),
    [anon_sym_while] = ACTIONS(3583),
    [anon_sym_do] = ACTIONS(3583),
    [anon_sym_for] = ACTIONS(3583),
    [anon_sym_return] = ACTIONS(3583),
    [anon_sym_break] = ACTIONS(3583),
    [anon_sym_continue] = ACTIONS(3583),
    [anon_sym_goto] = ACTIONS(3583),
    [anon_sym___try] = ACTIONS(3583),
    [anon_sym___leave] = ACTIONS(3583),
    [anon_sym_not] = ACTIONS(3583),
    [anon_sym_compl] = ACTIONS(3583),
    [anon_sym_DASH_DASH] = ACTIONS(3585),
    [anon_sym_PLUS_PLUS] = ACTIONS(3585),
    [anon_sym_sizeof] = ACTIONS(3583),
    [anon_sym___alignof__] = ACTIONS(3583),
    [anon_sym___alignof] = ACTIONS(3583),
    [anon_sym__alignof] = ACTIONS(3583),
    [anon_sym_alignof] = ACTIONS(3583),
    [anon_sym__Alignof] = ACTIONS(3583),
    [anon_sym_offsetof] = ACTIONS(3583),
    [anon_sym__Generic] = ACTIONS(3583),
    [anon_sym_asm] = ACTIONS(3583),
    [anon_sym___asm__] = ACTIONS(3583),
    [sym_number_literal] = ACTIONS(3585),
    [anon_sym_L_SQUOTE] = ACTIONS(3585),
    [anon_sym_u_SQUOTE] = ACTIONS(3585),
    [anon_sym_U_SQUOTE] = ACTIONS(3585),
    [anon_sym_u8_SQUOTE] = ACTIONS(3585),
    [anon_sym_SQUOTE] = ACTIONS(3585),
    [anon_sym_L_DQUOTE] = ACTIONS(3585),
    [anon_sym_u_DQUOTE] = ACTIONS(3585),
    [anon_sym_U_DQUOTE] = ACTIONS(3585),
    [anon_sym_u8_DQUOTE] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [sym_true] = ACTIONS(3583),
    [sym_false] = ACTIONS(3583),
    [anon_sym_NULL] = ACTIONS(3583),
    [anon_sym_nullptr] = ACTIONS(3583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3583),
    [anon_sym_let] = ACTIONS(3583),
    [anon_sym_This] = ACTIONS(3583),
    [anon_sym_decltype] = ACTIONS(3583),
    [sym_virtual] = ACTIONS(3583),
    [anon_sym_explicit] = ACTIONS(3583),
    [anon_sym_typename] = ACTIONS(3583),
    [anon_sym_template] = ACTIONS(3583),
    [anon_sym_operator] = ACTIONS(3583),
    [anon_sym_try] = ACTIONS(3583),
    [anon_sym_delete] = ACTIONS(3583),
    [anon_sym_throw] = ACTIONS(3583),
    [anon_sym_namespace] = ACTIONS(3583),
    [anon_sym_using] = ACTIONS(3583),
    [anon_sym_static_assert] = ACTIONS(3583),
    [anon_sym_concept] = ACTIONS(3583),
    [anon_sym_co_return] = ACTIONS(3583),
    [anon_sym_co_yield] = ACTIONS(3583),
    [anon_sym_R_DQUOTE] = ACTIONS(3585),
    [anon_sym_LR_DQUOTE] = ACTIONS(3585),
    [anon_sym_uR_DQUOTE] = ACTIONS(3585),
    [anon_sym_UR_DQUOTE] = ACTIONS(3585),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3585),
    [anon_sym_co_await] = ACTIONS(3583),
    [anon_sym_new] = ACTIONS(3583),
    [anon_sym_requires] = ACTIONS(3583),
    [sym_this] = ACTIONS(3583),
    [anon_sym_discard] = ACTIONS(3583),
    [anon_sym_precise] = ACTIONS(3583),
    [anon_sym_shared] = ACTIONS(3583),
    [anon_sym_groupshared] = ACTIONS(3583),
    [anon_sym_uniform] = ACTIONS(3583),
    [anon_sym_row_major] = ACTIONS(3583),
    [anon_sym_column_major] = ACTIONS(3583),
    [anon_sym_globallycoherent] = ACTIONS(3583),
    [anon_sym_centroid] = ACTIONS(3583),
    [anon_sym_noperspective] = ACTIONS(3583),
    [anon_sym_nointerpolation] = ACTIONS(3583),
    [anon_sym_sample] = ACTIONS(3583),
    [anon_sym_linear] = ACTIONS(3583),
    [anon_sym_snorm] = ACTIONS(3583),
    [anon_sym_unorm] = ACTIONS(3583),
    [anon_sym_point] = ACTIONS(3583),
    [anon_sym_line] = ACTIONS(3583),
    [anon_sym_triangleadj] = ACTIONS(3583),
    [anon_sym_lineadj] = ACTIONS(3583),
    [anon_sym_triangle] = ACTIONS(3583),
    [anon_sym_cbuffer] = ACTIONS(3583),
    [anon_sym_interface] = ACTIONS(3583),
    [anon_sym_extension] = ACTIONS(3583),
  },
  [929] = {
    [sym_identifier] = ACTIONS(3579),
    [aux_sym_preproc_include_token1] = ACTIONS(3579),
    [aux_sym_preproc_def_token1] = ACTIONS(3579),
    [aux_sym_preproc_if_token1] = ACTIONS(3579),
    [aux_sym_preproc_if_token2] = ACTIONS(3579),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3579),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3579),
    [sym_preproc_directive] = ACTIONS(3579),
    [anon_sym_LPAREN2] = ACTIONS(3581),
    [anon_sym_BANG] = ACTIONS(3581),
    [anon_sym_TILDE] = ACTIONS(3581),
    [anon_sym_DASH] = ACTIONS(3579),
    [anon_sym_PLUS] = ACTIONS(3579),
    [anon_sym_STAR] = ACTIONS(3581),
    [anon_sym_AMP_AMP] = ACTIONS(3581),
    [anon_sym_AMP] = ACTIONS(3579),
    [anon_sym_SEMI] = ACTIONS(3581),
    [anon_sym___extension__] = ACTIONS(3579),
    [anon_sym_typedef] = ACTIONS(3579),
    [anon_sym_in] = ACTIONS(3579),
    [anon_sym_out] = ACTIONS(3579),
    [anon_sym_inout] = ACTIONS(3579),
    [anon_sym_extern] = ACTIONS(3579),
    [anon_sym___attribute__] = ACTIONS(3579),
    [anon_sym_COLON_COLON] = ACTIONS(3581),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3581),
    [anon_sym___declspec] = ACTIONS(3579),
    [anon_sym___based] = ACTIONS(3579),
    [anon_sym___cdecl] = ACTIONS(3579),
    [anon_sym___clrcall] = ACTIONS(3579),
    [anon_sym___stdcall] = ACTIONS(3579),
    [anon_sym___fastcall] = ACTIONS(3579),
    [anon_sym___thiscall] = ACTIONS(3579),
    [anon_sym___vectorcall] = ACTIONS(3579),
    [anon_sym_LBRACE] = ACTIONS(3581),
    [anon_sym_signed] = ACTIONS(3579),
    [anon_sym_unsigned] = ACTIONS(3579),
    [anon_sym_long] = ACTIONS(3579),
    [anon_sym_short] = ACTIONS(3579),
    [anon_sym_LBRACK] = ACTIONS(3579),
    [anon_sym_static] = ACTIONS(3579),
    [anon_sym_register] = ACTIONS(3579),
    [anon_sym_inline] = ACTIONS(3579),
    [anon_sym___inline] = ACTIONS(3579),
    [anon_sym___inline__] = ACTIONS(3579),
    [anon_sym___forceinline] = ACTIONS(3579),
    [anon_sym_thread_local] = ACTIONS(3579),
    [anon_sym___thread] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3579),
    [anon_sym_constexpr] = ACTIONS(3579),
    [anon_sym_volatile] = ACTIONS(3579),
    [anon_sym_restrict] = ACTIONS(3579),
    [anon_sym___restrict__] = ACTIONS(3579),
    [anon_sym__Atomic] = ACTIONS(3579),
    [anon_sym__Noreturn] = ACTIONS(3579),
    [anon_sym_noreturn] = ACTIONS(3579),
    [anon_sym_mutable] = ACTIONS(3579),
    [anon_sym_constinit] = ACTIONS(3579),
    [anon_sym_consteval] = ACTIONS(3579),
    [anon_sym_alignas] = ACTIONS(3579),
    [anon_sym__Alignas] = ACTIONS(3579),
    [sym_primitive_type] = ACTIONS(3579),
    [anon_sym_enum] = ACTIONS(3579),
    [anon_sym_class] = ACTIONS(3579),
    [anon_sym_struct] = ACTIONS(3579),
    [anon_sym_union] = ACTIONS(3579),
    [anon_sym_if] = ACTIONS(3579),
    [anon_sym_switch] = ACTIONS(3579),
    [anon_sym_case] = ACTIONS(3579),
    [anon_sym_default] = ACTIONS(3579),
    [anon_sym_while] = ACTIONS(3579),
    [anon_sym_do] = ACTIONS(3579),
    [anon_sym_for] = ACTIONS(3579),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_break] = ACTIONS(3579),
    [anon_sym_continue] = ACTIONS(3579),
    [anon_sym_goto] = ACTIONS(3579),
    [anon_sym___try] = ACTIONS(3579),
    [anon_sym___leave] = ACTIONS(3579),
    [anon_sym_not] = ACTIONS(3579),
    [anon_sym_compl] = ACTIONS(3579),
    [anon_sym_DASH_DASH] = ACTIONS(3581),
    [anon_sym_PLUS_PLUS] = ACTIONS(3581),
    [anon_sym_sizeof] = ACTIONS(3579),
    [anon_sym___alignof__] = ACTIONS(3579),
    [anon_sym___alignof] = ACTIONS(3579),
    [anon_sym__alignof] = ACTIONS(3579),
    [anon_sym_alignof] = ACTIONS(3579),
    [anon_sym__Alignof] = ACTIONS(3579),
    [anon_sym_offsetof] = ACTIONS(3579),
    [anon_sym__Generic] = ACTIONS(3579),
    [anon_sym_asm] = ACTIONS(3579),
    [anon_sym___asm__] = ACTIONS(3579),
    [sym_number_literal] = ACTIONS(3581),
    [anon_sym_L_SQUOTE] = ACTIONS(3581),
    [anon_sym_u_SQUOTE] = ACTIONS(3581),
    [anon_sym_U_SQUOTE] = ACTIONS(3581),
    [anon_sym_u8_SQUOTE] = ACTIONS(3581),
    [anon_sym_SQUOTE] = ACTIONS(3581),
    [anon_sym_L_DQUOTE] = ACTIONS(3581),
    [anon_sym_u_DQUOTE] = ACTIONS(3581),
    [anon_sym_U_DQUOTE] = ACTIONS(3581),
    [anon_sym_u8_DQUOTE] = ACTIONS(3581),
    [anon_sym_DQUOTE] = ACTIONS(3581),
    [sym_true] = ACTIONS(3579),
    [sym_false] = ACTIONS(3579),
    [anon_sym_NULL] = ACTIONS(3579),
    [anon_sym_nullptr] = ACTIONS(3579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3579),
    [anon_sym_let] = ACTIONS(3579),
    [anon_sym_This] = ACTIONS(3579),
    [anon_sym_decltype] = ACTIONS(3579),
    [sym_virtual] = ACTIONS(3579),
    [anon_sym_explicit] = ACTIONS(3579),
    [anon_sym_typename] = ACTIONS(3579),
    [anon_sym_template] = ACTIONS(3579),
    [anon_sym_operator] = ACTIONS(3579),
    [anon_sym_try] = ACTIONS(3579),
    [anon_sym_delete] = ACTIONS(3579),
    [anon_sym_throw] = ACTIONS(3579),
    [anon_sym_namespace] = ACTIONS(3579),
    [anon_sym_using] = ACTIONS(3579),
    [anon_sym_static_assert] = ACTIONS(3579),
    [anon_sym_concept] = ACTIONS(3579),
    [anon_sym_co_return] = ACTIONS(3579),
    [anon_sym_co_yield] = ACTIONS(3579),
    [anon_sym_R_DQUOTE] = ACTIONS(3581),
    [anon_sym_LR_DQUOTE] = ACTIONS(3581),
    [anon_sym_uR_DQUOTE] = ACTIONS(3581),
    [anon_sym_UR_DQUOTE] = ACTIONS(3581),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3581),
    [anon_sym_co_await] = ACTIONS(3579),
    [anon_sym_new] = ACTIONS(3579),
    [anon_sym_requires] = ACTIONS(3579),
    [sym_this] = ACTIONS(3579),
    [anon_sym_discard] = ACTIONS(3579),
    [anon_sym_precise] = ACTIONS(3579),
    [anon_sym_shared] = ACTIONS(3579),
    [anon_sym_groupshared] = ACTIONS(3579),
    [anon_sym_uniform] = ACTIONS(3579),
    [anon_sym_row_major] = ACTIONS(3579),
    [anon_sym_column_major] = ACTIONS(3579),
    [anon_sym_globallycoherent] = ACTIONS(3579),
    [anon_sym_centroid] = ACTIONS(3579),
    [anon_sym_noperspective] = ACTIONS(3579),
    [anon_sym_nointerpolation] = ACTIONS(3579),
    [anon_sym_sample] = ACTIONS(3579),
    [anon_sym_linear] = ACTIONS(3579),
    [anon_sym_snorm] = ACTIONS(3579),
    [anon_sym_unorm] = ACTIONS(3579),
    [anon_sym_point] = ACTIONS(3579),
    [anon_sym_line] = ACTIONS(3579),
    [anon_sym_triangleadj] = ACTIONS(3579),
    [anon_sym_lineadj] = ACTIONS(3579),
    [anon_sym_triangle] = ACTIONS(3579),
    [anon_sym_cbuffer] = ACTIONS(3579),
    [anon_sym_interface] = ACTIONS(3579),
    [anon_sym_extension] = ACTIONS(3579),
  },
  [930] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(846),
    [ts_builtin_sym_end] = ACTIONS(2740),
    [sym_identifier] = ACTIONS(2742),
    [aux_sym_preproc_include_token1] = ACTIONS(2742),
    [aux_sym_preproc_def_token1] = ACTIONS(2742),
    [aux_sym_preproc_if_token1] = ACTIONS(2742),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2742),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2742),
    [sym_preproc_directive] = ACTIONS(2742),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_BANG] = ACTIONS(2740),
    [anon_sym_TILDE] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2742),
    [anon_sym_PLUS] = ACTIONS(2742),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym___extension__] = ACTIONS(2742),
    [anon_sym_typedef] = ACTIONS(2742),
    [anon_sym_in] = ACTIONS(2742),
    [anon_sym_out] = ACTIONS(2742),
    [anon_sym_inout] = ACTIONS(2742),
    [anon_sym_extern] = ACTIONS(2742),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym_COLON_COLON] = ACTIONS(2740),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2740),
    [anon_sym___declspec] = ACTIONS(2742),
    [anon_sym___based] = ACTIONS(2742),
    [anon_sym___cdecl] = ACTIONS(2742),
    [anon_sym___clrcall] = ACTIONS(2742),
    [anon_sym___stdcall] = ACTIONS(2742),
    [anon_sym___fastcall] = ACTIONS(2742),
    [anon_sym___thiscall] = ACTIONS(2742),
    [anon_sym___vectorcall] = ACTIONS(2742),
    [anon_sym_LBRACE] = ACTIONS(2740),
    [anon_sym_signed] = ACTIONS(3739),
    [anon_sym_unsigned] = ACTIONS(3739),
    [anon_sym_long] = ACTIONS(3739),
    [anon_sym_short] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2742),
    [anon_sym_register] = ACTIONS(2742),
    [anon_sym_inline] = ACTIONS(2742),
    [anon_sym___inline] = ACTIONS(2742),
    [anon_sym___inline__] = ACTIONS(2742),
    [anon_sym___forceinline] = ACTIONS(2742),
    [anon_sym_thread_local] = ACTIONS(2742),
    [anon_sym___thread] = ACTIONS(2742),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_constexpr] = ACTIONS(2742),
    [anon_sym_volatile] = ACTIONS(2742),
    [anon_sym_restrict] = ACTIONS(2742),
    [anon_sym___restrict__] = ACTIONS(2742),
    [anon_sym__Atomic] = ACTIONS(2742),
    [anon_sym__Noreturn] = ACTIONS(2742),
    [anon_sym_noreturn] = ACTIONS(2742),
    [anon_sym_mutable] = ACTIONS(2742),
    [anon_sym_constinit] = ACTIONS(2742),
    [anon_sym_consteval] = ACTIONS(2742),
    [anon_sym_alignas] = ACTIONS(2742),
    [anon_sym__Alignas] = ACTIONS(2742),
    [sym_primitive_type] = ACTIONS(2742),
    [anon_sym_enum] = ACTIONS(2742),
    [anon_sym_class] = ACTIONS(2742),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2742),
    [anon_sym_if] = ACTIONS(2742),
    [anon_sym_switch] = ACTIONS(2742),
    [anon_sym_case] = ACTIONS(2742),
    [anon_sym_default] = ACTIONS(2742),
    [anon_sym_while] = ACTIONS(2742),
    [anon_sym_do] = ACTIONS(2742),
    [anon_sym_for] = ACTIONS(2742),
    [anon_sym_return] = ACTIONS(2742),
    [anon_sym_break] = ACTIONS(2742),
    [anon_sym_continue] = ACTIONS(2742),
    [anon_sym_goto] = ACTIONS(2742),
    [anon_sym_not] = ACTIONS(2742),
    [anon_sym_compl] = ACTIONS(2742),
    [anon_sym_DASH_DASH] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2740),
    [anon_sym_sizeof] = ACTIONS(2742),
    [anon_sym___alignof__] = ACTIONS(2742),
    [anon_sym___alignof] = ACTIONS(2742),
    [anon_sym__alignof] = ACTIONS(2742),
    [anon_sym_alignof] = ACTIONS(2742),
    [anon_sym__Alignof] = ACTIONS(2742),
    [anon_sym_offsetof] = ACTIONS(2742),
    [anon_sym__Generic] = ACTIONS(2742),
    [anon_sym_asm] = ACTIONS(2742),
    [anon_sym___asm__] = ACTIONS(2742),
    [anon_sym_DOT] = ACTIONS(2742),
    [sym_number_literal] = ACTIONS(2740),
    [anon_sym_L_SQUOTE] = ACTIONS(2740),
    [anon_sym_u_SQUOTE] = ACTIONS(2740),
    [anon_sym_U_SQUOTE] = ACTIONS(2740),
    [anon_sym_u8_SQUOTE] = ACTIONS(2740),
    [anon_sym_SQUOTE] = ACTIONS(2740),
    [anon_sym_L_DQUOTE] = ACTIONS(2740),
    [anon_sym_u_DQUOTE] = ACTIONS(2740),
    [anon_sym_U_DQUOTE] = ACTIONS(2740),
    [anon_sym_u8_DQUOTE] = ACTIONS(2740),
    [anon_sym_DQUOTE] = ACTIONS(2740),
    [sym_true] = ACTIONS(2742),
    [sym_false] = ACTIONS(2742),
    [anon_sym_NULL] = ACTIONS(2742),
    [anon_sym_nullptr] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
    [anon_sym_decltype] = ACTIONS(2742),
    [sym_virtual] = ACTIONS(2742),
    [anon_sym_explicit] = ACTIONS(2742),
    [anon_sym_typename] = ACTIONS(2742),
    [anon_sym_template] = ACTIONS(2742),
    [anon_sym_operator] = ACTIONS(2742),
    [anon_sym_try] = ACTIONS(2742),
    [anon_sym_delete] = ACTIONS(2742),
    [anon_sym_throw] = ACTIONS(2742),
    [anon_sym_namespace] = ACTIONS(2742),
    [anon_sym_using] = ACTIONS(2742),
    [anon_sym_static_assert] = ACTIONS(2742),
    [anon_sym_concept] = ACTIONS(2742),
    [anon_sym_co_return] = ACTIONS(2742),
    [anon_sym_co_yield] = ACTIONS(2742),
    [anon_sym_R_DQUOTE] = ACTIONS(2740),
    [anon_sym_LR_DQUOTE] = ACTIONS(2740),
    [anon_sym_uR_DQUOTE] = ACTIONS(2740),
    [anon_sym_UR_DQUOTE] = ACTIONS(2740),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2740),
    [anon_sym_co_await] = ACTIONS(2742),
    [anon_sym_new] = ACTIONS(2742),
    [anon_sym_requires] = ACTIONS(2742),
    [sym_this] = ACTIONS(2742),
    [anon_sym_precise] = ACTIONS(2742),
    [anon_sym_shared] = ACTIONS(2742),
    [anon_sym_groupshared] = ACTIONS(2742),
    [anon_sym_uniform] = ACTIONS(2742),
    [anon_sym_row_major] = ACTIONS(2742),
    [anon_sym_column_major] = ACTIONS(2742),
    [anon_sym_globallycoherent] = ACTIONS(2742),
    [anon_sym_centroid] = ACTIONS(2742),
    [anon_sym_noperspective] = ACTIONS(2742),
    [anon_sym_nointerpolation] = ACTIONS(2742),
    [anon_sym_sample] = ACTIONS(2742),
    [anon_sym_linear] = ACTIONS(2742),
    [anon_sym_snorm] = ACTIONS(2742),
    [anon_sym_unorm] = ACTIONS(2742),
    [anon_sym_point] = ACTIONS(2742),
    [anon_sym_line] = ACTIONS(2742),
    [anon_sym_triangleadj] = ACTIONS(2742),
    [anon_sym_lineadj] = ACTIONS(2742),
    [anon_sym_triangle] = ACTIONS(2742),
    [anon_sym_interface] = ACTIONS(2742),
    [anon_sym_extension] = ACTIONS(2742),
    [anon_sym___exported] = ACTIONS(2742),
    [anon_sym_import] = ACTIONS(2742),
  },
  [931] = {
    [sym_attribute_specifier] = STATE(439),
    [ts_builtin_sym_end] = ACTIONS(3832),
    [sym_identifier] = ACTIONS(3830),
    [aux_sym_preproc_include_token1] = ACTIONS(3830),
    [aux_sym_preproc_def_token1] = ACTIONS(3830),
    [aux_sym_preproc_if_token1] = ACTIONS(3830),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3830),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3830),
    [sym_preproc_directive] = ACTIONS(3830),
    [anon_sym_LPAREN2] = ACTIONS(3832),
    [anon_sym_BANG] = ACTIONS(3832),
    [anon_sym_TILDE] = ACTIONS(3832),
    [anon_sym_DASH] = ACTIONS(3830),
    [anon_sym_PLUS] = ACTIONS(3830),
    [anon_sym_STAR] = ACTIONS(3832),
    [anon_sym_AMP_AMP] = ACTIONS(3832),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_SEMI] = ACTIONS(3832),
    [anon_sym___extension__] = ACTIONS(3830),
    [anon_sym_typedef] = ACTIONS(3830),
    [anon_sym_in] = ACTIONS(3830),
    [anon_sym_out] = ACTIONS(3830),
    [anon_sym_inout] = ACTIONS(3830),
    [anon_sym_extern] = ACTIONS(3830),
    [anon_sym___attribute__] = ACTIONS(2861),
    [anon_sym_COLON_COLON] = ACTIONS(3832),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3832),
    [anon_sym___declspec] = ACTIONS(3830),
    [anon_sym___based] = ACTIONS(3830),
    [anon_sym___cdecl] = ACTIONS(3830),
    [anon_sym___clrcall] = ACTIONS(3830),
    [anon_sym___stdcall] = ACTIONS(3830),
    [anon_sym___fastcall] = ACTIONS(3830),
    [anon_sym___thiscall] = ACTIONS(3830),
    [anon_sym___vectorcall] = ACTIONS(3830),
    [anon_sym_LBRACE] = ACTIONS(3832),
    [anon_sym_signed] = ACTIONS(3830),
    [anon_sym_unsigned] = ACTIONS(3830),
    [anon_sym_long] = ACTIONS(3830),
    [anon_sym_short] = ACTIONS(3830),
    [anon_sym_LBRACK] = ACTIONS(3830),
    [anon_sym_static] = ACTIONS(3830),
    [anon_sym_register] = ACTIONS(3830),
    [anon_sym_inline] = ACTIONS(3830),
    [anon_sym___inline] = ACTIONS(3830),
    [anon_sym___inline__] = ACTIONS(3830),
    [anon_sym___forceinline] = ACTIONS(3830),
    [anon_sym_thread_local] = ACTIONS(3830),
    [anon_sym___thread] = ACTIONS(3830),
    [anon_sym_const] = ACTIONS(3830),
    [anon_sym_constexpr] = ACTIONS(3830),
    [anon_sym_volatile] = ACTIONS(3830),
    [anon_sym_restrict] = ACTIONS(3830),
    [anon_sym___restrict__] = ACTIONS(3830),
    [anon_sym__Atomic] = ACTIONS(3830),
    [anon_sym__Noreturn] = ACTIONS(3830),
    [anon_sym_noreturn] = ACTIONS(3830),
    [anon_sym_mutable] = ACTIONS(3830),
    [anon_sym_constinit] = ACTIONS(3830),
    [anon_sym_consteval] = ACTIONS(3830),
    [anon_sym_alignas] = ACTIONS(3830),
    [anon_sym__Alignas] = ACTIONS(3830),
    [sym_primitive_type] = ACTIONS(3830),
    [anon_sym_enum] = ACTIONS(3830),
    [anon_sym_class] = ACTIONS(3830),
    [anon_sym_struct] = ACTIONS(3830),
    [anon_sym_union] = ACTIONS(3830),
    [anon_sym_if] = ACTIONS(3830),
    [anon_sym_switch] = ACTIONS(3830),
    [anon_sym_case] = ACTIONS(3830),
    [anon_sym_default] = ACTIONS(3830),
    [anon_sym_while] = ACTIONS(3830),
    [anon_sym_do] = ACTIONS(3830),
    [anon_sym_for] = ACTIONS(3830),
    [anon_sym_return] = ACTIONS(3830),
    [anon_sym_break] = ACTIONS(3830),
    [anon_sym_continue] = ACTIONS(3830),
    [anon_sym_goto] = ACTIONS(3830),
    [anon_sym_not] = ACTIONS(3830),
    [anon_sym_compl] = ACTIONS(3830),
    [anon_sym_DASH_DASH] = ACTIONS(3832),
    [anon_sym_PLUS_PLUS] = ACTIONS(3832),
    [anon_sym_sizeof] = ACTIONS(3830),
    [anon_sym___alignof__] = ACTIONS(3830),
    [anon_sym___alignof] = ACTIONS(3830),
    [anon_sym__alignof] = ACTIONS(3830),
    [anon_sym_alignof] = ACTIONS(3830),
    [anon_sym__Alignof] = ACTIONS(3830),
    [anon_sym_offsetof] = ACTIONS(3830),
    [anon_sym__Generic] = ACTIONS(3830),
    [anon_sym_asm] = ACTIONS(3830),
    [anon_sym___asm__] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3830),
    [sym_number_literal] = ACTIONS(3832),
    [anon_sym_L_SQUOTE] = ACTIONS(3832),
    [anon_sym_u_SQUOTE] = ACTIONS(3832),
    [anon_sym_U_SQUOTE] = ACTIONS(3832),
    [anon_sym_u8_SQUOTE] = ACTIONS(3832),
    [anon_sym_SQUOTE] = ACTIONS(3832),
    [anon_sym_L_DQUOTE] = ACTIONS(3832),
    [anon_sym_u_DQUOTE] = ACTIONS(3832),
    [anon_sym_U_DQUOTE] = ACTIONS(3832),
    [anon_sym_u8_DQUOTE] = ACTIONS(3832),
    [anon_sym_DQUOTE] = ACTIONS(3832),
    [sym_true] = ACTIONS(3830),
    [sym_false] = ACTIONS(3830),
    [anon_sym_NULL] = ACTIONS(3830),
    [anon_sym_nullptr] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3830),
    [anon_sym_let] = ACTIONS(3830),
    [anon_sym_This] = ACTIONS(3830),
    [anon_sym_decltype] = ACTIONS(3830),
    [sym_virtual] = ACTIONS(3830),
    [anon_sym_explicit] = ACTIONS(3830),
    [anon_sym_typename] = ACTIONS(3830),
    [anon_sym_template] = ACTIONS(3830),
    [anon_sym_operator] = ACTIONS(3830),
    [anon_sym_try] = ACTIONS(3830),
    [anon_sym_delete] = ACTIONS(3830),
    [anon_sym_throw] = ACTIONS(3830),
    [anon_sym_namespace] = ACTIONS(3830),
    [anon_sym_using] = ACTIONS(3830),
    [anon_sym_static_assert] = ACTIONS(3830),
    [anon_sym_concept] = ACTIONS(3830),
    [anon_sym_co_return] = ACTIONS(3830),
    [anon_sym_co_yield] = ACTIONS(3830),
    [anon_sym_R_DQUOTE] = ACTIONS(3832),
    [anon_sym_LR_DQUOTE] = ACTIONS(3832),
    [anon_sym_uR_DQUOTE] = ACTIONS(3832),
    [anon_sym_UR_DQUOTE] = ACTIONS(3832),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3832),
    [anon_sym_co_await] = ACTIONS(3830),
    [anon_sym_new] = ACTIONS(3830),
    [anon_sym_requires] = ACTIONS(3830),
    [sym_this] = ACTIONS(3830),
    [anon_sym_precise] = ACTIONS(3830),
    [anon_sym_shared] = ACTIONS(3830),
    [anon_sym_groupshared] = ACTIONS(3830),
    [anon_sym_uniform] = ACTIONS(3830),
    [anon_sym_row_major] = ACTIONS(3830),
    [anon_sym_column_major] = ACTIONS(3830),
    [anon_sym_globallycoherent] = ACTIONS(3830),
    [anon_sym_centroid] = ACTIONS(3830),
    [anon_sym_noperspective] = ACTIONS(3830),
    [anon_sym_nointerpolation] = ACTIONS(3830),
    [anon_sym_sample] = ACTIONS(3830),
    [anon_sym_linear] = ACTIONS(3830),
    [anon_sym_snorm] = ACTIONS(3830),
    [anon_sym_unorm] = ACTIONS(3830),
    [anon_sym_point] = ACTIONS(3830),
    [anon_sym_line] = ACTIONS(3830),
    [anon_sym_triangleadj] = ACTIONS(3830),
    [anon_sym_lineadj] = ACTIONS(3830),
    [anon_sym_triangle] = ACTIONS(3830),
    [anon_sym_interface] = ACTIONS(3830),
    [anon_sym_extension] = ACTIONS(3830),
    [anon_sym___exported] = ACTIONS(3830),
    [anon_sym_import] = ACTIONS(3830),
  },
  [932] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(827),
    [ts_builtin_sym_end] = ACTIONS(3766),
    [sym_identifier] = ACTIONS(3764),
    [aux_sym_preproc_include_token1] = ACTIONS(3764),
    [aux_sym_preproc_def_token1] = ACTIONS(3764),
    [aux_sym_preproc_if_token1] = ACTIONS(3764),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3764),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3764),
    [sym_preproc_directive] = ACTIONS(3764),
    [anon_sym_LPAREN2] = ACTIONS(3766),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [anon_sym_DASH] = ACTIONS(3764),
    [anon_sym_PLUS] = ACTIONS(3764),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_AMP_AMP] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3764),
    [anon_sym_SEMI] = ACTIONS(3766),
    [anon_sym___extension__] = ACTIONS(3764),
    [anon_sym_typedef] = ACTIONS(3764),
    [anon_sym_in] = ACTIONS(3764),
    [anon_sym_out] = ACTIONS(3764),
    [anon_sym_inout] = ACTIONS(3764),
    [anon_sym_extern] = ACTIONS(3764),
    [anon_sym___attribute__] = ACTIONS(3764),
    [anon_sym_COLON_COLON] = ACTIONS(3766),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3766),
    [anon_sym___declspec] = ACTIONS(3764),
    [anon_sym___based] = ACTIONS(3764),
    [anon_sym___cdecl] = ACTIONS(3764),
    [anon_sym___clrcall] = ACTIONS(3764),
    [anon_sym___stdcall] = ACTIONS(3764),
    [anon_sym___fastcall] = ACTIONS(3764),
    [anon_sym___thiscall] = ACTIONS(3764),
    [anon_sym___vectorcall] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3766),
    [anon_sym_signed] = ACTIONS(3935),
    [anon_sym_unsigned] = ACTIONS(3935),
    [anon_sym_long] = ACTIONS(3935),
    [anon_sym_short] = ACTIONS(3935),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_static] = ACTIONS(3764),
    [anon_sym_register] = ACTIONS(3764),
    [anon_sym_inline] = ACTIONS(3764),
    [anon_sym___inline] = ACTIONS(3764),
    [anon_sym___inline__] = ACTIONS(3764),
    [anon_sym___forceinline] = ACTIONS(3764),
    [anon_sym_thread_local] = ACTIONS(3764),
    [anon_sym___thread] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(3764),
    [anon_sym_constexpr] = ACTIONS(3764),
    [anon_sym_volatile] = ACTIONS(3764),
    [anon_sym_restrict] = ACTIONS(3764),
    [anon_sym___restrict__] = ACTIONS(3764),
    [anon_sym__Atomic] = ACTIONS(3764),
    [anon_sym__Noreturn] = ACTIONS(3764),
    [anon_sym_noreturn] = ACTIONS(3764),
    [anon_sym_mutable] = ACTIONS(3764),
    [anon_sym_constinit] = ACTIONS(3764),
    [anon_sym_consteval] = ACTIONS(3764),
    [anon_sym_alignas] = ACTIONS(3764),
    [anon_sym__Alignas] = ACTIONS(3764),
    [sym_primitive_type] = ACTIONS(3764),
    [anon_sym_enum] = ACTIONS(3764),
    [anon_sym_class] = ACTIONS(3764),
    [anon_sym_struct] = ACTIONS(3764),
    [anon_sym_union] = ACTIONS(3764),
    [anon_sym_if] = ACTIONS(3764),
    [anon_sym_switch] = ACTIONS(3764),
    [anon_sym_case] = ACTIONS(3764),
    [anon_sym_default] = ACTIONS(3764),
    [anon_sym_while] = ACTIONS(3764),
    [anon_sym_do] = ACTIONS(3764),
    [anon_sym_for] = ACTIONS(3764),
    [anon_sym_return] = ACTIONS(3764),
    [anon_sym_break] = ACTIONS(3764),
    [anon_sym_continue] = ACTIONS(3764),
    [anon_sym_goto] = ACTIONS(3764),
    [anon_sym_not] = ACTIONS(3764),
    [anon_sym_compl] = ACTIONS(3764),
    [anon_sym_DASH_DASH] = ACTIONS(3766),
    [anon_sym_PLUS_PLUS] = ACTIONS(3766),
    [anon_sym_sizeof] = ACTIONS(3764),
    [anon_sym___alignof__] = ACTIONS(3764),
    [anon_sym___alignof] = ACTIONS(3764),
    [anon_sym__alignof] = ACTIONS(3764),
    [anon_sym_alignof] = ACTIONS(3764),
    [anon_sym__Alignof] = ACTIONS(3764),
    [anon_sym_offsetof] = ACTIONS(3764),
    [anon_sym__Generic] = ACTIONS(3764),
    [anon_sym_asm] = ACTIONS(3764),
    [anon_sym___asm__] = ACTIONS(3764),
    [anon_sym_DOT] = ACTIONS(3764),
    [sym_number_literal] = ACTIONS(3766),
    [anon_sym_L_SQUOTE] = ACTIONS(3766),
    [anon_sym_u_SQUOTE] = ACTIONS(3766),
    [anon_sym_U_SQUOTE] = ACTIONS(3766),
    [anon_sym_u8_SQUOTE] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3766),
    [anon_sym_L_DQUOTE] = ACTIONS(3766),
    [anon_sym_u_DQUOTE] = ACTIONS(3766),
    [anon_sym_U_DQUOTE] = ACTIONS(3766),
    [anon_sym_u8_DQUOTE] = ACTIONS(3766),
    [anon_sym_DQUOTE] = ACTIONS(3766),
    [sym_true] = ACTIONS(3764),
    [sym_false] = ACTIONS(3764),
    [anon_sym_NULL] = ACTIONS(3764),
    [anon_sym_nullptr] = ACTIONS(3764),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3764),
    [anon_sym_let] = ACTIONS(3764),
    [anon_sym_This] = ACTIONS(3764),
    [anon_sym_decltype] = ACTIONS(3764),
    [sym_virtual] = ACTIONS(3764),
    [anon_sym_explicit] = ACTIONS(3764),
    [anon_sym_typename] = ACTIONS(3764),
    [anon_sym_template] = ACTIONS(3764),
    [anon_sym_operator] = ACTIONS(3764),
    [anon_sym_try] = ACTIONS(3764),
    [anon_sym_delete] = ACTIONS(3764),
    [anon_sym_throw] = ACTIONS(3764),
    [anon_sym_namespace] = ACTIONS(3764),
    [anon_sym_using] = ACTIONS(3764),
    [anon_sym_static_assert] = ACTIONS(3764),
    [anon_sym_concept] = ACTIONS(3764),
    [anon_sym_co_return] = ACTIONS(3764),
    [anon_sym_co_yield] = ACTIONS(3764),
    [anon_sym_R_DQUOTE] = ACTIONS(3766),
    [anon_sym_LR_DQUOTE] = ACTIONS(3766),
    [anon_sym_uR_DQUOTE] = ACTIONS(3766),
    [anon_sym_UR_DQUOTE] = ACTIONS(3766),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3766),
    [anon_sym_co_await] = ACTIONS(3764),
    [anon_sym_new] = ACTIONS(3764),
    [anon_sym_requires] = ACTIONS(3764),
    [sym_this] = ACTIONS(3764),
    [anon_sym_precise] = ACTIONS(3764),
    [anon_sym_shared] = ACTIONS(3764),
    [anon_sym_groupshared] = ACTIONS(3764),
    [anon_sym_uniform] = ACTIONS(3764),
    [anon_sym_row_major] = ACTIONS(3764),
    [anon_sym_column_major] = ACTIONS(3764),
    [anon_sym_globallycoherent] = ACTIONS(3764),
    [anon_sym_centroid] = ACTIONS(3764),
    [anon_sym_noperspective] = ACTIONS(3764),
    [anon_sym_nointerpolation] = ACTIONS(3764),
    [anon_sym_sample] = ACTIONS(3764),
    [anon_sym_linear] = ACTIONS(3764),
    [anon_sym_snorm] = ACTIONS(3764),
    [anon_sym_unorm] = ACTIONS(3764),
    [anon_sym_point] = ACTIONS(3764),
    [anon_sym_line] = ACTIONS(3764),
    [anon_sym_triangleadj] = ACTIONS(3764),
    [anon_sym_lineadj] = ACTIONS(3764),
    [anon_sym_triangle] = ACTIONS(3764),
    [anon_sym_interface] = ACTIONS(3764),
    [anon_sym_extension] = ACTIONS(3764),
    [anon_sym___exported] = ACTIONS(3764),
    [anon_sym_import] = ACTIONS(3764),
  },
  [933] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(828),
    [ts_builtin_sym_end] = ACTIONS(3773),
    [sym_identifier] = ACTIONS(3771),
    [aux_sym_preproc_include_token1] = ACTIONS(3771),
    [aux_sym_preproc_def_token1] = ACTIONS(3771),
    [aux_sym_preproc_if_token1] = ACTIONS(3771),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3771),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3771),
    [sym_preproc_directive] = ACTIONS(3771),
    [anon_sym_LPAREN2] = ACTIONS(3773),
    [anon_sym_BANG] = ACTIONS(3773),
    [anon_sym_TILDE] = ACTIONS(3773),
    [anon_sym_DASH] = ACTIONS(3771),
    [anon_sym_PLUS] = ACTIONS(3771),
    [anon_sym_STAR] = ACTIONS(3773),
    [anon_sym_AMP_AMP] = ACTIONS(3773),
    [anon_sym_AMP] = ACTIONS(3771),
    [anon_sym_SEMI] = ACTIONS(3773),
    [anon_sym___extension__] = ACTIONS(3771),
    [anon_sym_typedef] = ACTIONS(3771),
    [anon_sym_in] = ACTIONS(3771),
    [anon_sym_out] = ACTIONS(3771),
    [anon_sym_inout] = ACTIONS(3771),
    [anon_sym_extern] = ACTIONS(3771),
    [anon_sym___attribute__] = ACTIONS(3771),
    [anon_sym_COLON_COLON] = ACTIONS(3773),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3773),
    [anon_sym___declspec] = ACTIONS(3771),
    [anon_sym___based] = ACTIONS(3771),
    [anon_sym___cdecl] = ACTIONS(3771),
    [anon_sym___clrcall] = ACTIONS(3771),
    [anon_sym___stdcall] = ACTIONS(3771),
    [anon_sym___fastcall] = ACTIONS(3771),
    [anon_sym___thiscall] = ACTIONS(3771),
    [anon_sym___vectorcall] = ACTIONS(3771),
    [anon_sym_LBRACE] = ACTIONS(3773),
    [anon_sym_signed] = ACTIONS(3938),
    [anon_sym_unsigned] = ACTIONS(3938),
    [anon_sym_long] = ACTIONS(3938),
    [anon_sym_short] = ACTIONS(3938),
    [anon_sym_LBRACK] = ACTIONS(3771),
    [anon_sym_static] = ACTIONS(3771),
    [anon_sym_register] = ACTIONS(3771),
    [anon_sym_inline] = ACTIONS(3771),
    [anon_sym___inline] = ACTIONS(3771),
    [anon_sym___inline__] = ACTIONS(3771),
    [anon_sym___forceinline] = ACTIONS(3771),
    [anon_sym_thread_local] = ACTIONS(3771),
    [anon_sym___thread] = ACTIONS(3771),
    [anon_sym_const] = ACTIONS(3771),
    [anon_sym_constexpr] = ACTIONS(3771),
    [anon_sym_volatile] = ACTIONS(3771),
    [anon_sym_restrict] = ACTIONS(3771),
    [anon_sym___restrict__] = ACTIONS(3771),
    [anon_sym__Atomic] = ACTIONS(3771),
    [anon_sym__Noreturn] = ACTIONS(3771),
    [anon_sym_noreturn] = ACTIONS(3771),
    [anon_sym_mutable] = ACTIONS(3771),
    [anon_sym_constinit] = ACTIONS(3771),
    [anon_sym_consteval] = ACTIONS(3771),
    [anon_sym_alignas] = ACTIONS(3771),
    [anon_sym__Alignas] = ACTIONS(3771),
    [sym_primitive_type] = ACTIONS(3771),
    [anon_sym_enum] = ACTIONS(3771),
    [anon_sym_class] = ACTIONS(3771),
    [anon_sym_struct] = ACTIONS(3771),
    [anon_sym_union] = ACTIONS(3771),
    [anon_sym_if] = ACTIONS(3771),
    [anon_sym_switch] = ACTIONS(3771),
    [anon_sym_case] = ACTIONS(3771),
    [anon_sym_default] = ACTIONS(3771),
    [anon_sym_while] = ACTIONS(3771),
    [anon_sym_do] = ACTIONS(3771),
    [anon_sym_for] = ACTIONS(3771),
    [anon_sym_return] = ACTIONS(3771),
    [anon_sym_break] = ACTIONS(3771),
    [anon_sym_continue] = ACTIONS(3771),
    [anon_sym_goto] = ACTIONS(3771),
    [anon_sym_not] = ACTIONS(3771),
    [anon_sym_compl] = ACTIONS(3771),
    [anon_sym_DASH_DASH] = ACTIONS(3773),
    [anon_sym_PLUS_PLUS] = ACTIONS(3773),
    [anon_sym_sizeof] = ACTIONS(3771),
    [anon_sym___alignof__] = ACTIONS(3771),
    [anon_sym___alignof] = ACTIONS(3771),
    [anon_sym__alignof] = ACTIONS(3771),
    [anon_sym_alignof] = ACTIONS(3771),
    [anon_sym__Alignof] = ACTIONS(3771),
    [anon_sym_offsetof] = ACTIONS(3771),
    [anon_sym__Generic] = ACTIONS(3771),
    [anon_sym_asm] = ACTIONS(3771),
    [anon_sym___asm__] = ACTIONS(3771),
    [anon_sym_DOT] = ACTIONS(3771),
    [sym_number_literal] = ACTIONS(3773),
    [anon_sym_L_SQUOTE] = ACTIONS(3773),
    [anon_sym_u_SQUOTE] = ACTIONS(3773),
    [anon_sym_U_SQUOTE] = ACTIONS(3773),
    [anon_sym_u8_SQUOTE] = ACTIONS(3773),
    [anon_sym_SQUOTE] = ACTIONS(3773),
    [anon_sym_L_DQUOTE] = ACTIONS(3773),
    [anon_sym_u_DQUOTE] = ACTIONS(3773),
    [anon_sym_U_DQUOTE] = ACTIONS(3773),
    [anon_sym_u8_DQUOTE] = ACTIONS(3773),
    [anon_sym_DQUOTE] = ACTIONS(3773),
    [sym_true] = ACTIONS(3771),
    [sym_false] = ACTIONS(3771),
    [anon_sym_NULL] = ACTIONS(3771),
    [anon_sym_nullptr] = ACTIONS(3771),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3771),
    [anon_sym_let] = ACTIONS(3771),
    [anon_sym_This] = ACTIONS(3771),
    [anon_sym_decltype] = ACTIONS(3771),
    [sym_virtual] = ACTIONS(3771),
    [anon_sym_explicit] = ACTIONS(3771),
    [anon_sym_typename] = ACTIONS(3771),
    [anon_sym_template] = ACTIONS(3771),
    [anon_sym_operator] = ACTIONS(3771),
    [anon_sym_try] = ACTIONS(3771),
    [anon_sym_delete] = ACTIONS(3771),
    [anon_sym_throw] = ACTIONS(3771),
    [anon_sym_namespace] = ACTIONS(3771),
    [anon_sym_using] = ACTIONS(3771),
    [anon_sym_static_assert] = ACTIONS(3771),
    [anon_sym_concept] = ACTIONS(3771),
    [anon_sym_co_return] = ACTIONS(3771),
    [anon_sym_co_yield] = ACTIONS(3771),
    [anon_sym_R_DQUOTE] = ACTIONS(3773),
    [anon_sym_LR_DQUOTE] = ACTIONS(3773),
    [anon_sym_uR_DQUOTE] = ACTIONS(3773),
    [anon_sym_UR_DQUOTE] = ACTIONS(3773),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3773),
    [anon_sym_co_await] = ACTIONS(3771),
    [anon_sym_new] = ACTIONS(3771),
    [anon_sym_requires] = ACTIONS(3771),
    [sym_this] = ACTIONS(3771),
    [anon_sym_precise] = ACTIONS(3771),
    [anon_sym_shared] = ACTIONS(3771),
    [anon_sym_groupshared] = ACTIONS(3771),
    [anon_sym_uniform] = ACTIONS(3771),
    [anon_sym_row_major] = ACTIONS(3771),
    [anon_sym_column_major] = ACTIONS(3771),
    [anon_sym_globallycoherent] = ACTIONS(3771),
    [anon_sym_centroid] = ACTIONS(3771),
    [anon_sym_noperspective] = ACTIONS(3771),
    [anon_sym_nointerpolation] = ACTIONS(3771),
    [anon_sym_sample] = ACTIONS(3771),
    [anon_sym_linear] = ACTIONS(3771),
    [anon_sym_snorm] = ACTIONS(3771),
    [anon_sym_unorm] = ACTIONS(3771),
    [anon_sym_point] = ACTIONS(3771),
    [anon_sym_line] = ACTIONS(3771),
    [anon_sym_triangleadj] = ACTIONS(3771),
    [anon_sym_lineadj] = ACTIONS(3771),
    [anon_sym_triangle] = ACTIONS(3771),
    [anon_sym_interface] = ACTIONS(3771),
    [anon_sym_extension] = ACTIONS(3771),
    [anon_sym___exported] = ACTIONS(3771),
    [anon_sym_import] = ACTIONS(3771),
  },
  [934] = {
    [sym_identifier] = ACTIONS(3543),
    [aux_sym_preproc_include_token1] = ACTIONS(3543),
    [aux_sym_preproc_def_token1] = ACTIONS(3543),
    [aux_sym_preproc_if_token1] = ACTIONS(3543),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3543),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3543),
    [sym_preproc_directive] = ACTIONS(3543),
    [anon_sym_LPAREN2] = ACTIONS(3545),
    [anon_sym_BANG] = ACTIONS(3545),
    [anon_sym_TILDE] = ACTIONS(3545),
    [anon_sym_DASH] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(3543),
    [anon_sym_STAR] = ACTIONS(3545),
    [anon_sym_AMP_AMP] = ACTIONS(3545),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_SEMI] = ACTIONS(3545),
    [anon_sym___extension__] = ACTIONS(3543),
    [anon_sym_typedef] = ACTIONS(3543),
    [anon_sym_in] = ACTIONS(3543),
    [anon_sym_out] = ACTIONS(3543),
    [anon_sym_inout] = ACTIONS(3543),
    [anon_sym_extern] = ACTIONS(3543),
    [anon_sym___attribute__] = ACTIONS(3543),
    [anon_sym_COLON_COLON] = ACTIONS(3545),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3545),
    [anon_sym___declspec] = ACTIONS(3543),
    [anon_sym___based] = ACTIONS(3543),
    [anon_sym___cdecl] = ACTIONS(3543),
    [anon_sym___clrcall] = ACTIONS(3543),
    [anon_sym___stdcall] = ACTIONS(3543),
    [anon_sym___fastcall] = ACTIONS(3543),
    [anon_sym___thiscall] = ACTIONS(3543),
    [anon_sym___vectorcall] = ACTIONS(3543),
    [anon_sym_LBRACE] = ACTIONS(3545),
    [anon_sym_RBRACE] = ACTIONS(3545),
    [anon_sym_signed] = ACTIONS(3543),
    [anon_sym_unsigned] = ACTIONS(3543),
    [anon_sym_long] = ACTIONS(3543),
    [anon_sym_short] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3543),
    [anon_sym_static] = ACTIONS(3543),
    [anon_sym_register] = ACTIONS(3543),
    [anon_sym_inline] = ACTIONS(3543),
    [anon_sym___inline] = ACTIONS(3543),
    [anon_sym___inline__] = ACTIONS(3543),
    [anon_sym___forceinline] = ACTIONS(3543),
    [anon_sym_thread_local] = ACTIONS(3543),
    [anon_sym___thread] = ACTIONS(3543),
    [anon_sym_const] = ACTIONS(3543),
    [anon_sym_constexpr] = ACTIONS(3543),
    [anon_sym_volatile] = ACTIONS(3543),
    [anon_sym_restrict] = ACTIONS(3543),
    [anon_sym___restrict__] = ACTIONS(3543),
    [anon_sym__Atomic] = ACTIONS(3543),
    [anon_sym__Noreturn] = ACTIONS(3543),
    [anon_sym_noreturn] = ACTIONS(3543),
    [anon_sym_mutable] = ACTIONS(3543),
    [anon_sym_constinit] = ACTIONS(3543),
    [anon_sym_consteval] = ACTIONS(3543),
    [anon_sym_alignas] = ACTIONS(3543),
    [anon_sym__Alignas] = ACTIONS(3543),
    [sym_primitive_type] = ACTIONS(3543),
    [anon_sym_enum] = ACTIONS(3543),
    [anon_sym_class] = ACTIONS(3543),
    [anon_sym_struct] = ACTIONS(3543),
    [anon_sym_union] = ACTIONS(3543),
    [anon_sym_if] = ACTIONS(3543),
    [anon_sym_switch] = ACTIONS(3543),
    [anon_sym_case] = ACTIONS(3543),
    [anon_sym_default] = ACTIONS(3543),
    [anon_sym_while] = ACTIONS(3543),
    [anon_sym_do] = ACTIONS(3543),
    [anon_sym_for] = ACTIONS(3543),
    [anon_sym_return] = ACTIONS(3543),
    [anon_sym_break] = ACTIONS(3543),
    [anon_sym_continue] = ACTIONS(3543),
    [anon_sym_goto] = ACTIONS(3543),
    [anon_sym___try] = ACTIONS(3543),
    [anon_sym___leave] = ACTIONS(3543),
    [anon_sym_not] = ACTIONS(3543),
    [anon_sym_compl] = ACTIONS(3543),
    [anon_sym_DASH_DASH] = ACTIONS(3545),
    [anon_sym_PLUS_PLUS] = ACTIONS(3545),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym___alignof__] = ACTIONS(3543),
    [anon_sym___alignof] = ACTIONS(3543),
    [anon_sym__alignof] = ACTIONS(3543),
    [anon_sym_alignof] = ACTIONS(3543),
    [anon_sym__Alignof] = ACTIONS(3543),
    [anon_sym_offsetof] = ACTIONS(3543),
    [anon_sym__Generic] = ACTIONS(3543),
    [anon_sym_asm] = ACTIONS(3543),
    [anon_sym___asm__] = ACTIONS(3543),
    [sym_number_literal] = ACTIONS(3545),
    [anon_sym_L_SQUOTE] = ACTIONS(3545),
    [anon_sym_u_SQUOTE] = ACTIONS(3545),
    [anon_sym_U_SQUOTE] = ACTIONS(3545),
    [anon_sym_u8_SQUOTE] = ACTIONS(3545),
    [anon_sym_SQUOTE] = ACTIONS(3545),
    [anon_sym_L_DQUOTE] = ACTIONS(3545),
    [anon_sym_u_DQUOTE] = ACTIONS(3545),
    [anon_sym_U_DQUOTE] = ACTIONS(3545),
    [anon_sym_u8_DQUOTE] = ACTIONS(3545),
    [anon_sym_DQUOTE] = ACTIONS(3545),
    [sym_true] = ACTIONS(3543),
    [sym_false] = ACTIONS(3543),
    [anon_sym_NULL] = ACTIONS(3543),
    [anon_sym_nullptr] = ACTIONS(3543),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3543),
    [anon_sym_This] = ACTIONS(3543),
    [anon_sym_decltype] = ACTIONS(3543),
    [sym_virtual] = ACTIONS(3543),
    [anon_sym_explicit] = ACTIONS(3543),
    [anon_sym_typename] = ACTIONS(3543),
    [anon_sym_template] = ACTIONS(3543),
    [anon_sym_operator] = ACTIONS(3543),
    [anon_sym_try] = ACTIONS(3543),
    [anon_sym_delete] = ACTIONS(3543),
    [anon_sym_throw] = ACTIONS(3543),
    [anon_sym_namespace] = ACTIONS(3543),
    [anon_sym_using] = ACTIONS(3543),
    [anon_sym_static_assert] = ACTIONS(3543),
    [anon_sym_concept] = ACTIONS(3543),
    [anon_sym_co_return] = ACTIONS(3543),
    [anon_sym_co_yield] = ACTIONS(3543),
    [anon_sym_R_DQUOTE] = ACTIONS(3545),
    [anon_sym_LR_DQUOTE] = ACTIONS(3545),
    [anon_sym_uR_DQUOTE] = ACTIONS(3545),
    [anon_sym_UR_DQUOTE] = ACTIONS(3545),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3545),
    [anon_sym_co_await] = ACTIONS(3543),
    [anon_sym_new] = ACTIONS(3543),
    [anon_sym_requires] = ACTIONS(3543),
    [sym_this] = ACTIONS(3543),
    [anon_sym_discard] = ACTIONS(3543),
    [anon_sym_precise] = ACTIONS(3543),
    [anon_sym_shared] = ACTIONS(3543),
    [anon_sym_groupshared] = ACTIONS(3543),
    [anon_sym_uniform] = ACTIONS(3543),
    [anon_sym_row_major] = ACTIONS(3543),
    [anon_sym_column_major] = ACTIONS(3543),
    [anon_sym_globallycoherent] = ACTIONS(3543),
    [anon_sym_centroid] = ACTIONS(3543),
    [anon_sym_noperspective] = ACTIONS(3543),
    [anon_sym_nointerpolation] = ACTIONS(3543),
    [anon_sym_sample] = ACTIONS(3543),
    [anon_sym_linear] = ACTIONS(3543),
    [anon_sym_snorm] = ACTIONS(3543),
    [anon_sym_unorm] = ACTIONS(3543),
    [anon_sym_point] = ACTIONS(3543),
    [anon_sym_line] = ACTIONS(3543),
    [anon_sym_triangleadj] = ACTIONS(3543),
    [anon_sym_lineadj] = ACTIONS(3543),
    [anon_sym_triangle] = ACTIONS(3543),
    [anon_sym_cbuffer] = ACTIONS(3543),
    [anon_sym_interface] = ACTIONS(3543),
    [anon_sym_extension] = ACTIONS(3543),
  },
  [935] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(285),
    [ts_builtin_sym_end] = ACTIONS(3781),
    [sym_identifier] = ACTIONS(3778),
    [aux_sym_preproc_include_token1] = ACTIONS(3778),
    [aux_sym_preproc_def_token1] = ACTIONS(3778),
    [aux_sym_preproc_if_token1] = ACTIONS(3778),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3778),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3778),
    [sym_preproc_directive] = ACTIONS(3778),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_BANG] = ACTIONS(3781),
    [anon_sym_TILDE] = ACTIONS(3781),
    [anon_sym_DASH] = ACTIONS(3778),
    [anon_sym_PLUS] = ACTIONS(3778),
    [anon_sym_STAR] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_SEMI] = ACTIONS(3781),
    [anon_sym___extension__] = ACTIONS(3778),
    [anon_sym_typedef] = ACTIONS(3778),
    [anon_sym_in] = ACTIONS(3778),
    [anon_sym_out] = ACTIONS(3778),
    [anon_sym_inout] = ACTIONS(3778),
    [anon_sym_extern] = ACTIONS(3778),
    [anon_sym___attribute__] = ACTIONS(3778),
    [anon_sym_COLON_COLON] = ACTIONS(3781),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3781),
    [anon_sym___declspec] = ACTIONS(3778),
    [anon_sym___based] = ACTIONS(3778),
    [anon_sym___cdecl] = ACTIONS(3778),
    [anon_sym___clrcall] = ACTIONS(3778),
    [anon_sym___stdcall] = ACTIONS(3778),
    [anon_sym___fastcall] = ACTIONS(3778),
    [anon_sym___thiscall] = ACTIONS(3778),
    [anon_sym___vectorcall] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_signed] = ACTIONS(3941),
    [anon_sym_unsigned] = ACTIONS(3941),
    [anon_sym_long] = ACTIONS(3941),
    [anon_sym_short] = ACTIONS(3941),
    [anon_sym_LBRACK] = ACTIONS(3778),
    [anon_sym_static] = ACTIONS(3778),
    [anon_sym_register] = ACTIONS(3778),
    [anon_sym_inline] = ACTIONS(3778),
    [anon_sym___inline] = ACTIONS(3778),
    [anon_sym___inline__] = ACTIONS(3778),
    [anon_sym___forceinline] = ACTIONS(3778),
    [anon_sym_thread_local] = ACTIONS(3778),
    [anon_sym___thread] = ACTIONS(3778),
    [anon_sym_const] = ACTIONS(3778),
    [anon_sym_constexpr] = ACTIONS(3778),
    [anon_sym_volatile] = ACTIONS(3778),
    [anon_sym_restrict] = ACTIONS(3778),
    [anon_sym___restrict__] = ACTIONS(3778),
    [anon_sym__Atomic] = ACTIONS(3778),
    [anon_sym__Noreturn] = ACTIONS(3778),
    [anon_sym_noreturn] = ACTIONS(3778),
    [anon_sym_mutable] = ACTIONS(3778),
    [anon_sym_constinit] = ACTIONS(3778),
    [anon_sym_consteval] = ACTIONS(3778),
    [anon_sym_alignas] = ACTIONS(3778),
    [anon_sym__Alignas] = ACTIONS(3778),
    [sym_primitive_type] = ACTIONS(3778),
    [anon_sym_enum] = ACTIONS(3778),
    [anon_sym_class] = ACTIONS(3778),
    [anon_sym_struct] = ACTIONS(3778),
    [anon_sym_union] = ACTIONS(3778),
    [anon_sym_if] = ACTIONS(3778),
    [anon_sym_switch] = ACTIONS(3778),
    [anon_sym_case] = ACTIONS(3778),
    [anon_sym_default] = ACTIONS(3778),
    [anon_sym_while] = ACTIONS(3778),
    [anon_sym_do] = ACTIONS(3778),
    [anon_sym_for] = ACTIONS(3778),
    [anon_sym_return] = ACTIONS(3778),
    [anon_sym_break] = ACTIONS(3778),
    [anon_sym_continue] = ACTIONS(3778),
    [anon_sym_goto] = ACTIONS(3778),
    [anon_sym_not] = ACTIONS(3778),
    [anon_sym_compl] = ACTIONS(3778),
    [anon_sym_DASH_DASH] = ACTIONS(3781),
    [anon_sym_PLUS_PLUS] = ACTIONS(3781),
    [anon_sym_sizeof] = ACTIONS(3778),
    [anon_sym___alignof__] = ACTIONS(3778),
    [anon_sym___alignof] = ACTIONS(3778),
    [anon_sym__alignof] = ACTIONS(3778),
    [anon_sym_alignof] = ACTIONS(3778),
    [anon_sym__Alignof] = ACTIONS(3778),
    [anon_sym_offsetof] = ACTIONS(3778),
    [anon_sym__Generic] = ACTIONS(3778),
    [anon_sym_asm] = ACTIONS(3778),
    [anon_sym___asm__] = ACTIONS(3778),
    [anon_sym_DOT] = ACTIONS(3778),
    [sym_number_literal] = ACTIONS(3781),
    [anon_sym_L_SQUOTE] = ACTIONS(3781),
    [anon_sym_u_SQUOTE] = ACTIONS(3781),
    [anon_sym_U_SQUOTE] = ACTIONS(3781),
    [anon_sym_u8_SQUOTE] = ACTIONS(3781),
    [anon_sym_SQUOTE] = ACTIONS(3781),
    [anon_sym_L_DQUOTE] = ACTIONS(3781),
    [anon_sym_u_DQUOTE] = ACTIONS(3781),
    [anon_sym_U_DQUOTE] = ACTIONS(3781),
    [anon_sym_u8_DQUOTE] = ACTIONS(3781),
    [anon_sym_DQUOTE] = ACTIONS(3781),
    [sym_true] = ACTIONS(3778),
    [sym_false] = ACTIONS(3778),
    [anon_sym_NULL] = ACTIONS(3778),
    [anon_sym_nullptr] = ACTIONS(3778),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3778),
    [anon_sym_let] = ACTIONS(3778),
    [anon_sym_This] = ACTIONS(3778),
    [anon_sym_decltype] = ACTIONS(3778),
    [sym_virtual] = ACTIONS(3778),
    [anon_sym_explicit] = ACTIONS(3778),
    [anon_sym_typename] = ACTIONS(3778),
    [anon_sym_template] = ACTIONS(3778),
    [anon_sym_operator] = ACTIONS(3778),
    [anon_sym_try] = ACTIONS(3778),
    [anon_sym_delete] = ACTIONS(3778),
    [anon_sym_throw] = ACTIONS(3778),
    [anon_sym_namespace] = ACTIONS(3778),
    [anon_sym_using] = ACTIONS(3778),
    [anon_sym_static_assert] = ACTIONS(3778),
    [anon_sym_concept] = ACTIONS(3778),
    [anon_sym_co_return] = ACTIONS(3778),
    [anon_sym_co_yield] = ACTIONS(3778),
    [anon_sym_R_DQUOTE] = ACTIONS(3781),
    [anon_sym_LR_DQUOTE] = ACTIONS(3781),
    [anon_sym_uR_DQUOTE] = ACTIONS(3781),
    [anon_sym_UR_DQUOTE] = ACTIONS(3781),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3781),
    [anon_sym_co_await] = ACTIONS(3778),
    [anon_sym_new] = ACTIONS(3778),
    [anon_sym_requires] = ACTIONS(3778),
    [sym_this] = ACTIONS(3778),
    [anon_sym_precise] = ACTIONS(3778),
    [anon_sym_shared] = ACTIONS(3778),
    [anon_sym_groupshared] = ACTIONS(3778),
    [anon_sym_uniform] = ACTIONS(3778),
    [anon_sym_row_major] = ACTIONS(3778),
    [anon_sym_column_major] = ACTIONS(3778),
    [anon_sym_globallycoherent] = ACTIONS(3778),
    [anon_sym_centroid] = ACTIONS(3778),
    [anon_sym_noperspective] = ACTIONS(3778),
    [anon_sym_nointerpolation] = ACTIONS(3778),
    [anon_sym_sample] = ACTIONS(3778),
    [anon_sym_linear] = ACTIONS(3778),
    [anon_sym_snorm] = ACTIONS(3778),
    [anon_sym_unorm] = ACTIONS(3778),
    [anon_sym_point] = ACTIONS(3778),
    [anon_sym_line] = ACTIONS(3778),
    [anon_sym_triangleadj] = ACTIONS(3778),
    [anon_sym_lineadj] = ACTIONS(3778),
    [anon_sym_triangle] = ACTIONS(3778),
    [anon_sym_interface] = ACTIONS(3778),
    [anon_sym_extension] = ACTIONS(3778),
    [anon_sym___exported] = ACTIONS(3778),
    [anon_sym_import] = ACTIONS(3778),
  },
  [936] = {
    [sym_identifier] = ACTIONS(3559),
    [aux_sym_preproc_include_token1] = ACTIONS(3559),
    [aux_sym_preproc_def_token1] = ACTIONS(3559),
    [aux_sym_preproc_if_token1] = ACTIONS(3559),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3559),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3559),
    [sym_preproc_directive] = ACTIONS(3559),
    [anon_sym_LPAREN2] = ACTIONS(3561),
    [anon_sym_BANG] = ACTIONS(3561),
    [anon_sym_TILDE] = ACTIONS(3561),
    [anon_sym_DASH] = ACTIONS(3559),
    [anon_sym_PLUS] = ACTIONS(3559),
    [anon_sym_STAR] = ACTIONS(3561),
    [anon_sym_AMP_AMP] = ACTIONS(3561),
    [anon_sym_AMP] = ACTIONS(3559),
    [anon_sym_SEMI] = ACTIONS(3561),
    [anon_sym___extension__] = ACTIONS(3559),
    [anon_sym_typedef] = ACTIONS(3559),
    [anon_sym_in] = ACTIONS(3559),
    [anon_sym_out] = ACTIONS(3559),
    [anon_sym_inout] = ACTIONS(3559),
    [anon_sym_extern] = ACTIONS(3559),
    [anon_sym___attribute__] = ACTIONS(3559),
    [anon_sym_COLON_COLON] = ACTIONS(3561),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3561),
    [anon_sym___declspec] = ACTIONS(3559),
    [anon_sym___based] = ACTIONS(3559),
    [anon_sym___cdecl] = ACTIONS(3559),
    [anon_sym___clrcall] = ACTIONS(3559),
    [anon_sym___stdcall] = ACTIONS(3559),
    [anon_sym___fastcall] = ACTIONS(3559),
    [anon_sym___thiscall] = ACTIONS(3559),
    [anon_sym___vectorcall] = ACTIONS(3559),
    [anon_sym_LBRACE] = ACTIONS(3561),
    [anon_sym_RBRACE] = ACTIONS(3561),
    [anon_sym_signed] = ACTIONS(3559),
    [anon_sym_unsigned] = ACTIONS(3559),
    [anon_sym_long] = ACTIONS(3559),
    [anon_sym_short] = ACTIONS(3559),
    [anon_sym_LBRACK] = ACTIONS(3559),
    [anon_sym_static] = ACTIONS(3559),
    [anon_sym_register] = ACTIONS(3559),
    [anon_sym_inline] = ACTIONS(3559),
    [anon_sym___inline] = ACTIONS(3559),
    [anon_sym___inline__] = ACTIONS(3559),
    [anon_sym___forceinline] = ACTIONS(3559),
    [anon_sym_thread_local] = ACTIONS(3559),
    [anon_sym___thread] = ACTIONS(3559),
    [anon_sym_const] = ACTIONS(3559),
    [anon_sym_constexpr] = ACTIONS(3559),
    [anon_sym_volatile] = ACTIONS(3559),
    [anon_sym_restrict] = ACTIONS(3559),
    [anon_sym___restrict__] = ACTIONS(3559),
    [anon_sym__Atomic] = ACTIONS(3559),
    [anon_sym__Noreturn] = ACTIONS(3559),
    [anon_sym_noreturn] = ACTIONS(3559),
    [anon_sym_mutable] = ACTIONS(3559),
    [anon_sym_constinit] = ACTIONS(3559),
    [anon_sym_consteval] = ACTIONS(3559),
    [anon_sym_alignas] = ACTIONS(3559),
    [anon_sym__Alignas] = ACTIONS(3559),
    [sym_primitive_type] = ACTIONS(3559),
    [anon_sym_enum] = ACTIONS(3559),
    [anon_sym_class] = ACTIONS(3559),
    [anon_sym_struct] = ACTIONS(3559),
    [anon_sym_union] = ACTIONS(3559),
    [anon_sym_if] = ACTIONS(3559),
    [anon_sym_switch] = ACTIONS(3559),
    [anon_sym_case] = ACTIONS(3559),
    [anon_sym_default] = ACTIONS(3559),
    [anon_sym_while] = ACTIONS(3559),
    [anon_sym_do] = ACTIONS(3559),
    [anon_sym_for] = ACTIONS(3559),
    [anon_sym_return] = ACTIONS(3559),
    [anon_sym_break] = ACTIONS(3559),
    [anon_sym_continue] = ACTIONS(3559),
    [anon_sym_goto] = ACTIONS(3559),
    [anon_sym___try] = ACTIONS(3559),
    [anon_sym___leave] = ACTIONS(3559),
    [anon_sym_not] = ACTIONS(3559),
    [anon_sym_compl] = ACTIONS(3559),
    [anon_sym_DASH_DASH] = ACTIONS(3561),
    [anon_sym_PLUS_PLUS] = ACTIONS(3561),
    [anon_sym_sizeof] = ACTIONS(3559),
    [anon_sym___alignof__] = ACTIONS(3559),
    [anon_sym___alignof] = ACTIONS(3559),
    [anon_sym__alignof] = ACTIONS(3559),
    [anon_sym_alignof] = ACTIONS(3559),
    [anon_sym__Alignof] = ACTIONS(3559),
    [anon_sym_offsetof] = ACTIONS(3559),
    [anon_sym__Generic] = ACTIONS(3559),
    [anon_sym_asm] = ACTIONS(3559),
    [anon_sym___asm__] = ACTIONS(3559),
    [sym_number_literal] = ACTIONS(3561),
    [anon_sym_L_SQUOTE] = ACTIONS(3561),
    [anon_sym_u_SQUOTE] = ACTIONS(3561),
    [anon_sym_U_SQUOTE] = ACTIONS(3561),
    [anon_sym_u8_SQUOTE] = ACTIONS(3561),
    [anon_sym_SQUOTE] = ACTIONS(3561),
    [anon_sym_L_DQUOTE] = ACTIONS(3561),
    [anon_sym_u_DQUOTE] = ACTIONS(3561),
    [anon_sym_U_DQUOTE] = ACTIONS(3561),
    [anon_sym_u8_DQUOTE] = ACTIONS(3561),
    [anon_sym_DQUOTE] = ACTIONS(3561),
    [sym_true] = ACTIONS(3559),
    [sym_false] = ACTIONS(3559),
    [anon_sym_NULL] = ACTIONS(3559),
    [anon_sym_nullptr] = ACTIONS(3559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3559),
    [anon_sym_let] = ACTIONS(3559),
    [anon_sym_This] = ACTIONS(3559),
    [anon_sym_decltype] = ACTIONS(3559),
    [sym_virtual] = ACTIONS(3559),
    [anon_sym_explicit] = ACTIONS(3559),
    [anon_sym_typename] = ACTIONS(3559),
    [anon_sym_template] = ACTIONS(3559),
    [anon_sym_operator] = ACTIONS(3559),
    [anon_sym_try] = ACTIONS(3559),
    [anon_sym_delete] = ACTIONS(3559),
    [anon_sym_throw] = ACTIONS(3559),
    [anon_sym_namespace] = ACTIONS(3559),
    [anon_sym_using] = ACTIONS(3559),
    [anon_sym_static_assert] = ACTIONS(3559),
    [anon_sym_concept] = ACTIONS(3559),
    [anon_sym_co_return] = ACTIONS(3559),
    [anon_sym_co_yield] = ACTIONS(3559),
    [anon_sym_R_DQUOTE] = ACTIONS(3561),
    [anon_sym_LR_DQUOTE] = ACTIONS(3561),
    [anon_sym_uR_DQUOTE] = ACTIONS(3561),
    [anon_sym_UR_DQUOTE] = ACTIONS(3561),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3561),
    [anon_sym_co_await] = ACTIONS(3559),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_requires] = ACTIONS(3559),
    [sym_this] = ACTIONS(3559),
    [anon_sym_discard] = ACTIONS(3559),
    [anon_sym_precise] = ACTIONS(3559),
    [anon_sym_shared] = ACTIONS(3559),
    [anon_sym_groupshared] = ACTIONS(3559),
    [anon_sym_uniform] = ACTIONS(3559),
    [anon_sym_row_major] = ACTIONS(3559),
    [anon_sym_column_major] = ACTIONS(3559),
    [anon_sym_globallycoherent] = ACTIONS(3559),
    [anon_sym_centroid] = ACTIONS(3559),
    [anon_sym_noperspective] = ACTIONS(3559),
    [anon_sym_nointerpolation] = ACTIONS(3559),
    [anon_sym_sample] = ACTIONS(3559),
    [anon_sym_linear] = ACTIONS(3559),
    [anon_sym_snorm] = ACTIONS(3559),
    [anon_sym_unorm] = ACTIONS(3559),
    [anon_sym_point] = ACTIONS(3559),
    [anon_sym_line] = ACTIONS(3559),
    [anon_sym_triangleadj] = ACTIONS(3559),
    [anon_sym_lineadj] = ACTIONS(3559),
    [anon_sym_triangle] = ACTIONS(3559),
    [anon_sym_cbuffer] = ACTIONS(3559),
    [anon_sym_interface] = ACTIONS(3559),
    [anon_sym_extension] = ACTIONS(3559),
  },
  [937] = {
    [sym_identifier] = ACTIONS(3563),
    [aux_sym_preproc_include_token1] = ACTIONS(3563),
    [aux_sym_preproc_def_token1] = ACTIONS(3563),
    [aux_sym_preproc_if_token1] = ACTIONS(3563),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3563),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3563),
    [sym_preproc_directive] = ACTIONS(3563),
    [anon_sym_LPAREN2] = ACTIONS(3565),
    [anon_sym_BANG] = ACTIONS(3565),
    [anon_sym_TILDE] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3563),
    [anon_sym_PLUS] = ACTIONS(3563),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_AMP_AMP] = ACTIONS(3565),
    [anon_sym_AMP] = ACTIONS(3563),
    [anon_sym_SEMI] = ACTIONS(3565),
    [anon_sym___extension__] = ACTIONS(3563),
    [anon_sym_typedef] = ACTIONS(3563),
    [anon_sym_in] = ACTIONS(3563),
    [anon_sym_out] = ACTIONS(3563),
    [anon_sym_inout] = ACTIONS(3563),
    [anon_sym_extern] = ACTIONS(3563),
    [anon_sym___attribute__] = ACTIONS(3563),
    [anon_sym_COLON_COLON] = ACTIONS(3565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3565),
    [anon_sym___declspec] = ACTIONS(3563),
    [anon_sym___based] = ACTIONS(3563),
    [anon_sym___cdecl] = ACTIONS(3563),
    [anon_sym___clrcall] = ACTIONS(3563),
    [anon_sym___stdcall] = ACTIONS(3563),
    [anon_sym___fastcall] = ACTIONS(3563),
    [anon_sym___thiscall] = ACTIONS(3563),
    [anon_sym___vectorcall] = ACTIONS(3563),
    [anon_sym_LBRACE] = ACTIONS(3565),
    [anon_sym_RBRACE] = ACTIONS(3565),
    [anon_sym_signed] = ACTIONS(3563),
    [anon_sym_unsigned] = ACTIONS(3563),
    [anon_sym_long] = ACTIONS(3563),
    [anon_sym_short] = ACTIONS(3563),
    [anon_sym_LBRACK] = ACTIONS(3563),
    [anon_sym_static] = ACTIONS(3563),
    [anon_sym_register] = ACTIONS(3563),
    [anon_sym_inline] = ACTIONS(3563),
    [anon_sym___inline] = ACTIONS(3563),
    [anon_sym___inline__] = ACTIONS(3563),
    [anon_sym___forceinline] = ACTIONS(3563),
    [anon_sym_thread_local] = ACTIONS(3563),
    [anon_sym___thread] = ACTIONS(3563),
    [anon_sym_const] = ACTIONS(3563),
    [anon_sym_constexpr] = ACTIONS(3563),
    [anon_sym_volatile] = ACTIONS(3563),
    [anon_sym_restrict] = ACTIONS(3563),
    [anon_sym___restrict__] = ACTIONS(3563),
    [anon_sym__Atomic] = ACTIONS(3563),
    [anon_sym__Noreturn] = ACTIONS(3563),
    [anon_sym_noreturn] = ACTIONS(3563),
    [anon_sym_mutable] = ACTIONS(3563),
    [anon_sym_constinit] = ACTIONS(3563),
    [anon_sym_consteval] = ACTIONS(3563),
    [anon_sym_alignas] = ACTIONS(3563),
    [anon_sym__Alignas] = ACTIONS(3563),
    [sym_primitive_type] = ACTIONS(3563),
    [anon_sym_enum] = ACTIONS(3563),
    [anon_sym_class] = ACTIONS(3563),
    [anon_sym_struct] = ACTIONS(3563),
    [anon_sym_union] = ACTIONS(3563),
    [anon_sym_if] = ACTIONS(3563),
    [anon_sym_switch] = ACTIONS(3563),
    [anon_sym_case] = ACTIONS(3563),
    [anon_sym_default] = ACTIONS(3563),
    [anon_sym_while] = ACTIONS(3563),
    [anon_sym_do] = ACTIONS(3563),
    [anon_sym_for] = ACTIONS(3563),
    [anon_sym_return] = ACTIONS(3563),
    [anon_sym_break] = ACTIONS(3563),
    [anon_sym_continue] = ACTIONS(3563),
    [anon_sym_goto] = ACTIONS(3563),
    [anon_sym___try] = ACTIONS(3563),
    [anon_sym___leave] = ACTIONS(3563),
    [anon_sym_not] = ACTIONS(3563),
    [anon_sym_compl] = ACTIONS(3563),
    [anon_sym_DASH_DASH] = ACTIONS(3565),
    [anon_sym_PLUS_PLUS] = ACTIONS(3565),
    [anon_sym_sizeof] = ACTIONS(3563),
    [anon_sym___alignof__] = ACTIONS(3563),
    [anon_sym___alignof] = ACTIONS(3563),
    [anon_sym__alignof] = ACTIONS(3563),
    [anon_sym_alignof] = ACTIONS(3563),
    [anon_sym__Alignof] = ACTIONS(3563),
    [anon_sym_offsetof] = ACTIONS(3563),
    [anon_sym__Generic] = ACTIONS(3563),
    [anon_sym_asm] = ACTIONS(3563),
    [anon_sym___asm__] = ACTIONS(3563),
    [sym_number_literal] = ACTIONS(3565),
    [anon_sym_L_SQUOTE] = ACTIONS(3565),
    [anon_sym_u_SQUOTE] = ACTIONS(3565),
    [anon_sym_U_SQUOTE] = ACTIONS(3565),
    [anon_sym_u8_SQUOTE] = ACTIONS(3565),
    [anon_sym_SQUOTE] = ACTIONS(3565),
    [anon_sym_L_DQUOTE] = ACTIONS(3565),
    [anon_sym_u_DQUOTE] = ACTIONS(3565),
    [anon_sym_U_DQUOTE] = ACTIONS(3565),
    [anon_sym_u8_DQUOTE] = ACTIONS(3565),
    [anon_sym_DQUOTE] = ACTIONS(3565),
    [sym_true] = ACTIONS(3563),
    [sym_false] = ACTIONS(3563),
    [anon_sym_NULL] = ACTIONS(3563),
    [anon_sym_nullptr] = ACTIONS(3563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3563),
    [anon_sym_let] = ACTIONS(3563),
    [anon_sym_This] = ACTIONS(3563),
    [anon_sym_decltype] = ACTIONS(3563),
    [sym_virtual] = ACTIONS(3563),
    [anon_sym_explicit] = ACTIONS(3563),
    [anon_sym_typename] = ACTIONS(3563),
    [anon_sym_template] = ACTIONS(3563),
    [anon_sym_operator] = ACTIONS(3563),
    [anon_sym_try] = ACTIONS(3563),
    [anon_sym_delete] = ACTIONS(3563),
    [anon_sym_throw] = ACTIONS(3563),
    [anon_sym_namespace] = ACTIONS(3563),
    [anon_sym_using] = ACTIONS(3563),
    [anon_sym_static_assert] = ACTIONS(3563),
    [anon_sym_concept] = ACTIONS(3563),
    [anon_sym_co_return] = ACTIONS(3563),
    [anon_sym_co_yield] = ACTIONS(3563),
    [anon_sym_R_DQUOTE] = ACTIONS(3565),
    [anon_sym_LR_DQUOTE] = ACTIONS(3565),
    [anon_sym_uR_DQUOTE] = ACTIONS(3565),
    [anon_sym_UR_DQUOTE] = ACTIONS(3565),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3565),
    [anon_sym_co_await] = ACTIONS(3563),
    [anon_sym_new] = ACTIONS(3563),
    [anon_sym_requires] = ACTIONS(3563),
    [sym_this] = ACTIONS(3563),
    [anon_sym_discard] = ACTIONS(3563),
    [anon_sym_precise] = ACTIONS(3563),
    [anon_sym_shared] = ACTIONS(3563),
    [anon_sym_groupshared] = ACTIONS(3563),
    [anon_sym_uniform] = ACTIONS(3563),
    [anon_sym_row_major] = ACTIONS(3563),
    [anon_sym_column_major] = ACTIONS(3563),
    [anon_sym_globallycoherent] = ACTIONS(3563),
    [anon_sym_centroid] = ACTIONS(3563),
    [anon_sym_noperspective] = ACTIONS(3563),
    [anon_sym_nointerpolation] = ACTIONS(3563),
    [anon_sym_sample] = ACTIONS(3563),
    [anon_sym_linear] = ACTIONS(3563),
    [anon_sym_snorm] = ACTIONS(3563),
    [anon_sym_unorm] = ACTIONS(3563),
    [anon_sym_point] = ACTIONS(3563),
    [anon_sym_line] = ACTIONS(3563),
    [anon_sym_triangleadj] = ACTIONS(3563),
    [anon_sym_lineadj] = ACTIONS(3563),
    [anon_sym_triangle] = ACTIONS(3563),
    [anon_sym_cbuffer] = ACTIONS(3563),
    [anon_sym_interface] = ACTIONS(3563),
    [anon_sym_extension] = ACTIONS(3563),
  },
  [938] = {
    [sym_identifier] = ACTIONS(3445),
    [aux_sym_preproc_include_token1] = ACTIONS(3445),
    [aux_sym_preproc_def_token1] = ACTIONS(3445),
    [aux_sym_preproc_if_token1] = ACTIONS(3445),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3445),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3445),
    [sym_preproc_directive] = ACTIONS(3445),
    [anon_sym_LPAREN2] = ACTIONS(3447),
    [anon_sym_BANG] = ACTIONS(3447),
    [anon_sym_TILDE] = ACTIONS(3447),
    [anon_sym_DASH] = ACTIONS(3445),
    [anon_sym_PLUS] = ACTIONS(3445),
    [anon_sym_STAR] = ACTIONS(3447),
    [anon_sym_AMP_AMP] = ACTIONS(3447),
    [anon_sym_AMP] = ACTIONS(3445),
    [anon_sym_SEMI] = ACTIONS(3447),
    [anon_sym___extension__] = ACTIONS(3445),
    [anon_sym_typedef] = ACTIONS(3445),
    [anon_sym_in] = ACTIONS(3445),
    [anon_sym_out] = ACTIONS(3445),
    [anon_sym_inout] = ACTIONS(3445),
    [anon_sym_extern] = ACTIONS(3445),
    [anon_sym___attribute__] = ACTIONS(3445),
    [anon_sym_COLON_COLON] = ACTIONS(3447),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3447),
    [anon_sym___declspec] = ACTIONS(3445),
    [anon_sym___based] = ACTIONS(3445),
    [anon_sym___cdecl] = ACTIONS(3445),
    [anon_sym___clrcall] = ACTIONS(3445),
    [anon_sym___stdcall] = ACTIONS(3445),
    [anon_sym___fastcall] = ACTIONS(3445),
    [anon_sym___thiscall] = ACTIONS(3445),
    [anon_sym___vectorcall] = ACTIONS(3445),
    [anon_sym_LBRACE] = ACTIONS(3447),
    [anon_sym_RBRACE] = ACTIONS(3447),
    [anon_sym_signed] = ACTIONS(3445),
    [anon_sym_unsigned] = ACTIONS(3445),
    [anon_sym_long] = ACTIONS(3445),
    [anon_sym_short] = ACTIONS(3445),
    [anon_sym_LBRACK] = ACTIONS(3445),
    [anon_sym_static] = ACTIONS(3445),
    [anon_sym_register] = ACTIONS(3445),
    [anon_sym_inline] = ACTIONS(3445),
    [anon_sym___inline] = ACTIONS(3445),
    [anon_sym___inline__] = ACTIONS(3445),
    [anon_sym___forceinline] = ACTIONS(3445),
    [anon_sym_thread_local] = ACTIONS(3445),
    [anon_sym___thread] = ACTIONS(3445),
    [anon_sym_const] = ACTIONS(3445),
    [anon_sym_constexpr] = ACTIONS(3445),
    [anon_sym_volatile] = ACTIONS(3445),
    [anon_sym_restrict] = ACTIONS(3445),
    [anon_sym___restrict__] = ACTIONS(3445),
    [anon_sym__Atomic] = ACTIONS(3445),
    [anon_sym__Noreturn] = ACTIONS(3445),
    [anon_sym_noreturn] = ACTIONS(3445),
    [anon_sym_mutable] = ACTIONS(3445),
    [anon_sym_constinit] = ACTIONS(3445),
    [anon_sym_consteval] = ACTIONS(3445),
    [anon_sym_alignas] = ACTIONS(3445),
    [anon_sym__Alignas] = ACTIONS(3445),
    [sym_primitive_type] = ACTIONS(3445),
    [anon_sym_enum] = ACTIONS(3445),
    [anon_sym_class] = ACTIONS(3445),
    [anon_sym_struct] = ACTIONS(3445),
    [anon_sym_union] = ACTIONS(3445),
    [anon_sym_if] = ACTIONS(3445),
    [anon_sym_switch] = ACTIONS(3445),
    [anon_sym_case] = ACTIONS(3445),
    [anon_sym_default] = ACTIONS(3445),
    [anon_sym_while] = ACTIONS(3445),
    [anon_sym_do] = ACTIONS(3445),
    [anon_sym_for] = ACTIONS(3445),
    [anon_sym_return] = ACTIONS(3445),
    [anon_sym_break] = ACTIONS(3445),
    [anon_sym_continue] = ACTIONS(3445),
    [anon_sym_goto] = ACTIONS(3445),
    [anon_sym___try] = ACTIONS(3445),
    [anon_sym___leave] = ACTIONS(3445),
    [anon_sym_not] = ACTIONS(3445),
    [anon_sym_compl] = ACTIONS(3445),
    [anon_sym_DASH_DASH] = ACTIONS(3447),
    [anon_sym_PLUS_PLUS] = ACTIONS(3447),
    [anon_sym_sizeof] = ACTIONS(3445),
    [anon_sym___alignof__] = ACTIONS(3445),
    [anon_sym___alignof] = ACTIONS(3445),
    [anon_sym__alignof] = ACTIONS(3445),
    [anon_sym_alignof] = ACTIONS(3445),
    [anon_sym__Alignof] = ACTIONS(3445),
    [anon_sym_offsetof] = ACTIONS(3445),
    [anon_sym__Generic] = ACTIONS(3445),
    [anon_sym_asm] = ACTIONS(3445),
    [anon_sym___asm__] = ACTIONS(3445),
    [sym_number_literal] = ACTIONS(3447),
    [anon_sym_L_SQUOTE] = ACTIONS(3447),
    [anon_sym_u_SQUOTE] = ACTIONS(3447),
    [anon_sym_U_SQUOTE] = ACTIONS(3447),
    [anon_sym_u8_SQUOTE] = ACTIONS(3447),
    [anon_sym_SQUOTE] = ACTIONS(3447),
    [anon_sym_L_DQUOTE] = ACTIONS(3447),
    [anon_sym_u_DQUOTE] = ACTIONS(3447),
    [anon_sym_U_DQUOTE] = ACTIONS(3447),
    [anon_sym_u8_DQUOTE] = ACTIONS(3447),
    [anon_sym_DQUOTE] = ACTIONS(3447),
    [sym_true] = ACTIONS(3445),
    [sym_false] = ACTIONS(3445),
    [anon_sym_NULL] = ACTIONS(3445),
    [anon_sym_nullptr] = ACTIONS(3445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3445),
    [anon_sym_let] = ACTIONS(3445),
    [anon_sym_This] = ACTIONS(3445),
    [anon_sym_decltype] = ACTIONS(3445),
    [sym_virtual] = ACTIONS(3445),
    [anon_sym_explicit] = ACTIONS(3445),
    [anon_sym_typename] = ACTIONS(3445),
    [anon_sym_template] = ACTIONS(3445),
    [anon_sym_operator] = ACTIONS(3445),
    [anon_sym_try] = ACTIONS(3445),
    [anon_sym_delete] = ACTIONS(3445),
    [anon_sym_throw] = ACTIONS(3445),
    [anon_sym_namespace] = ACTIONS(3445),
    [anon_sym_using] = ACTIONS(3445),
    [anon_sym_static_assert] = ACTIONS(3445),
    [anon_sym_concept] = ACTIONS(3445),
    [anon_sym_co_return] = ACTIONS(3445),
    [anon_sym_co_yield] = ACTIONS(3445),
    [anon_sym_R_DQUOTE] = ACTIONS(3447),
    [anon_sym_LR_DQUOTE] = ACTIONS(3447),
    [anon_sym_uR_DQUOTE] = ACTIONS(3447),
    [anon_sym_UR_DQUOTE] = ACTIONS(3447),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3447),
    [anon_sym_co_await] = ACTIONS(3445),
    [anon_sym_new] = ACTIONS(3445),
    [anon_sym_requires] = ACTIONS(3445),
    [sym_this] = ACTIONS(3445),
    [anon_sym_discard] = ACTIONS(3445),
    [anon_sym_precise] = ACTIONS(3445),
    [anon_sym_shared] = ACTIONS(3445),
    [anon_sym_groupshared] = ACTIONS(3445),
    [anon_sym_uniform] = ACTIONS(3445),
    [anon_sym_row_major] = ACTIONS(3445),
    [anon_sym_column_major] = ACTIONS(3445),
    [anon_sym_globallycoherent] = ACTIONS(3445),
    [anon_sym_centroid] = ACTIONS(3445),
    [anon_sym_noperspective] = ACTIONS(3445),
    [anon_sym_nointerpolation] = ACTIONS(3445),
    [anon_sym_sample] = ACTIONS(3445),
    [anon_sym_linear] = ACTIONS(3445),
    [anon_sym_snorm] = ACTIONS(3445),
    [anon_sym_unorm] = ACTIONS(3445),
    [anon_sym_point] = ACTIONS(3445),
    [anon_sym_line] = ACTIONS(3445),
    [anon_sym_triangleadj] = ACTIONS(3445),
    [anon_sym_lineadj] = ACTIONS(3445),
    [anon_sym_triangle] = ACTIONS(3445),
    [anon_sym_cbuffer] = ACTIONS(3445),
    [anon_sym_interface] = ACTIONS(3445),
    [anon_sym_extension] = ACTIONS(3445),
  },
  [939] = {
    [sym_identifier] = ACTIONS(3441),
    [aux_sym_preproc_include_token1] = ACTIONS(3441),
    [aux_sym_preproc_def_token1] = ACTIONS(3441),
    [aux_sym_preproc_if_token1] = ACTIONS(3441),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3441),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3441),
    [sym_preproc_directive] = ACTIONS(3441),
    [anon_sym_LPAREN2] = ACTIONS(3443),
    [anon_sym_BANG] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3441),
    [anon_sym_PLUS] = ACTIONS(3441),
    [anon_sym_STAR] = ACTIONS(3443),
    [anon_sym_AMP_AMP] = ACTIONS(3443),
    [anon_sym_AMP] = ACTIONS(3441),
    [anon_sym_SEMI] = ACTIONS(3443),
    [anon_sym___extension__] = ACTIONS(3441),
    [anon_sym_typedef] = ACTIONS(3441),
    [anon_sym_in] = ACTIONS(3441),
    [anon_sym_out] = ACTIONS(3441),
    [anon_sym_inout] = ACTIONS(3441),
    [anon_sym_extern] = ACTIONS(3441),
    [anon_sym___attribute__] = ACTIONS(3441),
    [anon_sym_COLON_COLON] = ACTIONS(3443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3443),
    [anon_sym___declspec] = ACTIONS(3441),
    [anon_sym___based] = ACTIONS(3441),
    [anon_sym___cdecl] = ACTIONS(3441),
    [anon_sym___clrcall] = ACTIONS(3441),
    [anon_sym___stdcall] = ACTIONS(3441),
    [anon_sym___fastcall] = ACTIONS(3441),
    [anon_sym___thiscall] = ACTIONS(3441),
    [anon_sym___vectorcall] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_RBRACE] = ACTIONS(3443),
    [anon_sym_signed] = ACTIONS(3441),
    [anon_sym_unsigned] = ACTIONS(3441),
    [anon_sym_long] = ACTIONS(3441),
    [anon_sym_short] = ACTIONS(3441),
    [anon_sym_LBRACK] = ACTIONS(3441),
    [anon_sym_static] = ACTIONS(3441),
    [anon_sym_register] = ACTIONS(3441),
    [anon_sym_inline] = ACTIONS(3441),
    [anon_sym___inline] = ACTIONS(3441),
    [anon_sym___inline__] = ACTIONS(3441),
    [anon_sym___forceinline] = ACTIONS(3441),
    [anon_sym_thread_local] = ACTIONS(3441),
    [anon_sym___thread] = ACTIONS(3441),
    [anon_sym_const] = ACTIONS(3441),
    [anon_sym_constexpr] = ACTIONS(3441),
    [anon_sym_volatile] = ACTIONS(3441),
    [anon_sym_restrict] = ACTIONS(3441),
    [anon_sym___restrict__] = ACTIONS(3441),
    [anon_sym__Atomic] = ACTIONS(3441),
    [anon_sym__Noreturn] = ACTIONS(3441),
    [anon_sym_noreturn] = ACTIONS(3441),
    [anon_sym_mutable] = ACTIONS(3441),
    [anon_sym_constinit] = ACTIONS(3441),
    [anon_sym_consteval] = ACTIONS(3441),
    [anon_sym_alignas] = ACTIONS(3441),
    [anon_sym__Alignas] = ACTIONS(3441),
    [sym_primitive_type] = ACTIONS(3441),
    [anon_sym_enum] = ACTIONS(3441),
    [anon_sym_class] = ACTIONS(3441),
    [anon_sym_struct] = ACTIONS(3441),
    [anon_sym_union] = ACTIONS(3441),
    [anon_sym_if] = ACTIONS(3441),
    [anon_sym_switch] = ACTIONS(3441),
    [anon_sym_case] = ACTIONS(3441),
    [anon_sym_default] = ACTIONS(3441),
    [anon_sym_while] = ACTIONS(3441),
    [anon_sym_do] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3441),
    [anon_sym_return] = ACTIONS(3441),
    [anon_sym_break] = ACTIONS(3441),
    [anon_sym_continue] = ACTIONS(3441),
    [anon_sym_goto] = ACTIONS(3441),
    [anon_sym___try] = ACTIONS(3441),
    [anon_sym___leave] = ACTIONS(3441),
    [anon_sym_not] = ACTIONS(3441),
    [anon_sym_compl] = ACTIONS(3441),
    [anon_sym_DASH_DASH] = ACTIONS(3443),
    [anon_sym_PLUS_PLUS] = ACTIONS(3443),
    [anon_sym_sizeof] = ACTIONS(3441),
    [anon_sym___alignof__] = ACTIONS(3441),
    [anon_sym___alignof] = ACTIONS(3441),
    [anon_sym__alignof] = ACTIONS(3441),
    [anon_sym_alignof] = ACTIONS(3441),
    [anon_sym__Alignof] = ACTIONS(3441),
    [anon_sym_offsetof] = ACTIONS(3441),
    [anon_sym__Generic] = ACTIONS(3441),
    [anon_sym_asm] = ACTIONS(3441),
    [anon_sym___asm__] = ACTIONS(3441),
    [sym_number_literal] = ACTIONS(3443),
    [anon_sym_L_SQUOTE] = ACTIONS(3443),
    [anon_sym_u_SQUOTE] = ACTIONS(3443),
    [anon_sym_U_SQUOTE] = ACTIONS(3443),
    [anon_sym_u8_SQUOTE] = ACTIONS(3443),
    [anon_sym_SQUOTE] = ACTIONS(3443),
    [anon_sym_L_DQUOTE] = ACTIONS(3443),
    [anon_sym_u_DQUOTE] = ACTIONS(3443),
    [anon_sym_U_DQUOTE] = ACTIONS(3443),
    [anon_sym_u8_DQUOTE] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3443),
    [sym_true] = ACTIONS(3441),
    [sym_false] = ACTIONS(3441),
    [anon_sym_NULL] = ACTIONS(3441),
    [anon_sym_nullptr] = ACTIONS(3441),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3441),
    [anon_sym_let] = ACTIONS(3441),
    [anon_sym_This] = ACTIONS(3441),
    [anon_sym_decltype] = ACTIONS(3441),
    [sym_virtual] = ACTIONS(3441),
    [anon_sym_explicit] = ACTIONS(3441),
    [anon_sym_typename] = ACTIONS(3441),
    [anon_sym_template] = ACTIONS(3441),
    [anon_sym_operator] = ACTIONS(3441),
    [anon_sym_try] = ACTIONS(3441),
    [anon_sym_delete] = ACTIONS(3441),
    [anon_sym_throw] = ACTIONS(3441),
    [anon_sym_namespace] = ACTIONS(3441),
    [anon_sym_using] = ACTIONS(3441),
    [anon_sym_static_assert] = ACTIONS(3441),
    [anon_sym_concept] = ACTIONS(3441),
    [anon_sym_co_return] = ACTIONS(3441),
    [anon_sym_co_yield] = ACTIONS(3441),
    [anon_sym_R_DQUOTE] = ACTIONS(3443),
    [anon_sym_LR_DQUOTE] = ACTIONS(3443),
    [anon_sym_uR_DQUOTE] = ACTIONS(3443),
    [anon_sym_UR_DQUOTE] = ACTIONS(3443),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3443),
    [anon_sym_co_await] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3441),
    [anon_sym_requires] = ACTIONS(3441),
    [sym_this] = ACTIONS(3441),
    [anon_sym_discard] = ACTIONS(3441),
    [anon_sym_precise] = ACTIONS(3441),
    [anon_sym_shared] = ACTIONS(3441),
    [anon_sym_groupshared] = ACTIONS(3441),
    [anon_sym_uniform] = ACTIONS(3441),
    [anon_sym_row_major] = ACTIONS(3441),
    [anon_sym_column_major] = ACTIONS(3441),
    [anon_sym_globallycoherent] = ACTIONS(3441),
    [anon_sym_centroid] = ACTIONS(3441),
    [anon_sym_noperspective] = ACTIONS(3441),
    [anon_sym_nointerpolation] = ACTIONS(3441),
    [anon_sym_sample] = ACTIONS(3441),
    [anon_sym_linear] = ACTIONS(3441),
    [anon_sym_snorm] = ACTIONS(3441),
    [anon_sym_unorm] = ACTIONS(3441),
    [anon_sym_point] = ACTIONS(3441),
    [anon_sym_line] = ACTIONS(3441),
    [anon_sym_triangleadj] = ACTIONS(3441),
    [anon_sym_lineadj] = ACTIONS(3441),
    [anon_sym_triangle] = ACTIONS(3441),
    [anon_sym_cbuffer] = ACTIONS(3441),
    [anon_sym_interface] = ACTIONS(3441),
    [anon_sym_extension] = ACTIONS(3441),
  },
  [940] = {
    [sym_identifier] = ACTIONS(3525),
    [aux_sym_preproc_include_token1] = ACTIONS(3525),
    [aux_sym_preproc_def_token1] = ACTIONS(3525),
    [aux_sym_preproc_if_token1] = ACTIONS(3525),
    [aux_sym_preproc_if_token2] = ACTIONS(3525),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3525),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3525),
    [sym_preproc_directive] = ACTIONS(3525),
    [anon_sym_LPAREN2] = ACTIONS(3527),
    [anon_sym_BANG] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3525),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_AMP] = ACTIONS(3525),
    [anon_sym_SEMI] = ACTIONS(3527),
    [anon_sym___extension__] = ACTIONS(3525),
    [anon_sym_typedef] = ACTIONS(3525),
    [anon_sym_in] = ACTIONS(3525),
    [anon_sym_out] = ACTIONS(3525),
    [anon_sym_inout] = ACTIONS(3525),
    [anon_sym_extern] = ACTIONS(3525),
    [anon_sym___attribute__] = ACTIONS(3525),
    [anon_sym_COLON_COLON] = ACTIONS(3527),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3527),
    [anon_sym___declspec] = ACTIONS(3525),
    [anon_sym___based] = ACTIONS(3525),
    [anon_sym___cdecl] = ACTIONS(3525),
    [anon_sym___clrcall] = ACTIONS(3525),
    [anon_sym___stdcall] = ACTIONS(3525),
    [anon_sym___fastcall] = ACTIONS(3525),
    [anon_sym___thiscall] = ACTIONS(3525),
    [anon_sym___vectorcall] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_signed] = ACTIONS(3525),
    [anon_sym_unsigned] = ACTIONS(3525),
    [anon_sym_long] = ACTIONS(3525),
    [anon_sym_short] = ACTIONS(3525),
    [anon_sym_LBRACK] = ACTIONS(3525),
    [anon_sym_static] = ACTIONS(3525),
    [anon_sym_register] = ACTIONS(3525),
    [anon_sym_inline] = ACTIONS(3525),
    [anon_sym___inline] = ACTIONS(3525),
    [anon_sym___inline__] = ACTIONS(3525),
    [anon_sym___forceinline] = ACTIONS(3525),
    [anon_sym_thread_local] = ACTIONS(3525),
    [anon_sym___thread] = ACTIONS(3525),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_constexpr] = ACTIONS(3525),
    [anon_sym_volatile] = ACTIONS(3525),
    [anon_sym_restrict] = ACTIONS(3525),
    [anon_sym___restrict__] = ACTIONS(3525),
    [anon_sym__Atomic] = ACTIONS(3525),
    [anon_sym__Noreturn] = ACTIONS(3525),
    [anon_sym_noreturn] = ACTIONS(3525),
    [anon_sym_mutable] = ACTIONS(3525),
    [anon_sym_constinit] = ACTIONS(3525),
    [anon_sym_consteval] = ACTIONS(3525),
    [anon_sym_alignas] = ACTIONS(3525),
    [anon_sym__Alignas] = ACTIONS(3525),
    [sym_primitive_type] = ACTIONS(3525),
    [anon_sym_enum] = ACTIONS(3525),
    [anon_sym_class] = ACTIONS(3525),
    [anon_sym_struct] = ACTIONS(3525),
    [anon_sym_union] = ACTIONS(3525),
    [anon_sym_if] = ACTIONS(3525),
    [anon_sym_switch] = ACTIONS(3525),
    [anon_sym_case] = ACTIONS(3525),
    [anon_sym_default] = ACTIONS(3525),
    [anon_sym_while] = ACTIONS(3525),
    [anon_sym_do] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3525),
    [anon_sym_return] = ACTIONS(3525),
    [anon_sym_break] = ACTIONS(3525),
    [anon_sym_continue] = ACTIONS(3525),
    [anon_sym_goto] = ACTIONS(3525),
    [anon_sym___try] = ACTIONS(3525),
    [anon_sym___leave] = ACTIONS(3525),
    [anon_sym_not] = ACTIONS(3525),
    [anon_sym_compl] = ACTIONS(3525),
    [anon_sym_DASH_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_PLUS] = ACTIONS(3527),
    [anon_sym_sizeof] = ACTIONS(3525),
    [anon_sym___alignof__] = ACTIONS(3525),
    [anon_sym___alignof] = ACTIONS(3525),
    [anon_sym__alignof] = ACTIONS(3525),
    [anon_sym_alignof] = ACTIONS(3525),
    [anon_sym__Alignof] = ACTIONS(3525),
    [anon_sym_offsetof] = ACTIONS(3525),
    [anon_sym__Generic] = ACTIONS(3525),
    [anon_sym_asm] = ACTIONS(3525),
    [anon_sym___asm__] = ACTIONS(3525),
    [sym_number_literal] = ACTIONS(3527),
    [anon_sym_L_SQUOTE] = ACTIONS(3527),
    [anon_sym_u_SQUOTE] = ACTIONS(3527),
    [anon_sym_U_SQUOTE] = ACTIONS(3527),
    [anon_sym_u8_SQUOTE] = ACTIONS(3527),
    [anon_sym_SQUOTE] = ACTIONS(3527),
    [anon_sym_L_DQUOTE] = ACTIONS(3527),
    [anon_sym_u_DQUOTE] = ACTIONS(3527),
    [anon_sym_U_DQUOTE] = ACTIONS(3527),
    [anon_sym_u8_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [sym_true] = ACTIONS(3525),
    [sym_false] = ACTIONS(3525),
    [anon_sym_NULL] = ACTIONS(3525),
    [anon_sym_nullptr] = ACTIONS(3525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3525),
    [anon_sym_let] = ACTIONS(3525),
    [anon_sym_This] = ACTIONS(3525),
    [anon_sym_decltype] = ACTIONS(3525),
    [sym_virtual] = ACTIONS(3525),
    [anon_sym_explicit] = ACTIONS(3525),
    [anon_sym_typename] = ACTIONS(3525),
    [anon_sym_template] = ACTIONS(3525),
    [anon_sym_operator] = ACTIONS(3525),
    [anon_sym_try] = ACTIONS(3525),
    [anon_sym_delete] = ACTIONS(3525),
    [anon_sym_throw] = ACTIONS(3525),
    [anon_sym_namespace] = ACTIONS(3525),
    [anon_sym_using] = ACTIONS(3525),
    [anon_sym_static_assert] = ACTIONS(3525),
    [anon_sym_concept] = ACTIONS(3525),
    [anon_sym_co_return] = ACTIONS(3525),
    [anon_sym_co_yield] = ACTIONS(3525),
    [anon_sym_R_DQUOTE] = ACTIONS(3527),
    [anon_sym_LR_DQUOTE] = ACTIONS(3527),
    [anon_sym_uR_DQUOTE] = ACTIONS(3527),
    [anon_sym_UR_DQUOTE] = ACTIONS(3527),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3527),
    [anon_sym_co_await] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3525),
    [anon_sym_requires] = ACTIONS(3525),
    [sym_this] = ACTIONS(3525),
    [anon_sym_discard] = ACTIONS(3525),
    [anon_sym_precise] = ACTIONS(3525),
    [anon_sym_shared] = ACTIONS(3525),
    [anon_sym_groupshared] = ACTIONS(3525),
    [anon_sym_uniform] = ACTIONS(3525),
    [anon_sym_row_major] = ACTIONS(3525),
    [anon_sym_column_major] = ACTIONS(3525),
    [anon_sym_globallycoherent] = ACTIONS(3525),
    [anon_sym_centroid] = ACTIONS(3525),
    [anon_sym_noperspective] = ACTIONS(3525),
    [anon_sym_nointerpolation] = ACTIONS(3525),
    [anon_sym_sample] = ACTIONS(3525),
    [anon_sym_linear] = ACTIONS(3525),
    [anon_sym_snorm] = ACTIONS(3525),
    [anon_sym_unorm] = ACTIONS(3525),
    [anon_sym_point] = ACTIONS(3525),
    [anon_sym_line] = ACTIONS(3525),
    [anon_sym_triangleadj] = ACTIONS(3525),
    [anon_sym_lineadj] = ACTIONS(3525),
    [anon_sym_triangle] = ACTIONS(3525),
    [anon_sym_cbuffer] = ACTIONS(3525),
    [anon_sym_interface] = ACTIONS(3525),
    [anon_sym_extension] = ACTIONS(3525),
  },
  [941] = {
    [sym_identifier] = ACTIONS(3521),
    [aux_sym_preproc_include_token1] = ACTIONS(3521),
    [aux_sym_preproc_def_token1] = ACTIONS(3521),
    [aux_sym_preproc_if_token1] = ACTIONS(3521),
    [aux_sym_preproc_if_token2] = ACTIONS(3521),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3521),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3521),
    [sym_preproc_directive] = ACTIONS(3521),
    [anon_sym_LPAREN2] = ACTIONS(3523),
    [anon_sym_BANG] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3521),
    [anon_sym_PLUS] = ACTIONS(3521),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3521),
    [anon_sym_SEMI] = ACTIONS(3523),
    [anon_sym___extension__] = ACTIONS(3521),
    [anon_sym_typedef] = ACTIONS(3521),
    [anon_sym_in] = ACTIONS(3521),
    [anon_sym_out] = ACTIONS(3521),
    [anon_sym_inout] = ACTIONS(3521),
    [anon_sym_extern] = ACTIONS(3521),
    [anon_sym___attribute__] = ACTIONS(3521),
    [anon_sym_COLON_COLON] = ACTIONS(3523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3523),
    [anon_sym___declspec] = ACTIONS(3521),
    [anon_sym___based] = ACTIONS(3521),
    [anon_sym___cdecl] = ACTIONS(3521),
    [anon_sym___clrcall] = ACTIONS(3521),
    [anon_sym___stdcall] = ACTIONS(3521),
    [anon_sym___fastcall] = ACTIONS(3521),
    [anon_sym___thiscall] = ACTIONS(3521),
    [anon_sym___vectorcall] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_signed] = ACTIONS(3521),
    [anon_sym_unsigned] = ACTIONS(3521),
    [anon_sym_long] = ACTIONS(3521),
    [anon_sym_short] = ACTIONS(3521),
    [anon_sym_LBRACK] = ACTIONS(3521),
    [anon_sym_static] = ACTIONS(3521),
    [anon_sym_register] = ACTIONS(3521),
    [anon_sym_inline] = ACTIONS(3521),
    [anon_sym___inline] = ACTIONS(3521),
    [anon_sym___inline__] = ACTIONS(3521),
    [anon_sym___forceinline] = ACTIONS(3521),
    [anon_sym_thread_local] = ACTIONS(3521),
    [anon_sym___thread] = ACTIONS(3521),
    [anon_sym_const] = ACTIONS(3521),
    [anon_sym_constexpr] = ACTIONS(3521),
    [anon_sym_volatile] = ACTIONS(3521),
    [anon_sym_restrict] = ACTIONS(3521),
    [anon_sym___restrict__] = ACTIONS(3521),
    [anon_sym__Atomic] = ACTIONS(3521),
    [anon_sym__Noreturn] = ACTIONS(3521),
    [anon_sym_noreturn] = ACTIONS(3521),
    [anon_sym_mutable] = ACTIONS(3521),
    [anon_sym_constinit] = ACTIONS(3521),
    [anon_sym_consteval] = ACTIONS(3521),
    [anon_sym_alignas] = ACTIONS(3521),
    [anon_sym__Alignas] = ACTIONS(3521),
    [sym_primitive_type] = ACTIONS(3521),
    [anon_sym_enum] = ACTIONS(3521),
    [anon_sym_class] = ACTIONS(3521),
    [anon_sym_struct] = ACTIONS(3521),
    [anon_sym_union] = ACTIONS(3521),
    [anon_sym_if] = ACTIONS(3521),
    [anon_sym_switch] = ACTIONS(3521),
    [anon_sym_case] = ACTIONS(3521),
    [anon_sym_default] = ACTIONS(3521),
    [anon_sym_while] = ACTIONS(3521),
    [anon_sym_do] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3521),
    [anon_sym_return] = ACTIONS(3521),
    [anon_sym_break] = ACTIONS(3521),
    [anon_sym_continue] = ACTIONS(3521),
    [anon_sym_goto] = ACTIONS(3521),
    [anon_sym___try] = ACTIONS(3521),
    [anon_sym___leave] = ACTIONS(3521),
    [anon_sym_not] = ACTIONS(3521),
    [anon_sym_compl] = ACTIONS(3521),
    [anon_sym_DASH_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_PLUS] = ACTIONS(3523),
    [anon_sym_sizeof] = ACTIONS(3521),
    [anon_sym___alignof__] = ACTIONS(3521),
    [anon_sym___alignof] = ACTIONS(3521),
    [anon_sym__alignof] = ACTIONS(3521),
    [anon_sym_alignof] = ACTIONS(3521),
    [anon_sym__Alignof] = ACTIONS(3521),
    [anon_sym_offsetof] = ACTIONS(3521),
    [anon_sym__Generic] = ACTIONS(3521),
    [anon_sym_asm] = ACTIONS(3521),
    [anon_sym___asm__] = ACTIONS(3521),
    [sym_number_literal] = ACTIONS(3523),
    [anon_sym_L_SQUOTE] = ACTIONS(3523),
    [anon_sym_u_SQUOTE] = ACTIONS(3523),
    [anon_sym_U_SQUOTE] = ACTIONS(3523),
    [anon_sym_u8_SQUOTE] = ACTIONS(3523),
    [anon_sym_SQUOTE] = ACTIONS(3523),
    [anon_sym_L_DQUOTE] = ACTIONS(3523),
    [anon_sym_u_DQUOTE] = ACTIONS(3523),
    [anon_sym_U_DQUOTE] = ACTIONS(3523),
    [anon_sym_u8_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [sym_true] = ACTIONS(3521),
    [sym_false] = ACTIONS(3521),
    [anon_sym_NULL] = ACTIONS(3521),
    [anon_sym_nullptr] = ACTIONS(3521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3521),
    [anon_sym_let] = ACTIONS(3521),
    [anon_sym_This] = ACTIONS(3521),
    [anon_sym_decltype] = ACTIONS(3521),
    [sym_virtual] = ACTIONS(3521),
    [anon_sym_explicit] = ACTIONS(3521),
    [anon_sym_typename] = ACTIONS(3521),
    [anon_sym_template] = ACTIONS(3521),
    [anon_sym_operator] = ACTIONS(3521),
    [anon_sym_try] = ACTIONS(3521),
    [anon_sym_delete] = ACTIONS(3521),
    [anon_sym_throw] = ACTIONS(3521),
    [anon_sym_namespace] = ACTIONS(3521),
    [anon_sym_using] = ACTIONS(3521),
    [anon_sym_static_assert] = ACTIONS(3521),
    [anon_sym_concept] = ACTIONS(3521),
    [anon_sym_co_return] = ACTIONS(3521),
    [anon_sym_co_yield] = ACTIONS(3521),
    [anon_sym_R_DQUOTE] = ACTIONS(3523),
    [anon_sym_LR_DQUOTE] = ACTIONS(3523),
    [anon_sym_uR_DQUOTE] = ACTIONS(3523),
    [anon_sym_UR_DQUOTE] = ACTIONS(3523),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3523),
    [anon_sym_co_await] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3521),
    [anon_sym_requires] = ACTIONS(3521),
    [sym_this] = ACTIONS(3521),
    [anon_sym_discard] = ACTIONS(3521),
    [anon_sym_precise] = ACTIONS(3521),
    [anon_sym_shared] = ACTIONS(3521),
    [anon_sym_groupshared] = ACTIONS(3521),
    [anon_sym_uniform] = ACTIONS(3521),
    [anon_sym_row_major] = ACTIONS(3521),
    [anon_sym_column_major] = ACTIONS(3521),
    [anon_sym_globallycoherent] = ACTIONS(3521),
    [anon_sym_centroid] = ACTIONS(3521),
    [anon_sym_noperspective] = ACTIONS(3521),
    [anon_sym_nointerpolation] = ACTIONS(3521),
    [anon_sym_sample] = ACTIONS(3521),
    [anon_sym_linear] = ACTIONS(3521),
    [anon_sym_snorm] = ACTIONS(3521),
    [anon_sym_unorm] = ACTIONS(3521),
    [anon_sym_point] = ACTIONS(3521),
    [anon_sym_line] = ACTIONS(3521),
    [anon_sym_triangleadj] = ACTIONS(3521),
    [anon_sym_lineadj] = ACTIONS(3521),
    [anon_sym_triangle] = ACTIONS(3521),
    [anon_sym_cbuffer] = ACTIONS(3521),
    [anon_sym_interface] = ACTIONS(3521),
    [anon_sym_extension] = ACTIONS(3521),
  },
  [942] = {
    [sym_identifier] = ACTIONS(3555),
    [aux_sym_preproc_include_token1] = ACTIONS(3555),
    [aux_sym_preproc_def_token1] = ACTIONS(3555),
    [aux_sym_preproc_if_token1] = ACTIONS(3555),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3555),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3555),
    [sym_preproc_directive] = ACTIONS(3555),
    [anon_sym_LPAREN2] = ACTIONS(3557),
    [anon_sym_BANG] = ACTIONS(3557),
    [anon_sym_TILDE] = ACTIONS(3557),
    [anon_sym_DASH] = ACTIONS(3555),
    [anon_sym_PLUS] = ACTIONS(3555),
    [anon_sym_STAR] = ACTIONS(3557),
    [anon_sym_AMP_AMP] = ACTIONS(3557),
    [anon_sym_AMP] = ACTIONS(3555),
    [anon_sym_SEMI] = ACTIONS(3557),
    [anon_sym___extension__] = ACTIONS(3555),
    [anon_sym_typedef] = ACTIONS(3555),
    [anon_sym_in] = ACTIONS(3555),
    [anon_sym_out] = ACTIONS(3555),
    [anon_sym_inout] = ACTIONS(3555),
    [anon_sym_extern] = ACTIONS(3555),
    [anon_sym___attribute__] = ACTIONS(3555),
    [anon_sym_COLON_COLON] = ACTIONS(3557),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3557),
    [anon_sym___declspec] = ACTIONS(3555),
    [anon_sym___based] = ACTIONS(3555),
    [anon_sym___cdecl] = ACTIONS(3555),
    [anon_sym___clrcall] = ACTIONS(3555),
    [anon_sym___stdcall] = ACTIONS(3555),
    [anon_sym___fastcall] = ACTIONS(3555),
    [anon_sym___thiscall] = ACTIONS(3555),
    [anon_sym___vectorcall] = ACTIONS(3555),
    [anon_sym_LBRACE] = ACTIONS(3557),
    [anon_sym_RBRACE] = ACTIONS(3557),
    [anon_sym_signed] = ACTIONS(3555),
    [anon_sym_unsigned] = ACTIONS(3555),
    [anon_sym_long] = ACTIONS(3555),
    [anon_sym_short] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3555),
    [anon_sym_static] = ACTIONS(3555),
    [anon_sym_register] = ACTIONS(3555),
    [anon_sym_inline] = ACTIONS(3555),
    [anon_sym___inline] = ACTIONS(3555),
    [anon_sym___inline__] = ACTIONS(3555),
    [anon_sym___forceinline] = ACTIONS(3555),
    [anon_sym_thread_local] = ACTIONS(3555),
    [anon_sym___thread] = ACTIONS(3555),
    [anon_sym_const] = ACTIONS(3555),
    [anon_sym_constexpr] = ACTIONS(3555),
    [anon_sym_volatile] = ACTIONS(3555),
    [anon_sym_restrict] = ACTIONS(3555),
    [anon_sym___restrict__] = ACTIONS(3555),
    [anon_sym__Atomic] = ACTIONS(3555),
    [anon_sym__Noreturn] = ACTIONS(3555),
    [anon_sym_noreturn] = ACTIONS(3555),
    [anon_sym_mutable] = ACTIONS(3555),
    [anon_sym_constinit] = ACTIONS(3555),
    [anon_sym_consteval] = ACTIONS(3555),
    [anon_sym_alignas] = ACTIONS(3555),
    [anon_sym__Alignas] = ACTIONS(3555),
    [sym_primitive_type] = ACTIONS(3555),
    [anon_sym_enum] = ACTIONS(3555),
    [anon_sym_class] = ACTIONS(3555),
    [anon_sym_struct] = ACTIONS(3555),
    [anon_sym_union] = ACTIONS(3555),
    [anon_sym_if] = ACTIONS(3555),
    [anon_sym_switch] = ACTIONS(3555),
    [anon_sym_case] = ACTIONS(3555),
    [anon_sym_default] = ACTIONS(3555),
    [anon_sym_while] = ACTIONS(3555),
    [anon_sym_do] = ACTIONS(3555),
    [anon_sym_for] = ACTIONS(3555),
    [anon_sym_return] = ACTIONS(3555),
    [anon_sym_break] = ACTIONS(3555),
    [anon_sym_continue] = ACTIONS(3555),
    [anon_sym_goto] = ACTIONS(3555),
    [anon_sym___try] = ACTIONS(3555),
    [anon_sym___leave] = ACTIONS(3555),
    [anon_sym_not] = ACTIONS(3555),
    [anon_sym_compl] = ACTIONS(3555),
    [anon_sym_DASH_DASH] = ACTIONS(3557),
    [anon_sym_PLUS_PLUS] = ACTIONS(3557),
    [anon_sym_sizeof] = ACTIONS(3555),
    [anon_sym___alignof__] = ACTIONS(3555),
    [anon_sym___alignof] = ACTIONS(3555),
    [anon_sym__alignof] = ACTIONS(3555),
    [anon_sym_alignof] = ACTIONS(3555),
    [anon_sym__Alignof] = ACTIONS(3555),
    [anon_sym_offsetof] = ACTIONS(3555),
    [anon_sym__Generic] = ACTIONS(3555),
    [anon_sym_asm] = ACTIONS(3555),
    [anon_sym___asm__] = ACTIONS(3555),
    [sym_number_literal] = ACTIONS(3557),
    [anon_sym_L_SQUOTE] = ACTIONS(3557),
    [anon_sym_u_SQUOTE] = ACTIONS(3557),
    [anon_sym_U_SQUOTE] = ACTIONS(3557),
    [anon_sym_u8_SQUOTE] = ACTIONS(3557),
    [anon_sym_SQUOTE] = ACTIONS(3557),
    [anon_sym_L_DQUOTE] = ACTIONS(3557),
    [anon_sym_u_DQUOTE] = ACTIONS(3557),
    [anon_sym_U_DQUOTE] = ACTIONS(3557),
    [anon_sym_u8_DQUOTE] = ACTIONS(3557),
    [anon_sym_DQUOTE] = ACTIONS(3557),
    [sym_true] = ACTIONS(3555),
    [sym_false] = ACTIONS(3555),
    [anon_sym_NULL] = ACTIONS(3555),
    [anon_sym_nullptr] = ACTIONS(3555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3555),
    [anon_sym_let] = ACTIONS(3555),
    [anon_sym_This] = ACTIONS(3555),
    [anon_sym_decltype] = ACTIONS(3555),
    [sym_virtual] = ACTIONS(3555),
    [anon_sym_explicit] = ACTIONS(3555),
    [anon_sym_typename] = ACTIONS(3555),
    [anon_sym_template] = ACTIONS(3555),
    [anon_sym_operator] = ACTIONS(3555),
    [anon_sym_try] = ACTIONS(3555),
    [anon_sym_delete] = ACTIONS(3555),
    [anon_sym_throw] = ACTIONS(3555),
    [anon_sym_namespace] = ACTIONS(3555),
    [anon_sym_using] = ACTIONS(3555),
    [anon_sym_static_assert] = ACTIONS(3555),
    [anon_sym_concept] = ACTIONS(3555),
    [anon_sym_co_return] = ACTIONS(3555),
    [anon_sym_co_yield] = ACTIONS(3555),
    [anon_sym_R_DQUOTE] = ACTIONS(3557),
    [anon_sym_LR_DQUOTE] = ACTIONS(3557),
    [anon_sym_uR_DQUOTE] = ACTIONS(3557),
    [anon_sym_UR_DQUOTE] = ACTIONS(3557),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3557),
    [anon_sym_co_await] = ACTIONS(3555),
    [anon_sym_new] = ACTIONS(3555),
    [anon_sym_requires] = ACTIONS(3555),
    [sym_this] = ACTIONS(3555),
    [anon_sym_discard] = ACTIONS(3555),
    [anon_sym_precise] = ACTIONS(3555),
    [anon_sym_shared] = ACTIONS(3555),
    [anon_sym_groupshared] = ACTIONS(3555),
    [anon_sym_uniform] = ACTIONS(3555),
    [anon_sym_row_major] = ACTIONS(3555),
    [anon_sym_column_major] = ACTIONS(3555),
    [anon_sym_globallycoherent] = ACTIONS(3555),
    [anon_sym_centroid] = ACTIONS(3555),
    [anon_sym_noperspective] = ACTIONS(3555),
    [anon_sym_nointerpolation] = ACTIONS(3555),
    [anon_sym_sample] = ACTIONS(3555),
    [anon_sym_linear] = ACTIONS(3555),
    [anon_sym_snorm] = ACTIONS(3555),
    [anon_sym_unorm] = ACTIONS(3555),
    [anon_sym_point] = ACTIONS(3555),
    [anon_sym_line] = ACTIONS(3555),
    [anon_sym_triangleadj] = ACTIONS(3555),
    [anon_sym_lineadj] = ACTIONS(3555),
    [anon_sym_triangle] = ACTIONS(3555),
    [anon_sym_cbuffer] = ACTIONS(3555),
    [anon_sym_interface] = ACTIONS(3555),
    [anon_sym_extension] = ACTIONS(3555),
  },
  [943] = {
    [sym_identifier] = ACTIONS(3459),
    [aux_sym_preproc_include_token1] = ACTIONS(3459),
    [aux_sym_preproc_def_token1] = ACTIONS(3459),
    [aux_sym_preproc_if_token1] = ACTIONS(3459),
    [aux_sym_preproc_if_token2] = ACTIONS(3459),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3459),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3459),
    [sym_preproc_directive] = ACTIONS(3459),
    [anon_sym_LPAREN2] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_TILDE] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3459),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3459),
    [anon_sym_SEMI] = ACTIONS(3461),
    [anon_sym___extension__] = ACTIONS(3459),
    [anon_sym_typedef] = ACTIONS(3459),
    [anon_sym_in] = ACTIONS(3459),
    [anon_sym_out] = ACTIONS(3459),
    [anon_sym_inout] = ACTIONS(3459),
    [anon_sym_extern] = ACTIONS(3459),
    [anon_sym___attribute__] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3461),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3461),
    [anon_sym___declspec] = ACTIONS(3459),
    [anon_sym___based] = ACTIONS(3459),
    [anon_sym___cdecl] = ACTIONS(3459),
    [anon_sym___clrcall] = ACTIONS(3459),
    [anon_sym___stdcall] = ACTIONS(3459),
    [anon_sym___fastcall] = ACTIONS(3459),
    [anon_sym___thiscall] = ACTIONS(3459),
    [anon_sym___vectorcall] = ACTIONS(3459),
    [anon_sym_LBRACE] = ACTIONS(3461),
    [anon_sym_signed] = ACTIONS(3459),
    [anon_sym_unsigned] = ACTIONS(3459),
    [anon_sym_long] = ACTIONS(3459),
    [anon_sym_short] = ACTIONS(3459),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_static] = ACTIONS(3459),
    [anon_sym_register] = ACTIONS(3459),
    [anon_sym_inline] = ACTIONS(3459),
    [anon_sym___inline] = ACTIONS(3459),
    [anon_sym___inline__] = ACTIONS(3459),
    [anon_sym___forceinline] = ACTIONS(3459),
    [anon_sym_thread_local] = ACTIONS(3459),
    [anon_sym___thread] = ACTIONS(3459),
    [anon_sym_const] = ACTIONS(3459),
    [anon_sym_constexpr] = ACTIONS(3459),
    [anon_sym_volatile] = ACTIONS(3459),
    [anon_sym_restrict] = ACTIONS(3459),
    [anon_sym___restrict__] = ACTIONS(3459),
    [anon_sym__Atomic] = ACTIONS(3459),
    [anon_sym__Noreturn] = ACTIONS(3459),
    [anon_sym_noreturn] = ACTIONS(3459),
    [anon_sym_mutable] = ACTIONS(3459),
    [anon_sym_constinit] = ACTIONS(3459),
    [anon_sym_consteval] = ACTIONS(3459),
    [anon_sym_alignas] = ACTIONS(3459),
    [anon_sym__Alignas] = ACTIONS(3459),
    [sym_primitive_type] = ACTIONS(3459),
    [anon_sym_enum] = ACTIONS(3459),
    [anon_sym_class] = ACTIONS(3459),
    [anon_sym_struct] = ACTIONS(3459),
    [anon_sym_union] = ACTIONS(3459),
    [anon_sym_if] = ACTIONS(3459),
    [anon_sym_switch] = ACTIONS(3459),
    [anon_sym_case] = ACTIONS(3459),
    [anon_sym_default] = ACTIONS(3459),
    [anon_sym_while] = ACTIONS(3459),
    [anon_sym_do] = ACTIONS(3459),
    [anon_sym_for] = ACTIONS(3459),
    [anon_sym_return] = ACTIONS(3459),
    [anon_sym_break] = ACTIONS(3459),
    [anon_sym_continue] = ACTIONS(3459),
    [anon_sym_goto] = ACTIONS(3459),
    [anon_sym___try] = ACTIONS(3459),
    [anon_sym___leave] = ACTIONS(3459),
    [anon_sym_not] = ACTIONS(3459),
    [anon_sym_compl] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3461),
    [anon_sym_sizeof] = ACTIONS(3459),
    [anon_sym___alignof__] = ACTIONS(3459),
    [anon_sym___alignof] = ACTIONS(3459),
    [anon_sym__alignof] = ACTIONS(3459),
    [anon_sym_alignof] = ACTIONS(3459),
    [anon_sym__Alignof] = ACTIONS(3459),
    [anon_sym_offsetof] = ACTIONS(3459),
    [anon_sym__Generic] = ACTIONS(3459),
    [anon_sym_asm] = ACTIONS(3459),
    [anon_sym___asm__] = ACTIONS(3459),
    [sym_number_literal] = ACTIONS(3461),
    [anon_sym_L_SQUOTE] = ACTIONS(3461),
    [anon_sym_u_SQUOTE] = ACTIONS(3461),
    [anon_sym_U_SQUOTE] = ACTIONS(3461),
    [anon_sym_u8_SQUOTE] = ACTIONS(3461),
    [anon_sym_SQUOTE] = ACTIONS(3461),
    [anon_sym_L_DQUOTE] = ACTIONS(3461),
    [anon_sym_u_DQUOTE] = ACTIONS(3461),
    [anon_sym_U_DQUOTE] = ACTIONS(3461),
    [anon_sym_u8_DQUOTE] = ACTIONS(3461),
    [anon_sym_DQUOTE] = ACTIONS(3461),
    [sym_true] = ACTIONS(3459),
    [sym_false] = ACTIONS(3459),
    [anon_sym_NULL] = ACTIONS(3459),
    [anon_sym_nullptr] = ACTIONS(3459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3459),
    [anon_sym_let] = ACTIONS(3459),
    [anon_sym_This] = ACTIONS(3459),
    [anon_sym_decltype] = ACTIONS(3459),
    [sym_virtual] = ACTIONS(3459),
    [anon_sym_explicit] = ACTIONS(3459),
    [anon_sym_typename] = ACTIONS(3459),
    [anon_sym_template] = ACTIONS(3459),
    [anon_sym_operator] = ACTIONS(3459),
    [anon_sym_try] = ACTIONS(3459),
    [anon_sym_delete] = ACTIONS(3459),
    [anon_sym_throw] = ACTIONS(3459),
    [anon_sym_namespace] = ACTIONS(3459),
    [anon_sym_using] = ACTIONS(3459),
    [anon_sym_static_assert] = ACTIONS(3459),
    [anon_sym_concept] = ACTIONS(3459),
    [anon_sym_co_return] = ACTIONS(3459),
    [anon_sym_co_yield] = ACTIONS(3459),
    [anon_sym_R_DQUOTE] = ACTIONS(3461),
    [anon_sym_LR_DQUOTE] = ACTIONS(3461),
    [anon_sym_uR_DQUOTE] = ACTIONS(3461),
    [anon_sym_UR_DQUOTE] = ACTIONS(3461),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3461),
    [anon_sym_co_await] = ACTIONS(3459),
    [anon_sym_new] = ACTIONS(3459),
    [anon_sym_requires] = ACTIONS(3459),
    [sym_this] = ACTIONS(3459),
    [anon_sym_discard] = ACTIONS(3459),
    [anon_sym_precise] = ACTIONS(3459),
    [anon_sym_shared] = ACTIONS(3459),
    [anon_sym_groupshared] = ACTIONS(3459),
    [anon_sym_uniform] = ACTIONS(3459),
    [anon_sym_row_major] = ACTIONS(3459),
    [anon_sym_column_major] = ACTIONS(3459),
    [anon_sym_globallycoherent] = ACTIONS(3459),
    [anon_sym_centroid] = ACTIONS(3459),
    [anon_sym_noperspective] = ACTIONS(3459),
    [anon_sym_nointerpolation] = ACTIONS(3459),
    [anon_sym_sample] = ACTIONS(3459),
    [anon_sym_linear] = ACTIONS(3459),
    [anon_sym_snorm] = ACTIONS(3459),
    [anon_sym_unorm] = ACTIONS(3459),
    [anon_sym_point] = ACTIONS(3459),
    [anon_sym_line] = ACTIONS(3459),
    [anon_sym_triangleadj] = ACTIONS(3459),
    [anon_sym_lineadj] = ACTIONS(3459),
    [anon_sym_triangle] = ACTIONS(3459),
    [anon_sym_cbuffer] = ACTIONS(3459),
    [anon_sym_interface] = ACTIONS(3459),
    [anon_sym_extension] = ACTIONS(3459),
  },
  [944] = {
    [sym_identifier] = ACTIONS(3455),
    [aux_sym_preproc_include_token1] = ACTIONS(3455),
    [aux_sym_preproc_def_token1] = ACTIONS(3455),
    [aux_sym_preproc_if_token1] = ACTIONS(3455),
    [aux_sym_preproc_if_token2] = ACTIONS(3455),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3455),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3455),
    [sym_preproc_directive] = ACTIONS(3455),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_BANG] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3457),
    [anon_sym_DASH] = ACTIONS(3455),
    [anon_sym_PLUS] = ACTIONS(3455),
    [anon_sym_STAR] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3457),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym_SEMI] = ACTIONS(3457),
    [anon_sym___extension__] = ACTIONS(3455),
    [anon_sym_typedef] = ACTIONS(3455),
    [anon_sym_in] = ACTIONS(3455),
    [anon_sym_out] = ACTIONS(3455),
    [anon_sym_inout] = ACTIONS(3455),
    [anon_sym_extern] = ACTIONS(3455),
    [anon_sym___attribute__] = ACTIONS(3455),
    [anon_sym_COLON_COLON] = ACTIONS(3457),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3457),
    [anon_sym___declspec] = ACTIONS(3455),
    [anon_sym___based] = ACTIONS(3455),
    [anon_sym___cdecl] = ACTIONS(3455),
    [anon_sym___clrcall] = ACTIONS(3455),
    [anon_sym___stdcall] = ACTIONS(3455),
    [anon_sym___fastcall] = ACTIONS(3455),
    [anon_sym___thiscall] = ACTIONS(3455),
    [anon_sym___vectorcall] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_signed] = ACTIONS(3455),
    [anon_sym_unsigned] = ACTIONS(3455),
    [anon_sym_long] = ACTIONS(3455),
    [anon_sym_short] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_static] = ACTIONS(3455),
    [anon_sym_register] = ACTIONS(3455),
    [anon_sym_inline] = ACTIONS(3455),
    [anon_sym___inline] = ACTIONS(3455),
    [anon_sym___inline__] = ACTIONS(3455),
    [anon_sym___forceinline] = ACTIONS(3455),
    [anon_sym_thread_local] = ACTIONS(3455),
    [anon_sym___thread] = ACTIONS(3455),
    [anon_sym_const] = ACTIONS(3455),
    [anon_sym_constexpr] = ACTIONS(3455),
    [anon_sym_volatile] = ACTIONS(3455),
    [anon_sym_restrict] = ACTIONS(3455),
    [anon_sym___restrict__] = ACTIONS(3455),
    [anon_sym__Atomic] = ACTIONS(3455),
    [anon_sym__Noreturn] = ACTIONS(3455),
    [anon_sym_noreturn] = ACTIONS(3455),
    [anon_sym_mutable] = ACTIONS(3455),
    [anon_sym_constinit] = ACTIONS(3455),
    [anon_sym_consteval] = ACTIONS(3455),
    [anon_sym_alignas] = ACTIONS(3455),
    [anon_sym__Alignas] = ACTIONS(3455),
    [sym_primitive_type] = ACTIONS(3455),
    [anon_sym_enum] = ACTIONS(3455),
    [anon_sym_class] = ACTIONS(3455),
    [anon_sym_struct] = ACTIONS(3455),
    [anon_sym_union] = ACTIONS(3455),
    [anon_sym_if] = ACTIONS(3455),
    [anon_sym_switch] = ACTIONS(3455),
    [anon_sym_case] = ACTIONS(3455),
    [anon_sym_default] = ACTIONS(3455),
    [anon_sym_while] = ACTIONS(3455),
    [anon_sym_do] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3455),
    [anon_sym_return] = ACTIONS(3455),
    [anon_sym_break] = ACTIONS(3455),
    [anon_sym_continue] = ACTIONS(3455),
    [anon_sym_goto] = ACTIONS(3455),
    [anon_sym___try] = ACTIONS(3455),
    [anon_sym___leave] = ACTIONS(3455),
    [anon_sym_not] = ACTIONS(3455),
    [anon_sym_compl] = ACTIONS(3455),
    [anon_sym_DASH_DASH] = ACTIONS(3457),
    [anon_sym_PLUS_PLUS] = ACTIONS(3457),
    [anon_sym_sizeof] = ACTIONS(3455),
    [anon_sym___alignof__] = ACTIONS(3455),
    [anon_sym___alignof] = ACTIONS(3455),
    [anon_sym__alignof] = ACTIONS(3455),
    [anon_sym_alignof] = ACTIONS(3455),
    [anon_sym__Alignof] = ACTIONS(3455),
    [anon_sym_offsetof] = ACTIONS(3455),
    [anon_sym__Generic] = ACTIONS(3455),
    [anon_sym_asm] = ACTIONS(3455),
    [anon_sym___asm__] = ACTIONS(3455),
    [sym_number_literal] = ACTIONS(3457),
    [anon_sym_L_SQUOTE] = ACTIONS(3457),
    [anon_sym_u_SQUOTE] = ACTIONS(3457),
    [anon_sym_U_SQUOTE] = ACTIONS(3457),
    [anon_sym_u8_SQUOTE] = ACTIONS(3457),
    [anon_sym_SQUOTE] = ACTIONS(3457),
    [anon_sym_L_DQUOTE] = ACTIONS(3457),
    [anon_sym_u_DQUOTE] = ACTIONS(3457),
    [anon_sym_U_DQUOTE] = ACTIONS(3457),
    [anon_sym_u8_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [sym_true] = ACTIONS(3455),
    [sym_false] = ACTIONS(3455),
    [anon_sym_NULL] = ACTIONS(3455),
    [anon_sym_nullptr] = ACTIONS(3455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3455),
    [anon_sym_let] = ACTIONS(3455),
    [anon_sym_This] = ACTIONS(3455),
    [anon_sym_decltype] = ACTIONS(3455),
    [sym_virtual] = ACTIONS(3455),
    [anon_sym_explicit] = ACTIONS(3455),
    [anon_sym_typename] = ACTIONS(3455),
    [anon_sym_template] = ACTIONS(3455),
    [anon_sym_operator] = ACTIONS(3455),
    [anon_sym_try] = ACTIONS(3455),
    [anon_sym_delete] = ACTIONS(3455),
    [anon_sym_throw] = ACTIONS(3455),
    [anon_sym_namespace] = ACTIONS(3455),
    [anon_sym_using] = ACTIONS(3455),
    [anon_sym_static_assert] = ACTIONS(3455),
    [anon_sym_concept] = ACTIONS(3455),
    [anon_sym_co_return] = ACTIONS(3455),
    [anon_sym_co_yield] = ACTIONS(3455),
    [anon_sym_R_DQUOTE] = ACTIONS(3457),
    [anon_sym_LR_DQUOTE] = ACTIONS(3457),
    [anon_sym_uR_DQUOTE] = ACTIONS(3457),
    [anon_sym_UR_DQUOTE] = ACTIONS(3457),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3457),
    [anon_sym_co_await] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_requires] = ACTIONS(3455),
    [sym_this] = ACTIONS(3455),
    [anon_sym_discard] = ACTIONS(3455),
    [anon_sym_precise] = ACTIONS(3455),
    [anon_sym_shared] = ACTIONS(3455),
    [anon_sym_groupshared] = ACTIONS(3455),
    [anon_sym_uniform] = ACTIONS(3455),
    [anon_sym_row_major] = ACTIONS(3455),
    [anon_sym_column_major] = ACTIONS(3455),
    [anon_sym_globallycoherent] = ACTIONS(3455),
    [anon_sym_centroid] = ACTIONS(3455),
    [anon_sym_noperspective] = ACTIONS(3455),
    [anon_sym_nointerpolation] = ACTIONS(3455),
    [anon_sym_sample] = ACTIONS(3455),
    [anon_sym_linear] = ACTIONS(3455),
    [anon_sym_snorm] = ACTIONS(3455),
    [anon_sym_unorm] = ACTIONS(3455),
    [anon_sym_point] = ACTIONS(3455),
    [anon_sym_line] = ACTIONS(3455),
    [anon_sym_triangleadj] = ACTIONS(3455),
    [anon_sym_lineadj] = ACTIONS(3455),
    [anon_sym_triangle] = ACTIONS(3455),
    [anon_sym_cbuffer] = ACTIONS(3455),
    [anon_sym_interface] = ACTIONS(3455),
    [anon_sym_extension] = ACTIONS(3455),
  },
  [945] = {
    [sym_identifier] = ACTIONS(3449),
    [aux_sym_preproc_include_token1] = ACTIONS(3449),
    [aux_sym_preproc_def_token1] = ACTIONS(3449),
    [aux_sym_preproc_if_token1] = ACTIONS(3449),
    [aux_sym_preproc_if_token2] = ACTIONS(3449),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3449),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3449),
    [sym_preproc_directive] = ACTIONS(3449),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_BANG] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3449),
    [anon_sym_PLUS] = ACTIONS(3449),
    [anon_sym_STAR] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_AMP] = ACTIONS(3449),
    [anon_sym_SEMI] = ACTIONS(3451),
    [anon_sym___extension__] = ACTIONS(3449),
    [anon_sym_typedef] = ACTIONS(3449),
    [anon_sym_in] = ACTIONS(3449),
    [anon_sym_out] = ACTIONS(3449),
    [anon_sym_inout] = ACTIONS(3449),
    [anon_sym_extern] = ACTIONS(3449),
    [anon_sym___attribute__] = ACTIONS(3449),
    [anon_sym_COLON_COLON] = ACTIONS(3451),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3451),
    [anon_sym___declspec] = ACTIONS(3449),
    [anon_sym___based] = ACTIONS(3449),
    [anon_sym___cdecl] = ACTIONS(3449),
    [anon_sym___clrcall] = ACTIONS(3449),
    [anon_sym___stdcall] = ACTIONS(3449),
    [anon_sym___fastcall] = ACTIONS(3449),
    [anon_sym___thiscall] = ACTIONS(3449),
    [anon_sym___vectorcall] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_signed] = ACTIONS(3449),
    [anon_sym_unsigned] = ACTIONS(3449),
    [anon_sym_long] = ACTIONS(3449),
    [anon_sym_short] = ACTIONS(3449),
    [anon_sym_LBRACK] = ACTIONS(3449),
    [anon_sym_static] = ACTIONS(3449),
    [anon_sym_register] = ACTIONS(3449),
    [anon_sym_inline] = ACTIONS(3449),
    [anon_sym___inline] = ACTIONS(3449),
    [anon_sym___inline__] = ACTIONS(3449),
    [anon_sym___forceinline] = ACTIONS(3449),
    [anon_sym_thread_local] = ACTIONS(3449),
    [anon_sym___thread] = ACTIONS(3449),
    [anon_sym_const] = ACTIONS(3449),
    [anon_sym_constexpr] = ACTIONS(3449),
    [anon_sym_volatile] = ACTIONS(3449),
    [anon_sym_restrict] = ACTIONS(3449),
    [anon_sym___restrict__] = ACTIONS(3449),
    [anon_sym__Atomic] = ACTIONS(3449),
    [anon_sym__Noreturn] = ACTIONS(3449),
    [anon_sym_noreturn] = ACTIONS(3449),
    [anon_sym_mutable] = ACTIONS(3449),
    [anon_sym_constinit] = ACTIONS(3449),
    [anon_sym_consteval] = ACTIONS(3449),
    [anon_sym_alignas] = ACTIONS(3449),
    [anon_sym__Alignas] = ACTIONS(3449),
    [sym_primitive_type] = ACTIONS(3449),
    [anon_sym_enum] = ACTIONS(3449),
    [anon_sym_class] = ACTIONS(3449),
    [anon_sym_struct] = ACTIONS(3449),
    [anon_sym_union] = ACTIONS(3449),
    [anon_sym_if] = ACTIONS(3449),
    [anon_sym_switch] = ACTIONS(3449),
    [anon_sym_case] = ACTIONS(3449),
    [anon_sym_default] = ACTIONS(3449),
    [anon_sym_while] = ACTIONS(3449),
    [anon_sym_do] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3449),
    [anon_sym_return] = ACTIONS(3449),
    [anon_sym_break] = ACTIONS(3449),
    [anon_sym_continue] = ACTIONS(3449),
    [anon_sym_goto] = ACTIONS(3449),
    [anon_sym___try] = ACTIONS(3449),
    [anon_sym___leave] = ACTIONS(3449),
    [anon_sym_not] = ACTIONS(3449),
    [anon_sym_compl] = ACTIONS(3449),
    [anon_sym_DASH_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_PLUS] = ACTIONS(3451),
    [anon_sym_sizeof] = ACTIONS(3449),
    [anon_sym___alignof__] = ACTIONS(3449),
    [anon_sym___alignof] = ACTIONS(3449),
    [anon_sym__alignof] = ACTIONS(3449),
    [anon_sym_alignof] = ACTIONS(3449),
    [anon_sym__Alignof] = ACTIONS(3449),
    [anon_sym_offsetof] = ACTIONS(3449),
    [anon_sym__Generic] = ACTIONS(3449),
    [anon_sym_asm] = ACTIONS(3449),
    [anon_sym___asm__] = ACTIONS(3449),
    [sym_number_literal] = ACTIONS(3451),
    [anon_sym_L_SQUOTE] = ACTIONS(3451),
    [anon_sym_u_SQUOTE] = ACTIONS(3451),
    [anon_sym_U_SQUOTE] = ACTIONS(3451),
    [anon_sym_u8_SQUOTE] = ACTIONS(3451),
    [anon_sym_SQUOTE] = ACTIONS(3451),
    [anon_sym_L_DQUOTE] = ACTIONS(3451),
    [anon_sym_u_DQUOTE] = ACTIONS(3451),
    [anon_sym_U_DQUOTE] = ACTIONS(3451),
    [anon_sym_u8_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [sym_true] = ACTIONS(3449),
    [sym_false] = ACTIONS(3449),
    [anon_sym_NULL] = ACTIONS(3449),
    [anon_sym_nullptr] = ACTIONS(3449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3449),
    [anon_sym_let] = ACTIONS(3449),
    [anon_sym_This] = ACTIONS(3449),
    [anon_sym_decltype] = ACTIONS(3449),
    [sym_virtual] = ACTIONS(3449),
    [anon_sym_explicit] = ACTIONS(3449),
    [anon_sym_typename] = ACTIONS(3449),
    [anon_sym_template] = ACTIONS(3449),
    [anon_sym_operator] = ACTIONS(3449),
    [anon_sym_try] = ACTIONS(3449),
    [anon_sym_delete] = ACTIONS(3449),
    [anon_sym_throw] = ACTIONS(3449),
    [anon_sym_namespace] = ACTIONS(3449),
    [anon_sym_using] = ACTIONS(3449),
    [anon_sym_static_assert] = ACTIONS(3449),
    [anon_sym_concept] = ACTIONS(3449),
    [anon_sym_co_return] = ACTIONS(3449),
    [anon_sym_co_yield] = ACTIONS(3449),
    [anon_sym_R_DQUOTE] = ACTIONS(3451),
    [anon_sym_LR_DQUOTE] = ACTIONS(3451),
    [anon_sym_uR_DQUOTE] = ACTIONS(3451),
    [anon_sym_UR_DQUOTE] = ACTIONS(3451),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3451),
    [anon_sym_co_await] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3449),
    [anon_sym_requires] = ACTIONS(3449),
    [sym_this] = ACTIONS(3449),
    [anon_sym_discard] = ACTIONS(3449),
    [anon_sym_precise] = ACTIONS(3449),
    [anon_sym_shared] = ACTIONS(3449),
    [anon_sym_groupshared] = ACTIONS(3449),
    [anon_sym_uniform] = ACTIONS(3449),
    [anon_sym_row_major] = ACTIONS(3449),
    [anon_sym_column_major] = ACTIONS(3449),
    [anon_sym_globallycoherent] = ACTIONS(3449),
    [anon_sym_centroid] = ACTIONS(3449),
    [anon_sym_noperspective] = ACTIONS(3449),
    [anon_sym_nointerpolation] = ACTIONS(3449),
    [anon_sym_sample] = ACTIONS(3449),
    [anon_sym_linear] = ACTIONS(3449),
    [anon_sym_snorm] = ACTIONS(3449),
    [anon_sym_unorm] = ACTIONS(3449),
    [anon_sym_point] = ACTIONS(3449),
    [anon_sym_line] = ACTIONS(3449),
    [anon_sym_triangleadj] = ACTIONS(3449),
    [anon_sym_lineadj] = ACTIONS(3449),
    [anon_sym_triangle] = ACTIONS(3449),
    [anon_sym_cbuffer] = ACTIONS(3449),
    [anon_sym_interface] = ACTIONS(3449),
    [anon_sym_extension] = ACTIONS(3449),
  },
  [946] = {
    [sym_identifier] = ACTIONS(3429),
    [aux_sym_preproc_include_token1] = ACTIONS(3429),
    [aux_sym_preproc_def_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token2] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3429),
    [sym_preproc_directive] = ACTIONS(3429),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_BANG] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym_SEMI] = ACTIONS(3431),
    [anon_sym___extension__] = ACTIONS(3429),
    [anon_sym_typedef] = ACTIONS(3429),
    [anon_sym_in] = ACTIONS(3429),
    [anon_sym_out] = ACTIONS(3429),
    [anon_sym_inout] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym___attribute__] = ACTIONS(3429),
    [anon_sym_COLON_COLON] = ACTIONS(3431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3431),
    [anon_sym___declspec] = ACTIONS(3429),
    [anon_sym___based] = ACTIONS(3429),
    [anon_sym___cdecl] = ACTIONS(3429),
    [anon_sym___clrcall] = ACTIONS(3429),
    [anon_sym___stdcall] = ACTIONS(3429),
    [anon_sym___fastcall] = ACTIONS(3429),
    [anon_sym___thiscall] = ACTIONS(3429),
    [anon_sym___vectorcall] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_signed] = ACTIONS(3429),
    [anon_sym_unsigned] = ACTIONS(3429),
    [anon_sym_long] = ACTIONS(3429),
    [anon_sym_short] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_register] = ACTIONS(3429),
    [anon_sym_inline] = ACTIONS(3429),
    [anon_sym___inline] = ACTIONS(3429),
    [anon_sym___inline__] = ACTIONS(3429),
    [anon_sym___forceinline] = ACTIONS(3429),
    [anon_sym_thread_local] = ACTIONS(3429),
    [anon_sym___thread] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_constexpr] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_restrict] = ACTIONS(3429),
    [anon_sym___restrict__] = ACTIONS(3429),
    [anon_sym__Atomic] = ACTIONS(3429),
    [anon_sym__Noreturn] = ACTIONS(3429),
    [anon_sym_noreturn] = ACTIONS(3429),
    [anon_sym_mutable] = ACTIONS(3429),
    [anon_sym_constinit] = ACTIONS(3429),
    [anon_sym_consteval] = ACTIONS(3429),
    [anon_sym_alignas] = ACTIONS(3429),
    [anon_sym__Alignas] = ACTIONS(3429),
    [sym_primitive_type] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [anon_sym_if] = ACTIONS(3429),
    [anon_sym_switch] = ACTIONS(3429),
    [anon_sym_case] = ACTIONS(3429),
    [anon_sym_default] = ACTIONS(3429),
    [anon_sym_while] = ACTIONS(3429),
    [anon_sym_do] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3429),
    [anon_sym_return] = ACTIONS(3429),
    [anon_sym_break] = ACTIONS(3429),
    [anon_sym_continue] = ACTIONS(3429),
    [anon_sym_goto] = ACTIONS(3429),
    [anon_sym___try] = ACTIONS(3429),
    [anon_sym___leave] = ACTIONS(3429),
    [anon_sym_not] = ACTIONS(3429),
    [anon_sym_compl] = ACTIONS(3429),
    [anon_sym_DASH_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(3431),
    [anon_sym_sizeof] = ACTIONS(3429),
    [anon_sym___alignof__] = ACTIONS(3429),
    [anon_sym___alignof] = ACTIONS(3429),
    [anon_sym__alignof] = ACTIONS(3429),
    [anon_sym_alignof] = ACTIONS(3429),
    [anon_sym__Alignof] = ACTIONS(3429),
    [anon_sym_offsetof] = ACTIONS(3429),
    [anon_sym__Generic] = ACTIONS(3429),
    [anon_sym_asm] = ACTIONS(3429),
    [anon_sym___asm__] = ACTIONS(3429),
    [sym_number_literal] = ACTIONS(3431),
    [anon_sym_L_SQUOTE] = ACTIONS(3431),
    [anon_sym_u_SQUOTE] = ACTIONS(3431),
    [anon_sym_U_SQUOTE] = ACTIONS(3431),
    [anon_sym_u8_SQUOTE] = ACTIONS(3431),
    [anon_sym_SQUOTE] = ACTIONS(3431),
    [anon_sym_L_DQUOTE] = ACTIONS(3431),
    [anon_sym_u_DQUOTE] = ACTIONS(3431),
    [anon_sym_U_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [sym_true] = ACTIONS(3429),
    [sym_false] = ACTIONS(3429),
    [anon_sym_NULL] = ACTIONS(3429),
    [anon_sym_nullptr] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_This] = ACTIONS(3429),
    [anon_sym_decltype] = ACTIONS(3429),
    [sym_virtual] = ACTIONS(3429),
    [anon_sym_explicit] = ACTIONS(3429),
    [anon_sym_typename] = ACTIONS(3429),
    [anon_sym_template] = ACTIONS(3429),
    [anon_sym_operator] = ACTIONS(3429),
    [anon_sym_try] = ACTIONS(3429),
    [anon_sym_delete] = ACTIONS(3429),
    [anon_sym_throw] = ACTIONS(3429),
    [anon_sym_namespace] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_static_assert] = ACTIONS(3429),
    [anon_sym_concept] = ACTIONS(3429),
    [anon_sym_co_return] = ACTIONS(3429),
    [anon_sym_co_yield] = ACTIONS(3429),
    [anon_sym_R_DQUOTE] = ACTIONS(3431),
    [anon_sym_LR_DQUOTE] = ACTIONS(3431),
    [anon_sym_uR_DQUOTE] = ACTIONS(3431),
    [anon_sym_UR_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3431),
    [anon_sym_co_await] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3429),
    [anon_sym_requires] = ACTIONS(3429),
    [sym_this] = ACTIONS(3429),
    [anon_sym_discard] = ACTIONS(3429),
    [anon_sym_precise] = ACTIONS(3429),
    [anon_sym_shared] = ACTIONS(3429),
    [anon_sym_groupshared] = ACTIONS(3429),
    [anon_sym_uniform] = ACTIONS(3429),
    [anon_sym_row_major] = ACTIONS(3429),
    [anon_sym_column_major] = ACTIONS(3429),
    [anon_sym_globallycoherent] = ACTIONS(3429),
    [anon_sym_centroid] = ACTIONS(3429),
    [anon_sym_noperspective] = ACTIONS(3429),
    [anon_sym_nointerpolation] = ACTIONS(3429),
    [anon_sym_sample] = ACTIONS(3429),
    [anon_sym_linear] = ACTIONS(3429),
    [anon_sym_snorm] = ACTIONS(3429),
    [anon_sym_unorm] = ACTIONS(3429),
    [anon_sym_point] = ACTIONS(3429),
    [anon_sym_line] = ACTIONS(3429),
    [anon_sym_triangleadj] = ACTIONS(3429),
    [anon_sym_lineadj] = ACTIONS(3429),
    [anon_sym_triangle] = ACTIONS(3429),
    [anon_sym_cbuffer] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_extension] = ACTIONS(3429),
  },
  [947] = {
    [sym_identifier] = ACTIONS(3429),
    [aux_sym_preproc_include_token1] = ACTIONS(3429),
    [aux_sym_preproc_def_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token2] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3429),
    [sym_preproc_directive] = ACTIONS(3429),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_BANG] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym_SEMI] = ACTIONS(3431),
    [anon_sym___extension__] = ACTIONS(3429),
    [anon_sym_typedef] = ACTIONS(3429),
    [anon_sym_in] = ACTIONS(3429),
    [anon_sym_out] = ACTIONS(3429),
    [anon_sym_inout] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym___attribute__] = ACTIONS(3429),
    [anon_sym_COLON_COLON] = ACTIONS(3431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3431),
    [anon_sym___declspec] = ACTIONS(3429),
    [anon_sym___based] = ACTIONS(3429),
    [anon_sym___cdecl] = ACTIONS(3429),
    [anon_sym___clrcall] = ACTIONS(3429),
    [anon_sym___stdcall] = ACTIONS(3429),
    [anon_sym___fastcall] = ACTIONS(3429),
    [anon_sym___thiscall] = ACTIONS(3429),
    [anon_sym___vectorcall] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_signed] = ACTIONS(3429),
    [anon_sym_unsigned] = ACTIONS(3429),
    [anon_sym_long] = ACTIONS(3429),
    [anon_sym_short] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_register] = ACTIONS(3429),
    [anon_sym_inline] = ACTIONS(3429),
    [anon_sym___inline] = ACTIONS(3429),
    [anon_sym___inline__] = ACTIONS(3429),
    [anon_sym___forceinline] = ACTIONS(3429),
    [anon_sym_thread_local] = ACTIONS(3429),
    [anon_sym___thread] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_constexpr] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_restrict] = ACTIONS(3429),
    [anon_sym___restrict__] = ACTIONS(3429),
    [anon_sym__Atomic] = ACTIONS(3429),
    [anon_sym__Noreturn] = ACTIONS(3429),
    [anon_sym_noreturn] = ACTIONS(3429),
    [anon_sym_mutable] = ACTIONS(3429),
    [anon_sym_constinit] = ACTIONS(3429),
    [anon_sym_consteval] = ACTIONS(3429),
    [anon_sym_alignas] = ACTIONS(3429),
    [anon_sym__Alignas] = ACTIONS(3429),
    [sym_primitive_type] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [anon_sym_if] = ACTIONS(3429),
    [anon_sym_switch] = ACTIONS(3429),
    [anon_sym_case] = ACTIONS(3429),
    [anon_sym_default] = ACTIONS(3429),
    [anon_sym_while] = ACTIONS(3429),
    [anon_sym_do] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3429),
    [anon_sym_return] = ACTIONS(3429),
    [anon_sym_break] = ACTIONS(3429),
    [anon_sym_continue] = ACTIONS(3429),
    [anon_sym_goto] = ACTIONS(3429),
    [anon_sym___try] = ACTIONS(3429),
    [anon_sym___leave] = ACTIONS(3429),
    [anon_sym_not] = ACTIONS(3429),
    [anon_sym_compl] = ACTIONS(3429),
    [anon_sym_DASH_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(3431),
    [anon_sym_sizeof] = ACTIONS(3429),
    [anon_sym___alignof__] = ACTIONS(3429),
    [anon_sym___alignof] = ACTIONS(3429),
    [anon_sym__alignof] = ACTIONS(3429),
    [anon_sym_alignof] = ACTIONS(3429),
    [anon_sym__Alignof] = ACTIONS(3429),
    [anon_sym_offsetof] = ACTIONS(3429),
    [anon_sym__Generic] = ACTIONS(3429),
    [anon_sym_asm] = ACTIONS(3429),
    [anon_sym___asm__] = ACTIONS(3429),
    [sym_number_literal] = ACTIONS(3431),
    [anon_sym_L_SQUOTE] = ACTIONS(3431),
    [anon_sym_u_SQUOTE] = ACTIONS(3431),
    [anon_sym_U_SQUOTE] = ACTIONS(3431),
    [anon_sym_u8_SQUOTE] = ACTIONS(3431),
    [anon_sym_SQUOTE] = ACTIONS(3431),
    [anon_sym_L_DQUOTE] = ACTIONS(3431),
    [anon_sym_u_DQUOTE] = ACTIONS(3431),
    [anon_sym_U_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [sym_true] = ACTIONS(3429),
    [sym_false] = ACTIONS(3429),
    [anon_sym_NULL] = ACTIONS(3429),
    [anon_sym_nullptr] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_This] = ACTIONS(3429),
    [anon_sym_decltype] = ACTIONS(3429),
    [sym_virtual] = ACTIONS(3429),
    [anon_sym_explicit] = ACTIONS(3429),
    [anon_sym_typename] = ACTIONS(3429),
    [anon_sym_template] = ACTIONS(3429),
    [anon_sym_operator] = ACTIONS(3429),
    [anon_sym_try] = ACTIONS(3429),
    [anon_sym_delete] = ACTIONS(3429),
    [anon_sym_throw] = ACTIONS(3429),
    [anon_sym_namespace] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_static_assert] = ACTIONS(3429),
    [anon_sym_concept] = ACTIONS(3429),
    [anon_sym_co_return] = ACTIONS(3429),
    [anon_sym_co_yield] = ACTIONS(3429),
    [anon_sym_R_DQUOTE] = ACTIONS(3431),
    [anon_sym_LR_DQUOTE] = ACTIONS(3431),
    [anon_sym_uR_DQUOTE] = ACTIONS(3431),
    [anon_sym_UR_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3431),
    [anon_sym_co_await] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3429),
    [anon_sym_requires] = ACTIONS(3429),
    [sym_this] = ACTIONS(3429),
    [anon_sym_discard] = ACTIONS(3429),
    [anon_sym_precise] = ACTIONS(3429),
    [anon_sym_shared] = ACTIONS(3429),
    [anon_sym_groupshared] = ACTIONS(3429),
    [anon_sym_uniform] = ACTIONS(3429),
    [anon_sym_row_major] = ACTIONS(3429),
    [anon_sym_column_major] = ACTIONS(3429),
    [anon_sym_globallycoherent] = ACTIONS(3429),
    [anon_sym_centroid] = ACTIONS(3429),
    [anon_sym_noperspective] = ACTIONS(3429),
    [anon_sym_nointerpolation] = ACTIONS(3429),
    [anon_sym_sample] = ACTIONS(3429),
    [anon_sym_linear] = ACTIONS(3429),
    [anon_sym_snorm] = ACTIONS(3429),
    [anon_sym_unorm] = ACTIONS(3429),
    [anon_sym_point] = ACTIONS(3429),
    [anon_sym_line] = ACTIONS(3429),
    [anon_sym_triangleadj] = ACTIONS(3429),
    [anon_sym_lineadj] = ACTIONS(3429),
    [anon_sym_triangle] = ACTIONS(3429),
    [anon_sym_cbuffer] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_extension] = ACTIONS(3429),
  },
  [948] = {
    [sym_identifier] = ACTIONS(3429),
    [aux_sym_preproc_include_token1] = ACTIONS(3429),
    [aux_sym_preproc_def_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token2] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3429),
    [sym_preproc_directive] = ACTIONS(3429),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_BANG] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym_SEMI] = ACTIONS(3431),
    [anon_sym___extension__] = ACTIONS(3429),
    [anon_sym_typedef] = ACTIONS(3429),
    [anon_sym_in] = ACTIONS(3429),
    [anon_sym_out] = ACTIONS(3429),
    [anon_sym_inout] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym___attribute__] = ACTIONS(3429),
    [anon_sym_COLON_COLON] = ACTIONS(3431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3431),
    [anon_sym___declspec] = ACTIONS(3429),
    [anon_sym___based] = ACTIONS(3429),
    [anon_sym___cdecl] = ACTIONS(3429),
    [anon_sym___clrcall] = ACTIONS(3429),
    [anon_sym___stdcall] = ACTIONS(3429),
    [anon_sym___fastcall] = ACTIONS(3429),
    [anon_sym___thiscall] = ACTIONS(3429),
    [anon_sym___vectorcall] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_signed] = ACTIONS(3429),
    [anon_sym_unsigned] = ACTIONS(3429),
    [anon_sym_long] = ACTIONS(3429),
    [anon_sym_short] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_register] = ACTIONS(3429),
    [anon_sym_inline] = ACTIONS(3429),
    [anon_sym___inline] = ACTIONS(3429),
    [anon_sym___inline__] = ACTIONS(3429),
    [anon_sym___forceinline] = ACTIONS(3429),
    [anon_sym_thread_local] = ACTIONS(3429),
    [anon_sym___thread] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_constexpr] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_restrict] = ACTIONS(3429),
    [anon_sym___restrict__] = ACTIONS(3429),
    [anon_sym__Atomic] = ACTIONS(3429),
    [anon_sym__Noreturn] = ACTIONS(3429),
    [anon_sym_noreturn] = ACTIONS(3429),
    [anon_sym_mutable] = ACTIONS(3429),
    [anon_sym_constinit] = ACTIONS(3429),
    [anon_sym_consteval] = ACTIONS(3429),
    [anon_sym_alignas] = ACTIONS(3429),
    [anon_sym__Alignas] = ACTIONS(3429),
    [sym_primitive_type] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [anon_sym_if] = ACTIONS(3429),
    [anon_sym_switch] = ACTIONS(3429),
    [anon_sym_case] = ACTIONS(3429),
    [anon_sym_default] = ACTIONS(3429),
    [anon_sym_while] = ACTIONS(3429),
    [anon_sym_do] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3429),
    [anon_sym_return] = ACTIONS(3429),
    [anon_sym_break] = ACTIONS(3429),
    [anon_sym_continue] = ACTIONS(3429),
    [anon_sym_goto] = ACTIONS(3429),
    [anon_sym___try] = ACTIONS(3429),
    [anon_sym___leave] = ACTIONS(3429),
    [anon_sym_not] = ACTIONS(3429),
    [anon_sym_compl] = ACTIONS(3429),
    [anon_sym_DASH_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(3431),
    [anon_sym_sizeof] = ACTIONS(3429),
    [anon_sym___alignof__] = ACTIONS(3429),
    [anon_sym___alignof] = ACTIONS(3429),
    [anon_sym__alignof] = ACTIONS(3429),
    [anon_sym_alignof] = ACTIONS(3429),
    [anon_sym__Alignof] = ACTIONS(3429),
    [anon_sym_offsetof] = ACTIONS(3429),
    [anon_sym__Generic] = ACTIONS(3429),
    [anon_sym_asm] = ACTIONS(3429),
    [anon_sym___asm__] = ACTIONS(3429),
    [sym_number_literal] = ACTIONS(3431),
    [anon_sym_L_SQUOTE] = ACTIONS(3431),
    [anon_sym_u_SQUOTE] = ACTIONS(3431),
    [anon_sym_U_SQUOTE] = ACTIONS(3431),
    [anon_sym_u8_SQUOTE] = ACTIONS(3431),
    [anon_sym_SQUOTE] = ACTIONS(3431),
    [anon_sym_L_DQUOTE] = ACTIONS(3431),
    [anon_sym_u_DQUOTE] = ACTIONS(3431),
    [anon_sym_U_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [sym_true] = ACTIONS(3429),
    [sym_false] = ACTIONS(3429),
    [anon_sym_NULL] = ACTIONS(3429),
    [anon_sym_nullptr] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_This] = ACTIONS(3429),
    [anon_sym_decltype] = ACTIONS(3429),
    [sym_virtual] = ACTIONS(3429),
    [anon_sym_explicit] = ACTIONS(3429),
    [anon_sym_typename] = ACTIONS(3429),
    [anon_sym_template] = ACTIONS(3429),
    [anon_sym_operator] = ACTIONS(3429),
    [anon_sym_try] = ACTIONS(3429),
    [anon_sym_delete] = ACTIONS(3429),
    [anon_sym_throw] = ACTIONS(3429),
    [anon_sym_namespace] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_static_assert] = ACTIONS(3429),
    [anon_sym_concept] = ACTIONS(3429),
    [anon_sym_co_return] = ACTIONS(3429),
    [anon_sym_co_yield] = ACTIONS(3429),
    [anon_sym_R_DQUOTE] = ACTIONS(3431),
    [anon_sym_LR_DQUOTE] = ACTIONS(3431),
    [anon_sym_uR_DQUOTE] = ACTIONS(3431),
    [anon_sym_UR_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3431),
    [anon_sym_co_await] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3429),
    [anon_sym_requires] = ACTIONS(3429),
    [sym_this] = ACTIONS(3429),
    [anon_sym_discard] = ACTIONS(3429),
    [anon_sym_precise] = ACTIONS(3429),
    [anon_sym_shared] = ACTIONS(3429),
    [anon_sym_groupshared] = ACTIONS(3429),
    [anon_sym_uniform] = ACTIONS(3429),
    [anon_sym_row_major] = ACTIONS(3429),
    [anon_sym_column_major] = ACTIONS(3429),
    [anon_sym_globallycoherent] = ACTIONS(3429),
    [anon_sym_centroid] = ACTIONS(3429),
    [anon_sym_noperspective] = ACTIONS(3429),
    [anon_sym_nointerpolation] = ACTIONS(3429),
    [anon_sym_sample] = ACTIONS(3429),
    [anon_sym_linear] = ACTIONS(3429),
    [anon_sym_snorm] = ACTIONS(3429),
    [anon_sym_unorm] = ACTIONS(3429),
    [anon_sym_point] = ACTIONS(3429),
    [anon_sym_line] = ACTIONS(3429),
    [anon_sym_triangleadj] = ACTIONS(3429),
    [anon_sym_lineadj] = ACTIONS(3429),
    [anon_sym_triangle] = ACTIONS(3429),
    [anon_sym_cbuffer] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_extension] = ACTIONS(3429),
  },
  [949] = {
    [sym_identifier] = ACTIONS(3429),
    [aux_sym_preproc_include_token1] = ACTIONS(3429),
    [aux_sym_preproc_def_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token2] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3429),
    [sym_preproc_directive] = ACTIONS(3429),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_BANG] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym_SEMI] = ACTIONS(3431),
    [anon_sym___extension__] = ACTIONS(3429),
    [anon_sym_typedef] = ACTIONS(3429),
    [anon_sym_in] = ACTIONS(3429),
    [anon_sym_out] = ACTIONS(3429),
    [anon_sym_inout] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym___attribute__] = ACTIONS(3429),
    [anon_sym_COLON_COLON] = ACTIONS(3431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3431),
    [anon_sym___declspec] = ACTIONS(3429),
    [anon_sym___based] = ACTIONS(3429),
    [anon_sym___cdecl] = ACTIONS(3429),
    [anon_sym___clrcall] = ACTIONS(3429),
    [anon_sym___stdcall] = ACTIONS(3429),
    [anon_sym___fastcall] = ACTIONS(3429),
    [anon_sym___thiscall] = ACTIONS(3429),
    [anon_sym___vectorcall] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_signed] = ACTIONS(3429),
    [anon_sym_unsigned] = ACTIONS(3429),
    [anon_sym_long] = ACTIONS(3429),
    [anon_sym_short] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_register] = ACTIONS(3429),
    [anon_sym_inline] = ACTIONS(3429),
    [anon_sym___inline] = ACTIONS(3429),
    [anon_sym___inline__] = ACTIONS(3429),
    [anon_sym___forceinline] = ACTIONS(3429),
    [anon_sym_thread_local] = ACTIONS(3429),
    [anon_sym___thread] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_constexpr] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_restrict] = ACTIONS(3429),
    [anon_sym___restrict__] = ACTIONS(3429),
    [anon_sym__Atomic] = ACTIONS(3429),
    [anon_sym__Noreturn] = ACTIONS(3429),
    [anon_sym_noreturn] = ACTIONS(3429),
    [anon_sym_mutable] = ACTIONS(3429),
    [anon_sym_constinit] = ACTIONS(3429),
    [anon_sym_consteval] = ACTIONS(3429),
    [anon_sym_alignas] = ACTIONS(3429),
    [anon_sym__Alignas] = ACTIONS(3429),
    [sym_primitive_type] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [anon_sym_if] = ACTIONS(3429),
    [anon_sym_switch] = ACTIONS(3429),
    [anon_sym_case] = ACTIONS(3429),
    [anon_sym_default] = ACTIONS(3429),
    [anon_sym_while] = ACTIONS(3429),
    [anon_sym_do] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3429),
    [anon_sym_return] = ACTIONS(3429),
    [anon_sym_break] = ACTIONS(3429),
    [anon_sym_continue] = ACTIONS(3429),
    [anon_sym_goto] = ACTIONS(3429),
    [anon_sym___try] = ACTIONS(3429),
    [anon_sym___leave] = ACTIONS(3429),
    [anon_sym_not] = ACTIONS(3429),
    [anon_sym_compl] = ACTIONS(3429),
    [anon_sym_DASH_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(3431),
    [anon_sym_sizeof] = ACTIONS(3429),
    [anon_sym___alignof__] = ACTIONS(3429),
    [anon_sym___alignof] = ACTIONS(3429),
    [anon_sym__alignof] = ACTIONS(3429),
    [anon_sym_alignof] = ACTIONS(3429),
    [anon_sym__Alignof] = ACTIONS(3429),
    [anon_sym_offsetof] = ACTIONS(3429),
    [anon_sym__Generic] = ACTIONS(3429),
    [anon_sym_asm] = ACTIONS(3429),
    [anon_sym___asm__] = ACTIONS(3429),
    [sym_number_literal] = ACTIONS(3431),
    [anon_sym_L_SQUOTE] = ACTIONS(3431),
    [anon_sym_u_SQUOTE] = ACTIONS(3431),
    [anon_sym_U_SQUOTE] = ACTIONS(3431),
    [anon_sym_u8_SQUOTE] = ACTIONS(3431),
    [anon_sym_SQUOTE] = ACTIONS(3431),
    [anon_sym_L_DQUOTE] = ACTIONS(3431),
    [anon_sym_u_DQUOTE] = ACTIONS(3431),
    [anon_sym_U_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [sym_true] = ACTIONS(3429),
    [sym_false] = ACTIONS(3429),
    [anon_sym_NULL] = ACTIONS(3429),
    [anon_sym_nullptr] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_This] = ACTIONS(3429),
    [anon_sym_decltype] = ACTIONS(3429),
    [sym_virtual] = ACTIONS(3429),
    [anon_sym_explicit] = ACTIONS(3429),
    [anon_sym_typename] = ACTIONS(3429),
    [anon_sym_template] = ACTIONS(3429),
    [anon_sym_operator] = ACTIONS(3429),
    [anon_sym_try] = ACTIONS(3429),
    [anon_sym_delete] = ACTIONS(3429),
    [anon_sym_throw] = ACTIONS(3429),
    [anon_sym_namespace] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_static_assert] = ACTIONS(3429),
    [anon_sym_concept] = ACTIONS(3429),
    [anon_sym_co_return] = ACTIONS(3429),
    [anon_sym_co_yield] = ACTIONS(3429),
    [anon_sym_R_DQUOTE] = ACTIONS(3431),
    [anon_sym_LR_DQUOTE] = ACTIONS(3431),
    [anon_sym_uR_DQUOTE] = ACTIONS(3431),
    [anon_sym_UR_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3431),
    [anon_sym_co_await] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3429),
    [anon_sym_requires] = ACTIONS(3429),
    [sym_this] = ACTIONS(3429),
    [anon_sym_discard] = ACTIONS(3429),
    [anon_sym_precise] = ACTIONS(3429),
    [anon_sym_shared] = ACTIONS(3429),
    [anon_sym_groupshared] = ACTIONS(3429),
    [anon_sym_uniform] = ACTIONS(3429),
    [anon_sym_row_major] = ACTIONS(3429),
    [anon_sym_column_major] = ACTIONS(3429),
    [anon_sym_globallycoherent] = ACTIONS(3429),
    [anon_sym_centroid] = ACTIONS(3429),
    [anon_sym_noperspective] = ACTIONS(3429),
    [anon_sym_nointerpolation] = ACTIONS(3429),
    [anon_sym_sample] = ACTIONS(3429),
    [anon_sym_linear] = ACTIONS(3429),
    [anon_sym_snorm] = ACTIONS(3429),
    [anon_sym_unorm] = ACTIONS(3429),
    [anon_sym_point] = ACTIONS(3429),
    [anon_sym_line] = ACTIONS(3429),
    [anon_sym_triangleadj] = ACTIONS(3429),
    [anon_sym_lineadj] = ACTIONS(3429),
    [anon_sym_triangle] = ACTIONS(3429),
    [anon_sym_cbuffer] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_extension] = ACTIONS(3429),
  },
  [950] = {
    [sym_identifier] = ACTIONS(3410),
    [aux_sym_preproc_include_token1] = ACTIONS(3410),
    [aux_sym_preproc_def_token1] = ACTIONS(3410),
    [aux_sym_preproc_if_token1] = ACTIONS(3410),
    [aux_sym_preproc_if_token2] = ACTIONS(3410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3410),
    [sym_preproc_directive] = ACTIONS(3410),
    [anon_sym_LPAREN2] = ACTIONS(3412),
    [anon_sym_BANG] = ACTIONS(3412),
    [anon_sym_TILDE] = ACTIONS(3412),
    [anon_sym_DASH] = ACTIONS(3410),
    [anon_sym_PLUS] = ACTIONS(3410),
    [anon_sym_STAR] = ACTIONS(3412),
    [anon_sym_AMP_AMP] = ACTIONS(3412),
    [anon_sym_AMP] = ACTIONS(3410),
    [anon_sym_SEMI] = ACTIONS(3412),
    [anon_sym___extension__] = ACTIONS(3410),
    [anon_sym_typedef] = ACTIONS(3410),
    [anon_sym_in] = ACTIONS(3410),
    [anon_sym_out] = ACTIONS(3410),
    [anon_sym_inout] = ACTIONS(3410),
    [anon_sym_extern] = ACTIONS(3410),
    [anon_sym___attribute__] = ACTIONS(3410),
    [anon_sym_COLON_COLON] = ACTIONS(3412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3412),
    [anon_sym___declspec] = ACTIONS(3410),
    [anon_sym___based] = ACTIONS(3410),
    [anon_sym___cdecl] = ACTIONS(3410),
    [anon_sym___clrcall] = ACTIONS(3410),
    [anon_sym___stdcall] = ACTIONS(3410),
    [anon_sym___fastcall] = ACTIONS(3410),
    [anon_sym___thiscall] = ACTIONS(3410),
    [anon_sym___vectorcall] = ACTIONS(3410),
    [anon_sym_LBRACE] = ACTIONS(3412),
    [anon_sym_signed] = ACTIONS(3410),
    [anon_sym_unsigned] = ACTIONS(3410),
    [anon_sym_long] = ACTIONS(3410),
    [anon_sym_short] = ACTIONS(3410),
    [anon_sym_LBRACK] = ACTIONS(3410),
    [anon_sym_static] = ACTIONS(3410),
    [anon_sym_register] = ACTIONS(3410),
    [anon_sym_inline] = ACTIONS(3410),
    [anon_sym___inline] = ACTIONS(3410),
    [anon_sym___inline__] = ACTIONS(3410),
    [anon_sym___forceinline] = ACTIONS(3410),
    [anon_sym_thread_local] = ACTIONS(3410),
    [anon_sym___thread] = ACTIONS(3410),
    [anon_sym_const] = ACTIONS(3410),
    [anon_sym_constexpr] = ACTIONS(3410),
    [anon_sym_volatile] = ACTIONS(3410),
    [anon_sym_restrict] = ACTIONS(3410),
    [anon_sym___restrict__] = ACTIONS(3410),
    [anon_sym__Atomic] = ACTIONS(3410),
    [anon_sym__Noreturn] = ACTIONS(3410),
    [anon_sym_noreturn] = ACTIONS(3410),
    [anon_sym_mutable] = ACTIONS(3410),
    [anon_sym_constinit] = ACTIONS(3410),
    [anon_sym_consteval] = ACTIONS(3410),
    [anon_sym_alignas] = ACTIONS(3410),
    [anon_sym__Alignas] = ACTIONS(3410),
    [sym_primitive_type] = ACTIONS(3410),
    [anon_sym_enum] = ACTIONS(3410),
    [anon_sym_class] = ACTIONS(3410),
    [anon_sym_struct] = ACTIONS(3410),
    [anon_sym_union] = ACTIONS(3410),
    [anon_sym_if] = ACTIONS(3410),
    [anon_sym_switch] = ACTIONS(3410),
    [anon_sym_case] = ACTIONS(3410),
    [anon_sym_default] = ACTIONS(3410),
    [anon_sym_while] = ACTIONS(3410),
    [anon_sym_do] = ACTIONS(3410),
    [anon_sym_for] = ACTIONS(3410),
    [anon_sym_return] = ACTIONS(3410),
    [anon_sym_break] = ACTIONS(3410),
    [anon_sym_continue] = ACTIONS(3410),
    [anon_sym_goto] = ACTIONS(3410),
    [anon_sym___try] = ACTIONS(3410),
    [anon_sym___leave] = ACTIONS(3410),
    [anon_sym_not] = ACTIONS(3410),
    [anon_sym_compl] = ACTIONS(3410),
    [anon_sym_DASH_DASH] = ACTIONS(3412),
    [anon_sym_PLUS_PLUS] = ACTIONS(3412),
    [anon_sym_sizeof] = ACTIONS(3410),
    [anon_sym___alignof__] = ACTIONS(3410),
    [anon_sym___alignof] = ACTIONS(3410),
    [anon_sym__alignof] = ACTIONS(3410),
    [anon_sym_alignof] = ACTIONS(3410),
    [anon_sym__Alignof] = ACTIONS(3410),
    [anon_sym_offsetof] = ACTIONS(3410),
    [anon_sym__Generic] = ACTIONS(3410),
    [anon_sym_asm] = ACTIONS(3410),
    [anon_sym___asm__] = ACTIONS(3410),
    [sym_number_literal] = ACTIONS(3412),
    [anon_sym_L_SQUOTE] = ACTIONS(3412),
    [anon_sym_u_SQUOTE] = ACTIONS(3412),
    [anon_sym_U_SQUOTE] = ACTIONS(3412),
    [anon_sym_u8_SQUOTE] = ACTIONS(3412),
    [anon_sym_SQUOTE] = ACTIONS(3412),
    [anon_sym_L_DQUOTE] = ACTIONS(3412),
    [anon_sym_u_DQUOTE] = ACTIONS(3412),
    [anon_sym_U_DQUOTE] = ACTIONS(3412),
    [anon_sym_u8_DQUOTE] = ACTIONS(3412),
    [anon_sym_DQUOTE] = ACTIONS(3412),
    [sym_true] = ACTIONS(3410),
    [sym_false] = ACTIONS(3410),
    [anon_sym_NULL] = ACTIONS(3410),
    [anon_sym_nullptr] = ACTIONS(3410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3410),
    [anon_sym_let] = ACTIONS(3410),
    [anon_sym_This] = ACTIONS(3410),
    [anon_sym_decltype] = ACTIONS(3410),
    [sym_virtual] = ACTIONS(3410),
    [anon_sym_explicit] = ACTIONS(3410),
    [anon_sym_typename] = ACTIONS(3410),
    [anon_sym_template] = ACTIONS(3410),
    [anon_sym_operator] = ACTIONS(3410),
    [anon_sym_try] = ACTIONS(3410),
    [anon_sym_delete] = ACTIONS(3410),
    [anon_sym_throw] = ACTIONS(3410),
    [anon_sym_namespace] = ACTIONS(3410),
    [anon_sym_using] = ACTIONS(3410),
    [anon_sym_static_assert] = ACTIONS(3410),
    [anon_sym_concept] = ACTIONS(3410),
    [anon_sym_co_return] = ACTIONS(3410),
    [anon_sym_co_yield] = ACTIONS(3410),
    [anon_sym_R_DQUOTE] = ACTIONS(3412),
    [anon_sym_LR_DQUOTE] = ACTIONS(3412),
    [anon_sym_uR_DQUOTE] = ACTIONS(3412),
    [anon_sym_UR_DQUOTE] = ACTIONS(3412),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3412),
    [anon_sym_co_await] = ACTIONS(3410),
    [anon_sym_new] = ACTIONS(3410),
    [anon_sym_requires] = ACTIONS(3410),
    [sym_this] = ACTIONS(3410),
    [anon_sym_discard] = ACTIONS(3410),
    [anon_sym_precise] = ACTIONS(3410),
    [anon_sym_shared] = ACTIONS(3410),
    [anon_sym_groupshared] = ACTIONS(3410),
    [anon_sym_uniform] = ACTIONS(3410),
    [anon_sym_row_major] = ACTIONS(3410),
    [anon_sym_column_major] = ACTIONS(3410),
    [anon_sym_globallycoherent] = ACTIONS(3410),
    [anon_sym_centroid] = ACTIONS(3410),
    [anon_sym_noperspective] = ACTIONS(3410),
    [anon_sym_nointerpolation] = ACTIONS(3410),
    [anon_sym_sample] = ACTIONS(3410),
    [anon_sym_linear] = ACTIONS(3410),
    [anon_sym_snorm] = ACTIONS(3410),
    [anon_sym_unorm] = ACTIONS(3410),
    [anon_sym_point] = ACTIONS(3410),
    [anon_sym_line] = ACTIONS(3410),
    [anon_sym_triangleadj] = ACTIONS(3410),
    [anon_sym_lineadj] = ACTIONS(3410),
    [anon_sym_triangle] = ACTIONS(3410),
    [anon_sym_cbuffer] = ACTIONS(3410),
    [anon_sym_interface] = ACTIONS(3410),
    [anon_sym_extension] = ACTIONS(3410),
  },
  [951] = {
    [sym_identifier] = ACTIONS(3479),
    [aux_sym_preproc_include_token1] = ACTIONS(3479),
    [aux_sym_preproc_def_token1] = ACTIONS(3479),
    [aux_sym_preproc_if_token1] = ACTIONS(3479),
    [aux_sym_preproc_if_token2] = ACTIONS(3479),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3479),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3479),
    [sym_preproc_directive] = ACTIONS(3479),
    [anon_sym_LPAREN2] = ACTIONS(3481),
    [anon_sym_BANG] = ACTIONS(3481),
    [anon_sym_TILDE] = ACTIONS(3481),
    [anon_sym_DASH] = ACTIONS(3479),
    [anon_sym_PLUS] = ACTIONS(3479),
    [anon_sym_STAR] = ACTIONS(3481),
    [anon_sym_AMP_AMP] = ACTIONS(3481),
    [anon_sym_AMP] = ACTIONS(3479),
    [anon_sym_SEMI] = ACTIONS(3481),
    [anon_sym___extension__] = ACTIONS(3479),
    [anon_sym_typedef] = ACTIONS(3479),
    [anon_sym_in] = ACTIONS(3479),
    [anon_sym_out] = ACTIONS(3479),
    [anon_sym_inout] = ACTIONS(3479),
    [anon_sym_extern] = ACTIONS(3479),
    [anon_sym___attribute__] = ACTIONS(3479),
    [anon_sym_COLON_COLON] = ACTIONS(3481),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3481),
    [anon_sym___declspec] = ACTIONS(3479),
    [anon_sym___based] = ACTIONS(3479),
    [anon_sym___cdecl] = ACTIONS(3479),
    [anon_sym___clrcall] = ACTIONS(3479),
    [anon_sym___stdcall] = ACTIONS(3479),
    [anon_sym___fastcall] = ACTIONS(3479),
    [anon_sym___thiscall] = ACTIONS(3479),
    [anon_sym___vectorcall] = ACTIONS(3479),
    [anon_sym_LBRACE] = ACTIONS(3481),
    [anon_sym_signed] = ACTIONS(3479),
    [anon_sym_unsigned] = ACTIONS(3479),
    [anon_sym_long] = ACTIONS(3479),
    [anon_sym_short] = ACTIONS(3479),
    [anon_sym_LBRACK] = ACTIONS(3479),
    [anon_sym_static] = ACTIONS(3479),
    [anon_sym_register] = ACTIONS(3479),
    [anon_sym_inline] = ACTIONS(3479),
    [anon_sym___inline] = ACTIONS(3479),
    [anon_sym___inline__] = ACTIONS(3479),
    [anon_sym___forceinline] = ACTIONS(3479),
    [anon_sym_thread_local] = ACTIONS(3479),
    [anon_sym___thread] = ACTIONS(3479),
    [anon_sym_const] = ACTIONS(3479),
    [anon_sym_constexpr] = ACTIONS(3479),
    [anon_sym_volatile] = ACTIONS(3479),
    [anon_sym_restrict] = ACTIONS(3479),
    [anon_sym___restrict__] = ACTIONS(3479),
    [anon_sym__Atomic] = ACTIONS(3479),
    [anon_sym__Noreturn] = ACTIONS(3479),
    [anon_sym_noreturn] = ACTIONS(3479),
    [anon_sym_mutable] = ACTIONS(3479),
    [anon_sym_constinit] = ACTIONS(3479),
    [anon_sym_consteval] = ACTIONS(3479),
    [anon_sym_alignas] = ACTIONS(3479),
    [anon_sym__Alignas] = ACTIONS(3479),
    [sym_primitive_type] = ACTIONS(3479),
    [anon_sym_enum] = ACTIONS(3479),
    [anon_sym_class] = ACTIONS(3479),
    [anon_sym_struct] = ACTIONS(3479),
    [anon_sym_union] = ACTIONS(3479),
    [anon_sym_if] = ACTIONS(3479),
    [anon_sym_switch] = ACTIONS(3479),
    [anon_sym_case] = ACTIONS(3479),
    [anon_sym_default] = ACTIONS(3479),
    [anon_sym_while] = ACTIONS(3479),
    [anon_sym_do] = ACTIONS(3479),
    [anon_sym_for] = ACTIONS(3479),
    [anon_sym_return] = ACTIONS(3479),
    [anon_sym_break] = ACTIONS(3479),
    [anon_sym_continue] = ACTIONS(3479),
    [anon_sym_goto] = ACTIONS(3479),
    [anon_sym___try] = ACTIONS(3479),
    [anon_sym___leave] = ACTIONS(3479),
    [anon_sym_not] = ACTIONS(3479),
    [anon_sym_compl] = ACTIONS(3479),
    [anon_sym_DASH_DASH] = ACTIONS(3481),
    [anon_sym_PLUS_PLUS] = ACTIONS(3481),
    [anon_sym_sizeof] = ACTIONS(3479),
    [anon_sym___alignof__] = ACTIONS(3479),
    [anon_sym___alignof] = ACTIONS(3479),
    [anon_sym__alignof] = ACTIONS(3479),
    [anon_sym_alignof] = ACTIONS(3479),
    [anon_sym__Alignof] = ACTIONS(3479),
    [anon_sym_offsetof] = ACTIONS(3479),
    [anon_sym__Generic] = ACTIONS(3479),
    [anon_sym_asm] = ACTIONS(3479),
    [anon_sym___asm__] = ACTIONS(3479),
    [sym_number_literal] = ACTIONS(3481),
    [anon_sym_L_SQUOTE] = ACTIONS(3481),
    [anon_sym_u_SQUOTE] = ACTIONS(3481),
    [anon_sym_U_SQUOTE] = ACTIONS(3481),
    [anon_sym_u8_SQUOTE] = ACTIONS(3481),
    [anon_sym_SQUOTE] = ACTIONS(3481),
    [anon_sym_L_DQUOTE] = ACTIONS(3481),
    [anon_sym_u_DQUOTE] = ACTIONS(3481),
    [anon_sym_U_DQUOTE] = ACTIONS(3481),
    [anon_sym_u8_DQUOTE] = ACTIONS(3481),
    [anon_sym_DQUOTE] = ACTIONS(3481),
    [sym_true] = ACTIONS(3479),
    [sym_false] = ACTIONS(3479),
    [anon_sym_NULL] = ACTIONS(3479),
    [anon_sym_nullptr] = ACTIONS(3479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3479),
    [anon_sym_let] = ACTIONS(3479),
    [anon_sym_This] = ACTIONS(3479),
    [anon_sym_decltype] = ACTIONS(3479),
    [sym_virtual] = ACTIONS(3479),
    [anon_sym_explicit] = ACTIONS(3479),
    [anon_sym_typename] = ACTIONS(3479),
    [anon_sym_template] = ACTIONS(3479),
    [anon_sym_operator] = ACTIONS(3479),
    [anon_sym_try] = ACTIONS(3479),
    [anon_sym_delete] = ACTIONS(3479),
    [anon_sym_throw] = ACTIONS(3479),
    [anon_sym_namespace] = ACTIONS(3479),
    [anon_sym_using] = ACTIONS(3479),
    [anon_sym_static_assert] = ACTIONS(3479),
    [anon_sym_concept] = ACTIONS(3479),
    [anon_sym_co_return] = ACTIONS(3479),
    [anon_sym_co_yield] = ACTIONS(3479),
    [anon_sym_R_DQUOTE] = ACTIONS(3481),
    [anon_sym_LR_DQUOTE] = ACTIONS(3481),
    [anon_sym_uR_DQUOTE] = ACTIONS(3481),
    [anon_sym_UR_DQUOTE] = ACTIONS(3481),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3481),
    [anon_sym_co_await] = ACTIONS(3479),
    [anon_sym_new] = ACTIONS(3479),
    [anon_sym_requires] = ACTIONS(3479),
    [sym_this] = ACTIONS(3479),
    [anon_sym_discard] = ACTIONS(3479),
    [anon_sym_precise] = ACTIONS(3479),
    [anon_sym_shared] = ACTIONS(3479),
    [anon_sym_groupshared] = ACTIONS(3479),
    [anon_sym_uniform] = ACTIONS(3479),
    [anon_sym_row_major] = ACTIONS(3479),
    [anon_sym_column_major] = ACTIONS(3479),
    [anon_sym_globallycoherent] = ACTIONS(3479),
    [anon_sym_centroid] = ACTIONS(3479),
    [anon_sym_noperspective] = ACTIONS(3479),
    [anon_sym_nointerpolation] = ACTIONS(3479),
    [anon_sym_sample] = ACTIONS(3479),
    [anon_sym_linear] = ACTIONS(3479),
    [anon_sym_snorm] = ACTIONS(3479),
    [anon_sym_unorm] = ACTIONS(3479),
    [anon_sym_point] = ACTIONS(3479),
    [anon_sym_line] = ACTIONS(3479),
    [anon_sym_triangleadj] = ACTIONS(3479),
    [anon_sym_lineadj] = ACTIONS(3479),
    [anon_sym_triangle] = ACTIONS(3479),
    [anon_sym_cbuffer] = ACTIONS(3479),
    [anon_sym_interface] = ACTIONS(3479),
    [anon_sym_extension] = ACTIONS(3479),
  },
  [952] = {
    [sym_identifier] = ACTIONS(3410),
    [aux_sym_preproc_include_token1] = ACTIONS(3410),
    [aux_sym_preproc_def_token1] = ACTIONS(3410),
    [aux_sym_preproc_if_token1] = ACTIONS(3410),
    [aux_sym_preproc_if_token2] = ACTIONS(3410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3410),
    [sym_preproc_directive] = ACTIONS(3410),
    [anon_sym_LPAREN2] = ACTIONS(3412),
    [anon_sym_BANG] = ACTIONS(3412),
    [anon_sym_TILDE] = ACTIONS(3412),
    [anon_sym_DASH] = ACTIONS(3410),
    [anon_sym_PLUS] = ACTIONS(3410),
    [anon_sym_STAR] = ACTIONS(3412),
    [anon_sym_AMP_AMP] = ACTIONS(3412),
    [anon_sym_AMP] = ACTIONS(3410),
    [anon_sym_SEMI] = ACTIONS(3412),
    [anon_sym___extension__] = ACTIONS(3410),
    [anon_sym_typedef] = ACTIONS(3410),
    [anon_sym_in] = ACTIONS(3410),
    [anon_sym_out] = ACTIONS(3410),
    [anon_sym_inout] = ACTIONS(3410),
    [anon_sym_extern] = ACTIONS(3410),
    [anon_sym___attribute__] = ACTIONS(3410),
    [anon_sym_COLON_COLON] = ACTIONS(3412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3412),
    [anon_sym___declspec] = ACTIONS(3410),
    [anon_sym___based] = ACTIONS(3410),
    [anon_sym___cdecl] = ACTIONS(3410),
    [anon_sym___clrcall] = ACTIONS(3410),
    [anon_sym___stdcall] = ACTIONS(3410),
    [anon_sym___fastcall] = ACTIONS(3410),
    [anon_sym___thiscall] = ACTIONS(3410),
    [anon_sym___vectorcall] = ACTIONS(3410),
    [anon_sym_LBRACE] = ACTIONS(3412),
    [anon_sym_signed] = ACTIONS(3410),
    [anon_sym_unsigned] = ACTIONS(3410),
    [anon_sym_long] = ACTIONS(3410),
    [anon_sym_short] = ACTIONS(3410),
    [anon_sym_LBRACK] = ACTIONS(3410),
    [anon_sym_static] = ACTIONS(3410),
    [anon_sym_register] = ACTIONS(3410),
    [anon_sym_inline] = ACTIONS(3410),
    [anon_sym___inline] = ACTIONS(3410),
    [anon_sym___inline__] = ACTIONS(3410),
    [anon_sym___forceinline] = ACTIONS(3410),
    [anon_sym_thread_local] = ACTIONS(3410),
    [anon_sym___thread] = ACTIONS(3410),
    [anon_sym_const] = ACTIONS(3410),
    [anon_sym_constexpr] = ACTIONS(3410),
    [anon_sym_volatile] = ACTIONS(3410),
    [anon_sym_restrict] = ACTIONS(3410),
    [anon_sym___restrict__] = ACTIONS(3410),
    [anon_sym__Atomic] = ACTIONS(3410),
    [anon_sym__Noreturn] = ACTIONS(3410),
    [anon_sym_noreturn] = ACTIONS(3410),
    [anon_sym_mutable] = ACTIONS(3410),
    [anon_sym_constinit] = ACTIONS(3410),
    [anon_sym_consteval] = ACTIONS(3410),
    [anon_sym_alignas] = ACTIONS(3410),
    [anon_sym__Alignas] = ACTIONS(3410),
    [sym_primitive_type] = ACTIONS(3410),
    [anon_sym_enum] = ACTIONS(3410),
    [anon_sym_class] = ACTIONS(3410),
    [anon_sym_struct] = ACTIONS(3410),
    [anon_sym_union] = ACTIONS(3410),
    [anon_sym_if] = ACTIONS(3410),
    [anon_sym_switch] = ACTIONS(3410),
    [anon_sym_case] = ACTIONS(3410),
    [anon_sym_default] = ACTIONS(3410),
    [anon_sym_while] = ACTIONS(3410),
    [anon_sym_do] = ACTIONS(3410),
    [anon_sym_for] = ACTIONS(3410),
    [anon_sym_return] = ACTIONS(3410),
    [anon_sym_break] = ACTIONS(3410),
    [anon_sym_continue] = ACTIONS(3410),
    [anon_sym_goto] = ACTIONS(3410),
    [anon_sym___try] = ACTIONS(3410),
    [anon_sym___leave] = ACTIONS(3410),
    [anon_sym_not] = ACTIONS(3410),
    [anon_sym_compl] = ACTIONS(3410),
    [anon_sym_DASH_DASH] = ACTIONS(3412),
    [anon_sym_PLUS_PLUS] = ACTIONS(3412),
    [anon_sym_sizeof] = ACTIONS(3410),
    [anon_sym___alignof__] = ACTIONS(3410),
    [anon_sym___alignof] = ACTIONS(3410),
    [anon_sym__alignof] = ACTIONS(3410),
    [anon_sym_alignof] = ACTIONS(3410),
    [anon_sym__Alignof] = ACTIONS(3410),
    [anon_sym_offsetof] = ACTIONS(3410),
    [anon_sym__Generic] = ACTIONS(3410),
    [anon_sym_asm] = ACTIONS(3410),
    [anon_sym___asm__] = ACTIONS(3410),
    [sym_number_literal] = ACTIONS(3412),
    [anon_sym_L_SQUOTE] = ACTIONS(3412),
    [anon_sym_u_SQUOTE] = ACTIONS(3412),
    [anon_sym_U_SQUOTE] = ACTIONS(3412),
    [anon_sym_u8_SQUOTE] = ACTIONS(3412),
    [anon_sym_SQUOTE] = ACTIONS(3412),
    [anon_sym_L_DQUOTE] = ACTIONS(3412),
    [anon_sym_u_DQUOTE] = ACTIONS(3412),
    [anon_sym_U_DQUOTE] = ACTIONS(3412),
    [anon_sym_u8_DQUOTE] = ACTIONS(3412),
    [anon_sym_DQUOTE] = ACTIONS(3412),
    [sym_true] = ACTIONS(3410),
    [sym_false] = ACTIONS(3410),
    [anon_sym_NULL] = ACTIONS(3410),
    [anon_sym_nullptr] = ACTIONS(3410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3410),
    [anon_sym_let] = ACTIONS(3410),
    [anon_sym_This] = ACTIONS(3410),
    [anon_sym_decltype] = ACTIONS(3410),
    [sym_virtual] = ACTIONS(3410),
    [anon_sym_explicit] = ACTIONS(3410),
    [anon_sym_typename] = ACTIONS(3410),
    [anon_sym_template] = ACTIONS(3410),
    [anon_sym_operator] = ACTIONS(3410),
    [anon_sym_try] = ACTIONS(3410),
    [anon_sym_delete] = ACTIONS(3410),
    [anon_sym_throw] = ACTIONS(3410),
    [anon_sym_namespace] = ACTIONS(3410),
    [anon_sym_using] = ACTIONS(3410),
    [anon_sym_static_assert] = ACTIONS(3410),
    [anon_sym_concept] = ACTIONS(3410),
    [anon_sym_co_return] = ACTIONS(3410),
    [anon_sym_co_yield] = ACTIONS(3410),
    [anon_sym_R_DQUOTE] = ACTIONS(3412),
    [anon_sym_LR_DQUOTE] = ACTIONS(3412),
    [anon_sym_uR_DQUOTE] = ACTIONS(3412),
    [anon_sym_UR_DQUOTE] = ACTIONS(3412),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3412),
    [anon_sym_co_await] = ACTIONS(3410),
    [anon_sym_new] = ACTIONS(3410),
    [anon_sym_requires] = ACTIONS(3410),
    [sym_this] = ACTIONS(3410),
    [anon_sym_discard] = ACTIONS(3410),
    [anon_sym_precise] = ACTIONS(3410),
    [anon_sym_shared] = ACTIONS(3410),
    [anon_sym_groupshared] = ACTIONS(3410),
    [anon_sym_uniform] = ACTIONS(3410),
    [anon_sym_row_major] = ACTIONS(3410),
    [anon_sym_column_major] = ACTIONS(3410),
    [anon_sym_globallycoherent] = ACTIONS(3410),
    [anon_sym_centroid] = ACTIONS(3410),
    [anon_sym_noperspective] = ACTIONS(3410),
    [anon_sym_nointerpolation] = ACTIONS(3410),
    [anon_sym_sample] = ACTIONS(3410),
    [anon_sym_linear] = ACTIONS(3410),
    [anon_sym_snorm] = ACTIONS(3410),
    [anon_sym_unorm] = ACTIONS(3410),
    [anon_sym_point] = ACTIONS(3410),
    [anon_sym_line] = ACTIONS(3410),
    [anon_sym_triangleadj] = ACTIONS(3410),
    [anon_sym_lineadj] = ACTIONS(3410),
    [anon_sym_triangle] = ACTIONS(3410),
    [anon_sym_cbuffer] = ACTIONS(3410),
    [anon_sym_interface] = ACTIONS(3410),
    [anon_sym_extension] = ACTIONS(3410),
  },
  [953] = {
    [sym_identifier] = ACTIONS(3509),
    [aux_sym_preproc_include_token1] = ACTIONS(3509),
    [aux_sym_preproc_def_token1] = ACTIONS(3509),
    [aux_sym_preproc_if_token1] = ACTIONS(3509),
    [aux_sym_preproc_if_token2] = ACTIONS(3509),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3509),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3509),
    [sym_preproc_directive] = ACTIONS(3509),
    [anon_sym_LPAREN2] = ACTIONS(3511),
    [anon_sym_BANG] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3509),
    [anon_sym_PLUS] = ACTIONS(3509),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3511),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_SEMI] = ACTIONS(3511),
    [anon_sym___extension__] = ACTIONS(3509),
    [anon_sym_typedef] = ACTIONS(3509),
    [anon_sym_in] = ACTIONS(3509),
    [anon_sym_out] = ACTIONS(3509),
    [anon_sym_inout] = ACTIONS(3509),
    [anon_sym_extern] = ACTIONS(3509),
    [anon_sym___attribute__] = ACTIONS(3509),
    [anon_sym_COLON_COLON] = ACTIONS(3511),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3511),
    [anon_sym___declspec] = ACTIONS(3509),
    [anon_sym___based] = ACTIONS(3509),
    [anon_sym___cdecl] = ACTIONS(3509),
    [anon_sym___clrcall] = ACTIONS(3509),
    [anon_sym___stdcall] = ACTIONS(3509),
    [anon_sym___fastcall] = ACTIONS(3509),
    [anon_sym___thiscall] = ACTIONS(3509),
    [anon_sym___vectorcall] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_signed] = ACTIONS(3509),
    [anon_sym_unsigned] = ACTIONS(3509),
    [anon_sym_long] = ACTIONS(3509),
    [anon_sym_short] = ACTIONS(3509),
    [anon_sym_LBRACK] = ACTIONS(3509),
    [anon_sym_static] = ACTIONS(3509),
    [anon_sym_register] = ACTIONS(3509),
    [anon_sym_inline] = ACTIONS(3509),
    [anon_sym___inline] = ACTIONS(3509),
    [anon_sym___inline__] = ACTIONS(3509),
    [anon_sym___forceinline] = ACTIONS(3509),
    [anon_sym_thread_local] = ACTIONS(3509),
    [anon_sym___thread] = ACTIONS(3509),
    [anon_sym_const] = ACTIONS(3509),
    [anon_sym_constexpr] = ACTIONS(3509),
    [anon_sym_volatile] = ACTIONS(3509),
    [anon_sym_restrict] = ACTIONS(3509),
    [anon_sym___restrict__] = ACTIONS(3509),
    [anon_sym__Atomic] = ACTIONS(3509),
    [anon_sym__Noreturn] = ACTIONS(3509),
    [anon_sym_noreturn] = ACTIONS(3509),
    [anon_sym_mutable] = ACTIONS(3509),
    [anon_sym_constinit] = ACTIONS(3509),
    [anon_sym_consteval] = ACTIONS(3509),
    [anon_sym_alignas] = ACTIONS(3509),
    [anon_sym__Alignas] = ACTIONS(3509),
    [sym_primitive_type] = ACTIONS(3509),
    [anon_sym_enum] = ACTIONS(3509),
    [anon_sym_class] = ACTIONS(3509),
    [anon_sym_struct] = ACTIONS(3509),
    [anon_sym_union] = ACTIONS(3509),
    [anon_sym_if] = ACTIONS(3509),
    [anon_sym_switch] = ACTIONS(3509),
    [anon_sym_case] = ACTIONS(3509),
    [anon_sym_default] = ACTIONS(3509),
    [anon_sym_while] = ACTIONS(3509),
    [anon_sym_do] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3509),
    [anon_sym_return] = ACTIONS(3509),
    [anon_sym_break] = ACTIONS(3509),
    [anon_sym_continue] = ACTIONS(3509),
    [anon_sym_goto] = ACTIONS(3509),
    [anon_sym___try] = ACTIONS(3509),
    [anon_sym___leave] = ACTIONS(3509),
    [anon_sym_not] = ACTIONS(3509),
    [anon_sym_compl] = ACTIONS(3509),
    [anon_sym_DASH_DASH] = ACTIONS(3511),
    [anon_sym_PLUS_PLUS] = ACTIONS(3511),
    [anon_sym_sizeof] = ACTIONS(3509),
    [anon_sym___alignof__] = ACTIONS(3509),
    [anon_sym___alignof] = ACTIONS(3509),
    [anon_sym__alignof] = ACTIONS(3509),
    [anon_sym_alignof] = ACTIONS(3509),
    [anon_sym__Alignof] = ACTIONS(3509),
    [anon_sym_offsetof] = ACTIONS(3509),
    [anon_sym__Generic] = ACTIONS(3509),
    [anon_sym_asm] = ACTIONS(3509),
    [anon_sym___asm__] = ACTIONS(3509),
    [sym_number_literal] = ACTIONS(3511),
    [anon_sym_L_SQUOTE] = ACTIONS(3511),
    [anon_sym_u_SQUOTE] = ACTIONS(3511),
    [anon_sym_U_SQUOTE] = ACTIONS(3511),
    [anon_sym_u8_SQUOTE] = ACTIONS(3511),
    [anon_sym_SQUOTE] = ACTIONS(3511),
    [anon_sym_L_DQUOTE] = ACTIONS(3511),
    [anon_sym_u_DQUOTE] = ACTIONS(3511),
    [anon_sym_U_DQUOTE] = ACTIONS(3511),
    [anon_sym_u8_DQUOTE] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [sym_true] = ACTIONS(3509),
    [sym_false] = ACTIONS(3509),
    [anon_sym_NULL] = ACTIONS(3509),
    [anon_sym_nullptr] = ACTIONS(3509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3509),
    [anon_sym_let] = ACTIONS(3509),
    [anon_sym_This] = ACTIONS(3509),
    [anon_sym_decltype] = ACTIONS(3509),
    [sym_virtual] = ACTIONS(3509),
    [anon_sym_explicit] = ACTIONS(3509),
    [anon_sym_typename] = ACTIONS(3509),
    [anon_sym_template] = ACTIONS(3509),
    [anon_sym_operator] = ACTIONS(3509),
    [anon_sym_try] = ACTIONS(3509),
    [anon_sym_delete] = ACTIONS(3509),
    [anon_sym_throw] = ACTIONS(3509),
    [anon_sym_namespace] = ACTIONS(3509),
    [anon_sym_using] = ACTIONS(3509),
    [anon_sym_static_assert] = ACTIONS(3509),
    [anon_sym_concept] = ACTIONS(3509),
    [anon_sym_co_return] = ACTIONS(3509),
    [anon_sym_co_yield] = ACTIONS(3509),
    [anon_sym_R_DQUOTE] = ACTIONS(3511),
    [anon_sym_LR_DQUOTE] = ACTIONS(3511),
    [anon_sym_uR_DQUOTE] = ACTIONS(3511),
    [anon_sym_UR_DQUOTE] = ACTIONS(3511),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3511),
    [anon_sym_co_await] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3509),
    [anon_sym_requires] = ACTIONS(3509),
    [sym_this] = ACTIONS(3509),
    [anon_sym_discard] = ACTIONS(3509),
    [anon_sym_precise] = ACTIONS(3509),
    [anon_sym_shared] = ACTIONS(3509),
    [anon_sym_groupshared] = ACTIONS(3509),
    [anon_sym_uniform] = ACTIONS(3509),
    [anon_sym_row_major] = ACTIONS(3509),
    [anon_sym_column_major] = ACTIONS(3509),
    [anon_sym_globallycoherent] = ACTIONS(3509),
    [anon_sym_centroid] = ACTIONS(3509),
    [anon_sym_noperspective] = ACTIONS(3509),
    [anon_sym_nointerpolation] = ACTIONS(3509),
    [anon_sym_sample] = ACTIONS(3509),
    [anon_sym_linear] = ACTIONS(3509),
    [anon_sym_snorm] = ACTIONS(3509),
    [anon_sym_unorm] = ACTIONS(3509),
    [anon_sym_point] = ACTIONS(3509),
    [anon_sym_line] = ACTIONS(3509),
    [anon_sym_triangleadj] = ACTIONS(3509),
    [anon_sym_lineadj] = ACTIONS(3509),
    [anon_sym_triangle] = ACTIONS(3509),
    [anon_sym_cbuffer] = ACTIONS(3509),
    [anon_sym_interface] = ACTIONS(3509),
    [anon_sym_extension] = ACTIONS(3509),
  },
  [954] = {
    [sym_identifier] = ACTIONS(3567),
    [aux_sym_preproc_include_token1] = ACTIONS(3567),
    [aux_sym_preproc_def_token1] = ACTIONS(3567),
    [aux_sym_preproc_if_token1] = ACTIONS(3567),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3567),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3567),
    [sym_preproc_directive] = ACTIONS(3567),
    [anon_sym_LPAREN2] = ACTIONS(3569),
    [anon_sym_BANG] = ACTIONS(3569),
    [anon_sym_TILDE] = ACTIONS(3569),
    [anon_sym_DASH] = ACTIONS(3567),
    [anon_sym_PLUS] = ACTIONS(3567),
    [anon_sym_STAR] = ACTIONS(3569),
    [anon_sym_AMP_AMP] = ACTIONS(3569),
    [anon_sym_AMP] = ACTIONS(3567),
    [anon_sym_SEMI] = ACTIONS(3569),
    [anon_sym___extension__] = ACTIONS(3567),
    [anon_sym_typedef] = ACTIONS(3567),
    [anon_sym_in] = ACTIONS(3567),
    [anon_sym_out] = ACTIONS(3567),
    [anon_sym_inout] = ACTIONS(3567),
    [anon_sym_extern] = ACTIONS(3567),
    [anon_sym___attribute__] = ACTIONS(3567),
    [anon_sym_COLON_COLON] = ACTIONS(3569),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3569),
    [anon_sym___declspec] = ACTIONS(3567),
    [anon_sym___based] = ACTIONS(3567),
    [anon_sym___cdecl] = ACTIONS(3567),
    [anon_sym___clrcall] = ACTIONS(3567),
    [anon_sym___stdcall] = ACTIONS(3567),
    [anon_sym___fastcall] = ACTIONS(3567),
    [anon_sym___thiscall] = ACTIONS(3567),
    [anon_sym___vectorcall] = ACTIONS(3567),
    [anon_sym_LBRACE] = ACTIONS(3569),
    [anon_sym_RBRACE] = ACTIONS(3569),
    [anon_sym_signed] = ACTIONS(3567),
    [anon_sym_unsigned] = ACTIONS(3567),
    [anon_sym_long] = ACTIONS(3567),
    [anon_sym_short] = ACTIONS(3567),
    [anon_sym_LBRACK] = ACTIONS(3567),
    [anon_sym_static] = ACTIONS(3567),
    [anon_sym_register] = ACTIONS(3567),
    [anon_sym_inline] = ACTIONS(3567),
    [anon_sym___inline] = ACTIONS(3567),
    [anon_sym___inline__] = ACTIONS(3567),
    [anon_sym___forceinline] = ACTIONS(3567),
    [anon_sym_thread_local] = ACTIONS(3567),
    [anon_sym___thread] = ACTIONS(3567),
    [anon_sym_const] = ACTIONS(3567),
    [anon_sym_constexpr] = ACTIONS(3567),
    [anon_sym_volatile] = ACTIONS(3567),
    [anon_sym_restrict] = ACTIONS(3567),
    [anon_sym___restrict__] = ACTIONS(3567),
    [anon_sym__Atomic] = ACTIONS(3567),
    [anon_sym__Noreturn] = ACTIONS(3567),
    [anon_sym_noreturn] = ACTIONS(3567),
    [anon_sym_mutable] = ACTIONS(3567),
    [anon_sym_constinit] = ACTIONS(3567),
    [anon_sym_consteval] = ACTIONS(3567),
    [anon_sym_alignas] = ACTIONS(3567),
    [anon_sym__Alignas] = ACTIONS(3567),
    [sym_primitive_type] = ACTIONS(3567),
    [anon_sym_enum] = ACTIONS(3567),
    [anon_sym_class] = ACTIONS(3567),
    [anon_sym_struct] = ACTIONS(3567),
    [anon_sym_union] = ACTIONS(3567),
    [anon_sym_if] = ACTIONS(3567),
    [anon_sym_switch] = ACTIONS(3567),
    [anon_sym_case] = ACTIONS(3567),
    [anon_sym_default] = ACTIONS(3567),
    [anon_sym_while] = ACTIONS(3567),
    [anon_sym_do] = ACTIONS(3567),
    [anon_sym_for] = ACTIONS(3567),
    [anon_sym_return] = ACTIONS(3567),
    [anon_sym_break] = ACTIONS(3567),
    [anon_sym_continue] = ACTIONS(3567),
    [anon_sym_goto] = ACTIONS(3567),
    [anon_sym___try] = ACTIONS(3567),
    [anon_sym___leave] = ACTIONS(3567),
    [anon_sym_not] = ACTIONS(3567),
    [anon_sym_compl] = ACTIONS(3567),
    [anon_sym_DASH_DASH] = ACTIONS(3569),
    [anon_sym_PLUS_PLUS] = ACTIONS(3569),
    [anon_sym_sizeof] = ACTIONS(3567),
    [anon_sym___alignof__] = ACTIONS(3567),
    [anon_sym___alignof] = ACTIONS(3567),
    [anon_sym__alignof] = ACTIONS(3567),
    [anon_sym_alignof] = ACTIONS(3567),
    [anon_sym__Alignof] = ACTIONS(3567),
    [anon_sym_offsetof] = ACTIONS(3567),
    [anon_sym__Generic] = ACTIONS(3567),
    [anon_sym_asm] = ACTIONS(3567),
    [anon_sym___asm__] = ACTIONS(3567),
    [sym_number_literal] = ACTIONS(3569),
    [anon_sym_L_SQUOTE] = ACTIONS(3569),
    [anon_sym_u_SQUOTE] = ACTIONS(3569),
    [anon_sym_U_SQUOTE] = ACTIONS(3569),
    [anon_sym_u8_SQUOTE] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(3569),
    [anon_sym_L_DQUOTE] = ACTIONS(3569),
    [anon_sym_u_DQUOTE] = ACTIONS(3569),
    [anon_sym_U_DQUOTE] = ACTIONS(3569),
    [anon_sym_u8_DQUOTE] = ACTIONS(3569),
    [anon_sym_DQUOTE] = ACTIONS(3569),
    [sym_true] = ACTIONS(3567),
    [sym_false] = ACTIONS(3567),
    [anon_sym_NULL] = ACTIONS(3567),
    [anon_sym_nullptr] = ACTIONS(3567),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3567),
    [anon_sym_let] = ACTIONS(3567),
    [anon_sym_This] = ACTIONS(3567),
    [anon_sym_decltype] = ACTIONS(3567),
    [sym_virtual] = ACTIONS(3567),
    [anon_sym_explicit] = ACTIONS(3567),
    [anon_sym_typename] = ACTIONS(3567),
    [anon_sym_template] = ACTIONS(3567),
    [anon_sym_operator] = ACTIONS(3567),
    [anon_sym_try] = ACTIONS(3567),
    [anon_sym_delete] = ACTIONS(3567),
    [anon_sym_throw] = ACTIONS(3567),
    [anon_sym_namespace] = ACTIONS(3567),
    [anon_sym_using] = ACTIONS(3567),
    [anon_sym_static_assert] = ACTIONS(3567),
    [anon_sym_concept] = ACTIONS(3567),
    [anon_sym_co_return] = ACTIONS(3567),
    [anon_sym_co_yield] = ACTIONS(3567),
    [anon_sym_R_DQUOTE] = ACTIONS(3569),
    [anon_sym_LR_DQUOTE] = ACTIONS(3569),
    [anon_sym_uR_DQUOTE] = ACTIONS(3569),
    [anon_sym_UR_DQUOTE] = ACTIONS(3569),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3569),
    [anon_sym_co_await] = ACTIONS(3567),
    [anon_sym_new] = ACTIONS(3567),
    [anon_sym_requires] = ACTIONS(3567),
    [sym_this] = ACTIONS(3567),
    [anon_sym_discard] = ACTIONS(3567),
    [anon_sym_precise] = ACTIONS(3567),
    [anon_sym_shared] = ACTIONS(3567),
    [anon_sym_groupshared] = ACTIONS(3567),
    [anon_sym_uniform] = ACTIONS(3567),
    [anon_sym_row_major] = ACTIONS(3567),
    [anon_sym_column_major] = ACTIONS(3567),
    [anon_sym_globallycoherent] = ACTIONS(3567),
    [anon_sym_centroid] = ACTIONS(3567),
    [anon_sym_noperspective] = ACTIONS(3567),
    [anon_sym_nointerpolation] = ACTIONS(3567),
    [anon_sym_sample] = ACTIONS(3567),
    [anon_sym_linear] = ACTIONS(3567),
    [anon_sym_snorm] = ACTIONS(3567),
    [anon_sym_unorm] = ACTIONS(3567),
    [anon_sym_point] = ACTIONS(3567),
    [anon_sym_line] = ACTIONS(3567),
    [anon_sym_triangleadj] = ACTIONS(3567),
    [anon_sym_lineadj] = ACTIONS(3567),
    [anon_sym_triangle] = ACTIONS(3567),
    [anon_sym_cbuffer] = ACTIONS(3567),
    [anon_sym_interface] = ACTIONS(3567),
    [anon_sym_extension] = ACTIONS(3567),
  },
  [955] = {
    [sym_identifier] = ACTIONS(3571),
    [aux_sym_preproc_include_token1] = ACTIONS(3571),
    [aux_sym_preproc_def_token1] = ACTIONS(3571),
    [aux_sym_preproc_if_token1] = ACTIONS(3571),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3571),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3571),
    [sym_preproc_directive] = ACTIONS(3571),
    [anon_sym_LPAREN2] = ACTIONS(3573),
    [anon_sym_BANG] = ACTIONS(3573),
    [anon_sym_TILDE] = ACTIONS(3573),
    [anon_sym_DASH] = ACTIONS(3571),
    [anon_sym_PLUS] = ACTIONS(3571),
    [anon_sym_STAR] = ACTIONS(3573),
    [anon_sym_AMP_AMP] = ACTIONS(3573),
    [anon_sym_AMP] = ACTIONS(3571),
    [anon_sym_SEMI] = ACTIONS(3573),
    [anon_sym___extension__] = ACTIONS(3571),
    [anon_sym_typedef] = ACTIONS(3571),
    [anon_sym_in] = ACTIONS(3571),
    [anon_sym_out] = ACTIONS(3571),
    [anon_sym_inout] = ACTIONS(3571),
    [anon_sym_extern] = ACTIONS(3571),
    [anon_sym___attribute__] = ACTIONS(3571),
    [anon_sym_COLON_COLON] = ACTIONS(3573),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3573),
    [anon_sym___declspec] = ACTIONS(3571),
    [anon_sym___based] = ACTIONS(3571),
    [anon_sym___cdecl] = ACTIONS(3571),
    [anon_sym___clrcall] = ACTIONS(3571),
    [anon_sym___stdcall] = ACTIONS(3571),
    [anon_sym___fastcall] = ACTIONS(3571),
    [anon_sym___thiscall] = ACTIONS(3571),
    [anon_sym___vectorcall] = ACTIONS(3571),
    [anon_sym_LBRACE] = ACTIONS(3573),
    [anon_sym_RBRACE] = ACTIONS(3573),
    [anon_sym_signed] = ACTIONS(3571),
    [anon_sym_unsigned] = ACTIONS(3571),
    [anon_sym_long] = ACTIONS(3571),
    [anon_sym_short] = ACTIONS(3571),
    [anon_sym_LBRACK] = ACTIONS(3571),
    [anon_sym_static] = ACTIONS(3571),
    [anon_sym_register] = ACTIONS(3571),
    [anon_sym_inline] = ACTIONS(3571),
    [anon_sym___inline] = ACTIONS(3571),
    [anon_sym___inline__] = ACTIONS(3571),
    [anon_sym___forceinline] = ACTIONS(3571),
    [anon_sym_thread_local] = ACTIONS(3571),
    [anon_sym___thread] = ACTIONS(3571),
    [anon_sym_const] = ACTIONS(3571),
    [anon_sym_constexpr] = ACTIONS(3571),
    [anon_sym_volatile] = ACTIONS(3571),
    [anon_sym_restrict] = ACTIONS(3571),
    [anon_sym___restrict__] = ACTIONS(3571),
    [anon_sym__Atomic] = ACTIONS(3571),
    [anon_sym__Noreturn] = ACTIONS(3571),
    [anon_sym_noreturn] = ACTIONS(3571),
    [anon_sym_mutable] = ACTIONS(3571),
    [anon_sym_constinit] = ACTIONS(3571),
    [anon_sym_consteval] = ACTIONS(3571),
    [anon_sym_alignas] = ACTIONS(3571),
    [anon_sym__Alignas] = ACTIONS(3571),
    [sym_primitive_type] = ACTIONS(3571),
    [anon_sym_enum] = ACTIONS(3571),
    [anon_sym_class] = ACTIONS(3571),
    [anon_sym_struct] = ACTIONS(3571),
    [anon_sym_union] = ACTIONS(3571),
    [anon_sym_if] = ACTIONS(3571),
    [anon_sym_switch] = ACTIONS(3571),
    [anon_sym_case] = ACTIONS(3571),
    [anon_sym_default] = ACTIONS(3571),
    [anon_sym_while] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(3571),
    [anon_sym_for] = ACTIONS(3571),
    [anon_sym_return] = ACTIONS(3571),
    [anon_sym_break] = ACTIONS(3571),
    [anon_sym_continue] = ACTIONS(3571),
    [anon_sym_goto] = ACTIONS(3571),
    [anon_sym___try] = ACTIONS(3571),
    [anon_sym___leave] = ACTIONS(3571),
    [anon_sym_not] = ACTIONS(3571),
    [anon_sym_compl] = ACTIONS(3571),
    [anon_sym_DASH_DASH] = ACTIONS(3573),
    [anon_sym_PLUS_PLUS] = ACTIONS(3573),
    [anon_sym_sizeof] = ACTIONS(3571),
    [anon_sym___alignof__] = ACTIONS(3571),
    [anon_sym___alignof] = ACTIONS(3571),
    [anon_sym__alignof] = ACTIONS(3571),
    [anon_sym_alignof] = ACTIONS(3571),
    [anon_sym__Alignof] = ACTIONS(3571),
    [anon_sym_offsetof] = ACTIONS(3571),
    [anon_sym__Generic] = ACTIONS(3571),
    [anon_sym_asm] = ACTIONS(3571),
    [anon_sym___asm__] = ACTIONS(3571),
    [sym_number_literal] = ACTIONS(3573),
    [anon_sym_L_SQUOTE] = ACTIONS(3573),
    [anon_sym_u_SQUOTE] = ACTIONS(3573),
    [anon_sym_U_SQUOTE] = ACTIONS(3573),
    [anon_sym_u8_SQUOTE] = ACTIONS(3573),
    [anon_sym_SQUOTE] = ACTIONS(3573),
    [anon_sym_L_DQUOTE] = ACTIONS(3573),
    [anon_sym_u_DQUOTE] = ACTIONS(3573),
    [anon_sym_U_DQUOTE] = ACTIONS(3573),
    [anon_sym_u8_DQUOTE] = ACTIONS(3573),
    [anon_sym_DQUOTE] = ACTIONS(3573),
    [sym_true] = ACTIONS(3571),
    [sym_false] = ACTIONS(3571),
    [anon_sym_NULL] = ACTIONS(3571),
    [anon_sym_nullptr] = ACTIONS(3571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3571),
    [anon_sym_let] = ACTIONS(3571),
    [anon_sym_This] = ACTIONS(3571),
    [anon_sym_decltype] = ACTIONS(3571),
    [sym_virtual] = ACTIONS(3571),
    [anon_sym_explicit] = ACTIONS(3571),
    [anon_sym_typename] = ACTIONS(3571),
    [anon_sym_template] = ACTIONS(3571),
    [anon_sym_operator] = ACTIONS(3571),
    [anon_sym_try] = ACTIONS(3571),
    [anon_sym_delete] = ACTIONS(3571),
    [anon_sym_throw] = ACTIONS(3571),
    [anon_sym_namespace] = ACTIONS(3571),
    [anon_sym_using] = ACTIONS(3571),
    [anon_sym_static_assert] = ACTIONS(3571),
    [anon_sym_concept] = ACTIONS(3571),
    [anon_sym_co_return] = ACTIONS(3571),
    [anon_sym_co_yield] = ACTIONS(3571),
    [anon_sym_R_DQUOTE] = ACTIONS(3573),
    [anon_sym_LR_DQUOTE] = ACTIONS(3573),
    [anon_sym_uR_DQUOTE] = ACTIONS(3573),
    [anon_sym_UR_DQUOTE] = ACTIONS(3573),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3573),
    [anon_sym_co_await] = ACTIONS(3571),
    [anon_sym_new] = ACTIONS(3571),
    [anon_sym_requires] = ACTIONS(3571),
    [sym_this] = ACTIONS(3571),
    [anon_sym_discard] = ACTIONS(3571),
    [anon_sym_precise] = ACTIONS(3571),
    [anon_sym_shared] = ACTIONS(3571),
    [anon_sym_groupshared] = ACTIONS(3571),
    [anon_sym_uniform] = ACTIONS(3571),
    [anon_sym_row_major] = ACTIONS(3571),
    [anon_sym_column_major] = ACTIONS(3571),
    [anon_sym_globallycoherent] = ACTIONS(3571),
    [anon_sym_centroid] = ACTIONS(3571),
    [anon_sym_noperspective] = ACTIONS(3571),
    [anon_sym_nointerpolation] = ACTIONS(3571),
    [anon_sym_sample] = ACTIONS(3571),
    [anon_sym_linear] = ACTIONS(3571),
    [anon_sym_snorm] = ACTIONS(3571),
    [anon_sym_unorm] = ACTIONS(3571),
    [anon_sym_point] = ACTIONS(3571),
    [anon_sym_line] = ACTIONS(3571),
    [anon_sym_triangleadj] = ACTIONS(3571),
    [anon_sym_lineadj] = ACTIONS(3571),
    [anon_sym_triangle] = ACTIONS(3571),
    [anon_sym_cbuffer] = ACTIONS(3571),
    [anon_sym_interface] = ACTIONS(3571),
    [anon_sym_extension] = ACTIONS(3571),
  },
  [956] = {
    [sym_identifier] = ACTIONS(3445),
    [aux_sym_preproc_include_token1] = ACTIONS(3445),
    [aux_sym_preproc_def_token1] = ACTIONS(3445),
    [aux_sym_preproc_if_token1] = ACTIONS(3445),
    [aux_sym_preproc_if_token2] = ACTIONS(3445),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3445),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3445),
    [sym_preproc_directive] = ACTIONS(3445),
    [anon_sym_LPAREN2] = ACTIONS(3447),
    [anon_sym_BANG] = ACTIONS(3447),
    [anon_sym_TILDE] = ACTIONS(3447),
    [anon_sym_DASH] = ACTIONS(3445),
    [anon_sym_PLUS] = ACTIONS(3445),
    [anon_sym_STAR] = ACTIONS(3447),
    [anon_sym_AMP_AMP] = ACTIONS(3447),
    [anon_sym_AMP] = ACTIONS(3445),
    [anon_sym_SEMI] = ACTIONS(3447),
    [anon_sym___extension__] = ACTIONS(3445),
    [anon_sym_typedef] = ACTIONS(3445),
    [anon_sym_in] = ACTIONS(3445),
    [anon_sym_out] = ACTIONS(3445),
    [anon_sym_inout] = ACTIONS(3445),
    [anon_sym_extern] = ACTIONS(3445),
    [anon_sym___attribute__] = ACTIONS(3445),
    [anon_sym_COLON_COLON] = ACTIONS(3447),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3447),
    [anon_sym___declspec] = ACTIONS(3445),
    [anon_sym___based] = ACTIONS(3445),
    [anon_sym___cdecl] = ACTIONS(3445),
    [anon_sym___clrcall] = ACTIONS(3445),
    [anon_sym___stdcall] = ACTIONS(3445),
    [anon_sym___fastcall] = ACTIONS(3445),
    [anon_sym___thiscall] = ACTIONS(3445),
    [anon_sym___vectorcall] = ACTIONS(3445),
    [anon_sym_LBRACE] = ACTIONS(3447),
    [anon_sym_signed] = ACTIONS(3445),
    [anon_sym_unsigned] = ACTIONS(3445),
    [anon_sym_long] = ACTIONS(3445),
    [anon_sym_short] = ACTIONS(3445),
    [anon_sym_LBRACK] = ACTIONS(3445),
    [anon_sym_static] = ACTIONS(3445),
    [anon_sym_register] = ACTIONS(3445),
    [anon_sym_inline] = ACTIONS(3445),
    [anon_sym___inline] = ACTIONS(3445),
    [anon_sym___inline__] = ACTIONS(3445),
    [anon_sym___forceinline] = ACTIONS(3445),
    [anon_sym_thread_local] = ACTIONS(3445),
    [anon_sym___thread] = ACTIONS(3445),
    [anon_sym_const] = ACTIONS(3445),
    [anon_sym_constexpr] = ACTIONS(3445),
    [anon_sym_volatile] = ACTIONS(3445),
    [anon_sym_restrict] = ACTIONS(3445),
    [anon_sym___restrict__] = ACTIONS(3445),
    [anon_sym__Atomic] = ACTIONS(3445),
    [anon_sym__Noreturn] = ACTIONS(3445),
    [anon_sym_noreturn] = ACTIONS(3445),
    [anon_sym_mutable] = ACTIONS(3445),
    [anon_sym_constinit] = ACTIONS(3445),
    [anon_sym_consteval] = ACTIONS(3445),
    [anon_sym_alignas] = ACTIONS(3445),
    [anon_sym__Alignas] = ACTIONS(3445),
    [sym_primitive_type] = ACTIONS(3445),
    [anon_sym_enum] = ACTIONS(3445),
    [anon_sym_class] = ACTIONS(3445),
    [anon_sym_struct] = ACTIONS(3445),
    [anon_sym_union] = ACTIONS(3445),
    [anon_sym_if] = ACTIONS(3445),
    [anon_sym_switch] = ACTIONS(3445),
    [anon_sym_case] = ACTIONS(3445),
    [anon_sym_default] = ACTIONS(3445),
    [anon_sym_while] = ACTIONS(3445),
    [anon_sym_do] = ACTIONS(3445),
    [anon_sym_for] = ACTIONS(3445),
    [anon_sym_return] = ACTIONS(3445),
    [anon_sym_break] = ACTIONS(3445),
    [anon_sym_continue] = ACTIONS(3445),
    [anon_sym_goto] = ACTIONS(3445),
    [anon_sym___try] = ACTIONS(3445),
    [anon_sym___leave] = ACTIONS(3445),
    [anon_sym_not] = ACTIONS(3445),
    [anon_sym_compl] = ACTIONS(3445),
    [anon_sym_DASH_DASH] = ACTIONS(3447),
    [anon_sym_PLUS_PLUS] = ACTIONS(3447),
    [anon_sym_sizeof] = ACTIONS(3445),
    [anon_sym___alignof__] = ACTIONS(3445),
    [anon_sym___alignof] = ACTIONS(3445),
    [anon_sym__alignof] = ACTIONS(3445),
    [anon_sym_alignof] = ACTIONS(3445),
    [anon_sym__Alignof] = ACTIONS(3445),
    [anon_sym_offsetof] = ACTIONS(3445),
    [anon_sym__Generic] = ACTIONS(3445),
    [anon_sym_asm] = ACTIONS(3445),
    [anon_sym___asm__] = ACTIONS(3445),
    [sym_number_literal] = ACTIONS(3447),
    [anon_sym_L_SQUOTE] = ACTIONS(3447),
    [anon_sym_u_SQUOTE] = ACTIONS(3447),
    [anon_sym_U_SQUOTE] = ACTIONS(3447),
    [anon_sym_u8_SQUOTE] = ACTIONS(3447),
    [anon_sym_SQUOTE] = ACTIONS(3447),
    [anon_sym_L_DQUOTE] = ACTIONS(3447),
    [anon_sym_u_DQUOTE] = ACTIONS(3447),
    [anon_sym_U_DQUOTE] = ACTIONS(3447),
    [anon_sym_u8_DQUOTE] = ACTIONS(3447),
    [anon_sym_DQUOTE] = ACTIONS(3447),
    [sym_true] = ACTIONS(3445),
    [sym_false] = ACTIONS(3445),
    [anon_sym_NULL] = ACTIONS(3445),
    [anon_sym_nullptr] = ACTIONS(3445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3445),
    [anon_sym_let] = ACTIONS(3445),
    [anon_sym_This] = ACTIONS(3445),
    [anon_sym_decltype] = ACTIONS(3445),
    [sym_virtual] = ACTIONS(3445),
    [anon_sym_explicit] = ACTIONS(3445),
    [anon_sym_typename] = ACTIONS(3445),
    [anon_sym_template] = ACTIONS(3445),
    [anon_sym_operator] = ACTIONS(3445),
    [anon_sym_try] = ACTIONS(3445),
    [anon_sym_delete] = ACTIONS(3445),
    [anon_sym_throw] = ACTIONS(3445),
    [anon_sym_namespace] = ACTIONS(3445),
    [anon_sym_using] = ACTIONS(3445),
    [anon_sym_static_assert] = ACTIONS(3445),
    [anon_sym_concept] = ACTIONS(3445),
    [anon_sym_co_return] = ACTIONS(3445),
    [anon_sym_co_yield] = ACTIONS(3445),
    [anon_sym_R_DQUOTE] = ACTIONS(3447),
    [anon_sym_LR_DQUOTE] = ACTIONS(3447),
    [anon_sym_uR_DQUOTE] = ACTIONS(3447),
    [anon_sym_UR_DQUOTE] = ACTIONS(3447),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3447),
    [anon_sym_co_await] = ACTIONS(3445),
    [anon_sym_new] = ACTIONS(3445),
    [anon_sym_requires] = ACTIONS(3445),
    [sym_this] = ACTIONS(3445),
    [anon_sym_discard] = ACTIONS(3445),
    [anon_sym_precise] = ACTIONS(3445),
    [anon_sym_shared] = ACTIONS(3445),
    [anon_sym_groupshared] = ACTIONS(3445),
    [anon_sym_uniform] = ACTIONS(3445),
    [anon_sym_row_major] = ACTIONS(3445),
    [anon_sym_column_major] = ACTIONS(3445),
    [anon_sym_globallycoherent] = ACTIONS(3445),
    [anon_sym_centroid] = ACTIONS(3445),
    [anon_sym_noperspective] = ACTIONS(3445),
    [anon_sym_nointerpolation] = ACTIONS(3445),
    [anon_sym_sample] = ACTIONS(3445),
    [anon_sym_linear] = ACTIONS(3445),
    [anon_sym_snorm] = ACTIONS(3445),
    [anon_sym_unorm] = ACTIONS(3445),
    [anon_sym_point] = ACTIONS(3445),
    [anon_sym_line] = ACTIONS(3445),
    [anon_sym_triangleadj] = ACTIONS(3445),
    [anon_sym_lineadj] = ACTIONS(3445),
    [anon_sym_triangle] = ACTIONS(3445),
    [anon_sym_cbuffer] = ACTIONS(3445),
    [anon_sym_interface] = ACTIONS(3445),
    [anon_sym_extension] = ACTIONS(3445),
  },
  [957] = {
    [sym_identifier] = ACTIONS(3441),
    [aux_sym_preproc_include_token1] = ACTIONS(3441),
    [aux_sym_preproc_def_token1] = ACTIONS(3441),
    [aux_sym_preproc_if_token1] = ACTIONS(3441),
    [aux_sym_preproc_if_token2] = ACTIONS(3441),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3441),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3441),
    [sym_preproc_directive] = ACTIONS(3441),
    [anon_sym_LPAREN2] = ACTIONS(3443),
    [anon_sym_BANG] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3441),
    [anon_sym_PLUS] = ACTIONS(3441),
    [anon_sym_STAR] = ACTIONS(3443),
    [anon_sym_AMP_AMP] = ACTIONS(3443),
    [anon_sym_AMP] = ACTIONS(3441),
    [anon_sym_SEMI] = ACTIONS(3443),
    [anon_sym___extension__] = ACTIONS(3441),
    [anon_sym_typedef] = ACTIONS(3441),
    [anon_sym_in] = ACTIONS(3441),
    [anon_sym_out] = ACTIONS(3441),
    [anon_sym_inout] = ACTIONS(3441),
    [anon_sym_extern] = ACTIONS(3441),
    [anon_sym___attribute__] = ACTIONS(3441),
    [anon_sym_COLON_COLON] = ACTIONS(3443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3443),
    [anon_sym___declspec] = ACTIONS(3441),
    [anon_sym___based] = ACTIONS(3441),
    [anon_sym___cdecl] = ACTIONS(3441),
    [anon_sym___clrcall] = ACTIONS(3441),
    [anon_sym___stdcall] = ACTIONS(3441),
    [anon_sym___fastcall] = ACTIONS(3441),
    [anon_sym___thiscall] = ACTIONS(3441),
    [anon_sym___vectorcall] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_signed] = ACTIONS(3441),
    [anon_sym_unsigned] = ACTIONS(3441),
    [anon_sym_long] = ACTIONS(3441),
    [anon_sym_short] = ACTIONS(3441),
    [anon_sym_LBRACK] = ACTIONS(3441),
    [anon_sym_static] = ACTIONS(3441),
    [anon_sym_register] = ACTIONS(3441),
    [anon_sym_inline] = ACTIONS(3441),
    [anon_sym___inline] = ACTIONS(3441),
    [anon_sym___inline__] = ACTIONS(3441),
    [anon_sym___forceinline] = ACTIONS(3441),
    [anon_sym_thread_local] = ACTIONS(3441),
    [anon_sym___thread] = ACTIONS(3441),
    [anon_sym_const] = ACTIONS(3441),
    [anon_sym_constexpr] = ACTIONS(3441),
    [anon_sym_volatile] = ACTIONS(3441),
    [anon_sym_restrict] = ACTIONS(3441),
    [anon_sym___restrict__] = ACTIONS(3441),
    [anon_sym__Atomic] = ACTIONS(3441),
    [anon_sym__Noreturn] = ACTIONS(3441),
    [anon_sym_noreturn] = ACTIONS(3441),
    [anon_sym_mutable] = ACTIONS(3441),
    [anon_sym_constinit] = ACTIONS(3441),
    [anon_sym_consteval] = ACTIONS(3441),
    [anon_sym_alignas] = ACTIONS(3441),
    [anon_sym__Alignas] = ACTIONS(3441),
    [sym_primitive_type] = ACTIONS(3441),
    [anon_sym_enum] = ACTIONS(3441),
    [anon_sym_class] = ACTIONS(3441),
    [anon_sym_struct] = ACTIONS(3441),
    [anon_sym_union] = ACTIONS(3441),
    [anon_sym_if] = ACTIONS(3441),
    [anon_sym_switch] = ACTIONS(3441),
    [anon_sym_case] = ACTIONS(3441),
    [anon_sym_default] = ACTIONS(3441),
    [anon_sym_while] = ACTIONS(3441),
    [anon_sym_do] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3441),
    [anon_sym_return] = ACTIONS(3441),
    [anon_sym_break] = ACTIONS(3441),
    [anon_sym_continue] = ACTIONS(3441),
    [anon_sym_goto] = ACTIONS(3441),
    [anon_sym___try] = ACTIONS(3441),
    [anon_sym___leave] = ACTIONS(3441),
    [anon_sym_not] = ACTIONS(3441),
    [anon_sym_compl] = ACTIONS(3441),
    [anon_sym_DASH_DASH] = ACTIONS(3443),
    [anon_sym_PLUS_PLUS] = ACTIONS(3443),
    [anon_sym_sizeof] = ACTIONS(3441),
    [anon_sym___alignof__] = ACTIONS(3441),
    [anon_sym___alignof] = ACTIONS(3441),
    [anon_sym__alignof] = ACTIONS(3441),
    [anon_sym_alignof] = ACTIONS(3441),
    [anon_sym__Alignof] = ACTIONS(3441),
    [anon_sym_offsetof] = ACTIONS(3441),
    [anon_sym__Generic] = ACTIONS(3441),
    [anon_sym_asm] = ACTIONS(3441),
    [anon_sym___asm__] = ACTIONS(3441),
    [sym_number_literal] = ACTIONS(3443),
    [anon_sym_L_SQUOTE] = ACTIONS(3443),
    [anon_sym_u_SQUOTE] = ACTIONS(3443),
    [anon_sym_U_SQUOTE] = ACTIONS(3443),
    [anon_sym_u8_SQUOTE] = ACTIONS(3443),
    [anon_sym_SQUOTE] = ACTIONS(3443),
    [anon_sym_L_DQUOTE] = ACTIONS(3443),
    [anon_sym_u_DQUOTE] = ACTIONS(3443),
    [anon_sym_U_DQUOTE] = ACTIONS(3443),
    [anon_sym_u8_DQUOTE] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3443),
    [sym_true] = ACTIONS(3441),
    [sym_false] = ACTIONS(3441),
    [anon_sym_NULL] = ACTIONS(3441),
    [anon_sym_nullptr] = ACTIONS(3441),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3441),
    [anon_sym_let] = ACTIONS(3441),
    [anon_sym_This] = ACTIONS(3441),
    [anon_sym_decltype] = ACTIONS(3441),
    [sym_virtual] = ACTIONS(3441),
    [anon_sym_explicit] = ACTIONS(3441),
    [anon_sym_typename] = ACTIONS(3441),
    [anon_sym_template] = ACTIONS(3441),
    [anon_sym_operator] = ACTIONS(3441),
    [anon_sym_try] = ACTIONS(3441),
    [anon_sym_delete] = ACTIONS(3441),
    [anon_sym_throw] = ACTIONS(3441),
    [anon_sym_namespace] = ACTIONS(3441),
    [anon_sym_using] = ACTIONS(3441),
    [anon_sym_static_assert] = ACTIONS(3441),
    [anon_sym_concept] = ACTIONS(3441),
    [anon_sym_co_return] = ACTIONS(3441),
    [anon_sym_co_yield] = ACTIONS(3441),
    [anon_sym_R_DQUOTE] = ACTIONS(3443),
    [anon_sym_LR_DQUOTE] = ACTIONS(3443),
    [anon_sym_uR_DQUOTE] = ACTIONS(3443),
    [anon_sym_UR_DQUOTE] = ACTIONS(3443),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3443),
    [anon_sym_co_await] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3441),
    [anon_sym_requires] = ACTIONS(3441),
    [sym_this] = ACTIONS(3441),
    [anon_sym_discard] = ACTIONS(3441),
    [anon_sym_precise] = ACTIONS(3441),
    [anon_sym_shared] = ACTIONS(3441),
    [anon_sym_groupshared] = ACTIONS(3441),
    [anon_sym_uniform] = ACTIONS(3441),
    [anon_sym_row_major] = ACTIONS(3441),
    [anon_sym_column_major] = ACTIONS(3441),
    [anon_sym_globallycoherent] = ACTIONS(3441),
    [anon_sym_centroid] = ACTIONS(3441),
    [anon_sym_noperspective] = ACTIONS(3441),
    [anon_sym_nointerpolation] = ACTIONS(3441),
    [anon_sym_sample] = ACTIONS(3441),
    [anon_sym_linear] = ACTIONS(3441),
    [anon_sym_snorm] = ACTIONS(3441),
    [anon_sym_unorm] = ACTIONS(3441),
    [anon_sym_point] = ACTIONS(3441),
    [anon_sym_line] = ACTIONS(3441),
    [anon_sym_triangleadj] = ACTIONS(3441),
    [anon_sym_lineadj] = ACTIONS(3441),
    [anon_sym_triangle] = ACTIONS(3441),
    [anon_sym_cbuffer] = ACTIONS(3441),
    [anon_sym_interface] = ACTIONS(3441),
    [anon_sym_extension] = ACTIONS(3441),
  },
  [958] = {
    [sym_identifier] = ACTIONS(3517),
    [aux_sym_preproc_include_token1] = ACTIONS(3517),
    [aux_sym_preproc_def_token1] = ACTIONS(3517),
    [aux_sym_preproc_if_token1] = ACTIONS(3517),
    [aux_sym_preproc_if_token2] = ACTIONS(3517),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3517),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3517),
    [sym_preproc_directive] = ACTIONS(3517),
    [anon_sym_LPAREN2] = ACTIONS(3519),
    [anon_sym_BANG] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3517),
    [anon_sym_PLUS] = ACTIONS(3517),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym_SEMI] = ACTIONS(3519),
    [anon_sym___extension__] = ACTIONS(3517),
    [anon_sym_typedef] = ACTIONS(3517),
    [anon_sym_in] = ACTIONS(3517),
    [anon_sym_out] = ACTIONS(3517),
    [anon_sym_inout] = ACTIONS(3517),
    [anon_sym_extern] = ACTIONS(3517),
    [anon_sym___attribute__] = ACTIONS(3517),
    [anon_sym_COLON_COLON] = ACTIONS(3519),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3519),
    [anon_sym___declspec] = ACTIONS(3517),
    [anon_sym___based] = ACTIONS(3517),
    [anon_sym___cdecl] = ACTIONS(3517),
    [anon_sym___clrcall] = ACTIONS(3517),
    [anon_sym___stdcall] = ACTIONS(3517),
    [anon_sym___fastcall] = ACTIONS(3517),
    [anon_sym___thiscall] = ACTIONS(3517),
    [anon_sym___vectorcall] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_signed] = ACTIONS(3517),
    [anon_sym_unsigned] = ACTIONS(3517),
    [anon_sym_long] = ACTIONS(3517),
    [anon_sym_short] = ACTIONS(3517),
    [anon_sym_LBRACK] = ACTIONS(3517),
    [anon_sym_static] = ACTIONS(3517),
    [anon_sym_register] = ACTIONS(3517),
    [anon_sym_inline] = ACTIONS(3517),
    [anon_sym___inline] = ACTIONS(3517),
    [anon_sym___inline__] = ACTIONS(3517),
    [anon_sym___forceinline] = ACTIONS(3517),
    [anon_sym_thread_local] = ACTIONS(3517),
    [anon_sym___thread] = ACTIONS(3517),
    [anon_sym_const] = ACTIONS(3517),
    [anon_sym_constexpr] = ACTIONS(3517),
    [anon_sym_volatile] = ACTIONS(3517),
    [anon_sym_restrict] = ACTIONS(3517),
    [anon_sym___restrict__] = ACTIONS(3517),
    [anon_sym__Atomic] = ACTIONS(3517),
    [anon_sym__Noreturn] = ACTIONS(3517),
    [anon_sym_noreturn] = ACTIONS(3517),
    [anon_sym_mutable] = ACTIONS(3517),
    [anon_sym_constinit] = ACTIONS(3517),
    [anon_sym_consteval] = ACTIONS(3517),
    [anon_sym_alignas] = ACTIONS(3517),
    [anon_sym__Alignas] = ACTIONS(3517),
    [sym_primitive_type] = ACTIONS(3517),
    [anon_sym_enum] = ACTIONS(3517),
    [anon_sym_class] = ACTIONS(3517),
    [anon_sym_struct] = ACTIONS(3517),
    [anon_sym_union] = ACTIONS(3517),
    [anon_sym_if] = ACTIONS(3517),
    [anon_sym_switch] = ACTIONS(3517),
    [anon_sym_case] = ACTIONS(3517),
    [anon_sym_default] = ACTIONS(3517),
    [anon_sym_while] = ACTIONS(3517),
    [anon_sym_do] = ACTIONS(3517),
    [anon_sym_for] = ACTIONS(3517),
    [anon_sym_return] = ACTIONS(3517),
    [anon_sym_break] = ACTIONS(3517),
    [anon_sym_continue] = ACTIONS(3517),
    [anon_sym_goto] = ACTIONS(3517),
    [anon_sym___try] = ACTIONS(3517),
    [anon_sym___leave] = ACTIONS(3517),
    [anon_sym_not] = ACTIONS(3517),
    [anon_sym_compl] = ACTIONS(3517),
    [anon_sym_DASH_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_PLUS] = ACTIONS(3519),
    [anon_sym_sizeof] = ACTIONS(3517),
    [anon_sym___alignof__] = ACTIONS(3517),
    [anon_sym___alignof] = ACTIONS(3517),
    [anon_sym__alignof] = ACTIONS(3517),
    [anon_sym_alignof] = ACTIONS(3517),
    [anon_sym__Alignof] = ACTIONS(3517),
    [anon_sym_offsetof] = ACTIONS(3517),
    [anon_sym__Generic] = ACTIONS(3517),
    [anon_sym_asm] = ACTIONS(3517),
    [anon_sym___asm__] = ACTIONS(3517),
    [sym_number_literal] = ACTIONS(3519),
    [anon_sym_L_SQUOTE] = ACTIONS(3519),
    [anon_sym_u_SQUOTE] = ACTIONS(3519),
    [anon_sym_U_SQUOTE] = ACTIONS(3519),
    [anon_sym_u8_SQUOTE] = ACTIONS(3519),
    [anon_sym_SQUOTE] = ACTIONS(3519),
    [anon_sym_L_DQUOTE] = ACTIONS(3519),
    [anon_sym_u_DQUOTE] = ACTIONS(3519),
    [anon_sym_U_DQUOTE] = ACTIONS(3519),
    [anon_sym_u8_DQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [sym_true] = ACTIONS(3517),
    [sym_false] = ACTIONS(3517),
    [anon_sym_NULL] = ACTIONS(3517),
    [anon_sym_nullptr] = ACTIONS(3517),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3517),
    [anon_sym_let] = ACTIONS(3517),
    [anon_sym_This] = ACTIONS(3517),
    [anon_sym_decltype] = ACTIONS(3517),
    [sym_virtual] = ACTIONS(3517),
    [anon_sym_explicit] = ACTIONS(3517),
    [anon_sym_typename] = ACTIONS(3517),
    [anon_sym_template] = ACTIONS(3517),
    [anon_sym_operator] = ACTIONS(3517),
    [anon_sym_try] = ACTIONS(3517),
    [anon_sym_delete] = ACTIONS(3517),
    [anon_sym_throw] = ACTIONS(3517),
    [anon_sym_namespace] = ACTIONS(3517),
    [anon_sym_using] = ACTIONS(3517),
    [anon_sym_static_assert] = ACTIONS(3517),
    [anon_sym_concept] = ACTIONS(3517),
    [anon_sym_co_return] = ACTIONS(3517),
    [anon_sym_co_yield] = ACTIONS(3517),
    [anon_sym_R_DQUOTE] = ACTIONS(3519),
    [anon_sym_LR_DQUOTE] = ACTIONS(3519),
    [anon_sym_uR_DQUOTE] = ACTIONS(3519),
    [anon_sym_UR_DQUOTE] = ACTIONS(3519),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3519),
    [anon_sym_co_await] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3517),
    [anon_sym_requires] = ACTIONS(3517),
    [sym_this] = ACTIONS(3517),
    [anon_sym_discard] = ACTIONS(3517),
    [anon_sym_precise] = ACTIONS(3517),
    [anon_sym_shared] = ACTIONS(3517),
    [anon_sym_groupshared] = ACTIONS(3517),
    [anon_sym_uniform] = ACTIONS(3517),
    [anon_sym_row_major] = ACTIONS(3517),
    [anon_sym_column_major] = ACTIONS(3517),
    [anon_sym_globallycoherent] = ACTIONS(3517),
    [anon_sym_centroid] = ACTIONS(3517),
    [anon_sym_noperspective] = ACTIONS(3517),
    [anon_sym_nointerpolation] = ACTIONS(3517),
    [anon_sym_sample] = ACTIONS(3517),
    [anon_sym_linear] = ACTIONS(3517),
    [anon_sym_snorm] = ACTIONS(3517),
    [anon_sym_unorm] = ACTIONS(3517),
    [anon_sym_point] = ACTIONS(3517),
    [anon_sym_line] = ACTIONS(3517),
    [anon_sym_triangleadj] = ACTIONS(3517),
    [anon_sym_lineadj] = ACTIONS(3517),
    [anon_sym_triangle] = ACTIONS(3517),
    [anon_sym_cbuffer] = ACTIONS(3517),
    [anon_sym_interface] = ACTIONS(3517),
    [anon_sym_extension] = ACTIONS(3517),
  },
  [959] = {
    [sym_identifier] = ACTIONS(3641),
    [aux_sym_preproc_include_token1] = ACTIONS(3641),
    [aux_sym_preproc_def_token1] = ACTIONS(3641),
    [aux_sym_preproc_if_token1] = ACTIONS(3641),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3641),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3641),
    [sym_preproc_directive] = ACTIONS(3641),
    [anon_sym_LPAREN2] = ACTIONS(3643),
    [anon_sym_BANG] = ACTIONS(3643),
    [anon_sym_TILDE] = ACTIONS(3643),
    [anon_sym_DASH] = ACTIONS(3641),
    [anon_sym_PLUS] = ACTIONS(3641),
    [anon_sym_STAR] = ACTIONS(3643),
    [anon_sym_AMP_AMP] = ACTIONS(3643),
    [anon_sym_AMP] = ACTIONS(3641),
    [anon_sym_SEMI] = ACTIONS(3643),
    [anon_sym___extension__] = ACTIONS(3641),
    [anon_sym_typedef] = ACTIONS(3641),
    [anon_sym_in] = ACTIONS(3641),
    [anon_sym_out] = ACTIONS(3641),
    [anon_sym_inout] = ACTIONS(3641),
    [anon_sym_extern] = ACTIONS(3641),
    [anon_sym___attribute__] = ACTIONS(3641),
    [anon_sym_COLON_COLON] = ACTIONS(3643),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3643),
    [anon_sym___declspec] = ACTIONS(3641),
    [anon_sym___based] = ACTIONS(3641),
    [anon_sym___cdecl] = ACTIONS(3641),
    [anon_sym___clrcall] = ACTIONS(3641),
    [anon_sym___stdcall] = ACTIONS(3641),
    [anon_sym___fastcall] = ACTIONS(3641),
    [anon_sym___thiscall] = ACTIONS(3641),
    [anon_sym___vectorcall] = ACTIONS(3641),
    [anon_sym_LBRACE] = ACTIONS(3643),
    [anon_sym_RBRACE] = ACTIONS(3643),
    [anon_sym_signed] = ACTIONS(3641),
    [anon_sym_unsigned] = ACTIONS(3641),
    [anon_sym_long] = ACTIONS(3641),
    [anon_sym_short] = ACTIONS(3641),
    [anon_sym_LBRACK] = ACTIONS(3641),
    [anon_sym_static] = ACTIONS(3641),
    [anon_sym_register] = ACTIONS(3641),
    [anon_sym_inline] = ACTIONS(3641),
    [anon_sym___inline] = ACTIONS(3641),
    [anon_sym___inline__] = ACTIONS(3641),
    [anon_sym___forceinline] = ACTIONS(3641),
    [anon_sym_thread_local] = ACTIONS(3641),
    [anon_sym___thread] = ACTIONS(3641),
    [anon_sym_const] = ACTIONS(3641),
    [anon_sym_constexpr] = ACTIONS(3641),
    [anon_sym_volatile] = ACTIONS(3641),
    [anon_sym_restrict] = ACTIONS(3641),
    [anon_sym___restrict__] = ACTIONS(3641),
    [anon_sym__Atomic] = ACTIONS(3641),
    [anon_sym__Noreturn] = ACTIONS(3641),
    [anon_sym_noreturn] = ACTIONS(3641),
    [anon_sym_mutable] = ACTIONS(3641),
    [anon_sym_constinit] = ACTIONS(3641),
    [anon_sym_consteval] = ACTIONS(3641),
    [anon_sym_alignas] = ACTIONS(3641),
    [anon_sym__Alignas] = ACTIONS(3641),
    [sym_primitive_type] = ACTIONS(3641),
    [anon_sym_enum] = ACTIONS(3641),
    [anon_sym_class] = ACTIONS(3641),
    [anon_sym_struct] = ACTIONS(3641),
    [anon_sym_union] = ACTIONS(3641),
    [anon_sym_if] = ACTIONS(3641),
    [anon_sym_switch] = ACTIONS(3641),
    [anon_sym_case] = ACTIONS(3641),
    [anon_sym_default] = ACTIONS(3641),
    [anon_sym_while] = ACTIONS(3641),
    [anon_sym_do] = ACTIONS(3641),
    [anon_sym_for] = ACTIONS(3641),
    [anon_sym_return] = ACTIONS(3641),
    [anon_sym_break] = ACTIONS(3641),
    [anon_sym_continue] = ACTIONS(3641),
    [anon_sym_goto] = ACTIONS(3641),
    [anon_sym___try] = ACTIONS(3641),
    [anon_sym___leave] = ACTIONS(3641),
    [anon_sym_not] = ACTIONS(3641),
    [anon_sym_compl] = ACTIONS(3641),
    [anon_sym_DASH_DASH] = ACTIONS(3643),
    [anon_sym_PLUS_PLUS] = ACTIONS(3643),
    [anon_sym_sizeof] = ACTIONS(3641),
    [anon_sym___alignof__] = ACTIONS(3641),
    [anon_sym___alignof] = ACTIONS(3641),
    [anon_sym__alignof] = ACTIONS(3641),
    [anon_sym_alignof] = ACTIONS(3641),
    [anon_sym__Alignof] = ACTIONS(3641),
    [anon_sym_offsetof] = ACTIONS(3641),
    [anon_sym__Generic] = ACTIONS(3641),
    [anon_sym_asm] = ACTIONS(3641),
    [anon_sym___asm__] = ACTIONS(3641),
    [sym_number_literal] = ACTIONS(3643),
    [anon_sym_L_SQUOTE] = ACTIONS(3643),
    [anon_sym_u_SQUOTE] = ACTIONS(3643),
    [anon_sym_U_SQUOTE] = ACTIONS(3643),
    [anon_sym_u8_SQUOTE] = ACTIONS(3643),
    [anon_sym_SQUOTE] = ACTIONS(3643),
    [anon_sym_L_DQUOTE] = ACTIONS(3643),
    [anon_sym_u_DQUOTE] = ACTIONS(3643),
    [anon_sym_U_DQUOTE] = ACTIONS(3643),
    [anon_sym_u8_DQUOTE] = ACTIONS(3643),
    [anon_sym_DQUOTE] = ACTIONS(3643),
    [sym_true] = ACTIONS(3641),
    [sym_false] = ACTIONS(3641),
    [anon_sym_NULL] = ACTIONS(3641),
    [anon_sym_nullptr] = ACTIONS(3641),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3641),
    [anon_sym_let] = ACTIONS(3641),
    [anon_sym_This] = ACTIONS(3641),
    [anon_sym_decltype] = ACTIONS(3641),
    [sym_virtual] = ACTIONS(3641),
    [anon_sym_explicit] = ACTIONS(3641),
    [anon_sym_typename] = ACTIONS(3641),
    [anon_sym_template] = ACTIONS(3641),
    [anon_sym_operator] = ACTIONS(3641),
    [anon_sym_try] = ACTIONS(3641),
    [anon_sym_delete] = ACTIONS(3641),
    [anon_sym_throw] = ACTIONS(3641),
    [anon_sym_namespace] = ACTIONS(3641),
    [anon_sym_using] = ACTIONS(3641),
    [anon_sym_static_assert] = ACTIONS(3641),
    [anon_sym_concept] = ACTIONS(3641),
    [anon_sym_co_return] = ACTIONS(3641),
    [anon_sym_co_yield] = ACTIONS(3641),
    [anon_sym_R_DQUOTE] = ACTIONS(3643),
    [anon_sym_LR_DQUOTE] = ACTIONS(3643),
    [anon_sym_uR_DQUOTE] = ACTIONS(3643),
    [anon_sym_UR_DQUOTE] = ACTIONS(3643),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3643),
    [anon_sym_co_await] = ACTIONS(3641),
    [anon_sym_new] = ACTIONS(3641),
    [anon_sym_requires] = ACTIONS(3641),
    [sym_this] = ACTIONS(3641),
    [anon_sym_discard] = ACTIONS(3641),
    [anon_sym_precise] = ACTIONS(3641),
    [anon_sym_shared] = ACTIONS(3641),
    [anon_sym_groupshared] = ACTIONS(3641),
    [anon_sym_uniform] = ACTIONS(3641),
    [anon_sym_row_major] = ACTIONS(3641),
    [anon_sym_column_major] = ACTIONS(3641),
    [anon_sym_globallycoherent] = ACTIONS(3641),
    [anon_sym_centroid] = ACTIONS(3641),
    [anon_sym_noperspective] = ACTIONS(3641),
    [anon_sym_nointerpolation] = ACTIONS(3641),
    [anon_sym_sample] = ACTIONS(3641),
    [anon_sym_linear] = ACTIONS(3641),
    [anon_sym_snorm] = ACTIONS(3641),
    [anon_sym_unorm] = ACTIONS(3641),
    [anon_sym_point] = ACTIONS(3641),
    [anon_sym_line] = ACTIONS(3641),
    [anon_sym_triangleadj] = ACTIONS(3641),
    [anon_sym_lineadj] = ACTIONS(3641),
    [anon_sym_triangle] = ACTIONS(3641),
    [anon_sym_cbuffer] = ACTIONS(3641),
    [anon_sym_interface] = ACTIONS(3641),
    [anon_sym_extension] = ACTIONS(3641),
  },
  [960] = {
    [sym_identifier] = ACTIONS(3629),
    [aux_sym_preproc_include_token1] = ACTIONS(3629),
    [aux_sym_preproc_def_token1] = ACTIONS(3629),
    [aux_sym_preproc_if_token1] = ACTIONS(3629),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3629),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3629),
    [sym_preproc_directive] = ACTIONS(3629),
    [anon_sym_LPAREN2] = ACTIONS(3631),
    [anon_sym_BANG] = ACTIONS(3631),
    [anon_sym_TILDE] = ACTIONS(3631),
    [anon_sym_DASH] = ACTIONS(3629),
    [anon_sym_PLUS] = ACTIONS(3629),
    [anon_sym_STAR] = ACTIONS(3631),
    [anon_sym_AMP_AMP] = ACTIONS(3631),
    [anon_sym_AMP] = ACTIONS(3629),
    [anon_sym_SEMI] = ACTIONS(3631),
    [anon_sym___extension__] = ACTIONS(3629),
    [anon_sym_typedef] = ACTIONS(3629),
    [anon_sym_in] = ACTIONS(3629),
    [anon_sym_out] = ACTIONS(3629),
    [anon_sym_inout] = ACTIONS(3629),
    [anon_sym_extern] = ACTIONS(3629),
    [anon_sym___attribute__] = ACTIONS(3629),
    [anon_sym_COLON_COLON] = ACTIONS(3631),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3631),
    [anon_sym___declspec] = ACTIONS(3629),
    [anon_sym___based] = ACTIONS(3629),
    [anon_sym___cdecl] = ACTIONS(3629),
    [anon_sym___clrcall] = ACTIONS(3629),
    [anon_sym___stdcall] = ACTIONS(3629),
    [anon_sym___fastcall] = ACTIONS(3629),
    [anon_sym___thiscall] = ACTIONS(3629),
    [anon_sym___vectorcall] = ACTIONS(3629),
    [anon_sym_LBRACE] = ACTIONS(3631),
    [anon_sym_RBRACE] = ACTIONS(3631),
    [anon_sym_signed] = ACTIONS(3629),
    [anon_sym_unsigned] = ACTIONS(3629),
    [anon_sym_long] = ACTIONS(3629),
    [anon_sym_short] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3629),
    [anon_sym_static] = ACTIONS(3629),
    [anon_sym_register] = ACTIONS(3629),
    [anon_sym_inline] = ACTIONS(3629),
    [anon_sym___inline] = ACTIONS(3629),
    [anon_sym___inline__] = ACTIONS(3629),
    [anon_sym___forceinline] = ACTIONS(3629),
    [anon_sym_thread_local] = ACTIONS(3629),
    [anon_sym___thread] = ACTIONS(3629),
    [anon_sym_const] = ACTIONS(3629),
    [anon_sym_constexpr] = ACTIONS(3629),
    [anon_sym_volatile] = ACTIONS(3629),
    [anon_sym_restrict] = ACTIONS(3629),
    [anon_sym___restrict__] = ACTIONS(3629),
    [anon_sym__Atomic] = ACTIONS(3629),
    [anon_sym__Noreturn] = ACTIONS(3629),
    [anon_sym_noreturn] = ACTIONS(3629),
    [anon_sym_mutable] = ACTIONS(3629),
    [anon_sym_constinit] = ACTIONS(3629),
    [anon_sym_consteval] = ACTIONS(3629),
    [anon_sym_alignas] = ACTIONS(3629),
    [anon_sym__Alignas] = ACTIONS(3629),
    [sym_primitive_type] = ACTIONS(3629),
    [anon_sym_enum] = ACTIONS(3629),
    [anon_sym_class] = ACTIONS(3629),
    [anon_sym_struct] = ACTIONS(3629),
    [anon_sym_union] = ACTIONS(3629),
    [anon_sym_if] = ACTIONS(3629),
    [anon_sym_switch] = ACTIONS(3629),
    [anon_sym_case] = ACTIONS(3629),
    [anon_sym_default] = ACTIONS(3629),
    [anon_sym_while] = ACTIONS(3629),
    [anon_sym_do] = ACTIONS(3629),
    [anon_sym_for] = ACTIONS(3629),
    [anon_sym_return] = ACTIONS(3629),
    [anon_sym_break] = ACTIONS(3629),
    [anon_sym_continue] = ACTIONS(3629),
    [anon_sym_goto] = ACTIONS(3629),
    [anon_sym___try] = ACTIONS(3629),
    [anon_sym___leave] = ACTIONS(3629),
    [anon_sym_not] = ACTIONS(3629),
    [anon_sym_compl] = ACTIONS(3629),
    [anon_sym_DASH_DASH] = ACTIONS(3631),
    [anon_sym_PLUS_PLUS] = ACTIONS(3631),
    [anon_sym_sizeof] = ACTIONS(3629),
    [anon_sym___alignof__] = ACTIONS(3629),
    [anon_sym___alignof] = ACTIONS(3629),
    [anon_sym__alignof] = ACTIONS(3629),
    [anon_sym_alignof] = ACTIONS(3629),
    [anon_sym__Alignof] = ACTIONS(3629),
    [anon_sym_offsetof] = ACTIONS(3629),
    [anon_sym__Generic] = ACTIONS(3629),
    [anon_sym_asm] = ACTIONS(3629),
    [anon_sym___asm__] = ACTIONS(3629),
    [sym_number_literal] = ACTIONS(3631),
    [anon_sym_L_SQUOTE] = ACTIONS(3631),
    [anon_sym_u_SQUOTE] = ACTIONS(3631),
    [anon_sym_U_SQUOTE] = ACTIONS(3631),
    [anon_sym_u8_SQUOTE] = ACTIONS(3631),
    [anon_sym_SQUOTE] = ACTIONS(3631),
    [anon_sym_L_DQUOTE] = ACTIONS(3631),
    [anon_sym_u_DQUOTE] = ACTIONS(3631),
    [anon_sym_U_DQUOTE] = ACTIONS(3631),
    [anon_sym_u8_DQUOTE] = ACTIONS(3631),
    [anon_sym_DQUOTE] = ACTIONS(3631),
    [sym_true] = ACTIONS(3629),
    [sym_false] = ACTIONS(3629),
    [anon_sym_NULL] = ACTIONS(3629),
    [anon_sym_nullptr] = ACTIONS(3629),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3629),
    [anon_sym_let] = ACTIONS(3629),
    [anon_sym_This] = ACTIONS(3629),
    [anon_sym_decltype] = ACTIONS(3629),
    [sym_virtual] = ACTIONS(3629),
    [anon_sym_explicit] = ACTIONS(3629),
    [anon_sym_typename] = ACTIONS(3629),
    [anon_sym_template] = ACTIONS(3629),
    [anon_sym_operator] = ACTIONS(3629),
    [anon_sym_try] = ACTIONS(3629),
    [anon_sym_delete] = ACTIONS(3629),
    [anon_sym_throw] = ACTIONS(3629),
    [anon_sym_namespace] = ACTIONS(3629),
    [anon_sym_using] = ACTIONS(3629),
    [anon_sym_static_assert] = ACTIONS(3629),
    [anon_sym_concept] = ACTIONS(3629),
    [anon_sym_co_return] = ACTIONS(3629),
    [anon_sym_co_yield] = ACTIONS(3629),
    [anon_sym_R_DQUOTE] = ACTIONS(3631),
    [anon_sym_LR_DQUOTE] = ACTIONS(3631),
    [anon_sym_uR_DQUOTE] = ACTIONS(3631),
    [anon_sym_UR_DQUOTE] = ACTIONS(3631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3631),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3629),
    [anon_sym_requires] = ACTIONS(3629),
    [sym_this] = ACTIONS(3629),
    [anon_sym_discard] = ACTIONS(3629),
    [anon_sym_precise] = ACTIONS(3629),
    [anon_sym_shared] = ACTIONS(3629),
    [anon_sym_groupshared] = ACTIONS(3629),
    [anon_sym_uniform] = ACTIONS(3629),
    [anon_sym_row_major] = ACTIONS(3629),
    [anon_sym_column_major] = ACTIONS(3629),
    [anon_sym_globallycoherent] = ACTIONS(3629),
    [anon_sym_centroid] = ACTIONS(3629),
    [anon_sym_noperspective] = ACTIONS(3629),
    [anon_sym_nointerpolation] = ACTIONS(3629),
    [anon_sym_sample] = ACTIONS(3629),
    [anon_sym_linear] = ACTIONS(3629),
    [anon_sym_snorm] = ACTIONS(3629),
    [anon_sym_unorm] = ACTIONS(3629),
    [anon_sym_point] = ACTIONS(3629),
    [anon_sym_line] = ACTIONS(3629),
    [anon_sym_triangleadj] = ACTIONS(3629),
    [anon_sym_lineadj] = ACTIONS(3629),
    [anon_sym_triangle] = ACTIONS(3629),
    [anon_sym_cbuffer] = ACTIONS(3629),
    [anon_sym_interface] = ACTIONS(3629),
    [anon_sym_extension] = ACTIONS(3629),
  },
  [961] = {
    [sym_identifier] = ACTIONS(3543),
    [aux_sym_preproc_include_token1] = ACTIONS(3543),
    [aux_sym_preproc_def_token1] = ACTIONS(3543),
    [aux_sym_preproc_if_token1] = ACTIONS(3543),
    [aux_sym_preproc_if_token2] = ACTIONS(3543),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3543),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3543),
    [sym_preproc_directive] = ACTIONS(3543),
    [anon_sym_LPAREN2] = ACTIONS(3545),
    [anon_sym_BANG] = ACTIONS(3545),
    [anon_sym_TILDE] = ACTIONS(3545),
    [anon_sym_DASH] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(3543),
    [anon_sym_STAR] = ACTIONS(3545),
    [anon_sym_AMP_AMP] = ACTIONS(3545),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_SEMI] = ACTIONS(3545),
    [anon_sym___extension__] = ACTIONS(3543),
    [anon_sym_typedef] = ACTIONS(3543),
    [anon_sym_in] = ACTIONS(3543),
    [anon_sym_out] = ACTIONS(3543),
    [anon_sym_inout] = ACTIONS(3543),
    [anon_sym_extern] = ACTIONS(3543),
    [anon_sym___attribute__] = ACTIONS(3543),
    [anon_sym_COLON_COLON] = ACTIONS(3545),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3545),
    [anon_sym___declspec] = ACTIONS(3543),
    [anon_sym___based] = ACTIONS(3543),
    [anon_sym___cdecl] = ACTIONS(3543),
    [anon_sym___clrcall] = ACTIONS(3543),
    [anon_sym___stdcall] = ACTIONS(3543),
    [anon_sym___fastcall] = ACTIONS(3543),
    [anon_sym___thiscall] = ACTIONS(3543),
    [anon_sym___vectorcall] = ACTIONS(3543),
    [anon_sym_LBRACE] = ACTIONS(3545),
    [anon_sym_signed] = ACTIONS(3543),
    [anon_sym_unsigned] = ACTIONS(3543),
    [anon_sym_long] = ACTIONS(3543),
    [anon_sym_short] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3543),
    [anon_sym_static] = ACTIONS(3543),
    [anon_sym_register] = ACTIONS(3543),
    [anon_sym_inline] = ACTIONS(3543),
    [anon_sym___inline] = ACTIONS(3543),
    [anon_sym___inline__] = ACTIONS(3543),
    [anon_sym___forceinline] = ACTIONS(3543),
    [anon_sym_thread_local] = ACTIONS(3543),
    [anon_sym___thread] = ACTIONS(3543),
    [anon_sym_const] = ACTIONS(3543),
    [anon_sym_constexpr] = ACTIONS(3543),
    [anon_sym_volatile] = ACTIONS(3543),
    [anon_sym_restrict] = ACTIONS(3543),
    [anon_sym___restrict__] = ACTIONS(3543),
    [anon_sym__Atomic] = ACTIONS(3543),
    [anon_sym__Noreturn] = ACTIONS(3543),
    [anon_sym_noreturn] = ACTIONS(3543),
    [anon_sym_mutable] = ACTIONS(3543),
    [anon_sym_constinit] = ACTIONS(3543),
    [anon_sym_consteval] = ACTIONS(3543),
    [anon_sym_alignas] = ACTIONS(3543),
    [anon_sym__Alignas] = ACTIONS(3543),
    [sym_primitive_type] = ACTIONS(3543),
    [anon_sym_enum] = ACTIONS(3543),
    [anon_sym_class] = ACTIONS(3543),
    [anon_sym_struct] = ACTIONS(3543),
    [anon_sym_union] = ACTIONS(3543),
    [anon_sym_if] = ACTIONS(3543),
    [anon_sym_switch] = ACTIONS(3543),
    [anon_sym_case] = ACTIONS(3543),
    [anon_sym_default] = ACTIONS(3543),
    [anon_sym_while] = ACTIONS(3543),
    [anon_sym_do] = ACTIONS(3543),
    [anon_sym_for] = ACTIONS(3543),
    [anon_sym_return] = ACTIONS(3543),
    [anon_sym_break] = ACTIONS(3543),
    [anon_sym_continue] = ACTIONS(3543),
    [anon_sym_goto] = ACTIONS(3543),
    [anon_sym___try] = ACTIONS(3543),
    [anon_sym___leave] = ACTIONS(3543),
    [anon_sym_not] = ACTIONS(3543),
    [anon_sym_compl] = ACTIONS(3543),
    [anon_sym_DASH_DASH] = ACTIONS(3545),
    [anon_sym_PLUS_PLUS] = ACTIONS(3545),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym___alignof__] = ACTIONS(3543),
    [anon_sym___alignof] = ACTIONS(3543),
    [anon_sym__alignof] = ACTIONS(3543),
    [anon_sym_alignof] = ACTIONS(3543),
    [anon_sym__Alignof] = ACTIONS(3543),
    [anon_sym_offsetof] = ACTIONS(3543),
    [anon_sym__Generic] = ACTIONS(3543),
    [anon_sym_asm] = ACTIONS(3543),
    [anon_sym___asm__] = ACTIONS(3543),
    [sym_number_literal] = ACTIONS(3545),
    [anon_sym_L_SQUOTE] = ACTIONS(3545),
    [anon_sym_u_SQUOTE] = ACTIONS(3545),
    [anon_sym_U_SQUOTE] = ACTIONS(3545),
    [anon_sym_u8_SQUOTE] = ACTIONS(3545),
    [anon_sym_SQUOTE] = ACTIONS(3545),
    [anon_sym_L_DQUOTE] = ACTIONS(3545),
    [anon_sym_u_DQUOTE] = ACTIONS(3545),
    [anon_sym_U_DQUOTE] = ACTIONS(3545),
    [anon_sym_u8_DQUOTE] = ACTIONS(3545),
    [anon_sym_DQUOTE] = ACTIONS(3545),
    [sym_true] = ACTIONS(3543),
    [sym_false] = ACTIONS(3543),
    [anon_sym_NULL] = ACTIONS(3543),
    [anon_sym_nullptr] = ACTIONS(3543),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3543),
    [anon_sym_This] = ACTIONS(3543),
    [anon_sym_decltype] = ACTIONS(3543),
    [sym_virtual] = ACTIONS(3543),
    [anon_sym_explicit] = ACTIONS(3543),
    [anon_sym_typename] = ACTIONS(3543),
    [anon_sym_template] = ACTIONS(3543),
    [anon_sym_operator] = ACTIONS(3543),
    [anon_sym_try] = ACTIONS(3543),
    [anon_sym_delete] = ACTIONS(3543),
    [anon_sym_throw] = ACTIONS(3543),
    [anon_sym_namespace] = ACTIONS(3543),
    [anon_sym_using] = ACTIONS(3543),
    [anon_sym_static_assert] = ACTIONS(3543),
    [anon_sym_concept] = ACTIONS(3543),
    [anon_sym_co_return] = ACTIONS(3543),
    [anon_sym_co_yield] = ACTIONS(3543),
    [anon_sym_R_DQUOTE] = ACTIONS(3545),
    [anon_sym_LR_DQUOTE] = ACTIONS(3545),
    [anon_sym_uR_DQUOTE] = ACTIONS(3545),
    [anon_sym_UR_DQUOTE] = ACTIONS(3545),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3545),
    [anon_sym_co_await] = ACTIONS(3543),
    [anon_sym_new] = ACTIONS(3543),
    [anon_sym_requires] = ACTIONS(3543),
    [sym_this] = ACTIONS(3543),
    [anon_sym_discard] = ACTIONS(3543),
    [anon_sym_precise] = ACTIONS(3543),
    [anon_sym_shared] = ACTIONS(3543),
    [anon_sym_groupshared] = ACTIONS(3543),
    [anon_sym_uniform] = ACTIONS(3543),
    [anon_sym_row_major] = ACTIONS(3543),
    [anon_sym_column_major] = ACTIONS(3543),
    [anon_sym_globallycoherent] = ACTIONS(3543),
    [anon_sym_centroid] = ACTIONS(3543),
    [anon_sym_noperspective] = ACTIONS(3543),
    [anon_sym_nointerpolation] = ACTIONS(3543),
    [anon_sym_sample] = ACTIONS(3543),
    [anon_sym_linear] = ACTIONS(3543),
    [anon_sym_snorm] = ACTIONS(3543),
    [anon_sym_unorm] = ACTIONS(3543),
    [anon_sym_point] = ACTIONS(3543),
    [anon_sym_line] = ACTIONS(3543),
    [anon_sym_triangleadj] = ACTIONS(3543),
    [anon_sym_lineadj] = ACTIONS(3543),
    [anon_sym_triangle] = ACTIONS(3543),
    [anon_sym_cbuffer] = ACTIONS(3543),
    [anon_sym_interface] = ACTIONS(3543),
    [anon_sym_extension] = ACTIONS(3543),
  },
  [962] = {
    [sym_identifier] = ACTIONS(3559),
    [aux_sym_preproc_include_token1] = ACTIONS(3559),
    [aux_sym_preproc_def_token1] = ACTIONS(3559),
    [aux_sym_preproc_if_token1] = ACTIONS(3559),
    [aux_sym_preproc_if_token2] = ACTIONS(3559),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3559),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3559),
    [sym_preproc_directive] = ACTIONS(3559),
    [anon_sym_LPAREN2] = ACTIONS(3561),
    [anon_sym_BANG] = ACTIONS(3561),
    [anon_sym_TILDE] = ACTIONS(3561),
    [anon_sym_DASH] = ACTIONS(3559),
    [anon_sym_PLUS] = ACTIONS(3559),
    [anon_sym_STAR] = ACTIONS(3561),
    [anon_sym_AMP_AMP] = ACTIONS(3561),
    [anon_sym_AMP] = ACTIONS(3559),
    [anon_sym_SEMI] = ACTIONS(3561),
    [anon_sym___extension__] = ACTIONS(3559),
    [anon_sym_typedef] = ACTIONS(3559),
    [anon_sym_in] = ACTIONS(3559),
    [anon_sym_out] = ACTIONS(3559),
    [anon_sym_inout] = ACTIONS(3559),
    [anon_sym_extern] = ACTIONS(3559),
    [anon_sym___attribute__] = ACTIONS(3559),
    [anon_sym_COLON_COLON] = ACTIONS(3561),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3561),
    [anon_sym___declspec] = ACTIONS(3559),
    [anon_sym___based] = ACTIONS(3559),
    [anon_sym___cdecl] = ACTIONS(3559),
    [anon_sym___clrcall] = ACTIONS(3559),
    [anon_sym___stdcall] = ACTIONS(3559),
    [anon_sym___fastcall] = ACTIONS(3559),
    [anon_sym___thiscall] = ACTIONS(3559),
    [anon_sym___vectorcall] = ACTIONS(3559),
    [anon_sym_LBRACE] = ACTIONS(3561),
    [anon_sym_signed] = ACTIONS(3559),
    [anon_sym_unsigned] = ACTIONS(3559),
    [anon_sym_long] = ACTIONS(3559),
    [anon_sym_short] = ACTIONS(3559),
    [anon_sym_LBRACK] = ACTIONS(3559),
    [anon_sym_static] = ACTIONS(3559),
    [anon_sym_register] = ACTIONS(3559),
    [anon_sym_inline] = ACTIONS(3559),
    [anon_sym___inline] = ACTIONS(3559),
    [anon_sym___inline__] = ACTIONS(3559),
    [anon_sym___forceinline] = ACTIONS(3559),
    [anon_sym_thread_local] = ACTIONS(3559),
    [anon_sym___thread] = ACTIONS(3559),
    [anon_sym_const] = ACTIONS(3559),
    [anon_sym_constexpr] = ACTIONS(3559),
    [anon_sym_volatile] = ACTIONS(3559),
    [anon_sym_restrict] = ACTIONS(3559),
    [anon_sym___restrict__] = ACTIONS(3559),
    [anon_sym__Atomic] = ACTIONS(3559),
    [anon_sym__Noreturn] = ACTIONS(3559),
    [anon_sym_noreturn] = ACTIONS(3559),
    [anon_sym_mutable] = ACTIONS(3559),
    [anon_sym_constinit] = ACTIONS(3559),
    [anon_sym_consteval] = ACTIONS(3559),
    [anon_sym_alignas] = ACTIONS(3559),
    [anon_sym__Alignas] = ACTIONS(3559),
    [sym_primitive_type] = ACTIONS(3559),
    [anon_sym_enum] = ACTIONS(3559),
    [anon_sym_class] = ACTIONS(3559),
    [anon_sym_struct] = ACTIONS(3559),
    [anon_sym_union] = ACTIONS(3559),
    [anon_sym_if] = ACTIONS(3559),
    [anon_sym_switch] = ACTIONS(3559),
    [anon_sym_case] = ACTIONS(3559),
    [anon_sym_default] = ACTIONS(3559),
    [anon_sym_while] = ACTIONS(3559),
    [anon_sym_do] = ACTIONS(3559),
    [anon_sym_for] = ACTIONS(3559),
    [anon_sym_return] = ACTIONS(3559),
    [anon_sym_break] = ACTIONS(3559),
    [anon_sym_continue] = ACTIONS(3559),
    [anon_sym_goto] = ACTIONS(3559),
    [anon_sym___try] = ACTIONS(3559),
    [anon_sym___leave] = ACTIONS(3559),
    [anon_sym_not] = ACTIONS(3559),
    [anon_sym_compl] = ACTIONS(3559),
    [anon_sym_DASH_DASH] = ACTIONS(3561),
    [anon_sym_PLUS_PLUS] = ACTIONS(3561),
    [anon_sym_sizeof] = ACTIONS(3559),
    [anon_sym___alignof__] = ACTIONS(3559),
    [anon_sym___alignof] = ACTIONS(3559),
    [anon_sym__alignof] = ACTIONS(3559),
    [anon_sym_alignof] = ACTIONS(3559),
    [anon_sym__Alignof] = ACTIONS(3559),
    [anon_sym_offsetof] = ACTIONS(3559),
    [anon_sym__Generic] = ACTIONS(3559),
    [anon_sym_asm] = ACTIONS(3559),
    [anon_sym___asm__] = ACTIONS(3559),
    [sym_number_literal] = ACTIONS(3561),
    [anon_sym_L_SQUOTE] = ACTIONS(3561),
    [anon_sym_u_SQUOTE] = ACTIONS(3561),
    [anon_sym_U_SQUOTE] = ACTIONS(3561),
    [anon_sym_u8_SQUOTE] = ACTIONS(3561),
    [anon_sym_SQUOTE] = ACTIONS(3561),
    [anon_sym_L_DQUOTE] = ACTIONS(3561),
    [anon_sym_u_DQUOTE] = ACTIONS(3561),
    [anon_sym_U_DQUOTE] = ACTIONS(3561),
    [anon_sym_u8_DQUOTE] = ACTIONS(3561),
    [anon_sym_DQUOTE] = ACTIONS(3561),
    [sym_true] = ACTIONS(3559),
    [sym_false] = ACTIONS(3559),
    [anon_sym_NULL] = ACTIONS(3559),
    [anon_sym_nullptr] = ACTIONS(3559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3559),
    [anon_sym_let] = ACTIONS(3559),
    [anon_sym_This] = ACTIONS(3559),
    [anon_sym_decltype] = ACTIONS(3559),
    [sym_virtual] = ACTIONS(3559),
    [anon_sym_explicit] = ACTIONS(3559),
    [anon_sym_typename] = ACTIONS(3559),
    [anon_sym_template] = ACTIONS(3559),
    [anon_sym_operator] = ACTIONS(3559),
    [anon_sym_try] = ACTIONS(3559),
    [anon_sym_delete] = ACTIONS(3559),
    [anon_sym_throw] = ACTIONS(3559),
    [anon_sym_namespace] = ACTIONS(3559),
    [anon_sym_using] = ACTIONS(3559),
    [anon_sym_static_assert] = ACTIONS(3559),
    [anon_sym_concept] = ACTIONS(3559),
    [anon_sym_co_return] = ACTIONS(3559),
    [anon_sym_co_yield] = ACTIONS(3559),
    [anon_sym_R_DQUOTE] = ACTIONS(3561),
    [anon_sym_LR_DQUOTE] = ACTIONS(3561),
    [anon_sym_uR_DQUOTE] = ACTIONS(3561),
    [anon_sym_UR_DQUOTE] = ACTIONS(3561),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3561),
    [anon_sym_co_await] = ACTIONS(3559),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_requires] = ACTIONS(3559),
    [sym_this] = ACTIONS(3559),
    [anon_sym_discard] = ACTIONS(3559),
    [anon_sym_precise] = ACTIONS(3559),
    [anon_sym_shared] = ACTIONS(3559),
    [anon_sym_groupshared] = ACTIONS(3559),
    [anon_sym_uniform] = ACTIONS(3559),
    [anon_sym_row_major] = ACTIONS(3559),
    [anon_sym_column_major] = ACTIONS(3559),
    [anon_sym_globallycoherent] = ACTIONS(3559),
    [anon_sym_centroid] = ACTIONS(3559),
    [anon_sym_noperspective] = ACTIONS(3559),
    [anon_sym_nointerpolation] = ACTIONS(3559),
    [anon_sym_sample] = ACTIONS(3559),
    [anon_sym_linear] = ACTIONS(3559),
    [anon_sym_snorm] = ACTIONS(3559),
    [anon_sym_unorm] = ACTIONS(3559),
    [anon_sym_point] = ACTIONS(3559),
    [anon_sym_line] = ACTIONS(3559),
    [anon_sym_triangleadj] = ACTIONS(3559),
    [anon_sym_lineadj] = ACTIONS(3559),
    [anon_sym_triangle] = ACTIONS(3559),
    [anon_sym_cbuffer] = ACTIONS(3559),
    [anon_sym_interface] = ACTIONS(3559),
    [anon_sym_extension] = ACTIONS(3559),
  },
  [963] = {
    [sym_identifier] = ACTIONS(3563),
    [aux_sym_preproc_include_token1] = ACTIONS(3563),
    [aux_sym_preproc_def_token1] = ACTIONS(3563),
    [aux_sym_preproc_if_token1] = ACTIONS(3563),
    [aux_sym_preproc_if_token2] = ACTIONS(3563),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3563),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3563),
    [sym_preproc_directive] = ACTIONS(3563),
    [anon_sym_LPAREN2] = ACTIONS(3565),
    [anon_sym_BANG] = ACTIONS(3565),
    [anon_sym_TILDE] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3563),
    [anon_sym_PLUS] = ACTIONS(3563),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_AMP_AMP] = ACTIONS(3565),
    [anon_sym_AMP] = ACTIONS(3563),
    [anon_sym_SEMI] = ACTIONS(3565),
    [anon_sym___extension__] = ACTIONS(3563),
    [anon_sym_typedef] = ACTIONS(3563),
    [anon_sym_in] = ACTIONS(3563),
    [anon_sym_out] = ACTIONS(3563),
    [anon_sym_inout] = ACTIONS(3563),
    [anon_sym_extern] = ACTIONS(3563),
    [anon_sym___attribute__] = ACTIONS(3563),
    [anon_sym_COLON_COLON] = ACTIONS(3565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3565),
    [anon_sym___declspec] = ACTIONS(3563),
    [anon_sym___based] = ACTIONS(3563),
    [anon_sym___cdecl] = ACTIONS(3563),
    [anon_sym___clrcall] = ACTIONS(3563),
    [anon_sym___stdcall] = ACTIONS(3563),
    [anon_sym___fastcall] = ACTIONS(3563),
    [anon_sym___thiscall] = ACTIONS(3563),
    [anon_sym___vectorcall] = ACTIONS(3563),
    [anon_sym_LBRACE] = ACTIONS(3565),
    [anon_sym_signed] = ACTIONS(3563),
    [anon_sym_unsigned] = ACTIONS(3563),
    [anon_sym_long] = ACTIONS(3563),
    [anon_sym_short] = ACTIONS(3563),
    [anon_sym_LBRACK] = ACTIONS(3563),
    [anon_sym_static] = ACTIONS(3563),
    [anon_sym_register] = ACTIONS(3563),
    [anon_sym_inline] = ACTIONS(3563),
    [anon_sym___inline] = ACTIONS(3563),
    [anon_sym___inline__] = ACTIONS(3563),
    [anon_sym___forceinline] = ACTIONS(3563),
    [anon_sym_thread_local] = ACTIONS(3563),
    [anon_sym___thread] = ACTIONS(3563),
    [anon_sym_const] = ACTIONS(3563),
    [anon_sym_constexpr] = ACTIONS(3563),
    [anon_sym_volatile] = ACTIONS(3563),
    [anon_sym_restrict] = ACTIONS(3563),
    [anon_sym___restrict__] = ACTIONS(3563),
    [anon_sym__Atomic] = ACTIONS(3563),
    [anon_sym__Noreturn] = ACTIONS(3563),
    [anon_sym_noreturn] = ACTIONS(3563),
    [anon_sym_mutable] = ACTIONS(3563),
    [anon_sym_constinit] = ACTIONS(3563),
    [anon_sym_consteval] = ACTIONS(3563),
    [anon_sym_alignas] = ACTIONS(3563),
    [anon_sym__Alignas] = ACTIONS(3563),
    [sym_primitive_type] = ACTIONS(3563),
    [anon_sym_enum] = ACTIONS(3563),
    [anon_sym_class] = ACTIONS(3563),
    [anon_sym_struct] = ACTIONS(3563),
    [anon_sym_union] = ACTIONS(3563),
    [anon_sym_if] = ACTIONS(3563),
    [anon_sym_switch] = ACTIONS(3563),
    [anon_sym_case] = ACTIONS(3563),
    [anon_sym_default] = ACTIONS(3563),
    [anon_sym_while] = ACTIONS(3563),
    [anon_sym_do] = ACTIONS(3563),
    [anon_sym_for] = ACTIONS(3563),
    [anon_sym_return] = ACTIONS(3563),
    [anon_sym_break] = ACTIONS(3563),
    [anon_sym_continue] = ACTIONS(3563),
    [anon_sym_goto] = ACTIONS(3563),
    [anon_sym___try] = ACTIONS(3563),
    [anon_sym___leave] = ACTIONS(3563),
    [anon_sym_not] = ACTIONS(3563),
    [anon_sym_compl] = ACTIONS(3563),
    [anon_sym_DASH_DASH] = ACTIONS(3565),
    [anon_sym_PLUS_PLUS] = ACTIONS(3565),
    [anon_sym_sizeof] = ACTIONS(3563),
    [anon_sym___alignof__] = ACTIONS(3563),
    [anon_sym___alignof] = ACTIONS(3563),
    [anon_sym__alignof] = ACTIONS(3563),
    [anon_sym_alignof] = ACTIONS(3563),
    [anon_sym__Alignof] = ACTIONS(3563),
    [anon_sym_offsetof] = ACTIONS(3563),
    [anon_sym__Generic] = ACTIONS(3563),
    [anon_sym_asm] = ACTIONS(3563),
    [anon_sym___asm__] = ACTIONS(3563),
    [sym_number_literal] = ACTIONS(3565),
    [anon_sym_L_SQUOTE] = ACTIONS(3565),
    [anon_sym_u_SQUOTE] = ACTIONS(3565),
    [anon_sym_U_SQUOTE] = ACTIONS(3565),
    [anon_sym_u8_SQUOTE] = ACTIONS(3565),
    [anon_sym_SQUOTE] = ACTIONS(3565),
    [anon_sym_L_DQUOTE] = ACTIONS(3565),
    [anon_sym_u_DQUOTE] = ACTIONS(3565),
    [anon_sym_U_DQUOTE] = ACTIONS(3565),
    [anon_sym_u8_DQUOTE] = ACTIONS(3565),
    [anon_sym_DQUOTE] = ACTIONS(3565),
    [sym_true] = ACTIONS(3563),
    [sym_false] = ACTIONS(3563),
    [anon_sym_NULL] = ACTIONS(3563),
    [anon_sym_nullptr] = ACTIONS(3563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3563),
    [anon_sym_let] = ACTIONS(3563),
    [anon_sym_This] = ACTIONS(3563),
    [anon_sym_decltype] = ACTIONS(3563),
    [sym_virtual] = ACTIONS(3563),
    [anon_sym_explicit] = ACTIONS(3563),
    [anon_sym_typename] = ACTIONS(3563),
    [anon_sym_template] = ACTIONS(3563),
    [anon_sym_operator] = ACTIONS(3563),
    [anon_sym_try] = ACTIONS(3563),
    [anon_sym_delete] = ACTIONS(3563),
    [anon_sym_throw] = ACTIONS(3563),
    [anon_sym_namespace] = ACTIONS(3563),
    [anon_sym_using] = ACTIONS(3563),
    [anon_sym_static_assert] = ACTIONS(3563),
    [anon_sym_concept] = ACTIONS(3563),
    [anon_sym_co_return] = ACTIONS(3563),
    [anon_sym_co_yield] = ACTIONS(3563),
    [anon_sym_R_DQUOTE] = ACTIONS(3565),
    [anon_sym_LR_DQUOTE] = ACTIONS(3565),
    [anon_sym_uR_DQUOTE] = ACTIONS(3565),
    [anon_sym_UR_DQUOTE] = ACTIONS(3565),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3565),
    [anon_sym_co_await] = ACTIONS(3563),
    [anon_sym_new] = ACTIONS(3563),
    [anon_sym_requires] = ACTIONS(3563),
    [sym_this] = ACTIONS(3563),
    [anon_sym_discard] = ACTIONS(3563),
    [anon_sym_precise] = ACTIONS(3563),
    [anon_sym_shared] = ACTIONS(3563),
    [anon_sym_groupshared] = ACTIONS(3563),
    [anon_sym_uniform] = ACTIONS(3563),
    [anon_sym_row_major] = ACTIONS(3563),
    [anon_sym_column_major] = ACTIONS(3563),
    [anon_sym_globallycoherent] = ACTIONS(3563),
    [anon_sym_centroid] = ACTIONS(3563),
    [anon_sym_noperspective] = ACTIONS(3563),
    [anon_sym_nointerpolation] = ACTIONS(3563),
    [anon_sym_sample] = ACTIONS(3563),
    [anon_sym_linear] = ACTIONS(3563),
    [anon_sym_snorm] = ACTIONS(3563),
    [anon_sym_unorm] = ACTIONS(3563),
    [anon_sym_point] = ACTIONS(3563),
    [anon_sym_line] = ACTIONS(3563),
    [anon_sym_triangleadj] = ACTIONS(3563),
    [anon_sym_lineadj] = ACTIONS(3563),
    [anon_sym_triangle] = ACTIONS(3563),
    [anon_sym_cbuffer] = ACTIONS(3563),
    [anon_sym_interface] = ACTIONS(3563),
    [anon_sym_extension] = ACTIONS(3563),
  },
  [964] = {
    [sym_identifier] = ACTIONS(3575),
    [aux_sym_preproc_include_token1] = ACTIONS(3575),
    [aux_sym_preproc_def_token1] = ACTIONS(3575),
    [aux_sym_preproc_if_token1] = ACTIONS(3575),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3575),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3575),
    [sym_preproc_directive] = ACTIONS(3575),
    [anon_sym_LPAREN2] = ACTIONS(3577),
    [anon_sym_BANG] = ACTIONS(3577),
    [anon_sym_TILDE] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3575),
    [anon_sym_PLUS] = ACTIONS(3575),
    [anon_sym_STAR] = ACTIONS(3577),
    [anon_sym_AMP_AMP] = ACTIONS(3577),
    [anon_sym_AMP] = ACTIONS(3575),
    [anon_sym_SEMI] = ACTIONS(3577),
    [anon_sym___extension__] = ACTIONS(3575),
    [anon_sym_typedef] = ACTIONS(3575),
    [anon_sym_in] = ACTIONS(3575),
    [anon_sym_out] = ACTIONS(3575),
    [anon_sym_inout] = ACTIONS(3575),
    [anon_sym_extern] = ACTIONS(3575),
    [anon_sym___attribute__] = ACTIONS(3575),
    [anon_sym_COLON_COLON] = ACTIONS(3577),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3577),
    [anon_sym___declspec] = ACTIONS(3575),
    [anon_sym___based] = ACTIONS(3575),
    [anon_sym___cdecl] = ACTIONS(3575),
    [anon_sym___clrcall] = ACTIONS(3575),
    [anon_sym___stdcall] = ACTIONS(3575),
    [anon_sym___fastcall] = ACTIONS(3575),
    [anon_sym___thiscall] = ACTIONS(3575),
    [anon_sym___vectorcall] = ACTIONS(3575),
    [anon_sym_LBRACE] = ACTIONS(3577),
    [anon_sym_RBRACE] = ACTIONS(3577),
    [anon_sym_signed] = ACTIONS(3575),
    [anon_sym_unsigned] = ACTIONS(3575),
    [anon_sym_long] = ACTIONS(3575),
    [anon_sym_short] = ACTIONS(3575),
    [anon_sym_LBRACK] = ACTIONS(3575),
    [anon_sym_static] = ACTIONS(3575),
    [anon_sym_register] = ACTIONS(3575),
    [anon_sym_inline] = ACTIONS(3575),
    [anon_sym___inline] = ACTIONS(3575),
    [anon_sym___inline__] = ACTIONS(3575),
    [anon_sym___forceinline] = ACTIONS(3575),
    [anon_sym_thread_local] = ACTIONS(3575),
    [anon_sym___thread] = ACTIONS(3575),
    [anon_sym_const] = ACTIONS(3575),
    [anon_sym_constexpr] = ACTIONS(3575),
    [anon_sym_volatile] = ACTIONS(3575),
    [anon_sym_restrict] = ACTIONS(3575),
    [anon_sym___restrict__] = ACTIONS(3575),
    [anon_sym__Atomic] = ACTIONS(3575),
    [anon_sym__Noreturn] = ACTIONS(3575),
    [anon_sym_noreturn] = ACTIONS(3575),
    [anon_sym_mutable] = ACTIONS(3575),
    [anon_sym_constinit] = ACTIONS(3575),
    [anon_sym_consteval] = ACTIONS(3575),
    [anon_sym_alignas] = ACTIONS(3575),
    [anon_sym__Alignas] = ACTIONS(3575),
    [sym_primitive_type] = ACTIONS(3575),
    [anon_sym_enum] = ACTIONS(3575),
    [anon_sym_class] = ACTIONS(3575),
    [anon_sym_struct] = ACTIONS(3575),
    [anon_sym_union] = ACTIONS(3575),
    [anon_sym_if] = ACTIONS(3575),
    [anon_sym_switch] = ACTIONS(3575),
    [anon_sym_case] = ACTIONS(3575),
    [anon_sym_default] = ACTIONS(3575),
    [anon_sym_while] = ACTIONS(3575),
    [anon_sym_do] = ACTIONS(3575),
    [anon_sym_for] = ACTIONS(3575),
    [anon_sym_return] = ACTIONS(3575),
    [anon_sym_break] = ACTIONS(3575),
    [anon_sym_continue] = ACTIONS(3575),
    [anon_sym_goto] = ACTIONS(3575),
    [anon_sym___try] = ACTIONS(3575),
    [anon_sym___leave] = ACTIONS(3575),
    [anon_sym_not] = ACTIONS(3575),
    [anon_sym_compl] = ACTIONS(3575),
    [anon_sym_DASH_DASH] = ACTIONS(3577),
    [anon_sym_PLUS_PLUS] = ACTIONS(3577),
    [anon_sym_sizeof] = ACTIONS(3575),
    [anon_sym___alignof__] = ACTIONS(3575),
    [anon_sym___alignof] = ACTIONS(3575),
    [anon_sym__alignof] = ACTIONS(3575),
    [anon_sym_alignof] = ACTIONS(3575),
    [anon_sym__Alignof] = ACTIONS(3575),
    [anon_sym_offsetof] = ACTIONS(3575),
    [anon_sym__Generic] = ACTIONS(3575),
    [anon_sym_asm] = ACTIONS(3575),
    [anon_sym___asm__] = ACTIONS(3575),
    [sym_number_literal] = ACTIONS(3577),
    [anon_sym_L_SQUOTE] = ACTIONS(3577),
    [anon_sym_u_SQUOTE] = ACTIONS(3577),
    [anon_sym_U_SQUOTE] = ACTIONS(3577),
    [anon_sym_u8_SQUOTE] = ACTIONS(3577),
    [anon_sym_SQUOTE] = ACTIONS(3577),
    [anon_sym_L_DQUOTE] = ACTIONS(3577),
    [anon_sym_u_DQUOTE] = ACTIONS(3577),
    [anon_sym_U_DQUOTE] = ACTIONS(3577),
    [anon_sym_u8_DQUOTE] = ACTIONS(3577),
    [anon_sym_DQUOTE] = ACTIONS(3577),
    [sym_true] = ACTIONS(3575),
    [sym_false] = ACTIONS(3575),
    [anon_sym_NULL] = ACTIONS(3575),
    [anon_sym_nullptr] = ACTIONS(3575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3575),
    [anon_sym_let] = ACTIONS(3575),
    [anon_sym_This] = ACTIONS(3575),
    [anon_sym_decltype] = ACTIONS(3575),
    [sym_virtual] = ACTIONS(3575),
    [anon_sym_explicit] = ACTIONS(3575),
    [anon_sym_typename] = ACTIONS(3575),
    [anon_sym_template] = ACTIONS(3575),
    [anon_sym_operator] = ACTIONS(3575),
    [anon_sym_try] = ACTIONS(3575),
    [anon_sym_delete] = ACTIONS(3575),
    [anon_sym_throw] = ACTIONS(3575),
    [anon_sym_namespace] = ACTIONS(3575),
    [anon_sym_using] = ACTIONS(3575),
    [anon_sym_static_assert] = ACTIONS(3575),
    [anon_sym_concept] = ACTIONS(3575),
    [anon_sym_co_return] = ACTIONS(3575),
    [anon_sym_co_yield] = ACTIONS(3575),
    [anon_sym_R_DQUOTE] = ACTIONS(3577),
    [anon_sym_LR_DQUOTE] = ACTIONS(3577),
    [anon_sym_uR_DQUOTE] = ACTIONS(3577),
    [anon_sym_UR_DQUOTE] = ACTIONS(3577),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3577),
    [anon_sym_co_await] = ACTIONS(3575),
    [anon_sym_new] = ACTIONS(3575),
    [anon_sym_requires] = ACTIONS(3575),
    [sym_this] = ACTIONS(3575),
    [anon_sym_discard] = ACTIONS(3575),
    [anon_sym_precise] = ACTIONS(3575),
    [anon_sym_shared] = ACTIONS(3575),
    [anon_sym_groupshared] = ACTIONS(3575),
    [anon_sym_uniform] = ACTIONS(3575),
    [anon_sym_row_major] = ACTIONS(3575),
    [anon_sym_column_major] = ACTIONS(3575),
    [anon_sym_globallycoherent] = ACTIONS(3575),
    [anon_sym_centroid] = ACTIONS(3575),
    [anon_sym_noperspective] = ACTIONS(3575),
    [anon_sym_nointerpolation] = ACTIONS(3575),
    [anon_sym_sample] = ACTIONS(3575),
    [anon_sym_linear] = ACTIONS(3575),
    [anon_sym_snorm] = ACTIONS(3575),
    [anon_sym_unorm] = ACTIONS(3575),
    [anon_sym_point] = ACTIONS(3575),
    [anon_sym_line] = ACTIONS(3575),
    [anon_sym_triangleadj] = ACTIONS(3575),
    [anon_sym_lineadj] = ACTIONS(3575),
    [anon_sym_triangle] = ACTIONS(3575),
    [anon_sym_cbuffer] = ACTIONS(3575),
    [anon_sym_interface] = ACTIONS(3575),
    [anon_sym_extension] = ACTIONS(3575),
  },
  [965] = {
    [sym_attribute_specifier] = STATE(355),
    [ts_builtin_sym_end] = ACTIONS(3793),
    [sym_identifier] = ACTIONS(3791),
    [aux_sym_preproc_include_token1] = ACTIONS(3791),
    [aux_sym_preproc_def_token1] = ACTIONS(3791),
    [aux_sym_preproc_if_token1] = ACTIONS(3791),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3791),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3791),
    [sym_preproc_directive] = ACTIONS(3791),
    [anon_sym_LPAREN2] = ACTIONS(3793),
    [anon_sym_BANG] = ACTIONS(3793),
    [anon_sym_TILDE] = ACTIONS(3793),
    [anon_sym_DASH] = ACTIONS(3791),
    [anon_sym_PLUS] = ACTIONS(3791),
    [anon_sym_STAR] = ACTIONS(3793),
    [anon_sym_AMP_AMP] = ACTIONS(3793),
    [anon_sym_AMP] = ACTIONS(3791),
    [anon_sym_SEMI] = ACTIONS(3793),
    [anon_sym___extension__] = ACTIONS(3791),
    [anon_sym_typedef] = ACTIONS(3791),
    [anon_sym_in] = ACTIONS(3791),
    [anon_sym_out] = ACTIONS(3791),
    [anon_sym_inout] = ACTIONS(3791),
    [anon_sym_extern] = ACTIONS(3791),
    [anon_sym___attribute__] = ACTIONS(2861),
    [anon_sym_COLON_COLON] = ACTIONS(3793),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3793),
    [anon_sym___declspec] = ACTIONS(3791),
    [anon_sym___based] = ACTIONS(3791),
    [anon_sym___cdecl] = ACTIONS(3791),
    [anon_sym___clrcall] = ACTIONS(3791),
    [anon_sym___stdcall] = ACTIONS(3791),
    [anon_sym___fastcall] = ACTIONS(3791),
    [anon_sym___thiscall] = ACTIONS(3791),
    [anon_sym___vectorcall] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(3793),
    [anon_sym_signed] = ACTIONS(3791),
    [anon_sym_unsigned] = ACTIONS(3791),
    [anon_sym_long] = ACTIONS(3791),
    [anon_sym_short] = ACTIONS(3791),
    [anon_sym_LBRACK] = ACTIONS(3791),
    [anon_sym_static] = ACTIONS(3791),
    [anon_sym_register] = ACTIONS(3791),
    [anon_sym_inline] = ACTIONS(3791),
    [anon_sym___inline] = ACTIONS(3791),
    [anon_sym___inline__] = ACTIONS(3791),
    [anon_sym___forceinline] = ACTIONS(3791),
    [anon_sym_thread_local] = ACTIONS(3791),
    [anon_sym___thread] = ACTIONS(3791),
    [anon_sym_const] = ACTIONS(3791),
    [anon_sym_constexpr] = ACTIONS(3791),
    [anon_sym_volatile] = ACTIONS(3791),
    [anon_sym_restrict] = ACTIONS(3791),
    [anon_sym___restrict__] = ACTIONS(3791),
    [anon_sym__Atomic] = ACTIONS(3791),
    [anon_sym__Noreturn] = ACTIONS(3791),
    [anon_sym_noreturn] = ACTIONS(3791),
    [anon_sym_mutable] = ACTIONS(3791),
    [anon_sym_constinit] = ACTIONS(3791),
    [anon_sym_consteval] = ACTIONS(3791),
    [anon_sym_alignas] = ACTIONS(3791),
    [anon_sym__Alignas] = ACTIONS(3791),
    [sym_primitive_type] = ACTIONS(3791),
    [anon_sym_enum] = ACTIONS(3791),
    [anon_sym_class] = ACTIONS(3791),
    [anon_sym_struct] = ACTIONS(3791),
    [anon_sym_union] = ACTIONS(3791),
    [anon_sym_if] = ACTIONS(3791),
    [anon_sym_switch] = ACTIONS(3791),
    [anon_sym_case] = ACTIONS(3791),
    [anon_sym_default] = ACTIONS(3791),
    [anon_sym_while] = ACTIONS(3791),
    [anon_sym_do] = ACTIONS(3791),
    [anon_sym_for] = ACTIONS(3791),
    [anon_sym_return] = ACTIONS(3791),
    [anon_sym_break] = ACTIONS(3791),
    [anon_sym_continue] = ACTIONS(3791),
    [anon_sym_goto] = ACTIONS(3791),
    [anon_sym_not] = ACTIONS(3791),
    [anon_sym_compl] = ACTIONS(3791),
    [anon_sym_DASH_DASH] = ACTIONS(3793),
    [anon_sym_PLUS_PLUS] = ACTIONS(3793),
    [anon_sym_sizeof] = ACTIONS(3791),
    [anon_sym___alignof__] = ACTIONS(3791),
    [anon_sym___alignof] = ACTIONS(3791),
    [anon_sym__alignof] = ACTIONS(3791),
    [anon_sym_alignof] = ACTIONS(3791),
    [anon_sym__Alignof] = ACTIONS(3791),
    [anon_sym_offsetof] = ACTIONS(3791),
    [anon_sym__Generic] = ACTIONS(3791),
    [anon_sym_asm] = ACTIONS(3791),
    [anon_sym___asm__] = ACTIONS(3791),
    [anon_sym_DOT] = ACTIONS(3791),
    [sym_number_literal] = ACTIONS(3793),
    [anon_sym_L_SQUOTE] = ACTIONS(3793),
    [anon_sym_u_SQUOTE] = ACTIONS(3793),
    [anon_sym_U_SQUOTE] = ACTIONS(3793),
    [anon_sym_u8_SQUOTE] = ACTIONS(3793),
    [anon_sym_SQUOTE] = ACTIONS(3793),
    [anon_sym_L_DQUOTE] = ACTIONS(3793),
    [anon_sym_u_DQUOTE] = ACTIONS(3793),
    [anon_sym_U_DQUOTE] = ACTIONS(3793),
    [anon_sym_u8_DQUOTE] = ACTIONS(3793),
    [anon_sym_DQUOTE] = ACTIONS(3793),
    [sym_true] = ACTIONS(3791),
    [sym_false] = ACTIONS(3791),
    [anon_sym_NULL] = ACTIONS(3791),
    [anon_sym_nullptr] = ACTIONS(3791),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3791),
    [anon_sym_let] = ACTIONS(3791),
    [anon_sym_This] = ACTIONS(3791),
    [anon_sym_decltype] = ACTIONS(3791),
    [sym_virtual] = ACTIONS(3791),
    [anon_sym_explicit] = ACTIONS(3791),
    [anon_sym_typename] = ACTIONS(3791),
    [anon_sym_template] = ACTIONS(3791),
    [anon_sym_operator] = ACTIONS(3791),
    [anon_sym_try] = ACTIONS(3791),
    [anon_sym_delete] = ACTIONS(3791),
    [anon_sym_throw] = ACTIONS(3791),
    [anon_sym_namespace] = ACTIONS(3791),
    [anon_sym_using] = ACTIONS(3791),
    [anon_sym_static_assert] = ACTIONS(3791),
    [anon_sym_concept] = ACTIONS(3791),
    [anon_sym_co_return] = ACTIONS(3791),
    [anon_sym_co_yield] = ACTIONS(3791),
    [anon_sym_R_DQUOTE] = ACTIONS(3793),
    [anon_sym_LR_DQUOTE] = ACTIONS(3793),
    [anon_sym_uR_DQUOTE] = ACTIONS(3793),
    [anon_sym_UR_DQUOTE] = ACTIONS(3793),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3793),
    [anon_sym_co_await] = ACTIONS(3791),
    [anon_sym_new] = ACTIONS(3791),
    [anon_sym_requires] = ACTIONS(3791),
    [sym_this] = ACTIONS(3791),
    [anon_sym_precise] = ACTIONS(3791),
    [anon_sym_shared] = ACTIONS(3791),
    [anon_sym_groupshared] = ACTIONS(3791),
    [anon_sym_uniform] = ACTIONS(3791),
    [anon_sym_row_major] = ACTIONS(3791),
    [anon_sym_column_major] = ACTIONS(3791),
    [anon_sym_globallycoherent] = ACTIONS(3791),
    [anon_sym_centroid] = ACTIONS(3791),
    [anon_sym_noperspective] = ACTIONS(3791),
    [anon_sym_nointerpolation] = ACTIONS(3791),
    [anon_sym_sample] = ACTIONS(3791),
    [anon_sym_linear] = ACTIONS(3791),
    [anon_sym_snorm] = ACTIONS(3791),
    [anon_sym_unorm] = ACTIONS(3791),
    [anon_sym_point] = ACTIONS(3791),
    [anon_sym_line] = ACTIONS(3791),
    [anon_sym_triangleadj] = ACTIONS(3791),
    [anon_sym_lineadj] = ACTIONS(3791),
    [anon_sym_triangle] = ACTIONS(3791),
    [anon_sym_interface] = ACTIONS(3791),
    [anon_sym_extension] = ACTIONS(3791),
    [anon_sym___exported] = ACTIONS(3791),
    [anon_sym_import] = ACTIONS(3791),
  },
  [966] = {
    [sym_identifier] = ACTIONS(3587),
    [aux_sym_preproc_include_token1] = ACTIONS(3587),
    [aux_sym_preproc_def_token1] = ACTIONS(3587),
    [aux_sym_preproc_if_token1] = ACTIONS(3587),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3587),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3587),
    [sym_preproc_directive] = ACTIONS(3587),
    [anon_sym_LPAREN2] = ACTIONS(3589),
    [anon_sym_BANG] = ACTIONS(3589),
    [anon_sym_TILDE] = ACTIONS(3589),
    [anon_sym_DASH] = ACTIONS(3587),
    [anon_sym_PLUS] = ACTIONS(3587),
    [anon_sym_STAR] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3587),
    [anon_sym_SEMI] = ACTIONS(3589),
    [anon_sym___extension__] = ACTIONS(3587),
    [anon_sym_typedef] = ACTIONS(3587),
    [anon_sym_in] = ACTIONS(3587),
    [anon_sym_out] = ACTIONS(3587),
    [anon_sym_inout] = ACTIONS(3587),
    [anon_sym_extern] = ACTIONS(3587),
    [anon_sym___attribute__] = ACTIONS(3587),
    [anon_sym_COLON_COLON] = ACTIONS(3589),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3589),
    [anon_sym___declspec] = ACTIONS(3587),
    [anon_sym___based] = ACTIONS(3587),
    [anon_sym___cdecl] = ACTIONS(3587),
    [anon_sym___clrcall] = ACTIONS(3587),
    [anon_sym___stdcall] = ACTIONS(3587),
    [anon_sym___fastcall] = ACTIONS(3587),
    [anon_sym___thiscall] = ACTIONS(3587),
    [anon_sym___vectorcall] = ACTIONS(3587),
    [anon_sym_LBRACE] = ACTIONS(3589),
    [anon_sym_RBRACE] = ACTIONS(3589),
    [anon_sym_signed] = ACTIONS(3587),
    [anon_sym_unsigned] = ACTIONS(3587),
    [anon_sym_long] = ACTIONS(3587),
    [anon_sym_short] = ACTIONS(3587),
    [anon_sym_LBRACK] = ACTIONS(3587),
    [anon_sym_static] = ACTIONS(3587),
    [anon_sym_register] = ACTIONS(3587),
    [anon_sym_inline] = ACTIONS(3587),
    [anon_sym___inline] = ACTIONS(3587),
    [anon_sym___inline__] = ACTIONS(3587),
    [anon_sym___forceinline] = ACTIONS(3587),
    [anon_sym_thread_local] = ACTIONS(3587),
    [anon_sym___thread] = ACTIONS(3587),
    [anon_sym_const] = ACTIONS(3587),
    [anon_sym_constexpr] = ACTIONS(3587),
    [anon_sym_volatile] = ACTIONS(3587),
    [anon_sym_restrict] = ACTIONS(3587),
    [anon_sym___restrict__] = ACTIONS(3587),
    [anon_sym__Atomic] = ACTIONS(3587),
    [anon_sym__Noreturn] = ACTIONS(3587),
    [anon_sym_noreturn] = ACTIONS(3587),
    [anon_sym_mutable] = ACTIONS(3587),
    [anon_sym_constinit] = ACTIONS(3587),
    [anon_sym_consteval] = ACTIONS(3587),
    [anon_sym_alignas] = ACTIONS(3587),
    [anon_sym__Alignas] = ACTIONS(3587),
    [sym_primitive_type] = ACTIONS(3587),
    [anon_sym_enum] = ACTIONS(3587),
    [anon_sym_class] = ACTIONS(3587),
    [anon_sym_struct] = ACTIONS(3587),
    [anon_sym_union] = ACTIONS(3587),
    [anon_sym_if] = ACTIONS(3587),
    [anon_sym_switch] = ACTIONS(3587),
    [anon_sym_case] = ACTIONS(3587),
    [anon_sym_default] = ACTIONS(3587),
    [anon_sym_while] = ACTIONS(3587),
    [anon_sym_do] = ACTIONS(3587),
    [anon_sym_for] = ACTIONS(3587),
    [anon_sym_return] = ACTIONS(3587),
    [anon_sym_break] = ACTIONS(3587),
    [anon_sym_continue] = ACTIONS(3587),
    [anon_sym_goto] = ACTIONS(3587),
    [anon_sym___try] = ACTIONS(3587),
    [anon_sym___leave] = ACTIONS(3587),
    [anon_sym_not] = ACTIONS(3587),
    [anon_sym_compl] = ACTIONS(3587),
    [anon_sym_DASH_DASH] = ACTIONS(3589),
    [anon_sym_PLUS_PLUS] = ACTIONS(3589),
    [anon_sym_sizeof] = ACTIONS(3587),
    [anon_sym___alignof__] = ACTIONS(3587),
    [anon_sym___alignof] = ACTIONS(3587),
    [anon_sym__alignof] = ACTIONS(3587),
    [anon_sym_alignof] = ACTIONS(3587),
    [anon_sym__Alignof] = ACTIONS(3587),
    [anon_sym_offsetof] = ACTIONS(3587),
    [anon_sym__Generic] = ACTIONS(3587),
    [anon_sym_asm] = ACTIONS(3587),
    [anon_sym___asm__] = ACTIONS(3587),
    [sym_number_literal] = ACTIONS(3589),
    [anon_sym_L_SQUOTE] = ACTIONS(3589),
    [anon_sym_u_SQUOTE] = ACTIONS(3589),
    [anon_sym_U_SQUOTE] = ACTIONS(3589),
    [anon_sym_u8_SQUOTE] = ACTIONS(3589),
    [anon_sym_SQUOTE] = ACTIONS(3589),
    [anon_sym_L_DQUOTE] = ACTIONS(3589),
    [anon_sym_u_DQUOTE] = ACTIONS(3589),
    [anon_sym_U_DQUOTE] = ACTIONS(3589),
    [anon_sym_u8_DQUOTE] = ACTIONS(3589),
    [anon_sym_DQUOTE] = ACTIONS(3589),
    [sym_true] = ACTIONS(3587),
    [sym_false] = ACTIONS(3587),
    [anon_sym_NULL] = ACTIONS(3587),
    [anon_sym_nullptr] = ACTIONS(3587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3587),
    [anon_sym_let] = ACTIONS(3587),
    [anon_sym_This] = ACTIONS(3587),
    [anon_sym_decltype] = ACTIONS(3587),
    [sym_virtual] = ACTIONS(3587),
    [anon_sym_explicit] = ACTIONS(3587),
    [anon_sym_typename] = ACTIONS(3587),
    [anon_sym_template] = ACTIONS(3587),
    [anon_sym_operator] = ACTIONS(3587),
    [anon_sym_try] = ACTIONS(3587),
    [anon_sym_delete] = ACTIONS(3587),
    [anon_sym_throw] = ACTIONS(3587),
    [anon_sym_namespace] = ACTIONS(3587),
    [anon_sym_using] = ACTIONS(3587),
    [anon_sym_static_assert] = ACTIONS(3587),
    [anon_sym_concept] = ACTIONS(3587),
    [anon_sym_co_return] = ACTIONS(3587),
    [anon_sym_co_yield] = ACTIONS(3587),
    [anon_sym_R_DQUOTE] = ACTIONS(3589),
    [anon_sym_LR_DQUOTE] = ACTIONS(3589),
    [anon_sym_uR_DQUOTE] = ACTIONS(3589),
    [anon_sym_UR_DQUOTE] = ACTIONS(3589),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3589),
    [anon_sym_co_await] = ACTIONS(3587),
    [anon_sym_new] = ACTIONS(3587),
    [anon_sym_requires] = ACTIONS(3587),
    [sym_this] = ACTIONS(3587),
    [anon_sym_discard] = ACTIONS(3587),
    [anon_sym_precise] = ACTIONS(3587),
    [anon_sym_shared] = ACTIONS(3587),
    [anon_sym_groupshared] = ACTIONS(3587),
    [anon_sym_uniform] = ACTIONS(3587),
    [anon_sym_row_major] = ACTIONS(3587),
    [anon_sym_column_major] = ACTIONS(3587),
    [anon_sym_globallycoherent] = ACTIONS(3587),
    [anon_sym_centroid] = ACTIONS(3587),
    [anon_sym_noperspective] = ACTIONS(3587),
    [anon_sym_nointerpolation] = ACTIONS(3587),
    [anon_sym_sample] = ACTIONS(3587),
    [anon_sym_linear] = ACTIONS(3587),
    [anon_sym_snorm] = ACTIONS(3587),
    [anon_sym_unorm] = ACTIONS(3587),
    [anon_sym_point] = ACTIONS(3587),
    [anon_sym_line] = ACTIONS(3587),
    [anon_sym_triangleadj] = ACTIONS(3587),
    [anon_sym_lineadj] = ACTIONS(3587),
    [anon_sym_triangle] = ACTIONS(3587),
    [anon_sym_cbuffer] = ACTIONS(3587),
    [anon_sym_interface] = ACTIONS(3587),
    [anon_sym_extension] = ACTIONS(3587),
  },
  [967] = {
    [sym_identifier] = ACTIONS(3605),
    [aux_sym_preproc_include_token1] = ACTIONS(3605),
    [aux_sym_preproc_def_token1] = ACTIONS(3605),
    [aux_sym_preproc_if_token1] = ACTIONS(3605),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3605),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3605),
    [sym_preproc_directive] = ACTIONS(3605),
    [anon_sym_LPAREN2] = ACTIONS(3607),
    [anon_sym_BANG] = ACTIONS(3607),
    [anon_sym_TILDE] = ACTIONS(3607),
    [anon_sym_DASH] = ACTIONS(3605),
    [anon_sym_PLUS] = ACTIONS(3605),
    [anon_sym_STAR] = ACTIONS(3607),
    [anon_sym_AMP_AMP] = ACTIONS(3607),
    [anon_sym_AMP] = ACTIONS(3605),
    [anon_sym_SEMI] = ACTIONS(3607),
    [anon_sym___extension__] = ACTIONS(3605),
    [anon_sym_typedef] = ACTIONS(3605),
    [anon_sym_in] = ACTIONS(3605),
    [anon_sym_out] = ACTIONS(3605),
    [anon_sym_inout] = ACTIONS(3605),
    [anon_sym_extern] = ACTIONS(3605),
    [anon_sym___attribute__] = ACTIONS(3605),
    [anon_sym_COLON_COLON] = ACTIONS(3607),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3607),
    [anon_sym___declspec] = ACTIONS(3605),
    [anon_sym___based] = ACTIONS(3605),
    [anon_sym___cdecl] = ACTIONS(3605),
    [anon_sym___clrcall] = ACTIONS(3605),
    [anon_sym___stdcall] = ACTIONS(3605),
    [anon_sym___fastcall] = ACTIONS(3605),
    [anon_sym___thiscall] = ACTIONS(3605),
    [anon_sym___vectorcall] = ACTIONS(3605),
    [anon_sym_LBRACE] = ACTIONS(3607),
    [anon_sym_RBRACE] = ACTIONS(3607),
    [anon_sym_signed] = ACTIONS(3605),
    [anon_sym_unsigned] = ACTIONS(3605),
    [anon_sym_long] = ACTIONS(3605),
    [anon_sym_short] = ACTIONS(3605),
    [anon_sym_LBRACK] = ACTIONS(3605),
    [anon_sym_static] = ACTIONS(3605),
    [anon_sym_register] = ACTIONS(3605),
    [anon_sym_inline] = ACTIONS(3605),
    [anon_sym___inline] = ACTIONS(3605),
    [anon_sym___inline__] = ACTIONS(3605),
    [anon_sym___forceinline] = ACTIONS(3605),
    [anon_sym_thread_local] = ACTIONS(3605),
    [anon_sym___thread] = ACTIONS(3605),
    [anon_sym_const] = ACTIONS(3605),
    [anon_sym_constexpr] = ACTIONS(3605),
    [anon_sym_volatile] = ACTIONS(3605),
    [anon_sym_restrict] = ACTIONS(3605),
    [anon_sym___restrict__] = ACTIONS(3605),
    [anon_sym__Atomic] = ACTIONS(3605),
    [anon_sym__Noreturn] = ACTIONS(3605),
    [anon_sym_noreturn] = ACTIONS(3605),
    [anon_sym_mutable] = ACTIONS(3605),
    [anon_sym_constinit] = ACTIONS(3605),
    [anon_sym_consteval] = ACTIONS(3605),
    [anon_sym_alignas] = ACTIONS(3605),
    [anon_sym__Alignas] = ACTIONS(3605),
    [sym_primitive_type] = ACTIONS(3605),
    [anon_sym_enum] = ACTIONS(3605),
    [anon_sym_class] = ACTIONS(3605),
    [anon_sym_struct] = ACTIONS(3605),
    [anon_sym_union] = ACTIONS(3605),
    [anon_sym_if] = ACTIONS(3605),
    [anon_sym_switch] = ACTIONS(3605),
    [anon_sym_case] = ACTIONS(3605),
    [anon_sym_default] = ACTIONS(3605),
    [anon_sym_while] = ACTIONS(3605),
    [anon_sym_do] = ACTIONS(3605),
    [anon_sym_for] = ACTIONS(3605),
    [anon_sym_return] = ACTIONS(3605),
    [anon_sym_break] = ACTIONS(3605),
    [anon_sym_continue] = ACTIONS(3605),
    [anon_sym_goto] = ACTIONS(3605),
    [anon_sym___try] = ACTIONS(3605),
    [anon_sym___leave] = ACTIONS(3605),
    [anon_sym_not] = ACTIONS(3605),
    [anon_sym_compl] = ACTIONS(3605),
    [anon_sym_DASH_DASH] = ACTIONS(3607),
    [anon_sym_PLUS_PLUS] = ACTIONS(3607),
    [anon_sym_sizeof] = ACTIONS(3605),
    [anon_sym___alignof__] = ACTIONS(3605),
    [anon_sym___alignof] = ACTIONS(3605),
    [anon_sym__alignof] = ACTIONS(3605),
    [anon_sym_alignof] = ACTIONS(3605),
    [anon_sym__Alignof] = ACTIONS(3605),
    [anon_sym_offsetof] = ACTIONS(3605),
    [anon_sym__Generic] = ACTIONS(3605),
    [anon_sym_asm] = ACTIONS(3605),
    [anon_sym___asm__] = ACTIONS(3605),
    [sym_number_literal] = ACTIONS(3607),
    [anon_sym_L_SQUOTE] = ACTIONS(3607),
    [anon_sym_u_SQUOTE] = ACTIONS(3607),
    [anon_sym_U_SQUOTE] = ACTIONS(3607),
    [anon_sym_u8_SQUOTE] = ACTIONS(3607),
    [anon_sym_SQUOTE] = ACTIONS(3607),
    [anon_sym_L_DQUOTE] = ACTIONS(3607),
    [anon_sym_u_DQUOTE] = ACTIONS(3607),
    [anon_sym_U_DQUOTE] = ACTIONS(3607),
    [anon_sym_u8_DQUOTE] = ACTIONS(3607),
    [anon_sym_DQUOTE] = ACTIONS(3607),
    [sym_true] = ACTIONS(3605),
    [sym_false] = ACTIONS(3605),
    [anon_sym_NULL] = ACTIONS(3605),
    [anon_sym_nullptr] = ACTIONS(3605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3605),
    [anon_sym_let] = ACTIONS(3605),
    [anon_sym_This] = ACTIONS(3605),
    [anon_sym_decltype] = ACTIONS(3605),
    [sym_virtual] = ACTIONS(3605),
    [anon_sym_explicit] = ACTIONS(3605),
    [anon_sym_typename] = ACTIONS(3605),
    [anon_sym_template] = ACTIONS(3605),
    [anon_sym_operator] = ACTIONS(3605),
    [anon_sym_try] = ACTIONS(3605),
    [anon_sym_delete] = ACTIONS(3605),
    [anon_sym_throw] = ACTIONS(3605),
    [anon_sym_namespace] = ACTIONS(3605),
    [anon_sym_using] = ACTIONS(3605),
    [anon_sym_static_assert] = ACTIONS(3605),
    [anon_sym_concept] = ACTIONS(3605),
    [anon_sym_co_return] = ACTIONS(3605),
    [anon_sym_co_yield] = ACTIONS(3605),
    [anon_sym_R_DQUOTE] = ACTIONS(3607),
    [anon_sym_LR_DQUOTE] = ACTIONS(3607),
    [anon_sym_uR_DQUOTE] = ACTIONS(3607),
    [anon_sym_UR_DQUOTE] = ACTIONS(3607),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3607),
    [anon_sym_co_await] = ACTIONS(3605),
    [anon_sym_new] = ACTIONS(3605),
    [anon_sym_requires] = ACTIONS(3605),
    [sym_this] = ACTIONS(3605),
    [anon_sym_discard] = ACTIONS(3605),
    [anon_sym_precise] = ACTIONS(3605),
    [anon_sym_shared] = ACTIONS(3605),
    [anon_sym_groupshared] = ACTIONS(3605),
    [anon_sym_uniform] = ACTIONS(3605),
    [anon_sym_row_major] = ACTIONS(3605),
    [anon_sym_column_major] = ACTIONS(3605),
    [anon_sym_globallycoherent] = ACTIONS(3605),
    [anon_sym_centroid] = ACTIONS(3605),
    [anon_sym_noperspective] = ACTIONS(3605),
    [anon_sym_nointerpolation] = ACTIONS(3605),
    [anon_sym_sample] = ACTIONS(3605),
    [anon_sym_linear] = ACTIONS(3605),
    [anon_sym_snorm] = ACTIONS(3605),
    [anon_sym_unorm] = ACTIONS(3605),
    [anon_sym_point] = ACTIONS(3605),
    [anon_sym_line] = ACTIONS(3605),
    [anon_sym_triangleadj] = ACTIONS(3605),
    [anon_sym_lineadj] = ACTIONS(3605),
    [anon_sym_triangle] = ACTIONS(3605),
    [anon_sym_cbuffer] = ACTIONS(3605),
    [anon_sym_interface] = ACTIONS(3605),
    [anon_sym_extension] = ACTIONS(3605),
  },
  [968] = {
    [sym_identifier] = ACTIONS(3567),
    [aux_sym_preproc_include_token1] = ACTIONS(3567),
    [aux_sym_preproc_def_token1] = ACTIONS(3567),
    [aux_sym_preproc_if_token1] = ACTIONS(3567),
    [aux_sym_preproc_if_token2] = ACTIONS(3567),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3567),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3567),
    [sym_preproc_directive] = ACTIONS(3567),
    [anon_sym_LPAREN2] = ACTIONS(3569),
    [anon_sym_BANG] = ACTIONS(3569),
    [anon_sym_TILDE] = ACTIONS(3569),
    [anon_sym_DASH] = ACTIONS(3567),
    [anon_sym_PLUS] = ACTIONS(3567),
    [anon_sym_STAR] = ACTIONS(3569),
    [anon_sym_AMP_AMP] = ACTIONS(3569),
    [anon_sym_AMP] = ACTIONS(3567),
    [anon_sym_SEMI] = ACTIONS(3569),
    [anon_sym___extension__] = ACTIONS(3567),
    [anon_sym_typedef] = ACTIONS(3567),
    [anon_sym_in] = ACTIONS(3567),
    [anon_sym_out] = ACTIONS(3567),
    [anon_sym_inout] = ACTIONS(3567),
    [anon_sym_extern] = ACTIONS(3567),
    [anon_sym___attribute__] = ACTIONS(3567),
    [anon_sym_COLON_COLON] = ACTIONS(3569),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3569),
    [anon_sym___declspec] = ACTIONS(3567),
    [anon_sym___based] = ACTIONS(3567),
    [anon_sym___cdecl] = ACTIONS(3567),
    [anon_sym___clrcall] = ACTIONS(3567),
    [anon_sym___stdcall] = ACTIONS(3567),
    [anon_sym___fastcall] = ACTIONS(3567),
    [anon_sym___thiscall] = ACTIONS(3567),
    [anon_sym___vectorcall] = ACTIONS(3567),
    [anon_sym_LBRACE] = ACTIONS(3569),
    [anon_sym_signed] = ACTIONS(3567),
    [anon_sym_unsigned] = ACTIONS(3567),
    [anon_sym_long] = ACTIONS(3567),
    [anon_sym_short] = ACTIONS(3567),
    [anon_sym_LBRACK] = ACTIONS(3567),
    [anon_sym_static] = ACTIONS(3567),
    [anon_sym_register] = ACTIONS(3567),
    [anon_sym_inline] = ACTIONS(3567),
    [anon_sym___inline] = ACTIONS(3567),
    [anon_sym___inline__] = ACTIONS(3567),
    [anon_sym___forceinline] = ACTIONS(3567),
    [anon_sym_thread_local] = ACTIONS(3567),
    [anon_sym___thread] = ACTIONS(3567),
    [anon_sym_const] = ACTIONS(3567),
    [anon_sym_constexpr] = ACTIONS(3567),
    [anon_sym_volatile] = ACTIONS(3567),
    [anon_sym_restrict] = ACTIONS(3567),
    [anon_sym___restrict__] = ACTIONS(3567),
    [anon_sym__Atomic] = ACTIONS(3567),
    [anon_sym__Noreturn] = ACTIONS(3567),
    [anon_sym_noreturn] = ACTIONS(3567),
    [anon_sym_mutable] = ACTIONS(3567),
    [anon_sym_constinit] = ACTIONS(3567),
    [anon_sym_consteval] = ACTIONS(3567),
    [anon_sym_alignas] = ACTIONS(3567),
    [anon_sym__Alignas] = ACTIONS(3567),
    [sym_primitive_type] = ACTIONS(3567),
    [anon_sym_enum] = ACTIONS(3567),
    [anon_sym_class] = ACTIONS(3567),
    [anon_sym_struct] = ACTIONS(3567),
    [anon_sym_union] = ACTIONS(3567),
    [anon_sym_if] = ACTIONS(3567),
    [anon_sym_switch] = ACTIONS(3567),
    [anon_sym_case] = ACTIONS(3567),
    [anon_sym_default] = ACTIONS(3567),
    [anon_sym_while] = ACTIONS(3567),
    [anon_sym_do] = ACTIONS(3567),
    [anon_sym_for] = ACTIONS(3567),
    [anon_sym_return] = ACTIONS(3567),
    [anon_sym_break] = ACTIONS(3567),
    [anon_sym_continue] = ACTIONS(3567),
    [anon_sym_goto] = ACTIONS(3567),
    [anon_sym___try] = ACTIONS(3567),
    [anon_sym___leave] = ACTIONS(3567),
    [anon_sym_not] = ACTIONS(3567),
    [anon_sym_compl] = ACTIONS(3567),
    [anon_sym_DASH_DASH] = ACTIONS(3569),
    [anon_sym_PLUS_PLUS] = ACTIONS(3569),
    [anon_sym_sizeof] = ACTIONS(3567),
    [anon_sym___alignof__] = ACTIONS(3567),
    [anon_sym___alignof] = ACTIONS(3567),
    [anon_sym__alignof] = ACTIONS(3567),
    [anon_sym_alignof] = ACTIONS(3567),
    [anon_sym__Alignof] = ACTIONS(3567),
    [anon_sym_offsetof] = ACTIONS(3567),
    [anon_sym__Generic] = ACTIONS(3567),
    [anon_sym_asm] = ACTIONS(3567),
    [anon_sym___asm__] = ACTIONS(3567),
    [sym_number_literal] = ACTIONS(3569),
    [anon_sym_L_SQUOTE] = ACTIONS(3569),
    [anon_sym_u_SQUOTE] = ACTIONS(3569),
    [anon_sym_U_SQUOTE] = ACTIONS(3569),
    [anon_sym_u8_SQUOTE] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(3569),
    [anon_sym_L_DQUOTE] = ACTIONS(3569),
    [anon_sym_u_DQUOTE] = ACTIONS(3569),
    [anon_sym_U_DQUOTE] = ACTIONS(3569),
    [anon_sym_u8_DQUOTE] = ACTIONS(3569),
    [anon_sym_DQUOTE] = ACTIONS(3569),
    [sym_true] = ACTIONS(3567),
    [sym_false] = ACTIONS(3567),
    [anon_sym_NULL] = ACTIONS(3567),
    [anon_sym_nullptr] = ACTIONS(3567),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3567),
    [anon_sym_let] = ACTIONS(3567),
    [anon_sym_This] = ACTIONS(3567),
    [anon_sym_decltype] = ACTIONS(3567),
    [sym_virtual] = ACTIONS(3567),
    [anon_sym_explicit] = ACTIONS(3567),
    [anon_sym_typename] = ACTIONS(3567),
    [anon_sym_template] = ACTIONS(3567),
    [anon_sym_operator] = ACTIONS(3567),
    [anon_sym_try] = ACTIONS(3567),
    [anon_sym_delete] = ACTIONS(3567),
    [anon_sym_throw] = ACTIONS(3567),
    [anon_sym_namespace] = ACTIONS(3567),
    [anon_sym_using] = ACTIONS(3567),
    [anon_sym_static_assert] = ACTIONS(3567),
    [anon_sym_concept] = ACTIONS(3567),
    [anon_sym_co_return] = ACTIONS(3567),
    [anon_sym_co_yield] = ACTIONS(3567),
    [anon_sym_R_DQUOTE] = ACTIONS(3569),
    [anon_sym_LR_DQUOTE] = ACTIONS(3569),
    [anon_sym_uR_DQUOTE] = ACTIONS(3569),
    [anon_sym_UR_DQUOTE] = ACTIONS(3569),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3569),
    [anon_sym_co_await] = ACTIONS(3567),
    [anon_sym_new] = ACTIONS(3567),
    [anon_sym_requires] = ACTIONS(3567),
    [sym_this] = ACTIONS(3567),
    [anon_sym_discard] = ACTIONS(3567),
    [anon_sym_precise] = ACTIONS(3567),
    [anon_sym_shared] = ACTIONS(3567),
    [anon_sym_groupshared] = ACTIONS(3567),
    [anon_sym_uniform] = ACTIONS(3567),
    [anon_sym_row_major] = ACTIONS(3567),
    [anon_sym_column_major] = ACTIONS(3567),
    [anon_sym_globallycoherent] = ACTIONS(3567),
    [anon_sym_centroid] = ACTIONS(3567),
    [anon_sym_noperspective] = ACTIONS(3567),
    [anon_sym_nointerpolation] = ACTIONS(3567),
    [anon_sym_sample] = ACTIONS(3567),
    [anon_sym_linear] = ACTIONS(3567),
    [anon_sym_snorm] = ACTIONS(3567),
    [anon_sym_unorm] = ACTIONS(3567),
    [anon_sym_point] = ACTIONS(3567),
    [anon_sym_line] = ACTIONS(3567),
    [anon_sym_triangleadj] = ACTIONS(3567),
    [anon_sym_lineadj] = ACTIONS(3567),
    [anon_sym_triangle] = ACTIONS(3567),
    [anon_sym_cbuffer] = ACTIONS(3567),
    [anon_sym_interface] = ACTIONS(3567),
    [anon_sym_extension] = ACTIONS(3567),
  },
  [969] = {
    [sym_identifier] = ACTIONS(3609),
    [aux_sym_preproc_include_token1] = ACTIONS(3609),
    [aux_sym_preproc_def_token1] = ACTIONS(3609),
    [aux_sym_preproc_if_token1] = ACTIONS(3609),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3609),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3609),
    [sym_preproc_directive] = ACTIONS(3609),
    [anon_sym_LPAREN2] = ACTIONS(3611),
    [anon_sym_BANG] = ACTIONS(3611),
    [anon_sym_TILDE] = ACTIONS(3611),
    [anon_sym_DASH] = ACTIONS(3609),
    [anon_sym_PLUS] = ACTIONS(3609),
    [anon_sym_STAR] = ACTIONS(3611),
    [anon_sym_AMP_AMP] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3609),
    [anon_sym_SEMI] = ACTIONS(3611),
    [anon_sym___extension__] = ACTIONS(3609),
    [anon_sym_typedef] = ACTIONS(3609),
    [anon_sym_in] = ACTIONS(3609),
    [anon_sym_out] = ACTIONS(3609),
    [anon_sym_inout] = ACTIONS(3609),
    [anon_sym_extern] = ACTIONS(3609),
    [anon_sym___attribute__] = ACTIONS(3609),
    [anon_sym_COLON_COLON] = ACTIONS(3611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3611),
    [anon_sym___declspec] = ACTIONS(3609),
    [anon_sym___based] = ACTIONS(3609),
    [anon_sym___cdecl] = ACTIONS(3609),
    [anon_sym___clrcall] = ACTIONS(3609),
    [anon_sym___stdcall] = ACTIONS(3609),
    [anon_sym___fastcall] = ACTIONS(3609),
    [anon_sym___thiscall] = ACTIONS(3609),
    [anon_sym___vectorcall] = ACTIONS(3609),
    [anon_sym_LBRACE] = ACTIONS(3611),
    [anon_sym_RBRACE] = ACTIONS(3611),
    [anon_sym_signed] = ACTIONS(3609),
    [anon_sym_unsigned] = ACTIONS(3609),
    [anon_sym_long] = ACTIONS(3609),
    [anon_sym_short] = ACTIONS(3609),
    [anon_sym_LBRACK] = ACTIONS(3609),
    [anon_sym_static] = ACTIONS(3609),
    [anon_sym_register] = ACTIONS(3609),
    [anon_sym_inline] = ACTIONS(3609),
    [anon_sym___inline] = ACTIONS(3609),
    [anon_sym___inline__] = ACTIONS(3609),
    [anon_sym___forceinline] = ACTIONS(3609),
    [anon_sym_thread_local] = ACTIONS(3609),
    [anon_sym___thread] = ACTIONS(3609),
    [anon_sym_const] = ACTIONS(3609),
    [anon_sym_constexpr] = ACTIONS(3609),
    [anon_sym_volatile] = ACTIONS(3609),
    [anon_sym_restrict] = ACTIONS(3609),
    [anon_sym___restrict__] = ACTIONS(3609),
    [anon_sym__Atomic] = ACTIONS(3609),
    [anon_sym__Noreturn] = ACTIONS(3609),
    [anon_sym_noreturn] = ACTIONS(3609),
    [anon_sym_mutable] = ACTIONS(3609),
    [anon_sym_constinit] = ACTIONS(3609),
    [anon_sym_consteval] = ACTIONS(3609),
    [anon_sym_alignas] = ACTIONS(3609),
    [anon_sym__Alignas] = ACTIONS(3609),
    [sym_primitive_type] = ACTIONS(3609),
    [anon_sym_enum] = ACTIONS(3609),
    [anon_sym_class] = ACTIONS(3609),
    [anon_sym_struct] = ACTIONS(3609),
    [anon_sym_union] = ACTIONS(3609),
    [anon_sym_if] = ACTIONS(3609),
    [anon_sym_switch] = ACTIONS(3609),
    [anon_sym_case] = ACTIONS(3609),
    [anon_sym_default] = ACTIONS(3609),
    [anon_sym_while] = ACTIONS(3609),
    [anon_sym_do] = ACTIONS(3609),
    [anon_sym_for] = ACTIONS(3609),
    [anon_sym_return] = ACTIONS(3609),
    [anon_sym_break] = ACTIONS(3609),
    [anon_sym_continue] = ACTIONS(3609),
    [anon_sym_goto] = ACTIONS(3609),
    [anon_sym___try] = ACTIONS(3609),
    [anon_sym___leave] = ACTIONS(3609),
    [anon_sym_not] = ACTIONS(3609),
    [anon_sym_compl] = ACTIONS(3609),
    [anon_sym_DASH_DASH] = ACTIONS(3611),
    [anon_sym_PLUS_PLUS] = ACTIONS(3611),
    [anon_sym_sizeof] = ACTIONS(3609),
    [anon_sym___alignof__] = ACTIONS(3609),
    [anon_sym___alignof] = ACTIONS(3609),
    [anon_sym__alignof] = ACTIONS(3609),
    [anon_sym_alignof] = ACTIONS(3609),
    [anon_sym__Alignof] = ACTIONS(3609),
    [anon_sym_offsetof] = ACTIONS(3609),
    [anon_sym__Generic] = ACTIONS(3609),
    [anon_sym_asm] = ACTIONS(3609),
    [anon_sym___asm__] = ACTIONS(3609),
    [sym_number_literal] = ACTIONS(3611),
    [anon_sym_L_SQUOTE] = ACTIONS(3611),
    [anon_sym_u_SQUOTE] = ACTIONS(3611),
    [anon_sym_U_SQUOTE] = ACTIONS(3611),
    [anon_sym_u8_SQUOTE] = ACTIONS(3611),
    [anon_sym_SQUOTE] = ACTIONS(3611),
    [anon_sym_L_DQUOTE] = ACTIONS(3611),
    [anon_sym_u_DQUOTE] = ACTIONS(3611),
    [anon_sym_U_DQUOTE] = ACTIONS(3611),
    [anon_sym_u8_DQUOTE] = ACTIONS(3611),
    [anon_sym_DQUOTE] = ACTIONS(3611),
    [sym_true] = ACTIONS(3609),
    [sym_false] = ACTIONS(3609),
    [anon_sym_NULL] = ACTIONS(3609),
    [anon_sym_nullptr] = ACTIONS(3609),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3609),
    [anon_sym_let] = ACTIONS(3609),
    [anon_sym_This] = ACTIONS(3609),
    [anon_sym_decltype] = ACTIONS(3609),
    [sym_virtual] = ACTIONS(3609),
    [anon_sym_explicit] = ACTIONS(3609),
    [anon_sym_typename] = ACTIONS(3609),
    [anon_sym_template] = ACTIONS(3609),
    [anon_sym_operator] = ACTIONS(3609),
    [anon_sym_try] = ACTIONS(3609),
    [anon_sym_delete] = ACTIONS(3609),
    [anon_sym_throw] = ACTIONS(3609),
    [anon_sym_namespace] = ACTIONS(3609),
    [anon_sym_using] = ACTIONS(3609),
    [anon_sym_static_assert] = ACTIONS(3609),
    [anon_sym_concept] = ACTIONS(3609),
    [anon_sym_co_return] = ACTIONS(3609),
    [anon_sym_co_yield] = ACTIONS(3609),
    [anon_sym_R_DQUOTE] = ACTIONS(3611),
    [anon_sym_LR_DQUOTE] = ACTIONS(3611),
    [anon_sym_uR_DQUOTE] = ACTIONS(3611),
    [anon_sym_UR_DQUOTE] = ACTIONS(3611),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3611),
    [anon_sym_co_await] = ACTIONS(3609),
    [anon_sym_new] = ACTIONS(3609),
    [anon_sym_requires] = ACTIONS(3609),
    [sym_this] = ACTIONS(3609),
    [anon_sym_discard] = ACTIONS(3609),
    [anon_sym_precise] = ACTIONS(3609),
    [anon_sym_shared] = ACTIONS(3609),
    [anon_sym_groupshared] = ACTIONS(3609),
    [anon_sym_uniform] = ACTIONS(3609),
    [anon_sym_row_major] = ACTIONS(3609),
    [anon_sym_column_major] = ACTIONS(3609),
    [anon_sym_globallycoherent] = ACTIONS(3609),
    [anon_sym_centroid] = ACTIONS(3609),
    [anon_sym_noperspective] = ACTIONS(3609),
    [anon_sym_nointerpolation] = ACTIONS(3609),
    [anon_sym_sample] = ACTIONS(3609),
    [anon_sym_linear] = ACTIONS(3609),
    [anon_sym_snorm] = ACTIONS(3609),
    [anon_sym_unorm] = ACTIONS(3609),
    [anon_sym_point] = ACTIONS(3609),
    [anon_sym_line] = ACTIONS(3609),
    [anon_sym_triangleadj] = ACTIONS(3609),
    [anon_sym_lineadj] = ACTIONS(3609),
    [anon_sym_triangle] = ACTIONS(3609),
    [anon_sym_cbuffer] = ACTIONS(3609),
    [anon_sym_interface] = ACTIONS(3609),
    [anon_sym_extension] = ACTIONS(3609),
  },
  [970] = {
    [sym_identifier] = ACTIONS(3617),
    [aux_sym_preproc_include_token1] = ACTIONS(3617),
    [aux_sym_preproc_def_token1] = ACTIONS(3617),
    [aux_sym_preproc_if_token1] = ACTIONS(3617),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3617),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3617),
    [sym_preproc_directive] = ACTIONS(3617),
    [anon_sym_LPAREN2] = ACTIONS(3619),
    [anon_sym_BANG] = ACTIONS(3619),
    [anon_sym_TILDE] = ACTIONS(3619),
    [anon_sym_DASH] = ACTIONS(3617),
    [anon_sym_PLUS] = ACTIONS(3617),
    [anon_sym_STAR] = ACTIONS(3619),
    [anon_sym_AMP_AMP] = ACTIONS(3619),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym_SEMI] = ACTIONS(3619),
    [anon_sym___extension__] = ACTIONS(3617),
    [anon_sym_typedef] = ACTIONS(3617),
    [anon_sym_in] = ACTIONS(3617),
    [anon_sym_out] = ACTIONS(3617),
    [anon_sym_inout] = ACTIONS(3617),
    [anon_sym_extern] = ACTIONS(3617),
    [anon_sym___attribute__] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3619),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3619),
    [anon_sym___declspec] = ACTIONS(3617),
    [anon_sym___based] = ACTIONS(3617),
    [anon_sym___cdecl] = ACTIONS(3617),
    [anon_sym___clrcall] = ACTIONS(3617),
    [anon_sym___stdcall] = ACTIONS(3617),
    [anon_sym___fastcall] = ACTIONS(3617),
    [anon_sym___thiscall] = ACTIONS(3617),
    [anon_sym___vectorcall] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3619),
    [anon_sym_RBRACE] = ACTIONS(3619),
    [anon_sym_signed] = ACTIONS(3617),
    [anon_sym_unsigned] = ACTIONS(3617),
    [anon_sym_long] = ACTIONS(3617),
    [anon_sym_short] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_static] = ACTIONS(3617),
    [anon_sym_register] = ACTIONS(3617),
    [anon_sym_inline] = ACTIONS(3617),
    [anon_sym___inline] = ACTIONS(3617),
    [anon_sym___inline__] = ACTIONS(3617),
    [anon_sym___forceinline] = ACTIONS(3617),
    [anon_sym_thread_local] = ACTIONS(3617),
    [anon_sym___thread] = ACTIONS(3617),
    [anon_sym_const] = ACTIONS(3617),
    [anon_sym_constexpr] = ACTIONS(3617),
    [anon_sym_volatile] = ACTIONS(3617),
    [anon_sym_restrict] = ACTIONS(3617),
    [anon_sym___restrict__] = ACTIONS(3617),
    [anon_sym__Atomic] = ACTIONS(3617),
    [anon_sym__Noreturn] = ACTIONS(3617),
    [anon_sym_noreturn] = ACTIONS(3617),
    [anon_sym_mutable] = ACTIONS(3617),
    [anon_sym_constinit] = ACTIONS(3617),
    [anon_sym_consteval] = ACTIONS(3617),
    [anon_sym_alignas] = ACTIONS(3617),
    [anon_sym__Alignas] = ACTIONS(3617),
    [sym_primitive_type] = ACTIONS(3617),
    [anon_sym_enum] = ACTIONS(3617),
    [anon_sym_class] = ACTIONS(3617),
    [anon_sym_struct] = ACTIONS(3617),
    [anon_sym_union] = ACTIONS(3617),
    [anon_sym_if] = ACTIONS(3617),
    [anon_sym_switch] = ACTIONS(3617),
    [anon_sym_case] = ACTIONS(3617),
    [anon_sym_default] = ACTIONS(3617),
    [anon_sym_while] = ACTIONS(3617),
    [anon_sym_do] = ACTIONS(3617),
    [anon_sym_for] = ACTIONS(3617),
    [anon_sym_return] = ACTIONS(3617),
    [anon_sym_break] = ACTIONS(3617),
    [anon_sym_continue] = ACTIONS(3617),
    [anon_sym_goto] = ACTIONS(3617),
    [anon_sym___try] = ACTIONS(3617),
    [anon_sym___leave] = ACTIONS(3617),
    [anon_sym_not] = ACTIONS(3617),
    [anon_sym_compl] = ACTIONS(3617),
    [anon_sym_DASH_DASH] = ACTIONS(3619),
    [anon_sym_PLUS_PLUS] = ACTIONS(3619),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(3617),
    [anon_sym___alignof] = ACTIONS(3617),
    [anon_sym__alignof] = ACTIONS(3617),
    [anon_sym_alignof] = ACTIONS(3617),
    [anon_sym__Alignof] = ACTIONS(3617),
    [anon_sym_offsetof] = ACTIONS(3617),
    [anon_sym__Generic] = ACTIONS(3617),
    [anon_sym_asm] = ACTIONS(3617),
    [anon_sym___asm__] = ACTIONS(3617),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3619),
    [anon_sym_u_SQUOTE] = ACTIONS(3619),
    [anon_sym_U_SQUOTE] = ACTIONS(3619),
    [anon_sym_u8_SQUOTE] = ACTIONS(3619),
    [anon_sym_SQUOTE] = ACTIONS(3619),
    [anon_sym_L_DQUOTE] = ACTIONS(3619),
    [anon_sym_u_DQUOTE] = ACTIONS(3619),
    [anon_sym_U_DQUOTE] = ACTIONS(3619),
    [anon_sym_u8_DQUOTE] = ACTIONS(3619),
    [anon_sym_DQUOTE] = ACTIONS(3619),
    [sym_true] = ACTIONS(3617),
    [sym_false] = ACTIONS(3617),
    [anon_sym_NULL] = ACTIONS(3617),
    [anon_sym_nullptr] = ACTIONS(3617),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3617),
    [anon_sym_let] = ACTIONS(3617),
    [anon_sym_This] = ACTIONS(3617),
    [anon_sym_decltype] = ACTIONS(3617),
    [sym_virtual] = ACTIONS(3617),
    [anon_sym_explicit] = ACTIONS(3617),
    [anon_sym_typename] = ACTIONS(3617),
    [anon_sym_template] = ACTIONS(3617),
    [anon_sym_operator] = ACTIONS(3617),
    [anon_sym_try] = ACTIONS(3617),
    [anon_sym_delete] = ACTIONS(3617),
    [anon_sym_throw] = ACTIONS(3617),
    [anon_sym_namespace] = ACTIONS(3617),
    [anon_sym_using] = ACTIONS(3617),
    [anon_sym_static_assert] = ACTIONS(3617),
    [anon_sym_concept] = ACTIONS(3617),
    [anon_sym_co_return] = ACTIONS(3617),
    [anon_sym_co_yield] = ACTIONS(3617),
    [anon_sym_R_DQUOTE] = ACTIONS(3619),
    [anon_sym_LR_DQUOTE] = ACTIONS(3619),
    [anon_sym_uR_DQUOTE] = ACTIONS(3619),
    [anon_sym_UR_DQUOTE] = ACTIONS(3619),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3619),
    [anon_sym_co_await] = ACTIONS(3617),
    [anon_sym_new] = ACTIONS(3617),
    [anon_sym_requires] = ACTIONS(3617),
    [sym_this] = ACTIONS(3617),
    [anon_sym_discard] = ACTIONS(3617),
    [anon_sym_precise] = ACTIONS(3617),
    [anon_sym_shared] = ACTIONS(3617),
    [anon_sym_groupshared] = ACTIONS(3617),
    [anon_sym_uniform] = ACTIONS(3617),
    [anon_sym_row_major] = ACTIONS(3617),
    [anon_sym_column_major] = ACTIONS(3617),
    [anon_sym_globallycoherent] = ACTIONS(3617),
    [anon_sym_centroid] = ACTIONS(3617),
    [anon_sym_noperspective] = ACTIONS(3617),
    [anon_sym_nointerpolation] = ACTIONS(3617),
    [anon_sym_sample] = ACTIONS(3617),
    [anon_sym_linear] = ACTIONS(3617),
    [anon_sym_snorm] = ACTIONS(3617),
    [anon_sym_unorm] = ACTIONS(3617),
    [anon_sym_point] = ACTIONS(3617),
    [anon_sym_line] = ACTIONS(3617),
    [anon_sym_triangleadj] = ACTIONS(3617),
    [anon_sym_lineadj] = ACTIONS(3617),
    [anon_sym_triangle] = ACTIONS(3617),
    [anon_sym_cbuffer] = ACTIONS(3617),
    [anon_sym_interface] = ACTIONS(3617),
    [anon_sym_extension] = ACTIONS(3617),
  },
  [971] = {
    [sym_identifier] = ACTIONS(3621),
    [aux_sym_preproc_include_token1] = ACTIONS(3621),
    [aux_sym_preproc_def_token1] = ACTIONS(3621),
    [aux_sym_preproc_if_token1] = ACTIONS(3621),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3621),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3621),
    [sym_preproc_directive] = ACTIONS(3621),
    [anon_sym_LPAREN2] = ACTIONS(3623),
    [anon_sym_BANG] = ACTIONS(3623),
    [anon_sym_TILDE] = ACTIONS(3623),
    [anon_sym_DASH] = ACTIONS(3621),
    [anon_sym_PLUS] = ACTIONS(3621),
    [anon_sym_STAR] = ACTIONS(3623),
    [anon_sym_AMP_AMP] = ACTIONS(3623),
    [anon_sym_AMP] = ACTIONS(3621),
    [anon_sym_SEMI] = ACTIONS(3623),
    [anon_sym___extension__] = ACTIONS(3621),
    [anon_sym_typedef] = ACTIONS(3621),
    [anon_sym_in] = ACTIONS(3621),
    [anon_sym_out] = ACTIONS(3621),
    [anon_sym_inout] = ACTIONS(3621),
    [anon_sym_extern] = ACTIONS(3621),
    [anon_sym___attribute__] = ACTIONS(3621),
    [anon_sym_COLON_COLON] = ACTIONS(3623),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3623),
    [anon_sym___declspec] = ACTIONS(3621),
    [anon_sym___based] = ACTIONS(3621),
    [anon_sym___cdecl] = ACTIONS(3621),
    [anon_sym___clrcall] = ACTIONS(3621),
    [anon_sym___stdcall] = ACTIONS(3621),
    [anon_sym___fastcall] = ACTIONS(3621),
    [anon_sym___thiscall] = ACTIONS(3621),
    [anon_sym___vectorcall] = ACTIONS(3621),
    [anon_sym_LBRACE] = ACTIONS(3623),
    [anon_sym_RBRACE] = ACTIONS(3623),
    [anon_sym_signed] = ACTIONS(3621),
    [anon_sym_unsigned] = ACTIONS(3621),
    [anon_sym_long] = ACTIONS(3621),
    [anon_sym_short] = ACTIONS(3621),
    [anon_sym_LBRACK] = ACTIONS(3621),
    [anon_sym_static] = ACTIONS(3621),
    [anon_sym_register] = ACTIONS(3621),
    [anon_sym_inline] = ACTIONS(3621),
    [anon_sym___inline] = ACTIONS(3621),
    [anon_sym___inline__] = ACTIONS(3621),
    [anon_sym___forceinline] = ACTIONS(3621),
    [anon_sym_thread_local] = ACTIONS(3621),
    [anon_sym___thread] = ACTIONS(3621),
    [anon_sym_const] = ACTIONS(3621),
    [anon_sym_constexpr] = ACTIONS(3621),
    [anon_sym_volatile] = ACTIONS(3621),
    [anon_sym_restrict] = ACTIONS(3621),
    [anon_sym___restrict__] = ACTIONS(3621),
    [anon_sym__Atomic] = ACTIONS(3621),
    [anon_sym__Noreturn] = ACTIONS(3621),
    [anon_sym_noreturn] = ACTIONS(3621),
    [anon_sym_mutable] = ACTIONS(3621),
    [anon_sym_constinit] = ACTIONS(3621),
    [anon_sym_consteval] = ACTIONS(3621),
    [anon_sym_alignas] = ACTIONS(3621),
    [anon_sym__Alignas] = ACTIONS(3621),
    [sym_primitive_type] = ACTIONS(3621),
    [anon_sym_enum] = ACTIONS(3621),
    [anon_sym_class] = ACTIONS(3621),
    [anon_sym_struct] = ACTIONS(3621),
    [anon_sym_union] = ACTIONS(3621),
    [anon_sym_if] = ACTIONS(3621),
    [anon_sym_switch] = ACTIONS(3621),
    [anon_sym_case] = ACTIONS(3621),
    [anon_sym_default] = ACTIONS(3621),
    [anon_sym_while] = ACTIONS(3621),
    [anon_sym_do] = ACTIONS(3621),
    [anon_sym_for] = ACTIONS(3621),
    [anon_sym_return] = ACTIONS(3621),
    [anon_sym_break] = ACTIONS(3621),
    [anon_sym_continue] = ACTIONS(3621),
    [anon_sym_goto] = ACTIONS(3621),
    [anon_sym___try] = ACTIONS(3621),
    [anon_sym___leave] = ACTIONS(3621),
    [anon_sym_not] = ACTIONS(3621),
    [anon_sym_compl] = ACTIONS(3621),
    [anon_sym_DASH_DASH] = ACTIONS(3623),
    [anon_sym_PLUS_PLUS] = ACTIONS(3623),
    [anon_sym_sizeof] = ACTIONS(3621),
    [anon_sym___alignof__] = ACTIONS(3621),
    [anon_sym___alignof] = ACTIONS(3621),
    [anon_sym__alignof] = ACTIONS(3621),
    [anon_sym_alignof] = ACTIONS(3621),
    [anon_sym__Alignof] = ACTIONS(3621),
    [anon_sym_offsetof] = ACTIONS(3621),
    [anon_sym__Generic] = ACTIONS(3621),
    [anon_sym_asm] = ACTIONS(3621),
    [anon_sym___asm__] = ACTIONS(3621),
    [sym_number_literal] = ACTIONS(3623),
    [anon_sym_L_SQUOTE] = ACTIONS(3623),
    [anon_sym_u_SQUOTE] = ACTIONS(3623),
    [anon_sym_U_SQUOTE] = ACTIONS(3623),
    [anon_sym_u8_SQUOTE] = ACTIONS(3623),
    [anon_sym_SQUOTE] = ACTIONS(3623),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(3621),
    [sym_false] = ACTIONS(3621),
    [anon_sym_NULL] = ACTIONS(3621),
    [anon_sym_nullptr] = ACTIONS(3621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3621),
    [anon_sym_let] = ACTIONS(3621),
    [anon_sym_This] = ACTIONS(3621),
    [anon_sym_decltype] = ACTIONS(3621),
    [sym_virtual] = ACTIONS(3621),
    [anon_sym_explicit] = ACTIONS(3621),
    [anon_sym_typename] = ACTIONS(3621),
    [anon_sym_template] = ACTIONS(3621),
    [anon_sym_operator] = ACTIONS(3621),
    [anon_sym_try] = ACTIONS(3621),
    [anon_sym_delete] = ACTIONS(3621),
    [anon_sym_throw] = ACTIONS(3621),
    [anon_sym_namespace] = ACTIONS(3621),
    [anon_sym_using] = ACTIONS(3621),
    [anon_sym_static_assert] = ACTIONS(3621),
    [anon_sym_concept] = ACTIONS(3621),
    [anon_sym_co_return] = ACTIONS(3621),
    [anon_sym_co_yield] = ACTIONS(3621),
    [anon_sym_R_DQUOTE] = ACTIONS(3623),
    [anon_sym_LR_DQUOTE] = ACTIONS(3623),
    [anon_sym_uR_DQUOTE] = ACTIONS(3623),
    [anon_sym_UR_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3623),
    [anon_sym_co_await] = ACTIONS(3621),
    [anon_sym_new] = ACTIONS(3621),
    [anon_sym_requires] = ACTIONS(3621),
    [sym_this] = ACTIONS(3621),
    [anon_sym_discard] = ACTIONS(3621),
    [anon_sym_precise] = ACTIONS(3621),
    [anon_sym_shared] = ACTIONS(3621),
    [anon_sym_groupshared] = ACTIONS(3621),
    [anon_sym_uniform] = ACTIONS(3621),
    [anon_sym_row_major] = ACTIONS(3621),
    [anon_sym_column_major] = ACTIONS(3621),
    [anon_sym_globallycoherent] = ACTIONS(3621),
    [anon_sym_centroid] = ACTIONS(3621),
    [anon_sym_noperspective] = ACTIONS(3621),
    [anon_sym_nointerpolation] = ACTIONS(3621),
    [anon_sym_sample] = ACTIONS(3621),
    [anon_sym_linear] = ACTIONS(3621),
    [anon_sym_snorm] = ACTIONS(3621),
    [anon_sym_unorm] = ACTIONS(3621),
    [anon_sym_point] = ACTIONS(3621),
    [anon_sym_line] = ACTIONS(3621),
    [anon_sym_triangleadj] = ACTIONS(3621),
    [anon_sym_lineadj] = ACTIONS(3621),
    [anon_sym_triangle] = ACTIONS(3621),
    [anon_sym_cbuffer] = ACTIONS(3621),
    [anon_sym_interface] = ACTIONS(3621),
    [anon_sym_extension] = ACTIONS(3621),
  },
  [972] = {
    [sym_identifier] = ACTIONS(3571),
    [aux_sym_preproc_include_token1] = ACTIONS(3571),
    [aux_sym_preproc_def_token1] = ACTIONS(3571),
    [aux_sym_preproc_if_token1] = ACTIONS(3571),
    [aux_sym_preproc_if_token2] = ACTIONS(3571),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3571),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3571),
    [sym_preproc_directive] = ACTIONS(3571),
    [anon_sym_LPAREN2] = ACTIONS(3573),
    [anon_sym_BANG] = ACTIONS(3573),
    [anon_sym_TILDE] = ACTIONS(3573),
    [anon_sym_DASH] = ACTIONS(3571),
    [anon_sym_PLUS] = ACTIONS(3571),
    [anon_sym_STAR] = ACTIONS(3573),
    [anon_sym_AMP_AMP] = ACTIONS(3573),
    [anon_sym_AMP] = ACTIONS(3571),
    [anon_sym_SEMI] = ACTIONS(3573),
    [anon_sym___extension__] = ACTIONS(3571),
    [anon_sym_typedef] = ACTIONS(3571),
    [anon_sym_in] = ACTIONS(3571),
    [anon_sym_out] = ACTIONS(3571),
    [anon_sym_inout] = ACTIONS(3571),
    [anon_sym_extern] = ACTIONS(3571),
    [anon_sym___attribute__] = ACTIONS(3571),
    [anon_sym_COLON_COLON] = ACTIONS(3573),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3573),
    [anon_sym___declspec] = ACTIONS(3571),
    [anon_sym___based] = ACTIONS(3571),
    [anon_sym___cdecl] = ACTIONS(3571),
    [anon_sym___clrcall] = ACTIONS(3571),
    [anon_sym___stdcall] = ACTIONS(3571),
    [anon_sym___fastcall] = ACTIONS(3571),
    [anon_sym___thiscall] = ACTIONS(3571),
    [anon_sym___vectorcall] = ACTIONS(3571),
    [anon_sym_LBRACE] = ACTIONS(3573),
    [anon_sym_signed] = ACTIONS(3571),
    [anon_sym_unsigned] = ACTIONS(3571),
    [anon_sym_long] = ACTIONS(3571),
    [anon_sym_short] = ACTIONS(3571),
    [anon_sym_LBRACK] = ACTIONS(3571),
    [anon_sym_static] = ACTIONS(3571),
    [anon_sym_register] = ACTIONS(3571),
    [anon_sym_inline] = ACTIONS(3571),
    [anon_sym___inline] = ACTIONS(3571),
    [anon_sym___inline__] = ACTIONS(3571),
    [anon_sym___forceinline] = ACTIONS(3571),
    [anon_sym_thread_local] = ACTIONS(3571),
    [anon_sym___thread] = ACTIONS(3571),
    [anon_sym_const] = ACTIONS(3571),
    [anon_sym_constexpr] = ACTIONS(3571),
    [anon_sym_volatile] = ACTIONS(3571),
    [anon_sym_restrict] = ACTIONS(3571),
    [anon_sym___restrict__] = ACTIONS(3571),
    [anon_sym__Atomic] = ACTIONS(3571),
    [anon_sym__Noreturn] = ACTIONS(3571),
    [anon_sym_noreturn] = ACTIONS(3571),
    [anon_sym_mutable] = ACTIONS(3571),
    [anon_sym_constinit] = ACTIONS(3571),
    [anon_sym_consteval] = ACTIONS(3571),
    [anon_sym_alignas] = ACTIONS(3571),
    [anon_sym__Alignas] = ACTIONS(3571),
    [sym_primitive_type] = ACTIONS(3571),
    [anon_sym_enum] = ACTIONS(3571),
    [anon_sym_class] = ACTIONS(3571),
    [anon_sym_struct] = ACTIONS(3571),
    [anon_sym_union] = ACTIONS(3571),
    [anon_sym_if] = ACTIONS(3571),
    [anon_sym_switch] = ACTIONS(3571),
    [anon_sym_case] = ACTIONS(3571),
    [anon_sym_default] = ACTIONS(3571),
    [anon_sym_while] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(3571),
    [anon_sym_for] = ACTIONS(3571),
    [anon_sym_return] = ACTIONS(3571),
    [anon_sym_break] = ACTIONS(3571),
    [anon_sym_continue] = ACTIONS(3571),
    [anon_sym_goto] = ACTIONS(3571),
    [anon_sym___try] = ACTIONS(3571),
    [anon_sym___leave] = ACTIONS(3571),
    [anon_sym_not] = ACTIONS(3571),
    [anon_sym_compl] = ACTIONS(3571),
    [anon_sym_DASH_DASH] = ACTIONS(3573),
    [anon_sym_PLUS_PLUS] = ACTIONS(3573),
    [anon_sym_sizeof] = ACTIONS(3571),
    [anon_sym___alignof__] = ACTIONS(3571),
    [anon_sym___alignof] = ACTIONS(3571),
    [anon_sym__alignof] = ACTIONS(3571),
    [anon_sym_alignof] = ACTIONS(3571),
    [anon_sym__Alignof] = ACTIONS(3571),
    [anon_sym_offsetof] = ACTIONS(3571),
    [anon_sym__Generic] = ACTIONS(3571),
    [anon_sym_asm] = ACTIONS(3571),
    [anon_sym___asm__] = ACTIONS(3571),
    [sym_number_literal] = ACTIONS(3573),
    [anon_sym_L_SQUOTE] = ACTIONS(3573),
    [anon_sym_u_SQUOTE] = ACTIONS(3573),
    [anon_sym_U_SQUOTE] = ACTIONS(3573),
    [anon_sym_u8_SQUOTE] = ACTIONS(3573),
    [anon_sym_SQUOTE] = ACTIONS(3573),
    [anon_sym_L_DQUOTE] = ACTIONS(3573),
    [anon_sym_u_DQUOTE] = ACTIONS(3573),
    [anon_sym_U_DQUOTE] = ACTIONS(3573),
    [anon_sym_u8_DQUOTE] = ACTIONS(3573),
    [anon_sym_DQUOTE] = ACTIONS(3573),
    [sym_true] = ACTIONS(3571),
    [sym_false] = ACTIONS(3571),
    [anon_sym_NULL] = ACTIONS(3571),
    [anon_sym_nullptr] = ACTIONS(3571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3571),
    [anon_sym_let] = ACTIONS(3571),
    [anon_sym_This] = ACTIONS(3571),
    [anon_sym_decltype] = ACTIONS(3571),
    [sym_virtual] = ACTIONS(3571),
    [anon_sym_explicit] = ACTIONS(3571),
    [anon_sym_typename] = ACTIONS(3571),
    [anon_sym_template] = ACTIONS(3571),
    [anon_sym_operator] = ACTIONS(3571),
    [anon_sym_try] = ACTIONS(3571),
    [anon_sym_delete] = ACTIONS(3571),
    [anon_sym_throw] = ACTIONS(3571),
    [anon_sym_namespace] = ACTIONS(3571),
    [anon_sym_using] = ACTIONS(3571),
    [anon_sym_static_assert] = ACTIONS(3571),
    [anon_sym_concept] = ACTIONS(3571),
    [anon_sym_co_return] = ACTIONS(3571),
    [anon_sym_co_yield] = ACTIONS(3571),
    [anon_sym_R_DQUOTE] = ACTIONS(3573),
    [anon_sym_LR_DQUOTE] = ACTIONS(3573),
    [anon_sym_uR_DQUOTE] = ACTIONS(3573),
    [anon_sym_UR_DQUOTE] = ACTIONS(3573),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3573),
    [anon_sym_co_await] = ACTIONS(3571),
    [anon_sym_new] = ACTIONS(3571),
    [anon_sym_requires] = ACTIONS(3571),
    [sym_this] = ACTIONS(3571),
    [anon_sym_discard] = ACTIONS(3571),
    [anon_sym_precise] = ACTIONS(3571),
    [anon_sym_shared] = ACTIONS(3571),
    [anon_sym_groupshared] = ACTIONS(3571),
    [anon_sym_uniform] = ACTIONS(3571),
    [anon_sym_row_major] = ACTIONS(3571),
    [anon_sym_column_major] = ACTIONS(3571),
    [anon_sym_globallycoherent] = ACTIONS(3571),
    [anon_sym_centroid] = ACTIONS(3571),
    [anon_sym_noperspective] = ACTIONS(3571),
    [anon_sym_nointerpolation] = ACTIONS(3571),
    [anon_sym_sample] = ACTIONS(3571),
    [anon_sym_linear] = ACTIONS(3571),
    [anon_sym_snorm] = ACTIONS(3571),
    [anon_sym_unorm] = ACTIONS(3571),
    [anon_sym_point] = ACTIONS(3571),
    [anon_sym_line] = ACTIONS(3571),
    [anon_sym_triangleadj] = ACTIONS(3571),
    [anon_sym_lineadj] = ACTIONS(3571),
    [anon_sym_triangle] = ACTIONS(3571),
    [anon_sym_cbuffer] = ACTIONS(3571),
    [anon_sym_interface] = ACTIONS(3571),
    [anon_sym_extension] = ACTIONS(3571),
  },
  [973] = {
    [sym_attribute_specifier] = STATE(357),
    [ts_builtin_sym_end] = ACTIONS(3801),
    [sym_identifier] = ACTIONS(3799),
    [aux_sym_preproc_include_token1] = ACTIONS(3799),
    [aux_sym_preproc_def_token1] = ACTIONS(3799),
    [aux_sym_preproc_if_token1] = ACTIONS(3799),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3799),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3799),
    [sym_preproc_directive] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(3801),
    [anon_sym_BANG] = ACTIONS(3801),
    [anon_sym_TILDE] = ACTIONS(3801),
    [anon_sym_DASH] = ACTIONS(3799),
    [anon_sym_PLUS] = ACTIONS(3799),
    [anon_sym_STAR] = ACTIONS(3801),
    [anon_sym_AMP_AMP] = ACTIONS(3801),
    [anon_sym_AMP] = ACTIONS(3799),
    [anon_sym_SEMI] = ACTIONS(3801),
    [anon_sym___extension__] = ACTIONS(3799),
    [anon_sym_typedef] = ACTIONS(3799),
    [anon_sym_in] = ACTIONS(3799),
    [anon_sym_out] = ACTIONS(3799),
    [anon_sym_inout] = ACTIONS(3799),
    [anon_sym_extern] = ACTIONS(3799),
    [anon_sym___attribute__] = ACTIONS(2861),
    [anon_sym_COLON_COLON] = ACTIONS(3801),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3801),
    [anon_sym___declspec] = ACTIONS(3799),
    [anon_sym___based] = ACTIONS(3799),
    [anon_sym___cdecl] = ACTIONS(3799),
    [anon_sym___clrcall] = ACTIONS(3799),
    [anon_sym___stdcall] = ACTIONS(3799),
    [anon_sym___fastcall] = ACTIONS(3799),
    [anon_sym___thiscall] = ACTIONS(3799),
    [anon_sym___vectorcall] = ACTIONS(3799),
    [anon_sym_LBRACE] = ACTIONS(3801),
    [anon_sym_signed] = ACTIONS(3799),
    [anon_sym_unsigned] = ACTIONS(3799),
    [anon_sym_long] = ACTIONS(3799),
    [anon_sym_short] = ACTIONS(3799),
    [anon_sym_LBRACK] = ACTIONS(3799),
    [anon_sym_static] = ACTIONS(3799),
    [anon_sym_register] = ACTIONS(3799),
    [anon_sym_inline] = ACTIONS(3799),
    [anon_sym___inline] = ACTIONS(3799),
    [anon_sym___inline__] = ACTIONS(3799),
    [anon_sym___forceinline] = ACTIONS(3799),
    [anon_sym_thread_local] = ACTIONS(3799),
    [anon_sym___thread] = ACTIONS(3799),
    [anon_sym_const] = ACTIONS(3799),
    [anon_sym_constexpr] = ACTIONS(3799),
    [anon_sym_volatile] = ACTIONS(3799),
    [anon_sym_restrict] = ACTIONS(3799),
    [anon_sym___restrict__] = ACTIONS(3799),
    [anon_sym__Atomic] = ACTIONS(3799),
    [anon_sym__Noreturn] = ACTIONS(3799),
    [anon_sym_noreturn] = ACTIONS(3799),
    [anon_sym_mutable] = ACTIONS(3799),
    [anon_sym_constinit] = ACTIONS(3799),
    [anon_sym_consteval] = ACTIONS(3799),
    [anon_sym_alignas] = ACTIONS(3799),
    [anon_sym__Alignas] = ACTIONS(3799),
    [sym_primitive_type] = ACTIONS(3799),
    [anon_sym_enum] = ACTIONS(3799),
    [anon_sym_class] = ACTIONS(3799),
    [anon_sym_struct] = ACTIONS(3799),
    [anon_sym_union] = ACTIONS(3799),
    [anon_sym_if] = ACTIONS(3799),
    [anon_sym_switch] = ACTIONS(3799),
    [anon_sym_case] = ACTIONS(3799),
    [anon_sym_default] = ACTIONS(3799),
    [anon_sym_while] = ACTIONS(3799),
    [anon_sym_do] = ACTIONS(3799),
    [anon_sym_for] = ACTIONS(3799),
    [anon_sym_return] = ACTIONS(3799),
    [anon_sym_break] = ACTIONS(3799),
    [anon_sym_continue] = ACTIONS(3799),
    [anon_sym_goto] = ACTIONS(3799),
    [anon_sym_not] = ACTIONS(3799),
    [anon_sym_compl] = ACTIONS(3799),
    [anon_sym_DASH_DASH] = ACTIONS(3801),
    [anon_sym_PLUS_PLUS] = ACTIONS(3801),
    [anon_sym_sizeof] = ACTIONS(3799),
    [anon_sym___alignof__] = ACTIONS(3799),
    [anon_sym___alignof] = ACTIONS(3799),
    [anon_sym__alignof] = ACTIONS(3799),
    [anon_sym_alignof] = ACTIONS(3799),
    [anon_sym__Alignof] = ACTIONS(3799),
    [anon_sym_offsetof] = ACTIONS(3799),
    [anon_sym__Generic] = ACTIONS(3799),
    [anon_sym_asm] = ACTIONS(3799),
    [anon_sym___asm__] = ACTIONS(3799),
    [anon_sym_DOT] = ACTIONS(3799),
    [sym_number_literal] = ACTIONS(3801),
    [anon_sym_L_SQUOTE] = ACTIONS(3801),
    [anon_sym_u_SQUOTE] = ACTIONS(3801),
    [anon_sym_U_SQUOTE] = ACTIONS(3801),
    [anon_sym_u8_SQUOTE] = ACTIONS(3801),
    [anon_sym_SQUOTE] = ACTIONS(3801),
    [anon_sym_L_DQUOTE] = ACTIONS(3801),
    [anon_sym_u_DQUOTE] = ACTIONS(3801),
    [anon_sym_U_DQUOTE] = ACTIONS(3801),
    [anon_sym_u8_DQUOTE] = ACTIONS(3801),
    [anon_sym_DQUOTE] = ACTIONS(3801),
    [sym_true] = ACTIONS(3799),
    [sym_false] = ACTIONS(3799),
    [anon_sym_NULL] = ACTIONS(3799),
    [anon_sym_nullptr] = ACTIONS(3799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3799),
    [anon_sym_let] = ACTIONS(3799),
    [anon_sym_This] = ACTIONS(3799),
    [anon_sym_decltype] = ACTIONS(3799),
    [sym_virtual] = ACTIONS(3799),
    [anon_sym_explicit] = ACTIONS(3799),
    [anon_sym_typename] = ACTIONS(3799),
    [anon_sym_template] = ACTIONS(3799),
    [anon_sym_operator] = ACTIONS(3799),
    [anon_sym_try] = ACTIONS(3799),
    [anon_sym_delete] = ACTIONS(3799),
    [anon_sym_throw] = ACTIONS(3799),
    [anon_sym_namespace] = ACTIONS(3799),
    [anon_sym_using] = ACTIONS(3799),
    [anon_sym_static_assert] = ACTIONS(3799),
    [anon_sym_concept] = ACTIONS(3799),
    [anon_sym_co_return] = ACTIONS(3799),
    [anon_sym_co_yield] = ACTIONS(3799),
    [anon_sym_R_DQUOTE] = ACTIONS(3801),
    [anon_sym_LR_DQUOTE] = ACTIONS(3801),
    [anon_sym_uR_DQUOTE] = ACTIONS(3801),
    [anon_sym_UR_DQUOTE] = ACTIONS(3801),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3801),
    [anon_sym_co_await] = ACTIONS(3799),
    [anon_sym_new] = ACTIONS(3799),
    [anon_sym_requires] = ACTIONS(3799),
    [sym_this] = ACTIONS(3799),
    [anon_sym_precise] = ACTIONS(3799),
    [anon_sym_shared] = ACTIONS(3799),
    [anon_sym_groupshared] = ACTIONS(3799),
    [anon_sym_uniform] = ACTIONS(3799),
    [anon_sym_row_major] = ACTIONS(3799),
    [anon_sym_column_major] = ACTIONS(3799),
    [anon_sym_globallycoherent] = ACTIONS(3799),
    [anon_sym_centroid] = ACTIONS(3799),
    [anon_sym_noperspective] = ACTIONS(3799),
    [anon_sym_nointerpolation] = ACTIONS(3799),
    [anon_sym_sample] = ACTIONS(3799),
    [anon_sym_linear] = ACTIONS(3799),
    [anon_sym_snorm] = ACTIONS(3799),
    [anon_sym_unorm] = ACTIONS(3799),
    [anon_sym_point] = ACTIONS(3799),
    [anon_sym_line] = ACTIONS(3799),
    [anon_sym_triangleadj] = ACTIONS(3799),
    [anon_sym_lineadj] = ACTIONS(3799),
    [anon_sym_triangle] = ACTIONS(3799),
    [anon_sym_interface] = ACTIONS(3799),
    [anon_sym_extension] = ACTIONS(3799),
    [anon_sym___exported] = ACTIONS(3799),
    [anon_sym_import] = ACTIONS(3799),
  },
  [974] = {
    [sym_identifier] = ACTIONS(3575),
    [aux_sym_preproc_include_token1] = ACTIONS(3575),
    [aux_sym_preproc_def_token1] = ACTIONS(3575),
    [aux_sym_preproc_if_token1] = ACTIONS(3575),
    [aux_sym_preproc_if_token2] = ACTIONS(3575),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3575),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3575),
    [sym_preproc_directive] = ACTIONS(3575),
    [anon_sym_LPAREN2] = ACTIONS(3577),
    [anon_sym_BANG] = ACTIONS(3577),
    [anon_sym_TILDE] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3575),
    [anon_sym_PLUS] = ACTIONS(3575),
    [anon_sym_STAR] = ACTIONS(3577),
    [anon_sym_AMP_AMP] = ACTIONS(3577),
    [anon_sym_AMP] = ACTIONS(3575),
    [anon_sym_SEMI] = ACTIONS(3577),
    [anon_sym___extension__] = ACTIONS(3575),
    [anon_sym_typedef] = ACTIONS(3575),
    [anon_sym_in] = ACTIONS(3575),
    [anon_sym_out] = ACTIONS(3575),
    [anon_sym_inout] = ACTIONS(3575),
    [anon_sym_extern] = ACTIONS(3575),
    [anon_sym___attribute__] = ACTIONS(3575),
    [anon_sym_COLON_COLON] = ACTIONS(3577),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3577),
    [anon_sym___declspec] = ACTIONS(3575),
    [anon_sym___based] = ACTIONS(3575),
    [anon_sym___cdecl] = ACTIONS(3575),
    [anon_sym___clrcall] = ACTIONS(3575),
    [anon_sym___stdcall] = ACTIONS(3575),
    [anon_sym___fastcall] = ACTIONS(3575),
    [anon_sym___thiscall] = ACTIONS(3575),
    [anon_sym___vectorcall] = ACTIONS(3575),
    [anon_sym_LBRACE] = ACTIONS(3577),
    [anon_sym_signed] = ACTIONS(3575),
    [anon_sym_unsigned] = ACTIONS(3575),
    [anon_sym_long] = ACTIONS(3575),
    [anon_sym_short] = ACTIONS(3575),
    [anon_sym_LBRACK] = ACTIONS(3575),
    [anon_sym_static] = ACTIONS(3575),
    [anon_sym_register] = ACTIONS(3575),
    [anon_sym_inline] = ACTIONS(3575),
    [anon_sym___inline] = ACTIONS(3575),
    [anon_sym___inline__] = ACTIONS(3575),
    [anon_sym___forceinline] = ACTIONS(3575),
    [anon_sym_thread_local] = ACTIONS(3575),
    [anon_sym___thread] = ACTIONS(3575),
    [anon_sym_const] = ACTIONS(3575),
    [anon_sym_constexpr] = ACTIONS(3575),
    [anon_sym_volatile] = ACTIONS(3575),
    [anon_sym_restrict] = ACTIONS(3575),
    [anon_sym___restrict__] = ACTIONS(3575),
    [anon_sym__Atomic] = ACTIONS(3575),
    [anon_sym__Noreturn] = ACTIONS(3575),
    [anon_sym_noreturn] = ACTIONS(3575),
    [anon_sym_mutable] = ACTIONS(3575),
    [anon_sym_constinit] = ACTIONS(3575),
    [anon_sym_consteval] = ACTIONS(3575),
    [anon_sym_alignas] = ACTIONS(3575),
    [anon_sym__Alignas] = ACTIONS(3575),
    [sym_primitive_type] = ACTIONS(3575),
    [anon_sym_enum] = ACTIONS(3575),
    [anon_sym_class] = ACTIONS(3575),
    [anon_sym_struct] = ACTIONS(3575),
    [anon_sym_union] = ACTIONS(3575),
    [anon_sym_if] = ACTIONS(3575),
    [anon_sym_switch] = ACTIONS(3575),
    [anon_sym_case] = ACTIONS(3575),
    [anon_sym_default] = ACTIONS(3575),
    [anon_sym_while] = ACTIONS(3575),
    [anon_sym_do] = ACTIONS(3575),
    [anon_sym_for] = ACTIONS(3575),
    [anon_sym_return] = ACTIONS(3575),
    [anon_sym_break] = ACTIONS(3575),
    [anon_sym_continue] = ACTIONS(3575),
    [anon_sym_goto] = ACTIONS(3575),
    [anon_sym___try] = ACTIONS(3575),
    [anon_sym___leave] = ACTIONS(3575),
    [anon_sym_not] = ACTIONS(3575),
    [anon_sym_compl] = ACTIONS(3575),
    [anon_sym_DASH_DASH] = ACTIONS(3577),
    [anon_sym_PLUS_PLUS] = ACTIONS(3577),
    [anon_sym_sizeof] = ACTIONS(3575),
    [anon_sym___alignof__] = ACTIONS(3575),
    [anon_sym___alignof] = ACTIONS(3575),
    [anon_sym__alignof] = ACTIONS(3575),
    [anon_sym_alignof] = ACTIONS(3575),
    [anon_sym__Alignof] = ACTIONS(3575),
    [anon_sym_offsetof] = ACTIONS(3575),
    [anon_sym__Generic] = ACTIONS(3575),
    [anon_sym_asm] = ACTIONS(3575),
    [anon_sym___asm__] = ACTIONS(3575),
    [sym_number_literal] = ACTIONS(3577),
    [anon_sym_L_SQUOTE] = ACTIONS(3577),
    [anon_sym_u_SQUOTE] = ACTIONS(3577),
    [anon_sym_U_SQUOTE] = ACTIONS(3577),
    [anon_sym_u8_SQUOTE] = ACTIONS(3577),
    [anon_sym_SQUOTE] = ACTIONS(3577),
    [anon_sym_L_DQUOTE] = ACTIONS(3577),
    [anon_sym_u_DQUOTE] = ACTIONS(3577),
    [anon_sym_U_DQUOTE] = ACTIONS(3577),
    [anon_sym_u8_DQUOTE] = ACTIONS(3577),
    [anon_sym_DQUOTE] = ACTIONS(3577),
    [sym_true] = ACTIONS(3575),
    [sym_false] = ACTIONS(3575),
    [anon_sym_NULL] = ACTIONS(3575),
    [anon_sym_nullptr] = ACTIONS(3575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3575),
    [anon_sym_let] = ACTIONS(3575),
    [anon_sym_This] = ACTIONS(3575),
    [anon_sym_decltype] = ACTIONS(3575),
    [sym_virtual] = ACTIONS(3575),
    [anon_sym_explicit] = ACTIONS(3575),
    [anon_sym_typename] = ACTIONS(3575),
    [anon_sym_template] = ACTIONS(3575),
    [anon_sym_operator] = ACTIONS(3575),
    [anon_sym_try] = ACTIONS(3575),
    [anon_sym_delete] = ACTIONS(3575),
    [anon_sym_throw] = ACTIONS(3575),
    [anon_sym_namespace] = ACTIONS(3575),
    [anon_sym_using] = ACTIONS(3575),
    [anon_sym_static_assert] = ACTIONS(3575),
    [anon_sym_concept] = ACTIONS(3575),
    [anon_sym_co_return] = ACTIONS(3575),
    [anon_sym_co_yield] = ACTIONS(3575),
    [anon_sym_R_DQUOTE] = ACTIONS(3577),
    [anon_sym_LR_DQUOTE] = ACTIONS(3577),
    [anon_sym_uR_DQUOTE] = ACTIONS(3577),
    [anon_sym_UR_DQUOTE] = ACTIONS(3577),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3577),
    [anon_sym_co_await] = ACTIONS(3575),
    [anon_sym_new] = ACTIONS(3575),
    [anon_sym_requires] = ACTIONS(3575),
    [sym_this] = ACTIONS(3575),
    [anon_sym_discard] = ACTIONS(3575),
    [anon_sym_precise] = ACTIONS(3575),
    [anon_sym_shared] = ACTIONS(3575),
    [anon_sym_groupshared] = ACTIONS(3575),
    [anon_sym_uniform] = ACTIONS(3575),
    [anon_sym_row_major] = ACTIONS(3575),
    [anon_sym_column_major] = ACTIONS(3575),
    [anon_sym_globallycoherent] = ACTIONS(3575),
    [anon_sym_centroid] = ACTIONS(3575),
    [anon_sym_noperspective] = ACTIONS(3575),
    [anon_sym_nointerpolation] = ACTIONS(3575),
    [anon_sym_sample] = ACTIONS(3575),
    [anon_sym_linear] = ACTIONS(3575),
    [anon_sym_snorm] = ACTIONS(3575),
    [anon_sym_unorm] = ACTIONS(3575),
    [anon_sym_point] = ACTIONS(3575),
    [anon_sym_line] = ACTIONS(3575),
    [anon_sym_triangleadj] = ACTIONS(3575),
    [anon_sym_lineadj] = ACTIONS(3575),
    [anon_sym_triangle] = ACTIONS(3575),
    [anon_sym_cbuffer] = ACTIONS(3575),
    [anon_sym_interface] = ACTIONS(3575),
    [anon_sym_extension] = ACTIONS(3575),
  },
  [975] = {
    [sym_attribute_specifier] = STATE(378),
    [ts_builtin_sym_end] = ACTIONS(3797),
    [sym_identifier] = ACTIONS(3795),
    [aux_sym_preproc_include_token1] = ACTIONS(3795),
    [aux_sym_preproc_def_token1] = ACTIONS(3795),
    [aux_sym_preproc_if_token1] = ACTIONS(3795),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3795),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3795),
    [sym_preproc_directive] = ACTIONS(3795),
    [anon_sym_LPAREN2] = ACTIONS(3797),
    [anon_sym_BANG] = ACTIONS(3797),
    [anon_sym_TILDE] = ACTIONS(3797),
    [anon_sym_DASH] = ACTIONS(3795),
    [anon_sym_PLUS] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(3797),
    [anon_sym_AMP_AMP] = ACTIONS(3797),
    [anon_sym_AMP] = ACTIONS(3795),
    [anon_sym_SEMI] = ACTIONS(3797),
    [anon_sym___extension__] = ACTIONS(3795),
    [anon_sym_typedef] = ACTIONS(3795),
    [anon_sym_in] = ACTIONS(3795),
    [anon_sym_out] = ACTIONS(3795),
    [anon_sym_inout] = ACTIONS(3795),
    [anon_sym_extern] = ACTIONS(3795),
    [anon_sym___attribute__] = ACTIONS(2861),
    [anon_sym_COLON_COLON] = ACTIONS(3797),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3797),
    [anon_sym___declspec] = ACTIONS(3795),
    [anon_sym___based] = ACTIONS(3795),
    [anon_sym___cdecl] = ACTIONS(3795),
    [anon_sym___clrcall] = ACTIONS(3795),
    [anon_sym___stdcall] = ACTIONS(3795),
    [anon_sym___fastcall] = ACTIONS(3795),
    [anon_sym___thiscall] = ACTIONS(3795),
    [anon_sym___vectorcall] = ACTIONS(3795),
    [anon_sym_LBRACE] = ACTIONS(3797),
    [anon_sym_signed] = ACTIONS(3795),
    [anon_sym_unsigned] = ACTIONS(3795),
    [anon_sym_long] = ACTIONS(3795),
    [anon_sym_short] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3795),
    [anon_sym_static] = ACTIONS(3795),
    [anon_sym_register] = ACTIONS(3795),
    [anon_sym_inline] = ACTIONS(3795),
    [anon_sym___inline] = ACTIONS(3795),
    [anon_sym___inline__] = ACTIONS(3795),
    [anon_sym___forceinline] = ACTIONS(3795),
    [anon_sym_thread_local] = ACTIONS(3795),
    [anon_sym___thread] = ACTIONS(3795),
    [anon_sym_const] = ACTIONS(3795),
    [anon_sym_constexpr] = ACTIONS(3795),
    [anon_sym_volatile] = ACTIONS(3795),
    [anon_sym_restrict] = ACTIONS(3795),
    [anon_sym___restrict__] = ACTIONS(3795),
    [anon_sym__Atomic] = ACTIONS(3795),
    [anon_sym__Noreturn] = ACTIONS(3795),
    [anon_sym_noreturn] = ACTIONS(3795),
    [anon_sym_mutable] = ACTIONS(3795),
    [anon_sym_constinit] = ACTIONS(3795),
    [anon_sym_consteval] = ACTIONS(3795),
    [anon_sym_alignas] = ACTIONS(3795),
    [anon_sym__Alignas] = ACTIONS(3795),
    [sym_primitive_type] = ACTIONS(3795),
    [anon_sym_enum] = ACTIONS(3795),
    [anon_sym_class] = ACTIONS(3795),
    [anon_sym_struct] = ACTIONS(3795),
    [anon_sym_union] = ACTIONS(3795),
    [anon_sym_if] = ACTIONS(3795),
    [anon_sym_switch] = ACTIONS(3795),
    [anon_sym_case] = ACTIONS(3795),
    [anon_sym_default] = ACTIONS(3795),
    [anon_sym_while] = ACTIONS(3795),
    [anon_sym_do] = ACTIONS(3795),
    [anon_sym_for] = ACTIONS(3795),
    [anon_sym_return] = ACTIONS(3795),
    [anon_sym_break] = ACTIONS(3795),
    [anon_sym_continue] = ACTIONS(3795),
    [anon_sym_goto] = ACTIONS(3795),
    [anon_sym_not] = ACTIONS(3795),
    [anon_sym_compl] = ACTIONS(3795),
    [anon_sym_DASH_DASH] = ACTIONS(3797),
    [anon_sym_PLUS_PLUS] = ACTIONS(3797),
    [anon_sym_sizeof] = ACTIONS(3795),
    [anon_sym___alignof__] = ACTIONS(3795),
    [anon_sym___alignof] = ACTIONS(3795),
    [anon_sym__alignof] = ACTIONS(3795),
    [anon_sym_alignof] = ACTIONS(3795),
    [anon_sym__Alignof] = ACTIONS(3795),
    [anon_sym_offsetof] = ACTIONS(3795),
    [anon_sym__Generic] = ACTIONS(3795),
    [anon_sym_asm] = ACTIONS(3795),
    [anon_sym___asm__] = ACTIONS(3795),
    [anon_sym_DOT] = ACTIONS(3795),
    [sym_number_literal] = ACTIONS(3797),
    [anon_sym_L_SQUOTE] = ACTIONS(3797),
    [anon_sym_u_SQUOTE] = ACTIONS(3797),
    [anon_sym_U_SQUOTE] = ACTIONS(3797),
    [anon_sym_u8_SQUOTE] = ACTIONS(3797),
    [anon_sym_SQUOTE] = ACTIONS(3797),
    [anon_sym_L_DQUOTE] = ACTIONS(3797),
    [anon_sym_u_DQUOTE] = ACTIONS(3797),
    [anon_sym_U_DQUOTE] = ACTIONS(3797),
    [anon_sym_u8_DQUOTE] = ACTIONS(3797),
    [anon_sym_DQUOTE] = ACTIONS(3797),
    [sym_true] = ACTIONS(3795),
    [sym_false] = ACTIONS(3795),
    [anon_sym_NULL] = ACTIONS(3795),
    [anon_sym_nullptr] = ACTIONS(3795),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3795),
    [anon_sym_let] = ACTIONS(3795),
    [anon_sym_This] = ACTIONS(3795),
    [anon_sym_decltype] = ACTIONS(3795),
    [sym_virtual] = ACTIONS(3795),
    [anon_sym_explicit] = ACTIONS(3795),
    [anon_sym_typename] = ACTIONS(3795),
    [anon_sym_template] = ACTIONS(3795),
    [anon_sym_operator] = ACTIONS(3795),
    [anon_sym_try] = ACTIONS(3795),
    [anon_sym_delete] = ACTIONS(3795),
    [anon_sym_throw] = ACTIONS(3795),
    [anon_sym_namespace] = ACTIONS(3795),
    [anon_sym_using] = ACTIONS(3795),
    [anon_sym_static_assert] = ACTIONS(3795),
    [anon_sym_concept] = ACTIONS(3795),
    [anon_sym_co_return] = ACTIONS(3795),
    [anon_sym_co_yield] = ACTIONS(3795),
    [anon_sym_R_DQUOTE] = ACTIONS(3797),
    [anon_sym_LR_DQUOTE] = ACTIONS(3797),
    [anon_sym_uR_DQUOTE] = ACTIONS(3797),
    [anon_sym_UR_DQUOTE] = ACTIONS(3797),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3797),
    [anon_sym_co_await] = ACTIONS(3795),
    [anon_sym_new] = ACTIONS(3795),
    [anon_sym_requires] = ACTIONS(3795),
    [sym_this] = ACTIONS(3795),
    [anon_sym_precise] = ACTIONS(3795),
    [anon_sym_shared] = ACTIONS(3795),
    [anon_sym_groupshared] = ACTIONS(3795),
    [anon_sym_uniform] = ACTIONS(3795),
    [anon_sym_row_major] = ACTIONS(3795),
    [anon_sym_column_major] = ACTIONS(3795),
    [anon_sym_globallycoherent] = ACTIONS(3795),
    [anon_sym_centroid] = ACTIONS(3795),
    [anon_sym_noperspective] = ACTIONS(3795),
    [anon_sym_nointerpolation] = ACTIONS(3795),
    [anon_sym_sample] = ACTIONS(3795),
    [anon_sym_linear] = ACTIONS(3795),
    [anon_sym_snorm] = ACTIONS(3795),
    [anon_sym_unorm] = ACTIONS(3795),
    [anon_sym_point] = ACTIONS(3795),
    [anon_sym_line] = ACTIONS(3795),
    [anon_sym_triangleadj] = ACTIONS(3795),
    [anon_sym_lineadj] = ACTIONS(3795),
    [anon_sym_triangle] = ACTIONS(3795),
    [anon_sym_interface] = ACTIONS(3795),
    [anon_sym_extension] = ACTIONS(3795),
    [anon_sym___exported] = ACTIONS(3795),
    [anon_sym_import] = ACTIONS(3795),
  },
  [976] = {
    [sym_identifier] = ACTIONS(3665),
    [aux_sym_preproc_include_token1] = ACTIONS(3665),
    [aux_sym_preproc_def_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token2] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3665),
    [sym_preproc_directive] = ACTIONS(3665),
    [anon_sym_LPAREN2] = ACTIONS(3667),
    [anon_sym_BANG] = ACTIONS(3667),
    [anon_sym_TILDE] = ACTIONS(3667),
    [anon_sym_DASH] = ACTIONS(3665),
    [anon_sym_PLUS] = ACTIONS(3665),
    [anon_sym_STAR] = ACTIONS(3667),
    [anon_sym_AMP_AMP] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym_SEMI] = ACTIONS(3667),
    [anon_sym___extension__] = ACTIONS(3665),
    [anon_sym_typedef] = ACTIONS(3665),
    [anon_sym_in] = ACTIONS(3665),
    [anon_sym_out] = ACTIONS(3665),
    [anon_sym_inout] = ACTIONS(3665),
    [anon_sym_extern] = ACTIONS(3665),
    [anon_sym___attribute__] = ACTIONS(3665),
    [anon_sym_COLON_COLON] = ACTIONS(3667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3667),
    [anon_sym___declspec] = ACTIONS(3665),
    [anon_sym___based] = ACTIONS(3665),
    [anon_sym___cdecl] = ACTIONS(3665),
    [anon_sym___clrcall] = ACTIONS(3665),
    [anon_sym___stdcall] = ACTIONS(3665),
    [anon_sym___fastcall] = ACTIONS(3665),
    [anon_sym___thiscall] = ACTIONS(3665),
    [anon_sym___vectorcall] = ACTIONS(3665),
    [anon_sym_LBRACE] = ACTIONS(3667),
    [anon_sym_signed] = ACTIONS(3665),
    [anon_sym_unsigned] = ACTIONS(3665),
    [anon_sym_long] = ACTIONS(3665),
    [anon_sym_short] = ACTIONS(3665),
    [anon_sym_LBRACK] = ACTIONS(3665),
    [anon_sym_static] = ACTIONS(3665),
    [anon_sym_register] = ACTIONS(3665),
    [anon_sym_inline] = ACTIONS(3665),
    [anon_sym___inline] = ACTIONS(3665),
    [anon_sym___inline__] = ACTIONS(3665),
    [anon_sym___forceinline] = ACTIONS(3665),
    [anon_sym_thread_local] = ACTIONS(3665),
    [anon_sym___thread] = ACTIONS(3665),
    [anon_sym_const] = ACTIONS(3665),
    [anon_sym_constexpr] = ACTIONS(3665),
    [anon_sym_volatile] = ACTIONS(3665),
    [anon_sym_restrict] = ACTIONS(3665),
    [anon_sym___restrict__] = ACTIONS(3665),
    [anon_sym__Atomic] = ACTIONS(3665),
    [anon_sym__Noreturn] = ACTIONS(3665),
    [anon_sym_noreturn] = ACTIONS(3665),
    [anon_sym_mutable] = ACTIONS(3665),
    [anon_sym_constinit] = ACTIONS(3665),
    [anon_sym_consteval] = ACTIONS(3665),
    [anon_sym_alignas] = ACTIONS(3665),
    [anon_sym__Alignas] = ACTIONS(3665),
    [sym_primitive_type] = ACTIONS(3665),
    [anon_sym_enum] = ACTIONS(3665),
    [anon_sym_class] = ACTIONS(3665),
    [anon_sym_struct] = ACTIONS(3665),
    [anon_sym_union] = ACTIONS(3665),
    [anon_sym_if] = ACTIONS(3665),
    [anon_sym_switch] = ACTIONS(3665),
    [anon_sym_case] = ACTIONS(3665),
    [anon_sym_default] = ACTIONS(3665),
    [anon_sym_while] = ACTIONS(3665),
    [anon_sym_do] = ACTIONS(3665),
    [anon_sym_for] = ACTIONS(3665),
    [anon_sym_return] = ACTIONS(3665),
    [anon_sym_break] = ACTIONS(3665),
    [anon_sym_continue] = ACTIONS(3665),
    [anon_sym_goto] = ACTIONS(3665),
    [anon_sym___try] = ACTIONS(3665),
    [anon_sym___leave] = ACTIONS(3665),
    [anon_sym_not] = ACTIONS(3665),
    [anon_sym_compl] = ACTIONS(3665),
    [anon_sym_DASH_DASH] = ACTIONS(3667),
    [anon_sym_PLUS_PLUS] = ACTIONS(3667),
    [anon_sym_sizeof] = ACTIONS(3665),
    [anon_sym___alignof__] = ACTIONS(3665),
    [anon_sym___alignof] = ACTIONS(3665),
    [anon_sym__alignof] = ACTIONS(3665),
    [anon_sym_alignof] = ACTIONS(3665),
    [anon_sym__Alignof] = ACTIONS(3665),
    [anon_sym_offsetof] = ACTIONS(3665),
    [anon_sym__Generic] = ACTIONS(3665),
    [anon_sym_asm] = ACTIONS(3665),
    [anon_sym___asm__] = ACTIONS(3665),
    [sym_number_literal] = ACTIONS(3667),
    [anon_sym_L_SQUOTE] = ACTIONS(3667),
    [anon_sym_u_SQUOTE] = ACTIONS(3667),
    [anon_sym_U_SQUOTE] = ACTIONS(3667),
    [anon_sym_u8_SQUOTE] = ACTIONS(3667),
    [anon_sym_SQUOTE] = ACTIONS(3667),
    [anon_sym_L_DQUOTE] = ACTIONS(3667),
    [anon_sym_u_DQUOTE] = ACTIONS(3667),
    [anon_sym_U_DQUOTE] = ACTIONS(3667),
    [anon_sym_u8_DQUOTE] = ACTIONS(3667),
    [anon_sym_DQUOTE] = ACTIONS(3667),
    [sym_true] = ACTIONS(3665),
    [sym_false] = ACTIONS(3665),
    [anon_sym_NULL] = ACTIONS(3665),
    [anon_sym_nullptr] = ACTIONS(3665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3665),
    [anon_sym_let] = ACTIONS(3665),
    [anon_sym_This] = ACTIONS(3665),
    [anon_sym_decltype] = ACTIONS(3665),
    [sym_virtual] = ACTIONS(3665),
    [anon_sym_explicit] = ACTIONS(3665),
    [anon_sym_typename] = ACTIONS(3665),
    [anon_sym_template] = ACTIONS(3665),
    [anon_sym_operator] = ACTIONS(3665),
    [anon_sym_try] = ACTIONS(3665),
    [anon_sym_delete] = ACTIONS(3665),
    [anon_sym_throw] = ACTIONS(3665),
    [anon_sym_namespace] = ACTIONS(3665),
    [anon_sym_using] = ACTIONS(3665),
    [anon_sym_static_assert] = ACTIONS(3665),
    [anon_sym_concept] = ACTIONS(3665),
    [anon_sym_co_return] = ACTIONS(3665),
    [anon_sym_co_yield] = ACTIONS(3665),
    [anon_sym_R_DQUOTE] = ACTIONS(3667),
    [anon_sym_LR_DQUOTE] = ACTIONS(3667),
    [anon_sym_uR_DQUOTE] = ACTIONS(3667),
    [anon_sym_UR_DQUOTE] = ACTIONS(3667),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3667),
    [anon_sym_co_await] = ACTIONS(3665),
    [anon_sym_new] = ACTIONS(3665),
    [anon_sym_requires] = ACTIONS(3665),
    [sym_this] = ACTIONS(3665),
    [anon_sym_discard] = ACTIONS(3665),
    [anon_sym_precise] = ACTIONS(3665),
    [anon_sym_shared] = ACTIONS(3665),
    [anon_sym_groupshared] = ACTIONS(3665),
    [anon_sym_uniform] = ACTIONS(3665),
    [anon_sym_row_major] = ACTIONS(3665),
    [anon_sym_column_major] = ACTIONS(3665),
    [anon_sym_globallycoherent] = ACTIONS(3665),
    [anon_sym_centroid] = ACTIONS(3665),
    [anon_sym_noperspective] = ACTIONS(3665),
    [anon_sym_nointerpolation] = ACTIONS(3665),
    [anon_sym_sample] = ACTIONS(3665),
    [anon_sym_linear] = ACTIONS(3665),
    [anon_sym_snorm] = ACTIONS(3665),
    [anon_sym_unorm] = ACTIONS(3665),
    [anon_sym_point] = ACTIONS(3665),
    [anon_sym_line] = ACTIONS(3665),
    [anon_sym_triangleadj] = ACTIONS(3665),
    [anon_sym_lineadj] = ACTIONS(3665),
    [anon_sym_triangle] = ACTIONS(3665),
    [anon_sym_cbuffer] = ACTIONS(3665),
    [anon_sym_interface] = ACTIONS(3665),
    [anon_sym_extension] = ACTIONS(3665),
  },
  [977] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(846),
    [ts_builtin_sym_end] = ACTIONS(3390),
    [sym_identifier] = ACTIONS(3392),
    [aux_sym_preproc_include_token1] = ACTIONS(3392),
    [aux_sym_preproc_def_token1] = ACTIONS(3392),
    [aux_sym_preproc_if_token1] = ACTIONS(3392),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3392),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3392),
    [sym_preproc_directive] = ACTIONS(3392),
    [anon_sym_LPAREN2] = ACTIONS(3390),
    [anon_sym_BANG] = ACTIONS(3390),
    [anon_sym_TILDE] = ACTIONS(3390),
    [anon_sym_DASH] = ACTIONS(3392),
    [anon_sym_PLUS] = ACTIONS(3392),
    [anon_sym_STAR] = ACTIONS(3390),
    [anon_sym_AMP_AMP] = ACTIONS(3390),
    [anon_sym_AMP] = ACTIONS(3392),
    [anon_sym_SEMI] = ACTIONS(3390),
    [anon_sym___extension__] = ACTIONS(3392),
    [anon_sym_typedef] = ACTIONS(3392),
    [anon_sym_in] = ACTIONS(3392),
    [anon_sym_out] = ACTIONS(3392),
    [anon_sym_inout] = ACTIONS(3392),
    [anon_sym_extern] = ACTIONS(3392),
    [anon_sym___attribute__] = ACTIONS(3392),
    [anon_sym_COLON_COLON] = ACTIONS(3390),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3390),
    [anon_sym___declspec] = ACTIONS(3392),
    [anon_sym___based] = ACTIONS(3392),
    [anon_sym___cdecl] = ACTIONS(3392),
    [anon_sym___clrcall] = ACTIONS(3392),
    [anon_sym___stdcall] = ACTIONS(3392),
    [anon_sym___fastcall] = ACTIONS(3392),
    [anon_sym___thiscall] = ACTIONS(3392),
    [anon_sym___vectorcall] = ACTIONS(3392),
    [anon_sym_LBRACE] = ACTIONS(3390),
    [anon_sym_signed] = ACTIONS(3392),
    [anon_sym_unsigned] = ACTIONS(3392),
    [anon_sym_long] = ACTIONS(3392),
    [anon_sym_short] = ACTIONS(3392),
    [anon_sym_LBRACK] = ACTIONS(3392),
    [anon_sym_static] = ACTIONS(3392),
    [anon_sym_register] = ACTIONS(3392),
    [anon_sym_inline] = ACTIONS(3392),
    [anon_sym___inline] = ACTIONS(3392),
    [anon_sym___inline__] = ACTIONS(3392),
    [anon_sym___forceinline] = ACTIONS(3392),
    [anon_sym_thread_local] = ACTIONS(3392),
    [anon_sym___thread] = ACTIONS(3392),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_constexpr] = ACTIONS(3392),
    [anon_sym_volatile] = ACTIONS(3392),
    [anon_sym_restrict] = ACTIONS(3392),
    [anon_sym___restrict__] = ACTIONS(3392),
    [anon_sym__Atomic] = ACTIONS(3392),
    [anon_sym__Noreturn] = ACTIONS(3392),
    [anon_sym_noreturn] = ACTIONS(3392),
    [anon_sym_mutable] = ACTIONS(3392),
    [anon_sym_constinit] = ACTIONS(3392),
    [anon_sym_consteval] = ACTIONS(3392),
    [anon_sym_alignas] = ACTIONS(3392),
    [anon_sym__Alignas] = ACTIONS(3392),
    [sym_primitive_type] = ACTIONS(3392),
    [anon_sym_enum] = ACTIONS(3392),
    [anon_sym_class] = ACTIONS(3392),
    [anon_sym_struct] = ACTIONS(3392),
    [anon_sym_union] = ACTIONS(3392),
    [anon_sym_if] = ACTIONS(3392),
    [anon_sym_switch] = ACTIONS(3392),
    [anon_sym_case] = ACTIONS(3392),
    [anon_sym_default] = ACTIONS(3392),
    [anon_sym_while] = ACTIONS(3392),
    [anon_sym_do] = ACTIONS(3392),
    [anon_sym_for] = ACTIONS(3392),
    [anon_sym_return] = ACTIONS(3392),
    [anon_sym_break] = ACTIONS(3392),
    [anon_sym_continue] = ACTIONS(3392),
    [anon_sym_goto] = ACTIONS(3392),
    [anon_sym_not] = ACTIONS(3392),
    [anon_sym_compl] = ACTIONS(3392),
    [anon_sym_DASH_DASH] = ACTIONS(3390),
    [anon_sym_PLUS_PLUS] = ACTIONS(3390),
    [anon_sym_sizeof] = ACTIONS(3392),
    [anon_sym___alignof__] = ACTIONS(3392),
    [anon_sym___alignof] = ACTIONS(3392),
    [anon_sym__alignof] = ACTIONS(3392),
    [anon_sym_alignof] = ACTIONS(3392),
    [anon_sym__Alignof] = ACTIONS(3392),
    [anon_sym_offsetof] = ACTIONS(3392),
    [anon_sym__Generic] = ACTIONS(3392),
    [anon_sym_asm] = ACTIONS(3392),
    [anon_sym___asm__] = ACTIONS(3392),
    [anon_sym_DOT] = ACTIONS(3392),
    [sym_number_literal] = ACTIONS(3390),
    [anon_sym_L_SQUOTE] = ACTIONS(3390),
    [anon_sym_u_SQUOTE] = ACTIONS(3390),
    [anon_sym_U_SQUOTE] = ACTIONS(3390),
    [anon_sym_u8_SQUOTE] = ACTIONS(3390),
    [anon_sym_SQUOTE] = ACTIONS(3390),
    [anon_sym_L_DQUOTE] = ACTIONS(3390),
    [anon_sym_u_DQUOTE] = ACTIONS(3390),
    [anon_sym_U_DQUOTE] = ACTIONS(3390),
    [anon_sym_u8_DQUOTE] = ACTIONS(3390),
    [anon_sym_DQUOTE] = ACTIONS(3390),
    [sym_true] = ACTIONS(3392),
    [sym_false] = ACTIONS(3392),
    [anon_sym_NULL] = ACTIONS(3392),
    [anon_sym_nullptr] = ACTIONS(3392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3392),
    [anon_sym_let] = ACTIONS(3392),
    [anon_sym_This] = ACTIONS(3392),
    [anon_sym_decltype] = ACTIONS(3392),
    [sym_virtual] = ACTIONS(3392),
    [anon_sym_explicit] = ACTIONS(3392),
    [anon_sym_typename] = ACTIONS(3392),
    [anon_sym_template] = ACTIONS(3392),
    [anon_sym_operator] = ACTIONS(3392),
    [anon_sym_try] = ACTIONS(3392),
    [anon_sym_delete] = ACTIONS(3392),
    [anon_sym_throw] = ACTIONS(3392),
    [anon_sym_namespace] = ACTIONS(3392),
    [anon_sym_using] = ACTIONS(3392),
    [anon_sym_static_assert] = ACTIONS(3392),
    [anon_sym_concept] = ACTIONS(3392),
    [anon_sym_co_return] = ACTIONS(3392),
    [anon_sym_co_yield] = ACTIONS(3392),
    [anon_sym_R_DQUOTE] = ACTIONS(3390),
    [anon_sym_LR_DQUOTE] = ACTIONS(3390),
    [anon_sym_uR_DQUOTE] = ACTIONS(3390),
    [anon_sym_UR_DQUOTE] = ACTIONS(3390),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3390),
    [anon_sym_co_await] = ACTIONS(3392),
    [anon_sym_new] = ACTIONS(3392),
    [anon_sym_requires] = ACTIONS(3392),
    [sym_this] = ACTIONS(3392),
    [anon_sym_precise] = ACTIONS(3392),
    [anon_sym_shared] = ACTIONS(3392),
    [anon_sym_groupshared] = ACTIONS(3392),
    [anon_sym_uniform] = ACTIONS(3392),
    [anon_sym_row_major] = ACTIONS(3392),
    [anon_sym_column_major] = ACTIONS(3392),
    [anon_sym_globallycoherent] = ACTIONS(3392),
    [anon_sym_centroid] = ACTIONS(3392),
    [anon_sym_noperspective] = ACTIONS(3392),
    [anon_sym_nointerpolation] = ACTIONS(3392),
    [anon_sym_sample] = ACTIONS(3392),
    [anon_sym_linear] = ACTIONS(3392),
    [anon_sym_snorm] = ACTIONS(3392),
    [anon_sym_unorm] = ACTIONS(3392),
    [anon_sym_point] = ACTIONS(3392),
    [anon_sym_line] = ACTIONS(3392),
    [anon_sym_triangleadj] = ACTIONS(3392),
    [anon_sym_lineadj] = ACTIONS(3392),
    [anon_sym_triangle] = ACTIONS(3392),
    [anon_sym_interface] = ACTIONS(3392),
    [anon_sym_extension] = ACTIONS(3392),
    [anon_sym___exported] = ACTIONS(3392),
    [anon_sym_import] = ACTIONS(3392),
  },
  [978] = {
    [sym_identifier] = ACTIONS(3665),
    [aux_sym_preproc_include_token1] = ACTIONS(3665),
    [aux_sym_preproc_def_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token2] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3665),
    [sym_preproc_directive] = ACTIONS(3665),
    [anon_sym_LPAREN2] = ACTIONS(3667),
    [anon_sym_BANG] = ACTIONS(3667),
    [anon_sym_TILDE] = ACTIONS(3667),
    [anon_sym_DASH] = ACTIONS(3665),
    [anon_sym_PLUS] = ACTIONS(3665),
    [anon_sym_STAR] = ACTIONS(3667),
    [anon_sym_AMP_AMP] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym_SEMI] = ACTIONS(3667),
    [anon_sym___extension__] = ACTIONS(3665),
    [anon_sym_typedef] = ACTIONS(3665),
    [anon_sym_in] = ACTIONS(3665),
    [anon_sym_out] = ACTIONS(3665),
    [anon_sym_inout] = ACTIONS(3665),
    [anon_sym_extern] = ACTIONS(3665),
    [anon_sym___attribute__] = ACTIONS(3665),
    [anon_sym_COLON_COLON] = ACTIONS(3667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3667),
    [anon_sym___declspec] = ACTIONS(3665),
    [anon_sym___based] = ACTIONS(3665),
    [anon_sym___cdecl] = ACTIONS(3665),
    [anon_sym___clrcall] = ACTIONS(3665),
    [anon_sym___stdcall] = ACTIONS(3665),
    [anon_sym___fastcall] = ACTIONS(3665),
    [anon_sym___thiscall] = ACTIONS(3665),
    [anon_sym___vectorcall] = ACTIONS(3665),
    [anon_sym_LBRACE] = ACTIONS(3667),
    [anon_sym_signed] = ACTIONS(3665),
    [anon_sym_unsigned] = ACTIONS(3665),
    [anon_sym_long] = ACTIONS(3665),
    [anon_sym_short] = ACTIONS(3665),
    [anon_sym_LBRACK] = ACTIONS(3665),
    [anon_sym_static] = ACTIONS(3665),
    [anon_sym_register] = ACTIONS(3665),
    [anon_sym_inline] = ACTIONS(3665),
    [anon_sym___inline] = ACTIONS(3665),
    [anon_sym___inline__] = ACTIONS(3665),
    [anon_sym___forceinline] = ACTIONS(3665),
    [anon_sym_thread_local] = ACTIONS(3665),
    [anon_sym___thread] = ACTIONS(3665),
    [anon_sym_const] = ACTIONS(3665),
    [anon_sym_constexpr] = ACTIONS(3665),
    [anon_sym_volatile] = ACTIONS(3665),
    [anon_sym_restrict] = ACTIONS(3665),
    [anon_sym___restrict__] = ACTIONS(3665),
    [anon_sym__Atomic] = ACTIONS(3665),
    [anon_sym__Noreturn] = ACTIONS(3665),
    [anon_sym_noreturn] = ACTIONS(3665),
    [anon_sym_mutable] = ACTIONS(3665),
    [anon_sym_constinit] = ACTIONS(3665),
    [anon_sym_consteval] = ACTIONS(3665),
    [anon_sym_alignas] = ACTIONS(3665),
    [anon_sym__Alignas] = ACTIONS(3665),
    [sym_primitive_type] = ACTIONS(3665),
    [anon_sym_enum] = ACTIONS(3665),
    [anon_sym_class] = ACTIONS(3665),
    [anon_sym_struct] = ACTIONS(3665),
    [anon_sym_union] = ACTIONS(3665),
    [anon_sym_if] = ACTIONS(3665),
    [anon_sym_switch] = ACTIONS(3665),
    [anon_sym_case] = ACTIONS(3665),
    [anon_sym_default] = ACTIONS(3665),
    [anon_sym_while] = ACTIONS(3665),
    [anon_sym_do] = ACTIONS(3665),
    [anon_sym_for] = ACTIONS(3665),
    [anon_sym_return] = ACTIONS(3665),
    [anon_sym_break] = ACTIONS(3665),
    [anon_sym_continue] = ACTIONS(3665),
    [anon_sym_goto] = ACTIONS(3665),
    [anon_sym___try] = ACTIONS(3665),
    [anon_sym___leave] = ACTIONS(3665),
    [anon_sym_not] = ACTIONS(3665),
    [anon_sym_compl] = ACTIONS(3665),
    [anon_sym_DASH_DASH] = ACTIONS(3667),
    [anon_sym_PLUS_PLUS] = ACTIONS(3667),
    [anon_sym_sizeof] = ACTIONS(3665),
    [anon_sym___alignof__] = ACTIONS(3665),
    [anon_sym___alignof] = ACTIONS(3665),
    [anon_sym__alignof] = ACTIONS(3665),
    [anon_sym_alignof] = ACTIONS(3665),
    [anon_sym__Alignof] = ACTIONS(3665),
    [anon_sym_offsetof] = ACTIONS(3665),
    [anon_sym__Generic] = ACTIONS(3665),
    [anon_sym_asm] = ACTIONS(3665),
    [anon_sym___asm__] = ACTIONS(3665),
    [sym_number_literal] = ACTIONS(3667),
    [anon_sym_L_SQUOTE] = ACTIONS(3667),
    [anon_sym_u_SQUOTE] = ACTIONS(3667),
    [anon_sym_U_SQUOTE] = ACTIONS(3667),
    [anon_sym_u8_SQUOTE] = ACTIONS(3667),
    [anon_sym_SQUOTE] = ACTIONS(3667),
    [anon_sym_L_DQUOTE] = ACTIONS(3667),
    [anon_sym_u_DQUOTE] = ACTIONS(3667),
    [anon_sym_U_DQUOTE] = ACTIONS(3667),
    [anon_sym_u8_DQUOTE] = ACTIONS(3667),
    [anon_sym_DQUOTE] = ACTIONS(3667),
    [sym_true] = ACTIONS(3665),
    [sym_false] = ACTIONS(3665),
    [anon_sym_NULL] = ACTIONS(3665),
    [anon_sym_nullptr] = ACTIONS(3665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3665),
    [anon_sym_let] = ACTIONS(3665),
    [anon_sym_This] = ACTIONS(3665),
    [anon_sym_decltype] = ACTIONS(3665),
    [sym_virtual] = ACTIONS(3665),
    [anon_sym_explicit] = ACTIONS(3665),
    [anon_sym_typename] = ACTIONS(3665),
    [anon_sym_template] = ACTIONS(3665),
    [anon_sym_operator] = ACTIONS(3665),
    [anon_sym_try] = ACTIONS(3665),
    [anon_sym_delete] = ACTIONS(3665),
    [anon_sym_throw] = ACTIONS(3665),
    [anon_sym_namespace] = ACTIONS(3665),
    [anon_sym_using] = ACTIONS(3665),
    [anon_sym_static_assert] = ACTIONS(3665),
    [anon_sym_concept] = ACTIONS(3665),
    [anon_sym_co_return] = ACTIONS(3665),
    [anon_sym_co_yield] = ACTIONS(3665),
    [anon_sym_R_DQUOTE] = ACTIONS(3667),
    [anon_sym_LR_DQUOTE] = ACTIONS(3667),
    [anon_sym_uR_DQUOTE] = ACTIONS(3667),
    [anon_sym_UR_DQUOTE] = ACTIONS(3667),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3667),
    [anon_sym_co_await] = ACTIONS(3665),
    [anon_sym_new] = ACTIONS(3665),
    [anon_sym_requires] = ACTIONS(3665),
    [sym_this] = ACTIONS(3665),
    [anon_sym_discard] = ACTIONS(3665),
    [anon_sym_precise] = ACTIONS(3665),
    [anon_sym_shared] = ACTIONS(3665),
    [anon_sym_groupshared] = ACTIONS(3665),
    [anon_sym_uniform] = ACTIONS(3665),
    [anon_sym_row_major] = ACTIONS(3665),
    [anon_sym_column_major] = ACTIONS(3665),
    [anon_sym_globallycoherent] = ACTIONS(3665),
    [anon_sym_centroid] = ACTIONS(3665),
    [anon_sym_noperspective] = ACTIONS(3665),
    [anon_sym_nointerpolation] = ACTIONS(3665),
    [anon_sym_sample] = ACTIONS(3665),
    [anon_sym_linear] = ACTIONS(3665),
    [anon_sym_snorm] = ACTIONS(3665),
    [anon_sym_unorm] = ACTIONS(3665),
    [anon_sym_point] = ACTIONS(3665),
    [anon_sym_line] = ACTIONS(3665),
    [anon_sym_triangleadj] = ACTIONS(3665),
    [anon_sym_lineadj] = ACTIONS(3665),
    [anon_sym_triangle] = ACTIONS(3665),
    [anon_sym_cbuffer] = ACTIONS(3665),
    [anon_sym_interface] = ACTIONS(3665),
    [anon_sym_extension] = ACTIONS(3665),
  },
  [979] = {
    [sym_identifier] = ACTIONS(3677),
    [aux_sym_preproc_include_token1] = ACTIONS(3677),
    [aux_sym_preproc_def_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token2] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3677),
    [sym_preproc_directive] = ACTIONS(3677),
    [anon_sym_LPAREN2] = ACTIONS(3679),
    [anon_sym_BANG] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3677),
    [anon_sym_PLUS] = ACTIONS(3677),
    [anon_sym_STAR] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_AMP] = ACTIONS(3677),
    [anon_sym_SEMI] = ACTIONS(3679),
    [anon_sym___extension__] = ACTIONS(3677),
    [anon_sym_typedef] = ACTIONS(3677),
    [anon_sym_in] = ACTIONS(3677),
    [anon_sym_out] = ACTIONS(3677),
    [anon_sym_inout] = ACTIONS(3677),
    [anon_sym_extern] = ACTIONS(3677),
    [anon_sym___attribute__] = ACTIONS(3677),
    [anon_sym_COLON_COLON] = ACTIONS(3679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3679),
    [anon_sym___declspec] = ACTIONS(3677),
    [anon_sym___based] = ACTIONS(3677),
    [anon_sym___cdecl] = ACTIONS(3677),
    [anon_sym___clrcall] = ACTIONS(3677),
    [anon_sym___stdcall] = ACTIONS(3677),
    [anon_sym___fastcall] = ACTIONS(3677),
    [anon_sym___thiscall] = ACTIONS(3677),
    [anon_sym___vectorcall] = ACTIONS(3677),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_signed] = ACTIONS(3677),
    [anon_sym_unsigned] = ACTIONS(3677),
    [anon_sym_long] = ACTIONS(3677),
    [anon_sym_short] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3677),
    [anon_sym_static] = ACTIONS(3677),
    [anon_sym_register] = ACTIONS(3677),
    [anon_sym_inline] = ACTIONS(3677),
    [anon_sym___inline] = ACTIONS(3677),
    [anon_sym___inline__] = ACTIONS(3677),
    [anon_sym___forceinline] = ACTIONS(3677),
    [anon_sym_thread_local] = ACTIONS(3677),
    [anon_sym___thread] = ACTIONS(3677),
    [anon_sym_const] = ACTIONS(3677),
    [anon_sym_constexpr] = ACTIONS(3677),
    [anon_sym_volatile] = ACTIONS(3677),
    [anon_sym_restrict] = ACTIONS(3677),
    [anon_sym___restrict__] = ACTIONS(3677),
    [anon_sym__Atomic] = ACTIONS(3677),
    [anon_sym__Noreturn] = ACTIONS(3677),
    [anon_sym_noreturn] = ACTIONS(3677),
    [anon_sym_mutable] = ACTIONS(3677),
    [anon_sym_constinit] = ACTIONS(3677),
    [anon_sym_consteval] = ACTIONS(3677),
    [anon_sym_alignas] = ACTIONS(3677),
    [anon_sym__Alignas] = ACTIONS(3677),
    [sym_primitive_type] = ACTIONS(3677),
    [anon_sym_enum] = ACTIONS(3677),
    [anon_sym_class] = ACTIONS(3677),
    [anon_sym_struct] = ACTIONS(3677),
    [anon_sym_union] = ACTIONS(3677),
    [anon_sym_if] = ACTIONS(3677),
    [anon_sym_switch] = ACTIONS(3677),
    [anon_sym_case] = ACTIONS(3677),
    [anon_sym_default] = ACTIONS(3677),
    [anon_sym_while] = ACTIONS(3677),
    [anon_sym_do] = ACTIONS(3677),
    [anon_sym_for] = ACTIONS(3677),
    [anon_sym_return] = ACTIONS(3677),
    [anon_sym_break] = ACTIONS(3677),
    [anon_sym_continue] = ACTIONS(3677),
    [anon_sym_goto] = ACTIONS(3677),
    [anon_sym___try] = ACTIONS(3677),
    [anon_sym___leave] = ACTIONS(3677),
    [anon_sym_not] = ACTIONS(3677),
    [anon_sym_compl] = ACTIONS(3677),
    [anon_sym_DASH_DASH] = ACTIONS(3679),
    [anon_sym_PLUS_PLUS] = ACTIONS(3679),
    [anon_sym_sizeof] = ACTIONS(3677),
    [anon_sym___alignof__] = ACTIONS(3677),
    [anon_sym___alignof] = ACTIONS(3677),
    [anon_sym__alignof] = ACTIONS(3677),
    [anon_sym_alignof] = ACTIONS(3677),
    [anon_sym__Alignof] = ACTIONS(3677),
    [anon_sym_offsetof] = ACTIONS(3677),
    [anon_sym__Generic] = ACTIONS(3677),
    [anon_sym_asm] = ACTIONS(3677),
    [anon_sym___asm__] = ACTIONS(3677),
    [sym_number_literal] = ACTIONS(3679),
    [anon_sym_L_SQUOTE] = ACTIONS(3679),
    [anon_sym_u_SQUOTE] = ACTIONS(3679),
    [anon_sym_U_SQUOTE] = ACTIONS(3679),
    [anon_sym_u8_SQUOTE] = ACTIONS(3679),
    [anon_sym_SQUOTE] = ACTIONS(3679),
    [anon_sym_L_DQUOTE] = ACTIONS(3679),
    [anon_sym_u_DQUOTE] = ACTIONS(3679),
    [anon_sym_U_DQUOTE] = ACTIONS(3679),
    [anon_sym_u8_DQUOTE] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3679),
    [sym_true] = ACTIONS(3677),
    [sym_false] = ACTIONS(3677),
    [anon_sym_NULL] = ACTIONS(3677),
    [anon_sym_nullptr] = ACTIONS(3677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3677),
    [anon_sym_let] = ACTIONS(3677),
    [anon_sym_This] = ACTIONS(3677),
    [anon_sym_decltype] = ACTIONS(3677),
    [sym_virtual] = ACTIONS(3677),
    [anon_sym_explicit] = ACTIONS(3677),
    [anon_sym_typename] = ACTIONS(3677),
    [anon_sym_template] = ACTIONS(3677),
    [anon_sym_operator] = ACTIONS(3677),
    [anon_sym_try] = ACTIONS(3677),
    [anon_sym_delete] = ACTIONS(3677),
    [anon_sym_throw] = ACTIONS(3677),
    [anon_sym_namespace] = ACTIONS(3677),
    [anon_sym_using] = ACTIONS(3677),
    [anon_sym_static_assert] = ACTIONS(3677),
    [anon_sym_concept] = ACTIONS(3677),
    [anon_sym_co_return] = ACTIONS(3677),
    [anon_sym_co_yield] = ACTIONS(3677),
    [anon_sym_R_DQUOTE] = ACTIONS(3679),
    [anon_sym_LR_DQUOTE] = ACTIONS(3679),
    [anon_sym_uR_DQUOTE] = ACTIONS(3679),
    [anon_sym_UR_DQUOTE] = ACTIONS(3679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3679),
    [anon_sym_co_await] = ACTIONS(3677),
    [anon_sym_new] = ACTIONS(3677),
    [anon_sym_requires] = ACTIONS(3677),
    [sym_this] = ACTIONS(3677),
    [anon_sym_discard] = ACTIONS(3677),
    [anon_sym_precise] = ACTIONS(3677),
    [anon_sym_shared] = ACTIONS(3677),
    [anon_sym_groupshared] = ACTIONS(3677),
    [anon_sym_uniform] = ACTIONS(3677),
    [anon_sym_row_major] = ACTIONS(3677),
    [anon_sym_column_major] = ACTIONS(3677),
    [anon_sym_globallycoherent] = ACTIONS(3677),
    [anon_sym_centroid] = ACTIONS(3677),
    [anon_sym_noperspective] = ACTIONS(3677),
    [anon_sym_nointerpolation] = ACTIONS(3677),
    [anon_sym_sample] = ACTIONS(3677),
    [anon_sym_linear] = ACTIONS(3677),
    [anon_sym_snorm] = ACTIONS(3677),
    [anon_sym_unorm] = ACTIONS(3677),
    [anon_sym_point] = ACTIONS(3677),
    [anon_sym_line] = ACTIONS(3677),
    [anon_sym_triangleadj] = ACTIONS(3677),
    [anon_sym_lineadj] = ACTIONS(3677),
    [anon_sym_triangle] = ACTIONS(3677),
    [anon_sym_cbuffer] = ACTIONS(3677),
    [anon_sym_interface] = ACTIONS(3677),
    [anon_sym_extension] = ACTIONS(3677),
  },
  [980] = {
    [sym_identifier] = ACTIONS(3681),
    [aux_sym_preproc_include_token1] = ACTIONS(3681),
    [aux_sym_preproc_def_token1] = ACTIONS(3681),
    [aux_sym_preproc_if_token1] = ACTIONS(3681),
    [aux_sym_preproc_if_token2] = ACTIONS(3681),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3681),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3681),
    [sym_preproc_directive] = ACTIONS(3681),
    [anon_sym_LPAREN2] = ACTIONS(3683),
    [anon_sym_BANG] = ACTIONS(3683),
    [anon_sym_TILDE] = ACTIONS(3683),
    [anon_sym_DASH] = ACTIONS(3681),
    [anon_sym_PLUS] = ACTIONS(3681),
    [anon_sym_STAR] = ACTIONS(3683),
    [anon_sym_AMP_AMP] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3681),
    [anon_sym_SEMI] = ACTIONS(3683),
    [anon_sym___extension__] = ACTIONS(3681),
    [anon_sym_typedef] = ACTIONS(3681),
    [anon_sym_in] = ACTIONS(3681),
    [anon_sym_out] = ACTIONS(3681),
    [anon_sym_inout] = ACTIONS(3681),
    [anon_sym_extern] = ACTIONS(3681),
    [anon_sym___attribute__] = ACTIONS(3681),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3683),
    [anon_sym___declspec] = ACTIONS(3681),
    [anon_sym___based] = ACTIONS(3681),
    [anon_sym___cdecl] = ACTIONS(3681),
    [anon_sym___clrcall] = ACTIONS(3681),
    [anon_sym___stdcall] = ACTIONS(3681),
    [anon_sym___fastcall] = ACTIONS(3681),
    [anon_sym___thiscall] = ACTIONS(3681),
    [anon_sym___vectorcall] = ACTIONS(3681),
    [anon_sym_LBRACE] = ACTIONS(3683),
    [anon_sym_signed] = ACTIONS(3681),
    [anon_sym_unsigned] = ACTIONS(3681),
    [anon_sym_long] = ACTIONS(3681),
    [anon_sym_short] = ACTIONS(3681),
    [anon_sym_LBRACK] = ACTIONS(3681),
    [anon_sym_static] = ACTIONS(3681),
    [anon_sym_register] = ACTIONS(3681),
    [anon_sym_inline] = ACTIONS(3681),
    [anon_sym___inline] = ACTIONS(3681),
    [anon_sym___inline__] = ACTIONS(3681),
    [anon_sym___forceinline] = ACTIONS(3681),
    [anon_sym_thread_local] = ACTIONS(3681),
    [anon_sym___thread] = ACTIONS(3681),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_constexpr] = ACTIONS(3681),
    [anon_sym_volatile] = ACTIONS(3681),
    [anon_sym_restrict] = ACTIONS(3681),
    [anon_sym___restrict__] = ACTIONS(3681),
    [anon_sym__Atomic] = ACTIONS(3681),
    [anon_sym__Noreturn] = ACTIONS(3681),
    [anon_sym_noreturn] = ACTIONS(3681),
    [anon_sym_mutable] = ACTIONS(3681),
    [anon_sym_constinit] = ACTIONS(3681),
    [anon_sym_consteval] = ACTIONS(3681),
    [anon_sym_alignas] = ACTIONS(3681),
    [anon_sym__Alignas] = ACTIONS(3681),
    [sym_primitive_type] = ACTIONS(3681),
    [anon_sym_enum] = ACTIONS(3681),
    [anon_sym_class] = ACTIONS(3681),
    [anon_sym_struct] = ACTIONS(3681),
    [anon_sym_union] = ACTIONS(3681),
    [anon_sym_if] = ACTIONS(3681),
    [anon_sym_switch] = ACTIONS(3681),
    [anon_sym_case] = ACTIONS(3681),
    [anon_sym_default] = ACTIONS(3681),
    [anon_sym_while] = ACTIONS(3681),
    [anon_sym_do] = ACTIONS(3681),
    [anon_sym_for] = ACTIONS(3681),
    [anon_sym_return] = ACTIONS(3681),
    [anon_sym_break] = ACTIONS(3681),
    [anon_sym_continue] = ACTIONS(3681),
    [anon_sym_goto] = ACTIONS(3681),
    [anon_sym___try] = ACTIONS(3681),
    [anon_sym___leave] = ACTIONS(3681),
    [anon_sym_not] = ACTIONS(3681),
    [anon_sym_compl] = ACTIONS(3681),
    [anon_sym_DASH_DASH] = ACTIONS(3683),
    [anon_sym_PLUS_PLUS] = ACTIONS(3683),
    [anon_sym_sizeof] = ACTIONS(3681),
    [anon_sym___alignof__] = ACTIONS(3681),
    [anon_sym___alignof] = ACTIONS(3681),
    [anon_sym__alignof] = ACTIONS(3681),
    [anon_sym_alignof] = ACTIONS(3681),
    [anon_sym__Alignof] = ACTIONS(3681),
    [anon_sym_offsetof] = ACTIONS(3681),
    [anon_sym__Generic] = ACTIONS(3681),
    [anon_sym_asm] = ACTIONS(3681),
    [anon_sym___asm__] = ACTIONS(3681),
    [sym_number_literal] = ACTIONS(3683),
    [anon_sym_L_SQUOTE] = ACTIONS(3683),
    [anon_sym_u_SQUOTE] = ACTIONS(3683),
    [anon_sym_U_SQUOTE] = ACTIONS(3683),
    [anon_sym_u8_SQUOTE] = ACTIONS(3683),
    [anon_sym_SQUOTE] = ACTIONS(3683),
    [anon_sym_L_DQUOTE] = ACTIONS(3683),
    [anon_sym_u_DQUOTE] = ACTIONS(3683),
    [anon_sym_U_DQUOTE] = ACTIONS(3683),
    [anon_sym_u8_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE] = ACTIONS(3683),
    [sym_true] = ACTIONS(3681),
    [sym_false] = ACTIONS(3681),
    [anon_sym_NULL] = ACTIONS(3681),
    [anon_sym_nullptr] = ACTIONS(3681),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3681),
    [anon_sym_let] = ACTIONS(3681),
    [anon_sym_This] = ACTIONS(3681),
    [anon_sym_decltype] = ACTIONS(3681),
    [sym_virtual] = ACTIONS(3681),
    [anon_sym_explicit] = ACTIONS(3681),
    [anon_sym_typename] = ACTIONS(3681),
    [anon_sym_template] = ACTIONS(3681),
    [anon_sym_operator] = ACTIONS(3681),
    [anon_sym_try] = ACTIONS(3681),
    [anon_sym_delete] = ACTIONS(3681),
    [anon_sym_throw] = ACTIONS(3681),
    [anon_sym_namespace] = ACTIONS(3681),
    [anon_sym_using] = ACTIONS(3681),
    [anon_sym_static_assert] = ACTIONS(3681),
    [anon_sym_concept] = ACTIONS(3681),
    [anon_sym_co_return] = ACTIONS(3681),
    [anon_sym_co_yield] = ACTIONS(3681),
    [anon_sym_R_DQUOTE] = ACTIONS(3683),
    [anon_sym_LR_DQUOTE] = ACTIONS(3683),
    [anon_sym_uR_DQUOTE] = ACTIONS(3683),
    [anon_sym_UR_DQUOTE] = ACTIONS(3683),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3683),
    [anon_sym_co_await] = ACTIONS(3681),
    [anon_sym_new] = ACTIONS(3681),
    [anon_sym_requires] = ACTIONS(3681),
    [sym_this] = ACTIONS(3681),
    [anon_sym_discard] = ACTIONS(3681),
    [anon_sym_precise] = ACTIONS(3681),
    [anon_sym_shared] = ACTIONS(3681),
    [anon_sym_groupshared] = ACTIONS(3681),
    [anon_sym_uniform] = ACTIONS(3681),
    [anon_sym_row_major] = ACTIONS(3681),
    [anon_sym_column_major] = ACTIONS(3681),
    [anon_sym_globallycoherent] = ACTIONS(3681),
    [anon_sym_centroid] = ACTIONS(3681),
    [anon_sym_noperspective] = ACTIONS(3681),
    [anon_sym_nointerpolation] = ACTIONS(3681),
    [anon_sym_sample] = ACTIONS(3681),
    [anon_sym_linear] = ACTIONS(3681),
    [anon_sym_snorm] = ACTIONS(3681),
    [anon_sym_unorm] = ACTIONS(3681),
    [anon_sym_point] = ACTIONS(3681),
    [anon_sym_line] = ACTIONS(3681),
    [anon_sym_triangleadj] = ACTIONS(3681),
    [anon_sym_lineadj] = ACTIONS(3681),
    [anon_sym_triangle] = ACTIONS(3681),
    [anon_sym_cbuffer] = ACTIONS(3681),
    [anon_sym_interface] = ACTIONS(3681),
    [anon_sym_extension] = ACTIONS(3681),
  },
  [981] = {
    [sym_identifier] = ACTIONS(3531),
    [aux_sym_preproc_include_token1] = ACTIONS(3531),
    [aux_sym_preproc_def_token1] = ACTIONS(3531),
    [aux_sym_preproc_if_token1] = ACTIONS(3531),
    [aux_sym_preproc_if_token2] = ACTIONS(3531),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3531),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3531),
    [sym_preproc_directive] = ACTIONS(3531),
    [anon_sym_LPAREN2] = ACTIONS(3533),
    [anon_sym_BANG] = ACTIONS(3533),
    [anon_sym_TILDE] = ACTIONS(3533),
    [anon_sym_DASH] = ACTIONS(3531),
    [anon_sym_PLUS] = ACTIONS(3531),
    [anon_sym_STAR] = ACTIONS(3533),
    [anon_sym_AMP_AMP] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_SEMI] = ACTIONS(3533),
    [anon_sym___extension__] = ACTIONS(3531),
    [anon_sym_typedef] = ACTIONS(3531),
    [anon_sym_in] = ACTIONS(3531),
    [anon_sym_out] = ACTIONS(3531),
    [anon_sym_inout] = ACTIONS(3531),
    [anon_sym_extern] = ACTIONS(3531),
    [anon_sym___attribute__] = ACTIONS(3531),
    [anon_sym_COLON_COLON] = ACTIONS(3533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3533),
    [anon_sym___declspec] = ACTIONS(3531),
    [anon_sym___based] = ACTIONS(3531),
    [anon_sym___cdecl] = ACTIONS(3531),
    [anon_sym___clrcall] = ACTIONS(3531),
    [anon_sym___stdcall] = ACTIONS(3531),
    [anon_sym___fastcall] = ACTIONS(3531),
    [anon_sym___thiscall] = ACTIONS(3531),
    [anon_sym___vectorcall] = ACTIONS(3531),
    [anon_sym_LBRACE] = ACTIONS(3533),
    [anon_sym_signed] = ACTIONS(3531),
    [anon_sym_unsigned] = ACTIONS(3531),
    [anon_sym_long] = ACTIONS(3531),
    [anon_sym_short] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_static] = ACTIONS(3531),
    [anon_sym_register] = ACTIONS(3531),
    [anon_sym_inline] = ACTIONS(3531),
    [anon_sym___inline] = ACTIONS(3531),
    [anon_sym___inline__] = ACTIONS(3531),
    [anon_sym___forceinline] = ACTIONS(3531),
    [anon_sym_thread_local] = ACTIONS(3531),
    [anon_sym___thread] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3531),
    [anon_sym_constexpr] = ACTIONS(3531),
    [anon_sym_volatile] = ACTIONS(3531),
    [anon_sym_restrict] = ACTIONS(3531),
    [anon_sym___restrict__] = ACTIONS(3531),
    [anon_sym__Atomic] = ACTIONS(3531),
    [anon_sym__Noreturn] = ACTIONS(3531),
    [anon_sym_noreturn] = ACTIONS(3531),
    [anon_sym_mutable] = ACTIONS(3531),
    [anon_sym_constinit] = ACTIONS(3531),
    [anon_sym_consteval] = ACTIONS(3531),
    [anon_sym_alignas] = ACTIONS(3531),
    [anon_sym__Alignas] = ACTIONS(3531),
    [sym_primitive_type] = ACTIONS(3531),
    [anon_sym_enum] = ACTIONS(3531),
    [anon_sym_class] = ACTIONS(3531),
    [anon_sym_struct] = ACTIONS(3531),
    [anon_sym_union] = ACTIONS(3531),
    [anon_sym_if] = ACTIONS(3531),
    [anon_sym_switch] = ACTIONS(3531),
    [anon_sym_case] = ACTIONS(3531),
    [anon_sym_default] = ACTIONS(3531),
    [anon_sym_while] = ACTIONS(3531),
    [anon_sym_do] = ACTIONS(3531),
    [anon_sym_for] = ACTIONS(3531),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_break] = ACTIONS(3531),
    [anon_sym_continue] = ACTIONS(3531),
    [anon_sym_goto] = ACTIONS(3531),
    [anon_sym___try] = ACTIONS(3531),
    [anon_sym___leave] = ACTIONS(3531),
    [anon_sym_not] = ACTIONS(3531),
    [anon_sym_compl] = ACTIONS(3531),
    [anon_sym_DASH_DASH] = ACTIONS(3533),
    [anon_sym_PLUS_PLUS] = ACTIONS(3533),
    [anon_sym_sizeof] = ACTIONS(3531),
    [anon_sym___alignof__] = ACTIONS(3531),
    [anon_sym___alignof] = ACTIONS(3531),
    [anon_sym__alignof] = ACTIONS(3531),
    [anon_sym_alignof] = ACTIONS(3531),
    [anon_sym__Alignof] = ACTIONS(3531),
    [anon_sym_offsetof] = ACTIONS(3531),
    [anon_sym__Generic] = ACTIONS(3531),
    [anon_sym_asm] = ACTIONS(3531),
    [anon_sym___asm__] = ACTIONS(3531),
    [sym_number_literal] = ACTIONS(3533),
    [anon_sym_L_SQUOTE] = ACTIONS(3533),
    [anon_sym_u_SQUOTE] = ACTIONS(3533),
    [anon_sym_U_SQUOTE] = ACTIONS(3533),
    [anon_sym_u8_SQUOTE] = ACTIONS(3533),
    [anon_sym_SQUOTE] = ACTIONS(3533),
    [anon_sym_L_DQUOTE] = ACTIONS(3533),
    [anon_sym_u_DQUOTE] = ACTIONS(3533),
    [anon_sym_U_DQUOTE] = ACTIONS(3533),
    [anon_sym_u8_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE] = ACTIONS(3533),
    [sym_true] = ACTIONS(3531),
    [sym_false] = ACTIONS(3531),
    [anon_sym_NULL] = ACTIONS(3531),
    [anon_sym_nullptr] = ACTIONS(3531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_This] = ACTIONS(3531),
    [anon_sym_decltype] = ACTIONS(3531),
    [sym_virtual] = ACTIONS(3531),
    [anon_sym_explicit] = ACTIONS(3531),
    [anon_sym_typename] = ACTIONS(3531),
    [anon_sym_template] = ACTIONS(3531),
    [anon_sym_operator] = ACTIONS(3531),
    [anon_sym_try] = ACTIONS(3531),
    [anon_sym_delete] = ACTIONS(3531),
    [anon_sym_throw] = ACTIONS(3531),
    [anon_sym_namespace] = ACTIONS(3531),
    [anon_sym_using] = ACTIONS(3531),
    [anon_sym_static_assert] = ACTIONS(3531),
    [anon_sym_concept] = ACTIONS(3531),
    [anon_sym_co_return] = ACTIONS(3531),
    [anon_sym_co_yield] = ACTIONS(3531),
    [anon_sym_R_DQUOTE] = ACTIONS(3533),
    [anon_sym_LR_DQUOTE] = ACTIONS(3533),
    [anon_sym_uR_DQUOTE] = ACTIONS(3533),
    [anon_sym_UR_DQUOTE] = ACTIONS(3533),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3533),
    [anon_sym_co_await] = ACTIONS(3531),
    [anon_sym_new] = ACTIONS(3531),
    [anon_sym_requires] = ACTIONS(3531),
    [sym_this] = ACTIONS(3531),
    [anon_sym_discard] = ACTIONS(3531),
    [anon_sym_precise] = ACTIONS(3531),
    [anon_sym_shared] = ACTIONS(3531),
    [anon_sym_groupshared] = ACTIONS(3531),
    [anon_sym_uniform] = ACTIONS(3531),
    [anon_sym_row_major] = ACTIONS(3531),
    [anon_sym_column_major] = ACTIONS(3531),
    [anon_sym_globallycoherent] = ACTIONS(3531),
    [anon_sym_centroid] = ACTIONS(3531),
    [anon_sym_noperspective] = ACTIONS(3531),
    [anon_sym_nointerpolation] = ACTIONS(3531),
    [anon_sym_sample] = ACTIONS(3531),
    [anon_sym_linear] = ACTIONS(3531),
    [anon_sym_snorm] = ACTIONS(3531),
    [anon_sym_unorm] = ACTIONS(3531),
    [anon_sym_point] = ACTIONS(3531),
    [anon_sym_line] = ACTIONS(3531),
    [anon_sym_triangleadj] = ACTIONS(3531),
    [anon_sym_lineadj] = ACTIONS(3531),
    [anon_sym_triangle] = ACTIONS(3531),
    [anon_sym_cbuffer] = ACTIONS(3531),
    [anon_sym_interface] = ACTIONS(3531),
    [anon_sym_extension] = ACTIONS(3531),
  },
  [982] = {
    [sym_attribute_specifier] = STATE(349),
    [ts_builtin_sym_end] = ACTIONS(3733),
    [sym_identifier] = ACTIONS(3731),
    [aux_sym_preproc_include_token1] = ACTIONS(3731),
    [aux_sym_preproc_def_token1] = ACTIONS(3731),
    [aux_sym_preproc_if_token1] = ACTIONS(3731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3731),
    [sym_preproc_directive] = ACTIONS(3731),
    [anon_sym_LPAREN2] = ACTIONS(3733),
    [anon_sym_BANG] = ACTIONS(3733),
    [anon_sym_TILDE] = ACTIONS(3733),
    [anon_sym_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3731),
    [anon_sym_STAR] = ACTIONS(3733),
    [anon_sym_AMP_AMP] = ACTIONS(3733),
    [anon_sym_AMP] = ACTIONS(3731),
    [anon_sym_SEMI] = ACTIONS(3733),
    [anon_sym___extension__] = ACTIONS(3731),
    [anon_sym_typedef] = ACTIONS(3731),
    [anon_sym_in] = ACTIONS(3731),
    [anon_sym_out] = ACTIONS(3731),
    [anon_sym_inout] = ACTIONS(3731),
    [anon_sym_extern] = ACTIONS(3731),
    [anon_sym___attribute__] = ACTIONS(2861),
    [anon_sym_COLON_COLON] = ACTIONS(3733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3733),
    [anon_sym___declspec] = ACTIONS(3731),
    [anon_sym___based] = ACTIONS(3731),
    [anon_sym___cdecl] = ACTIONS(3731),
    [anon_sym___clrcall] = ACTIONS(3731),
    [anon_sym___stdcall] = ACTIONS(3731),
    [anon_sym___fastcall] = ACTIONS(3731),
    [anon_sym___thiscall] = ACTIONS(3731),
    [anon_sym___vectorcall] = ACTIONS(3731),
    [anon_sym_LBRACE] = ACTIONS(3733),
    [anon_sym_signed] = ACTIONS(3731),
    [anon_sym_unsigned] = ACTIONS(3731),
    [anon_sym_long] = ACTIONS(3731),
    [anon_sym_short] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3731),
    [anon_sym_static] = ACTIONS(3731),
    [anon_sym_register] = ACTIONS(3731),
    [anon_sym_inline] = ACTIONS(3731),
    [anon_sym___inline] = ACTIONS(3731),
    [anon_sym___inline__] = ACTIONS(3731),
    [anon_sym___forceinline] = ACTIONS(3731),
    [anon_sym_thread_local] = ACTIONS(3731),
    [anon_sym___thread] = ACTIONS(3731),
    [anon_sym_const] = ACTIONS(3731),
    [anon_sym_constexpr] = ACTIONS(3731),
    [anon_sym_volatile] = ACTIONS(3731),
    [anon_sym_restrict] = ACTIONS(3731),
    [anon_sym___restrict__] = ACTIONS(3731),
    [anon_sym__Atomic] = ACTIONS(3731),
    [anon_sym__Noreturn] = ACTIONS(3731),
    [anon_sym_noreturn] = ACTIONS(3731),
    [anon_sym_mutable] = ACTIONS(3731),
    [anon_sym_constinit] = ACTIONS(3731),
    [anon_sym_consteval] = ACTIONS(3731),
    [anon_sym_alignas] = ACTIONS(3731),
    [anon_sym__Alignas] = ACTIONS(3731),
    [sym_primitive_type] = ACTIONS(3731),
    [anon_sym_enum] = ACTIONS(3731),
    [anon_sym_class] = ACTIONS(3731),
    [anon_sym_struct] = ACTIONS(3731),
    [anon_sym_union] = ACTIONS(3731),
    [anon_sym_if] = ACTIONS(3731),
    [anon_sym_switch] = ACTIONS(3731),
    [anon_sym_case] = ACTIONS(3731),
    [anon_sym_default] = ACTIONS(3731),
    [anon_sym_while] = ACTIONS(3731),
    [anon_sym_do] = ACTIONS(3731),
    [anon_sym_for] = ACTIONS(3731),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_break] = ACTIONS(3731),
    [anon_sym_continue] = ACTIONS(3731),
    [anon_sym_goto] = ACTIONS(3731),
    [anon_sym_not] = ACTIONS(3731),
    [anon_sym_compl] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3733),
    [anon_sym_PLUS_PLUS] = ACTIONS(3733),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3731),
    [anon_sym___alignof] = ACTIONS(3731),
    [anon_sym__alignof] = ACTIONS(3731),
    [anon_sym_alignof] = ACTIONS(3731),
    [anon_sym__Alignof] = ACTIONS(3731),
    [anon_sym_offsetof] = ACTIONS(3731),
    [anon_sym__Generic] = ACTIONS(3731),
    [anon_sym_asm] = ACTIONS(3731),
    [anon_sym___asm__] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3731),
    [sym_number_literal] = ACTIONS(3733),
    [anon_sym_L_SQUOTE] = ACTIONS(3733),
    [anon_sym_u_SQUOTE] = ACTIONS(3733),
    [anon_sym_U_SQUOTE] = ACTIONS(3733),
    [anon_sym_u8_SQUOTE] = ACTIONS(3733),
    [anon_sym_SQUOTE] = ACTIONS(3733),
    [anon_sym_L_DQUOTE] = ACTIONS(3733),
    [anon_sym_u_DQUOTE] = ACTIONS(3733),
    [anon_sym_U_DQUOTE] = ACTIONS(3733),
    [anon_sym_u8_DQUOTE] = ACTIONS(3733),
    [anon_sym_DQUOTE] = ACTIONS(3733),
    [sym_true] = ACTIONS(3731),
    [sym_false] = ACTIONS(3731),
    [anon_sym_NULL] = ACTIONS(3731),
    [anon_sym_nullptr] = ACTIONS(3731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3731),
    [anon_sym_let] = ACTIONS(3731),
    [anon_sym_This] = ACTIONS(3731),
    [anon_sym_decltype] = ACTIONS(3731),
    [sym_virtual] = ACTIONS(3731),
    [anon_sym_explicit] = ACTIONS(3731),
    [anon_sym_typename] = ACTIONS(3731),
    [anon_sym_template] = ACTIONS(3731),
    [anon_sym_operator] = ACTIONS(3731),
    [anon_sym_try] = ACTIONS(3731),
    [anon_sym_delete] = ACTIONS(3731),
    [anon_sym_throw] = ACTIONS(3731),
    [anon_sym_namespace] = ACTIONS(3731),
    [anon_sym_using] = ACTIONS(3731),
    [anon_sym_static_assert] = ACTIONS(3731),
    [anon_sym_concept] = ACTIONS(3731),
    [anon_sym_co_return] = ACTIONS(3731),
    [anon_sym_co_yield] = ACTIONS(3731),
    [anon_sym_R_DQUOTE] = ACTIONS(3733),
    [anon_sym_LR_DQUOTE] = ACTIONS(3733),
    [anon_sym_uR_DQUOTE] = ACTIONS(3733),
    [anon_sym_UR_DQUOTE] = ACTIONS(3733),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3733),
    [anon_sym_co_await] = ACTIONS(3731),
    [anon_sym_new] = ACTIONS(3731),
    [anon_sym_requires] = ACTIONS(3731),
    [sym_this] = ACTIONS(3731),
    [anon_sym_precise] = ACTIONS(3731),
    [anon_sym_shared] = ACTIONS(3731),
    [anon_sym_groupshared] = ACTIONS(3731),
    [anon_sym_uniform] = ACTIONS(3731),
    [anon_sym_row_major] = ACTIONS(3731),
    [anon_sym_column_major] = ACTIONS(3731),
    [anon_sym_globallycoherent] = ACTIONS(3731),
    [anon_sym_centroid] = ACTIONS(3731),
    [anon_sym_noperspective] = ACTIONS(3731),
    [anon_sym_nointerpolation] = ACTIONS(3731),
    [anon_sym_sample] = ACTIONS(3731),
    [anon_sym_linear] = ACTIONS(3731),
    [anon_sym_snorm] = ACTIONS(3731),
    [anon_sym_unorm] = ACTIONS(3731),
    [anon_sym_point] = ACTIONS(3731),
    [anon_sym_line] = ACTIONS(3731),
    [anon_sym_triangleadj] = ACTIONS(3731),
    [anon_sym_lineadj] = ACTIONS(3731),
    [anon_sym_triangle] = ACTIONS(3731),
    [anon_sym_interface] = ACTIONS(3731),
    [anon_sym_extension] = ACTIONS(3731),
    [anon_sym___exported] = ACTIONS(3731),
    [anon_sym_import] = ACTIONS(3731),
  },
  [983] = {
    [sym_identifier] = ACTIONS(3597),
    [aux_sym_preproc_include_token1] = ACTIONS(3597),
    [aux_sym_preproc_def_token1] = ACTIONS(3597),
    [aux_sym_preproc_if_token1] = ACTIONS(3597),
    [aux_sym_preproc_if_token2] = ACTIONS(3597),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3597),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3597),
    [sym_preproc_directive] = ACTIONS(3597),
    [anon_sym_LPAREN2] = ACTIONS(3599),
    [anon_sym_BANG] = ACTIONS(3599),
    [anon_sym_TILDE] = ACTIONS(3599),
    [anon_sym_DASH] = ACTIONS(3597),
    [anon_sym_PLUS] = ACTIONS(3597),
    [anon_sym_STAR] = ACTIONS(3599),
    [anon_sym_AMP_AMP] = ACTIONS(3599),
    [anon_sym_AMP] = ACTIONS(3597),
    [anon_sym_SEMI] = ACTIONS(3599),
    [anon_sym___extension__] = ACTIONS(3597),
    [anon_sym_typedef] = ACTIONS(3597),
    [anon_sym_in] = ACTIONS(3597),
    [anon_sym_out] = ACTIONS(3597),
    [anon_sym_inout] = ACTIONS(3597),
    [anon_sym_extern] = ACTIONS(3597),
    [anon_sym___attribute__] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3599),
    [anon_sym___declspec] = ACTIONS(3597),
    [anon_sym___based] = ACTIONS(3597),
    [anon_sym___cdecl] = ACTIONS(3597),
    [anon_sym___clrcall] = ACTIONS(3597),
    [anon_sym___stdcall] = ACTIONS(3597),
    [anon_sym___fastcall] = ACTIONS(3597),
    [anon_sym___thiscall] = ACTIONS(3597),
    [anon_sym___vectorcall] = ACTIONS(3597),
    [anon_sym_LBRACE] = ACTIONS(3599),
    [anon_sym_signed] = ACTIONS(3597),
    [anon_sym_unsigned] = ACTIONS(3597),
    [anon_sym_long] = ACTIONS(3597),
    [anon_sym_short] = ACTIONS(3597),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_static] = ACTIONS(3597),
    [anon_sym_register] = ACTIONS(3597),
    [anon_sym_inline] = ACTIONS(3597),
    [anon_sym___inline] = ACTIONS(3597),
    [anon_sym___inline__] = ACTIONS(3597),
    [anon_sym___forceinline] = ACTIONS(3597),
    [anon_sym_thread_local] = ACTIONS(3597),
    [anon_sym___thread] = ACTIONS(3597),
    [anon_sym_const] = ACTIONS(3597),
    [anon_sym_constexpr] = ACTIONS(3597),
    [anon_sym_volatile] = ACTIONS(3597),
    [anon_sym_restrict] = ACTIONS(3597),
    [anon_sym___restrict__] = ACTIONS(3597),
    [anon_sym__Atomic] = ACTIONS(3597),
    [anon_sym__Noreturn] = ACTIONS(3597),
    [anon_sym_noreturn] = ACTIONS(3597),
    [anon_sym_mutable] = ACTIONS(3597),
    [anon_sym_constinit] = ACTIONS(3597),
    [anon_sym_consteval] = ACTIONS(3597),
    [anon_sym_alignas] = ACTIONS(3597),
    [anon_sym__Alignas] = ACTIONS(3597),
    [sym_primitive_type] = ACTIONS(3597),
    [anon_sym_enum] = ACTIONS(3597),
    [anon_sym_class] = ACTIONS(3597),
    [anon_sym_struct] = ACTIONS(3597),
    [anon_sym_union] = ACTIONS(3597),
    [anon_sym_if] = ACTIONS(3597),
    [anon_sym_switch] = ACTIONS(3597),
    [anon_sym_case] = ACTIONS(3597),
    [anon_sym_default] = ACTIONS(3597),
    [anon_sym_while] = ACTIONS(3597),
    [anon_sym_do] = ACTIONS(3597),
    [anon_sym_for] = ACTIONS(3597),
    [anon_sym_return] = ACTIONS(3597),
    [anon_sym_break] = ACTIONS(3597),
    [anon_sym_continue] = ACTIONS(3597),
    [anon_sym_goto] = ACTIONS(3597),
    [anon_sym___try] = ACTIONS(3597),
    [anon_sym___leave] = ACTIONS(3597),
    [anon_sym_not] = ACTIONS(3597),
    [anon_sym_compl] = ACTIONS(3597),
    [anon_sym_DASH_DASH] = ACTIONS(3599),
    [anon_sym_PLUS_PLUS] = ACTIONS(3599),
    [anon_sym_sizeof] = ACTIONS(3597),
    [anon_sym___alignof__] = ACTIONS(3597),
    [anon_sym___alignof] = ACTIONS(3597),
    [anon_sym__alignof] = ACTIONS(3597),
    [anon_sym_alignof] = ACTIONS(3597),
    [anon_sym__Alignof] = ACTIONS(3597),
    [anon_sym_offsetof] = ACTIONS(3597),
    [anon_sym__Generic] = ACTIONS(3597),
    [anon_sym_asm] = ACTIONS(3597),
    [anon_sym___asm__] = ACTIONS(3597),
    [sym_number_literal] = ACTIONS(3599),
    [anon_sym_L_SQUOTE] = ACTIONS(3599),
    [anon_sym_u_SQUOTE] = ACTIONS(3599),
    [anon_sym_U_SQUOTE] = ACTIONS(3599),
    [anon_sym_u8_SQUOTE] = ACTIONS(3599),
    [anon_sym_SQUOTE] = ACTIONS(3599),
    [anon_sym_L_DQUOTE] = ACTIONS(3599),
    [anon_sym_u_DQUOTE] = ACTIONS(3599),
    [anon_sym_U_DQUOTE] = ACTIONS(3599),
    [anon_sym_u8_DQUOTE] = ACTIONS(3599),
    [anon_sym_DQUOTE] = ACTIONS(3599),
    [sym_true] = ACTIONS(3597),
    [sym_false] = ACTIONS(3597),
    [anon_sym_NULL] = ACTIONS(3597),
    [anon_sym_nullptr] = ACTIONS(3597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3597),
    [anon_sym_let] = ACTIONS(3597),
    [anon_sym_This] = ACTIONS(3597),
    [anon_sym_decltype] = ACTIONS(3597),
    [sym_virtual] = ACTIONS(3597),
    [anon_sym_explicit] = ACTIONS(3597),
    [anon_sym_typename] = ACTIONS(3597),
    [anon_sym_template] = ACTIONS(3597),
    [anon_sym_operator] = ACTIONS(3597),
    [anon_sym_try] = ACTIONS(3597),
    [anon_sym_delete] = ACTIONS(3597),
    [anon_sym_throw] = ACTIONS(3597),
    [anon_sym_namespace] = ACTIONS(3597),
    [anon_sym_using] = ACTIONS(3597),
    [anon_sym_static_assert] = ACTIONS(3597),
    [anon_sym_concept] = ACTIONS(3597),
    [anon_sym_co_return] = ACTIONS(3597),
    [anon_sym_co_yield] = ACTIONS(3597),
    [anon_sym_R_DQUOTE] = ACTIONS(3599),
    [anon_sym_LR_DQUOTE] = ACTIONS(3599),
    [anon_sym_uR_DQUOTE] = ACTIONS(3599),
    [anon_sym_UR_DQUOTE] = ACTIONS(3599),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3599),
    [anon_sym_co_await] = ACTIONS(3597),
    [anon_sym_new] = ACTIONS(3597),
    [anon_sym_requires] = ACTIONS(3597),
    [sym_this] = ACTIONS(3597),
    [anon_sym_discard] = ACTIONS(3597),
    [anon_sym_precise] = ACTIONS(3597),
    [anon_sym_shared] = ACTIONS(3597),
    [anon_sym_groupshared] = ACTIONS(3597),
    [anon_sym_uniform] = ACTIONS(3597),
    [anon_sym_row_major] = ACTIONS(3597),
    [anon_sym_column_major] = ACTIONS(3597),
    [anon_sym_globallycoherent] = ACTIONS(3597),
    [anon_sym_centroid] = ACTIONS(3597),
    [anon_sym_noperspective] = ACTIONS(3597),
    [anon_sym_nointerpolation] = ACTIONS(3597),
    [anon_sym_sample] = ACTIONS(3597),
    [anon_sym_linear] = ACTIONS(3597),
    [anon_sym_snorm] = ACTIONS(3597),
    [anon_sym_unorm] = ACTIONS(3597),
    [anon_sym_point] = ACTIONS(3597),
    [anon_sym_line] = ACTIONS(3597),
    [anon_sym_triangleadj] = ACTIONS(3597),
    [anon_sym_lineadj] = ACTIONS(3597),
    [anon_sym_triangle] = ACTIONS(3597),
    [anon_sym_cbuffer] = ACTIONS(3597),
    [anon_sym_interface] = ACTIONS(3597),
    [anon_sym_extension] = ACTIONS(3597),
  },
  [984] = {
    [sym_identifier] = ACTIONS(3625),
    [aux_sym_preproc_include_token1] = ACTIONS(3625),
    [aux_sym_preproc_def_token1] = ACTIONS(3625),
    [aux_sym_preproc_if_token1] = ACTIONS(3625),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3625),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3625),
    [sym_preproc_directive] = ACTIONS(3625),
    [anon_sym_LPAREN2] = ACTIONS(3627),
    [anon_sym_BANG] = ACTIONS(3627),
    [anon_sym_TILDE] = ACTIONS(3627),
    [anon_sym_DASH] = ACTIONS(3625),
    [anon_sym_PLUS] = ACTIONS(3625),
    [anon_sym_STAR] = ACTIONS(3627),
    [anon_sym_AMP_AMP] = ACTIONS(3627),
    [anon_sym_AMP] = ACTIONS(3625),
    [anon_sym_SEMI] = ACTIONS(3627),
    [anon_sym___extension__] = ACTIONS(3625),
    [anon_sym_typedef] = ACTIONS(3625),
    [anon_sym_in] = ACTIONS(3625),
    [anon_sym_out] = ACTIONS(3625),
    [anon_sym_inout] = ACTIONS(3625),
    [anon_sym_extern] = ACTIONS(3625),
    [anon_sym___attribute__] = ACTIONS(3625),
    [anon_sym_COLON_COLON] = ACTIONS(3627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3627),
    [anon_sym___declspec] = ACTIONS(3625),
    [anon_sym___based] = ACTIONS(3625),
    [anon_sym___cdecl] = ACTIONS(3625),
    [anon_sym___clrcall] = ACTIONS(3625),
    [anon_sym___stdcall] = ACTIONS(3625),
    [anon_sym___fastcall] = ACTIONS(3625),
    [anon_sym___thiscall] = ACTIONS(3625),
    [anon_sym___vectorcall] = ACTIONS(3625),
    [anon_sym_LBRACE] = ACTIONS(3627),
    [anon_sym_RBRACE] = ACTIONS(3627),
    [anon_sym_signed] = ACTIONS(3625),
    [anon_sym_unsigned] = ACTIONS(3625),
    [anon_sym_long] = ACTIONS(3625),
    [anon_sym_short] = ACTIONS(3625),
    [anon_sym_LBRACK] = ACTIONS(3625),
    [anon_sym_static] = ACTIONS(3625),
    [anon_sym_register] = ACTIONS(3625),
    [anon_sym_inline] = ACTIONS(3625),
    [anon_sym___inline] = ACTIONS(3625),
    [anon_sym___inline__] = ACTIONS(3625),
    [anon_sym___forceinline] = ACTIONS(3625),
    [anon_sym_thread_local] = ACTIONS(3625),
    [anon_sym___thread] = ACTIONS(3625),
    [anon_sym_const] = ACTIONS(3625),
    [anon_sym_constexpr] = ACTIONS(3625),
    [anon_sym_volatile] = ACTIONS(3625),
    [anon_sym_restrict] = ACTIONS(3625),
    [anon_sym___restrict__] = ACTIONS(3625),
    [anon_sym__Atomic] = ACTIONS(3625),
    [anon_sym__Noreturn] = ACTIONS(3625),
    [anon_sym_noreturn] = ACTIONS(3625),
    [anon_sym_mutable] = ACTIONS(3625),
    [anon_sym_constinit] = ACTIONS(3625),
    [anon_sym_consteval] = ACTIONS(3625),
    [anon_sym_alignas] = ACTIONS(3625),
    [anon_sym__Alignas] = ACTIONS(3625),
    [sym_primitive_type] = ACTIONS(3625),
    [anon_sym_enum] = ACTIONS(3625),
    [anon_sym_class] = ACTIONS(3625),
    [anon_sym_struct] = ACTIONS(3625),
    [anon_sym_union] = ACTIONS(3625),
    [anon_sym_if] = ACTIONS(3625),
    [anon_sym_switch] = ACTIONS(3625),
    [anon_sym_case] = ACTIONS(3625),
    [anon_sym_default] = ACTIONS(3625),
    [anon_sym_while] = ACTIONS(3625),
    [anon_sym_do] = ACTIONS(3625),
    [anon_sym_for] = ACTIONS(3625),
    [anon_sym_return] = ACTIONS(3625),
    [anon_sym_break] = ACTIONS(3625),
    [anon_sym_continue] = ACTIONS(3625),
    [anon_sym_goto] = ACTIONS(3625),
    [anon_sym___try] = ACTIONS(3625),
    [anon_sym___leave] = ACTIONS(3625),
    [anon_sym_not] = ACTIONS(3625),
    [anon_sym_compl] = ACTIONS(3625),
    [anon_sym_DASH_DASH] = ACTIONS(3627),
    [anon_sym_PLUS_PLUS] = ACTIONS(3627),
    [anon_sym_sizeof] = ACTIONS(3625),
    [anon_sym___alignof__] = ACTIONS(3625),
    [anon_sym___alignof] = ACTIONS(3625),
    [anon_sym__alignof] = ACTIONS(3625),
    [anon_sym_alignof] = ACTIONS(3625),
    [anon_sym__Alignof] = ACTIONS(3625),
    [anon_sym_offsetof] = ACTIONS(3625),
    [anon_sym__Generic] = ACTIONS(3625),
    [anon_sym_asm] = ACTIONS(3625),
    [anon_sym___asm__] = ACTIONS(3625),
    [sym_number_literal] = ACTIONS(3627),
    [anon_sym_L_SQUOTE] = ACTIONS(3627),
    [anon_sym_u_SQUOTE] = ACTIONS(3627),
    [anon_sym_U_SQUOTE] = ACTIONS(3627),
    [anon_sym_u8_SQUOTE] = ACTIONS(3627),
    [anon_sym_SQUOTE] = ACTIONS(3627),
    [anon_sym_L_DQUOTE] = ACTIONS(3627),
    [anon_sym_u_DQUOTE] = ACTIONS(3627),
    [anon_sym_U_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8_DQUOTE] = ACTIONS(3627),
    [anon_sym_DQUOTE] = ACTIONS(3627),
    [sym_true] = ACTIONS(3625),
    [sym_false] = ACTIONS(3625),
    [anon_sym_NULL] = ACTIONS(3625),
    [anon_sym_nullptr] = ACTIONS(3625),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3625),
    [anon_sym_let] = ACTIONS(3625),
    [anon_sym_This] = ACTIONS(3625),
    [anon_sym_decltype] = ACTIONS(3625),
    [sym_virtual] = ACTIONS(3625),
    [anon_sym_explicit] = ACTIONS(3625),
    [anon_sym_typename] = ACTIONS(3625),
    [anon_sym_template] = ACTIONS(3625),
    [anon_sym_operator] = ACTIONS(3625),
    [anon_sym_try] = ACTIONS(3625),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_throw] = ACTIONS(3625),
    [anon_sym_namespace] = ACTIONS(3625),
    [anon_sym_using] = ACTIONS(3625),
    [anon_sym_static_assert] = ACTIONS(3625),
    [anon_sym_concept] = ACTIONS(3625),
    [anon_sym_co_return] = ACTIONS(3625),
    [anon_sym_co_yield] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3625),
    [anon_sym_new] = ACTIONS(3625),
    [anon_sym_requires] = ACTIONS(3625),
    [sym_this] = ACTIONS(3625),
    [anon_sym_discard] = ACTIONS(3625),
    [anon_sym_precise] = ACTIONS(3625),
    [anon_sym_shared] = ACTIONS(3625),
    [anon_sym_groupshared] = ACTIONS(3625),
    [anon_sym_uniform] = ACTIONS(3625),
    [anon_sym_row_major] = ACTIONS(3625),
    [anon_sym_column_major] = ACTIONS(3625),
    [anon_sym_globallycoherent] = ACTIONS(3625),
    [anon_sym_centroid] = ACTIONS(3625),
    [anon_sym_noperspective] = ACTIONS(3625),
    [anon_sym_nointerpolation] = ACTIONS(3625),
    [anon_sym_sample] = ACTIONS(3625),
    [anon_sym_linear] = ACTIONS(3625),
    [anon_sym_snorm] = ACTIONS(3625),
    [anon_sym_unorm] = ACTIONS(3625),
    [anon_sym_point] = ACTIONS(3625),
    [anon_sym_line] = ACTIONS(3625),
    [anon_sym_triangleadj] = ACTIONS(3625),
    [anon_sym_lineadj] = ACTIONS(3625),
    [anon_sym_triangle] = ACTIONS(3625),
    [anon_sym_cbuffer] = ACTIONS(3625),
    [anon_sym_interface] = ACTIONS(3625),
    [anon_sym_extension] = ACTIONS(3625),
  },
  [985] = {
    [sym_identifier] = ACTIONS(3685),
    [aux_sym_preproc_include_token1] = ACTIONS(3685),
    [aux_sym_preproc_def_token1] = ACTIONS(3685),
    [aux_sym_preproc_if_token1] = ACTIONS(3685),
    [aux_sym_preproc_if_token2] = ACTIONS(3685),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3685),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3685),
    [sym_preproc_directive] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3687),
    [anon_sym_BANG] = ACTIONS(3687),
    [anon_sym_TILDE] = ACTIONS(3687),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_STAR] = ACTIONS(3687),
    [anon_sym_AMP_AMP] = ACTIONS(3687),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_SEMI] = ACTIONS(3687),
    [anon_sym___extension__] = ACTIONS(3685),
    [anon_sym_typedef] = ACTIONS(3685),
    [anon_sym_in] = ACTIONS(3685),
    [anon_sym_out] = ACTIONS(3685),
    [anon_sym_inout] = ACTIONS(3685),
    [anon_sym_extern] = ACTIONS(3685),
    [anon_sym___attribute__] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3687),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3687),
    [anon_sym___declspec] = ACTIONS(3685),
    [anon_sym___based] = ACTIONS(3685),
    [anon_sym___cdecl] = ACTIONS(3685),
    [anon_sym___clrcall] = ACTIONS(3685),
    [anon_sym___stdcall] = ACTIONS(3685),
    [anon_sym___fastcall] = ACTIONS(3685),
    [anon_sym___thiscall] = ACTIONS(3685),
    [anon_sym___vectorcall] = ACTIONS(3685),
    [anon_sym_LBRACE] = ACTIONS(3687),
    [anon_sym_signed] = ACTIONS(3685),
    [anon_sym_unsigned] = ACTIONS(3685),
    [anon_sym_long] = ACTIONS(3685),
    [anon_sym_short] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_static] = ACTIONS(3685),
    [anon_sym_register] = ACTIONS(3685),
    [anon_sym_inline] = ACTIONS(3685),
    [anon_sym___inline] = ACTIONS(3685),
    [anon_sym___inline__] = ACTIONS(3685),
    [anon_sym___forceinline] = ACTIONS(3685),
    [anon_sym_thread_local] = ACTIONS(3685),
    [anon_sym___thread] = ACTIONS(3685),
    [anon_sym_const] = ACTIONS(3685),
    [anon_sym_constexpr] = ACTIONS(3685),
    [anon_sym_volatile] = ACTIONS(3685),
    [anon_sym_restrict] = ACTIONS(3685),
    [anon_sym___restrict__] = ACTIONS(3685),
    [anon_sym__Atomic] = ACTIONS(3685),
    [anon_sym__Noreturn] = ACTIONS(3685),
    [anon_sym_noreturn] = ACTIONS(3685),
    [anon_sym_mutable] = ACTIONS(3685),
    [anon_sym_constinit] = ACTIONS(3685),
    [anon_sym_consteval] = ACTIONS(3685),
    [anon_sym_alignas] = ACTIONS(3685),
    [anon_sym__Alignas] = ACTIONS(3685),
    [sym_primitive_type] = ACTIONS(3685),
    [anon_sym_enum] = ACTIONS(3685),
    [anon_sym_class] = ACTIONS(3685),
    [anon_sym_struct] = ACTIONS(3685),
    [anon_sym_union] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_switch] = ACTIONS(3685),
    [anon_sym_case] = ACTIONS(3685),
    [anon_sym_default] = ACTIONS(3685),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_break] = ACTIONS(3685),
    [anon_sym_continue] = ACTIONS(3685),
    [anon_sym_goto] = ACTIONS(3685),
    [anon_sym___try] = ACTIONS(3685),
    [anon_sym___leave] = ACTIONS(3685),
    [anon_sym_not] = ACTIONS(3685),
    [anon_sym_compl] = ACTIONS(3685),
    [anon_sym_DASH_DASH] = ACTIONS(3687),
    [anon_sym_PLUS_PLUS] = ACTIONS(3687),
    [anon_sym_sizeof] = ACTIONS(3685),
    [anon_sym___alignof__] = ACTIONS(3685),
    [anon_sym___alignof] = ACTIONS(3685),
    [anon_sym__alignof] = ACTIONS(3685),
    [anon_sym_alignof] = ACTIONS(3685),
    [anon_sym__Alignof] = ACTIONS(3685),
    [anon_sym_offsetof] = ACTIONS(3685),
    [anon_sym__Generic] = ACTIONS(3685),
    [anon_sym_asm] = ACTIONS(3685),
    [anon_sym___asm__] = ACTIONS(3685),
    [sym_number_literal] = ACTIONS(3687),
    [anon_sym_L_SQUOTE] = ACTIONS(3687),
    [anon_sym_u_SQUOTE] = ACTIONS(3687),
    [anon_sym_U_SQUOTE] = ACTIONS(3687),
    [anon_sym_u8_SQUOTE] = ACTIONS(3687),
    [anon_sym_SQUOTE] = ACTIONS(3687),
    [anon_sym_L_DQUOTE] = ACTIONS(3687),
    [anon_sym_u_DQUOTE] = ACTIONS(3687),
    [anon_sym_U_DQUOTE] = ACTIONS(3687),
    [anon_sym_u8_DQUOTE] = ACTIONS(3687),
    [anon_sym_DQUOTE] = ACTIONS(3687),
    [sym_true] = ACTIONS(3685),
    [sym_false] = ACTIONS(3685),
    [anon_sym_NULL] = ACTIONS(3685),
    [anon_sym_nullptr] = ACTIONS(3685),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_This] = ACTIONS(3685),
    [anon_sym_decltype] = ACTIONS(3685),
    [sym_virtual] = ACTIONS(3685),
    [anon_sym_explicit] = ACTIONS(3685),
    [anon_sym_typename] = ACTIONS(3685),
    [anon_sym_template] = ACTIONS(3685),
    [anon_sym_operator] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_delete] = ACTIONS(3685),
    [anon_sym_throw] = ACTIONS(3685),
    [anon_sym_namespace] = ACTIONS(3685),
    [anon_sym_using] = ACTIONS(3685),
    [anon_sym_static_assert] = ACTIONS(3685),
    [anon_sym_concept] = ACTIONS(3685),
    [anon_sym_co_return] = ACTIONS(3685),
    [anon_sym_co_yield] = ACTIONS(3685),
    [anon_sym_R_DQUOTE] = ACTIONS(3687),
    [anon_sym_LR_DQUOTE] = ACTIONS(3687),
    [anon_sym_uR_DQUOTE] = ACTIONS(3687),
    [anon_sym_UR_DQUOTE] = ACTIONS(3687),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3687),
    [anon_sym_co_await] = ACTIONS(3685),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_requires] = ACTIONS(3685),
    [sym_this] = ACTIONS(3685),
    [anon_sym_discard] = ACTIONS(3685),
    [anon_sym_precise] = ACTIONS(3685),
    [anon_sym_shared] = ACTIONS(3685),
    [anon_sym_groupshared] = ACTIONS(3685),
    [anon_sym_uniform] = ACTIONS(3685),
    [anon_sym_row_major] = ACTIONS(3685),
    [anon_sym_column_major] = ACTIONS(3685),
    [anon_sym_globallycoherent] = ACTIONS(3685),
    [anon_sym_centroid] = ACTIONS(3685),
    [anon_sym_noperspective] = ACTIONS(3685),
    [anon_sym_nointerpolation] = ACTIONS(3685),
    [anon_sym_sample] = ACTIONS(3685),
    [anon_sym_linear] = ACTIONS(3685),
    [anon_sym_snorm] = ACTIONS(3685),
    [anon_sym_unorm] = ACTIONS(3685),
    [anon_sym_point] = ACTIONS(3685),
    [anon_sym_line] = ACTIONS(3685),
    [anon_sym_triangleadj] = ACTIONS(3685),
    [anon_sym_lineadj] = ACTIONS(3685),
    [anon_sym_triangle] = ACTIONS(3685),
    [anon_sym_cbuffer] = ACTIONS(3685),
    [anon_sym_interface] = ACTIONS(3685),
    [anon_sym_extension] = ACTIONS(3685),
  },
  [986] = {
    [sym_identifier] = ACTIONS(3695),
    [aux_sym_preproc_include_token1] = ACTIONS(3695),
    [aux_sym_preproc_def_token1] = ACTIONS(3695),
    [aux_sym_preproc_if_token1] = ACTIONS(3695),
    [aux_sym_preproc_if_token2] = ACTIONS(3695),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3695),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3695),
    [sym_preproc_directive] = ACTIONS(3695),
    [anon_sym_LPAREN2] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3697),
    [anon_sym_TILDE] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3695),
    [anon_sym_PLUS] = ACTIONS(3695),
    [anon_sym_STAR] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3697),
    [anon_sym_AMP] = ACTIONS(3695),
    [anon_sym_SEMI] = ACTIONS(3697),
    [anon_sym___extension__] = ACTIONS(3695),
    [anon_sym_typedef] = ACTIONS(3695),
    [anon_sym_in] = ACTIONS(3695),
    [anon_sym_out] = ACTIONS(3695),
    [anon_sym_inout] = ACTIONS(3695),
    [anon_sym_extern] = ACTIONS(3695),
    [anon_sym___attribute__] = ACTIONS(3695),
    [anon_sym_COLON_COLON] = ACTIONS(3697),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3697),
    [anon_sym___declspec] = ACTIONS(3695),
    [anon_sym___based] = ACTIONS(3695),
    [anon_sym___cdecl] = ACTIONS(3695),
    [anon_sym___clrcall] = ACTIONS(3695),
    [anon_sym___stdcall] = ACTIONS(3695),
    [anon_sym___fastcall] = ACTIONS(3695),
    [anon_sym___thiscall] = ACTIONS(3695),
    [anon_sym___vectorcall] = ACTIONS(3695),
    [anon_sym_LBRACE] = ACTIONS(3697),
    [anon_sym_signed] = ACTIONS(3695),
    [anon_sym_unsigned] = ACTIONS(3695),
    [anon_sym_long] = ACTIONS(3695),
    [anon_sym_short] = ACTIONS(3695),
    [anon_sym_LBRACK] = ACTIONS(3695),
    [anon_sym_static] = ACTIONS(3695),
    [anon_sym_register] = ACTIONS(3695),
    [anon_sym_inline] = ACTIONS(3695),
    [anon_sym___inline] = ACTIONS(3695),
    [anon_sym___inline__] = ACTIONS(3695),
    [anon_sym___forceinline] = ACTIONS(3695),
    [anon_sym_thread_local] = ACTIONS(3695),
    [anon_sym___thread] = ACTIONS(3695),
    [anon_sym_const] = ACTIONS(3695),
    [anon_sym_constexpr] = ACTIONS(3695),
    [anon_sym_volatile] = ACTIONS(3695),
    [anon_sym_restrict] = ACTIONS(3695),
    [anon_sym___restrict__] = ACTIONS(3695),
    [anon_sym__Atomic] = ACTIONS(3695),
    [anon_sym__Noreturn] = ACTIONS(3695),
    [anon_sym_noreturn] = ACTIONS(3695),
    [anon_sym_mutable] = ACTIONS(3695),
    [anon_sym_constinit] = ACTIONS(3695),
    [anon_sym_consteval] = ACTIONS(3695),
    [anon_sym_alignas] = ACTIONS(3695),
    [anon_sym__Alignas] = ACTIONS(3695),
    [sym_primitive_type] = ACTIONS(3695),
    [anon_sym_enum] = ACTIONS(3695),
    [anon_sym_class] = ACTIONS(3695),
    [anon_sym_struct] = ACTIONS(3695),
    [anon_sym_union] = ACTIONS(3695),
    [anon_sym_if] = ACTIONS(3695),
    [anon_sym_switch] = ACTIONS(3695),
    [anon_sym_case] = ACTIONS(3695),
    [anon_sym_default] = ACTIONS(3695),
    [anon_sym_while] = ACTIONS(3695),
    [anon_sym_do] = ACTIONS(3695),
    [anon_sym_for] = ACTIONS(3695),
    [anon_sym_return] = ACTIONS(3695),
    [anon_sym_break] = ACTIONS(3695),
    [anon_sym_continue] = ACTIONS(3695),
    [anon_sym_goto] = ACTIONS(3695),
    [anon_sym___try] = ACTIONS(3695),
    [anon_sym___leave] = ACTIONS(3695),
    [anon_sym_not] = ACTIONS(3695),
    [anon_sym_compl] = ACTIONS(3695),
    [anon_sym_DASH_DASH] = ACTIONS(3697),
    [anon_sym_PLUS_PLUS] = ACTIONS(3697),
    [anon_sym_sizeof] = ACTIONS(3695),
    [anon_sym___alignof__] = ACTIONS(3695),
    [anon_sym___alignof] = ACTIONS(3695),
    [anon_sym__alignof] = ACTIONS(3695),
    [anon_sym_alignof] = ACTIONS(3695),
    [anon_sym__Alignof] = ACTIONS(3695),
    [anon_sym_offsetof] = ACTIONS(3695),
    [anon_sym__Generic] = ACTIONS(3695),
    [anon_sym_asm] = ACTIONS(3695),
    [anon_sym___asm__] = ACTIONS(3695),
    [sym_number_literal] = ACTIONS(3697),
    [anon_sym_L_SQUOTE] = ACTIONS(3697),
    [anon_sym_u_SQUOTE] = ACTIONS(3697),
    [anon_sym_U_SQUOTE] = ACTIONS(3697),
    [anon_sym_u8_SQUOTE] = ACTIONS(3697),
    [anon_sym_SQUOTE] = ACTIONS(3697),
    [anon_sym_L_DQUOTE] = ACTIONS(3697),
    [anon_sym_u_DQUOTE] = ACTIONS(3697),
    [anon_sym_U_DQUOTE] = ACTIONS(3697),
    [anon_sym_u8_DQUOTE] = ACTIONS(3697),
    [anon_sym_DQUOTE] = ACTIONS(3697),
    [sym_true] = ACTIONS(3695),
    [sym_false] = ACTIONS(3695),
    [anon_sym_NULL] = ACTIONS(3695),
    [anon_sym_nullptr] = ACTIONS(3695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3695),
    [anon_sym_let] = ACTIONS(3695),
    [anon_sym_This] = ACTIONS(3695),
    [anon_sym_decltype] = ACTIONS(3695),
    [sym_virtual] = ACTIONS(3695),
    [anon_sym_explicit] = ACTIONS(3695),
    [anon_sym_typename] = ACTIONS(3695),
    [anon_sym_template] = ACTIONS(3695),
    [anon_sym_operator] = ACTIONS(3695),
    [anon_sym_try] = ACTIONS(3695),
    [anon_sym_delete] = ACTIONS(3695),
    [anon_sym_throw] = ACTIONS(3695),
    [anon_sym_namespace] = ACTIONS(3695),
    [anon_sym_using] = ACTIONS(3695),
    [anon_sym_static_assert] = ACTIONS(3695),
    [anon_sym_concept] = ACTIONS(3695),
    [anon_sym_co_return] = ACTIONS(3695),
    [anon_sym_co_yield] = ACTIONS(3695),
    [anon_sym_R_DQUOTE] = ACTIONS(3697),
    [anon_sym_LR_DQUOTE] = ACTIONS(3697),
    [anon_sym_uR_DQUOTE] = ACTIONS(3697),
    [anon_sym_UR_DQUOTE] = ACTIONS(3697),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3697),
    [anon_sym_co_await] = ACTIONS(3695),
    [anon_sym_new] = ACTIONS(3695),
    [anon_sym_requires] = ACTIONS(3695),
    [sym_this] = ACTIONS(3695),
    [anon_sym_discard] = ACTIONS(3695),
    [anon_sym_precise] = ACTIONS(3695),
    [anon_sym_shared] = ACTIONS(3695),
    [anon_sym_groupshared] = ACTIONS(3695),
    [anon_sym_uniform] = ACTIONS(3695),
    [anon_sym_row_major] = ACTIONS(3695),
    [anon_sym_column_major] = ACTIONS(3695),
    [anon_sym_globallycoherent] = ACTIONS(3695),
    [anon_sym_centroid] = ACTIONS(3695),
    [anon_sym_noperspective] = ACTIONS(3695),
    [anon_sym_nointerpolation] = ACTIONS(3695),
    [anon_sym_sample] = ACTIONS(3695),
    [anon_sym_linear] = ACTIONS(3695),
    [anon_sym_snorm] = ACTIONS(3695),
    [anon_sym_unorm] = ACTIONS(3695),
    [anon_sym_point] = ACTIONS(3695),
    [anon_sym_line] = ACTIONS(3695),
    [anon_sym_triangleadj] = ACTIONS(3695),
    [anon_sym_lineadj] = ACTIONS(3695),
    [anon_sym_triangle] = ACTIONS(3695),
    [anon_sym_cbuffer] = ACTIONS(3695),
    [anon_sym_interface] = ACTIONS(3695),
    [anon_sym_extension] = ACTIONS(3695),
  },
  [987] = {
    [sym_identifier] = ACTIONS(3531),
    [aux_sym_preproc_include_token1] = ACTIONS(3531),
    [aux_sym_preproc_def_token1] = ACTIONS(3531),
    [aux_sym_preproc_if_token1] = ACTIONS(3531),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3531),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3531),
    [sym_preproc_directive] = ACTIONS(3531),
    [anon_sym_LPAREN2] = ACTIONS(3533),
    [anon_sym_BANG] = ACTIONS(3533),
    [anon_sym_TILDE] = ACTIONS(3533),
    [anon_sym_DASH] = ACTIONS(3531),
    [anon_sym_PLUS] = ACTIONS(3531),
    [anon_sym_STAR] = ACTIONS(3533),
    [anon_sym_AMP_AMP] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_SEMI] = ACTIONS(3533),
    [anon_sym___extension__] = ACTIONS(3531),
    [anon_sym_typedef] = ACTIONS(3531),
    [anon_sym_in] = ACTIONS(3531),
    [anon_sym_out] = ACTIONS(3531),
    [anon_sym_inout] = ACTIONS(3531),
    [anon_sym_extern] = ACTIONS(3531),
    [anon_sym___attribute__] = ACTIONS(3531),
    [anon_sym_COLON_COLON] = ACTIONS(3533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3533),
    [anon_sym___declspec] = ACTIONS(3531),
    [anon_sym___based] = ACTIONS(3531),
    [anon_sym___cdecl] = ACTIONS(3531),
    [anon_sym___clrcall] = ACTIONS(3531),
    [anon_sym___stdcall] = ACTIONS(3531),
    [anon_sym___fastcall] = ACTIONS(3531),
    [anon_sym___thiscall] = ACTIONS(3531),
    [anon_sym___vectorcall] = ACTIONS(3531),
    [anon_sym_LBRACE] = ACTIONS(3533),
    [anon_sym_RBRACE] = ACTIONS(3533),
    [anon_sym_signed] = ACTIONS(3531),
    [anon_sym_unsigned] = ACTIONS(3531),
    [anon_sym_long] = ACTIONS(3531),
    [anon_sym_short] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_static] = ACTIONS(3531),
    [anon_sym_register] = ACTIONS(3531),
    [anon_sym_inline] = ACTIONS(3531),
    [anon_sym___inline] = ACTIONS(3531),
    [anon_sym___inline__] = ACTIONS(3531),
    [anon_sym___forceinline] = ACTIONS(3531),
    [anon_sym_thread_local] = ACTIONS(3531),
    [anon_sym___thread] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3531),
    [anon_sym_constexpr] = ACTIONS(3531),
    [anon_sym_volatile] = ACTIONS(3531),
    [anon_sym_restrict] = ACTIONS(3531),
    [anon_sym___restrict__] = ACTIONS(3531),
    [anon_sym__Atomic] = ACTIONS(3531),
    [anon_sym__Noreturn] = ACTIONS(3531),
    [anon_sym_noreturn] = ACTIONS(3531),
    [anon_sym_mutable] = ACTIONS(3531),
    [anon_sym_constinit] = ACTIONS(3531),
    [anon_sym_consteval] = ACTIONS(3531),
    [anon_sym_alignas] = ACTIONS(3531),
    [anon_sym__Alignas] = ACTIONS(3531),
    [sym_primitive_type] = ACTIONS(3531),
    [anon_sym_enum] = ACTIONS(3531),
    [anon_sym_class] = ACTIONS(3531),
    [anon_sym_struct] = ACTIONS(3531),
    [anon_sym_union] = ACTIONS(3531),
    [anon_sym_if] = ACTIONS(3531),
    [anon_sym_switch] = ACTIONS(3531),
    [anon_sym_case] = ACTIONS(3531),
    [anon_sym_default] = ACTIONS(3531),
    [anon_sym_while] = ACTIONS(3531),
    [anon_sym_do] = ACTIONS(3531),
    [anon_sym_for] = ACTIONS(3531),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_break] = ACTIONS(3531),
    [anon_sym_continue] = ACTIONS(3531),
    [anon_sym_goto] = ACTIONS(3531),
    [anon_sym___try] = ACTIONS(3531),
    [anon_sym___leave] = ACTIONS(3531),
    [anon_sym_not] = ACTIONS(3531),
    [anon_sym_compl] = ACTIONS(3531),
    [anon_sym_DASH_DASH] = ACTIONS(3533),
    [anon_sym_PLUS_PLUS] = ACTIONS(3533),
    [anon_sym_sizeof] = ACTIONS(3531),
    [anon_sym___alignof__] = ACTIONS(3531),
    [anon_sym___alignof] = ACTIONS(3531),
    [anon_sym__alignof] = ACTIONS(3531),
    [anon_sym_alignof] = ACTIONS(3531),
    [anon_sym__Alignof] = ACTIONS(3531),
    [anon_sym_offsetof] = ACTIONS(3531),
    [anon_sym__Generic] = ACTIONS(3531),
    [anon_sym_asm] = ACTIONS(3531),
    [anon_sym___asm__] = ACTIONS(3531),
    [sym_number_literal] = ACTIONS(3533),
    [anon_sym_L_SQUOTE] = ACTIONS(3533),
    [anon_sym_u_SQUOTE] = ACTIONS(3533),
    [anon_sym_U_SQUOTE] = ACTIONS(3533),
    [anon_sym_u8_SQUOTE] = ACTIONS(3533),
    [anon_sym_SQUOTE] = ACTIONS(3533),
    [anon_sym_L_DQUOTE] = ACTIONS(3533),
    [anon_sym_u_DQUOTE] = ACTIONS(3533),
    [anon_sym_U_DQUOTE] = ACTIONS(3533),
    [anon_sym_u8_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE] = ACTIONS(3533),
    [sym_true] = ACTIONS(3531),
    [sym_false] = ACTIONS(3531),
    [anon_sym_NULL] = ACTIONS(3531),
    [anon_sym_nullptr] = ACTIONS(3531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_This] = ACTIONS(3531),
    [anon_sym_decltype] = ACTIONS(3531),
    [sym_virtual] = ACTIONS(3531),
    [anon_sym_explicit] = ACTIONS(3531),
    [anon_sym_typename] = ACTIONS(3531),
    [anon_sym_template] = ACTIONS(3531),
    [anon_sym_operator] = ACTIONS(3531),
    [anon_sym_try] = ACTIONS(3531),
    [anon_sym_delete] = ACTIONS(3531),
    [anon_sym_throw] = ACTIONS(3531),
    [anon_sym_namespace] = ACTIONS(3531),
    [anon_sym_using] = ACTIONS(3531),
    [anon_sym_static_assert] = ACTIONS(3531),
    [anon_sym_concept] = ACTIONS(3531),
    [anon_sym_co_return] = ACTIONS(3531),
    [anon_sym_co_yield] = ACTIONS(3531),
    [anon_sym_R_DQUOTE] = ACTIONS(3533),
    [anon_sym_LR_DQUOTE] = ACTIONS(3533),
    [anon_sym_uR_DQUOTE] = ACTIONS(3533),
    [anon_sym_UR_DQUOTE] = ACTIONS(3533),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3533),
    [anon_sym_co_await] = ACTIONS(3531),
    [anon_sym_new] = ACTIONS(3531),
    [anon_sym_requires] = ACTIONS(3531),
    [sym_this] = ACTIONS(3531),
    [anon_sym_discard] = ACTIONS(3531),
    [anon_sym_precise] = ACTIONS(3531),
    [anon_sym_shared] = ACTIONS(3531),
    [anon_sym_groupshared] = ACTIONS(3531),
    [anon_sym_uniform] = ACTIONS(3531),
    [anon_sym_row_major] = ACTIONS(3531),
    [anon_sym_column_major] = ACTIONS(3531),
    [anon_sym_globallycoherent] = ACTIONS(3531),
    [anon_sym_centroid] = ACTIONS(3531),
    [anon_sym_noperspective] = ACTIONS(3531),
    [anon_sym_nointerpolation] = ACTIONS(3531),
    [anon_sym_sample] = ACTIONS(3531),
    [anon_sym_linear] = ACTIONS(3531),
    [anon_sym_snorm] = ACTIONS(3531),
    [anon_sym_unorm] = ACTIONS(3531),
    [anon_sym_point] = ACTIONS(3531),
    [anon_sym_line] = ACTIONS(3531),
    [anon_sym_triangleadj] = ACTIONS(3531),
    [anon_sym_lineadj] = ACTIONS(3531),
    [anon_sym_triangle] = ACTIONS(3531),
    [anon_sym_cbuffer] = ACTIONS(3531),
    [anon_sym_interface] = ACTIONS(3531),
    [anon_sym_extension] = ACTIONS(3531),
  },
  [988] = {
    [sym_identifier] = ACTIONS(3597),
    [aux_sym_preproc_include_token1] = ACTIONS(3597),
    [aux_sym_preproc_def_token1] = ACTIONS(3597),
    [aux_sym_preproc_if_token1] = ACTIONS(3597),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3597),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3597),
    [sym_preproc_directive] = ACTIONS(3597),
    [anon_sym_LPAREN2] = ACTIONS(3599),
    [anon_sym_BANG] = ACTIONS(3599),
    [anon_sym_TILDE] = ACTIONS(3599),
    [anon_sym_DASH] = ACTIONS(3597),
    [anon_sym_PLUS] = ACTIONS(3597),
    [anon_sym_STAR] = ACTIONS(3599),
    [anon_sym_AMP_AMP] = ACTIONS(3599),
    [anon_sym_AMP] = ACTIONS(3597),
    [anon_sym_SEMI] = ACTIONS(3599),
    [anon_sym___extension__] = ACTIONS(3597),
    [anon_sym_typedef] = ACTIONS(3597),
    [anon_sym_in] = ACTIONS(3597),
    [anon_sym_out] = ACTIONS(3597),
    [anon_sym_inout] = ACTIONS(3597),
    [anon_sym_extern] = ACTIONS(3597),
    [anon_sym___attribute__] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3599),
    [anon_sym___declspec] = ACTIONS(3597),
    [anon_sym___based] = ACTIONS(3597),
    [anon_sym___cdecl] = ACTIONS(3597),
    [anon_sym___clrcall] = ACTIONS(3597),
    [anon_sym___stdcall] = ACTIONS(3597),
    [anon_sym___fastcall] = ACTIONS(3597),
    [anon_sym___thiscall] = ACTIONS(3597),
    [anon_sym___vectorcall] = ACTIONS(3597),
    [anon_sym_LBRACE] = ACTIONS(3599),
    [anon_sym_RBRACE] = ACTIONS(3599),
    [anon_sym_signed] = ACTIONS(3597),
    [anon_sym_unsigned] = ACTIONS(3597),
    [anon_sym_long] = ACTIONS(3597),
    [anon_sym_short] = ACTIONS(3597),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_static] = ACTIONS(3597),
    [anon_sym_register] = ACTIONS(3597),
    [anon_sym_inline] = ACTIONS(3597),
    [anon_sym___inline] = ACTIONS(3597),
    [anon_sym___inline__] = ACTIONS(3597),
    [anon_sym___forceinline] = ACTIONS(3597),
    [anon_sym_thread_local] = ACTIONS(3597),
    [anon_sym___thread] = ACTIONS(3597),
    [anon_sym_const] = ACTIONS(3597),
    [anon_sym_constexpr] = ACTIONS(3597),
    [anon_sym_volatile] = ACTIONS(3597),
    [anon_sym_restrict] = ACTIONS(3597),
    [anon_sym___restrict__] = ACTIONS(3597),
    [anon_sym__Atomic] = ACTIONS(3597),
    [anon_sym__Noreturn] = ACTIONS(3597),
    [anon_sym_noreturn] = ACTIONS(3597),
    [anon_sym_mutable] = ACTIONS(3597),
    [anon_sym_constinit] = ACTIONS(3597),
    [anon_sym_consteval] = ACTIONS(3597),
    [anon_sym_alignas] = ACTIONS(3597),
    [anon_sym__Alignas] = ACTIONS(3597),
    [sym_primitive_type] = ACTIONS(3597),
    [anon_sym_enum] = ACTIONS(3597),
    [anon_sym_class] = ACTIONS(3597),
    [anon_sym_struct] = ACTIONS(3597),
    [anon_sym_union] = ACTIONS(3597),
    [anon_sym_if] = ACTIONS(3597),
    [anon_sym_switch] = ACTIONS(3597),
    [anon_sym_case] = ACTIONS(3597),
    [anon_sym_default] = ACTIONS(3597),
    [anon_sym_while] = ACTIONS(3597),
    [anon_sym_do] = ACTIONS(3597),
    [anon_sym_for] = ACTIONS(3597),
    [anon_sym_return] = ACTIONS(3597),
    [anon_sym_break] = ACTIONS(3597),
    [anon_sym_continue] = ACTIONS(3597),
    [anon_sym_goto] = ACTIONS(3597),
    [anon_sym___try] = ACTIONS(3597),
    [anon_sym___leave] = ACTIONS(3597),
    [anon_sym_not] = ACTIONS(3597),
    [anon_sym_compl] = ACTIONS(3597),
    [anon_sym_DASH_DASH] = ACTIONS(3599),
    [anon_sym_PLUS_PLUS] = ACTIONS(3599),
    [anon_sym_sizeof] = ACTIONS(3597),
    [anon_sym___alignof__] = ACTIONS(3597),
    [anon_sym___alignof] = ACTIONS(3597),
    [anon_sym__alignof] = ACTIONS(3597),
    [anon_sym_alignof] = ACTIONS(3597),
    [anon_sym__Alignof] = ACTIONS(3597),
    [anon_sym_offsetof] = ACTIONS(3597),
    [anon_sym__Generic] = ACTIONS(3597),
    [anon_sym_asm] = ACTIONS(3597),
    [anon_sym___asm__] = ACTIONS(3597),
    [sym_number_literal] = ACTIONS(3599),
    [anon_sym_L_SQUOTE] = ACTIONS(3599),
    [anon_sym_u_SQUOTE] = ACTIONS(3599),
    [anon_sym_U_SQUOTE] = ACTIONS(3599),
    [anon_sym_u8_SQUOTE] = ACTIONS(3599),
    [anon_sym_SQUOTE] = ACTIONS(3599),
    [anon_sym_L_DQUOTE] = ACTIONS(3599),
    [anon_sym_u_DQUOTE] = ACTIONS(3599),
    [anon_sym_U_DQUOTE] = ACTIONS(3599),
    [anon_sym_u8_DQUOTE] = ACTIONS(3599),
    [anon_sym_DQUOTE] = ACTIONS(3599),
    [sym_true] = ACTIONS(3597),
    [sym_false] = ACTIONS(3597),
    [anon_sym_NULL] = ACTIONS(3597),
    [anon_sym_nullptr] = ACTIONS(3597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3597),
    [anon_sym_let] = ACTIONS(3597),
    [anon_sym_This] = ACTIONS(3597),
    [anon_sym_decltype] = ACTIONS(3597),
    [sym_virtual] = ACTIONS(3597),
    [anon_sym_explicit] = ACTIONS(3597),
    [anon_sym_typename] = ACTIONS(3597),
    [anon_sym_template] = ACTIONS(3597),
    [anon_sym_operator] = ACTIONS(3597),
    [anon_sym_try] = ACTIONS(3597),
    [anon_sym_delete] = ACTIONS(3597),
    [anon_sym_throw] = ACTIONS(3597),
    [anon_sym_namespace] = ACTIONS(3597),
    [anon_sym_using] = ACTIONS(3597),
    [anon_sym_static_assert] = ACTIONS(3597),
    [anon_sym_concept] = ACTIONS(3597),
    [anon_sym_co_return] = ACTIONS(3597),
    [anon_sym_co_yield] = ACTIONS(3597),
    [anon_sym_R_DQUOTE] = ACTIONS(3599),
    [anon_sym_LR_DQUOTE] = ACTIONS(3599),
    [anon_sym_uR_DQUOTE] = ACTIONS(3599),
    [anon_sym_UR_DQUOTE] = ACTIONS(3599),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3599),
    [anon_sym_co_await] = ACTIONS(3597),
    [anon_sym_new] = ACTIONS(3597),
    [anon_sym_requires] = ACTIONS(3597),
    [sym_this] = ACTIONS(3597),
    [anon_sym_discard] = ACTIONS(3597),
    [anon_sym_precise] = ACTIONS(3597),
    [anon_sym_shared] = ACTIONS(3597),
    [anon_sym_groupshared] = ACTIONS(3597),
    [anon_sym_uniform] = ACTIONS(3597),
    [anon_sym_row_major] = ACTIONS(3597),
    [anon_sym_column_major] = ACTIONS(3597),
    [anon_sym_globallycoherent] = ACTIONS(3597),
    [anon_sym_centroid] = ACTIONS(3597),
    [anon_sym_noperspective] = ACTIONS(3597),
    [anon_sym_nointerpolation] = ACTIONS(3597),
    [anon_sym_sample] = ACTIONS(3597),
    [anon_sym_linear] = ACTIONS(3597),
    [anon_sym_snorm] = ACTIONS(3597),
    [anon_sym_unorm] = ACTIONS(3597),
    [anon_sym_point] = ACTIONS(3597),
    [anon_sym_line] = ACTIONS(3597),
    [anon_sym_triangleadj] = ACTIONS(3597),
    [anon_sym_lineadj] = ACTIONS(3597),
    [anon_sym_triangle] = ACTIONS(3597),
    [anon_sym_cbuffer] = ACTIONS(3597),
    [anon_sym_interface] = ACTIONS(3597),
    [anon_sym_extension] = ACTIONS(3597),
  },
  [989] = {
    [sym_identifier] = ACTIONS(3493),
    [aux_sym_preproc_include_token1] = ACTIONS(3493),
    [aux_sym_preproc_def_token1] = ACTIONS(3493),
    [aux_sym_preproc_if_token1] = ACTIONS(3493),
    [aux_sym_preproc_if_token2] = ACTIONS(3493),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3493),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3493),
    [sym_preproc_directive] = ACTIONS(3493),
    [anon_sym_LPAREN2] = ACTIONS(3495),
    [anon_sym_BANG] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3495),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_PLUS] = ACTIONS(3493),
    [anon_sym_STAR] = ACTIONS(3495),
    [anon_sym_AMP_AMP] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_SEMI] = ACTIONS(3495),
    [anon_sym___extension__] = ACTIONS(3493),
    [anon_sym_typedef] = ACTIONS(3493),
    [anon_sym_in] = ACTIONS(3493),
    [anon_sym_out] = ACTIONS(3493),
    [anon_sym_inout] = ACTIONS(3493),
    [anon_sym_extern] = ACTIONS(3493),
    [anon_sym___attribute__] = ACTIONS(3493),
    [anon_sym_COLON_COLON] = ACTIONS(3495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3495),
    [anon_sym___declspec] = ACTIONS(3493),
    [anon_sym___based] = ACTIONS(3493),
    [anon_sym___cdecl] = ACTIONS(3493),
    [anon_sym___clrcall] = ACTIONS(3493),
    [anon_sym___stdcall] = ACTIONS(3493),
    [anon_sym___fastcall] = ACTIONS(3493),
    [anon_sym___thiscall] = ACTIONS(3493),
    [anon_sym___vectorcall] = ACTIONS(3493),
    [anon_sym_LBRACE] = ACTIONS(3495),
    [anon_sym_signed] = ACTIONS(3493),
    [anon_sym_unsigned] = ACTIONS(3493),
    [anon_sym_long] = ACTIONS(3493),
    [anon_sym_short] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3493),
    [anon_sym_static] = ACTIONS(3493),
    [anon_sym_register] = ACTIONS(3493),
    [anon_sym_inline] = ACTIONS(3493),
    [anon_sym___inline] = ACTIONS(3493),
    [anon_sym___inline__] = ACTIONS(3493),
    [anon_sym___forceinline] = ACTIONS(3493),
    [anon_sym_thread_local] = ACTIONS(3493),
    [anon_sym___thread] = ACTIONS(3493),
    [anon_sym_const] = ACTIONS(3493),
    [anon_sym_constexpr] = ACTIONS(3493),
    [anon_sym_volatile] = ACTIONS(3493),
    [anon_sym_restrict] = ACTIONS(3493),
    [anon_sym___restrict__] = ACTIONS(3493),
    [anon_sym__Atomic] = ACTIONS(3493),
    [anon_sym__Noreturn] = ACTIONS(3493),
    [anon_sym_noreturn] = ACTIONS(3493),
    [anon_sym_mutable] = ACTIONS(3493),
    [anon_sym_constinit] = ACTIONS(3493),
    [anon_sym_consteval] = ACTIONS(3493),
    [anon_sym_alignas] = ACTIONS(3493),
    [anon_sym__Alignas] = ACTIONS(3493),
    [sym_primitive_type] = ACTIONS(3493),
    [anon_sym_enum] = ACTIONS(3493),
    [anon_sym_class] = ACTIONS(3493),
    [anon_sym_struct] = ACTIONS(3493),
    [anon_sym_union] = ACTIONS(3493),
    [anon_sym_if] = ACTIONS(3493),
    [anon_sym_switch] = ACTIONS(3493),
    [anon_sym_case] = ACTIONS(3493),
    [anon_sym_default] = ACTIONS(3493),
    [anon_sym_while] = ACTIONS(3493),
    [anon_sym_do] = ACTIONS(3493),
    [anon_sym_for] = ACTIONS(3493),
    [anon_sym_return] = ACTIONS(3493),
    [anon_sym_break] = ACTIONS(3493),
    [anon_sym_continue] = ACTIONS(3493),
    [anon_sym_goto] = ACTIONS(3493),
    [anon_sym___try] = ACTIONS(3493),
    [anon_sym___leave] = ACTIONS(3493),
    [anon_sym_not] = ACTIONS(3493),
    [anon_sym_compl] = ACTIONS(3493),
    [anon_sym_DASH_DASH] = ACTIONS(3495),
    [anon_sym_PLUS_PLUS] = ACTIONS(3495),
    [anon_sym_sizeof] = ACTIONS(3493),
    [anon_sym___alignof__] = ACTIONS(3493),
    [anon_sym___alignof] = ACTIONS(3493),
    [anon_sym__alignof] = ACTIONS(3493),
    [anon_sym_alignof] = ACTIONS(3493),
    [anon_sym__Alignof] = ACTIONS(3493),
    [anon_sym_offsetof] = ACTIONS(3493),
    [anon_sym__Generic] = ACTIONS(3493),
    [anon_sym_asm] = ACTIONS(3493),
    [anon_sym___asm__] = ACTIONS(3493),
    [sym_number_literal] = ACTIONS(3495),
    [anon_sym_L_SQUOTE] = ACTIONS(3495),
    [anon_sym_u_SQUOTE] = ACTIONS(3495),
    [anon_sym_U_SQUOTE] = ACTIONS(3495),
    [anon_sym_u8_SQUOTE] = ACTIONS(3495),
    [anon_sym_SQUOTE] = ACTIONS(3495),
    [anon_sym_L_DQUOTE] = ACTIONS(3495),
    [anon_sym_u_DQUOTE] = ACTIONS(3495),
    [anon_sym_U_DQUOTE] = ACTIONS(3495),
    [anon_sym_u8_DQUOTE] = ACTIONS(3495),
    [anon_sym_DQUOTE] = ACTIONS(3495),
    [sym_true] = ACTIONS(3493),
    [sym_false] = ACTIONS(3493),
    [anon_sym_NULL] = ACTIONS(3493),
    [anon_sym_nullptr] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3493),
    [anon_sym_let] = ACTIONS(3493),
    [anon_sym_This] = ACTIONS(3493),
    [anon_sym_decltype] = ACTIONS(3493),
    [sym_virtual] = ACTIONS(3493),
    [anon_sym_explicit] = ACTIONS(3493),
    [anon_sym_typename] = ACTIONS(3493),
    [anon_sym_template] = ACTIONS(3493),
    [anon_sym_operator] = ACTIONS(3493),
    [anon_sym_try] = ACTIONS(3493),
    [anon_sym_delete] = ACTIONS(3493),
    [anon_sym_throw] = ACTIONS(3493),
    [anon_sym_namespace] = ACTIONS(3493),
    [anon_sym_using] = ACTIONS(3493),
    [anon_sym_static_assert] = ACTIONS(3493),
    [anon_sym_concept] = ACTIONS(3493),
    [anon_sym_co_return] = ACTIONS(3493),
    [anon_sym_co_yield] = ACTIONS(3493),
    [anon_sym_R_DQUOTE] = ACTIONS(3495),
    [anon_sym_LR_DQUOTE] = ACTIONS(3495),
    [anon_sym_uR_DQUOTE] = ACTIONS(3495),
    [anon_sym_UR_DQUOTE] = ACTIONS(3495),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3495),
    [anon_sym_co_await] = ACTIONS(3493),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_requires] = ACTIONS(3493),
    [sym_this] = ACTIONS(3493),
    [anon_sym_discard] = ACTIONS(3493),
    [anon_sym_precise] = ACTIONS(3493),
    [anon_sym_shared] = ACTIONS(3493),
    [anon_sym_groupshared] = ACTIONS(3493),
    [anon_sym_uniform] = ACTIONS(3493),
    [anon_sym_row_major] = ACTIONS(3493),
    [anon_sym_column_major] = ACTIONS(3493),
    [anon_sym_globallycoherent] = ACTIONS(3493),
    [anon_sym_centroid] = ACTIONS(3493),
    [anon_sym_noperspective] = ACTIONS(3493),
    [anon_sym_nointerpolation] = ACTIONS(3493),
    [anon_sym_sample] = ACTIONS(3493),
    [anon_sym_linear] = ACTIONS(3493),
    [anon_sym_snorm] = ACTIONS(3493),
    [anon_sym_unorm] = ACTIONS(3493),
    [anon_sym_point] = ACTIONS(3493),
    [anon_sym_line] = ACTIONS(3493),
    [anon_sym_triangleadj] = ACTIONS(3493),
    [anon_sym_lineadj] = ACTIONS(3493),
    [anon_sym_triangle] = ACTIONS(3493),
    [anon_sym_cbuffer] = ACTIONS(3493),
    [anon_sym_interface] = ACTIONS(3493),
    [anon_sym_extension] = ACTIONS(3493),
  },
  [990] = {
    [sym_identifier] = ACTIONS(3649),
    [aux_sym_preproc_include_token1] = ACTIONS(3649),
    [aux_sym_preproc_def_token1] = ACTIONS(3649),
    [aux_sym_preproc_if_token1] = ACTIONS(3649),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3649),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3649),
    [sym_preproc_directive] = ACTIONS(3649),
    [anon_sym_LPAREN2] = ACTIONS(3651),
    [anon_sym_BANG] = ACTIONS(3651),
    [anon_sym_TILDE] = ACTIONS(3651),
    [anon_sym_DASH] = ACTIONS(3649),
    [anon_sym_PLUS] = ACTIONS(3649),
    [anon_sym_STAR] = ACTIONS(3651),
    [anon_sym_AMP_AMP] = ACTIONS(3651),
    [anon_sym_AMP] = ACTIONS(3649),
    [anon_sym_SEMI] = ACTIONS(3651),
    [anon_sym___extension__] = ACTIONS(3649),
    [anon_sym_typedef] = ACTIONS(3649),
    [anon_sym_in] = ACTIONS(3649),
    [anon_sym_out] = ACTIONS(3649),
    [anon_sym_inout] = ACTIONS(3649),
    [anon_sym_extern] = ACTIONS(3649),
    [anon_sym___attribute__] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(3651),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3651),
    [anon_sym___declspec] = ACTIONS(3649),
    [anon_sym___based] = ACTIONS(3649),
    [anon_sym___cdecl] = ACTIONS(3649),
    [anon_sym___clrcall] = ACTIONS(3649),
    [anon_sym___stdcall] = ACTIONS(3649),
    [anon_sym___fastcall] = ACTIONS(3649),
    [anon_sym___thiscall] = ACTIONS(3649),
    [anon_sym___vectorcall] = ACTIONS(3649),
    [anon_sym_LBRACE] = ACTIONS(3651),
    [anon_sym_RBRACE] = ACTIONS(3651),
    [anon_sym_signed] = ACTIONS(3649),
    [anon_sym_unsigned] = ACTIONS(3649),
    [anon_sym_long] = ACTIONS(3649),
    [anon_sym_short] = ACTIONS(3649),
    [anon_sym_LBRACK] = ACTIONS(3649),
    [anon_sym_static] = ACTIONS(3649),
    [anon_sym_register] = ACTIONS(3649),
    [anon_sym_inline] = ACTIONS(3649),
    [anon_sym___inline] = ACTIONS(3649),
    [anon_sym___inline__] = ACTIONS(3649),
    [anon_sym___forceinline] = ACTIONS(3649),
    [anon_sym_thread_local] = ACTIONS(3649),
    [anon_sym___thread] = ACTIONS(3649),
    [anon_sym_const] = ACTIONS(3649),
    [anon_sym_constexpr] = ACTIONS(3649),
    [anon_sym_volatile] = ACTIONS(3649),
    [anon_sym_restrict] = ACTIONS(3649),
    [anon_sym___restrict__] = ACTIONS(3649),
    [anon_sym__Atomic] = ACTIONS(3649),
    [anon_sym__Noreturn] = ACTIONS(3649),
    [anon_sym_noreturn] = ACTIONS(3649),
    [anon_sym_mutable] = ACTIONS(3649),
    [anon_sym_constinit] = ACTIONS(3649),
    [anon_sym_consteval] = ACTIONS(3649),
    [anon_sym_alignas] = ACTIONS(3649),
    [anon_sym__Alignas] = ACTIONS(3649),
    [sym_primitive_type] = ACTIONS(3649),
    [anon_sym_enum] = ACTIONS(3649),
    [anon_sym_class] = ACTIONS(3649),
    [anon_sym_struct] = ACTIONS(3649),
    [anon_sym_union] = ACTIONS(3649),
    [anon_sym_if] = ACTIONS(3649),
    [anon_sym_switch] = ACTIONS(3649),
    [anon_sym_case] = ACTIONS(3649),
    [anon_sym_default] = ACTIONS(3649),
    [anon_sym_while] = ACTIONS(3649),
    [anon_sym_do] = ACTIONS(3649),
    [anon_sym_for] = ACTIONS(3649),
    [anon_sym_return] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3649),
    [anon_sym_continue] = ACTIONS(3649),
    [anon_sym_goto] = ACTIONS(3649),
    [anon_sym___try] = ACTIONS(3649),
    [anon_sym___leave] = ACTIONS(3649),
    [anon_sym_not] = ACTIONS(3649),
    [anon_sym_compl] = ACTIONS(3649),
    [anon_sym_DASH_DASH] = ACTIONS(3651),
    [anon_sym_PLUS_PLUS] = ACTIONS(3651),
    [anon_sym_sizeof] = ACTIONS(3649),
    [anon_sym___alignof__] = ACTIONS(3649),
    [anon_sym___alignof] = ACTIONS(3649),
    [anon_sym__alignof] = ACTIONS(3649),
    [anon_sym_alignof] = ACTIONS(3649),
    [anon_sym__Alignof] = ACTIONS(3649),
    [anon_sym_offsetof] = ACTIONS(3649),
    [anon_sym__Generic] = ACTIONS(3649),
    [anon_sym_asm] = ACTIONS(3649),
    [anon_sym___asm__] = ACTIONS(3649),
    [sym_number_literal] = ACTIONS(3651),
    [anon_sym_L_SQUOTE] = ACTIONS(3651),
    [anon_sym_u_SQUOTE] = ACTIONS(3651),
    [anon_sym_U_SQUOTE] = ACTIONS(3651),
    [anon_sym_u8_SQUOTE] = ACTIONS(3651),
    [anon_sym_SQUOTE] = ACTIONS(3651),
    [anon_sym_L_DQUOTE] = ACTIONS(3651),
    [anon_sym_u_DQUOTE] = ACTIONS(3651),
    [anon_sym_U_DQUOTE] = ACTIONS(3651),
    [anon_sym_u8_DQUOTE] = ACTIONS(3651),
    [anon_sym_DQUOTE] = ACTIONS(3651),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [anon_sym_NULL] = ACTIONS(3649),
    [anon_sym_nullptr] = ACTIONS(3649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3649),
    [anon_sym_let] = ACTIONS(3649),
    [anon_sym_This] = ACTIONS(3649),
    [anon_sym_decltype] = ACTIONS(3649),
    [sym_virtual] = ACTIONS(3649),
    [anon_sym_explicit] = ACTIONS(3649),
    [anon_sym_typename] = ACTIONS(3649),
    [anon_sym_template] = ACTIONS(3649),
    [anon_sym_operator] = ACTIONS(3649),
    [anon_sym_try] = ACTIONS(3649),
    [anon_sym_delete] = ACTIONS(3649),
    [anon_sym_throw] = ACTIONS(3649),
    [anon_sym_namespace] = ACTIONS(3649),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_static_assert] = ACTIONS(3649),
    [anon_sym_concept] = ACTIONS(3649),
    [anon_sym_co_return] = ACTIONS(3649),
    [anon_sym_co_yield] = ACTIONS(3649),
    [anon_sym_R_DQUOTE] = ACTIONS(3651),
    [anon_sym_LR_DQUOTE] = ACTIONS(3651),
    [anon_sym_uR_DQUOTE] = ACTIONS(3651),
    [anon_sym_UR_DQUOTE] = ACTIONS(3651),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3651),
    [anon_sym_co_await] = ACTIONS(3649),
    [anon_sym_new] = ACTIONS(3649),
    [anon_sym_requires] = ACTIONS(3649),
    [sym_this] = ACTIONS(3649),
    [anon_sym_discard] = ACTIONS(3649),
    [anon_sym_precise] = ACTIONS(3649),
    [anon_sym_shared] = ACTIONS(3649),
    [anon_sym_groupshared] = ACTIONS(3649),
    [anon_sym_uniform] = ACTIONS(3649),
    [anon_sym_row_major] = ACTIONS(3649),
    [anon_sym_column_major] = ACTIONS(3649),
    [anon_sym_globallycoherent] = ACTIONS(3649),
    [anon_sym_centroid] = ACTIONS(3649),
    [anon_sym_noperspective] = ACTIONS(3649),
    [anon_sym_nointerpolation] = ACTIONS(3649),
    [anon_sym_sample] = ACTIONS(3649),
    [anon_sym_linear] = ACTIONS(3649),
    [anon_sym_snorm] = ACTIONS(3649),
    [anon_sym_unorm] = ACTIONS(3649),
    [anon_sym_point] = ACTIONS(3649),
    [anon_sym_line] = ACTIONS(3649),
    [anon_sym_triangleadj] = ACTIONS(3649),
    [anon_sym_lineadj] = ACTIONS(3649),
    [anon_sym_triangle] = ACTIONS(3649),
    [anon_sym_cbuffer] = ACTIONS(3649),
    [anon_sym_interface] = ACTIONS(3649),
    [anon_sym_extension] = ACTIONS(3649),
  },
  [991] = {
    [sym_attribute_specifier] = STATE(434),
    [ts_builtin_sym_end] = ACTIONS(3721),
    [sym_identifier] = ACTIONS(3719),
    [aux_sym_preproc_include_token1] = ACTIONS(3719),
    [aux_sym_preproc_def_token1] = ACTIONS(3719),
    [aux_sym_preproc_if_token1] = ACTIONS(3719),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3719),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3719),
    [sym_preproc_directive] = ACTIONS(3719),
    [anon_sym_LPAREN2] = ACTIONS(3721),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_TILDE] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3719),
    [anon_sym_SEMI] = ACTIONS(3721),
    [anon_sym___extension__] = ACTIONS(3719),
    [anon_sym_typedef] = ACTIONS(3719),
    [anon_sym_in] = ACTIONS(3719),
    [anon_sym_out] = ACTIONS(3719),
    [anon_sym_inout] = ACTIONS(3719),
    [anon_sym_extern] = ACTIONS(3719),
    [anon_sym___attribute__] = ACTIONS(2861),
    [anon_sym_COLON_COLON] = ACTIONS(3721),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3721),
    [anon_sym___declspec] = ACTIONS(3719),
    [anon_sym___based] = ACTIONS(3719),
    [anon_sym___cdecl] = ACTIONS(3719),
    [anon_sym___clrcall] = ACTIONS(3719),
    [anon_sym___stdcall] = ACTIONS(3719),
    [anon_sym___fastcall] = ACTIONS(3719),
    [anon_sym___thiscall] = ACTIONS(3719),
    [anon_sym___vectorcall] = ACTIONS(3719),
    [anon_sym_LBRACE] = ACTIONS(3721),
    [anon_sym_signed] = ACTIONS(3719),
    [anon_sym_unsigned] = ACTIONS(3719),
    [anon_sym_long] = ACTIONS(3719),
    [anon_sym_short] = ACTIONS(3719),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_static] = ACTIONS(3719),
    [anon_sym_register] = ACTIONS(3719),
    [anon_sym_inline] = ACTIONS(3719),
    [anon_sym___inline] = ACTIONS(3719),
    [anon_sym___inline__] = ACTIONS(3719),
    [anon_sym___forceinline] = ACTIONS(3719),
    [anon_sym_thread_local] = ACTIONS(3719),
    [anon_sym___thread] = ACTIONS(3719),
    [anon_sym_const] = ACTIONS(3719),
    [anon_sym_constexpr] = ACTIONS(3719),
    [anon_sym_volatile] = ACTIONS(3719),
    [anon_sym_restrict] = ACTIONS(3719),
    [anon_sym___restrict__] = ACTIONS(3719),
    [anon_sym__Atomic] = ACTIONS(3719),
    [anon_sym__Noreturn] = ACTIONS(3719),
    [anon_sym_noreturn] = ACTIONS(3719),
    [anon_sym_mutable] = ACTIONS(3719),
    [anon_sym_constinit] = ACTIONS(3719),
    [anon_sym_consteval] = ACTIONS(3719),
    [anon_sym_alignas] = ACTIONS(3719),
    [anon_sym__Alignas] = ACTIONS(3719),
    [sym_primitive_type] = ACTIONS(3719),
    [anon_sym_enum] = ACTIONS(3719),
    [anon_sym_class] = ACTIONS(3719),
    [anon_sym_struct] = ACTIONS(3719),
    [anon_sym_union] = ACTIONS(3719),
    [anon_sym_if] = ACTIONS(3719),
    [anon_sym_switch] = ACTIONS(3719),
    [anon_sym_case] = ACTIONS(3719),
    [anon_sym_default] = ACTIONS(3719),
    [anon_sym_while] = ACTIONS(3719),
    [anon_sym_do] = ACTIONS(3719),
    [anon_sym_for] = ACTIONS(3719),
    [anon_sym_return] = ACTIONS(3719),
    [anon_sym_break] = ACTIONS(3719),
    [anon_sym_continue] = ACTIONS(3719),
    [anon_sym_goto] = ACTIONS(3719),
    [anon_sym_not] = ACTIONS(3719),
    [anon_sym_compl] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3721),
    [anon_sym_sizeof] = ACTIONS(3719),
    [anon_sym___alignof__] = ACTIONS(3719),
    [anon_sym___alignof] = ACTIONS(3719),
    [anon_sym__alignof] = ACTIONS(3719),
    [anon_sym_alignof] = ACTIONS(3719),
    [anon_sym__Alignof] = ACTIONS(3719),
    [anon_sym_offsetof] = ACTIONS(3719),
    [anon_sym__Generic] = ACTIONS(3719),
    [anon_sym_asm] = ACTIONS(3719),
    [anon_sym___asm__] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3719),
    [sym_number_literal] = ACTIONS(3721),
    [anon_sym_L_SQUOTE] = ACTIONS(3721),
    [anon_sym_u_SQUOTE] = ACTIONS(3721),
    [anon_sym_U_SQUOTE] = ACTIONS(3721),
    [anon_sym_u8_SQUOTE] = ACTIONS(3721),
    [anon_sym_SQUOTE] = ACTIONS(3721),
    [anon_sym_L_DQUOTE] = ACTIONS(3721),
    [anon_sym_u_DQUOTE] = ACTIONS(3721),
    [anon_sym_U_DQUOTE] = ACTIONS(3721),
    [anon_sym_u8_DQUOTE] = ACTIONS(3721),
    [anon_sym_DQUOTE] = ACTIONS(3721),
    [sym_true] = ACTIONS(3719),
    [sym_false] = ACTIONS(3719),
    [anon_sym_NULL] = ACTIONS(3719),
    [anon_sym_nullptr] = ACTIONS(3719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3719),
    [anon_sym_let] = ACTIONS(3719),
    [anon_sym_This] = ACTIONS(3719),
    [anon_sym_decltype] = ACTIONS(3719),
    [sym_virtual] = ACTIONS(3719),
    [anon_sym_explicit] = ACTIONS(3719),
    [anon_sym_typename] = ACTIONS(3719),
    [anon_sym_template] = ACTIONS(3719),
    [anon_sym_operator] = ACTIONS(3719),
    [anon_sym_try] = ACTIONS(3719),
    [anon_sym_delete] = ACTIONS(3719),
    [anon_sym_throw] = ACTIONS(3719),
    [anon_sym_namespace] = ACTIONS(3719),
    [anon_sym_using] = ACTIONS(3719),
    [anon_sym_static_assert] = ACTIONS(3719),
    [anon_sym_concept] = ACTIONS(3719),
    [anon_sym_co_return] = ACTIONS(3719),
    [anon_sym_co_yield] = ACTIONS(3719),
    [anon_sym_R_DQUOTE] = ACTIONS(3721),
    [anon_sym_LR_DQUOTE] = ACTIONS(3721),
    [anon_sym_uR_DQUOTE] = ACTIONS(3721),
    [anon_sym_UR_DQUOTE] = ACTIONS(3721),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3721),
    [anon_sym_co_await] = ACTIONS(3719),
    [anon_sym_new] = ACTIONS(3719),
    [anon_sym_requires] = ACTIONS(3719),
    [sym_this] = ACTIONS(3719),
    [anon_sym_precise] = ACTIONS(3719),
    [anon_sym_shared] = ACTIONS(3719),
    [anon_sym_groupshared] = ACTIONS(3719),
    [anon_sym_uniform] = ACTIONS(3719),
    [anon_sym_row_major] = ACTIONS(3719),
    [anon_sym_column_major] = ACTIONS(3719),
    [anon_sym_globallycoherent] = ACTIONS(3719),
    [anon_sym_centroid] = ACTIONS(3719),
    [anon_sym_noperspective] = ACTIONS(3719),
    [anon_sym_nointerpolation] = ACTIONS(3719),
    [anon_sym_sample] = ACTIONS(3719),
    [anon_sym_linear] = ACTIONS(3719),
    [anon_sym_snorm] = ACTIONS(3719),
    [anon_sym_unorm] = ACTIONS(3719),
    [anon_sym_point] = ACTIONS(3719),
    [anon_sym_line] = ACTIONS(3719),
    [anon_sym_triangleadj] = ACTIONS(3719),
    [anon_sym_lineadj] = ACTIONS(3719),
    [anon_sym_triangle] = ACTIONS(3719),
    [anon_sym_interface] = ACTIONS(3719),
    [anon_sym_extension] = ACTIONS(3719),
    [anon_sym___exported] = ACTIONS(3719),
    [anon_sym_import] = ACTIONS(3719),
  },
  [992] = {
    [sym_identifier] = ACTIONS(3551),
    [aux_sym_preproc_include_token1] = ACTIONS(3551),
    [aux_sym_preproc_def_token1] = ACTIONS(3551),
    [aux_sym_preproc_if_token1] = ACTIONS(3551),
    [aux_sym_preproc_if_token2] = ACTIONS(3551),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3551),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3551),
    [sym_preproc_directive] = ACTIONS(3551),
    [anon_sym_LPAREN2] = ACTIONS(3553),
    [anon_sym_BANG] = ACTIONS(3553),
    [anon_sym_TILDE] = ACTIONS(3553),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_PLUS] = ACTIONS(3551),
    [anon_sym_STAR] = ACTIONS(3553),
    [anon_sym_AMP_AMP] = ACTIONS(3553),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_SEMI] = ACTIONS(3553),
    [anon_sym___extension__] = ACTIONS(3551),
    [anon_sym_typedef] = ACTIONS(3551),
    [anon_sym_in] = ACTIONS(3551),
    [anon_sym_out] = ACTIONS(3551),
    [anon_sym_inout] = ACTIONS(3551),
    [anon_sym_extern] = ACTIONS(3551),
    [anon_sym___attribute__] = ACTIONS(3551),
    [anon_sym_COLON_COLON] = ACTIONS(3553),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3553),
    [anon_sym___declspec] = ACTIONS(3551),
    [anon_sym___based] = ACTIONS(3551),
    [anon_sym___cdecl] = ACTIONS(3551),
    [anon_sym___clrcall] = ACTIONS(3551),
    [anon_sym___stdcall] = ACTIONS(3551),
    [anon_sym___fastcall] = ACTIONS(3551),
    [anon_sym___thiscall] = ACTIONS(3551),
    [anon_sym___vectorcall] = ACTIONS(3551),
    [anon_sym_LBRACE] = ACTIONS(3553),
    [anon_sym_signed] = ACTIONS(3551),
    [anon_sym_unsigned] = ACTIONS(3551),
    [anon_sym_long] = ACTIONS(3551),
    [anon_sym_short] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3551),
    [anon_sym_static] = ACTIONS(3551),
    [anon_sym_register] = ACTIONS(3551),
    [anon_sym_inline] = ACTIONS(3551),
    [anon_sym___inline] = ACTIONS(3551),
    [anon_sym___inline__] = ACTIONS(3551),
    [anon_sym___forceinline] = ACTIONS(3551),
    [anon_sym_thread_local] = ACTIONS(3551),
    [anon_sym___thread] = ACTIONS(3551),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_constexpr] = ACTIONS(3551),
    [anon_sym_volatile] = ACTIONS(3551),
    [anon_sym_restrict] = ACTIONS(3551),
    [anon_sym___restrict__] = ACTIONS(3551),
    [anon_sym__Atomic] = ACTIONS(3551),
    [anon_sym__Noreturn] = ACTIONS(3551),
    [anon_sym_noreturn] = ACTIONS(3551),
    [anon_sym_mutable] = ACTIONS(3551),
    [anon_sym_constinit] = ACTIONS(3551),
    [anon_sym_consteval] = ACTIONS(3551),
    [anon_sym_alignas] = ACTIONS(3551),
    [anon_sym__Alignas] = ACTIONS(3551),
    [sym_primitive_type] = ACTIONS(3551),
    [anon_sym_enum] = ACTIONS(3551),
    [anon_sym_class] = ACTIONS(3551),
    [anon_sym_struct] = ACTIONS(3551),
    [anon_sym_union] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(3551),
    [anon_sym_switch] = ACTIONS(3551),
    [anon_sym_case] = ACTIONS(3551),
    [anon_sym_default] = ACTIONS(3551),
    [anon_sym_while] = ACTIONS(3551),
    [anon_sym_do] = ACTIONS(3551),
    [anon_sym_for] = ACTIONS(3551),
    [anon_sym_return] = ACTIONS(3551),
    [anon_sym_break] = ACTIONS(3551),
    [anon_sym_continue] = ACTIONS(3551),
    [anon_sym_goto] = ACTIONS(3551),
    [anon_sym___try] = ACTIONS(3551),
    [anon_sym___leave] = ACTIONS(3551),
    [anon_sym_not] = ACTIONS(3551),
    [anon_sym_compl] = ACTIONS(3551),
    [anon_sym_DASH_DASH] = ACTIONS(3553),
    [anon_sym_PLUS_PLUS] = ACTIONS(3553),
    [anon_sym_sizeof] = ACTIONS(3551),
    [anon_sym___alignof__] = ACTIONS(3551),
    [anon_sym___alignof] = ACTIONS(3551),
    [anon_sym__alignof] = ACTIONS(3551),
    [anon_sym_alignof] = ACTIONS(3551),
    [anon_sym__Alignof] = ACTIONS(3551),
    [anon_sym_offsetof] = ACTIONS(3551),
    [anon_sym__Generic] = ACTIONS(3551),
    [anon_sym_asm] = ACTIONS(3551),
    [anon_sym___asm__] = ACTIONS(3551),
    [sym_number_literal] = ACTIONS(3553),
    [anon_sym_L_SQUOTE] = ACTIONS(3553),
    [anon_sym_u_SQUOTE] = ACTIONS(3553),
    [anon_sym_U_SQUOTE] = ACTIONS(3553),
    [anon_sym_u8_SQUOTE] = ACTIONS(3553),
    [anon_sym_SQUOTE] = ACTIONS(3553),
    [anon_sym_L_DQUOTE] = ACTIONS(3553),
    [anon_sym_u_DQUOTE] = ACTIONS(3553),
    [anon_sym_U_DQUOTE] = ACTIONS(3553),
    [anon_sym_u8_DQUOTE] = ACTIONS(3553),
    [anon_sym_DQUOTE] = ACTIONS(3553),
    [sym_true] = ACTIONS(3551),
    [sym_false] = ACTIONS(3551),
    [anon_sym_NULL] = ACTIONS(3551),
    [anon_sym_nullptr] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3551),
    [anon_sym_let] = ACTIONS(3551),
    [anon_sym_This] = ACTIONS(3551),
    [anon_sym_decltype] = ACTIONS(3551),
    [sym_virtual] = ACTIONS(3551),
    [anon_sym_explicit] = ACTIONS(3551),
    [anon_sym_typename] = ACTIONS(3551),
    [anon_sym_template] = ACTIONS(3551),
    [anon_sym_operator] = ACTIONS(3551),
    [anon_sym_try] = ACTIONS(3551),
    [anon_sym_delete] = ACTIONS(3551),
    [anon_sym_throw] = ACTIONS(3551),
    [anon_sym_namespace] = ACTIONS(3551),
    [anon_sym_using] = ACTIONS(3551),
    [anon_sym_static_assert] = ACTIONS(3551),
    [anon_sym_concept] = ACTIONS(3551),
    [anon_sym_co_return] = ACTIONS(3551),
    [anon_sym_co_yield] = ACTIONS(3551),
    [anon_sym_R_DQUOTE] = ACTIONS(3553),
    [anon_sym_LR_DQUOTE] = ACTIONS(3553),
    [anon_sym_uR_DQUOTE] = ACTIONS(3553),
    [anon_sym_UR_DQUOTE] = ACTIONS(3553),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3553),
    [anon_sym_co_await] = ACTIONS(3551),
    [anon_sym_new] = ACTIONS(3551),
    [anon_sym_requires] = ACTIONS(3551),
    [sym_this] = ACTIONS(3551),
    [anon_sym_discard] = ACTIONS(3551),
    [anon_sym_precise] = ACTIONS(3551),
    [anon_sym_shared] = ACTIONS(3551),
    [anon_sym_groupshared] = ACTIONS(3551),
    [anon_sym_uniform] = ACTIONS(3551),
    [anon_sym_row_major] = ACTIONS(3551),
    [anon_sym_column_major] = ACTIONS(3551),
    [anon_sym_globallycoherent] = ACTIONS(3551),
    [anon_sym_centroid] = ACTIONS(3551),
    [anon_sym_noperspective] = ACTIONS(3551),
    [anon_sym_nointerpolation] = ACTIONS(3551),
    [anon_sym_sample] = ACTIONS(3551),
    [anon_sym_linear] = ACTIONS(3551),
    [anon_sym_snorm] = ACTIONS(3551),
    [anon_sym_unorm] = ACTIONS(3551),
    [anon_sym_point] = ACTIONS(3551),
    [anon_sym_line] = ACTIONS(3551),
    [anon_sym_triangleadj] = ACTIONS(3551),
    [anon_sym_lineadj] = ACTIONS(3551),
    [anon_sym_triangle] = ACTIONS(3551),
    [anon_sym_cbuffer] = ACTIONS(3551),
    [anon_sym_interface] = ACTIONS(3551),
    [anon_sym_extension] = ACTIONS(3551),
  },
  [993] = {
    [ts_builtin_sym_end] = ACTIONS(3507),
    [sym_identifier] = ACTIONS(3505),
    [aux_sym_preproc_include_token1] = ACTIONS(3505),
    [aux_sym_preproc_def_token1] = ACTIONS(3505),
    [anon_sym_COMMA] = ACTIONS(3507),
    [aux_sym_preproc_if_token1] = ACTIONS(3505),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3505),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3505),
    [sym_preproc_directive] = ACTIONS(3505),
    [anon_sym_LPAREN2] = ACTIONS(3507),
    [anon_sym_BANG] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3505),
    [anon_sym_PLUS] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym___extension__] = ACTIONS(3505),
    [anon_sym_typedef] = ACTIONS(3505),
    [anon_sym_in] = ACTIONS(3505),
    [anon_sym_out] = ACTIONS(3505),
    [anon_sym_inout] = ACTIONS(3505),
    [anon_sym_extern] = ACTIONS(3505),
    [anon_sym___attribute__] = ACTIONS(3505),
    [anon_sym_COLON_COLON] = ACTIONS(3507),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3507),
    [anon_sym___declspec] = ACTIONS(3505),
    [anon_sym___based] = ACTIONS(3505),
    [anon_sym___cdecl] = ACTIONS(3505),
    [anon_sym___clrcall] = ACTIONS(3505),
    [anon_sym___stdcall] = ACTIONS(3505),
    [anon_sym___fastcall] = ACTIONS(3505),
    [anon_sym___thiscall] = ACTIONS(3505),
    [anon_sym___vectorcall] = ACTIONS(3505),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_RBRACE] = ACTIONS(3507),
    [anon_sym_signed] = ACTIONS(3505),
    [anon_sym_unsigned] = ACTIONS(3505),
    [anon_sym_long] = ACTIONS(3505),
    [anon_sym_short] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_static] = ACTIONS(3505),
    [anon_sym_register] = ACTIONS(3505),
    [anon_sym_inline] = ACTIONS(3505),
    [anon_sym___inline] = ACTIONS(3505),
    [anon_sym___inline__] = ACTIONS(3505),
    [anon_sym___forceinline] = ACTIONS(3505),
    [anon_sym_thread_local] = ACTIONS(3505),
    [anon_sym___thread] = ACTIONS(3505),
    [anon_sym_const] = ACTIONS(3505),
    [anon_sym_constexpr] = ACTIONS(3505),
    [anon_sym_volatile] = ACTIONS(3505),
    [anon_sym_restrict] = ACTIONS(3505),
    [anon_sym___restrict__] = ACTIONS(3505),
    [anon_sym__Atomic] = ACTIONS(3505),
    [anon_sym__Noreturn] = ACTIONS(3505),
    [anon_sym_noreturn] = ACTIONS(3505),
    [anon_sym_mutable] = ACTIONS(3505),
    [anon_sym_constinit] = ACTIONS(3505),
    [anon_sym_consteval] = ACTIONS(3505),
    [anon_sym_alignas] = ACTIONS(3505),
    [anon_sym__Alignas] = ACTIONS(3505),
    [sym_primitive_type] = ACTIONS(3505),
    [anon_sym_enum] = ACTIONS(3505),
    [anon_sym_class] = ACTIONS(3505),
    [anon_sym_struct] = ACTIONS(3505),
    [anon_sym_union] = ACTIONS(3505),
    [anon_sym_if] = ACTIONS(3505),
    [anon_sym_switch] = ACTIONS(3505),
    [anon_sym_case] = ACTIONS(3505),
    [anon_sym_default] = ACTIONS(3505),
    [anon_sym_while] = ACTIONS(3505),
    [anon_sym_do] = ACTIONS(3505),
    [anon_sym_for] = ACTIONS(3505),
    [anon_sym_return] = ACTIONS(3505),
    [anon_sym_break] = ACTIONS(3505),
    [anon_sym_continue] = ACTIONS(3505),
    [anon_sym_goto] = ACTIONS(3505),
    [anon_sym_not] = ACTIONS(3505),
    [anon_sym_compl] = ACTIONS(3505),
    [anon_sym_DASH_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_PLUS] = ACTIONS(3507),
    [anon_sym_sizeof] = ACTIONS(3505),
    [anon_sym___alignof__] = ACTIONS(3505),
    [anon_sym___alignof] = ACTIONS(3505),
    [anon_sym__alignof] = ACTIONS(3505),
    [anon_sym_alignof] = ACTIONS(3505),
    [anon_sym__Alignof] = ACTIONS(3505),
    [anon_sym_offsetof] = ACTIONS(3505),
    [anon_sym__Generic] = ACTIONS(3505),
    [anon_sym_asm] = ACTIONS(3505),
    [anon_sym___asm__] = ACTIONS(3505),
    [sym_number_literal] = ACTIONS(3507),
    [anon_sym_L_SQUOTE] = ACTIONS(3507),
    [anon_sym_u_SQUOTE] = ACTIONS(3507),
    [anon_sym_U_SQUOTE] = ACTIONS(3507),
    [anon_sym_u8_SQUOTE] = ACTIONS(3507),
    [anon_sym_SQUOTE] = ACTIONS(3507),
    [anon_sym_L_DQUOTE] = ACTIONS(3507),
    [anon_sym_u_DQUOTE] = ACTIONS(3507),
    [anon_sym_U_DQUOTE] = ACTIONS(3507),
    [anon_sym_u8_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [sym_true] = ACTIONS(3505),
    [sym_false] = ACTIONS(3505),
    [anon_sym_NULL] = ACTIONS(3505),
    [anon_sym_nullptr] = ACTIONS(3505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_This] = ACTIONS(3505),
    [anon_sym_decltype] = ACTIONS(3505),
    [sym_virtual] = ACTIONS(3505),
    [anon_sym_explicit] = ACTIONS(3505),
    [anon_sym_typename] = ACTIONS(3505),
    [anon_sym_template] = ACTIONS(3505),
    [anon_sym_operator] = ACTIONS(3505),
    [anon_sym_try] = ACTIONS(3505),
    [anon_sym_delete] = ACTIONS(3505),
    [anon_sym_throw] = ACTIONS(3505),
    [anon_sym_namespace] = ACTIONS(3505),
    [anon_sym_using] = ACTIONS(3505),
    [anon_sym_static_assert] = ACTIONS(3505),
    [anon_sym_concept] = ACTIONS(3505),
    [anon_sym_co_return] = ACTIONS(3505),
    [anon_sym_co_yield] = ACTIONS(3505),
    [anon_sym_R_DQUOTE] = ACTIONS(3507),
    [anon_sym_LR_DQUOTE] = ACTIONS(3507),
    [anon_sym_uR_DQUOTE] = ACTIONS(3507),
    [anon_sym_UR_DQUOTE] = ACTIONS(3507),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3507),
    [anon_sym_co_await] = ACTIONS(3505),
    [anon_sym_new] = ACTIONS(3505),
    [anon_sym_requires] = ACTIONS(3505),
    [sym_this] = ACTIONS(3505),
    [anon_sym_precise] = ACTIONS(3505),
    [anon_sym_shared] = ACTIONS(3505),
    [anon_sym_groupshared] = ACTIONS(3505),
    [anon_sym_uniform] = ACTIONS(3505),
    [anon_sym_row_major] = ACTIONS(3505),
    [anon_sym_column_major] = ACTIONS(3505),
    [anon_sym_globallycoherent] = ACTIONS(3505),
    [anon_sym_centroid] = ACTIONS(3505),
    [anon_sym_noperspective] = ACTIONS(3505),
    [anon_sym_nointerpolation] = ACTIONS(3505),
    [anon_sym_sample] = ACTIONS(3505),
    [anon_sym_linear] = ACTIONS(3505),
    [anon_sym_snorm] = ACTIONS(3505),
    [anon_sym_unorm] = ACTIONS(3505),
    [anon_sym_point] = ACTIONS(3505),
    [anon_sym_line] = ACTIONS(3505),
    [anon_sym_triangleadj] = ACTIONS(3505),
    [anon_sym_lineadj] = ACTIONS(3505),
    [anon_sym_triangle] = ACTIONS(3505),
    [anon_sym_interface] = ACTIONS(3505),
    [anon_sym_extension] = ACTIONS(3505),
    [anon_sym___exported] = ACTIONS(3505),
    [anon_sym_import] = ACTIONS(3505),
  },
  [994] = {
    [ts_builtin_sym_end] = ACTIONS(3846),
    [sym_identifier] = ACTIONS(3844),
    [aux_sym_preproc_include_token1] = ACTIONS(3844),
    [aux_sym_preproc_def_token1] = ACTIONS(3844),
    [aux_sym_preproc_if_token1] = ACTIONS(3844),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3844),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3844),
    [sym_preproc_directive] = ACTIONS(3844),
    [anon_sym_LPAREN2] = ACTIONS(3846),
    [anon_sym_BANG] = ACTIONS(3846),
    [anon_sym_TILDE] = ACTIONS(3846),
    [anon_sym_DASH] = ACTIONS(3844),
    [anon_sym_PLUS] = ACTIONS(3844),
    [anon_sym_STAR] = ACTIONS(3846),
    [anon_sym_AMP_AMP] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3844),
    [anon_sym_SEMI] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(3844),
    [anon_sym_typedef] = ACTIONS(3844),
    [anon_sym_in] = ACTIONS(3844),
    [anon_sym_out] = ACTIONS(3844),
    [anon_sym_inout] = ACTIONS(3844),
    [anon_sym_extern] = ACTIONS(3844),
    [anon_sym___attribute__] = ACTIONS(3844),
    [anon_sym_COLON_COLON] = ACTIONS(3846),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3846),
    [anon_sym___declspec] = ACTIONS(3844),
    [anon_sym___based] = ACTIONS(3844),
    [anon_sym___cdecl] = ACTIONS(3844),
    [anon_sym___clrcall] = ACTIONS(3844),
    [anon_sym___stdcall] = ACTIONS(3844),
    [anon_sym___fastcall] = ACTIONS(3844),
    [anon_sym___thiscall] = ACTIONS(3844),
    [anon_sym___vectorcall] = ACTIONS(3844),
    [anon_sym_LBRACE] = ACTIONS(3846),
    [anon_sym_signed] = ACTIONS(3844),
    [anon_sym_unsigned] = ACTIONS(3844),
    [anon_sym_long] = ACTIONS(3844),
    [anon_sym_short] = ACTIONS(3844),
    [anon_sym_LBRACK] = ACTIONS(3844),
    [anon_sym_static] = ACTIONS(3844),
    [anon_sym_register] = ACTIONS(3844),
    [anon_sym_inline] = ACTIONS(3844),
    [anon_sym___inline] = ACTIONS(3844),
    [anon_sym___inline__] = ACTIONS(3844),
    [anon_sym___forceinline] = ACTIONS(3844),
    [anon_sym_thread_local] = ACTIONS(3844),
    [anon_sym___thread] = ACTIONS(3844),
    [anon_sym_const] = ACTIONS(3844),
    [anon_sym_constexpr] = ACTIONS(3844),
    [anon_sym_volatile] = ACTIONS(3844),
    [anon_sym_restrict] = ACTIONS(3844),
    [anon_sym___restrict__] = ACTIONS(3844),
    [anon_sym__Atomic] = ACTIONS(3844),
    [anon_sym__Noreturn] = ACTIONS(3844),
    [anon_sym_noreturn] = ACTIONS(3844),
    [anon_sym_mutable] = ACTIONS(3844),
    [anon_sym_constinit] = ACTIONS(3844),
    [anon_sym_consteval] = ACTIONS(3844),
    [anon_sym_alignas] = ACTIONS(3844),
    [anon_sym__Alignas] = ACTIONS(3844),
    [sym_primitive_type] = ACTIONS(3844),
    [anon_sym_enum] = ACTIONS(3844),
    [anon_sym_class] = ACTIONS(3844),
    [anon_sym_struct] = ACTIONS(3844),
    [anon_sym_union] = ACTIONS(3844),
    [anon_sym_if] = ACTIONS(3844),
    [anon_sym_switch] = ACTIONS(3844),
    [anon_sym_case] = ACTIONS(3844),
    [anon_sym_default] = ACTIONS(3844),
    [anon_sym_while] = ACTIONS(3844),
    [anon_sym_do] = ACTIONS(3844),
    [anon_sym_for] = ACTIONS(3844),
    [anon_sym_return] = ACTIONS(3844),
    [anon_sym_break] = ACTIONS(3844),
    [anon_sym_continue] = ACTIONS(3844),
    [anon_sym_goto] = ACTIONS(3844),
    [anon_sym_not] = ACTIONS(3844),
    [anon_sym_compl] = ACTIONS(3844),
    [anon_sym_DASH_DASH] = ACTIONS(3846),
    [anon_sym_PLUS_PLUS] = ACTIONS(3846),
    [anon_sym_sizeof] = ACTIONS(3844),
    [anon_sym___alignof__] = ACTIONS(3844),
    [anon_sym___alignof] = ACTIONS(3844),
    [anon_sym__alignof] = ACTIONS(3844),
    [anon_sym_alignof] = ACTIONS(3844),
    [anon_sym__Alignof] = ACTIONS(3844),
    [anon_sym_offsetof] = ACTIONS(3844),
    [anon_sym__Generic] = ACTIONS(3844),
    [anon_sym_asm] = ACTIONS(3844),
    [anon_sym___asm__] = ACTIONS(3844),
    [anon_sym_DOT] = ACTIONS(3844),
    [sym_number_literal] = ACTIONS(3846),
    [anon_sym_L_SQUOTE] = ACTIONS(3846),
    [anon_sym_u_SQUOTE] = ACTIONS(3846),
    [anon_sym_U_SQUOTE] = ACTIONS(3846),
    [anon_sym_u8_SQUOTE] = ACTIONS(3846),
    [anon_sym_SQUOTE] = ACTIONS(3846),
    [anon_sym_L_DQUOTE] = ACTIONS(3846),
    [anon_sym_u_DQUOTE] = ACTIONS(3846),
    [anon_sym_U_DQUOTE] = ACTIONS(3846),
    [anon_sym_u8_DQUOTE] = ACTIONS(3846),
    [anon_sym_DQUOTE] = ACTIONS(3846),
    [sym_true] = ACTIONS(3844),
    [sym_false] = ACTIONS(3844),
    [anon_sym_NULL] = ACTIONS(3844),
    [anon_sym_nullptr] = ACTIONS(3844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3844),
    [anon_sym_let] = ACTIONS(3844),
    [anon_sym_This] = ACTIONS(3844),
    [anon_sym_decltype] = ACTIONS(3844),
    [sym_virtual] = ACTIONS(3844),
    [anon_sym_explicit] = ACTIONS(3844),
    [anon_sym_typename] = ACTIONS(3844),
    [anon_sym_template] = ACTIONS(3844),
    [anon_sym_operator] = ACTIONS(3844),
    [anon_sym_try] = ACTIONS(3844),
    [anon_sym_delete] = ACTIONS(3844),
    [anon_sym_throw] = ACTIONS(3844),
    [anon_sym_namespace] = ACTIONS(3844),
    [anon_sym_using] = ACTIONS(3844),
    [anon_sym_static_assert] = ACTIONS(3844),
    [anon_sym_concept] = ACTIONS(3844),
    [anon_sym_co_return] = ACTIONS(3844),
    [anon_sym_co_yield] = ACTIONS(3844),
    [anon_sym_R_DQUOTE] = ACTIONS(3846),
    [anon_sym_LR_DQUOTE] = ACTIONS(3846),
    [anon_sym_uR_DQUOTE] = ACTIONS(3846),
    [anon_sym_UR_DQUOTE] = ACTIONS(3846),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3846),
    [anon_sym_co_await] = ACTIONS(3844),
    [anon_sym_new] = ACTIONS(3844),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3844),
    [anon_sym_precise] = ACTIONS(3844),
    [anon_sym_shared] = ACTIONS(3844),
    [anon_sym_groupshared] = ACTIONS(3844),
    [anon_sym_uniform] = ACTIONS(3844),
    [anon_sym_row_major] = ACTIONS(3844),
    [anon_sym_column_major] = ACTIONS(3844),
    [anon_sym_globallycoherent] = ACTIONS(3844),
    [anon_sym_centroid] = ACTIONS(3844),
    [anon_sym_noperspective] = ACTIONS(3844),
    [anon_sym_nointerpolation] = ACTIONS(3844),
    [anon_sym_sample] = ACTIONS(3844),
    [anon_sym_linear] = ACTIONS(3844),
    [anon_sym_snorm] = ACTIONS(3844),
    [anon_sym_unorm] = ACTIONS(3844),
    [anon_sym_point] = ACTIONS(3844),
    [anon_sym_line] = ACTIONS(3844),
    [anon_sym_triangleadj] = ACTIONS(3844),
    [anon_sym_lineadj] = ACTIONS(3844),
    [anon_sym_triangle] = ACTIONS(3844),
    [anon_sym_interface] = ACTIONS(3844),
    [anon_sym_extension] = ACTIONS(3844),
    [anon_sym___exported] = ACTIONS(3844),
    [anon_sym_import] = ACTIONS(3844),
  },
  [995] = {
    [ts_builtin_sym_end] = ACTIONS(2740),
    [sym_identifier] = ACTIONS(2742),
    [aux_sym_preproc_include_token1] = ACTIONS(2742),
    [aux_sym_preproc_def_token1] = ACTIONS(2742),
    [aux_sym_preproc_if_token1] = ACTIONS(2742),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2742),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2742),
    [sym_preproc_directive] = ACTIONS(2742),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_BANG] = ACTIONS(2740),
    [anon_sym_TILDE] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2742),
    [anon_sym_PLUS] = ACTIONS(2742),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym___extension__] = ACTIONS(2742),
    [anon_sym_typedef] = ACTIONS(2742),
    [anon_sym_in] = ACTIONS(2742),
    [anon_sym_out] = ACTIONS(2742),
    [anon_sym_inout] = ACTIONS(2742),
    [anon_sym_extern] = ACTIONS(2742),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2740),
    [anon_sym___declspec] = ACTIONS(2742),
    [anon_sym___based] = ACTIONS(2742),
    [anon_sym___cdecl] = ACTIONS(2742),
    [anon_sym___clrcall] = ACTIONS(2742),
    [anon_sym___stdcall] = ACTIONS(2742),
    [anon_sym___fastcall] = ACTIONS(2742),
    [anon_sym___thiscall] = ACTIONS(2742),
    [anon_sym___vectorcall] = ACTIONS(2742),
    [anon_sym_LBRACE] = ACTIONS(3911),
    [anon_sym_signed] = ACTIONS(2742),
    [anon_sym_unsigned] = ACTIONS(2742),
    [anon_sym_long] = ACTIONS(2742),
    [anon_sym_short] = ACTIONS(2742),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2742),
    [anon_sym_register] = ACTIONS(2742),
    [anon_sym_inline] = ACTIONS(2742),
    [anon_sym___inline] = ACTIONS(2742),
    [anon_sym___inline__] = ACTIONS(2742),
    [anon_sym___forceinline] = ACTIONS(2742),
    [anon_sym_thread_local] = ACTIONS(2742),
    [anon_sym___thread] = ACTIONS(2742),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_constexpr] = ACTIONS(2742),
    [anon_sym_volatile] = ACTIONS(2742),
    [anon_sym_restrict] = ACTIONS(2742),
    [anon_sym___restrict__] = ACTIONS(2742),
    [anon_sym__Atomic] = ACTIONS(2742),
    [anon_sym__Noreturn] = ACTIONS(2742),
    [anon_sym_noreturn] = ACTIONS(2742),
    [anon_sym_mutable] = ACTIONS(2742),
    [anon_sym_constinit] = ACTIONS(2742),
    [anon_sym_consteval] = ACTIONS(2742),
    [anon_sym_alignas] = ACTIONS(2742),
    [anon_sym__Alignas] = ACTIONS(2742),
    [sym_primitive_type] = ACTIONS(2742),
    [anon_sym_enum] = ACTIONS(2742),
    [anon_sym_class] = ACTIONS(2742),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2742),
    [anon_sym_if] = ACTIONS(2742),
    [anon_sym_switch] = ACTIONS(2742),
    [anon_sym_case] = ACTIONS(2742),
    [anon_sym_default] = ACTIONS(2742),
    [anon_sym_while] = ACTIONS(2742),
    [anon_sym_do] = ACTIONS(2742),
    [anon_sym_for] = ACTIONS(2742),
    [anon_sym_return] = ACTIONS(2742),
    [anon_sym_break] = ACTIONS(2742),
    [anon_sym_continue] = ACTIONS(2742),
    [anon_sym_goto] = ACTIONS(2742),
    [anon_sym_not] = ACTIONS(2742),
    [anon_sym_compl] = ACTIONS(2742),
    [anon_sym_DASH_DASH] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2740),
    [anon_sym_sizeof] = ACTIONS(2742),
    [anon_sym___alignof__] = ACTIONS(2742),
    [anon_sym___alignof] = ACTIONS(2742),
    [anon_sym__alignof] = ACTIONS(2742),
    [anon_sym_alignof] = ACTIONS(2742),
    [anon_sym__Alignof] = ACTIONS(2742),
    [anon_sym_offsetof] = ACTIONS(2742),
    [anon_sym__Generic] = ACTIONS(2742),
    [anon_sym_asm] = ACTIONS(2742),
    [anon_sym___asm__] = ACTIONS(2742),
    [anon_sym_DOT] = ACTIONS(2742),
    [sym_number_literal] = ACTIONS(2740),
    [anon_sym_L_SQUOTE] = ACTIONS(2740),
    [anon_sym_u_SQUOTE] = ACTIONS(2740),
    [anon_sym_U_SQUOTE] = ACTIONS(2740),
    [anon_sym_u8_SQUOTE] = ACTIONS(2740),
    [anon_sym_SQUOTE] = ACTIONS(2740),
    [anon_sym_L_DQUOTE] = ACTIONS(2740),
    [anon_sym_u_DQUOTE] = ACTIONS(2740),
    [anon_sym_U_DQUOTE] = ACTIONS(2740),
    [anon_sym_u8_DQUOTE] = ACTIONS(2740),
    [anon_sym_DQUOTE] = ACTIONS(2740),
    [sym_true] = ACTIONS(2742),
    [sym_false] = ACTIONS(2742),
    [anon_sym_NULL] = ACTIONS(2742),
    [anon_sym_nullptr] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
    [anon_sym_decltype] = ACTIONS(2742),
    [sym_virtual] = ACTIONS(2742),
    [anon_sym_explicit] = ACTIONS(2742),
    [anon_sym_typename] = ACTIONS(2742),
    [anon_sym_template] = ACTIONS(2742),
    [anon_sym_operator] = ACTIONS(2742),
    [anon_sym_try] = ACTIONS(2742),
    [anon_sym_delete] = ACTIONS(2742),
    [anon_sym_throw] = ACTIONS(2742),
    [anon_sym_namespace] = ACTIONS(2742),
    [anon_sym_using] = ACTIONS(2742),
    [anon_sym_static_assert] = ACTIONS(2742),
    [anon_sym_concept] = ACTIONS(2742),
    [anon_sym_co_return] = ACTIONS(2742),
    [anon_sym_co_yield] = ACTIONS(2742),
    [anon_sym_R_DQUOTE] = ACTIONS(2740),
    [anon_sym_LR_DQUOTE] = ACTIONS(2740),
    [anon_sym_uR_DQUOTE] = ACTIONS(2740),
    [anon_sym_UR_DQUOTE] = ACTIONS(2740),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2740),
    [anon_sym_co_await] = ACTIONS(2742),
    [anon_sym_new] = ACTIONS(2742),
    [anon_sym_requires] = ACTIONS(2742),
    [sym_this] = ACTIONS(2742),
    [anon_sym_precise] = ACTIONS(2742),
    [anon_sym_shared] = ACTIONS(2742),
    [anon_sym_groupshared] = ACTIONS(2742),
    [anon_sym_uniform] = ACTIONS(2742),
    [anon_sym_row_major] = ACTIONS(2742),
    [anon_sym_column_major] = ACTIONS(2742),
    [anon_sym_globallycoherent] = ACTIONS(2742),
    [anon_sym_centroid] = ACTIONS(2742),
    [anon_sym_noperspective] = ACTIONS(2742),
    [anon_sym_nointerpolation] = ACTIONS(2742),
    [anon_sym_sample] = ACTIONS(2742),
    [anon_sym_linear] = ACTIONS(2742),
    [anon_sym_snorm] = ACTIONS(2742),
    [anon_sym_unorm] = ACTIONS(2742),
    [anon_sym_point] = ACTIONS(2742),
    [anon_sym_line] = ACTIONS(2742),
    [anon_sym_triangleadj] = ACTIONS(2742),
    [anon_sym_lineadj] = ACTIONS(2742),
    [anon_sym_triangle] = ACTIONS(2742),
    [anon_sym_interface] = ACTIONS(2742),
    [anon_sym_extension] = ACTIONS(2742),
    [anon_sym___exported] = ACTIONS(2742),
    [anon_sym_import] = ACTIONS(2742),
  },
  [996] = {
    [ts_builtin_sym_end] = ACTIONS(2740),
    [sym_identifier] = ACTIONS(2742),
    [aux_sym_preproc_include_token1] = ACTIONS(2742),
    [aux_sym_preproc_def_token1] = ACTIONS(2742),
    [aux_sym_preproc_if_token1] = ACTIONS(2742),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2742),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2742),
    [sym_preproc_directive] = ACTIONS(2742),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_BANG] = ACTIONS(2740),
    [anon_sym_TILDE] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2742),
    [anon_sym_PLUS] = ACTIONS(2742),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym___extension__] = ACTIONS(2742),
    [anon_sym_typedef] = ACTIONS(2742),
    [anon_sym_in] = ACTIONS(2742),
    [anon_sym_out] = ACTIONS(2742),
    [anon_sym_inout] = ACTIONS(2742),
    [anon_sym_extern] = ACTIONS(2742),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym_COLON_COLON] = ACTIONS(2740),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2740),
    [anon_sym___declspec] = ACTIONS(2742),
    [anon_sym___based] = ACTIONS(2742),
    [anon_sym___cdecl] = ACTIONS(2742),
    [anon_sym___clrcall] = ACTIONS(2742),
    [anon_sym___stdcall] = ACTIONS(2742),
    [anon_sym___fastcall] = ACTIONS(2742),
    [anon_sym___thiscall] = ACTIONS(2742),
    [anon_sym___vectorcall] = ACTIONS(2742),
    [anon_sym_LBRACE] = ACTIONS(3911),
    [anon_sym_signed] = ACTIONS(2742),
    [anon_sym_unsigned] = ACTIONS(2742),
    [anon_sym_long] = ACTIONS(2742),
    [anon_sym_short] = ACTIONS(2742),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2742),
    [anon_sym_register] = ACTIONS(2742),
    [anon_sym_inline] = ACTIONS(2742),
    [anon_sym___inline] = ACTIONS(2742),
    [anon_sym___inline__] = ACTIONS(2742),
    [anon_sym___forceinline] = ACTIONS(2742),
    [anon_sym_thread_local] = ACTIONS(2742),
    [anon_sym___thread] = ACTIONS(2742),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_constexpr] = ACTIONS(2742),
    [anon_sym_volatile] = ACTIONS(2742),
    [anon_sym_restrict] = ACTIONS(2742),
    [anon_sym___restrict__] = ACTIONS(2742),
    [anon_sym__Atomic] = ACTIONS(2742),
    [anon_sym__Noreturn] = ACTIONS(2742),
    [anon_sym_noreturn] = ACTIONS(2742),
    [anon_sym_mutable] = ACTIONS(2742),
    [anon_sym_constinit] = ACTIONS(2742),
    [anon_sym_consteval] = ACTIONS(2742),
    [anon_sym_alignas] = ACTIONS(2742),
    [anon_sym__Alignas] = ACTIONS(2742),
    [sym_primitive_type] = ACTIONS(2742),
    [anon_sym_enum] = ACTIONS(2742),
    [anon_sym_class] = ACTIONS(2742),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2742),
    [anon_sym_if] = ACTIONS(2742),
    [anon_sym_switch] = ACTIONS(2742),
    [anon_sym_case] = ACTIONS(2742),
    [anon_sym_default] = ACTIONS(2742),
    [anon_sym_while] = ACTIONS(2742),
    [anon_sym_do] = ACTIONS(2742),
    [anon_sym_for] = ACTIONS(2742),
    [anon_sym_return] = ACTIONS(2742),
    [anon_sym_break] = ACTIONS(2742),
    [anon_sym_continue] = ACTIONS(2742),
    [anon_sym_goto] = ACTIONS(2742),
    [anon_sym_not] = ACTIONS(2742),
    [anon_sym_compl] = ACTIONS(2742),
    [anon_sym_DASH_DASH] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2740),
    [anon_sym_sizeof] = ACTIONS(2742),
    [anon_sym___alignof__] = ACTIONS(2742),
    [anon_sym___alignof] = ACTIONS(2742),
    [anon_sym__alignof] = ACTIONS(2742),
    [anon_sym_alignof] = ACTIONS(2742),
    [anon_sym__Alignof] = ACTIONS(2742),
    [anon_sym_offsetof] = ACTIONS(2742),
    [anon_sym__Generic] = ACTIONS(2742),
    [anon_sym_asm] = ACTIONS(2742),
    [anon_sym___asm__] = ACTIONS(2742),
    [anon_sym_DOT] = ACTIONS(2742),
    [sym_number_literal] = ACTIONS(2740),
    [anon_sym_L_SQUOTE] = ACTIONS(2740),
    [anon_sym_u_SQUOTE] = ACTIONS(2740),
    [anon_sym_U_SQUOTE] = ACTIONS(2740),
    [anon_sym_u8_SQUOTE] = ACTIONS(2740),
    [anon_sym_SQUOTE] = ACTIONS(2740),
    [anon_sym_L_DQUOTE] = ACTIONS(2740),
    [anon_sym_u_DQUOTE] = ACTIONS(2740),
    [anon_sym_U_DQUOTE] = ACTIONS(2740),
    [anon_sym_u8_DQUOTE] = ACTIONS(2740),
    [anon_sym_DQUOTE] = ACTIONS(2740),
    [sym_true] = ACTIONS(2742),
    [sym_false] = ACTIONS(2742),
    [anon_sym_NULL] = ACTIONS(2742),
    [anon_sym_nullptr] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
    [anon_sym_decltype] = ACTIONS(2742),
    [sym_virtual] = ACTIONS(2742),
    [anon_sym_explicit] = ACTIONS(2742),
    [anon_sym_typename] = ACTIONS(2742),
    [anon_sym_template] = ACTIONS(2742),
    [anon_sym_operator] = ACTIONS(2742),
    [anon_sym_try] = ACTIONS(2742),
    [anon_sym_delete] = ACTIONS(2742),
    [anon_sym_throw] = ACTIONS(2742),
    [anon_sym_namespace] = ACTIONS(2742),
    [anon_sym_using] = ACTIONS(2742),
    [anon_sym_static_assert] = ACTIONS(2742),
    [anon_sym_concept] = ACTIONS(2742),
    [anon_sym_co_return] = ACTIONS(2742),
    [anon_sym_co_yield] = ACTIONS(2742),
    [anon_sym_R_DQUOTE] = ACTIONS(2740),
    [anon_sym_LR_DQUOTE] = ACTIONS(2740),
    [anon_sym_uR_DQUOTE] = ACTIONS(2740),
    [anon_sym_UR_DQUOTE] = ACTIONS(2740),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2740),
    [anon_sym_co_await] = ACTIONS(2742),
    [anon_sym_new] = ACTIONS(2742),
    [anon_sym_requires] = ACTIONS(2742),
    [sym_this] = ACTIONS(2742),
    [anon_sym_precise] = ACTIONS(2742),
    [anon_sym_shared] = ACTIONS(2742),
    [anon_sym_groupshared] = ACTIONS(2742),
    [anon_sym_uniform] = ACTIONS(2742),
    [anon_sym_row_major] = ACTIONS(2742),
    [anon_sym_column_major] = ACTIONS(2742),
    [anon_sym_globallycoherent] = ACTIONS(2742),
    [anon_sym_centroid] = ACTIONS(2742),
    [anon_sym_noperspective] = ACTIONS(2742),
    [anon_sym_nointerpolation] = ACTIONS(2742),
    [anon_sym_sample] = ACTIONS(2742),
    [anon_sym_linear] = ACTIONS(2742),
    [anon_sym_snorm] = ACTIONS(2742),
    [anon_sym_unorm] = ACTIONS(2742),
    [anon_sym_point] = ACTIONS(2742),
    [anon_sym_line] = ACTIONS(2742),
    [anon_sym_triangleadj] = ACTIONS(2742),
    [anon_sym_lineadj] = ACTIONS(2742),
    [anon_sym_triangle] = ACTIONS(2742),
    [anon_sym_interface] = ACTIONS(2742),
    [anon_sym_extension] = ACTIONS(2742),
    [anon_sym___exported] = ACTIONS(2742),
    [anon_sym_import] = ACTIONS(2742),
  },
  [997] = {
    [ts_builtin_sym_end] = ACTIONS(3892),
    [sym_identifier] = ACTIONS(3890),
    [aux_sym_preproc_include_token1] = ACTIONS(3890),
    [aux_sym_preproc_def_token1] = ACTIONS(3890),
    [aux_sym_preproc_if_token1] = ACTIONS(3890),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3890),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3890),
    [sym_preproc_directive] = ACTIONS(3890),
    [anon_sym_LPAREN2] = ACTIONS(3892),
    [anon_sym_BANG] = ACTIONS(3892),
    [anon_sym_TILDE] = ACTIONS(3892),
    [anon_sym_DASH] = ACTIONS(3890),
    [anon_sym_PLUS] = ACTIONS(3890),
    [anon_sym_STAR] = ACTIONS(3892),
    [anon_sym_AMP_AMP] = ACTIONS(3892),
    [anon_sym_AMP] = ACTIONS(3890),
    [anon_sym_SEMI] = ACTIONS(3892),
    [anon_sym___extension__] = ACTIONS(3890),
    [anon_sym_typedef] = ACTIONS(3890),
    [anon_sym_in] = ACTIONS(3890),
    [anon_sym_out] = ACTIONS(3890),
    [anon_sym_inout] = ACTIONS(3890),
    [anon_sym_extern] = ACTIONS(3890),
    [anon_sym___attribute__] = ACTIONS(3890),
    [anon_sym_COLON_COLON] = ACTIONS(3892),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3892),
    [anon_sym___declspec] = ACTIONS(3890),
    [anon_sym___based] = ACTIONS(3890),
    [anon_sym___cdecl] = ACTIONS(3890),
    [anon_sym___clrcall] = ACTIONS(3890),
    [anon_sym___stdcall] = ACTIONS(3890),
    [anon_sym___fastcall] = ACTIONS(3890),
    [anon_sym___thiscall] = ACTIONS(3890),
    [anon_sym___vectorcall] = ACTIONS(3890),
    [anon_sym_LBRACE] = ACTIONS(3892),
    [anon_sym_signed] = ACTIONS(3890),
    [anon_sym_unsigned] = ACTIONS(3890),
    [anon_sym_long] = ACTIONS(3890),
    [anon_sym_short] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3890),
    [anon_sym_static] = ACTIONS(3890),
    [anon_sym_register] = ACTIONS(3890),
    [anon_sym_inline] = ACTIONS(3890),
    [anon_sym___inline] = ACTIONS(3890),
    [anon_sym___inline__] = ACTIONS(3890),
    [anon_sym___forceinline] = ACTIONS(3890),
    [anon_sym_thread_local] = ACTIONS(3890),
    [anon_sym___thread] = ACTIONS(3890),
    [anon_sym_const] = ACTIONS(3890),
    [anon_sym_constexpr] = ACTIONS(3890),
    [anon_sym_volatile] = ACTIONS(3890),
    [anon_sym_restrict] = ACTIONS(3890),
    [anon_sym___restrict__] = ACTIONS(3890),
    [anon_sym__Atomic] = ACTIONS(3890),
    [anon_sym__Noreturn] = ACTIONS(3890),
    [anon_sym_noreturn] = ACTIONS(3890),
    [anon_sym_mutable] = ACTIONS(3890),
    [anon_sym_constinit] = ACTIONS(3890),
    [anon_sym_consteval] = ACTIONS(3890),
    [anon_sym_alignas] = ACTIONS(3890),
    [anon_sym__Alignas] = ACTIONS(3890),
    [sym_primitive_type] = ACTIONS(3890),
    [anon_sym_enum] = ACTIONS(3890),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_struct] = ACTIONS(3890),
    [anon_sym_union] = ACTIONS(3890),
    [anon_sym_if] = ACTIONS(3890),
    [anon_sym_switch] = ACTIONS(3890),
    [anon_sym_case] = ACTIONS(3890),
    [anon_sym_default] = ACTIONS(3890),
    [anon_sym_while] = ACTIONS(3890),
    [anon_sym_do] = ACTIONS(3890),
    [anon_sym_for] = ACTIONS(3890),
    [anon_sym_return] = ACTIONS(3890),
    [anon_sym_break] = ACTIONS(3890),
    [anon_sym_continue] = ACTIONS(3890),
    [anon_sym_goto] = ACTIONS(3890),
    [anon_sym_not] = ACTIONS(3890),
    [anon_sym_compl] = ACTIONS(3890),
    [anon_sym_DASH_DASH] = ACTIONS(3892),
    [anon_sym_PLUS_PLUS] = ACTIONS(3892),
    [anon_sym_sizeof] = ACTIONS(3890),
    [anon_sym___alignof__] = ACTIONS(3890),
    [anon_sym___alignof] = ACTIONS(3890),
    [anon_sym__alignof] = ACTIONS(3890),
    [anon_sym_alignof] = ACTIONS(3890),
    [anon_sym__Alignof] = ACTIONS(3890),
    [anon_sym_offsetof] = ACTIONS(3890),
    [anon_sym__Generic] = ACTIONS(3890),
    [anon_sym_asm] = ACTIONS(3890),
    [anon_sym___asm__] = ACTIONS(3890),
    [anon_sym_DOT] = ACTIONS(2724),
    [sym_number_literal] = ACTIONS(3892),
    [anon_sym_L_SQUOTE] = ACTIONS(3892),
    [anon_sym_u_SQUOTE] = ACTIONS(3892),
    [anon_sym_U_SQUOTE] = ACTIONS(3892),
    [anon_sym_u8_SQUOTE] = ACTIONS(3892),
    [anon_sym_SQUOTE] = ACTIONS(3892),
    [anon_sym_L_DQUOTE] = ACTIONS(3892),
    [anon_sym_u_DQUOTE] = ACTIONS(3892),
    [anon_sym_U_DQUOTE] = ACTIONS(3892),
    [anon_sym_u8_DQUOTE] = ACTIONS(3892),
    [anon_sym_DQUOTE] = ACTIONS(3892),
    [sym_true] = ACTIONS(3890),
    [sym_false] = ACTIONS(3890),
    [anon_sym_NULL] = ACTIONS(3890),
    [anon_sym_nullptr] = ACTIONS(3890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2726),
    [anon_sym_let] = ACTIONS(2726),
    [anon_sym_This] = ACTIONS(2726),
    [anon_sym_decltype] = ACTIONS(3890),
    [sym_virtual] = ACTIONS(3890),
    [anon_sym_explicit] = ACTIONS(3890),
    [anon_sym_typename] = ACTIONS(3890),
    [anon_sym_template] = ACTIONS(3890),
    [anon_sym_operator] = ACTIONS(3890),
    [anon_sym_try] = ACTIONS(3890),
    [anon_sym_delete] = ACTIONS(3890),
    [anon_sym_throw] = ACTIONS(3890),
    [anon_sym_namespace] = ACTIONS(3890),
    [anon_sym_using] = ACTIONS(3890),
    [anon_sym_static_assert] = ACTIONS(3890),
    [anon_sym_concept] = ACTIONS(3890),
    [anon_sym_co_return] = ACTIONS(3890),
    [anon_sym_co_yield] = ACTIONS(3890),
    [anon_sym_R_DQUOTE] = ACTIONS(3892),
    [anon_sym_LR_DQUOTE] = ACTIONS(3892),
    [anon_sym_uR_DQUOTE] = ACTIONS(3892),
    [anon_sym_UR_DQUOTE] = ACTIONS(3892),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3892),
    [anon_sym_co_await] = ACTIONS(3890),
    [anon_sym_new] = ACTIONS(3890),
    [anon_sym_requires] = ACTIONS(3890),
    [sym_this] = ACTIONS(3890),
    [anon_sym_precise] = ACTIONS(3890),
    [anon_sym_shared] = ACTIONS(3890),
    [anon_sym_groupshared] = ACTIONS(3890),
    [anon_sym_uniform] = ACTIONS(3890),
    [anon_sym_row_major] = ACTIONS(3890),
    [anon_sym_column_major] = ACTIONS(3890),
    [anon_sym_globallycoherent] = ACTIONS(3890),
    [anon_sym_centroid] = ACTIONS(3890),
    [anon_sym_noperspective] = ACTIONS(3890),
    [anon_sym_nointerpolation] = ACTIONS(3890),
    [anon_sym_sample] = ACTIONS(3890),
    [anon_sym_linear] = ACTIONS(3890),
    [anon_sym_snorm] = ACTIONS(3890),
    [anon_sym_unorm] = ACTIONS(3890),
    [anon_sym_point] = ACTIONS(3890),
    [anon_sym_line] = ACTIONS(3890),
    [anon_sym_triangleadj] = ACTIONS(3890),
    [anon_sym_lineadj] = ACTIONS(3890),
    [anon_sym_triangle] = ACTIONS(3890),
    [anon_sym_interface] = ACTIONS(3890),
    [anon_sym_extension] = ACTIONS(3890),
    [anon_sym___exported] = ACTIONS(3890),
    [anon_sym_import] = ACTIONS(3890),
  },
  [998] = {
    [ts_builtin_sym_end] = ACTIONS(3631),
    [sym_identifier] = ACTIONS(3629),
    [aux_sym_preproc_include_token1] = ACTIONS(3629),
    [aux_sym_preproc_def_token1] = ACTIONS(3629),
    [anon_sym_COMMA] = ACTIONS(3631),
    [aux_sym_preproc_if_token1] = ACTIONS(3629),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3629),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3629),
    [sym_preproc_directive] = ACTIONS(3629),
    [anon_sym_LPAREN2] = ACTIONS(3631),
    [anon_sym_BANG] = ACTIONS(3631),
    [anon_sym_TILDE] = ACTIONS(3631),
    [anon_sym_DASH] = ACTIONS(3629),
    [anon_sym_PLUS] = ACTIONS(3629),
    [anon_sym_STAR] = ACTIONS(3631),
    [anon_sym_AMP_AMP] = ACTIONS(3631),
    [anon_sym_AMP] = ACTIONS(3629),
    [anon_sym___extension__] = ACTIONS(3629),
    [anon_sym_typedef] = ACTIONS(3629),
    [anon_sym_in] = ACTIONS(3629),
    [anon_sym_out] = ACTIONS(3629),
    [anon_sym_inout] = ACTIONS(3629),
    [anon_sym_extern] = ACTIONS(3629),
    [anon_sym___attribute__] = ACTIONS(3629),
    [anon_sym_COLON_COLON] = ACTIONS(3631),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3631),
    [anon_sym___declspec] = ACTIONS(3629),
    [anon_sym___based] = ACTIONS(3629),
    [anon_sym___cdecl] = ACTIONS(3629),
    [anon_sym___clrcall] = ACTIONS(3629),
    [anon_sym___stdcall] = ACTIONS(3629),
    [anon_sym___fastcall] = ACTIONS(3629),
    [anon_sym___thiscall] = ACTIONS(3629),
    [anon_sym___vectorcall] = ACTIONS(3629),
    [anon_sym_LBRACE] = ACTIONS(3631),
    [anon_sym_RBRACE] = ACTIONS(3631),
    [anon_sym_signed] = ACTIONS(3629),
    [anon_sym_unsigned] = ACTIONS(3629),
    [anon_sym_long] = ACTIONS(3629),
    [anon_sym_short] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3629),
    [anon_sym_static] = ACTIONS(3629),
    [anon_sym_register] = ACTIONS(3629),
    [anon_sym_inline] = ACTIONS(3629),
    [anon_sym___inline] = ACTIONS(3629),
    [anon_sym___inline__] = ACTIONS(3629),
    [anon_sym___forceinline] = ACTIONS(3629),
    [anon_sym_thread_local] = ACTIONS(3629),
    [anon_sym___thread] = ACTIONS(3629),
    [anon_sym_const] = ACTIONS(3629),
    [anon_sym_constexpr] = ACTIONS(3629),
    [anon_sym_volatile] = ACTIONS(3629),
    [anon_sym_restrict] = ACTIONS(3629),
    [anon_sym___restrict__] = ACTIONS(3629),
    [anon_sym__Atomic] = ACTIONS(3629),
    [anon_sym__Noreturn] = ACTIONS(3629),
    [anon_sym_noreturn] = ACTIONS(3629),
    [anon_sym_mutable] = ACTIONS(3629),
    [anon_sym_constinit] = ACTIONS(3629),
    [anon_sym_consteval] = ACTIONS(3629),
    [anon_sym_alignas] = ACTIONS(3629),
    [anon_sym__Alignas] = ACTIONS(3629),
    [sym_primitive_type] = ACTIONS(3629),
    [anon_sym_enum] = ACTIONS(3629),
    [anon_sym_class] = ACTIONS(3629),
    [anon_sym_struct] = ACTIONS(3629),
    [anon_sym_union] = ACTIONS(3629),
    [anon_sym_if] = ACTIONS(3629),
    [anon_sym_switch] = ACTIONS(3629),
    [anon_sym_case] = ACTIONS(3629),
    [anon_sym_default] = ACTIONS(3629),
    [anon_sym_while] = ACTIONS(3629),
    [anon_sym_do] = ACTIONS(3629),
    [anon_sym_for] = ACTIONS(3629),
    [anon_sym_return] = ACTIONS(3629),
    [anon_sym_break] = ACTIONS(3629),
    [anon_sym_continue] = ACTIONS(3629),
    [anon_sym_goto] = ACTIONS(3629),
    [anon_sym_not] = ACTIONS(3629),
    [anon_sym_compl] = ACTIONS(3629),
    [anon_sym_DASH_DASH] = ACTIONS(3631),
    [anon_sym_PLUS_PLUS] = ACTIONS(3631),
    [anon_sym_sizeof] = ACTIONS(3629),
    [anon_sym___alignof__] = ACTIONS(3629),
    [anon_sym___alignof] = ACTIONS(3629),
    [anon_sym__alignof] = ACTIONS(3629),
    [anon_sym_alignof] = ACTIONS(3629),
    [anon_sym__Alignof] = ACTIONS(3629),
    [anon_sym_offsetof] = ACTIONS(3629),
    [anon_sym__Generic] = ACTIONS(3629),
    [anon_sym_asm] = ACTIONS(3629),
    [anon_sym___asm__] = ACTIONS(3629),
    [sym_number_literal] = ACTIONS(3631),
    [anon_sym_L_SQUOTE] = ACTIONS(3631),
    [anon_sym_u_SQUOTE] = ACTIONS(3631),
    [anon_sym_U_SQUOTE] = ACTIONS(3631),
    [anon_sym_u8_SQUOTE] = ACTIONS(3631),
    [anon_sym_SQUOTE] = ACTIONS(3631),
    [anon_sym_L_DQUOTE] = ACTIONS(3631),
    [anon_sym_u_DQUOTE] = ACTIONS(3631),
    [anon_sym_U_DQUOTE] = ACTIONS(3631),
    [anon_sym_u8_DQUOTE] = ACTIONS(3631),
    [anon_sym_DQUOTE] = ACTIONS(3631),
    [sym_true] = ACTIONS(3629),
    [sym_false] = ACTIONS(3629),
    [anon_sym_NULL] = ACTIONS(3629),
    [anon_sym_nullptr] = ACTIONS(3629),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3629),
    [anon_sym_let] = ACTIONS(3629),
    [anon_sym_This] = ACTIONS(3629),
    [anon_sym_decltype] = ACTIONS(3629),
    [sym_virtual] = ACTIONS(3629),
    [anon_sym_explicit] = ACTIONS(3629),
    [anon_sym_typename] = ACTIONS(3629),
    [anon_sym_template] = ACTIONS(3629),
    [anon_sym_operator] = ACTIONS(3629),
    [anon_sym_try] = ACTIONS(3629),
    [anon_sym_delete] = ACTIONS(3629),
    [anon_sym_throw] = ACTIONS(3629),
    [anon_sym_namespace] = ACTIONS(3629),
    [anon_sym_using] = ACTIONS(3629),
    [anon_sym_static_assert] = ACTIONS(3629),
    [anon_sym_concept] = ACTIONS(3629),
    [anon_sym_co_return] = ACTIONS(3629),
    [anon_sym_co_yield] = ACTIONS(3629),
    [anon_sym_R_DQUOTE] = ACTIONS(3631),
    [anon_sym_LR_DQUOTE] = ACTIONS(3631),
    [anon_sym_uR_DQUOTE] = ACTIONS(3631),
    [anon_sym_UR_DQUOTE] = ACTIONS(3631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3631),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3629),
    [anon_sym_requires] = ACTIONS(3629),
    [sym_this] = ACTIONS(3629),
    [anon_sym_precise] = ACTIONS(3629),
    [anon_sym_shared] = ACTIONS(3629),
    [anon_sym_groupshared] = ACTIONS(3629),
    [anon_sym_uniform] = ACTIONS(3629),
    [anon_sym_row_major] = ACTIONS(3629),
    [anon_sym_column_major] = ACTIONS(3629),
    [anon_sym_globallycoherent] = ACTIONS(3629),
    [anon_sym_centroid] = ACTIONS(3629),
    [anon_sym_noperspective] = ACTIONS(3629),
    [anon_sym_nointerpolation] = ACTIONS(3629),
    [anon_sym_sample] = ACTIONS(3629),
    [anon_sym_linear] = ACTIONS(3629),
    [anon_sym_snorm] = ACTIONS(3629),
    [anon_sym_unorm] = ACTIONS(3629),
    [anon_sym_point] = ACTIONS(3629),
    [anon_sym_line] = ACTIONS(3629),
    [anon_sym_triangleadj] = ACTIONS(3629),
    [anon_sym_lineadj] = ACTIONS(3629),
    [anon_sym_triangle] = ACTIONS(3629),
    [anon_sym_interface] = ACTIONS(3629),
    [anon_sym_extension] = ACTIONS(3629),
    [anon_sym___exported] = ACTIONS(3629),
    [anon_sym_import] = ACTIONS(3629),
  },
  [999] = {
    [ts_builtin_sym_end] = ACTIONS(3850),
    [sym_identifier] = ACTIONS(3848),
    [aux_sym_preproc_include_token1] = ACTIONS(3848),
    [aux_sym_preproc_def_token1] = ACTIONS(3848),
    [aux_sym_preproc_if_token1] = ACTIONS(3848),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3848),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3848),
    [sym_preproc_directive] = ACTIONS(3848),
    [anon_sym_LPAREN2] = ACTIONS(3850),
    [anon_sym_BANG] = ACTIONS(3850),
    [anon_sym_TILDE] = ACTIONS(3850),
    [anon_sym_DASH] = ACTIONS(3848),
    [anon_sym_PLUS] = ACTIONS(3848),
    [anon_sym_STAR] = ACTIONS(3850),
    [anon_sym_AMP_AMP] = ACTIONS(3850),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_SEMI] = ACTIONS(3850),
    [anon_sym___extension__] = ACTIONS(3848),
    [anon_sym_typedef] = ACTIONS(3848),
    [anon_sym_in] = ACTIONS(3848),
    [anon_sym_out] = ACTIONS(3848),
    [anon_sym_inout] = ACTIONS(3848),
    [anon_sym_extern] = ACTIONS(3848),
    [anon_sym___attribute__] = ACTIONS(3848),
    [anon_sym_COLON_COLON] = ACTIONS(3850),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3850),
    [anon_sym___declspec] = ACTIONS(3848),
    [anon_sym___based] = ACTIONS(3848),
    [anon_sym___cdecl] = ACTIONS(3848),
    [anon_sym___clrcall] = ACTIONS(3848),
    [anon_sym___stdcall] = ACTIONS(3848),
    [anon_sym___fastcall] = ACTIONS(3848),
    [anon_sym___thiscall] = ACTIONS(3848),
    [anon_sym___vectorcall] = ACTIONS(3848),
    [anon_sym_LBRACE] = ACTIONS(3850),
    [anon_sym_signed] = ACTIONS(3848),
    [anon_sym_unsigned] = ACTIONS(3848),
    [anon_sym_long] = ACTIONS(3848),
    [anon_sym_short] = ACTIONS(3848),
    [anon_sym_LBRACK] = ACTIONS(3848),
    [anon_sym_static] = ACTIONS(3848),
    [anon_sym_register] = ACTIONS(3848),
    [anon_sym_inline] = ACTIONS(3848),
    [anon_sym___inline] = ACTIONS(3848),
    [anon_sym___inline__] = ACTIONS(3848),
    [anon_sym___forceinline] = ACTIONS(3848),
    [anon_sym_thread_local] = ACTIONS(3848),
    [anon_sym___thread] = ACTIONS(3848),
    [anon_sym_const] = ACTIONS(3848),
    [anon_sym_constexpr] = ACTIONS(3848),
    [anon_sym_volatile] = ACTIONS(3848),
    [anon_sym_restrict] = ACTIONS(3848),
    [anon_sym___restrict__] = ACTIONS(3848),
    [anon_sym__Atomic] = ACTIONS(3848),
    [anon_sym__Noreturn] = ACTIONS(3848),
    [anon_sym_noreturn] = ACTIONS(3848),
    [anon_sym_mutable] = ACTIONS(3848),
    [anon_sym_constinit] = ACTIONS(3848),
    [anon_sym_consteval] = ACTIONS(3848),
    [anon_sym_alignas] = ACTIONS(3848),
    [anon_sym__Alignas] = ACTIONS(3848),
    [sym_primitive_type] = ACTIONS(3848),
    [anon_sym_enum] = ACTIONS(3848),
    [anon_sym_class] = ACTIONS(3848),
    [anon_sym_struct] = ACTIONS(3848),
    [anon_sym_union] = ACTIONS(3848),
    [anon_sym_if] = ACTIONS(3848),
    [anon_sym_switch] = ACTIONS(3848),
    [anon_sym_case] = ACTIONS(3848),
    [anon_sym_default] = ACTIONS(3848),
    [anon_sym_while] = ACTIONS(3848),
    [anon_sym_do] = ACTIONS(3848),
    [anon_sym_for] = ACTIONS(3848),
    [anon_sym_return] = ACTIONS(3848),
    [anon_sym_break] = ACTIONS(3848),
    [anon_sym_continue] = ACTIONS(3848),
    [anon_sym_goto] = ACTIONS(3848),
    [anon_sym_not] = ACTIONS(3848),
    [anon_sym_compl] = ACTIONS(3848),
    [anon_sym_DASH_DASH] = ACTIONS(3850),
    [anon_sym_PLUS_PLUS] = ACTIONS(3850),
    [anon_sym_sizeof] = ACTIONS(3848),
    [anon_sym___alignof__] = ACTIONS(3848),
    [anon_sym___alignof] = ACTIONS(3848),
    [anon_sym__alignof] = ACTIONS(3848),
    [anon_sym_alignof] = ACTIONS(3848),
    [anon_sym__Alignof] = ACTIONS(3848),
    [anon_sym_offsetof] = ACTIONS(3848),
    [anon_sym__Generic] = ACTIONS(3848),
    [anon_sym_asm] = ACTIONS(3848),
    [anon_sym___asm__] = ACTIONS(3848),
    [anon_sym_DOT] = ACTIONS(2724),
    [sym_number_literal] = ACTIONS(3850),
    [anon_sym_L_SQUOTE] = ACTIONS(3850),
    [anon_sym_u_SQUOTE] = ACTIONS(3850),
    [anon_sym_U_SQUOTE] = ACTIONS(3850),
    [anon_sym_u8_SQUOTE] = ACTIONS(3850),
    [anon_sym_SQUOTE] = ACTIONS(3850),
    [anon_sym_L_DQUOTE] = ACTIONS(3850),
    [anon_sym_u_DQUOTE] = ACTIONS(3850),
    [anon_sym_U_DQUOTE] = ACTIONS(3850),
    [anon_sym_u8_DQUOTE] = ACTIONS(3850),
    [anon_sym_DQUOTE] = ACTIONS(3850),
    [sym_true] = ACTIONS(3848),
    [sym_false] = ACTIONS(3848),
    [anon_sym_NULL] = ACTIONS(3848),
    [anon_sym_nullptr] = ACTIONS(3848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2726),
    [anon_sym_let] = ACTIONS(2726),
    [anon_sym_This] = ACTIONS(2726),
    [anon_sym_decltype] = ACTIONS(3848),
    [sym_virtual] = ACTIONS(3848),
    [anon_sym_explicit] = ACTIONS(3848),
    [anon_sym_typename] = ACTIONS(3848),
    [anon_sym_template] = ACTIONS(3848),
    [anon_sym_operator] = ACTIONS(3848),
    [anon_sym_try] = ACTIONS(3848),
    [anon_sym_delete] = ACTIONS(3848),
    [anon_sym_throw] = ACTIONS(3848),
    [anon_sym_namespace] = ACTIONS(3848),
    [anon_sym_using] = ACTIONS(3848),
    [anon_sym_static_assert] = ACTIONS(3848),
    [anon_sym_concept] = ACTIONS(3848),
    [anon_sym_co_return] = ACTIONS(3848),
    [anon_sym_co_yield] = ACTIONS(3848),
    [anon_sym_R_DQUOTE] = ACTIONS(3850),
    [anon_sym_LR_DQUOTE] = ACTIONS(3850),
    [anon_sym_uR_DQUOTE] = ACTIONS(3850),
    [anon_sym_UR_DQUOTE] = ACTIONS(3850),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3850),
    [anon_sym_co_await] = ACTIONS(3848),
    [anon_sym_new] = ACTIONS(3848),
    [anon_sym_requires] = ACTIONS(3848),
    [sym_this] = ACTIONS(3848),
    [anon_sym_precise] = ACTIONS(3848),
    [anon_sym_shared] = ACTIONS(3848),
    [anon_sym_groupshared] = ACTIONS(3848),
    [anon_sym_uniform] = ACTIONS(3848),
    [anon_sym_row_major] = ACTIONS(3848),
    [anon_sym_column_major] = ACTIONS(3848),
    [anon_sym_globallycoherent] = ACTIONS(3848),
    [anon_sym_centroid] = ACTIONS(3848),
    [anon_sym_noperspective] = ACTIONS(3848),
    [anon_sym_nointerpolation] = ACTIONS(3848),
    [anon_sym_sample] = ACTIONS(3848),
    [anon_sym_linear] = ACTIONS(3848),
    [anon_sym_snorm] = ACTIONS(3848),
    [anon_sym_unorm] = ACTIONS(3848),
    [anon_sym_point] = ACTIONS(3848),
    [anon_sym_line] = ACTIONS(3848),
    [anon_sym_triangleadj] = ACTIONS(3848),
    [anon_sym_lineadj] = ACTIONS(3848),
    [anon_sym_triangle] = ACTIONS(3848),
    [anon_sym_interface] = ACTIONS(3848),
    [anon_sym_extension] = ACTIONS(3848),
    [anon_sym___exported] = ACTIONS(3848),
    [anon_sym_import] = ACTIONS(3848),
  },
  [1000] = {
    [ts_builtin_sym_end] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3665),
    [aux_sym_preproc_include_token1] = ACTIONS(3665),
    [aux_sym_preproc_def_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3665),
    [sym_preproc_directive] = ACTIONS(3665),
    [anon_sym_LPAREN2] = ACTIONS(3667),
    [anon_sym_BANG] = ACTIONS(3667),
    [anon_sym_TILDE] = ACTIONS(3667),
    [anon_sym_DASH] = ACTIONS(3665),
    [anon_sym_PLUS] = ACTIONS(3665),
    [anon_sym_STAR] = ACTIONS(3667),
    [anon_sym_AMP_AMP] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym___extension__] = ACTIONS(3665),
    [anon_sym_typedef] = ACTIONS(3665),
    [anon_sym_in] = ACTIONS(3665),
    [anon_sym_out] = ACTIONS(3665),
    [anon_sym_inout] = ACTIONS(3665),
    [anon_sym_extern] = ACTIONS(3665),
    [anon_sym___attribute__] = ACTIONS(3665),
    [anon_sym_COLON_COLON] = ACTIONS(3667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3667),
    [anon_sym___declspec] = ACTIONS(3665),
    [anon_sym___based] = ACTIONS(3665),
    [anon_sym___cdecl] = ACTIONS(3665),
    [anon_sym___clrcall] = ACTIONS(3665),
    [anon_sym___stdcall] = ACTIONS(3665),
    [anon_sym___fastcall] = ACTIONS(3665),
    [anon_sym___thiscall] = ACTIONS(3665),
    [anon_sym___vectorcall] = ACTIONS(3665),
    [anon_sym_LBRACE] = ACTIONS(3667),
    [anon_sym_signed] = ACTIONS(3665),
    [anon_sym_unsigned] = ACTIONS(3665),
    [anon_sym_long] = ACTIONS(3665),
    [anon_sym_short] = ACTIONS(3665),
    [anon_sym_LBRACK] = ACTIONS(3665),
    [anon_sym_static] = ACTIONS(3665),
    [anon_sym_register] = ACTIONS(3665),
    [anon_sym_inline] = ACTIONS(3665),
    [anon_sym___inline] = ACTIONS(3665),
    [anon_sym___inline__] = ACTIONS(3665),
    [anon_sym___forceinline] = ACTIONS(3665),
    [anon_sym_thread_local] = ACTIONS(3665),
    [anon_sym___thread] = ACTIONS(3665),
    [anon_sym_const] = ACTIONS(3665),
    [anon_sym_constexpr] = ACTIONS(3665),
    [anon_sym_volatile] = ACTIONS(3665),
    [anon_sym_restrict] = ACTIONS(3665),
    [anon_sym___restrict__] = ACTIONS(3665),
    [anon_sym__Atomic] = ACTIONS(3665),
    [anon_sym__Noreturn] = ACTIONS(3665),
    [anon_sym_noreturn] = ACTIONS(3665),
    [anon_sym_mutable] = ACTIONS(3665),
    [anon_sym_constinit] = ACTIONS(3665),
    [anon_sym_consteval] = ACTIONS(3665),
    [anon_sym_alignas] = ACTIONS(3665),
    [anon_sym__Alignas] = ACTIONS(3665),
    [sym_primitive_type] = ACTIONS(3665),
    [anon_sym_enum] = ACTIONS(3665),
    [anon_sym_class] = ACTIONS(3665),
    [anon_sym_struct] = ACTIONS(3665),
    [anon_sym_union] = ACTIONS(3665),
    [anon_sym_if] = ACTIONS(3665),
    [anon_sym_switch] = ACTIONS(3665),
    [anon_sym_case] = ACTIONS(3665),
    [anon_sym_default] = ACTIONS(3665),
    [anon_sym_while] = ACTIONS(3665),
    [anon_sym_do] = ACTIONS(3665),
    [anon_sym_for] = ACTIONS(3665),
    [anon_sym_return] = ACTIONS(3665),
    [anon_sym_break] = ACTIONS(3665),
    [anon_sym_continue] = ACTIONS(3665),
    [anon_sym_goto] = ACTIONS(3665),
    [anon_sym_not] = ACTIONS(3665),
    [anon_sym_compl] = ACTIONS(3665),
    [anon_sym_DASH_DASH] = ACTIONS(3667),
    [anon_sym_PLUS_PLUS] = ACTIONS(3667),
    [anon_sym_sizeof] = ACTIONS(3665),
    [anon_sym___alignof__] = ACTIONS(3665),
    [anon_sym___alignof] = ACTIONS(3665),
    [anon_sym__alignof] = ACTIONS(3665),
    [anon_sym_alignof] = ACTIONS(3665),
    [anon_sym__Alignof] = ACTIONS(3665),
    [anon_sym_offsetof] = ACTIONS(3665),
    [anon_sym__Generic] = ACTIONS(3665),
    [anon_sym_asm] = ACTIONS(3665),
    [anon_sym___asm__] = ACTIONS(3665),
    [sym_number_literal] = ACTIONS(3667),
    [anon_sym_L_SQUOTE] = ACTIONS(3667),
    [anon_sym_u_SQUOTE] = ACTIONS(3667),
    [anon_sym_U_SQUOTE] = ACTIONS(3667),
    [anon_sym_u8_SQUOTE] = ACTIONS(3667),
    [anon_sym_SQUOTE] = ACTIONS(3667),
    [anon_sym_L_DQUOTE] = ACTIONS(3667),
    [anon_sym_u_DQUOTE] = ACTIONS(3667),
    [anon_sym_U_DQUOTE] = ACTIONS(3667),
    [anon_sym_u8_DQUOTE] = ACTIONS(3667),
    [anon_sym_DQUOTE] = ACTIONS(3667),
    [sym_true] = ACTIONS(3665),
    [sym_false] = ACTIONS(3665),
    [anon_sym_NULL] = ACTIONS(3665),
    [anon_sym_nullptr] = ACTIONS(3665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3665),
    [anon_sym_let] = ACTIONS(3665),
    [anon_sym_This] = ACTIONS(3665),
    [anon_sym_decltype] = ACTIONS(3665),
    [sym_virtual] = ACTIONS(3665),
    [anon_sym_explicit] = ACTIONS(3665),
    [anon_sym_typename] = ACTIONS(3665),
    [anon_sym_template] = ACTIONS(3665),
    [anon_sym_operator] = ACTIONS(3665),
    [anon_sym_try] = ACTIONS(3665),
    [anon_sym_delete] = ACTIONS(3665),
    [anon_sym_throw] = ACTIONS(3665),
    [anon_sym_namespace] = ACTIONS(3665),
    [anon_sym_using] = ACTIONS(3665),
    [anon_sym_static_assert] = ACTIONS(3665),
    [anon_sym_concept] = ACTIONS(3665),
    [anon_sym_co_return] = ACTIONS(3665),
    [anon_sym_co_yield] = ACTIONS(3665),
    [anon_sym_R_DQUOTE] = ACTIONS(3667),
    [anon_sym_LR_DQUOTE] = ACTIONS(3667),
    [anon_sym_uR_DQUOTE] = ACTIONS(3667),
    [anon_sym_UR_DQUOTE] = ACTIONS(3667),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3667),
    [anon_sym_co_await] = ACTIONS(3665),
    [anon_sym_new] = ACTIONS(3665),
    [anon_sym_requires] = ACTIONS(3665),
    [sym_this] = ACTIONS(3665),
    [anon_sym_precise] = ACTIONS(3665),
    [anon_sym_shared] = ACTIONS(3665),
    [anon_sym_groupshared] = ACTIONS(3665),
    [anon_sym_uniform] = ACTIONS(3665),
    [anon_sym_row_major] = ACTIONS(3665),
    [anon_sym_column_major] = ACTIONS(3665),
    [anon_sym_globallycoherent] = ACTIONS(3665),
    [anon_sym_centroid] = ACTIONS(3665),
    [anon_sym_noperspective] = ACTIONS(3665),
    [anon_sym_nointerpolation] = ACTIONS(3665),
    [anon_sym_sample] = ACTIONS(3665),
    [anon_sym_linear] = ACTIONS(3665),
    [anon_sym_snorm] = ACTIONS(3665),
    [anon_sym_unorm] = ACTIONS(3665),
    [anon_sym_point] = ACTIONS(3665),
    [anon_sym_line] = ACTIONS(3665),
    [anon_sym_triangleadj] = ACTIONS(3665),
    [anon_sym_lineadj] = ACTIONS(3665),
    [anon_sym_triangle] = ACTIONS(3665),
    [anon_sym_interface] = ACTIONS(3665),
    [anon_sym_extension] = ACTIONS(3665),
    [anon_sym___exported] = ACTIONS(3665),
    [anon_sym_import] = ACTIONS(3665),
  },
  [1001] = {
    [ts_builtin_sym_end] = ACTIONS(3431),
    [sym_identifier] = ACTIONS(3429),
    [aux_sym_preproc_include_token1] = ACTIONS(3429),
    [aux_sym_preproc_def_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3429),
    [sym_preproc_directive] = ACTIONS(3429),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_BANG] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym___extension__] = ACTIONS(3429),
    [anon_sym_typedef] = ACTIONS(3429),
    [anon_sym_in] = ACTIONS(3429),
    [anon_sym_out] = ACTIONS(3429),
    [anon_sym_inout] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym___attribute__] = ACTIONS(3429),
    [anon_sym_COLON_COLON] = ACTIONS(3431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3431),
    [anon_sym___declspec] = ACTIONS(3429),
    [anon_sym___based] = ACTIONS(3429),
    [anon_sym___cdecl] = ACTIONS(3429),
    [anon_sym___clrcall] = ACTIONS(3429),
    [anon_sym___stdcall] = ACTIONS(3429),
    [anon_sym___fastcall] = ACTIONS(3429),
    [anon_sym___thiscall] = ACTIONS(3429),
    [anon_sym___vectorcall] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_signed] = ACTIONS(3429),
    [anon_sym_unsigned] = ACTIONS(3429),
    [anon_sym_long] = ACTIONS(3429),
    [anon_sym_short] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_register] = ACTIONS(3429),
    [anon_sym_inline] = ACTIONS(3429),
    [anon_sym___inline] = ACTIONS(3429),
    [anon_sym___inline__] = ACTIONS(3429),
    [anon_sym___forceinline] = ACTIONS(3429),
    [anon_sym_thread_local] = ACTIONS(3429),
    [anon_sym___thread] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_constexpr] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_restrict] = ACTIONS(3429),
    [anon_sym___restrict__] = ACTIONS(3429),
    [anon_sym__Atomic] = ACTIONS(3429),
    [anon_sym__Noreturn] = ACTIONS(3429),
    [anon_sym_noreturn] = ACTIONS(3429),
    [anon_sym_mutable] = ACTIONS(3429),
    [anon_sym_constinit] = ACTIONS(3429),
    [anon_sym_consteval] = ACTIONS(3429),
    [anon_sym_alignas] = ACTIONS(3429),
    [anon_sym__Alignas] = ACTIONS(3429),
    [sym_primitive_type] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [anon_sym_if] = ACTIONS(3429),
    [anon_sym_switch] = ACTIONS(3429),
    [anon_sym_case] = ACTIONS(3429),
    [anon_sym_default] = ACTIONS(3429),
    [anon_sym_while] = ACTIONS(3429),
    [anon_sym_do] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3429),
    [anon_sym_return] = ACTIONS(3429),
    [anon_sym_break] = ACTIONS(3429),
    [anon_sym_continue] = ACTIONS(3429),
    [anon_sym_goto] = ACTIONS(3429),
    [anon_sym_not] = ACTIONS(3429),
    [anon_sym_compl] = ACTIONS(3429),
    [anon_sym_DASH_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(3431),
    [anon_sym_sizeof] = ACTIONS(3429),
    [anon_sym___alignof__] = ACTIONS(3429),
    [anon_sym___alignof] = ACTIONS(3429),
    [anon_sym__alignof] = ACTIONS(3429),
    [anon_sym_alignof] = ACTIONS(3429),
    [anon_sym__Alignof] = ACTIONS(3429),
    [anon_sym_offsetof] = ACTIONS(3429),
    [anon_sym__Generic] = ACTIONS(3429),
    [anon_sym_asm] = ACTIONS(3429),
    [anon_sym___asm__] = ACTIONS(3429),
    [sym_number_literal] = ACTIONS(3431),
    [anon_sym_L_SQUOTE] = ACTIONS(3431),
    [anon_sym_u_SQUOTE] = ACTIONS(3431),
    [anon_sym_U_SQUOTE] = ACTIONS(3431),
    [anon_sym_u8_SQUOTE] = ACTIONS(3431),
    [anon_sym_SQUOTE] = ACTIONS(3431),
    [anon_sym_L_DQUOTE] = ACTIONS(3431),
    [anon_sym_u_DQUOTE] = ACTIONS(3431),
    [anon_sym_U_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [sym_true] = ACTIONS(3429),
    [sym_false] = ACTIONS(3429),
    [anon_sym_NULL] = ACTIONS(3429),
    [anon_sym_nullptr] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_This] = ACTIONS(3429),
    [anon_sym_decltype] = ACTIONS(3429),
    [sym_virtual] = ACTIONS(3429),
    [anon_sym_explicit] = ACTIONS(3429),
    [anon_sym_typename] = ACTIONS(3429),
    [anon_sym_template] = ACTIONS(3429),
    [anon_sym_operator] = ACTIONS(3429),
    [anon_sym_try] = ACTIONS(3429),
    [anon_sym_delete] = ACTIONS(3429),
    [anon_sym_throw] = ACTIONS(3429),
    [anon_sym_namespace] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_static_assert] = ACTIONS(3429),
    [anon_sym_concept] = ACTIONS(3429),
    [anon_sym_co_return] = ACTIONS(3429),
    [anon_sym_co_yield] = ACTIONS(3429),
    [anon_sym_R_DQUOTE] = ACTIONS(3431),
    [anon_sym_LR_DQUOTE] = ACTIONS(3431),
    [anon_sym_uR_DQUOTE] = ACTIONS(3431),
    [anon_sym_UR_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3431),
    [anon_sym_co_await] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3429),
    [anon_sym_requires] = ACTIONS(3429),
    [sym_this] = ACTIONS(3429),
    [anon_sym_precise] = ACTIONS(3429),
    [anon_sym_shared] = ACTIONS(3429),
    [anon_sym_groupshared] = ACTIONS(3429),
    [anon_sym_uniform] = ACTIONS(3429),
    [anon_sym_row_major] = ACTIONS(3429),
    [anon_sym_column_major] = ACTIONS(3429),
    [anon_sym_globallycoherent] = ACTIONS(3429),
    [anon_sym_centroid] = ACTIONS(3429),
    [anon_sym_noperspective] = ACTIONS(3429),
    [anon_sym_nointerpolation] = ACTIONS(3429),
    [anon_sym_sample] = ACTIONS(3429),
    [anon_sym_linear] = ACTIONS(3429),
    [anon_sym_snorm] = ACTIONS(3429),
    [anon_sym_unorm] = ACTIONS(3429),
    [anon_sym_point] = ACTIONS(3429),
    [anon_sym_line] = ACTIONS(3429),
    [anon_sym_triangleadj] = ACTIONS(3429),
    [anon_sym_lineadj] = ACTIONS(3429),
    [anon_sym_triangle] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_extension] = ACTIONS(3429),
    [anon_sym___exported] = ACTIONS(3429),
    [anon_sym_import] = ACTIONS(3429),
  },
  [1002] = {
    [ts_builtin_sym_end] = ACTIONS(3435),
    [sym_identifier] = ACTIONS(3433),
    [aux_sym_preproc_include_token1] = ACTIONS(3433),
    [aux_sym_preproc_def_token1] = ACTIONS(3433),
    [aux_sym_preproc_if_token1] = ACTIONS(3433),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3433),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3433),
    [sym_preproc_directive] = ACTIONS(3433),
    [anon_sym_LPAREN2] = ACTIONS(3435),
    [anon_sym_BANG] = ACTIONS(3435),
    [anon_sym_TILDE] = ACTIONS(3435),
    [anon_sym_DASH] = ACTIONS(3433),
    [anon_sym_PLUS] = ACTIONS(3433),
    [anon_sym_STAR] = ACTIONS(3435),
    [anon_sym_AMP_AMP] = ACTIONS(3435),
    [anon_sym_AMP] = ACTIONS(3433),
    [anon_sym___extension__] = ACTIONS(3433),
    [anon_sym_typedef] = ACTIONS(3433),
    [anon_sym_in] = ACTIONS(3433),
    [anon_sym_out] = ACTIONS(3433),
    [anon_sym_inout] = ACTIONS(3433),
    [anon_sym_extern] = ACTIONS(3433),
    [anon_sym___attribute__] = ACTIONS(3433),
    [anon_sym_COLON_COLON] = ACTIONS(3435),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3435),
    [anon_sym___declspec] = ACTIONS(3433),
    [anon_sym___based] = ACTIONS(3433),
    [anon_sym___cdecl] = ACTIONS(3433),
    [anon_sym___clrcall] = ACTIONS(3433),
    [anon_sym___stdcall] = ACTIONS(3433),
    [anon_sym___fastcall] = ACTIONS(3433),
    [anon_sym___thiscall] = ACTIONS(3433),
    [anon_sym___vectorcall] = ACTIONS(3433),
    [anon_sym_LBRACE] = ACTIONS(3435),
    [anon_sym_signed] = ACTIONS(3433),
    [anon_sym_unsigned] = ACTIONS(3433),
    [anon_sym_long] = ACTIONS(3433),
    [anon_sym_short] = ACTIONS(3433),
    [anon_sym_LBRACK] = ACTIONS(3433),
    [anon_sym_static] = ACTIONS(3433),
    [anon_sym_register] = ACTIONS(3433),
    [anon_sym_inline] = ACTIONS(3433),
    [anon_sym___inline] = ACTIONS(3433),
    [anon_sym___inline__] = ACTIONS(3433),
    [anon_sym___forceinline] = ACTIONS(3433),
    [anon_sym_thread_local] = ACTIONS(3433),
    [anon_sym___thread] = ACTIONS(3433),
    [anon_sym_const] = ACTIONS(3433),
    [anon_sym_constexpr] = ACTIONS(3433),
    [anon_sym_volatile] = ACTIONS(3433),
    [anon_sym_restrict] = ACTIONS(3433),
    [anon_sym___restrict__] = ACTIONS(3433),
    [anon_sym__Atomic] = ACTIONS(3433),
    [anon_sym__Noreturn] = ACTIONS(3433),
    [anon_sym_noreturn] = ACTIONS(3433),
    [anon_sym_mutable] = ACTIONS(3433),
    [anon_sym_constinit] = ACTIONS(3433),
    [anon_sym_consteval] = ACTIONS(3433),
    [anon_sym_alignas] = ACTIONS(3433),
    [anon_sym__Alignas] = ACTIONS(3433),
    [sym_primitive_type] = ACTIONS(3433),
    [anon_sym_enum] = ACTIONS(3433),
    [anon_sym_class] = ACTIONS(3433),
    [anon_sym_struct] = ACTIONS(3433),
    [anon_sym_union] = ACTIONS(3433),
    [anon_sym_if] = ACTIONS(3433),
    [anon_sym_switch] = ACTIONS(3433),
    [anon_sym_case] = ACTIONS(3433),
    [anon_sym_default] = ACTIONS(3433),
    [anon_sym_while] = ACTIONS(3433),
    [anon_sym_do] = ACTIONS(3433),
    [anon_sym_for] = ACTIONS(3433),
    [anon_sym_return] = ACTIONS(3433),
    [anon_sym_break] = ACTIONS(3433),
    [anon_sym_continue] = ACTIONS(3433),
    [anon_sym_goto] = ACTIONS(3433),
    [anon_sym_not] = ACTIONS(3433),
    [anon_sym_compl] = ACTIONS(3433),
    [anon_sym_DASH_DASH] = ACTIONS(3435),
    [anon_sym_PLUS_PLUS] = ACTIONS(3435),
    [anon_sym_sizeof] = ACTIONS(3433),
    [anon_sym___alignof__] = ACTIONS(3433),
    [anon_sym___alignof] = ACTIONS(3433),
    [anon_sym__alignof] = ACTIONS(3433),
    [anon_sym_alignof] = ACTIONS(3433),
    [anon_sym__Alignof] = ACTIONS(3433),
    [anon_sym_offsetof] = ACTIONS(3433),
    [anon_sym__Generic] = ACTIONS(3433),
    [anon_sym_asm] = ACTIONS(3433),
    [anon_sym___asm__] = ACTIONS(3433),
    [sym_number_literal] = ACTIONS(3435),
    [anon_sym_L_SQUOTE] = ACTIONS(3435),
    [anon_sym_u_SQUOTE] = ACTIONS(3435),
    [anon_sym_U_SQUOTE] = ACTIONS(3435),
    [anon_sym_u8_SQUOTE] = ACTIONS(3435),
    [anon_sym_SQUOTE] = ACTIONS(3435),
    [anon_sym_L_DQUOTE] = ACTIONS(3435),
    [anon_sym_u_DQUOTE] = ACTIONS(3435),
    [anon_sym_U_DQUOTE] = ACTIONS(3435),
    [anon_sym_u8_DQUOTE] = ACTIONS(3435),
    [anon_sym_DQUOTE] = ACTIONS(3435),
    [sym_true] = ACTIONS(3433),
    [sym_false] = ACTIONS(3433),
    [anon_sym_NULL] = ACTIONS(3433),
    [anon_sym_nullptr] = ACTIONS(3433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3433),
    [anon_sym_let] = ACTIONS(3433),
    [anon_sym_This] = ACTIONS(3433),
    [anon_sym_decltype] = ACTIONS(3433),
    [sym_virtual] = ACTIONS(3433),
    [anon_sym_explicit] = ACTIONS(3433),
    [anon_sym_typename] = ACTIONS(3433),
    [anon_sym_template] = ACTIONS(3433),
    [anon_sym_operator] = ACTIONS(3433),
    [anon_sym_try] = ACTIONS(3433),
    [anon_sym_delete] = ACTIONS(3433),
    [anon_sym_throw] = ACTIONS(3433),
    [anon_sym_namespace] = ACTIONS(3433),
    [anon_sym_using] = ACTIONS(3433),
    [anon_sym_static_assert] = ACTIONS(3433),
    [anon_sym_concept] = ACTIONS(3433),
    [anon_sym_co_return] = ACTIONS(3433),
    [anon_sym_co_yield] = ACTIONS(3433),
    [anon_sym_R_DQUOTE] = ACTIONS(3435),
    [anon_sym_LR_DQUOTE] = ACTIONS(3435),
    [anon_sym_uR_DQUOTE] = ACTIONS(3435),
    [anon_sym_UR_DQUOTE] = ACTIONS(3435),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3435),
    [anon_sym_co_await] = ACTIONS(3433),
    [anon_sym_new] = ACTIONS(3433),
    [anon_sym_requires] = ACTIONS(3433),
    [sym_this] = ACTIONS(3433),
    [anon_sym_precise] = ACTIONS(3433),
    [anon_sym_shared] = ACTIONS(3433),
    [anon_sym_groupshared] = ACTIONS(3433),
    [anon_sym_uniform] = ACTIONS(3433),
    [anon_sym_row_major] = ACTIONS(3433),
    [anon_sym_column_major] = ACTIONS(3433),
    [anon_sym_globallycoherent] = ACTIONS(3433),
    [anon_sym_centroid] = ACTIONS(3433),
    [anon_sym_noperspective] = ACTIONS(3433),
    [anon_sym_nointerpolation] = ACTIONS(3433),
    [anon_sym_sample] = ACTIONS(3433),
    [anon_sym_linear] = ACTIONS(3433),
    [anon_sym_snorm] = ACTIONS(3433),
    [anon_sym_unorm] = ACTIONS(3433),
    [anon_sym_point] = ACTIONS(3433),
    [anon_sym_line] = ACTIONS(3433),
    [anon_sym_triangleadj] = ACTIONS(3433),
    [anon_sym_lineadj] = ACTIONS(3433),
    [anon_sym_triangle] = ACTIONS(3433),
    [anon_sym_interface] = ACTIONS(3433),
    [anon_sym_extension] = ACTIONS(3433),
    [anon_sym___exported] = ACTIONS(3433),
    [anon_sym_import] = ACTIONS(3433),
  },
  [1003] = {
    [ts_builtin_sym_end] = ACTIONS(3585),
    [sym_identifier] = ACTIONS(3583),
    [aux_sym_preproc_include_token1] = ACTIONS(3583),
    [aux_sym_preproc_def_token1] = ACTIONS(3583),
    [aux_sym_preproc_if_token1] = ACTIONS(3583),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3583),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3583),
    [sym_preproc_directive] = ACTIONS(3583),
    [anon_sym_LPAREN2] = ACTIONS(3585),
    [anon_sym_BANG] = ACTIONS(3585),
    [anon_sym_TILDE] = ACTIONS(3585),
    [anon_sym_DASH] = ACTIONS(3583),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_STAR] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3583),
    [anon_sym___extension__] = ACTIONS(3583),
    [anon_sym_typedef] = ACTIONS(3583),
    [anon_sym_in] = ACTIONS(3583),
    [anon_sym_out] = ACTIONS(3583),
    [anon_sym_inout] = ACTIONS(3583),
    [anon_sym_extern] = ACTIONS(3583),
    [anon_sym___attribute__] = ACTIONS(3583),
    [anon_sym_COLON_COLON] = ACTIONS(3585),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3585),
    [anon_sym___declspec] = ACTIONS(3583),
    [anon_sym___based] = ACTIONS(3583),
    [anon_sym___cdecl] = ACTIONS(3583),
    [anon_sym___clrcall] = ACTIONS(3583),
    [anon_sym___stdcall] = ACTIONS(3583),
    [anon_sym___fastcall] = ACTIONS(3583),
    [anon_sym___thiscall] = ACTIONS(3583),
    [anon_sym___vectorcall] = ACTIONS(3583),
    [anon_sym_LBRACE] = ACTIONS(3585),
    [anon_sym_signed] = ACTIONS(3583),
    [anon_sym_unsigned] = ACTIONS(3583),
    [anon_sym_long] = ACTIONS(3583),
    [anon_sym_short] = ACTIONS(3583),
    [anon_sym_LBRACK] = ACTIONS(3583),
    [anon_sym_static] = ACTIONS(3583),
    [anon_sym_register] = ACTIONS(3583),
    [anon_sym_inline] = ACTIONS(3583),
    [anon_sym___inline] = ACTIONS(3583),
    [anon_sym___inline__] = ACTIONS(3583),
    [anon_sym___forceinline] = ACTIONS(3583),
    [anon_sym_thread_local] = ACTIONS(3583),
    [anon_sym___thread] = ACTIONS(3583),
    [anon_sym_const] = ACTIONS(3583),
    [anon_sym_constexpr] = ACTIONS(3583),
    [anon_sym_volatile] = ACTIONS(3583),
    [anon_sym_restrict] = ACTIONS(3583),
    [anon_sym___restrict__] = ACTIONS(3583),
    [anon_sym__Atomic] = ACTIONS(3583),
    [anon_sym__Noreturn] = ACTIONS(3583),
    [anon_sym_noreturn] = ACTIONS(3583),
    [anon_sym_mutable] = ACTIONS(3583),
    [anon_sym_constinit] = ACTIONS(3583),
    [anon_sym_consteval] = ACTIONS(3583),
    [anon_sym_alignas] = ACTIONS(3583),
    [anon_sym__Alignas] = ACTIONS(3583),
    [sym_primitive_type] = ACTIONS(3583),
    [anon_sym_enum] = ACTIONS(3583),
    [anon_sym_class] = ACTIONS(3583),
    [anon_sym_struct] = ACTIONS(3583),
    [anon_sym_union] = ACTIONS(3583),
    [anon_sym_if] = ACTIONS(3583),
    [anon_sym_switch] = ACTIONS(3583),
    [anon_sym_case] = ACTIONS(3583),
    [anon_sym_default] = ACTIONS(3583),
    [anon_sym_while] = ACTIONS(3583),
    [anon_sym_do] = ACTIONS(3583),
    [anon_sym_for] = ACTIONS(3583),
    [anon_sym_return] = ACTIONS(3583),
    [anon_sym_break] = ACTIONS(3583),
    [anon_sym_continue] = ACTIONS(3583),
    [anon_sym_goto] = ACTIONS(3583),
    [anon_sym_not] = ACTIONS(3583),
    [anon_sym_compl] = ACTIONS(3583),
    [anon_sym_DASH_DASH] = ACTIONS(3585),
    [anon_sym_PLUS_PLUS] = ACTIONS(3585),
    [anon_sym_sizeof] = ACTIONS(3583),
    [anon_sym___alignof__] = ACTIONS(3583),
    [anon_sym___alignof] = ACTIONS(3583),
    [anon_sym__alignof] = ACTIONS(3583),
    [anon_sym_alignof] = ACTIONS(3583),
    [anon_sym__Alignof] = ACTIONS(3583),
    [anon_sym_offsetof] = ACTIONS(3583),
    [anon_sym__Generic] = ACTIONS(3583),
    [anon_sym_asm] = ACTIONS(3583),
    [anon_sym___asm__] = ACTIONS(3583),
    [sym_number_literal] = ACTIONS(3585),
    [anon_sym_L_SQUOTE] = ACTIONS(3585),
    [anon_sym_u_SQUOTE] = ACTIONS(3585),
    [anon_sym_U_SQUOTE] = ACTIONS(3585),
    [anon_sym_u8_SQUOTE] = ACTIONS(3585),
    [anon_sym_SQUOTE] = ACTIONS(3585),
    [anon_sym_L_DQUOTE] = ACTIONS(3585),
    [anon_sym_u_DQUOTE] = ACTIONS(3585),
    [anon_sym_U_DQUOTE] = ACTIONS(3585),
    [anon_sym_u8_DQUOTE] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [sym_true] = ACTIONS(3583),
    [sym_false] = ACTIONS(3583),
    [anon_sym_NULL] = ACTIONS(3583),
    [anon_sym_nullptr] = ACTIONS(3583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3583),
    [anon_sym_let] = ACTIONS(3583),
    [anon_sym_This] = ACTIONS(3583),
    [anon_sym_decltype] = ACTIONS(3583),
    [sym_virtual] = ACTIONS(3583),
    [anon_sym_explicit] = ACTIONS(3583),
    [anon_sym_typename] = ACTIONS(3583),
    [anon_sym_template] = ACTIONS(3583),
    [anon_sym_operator] = ACTIONS(3583),
    [anon_sym_try] = ACTIONS(3583),
    [anon_sym_delete] = ACTIONS(3583),
    [anon_sym_throw] = ACTIONS(3583),
    [anon_sym_namespace] = ACTIONS(3583),
    [anon_sym_using] = ACTIONS(3583),
    [anon_sym_static_assert] = ACTIONS(3583),
    [anon_sym_concept] = ACTIONS(3583),
    [anon_sym_co_return] = ACTIONS(3583),
    [anon_sym_co_yield] = ACTIONS(3583),
    [anon_sym_R_DQUOTE] = ACTIONS(3585),
    [anon_sym_LR_DQUOTE] = ACTIONS(3585),
    [anon_sym_uR_DQUOTE] = ACTIONS(3585),
    [anon_sym_UR_DQUOTE] = ACTIONS(3585),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3585),
    [anon_sym_co_await] = ACTIONS(3583),
    [anon_sym_new] = ACTIONS(3583),
    [anon_sym_requires] = ACTIONS(3583),
    [sym_this] = ACTIONS(3583),
    [anon_sym_precise] = ACTIONS(3583),
    [anon_sym_shared] = ACTIONS(3583),
    [anon_sym_groupshared] = ACTIONS(3583),
    [anon_sym_uniform] = ACTIONS(3583),
    [anon_sym_row_major] = ACTIONS(3583),
    [anon_sym_column_major] = ACTIONS(3583),
    [anon_sym_globallycoherent] = ACTIONS(3583),
    [anon_sym_centroid] = ACTIONS(3583),
    [anon_sym_noperspective] = ACTIONS(3583),
    [anon_sym_nointerpolation] = ACTIONS(3583),
    [anon_sym_sample] = ACTIONS(3583),
    [anon_sym_linear] = ACTIONS(3583),
    [anon_sym_snorm] = ACTIONS(3583),
    [anon_sym_unorm] = ACTIONS(3583),
    [anon_sym_point] = ACTIONS(3583),
    [anon_sym_line] = ACTIONS(3583),
    [anon_sym_triangleadj] = ACTIONS(3583),
    [anon_sym_lineadj] = ACTIONS(3583),
    [anon_sym_triangle] = ACTIONS(3583),
    [anon_sym_interface] = ACTIONS(3583),
    [anon_sym_extension] = ACTIONS(3583),
    [anon_sym___exported] = ACTIONS(3583),
    [anon_sym_import] = ACTIONS(3583),
  },
  [1004] = {
    [ts_builtin_sym_end] = ACTIONS(3565),
    [sym_identifier] = ACTIONS(3563),
    [aux_sym_preproc_include_token1] = ACTIONS(3563),
    [aux_sym_preproc_def_token1] = ACTIONS(3563),
    [aux_sym_preproc_if_token1] = ACTIONS(3563),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3563),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3563),
    [sym_preproc_directive] = ACTIONS(3563),
    [anon_sym_LPAREN2] = ACTIONS(3565),
    [anon_sym_BANG] = ACTIONS(3565),
    [anon_sym_TILDE] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3563),
    [anon_sym_PLUS] = ACTIONS(3563),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_AMP_AMP] = ACTIONS(3565),
    [anon_sym_AMP] = ACTIONS(3563),
    [anon_sym___extension__] = ACTIONS(3563),
    [anon_sym_typedef] = ACTIONS(3563),
    [anon_sym_in] = ACTIONS(3563),
    [anon_sym_out] = ACTIONS(3563),
    [anon_sym_inout] = ACTIONS(3563),
    [anon_sym_extern] = ACTIONS(3563),
    [anon_sym___attribute__] = ACTIONS(3563),
    [anon_sym_COLON_COLON] = ACTIONS(3565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3565),
    [anon_sym___declspec] = ACTIONS(3563),
    [anon_sym___based] = ACTIONS(3563),
    [anon_sym___cdecl] = ACTIONS(3563),
    [anon_sym___clrcall] = ACTIONS(3563),
    [anon_sym___stdcall] = ACTIONS(3563),
    [anon_sym___fastcall] = ACTIONS(3563),
    [anon_sym___thiscall] = ACTIONS(3563),
    [anon_sym___vectorcall] = ACTIONS(3563),
    [anon_sym_LBRACE] = ACTIONS(3565),
    [anon_sym_signed] = ACTIONS(3563),
    [anon_sym_unsigned] = ACTIONS(3563),
    [anon_sym_long] = ACTIONS(3563),
    [anon_sym_short] = ACTIONS(3563),
    [anon_sym_LBRACK] = ACTIONS(3563),
    [anon_sym_static] = ACTIONS(3563),
    [anon_sym_register] = ACTIONS(3563),
    [anon_sym_inline] = ACTIONS(3563),
    [anon_sym___inline] = ACTIONS(3563),
    [anon_sym___inline__] = ACTIONS(3563),
    [anon_sym___forceinline] = ACTIONS(3563),
    [anon_sym_thread_local] = ACTIONS(3563),
    [anon_sym___thread] = ACTIONS(3563),
    [anon_sym_const] = ACTIONS(3563),
    [anon_sym_constexpr] = ACTIONS(3563),
    [anon_sym_volatile] = ACTIONS(3563),
    [anon_sym_restrict] = ACTIONS(3563),
    [anon_sym___restrict__] = ACTIONS(3563),
    [anon_sym__Atomic] = ACTIONS(3563),
    [anon_sym__Noreturn] = ACTIONS(3563),
    [anon_sym_noreturn] = ACTIONS(3563),
    [anon_sym_mutable] = ACTIONS(3563),
    [anon_sym_constinit] = ACTIONS(3563),
    [anon_sym_consteval] = ACTIONS(3563),
    [anon_sym_alignas] = ACTIONS(3563),
    [anon_sym__Alignas] = ACTIONS(3563),
    [sym_primitive_type] = ACTIONS(3563),
    [anon_sym_enum] = ACTIONS(3563),
    [anon_sym_class] = ACTIONS(3563),
    [anon_sym_struct] = ACTIONS(3563),
    [anon_sym_union] = ACTIONS(3563),
    [anon_sym_if] = ACTIONS(3563),
    [anon_sym_switch] = ACTIONS(3563),
    [anon_sym_case] = ACTIONS(3563),
    [anon_sym_default] = ACTIONS(3563),
    [anon_sym_while] = ACTIONS(3563),
    [anon_sym_do] = ACTIONS(3563),
    [anon_sym_for] = ACTIONS(3563),
    [anon_sym_return] = ACTIONS(3563),
    [anon_sym_break] = ACTIONS(3563),
    [anon_sym_continue] = ACTIONS(3563),
    [anon_sym_goto] = ACTIONS(3563),
    [anon_sym_not] = ACTIONS(3563),
    [anon_sym_compl] = ACTIONS(3563),
    [anon_sym_DASH_DASH] = ACTIONS(3565),
    [anon_sym_PLUS_PLUS] = ACTIONS(3565),
    [anon_sym_sizeof] = ACTIONS(3563),
    [anon_sym___alignof__] = ACTIONS(3563),
    [anon_sym___alignof] = ACTIONS(3563),
    [anon_sym__alignof] = ACTIONS(3563),
    [anon_sym_alignof] = ACTIONS(3563),
    [anon_sym__Alignof] = ACTIONS(3563),
    [anon_sym_offsetof] = ACTIONS(3563),
    [anon_sym__Generic] = ACTIONS(3563),
    [anon_sym_asm] = ACTIONS(3563),
    [anon_sym___asm__] = ACTIONS(3563),
    [sym_number_literal] = ACTIONS(3565),
    [anon_sym_L_SQUOTE] = ACTIONS(3565),
    [anon_sym_u_SQUOTE] = ACTIONS(3565),
    [anon_sym_U_SQUOTE] = ACTIONS(3565),
    [anon_sym_u8_SQUOTE] = ACTIONS(3565),
    [anon_sym_SQUOTE] = ACTIONS(3565),
    [anon_sym_L_DQUOTE] = ACTIONS(3565),
    [anon_sym_u_DQUOTE] = ACTIONS(3565),
    [anon_sym_U_DQUOTE] = ACTIONS(3565),
    [anon_sym_u8_DQUOTE] = ACTIONS(3565),
    [anon_sym_DQUOTE] = ACTIONS(3565),
    [sym_true] = ACTIONS(3563),
    [sym_false] = ACTIONS(3563),
    [anon_sym_NULL] = ACTIONS(3563),
    [anon_sym_nullptr] = ACTIONS(3563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3563),
    [anon_sym_let] = ACTIONS(3563),
    [anon_sym_This] = ACTIONS(3563),
    [anon_sym_decltype] = ACTIONS(3563),
    [sym_virtual] = ACTIONS(3563),
    [anon_sym_explicit] = ACTIONS(3563),
    [anon_sym_typename] = ACTIONS(3563),
    [anon_sym_template] = ACTIONS(3563),
    [anon_sym_operator] = ACTIONS(3563),
    [anon_sym_try] = ACTIONS(3563),
    [anon_sym_delete] = ACTIONS(3563),
    [anon_sym_throw] = ACTIONS(3563),
    [anon_sym_namespace] = ACTIONS(3563),
    [anon_sym_using] = ACTIONS(3563),
    [anon_sym_static_assert] = ACTIONS(3563),
    [anon_sym_concept] = ACTIONS(3563),
    [anon_sym_co_return] = ACTIONS(3563),
    [anon_sym_co_yield] = ACTIONS(3563),
    [anon_sym_R_DQUOTE] = ACTIONS(3565),
    [anon_sym_LR_DQUOTE] = ACTIONS(3565),
    [anon_sym_uR_DQUOTE] = ACTIONS(3565),
    [anon_sym_UR_DQUOTE] = ACTIONS(3565),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3565),
    [anon_sym_co_await] = ACTIONS(3563),
    [anon_sym_new] = ACTIONS(3563),
    [anon_sym_requires] = ACTIONS(3563),
    [sym_this] = ACTIONS(3563),
    [anon_sym_precise] = ACTIONS(3563),
    [anon_sym_shared] = ACTIONS(3563),
    [anon_sym_groupshared] = ACTIONS(3563),
    [anon_sym_uniform] = ACTIONS(3563),
    [anon_sym_row_major] = ACTIONS(3563),
    [anon_sym_column_major] = ACTIONS(3563),
    [anon_sym_globallycoherent] = ACTIONS(3563),
    [anon_sym_centroid] = ACTIONS(3563),
    [anon_sym_noperspective] = ACTIONS(3563),
    [anon_sym_nointerpolation] = ACTIONS(3563),
    [anon_sym_sample] = ACTIONS(3563),
    [anon_sym_linear] = ACTIONS(3563),
    [anon_sym_snorm] = ACTIONS(3563),
    [anon_sym_unorm] = ACTIONS(3563),
    [anon_sym_point] = ACTIONS(3563),
    [anon_sym_line] = ACTIONS(3563),
    [anon_sym_triangleadj] = ACTIONS(3563),
    [anon_sym_lineadj] = ACTIONS(3563),
    [anon_sym_triangle] = ACTIONS(3563),
    [anon_sym_interface] = ACTIONS(3563),
    [anon_sym_extension] = ACTIONS(3563),
    [anon_sym___exported] = ACTIONS(3563),
    [anon_sym_import] = ACTIONS(3563),
  },
  [1005] = {
    [ts_builtin_sym_end] = ACTIONS(3581),
    [sym_identifier] = ACTIONS(3579),
    [aux_sym_preproc_include_token1] = ACTIONS(3579),
    [aux_sym_preproc_def_token1] = ACTIONS(3579),
    [aux_sym_preproc_if_token1] = ACTIONS(3579),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3579),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3579),
    [sym_preproc_directive] = ACTIONS(3579),
    [anon_sym_LPAREN2] = ACTIONS(3581),
    [anon_sym_BANG] = ACTIONS(3581),
    [anon_sym_TILDE] = ACTIONS(3581),
    [anon_sym_DASH] = ACTIONS(3579),
    [anon_sym_PLUS] = ACTIONS(3579),
    [anon_sym_STAR] = ACTIONS(3581),
    [anon_sym_AMP_AMP] = ACTIONS(3581),
    [anon_sym_AMP] = ACTIONS(3579),
    [anon_sym___extension__] = ACTIONS(3579),
    [anon_sym_typedef] = ACTIONS(3579),
    [anon_sym_in] = ACTIONS(3579),
    [anon_sym_out] = ACTIONS(3579),
    [anon_sym_inout] = ACTIONS(3579),
    [anon_sym_extern] = ACTIONS(3579),
    [anon_sym___attribute__] = ACTIONS(3579),
    [anon_sym_COLON_COLON] = ACTIONS(3581),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3581),
    [anon_sym___declspec] = ACTIONS(3579),
    [anon_sym___based] = ACTIONS(3579),
    [anon_sym___cdecl] = ACTIONS(3579),
    [anon_sym___clrcall] = ACTIONS(3579),
    [anon_sym___stdcall] = ACTIONS(3579),
    [anon_sym___fastcall] = ACTIONS(3579),
    [anon_sym___thiscall] = ACTIONS(3579),
    [anon_sym___vectorcall] = ACTIONS(3579),
    [anon_sym_LBRACE] = ACTIONS(3581),
    [anon_sym_signed] = ACTIONS(3579),
    [anon_sym_unsigned] = ACTIONS(3579),
    [anon_sym_long] = ACTIONS(3579),
    [anon_sym_short] = ACTIONS(3579),
    [anon_sym_LBRACK] = ACTIONS(3579),
    [anon_sym_static] = ACTIONS(3579),
    [anon_sym_register] = ACTIONS(3579),
    [anon_sym_inline] = ACTIONS(3579),
    [anon_sym___inline] = ACTIONS(3579),
    [anon_sym___inline__] = ACTIONS(3579),
    [anon_sym___forceinline] = ACTIONS(3579),
    [anon_sym_thread_local] = ACTIONS(3579),
    [anon_sym___thread] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3579),
    [anon_sym_constexpr] = ACTIONS(3579),
    [anon_sym_volatile] = ACTIONS(3579),
    [anon_sym_restrict] = ACTIONS(3579),
    [anon_sym___restrict__] = ACTIONS(3579),
    [anon_sym__Atomic] = ACTIONS(3579),
    [anon_sym__Noreturn] = ACTIONS(3579),
    [anon_sym_noreturn] = ACTIONS(3579),
    [anon_sym_mutable] = ACTIONS(3579),
    [anon_sym_constinit] = ACTIONS(3579),
    [anon_sym_consteval] = ACTIONS(3579),
    [anon_sym_alignas] = ACTIONS(3579),
    [anon_sym__Alignas] = ACTIONS(3579),
    [sym_primitive_type] = ACTIONS(3579),
    [anon_sym_enum] = ACTIONS(3579),
    [anon_sym_class] = ACTIONS(3579),
    [anon_sym_struct] = ACTIONS(3579),
    [anon_sym_union] = ACTIONS(3579),
    [anon_sym_if] = ACTIONS(3579),
    [anon_sym_switch] = ACTIONS(3579),
    [anon_sym_case] = ACTIONS(3579),
    [anon_sym_default] = ACTIONS(3579),
    [anon_sym_while] = ACTIONS(3579),
    [anon_sym_do] = ACTIONS(3579),
    [anon_sym_for] = ACTIONS(3579),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_break] = ACTIONS(3579),
    [anon_sym_continue] = ACTIONS(3579),
    [anon_sym_goto] = ACTIONS(3579),
    [anon_sym_not] = ACTIONS(3579),
    [anon_sym_compl] = ACTIONS(3579),
    [anon_sym_DASH_DASH] = ACTIONS(3581),
    [anon_sym_PLUS_PLUS] = ACTIONS(3581),
    [anon_sym_sizeof] = ACTIONS(3579),
    [anon_sym___alignof__] = ACTIONS(3579),
    [anon_sym___alignof] = ACTIONS(3579),
    [anon_sym__alignof] = ACTIONS(3579),
    [anon_sym_alignof] = ACTIONS(3579),
    [anon_sym__Alignof] = ACTIONS(3579),
    [anon_sym_offsetof] = ACTIONS(3579),
    [anon_sym__Generic] = ACTIONS(3579),
    [anon_sym_asm] = ACTIONS(3579),
    [anon_sym___asm__] = ACTIONS(3579),
    [sym_number_literal] = ACTIONS(3581),
    [anon_sym_L_SQUOTE] = ACTIONS(3581),
    [anon_sym_u_SQUOTE] = ACTIONS(3581),
    [anon_sym_U_SQUOTE] = ACTIONS(3581),
    [anon_sym_u8_SQUOTE] = ACTIONS(3581),
    [anon_sym_SQUOTE] = ACTIONS(3581),
    [anon_sym_L_DQUOTE] = ACTIONS(3581),
    [anon_sym_u_DQUOTE] = ACTIONS(3581),
    [anon_sym_U_DQUOTE] = ACTIONS(3581),
    [anon_sym_u8_DQUOTE] = ACTIONS(3581),
    [anon_sym_DQUOTE] = ACTIONS(3581),
    [sym_true] = ACTIONS(3579),
    [sym_false] = ACTIONS(3579),
    [anon_sym_NULL] = ACTIONS(3579),
    [anon_sym_nullptr] = ACTIONS(3579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3579),
    [anon_sym_let] = ACTIONS(3579),
    [anon_sym_This] = ACTIONS(3579),
    [anon_sym_decltype] = ACTIONS(3579),
    [sym_virtual] = ACTIONS(3579),
    [anon_sym_explicit] = ACTIONS(3579),
    [anon_sym_typename] = ACTIONS(3579),
    [anon_sym_template] = ACTIONS(3579),
    [anon_sym_operator] = ACTIONS(3579),
    [anon_sym_try] = ACTIONS(3579),
    [anon_sym_delete] = ACTIONS(3579),
    [anon_sym_throw] = ACTIONS(3579),
    [anon_sym_namespace] = ACTIONS(3579),
    [anon_sym_using] = ACTIONS(3579),
    [anon_sym_static_assert] = ACTIONS(3579),
    [anon_sym_concept] = ACTIONS(3579),
    [anon_sym_co_return] = ACTIONS(3579),
    [anon_sym_co_yield] = ACTIONS(3579),
    [anon_sym_R_DQUOTE] = ACTIONS(3581),
    [anon_sym_LR_DQUOTE] = ACTIONS(3581),
    [anon_sym_uR_DQUOTE] = ACTIONS(3581),
    [anon_sym_UR_DQUOTE] = ACTIONS(3581),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3581),
    [anon_sym_co_await] = ACTIONS(3579),
    [anon_sym_new] = ACTIONS(3579),
    [anon_sym_requires] = ACTIONS(3579),
    [sym_this] = ACTIONS(3579),
    [anon_sym_precise] = ACTIONS(3579),
    [anon_sym_shared] = ACTIONS(3579),
    [anon_sym_groupshared] = ACTIONS(3579),
    [anon_sym_uniform] = ACTIONS(3579),
    [anon_sym_row_major] = ACTIONS(3579),
    [anon_sym_column_major] = ACTIONS(3579),
    [anon_sym_globallycoherent] = ACTIONS(3579),
    [anon_sym_centroid] = ACTIONS(3579),
    [anon_sym_noperspective] = ACTIONS(3579),
    [anon_sym_nointerpolation] = ACTIONS(3579),
    [anon_sym_sample] = ACTIONS(3579),
    [anon_sym_linear] = ACTIONS(3579),
    [anon_sym_snorm] = ACTIONS(3579),
    [anon_sym_unorm] = ACTIONS(3579),
    [anon_sym_point] = ACTIONS(3579),
    [anon_sym_line] = ACTIONS(3579),
    [anon_sym_triangleadj] = ACTIONS(3579),
    [anon_sym_lineadj] = ACTIONS(3579),
    [anon_sym_triangle] = ACTIONS(3579),
    [anon_sym_interface] = ACTIONS(3579),
    [anon_sym_extension] = ACTIONS(3579),
    [anon_sym___exported] = ACTIONS(3579),
    [anon_sym_import] = ACTIONS(3579),
  },
  [1006] = {
    [ts_builtin_sym_end] = ACTIONS(3675),
    [sym_identifier] = ACTIONS(3673),
    [aux_sym_preproc_include_token1] = ACTIONS(3673),
    [aux_sym_preproc_def_token1] = ACTIONS(3673),
    [aux_sym_preproc_if_token1] = ACTIONS(3673),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3673),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3673),
    [sym_preproc_directive] = ACTIONS(3673),
    [anon_sym_LPAREN2] = ACTIONS(3675),
    [anon_sym_BANG] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3673),
    [anon_sym_PLUS] = ACTIONS(3673),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3673),
    [anon_sym___extension__] = ACTIONS(3673),
    [anon_sym_typedef] = ACTIONS(3673),
    [anon_sym_in] = ACTIONS(3673),
    [anon_sym_out] = ACTIONS(3673),
    [anon_sym_inout] = ACTIONS(3673),
    [anon_sym_extern] = ACTIONS(3673),
    [anon_sym___attribute__] = ACTIONS(3673),
    [anon_sym_COLON_COLON] = ACTIONS(3675),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3675),
    [anon_sym___declspec] = ACTIONS(3673),
    [anon_sym___based] = ACTIONS(3673),
    [anon_sym___cdecl] = ACTIONS(3673),
    [anon_sym___clrcall] = ACTIONS(3673),
    [anon_sym___stdcall] = ACTIONS(3673),
    [anon_sym___fastcall] = ACTIONS(3673),
    [anon_sym___thiscall] = ACTIONS(3673),
    [anon_sym___vectorcall] = ACTIONS(3673),
    [anon_sym_LBRACE] = ACTIONS(3675),
    [anon_sym_signed] = ACTIONS(3673),
    [anon_sym_unsigned] = ACTIONS(3673),
    [anon_sym_long] = ACTIONS(3673),
    [anon_sym_short] = ACTIONS(3673),
    [anon_sym_LBRACK] = ACTIONS(3673),
    [anon_sym_static] = ACTIONS(3673),
    [anon_sym_register] = ACTIONS(3673),
    [anon_sym_inline] = ACTIONS(3673),
    [anon_sym___inline] = ACTIONS(3673),
    [anon_sym___inline__] = ACTIONS(3673),
    [anon_sym___forceinline] = ACTIONS(3673),
    [anon_sym_thread_local] = ACTIONS(3673),
    [anon_sym___thread] = ACTIONS(3673),
    [anon_sym_const] = ACTIONS(3673),
    [anon_sym_constexpr] = ACTIONS(3673),
    [anon_sym_volatile] = ACTIONS(3673),
    [anon_sym_restrict] = ACTIONS(3673),
    [anon_sym___restrict__] = ACTIONS(3673),
    [anon_sym__Atomic] = ACTIONS(3673),
    [anon_sym__Noreturn] = ACTIONS(3673),
    [anon_sym_noreturn] = ACTIONS(3673),
    [anon_sym_mutable] = ACTIONS(3673),
    [anon_sym_constinit] = ACTIONS(3673),
    [anon_sym_consteval] = ACTIONS(3673),
    [anon_sym_alignas] = ACTIONS(3673),
    [anon_sym__Alignas] = ACTIONS(3673),
    [sym_primitive_type] = ACTIONS(3673),
    [anon_sym_enum] = ACTIONS(3673),
    [anon_sym_class] = ACTIONS(3673),
    [anon_sym_struct] = ACTIONS(3673),
    [anon_sym_union] = ACTIONS(3673),
    [anon_sym_if] = ACTIONS(3673),
    [anon_sym_switch] = ACTIONS(3673),
    [anon_sym_case] = ACTIONS(3673),
    [anon_sym_default] = ACTIONS(3673),
    [anon_sym_while] = ACTIONS(3673),
    [anon_sym_do] = ACTIONS(3673),
    [anon_sym_for] = ACTIONS(3673),
    [anon_sym_return] = ACTIONS(3673),
    [anon_sym_break] = ACTIONS(3673),
    [anon_sym_continue] = ACTIONS(3673),
    [anon_sym_goto] = ACTIONS(3673),
    [anon_sym_not] = ACTIONS(3673),
    [anon_sym_compl] = ACTIONS(3673),
    [anon_sym_DASH_DASH] = ACTIONS(3675),
    [anon_sym_PLUS_PLUS] = ACTIONS(3675),
    [anon_sym_sizeof] = ACTIONS(3673),
    [anon_sym___alignof__] = ACTIONS(3673),
    [anon_sym___alignof] = ACTIONS(3673),
    [anon_sym__alignof] = ACTIONS(3673),
    [anon_sym_alignof] = ACTIONS(3673),
    [anon_sym__Alignof] = ACTIONS(3673),
    [anon_sym_offsetof] = ACTIONS(3673),
    [anon_sym__Generic] = ACTIONS(3673),
    [anon_sym_asm] = ACTIONS(3673),
    [anon_sym___asm__] = ACTIONS(3673),
    [sym_number_literal] = ACTIONS(3675),
    [anon_sym_L_SQUOTE] = ACTIONS(3675),
    [anon_sym_u_SQUOTE] = ACTIONS(3675),
    [anon_sym_U_SQUOTE] = ACTIONS(3675),
    [anon_sym_u8_SQUOTE] = ACTIONS(3675),
    [anon_sym_SQUOTE] = ACTIONS(3675),
    [anon_sym_L_DQUOTE] = ACTIONS(3675),
    [anon_sym_u_DQUOTE] = ACTIONS(3675),
    [anon_sym_U_DQUOTE] = ACTIONS(3675),
    [anon_sym_u8_DQUOTE] = ACTIONS(3675),
    [anon_sym_DQUOTE] = ACTIONS(3675),
    [sym_true] = ACTIONS(3673),
    [sym_false] = ACTIONS(3673),
    [anon_sym_NULL] = ACTIONS(3673),
    [anon_sym_nullptr] = ACTIONS(3673),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3673),
    [anon_sym_let] = ACTIONS(3673),
    [anon_sym_This] = ACTIONS(3673),
    [anon_sym_decltype] = ACTIONS(3673),
    [sym_virtual] = ACTIONS(3673),
    [anon_sym_explicit] = ACTIONS(3673),
    [anon_sym_typename] = ACTIONS(3673),
    [anon_sym_template] = ACTIONS(3673),
    [anon_sym_operator] = ACTIONS(3673),
    [anon_sym_try] = ACTIONS(3673),
    [anon_sym_delete] = ACTIONS(3673),
    [anon_sym_throw] = ACTIONS(3673),
    [anon_sym_namespace] = ACTIONS(3673),
    [anon_sym_using] = ACTIONS(3673),
    [anon_sym_static_assert] = ACTIONS(3673),
    [anon_sym_concept] = ACTIONS(3673),
    [anon_sym_co_return] = ACTIONS(3673),
    [anon_sym_co_yield] = ACTIONS(3673),
    [anon_sym_R_DQUOTE] = ACTIONS(3675),
    [anon_sym_LR_DQUOTE] = ACTIONS(3675),
    [anon_sym_uR_DQUOTE] = ACTIONS(3675),
    [anon_sym_UR_DQUOTE] = ACTIONS(3675),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3675),
    [anon_sym_co_await] = ACTIONS(3673),
    [anon_sym_new] = ACTIONS(3673),
    [anon_sym_requires] = ACTIONS(3673),
    [sym_this] = ACTIONS(3673),
    [anon_sym_precise] = ACTIONS(3673),
    [anon_sym_shared] = ACTIONS(3673),
    [anon_sym_groupshared] = ACTIONS(3673),
    [anon_sym_uniform] = ACTIONS(3673),
    [anon_sym_row_major] = ACTIONS(3673),
    [anon_sym_column_major] = ACTIONS(3673),
    [anon_sym_globallycoherent] = ACTIONS(3673),
    [anon_sym_centroid] = ACTIONS(3673),
    [anon_sym_noperspective] = ACTIONS(3673),
    [anon_sym_nointerpolation] = ACTIONS(3673),
    [anon_sym_sample] = ACTIONS(3673),
    [anon_sym_linear] = ACTIONS(3673),
    [anon_sym_snorm] = ACTIONS(3673),
    [anon_sym_unorm] = ACTIONS(3673),
    [anon_sym_point] = ACTIONS(3673),
    [anon_sym_line] = ACTIONS(3673),
    [anon_sym_triangleadj] = ACTIONS(3673),
    [anon_sym_lineadj] = ACTIONS(3673),
    [anon_sym_triangle] = ACTIONS(3673),
    [anon_sym_interface] = ACTIONS(3673),
    [anon_sym_extension] = ACTIONS(3673),
    [anon_sym___exported] = ACTIONS(3673),
    [anon_sym_import] = ACTIONS(3673),
  },
  [1007] = {
    [ts_builtin_sym_end] = ACTIONS(3408),
    [sym_identifier] = ACTIONS(3406),
    [aux_sym_preproc_include_token1] = ACTIONS(3406),
    [aux_sym_preproc_def_token1] = ACTIONS(3406),
    [aux_sym_preproc_if_token1] = ACTIONS(3406),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3406),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3406),
    [sym_preproc_directive] = ACTIONS(3406),
    [anon_sym_LPAREN2] = ACTIONS(3408),
    [anon_sym_BANG] = ACTIONS(3408),
    [anon_sym_TILDE] = ACTIONS(3408),
    [anon_sym_DASH] = ACTIONS(3406),
    [anon_sym_PLUS] = ACTIONS(3406),
    [anon_sym_STAR] = ACTIONS(3408),
    [anon_sym_AMP_AMP] = ACTIONS(3408),
    [anon_sym_AMP] = ACTIONS(3406),
    [anon_sym___extension__] = ACTIONS(3406),
    [anon_sym_typedef] = ACTIONS(3406),
    [anon_sym_in] = ACTIONS(3406),
    [anon_sym_out] = ACTIONS(3406),
    [anon_sym_inout] = ACTIONS(3406),
    [anon_sym_extern] = ACTIONS(3406),
    [anon_sym___attribute__] = ACTIONS(3406),
    [anon_sym_COLON_COLON] = ACTIONS(3408),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3408),
    [anon_sym___declspec] = ACTIONS(3406),
    [anon_sym___based] = ACTIONS(3406),
    [anon_sym___cdecl] = ACTIONS(3406),
    [anon_sym___clrcall] = ACTIONS(3406),
    [anon_sym___stdcall] = ACTIONS(3406),
    [anon_sym___fastcall] = ACTIONS(3406),
    [anon_sym___thiscall] = ACTIONS(3406),
    [anon_sym___vectorcall] = ACTIONS(3406),
    [anon_sym_LBRACE] = ACTIONS(3408),
    [anon_sym_signed] = ACTIONS(3406),
    [anon_sym_unsigned] = ACTIONS(3406),
    [anon_sym_long] = ACTIONS(3406),
    [anon_sym_short] = ACTIONS(3406),
    [anon_sym_LBRACK] = ACTIONS(3406),
    [anon_sym_static] = ACTIONS(3406),
    [anon_sym_register] = ACTIONS(3406),
    [anon_sym_inline] = ACTIONS(3406),
    [anon_sym___inline] = ACTIONS(3406),
    [anon_sym___inline__] = ACTIONS(3406),
    [anon_sym___forceinline] = ACTIONS(3406),
    [anon_sym_thread_local] = ACTIONS(3406),
    [anon_sym___thread] = ACTIONS(3406),
    [anon_sym_const] = ACTIONS(3406),
    [anon_sym_constexpr] = ACTIONS(3406),
    [anon_sym_volatile] = ACTIONS(3406),
    [anon_sym_restrict] = ACTIONS(3406),
    [anon_sym___restrict__] = ACTIONS(3406),
    [anon_sym__Atomic] = ACTIONS(3406),
    [anon_sym__Noreturn] = ACTIONS(3406),
    [anon_sym_noreturn] = ACTIONS(3406),
    [anon_sym_mutable] = ACTIONS(3406),
    [anon_sym_constinit] = ACTIONS(3406),
    [anon_sym_consteval] = ACTIONS(3406),
    [anon_sym_alignas] = ACTIONS(3406),
    [anon_sym__Alignas] = ACTIONS(3406),
    [sym_primitive_type] = ACTIONS(3406),
    [anon_sym_enum] = ACTIONS(3406),
    [anon_sym_class] = ACTIONS(3406),
    [anon_sym_struct] = ACTIONS(3406),
    [anon_sym_union] = ACTIONS(3406),
    [anon_sym_if] = ACTIONS(3406),
    [anon_sym_switch] = ACTIONS(3406),
    [anon_sym_case] = ACTIONS(3406),
    [anon_sym_default] = ACTIONS(3406),
    [anon_sym_while] = ACTIONS(3406),
    [anon_sym_do] = ACTIONS(3406),
    [anon_sym_for] = ACTIONS(3406),
    [anon_sym_return] = ACTIONS(3406),
    [anon_sym_break] = ACTIONS(3406),
    [anon_sym_continue] = ACTIONS(3406),
    [anon_sym_goto] = ACTIONS(3406),
    [anon_sym_not] = ACTIONS(3406),
    [anon_sym_compl] = ACTIONS(3406),
    [anon_sym_DASH_DASH] = ACTIONS(3408),
    [anon_sym_PLUS_PLUS] = ACTIONS(3408),
    [anon_sym_sizeof] = ACTIONS(3406),
    [anon_sym___alignof__] = ACTIONS(3406),
    [anon_sym___alignof] = ACTIONS(3406),
    [anon_sym__alignof] = ACTIONS(3406),
    [anon_sym_alignof] = ACTIONS(3406),
    [anon_sym__Alignof] = ACTIONS(3406),
    [anon_sym_offsetof] = ACTIONS(3406),
    [anon_sym__Generic] = ACTIONS(3406),
    [anon_sym_asm] = ACTIONS(3406),
    [anon_sym___asm__] = ACTIONS(3406),
    [sym_number_literal] = ACTIONS(3408),
    [anon_sym_L_SQUOTE] = ACTIONS(3408),
    [anon_sym_u_SQUOTE] = ACTIONS(3408),
    [anon_sym_U_SQUOTE] = ACTIONS(3408),
    [anon_sym_u8_SQUOTE] = ACTIONS(3408),
    [anon_sym_SQUOTE] = ACTIONS(3408),
    [anon_sym_L_DQUOTE] = ACTIONS(3408),
    [anon_sym_u_DQUOTE] = ACTIONS(3408),
    [anon_sym_U_DQUOTE] = ACTIONS(3408),
    [anon_sym_u8_DQUOTE] = ACTIONS(3408),
    [anon_sym_DQUOTE] = ACTIONS(3408),
    [sym_true] = ACTIONS(3406),
    [sym_false] = ACTIONS(3406),
    [anon_sym_NULL] = ACTIONS(3406),
    [anon_sym_nullptr] = ACTIONS(3406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3406),
    [anon_sym_let] = ACTIONS(3406),
    [anon_sym_This] = ACTIONS(3406),
    [anon_sym_decltype] = ACTIONS(3406),
    [sym_virtual] = ACTIONS(3406),
    [anon_sym_explicit] = ACTIONS(3406),
    [anon_sym_typename] = ACTIONS(3406),
    [anon_sym_template] = ACTIONS(3406),
    [anon_sym_operator] = ACTIONS(3406),
    [anon_sym_try] = ACTIONS(3406),
    [anon_sym_delete] = ACTIONS(3406),
    [anon_sym_throw] = ACTIONS(3406),
    [anon_sym_namespace] = ACTIONS(3406),
    [anon_sym_using] = ACTIONS(3406),
    [anon_sym_static_assert] = ACTIONS(3406),
    [anon_sym_concept] = ACTIONS(3406),
    [anon_sym_co_return] = ACTIONS(3406),
    [anon_sym_co_yield] = ACTIONS(3406),
    [anon_sym_R_DQUOTE] = ACTIONS(3408),
    [anon_sym_LR_DQUOTE] = ACTIONS(3408),
    [anon_sym_uR_DQUOTE] = ACTIONS(3408),
    [anon_sym_UR_DQUOTE] = ACTIONS(3408),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3408),
    [anon_sym_co_await] = ACTIONS(3406),
    [anon_sym_new] = ACTIONS(3406),
    [anon_sym_requires] = ACTIONS(3406),
    [sym_this] = ACTIONS(3406),
    [anon_sym_precise] = ACTIONS(3406),
    [anon_sym_shared] = ACTIONS(3406),
    [anon_sym_groupshared] = ACTIONS(3406),
    [anon_sym_uniform] = ACTIONS(3406),
    [anon_sym_row_major] = ACTIONS(3406),
    [anon_sym_column_major] = ACTIONS(3406),
    [anon_sym_globallycoherent] = ACTIONS(3406),
    [anon_sym_centroid] = ACTIONS(3406),
    [anon_sym_noperspective] = ACTIONS(3406),
    [anon_sym_nointerpolation] = ACTIONS(3406),
    [anon_sym_sample] = ACTIONS(3406),
    [anon_sym_linear] = ACTIONS(3406),
    [anon_sym_snorm] = ACTIONS(3406),
    [anon_sym_unorm] = ACTIONS(3406),
    [anon_sym_point] = ACTIONS(3406),
    [anon_sym_line] = ACTIONS(3406),
    [anon_sym_triangleadj] = ACTIONS(3406),
    [anon_sym_lineadj] = ACTIONS(3406),
    [anon_sym_triangle] = ACTIONS(3406),
    [anon_sym_interface] = ACTIONS(3406),
    [anon_sym_extension] = ACTIONS(3406),
    [anon_sym___exported] = ACTIONS(3406),
    [anon_sym_import] = ACTIONS(3406),
  },
  [1008] = {
    [ts_builtin_sym_end] = ACTIONS(3439),
    [sym_identifier] = ACTIONS(3437),
    [aux_sym_preproc_include_token1] = ACTIONS(3437),
    [aux_sym_preproc_def_token1] = ACTIONS(3437),
    [aux_sym_preproc_if_token1] = ACTIONS(3437),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3437),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3437),
    [sym_preproc_directive] = ACTIONS(3437),
    [anon_sym_LPAREN2] = ACTIONS(3439),
    [anon_sym_BANG] = ACTIONS(3439),
    [anon_sym_TILDE] = ACTIONS(3439),
    [anon_sym_DASH] = ACTIONS(3437),
    [anon_sym_PLUS] = ACTIONS(3437),
    [anon_sym_STAR] = ACTIONS(3439),
    [anon_sym_AMP_AMP] = ACTIONS(3439),
    [anon_sym_AMP] = ACTIONS(3437),
    [anon_sym___extension__] = ACTIONS(3437),
    [anon_sym_typedef] = ACTIONS(3437),
    [anon_sym_in] = ACTIONS(3437),
    [anon_sym_out] = ACTIONS(3437),
    [anon_sym_inout] = ACTIONS(3437),
    [anon_sym_extern] = ACTIONS(3437),
    [anon_sym___attribute__] = ACTIONS(3437),
    [anon_sym_COLON_COLON] = ACTIONS(3439),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3439),
    [anon_sym___declspec] = ACTIONS(3437),
    [anon_sym___based] = ACTIONS(3437),
    [anon_sym___cdecl] = ACTIONS(3437),
    [anon_sym___clrcall] = ACTIONS(3437),
    [anon_sym___stdcall] = ACTIONS(3437),
    [anon_sym___fastcall] = ACTIONS(3437),
    [anon_sym___thiscall] = ACTIONS(3437),
    [anon_sym___vectorcall] = ACTIONS(3437),
    [anon_sym_LBRACE] = ACTIONS(3439),
    [anon_sym_signed] = ACTIONS(3437),
    [anon_sym_unsigned] = ACTIONS(3437),
    [anon_sym_long] = ACTIONS(3437),
    [anon_sym_short] = ACTIONS(3437),
    [anon_sym_LBRACK] = ACTIONS(3437),
    [anon_sym_static] = ACTIONS(3437),
    [anon_sym_register] = ACTIONS(3437),
    [anon_sym_inline] = ACTIONS(3437),
    [anon_sym___inline] = ACTIONS(3437),
    [anon_sym___inline__] = ACTIONS(3437),
    [anon_sym___forceinline] = ACTIONS(3437),
    [anon_sym_thread_local] = ACTIONS(3437),
    [anon_sym___thread] = ACTIONS(3437),
    [anon_sym_const] = ACTIONS(3437),
    [anon_sym_constexpr] = ACTIONS(3437),
    [anon_sym_volatile] = ACTIONS(3437),
    [anon_sym_restrict] = ACTIONS(3437),
    [anon_sym___restrict__] = ACTIONS(3437),
    [anon_sym__Atomic] = ACTIONS(3437),
    [anon_sym__Noreturn] = ACTIONS(3437),
    [anon_sym_noreturn] = ACTIONS(3437),
    [anon_sym_mutable] = ACTIONS(3437),
    [anon_sym_constinit] = ACTIONS(3437),
    [anon_sym_consteval] = ACTIONS(3437),
    [anon_sym_alignas] = ACTIONS(3437),
    [anon_sym__Alignas] = ACTIONS(3437),
    [sym_primitive_type] = ACTIONS(3437),
    [anon_sym_enum] = ACTIONS(3437),
    [anon_sym_class] = ACTIONS(3437),
    [anon_sym_struct] = ACTIONS(3437),
    [anon_sym_union] = ACTIONS(3437),
    [anon_sym_if] = ACTIONS(3437),
    [anon_sym_switch] = ACTIONS(3437),
    [anon_sym_case] = ACTIONS(3437),
    [anon_sym_default] = ACTIONS(3437),
    [anon_sym_while] = ACTIONS(3437),
    [anon_sym_do] = ACTIONS(3437),
    [anon_sym_for] = ACTIONS(3437),
    [anon_sym_return] = ACTIONS(3437),
    [anon_sym_break] = ACTIONS(3437),
    [anon_sym_continue] = ACTIONS(3437),
    [anon_sym_goto] = ACTIONS(3437),
    [anon_sym_not] = ACTIONS(3437),
    [anon_sym_compl] = ACTIONS(3437),
    [anon_sym_DASH_DASH] = ACTIONS(3439),
    [anon_sym_PLUS_PLUS] = ACTIONS(3439),
    [anon_sym_sizeof] = ACTIONS(3437),
    [anon_sym___alignof__] = ACTIONS(3437),
    [anon_sym___alignof] = ACTIONS(3437),
    [anon_sym__alignof] = ACTIONS(3437),
    [anon_sym_alignof] = ACTIONS(3437),
    [anon_sym__Alignof] = ACTIONS(3437),
    [anon_sym_offsetof] = ACTIONS(3437),
    [anon_sym__Generic] = ACTIONS(3437),
    [anon_sym_asm] = ACTIONS(3437),
    [anon_sym___asm__] = ACTIONS(3437),
    [sym_number_literal] = ACTIONS(3439),
    [anon_sym_L_SQUOTE] = ACTIONS(3439),
    [anon_sym_u_SQUOTE] = ACTIONS(3439),
    [anon_sym_U_SQUOTE] = ACTIONS(3439),
    [anon_sym_u8_SQUOTE] = ACTIONS(3439),
    [anon_sym_SQUOTE] = ACTIONS(3439),
    [anon_sym_L_DQUOTE] = ACTIONS(3439),
    [anon_sym_u_DQUOTE] = ACTIONS(3439),
    [anon_sym_U_DQUOTE] = ACTIONS(3439),
    [anon_sym_u8_DQUOTE] = ACTIONS(3439),
    [anon_sym_DQUOTE] = ACTIONS(3439),
    [sym_true] = ACTIONS(3437),
    [sym_false] = ACTIONS(3437),
    [anon_sym_NULL] = ACTIONS(3437),
    [anon_sym_nullptr] = ACTIONS(3437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3437),
    [anon_sym_let] = ACTIONS(3437),
    [anon_sym_This] = ACTIONS(3437),
    [anon_sym_decltype] = ACTIONS(3437),
    [sym_virtual] = ACTIONS(3437),
    [anon_sym_explicit] = ACTIONS(3437),
    [anon_sym_typename] = ACTIONS(3437),
    [anon_sym_template] = ACTIONS(3437),
    [anon_sym_operator] = ACTIONS(3437),
    [anon_sym_try] = ACTIONS(3437),
    [anon_sym_delete] = ACTIONS(3437),
    [anon_sym_throw] = ACTIONS(3437),
    [anon_sym_namespace] = ACTIONS(3437),
    [anon_sym_using] = ACTIONS(3437),
    [anon_sym_static_assert] = ACTIONS(3437),
    [anon_sym_concept] = ACTIONS(3437),
    [anon_sym_co_return] = ACTIONS(3437),
    [anon_sym_co_yield] = ACTIONS(3437),
    [anon_sym_R_DQUOTE] = ACTIONS(3439),
    [anon_sym_LR_DQUOTE] = ACTIONS(3439),
    [anon_sym_uR_DQUOTE] = ACTIONS(3439),
    [anon_sym_UR_DQUOTE] = ACTIONS(3439),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3439),
    [anon_sym_co_await] = ACTIONS(3437),
    [anon_sym_new] = ACTIONS(3437),
    [anon_sym_requires] = ACTIONS(3437),
    [sym_this] = ACTIONS(3437),
    [anon_sym_precise] = ACTIONS(3437),
    [anon_sym_shared] = ACTIONS(3437),
    [anon_sym_groupshared] = ACTIONS(3437),
    [anon_sym_uniform] = ACTIONS(3437),
    [anon_sym_row_major] = ACTIONS(3437),
    [anon_sym_column_major] = ACTIONS(3437),
    [anon_sym_globallycoherent] = ACTIONS(3437),
    [anon_sym_centroid] = ACTIONS(3437),
    [anon_sym_noperspective] = ACTIONS(3437),
    [anon_sym_nointerpolation] = ACTIONS(3437),
    [anon_sym_sample] = ACTIONS(3437),
    [anon_sym_linear] = ACTIONS(3437),
    [anon_sym_snorm] = ACTIONS(3437),
    [anon_sym_unorm] = ACTIONS(3437),
    [anon_sym_point] = ACTIONS(3437),
    [anon_sym_line] = ACTIONS(3437),
    [anon_sym_triangleadj] = ACTIONS(3437),
    [anon_sym_lineadj] = ACTIONS(3437),
    [anon_sym_triangle] = ACTIONS(3437),
    [anon_sym_interface] = ACTIONS(3437),
    [anon_sym_extension] = ACTIONS(3437),
    [anon_sym___exported] = ACTIONS(3437),
    [anon_sym_import] = ACTIONS(3437),
  },
  [1009] = {
    [ts_builtin_sym_end] = ACTIONS(3431),
    [sym_identifier] = ACTIONS(3429),
    [aux_sym_preproc_include_token1] = ACTIONS(3429),
    [aux_sym_preproc_def_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3429),
    [sym_preproc_directive] = ACTIONS(3429),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_BANG] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym___extension__] = ACTIONS(3429),
    [anon_sym_typedef] = ACTIONS(3429),
    [anon_sym_in] = ACTIONS(3429),
    [anon_sym_out] = ACTIONS(3429),
    [anon_sym_inout] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym___attribute__] = ACTIONS(3429),
    [anon_sym_COLON_COLON] = ACTIONS(3431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3431),
    [anon_sym___declspec] = ACTIONS(3429),
    [anon_sym___based] = ACTIONS(3429),
    [anon_sym___cdecl] = ACTIONS(3429),
    [anon_sym___clrcall] = ACTIONS(3429),
    [anon_sym___stdcall] = ACTIONS(3429),
    [anon_sym___fastcall] = ACTIONS(3429),
    [anon_sym___thiscall] = ACTIONS(3429),
    [anon_sym___vectorcall] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_signed] = ACTIONS(3429),
    [anon_sym_unsigned] = ACTIONS(3429),
    [anon_sym_long] = ACTIONS(3429),
    [anon_sym_short] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_register] = ACTIONS(3429),
    [anon_sym_inline] = ACTIONS(3429),
    [anon_sym___inline] = ACTIONS(3429),
    [anon_sym___inline__] = ACTIONS(3429),
    [anon_sym___forceinline] = ACTIONS(3429),
    [anon_sym_thread_local] = ACTIONS(3429),
    [anon_sym___thread] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_constexpr] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_restrict] = ACTIONS(3429),
    [anon_sym___restrict__] = ACTIONS(3429),
    [anon_sym__Atomic] = ACTIONS(3429),
    [anon_sym__Noreturn] = ACTIONS(3429),
    [anon_sym_noreturn] = ACTIONS(3429),
    [anon_sym_mutable] = ACTIONS(3429),
    [anon_sym_constinit] = ACTIONS(3429),
    [anon_sym_consteval] = ACTIONS(3429),
    [anon_sym_alignas] = ACTIONS(3429),
    [anon_sym__Alignas] = ACTIONS(3429),
    [sym_primitive_type] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [anon_sym_if] = ACTIONS(3429),
    [anon_sym_switch] = ACTIONS(3429),
    [anon_sym_case] = ACTIONS(3429),
    [anon_sym_default] = ACTIONS(3429),
    [anon_sym_while] = ACTIONS(3429),
    [anon_sym_do] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3429),
    [anon_sym_return] = ACTIONS(3429),
    [anon_sym_break] = ACTIONS(3429),
    [anon_sym_continue] = ACTIONS(3429),
    [anon_sym_goto] = ACTIONS(3429),
    [anon_sym_not] = ACTIONS(3429),
    [anon_sym_compl] = ACTIONS(3429),
    [anon_sym_DASH_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(3431),
    [anon_sym_sizeof] = ACTIONS(3429),
    [anon_sym___alignof__] = ACTIONS(3429),
    [anon_sym___alignof] = ACTIONS(3429),
    [anon_sym__alignof] = ACTIONS(3429),
    [anon_sym_alignof] = ACTIONS(3429),
    [anon_sym__Alignof] = ACTIONS(3429),
    [anon_sym_offsetof] = ACTIONS(3429),
    [anon_sym__Generic] = ACTIONS(3429),
    [anon_sym_asm] = ACTIONS(3429),
    [anon_sym___asm__] = ACTIONS(3429),
    [sym_number_literal] = ACTIONS(3431),
    [anon_sym_L_SQUOTE] = ACTIONS(3431),
    [anon_sym_u_SQUOTE] = ACTIONS(3431),
    [anon_sym_U_SQUOTE] = ACTIONS(3431),
    [anon_sym_u8_SQUOTE] = ACTIONS(3431),
    [anon_sym_SQUOTE] = ACTIONS(3431),
    [anon_sym_L_DQUOTE] = ACTIONS(3431),
    [anon_sym_u_DQUOTE] = ACTIONS(3431),
    [anon_sym_U_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [sym_true] = ACTIONS(3429),
    [sym_false] = ACTIONS(3429),
    [anon_sym_NULL] = ACTIONS(3429),
    [anon_sym_nullptr] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_This] = ACTIONS(3429),
    [anon_sym_decltype] = ACTIONS(3429),
    [sym_virtual] = ACTIONS(3429),
    [anon_sym_explicit] = ACTIONS(3429),
    [anon_sym_typename] = ACTIONS(3429),
    [anon_sym_template] = ACTIONS(3429),
    [anon_sym_operator] = ACTIONS(3429),
    [anon_sym_try] = ACTIONS(3429),
    [anon_sym_delete] = ACTIONS(3429),
    [anon_sym_throw] = ACTIONS(3429),
    [anon_sym_namespace] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_static_assert] = ACTIONS(3429),
    [anon_sym_concept] = ACTIONS(3429),
    [anon_sym_co_return] = ACTIONS(3429),
    [anon_sym_co_yield] = ACTIONS(3429),
    [anon_sym_R_DQUOTE] = ACTIONS(3431),
    [anon_sym_LR_DQUOTE] = ACTIONS(3431),
    [anon_sym_uR_DQUOTE] = ACTIONS(3431),
    [anon_sym_UR_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3431),
    [anon_sym_co_await] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3429),
    [anon_sym_requires] = ACTIONS(3429),
    [sym_this] = ACTIONS(3429),
    [anon_sym_precise] = ACTIONS(3429),
    [anon_sym_shared] = ACTIONS(3429),
    [anon_sym_groupshared] = ACTIONS(3429),
    [anon_sym_uniform] = ACTIONS(3429),
    [anon_sym_row_major] = ACTIONS(3429),
    [anon_sym_column_major] = ACTIONS(3429),
    [anon_sym_globallycoherent] = ACTIONS(3429),
    [anon_sym_centroid] = ACTIONS(3429),
    [anon_sym_noperspective] = ACTIONS(3429),
    [anon_sym_nointerpolation] = ACTIONS(3429),
    [anon_sym_sample] = ACTIONS(3429),
    [anon_sym_linear] = ACTIONS(3429),
    [anon_sym_snorm] = ACTIONS(3429),
    [anon_sym_unorm] = ACTIONS(3429),
    [anon_sym_point] = ACTIONS(3429),
    [anon_sym_line] = ACTIONS(3429),
    [anon_sym_triangleadj] = ACTIONS(3429),
    [anon_sym_lineadj] = ACTIONS(3429),
    [anon_sym_triangle] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_extension] = ACTIONS(3429),
    [anon_sym___exported] = ACTIONS(3429),
    [anon_sym_import] = ACTIONS(3429),
  },
  [1010] = {
    [ts_builtin_sym_end] = ACTIONS(3431),
    [sym_identifier] = ACTIONS(3429),
    [aux_sym_preproc_include_token1] = ACTIONS(3429),
    [aux_sym_preproc_def_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3429),
    [sym_preproc_directive] = ACTIONS(3429),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_BANG] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym___extension__] = ACTIONS(3429),
    [anon_sym_typedef] = ACTIONS(3429),
    [anon_sym_in] = ACTIONS(3429),
    [anon_sym_out] = ACTIONS(3429),
    [anon_sym_inout] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym___attribute__] = ACTIONS(3429),
    [anon_sym_COLON_COLON] = ACTIONS(3431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3431),
    [anon_sym___declspec] = ACTIONS(3429),
    [anon_sym___based] = ACTIONS(3429),
    [anon_sym___cdecl] = ACTIONS(3429),
    [anon_sym___clrcall] = ACTIONS(3429),
    [anon_sym___stdcall] = ACTIONS(3429),
    [anon_sym___fastcall] = ACTIONS(3429),
    [anon_sym___thiscall] = ACTIONS(3429),
    [anon_sym___vectorcall] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_signed] = ACTIONS(3429),
    [anon_sym_unsigned] = ACTIONS(3429),
    [anon_sym_long] = ACTIONS(3429),
    [anon_sym_short] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_register] = ACTIONS(3429),
    [anon_sym_inline] = ACTIONS(3429),
    [anon_sym___inline] = ACTIONS(3429),
    [anon_sym___inline__] = ACTIONS(3429),
    [anon_sym___forceinline] = ACTIONS(3429),
    [anon_sym_thread_local] = ACTIONS(3429),
    [anon_sym___thread] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_constexpr] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_restrict] = ACTIONS(3429),
    [anon_sym___restrict__] = ACTIONS(3429),
    [anon_sym__Atomic] = ACTIONS(3429),
    [anon_sym__Noreturn] = ACTIONS(3429),
    [anon_sym_noreturn] = ACTIONS(3429),
    [anon_sym_mutable] = ACTIONS(3429),
    [anon_sym_constinit] = ACTIONS(3429),
    [anon_sym_consteval] = ACTIONS(3429),
    [anon_sym_alignas] = ACTIONS(3429),
    [anon_sym__Alignas] = ACTIONS(3429),
    [sym_primitive_type] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [anon_sym_if] = ACTIONS(3429),
    [anon_sym_switch] = ACTIONS(3429),
    [anon_sym_case] = ACTIONS(3429),
    [anon_sym_default] = ACTIONS(3429),
    [anon_sym_while] = ACTIONS(3429),
    [anon_sym_do] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3429),
    [anon_sym_return] = ACTIONS(3429),
    [anon_sym_break] = ACTIONS(3429),
    [anon_sym_continue] = ACTIONS(3429),
    [anon_sym_goto] = ACTIONS(3429),
    [anon_sym_not] = ACTIONS(3429),
    [anon_sym_compl] = ACTIONS(3429),
    [anon_sym_DASH_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(3431),
    [anon_sym_sizeof] = ACTIONS(3429),
    [anon_sym___alignof__] = ACTIONS(3429),
    [anon_sym___alignof] = ACTIONS(3429),
    [anon_sym__alignof] = ACTIONS(3429),
    [anon_sym_alignof] = ACTIONS(3429),
    [anon_sym__Alignof] = ACTIONS(3429),
    [anon_sym_offsetof] = ACTIONS(3429),
    [anon_sym__Generic] = ACTIONS(3429),
    [anon_sym_asm] = ACTIONS(3429),
    [anon_sym___asm__] = ACTIONS(3429),
    [sym_number_literal] = ACTIONS(3431),
    [anon_sym_L_SQUOTE] = ACTIONS(3431),
    [anon_sym_u_SQUOTE] = ACTIONS(3431),
    [anon_sym_U_SQUOTE] = ACTIONS(3431),
    [anon_sym_u8_SQUOTE] = ACTIONS(3431),
    [anon_sym_SQUOTE] = ACTIONS(3431),
    [anon_sym_L_DQUOTE] = ACTIONS(3431),
    [anon_sym_u_DQUOTE] = ACTIONS(3431),
    [anon_sym_U_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [sym_true] = ACTIONS(3429),
    [sym_false] = ACTIONS(3429),
    [anon_sym_NULL] = ACTIONS(3429),
    [anon_sym_nullptr] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_This] = ACTIONS(3429),
    [anon_sym_decltype] = ACTIONS(3429),
    [sym_virtual] = ACTIONS(3429),
    [anon_sym_explicit] = ACTIONS(3429),
    [anon_sym_typename] = ACTIONS(3429),
    [anon_sym_template] = ACTIONS(3429),
    [anon_sym_operator] = ACTIONS(3429),
    [anon_sym_try] = ACTIONS(3429),
    [anon_sym_delete] = ACTIONS(3429),
    [anon_sym_throw] = ACTIONS(3429),
    [anon_sym_namespace] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_static_assert] = ACTIONS(3429),
    [anon_sym_concept] = ACTIONS(3429),
    [anon_sym_co_return] = ACTIONS(3429),
    [anon_sym_co_yield] = ACTIONS(3429),
    [anon_sym_R_DQUOTE] = ACTIONS(3431),
    [anon_sym_LR_DQUOTE] = ACTIONS(3431),
    [anon_sym_uR_DQUOTE] = ACTIONS(3431),
    [anon_sym_UR_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3431),
    [anon_sym_co_await] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3429),
    [anon_sym_requires] = ACTIONS(3429),
    [sym_this] = ACTIONS(3429),
    [anon_sym_precise] = ACTIONS(3429),
    [anon_sym_shared] = ACTIONS(3429),
    [anon_sym_groupshared] = ACTIONS(3429),
    [anon_sym_uniform] = ACTIONS(3429),
    [anon_sym_row_major] = ACTIONS(3429),
    [anon_sym_column_major] = ACTIONS(3429),
    [anon_sym_globallycoherent] = ACTIONS(3429),
    [anon_sym_centroid] = ACTIONS(3429),
    [anon_sym_noperspective] = ACTIONS(3429),
    [anon_sym_nointerpolation] = ACTIONS(3429),
    [anon_sym_sample] = ACTIONS(3429),
    [anon_sym_linear] = ACTIONS(3429),
    [anon_sym_snorm] = ACTIONS(3429),
    [anon_sym_unorm] = ACTIONS(3429),
    [anon_sym_point] = ACTIONS(3429),
    [anon_sym_line] = ACTIONS(3429),
    [anon_sym_triangleadj] = ACTIONS(3429),
    [anon_sym_lineadj] = ACTIONS(3429),
    [anon_sym_triangle] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_extension] = ACTIONS(3429),
    [anon_sym___exported] = ACTIONS(3429),
    [anon_sym_import] = ACTIONS(3429),
  },
  [1011] = {
    [ts_builtin_sym_end] = ACTIONS(3639),
    [sym_identifier] = ACTIONS(3637),
    [aux_sym_preproc_include_token1] = ACTIONS(3637),
    [aux_sym_preproc_def_token1] = ACTIONS(3637),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3637),
    [sym_preproc_directive] = ACTIONS(3637),
    [anon_sym_LPAREN2] = ACTIONS(3639),
    [anon_sym_BANG] = ACTIONS(3639),
    [anon_sym_TILDE] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3637),
    [anon_sym_STAR] = ACTIONS(3639),
    [anon_sym_AMP_AMP] = ACTIONS(3639),
    [anon_sym_AMP] = ACTIONS(3637),
    [anon_sym___extension__] = ACTIONS(3637),
    [anon_sym_typedef] = ACTIONS(3637),
    [anon_sym_in] = ACTIONS(3637),
    [anon_sym_out] = ACTIONS(3637),
    [anon_sym_inout] = ACTIONS(3637),
    [anon_sym_extern] = ACTIONS(3637),
    [anon_sym___attribute__] = ACTIONS(3637),
    [anon_sym_COLON_COLON] = ACTIONS(3639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3639),
    [anon_sym___declspec] = ACTIONS(3637),
    [anon_sym___based] = ACTIONS(3637),
    [anon_sym___cdecl] = ACTIONS(3637),
    [anon_sym___clrcall] = ACTIONS(3637),
    [anon_sym___stdcall] = ACTIONS(3637),
    [anon_sym___fastcall] = ACTIONS(3637),
    [anon_sym___thiscall] = ACTIONS(3637),
    [anon_sym___vectorcall] = ACTIONS(3637),
    [anon_sym_LBRACE] = ACTIONS(3639),
    [anon_sym_signed] = ACTIONS(3637),
    [anon_sym_unsigned] = ACTIONS(3637),
    [anon_sym_long] = ACTIONS(3637),
    [anon_sym_short] = ACTIONS(3637),
    [anon_sym_LBRACK] = ACTIONS(3637),
    [anon_sym_static] = ACTIONS(3637),
    [anon_sym_register] = ACTIONS(3637),
    [anon_sym_inline] = ACTIONS(3637),
    [anon_sym___inline] = ACTIONS(3637),
    [anon_sym___inline__] = ACTIONS(3637),
    [anon_sym___forceinline] = ACTIONS(3637),
    [anon_sym_thread_local] = ACTIONS(3637),
    [anon_sym___thread] = ACTIONS(3637),
    [anon_sym_const] = ACTIONS(3637),
    [anon_sym_constexpr] = ACTIONS(3637),
    [anon_sym_volatile] = ACTIONS(3637),
    [anon_sym_restrict] = ACTIONS(3637),
    [anon_sym___restrict__] = ACTIONS(3637),
    [anon_sym__Atomic] = ACTIONS(3637),
    [anon_sym__Noreturn] = ACTIONS(3637),
    [anon_sym_noreturn] = ACTIONS(3637),
    [anon_sym_mutable] = ACTIONS(3637),
    [anon_sym_constinit] = ACTIONS(3637),
    [anon_sym_consteval] = ACTIONS(3637),
    [anon_sym_alignas] = ACTIONS(3637),
    [anon_sym__Alignas] = ACTIONS(3637),
    [sym_primitive_type] = ACTIONS(3637),
    [anon_sym_enum] = ACTIONS(3637),
    [anon_sym_class] = ACTIONS(3637),
    [anon_sym_struct] = ACTIONS(3637),
    [anon_sym_union] = ACTIONS(3637),
    [anon_sym_if] = ACTIONS(3637),
    [anon_sym_switch] = ACTIONS(3637),
    [anon_sym_case] = ACTIONS(3637),
    [anon_sym_default] = ACTIONS(3637),
    [anon_sym_while] = ACTIONS(3637),
    [anon_sym_do] = ACTIONS(3637),
    [anon_sym_for] = ACTIONS(3637),
    [anon_sym_return] = ACTIONS(3637),
    [anon_sym_break] = ACTIONS(3637),
    [anon_sym_continue] = ACTIONS(3637),
    [anon_sym_goto] = ACTIONS(3637),
    [anon_sym_not] = ACTIONS(3637),
    [anon_sym_compl] = ACTIONS(3637),
    [anon_sym_DASH_DASH] = ACTIONS(3639),
    [anon_sym_PLUS_PLUS] = ACTIONS(3639),
    [anon_sym_sizeof] = ACTIONS(3637),
    [anon_sym___alignof__] = ACTIONS(3637),
    [anon_sym___alignof] = ACTIONS(3637),
    [anon_sym__alignof] = ACTIONS(3637),
    [anon_sym_alignof] = ACTIONS(3637),
    [anon_sym__Alignof] = ACTIONS(3637),
    [anon_sym_offsetof] = ACTIONS(3637),
    [anon_sym__Generic] = ACTIONS(3637),
    [anon_sym_asm] = ACTIONS(3637),
    [anon_sym___asm__] = ACTIONS(3637),
    [sym_number_literal] = ACTIONS(3639),
    [anon_sym_L_SQUOTE] = ACTIONS(3639),
    [anon_sym_u_SQUOTE] = ACTIONS(3639),
    [anon_sym_U_SQUOTE] = ACTIONS(3639),
    [anon_sym_u8_SQUOTE] = ACTIONS(3639),
    [anon_sym_SQUOTE] = ACTIONS(3639),
    [anon_sym_L_DQUOTE] = ACTIONS(3639),
    [anon_sym_u_DQUOTE] = ACTIONS(3639),
    [anon_sym_U_DQUOTE] = ACTIONS(3639),
    [anon_sym_u8_DQUOTE] = ACTIONS(3639),
    [anon_sym_DQUOTE] = ACTIONS(3639),
    [sym_true] = ACTIONS(3637),
    [sym_false] = ACTIONS(3637),
    [anon_sym_NULL] = ACTIONS(3637),
    [anon_sym_nullptr] = ACTIONS(3637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3637),
    [anon_sym_let] = ACTIONS(3637),
    [anon_sym_This] = ACTIONS(3637),
    [anon_sym_decltype] = ACTIONS(3637),
    [sym_virtual] = ACTIONS(3637),
    [anon_sym_explicit] = ACTIONS(3637),
    [anon_sym_typename] = ACTIONS(3637),
    [anon_sym_template] = ACTIONS(3637),
    [anon_sym_operator] = ACTIONS(3637),
    [anon_sym_try] = ACTIONS(3637),
    [anon_sym_delete] = ACTIONS(3637),
    [anon_sym_throw] = ACTIONS(3637),
    [anon_sym_namespace] = ACTIONS(3637),
    [anon_sym_using] = ACTIONS(3637),
    [anon_sym_static_assert] = ACTIONS(3637),
    [anon_sym_concept] = ACTIONS(3637),
    [anon_sym_co_return] = ACTIONS(3637),
    [anon_sym_co_yield] = ACTIONS(3637),
    [anon_sym_R_DQUOTE] = ACTIONS(3639),
    [anon_sym_LR_DQUOTE] = ACTIONS(3639),
    [anon_sym_uR_DQUOTE] = ACTIONS(3639),
    [anon_sym_UR_DQUOTE] = ACTIONS(3639),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3639),
    [anon_sym_co_await] = ACTIONS(3637),
    [anon_sym_new] = ACTIONS(3637),
    [anon_sym_requires] = ACTIONS(3637),
    [sym_this] = ACTIONS(3637),
    [anon_sym_precise] = ACTIONS(3637),
    [anon_sym_shared] = ACTIONS(3637),
    [anon_sym_groupshared] = ACTIONS(3637),
    [anon_sym_uniform] = ACTIONS(3637),
    [anon_sym_row_major] = ACTIONS(3637),
    [anon_sym_column_major] = ACTIONS(3637),
    [anon_sym_globallycoherent] = ACTIONS(3637),
    [anon_sym_centroid] = ACTIONS(3637),
    [anon_sym_noperspective] = ACTIONS(3637),
    [anon_sym_nointerpolation] = ACTIONS(3637),
    [anon_sym_sample] = ACTIONS(3637),
    [anon_sym_linear] = ACTIONS(3637),
    [anon_sym_snorm] = ACTIONS(3637),
    [anon_sym_unorm] = ACTIONS(3637),
    [anon_sym_point] = ACTIONS(3637),
    [anon_sym_line] = ACTIONS(3637),
    [anon_sym_triangleadj] = ACTIONS(3637),
    [anon_sym_lineadj] = ACTIONS(3637),
    [anon_sym_triangle] = ACTIONS(3637),
    [anon_sym_interface] = ACTIONS(3637),
    [anon_sym_extension] = ACTIONS(3637),
    [anon_sym___exported] = ACTIONS(3637),
    [anon_sym_import] = ACTIONS(3637),
  },
  [1012] = {
    [ts_builtin_sym_end] = ACTIONS(3561),
    [sym_identifier] = ACTIONS(3559),
    [aux_sym_preproc_include_token1] = ACTIONS(3559),
    [aux_sym_preproc_def_token1] = ACTIONS(3559),
    [aux_sym_preproc_if_token1] = ACTIONS(3559),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3559),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3559),
    [sym_preproc_directive] = ACTIONS(3559),
    [anon_sym_LPAREN2] = ACTIONS(3561),
    [anon_sym_BANG] = ACTIONS(3561),
    [anon_sym_TILDE] = ACTIONS(3561),
    [anon_sym_DASH] = ACTIONS(3559),
    [anon_sym_PLUS] = ACTIONS(3559),
    [anon_sym_STAR] = ACTIONS(3561),
    [anon_sym_AMP_AMP] = ACTIONS(3561),
    [anon_sym_AMP] = ACTIONS(3559),
    [anon_sym___extension__] = ACTIONS(3559),
    [anon_sym_typedef] = ACTIONS(3559),
    [anon_sym_in] = ACTIONS(3559),
    [anon_sym_out] = ACTIONS(3559),
    [anon_sym_inout] = ACTIONS(3559),
    [anon_sym_extern] = ACTIONS(3559),
    [anon_sym___attribute__] = ACTIONS(3559),
    [anon_sym_COLON_COLON] = ACTIONS(3561),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3561),
    [anon_sym___declspec] = ACTIONS(3559),
    [anon_sym___based] = ACTIONS(3559),
    [anon_sym___cdecl] = ACTIONS(3559),
    [anon_sym___clrcall] = ACTIONS(3559),
    [anon_sym___stdcall] = ACTIONS(3559),
    [anon_sym___fastcall] = ACTIONS(3559),
    [anon_sym___thiscall] = ACTIONS(3559),
    [anon_sym___vectorcall] = ACTIONS(3559),
    [anon_sym_LBRACE] = ACTIONS(3561),
    [anon_sym_signed] = ACTIONS(3559),
    [anon_sym_unsigned] = ACTIONS(3559),
    [anon_sym_long] = ACTIONS(3559),
    [anon_sym_short] = ACTIONS(3559),
    [anon_sym_LBRACK] = ACTIONS(3559),
    [anon_sym_static] = ACTIONS(3559),
    [anon_sym_register] = ACTIONS(3559),
    [anon_sym_inline] = ACTIONS(3559),
    [anon_sym___inline] = ACTIONS(3559),
    [anon_sym___inline__] = ACTIONS(3559),
    [anon_sym___forceinline] = ACTIONS(3559),
    [anon_sym_thread_local] = ACTIONS(3559),
    [anon_sym___thread] = ACTIONS(3559),
    [anon_sym_const] = ACTIONS(3559),
    [anon_sym_constexpr] = ACTIONS(3559),
    [anon_sym_volatile] = ACTIONS(3559),
    [anon_sym_restrict] = ACTIONS(3559),
    [anon_sym___restrict__] = ACTIONS(3559),
    [anon_sym__Atomic] = ACTIONS(3559),
    [anon_sym__Noreturn] = ACTIONS(3559),
    [anon_sym_noreturn] = ACTIONS(3559),
    [anon_sym_mutable] = ACTIONS(3559),
    [anon_sym_constinit] = ACTIONS(3559),
    [anon_sym_consteval] = ACTIONS(3559),
    [anon_sym_alignas] = ACTIONS(3559),
    [anon_sym__Alignas] = ACTIONS(3559),
    [sym_primitive_type] = ACTIONS(3559),
    [anon_sym_enum] = ACTIONS(3559),
    [anon_sym_class] = ACTIONS(3559),
    [anon_sym_struct] = ACTIONS(3559),
    [anon_sym_union] = ACTIONS(3559),
    [anon_sym_if] = ACTIONS(3559),
    [anon_sym_switch] = ACTIONS(3559),
    [anon_sym_case] = ACTIONS(3559),
    [anon_sym_default] = ACTIONS(3559),
    [anon_sym_while] = ACTIONS(3559),
    [anon_sym_do] = ACTIONS(3559),
    [anon_sym_for] = ACTIONS(3559),
    [anon_sym_return] = ACTIONS(3559),
    [anon_sym_break] = ACTIONS(3559),
    [anon_sym_continue] = ACTIONS(3559),
    [anon_sym_goto] = ACTIONS(3559),
    [anon_sym_not] = ACTIONS(3559),
    [anon_sym_compl] = ACTIONS(3559),
    [anon_sym_DASH_DASH] = ACTIONS(3561),
    [anon_sym_PLUS_PLUS] = ACTIONS(3561),
    [anon_sym_sizeof] = ACTIONS(3559),
    [anon_sym___alignof__] = ACTIONS(3559),
    [anon_sym___alignof] = ACTIONS(3559),
    [anon_sym__alignof] = ACTIONS(3559),
    [anon_sym_alignof] = ACTIONS(3559),
    [anon_sym__Alignof] = ACTIONS(3559),
    [anon_sym_offsetof] = ACTIONS(3559),
    [anon_sym__Generic] = ACTIONS(3559),
    [anon_sym_asm] = ACTIONS(3559),
    [anon_sym___asm__] = ACTIONS(3559),
    [sym_number_literal] = ACTIONS(3561),
    [anon_sym_L_SQUOTE] = ACTIONS(3561),
    [anon_sym_u_SQUOTE] = ACTIONS(3561),
    [anon_sym_U_SQUOTE] = ACTIONS(3561),
    [anon_sym_u8_SQUOTE] = ACTIONS(3561),
    [anon_sym_SQUOTE] = ACTIONS(3561),
    [anon_sym_L_DQUOTE] = ACTIONS(3561),
    [anon_sym_u_DQUOTE] = ACTIONS(3561),
    [anon_sym_U_DQUOTE] = ACTIONS(3561),
    [anon_sym_u8_DQUOTE] = ACTIONS(3561),
    [anon_sym_DQUOTE] = ACTIONS(3561),
    [sym_true] = ACTIONS(3559),
    [sym_false] = ACTIONS(3559),
    [anon_sym_NULL] = ACTIONS(3559),
    [anon_sym_nullptr] = ACTIONS(3559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3559),
    [anon_sym_let] = ACTIONS(3559),
    [anon_sym_This] = ACTIONS(3559),
    [anon_sym_decltype] = ACTIONS(3559),
    [sym_virtual] = ACTIONS(3559),
    [anon_sym_explicit] = ACTIONS(3559),
    [anon_sym_typename] = ACTIONS(3559),
    [anon_sym_template] = ACTIONS(3559),
    [anon_sym_operator] = ACTIONS(3559),
    [anon_sym_try] = ACTIONS(3559),
    [anon_sym_delete] = ACTIONS(3559),
    [anon_sym_throw] = ACTIONS(3559),
    [anon_sym_namespace] = ACTIONS(3559),
    [anon_sym_using] = ACTIONS(3559),
    [anon_sym_static_assert] = ACTIONS(3559),
    [anon_sym_concept] = ACTIONS(3559),
    [anon_sym_co_return] = ACTIONS(3559),
    [anon_sym_co_yield] = ACTIONS(3559),
    [anon_sym_R_DQUOTE] = ACTIONS(3561),
    [anon_sym_LR_DQUOTE] = ACTIONS(3561),
    [anon_sym_uR_DQUOTE] = ACTIONS(3561),
    [anon_sym_UR_DQUOTE] = ACTIONS(3561),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3561),
    [anon_sym_co_await] = ACTIONS(3559),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_requires] = ACTIONS(3559),
    [sym_this] = ACTIONS(3559),
    [anon_sym_precise] = ACTIONS(3559),
    [anon_sym_shared] = ACTIONS(3559),
    [anon_sym_groupshared] = ACTIONS(3559),
    [anon_sym_uniform] = ACTIONS(3559),
    [anon_sym_row_major] = ACTIONS(3559),
    [anon_sym_column_major] = ACTIONS(3559),
    [anon_sym_globallycoherent] = ACTIONS(3559),
    [anon_sym_centroid] = ACTIONS(3559),
    [anon_sym_noperspective] = ACTIONS(3559),
    [anon_sym_nointerpolation] = ACTIONS(3559),
    [anon_sym_sample] = ACTIONS(3559),
    [anon_sym_linear] = ACTIONS(3559),
    [anon_sym_snorm] = ACTIONS(3559),
    [anon_sym_unorm] = ACTIONS(3559),
    [anon_sym_point] = ACTIONS(3559),
    [anon_sym_line] = ACTIONS(3559),
    [anon_sym_triangleadj] = ACTIONS(3559),
    [anon_sym_lineadj] = ACTIONS(3559),
    [anon_sym_triangle] = ACTIONS(3559),
    [anon_sym_interface] = ACTIONS(3559),
    [anon_sym_extension] = ACTIONS(3559),
    [anon_sym___exported] = ACTIONS(3559),
    [anon_sym_import] = ACTIONS(3559),
  },
  [1013] = {
    [ts_builtin_sym_end] = ACTIONS(3557),
    [sym_identifier] = ACTIONS(3555),
    [aux_sym_preproc_include_token1] = ACTIONS(3555),
    [aux_sym_preproc_def_token1] = ACTIONS(3555),
    [aux_sym_preproc_if_token1] = ACTIONS(3555),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3555),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3555),
    [sym_preproc_directive] = ACTIONS(3555),
    [anon_sym_LPAREN2] = ACTIONS(3557),
    [anon_sym_BANG] = ACTIONS(3557),
    [anon_sym_TILDE] = ACTIONS(3557),
    [anon_sym_DASH] = ACTIONS(3555),
    [anon_sym_PLUS] = ACTIONS(3555),
    [anon_sym_STAR] = ACTIONS(3557),
    [anon_sym_AMP_AMP] = ACTIONS(3557),
    [anon_sym_AMP] = ACTIONS(3555),
    [anon_sym___extension__] = ACTIONS(3555),
    [anon_sym_typedef] = ACTIONS(3555),
    [anon_sym_in] = ACTIONS(3555),
    [anon_sym_out] = ACTIONS(3555),
    [anon_sym_inout] = ACTIONS(3555),
    [anon_sym_extern] = ACTIONS(3555),
    [anon_sym___attribute__] = ACTIONS(3555),
    [anon_sym_COLON_COLON] = ACTIONS(3557),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3557),
    [anon_sym___declspec] = ACTIONS(3555),
    [anon_sym___based] = ACTIONS(3555),
    [anon_sym___cdecl] = ACTIONS(3555),
    [anon_sym___clrcall] = ACTIONS(3555),
    [anon_sym___stdcall] = ACTIONS(3555),
    [anon_sym___fastcall] = ACTIONS(3555),
    [anon_sym___thiscall] = ACTIONS(3555),
    [anon_sym___vectorcall] = ACTIONS(3555),
    [anon_sym_LBRACE] = ACTIONS(3557),
    [anon_sym_signed] = ACTIONS(3555),
    [anon_sym_unsigned] = ACTIONS(3555),
    [anon_sym_long] = ACTIONS(3555),
    [anon_sym_short] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3555),
    [anon_sym_static] = ACTIONS(3555),
    [anon_sym_register] = ACTIONS(3555),
    [anon_sym_inline] = ACTIONS(3555),
    [anon_sym___inline] = ACTIONS(3555),
    [anon_sym___inline__] = ACTIONS(3555),
    [anon_sym___forceinline] = ACTIONS(3555),
    [anon_sym_thread_local] = ACTIONS(3555),
    [anon_sym___thread] = ACTIONS(3555),
    [anon_sym_const] = ACTIONS(3555),
    [anon_sym_constexpr] = ACTIONS(3555),
    [anon_sym_volatile] = ACTIONS(3555),
    [anon_sym_restrict] = ACTIONS(3555),
    [anon_sym___restrict__] = ACTIONS(3555),
    [anon_sym__Atomic] = ACTIONS(3555),
    [anon_sym__Noreturn] = ACTIONS(3555),
    [anon_sym_noreturn] = ACTIONS(3555),
    [anon_sym_mutable] = ACTIONS(3555),
    [anon_sym_constinit] = ACTIONS(3555),
    [anon_sym_consteval] = ACTIONS(3555),
    [anon_sym_alignas] = ACTIONS(3555),
    [anon_sym__Alignas] = ACTIONS(3555),
    [sym_primitive_type] = ACTIONS(3555),
    [anon_sym_enum] = ACTIONS(3555),
    [anon_sym_class] = ACTIONS(3555),
    [anon_sym_struct] = ACTIONS(3555),
    [anon_sym_union] = ACTIONS(3555),
    [anon_sym_if] = ACTIONS(3555),
    [anon_sym_switch] = ACTIONS(3555),
    [anon_sym_case] = ACTIONS(3555),
    [anon_sym_default] = ACTIONS(3555),
    [anon_sym_while] = ACTIONS(3555),
    [anon_sym_do] = ACTIONS(3555),
    [anon_sym_for] = ACTIONS(3555),
    [anon_sym_return] = ACTIONS(3555),
    [anon_sym_break] = ACTIONS(3555),
    [anon_sym_continue] = ACTIONS(3555),
    [anon_sym_goto] = ACTIONS(3555),
    [anon_sym_not] = ACTIONS(3555),
    [anon_sym_compl] = ACTIONS(3555),
    [anon_sym_DASH_DASH] = ACTIONS(3557),
    [anon_sym_PLUS_PLUS] = ACTIONS(3557),
    [anon_sym_sizeof] = ACTIONS(3555),
    [anon_sym___alignof__] = ACTIONS(3555),
    [anon_sym___alignof] = ACTIONS(3555),
    [anon_sym__alignof] = ACTIONS(3555),
    [anon_sym_alignof] = ACTIONS(3555),
    [anon_sym__Alignof] = ACTIONS(3555),
    [anon_sym_offsetof] = ACTIONS(3555),
    [anon_sym__Generic] = ACTIONS(3555),
    [anon_sym_asm] = ACTIONS(3555),
    [anon_sym___asm__] = ACTIONS(3555),
    [sym_number_literal] = ACTIONS(3557),
    [anon_sym_L_SQUOTE] = ACTIONS(3557),
    [anon_sym_u_SQUOTE] = ACTIONS(3557),
    [anon_sym_U_SQUOTE] = ACTIONS(3557),
    [anon_sym_u8_SQUOTE] = ACTIONS(3557),
    [anon_sym_SQUOTE] = ACTIONS(3557),
    [anon_sym_L_DQUOTE] = ACTIONS(3557),
    [anon_sym_u_DQUOTE] = ACTIONS(3557),
    [anon_sym_U_DQUOTE] = ACTIONS(3557),
    [anon_sym_u8_DQUOTE] = ACTIONS(3557),
    [anon_sym_DQUOTE] = ACTIONS(3557),
    [sym_true] = ACTIONS(3555),
    [sym_false] = ACTIONS(3555),
    [anon_sym_NULL] = ACTIONS(3555),
    [anon_sym_nullptr] = ACTIONS(3555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3555),
    [anon_sym_let] = ACTIONS(3555),
    [anon_sym_This] = ACTIONS(3555),
    [anon_sym_decltype] = ACTIONS(3555),
    [sym_virtual] = ACTIONS(3555),
    [anon_sym_explicit] = ACTIONS(3555),
    [anon_sym_typename] = ACTIONS(3555),
    [anon_sym_template] = ACTIONS(3555),
    [anon_sym_operator] = ACTIONS(3555),
    [anon_sym_try] = ACTIONS(3555),
    [anon_sym_delete] = ACTIONS(3555),
    [anon_sym_throw] = ACTIONS(3555),
    [anon_sym_namespace] = ACTIONS(3555),
    [anon_sym_using] = ACTIONS(3555),
    [anon_sym_static_assert] = ACTIONS(3555),
    [anon_sym_concept] = ACTIONS(3555),
    [anon_sym_co_return] = ACTIONS(3555),
    [anon_sym_co_yield] = ACTIONS(3555),
    [anon_sym_R_DQUOTE] = ACTIONS(3557),
    [anon_sym_LR_DQUOTE] = ACTIONS(3557),
    [anon_sym_uR_DQUOTE] = ACTIONS(3557),
    [anon_sym_UR_DQUOTE] = ACTIONS(3557),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3557),
    [anon_sym_co_await] = ACTIONS(3555),
    [anon_sym_new] = ACTIONS(3555),
    [anon_sym_requires] = ACTIONS(3555),
    [sym_this] = ACTIONS(3555),
    [anon_sym_precise] = ACTIONS(3555),
    [anon_sym_shared] = ACTIONS(3555),
    [anon_sym_groupshared] = ACTIONS(3555),
    [anon_sym_uniform] = ACTIONS(3555),
    [anon_sym_row_major] = ACTIONS(3555),
    [anon_sym_column_major] = ACTIONS(3555),
    [anon_sym_globallycoherent] = ACTIONS(3555),
    [anon_sym_centroid] = ACTIONS(3555),
    [anon_sym_noperspective] = ACTIONS(3555),
    [anon_sym_nointerpolation] = ACTIONS(3555),
    [anon_sym_sample] = ACTIONS(3555),
    [anon_sym_linear] = ACTIONS(3555),
    [anon_sym_snorm] = ACTIONS(3555),
    [anon_sym_unorm] = ACTIONS(3555),
    [anon_sym_point] = ACTIONS(3555),
    [anon_sym_line] = ACTIONS(3555),
    [anon_sym_triangleadj] = ACTIONS(3555),
    [anon_sym_lineadj] = ACTIONS(3555),
    [anon_sym_triangle] = ACTIONS(3555),
    [anon_sym_interface] = ACTIONS(3555),
    [anon_sym_extension] = ACTIONS(3555),
    [anon_sym___exported] = ACTIONS(3555),
    [anon_sym_import] = ACTIONS(3555),
  },
  [1014] = {
    [ts_builtin_sym_end] = ACTIONS(3451),
    [sym_identifier] = ACTIONS(3449),
    [aux_sym_preproc_include_token1] = ACTIONS(3449),
    [aux_sym_preproc_def_token1] = ACTIONS(3449),
    [aux_sym_preproc_if_token1] = ACTIONS(3449),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3449),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3449),
    [sym_preproc_directive] = ACTIONS(3449),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_BANG] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3449),
    [anon_sym_PLUS] = ACTIONS(3449),
    [anon_sym_STAR] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_AMP] = ACTIONS(3449),
    [anon_sym___extension__] = ACTIONS(3449),
    [anon_sym_typedef] = ACTIONS(3449),
    [anon_sym_in] = ACTIONS(3449),
    [anon_sym_out] = ACTIONS(3449),
    [anon_sym_inout] = ACTIONS(3449),
    [anon_sym_extern] = ACTIONS(3449),
    [anon_sym___attribute__] = ACTIONS(3449),
    [anon_sym_COLON_COLON] = ACTIONS(3451),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3451),
    [anon_sym___declspec] = ACTIONS(3449),
    [anon_sym___based] = ACTIONS(3449),
    [anon_sym___cdecl] = ACTIONS(3449),
    [anon_sym___clrcall] = ACTIONS(3449),
    [anon_sym___stdcall] = ACTIONS(3449),
    [anon_sym___fastcall] = ACTIONS(3449),
    [anon_sym___thiscall] = ACTIONS(3449),
    [anon_sym___vectorcall] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_signed] = ACTIONS(3449),
    [anon_sym_unsigned] = ACTIONS(3449),
    [anon_sym_long] = ACTIONS(3449),
    [anon_sym_short] = ACTIONS(3449),
    [anon_sym_LBRACK] = ACTIONS(3449),
    [anon_sym_static] = ACTIONS(3449),
    [anon_sym_register] = ACTIONS(3449),
    [anon_sym_inline] = ACTIONS(3449),
    [anon_sym___inline] = ACTIONS(3449),
    [anon_sym___inline__] = ACTIONS(3449),
    [anon_sym___forceinline] = ACTIONS(3449),
    [anon_sym_thread_local] = ACTIONS(3449),
    [anon_sym___thread] = ACTIONS(3449),
    [anon_sym_const] = ACTIONS(3449),
    [anon_sym_constexpr] = ACTIONS(3449),
    [anon_sym_volatile] = ACTIONS(3449),
    [anon_sym_restrict] = ACTIONS(3449),
    [anon_sym___restrict__] = ACTIONS(3449),
    [anon_sym__Atomic] = ACTIONS(3449),
    [anon_sym__Noreturn] = ACTIONS(3449),
    [anon_sym_noreturn] = ACTIONS(3449),
    [anon_sym_mutable] = ACTIONS(3449),
    [anon_sym_constinit] = ACTIONS(3449),
    [anon_sym_consteval] = ACTIONS(3449),
    [anon_sym_alignas] = ACTIONS(3449),
    [anon_sym__Alignas] = ACTIONS(3449),
    [sym_primitive_type] = ACTIONS(3449),
    [anon_sym_enum] = ACTIONS(3449),
    [anon_sym_class] = ACTIONS(3449),
    [anon_sym_struct] = ACTIONS(3449),
    [anon_sym_union] = ACTIONS(3449),
    [anon_sym_if] = ACTIONS(3449),
    [anon_sym_switch] = ACTIONS(3449),
    [anon_sym_case] = ACTIONS(3449),
    [anon_sym_default] = ACTIONS(3449),
    [anon_sym_while] = ACTIONS(3449),
    [anon_sym_do] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3449),
    [anon_sym_return] = ACTIONS(3449),
    [anon_sym_break] = ACTIONS(3449),
    [anon_sym_continue] = ACTIONS(3449),
    [anon_sym_goto] = ACTIONS(3449),
    [anon_sym_not] = ACTIONS(3449),
    [anon_sym_compl] = ACTIONS(3449),
    [anon_sym_DASH_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_PLUS] = ACTIONS(3451),
    [anon_sym_sizeof] = ACTIONS(3449),
    [anon_sym___alignof__] = ACTIONS(3449),
    [anon_sym___alignof] = ACTIONS(3449),
    [anon_sym__alignof] = ACTIONS(3449),
    [anon_sym_alignof] = ACTIONS(3449),
    [anon_sym__Alignof] = ACTIONS(3449),
    [anon_sym_offsetof] = ACTIONS(3449),
    [anon_sym__Generic] = ACTIONS(3449),
    [anon_sym_asm] = ACTIONS(3449),
    [anon_sym___asm__] = ACTIONS(3449),
    [sym_number_literal] = ACTIONS(3451),
    [anon_sym_L_SQUOTE] = ACTIONS(3451),
    [anon_sym_u_SQUOTE] = ACTIONS(3451),
    [anon_sym_U_SQUOTE] = ACTIONS(3451),
    [anon_sym_u8_SQUOTE] = ACTIONS(3451),
    [anon_sym_SQUOTE] = ACTIONS(3451),
    [anon_sym_L_DQUOTE] = ACTIONS(3451),
    [anon_sym_u_DQUOTE] = ACTIONS(3451),
    [anon_sym_U_DQUOTE] = ACTIONS(3451),
    [anon_sym_u8_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [sym_true] = ACTIONS(3449),
    [sym_false] = ACTIONS(3449),
    [anon_sym_NULL] = ACTIONS(3449),
    [anon_sym_nullptr] = ACTIONS(3449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3449),
    [anon_sym_let] = ACTIONS(3449),
    [anon_sym_This] = ACTIONS(3449),
    [anon_sym_decltype] = ACTIONS(3449),
    [sym_virtual] = ACTIONS(3449),
    [anon_sym_explicit] = ACTIONS(3449),
    [anon_sym_typename] = ACTIONS(3449),
    [anon_sym_template] = ACTIONS(3449),
    [anon_sym_operator] = ACTIONS(3449),
    [anon_sym_try] = ACTIONS(3449),
    [anon_sym_delete] = ACTIONS(3449),
    [anon_sym_throw] = ACTIONS(3449),
    [anon_sym_namespace] = ACTIONS(3449),
    [anon_sym_using] = ACTIONS(3449),
    [anon_sym_static_assert] = ACTIONS(3449),
    [anon_sym_concept] = ACTIONS(3449),
    [anon_sym_co_return] = ACTIONS(3449),
    [anon_sym_co_yield] = ACTIONS(3449),
    [anon_sym_R_DQUOTE] = ACTIONS(3451),
    [anon_sym_LR_DQUOTE] = ACTIONS(3451),
    [anon_sym_uR_DQUOTE] = ACTIONS(3451),
    [anon_sym_UR_DQUOTE] = ACTIONS(3451),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3451),
    [anon_sym_co_await] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3449),
    [anon_sym_requires] = ACTIONS(3449),
    [sym_this] = ACTIONS(3449),
    [anon_sym_precise] = ACTIONS(3449),
    [anon_sym_shared] = ACTIONS(3449),
    [anon_sym_groupshared] = ACTIONS(3449),
    [anon_sym_uniform] = ACTIONS(3449),
    [anon_sym_row_major] = ACTIONS(3449),
    [anon_sym_column_major] = ACTIONS(3449),
    [anon_sym_globallycoherent] = ACTIONS(3449),
    [anon_sym_centroid] = ACTIONS(3449),
    [anon_sym_noperspective] = ACTIONS(3449),
    [anon_sym_nointerpolation] = ACTIONS(3449),
    [anon_sym_sample] = ACTIONS(3449),
    [anon_sym_linear] = ACTIONS(3449),
    [anon_sym_snorm] = ACTIONS(3449),
    [anon_sym_unorm] = ACTIONS(3449),
    [anon_sym_point] = ACTIONS(3449),
    [anon_sym_line] = ACTIONS(3449),
    [anon_sym_triangleadj] = ACTIONS(3449),
    [anon_sym_lineadj] = ACTIONS(3449),
    [anon_sym_triangle] = ACTIONS(3449),
    [anon_sym_interface] = ACTIONS(3449),
    [anon_sym_extension] = ACTIONS(3449),
    [anon_sym___exported] = ACTIONS(3449),
    [anon_sym_import] = ACTIONS(3449),
  },
  [1015] = {
    [ts_builtin_sym_end] = ACTIONS(3457),
    [sym_identifier] = ACTIONS(3455),
    [aux_sym_preproc_include_token1] = ACTIONS(3455),
    [aux_sym_preproc_def_token1] = ACTIONS(3455),
    [aux_sym_preproc_if_token1] = ACTIONS(3455),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3455),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3455),
    [sym_preproc_directive] = ACTIONS(3455),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_BANG] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3457),
    [anon_sym_DASH] = ACTIONS(3455),
    [anon_sym_PLUS] = ACTIONS(3455),
    [anon_sym_STAR] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3457),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym___extension__] = ACTIONS(3455),
    [anon_sym_typedef] = ACTIONS(3455),
    [anon_sym_in] = ACTIONS(3455),
    [anon_sym_out] = ACTIONS(3455),
    [anon_sym_inout] = ACTIONS(3455),
    [anon_sym_extern] = ACTIONS(3455),
    [anon_sym___attribute__] = ACTIONS(3455),
    [anon_sym_COLON_COLON] = ACTIONS(3457),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3457),
    [anon_sym___declspec] = ACTIONS(3455),
    [anon_sym___based] = ACTIONS(3455),
    [anon_sym___cdecl] = ACTIONS(3455),
    [anon_sym___clrcall] = ACTIONS(3455),
    [anon_sym___stdcall] = ACTIONS(3455),
    [anon_sym___fastcall] = ACTIONS(3455),
    [anon_sym___thiscall] = ACTIONS(3455),
    [anon_sym___vectorcall] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_signed] = ACTIONS(3455),
    [anon_sym_unsigned] = ACTIONS(3455),
    [anon_sym_long] = ACTIONS(3455),
    [anon_sym_short] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_static] = ACTIONS(3455),
    [anon_sym_register] = ACTIONS(3455),
    [anon_sym_inline] = ACTIONS(3455),
    [anon_sym___inline] = ACTIONS(3455),
    [anon_sym___inline__] = ACTIONS(3455),
    [anon_sym___forceinline] = ACTIONS(3455),
    [anon_sym_thread_local] = ACTIONS(3455),
    [anon_sym___thread] = ACTIONS(3455),
    [anon_sym_const] = ACTIONS(3455),
    [anon_sym_constexpr] = ACTIONS(3455),
    [anon_sym_volatile] = ACTIONS(3455),
    [anon_sym_restrict] = ACTIONS(3455),
    [anon_sym___restrict__] = ACTIONS(3455),
    [anon_sym__Atomic] = ACTIONS(3455),
    [anon_sym__Noreturn] = ACTIONS(3455),
    [anon_sym_noreturn] = ACTIONS(3455),
    [anon_sym_mutable] = ACTIONS(3455),
    [anon_sym_constinit] = ACTIONS(3455),
    [anon_sym_consteval] = ACTIONS(3455),
    [anon_sym_alignas] = ACTIONS(3455),
    [anon_sym__Alignas] = ACTIONS(3455),
    [sym_primitive_type] = ACTIONS(3455),
    [anon_sym_enum] = ACTIONS(3455),
    [anon_sym_class] = ACTIONS(3455),
    [anon_sym_struct] = ACTIONS(3455),
    [anon_sym_union] = ACTIONS(3455),
    [anon_sym_if] = ACTIONS(3455),
    [anon_sym_switch] = ACTIONS(3455),
    [anon_sym_case] = ACTIONS(3455),
    [anon_sym_default] = ACTIONS(3455),
    [anon_sym_while] = ACTIONS(3455),
    [anon_sym_do] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3455),
    [anon_sym_return] = ACTIONS(3455),
    [anon_sym_break] = ACTIONS(3455),
    [anon_sym_continue] = ACTIONS(3455),
    [anon_sym_goto] = ACTIONS(3455),
    [anon_sym_not] = ACTIONS(3455),
    [anon_sym_compl] = ACTIONS(3455),
    [anon_sym_DASH_DASH] = ACTIONS(3457),
    [anon_sym_PLUS_PLUS] = ACTIONS(3457),
    [anon_sym_sizeof] = ACTIONS(3455),
    [anon_sym___alignof__] = ACTIONS(3455),
    [anon_sym___alignof] = ACTIONS(3455),
    [anon_sym__alignof] = ACTIONS(3455),
    [anon_sym_alignof] = ACTIONS(3455),
    [anon_sym__Alignof] = ACTIONS(3455),
    [anon_sym_offsetof] = ACTIONS(3455),
    [anon_sym__Generic] = ACTIONS(3455),
    [anon_sym_asm] = ACTIONS(3455),
    [anon_sym___asm__] = ACTIONS(3455),
    [sym_number_literal] = ACTIONS(3457),
    [anon_sym_L_SQUOTE] = ACTIONS(3457),
    [anon_sym_u_SQUOTE] = ACTIONS(3457),
    [anon_sym_U_SQUOTE] = ACTIONS(3457),
    [anon_sym_u8_SQUOTE] = ACTIONS(3457),
    [anon_sym_SQUOTE] = ACTIONS(3457),
    [anon_sym_L_DQUOTE] = ACTIONS(3457),
    [anon_sym_u_DQUOTE] = ACTIONS(3457),
    [anon_sym_U_DQUOTE] = ACTIONS(3457),
    [anon_sym_u8_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [sym_true] = ACTIONS(3455),
    [sym_false] = ACTIONS(3455),
    [anon_sym_NULL] = ACTIONS(3455),
    [anon_sym_nullptr] = ACTIONS(3455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3455),
    [anon_sym_let] = ACTIONS(3455),
    [anon_sym_This] = ACTIONS(3455),
    [anon_sym_decltype] = ACTIONS(3455),
    [sym_virtual] = ACTIONS(3455),
    [anon_sym_explicit] = ACTIONS(3455),
    [anon_sym_typename] = ACTIONS(3455),
    [anon_sym_template] = ACTIONS(3455),
    [anon_sym_operator] = ACTIONS(3455),
    [anon_sym_try] = ACTIONS(3455),
    [anon_sym_delete] = ACTIONS(3455),
    [anon_sym_throw] = ACTIONS(3455),
    [anon_sym_namespace] = ACTIONS(3455),
    [anon_sym_using] = ACTIONS(3455),
    [anon_sym_static_assert] = ACTIONS(3455),
    [anon_sym_concept] = ACTIONS(3455),
    [anon_sym_co_return] = ACTIONS(3455),
    [anon_sym_co_yield] = ACTIONS(3455),
    [anon_sym_R_DQUOTE] = ACTIONS(3457),
    [anon_sym_LR_DQUOTE] = ACTIONS(3457),
    [anon_sym_uR_DQUOTE] = ACTIONS(3457),
    [anon_sym_UR_DQUOTE] = ACTIONS(3457),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3457),
    [anon_sym_co_await] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_requires] = ACTIONS(3455),
    [sym_this] = ACTIONS(3455),
    [anon_sym_precise] = ACTIONS(3455),
    [anon_sym_shared] = ACTIONS(3455),
    [anon_sym_groupshared] = ACTIONS(3455),
    [anon_sym_uniform] = ACTIONS(3455),
    [anon_sym_row_major] = ACTIONS(3455),
    [anon_sym_column_major] = ACTIONS(3455),
    [anon_sym_globallycoherent] = ACTIONS(3455),
    [anon_sym_centroid] = ACTIONS(3455),
    [anon_sym_noperspective] = ACTIONS(3455),
    [anon_sym_nointerpolation] = ACTIONS(3455),
    [anon_sym_sample] = ACTIONS(3455),
    [anon_sym_linear] = ACTIONS(3455),
    [anon_sym_snorm] = ACTIONS(3455),
    [anon_sym_unorm] = ACTIONS(3455),
    [anon_sym_point] = ACTIONS(3455),
    [anon_sym_line] = ACTIONS(3455),
    [anon_sym_triangleadj] = ACTIONS(3455),
    [anon_sym_lineadj] = ACTIONS(3455),
    [anon_sym_triangle] = ACTIONS(3455),
    [anon_sym_interface] = ACTIONS(3455),
    [anon_sym_extension] = ACTIONS(3455),
    [anon_sym___exported] = ACTIONS(3455),
    [anon_sym_import] = ACTIONS(3455),
  },
  [1016] = {
    [ts_builtin_sym_end] = ACTIONS(3549),
    [sym_identifier] = ACTIONS(3547),
    [aux_sym_preproc_include_token1] = ACTIONS(3547),
    [aux_sym_preproc_def_token1] = ACTIONS(3547),
    [aux_sym_preproc_if_token1] = ACTIONS(3547),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3547),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3547),
    [sym_preproc_directive] = ACTIONS(3547),
    [anon_sym_LPAREN2] = ACTIONS(3549),
    [anon_sym_BANG] = ACTIONS(3549),
    [anon_sym_TILDE] = ACTIONS(3549),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_STAR] = ACTIONS(3549),
    [anon_sym_AMP_AMP] = ACTIONS(3549),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym___extension__] = ACTIONS(3547),
    [anon_sym_typedef] = ACTIONS(3547),
    [anon_sym_in] = ACTIONS(3547),
    [anon_sym_out] = ACTIONS(3547),
    [anon_sym_inout] = ACTIONS(3547),
    [anon_sym_extern] = ACTIONS(3547),
    [anon_sym___attribute__] = ACTIONS(3547),
    [anon_sym_COLON_COLON] = ACTIONS(3549),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3549),
    [anon_sym___declspec] = ACTIONS(3547),
    [anon_sym___based] = ACTIONS(3547),
    [anon_sym___cdecl] = ACTIONS(3547),
    [anon_sym___clrcall] = ACTIONS(3547),
    [anon_sym___stdcall] = ACTIONS(3547),
    [anon_sym___fastcall] = ACTIONS(3547),
    [anon_sym___thiscall] = ACTIONS(3547),
    [anon_sym___vectorcall] = ACTIONS(3547),
    [anon_sym_LBRACE] = ACTIONS(3549),
    [anon_sym_signed] = ACTIONS(3547),
    [anon_sym_unsigned] = ACTIONS(3547),
    [anon_sym_long] = ACTIONS(3547),
    [anon_sym_short] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_static] = ACTIONS(3547),
    [anon_sym_register] = ACTIONS(3547),
    [anon_sym_inline] = ACTIONS(3547),
    [anon_sym___inline] = ACTIONS(3547),
    [anon_sym___inline__] = ACTIONS(3547),
    [anon_sym___forceinline] = ACTIONS(3547),
    [anon_sym_thread_local] = ACTIONS(3547),
    [anon_sym___thread] = ACTIONS(3547),
    [anon_sym_const] = ACTIONS(3547),
    [anon_sym_constexpr] = ACTIONS(3547),
    [anon_sym_volatile] = ACTIONS(3547),
    [anon_sym_restrict] = ACTIONS(3547),
    [anon_sym___restrict__] = ACTIONS(3547),
    [anon_sym__Atomic] = ACTIONS(3547),
    [anon_sym__Noreturn] = ACTIONS(3547),
    [anon_sym_noreturn] = ACTIONS(3547),
    [anon_sym_mutable] = ACTIONS(3547),
    [anon_sym_constinit] = ACTIONS(3547),
    [anon_sym_consteval] = ACTIONS(3547),
    [anon_sym_alignas] = ACTIONS(3547),
    [anon_sym__Alignas] = ACTIONS(3547),
    [sym_primitive_type] = ACTIONS(3547),
    [anon_sym_enum] = ACTIONS(3547),
    [anon_sym_class] = ACTIONS(3547),
    [anon_sym_struct] = ACTIONS(3547),
    [anon_sym_union] = ACTIONS(3547),
    [anon_sym_if] = ACTIONS(3547),
    [anon_sym_switch] = ACTIONS(3547),
    [anon_sym_case] = ACTIONS(3547),
    [anon_sym_default] = ACTIONS(3547),
    [anon_sym_while] = ACTIONS(3547),
    [anon_sym_do] = ACTIONS(3547),
    [anon_sym_for] = ACTIONS(3547),
    [anon_sym_return] = ACTIONS(3547),
    [anon_sym_break] = ACTIONS(3547),
    [anon_sym_continue] = ACTIONS(3547),
    [anon_sym_goto] = ACTIONS(3547),
    [anon_sym_not] = ACTIONS(3547),
    [anon_sym_compl] = ACTIONS(3547),
    [anon_sym_DASH_DASH] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(3549),
    [anon_sym_sizeof] = ACTIONS(3547),
    [anon_sym___alignof__] = ACTIONS(3547),
    [anon_sym___alignof] = ACTIONS(3547),
    [anon_sym__alignof] = ACTIONS(3547),
    [anon_sym_alignof] = ACTIONS(3547),
    [anon_sym__Alignof] = ACTIONS(3547),
    [anon_sym_offsetof] = ACTIONS(3547),
    [anon_sym__Generic] = ACTIONS(3547),
    [anon_sym_asm] = ACTIONS(3547),
    [anon_sym___asm__] = ACTIONS(3547),
    [sym_number_literal] = ACTIONS(3549),
    [anon_sym_L_SQUOTE] = ACTIONS(3549),
    [anon_sym_u_SQUOTE] = ACTIONS(3549),
    [anon_sym_U_SQUOTE] = ACTIONS(3549),
    [anon_sym_u8_SQUOTE] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [anon_sym_L_DQUOTE] = ACTIONS(3549),
    [anon_sym_u_DQUOTE] = ACTIONS(3549),
    [anon_sym_U_DQUOTE] = ACTIONS(3549),
    [anon_sym_u8_DQUOTE] = ACTIONS(3549),
    [anon_sym_DQUOTE] = ACTIONS(3549),
    [sym_true] = ACTIONS(3547),
    [sym_false] = ACTIONS(3547),
    [anon_sym_NULL] = ACTIONS(3547),
    [anon_sym_nullptr] = ACTIONS(3547),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_This] = ACTIONS(3547),
    [anon_sym_decltype] = ACTIONS(3547),
    [sym_virtual] = ACTIONS(3547),
    [anon_sym_explicit] = ACTIONS(3547),
    [anon_sym_typename] = ACTIONS(3547),
    [anon_sym_template] = ACTIONS(3547),
    [anon_sym_operator] = ACTIONS(3547),
    [anon_sym_try] = ACTIONS(3547),
    [anon_sym_delete] = ACTIONS(3547),
    [anon_sym_throw] = ACTIONS(3547),
    [anon_sym_namespace] = ACTIONS(3547),
    [anon_sym_using] = ACTIONS(3547),
    [anon_sym_static_assert] = ACTIONS(3547),
    [anon_sym_concept] = ACTIONS(3547),
    [anon_sym_co_return] = ACTIONS(3547),
    [anon_sym_co_yield] = ACTIONS(3547),
    [anon_sym_R_DQUOTE] = ACTIONS(3549),
    [anon_sym_LR_DQUOTE] = ACTIONS(3549),
    [anon_sym_uR_DQUOTE] = ACTIONS(3549),
    [anon_sym_UR_DQUOTE] = ACTIONS(3549),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3549),
    [anon_sym_co_await] = ACTIONS(3547),
    [anon_sym_new] = ACTIONS(3547),
    [anon_sym_requires] = ACTIONS(3547),
    [sym_this] = ACTIONS(3547),
    [anon_sym_precise] = ACTIONS(3547),
    [anon_sym_shared] = ACTIONS(3547),
    [anon_sym_groupshared] = ACTIONS(3547),
    [anon_sym_uniform] = ACTIONS(3547),
    [anon_sym_row_major] = ACTIONS(3547),
    [anon_sym_column_major] = ACTIONS(3547),
    [anon_sym_globallycoherent] = ACTIONS(3547),
    [anon_sym_centroid] = ACTIONS(3547),
    [anon_sym_noperspective] = ACTIONS(3547),
    [anon_sym_nointerpolation] = ACTIONS(3547),
    [anon_sym_sample] = ACTIONS(3547),
    [anon_sym_linear] = ACTIONS(3547),
    [anon_sym_snorm] = ACTIONS(3547),
    [anon_sym_unorm] = ACTIONS(3547),
    [anon_sym_point] = ACTIONS(3547),
    [anon_sym_line] = ACTIONS(3547),
    [anon_sym_triangleadj] = ACTIONS(3547),
    [anon_sym_lineadj] = ACTIONS(3547),
    [anon_sym_triangle] = ACTIONS(3547),
    [anon_sym_interface] = ACTIONS(3547),
    [anon_sym_extension] = ACTIONS(3547),
    [anon_sym___exported] = ACTIONS(3547),
    [anon_sym_import] = ACTIONS(3547),
  },
  [1017] = {
    [ts_builtin_sym_end] = ACTIONS(3511),
    [sym_identifier] = ACTIONS(3509),
    [aux_sym_preproc_include_token1] = ACTIONS(3509),
    [aux_sym_preproc_def_token1] = ACTIONS(3509),
    [aux_sym_preproc_if_token1] = ACTIONS(3509),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3509),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3509),
    [sym_preproc_directive] = ACTIONS(3509),
    [anon_sym_LPAREN2] = ACTIONS(3511),
    [anon_sym_BANG] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3509),
    [anon_sym_PLUS] = ACTIONS(3509),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3511),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym___extension__] = ACTIONS(3509),
    [anon_sym_typedef] = ACTIONS(3509),
    [anon_sym_in] = ACTIONS(3509),
    [anon_sym_out] = ACTIONS(3509),
    [anon_sym_inout] = ACTIONS(3509),
    [anon_sym_extern] = ACTIONS(3509),
    [anon_sym___attribute__] = ACTIONS(3509),
    [anon_sym_COLON_COLON] = ACTIONS(3511),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3511),
    [anon_sym___declspec] = ACTIONS(3509),
    [anon_sym___based] = ACTIONS(3509),
    [anon_sym___cdecl] = ACTIONS(3509),
    [anon_sym___clrcall] = ACTIONS(3509),
    [anon_sym___stdcall] = ACTIONS(3509),
    [anon_sym___fastcall] = ACTIONS(3509),
    [anon_sym___thiscall] = ACTIONS(3509),
    [anon_sym___vectorcall] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_signed] = ACTIONS(3509),
    [anon_sym_unsigned] = ACTIONS(3509),
    [anon_sym_long] = ACTIONS(3509),
    [anon_sym_short] = ACTIONS(3509),
    [anon_sym_LBRACK] = ACTIONS(3509),
    [anon_sym_static] = ACTIONS(3509),
    [anon_sym_register] = ACTIONS(3509),
    [anon_sym_inline] = ACTIONS(3509),
    [anon_sym___inline] = ACTIONS(3509),
    [anon_sym___inline__] = ACTIONS(3509),
    [anon_sym___forceinline] = ACTIONS(3509),
    [anon_sym_thread_local] = ACTIONS(3509),
    [anon_sym___thread] = ACTIONS(3509),
    [anon_sym_const] = ACTIONS(3509),
    [anon_sym_constexpr] = ACTIONS(3509),
    [anon_sym_volatile] = ACTIONS(3509),
    [anon_sym_restrict] = ACTIONS(3509),
    [anon_sym___restrict__] = ACTIONS(3509),
    [anon_sym__Atomic] = ACTIONS(3509),
    [anon_sym__Noreturn] = ACTIONS(3509),
    [anon_sym_noreturn] = ACTIONS(3509),
    [anon_sym_mutable] = ACTIONS(3509),
    [anon_sym_constinit] = ACTIONS(3509),
    [anon_sym_consteval] = ACTIONS(3509),
    [anon_sym_alignas] = ACTIONS(3509),
    [anon_sym__Alignas] = ACTIONS(3509),
    [sym_primitive_type] = ACTIONS(3509),
    [anon_sym_enum] = ACTIONS(3509),
    [anon_sym_class] = ACTIONS(3509),
    [anon_sym_struct] = ACTIONS(3509),
    [anon_sym_union] = ACTIONS(3509),
    [anon_sym_if] = ACTIONS(3509),
    [anon_sym_switch] = ACTIONS(3509),
    [anon_sym_case] = ACTIONS(3509),
    [anon_sym_default] = ACTIONS(3509),
    [anon_sym_while] = ACTIONS(3509),
    [anon_sym_do] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3509),
    [anon_sym_return] = ACTIONS(3509),
    [anon_sym_break] = ACTIONS(3509),
    [anon_sym_continue] = ACTIONS(3509),
    [anon_sym_goto] = ACTIONS(3509),
    [anon_sym_not] = ACTIONS(3509),
    [anon_sym_compl] = ACTIONS(3509),
    [anon_sym_DASH_DASH] = ACTIONS(3511),
    [anon_sym_PLUS_PLUS] = ACTIONS(3511),
    [anon_sym_sizeof] = ACTIONS(3509),
    [anon_sym___alignof__] = ACTIONS(3509),
    [anon_sym___alignof] = ACTIONS(3509),
    [anon_sym__alignof] = ACTIONS(3509),
    [anon_sym_alignof] = ACTIONS(3509),
    [anon_sym__Alignof] = ACTIONS(3509),
    [anon_sym_offsetof] = ACTIONS(3509),
    [anon_sym__Generic] = ACTIONS(3509),
    [anon_sym_asm] = ACTIONS(3509),
    [anon_sym___asm__] = ACTIONS(3509),
    [sym_number_literal] = ACTIONS(3511),
    [anon_sym_L_SQUOTE] = ACTIONS(3511),
    [anon_sym_u_SQUOTE] = ACTIONS(3511),
    [anon_sym_U_SQUOTE] = ACTIONS(3511),
    [anon_sym_u8_SQUOTE] = ACTIONS(3511),
    [anon_sym_SQUOTE] = ACTIONS(3511),
    [anon_sym_L_DQUOTE] = ACTIONS(3511),
    [anon_sym_u_DQUOTE] = ACTIONS(3511),
    [anon_sym_U_DQUOTE] = ACTIONS(3511),
    [anon_sym_u8_DQUOTE] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [sym_true] = ACTIONS(3509),
    [sym_false] = ACTIONS(3509),
    [anon_sym_NULL] = ACTIONS(3509),
    [anon_sym_nullptr] = ACTIONS(3509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3509),
    [anon_sym_let] = ACTIONS(3509),
    [anon_sym_This] = ACTIONS(3509),
    [anon_sym_decltype] = ACTIONS(3509),
    [sym_virtual] = ACTIONS(3509),
    [anon_sym_explicit] = ACTIONS(3509),
    [anon_sym_typename] = ACTIONS(3509),
    [anon_sym_template] = ACTIONS(3509),
    [anon_sym_operator] = ACTIONS(3509),
    [anon_sym_try] = ACTIONS(3509),
    [anon_sym_delete] = ACTIONS(3509),
    [anon_sym_throw] = ACTIONS(3509),
    [anon_sym_namespace] = ACTIONS(3509),
    [anon_sym_using] = ACTIONS(3509),
    [anon_sym_static_assert] = ACTIONS(3509),
    [anon_sym_concept] = ACTIONS(3509),
    [anon_sym_co_return] = ACTIONS(3509),
    [anon_sym_co_yield] = ACTIONS(3509),
    [anon_sym_R_DQUOTE] = ACTIONS(3511),
    [anon_sym_LR_DQUOTE] = ACTIONS(3511),
    [anon_sym_uR_DQUOTE] = ACTIONS(3511),
    [anon_sym_UR_DQUOTE] = ACTIONS(3511),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3511),
    [anon_sym_co_await] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3509),
    [anon_sym_requires] = ACTIONS(3509),
    [sym_this] = ACTIONS(3509),
    [anon_sym_precise] = ACTIONS(3509),
    [anon_sym_shared] = ACTIONS(3509),
    [anon_sym_groupshared] = ACTIONS(3509),
    [anon_sym_uniform] = ACTIONS(3509),
    [anon_sym_row_major] = ACTIONS(3509),
    [anon_sym_column_major] = ACTIONS(3509),
    [anon_sym_globallycoherent] = ACTIONS(3509),
    [anon_sym_centroid] = ACTIONS(3509),
    [anon_sym_noperspective] = ACTIONS(3509),
    [anon_sym_nointerpolation] = ACTIONS(3509),
    [anon_sym_sample] = ACTIONS(3509),
    [anon_sym_linear] = ACTIONS(3509),
    [anon_sym_snorm] = ACTIONS(3509),
    [anon_sym_unorm] = ACTIONS(3509),
    [anon_sym_point] = ACTIONS(3509),
    [anon_sym_line] = ACTIONS(3509),
    [anon_sym_triangleadj] = ACTIONS(3509),
    [anon_sym_lineadj] = ACTIONS(3509),
    [anon_sym_triangle] = ACTIONS(3509),
    [anon_sym_interface] = ACTIONS(3509),
    [anon_sym_extension] = ACTIONS(3509),
    [anon_sym___exported] = ACTIONS(3509),
    [anon_sym_import] = ACTIONS(3509),
  },
  [1018] = {
    [ts_builtin_sym_end] = ACTIONS(3541),
    [sym_identifier] = ACTIONS(3539),
    [aux_sym_preproc_include_token1] = ACTIONS(3539),
    [aux_sym_preproc_def_token1] = ACTIONS(3539),
    [aux_sym_preproc_if_token1] = ACTIONS(3539),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3539),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3539),
    [sym_preproc_directive] = ACTIONS(3539),
    [anon_sym_LPAREN2] = ACTIONS(3541),
    [anon_sym_BANG] = ACTIONS(3541),
    [anon_sym_TILDE] = ACTIONS(3541),
    [anon_sym_DASH] = ACTIONS(3539),
    [anon_sym_PLUS] = ACTIONS(3539),
    [anon_sym_STAR] = ACTIONS(3541),
    [anon_sym_AMP_AMP] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym___extension__] = ACTIONS(3539),
    [anon_sym_typedef] = ACTIONS(3539),
    [anon_sym_in] = ACTIONS(3539),
    [anon_sym_out] = ACTIONS(3539),
    [anon_sym_inout] = ACTIONS(3539),
    [anon_sym_extern] = ACTIONS(3539),
    [anon_sym___attribute__] = ACTIONS(3539),
    [anon_sym_COLON_COLON] = ACTIONS(3541),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3541),
    [anon_sym___declspec] = ACTIONS(3539),
    [anon_sym___based] = ACTIONS(3539),
    [anon_sym___cdecl] = ACTIONS(3539),
    [anon_sym___clrcall] = ACTIONS(3539),
    [anon_sym___stdcall] = ACTIONS(3539),
    [anon_sym___fastcall] = ACTIONS(3539),
    [anon_sym___thiscall] = ACTIONS(3539),
    [anon_sym___vectorcall] = ACTIONS(3539),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_signed] = ACTIONS(3539),
    [anon_sym_unsigned] = ACTIONS(3539),
    [anon_sym_long] = ACTIONS(3539),
    [anon_sym_short] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_static] = ACTIONS(3539),
    [anon_sym_register] = ACTIONS(3539),
    [anon_sym_inline] = ACTIONS(3539),
    [anon_sym___inline] = ACTIONS(3539),
    [anon_sym___inline__] = ACTIONS(3539),
    [anon_sym___forceinline] = ACTIONS(3539),
    [anon_sym_thread_local] = ACTIONS(3539),
    [anon_sym___thread] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3539),
    [anon_sym_constexpr] = ACTIONS(3539),
    [anon_sym_volatile] = ACTIONS(3539),
    [anon_sym_restrict] = ACTIONS(3539),
    [anon_sym___restrict__] = ACTIONS(3539),
    [anon_sym__Atomic] = ACTIONS(3539),
    [anon_sym__Noreturn] = ACTIONS(3539),
    [anon_sym_noreturn] = ACTIONS(3539),
    [anon_sym_mutable] = ACTIONS(3539),
    [anon_sym_constinit] = ACTIONS(3539),
    [anon_sym_consteval] = ACTIONS(3539),
    [anon_sym_alignas] = ACTIONS(3539),
    [anon_sym__Alignas] = ACTIONS(3539),
    [sym_primitive_type] = ACTIONS(3539),
    [anon_sym_enum] = ACTIONS(3539),
    [anon_sym_class] = ACTIONS(3539),
    [anon_sym_struct] = ACTIONS(3539),
    [anon_sym_union] = ACTIONS(3539),
    [anon_sym_if] = ACTIONS(3539),
    [anon_sym_switch] = ACTIONS(3539),
    [anon_sym_case] = ACTIONS(3539),
    [anon_sym_default] = ACTIONS(3539),
    [anon_sym_while] = ACTIONS(3539),
    [anon_sym_do] = ACTIONS(3539),
    [anon_sym_for] = ACTIONS(3539),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_break] = ACTIONS(3539),
    [anon_sym_continue] = ACTIONS(3539),
    [anon_sym_goto] = ACTIONS(3539),
    [anon_sym_not] = ACTIONS(3539),
    [anon_sym_compl] = ACTIONS(3539),
    [anon_sym_DASH_DASH] = ACTIONS(3541),
    [anon_sym_PLUS_PLUS] = ACTIONS(3541),
    [anon_sym_sizeof] = ACTIONS(3539),
    [anon_sym___alignof__] = ACTIONS(3539),
    [anon_sym___alignof] = ACTIONS(3539),
    [anon_sym__alignof] = ACTIONS(3539),
    [anon_sym_alignof] = ACTIONS(3539),
    [anon_sym__Alignof] = ACTIONS(3539),
    [anon_sym_offsetof] = ACTIONS(3539),
    [anon_sym__Generic] = ACTIONS(3539),
    [anon_sym_asm] = ACTIONS(3539),
    [anon_sym___asm__] = ACTIONS(3539),
    [sym_number_literal] = ACTIONS(3541),
    [anon_sym_L_SQUOTE] = ACTIONS(3541),
    [anon_sym_u_SQUOTE] = ACTIONS(3541),
    [anon_sym_U_SQUOTE] = ACTIONS(3541),
    [anon_sym_u8_SQUOTE] = ACTIONS(3541),
    [anon_sym_SQUOTE] = ACTIONS(3541),
    [anon_sym_L_DQUOTE] = ACTIONS(3541),
    [anon_sym_u_DQUOTE] = ACTIONS(3541),
    [anon_sym_U_DQUOTE] = ACTIONS(3541),
    [anon_sym_u8_DQUOTE] = ACTIONS(3541),
    [anon_sym_DQUOTE] = ACTIONS(3541),
    [sym_true] = ACTIONS(3539),
    [sym_false] = ACTIONS(3539),
    [anon_sym_NULL] = ACTIONS(3539),
    [anon_sym_nullptr] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_This] = ACTIONS(3539),
    [anon_sym_decltype] = ACTIONS(3539),
    [sym_virtual] = ACTIONS(3539),
    [anon_sym_explicit] = ACTIONS(3539),
    [anon_sym_typename] = ACTIONS(3539),
    [anon_sym_template] = ACTIONS(3539),
    [anon_sym_operator] = ACTIONS(3539),
    [anon_sym_try] = ACTIONS(3539),
    [anon_sym_delete] = ACTIONS(3539),
    [anon_sym_throw] = ACTIONS(3539),
    [anon_sym_namespace] = ACTIONS(3539),
    [anon_sym_using] = ACTIONS(3539),
    [anon_sym_static_assert] = ACTIONS(3539),
    [anon_sym_concept] = ACTIONS(3539),
    [anon_sym_co_return] = ACTIONS(3539),
    [anon_sym_co_yield] = ACTIONS(3539),
    [anon_sym_R_DQUOTE] = ACTIONS(3541),
    [anon_sym_LR_DQUOTE] = ACTIONS(3541),
    [anon_sym_uR_DQUOTE] = ACTIONS(3541),
    [anon_sym_UR_DQUOTE] = ACTIONS(3541),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3541),
    [anon_sym_co_await] = ACTIONS(3539),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_requires] = ACTIONS(3539),
    [sym_this] = ACTIONS(3539),
    [anon_sym_precise] = ACTIONS(3539),
    [anon_sym_shared] = ACTIONS(3539),
    [anon_sym_groupshared] = ACTIONS(3539),
    [anon_sym_uniform] = ACTIONS(3539),
    [anon_sym_row_major] = ACTIONS(3539),
    [anon_sym_column_major] = ACTIONS(3539),
    [anon_sym_globallycoherent] = ACTIONS(3539),
    [anon_sym_centroid] = ACTIONS(3539),
    [anon_sym_noperspective] = ACTIONS(3539),
    [anon_sym_nointerpolation] = ACTIONS(3539),
    [anon_sym_sample] = ACTIONS(3539),
    [anon_sym_linear] = ACTIONS(3539),
    [anon_sym_snorm] = ACTIONS(3539),
    [anon_sym_unorm] = ACTIONS(3539),
    [anon_sym_point] = ACTIONS(3539),
    [anon_sym_line] = ACTIONS(3539),
    [anon_sym_triangleadj] = ACTIONS(3539),
    [anon_sym_lineadj] = ACTIONS(3539),
    [anon_sym_triangle] = ACTIONS(3539),
    [anon_sym_interface] = ACTIONS(3539),
    [anon_sym_extension] = ACTIONS(3539),
    [anon_sym___exported] = ACTIONS(3539),
    [anon_sym_import] = ACTIONS(3539),
  },
  [1019] = {
    [ts_builtin_sym_end] = ACTIONS(3461),
    [sym_identifier] = ACTIONS(3459),
    [aux_sym_preproc_include_token1] = ACTIONS(3459),
    [aux_sym_preproc_def_token1] = ACTIONS(3459),
    [aux_sym_preproc_if_token1] = ACTIONS(3459),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3459),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3459),
    [sym_preproc_directive] = ACTIONS(3459),
    [anon_sym_LPAREN2] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_TILDE] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3459),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3459),
    [anon_sym___extension__] = ACTIONS(3459),
    [anon_sym_typedef] = ACTIONS(3459),
    [anon_sym_in] = ACTIONS(3459),
    [anon_sym_out] = ACTIONS(3459),
    [anon_sym_inout] = ACTIONS(3459),
    [anon_sym_extern] = ACTIONS(3459),
    [anon_sym___attribute__] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3461),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3461),
    [anon_sym___declspec] = ACTIONS(3459),
    [anon_sym___based] = ACTIONS(3459),
    [anon_sym___cdecl] = ACTIONS(3459),
    [anon_sym___clrcall] = ACTIONS(3459),
    [anon_sym___stdcall] = ACTIONS(3459),
    [anon_sym___fastcall] = ACTIONS(3459),
    [anon_sym___thiscall] = ACTIONS(3459),
    [anon_sym___vectorcall] = ACTIONS(3459),
    [anon_sym_LBRACE] = ACTIONS(3461),
    [anon_sym_signed] = ACTIONS(3459),
    [anon_sym_unsigned] = ACTIONS(3459),
    [anon_sym_long] = ACTIONS(3459),
    [anon_sym_short] = ACTIONS(3459),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_static] = ACTIONS(3459),
    [anon_sym_register] = ACTIONS(3459),
    [anon_sym_inline] = ACTIONS(3459),
    [anon_sym___inline] = ACTIONS(3459),
    [anon_sym___inline__] = ACTIONS(3459),
    [anon_sym___forceinline] = ACTIONS(3459),
    [anon_sym_thread_local] = ACTIONS(3459),
    [anon_sym___thread] = ACTIONS(3459),
    [anon_sym_const] = ACTIONS(3459),
    [anon_sym_constexpr] = ACTIONS(3459),
    [anon_sym_volatile] = ACTIONS(3459),
    [anon_sym_restrict] = ACTIONS(3459),
    [anon_sym___restrict__] = ACTIONS(3459),
    [anon_sym__Atomic] = ACTIONS(3459),
    [anon_sym__Noreturn] = ACTIONS(3459),
    [anon_sym_noreturn] = ACTIONS(3459),
    [anon_sym_mutable] = ACTIONS(3459),
    [anon_sym_constinit] = ACTIONS(3459),
    [anon_sym_consteval] = ACTIONS(3459),
    [anon_sym_alignas] = ACTIONS(3459),
    [anon_sym__Alignas] = ACTIONS(3459),
    [sym_primitive_type] = ACTIONS(3459),
    [anon_sym_enum] = ACTIONS(3459),
    [anon_sym_class] = ACTIONS(3459),
    [anon_sym_struct] = ACTIONS(3459),
    [anon_sym_union] = ACTIONS(3459),
    [anon_sym_if] = ACTIONS(3459),
    [anon_sym_switch] = ACTIONS(3459),
    [anon_sym_case] = ACTIONS(3459),
    [anon_sym_default] = ACTIONS(3459),
    [anon_sym_while] = ACTIONS(3459),
    [anon_sym_do] = ACTIONS(3459),
    [anon_sym_for] = ACTIONS(3459),
    [anon_sym_return] = ACTIONS(3459),
    [anon_sym_break] = ACTIONS(3459),
    [anon_sym_continue] = ACTIONS(3459),
    [anon_sym_goto] = ACTIONS(3459),
    [anon_sym_not] = ACTIONS(3459),
    [anon_sym_compl] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3461),
    [anon_sym_sizeof] = ACTIONS(3459),
    [anon_sym___alignof__] = ACTIONS(3459),
    [anon_sym___alignof] = ACTIONS(3459),
    [anon_sym__alignof] = ACTIONS(3459),
    [anon_sym_alignof] = ACTIONS(3459),
    [anon_sym__Alignof] = ACTIONS(3459),
    [anon_sym_offsetof] = ACTIONS(3459),
    [anon_sym__Generic] = ACTIONS(3459),
    [anon_sym_asm] = ACTIONS(3459),
    [anon_sym___asm__] = ACTIONS(3459),
    [sym_number_literal] = ACTIONS(3461),
    [anon_sym_L_SQUOTE] = ACTIONS(3461),
    [anon_sym_u_SQUOTE] = ACTIONS(3461),
    [anon_sym_U_SQUOTE] = ACTIONS(3461),
    [anon_sym_u8_SQUOTE] = ACTIONS(3461),
    [anon_sym_SQUOTE] = ACTIONS(3461),
    [anon_sym_L_DQUOTE] = ACTIONS(3461),
    [anon_sym_u_DQUOTE] = ACTIONS(3461),
    [anon_sym_U_DQUOTE] = ACTIONS(3461),
    [anon_sym_u8_DQUOTE] = ACTIONS(3461),
    [anon_sym_DQUOTE] = ACTIONS(3461),
    [sym_true] = ACTIONS(3459),
    [sym_false] = ACTIONS(3459),
    [anon_sym_NULL] = ACTIONS(3459),
    [anon_sym_nullptr] = ACTIONS(3459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3459),
    [anon_sym_let] = ACTIONS(3459),
    [anon_sym_This] = ACTIONS(3459),
    [anon_sym_decltype] = ACTIONS(3459),
    [sym_virtual] = ACTIONS(3459),
    [anon_sym_explicit] = ACTIONS(3459),
    [anon_sym_typename] = ACTIONS(3459),
    [anon_sym_template] = ACTIONS(3459),
    [anon_sym_operator] = ACTIONS(3459),
    [anon_sym_try] = ACTIONS(3459),
    [anon_sym_delete] = ACTIONS(3459),
    [anon_sym_throw] = ACTIONS(3459),
    [anon_sym_namespace] = ACTIONS(3459),
    [anon_sym_using] = ACTIONS(3459),
    [anon_sym_static_assert] = ACTIONS(3459),
    [anon_sym_concept] = ACTIONS(3459),
    [anon_sym_co_return] = ACTIONS(3459),
    [anon_sym_co_yield] = ACTIONS(3459),
    [anon_sym_R_DQUOTE] = ACTIONS(3461),
    [anon_sym_LR_DQUOTE] = ACTIONS(3461),
    [anon_sym_uR_DQUOTE] = ACTIONS(3461),
    [anon_sym_UR_DQUOTE] = ACTIONS(3461),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3461),
    [anon_sym_co_await] = ACTIONS(3459),
    [anon_sym_new] = ACTIONS(3459),
    [anon_sym_requires] = ACTIONS(3459),
    [sym_this] = ACTIONS(3459),
    [anon_sym_precise] = ACTIONS(3459),
    [anon_sym_shared] = ACTIONS(3459),
    [anon_sym_groupshared] = ACTIONS(3459),
    [anon_sym_uniform] = ACTIONS(3459),
    [anon_sym_row_major] = ACTIONS(3459),
    [anon_sym_column_major] = ACTIONS(3459),
    [anon_sym_globallycoherent] = ACTIONS(3459),
    [anon_sym_centroid] = ACTIONS(3459),
    [anon_sym_noperspective] = ACTIONS(3459),
    [anon_sym_nointerpolation] = ACTIONS(3459),
    [anon_sym_sample] = ACTIONS(3459),
    [anon_sym_linear] = ACTIONS(3459),
    [anon_sym_snorm] = ACTIONS(3459),
    [anon_sym_unorm] = ACTIONS(3459),
    [anon_sym_point] = ACTIONS(3459),
    [anon_sym_line] = ACTIONS(3459),
    [anon_sym_triangleadj] = ACTIONS(3459),
    [anon_sym_lineadj] = ACTIONS(3459),
    [anon_sym_triangle] = ACTIONS(3459),
    [anon_sym_interface] = ACTIONS(3459),
    [anon_sym_extension] = ACTIONS(3459),
    [anon_sym___exported] = ACTIONS(3459),
    [anon_sym_import] = ACTIONS(3459),
  },
  [1020] = {
    [ts_builtin_sym_end] = ACTIONS(3420),
    [sym_identifier] = ACTIONS(3418),
    [aux_sym_preproc_include_token1] = ACTIONS(3418),
    [aux_sym_preproc_def_token1] = ACTIONS(3418),
    [aux_sym_preproc_if_token1] = ACTIONS(3418),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3418),
    [sym_preproc_directive] = ACTIONS(3418),
    [anon_sym_LPAREN2] = ACTIONS(3420),
    [anon_sym_BANG] = ACTIONS(3420),
    [anon_sym_TILDE] = ACTIONS(3420),
    [anon_sym_DASH] = ACTIONS(3418),
    [anon_sym_PLUS] = ACTIONS(3418),
    [anon_sym_STAR] = ACTIONS(3420),
    [anon_sym_AMP_AMP] = ACTIONS(3420),
    [anon_sym_AMP] = ACTIONS(3418),
    [anon_sym___extension__] = ACTIONS(3418),
    [anon_sym_typedef] = ACTIONS(3418),
    [anon_sym_in] = ACTIONS(3418),
    [anon_sym_out] = ACTIONS(3418),
    [anon_sym_inout] = ACTIONS(3418),
    [anon_sym_extern] = ACTIONS(3418),
    [anon_sym___attribute__] = ACTIONS(3418),
    [anon_sym_COLON_COLON] = ACTIONS(3420),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3420),
    [anon_sym___declspec] = ACTIONS(3418),
    [anon_sym___based] = ACTIONS(3418),
    [anon_sym___cdecl] = ACTIONS(3418),
    [anon_sym___clrcall] = ACTIONS(3418),
    [anon_sym___stdcall] = ACTIONS(3418),
    [anon_sym___fastcall] = ACTIONS(3418),
    [anon_sym___thiscall] = ACTIONS(3418),
    [anon_sym___vectorcall] = ACTIONS(3418),
    [anon_sym_LBRACE] = ACTIONS(3420),
    [anon_sym_signed] = ACTIONS(3418),
    [anon_sym_unsigned] = ACTIONS(3418),
    [anon_sym_long] = ACTIONS(3418),
    [anon_sym_short] = ACTIONS(3418),
    [anon_sym_LBRACK] = ACTIONS(3418),
    [anon_sym_static] = ACTIONS(3418),
    [anon_sym_register] = ACTIONS(3418),
    [anon_sym_inline] = ACTIONS(3418),
    [anon_sym___inline] = ACTIONS(3418),
    [anon_sym___inline__] = ACTIONS(3418),
    [anon_sym___forceinline] = ACTIONS(3418),
    [anon_sym_thread_local] = ACTIONS(3418),
    [anon_sym___thread] = ACTIONS(3418),
    [anon_sym_const] = ACTIONS(3418),
    [anon_sym_constexpr] = ACTIONS(3418),
    [anon_sym_volatile] = ACTIONS(3418),
    [anon_sym_restrict] = ACTIONS(3418),
    [anon_sym___restrict__] = ACTIONS(3418),
    [anon_sym__Atomic] = ACTIONS(3418),
    [anon_sym__Noreturn] = ACTIONS(3418),
    [anon_sym_noreturn] = ACTIONS(3418),
    [anon_sym_mutable] = ACTIONS(3418),
    [anon_sym_constinit] = ACTIONS(3418),
    [anon_sym_consteval] = ACTIONS(3418),
    [anon_sym_alignas] = ACTIONS(3418),
    [anon_sym__Alignas] = ACTIONS(3418),
    [sym_primitive_type] = ACTIONS(3418),
    [anon_sym_enum] = ACTIONS(3418),
    [anon_sym_class] = ACTIONS(3418),
    [anon_sym_struct] = ACTIONS(3418),
    [anon_sym_union] = ACTIONS(3418),
    [anon_sym_if] = ACTIONS(3418),
    [anon_sym_switch] = ACTIONS(3418),
    [anon_sym_case] = ACTIONS(3418),
    [anon_sym_default] = ACTIONS(3418),
    [anon_sym_while] = ACTIONS(3418),
    [anon_sym_do] = ACTIONS(3418),
    [anon_sym_for] = ACTIONS(3418),
    [anon_sym_return] = ACTIONS(3418),
    [anon_sym_break] = ACTIONS(3418),
    [anon_sym_continue] = ACTIONS(3418),
    [anon_sym_goto] = ACTIONS(3418),
    [anon_sym_not] = ACTIONS(3418),
    [anon_sym_compl] = ACTIONS(3418),
    [anon_sym_DASH_DASH] = ACTIONS(3420),
    [anon_sym_PLUS_PLUS] = ACTIONS(3420),
    [anon_sym_sizeof] = ACTIONS(3418),
    [anon_sym___alignof__] = ACTIONS(3418),
    [anon_sym___alignof] = ACTIONS(3418),
    [anon_sym__alignof] = ACTIONS(3418),
    [anon_sym_alignof] = ACTIONS(3418),
    [anon_sym__Alignof] = ACTIONS(3418),
    [anon_sym_offsetof] = ACTIONS(3418),
    [anon_sym__Generic] = ACTIONS(3418),
    [anon_sym_asm] = ACTIONS(3418),
    [anon_sym___asm__] = ACTIONS(3418),
    [sym_number_literal] = ACTIONS(3420),
    [anon_sym_L_SQUOTE] = ACTIONS(3420),
    [anon_sym_u_SQUOTE] = ACTIONS(3420),
    [anon_sym_U_SQUOTE] = ACTIONS(3420),
    [anon_sym_u8_SQUOTE] = ACTIONS(3420),
    [anon_sym_SQUOTE] = ACTIONS(3420),
    [anon_sym_L_DQUOTE] = ACTIONS(3420),
    [anon_sym_u_DQUOTE] = ACTIONS(3420),
    [anon_sym_U_DQUOTE] = ACTIONS(3420),
    [anon_sym_u8_DQUOTE] = ACTIONS(3420),
    [anon_sym_DQUOTE] = ACTIONS(3420),
    [sym_true] = ACTIONS(3418),
    [sym_false] = ACTIONS(3418),
    [anon_sym_NULL] = ACTIONS(3418),
    [anon_sym_nullptr] = ACTIONS(3418),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3418),
    [anon_sym_let] = ACTIONS(3418),
    [anon_sym_This] = ACTIONS(3418),
    [anon_sym_decltype] = ACTIONS(3418),
    [sym_virtual] = ACTIONS(3418),
    [anon_sym_explicit] = ACTIONS(3418),
    [anon_sym_typename] = ACTIONS(3418),
    [anon_sym_template] = ACTIONS(3418),
    [anon_sym_operator] = ACTIONS(3418),
    [anon_sym_try] = ACTIONS(3418),
    [anon_sym_delete] = ACTIONS(3418),
    [anon_sym_throw] = ACTIONS(3418),
    [anon_sym_namespace] = ACTIONS(3418),
    [anon_sym_using] = ACTIONS(3418),
    [anon_sym_static_assert] = ACTIONS(3418),
    [anon_sym_concept] = ACTIONS(3418),
    [anon_sym_co_return] = ACTIONS(3418),
    [anon_sym_co_yield] = ACTIONS(3418),
    [anon_sym_R_DQUOTE] = ACTIONS(3420),
    [anon_sym_LR_DQUOTE] = ACTIONS(3420),
    [anon_sym_uR_DQUOTE] = ACTIONS(3420),
    [anon_sym_UR_DQUOTE] = ACTIONS(3420),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3420),
    [anon_sym_co_await] = ACTIONS(3418),
    [anon_sym_new] = ACTIONS(3418),
    [anon_sym_requires] = ACTIONS(3418),
    [sym_this] = ACTIONS(3418),
    [anon_sym_precise] = ACTIONS(3418),
    [anon_sym_shared] = ACTIONS(3418),
    [anon_sym_groupshared] = ACTIONS(3418),
    [anon_sym_uniform] = ACTIONS(3418),
    [anon_sym_row_major] = ACTIONS(3418),
    [anon_sym_column_major] = ACTIONS(3418),
    [anon_sym_globallycoherent] = ACTIONS(3418),
    [anon_sym_centroid] = ACTIONS(3418),
    [anon_sym_noperspective] = ACTIONS(3418),
    [anon_sym_nointerpolation] = ACTIONS(3418),
    [anon_sym_sample] = ACTIONS(3418),
    [anon_sym_linear] = ACTIONS(3418),
    [anon_sym_snorm] = ACTIONS(3418),
    [anon_sym_unorm] = ACTIONS(3418),
    [anon_sym_point] = ACTIONS(3418),
    [anon_sym_line] = ACTIONS(3418),
    [anon_sym_triangleadj] = ACTIONS(3418),
    [anon_sym_lineadj] = ACTIONS(3418),
    [anon_sym_triangle] = ACTIONS(3418),
    [anon_sym_interface] = ACTIONS(3418),
    [anon_sym_extension] = ACTIONS(3418),
    [anon_sym___exported] = ACTIONS(3418),
    [anon_sym_import] = ACTIONS(3418),
  },
  [1021] = {
    [ts_builtin_sym_end] = ACTIONS(3469),
    [sym_identifier] = ACTIONS(3467),
    [aux_sym_preproc_include_token1] = ACTIONS(3467),
    [aux_sym_preproc_def_token1] = ACTIONS(3467),
    [aux_sym_preproc_if_token1] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3467),
    [sym_preproc_directive] = ACTIONS(3467),
    [anon_sym_LPAREN2] = ACTIONS(3469),
    [anon_sym_BANG] = ACTIONS(3469),
    [anon_sym_TILDE] = ACTIONS(3469),
    [anon_sym_DASH] = ACTIONS(3467),
    [anon_sym_PLUS] = ACTIONS(3467),
    [anon_sym_STAR] = ACTIONS(3469),
    [anon_sym_AMP_AMP] = ACTIONS(3469),
    [anon_sym_AMP] = ACTIONS(3467),
    [anon_sym___extension__] = ACTIONS(3467),
    [anon_sym_typedef] = ACTIONS(3467),
    [anon_sym_in] = ACTIONS(3467),
    [anon_sym_out] = ACTIONS(3467),
    [anon_sym_inout] = ACTIONS(3467),
    [anon_sym_extern] = ACTIONS(3467),
    [anon_sym___attribute__] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(3469),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3469),
    [anon_sym___declspec] = ACTIONS(3467),
    [anon_sym___based] = ACTIONS(3467),
    [anon_sym___cdecl] = ACTIONS(3467),
    [anon_sym___clrcall] = ACTIONS(3467),
    [anon_sym___stdcall] = ACTIONS(3467),
    [anon_sym___fastcall] = ACTIONS(3467),
    [anon_sym___thiscall] = ACTIONS(3467),
    [anon_sym___vectorcall] = ACTIONS(3467),
    [anon_sym_LBRACE] = ACTIONS(3469),
    [anon_sym_signed] = ACTIONS(3467),
    [anon_sym_unsigned] = ACTIONS(3467),
    [anon_sym_long] = ACTIONS(3467),
    [anon_sym_short] = ACTIONS(3467),
    [anon_sym_LBRACK] = ACTIONS(3467),
    [anon_sym_static] = ACTIONS(3467),
    [anon_sym_register] = ACTIONS(3467),
    [anon_sym_inline] = ACTIONS(3467),
    [anon_sym___inline] = ACTIONS(3467),
    [anon_sym___inline__] = ACTIONS(3467),
    [anon_sym___forceinline] = ACTIONS(3467),
    [anon_sym_thread_local] = ACTIONS(3467),
    [anon_sym___thread] = ACTIONS(3467),
    [anon_sym_const] = ACTIONS(3467),
    [anon_sym_constexpr] = ACTIONS(3467),
    [anon_sym_volatile] = ACTIONS(3467),
    [anon_sym_restrict] = ACTIONS(3467),
    [anon_sym___restrict__] = ACTIONS(3467),
    [anon_sym__Atomic] = ACTIONS(3467),
    [anon_sym__Noreturn] = ACTIONS(3467),
    [anon_sym_noreturn] = ACTIONS(3467),
    [anon_sym_mutable] = ACTIONS(3467),
    [anon_sym_constinit] = ACTIONS(3467),
    [anon_sym_consteval] = ACTIONS(3467),
    [anon_sym_alignas] = ACTIONS(3467),
    [anon_sym__Alignas] = ACTIONS(3467),
    [sym_primitive_type] = ACTIONS(3467),
    [anon_sym_enum] = ACTIONS(3467),
    [anon_sym_class] = ACTIONS(3467),
    [anon_sym_struct] = ACTIONS(3467),
    [anon_sym_union] = ACTIONS(3467),
    [anon_sym_if] = ACTIONS(3467),
    [anon_sym_switch] = ACTIONS(3467),
    [anon_sym_case] = ACTIONS(3467),
    [anon_sym_default] = ACTIONS(3467),
    [anon_sym_while] = ACTIONS(3467),
    [anon_sym_do] = ACTIONS(3467),
    [anon_sym_for] = ACTIONS(3467),
    [anon_sym_return] = ACTIONS(3467),
    [anon_sym_break] = ACTIONS(3467),
    [anon_sym_continue] = ACTIONS(3467),
    [anon_sym_goto] = ACTIONS(3467),
    [anon_sym_not] = ACTIONS(3467),
    [anon_sym_compl] = ACTIONS(3467),
    [anon_sym_DASH_DASH] = ACTIONS(3469),
    [anon_sym_PLUS_PLUS] = ACTIONS(3469),
    [anon_sym_sizeof] = ACTIONS(3467),
    [anon_sym___alignof__] = ACTIONS(3467),
    [anon_sym___alignof] = ACTIONS(3467),
    [anon_sym__alignof] = ACTIONS(3467),
    [anon_sym_alignof] = ACTIONS(3467),
    [anon_sym__Alignof] = ACTIONS(3467),
    [anon_sym_offsetof] = ACTIONS(3467),
    [anon_sym__Generic] = ACTIONS(3467),
    [anon_sym_asm] = ACTIONS(3467),
    [anon_sym___asm__] = ACTIONS(3467),
    [sym_number_literal] = ACTIONS(3469),
    [anon_sym_L_SQUOTE] = ACTIONS(3469),
    [anon_sym_u_SQUOTE] = ACTIONS(3469),
    [anon_sym_U_SQUOTE] = ACTIONS(3469),
    [anon_sym_u8_SQUOTE] = ACTIONS(3469),
    [anon_sym_SQUOTE] = ACTIONS(3469),
    [anon_sym_L_DQUOTE] = ACTIONS(3469),
    [anon_sym_u_DQUOTE] = ACTIONS(3469),
    [anon_sym_U_DQUOTE] = ACTIONS(3469),
    [anon_sym_u8_DQUOTE] = ACTIONS(3469),
    [anon_sym_DQUOTE] = ACTIONS(3469),
    [sym_true] = ACTIONS(3467),
    [sym_false] = ACTIONS(3467),
    [anon_sym_NULL] = ACTIONS(3467),
    [anon_sym_nullptr] = ACTIONS(3467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3467),
    [anon_sym_let] = ACTIONS(3467),
    [anon_sym_This] = ACTIONS(3467),
    [anon_sym_decltype] = ACTIONS(3467),
    [sym_virtual] = ACTIONS(3467),
    [anon_sym_explicit] = ACTIONS(3467),
    [anon_sym_typename] = ACTIONS(3467),
    [anon_sym_template] = ACTIONS(3467),
    [anon_sym_operator] = ACTIONS(3467),
    [anon_sym_try] = ACTIONS(3467),
    [anon_sym_delete] = ACTIONS(3467),
    [anon_sym_throw] = ACTIONS(3467),
    [anon_sym_namespace] = ACTIONS(3467),
    [anon_sym_using] = ACTIONS(3467),
    [anon_sym_static_assert] = ACTIONS(3467),
    [anon_sym_concept] = ACTIONS(3467),
    [anon_sym_co_return] = ACTIONS(3467),
    [anon_sym_co_yield] = ACTIONS(3467),
    [anon_sym_R_DQUOTE] = ACTIONS(3469),
    [anon_sym_LR_DQUOTE] = ACTIONS(3469),
    [anon_sym_uR_DQUOTE] = ACTIONS(3469),
    [anon_sym_UR_DQUOTE] = ACTIONS(3469),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3469),
    [anon_sym_co_await] = ACTIONS(3467),
    [anon_sym_new] = ACTIONS(3467),
    [anon_sym_requires] = ACTIONS(3467),
    [sym_this] = ACTIONS(3467),
    [anon_sym_precise] = ACTIONS(3467),
    [anon_sym_shared] = ACTIONS(3467),
    [anon_sym_groupshared] = ACTIONS(3467),
    [anon_sym_uniform] = ACTIONS(3467),
    [anon_sym_row_major] = ACTIONS(3467),
    [anon_sym_column_major] = ACTIONS(3467),
    [anon_sym_globallycoherent] = ACTIONS(3467),
    [anon_sym_centroid] = ACTIONS(3467),
    [anon_sym_noperspective] = ACTIONS(3467),
    [anon_sym_nointerpolation] = ACTIONS(3467),
    [anon_sym_sample] = ACTIONS(3467),
    [anon_sym_linear] = ACTIONS(3467),
    [anon_sym_snorm] = ACTIONS(3467),
    [anon_sym_unorm] = ACTIONS(3467),
    [anon_sym_point] = ACTIONS(3467),
    [anon_sym_line] = ACTIONS(3467),
    [anon_sym_triangleadj] = ACTIONS(3467),
    [anon_sym_lineadj] = ACTIONS(3467),
    [anon_sym_triangle] = ACTIONS(3467),
    [anon_sym_interface] = ACTIONS(3467),
    [anon_sym_extension] = ACTIONS(3467),
    [anon_sym___exported] = ACTIONS(3467),
    [anon_sym_import] = ACTIONS(3467),
  },
  [1022] = {
    [ts_builtin_sym_end] = ACTIONS(3473),
    [sym_identifier] = ACTIONS(3471),
    [aux_sym_preproc_include_token1] = ACTIONS(3471),
    [aux_sym_preproc_def_token1] = ACTIONS(3471),
    [aux_sym_preproc_if_token1] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3471),
    [sym_preproc_directive] = ACTIONS(3471),
    [anon_sym_LPAREN2] = ACTIONS(3473),
    [anon_sym_BANG] = ACTIONS(3473),
    [anon_sym_TILDE] = ACTIONS(3473),
    [anon_sym_DASH] = ACTIONS(3471),
    [anon_sym_PLUS] = ACTIONS(3471),
    [anon_sym_STAR] = ACTIONS(3473),
    [anon_sym_AMP_AMP] = ACTIONS(3473),
    [anon_sym_AMP] = ACTIONS(3471),
    [anon_sym___extension__] = ACTIONS(3471),
    [anon_sym_typedef] = ACTIONS(3471),
    [anon_sym_in] = ACTIONS(3471),
    [anon_sym_out] = ACTIONS(3471),
    [anon_sym_inout] = ACTIONS(3471),
    [anon_sym_extern] = ACTIONS(3471),
    [anon_sym___attribute__] = ACTIONS(3471),
    [anon_sym_COLON_COLON] = ACTIONS(3473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3473),
    [anon_sym___declspec] = ACTIONS(3471),
    [anon_sym___based] = ACTIONS(3471),
    [anon_sym___cdecl] = ACTIONS(3471),
    [anon_sym___clrcall] = ACTIONS(3471),
    [anon_sym___stdcall] = ACTIONS(3471),
    [anon_sym___fastcall] = ACTIONS(3471),
    [anon_sym___thiscall] = ACTIONS(3471),
    [anon_sym___vectorcall] = ACTIONS(3471),
    [anon_sym_LBRACE] = ACTIONS(3473),
    [anon_sym_signed] = ACTIONS(3471),
    [anon_sym_unsigned] = ACTIONS(3471),
    [anon_sym_long] = ACTIONS(3471),
    [anon_sym_short] = ACTIONS(3471),
    [anon_sym_LBRACK] = ACTIONS(3471),
    [anon_sym_static] = ACTIONS(3471),
    [anon_sym_register] = ACTIONS(3471),
    [anon_sym_inline] = ACTIONS(3471),
    [anon_sym___inline] = ACTIONS(3471),
    [anon_sym___inline__] = ACTIONS(3471),
    [anon_sym___forceinline] = ACTIONS(3471),
    [anon_sym_thread_local] = ACTIONS(3471),
    [anon_sym___thread] = ACTIONS(3471),
    [anon_sym_const] = ACTIONS(3471),
    [anon_sym_constexpr] = ACTIONS(3471),
    [anon_sym_volatile] = ACTIONS(3471),
    [anon_sym_restrict] = ACTIONS(3471),
    [anon_sym___restrict__] = ACTIONS(3471),
    [anon_sym__Atomic] = ACTIONS(3471),
    [anon_sym__Noreturn] = ACTIONS(3471),
    [anon_sym_noreturn] = ACTIONS(3471),
    [anon_sym_mutable] = ACTIONS(3471),
    [anon_sym_constinit] = ACTIONS(3471),
    [anon_sym_consteval] = ACTIONS(3471),
    [anon_sym_alignas] = ACTIONS(3471),
    [anon_sym__Alignas] = ACTIONS(3471),
    [sym_primitive_type] = ACTIONS(3471),
    [anon_sym_enum] = ACTIONS(3471),
    [anon_sym_class] = ACTIONS(3471),
    [anon_sym_struct] = ACTIONS(3471),
    [anon_sym_union] = ACTIONS(3471),
    [anon_sym_if] = ACTIONS(3471),
    [anon_sym_switch] = ACTIONS(3471),
    [anon_sym_case] = ACTIONS(3471),
    [anon_sym_default] = ACTIONS(3471),
    [anon_sym_while] = ACTIONS(3471),
    [anon_sym_do] = ACTIONS(3471),
    [anon_sym_for] = ACTIONS(3471),
    [anon_sym_return] = ACTIONS(3471),
    [anon_sym_break] = ACTIONS(3471),
    [anon_sym_continue] = ACTIONS(3471),
    [anon_sym_goto] = ACTIONS(3471),
    [anon_sym_not] = ACTIONS(3471),
    [anon_sym_compl] = ACTIONS(3471),
    [anon_sym_DASH_DASH] = ACTIONS(3473),
    [anon_sym_PLUS_PLUS] = ACTIONS(3473),
    [anon_sym_sizeof] = ACTIONS(3471),
    [anon_sym___alignof__] = ACTIONS(3471),
    [anon_sym___alignof] = ACTIONS(3471),
    [anon_sym__alignof] = ACTIONS(3471),
    [anon_sym_alignof] = ACTIONS(3471),
    [anon_sym__Alignof] = ACTIONS(3471),
    [anon_sym_offsetof] = ACTIONS(3471),
    [anon_sym__Generic] = ACTIONS(3471),
    [anon_sym_asm] = ACTIONS(3471),
    [anon_sym___asm__] = ACTIONS(3471),
    [sym_number_literal] = ACTIONS(3473),
    [anon_sym_L_SQUOTE] = ACTIONS(3473),
    [anon_sym_u_SQUOTE] = ACTIONS(3473),
    [anon_sym_U_SQUOTE] = ACTIONS(3473),
    [anon_sym_u8_SQUOTE] = ACTIONS(3473),
    [anon_sym_SQUOTE] = ACTIONS(3473),
    [anon_sym_L_DQUOTE] = ACTIONS(3473),
    [anon_sym_u_DQUOTE] = ACTIONS(3473),
    [anon_sym_U_DQUOTE] = ACTIONS(3473),
    [anon_sym_u8_DQUOTE] = ACTIONS(3473),
    [anon_sym_DQUOTE] = ACTIONS(3473),
    [sym_true] = ACTIONS(3471),
    [sym_false] = ACTIONS(3471),
    [anon_sym_NULL] = ACTIONS(3471),
    [anon_sym_nullptr] = ACTIONS(3471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3471),
    [anon_sym_let] = ACTIONS(3471),
    [anon_sym_This] = ACTIONS(3471),
    [anon_sym_decltype] = ACTIONS(3471),
    [sym_virtual] = ACTIONS(3471),
    [anon_sym_explicit] = ACTIONS(3471),
    [anon_sym_typename] = ACTIONS(3471),
    [anon_sym_template] = ACTIONS(3471),
    [anon_sym_operator] = ACTIONS(3471),
    [anon_sym_try] = ACTIONS(3471),
    [anon_sym_delete] = ACTIONS(3471),
    [anon_sym_throw] = ACTIONS(3471),
    [anon_sym_namespace] = ACTIONS(3471),
    [anon_sym_using] = ACTIONS(3471),
    [anon_sym_static_assert] = ACTIONS(3471),
    [anon_sym_concept] = ACTIONS(3471),
    [anon_sym_co_return] = ACTIONS(3471),
    [anon_sym_co_yield] = ACTIONS(3471),
    [anon_sym_R_DQUOTE] = ACTIONS(3473),
    [anon_sym_LR_DQUOTE] = ACTIONS(3473),
    [anon_sym_uR_DQUOTE] = ACTIONS(3473),
    [anon_sym_UR_DQUOTE] = ACTIONS(3473),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3473),
    [anon_sym_co_await] = ACTIONS(3471),
    [anon_sym_new] = ACTIONS(3471),
    [anon_sym_requires] = ACTIONS(3471),
    [sym_this] = ACTIONS(3471),
    [anon_sym_precise] = ACTIONS(3471),
    [anon_sym_shared] = ACTIONS(3471),
    [anon_sym_groupshared] = ACTIONS(3471),
    [anon_sym_uniform] = ACTIONS(3471),
    [anon_sym_row_major] = ACTIONS(3471),
    [anon_sym_column_major] = ACTIONS(3471),
    [anon_sym_globallycoherent] = ACTIONS(3471),
    [anon_sym_centroid] = ACTIONS(3471),
    [anon_sym_noperspective] = ACTIONS(3471),
    [anon_sym_nointerpolation] = ACTIONS(3471),
    [anon_sym_sample] = ACTIONS(3471),
    [anon_sym_linear] = ACTIONS(3471),
    [anon_sym_snorm] = ACTIONS(3471),
    [anon_sym_unorm] = ACTIONS(3471),
    [anon_sym_point] = ACTIONS(3471),
    [anon_sym_line] = ACTIONS(3471),
    [anon_sym_triangleadj] = ACTIONS(3471),
    [anon_sym_lineadj] = ACTIONS(3471),
    [anon_sym_triangle] = ACTIONS(3471),
    [anon_sym_interface] = ACTIONS(3471),
    [anon_sym_extension] = ACTIONS(3471),
    [anon_sym___exported] = ACTIONS(3471),
    [anon_sym_import] = ACTIONS(3471),
  },
  [1023] = {
    [ts_builtin_sym_end] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3489),
    [aux_sym_preproc_include_token1] = ACTIONS(3489),
    [aux_sym_preproc_def_token1] = ACTIONS(3489),
    [aux_sym_preproc_if_token1] = ACTIONS(3489),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3489),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3489),
    [sym_preproc_directive] = ACTIONS(3489),
    [anon_sym_LPAREN2] = ACTIONS(3491),
    [anon_sym_BANG] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(3489),
    [anon_sym_PLUS] = ACTIONS(3489),
    [anon_sym_STAR] = ACTIONS(3491),
    [anon_sym_AMP_AMP] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3489),
    [anon_sym___extension__] = ACTIONS(3489),
    [anon_sym_typedef] = ACTIONS(3489),
    [anon_sym_in] = ACTIONS(3489),
    [anon_sym_out] = ACTIONS(3489),
    [anon_sym_inout] = ACTIONS(3489),
    [anon_sym_extern] = ACTIONS(3489),
    [anon_sym___attribute__] = ACTIONS(3489),
    [anon_sym_COLON_COLON] = ACTIONS(3491),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3491),
    [anon_sym___declspec] = ACTIONS(3489),
    [anon_sym___based] = ACTIONS(3489),
    [anon_sym___cdecl] = ACTIONS(3489),
    [anon_sym___clrcall] = ACTIONS(3489),
    [anon_sym___stdcall] = ACTIONS(3489),
    [anon_sym___fastcall] = ACTIONS(3489),
    [anon_sym___thiscall] = ACTIONS(3489),
    [anon_sym___vectorcall] = ACTIONS(3489),
    [anon_sym_LBRACE] = ACTIONS(3491),
    [anon_sym_signed] = ACTIONS(3489),
    [anon_sym_unsigned] = ACTIONS(3489),
    [anon_sym_long] = ACTIONS(3489),
    [anon_sym_short] = ACTIONS(3489),
    [anon_sym_LBRACK] = ACTIONS(3489),
    [anon_sym_static] = ACTIONS(3489),
    [anon_sym_register] = ACTIONS(3489),
    [anon_sym_inline] = ACTIONS(3489),
    [anon_sym___inline] = ACTIONS(3489),
    [anon_sym___inline__] = ACTIONS(3489),
    [anon_sym___forceinline] = ACTIONS(3489),
    [anon_sym_thread_local] = ACTIONS(3489),
    [anon_sym___thread] = ACTIONS(3489),
    [anon_sym_const] = ACTIONS(3489),
    [anon_sym_constexpr] = ACTIONS(3489),
    [anon_sym_volatile] = ACTIONS(3489),
    [anon_sym_restrict] = ACTIONS(3489),
    [anon_sym___restrict__] = ACTIONS(3489),
    [anon_sym__Atomic] = ACTIONS(3489),
    [anon_sym__Noreturn] = ACTIONS(3489),
    [anon_sym_noreturn] = ACTIONS(3489),
    [anon_sym_mutable] = ACTIONS(3489),
    [anon_sym_constinit] = ACTIONS(3489),
    [anon_sym_consteval] = ACTIONS(3489),
    [anon_sym_alignas] = ACTIONS(3489),
    [anon_sym__Alignas] = ACTIONS(3489),
    [sym_primitive_type] = ACTIONS(3489),
    [anon_sym_enum] = ACTIONS(3489),
    [anon_sym_class] = ACTIONS(3489),
    [anon_sym_struct] = ACTIONS(3489),
    [anon_sym_union] = ACTIONS(3489),
    [anon_sym_if] = ACTIONS(3489),
    [anon_sym_switch] = ACTIONS(3489),
    [anon_sym_case] = ACTIONS(3489),
    [anon_sym_default] = ACTIONS(3489),
    [anon_sym_while] = ACTIONS(3489),
    [anon_sym_do] = ACTIONS(3489),
    [anon_sym_for] = ACTIONS(3489),
    [anon_sym_return] = ACTIONS(3489),
    [anon_sym_break] = ACTIONS(3489),
    [anon_sym_continue] = ACTIONS(3489),
    [anon_sym_goto] = ACTIONS(3489),
    [anon_sym_not] = ACTIONS(3489),
    [anon_sym_compl] = ACTIONS(3489),
    [anon_sym_DASH_DASH] = ACTIONS(3491),
    [anon_sym_PLUS_PLUS] = ACTIONS(3491),
    [anon_sym_sizeof] = ACTIONS(3489),
    [anon_sym___alignof__] = ACTIONS(3489),
    [anon_sym___alignof] = ACTIONS(3489),
    [anon_sym__alignof] = ACTIONS(3489),
    [anon_sym_alignof] = ACTIONS(3489),
    [anon_sym__Alignof] = ACTIONS(3489),
    [anon_sym_offsetof] = ACTIONS(3489),
    [anon_sym__Generic] = ACTIONS(3489),
    [anon_sym_asm] = ACTIONS(3489),
    [anon_sym___asm__] = ACTIONS(3489),
    [sym_number_literal] = ACTIONS(3491),
    [anon_sym_L_SQUOTE] = ACTIONS(3491),
    [anon_sym_u_SQUOTE] = ACTIONS(3491),
    [anon_sym_U_SQUOTE] = ACTIONS(3491),
    [anon_sym_u8_SQUOTE] = ACTIONS(3491),
    [anon_sym_SQUOTE] = ACTIONS(3491),
    [anon_sym_L_DQUOTE] = ACTIONS(3491),
    [anon_sym_u_DQUOTE] = ACTIONS(3491),
    [anon_sym_U_DQUOTE] = ACTIONS(3491),
    [anon_sym_u8_DQUOTE] = ACTIONS(3491),
    [anon_sym_DQUOTE] = ACTIONS(3491),
    [sym_true] = ACTIONS(3489),
    [sym_false] = ACTIONS(3489),
    [anon_sym_NULL] = ACTIONS(3489),
    [anon_sym_nullptr] = ACTIONS(3489),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3489),
    [anon_sym_let] = ACTIONS(3489),
    [anon_sym_This] = ACTIONS(3489),
    [anon_sym_decltype] = ACTIONS(3489),
    [sym_virtual] = ACTIONS(3489),
    [anon_sym_explicit] = ACTIONS(3489),
    [anon_sym_typename] = ACTIONS(3489),
    [anon_sym_template] = ACTIONS(3489),
    [anon_sym_operator] = ACTIONS(3489),
    [anon_sym_try] = ACTIONS(3489),
    [anon_sym_delete] = ACTIONS(3489),
    [anon_sym_throw] = ACTIONS(3489),
    [anon_sym_namespace] = ACTIONS(3489),
    [anon_sym_using] = ACTIONS(3489),
    [anon_sym_static_assert] = ACTIONS(3489),
    [anon_sym_concept] = ACTIONS(3489),
    [anon_sym_co_return] = ACTIONS(3489),
    [anon_sym_co_yield] = ACTIONS(3489),
    [anon_sym_R_DQUOTE] = ACTIONS(3491),
    [anon_sym_LR_DQUOTE] = ACTIONS(3491),
    [anon_sym_uR_DQUOTE] = ACTIONS(3491),
    [anon_sym_UR_DQUOTE] = ACTIONS(3491),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3491),
    [anon_sym_co_await] = ACTIONS(3489),
    [anon_sym_new] = ACTIONS(3489),
    [anon_sym_requires] = ACTIONS(3489),
    [sym_this] = ACTIONS(3489),
    [anon_sym_precise] = ACTIONS(3489),
    [anon_sym_shared] = ACTIONS(3489),
    [anon_sym_groupshared] = ACTIONS(3489),
    [anon_sym_uniform] = ACTIONS(3489),
    [anon_sym_row_major] = ACTIONS(3489),
    [anon_sym_column_major] = ACTIONS(3489),
    [anon_sym_globallycoherent] = ACTIONS(3489),
    [anon_sym_centroid] = ACTIONS(3489),
    [anon_sym_noperspective] = ACTIONS(3489),
    [anon_sym_nointerpolation] = ACTIONS(3489),
    [anon_sym_sample] = ACTIONS(3489),
    [anon_sym_linear] = ACTIONS(3489),
    [anon_sym_snorm] = ACTIONS(3489),
    [anon_sym_unorm] = ACTIONS(3489),
    [anon_sym_point] = ACTIONS(3489),
    [anon_sym_line] = ACTIONS(3489),
    [anon_sym_triangleadj] = ACTIONS(3489),
    [anon_sym_lineadj] = ACTIONS(3489),
    [anon_sym_triangle] = ACTIONS(3489),
    [anon_sym_interface] = ACTIONS(3489),
    [anon_sym_extension] = ACTIONS(3489),
    [anon_sym___exported] = ACTIONS(3489),
    [anon_sym_import] = ACTIONS(3489),
  },
  [1024] = {
    [ts_builtin_sym_end] = ACTIONS(3537),
    [sym_identifier] = ACTIONS(3535),
    [aux_sym_preproc_include_token1] = ACTIONS(3535),
    [aux_sym_preproc_def_token1] = ACTIONS(3535),
    [aux_sym_preproc_if_token1] = ACTIONS(3535),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3535),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3535),
    [sym_preproc_directive] = ACTIONS(3535),
    [anon_sym_LPAREN2] = ACTIONS(3537),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3537),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym___extension__] = ACTIONS(3535),
    [anon_sym_typedef] = ACTIONS(3535),
    [anon_sym_in] = ACTIONS(3535),
    [anon_sym_out] = ACTIONS(3535),
    [anon_sym_inout] = ACTIONS(3535),
    [anon_sym_extern] = ACTIONS(3535),
    [anon_sym___attribute__] = ACTIONS(3535),
    [anon_sym_COLON_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3537),
    [anon_sym___declspec] = ACTIONS(3535),
    [anon_sym___based] = ACTIONS(3535),
    [anon_sym___cdecl] = ACTIONS(3535),
    [anon_sym___clrcall] = ACTIONS(3535),
    [anon_sym___stdcall] = ACTIONS(3535),
    [anon_sym___fastcall] = ACTIONS(3535),
    [anon_sym___thiscall] = ACTIONS(3535),
    [anon_sym___vectorcall] = ACTIONS(3535),
    [anon_sym_LBRACE] = ACTIONS(3537),
    [anon_sym_signed] = ACTIONS(3535),
    [anon_sym_unsigned] = ACTIONS(3535),
    [anon_sym_long] = ACTIONS(3535),
    [anon_sym_short] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_static] = ACTIONS(3535),
    [anon_sym_register] = ACTIONS(3535),
    [anon_sym_inline] = ACTIONS(3535),
    [anon_sym___inline] = ACTIONS(3535),
    [anon_sym___inline__] = ACTIONS(3535),
    [anon_sym___forceinline] = ACTIONS(3535),
    [anon_sym_thread_local] = ACTIONS(3535),
    [anon_sym___thread] = ACTIONS(3535),
    [anon_sym_const] = ACTIONS(3535),
    [anon_sym_constexpr] = ACTIONS(3535),
    [anon_sym_volatile] = ACTIONS(3535),
    [anon_sym_restrict] = ACTIONS(3535),
    [anon_sym___restrict__] = ACTIONS(3535),
    [anon_sym__Atomic] = ACTIONS(3535),
    [anon_sym__Noreturn] = ACTIONS(3535),
    [anon_sym_noreturn] = ACTIONS(3535),
    [anon_sym_mutable] = ACTIONS(3535),
    [anon_sym_constinit] = ACTIONS(3535),
    [anon_sym_consteval] = ACTIONS(3535),
    [anon_sym_alignas] = ACTIONS(3535),
    [anon_sym__Alignas] = ACTIONS(3535),
    [sym_primitive_type] = ACTIONS(3535),
    [anon_sym_enum] = ACTIONS(3535),
    [anon_sym_class] = ACTIONS(3535),
    [anon_sym_struct] = ACTIONS(3535),
    [anon_sym_union] = ACTIONS(3535),
    [anon_sym_if] = ACTIONS(3535),
    [anon_sym_switch] = ACTIONS(3535),
    [anon_sym_case] = ACTIONS(3535),
    [anon_sym_default] = ACTIONS(3535),
    [anon_sym_while] = ACTIONS(3535),
    [anon_sym_do] = ACTIONS(3535),
    [anon_sym_for] = ACTIONS(3535),
    [anon_sym_return] = ACTIONS(3535),
    [anon_sym_break] = ACTIONS(3535),
    [anon_sym_continue] = ACTIONS(3535),
    [anon_sym_goto] = ACTIONS(3535),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_compl] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(3537),
    [anon_sym_PLUS_PLUS] = ACTIONS(3537),
    [anon_sym_sizeof] = ACTIONS(3535),
    [anon_sym___alignof__] = ACTIONS(3535),
    [anon_sym___alignof] = ACTIONS(3535),
    [anon_sym__alignof] = ACTIONS(3535),
    [anon_sym_alignof] = ACTIONS(3535),
    [anon_sym__Alignof] = ACTIONS(3535),
    [anon_sym_offsetof] = ACTIONS(3535),
    [anon_sym__Generic] = ACTIONS(3535),
    [anon_sym_asm] = ACTIONS(3535),
    [anon_sym___asm__] = ACTIONS(3535),
    [sym_number_literal] = ACTIONS(3537),
    [anon_sym_L_SQUOTE] = ACTIONS(3537),
    [anon_sym_u_SQUOTE] = ACTIONS(3537),
    [anon_sym_U_SQUOTE] = ACTIONS(3537),
    [anon_sym_u8_SQUOTE] = ACTIONS(3537),
    [anon_sym_SQUOTE] = ACTIONS(3537),
    [anon_sym_L_DQUOTE] = ACTIONS(3537),
    [anon_sym_u_DQUOTE] = ACTIONS(3537),
    [anon_sym_U_DQUOTE] = ACTIONS(3537),
    [anon_sym_u8_DQUOTE] = ACTIONS(3537),
    [anon_sym_DQUOTE] = ACTIONS(3537),
    [sym_true] = ACTIONS(3535),
    [sym_false] = ACTIONS(3535),
    [anon_sym_NULL] = ACTIONS(3535),
    [anon_sym_nullptr] = ACTIONS(3535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3535),
    [anon_sym_let] = ACTIONS(3535),
    [anon_sym_This] = ACTIONS(3535),
    [anon_sym_decltype] = ACTIONS(3535),
    [sym_virtual] = ACTIONS(3535),
    [anon_sym_explicit] = ACTIONS(3535),
    [anon_sym_typename] = ACTIONS(3535),
    [anon_sym_template] = ACTIONS(3535),
    [anon_sym_operator] = ACTIONS(3535),
    [anon_sym_try] = ACTIONS(3535),
    [anon_sym_delete] = ACTIONS(3535),
    [anon_sym_throw] = ACTIONS(3535),
    [anon_sym_namespace] = ACTIONS(3535),
    [anon_sym_using] = ACTIONS(3535),
    [anon_sym_static_assert] = ACTIONS(3535),
    [anon_sym_concept] = ACTIONS(3535),
    [anon_sym_co_return] = ACTIONS(3535),
    [anon_sym_co_yield] = ACTIONS(3535),
    [anon_sym_R_DQUOTE] = ACTIONS(3537),
    [anon_sym_LR_DQUOTE] = ACTIONS(3537),
    [anon_sym_uR_DQUOTE] = ACTIONS(3537),
    [anon_sym_UR_DQUOTE] = ACTIONS(3537),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3537),
    [anon_sym_co_await] = ACTIONS(3535),
    [anon_sym_new] = ACTIONS(3535),
    [anon_sym_requires] = ACTIONS(3535),
    [sym_this] = ACTIONS(3535),
    [anon_sym_precise] = ACTIONS(3535),
    [anon_sym_shared] = ACTIONS(3535),
    [anon_sym_groupshared] = ACTIONS(3535),
    [anon_sym_uniform] = ACTIONS(3535),
    [anon_sym_row_major] = ACTIONS(3535),
    [anon_sym_column_major] = ACTIONS(3535),
    [anon_sym_globallycoherent] = ACTIONS(3535),
    [anon_sym_centroid] = ACTIONS(3535),
    [anon_sym_noperspective] = ACTIONS(3535),
    [anon_sym_nointerpolation] = ACTIONS(3535),
    [anon_sym_sample] = ACTIONS(3535),
    [anon_sym_linear] = ACTIONS(3535),
    [anon_sym_snorm] = ACTIONS(3535),
    [anon_sym_unorm] = ACTIONS(3535),
    [anon_sym_point] = ACTIONS(3535),
    [anon_sym_line] = ACTIONS(3535),
    [anon_sym_triangleadj] = ACTIONS(3535),
    [anon_sym_lineadj] = ACTIONS(3535),
    [anon_sym_triangle] = ACTIONS(3535),
    [anon_sym_interface] = ACTIONS(3535),
    [anon_sym_extension] = ACTIONS(3535),
    [anon_sym___exported] = ACTIONS(3535),
    [anon_sym_import] = ACTIONS(3535),
  },
  [1025] = {
    [ts_builtin_sym_end] = ACTIONS(3945),
    [sym_identifier] = ACTIONS(3947),
    [aux_sym_preproc_include_token1] = ACTIONS(3947),
    [aux_sym_preproc_def_token1] = ACTIONS(3947),
    [aux_sym_preproc_if_token1] = ACTIONS(3947),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3947),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3947),
    [sym_preproc_directive] = ACTIONS(3947),
    [anon_sym_LPAREN2] = ACTIONS(3945),
    [anon_sym_BANG] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3945),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_STAR] = ACTIONS(3945),
    [anon_sym_AMP_AMP] = ACTIONS(3945),
    [anon_sym_AMP] = ACTIONS(3947),
    [anon_sym___extension__] = ACTIONS(3947),
    [anon_sym_typedef] = ACTIONS(3947),
    [anon_sym_in] = ACTIONS(3947),
    [anon_sym_out] = ACTIONS(3947),
    [anon_sym_inout] = ACTIONS(3947),
    [anon_sym_extern] = ACTIONS(3947),
    [anon_sym___attribute__] = ACTIONS(3947),
    [anon_sym_COLON_COLON] = ACTIONS(3945),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3945),
    [anon_sym___declspec] = ACTIONS(3947),
    [anon_sym___based] = ACTIONS(3947),
    [anon_sym___cdecl] = ACTIONS(3947),
    [anon_sym___clrcall] = ACTIONS(3947),
    [anon_sym___stdcall] = ACTIONS(3947),
    [anon_sym___fastcall] = ACTIONS(3947),
    [anon_sym___thiscall] = ACTIONS(3947),
    [anon_sym___vectorcall] = ACTIONS(3947),
    [anon_sym_LBRACE] = ACTIONS(3945),
    [anon_sym_signed] = ACTIONS(3947),
    [anon_sym_unsigned] = ACTIONS(3947),
    [anon_sym_long] = ACTIONS(3947),
    [anon_sym_short] = ACTIONS(3947),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_static] = ACTIONS(3947),
    [anon_sym_register] = ACTIONS(3947),
    [anon_sym_inline] = ACTIONS(3947),
    [anon_sym___inline] = ACTIONS(3947),
    [anon_sym___inline__] = ACTIONS(3947),
    [anon_sym___forceinline] = ACTIONS(3947),
    [anon_sym_thread_local] = ACTIONS(3947),
    [anon_sym___thread] = ACTIONS(3947),
    [anon_sym_const] = ACTIONS(3947),
    [anon_sym_constexpr] = ACTIONS(3947),
    [anon_sym_volatile] = ACTIONS(3947),
    [anon_sym_restrict] = ACTIONS(3947),
    [anon_sym___restrict__] = ACTIONS(3947),
    [anon_sym__Atomic] = ACTIONS(3947),
    [anon_sym__Noreturn] = ACTIONS(3947),
    [anon_sym_noreturn] = ACTIONS(3947),
    [anon_sym_mutable] = ACTIONS(3947),
    [anon_sym_constinit] = ACTIONS(3947),
    [anon_sym_consteval] = ACTIONS(3947),
    [anon_sym_alignas] = ACTIONS(3947),
    [anon_sym__Alignas] = ACTIONS(3947),
    [sym_primitive_type] = ACTIONS(3947),
    [anon_sym_enum] = ACTIONS(3947),
    [anon_sym_class] = ACTIONS(3947),
    [anon_sym_struct] = ACTIONS(3947),
    [anon_sym_union] = ACTIONS(3947),
    [anon_sym_if] = ACTIONS(3947),
    [anon_sym_switch] = ACTIONS(3947),
    [anon_sym_case] = ACTIONS(3947),
    [anon_sym_default] = ACTIONS(3947),
    [anon_sym_while] = ACTIONS(3947),
    [anon_sym_do] = ACTIONS(3947),
    [anon_sym_for] = ACTIONS(3947),
    [anon_sym_return] = ACTIONS(3947),
    [anon_sym_break] = ACTIONS(3947),
    [anon_sym_continue] = ACTIONS(3947),
    [anon_sym_goto] = ACTIONS(3947),
    [anon_sym_not] = ACTIONS(3947),
    [anon_sym_compl] = ACTIONS(3947),
    [anon_sym_DASH_DASH] = ACTIONS(3945),
    [anon_sym_PLUS_PLUS] = ACTIONS(3945),
    [anon_sym_sizeof] = ACTIONS(3947),
    [anon_sym___alignof__] = ACTIONS(3947),
    [anon_sym___alignof] = ACTIONS(3947),
    [anon_sym__alignof] = ACTIONS(3947),
    [anon_sym_alignof] = ACTIONS(3947),
    [anon_sym__Alignof] = ACTIONS(3947),
    [anon_sym_offsetof] = ACTIONS(3947),
    [anon_sym__Generic] = ACTIONS(3947),
    [anon_sym_asm] = ACTIONS(3947),
    [anon_sym___asm__] = ACTIONS(3947),
    [sym_number_literal] = ACTIONS(3945),
    [anon_sym_L_SQUOTE] = ACTIONS(3945),
    [anon_sym_u_SQUOTE] = ACTIONS(3945),
    [anon_sym_U_SQUOTE] = ACTIONS(3945),
    [anon_sym_u8_SQUOTE] = ACTIONS(3945),
    [anon_sym_SQUOTE] = ACTIONS(3945),
    [anon_sym_L_DQUOTE] = ACTIONS(3945),
    [anon_sym_u_DQUOTE] = ACTIONS(3945),
    [anon_sym_U_DQUOTE] = ACTIONS(3945),
    [anon_sym_u8_DQUOTE] = ACTIONS(3945),
    [anon_sym_DQUOTE] = ACTIONS(3945),
    [sym_true] = ACTIONS(3947),
    [sym_false] = ACTIONS(3947),
    [anon_sym_NULL] = ACTIONS(3947),
    [anon_sym_nullptr] = ACTIONS(3947),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3947),
    [anon_sym_let] = ACTIONS(3947),
    [anon_sym_This] = ACTIONS(3947),
    [anon_sym_decltype] = ACTIONS(3947),
    [sym_virtual] = ACTIONS(3947),
    [anon_sym_explicit] = ACTIONS(3947),
    [anon_sym_typename] = ACTIONS(3947),
    [anon_sym_template] = ACTIONS(3947),
    [anon_sym_operator] = ACTIONS(3947),
    [anon_sym_try] = ACTIONS(3947),
    [anon_sym_delete] = ACTIONS(3947),
    [anon_sym_throw] = ACTIONS(3947),
    [anon_sym_namespace] = ACTIONS(3947),
    [anon_sym_using] = ACTIONS(3947),
    [anon_sym_static_assert] = ACTIONS(3947),
    [anon_sym_concept] = ACTIONS(3947),
    [anon_sym_co_return] = ACTIONS(3947),
    [anon_sym_co_yield] = ACTIONS(3947),
    [anon_sym_R_DQUOTE] = ACTIONS(3945),
    [anon_sym_LR_DQUOTE] = ACTIONS(3945),
    [anon_sym_uR_DQUOTE] = ACTIONS(3945),
    [anon_sym_UR_DQUOTE] = ACTIONS(3945),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3945),
    [anon_sym_co_await] = ACTIONS(3947),
    [anon_sym_new] = ACTIONS(3947),
    [anon_sym_requires] = ACTIONS(3947),
    [sym_this] = ACTIONS(3947),
    [anon_sym_precise] = ACTIONS(3947),
    [anon_sym_shared] = ACTIONS(3947),
    [anon_sym_groupshared] = ACTIONS(3947),
    [anon_sym_uniform] = ACTIONS(3947),
    [anon_sym_row_major] = ACTIONS(3947),
    [anon_sym_column_major] = ACTIONS(3947),
    [anon_sym_globallycoherent] = ACTIONS(3947),
    [anon_sym_centroid] = ACTIONS(3947),
    [anon_sym_noperspective] = ACTIONS(3947),
    [anon_sym_nointerpolation] = ACTIONS(3947),
    [anon_sym_sample] = ACTIONS(3947),
    [anon_sym_linear] = ACTIONS(3947),
    [anon_sym_snorm] = ACTIONS(3947),
    [anon_sym_unorm] = ACTIONS(3947),
    [anon_sym_point] = ACTIONS(3947),
    [anon_sym_line] = ACTIONS(3947),
    [anon_sym_triangleadj] = ACTIONS(3947),
    [anon_sym_lineadj] = ACTIONS(3947),
    [anon_sym_triangle] = ACTIONS(3947),
    [anon_sym_interface] = ACTIONS(3947),
    [anon_sym_extension] = ACTIONS(3947),
    [anon_sym___exported] = ACTIONS(3947),
    [anon_sym_import] = ACTIONS(3947),
  },
  [1026] = {
    [ts_builtin_sym_end] = ACTIONS(3447),
    [sym_identifier] = ACTIONS(3445),
    [aux_sym_preproc_include_token1] = ACTIONS(3445),
    [aux_sym_preproc_def_token1] = ACTIONS(3445),
    [aux_sym_preproc_if_token1] = ACTIONS(3445),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3445),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3445),
    [sym_preproc_directive] = ACTIONS(3445),
    [anon_sym_LPAREN2] = ACTIONS(3447),
    [anon_sym_BANG] = ACTIONS(3447),
    [anon_sym_TILDE] = ACTIONS(3447),
    [anon_sym_DASH] = ACTIONS(3445),
    [anon_sym_PLUS] = ACTIONS(3445),
    [anon_sym_STAR] = ACTIONS(3447),
    [anon_sym_AMP_AMP] = ACTIONS(3447),
    [anon_sym_AMP] = ACTIONS(3445),
    [anon_sym___extension__] = ACTIONS(3445),
    [anon_sym_typedef] = ACTIONS(3445),
    [anon_sym_in] = ACTIONS(3445),
    [anon_sym_out] = ACTIONS(3445),
    [anon_sym_inout] = ACTIONS(3445),
    [anon_sym_extern] = ACTIONS(3445),
    [anon_sym___attribute__] = ACTIONS(3445),
    [anon_sym_COLON_COLON] = ACTIONS(3447),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3447),
    [anon_sym___declspec] = ACTIONS(3445),
    [anon_sym___based] = ACTIONS(3445),
    [anon_sym___cdecl] = ACTIONS(3445),
    [anon_sym___clrcall] = ACTIONS(3445),
    [anon_sym___stdcall] = ACTIONS(3445),
    [anon_sym___fastcall] = ACTIONS(3445),
    [anon_sym___thiscall] = ACTIONS(3445),
    [anon_sym___vectorcall] = ACTIONS(3445),
    [anon_sym_LBRACE] = ACTIONS(3447),
    [anon_sym_signed] = ACTIONS(3445),
    [anon_sym_unsigned] = ACTIONS(3445),
    [anon_sym_long] = ACTIONS(3445),
    [anon_sym_short] = ACTIONS(3445),
    [anon_sym_LBRACK] = ACTIONS(3445),
    [anon_sym_static] = ACTIONS(3445),
    [anon_sym_register] = ACTIONS(3445),
    [anon_sym_inline] = ACTIONS(3445),
    [anon_sym___inline] = ACTIONS(3445),
    [anon_sym___inline__] = ACTIONS(3445),
    [anon_sym___forceinline] = ACTIONS(3445),
    [anon_sym_thread_local] = ACTIONS(3445),
    [anon_sym___thread] = ACTIONS(3445),
    [anon_sym_const] = ACTIONS(3445),
    [anon_sym_constexpr] = ACTIONS(3445),
    [anon_sym_volatile] = ACTIONS(3445),
    [anon_sym_restrict] = ACTIONS(3445),
    [anon_sym___restrict__] = ACTIONS(3445),
    [anon_sym__Atomic] = ACTIONS(3445),
    [anon_sym__Noreturn] = ACTIONS(3445),
    [anon_sym_noreturn] = ACTIONS(3445),
    [anon_sym_mutable] = ACTIONS(3445),
    [anon_sym_constinit] = ACTIONS(3445),
    [anon_sym_consteval] = ACTIONS(3445),
    [anon_sym_alignas] = ACTIONS(3445),
    [anon_sym__Alignas] = ACTIONS(3445),
    [sym_primitive_type] = ACTIONS(3445),
    [anon_sym_enum] = ACTIONS(3445),
    [anon_sym_class] = ACTIONS(3445),
    [anon_sym_struct] = ACTIONS(3445),
    [anon_sym_union] = ACTIONS(3445),
    [anon_sym_if] = ACTIONS(3445),
    [anon_sym_switch] = ACTIONS(3445),
    [anon_sym_case] = ACTIONS(3445),
    [anon_sym_default] = ACTIONS(3445),
    [anon_sym_while] = ACTIONS(3445),
    [anon_sym_do] = ACTIONS(3445),
    [anon_sym_for] = ACTIONS(3445),
    [anon_sym_return] = ACTIONS(3445),
    [anon_sym_break] = ACTIONS(3445),
    [anon_sym_continue] = ACTIONS(3445),
    [anon_sym_goto] = ACTIONS(3445),
    [anon_sym_not] = ACTIONS(3445),
    [anon_sym_compl] = ACTIONS(3445),
    [anon_sym_DASH_DASH] = ACTIONS(3447),
    [anon_sym_PLUS_PLUS] = ACTIONS(3447),
    [anon_sym_sizeof] = ACTIONS(3445),
    [anon_sym___alignof__] = ACTIONS(3445),
    [anon_sym___alignof] = ACTIONS(3445),
    [anon_sym__alignof] = ACTIONS(3445),
    [anon_sym_alignof] = ACTIONS(3445),
    [anon_sym__Alignof] = ACTIONS(3445),
    [anon_sym_offsetof] = ACTIONS(3445),
    [anon_sym__Generic] = ACTIONS(3445),
    [anon_sym_asm] = ACTIONS(3445),
    [anon_sym___asm__] = ACTIONS(3445),
    [sym_number_literal] = ACTIONS(3447),
    [anon_sym_L_SQUOTE] = ACTIONS(3447),
    [anon_sym_u_SQUOTE] = ACTIONS(3447),
    [anon_sym_U_SQUOTE] = ACTIONS(3447),
    [anon_sym_u8_SQUOTE] = ACTIONS(3447),
    [anon_sym_SQUOTE] = ACTIONS(3447),
    [anon_sym_L_DQUOTE] = ACTIONS(3447),
    [anon_sym_u_DQUOTE] = ACTIONS(3447),
    [anon_sym_U_DQUOTE] = ACTIONS(3447),
    [anon_sym_u8_DQUOTE] = ACTIONS(3447),
    [anon_sym_DQUOTE] = ACTIONS(3447),
    [sym_true] = ACTIONS(3445),
    [sym_false] = ACTIONS(3445),
    [anon_sym_NULL] = ACTIONS(3445),
    [anon_sym_nullptr] = ACTIONS(3445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3445),
    [anon_sym_let] = ACTIONS(3445),
    [anon_sym_This] = ACTIONS(3445),
    [anon_sym_decltype] = ACTIONS(3445),
    [sym_virtual] = ACTIONS(3445),
    [anon_sym_explicit] = ACTIONS(3445),
    [anon_sym_typename] = ACTIONS(3445),
    [anon_sym_template] = ACTIONS(3445),
    [anon_sym_operator] = ACTIONS(3445),
    [anon_sym_try] = ACTIONS(3445),
    [anon_sym_delete] = ACTIONS(3445),
    [anon_sym_throw] = ACTIONS(3445),
    [anon_sym_namespace] = ACTIONS(3445),
    [anon_sym_using] = ACTIONS(3445),
    [anon_sym_static_assert] = ACTIONS(3445),
    [anon_sym_concept] = ACTIONS(3445),
    [anon_sym_co_return] = ACTIONS(3445),
    [anon_sym_co_yield] = ACTIONS(3445),
    [anon_sym_R_DQUOTE] = ACTIONS(3447),
    [anon_sym_LR_DQUOTE] = ACTIONS(3447),
    [anon_sym_uR_DQUOTE] = ACTIONS(3447),
    [anon_sym_UR_DQUOTE] = ACTIONS(3447),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3447),
    [anon_sym_co_await] = ACTIONS(3445),
    [anon_sym_new] = ACTIONS(3445),
    [anon_sym_requires] = ACTIONS(3445),
    [sym_this] = ACTIONS(3445),
    [anon_sym_precise] = ACTIONS(3445),
    [anon_sym_shared] = ACTIONS(3445),
    [anon_sym_groupshared] = ACTIONS(3445),
    [anon_sym_uniform] = ACTIONS(3445),
    [anon_sym_row_major] = ACTIONS(3445),
    [anon_sym_column_major] = ACTIONS(3445),
    [anon_sym_globallycoherent] = ACTIONS(3445),
    [anon_sym_centroid] = ACTIONS(3445),
    [anon_sym_noperspective] = ACTIONS(3445),
    [anon_sym_nointerpolation] = ACTIONS(3445),
    [anon_sym_sample] = ACTIONS(3445),
    [anon_sym_linear] = ACTIONS(3445),
    [anon_sym_snorm] = ACTIONS(3445),
    [anon_sym_unorm] = ACTIONS(3445),
    [anon_sym_point] = ACTIONS(3445),
    [anon_sym_line] = ACTIONS(3445),
    [anon_sym_triangleadj] = ACTIONS(3445),
    [anon_sym_lineadj] = ACTIONS(3445),
    [anon_sym_triangle] = ACTIONS(3445),
    [anon_sym_interface] = ACTIONS(3445),
    [anon_sym_extension] = ACTIONS(3445),
    [anon_sym___exported] = ACTIONS(3445),
    [anon_sym_import] = ACTIONS(3445),
  },
  [1027] = {
    [ts_builtin_sym_end] = ACTIONS(3443),
    [sym_identifier] = ACTIONS(3441),
    [aux_sym_preproc_include_token1] = ACTIONS(3441),
    [aux_sym_preproc_def_token1] = ACTIONS(3441),
    [aux_sym_preproc_if_token1] = ACTIONS(3441),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3441),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3441),
    [sym_preproc_directive] = ACTIONS(3441),
    [anon_sym_LPAREN2] = ACTIONS(3443),
    [anon_sym_BANG] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3441),
    [anon_sym_PLUS] = ACTIONS(3441),
    [anon_sym_STAR] = ACTIONS(3443),
    [anon_sym_AMP_AMP] = ACTIONS(3443),
    [anon_sym_AMP] = ACTIONS(3441),
    [anon_sym___extension__] = ACTIONS(3441),
    [anon_sym_typedef] = ACTIONS(3441),
    [anon_sym_in] = ACTIONS(3441),
    [anon_sym_out] = ACTIONS(3441),
    [anon_sym_inout] = ACTIONS(3441),
    [anon_sym_extern] = ACTIONS(3441),
    [anon_sym___attribute__] = ACTIONS(3441),
    [anon_sym_COLON_COLON] = ACTIONS(3443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3443),
    [anon_sym___declspec] = ACTIONS(3441),
    [anon_sym___based] = ACTIONS(3441),
    [anon_sym___cdecl] = ACTIONS(3441),
    [anon_sym___clrcall] = ACTIONS(3441),
    [anon_sym___stdcall] = ACTIONS(3441),
    [anon_sym___fastcall] = ACTIONS(3441),
    [anon_sym___thiscall] = ACTIONS(3441),
    [anon_sym___vectorcall] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_signed] = ACTIONS(3441),
    [anon_sym_unsigned] = ACTIONS(3441),
    [anon_sym_long] = ACTIONS(3441),
    [anon_sym_short] = ACTIONS(3441),
    [anon_sym_LBRACK] = ACTIONS(3441),
    [anon_sym_static] = ACTIONS(3441),
    [anon_sym_register] = ACTIONS(3441),
    [anon_sym_inline] = ACTIONS(3441),
    [anon_sym___inline] = ACTIONS(3441),
    [anon_sym___inline__] = ACTIONS(3441),
    [anon_sym___forceinline] = ACTIONS(3441),
    [anon_sym_thread_local] = ACTIONS(3441),
    [anon_sym___thread] = ACTIONS(3441),
    [anon_sym_const] = ACTIONS(3441),
    [anon_sym_constexpr] = ACTIONS(3441),
    [anon_sym_volatile] = ACTIONS(3441),
    [anon_sym_restrict] = ACTIONS(3441),
    [anon_sym___restrict__] = ACTIONS(3441),
    [anon_sym__Atomic] = ACTIONS(3441),
    [anon_sym__Noreturn] = ACTIONS(3441),
    [anon_sym_noreturn] = ACTIONS(3441),
    [anon_sym_mutable] = ACTIONS(3441),
    [anon_sym_constinit] = ACTIONS(3441),
    [anon_sym_consteval] = ACTIONS(3441),
    [anon_sym_alignas] = ACTIONS(3441),
    [anon_sym__Alignas] = ACTIONS(3441),
    [sym_primitive_type] = ACTIONS(3441),
    [anon_sym_enum] = ACTIONS(3441),
    [anon_sym_class] = ACTIONS(3441),
    [anon_sym_struct] = ACTIONS(3441),
    [anon_sym_union] = ACTIONS(3441),
    [anon_sym_if] = ACTIONS(3441),
    [anon_sym_switch] = ACTIONS(3441),
    [anon_sym_case] = ACTIONS(3441),
    [anon_sym_default] = ACTIONS(3441),
    [anon_sym_while] = ACTIONS(3441),
    [anon_sym_do] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3441),
    [anon_sym_return] = ACTIONS(3441),
    [anon_sym_break] = ACTIONS(3441),
    [anon_sym_continue] = ACTIONS(3441),
    [anon_sym_goto] = ACTIONS(3441),
    [anon_sym_not] = ACTIONS(3441),
    [anon_sym_compl] = ACTIONS(3441),
    [anon_sym_DASH_DASH] = ACTIONS(3443),
    [anon_sym_PLUS_PLUS] = ACTIONS(3443),
    [anon_sym_sizeof] = ACTIONS(3441),
    [anon_sym___alignof__] = ACTIONS(3441),
    [anon_sym___alignof] = ACTIONS(3441),
    [anon_sym__alignof] = ACTIONS(3441),
    [anon_sym_alignof] = ACTIONS(3441),
    [anon_sym__Alignof] = ACTIONS(3441),
    [anon_sym_offsetof] = ACTIONS(3441),
    [anon_sym__Generic] = ACTIONS(3441),
    [anon_sym_asm] = ACTIONS(3441),
    [anon_sym___asm__] = ACTIONS(3441),
    [sym_number_literal] = ACTIONS(3443),
    [anon_sym_L_SQUOTE] = ACTIONS(3443),
    [anon_sym_u_SQUOTE] = ACTIONS(3443),
    [anon_sym_U_SQUOTE] = ACTIONS(3443),
    [anon_sym_u8_SQUOTE] = ACTIONS(3443),
    [anon_sym_SQUOTE] = ACTIONS(3443),
    [anon_sym_L_DQUOTE] = ACTIONS(3443),
    [anon_sym_u_DQUOTE] = ACTIONS(3443),
    [anon_sym_U_DQUOTE] = ACTIONS(3443),
    [anon_sym_u8_DQUOTE] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3443),
    [sym_true] = ACTIONS(3441),
    [sym_false] = ACTIONS(3441),
    [anon_sym_NULL] = ACTIONS(3441),
    [anon_sym_nullptr] = ACTIONS(3441),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3441),
    [anon_sym_let] = ACTIONS(3441),
    [anon_sym_This] = ACTIONS(3441),
    [anon_sym_decltype] = ACTIONS(3441),
    [sym_virtual] = ACTIONS(3441),
    [anon_sym_explicit] = ACTIONS(3441),
    [anon_sym_typename] = ACTIONS(3441),
    [anon_sym_template] = ACTIONS(3441),
    [anon_sym_operator] = ACTIONS(3441),
    [anon_sym_try] = ACTIONS(3441),
    [anon_sym_delete] = ACTIONS(3441),
    [anon_sym_throw] = ACTIONS(3441),
    [anon_sym_namespace] = ACTIONS(3441),
    [anon_sym_using] = ACTIONS(3441),
    [anon_sym_static_assert] = ACTIONS(3441),
    [anon_sym_concept] = ACTIONS(3441),
    [anon_sym_co_return] = ACTIONS(3441),
    [anon_sym_co_yield] = ACTIONS(3441),
    [anon_sym_R_DQUOTE] = ACTIONS(3443),
    [anon_sym_LR_DQUOTE] = ACTIONS(3443),
    [anon_sym_uR_DQUOTE] = ACTIONS(3443),
    [anon_sym_UR_DQUOTE] = ACTIONS(3443),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3443),
    [anon_sym_co_await] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3441),
    [anon_sym_requires] = ACTIONS(3441),
    [sym_this] = ACTIONS(3441),
    [anon_sym_precise] = ACTIONS(3441),
    [anon_sym_shared] = ACTIONS(3441),
    [anon_sym_groupshared] = ACTIONS(3441),
    [anon_sym_uniform] = ACTIONS(3441),
    [anon_sym_row_major] = ACTIONS(3441),
    [anon_sym_column_major] = ACTIONS(3441),
    [anon_sym_globallycoherent] = ACTIONS(3441),
    [anon_sym_centroid] = ACTIONS(3441),
    [anon_sym_noperspective] = ACTIONS(3441),
    [anon_sym_nointerpolation] = ACTIONS(3441),
    [anon_sym_sample] = ACTIONS(3441),
    [anon_sym_linear] = ACTIONS(3441),
    [anon_sym_snorm] = ACTIONS(3441),
    [anon_sym_unorm] = ACTIONS(3441),
    [anon_sym_point] = ACTIONS(3441),
    [anon_sym_line] = ACTIONS(3441),
    [anon_sym_triangleadj] = ACTIONS(3441),
    [anon_sym_lineadj] = ACTIONS(3441),
    [anon_sym_triangle] = ACTIONS(3441),
    [anon_sym_interface] = ACTIONS(3441),
    [anon_sym_extension] = ACTIONS(3441),
    [anon_sym___exported] = ACTIONS(3441),
    [anon_sym_import] = ACTIONS(3441),
  },
  [1028] = {
    [ts_builtin_sym_end] = ACTIONS(3705),
    [sym_identifier] = ACTIONS(3703),
    [aux_sym_preproc_include_token1] = ACTIONS(3703),
    [aux_sym_preproc_def_token1] = ACTIONS(3703),
    [aux_sym_preproc_if_token1] = ACTIONS(3703),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3703),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3703),
    [sym_preproc_directive] = ACTIONS(3703),
    [anon_sym_LPAREN2] = ACTIONS(3705),
    [anon_sym_BANG] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3705),
    [anon_sym_DASH] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3703),
    [anon_sym_STAR] = ACTIONS(3705),
    [anon_sym_AMP_AMP] = ACTIONS(3705),
    [anon_sym_AMP] = ACTIONS(3703),
    [anon_sym___extension__] = ACTIONS(3703),
    [anon_sym_typedef] = ACTIONS(3703),
    [anon_sym_in] = ACTIONS(3703),
    [anon_sym_out] = ACTIONS(3703),
    [anon_sym_inout] = ACTIONS(3703),
    [anon_sym_extern] = ACTIONS(3703),
    [anon_sym___attribute__] = ACTIONS(3703),
    [anon_sym_COLON_COLON] = ACTIONS(3705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3705),
    [anon_sym___declspec] = ACTIONS(3703),
    [anon_sym___based] = ACTIONS(3703),
    [anon_sym___cdecl] = ACTIONS(3703),
    [anon_sym___clrcall] = ACTIONS(3703),
    [anon_sym___stdcall] = ACTIONS(3703),
    [anon_sym___fastcall] = ACTIONS(3703),
    [anon_sym___thiscall] = ACTIONS(3703),
    [anon_sym___vectorcall] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [anon_sym_signed] = ACTIONS(3703),
    [anon_sym_unsigned] = ACTIONS(3703),
    [anon_sym_long] = ACTIONS(3703),
    [anon_sym_short] = ACTIONS(3703),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_static] = ACTIONS(3703),
    [anon_sym_register] = ACTIONS(3703),
    [anon_sym_inline] = ACTIONS(3703),
    [anon_sym___inline] = ACTIONS(3703),
    [anon_sym___inline__] = ACTIONS(3703),
    [anon_sym___forceinline] = ACTIONS(3703),
    [anon_sym_thread_local] = ACTIONS(3703),
    [anon_sym___thread] = ACTIONS(3703),
    [anon_sym_const] = ACTIONS(3703),
    [anon_sym_constexpr] = ACTIONS(3703),
    [anon_sym_volatile] = ACTIONS(3703),
    [anon_sym_restrict] = ACTIONS(3703),
    [anon_sym___restrict__] = ACTIONS(3703),
    [anon_sym__Atomic] = ACTIONS(3703),
    [anon_sym__Noreturn] = ACTIONS(3703),
    [anon_sym_noreturn] = ACTIONS(3703),
    [anon_sym_mutable] = ACTIONS(3703),
    [anon_sym_constinit] = ACTIONS(3703),
    [anon_sym_consteval] = ACTIONS(3703),
    [anon_sym_alignas] = ACTIONS(3703),
    [anon_sym__Alignas] = ACTIONS(3703),
    [sym_primitive_type] = ACTIONS(3703),
    [anon_sym_enum] = ACTIONS(3703),
    [anon_sym_class] = ACTIONS(3703),
    [anon_sym_struct] = ACTIONS(3703),
    [anon_sym_union] = ACTIONS(3703),
    [anon_sym_if] = ACTIONS(3703),
    [anon_sym_switch] = ACTIONS(3703),
    [anon_sym_case] = ACTIONS(3703),
    [anon_sym_default] = ACTIONS(3703),
    [anon_sym_while] = ACTIONS(3703),
    [anon_sym_do] = ACTIONS(3703),
    [anon_sym_for] = ACTIONS(3703),
    [anon_sym_return] = ACTIONS(3703),
    [anon_sym_break] = ACTIONS(3703),
    [anon_sym_continue] = ACTIONS(3703),
    [anon_sym_goto] = ACTIONS(3703),
    [anon_sym_not] = ACTIONS(3703),
    [anon_sym_compl] = ACTIONS(3703),
    [anon_sym_DASH_DASH] = ACTIONS(3705),
    [anon_sym_PLUS_PLUS] = ACTIONS(3705),
    [anon_sym_sizeof] = ACTIONS(3703),
    [anon_sym___alignof__] = ACTIONS(3703),
    [anon_sym___alignof] = ACTIONS(3703),
    [anon_sym__alignof] = ACTIONS(3703),
    [anon_sym_alignof] = ACTIONS(3703),
    [anon_sym__Alignof] = ACTIONS(3703),
    [anon_sym_offsetof] = ACTIONS(3703),
    [anon_sym__Generic] = ACTIONS(3703),
    [anon_sym_asm] = ACTIONS(3703),
    [anon_sym___asm__] = ACTIONS(3703),
    [sym_number_literal] = ACTIONS(3705),
    [anon_sym_L_SQUOTE] = ACTIONS(3705),
    [anon_sym_u_SQUOTE] = ACTIONS(3705),
    [anon_sym_U_SQUOTE] = ACTIONS(3705),
    [anon_sym_u8_SQUOTE] = ACTIONS(3705),
    [anon_sym_SQUOTE] = ACTIONS(3705),
    [anon_sym_L_DQUOTE] = ACTIONS(3705),
    [anon_sym_u_DQUOTE] = ACTIONS(3705),
    [anon_sym_U_DQUOTE] = ACTIONS(3705),
    [anon_sym_u8_DQUOTE] = ACTIONS(3705),
    [anon_sym_DQUOTE] = ACTIONS(3705),
    [sym_true] = ACTIONS(3703),
    [sym_false] = ACTIONS(3703),
    [anon_sym_NULL] = ACTIONS(3703),
    [anon_sym_nullptr] = ACTIONS(3703),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3703),
    [anon_sym_let] = ACTIONS(3703),
    [anon_sym_This] = ACTIONS(3703),
    [anon_sym_decltype] = ACTIONS(3703),
    [sym_virtual] = ACTIONS(3703),
    [anon_sym_explicit] = ACTIONS(3703),
    [anon_sym_typename] = ACTIONS(3703),
    [anon_sym_template] = ACTIONS(3703),
    [anon_sym_operator] = ACTIONS(3703),
    [anon_sym_try] = ACTIONS(3703),
    [anon_sym_delete] = ACTIONS(3703),
    [anon_sym_throw] = ACTIONS(3703),
    [anon_sym_namespace] = ACTIONS(3703),
    [anon_sym_using] = ACTIONS(3703),
    [anon_sym_static_assert] = ACTIONS(3703),
    [anon_sym_concept] = ACTIONS(3703),
    [anon_sym_co_return] = ACTIONS(3703),
    [anon_sym_co_yield] = ACTIONS(3703),
    [anon_sym_R_DQUOTE] = ACTIONS(3705),
    [anon_sym_LR_DQUOTE] = ACTIONS(3705),
    [anon_sym_uR_DQUOTE] = ACTIONS(3705),
    [anon_sym_UR_DQUOTE] = ACTIONS(3705),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3705),
    [anon_sym_co_await] = ACTIONS(3703),
    [anon_sym_new] = ACTIONS(3703),
    [anon_sym_requires] = ACTIONS(3703),
    [sym_this] = ACTIONS(3703),
    [anon_sym_precise] = ACTIONS(3703),
    [anon_sym_shared] = ACTIONS(3703),
    [anon_sym_groupshared] = ACTIONS(3703),
    [anon_sym_uniform] = ACTIONS(3703),
    [anon_sym_row_major] = ACTIONS(3703),
    [anon_sym_column_major] = ACTIONS(3703),
    [anon_sym_globallycoherent] = ACTIONS(3703),
    [anon_sym_centroid] = ACTIONS(3703),
    [anon_sym_noperspective] = ACTIONS(3703),
    [anon_sym_nointerpolation] = ACTIONS(3703),
    [anon_sym_sample] = ACTIONS(3703),
    [anon_sym_linear] = ACTIONS(3703),
    [anon_sym_snorm] = ACTIONS(3703),
    [anon_sym_unorm] = ACTIONS(3703),
    [anon_sym_point] = ACTIONS(3703),
    [anon_sym_line] = ACTIONS(3703),
    [anon_sym_triangleadj] = ACTIONS(3703),
    [anon_sym_lineadj] = ACTIONS(3703),
    [anon_sym_triangle] = ACTIONS(3703),
    [anon_sym_interface] = ACTIONS(3703),
    [anon_sym_extension] = ACTIONS(3703),
    [anon_sym___exported] = ACTIONS(3703),
    [anon_sym_import] = ACTIONS(3703),
  },
  [1029] = {
    [ts_builtin_sym_end] = ACTIONS(3643),
    [sym_identifier] = ACTIONS(3641),
    [aux_sym_preproc_include_token1] = ACTIONS(3641),
    [aux_sym_preproc_def_token1] = ACTIONS(3641),
    [aux_sym_preproc_if_token1] = ACTIONS(3641),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3641),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3641),
    [sym_preproc_directive] = ACTIONS(3641),
    [anon_sym_LPAREN2] = ACTIONS(3643),
    [anon_sym_BANG] = ACTIONS(3643),
    [anon_sym_TILDE] = ACTIONS(3643),
    [anon_sym_DASH] = ACTIONS(3641),
    [anon_sym_PLUS] = ACTIONS(3641),
    [anon_sym_STAR] = ACTIONS(3643),
    [anon_sym_AMP_AMP] = ACTIONS(3643),
    [anon_sym_AMP] = ACTIONS(3641),
    [anon_sym___extension__] = ACTIONS(3641),
    [anon_sym_typedef] = ACTIONS(3641),
    [anon_sym_in] = ACTIONS(3641),
    [anon_sym_out] = ACTIONS(3641),
    [anon_sym_inout] = ACTIONS(3641),
    [anon_sym_extern] = ACTIONS(3641),
    [anon_sym___attribute__] = ACTIONS(3641),
    [anon_sym_COLON_COLON] = ACTIONS(3643),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3643),
    [anon_sym___declspec] = ACTIONS(3641),
    [anon_sym___based] = ACTIONS(3641),
    [anon_sym___cdecl] = ACTIONS(3641),
    [anon_sym___clrcall] = ACTIONS(3641),
    [anon_sym___stdcall] = ACTIONS(3641),
    [anon_sym___fastcall] = ACTIONS(3641),
    [anon_sym___thiscall] = ACTIONS(3641),
    [anon_sym___vectorcall] = ACTIONS(3641),
    [anon_sym_LBRACE] = ACTIONS(3643),
    [anon_sym_signed] = ACTIONS(3641),
    [anon_sym_unsigned] = ACTIONS(3641),
    [anon_sym_long] = ACTIONS(3641),
    [anon_sym_short] = ACTIONS(3641),
    [anon_sym_LBRACK] = ACTIONS(3641),
    [anon_sym_static] = ACTIONS(3641),
    [anon_sym_register] = ACTIONS(3641),
    [anon_sym_inline] = ACTIONS(3641),
    [anon_sym___inline] = ACTIONS(3641),
    [anon_sym___inline__] = ACTIONS(3641),
    [anon_sym___forceinline] = ACTIONS(3641),
    [anon_sym_thread_local] = ACTIONS(3641),
    [anon_sym___thread] = ACTIONS(3641),
    [anon_sym_const] = ACTIONS(3641),
    [anon_sym_constexpr] = ACTIONS(3641),
    [anon_sym_volatile] = ACTIONS(3641),
    [anon_sym_restrict] = ACTIONS(3641),
    [anon_sym___restrict__] = ACTIONS(3641),
    [anon_sym__Atomic] = ACTIONS(3641),
    [anon_sym__Noreturn] = ACTIONS(3641),
    [anon_sym_noreturn] = ACTIONS(3641),
    [anon_sym_mutable] = ACTIONS(3641),
    [anon_sym_constinit] = ACTIONS(3641),
    [anon_sym_consteval] = ACTIONS(3641),
    [anon_sym_alignas] = ACTIONS(3641),
    [anon_sym__Alignas] = ACTIONS(3641),
    [sym_primitive_type] = ACTIONS(3641),
    [anon_sym_enum] = ACTIONS(3641),
    [anon_sym_class] = ACTIONS(3641),
    [anon_sym_struct] = ACTIONS(3641),
    [anon_sym_union] = ACTIONS(3641),
    [anon_sym_if] = ACTIONS(3641),
    [anon_sym_switch] = ACTIONS(3641),
    [anon_sym_case] = ACTIONS(3641),
    [anon_sym_default] = ACTIONS(3641),
    [anon_sym_while] = ACTIONS(3641),
    [anon_sym_do] = ACTIONS(3641),
    [anon_sym_for] = ACTIONS(3641),
    [anon_sym_return] = ACTIONS(3641),
    [anon_sym_break] = ACTIONS(3641),
    [anon_sym_continue] = ACTIONS(3641),
    [anon_sym_goto] = ACTIONS(3641),
    [anon_sym_not] = ACTIONS(3641),
    [anon_sym_compl] = ACTIONS(3641),
    [anon_sym_DASH_DASH] = ACTIONS(3643),
    [anon_sym_PLUS_PLUS] = ACTIONS(3643),
    [anon_sym_sizeof] = ACTIONS(3641),
    [anon_sym___alignof__] = ACTIONS(3641),
    [anon_sym___alignof] = ACTIONS(3641),
    [anon_sym__alignof] = ACTIONS(3641),
    [anon_sym_alignof] = ACTIONS(3641),
    [anon_sym__Alignof] = ACTIONS(3641),
    [anon_sym_offsetof] = ACTIONS(3641),
    [anon_sym__Generic] = ACTIONS(3641),
    [anon_sym_asm] = ACTIONS(3641),
    [anon_sym___asm__] = ACTIONS(3641),
    [sym_number_literal] = ACTIONS(3643),
    [anon_sym_L_SQUOTE] = ACTIONS(3643),
    [anon_sym_u_SQUOTE] = ACTIONS(3643),
    [anon_sym_U_SQUOTE] = ACTIONS(3643),
    [anon_sym_u8_SQUOTE] = ACTIONS(3643),
    [anon_sym_SQUOTE] = ACTIONS(3643),
    [anon_sym_L_DQUOTE] = ACTIONS(3643),
    [anon_sym_u_DQUOTE] = ACTIONS(3643),
    [anon_sym_U_DQUOTE] = ACTIONS(3643),
    [anon_sym_u8_DQUOTE] = ACTIONS(3643),
    [anon_sym_DQUOTE] = ACTIONS(3643),
    [sym_true] = ACTIONS(3641),
    [sym_false] = ACTIONS(3641),
    [anon_sym_NULL] = ACTIONS(3641),
    [anon_sym_nullptr] = ACTIONS(3641),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3641),
    [anon_sym_let] = ACTIONS(3641),
    [anon_sym_This] = ACTIONS(3641),
    [anon_sym_decltype] = ACTIONS(3641),
    [sym_virtual] = ACTIONS(3641),
    [anon_sym_explicit] = ACTIONS(3641),
    [anon_sym_typename] = ACTIONS(3641),
    [anon_sym_template] = ACTIONS(3641),
    [anon_sym_operator] = ACTIONS(3641),
    [anon_sym_try] = ACTIONS(3641),
    [anon_sym_delete] = ACTIONS(3641),
    [anon_sym_throw] = ACTIONS(3641),
    [anon_sym_namespace] = ACTIONS(3641),
    [anon_sym_using] = ACTIONS(3641),
    [anon_sym_static_assert] = ACTIONS(3641),
    [anon_sym_concept] = ACTIONS(3641),
    [anon_sym_co_return] = ACTIONS(3641),
    [anon_sym_co_yield] = ACTIONS(3641),
    [anon_sym_R_DQUOTE] = ACTIONS(3643),
    [anon_sym_LR_DQUOTE] = ACTIONS(3643),
    [anon_sym_uR_DQUOTE] = ACTIONS(3643),
    [anon_sym_UR_DQUOTE] = ACTIONS(3643),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3643),
    [anon_sym_co_await] = ACTIONS(3641),
    [anon_sym_new] = ACTIONS(3641),
    [anon_sym_requires] = ACTIONS(3641),
    [sym_this] = ACTIONS(3641),
    [anon_sym_precise] = ACTIONS(3641),
    [anon_sym_shared] = ACTIONS(3641),
    [anon_sym_groupshared] = ACTIONS(3641),
    [anon_sym_uniform] = ACTIONS(3641),
    [anon_sym_row_major] = ACTIONS(3641),
    [anon_sym_column_major] = ACTIONS(3641),
    [anon_sym_globallycoherent] = ACTIONS(3641),
    [anon_sym_centroid] = ACTIONS(3641),
    [anon_sym_noperspective] = ACTIONS(3641),
    [anon_sym_nointerpolation] = ACTIONS(3641),
    [anon_sym_sample] = ACTIONS(3641),
    [anon_sym_linear] = ACTIONS(3641),
    [anon_sym_snorm] = ACTIONS(3641),
    [anon_sym_unorm] = ACTIONS(3641),
    [anon_sym_point] = ACTIONS(3641),
    [anon_sym_line] = ACTIONS(3641),
    [anon_sym_triangleadj] = ACTIONS(3641),
    [anon_sym_lineadj] = ACTIONS(3641),
    [anon_sym_triangle] = ACTIONS(3641),
    [anon_sym_interface] = ACTIONS(3641),
    [anon_sym_extension] = ACTIONS(3641),
    [anon_sym___exported] = ACTIONS(3641),
    [anon_sym_import] = ACTIONS(3641),
  },
  [1030] = {
    [ts_builtin_sym_end] = ACTIONS(3651),
    [sym_identifier] = ACTIONS(3649),
    [aux_sym_preproc_include_token1] = ACTIONS(3649),
    [aux_sym_preproc_def_token1] = ACTIONS(3649),
    [aux_sym_preproc_if_token1] = ACTIONS(3649),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3649),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3649),
    [sym_preproc_directive] = ACTIONS(3649),
    [anon_sym_LPAREN2] = ACTIONS(3651),
    [anon_sym_BANG] = ACTIONS(3651),
    [anon_sym_TILDE] = ACTIONS(3651),
    [anon_sym_DASH] = ACTIONS(3649),
    [anon_sym_PLUS] = ACTIONS(3649),
    [anon_sym_STAR] = ACTIONS(3651),
    [anon_sym_AMP_AMP] = ACTIONS(3651),
    [anon_sym_AMP] = ACTIONS(3649),
    [anon_sym___extension__] = ACTIONS(3649),
    [anon_sym_typedef] = ACTIONS(3649),
    [anon_sym_in] = ACTIONS(3649),
    [anon_sym_out] = ACTIONS(3649),
    [anon_sym_inout] = ACTIONS(3649),
    [anon_sym_extern] = ACTIONS(3649),
    [anon_sym___attribute__] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(3651),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3651),
    [anon_sym___declspec] = ACTIONS(3649),
    [anon_sym___based] = ACTIONS(3649),
    [anon_sym___cdecl] = ACTIONS(3649),
    [anon_sym___clrcall] = ACTIONS(3649),
    [anon_sym___stdcall] = ACTIONS(3649),
    [anon_sym___fastcall] = ACTIONS(3649),
    [anon_sym___thiscall] = ACTIONS(3649),
    [anon_sym___vectorcall] = ACTIONS(3649),
    [anon_sym_LBRACE] = ACTIONS(3651),
    [anon_sym_signed] = ACTIONS(3649),
    [anon_sym_unsigned] = ACTIONS(3649),
    [anon_sym_long] = ACTIONS(3649),
    [anon_sym_short] = ACTIONS(3649),
    [anon_sym_LBRACK] = ACTIONS(3649),
    [anon_sym_static] = ACTIONS(3649),
    [anon_sym_register] = ACTIONS(3649),
    [anon_sym_inline] = ACTIONS(3649),
    [anon_sym___inline] = ACTIONS(3649),
    [anon_sym___inline__] = ACTIONS(3649),
    [anon_sym___forceinline] = ACTIONS(3649),
    [anon_sym_thread_local] = ACTIONS(3649),
    [anon_sym___thread] = ACTIONS(3649),
    [anon_sym_const] = ACTIONS(3649),
    [anon_sym_constexpr] = ACTIONS(3649),
    [anon_sym_volatile] = ACTIONS(3649),
    [anon_sym_restrict] = ACTIONS(3649),
    [anon_sym___restrict__] = ACTIONS(3649),
    [anon_sym__Atomic] = ACTIONS(3649),
    [anon_sym__Noreturn] = ACTIONS(3649),
    [anon_sym_noreturn] = ACTIONS(3649),
    [anon_sym_mutable] = ACTIONS(3649),
    [anon_sym_constinit] = ACTIONS(3649),
    [anon_sym_consteval] = ACTIONS(3649),
    [anon_sym_alignas] = ACTIONS(3649),
    [anon_sym__Alignas] = ACTIONS(3649),
    [sym_primitive_type] = ACTIONS(3649),
    [anon_sym_enum] = ACTIONS(3649),
    [anon_sym_class] = ACTIONS(3649),
    [anon_sym_struct] = ACTIONS(3649),
    [anon_sym_union] = ACTIONS(3649),
    [anon_sym_if] = ACTIONS(3649),
    [anon_sym_switch] = ACTIONS(3649),
    [anon_sym_case] = ACTIONS(3649),
    [anon_sym_default] = ACTIONS(3649),
    [anon_sym_while] = ACTIONS(3649),
    [anon_sym_do] = ACTIONS(3649),
    [anon_sym_for] = ACTIONS(3649),
    [anon_sym_return] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3649),
    [anon_sym_continue] = ACTIONS(3649),
    [anon_sym_goto] = ACTIONS(3649),
    [anon_sym_not] = ACTIONS(3649),
    [anon_sym_compl] = ACTIONS(3649),
    [anon_sym_DASH_DASH] = ACTIONS(3651),
    [anon_sym_PLUS_PLUS] = ACTIONS(3651),
    [anon_sym_sizeof] = ACTIONS(3649),
    [anon_sym___alignof__] = ACTIONS(3649),
    [anon_sym___alignof] = ACTIONS(3649),
    [anon_sym__alignof] = ACTIONS(3649),
    [anon_sym_alignof] = ACTIONS(3649),
    [anon_sym__Alignof] = ACTIONS(3649),
    [anon_sym_offsetof] = ACTIONS(3649),
    [anon_sym__Generic] = ACTIONS(3649),
    [anon_sym_asm] = ACTIONS(3649),
    [anon_sym___asm__] = ACTIONS(3649),
    [sym_number_literal] = ACTIONS(3651),
    [anon_sym_L_SQUOTE] = ACTIONS(3651),
    [anon_sym_u_SQUOTE] = ACTIONS(3651),
    [anon_sym_U_SQUOTE] = ACTIONS(3651),
    [anon_sym_u8_SQUOTE] = ACTIONS(3651),
    [anon_sym_SQUOTE] = ACTIONS(3651),
    [anon_sym_L_DQUOTE] = ACTIONS(3651),
    [anon_sym_u_DQUOTE] = ACTIONS(3651),
    [anon_sym_U_DQUOTE] = ACTIONS(3651),
    [anon_sym_u8_DQUOTE] = ACTIONS(3651),
    [anon_sym_DQUOTE] = ACTIONS(3651),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [anon_sym_NULL] = ACTIONS(3649),
    [anon_sym_nullptr] = ACTIONS(3649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3649),
    [anon_sym_let] = ACTIONS(3649),
    [anon_sym_This] = ACTIONS(3649),
    [anon_sym_decltype] = ACTIONS(3649),
    [sym_virtual] = ACTIONS(3649),
    [anon_sym_explicit] = ACTIONS(3649),
    [anon_sym_typename] = ACTIONS(3649),
    [anon_sym_template] = ACTIONS(3649),
    [anon_sym_operator] = ACTIONS(3649),
    [anon_sym_try] = ACTIONS(3649),
    [anon_sym_delete] = ACTIONS(3649),
    [anon_sym_throw] = ACTIONS(3649),
    [anon_sym_namespace] = ACTIONS(3649),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_static_assert] = ACTIONS(3649),
    [anon_sym_concept] = ACTIONS(3649),
    [anon_sym_co_return] = ACTIONS(3649),
    [anon_sym_co_yield] = ACTIONS(3649),
    [anon_sym_R_DQUOTE] = ACTIONS(3651),
    [anon_sym_LR_DQUOTE] = ACTIONS(3651),
    [anon_sym_uR_DQUOTE] = ACTIONS(3651),
    [anon_sym_UR_DQUOTE] = ACTIONS(3651),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3651),
    [anon_sym_co_await] = ACTIONS(3649),
    [anon_sym_new] = ACTIONS(3649),
    [anon_sym_requires] = ACTIONS(3649),
    [sym_this] = ACTIONS(3649),
    [anon_sym_precise] = ACTIONS(3649),
    [anon_sym_shared] = ACTIONS(3649),
    [anon_sym_groupshared] = ACTIONS(3649),
    [anon_sym_uniform] = ACTIONS(3649),
    [anon_sym_row_major] = ACTIONS(3649),
    [anon_sym_column_major] = ACTIONS(3649),
    [anon_sym_globallycoherent] = ACTIONS(3649),
    [anon_sym_centroid] = ACTIONS(3649),
    [anon_sym_noperspective] = ACTIONS(3649),
    [anon_sym_nointerpolation] = ACTIONS(3649),
    [anon_sym_sample] = ACTIONS(3649),
    [anon_sym_linear] = ACTIONS(3649),
    [anon_sym_snorm] = ACTIONS(3649),
    [anon_sym_unorm] = ACTIONS(3649),
    [anon_sym_point] = ACTIONS(3649),
    [anon_sym_line] = ACTIONS(3649),
    [anon_sym_triangleadj] = ACTIONS(3649),
    [anon_sym_lineadj] = ACTIONS(3649),
    [anon_sym_triangle] = ACTIONS(3649),
    [anon_sym_interface] = ACTIONS(3649),
    [anon_sym_extension] = ACTIONS(3649),
    [anon_sym___exported] = ACTIONS(3649),
    [anon_sym_import] = ACTIONS(3649),
  },
  [1031] = {
    [ts_builtin_sym_end] = ACTIONS(3603),
    [sym_identifier] = ACTIONS(3601),
    [aux_sym_preproc_include_token1] = ACTIONS(3601),
    [aux_sym_preproc_def_token1] = ACTIONS(3601),
    [aux_sym_preproc_if_token1] = ACTIONS(3601),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3601),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3601),
    [sym_preproc_directive] = ACTIONS(3601),
    [anon_sym_LPAREN2] = ACTIONS(3603),
    [anon_sym_BANG] = ACTIONS(3603),
    [anon_sym_TILDE] = ACTIONS(3603),
    [anon_sym_DASH] = ACTIONS(3601),
    [anon_sym_PLUS] = ACTIONS(3601),
    [anon_sym_STAR] = ACTIONS(3603),
    [anon_sym_AMP_AMP] = ACTIONS(3603),
    [anon_sym_AMP] = ACTIONS(3601),
    [anon_sym___extension__] = ACTIONS(3601),
    [anon_sym_typedef] = ACTIONS(3601),
    [anon_sym_in] = ACTIONS(3601),
    [anon_sym_out] = ACTIONS(3601),
    [anon_sym_inout] = ACTIONS(3601),
    [anon_sym_extern] = ACTIONS(3601),
    [anon_sym___attribute__] = ACTIONS(3601),
    [anon_sym_COLON_COLON] = ACTIONS(3603),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3603),
    [anon_sym___declspec] = ACTIONS(3601),
    [anon_sym___based] = ACTIONS(3601),
    [anon_sym___cdecl] = ACTIONS(3601),
    [anon_sym___clrcall] = ACTIONS(3601),
    [anon_sym___stdcall] = ACTIONS(3601),
    [anon_sym___fastcall] = ACTIONS(3601),
    [anon_sym___thiscall] = ACTIONS(3601),
    [anon_sym___vectorcall] = ACTIONS(3601),
    [anon_sym_LBRACE] = ACTIONS(3603),
    [anon_sym_signed] = ACTIONS(3601),
    [anon_sym_unsigned] = ACTIONS(3601),
    [anon_sym_long] = ACTIONS(3601),
    [anon_sym_short] = ACTIONS(3601),
    [anon_sym_LBRACK] = ACTIONS(3601),
    [anon_sym_static] = ACTIONS(3601),
    [anon_sym_register] = ACTIONS(3601),
    [anon_sym_inline] = ACTIONS(3601),
    [anon_sym___inline] = ACTIONS(3601),
    [anon_sym___inline__] = ACTIONS(3601),
    [anon_sym___forceinline] = ACTIONS(3601),
    [anon_sym_thread_local] = ACTIONS(3601),
    [anon_sym___thread] = ACTIONS(3601),
    [anon_sym_const] = ACTIONS(3601),
    [anon_sym_constexpr] = ACTIONS(3601),
    [anon_sym_volatile] = ACTIONS(3601),
    [anon_sym_restrict] = ACTIONS(3601),
    [anon_sym___restrict__] = ACTIONS(3601),
    [anon_sym__Atomic] = ACTIONS(3601),
    [anon_sym__Noreturn] = ACTIONS(3601),
    [anon_sym_noreturn] = ACTIONS(3601),
    [anon_sym_mutable] = ACTIONS(3601),
    [anon_sym_constinit] = ACTIONS(3601),
    [anon_sym_consteval] = ACTIONS(3601),
    [anon_sym_alignas] = ACTIONS(3601),
    [anon_sym__Alignas] = ACTIONS(3601),
    [sym_primitive_type] = ACTIONS(3601),
    [anon_sym_enum] = ACTIONS(3601),
    [anon_sym_class] = ACTIONS(3601),
    [anon_sym_struct] = ACTIONS(3601),
    [anon_sym_union] = ACTIONS(3601),
    [anon_sym_if] = ACTIONS(3601),
    [anon_sym_switch] = ACTIONS(3601),
    [anon_sym_case] = ACTIONS(3601),
    [anon_sym_default] = ACTIONS(3601),
    [anon_sym_while] = ACTIONS(3601),
    [anon_sym_do] = ACTIONS(3601),
    [anon_sym_for] = ACTIONS(3601),
    [anon_sym_return] = ACTIONS(3601),
    [anon_sym_break] = ACTIONS(3601),
    [anon_sym_continue] = ACTIONS(3601),
    [anon_sym_goto] = ACTIONS(3601),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_compl] = ACTIONS(3601),
    [anon_sym_DASH_DASH] = ACTIONS(3603),
    [anon_sym_PLUS_PLUS] = ACTIONS(3603),
    [anon_sym_sizeof] = ACTIONS(3601),
    [anon_sym___alignof__] = ACTIONS(3601),
    [anon_sym___alignof] = ACTIONS(3601),
    [anon_sym__alignof] = ACTIONS(3601),
    [anon_sym_alignof] = ACTIONS(3601),
    [anon_sym__Alignof] = ACTIONS(3601),
    [anon_sym_offsetof] = ACTIONS(3601),
    [anon_sym__Generic] = ACTIONS(3601),
    [anon_sym_asm] = ACTIONS(3601),
    [anon_sym___asm__] = ACTIONS(3601),
    [sym_number_literal] = ACTIONS(3603),
    [anon_sym_L_SQUOTE] = ACTIONS(3603),
    [anon_sym_u_SQUOTE] = ACTIONS(3603),
    [anon_sym_U_SQUOTE] = ACTIONS(3603),
    [anon_sym_u8_SQUOTE] = ACTIONS(3603),
    [anon_sym_SQUOTE] = ACTIONS(3603),
    [anon_sym_L_DQUOTE] = ACTIONS(3603),
    [anon_sym_u_DQUOTE] = ACTIONS(3603),
    [anon_sym_U_DQUOTE] = ACTIONS(3603),
    [anon_sym_u8_DQUOTE] = ACTIONS(3603),
    [anon_sym_DQUOTE] = ACTIONS(3603),
    [sym_true] = ACTIONS(3601),
    [sym_false] = ACTIONS(3601),
    [anon_sym_NULL] = ACTIONS(3601),
    [anon_sym_nullptr] = ACTIONS(3601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3601),
    [anon_sym_let] = ACTIONS(3601),
    [anon_sym_This] = ACTIONS(3601),
    [anon_sym_decltype] = ACTIONS(3601),
    [sym_virtual] = ACTIONS(3601),
    [anon_sym_explicit] = ACTIONS(3601),
    [anon_sym_typename] = ACTIONS(3601),
    [anon_sym_template] = ACTIONS(3601),
    [anon_sym_operator] = ACTIONS(3601),
    [anon_sym_try] = ACTIONS(3601),
    [anon_sym_delete] = ACTIONS(3601),
    [anon_sym_throw] = ACTIONS(3601),
    [anon_sym_namespace] = ACTIONS(3601),
    [anon_sym_using] = ACTIONS(3601),
    [anon_sym_static_assert] = ACTIONS(3601),
    [anon_sym_concept] = ACTIONS(3601),
    [anon_sym_co_return] = ACTIONS(3601),
    [anon_sym_co_yield] = ACTIONS(3601),
    [anon_sym_R_DQUOTE] = ACTIONS(3603),
    [anon_sym_LR_DQUOTE] = ACTIONS(3603),
    [anon_sym_uR_DQUOTE] = ACTIONS(3603),
    [anon_sym_UR_DQUOTE] = ACTIONS(3603),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3603),
    [anon_sym_co_await] = ACTIONS(3601),
    [anon_sym_new] = ACTIONS(3601),
    [anon_sym_requires] = ACTIONS(3601),
    [sym_this] = ACTIONS(3601),
    [anon_sym_precise] = ACTIONS(3601),
    [anon_sym_shared] = ACTIONS(3601),
    [anon_sym_groupshared] = ACTIONS(3601),
    [anon_sym_uniform] = ACTIONS(3601),
    [anon_sym_row_major] = ACTIONS(3601),
    [anon_sym_column_major] = ACTIONS(3601),
    [anon_sym_globallycoherent] = ACTIONS(3601),
    [anon_sym_centroid] = ACTIONS(3601),
    [anon_sym_noperspective] = ACTIONS(3601),
    [anon_sym_nointerpolation] = ACTIONS(3601),
    [anon_sym_sample] = ACTIONS(3601),
    [anon_sym_linear] = ACTIONS(3601),
    [anon_sym_snorm] = ACTIONS(3601),
    [anon_sym_unorm] = ACTIONS(3601),
    [anon_sym_point] = ACTIONS(3601),
    [anon_sym_line] = ACTIONS(3601),
    [anon_sym_triangleadj] = ACTIONS(3601),
    [anon_sym_lineadj] = ACTIONS(3601),
    [anon_sym_triangle] = ACTIONS(3601),
    [anon_sym_interface] = ACTIONS(3601),
    [anon_sym_extension] = ACTIONS(3601),
    [anon_sym___exported] = ACTIONS(3601),
    [anon_sym_import] = ACTIONS(3601),
  },
  [1032] = {
    [ts_builtin_sym_end] = ACTIONS(3416),
    [sym_identifier] = ACTIONS(3414),
    [aux_sym_preproc_include_token1] = ACTIONS(3414),
    [aux_sym_preproc_def_token1] = ACTIONS(3414),
    [aux_sym_preproc_if_token1] = ACTIONS(3414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3414),
    [sym_preproc_directive] = ACTIONS(3414),
    [anon_sym_LPAREN2] = ACTIONS(3416),
    [anon_sym_BANG] = ACTIONS(3416),
    [anon_sym_TILDE] = ACTIONS(3416),
    [anon_sym_DASH] = ACTIONS(3414),
    [anon_sym_PLUS] = ACTIONS(3414),
    [anon_sym_STAR] = ACTIONS(3416),
    [anon_sym_AMP_AMP] = ACTIONS(3416),
    [anon_sym_AMP] = ACTIONS(3414),
    [anon_sym___extension__] = ACTIONS(3414),
    [anon_sym_typedef] = ACTIONS(3414),
    [anon_sym_in] = ACTIONS(3414),
    [anon_sym_out] = ACTIONS(3414),
    [anon_sym_inout] = ACTIONS(3414),
    [anon_sym_extern] = ACTIONS(3414),
    [anon_sym___attribute__] = ACTIONS(3414),
    [anon_sym_COLON_COLON] = ACTIONS(3416),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3416),
    [anon_sym___declspec] = ACTIONS(3414),
    [anon_sym___based] = ACTIONS(3414),
    [anon_sym___cdecl] = ACTIONS(3414),
    [anon_sym___clrcall] = ACTIONS(3414),
    [anon_sym___stdcall] = ACTIONS(3414),
    [anon_sym___fastcall] = ACTIONS(3414),
    [anon_sym___thiscall] = ACTIONS(3414),
    [anon_sym___vectorcall] = ACTIONS(3414),
    [anon_sym_LBRACE] = ACTIONS(3416),
    [anon_sym_signed] = ACTIONS(3414),
    [anon_sym_unsigned] = ACTIONS(3414),
    [anon_sym_long] = ACTIONS(3414),
    [anon_sym_short] = ACTIONS(3414),
    [anon_sym_LBRACK] = ACTIONS(3414),
    [anon_sym_static] = ACTIONS(3414),
    [anon_sym_register] = ACTIONS(3414),
    [anon_sym_inline] = ACTIONS(3414),
    [anon_sym___inline] = ACTIONS(3414),
    [anon_sym___inline__] = ACTIONS(3414),
    [anon_sym___forceinline] = ACTIONS(3414),
    [anon_sym_thread_local] = ACTIONS(3414),
    [anon_sym___thread] = ACTIONS(3414),
    [anon_sym_const] = ACTIONS(3414),
    [anon_sym_constexpr] = ACTIONS(3414),
    [anon_sym_volatile] = ACTIONS(3414),
    [anon_sym_restrict] = ACTIONS(3414),
    [anon_sym___restrict__] = ACTIONS(3414),
    [anon_sym__Atomic] = ACTIONS(3414),
    [anon_sym__Noreturn] = ACTIONS(3414),
    [anon_sym_noreturn] = ACTIONS(3414),
    [anon_sym_mutable] = ACTIONS(3414),
    [anon_sym_constinit] = ACTIONS(3414),
    [anon_sym_consteval] = ACTIONS(3414),
    [anon_sym_alignas] = ACTIONS(3414),
    [anon_sym__Alignas] = ACTIONS(3414),
    [sym_primitive_type] = ACTIONS(3414),
    [anon_sym_enum] = ACTIONS(3414),
    [anon_sym_class] = ACTIONS(3414),
    [anon_sym_struct] = ACTIONS(3414),
    [anon_sym_union] = ACTIONS(3414),
    [anon_sym_if] = ACTIONS(3414),
    [anon_sym_switch] = ACTIONS(3414),
    [anon_sym_case] = ACTIONS(3414),
    [anon_sym_default] = ACTIONS(3414),
    [anon_sym_while] = ACTIONS(3414),
    [anon_sym_do] = ACTIONS(3414),
    [anon_sym_for] = ACTIONS(3414),
    [anon_sym_return] = ACTIONS(3414),
    [anon_sym_break] = ACTIONS(3414),
    [anon_sym_continue] = ACTIONS(3414),
    [anon_sym_goto] = ACTIONS(3414),
    [anon_sym_not] = ACTIONS(3414),
    [anon_sym_compl] = ACTIONS(3414),
    [anon_sym_DASH_DASH] = ACTIONS(3416),
    [anon_sym_PLUS_PLUS] = ACTIONS(3416),
    [anon_sym_sizeof] = ACTIONS(3414),
    [anon_sym___alignof__] = ACTIONS(3414),
    [anon_sym___alignof] = ACTIONS(3414),
    [anon_sym__alignof] = ACTIONS(3414),
    [anon_sym_alignof] = ACTIONS(3414),
    [anon_sym__Alignof] = ACTIONS(3414),
    [anon_sym_offsetof] = ACTIONS(3414),
    [anon_sym__Generic] = ACTIONS(3414),
    [anon_sym_asm] = ACTIONS(3414),
    [anon_sym___asm__] = ACTIONS(3414),
    [sym_number_literal] = ACTIONS(3416),
    [anon_sym_L_SQUOTE] = ACTIONS(3416),
    [anon_sym_u_SQUOTE] = ACTIONS(3416),
    [anon_sym_U_SQUOTE] = ACTIONS(3416),
    [anon_sym_u8_SQUOTE] = ACTIONS(3416),
    [anon_sym_SQUOTE] = ACTIONS(3416),
    [anon_sym_L_DQUOTE] = ACTIONS(3416),
    [anon_sym_u_DQUOTE] = ACTIONS(3416),
    [anon_sym_U_DQUOTE] = ACTIONS(3416),
    [anon_sym_u8_DQUOTE] = ACTIONS(3416),
    [anon_sym_DQUOTE] = ACTIONS(3416),
    [sym_true] = ACTIONS(3414),
    [sym_false] = ACTIONS(3414),
    [anon_sym_NULL] = ACTIONS(3414),
    [anon_sym_nullptr] = ACTIONS(3414),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3414),
    [anon_sym_let] = ACTIONS(3414),
    [anon_sym_This] = ACTIONS(3414),
    [anon_sym_decltype] = ACTIONS(3414),
    [sym_virtual] = ACTIONS(3414),
    [anon_sym_explicit] = ACTIONS(3414),
    [anon_sym_typename] = ACTIONS(3414),
    [anon_sym_template] = ACTIONS(3414),
    [anon_sym_operator] = ACTIONS(3414),
    [anon_sym_try] = ACTIONS(3414),
    [anon_sym_delete] = ACTIONS(3414),
    [anon_sym_throw] = ACTIONS(3414),
    [anon_sym_namespace] = ACTIONS(3414),
    [anon_sym_using] = ACTIONS(3414),
    [anon_sym_static_assert] = ACTIONS(3414),
    [anon_sym_concept] = ACTIONS(3414),
    [anon_sym_co_return] = ACTIONS(3414),
    [anon_sym_co_yield] = ACTIONS(3414),
    [anon_sym_R_DQUOTE] = ACTIONS(3416),
    [anon_sym_LR_DQUOTE] = ACTIONS(3416),
    [anon_sym_uR_DQUOTE] = ACTIONS(3416),
    [anon_sym_UR_DQUOTE] = ACTIONS(3416),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3416),
    [anon_sym_co_await] = ACTIONS(3414),
    [anon_sym_new] = ACTIONS(3414),
    [anon_sym_requires] = ACTIONS(3414),
    [sym_this] = ACTIONS(3414),
    [anon_sym_precise] = ACTIONS(3414),
    [anon_sym_shared] = ACTIONS(3414),
    [anon_sym_groupshared] = ACTIONS(3414),
    [anon_sym_uniform] = ACTIONS(3414),
    [anon_sym_row_major] = ACTIONS(3414),
    [anon_sym_column_major] = ACTIONS(3414),
    [anon_sym_globallycoherent] = ACTIONS(3414),
    [anon_sym_centroid] = ACTIONS(3414),
    [anon_sym_noperspective] = ACTIONS(3414),
    [anon_sym_nointerpolation] = ACTIONS(3414),
    [anon_sym_sample] = ACTIONS(3414),
    [anon_sym_linear] = ACTIONS(3414),
    [anon_sym_snorm] = ACTIONS(3414),
    [anon_sym_unorm] = ACTIONS(3414),
    [anon_sym_point] = ACTIONS(3414),
    [anon_sym_line] = ACTIONS(3414),
    [anon_sym_triangleadj] = ACTIONS(3414),
    [anon_sym_lineadj] = ACTIONS(3414),
    [anon_sym_triangle] = ACTIONS(3414),
    [anon_sym_interface] = ACTIONS(3414),
    [anon_sym_extension] = ACTIONS(3414),
    [anon_sym___exported] = ACTIONS(3414),
    [anon_sym_import] = ACTIONS(3414),
  },
  [1033] = {
    [ts_builtin_sym_end] = ACTIONS(3949),
    [sym_identifier] = ACTIONS(3951),
    [aux_sym_preproc_include_token1] = ACTIONS(3951),
    [aux_sym_preproc_def_token1] = ACTIONS(3951),
    [aux_sym_preproc_if_token1] = ACTIONS(3951),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3951),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3951),
    [sym_preproc_directive] = ACTIONS(3951),
    [anon_sym_LPAREN2] = ACTIONS(3949),
    [anon_sym_BANG] = ACTIONS(3949),
    [anon_sym_TILDE] = ACTIONS(3949),
    [anon_sym_DASH] = ACTIONS(3951),
    [anon_sym_PLUS] = ACTIONS(3951),
    [anon_sym_STAR] = ACTIONS(3949),
    [anon_sym_AMP_AMP] = ACTIONS(3949),
    [anon_sym_AMP] = ACTIONS(3951),
    [anon_sym___extension__] = ACTIONS(3951),
    [anon_sym_typedef] = ACTIONS(3951),
    [anon_sym_in] = ACTIONS(3951),
    [anon_sym_out] = ACTIONS(3951),
    [anon_sym_inout] = ACTIONS(3951),
    [anon_sym_extern] = ACTIONS(3951),
    [anon_sym___attribute__] = ACTIONS(3951),
    [anon_sym_COLON_COLON] = ACTIONS(3949),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3949),
    [anon_sym___declspec] = ACTIONS(3951),
    [anon_sym___based] = ACTIONS(3951),
    [anon_sym___cdecl] = ACTIONS(3951),
    [anon_sym___clrcall] = ACTIONS(3951),
    [anon_sym___stdcall] = ACTIONS(3951),
    [anon_sym___fastcall] = ACTIONS(3951),
    [anon_sym___thiscall] = ACTIONS(3951),
    [anon_sym___vectorcall] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3949),
    [anon_sym_signed] = ACTIONS(3951),
    [anon_sym_unsigned] = ACTIONS(3951),
    [anon_sym_long] = ACTIONS(3951),
    [anon_sym_short] = ACTIONS(3951),
    [anon_sym_LBRACK] = ACTIONS(3951),
    [anon_sym_static] = ACTIONS(3951),
    [anon_sym_register] = ACTIONS(3951),
    [anon_sym_inline] = ACTIONS(3951),
    [anon_sym___inline] = ACTIONS(3951),
    [anon_sym___inline__] = ACTIONS(3951),
    [anon_sym___forceinline] = ACTIONS(3951),
    [anon_sym_thread_local] = ACTIONS(3951),
    [anon_sym___thread] = ACTIONS(3951),
    [anon_sym_const] = ACTIONS(3951),
    [anon_sym_constexpr] = ACTIONS(3951),
    [anon_sym_volatile] = ACTIONS(3951),
    [anon_sym_restrict] = ACTIONS(3951),
    [anon_sym___restrict__] = ACTIONS(3951),
    [anon_sym__Atomic] = ACTIONS(3951),
    [anon_sym__Noreturn] = ACTIONS(3951),
    [anon_sym_noreturn] = ACTIONS(3951),
    [anon_sym_mutable] = ACTIONS(3951),
    [anon_sym_constinit] = ACTIONS(3951),
    [anon_sym_consteval] = ACTIONS(3951),
    [anon_sym_alignas] = ACTIONS(3951),
    [anon_sym__Alignas] = ACTIONS(3951),
    [sym_primitive_type] = ACTIONS(3951),
    [anon_sym_enum] = ACTIONS(3951),
    [anon_sym_class] = ACTIONS(3951),
    [anon_sym_struct] = ACTIONS(3951),
    [anon_sym_union] = ACTIONS(3951),
    [anon_sym_if] = ACTIONS(3951),
    [anon_sym_switch] = ACTIONS(3951),
    [anon_sym_case] = ACTIONS(3951),
    [anon_sym_default] = ACTIONS(3951),
    [anon_sym_while] = ACTIONS(3951),
    [anon_sym_do] = ACTIONS(3951),
    [anon_sym_for] = ACTIONS(3951),
    [anon_sym_return] = ACTIONS(3951),
    [anon_sym_break] = ACTIONS(3951),
    [anon_sym_continue] = ACTIONS(3951),
    [anon_sym_goto] = ACTIONS(3951),
    [anon_sym_not] = ACTIONS(3951),
    [anon_sym_compl] = ACTIONS(3951),
    [anon_sym_DASH_DASH] = ACTIONS(3949),
    [anon_sym_PLUS_PLUS] = ACTIONS(3949),
    [anon_sym_sizeof] = ACTIONS(3951),
    [anon_sym___alignof__] = ACTIONS(3951),
    [anon_sym___alignof] = ACTIONS(3951),
    [anon_sym__alignof] = ACTIONS(3951),
    [anon_sym_alignof] = ACTIONS(3951),
    [anon_sym__Alignof] = ACTIONS(3951),
    [anon_sym_offsetof] = ACTIONS(3951),
    [anon_sym__Generic] = ACTIONS(3951),
    [anon_sym_asm] = ACTIONS(3951),
    [anon_sym___asm__] = ACTIONS(3951),
    [sym_number_literal] = ACTIONS(3949),
    [anon_sym_L_SQUOTE] = ACTIONS(3949),
    [anon_sym_u_SQUOTE] = ACTIONS(3949),
    [anon_sym_U_SQUOTE] = ACTIONS(3949),
    [anon_sym_u8_SQUOTE] = ACTIONS(3949),
    [anon_sym_SQUOTE] = ACTIONS(3949),
    [anon_sym_L_DQUOTE] = ACTIONS(3949),
    [anon_sym_u_DQUOTE] = ACTIONS(3949),
    [anon_sym_U_DQUOTE] = ACTIONS(3949),
    [anon_sym_u8_DQUOTE] = ACTIONS(3949),
    [anon_sym_DQUOTE] = ACTIONS(3949),
    [sym_true] = ACTIONS(3951),
    [sym_false] = ACTIONS(3951),
    [anon_sym_NULL] = ACTIONS(3951),
    [anon_sym_nullptr] = ACTIONS(3951),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3951),
    [anon_sym_let] = ACTIONS(3951),
    [anon_sym_This] = ACTIONS(3951),
    [anon_sym_decltype] = ACTIONS(3951),
    [sym_virtual] = ACTIONS(3951),
    [anon_sym_explicit] = ACTIONS(3951),
    [anon_sym_typename] = ACTIONS(3951),
    [anon_sym_template] = ACTIONS(3951),
    [anon_sym_operator] = ACTIONS(3951),
    [anon_sym_try] = ACTIONS(3951),
    [anon_sym_delete] = ACTIONS(3951),
    [anon_sym_throw] = ACTIONS(3951),
    [anon_sym_namespace] = ACTIONS(3951),
    [anon_sym_using] = ACTIONS(3951),
    [anon_sym_static_assert] = ACTIONS(3951),
    [anon_sym_concept] = ACTIONS(3951),
    [anon_sym_co_return] = ACTIONS(3951),
    [anon_sym_co_yield] = ACTIONS(3951),
    [anon_sym_R_DQUOTE] = ACTIONS(3949),
    [anon_sym_LR_DQUOTE] = ACTIONS(3949),
    [anon_sym_uR_DQUOTE] = ACTIONS(3949),
    [anon_sym_UR_DQUOTE] = ACTIONS(3949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3949),
    [anon_sym_co_await] = ACTIONS(3951),
    [anon_sym_new] = ACTIONS(3951),
    [anon_sym_requires] = ACTIONS(3951),
    [sym_this] = ACTIONS(3951),
    [anon_sym_precise] = ACTIONS(3951),
    [anon_sym_shared] = ACTIONS(3951),
    [anon_sym_groupshared] = ACTIONS(3951),
    [anon_sym_uniform] = ACTIONS(3951),
    [anon_sym_row_major] = ACTIONS(3951),
    [anon_sym_column_major] = ACTIONS(3951),
    [anon_sym_globallycoherent] = ACTIONS(3951),
    [anon_sym_centroid] = ACTIONS(3951),
    [anon_sym_noperspective] = ACTIONS(3951),
    [anon_sym_nointerpolation] = ACTIONS(3951),
    [anon_sym_sample] = ACTIONS(3951),
    [anon_sym_linear] = ACTIONS(3951),
    [anon_sym_snorm] = ACTIONS(3951),
    [anon_sym_unorm] = ACTIONS(3951),
    [anon_sym_point] = ACTIONS(3951),
    [anon_sym_line] = ACTIONS(3951),
    [anon_sym_triangleadj] = ACTIONS(3951),
    [anon_sym_lineadj] = ACTIONS(3951),
    [anon_sym_triangle] = ACTIONS(3951),
    [anon_sym_interface] = ACTIONS(3951),
    [anon_sym_extension] = ACTIONS(3951),
    [anon_sym___exported] = ACTIONS(3951),
    [anon_sym_import] = ACTIONS(3951),
  },
  [1034] = {
    [ts_builtin_sym_end] = ACTIONS(3427),
    [sym_identifier] = ACTIONS(3425),
    [aux_sym_preproc_include_token1] = ACTIONS(3425),
    [aux_sym_preproc_def_token1] = ACTIONS(3425),
    [aux_sym_preproc_if_token1] = ACTIONS(3425),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3425),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3425),
    [sym_preproc_directive] = ACTIONS(3425),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_BANG] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3425),
    [anon_sym_PLUS] = ACTIONS(3425),
    [anon_sym_STAR] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3425),
    [anon_sym___extension__] = ACTIONS(3425),
    [anon_sym_typedef] = ACTIONS(3425),
    [anon_sym_in] = ACTIONS(3425),
    [anon_sym_out] = ACTIONS(3425),
    [anon_sym_inout] = ACTIONS(3425),
    [anon_sym_extern] = ACTIONS(3425),
    [anon_sym___attribute__] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(3427),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3427),
    [anon_sym___declspec] = ACTIONS(3425),
    [anon_sym___based] = ACTIONS(3425),
    [anon_sym___cdecl] = ACTIONS(3425),
    [anon_sym___clrcall] = ACTIONS(3425),
    [anon_sym___stdcall] = ACTIONS(3425),
    [anon_sym___fastcall] = ACTIONS(3425),
    [anon_sym___thiscall] = ACTIONS(3425),
    [anon_sym___vectorcall] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_signed] = ACTIONS(3425),
    [anon_sym_unsigned] = ACTIONS(3425),
    [anon_sym_long] = ACTIONS(3425),
    [anon_sym_short] = ACTIONS(3425),
    [anon_sym_LBRACK] = ACTIONS(3425),
    [anon_sym_static] = ACTIONS(3425),
    [anon_sym_register] = ACTIONS(3425),
    [anon_sym_inline] = ACTIONS(3425),
    [anon_sym___inline] = ACTIONS(3425),
    [anon_sym___inline__] = ACTIONS(3425),
    [anon_sym___forceinline] = ACTIONS(3425),
    [anon_sym_thread_local] = ACTIONS(3425),
    [anon_sym___thread] = ACTIONS(3425),
    [anon_sym_const] = ACTIONS(3425),
    [anon_sym_constexpr] = ACTIONS(3425),
    [anon_sym_volatile] = ACTIONS(3425),
    [anon_sym_restrict] = ACTIONS(3425),
    [anon_sym___restrict__] = ACTIONS(3425),
    [anon_sym__Atomic] = ACTIONS(3425),
    [anon_sym__Noreturn] = ACTIONS(3425),
    [anon_sym_noreturn] = ACTIONS(3425),
    [anon_sym_mutable] = ACTIONS(3425),
    [anon_sym_constinit] = ACTIONS(3425),
    [anon_sym_consteval] = ACTIONS(3425),
    [anon_sym_alignas] = ACTIONS(3425),
    [anon_sym__Alignas] = ACTIONS(3425),
    [sym_primitive_type] = ACTIONS(3425),
    [anon_sym_enum] = ACTIONS(3425),
    [anon_sym_class] = ACTIONS(3425),
    [anon_sym_struct] = ACTIONS(3425),
    [anon_sym_union] = ACTIONS(3425),
    [anon_sym_if] = ACTIONS(3425),
    [anon_sym_switch] = ACTIONS(3425),
    [anon_sym_case] = ACTIONS(3425),
    [anon_sym_default] = ACTIONS(3425),
    [anon_sym_while] = ACTIONS(3425),
    [anon_sym_do] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3425),
    [anon_sym_return] = ACTIONS(3425),
    [anon_sym_break] = ACTIONS(3425),
    [anon_sym_continue] = ACTIONS(3425),
    [anon_sym_goto] = ACTIONS(3425),
    [anon_sym_not] = ACTIONS(3425),
    [anon_sym_compl] = ACTIONS(3425),
    [anon_sym_DASH_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_PLUS] = ACTIONS(3427),
    [anon_sym_sizeof] = ACTIONS(3425),
    [anon_sym___alignof__] = ACTIONS(3425),
    [anon_sym___alignof] = ACTIONS(3425),
    [anon_sym__alignof] = ACTIONS(3425),
    [anon_sym_alignof] = ACTIONS(3425),
    [anon_sym__Alignof] = ACTIONS(3425),
    [anon_sym_offsetof] = ACTIONS(3425),
    [anon_sym__Generic] = ACTIONS(3425),
    [anon_sym_asm] = ACTIONS(3425),
    [anon_sym___asm__] = ACTIONS(3425),
    [sym_number_literal] = ACTIONS(3427),
    [anon_sym_L_SQUOTE] = ACTIONS(3427),
    [anon_sym_u_SQUOTE] = ACTIONS(3427),
    [anon_sym_U_SQUOTE] = ACTIONS(3427),
    [anon_sym_u8_SQUOTE] = ACTIONS(3427),
    [anon_sym_SQUOTE] = ACTIONS(3427),
    [anon_sym_L_DQUOTE] = ACTIONS(3427),
    [anon_sym_u_DQUOTE] = ACTIONS(3427),
    [anon_sym_U_DQUOTE] = ACTIONS(3427),
    [anon_sym_u8_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [sym_true] = ACTIONS(3425),
    [sym_false] = ACTIONS(3425),
    [anon_sym_NULL] = ACTIONS(3425),
    [anon_sym_nullptr] = ACTIONS(3425),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3425),
    [anon_sym_let] = ACTIONS(3425),
    [anon_sym_This] = ACTIONS(3425),
    [anon_sym_decltype] = ACTIONS(3425),
    [sym_virtual] = ACTIONS(3425),
    [anon_sym_explicit] = ACTIONS(3425),
    [anon_sym_typename] = ACTIONS(3425),
    [anon_sym_template] = ACTIONS(3425),
    [anon_sym_operator] = ACTIONS(3425),
    [anon_sym_try] = ACTIONS(3425),
    [anon_sym_delete] = ACTIONS(3425),
    [anon_sym_throw] = ACTIONS(3425),
    [anon_sym_namespace] = ACTIONS(3425),
    [anon_sym_using] = ACTIONS(3425),
    [anon_sym_static_assert] = ACTIONS(3425),
    [anon_sym_concept] = ACTIONS(3425),
    [anon_sym_co_return] = ACTIONS(3425),
    [anon_sym_co_yield] = ACTIONS(3425),
    [anon_sym_R_DQUOTE] = ACTIONS(3427),
    [anon_sym_LR_DQUOTE] = ACTIONS(3427),
    [anon_sym_uR_DQUOTE] = ACTIONS(3427),
    [anon_sym_UR_DQUOTE] = ACTIONS(3427),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3427),
    [anon_sym_co_await] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_requires] = ACTIONS(3425),
    [sym_this] = ACTIONS(3425),
    [anon_sym_precise] = ACTIONS(3425),
    [anon_sym_shared] = ACTIONS(3425),
    [anon_sym_groupshared] = ACTIONS(3425),
    [anon_sym_uniform] = ACTIONS(3425),
    [anon_sym_row_major] = ACTIONS(3425),
    [anon_sym_column_major] = ACTIONS(3425),
    [anon_sym_globallycoherent] = ACTIONS(3425),
    [anon_sym_centroid] = ACTIONS(3425),
    [anon_sym_noperspective] = ACTIONS(3425),
    [anon_sym_nointerpolation] = ACTIONS(3425),
    [anon_sym_sample] = ACTIONS(3425),
    [anon_sym_linear] = ACTIONS(3425),
    [anon_sym_snorm] = ACTIONS(3425),
    [anon_sym_unorm] = ACTIONS(3425),
    [anon_sym_point] = ACTIONS(3425),
    [anon_sym_line] = ACTIONS(3425),
    [anon_sym_triangleadj] = ACTIONS(3425),
    [anon_sym_lineadj] = ACTIONS(3425),
    [anon_sym_triangle] = ACTIONS(3425),
    [anon_sym_interface] = ACTIONS(3425),
    [anon_sym_extension] = ACTIONS(3425),
    [anon_sym___exported] = ACTIONS(3425),
    [anon_sym_import] = ACTIONS(3425),
  },
  [1035] = {
    [ts_builtin_sym_end] = ACTIONS(3523),
    [sym_identifier] = ACTIONS(3521),
    [aux_sym_preproc_include_token1] = ACTIONS(3521),
    [aux_sym_preproc_def_token1] = ACTIONS(3521),
    [aux_sym_preproc_if_token1] = ACTIONS(3521),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3521),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3521),
    [sym_preproc_directive] = ACTIONS(3521),
    [anon_sym_LPAREN2] = ACTIONS(3523),
    [anon_sym_BANG] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3521),
    [anon_sym_PLUS] = ACTIONS(3521),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3521),
    [anon_sym___extension__] = ACTIONS(3521),
    [anon_sym_typedef] = ACTIONS(3521),
    [anon_sym_in] = ACTIONS(3521),
    [anon_sym_out] = ACTIONS(3521),
    [anon_sym_inout] = ACTIONS(3521),
    [anon_sym_extern] = ACTIONS(3521),
    [anon_sym___attribute__] = ACTIONS(3521),
    [anon_sym_COLON_COLON] = ACTIONS(3523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3523),
    [anon_sym___declspec] = ACTIONS(3521),
    [anon_sym___based] = ACTIONS(3521),
    [anon_sym___cdecl] = ACTIONS(3521),
    [anon_sym___clrcall] = ACTIONS(3521),
    [anon_sym___stdcall] = ACTIONS(3521),
    [anon_sym___fastcall] = ACTIONS(3521),
    [anon_sym___thiscall] = ACTIONS(3521),
    [anon_sym___vectorcall] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_signed] = ACTIONS(3521),
    [anon_sym_unsigned] = ACTIONS(3521),
    [anon_sym_long] = ACTIONS(3521),
    [anon_sym_short] = ACTIONS(3521),
    [anon_sym_LBRACK] = ACTIONS(3521),
    [anon_sym_static] = ACTIONS(3521),
    [anon_sym_register] = ACTIONS(3521),
    [anon_sym_inline] = ACTIONS(3521),
    [anon_sym___inline] = ACTIONS(3521),
    [anon_sym___inline__] = ACTIONS(3521),
    [anon_sym___forceinline] = ACTIONS(3521),
    [anon_sym_thread_local] = ACTIONS(3521),
    [anon_sym___thread] = ACTIONS(3521),
    [anon_sym_const] = ACTIONS(3521),
    [anon_sym_constexpr] = ACTIONS(3521),
    [anon_sym_volatile] = ACTIONS(3521),
    [anon_sym_restrict] = ACTIONS(3521),
    [anon_sym___restrict__] = ACTIONS(3521),
    [anon_sym__Atomic] = ACTIONS(3521),
    [anon_sym__Noreturn] = ACTIONS(3521),
    [anon_sym_noreturn] = ACTIONS(3521),
    [anon_sym_mutable] = ACTIONS(3521),
    [anon_sym_constinit] = ACTIONS(3521),
    [anon_sym_consteval] = ACTIONS(3521),
    [anon_sym_alignas] = ACTIONS(3521),
    [anon_sym__Alignas] = ACTIONS(3521),
    [sym_primitive_type] = ACTIONS(3521),
    [anon_sym_enum] = ACTIONS(3521),
    [anon_sym_class] = ACTIONS(3521),
    [anon_sym_struct] = ACTIONS(3521),
    [anon_sym_union] = ACTIONS(3521),
    [anon_sym_if] = ACTIONS(3521),
    [anon_sym_switch] = ACTIONS(3521),
    [anon_sym_case] = ACTIONS(3521),
    [anon_sym_default] = ACTIONS(3521),
    [anon_sym_while] = ACTIONS(3521),
    [anon_sym_do] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3521),
    [anon_sym_return] = ACTIONS(3521),
    [anon_sym_break] = ACTIONS(3521),
    [anon_sym_continue] = ACTIONS(3521),
    [anon_sym_goto] = ACTIONS(3521),
    [anon_sym_not] = ACTIONS(3521),
    [anon_sym_compl] = ACTIONS(3521),
    [anon_sym_DASH_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_PLUS] = ACTIONS(3523),
    [anon_sym_sizeof] = ACTIONS(3521),
    [anon_sym___alignof__] = ACTIONS(3521),
    [anon_sym___alignof] = ACTIONS(3521),
    [anon_sym__alignof] = ACTIONS(3521),
    [anon_sym_alignof] = ACTIONS(3521),
    [anon_sym__Alignof] = ACTIONS(3521),
    [anon_sym_offsetof] = ACTIONS(3521),
    [anon_sym__Generic] = ACTIONS(3521),
    [anon_sym_asm] = ACTIONS(3521),
    [anon_sym___asm__] = ACTIONS(3521),
    [sym_number_literal] = ACTIONS(3523),
    [anon_sym_L_SQUOTE] = ACTIONS(3523),
    [anon_sym_u_SQUOTE] = ACTIONS(3523),
    [anon_sym_U_SQUOTE] = ACTIONS(3523),
    [anon_sym_u8_SQUOTE] = ACTIONS(3523),
    [anon_sym_SQUOTE] = ACTIONS(3523),
    [anon_sym_L_DQUOTE] = ACTIONS(3523),
    [anon_sym_u_DQUOTE] = ACTIONS(3523),
    [anon_sym_U_DQUOTE] = ACTIONS(3523),
    [anon_sym_u8_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [sym_true] = ACTIONS(3521),
    [sym_false] = ACTIONS(3521),
    [anon_sym_NULL] = ACTIONS(3521),
    [anon_sym_nullptr] = ACTIONS(3521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3521),
    [anon_sym_let] = ACTIONS(3521),
    [anon_sym_This] = ACTIONS(3521),
    [anon_sym_decltype] = ACTIONS(3521),
    [sym_virtual] = ACTIONS(3521),
    [anon_sym_explicit] = ACTIONS(3521),
    [anon_sym_typename] = ACTIONS(3521),
    [anon_sym_template] = ACTIONS(3521),
    [anon_sym_operator] = ACTIONS(3521),
    [anon_sym_try] = ACTIONS(3521),
    [anon_sym_delete] = ACTIONS(3521),
    [anon_sym_throw] = ACTIONS(3521),
    [anon_sym_namespace] = ACTIONS(3521),
    [anon_sym_using] = ACTIONS(3521),
    [anon_sym_static_assert] = ACTIONS(3521),
    [anon_sym_concept] = ACTIONS(3521),
    [anon_sym_co_return] = ACTIONS(3521),
    [anon_sym_co_yield] = ACTIONS(3521),
    [anon_sym_R_DQUOTE] = ACTIONS(3523),
    [anon_sym_LR_DQUOTE] = ACTIONS(3523),
    [anon_sym_uR_DQUOTE] = ACTIONS(3523),
    [anon_sym_UR_DQUOTE] = ACTIONS(3523),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3523),
    [anon_sym_co_await] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3521),
    [anon_sym_requires] = ACTIONS(3521),
    [sym_this] = ACTIONS(3521),
    [anon_sym_precise] = ACTIONS(3521),
    [anon_sym_shared] = ACTIONS(3521),
    [anon_sym_groupshared] = ACTIONS(3521),
    [anon_sym_uniform] = ACTIONS(3521),
    [anon_sym_row_major] = ACTIONS(3521),
    [anon_sym_column_major] = ACTIONS(3521),
    [anon_sym_globallycoherent] = ACTIONS(3521),
    [anon_sym_centroid] = ACTIONS(3521),
    [anon_sym_noperspective] = ACTIONS(3521),
    [anon_sym_nointerpolation] = ACTIONS(3521),
    [anon_sym_sample] = ACTIONS(3521),
    [anon_sym_linear] = ACTIONS(3521),
    [anon_sym_snorm] = ACTIONS(3521),
    [anon_sym_unorm] = ACTIONS(3521),
    [anon_sym_point] = ACTIONS(3521),
    [anon_sym_line] = ACTIONS(3521),
    [anon_sym_triangleadj] = ACTIONS(3521),
    [anon_sym_lineadj] = ACTIONS(3521),
    [anon_sym_triangle] = ACTIONS(3521),
    [anon_sym_interface] = ACTIONS(3521),
    [anon_sym_extension] = ACTIONS(3521),
    [anon_sym___exported] = ACTIONS(3521),
    [anon_sym_import] = ACTIONS(3521),
  },
  [1036] = {
    [ts_builtin_sym_end] = ACTIONS(3623),
    [sym_identifier] = ACTIONS(3621),
    [aux_sym_preproc_include_token1] = ACTIONS(3621),
    [aux_sym_preproc_def_token1] = ACTIONS(3621),
    [aux_sym_preproc_if_token1] = ACTIONS(3621),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3621),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3621),
    [sym_preproc_directive] = ACTIONS(3621),
    [anon_sym_LPAREN2] = ACTIONS(3623),
    [anon_sym_BANG] = ACTIONS(3623),
    [anon_sym_TILDE] = ACTIONS(3623),
    [anon_sym_DASH] = ACTIONS(3621),
    [anon_sym_PLUS] = ACTIONS(3621),
    [anon_sym_STAR] = ACTIONS(3623),
    [anon_sym_AMP_AMP] = ACTIONS(3623),
    [anon_sym_AMP] = ACTIONS(3621),
    [anon_sym___extension__] = ACTIONS(3621),
    [anon_sym_typedef] = ACTIONS(3621),
    [anon_sym_in] = ACTIONS(3621),
    [anon_sym_out] = ACTIONS(3621),
    [anon_sym_inout] = ACTIONS(3621),
    [anon_sym_extern] = ACTIONS(3621),
    [anon_sym___attribute__] = ACTIONS(3621),
    [anon_sym_COLON_COLON] = ACTIONS(3623),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3623),
    [anon_sym___declspec] = ACTIONS(3621),
    [anon_sym___based] = ACTIONS(3621),
    [anon_sym___cdecl] = ACTIONS(3621),
    [anon_sym___clrcall] = ACTIONS(3621),
    [anon_sym___stdcall] = ACTIONS(3621),
    [anon_sym___fastcall] = ACTIONS(3621),
    [anon_sym___thiscall] = ACTIONS(3621),
    [anon_sym___vectorcall] = ACTIONS(3621),
    [anon_sym_LBRACE] = ACTIONS(3623),
    [anon_sym_signed] = ACTIONS(3621),
    [anon_sym_unsigned] = ACTIONS(3621),
    [anon_sym_long] = ACTIONS(3621),
    [anon_sym_short] = ACTIONS(3621),
    [anon_sym_LBRACK] = ACTIONS(3621),
    [anon_sym_static] = ACTIONS(3621),
    [anon_sym_register] = ACTIONS(3621),
    [anon_sym_inline] = ACTIONS(3621),
    [anon_sym___inline] = ACTIONS(3621),
    [anon_sym___inline__] = ACTIONS(3621),
    [anon_sym___forceinline] = ACTIONS(3621),
    [anon_sym_thread_local] = ACTIONS(3621),
    [anon_sym___thread] = ACTIONS(3621),
    [anon_sym_const] = ACTIONS(3621),
    [anon_sym_constexpr] = ACTIONS(3621),
    [anon_sym_volatile] = ACTIONS(3621),
    [anon_sym_restrict] = ACTIONS(3621),
    [anon_sym___restrict__] = ACTIONS(3621),
    [anon_sym__Atomic] = ACTIONS(3621),
    [anon_sym__Noreturn] = ACTIONS(3621),
    [anon_sym_noreturn] = ACTIONS(3621),
    [anon_sym_mutable] = ACTIONS(3621),
    [anon_sym_constinit] = ACTIONS(3621),
    [anon_sym_consteval] = ACTIONS(3621),
    [anon_sym_alignas] = ACTIONS(3621),
    [anon_sym__Alignas] = ACTIONS(3621),
    [sym_primitive_type] = ACTIONS(3621),
    [anon_sym_enum] = ACTIONS(3621),
    [anon_sym_class] = ACTIONS(3621),
    [anon_sym_struct] = ACTIONS(3621),
    [anon_sym_union] = ACTIONS(3621),
    [anon_sym_if] = ACTIONS(3621),
    [anon_sym_switch] = ACTIONS(3621),
    [anon_sym_case] = ACTIONS(3621),
    [anon_sym_default] = ACTIONS(3621),
    [anon_sym_while] = ACTIONS(3621),
    [anon_sym_do] = ACTIONS(3621),
    [anon_sym_for] = ACTIONS(3621),
    [anon_sym_return] = ACTIONS(3621),
    [anon_sym_break] = ACTIONS(3621),
    [anon_sym_continue] = ACTIONS(3621),
    [anon_sym_goto] = ACTIONS(3621),
    [anon_sym_not] = ACTIONS(3621),
    [anon_sym_compl] = ACTIONS(3621),
    [anon_sym_DASH_DASH] = ACTIONS(3623),
    [anon_sym_PLUS_PLUS] = ACTIONS(3623),
    [anon_sym_sizeof] = ACTIONS(3621),
    [anon_sym___alignof__] = ACTIONS(3621),
    [anon_sym___alignof] = ACTIONS(3621),
    [anon_sym__alignof] = ACTIONS(3621),
    [anon_sym_alignof] = ACTIONS(3621),
    [anon_sym__Alignof] = ACTIONS(3621),
    [anon_sym_offsetof] = ACTIONS(3621),
    [anon_sym__Generic] = ACTIONS(3621),
    [anon_sym_asm] = ACTIONS(3621),
    [anon_sym___asm__] = ACTIONS(3621),
    [sym_number_literal] = ACTIONS(3623),
    [anon_sym_L_SQUOTE] = ACTIONS(3623),
    [anon_sym_u_SQUOTE] = ACTIONS(3623),
    [anon_sym_U_SQUOTE] = ACTIONS(3623),
    [anon_sym_u8_SQUOTE] = ACTIONS(3623),
    [anon_sym_SQUOTE] = ACTIONS(3623),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(3621),
    [sym_false] = ACTIONS(3621),
    [anon_sym_NULL] = ACTIONS(3621),
    [anon_sym_nullptr] = ACTIONS(3621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3621),
    [anon_sym_let] = ACTIONS(3621),
    [anon_sym_This] = ACTIONS(3621),
    [anon_sym_decltype] = ACTIONS(3621),
    [sym_virtual] = ACTIONS(3621),
    [anon_sym_explicit] = ACTIONS(3621),
    [anon_sym_typename] = ACTIONS(3621),
    [anon_sym_template] = ACTIONS(3621),
    [anon_sym_operator] = ACTIONS(3621),
    [anon_sym_try] = ACTIONS(3621),
    [anon_sym_delete] = ACTIONS(3621),
    [anon_sym_throw] = ACTIONS(3621),
    [anon_sym_namespace] = ACTIONS(3621),
    [anon_sym_using] = ACTIONS(3621),
    [anon_sym_static_assert] = ACTIONS(3621),
    [anon_sym_concept] = ACTIONS(3621),
    [anon_sym_co_return] = ACTIONS(3621),
    [anon_sym_co_yield] = ACTIONS(3621),
    [anon_sym_R_DQUOTE] = ACTIONS(3623),
    [anon_sym_LR_DQUOTE] = ACTIONS(3623),
    [anon_sym_uR_DQUOTE] = ACTIONS(3623),
    [anon_sym_UR_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3623),
    [anon_sym_co_await] = ACTIONS(3621),
    [anon_sym_new] = ACTIONS(3621),
    [anon_sym_requires] = ACTIONS(3621),
    [sym_this] = ACTIONS(3621),
    [anon_sym_precise] = ACTIONS(3621),
    [anon_sym_shared] = ACTIONS(3621),
    [anon_sym_groupshared] = ACTIONS(3621),
    [anon_sym_uniform] = ACTIONS(3621),
    [anon_sym_row_major] = ACTIONS(3621),
    [anon_sym_column_major] = ACTIONS(3621),
    [anon_sym_globallycoherent] = ACTIONS(3621),
    [anon_sym_centroid] = ACTIONS(3621),
    [anon_sym_noperspective] = ACTIONS(3621),
    [anon_sym_nointerpolation] = ACTIONS(3621),
    [anon_sym_sample] = ACTIONS(3621),
    [anon_sym_linear] = ACTIONS(3621),
    [anon_sym_snorm] = ACTIONS(3621),
    [anon_sym_unorm] = ACTIONS(3621),
    [anon_sym_point] = ACTIONS(3621),
    [anon_sym_line] = ACTIONS(3621),
    [anon_sym_triangleadj] = ACTIONS(3621),
    [anon_sym_lineadj] = ACTIONS(3621),
    [anon_sym_triangle] = ACTIONS(3621),
    [anon_sym_interface] = ACTIONS(3621),
    [anon_sym_extension] = ACTIONS(3621),
    [anon_sym___exported] = ACTIONS(3621),
    [anon_sym_import] = ACTIONS(3621),
  },
  [1037] = {
    [ts_builtin_sym_end] = ACTIONS(3527),
    [sym_identifier] = ACTIONS(3525),
    [aux_sym_preproc_include_token1] = ACTIONS(3525),
    [aux_sym_preproc_def_token1] = ACTIONS(3525),
    [aux_sym_preproc_if_token1] = ACTIONS(3525),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3525),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3525),
    [sym_preproc_directive] = ACTIONS(3525),
    [anon_sym_LPAREN2] = ACTIONS(3527),
    [anon_sym_BANG] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3525),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_AMP] = ACTIONS(3525),
    [anon_sym___extension__] = ACTIONS(3525),
    [anon_sym_typedef] = ACTIONS(3525),
    [anon_sym_in] = ACTIONS(3525),
    [anon_sym_out] = ACTIONS(3525),
    [anon_sym_inout] = ACTIONS(3525),
    [anon_sym_extern] = ACTIONS(3525),
    [anon_sym___attribute__] = ACTIONS(3525),
    [anon_sym_COLON_COLON] = ACTIONS(3527),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3527),
    [anon_sym___declspec] = ACTIONS(3525),
    [anon_sym___based] = ACTIONS(3525),
    [anon_sym___cdecl] = ACTIONS(3525),
    [anon_sym___clrcall] = ACTIONS(3525),
    [anon_sym___stdcall] = ACTIONS(3525),
    [anon_sym___fastcall] = ACTIONS(3525),
    [anon_sym___thiscall] = ACTIONS(3525),
    [anon_sym___vectorcall] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_signed] = ACTIONS(3525),
    [anon_sym_unsigned] = ACTIONS(3525),
    [anon_sym_long] = ACTIONS(3525),
    [anon_sym_short] = ACTIONS(3525),
    [anon_sym_LBRACK] = ACTIONS(3525),
    [anon_sym_static] = ACTIONS(3525),
    [anon_sym_register] = ACTIONS(3525),
    [anon_sym_inline] = ACTIONS(3525),
    [anon_sym___inline] = ACTIONS(3525),
    [anon_sym___inline__] = ACTIONS(3525),
    [anon_sym___forceinline] = ACTIONS(3525),
    [anon_sym_thread_local] = ACTIONS(3525),
    [anon_sym___thread] = ACTIONS(3525),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_constexpr] = ACTIONS(3525),
    [anon_sym_volatile] = ACTIONS(3525),
    [anon_sym_restrict] = ACTIONS(3525),
    [anon_sym___restrict__] = ACTIONS(3525),
    [anon_sym__Atomic] = ACTIONS(3525),
    [anon_sym__Noreturn] = ACTIONS(3525),
    [anon_sym_noreturn] = ACTIONS(3525),
    [anon_sym_mutable] = ACTIONS(3525),
    [anon_sym_constinit] = ACTIONS(3525),
    [anon_sym_consteval] = ACTIONS(3525),
    [anon_sym_alignas] = ACTIONS(3525),
    [anon_sym__Alignas] = ACTIONS(3525),
    [sym_primitive_type] = ACTIONS(3525),
    [anon_sym_enum] = ACTIONS(3525),
    [anon_sym_class] = ACTIONS(3525),
    [anon_sym_struct] = ACTIONS(3525),
    [anon_sym_union] = ACTIONS(3525),
    [anon_sym_if] = ACTIONS(3525),
    [anon_sym_switch] = ACTIONS(3525),
    [anon_sym_case] = ACTIONS(3525),
    [anon_sym_default] = ACTIONS(3525),
    [anon_sym_while] = ACTIONS(3525),
    [anon_sym_do] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3525),
    [anon_sym_return] = ACTIONS(3525),
    [anon_sym_break] = ACTIONS(3525),
    [anon_sym_continue] = ACTIONS(3525),
    [anon_sym_goto] = ACTIONS(3525),
    [anon_sym_not] = ACTIONS(3525),
    [anon_sym_compl] = ACTIONS(3525),
    [anon_sym_DASH_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_PLUS] = ACTIONS(3527),
    [anon_sym_sizeof] = ACTIONS(3525),
    [anon_sym___alignof__] = ACTIONS(3525),
    [anon_sym___alignof] = ACTIONS(3525),
    [anon_sym__alignof] = ACTIONS(3525),
    [anon_sym_alignof] = ACTIONS(3525),
    [anon_sym__Alignof] = ACTIONS(3525),
    [anon_sym_offsetof] = ACTIONS(3525),
    [anon_sym__Generic] = ACTIONS(3525),
    [anon_sym_asm] = ACTIONS(3525),
    [anon_sym___asm__] = ACTIONS(3525),
    [sym_number_literal] = ACTIONS(3527),
    [anon_sym_L_SQUOTE] = ACTIONS(3527),
    [anon_sym_u_SQUOTE] = ACTIONS(3527),
    [anon_sym_U_SQUOTE] = ACTIONS(3527),
    [anon_sym_u8_SQUOTE] = ACTIONS(3527),
    [anon_sym_SQUOTE] = ACTIONS(3527),
    [anon_sym_L_DQUOTE] = ACTIONS(3527),
    [anon_sym_u_DQUOTE] = ACTIONS(3527),
    [anon_sym_U_DQUOTE] = ACTIONS(3527),
    [anon_sym_u8_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [sym_true] = ACTIONS(3525),
    [sym_false] = ACTIONS(3525),
    [anon_sym_NULL] = ACTIONS(3525),
    [anon_sym_nullptr] = ACTIONS(3525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3525),
    [anon_sym_let] = ACTIONS(3525),
    [anon_sym_This] = ACTIONS(3525),
    [anon_sym_decltype] = ACTIONS(3525),
    [sym_virtual] = ACTIONS(3525),
    [anon_sym_explicit] = ACTIONS(3525),
    [anon_sym_typename] = ACTIONS(3525),
    [anon_sym_template] = ACTIONS(3525),
    [anon_sym_operator] = ACTIONS(3525),
    [anon_sym_try] = ACTIONS(3525),
    [anon_sym_delete] = ACTIONS(3525),
    [anon_sym_throw] = ACTIONS(3525),
    [anon_sym_namespace] = ACTIONS(3525),
    [anon_sym_using] = ACTIONS(3525),
    [anon_sym_static_assert] = ACTIONS(3525),
    [anon_sym_concept] = ACTIONS(3525),
    [anon_sym_co_return] = ACTIONS(3525),
    [anon_sym_co_yield] = ACTIONS(3525),
    [anon_sym_R_DQUOTE] = ACTIONS(3527),
    [anon_sym_LR_DQUOTE] = ACTIONS(3527),
    [anon_sym_uR_DQUOTE] = ACTIONS(3527),
    [anon_sym_UR_DQUOTE] = ACTIONS(3527),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3527),
    [anon_sym_co_await] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3525),
    [anon_sym_requires] = ACTIONS(3525),
    [sym_this] = ACTIONS(3525),
    [anon_sym_precise] = ACTIONS(3525),
    [anon_sym_shared] = ACTIONS(3525),
    [anon_sym_groupshared] = ACTIONS(3525),
    [anon_sym_uniform] = ACTIONS(3525),
    [anon_sym_row_major] = ACTIONS(3525),
    [anon_sym_column_major] = ACTIONS(3525),
    [anon_sym_globallycoherent] = ACTIONS(3525),
    [anon_sym_centroid] = ACTIONS(3525),
    [anon_sym_noperspective] = ACTIONS(3525),
    [anon_sym_nointerpolation] = ACTIONS(3525),
    [anon_sym_sample] = ACTIONS(3525),
    [anon_sym_linear] = ACTIONS(3525),
    [anon_sym_snorm] = ACTIONS(3525),
    [anon_sym_unorm] = ACTIONS(3525),
    [anon_sym_point] = ACTIONS(3525),
    [anon_sym_line] = ACTIONS(3525),
    [anon_sym_triangleadj] = ACTIONS(3525),
    [anon_sym_lineadj] = ACTIONS(3525),
    [anon_sym_triangle] = ACTIONS(3525),
    [anon_sym_interface] = ACTIONS(3525),
    [anon_sym_extension] = ACTIONS(3525),
    [anon_sym___exported] = ACTIONS(3525),
    [anon_sym_import] = ACTIONS(3525),
  },
  [1038] = {
    [ts_builtin_sym_end] = ACTIONS(3647),
    [sym_identifier] = ACTIONS(3645),
    [aux_sym_preproc_include_token1] = ACTIONS(3645),
    [aux_sym_preproc_def_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token1] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3645),
    [sym_preproc_directive] = ACTIONS(3645),
    [anon_sym_LPAREN2] = ACTIONS(3647),
    [anon_sym_BANG] = ACTIONS(3647),
    [anon_sym_TILDE] = ACTIONS(3647),
    [anon_sym_DASH] = ACTIONS(3645),
    [anon_sym_PLUS] = ACTIONS(3645),
    [anon_sym_STAR] = ACTIONS(3647),
    [anon_sym_AMP_AMP] = ACTIONS(3647),
    [anon_sym_AMP] = ACTIONS(3645),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3645),
    [anon_sym_in] = ACTIONS(3645),
    [anon_sym_out] = ACTIONS(3645),
    [anon_sym_inout] = ACTIONS(3645),
    [anon_sym_extern] = ACTIONS(3645),
    [anon_sym___attribute__] = ACTIONS(3645),
    [anon_sym_COLON_COLON] = ACTIONS(3647),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3647),
    [anon_sym___declspec] = ACTIONS(3645),
    [anon_sym___based] = ACTIONS(3645),
    [anon_sym___cdecl] = ACTIONS(3645),
    [anon_sym___clrcall] = ACTIONS(3645),
    [anon_sym___stdcall] = ACTIONS(3645),
    [anon_sym___fastcall] = ACTIONS(3645),
    [anon_sym___thiscall] = ACTIONS(3645),
    [anon_sym___vectorcall] = ACTIONS(3645),
    [anon_sym_LBRACE] = ACTIONS(3647),
    [anon_sym_signed] = ACTIONS(3645),
    [anon_sym_unsigned] = ACTIONS(3645),
    [anon_sym_long] = ACTIONS(3645),
    [anon_sym_short] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_static] = ACTIONS(3645),
    [anon_sym_register] = ACTIONS(3645),
    [anon_sym_inline] = ACTIONS(3645),
    [anon_sym___inline] = ACTIONS(3645),
    [anon_sym___inline__] = ACTIONS(3645),
    [anon_sym___forceinline] = ACTIONS(3645),
    [anon_sym_thread_local] = ACTIONS(3645),
    [anon_sym___thread] = ACTIONS(3645),
    [anon_sym_const] = ACTIONS(3645),
    [anon_sym_constexpr] = ACTIONS(3645),
    [anon_sym_volatile] = ACTIONS(3645),
    [anon_sym_restrict] = ACTIONS(3645),
    [anon_sym___restrict__] = ACTIONS(3645),
    [anon_sym__Atomic] = ACTIONS(3645),
    [anon_sym__Noreturn] = ACTIONS(3645),
    [anon_sym_noreturn] = ACTIONS(3645),
    [anon_sym_mutable] = ACTIONS(3645),
    [anon_sym_constinit] = ACTIONS(3645),
    [anon_sym_consteval] = ACTIONS(3645),
    [anon_sym_alignas] = ACTIONS(3645),
    [anon_sym__Alignas] = ACTIONS(3645),
    [sym_primitive_type] = ACTIONS(3645),
    [anon_sym_enum] = ACTIONS(3645),
    [anon_sym_class] = ACTIONS(3645),
    [anon_sym_struct] = ACTIONS(3645),
    [anon_sym_union] = ACTIONS(3645),
    [anon_sym_if] = ACTIONS(3645),
    [anon_sym_switch] = ACTIONS(3645),
    [anon_sym_case] = ACTIONS(3645),
    [anon_sym_default] = ACTIONS(3645),
    [anon_sym_while] = ACTIONS(3645),
    [anon_sym_do] = ACTIONS(3645),
    [anon_sym_for] = ACTIONS(3645),
    [anon_sym_return] = ACTIONS(3645),
    [anon_sym_break] = ACTIONS(3645),
    [anon_sym_continue] = ACTIONS(3645),
    [anon_sym_goto] = ACTIONS(3645),
    [anon_sym_not] = ACTIONS(3645),
    [anon_sym_compl] = ACTIONS(3645),
    [anon_sym_DASH_DASH] = ACTIONS(3647),
    [anon_sym_PLUS_PLUS] = ACTIONS(3647),
    [anon_sym_sizeof] = ACTIONS(3645),
    [anon_sym___alignof__] = ACTIONS(3645),
    [anon_sym___alignof] = ACTIONS(3645),
    [anon_sym__alignof] = ACTIONS(3645),
    [anon_sym_alignof] = ACTIONS(3645),
    [anon_sym__Alignof] = ACTIONS(3645),
    [anon_sym_offsetof] = ACTIONS(3645),
    [anon_sym__Generic] = ACTIONS(3645),
    [anon_sym_asm] = ACTIONS(3645),
    [anon_sym___asm__] = ACTIONS(3645),
    [sym_number_literal] = ACTIONS(3647),
    [anon_sym_L_SQUOTE] = ACTIONS(3647),
    [anon_sym_u_SQUOTE] = ACTIONS(3647),
    [anon_sym_U_SQUOTE] = ACTIONS(3647),
    [anon_sym_u8_SQUOTE] = ACTIONS(3647),
    [anon_sym_SQUOTE] = ACTIONS(3647),
    [anon_sym_L_DQUOTE] = ACTIONS(3647),
    [anon_sym_u_DQUOTE] = ACTIONS(3647),
    [anon_sym_U_DQUOTE] = ACTIONS(3647),
    [anon_sym_u8_DQUOTE] = ACTIONS(3647),
    [anon_sym_DQUOTE] = ACTIONS(3647),
    [sym_true] = ACTIONS(3645),
    [sym_false] = ACTIONS(3645),
    [anon_sym_NULL] = ACTIONS(3645),
    [anon_sym_nullptr] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3645),
    [anon_sym_let] = ACTIONS(3645),
    [anon_sym_This] = ACTIONS(3645),
    [anon_sym_decltype] = ACTIONS(3645),
    [sym_virtual] = ACTIONS(3645),
    [anon_sym_explicit] = ACTIONS(3645),
    [anon_sym_typename] = ACTIONS(3645),
    [anon_sym_template] = ACTIONS(3645),
    [anon_sym_operator] = ACTIONS(3645),
    [anon_sym_try] = ACTIONS(3645),
    [anon_sym_delete] = ACTIONS(3645),
    [anon_sym_throw] = ACTIONS(3645),
    [anon_sym_namespace] = ACTIONS(3645),
    [anon_sym_using] = ACTIONS(3645),
    [anon_sym_static_assert] = ACTIONS(3645),
    [anon_sym_concept] = ACTIONS(3645),
    [anon_sym_co_return] = ACTIONS(3645),
    [anon_sym_co_yield] = ACTIONS(3645),
    [anon_sym_R_DQUOTE] = ACTIONS(3647),
    [anon_sym_LR_DQUOTE] = ACTIONS(3647),
    [anon_sym_uR_DQUOTE] = ACTIONS(3647),
    [anon_sym_UR_DQUOTE] = ACTIONS(3647),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3647),
    [anon_sym_co_await] = ACTIONS(3645),
    [anon_sym_new] = ACTIONS(3645),
    [anon_sym_requires] = ACTIONS(3645),
    [sym_this] = ACTIONS(3645),
    [anon_sym_precise] = ACTIONS(3645),
    [anon_sym_shared] = ACTIONS(3645),
    [anon_sym_groupshared] = ACTIONS(3645),
    [anon_sym_uniform] = ACTIONS(3645),
    [anon_sym_row_major] = ACTIONS(3645),
    [anon_sym_column_major] = ACTIONS(3645),
    [anon_sym_globallycoherent] = ACTIONS(3645),
    [anon_sym_centroid] = ACTIONS(3645),
    [anon_sym_noperspective] = ACTIONS(3645),
    [anon_sym_nointerpolation] = ACTIONS(3645),
    [anon_sym_sample] = ACTIONS(3645),
    [anon_sym_linear] = ACTIONS(3645),
    [anon_sym_snorm] = ACTIONS(3645),
    [anon_sym_unorm] = ACTIONS(3645),
    [anon_sym_point] = ACTIONS(3645),
    [anon_sym_line] = ACTIONS(3645),
    [anon_sym_triangleadj] = ACTIONS(3645),
    [anon_sym_lineadj] = ACTIONS(3645),
    [anon_sym_triangle] = ACTIONS(3645),
    [anon_sym_interface] = ACTIONS(3645),
    [anon_sym_extension] = ACTIONS(3645),
    [anon_sym___exported] = ACTIONS(3645),
    [anon_sym_import] = ACTIONS(3645),
  },
  [1039] = {
    [ts_builtin_sym_end] = ACTIONS(3647),
    [sym_identifier] = ACTIONS(3645),
    [aux_sym_preproc_include_token1] = ACTIONS(3645),
    [aux_sym_preproc_def_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token1] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3645),
    [sym_preproc_directive] = ACTIONS(3645),
    [anon_sym_LPAREN2] = ACTIONS(3647),
    [anon_sym_BANG] = ACTIONS(3647),
    [anon_sym_TILDE] = ACTIONS(3647),
    [anon_sym_DASH] = ACTIONS(3645),
    [anon_sym_PLUS] = ACTIONS(3645),
    [anon_sym_STAR] = ACTIONS(3647),
    [anon_sym_AMP_AMP] = ACTIONS(3647),
    [anon_sym_AMP] = ACTIONS(3645),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3645),
    [anon_sym_in] = ACTIONS(3645),
    [anon_sym_out] = ACTIONS(3645),
    [anon_sym_inout] = ACTIONS(3645),
    [anon_sym_extern] = ACTIONS(3645),
    [anon_sym___attribute__] = ACTIONS(3645),
    [anon_sym_COLON_COLON] = ACTIONS(3647),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3647),
    [anon_sym___declspec] = ACTIONS(3645),
    [anon_sym___based] = ACTIONS(3645),
    [anon_sym___cdecl] = ACTIONS(3645),
    [anon_sym___clrcall] = ACTIONS(3645),
    [anon_sym___stdcall] = ACTIONS(3645),
    [anon_sym___fastcall] = ACTIONS(3645),
    [anon_sym___thiscall] = ACTIONS(3645),
    [anon_sym___vectorcall] = ACTIONS(3645),
    [anon_sym_LBRACE] = ACTIONS(3647),
    [anon_sym_signed] = ACTIONS(3645),
    [anon_sym_unsigned] = ACTIONS(3645),
    [anon_sym_long] = ACTIONS(3645),
    [anon_sym_short] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_static] = ACTIONS(3645),
    [anon_sym_register] = ACTIONS(3645),
    [anon_sym_inline] = ACTIONS(3645),
    [anon_sym___inline] = ACTIONS(3645),
    [anon_sym___inline__] = ACTIONS(3645),
    [anon_sym___forceinline] = ACTIONS(3645),
    [anon_sym_thread_local] = ACTIONS(3645),
    [anon_sym___thread] = ACTIONS(3645),
    [anon_sym_const] = ACTIONS(3645),
    [anon_sym_constexpr] = ACTIONS(3645),
    [anon_sym_volatile] = ACTIONS(3645),
    [anon_sym_restrict] = ACTIONS(3645),
    [anon_sym___restrict__] = ACTIONS(3645),
    [anon_sym__Atomic] = ACTIONS(3645),
    [anon_sym__Noreturn] = ACTIONS(3645),
    [anon_sym_noreturn] = ACTIONS(3645),
    [anon_sym_mutable] = ACTIONS(3645),
    [anon_sym_constinit] = ACTIONS(3645),
    [anon_sym_consteval] = ACTIONS(3645),
    [anon_sym_alignas] = ACTIONS(3645),
    [anon_sym__Alignas] = ACTIONS(3645),
    [sym_primitive_type] = ACTIONS(3645),
    [anon_sym_enum] = ACTIONS(3645),
    [anon_sym_class] = ACTIONS(3645),
    [anon_sym_struct] = ACTIONS(3645),
    [anon_sym_union] = ACTIONS(3645),
    [anon_sym_if] = ACTIONS(3645),
    [anon_sym_switch] = ACTIONS(3645),
    [anon_sym_case] = ACTIONS(3645),
    [anon_sym_default] = ACTIONS(3645),
    [anon_sym_while] = ACTIONS(3645),
    [anon_sym_do] = ACTIONS(3645),
    [anon_sym_for] = ACTIONS(3645),
    [anon_sym_return] = ACTIONS(3645),
    [anon_sym_break] = ACTIONS(3645),
    [anon_sym_continue] = ACTIONS(3645),
    [anon_sym_goto] = ACTIONS(3645),
    [anon_sym_not] = ACTIONS(3645),
    [anon_sym_compl] = ACTIONS(3645),
    [anon_sym_DASH_DASH] = ACTIONS(3647),
    [anon_sym_PLUS_PLUS] = ACTIONS(3647),
    [anon_sym_sizeof] = ACTIONS(3645),
    [anon_sym___alignof__] = ACTIONS(3645),
    [anon_sym___alignof] = ACTIONS(3645),
    [anon_sym__alignof] = ACTIONS(3645),
    [anon_sym_alignof] = ACTIONS(3645),
    [anon_sym__Alignof] = ACTIONS(3645),
    [anon_sym_offsetof] = ACTIONS(3645),
    [anon_sym__Generic] = ACTIONS(3645),
    [anon_sym_asm] = ACTIONS(3645),
    [anon_sym___asm__] = ACTIONS(3645),
    [sym_number_literal] = ACTIONS(3647),
    [anon_sym_L_SQUOTE] = ACTIONS(3647),
    [anon_sym_u_SQUOTE] = ACTIONS(3647),
    [anon_sym_U_SQUOTE] = ACTIONS(3647),
    [anon_sym_u8_SQUOTE] = ACTIONS(3647),
    [anon_sym_SQUOTE] = ACTIONS(3647),
    [anon_sym_L_DQUOTE] = ACTIONS(3647),
    [anon_sym_u_DQUOTE] = ACTIONS(3647),
    [anon_sym_U_DQUOTE] = ACTIONS(3647),
    [anon_sym_u8_DQUOTE] = ACTIONS(3647),
    [anon_sym_DQUOTE] = ACTIONS(3647),
    [sym_true] = ACTIONS(3645),
    [sym_false] = ACTIONS(3645),
    [anon_sym_NULL] = ACTIONS(3645),
    [anon_sym_nullptr] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3645),
    [anon_sym_let] = ACTIONS(3645),
    [anon_sym_This] = ACTIONS(3645),
    [anon_sym_decltype] = ACTIONS(3645),
    [sym_virtual] = ACTIONS(3645),
    [anon_sym_explicit] = ACTIONS(3645),
    [anon_sym_typename] = ACTIONS(3645),
    [anon_sym_template] = ACTIONS(3645),
    [anon_sym_operator] = ACTIONS(3645),
    [anon_sym_try] = ACTIONS(3645),
    [anon_sym_delete] = ACTIONS(3645),
    [anon_sym_throw] = ACTIONS(3645),
    [anon_sym_namespace] = ACTIONS(3645),
    [anon_sym_using] = ACTIONS(3645),
    [anon_sym_static_assert] = ACTIONS(3645),
    [anon_sym_concept] = ACTIONS(3645),
    [anon_sym_co_return] = ACTIONS(3645),
    [anon_sym_co_yield] = ACTIONS(3645),
    [anon_sym_R_DQUOTE] = ACTIONS(3647),
    [anon_sym_LR_DQUOTE] = ACTIONS(3647),
    [anon_sym_uR_DQUOTE] = ACTIONS(3647),
    [anon_sym_UR_DQUOTE] = ACTIONS(3647),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3647),
    [anon_sym_co_await] = ACTIONS(3645),
    [anon_sym_new] = ACTIONS(3645),
    [anon_sym_requires] = ACTIONS(3645),
    [sym_this] = ACTIONS(3645),
    [anon_sym_precise] = ACTIONS(3645),
    [anon_sym_shared] = ACTIONS(3645),
    [anon_sym_groupshared] = ACTIONS(3645),
    [anon_sym_uniform] = ACTIONS(3645),
    [anon_sym_row_major] = ACTIONS(3645),
    [anon_sym_column_major] = ACTIONS(3645),
    [anon_sym_globallycoherent] = ACTIONS(3645),
    [anon_sym_centroid] = ACTIONS(3645),
    [anon_sym_noperspective] = ACTIONS(3645),
    [anon_sym_nointerpolation] = ACTIONS(3645),
    [anon_sym_sample] = ACTIONS(3645),
    [anon_sym_linear] = ACTIONS(3645),
    [anon_sym_snorm] = ACTIONS(3645),
    [anon_sym_unorm] = ACTIONS(3645),
    [anon_sym_point] = ACTIONS(3645),
    [anon_sym_line] = ACTIONS(3645),
    [anon_sym_triangleadj] = ACTIONS(3645),
    [anon_sym_lineadj] = ACTIONS(3645),
    [anon_sym_triangle] = ACTIONS(3645),
    [anon_sym_interface] = ACTIONS(3645),
    [anon_sym_extension] = ACTIONS(3645),
    [anon_sym___exported] = ACTIONS(3645),
    [anon_sym_import] = ACTIONS(3645),
  },
  [1040] = {
    [ts_builtin_sym_end] = ACTIONS(3499),
    [sym_identifier] = ACTIONS(3497),
    [aux_sym_preproc_include_token1] = ACTIONS(3497),
    [aux_sym_preproc_def_token1] = ACTIONS(3497),
    [aux_sym_preproc_if_token1] = ACTIONS(3497),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3497),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3497),
    [sym_preproc_directive] = ACTIONS(3497),
    [anon_sym_LPAREN2] = ACTIONS(3499),
    [anon_sym_BANG] = ACTIONS(3499),
    [anon_sym_TILDE] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_STAR] = ACTIONS(3499),
    [anon_sym_AMP_AMP] = ACTIONS(3499),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym___extension__] = ACTIONS(3497),
    [anon_sym_typedef] = ACTIONS(3497),
    [anon_sym_in] = ACTIONS(3497),
    [anon_sym_out] = ACTIONS(3497),
    [anon_sym_inout] = ACTIONS(3497),
    [anon_sym_extern] = ACTIONS(3497),
    [anon_sym___attribute__] = ACTIONS(3497),
    [anon_sym_COLON_COLON] = ACTIONS(3499),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3499),
    [anon_sym___declspec] = ACTIONS(3497),
    [anon_sym___based] = ACTIONS(3497),
    [anon_sym___cdecl] = ACTIONS(3497),
    [anon_sym___clrcall] = ACTIONS(3497),
    [anon_sym___stdcall] = ACTIONS(3497),
    [anon_sym___fastcall] = ACTIONS(3497),
    [anon_sym___thiscall] = ACTIONS(3497),
    [anon_sym___vectorcall] = ACTIONS(3497),
    [anon_sym_LBRACE] = ACTIONS(3499),
    [anon_sym_signed] = ACTIONS(3497),
    [anon_sym_unsigned] = ACTIONS(3497),
    [anon_sym_long] = ACTIONS(3497),
    [anon_sym_short] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3497),
    [anon_sym_static] = ACTIONS(3497),
    [anon_sym_register] = ACTIONS(3497),
    [anon_sym_inline] = ACTIONS(3497),
    [anon_sym___inline] = ACTIONS(3497),
    [anon_sym___inline__] = ACTIONS(3497),
    [anon_sym___forceinline] = ACTIONS(3497),
    [anon_sym_thread_local] = ACTIONS(3497),
    [anon_sym___thread] = ACTIONS(3497),
    [anon_sym_const] = ACTIONS(3497),
    [anon_sym_constexpr] = ACTIONS(3497),
    [anon_sym_volatile] = ACTIONS(3497),
    [anon_sym_restrict] = ACTIONS(3497),
    [anon_sym___restrict__] = ACTIONS(3497),
    [anon_sym__Atomic] = ACTIONS(3497),
    [anon_sym__Noreturn] = ACTIONS(3497),
    [anon_sym_noreturn] = ACTIONS(3497),
    [anon_sym_mutable] = ACTIONS(3497),
    [anon_sym_constinit] = ACTIONS(3497),
    [anon_sym_consteval] = ACTIONS(3497),
    [anon_sym_alignas] = ACTIONS(3497),
    [anon_sym__Alignas] = ACTIONS(3497),
    [sym_primitive_type] = ACTIONS(3497),
    [anon_sym_enum] = ACTIONS(3497),
    [anon_sym_class] = ACTIONS(3497),
    [anon_sym_struct] = ACTIONS(3497),
    [anon_sym_union] = ACTIONS(3497),
    [anon_sym_if] = ACTIONS(3497),
    [anon_sym_switch] = ACTIONS(3497),
    [anon_sym_case] = ACTIONS(3497),
    [anon_sym_default] = ACTIONS(3497),
    [anon_sym_while] = ACTIONS(3497),
    [anon_sym_do] = ACTIONS(3497),
    [anon_sym_for] = ACTIONS(3497),
    [anon_sym_return] = ACTIONS(3497),
    [anon_sym_break] = ACTIONS(3497),
    [anon_sym_continue] = ACTIONS(3497),
    [anon_sym_goto] = ACTIONS(3497),
    [anon_sym_not] = ACTIONS(3497),
    [anon_sym_compl] = ACTIONS(3497),
    [anon_sym_DASH_DASH] = ACTIONS(3499),
    [anon_sym_PLUS_PLUS] = ACTIONS(3499),
    [anon_sym_sizeof] = ACTIONS(3497),
    [anon_sym___alignof__] = ACTIONS(3497),
    [anon_sym___alignof] = ACTIONS(3497),
    [anon_sym__alignof] = ACTIONS(3497),
    [anon_sym_alignof] = ACTIONS(3497),
    [anon_sym__Alignof] = ACTIONS(3497),
    [anon_sym_offsetof] = ACTIONS(3497),
    [anon_sym__Generic] = ACTIONS(3497),
    [anon_sym_asm] = ACTIONS(3497),
    [anon_sym___asm__] = ACTIONS(3497),
    [sym_number_literal] = ACTIONS(3499),
    [anon_sym_L_SQUOTE] = ACTIONS(3499),
    [anon_sym_u_SQUOTE] = ACTIONS(3499),
    [anon_sym_U_SQUOTE] = ACTIONS(3499),
    [anon_sym_u8_SQUOTE] = ACTIONS(3499),
    [anon_sym_SQUOTE] = ACTIONS(3499),
    [anon_sym_L_DQUOTE] = ACTIONS(3499),
    [anon_sym_u_DQUOTE] = ACTIONS(3499),
    [anon_sym_U_DQUOTE] = ACTIONS(3499),
    [anon_sym_u8_DQUOTE] = ACTIONS(3499),
    [anon_sym_DQUOTE] = ACTIONS(3499),
    [sym_true] = ACTIONS(3497),
    [sym_false] = ACTIONS(3497),
    [anon_sym_NULL] = ACTIONS(3497),
    [anon_sym_nullptr] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3497),
    [anon_sym_let] = ACTIONS(3497),
    [anon_sym_This] = ACTIONS(3497),
    [anon_sym_decltype] = ACTIONS(3497),
    [sym_virtual] = ACTIONS(3497),
    [anon_sym_explicit] = ACTIONS(3497),
    [anon_sym_typename] = ACTIONS(3497),
    [anon_sym_template] = ACTIONS(3497),
    [anon_sym_operator] = ACTIONS(3497),
    [anon_sym_try] = ACTIONS(3497),
    [anon_sym_delete] = ACTIONS(3497),
    [anon_sym_throw] = ACTIONS(3497),
    [anon_sym_namespace] = ACTIONS(3497),
    [anon_sym_using] = ACTIONS(3497),
    [anon_sym_static_assert] = ACTIONS(3497),
    [anon_sym_concept] = ACTIONS(3497),
    [anon_sym_co_return] = ACTIONS(3497),
    [anon_sym_co_yield] = ACTIONS(3497),
    [anon_sym_R_DQUOTE] = ACTIONS(3499),
    [anon_sym_LR_DQUOTE] = ACTIONS(3499),
    [anon_sym_uR_DQUOTE] = ACTIONS(3499),
    [anon_sym_UR_DQUOTE] = ACTIONS(3499),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3499),
    [anon_sym_co_await] = ACTIONS(3497),
    [anon_sym_new] = ACTIONS(3497),
    [anon_sym_requires] = ACTIONS(3497),
    [sym_this] = ACTIONS(3497),
    [anon_sym_precise] = ACTIONS(3497),
    [anon_sym_shared] = ACTIONS(3497),
    [anon_sym_groupshared] = ACTIONS(3497),
    [anon_sym_uniform] = ACTIONS(3497),
    [anon_sym_row_major] = ACTIONS(3497),
    [anon_sym_column_major] = ACTIONS(3497),
    [anon_sym_globallycoherent] = ACTIONS(3497),
    [anon_sym_centroid] = ACTIONS(3497),
    [anon_sym_noperspective] = ACTIONS(3497),
    [anon_sym_nointerpolation] = ACTIONS(3497),
    [anon_sym_sample] = ACTIONS(3497),
    [anon_sym_linear] = ACTIONS(3497),
    [anon_sym_snorm] = ACTIONS(3497),
    [anon_sym_unorm] = ACTIONS(3497),
    [anon_sym_point] = ACTIONS(3497),
    [anon_sym_line] = ACTIONS(3497),
    [anon_sym_triangleadj] = ACTIONS(3497),
    [anon_sym_lineadj] = ACTIONS(3497),
    [anon_sym_triangle] = ACTIONS(3497),
    [anon_sym_interface] = ACTIONS(3497),
    [anon_sym_extension] = ACTIONS(3497),
    [anon_sym___exported] = ACTIONS(3497),
    [anon_sym_import] = ACTIONS(3497),
  },
  [1041] = {
    [ts_builtin_sym_end] = ACTIONS(3465),
    [sym_identifier] = ACTIONS(3463),
    [aux_sym_preproc_include_token1] = ACTIONS(3463),
    [aux_sym_preproc_def_token1] = ACTIONS(3463),
    [aux_sym_preproc_if_token1] = ACTIONS(3463),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3463),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3463),
    [sym_preproc_directive] = ACTIONS(3463),
    [anon_sym_LPAREN2] = ACTIONS(3465),
    [anon_sym_BANG] = ACTIONS(3465),
    [anon_sym_TILDE] = ACTIONS(3465),
    [anon_sym_DASH] = ACTIONS(3463),
    [anon_sym_PLUS] = ACTIONS(3463),
    [anon_sym_STAR] = ACTIONS(3465),
    [anon_sym_AMP_AMP] = ACTIONS(3465),
    [anon_sym_AMP] = ACTIONS(3463),
    [anon_sym___extension__] = ACTIONS(3463),
    [anon_sym_typedef] = ACTIONS(3463),
    [anon_sym_in] = ACTIONS(3463),
    [anon_sym_out] = ACTIONS(3463),
    [anon_sym_inout] = ACTIONS(3463),
    [anon_sym_extern] = ACTIONS(3463),
    [anon_sym___attribute__] = ACTIONS(3463),
    [anon_sym_COLON_COLON] = ACTIONS(3465),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3465),
    [anon_sym___declspec] = ACTIONS(3463),
    [anon_sym___based] = ACTIONS(3463),
    [anon_sym___cdecl] = ACTIONS(3463),
    [anon_sym___clrcall] = ACTIONS(3463),
    [anon_sym___stdcall] = ACTIONS(3463),
    [anon_sym___fastcall] = ACTIONS(3463),
    [anon_sym___thiscall] = ACTIONS(3463),
    [anon_sym___vectorcall] = ACTIONS(3463),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_signed] = ACTIONS(3463),
    [anon_sym_unsigned] = ACTIONS(3463),
    [anon_sym_long] = ACTIONS(3463),
    [anon_sym_short] = ACTIONS(3463),
    [anon_sym_LBRACK] = ACTIONS(3463),
    [anon_sym_static] = ACTIONS(3463),
    [anon_sym_register] = ACTIONS(3463),
    [anon_sym_inline] = ACTIONS(3463),
    [anon_sym___inline] = ACTIONS(3463),
    [anon_sym___inline__] = ACTIONS(3463),
    [anon_sym___forceinline] = ACTIONS(3463),
    [anon_sym_thread_local] = ACTIONS(3463),
    [anon_sym___thread] = ACTIONS(3463),
    [anon_sym_const] = ACTIONS(3463),
    [anon_sym_constexpr] = ACTIONS(3463),
    [anon_sym_volatile] = ACTIONS(3463),
    [anon_sym_restrict] = ACTIONS(3463),
    [anon_sym___restrict__] = ACTIONS(3463),
    [anon_sym__Atomic] = ACTIONS(3463),
    [anon_sym__Noreturn] = ACTIONS(3463),
    [anon_sym_noreturn] = ACTIONS(3463),
    [anon_sym_mutable] = ACTIONS(3463),
    [anon_sym_constinit] = ACTIONS(3463),
    [anon_sym_consteval] = ACTIONS(3463),
    [anon_sym_alignas] = ACTIONS(3463),
    [anon_sym__Alignas] = ACTIONS(3463),
    [sym_primitive_type] = ACTIONS(3463),
    [anon_sym_enum] = ACTIONS(3463),
    [anon_sym_class] = ACTIONS(3463),
    [anon_sym_struct] = ACTIONS(3463),
    [anon_sym_union] = ACTIONS(3463),
    [anon_sym_if] = ACTIONS(3463),
    [anon_sym_switch] = ACTIONS(3463),
    [anon_sym_case] = ACTIONS(3463),
    [anon_sym_default] = ACTIONS(3463),
    [anon_sym_while] = ACTIONS(3463),
    [anon_sym_do] = ACTIONS(3463),
    [anon_sym_for] = ACTIONS(3463),
    [anon_sym_return] = ACTIONS(3463),
    [anon_sym_break] = ACTIONS(3463),
    [anon_sym_continue] = ACTIONS(3463),
    [anon_sym_goto] = ACTIONS(3463),
    [anon_sym_not] = ACTIONS(3463),
    [anon_sym_compl] = ACTIONS(3463),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(3463),
    [anon_sym___alignof__] = ACTIONS(3463),
    [anon_sym___alignof] = ACTIONS(3463),
    [anon_sym__alignof] = ACTIONS(3463),
    [anon_sym_alignof] = ACTIONS(3463),
    [anon_sym__Alignof] = ACTIONS(3463),
    [anon_sym_offsetof] = ACTIONS(3463),
    [anon_sym__Generic] = ACTIONS(3463),
    [anon_sym_asm] = ACTIONS(3463),
    [anon_sym___asm__] = ACTIONS(3463),
    [sym_number_literal] = ACTIONS(3465),
    [anon_sym_L_SQUOTE] = ACTIONS(3465),
    [anon_sym_u_SQUOTE] = ACTIONS(3465),
    [anon_sym_U_SQUOTE] = ACTIONS(3465),
    [anon_sym_u8_SQUOTE] = ACTIONS(3465),
    [anon_sym_SQUOTE] = ACTIONS(3465),
    [anon_sym_L_DQUOTE] = ACTIONS(3465),
    [anon_sym_u_DQUOTE] = ACTIONS(3465),
    [anon_sym_U_DQUOTE] = ACTIONS(3465),
    [anon_sym_u8_DQUOTE] = ACTIONS(3465),
    [anon_sym_DQUOTE] = ACTIONS(3465),
    [sym_true] = ACTIONS(3463),
    [sym_false] = ACTIONS(3463),
    [anon_sym_NULL] = ACTIONS(3463),
    [anon_sym_nullptr] = ACTIONS(3463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3463),
    [anon_sym_let] = ACTIONS(3463),
    [anon_sym_This] = ACTIONS(3463),
    [anon_sym_decltype] = ACTIONS(3463),
    [sym_virtual] = ACTIONS(3463),
    [anon_sym_explicit] = ACTIONS(3463),
    [anon_sym_typename] = ACTIONS(3463),
    [anon_sym_template] = ACTIONS(3463),
    [anon_sym_operator] = ACTIONS(3463),
    [anon_sym_try] = ACTIONS(3463),
    [anon_sym_delete] = ACTIONS(3463),
    [anon_sym_throw] = ACTIONS(3463),
    [anon_sym_namespace] = ACTIONS(3463),
    [anon_sym_using] = ACTIONS(3463),
    [anon_sym_static_assert] = ACTIONS(3463),
    [anon_sym_concept] = ACTIONS(3463),
    [anon_sym_co_return] = ACTIONS(3463),
    [anon_sym_co_yield] = ACTIONS(3463),
    [anon_sym_R_DQUOTE] = ACTIONS(3465),
    [anon_sym_LR_DQUOTE] = ACTIONS(3465),
    [anon_sym_uR_DQUOTE] = ACTIONS(3465),
    [anon_sym_UR_DQUOTE] = ACTIONS(3465),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3465),
    [anon_sym_co_await] = ACTIONS(3463),
    [anon_sym_new] = ACTIONS(3463),
    [anon_sym_requires] = ACTIONS(3463),
    [sym_this] = ACTIONS(3463),
    [anon_sym_precise] = ACTIONS(3463),
    [anon_sym_shared] = ACTIONS(3463),
    [anon_sym_groupshared] = ACTIONS(3463),
    [anon_sym_uniform] = ACTIONS(3463),
    [anon_sym_row_major] = ACTIONS(3463),
    [anon_sym_column_major] = ACTIONS(3463),
    [anon_sym_globallycoherent] = ACTIONS(3463),
    [anon_sym_centroid] = ACTIONS(3463),
    [anon_sym_noperspective] = ACTIONS(3463),
    [anon_sym_nointerpolation] = ACTIONS(3463),
    [anon_sym_sample] = ACTIONS(3463),
    [anon_sym_linear] = ACTIONS(3463),
    [anon_sym_snorm] = ACTIONS(3463),
    [anon_sym_unorm] = ACTIONS(3463),
    [anon_sym_point] = ACTIONS(3463),
    [anon_sym_line] = ACTIONS(3463),
    [anon_sym_triangleadj] = ACTIONS(3463),
    [anon_sym_lineadj] = ACTIONS(3463),
    [anon_sym_triangle] = ACTIONS(3463),
    [anon_sym_interface] = ACTIONS(3463),
    [anon_sym_extension] = ACTIONS(3463),
    [anon_sym___exported] = ACTIONS(3463),
    [anon_sym_import] = ACTIONS(3463),
  },
  [1042] = {
    [ts_builtin_sym_end] = ACTIONS(3477),
    [sym_identifier] = ACTIONS(3475),
    [aux_sym_preproc_include_token1] = ACTIONS(3475),
    [aux_sym_preproc_def_token1] = ACTIONS(3475),
    [aux_sym_preproc_if_token1] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3475),
    [sym_preproc_directive] = ACTIONS(3475),
    [anon_sym_LPAREN2] = ACTIONS(3477),
    [anon_sym_BANG] = ACTIONS(3477),
    [anon_sym_TILDE] = ACTIONS(3477),
    [anon_sym_DASH] = ACTIONS(3475),
    [anon_sym_PLUS] = ACTIONS(3475),
    [anon_sym_STAR] = ACTIONS(3477),
    [anon_sym_AMP_AMP] = ACTIONS(3477),
    [anon_sym_AMP] = ACTIONS(3475),
    [anon_sym___extension__] = ACTIONS(3475),
    [anon_sym_typedef] = ACTIONS(3475),
    [anon_sym_in] = ACTIONS(3475),
    [anon_sym_out] = ACTIONS(3475),
    [anon_sym_inout] = ACTIONS(3475),
    [anon_sym_extern] = ACTIONS(3475),
    [anon_sym___attribute__] = ACTIONS(3475),
    [anon_sym_COLON_COLON] = ACTIONS(3477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3477),
    [anon_sym___declspec] = ACTIONS(3475),
    [anon_sym___based] = ACTIONS(3475),
    [anon_sym___cdecl] = ACTIONS(3475),
    [anon_sym___clrcall] = ACTIONS(3475),
    [anon_sym___stdcall] = ACTIONS(3475),
    [anon_sym___fastcall] = ACTIONS(3475),
    [anon_sym___thiscall] = ACTIONS(3475),
    [anon_sym___vectorcall] = ACTIONS(3475),
    [anon_sym_LBRACE] = ACTIONS(3477),
    [anon_sym_signed] = ACTIONS(3475),
    [anon_sym_unsigned] = ACTIONS(3475),
    [anon_sym_long] = ACTIONS(3475),
    [anon_sym_short] = ACTIONS(3475),
    [anon_sym_LBRACK] = ACTIONS(3475),
    [anon_sym_static] = ACTIONS(3475),
    [anon_sym_register] = ACTIONS(3475),
    [anon_sym_inline] = ACTIONS(3475),
    [anon_sym___inline] = ACTIONS(3475),
    [anon_sym___inline__] = ACTIONS(3475),
    [anon_sym___forceinline] = ACTIONS(3475),
    [anon_sym_thread_local] = ACTIONS(3475),
    [anon_sym___thread] = ACTIONS(3475),
    [anon_sym_const] = ACTIONS(3475),
    [anon_sym_constexpr] = ACTIONS(3475),
    [anon_sym_volatile] = ACTIONS(3475),
    [anon_sym_restrict] = ACTIONS(3475),
    [anon_sym___restrict__] = ACTIONS(3475),
    [anon_sym__Atomic] = ACTIONS(3475),
    [anon_sym__Noreturn] = ACTIONS(3475),
    [anon_sym_noreturn] = ACTIONS(3475),
    [anon_sym_mutable] = ACTIONS(3475),
    [anon_sym_constinit] = ACTIONS(3475),
    [anon_sym_consteval] = ACTIONS(3475),
    [anon_sym_alignas] = ACTIONS(3475),
    [anon_sym__Alignas] = ACTIONS(3475),
    [sym_primitive_type] = ACTIONS(3475),
    [anon_sym_enum] = ACTIONS(3475),
    [anon_sym_class] = ACTIONS(3475),
    [anon_sym_struct] = ACTIONS(3475),
    [anon_sym_union] = ACTIONS(3475),
    [anon_sym_if] = ACTIONS(3475),
    [anon_sym_switch] = ACTIONS(3475),
    [anon_sym_case] = ACTIONS(3475),
    [anon_sym_default] = ACTIONS(3475),
    [anon_sym_while] = ACTIONS(3475),
    [anon_sym_do] = ACTIONS(3475),
    [anon_sym_for] = ACTIONS(3475),
    [anon_sym_return] = ACTIONS(3475),
    [anon_sym_break] = ACTIONS(3475),
    [anon_sym_continue] = ACTIONS(3475),
    [anon_sym_goto] = ACTIONS(3475),
    [anon_sym_not] = ACTIONS(3475),
    [anon_sym_compl] = ACTIONS(3475),
    [anon_sym_DASH_DASH] = ACTIONS(3477),
    [anon_sym_PLUS_PLUS] = ACTIONS(3477),
    [anon_sym_sizeof] = ACTIONS(3475),
    [anon_sym___alignof__] = ACTIONS(3475),
    [anon_sym___alignof] = ACTIONS(3475),
    [anon_sym__alignof] = ACTIONS(3475),
    [anon_sym_alignof] = ACTIONS(3475),
    [anon_sym__Alignof] = ACTIONS(3475),
    [anon_sym_offsetof] = ACTIONS(3475),
    [anon_sym__Generic] = ACTIONS(3475),
    [anon_sym_asm] = ACTIONS(3475),
    [anon_sym___asm__] = ACTIONS(3475),
    [sym_number_literal] = ACTIONS(3477),
    [anon_sym_L_SQUOTE] = ACTIONS(3477),
    [anon_sym_u_SQUOTE] = ACTIONS(3477),
    [anon_sym_U_SQUOTE] = ACTIONS(3477),
    [anon_sym_u8_SQUOTE] = ACTIONS(3477),
    [anon_sym_SQUOTE] = ACTIONS(3477),
    [anon_sym_L_DQUOTE] = ACTIONS(3477),
    [anon_sym_u_DQUOTE] = ACTIONS(3477),
    [anon_sym_U_DQUOTE] = ACTIONS(3477),
    [anon_sym_u8_DQUOTE] = ACTIONS(3477),
    [anon_sym_DQUOTE] = ACTIONS(3477),
    [sym_true] = ACTIONS(3475),
    [sym_false] = ACTIONS(3475),
    [anon_sym_NULL] = ACTIONS(3475),
    [anon_sym_nullptr] = ACTIONS(3475),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3475),
    [anon_sym_let] = ACTIONS(3475),
    [anon_sym_This] = ACTIONS(3475),
    [anon_sym_decltype] = ACTIONS(3475),
    [sym_virtual] = ACTIONS(3475),
    [anon_sym_explicit] = ACTIONS(3475),
    [anon_sym_typename] = ACTIONS(3475),
    [anon_sym_template] = ACTIONS(3475),
    [anon_sym_operator] = ACTIONS(3475),
    [anon_sym_try] = ACTIONS(3475),
    [anon_sym_delete] = ACTIONS(3475),
    [anon_sym_throw] = ACTIONS(3475),
    [anon_sym_namespace] = ACTIONS(3475),
    [anon_sym_using] = ACTIONS(3475),
    [anon_sym_static_assert] = ACTIONS(3475),
    [anon_sym_concept] = ACTIONS(3475),
    [anon_sym_co_return] = ACTIONS(3475),
    [anon_sym_co_yield] = ACTIONS(3475),
    [anon_sym_R_DQUOTE] = ACTIONS(3477),
    [anon_sym_LR_DQUOTE] = ACTIONS(3477),
    [anon_sym_uR_DQUOTE] = ACTIONS(3477),
    [anon_sym_UR_DQUOTE] = ACTIONS(3477),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3477),
    [anon_sym_co_await] = ACTIONS(3475),
    [anon_sym_new] = ACTIONS(3475),
    [anon_sym_requires] = ACTIONS(3475),
    [sym_this] = ACTIONS(3475),
    [anon_sym_precise] = ACTIONS(3475),
    [anon_sym_shared] = ACTIONS(3475),
    [anon_sym_groupshared] = ACTIONS(3475),
    [anon_sym_uniform] = ACTIONS(3475),
    [anon_sym_row_major] = ACTIONS(3475),
    [anon_sym_column_major] = ACTIONS(3475),
    [anon_sym_globallycoherent] = ACTIONS(3475),
    [anon_sym_centroid] = ACTIONS(3475),
    [anon_sym_noperspective] = ACTIONS(3475),
    [anon_sym_nointerpolation] = ACTIONS(3475),
    [anon_sym_sample] = ACTIONS(3475),
    [anon_sym_linear] = ACTIONS(3475),
    [anon_sym_snorm] = ACTIONS(3475),
    [anon_sym_unorm] = ACTIONS(3475),
    [anon_sym_point] = ACTIONS(3475),
    [anon_sym_line] = ACTIONS(3475),
    [anon_sym_triangleadj] = ACTIONS(3475),
    [anon_sym_lineadj] = ACTIONS(3475),
    [anon_sym_triangle] = ACTIONS(3475),
    [anon_sym_interface] = ACTIONS(3475),
    [anon_sym_extension] = ACTIONS(3475),
    [anon_sym___exported] = ACTIONS(3475),
    [anon_sym_import] = ACTIONS(3475),
  },
  [1043] = {
    [ts_builtin_sym_end] = ACTIONS(3953),
    [sym_identifier] = ACTIONS(3955),
    [aux_sym_preproc_include_token1] = ACTIONS(3955),
    [aux_sym_preproc_def_token1] = ACTIONS(3955),
    [aux_sym_preproc_if_token1] = ACTIONS(3955),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3955),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3955),
    [sym_preproc_directive] = ACTIONS(3955),
    [anon_sym_LPAREN2] = ACTIONS(3953),
    [anon_sym_BANG] = ACTIONS(3953),
    [anon_sym_TILDE] = ACTIONS(3953),
    [anon_sym_DASH] = ACTIONS(3955),
    [anon_sym_PLUS] = ACTIONS(3955),
    [anon_sym_STAR] = ACTIONS(3953),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_AMP] = ACTIONS(3955),
    [anon_sym___extension__] = ACTIONS(3955),
    [anon_sym_typedef] = ACTIONS(3955),
    [anon_sym_in] = ACTIONS(3955),
    [anon_sym_out] = ACTIONS(3955),
    [anon_sym_inout] = ACTIONS(3955),
    [anon_sym_extern] = ACTIONS(3955),
    [anon_sym___attribute__] = ACTIONS(3955),
    [anon_sym_COLON_COLON] = ACTIONS(3953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3953),
    [anon_sym___declspec] = ACTIONS(3955),
    [anon_sym___based] = ACTIONS(3955),
    [anon_sym___cdecl] = ACTIONS(3955),
    [anon_sym___clrcall] = ACTIONS(3955),
    [anon_sym___stdcall] = ACTIONS(3955),
    [anon_sym___fastcall] = ACTIONS(3955),
    [anon_sym___thiscall] = ACTIONS(3955),
    [anon_sym___vectorcall] = ACTIONS(3955),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_signed] = ACTIONS(3955),
    [anon_sym_unsigned] = ACTIONS(3955),
    [anon_sym_long] = ACTIONS(3955),
    [anon_sym_short] = ACTIONS(3955),
    [anon_sym_LBRACK] = ACTIONS(3955),
    [anon_sym_static] = ACTIONS(3955),
    [anon_sym_register] = ACTIONS(3955),
    [anon_sym_inline] = ACTIONS(3955),
    [anon_sym___inline] = ACTIONS(3955),
    [anon_sym___inline__] = ACTIONS(3955),
    [anon_sym___forceinline] = ACTIONS(3955),
    [anon_sym_thread_local] = ACTIONS(3955),
    [anon_sym___thread] = ACTIONS(3955),
    [anon_sym_const] = ACTIONS(3955),
    [anon_sym_constexpr] = ACTIONS(3955),
    [anon_sym_volatile] = ACTIONS(3955),
    [anon_sym_restrict] = ACTIONS(3955),
    [anon_sym___restrict__] = ACTIONS(3955),
    [anon_sym__Atomic] = ACTIONS(3955),
    [anon_sym__Noreturn] = ACTIONS(3955),
    [anon_sym_noreturn] = ACTIONS(3955),
    [anon_sym_mutable] = ACTIONS(3955),
    [anon_sym_constinit] = ACTIONS(3955),
    [anon_sym_consteval] = ACTIONS(3955),
    [anon_sym_alignas] = ACTIONS(3955),
    [anon_sym__Alignas] = ACTIONS(3955),
    [sym_primitive_type] = ACTIONS(3955),
    [anon_sym_enum] = ACTIONS(3955),
    [anon_sym_class] = ACTIONS(3955),
    [anon_sym_struct] = ACTIONS(3955),
    [anon_sym_union] = ACTIONS(3955),
    [anon_sym_if] = ACTIONS(3955),
    [anon_sym_switch] = ACTIONS(3955),
    [anon_sym_case] = ACTIONS(3955),
    [anon_sym_default] = ACTIONS(3955),
    [anon_sym_while] = ACTIONS(3955),
    [anon_sym_do] = ACTIONS(3955),
    [anon_sym_for] = ACTIONS(3955),
    [anon_sym_return] = ACTIONS(3955),
    [anon_sym_break] = ACTIONS(3955),
    [anon_sym_continue] = ACTIONS(3955),
    [anon_sym_goto] = ACTIONS(3955),
    [anon_sym_not] = ACTIONS(3955),
    [anon_sym_compl] = ACTIONS(3955),
    [anon_sym_DASH_DASH] = ACTIONS(3953),
    [anon_sym_PLUS_PLUS] = ACTIONS(3953),
    [anon_sym_sizeof] = ACTIONS(3955),
    [anon_sym___alignof__] = ACTIONS(3955),
    [anon_sym___alignof] = ACTIONS(3955),
    [anon_sym__alignof] = ACTIONS(3955),
    [anon_sym_alignof] = ACTIONS(3955),
    [anon_sym__Alignof] = ACTIONS(3955),
    [anon_sym_offsetof] = ACTIONS(3955),
    [anon_sym__Generic] = ACTIONS(3955),
    [anon_sym_asm] = ACTIONS(3955),
    [anon_sym___asm__] = ACTIONS(3955),
    [sym_number_literal] = ACTIONS(3953),
    [anon_sym_L_SQUOTE] = ACTIONS(3953),
    [anon_sym_u_SQUOTE] = ACTIONS(3953),
    [anon_sym_U_SQUOTE] = ACTIONS(3953),
    [anon_sym_u8_SQUOTE] = ACTIONS(3953),
    [anon_sym_SQUOTE] = ACTIONS(3953),
    [anon_sym_L_DQUOTE] = ACTIONS(3953),
    [anon_sym_u_DQUOTE] = ACTIONS(3953),
    [anon_sym_U_DQUOTE] = ACTIONS(3953),
    [anon_sym_u8_DQUOTE] = ACTIONS(3953),
    [anon_sym_DQUOTE] = ACTIONS(3953),
    [sym_true] = ACTIONS(3955),
    [sym_false] = ACTIONS(3955),
    [anon_sym_NULL] = ACTIONS(3955),
    [anon_sym_nullptr] = ACTIONS(3955),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3955),
    [anon_sym_let] = ACTIONS(3955),
    [anon_sym_This] = ACTIONS(3955),
    [anon_sym_decltype] = ACTIONS(3955),
    [sym_virtual] = ACTIONS(3955),
    [anon_sym_explicit] = ACTIONS(3955),
    [anon_sym_typename] = ACTIONS(3955),
    [anon_sym_template] = ACTIONS(3955),
    [anon_sym_operator] = ACTIONS(3955),
    [anon_sym_try] = ACTIONS(3955),
    [anon_sym_delete] = ACTIONS(3955),
    [anon_sym_throw] = ACTIONS(3955),
    [anon_sym_namespace] = ACTIONS(3955),
    [anon_sym_using] = ACTIONS(3955),
    [anon_sym_static_assert] = ACTIONS(3955),
    [anon_sym_concept] = ACTIONS(3955),
    [anon_sym_co_return] = ACTIONS(3955),
    [anon_sym_co_yield] = ACTIONS(3955),
    [anon_sym_R_DQUOTE] = ACTIONS(3953),
    [anon_sym_LR_DQUOTE] = ACTIONS(3953),
    [anon_sym_uR_DQUOTE] = ACTIONS(3953),
    [anon_sym_UR_DQUOTE] = ACTIONS(3953),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3953),
    [anon_sym_co_await] = ACTIONS(3955),
    [anon_sym_new] = ACTIONS(3955),
    [anon_sym_requires] = ACTIONS(3955),
    [sym_this] = ACTIONS(3955),
    [anon_sym_precise] = ACTIONS(3955),
    [anon_sym_shared] = ACTIONS(3955),
    [anon_sym_groupshared] = ACTIONS(3955),
    [anon_sym_uniform] = ACTIONS(3955),
    [anon_sym_row_major] = ACTIONS(3955),
    [anon_sym_column_major] = ACTIONS(3955),
    [anon_sym_globallycoherent] = ACTIONS(3955),
    [anon_sym_centroid] = ACTIONS(3955),
    [anon_sym_noperspective] = ACTIONS(3955),
    [anon_sym_nointerpolation] = ACTIONS(3955),
    [anon_sym_sample] = ACTIONS(3955),
    [anon_sym_linear] = ACTIONS(3955),
    [anon_sym_snorm] = ACTIONS(3955),
    [anon_sym_unorm] = ACTIONS(3955),
    [anon_sym_point] = ACTIONS(3955),
    [anon_sym_line] = ACTIONS(3955),
    [anon_sym_triangleadj] = ACTIONS(3955),
    [anon_sym_lineadj] = ACTIONS(3955),
    [anon_sym_triangle] = ACTIONS(3955),
    [anon_sym_interface] = ACTIONS(3955),
    [anon_sym_extension] = ACTIONS(3955),
    [anon_sym___exported] = ACTIONS(3955),
    [anon_sym_import] = ACTIONS(3955),
  },
  [1044] = {
    [ts_builtin_sym_end] = ACTIONS(3481),
    [sym_identifier] = ACTIONS(3479),
    [aux_sym_preproc_include_token1] = ACTIONS(3479),
    [aux_sym_preproc_def_token1] = ACTIONS(3479),
    [aux_sym_preproc_if_token1] = ACTIONS(3479),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3479),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3479),
    [sym_preproc_directive] = ACTIONS(3479),
    [anon_sym_LPAREN2] = ACTIONS(3481),
    [anon_sym_BANG] = ACTIONS(3481),
    [anon_sym_TILDE] = ACTIONS(3481),
    [anon_sym_DASH] = ACTIONS(3479),
    [anon_sym_PLUS] = ACTIONS(3479),
    [anon_sym_STAR] = ACTIONS(3481),
    [anon_sym_AMP_AMP] = ACTIONS(3481),
    [anon_sym_AMP] = ACTIONS(3479),
    [anon_sym___extension__] = ACTIONS(3479),
    [anon_sym_typedef] = ACTIONS(3479),
    [anon_sym_in] = ACTIONS(3479),
    [anon_sym_out] = ACTIONS(3479),
    [anon_sym_inout] = ACTIONS(3479),
    [anon_sym_extern] = ACTIONS(3479),
    [anon_sym___attribute__] = ACTIONS(3479),
    [anon_sym_COLON_COLON] = ACTIONS(3481),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3481),
    [anon_sym___declspec] = ACTIONS(3479),
    [anon_sym___based] = ACTIONS(3479),
    [anon_sym___cdecl] = ACTIONS(3479),
    [anon_sym___clrcall] = ACTIONS(3479),
    [anon_sym___stdcall] = ACTIONS(3479),
    [anon_sym___fastcall] = ACTIONS(3479),
    [anon_sym___thiscall] = ACTIONS(3479),
    [anon_sym___vectorcall] = ACTIONS(3479),
    [anon_sym_LBRACE] = ACTIONS(3481),
    [anon_sym_signed] = ACTIONS(3479),
    [anon_sym_unsigned] = ACTIONS(3479),
    [anon_sym_long] = ACTIONS(3479),
    [anon_sym_short] = ACTIONS(3479),
    [anon_sym_LBRACK] = ACTIONS(3479),
    [anon_sym_static] = ACTIONS(3479),
    [anon_sym_register] = ACTIONS(3479),
    [anon_sym_inline] = ACTIONS(3479),
    [anon_sym___inline] = ACTIONS(3479),
    [anon_sym___inline__] = ACTIONS(3479),
    [anon_sym___forceinline] = ACTIONS(3479),
    [anon_sym_thread_local] = ACTIONS(3479),
    [anon_sym___thread] = ACTIONS(3479),
    [anon_sym_const] = ACTIONS(3479),
    [anon_sym_constexpr] = ACTIONS(3479),
    [anon_sym_volatile] = ACTIONS(3479),
    [anon_sym_restrict] = ACTIONS(3479),
    [anon_sym___restrict__] = ACTIONS(3479),
    [anon_sym__Atomic] = ACTIONS(3479),
    [anon_sym__Noreturn] = ACTIONS(3479),
    [anon_sym_noreturn] = ACTIONS(3479),
    [anon_sym_mutable] = ACTIONS(3479),
    [anon_sym_constinit] = ACTIONS(3479),
    [anon_sym_consteval] = ACTIONS(3479),
    [anon_sym_alignas] = ACTIONS(3479),
    [anon_sym__Alignas] = ACTIONS(3479),
    [sym_primitive_type] = ACTIONS(3479),
    [anon_sym_enum] = ACTIONS(3479),
    [anon_sym_class] = ACTIONS(3479),
    [anon_sym_struct] = ACTIONS(3479),
    [anon_sym_union] = ACTIONS(3479),
    [anon_sym_if] = ACTIONS(3479),
    [anon_sym_switch] = ACTIONS(3479),
    [anon_sym_case] = ACTIONS(3479),
    [anon_sym_default] = ACTIONS(3479),
    [anon_sym_while] = ACTIONS(3479),
    [anon_sym_do] = ACTIONS(3479),
    [anon_sym_for] = ACTIONS(3479),
    [anon_sym_return] = ACTIONS(3479),
    [anon_sym_break] = ACTIONS(3479),
    [anon_sym_continue] = ACTIONS(3479),
    [anon_sym_goto] = ACTIONS(3479),
    [anon_sym_not] = ACTIONS(3479),
    [anon_sym_compl] = ACTIONS(3479),
    [anon_sym_DASH_DASH] = ACTIONS(3481),
    [anon_sym_PLUS_PLUS] = ACTIONS(3481),
    [anon_sym_sizeof] = ACTIONS(3479),
    [anon_sym___alignof__] = ACTIONS(3479),
    [anon_sym___alignof] = ACTIONS(3479),
    [anon_sym__alignof] = ACTIONS(3479),
    [anon_sym_alignof] = ACTIONS(3479),
    [anon_sym__Alignof] = ACTIONS(3479),
    [anon_sym_offsetof] = ACTIONS(3479),
    [anon_sym__Generic] = ACTIONS(3479),
    [anon_sym_asm] = ACTIONS(3479),
    [anon_sym___asm__] = ACTIONS(3479),
    [sym_number_literal] = ACTIONS(3481),
    [anon_sym_L_SQUOTE] = ACTIONS(3481),
    [anon_sym_u_SQUOTE] = ACTIONS(3481),
    [anon_sym_U_SQUOTE] = ACTIONS(3481),
    [anon_sym_u8_SQUOTE] = ACTIONS(3481),
    [anon_sym_SQUOTE] = ACTIONS(3481),
    [anon_sym_L_DQUOTE] = ACTIONS(3481),
    [anon_sym_u_DQUOTE] = ACTIONS(3481),
    [anon_sym_U_DQUOTE] = ACTIONS(3481),
    [anon_sym_u8_DQUOTE] = ACTIONS(3481),
    [anon_sym_DQUOTE] = ACTIONS(3481),
    [sym_true] = ACTIONS(3479),
    [sym_false] = ACTIONS(3479),
    [anon_sym_NULL] = ACTIONS(3479),
    [anon_sym_nullptr] = ACTIONS(3479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3479),
    [anon_sym_let] = ACTIONS(3479),
    [anon_sym_This] = ACTIONS(3479),
    [anon_sym_decltype] = ACTIONS(3479),
    [sym_virtual] = ACTIONS(3479),
    [anon_sym_explicit] = ACTIONS(3479),
    [anon_sym_typename] = ACTIONS(3479),
    [anon_sym_template] = ACTIONS(3479),
    [anon_sym_operator] = ACTIONS(3479),
    [anon_sym_try] = ACTIONS(3479),
    [anon_sym_delete] = ACTIONS(3479),
    [anon_sym_throw] = ACTIONS(3479),
    [anon_sym_namespace] = ACTIONS(3479),
    [anon_sym_using] = ACTIONS(3479),
    [anon_sym_static_assert] = ACTIONS(3479),
    [anon_sym_concept] = ACTIONS(3479),
    [anon_sym_co_return] = ACTIONS(3479),
    [anon_sym_co_yield] = ACTIONS(3479),
    [anon_sym_R_DQUOTE] = ACTIONS(3481),
    [anon_sym_LR_DQUOTE] = ACTIONS(3481),
    [anon_sym_uR_DQUOTE] = ACTIONS(3481),
    [anon_sym_UR_DQUOTE] = ACTIONS(3481),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3481),
    [anon_sym_co_await] = ACTIONS(3479),
    [anon_sym_new] = ACTIONS(3479),
    [anon_sym_requires] = ACTIONS(3479),
    [sym_this] = ACTIONS(3479),
    [anon_sym_precise] = ACTIONS(3479),
    [anon_sym_shared] = ACTIONS(3479),
    [anon_sym_groupshared] = ACTIONS(3479),
    [anon_sym_uniform] = ACTIONS(3479),
    [anon_sym_row_major] = ACTIONS(3479),
    [anon_sym_column_major] = ACTIONS(3479),
    [anon_sym_globallycoherent] = ACTIONS(3479),
    [anon_sym_centroid] = ACTIONS(3479),
    [anon_sym_noperspective] = ACTIONS(3479),
    [anon_sym_nointerpolation] = ACTIONS(3479),
    [anon_sym_sample] = ACTIONS(3479),
    [anon_sym_linear] = ACTIONS(3479),
    [anon_sym_snorm] = ACTIONS(3479),
    [anon_sym_unorm] = ACTIONS(3479),
    [anon_sym_point] = ACTIONS(3479),
    [anon_sym_line] = ACTIONS(3479),
    [anon_sym_triangleadj] = ACTIONS(3479),
    [anon_sym_lineadj] = ACTIONS(3479),
    [anon_sym_triangle] = ACTIONS(3479),
    [anon_sym_interface] = ACTIONS(3479),
    [anon_sym_extension] = ACTIONS(3479),
    [anon_sym___exported] = ACTIONS(3479),
    [anon_sym_import] = ACTIONS(3479),
  },
  [1045] = {
    [ts_builtin_sym_end] = ACTIONS(3545),
    [sym_identifier] = ACTIONS(3543),
    [aux_sym_preproc_include_token1] = ACTIONS(3543),
    [aux_sym_preproc_def_token1] = ACTIONS(3543),
    [aux_sym_preproc_if_token1] = ACTIONS(3543),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3543),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3543),
    [sym_preproc_directive] = ACTIONS(3543),
    [anon_sym_LPAREN2] = ACTIONS(3545),
    [anon_sym_BANG] = ACTIONS(3545),
    [anon_sym_TILDE] = ACTIONS(3545),
    [anon_sym_DASH] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(3543),
    [anon_sym_STAR] = ACTIONS(3545),
    [anon_sym_AMP_AMP] = ACTIONS(3545),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym___extension__] = ACTIONS(3543),
    [anon_sym_typedef] = ACTIONS(3543),
    [anon_sym_in] = ACTIONS(3543),
    [anon_sym_out] = ACTIONS(3543),
    [anon_sym_inout] = ACTIONS(3543),
    [anon_sym_extern] = ACTIONS(3543),
    [anon_sym___attribute__] = ACTIONS(3543),
    [anon_sym_COLON_COLON] = ACTIONS(3545),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3545),
    [anon_sym___declspec] = ACTIONS(3543),
    [anon_sym___based] = ACTIONS(3543),
    [anon_sym___cdecl] = ACTIONS(3543),
    [anon_sym___clrcall] = ACTIONS(3543),
    [anon_sym___stdcall] = ACTIONS(3543),
    [anon_sym___fastcall] = ACTIONS(3543),
    [anon_sym___thiscall] = ACTIONS(3543),
    [anon_sym___vectorcall] = ACTIONS(3543),
    [anon_sym_LBRACE] = ACTIONS(3545),
    [anon_sym_signed] = ACTIONS(3543),
    [anon_sym_unsigned] = ACTIONS(3543),
    [anon_sym_long] = ACTIONS(3543),
    [anon_sym_short] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3543),
    [anon_sym_static] = ACTIONS(3543),
    [anon_sym_register] = ACTIONS(3543),
    [anon_sym_inline] = ACTIONS(3543),
    [anon_sym___inline] = ACTIONS(3543),
    [anon_sym___inline__] = ACTIONS(3543),
    [anon_sym___forceinline] = ACTIONS(3543),
    [anon_sym_thread_local] = ACTIONS(3543),
    [anon_sym___thread] = ACTIONS(3543),
    [anon_sym_const] = ACTIONS(3543),
    [anon_sym_constexpr] = ACTIONS(3543),
    [anon_sym_volatile] = ACTIONS(3543),
    [anon_sym_restrict] = ACTIONS(3543),
    [anon_sym___restrict__] = ACTIONS(3543),
    [anon_sym__Atomic] = ACTIONS(3543),
    [anon_sym__Noreturn] = ACTIONS(3543),
    [anon_sym_noreturn] = ACTIONS(3543),
    [anon_sym_mutable] = ACTIONS(3543),
    [anon_sym_constinit] = ACTIONS(3543),
    [anon_sym_consteval] = ACTIONS(3543),
    [anon_sym_alignas] = ACTIONS(3543),
    [anon_sym__Alignas] = ACTIONS(3543),
    [sym_primitive_type] = ACTIONS(3543),
    [anon_sym_enum] = ACTIONS(3543),
    [anon_sym_class] = ACTIONS(3543),
    [anon_sym_struct] = ACTIONS(3543),
    [anon_sym_union] = ACTIONS(3543),
    [anon_sym_if] = ACTIONS(3543),
    [anon_sym_switch] = ACTIONS(3543),
    [anon_sym_case] = ACTIONS(3543),
    [anon_sym_default] = ACTIONS(3543),
    [anon_sym_while] = ACTIONS(3543),
    [anon_sym_do] = ACTIONS(3543),
    [anon_sym_for] = ACTIONS(3543),
    [anon_sym_return] = ACTIONS(3543),
    [anon_sym_break] = ACTIONS(3543),
    [anon_sym_continue] = ACTIONS(3543),
    [anon_sym_goto] = ACTIONS(3543),
    [anon_sym_not] = ACTIONS(3543),
    [anon_sym_compl] = ACTIONS(3543),
    [anon_sym_DASH_DASH] = ACTIONS(3545),
    [anon_sym_PLUS_PLUS] = ACTIONS(3545),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym___alignof__] = ACTIONS(3543),
    [anon_sym___alignof] = ACTIONS(3543),
    [anon_sym__alignof] = ACTIONS(3543),
    [anon_sym_alignof] = ACTIONS(3543),
    [anon_sym__Alignof] = ACTIONS(3543),
    [anon_sym_offsetof] = ACTIONS(3543),
    [anon_sym__Generic] = ACTIONS(3543),
    [anon_sym_asm] = ACTIONS(3543),
    [anon_sym___asm__] = ACTIONS(3543),
    [sym_number_literal] = ACTIONS(3545),
    [anon_sym_L_SQUOTE] = ACTIONS(3545),
    [anon_sym_u_SQUOTE] = ACTIONS(3545),
    [anon_sym_U_SQUOTE] = ACTIONS(3545),
    [anon_sym_u8_SQUOTE] = ACTIONS(3545),
    [anon_sym_SQUOTE] = ACTIONS(3545),
    [anon_sym_L_DQUOTE] = ACTIONS(3545),
    [anon_sym_u_DQUOTE] = ACTIONS(3545),
    [anon_sym_U_DQUOTE] = ACTIONS(3545),
    [anon_sym_u8_DQUOTE] = ACTIONS(3545),
    [anon_sym_DQUOTE] = ACTIONS(3545),
    [sym_true] = ACTIONS(3543),
    [sym_false] = ACTIONS(3543),
    [anon_sym_NULL] = ACTIONS(3543),
    [anon_sym_nullptr] = ACTIONS(3543),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3543),
    [anon_sym_This] = ACTIONS(3543),
    [anon_sym_decltype] = ACTIONS(3543),
    [sym_virtual] = ACTIONS(3543),
    [anon_sym_explicit] = ACTIONS(3543),
    [anon_sym_typename] = ACTIONS(3543),
    [anon_sym_template] = ACTIONS(3543),
    [anon_sym_operator] = ACTIONS(3543),
    [anon_sym_try] = ACTIONS(3543),
    [anon_sym_delete] = ACTIONS(3543),
    [anon_sym_throw] = ACTIONS(3543),
    [anon_sym_namespace] = ACTIONS(3543),
    [anon_sym_using] = ACTIONS(3543),
    [anon_sym_static_assert] = ACTIONS(3543),
    [anon_sym_concept] = ACTIONS(3543),
    [anon_sym_co_return] = ACTIONS(3543),
    [anon_sym_co_yield] = ACTIONS(3543),
    [anon_sym_R_DQUOTE] = ACTIONS(3545),
    [anon_sym_LR_DQUOTE] = ACTIONS(3545),
    [anon_sym_uR_DQUOTE] = ACTIONS(3545),
    [anon_sym_UR_DQUOTE] = ACTIONS(3545),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3545),
    [anon_sym_co_await] = ACTIONS(3543),
    [anon_sym_new] = ACTIONS(3543),
    [anon_sym_requires] = ACTIONS(3543),
    [sym_this] = ACTIONS(3543),
    [anon_sym_precise] = ACTIONS(3543),
    [anon_sym_shared] = ACTIONS(3543),
    [anon_sym_groupshared] = ACTIONS(3543),
    [anon_sym_uniform] = ACTIONS(3543),
    [anon_sym_row_major] = ACTIONS(3543),
    [anon_sym_column_major] = ACTIONS(3543),
    [anon_sym_globallycoherent] = ACTIONS(3543),
    [anon_sym_centroid] = ACTIONS(3543),
    [anon_sym_noperspective] = ACTIONS(3543),
    [anon_sym_nointerpolation] = ACTIONS(3543),
    [anon_sym_sample] = ACTIONS(3543),
    [anon_sym_linear] = ACTIONS(3543),
    [anon_sym_snorm] = ACTIONS(3543),
    [anon_sym_unorm] = ACTIONS(3543),
    [anon_sym_point] = ACTIONS(3543),
    [anon_sym_line] = ACTIONS(3543),
    [anon_sym_triangleadj] = ACTIONS(3543),
    [anon_sym_lineadj] = ACTIONS(3543),
    [anon_sym_triangle] = ACTIONS(3543),
    [anon_sym_interface] = ACTIONS(3543),
    [anon_sym_extension] = ACTIONS(3543),
    [anon_sym___exported] = ACTIONS(3543),
    [anon_sym_import] = ACTIONS(3543),
  },
  [1046] = {
    [ts_builtin_sym_end] = ACTIONS(3431),
    [sym_identifier] = ACTIONS(3429),
    [aux_sym_preproc_include_token1] = ACTIONS(3429),
    [aux_sym_preproc_def_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3429),
    [sym_preproc_directive] = ACTIONS(3429),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_BANG] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym___extension__] = ACTIONS(3429),
    [anon_sym_typedef] = ACTIONS(3429),
    [anon_sym_in] = ACTIONS(3429),
    [anon_sym_out] = ACTIONS(3429),
    [anon_sym_inout] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym___attribute__] = ACTIONS(3429),
    [anon_sym_COLON_COLON] = ACTIONS(3431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3431),
    [anon_sym___declspec] = ACTIONS(3429),
    [anon_sym___based] = ACTIONS(3429),
    [anon_sym___cdecl] = ACTIONS(3429),
    [anon_sym___clrcall] = ACTIONS(3429),
    [anon_sym___stdcall] = ACTIONS(3429),
    [anon_sym___fastcall] = ACTIONS(3429),
    [anon_sym___thiscall] = ACTIONS(3429),
    [anon_sym___vectorcall] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_signed] = ACTIONS(3429),
    [anon_sym_unsigned] = ACTIONS(3429),
    [anon_sym_long] = ACTIONS(3429),
    [anon_sym_short] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_register] = ACTIONS(3429),
    [anon_sym_inline] = ACTIONS(3429),
    [anon_sym___inline] = ACTIONS(3429),
    [anon_sym___inline__] = ACTIONS(3429),
    [anon_sym___forceinline] = ACTIONS(3429),
    [anon_sym_thread_local] = ACTIONS(3429),
    [anon_sym___thread] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_constexpr] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_restrict] = ACTIONS(3429),
    [anon_sym___restrict__] = ACTIONS(3429),
    [anon_sym__Atomic] = ACTIONS(3429),
    [anon_sym__Noreturn] = ACTIONS(3429),
    [anon_sym_noreturn] = ACTIONS(3429),
    [anon_sym_mutable] = ACTIONS(3429),
    [anon_sym_constinit] = ACTIONS(3429),
    [anon_sym_consteval] = ACTIONS(3429),
    [anon_sym_alignas] = ACTIONS(3429),
    [anon_sym__Alignas] = ACTIONS(3429),
    [sym_primitive_type] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [anon_sym_if] = ACTIONS(3429),
    [anon_sym_switch] = ACTIONS(3429),
    [anon_sym_case] = ACTIONS(3429),
    [anon_sym_default] = ACTIONS(3429),
    [anon_sym_while] = ACTIONS(3429),
    [anon_sym_do] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3429),
    [anon_sym_return] = ACTIONS(3429),
    [anon_sym_break] = ACTIONS(3429),
    [anon_sym_continue] = ACTIONS(3429),
    [anon_sym_goto] = ACTIONS(3429),
    [anon_sym_not] = ACTIONS(3429),
    [anon_sym_compl] = ACTIONS(3429),
    [anon_sym_DASH_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(3431),
    [anon_sym_sizeof] = ACTIONS(3429),
    [anon_sym___alignof__] = ACTIONS(3429),
    [anon_sym___alignof] = ACTIONS(3429),
    [anon_sym__alignof] = ACTIONS(3429),
    [anon_sym_alignof] = ACTIONS(3429),
    [anon_sym__Alignof] = ACTIONS(3429),
    [anon_sym_offsetof] = ACTIONS(3429),
    [anon_sym__Generic] = ACTIONS(3429),
    [anon_sym_asm] = ACTIONS(3429),
    [anon_sym___asm__] = ACTIONS(3429),
    [sym_number_literal] = ACTIONS(3431),
    [anon_sym_L_SQUOTE] = ACTIONS(3431),
    [anon_sym_u_SQUOTE] = ACTIONS(3431),
    [anon_sym_U_SQUOTE] = ACTIONS(3431),
    [anon_sym_u8_SQUOTE] = ACTIONS(3431),
    [anon_sym_SQUOTE] = ACTIONS(3431),
    [anon_sym_L_DQUOTE] = ACTIONS(3431),
    [anon_sym_u_DQUOTE] = ACTIONS(3431),
    [anon_sym_U_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [sym_true] = ACTIONS(3429),
    [sym_false] = ACTIONS(3429),
    [anon_sym_NULL] = ACTIONS(3429),
    [anon_sym_nullptr] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_This] = ACTIONS(3429),
    [anon_sym_decltype] = ACTIONS(3429),
    [sym_virtual] = ACTIONS(3429),
    [anon_sym_explicit] = ACTIONS(3429),
    [anon_sym_typename] = ACTIONS(3429),
    [anon_sym_template] = ACTIONS(3429),
    [anon_sym_operator] = ACTIONS(3429),
    [anon_sym_try] = ACTIONS(3429),
    [anon_sym_delete] = ACTIONS(3429),
    [anon_sym_throw] = ACTIONS(3429),
    [anon_sym_namespace] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_static_assert] = ACTIONS(3429),
    [anon_sym_concept] = ACTIONS(3429),
    [anon_sym_co_return] = ACTIONS(3429),
    [anon_sym_co_yield] = ACTIONS(3429),
    [anon_sym_R_DQUOTE] = ACTIONS(3431),
    [anon_sym_LR_DQUOTE] = ACTIONS(3431),
    [anon_sym_uR_DQUOTE] = ACTIONS(3431),
    [anon_sym_UR_DQUOTE] = ACTIONS(3431),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3431),
    [anon_sym_co_await] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3429),
    [anon_sym_requires] = ACTIONS(3429),
    [sym_this] = ACTIONS(3429),
    [anon_sym_precise] = ACTIONS(3429),
    [anon_sym_shared] = ACTIONS(3429),
    [anon_sym_groupshared] = ACTIONS(3429),
    [anon_sym_uniform] = ACTIONS(3429),
    [anon_sym_row_major] = ACTIONS(3429),
    [anon_sym_column_major] = ACTIONS(3429),
    [anon_sym_globallycoherent] = ACTIONS(3429),
    [anon_sym_centroid] = ACTIONS(3429),
    [anon_sym_noperspective] = ACTIONS(3429),
    [anon_sym_nointerpolation] = ACTIONS(3429),
    [anon_sym_sample] = ACTIONS(3429),
    [anon_sym_linear] = ACTIONS(3429),
    [anon_sym_snorm] = ACTIONS(3429),
    [anon_sym_unorm] = ACTIONS(3429),
    [anon_sym_point] = ACTIONS(3429),
    [anon_sym_line] = ACTIONS(3429),
    [anon_sym_triangleadj] = ACTIONS(3429),
    [anon_sym_lineadj] = ACTIONS(3429),
    [anon_sym_triangle] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_extension] = ACTIONS(3429),
    [anon_sym___exported] = ACTIONS(3429),
    [anon_sym_import] = ACTIONS(3429),
  },
  [1047] = {
    [ts_builtin_sym_end] = ACTIONS(3533),
    [sym_identifier] = ACTIONS(3531),
    [aux_sym_preproc_include_token1] = ACTIONS(3531),
    [aux_sym_preproc_def_token1] = ACTIONS(3531),
    [aux_sym_preproc_if_token1] = ACTIONS(3531),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3531),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3531),
    [sym_preproc_directive] = ACTIONS(3531),
    [anon_sym_LPAREN2] = ACTIONS(3533),
    [anon_sym_BANG] = ACTIONS(3533),
    [anon_sym_TILDE] = ACTIONS(3533),
    [anon_sym_DASH] = ACTIONS(3531),
    [anon_sym_PLUS] = ACTIONS(3531),
    [anon_sym_STAR] = ACTIONS(3533),
    [anon_sym_AMP_AMP] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym___extension__] = ACTIONS(3531),
    [anon_sym_typedef] = ACTIONS(3531),
    [anon_sym_in] = ACTIONS(3531),
    [anon_sym_out] = ACTIONS(3531),
    [anon_sym_inout] = ACTIONS(3531),
    [anon_sym_extern] = ACTIONS(3531),
    [anon_sym___attribute__] = ACTIONS(3531),
    [anon_sym_COLON_COLON] = ACTIONS(3533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3533),
    [anon_sym___declspec] = ACTIONS(3531),
    [anon_sym___based] = ACTIONS(3531),
    [anon_sym___cdecl] = ACTIONS(3531),
    [anon_sym___clrcall] = ACTIONS(3531),
    [anon_sym___stdcall] = ACTIONS(3531),
    [anon_sym___fastcall] = ACTIONS(3531),
    [anon_sym___thiscall] = ACTIONS(3531),
    [anon_sym___vectorcall] = ACTIONS(3531),
    [anon_sym_LBRACE] = ACTIONS(3533),
    [anon_sym_signed] = ACTIONS(3531),
    [anon_sym_unsigned] = ACTIONS(3531),
    [anon_sym_long] = ACTIONS(3531),
    [anon_sym_short] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_static] = ACTIONS(3531),
    [anon_sym_register] = ACTIONS(3531),
    [anon_sym_inline] = ACTIONS(3531),
    [anon_sym___inline] = ACTIONS(3531),
    [anon_sym___inline__] = ACTIONS(3531),
    [anon_sym___forceinline] = ACTIONS(3531),
    [anon_sym_thread_local] = ACTIONS(3531),
    [anon_sym___thread] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3531),
    [anon_sym_constexpr] = ACTIONS(3531),
    [anon_sym_volatile] = ACTIONS(3531),
    [anon_sym_restrict] = ACTIONS(3531),
    [anon_sym___restrict__] = ACTIONS(3531),
    [anon_sym__Atomic] = ACTIONS(3531),
    [anon_sym__Noreturn] = ACTIONS(3531),
    [anon_sym_noreturn] = ACTIONS(3531),
    [anon_sym_mutable] = ACTIONS(3531),
    [anon_sym_constinit] = ACTIONS(3531),
    [anon_sym_consteval] = ACTIONS(3531),
    [anon_sym_alignas] = ACTIONS(3531),
    [anon_sym__Alignas] = ACTIONS(3531),
    [sym_primitive_type] = ACTIONS(3531),
    [anon_sym_enum] = ACTIONS(3531),
    [anon_sym_class] = ACTIONS(3531),
    [anon_sym_struct] = ACTIONS(3531),
    [anon_sym_union] = ACTIONS(3531),
    [anon_sym_if] = ACTIONS(3531),
    [anon_sym_switch] = ACTIONS(3531),
    [anon_sym_case] = ACTIONS(3531),
    [anon_sym_default] = ACTIONS(3531),
    [anon_sym_while] = ACTIONS(3531),
    [anon_sym_do] = ACTIONS(3531),
    [anon_sym_for] = ACTIONS(3531),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_break] = ACTIONS(3531),
    [anon_sym_continue] = ACTIONS(3531),
    [anon_sym_goto] = ACTIONS(3531),
    [anon_sym_not] = ACTIONS(3531),
    [anon_sym_compl] = ACTIONS(3531),
    [anon_sym_DASH_DASH] = ACTIONS(3533),
    [anon_sym_PLUS_PLUS] = ACTIONS(3533),
    [anon_sym_sizeof] = ACTIONS(3531),
    [anon_sym___alignof__] = ACTIONS(3531),
    [anon_sym___alignof] = ACTIONS(3531),
    [anon_sym__alignof] = ACTIONS(3531),
    [anon_sym_alignof] = ACTIONS(3531),
    [anon_sym__Alignof] = ACTIONS(3531),
    [anon_sym_offsetof] = ACTIONS(3531),
    [anon_sym__Generic] = ACTIONS(3531),
    [anon_sym_asm] = ACTIONS(3531),
    [anon_sym___asm__] = ACTIONS(3531),
    [sym_number_literal] = ACTIONS(3533),
    [anon_sym_L_SQUOTE] = ACTIONS(3533),
    [anon_sym_u_SQUOTE] = ACTIONS(3533),
    [anon_sym_U_SQUOTE] = ACTIONS(3533),
    [anon_sym_u8_SQUOTE] = ACTIONS(3533),
    [anon_sym_SQUOTE] = ACTIONS(3533),
    [anon_sym_L_DQUOTE] = ACTIONS(3533),
    [anon_sym_u_DQUOTE] = ACTIONS(3533),
    [anon_sym_U_DQUOTE] = ACTIONS(3533),
    [anon_sym_u8_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE] = ACTIONS(3533),
    [sym_true] = ACTIONS(3531),
    [sym_false] = ACTIONS(3531),
    [anon_sym_NULL] = ACTIONS(3531),
    [anon_sym_nullptr] = ACTIONS(3531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_This] = ACTIONS(3531),
    [anon_sym_decltype] = ACTIONS(3531),
    [sym_virtual] = ACTIONS(3531),
    [anon_sym_explicit] = ACTIONS(3531),
    [anon_sym_typename] = ACTIONS(3531),
    [anon_sym_template] = ACTIONS(3531),
    [anon_sym_operator] = ACTIONS(3531),
    [anon_sym_try] = ACTIONS(3531),
    [anon_sym_delete] = ACTIONS(3531),
    [anon_sym_throw] = ACTIONS(3531),
    [anon_sym_namespace] = ACTIONS(3531),
    [anon_sym_using] = ACTIONS(3531),
    [anon_sym_static_assert] = ACTIONS(3531),
    [anon_sym_concept] = ACTIONS(3531),
    [anon_sym_co_return] = ACTIONS(3531),
    [anon_sym_co_yield] = ACTIONS(3531),
    [anon_sym_R_DQUOTE] = ACTIONS(3533),
    [anon_sym_LR_DQUOTE] = ACTIONS(3533),
    [anon_sym_uR_DQUOTE] = ACTIONS(3533),
    [anon_sym_UR_DQUOTE] = ACTIONS(3533),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3533),
    [anon_sym_co_await] = ACTIONS(3531),
    [anon_sym_new] = ACTIONS(3531),
    [anon_sym_requires] = ACTIONS(3531),
    [sym_this] = ACTIONS(3531),
    [anon_sym_precise] = ACTIONS(3531),
    [anon_sym_shared] = ACTIONS(3531),
    [anon_sym_groupshared] = ACTIONS(3531),
    [anon_sym_uniform] = ACTIONS(3531),
    [anon_sym_row_major] = ACTIONS(3531),
    [anon_sym_column_major] = ACTIONS(3531),
    [anon_sym_globallycoherent] = ACTIONS(3531),
    [anon_sym_centroid] = ACTIONS(3531),
    [anon_sym_noperspective] = ACTIONS(3531),
    [anon_sym_nointerpolation] = ACTIONS(3531),
    [anon_sym_sample] = ACTIONS(3531),
    [anon_sym_linear] = ACTIONS(3531),
    [anon_sym_snorm] = ACTIONS(3531),
    [anon_sym_unorm] = ACTIONS(3531),
    [anon_sym_point] = ACTIONS(3531),
    [anon_sym_line] = ACTIONS(3531),
    [anon_sym_triangleadj] = ACTIONS(3531),
    [anon_sym_lineadj] = ACTIONS(3531),
    [anon_sym_triangle] = ACTIONS(3531),
    [anon_sym_interface] = ACTIONS(3531),
    [anon_sym_extension] = ACTIONS(3531),
    [anon_sym___exported] = ACTIONS(3531),
    [anon_sym_import] = ACTIONS(3531),
  },
  [1048] = {
    [ts_builtin_sym_end] = ACTIONS(3599),
    [sym_identifier] = ACTIONS(3597),
    [aux_sym_preproc_include_token1] = ACTIONS(3597),
    [aux_sym_preproc_def_token1] = ACTIONS(3597),
    [aux_sym_preproc_if_token1] = ACTIONS(3597),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3597),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3597),
    [sym_preproc_directive] = ACTIONS(3597),
    [anon_sym_LPAREN2] = ACTIONS(3599),
    [anon_sym_BANG] = ACTIONS(3599),
    [anon_sym_TILDE] = ACTIONS(3599),
    [anon_sym_DASH] = ACTIONS(3597),
    [anon_sym_PLUS] = ACTIONS(3597),
    [anon_sym_STAR] = ACTIONS(3599),
    [anon_sym_AMP_AMP] = ACTIONS(3599),
    [anon_sym_AMP] = ACTIONS(3597),
    [anon_sym___extension__] = ACTIONS(3597),
    [anon_sym_typedef] = ACTIONS(3597),
    [anon_sym_in] = ACTIONS(3597),
    [anon_sym_out] = ACTIONS(3597),
    [anon_sym_inout] = ACTIONS(3597),
    [anon_sym_extern] = ACTIONS(3597),
    [anon_sym___attribute__] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3599),
    [anon_sym___declspec] = ACTIONS(3597),
    [anon_sym___based] = ACTIONS(3597),
    [anon_sym___cdecl] = ACTIONS(3597),
    [anon_sym___clrcall] = ACTIONS(3597),
    [anon_sym___stdcall] = ACTIONS(3597),
    [anon_sym___fastcall] = ACTIONS(3597),
    [anon_sym___thiscall] = ACTIONS(3597),
    [anon_sym___vectorcall] = ACTIONS(3597),
    [anon_sym_LBRACE] = ACTIONS(3599),
    [anon_sym_signed] = ACTIONS(3597),
    [anon_sym_unsigned] = ACTIONS(3597),
    [anon_sym_long] = ACTIONS(3597),
    [anon_sym_short] = ACTIONS(3597),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_static] = ACTIONS(3597),
    [anon_sym_register] = ACTIONS(3597),
    [anon_sym_inline] = ACTIONS(3597),
    [anon_sym___inline] = ACTIONS(3597),
    [anon_sym___inline__] = ACTIONS(3597),
    [anon_sym___forceinline] = ACTIONS(3597),
    [anon_sym_thread_local] = ACTIONS(3597),
    [anon_sym___thread] = ACTIONS(3597),
    [anon_sym_const] = ACTIONS(3597),
    [anon_sym_constexpr] = ACTIONS(3597),
    [anon_sym_volatile] = ACTIONS(3597),
    [anon_sym_restrict] = ACTIONS(3597),
    [anon_sym___restrict__] = ACTIONS(3597),
    [anon_sym__Atomic] = ACTIONS(3597),
    [anon_sym__Noreturn] = ACTIONS(3597),
    [anon_sym_noreturn] = ACTIONS(3597),
    [anon_sym_mutable] = ACTIONS(3597),
    [anon_sym_constinit] = ACTIONS(3597),
    [anon_sym_consteval] = ACTIONS(3597),
    [anon_sym_alignas] = ACTIONS(3597),
    [anon_sym__Alignas] = ACTIONS(3597),
    [sym_primitive_type] = ACTIONS(3597),
    [anon_sym_enum] = ACTIONS(3597),
    [anon_sym_class] = ACTIONS(3597),
    [anon_sym_struct] = ACTIONS(3597),
    [anon_sym_union] = ACTIONS(3597),
    [anon_sym_if] = ACTIONS(3597),
    [anon_sym_switch] = ACTIONS(3597),
    [anon_sym_case] = ACTIONS(3597),
    [anon_sym_default] = ACTIONS(3597),
    [anon_sym_while] = ACTIONS(3597),
    [anon_sym_do] = ACTIONS(3597),
    [anon_sym_for] = ACTIONS(3597),
    [anon_sym_return] = ACTIONS(3597),
    [anon_sym_break] = ACTIONS(3597),
    [anon_sym_continue] = ACTIONS(3597),
    [anon_sym_goto] = ACTIONS(3597),
    [anon_sym_not] = ACTIONS(3597),
    [anon_sym_compl] = ACTIONS(3597),
    [anon_sym_DASH_DASH] = ACTIONS(3599),
    [anon_sym_PLUS_PLUS] = ACTIONS(3599),
    [anon_sym_sizeof] = ACTIONS(3597),
    [anon_sym___alignof__] = ACTIONS(3597),
    [anon_sym___alignof] = ACTIONS(3597),
    [anon_sym__alignof] = ACTIONS(3597),
    [anon_sym_alignof] = ACTIONS(3597),
    [anon_sym__Alignof] = ACTIONS(3597),
    [anon_sym_offsetof] = ACTIONS(3597),
    [anon_sym__Generic] = ACTIONS(3597),
    [anon_sym_asm] = ACTIONS(3597),
    [anon_sym___asm__] = ACTIONS(3597),
    [sym_number_literal] = ACTIONS(3599),
    [anon_sym_L_SQUOTE] = ACTIONS(3599),
    [anon_sym_u_SQUOTE] = ACTIONS(3599),
    [anon_sym_U_SQUOTE] = ACTIONS(3599),
    [anon_sym_u8_SQUOTE] = ACTIONS(3599),
    [anon_sym_SQUOTE] = ACTIONS(3599),
    [anon_sym_L_DQUOTE] = ACTIONS(3599),
    [anon_sym_u_DQUOTE] = ACTIONS(3599),
    [anon_sym_U_DQUOTE] = ACTIONS(3599),
    [anon_sym_u8_DQUOTE] = ACTIONS(3599),
    [anon_sym_DQUOTE] = ACTIONS(3599),
    [sym_true] = ACTIONS(3597),
    [sym_false] = ACTIONS(3597),
    [anon_sym_NULL] = ACTIONS(3597),
    [anon_sym_nullptr] = ACTIONS(3597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3597),
    [anon_sym_let] = ACTIONS(3597),
    [anon_sym_This] = ACTIONS(3597),
    [anon_sym_decltype] = ACTIONS(3597),
    [sym_virtual] = ACTIONS(3597),
    [anon_sym_explicit] = ACTIONS(3597),
    [anon_sym_typename] = ACTIONS(3597),
    [anon_sym_template] = ACTIONS(3597),
    [anon_sym_operator] = ACTIONS(3597),
    [anon_sym_try] = ACTIONS(3597),
    [anon_sym_delete] = ACTIONS(3597),
    [anon_sym_throw] = ACTIONS(3597),
    [anon_sym_namespace] = ACTIONS(3597),
    [anon_sym_using] = ACTIONS(3597),
    [anon_sym_static_assert] = ACTIONS(3597),
    [anon_sym_concept] = ACTIONS(3597),
    [anon_sym_co_return] = ACTIONS(3597),
    [anon_sym_co_yield] = ACTIONS(3597),
    [anon_sym_R_DQUOTE] = ACTIONS(3599),
    [anon_sym_LR_DQUOTE] = ACTIONS(3599),
    [anon_sym_uR_DQUOTE] = ACTIONS(3599),
    [anon_sym_UR_DQUOTE] = ACTIONS(3599),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3599),
    [anon_sym_co_await] = ACTIONS(3597),
    [anon_sym_new] = ACTIONS(3597),
    [anon_sym_requires] = ACTIONS(3597),
    [sym_this] = ACTIONS(3597),
    [anon_sym_precise] = ACTIONS(3597),
    [anon_sym_shared] = ACTIONS(3597),
    [anon_sym_groupshared] = ACTIONS(3597),
    [anon_sym_uniform] = ACTIONS(3597),
    [anon_sym_row_major] = ACTIONS(3597),
    [anon_sym_column_major] = ACTIONS(3597),
    [anon_sym_globallycoherent] = ACTIONS(3597),
    [anon_sym_centroid] = ACTIONS(3597),
    [anon_sym_noperspective] = ACTIONS(3597),
    [anon_sym_nointerpolation] = ACTIONS(3597),
    [anon_sym_sample] = ACTIONS(3597),
    [anon_sym_linear] = ACTIONS(3597),
    [anon_sym_snorm] = ACTIONS(3597),
    [anon_sym_unorm] = ACTIONS(3597),
    [anon_sym_point] = ACTIONS(3597),
    [anon_sym_line] = ACTIONS(3597),
    [anon_sym_triangleadj] = ACTIONS(3597),
    [anon_sym_lineadj] = ACTIONS(3597),
    [anon_sym_triangle] = ACTIONS(3597),
    [anon_sym_interface] = ACTIONS(3597),
    [anon_sym_extension] = ACTIONS(3597),
    [anon_sym___exported] = ACTIONS(3597),
    [anon_sym_import] = ACTIONS(3597),
  },
  [1049] = {
    [ts_builtin_sym_end] = ACTIONS(3671),
    [sym_identifier] = ACTIONS(3669),
    [aux_sym_preproc_include_token1] = ACTIONS(3669),
    [aux_sym_preproc_def_token1] = ACTIONS(3669),
    [aux_sym_preproc_if_token1] = ACTIONS(3669),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3669),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3669),
    [sym_preproc_directive] = ACTIONS(3669),
    [anon_sym_LPAREN2] = ACTIONS(3671),
    [anon_sym_BANG] = ACTIONS(3671),
    [anon_sym_TILDE] = ACTIONS(3671),
    [anon_sym_DASH] = ACTIONS(3669),
    [anon_sym_PLUS] = ACTIONS(3669),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3671),
    [anon_sym_AMP] = ACTIONS(3669),
    [anon_sym___extension__] = ACTIONS(3669),
    [anon_sym_typedef] = ACTIONS(3669),
    [anon_sym_in] = ACTIONS(3669),
    [anon_sym_out] = ACTIONS(3669),
    [anon_sym_inout] = ACTIONS(3669),
    [anon_sym_extern] = ACTIONS(3669),
    [anon_sym___attribute__] = ACTIONS(3669),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3671),
    [anon_sym___declspec] = ACTIONS(3669),
    [anon_sym___based] = ACTIONS(3669),
    [anon_sym___cdecl] = ACTIONS(3669),
    [anon_sym___clrcall] = ACTIONS(3669),
    [anon_sym___stdcall] = ACTIONS(3669),
    [anon_sym___fastcall] = ACTIONS(3669),
    [anon_sym___thiscall] = ACTIONS(3669),
    [anon_sym___vectorcall] = ACTIONS(3669),
    [anon_sym_LBRACE] = ACTIONS(3671),
    [anon_sym_signed] = ACTIONS(3669),
    [anon_sym_unsigned] = ACTIONS(3669),
    [anon_sym_long] = ACTIONS(3669),
    [anon_sym_short] = ACTIONS(3669),
    [anon_sym_LBRACK] = ACTIONS(3669),
    [anon_sym_static] = ACTIONS(3669),
    [anon_sym_register] = ACTIONS(3669),
    [anon_sym_inline] = ACTIONS(3669),
    [anon_sym___inline] = ACTIONS(3669),
    [anon_sym___inline__] = ACTIONS(3669),
    [anon_sym___forceinline] = ACTIONS(3669),
    [anon_sym_thread_local] = ACTIONS(3669),
    [anon_sym___thread] = ACTIONS(3669),
    [anon_sym_const] = ACTIONS(3669),
    [anon_sym_constexpr] = ACTIONS(3669),
    [anon_sym_volatile] = ACTIONS(3669),
    [anon_sym_restrict] = ACTIONS(3669),
    [anon_sym___restrict__] = ACTIONS(3669),
    [anon_sym__Atomic] = ACTIONS(3669),
    [anon_sym__Noreturn] = ACTIONS(3669),
    [anon_sym_noreturn] = ACTIONS(3669),
    [anon_sym_mutable] = ACTIONS(3669),
    [anon_sym_constinit] = ACTIONS(3669),
    [anon_sym_consteval] = ACTIONS(3669),
    [anon_sym_alignas] = ACTIONS(3669),
    [anon_sym__Alignas] = ACTIONS(3669),
    [sym_primitive_type] = ACTIONS(3669),
    [anon_sym_enum] = ACTIONS(3669),
    [anon_sym_class] = ACTIONS(3669),
    [anon_sym_struct] = ACTIONS(3669),
    [anon_sym_union] = ACTIONS(3669),
    [anon_sym_if] = ACTIONS(3669),
    [anon_sym_switch] = ACTIONS(3669),
    [anon_sym_case] = ACTIONS(3669),
    [anon_sym_default] = ACTIONS(3669),
    [anon_sym_while] = ACTIONS(3669),
    [anon_sym_do] = ACTIONS(3669),
    [anon_sym_for] = ACTIONS(3669),
    [anon_sym_return] = ACTIONS(3669),
    [anon_sym_break] = ACTIONS(3669),
    [anon_sym_continue] = ACTIONS(3669),
    [anon_sym_goto] = ACTIONS(3669),
    [anon_sym_not] = ACTIONS(3669),
    [anon_sym_compl] = ACTIONS(3669),
    [anon_sym_DASH_DASH] = ACTIONS(3671),
    [anon_sym_PLUS_PLUS] = ACTIONS(3671),
    [anon_sym_sizeof] = ACTIONS(3669),
    [anon_sym___alignof__] = ACTIONS(3669),
    [anon_sym___alignof] = ACTIONS(3669),
    [anon_sym__alignof] = ACTIONS(3669),
    [anon_sym_alignof] = ACTIONS(3669),
    [anon_sym__Alignof] = ACTIONS(3669),
    [anon_sym_offsetof] = ACTIONS(3669),
    [anon_sym__Generic] = ACTIONS(3669),
    [anon_sym_asm] = ACTIONS(3669),
    [anon_sym___asm__] = ACTIONS(3669),
    [sym_number_literal] = ACTIONS(3671),
    [anon_sym_L_SQUOTE] = ACTIONS(3671),
    [anon_sym_u_SQUOTE] = ACTIONS(3671),
    [anon_sym_U_SQUOTE] = ACTIONS(3671),
    [anon_sym_u8_SQUOTE] = ACTIONS(3671),
    [anon_sym_SQUOTE] = ACTIONS(3671),
    [anon_sym_L_DQUOTE] = ACTIONS(3671),
    [anon_sym_u_DQUOTE] = ACTIONS(3671),
    [anon_sym_U_DQUOTE] = ACTIONS(3671),
    [anon_sym_u8_DQUOTE] = ACTIONS(3671),
    [anon_sym_DQUOTE] = ACTIONS(3671),
    [sym_true] = ACTIONS(3669),
    [sym_false] = ACTIONS(3669),
    [anon_sym_NULL] = ACTIONS(3669),
    [anon_sym_nullptr] = ACTIONS(3669),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3669),
    [anon_sym_let] = ACTIONS(3669),
    [anon_sym_This] = ACTIONS(3669),
    [anon_sym_decltype] = ACTIONS(3669),
    [sym_virtual] = ACTIONS(3669),
    [anon_sym_explicit] = ACTIONS(3669),
    [anon_sym_typename] = ACTIONS(3669),
    [anon_sym_template] = ACTIONS(3669),
    [anon_sym_operator] = ACTIONS(3669),
    [anon_sym_try] = ACTIONS(3669),
    [anon_sym_delete] = ACTIONS(3669),
    [anon_sym_throw] = ACTIONS(3669),
    [anon_sym_namespace] = ACTIONS(3669),
    [anon_sym_using] = ACTIONS(3669),
    [anon_sym_static_assert] = ACTIONS(3669),
    [anon_sym_concept] = ACTIONS(3669),
    [anon_sym_co_return] = ACTIONS(3669),
    [anon_sym_co_yield] = ACTIONS(3669),
    [anon_sym_R_DQUOTE] = ACTIONS(3671),
    [anon_sym_LR_DQUOTE] = ACTIONS(3671),
    [anon_sym_uR_DQUOTE] = ACTIONS(3671),
    [anon_sym_UR_DQUOTE] = ACTIONS(3671),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3671),
    [anon_sym_co_await] = ACTIONS(3669),
    [anon_sym_new] = ACTIONS(3669),
    [anon_sym_requires] = ACTIONS(3669),
    [sym_this] = ACTIONS(3669),
    [anon_sym_precise] = ACTIONS(3669),
    [anon_sym_shared] = ACTIONS(3669),
    [anon_sym_groupshared] = ACTIONS(3669),
    [anon_sym_uniform] = ACTIONS(3669),
    [anon_sym_row_major] = ACTIONS(3669),
    [anon_sym_column_major] = ACTIONS(3669),
    [anon_sym_globallycoherent] = ACTIONS(3669),
    [anon_sym_centroid] = ACTIONS(3669),
    [anon_sym_noperspective] = ACTIONS(3669),
    [anon_sym_nointerpolation] = ACTIONS(3669),
    [anon_sym_sample] = ACTIONS(3669),
    [anon_sym_linear] = ACTIONS(3669),
    [anon_sym_snorm] = ACTIONS(3669),
    [anon_sym_unorm] = ACTIONS(3669),
    [anon_sym_point] = ACTIONS(3669),
    [anon_sym_line] = ACTIONS(3669),
    [anon_sym_triangleadj] = ACTIONS(3669),
    [anon_sym_lineadj] = ACTIONS(3669),
    [anon_sym_triangle] = ACTIONS(3669),
    [anon_sym_interface] = ACTIONS(3669),
    [anon_sym_extension] = ACTIONS(3669),
    [anon_sym___exported] = ACTIONS(3669),
    [anon_sym_import] = ACTIONS(3669),
  },
  [1050] = {
    [ts_builtin_sym_end] = ACTIONS(3412),
    [sym_identifier] = ACTIONS(3410),
    [aux_sym_preproc_include_token1] = ACTIONS(3410),
    [aux_sym_preproc_def_token1] = ACTIONS(3410),
    [aux_sym_preproc_if_token1] = ACTIONS(3410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3410),
    [sym_preproc_directive] = ACTIONS(3410),
    [anon_sym_LPAREN2] = ACTIONS(3412),
    [anon_sym_BANG] = ACTIONS(3412),
    [anon_sym_TILDE] = ACTIONS(3412),
    [anon_sym_DASH] = ACTIONS(3410),
    [anon_sym_PLUS] = ACTIONS(3410),
    [anon_sym_STAR] = ACTIONS(3412),
    [anon_sym_AMP_AMP] = ACTIONS(3412),
    [anon_sym_AMP] = ACTIONS(3410),
    [anon_sym___extension__] = ACTIONS(3410),
    [anon_sym_typedef] = ACTIONS(3410),
    [anon_sym_in] = ACTIONS(3410),
    [anon_sym_out] = ACTIONS(3410),
    [anon_sym_inout] = ACTIONS(3410),
    [anon_sym_extern] = ACTIONS(3410),
    [anon_sym___attribute__] = ACTIONS(3410),
    [anon_sym_COLON_COLON] = ACTIONS(3412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3412),
    [anon_sym___declspec] = ACTIONS(3410),
    [anon_sym___based] = ACTIONS(3410),
    [anon_sym___cdecl] = ACTIONS(3410),
    [anon_sym___clrcall] = ACTIONS(3410),
    [anon_sym___stdcall] = ACTIONS(3410),
    [anon_sym___fastcall] = ACTIONS(3410),
    [anon_sym___thiscall] = ACTIONS(3410),
    [anon_sym___vectorcall] = ACTIONS(3410),
    [anon_sym_LBRACE] = ACTIONS(3412),
    [anon_sym_signed] = ACTIONS(3410),
    [anon_sym_unsigned] = ACTIONS(3410),
    [anon_sym_long] = ACTIONS(3410),
    [anon_sym_short] = ACTIONS(3410),
    [anon_sym_LBRACK] = ACTIONS(3410),
    [anon_sym_static] = ACTIONS(3410),
    [anon_sym_register] = ACTIONS(3410),
    [anon_sym_inline] = ACTIONS(3410),
    [anon_sym___inline] = ACTIONS(3410),
    [anon_sym___inline__] = ACTIONS(3410),
    [anon_sym___forceinline] = ACTIONS(3410),
    [anon_sym_thread_local] = ACTIONS(3410),
    [anon_sym___thread] = ACTIONS(3410),
    [anon_sym_const] = ACTIONS(3410),
    [anon_sym_constexpr] = ACTIONS(3410),
    [anon_sym_volatile] = ACTIONS(3410),
    [anon_sym_restrict] = ACTIONS(3410),
    [anon_sym___restrict__] = ACTIONS(3410),
    [anon_sym__Atomic] = ACTIONS(3410),
    [anon_sym__Noreturn] = ACTIONS(3410),
    [anon_sym_noreturn] = ACTIONS(3410),
    [anon_sym_mutable] = ACTIONS(3410),
    [anon_sym_constinit] = ACTIONS(3410),
    [anon_sym_consteval] = ACTIONS(3410),
    [anon_sym_alignas] = ACTIONS(3410),
    [anon_sym__Alignas] = ACTIONS(3410),
    [sym_primitive_type] = ACTIONS(3410),
    [anon_sym_enum] = ACTIONS(3410),
    [anon_sym_class] = ACTIONS(3410),
    [anon_sym_struct] = ACTIONS(3410),
    [anon_sym_union] = ACTIONS(3410),
    [anon_sym_if] = ACTIONS(3410),
    [anon_sym_switch] = ACTIONS(3410),
    [anon_sym_case] = ACTIONS(3410),
    [anon_sym_default] = ACTIONS(3410),
    [anon_sym_while] = ACTIONS(3410),
    [anon_sym_do] = ACTIONS(3410),
    [anon_sym_for] = ACTIONS(3410),
    [anon_sym_return] = ACTIONS(3410),
    [anon_sym_break] = ACTIONS(3410),
    [anon_sym_continue] = ACTIONS(3410),
    [anon_sym_goto] = ACTIONS(3410),
    [anon_sym_not] = ACTIONS(3410),
    [anon_sym_compl] = ACTIONS(3410),
    [anon_sym_DASH_DASH] = ACTIONS(3412),
    [anon_sym_PLUS_PLUS] = ACTIONS(3412),
    [anon_sym_sizeof] = ACTIONS(3410),
    [anon_sym___alignof__] = ACTIONS(3410),
    [anon_sym___alignof] = ACTIONS(3410),
    [anon_sym__alignof] = ACTIONS(3410),
    [anon_sym_alignof] = ACTIONS(3410),
    [anon_sym__Alignof] = ACTIONS(3410),
    [anon_sym_offsetof] = ACTIONS(3410),
    [anon_sym__Generic] = ACTIONS(3410),
    [anon_sym_asm] = ACTIONS(3410),
    [anon_sym___asm__] = ACTIONS(3410),
    [sym_number_literal] = ACTIONS(3412),
    [anon_sym_L_SQUOTE] = ACTIONS(3412),
    [anon_sym_u_SQUOTE] = ACTIONS(3412),
    [anon_sym_U_SQUOTE] = ACTIONS(3412),
    [anon_sym_u8_SQUOTE] = ACTIONS(3412),
    [anon_sym_SQUOTE] = ACTIONS(3412),
    [anon_sym_L_DQUOTE] = ACTIONS(3412),
    [anon_sym_u_DQUOTE] = ACTIONS(3412),
    [anon_sym_U_DQUOTE] = ACTIONS(3412),
    [anon_sym_u8_DQUOTE] = ACTIONS(3412),
    [anon_sym_DQUOTE] = ACTIONS(3412),
    [sym_true] = ACTIONS(3410),
    [sym_false] = ACTIONS(3410),
    [anon_sym_NULL] = ACTIONS(3410),
    [anon_sym_nullptr] = ACTIONS(3410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3410),
    [anon_sym_let] = ACTIONS(3410),
    [anon_sym_This] = ACTIONS(3410),
    [anon_sym_decltype] = ACTIONS(3410),
    [sym_virtual] = ACTIONS(3410),
    [anon_sym_explicit] = ACTIONS(3410),
    [anon_sym_typename] = ACTIONS(3410),
    [anon_sym_template] = ACTIONS(3410),
    [anon_sym_operator] = ACTIONS(3410),
    [anon_sym_try] = ACTIONS(3410),
    [anon_sym_delete] = ACTIONS(3410),
    [anon_sym_throw] = ACTIONS(3410),
    [anon_sym_namespace] = ACTIONS(3410),
    [anon_sym_using] = ACTIONS(3410),
    [anon_sym_static_assert] = ACTIONS(3410),
    [anon_sym_concept] = ACTIONS(3410),
    [anon_sym_co_return] = ACTIONS(3410),
    [anon_sym_co_yield] = ACTIONS(3410),
    [anon_sym_R_DQUOTE] = ACTIONS(3412),
    [anon_sym_LR_DQUOTE] = ACTIONS(3412),
    [anon_sym_uR_DQUOTE] = ACTIONS(3412),
    [anon_sym_UR_DQUOTE] = ACTIONS(3412),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3412),
    [anon_sym_co_await] = ACTIONS(3410),
    [anon_sym_new] = ACTIONS(3410),
    [anon_sym_requires] = ACTIONS(3410),
    [sym_this] = ACTIONS(3410),
    [anon_sym_precise] = ACTIONS(3410),
    [anon_sym_shared] = ACTIONS(3410),
    [anon_sym_groupshared] = ACTIONS(3410),
    [anon_sym_uniform] = ACTIONS(3410),
    [anon_sym_row_major] = ACTIONS(3410),
    [anon_sym_column_major] = ACTIONS(3410),
    [anon_sym_globallycoherent] = ACTIONS(3410),
    [anon_sym_centroid] = ACTIONS(3410),
    [anon_sym_noperspective] = ACTIONS(3410),
    [anon_sym_nointerpolation] = ACTIONS(3410),
    [anon_sym_sample] = ACTIONS(3410),
    [anon_sym_linear] = ACTIONS(3410),
    [anon_sym_snorm] = ACTIONS(3410),
    [anon_sym_unorm] = ACTIONS(3410),
    [anon_sym_point] = ACTIONS(3410),
    [anon_sym_line] = ACTIONS(3410),
    [anon_sym_triangleadj] = ACTIONS(3410),
    [anon_sym_lineadj] = ACTIONS(3410),
    [anon_sym_triangle] = ACTIONS(3410),
    [anon_sym_interface] = ACTIONS(3410),
    [anon_sym_extension] = ACTIONS(3410),
    [anon_sym___exported] = ACTIONS(3410),
    [anon_sym_import] = ACTIONS(3410),
  },
  [1051] = {
    [ts_builtin_sym_end] = ACTIONS(3615),
    [sym_identifier] = ACTIONS(3613),
    [aux_sym_preproc_include_token1] = ACTIONS(3613),
    [aux_sym_preproc_def_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3613),
    [sym_preproc_directive] = ACTIONS(3613),
    [anon_sym_LPAREN2] = ACTIONS(3615),
    [anon_sym_BANG] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3613),
    [anon_sym_PLUS] = ACTIONS(3613),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym___extension__] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3613),
    [anon_sym_in] = ACTIONS(3613),
    [anon_sym_out] = ACTIONS(3613),
    [anon_sym_inout] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym___attribute__] = ACTIONS(3613),
    [anon_sym_COLON_COLON] = ACTIONS(3615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3615),
    [anon_sym___declspec] = ACTIONS(3613),
    [anon_sym___based] = ACTIONS(3613),
    [anon_sym___cdecl] = ACTIONS(3613),
    [anon_sym___clrcall] = ACTIONS(3613),
    [anon_sym___stdcall] = ACTIONS(3613),
    [anon_sym___fastcall] = ACTIONS(3613),
    [anon_sym___thiscall] = ACTIONS(3613),
    [anon_sym___vectorcall] = ACTIONS(3613),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_signed] = ACTIONS(3613),
    [anon_sym_unsigned] = ACTIONS(3613),
    [anon_sym_long] = ACTIONS(3613),
    [anon_sym_short] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_register] = ACTIONS(3613),
    [anon_sym_inline] = ACTIONS(3613),
    [anon_sym___inline] = ACTIONS(3613),
    [anon_sym___inline__] = ACTIONS(3613),
    [anon_sym___forceinline] = ACTIONS(3613),
    [anon_sym_thread_local] = ACTIONS(3613),
    [anon_sym___thread] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_constexpr] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_restrict] = ACTIONS(3613),
    [anon_sym___restrict__] = ACTIONS(3613),
    [anon_sym__Atomic] = ACTIONS(3613),
    [anon_sym__Noreturn] = ACTIONS(3613),
    [anon_sym_noreturn] = ACTIONS(3613),
    [anon_sym_mutable] = ACTIONS(3613),
    [anon_sym_constinit] = ACTIONS(3613),
    [anon_sym_consteval] = ACTIONS(3613),
    [anon_sym_alignas] = ACTIONS(3613),
    [anon_sym__Alignas] = ACTIONS(3613),
    [sym_primitive_type] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_union] = ACTIONS(3613),
    [anon_sym_if] = ACTIONS(3613),
    [anon_sym_switch] = ACTIONS(3613),
    [anon_sym_case] = ACTIONS(3613),
    [anon_sym_default] = ACTIONS(3613),
    [anon_sym_while] = ACTIONS(3613),
    [anon_sym_do] = ACTIONS(3613),
    [anon_sym_for] = ACTIONS(3613),
    [anon_sym_return] = ACTIONS(3613),
    [anon_sym_break] = ACTIONS(3613),
    [anon_sym_continue] = ACTIONS(3613),
    [anon_sym_goto] = ACTIONS(3613),
    [anon_sym_not] = ACTIONS(3613),
    [anon_sym_compl] = ACTIONS(3613),
    [anon_sym_DASH_DASH] = ACTIONS(3615),
    [anon_sym_PLUS_PLUS] = ACTIONS(3615),
    [anon_sym_sizeof] = ACTIONS(3613),
    [anon_sym___alignof__] = ACTIONS(3613),
    [anon_sym___alignof] = ACTIONS(3613),
    [anon_sym__alignof] = ACTIONS(3613),
    [anon_sym_alignof] = ACTIONS(3613),
    [anon_sym__Alignof] = ACTIONS(3613),
    [anon_sym_offsetof] = ACTIONS(3613),
    [anon_sym__Generic] = ACTIONS(3613),
    [anon_sym_asm] = ACTIONS(3613),
    [anon_sym___asm__] = ACTIONS(3613),
    [sym_number_literal] = ACTIONS(3615),
    [anon_sym_L_SQUOTE] = ACTIONS(3615),
    [anon_sym_u_SQUOTE] = ACTIONS(3615),
    [anon_sym_U_SQUOTE] = ACTIONS(3615),
    [anon_sym_u8_SQUOTE] = ACTIONS(3615),
    [anon_sym_SQUOTE] = ACTIONS(3615),
    [anon_sym_L_DQUOTE] = ACTIONS(3615),
    [anon_sym_u_DQUOTE] = ACTIONS(3615),
    [anon_sym_U_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8_DQUOTE] = ACTIONS(3615),
    [anon_sym_DQUOTE] = ACTIONS(3615),
    [sym_true] = ACTIONS(3613),
    [sym_false] = ACTIONS(3613),
    [anon_sym_NULL] = ACTIONS(3613),
    [anon_sym_nullptr] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_This] = ACTIONS(3613),
    [anon_sym_decltype] = ACTIONS(3613),
    [sym_virtual] = ACTIONS(3613),
    [anon_sym_explicit] = ACTIONS(3613),
    [anon_sym_typename] = ACTIONS(3613),
    [anon_sym_template] = ACTIONS(3613),
    [anon_sym_operator] = ACTIONS(3613),
    [anon_sym_try] = ACTIONS(3613),
    [anon_sym_delete] = ACTIONS(3613),
    [anon_sym_throw] = ACTIONS(3613),
    [anon_sym_namespace] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_static_assert] = ACTIONS(3613),
    [anon_sym_concept] = ACTIONS(3613),
    [anon_sym_co_return] = ACTIONS(3613),
    [anon_sym_co_yield] = ACTIONS(3613),
    [anon_sym_R_DQUOTE] = ACTIONS(3615),
    [anon_sym_LR_DQUOTE] = ACTIONS(3615),
    [anon_sym_uR_DQUOTE] = ACTIONS(3615),
    [anon_sym_UR_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3615),
    [anon_sym_co_await] = ACTIONS(3613),
    [anon_sym_new] = ACTIONS(3613),
    [anon_sym_requires] = ACTIONS(3613),
    [sym_this] = ACTIONS(3613),
    [anon_sym_precise] = ACTIONS(3613),
    [anon_sym_shared] = ACTIONS(3613),
    [anon_sym_groupshared] = ACTIONS(3613),
    [anon_sym_uniform] = ACTIONS(3613),
    [anon_sym_row_major] = ACTIONS(3613),
    [anon_sym_column_major] = ACTIONS(3613),
    [anon_sym_globallycoherent] = ACTIONS(3613),
    [anon_sym_centroid] = ACTIONS(3613),
    [anon_sym_noperspective] = ACTIONS(3613),
    [anon_sym_nointerpolation] = ACTIONS(3613),
    [anon_sym_sample] = ACTIONS(3613),
    [anon_sym_linear] = ACTIONS(3613),
    [anon_sym_snorm] = ACTIONS(3613),
    [anon_sym_unorm] = ACTIONS(3613),
    [anon_sym_point] = ACTIONS(3613),
    [anon_sym_line] = ACTIONS(3613),
    [anon_sym_triangleadj] = ACTIONS(3613),
    [anon_sym_lineadj] = ACTIONS(3613),
    [anon_sym_triangle] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_extension] = ACTIONS(3613),
    [anon_sym___exported] = ACTIONS(3613),
    [anon_sym_import] = ACTIONS(3613),
  },
  [1052] = {
    [ts_builtin_sym_end] = ACTIONS(3412),
    [sym_identifier] = ACTIONS(3410),
    [aux_sym_preproc_include_token1] = ACTIONS(3410),
    [aux_sym_preproc_def_token1] = ACTIONS(3410),
    [aux_sym_preproc_if_token1] = ACTIONS(3410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3410),
    [sym_preproc_directive] = ACTIONS(3410),
    [anon_sym_LPAREN2] = ACTIONS(3412),
    [anon_sym_BANG] = ACTIONS(3412),
    [anon_sym_TILDE] = ACTIONS(3412),
    [anon_sym_DASH] = ACTIONS(3410),
    [anon_sym_PLUS] = ACTIONS(3410),
    [anon_sym_STAR] = ACTIONS(3412),
    [anon_sym_AMP_AMP] = ACTIONS(3412),
    [anon_sym_AMP] = ACTIONS(3410),
    [anon_sym___extension__] = ACTIONS(3410),
    [anon_sym_typedef] = ACTIONS(3410),
    [anon_sym_in] = ACTIONS(3410),
    [anon_sym_out] = ACTIONS(3410),
    [anon_sym_inout] = ACTIONS(3410),
    [anon_sym_extern] = ACTIONS(3410),
    [anon_sym___attribute__] = ACTIONS(3410),
    [anon_sym_COLON_COLON] = ACTIONS(3412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3412),
    [anon_sym___declspec] = ACTIONS(3410),
    [anon_sym___based] = ACTIONS(3410),
    [anon_sym___cdecl] = ACTIONS(3410),
    [anon_sym___clrcall] = ACTIONS(3410),
    [anon_sym___stdcall] = ACTIONS(3410),
    [anon_sym___fastcall] = ACTIONS(3410),
    [anon_sym___thiscall] = ACTIONS(3410),
    [anon_sym___vectorcall] = ACTIONS(3410),
    [anon_sym_LBRACE] = ACTIONS(3412),
    [anon_sym_signed] = ACTIONS(3410),
    [anon_sym_unsigned] = ACTIONS(3410),
    [anon_sym_long] = ACTIONS(3410),
    [anon_sym_short] = ACTIONS(3410),
    [anon_sym_LBRACK] = ACTIONS(3410),
    [anon_sym_static] = ACTIONS(3410),
    [anon_sym_register] = ACTIONS(3410),
    [anon_sym_inline] = ACTIONS(3410),
    [anon_sym___inline] = ACTIONS(3410),
    [anon_sym___inline__] = ACTIONS(3410),
    [anon_sym___forceinline] = ACTIONS(3410),
    [anon_sym_thread_local] = ACTIONS(3410),
    [anon_sym___thread] = ACTIONS(3410),
    [anon_sym_const] = ACTIONS(3410),
    [anon_sym_constexpr] = ACTIONS(3410),
    [anon_sym_volatile] = ACTIONS(3410),
    [anon_sym_restrict] = ACTIONS(3410),
    [anon_sym___restrict__] = ACTIONS(3410),
    [anon_sym__Atomic] = ACTIONS(3410),
    [anon_sym__Noreturn] = ACTIONS(3410),
    [anon_sym_noreturn] = ACTIONS(3410),
    [anon_sym_mutable] = ACTIONS(3410),
    [anon_sym_constinit] = ACTIONS(3410),
    [anon_sym_consteval] = ACTIONS(3410),
    [anon_sym_alignas] = ACTIONS(3410),
    [anon_sym__Alignas] = ACTIONS(3410),
    [sym_primitive_type] = ACTIONS(3410),
    [anon_sym_enum] = ACTIONS(3410),
    [anon_sym_class] = ACTIONS(3410),
    [anon_sym_struct] = ACTIONS(3410),
    [anon_sym_union] = ACTIONS(3410),
    [anon_sym_if] = ACTIONS(3410),
    [anon_sym_switch] = ACTIONS(3410),
    [anon_sym_case] = ACTIONS(3410),
    [anon_sym_default] = ACTIONS(3410),
    [anon_sym_while] = ACTIONS(3410),
    [anon_sym_do] = ACTIONS(3410),
    [anon_sym_for] = ACTIONS(3410),
    [anon_sym_return] = ACTIONS(3410),
    [anon_sym_break] = ACTIONS(3410),
    [anon_sym_continue] = ACTIONS(3410),
    [anon_sym_goto] = ACTIONS(3410),
    [anon_sym_not] = ACTIONS(3410),
    [anon_sym_compl] = ACTIONS(3410),
    [anon_sym_DASH_DASH] = ACTIONS(3412),
    [anon_sym_PLUS_PLUS] = ACTIONS(3412),
    [anon_sym_sizeof] = ACTIONS(3410),
    [anon_sym___alignof__] = ACTIONS(3410),
    [anon_sym___alignof] = ACTIONS(3410),
    [anon_sym__alignof] = ACTIONS(3410),
    [anon_sym_alignof] = ACTIONS(3410),
    [anon_sym__Alignof] = ACTIONS(3410),
    [anon_sym_offsetof] = ACTIONS(3410),
    [anon_sym__Generic] = ACTIONS(3410),
    [anon_sym_asm] = ACTIONS(3410),
    [anon_sym___asm__] = ACTIONS(3410),
    [sym_number_literal] = ACTIONS(3412),
    [anon_sym_L_SQUOTE] = ACTIONS(3412),
    [anon_sym_u_SQUOTE] = ACTIONS(3412),
    [anon_sym_U_SQUOTE] = ACTIONS(3412),
    [anon_sym_u8_SQUOTE] = ACTIONS(3412),
    [anon_sym_SQUOTE] = ACTIONS(3412),
    [anon_sym_L_DQUOTE] = ACTIONS(3412),
    [anon_sym_u_DQUOTE] = ACTIONS(3412),
    [anon_sym_U_DQUOTE] = ACTIONS(3412),
    [anon_sym_u8_DQUOTE] = ACTIONS(3412),
    [anon_sym_DQUOTE] = ACTIONS(3412),
    [sym_true] = ACTIONS(3410),
    [sym_false] = ACTIONS(3410),
    [anon_sym_NULL] = ACTIONS(3410),
    [anon_sym_nullptr] = ACTIONS(3410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3410),
    [anon_sym_let] = ACTIONS(3410),
    [anon_sym_This] = ACTIONS(3410),
    [anon_sym_decltype] = ACTIONS(3410),
    [sym_virtual] = ACTIONS(3410),
    [anon_sym_explicit] = ACTIONS(3410),
    [anon_sym_typename] = ACTIONS(3410),
    [anon_sym_template] = ACTIONS(3410),
    [anon_sym_operator] = ACTIONS(3410),
    [anon_sym_try] = ACTIONS(3410),
    [anon_sym_delete] = ACTIONS(3410),
    [anon_sym_throw] = ACTIONS(3410),
    [anon_sym_namespace] = ACTIONS(3410),
    [anon_sym_using] = ACTIONS(3410),
    [anon_sym_static_assert] = ACTIONS(3410),
    [anon_sym_concept] = ACTIONS(3410),
    [anon_sym_co_return] = ACTIONS(3410),
    [anon_sym_co_yield] = ACTIONS(3410),
    [anon_sym_R_DQUOTE] = ACTIONS(3412),
    [anon_sym_LR_DQUOTE] = ACTIONS(3412),
    [anon_sym_uR_DQUOTE] = ACTIONS(3412),
    [anon_sym_UR_DQUOTE] = ACTIONS(3412),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3412),
    [anon_sym_co_await] = ACTIONS(3410),
    [anon_sym_new] = ACTIONS(3410),
    [anon_sym_requires] = ACTIONS(3410),
    [sym_this] = ACTIONS(3410),
    [anon_sym_precise] = ACTIONS(3410),
    [anon_sym_shared] = ACTIONS(3410),
    [anon_sym_groupshared] = ACTIONS(3410),
    [anon_sym_uniform] = ACTIONS(3410),
    [anon_sym_row_major] = ACTIONS(3410),
    [anon_sym_column_major] = ACTIONS(3410),
    [anon_sym_globallycoherent] = ACTIONS(3410),
    [anon_sym_centroid] = ACTIONS(3410),
    [anon_sym_noperspective] = ACTIONS(3410),
    [anon_sym_nointerpolation] = ACTIONS(3410),
    [anon_sym_sample] = ACTIONS(3410),
    [anon_sym_linear] = ACTIONS(3410),
    [anon_sym_snorm] = ACTIONS(3410),
    [anon_sym_unorm] = ACTIONS(3410),
    [anon_sym_point] = ACTIONS(3410),
    [anon_sym_line] = ACTIONS(3410),
    [anon_sym_triangleadj] = ACTIONS(3410),
    [anon_sym_lineadj] = ACTIONS(3410),
    [anon_sym_triangle] = ACTIONS(3410),
    [anon_sym_interface] = ACTIONS(3410),
    [anon_sym_extension] = ACTIONS(3410),
    [anon_sym___exported] = ACTIONS(3410),
    [anon_sym_import] = ACTIONS(3410),
  },
  [1053] = {
    [ts_builtin_sym_end] = ACTIONS(3569),
    [sym_identifier] = ACTIONS(3567),
    [aux_sym_preproc_include_token1] = ACTIONS(3567),
    [aux_sym_preproc_def_token1] = ACTIONS(3567),
    [aux_sym_preproc_if_token1] = ACTIONS(3567),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3567),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3567),
    [sym_preproc_directive] = ACTIONS(3567),
    [anon_sym_LPAREN2] = ACTIONS(3569),
    [anon_sym_BANG] = ACTIONS(3569),
    [anon_sym_TILDE] = ACTIONS(3569),
    [anon_sym_DASH] = ACTIONS(3567),
    [anon_sym_PLUS] = ACTIONS(3567),
    [anon_sym_STAR] = ACTIONS(3569),
    [anon_sym_AMP_AMP] = ACTIONS(3569),
    [anon_sym_AMP] = ACTIONS(3567),
    [anon_sym___extension__] = ACTIONS(3567),
    [anon_sym_typedef] = ACTIONS(3567),
    [anon_sym_in] = ACTIONS(3567),
    [anon_sym_out] = ACTIONS(3567),
    [anon_sym_inout] = ACTIONS(3567),
    [anon_sym_extern] = ACTIONS(3567),
    [anon_sym___attribute__] = ACTIONS(3567),
    [anon_sym_COLON_COLON] = ACTIONS(3569),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3569),
    [anon_sym___declspec] = ACTIONS(3567),
    [anon_sym___based] = ACTIONS(3567),
    [anon_sym___cdecl] = ACTIONS(3567),
    [anon_sym___clrcall] = ACTIONS(3567),
    [anon_sym___stdcall] = ACTIONS(3567),
    [anon_sym___fastcall] = ACTIONS(3567),
    [anon_sym___thiscall] = ACTIONS(3567),
    [anon_sym___vectorcall] = ACTIONS(3567),
    [anon_sym_LBRACE] = ACTIONS(3569),
    [anon_sym_signed] = ACTIONS(3567),
    [anon_sym_unsigned] = ACTIONS(3567),
    [anon_sym_long] = ACTIONS(3567),
    [anon_sym_short] = ACTIONS(3567),
    [anon_sym_LBRACK] = ACTIONS(3567),
    [anon_sym_static] = ACTIONS(3567),
    [anon_sym_register] = ACTIONS(3567),
    [anon_sym_inline] = ACTIONS(3567),
    [anon_sym___inline] = ACTIONS(3567),
    [anon_sym___inline__] = ACTIONS(3567),
    [anon_sym___forceinline] = ACTIONS(3567),
    [anon_sym_thread_local] = ACTIONS(3567),
    [anon_sym___thread] = ACTIONS(3567),
    [anon_sym_const] = ACTIONS(3567),
    [anon_sym_constexpr] = ACTIONS(3567),
    [anon_sym_volatile] = ACTIONS(3567),
    [anon_sym_restrict] = ACTIONS(3567),
    [anon_sym___restrict__] = ACTIONS(3567),
    [anon_sym__Atomic] = ACTIONS(3567),
    [anon_sym__Noreturn] = ACTIONS(3567),
    [anon_sym_noreturn] = ACTIONS(3567),
    [anon_sym_mutable] = ACTIONS(3567),
    [anon_sym_constinit] = ACTIONS(3567),
    [anon_sym_consteval] = ACTIONS(3567),
    [anon_sym_alignas] = ACTIONS(3567),
    [anon_sym__Alignas] = ACTIONS(3567),
    [sym_primitive_type] = ACTIONS(3567),
    [anon_sym_enum] = ACTIONS(3567),
    [anon_sym_class] = ACTIONS(3567),
    [anon_sym_struct] = ACTIONS(3567),
    [anon_sym_union] = ACTIONS(3567),
    [anon_sym_if] = ACTIONS(3567),
    [anon_sym_switch] = ACTIONS(3567),
    [anon_sym_case] = ACTIONS(3567),
    [anon_sym_default] = ACTIONS(3567),
    [anon_sym_while] = ACTIONS(3567),
    [anon_sym_do] = ACTIONS(3567),
    [anon_sym_for] = ACTIONS(3567),
    [anon_sym_return] = ACTIONS(3567),
    [anon_sym_break] = ACTIONS(3567),
    [anon_sym_continue] = ACTIONS(3567),
    [anon_sym_goto] = ACTIONS(3567),
    [anon_sym_not] = ACTIONS(3567),
    [anon_sym_compl] = ACTIONS(3567),
    [anon_sym_DASH_DASH] = ACTIONS(3569),
    [anon_sym_PLUS_PLUS] = ACTIONS(3569),
    [anon_sym_sizeof] = ACTIONS(3567),
    [anon_sym___alignof__] = ACTIONS(3567),
    [anon_sym___alignof] = ACTIONS(3567),
    [anon_sym__alignof] = ACTIONS(3567),
    [anon_sym_alignof] = ACTIONS(3567),
    [anon_sym__Alignof] = ACTIONS(3567),
    [anon_sym_offsetof] = ACTIONS(3567),
    [anon_sym__Generic] = ACTIONS(3567),
    [anon_sym_asm] = ACTIONS(3567),
    [anon_sym___asm__] = ACTIONS(3567),
    [sym_number_literal] = ACTIONS(3569),
    [anon_sym_L_SQUOTE] = ACTIONS(3569),
    [anon_sym_u_SQUOTE] = ACTIONS(3569),
    [anon_sym_U_SQUOTE] = ACTIONS(3569),
    [anon_sym_u8_SQUOTE] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(3569),
    [anon_sym_L_DQUOTE] = ACTIONS(3569),
    [anon_sym_u_DQUOTE] = ACTIONS(3569),
    [anon_sym_U_DQUOTE] = ACTIONS(3569),
    [anon_sym_u8_DQUOTE] = ACTIONS(3569),
    [anon_sym_DQUOTE] = ACTIONS(3569),
    [sym_true] = ACTIONS(3567),
    [sym_false] = ACTIONS(3567),
    [anon_sym_NULL] = ACTIONS(3567),
    [anon_sym_nullptr] = ACTIONS(3567),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3567),
    [anon_sym_let] = ACTIONS(3567),
    [anon_sym_This] = ACTIONS(3567),
    [anon_sym_decltype] = ACTIONS(3567),
    [sym_virtual] = ACTIONS(3567),
    [anon_sym_explicit] = ACTIONS(3567),
    [anon_sym_typename] = ACTIONS(3567),
    [anon_sym_template] = ACTIONS(3567),
    [anon_sym_operator] = ACTIONS(3567),
    [anon_sym_try] = ACTIONS(3567),
    [anon_sym_delete] = ACTIONS(3567),
    [anon_sym_throw] = ACTIONS(3567),
    [anon_sym_namespace] = ACTIONS(3567),
    [anon_sym_using] = ACTIONS(3567),
    [anon_sym_static_assert] = ACTIONS(3567),
    [anon_sym_concept] = ACTIONS(3567),
    [anon_sym_co_return] = ACTIONS(3567),
    [anon_sym_co_yield] = ACTIONS(3567),
    [anon_sym_R_DQUOTE] = ACTIONS(3569),
    [anon_sym_LR_DQUOTE] = ACTIONS(3569),
    [anon_sym_uR_DQUOTE] = ACTIONS(3569),
    [anon_sym_UR_DQUOTE] = ACTIONS(3569),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3569),
    [anon_sym_co_await] = ACTIONS(3567),
    [anon_sym_new] = ACTIONS(3567),
    [anon_sym_requires] = ACTIONS(3567),
    [sym_this] = ACTIONS(3567),
    [anon_sym_precise] = ACTIONS(3567),
    [anon_sym_shared] = ACTIONS(3567),
    [anon_sym_groupshared] = ACTIONS(3567),
    [anon_sym_uniform] = ACTIONS(3567),
    [anon_sym_row_major] = ACTIONS(3567),
    [anon_sym_column_major] = ACTIONS(3567),
    [anon_sym_globallycoherent] = ACTIONS(3567),
    [anon_sym_centroid] = ACTIONS(3567),
    [anon_sym_noperspective] = ACTIONS(3567),
    [anon_sym_nointerpolation] = ACTIONS(3567),
    [anon_sym_sample] = ACTIONS(3567),
    [anon_sym_linear] = ACTIONS(3567),
    [anon_sym_snorm] = ACTIONS(3567),
    [anon_sym_unorm] = ACTIONS(3567),
    [anon_sym_point] = ACTIONS(3567),
    [anon_sym_line] = ACTIONS(3567),
    [anon_sym_triangleadj] = ACTIONS(3567),
    [anon_sym_lineadj] = ACTIONS(3567),
    [anon_sym_triangle] = ACTIONS(3567),
    [anon_sym_interface] = ACTIONS(3567),
    [anon_sym_extension] = ACTIONS(3567),
    [anon_sym___exported] = ACTIONS(3567),
    [anon_sym_import] = ACTIONS(3567),
  },
  [1054] = {
    [ts_builtin_sym_end] = ACTIONS(3573),
    [sym_identifier] = ACTIONS(3571),
    [aux_sym_preproc_include_token1] = ACTIONS(3571),
    [aux_sym_preproc_def_token1] = ACTIONS(3571),
    [aux_sym_preproc_if_token1] = ACTIONS(3571),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3571),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3571),
    [sym_preproc_directive] = ACTIONS(3571),
    [anon_sym_LPAREN2] = ACTIONS(3573),
    [anon_sym_BANG] = ACTIONS(3573),
    [anon_sym_TILDE] = ACTIONS(3573),
    [anon_sym_DASH] = ACTIONS(3571),
    [anon_sym_PLUS] = ACTIONS(3571),
    [anon_sym_STAR] = ACTIONS(3573),
    [anon_sym_AMP_AMP] = ACTIONS(3573),
    [anon_sym_AMP] = ACTIONS(3571),
    [anon_sym___extension__] = ACTIONS(3571),
    [anon_sym_typedef] = ACTIONS(3571),
    [anon_sym_in] = ACTIONS(3571),
    [anon_sym_out] = ACTIONS(3571),
    [anon_sym_inout] = ACTIONS(3571),
    [anon_sym_extern] = ACTIONS(3571),
    [anon_sym___attribute__] = ACTIONS(3571),
    [anon_sym_COLON_COLON] = ACTIONS(3573),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3573),
    [anon_sym___declspec] = ACTIONS(3571),
    [anon_sym___based] = ACTIONS(3571),
    [anon_sym___cdecl] = ACTIONS(3571),
    [anon_sym___clrcall] = ACTIONS(3571),
    [anon_sym___stdcall] = ACTIONS(3571),
    [anon_sym___fastcall] = ACTIONS(3571),
    [anon_sym___thiscall] = ACTIONS(3571),
    [anon_sym___vectorcall] = ACTIONS(3571),
    [anon_sym_LBRACE] = ACTIONS(3573),
    [anon_sym_signed] = ACTIONS(3571),
    [anon_sym_unsigned] = ACTIONS(3571),
    [anon_sym_long] = ACTIONS(3571),
    [anon_sym_short] = ACTIONS(3571),
    [anon_sym_LBRACK] = ACTIONS(3571),
    [anon_sym_static] = ACTIONS(3571),
    [anon_sym_register] = ACTIONS(3571),
    [anon_sym_inline] = ACTIONS(3571),
    [anon_sym___inline] = ACTIONS(3571),
    [anon_sym___inline__] = ACTIONS(3571),
    [anon_sym___forceinline] = ACTIONS(3571),
    [anon_sym_thread_local] = ACTIONS(3571),
    [anon_sym___thread] = ACTIONS(3571),
    [anon_sym_const] = ACTIONS(3571),
    [anon_sym_constexpr] = ACTIONS(3571),
    [anon_sym_volatile] = ACTIONS(3571),
    [anon_sym_restrict] = ACTIONS(3571),
    [anon_sym___restrict__] = ACTIONS(3571),
    [anon_sym__Atomic] = ACTIONS(3571),
    [anon_sym__Noreturn] = ACTIONS(3571),
    [anon_sym_noreturn] = ACTIONS(3571),
    [anon_sym_mutable] = ACTIONS(3571),
    [anon_sym_constinit] = ACTIONS(3571),
    [anon_sym_consteval] = ACTIONS(3571),
    [anon_sym_alignas] = ACTIONS(3571),
    [anon_sym__Alignas] = ACTIONS(3571),
    [sym_primitive_type] = ACTIONS(3571),
    [anon_sym_enum] = ACTIONS(3571),
    [anon_sym_class] = ACTIONS(3571),
    [anon_sym_struct] = ACTIONS(3571),
    [anon_sym_union] = ACTIONS(3571),
    [anon_sym_if] = ACTIONS(3571),
    [anon_sym_switch] = ACTIONS(3571),
    [anon_sym_case] = ACTIONS(3571),
    [anon_sym_default] = ACTIONS(3571),
    [anon_sym_while] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(3571),
    [anon_sym_for] = ACTIONS(3571),
    [anon_sym_return] = ACTIONS(3571),
    [anon_sym_break] = ACTIONS(3571),
    [anon_sym_continue] = ACTIONS(3571),
    [anon_sym_goto] = ACTIONS(3571),
    [anon_sym_not] = ACTIONS(3571),
    [anon_sym_compl] = ACTIONS(3571),
    [anon_sym_DASH_DASH] = ACTIONS(3573),
    [anon_sym_PLUS_PLUS] = ACTIONS(3573),
    [anon_sym_sizeof] = ACTIONS(3571),
    [anon_sym___alignof__] = ACTIONS(3571),
    [anon_sym___alignof] = ACTIONS(3571),
    [anon_sym__alignof] = ACTIONS(3571),
    [anon_sym_alignof] = ACTIONS(3571),
    [anon_sym__Alignof] = ACTIONS(3571),
    [anon_sym_offsetof] = ACTIONS(3571),
    [anon_sym__Generic] = ACTIONS(3571),
    [anon_sym_asm] = ACTIONS(3571),
    [anon_sym___asm__] = ACTIONS(3571),
    [sym_number_literal] = ACTIONS(3573),
    [anon_sym_L_SQUOTE] = ACTIONS(3573),
    [anon_sym_u_SQUOTE] = ACTIONS(3573),
    [anon_sym_U_SQUOTE] = ACTIONS(3573),
    [anon_sym_u8_SQUOTE] = ACTIONS(3573),
    [anon_sym_SQUOTE] = ACTIONS(3573),
    [anon_sym_L_DQUOTE] = ACTIONS(3573),
    [anon_sym_u_DQUOTE] = ACTIONS(3573),
    [anon_sym_U_DQUOTE] = ACTIONS(3573),
    [anon_sym_u8_DQUOTE] = ACTIONS(3573),
    [anon_sym_DQUOTE] = ACTIONS(3573),
    [sym_true] = ACTIONS(3571),
    [sym_false] = ACTIONS(3571),
    [anon_sym_NULL] = ACTIONS(3571),
    [anon_sym_nullptr] = ACTIONS(3571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3571),
    [anon_sym_let] = ACTIONS(3571),
    [anon_sym_This] = ACTIONS(3571),
    [anon_sym_decltype] = ACTIONS(3571),
    [sym_virtual] = ACTIONS(3571),
    [anon_sym_explicit] = ACTIONS(3571),
    [anon_sym_typename] = ACTIONS(3571),
    [anon_sym_template] = ACTIONS(3571),
    [anon_sym_operator] = ACTIONS(3571),
    [anon_sym_try] = ACTIONS(3571),
    [anon_sym_delete] = ACTIONS(3571),
    [anon_sym_throw] = ACTIONS(3571),
    [anon_sym_namespace] = ACTIONS(3571),
    [anon_sym_using] = ACTIONS(3571),
    [anon_sym_static_assert] = ACTIONS(3571),
    [anon_sym_concept] = ACTIONS(3571),
    [anon_sym_co_return] = ACTIONS(3571),
    [anon_sym_co_yield] = ACTIONS(3571),
    [anon_sym_R_DQUOTE] = ACTIONS(3573),
    [anon_sym_LR_DQUOTE] = ACTIONS(3573),
    [anon_sym_uR_DQUOTE] = ACTIONS(3573),
    [anon_sym_UR_DQUOTE] = ACTIONS(3573),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3573),
    [anon_sym_co_await] = ACTIONS(3571),
    [anon_sym_new] = ACTIONS(3571),
    [anon_sym_requires] = ACTIONS(3571),
    [sym_this] = ACTIONS(3571),
    [anon_sym_precise] = ACTIONS(3571),
    [anon_sym_shared] = ACTIONS(3571),
    [anon_sym_groupshared] = ACTIONS(3571),
    [anon_sym_uniform] = ACTIONS(3571),
    [anon_sym_row_major] = ACTIONS(3571),
    [anon_sym_column_major] = ACTIONS(3571),
    [anon_sym_globallycoherent] = ACTIONS(3571),
    [anon_sym_centroid] = ACTIONS(3571),
    [anon_sym_noperspective] = ACTIONS(3571),
    [anon_sym_nointerpolation] = ACTIONS(3571),
    [anon_sym_sample] = ACTIONS(3571),
    [anon_sym_linear] = ACTIONS(3571),
    [anon_sym_snorm] = ACTIONS(3571),
    [anon_sym_unorm] = ACTIONS(3571),
    [anon_sym_point] = ACTIONS(3571),
    [anon_sym_line] = ACTIONS(3571),
    [anon_sym_triangleadj] = ACTIONS(3571),
    [anon_sym_lineadj] = ACTIONS(3571),
    [anon_sym_triangle] = ACTIONS(3571),
    [anon_sym_interface] = ACTIONS(3571),
    [anon_sym_extension] = ACTIONS(3571),
    [anon_sym___exported] = ACTIONS(3571),
    [anon_sym_import] = ACTIONS(3571),
  },
  [1055] = {
    [ts_builtin_sym_end] = ACTIONS(3615),
    [sym_identifier] = ACTIONS(3613),
    [aux_sym_preproc_include_token1] = ACTIONS(3613),
    [aux_sym_preproc_def_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3613),
    [sym_preproc_directive] = ACTIONS(3613),
    [anon_sym_LPAREN2] = ACTIONS(3615),
    [anon_sym_BANG] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3613),
    [anon_sym_PLUS] = ACTIONS(3613),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym___extension__] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3613),
    [anon_sym_in] = ACTIONS(3613),
    [anon_sym_out] = ACTIONS(3613),
    [anon_sym_inout] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym___attribute__] = ACTIONS(3613),
    [anon_sym_COLON_COLON] = ACTIONS(3615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3615),
    [anon_sym___declspec] = ACTIONS(3613),
    [anon_sym___based] = ACTIONS(3613),
    [anon_sym___cdecl] = ACTIONS(3613),
    [anon_sym___clrcall] = ACTIONS(3613),
    [anon_sym___stdcall] = ACTIONS(3613),
    [anon_sym___fastcall] = ACTIONS(3613),
    [anon_sym___thiscall] = ACTIONS(3613),
    [anon_sym___vectorcall] = ACTIONS(3613),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_signed] = ACTIONS(3613),
    [anon_sym_unsigned] = ACTIONS(3613),
    [anon_sym_long] = ACTIONS(3613),
    [anon_sym_short] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_register] = ACTIONS(3613),
    [anon_sym_inline] = ACTIONS(3613),
    [anon_sym___inline] = ACTIONS(3613),
    [anon_sym___inline__] = ACTIONS(3613),
    [anon_sym___forceinline] = ACTIONS(3613),
    [anon_sym_thread_local] = ACTIONS(3613),
    [anon_sym___thread] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_constexpr] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_restrict] = ACTIONS(3613),
    [anon_sym___restrict__] = ACTIONS(3613),
    [anon_sym__Atomic] = ACTIONS(3613),
    [anon_sym__Noreturn] = ACTIONS(3613),
    [anon_sym_noreturn] = ACTIONS(3613),
    [anon_sym_mutable] = ACTIONS(3613),
    [anon_sym_constinit] = ACTIONS(3613),
    [anon_sym_consteval] = ACTIONS(3613),
    [anon_sym_alignas] = ACTIONS(3613),
    [anon_sym__Alignas] = ACTIONS(3613),
    [sym_primitive_type] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_union] = ACTIONS(3613),
    [anon_sym_if] = ACTIONS(3613),
    [anon_sym_switch] = ACTIONS(3613),
    [anon_sym_case] = ACTIONS(3613),
    [anon_sym_default] = ACTIONS(3613),
    [anon_sym_while] = ACTIONS(3613),
    [anon_sym_do] = ACTIONS(3613),
    [anon_sym_for] = ACTIONS(3613),
    [anon_sym_return] = ACTIONS(3613),
    [anon_sym_break] = ACTIONS(3613),
    [anon_sym_continue] = ACTIONS(3613),
    [anon_sym_goto] = ACTIONS(3613),
    [anon_sym_not] = ACTIONS(3613),
    [anon_sym_compl] = ACTIONS(3613),
    [anon_sym_DASH_DASH] = ACTIONS(3615),
    [anon_sym_PLUS_PLUS] = ACTIONS(3615),
    [anon_sym_sizeof] = ACTIONS(3613),
    [anon_sym___alignof__] = ACTIONS(3613),
    [anon_sym___alignof] = ACTIONS(3613),
    [anon_sym__alignof] = ACTIONS(3613),
    [anon_sym_alignof] = ACTIONS(3613),
    [anon_sym__Alignof] = ACTIONS(3613),
    [anon_sym_offsetof] = ACTIONS(3613),
    [anon_sym__Generic] = ACTIONS(3613),
    [anon_sym_asm] = ACTIONS(3613),
    [anon_sym___asm__] = ACTIONS(3613),
    [sym_number_literal] = ACTIONS(3615),
    [anon_sym_L_SQUOTE] = ACTIONS(3615),
    [anon_sym_u_SQUOTE] = ACTIONS(3615),
    [anon_sym_U_SQUOTE] = ACTIONS(3615),
    [anon_sym_u8_SQUOTE] = ACTIONS(3615),
    [anon_sym_SQUOTE] = ACTIONS(3615),
    [anon_sym_L_DQUOTE] = ACTIONS(3615),
    [anon_sym_u_DQUOTE] = ACTIONS(3615),
    [anon_sym_U_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8_DQUOTE] = ACTIONS(3615),
    [anon_sym_DQUOTE] = ACTIONS(3615),
    [sym_true] = ACTIONS(3613),
    [sym_false] = ACTIONS(3613),
    [anon_sym_NULL] = ACTIONS(3613),
    [anon_sym_nullptr] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_This] = ACTIONS(3613),
    [anon_sym_decltype] = ACTIONS(3613),
    [sym_virtual] = ACTIONS(3613),
    [anon_sym_explicit] = ACTIONS(3613),
    [anon_sym_typename] = ACTIONS(3613),
    [anon_sym_template] = ACTIONS(3613),
    [anon_sym_operator] = ACTIONS(3613),
    [anon_sym_try] = ACTIONS(3613),
    [anon_sym_delete] = ACTIONS(3613),
    [anon_sym_throw] = ACTIONS(3613),
    [anon_sym_namespace] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_static_assert] = ACTIONS(3613),
    [anon_sym_concept] = ACTIONS(3613),
    [anon_sym_co_return] = ACTIONS(3613),
    [anon_sym_co_yield] = ACTIONS(3613),
    [anon_sym_R_DQUOTE] = ACTIONS(3615),
    [anon_sym_LR_DQUOTE] = ACTIONS(3615),
    [anon_sym_uR_DQUOTE] = ACTIONS(3615),
    [anon_sym_UR_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3615),
    [anon_sym_co_await] = ACTIONS(3613),
    [anon_sym_new] = ACTIONS(3613),
    [anon_sym_requires] = ACTIONS(3613),
    [sym_this] = ACTIONS(3613),
    [anon_sym_precise] = ACTIONS(3613),
    [anon_sym_shared] = ACTIONS(3613),
    [anon_sym_groupshared] = ACTIONS(3613),
    [anon_sym_uniform] = ACTIONS(3613),
    [anon_sym_row_major] = ACTIONS(3613),
    [anon_sym_column_major] = ACTIONS(3613),
    [anon_sym_globallycoherent] = ACTIONS(3613),
    [anon_sym_centroid] = ACTIONS(3613),
    [anon_sym_noperspective] = ACTIONS(3613),
    [anon_sym_nointerpolation] = ACTIONS(3613),
    [anon_sym_sample] = ACTIONS(3613),
    [anon_sym_linear] = ACTIONS(3613),
    [anon_sym_snorm] = ACTIONS(3613),
    [anon_sym_unorm] = ACTIONS(3613),
    [anon_sym_point] = ACTIONS(3613),
    [anon_sym_line] = ACTIONS(3613),
    [anon_sym_triangleadj] = ACTIONS(3613),
    [anon_sym_lineadj] = ACTIONS(3613),
    [anon_sym_triangle] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_extension] = ACTIONS(3613),
    [anon_sym___exported] = ACTIONS(3613),
    [anon_sym_import] = ACTIONS(3613),
  },
  [1056] = {
    [ts_builtin_sym_end] = ACTIONS(3697),
    [sym_identifier] = ACTIONS(3695),
    [aux_sym_preproc_include_token1] = ACTIONS(3695),
    [aux_sym_preproc_def_token1] = ACTIONS(3695),
    [aux_sym_preproc_if_token1] = ACTIONS(3695),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3695),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3695),
    [sym_preproc_directive] = ACTIONS(3695),
    [anon_sym_LPAREN2] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3697),
    [anon_sym_TILDE] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3695),
    [anon_sym_PLUS] = ACTIONS(3695),
    [anon_sym_STAR] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3697),
    [anon_sym_AMP] = ACTIONS(3695),
    [anon_sym___extension__] = ACTIONS(3695),
    [anon_sym_typedef] = ACTIONS(3695),
    [anon_sym_in] = ACTIONS(3695),
    [anon_sym_out] = ACTIONS(3695),
    [anon_sym_inout] = ACTIONS(3695),
    [anon_sym_extern] = ACTIONS(3695),
    [anon_sym___attribute__] = ACTIONS(3695),
    [anon_sym_COLON_COLON] = ACTIONS(3697),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3697),
    [anon_sym___declspec] = ACTIONS(3695),
    [anon_sym___based] = ACTIONS(3695),
    [anon_sym___cdecl] = ACTIONS(3695),
    [anon_sym___clrcall] = ACTIONS(3695),
    [anon_sym___stdcall] = ACTIONS(3695),
    [anon_sym___fastcall] = ACTIONS(3695),
    [anon_sym___thiscall] = ACTIONS(3695),
    [anon_sym___vectorcall] = ACTIONS(3695),
    [anon_sym_LBRACE] = ACTIONS(3697),
    [anon_sym_signed] = ACTIONS(3695),
    [anon_sym_unsigned] = ACTIONS(3695),
    [anon_sym_long] = ACTIONS(3695),
    [anon_sym_short] = ACTIONS(3695),
    [anon_sym_LBRACK] = ACTIONS(3695),
    [anon_sym_static] = ACTIONS(3695),
    [anon_sym_register] = ACTIONS(3695),
    [anon_sym_inline] = ACTIONS(3695),
    [anon_sym___inline] = ACTIONS(3695),
    [anon_sym___inline__] = ACTIONS(3695),
    [anon_sym___forceinline] = ACTIONS(3695),
    [anon_sym_thread_local] = ACTIONS(3695),
    [anon_sym___thread] = ACTIONS(3695),
    [anon_sym_const] = ACTIONS(3695),
    [anon_sym_constexpr] = ACTIONS(3695),
    [anon_sym_volatile] = ACTIONS(3695),
    [anon_sym_restrict] = ACTIONS(3695),
    [anon_sym___restrict__] = ACTIONS(3695),
    [anon_sym__Atomic] = ACTIONS(3695),
    [anon_sym__Noreturn] = ACTIONS(3695),
    [anon_sym_noreturn] = ACTIONS(3695),
    [anon_sym_mutable] = ACTIONS(3695),
    [anon_sym_constinit] = ACTIONS(3695),
    [anon_sym_consteval] = ACTIONS(3695),
    [anon_sym_alignas] = ACTIONS(3695),
    [anon_sym__Alignas] = ACTIONS(3695),
    [sym_primitive_type] = ACTIONS(3695),
    [anon_sym_enum] = ACTIONS(3695),
    [anon_sym_class] = ACTIONS(3695),
    [anon_sym_struct] = ACTIONS(3695),
    [anon_sym_union] = ACTIONS(3695),
    [anon_sym_if] = ACTIONS(3695),
    [anon_sym_switch] = ACTIONS(3695),
    [anon_sym_case] = ACTIONS(3695),
    [anon_sym_default] = ACTIONS(3695),
    [anon_sym_while] = ACTIONS(3695),
    [anon_sym_do] = ACTIONS(3695),
    [anon_sym_for] = ACTIONS(3695),
    [anon_sym_return] = ACTIONS(3695),
    [anon_sym_break] = ACTIONS(3695),
    [anon_sym_continue] = ACTIONS(3695),
    [anon_sym_goto] = ACTIONS(3695),
    [anon_sym_not] = ACTIONS(3695),
    [anon_sym_compl] = ACTIONS(3695),
    [anon_sym_DASH_DASH] = ACTIONS(3697),
    [anon_sym_PLUS_PLUS] = ACTIONS(3697),
    [anon_sym_sizeof] = ACTIONS(3695),
    [anon_sym___alignof__] = ACTIONS(3695),
    [anon_sym___alignof] = ACTIONS(3695),
    [anon_sym__alignof] = ACTIONS(3695),
    [anon_sym_alignof] = ACTIONS(3695),
    [anon_sym__Alignof] = ACTIONS(3695),
    [anon_sym_offsetof] = ACTIONS(3695),
    [anon_sym__Generic] = ACTIONS(3695),
    [anon_sym_asm] = ACTIONS(3695),
    [anon_sym___asm__] = ACTIONS(3695),
    [sym_number_literal] = ACTIONS(3697),
    [anon_sym_L_SQUOTE] = ACTIONS(3697),
    [anon_sym_u_SQUOTE] = ACTIONS(3697),
    [anon_sym_U_SQUOTE] = ACTIONS(3697),
    [anon_sym_u8_SQUOTE] = ACTIONS(3697),
    [anon_sym_SQUOTE] = ACTIONS(3697),
    [anon_sym_L_DQUOTE] = ACTIONS(3697),
    [anon_sym_u_DQUOTE] = ACTIONS(3697),
    [anon_sym_U_DQUOTE] = ACTIONS(3697),
    [anon_sym_u8_DQUOTE] = ACTIONS(3697),
    [anon_sym_DQUOTE] = ACTIONS(3697),
    [sym_true] = ACTIONS(3695),
    [sym_false] = ACTIONS(3695),
    [anon_sym_NULL] = ACTIONS(3695),
    [anon_sym_nullptr] = ACTIONS(3695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3695),
    [anon_sym_let] = ACTIONS(3695),
    [anon_sym_This] = ACTIONS(3695),
    [anon_sym_decltype] = ACTIONS(3695),
    [sym_virtual] = ACTIONS(3695),
    [anon_sym_explicit] = ACTIONS(3695),
    [anon_sym_typename] = ACTIONS(3695),
    [anon_sym_template] = ACTIONS(3695),
    [anon_sym_operator] = ACTIONS(3695),
    [anon_sym_try] = ACTIONS(3695),
    [anon_sym_delete] = ACTIONS(3695),
    [anon_sym_throw] = ACTIONS(3695),
    [anon_sym_namespace] = ACTIONS(3695),
    [anon_sym_using] = ACTIONS(3695),
    [anon_sym_static_assert] = ACTIONS(3695),
    [anon_sym_concept] = ACTIONS(3695),
    [anon_sym_co_return] = ACTIONS(3695),
    [anon_sym_co_yield] = ACTIONS(3695),
    [anon_sym_R_DQUOTE] = ACTIONS(3697),
    [anon_sym_LR_DQUOTE] = ACTIONS(3697),
    [anon_sym_uR_DQUOTE] = ACTIONS(3697),
    [anon_sym_UR_DQUOTE] = ACTIONS(3697),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3697),
    [anon_sym_co_await] = ACTIONS(3695),
    [anon_sym_new] = ACTIONS(3695),
    [anon_sym_requires] = ACTIONS(3695),
    [sym_this] = ACTIONS(3695),
    [anon_sym_precise] = ACTIONS(3695),
    [anon_sym_shared] = ACTIONS(3695),
    [anon_sym_groupshared] = ACTIONS(3695),
    [anon_sym_uniform] = ACTIONS(3695),
    [anon_sym_row_major] = ACTIONS(3695),
    [anon_sym_column_major] = ACTIONS(3695),
    [anon_sym_globallycoherent] = ACTIONS(3695),
    [anon_sym_centroid] = ACTIONS(3695),
    [anon_sym_noperspective] = ACTIONS(3695),
    [anon_sym_nointerpolation] = ACTIONS(3695),
    [anon_sym_sample] = ACTIONS(3695),
    [anon_sym_linear] = ACTIONS(3695),
    [anon_sym_snorm] = ACTIONS(3695),
    [anon_sym_unorm] = ACTIONS(3695),
    [anon_sym_point] = ACTIONS(3695),
    [anon_sym_line] = ACTIONS(3695),
    [anon_sym_triangleadj] = ACTIONS(3695),
    [anon_sym_lineadj] = ACTIONS(3695),
    [anon_sym_triangle] = ACTIONS(3695),
    [anon_sym_interface] = ACTIONS(3695),
    [anon_sym_extension] = ACTIONS(3695),
    [anon_sym___exported] = ACTIONS(3695),
    [anon_sym_import] = ACTIONS(3695),
  },
  [1057] = {
    [ts_builtin_sym_end] = ACTIONS(3499),
    [sym_identifier] = ACTIONS(3497),
    [aux_sym_preproc_include_token1] = ACTIONS(3497),
    [aux_sym_preproc_def_token1] = ACTIONS(3497),
    [aux_sym_preproc_if_token1] = ACTIONS(3497),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3497),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3497),
    [sym_preproc_directive] = ACTIONS(3497),
    [anon_sym_LPAREN2] = ACTIONS(3499),
    [anon_sym_BANG] = ACTIONS(3499),
    [anon_sym_TILDE] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_STAR] = ACTIONS(3499),
    [anon_sym_AMP_AMP] = ACTIONS(3499),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym___extension__] = ACTIONS(3497),
    [anon_sym_typedef] = ACTIONS(3497),
    [anon_sym_in] = ACTIONS(3497),
    [anon_sym_out] = ACTIONS(3497),
    [anon_sym_inout] = ACTIONS(3497),
    [anon_sym_extern] = ACTIONS(3497),
    [anon_sym___attribute__] = ACTIONS(3497),
    [anon_sym_COLON_COLON] = ACTIONS(3499),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3499),
    [anon_sym___declspec] = ACTIONS(3497),
    [anon_sym___based] = ACTIONS(3497),
    [anon_sym___cdecl] = ACTIONS(3497),
    [anon_sym___clrcall] = ACTIONS(3497),
    [anon_sym___stdcall] = ACTIONS(3497),
    [anon_sym___fastcall] = ACTIONS(3497),
    [anon_sym___thiscall] = ACTIONS(3497),
    [anon_sym___vectorcall] = ACTIONS(3497),
    [anon_sym_LBRACE] = ACTIONS(3499),
    [anon_sym_signed] = ACTIONS(3497),
    [anon_sym_unsigned] = ACTIONS(3497),
    [anon_sym_long] = ACTIONS(3497),
    [anon_sym_short] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3497),
    [anon_sym_static] = ACTIONS(3497),
    [anon_sym_register] = ACTIONS(3497),
    [anon_sym_inline] = ACTIONS(3497),
    [anon_sym___inline] = ACTIONS(3497),
    [anon_sym___inline__] = ACTIONS(3497),
    [anon_sym___forceinline] = ACTIONS(3497),
    [anon_sym_thread_local] = ACTIONS(3497),
    [anon_sym___thread] = ACTIONS(3497),
    [anon_sym_const] = ACTIONS(3497),
    [anon_sym_constexpr] = ACTIONS(3497),
    [anon_sym_volatile] = ACTIONS(3497),
    [anon_sym_restrict] = ACTIONS(3497),
    [anon_sym___restrict__] = ACTIONS(3497),
    [anon_sym__Atomic] = ACTIONS(3497),
    [anon_sym__Noreturn] = ACTIONS(3497),
    [anon_sym_noreturn] = ACTIONS(3497),
    [anon_sym_mutable] = ACTIONS(3497),
    [anon_sym_constinit] = ACTIONS(3497),
    [anon_sym_consteval] = ACTIONS(3497),
    [anon_sym_alignas] = ACTIONS(3497),
    [anon_sym__Alignas] = ACTIONS(3497),
    [sym_primitive_type] = ACTIONS(3497),
    [anon_sym_enum] = ACTIONS(3497),
    [anon_sym_class] = ACTIONS(3497),
    [anon_sym_struct] = ACTIONS(3497),
    [anon_sym_union] = ACTIONS(3497),
    [anon_sym_if] = ACTIONS(3497),
    [anon_sym_switch] = ACTIONS(3497),
    [anon_sym_case] = ACTIONS(3497),
    [anon_sym_default] = ACTIONS(3497),
    [anon_sym_while] = ACTIONS(3497),
    [anon_sym_do] = ACTIONS(3497),
    [anon_sym_for] = ACTIONS(3497),
    [anon_sym_return] = ACTIONS(3497),
    [anon_sym_break] = ACTIONS(3497),
    [anon_sym_continue] = ACTIONS(3497),
    [anon_sym_goto] = ACTIONS(3497),
    [anon_sym_not] = ACTIONS(3497),
    [anon_sym_compl] = ACTIONS(3497),
    [anon_sym_DASH_DASH] = ACTIONS(3499),
    [anon_sym_PLUS_PLUS] = ACTIONS(3499),
    [anon_sym_sizeof] = ACTIONS(3497),
    [anon_sym___alignof__] = ACTIONS(3497),
    [anon_sym___alignof] = ACTIONS(3497),
    [anon_sym__alignof] = ACTIONS(3497),
    [anon_sym_alignof] = ACTIONS(3497),
    [anon_sym__Alignof] = ACTIONS(3497),
    [anon_sym_offsetof] = ACTIONS(3497),
    [anon_sym__Generic] = ACTIONS(3497),
    [anon_sym_asm] = ACTIONS(3497),
    [anon_sym___asm__] = ACTIONS(3497),
    [sym_number_literal] = ACTIONS(3499),
    [anon_sym_L_SQUOTE] = ACTIONS(3499),
    [anon_sym_u_SQUOTE] = ACTIONS(3499),
    [anon_sym_U_SQUOTE] = ACTIONS(3499),
    [anon_sym_u8_SQUOTE] = ACTIONS(3499),
    [anon_sym_SQUOTE] = ACTIONS(3499),
    [anon_sym_L_DQUOTE] = ACTIONS(3499),
    [anon_sym_u_DQUOTE] = ACTIONS(3499),
    [anon_sym_U_DQUOTE] = ACTIONS(3499),
    [anon_sym_u8_DQUOTE] = ACTIONS(3499),
    [anon_sym_DQUOTE] = ACTIONS(3499),
    [sym_true] = ACTIONS(3497),
    [sym_false] = ACTIONS(3497),
    [anon_sym_NULL] = ACTIONS(3497),
    [anon_sym_nullptr] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3497),
    [anon_sym_let] = ACTIONS(3497),
    [anon_sym_This] = ACTIONS(3497),
    [anon_sym_decltype] = ACTIONS(3497),
    [sym_virtual] = ACTIONS(3497),
    [anon_sym_explicit] = ACTIONS(3497),
    [anon_sym_typename] = ACTIONS(3497),
    [anon_sym_template] = ACTIONS(3497),
    [anon_sym_operator] = ACTIONS(3497),
    [anon_sym_try] = ACTIONS(3497),
    [anon_sym_delete] = ACTIONS(3497),
    [anon_sym_throw] = ACTIONS(3497),
    [anon_sym_namespace] = ACTIONS(3497),
    [anon_sym_using] = ACTIONS(3497),
    [anon_sym_static_assert] = ACTIONS(3497),
    [anon_sym_concept] = ACTIONS(3497),
    [anon_sym_co_return] = ACTIONS(3497),
    [anon_sym_co_yield] = ACTIONS(3497),
    [anon_sym_R_DQUOTE] = ACTIONS(3499),
    [anon_sym_LR_DQUOTE] = ACTIONS(3499),
    [anon_sym_uR_DQUOTE] = ACTIONS(3499),
    [anon_sym_UR_DQUOTE] = ACTIONS(3499),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3499),
    [anon_sym_co_await] = ACTIONS(3497),
    [anon_sym_new] = ACTIONS(3497),
    [anon_sym_requires] = ACTIONS(3497),
    [sym_this] = ACTIONS(3497),
    [anon_sym_precise] = ACTIONS(3497),
    [anon_sym_shared] = ACTIONS(3497),
    [anon_sym_groupshared] = ACTIONS(3497),
    [anon_sym_uniform] = ACTIONS(3497),
    [anon_sym_row_major] = ACTIONS(3497),
    [anon_sym_column_major] = ACTIONS(3497),
    [anon_sym_globallycoherent] = ACTIONS(3497),
    [anon_sym_centroid] = ACTIONS(3497),
    [anon_sym_noperspective] = ACTIONS(3497),
    [anon_sym_nointerpolation] = ACTIONS(3497),
    [anon_sym_sample] = ACTIONS(3497),
    [anon_sym_linear] = ACTIONS(3497),
    [anon_sym_snorm] = ACTIONS(3497),
    [anon_sym_unorm] = ACTIONS(3497),
    [anon_sym_point] = ACTIONS(3497),
    [anon_sym_line] = ACTIONS(3497),
    [anon_sym_triangleadj] = ACTIONS(3497),
    [anon_sym_lineadj] = ACTIONS(3497),
    [anon_sym_triangle] = ACTIONS(3497),
    [anon_sym_interface] = ACTIONS(3497),
    [anon_sym_extension] = ACTIONS(3497),
    [anon_sym___exported] = ACTIONS(3497),
    [anon_sym_import] = ACTIONS(3497),
  },
  [1058] = {
    [ts_builtin_sym_end] = ACTIONS(3957),
    [sym_identifier] = ACTIONS(3959),
    [aux_sym_preproc_include_token1] = ACTIONS(3959),
    [aux_sym_preproc_def_token1] = ACTIONS(3959),
    [aux_sym_preproc_if_token1] = ACTIONS(3959),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3959),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3959),
    [sym_preproc_directive] = ACTIONS(3959),
    [anon_sym_LPAREN2] = ACTIONS(3957),
    [anon_sym_BANG] = ACTIONS(3957),
    [anon_sym_TILDE] = ACTIONS(3957),
    [anon_sym_DASH] = ACTIONS(3959),
    [anon_sym_PLUS] = ACTIONS(3959),
    [anon_sym_STAR] = ACTIONS(3957),
    [anon_sym_AMP_AMP] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym___extension__] = ACTIONS(3959),
    [anon_sym_typedef] = ACTIONS(3959),
    [anon_sym_in] = ACTIONS(3959),
    [anon_sym_out] = ACTIONS(3959),
    [anon_sym_inout] = ACTIONS(3959),
    [anon_sym_extern] = ACTIONS(3959),
    [anon_sym___attribute__] = ACTIONS(3959),
    [anon_sym_COLON_COLON] = ACTIONS(3957),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3957),
    [anon_sym___declspec] = ACTIONS(3959),
    [anon_sym___based] = ACTIONS(3959),
    [anon_sym___cdecl] = ACTIONS(3959),
    [anon_sym___clrcall] = ACTIONS(3959),
    [anon_sym___stdcall] = ACTIONS(3959),
    [anon_sym___fastcall] = ACTIONS(3959),
    [anon_sym___thiscall] = ACTIONS(3959),
    [anon_sym___vectorcall] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(3957),
    [anon_sym_signed] = ACTIONS(3959),
    [anon_sym_unsigned] = ACTIONS(3959),
    [anon_sym_long] = ACTIONS(3959),
    [anon_sym_short] = ACTIONS(3959),
    [anon_sym_LBRACK] = ACTIONS(3959),
    [anon_sym_static] = ACTIONS(3959),
    [anon_sym_register] = ACTIONS(3959),
    [anon_sym_inline] = ACTIONS(3959),
    [anon_sym___inline] = ACTIONS(3959),
    [anon_sym___inline__] = ACTIONS(3959),
    [anon_sym___forceinline] = ACTIONS(3959),
    [anon_sym_thread_local] = ACTIONS(3959),
    [anon_sym___thread] = ACTIONS(3959),
    [anon_sym_const] = ACTIONS(3959),
    [anon_sym_constexpr] = ACTIONS(3959),
    [anon_sym_volatile] = ACTIONS(3959),
    [anon_sym_restrict] = ACTIONS(3959),
    [anon_sym___restrict__] = ACTIONS(3959),
    [anon_sym__Atomic] = ACTIONS(3959),
    [anon_sym__Noreturn] = ACTIONS(3959),
    [anon_sym_noreturn] = ACTIONS(3959),
    [anon_sym_mutable] = ACTIONS(3959),
    [anon_sym_constinit] = ACTIONS(3959),
    [anon_sym_consteval] = ACTIONS(3959),
    [anon_sym_alignas] = ACTIONS(3959),
    [anon_sym__Alignas] = ACTIONS(3959),
    [sym_primitive_type] = ACTIONS(3959),
    [anon_sym_enum] = ACTIONS(3959),
    [anon_sym_class] = ACTIONS(3959),
    [anon_sym_struct] = ACTIONS(3959),
    [anon_sym_union] = ACTIONS(3959),
    [anon_sym_if] = ACTIONS(3959),
    [anon_sym_switch] = ACTIONS(3959),
    [anon_sym_case] = ACTIONS(3959),
    [anon_sym_default] = ACTIONS(3959),
    [anon_sym_while] = ACTIONS(3959),
    [anon_sym_do] = ACTIONS(3959),
    [anon_sym_for] = ACTIONS(3959),
    [anon_sym_return] = ACTIONS(3959),
    [anon_sym_break] = ACTIONS(3959),
    [anon_sym_continue] = ACTIONS(3959),
    [anon_sym_goto] = ACTIONS(3959),
    [anon_sym_not] = ACTIONS(3959),
    [anon_sym_compl] = ACTIONS(3959),
    [anon_sym_DASH_DASH] = ACTIONS(3957),
    [anon_sym_PLUS_PLUS] = ACTIONS(3957),
    [anon_sym_sizeof] = ACTIONS(3959),
    [anon_sym___alignof__] = ACTIONS(3959),
    [anon_sym___alignof] = ACTIONS(3959),
    [anon_sym__alignof] = ACTIONS(3959),
    [anon_sym_alignof] = ACTIONS(3959),
    [anon_sym__Alignof] = ACTIONS(3959),
    [anon_sym_offsetof] = ACTIONS(3959),
    [anon_sym__Generic] = ACTIONS(3959),
    [anon_sym_asm] = ACTIONS(3959),
    [anon_sym___asm__] = ACTIONS(3959),
    [sym_number_literal] = ACTIONS(3957),
    [anon_sym_L_SQUOTE] = ACTIONS(3957),
    [anon_sym_u_SQUOTE] = ACTIONS(3957),
    [anon_sym_U_SQUOTE] = ACTIONS(3957),
    [anon_sym_u8_SQUOTE] = ACTIONS(3957),
    [anon_sym_SQUOTE] = ACTIONS(3957),
    [anon_sym_L_DQUOTE] = ACTIONS(3957),
    [anon_sym_u_DQUOTE] = ACTIONS(3957),
    [anon_sym_U_DQUOTE] = ACTIONS(3957),
    [anon_sym_u8_DQUOTE] = ACTIONS(3957),
    [anon_sym_DQUOTE] = ACTIONS(3957),
    [sym_true] = ACTIONS(3959),
    [sym_false] = ACTIONS(3959),
    [anon_sym_NULL] = ACTIONS(3959),
    [anon_sym_nullptr] = ACTIONS(3959),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3959),
    [anon_sym_let] = ACTIONS(3959),
    [anon_sym_This] = ACTIONS(3959),
    [anon_sym_decltype] = ACTIONS(3959),
    [sym_virtual] = ACTIONS(3959),
    [anon_sym_explicit] = ACTIONS(3959),
    [anon_sym_typename] = ACTIONS(3959),
    [anon_sym_template] = ACTIONS(3959),
    [anon_sym_operator] = ACTIONS(3959),
    [anon_sym_try] = ACTIONS(3959),
    [anon_sym_delete] = ACTIONS(3959),
    [anon_sym_throw] = ACTIONS(3959),
    [anon_sym_namespace] = ACTIONS(3959),
    [anon_sym_using] = ACTIONS(3959),
    [anon_sym_static_assert] = ACTIONS(3959),
    [anon_sym_concept] = ACTIONS(3959),
    [anon_sym_co_return] = ACTIONS(3959),
    [anon_sym_co_yield] = ACTIONS(3959),
    [anon_sym_R_DQUOTE] = ACTIONS(3957),
    [anon_sym_LR_DQUOTE] = ACTIONS(3957),
    [anon_sym_uR_DQUOTE] = ACTIONS(3957),
    [anon_sym_UR_DQUOTE] = ACTIONS(3957),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3957),
    [anon_sym_co_await] = ACTIONS(3959),
    [anon_sym_new] = ACTIONS(3959),
    [anon_sym_requires] = ACTIONS(3959),
    [sym_this] = ACTIONS(3959),
    [anon_sym_precise] = ACTIONS(3959),
    [anon_sym_shared] = ACTIONS(3959),
    [anon_sym_groupshared] = ACTIONS(3959),
    [anon_sym_uniform] = ACTIONS(3959),
    [anon_sym_row_major] = ACTIONS(3959),
    [anon_sym_column_major] = ACTIONS(3959),
    [anon_sym_globallycoherent] = ACTIONS(3959),
    [anon_sym_centroid] = ACTIONS(3959),
    [anon_sym_noperspective] = ACTIONS(3959),
    [anon_sym_nointerpolation] = ACTIONS(3959),
    [anon_sym_sample] = ACTIONS(3959),
    [anon_sym_linear] = ACTIONS(3959),
    [anon_sym_snorm] = ACTIONS(3959),
    [anon_sym_unorm] = ACTIONS(3959),
    [anon_sym_point] = ACTIONS(3959),
    [anon_sym_line] = ACTIONS(3959),
    [anon_sym_triangleadj] = ACTIONS(3959),
    [anon_sym_lineadj] = ACTIONS(3959),
    [anon_sym_triangle] = ACTIONS(3959),
    [anon_sym_interface] = ACTIONS(3959),
    [anon_sym_extension] = ACTIONS(3959),
    [anon_sym___exported] = ACTIONS(3959),
    [anon_sym_import] = ACTIONS(3959),
  },
  [1059] = {
    [ts_builtin_sym_end] = ACTIONS(3553),
    [sym_identifier] = ACTIONS(3551),
    [aux_sym_preproc_include_token1] = ACTIONS(3551),
    [aux_sym_preproc_def_token1] = ACTIONS(3551),
    [aux_sym_preproc_if_token1] = ACTIONS(3551),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3551),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3551),
    [sym_preproc_directive] = ACTIONS(3551),
    [anon_sym_LPAREN2] = ACTIONS(3553),
    [anon_sym_BANG] = ACTIONS(3553),
    [anon_sym_TILDE] = ACTIONS(3553),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_PLUS] = ACTIONS(3551),
    [anon_sym_STAR] = ACTIONS(3553),
    [anon_sym_AMP_AMP] = ACTIONS(3553),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym___extension__] = ACTIONS(3551),
    [anon_sym_typedef] = ACTIONS(3551),
    [anon_sym_in] = ACTIONS(3551),
    [anon_sym_out] = ACTIONS(3551),
    [anon_sym_inout] = ACTIONS(3551),
    [anon_sym_extern] = ACTIONS(3551),
    [anon_sym___attribute__] = ACTIONS(3551),
    [anon_sym_COLON_COLON] = ACTIONS(3553),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3553),
    [anon_sym___declspec] = ACTIONS(3551),
    [anon_sym___based] = ACTIONS(3551),
    [anon_sym___cdecl] = ACTIONS(3551),
    [anon_sym___clrcall] = ACTIONS(3551),
    [anon_sym___stdcall] = ACTIONS(3551),
    [anon_sym___fastcall] = ACTIONS(3551),
    [anon_sym___thiscall] = ACTIONS(3551),
    [anon_sym___vectorcall] = ACTIONS(3551),
    [anon_sym_LBRACE] = ACTIONS(3553),
    [anon_sym_signed] = ACTIONS(3551),
    [anon_sym_unsigned] = ACTIONS(3551),
    [anon_sym_long] = ACTIONS(3551),
    [anon_sym_short] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3551),
    [anon_sym_static] = ACTIONS(3551),
    [anon_sym_register] = ACTIONS(3551),
    [anon_sym_inline] = ACTIONS(3551),
    [anon_sym___inline] = ACTIONS(3551),
    [anon_sym___inline__] = ACTIONS(3551),
    [anon_sym___forceinline] = ACTIONS(3551),
    [anon_sym_thread_local] = ACTIONS(3551),
    [anon_sym___thread] = ACTIONS(3551),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_constexpr] = ACTIONS(3551),
    [anon_sym_volatile] = ACTIONS(3551),
    [anon_sym_restrict] = ACTIONS(3551),
    [anon_sym___restrict__] = ACTIONS(3551),
    [anon_sym__Atomic] = ACTIONS(3551),
    [anon_sym__Noreturn] = ACTIONS(3551),
    [anon_sym_noreturn] = ACTIONS(3551),
    [anon_sym_mutable] = ACTIONS(3551),
    [anon_sym_constinit] = ACTIONS(3551),
    [anon_sym_consteval] = ACTIONS(3551),
    [anon_sym_alignas] = ACTIONS(3551),
    [anon_sym__Alignas] = ACTIONS(3551),
    [sym_primitive_type] = ACTIONS(3551),
    [anon_sym_enum] = ACTIONS(3551),
    [anon_sym_class] = ACTIONS(3551),
    [anon_sym_struct] = ACTIONS(3551),
    [anon_sym_union] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(3551),
    [anon_sym_switch] = ACTIONS(3551),
    [anon_sym_case] = ACTIONS(3551),
    [anon_sym_default] = ACTIONS(3551),
    [anon_sym_while] = ACTIONS(3551),
    [anon_sym_do] = ACTIONS(3551),
    [anon_sym_for] = ACTIONS(3551),
    [anon_sym_return] = ACTIONS(3551),
    [anon_sym_break] = ACTIONS(3551),
    [anon_sym_continue] = ACTIONS(3551),
    [anon_sym_goto] = ACTIONS(3551),
    [anon_sym_not] = ACTIONS(3551),
    [anon_sym_compl] = ACTIONS(3551),
    [anon_sym_DASH_DASH] = ACTIONS(3553),
    [anon_sym_PLUS_PLUS] = ACTIONS(3553),
    [anon_sym_sizeof] = ACTIONS(3551),
    [anon_sym___alignof__] = ACTIONS(3551),
    [anon_sym___alignof] = ACTIONS(3551),
    [anon_sym__alignof] = ACTIONS(3551),
    [anon_sym_alignof] = ACTIONS(3551),
    [anon_sym__Alignof] = ACTIONS(3551),
    [anon_sym_offsetof] = ACTIONS(3551),
    [anon_sym__Generic] = ACTIONS(3551),
    [anon_sym_asm] = ACTIONS(3551),
    [anon_sym___asm__] = ACTIONS(3551),
    [sym_number_literal] = ACTIONS(3553),
    [anon_sym_L_SQUOTE] = ACTIONS(3553),
    [anon_sym_u_SQUOTE] = ACTIONS(3553),
    [anon_sym_U_SQUOTE] = ACTIONS(3553),
    [anon_sym_u8_SQUOTE] = ACTIONS(3553),
    [anon_sym_SQUOTE] = ACTIONS(3553),
    [anon_sym_L_DQUOTE] = ACTIONS(3553),
    [anon_sym_u_DQUOTE] = ACTIONS(3553),
    [anon_sym_U_DQUOTE] = ACTIONS(3553),
    [anon_sym_u8_DQUOTE] = ACTIONS(3553),
    [anon_sym_DQUOTE] = ACTIONS(3553),
    [sym_true] = ACTIONS(3551),
    [sym_false] = ACTIONS(3551),
    [anon_sym_NULL] = ACTIONS(3551),
    [anon_sym_nullptr] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3551),
    [anon_sym_let] = ACTIONS(3551),
    [anon_sym_This] = ACTIONS(3551),
    [anon_sym_decltype] = ACTIONS(3551),
    [sym_virtual] = ACTIONS(3551),
    [anon_sym_explicit] = ACTIONS(3551),
    [anon_sym_typename] = ACTIONS(3551),
    [anon_sym_template] = ACTIONS(3551),
    [anon_sym_operator] = ACTIONS(3551),
    [anon_sym_try] = ACTIONS(3551),
    [anon_sym_delete] = ACTIONS(3551),
    [anon_sym_throw] = ACTIONS(3551),
    [anon_sym_namespace] = ACTIONS(3551),
    [anon_sym_using] = ACTIONS(3551),
    [anon_sym_static_assert] = ACTIONS(3551),
    [anon_sym_concept] = ACTIONS(3551),
    [anon_sym_co_return] = ACTIONS(3551),
    [anon_sym_co_yield] = ACTIONS(3551),
    [anon_sym_R_DQUOTE] = ACTIONS(3553),
    [anon_sym_LR_DQUOTE] = ACTIONS(3553),
    [anon_sym_uR_DQUOTE] = ACTIONS(3553),
    [anon_sym_UR_DQUOTE] = ACTIONS(3553),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3553),
    [anon_sym_co_await] = ACTIONS(3551),
    [anon_sym_new] = ACTIONS(3551),
    [anon_sym_requires] = ACTIONS(3551),
    [sym_this] = ACTIONS(3551),
    [anon_sym_precise] = ACTIONS(3551),
    [anon_sym_shared] = ACTIONS(3551),
    [anon_sym_groupshared] = ACTIONS(3551),
    [anon_sym_uniform] = ACTIONS(3551),
    [anon_sym_row_major] = ACTIONS(3551),
    [anon_sym_column_major] = ACTIONS(3551),
    [anon_sym_globallycoherent] = ACTIONS(3551),
    [anon_sym_centroid] = ACTIONS(3551),
    [anon_sym_noperspective] = ACTIONS(3551),
    [anon_sym_nointerpolation] = ACTIONS(3551),
    [anon_sym_sample] = ACTIONS(3551),
    [anon_sym_linear] = ACTIONS(3551),
    [anon_sym_snorm] = ACTIONS(3551),
    [anon_sym_unorm] = ACTIONS(3551),
    [anon_sym_point] = ACTIONS(3551),
    [anon_sym_line] = ACTIONS(3551),
    [anon_sym_triangleadj] = ACTIONS(3551),
    [anon_sym_lineadj] = ACTIONS(3551),
    [anon_sym_triangle] = ACTIONS(3551),
    [anon_sym_interface] = ACTIONS(3551),
    [anon_sym_extension] = ACTIONS(3551),
    [anon_sym___exported] = ACTIONS(3551),
    [anon_sym_import] = ACTIONS(3551),
  },
  [1060] = {
    [ts_builtin_sym_end] = ACTIONS(3495),
    [sym_identifier] = ACTIONS(3493),
    [aux_sym_preproc_include_token1] = ACTIONS(3493),
    [aux_sym_preproc_def_token1] = ACTIONS(3493),
    [aux_sym_preproc_if_token1] = ACTIONS(3493),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3493),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3493),
    [sym_preproc_directive] = ACTIONS(3493),
    [anon_sym_LPAREN2] = ACTIONS(3495),
    [anon_sym_BANG] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3495),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_PLUS] = ACTIONS(3493),
    [anon_sym_STAR] = ACTIONS(3495),
    [anon_sym_AMP_AMP] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym___extension__] = ACTIONS(3493),
    [anon_sym_typedef] = ACTIONS(3493),
    [anon_sym_in] = ACTIONS(3493),
    [anon_sym_out] = ACTIONS(3493),
    [anon_sym_inout] = ACTIONS(3493),
    [anon_sym_extern] = ACTIONS(3493),
    [anon_sym___attribute__] = ACTIONS(3493),
    [anon_sym_COLON_COLON] = ACTIONS(3495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3495),
    [anon_sym___declspec] = ACTIONS(3493),
    [anon_sym___based] = ACTIONS(3493),
    [anon_sym___cdecl] = ACTIONS(3493),
    [anon_sym___clrcall] = ACTIONS(3493),
    [anon_sym___stdcall] = ACTIONS(3493),
    [anon_sym___fastcall] = ACTIONS(3493),
    [anon_sym___thiscall] = ACTIONS(3493),
    [anon_sym___vectorcall] = ACTIONS(3493),
    [anon_sym_LBRACE] = ACTIONS(3495),
    [anon_sym_signed] = ACTIONS(3493),
    [anon_sym_unsigned] = ACTIONS(3493),
    [anon_sym_long] = ACTIONS(3493),
    [anon_sym_short] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3493),
    [anon_sym_static] = ACTIONS(3493),
    [anon_sym_register] = ACTIONS(3493),
    [anon_sym_inline] = ACTIONS(3493),
    [anon_sym___inline] = ACTIONS(3493),
    [anon_sym___inline__] = ACTIONS(3493),
    [anon_sym___forceinline] = ACTIONS(3493),
    [anon_sym_thread_local] = ACTIONS(3493),
    [anon_sym___thread] = ACTIONS(3493),
    [anon_sym_const] = ACTIONS(3493),
    [anon_sym_constexpr] = ACTIONS(3493),
    [anon_sym_volatile] = ACTIONS(3493),
    [anon_sym_restrict] = ACTIONS(3493),
    [anon_sym___restrict__] = ACTIONS(3493),
    [anon_sym__Atomic] = ACTIONS(3493),
    [anon_sym__Noreturn] = ACTIONS(3493),
    [anon_sym_noreturn] = ACTIONS(3493),
    [anon_sym_mutable] = ACTIONS(3493),
    [anon_sym_constinit] = ACTIONS(3493),
    [anon_sym_consteval] = ACTIONS(3493),
    [anon_sym_alignas] = ACTIONS(3493),
    [anon_sym__Alignas] = ACTIONS(3493),
    [sym_primitive_type] = ACTIONS(3493),
    [anon_sym_enum] = ACTIONS(3493),
    [anon_sym_class] = ACTIONS(3493),
    [anon_sym_struct] = ACTIONS(3493),
    [anon_sym_union] = ACTIONS(3493),
    [anon_sym_if] = ACTIONS(3493),
    [anon_sym_switch] = ACTIONS(3493),
    [anon_sym_case] = ACTIONS(3493),
    [anon_sym_default] = ACTIONS(3493),
    [anon_sym_while] = ACTIONS(3493),
    [anon_sym_do] = ACTIONS(3493),
    [anon_sym_for] = ACTIONS(3493),
    [anon_sym_return] = ACTIONS(3493),
    [anon_sym_break] = ACTIONS(3493),
    [anon_sym_continue] = ACTIONS(3493),
    [anon_sym_goto] = ACTIONS(3493),
    [anon_sym_not] = ACTIONS(3493),
    [anon_sym_compl] = ACTIONS(3493),
    [anon_sym_DASH_DASH] = ACTIONS(3495),
    [anon_sym_PLUS_PLUS] = ACTIONS(3495),
    [anon_sym_sizeof] = ACTIONS(3493),
    [anon_sym___alignof__] = ACTIONS(3493),
    [anon_sym___alignof] = ACTIONS(3493),
    [anon_sym__alignof] = ACTIONS(3493),
    [anon_sym_alignof] = ACTIONS(3493),
    [anon_sym__Alignof] = ACTIONS(3493),
    [anon_sym_offsetof] = ACTIONS(3493),
    [anon_sym__Generic] = ACTIONS(3493),
    [anon_sym_asm] = ACTIONS(3493),
    [anon_sym___asm__] = ACTIONS(3493),
    [sym_number_literal] = ACTIONS(3495),
    [anon_sym_L_SQUOTE] = ACTIONS(3495),
    [anon_sym_u_SQUOTE] = ACTIONS(3495),
    [anon_sym_U_SQUOTE] = ACTIONS(3495),
    [anon_sym_u8_SQUOTE] = ACTIONS(3495),
    [anon_sym_SQUOTE] = ACTIONS(3495),
    [anon_sym_L_DQUOTE] = ACTIONS(3495),
    [anon_sym_u_DQUOTE] = ACTIONS(3495),
    [anon_sym_U_DQUOTE] = ACTIONS(3495),
    [anon_sym_u8_DQUOTE] = ACTIONS(3495),
    [anon_sym_DQUOTE] = ACTIONS(3495),
    [sym_true] = ACTIONS(3493),
    [sym_false] = ACTIONS(3493),
    [anon_sym_NULL] = ACTIONS(3493),
    [anon_sym_nullptr] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3493),
    [anon_sym_let] = ACTIONS(3493),
    [anon_sym_This] = ACTIONS(3493),
    [anon_sym_decltype] = ACTIONS(3493),
    [sym_virtual] = ACTIONS(3493),
    [anon_sym_explicit] = ACTIONS(3493),
    [anon_sym_typename] = ACTIONS(3493),
    [anon_sym_template] = ACTIONS(3493),
    [anon_sym_operator] = ACTIONS(3493),
    [anon_sym_try] = ACTIONS(3493),
    [anon_sym_delete] = ACTIONS(3493),
    [anon_sym_throw] = ACTIONS(3493),
    [anon_sym_namespace] = ACTIONS(3493),
    [anon_sym_using] = ACTIONS(3493),
    [anon_sym_static_assert] = ACTIONS(3493),
    [anon_sym_concept] = ACTIONS(3493),
    [anon_sym_co_return] = ACTIONS(3493),
    [anon_sym_co_yield] = ACTIONS(3493),
    [anon_sym_R_DQUOTE] = ACTIONS(3495),
    [anon_sym_LR_DQUOTE] = ACTIONS(3495),
    [anon_sym_uR_DQUOTE] = ACTIONS(3495),
    [anon_sym_UR_DQUOTE] = ACTIONS(3495),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3495),
    [anon_sym_co_await] = ACTIONS(3493),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_requires] = ACTIONS(3493),
    [sym_this] = ACTIONS(3493),
    [anon_sym_precise] = ACTIONS(3493),
    [anon_sym_shared] = ACTIONS(3493),
    [anon_sym_groupshared] = ACTIONS(3493),
    [anon_sym_uniform] = ACTIONS(3493),
    [anon_sym_row_major] = ACTIONS(3493),
    [anon_sym_column_major] = ACTIONS(3493),
    [anon_sym_globallycoherent] = ACTIONS(3493),
    [anon_sym_centroid] = ACTIONS(3493),
    [anon_sym_noperspective] = ACTIONS(3493),
    [anon_sym_nointerpolation] = ACTIONS(3493),
    [anon_sym_sample] = ACTIONS(3493),
    [anon_sym_linear] = ACTIONS(3493),
    [anon_sym_snorm] = ACTIONS(3493),
    [anon_sym_unorm] = ACTIONS(3493),
    [anon_sym_point] = ACTIONS(3493),
    [anon_sym_line] = ACTIONS(3493),
    [anon_sym_triangleadj] = ACTIONS(3493),
    [anon_sym_lineadj] = ACTIONS(3493),
    [anon_sym_triangle] = ACTIONS(3493),
    [anon_sym_interface] = ACTIONS(3493),
    [anon_sym_extension] = ACTIONS(3493),
    [anon_sym___exported] = ACTIONS(3493),
    [anon_sym_import] = ACTIONS(3493),
  },
  [1061] = {
    [ts_builtin_sym_end] = ACTIONS(3615),
    [sym_identifier] = ACTIONS(3613),
    [aux_sym_preproc_include_token1] = ACTIONS(3613),
    [aux_sym_preproc_def_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3613),
    [sym_preproc_directive] = ACTIONS(3613),
    [anon_sym_LPAREN2] = ACTIONS(3615),
    [anon_sym_BANG] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3613),
    [anon_sym_PLUS] = ACTIONS(3613),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym___extension__] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3613),
    [anon_sym_in] = ACTIONS(3613),
    [anon_sym_out] = ACTIONS(3613),
    [anon_sym_inout] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym___attribute__] = ACTIONS(3613),
    [anon_sym_COLON_COLON] = ACTIONS(3615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3615),
    [anon_sym___declspec] = ACTIONS(3613),
    [anon_sym___based] = ACTIONS(3613),
    [anon_sym___cdecl] = ACTIONS(3613),
    [anon_sym___clrcall] = ACTIONS(3613),
    [anon_sym___stdcall] = ACTIONS(3613),
    [anon_sym___fastcall] = ACTIONS(3613),
    [anon_sym___thiscall] = ACTIONS(3613),
    [anon_sym___vectorcall] = ACTIONS(3613),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_signed] = ACTIONS(3613),
    [anon_sym_unsigned] = ACTIONS(3613),
    [anon_sym_long] = ACTIONS(3613),
    [anon_sym_short] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_register] = ACTIONS(3613),
    [anon_sym_inline] = ACTIONS(3613),
    [anon_sym___inline] = ACTIONS(3613),
    [anon_sym___inline__] = ACTIONS(3613),
    [anon_sym___forceinline] = ACTIONS(3613),
    [anon_sym_thread_local] = ACTIONS(3613),
    [anon_sym___thread] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_constexpr] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_restrict] = ACTIONS(3613),
    [anon_sym___restrict__] = ACTIONS(3613),
    [anon_sym__Atomic] = ACTIONS(3613),
    [anon_sym__Noreturn] = ACTIONS(3613),
    [anon_sym_noreturn] = ACTIONS(3613),
    [anon_sym_mutable] = ACTIONS(3613),
    [anon_sym_constinit] = ACTIONS(3613),
    [anon_sym_consteval] = ACTIONS(3613),
    [anon_sym_alignas] = ACTIONS(3613),
    [anon_sym__Alignas] = ACTIONS(3613),
    [sym_primitive_type] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_union] = ACTIONS(3613),
    [anon_sym_if] = ACTIONS(3613),
    [anon_sym_switch] = ACTIONS(3613),
    [anon_sym_case] = ACTIONS(3613),
    [anon_sym_default] = ACTIONS(3613),
    [anon_sym_while] = ACTIONS(3613),
    [anon_sym_do] = ACTIONS(3613),
    [anon_sym_for] = ACTIONS(3613),
    [anon_sym_return] = ACTIONS(3613),
    [anon_sym_break] = ACTIONS(3613),
    [anon_sym_continue] = ACTIONS(3613),
    [anon_sym_goto] = ACTIONS(3613),
    [anon_sym_not] = ACTIONS(3613),
    [anon_sym_compl] = ACTIONS(3613),
    [anon_sym_DASH_DASH] = ACTIONS(3615),
    [anon_sym_PLUS_PLUS] = ACTIONS(3615),
    [anon_sym_sizeof] = ACTIONS(3613),
    [anon_sym___alignof__] = ACTIONS(3613),
    [anon_sym___alignof] = ACTIONS(3613),
    [anon_sym__alignof] = ACTIONS(3613),
    [anon_sym_alignof] = ACTIONS(3613),
    [anon_sym__Alignof] = ACTIONS(3613),
    [anon_sym_offsetof] = ACTIONS(3613),
    [anon_sym__Generic] = ACTIONS(3613),
    [anon_sym_asm] = ACTIONS(3613),
    [anon_sym___asm__] = ACTIONS(3613),
    [sym_number_literal] = ACTIONS(3615),
    [anon_sym_L_SQUOTE] = ACTIONS(3615),
    [anon_sym_u_SQUOTE] = ACTIONS(3615),
    [anon_sym_U_SQUOTE] = ACTIONS(3615),
    [anon_sym_u8_SQUOTE] = ACTIONS(3615),
    [anon_sym_SQUOTE] = ACTIONS(3615),
    [anon_sym_L_DQUOTE] = ACTIONS(3615),
    [anon_sym_u_DQUOTE] = ACTIONS(3615),
    [anon_sym_U_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8_DQUOTE] = ACTIONS(3615),
    [anon_sym_DQUOTE] = ACTIONS(3615),
    [sym_true] = ACTIONS(3613),
    [sym_false] = ACTIONS(3613),
    [anon_sym_NULL] = ACTIONS(3613),
    [anon_sym_nullptr] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_This] = ACTIONS(3613),
    [anon_sym_decltype] = ACTIONS(3613),
    [sym_virtual] = ACTIONS(3613),
    [anon_sym_explicit] = ACTIONS(3613),
    [anon_sym_typename] = ACTIONS(3613),
    [anon_sym_template] = ACTIONS(3613),
    [anon_sym_operator] = ACTIONS(3613),
    [anon_sym_try] = ACTIONS(3613),
    [anon_sym_delete] = ACTIONS(3613),
    [anon_sym_throw] = ACTIONS(3613),
    [anon_sym_namespace] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_static_assert] = ACTIONS(3613),
    [anon_sym_concept] = ACTIONS(3613),
    [anon_sym_co_return] = ACTIONS(3613),
    [anon_sym_co_yield] = ACTIONS(3613),
    [anon_sym_R_DQUOTE] = ACTIONS(3615),
    [anon_sym_LR_DQUOTE] = ACTIONS(3615),
    [anon_sym_uR_DQUOTE] = ACTIONS(3615),
    [anon_sym_UR_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3615),
    [anon_sym_co_await] = ACTIONS(3613),
    [anon_sym_new] = ACTIONS(3613),
    [anon_sym_requires] = ACTIONS(3613),
    [sym_this] = ACTIONS(3613),
    [anon_sym_precise] = ACTIONS(3613),
    [anon_sym_shared] = ACTIONS(3613),
    [anon_sym_groupshared] = ACTIONS(3613),
    [anon_sym_uniform] = ACTIONS(3613),
    [anon_sym_row_major] = ACTIONS(3613),
    [anon_sym_column_major] = ACTIONS(3613),
    [anon_sym_globallycoherent] = ACTIONS(3613),
    [anon_sym_centroid] = ACTIONS(3613),
    [anon_sym_noperspective] = ACTIONS(3613),
    [anon_sym_nointerpolation] = ACTIONS(3613),
    [anon_sym_sample] = ACTIONS(3613),
    [anon_sym_linear] = ACTIONS(3613),
    [anon_sym_snorm] = ACTIONS(3613),
    [anon_sym_unorm] = ACTIONS(3613),
    [anon_sym_point] = ACTIONS(3613),
    [anon_sym_line] = ACTIONS(3613),
    [anon_sym_triangleadj] = ACTIONS(3613),
    [anon_sym_lineadj] = ACTIONS(3613),
    [anon_sym_triangle] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_extension] = ACTIONS(3613),
    [anon_sym___exported] = ACTIONS(3613),
    [anon_sym_import] = ACTIONS(3613),
  },
  [1062] = {
    [ts_builtin_sym_end] = ACTIONS(3693),
    [sym_identifier] = ACTIONS(3691),
    [aux_sym_preproc_include_token1] = ACTIONS(3691),
    [aux_sym_preproc_def_token1] = ACTIONS(3691),
    [aux_sym_preproc_if_token1] = ACTIONS(3691),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3691),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3691),
    [sym_preproc_directive] = ACTIONS(3691),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_BANG] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_PLUS] = ACTIONS(3691),
    [anon_sym_STAR] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_AMP] = ACTIONS(3691),
    [anon_sym___extension__] = ACTIONS(3691),
    [anon_sym_typedef] = ACTIONS(3691),
    [anon_sym_in] = ACTIONS(3691),
    [anon_sym_out] = ACTIONS(3691),
    [anon_sym_inout] = ACTIONS(3691),
    [anon_sym_extern] = ACTIONS(3691),
    [anon_sym___attribute__] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3693),
    [anon_sym___declspec] = ACTIONS(3691),
    [anon_sym___based] = ACTIONS(3691),
    [anon_sym___cdecl] = ACTIONS(3691),
    [anon_sym___clrcall] = ACTIONS(3691),
    [anon_sym___stdcall] = ACTIONS(3691),
    [anon_sym___fastcall] = ACTIONS(3691),
    [anon_sym___thiscall] = ACTIONS(3691),
    [anon_sym___vectorcall] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_signed] = ACTIONS(3691),
    [anon_sym_unsigned] = ACTIONS(3691),
    [anon_sym_long] = ACTIONS(3691),
    [anon_sym_short] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(3691),
    [anon_sym_static] = ACTIONS(3691),
    [anon_sym_register] = ACTIONS(3691),
    [anon_sym_inline] = ACTIONS(3691),
    [anon_sym___inline] = ACTIONS(3691),
    [anon_sym___inline__] = ACTIONS(3691),
    [anon_sym___forceinline] = ACTIONS(3691),
    [anon_sym_thread_local] = ACTIONS(3691),
    [anon_sym___thread] = ACTIONS(3691),
    [anon_sym_const] = ACTIONS(3691),
    [anon_sym_constexpr] = ACTIONS(3691),
    [anon_sym_volatile] = ACTIONS(3691),
    [anon_sym_restrict] = ACTIONS(3691),
    [anon_sym___restrict__] = ACTIONS(3691),
    [anon_sym__Atomic] = ACTIONS(3691),
    [anon_sym__Noreturn] = ACTIONS(3691),
    [anon_sym_noreturn] = ACTIONS(3691),
    [anon_sym_mutable] = ACTIONS(3691),
    [anon_sym_constinit] = ACTIONS(3691),
    [anon_sym_consteval] = ACTIONS(3691),
    [anon_sym_alignas] = ACTIONS(3691),
    [anon_sym__Alignas] = ACTIONS(3691),
    [sym_primitive_type] = ACTIONS(3691),
    [anon_sym_enum] = ACTIONS(3691),
    [anon_sym_class] = ACTIONS(3691),
    [anon_sym_struct] = ACTIONS(3691),
    [anon_sym_union] = ACTIONS(3691),
    [anon_sym_if] = ACTIONS(3691),
    [anon_sym_switch] = ACTIONS(3691),
    [anon_sym_case] = ACTIONS(3691),
    [anon_sym_default] = ACTIONS(3691),
    [anon_sym_while] = ACTIONS(3691),
    [anon_sym_do] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3691),
    [anon_sym_return] = ACTIONS(3691),
    [anon_sym_break] = ACTIONS(3691),
    [anon_sym_continue] = ACTIONS(3691),
    [anon_sym_goto] = ACTIONS(3691),
    [anon_sym_not] = ACTIONS(3691),
    [anon_sym_compl] = ACTIONS(3691),
    [anon_sym_DASH_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_PLUS] = ACTIONS(3693),
    [anon_sym_sizeof] = ACTIONS(3691),
    [anon_sym___alignof__] = ACTIONS(3691),
    [anon_sym___alignof] = ACTIONS(3691),
    [anon_sym__alignof] = ACTIONS(3691),
    [anon_sym_alignof] = ACTIONS(3691),
    [anon_sym__Alignof] = ACTIONS(3691),
    [anon_sym_offsetof] = ACTIONS(3691),
    [anon_sym__Generic] = ACTIONS(3691),
    [anon_sym_asm] = ACTIONS(3691),
    [anon_sym___asm__] = ACTIONS(3691),
    [sym_number_literal] = ACTIONS(3693),
    [anon_sym_L_SQUOTE] = ACTIONS(3693),
    [anon_sym_u_SQUOTE] = ACTIONS(3693),
    [anon_sym_U_SQUOTE] = ACTIONS(3693),
    [anon_sym_u8_SQUOTE] = ACTIONS(3693),
    [anon_sym_SQUOTE] = ACTIONS(3693),
    [anon_sym_L_DQUOTE] = ACTIONS(3693),
    [anon_sym_u_DQUOTE] = ACTIONS(3693),
    [anon_sym_U_DQUOTE] = ACTIONS(3693),
    [anon_sym_u8_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [sym_true] = ACTIONS(3691),
    [sym_false] = ACTIONS(3691),
    [anon_sym_NULL] = ACTIONS(3691),
    [anon_sym_nullptr] = ACTIONS(3691),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3691),
    [anon_sym_let] = ACTIONS(3691),
    [anon_sym_This] = ACTIONS(3691),
    [anon_sym_decltype] = ACTIONS(3691),
    [sym_virtual] = ACTIONS(3691),
    [anon_sym_explicit] = ACTIONS(3691),
    [anon_sym_typename] = ACTIONS(3691),
    [anon_sym_template] = ACTIONS(3691),
    [anon_sym_operator] = ACTIONS(3691),
    [anon_sym_try] = ACTIONS(3691),
    [anon_sym_delete] = ACTIONS(3691),
    [anon_sym_throw] = ACTIONS(3691),
    [anon_sym_namespace] = ACTIONS(3691),
    [anon_sym_using] = ACTIONS(3691),
    [anon_sym_static_assert] = ACTIONS(3691),
    [anon_sym_concept] = ACTIONS(3691),
    [anon_sym_co_return] = ACTIONS(3691),
    [anon_sym_co_yield] = ACTIONS(3691),
    [anon_sym_R_DQUOTE] = ACTIONS(3693),
    [anon_sym_LR_DQUOTE] = ACTIONS(3693),
    [anon_sym_uR_DQUOTE] = ACTIONS(3693),
    [anon_sym_UR_DQUOTE] = ACTIONS(3693),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3693),
    [anon_sym_co_await] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3691),
    [anon_sym_requires] = ACTIONS(3691),
    [sym_this] = ACTIONS(3691),
    [anon_sym_precise] = ACTIONS(3691),
    [anon_sym_shared] = ACTIONS(3691),
    [anon_sym_groupshared] = ACTIONS(3691),
    [anon_sym_uniform] = ACTIONS(3691),
    [anon_sym_row_major] = ACTIONS(3691),
    [anon_sym_column_major] = ACTIONS(3691),
    [anon_sym_globallycoherent] = ACTIONS(3691),
    [anon_sym_centroid] = ACTIONS(3691),
    [anon_sym_noperspective] = ACTIONS(3691),
    [anon_sym_nointerpolation] = ACTIONS(3691),
    [anon_sym_sample] = ACTIONS(3691),
    [anon_sym_linear] = ACTIONS(3691),
    [anon_sym_snorm] = ACTIONS(3691),
    [anon_sym_unorm] = ACTIONS(3691),
    [anon_sym_point] = ACTIONS(3691),
    [anon_sym_line] = ACTIONS(3691),
    [anon_sym_triangleadj] = ACTIONS(3691),
    [anon_sym_lineadj] = ACTIONS(3691),
    [anon_sym_triangle] = ACTIONS(3691),
    [anon_sym_interface] = ACTIONS(3691),
    [anon_sym_extension] = ACTIONS(3691),
    [anon_sym___exported] = ACTIONS(3691),
    [anon_sym_import] = ACTIONS(3691),
  },
  [1063] = {
    [ts_builtin_sym_end] = ACTIONS(3635),
    [sym_identifier] = ACTIONS(3633),
    [aux_sym_preproc_include_token1] = ACTIONS(3633),
    [aux_sym_preproc_def_token1] = ACTIONS(3633),
    [aux_sym_preproc_if_token1] = ACTIONS(3633),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3633),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3633),
    [sym_preproc_directive] = ACTIONS(3633),
    [anon_sym_LPAREN2] = ACTIONS(3635),
    [anon_sym_BANG] = ACTIONS(3635),
    [anon_sym_TILDE] = ACTIONS(3635),
    [anon_sym_DASH] = ACTIONS(3633),
    [anon_sym_PLUS] = ACTIONS(3633),
    [anon_sym_STAR] = ACTIONS(3635),
    [anon_sym_AMP_AMP] = ACTIONS(3635),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym___extension__] = ACTIONS(3633),
    [anon_sym_typedef] = ACTIONS(3633),
    [anon_sym_in] = ACTIONS(3633),
    [anon_sym_out] = ACTIONS(3633),
    [anon_sym_inout] = ACTIONS(3633),
    [anon_sym_extern] = ACTIONS(3633),
    [anon_sym___attribute__] = ACTIONS(3633),
    [anon_sym_COLON_COLON] = ACTIONS(3635),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3635),
    [anon_sym___declspec] = ACTIONS(3633),
    [anon_sym___based] = ACTIONS(3633),
    [anon_sym___cdecl] = ACTIONS(3633),
    [anon_sym___clrcall] = ACTIONS(3633),
    [anon_sym___stdcall] = ACTIONS(3633),
    [anon_sym___fastcall] = ACTIONS(3633),
    [anon_sym___thiscall] = ACTIONS(3633),
    [anon_sym___vectorcall] = ACTIONS(3633),
    [anon_sym_LBRACE] = ACTIONS(3635),
    [anon_sym_signed] = ACTIONS(3633),
    [anon_sym_unsigned] = ACTIONS(3633),
    [anon_sym_long] = ACTIONS(3633),
    [anon_sym_short] = ACTIONS(3633),
    [anon_sym_LBRACK] = ACTIONS(3633),
    [anon_sym_static] = ACTIONS(3633),
    [anon_sym_register] = ACTIONS(3633),
    [anon_sym_inline] = ACTIONS(3633),
    [anon_sym___inline] = ACTIONS(3633),
    [anon_sym___inline__] = ACTIONS(3633),
    [anon_sym___forceinline] = ACTIONS(3633),
    [anon_sym_thread_local] = ACTIONS(3633),
    [anon_sym___thread] = ACTIONS(3633),
    [anon_sym_const] = ACTIONS(3633),
    [anon_sym_constexpr] = ACTIONS(3633),
    [anon_sym_volatile] = ACTIONS(3633),
    [anon_sym_restrict] = ACTIONS(3633),
    [anon_sym___restrict__] = ACTIONS(3633),
    [anon_sym__Atomic] = ACTIONS(3633),
    [anon_sym__Noreturn] = ACTIONS(3633),
    [anon_sym_noreturn] = ACTIONS(3633),
    [anon_sym_mutable] = ACTIONS(3633),
    [anon_sym_constinit] = ACTIONS(3633),
    [anon_sym_consteval] = ACTIONS(3633),
    [anon_sym_alignas] = ACTIONS(3633),
    [anon_sym__Alignas] = ACTIONS(3633),
    [sym_primitive_type] = ACTIONS(3633),
    [anon_sym_enum] = ACTIONS(3633),
    [anon_sym_class] = ACTIONS(3633),
    [anon_sym_struct] = ACTIONS(3633),
    [anon_sym_union] = ACTIONS(3633),
    [anon_sym_if] = ACTIONS(3633),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_case] = ACTIONS(3633),
    [anon_sym_default] = ACTIONS(3633),
    [anon_sym_while] = ACTIONS(3633),
    [anon_sym_do] = ACTIONS(3633),
    [anon_sym_for] = ACTIONS(3633),
    [anon_sym_return] = ACTIONS(3633),
    [anon_sym_break] = ACTIONS(3633),
    [anon_sym_continue] = ACTIONS(3633),
    [anon_sym_goto] = ACTIONS(3633),
    [anon_sym_not] = ACTIONS(3633),
    [anon_sym_compl] = ACTIONS(3633),
    [anon_sym_DASH_DASH] = ACTIONS(3635),
    [anon_sym_PLUS_PLUS] = ACTIONS(3635),
    [anon_sym_sizeof] = ACTIONS(3633),
    [anon_sym___alignof__] = ACTIONS(3633),
    [anon_sym___alignof] = ACTIONS(3633),
    [anon_sym__alignof] = ACTIONS(3633),
    [anon_sym_alignof] = ACTIONS(3633),
    [anon_sym__Alignof] = ACTIONS(3633),
    [anon_sym_offsetof] = ACTIONS(3633),
    [anon_sym__Generic] = ACTIONS(3633),
    [anon_sym_asm] = ACTIONS(3633),
    [anon_sym___asm__] = ACTIONS(3633),
    [sym_number_literal] = ACTIONS(3635),
    [anon_sym_L_SQUOTE] = ACTIONS(3635),
    [anon_sym_u_SQUOTE] = ACTIONS(3635),
    [anon_sym_U_SQUOTE] = ACTIONS(3635),
    [anon_sym_u8_SQUOTE] = ACTIONS(3635),
    [anon_sym_SQUOTE] = ACTIONS(3635),
    [anon_sym_L_DQUOTE] = ACTIONS(3635),
    [anon_sym_u_DQUOTE] = ACTIONS(3635),
    [anon_sym_U_DQUOTE] = ACTIONS(3635),
    [anon_sym_u8_DQUOTE] = ACTIONS(3635),
    [anon_sym_DQUOTE] = ACTIONS(3635),
    [sym_true] = ACTIONS(3633),
    [sym_false] = ACTIONS(3633),
    [anon_sym_NULL] = ACTIONS(3633),
    [anon_sym_nullptr] = ACTIONS(3633),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3633),
    [anon_sym_let] = ACTIONS(3633),
    [anon_sym_This] = ACTIONS(3633),
    [anon_sym_decltype] = ACTIONS(3633),
    [sym_virtual] = ACTIONS(3633),
    [anon_sym_explicit] = ACTIONS(3633),
    [anon_sym_typename] = ACTIONS(3633),
    [anon_sym_template] = ACTIONS(3633),
    [anon_sym_operator] = ACTIONS(3633),
    [anon_sym_try] = ACTIONS(3633),
    [anon_sym_delete] = ACTIONS(3633),
    [anon_sym_throw] = ACTIONS(3633),
    [anon_sym_namespace] = ACTIONS(3633),
    [anon_sym_using] = ACTIONS(3633),
    [anon_sym_static_assert] = ACTIONS(3633),
    [anon_sym_concept] = ACTIONS(3633),
    [anon_sym_co_return] = ACTIONS(3633),
    [anon_sym_co_yield] = ACTIONS(3633),
    [anon_sym_R_DQUOTE] = ACTIONS(3635),
    [anon_sym_LR_DQUOTE] = ACTIONS(3635),
    [anon_sym_uR_DQUOTE] = ACTIONS(3635),
    [anon_sym_UR_DQUOTE] = ACTIONS(3635),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3635),
    [anon_sym_co_await] = ACTIONS(3633),
    [anon_sym_new] = ACTIONS(3633),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(3633),
    [anon_sym_precise] = ACTIONS(3633),
    [anon_sym_shared] = ACTIONS(3633),
    [anon_sym_groupshared] = ACTIONS(3633),
    [anon_sym_uniform] = ACTIONS(3633),
    [anon_sym_row_major] = ACTIONS(3633),
    [anon_sym_column_major] = ACTIONS(3633),
    [anon_sym_globallycoherent] = ACTIONS(3633),
    [anon_sym_centroid] = ACTIONS(3633),
    [anon_sym_noperspective] = ACTIONS(3633),
    [anon_sym_nointerpolation] = ACTIONS(3633),
    [anon_sym_sample] = ACTIONS(3633),
    [anon_sym_linear] = ACTIONS(3633),
    [anon_sym_snorm] = ACTIONS(3633),
    [anon_sym_unorm] = ACTIONS(3633),
    [anon_sym_point] = ACTIONS(3633),
    [anon_sym_line] = ACTIONS(3633),
    [anon_sym_triangleadj] = ACTIONS(3633),
    [anon_sym_lineadj] = ACTIONS(3633),
    [anon_sym_triangle] = ACTIONS(3633),
    [anon_sym_interface] = ACTIONS(3633),
    [anon_sym_extension] = ACTIONS(3633),
    [anon_sym___exported] = ACTIONS(3633),
    [anon_sym_import] = ACTIONS(3633),
  },
  [1064] = {
    [ts_builtin_sym_end] = ACTIONS(3577),
    [sym_identifier] = ACTIONS(3575),
    [aux_sym_preproc_include_token1] = ACTIONS(3575),
    [aux_sym_preproc_def_token1] = ACTIONS(3575),
    [aux_sym_preproc_if_token1] = ACTIONS(3575),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3575),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3575),
    [sym_preproc_directive] = ACTIONS(3575),
    [anon_sym_LPAREN2] = ACTIONS(3577),
    [anon_sym_BANG] = ACTIONS(3577),
    [anon_sym_TILDE] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3575),
    [anon_sym_PLUS] = ACTIONS(3575),
    [anon_sym_STAR] = ACTIONS(3577),
    [anon_sym_AMP_AMP] = ACTIONS(3577),
    [anon_sym_AMP] = ACTIONS(3575),
    [anon_sym___extension__] = ACTIONS(3575),
    [anon_sym_typedef] = ACTIONS(3575),
    [anon_sym_in] = ACTIONS(3575),
    [anon_sym_out] = ACTIONS(3575),
    [anon_sym_inout] = ACTIONS(3575),
    [anon_sym_extern] = ACTIONS(3575),
    [anon_sym___attribute__] = ACTIONS(3575),
    [anon_sym_COLON_COLON] = ACTIONS(3577),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3577),
    [anon_sym___declspec] = ACTIONS(3575),
    [anon_sym___based] = ACTIONS(3575),
    [anon_sym___cdecl] = ACTIONS(3575),
    [anon_sym___clrcall] = ACTIONS(3575),
    [anon_sym___stdcall] = ACTIONS(3575),
    [anon_sym___fastcall] = ACTIONS(3575),
    [anon_sym___thiscall] = ACTIONS(3575),
    [anon_sym___vectorcall] = ACTIONS(3575),
    [anon_sym_LBRACE] = ACTIONS(3577),
    [anon_sym_signed] = ACTIONS(3575),
    [anon_sym_unsigned] = ACTIONS(3575),
    [anon_sym_long] = ACTIONS(3575),
    [anon_sym_short] = ACTIONS(3575),
    [anon_sym_LBRACK] = ACTIONS(3575),
    [anon_sym_static] = ACTIONS(3575),
    [anon_sym_register] = ACTIONS(3575),
    [anon_sym_inline] = ACTIONS(3575),
    [anon_sym___inline] = ACTIONS(3575),
    [anon_sym___inline__] = ACTIONS(3575),
    [anon_sym___forceinline] = ACTIONS(3575),
    [anon_sym_thread_local] = ACTIONS(3575),
    [anon_sym___thread] = ACTIONS(3575),
    [anon_sym_const] = ACTIONS(3575),
    [anon_sym_constexpr] = ACTIONS(3575),
    [anon_sym_volatile] = ACTIONS(3575),
    [anon_sym_restrict] = ACTIONS(3575),
    [anon_sym___restrict__] = ACTIONS(3575),
    [anon_sym__Atomic] = ACTIONS(3575),
    [anon_sym__Noreturn] = ACTIONS(3575),
    [anon_sym_noreturn] = ACTIONS(3575),
    [anon_sym_mutable] = ACTIONS(3575),
    [anon_sym_constinit] = ACTIONS(3575),
    [anon_sym_consteval] = ACTIONS(3575),
    [anon_sym_alignas] = ACTIONS(3575),
    [anon_sym__Alignas] = ACTIONS(3575),
    [sym_primitive_type] = ACTIONS(3575),
    [anon_sym_enum] = ACTIONS(3575),
    [anon_sym_class] = ACTIONS(3575),
    [anon_sym_struct] = ACTIONS(3575),
    [anon_sym_union] = ACTIONS(3575),
    [anon_sym_if] = ACTIONS(3575),
    [anon_sym_switch] = ACTIONS(3575),
    [anon_sym_case] = ACTIONS(3575),
    [anon_sym_default] = ACTIONS(3575),
    [anon_sym_while] = ACTIONS(3575),
    [anon_sym_do] = ACTIONS(3575),
    [anon_sym_for] = ACTIONS(3575),
    [anon_sym_return] = ACTIONS(3575),
    [anon_sym_break] = ACTIONS(3575),
    [anon_sym_continue] = ACTIONS(3575),
    [anon_sym_goto] = ACTIONS(3575),
    [anon_sym_not] = ACTIONS(3575),
    [anon_sym_compl] = ACTIONS(3575),
    [anon_sym_DASH_DASH] = ACTIONS(3577),
    [anon_sym_PLUS_PLUS] = ACTIONS(3577),
    [anon_sym_sizeof] = ACTIONS(3575),
    [anon_sym___alignof__] = ACTIONS(3575),
    [anon_sym___alignof] = ACTIONS(3575),
    [anon_sym__alignof] = ACTIONS(3575),
    [anon_sym_alignof] = ACTIONS(3575),
    [anon_sym__Alignof] = ACTIONS(3575),
    [anon_sym_offsetof] = ACTIONS(3575),
    [anon_sym__Generic] = ACTIONS(3575),
    [anon_sym_asm] = ACTIONS(3575),
    [anon_sym___asm__] = ACTIONS(3575),
    [sym_number_literal] = ACTIONS(3577),
    [anon_sym_L_SQUOTE] = ACTIONS(3577),
    [anon_sym_u_SQUOTE] = ACTIONS(3577),
    [anon_sym_U_SQUOTE] = ACTIONS(3577),
    [anon_sym_u8_SQUOTE] = ACTIONS(3577),
    [anon_sym_SQUOTE] = ACTIONS(3577),
    [anon_sym_L_DQUOTE] = ACTIONS(3577),
    [anon_sym_u_DQUOTE] = ACTIONS(3577),
    [anon_sym_U_DQUOTE] = ACTIONS(3577),
    [anon_sym_u8_DQUOTE] = ACTIONS(3577),
    [anon_sym_DQUOTE] = ACTIONS(3577),
    [sym_true] = ACTIONS(3575),
    [sym_false] = ACTIONS(3575),
    [anon_sym_NULL] = ACTIONS(3575),
    [anon_sym_nullptr] = ACTIONS(3575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3575),
    [anon_sym_let] = ACTIONS(3575),
    [anon_sym_This] = ACTIONS(3575),
    [anon_sym_decltype] = ACTIONS(3575),
    [sym_virtual] = ACTIONS(3575),
    [anon_sym_explicit] = ACTIONS(3575),
    [anon_sym_typename] = ACTIONS(3575),
    [anon_sym_template] = ACTIONS(3575),
    [anon_sym_operator] = ACTIONS(3575),
    [anon_sym_try] = ACTIONS(3575),
    [anon_sym_delete] = ACTIONS(3575),
    [anon_sym_throw] = ACTIONS(3575),
    [anon_sym_namespace] = ACTIONS(3575),
    [anon_sym_using] = ACTIONS(3575),
    [anon_sym_static_assert] = ACTIONS(3575),
    [anon_sym_concept] = ACTIONS(3575),
    [anon_sym_co_return] = ACTIONS(3575),
    [anon_sym_co_yield] = ACTIONS(3575),
    [anon_sym_R_DQUOTE] = ACTIONS(3577),
    [anon_sym_LR_DQUOTE] = ACTIONS(3577),
    [anon_sym_uR_DQUOTE] = ACTIONS(3577),
    [anon_sym_UR_DQUOTE] = ACTIONS(3577),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3577),
    [anon_sym_co_await] = ACTIONS(3575),
    [anon_sym_new] = ACTIONS(3575),
    [anon_sym_requires] = ACTIONS(3575),
    [sym_this] = ACTIONS(3575),
    [anon_sym_precise] = ACTIONS(3575),
    [anon_sym_shared] = ACTIONS(3575),
    [anon_sym_groupshared] = ACTIONS(3575),
    [anon_sym_uniform] = ACTIONS(3575),
    [anon_sym_row_major] = ACTIONS(3575),
    [anon_sym_column_major] = ACTIONS(3575),
    [anon_sym_globallycoherent] = ACTIONS(3575),
    [anon_sym_centroid] = ACTIONS(3575),
    [anon_sym_noperspective] = ACTIONS(3575),
    [anon_sym_nointerpolation] = ACTIONS(3575),
    [anon_sym_sample] = ACTIONS(3575),
    [anon_sym_linear] = ACTIONS(3575),
    [anon_sym_snorm] = ACTIONS(3575),
    [anon_sym_unorm] = ACTIONS(3575),
    [anon_sym_point] = ACTIONS(3575),
    [anon_sym_line] = ACTIONS(3575),
    [anon_sym_triangleadj] = ACTIONS(3575),
    [anon_sym_lineadj] = ACTIONS(3575),
    [anon_sym_triangle] = ACTIONS(3575),
    [anon_sym_interface] = ACTIONS(3575),
    [anon_sym_extension] = ACTIONS(3575),
    [anon_sym___exported] = ACTIONS(3575),
    [anon_sym_import] = ACTIONS(3575),
  },
  [1065] = {
    [ts_builtin_sym_end] = ACTIONS(3701),
    [sym_identifier] = ACTIONS(3699),
    [aux_sym_preproc_include_token1] = ACTIONS(3699),
    [aux_sym_preproc_def_token1] = ACTIONS(3699),
    [aux_sym_preproc_if_token1] = ACTIONS(3699),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3699),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3699),
    [sym_preproc_directive] = ACTIONS(3699),
    [anon_sym_LPAREN2] = ACTIONS(3701),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_TILDE] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_STAR] = ACTIONS(3701),
    [anon_sym_AMP_AMP] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym___extension__] = ACTIONS(3699),
    [anon_sym_typedef] = ACTIONS(3699),
    [anon_sym_in] = ACTIONS(3699),
    [anon_sym_out] = ACTIONS(3699),
    [anon_sym_inout] = ACTIONS(3699),
    [anon_sym_extern] = ACTIONS(3699),
    [anon_sym___attribute__] = ACTIONS(3699),
    [anon_sym_COLON_COLON] = ACTIONS(3701),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3701),
    [anon_sym___declspec] = ACTIONS(3699),
    [anon_sym___based] = ACTIONS(3699),
    [anon_sym___cdecl] = ACTIONS(3699),
    [anon_sym___clrcall] = ACTIONS(3699),
    [anon_sym___stdcall] = ACTIONS(3699),
    [anon_sym___fastcall] = ACTIONS(3699),
    [anon_sym___thiscall] = ACTIONS(3699),
    [anon_sym___vectorcall] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3701),
    [anon_sym_signed] = ACTIONS(3699),
    [anon_sym_unsigned] = ACTIONS(3699),
    [anon_sym_long] = ACTIONS(3699),
    [anon_sym_short] = ACTIONS(3699),
    [anon_sym_LBRACK] = ACTIONS(3699),
    [anon_sym_static] = ACTIONS(3699),
    [anon_sym_register] = ACTIONS(3699),
    [anon_sym_inline] = ACTIONS(3699),
    [anon_sym___inline] = ACTIONS(3699),
    [anon_sym___inline__] = ACTIONS(3699),
    [anon_sym___forceinline] = ACTIONS(3699),
    [anon_sym_thread_local] = ACTIONS(3699),
    [anon_sym___thread] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3699),
    [anon_sym_constexpr] = ACTIONS(3699),
    [anon_sym_volatile] = ACTIONS(3699),
    [anon_sym_restrict] = ACTIONS(3699),
    [anon_sym___restrict__] = ACTIONS(3699),
    [anon_sym__Atomic] = ACTIONS(3699),
    [anon_sym__Noreturn] = ACTIONS(3699),
    [anon_sym_noreturn] = ACTIONS(3699),
    [anon_sym_mutable] = ACTIONS(3699),
    [anon_sym_constinit] = ACTIONS(3699),
    [anon_sym_consteval] = ACTIONS(3699),
    [anon_sym_alignas] = ACTIONS(3699),
    [anon_sym__Alignas] = ACTIONS(3699),
    [sym_primitive_type] = ACTIONS(3699),
    [anon_sym_enum] = ACTIONS(3699),
    [anon_sym_class] = ACTIONS(3699),
    [anon_sym_struct] = ACTIONS(3699),
    [anon_sym_union] = ACTIONS(3699),
    [anon_sym_if] = ACTIONS(3699),
    [anon_sym_switch] = ACTIONS(3699),
    [anon_sym_case] = ACTIONS(3699),
    [anon_sym_default] = ACTIONS(3699),
    [anon_sym_while] = ACTIONS(3699),
    [anon_sym_do] = ACTIONS(3699),
    [anon_sym_for] = ACTIONS(3699),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_break] = ACTIONS(3699),
    [anon_sym_continue] = ACTIONS(3699),
    [anon_sym_goto] = ACTIONS(3699),
    [anon_sym_not] = ACTIONS(3699),
    [anon_sym_compl] = ACTIONS(3699),
    [anon_sym_DASH_DASH] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3701),
    [anon_sym_sizeof] = ACTIONS(3699),
    [anon_sym___alignof__] = ACTIONS(3699),
    [anon_sym___alignof] = ACTIONS(3699),
    [anon_sym__alignof] = ACTIONS(3699),
    [anon_sym_alignof] = ACTIONS(3699),
    [anon_sym__Alignof] = ACTIONS(3699),
    [anon_sym_offsetof] = ACTIONS(3699),
    [anon_sym__Generic] = ACTIONS(3699),
    [anon_sym_asm] = ACTIONS(3699),
    [anon_sym___asm__] = ACTIONS(3699),
    [sym_number_literal] = ACTIONS(3701),
    [anon_sym_L_SQUOTE] = ACTIONS(3701),
    [anon_sym_u_SQUOTE] = ACTIONS(3701),
    [anon_sym_U_SQUOTE] = ACTIONS(3701),
    [anon_sym_u8_SQUOTE] = ACTIONS(3701),
    [anon_sym_SQUOTE] = ACTIONS(3701),
    [anon_sym_L_DQUOTE] = ACTIONS(3701),
    [anon_sym_u_DQUOTE] = ACTIONS(3701),
    [anon_sym_U_DQUOTE] = ACTIONS(3701),
    [anon_sym_u8_DQUOTE] = ACTIONS(3701),
    [anon_sym_DQUOTE] = ACTIONS(3701),
    [sym_true] = ACTIONS(3699),
    [sym_false] = ACTIONS(3699),
    [anon_sym_NULL] = ACTIONS(3699),
    [anon_sym_nullptr] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3699),
    [anon_sym_let] = ACTIONS(3699),
    [anon_sym_This] = ACTIONS(3699),
    [anon_sym_decltype] = ACTIONS(3699),
    [sym_virtual] = ACTIONS(3699),
    [anon_sym_explicit] = ACTIONS(3699),
    [anon_sym_typename] = ACTIONS(3699),
    [anon_sym_template] = ACTIONS(3699),
    [anon_sym_operator] = ACTIONS(3699),
    [anon_sym_try] = ACTIONS(3699),
    [anon_sym_delete] = ACTIONS(3699),
    [anon_sym_throw] = ACTIONS(3699),
    [anon_sym_namespace] = ACTIONS(3699),
    [anon_sym_using] = ACTIONS(3699),
    [anon_sym_static_assert] = ACTIONS(3699),
    [anon_sym_concept] = ACTIONS(3699),
    [anon_sym_co_return] = ACTIONS(3699),
    [anon_sym_co_yield] = ACTIONS(3699),
    [anon_sym_R_DQUOTE] = ACTIONS(3701),
    [anon_sym_LR_DQUOTE] = ACTIONS(3701),
    [anon_sym_uR_DQUOTE] = ACTIONS(3701),
    [anon_sym_UR_DQUOTE] = ACTIONS(3701),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3701),
    [anon_sym_co_await] = ACTIONS(3699),
    [anon_sym_new] = ACTIONS(3699),
    [anon_sym_requires] = ACTIONS(3699),
    [sym_this] = ACTIONS(3699),
    [anon_sym_precise] = ACTIONS(3699),
    [anon_sym_shared] = ACTIONS(3699),
    [anon_sym_groupshared] = ACTIONS(3699),
    [anon_sym_uniform] = ACTIONS(3699),
    [anon_sym_row_major] = ACTIONS(3699),
    [anon_sym_column_major] = ACTIONS(3699),
    [anon_sym_globallycoherent] = ACTIONS(3699),
    [anon_sym_centroid] = ACTIONS(3699),
    [anon_sym_noperspective] = ACTIONS(3699),
    [anon_sym_nointerpolation] = ACTIONS(3699),
    [anon_sym_sample] = ACTIONS(3699),
    [anon_sym_linear] = ACTIONS(3699),
    [anon_sym_snorm] = ACTIONS(3699),
    [anon_sym_unorm] = ACTIONS(3699),
    [anon_sym_point] = ACTIONS(3699),
    [anon_sym_line] = ACTIONS(3699),
    [anon_sym_triangleadj] = ACTIONS(3699),
    [anon_sym_lineadj] = ACTIONS(3699),
    [anon_sym_triangle] = ACTIONS(3699),
    [anon_sym_interface] = ACTIONS(3699),
    [anon_sym_extension] = ACTIONS(3699),
    [anon_sym___exported] = ACTIONS(3699),
    [anon_sym_import] = ACTIONS(3699),
  },
  [1066] = {
    [ts_builtin_sym_end] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3665),
    [aux_sym_preproc_include_token1] = ACTIONS(3665),
    [aux_sym_preproc_def_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3665),
    [sym_preproc_directive] = ACTIONS(3665),
    [anon_sym_LPAREN2] = ACTIONS(3667),
    [anon_sym_BANG] = ACTIONS(3667),
    [anon_sym_TILDE] = ACTIONS(3667),
    [anon_sym_DASH] = ACTIONS(3665),
    [anon_sym_PLUS] = ACTIONS(3665),
    [anon_sym_STAR] = ACTIONS(3667),
    [anon_sym_AMP_AMP] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym___extension__] = ACTIONS(3665),
    [anon_sym_typedef] = ACTIONS(3665),
    [anon_sym_in] = ACTIONS(3665),
    [anon_sym_out] = ACTIONS(3665),
    [anon_sym_inout] = ACTIONS(3665),
    [anon_sym_extern] = ACTIONS(3665),
    [anon_sym___attribute__] = ACTIONS(3665),
    [anon_sym_COLON_COLON] = ACTIONS(3667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3667),
    [anon_sym___declspec] = ACTIONS(3665),
    [anon_sym___based] = ACTIONS(3665),
    [anon_sym___cdecl] = ACTIONS(3665),
    [anon_sym___clrcall] = ACTIONS(3665),
    [anon_sym___stdcall] = ACTIONS(3665),
    [anon_sym___fastcall] = ACTIONS(3665),
    [anon_sym___thiscall] = ACTIONS(3665),
    [anon_sym___vectorcall] = ACTIONS(3665),
    [anon_sym_LBRACE] = ACTIONS(3667),
    [anon_sym_signed] = ACTIONS(3665),
    [anon_sym_unsigned] = ACTIONS(3665),
    [anon_sym_long] = ACTIONS(3665),
    [anon_sym_short] = ACTIONS(3665),
    [anon_sym_LBRACK] = ACTIONS(3665),
    [anon_sym_static] = ACTIONS(3665),
    [anon_sym_register] = ACTIONS(3665),
    [anon_sym_inline] = ACTIONS(3665),
    [anon_sym___inline] = ACTIONS(3665),
    [anon_sym___inline__] = ACTIONS(3665),
    [anon_sym___forceinline] = ACTIONS(3665),
    [anon_sym_thread_local] = ACTIONS(3665),
    [anon_sym___thread] = ACTIONS(3665),
    [anon_sym_const] = ACTIONS(3665),
    [anon_sym_constexpr] = ACTIONS(3665),
    [anon_sym_volatile] = ACTIONS(3665),
    [anon_sym_restrict] = ACTIONS(3665),
    [anon_sym___restrict__] = ACTIONS(3665),
    [anon_sym__Atomic] = ACTIONS(3665),
    [anon_sym__Noreturn] = ACTIONS(3665),
    [anon_sym_noreturn] = ACTIONS(3665),
    [anon_sym_mutable] = ACTIONS(3665),
    [anon_sym_constinit] = ACTIONS(3665),
    [anon_sym_consteval] = ACTIONS(3665),
    [anon_sym_alignas] = ACTIONS(3665),
    [anon_sym__Alignas] = ACTIONS(3665),
    [sym_primitive_type] = ACTIONS(3665),
    [anon_sym_enum] = ACTIONS(3665),
    [anon_sym_class] = ACTIONS(3665),
    [anon_sym_struct] = ACTIONS(3665),
    [anon_sym_union] = ACTIONS(3665),
    [anon_sym_if] = ACTIONS(3665),
    [anon_sym_switch] = ACTIONS(3665),
    [anon_sym_case] = ACTIONS(3665),
    [anon_sym_default] = ACTIONS(3665),
    [anon_sym_while] = ACTIONS(3665),
    [anon_sym_do] = ACTIONS(3665),
    [anon_sym_for] = ACTIONS(3665),
    [anon_sym_return] = ACTIONS(3665),
    [anon_sym_break] = ACTIONS(3665),
    [anon_sym_continue] = ACTIONS(3665),
    [anon_sym_goto] = ACTIONS(3665),
    [anon_sym_not] = ACTIONS(3665),
    [anon_sym_compl] = ACTIONS(3665),
    [anon_sym_DASH_DASH] = ACTIONS(3667),
    [anon_sym_PLUS_PLUS] = ACTIONS(3667),
    [anon_sym_sizeof] = ACTIONS(3665),
    [anon_sym___alignof__] = ACTIONS(3665),
    [anon_sym___alignof] = ACTIONS(3665),
    [anon_sym__alignof] = ACTIONS(3665),
    [anon_sym_alignof] = ACTIONS(3665),
    [anon_sym__Alignof] = ACTIONS(3665),
    [anon_sym_offsetof] = ACTIONS(3665),
    [anon_sym__Generic] = ACTIONS(3665),
    [anon_sym_asm] = ACTIONS(3665),
    [anon_sym___asm__] = ACTIONS(3665),
    [sym_number_literal] = ACTIONS(3667),
    [anon_sym_L_SQUOTE] = ACTIONS(3667),
    [anon_sym_u_SQUOTE] = ACTIONS(3667),
    [anon_sym_U_SQUOTE] = ACTIONS(3667),
    [anon_sym_u8_SQUOTE] = ACTIONS(3667),
    [anon_sym_SQUOTE] = ACTIONS(3667),
    [anon_sym_L_DQUOTE] = ACTIONS(3667),
    [anon_sym_u_DQUOTE] = ACTIONS(3667),
    [anon_sym_U_DQUOTE] = ACTIONS(3667),
    [anon_sym_u8_DQUOTE] = ACTIONS(3667),
    [anon_sym_DQUOTE] = ACTIONS(3667),
    [sym_true] = ACTIONS(3665),
    [sym_false] = ACTIONS(3665),
    [anon_sym_NULL] = ACTIONS(3665),
    [anon_sym_nullptr] = ACTIONS(3665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3665),
    [anon_sym_let] = ACTIONS(3665),
    [anon_sym_This] = ACTIONS(3665),
    [anon_sym_decltype] = ACTIONS(3665),
    [sym_virtual] = ACTIONS(3665),
    [anon_sym_explicit] = ACTIONS(3665),
    [anon_sym_typename] = ACTIONS(3665),
    [anon_sym_template] = ACTIONS(3665),
    [anon_sym_operator] = ACTIONS(3665),
    [anon_sym_try] = ACTIONS(3665),
    [anon_sym_delete] = ACTIONS(3665),
    [anon_sym_throw] = ACTIONS(3665),
    [anon_sym_namespace] = ACTIONS(3665),
    [anon_sym_using] = ACTIONS(3665),
    [anon_sym_static_assert] = ACTIONS(3665),
    [anon_sym_concept] = ACTIONS(3665),
    [anon_sym_co_return] = ACTIONS(3665),
    [anon_sym_co_yield] = ACTIONS(3665),
    [anon_sym_R_DQUOTE] = ACTIONS(3667),
    [anon_sym_LR_DQUOTE] = ACTIONS(3667),
    [anon_sym_uR_DQUOTE] = ACTIONS(3667),
    [anon_sym_UR_DQUOTE] = ACTIONS(3667),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3667),
    [anon_sym_co_await] = ACTIONS(3665),
    [anon_sym_new] = ACTIONS(3665),
    [anon_sym_requires] = ACTIONS(3665),
    [sym_this] = ACTIONS(3665),
    [anon_sym_precise] = ACTIONS(3665),
    [anon_sym_shared] = ACTIONS(3665),
    [anon_sym_groupshared] = ACTIONS(3665),
    [anon_sym_uniform] = ACTIONS(3665),
    [anon_sym_row_major] = ACTIONS(3665),
    [anon_sym_column_major] = ACTIONS(3665),
    [anon_sym_globallycoherent] = ACTIONS(3665),
    [anon_sym_centroid] = ACTIONS(3665),
    [anon_sym_noperspective] = ACTIONS(3665),
    [anon_sym_nointerpolation] = ACTIONS(3665),
    [anon_sym_sample] = ACTIONS(3665),
    [anon_sym_linear] = ACTIONS(3665),
    [anon_sym_snorm] = ACTIONS(3665),
    [anon_sym_unorm] = ACTIONS(3665),
    [anon_sym_point] = ACTIONS(3665),
    [anon_sym_line] = ACTIONS(3665),
    [anon_sym_triangleadj] = ACTIONS(3665),
    [anon_sym_lineadj] = ACTIONS(3665),
    [anon_sym_triangle] = ACTIONS(3665),
    [anon_sym_interface] = ACTIONS(3665),
    [anon_sym_extension] = ACTIONS(3665),
    [anon_sym___exported] = ACTIONS(3665),
    [anon_sym_import] = ACTIONS(3665),
  },
  [1067] = {
    [ts_builtin_sym_end] = ACTIONS(3589),
    [sym_identifier] = ACTIONS(3587),
    [aux_sym_preproc_include_token1] = ACTIONS(3587),
    [aux_sym_preproc_def_token1] = ACTIONS(3587),
    [aux_sym_preproc_if_token1] = ACTIONS(3587),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3587),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3587),
    [sym_preproc_directive] = ACTIONS(3587),
    [anon_sym_LPAREN2] = ACTIONS(3589),
    [anon_sym_BANG] = ACTIONS(3589),
    [anon_sym_TILDE] = ACTIONS(3589),
    [anon_sym_DASH] = ACTIONS(3587),
    [anon_sym_PLUS] = ACTIONS(3587),
    [anon_sym_STAR] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3587),
    [anon_sym___extension__] = ACTIONS(3587),
    [anon_sym_typedef] = ACTIONS(3587),
    [anon_sym_in] = ACTIONS(3587),
    [anon_sym_out] = ACTIONS(3587),
    [anon_sym_inout] = ACTIONS(3587),
    [anon_sym_extern] = ACTIONS(3587),
    [anon_sym___attribute__] = ACTIONS(3587),
    [anon_sym_COLON_COLON] = ACTIONS(3589),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3589),
    [anon_sym___declspec] = ACTIONS(3587),
    [anon_sym___based] = ACTIONS(3587),
    [anon_sym___cdecl] = ACTIONS(3587),
    [anon_sym___clrcall] = ACTIONS(3587),
    [anon_sym___stdcall] = ACTIONS(3587),
    [anon_sym___fastcall] = ACTIONS(3587),
    [anon_sym___thiscall] = ACTIONS(3587),
    [anon_sym___vectorcall] = ACTIONS(3587),
    [anon_sym_LBRACE] = ACTIONS(3589),
    [anon_sym_signed] = ACTIONS(3587),
    [anon_sym_unsigned] = ACTIONS(3587),
    [anon_sym_long] = ACTIONS(3587),
    [anon_sym_short] = ACTIONS(3587),
    [anon_sym_LBRACK] = ACTIONS(3587),
    [anon_sym_static] = ACTIONS(3587),
    [anon_sym_register] = ACTIONS(3587),
    [anon_sym_inline] = ACTIONS(3587),
    [anon_sym___inline] = ACTIONS(3587),
    [anon_sym___inline__] = ACTIONS(3587),
    [anon_sym___forceinline] = ACTIONS(3587),
    [anon_sym_thread_local] = ACTIONS(3587),
    [anon_sym___thread] = ACTIONS(3587),
    [anon_sym_const] = ACTIONS(3587),
    [anon_sym_constexpr] = ACTIONS(3587),
    [anon_sym_volatile] = ACTIONS(3587),
    [anon_sym_restrict] = ACTIONS(3587),
    [anon_sym___restrict__] = ACTIONS(3587),
    [anon_sym__Atomic] = ACTIONS(3587),
    [anon_sym__Noreturn] = ACTIONS(3587),
    [anon_sym_noreturn] = ACTIONS(3587),
    [anon_sym_mutable] = ACTIONS(3587),
    [anon_sym_constinit] = ACTIONS(3587),
    [anon_sym_consteval] = ACTIONS(3587),
    [anon_sym_alignas] = ACTIONS(3587),
    [anon_sym__Alignas] = ACTIONS(3587),
    [sym_primitive_type] = ACTIONS(3587),
    [anon_sym_enum] = ACTIONS(3587),
    [anon_sym_class] = ACTIONS(3587),
    [anon_sym_struct] = ACTIONS(3587),
    [anon_sym_union] = ACTIONS(3587),
    [anon_sym_if] = ACTIONS(3587),
    [anon_sym_switch] = ACTIONS(3587),
    [anon_sym_case] = ACTIONS(3587),
    [anon_sym_default] = ACTIONS(3587),
    [anon_sym_while] = ACTIONS(3587),
    [anon_sym_do] = ACTIONS(3587),
    [anon_sym_for] = ACTIONS(3587),
    [anon_sym_return] = ACTIONS(3587),
    [anon_sym_break] = ACTIONS(3587),
    [anon_sym_continue] = ACTIONS(3587),
    [anon_sym_goto] = ACTIONS(3587),
    [anon_sym_not] = ACTIONS(3587),
    [anon_sym_compl] = ACTIONS(3587),
    [anon_sym_DASH_DASH] = ACTIONS(3589),
    [anon_sym_PLUS_PLUS] = ACTIONS(3589),
    [anon_sym_sizeof] = ACTIONS(3587),
    [anon_sym___alignof__] = ACTIONS(3587),
    [anon_sym___alignof] = ACTIONS(3587),
    [anon_sym__alignof] = ACTIONS(3587),
    [anon_sym_alignof] = ACTIONS(3587),
    [anon_sym__Alignof] = ACTIONS(3587),
    [anon_sym_offsetof] = ACTIONS(3587),
    [anon_sym__Generic] = ACTIONS(3587),
    [anon_sym_asm] = ACTIONS(3587),
    [anon_sym___asm__] = ACTIONS(3587),
    [sym_number_literal] = ACTIONS(3589),
    [anon_sym_L_SQUOTE] = ACTIONS(3589),
    [anon_sym_u_SQUOTE] = ACTIONS(3589),
    [anon_sym_U_SQUOTE] = ACTIONS(3589),
    [anon_sym_u8_SQUOTE] = ACTIONS(3589),
    [anon_sym_SQUOTE] = ACTIONS(3589),
    [anon_sym_L_DQUOTE] = ACTIONS(3589),
    [anon_sym_u_DQUOTE] = ACTIONS(3589),
    [anon_sym_U_DQUOTE] = ACTIONS(3589),
    [anon_sym_u8_DQUOTE] = ACTIONS(3589),
    [anon_sym_DQUOTE] = ACTIONS(3589),
    [sym_true] = ACTIONS(3587),
    [sym_false] = ACTIONS(3587),
    [anon_sym_NULL] = ACTIONS(3587),
    [anon_sym_nullptr] = ACTIONS(3587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3587),
    [anon_sym_let] = ACTIONS(3587),
    [anon_sym_This] = ACTIONS(3587),
    [anon_sym_decltype] = ACTIONS(3587),
    [sym_virtual] = ACTIONS(3587),
    [anon_sym_explicit] = ACTIONS(3587),
    [anon_sym_typename] = ACTIONS(3587),
    [anon_sym_template] = ACTIONS(3587),
    [anon_sym_operator] = ACTIONS(3587),
    [anon_sym_try] = ACTIONS(3587),
    [anon_sym_delete] = ACTIONS(3587),
    [anon_sym_throw] = ACTIONS(3587),
    [anon_sym_namespace] = ACTIONS(3587),
    [anon_sym_using] = ACTIONS(3587),
    [anon_sym_static_assert] = ACTIONS(3587),
    [anon_sym_concept] = ACTIONS(3587),
    [anon_sym_co_return] = ACTIONS(3587),
    [anon_sym_co_yield] = ACTIONS(3587),
    [anon_sym_R_DQUOTE] = ACTIONS(3589),
    [anon_sym_LR_DQUOTE] = ACTIONS(3589),
    [anon_sym_uR_DQUOTE] = ACTIONS(3589),
    [anon_sym_UR_DQUOTE] = ACTIONS(3589),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3589),
    [anon_sym_co_await] = ACTIONS(3587),
    [anon_sym_new] = ACTIONS(3587),
    [anon_sym_requires] = ACTIONS(3587),
    [sym_this] = ACTIONS(3587),
    [anon_sym_precise] = ACTIONS(3587),
    [anon_sym_shared] = ACTIONS(3587),
    [anon_sym_groupshared] = ACTIONS(3587),
    [anon_sym_uniform] = ACTIONS(3587),
    [anon_sym_row_major] = ACTIONS(3587),
    [anon_sym_column_major] = ACTIONS(3587),
    [anon_sym_globallycoherent] = ACTIONS(3587),
    [anon_sym_centroid] = ACTIONS(3587),
    [anon_sym_noperspective] = ACTIONS(3587),
    [anon_sym_nointerpolation] = ACTIONS(3587),
    [anon_sym_sample] = ACTIONS(3587),
    [anon_sym_linear] = ACTIONS(3587),
    [anon_sym_snorm] = ACTIONS(3587),
    [anon_sym_unorm] = ACTIONS(3587),
    [anon_sym_point] = ACTIONS(3587),
    [anon_sym_line] = ACTIONS(3587),
    [anon_sym_triangleadj] = ACTIONS(3587),
    [anon_sym_lineadj] = ACTIONS(3587),
    [anon_sym_triangle] = ACTIONS(3587),
    [anon_sym_interface] = ACTIONS(3587),
    [anon_sym_extension] = ACTIONS(3587),
    [anon_sym___exported] = ACTIONS(3587),
    [anon_sym_import] = ACTIONS(3587),
  },
  [1068] = {
    [ts_builtin_sym_end] = ACTIONS(3607),
    [sym_identifier] = ACTIONS(3605),
    [aux_sym_preproc_include_token1] = ACTIONS(3605),
    [aux_sym_preproc_def_token1] = ACTIONS(3605),
    [aux_sym_preproc_if_token1] = ACTIONS(3605),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3605),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3605),
    [sym_preproc_directive] = ACTIONS(3605),
    [anon_sym_LPAREN2] = ACTIONS(3607),
    [anon_sym_BANG] = ACTIONS(3607),
    [anon_sym_TILDE] = ACTIONS(3607),
    [anon_sym_DASH] = ACTIONS(3605),
    [anon_sym_PLUS] = ACTIONS(3605),
    [anon_sym_STAR] = ACTIONS(3607),
    [anon_sym_AMP_AMP] = ACTIONS(3607),
    [anon_sym_AMP] = ACTIONS(3605),
    [anon_sym___extension__] = ACTIONS(3605),
    [anon_sym_typedef] = ACTIONS(3605),
    [anon_sym_in] = ACTIONS(3605),
    [anon_sym_out] = ACTIONS(3605),
    [anon_sym_inout] = ACTIONS(3605),
    [anon_sym_extern] = ACTIONS(3605),
    [anon_sym___attribute__] = ACTIONS(3605),
    [anon_sym_COLON_COLON] = ACTIONS(3607),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3607),
    [anon_sym___declspec] = ACTIONS(3605),
    [anon_sym___based] = ACTIONS(3605),
    [anon_sym___cdecl] = ACTIONS(3605),
    [anon_sym___clrcall] = ACTIONS(3605),
    [anon_sym___stdcall] = ACTIONS(3605),
    [anon_sym___fastcall] = ACTIONS(3605),
    [anon_sym___thiscall] = ACTIONS(3605),
    [anon_sym___vectorcall] = ACTIONS(3605),
    [anon_sym_LBRACE] = ACTIONS(3607),
    [anon_sym_signed] = ACTIONS(3605),
    [anon_sym_unsigned] = ACTIONS(3605),
    [anon_sym_long] = ACTIONS(3605),
    [anon_sym_short] = ACTIONS(3605),
    [anon_sym_LBRACK] = ACTIONS(3605),
    [anon_sym_static] = ACTIONS(3605),
    [anon_sym_register] = ACTIONS(3605),
    [anon_sym_inline] = ACTIONS(3605),
    [anon_sym___inline] = ACTIONS(3605),
    [anon_sym___inline__] = ACTIONS(3605),
    [anon_sym___forceinline] = ACTIONS(3605),
    [anon_sym_thread_local] = ACTIONS(3605),
    [anon_sym___thread] = ACTIONS(3605),
    [anon_sym_const] = ACTIONS(3605),
    [anon_sym_constexpr] = ACTIONS(3605),
    [anon_sym_volatile] = ACTIONS(3605),
    [anon_sym_restrict] = ACTIONS(3605),
    [anon_sym___restrict__] = ACTIONS(3605),
    [anon_sym__Atomic] = ACTIONS(3605),
    [anon_sym__Noreturn] = ACTIONS(3605),
    [anon_sym_noreturn] = ACTIONS(3605),
    [anon_sym_mutable] = ACTIONS(3605),
    [anon_sym_constinit] = ACTIONS(3605),
    [anon_sym_consteval] = ACTIONS(3605),
    [anon_sym_alignas] = ACTIONS(3605),
    [anon_sym__Alignas] = ACTIONS(3605),
    [sym_primitive_type] = ACTIONS(3605),
    [anon_sym_enum] = ACTIONS(3605),
    [anon_sym_class] = ACTIONS(3605),
    [anon_sym_struct] = ACTIONS(3605),
    [anon_sym_union] = ACTIONS(3605),
    [anon_sym_if] = ACTIONS(3605),
    [anon_sym_switch] = ACTIONS(3605),
    [anon_sym_case] = ACTIONS(3605),
    [anon_sym_default] = ACTIONS(3605),
    [anon_sym_while] = ACTIONS(3605),
    [anon_sym_do] = ACTIONS(3605),
    [anon_sym_for] = ACTIONS(3605),
    [anon_sym_return] = ACTIONS(3605),
    [anon_sym_break] = ACTIONS(3605),
    [anon_sym_continue] = ACTIONS(3605),
    [anon_sym_goto] = ACTIONS(3605),
    [anon_sym_not] = ACTIONS(3605),
    [anon_sym_compl] = ACTIONS(3605),
    [anon_sym_DASH_DASH] = ACTIONS(3607),
    [anon_sym_PLUS_PLUS] = ACTIONS(3607),
    [anon_sym_sizeof] = ACTIONS(3605),
    [anon_sym___alignof__] = ACTIONS(3605),
    [anon_sym___alignof] = ACTIONS(3605),
    [anon_sym__alignof] = ACTIONS(3605),
    [anon_sym_alignof] = ACTIONS(3605),
    [anon_sym__Alignof] = ACTIONS(3605),
    [anon_sym_offsetof] = ACTIONS(3605),
    [anon_sym__Generic] = ACTIONS(3605),
    [anon_sym_asm] = ACTIONS(3605),
    [anon_sym___asm__] = ACTIONS(3605),
    [sym_number_literal] = ACTIONS(3607),
    [anon_sym_L_SQUOTE] = ACTIONS(3607),
    [anon_sym_u_SQUOTE] = ACTIONS(3607),
    [anon_sym_U_SQUOTE] = ACTIONS(3607),
    [anon_sym_u8_SQUOTE] = ACTIONS(3607),
    [anon_sym_SQUOTE] = ACTIONS(3607),
    [anon_sym_L_DQUOTE] = ACTIONS(3607),
    [anon_sym_u_DQUOTE] = ACTIONS(3607),
    [anon_sym_U_DQUOTE] = ACTIONS(3607),
    [anon_sym_u8_DQUOTE] = ACTIONS(3607),
    [anon_sym_DQUOTE] = ACTIONS(3607),
    [sym_true] = ACTIONS(3605),
    [sym_false] = ACTIONS(3605),
    [anon_sym_NULL] = ACTIONS(3605),
    [anon_sym_nullptr] = ACTIONS(3605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3605),
    [anon_sym_let] = ACTIONS(3605),
    [anon_sym_This] = ACTIONS(3605),
    [anon_sym_decltype] = ACTIONS(3605),
    [sym_virtual] = ACTIONS(3605),
    [anon_sym_explicit] = ACTIONS(3605),
    [anon_sym_typename] = ACTIONS(3605),
    [anon_sym_template] = ACTIONS(3605),
    [anon_sym_operator] = ACTIONS(3605),
    [anon_sym_try] = ACTIONS(3605),
    [anon_sym_delete] = ACTIONS(3605),
    [anon_sym_throw] = ACTIONS(3605),
    [anon_sym_namespace] = ACTIONS(3605),
    [anon_sym_using] = ACTIONS(3605),
    [anon_sym_static_assert] = ACTIONS(3605),
    [anon_sym_concept] = ACTIONS(3605),
    [anon_sym_co_return] = ACTIONS(3605),
    [anon_sym_co_yield] = ACTIONS(3605),
    [anon_sym_R_DQUOTE] = ACTIONS(3607),
    [anon_sym_LR_DQUOTE] = ACTIONS(3607),
    [anon_sym_uR_DQUOTE] = ACTIONS(3607),
    [anon_sym_UR_DQUOTE] = ACTIONS(3607),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3607),
    [anon_sym_co_await] = ACTIONS(3605),
    [anon_sym_new] = ACTIONS(3605),
    [anon_sym_requires] = ACTIONS(3605),
    [sym_this] = ACTIONS(3605),
    [anon_sym_precise] = ACTIONS(3605),
    [anon_sym_shared] = ACTIONS(3605),
    [anon_sym_groupshared] = ACTIONS(3605),
    [anon_sym_uniform] = ACTIONS(3605),
    [anon_sym_row_major] = ACTIONS(3605),
    [anon_sym_column_major] = ACTIONS(3605),
    [anon_sym_globallycoherent] = ACTIONS(3605),
    [anon_sym_centroid] = ACTIONS(3605),
    [anon_sym_noperspective] = ACTIONS(3605),
    [anon_sym_nointerpolation] = ACTIONS(3605),
    [anon_sym_sample] = ACTIONS(3605),
    [anon_sym_linear] = ACTIONS(3605),
    [anon_sym_snorm] = ACTIONS(3605),
    [anon_sym_unorm] = ACTIONS(3605),
    [anon_sym_point] = ACTIONS(3605),
    [anon_sym_line] = ACTIONS(3605),
    [anon_sym_triangleadj] = ACTIONS(3605),
    [anon_sym_lineadj] = ACTIONS(3605),
    [anon_sym_triangle] = ACTIONS(3605),
    [anon_sym_interface] = ACTIONS(3605),
    [anon_sym_extension] = ACTIONS(3605),
    [anon_sym___exported] = ACTIONS(3605),
    [anon_sym_import] = ACTIONS(3605),
  },
  [1069] = {
    [ts_builtin_sym_end] = ACTIONS(3961),
    [sym_identifier] = ACTIONS(3964),
    [aux_sym_preproc_include_token1] = ACTIONS(3964),
    [aux_sym_preproc_def_token1] = ACTIONS(3964),
    [aux_sym_preproc_if_token1] = ACTIONS(3964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3964),
    [sym_preproc_directive] = ACTIONS(3964),
    [anon_sym_LPAREN2] = ACTIONS(3961),
    [anon_sym_BANG] = ACTIONS(3961),
    [anon_sym_TILDE] = ACTIONS(3961),
    [anon_sym_DASH] = ACTIONS(3964),
    [anon_sym_PLUS] = ACTIONS(3964),
    [anon_sym_STAR] = ACTIONS(3961),
    [anon_sym_AMP_AMP] = ACTIONS(3961),
    [anon_sym_AMP] = ACTIONS(3964),
    [anon_sym___extension__] = ACTIONS(3964),
    [anon_sym_typedef] = ACTIONS(3964),
    [anon_sym_in] = ACTIONS(3964),
    [anon_sym_out] = ACTIONS(3964),
    [anon_sym_inout] = ACTIONS(3964),
    [anon_sym_extern] = ACTIONS(3964),
    [anon_sym___attribute__] = ACTIONS(3964),
    [anon_sym_COLON_COLON] = ACTIONS(3961),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3961),
    [anon_sym___declspec] = ACTIONS(3964),
    [anon_sym___based] = ACTIONS(3964),
    [anon_sym___cdecl] = ACTIONS(3964),
    [anon_sym___clrcall] = ACTIONS(3964),
    [anon_sym___stdcall] = ACTIONS(3964),
    [anon_sym___fastcall] = ACTIONS(3964),
    [anon_sym___thiscall] = ACTIONS(3964),
    [anon_sym___vectorcall] = ACTIONS(3964),
    [anon_sym_LBRACE] = ACTIONS(3961),
    [anon_sym_signed] = ACTIONS(3964),
    [anon_sym_unsigned] = ACTIONS(3964),
    [anon_sym_long] = ACTIONS(3964),
    [anon_sym_short] = ACTIONS(3964),
    [anon_sym_LBRACK] = ACTIONS(3964),
    [anon_sym_static] = ACTIONS(3964),
    [anon_sym_register] = ACTIONS(3964),
    [anon_sym_inline] = ACTIONS(3964),
    [anon_sym___inline] = ACTIONS(3964),
    [anon_sym___inline__] = ACTIONS(3964),
    [anon_sym___forceinline] = ACTIONS(3964),
    [anon_sym_thread_local] = ACTIONS(3964),
    [anon_sym___thread] = ACTIONS(3964),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_constexpr] = ACTIONS(3964),
    [anon_sym_volatile] = ACTIONS(3964),
    [anon_sym_restrict] = ACTIONS(3964),
    [anon_sym___restrict__] = ACTIONS(3964),
    [anon_sym__Atomic] = ACTIONS(3964),
    [anon_sym__Noreturn] = ACTIONS(3964),
    [anon_sym_noreturn] = ACTIONS(3964),
    [anon_sym_mutable] = ACTIONS(3964),
    [anon_sym_constinit] = ACTIONS(3964),
    [anon_sym_consteval] = ACTIONS(3964),
    [anon_sym_alignas] = ACTIONS(3964),
    [anon_sym__Alignas] = ACTIONS(3964),
    [sym_primitive_type] = ACTIONS(3964),
    [anon_sym_enum] = ACTIONS(3964),
    [anon_sym_class] = ACTIONS(3964),
    [anon_sym_struct] = ACTIONS(3964),
    [anon_sym_union] = ACTIONS(3964),
    [anon_sym_if] = ACTIONS(3964),
    [anon_sym_switch] = ACTIONS(3964),
    [anon_sym_case] = ACTIONS(3964),
    [anon_sym_default] = ACTIONS(3964),
    [anon_sym_while] = ACTIONS(3964),
    [anon_sym_do] = ACTIONS(3964),
    [anon_sym_for] = ACTIONS(3964),
    [anon_sym_return] = ACTIONS(3964),
    [anon_sym_break] = ACTIONS(3964),
    [anon_sym_continue] = ACTIONS(3964),
    [anon_sym_goto] = ACTIONS(3964),
    [anon_sym_not] = ACTIONS(3964),
    [anon_sym_compl] = ACTIONS(3964),
    [anon_sym_DASH_DASH] = ACTIONS(3961),
    [anon_sym_PLUS_PLUS] = ACTIONS(3961),
    [anon_sym_sizeof] = ACTIONS(3964),
    [anon_sym___alignof__] = ACTIONS(3964),
    [anon_sym___alignof] = ACTIONS(3964),
    [anon_sym__alignof] = ACTIONS(3964),
    [anon_sym_alignof] = ACTIONS(3964),
    [anon_sym__Alignof] = ACTIONS(3964),
    [anon_sym_offsetof] = ACTIONS(3964),
    [anon_sym__Generic] = ACTIONS(3964),
    [anon_sym_asm] = ACTIONS(3964),
    [anon_sym___asm__] = ACTIONS(3964),
    [sym_number_literal] = ACTIONS(3961),
    [anon_sym_L_SQUOTE] = ACTIONS(3961),
    [anon_sym_u_SQUOTE] = ACTIONS(3961),
    [anon_sym_U_SQUOTE] = ACTIONS(3961),
    [anon_sym_u8_SQUOTE] = ACTIONS(3961),
    [anon_sym_SQUOTE] = ACTIONS(3961),
    [anon_sym_L_DQUOTE] = ACTIONS(3961),
    [anon_sym_u_DQUOTE] = ACTIONS(3961),
    [anon_sym_U_DQUOTE] = ACTIONS(3961),
    [anon_sym_u8_DQUOTE] = ACTIONS(3961),
    [anon_sym_DQUOTE] = ACTIONS(3961),
    [sym_true] = ACTIONS(3964),
    [sym_false] = ACTIONS(3964),
    [anon_sym_NULL] = ACTIONS(3964),
    [anon_sym_nullptr] = ACTIONS(3964),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3964),
    [anon_sym_let] = ACTIONS(3964),
    [anon_sym_This] = ACTIONS(3964),
    [anon_sym_decltype] = ACTIONS(3964),
    [sym_virtual] = ACTIONS(3964),
    [anon_sym_explicit] = ACTIONS(3964),
    [anon_sym_typename] = ACTIONS(3964),
    [anon_sym_template] = ACTIONS(3964),
    [anon_sym_operator] = ACTIONS(3964),
    [anon_sym_try] = ACTIONS(3964),
    [anon_sym_delete] = ACTIONS(3964),
    [anon_sym_throw] = ACTIONS(3964),
    [anon_sym_namespace] = ACTIONS(3964),
    [anon_sym_using] = ACTIONS(3964),
    [anon_sym_static_assert] = ACTIONS(3964),
    [anon_sym_concept] = ACTIONS(3964),
    [anon_sym_co_return] = ACTIONS(3964),
    [anon_sym_co_yield] = ACTIONS(3964),
    [anon_sym_R_DQUOTE] = ACTIONS(3961),
    [anon_sym_LR_DQUOTE] = ACTIONS(3961),
    [anon_sym_uR_DQUOTE] = ACTIONS(3961),
    [anon_sym_UR_DQUOTE] = ACTIONS(3961),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3961),
    [anon_sym_co_await] = ACTIONS(3964),
    [anon_sym_new] = ACTIONS(3964),
    [anon_sym_requires] = ACTIONS(3964),
    [sym_this] = ACTIONS(3964),
    [anon_sym_precise] = ACTIONS(3964),
    [anon_sym_shared] = ACTIONS(3964),
    [anon_sym_groupshared] = ACTIONS(3964),
    [anon_sym_uniform] = ACTIONS(3964),
    [anon_sym_row_major] = ACTIONS(3964),
    [anon_sym_column_major] = ACTIONS(3964),
    [anon_sym_globallycoherent] = ACTIONS(3964),
    [anon_sym_centroid] = ACTIONS(3964),
    [anon_sym_noperspective] = ACTIONS(3964),
    [anon_sym_nointerpolation] = ACTIONS(3964),
    [anon_sym_sample] = ACTIONS(3964),
    [anon_sym_linear] = ACTIONS(3964),
    [anon_sym_snorm] = ACTIONS(3964),
    [anon_sym_unorm] = ACTIONS(3964),
    [anon_sym_point] = ACTIONS(3964),
    [anon_sym_line] = ACTIONS(3964),
    [anon_sym_triangleadj] = ACTIONS(3964),
    [anon_sym_lineadj] = ACTIONS(3964),
    [anon_sym_triangle] = ACTIONS(3964),
    [anon_sym_interface] = ACTIONS(3964),
    [anon_sym_extension] = ACTIONS(3964),
    [anon_sym___exported] = ACTIONS(3964),
    [anon_sym_import] = ACTIONS(3964),
  },
  [1070] = {
    [ts_builtin_sym_end] = ACTIONS(3679),
    [sym_identifier] = ACTIONS(3677),
    [aux_sym_preproc_include_token1] = ACTIONS(3677),
    [aux_sym_preproc_def_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token1] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3677),
    [sym_preproc_directive] = ACTIONS(3677),
    [anon_sym_LPAREN2] = ACTIONS(3679),
    [anon_sym_BANG] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3677),
    [anon_sym_PLUS] = ACTIONS(3677),
    [anon_sym_STAR] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_AMP] = ACTIONS(3677),
    [anon_sym___extension__] = ACTIONS(3677),
    [anon_sym_typedef] = ACTIONS(3677),
    [anon_sym_in] = ACTIONS(3677),
    [anon_sym_out] = ACTIONS(3677),
    [anon_sym_inout] = ACTIONS(3677),
    [anon_sym_extern] = ACTIONS(3677),
    [anon_sym___attribute__] = ACTIONS(3677),
    [anon_sym_COLON_COLON] = ACTIONS(3679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3679),
    [anon_sym___declspec] = ACTIONS(3677),
    [anon_sym___based] = ACTIONS(3677),
    [anon_sym___cdecl] = ACTIONS(3677),
    [anon_sym___clrcall] = ACTIONS(3677),
    [anon_sym___stdcall] = ACTIONS(3677),
    [anon_sym___fastcall] = ACTIONS(3677),
    [anon_sym___thiscall] = ACTIONS(3677),
    [anon_sym___vectorcall] = ACTIONS(3677),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_signed] = ACTIONS(3677),
    [anon_sym_unsigned] = ACTIONS(3677),
    [anon_sym_long] = ACTIONS(3677),
    [anon_sym_short] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3677),
    [anon_sym_static] = ACTIONS(3677),
    [anon_sym_register] = ACTIONS(3677),
    [anon_sym_inline] = ACTIONS(3677),
    [anon_sym___inline] = ACTIONS(3677),
    [anon_sym___inline__] = ACTIONS(3677),
    [anon_sym___forceinline] = ACTIONS(3677),
    [anon_sym_thread_local] = ACTIONS(3677),
    [anon_sym___thread] = ACTIONS(3677),
    [anon_sym_const] = ACTIONS(3677),
    [anon_sym_constexpr] = ACTIONS(3677),
    [anon_sym_volatile] = ACTIONS(3677),
    [anon_sym_restrict] = ACTIONS(3677),
    [anon_sym___restrict__] = ACTIONS(3677),
    [anon_sym__Atomic] = ACTIONS(3677),
    [anon_sym__Noreturn] = ACTIONS(3677),
    [anon_sym_noreturn] = ACTIONS(3677),
    [anon_sym_mutable] = ACTIONS(3677),
    [anon_sym_constinit] = ACTIONS(3677),
    [anon_sym_consteval] = ACTIONS(3677),
    [anon_sym_alignas] = ACTIONS(3677),
    [anon_sym__Alignas] = ACTIONS(3677),
    [sym_primitive_type] = ACTIONS(3677),
    [anon_sym_enum] = ACTIONS(3677),
    [anon_sym_class] = ACTIONS(3677),
    [anon_sym_struct] = ACTIONS(3677),
    [anon_sym_union] = ACTIONS(3677),
    [anon_sym_if] = ACTIONS(3677),
    [anon_sym_switch] = ACTIONS(3677),
    [anon_sym_case] = ACTIONS(3677),
    [anon_sym_default] = ACTIONS(3677),
    [anon_sym_while] = ACTIONS(3677),
    [anon_sym_do] = ACTIONS(3677),
    [anon_sym_for] = ACTIONS(3677),
    [anon_sym_return] = ACTIONS(3677),
    [anon_sym_break] = ACTIONS(3677),
    [anon_sym_continue] = ACTIONS(3677),
    [anon_sym_goto] = ACTIONS(3677),
    [anon_sym_not] = ACTIONS(3677),
    [anon_sym_compl] = ACTIONS(3677),
    [anon_sym_DASH_DASH] = ACTIONS(3679),
    [anon_sym_PLUS_PLUS] = ACTIONS(3679),
    [anon_sym_sizeof] = ACTIONS(3677),
    [anon_sym___alignof__] = ACTIONS(3677),
    [anon_sym___alignof] = ACTIONS(3677),
    [anon_sym__alignof] = ACTIONS(3677),
    [anon_sym_alignof] = ACTIONS(3677),
    [anon_sym__Alignof] = ACTIONS(3677),
    [anon_sym_offsetof] = ACTIONS(3677),
    [anon_sym__Generic] = ACTIONS(3677),
    [anon_sym_asm] = ACTIONS(3677),
    [anon_sym___asm__] = ACTIONS(3677),
    [sym_number_literal] = ACTIONS(3679),
    [anon_sym_L_SQUOTE] = ACTIONS(3679),
    [anon_sym_u_SQUOTE] = ACTIONS(3679),
    [anon_sym_U_SQUOTE] = ACTIONS(3679),
    [anon_sym_u8_SQUOTE] = ACTIONS(3679),
    [anon_sym_SQUOTE] = ACTIONS(3679),
    [anon_sym_L_DQUOTE] = ACTIONS(3679),
    [anon_sym_u_DQUOTE] = ACTIONS(3679),
    [anon_sym_U_DQUOTE] = ACTIONS(3679),
    [anon_sym_u8_DQUOTE] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3679),
    [sym_true] = ACTIONS(3677),
    [sym_false] = ACTIONS(3677),
    [anon_sym_NULL] = ACTIONS(3677),
    [anon_sym_nullptr] = ACTIONS(3677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3677),
    [anon_sym_let] = ACTIONS(3677),
    [anon_sym_This] = ACTIONS(3677),
    [anon_sym_decltype] = ACTIONS(3677),
    [sym_virtual] = ACTIONS(3677),
    [anon_sym_explicit] = ACTIONS(3677),
    [anon_sym_typename] = ACTIONS(3677),
    [anon_sym_template] = ACTIONS(3677),
    [anon_sym_operator] = ACTIONS(3677),
    [anon_sym_try] = ACTIONS(3677),
    [anon_sym_delete] = ACTIONS(3677),
    [anon_sym_throw] = ACTIONS(3677),
    [anon_sym_namespace] = ACTIONS(3677),
    [anon_sym_using] = ACTIONS(3677),
    [anon_sym_static_assert] = ACTIONS(3677),
    [anon_sym_concept] = ACTIONS(3677),
    [anon_sym_co_return] = ACTIONS(3677),
    [anon_sym_co_yield] = ACTIONS(3677),
    [anon_sym_R_DQUOTE] = ACTIONS(3679),
    [anon_sym_LR_DQUOTE] = ACTIONS(3679),
    [anon_sym_uR_DQUOTE] = ACTIONS(3679),
    [anon_sym_UR_DQUOTE] = ACTIONS(3679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3679),
    [anon_sym_co_await] = ACTIONS(3677),
    [anon_sym_new] = ACTIONS(3677),
    [anon_sym_requires] = ACTIONS(3677),
    [sym_this] = ACTIONS(3677),
    [anon_sym_precise] = ACTIONS(3677),
    [anon_sym_shared] = ACTIONS(3677),
    [anon_sym_groupshared] = ACTIONS(3677),
    [anon_sym_uniform] = ACTIONS(3677),
    [anon_sym_row_major] = ACTIONS(3677),
    [anon_sym_column_major] = ACTIONS(3677),
    [anon_sym_globallycoherent] = ACTIONS(3677),
    [anon_sym_centroid] = ACTIONS(3677),
    [anon_sym_noperspective] = ACTIONS(3677),
    [anon_sym_nointerpolation] = ACTIONS(3677),
    [anon_sym_sample] = ACTIONS(3677),
    [anon_sym_linear] = ACTIONS(3677),
    [anon_sym_snorm] = ACTIONS(3677),
    [anon_sym_unorm] = ACTIONS(3677),
    [anon_sym_point] = ACTIONS(3677),
    [anon_sym_line] = ACTIONS(3677),
    [anon_sym_triangleadj] = ACTIONS(3677),
    [anon_sym_lineadj] = ACTIONS(3677),
    [anon_sym_triangle] = ACTIONS(3677),
    [anon_sym_interface] = ACTIONS(3677),
    [anon_sym_extension] = ACTIONS(3677),
    [anon_sym___exported] = ACTIONS(3677),
    [anon_sym_import] = ACTIONS(3677),
  },
  [1071] = {
    [ts_builtin_sym_end] = ACTIONS(3519),
    [sym_identifier] = ACTIONS(3517),
    [aux_sym_preproc_include_token1] = ACTIONS(3517),
    [aux_sym_preproc_def_token1] = ACTIONS(3517),
    [aux_sym_preproc_if_token1] = ACTIONS(3517),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3517),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3517),
    [sym_preproc_directive] = ACTIONS(3517),
    [anon_sym_LPAREN2] = ACTIONS(3519),
    [anon_sym_BANG] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3517),
    [anon_sym_PLUS] = ACTIONS(3517),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym___extension__] = ACTIONS(3517),
    [anon_sym_typedef] = ACTIONS(3517),
    [anon_sym_in] = ACTIONS(3517),
    [anon_sym_out] = ACTIONS(3517),
    [anon_sym_inout] = ACTIONS(3517),
    [anon_sym_extern] = ACTIONS(3517),
    [anon_sym___attribute__] = ACTIONS(3517),
    [anon_sym_COLON_COLON] = ACTIONS(3519),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3519),
    [anon_sym___declspec] = ACTIONS(3517),
    [anon_sym___based] = ACTIONS(3517),
    [anon_sym___cdecl] = ACTIONS(3517),
    [anon_sym___clrcall] = ACTIONS(3517),
    [anon_sym___stdcall] = ACTIONS(3517),
    [anon_sym___fastcall] = ACTIONS(3517),
    [anon_sym___thiscall] = ACTIONS(3517),
    [anon_sym___vectorcall] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_signed] = ACTIONS(3517),
    [anon_sym_unsigned] = ACTIONS(3517),
    [anon_sym_long] = ACTIONS(3517),
    [anon_sym_short] = ACTIONS(3517),
    [anon_sym_LBRACK] = ACTIONS(3517),
    [anon_sym_static] = ACTIONS(3517),
    [anon_sym_register] = ACTIONS(3517),
    [anon_sym_inline] = ACTIONS(3517),
    [anon_sym___inline] = ACTIONS(3517),
    [anon_sym___inline__] = ACTIONS(3517),
    [anon_sym___forceinline] = ACTIONS(3517),
    [anon_sym_thread_local] = ACTIONS(3517),
    [anon_sym___thread] = ACTIONS(3517),
    [anon_sym_const] = ACTIONS(3517),
    [anon_sym_constexpr] = ACTIONS(3517),
    [anon_sym_volatile] = ACTIONS(3517),
    [anon_sym_restrict] = ACTIONS(3517),
    [anon_sym___restrict__] = ACTIONS(3517),
    [anon_sym__Atomic] = ACTIONS(3517),
    [anon_sym__Noreturn] = ACTIONS(3517),
    [anon_sym_noreturn] = ACTIONS(3517),
    [anon_sym_mutable] = ACTIONS(3517),
    [anon_sym_constinit] = ACTIONS(3517),
    [anon_sym_consteval] = ACTIONS(3517),
    [anon_sym_alignas] = ACTIONS(3517),
    [anon_sym__Alignas] = ACTIONS(3517),
    [sym_primitive_type] = ACTIONS(3517),
    [anon_sym_enum] = ACTIONS(3517),
    [anon_sym_class] = ACTIONS(3517),
    [anon_sym_struct] = ACTIONS(3517),
    [anon_sym_union] = ACTIONS(3517),
    [anon_sym_if] = ACTIONS(3517),
    [anon_sym_switch] = ACTIONS(3517),
    [anon_sym_case] = ACTIONS(3517),
    [anon_sym_default] = ACTIONS(3517),
    [anon_sym_while] = ACTIONS(3517),
    [anon_sym_do] = ACTIONS(3517),
    [anon_sym_for] = ACTIONS(3517),
    [anon_sym_return] = ACTIONS(3517),
    [anon_sym_break] = ACTIONS(3517),
    [anon_sym_continue] = ACTIONS(3517),
    [anon_sym_goto] = ACTIONS(3517),
    [anon_sym_not] = ACTIONS(3517),
    [anon_sym_compl] = ACTIONS(3517),
    [anon_sym_DASH_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_PLUS] = ACTIONS(3519),
    [anon_sym_sizeof] = ACTIONS(3517),
    [anon_sym___alignof__] = ACTIONS(3517),
    [anon_sym___alignof] = ACTIONS(3517),
    [anon_sym__alignof] = ACTIONS(3517),
    [anon_sym_alignof] = ACTIONS(3517),
    [anon_sym__Alignof] = ACTIONS(3517),
    [anon_sym_offsetof] = ACTIONS(3517),
    [anon_sym__Generic] = ACTIONS(3517),
    [anon_sym_asm] = ACTIONS(3517),
    [anon_sym___asm__] = ACTIONS(3517),
    [sym_number_literal] = ACTIONS(3519),
    [anon_sym_L_SQUOTE] = ACTIONS(3519),
    [anon_sym_u_SQUOTE] = ACTIONS(3519),
    [anon_sym_U_SQUOTE] = ACTIONS(3519),
    [anon_sym_u8_SQUOTE] = ACTIONS(3519),
    [anon_sym_SQUOTE] = ACTIONS(3519),
    [anon_sym_L_DQUOTE] = ACTIONS(3519),
    [anon_sym_u_DQUOTE] = ACTIONS(3519),
    [anon_sym_U_DQUOTE] = ACTIONS(3519),
    [anon_sym_u8_DQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [sym_true] = ACTIONS(3517),
    [sym_false] = ACTIONS(3517),
    [anon_sym_NULL] = ACTIONS(3517),
    [anon_sym_nullptr] = ACTIONS(3517),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3517),
    [anon_sym_let] = ACTIONS(3517),
    [anon_sym_This] = ACTIONS(3517),
    [anon_sym_decltype] = ACTIONS(3517),
    [sym_virtual] = ACTIONS(3517),
    [anon_sym_explicit] = ACTIONS(3517),
    [anon_sym_typename] = ACTIONS(3517),
    [anon_sym_template] = ACTIONS(3517),
    [anon_sym_operator] = ACTIONS(3517),
    [anon_sym_try] = ACTIONS(3517),
    [anon_sym_delete] = ACTIONS(3517),
    [anon_sym_throw] = ACTIONS(3517),
    [anon_sym_namespace] = ACTIONS(3517),
    [anon_sym_using] = ACTIONS(3517),
    [anon_sym_static_assert] = ACTIONS(3517),
    [anon_sym_concept] = ACTIONS(3517),
    [anon_sym_co_return] = ACTIONS(3517),
    [anon_sym_co_yield] = ACTIONS(3517),
    [anon_sym_R_DQUOTE] = ACTIONS(3519),
    [anon_sym_LR_DQUOTE] = ACTIONS(3519),
    [anon_sym_uR_DQUOTE] = ACTIONS(3519),
    [anon_sym_UR_DQUOTE] = ACTIONS(3519),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3519),
    [anon_sym_co_await] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3517),
    [anon_sym_requires] = ACTIONS(3517),
    [sym_this] = ACTIONS(3517),
    [anon_sym_precise] = ACTIONS(3517),
    [anon_sym_shared] = ACTIONS(3517),
    [anon_sym_groupshared] = ACTIONS(3517),
    [anon_sym_uniform] = ACTIONS(3517),
    [anon_sym_row_major] = ACTIONS(3517),
    [anon_sym_column_major] = ACTIONS(3517),
    [anon_sym_globallycoherent] = ACTIONS(3517),
    [anon_sym_centroid] = ACTIONS(3517),
    [anon_sym_noperspective] = ACTIONS(3517),
    [anon_sym_nointerpolation] = ACTIONS(3517),
    [anon_sym_sample] = ACTIONS(3517),
    [anon_sym_linear] = ACTIONS(3517),
    [anon_sym_snorm] = ACTIONS(3517),
    [anon_sym_unorm] = ACTIONS(3517),
    [anon_sym_point] = ACTIONS(3517),
    [anon_sym_line] = ACTIONS(3517),
    [anon_sym_triangleadj] = ACTIONS(3517),
    [anon_sym_lineadj] = ACTIONS(3517),
    [anon_sym_triangle] = ACTIONS(3517),
    [anon_sym_interface] = ACTIONS(3517),
    [anon_sym_extension] = ACTIONS(3517),
    [anon_sym___exported] = ACTIONS(3517),
    [anon_sym_import] = ACTIONS(3517),
  },
  [1072] = {
    [ts_builtin_sym_end] = ACTIONS(3611),
    [sym_identifier] = ACTIONS(3609),
    [aux_sym_preproc_include_token1] = ACTIONS(3609),
    [aux_sym_preproc_def_token1] = ACTIONS(3609),
    [aux_sym_preproc_if_token1] = ACTIONS(3609),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3609),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3609),
    [sym_preproc_directive] = ACTIONS(3609),
    [anon_sym_LPAREN2] = ACTIONS(3611),
    [anon_sym_BANG] = ACTIONS(3611),
    [anon_sym_TILDE] = ACTIONS(3611),
    [anon_sym_DASH] = ACTIONS(3609),
    [anon_sym_PLUS] = ACTIONS(3609),
    [anon_sym_STAR] = ACTIONS(3611),
    [anon_sym_AMP_AMP] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3609),
    [anon_sym___extension__] = ACTIONS(3609),
    [anon_sym_typedef] = ACTIONS(3609),
    [anon_sym_in] = ACTIONS(3609),
    [anon_sym_out] = ACTIONS(3609),
    [anon_sym_inout] = ACTIONS(3609),
    [anon_sym_extern] = ACTIONS(3609),
    [anon_sym___attribute__] = ACTIONS(3609),
    [anon_sym_COLON_COLON] = ACTIONS(3611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3611),
    [anon_sym___declspec] = ACTIONS(3609),
    [anon_sym___based] = ACTIONS(3609),
    [anon_sym___cdecl] = ACTIONS(3609),
    [anon_sym___clrcall] = ACTIONS(3609),
    [anon_sym___stdcall] = ACTIONS(3609),
    [anon_sym___fastcall] = ACTIONS(3609),
    [anon_sym___thiscall] = ACTIONS(3609),
    [anon_sym___vectorcall] = ACTIONS(3609),
    [anon_sym_LBRACE] = ACTIONS(3611),
    [anon_sym_signed] = ACTIONS(3609),
    [anon_sym_unsigned] = ACTIONS(3609),
    [anon_sym_long] = ACTIONS(3609),
    [anon_sym_short] = ACTIONS(3609),
    [anon_sym_LBRACK] = ACTIONS(3609),
    [anon_sym_static] = ACTIONS(3609),
    [anon_sym_register] = ACTIONS(3609),
    [anon_sym_inline] = ACTIONS(3609),
    [anon_sym___inline] = ACTIONS(3609),
    [anon_sym___inline__] = ACTIONS(3609),
    [anon_sym___forceinline] = ACTIONS(3609),
    [anon_sym_thread_local] = ACTIONS(3609),
    [anon_sym___thread] = ACTIONS(3609),
    [anon_sym_const] = ACTIONS(3609),
    [anon_sym_constexpr] = ACTIONS(3609),
    [anon_sym_volatile] = ACTIONS(3609),
    [anon_sym_restrict] = ACTIONS(3609),
    [anon_sym___restrict__] = ACTIONS(3609),
    [anon_sym__Atomic] = ACTIONS(3609),
    [anon_sym__Noreturn] = ACTIONS(3609),
    [anon_sym_noreturn] = ACTIONS(3609),
    [anon_sym_mutable] = ACTIONS(3609),
    [anon_sym_constinit] = ACTIONS(3609),
    [anon_sym_consteval] = ACTIONS(3609),
    [anon_sym_alignas] = ACTIONS(3609),
    [anon_sym__Alignas] = ACTIONS(3609),
    [sym_primitive_type] = ACTIONS(3609),
    [anon_sym_enum] = ACTIONS(3609),
    [anon_sym_class] = ACTIONS(3609),
    [anon_sym_struct] = ACTIONS(3609),
    [anon_sym_union] = ACTIONS(3609),
    [anon_sym_if] = ACTIONS(3609),
    [anon_sym_switch] = ACTIONS(3609),
    [anon_sym_case] = ACTIONS(3609),
    [anon_sym_default] = ACTIONS(3609),
    [anon_sym_while] = ACTIONS(3609),
    [anon_sym_do] = ACTIONS(3609),
    [anon_sym_for] = ACTIONS(3609),
    [anon_sym_return] = ACTIONS(3609),
    [anon_sym_break] = ACTIONS(3609),
    [anon_sym_continue] = ACTIONS(3609),
    [anon_sym_goto] = ACTIONS(3609),
    [anon_sym_not] = ACTIONS(3609),
    [anon_sym_compl] = ACTIONS(3609),
    [anon_sym_DASH_DASH] = ACTIONS(3611),
    [anon_sym_PLUS_PLUS] = ACTIONS(3611),
    [anon_sym_sizeof] = ACTIONS(3609),
    [anon_sym___alignof__] = ACTIONS(3609),
    [anon_sym___alignof] = ACTIONS(3609),
    [anon_sym__alignof] = ACTIONS(3609),
    [anon_sym_alignof] = ACTIONS(3609),
    [anon_sym__Alignof] = ACTIONS(3609),
    [anon_sym_offsetof] = ACTIONS(3609),
    [anon_sym__Generic] = ACTIONS(3609),
    [anon_sym_asm] = ACTIONS(3609),
    [anon_sym___asm__] = ACTIONS(3609),
    [sym_number_literal] = ACTIONS(3611),
    [anon_sym_L_SQUOTE] = ACTIONS(3611),
    [anon_sym_u_SQUOTE] = ACTIONS(3611),
    [anon_sym_U_SQUOTE] = ACTIONS(3611),
    [anon_sym_u8_SQUOTE] = ACTIONS(3611),
    [anon_sym_SQUOTE] = ACTIONS(3611),
    [anon_sym_L_DQUOTE] = ACTIONS(3611),
    [anon_sym_u_DQUOTE] = ACTIONS(3611),
    [anon_sym_U_DQUOTE] = ACTIONS(3611),
    [anon_sym_u8_DQUOTE] = ACTIONS(3611),
    [anon_sym_DQUOTE] = ACTIONS(3611),
    [sym_true] = ACTIONS(3609),
    [sym_false] = ACTIONS(3609),
    [anon_sym_NULL] = ACTIONS(3609),
    [anon_sym_nullptr] = ACTIONS(3609),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3609),
    [anon_sym_let] = ACTIONS(3609),
    [anon_sym_This] = ACTIONS(3609),
    [anon_sym_decltype] = ACTIONS(3609),
    [sym_virtual] = ACTIONS(3609),
    [anon_sym_explicit] = ACTIONS(3609),
    [anon_sym_typename] = ACTIONS(3609),
    [anon_sym_template] = ACTIONS(3609),
    [anon_sym_operator] = ACTIONS(3609),
    [anon_sym_try] = ACTIONS(3609),
    [anon_sym_delete] = ACTIONS(3609),
    [anon_sym_throw] = ACTIONS(3609),
    [anon_sym_namespace] = ACTIONS(3609),
    [anon_sym_using] = ACTIONS(3609),
    [anon_sym_static_assert] = ACTIONS(3609),
    [anon_sym_concept] = ACTIONS(3609),
    [anon_sym_co_return] = ACTIONS(3609),
    [anon_sym_co_yield] = ACTIONS(3609),
    [anon_sym_R_DQUOTE] = ACTIONS(3611),
    [anon_sym_LR_DQUOTE] = ACTIONS(3611),
    [anon_sym_uR_DQUOTE] = ACTIONS(3611),
    [anon_sym_UR_DQUOTE] = ACTIONS(3611),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3611),
    [anon_sym_co_await] = ACTIONS(3609),
    [anon_sym_new] = ACTIONS(3609),
    [anon_sym_requires] = ACTIONS(3609),
    [sym_this] = ACTIONS(3609),
    [anon_sym_precise] = ACTIONS(3609),
    [anon_sym_shared] = ACTIONS(3609),
    [anon_sym_groupshared] = ACTIONS(3609),
    [anon_sym_uniform] = ACTIONS(3609),
    [anon_sym_row_major] = ACTIONS(3609),
    [anon_sym_column_major] = ACTIONS(3609),
    [anon_sym_globallycoherent] = ACTIONS(3609),
    [anon_sym_centroid] = ACTIONS(3609),
    [anon_sym_noperspective] = ACTIONS(3609),
    [anon_sym_nointerpolation] = ACTIONS(3609),
    [anon_sym_sample] = ACTIONS(3609),
    [anon_sym_linear] = ACTIONS(3609),
    [anon_sym_snorm] = ACTIONS(3609),
    [anon_sym_unorm] = ACTIONS(3609),
    [anon_sym_point] = ACTIONS(3609),
    [anon_sym_line] = ACTIONS(3609),
    [anon_sym_triangleadj] = ACTIONS(3609),
    [anon_sym_lineadj] = ACTIONS(3609),
    [anon_sym_triangle] = ACTIONS(3609),
    [anon_sym_interface] = ACTIONS(3609),
    [anon_sym_extension] = ACTIONS(3609),
    [anon_sym___exported] = ACTIONS(3609),
    [anon_sym_import] = ACTIONS(3609),
  },
  [1073] = {
    [ts_builtin_sym_end] = ACTIONS(3683),
    [sym_identifier] = ACTIONS(3681),
    [aux_sym_preproc_include_token1] = ACTIONS(3681),
    [aux_sym_preproc_def_token1] = ACTIONS(3681),
    [aux_sym_preproc_if_token1] = ACTIONS(3681),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3681),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3681),
    [sym_preproc_directive] = ACTIONS(3681),
    [anon_sym_LPAREN2] = ACTIONS(3683),
    [anon_sym_BANG] = ACTIONS(3683),
    [anon_sym_TILDE] = ACTIONS(3683),
    [anon_sym_DASH] = ACTIONS(3681),
    [anon_sym_PLUS] = ACTIONS(3681),
    [anon_sym_STAR] = ACTIONS(3683),
    [anon_sym_AMP_AMP] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3681),
    [anon_sym___extension__] = ACTIONS(3681),
    [anon_sym_typedef] = ACTIONS(3681),
    [anon_sym_in] = ACTIONS(3681),
    [anon_sym_out] = ACTIONS(3681),
    [anon_sym_inout] = ACTIONS(3681),
    [anon_sym_extern] = ACTIONS(3681),
    [anon_sym___attribute__] = ACTIONS(3681),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3683),
    [anon_sym___declspec] = ACTIONS(3681),
    [anon_sym___based] = ACTIONS(3681),
    [anon_sym___cdecl] = ACTIONS(3681),
    [anon_sym___clrcall] = ACTIONS(3681),
    [anon_sym___stdcall] = ACTIONS(3681),
    [anon_sym___fastcall] = ACTIONS(3681),
    [anon_sym___thiscall] = ACTIONS(3681),
    [anon_sym___vectorcall] = ACTIONS(3681),
    [anon_sym_LBRACE] = ACTIONS(3683),
    [anon_sym_signed] = ACTIONS(3681),
    [anon_sym_unsigned] = ACTIONS(3681),
    [anon_sym_long] = ACTIONS(3681),
    [anon_sym_short] = ACTIONS(3681),
    [anon_sym_LBRACK] = ACTIONS(3681),
    [anon_sym_static] = ACTIONS(3681),
    [anon_sym_register] = ACTIONS(3681),
    [anon_sym_inline] = ACTIONS(3681),
    [anon_sym___inline] = ACTIONS(3681),
    [anon_sym___inline__] = ACTIONS(3681),
    [anon_sym___forceinline] = ACTIONS(3681),
    [anon_sym_thread_local] = ACTIONS(3681),
    [anon_sym___thread] = ACTIONS(3681),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_constexpr] = ACTIONS(3681),
    [anon_sym_volatile] = ACTIONS(3681),
    [anon_sym_restrict] = ACTIONS(3681),
    [anon_sym___restrict__] = ACTIONS(3681),
    [anon_sym__Atomic] = ACTIONS(3681),
    [anon_sym__Noreturn] = ACTIONS(3681),
    [anon_sym_noreturn] = ACTIONS(3681),
    [anon_sym_mutable] = ACTIONS(3681),
    [anon_sym_constinit] = ACTIONS(3681),
    [anon_sym_consteval] = ACTIONS(3681),
    [anon_sym_alignas] = ACTIONS(3681),
    [anon_sym__Alignas] = ACTIONS(3681),
    [sym_primitive_type] = ACTIONS(3681),
    [anon_sym_enum] = ACTIONS(3681),
    [anon_sym_class] = ACTIONS(3681),
    [anon_sym_struct] = ACTIONS(3681),
    [anon_sym_union] = ACTIONS(3681),
    [anon_sym_if] = ACTIONS(3681),
    [anon_sym_switch] = ACTIONS(3681),
    [anon_sym_case] = ACTIONS(3681),
    [anon_sym_default] = ACTIONS(3681),
    [anon_sym_while] = ACTIONS(3681),
    [anon_sym_do] = ACTIONS(3681),
    [anon_sym_for] = ACTIONS(3681),
    [anon_sym_return] = ACTIONS(3681),
    [anon_sym_break] = ACTIONS(3681),
    [anon_sym_continue] = ACTIONS(3681),
    [anon_sym_goto] = ACTIONS(3681),
    [anon_sym_not] = ACTIONS(3681),
    [anon_sym_compl] = ACTIONS(3681),
    [anon_sym_DASH_DASH] = ACTIONS(3683),
    [anon_sym_PLUS_PLUS] = ACTIONS(3683),
    [anon_sym_sizeof] = ACTIONS(3681),
    [anon_sym___alignof__] = ACTIONS(3681),
    [anon_sym___alignof] = ACTIONS(3681),
    [anon_sym__alignof] = ACTIONS(3681),
    [anon_sym_alignof] = ACTIONS(3681),
    [anon_sym__Alignof] = ACTIONS(3681),
    [anon_sym_offsetof] = ACTIONS(3681),
    [anon_sym__Generic] = ACTIONS(3681),
    [anon_sym_asm] = ACTIONS(3681),
    [anon_sym___asm__] = ACTIONS(3681),
    [sym_number_literal] = ACTIONS(3683),
    [anon_sym_L_SQUOTE] = ACTIONS(3683),
    [anon_sym_u_SQUOTE] = ACTIONS(3683),
    [anon_sym_U_SQUOTE] = ACTIONS(3683),
    [anon_sym_u8_SQUOTE] = ACTIONS(3683),
    [anon_sym_SQUOTE] = ACTIONS(3683),
    [anon_sym_L_DQUOTE] = ACTIONS(3683),
    [anon_sym_u_DQUOTE] = ACTIONS(3683),
    [anon_sym_U_DQUOTE] = ACTIONS(3683),
    [anon_sym_u8_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE] = ACTIONS(3683),
    [sym_true] = ACTIONS(3681),
    [sym_false] = ACTIONS(3681),
    [anon_sym_NULL] = ACTIONS(3681),
    [anon_sym_nullptr] = ACTIONS(3681),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3681),
    [anon_sym_let] = ACTIONS(3681),
    [anon_sym_This] = ACTIONS(3681),
    [anon_sym_decltype] = ACTIONS(3681),
    [sym_virtual] = ACTIONS(3681),
    [anon_sym_explicit] = ACTIONS(3681),
    [anon_sym_typename] = ACTIONS(3681),
    [anon_sym_template] = ACTIONS(3681),
    [anon_sym_operator] = ACTIONS(3681),
    [anon_sym_try] = ACTIONS(3681),
    [anon_sym_delete] = ACTIONS(3681),
    [anon_sym_throw] = ACTIONS(3681),
    [anon_sym_namespace] = ACTIONS(3681),
    [anon_sym_using] = ACTIONS(3681),
    [anon_sym_static_assert] = ACTIONS(3681),
    [anon_sym_concept] = ACTIONS(3681),
    [anon_sym_co_return] = ACTIONS(3681),
    [anon_sym_co_yield] = ACTIONS(3681),
    [anon_sym_R_DQUOTE] = ACTIONS(3683),
    [anon_sym_LR_DQUOTE] = ACTIONS(3683),
    [anon_sym_uR_DQUOTE] = ACTIONS(3683),
    [anon_sym_UR_DQUOTE] = ACTIONS(3683),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3683),
    [anon_sym_co_await] = ACTIONS(3681),
    [anon_sym_new] = ACTIONS(3681),
    [anon_sym_requires] = ACTIONS(3681),
    [sym_this] = ACTIONS(3681),
    [anon_sym_precise] = ACTIONS(3681),
    [anon_sym_shared] = ACTIONS(3681),
    [anon_sym_groupshared] = ACTIONS(3681),
    [anon_sym_uniform] = ACTIONS(3681),
    [anon_sym_row_major] = ACTIONS(3681),
    [anon_sym_column_major] = ACTIONS(3681),
    [anon_sym_globallycoherent] = ACTIONS(3681),
    [anon_sym_centroid] = ACTIONS(3681),
    [anon_sym_noperspective] = ACTIONS(3681),
    [anon_sym_nointerpolation] = ACTIONS(3681),
    [anon_sym_sample] = ACTIONS(3681),
    [anon_sym_linear] = ACTIONS(3681),
    [anon_sym_snorm] = ACTIONS(3681),
    [anon_sym_unorm] = ACTIONS(3681),
    [anon_sym_point] = ACTIONS(3681),
    [anon_sym_line] = ACTIONS(3681),
    [anon_sym_triangleadj] = ACTIONS(3681),
    [anon_sym_lineadj] = ACTIONS(3681),
    [anon_sym_triangle] = ACTIONS(3681),
    [anon_sym_interface] = ACTIONS(3681),
    [anon_sym_extension] = ACTIONS(3681),
    [anon_sym___exported] = ACTIONS(3681),
    [anon_sym_import] = ACTIONS(3681),
  },
  [1074] = {
    [ts_builtin_sym_end] = ACTIONS(3515),
    [sym_identifier] = ACTIONS(3513),
    [aux_sym_preproc_include_token1] = ACTIONS(3513),
    [aux_sym_preproc_def_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3513),
    [sym_preproc_directive] = ACTIONS(3513),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_BANG] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3513),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3513),
    [anon_sym___extension__] = ACTIONS(3513),
    [anon_sym_typedef] = ACTIONS(3513),
    [anon_sym_in] = ACTIONS(3513),
    [anon_sym_out] = ACTIONS(3513),
    [anon_sym_inout] = ACTIONS(3513),
    [anon_sym_extern] = ACTIONS(3513),
    [anon_sym___attribute__] = ACTIONS(3513),
    [anon_sym_COLON_COLON] = ACTIONS(3515),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3515),
    [anon_sym___declspec] = ACTIONS(3513),
    [anon_sym___based] = ACTIONS(3513),
    [anon_sym___cdecl] = ACTIONS(3513),
    [anon_sym___clrcall] = ACTIONS(3513),
    [anon_sym___stdcall] = ACTIONS(3513),
    [anon_sym___fastcall] = ACTIONS(3513),
    [anon_sym___thiscall] = ACTIONS(3513),
    [anon_sym___vectorcall] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_signed] = ACTIONS(3513),
    [anon_sym_unsigned] = ACTIONS(3513),
    [anon_sym_long] = ACTIONS(3513),
    [anon_sym_short] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_register] = ACTIONS(3513),
    [anon_sym_inline] = ACTIONS(3513),
    [anon_sym___inline] = ACTIONS(3513),
    [anon_sym___inline__] = ACTIONS(3513),
    [anon_sym___forceinline] = ACTIONS(3513),
    [anon_sym_thread_local] = ACTIONS(3513),
    [anon_sym___thread] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [anon_sym_constexpr] = ACTIONS(3513),
    [anon_sym_volatile] = ACTIONS(3513),
    [anon_sym_restrict] = ACTIONS(3513),
    [anon_sym___restrict__] = ACTIONS(3513),
    [anon_sym__Atomic] = ACTIONS(3513),
    [anon_sym__Noreturn] = ACTIONS(3513),
    [anon_sym_noreturn] = ACTIONS(3513),
    [anon_sym_mutable] = ACTIONS(3513),
    [anon_sym_constinit] = ACTIONS(3513),
    [anon_sym_consteval] = ACTIONS(3513),
    [anon_sym_alignas] = ACTIONS(3513),
    [anon_sym__Alignas] = ACTIONS(3513),
    [sym_primitive_type] = ACTIONS(3513),
    [anon_sym_enum] = ACTIONS(3513),
    [anon_sym_class] = ACTIONS(3513),
    [anon_sym_struct] = ACTIONS(3513),
    [anon_sym_union] = ACTIONS(3513),
    [anon_sym_if] = ACTIONS(3513),
    [anon_sym_switch] = ACTIONS(3513),
    [anon_sym_case] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3513),
    [anon_sym_while] = ACTIONS(3513),
    [anon_sym_do] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3513),
    [anon_sym_return] = ACTIONS(3513),
    [anon_sym_break] = ACTIONS(3513),
    [anon_sym_continue] = ACTIONS(3513),
    [anon_sym_goto] = ACTIONS(3513),
    [anon_sym_not] = ACTIONS(3513),
    [anon_sym_compl] = ACTIONS(3513),
    [anon_sym_DASH_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_PLUS] = ACTIONS(3515),
    [anon_sym_sizeof] = ACTIONS(3513),
    [anon_sym___alignof__] = ACTIONS(3513),
    [anon_sym___alignof] = ACTIONS(3513),
    [anon_sym__alignof] = ACTIONS(3513),
    [anon_sym_alignof] = ACTIONS(3513),
    [anon_sym__Alignof] = ACTIONS(3513),
    [anon_sym_offsetof] = ACTIONS(3513),
    [anon_sym__Generic] = ACTIONS(3513),
    [anon_sym_asm] = ACTIONS(3513),
    [anon_sym___asm__] = ACTIONS(3513),
    [sym_number_literal] = ACTIONS(3515),
    [anon_sym_L_SQUOTE] = ACTIONS(3515),
    [anon_sym_u_SQUOTE] = ACTIONS(3515),
    [anon_sym_U_SQUOTE] = ACTIONS(3515),
    [anon_sym_u8_SQUOTE] = ACTIONS(3515),
    [anon_sym_SQUOTE] = ACTIONS(3515),
    [anon_sym_L_DQUOTE] = ACTIONS(3515),
    [anon_sym_u_DQUOTE] = ACTIONS(3515),
    [anon_sym_U_DQUOTE] = ACTIONS(3515),
    [anon_sym_u8_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [sym_true] = ACTIONS(3513),
    [sym_false] = ACTIONS(3513),
    [anon_sym_NULL] = ACTIONS(3513),
    [anon_sym_nullptr] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3513),
    [anon_sym_let] = ACTIONS(3513),
    [anon_sym_This] = ACTIONS(3513),
    [anon_sym_decltype] = ACTIONS(3513),
    [sym_virtual] = ACTIONS(3513),
    [anon_sym_explicit] = ACTIONS(3513),
    [anon_sym_typename] = ACTIONS(3513),
    [anon_sym_template] = ACTIONS(3513),
    [anon_sym_operator] = ACTIONS(3513),
    [anon_sym_try] = ACTIONS(3513),
    [anon_sym_delete] = ACTIONS(3513),
    [anon_sym_throw] = ACTIONS(3513),
    [anon_sym_namespace] = ACTIONS(3513),
    [anon_sym_using] = ACTIONS(3513),
    [anon_sym_static_assert] = ACTIONS(3513),
    [anon_sym_concept] = ACTIONS(3513),
    [anon_sym_co_return] = ACTIONS(3513),
    [anon_sym_co_yield] = ACTIONS(3513),
    [anon_sym_R_DQUOTE] = ACTIONS(3515),
    [anon_sym_LR_DQUOTE] = ACTIONS(3515),
    [anon_sym_uR_DQUOTE] = ACTIONS(3515),
    [anon_sym_UR_DQUOTE] = ACTIONS(3515),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3515),
    [anon_sym_co_await] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3513),
    [anon_sym_requires] = ACTIONS(3513),
    [sym_this] = ACTIONS(3513),
    [anon_sym_precise] = ACTIONS(3513),
    [anon_sym_shared] = ACTIONS(3513),
    [anon_sym_groupshared] = ACTIONS(3513),
    [anon_sym_uniform] = ACTIONS(3513),
    [anon_sym_row_major] = ACTIONS(3513),
    [anon_sym_column_major] = ACTIONS(3513),
    [anon_sym_globallycoherent] = ACTIONS(3513),
    [anon_sym_centroid] = ACTIONS(3513),
    [anon_sym_noperspective] = ACTIONS(3513),
    [anon_sym_nointerpolation] = ACTIONS(3513),
    [anon_sym_sample] = ACTIONS(3513),
    [anon_sym_linear] = ACTIONS(3513),
    [anon_sym_snorm] = ACTIONS(3513),
    [anon_sym_unorm] = ACTIONS(3513),
    [anon_sym_point] = ACTIONS(3513),
    [anon_sym_line] = ACTIONS(3513),
    [anon_sym_triangleadj] = ACTIONS(3513),
    [anon_sym_lineadj] = ACTIONS(3513),
    [anon_sym_triangle] = ACTIONS(3513),
    [anon_sym_interface] = ACTIONS(3513),
    [anon_sym_extension] = ACTIONS(3513),
    [anon_sym___exported] = ACTIONS(3513),
    [anon_sym_import] = ACTIONS(3513),
  },
  [1075] = {
    [ts_builtin_sym_end] = ACTIONS(3619),
    [sym_identifier] = ACTIONS(3617),
    [aux_sym_preproc_include_token1] = ACTIONS(3617),
    [aux_sym_preproc_def_token1] = ACTIONS(3617),
    [aux_sym_preproc_if_token1] = ACTIONS(3617),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3617),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3617),
    [sym_preproc_directive] = ACTIONS(3617),
    [anon_sym_LPAREN2] = ACTIONS(3619),
    [anon_sym_BANG] = ACTIONS(3619),
    [anon_sym_TILDE] = ACTIONS(3619),
    [anon_sym_DASH] = ACTIONS(3617),
    [anon_sym_PLUS] = ACTIONS(3617),
    [anon_sym_STAR] = ACTIONS(3619),
    [anon_sym_AMP_AMP] = ACTIONS(3619),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym___extension__] = ACTIONS(3617),
    [anon_sym_typedef] = ACTIONS(3617),
    [anon_sym_in] = ACTIONS(3617),
    [anon_sym_out] = ACTIONS(3617),
    [anon_sym_inout] = ACTIONS(3617),
    [anon_sym_extern] = ACTIONS(3617),
    [anon_sym___attribute__] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3619),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3619),
    [anon_sym___declspec] = ACTIONS(3617),
    [anon_sym___based] = ACTIONS(3617),
    [anon_sym___cdecl] = ACTIONS(3617),
    [anon_sym___clrcall] = ACTIONS(3617),
    [anon_sym___stdcall] = ACTIONS(3617),
    [anon_sym___fastcall] = ACTIONS(3617),
    [anon_sym___thiscall] = ACTIONS(3617),
    [anon_sym___vectorcall] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3619),
    [anon_sym_signed] = ACTIONS(3617),
    [anon_sym_unsigned] = ACTIONS(3617),
    [anon_sym_long] = ACTIONS(3617),
    [anon_sym_short] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_static] = ACTIONS(3617),
    [anon_sym_register] = ACTIONS(3617),
    [anon_sym_inline] = ACTIONS(3617),
    [anon_sym___inline] = ACTIONS(3617),
    [anon_sym___inline__] = ACTIONS(3617),
    [anon_sym___forceinline] = ACTIONS(3617),
    [anon_sym_thread_local] = ACTIONS(3617),
    [anon_sym___thread] = ACTIONS(3617),
    [anon_sym_const] = ACTIONS(3617),
    [anon_sym_constexpr] = ACTIONS(3617),
    [anon_sym_volatile] = ACTIONS(3617),
    [anon_sym_restrict] = ACTIONS(3617),
    [anon_sym___restrict__] = ACTIONS(3617),
    [anon_sym__Atomic] = ACTIONS(3617),
    [anon_sym__Noreturn] = ACTIONS(3617),
    [anon_sym_noreturn] = ACTIONS(3617),
    [anon_sym_mutable] = ACTIONS(3617),
    [anon_sym_constinit] = ACTIONS(3617),
    [anon_sym_consteval] = ACTIONS(3617),
    [anon_sym_alignas] = ACTIONS(3617),
    [anon_sym__Alignas] = ACTIONS(3617),
    [sym_primitive_type] = ACTIONS(3617),
    [anon_sym_enum] = ACTIONS(3617),
    [anon_sym_class] = ACTIONS(3617),
    [anon_sym_struct] = ACTIONS(3617),
    [anon_sym_union] = ACTIONS(3617),
    [anon_sym_if] = ACTIONS(3617),
    [anon_sym_switch] = ACTIONS(3617),
    [anon_sym_case] = ACTIONS(3617),
    [anon_sym_default] = ACTIONS(3617),
    [anon_sym_while] = ACTIONS(3617),
    [anon_sym_do] = ACTIONS(3617),
    [anon_sym_for] = ACTIONS(3617),
    [anon_sym_return] = ACTIONS(3617),
    [anon_sym_break] = ACTIONS(3617),
    [anon_sym_continue] = ACTIONS(3617),
    [anon_sym_goto] = ACTIONS(3617),
    [anon_sym_not] = ACTIONS(3617),
    [anon_sym_compl] = ACTIONS(3617),
    [anon_sym_DASH_DASH] = ACTIONS(3619),
    [anon_sym_PLUS_PLUS] = ACTIONS(3619),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(3617),
    [anon_sym___alignof] = ACTIONS(3617),
    [anon_sym__alignof] = ACTIONS(3617),
    [anon_sym_alignof] = ACTIONS(3617),
    [anon_sym__Alignof] = ACTIONS(3617),
    [anon_sym_offsetof] = ACTIONS(3617),
    [anon_sym__Generic] = ACTIONS(3617),
    [anon_sym_asm] = ACTIONS(3617),
    [anon_sym___asm__] = ACTIONS(3617),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3619),
    [anon_sym_u_SQUOTE] = ACTIONS(3619),
    [anon_sym_U_SQUOTE] = ACTIONS(3619),
    [anon_sym_u8_SQUOTE] = ACTIONS(3619),
    [anon_sym_SQUOTE] = ACTIONS(3619),
    [anon_sym_L_DQUOTE] = ACTIONS(3619),
    [anon_sym_u_DQUOTE] = ACTIONS(3619),
    [anon_sym_U_DQUOTE] = ACTIONS(3619),
    [anon_sym_u8_DQUOTE] = ACTIONS(3619),
    [anon_sym_DQUOTE] = ACTIONS(3619),
    [sym_true] = ACTIONS(3617),
    [sym_false] = ACTIONS(3617),
    [anon_sym_NULL] = ACTIONS(3617),
    [anon_sym_nullptr] = ACTIONS(3617),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3617),
    [anon_sym_let] = ACTIONS(3617),
    [anon_sym_This] = ACTIONS(3617),
    [anon_sym_decltype] = ACTIONS(3617),
    [sym_virtual] = ACTIONS(3617),
    [anon_sym_explicit] = ACTIONS(3617),
    [anon_sym_typename] = ACTIONS(3617),
    [anon_sym_template] = ACTIONS(3617),
    [anon_sym_operator] = ACTIONS(3617),
    [anon_sym_try] = ACTIONS(3617),
    [anon_sym_delete] = ACTIONS(3617),
    [anon_sym_throw] = ACTIONS(3617),
    [anon_sym_namespace] = ACTIONS(3617),
    [anon_sym_using] = ACTIONS(3617),
    [anon_sym_static_assert] = ACTIONS(3617),
    [anon_sym_concept] = ACTIONS(3617),
    [anon_sym_co_return] = ACTIONS(3617),
    [anon_sym_co_yield] = ACTIONS(3617),
    [anon_sym_R_DQUOTE] = ACTIONS(3619),
    [anon_sym_LR_DQUOTE] = ACTIONS(3619),
    [anon_sym_uR_DQUOTE] = ACTIONS(3619),
    [anon_sym_UR_DQUOTE] = ACTIONS(3619),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3619),
    [anon_sym_co_await] = ACTIONS(3617),
    [anon_sym_new] = ACTIONS(3617),
    [anon_sym_requires] = ACTIONS(3617),
    [sym_this] = ACTIONS(3617),
    [anon_sym_precise] = ACTIONS(3617),
    [anon_sym_shared] = ACTIONS(3617),
    [anon_sym_groupshared] = ACTIONS(3617),
    [anon_sym_uniform] = ACTIONS(3617),
    [anon_sym_row_major] = ACTIONS(3617),
    [anon_sym_column_major] = ACTIONS(3617),
    [anon_sym_globallycoherent] = ACTIONS(3617),
    [anon_sym_centroid] = ACTIONS(3617),
    [anon_sym_noperspective] = ACTIONS(3617),
    [anon_sym_nointerpolation] = ACTIONS(3617),
    [anon_sym_sample] = ACTIONS(3617),
    [anon_sym_linear] = ACTIONS(3617),
    [anon_sym_snorm] = ACTIONS(3617),
    [anon_sym_unorm] = ACTIONS(3617),
    [anon_sym_point] = ACTIONS(3617),
    [anon_sym_line] = ACTIONS(3617),
    [anon_sym_triangleadj] = ACTIONS(3617),
    [anon_sym_lineadj] = ACTIONS(3617),
    [anon_sym_triangle] = ACTIONS(3617),
    [anon_sym_interface] = ACTIONS(3617),
    [anon_sym_extension] = ACTIONS(3617),
    [anon_sym___exported] = ACTIONS(3617),
    [anon_sym_import] = ACTIONS(3617),
  },
  [1076] = {
    [ts_builtin_sym_end] = ACTIONS(3503),
    [sym_identifier] = ACTIONS(3501),
    [aux_sym_preproc_include_token1] = ACTIONS(3501),
    [aux_sym_preproc_def_token1] = ACTIONS(3501),
    [aux_sym_preproc_if_token1] = ACTIONS(3501),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3501),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3501),
    [sym_preproc_directive] = ACTIONS(3501),
    [anon_sym_LPAREN2] = ACTIONS(3503),
    [anon_sym_BANG] = ACTIONS(3503),
    [anon_sym_TILDE] = ACTIONS(3503),
    [anon_sym_DASH] = ACTIONS(3501),
    [anon_sym_PLUS] = ACTIONS(3501),
    [anon_sym_STAR] = ACTIONS(3503),
    [anon_sym_AMP_AMP] = ACTIONS(3503),
    [anon_sym_AMP] = ACTIONS(3501),
    [anon_sym___extension__] = ACTIONS(3501),
    [anon_sym_typedef] = ACTIONS(3501),
    [anon_sym_in] = ACTIONS(3501),
    [anon_sym_out] = ACTIONS(3501),
    [anon_sym_inout] = ACTIONS(3501),
    [anon_sym_extern] = ACTIONS(3501),
    [anon_sym___attribute__] = ACTIONS(3501),
    [anon_sym_COLON_COLON] = ACTIONS(3503),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3503),
    [anon_sym___declspec] = ACTIONS(3501),
    [anon_sym___based] = ACTIONS(3501),
    [anon_sym___cdecl] = ACTIONS(3501),
    [anon_sym___clrcall] = ACTIONS(3501),
    [anon_sym___stdcall] = ACTIONS(3501),
    [anon_sym___fastcall] = ACTIONS(3501),
    [anon_sym___thiscall] = ACTIONS(3501),
    [anon_sym___vectorcall] = ACTIONS(3501),
    [anon_sym_LBRACE] = ACTIONS(3503),
    [anon_sym_signed] = ACTIONS(3501),
    [anon_sym_unsigned] = ACTIONS(3501),
    [anon_sym_long] = ACTIONS(3501),
    [anon_sym_short] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(3501),
    [anon_sym_static] = ACTIONS(3501),
    [anon_sym_register] = ACTIONS(3501),
    [anon_sym_inline] = ACTIONS(3501),
    [anon_sym___inline] = ACTIONS(3501),
    [anon_sym___inline__] = ACTIONS(3501),
    [anon_sym___forceinline] = ACTIONS(3501),
    [anon_sym_thread_local] = ACTIONS(3501),
    [anon_sym___thread] = ACTIONS(3501),
    [anon_sym_const] = ACTIONS(3501),
    [anon_sym_constexpr] = ACTIONS(3501),
    [anon_sym_volatile] = ACTIONS(3501),
    [anon_sym_restrict] = ACTIONS(3501),
    [anon_sym___restrict__] = ACTIONS(3501),
    [anon_sym__Atomic] = ACTIONS(3501),
    [anon_sym__Noreturn] = ACTIONS(3501),
    [anon_sym_noreturn] = ACTIONS(3501),
    [anon_sym_mutable] = ACTIONS(3501),
    [anon_sym_constinit] = ACTIONS(3501),
    [anon_sym_consteval] = ACTIONS(3501),
    [anon_sym_alignas] = ACTIONS(3501),
    [anon_sym__Alignas] = ACTIONS(3501),
    [sym_primitive_type] = ACTIONS(3501),
    [anon_sym_enum] = ACTIONS(3501),
    [anon_sym_class] = ACTIONS(3501),
    [anon_sym_struct] = ACTIONS(3501),
    [anon_sym_union] = ACTIONS(3501),
    [anon_sym_if] = ACTIONS(3501),
    [anon_sym_switch] = ACTIONS(3501),
    [anon_sym_case] = ACTIONS(3501),
    [anon_sym_default] = ACTIONS(3501),
    [anon_sym_while] = ACTIONS(3501),
    [anon_sym_do] = ACTIONS(3501),
    [anon_sym_for] = ACTIONS(3501),
    [anon_sym_return] = ACTIONS(3501),
    [anon_sym_break] = ACTIONS(3501),
    [anon_sym_continue] = ACTIONS(3501),
    [anon_sym_goto] = ACTIONS(3501),
    [anon_sym_not] = ACTIONS(3501),
    [anon_sym_compl] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(3503),
    [anon_sym_PLUS_PLUS] = ACTIONS(3503),
    [anon_sym_sizeof] = ACTIONS(3501),
    [anon_sym___alignof__] = ACTIONS(3501),
    [anon_sym___alignof] = ACTIONS(3501),
    [anon_sym__alignof] = ACTIONS(3501),
    [anon_sym_alignof] = ACTIONS(3501),
    [anon_sym__Alignof] = ACTIONS(3501),
    [anon_sym_offsetof] = ACTIONS(3501),
    [anon_sym__Generic] = ACTIONS(3501),
    [anon_sym_asm] = ACTIONS(3501),
    [anon_sym___asm__] = ACTIONS(3501),
    [sym_number_literal] = ACTIONS(3503),
    [anon_sym_L_SQUOTE] = ACTIONS(3503),
    [anon_sym_u_SQUOTE] = ACTIONS(3503),
    [anon_sym_U_SQUOTE] = ACTIONS(3503),
    [anon_sym_u8_SQUOTE] = ACTIONS(3503),
    [anon_sym_SQUOTE] = ACTIONS(3503),
    [anon_sym_L_DQUOTE] = ACTIONS(3503),
    [anon_sym_u_DQUOTE] = ACTIONS(3503),
    [anon_sym_U_DQUOTE] = ACTIONS(3503),
    [anon_sym_u8_DQUOTE] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3503),
    [sym_true] = ACTIONS(3501),
    [sym_false] = ACTIONS(3501),
    [anon_sym_NULL] = ACTIONS(3501),
    [anon_sym_nullptr] = ACTIONS(3501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3501),
    [anon_sym_let] = ACTIONS(3501),
    [anon_sym_This] = ACTIONS(3501),
    [anon_sym_decltype] = ACTIONS(3501),
    [sym_virtual] = ACTIONS(3501),
    [anon_sym_explicit] = ACTIONS(3501),
    [anon_sym_typename] = ACTIONS(3501),
    [anon_sym_template] = ACTIONS(3501),
    [anon_sym_operator] = ACTIONS(3501),
    [anon_sym_try] = ACTIONS(3501),
    [anon_sym_delete] = ACTIONS(3501),
    [anon_sym_throw] = ACTIONS(3501),
    [anon_sym_namespace] = ACTIONS(3501),
    [anon_sym_using] = ACTIONS(3501),
    [anon_sym_static_assert] = ACTIONS(3501),
    [anon_sym_concept] = ACTIONS(3501),
    [anon_sym_co_return] = ACTIONS(3501),
    [anon_sym_co_yield] = ACTIONS(3501),
    [anon_sym_R_DQUOTE] = ACTIONS(3503),
    [anon_sym_LR_DQUOTE] = ACTIONS(3503),
    [anon_sym_uR_DQUOTE] = ACTIONS(3503),
    [anon_sym_UR_DQUOTE] = ACTIONS(3503),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3503),
    [anon_sym_co_await] = ACTIONS(3501),
    [anon_sym_new] = ACTIONS(3501),
    [anon_sym_requires] = ACTIONS(3501),
    [sym_this] = ACTIONS(3501),
    [anon_sym_precise] = ACTIONS(3501),
    [anon_sym_shared] = ACTIONS(3501),
    [anon_sym_groupshared] = ACTIONS(3501),
    [anon_sym_uniform] = ACTIONS(3501),
    [anon_sym_row_major] = ACTIONS(3501),
    [anon_sym_column_major] = ACTIONS(3501),
    [anon_sym_globallycoherent] = ACTIONS(3501),
    [anon_sym_centroid] = ACTIONS(3501),
    [anon_sym_noperspective] = ACTIONS(3501),
    [anon_sym_nointerpolation] = ACTIONS(3501),
    [anon_sym_sample] = ACTIONS(3501),
    [anon_sym_linear] = ACTIONS(3501),
    [anon_sym_snorm] = ACTIONS(3501),
    [anon_sym_unorm] = ACTIONS(3501),
    [anon_sym_point] = ACTIONS(3501),
    [anon_sym_line] = ACTIONS(3501),
    [anon_sym_triangleadj] = ACTIONS(3501),
    [anon_sym_lineadj] = ACTIONS(3501),
    [anon_sym_triangle] = ACTIONS(3501),
    [anon_sym_interface] = ACTIONS(3501),
    [anon_sym_extension] = ACTIONS(3501),
    [anon_sym___exported] = ACTIONS(3501),
    [anon_sym_import] = ACTIONS(3501),
  },
  [1077] = {
    [ts_builtin_sym_end] = ACTIONS(3687),
    [sym_identifier] = ACTIONS(3685),
    [aux_sym_preproc_include_token1] = ACTIONS(3685),
    [aux_sym_preproc_def_token1] = ACTIONS(3685),
    [aux_sym_preproc_if_token1] = ACTIONS(3685),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3685),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3685),
    [sym_preproc_directive] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3687),
    [anon_sym_BANG] = ACTIONS(3687),
    [anon_sym_TILDE] = ACTIONS(3687),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_STAR] = ACTIONS(3687),
    [anon_sym_AMP_AMP] = ACTIONS(3687),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym___extension__] = ACTIONS(3685),
    [anon_sym_typedef] = ACTIONS(3685),
    [anon_sym_in] = ACTIONS(3685),
    [anon_sym_out] = ACTIONS(3685),
    [anon_sym_inout] = ACTIONS(3685),
    [anon_sym_extern] = ACTIONS(3685),
    [anon_sym___attribute__] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3687),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3687),
    [anon_sym___declspec] = ACTIONS(3685),
    [anon_sym___based] = ACTIONS(3685),
    [anon_sym___cdecl] = ACTIONS(3685),
    [anon_sym___clrcall] = ACTIONS(3685),
    [anon_sym___stdcall] = ACTIONS(3685),
    [anon_sym___fastcall] = ACTIONS(3685),
    [anon_sym___thiscall] = ACTIONS(3685),
    [anon_sym___vectorcall] = ACTIONS(3685),
    [anon_sym_LBRACE] = ACTIONS(3687),
    [anon_sym_signed] = ACTIONS(3685),
    [anon_sym_unsigned] = ACTIONS(3685),
    [anon_sym_long] = ACTIONS(3685),
    [anon_sym_short] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_static] = ACTIONS(3685),
    [anon_sym_register] = ACTIONS(3685),
    [anon_sym_inline] = ACTIONS(3685),
    [anon_sym___inline] = ACTIONS(3685),
    [anon_sym___inline__] = ACTIONS(3685),
    [anon_sym___forceinline] = ACTIONS(3685),
    [anon_sym_thread_local] = ACTIONS(3685),
    [anon_sym___thread] = ACTIONS(3685),
    [anon_sym_const] = ACTIONS(3685),
    [anon_sym_constexpr] = ACTIONS(3685),
    [anon_sym_volatile] = ACTIONS(3685),
    [anon_sym_restrict] = ACTIONS(3685),
    [anon_sym___restrict__] = ACTIONS(3685),
    [anon_sym__Atomic] = ACTIONS(3685),
    [anon_sym__Noreturn] = ACTIONS(3685),
    [anon_sym_noreturn] = ACTIONS(3685),
    [anon_sym_mutable] = ACTIONS(3685),
    [anon_sym_constinit] = ACTIONS(3685),
    [anon_sym_consteval] = ACTIONS(3685),
    [anon_sym_alignas] = ACTIONS(3685),
    [anon_sym__Alignas] = ACTIONS(3685),
    [sym_primitive_type] = ACTIONS(3685),
    [anon_sym_enum] = ACTIONS(3685),
    [anon_sym_class] = ACTIONS(3685),
    [anon_sym_struct] = ACTIONS(3685),
    [anon_sym_union] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_switch] = ACTIONS(3685),
    [anon_sym_case] = ACTIONS(3685),
    [anon_sym_default] = ACTIONS(3685),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_break] = ACTIONS(3685),
    [anon_sym_continue] = ACTIONS(3685),
    [anon_sym_goto] = ACTIONS(3685),
    [anon_sym_not] = ACTIONS(3685),
    [anon_sym_compl] = ACTIONS(3685),
    [anon_sym_DASH_DASH] = ACTIONS(3687),
    [anon_sym_PLUS_PLUS] = ACTIONS(3687),
    [anon_sym_sizeof] = ACTIONS(3685),
    [anon_sym___alignof__] = ACTIONS(3685),
    [anon_sym___alignof] = ACTIONS(3685),
    [anon_sym__alignof] = ACTIONS(3685),
    [anon_sym_alignof] = ACTIONS(3685),
    [anon_sym__Alignof] = ACTIONS(3685),
    [anon_sym_offsetof] = ACTIONS(3685),
    [anon_sym__Generic] = ACTIONS(3685),
    [anon_sym_asm] = ACTIONS(3685),
    [anon_sym___asm__] = ACTIONS(3685),
    [sym_number_literal] = ACTIONS(3687),
    [anon_sym_L_SQUOTE] = ACTIONS(3687),
    [anon_sym_u_SQUOTE] = ACTIONS(3687),
    [anon_sym_U_SQUOTE] = ACTIONS(3687),
    [anon_sym_u8_SQUOTE] = ACTIONS(3687),
    [anon_sym_SQUOTE] = ACTIONS(3687),
    [anon_sym_L_DQUOTE] = ACTIONS(3687),
    [anon_sym_u_DQUOTE] = ACTIONS(3687),
    [anon_sym_U_DQUOTE] = ACTIONS(3687),
    [anon_sym_u8_DQUOTE] = ACTIONS(3687),
    [anon_sym_DQUOTE] = ACTIONS(3687),
    [sym_true] = ACTIONS(3685),
    [sym_false] = ACTIONS(3685),
    [anon_sym_NULL] = ACTIONS(3685),
    [anon_sym_nullptr] = ACTIONS(3685),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_This] = ACTIONS(3685),
    [anon_sym_decltype] = ACTIONS(3685),
    [sym_virtual] = ACTIONS(3685),
    [anon_sym_explicit] = ACTIONS(3685),
    [anon_sym_typename] = ACTIONS(3685),
    [anon_sym_template] = ACTIONS(3685),
    [anon_sym_operator] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_delete] = ACTIONS(3685),
    [anon_sym_throw] = ACTIONS(3685),
    [anon_sym_namespace] = ACTIONS(3685),
    [anon_sym_using] = ACTIONS(3685),
    [anon_sym_static_assert] = ACTIONS(3685),
    [anon_sym_concept] = ACTIONS(3685),
    [anon_sym_co_return] = ACTIONS(3685),
    [anon_sym_co_yield] = ACTIONS(3685),
    [anon_sym_R_DQUOTE] = ACTIONS(3687),
    [anon_sym_LR_DQUOTE] = ACTIONS(3687),
    [anon_sym_uR_DQUOTE] = ACTIONS(3687),
    [anon_sym_UR_DQUOTE] = ACTIONS(3687),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3687),
    [anon_sym_co_await] = ACTIONS(3685),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_requires] = ACTIONS(3685),
    [sym_this] = ACTIONS(3685),
    [anon_sym_precise] = ACTIONS(3685),
    [anon_sym_shared] = ACTIONS(3685),
    [anon_sym_groupshared] = ACTIONS(3685),
    [anon_sym_uniform] = ACTIONS(3685),
    [anon_sym_row_major] = ACTIONS(3685),
    [anon_sym_column_major] = ACTIONS(3685),
    [anon_sym_globallycoherent] = ACTIONS(3685),
    [anon_sym_centroid] = ACTIONS(3685),
    [anon_sym_noperspective] = ACTIONS(3685),
    [anon_sym_nointerpolation] = ACTIONS(3685),
    [anon_sym_sample] = ACTIONS(3685),
    [anon_sym_linear] = ACTIONS(3685),
    [anon_sym_snorm] = ACTIONS(3685),
    [anon_sym_unorm] = ACTIONS(3685),
    [anon_sym_point] = ACTIONS(3685),
    [anon_sym_line] = ACTIONS(3685),
    [anon_sym_triangleadj] = ACTIONS(3685),
    [anon_sym_lineadj] = ACTIONS(3685),
    [anon_sym_triangle] = ACTIONS(3685),
    [anon_sym_interface] = ACTIONS(3685),
    [anon_sym_extension] = ACTIONS(3685),
    [anon_sym___exported] = ACTIONS(3685),
    [anon_sym_import] = ACTIONS(3685),
  },
  [1078] = {
    [ts_builtin_sym_end] = ACTIONS(3627),
    [sym_identifier] = ACTIONS(3625),
    [aux_sym_preproc_include_token1] = ACTIONS(3625),
    [aux_sym_preproc_def_token1] = ACTIONS(3625),
    [aux_sym_preproc_if_token1] = ACTIONS(3625),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3625),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3625),
    [sym_preproc_directive] = ACTIONS(3625),
    [anon_sym_LPAREN2] = ACTIONS(3627),
    [anon_sym_BANG] = ACTIONS(3627),
    [anon_sym_TILDE] = ACTIONS(3627),
    [anon_sym_DASH] = ACTIONS(3625),
    [anon_sym_PLUS] = ACTIONS(3625),
    [anon_sym_STAR] = ACTIONS(3627),
    [anon_sym_AMP_AMP] = ACTIONS(3627),
    [anon_sym_AMP] = ACTIONS(3625),
    [anon_sym___extension__] = ACTIONS(3625),
    [anon_sym_typedef] = ACTIONS(3625),
    [anon_sym_in] = ACTIONS(3625),
    [anon_sym_out] = ACTIONS(3625),
    [anon_sym_inout] = ACTIONS(3625),
    [anon_sym_extern] = ACTIONS(3625),
    [anon_sym___attribute__] = ACTIONS(3625),
    [anon_sym_COLON_COLON] = ACTIONS(3627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3627),
    [anon_sym___declspec] = ACTIONS(3625),
    [anon_sym___based] = ACTIONS(3625),
    [anon_sym___cdecl] = ACTIONS(3625),
    [anon_sym___clrcall] = ACTIONS(3625),
    [anon_sym___stdcall] = ACTIONS(3625),
    [anon_sym___fastcall] = ACTIONS(3625),
    [anon_sym___thiscall] = ACTIONS(3625),
    [anon_sym___vectorcall] = ACTIONS(3625),
    [anon_sym_LBRACE] = ACTIONS(3627),
    [anon_sym_signed] = ACTIONS(3625),
    [anon_sym_unsigned] = ACTIONS(3625),
    [anon_sym_long] = ACTIONS(3625),
    [anon_sym_short] = ACTIONS(3625),
    [anon_sym_LBRACK] = ACTIONS(3625),
    [anon_sym_static] = ACTIONS(3625),
    [anon_sym_register] = ACTIONS(3625),
    [anon_sym_inline] = ACTIONS(3625),
    [anon_sym___inline] = ACTIONS(3625),
    [anon_sym___inline__] = ACTIONS(3625),
    [anon_sym___forceinline] = ACTIONS(3625),
    [anon_sym_thread_local] = ACTIONS(3625),
    [anon_sym___thread] = ACTIONS(3625),
    [anon_sym_const] = ACTIONS(3625),
    [anon_sym_constexpr] = ACTIONS(3625),
    [anon_sym_volatile] = ACTIONS(3625),
    [anon_sym_restrict] = ACTIONS(3625),
    [anon_sym___restrict__] = ACTIONS(3625),
    [anon_sym__Atomic] = ACTIONS(3625),
    [anon_sym__Noreturn] = ACTIONS(3625),
    [anon_sym_noreturn] = ACTIONS(3625),
    [anon_sym_mutable] = ACTIONS(3625),
    [anon_sym_constinit] = ACTIONS(3625),
    [anon_sym_consteval] = ACTIONS(3625),
    [anon_sym_alignas] = ACTIONS(3625),
    [anon_sym__Alignas] = ACTIONS(3625),
    [sym_primitive_type] = ACTIONS(3625),
    [anon_sym_enum] = ACTIONS(3625),
    [anon_sym_class] = ACTIONS(3625),
    [anon_sym_struct] = ACTIONS(3625),
    [anon_sym_union] = ACTIONS(3625),
    [anon_sym_if] = ACTIONS(3625),
    [anon_sym_switch] = ACTIONS(3625),
    [anon_sym_case] = ACTIONS(3625),
    [anon_sym_default] = ACTIONS(3625),
    [anon_sym_while] = ACTIONS(3625),
    [anon_sym_do] = ACTIONS(3625),
    [anon_sym_for] = ACTIONS(3625),
    [anon_sym_return] = ACTIONS(3625),
    [anon_sym_break] = ACTIONS(3625),
    [anon_sym_continue] = ACTIONS(3625),
    [anon_sym_goto] = ACTIONS(3625),
    [anon_sym_not] = ACTIONS(3625),
    [anon_sym_compl] = ACTIONS(3625),
    [anon_sym_DASH_DASH] = ACTIONS(3627),
    [anon_sym_PLUS_PLUS] = ACTIONS(3627),
    [anon_sym_sizeof] = ACTIONS(3625),
    [anon_sym___alignof__] = ACTIONS(3625),
    [anon_sym___alignof] = ACTIONS(3625),
    [anon_sym__alignof] = ACTIONS(3625),
    [anon_sym_alignof] = ACTIONS(3625),
    [anon_sym__Alignof] = ACTIONS(3625),
    [anon_sym_offsetof] = ACTIONS(3625),
    [anon_sym__Generic] = ACTIONS(3625),
    [anon_sym_asm] = ACTIONS(3625),
    [anon_sym___asm__] = ACTIONS(3625),
    [sym_number_literal] = ACTIONS(3627),
    [anon_sym_L_SQUOTE] = ACTIONS(3627),
    [anon_sym_u_SQUOTE] = ACTIONS(3627),
    [anon_sym_U_SQUOTE] = ACTIONS(3627),
    [anon_sym_u8_SQUOTE] = ACTIONS(3627),
    [anon_sym_SQUOTE] = ACTIONS(3627),
    [anon_sym_L_DQUOTE] = ACTIONS(3627),
    [anon_sym_u_DQUOTE] = ACTIONS(3627),
    [anon_sym_U_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8_DQUOTE] = ACTIONS(3627),
    [anon_sym_DQUOTE] = ACTIONS(3627),
    [sym_true] = ACTIONS(3625),
    [sym_false] = ACTIONS(3625),
    [anon_sym_NULL] = ACTIONS(3625),
    [anon_sym_nullptr] = ACTIONS(3625),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3625),
    [anon_sym_let] = ACTIONS(3625),
    [anon_sym_This] = ACTIONS(3625),
    [anon_sym_decltype] = ACTIONS(3625),
    [sym_virtual] = ACTIONS(3625),
    [anon_sym_explicit] = ACTIONS(3625),
    [anon_sym_typename] = ACTIONS(3625),
    [anon_sym_template] = ACTIONS(3625),
    [anon_sym_operator] = ACTIONS(3625),
    [anon_sym_try] = ACTIONS(3625),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_throw] = ACTIONS(3625),
    [anon_sym_namespace] = ACTIONS(3625),
    [anon_sym_using] = ACTIONS(3625),
    [anon_sym_static_assert] = ACTIONS(3625),
    [anon_sym_concept] = ACTIONS(3625),
    [anon_sym_co_return] = ACTIONS(3625),
    [anon_sym_co_yield] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3625),
    [anon_sym_new] = ACTIONS(3625),
    [anon_sym_requires] = ACTIONS(3625),
    [sym_this] = ACTIONS(3625),
    [anon_sym_precise] = ACTIONS(3625),
    [anon_sym_shared] = ACTIONS(3625),
    [anon_sym_groupshared] = ACTIONS(3625),
    [anon_sym_uniform] = ACTIONS(3625),
    [anon_sym_row_major] = ACTIONS(3625),
    [anon_sym_column_major] = ACTIONS(3625),
    [anon_sym_globallycoherent] = ACTIONS(3625),
    [anon_sym_centroid] = ACTIONS(3625),
    [anon_sym_noperspective] = ACTIONS(3625),
    [anon_sym_nointerpolation] = ACTIONS(3625),
    [anon_sym_sample] = ACTIONS(3625),
    [anon_sym_linear] = ACTIONS(3625),
    [anon_sym_snorm] = ACTIONS(3625),
    [anon_sym_unorm] = ACTIONS(3625),
    [anon_sym_point] = ACTIONS(3625),
    [anon_sym_line] = ACTIONS(3625),
    [anon_sym_triangleadj] = ACTIONS(3625),
    [anon_sym_lineadj] = ACTIONS(3625),
    [anon_sym_triangle] = ACTIONS(3625),
    [anon_sym_interface] = ACTIONS(3625),
    [anon_sym_extension] = ACTIONS(3625),
    [anon_sym___exported] = ACTIONS(3625),
    [anon_sym_import] = ACTIONS(3625),
  },
  [1079] = {
    [ts_builtin_sym_end] = ACTIONS(3615),
    [sym_identifier] = ACTIONS(3613),
    [aux_sym_preproc_include_token1] = ACTIONS(3613),
    [aux_sym_preproc_def_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3613),
    [sym_preproc_directive] = ACTIONS(3613),
    [anon_sym_LPAREN2] = ACTIONS(3615),
    [anon_sym_BANG] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3613),
    [anon_sym_PLUS] = ACTIONS(3613),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym___extension__] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3613),
    [anon_sym_in] = ACTIONS(3613),
    [anon_sym_out] = ACTIONS(3613),
    [anon_sym_inout] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym___attribute__] = ACTIONS(3613),
    [anon_sym_COLON_COLON] = ACTIONS(3615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3615),
    [anon_sym___declspec] = ACTIONS(3613),
    [anon_sym___based] = ACTIONS(3613),
    [anon_sym___cdecl] = ACTIONS(3613),
    [anon_sym___clrcall] = ACTIONS(3613),
    [anon_sym___stdcall] = ACTIONS(3613),
    [anon_sym___fastcall] = ACTIONS(3613),
    [anon_sym___thiscall] = ACTIONS(3613),
    [anon_sym___vectorcall] = ACTIONS(3613),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_signed] = ACTIONS(3613),
    [anon_sym_unsigned] = ACTIONS(3613),
    [anon_sym_long] = ACTIONS(3613),
    [anon_sym_short] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_register] = ACTIONS(3613),
    [anon_sym_inline] = ACTIONS(3613),
    [anon_sym___inline] = ACTIONS(3613),
    [anon_sym___inline__] = ACTIONS(3613),
    [anon_sym___forceinline] = ACTIONS(3613),
    [anon_sym_thread_local] = ACTIONS(3613),
    [anon_sym___thread] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_constexpr] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_restrict] = ACTIONS(3613),
    [anon_sym___restrict__] = ACTIONS(3613),
    [anon_sym__Atomic] = ACTIONS(3613),
    [anon_sym__Noreturn] = ACTIONS(3613),
    [anon_sym_noreturn] = ACTIONS(3613),
    [anon_sym_mutable] = ACTIONS(3613),
    [anon_sym_constinit] = ACTIONS(3613),
    [anon_sym_consteval] = ACTIONS(3613),
    [anon_sym_alignas] = ACTIONS(3613),
    [anon_sym__Alignas] = ACTIONS(3613),
    [sym_primitive_type] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_union] = ACTIONS(3613),
    [anon_sym_if] = ACTIONS(3613),
    [anon_sym_switch] = ACTIONS(3613),
    [anon_sym_case] = ACTIONS(3613),
    [anon_sym_default] = ACTIONS(3613),
    [anon_sym_while] = ACTIONS(3613),
    [anon_sym_do] = ACTIONS(3613),
    [anon_sym_for] = ACTIONS(3613),
    [anon_sym_return] = ACTIONS(3613),
    [anon_sym_break] = ACTIONS(3613),
    [anon_sym_continue] = ACTIONS(3613),
    [anon_sym_goto] = ACTIONS(3613),
    [anon_sym_not] = ACTIONS(3613),
    [anon_sym_compl] = ACTIONS(3613),
    [anon_sym_DASH_DASH] = ACTIONS(3615),
    [anon_sym_PLUS_PLUS] = ACTIONS(3615),
    [anon_sym_sizeof] = ACTIONS(3613),
    [anon_sym___alignof__] = ACTIONS(3613),
    [anon_sym___alignof] = ACTIONS(3613),
    [anon_sym__alignof] = ACTIONS(3613),
    [anon_sym_alignof] = ACTIONS(3613),
    [anon_sym__Alignof] = ACTIONS(3613),
    [anon_sym_offsetof] = ACTIONS(3613),
    [anon_sym__Generic] = ACTIONS(3613),
    [anon_sym_asm] = ACTIONS(3613),
    [anon_sym___asm__] = ACTIONS(3613),
    [sym_number_literal] = ACTIONS(3615),
    [anon_sym_L_SQUOTE] = ACTIONS(3615),
    [anon_sym_u_SQUOTE] = ACTIONS(3615),
    [anon_sym_U_SQUOTE] = ACTIONS(3615),
    [anon_sym_u8_SQUOTE] = ACTIONS(3615),
    [anon_sym_SQUOTE] = ACTIONS(3615),
    [anon_sym_L_DQUOTE] = ACTIONS(3615),
    [anon_sym_u_DQUOTE] = ACTIONS(3615),
    [anon_sym_U_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8_DQUOTE] = ACTIONS(3615),
    [anon_sym_DQUOTE] = ACTIONS(3615),
    [sym_true] = ACTIONS(3613),
    [sym_false] = ACTIONS(3613),
    [anon_sym_NULL] = ACTIONS(3613),
    [anon_sym_nullptr] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_This] = ACTIONS(3613),
    [anon_sym_decltype] = ACTIONS(3613),
    [sym_virtual] = ACTIONS(3613),
    [anon_sym_explicit] = ACTIONS(3613),
    [anon_sym_typename] = ACTIONS(3613),
    [anon_sym_template] = ACTIONS(3613),
    [anon_sym_operator] = ACTIONS(3613),
    [anon_sym_try] = ACTIONS(3613),
    [anon_sym_delete] = ACTIONS(3613),
    [anon_sym_throw] = ACTIONS(3613),
    [anon_sym_namespace] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_static_assert] = ACTIONS(3613),
    [anon_sym_concept] = ACTIONS(3613),
    [anon_sym_co_return] = ACTIONS(3613),
    [anon_sym_co_yield] = ACTIONS(3613),
    [anon_sym_R_DQUOTE] = ACTIONS(3615),
    [anon_sym_LR_DQUOTE] = ACTIONS(3615),
    [anon_sym_uR_DQUOTE] = ACTIONS(3615),
    [anon_sym_UR_DQUOTE] = ACTIONS(3615),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3615),
    [anon_sym_co_await] = ACTIONS(3613),
    [anon_sym_new] = ACTIONS(3613),
    [anon_sym_requires] = ACTIONS(3613),
    [sym_this] = ACTIONS(3613),
    [anon_sym_precise] = ACTIONS(3613),
    [anon_sym_shared] = ACTIONS(3613),
    [anon_sym_groupshared] = ACTIONS(3613),
    [anon_sym_uniform] = ACTIONS(3613),
    [anon_sym_row_major] = ACTIONS(3613),
    [anon_sym_column_major] = ACTIONS(3613),
    [anon_sym_globallycoherent] = ACTIONS(3613),
    [anon_sym_centroid] = ACTIONS(3613),
    [anon_sym_noperspective] = ACTIONS(3613),
    [anon_sym_nointerpolation] = ACTIONS(3613),
    [anon_sym_sample] = ACTIONS(3613),
    [anon_sym_linear] = ACTIONS(3613),
    [anon_sym_snorm] = ACTIONS(3613),
    [anon_sym_unorm] = ACTIONS(3613),
    [anon_sym_point] = ACTIONS(3613),
    [anon_sym_line] = ACTIONS(3613),
    [anon_sym_triangleadj] = ACTIONS(3613),
    [anon_sym_lineadj] = ACTIONS(3613),
    [anon_sym_triangle] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_extension] = ACTIONS(3613),
    [anon_sym___exported] = ACTIONS(3613),
    [anon_sym_import] = ACTIONS(3613),
  },
  [1080] = {
    [sym__declaration_modifiers] = STATE(2191),
    [sym__declaration_specifiers] = STATE(7575),
    [sym_attribute_specifier] = STATE(2191),
    [sym_attribute_declaration] = STATE(2191),
    [sym_ms_declspec_modifier] = STATE(2191),
    [sym_storage_class_specifier] = STATE(2191),
    [sym_type_qualifier] = STATE(2191),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(3067),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2191),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2191),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3133),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym_COMMA] = ACTIONS(3969),
    [anon_sym_BANG] = ACTIONS(3971),
    [anon_sym_TILDE] = ACTIONS(3969),
    [anon_sym_DASH] = ACTIONS(3971),
    [anon_sym_PLUS] = ACTIONS(3971),
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_PERCENT] = ACTIONS(3971),
    [anon_sym_PIPE_PIPE] = ACTIONS(3969),
    [anon_sym_AMP_AMP] = ACTIONS(3969),
    [anon_sym_PIPE] = ACTIONS(3971),
    [anon_sym_CARET] = ACTIONS(3971),
    [anon_sym_AMP] = ACTIONS(3971),
    [anon_sym_EQ_EQ] = ACTIONS(3969),
    [anon_sym_BANG_EQ] = ACTIONS(3969),
    [anon_sym_GT] = ACTIONS(3971),
    [anon_sym_GT_EQ] = ACTIONS(3969),
    [anon_sym_LT_EQ] = ACTIONS(3971),
    [anon_sym_LT] = ACTIONS(3971),
    [anon_sym_LT_LT] = ACTIONS(3971),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(3973),
    [anon_sym_out] = ACTIONS(3973),
    [anon_sym_inout] = ACTIONS(3973),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(3977),
    [anon_sym_unsigned] = ACTIONS(3977),
    [anon_sym_long] = ACTIONS(3977),
    [anon_sym_short] = ACTIONS(3977),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_EQ] = ACTIONS(3971),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(3979),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [anon_sym_STAR_EQ] = ACTIONS(3969),
    [anon_sym_SLASH_EQ] = ACTIONS(3969),
    [anon_sym_PERCENT_EQ] = ACTIONS(3969),
    [anon_sym_PLUS_EQ] = ACTIONS(3969),
    [anon_sym_DASH_EQ] = ACTIONS(3969),
    [anon_sym_LT_LT_EQ] = ACTIONS(3969),
    [anon_sym_GT_GT_EQ] = ACTIONS(3969),
    [anon_sym_AMP_EQ] = ACTIONS(3969),
    [anon_sym_CARET_EQ] = ACTIONS(3969),
    [anon_sym_PIPE_EQ] = ACTIONS(3969),
    [anon_sym_and_eq] = ACTIONS(3971),
    [anon_sym_or_eq] = ACTIONS(3971),
    [anon_sym_xor_eq] = ACTIONS(3971),
    [anon_sym_not] = ACTIONS(3971),
    [anon_sym_compl] = ACTIONS(3971),
    [anon_sym_LT_EQ_GT] = ACTIONS(3969),
    [anon_sym_or] = ACTIONS(3971),
    [anon_sym_and] = ACTIONS(3971),
    [anon_sym_bitor] = ACTIONS(3971),
    [anon_sym_xor] = ACTIONS(3971),
    [anon_sym_bitand] = ACTIONS(3971),
    [anon_sym_not_eq] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3969),
    [anon_sym_DASH_GT] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(3973),
    [anon_sym_typename] = ACTIONS(3981),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(3983),
    [anon_sym_co_await] = ACTIONS(3971),
    [anon_sym_new] = ACTIONS(3983),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3969),
    [anon_sym_LPAREN_RPAREN] = ACTIONS(3969),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3969),
    [anon_sym_DQUOTE_DQUOTE] = ACTIONS(3985),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
  },
  [1081] = {
    [sym__declaration_modifiers] = STATE(2191),
    [sym__declaration_specifiers] = STATE(7575),
    [sym_attribute_specifier] = STATE(2191),
    [sym_attribute_declaration] = STATE(2191),
    [sym_ms_declspec_modifier] = STATE(2191),
    [sym_storage_class_specifier] = STATE(2191),
    [sym_type_qualifier] = STATE(2191),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(3067),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2191),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2191),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3133),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym_COMMA] = ACTIONS(3987),
    [anon_sym_BANG] = ACTIONS(3989),
    [anon_sym_TILDE] = ACTIONS(3987),
    [anon_sym_DASH] = ACTIONS(3989),
    [anon_sym_PLUS] = ACTIONS(3989),
    [anon_sym_STAR] = ACTIONS(3989),
    [anon_sym_SLASH] = ACTIONS(3989),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_PIPE_PIPE] = ACTIONS(3987),
    [anon_sym_AMP_AMP] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3989),
    [anon_sym_CARET] = ACTIONS(3989),
    [anon_sym_AMP] = ACTIONS(3989),
    [anon_sym_EQ_EQ] = ACTIONS(3987),
    [anon_sym_BANG_EQ] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3989),
    [anon_sym_GT_EQ] = ACTIONS(3987),
    [anon_sym_LT_EQ] = ACTIONS(3989),
    [anon_sym_LT] = ACTIONS(3989),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_GT_GT] = ACTIONS(3989),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(3973),
    [anon_sym_out] = ACTIONS(3973),
    [anon_sym_inout] = ACTIONS(3973),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(3977),
    [anon_sym_unsigned] = ACTIONS(3977),
    [anon_sym_long] = ACTIONS(3977),
    [anon_sym_short] = ACTIONS(3977),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_EQ] = ACTIONS(3989),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(3979),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [anon_sym_STAR_EQ] = ACTIONS(3987),
    [anon_sym_SLASH_EQ] = ACTIONS(3987),
    [anon_sym_PERCENT_EQ] = ACTIONS(3987),
    [anon_sym_PLUS_EQ] = ACTIONS(3987),
    [anon_sym_DASH_EQ] = ACTIONS(3987),
    [anon_sym_LT_LT_EQ] = ACTIONS(3987),
    [anon_sym_GT_GT_EQ] = ACTIONS(3987),
    [anon_sym_AMP_EQ] = ACTIONS(3987),
    [anon_sym_CARET_EQ] = ACTIONS(3987),
    [anon_sym_PIPE_EQ] = ACTIONS(3987),
    [anon_sym_and_eq] = ACTIONS(3989),
    [anon_sym_or_eq] = ACTIONS(3989),
    [anon_sym_xor_eq] = ACTIONS(3989),
    [anon_sym_not] = ACTIONS(3989),
    [anon_sym_compl] = ACTIONS(3989),
    [anon_sym_LT_EQ_GT] = ACTIONS(3987),
    [anon_sym_or] = ACTIONS(3989),
    [anon_sym_and] = ACTIONS(3989),
    [anon_sym_bitor] = ACTIONS(3989),
    [anon_sym_xor] = ACTIONS(3989),
    [anon_sym_bitand] = ACTIONS(3989),
    [anon_sym_not_eq] = ACTIONS(3989),
    [anon_sym_DASH_DASH] = ACTIONS(3987),
    [anon_sym_PLUS_PLUS] = ACTIONS(3987),
    [anon_sym_DASH_GT] = ACTIONS(3989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(3973),
    [anon_sym_typename] = ACTIONS(3981),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(3991),
    [anon_sym_co_await] = ACTIONS(3989),
    [anon_sym_new] = ACTIONS(3991),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3987),
    [anon_sym_LPAREN_RPAREN] = ACTIONS(3987),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3987),
    [anon_sym_DQUOTE_DQUOTE] = ACTIONS(3993),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
  },
  [1082] = {
    [sym_function_definition] = STATE(2498),
    [sym_declaration] = STATE(2498),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5682),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1908),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7427),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2676),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__empty_declaration] = STATE(2498),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2593),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(2498),
    [sym_operator_cast] = STATE(8371),
    [sym__constructor_specifiers] = STATE(2593),
    [sym_operator_cast_definition] = STATE(2498),
    [sym_operator_cast_declaration] = STATE(2498),
    [sym_constructor_or_destructor_definition] = STATE(2498),
    [sym_constructor_or_destructor_declaration] = STATE(2498),
    [sym_friend_declaration] = STATE(2498),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_alias_declaration] = STATE(2498),
    [sym_concept_definition] = STATE(2498),
    [sym_requires_clause] = STATE(1133),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6578),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8371),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_hlsl_attribute] = STATE(1514),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2593),
    [sym_identifier] = ACTIONS(3995),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3997),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(3999),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(2926),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2928),
    [anon_sym_using] = ACTIONS(4001),
    [anon_sym_concept] = ACTIONS(4003),
    [anon_sym_requires] = ACTIONS(4005),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1083] = {
    [sym_function_definition] = STATE(2417),
    [sym_declaration] = STATE(2417),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5723),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2685),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__empty_declaration] = STATE(2417),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(2417),
    [sym_operator_cast] = STATE(8480),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(2417),
    [sym_operator_cast_declaration] = STATE(2417),
    [sym_constructor_or_destructor_definition] = STATE(2417),
    [sym_constructor_or_destructor_declaration] = STATE(2417),
    [sym_friend_declaration] = STATE(2417),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_alias_declaration] = STATE(2417),
    [sym_concept_definition] = STATE(2417),
    [sym_requires_clause] = STATE(1171),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6578),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_hlsl_attribute] = STATE(1511),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(3995),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3997),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(3999),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_using] = ACTIONS(4007),
    [anon_sym_concept] = ACTIONS(4009),
    [anon_sym_requires] = ACTIONS(4005),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1084] = {
    [sym_function_definition] = STATE(1557),
    [sym_declaration] = STATE(1557),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5707),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1906),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7467),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2674),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__empty_declaration] = STATE(1557),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2591),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(1557),
    [sym_operator_cast] = STATE(8364),
    [sym__constructor_specifiers] = STATE(2591),
    [sym_operator_cast_definition] = STATE(1557),
    [sym_operator_cast_declaration] = STATE(1557),
    [sym_constructor_or_destructor_definition] = STATE(1557),
    [sym_constructor_or_destructor_declaration] = STATE(1557),
    [sym_friend_declaration] = STATE(1557),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_alias_declaration] = STATE(1557),
    [sym_concept_definition] = STATE(1557),
    [sym_requires_clause] = STATE(1168),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6578),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8364),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_hlsl_attribute] = STATE(1512),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(3995),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3997),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(3999),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(2421),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2423),
    [anon_sym_using] = ACTIONS(4011),
    [anon_sym_concept] = ACTIONS(4013),
    [anon_sym_requires] = ACTIONS(4005),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1085] = {
    [sym_function_definition] = STATE(1062),
    [sym_declaration] = STATE(1062),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5680),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1937),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7449),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2681),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__empty_declaration] = STATE(1062),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2586),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(1062),
    [sym_operator_cast] = STATE(8467),
    [sym__constructor_specifiers] = STATE(2586),
    [sym_operator_cast_definition] = STATE(1062),
    [sym_operator_cast_declaration] = STATE(1062),
    [sym_constructor_or_destructor_definition] = STATE(1062),
    [sym_constructor_or_destructor_declaration] = STATE(1062),
    [sym_friend_declaration] = STATE(1062),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_alias_declaration] = STATE(1062),
    [sym_concept_definition] = STATE(1062),
    [sym_requires_clause] = STATE(1132),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6578),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8467),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_hlsl_attribute] = STATE(1507),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2586),
    [sym_identifier] = ACTIONS(3995),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3997),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(3999),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(4015),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(4017),
    [anon_sym_using] = ACTIONS(4019),
    [anon_sym_concept] = ACTIONS(145),
    [anon_sym_requires] = ACTIONS(4005),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1086] = {
    [sym_function_definition] = STATE(839),
    [sym_declaration] = STATE(839),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7413),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__empty_declaration] = STATE(839),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2587),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(839),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2587),
    [sym_operator_cast_definition] = STATE(839),
    [sym_operator_cast_declaration] = STATE(839),
    [sym_constructor_or_destructor_definition] = STATE(839),
    [sym_constructor_or_destructor_declaration] = STATE(839),
    [sym_friend_declaration] = STATE(839),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_alias_declaration] = STATE(839),
    [sym_concept_definition] = STATE(839),
    [sym_requires_clause] = STATE(1136),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6578),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_hlsl_attribute] = STATE(1508),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2587),
    [sym_identifier] = ACTIONS(3995),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3997),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(3999),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(4021),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(4023),
    [anon_sym_using] = ACTIONS(4025),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_requires] = ACTIONS(4005),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1087] = {
    [sym_function_definition] = STATE(878),
    [sym_declaration] = STATE(878),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5738),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1856),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7456),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2683),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__empty_declaration] = STATE(878),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2589),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(878),
    [sym_operator_cast] = STATE(8413),
    [sym__constructor_specifiers] = STATE(2589),
    [sym_operator_cast_definition] = STATE(878),
    [sym_operator_cast_declaration] = STATE(878),
    [sym_constructor_or_destructor_definition] = STATE(878),
    [sym_constructor_or_destructor_declaration] = STATE(878),
    [sym_friend_declaration] = STATE(878),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_alias_declaration] = STATE(878),
    [sym_concept_definition] = STATE(878),
    [sym_requires_clause] = STATE(1127),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6578),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8413),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_hlsl_attribute] = STATE(1510),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2589),
    [sym_identifier] = ACTIONS(3995),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3997),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(3999),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(4027),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(4029),
    [anon_sym_using] = ACTIONS(4031),
    [anon_sym_concept] = ACTIONS(1261),
    [anon_sym_requires] = ACTIONS(4005),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1088] = {
    [sym_function_definition] = STATE(547),
    [sym_declaration] = STATE(547),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5695),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1831),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7458),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2673),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__empty_declaration] = STATE(547),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2585),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(547),
    [sym_operator_cast] = STATE(8424),
    [sym__constructor_specifiers] = STATE(2585),
    [sym_operator_cast_definition] = STATE(547),
    [sym_operator_cast_declaration] = STATE(547),
    [sym_constructor_or_destructor_definition] = STATE(547),
    [sym_constructor_or_destructor_declaration] = STATE(547),
    [sym_friend_declaration] = STATE(547),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_alias_declaration] = STATE(547),
    [sym_concept_definition] = STATE(547),
    [sym_requires_clause] = STATE(1158),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6578),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8424),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_hlsl_attribute] = STATE(1506),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2585),
    [sym_identifier] = ACTIONS(3995),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3997),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(3999),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(4033),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(4035),
    [anon_sym_using] = ACTIONS(4037),
    [anon_sym_concept] = ACTIONS(351),
    [anon_sym_requires] = ACTIONS(4005),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1089] = {
    [sym_attribute_declaration] = STATE(1117),
    [sym_compound_statement] = STATE(774),
    [sym_attributed_statement] = STATE(774),
    [sym_statement] = STATE(770),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5238),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(9902),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(9709),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [sym_identifier] = ACTIONS(4039),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_cbuffer] = ACTIONS(269),
  },
  [1090] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(3543),
    [sym__string] = STATE(4324),
    [sym_comma_expression] = STATE(10299),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_type_descriptor] = STATE(10797),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9813),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym__unary_left_fold] = STATE(10796),
    [sym__unary_right_fold] = STATE(10795),
    [sym__binary_fold] = STATE(10794),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6796),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym__assignment_expression_lhs] = STATE(10304),
    [sym_user_defined_literal] = STATE(4292),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1091] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(3522),
    [sym__string] = STATE(4324),
    [sym_comma_expression] = STATE(10715),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_type_descriptor] = STATE(10727),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9813),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym__unary_left_fold] = STATE(10301),
    [sym__unary_right_fold] = STATE(10302),
    [sym__binary_fold] = STATE(10271),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6796),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym__assignment_expression_lhs] = STATE(10673),
    [sym_user_defined_literal] = STATE(4292),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1092] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(3522),
    [sym__string] = STATE(4324),
    [sym_comma_expression] = STATE(10715),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_type_descriptor] = STATE(10430),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9813),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym__unary_left_fold] = STATE(10708),
    [sym__unary_right_fold] = STATE(10705),
    [sym__binary_fold] = STATE(10700),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6796),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym__assignment_expression_lhs] = STATE(10673),
    [sym_user_defined_literal] = STATE(4292),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1093] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(3522),
    [sym__string] = STATE(4324),
    [sym_comma_expression] = STATE(10715),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_type_descriptor] = STATE(10588),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9813),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym__unary_left_fold] = STATE(10301),
    [sym__unary_right_fold] = STATE(10302),
    [sym__binary_fold] = STATE(10271),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6796),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym__assignment_expression_lhs] = STATE(10673),
    [sym_user_defined_literal] = STATE(4292),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1094] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(3522),
    [sym__string] = STATE(4324),
    [sym_comma_expression] = STATE(10715),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_type_descriptor] = STATE(10464),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9813),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym__unary_left_fold] = STATE(10301),
    [sym__unary_right_fold] = STATE(10302),
    [sym__binary_fold] = STATE(10271),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6796),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym__assignment_expression_lhs] = STATE(10673),
    [sym_user_defined_literal] = STATE(4292),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1095] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(3522),
    [sym__string] = STATE(4324),
    [sym_comma_expression] = STATE(10715),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_type_descriptor] = STATE(10799),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9813),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym__unary_left_fold] = STATE(10301),
    [sym__unary_right_fold] = STATE(10302),
    [sym__binary_fold] = STATE(10271),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6796),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym__assignment_expression_lhs] = STATE(10673),
    [sym_user_defined_literal] = STATE(4292),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1096] = {
    [sym_attribute_declaration] = STATE(1096),
    [sym_compound_statement] = STATE(787),
    [sym_attributed_statement] = STATE(787),
    [sym_statement] = STATE(771),
    [sym_labeled_statement] = STATE(787),
    [sym_expression_statement] = STATE(787),
    [sym_if_statement] = STATE(787),
    [sym_switch_statement] = STATE(787),
    [sym_case_statement] = STATE(787),
    [sym_while_statement] = STATE(787),
    [sym_do_statement] = STATE(787),
    [sym_for_statement] = STATE(787),
    [sym_return_statement] = STATE(787),
    [sym_break_statement] = STATE(787),
    [sym_continue_statement] = STATE(787),
    [sym_goto_statement] = STATE(787),
    [sym_seh_try_statement] = STATE(787),
    [sym_seh_leave_statement] = STATE(787),
    [sym_expression] = STATE(5465),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10896),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(787),
    [sym_co_return_statement] = STATE(787),
    [sym_co_yield_statement] = STATE(787),
    [sym_throw_statement] = STATE(787),
    [sym_try_statement] = STATE(787),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(787),
    [sym_cbuffer_specifier] = STATE(787),
    [sym_hlsl_attribute] = STATE(9939),
    [aux_sym_attributed_declarator_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(4051),
    [anon_sym_LPAREN2] = ACTIONS(4054),
    [anon_sym_BANG] = ACTIONS(4057),
    [anon_sym_TILDE] = ACTIONS(4057),
    [anon_sym_DASH] = ACTIONS(4060),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_STAR] = ACTIONS(4063),
    [anon_sym_AMP] = ACTIONS(4063),
    [anon_sym_SEMI] = ACTIONS(4066),
    [anon_sym_COLON_COLON] = ACTIONS(4069),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4075),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [sym_primitive_type] = ACTIONS(4081),
    [anon_sym_if] = ACTIONS(4084),
    [anon_sym_switch] = ACTIONS(4087),
    [anon_sym_case] = ACTIONS(4090),
    [anon_sym_default] = ACTIONS(4093),
    [anon_sym_while] = ACTIONS(4096),
    [anon_sym_do] = ACTIONS(4099),
    [anon_sym_for] = ACTIONS(4102),
    [anon_sym_return] = ACTIONS(4105),
    [anon_sym_break] = ACTIONS(4108),
    [anon_sym_continue] = ACTIONS(4111),
    [anon_sym_goto] = ACTIONS(4114),
    [anon_sym___try] = ACTIONS(4117),
    [anon_sym___leave] = ACTIONS(4120),
    [anon_sym_not] = ACTIONS(4060),
    [anon_sym_compl] = ACTIONS(4060),
    [anon_sym_DASH_DASH] = ACTIONS(4123),
    [anon_sym_PLUS_PLUS] = ACTIONS(4123),
    [anon_sym_sizeof] = ACTIONS(4126),
    [anon_sym___alignof__] = ACTIONS(4129),
    [anon_sym___alignof] = ACTIONS(4129),
    [anon_sym__alignof] = ACTIONS(4129),
    [anon_sym_alignof] = ACTIONS(4129),
    [anon_sym__Alignof] = ACTIONS(4129),
    [anon_sym_offsetof] = ACTIONS(4132),
    [anon_sym__Generic] = ACTIONS(4135),
    [anon_sym_asm] = ACTIONS(4138),
    [anon_sym___asm__] = ACTIONS(4138),
    [sym_number_literal] = ACTIONS(4141),
    [anon_sym_L_SQUOTE] = ACTIONS(4144),
    [anon_sym_u_SQUOTE] = ACTIONS(4144),
    [anon_sym_U_SQUOTE] = ACTIONS(4144),
    [anon_sym_u8_SQUOTE] = ACTIONS(4144),
    [anon_sym_SQUOTE] = ACTIONS(4144),
    [anon_sym_L_DQUOTE] = ACTIONS(4147),
    [anon_sym_u_DQUOTE] = ACTIONS(4147),
    [anon_sym_U_DQUOTE] = ACTIONS(4147),
    [anon_sym_u8_DQUOTE] = ACTIONS(4147),
    [anon_sym_DQUOTE] = ACTIONS(4147),
    [sym_true] = ACTIONS(4150),
    [sym_false] = ACTIONS(4150),
    [anon_sym_NULL] = ACTIONS(4153),
    [anon_sym_nullptr] = ACTIONS(4153),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4156),
    [anon_sym_template] = ACTIONS(4159),
    [anon_sym_try] = ACTIONS(4162),
    [anon_sym_delete] = ACTIONS(4165),
    [anon_sym_throw] = ACTIONS(4168),
    [anon_sym_co_return] = ACTIONS(4171),
    [anon_sym_co_yield] = ACTIONS(4174),
    [anon_sym_R_DQUOTE] = ACTIONS(4177),
    [anon_sym_LR_DQUOTE] = ACTIONS(4177),
    [anon_sym_uR_DQUOTE] = ACTIONS(4177),
    [anon_sym_UR_DQUOTE] = ACTIONS(4177),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4177),
    [anon_sym_co_await] = ACTIONS(4180),
    [anon_sym_new] = ACTIONS(4183),
    [anon_sym_requires] = ACTIONS(4186),
    [sym_this] = ACTIONS(4150),
    [anon_sym_discard] = ACTIONS(4189),
    [anon_sym_cbuffer] = ACTIONS(4192),
  },
  [1097] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(3522),
    [sym__string] = STATE(4324),
    [sym_comma_expression] = STATE(10715),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_type_descriptor] = STATE(10217),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9813),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym__unary_left_fold] = STATE(10708),
    [sym__unary_right_fold] = STATE(10705),
    [sym__binary_fold] = STATE(10700),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6796),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym__assignment_expression_lhs] = STATE(10673),
    [sym_user_defined_literal] = STATE(4292),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1098] = {
    [sym_attribute_declaration] = STATE(1120),
    [sym_compound_statement] = STATE(406),
    [sym_attributed_statement] = STATE(406),
    [sym_statement] = STATE(280),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(9743),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [sym_identifier] = ACTIONS(4195),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_cbuffer] = ACTIONS(359),
  },
  [1099] = {
    [sym_attribute_declaration] = STATE(1102),
    [sym_compound_statement] = STATE(612),
    [sym_attributed_statement] = STATE(612),
    [sym_statement] = STATE(551),
    [sym_labeled_statement] = STATE(612),
    [sym_expression_statement] = STATE(612),
    [sym_if_statement] = STATE(612),
    [sym_switch_statement] = STATE(612),
    [sym_case_statement] = STATE(612),
    [sym_while_statement] = STATE(612),
    [sym_do_statement] = STATE(612),
    [sym_for_statement] = STATE(612),
    [sym_return_statement] = STATE(612),
    [sym_break_statement] = STATE(612),
    [sym_continue_statement] = STATE(612),
    [sym_goto_statement] = STATE(612),
    [sym_seh_try_statement] = STATE(612),
    [sym_seh_leave_statement] = STATE(612),
    [sym_expression] = STATE(5434),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10523),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(612),
    [sym_co_return_statement] = STATE(612),
    [sym_co_yield_statement] = STATE(612),
    [sym_throw_statement] = STATE(612),
    [sym_try_statement] = STATE(612),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(612),
    [sym_cbuffer_specifier] = STATE(612),
    [sym_hlsl_attribute] = STATE(10015),
    [aux_sym_attributed_declarator_repeat1] = STATE(1102),
    [sym_identifier] = ACTIONS(4197),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1793),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(81),
    [anon_sym_default] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(1795),
    [anon_sym___leave] = ACTIONS(1797),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1799),
    [anon_sym_cbuffer] = ACTIONS(1801),
  },
  [1100] = {
    [sym_attribute_declaration] = STATE(1117),
    [sym_compound_statement] = STATE(774),
    [sym_attributed_statement] = STATE(774),
    [sym_statement] = STATE(738),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(9709),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [sym_identifier] = ACTIONS(4039),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_cbuffer] = ACTIONS(269),
  },
  [1101] = {
    [sym_attribute_declaration] = STATE(1117),
    [sym_compound_statement] = STATE(774),
    [sym_attributed_statement] = STATE(774),
    [sym_statement] = STATE(792),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(9709),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [sym_identifier] = ACTIONS(4039),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_cbuffer] = ACTIONS(269),
  },
  [1102] = {
    [sym_attribute_declaration] = STATE(1180),
    [sym_compound_statement] = STATE(612),
    [sym_attributed_statement] = STATE(612),
    [sym_statement] = STATE(597),
    [sym_labeled_statement] = STATE(612),
    [sym_expression_statement] = STATE(612),
    [sym_if_statement] = STATE(612),
    [sym_switch_statement] = STATE(612),
    [sym_case_statement] = STATE(612),
    [sym_while_statement] = STATE(612),
    [sym_do_statement] = STATE(612),
    [sym_for_statement] = STATE(612),
    [sym_return_statement] = STATE(612),
    [sym_break_statement] = STATE(612),
    [sym_continue_statement] = STATE(612),
    [sym_goto_statement] = STATE(612),
    [sym_seh_try_statement] = STATE(612),
    [sym_seh_leave_statement] = STATE(612),
    [sym_expression] = STATE(5434),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10523),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(612),
    [sym_co_return_statement] = STATE(612),
    [sym_co_yield_statement] = STATE(612),
    [sym_throw_statement] = STATE(612),
    [sym_try_statement] = STATE(612),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(612),
    [sym_cbuffer_specifier] = STATE(612),
    [sym_hlsl_attribute] = STATE(10015),
    [aux_sym_attributed_declarator_repeat1] = STATE(1180),
    [sym_identifier] = ACTIONS(4197),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1793),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(81),
    [anon_sym_default] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(1795),
    [anon_sym___leave] = ACTIONS(1797),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1799),
    [anon_sym_cbuffer] = ACTIONS(1801),
  },
  [1103] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(3522),
    [sym__string] = STATE(4324),
    [sym_comma_expression] = STATE(10715),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_type_descriptor] = STATE(10253),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9813),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym__unary_left_fold] = STATE(10708),
    [sym__unary_right_fold] = STATE(10705),
    [sym__binary_fold] = STATE(10700),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6796),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym__assignment_expression_lhs] = STATE(10673),
    [sym_user_defined_literal] = STATE(4292),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1104] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(3522),
    [sym__string] = STATE(4324),
    [sym_comma_expression] = STATE(10715),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_type_descriptor] = STATE(10222),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9813),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym__unary_left_fold] = STATE(10708),
    [sym__unary_right_fold] = STATE(10705),
    [sym__binary_fold] = STATE(10700),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6796),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym__assignment_expression_lhs] = STATE(10673),
    [sym_user_defined_literal] = STATE(4292),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1105] = {
    [sym_attribute_declaration] = STATE(1117),
    [sym_compound_statement] = STATE(774),
    [sym_attributed_statement] = STATE(774),
    [sym_statement] = STATE(650),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(9709),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [sym_identifier] = ACTIONS(4039),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_cbuffer] = ACTIONS(269),
  },
  [1106] = {
    [sym_attribute_declaration] = STATE(1148),
    [sym_compound_statement] = STATE(787),
    [sym_attributed_statement] = STATE(787),
    [sym_statement] = STATE(705),
    [sym_labeled_statement] = STATE(787),
    [sym_expression_statement] = STATE(787),
    [sym_if_statement] = STATE(787),
    [sym_switch_statement] = STATE(787),
    [sym_case_statement] = STATE(787),
    [sym_while_statement] = STATE(787),
    [sym_do_statement] = STATE(787),
    [sym_for_statement] = STATE(787),
    [sym_return_statement] = STATE(787),
    [sym_break_statement] = STATE(787),
    [sym_continue_statement] = STATE(787),
    [sym_goto_statement] = STATE(787),
    [sym_seh_try_statement] = STATE(787),
    [sym_seh_leave_statement] = STATE(787),
    [sym_expression] = STATE(5465),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10896),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(787),
    [sym_co_return_statement] = STATE(787),
    [sym_co_yield_statement] = STATE(787),
    [sym_throw_statement] = STATE(787),
    [sym_try_statement] = STATE(787),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(787),
    [sym_cbuffer_specifier] = STATE(787),
    [sym_hlsl_attribute] = STATE(9939),
    [aux_sym_attributed_declarator_repeat1] = STATE(1148),
    [sym_identifier] = ACTIONS(4199),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1211),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(1219),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_switch] = ACTIONS(1225),
    [anon_sym_case] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1229),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_do] = ACTIONS(1233),
    [anon_sym_for] = ACTIONS(1235),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1239),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_goto] = ACTIONS(1243),
    [anon_sym___try] = ACTIONS(1245),
    [anon_sym___leave] = ACTIONS(1247),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(1251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(1253),
    [anon_sym_co_return] = ACTIONS(1263),
    [anon_sym_co_yield] = ACTIONS(1265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1267),
    [anon_sym_cbuffer] = ACTIONS(1269),
  },
  [1107] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(3522),
    [sym__string] = STATE(4324),
    [sym_comma_expression] = STATE(10715),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_type_descriptor] = STATE(10413),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9813),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym__unary_left_fold] = STATE(10708),
    [sym__unary_right_fold] = STATE(10705),
    [sym__binary_fold] = STATE(10700),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6796),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym__assignment_expression_lhs] = STATE(10673),
    [sym_user_defined_literal] = STATE(4292),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1108] = {
    [sym_attribute_declaration] = STATE(1117),
    [sym_compound_statement] = STATE(774),
    [sym_attributed_statement] = STATE(774),
    [sym_statement] = STATE(739),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(9709),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [sym_identifier] = ACTIONS(4039),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_cbuffer] = ACTIONS(269),
  },
  [1109] = {
    [sym_attribute_declaration] = STATE(1119),
    [sym_compound_statement] = STATE(774),
    [sym_attributed_statement] = STATE(774),
    [sym_statement] = STATE(10225),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(9921),
    [aux_sym_attributed_declarator_repeat1] = STATE(1119),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(4203),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(4205),
    [anon_sym_default] = ACTIONS(4207),
    [anon_sym_while] = ACTIONS(4209),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(4211),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(4213),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_cbuffer] = ACTIONS(4215),
  },
  [1110] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(3522),
    [sym__string] = STATE(4324),
    [sym_comma_expression] = STATE(10715),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_type_descriptor] = STATE(10339),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9813),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym__unary_left_fold] = STATE(10301),
    [sym__unary_right_fold] = STATE(10302),
    [sym__binary_fold] = STATE(10271),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6796),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym__assignment_expression_lhs] = STATE(10673),
    [sym_user_defined_literal] = STATE(4292),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1111] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(3521),
    [sym__string] = STATE(4324),
    [sym_comma_expression] = STATE(10578),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_type_descriptor] = STATE(10576),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9813),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym__unary_left_fold] = STATE(10439),
    [sym__unary_right_fold] = STATE(10553),
    [sym__binary_fold] = STATE(10552),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6796),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym__assignment_expression_lhs] = STATE(10550),
    [sym_user_defined_literal] = STATE(4292),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1112] = {
    [sym_attribute_declaration] = STATE(1148),
    [sym_compound_statement] = STATE(787),
    [sym_attributed_statement] = STATE(787),
    [sym_statement] = STATE(713),
    [sym_labeled_statement] = STATE(787),
    [sym_expression_statement] = STATE(787),
    [sym_if_statement] = STATE(787),
    [sym_switch_statement] = STATE(787),
    [sym_case_statement] = STATE(787),
    [sym_while_statement] = STATE(787),
    [sym_do_statement] = STATE(787),
    [sym_for_statement] = STATE(787),
    [sym_return_statement] = STATE(787),
    [sym_break_statement] = STATE(787),
    [sym_continue_statement] = STATE(787),
    [sym_goto_statement] = STATE(787),
    [sym_seh_try_statement] = STATE(787),
    [sym_seh_leave_statement] = STATE(787),
    [sym_expression] = STATE(5465),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10896),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(787),
    [sym_co_return_statement] = STATE(787),
    [sym_co_yield_statement] = STATE(787),
    [sym_throw_statement] = STATE(787),
    [sym_try_statement] = STATE(787),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(787),
    [sym_cbuffer_specifier] = STATE(787),
    [sym_hlsl_attribute] = STATE(9939),
    [aux_sym_attributed_declarator_repeat1] = STATE(1148),
    [sym_identifier] = ACTIONS(4199),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1211),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(1219),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_switch] = ACTIONS(1225),
    [anon_sym_case] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1229),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_do] = ACTIONS(1233),
    [anon_sym_for] = ACTIONS(1235),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1239),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_goto] = ACTIONS(1243),
    [anon_sym___try] = ACTIONS(1245),
    [anon_sym___leave] = ACTIONS(1247),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(1251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(1253),
    [anon_sym_co_return] = ACTIONS(1263),
    [anon_sym_co_yield] = ACTIONS(1265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1267),
    [anon_sym_cbuffer] = ACTIONS(1269),
  },
  [1113] = {
    [sym_attribute_declaration] = STATE(1148),
    [sym_compound_statement] = STATE(787),
    [sym_attributed_statement] = STATE(787),
    [sym_statement] = STATE(636),
    [sym_labeled_statement] = STATE(787),
    [sym_expression_statement] = STATE(787),
    [sym_if_statement] = STATE(787),
    [sym_switch_statement] = STATE(787),
    [sym_case_statement] = STATE(787),
    [sym_while_statement] = STATE(787),
    [sym_do_statement] = STATE(787),
    [sym_for_statement] = STATE(787),
    [sym_return_statement] = STATE(787),
    [sym_break_statement] = STATE(787),
    [sym_continue_statement] = STATE(787),
    [sym_goto_statement] = STATE(787),
    [sym_seh_try_statement] = STATE(787),
    [sym_seh_leave_statement] = STATE(787),
    [sym_expression] = STATE(5465),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10896),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(787),
    [sym_co_return_statement] = STATE(787),
    [sym_co_yield_statement] = STATE(787),
    [sym_throw_statement] = STATE(787),
    [sym_try_statement] = STATE(787),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(787),
    [sym_cbuffer_specifier] = STATE(787),
    [sym_hlsl_attribute] = STATE(9939),
    [aux_sym_attributed_declarator_repeat1] = STATE(1148),
    [sym_identifier] = ACTIONS(4199),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1211),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(1219),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_switch] = ACTIONS(1225),
    [anon_sym_case] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1229),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_do] = ACTIONS(1233),
    [anon_sym_for] = ACTIONS(1235),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1239),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_goto] = ACTIONS(1243),
    [anon_sym___try] = ACTIONS(1245),
    [anon_sym___leave] = ACTIONS(1247),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(1251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(1253),
    [anon_sym_co_return] = ACTIONS(1263),
    [anon_sym_co_yield] = ACTIONS(1265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1267),
    [anon_sym_cbuffer] = ACTIONS(1269),
  },
  [1114] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(3522),
    [sym__string] = STATE(4324),
    [sym_comma_expression] = STATE(10715),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_type_descriptor] = STATE(10713),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9813),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym__unary_left_fold] = STATE(10708),
    [sym__unary_right_fold] = STATE(10705),
    [sym__binary_fold] = STATE(10700),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6796),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym__assignment_expression_lhs] = STATE(10673),
    [sym_user_defined_literal] = STATE(4292),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1115] = {
    [sym_attribute_declaration] = STATE(1119),
    [sym_compound_statement] = STATE(774),
    [sym_attributed_statement] = STATE(774),
    [sym_statement] = STATE(10601),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(9921),
    [aux_sym_attributed_declarator_repeat1] = STATE(1119),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(4203),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(4205),
    [anon_sym_default] = ACTIONS(4207),
    [anon_sym_while] = ACTIONS(4209),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(4211),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(4213),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_cbuffer] = ACTIONS(4215),
  },
  [1116] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(3522),
    [sym__string] = STATE(4324),
    [sym_comma_expression] = STATE(10715),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_type_descriptor] = STATE(10300),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9813),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym__unary_left_fold] = STATE(10301),
    [sym__unary_right_fold] = STATE(10302),
    [sym__binary_fold] = STATE(10271),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6796),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym__assignment_expression_lhs] = STATE(10673),
    [sym_user_defined_literal] = STATE(4292),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1117] = {
    [sym_attribute_declaration] = STATE(1126),
    [sym_compound_statement] = STATE(774),
    [sym_attributed_statement] = STATE(774),
    [sym_statement] = STATE(699),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(9709),
    [aux_sym_attributed_declarator_repeat1] = STATE(1126),
    [sym_identifier] = ACTIONS(4039),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_cbuffer] = ACTIONS(269),
  },
  [1118] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(3522),
    [sym__string] = STATE(4324),
    [sym_comma_expression] = STATE(10715),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_type_descriptor] = STATE(10546),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9813),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym__unary_left_fold] = STATE(10301),
    [sym__unary_right_fold] = STATE(10302),
    [sym__binary_fold] = STATE(10271),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6796),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym__assignment_expression_lhs] = STATE(10673),
    [sym_user_defined_literal] = STATE(4292),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1119] = {
    [sym_attribute_declaration] = STATE(1143),
    [sym_compound_statement] = STATE(774),
    [sym_attributed_statement] = STATE(774),
    [sym_statement] = STATE(597),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(9921),
    [aux_sym_attributed_declarator_repeat1] = STATE(1143),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(4203),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(4205),
    [anon_sym_default] = ACTIONS(4207),
    [anon_sym_while] = ACTIONS(4209),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(4211),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(4213),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_cbuffer] = ACTIONS(4215),
  },
  [1120] = {
    [sym_attribute_declaration] = STATE(1147),
    [sym_compound_statement] = STATE(406),
    [sym_attributed_statement] = STATE(406),
    [sym_statement] = STATE(433),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(9743),
    [aux_sym_attributed_declarator_repeat1] = STATE(1147),
    [sym_identifier] = ACTIONS(4195),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_cbuffer] = ACTIONS(359),
  },
  [1121] = {
    [sym_attribute_declaration] = STATE(1119),
    [sym_compound_statement] = STATE(774),
    [sym_attributed_statement] = STATE(774),
    [sym_statement] = STATE(551),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(9921),
    [aux_sym_attributed_declarator_repeat1] = STATE(1119),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(4203),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(4205),
    [anon_sym_default] = ACTIONS(4207),
    [anon_sym_while] = ACTIONS(4209),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(4211),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(4213),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_cbuffer] = ACTIONS(4215),
  },
  [1122] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(3543),
    [sym__string] = STATE(4324),
    [sym_comma_expression] = STATE(10299),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_type_descriptor] = STATE(10565),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9813),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym__unary_left_fold] = STATE(10569),
    [sym__unary_right_fold] = STATE(10571),
    [sym__binary_fold] = STATE(10572),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6796),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym__assignment_expression_lhs] = STATE(10304),
    [sym_user_defined_literal] = STATE(4292),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1123] = {
    [sym_attribute_declaration] = STATE(1102),
    [sym_compound_statement] = STATE(612),
    [sym_attributed_statement] = STATE(612),
    [sym_statement] = STATE(537),
    [sym_labeled_statement] = STATE(612),
    [sym_expression_statement] = STATE(612),
    [sym_if_statement] = STATE(612),
    [sym_switch_statement] = STATE(612),
    [sym_case_statement] = STATE(612),
    [sym_while_statement] = STATE(612),
    [sym_do_statement] = STATE(612),
    [sym_for_statement] = STATE(612),
    [sym_return_statement] = STATE(612),
    [sym_break_statement] = STATE(612),
    [sym_continue_statement] = STATE(612),
    [sym_goto_statement] = STATE(612),
    [sym_seh_try_statement] = STATE(612),
    [sym_seh_leave_statement] = STATE(612),
    [sym_expression] = STATE(5434),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10523),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(612),
    [sym_co_return_statement] = STATE(612),
    [sym_co_yield_statement] = STATE(612),
    [sym_throw_statement] = STATE(612),
    [sym_try_statement] = STATE(612),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(612),
    [sym_cbuffer_specifier] = STATE(612),
    [sym_hlsl_attribute] = STATE(10015),
    [aux_sym_attributed_declarator_repeat1] = STATE(1102),
    [sym_identifier] = ACTIONS(4197),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1793),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(81),
    [anon_sym_default] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(1795),
    [anon_sym___leave] = ACTIONS(1797),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1799),
    [anon_sym_cbuffer] = ACTIONS(1801),
  },
  [1124] = {
    [sym_attribute_declaration] = STATE(1119),
    [sym_compound_statement] = STATE(774),
    [sym_attributed_statement] = STATE(774),
    [sym_statement] = STATE(9605),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(9921),
    [aux_sym_attributed_declarator_repeat1] = STATE(1119),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(4203),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(4205),
    [anon_sym_default] = ACTIONS(4207),
    [anon_sym_while] = ACTIONS(4209),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(4211),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(4213),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_cbuffer] = ACTIONS(4215),
  },
  [1125] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(3522),
    [sym__string] = STATE(4324),
    [sym_comma_expression] = STATE(10715),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_type_descriptor] = STATE(10561),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9813),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym__unary_left_fold] = STATE(10301),
    [sym__unary_right_fold] = STATE(10302),
    [sym__binary_fold] = STATE(10271),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6796),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym__assignment_expression_lhs] = STATE(10673),
    [sym_user_defined_literal] = STATE(4292),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1126] = {
    [sym_attribute_declaration] = STATE(1126),
    [sym_compound_statement] = STATE(774),
    [sym_attributed_statement] = STATE(774),
    [sym_statement] = STATE(699),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(9709),
    [aux_sym_attributed_declarator_repeat1] = STATE(1126),
    [sym_identifier] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4054),
    [anon_sym_BANG] = ACTIONS(4057),
    [anon_sym_TILDE] = ACTIONS(4057),
    [anon_sym_DASH] = ACTIONS(4060),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_STAR] = ACTIONS(4063),
    [anon_sym_AMP] = ACTIONS(4063),
    [anon_sym_SEMI] = ACTIONS(4220),
    [anon_sym_COLON_COLON] = ACTIONS(4069),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4223),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [sym_primitive_type] = ACTIONS(4081),
    [anon_sym_if] = ACTIONS(4226),
    [anon_sym_switch] = ACTIONS(4229),
    [anon_sym_case] = ACTIONS(4232),
    [anon_sym_default] = ACTIONS(4235),
    [anon_sym_while] = ACTIONS(4238),
    [anon_sym_do] = ACTIONS(4241),
    [anon_sym_for] = ACTIONS(4244),
    [anon_sym_return] = ACTIONS(4247),
    [anon_sym_break] = ACTIONS(4250),
    [anon_sym_continue] = ACTIONS(4253),
    [anon_sym_goto] = ACTIONS(4256),
    [anon_sym___try] = ACTIONS(4259),
    [anon_sym___leave] = ACTIONS(4262),
    [anon_sym_not] = ACTIONS(4060),
    [anon_sym_compl] = ACTIONS(4060),
    [anon_sym_DASH_DASH] = ACTIONS(4123),
    [anon_sym_PLUS_PLUS] = ACTIONS(4123),
    [anon_sym_sizeof] = ACTIONS(4126),
    [anon_sym___alignof__] = ACTIONS(4129),
    [anon_sym___alignof] = ACTIONS(4129),
    [anon_sym__alignof] = ACTIONS(4129),
    [anon_sym_alignof] = ACTIONS(4129),
    [anon_sym__Alignof] = ACTIONS(4129),
    [anon_sym_offsetof] = ACTIONS(4132),
    [anon_sym__Generic] = ACTIONS(4135),
    [anon_sym_asm] = ACTIONS(4138),
    [anon_sym___asm__] = ACTIONS(4138),
    [sym_number_literal] = ACTIONS(4141),
    [anon_sym_L_SQUOTE] = ACTIONS(4144),
    [anon_sym_u_SQUOTE] = ACTIONS(4144),
    [anon_sym_U_SQUOTE] = ACTIONS(4144),
    [anon_sym_u8_SQUOTE] = ACTIONS(4144),
    [anon_sym_SQUOTE] = ACTIONS(4144),
    [anon_sym_L_DQUOTE] = ACTIONS(4147),
    [anon_sym_u_DQUOTE] = ACTIONS(4147),
    [anon_sym_U_DQUOTE] = ACTIONS(4147),
    [anon_sym_u8_DQUOTE] = ACTIONS(4147),
    [anon_sym_DQUOTE] = ACTIONS(4147),
    [sym_true] = ACTIONS(4150),
    [sym_false] = ACTIONS(4150),
    [anon_sym_NULL] = ACTIONS(4153),
    [anon_sym_nullptr] = ACTIONS(4153),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4156),
    [anon_sym_template] = ACTIONS(4159),
    [anon_sym_try] = ACTIONS(4265),
    [anon_sym_delete] = ACTIONS(4165),
    [anon_sym_throw] = ACTIONS(4268),
    [anon_sym_co_return] = ACTIONS(4271),
    [anon_sym_co_yield] = ACTIONS(4274),
    [anon_sym_R_DQUOTE] = ACTIONS(4177),
    [anon_sym_LR_DQUOTE] = ACTIONS(4177),
    [anon_sym_uR_DQUOTE] = ACTIONS(4177),
    [anon_sym_UR_DQUOTE] = ACTIONS(4177),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4177),
    [anon_sym_co_await] = ACTIONS(4180),
    [anon_sym_new] = ACTIONS(4183),
    [anon_sym_requires] = ACTIONS(4186),
    [sym_this] = ACTIONS(4150),
    [anon_sym_discard] = ACTIONS(4277),
    [anon_sym_cbuffer] = ACTIONS(4280),
  },
  [1127] = {
    [sym_function_definition] = STATE(858),
    [sym_declaration] = STATE(858),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5738),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1856),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7456),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2683),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__empty_declaration] = STATE(858),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2589),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(858),
    [sym_operator_cast] = STATE(8413),
    [sym__constructor_specifiers] = STATE(2589),
    [sym_operator_cast_definition] = STATE(858),
    [sym_operator_cast_declaration] = STATE(858),
    [sym_constructor_or_destructor_definition] = STATE(858),
    [sym_constructor_or_destructor_declaration] = STATE(858),
    [sym_friend_declaration] = STATE(858),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_alias_declaration] = STATE(858),
    [sym_concept_definition] = STATE(858),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6578),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8413),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_hlsl_attribute] = STATE(1510),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2589),
    [sym_identifier] = ACTIONS(3995),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3997),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(3999),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(4027),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(4029),
    [anon_sym_using] = ACTIONS(4031),
    [anon_sym_concept] = ACTIONS(1261),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1128] = {
    [sym_attribute_declaration] = STATE(1120),
    [sym_compound_statement] = STATE(406),
    [sym_attributed_statement] = STATE(406),
    [sym_statement] = STATE(283),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(9743),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [sym_identifier] = ACTIONS(4195),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_cbuffer] = ACTIONS(359),
  },
  [1129] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(3521),
    [sym__string] = STATE(4324),
    [sym_comma_expression] = STATE(10578),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_type_descriptor] = STATE(10912),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9813),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym__unary_left_fold] = STATE(10910),
    [sym__unary_right_fold] = STATE(10908),
    [sym__binary_fold] = STATE(10906),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6796),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym__assignment_expression_lhs] = STATE(10550),
    [sym_user_defined_literal] = STATE(4292),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1130] = {
    [sym_attribute_declaration] = STATE(1119),
    [sym_compound_statement] = STATE(774),
    [sym_attributed_statement] = STATE(774),
    [sym_statement] = STATE(589),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(9921),
    [aux_sym_attributed_declarator_repeat1] = STATE(1119),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(4203),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(4205),
    [anon_sym_default] = ACTIONS(4207),
    [anon_sym_while] = ACTIONS(4209),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(4211),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(4213),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_cbuffer] = ACTIONS(4215),
  },
  [1131] = {
    [sym_attribute_declaration] = STATE(1119),
    [sym_compound_statement] = STATE(774),
    [sym_attributed_statement] = STATE(774),
    [sym_statement] = STATE(570),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(9921),
    [aux_sym_attributed_declarator_repeat1] = STATE(1119),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(4203),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(4205),
    [anon_sym_default] = ACTIONS(4207),
    [anon_sym_while] = ACTIONS(4209),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(4211),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(4213),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_cbuffer] = ACTIONS(4215),
  },
  [1132] = {
    [sym_function_definition] = STATE(1074),
    [sym_declaration] = STATE(1074),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5680),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1937),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7449),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2681),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__empty_declaration] = STATE(1074),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2586),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(1074),
    [sym_operator_cast] = STATE(8467),
    [sym__constructor_specifiers] = STATE(2586),
    [sym_operator_cast_definition] = STATE(1074),
    [sym_operator_cast_declaration] = STATE(1074),
    [sym_constructor_or_destructor_definition] = STATE(1074),
    [sym_constructor_or_destructor_declaration] = STATE(1074),
    [sym_friend_declaration] = STATE(1074),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_alias_declaration] = STATE(1074),
    [sym_concept_definition] = STATE(1074),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6578),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8467),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_hlsl_attribute] = STATE(1507),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2586),
    [sym_identifier] = ACTIONS(3995),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3997),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(3999),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(4015),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(4017),
    [anon_sym_using] = ACTIONS(4019),
    [anon_sym_concept] = ACTIONS(145),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1133] = {
    [sym_function_definition] = STATE(1959),
    [sym_declaration] = STATE(1959),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5682),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1908),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7427),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2676),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__empty_declaration] = STATE(1959),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2593),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(1959),
    [sym_operator_cast] = STATE(8371),
    [sym__constructor_specifiers] = STATE(2593),
    [sym_operator_cast_definition] = STATE(1959),
    [sym_operator_cast_declaration] = STATE(1959),
    [sym_constructor_or_destructor_definition] = STATE(1959),
    [sym_constructor_or_destructor_declaration] = STATE(1959),
    [sym_friend_declaration] = STATE(1959),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_alias_declaration] = STATE(1959),
    [sym_concept_definition] = STATE(1959),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6578),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8371),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_hlsl_attribute] = STATE(1514),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2593),
    [sym_identifier] = ACTIONS(3995),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3997),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(3999),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(2926),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2928),
    [anon_sym_using] = ACTIONS(4001),
    [anon_sym_concept] = ACTIONS(4003),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1134] = {
    [sym_attribute_declaration] = STATE(1120),
    [sym_compound_statement] = STATE(406),
    [sym_attributed_statement] = STATE(406),
    [sym_statement] = STATE(299),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(9743),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [sym_identifier] = ACTIONS(4195),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_cbuffer] = ACTIONS(359),
  },
  [1135] = {
    [sym_attribute_declaration] = STATE(1119),
    [sym_compound_statement] = STATE(774),
    [sym_attributed_statement] = STATE(774),
    [sym_statement] = STATE(561),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(9921),
    [aux_sym_attributed_declarator_repeat1] = STATE(1119),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(4203),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(4205),
    [anon_sym_default] = ACTIONS(4207),
    [anon_sym_while] = ACTIONS(4209),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(4211),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(4213),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_cbuffer] = ACTIONS(4215),
  },
  [1136] = {
    [sym_function_definition] = STATE(915),
    [sym_declaration] = STATE(915),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7413),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2684),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__empty_declaration] = STATE(915),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2587),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(915),
    [sym_operator_cast] = STATE(8406),
    [sym__constructor_specifiers] = STATE(2587),
    [sym_operator_cast_definition] = STATE(915),
    [sym_operator_cast_declaration] = STATE(915),
    [sym_constructor_or_destructor_definition] = STATE(915),
    [sym_constructor_or_destructor_declaration] = STATE(915),
    [sym_friend_declaration] = STATE(915),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_alias_declaration] = STATE(915),
    [sym_concept_definition] = STATE(915),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6578),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8406),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_hlsl_attribute] = STATE(1508),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2587),
    [sym_identifier] = ACTIONS(3995),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3997),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(3999),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(4021),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(4023),
    [anon_sym_using] = ACTIONS(4025),
    [anon_sym_concept] = ACTIONS(261),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1137] = {
    [sym_attribute_declaration] = STATE(1102),
    [sym_compound_statement] = STATE(612),
    [sym_attributed_statement] = STATE(612),
    [sym_statement] = STATE(598),
    [sym_labeled_statement] = STATE(612),
    [sym_expression_statement] = STATE(612),
    [sym_if_statement] = STATE(612),
    [sym_switch_statement] = STATE(612),
    [sym_case_statement] = STATE(612),
    [sym_while_statement] = STATE(612),
    [sym_do_statement] = STATE(612),
    [sym_for_statement] = STATE(612),
    [sym_return_statement] = STATE(612),
    [sym_break_statement] = STATE(612),
    [sym_continue_statement] = STATE(612),
    [sym_goto_statement] = STATE(612),
    [sym_seh_try_statement] = STATE(612),
    [sym_seh_leave_statement] = STATE(612),
    [sym_expression] = STATE(5434),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10523),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(612),
    [sym_co_return_statement] = STATE(612),
    [sym_co_yield_statement] = STATE(612),
    [sym_throw_statement] = STATE(612),
    [sym_try_statement] = STATE(612),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(612),
    [sym_cbuffer_specifier] = STATE(612),
    [sym_hlsl_attribute] = STATE(10015),
    [aux_sym_attributed_declarator_repeat1] = STATE(1102),
    [sym_identifier] = ACTIONS(4197),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1793),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(81),
    [anon_sym_default] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(1795),
    [anon_sym___leave] = ACTIONS(1797),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1799),
    [anon_sym_cbuffer] = ACTIONS(1801),
  },
  [1138] = {
    [sym_attribute_declaration] = STATE(1119),
    [sym_compound_statement] = STATE(774),
    [sym_attributed_statement] = STATE(774),
    [sym_statement] = STATE(9014),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(9921),
    [aux_sym_attributed_declarator_repeat1] = STATE(1119),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(4203),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(4205),
    [anon_sym_default] = ACTIONS(4207),
    [anon_sym_while] = ACTIONS(4209),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(4211),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(4213),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_cbuffer] = ACTIONS(4215),
  },
  [1139] = {
    [sym_attribute_declaration] = STATE(1193),
    [sym_compound_statement] = STATE(1292),
    [sym_attributed_statement] = STATE(1292),
    [sym_statement] = STATE(1273),
    [sym_labeled_statement] = STATE(1292),
    [sym_expression_statement] = STATE(1292),
    [sym_if_statement] = STATE(1292),
    [sym_switch_statement] = STATE(1292),
    [sym_case_statement] = STATE(1292),
    [sym_while_statement] = STATE(1292),
    [sym_do_statement] = STATE(1292),
    [sym_for_statement] = STATE(1292),
    [sym_return_statement] = STATE(1292),
    [sym_break_statement] = STATE(1292),
    [sym_continue_statement] = STATE(1292),
    [sym_goto_statement] = STATE(1292),
    [sym_seh_try_statement] = STATE(1292),
    [sym_seh_leave_statement] = STATE(1292),
    [sym_expression] = STATE(5437),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10787),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(1292),
    [sym_co_return_statement] = STATE(1292),
    [sym_co_yield_statement] = STATE(1292),
    [sym_throw_statement] = STATE(1292),
    [sym_try_statement] = STATE(1292),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(1292),
    [sym_cbuffer_specifier] = STATE(1292),
    [sym_hlsl_attribute] = STATE(9865),
    [aux_sym_attributed_declarator_repeat1] = STATE(1193),
    [sym_identifier] = ACTIONS(4283),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(2015),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_case] = ACTIONS(4205),
    [anon_sym_default] = ACTIONS(4207),
    [anon_sym_while] = ACTIONS(2019),
    [anon_sym_do] = ACTIONS(2021),
    [anon_sym_for] = ACTIONS(2023),
    [anon_sym_return] = ACTIONS(2025),
    [anon_sym_break] = ACTIONS(2027),
    [anon_sym_continue] = ACTIONS(2029),
    [anon_sym_goto] = ACTIONS(2031),
    [anon_sym___try] = ACTIONS(2033),
    [anon_sym___leave] = ACTIONS(2035),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(2037),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(2039),
    [anon_sym_co_return] = ACTIONS(2041),
    [anon_sym_co_yield] = ACTIONS(2043),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(2045),
    [anon_sym_cbuffer] = ACTIONS(2047),
  },
  [1140] = {
    [sym_attribute_declaration] = STATE(1102),
    [sym_compound_statement] = STATE(612),
    [sym_attributed_statement] = STATE(612),
    [sym_statement] = STATE(545),
    [sym_labeled_statement] = STATE(612),
    [sym_expression_statement] = STATE(612),
    [sym_if_statement] = STATE(612),
    [sym_switch_statement] = STATE(612),
    [sym_case_statement] = STATE(612),
    [sym_while_statement] = STATE(612),
    [sym_do_statement] = STATE(612),
    [sym_for_statement] = STATE(612),
    [sym_return_statement] = STATE(612),
    [sym_break_statement] = STATE(612),
    [sym_continue_statement] = STATE(612),
    [sym_goto_statement] = STATE(612),
    [sym_seh_try_statement] = STATE(612),
    [sym_seh_leave_statement] = STATE(612),
    [sym_expression] = STATE(5434),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10523),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(612),
    [sym_co_return_statement] = STATE(612),
    [sym_co_yield_statement] = STATE(612),
    [sym_throw_statement] = STATE(612),
    [sym_try_statement] = STATE(612),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(612),
    [sym_cbuffer_specifier] = STATE(612),
    [sym_hlsl_attribute] = STATE(10015),
    [aux_sym_attributed_declarator_repeat1] = STATE(1102),
    [sym_identifier] = ACTIONS(4197),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1793),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(81),
    [anon_sym_default] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(1795),
    [anon_sym___leave] = ACTIONS(1797),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1799),
    [anon_sym_cbuffer] = ACTIONS(1801),
  },
  [1141] = {
    [sym_attribute_declaration] = STATE(1102),
    [sym_compound_statement] = STATE(612),
    [sym_attributed_statement] = STATE(612),
    [sym_statement] = STATE(589),
    [sym_labeled_statement] = STATE(612),
    [sym_expression_statement] = STATE(612),
    [sym_if_statement] = STATE(612),
    [sym_switch_statement] = STATE(612),
    [sym_case_statement] = STATE(612),
    [sym_while_statement] = STATE(612),
    [sym_do_statement] = STATE(612),
    [sym_for_statement] = STATE(612),
    [sym_return_statement] = STATE(612),
    [sym_break_statement] = STATE(612),
    [sym_continue_statement] = STATE(612),
    [sym_goto_statement] = STATE(612),
    [sym_seh_try_statement] = STATE(612),
    [sym_seh_leave_statement] = STATE(612),
    [sym_expression] = STATE(5434),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10523),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(612),
    [sym_co_return_statement] = STATE(612),
    [sym_co_yield_statement] = STATE(612),
    [sym_throw_statement] = STATE(612),
    [sym_try_statement] = STATE(612),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(612),
    [sym_cbuffer_specifier] = STATE(612),
    [sym_hlsl_attribute] = STATE(10015),
    [aux_sym_attributed_declarator_repeat1] = STATE(1102),
    [sym_identifier] = ACTIONS(4197),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1793),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(81),
    [anon_sym_default] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(1795),
    [anon_sym___leave] = ACTIONS(1797),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1799),
    [anon_sym_cbuffer] = ACTIONS(1801),
  },
  [1142] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(3521),
    [sym__string] = STATE(4324),
    [sym_comma_expression] = STATE(10578),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_type_descriptor] = STATE(10245),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9813),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym__unary_left_fold] = STATE(10439),
    [sym__unary_right_fold] = STATE(10553),
    [sym__binary_fold] = STATE(10552),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6796),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym__assignment_expression_lhs] = STATE(10550),
    [sym_user_defined_literal] = STATE(4292),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1143] = {
    [sym_attribute_declaration] = STATE(1143),
    [sym_compound_statement] = STATE(774),
    [sym_attributed_statement] = STATE(774),
    [sym_statement] = STATE(597),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(9921),
    [aux_sym_attributed_declarator_repeat1] = STATE(1143),
    [sym_identifier] = ACTIONS(4285),
    [anon_sym_LPAREN2] = ACTIONS(4054),
    [anon_sym_BANG] = ACTIONS(4057),
    [anon_sym_TILDE] = ACTIONS(4057),
    [anon_sym_DASH] = ACTIONS(4060),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_STAR] = ACTIONS(4063),
    [anon_sym_AMP] = ACTIONS(4063),
    [anon_sym_SEMI] = ACTIONS(4220),
    [anon_sym_COLON_COLON] = ACTIONS(4069),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [sym_primitive_type] = ACTIONS(4081),
    [anon_sym_if] = ACTIONS(4291),
    [anon_sym_switch] = ACTIONS(4294),
    [anon_sym_case] = ACTIONS(4297),
    [anon_sym_default] = ACTIONS(4300),
    [anon_sym_while] = ACTIONS(4303),
    [anon_sym_do] = ACTIONS(4306),
    [anon_sym_for] = ACTIONS(4309),
    [anon_sym_return] = ACTIONS(4312),
    [anon_sym_break] = ACTIONS(4315),
    [anon_sym_continue] = ACTIONS(4318),
    [anon_sym_goto] = ACTIONS(4321),
    [anon_sym___try] = ACTIONS(4324),
    [anon_sym___leave] = ACTIONS(4262),
    [anon_sym_not] = ACTIONS(4060),
    [anon_sym_compl] = ACTIONS(4060),
    [anon_sym_DASH_DASH] = ACTIONS(4123),
    [anon_sym_PLUS_PLUS] = ACTIONS(4123),
    [anon_sym_sizeof] = ACTIONS(4126),
    [anon_sym___alignof__] = ACTIONS(4129),
    [anon_sym___alignof] = ACTIONS(4129),
    [anon_sym__alignof] = ACTIONS(4129),
    [anon_sym_alignof] = ACTIONS(4129),
    [anon_sym__Alignof] = ACTIONS(4129),
    [anon_sym_offsetof] = ACTIONS(4132),
    [anon_sym__Generic] = ACTIONS(4135),
    [anon_sym_asm] = ACTIONS(4138),
    [anon_sym___asm__] = ACTIONS(4138),
    [sym_number_literal] = ACTIONS(4141),
    [anon_sym_L_SQUOTE] = ACTIONS(4144),
    [anon_sym_u_SQUOTE] = ACTIONS(4144),
    [anon_sym_U_SQUOTE] = ACTIONS(4144),
    [anon_sym_u8_SQUOTE] = ACTIONS(4144),
    [anon_sym_SQUOTE] = ACTIONS(4144),
    [anon_sym_L_DQUOTE] = ACTIONS(4147),
    [anon_sym_u_DQUOTE] = ACTIONS(4147),
    [anon_sym_U_DQUOTE] = ACTIONS(4147),
    [anon_sym_u8_DQUOTE] = ACTIONS(4147),
    [anon_sym_DQUOTE] = ACTIONS(4147),
    [sym_true] = ACTIONS(4150),
    [sym_false] = ACTIONS(4150),
    [anon_sym_NULL] = ACTIONS(4153),
    [anon_sym_nullptr] = ACTIONS(4153),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4156),
    [anon_sym_template] = ACTIONS(4159),
    [anon_sym_try] = ACTIONS(4327),
    [anon_sym_delete] = ACTIONS(4165),
    [anon_sym_throw] = ACTIONS(4330),
    [anon_sym_co_return] = ACTIONS(4333),
    [anon_sym_co_yield] = ACTIONS(4336),
    [anon_sym_R_DQUOTE] = ACTIONS(4177),
    [anon_sym_LR_DQUOTE] = ACTIONS(4177),
    [anon_sym_uR_DQUOTE] = ACTIONS(4177),
    [anon_sym_UR_DQUOTE] = ACTIONS(4177),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4177),
    [anon_sym_co_await] = ACTIONS(4180),
    [anon_sym_new] = ACTIONS(4183),
    [anon_sym_requires] = ACTIONS(4186),
    [sym_this] = ACTIONS(4150),
    [anon_sym_discard] = ACTIONS(4277),
    [anon_sym_cbuffer] = ACTIONS(4339),
  },
  [1144] = {
    [sym_attribute_declaration] = STATE(1193),
    [sym_compound_statement] = STATE(1292),
    [sym_attributed_statement] = STATE(1292),
    [sym_statement] = STATE(1286),
    [sym_labeled_statement] = STATE(1292),
    [sym_expression_statement] = STATE(1292),
    [sym_if_statement] = STATE(1292),
    [sym_switch_statement] = STATE(1292),
    [sym_case_statement] = STATE(1292),
    [sym_while_statement] = STATE(1292),
    [sym_do_statement] = STATE(1292),
    [sym_for_statement] = STATE(1292),
    [sym_return_statement] = STATE(1292),
    [sym_break_statement] = STATE(1292),
    [sym_continue_statement] = STATE(1292),
    [sym_goto_statement] = STATE(1292),
    [sym_seh_try_statement] = STATE(1292),
    [sym_seh_leave_statement] = STATE(1292),
    [sym_expression] = STATE(5437),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10787),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(1292),
    [sym_co_return_statement] = STATE(1292),
    [sym_co_yield_statement] = STATE(1292),
    [sym_throw_statement] = STATE(1292),
    [sym_try_statement] = STATE(1292),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(1292),
    [sym_cbuffer_specifier] = STATE(1292),
    [sym_hlsl_attribute] = STATE(9865),
    [aux_sym_attributed_declarator_repeat1] = STATE(1193),
    [sym_identifier] = ACTIONS(4283),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(2015),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_case] = ACTIONS(4205),
    [anon_sym_default] = ACTIONS(4207),
    [anon_sym_while] = ACTIONS(2019),
    [anon_sym_do] = ACTIONS(2021),
    [anon_sym_for] = ACTIONS(2023),
    [anon_sym_return] = ACTIONS(2025),
    [anon_sym_break] = ACTIONS(2027),
    [anon_sym_continue] = ACTIONS(2029),
    [anon_sym_goto] = ACTIONS(2031),
    [anon_sym___try] = ACTIONS(2033),
    [anon_sym___leave] = ACTIONS(2035),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(2037),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(2039),
    [anon_sym_co_return] = ACTIONS(2041),
    [anon_sym_co_yield] = ACTIONS(2043),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(2045),
    [anon_sym_cbuffer] = ACTIONS(2047),
  },
  [1145] = {
    [sym_attribute_declaration] = STATE(1119),
    [sym_compound_statement] = STATE(774),
    [sym_attributed_statement] = STATE(774),
    [sym_statement] = STATE(598),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(9921),
    [aux_sym_attributed_declarator_repeat1] = STATE(1119),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(4203),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(4205),
    [anon_sym_default] = ACTIONS(4207),
    [anon_sym_while] = ACTIONS(4209),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(4211),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(4213),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_cbuffer] = ACTIONS(4215),
  },
  [1146] = {
    [sym_attribute_declaration] = STATE(1117),
    [sym_compound_statement] = STATE(774),
    [sym_attributed_statement] = STATE(774),
    [sym_statement] = STATE(770),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(9709),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [sym_identifier] = ACTIONS(4039),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_cbuffer] = ACTIONS(269),
  },
  [1147] = {
    [sym_attribute_declaration] = STATE(1147),
    [sym_compound_statement] = STATE(406),
    [sym_attributed_statement] = STATE(406),
    [sym_statement] = STATE(433),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(9743),
    [aux_sym_attributed_declarator_repeat1] = STATE(1147),
    [sym_identifier] = ACTIONS(4342),
    [anon_sym_LPAREN2] = ACTIONS(4054),
    [anon_sym_BANG] = ACTIONS(4057),
    [anon_sym_TILDE] = ACTIONS(4057),
    [anon_sym_DASH] = ACTIONS(4060),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_STAR] = ACTIONS(4063),
    [anon_sym_AMP] = ACTIONS(4063),
    [anon_sym_SEMI] = ACTIONS(4345),
    [anon_sym_COLON_COLON] = ACTIONS(4069),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [sym_primitive_type] = ACTIONS(4081),
    [anon_sym_if] = ACTIONS(4351),
    [anon_sym_switch] = ACTIONS(4354),
    [anon_sym_case] = ACTIONS(4357),
    [anon_sym_default] = ACTIONS(4360),
    [anon_sym_while] = ACTIONS(4363),
    [anon_sym_do] = ACTIONS(4366),
    [anon_sym_for] = ACTIONS(4369),
    [anon_sym_return] = ACTIONS(4372),
    [anon_sym_break] = ACTIONS(4375),
    [anon_sym_continue] = ACTIONS(4378),
    [anon_sym_goto] = ACTIONS(4381),
    [anon_sym___try] = ACTIONS(4384),
    [anon_sym___leave] = ACTIONS(4387),
    [anon_sym_not] = ACTIONS(4060),
    [anon_sym_compl] = ACTIONS(4060),
    [anon_sym_DASH_DASH] = ACTIONS(4123),
    [anon_sym_PLUS_PLUS] = ACTIONS(4123),
    [anon_sym_sizeof] = ACTIONS(4126),
    [anon_sym___alignof__] = ACTIONS(4129),
    [anon_sym___alignof] = ACTIONS(4129),
    [anon_sym__alignof] = ACTIONS(4129),
    [anon_sym_alignof] = ACTIONS(4129),
    [anon_sym__Alignof] = ACTIONS(4129),
    [anon_sym_offsetof] = ACTIONS(4132),
    [anon_sym__Generic] = ACTIONS(4135),
    [anon_sym_asm] = ACTIONS(4138),
    [anon_sym___asm__] = ACTIONS(4138),
    [sym_number_literal] = ACTIONS(4141),
    [anon_sym_L_SQUOTE] = ACTIONS(4144),
    [anon_sym_u_SQUOTE] = ACTIONS(4144),
    [anon_sym_U_SQUOTE] = ACTIONS(4144),
    [anon_sym_u8_SQUOTE] = ACTIONS(4144),
    [anon_sym_SQUOTE] = ACTIONS(4144),
    [anon_sym_L_DQUOTE] = ACTIONS(4147),
    [anon_sym_u_DQUOTE] = ACTIONS(4147),
    [anon_sym_U_DQUOTE] = ACTIONS(4147),
    [anon_sym_u8_DQUOTE] = ACTIONS(4147),
    [anon_sym_DQUOTE] = ACTIONS(4147),
    [sym_true] = ACTIONS(4150),
    [sym_false] = ACTIONS(4150),
    [anon_sym_NULL] = ACTIONS(4153),
    [anon_sym_nullptr] = ACTIONS(4153),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4156),
    [anon_sym_template] = ACTIONS(4159),
    [anon_sym_try] = ACTIONS(4390),
    [anon_sym_delete] = ACTIONS(4165),
    [anon_sym_throw] = ACTIONS(4393),
    [anon_sym_co_return] = ACTIONS(4396),
    [anon_sym_co_yield] = ACTIONS(4399),
    [anon_sym_R_DQUOTE] = ACTIONS(4177),
    [anon_sym_LR_DQUOTE] = ACTIONS(4177),
    [anon_sym_uR_DQUOTE] = ACTIONS(4177),
    [anon_sym_UR_DQUOTE] = ACTIONS(4177),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4177),
    [anon_sym_co_await] = ACTIONS(4180),
    [anon_sym_new] = ACTIONS(4183),
    [anon_sym_requires] = ACTIONS(4186),
    [sym_this] = ACTIONS(4150),
    [anon_sym_discard] = ACTIONS(4402),
    [anon_sym_cbuffer] = ACTIONS(4405),
  },
  [1148] = {
    [sym_attribute_declaration] = STATE(1096),
    [sym_compound_statement] = STATE(787),
    [sym_attributed_statement] = STATE(787),
    [sym_statement] = STATE(771),
    [sym_labeled_statement] = STATE(787),
    [sym_expression_statement] = STATE(787),
    [sym_if_statement] = STATE(787),
    [sym_switch_statement] = STATE(787),
    [sym_case_statement] = STATE(787),
    [sym_while_statement] = STATE(787),
    [sym_do_statement] = STATE(787),
    [sym_for_statement] = STATE(787),
    [sym_return_statement] = STATE(787),
    [sym_break_statement] = STATE(787),
    [sym_continue_statement] = STATE(787),
    [sym_goto_statement] = STATE(787),
    [sym_seh_try_statement] = STATE(787),
    [sym_seh_leave_statement] = STATE(787),
    [sym_expression] = STATE(5465),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10896),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(787),
    [sym_co_return_statement] = STATE(787),
    [sym_co_yield_statement] = STATE(787),
    [sym_throw_statement] = STATE(787),
    [sym_try_statement] = STATE(787),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(787),
    [sym_cbuffer_specifier] = STATE(787),
    [sym_hlsl_attribute] = STATE(9939),
    [aux_sym_attributed_declarator_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(4199),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1211),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(1219),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_switch] = ACTIONS(1225),
    [anon_sym_case] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1229),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_do] = ACTIONS(1233),
    [anon_sym_for] = ACTIONS(1235),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1239),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_goto] = ACTIONS(1243),
    [anon_sym___try] = ACTIONS(1245),
    [anon_sym___leave] = ACTIONS(1247),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(1251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(1253),
    [anon_sym_co_return] = ACTIONS(1263),
    [anon_sym_co_yield] = ACTIONS(1265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1267),
    [anon_sym_cbuffer] = ACTIONS(1269),
  },
  [1149] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(3543),
    [sym__string] = STATE(4324),
    [sym_comma_expression] = STATE(10299),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_type_descriptor] = STATE(10748),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9813),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym__unary_left_fold] = STATE(10569),
    [sym__unary_right_fold] = STATE(10571),
    [sym__binary_fold] = STATE(10572),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6796),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym__assignment_expression_lhs] = STATE(10304),
    [sym_user_defined_literal] = STATE(4292),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1150] = {
    [sym_attribute_declaration] = STATE(1102),
    [sym_compound_statement] = STATE(612),
    [sym_attributed_statement] = STATE(612),
    [sym_statement] = STATE(570),
    [sym_labeled_statement] = STATE(612),
    [sym_expression_statement] = STATE(612),
    [sym_if_statement] = STATE(612),
    [sym_switch_statement] = STATE(612),
    [sym_case_statement] = STATE(612),
    [sym_while_statement] = STATE(612),
    [sym_do_statement] = STATE(612),
    [sym_for_statement] = STATE(612),
    [sym_return_statement] = STATE(612),
    [sym_break_statement] = STATE(612),
    [sym_continue_statement] = STATE(612),
    [sym_goto_statement] = STATE(612),
    [sym_seh_try_statement] = STATE(612),
    [sym_seh_leave_statement] = STATE(612),
    [sym_expression] = STATE(5434),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10523),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(612),
    [sym_co_return_statement] = STATE(612),
    [sym_co_yield_statement] = STATE(612),
    [sym_throw_statement] = STATE(612),
    [sym_try_statement] = STATE(612),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(612),
    [sym_cbuffer_specifier] = STATE(612),
    [sym_hlsl_attribute] = STATE(10015),
    [aux_sym_attributed_declarator_repeat1] = STATE(1102),
    [sym_identifier] = ACTIONS(4197),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1793),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(81),
    [anon_sym_default] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(1795),
    [anon_sym___leave] = ACTIONS(1797),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1799),
    [anon_sym_cbuffer] = ACTIONS(1801),
  },
  [1151] = {
    [sym_attribute_declaration] = STATE(1119),
    [sym_compound_statement] = STATE(774),
    [sym_attributed_statement] = STATE(774),
    [sym_statement] = STATE(608),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(9921),
    [aux_sym_attributed_declarator_repeat1] = STATE(1119),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(4203),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(4205),
    [anon_sym_default] = ACTIONS(4207),
    [anon_sym_while] = ACTIONS(4209),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(4211),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(4213),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_cbuffer] = ACTIONS(4215),
  },
  [1152] = {
    [sym_attribute_declaration] = STATE(1117),
    [sym_compound_statement] = STATE(774),
    [sym_attributed_statement] = STATE(774),
    [sym_statement] = STATE(782),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(9709),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [sym_identifier] = ACTIONS(4039),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_cbuffer] = ACTIONS(269),
  },
  [1153] = {
    [sym_attribute_declaration] = STATE(1119),
    [sym_compound_statement] = STATE(774),
    [sym_attributed_statement] = STATE(774),
    [sym_statement] = STATE(9603),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(9921),
    [aux_sym_attributed_declarator_repeat1] = STATE(1119),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(4203),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(4205),
    [anon_sym_default] = ACTIONS(4207),
    [anon_sym_while] = ACTIONS(4209),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(4211),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(4213),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_cbuffer] = ACTIONS(4215),
  },
  [1154] = {
    [sym_attribute_declaration] = STATE(1148),
    [sym_compound_statement] = STATE(787),
    [sym_attributed_statement] = STATE(787),
    [sym_statement] = STATE(619),
    [sym_labeled_statement] = STATE(787),
    [sym_expression_statement] = STATE(787),
    [sym_if_statement] = STATE(787),
    [sym_switch_statement] = STATE(787),
    [sym_case_statement] = STATE(787),
    [sym_while_statement] = STATE(787),
    [sym_do_statement] = STATE(787),
    [sym_for_statement] = STATE(787),
    [sym_return_statement] = STATE(787),
    [sym_break_statement] = STATE(787),
    [sym_continue_statement] = STATE(787),
    [sym_goto_statement] = STATE(787),
    [sym_seh_try_statement] = STATE(787),
    [sym_seh_leave_statement] = STATE(787),
    [sym_expression] = STATE(5465),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10896),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(787),
    [sym_co_return_statement] = STATE(787),
    [sym_co_yield_statement] = STATE(787),
    [sym_throw_statement] = STATE(787),
    [sym_try_statement] = STATE(787),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(787),
    [sym_cbuffer_specifier] = STATE(787),
    [sym_hlsl_attribute] = STATE(9939),
    [aux_sym_attributed_declarator_repeat1] = STATE(1148),
    [sym_identifier] = ACTIONS(4199),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1211),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(1219),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_switch] = ACTIONS(1225),
    [anon_sym_case] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1229),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_do] = ACTIONS(1233),
    [anon_sym_for] = ACTIONS(1235),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1239),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_goto] = ACTIONS(1243),
    [anon_sym___try] = ACTIONS(1245),
    [anon_sym___leave] = ACTIONS(1247),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(1251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(1253),
    [anon_sym_co_return] = ACTIONS(1263),
    [anon_sym_co_yield] = ACTIONS(1265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1267),
    [anon_sym_cbuffer] = ACTIONS(1269),
  },
  [1155] = {
    [sym_attribute_declaration] = STATE(1117),
    [sym_compound_statement] = STATE(774),
    [sym_attributed_statement] = STATE(774),
    [sym_statement] = STATE(615),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(9709),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [sym_identifier] = ACTIONS(4039),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_cbuffer] = ACTIONS(269),
  },
  [1156] = {
    [sym_attribute_declaration] = STATE(1148),
    [sym_compound_statement] = STATE(787),
    [sym_attributed_statement] = STATE(787),
    [sym_statement] = STATE(645),
    [sym_labeled_statement] = STATE(787),
    [sym_expression_statement] = STATE(787),
    [sym_if_statement] = STATE(787),
    [sym_switch_statement] = STATE(787),
    [sym_case_statement] = STATE(787),
    [sym_while_statement] = STATE(787),
    [sym_do_statement] = STATE(787),
    [sym_for_statement] = STATE(787),
    [sym_return_statement] = STATE(787),
    [sym_break_statement] = STATE(787),
    [sym_continue_statement] = STATE(787),
    [sym_goto_statement] = STATE(787),
    [sym_seh_try_statement] = STATE(787),
    [sym_seh_leave_statement] = STATE(787),
    [sym_expression] = STATE(5465),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10896),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(787),
    [sym_co_return_statement] = STATE(787),
    [sym_co_yield_statement] = STATE(787),
    [sym_throw_statement] = STATE(787),
    [sym_try_statement] = STATE(787),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(787),
    [sym_cbuffer_specifier] = STATE(787),
    [sym_hlsl_attribute] = STATE(9939),
    [aux_sym_attributed_declarator_repeat1] = STATE(1148),
    [sym_identifier] = ACTIONS(4199),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1211),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(1219),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_switch] = ACTIONS(1225),
    [anon_sym_case] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1229),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_do] = ACTIONS(1233),
    [anon_sym_for] = ACTIONS(1235),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1239),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_goto] = ACTIONS(1243),
    [anon_sym___try] = ACTIONS(1245),
    [anon_sym___leave] = ACTIONS(1247),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(1251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(1253),
    [anon_sym_co_return] = ACTIONS(1263),
    [anon_sym_co_yield] = ACTIONS(1265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1267),
    [anon_sym_cbuffer] = ACTIONS(1269),
  },
  [1157] = {
    [sym_attribute_declaration] = STATE(1193),
    [sym_compound_statement] = STATE(1292),
    [sym_attributed_statement] = STATE(1292),
    [sym_statement] = STATE(1291),
    [sym_labeled_statement] = STATE(1292),
    [sym_expression_statement] = STATE(1292),
    [sym_if_statement] = STATE(1292),
    [sym_switch_statement] = STATE(1292),
    [sym_case_statement] = STATE(1292),
    [sym_while_statement] = STATE(1292),
    [sym_do_statement] = STATE(1292),
    [sym_for_statement] = STATE(1292),
    [sym_return_statement] = STATE(1292),
    [sym_break_statement] = STATE(1292),
    [sym_continue_statement] = STATE(1292),
    [sym_goto_statement] = STATE(1292),
    [sym_seh_try_statement] = STATE(1292),
    [sym_seh_leave_statement] = STATE(1292),
    [sym_expression] = STATE(5437),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10787),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(1292),
    [sym_co_return_statement] = STATE(1292),
    [sym_co_yield_statement] = STATE(1292),
    [sym_throw_statement] = STATE(1292),
    [sym_try_statement] = STATE(1292),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(1292),
    [sym_cbuffer_specifier] = STATE(1292),
    [sym_hlsl_attribute] = STATE(9865),
    [aux_sym_attributed_declarator_repeat1] = STATE(1193),
    [sym_identifier] = ACTIONS(4283),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(2015),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_case] = ACTIONS(4205),
    [anon_sym_default] = ACTIONS(4207),
    [anon_sym_while] = ACTIONS(2019),
    [anon_sym_do] = ACTIONS(2021),
    [anon_sym_for] = ACTIONS(2023),
    [anon_sym_return] = ACTIONS(2025),
    [anon_sym_break] = ACTIONS(2027),
    [anon_sym_continue] = ACTIONS(2029),
    [anon_sym_goto] = ACTIONS(2031),
    [anon_sym___try] = ACTIONS(2033),
    [anon_sym___leave] = ACTIONS(2035),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(2037),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(2039),
    [anon_sym_co_return] = ACTIONS(2041),
    [anon_sym_co_yield] = ACTIONS(2043),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(2045),
    [anon_sym_cbuffer] = ACTIONS(2047),
  },
  [1158] = {
    [sym_function_definition] = STATE(473),
    [sym_declaration] = STATE(473),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5695),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1831),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7458),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2673),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__empty_declaration] = STATE(473),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2585),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(473),
    [sym_operator_cast] = STATE(8424),
    [sym__constructor_specifiers] = STATE(2585),
    [sym_operator_cast_definition] = STATE(473),
    [sym_operator_cast_declaration] = STATE(473),
    [sym_constructor_or_destructor_definition] = STATE(473),
    [sym_constructor_or_destructor_declaration] = STATE(473),
    [sym_friend_declaration] = STATE(473),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_alias_declaration] = STATE(473),
    [sym_concept_definition] = STATE(473),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6578),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8424),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_hlsl_attribute] = STATE(1506),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2585),
    [sym_identifier] = ACTIONS(3995),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3997),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(3999),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(4033),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(4035),
    [anon_sym_using] = ACTIONS(4037),
    [anon_sym_concept] = ACTIONS(351),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1159] = {
    [sym_attribute_declaration] = STATE(1148),
    [sym_compound_statement] = STATE(787),
    [sym_attributed_statement] = STATE(787),
    [sym_statement] = STATE(673),
    [sym_labeled_statement] = STATE(787),
    [sym_expression_statement] = STATE(787),
    [sym_if_statement] = STATE(787),
    [sym_switch_statement] = STATE(787),
    [sym_case_statement] = STATE(787),
    [sym_while_statement] = STATE(787),
    [sym_do_statement] = STATE(787),
    [sym_for_statement] = STATE(787),
    [sym_return_statement] = STATE(787),
    [sym_break_statement] = STATE(787),
    [sym_continue_statement] = STATE(787),
    [sym_goto_statement] = STATE(787),
    [sym_seh_try_statement] = STATE(787),
    [sym_seh_leave_statement] = STATE(787),
    [sym_expression] = STATE(5465),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10896),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(787),
    [sym_co_return_statement] = STATE(787),
    [sym_co_yield_statement] = STATE(787),
    [sym_throw_statement] = STATE(787),
    [sym_try_statement] = STATE(787),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(787),
    [sym_cbuffer_specifier] = STATE(787),
    [sym_hlsl_attribute] = STATE(9939),
    [aux_sym_attributed_declarator_repeat1] = STATE(1148),
    [sym_identifier] = ACTIONS(4199),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1211),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(1219),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_switch] = ACTIONS(1225),
    [anon_sym_case] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1229),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_do] = ACTIONS(1233),
    [anon_sym_for] = ACTIONS(1235),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1239),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_goto] = ACTIONS(1243),
    [anon_sym___try] = ACTIONS(1245),
    [anon_sym___leave] = ACTIONS(1247),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(1251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(1253),
    [anon_sym_co_return] = ACTIONS(1263),
    [anon_sym_co_yield] = ACTIONS(1265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1267),
    [anon_sym_cbuffer] = ACTIONS(1269),
  },
  [1160] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(3522),
    [sym__string] = STATE(4324),
    [sym_comma_expression] = STATE(10715),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_type_descriptor] = STATE(10658),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9813),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym__unary_left_fold] = STATE(10708),
    [sym__unary_right_fold] = STATE(10705),
    [sym__binary_fold] = STATE(10700),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6796),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym__assignment_expression_lhs] = STATE(10673),
    [sym_user_defined_literal] = STATE(4292),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1161] = {
    [sym_attribute_declaration] = STATE(1148),
    [sym_compound_statement] = STATE(787),
    [sym_attributed_statement] = STATE(787),
    [sym_statement] = STATE(671),
    [sym_labeled_statement] = STATE(787),
    [sym_expression_statement] = STATE(787),
    [sym_if_statement] = STATE(787),
    [sym_switch_statement] = STATE(787),
    [sym_case_statement] = STATE(787),
    [sym_while_statement] = STATE(787),
    [sym_do_statement] = STATE(787),
    [sym_for_statement] = STATE(787),
    [sym_return_statement] = STATE(787),
    [sym_break_statement] = STATE(787),
    [sym_continue_statement] = STATE(787),
    [sym_goto_statement] = STATE(787),
    [sym_seh_try_statement] = STATE(787),
    [sym_seh_leave_statement] = STATE(787),
    [sym_expression] = STATE(5465),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10896),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(787),
    [sym_co_return_statement] = STATE(787),
    [sym_co_yield_statement] = STATE(787),
    [sym_throw_statement] = STATE(787),
    [sym_try_statement] = STATE(787),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(787),
    [sym_cbuffer_specifier] = STATE(787),
    [sym_hlsl_attribute] = STATE(9939),
    [aux_sym_attributed_declarator_repeat1] = STATE(1148),
    [sym_identifier] = ACTIONS(4199),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1211),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(1219),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_switch] = ACTIONS(1225),
    [anon_sym_case] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1229),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_do] = ACTIONS(1233),
    [anon_sym_for] = ACTIONS(1235),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1239),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_goto] = ACTIONS(1243),
    [anon_sym___try] = ACTIONS(1245),
    [anon_sym___leave] = ACTIONS(1247),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(1251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(1253),
    [anon_sym_co_return] = ACTIONS(1263),
    [anon_sym_co_yield] = ACTIONS(1265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1267),
    [anon_sym_cbuffer] = ACTIONS(1269),
  },
  [1162] = {
    [sym_expression] = STATE(3205),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_initializer_list] = STATE(3277),
    [sym_char_literal] = STATE(3481),
    [sym_concatenated_string] = STATE(3486),
    [sym_string_literal] = STATE(2963),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2960),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4410),
    [anon_sym_COMMA] = ACTIONS(4410),
    [aux_sym_preproc_if_token2] = ACTIONS(4410),
    [aux_sym_preproc_else_token1] = ACTIONS(4410),
    [aux_sym_preproc_elif_token1] = ACTIONS(4408),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4410),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4410),
    [anon_sym_LPAREN2] = ACTIONS(4410),
    [anon_sym_BANG] = ACTIONS(4412),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4408),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_STAR] = ACTIONS(4408),
    [anon_sym_SLASH] = ACTIONS(4408),
    [anon_sym_PERCENT] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4408),
    [anon_sym_GT_EQ] = ACTIONS(4410),
    [anon_sym_LT_EQ] = ACTIONS(4408),
    [anon_sym_LT] = ACTIONS(4408),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_COLON_COLON] = ACTIONS(4416),
    [anon_sym_LBRACE] = ACTIONS(4418),
    [anon_sym_LBRACK] = ACTIONS(4410),
    [anon_sym_EQ] = ACTIONS(4408),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_QMARK] = ACTIONS(4410),
    [anon_sym_STAR_EQ] = ACTIONS(4410),
    [anon_sym_SLASH_EQ] = ACTIONS(4410),
    [anon_sym_PERCENT_EQ] = ACTIONS(4410),
    [anon_sym_PLUS_EQ] = ACTIONS(4410),
    [anon_sym_DASH_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_GT_EQ] = ACTIONS(4410),
    [anon_sym_AMP_EQ] = ACTIONS(4410),
    [anon_sym_CARET_EQ] = ACTIONS(4410),
    [anon_sym_PIPE_EQ] = ACTIONS(4410),
    [anon_sym_and_eq] = ACTIONS(4408),
    [anon_sym_or_eq] = ACTIONS(4408),
    [anon_sym_xor_eq] = ACTIONS(4408),
    [anon_sym_not] = ACTIONS(4412),
    [anon_sym_compl] = ACTIONS(4412),
    [anon_sym_LT_EQ_GT] = ACTIONS(4410),
    [anon_sym_or] = ACTIONS(4408),
    [anon_sym_and] = ACTIONS(4408),
    [anon_sym_bitor] = ACTIONS(4408),
    [anon_sym_xor] = ACTIONS(4408),
    [anon_sym_bitand] = ACTIONS(4408),
    [anon_sym_not_eq] = ACTIONS(4408),
    [anon_sym_is] = ACTIONS(4408),
    [anon_sym_as] = ACTIONS(4408),
    [anon_sym_DASH_DASH] = ACTIONS(4410),
    [anon_sym_PLUS_PLUS] = ACTIONS(4410),
    [anon_sym_sizeof] = ACTIONS(4422),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [anon_sym_DOT] = ACTIONS(4408),
    [anon_sym_DOT_STAR] = ACTIONS(4410),
    [anon_sym_DASH_GT] = ACTIONS(4410),
    [sym_number_literal] = ACTIONS(4432),
    [anon_sym_L_SQUOTE] = ACTIONS(4434),
    [anon_sym_u_SQUOTE] = ACTIONS(4434),
    [anon_sym_U_SQUOTE] = ACTIONS(4434),
    [anon_sym_u8_SQUOTE] = ACTIONS(4434),
    [anon_sym_SQUOTE] = ACTIONS(4434),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4442),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [anon_sym_co_await] = ACTIONS(4446),
    [anon_sym_new] = ACTIONS(4448),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1163] = {
    [sym_attribute_declaration] = STATE(1120),
    [sym_compound_statement] = STATE(406),
    [sym_attributed_statement] = STATE(406),
    [sym_statement] = STATE(356),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(9743),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [sym_identifier] = ACTIONS(4195),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_cbuffer] = ACTIONS(359),
  },
  [1164] = {
    [sym_attribute_declaration] = STATE(1120),
    [sym_compound_statement] = STATE(406),
    [sym_attributed_statement] = STATE(406),
    [sym_statement] = STATE(310),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(9743),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [sym_identifier] = ACTIONS(4195),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_cbuffer] = ACTIONS(359),
  },
  [1165] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(3522),
    [sym__string] = STATE(4324),
    [sym_comma_expression] = STATE(10715),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_type_descriptor] = STATE(10507),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9813),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym__unary_left_fold] = STATE(10708),
    [sym__unary_right_fold] = STATE(10705),
    [sym__binary_fold] = STATE(10700),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6796),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym__assignment_expression_lhs] = STATE(10673),
    [sym_user_defined_literal] = STATE(4292),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1166] = {
    [sym_attribute_declaration] = STATE(1166),
    [sym_compound_statement] = STATE(1292),
    [sym_attributed_statement] = STATE(1292),
    [sym_statement] = STATE(1297),
    [sym_labeled_statement] = STATE(1292),
    [sym_expression_statement] = STATE(1292),
    [sym_if_statement] = STATE(1292),
    [sym_switch_statement] = STATE(1292),
    [sym_case_statement] = STATE(1292),
    [sym_while_statement] = STATE(1292),
    [sym_do_statement] = STATE(1292),
    [sym_for_statement] = STATE(1292),
    [sym_return_statement] = STATE(1292),
    [sym_break_statement] = STATE(1292),
    [sym_continue_statement] = STATE(1292),
    [sym_goto_statement] = STATE(1292),
    [sym_seh_try_statement] = STATE(1292),
    [sym_seh_leave_statement] = STATE(1292),
    [sym_expression] = STATE(5437),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10787),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(1292),
    [sym_co_return_statement] = STATE(1292),
    [sym_co_yield_statement] = STATE(1292),
    [sym_throw_statement] = STATE(1292),
    [sym_try_statement] = STATE(1292),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(1292),
    [sym_cbuffer_specifier] = STATE(1292),
    [sym_hlsl_attribute] = STATE(9865),
    [aux_sym_attributed_declarator_repeat1] = STATE(1166),
    [sym_identifier] = ACTIONS(4452),
    [anon_sym_LPAREN2] = ACTIONS(4054),
    [anon_sym_BANG] = ACTIONS(4057),
    [anon_sym_TILDE] = ACTIONS(4057),
    [anon_sym_DASH] = ACTIONS(4060),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_STAR] = ACTIONS(4063),
    [anon_sym_AMP] = ACTIONS(4063),
    [anon_sym_SEMI] = ACTIONS(4455),
    [anon_sym_COLON_COLON] = ACTIONS(4069),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4458),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [sym_primitive_type] = ACTIONS(4081),
    [anon_sym_if] = ACTIONS(4461),
    [anon_sym_switch] = ACTIONS(4464),
    [anon_sym_case] = ACTIONS(4297),
    [anon_sym_default] = ACTIONS(4300),
    [anon_sym_while] = ACTIONS(4467),
    [anon_sym_do] = ACTIONS(4470),
    [anon_sym_for] = ACTIONS(4473),
    [anon_sym_return] = ACTIONS(4476),
    [anon_sym_break] = ACTIONS(4479),
    [anon_sym_continue] = ACTIONS(4482),
    [anon_sym_goto] = ACTIONS(4485),
    [anon_sym___try] = ACTIONS(4488),
    [anon_sym___leave] = ACTIONS(4491),
    [anon_sym_not] = ACTIONS(4060),
    [anon_sym_compl] = ACTIONS(4060),
    [anon_sym_DASH_DASH] = ACTIONS(4123),
    [anon_sym_PLUS_PLUS] = ACTIONS(4123),
    [anon_sym_sizeof] = ACTIONS(4126),
    [anon_sym___alignof__] = ACTIONS(4129),
    [anon_sym___alignof] = ACTIONS(4129),
    [anon_sym__alignof] = ACTIONS(4129),
    [anon_sym_alignof] = ACTIONS(4129),
    [anon_sym__Alignof] = ACTIONS(4129),
    [anon_sym_offsetof] = ACTIONS(4132),
    [anon_sym__Generic] = ACTIONS(4135),
    [anon_sym_asm] = ACTIONS(4138),
    [anon_sym___asm__] = ACTIONS(4138),
    [sym_number_literal] = ACTIONS(4141),
    [anon_sym_L_SQUOTE] = ACTIONS(4144),
    [anon_sym_u_SQUOTE] = ACTIONS(4144),
    [anon_sym_U_SQUOTE] = ACTIONS(4144),
    [anon_sym_u8_SQUOTE] = ACTIONS(4144),
    [anon_sym_SQUOTE] = ACTIONS(4144),
    [anon_sym_L_DQUOTE] = ACTIONS(4147),
    [anon_sym_u_DQUOTE] = ACTIONS(4147),
    [anon_sym_U_DQUOTE] = ACTIONS(4147),
    [anon_sym_u8_DQUOTE] = ACTIONS(4147),
    [anon_sym_DQUOTE] = ACTIONS(4147),
    [sym_true] = ACTIONS(4150),
    [sym_false] = ACTIONS(4150),
    [anon_sym_NULL] = ACTIONS(4153),
    [anon_sym_nullptr] = ACTIONS(4153),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4156),
    [anon_sym_template] = ACTIONS(4159),
    [anon_sym_try] = ACTIONS(4494),
    [anon_sym_delete] = ACTIONS(4165),
    [anon_sym_throw] = ACTIONS(4497),
    [anon_sym_co_return] = ACTIONS(4500),
    [anon_sym_co_yield] = ACTIONS(4503),
    [anon_sym_R_DQUOTE] = ACTIONS(4177),
    [anon_sym_LR_DQUOTE] = ACTIONS(4177),
    [anon_sym_uR_DQUOTE] = ACTIONS(4177),
    [anon_sym_UR_DQUOTE] = ACTIONS(4177),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4177),
    [anon_sym_co_await] = ACTIONS(4180),
    [anon_sym_new] = ACTIONS(4183),
    [anon_sym_requires] = ACTIONS(4186),
    [sym_this] = ACTIONS(4150),
    [anon_sym_discard] = ACTIONS(4506),
    [anon_sym_cbuffer] = ACTIONS(4509),
  },
  [1167] = {
    [sym_attribute_declaration] = STATE(1102),
    [sym_compound_statement] = STATE(612),
    [sym_attributed_statement] = STATE(612),
    [sym_statement] = STATE(453),
    [sym_labeled_statement] = STATE(612),
    [sym_expression_statement] = STATE(612),
    [sym_if_statement] = STATE(612),
    [sym_switch_statement] = STATE(612),
    [sym_case_statement] = STATE(612),
    [sym_while_statement] = STATE(612),
    [sym_do_statement] = STATE(612),
    [sym_for_statement] = STATE(612),
    [sym_return_statement] = STATE(612),
    [sym_break_statement] = STATE(612),
    [sym_continue_statement] = STATE(612),
    [sym_goto_statement] = STATE(612),
    [sym_seh_try_statement] = STATE(612),
    [sym_seh_leave_statement] = STATE(612),
    [sym_expression] = STATE(5434),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10523),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(612),
    [sym_co_return_statement] = STATE(612),
    [sym_co_yield_statement] = STATE(612),
    [sym_throw_statement] = STATE(612),
    [sym_try_statement] = STATE(612),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(612),
    [sym_cbuffer_specifier] = STATE(612),
    [sym_hlsl_attribute] = STATE(10015),
    [aux_sym_attributed_declarator_repeat1] = STATE(1102),
    [sym_identifier] = ACTIONS(4197),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1793),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(81),
    [anon_sym_default] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(1795),
    [anon_sym___leave] = ACTIONS(1797),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1799),
    [anon_sym_cbuffer] = ACTIONS(1801),
  },
  [1168] = {
    [sym_function_definition] = STATE(1653),
    [sym_declaration] = STATE(1653),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5707),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1906),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7467),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2674),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__empty_declaration] = STATE(1653),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2591),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(1653),
    [sym_operator_cast] = STATE(8364),
    [sym__constructor_specifiers] = STATE(2591),
    [sym_operator_cast_definition] = STATE(1653),
    [sym_operator_cast_declaration] = STATE(1653),
    [sym_constructor_or_destructor_definition] = STATE(1653),
    [sym_constructor_or_destructor_declaration] = STATE(1653),
    [sym_friend_declaration] = STATE(1653),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_alias_declaration] = STATE(1653),
    [sym_concept_definition] = STATE(1653),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6578),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8364),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_hlsl_attribute] = STATE(1512),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(3995),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3997),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(3999),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(2421),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2423),
    [anon_sym_using] = ACTIONS(4011),
    [anon_sym_concept] = ACTIONS(4013),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1169] = {
    [sym_attribute_declaration] = STATE(1102),
    [sym_compound_statement] = STATE(612),
    [sym_attributed_statement] = STATE(612),
    [sym_statement] = STATE(608),
    [sym_labeled_statement] = STATE(612),
    [sym_expression_statement] = STATE(612),
    [sym_if_statement] = STATE(612),
    [sym_switch_statement] = STATE(612),
    [sym_case_statement] = STATE(612),
    [sym_while_statement] = STATE(612),
    [sym_do_statement] = STATE(612),
    [sym_for_statement] = STATE(612),
    [sym_return_statement] = STATE(612),
    [sym_break_statement] = STATE(612),
    [sym_continue_statement] = STATE(612),
    [sym_goto_statement] = STATE(612),
    [sym_seh_try_statement] = STATE(612),
    [sym_seh_leave_statement] = STATE(612),
    [sym_expression] = STATE(5434),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10523),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(612),
    [sym_co_return_statement] = STATE(612),
    [sym_co_yield_statement] = STATE(612),
    [sym_throw_statement] = STATE(612),
    [sym_try_statement] = STATE(612),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(612),
    [sym_cbuffer_specifier] = STATE(612),
    [sym_hlsl_attribute] = STATE(10015),
    [aux_sym_attributed_declarator_repeat1] = STATE(1102),
    [sym_identifier] = ACTIONS(4197),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1793),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(81),
    [anon_sym_default] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(1795),
    [anon_sym___leave] = ACTIONS(1797),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1799),
    [anon_sym_cbuffer] = ACTIONS(1801),
  },
  [1170] = {
    [sym_attribute_declaration] = STATE(1193),
    [sym_compound_statement] = STATE(1292),
    [sym_attributed_statement] = STATE(1292),
    [sym_statement] = STATE(1266),
    [sym_labeled_statement] = STATE(1292),
    [sym_expression_statement] = STATE(1292),
    [sym_if_statement] = STATE(1292),
    [sym_switch_statement] = STATE(1292),
    [sym_case_statement] = STATE(1292),
    [sym_while_statement] = STATE(1292),
    [sym_do_statement] = STATE(1292),
    [sym_for_statement] = STATE(1292),
    [sym_return_statement] = STATE(1292),
    [sym_break_statement] = STATE(1292),
    [sym_continue_statement] = STATE(1292),
    [sym_goto_statement] = STATE(1292),
    [sym_seh_try_statement] = STATE(1292),
    [sym_seh_leave_statement] = STATE(1292),
    [sym_expression] = STATE(5437),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10787),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(1292),
    [sym_co_return_statement] = STATE(1292),
    [sym_co_yield_statement] = STATE(1292),
    [sym_throw_statement] = STATE(1292),
    [sym_try_statement] = STATE(1292),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(1292),
    [sym_cbuffer_specifier] = STATE(1292),
    [sym_hlsl_attribute] = STATE(9865),
    [aux_sym_attributed_declarator_repeat1] = STATE(1193),
    [sym_identifier] = ACTIONS(4283),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(2015),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_case] = ACTIONS(4205),
    [anon_sym_default] = ACTIONS(4207),
    [anon_sym_while] = ACTIONS(2019),
    [anon_sym_do] = ACTIONS(2021),
    [anon_sym_for] = ACTIONS(2023),
    [anon_sym_return] = ACTIONS(2025),
    [anon_sym_break] = ACTIONS(2027),
    [anon_sym_continue] = ACTIONS(2029),
    [anon_sym_goto] = ACTIONS(2031),
    [anon_sym___try] = ACTIONS(2033),
    [anon_sym___leave] = ACTIONS(2035),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(2037),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(2039),
    [anon_sym_co_return] = ACTIONS(2041),
    [anon_sym_co_yield] = ACTIONS(2043),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(2045),
    [anon_sym_cbuffer] = ACTIONS(2047),
  },
  [1171] = {
    [sym_function_definition] = STATE(2497),
    [sym_declaration] = STATE(2497),
    [sym__declaration_modifiers] = STATE(2776),
    [sym__declaration_specifiers] = STATE(5723),
    [sym_attribute_specifier] = STATE(2776),
    [sym_attribute_declaration] = STATE(2776),
    [sym_ms_declspec_modifier] = STATE(2776),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7407),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2776),
    [sym_type_qualifier] = STATE(2776),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2685),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym__empty_declaration] = STATE(2497),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_explicit_function_specifier] = STATE(2590),
    [sym_dependent_type] = STATE(2741),
    [sym_template_declaration] = STATE(2497),
    [sym_operator_cast] = STATE(8480),
    [sym__constructor_specifiers] = STATE(2590),
    [sym_operator_cast_definition] = STATE(2497),
    [sym_operator_cast_declaration] = STATE(2497),
    [sym_constructor_or_destructor_definition] = STATE(2497),
    [sym_constructor_or_destructor_declaration] = STATE(2497),
    [sym_friend_declaration] = STATE(2497),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_alias_declaration] = STATE(2497),
    [sym_concept_definition] = STATE(2497),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6578),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualified_operator_cast_identifier] = STATE(8480),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2776),
    [sym_hlsl_attribute] = STATE(1511),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2590),
    [sym_identifier] = ACTIONS(3995),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(37),
    [anon_sym_out] = ACTIONS(37),
    [anon_sym_inout] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3997),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(3999),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(2882),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2884),
    [anon_sym_using] = ACTIONS(4007),
    [anon_sym_concept] = ACTIONS(4009),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1172] = {
    [sym_attribute_declaration] = STATE(1120),
    [sym_compound_statement] = STATE(406),
    [sym_attributed_statement] = STATE(406),
    [sym_statement] = STATE(284),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(9743),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [sym_identifier] = ACTIONS(4195),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_cbuffer] = ACTIONS(359),
  },
  [1173] = {
    [sym_attribute_declaration] = STATE(1117),
    [sym_compound_statement] = STATE(774),
    [sym_attributed_statement] = STATE(774),
    [sym_statement] = STATE(735),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(9709),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [sym_identifier] = ACTIONS(4039),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_cbuffer] = ACTIONS(269),
  },
  [1174] = {
    [sym_attribute_declaration] = STATE(1102),
    [sym_compound_statement] = STATE(612),
    [sym_attributed_statement] = STATE(612),
    [sym_statement] = STATE(561),
    [sym_labeled_statement] = STATE(612),
    [sym_expression_statement] = STATE(612),
    [sym_if_statement] = STATE(612),
    [sym_switch_statement] = STATE(612),
    [sym_case_statement] = STATE(612),
    [sym_while_statement] = STATE(612),
    [sym_do_statement] = STATE(612),
    [sym_for_statement] = STATE(612),
    [sym_return_statement] = STATE(612),
    [sym_break_statement] = STATE(612),
    [sym_continue_statement] = STATE(612),
    [sym_goto_statement] = STATE(612),
    [sym_seh_try_statement] = STATE(612),
    [sym_seh_leave_statement] = STATE(612),
    [sym_expression] = STATE(5434),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10523),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(612),
    [sym_co_return_statement] = STATE(612),
    [sym_co_yield_statement] = STATE(612),
    [sym_throw_statement] = STATE(612),
    [sym_try_statement] = STATE(612),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(612),
    [sym_cbuffer_specifier] = STATE(612),
    [sym_hlsl_attribute] = STATE(10015),
    [aux_sym_attributed_declarator_repeat1] = STATE(1102),
    [sym_identifier] = ACTIONS(4197),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1793),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(81),
    [anon_sym_default] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(1795),
    [anon_sym___leave] = ACTIONS(1797),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1799),
    [anon_sym_cbuffer] = ACTIONS(1801),
  },
  [1175] = {
    [sym_attribute_declaration] = STATE(1119),
    [sym_compound_statement] = STATE(774),
    [sym_attributed_statement] = STATE(774),
    [sym_statement] = STATE(10510),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(9921),
    [aux_sym_attributed_declarator_repeat1] = STATE(1119),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(4203),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(4205),
    [anon_sym_default] = ACTIONS(4207),
    [anon_sym_while] = ACTIONS(4209),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(4211),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(4213),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_cbuffer] = ACTIONS(4215),
  },
  [1176] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(3522),
    [sym__string] = STATE(4324),
    [sym_comma_expression] = STATE(10715),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_type_descriptor] = STATE(10139),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9813),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym__unary_left_fold] = STATE(10708),
    [sym__unary_right_fold] = STATE(10705),
    [sym__binary_fold] = STATE(10700),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6796),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym__assignment_expression_lhs] = STATE(10673),
    [sym_user_defined_literal] = STATE(4292),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1177] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(3522),
    [sym__string] = STATE(4324),
    [sym_comma_expression] = STATE(10715),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_type_descriptor] = STATE(10525),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9813),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym__unary_left_fold] = STATE(10708),
    [sym__unary_right_fold] = STATE(10705),
    [sym__binary_fold] = STATE(10700),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6796),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym__assignment_expression_lhs] = STATE(10673),
    [sym_user_defined_literal] = STATE(4292),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1178] = {
    [sym_attribute_declaration] = STATE(1117),
    [sym_compound_statement] = STATE(774),
    [sym_attributed_statement] = STATE(774),
    [sym_statement] = STATE(616),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(9709),
    [aux_sym_attributed_declarator_repeat1] = STATE(1117),
    [sym_identifier] = ACTIONS(4039),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(213),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(217),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(227),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_goto] = ACTIONS(231),
    [anon_sym___try] = ACTIONS(233),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(253),
    [anon_sym_co_return] = ACTIONS(263),
    [anon_sym_co_yield] = ACTIONS(265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_cbuffer] = ACTIONS(269),
  },
  [1179] = {
    [sym_attribute_declaration] = STATE(1193),
    [sym_compound_statement] = STATE(1292),
    [sym_attributed_statement] = STATE(1292),
    [sym_statement] = STATE(1307),
    [sym_labeled_statement] = STATE(1292),
    [sym_expression_statement] = STATE(1292),
    [sym_if_statement] = STATE(1292),
    [sym_switch_statement] = STATE(1292),
    [sym_case_statement] = STATE(1292),
    [sym_while_statement] = STATE(1292),
    [sym_do_statement] = STATE(1292),
    [sym_for_statement] = STATE(1292),
    [sym_return_statement] = STATE(1292),
    [sym_break_statement] = STATE(1292),
    [sym_continue_statement] = STATE(1292),
    [sym_goto_statement] = STATE(1292),
    [sym_seh_try_statement] = STATE(1292),
    [sym_seh_leave_statement] = STATE(1292),
    [sym_expression] = STATE(5437),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10787),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(1292),
    [sym_co_return_statement] = STATE(1292),
    [sym_co_yield_statement] = STATE(1292),
    [sym_throw_statement] = STATE(1292),
    [sym_try_statement] = STATE(1292),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(1292),
    [sym_cbuffer_specifier] = STATE(1292),
    [sym_hlsl_attribute] = STATE(9865),
    [aux_sym_attributed_declarator_repeat1] = STATE(1193),
    [sym_identifier] = ACTIONS(4283),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(2015),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_case] = ACTIONS(4205),
    [anon_sym_default] = ACTIONS(4207),
    [anon_sym_while] = ACTIONS(2019),
    [anon_sym_do] = ACTIONS(2021),
    [anon_sym_for] = ACTIONS(2023),
    [anon_sym_return] = ACTIONS(2025),
    [anon_sym_break] = ACTIONS(2027),
    [anon_sym_continue] = ACTIONS(2029),
    [anon_sym_goto] = ACTIONS(2031),
    [anon_sym___try] = ACTIONS(2033),
    [anon_sym___leave] = ACTIONS(2035),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(2037),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(2039),
    [anon_sym_co_return] = ACTIONS(2041),
    [anon_sym_co_yield] = ACTIONS(2043),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(2045),
    [anon_sym_cbuffer] = ACTIONS(2047),
  },
  [1180] = {
    [sym_attribute_declaration] = STATE(1180),
    [sym_compound_statement] = STATE(612),
    [sym_attributed_statement] = STATE(612),
    [sym_statement] = STATE(597),
    [sym_labeled_statement] = STATE(612),
    [sym_expression_statement] = STATE(612),
    [sym_if_statement] = STATE(612),
    [sym_switch_statement] = STATE(612),
    [sym_case_statement] = STATE(612),
    [sym_while_statement] = STATE(612),
    [sym_do_statement] = STATE(612),
    [sym_for_statement] = STATE(612),
    [sym_return_statement] = STATE(612),
    [sym_break_statement] = STATE(612),
    [sym_continue_statement] = STATE(612),
    [sym_goto_statement] = STATE(612),
    [sym_seh_try_statement] = STATE(612),
    [sym_seh_leave_statement] = STATE(612),
    [sym_expression] = STATE(5434),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10523),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(612),
    [sym_co_return_statement] = STATE(612),
    [sym_co_yield_statement] = STATE(612),
    [sym_throw_statement] = STATE(612),
    [sym_try_statement] = STATE(612),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(612),
    [sym_cbuffer_specifier] = STATE(612),
    [sym_hlsl_attribute] = STATE(10015),
    [aux_sym_attributed_declarator_repeat1] = STATE(1180),
    [sym_identifier] = ACTIONS(4512),
    [anon_sym_LPAREN2] = ACTIONS(4054),
    [anon_sym_BANG] = ACTIONS(4057),
    [anon_sym_TILDE] = ACTIONS(4057),
    [anon_sym_DASH] = ACTIONS(4060),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_STAR] = ACTIONS(4063),
    [anon_sym_AMP] = ACTIONS(4063),
    [anon_sym_SEMI] = ACTIONS(4515),
    [anon_sym_COLON_COLON] = ACTIONS(4069),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [sym_primitive_type] = ACTIONS(4081),
    [anon_sym_if] = ACTIONS(4518),
    [anon_sym_switch] = ACTIONS(4294),
    [anon_sym_case] = ACTIONS(4521),
    [anon_sym_default] = ACTIONS(4524),
    [anon_sym_while] = ACTIONS(4527),
    [anon_sym_do] = ACTIONS(4306),
    [anon_sym_for] = ACTIONS(4530),
    [anon_sym_return] = ACTIONS(4312),
    [anon_sym_break] = ACTIONS(4315),
    [anon_sym_continue] = ACTIONS(4318),
    [anon_sym_goto] = ACTIONS(4321),
    [anon_sym___try] = ACTIONS(4533),
    [anon_sym___leave] = ACTIONS(4536),
    [anon_sym_not] = ACTIONS(4060),
    [anon_sym_compl] = ACTIONS(4060),
    [anon_sym_DASH_DASH] = ACTIONS(4123),
    [anon_sym_PLUS_PLUS] = ACTIONS(4123),
    [anon_sym_sizeof] = ACTIONS(4126),
    [anon_sym___alignof__] = ACTIONS(4129),
    [anon_sym___alignof] = ACTIONS(4129),
    [anon_sym__alignof] = ACTIONS(4129),
    [anon_sym_alignof] = ACTIONS(4129),
    [anon_sym__Alignof] = ACTIONS(4129),
    [anon_sym_offsetof] = ACTIONS(4132),
    [anon_sym__Generic] = ACTIONS(4135),
    [anon_sym_asm] = ACTIONS(4138),
    [anon_sym___asm__] = ACTIONS(4138),
    [sym_number_literal] = ACTIONS(4141),
    [anon_sym_L_SQUOTE] = ACTIONS(4144),
    [anon_sym_u_SQUOTE] = ACTIONS(4144),
    [anon_sym_U_SQUOTE] = ACTIONS(4144),
    [anon_sym_u8_SQUOTE] = ACTIONS(4144),
    [anon_sym_SQUOTE] = ACTIONS(4144),
    [anon_sym_L_DQUOTE] = ACTIONS(4147),
    [anon_sym_u_DQUOTE] = ACTIONS(4147),
    [anon_sym_U_DQUOTE] = ACTIONS(4147),
    [anon_sym_u8_DQUOTE] = ACTIONS(4147),
    [anon_sym_DQUOTE] = ACTIONS(4147),
    [sym_true] = ACTIONS(4150),
    [sym_false] = ACTIONS(4150),
    [anon_sym_NULL] = ACTIONS(4153),
    [anon_sym_nullptr] = ACTIONS(4153),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4156),
    [anon_sym_template] = ACTIONS(4159),
    [anon_sym_try] = ACTIONS(4327),
    [anon_sym_delete] = ACTIONS(4165),
    [anon_sym_throw] = ACTIONS(4330),
    [anon_sym_co_return] = ACTIONS(4333),
    [anon_sym_co_yield] = ACTIONS(4336),
    [anon_sym_R_DQUOTE] = ACTIONS(4177),
    [anon_sym_LR_DQUOTE] = ACTIONS(4177),
    [anon_sym_uR_DQUOTE] = ACTIONS(4177),
    [anon_sym_UR_DQUOTE] = ACTIONS(4177),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4177),
    [anon_sym_co_await] = ACTIONS(4180),
    [anon_sym_new] = ACTIONS(4183),
    [anon_sym_requires] = ACTIONS(4186),
    [sym_this] = ACTIONS(4150),
    [anon_sym_discard] = ACTIONS(4539),
    [anon_sym_cbuffer] = ACTIONS(4542),
  },
  [1181] = {
    [sym_attribute_declaration] = STATE(1119),
    [sym_compound_statement] = STATE(774),
    [sym_attributed_statement] = STATE(774),
    [sym_statement] = STATE(10432),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(9921),
    [aux_sym_attributed_declarator_repeat1] = STATE(1119),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(4203),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(4205),
    [anon_sym_default] = ACTIONS(4207),
    [anon_sym_while] = ACTIONS(4209),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(4211),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(4213),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_cbuffer] = ACTIONS(4215),
  },
  [1182] = {
    [sym_attribute_declaration] = STATE(1193),
    [sym_compound_statement] = STATE(1292),
    [sym_attributed_statement] = STATE(1292),
    [sym_statement] = STATE(1301),
    [sym_labeled_statement] = STATE(1292),
    [sym_expression_statement] = STATE(1292),
    [sym_if_statement] = STATE(1292),
    [sym_switch_statement] = STATE(1292),
    [sym_case_statement] = STATE(1292),
    [sym_while_statement] = STATE(1292),
    [sym_do_statement] = STATE(1292),
    [sym_for_statement] = STATE(1292),
    [sym_return_statement] = STATE(1292),
    [sym_break_statement] = STATE(1292),
    [sym_continue_statement] = STATE(1292),
    [sym_goto_statement] = STATE(1292),
    [sym_seh_try_statement] = STATE(1292),
    [sym_seh_leave_statement] = STATE(1292),
    [sym_expression] = STATE(5437),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10787),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(1292),
    [sym_co_return_statement] = STATE(1292),
    [sym_co_yield_statement] = STATE(1292),
    [sym_throw_statement] = STATE(1292),
    [sym_try_statement] = STATE(1292),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(1292),
    [sym_cbuffer_specifier] = STATE(1292),
    [sym_hlsl_attribute] = STATE(9865),
    [aux_sym_attributed_declarator_repeat1] = STATE(1193),
    [sym_identifier] = ACTIONS(4283),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(2015),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_case] = ACTIONS(4205),
    [anon_sym_default] = ACTIONS(4207),
    [anon_sym_while] = ACTIONS(2019),
    [anon_sym_do] = ACTIONS(2021),
    [anon_sym_for] = ACTIONS(2023),
    [anon_sym_return] = ACTIONS(2025),
    [anon_sym_break] = ACTIONS(2027),
    [anon_sym_continue] = ACTIONS(2029),
    [anon_sym_goto] = ACTIONS(2031),
    [anon_sym___try] = ACTIONS(2033),
    [anon_sym___leave] = ACTIONS(2035),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(2037),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(2039),
    [anon_sym_co_return] = ACTIONS(2041),
    [anon_sym_co_yield] = ACTIONS(2043),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(2045),
    [anon_sym_cbuffer] = ACTIONS(2047),
  },
  [1183] = {
    [sym_attribute_declaration] = STATE(1193),
    [sym_compound_statement] = STATE(1292),
    [sym_attributed_statement] = STATE(1292),
    [sym_statement] = STATE(1294),
    [sym_labeled_statement] = STATE(1292),
    [sym_expression_statement] = STATE(1292),
    [sym_if_statement] = STATE(1292),
    [sym_switch_statement] = STATE(1292),
    [sym_case_statement] = STATE(1292),
    [sym_while_statement] = STATE(1292),
    [sym_do_statement] = STATE(1292),
    [sym_for_statement] = STATE(1292),
    [sym_return_statement] = STATE(1292),
    [sym_break_statement] = STATE(1292),
    [sym_continue_statement] = STATE(1292),
    [sym_goto_statement] = STATE(1292),
    [sym_seh_try_statement] = STATE(1292),
    [sym_seh_leave_statement] = STATE(1292),
    [sym_expression] = STATE(5437),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10787),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(1292),
    [sym_co_return_statement] = STATE(1292),
    [sym_co_yield_statement] = STATE(1292),
    [sym_throw_statement] = STATE(1292),
    [sym_try_statement] = STATE(1292),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(1292),
    [sym_cbuffer_specifier] = STATE(1292),
    [sym_hlsl_attribute] = STATE(9865),
    [aux_sym_attributed_declarator_repeat1] = STATE(1193),
    [sym_identifier] = ACTIONS(4283),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(2015),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_case] = ACTIONS(4205),
    [anon_sym_default] = ACTIONS(4207),
    [anon_sym_while] = ACTIONS(2019),
    [anon_sym_do] = ACTIONS(2021),
    [anon_sym_for] = ACTIONS(2023),
    [anon_sym_return] = ACTIONS(2025),
    [anon_sym_break] = ACTIONS(2027),
    [anon_sym_continue] = ACTIONS(2029),
    [anon_sym_goto] = ACTIONS(2031),
    [anon_sym___try] = ACTIONS(2033),
    [anon_sym___leave] = ACTIONS(2035),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(2037),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(2039),
    [anon_sym_co_return] = ACTIONS(2041),
    [anon_sym_co_yield] = ACTIONS(2043),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(2045),
    [anon_sym_cbuffer] = ACTIONS(2047),
  },
  [1184] = {
    [sym_attribute_declaration] = STATE(1148),
    [sym_compound_statement] = STATE(787),
    [sym_attributed_statement] = STATE(787),
    [sym_statement] = STATE(695),
    [sym_labeled_statement] = STATE(787),
    [sym_expression_statement] = STATE(787),
    [sym_if_statement] = STATE(787),
    [sym_switch_statement] = STATE(787),
    [sym_case_statement] = STATE(787),
    [sym_while_statement] = STATE(787),
    [sym_do_statement] = STATE(787),
    [sym_for_statement] = STATE(787),
    [sym_return_statement] = STATE(787),
    [sym_break_statement] = STATE(787),
    [sym_continue_statement] = STATE(787),
    [sym_goto_statement] = STATE(787),
    [sym_seh_try_statement] = STATE(787),
    [sym_seh_leave_statement] = STATE(787),
    [sym_expression] = STATE(5465),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10896),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(787),
    [sym_co_return_statement] = STATE(787),
    [sym_co_yield_statement] = STATE(787),
    [sym_throw_statement] = STATE(787),
    [sym_try_statement] = STATE(787),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(787),
    [sym_cbuffer_specifier] = STATE(787),
    [sym_hlsl_attribute] = STATE(9939),
    [aux_sym_attributed_declarator_repeat1] = STATE(1148),
    [sym_identifier] = ACTIONS(4199),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1211),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(1219),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_switch] = ACTIONS(1225),
    [anon_sym_case] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1229),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_do] = ACTIONS(1233),
    [anon_sym_for] = ACTIONS(1235),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1239),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_goto] = ACTIONS(1243),
    [anon_sym___try] = ACTIONS(1245),
    [anon_sym___leave] = ACTIONS(1247),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(1251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(1253),
    [anon_sym_co_return] = ACTIONS(1263),
    [anon_sym_co_yield] = ACTIONS(1265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1267),
    [anon_sym_cbuffer] = ACTIONS(1269),
  },
  [1185] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(3543),
    [sym__string] = STATE(4324),
    [sym_comma_expression] = STATE(10299),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_type_descriptor] = STATE(10773),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9813),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym__unary_left_fold] = STATE(10796),
    [sym__unary_right_fold] = STATE(10795),
    [sym__binary_fold] = STATE(10794),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6796),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym__assignment_expression_lhs] = STATE(10304),
    [sym_user_defined_literal] = STATE(4292),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1186] = {
    [sym_attribute_declaration] = STATE(1193),
    [sym_compound_statement] = STATE(1292),
    [sym_attributed_statement] = STATE(1292),
    [sym_statement] = STATE(1274),
    [sym_labeled_statement] = STATE(1292),
    [sym_expression_statement] = STATE(1292),
    [sym_if_statement] = STATE(1292),
    [sym_switch_statement] = STATE(1292),
    [sym_case_statement] = STATE(1292),
    [sym_while_statement] = STATE(1292),
    [sym_do_statement] = STATE(1292),
    [sym_for_statement] = STATE(1292),
    [sym_return_statement] = STATE(1292),
    [sym_break_statement] = STATE(1292),
    [sym_continue_statement] = STATE(1292),
    [sym_goto_statement] = STATE(1292),
    [sym_seh_try_statement] = STATE(1292),
    [sym_seh_leave_statement] = STATE(1292),
    [sym_expression] = STATE(5437),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10787),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(1292),
    [sym_co_return_statement] = STATE(1292),
    [sym_co_yield_statement] = STATE(1292),
    [sym_throw_statement] = STATE(1292),
    [sym_try_statement] = STATE(1292),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(1292),
    [sym_cbuffer_specifier] = STATE(1292),
    [sym_hlsl_attribute] = STATE(9865),
    [aux_sym_attributed_declarator_repeat1] = STATE(1193),
    [sym_identifier] = ACTIONS(4283),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(2015),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_case] = ACTIONS(4205),
    [anon_sym_default] = ACTIONS(4207),
    [anon_sym_while] = ACTIONS(2019),
    [anon_sym_do] = ACTIONS(2021),
    [anon_sym_for] = ACTIONS(2023),
    [anon_sym_return] = ACTIONS(2025),
    [anon_sym_break] = ACTIONS(2027),
    [anon_sym_continue] = ACTIONS(2029),
    [anon_sym_goto] = ACTIONS(2031),
    [anon_sym___try] = ACTIONS(2033),
    [anon_sym___leave] = ACTIONS(2035),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(2037),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(2039),
    [anon_sym_co_return] = ACTIONS(2041),
    [anon_sym_co_yield] = ACTIONS(2043),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(2045),
    [anon_sym_cbuffer] = ACTIONS(2047),
  },
  [1187] = {
    [sym_attribute_declaration] = STATE(1120),
    [sym_compound_statement] = STATE(406),
    [sym_attributed_statement] = STATE(406),
    [sym_statement] = STATE(391),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(9743),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [sym_identifier] = ACTIONS(4195),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_cbuffer] = ACTIONS(359),
  },
  [1188] = {
    [sym_attribute_declaration] = STATE(1119),
    [sym_compound_statement] = STATE(774),
    [sym_attributed_statement] = STATE(774),
    [sym_statement] = STATE(10562),
    [sym_labeled_statement] = STATE(774),
    [sym_expression_statement] = STATE(774),
    [sym_if_statement] = STATE(774),
    [sym_switch_statement] = STATE(774),
    [sym_case_statement] = STATE(774),
    [sym_while_statement] = STATE(774),
    [sym_do_statement] = STATE(774),
    [sym_for_statement] = STATE(774),
    [sym_return_statement] = STATE(774),
    [sym_break_statement] = STATE(774),
    [sym_continue_statement] = STATE(774),
    [sym_goto_statement] = STATE(774),
    [sym_seh_try_statement] = STATE(774),
    [sym_seh_leave_statement] = STATE(774),
    [sym_expression] = STATE(5358),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10534),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(774),
    [sym_co_return_statement] = STATE(774),
    [sym_co_yield_statement] = STATE(774),
    [sym_throw_statement] = STATE(774),
    [sym_try_statement] = STATE(774),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(774),
    [sym_cbuffer_specifier] = STATE(774),
    [sym_hlsl_attribute] = STATE(9921),
    [aux_sym_attributed_declarator_repeat1] = STATE(1119),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(4203),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(4205),
    [anon_sym_default] = ACTIONS(4207),
    [anon_sym_while] = ACTIONS(4209),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(4211),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(4213),
    [anon_sym___leave] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(267),
    [anon_sym_cbuffer] = ACTIONS(4215),
  },
  [1189] = {
    [sym_attribute_declaration] = STATE(1148),
    [sym_compound_statement] = STATE(787),
    [sym_attributed_statement] = STATE(787),
    [sym_statement] = STATE(667),
    [sym_labeled_statement] = STATE(787),
    [sym_expression_statement] = STATE(787),
    [sym_if_statement] = STATE(787),
    [sym_switch_statement] = STATE(787),
    [sym_case_statement] = STATE(787),
    [sym_while_statement] = STATE(787),
    [sym_do_statement] = STATE(787),
    [sym_for_statement] = STATE(787),
    [sym_return_statement] = STATE(787),
    [sym_break_statement] = STATE(787),
    [sym_continue_statement] = STATE(787),
    [sym_goto_statement] = STATE(787),
    [sym_seh_try_statement] = STATE(787),
    [sym_seh_leave_statement] = STATE(787),
    [sym_expression] = STATE(5465),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10896),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(787),
    [sym_co_return_statement] = STATE(787),
    [sym_co_yield_statement] = STATE(787),
    [sym_throw_statement] = STATE(787),
    [sym_try_statement] = STATE(787),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(787),
    [sym_cbuffer_specifier] = STATE(787),
    [sym_hlsl_attribute] = STATE(9939),
    [aux_sym_attributed_declarator_repeat1] = STATE(1148),
    [sym_identifier] = ACTIONS(4199),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1211),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(1219),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_switch] = ACTIONS(1225),
    [anon_sym_case] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1229),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_do] = ACTIONS(1233),
    [anon_sym_for] = ACTIONS(1235),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1239),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_goto] = ACTIONS(1243),
    [anon_sym___try] = ACTIONS(1245),
    [anon_sym___leave] = ACTIONS(1247),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(1251),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(1253),
    [anon_sym_co_return] = ACTIONS(1263),
    [anon_sym_co_yield] = ACTIONS(1265),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(1267),
    [anon_sym_cbuffer] = ACTIONS(1269),
  },
  [1190] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(3521),
    [sym__string] = STATE(4324),
    [sym_comma_expression] = STATE(10578),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_type_descriptor] = STATE(10854),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9813),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym__unary_left_fold] = STATE(10910),
    [sym__unary_right_fold] = STATE(10908),
    [sym__binary_fold] = STATE(10906),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6796),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym__assignment_expression_lhs] = STATE(10550),
    [sym_user_defined_literal] = STATE(4292),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1191] = {
    [sym_attribute_declaration] = STATE(1193),
    [sym_compound_statement] = STATE(1292),
    [sym_attributed_statement] = STATE(1292),
    [sym_statement] = STATE(1277),
    [sym_labeled_statement] = STATE(1292),
    [sym_expression_statement] = STATE(1292),
    [sym_if_statement] = STATE(1292),
    [sym_switch_statement] = STATE(1292),
    [sym_case_statement] = STATE(1292),
    [sym_while_statement] = STATE(1292),
    [sym_do_statement] = STATE(1292),
    [sym_for_statement] = STATE(1292),
    [sym_return_statement] = STATE(1292),
    [sym_break_statement] = STATE(1292),
    [sym_continue_statement] = STATE(1292),
    [sym_goto_statement] = STATE(1292),
    [sym_seh_try_statement] = STATE(1292),
    [sym_seh_leave_statement] = STATE(1292),
    [sym_expression] = STATE(5437),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10787),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(1292),
    [sym_co_return_statement] = STATE(1292),
    [sym_co_yield_statement] = STATE(1292),
    [sym_throw_statement] = STATE(1292),
    [sym_try_statement] = STATE(1292),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(1292),
    [sym_cbuffer_specifier] = STATE(1292),
    [sym_hlsl_attribute] = STATE(9865),
    [aux_sym_attributed_declarator_repeat1] = STATE(1193),
    [sym_identifier] = ACTIONS(4283),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(2015),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_case] = ACTIONS(4205),
    [anon_sym_default] = ACTIONS(4207),
    [anon_sym_while] = ACTIONS(2019),
    [anon_sym_do] = ACTIONS(2021),
    [anon_sym_for] = ACTIONS(2023),
    [anon_sym_return] = ACTIONS(2025),
    [anon_sym_break] = ACTIONS(2027),
    [anon_sym_continue] = ACTIONS(2029),
    [anon_sym_goto] = ACTIONS(2031),
    [anon_sym___try] = ACTIONS(2033),
    [anon_sym___leave] = ACTIONS(2035),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(2037),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(2039),
    [anon_sym_co_return] = ACTIONS(2041),
    [anon_sym_co_yield] = ACTIONS(2043),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(2045),
    [anon_sym_cbuffer] = ACTIONS(2047),
  },
  [1192] = {
    [sym_attribute_declaration] = STATE(1120),
    [sym_compound_statement] = STATE(406),
    [sym_attributed_statement] = STATE(406),
    [sym_statement] = STATE(399),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(9743),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [sym_identifier] = ACTIONS(4195),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_cbuffer] = ACTIONS(359),
  },
  [1193] = {
    [sym_attribute_declaration] = STATE(1166),
    [sym_compound_statement] = STATE(1292),
    [sym_attributed_statement] = STATE(1292),
    [sym_statement] = STATE(1297),
    [sym_labeled_statement] = STATE(1292),
    [sym_expression_statement] = STATE(1292),
    [sym_if_statement] = STATE(1292),
    [sym_switch_statement] = STATE(1292),
    [sym_case_statement] = STATE(1292),
    [sym_while_statement] = STATE(1292),
    [sym_do_statement] = STATE(1292),
    [sym_for_statement] = STATE(1292),
    [sym_return_statement] = STATE(1292),
    [sym_break_statement] = STATE(1292),
    [sym_continue_statement] = STATE(1292),
    [sym_goto_statement] = STATE(1292),
    [sym_seh_try_statement] = STATE(1292),
    [sym_seh_leave_statement] = STATE(1292),
    [sym_expression] = STATE(5437),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10787),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(1292),
    [sym_co_return_statement] = STATE(1292),
    [sym_co_yield_statement] = STATE(1292),
    [sym_throw_statement] = STATE(1292),
    [sym_try_statement] = STATE(1292),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(1292),
    [sym_cbuffer_specifier] = STATE(1292),
    [sym_hlsl_attribute] = STATE(9865),
    [aux_sym_attributed_declarator_repeat1] = STATE(1166),
    [sym_identifier] = ACTIONS(4283),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(2015),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_case] = ACTIONS(4205),
    [anon_sym_default] = ACTIONS(4207),
    [anon_sym_while] = ACTIONS(2019),
    [anon_sym_do] = ACTIONS(2021),
    [anon_sym_for] = ACTIONS(2023),
    [anon_sym_return] = ACTIONS(2025),
    [anon_sym_break] = ACTIONS(2027),
    [anon_sym_continue] = ACTIONS(2029),
    [anon_sym_goto] = ACTIONS(2031),
    [anon_sym___try] = ACTIONS(2033),
    [anon_sym___leave] = ACTIONS(2035),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(2037),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(2039),
    [anon_sym_co_return] = ACTIONS(2041),
    [anon_sym_co_yield] = ACTIONS(2043),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(2045),
    [anon_sym_cbuffer] = ACTIONS(2047),
  },
  [1194] = {
    [sym_attribute_declaration] = STATE(1120),
    [sym_compound_statement] = STATE(406),
    [sym_attributed_statement] = STATE(406),
    [sym_statement] = STATE(402),
    [sym_labeled_statement] = STATE(406),
    [sym_expression_statement] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_switch_statement] = STATE(406),
    [sym_case_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_do_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_return_statement] = STATE(406),
    [sym_break_statement] = STATE(406),
    [sym_continue_statement] = STATE(406),
    [sym_goto_statement] = STATE(406),
    [sym_seh_try_statement] = STATE(406),
    [sym_seh_leave_statement] = STATE(406),
    [sym_expression] = STATE(5371),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10317),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_for_range_loop] = STATE(406),
    [sym_co_return_statement] = STATE(406),
    [sym_co_yield_statement] = STATE(406),
    [sym_throw_statement] = STATE(406),
    [sym_try_statement] = STATE(406),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_discard_statement] = STATE(406),
    [sym_cbuffer_specifier] = STATE(406),
    [sym_hlsl_attribute] = STATE(9743),
    [aux_sym_attributed_declarator_repeat1] = STATE(1120),
    [sym_identifier] = ACTIONS(4195),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_switch] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(327),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(331),
    [anon_sym_goto] = ACTIONS(333),
    [anon_sym___try] = ACTIONS(335),
    [anon_sym___leave] = ACTIONS(337),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(353),
    [anon_sym_co_yield] = ACTIONS(355),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(357),
    [anon_sym_cbuffer] = ACTIONS(359),
  },
  [1195] = {
    [sym_identifier] = ACTIONS(4545),
    [anon_sym_COMMA] = ACTIONS(4547),
    [anon_sym_RPAREN] = ACTIONS(4547),
    [anon_sym_LPAREN2] = ACTIONS(4547),
    [anon_sym_BANG] = ACTIONS(4547),
    [anon_sym_TILDE] = ACTIONS(4547),
    [anon_sym_DASH] = ACTIONS(4545),
    [anon_sym_PLUS] = ACTIONS(4545),
    [anon_sym_STAR] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4547),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_SEMI] = ACTIONS(4547),
    [anon_sym___extension__] = ACTIONS(4545),
    [anon_sym_in] = ACTIONS(4545),
    [anon_sym_out] = ACTIONS(4545),
    [anon_sym_inout] = ACTIONS(4545),
    [anon_sym_extern] = ACTIONS(4545),
    [anon_sym___attribute__] = ACTIONS(4545),
    [anon_sym_COLON_COLON] = ACTIONS(4547),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4547),
    [anon_sym___declspec] = ACTIONS(4545),
    [anon_sym___based] = ACTIONS(4545),
    [anon_sym_LBRACE] = ACTIONS(4547),
    [anon_sym_signed] = ACTIONS(4545),
    [anon_sym_unsigned] = ACTIONS(4545),
    [anon_sym_long] = ACTIONS(4545),
    [anon_sym_short] = ACTIONS(4545),
    [anon_sym_LBRACK] = ACTIONS(4545),
    [anon_sym_static] = ACTIONS(4545),
    [anon_sym_EQ] = ACTIONS(4547),
    [anon_sym_register] = ACTIONS(4545),
    [anon_sym_inline] = ACTIONS(4545),
    [anon_sym___inline] = ACTIONS(4545),
    [anon_sym___inline__] = ACTIONS(4545),
    [anon_sym___forceinline] = ACTIONS(4545),
    [anon_sym_thread_local] = ACTIONS(4545),
    [anon_sym___thread] = ACTIONS(4545),
    [anon_sym_const] = ACTIONS(4545),
    [anon_sym_constexpr] = ACTIONS(4545),
    [anon_sym_volatile] = ACTIONS(4545),
    [anon_sym_restrict] = ACTIONS(4545),
    [anon_sym___restrict__] = ACTIONS(4545),
    [anon_sym__Atomic] = ACTIONS(4545),
    [anon_sym__Noreturn] = ACTIONS(4545),
    [anon_sym_noreturn] = ACTIONS(4545),
    [anon_sym_mutable] = ACTIONS(4545),
    [anon_sym_constinit] = ACTIONS(4545),
    [anon_sym_consteval] = ACTIONS(4545),
    [anon_sym_alignas] = ACTIONS(4545),
    [anon_sym__Alignas] = ACTIONS(4545),
    [sym_primitive_type] = ACTIONS(4545),
    [anon_sym_enum] = ACTIONS(4545),
    [anon_sym_class] = ACTIONS(4545),
    [anon_sym_struct] = ACTIONS(4545),
    [anon_sym_union] = ACTIONS(4545),
    [anon_sym_if] = ACTIONS(4545),
    [anon_sym_switch] = ACTIONS(4545),
    [anon_sym_case] = ACTIONS(4545),
    [anon_sym_default] = ACTIONS(4545),
    [anon_sym_while] = ACTIONS(4545),
    [anon_sym_do] = ACTIONS(4545),
    [anon_sym_for] = ACTIONS(4545),
    [anon_sym_return] = ACTIONS(4545),
    [anon_sym_break] = ACTIONS(4545),
    [anon_sym_continue] = ACTIONS(4545),
    [anon_sym_goto] = ACTIONS(4545),
    [anon_sym___try] = ACTIONS(4545),
    [anon_sym___leave] = ACTIONS(4545),
    [anon_sym_not] = ACTIONS(4545),
    [anon_sym_compl] = ACTIONS(4545),
    [anon_sym_DASH_DASH] = ACTIONS(4547),
    [anon_sym_PLUS_PLUS] = ACTIONS(4547),
    [anon_sym_sizeof] = ACTIONS(4545),
    [anon_sym___alignof__] = ACTIONS(4545),
    [anon_sym___alignof] = ACTIONS(4545),
    [anon_sym__alignof] = ACTIONS(4545),
    [anon_sym_alignof] = ACTIONS(4545),
    [anon_sym__Alignof] = ACTIONS(4545),
    [anon_sym_offsetof] = ACTIONS(4545),
    [anon_sym__Generic] = ACTIONS(4545),
    [anon_sym_asm] = ACTIONS(4545),
    [anon_sym___asm__] = ACTIONS(4545),
    [sym_number_literal] = ACTIONS(4547),
    [anon_sym_L_SQUOTE] = ACTIONS(4547),
    [anon_sym_u_SQUOTE] = ACTIONS(4547),
    [anon_sym_U_SQUOTE] = ACTIONS(4547),
    [anon_sym_u8_SQUOTE] = ACTIONS(4547),
    [anon_sym_SQUOTE] = ACTIONS(4547),
    [anon_sym_L_DQUOTE] = ACTIONS(4547),
    [anon_sym_u_DQUOTE] = ACTIONS(4547),
    [anon_sym_U_DQUOTE] = ACTIONS(4547),
    [anon_sym_u8_DQUOTE] = ACTIONS(4547),
    [anon_sym_DQUOTE] = ACTIONS(4547),
    [sym_true] = ACTIONS(4545),
    [sym_false] = ACTIONS(4545),
    [anon_sym_NULL] = ACTIONS(4545),
    [anon_sym_nullptr] = ACTIONS(4545),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4545),
    [anon_sym_let] = ACTIONS(4545),
    [anon_sym_This] = ACTIONS(4545),
    [anon_sym_decltype] = ACTIONS(4545),
    [sym_virtual] = ACTIONS(4545),
    [anon_sym_explicit] = ACTIONS(4545),
    [anon_sym_typename] = ACTIONS(4545),
    [anon_sym_template] = ACTIONS(4545),
    [anon_sym_operator] = ACTIONS(4545),
    [anon_sym_try] = ACTIONS(4545),
    [anon_sym_delete] = ACTIONS(4545),
    [anon_sym_throw] = ACTIONS(4545),
    [anon_sym_co_return] = ACTIONS(4545),
    [anon_sym_co_yield] = ACTIONS(4545),
    [anon_sym_R_DQUOTE] = ACTIONS(4547),
    [anon_sym_LR_DQUOTE] = ACTIONS(4547),
    [anon_sym_uR_DQUOTE] = ACTIONS(4547),
    [anon_sym_UR_DQUOTE] = ACTIONS(4547),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4547),
    [anon_sym_co_await] = ACTIONS(4545),
    [anon_sym_new] = ACTIONS(4545),
    [anon_sym_requires] = ACTIONS(4545),
    [sym_this] = ACTIONS(4545),
    [anon_sym_discard] = ACTIONS(4545),
    [anon_sym_precise] = ACTIONS(4545),
    [anon_sym_shared] = ACTIONS(4545),
    [anon_sym_groupshared] = ACTIONS(4545),
    [anon_sym_uniform] = ACTIONS(4545),
    [anon_sym_row_major] = ACTIONS(4545),
    [anon_sym_column_major] = ACTIONS(4545),
    [anon_sym_globallycoherent] = ACTIONS(4545),
    [anon_sym_centroid] = ACTIONS(4545),
    [anon_sym_noperspective] = ACTIONS(4545),
    [anon_sym_nointerpolation] = ACTIONS(4545),
    [anon_sym_sample] = ACTIONS(4545),
    [anon_sym_linear] = ACTIONS(4545),
    [anon_sym_snorm] = ACTIONS(4545),
    [anon_sym_unorm] = ACTIONS(4545),
    [anon_sym_point] = ACTIONS(4545),
    [anon_sym_line] = ACTIONS(4545),
    [anon_sym_triangleadj] = ACTIONS(4545),
    [anon_sym_lineadj] = ACTIONS(4545),
    [anon_sym_triangle] = ACTIONS(4545),
    [anon_sym_cbuffer] = ACTIONS(4545),
    [anon_sym_interface] = ACTIONS(4545),
    [anon_sym_extension] = ACTIONS(4545),
  },
  [1196] = {
    [sym_expression] = STATE(3205),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_initializer_list] = STATE(3277),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4410),
    [anon_sym_COMMA] = ACTIONS(4410),
    [anon_sym_RPAREN] = ACTIONS(4410),
    [anon_sym_LPAREN2] = ACTIONS(4410),
    [anon_sym_BANG] = ACTIONS(4551),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4408),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_STAR] = ACTIONS(4408),
    [anon_sym_SLASH] = ACTIONS(4408),
    [anon_sym_PERCENT] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4408),
    [anon_sym_GT_EQ] = ACTIONS(4410),
    [anon_sym_LT_EQ] = ACTIONS(4408),
    [anon_sym_LT] = ACTIONS(4408),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_SEMI] = ACTIONS(4410),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACE] = ACTIONS(4418),
    [anon_sym_RBRACE] = ACTIONS(4410),
    [anon_sym_LBRACK] = ACTIONS(4410),
    [anon_sym_RBRACK] = ACTIONS(4410),
    [anon_sym_EQ] = ACTIONS(4408),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_QMARK] = ACTIONS(4410),
    [anon_sym_STAR_EQ] = ACTIONS(4410),
    [anon_sym_SLASH_EQ] = ACTIONS(4410),
    [anon_sym_PERCENT_EQ] = ACTIONS(4410),
    [anon_sym_PLUS_EQ] = ACTIONS(4410),
    [anon_sym_DASH_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_GT_EQ] = ACTIONS(4410),
    [anon_sym_AMP_EQ] = ACTIONS(4410),
    [anon_sym_CARET_EQ] = ACTIONS(4410),
    [anon_sym_PIPE_EQ] = ACTIONS(4410),
    [anon_sym_and_eq] = ACTIONS(4408),
    [anon_sym_or_eq] = ACTIONS(4408),
    [anon_sym_xor_eq] = ACTIONS(4408),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_LT_EQ_GT] = ACTIONS(4410),
    [anon_sym_or] = ACTIONS(4408),
    [anon_sym_and] = ACTIONS(4408),
    [anon_sym_bitor] = ACTIONS(4408),
    [anon_sym_xor] = ACTIONS(4408),
    [anon_sym_bitand] = ACTIONS(4408),
    [anon_sym_not_eq] = ACTIONS(4408),
    [anon_sym_is] = ACTIONS(4408),
    [anon_sym_as] = ACTIONS(4408),
    [anon_sym_DASH_DASH] = ACTIONS(4410),
    [anon_sym_PLUS_PLUS] = ACTIONS(4410),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [anon_sym_DOT] = ACTIONS(4408),
    [anon_sym_DOT_STAR] = ACTIONS(4410),
    [anon_sym_DASH_GT] = ACTIONS(4410),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1197] = {
    [sym_identifier] = ACTIONS(4573),
    [anon_sym_COMMA] = ACTIONS(4575),
    [anon_sym_RPAREN] = ACTIONS(4575),
    [anon_sym_LPAREN2] = ACTIONS(4575),
    [anon_sym_BANG] = ACTIONS(4575),
    [anon_sym_TILDE] = ACTIONS(4575),
    [anon_sym_DASH] = ACTIONS(4573),
    [anon_sym_PLUS] = ACTIONS(4573),
    [anon_sym_STAR] = ACTIONS(4575),
    [anon_sym_AMP_AMP] = ACTIONS(4575),
    [anon_sym_AMP] = ACTIONS(4573),
    [anon_sym_SEMI] = ACTIONS(4575),
    [anon_sym___extension__] = ACTIONS(4573),
    [anon_sym_in] = ACTIONS(4573),
    [anon_sym_out] = ACTIONS(4573),
    [anon_sym_inout] = ACTIONS(4573),
    [anon_sym_extern] = ACTIONS(4573),
    [anon_sym___attribute__] = ACTIONS(4573),
    [anon_sym_COLON_COLON] = ACTIONS(4575),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4575),
    [anon_sym___declspec] = ACTIONS(4573),
    [anon_sym___based] = ACTIONS(4573),
    [anon_sym_LBRACE] = ACTIONS(4575),
    [anon_sym_signed] = ACTIONS(4573),
    [anon_sym_unsigned] = ACTIONS(4573),
    [anon_sym_long] = ACTIONS(4573),
    [anon_sym_short] = ACTIONS(4573),
    [anon_sym_LBRACK] = ACTIONS(4573),
    [anon_sym_static] = ACTIONS(4573),
    [anon_sym_EQ] = ACTIONS(4575),
    [anon_sym_register] = ACTIONS(4573),
    [anon_sym_inline] = ACTIONS(4573),
    [anon_sym___inline] = ACTIONS(4573),
    [anon_sym___inline__] = ACTIONS(4573),
    [anon_sym___forceinline] = ACTIONS(4573),
    [anon_sym_thread_local] = ACTIONS(4573),
    [anon_sym___thread] = ACTIONS(4573),
    [anon_sym_const] = ACTIONS(4573),
    [anon_sym_constexpr] = ACTIONS(4573),
    [anon_sym_volatile] = ACTIONS(4573),
    [anon_sym_restrict] = ACTIONS(4573),
    [anon_sym___restrict__] = ACTIONS(4573),
    [anon_sym__Atomic] = ACTIONS(4573),
    [anon_sym__Noreturn] = ACTIONS(4573),
    [anon_sym_noreturn] = ACTIONS(4573),
    [anon_sym_mutable] = ACTIONS(4573),
    [anon_sym_constinit] = ACTIONS(4573),
    [anon_sym_consteval] = ACTIONS(4573),
    [anon_sym_alignas] = ACTIONS(4573),
    [anon_sym__Alignas] = ACTIONS(4573),
    [sym_primitive_type] = ACTIONS(4573),
    [anon_sym_enum] = ACTIONS(4573),
    [anon_sym_class] = ACTIONS(4573),
    [anon_sym_struct] = ACTIONS(4573),
    [anon_sym_union] = ACTIONS(4573),
    [anon_sym_if] = ACTIONS(4573),
    [anon_sym_switch] = ACTIONS(4573),
    [anon_sym_case] = ACTIONS(4573),
    [anon_sym_default] = ACTIONS(4573),
    [anon_sym_while] = ACTIONS(4573),
    [anon_sym_do] = ACTIONS(4573),
    [anon_sym_for] = ACTIONS(4573),
    [anon_sym_return] = ACTIONS(4573),
    [anon_sym_break] = ACTIONS(4573),
    [anon_sym_continue] = ACTIONS(4573),
    [anon_sym_goto] = ACTIONS(4573),
    [anon_sym___try] = ACTIONS(4573),
    [anon_sym___leave] = ACTIONS(4573),
    [anon_sym_not] = ACTIONS(4573),
    [anon_sym_compl] = ACTIONS(4573),
    [anon_sym_DASH_DASH] = ACTIONS(4575),
    [anon_sym_PLUS_PLUS] = ACTIONS(4575),
    [anon_sym_sizeof] = ACTIONS(4573),
    [anon_sym___alignof__] = ACTIONS(4573),
    [anon_sym___alignof] = ACTIONS(4573),
    [anon_sym__alignof] = ACTIONS(4573),
    [anon_sym_alignof] = ACTIONS(4573),
    [anon_sym__Alignof] = ACTIONS(4573),
    [anon_sym_offsetof] = ACTIONS(4573),
    [anon_sym__Generic] = ACTIONS(4573),
    [anon_sym_asm] = ACTIONS(4573),
    [anon_sym___asm__] = ACTIONS(4573),
    [sym_number_literal] = ACTIONS(4575),
    [anon_sym_L_SQUOTE] = ACTIONS(4575),
    [anon_sym_u_SQUOTE] = ACTIONS(4575),
    [anon_sym_U_SQUOTE] = ACTIONS(4575),
    [anon_sym_u8_SQUOTE] = ACTIONS(4575),
    [anon_sym_SQUOTE] = ACTIONS(4575),
    [anon_sym_L_DQUOTE] = ACTIONS(4575),
    [anon_sym_u_DQUOTE] = ACTIONS(4575),
    [anon_sym_U_DQUOTE] = ACTIONS(4575),
    [anon_sym_u8_DQUOTE] = ACTIONS(4575),
    [anon_sym_DQUOTE] = ACTIONS(4575),
    [sym_true] = ACTIONS(4573),
    [sym_false] = ACTIONS(4573),
    [anon_sym_NULL] = ACTIONS(4573),
    [anon_sym_nullptr] = ACTIONS(4573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4573),
    [anon_sym_let] = ACTIONS(4573),
    [anon_sym_This] = ACTIONS(4573),
    [anon_sym_decltype] = ACTIONS(4573),
    [sym_virtual] = ACTIONS(4573),
    [anon_sym_explicit] = ACTIONS(4573),
    [anon_sym_typename] = ACTIONS(4573),
    [anon_sym_template] = ACTIONS(4573),
    [anon_sym_operator] = ACTIONS(4573),
    [anon_sym_try] = ACTIONS(4573),
    [anon_sym_delete] = ACTIONS(4573),
    [anon_sym_throw] = ACTIONS(4573),
    [anon_sym_co_return] = ACTIONS(4573),
    [anon_sym_co_yield] = ACTIONS(4573),
    [anon_sym_R_DQUOTE] = ACTIONS(4575),
    [anon_sym_LR_DQUOTE] = ACTIONS(4575),
    [anon_sym_uR_DQUOTE] = ACTIONS(4575),
    [anon_sym_UR_DQUOTE] = ACTIONS(4575),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4575),
    [anon_sym_co_await] = ACTIONS(4573),
    [anon_sym_new] = ACTIONS(4573),
    [anon_sym_requires] = ACTIONS(4573),
    [sym_this] = ACTIONS(4573),
    [anon_sym_discard] = ACTIONS(4573),
    [anon_sym_precise] = ACTIONS(4573),
    [anon_sym_shared] = ACTIONS(4573),
    [anon_sym_groupshared] = ACTIONS(4573),
    [anon_sym_uniform] = ACTIONS(4573),
    [anon_sym_row_major] = ACTIONS(4573),
    [anon_sym_column_major] = ACTIONS(4573),
    [anon_sym_globallycoherent] = ACTIONS(4573),
    [anon_sym_centroid] = ACTIONS(4573),
    [anon_sym_noperspective] = ACTIONS(4573),
    [anon_sym_nointerpolation] = ACTIONS(4573),
    [anon_sym_sample] = ACTIONS(4573),
    [anon_sym_linear] = ACTIONS(4573),
    [anon_sym_snorm] = ACTIONS(4573),
    [anon_sym_unorm] = ACTIONS(4573),
    [anon_sym_point] = ACTIONS(4573),
    [anon_sym_line] = ACTIONS(4573),
    [anon_sym_triangleadj] = ACTIONS(4573),
    [anon_sym_lineadj] = ACTIONS(4573),
    [anon_sym_triangle] = ACTIONS(4573),
    [anon_sym_cbuffer] = ACTIONS(4573),
    [anon_sym_interface] = ACTIONS(4573),
    [anon_sym_extension] = ACTIONS(4573),
  },
  [1198] = {
    [sym_field_declaration_list] = STATE(1315),
    [sym_virtual_specifier] = STATE(8753),
    [sym_base_class_clause] = STATE(9745),
    [sym_identifier] = ACTIONS(2473),
    [anon_sym_LPAREN2] = ACTIONS(2475),
    [anon_sym_BANG] = ACTIONS(2475),
    [anon_sym_TILDE] = ACTIONS(2475),
    [anon_sym_DASH] = ACTIONS(2473),
    [anon_sym_PLUS] = ACTIONS(2473),
    [anon_sym_STAR] = ACTIONS(2475),
    [anon_sym_AMP] = ACTIONS(2475),
    [anon_sym_COLON] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(2475),
    [anon_sym___extension__] = ACTIONS(2473),
    [anon_sym_typedef] = ACTIONS(2473),
    [anon_sym_in] = ACTIONS(2473),
    [anon_sym_out] = ACTIONS(2473),
    [anon_sym_inout] = ACTIONS(2473),
    [anon_sym_extern] = ACTIONS(2473),
    [anon_sym___attribute__] = ACTIONS(2473),
    [anon_sym_COLON_COLON] = ACTIONS(2475),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2475),
    [anon_sym___declspec] = ACTIONS(2473),
    [anon_sym_LBRACE] = ACTIONS(4577),
    [anon_sym_signed] = ACTIONS(2473),
    [anon_sym_unsigned] = ACTIONS(2473),
    [anon_sym_long] = ACTIONS(2473),
    [anon_sym_short] = ACTIONS(2473),
    [anon_sym_LBRACK] = ACTIONS(2473),
    [anon_sym_static] = ACTIONS(2473),
    [anon_sym_register] = ACTIONS(2473),
    [anon_sym_inline] = ACTIONS(2473),
    [anon_sym___inline] = ACTIONS(2473),
    [anon_sym___inline__] = ACTIONS(2473),
    [anon_sym___forceinline] = ACTIONS(2473),
    [anon_sym_thread_local] = ACTIONS(2473),
    [anon_sym___thread] = ACTIONS(2473),
    [anon_sym_const] = ACTIONS(2473),
    [anon_sym_constexpr] = ACTIONS(2473),
    [anon_sym_volatile] = ACTIONS(2473),
    [anon_sym_restrict] = ACTIONS(2473),
    [anon_sym___restrict__] = ACTIONS(2473),
    [anon_sym__Atomic] = ACTIONS(2473),
    [anon_sym__Noreturn] = ACTIONS(2473),
    [anon_sym_noreturn] = ACTIONS(2473),
    [anon_sym_mutable] = ACTIONS(2473),
    [anon_sym_constinit] = ACTIONS(2473),
    [anon_sym_consteval] = ACTIONS(2473),
    [anon_sym_alignas] = ACTIONS(2473),
    [anon_sym__Alignas] = ACTIONS(2473),
    [sym_primitive_type] = ACTIONS(2473),
    [anon_sym_enum] = ACTIONS(2473),
    [anon_sym_class] = ACTIONS(2473),
    [anon_sym_struct] = ACTIONS(2473),
    [anon_sym_union] = ACTIONS(2473),
    [anon_sym_if] = ACTIONS(2473),
    [anon_sym_else] = ACTIONS(2473),
    [anon_sym_switch] = ACTIONS(2473),
    [anon_sym_while] = ACTIONS(2473),
    [anon_sym_do] = ACTIONS(2473),
    [anon_sym_for] = ACTIONS(2473),
    [anon_sym_return] = ACTIONS(2473),
    [anon_sym_break] = ACTIONS(2473),
    [anon_sym_continue] = ACTIONS(2473),
    [anon_sym_goto] = ACTIONS(2473),
    [anon_sym___try] = ACTIONS(2473),
    [anon_sym___leave] = ACTIONS(2473),
    [anon_sym_not] = ACTIONS(2473),
    [anon_sym_compl] = ACTIONS(2473),
    [anon_sym_DASH_DASH] = ACTIONS(2475),
    [anon_sym_PLUS_PLUS] = ACTIONS(2475),
    [anon_sym_sizeof] = ACTIONS(2473),
    [anon_sym___alignof__] = ACTIONS(2473),
    [anon_sym___alignof] = ACTIONS(2473),
    [anon_sym__alignof] = ACTIONS(2473),
    [anon_sym_alignof] = ACTIONS(2473),
    [anon_sym__Alignof] = ACTIONS(2473),
    [anon_sym_offsetof] = ACTIONS(2473),
    [anon_sym__Generic] = ACTIONS(2473),
    [anon_sym_asm] = ACTIONS(2473),
    [anon_sym___asm__] = ACTIONS(2473),
    [sym_number_literal] = ACTIONS(2475),
    [anon_sym_L_SQUOTE] = ACTIONS(2475),
    [anon_sym_u_SQUOTE] = ACTIONS(2475),
    [anon_sym_U_SQUOTE] = ACTIONS(2475),
    [anon_sym_u8_SQUOTE] = ACTIONS(2475),
    [anon_sym_SQUOTE] = ACTIONS(2475),
    [anon_sym_L_DQUOTE] = ACTIONS(2475),
    [anon_sym_u_DQUOTE] = ACTIONS(2475),
    [anon_sym_U_DQUOTE] = ACTIONS(2475),
    [anon_sym_u8_DQUOTE] = ACTIONS(2475),
    [anon_sym_DQUOTE] = ACTIONS(2475),
    [sym_true] = ACTIONS(2473),
    [sym_false] = ACTIONS(2473),
    [anon_sym_NULL] = ACTIONS(2473),
    [anon_sym_nullptr] = ACTIONS(2473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2473),
    [anon_sym_let] = ACTIONS(2473),
    [anon_sym_This] = ACTIONS(2473),
    [anon_sym_decltype] = ACTIONS(2473),
    [anon_sym_final] = ACTIONS(2481),
    [anon_sym_override] = ACTIONS(2481),
    [sym_virtual] = ACTIONS(2473),
    [anon_sym_typename] = ACTIONS(2473),
    [anon_sym_template] = ACTIONS(2473),
    [anon_sym_try] = ACTIONS(2473),
    [anon_sym_delete] = ACTIONS(2473),
    [anon_sym_throw] = ACTIONS(2473),
    [anon_sym_co_return] = ACTIONS(2473),
    [anon_sym_co_yield] = ACTIONS(2473),
    [anon_sym_R_DQUOTE] = ACTIONS(2475),
    [anon_sym_LR_DQUOTE] = ACTIONS(2475),
    [anon_sym_uR_DQUOTE] = ACTIONS(2475),
    [anon_sym_UR_DQUOTE] = ACTIONS(2475),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2475),
    [anon_sym_co_await] = ACTIONS(2473),
    [anon_sym_new] = ACTIONS(2473),
    [anon_sym_requires] = ACTIONS(2473),
    [sym_this] = ACTIONS(2473),
    [anon_sym_discard] = ACTIONS(2473),
    [anon_sym_precise] = ACTIONS(2473),
    [anon_sym_shared] = ACTIONS(2473),
    [anon_sym_groupshared] = ACTIONS(2473),
    [anon_sym_uniform] = ACTIONS(2473),
    [anon_sym_row_major] = ACTIONS(2473),
    [anon_sym_column_major] = ACTIONS(2473),
    [anon_sym_globallycoherent] = ACTIONS(2473),
    [anon_sym_centroid] = ACTIONS(2473),
    [anon_sym_noperspective] = ACTIONS(2473),
    [anon_sym_nointerpolation] = ACTIONS(2473),
    [anon_sym_sample] = ACTIONS(2473),
    [anon_sym_linear] = ACTIONS(2473),
    [anon_sym_snorm] = ACTIONS(2473),
    [anon_sym_unorm] = ACTIONS(2473),
    [anon_sym_point] = ACTIONS(2473),
    [anon_sym_line] = ACTIONS(2473),
    [anon_sym_triangleadj] = ACTIONS(2473),
    [anon_sym_lineadj] = ACTIONS(2473),
    [anon_sym_triangle] = ACTIONS(2473),
    [anon_sym_cbuffer] = ACTIONS(2473),
    [anon_sym_interface] = ACTIONS(2473),
    [anon_sym_extension] = ACTIONS(2473),
  },
  [1199] = {
    [sym_field_declaration_list] = STATE(1300),
    [sym_virtual_specifier] = STATE(8743),
    [sym_base_class_clause] = STATE(9716),
    [sym_identifier] = ACTIONS(2483),
    [anon_sym_LPAREN2] = ACTIONS(2485),
    [anon_sym_BANG] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2483),
    [anon_sym_PLUS] = ACTIONS(2483),
    [anon_sym_STAR] = ACTIONS(2485),
    [anon_sym_AMP] = ACTIONS(2485),
    [anon_sym_COLON] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(2485),
    [anon_sym___extension__] = ACTIONS(2483),
    [anon_sym_typedef] = ACTIONS(2483),
    [anon_sym_in] = ACTIONS(2483),
    [anon_sym_out] = ACTIONS(2483),
    [anon_sym_inout] = ACTIONS(2483),
    [anon_sym_extern] = ACTIONS(2483),
    [anon_sym___attribute__] = ACTIONS(2483),
    [anon_sym_COLON_COLON] = ACTIONS(2485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2485),
    [anon_sym___declspec] = ACTIONS(2483),
    [anon_sym_LBRACE] = ACTIONS(4577),
    [anon_sym_signed] = ACTIONS(2483),
    [anon_sym_unsigned] = ACTIONS(2483),
    [anon_sym_long] = ACTIONS(2483),
    [anon_sym_short] = ACTIONS(2483),
    [anon_sym_LBRACK] = ACTIONS(2483),
    [anon_sym_static] = ACTIONS(2483),
    [anon_sym_register] = ACTIONS(2483),
    [anon_sym_inline] = ACTIONS(2483),
    [anon_sym___inline] = ACTIONS(2483),
    [anon_sym___inline__] = ACTIONS(2483),
    [anon_sym___forceinline] = ACTIONS(2483),
    [anon_sym_thread_local] = ACTIONS(2483),
    [anon_sym___thread] = ACTIONS(2483),
    [anon_sym_const] = ACTIONS(2483),
    [anon_sym_constexpr] = ACTIONS(2483),
    [anon_sym_volatile] = ACTIONS(2483),
    [anon_sym_restrict] = ACTIONS(2483),
    [anon_sym___restrict__] = ACTIONS(2483),
    [anon_sym__Atomic] = ACTIONS(2483),
    [anon_sym__Noreturn] = ACTIONS(2483),
    [anon_sym_noreturn] = ACTIONS(2483),
    [anon_sym_mutable] = ACTIONS(2483),
    [anon_sym_constinit] = ACTIONS(2483),
    [anon_sym_consteval] = ACTIONS(2483),
    [anon_sym_alignas] = ACTIONS(2483),
    [anon_sym__Alignas] = ACTIONS(2483),
    [sym_primitive_type] = ACTIONS(2483),
    [anon_sym_enum] = ACTIONS(2483),
    [anon_sym_class] = ACTIONS(2483),
    [anon_sym_struct] = ACTIONS(2483),
    [anon_sym_union] = ACTIONS(2483),
    [anon_sym_if] = ACTIONS(2483),
    [anon_sym_else] = ACTIONS(2483),
    [anon_sym_switch] = ACTIONS(2483),
    [anon_sym_while] = ACTIONS(2483),
    [anon_sym_do] = ACTIONS(2483),
    [anon_sym_for] = ACTIONS(2483),
    [anon_sym_return] = ACTIONS(2483),
    [anon_sym_break] = ACTIONS(2483),
    [anon_sym_continue] = ACTIONS(2483),
    [anon_sym_goto] = ACTIONS(2483),
    [anon_sym___try] = ACTIONS(2483),
    [anon_sym___leave] = ACTIONS(2483),
    [anon_sym_not] = ACTIONS(2483),
    [anon_sym_compl] = ACTIONS(2483),
    [anon_sym_DASH_DASH] = ACTIONS(2485),
    [anon_sym_PLUS_PLUS] = ACTIONS(2485),
    [anon_sym_sizeof] = ACTIONS(2483),
    [anon_sym___alignof__] = ACTIONS(2483),
    [anon_sym___alignof] = ACTIONS(2483),
    [anon_sym__alignof] = ACTIONS(2483),
    [anon_sym_alignof] = ACTIONS(2483),
    [anon_sym__Alignof] = ACTIONS(2483),
    [anon_sym_offsetof] = ACTIONS(2483),
    [anon_sym__Generic] = ACTIONS(2483),
    [anon_sym_asm] = ACTIONS(2483),
    [anon_sym___asm__] = ACTIONS(2483),
    [sym_number_literal] = ACTIONS(2485),
    [anon_sym_L_SQUOTE] = ACTIONS(2485),
    [anon_sym_u_SQUOTE] = ACTIONS(2485),
    [anon_sym_U_SQUOTE] = ACTIONS(2485),
    [anon_sym_u8_SQUOTE] = ACTIONS(2485),
    [anon_sym_SQUOTE] = ACTIONS(2485),
    [anon_sym_L_DQUOTE] = ACTIONS(2485),
    [anon_sym_u_DQUOTE] = ACTIONS(2485),
    [anon_sym_U_DQUOTE] = ACTIONS(2485),
    [anon_sym_u8_DQUOTE] = ACTIONS(2485),
    [anon_sym_DQUOTE] = ACTIONS(2485),
    [sym_true] = ACTIONS(2483),
    [sym_false] = ACTIONS(2483),
    [anon_sym_NULL] = ACTIONS(2483),
    [anon_sym_nullptr] = ACTIONS(2483),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2483),
    [anon_sym_let] = ACTIONS(2483),
    [anon_sym_This] = ACTIONS(2483),
    [anon_sym_decltype] = ACTIONS(2483),
    [anon_sym_final] = ACTIONS(2481),
    [anon_sym_override] = ACTIONS(2481),
    [sym_virtual] = ACTIONS(2483),
    [anon_sym_typename] = ACTIONS(2483),
    [anon_sym_template] = ACTIONS(2483),
    [anon_sym_try] = ACTIONS(2483),
    [anon_sym_delete] = ACTIONS(2483),
    [anon_sym_throw] = ACTIONS(2483),
    [anon_sym_co_return] = ACTIONS(2483),
    [anon_sym_co_yield] = ACTIONS(2483),
    [anon_sym_R_DQUOTE] = ACTIONS(2485),
    [anon_sym_LR_DQUOTE] = ACTIONS(2485),
    [anon_sym_uR_DQUOTE] = ACTIONS(2485),
    [anon_sym_UR_DQUOTE] = ACTIONS(2485),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2485),
    [anon_sym_co_await] = ACTIONS(2483),
    [anon_sym_new] = ACTIONS(2483),
    [anon_sym_requires] = ACTIONS(2483),
    [sym_this] = ACTIONS(2483),
    [anon_sym_discard] = ACTIONS(2483),
    [anon_sym_precise] = ACTIONS(2483),
    [anon_sym_shared] = ACTIONS(2483),
    [anon_sym_groupshared] = ACTIONS(2483),
    [anon_sym_uniform] = ACTIONS(2483),
    [anon_sym_row_major] = ACTIONS(2483),
    [anon_sym_column_major] = ACTIONS(2483),
    [anon_sym_globallycoherent] = ACTIONS(2483),
    [anon_sym_centroid] = ACTIONS(2483),
    [anon_sym_noperspective] = ACTIONS(2483),
    [anon_sym_nointerpolation] = ACTIONS(2483),
    [anon_sym_sample] = ACTIONS(2483),
    [anon_sym_linear] = ACTIONS(2483),
    [anon_sym_snorm] = ACTIONS(2483),
    [anon_sym_unorm] = ACTIONS(2483),
    [anon_sym_point] = ACTIONS(2483),
    [anon_sym_line] = ACTIONS(2483),
    [anon_sym_triangleadj] = ACTIONS(2483),
    [anon_sym_lineadj] = ACTIONS(2483),
    [anon_sym_triangle] = ACTIONS(2483),
    [anon_sym_cbuffer] = ACTIONS(2483),
    [anon_sym_interface] = ACTIONS(2483),
    [anon_sym_extension] = ACTIONS(2483),
  },
  [1200] = {
    [sym_template_argument_list] = STATE(1246),
    [sym_identifier] = ACTIONS(2169),
    [anon_sym_LPAREN2] = ACTIONS(2176),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2169),
    [anon_sym_PLUS] = ACTIONS(2169),
    [anon_sym_STAR] = ACTIONS(2176),
    [anon_sym_AMP] = ACTIONS(2176),
    [anon_sym_LT] = ACTIONS(4579),
    [anon_sym_COLON] = ACTIONS(2169),
    [anon_sym_SEMI] = ACTIONS(2176),
    [anon_sym___extension__] = ACTIONS(2169),
    [anon_sym_typedef] = ACTIONS(2169),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_out] = ACTIONS(2169),
    [anon_sym_inout] = ACTIONS(2169),
    [anon_sym_extern] = ACTIONS(2169),
    [anon_sym___attribute__] = ACTIONS(2169),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2176),
    [anon_sym___declspec] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2176),
    [anon_sym_signed] = ACTIONS(2169),
    [anon_sym_unsigned] = ACTIONS(2169),
    [anon_sym_long] = ACTIONS(2169),
    [anon_sym_short] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(2169),
    [anon_sym_static] = ACTIONS(2169),
    [anon_sym_register] = ACTIONS(2169),
    [anon_sym_inline] = ACTIONS(2169),
    [anon_sym___inline] = ACTIONS(2169),
    [anon_sym___inline__] = ACTIONS(2169),
    [anon_sym___forceinline] = ACTIONS(2169),
    [anon_sym_thread_local] = ACTIONS(2169),
    [anon_sym___thread] = ACTIONS(2169),
    [anon_sym_const] = ACTIONS(2169),
    [anon_sym_constexpr] = ACTIONS(2169),
    [anon_sym_volatile] = ACTIONS(2169),
    [anon_sym_restrict] = ACTIONS(2169),
    [anon_sym___restrict__] = ACTIONS(2169),
    [anon_sym__Atomic] = ACTIONS(2169),
    [anon_sym__Noreturn] = ACTIONS(2169),
    [anon_sym_noreturn] = ACTIONS(2169),
    [anon_sym_mutable] = ACTIONS(2169),
    [anon_sym_constinit] = ACTIONS(2169),
    [anon_sym_consteval] = ACTIONS(2169),
    [anon_sym_alignas] = ACTIONS(2169),
    [anon_sym__Alignas] = ACTIONS(2169),
    [sym_primitive_type] = ACTIONS(2169),
    [anon_sym_enum] = ACTIONS(2169),
    [anon_sym_class] = ACTIONS(2169),
    [anon_sym_struct] = ACTIONS(2169),
    [anon_sym_union] = ACTIONS(2169),
    [anon_sym_if] = ACTIONS(2169),
    [anon_sym_else] = ACTIONS(2169),
    [anon_sym_switch] = ACTIONS(2169),
    [anon_sym_while] = ACTIONS(2169),
    [anon_sym_do] = ACTIONS(2169),
    [anon_sym_for] = ACTIONS(2169),
    [anon_sym_return] = ACTIONS(2169),
    [anon_sym_break] = ACTIONS(2169),
    [anon_sym_continue] = ACTIONS(2169),
    [anon_sym_goto] = ACTIONS(2169),
    [anon_sym___try] = ACTIONS(2169),
    [anon_sym___leave] = ACTIONS(2169),
    [anon_sym_not] = ACTIONS(2169),
    [anon_sym_compl] = ACTIONS(2169),
    [anon_sym_DASH_DASH] = ACTIONS(2176),
    [anon_sym_PLUS_PLUS] = ACTIONS(2176),
    [anon_sym_sizeof] = ACTIONS(2169),
    [anon_sym___alignof__] = ACTIONS(2169),
    [anon_sym___alignof] = ACTIONS(2169),
    [anon_sym__alignof] = ACTIONS(2169),
    [anon_sym_alignof] = ACTIONS(2169),
    [anon_sym__Alignof] = ACTIONS(2169),
    [anon_sym_offsetof] = ACTIONS(2169),
    [anon_sym__Generic] = ACTIONS(2169),
    [anon_sym_asm] = ACTIONS(2169),
    [anon_sym___asm__] = ACTIONS(2169),
    [sym_number_literal] = ACTIONS(2176),
    [anon_sym_L_SQUOTE] = ACTIONS(2176),
    [anon_sym_u_SQUOTE] = ACTIONS(2176),
    [anon_sym_U_SQUOTE] = ACTIONS(2176),
    [anon_sym_u8_SQUOTE] = ACTIONS(2176),
    [anon_sym_SQUOTE] = ACTIONS(2176),
    [anon_sym_L_DQUOTE] = ACTIONS(2176),
    [anon_sym_u_DQUOTE] = ACTIONS(2176),
    [anon_sym_U_DQUOTE] = ACTIONS(2176),
    [anon_sym_u8_DQUOTE] = ACTIONS(2176),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [sym_true] = ACTIONS(2169),
    [sym_false] = ACTIONS(2169),
    [anon_sym_NULL] = ACTIONS(2169),
    [anon_sym_nullptr] = ACTIONS(2169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2169),
    [anon_sym_let] = ACTIONS(2169),
    [anon_sym_This] = ACTIONS(2169),
    [anon_sym_decltype] = ACTIONS(2169),
    [anon_sym_final] = ACTIONS(2169),
    [anon_sym_override] = ACTIONS(2169),
    [sym_virtual] = ACTIONS(2169),
    [anon_sym_typename] = ACTIONS(2169),
    [anon_sym_template] = ACTIONS(2169),
    [anon_sym_try] = ACTIONS(2169),
    [anon_sym_delete] = ACTIONS(2169),
    [anon_sym_throw] = ACTIONS(2169),
    [anon_sym_co_return] = ACTIONS(2169),
    [anon_sym_co_yield] = ACTIONS(2169),
    [anon_sym_R_DQUOTE] = ACTIONS(2176),
    [anon_sym_LR_DQUOTE] = ACTIONS(2176),
    [anon_sym_uR_DQUOTE] = ACTIONS(2176),
    [anon_sym_UR_DQUOTE] = ACTIONS(2176),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2176),
    [anon_sym_co_await] = ACTIONS(2169),
    [anon_sym_new] = ACTIONS(2169),
    [anon_sym_requires] = ACTIONS(2169),
    [sym_this] = ACTIONS(2169),
    [anon_sym_discard] = ACTIONS(2169),
    [anon_sym_precise] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_groupshared] = ACTIONS(2169),
    [anon_sym_uniform] = ACTIONS(2169),
    [anon_sym_row_major] = ACTIONS(2169),
    [anon_sym_column_major] = ACTIONS(2169),
    [anon_sym_globallycoherent] = ACTIONS(2169),
    [anon_sym_centroid] = ACTIONS(2169),
    [anon_sym_noperspective] = ACTIONS(2169),
    [anon_sym_nointerpolation] = ACTIONS(2169),
    [anon_sym_sample] = ACTIONS(2169),
    [anon_sym_linear] = ACTIONS(2169),
    [anon_sym_snorm] = ACTIONS(2169),
    [anon_sym_unorm] = ACTIONS(2169),
    [anon_sym_point] = ACTIONS(2169),
    [anon_sym_line] = ACTIONS(2169),
    [anon_sym_triangleadj] = ACTIONS(2169),
    [anon_sym_lineadj] = ACTIONS(2169),
    [anon_sym_triangle] = ACTIONS(2169),
    [anon_sym_cbuffer] = ACTIONS(2169),
    [anon_sym_interface] = ACTIONS(2169),
    [anon_sym_extension] = ACTIONS(2169),
  },
  [1201] = {
    [sym_expression] = STATE(3749),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_initializer_list] = STATE(4375),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4410),
    [anon_sym_COMMA] = ACTIONS(4410),
    [anon_sym_RPAREN] = ACTIONS(4410),
    [anon_sym_LPAREN2] = ACTIONS(4410),
    [anon_sym_BANG] = ACTIONS(2756),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(4408),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_STAR] = ACTIONS(4408),
    [anon_sym_SLASH] = ACTIONS(4408),
    [anon_sym_PERCENT] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4408),
    [anon_sym_GT_EQ] = ACTIONS(4410),
    [anon_sym_LT_EQ] = ACTIONS(4408),
    [anon_sym_LT] = ACTIONS(4408),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4410),
    [anon_sym_EQ] = ACTIONS(4408),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_QMARK] = ACTIONS(4410),
    [anon_sym_STAR_EQ] = ACTIONS(4410),
    [anon_sym_SLASH_EQ] = ACTIONS(4410),
    [anon_sym_PERCENT_EQ] = ACTIONS(4410),
    [anon_sym_PLUS_EQ] = ACTIONS(4410),
    [anon_sym_DASH_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_GT_EQ] = ACTIONS(4410),
    [anon_sym_AMP_EQ] = ACTIONS(4410),
    [anon_sym_CARET_EQ] = ACTIONS(4410),
    [anon_sym_PIPE_EQ] = ACTIONS(4410),
    [anon_sym_and_eq] = ACTIONS(4408),
    [anon_sym_or_eq] = ACTIONS(4408),
    [anon_sym_xor_eq] = ACTIONS(4408),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_LT_EQ_GT] = ACTIONS(4410),
    [anon_sym_or] = ACTIONS(4408),
    [anon_sym_and] = ACTIONS(4408),
    [anon_sym_bitor] = ACTIONS(4408),
    [anon_sym_xor] = ACTIONS(4408),
    [anon_sym_bitand] = ACTIONS(4408),
    [anon_sym_not_eq] = ACTIONS(4408),
    [anon_sym_is] = ACTIONS(4408),
    [anon_sym_as] = ACTIONS(4408),
    [anon_sym_DASH_DASH] = ACTIONS(4410),
    [anon_sym_PLUS_PLUS] = ACTIONS(4410),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [anon_sym_DOT] = ACTIONS(4408),
    [anon_sym_DOT_STAR] = ACTIONS(4410),
    [anon_sym_DASH_GT] = ACTIONS(4408),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4410),
    [sym_this] = ACTIONS(2798),
  },
  [1202] = {
    [sym_template_argument_list] = STATE(1246),
    [sym_identifier] = ACTIONS(2349),
    [anon_sym_LPAREN2] = ACTIONS(2347),
    [anon_sym_BANG] = ACTIONS(2347),
    [anon_sym_TILDE] = ACTIONS(2347),
    [anon_sym_DASH] = ACTIONS(2349),
    [anon_sym_PLUS] = ACTIONS(2349),
    [anon_sym_STAR] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(4579),
    [anon_sym_COLON] = ACTIONS(2349),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym___extension__] = ACTIONS(2349),
    [anon_sym_typedef] = ACTIONS(2349),
    [anon_sym_in] = ACTIONS(2349),
    [anon_sym_out] = ACTIONS(2349),
    [anon_sym_inout] = ACTIONS(2349),
    [anon_sym_extern] = ACTIONS(2349),
    [anon_sym___attribute__] = ACTIONS(2349),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2347),
    [anon_sym___declspec] = ACTIONS(2349),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_signed] = ACTIONS(2349),
    [anon_sym_unsigned] = ACTIONS(2349),
    [anon_sym_long] = ACTIONS(2349),
    [anon_sym_short] = ACTIONS(2349),
    [anon_sym_LBRACK] = ACTIONS(2349),
    [anon_sym_static] = ACTIONS(2349),
    [anon_sym_register] = ACTIONS(2349),
    [anon_sym_inline] = ACTIONS(2349),
    [anon_sym___inline] = ACTIONS(2349),
    [anon_sym___inline__] = ACTIONS(2349),
    [anon_sym___forceinline] = ACTIONS(2349),
    [anon_sym_thread_local] = ACTIONS(2349),
    [anon_sym___thread] = ACTIONS(2349),
    [anon_sym_const] = ACTIONS(2349),
    [anon_sym_constexpr] = ACTIONS(2349),
    [anon_sym_volatile] = ACTIONS(2349),
    [anon_sym_restrict] = ACTIONS(2349),
    [anon_sym___restrict__] = ACTIONS(2349),
    [anon_sym__Atomic] = ACTIONS(2349),
    [anon_sym__Noreturn] = ACTIONS(2349),
    [anon_sym_noreturn] = ACTIONS(2349),
    [anon_sym_mutable] = ACTIONS(2349),
    [anon_sym_constinit] = ACTIONS(2349),
    [anon_sym_consteval] = ACTIONS(2349),
    [anon_sym_alignas] = ACTIONS(2349),
    [anon_sym__Alignas] = ACTIONS(2349),
    [sym_primitive_type] = ACTIONS(2349),
    [anon_sym_enum] = ACTIONS(2349),
    [anon_sym_class] = ACTIONS(2349),
    [anon_sym_struct] = ACTIONS(2349),
    [anon_sym_union] = ACTIONS(2349),
    [anon_sym_if] = ACTIONS(2349),
    [anon_sym_else] = ACTIONS(2349),
    [anon_sym_switch] = ACTIONS(2349),
    [anon_sym_while] = ACTIONS(2349),
    [anon_sym_do] = ACTIONS(2349),
    [anon_sym_for] = ACTIONS(2349),
    [anon_sym_return] = ACTIONS(2349),
    [anon_sym_break] = ACTIONS(2349),
    [anon_sym_continue] = ACTIONS(2349),
    [anon_sym_goto] = ACTIONS(2349),
    [anon_sym___try] = ACTIONS(2349),
    [anon_sym___leave] = ACTIONS(2349),
    [anon_sym_not] = ACTIONS(2349),
    [anon_sym_compl] = ACTIONS(2349),
    [anon_sym_DASH_DASH] = ACTIONS(2347),
    [anon_sym_PLUS_PLUS] = ACTIONS(2347),
    [anon_sym_sizeof] = ACTIONS(2349),
    [anon_sym___alignof__] = ACTIONS(2349),
    [anon_sym___alignof] = ACTIONS(2349),
    [anon_sym__alignof] = ACTIONS(2349),
    [anon_sym_alignof] = ACTIONS(2349),
    [anon_sym__Alignof] = ACTIONS(2349),
    [anon_sym_offsetof] = ACTIONS(2349),
    [anon_sym__Generic] = ACTIONS(2349),
    [anon_sym_asm] = ACTIONS(2349),
    [anon_sym___asm__] = ACTIONS(2349),
    [sym_number_literal] = ACTIONS(2347),
    [anon_sym_L_SQUOTE] = ACTIONS(2347),
    [anon_sym_u_SQUOTE] = ACTIONS(2347),
    [anon_sym_U_SQUOTE] = ACTIONS(2347),
    [anon_sym_u8_SQUOTE] = ACTIONS(2347),
    [anon_sym_SQUOTE] = ACTIONS(2347),
    [anon_sym_L_DQUOTE] = ACTIONS(2347),
    [anon_sym_u_DQUOTE] = ACTIONS(2347),
    [anon_sym_U_DQUOTE] = ACTIONS(2347),
    [anon_sym_u8_DQUOTE] = ACTIONS(2347),
    [anon_sym_DQUOTE] = ACTIONS(2347),
    [sym_true] = ACTIONS(2349),
    [sym_false] = ACTIONS(2349),
    [anon_sym_NULL] = ACTIONS(2349),
    [anon_sym_nullptr] = ACTIONS(2349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2349),
    [anon_sym_let] = ACTIONS(2349),
    [anon_sym_This] = ACTIONS(2349),
    [anon_sym_decltype] = ACTIONS(2349),
    [anon_sym_final] = ACTIONS(2349),
    [anon_sym_override] = ACTIONS(2349),
    [sym_virtual] = ACTIONS(2349),
    [anon_sym_typename] = ACTIONS(2349),
    [anon_sym_template] = ACTIONS(2349),
    [anon_sym_try] = ACTIONS(2349),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_throw] = ACTIONS(2349),
    [anon_sym_co_return] = ACTIONS(2349),
    [anon_sym_co_yield] = ACTIONS(2349),
    [anon_sym_R_DQUOTE] = ACTIONS(2347),
    [anon_sym_LR_DQUOTE] = ACTIONS(2347),
    [anon_sym_uR_DQUOTE] = ACTIONS(2347),
    [anon_sym_UR_DQUOTE] = ACTIONS(2347),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2347),
    [anon_sym_co_await] = ACTIONS(2349),
    [anon_sym_new] = ACTIONS(2349),
    [anon_sym_requires] = ACTIONS(2349),
    [sym_this] = ACTIONS(2349),
    [anon_sym_discard] = ACTIONS(2349),
    [anon_sym_precise] = ACTIONS(2349),
    [anon_sym_shared] = ACTIONS(2349),
    [anon_sym_groupshared] = ACTIONS(2349),
    [anon_sym_uniform] = ACTIONS(2349),
    [anon_sym_row_major] = ACTIONS(2349),
    [anon_sym_column_major] = ACTIONS(2349),
    [anon_sym_globallycoherent] = ACTIONS(2349),
    [anon_sym_centroid] = ACTIONS(2349),
    [anon_sym_noperspective] = ACTIONS(2349),
    [anon_sym_nointerpolation] = ACTIONS(2349),
    [anon_sym_sample] = ACTIONS(2349),
    [anon_sym_linear] = ACTIONS(2349),
    [anon_sym_snorm] = ACTIONS(2349),
    [anon_sym_unorm] = ACTIONS(2349),
    [anon_sym_point] = ACTIONS(2349),
    [anon_sym_line] = ACTIONS(2349),
    [anon_sym_triangleadj] = ACTIONS(2349),
    [anon_sym_lineadj] = ACTIONS(2349),
    [anon_sym_triangle] = ACTIONS(2349),
    [anon_sym_cbuffer] = ACTIONS(2349),
    [anon_sym_interface] = ACTIONS(2349),
    [anon_sym_extension] = ACTIONS(2349),
  },
  [1203] = {
    [sym_expression] = STATE(3205),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_initializer_list] = STATE(3277),
    [sym_char_literal] = STATE(4134),
    [sym_concatenated_string] = STATE(4159),
    [sym_string_literal] = STATE(3152),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(3145),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4410),
    [anon_sym_COMMA] = ACTIONS(4410),
    [anon_sym_LPAREN2] = ACTIONS(4410),
    [anon_sym_BANG] = ACTIONS(4589),
    [anon_sym_TILDE] = ACTIONS(4591),
    [anon_sym_DASH] = ACTIONS(4408),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_STAR] = ACTIONS(4408),
    [anon_sym_SLASH] = ACTIONS(4408),
    [anon_sym_PERCENT] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4408),
    [anon_sym_GT_EQ] = ACTIONS(4410),
    [anon_sym_LT_EQ] = ACTIONS(4408),
    [anon_sym_LT] = ACTIONS(4408),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_SEMI] = ACTIONS(4410),
    [anon_sym___attribute__] = ACTIONS(4408),
    [anon_sym_COLON_COLON] = ACTIONS(4593),
    [anon_sym_LBRACE] = ACTIONS(4418),
    [anon_sym_LBRACK] = ACTIONS(4410),
    [anon_sym_EQ] = ACTIONS(4408),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_QMARK] = ACTIONS(4410),
    [anon_sym_STAR_EQ] = ACTIONS(4410),
    [anon_sym_SLASH_EQ] = ACTIONS(4410),
    [anon_sym_PERCENT_EQ] = ACTIONS(4410),
    [anon_sym_PLUS_EQ] = ACTIONS(4410),
    [anon_sym_DASH_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_GT_EQ] = ACTIONS(4410),
    [anon_sym_AMP_EQ] = ACTIONS(4410),
    [anon_sym_CARET_EQ] = ACTIONS(4410),
    [anon_sym_PIPE_EQ] = ACTIONS(4410),
    [anon_sym_and_eq] = ACTIONS(4408),
    [anon_sym_or_eq] = ACTIONS(4408),
    [anon_sym_xor_eq] = ACTIONS(4408),
    [anon_sym_not] = ACTIONS(4589),
    [anon_sym_compl] = ACTIONS(4589),
    [anon_sym_LT_EQ_GT] = ACTIONS(4410),
    [anon_sym_or] = ACTIONS(4408),
    [anon_sym_and] = ACTIONS(4408),
    [anon_sym_bitor] = ACTIONS(4408),
    [anon_sym_xor] = ACTIONS(4408),
    [anon_sym_bitand] = ACTIONS(4408),
    [anon_sym_not_eq] = ACTIONS(4408),
    [anon_sym_is] = ACTIONS(4408),
    [anon_sym_as] = ACTIONS(4408),
    [anon_sym_DASH_DASH] = ACTIONS(4410),
    [anon_sym_PLUS_PLUS] = ACTIONS(4410),
    [anon_sym_sizeof] = ACTIONS(4595),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [anon_sym_DOT] = ACTIONS(4408),
    [anon_sym_DOT_STAR] = ACTIONS(4410),
    [anon_sym_DASH_GT] = ACTIONS(4410),
    [sym_number_literal] = ACTIONS(4597),
    [anon_sym_L_SQUOTE] = ACTIONS(4599),
    [anon_sym_u_SQUOTE] = ACTIONS(4599),
    [anon_sym_U_SQUOTE] = ACTIONS(4599),
    [anon_sym_u8_SQUOTE] = ACTIONS(4599),
    [anon_sym_SQUOTE] = ACTIONS(4599),
    [anon_sym_L_DQUOTE] = ACTIONS(4601),
    [anon_sym_u_DQUOTE] = ACTIONS(4601),
    [anon_sym_U_DQUOTE] = ACTIONS(4601),
    [anon_sym_u8_DQUOTE] = ACTIONS(4601),
    [anon_sym_DQUOTE] = ACTIONS(4601),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4603),
    [anon_sym_R_DQUOTE] = ACTIONS(4605),
    [anon_sym_LR_DQUOTE] = ACTIONS(4605),
    [anon_sym_uR_DQUOTE] = ACTIONS(4605),
    [anon_sym_UR_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4605),
    [anon_sym_co_await] = ACTIONS(4607),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1204] = {
    [sym_expression] = STATE(3852),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_initializer_list] = STATE(3277),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4410),
    [anon_sym_COMMA] = ACTIONS(4410),
    [anon_sym_LPAREN2] = ACTIONS(4410),
    [anon_sym_BANG] = ACTIONS(4609),
    [anon_sym_TILDE] = ACTIONS(4611),
    [anon_sym_DASH] = ACTIONS(4408),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_STAR] = ACTIONS(4408),
    [anon_sym_SLASH] = ACTIONS(4408),
    [anon_sym_PERCENT] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4408),
    [anon_sym_GT_EQ] = ACTIONS(4410),
    [anon_sym_LT_EQ] = ACTIONS(4408),
    [anon_sym_LT] = ACTIONS(4408),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_COLON] = ACTIONS(4408),
    [anon_sym_COLON_COLON] = ACTIONS(4613),
    [anon_sym_LBRACE] = ACTIONS(4418),
    [anon_sym_LBRACK] = ACTIONS(4410),
    [anon_sym_EQ] = ACTIONS(4408),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_QMARK] = ACTIONS(4410),
    [anon_sym_STAR_EQ] = ACTIONS(4410),
    [anon_sym_SLASH_EQ] = ACTIONS(4410),
    [anon_sym_PERCENT_EQ] = ACTIONS(4410),
    [anon_sym_PLUS_EQ] = ACTIONS(4410),
    [anon_sym_DASH_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_GT_EQ] = ACTIONS(4410),
    [anon_sym_AMP_EQ] = ACTIONS(4410),
    [anon_sym_CARET_EQ] = ACTIONS(4410),
    [anon_sym_PIPE_EQ] = ACTIONS(4410),
    [anon_sym_and_eq] = ACTIONS(4408),
    [anon_sym_or_eq] = ACTIONS(4408),
    [anon_sym_xor_eq] = ACTIONS(4408),
    [anon_sym_not] = ACTIONS(4609),
    [anon_sym_compl] = ACTIONS(4609),
    [anon_sym_LT_EQ_GT] = ACTIONS(4410),
    [anon_sym_or] = ACTIONS(4408),
    [anon_sym_and] = ACTIONS(4408),
    [anon_sym_bitor] = ACTIONS(4408),
    [anon_sym_xor] = ACTIONS(4408),
    [anon_sym_bitand] = ACTIONS(4408),
    [anon_sym_not_eq] = ACTIONS(4408),
    [anon_sym_is] = ACTIONS(4408),
    [anon_sym_as] = ACTIONS(4408),
    [anon_sym_DASH_DASH] = ACTIONS(4410),
    [anon_sym_PLUS_PLUS] = ACTIONS(4410),
    [anon_sym_sizeof] = ACTIONS(4615),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [anon_sym_DOT] = ACTIONS(4408),
    [anon_sym_DOT_STAR] = ACTIONS(4410),
    [anon_sym_DASH_GT] = ACTIONS(4410),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4617),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4619),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1205] = {
    [sym_type_qualifier] = STATE(4248),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(4960),
    [sym_sized_type_specifier] = STATE(5826),
    [sym_enum_specifier] = STATE(5826),
    [sym_struct_specifier] = STATE(5826),
    [sym_union_specifier] = STATE(5826),
    [sym_expression] = STATE(5302),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_type_descriptor] = STATE(8232),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_placeholder_type_specifier] = STATE(5826),
    [sym_decltype] = STATE(5647),
    [sym_class_specifier] = STATE(5826),
    [sym__class_name] = STATE(9946),
    [sym_dependent_type] = STATE(5826),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_type_parameter_pack_expansion] = STATE(9256),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6860),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4414),
    [sym_interface_specifier] = STATE(5826),
    [sym_extension_specifier] = STATE(5826),
    [sym_associatedtype_specifier] = STATE(5826),
    [aux_sym__type_definition_type_repeat1] = STATE(4248),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4903),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_signed] = ACTIONS(4633),
    [anon_sym_unsigned] = ACTIONS(4633),
    [anon_sym_long] = ACTIONS(4633),
    [anon_sym_short] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4635),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_class] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4641),
    [anon_sym_union] = ACTIONS(4643),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4667),
    [anon_sym_let] = ACTIONS(4669),
    [anon_sym_This] = ACTIONS(4667),
    [anon_sym_decltype] = ACTIONS(4671),
    [anon_sym_typename] = ACTIONS(4673),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(4675),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
    [anon_sym_interface] = ACTIONS(4687),
    [anon_sym_extension] = ACTIONS(4689),
  },
  [1206] = {
    [sym_type_qualifier] = STATE(4248),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(4960),
    [sym_sized_type_specifier] = STATE(5826),
    [sym_enum_specifier] = STATE(5826),
    [sym_struct_specifier] = STATE(5826),
    [sym_union_specifier] = STATE(5826),
    [sym_expression] = STATE(5298),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_type_descriptor] = STATE(8253),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_placeholder_type_specifier] = STATE(5826),
    [sym_decltype] = STATE(5647),
    [sym_class_specifier] = STATE(5826),
    [sym__class_name] = STATE(9946),
    [sym_dependent_type] = STATE(5826),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_type_parameter_pack_expansion] = STATE(9591),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6860),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4414),
    [sym_interface_specifier] = STATE(5826),
    [sym_extension_specifier] = STATE(5826),
    [sym_associatedtype_specifier] = STATE(5826),
    [aux_sym__type_definition_type_repeat1] = STATE(4248),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4903),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_signed] = ACTIONS(4633),
    [anon_sym_unsigned] = ACTIONS(4633),
    [anon_sym_long] = ACTIONS(4633),
    [anon_sym_short] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4635),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_class] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4641),
    [anon_sym_union] = ACTIONS(4643),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4667),
    [anon_sym_let] = ACTIONS(4691),
    [anon_sym_This] = ACTIONS(4667),
    [anon_sym_decltype] = ACTIONS(4671),
    [anon_sym_typename] = ACTIONS(4673),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(4693),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
    [anon_sym_interface] = ACTIONS(4687),
    [anon_sym_extension] = ACTIONS(4689),
  },
  [1207] = {
    [sym_type_qualifier] = STATE(4248),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(4960),
    [sym_sized_type_specifier] = STATE(5826),
    [sym_enum_specifier] = STATE(5826),
    [sym_struct_specifier] = STATE(5826),
    [sym_union_specifier] = STATE(5826),
    [sym_expression] = STATE(5138),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_type_descriptor] = STATE(8273),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_placeholder_type_specifier] = STATE(5826),
    [sym_decltype] = STATE(5647),
    [sym_class_specifier] = STATE(5826),
    [sym__class_name] = STATE(9946),
    [sym_dependent_type] = STATE(5826),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_type_parameter_pack_expansion] = STATE(9338),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6860),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4414),
    [sym_interface_specifier] = STATE(5826),
    [sym_extension_specifier] = STATE(5826),
    [sym_associatedtype_specifier] = STATE(5826),
    [aux_sym__type_definition_type_repeat1] = STATE(4248),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4903),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_signed] = ACTIONS(4633),
    [anon_sym_unsigned] = ACTIONS(4633),
    [anon_sym_long] = ACTIONS(4633),
    [anon_sym_short] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4635),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_class] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4641),
    [anon_sym_union] = ACTIONS(4643),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4667),
    [anon_sym_let] = ACTIONS(4695),
    [anon_sym_This] = ACTIONS(4667),
    [anon_sym_decltype] = ACTIONS(4671),
    [anon_sym_typename] = ACTIONS(4673),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(4697),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
    [anon_sym_interface] = ACTIONS(4687),
    [anon_sym_extension] = ACTIONS(4689),
  },
  [1208] = {
    [sym_type_qualifier] = STATE(4248),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(4960),
    [sym_sized_type_specifier] = STATE(5826),
    [sym_enum_specifier] = STATE(5826),
    [sym_struct_specifier] = STATE(5826),
    [sym_union_specifier] = STATE(5826),
    [sym_expression] = STATE(5205),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_type_descriptor] = STATE(8298),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_placeholder_type_specifier] = STATE(5826),
    [sym_decltype] = STATE(5647),
    [sym_class_specifier] = STATE(5826),
    [sym__class_name] = STATE(9946),
    [sym_dependent_type] = STATE(5826),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_type_parameter_pack_expansion] = STATE(9569),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6860),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4414),
    [sym_interface_specifier] = STATE(5826),
    [sym_extension_specifier] = STATE(5826),
    [sym_associatedtype_specifier] = STATE(5826),
    [aux_sym__type_definition_type_repeat1] = STATE(4248),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4903),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_signed] = ACTIONS(4633),
    [anon_sym_unsigned] = ACTIONS(4633),
    [anon_sym_long] = ACTIONS(4633),
    [anon_sym_short] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4635),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_class] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4641),
    [anon_sym_union] = ACTIONS(4643),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4667),
    [anon_sym_let] = ACTIONS(4699),
    [anon_sym_This] = ACTIONS(4667),
    [anon_sym_decltype] = ACTIONS(4671),
    [anon_sym_typename] = ACTIONS(4673),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(4701),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
    [anon_sym_interface] = ACTIONS(4687),
    [anon_sym_extension] = ACTIONS(4689),
  },
  [1209] = {
    [sym_identifier] = ACTIONS(4703),
    [anon_sym_LPAREN2] = ACTIONS(4706),
    [anon_sym_BANG] = ACTIONS(4709),
    [anon_sym_TILDE] = ACTIONS(4706),
    [anon_sym_DASH] = ACTIONS(4711),
    [anon_sym_PLUS] = ACTIONS(4711),
    [anon_sym_STAR] = ACTIONS(4706),
    [anon_sym_AMP_AMP] = ACTIONS(4713),
    [anon_sym_AMP] = ACTIONS(4703),
    [anon_sym_SEMI] = ACTIONS(4709),
    [anon_sym___extension__] = ACTIONS(4715),
    [anon_sym_in] = ACTIONS(4715),
    [anon_sym_out] = ACTIONS(4715),
    [anon_sym_inout] = ACTIONS(4715),
    [anon_sym_extern] = ACTIONS(4715),
    [anon_sym___attribute__] = ACTIONS(4715),
    [anon_sym_COLON_COLON] = ACTIONS(4706),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4706),
    [anon_sym___declspec] = ACTIONS(4715),
    [anon_sym___based] = ACTIONS(4715),
    [anon_sym_LBRACE] = ACTIONS(4709),
    [anon_sym_signed] = ACTIONS(4715),
    [anon_sym_unsigned] = ACTIONS(4715),
    [anon_sym_long] = ACTIONS(4715),
    [anon_sym_short] = ACTIONS(4715),
    [anon_sym_LBRACK] = ACTIONS(4703),
    [anon_sym_static] = ACTIONS(4715),
    [anon_sym_register] = ACTIONS(4715),
    [anon_sym_inline] = ACTIONS(4715),
    [anon_sym___inline] = ACTIONS(4715),
    [anon_sym___inline__] = ACTIONS(4715),
    [anon_sym___forceinline] = ACTIONS(4715),
    [anon_sym_thread_local] = ACTIONS(4715),
    [anon_sym___thread] = ACTIONS(4715),
    [anon_sym_const] = ACTIONS(4715),
    [anon_sym_constexpr] = ACTIONS(4715),
    [anon_sym_volatile] = ACTIONS(4715),
    [anon_sym_restrict] = ACTIONS(4715),
    [anon_sym___restrict__] = ACTIONS(4715),
    [anon_sym__Atomic] = ACTIONS(4715),
    [anon_sym__Noreturn] = ACTIONS(4715),
    [anon_sym_noreturn] = ACTIONS(4715),
    [anon_sym_mutable] = ACTIONS(4715),
    [anon_sym_constinit] = ACTIONS(4715),
    [anon_sym_consteval] = ACTIONS(4715),
    [anon_sym_alignas] = ACTIONS(4715),
    [anon_sym__Alignas] = ACTIONS(4715),
    [sym_primitive_type] = ACTIONS(4703),
    [anon_sym_enum] = ACTIONS(4715),
    [anon_sym_class] = ACTIONS(4715),
    [anon_sym_struct] = ACTIONS(4715),
    [anon_sym_union] = ACTIONS(4715),
    [anon_sym_if] = ACTIONS(4711),
    [anon_sym_switch] = ACTIONS(4711),
    [anon_sym_case] = ACTIONS(4711),
    [anon_sym_default] = ACTIONS(4711),
    [anon_sym_while] = ACTIONS(4711),
    [anon_sym_do] = ACTIONS(4711),
    [anon_sym_for] = ACTIONS(4711),
    [anon_sym_return] = ACTIONS(4711),
    [anon_sym_break] = ACTIONS(4711),
    [anon_sym_continue] = ACTIONS(4711),
    [anon_sym_goto] = ACTIONS(4711),
    [anon_sym___try] = ACTIONS(4711),
    [anon_sym___leave] = ACTIONS(4711),
    [anon_sym_not] = ACTIONS(4711),
    [anon_sym_compl] = ACTIONS(4711),
    [anon_sym_DASH_DASH] = ACTIONS(4709),
    [anon_sym_PLUS_PLUS] = ACTIONS(4709),
    [anon_sym_sizeof] = ACTIONS(4711),
    [anon_sym___alignof__] = ACTIONS(4711),
    [anon_sym___alignof] = ACTIONS(4711),
    [anon_sym__alignof] = ACTIONS(4711),
    [anon_sym_alignof] = ACTIONS(4711),
    [anon_sym__Alignof] = ACTIONS(4711),
    [anon_sym_offsetof] = ACTIONS(4711),
    [anon_sym__Generic] = ACTIONS(4711),
    [anon_sym_asm] = ACTIONS(4711),
    [anon_sym___asm__] = ACTIONS(4711),
    [sym_number_literal] = ACTIONS(4709),
    [anon_sym_L_SQUOTE] = ACTIONS(4709),
    [anon_sym_u_SQUOTE] = ACTIONS(4709),
    [anon_sym_U_SQUOTE] = ACTIONS(4709),
    [anon_sym_u8_SQUOTE] = ACTIONS(4709),
    [anon_sym_SQUOTE] = ACTIONS(4709),
    [anon_sym_L_DQUOTE] = ACTIONS(4709),
    [anon_sym_u_DQUOTE] = ACTIONS(4709),
    [anon_sym_U_DQUOTE] = ACTIONS(4709),
    [anon_sym_u8_DQUOTE] = ACTIONS(4709),
    [anon_sym_DQUOTE] = ACTIONS(4709),
    [sym_true] = ACTIONS(4711),
    [sym_false] = ACTIONS(4711),
    [anon_sym_NULL] = ACTIONS(4711),
    [anon_sym_nullptr] = ACTIONS(4711),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4715),
    [anon_sym_let] = ACTIONS(4715),
    [anon_sym_This] = ACTIONS(4715),
    [anon_sym_decltype] = ACTIONS(4703),
    [sym_virtual] = ACTIONS(4715),
    [anon_sym_explicit] = ACTIONS(4715),
    [anon_sym_typename] = ACTIONS(4715),
    [anon_sym_template] = ACTIONS(4703),
    [anon_sym_operator] = ACTIONS(4715),
    [anon_sym_try] = ACTIONS(4711),
    [anon_sym_delete] = ACTIONS(4711),
    [anon_sym_throw] = ACTIONS(4711),
    [anon_sym_co_return] = ACTIONS(4711),
    [anon_sym_co_yield] = ACTIONS(4711),
    [anon_sym_R_DQUOTE] = ACTIONS(4709),
    [anon_sym_LR_DQUOTE] = ACTIONS(4709),
    [anon_sym_uR_DQUOTE] = ACTIONS(4709),
    [anon_sym_UR_DQUOTE] = ACTIONS(4709),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4709),
    [anon_sym_co_await] = ACTIONS(4711),
    [anon_sym_new] = ACTIONS(4711),
    [anon_sym_requires] = ACTIONS(4711),
    [sym_this] = ACTIONS(4711),
    [anon_sym_discard] = ACTIONS(4711),
    [anon_sym_precise] = ACTIONS(4715),
    [anon_sym_shared] = ACTIONS(4715),
    [anon_sym_groupshared] = ACTIONS(4715),
    [anon_sym_uniform] = ACTIONS(4715),
    [anon_sym_row_major] = ACTIONS(4715),
    [anon_sym_column_major] = ACTIONS(4715),
    [anon_sym_globallycoherent] = ACTIONS(4715),
    [anon_sym_centroid] = ACTIONS(4715),
    [anon_sym_noperspective] = ACTIONS(4715),
    [anon_sym_nointerpolation] = ACTIONS(4715),
    [anon_sym_sample] = ACTIONS(4715),
    [anon_sym_linear] = ACTIONS(4715),
    [anon_sym_snorm] = ACTIONS(4715),
    [anon_sym_unorm] = ACTIONS(4715),
    [anon_sym_point] = ACTIONS(4715),
    [anon_sym_line] = ACTIONS(4715),
    [anon_sym_triangleadj] = ACTIONS(4715),
    [anon_sym_lineadj] = ACTIONS(4715),
    [anon_sym_triangle] = ACTIONS(4715),
    [anon_sym_cbuffer] = ACTIONS(4711),
    [anon_sym_interface] = ACTIONS(4715),
    [anon_sym_extension] = ACTIONS(4715),
  },
  [1210] = {
    [sym_type_qualifier] = STATE(4248),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(4960),
    [sym_sized_type_specifier] = STATE(5826),
    [sym_enum_specifier] = STATE(5826),
    [sym_struct_specifier] = STATE(5826),
    [sym_union_specifier] = STATE(5826),
    [sym_expression] = STATE(5272),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_type_descriptor] = STATE(8342),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_placeholder_type_specifier] = STATE(5826),
    [sym_decltype] = STATE(5647),
    [sym_class_specifier] = STATE(5826),
    [sym__class_name] = STATE(9946),
    [sym_dependent_type] = STATE(5826),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_type_parameter_pack_expansion] = STATE(9007),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6860),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4414),
    [sym_interface_specifier] = STATE(5826),
    [sym_extension_specifier] = STATE(5826),
    [sym_associatedtype_specifier] = STATE(5826),
    [aux_sym__type_definition_type_repeat1] = STATE(4248),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4903),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_signed] = ACTIONS(4633),
    [anon_sym_unsigned] = ACTIONS(4633),
    [anon_sym_long] = ACTIONS(4633),
    [anon_sym_short] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4635),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_class] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4641),
    [anon_sym_union] = ACTIONS(4643),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4667),
    [anon_sym_let] = ACTIONS(4717),
    [anon_sym_This] = ACTIONS(4667),
    [anon_sym_decltype] = ACTIONS(4671),
    [anon_sym_typename] = ACTIONS(4673),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(4719),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
    [anon_sym_interface] = ACTIONS(4687),
    [anon_sym_extension] = ACTIONS(4689),
  },
  [1211] = {
    [sym_type_qualifier] = STATE(4248),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(4960),
    [sym_sized_type_specifier] = STATE(5826),
    [sym_enum_specifier] = STATE(5826),
    [sym_struct_specifier] = STATE(5826),
    [sym_union_specifier] = STATE(5826),
    [sym_expression] = STATE(5280),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_type_descriptor] = STATE(8278),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_placeholder_type_specifier] = STATE(5826),
    [sym_decltype] = STATE(5647),
    [sym_class_specifier] = STATE(5826),
    [sym__class_name] = STATE(9946),
    [sym_dependent_type] = STATE(5826),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_type_parameter_pack_expansion] = STATE(9295),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6860),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4414),
    [sym_interface_specifier] = STATE(5826),
    [sym_extension_specifier] = STATE(5826),
    [sym_associatedtype_specifier] = STATE(5826),
    [aux_sym__type_definition_type_repeat1] = STATE(4248),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4903),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_signed] = ACTIONS(4633),
    [anon_sym_unsigned] = ACTIONS(4633),
    [anon_sym_long] = ACTIONS(4633),
    [anon_sym_short] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4635),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_class] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4641),
    [anon_sym_union] = ACTIONS(4643),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4667),
    [anon_sym_let] = ACTIONS(4721),
    [anon_sym_This] = ACTIONS(4667),
    [anon_sym_decltype] = ACTIONS(4671),
    [anon_sym_typename] = ACTIONS(4673),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(4723),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
    [anon_sym_interface] = ACTIONS(4687),
    [anon_sym_extension] = ACTIONS(4689),
  },
  [1212] = {
    [sym_type_qualifier] = STATE(4248),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(4960),
    [sym_sized_type_specifier] = STATE(5826),
    [sym_enum_specifier] = STATE(5826),
    [sym_struct_specifier] = STATE(5826),
    [sym_union_specifier] = STATE(5826),
    [sym_expression] = STATE(5304),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_type_descriptor] = STATE(8240),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_placeholder_type_specifier] = STATE(5826),
    [sym_decltype] = STATE(5647),
    [sym_class_specifier] = STATE(5826),
    [sym__class_name] = STATE(9946),
    [sym_dependent_type] = STATE(5826),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_type_parameter_pack_expansion] = STATE(9337),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6860),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4414),
    [sym_interface_specifier] = STATE(5826),
    [sym_extension_specifier] = STATE(5826),
    [sym_associatedtype_specifier] = STATE(5826),
    [aux_sym__type_definition_type_repeat1] = STATE(4248),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4903),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_signed] = ACTIONS(4633),
    [anon_sym_unsigned] = ACTIONS(4633),
    [anon_sym_long] = ACTIONS(4633),
    [anon_sym_short] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4635),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_class] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4641),
    [anon_sym_union] = ACTIONS(4643),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4667),
    [anon_sym_let] = ACTIONS(4725),
    [anon_sym_This] = ACTIONS(4667),
    [anon_sym_decltype] = ACTIONS(4671),
    [anon_sym_typename] = ACTIONS(4673),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(4727),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
    [anon_sym_interface] = ACTIONS(4687),
    [anon_sym_extension] = ACTIONS(4689),
  },
  [1213] = {
    [sym_expression] = STATE(4201),
    [sym__string] = STATE(4545),
    [sym_conditional_expression] = STATE(4545),
    [sym_assignment_expression] = STATE(4545),
    [sym_pointer_expression] = STATE(4540),
    [sym_unary_expression] = STATE(4545),
    [sym_binary_expression] = STATE(4545),
    [sym_update_expression] = STATE(4545),
    [sym_cast_expression] = STATE(4545),
    [sym_sizeof_expression] = STATE(4545),
    [sym_alignof_expression] = STATE(4545),
    [sym_offsetof_expression] = STATE(4545),
    [sym_generic_expression] = STATE(4545),
    [sym_subscript_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_gnu_asm_expression] = STATE(4545),
    [sym_field_expression] = STATE(4540),
    [sym_compound_literal_expression] = STATE(4545),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_initializer_list] = STATE(4492),
    [sym_char_literal] = STATE(4286),
    [sym_concatenated_string] = STATE(4290),
    [sym_string_literal] = STATE(3166),
    [sym_null] = STATE(4545),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9673),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4545),
    [sym_raw_string_literal] = STATE(3169),
    [sym_co_await_expression] = STATE(4545),
    [sym_new_expression] = STATE(4545),
    [sym_delete_expression] = STATE(4545),
    [sym_requires_clause] = STATE(4545),
    [sym_requires_expression] = STATE(4545),
    [sym_lambda_expression] = STATE(4545),
    [sym_lambda_capture_specifier] = STATE(7034),
    [sym_fold_expression] = STATE(4545),
    [sym_parameter_pack_expansion] = STATE(4545),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4540),
    [sym_qualified_type_identifier] = STATE(9673),
    [sym_user_defined_literal] = STATE(4540),
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4410),
    [anon_sym_COMMA] = ACTIONS(4410),
    [anon_sym_LPAREN2] = ACTIONS(4410),
    [anon_sym_BANG] = ACTIONS(4731),
    [anon_sym_TILDE] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4408),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_STAR] = ACTIONS(4408),
    [anon_sym_SLASH] = ACTIONS(4408),
    [anon_sym_PERCENT] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4408),
    [anon_sym_GT_EQ] = ACTIONS(4408),
    [anon_sym_LT_EQ] = ACTIONS(4408),
    [anon_sym_LT] = ACTIONS(4408),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_COLON_COLON] = ACTIONS(4735),
    [anon_sym_LBRACE] = ACTIONS(4737),
    [anon_sym_LBRACK] = ACTIONS(4410),
    [anon_sym_EQ] = ACTIONS(4408),
    [sym_primitive_type] = ACTIONS(4739),
    [anon_sym_QMARK] = ACTIONS(4410),
    [anon_sym_STAR_EQ] = ACTIONS(4410),
    [anon_sym_SLASH_EQ] = ACTIONS(4410),
    [anon_sym_PERCENT_EQ] = ACTIONS(4410),
    [anon_sym_PLUS_EQ] = ACTIONS(4410),
    [anon_sym_DASH_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_GT_EQ] = ACTIONS(4408),
    [anon_sym_AMP_EQ] = ACTIONS(4410),
    [anon_sym_CARET_EQ] = ACTIONS(4410),
    [anon_sym_PIPE_EQ] = ACTIONS(4410),
    [anon_sym_and_eq] = ACTIONS(4408),
    [anon_sym_or_eq] = ACTIONS(4408),
    [anon_sym_xor_eq] = ACTIONS(4408),
    [anon_sym_not] = ACTIONS(4731),
    [anon_sym_compl] = ACTIONS(4731),
    [anon_sym_LT_EQ_GT] = ACTIONS(4410),
    [anon_sym_or] = ACTIONS(4408),
    [anon_sym_and] = ACTIONS(4408),
    [anon_sym_bitor] = ACTIONS(4408),
    [anon_sym_xor] = ACTIONS(4408),
    [anon_sym_bitand] = ACTIONS(4408),
    [anon_sym_not_eq] = ACTIONS(4408),
    [anon_sym_is] = ACTIONS(4408),
    [anon_sym_as] = ACTIONS(4408),
    [anon_sym_DASH_DASH] = ACTIONS(4410),
    [anon_sym_PLUS_PLUS] = ACTIONS(4410),
    [anon_sym_sizeof] = ACTIONS(4741),
    [anon_sym___alignof__] = ACTIONS(4743),
    [anon_sym___alignof] = ACTIONS(4743),
    [anon_sym__alignof] = ACTIONS(4743),
    [anon_sym_alignof] = ACTIONS(4743),
    [anon_sym__Alignof] = ACTIONS(4743),
    [anon_sym_offsetof] = ACTIONS(4745),
    [anon_sym__Generic] = ACTIONS(4747),
    [anon_sym_asm] = ACTIONS(4749),
    [anon_sym___asm__] = ACTIONS(4749),
    [anon_sym_DOT] = ACTIONS(4408),
    [anon_sym_DOT_STAR] = ACTIONS(4410),
    [anon_sym_DASH_GT] = ACTIONS(4410),
    [sym_number_literal] = ACTIONS(4751),
    [anon_sym_L_SQUOTE] = ACTIONS(4753),
    [anon_sym_u_SQUOTE] = ACTIONS(4753),
    [anon_sym_U_SQUOTE] = ACTIONS(4753),
    [anon_sym_u8_SQUOTE] = ACTIONS(4753),
    [anon_sym_SQUOTE] = ACTIONS(4753),
    [anon_sym_L_DQUOTE] = ACTIONS(4755),
    [anon_sym_u_DQUOTE] = ACTIONS(4755),
    [anon_sym_U_DQUOTE] = ACTIONS(4755),
    [anon_sym_u8_DQUOTE] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [anon_sym_NULL] = ACTIONS(4759),
    [anon_sym_nullptr] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(4410),
    [anon_sym_delete] = ACTIONS(4761),
    [anon_sym_R_DQUOTE] = ACTIONS(4763),
    [anon_sym_LR_DQUOTE] = ACTIONS(4763),
    [anon_sym_uR_DQUOTE] = ACTIONS(4763),
    [anon_sym_UR_DQUOTE] = ACTIONS(4763),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4763),
    [anon_sym_co_await] = ACTIONS(4765),
    [anon_sym_new] = ACTIONS(4767),
    [anon_sym_requires] = ACTIONS(4769),
    [sym_this] = ACTIONS(4757),
  },
  [1214] = {
    [sym_type_qualifier] = STATE(4248),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(4960),
    [sym_sized_type_specifier] = STATE(5826),
    [sym_enum_specifier] = STATE(5826),
    [sym_struct_specifier] = STATE(5826),
    [sym_union_specifier] = STATE(5826),
    [sym_expression] = STATE(5158),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_type_descriptor] = STATE(8271),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_placeholder_type_specifier] = STATE(5826),
    [sym_decltype] = STATE(5647),
    [sym_class_specifier] = STATE(5826),
    [sym__class_name] = STATE(9946),
    [sym_dependent_type] = STATE(5826),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_type_parameter_pack_expansion] = STATE(9622),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6860),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4414),
    [sym_interface_specifier] = STATE(5826),
    [sym_extension_specifier] = STATE(5826),
    [sym_associatedtype_specifier] = STATE(5826),
    [aux_sym__type_definition_type_repeat1] = STATE(4248),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4903),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_signed] = ACTIONS(4633),
    [anon_sym_unsigned] = ACTIONS(4633),
    [anon_sym_long] = ACTIONS(4633),
    [anon_sym_short] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4635),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_class] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4641),
    [anon_sym_union] = ACTIONS(4643),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4667),
    [anon_sym_let] = ACTIONS(4771),
    [anon_sym_This] = ACTIONS(4667),
    [anon_sym_decltype] = ACTIONS(4671),
    [anon_sym_typename] = ACTIONS(4673),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(4773),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
    [anon_sym_interface] = ACTIONS(4687),
    [anon_sym_extension] = ACTIONS(4689),
  },
  [1215] = {
    [sym_type_qualifier] = STATE(4248),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(4960),
    [sym_sized_type_specifier] = STATE(5826),
    [sym_enum_specifier] = STATE(5826),
    [sym_struct_specifier] = STATE(5826),
    [sym_union_specifier] = STATE(5826),
    [sym_expression] = STATE(5262),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_type_descriptor] = STATE(8288),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_placeholder_type_specifier] = STATE(5826),
    [sym_decltype] = STATE(5647),
    [sym_class_specifier] = STATE(5826),
    [sym__class_name] = STATE(9946),
    [sym_dependent_type] = STATE(5826),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_type_parameter_pack_expansion] = STATE(9133),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6860),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4414),
    [sym_interface_specifier] = STATE(5826),
    [sym_extension_specifier] = STATE(5826),
    [sym_associatedtype_specifier] = STATE(5826),
    [aux_sym__type_definition_type_repeat1] = STATE(4248),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4903),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_signed] = ACTIONS(4633),
    [anon_sym_unsigned] = ACTIONS(4633),
    [anon_sym_long] = ACTIONS(4633),
    [anon_sym_short] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4635),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_class] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4641),
    [anon_sym_union] = ACTIONS(4643),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4667),
    [anon_sym_let] = ACTIONS(4775),
    [anon_sym_This] = ACTIONS(4667),
    [anon_sym_decltype] = ACTIONS(4671),
    [anon_sym_typename] = ACTIONS(4673),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(4777),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
    [anon_sym_interface] = ACTIONS(4687),
    [anon_sym_extension] = ACTIONS(4689),
  },
  [1216] = {
    [sym_type_qualifier] = STATE(4248),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(4960),
    [sym_sized_type_specifier] = STATE(5826),
    [sym_enum_specifier] = STATE(5826),
    [sym_struct_specifier] = STATE(5826),
    [sym_union_specifier] = STATE(5826),
    [sym_expression] = STATE(5235),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_type_descriptor] = STATE(8325),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_placeholder_type_specifier] = STATE(5826),
    [sym_decltype] = STATE(5647),
    [sym_class_specifier] = STATE(5826),
    [sym__class_name] = STATE(9946),
    [sym_dependent_type] = STATE(5826),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_type_parameter_pack_expansion] = STATE(8963),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6860),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4414),
    [sym_interface_specifier] = STATE(5826),
    [sym_extension_specifier] = STATE(5826),
    [sym_associatedtype_specifier] = STATE(5826),
    [aux_sym__type_definition_type_repeat1] = STATE(4248),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4903),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_signed] = ACTIONS(4633),
    [anon_sym_unsigned] = ACTIONS(4633),
    [anon_sym_long] = ACTIONS(4633),
    [anon_sym_short] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4635),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_class] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4641),
    [anon_sym_union] = ACTIONS(4643),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4667),
    [anon_sym_let] = ACTIONS(4779),
    [anon_sym_This] = ACTIONS(4667),
    [anon_sym_decltype] = ACTIONS(4671),
    [anon_sym_typename] = ACTIONS(4673),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(4781),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
    [anon_sym_interface] = ACTIONS(4687),
    [anon_sym_extension] = ACTIONS(4689),
  },
  [1217] = {
    [sym_type_qualifier] = STATE(4248),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(4960),
    [sym_sized_type_specifier] = STATE(5826),
    [sym_enum_specifier] = STATE(5826),
    [sym_struct_specifier] = STATE(5826),
    [sym_union_specifier] = STATE(5826),
    [sym_expression] = STATE(5243),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_type_descriptor] = STATE(8309),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_placeholder_type_specifier] = STATE(5826),
    [sym_decltype] = STATE(5647),
    [sym_class_specifier] = STATE(5826),
    [sym__class_name] = STATE(9946),
    [sym_dependent_type] = STATE(5826),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_type_parameter_pack_expansion] = STATE(8946),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6860),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4414),
    [sym_interface_specifier] = STATE(5826),
    [sym_extension_specifier] = STATE(5826),
    [sym_associatedtype_specifier] = STATE(5826),
    [aux_sym__type_definition_type_repeat1] = STATE(4248),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4903),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_signed] = ACTIONS(4633),
    [anon_sym_unsigned] = ACTIONS(4633),
    [anon_sym_long] = ACTIONS(4633),
    [anon_sym_short] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4635),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_class] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4641),
    [anon_sym_union] = ACTIONS(4643),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4667),
    [anon_sym_let] = ACTIONS(4783),
    [anon_sym_This] = ACTIONS(4667),
    [anon_sym_decltype] = ACTIONS(4671),
    [anon_sym_typename] = ACTIONS(4673),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(4785),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
    [anon_sym_interface] = ACTIONS(4687),
    [anon_sym_extension] = ACTIONS(4689),
  },
  [1218] = {
    [sym_type_qualifier] = STATE(4248),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(4960),
    [sym_sized_type_specifier] = STATE(5826),
    [sym_enum_specifier] = STATE(5826),
    [sym_struct_specifier] = STATE(5826),
    [sym_union_specifier] = STATE(5826),
    [sym_expression] = STATE(5149),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_type_descriptor] = STATE(8262),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_placeholder_type_specifier] = STATE(5826),
    [sym_decltype] = STATE(5647),
    [sym_class_specifier] = STATE(5826),
    [sym__class_name] = STATE(9946),
    [sym_dependent_type] = STATE(5826),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_type_parameter_pack_expansion] = STATE(9197),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6860),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4414),
    [sym_interface_specifier] = STATE(5826),
    [sym_extension_specifier] = STATE(5826),
    [sym_associatedtype_specifier] = STATE(5826),
    [aux_sym__type_definition_type_repeat1] = STATE(4248),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4903),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_signed] = ACTIONS(4633),
    [anon_sym_unsigned] = ACTIONS(4633),
    [anon_sym_long] = ACTIONS(4633),
    [anon_sym_short] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4635),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_class] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4641),
    [anon_sym_union] = ACTIONS(4643),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4667),
    [anon_sym_let] = ACTIONS(4787),
    [anon_sym_This] = ACTIONS(4667),
    [anon_sym_decltype] = ACTIONS(4671),
    [anon_sym_typename] = ACTIONS(4673),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(4789),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
    [anon_sym_interface] = ACTIONS(4687),
    [anon_sym_extension] = ACTIONS(4689),
  },
  [1219] = {
    [sym_type_qualifier] = STATE(4248),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(4960),
    [sym_sized_type_specifier] = STATE(5826),
    [sym_enum_specifier] = STATE(5826),
    [sym_struct_specifier] = STATE(5826),
    [sym_union_specifier] = STATE(5826),
    [sym_expression] = STATE(5313),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_type_descriptor] = STATE(8251),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_placeholder_type_specifier] = STATE(5826),
    [sym_decltype] = STATE(5647),
    [sym_class_specifier] = STATE(5826),
    [sym__class_name] = STATE(9946),
    [sym_dependent_type] = STATE(5826),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_type_parameter_pack_expansion] = STATE(9632),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6860),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4414),
    [sym_interface_specifier] = STATE(5826),
    [sym_extension_specifier] = STATE(5826),
    [sym_associatedtype_specifier] = STATE(5826),
    [aux_sym__type_definition_type_repeat1] = STATE(4248),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4903),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_signed] = ACTIONS(4633),
    [anon_sym_unsigned] = ACTIONS(4633),
    [anon_sym_long] = ACTIONS(4633),
    [anon_sym_short] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4635),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_class] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4641),
    [anon_sym_union] = ACTIONS(4643),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4667),
    [anon_sym_let] = ACTIONS(4791),
    [anon_sym_This] = ACTIONS(4667),
    [anon_sym_decltype] = ACTIONS(4671),
    [anon_sym_typename] = ACTIONS(4673),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(4793),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
    [anon_sym_interface] = ACTIONS(4687),
    [anon_sym_extension] = ACTIONS(4689),
  },
  [1220] = {
    [sym_type_qualifier] = STATE(4248),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(4960),
    [sym_sized_type_specifier] = STATE(5826),
    [sym_enum_specifier] = STATE(5826),
    [sym_struct_specifier] = STATE(5826),
    [sym_union_specifier] = STATE(5826),
    [sym_expression] = STATE(5310),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_type_descriptor] = STATE(8243),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_placeholder_type_specifier] = STATE(5826),
    [sym_decltype] = STATE(5647),
    [sym_class_specifier] = STATE(5826),
    [sym__class_name] = STATE(9946),
    [sym_dependent_type] = STATE(5826),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_type_parameter_pack_expansion] = STATE(9417),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6860),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4414),
    [sym_interface_specifier] = STATE(5826),
    [sym_extension_specifier] = STATE(5826),
    [sym_associatedtype_specifier] = STATE(5826),
    [aux_sym__type_definition_type_repeat1] = STATE(4248),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4903),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_signed] = ACTIONS(4633),
    [anon_sym_unsigned] = ACTIONS(4633),
    [anon_sym_long] = ACTIONS(4633),
    [anon_sym_short] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4635),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_class] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4641),
    [anon_sym_union] = ACTIONS(4643),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4667),
    [anon_sym_let] = ACTIONS(4795),
    [anon_sym_This] = ACTIONS(4667),
    [anon_sym_decltype] = ACTIONS(4671),
    [anon_sym_typename] = ACTIONS(4673),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(4797),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
    [anon_sym_interface] = ACTIONS(4687),
    [anon_sym_extension] = ACTIONS(4689),
  },
  [1221] = {
    [sym_type_qualifier] = STATE(4248),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(4960),
    [sym_sized_type_specifier] = STATE(5826),
    [sym_enum_specifier] = STATE(5826),
    [sym_struct_specifier] = STATE(5826),
    [sym_union_specifier] = STATE(5826),
    [sym_expression] = STATE(5250),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_type_descriptor] = STATE(8306),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_placeholder_type_specifier] = STATE(5826),
    [sym_decltype] = STATE(5647),
    [sym_class_specifier] = STATE(5826),
    [sym__class_name] = STATE(9946),
    [sym_dependent_type] = STATE(5826),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_type_parameter_pack_expansion] = STATE(9053),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6860),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4414),
    [sym_interface_specifier] = STATE(5826),
    [sym_extension_specifier] = STATE(5826),
    [sym_associatedtype_specifier] = STATE(5826),
    [aux_sym__type_definition_type_repeat1] = STATE(4248),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4903),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_signed] = ACTIONS(4633),
    [anon_sym_unsigned] = ACTIONS(4633),
    [anon_sym_long] = ACTIONS(4633),
    [anon_sym_short] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4635),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_class] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4641),
    [anon_sym_union] = ACTIONS(4643),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4667),
    [anon_sym_let] = ACTIONS(4799),
    [anon_sym_This] = ACTIONS(4667),
    [anon_sym_decltype] = ACTIONS(4671),
    [anon_sym_typename] = ACTIONS(4673),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(4801),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
    [anon_sym_interface] = ACTIONS(4687),
    [anon_sym_extension] = ACTIONS(4689),
  },
  [1222] = {
    [sym_type_qualifier] = STATE(4248),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(4960),
    [sym_sized_type_specifier] = STATE(5826),
    [sym_enum_specifier] = STATE(5826),
    [sym_struct_specifier] = STATE(5826),
    [sym_union_specifier] = STATE(5826),
    [sym_expression] = STATE(5255),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_type_descriptor] = STATE(8301),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_placeholder_type_specifier] = STATE(5826),
    [sym_decltype] = STATE(5647),
    [sym_class_specifier] = STATE(5826),
    [sym__class_name] = STATE(9946),
    [sym_dependent_type] = STATE(5826),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_type_parameter_pack_expansion] = STATE(9108),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6860),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4414),
    [sym_interface_specifier] = STATE(5826),
    [sym_extension_specifier] = STATE(5826),
    [sym_associatedtype_specifier] = STATE(5826),
    [aux_sym__type_definition_type_repeat1] = STATE(4248),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4903),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_signed] = ACTIONS(4633),
    [anon_sym_unsigned] = ACTIONS(4633),
    [anon_sym_long] = ACTIONS(4633),
    [anon_sym_short] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4635),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_class] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4641),
    [anon_sym_union] = ACTIONS(4643),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4667),
    [anon_sym_let] = ACTIONS(4803),
    [anon_sym_This] = ACTIONS(4667),
    [anon_sym_decltype] = ACTIONS(4671),
    [anon_sym_typename] = ACTIONS(4673),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(4805),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
    [anon_sym_interface] = ACTIONS(4687),
    [anon_sym_extension] = ACTIONS(4689),
  },
  [1223] = {
    [sym_type_qualifier] = STATE(4248),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(4960),
    [sym_sized_type_specifier] = STATE(5826),
    [sym_enum_specifier] = STATE(5826),
    [sym_struct_specifier] = STATE(5826),
    [sym_union_specifier] = STATE(5826),
    [sym_expression] = STATE(5279),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_type_descriptor] = STATE(8292),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_placeholder_type_specifier] = STATE(5826),
    [sym_decltype] = STATE(5647),
    [sym_class_specifier] = STATE(5826),
    [sym__class_name] = STATE(9946),
    [sym_dependent_type] = STATE(5826),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_type_parameter_pack_expansion] = STATE(9176),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6860),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4414),
    [sym_interface_specifier] = STATE(5826),
    [sym_extension_specifier] = STATE(5826),
    [sym_associatedtype_specifier] = STATE(5826),
    [aux_sym__type_definition_type_repeat1] = STATE(4248),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4903),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_signed] = ACTIONS(4633),
    [anon_sym_unsigned] = ACTIONS(4633),
    [anon_sym_long] = ACTIONS(4633),
    [anon_sym_short] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4635),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_class] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4641),
    [anon_sym_union] = ACTIONS(4643),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4667),
    [anon_sym_let] = ACTIONS(4807),
    [anon_sym_This] = ACTIONS(4667),
    [anon_sym_decltype] = ACTIONS(4671),
    [anon_sym_typename] = ACTIONS(4673),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(4809),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
    [anon_sym_interface] = ACTIONS(4687),
    [anon_sym_extension] = ACTIONS(4689),
  },
  [1224] = {
    [sym_type_qualifier] = STATE(4248),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(4960),
    [sym_sized_type_specifier] = STATE(5826),
    [sym_enum_specifier] = STATE(5826),
    [sym_struct_specifier] = STATE(5826),
    [sym_union_specifier] = STATE(5826),
    [sym_expression] = STATE(5288),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_type_descriptor] = STATE(8276),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_placeholder_type_specifier] = STATE(5826),
    [sym_decltype] = STATE(5647),
    [sym_class_specifier] = STATE(5826),
    [sym__class_name] = STATE(9946),
    [sym_dependent_type] = STATE(5826),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_type_parameter_pack_expansion] = STATE(9370),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6860),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4414),
    [sym_interface_specifier] = STATE(5826),
    [sym_extension_specifier] = STATE(5826),
    [sym_associatedtype_specifier] = STATE(5826),
    [aux_sym__type_definition_type_repeat1] = STATE(4248),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4903),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_signed] = ACTIONS(4633),
    [anon_sym_unsigned] = ACTIONS(4633),
    [anon_sym_long] = ACTIONS(4633),
    [anon_sym_short] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4635),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_class] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4641),
    [anon_sym_union] = ACTIONS(4643),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4667),
    [anon_sym_let] = ACTIONS(4811),
    [anon_sym_This] = ACTIONS(4667),
    [anon_sym_decltype] = ACTIONS(4671),
    [anon_sym_typename] = ACTIONS(4673),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(4813),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
    [anon_sym_interface] = ACTIONS(4687),
    [anon_sym_extension] = ACTIONS(4689),
  },
  [1225] = {
    [sym_type_qualifier] = STATE(4248),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(4960),
    [sym_sized_type_specifier] = STATE(5826),
    [sym_enum_specifier] = STATE(5826),
    [sym_struct_specifier] = STATE(5826),
    [sym_union_specifier] = STATE(5826),
    [sym_expression] = STATE(5249),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_type_descriptor] = STATE(8281),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_placeholder_type_specifier] = STATE(5826),
    [sym_decltype] = STATE(5647),
    [sym_class_specifier] = STATE(5826),
    [sym__class_name] = STATE(9946),
    [sym_dependent_type] = STATE(5826),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_type_parameter_pack_expansion] = STATE(9219),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6860),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4414),
    [sym_interface_specifier] = STATE(5826),
    [sym_extension_specifier] = STATE(5826),
    [sym_associatedtype_specifier] = STATE(5826),
    [aux_sym__type_definition_type_repeat1] = STATE(4248),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4903),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_signed] = ACTIONS(4633),
    [anon_sym_unsigned] = ACTIONS(4633),
    [anon_sym_long] = ACTIONS(4633),
    [anon_sym_short] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4635),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_class] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4641),
    [anon_sym_union] = ACTIONS(4643),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4667),
    [anon_sym_let] = ACTIONS(4815),
    [anon_sym_This] = ACTIONS(4667),
    [anon_sym_decltype] = ACTIONS(4671),
    [anon_sym_typename] = ACTIONS(4673),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(4817),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
    [anon_sym_interface] = ACTIONS(4687),
    [anon_sym_extension] = ACTIONS(4689),
  },
  [1226] = {
    [sym_type_qualifier] = STATE(4248),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(4960),
    [sym_sized_type_specifier] = STATE(5826),
    [sym_enum_specifier] = STATE(5826),
    [sym_struct_specifier] = STATE(5826),
    [sym_union_specifier] = STATE(5826),
    [sym_expression] = STATE(5307),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_type_descriptor] = STATE(8241),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_placeholder_type_specifier] = STATE(5826),
    [sym_decltype] = STATE(5647),
    [sym_class_specifier] = STATE(5826),
    [sym__class_name] = STATE(9946),
    [sym_dependent_type] = STATE(5826),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_type_parameter_pack_expansion] = STATE(9141),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6860),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4414),
    [sym_interface_specifier] = STATE(5826),
    [sym_extension_specifier] = STATE(5826),
    [sym_associatedtype_specifier] = STATE(5826),
    [aux_sym__type_definition_type_repeat1] = STATE(4248),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4903),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_signed] = ACTIONS(4633),
    [anon_sym_unsigned] = ACTIONS(4633),
    [anon_sym_long] = ACTIONS(4633),
    [anon_sym_short] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4635),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_class] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4641),
    [anon_sym_union] = ACTIONS(4643),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4667),
    [anon_sym_let] = ACTIONS(4819),
    [anon_sym_This] = ACTIONS(4667),
    [anon_sym_decltype] = ACTIONS(4671),
    [anon_sym_typename] = ACTIONS(4673),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(4821),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
    [anon_sym_interface] = ACTIONS(4687),
    [anon_sym_extension] = ACTIONS(4689),
  },
  [1227] = {
    [sym_type_qualifier] = STATE(4248),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(4960),
    [sym_sized_type_specifier] = STATE(5826),
    [sym_enum_specifier] = STATE(5826),
    [sym_struct_specifier] = STATE(5826),
    [sym_union_specifier] = STATE(5826),
    [sym_expression] = STATE(5291),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_type_descriptor] = STATE(8267),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_placeholder_type_specifier] = STATE(5826),
    [sym_decltype] = STATE(5647),
    [sym_class_specifier] = STATE(5826),
    [sym__class_name] = STATE(9946),
    [sym_dependent_type] = STATE(5826),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_type_parameter_pack_expansion] = STATE(9422),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6860),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4414),
    [sym_interface_specifier] = STATE(5826),
    [sym_extension_specifier] = STATE(5826),
    [sym_associatedtype_specifier] = STATE(5826),
    [aux_sym__type_definition_type_repeat1] = STATE(4248),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4903),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_signed] = ACTIONS(4633),
    [anon_sym_unsigned] = ACTIONS(4633),
    [anon_sym_long] = ACTIONS(4633),
    [anon_sym_short] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4635),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_class] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4641),
    [anon_sym_union] = ACTIONS(4643),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4667),
    [anon_sym_let] = ACTIONS(4823),
    [anon_sym_This] = ACTIONS(4667),
    [anon_sym_decltype] = ACTIONS(4671),
    [anon_sym_typename] = ACTIONS(4673),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(4825),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
    [anon_sym_interface] = ACTIONS(4687),
    [anon_sym_extension] = ACTIONS(4689),
  },
  [1228] = {
    [sym_type_qualifier] = STATE(4248),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(4960),
    [sym_sized_type_specifier] = STATE(5826),
    [sym_enum_specifier] = STATE(5826),
    [sym_struct_specifier] = STATE(5826),
    [sym_union_specifier] = STATE(5826),
    [sym_expression] = STATE(5294),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_type_descriptor] = STATE(8257),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_placeholder_type_specifier] = STATE(5826),
    [sym_decltype] = STATE(5647),
    [sym_class_specifier] = STATE(5826),
    [sym__class_name] = STATE(9946),
    [sym_dependent_type] = STATE(5826),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_type_parameter_pack_expansion] = STATE(9519),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6860),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4414),
    [sym_interface_specifier] = STATE(5826),
    [sym_extension_specifier] = STATE(5826),
    [sym_associatedtype_specifier] = STATE(5826),
    [aux_sym__type_definition_type_repeat1] = STATE(4248),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4903),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_signed] = ACTIONS(4633),
    [anon_sym_unsigned] = ACTIONS(4633),
    [anon_sym_long] = ACTIONS(4633),
    [anon_sym_short] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4635),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_class] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4641),
    [anon_sym_union] = ACTIONS(4643),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4667),
    [anon_sym_let] = ACTIONS(4827),
    [anon_sym_This] = ACTIONS(4667),
    [anon_sym_decltype] = ACTIONS(4671),
    [anon_sym_typename] = ACTIONS(4673),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(4829),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
    [anon_sym_interface] = ACTIONS(4687),
    [anon_sym_extension] = ACTIONS(4689),
  },
  [1229] = {
    [sym_type_qualifier] = STATE(4248),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(4960),
    [sym_sized_type_specifier] = STATE(5826),
    [sym_enum_specifier] = STATE(5826),
    [sym_struct_specifier] = STATE(5826),
    [sym_union_specifier] = STATE(5826),
    [sym_expression] = STATE(5264),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_type_descriptor] = STATE(8294),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_placeholder_type_specifier] = STATE(5826),
    [sym_decltype] = STATE(5647),
    [sym_class_specifier] = STATE(5826),
    [sym__class_name] = STATE(9946),
    [sym_dependent_type] = STATE(5826),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_type_parameter_pack_expansion] = STATE(9168),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6860),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4414),
    [sym_interface_specifier] = STATE(5826),
    [sym_extension_specifier] = STATE(5826),
    [sym_associatedtype_specifier] = STATE(5826),
    [aux_sym__type_definition_type_repeat1] = STATE(4248),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4903),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_signed] = ACTIONS(4633),
    [anon_sym_unsigned] = ACTIONS(4633),
    [anon_sym_long] = ACTIONS(4633),
    [anon_sym_short] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4635),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_class] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4641),
    [anon_sym_union] = ACTIONS(4643),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4667),
    [anon_sym_let] = ACTIONS(4831),
    [anon_sym_This] = ACTIONS(4667),
    [anon_sym_decltype] = ACTIONS(4671),
    [anon_sym_typename] = ACTIONS(4673),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(4833),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
    [anon_sym_interface] = ACTIONS(4687),
    [anon_sym_extension] = ACTIONS(4689),
  },
  [1230] = {
    [sym_type_qualifier] = STATE(4248),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(4960),
    [sym_sized_type_specifier] = STATE(5826),
    [sym_enum_specifier] = STATE(5826),
    [sym_struct_specifier] = STATE(5826),
    [sym_union_specifier] = STATE(5826),
    [sym_expression] = STATE(5274),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_type_descriptor] = STATE(8287),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_placeholder_type_specifier] = STATE(5826),
    [sym_decltype] = STATE(5647),
    [sym_class_specifier] = STATE(5826),
    [sym__class_name] = STATE(9946),
    [sym_dependent_type] = STATE(5826),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_type_parameter_pack_expansion] = STATE(9233),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6860),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4414),
    [sym_interface_specifier] = STATE(5826),
    [sym_extension_specifier] = STATE(5826),
    [sym_associatedtype_specifier] = STATE(5826),
    [aux_sym__type_definition_type_repeat1] = STATE(4248),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4903),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_signed] = ACTIONS(4633),
    [anon_sym_unsigned] = ACTIONS(4633),
    [anon_sym_long] = ACTIONS(4633),
    [anon_sym_short] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4635),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_class] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4641),
    [anon_sym_union] = ACTIONS(4643),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4667),
    [anon_sym_let] = ACTIONS(4835),
    [anon_sym_This] = ACTIONS(4667),
    [anon_sym_decltype] = ACTIONS(4671),
    [anon_sym_typename] = ACTIONS(4673),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(4837),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
    [anon_sym_interface] = ACTIONS(4687),
    [anon_sym_extension] = ACTIONS(4689),
  },
  [1231] = {
    [sym_type_qualifier] = STATE(4248),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(4960),
    [sym_sized_type_specifier] = STATE(5826),
    [sym_enum_specifier] = STATE(5826),
    [sym_struct_specifier] = STATE(5826),
    [sym_union_specifier] = STATE(5826),
    [sym_expression] = STATE(5131),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_type_descriptor] = STATE(8244),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_placeholder_type_specifier] = STATE(5826),
    [sym_decltype] = STATE(5647),
    [sym_class_specifier] = STATE(5826),
    [sym__class_name] = STATE(9946),
    [sym_dependent_type] = STATE(5826),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_type_parameter_pack_expansion] = STATE(9545),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6860),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4414),
    [sym_interface_specifier] = STATE(5826),
    [sym_extension_specifier] = STATE(5826),
    [sym_associatedtype_specifier] = STATE(5826),
    [aux_sym__type_definition_type_repeat1] = STATE(4248),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4903),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_signed] = ACTIONS(4633),
    [anon_sym_unsigned] = ACTIONS(4633),
    [anon_sym_long] = ACTIONS(4633),
    [anon_sym_short] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4635),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_class] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4641),
    [anon_sym_union] = ACTIONS(4643),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4667),
    [anon_sym_let] = ACTIONS(4839),
    [anon_sym_This] = ACTIONS(4667),
    [anon_sym_decltype] = ACTIONS(4671),
    [anon_sym_typename] = ACTIONS(4673),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(4841),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
    [anon_sym_interface] = ACTIONS(4687),
    [anon_sym_extension] = ACTIONS(4689),
  },
  [1232] = {
    [sym_type_qualifier] = STATE(4248),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(4960),
    [sym_sized_type_specifier] = STATE(5826),
    [sym_enum_specifier] = STATE(5826),
    [sym_struct_specifier] = STATE(5826),
    [sym_union_specifier] = STATE(5826),
    [sym_expression] = STATE(5233),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_type_descriptor] = STATE(8334),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_placeholder_type_specifier] = STATE(5826),
    [sym_decltype] = STATE(5647),
    [sym_class_specifier] = STATE(5826),
    [sym__class_name] = STATE(9946),
    [sym_dependent_type] = STATE(5826),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_type_parameter_pack_expansion] = STATE(9368),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6860),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4414),
    [sym_interface_specifier] = STATE(5826),
    [sym_extension_specifier] = STATE(5826),
    [sym_associatedtype_specifier] = STATE(5826),
    [aux_sym__type_definition_type_repeat1] = STATE(4248),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4903),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_signed] = ACTIONS(4633),
    [anon_sym_unsigned] = ACTIONS(4633),
    [anon_sym_long] = ACTIONS(4633),
    [anon_sym_short] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4635),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_class] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4641),
    [anon_sym_union] = ACTIONS(4643),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4667),
    [anon_sym_let] = ACTIONS(4843),
    [anon_sym_This] = ACTIONS(4667),
    [anon_sym_decltype] = ACTIONS(4671),
    [anon_sym_typename] = ACTIONS(4673),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(4845),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
    [anon_sym_interface] = ACTIONS(4687),
    [anon_sym_extension] = ACTIONS(4689),
  },
  [1233] = {
    [sym_identifier] = ACTIONS(2186),
    [anon_sym_LPAREN2] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2188),
    [anon_sym_TILDE] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2186),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_STAR] = ACTIONS(2188),
    [anon_sym_AMP] = ACTIONS(2188),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym___extension__] = ACTIONS(2186),
    [anon_sym_typedef] = ACTIONS(2186),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_out] = ACTIONS(2186),
    [anon_sym_inout] = ACTIONS(2186),
    [anon_sym_extern] = ACTIONS(2186),
    [anon_sym___attribute__] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2188),
    [anon_sym___declspec] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_signed] = ACTIONS(2186),
    [anon_sym_unsigned] = ACTIONS(2186),
    [anon_sym_long] = ACTIONS(2186),
    [anon_sym_short] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_static] = ACTIONS(2186),
    [anon_sym_register] = ACTIONS(2186),
    [anon_sym_inline] = ACTIONS(2186),
    [anon_sym___inline] = ACTIONS(2186),
    [anon_sym___inline__] = ACTIONS(2186),
    [anon_sym___forceinline] = ACTIONS(2186),
    [anon_sym_thread_local] = ACTIONS(2186),
    [anon_sym___thread] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_constexpr] = ACTIONS(2186),
    [anon_sym_volatile] = ACTIONS(2186),
    [anon_sym_restrict] = ACTIONS(2186),
    [anon_sym___restrict__] = ACTIONS(2186),
    [anon_sym__Atomic] = ACTIONS(2186),
    [anon_sym__Noreturn] = ACTIONS(2186),
    [anon_sym_noreturn] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_constinit] = ACTIONS(2186),
    [anon_sym_consteval] = ACTIONS(2186),
    [anon_sym_alignas] = ACTIONS(2186),
    [anon_sym__Alignas] = ACTIONS(2186),
    [sym_primitive_type] = ACTIONS(2186),
    [anon_sym_enum] = ACTIONS(2186),
    [anon_sym_class] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_union] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_switch] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [anon_sym_do] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_break] = ACTIONS(2186),
    [anon_sym_continue] = ACTIONS(2186),
    [anon_sym_goto] = ACTIONS(2186),
    [anon_sym___try] = ACTIONS(2186),
    [anon_sym___leave] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2186),
    [anon_sym_compl] = ACTIONS(2186),
    [anon_sym_DASH_DASH] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2188),
    [anon_sym_sizeof] = ACTIONS(2186),
    [anon_sym___alignof__] = ACTIONS(2186),
    [anon_sym___alignof] = ACTIONS(2186),
    [anon_sym__alignof] = ACTIONS(2186),
    [anon_sym_alignof] = ACTIONS(2186),
    [anon_sym__Alignof] = ACTIONS(2186),
    [anon_sym_offsetof] = ACTIONS(2186),
    [anon_sym__Generic] = ACTIONS(2186),
    [anon_sym_asm] = ACTIONS(2186),
    [anon_sym___asm__] = ACTIONS(2186),
    [sym_number_literal] = ACTIONS(2188),
    [anon_sym_L_SQUOTE] = ACTIONS(2188),
    [anon_sym_u_SQUOTE] = ACTIONS(2188),
    [anon_sym_U_SQUOTE] = ACTIONS(2188),
    [anon_sym_u8_SQUOTE] = ACTIONS(2188),
    [anon_sym_SQUOTE] = ACTIONS(2188),
    [anon_sym_L_DQUOTE] = ACTIONS(2188),
    [anon_sym_u_DQUOTE] = ACTIONS(2188),
    [anon_sym_U_DQUOTE] = ACTIONS(2188),
    [anon_sym_u8_DQUOTE] = ACTIONS(2188),
    [anon_sym_DQUOTE] = ACTIONS(2188),
    [sym_true] = ACTIONS(2186),
    [sym_false] = ACTIONS(2186),
    [anon_sym_NULL] = ACTIONS(2186),
    [anon_sym_nullptr] = ACTIONS(2186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_This] = ACTIONS(2186),
    [anon_sym_decltype] = ACTIONS(2186),
    [anon_sym_final] = ACTIONS(2186),
    [anon_sym_override] = ACTIONS(2186),
    [sym_virtual] = ACTIONS(2186),
    [anon_sym_typename] = ACTIONS(2186),
    [anon_sym_template] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_delete] = ACTIONS(2186),
    [anon_sym_throw] = ACTIONS(2186),
    [anon_sym_co_return] = ACTIONS(2186),
    [anon_sym_co_yield] = ACTIONS(2186),
    [anon_sym_R_DQUOTE] = ACTIONS(2188),
    [anon_sym_LR_DQUOTE] = ACTIONS(2188),
    [anon_sym_uR_DQUOTE] = ACTIONS(2188),
    [anon_sym_UR_DQUOTE] = ACTIONS(2188),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2188),
    [anon_sym_co_await] = ACTIONS(2186),
    [anon_sym_new] = ACTIONS(2186),
    [anon_sym_requires] = ACTIONS(2186),
    [sym_this] = ACTIONS(2186),
    [anon_sym_discard] = ACTIONS(2186),
    [anon_sym_precise] = ACTIONS(2186),
    [anon_sym_shared] = ACTIONS(2186),
    [anon_sym_groupshared] = ACTIONS(2186),
    [anon_sym_uniform] = ACTIONS(2186),
    [anon_sym_row_major] = ACTIONS(2186),
    [anon_sym_column_major] = ACTIONS(2186),
    [anon_sym_globallycoherent] = ACTIONS(2186),
    [anon_sym_centroid] = ACTIONS(2186),
    [anon_sym_noperspective] = ACTIONS(2186),
    [anon_sym_nointerpolation] = ACTIONS(2186),
    [anon_sym_sample] = ACTIONS(2186),
    [anon_sym_linear] = ACTIONS(2186),
    [anon_sym_snorm] = ACTIONS(2186),
    [anon_sym_unorm] = ACTIONS(2186),
    [anon_sym_point] = ACTIONS(2186),
    [anon_sym_line] = ACTIONS(2186),
    [anon_sym_triangleadj] = ACTIONS(2186),
    [anon_sym_lineadj] = ACTIONS(2186),
    [anon_sym_triangle] = ACTIONS(2186),
    [anon_sym_cbuffer] = ACTIONS(2186),
    [anon_sym_interface] = ACTIONS(2186),
    [anon_sym_extension] = ACTIONS(2186),
  },
  [1234] = {
    [sym_catch_clause] = STATE(1235),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1235),
    [sym_identifier] = ACTIONS(2677),
    [anon_sym_LPAREN2] = ACTIONS(2679),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_DASH] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_STAR] = ACTIONS(2679),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2679),
    [anon_sym___extension__] = ACTIONS(2677),
    [anon_sym_typedef] = ACTIONS(2677),
    [anon_sym_in] = ACTIONS(2677),
    [anon_sym_out] = ACTIONS(2677),
    [anon_sym_inout] = ACTIONS(2677),
    [anon_sym_extern] = ACTIONS(2677),
    [anon_sym___attribute__] = ACTIONS(2677),
    [anon_sym_COLON_COLON] = ACTIONS(2679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2679),
    [anon_sym___declspec] = ACTIONS(2677),
    [anon_sym_LBRACE] = ACTIONS(2679),
    [anon_sym_signed] = ACTIONS(2677),
    [anon_sym_unsigned] = ACTIONS(2677),
    [anon_sym_long] = ACTIONS(2677),
    [anon_sym_short] = ACTIONS(2677),
    [anon_sym_LBRACK] = ACTIONS(2677),
    [anon_sym_static] = ACTIONS(2677),
    [anon_sym_register] = ACTIONS(2677),
    [anon_sym_inline] = ACTIONS(2677),
    [anon_sym___inline] = ACTIONS(2677),
    [anon_sym___inline__] = ACTIONS(2677),
    [anon_sym___forceinline] = ACTIONS(2677),
    [anon_sym_thread_local] = ACTIONS(2677),
    [anon_sym___thread] = ACTIONS(2677),
    [anon_sym_const] = ACTIONS(2677),
    [anon_sym_constexpr] = ACTIONS(2677),
    [anon_sym_volatile] = ACTIONS(2677),
    [anon_sym_restrict] = ACTIONS(2677),
    [anon_sym___restrict__] = ACTIONS(2677),
    [anon_sym__Atomic] = ACTIONS(2677),
    [anon_sym__Noreturn] = ACTIONS(2677),
    [anon_sym_noreturn] = ACTIONS(2677),
    [anon_sym_mutable] = ACTIONS(2677),
    [anon_sym_constinit] = ACTIONS(2677),
    [anon_sym_consteval] = ACTIONS(2677),
    [anon_sym_alignas] = ACTIONS(2677),
    [anon_sym__Alignas] = ACTIONS(2677),
    [sym_primitive_type] = ACTIONS(2677),
    [anon_sym_enum] = ACTIONS(2677),
    [anon_sym_class] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(2677),
    [anon_sym_union] = ACTIONS(2677),
    [anon_sym_if] = ACTIONS(2677),
    [anon_sym_else] = ACTIONS(2677),
    [anon_sym_switch] = ACTIONS(2677),
    [anon_sym_while] = ACTIONS(2677),
    [anon_sym_do] = ACTIONS(2677),
    [anon_sym_for] = ACTIONS(2677),
    [anon_sym_return] = ACTIONS(2677),
    [anon_sym_break] = ACTIONS(2677),
    [anon_sym_continue] = ACTIONS(2677),
    [anon_sym_goto] = ACTIONS(2677),
    [anon_sym___try] = ACTIONS(2677),
    [anon_sym___leave] = ACTIONS(2677),
    [anon_sym_not] = ACTIONS(2677),
    [anon_sym_compl] = ACTIONS(2677),
    [anon_sym_DASH_DASH] = ACTIONS(2679),
    [anon_sym_PLUS_PLUS] = ACTIONS(2679),
    [anon_sym_sizeof] = ACTIONS(2677),
    [anon_sym___alignof__] = ACTIONS(2677),
    [anon_sym___alignof] = ACTIONS(2677),
    [anon_sym__alignof] = ACTIONS(2677),
    [anon_sym_alignof] = ACTIONS(2677),
    [anon_sym__Alignof] = ACTIONS(2677),
    [anon_sym_offsetof] = ACTIONS(2677),
    [anon_sym__Generic] = ACTIONS(2677),
    [anon_sym_asm] = ACTIONS(2677),
    [anon_sym___asm__] = ACTIONS(2677),
    [sym_number_literal] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2679),
    [anon_sym_u_SQUOTE] = ACTIONS(2679),
    [anon_sym_U_SQUOTE] = ACTIONS(2679),
    [anon_sym_u8_SQUOTE] = ACTIONS(2679),
    [anon_sym_SQUOTE] = ACTIONS(2679),
    [anon_sym_L_DQUOTE] = ACTIONS(2679),
    [anon_sym_u_DQUOTE] = ACTIONS(2679),
    [anon_sym_U_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8_DQUOTE] = ACTIONS(2679),
    [anon_sym_DQUOTE] = ACTIONS(2679),
    [sym_true] = ACTIONS(2677),
    [sym_false] = ACTIONS(2677),
    [anon_sym_NULL] = ACTIONS(2677),
    [anon_sym_nullptr] = ACTIONS(2677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2677),
    [anon_sym_let] = ACTIONS(2677),
    [anon_sym_This] = ACTIONS(2677),
    [anon_sym_decltype] = ACTIONS(2677),
    [sym_virtual] = ACTIONS(2677),
    [anon_sym_typename] = ACTIONS(2677),
    [anon_sym_template] = ACTIONS(2677),
    [anon_sym_try] = ACTIONS(2677),
    [anon_sym_delete] = ACTIONS(2677),
    [anon_sym_throw] = ACTIONS(2677),
    [anon_sym_co_return] = ACTIONS(2677),
    [anon_sym_co_yield] = ACTIONS(2677),
    [anon_sym_catch] = ACTIONS(4847),
    [anon_sym_R_DQUOTE] = ACTIONS(2679),
    [anon_sym_LR_DQUOTE] = ACTIONS(2679),
    [anon_sym_uR_DQUOTE] = ACTIONS(2679),
    [anon_sym_UR_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2679),
    [anon_sym_co_await] = ACTIONS(2677),
    [anon_sym_new] = ACTIONS(2677),
    [anon_sym_requires] = ACTIONS(2677),
    [sym_this] = ACTIONS(2677),
    [anon_sym_discard] = ACTIONS(2677),
    [anon_sym_precise] = ACTIONS(2677),
    [anon_sym_shared] = ACTIONS(2677),
    [anon_sym_groupshared] = ACTIONS(2677),
    [anon_sym_uniform] = ACTIONS(2677),
    [anon_sym_row_major] = ACTIONS(2677),
    [anon_sym_column_major] = ACTIONS(2677),
    [anon_sym_globallycoherent] = ACTIONS(2677),
    [anon_sym_centroid] = ACTIONS(2677),
    [anon_sym_noperspective] = ACTIONS(2677),
    [anon_sym_nointerpolation] = ACTIONS(2677),
    [anon_sym_sample] = ACTIONS(2677),
    [anon_sym_linear] = ACTIONS(2677),
    [anon_sym_snorm] = ACTIONS(2677),
    [anon_sym_unorm] = ACTIONS(2677),
    [anon_sym_point] = ACTIONS(2677),
    [anon_sym_line] = ACTIONS(2677),
    [anon_sym_triangleadj] = ACTIONS(2677),
    [anon_sym_lineadj] = ACTIONS(2677),
    [anon_sym_triangle] = ACTIONS(2677),
    [anon_sym_cbuffer] = ACTIONS(2677),
    [anon_sym_interface] = ACTIONS(2677),
    [anon_sym_extension] = ACTIONS(2677),
  },
  [1235] = {
    [sym_catch_clause] = STATE(1235),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1235),
    [sym_identifier] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(2733),
    [anon_sym_BANG] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2731),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2733),
    [anon_sym_SEMI] = ACTIONS(2733),
    [anon_sym___extension__] = ACTIONS(2731),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_in] = ACTIONS(2731),
    [anon_sym_out] = ACTIONS(2731),
    [anon_sym_inout] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2733),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym__Alignas] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [anon_sym_if] = ACTIONS(2731),
    [anon_sym_else] = ACTIONS(2731),
    [anon_sym_switch] = ACTIONS(2731),
    [anon_sym_while] = ACTIONS(2731),
    [anon_sym_do] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2731),
    [anon_sym_return] = ACTIONS(2731),
    [anon_sym_break] = ACTIONS(2731),
    [anon_sym_continue] = ACTIONS(2731),
    [anon_sym_goto] = ACTIONS(2731),
    [anon_sym___try] = ACTIONS(2731),
    [anon_sym___leave] = ACTIONS(2731),
    [anon_sym_not] = ACTIONS(2731),
    [anon_sym_compl] = ACTIONS(2731),
    [anon_sym_DASH_DASH] = ACTIONS(2733),
    [anon_sym_PLUS_PLUS] = ACTIONS(2733),
    [anon_sym_sizeof] = ACTIONS(2731),
    [anon_sym___alignof__] = ACTIONS(2731),
    [anon_sym___alignof] = ACTIONS(2731),
    [anon_sym__alignof] = ACTIONS(2731),
    [anon_sym_alignof] = ACTIONS(2731),
    [anon_sym__Alignof] = ACTIONS(2731),
    [anon_sym_offsetof] = ACTIONS(2731),
    [anon_sym__Generic] = ACTIONS(2731),
    [anon_sym_asm] = ACTIONS(2731),
    [anon_sym___asm__] = ACTIONS(2731),
    [sym_number_literal] = ACTIONS(2733),
    [anon_sym_L_SQUOTE] = ACTIONS(2733),
    [anon_sym_u_SQUOTE] = ACTIONS(2733),
    [anon_sym_U_SQUOTE] = ACTIONS(2733),
    [anon_sym_u8_SQUOTE] = ACTIONS(2733),
    [anon_sym_SQUOTE] = ACTIONS(2733),
    [anon_sym_L_DQUOTE] = ACTIONS(2733),
    [anon_sym_u_DQUOTE] = ACTIONS(2733),
    [anon_sym_U_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8_DQUOTE] = ACTIONS(2733),
    [anon_sym_DQUOTE] = ACTIONS(2733),
    [sym_true] = ACTIONS(2731),
    [sym_false] = ACTIONS(2731),
    [anon_sym_NULL] = ACTIONS(2731),
    [anon_sym_nullptr] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2731),
    [anon_sym_let] = ACTIONS(2731),
    [anon_sym_This] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(2731),
    [sym_virtual] = ACTIONS(2731),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(2731),
    [anon_sym_try] = ACTIONS(2731),
    [anon_sym_delete] = ACTIONS(2731),
    [anon_sym_throw] = ACTIONS(2731),
    [anon_sym_co_return] = ACTIONS(2731),
    [anon_sym_co_yield] = ACTIONS(2731),
    [anon_sym_catch] = ACTIONS(4849),
    [anon_sym_R_DQUOTE] = ACTIONS(2733),
    [anon_sym_LR_DQUOTE] = ACTIONS(2733),
    [anon_sym_uR_DQUOTE] = ACTIONS(2733),
    [anon_sym_UR_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2733),
    [anon_sym_co_await] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2731),
    [anon_sym_requires] = ACTIONS(2731),
    [sym_this] = ACTIONS(2731),
    [anon_sym_discard] = ACTIONS(2731),
    [anon_sym_precise] = ACTIONS(2731),
    [anon_sym_shared] = ACTIONS(2731),
    [anon_sym_groupshared] = ACTIONS(2731),
    [anon_sym_uniform] = ACTIONS(2731),
    [anon_sym_row_major] = ACTIONS(2731),
    [anon_sym_column_major] = ACTIONS(2731),
    [anon_sym_globallycoherent] = ACTIONS(2731),
    [anon_sym_centroid] = ACTIONS(2731),
    [anon_sym_noperspective] = ACTIONS(2731),
    [anon_sym_nointerpolation] = ACTIONS(2731),
    [anon_sym_sample] = ACTIONS(2731),
    [anon_sym_linear] = ACTIONS(2731),
    [anon_sym_snorm] = ACTIONS(2731),
    [anon_sym_unorm] = ACTIONS(2731),
    [anon_sym_point] = ACTIONS(2731),
    [anon_sym_line] = ACTIONS(2731),
    [anon_sym_triangleadj] = ACTIONS(2731),
    [anon_sym_lineadj] = ACTIONS(2731),
    [anon_sym_triangle] = ACTIONS(2731),
    [anon_sym_cbuffer] = ACTIONS(2731),
    [anon_sym_interface] = ACTIONS(2731),
    [anon_sym_extension] = ACTIONS(2731),
  },
  [1236] = {
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_LPAREN2] = ACTIONS(2371),
    [anon_sym_BANG] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2371),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym___extension__] = ACTIONS(2373),
    [anon_sym_typedef] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_out] = ACTIONS(2373),
    [anon_sym_inout] = ACTIONS(2373),
    [anon_sym_extern] = ACTIONS(2373),
    [anon_sym___attribute__] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2371),
    [anon_sym___declspec] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_signed] = ACTIONS(2373),
    [anon_sym_unsigned] = ACTIONS(2373),
    [anon_sym_long] = ACTIONS(2373),
    [anon_sym_short] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2373),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_register] = ACTIONS(2373),
    [anon_sym_inline] = ACTIONS(2373),
    [anon_sym___inline] = ACTIONS(2373),
    [anon_sym___inline__] = ACTIONS(2373),
    [anon_sym___forceinline] = ACTIONS(2373),
    [anon_sym_thread_local] = ACTIONS(2373),
    [anon_sym___thread] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym___restrict__] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym__Noreturn] = ACTIONS(2373),
    [anon_sym_noreturn] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_constinit] = ACTIONS(2373),
    [anon_sym_consteval] = ACTIONS(2373),
    [anon_sym_alignas] = ACTIONS(2373),
    [anon_sym__Alignas] = ACTIONS(2373),
    [sym_primitive_type] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_class] = ACTIONS(2373),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_else] = ACTIONS(2373),
    [anon_sym_switch] = ACTIONS(2373),
    [anon_sym_while] = ACTIONS(2373),
    [anon_sym_do] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2373),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2373),
    [anon_sym_goto] = ACTIONS(2373),
    [anon_sym___try] = ACTIONS(2373),
    [anon_sym___leave] = ACTIONS(2373),
    [anon_sym_not] = ACTIONS(2373),
    [anon_sym_compl] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_sizeof] = ACTIONS(2373),
    [anon_sym___alignof__] = ACTIONS(2373),
    [anon_sym___alignof] = ACTIONS(2373),
    [anon_sym__alignof] = ACTIONS(2373),
    [anon_sym_alignof] = ACTIONS(2373),
    [anon_sym__Alignof] = ACTIONS(2373),
    [anon_sym_offsetof] = ACTIONS(2373),
    [anon_sym__Generic] = ACTIONS(2373),
    [anon_sym_asm] = ACTIONS(2373),
    [anon_sym___asm__] = ACTIONS(2373),
    [sym_number_literal] = ACTIONS(2371),
    [anon_sym_L_SQUOTE] = ACTIONS(2371),
    [anon_sym_u_SQUOTE] = ACTIONS(2371),
    [anon_sym_U_SQUOTE] = ACTIONS(2371),
    [anon_sym_u8_SQUOTE] = ACTIONS(2371),
    [anon_sym_SQUOTE] = ACTIONS(2371),
    [anon_sym_L_DQUOTE] = ACTIONS(2371),
    [anon_sym_u_DQUOTE] = ACTIONS(2371),
    [anon_sym_U_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8_DQUOTE] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [anon_sym_NULL] = ACTIONS(2373),
    [anon_sym_nullptr] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_This] = ACTIONS(2373),
    [anon_sym_decltype] = ACTIONS(2373),
    [anon_sym_final] = ACTIONS(2373),
    [anon_sym_override] = ACTIONS(2373),
    [sym_virtual] = ACTIONS(2373),
    [anon_sym_typename] = ACTIONS(2373),
    [anon_sym_template] = ACTIONS(2373),
    [anon_sym_try] = ACTIONS(2373),
    [anon_sym_delete] = ACTIONS(2373),
    [anon_sym_throw] = ACTIONS(2373),
    [anon_sym_co_return] = ACTIONS(2373),
    [anon_sym_co_yield] = ACTIONS(2373),
    [anon_sym_R_DQUOTE] = ACTIONS(2371),
    [anon_sym_LR_DQUOTE] = ACTIONS(2371),
    [anon_sym_uR_DQUOTE] = ACTIONS(2371),
    [anon_sym_UR_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2371),
    [anon_sym_co_await] = ACTIONS(2373),
    [anon_sym_new] = ACTIONS(2373),
    [anon_sym_requires] = ACTIONS(2373),
    [sym_this] = ACTIONS(2373),
    [anon_sym_discard] = ACTIONS(2373),
    [anon_sym_precise] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_groupshared] = ACTIONS(2373),
    [anon_sym_uniform] = ACTIONS(2373),
    [anon_sym_row_major] = ACTIONS(2373),
    [anon_sym_column_major] = ACTIONS(2373),
    [anon_sym_globallycoherent] = ACTIONS(2373),
    [anon_sym_centroid] = ACTIONS(2373),
    [anon_sym_noperspective] = ACTIONS(2373),
    [anon_sym_nointerpolation] = ACTIONS(2373),
    [anon_sym_sample] = ACTIONS(2373),
    [anon_sym_linear] = ACTIONS(2373),
    [anon_sym_snorm] = ACTIONS(2373),
    [anon_sym_unorm] = ACTIONS(2373),
    [anon_sym_point] = ACTIONS(2373),
    [anon_sym_line] = ACTIONS(2373),
    [anon_sym_triangleadj] = ACTIONS(2373),
    [anon_sym_lineadj] = ACTIONS(2373),
    [anon_sym_triangle] = ACTIONS(2373),
    [anon_sym_cbuffer] = ACTIONS(2373),
    [anon_sym_interface] = ACTIONS(2373),
    [anon_sym_extension] = ACTIONS(2373),
  },
  [1237] = {
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_LPAREN2] = ACTIONS(2371),
    [anon_sym_BANG] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2371),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym___extension__] = ACTIONS(2373),
    [anon_sym_typedef] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_out] = ACTIONS(2373),
    [anon_sym_inout] = ACTIONS(2373),
    [anon_sym_extern] = ACTIONS(2373),
    [anon_sym___attribute__] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2371),
    [anon_sym___declspec] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_signed] = ACTIONS(2373),
    [anon_sym_unsigned] = ACTIONS(2373),
    [anon_sym_long] = ACTIONS(2373),
    [anon_sym_short] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2373),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_register] = ACTIONS(2373),
    [anon_sym_inline] = ACTIONS(2373),
    [anon_sym___inline] = ACTIONS(2373),
    [anon_sym___inline__] = ACTIONS(2373),
    [anon_sym___forceinline] = ACTIONS(2373),
    [anon_sym_thread_local] = ACTIONS(2373),
    [anon_sym___thread] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym___restrict__] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym__Noreturn] = ACTIONS(2373),
    [anon_sym_noreturn] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_constinit] = ACTIONS(2373),
    [anon_sym_consteval] = ACTIONS(2373),
    [anon_sym_alignas] = ACTIONS(2373),
    [anon_sym__Alignas] = ACTIONS(2373),
    [sym_primitive_type] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_class] = ACTIONS(2373),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_else] = ACTIONS(2373),
    [anon_sym_switch] = ACTIONS(2373),
    [anon_sym_while] = ACTIONS(2373),
    [anon_sym_do] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2373),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2373),
    [anon_sym_goto] = ACTIONS(2373),
    [anon_sym___try] = ACTIONS(2373),
    [anon_sym___leave] = ACTIONS(2373),
    [anon_sym_not] = ACTIONS(2373),
    [anon_sym_compl] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_sizeof] = ACTIONS(2373),
    [anon_sym___alignof__] = ACTIONS(2373),
    [anon_sym___alignof] = ACTIONS(2373),
    [anon_sym__alignof] = ACTIONS(2373),
    [anon_sym_alignof] = ACTIONS(2373),
    [anon_sym__Alignof] = ACTIONS(2373),
    [anon_sym_offsetof] = ACTIONS(2373),
    [anon_sym__Generic] = ACTIONS(2373),
    [anon_sym_asm] = ACTIONS(2373),
    [anon_sym___asm__] = ACTIONS(2373),
    [sym_number_literal] = ACTIONS(2371),
    [anon_sym_L_SQUOTE] = ACTIONS(2371),
    [anon_sym_u_SQUOTE] = ACTIONS(2371),
    [anon_sym_U_SQUOTE] = ACTIONS(2371),
    [anon_sym_u8_SQUOTE] = ACTIONS(2371),
    [anon_sym_SQUOTE] = ACTIONS(2371),
    [anon_sym_L_DQUOTE] = ACTIONS(2371),
    [anon_sym_u_DQUOTE] = ACTIONS(2371),
    [anon_sym_U_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8_DQUOTE] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [anon_sym_NULL] = ACTIONS(2373),
    [anon_sym_nullptr] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_This] = ACTIONS(2373),
    [anon_sym_decltype] = ACTIONS(2373),
    [anon_sym_final] = ACTIONS(2373),
    [anon_sym_override] = ACTIONS(2373),
    [sym_virtual] = ACTIONS(2373),
    [anon_sym_typename] = ACTIONS(2373),
    [anon_sym_template] = ACTIONS(2373),
    [anon_sym_try] = ACTIONS(2373),
    [anon_sym_delete] = ACTIONS(2373),
    [anon_sym_throw] = ACTIONS(2373),
    [anon_sym_co_return] = ACTIONS(2373),
    [anon_sym_co_yield] = ACTIONS(2373),
    [anon_sym_R_DQUOTE] = ACTIONS(2371),
    [anon_sym_LR_DQUOTE] = ACTIONS(2371),
    [anon_sym_uR_DQUOTE] = ACTIONS(2371),
    [anon_sym_UR_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2371),
    [anon_sym_co_await] = ACTIONS(2373),
    [anon_sym_new] = ACTIONS(2373),
    [anon_sym_requires] = ACTIONS(2373),
    [sym_this] = ACTIONS(2373),
    [anon_sym_discard] = ACTIONS(2373),
    [anon_sym_precise] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_groupshared] = ACTIONS(2373),
    [anon_sym_uniform] = ACTIONS(2373),
    [anon_sym_row_major] = ACTIONS(2373),
    [anon_sym_column_major] = ACTIONS(2373),
    [anon_sym_globallycoherent] = ACTIONS(2373),
    [anon_sym_centroid] = ACTIONS(2373),
    [anon_sym_noperspective] = ACTIONS(2373),
    [anon_sym_nointerpolation] = ACTIONS(2373),
    [anon_sym_sample] = ACTIONS(2373),
    [anon_sym_linear] = ACTIONS(2373),
    [anon_sym_snorm] = ACTIONS(2373),
    [anon_sym_unorm] = ACTIONS(2373),
    [anon_sym_point] = ACTIONS(2373),
    [anon_sym_line] = ACTIONS(2373),
    [anon_sym_triangleadj] = ACTIONS(2373),
    [anon_sym_lineadj] = ACTIONS(2373),
    [anon_sym_triangle] = ACTIONS(2373),
    [anon_sym_cbuffer] = ACTIONS(2373),
    [anon_sym_interface] = ACTIONS(2373),
    [anon_sym_extension] = ACTIONS(2373),
  },
  [1238] = {
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_BANG] = ACTIONS(2230),
    [anon_sym_TILDE] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2228),
    [anon_sym_PLUS] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(2230),
    [anon_sym_AMP] = ACTIONS(2230),
    [anon_sym_COLON] = ACTIONS(2228),
    [anon_sym_SEMI] = ACTIONS(2230),
    [anon_sym___extension__] = ACTIONS(2228),
    [anon_sym_typedef] = ACTIONS(2228),
    [anon_sym_in] = ACTIONS(2228),
    [anon_sym_out] = ACTIONS(2228),
    [anon_sym_inout] = ACTIONS(2228),
    [anon_sym_extern] = ACTIONS(2228),
    [anon_sym___attribute__] = ACTIONS(2228),
    [anon_sym_COLON_COLON] = ACTIONS(2230),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2230),
    [anon_sym___declspec] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_signed] = ACTIONS(2228),
    [anon_sym_unsigned] = ACTIONS(2228),
    [anon_sym_long] = ACTIONS(2228),
    [anon_sym_short] = ACTIONS(2228),
    [anon_sym_LBRACK] = ACTIONS(2228),
    [anon_sym_static] = ACTIONS(2228),
    [anon_sym_register] = ACTIONS(2228),
    [anon_sym_inline] = ACTIONS(2228),
    [anon_sym___inline] = ACTIONS(2228),
    [anon_sym___inline__] = ACTIONS(2228),
    [anon_sym___forceinline] = ACTIONS(2228),
    [anon_sym_thread_local] = ACTIONS(2228),
    [anon_sym___thread] = ACTIONS(2228),
    [anon_sym_const] = ACTIONS(2228),
    [anon_sym_constexpr] = ACTIONS(2228),
    [anon_sym_volatile] = ACTIONS(2228),
    [anon_sym_restrict] = ACTIONS(2228),
    [anon_sym___restrict__] = ACTIONS(2228),
    [anon_sym__Atomic] = ACTIONS(2228),
    [anon_sym__Noreturn] = ACTIONS(2228),
    [anon_sym_noreturn] = ACTIONS(2228),
    [anon_sym_mutable] = ACTIONS(2228),
    [anon_sym_constinit] = ACTIONS(2228),
    [anon_sym_consteval] = ACTIONS(2228),
    [anon_sym_alignas] = ACTIONS(2228),
    [anon_sym__Alignas] = ACTIONS(2228),
    [sym_primitive_type] = ACTIONS(2228),
    [anon_sym_enum] = ACTIONS(2228),
    [anon_sym_class] = ACTIONS(2228),
    [anon_sym_struct] = ACTIONS(2228),
    [anon_sym_union] = ACTIONS(2228),
    [anon_sym_if] = ACTIONS(2228),
    [anon_sym_else] = ACTIONS(2228),
    [anon_sym_switch] = ACTIONS(2228),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2228),
    [anon_sym_for] = ACTIONS(2228),
    [anon_sym_return] = ACTIONS(2228),
    [anon_sym_break] = ACTIONS(2228),
    [anon_sym_continue] = ACTIONS(2228),
    [anon_sym_goto] = ACTIONS(2228),
    [anon_sym___try] = ACTIONS(2228),
    [anon_sym___leave] = ACTIONS(2228),
    [anon_sym_not] = ACTIONS(2228),
    [anon_sym_compl] = ACTIONS(2228),
    [anon_sym_DASH_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_PLUS] = ACTIONS(2230),
    [anon_sym_sizeof] = ACTIONS(2228),
    [anon_sym___alignof__] = ACTIONS(2228),
    [anon_sym___alignof] = ACTIONS(2228),
    [anon_sym__alignof] = ACTIONS(2228),
    [anon_sym_alignof] = ACTIONS(2228),
    [anon_sym__Alignof] = ACTIONS(2228),
    [anon_sym_offsetof] = ACTIONS(2228),
    [anon_sym__Generic] = ACTIONS(2228),
    [anon_sym_asm] = ACTIONS(2228),
    [anon_sym___asm__] = ACTIONS(2228),
    [sym_number_literal] = ACTIONS(2230),
    [anon_sym_L_SQUOTE] = ACTIONS(2230),
    [anon_sym_u_SQUOTE] = ACTIONS(2230),
    [anon_sym_U_SQUOTE] = ACTIONS(2230),
    [anon_sym_u8_SQUOTE] = ACTIONS(2230),
    [anon_sym_SQUOTE] = ACTIONS(2230),
    [anon_sym_L_DQUOTE] = ACTIONS(2230),
    [anon_sym_u_DQUOTE] = ACTIONS(2230),
    [anon_sym_U_DQUOTE] = ACTIONS(2230),
    [anon_sym_u8_DQUOTE] = ACTIONS(2230),
    [anon_sym_DQUOTE] = ACTIONS(2230),
    [sym_true] = ACTIONS(2228),
    [sym_false] = ACTIONS(2228),
    [anon_sym_NULL] = ACTIONS(2228),
    [anon_sym_nullptr] = ACTIONS(2228),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(2228),
    [anon_sym_This] = ACTIONS(2228),
    [anon_sym_decltype] = ACTIONS(2228),
    [anon_sym_final] = ACTIONS(2228),
    [anon_sym_override] = ACTIONS(2228),
    [sym_virtual] = ACTIONS(2228),
    [anon_sym_typename] = ACTIONS(2228),
    [anon_sym_template] = ACTIONS(2228),
    [anon_sym_try] = ACTIONS(2228),
    [anon_sym_delete] = ACTIONS(2228),
    [anon_sym_throw] = ACTIONS(2228),
    [anon_sym_co_return] = ACTIONS(2228),
    [anon_sym_co_yield] = ACTIONS(2228),
    [anon_sym_R_DQUOTE] = ACTIONS(2230),
    [anon_sym_LR_DQUOTE] = ACTIONS(2230),
    [anon_sym_uR_DQUOTE] = ACTIONS(2230),
    [anon_sym_UR_DQUOTE] = ACTIONS(2230),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2230),
    [anon_sym_co_await] = ACTIONS(2228),
    [anon_sym_new] = ACTIONS(2228),
    [anon_sym_requires] = ACTIONS(2228),
    [sym_this] = ACTIONS(2228),
    [anon_sym_discard] = ACTIONS(2228),
    [anon_sym_precise] = ACTIONS(2228),
    [anon_sym_shared] = ACTIONS(2228),
    [anon_sym_groupshared] = ACTIONS(2228),
    [anon_sym_uniform] = ACTIONS(2228),
    [anon_sym_row_major] = ACTIONS(2228),
    [anon_sym_column_major] = ACTIONS(2228),
    [anon_sym_globallycoherent] = ACTIONS(2228),
    [anon_sym_centroid] = ACTIONS(2228),
    [anon_sym_noperspective] = ACTIONS(2228),
    [anon_sym_nointerpolation] = ACTIONS(2228),
    [anon_sym_sample] = ACTIONS(2228),
    [anon_sym_linear] = ACTIONS(2228),
    [anon_sym_snorm] = ACTIONS(2228),
    [anon_sym_unorm] = ACTIONS(2228),
    [anon_sym_point] = ACTIONS(2228),
    [anon_sym_line] = ACTIONS(2228),
    [anon_sym_triangleadj] = ACTIONS(2228),
    [anon_sym_lineadj] = ACTIONS(2228),
    [anon_sym_triangle] = ACTIONS(2228),
    [anon_sym_cbuffer] = ACTIONS(2228),
    [anon_sym_interface] = ACTIONS(2228),
    [anon_sym_extension] = ACTIONS(2228),
  },
  [1239] = {
    [sym_identifier] = ACTIONS(2232),
    [anon_sym_LPAREN2] = ACTIONS(2234),
    [anon_sym_BANG] = ACTIONS(2234),
    [anon_sym_TILDE] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2232),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2234),
    [anon_sym_COLON] = ACTIONS(2232),
    [anon_sym_SEMI] = ACTIONS(2234),
    [anon_sym___extension__] = ACTIONS(2232),
    [anon_sym_typedef] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2232),
    [anon_sym_out] = ACTIONS(2232),
    [anon_sym_inout] = ACTIONS(2232),
    [anon_sym_extern] = ACTIONS(2232),
    [anon_sym___attribute__] = ACTIONS(2232),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2234),
    [anon_sym___declspec] = ACTIONS(2232),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_signed] = ACTIONS(2232),
    [anon_sym_unsigned] = ACTIONS(2232),
    [anon_sym_long] = ACTIONS(2232),
    [anon_sym_short] = ACTIONS(2232),
    [anon_sym_LBRACK] = ACTIONS(2232),
    [anon_sym_static] = ACTIONS(2232),
    [anon_sym_register] = ACTIONS(2232),
    [anon_sym_inline] = ACTIONS(2232),
    [anon_sym___inline] = ACTIONS(2232),
    [anon_sym___inline__] = ACTIONS(2232),
    [anon_sym___forceinline] = ACTIONS(2232),
    [anon_sym_thread_local] = ACTIONS(2232),
    [anon_sym___thread] = ACTIONS(2232),
    [anon_sym_const] = ACTIONS(2232),
    [anon_sym_constexpr] = ACTIONS(2232),
    [anon_sym_volatile] = ACTIONS(2232),
    [anon_sym_restrict] = ACTIONS(2232),
    [anon_sym___restrict__] = ACTIONS(2232),
    [anon_sym__Atomic] = ACTIONS(2232),
    [anon_sym__Noreturn] = ACTIONS(2232),
    [anon_sym_noreturn] = ACTIONS(2232),
    [anon_sym_mutable] = ACTIONS(2232),
    [anon_sym_constinit] = ACTIONS(2232),
    [anon_sym_consteval] = ACTIONS(2232),
    [anon_sym_alignas] = ACTIONS(2232),
    [anon_sym__Alignas] = ACTIONS(2232),
    [sym_primitive_type] = ACTIONS(2232),
    [anon_sym_enum] = ACTIONS(2232),
    [anon_sym_class] = ACTIONS(2232),
    [anon_sym_struct] = ACTIONS(2232),
    [anon_sym_union] = ACTIONS(2232),
    [anon_sym_if] = ACTIONS(2232),
    [anon_sym_else] = ACTIONS(2232),
    [anon_sym_switch] = ACTIONS(2232),
    [anon_sym_while] = ACTIONS(2232),
    [anon_sym_do] = ACTIONS(2232),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2232),
    [anon_sym_break] = ACTIONS(2232),
    [anon_sym_continue] = ACTIONS(2232),
    [anon_sym_goto] = ACTIONS(2232),
    [anon_sym___try] = ACTIONS(2232),
    [anon_sym___leave] = ACTIONS(2232),
    [anon_sym_not] = ACTIONS(2232),
    [anon_sym_compl] = ACTIONS(2232),
    [anon_sym_DASH_DASH] = ACTIONS(2234),
    [anon_sym_PLUS_PLUS] = ACTIONS(2234),
    [anon_sym_sizeof] = ACTIONS(2232),
    [anon_sym___alignof__] = ACTIONS(2232),
    [anon_sym___alignof] = ACTIONS(2232),
    [anon_sym__alignof] = ACTIONS(2232),
    [anon_sym_alignof] = ACTIONS(2232),
    [anon_sym__Alignof] = ACTIONS(2232),
    [anon_sym_offsetof] = ACTIONS(2232),
    [anon_sym__Generic] = ACTIONS(2232),
    [anon_sym_asm] = ACTIONS(2232),
    [anon_sym___asm__] = ACTIONS(2232),
    [sym_number_literal] = ACTIONS(2234),
    [anon_sym_L_SQUOTE] = ACTIONS(2234),
    [anon_sym_u_SQUOTE] = ACTIONS(2234),
    [anon_sym_U_SQUOTE] = ACTIONS(2234),
    [anon_sym_u8_SQUOTE] = ACTIONS(2234),
    [anon_sym_SQUOTE] = ACTIONS(2234),
    [anon_sym_L_DQUOTE] = ACTIONS(2234),
    [anon_sym_u_DQUOTE] = ACTIONS(2234),
    [anon_sym_U_DQUOTE] = ACTIONS(2234),
    [anon_sym_u8_DQUOTE] = ACTIONS(2234),
    [anon_sym_DQUOTE] = ACTIONS(2234),
    [sym_true] = ACTIONS(2232),
    [sym_false] = ACTIONS(2232),
    [anon_sym_NULL] = ACTIONS(2232),
    [anon_sym_nullptr] = ACTIONS(2232),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2232),
    [anon_sym_let] = ACTIONS(2232),
    [anon_sym_This] = ACTIONS(2232),
    [anon_sym_decltype] = ACTIONS(2232),
    [anon_sym_final] = ACTIONS(2232),
    [anon_sym_override] = ACTIONS(2232),
    [sym_virtual] = ACTIONS(2232),
    [anon_sym_typename] = ACTIONS(2232),
    [anon_sym_template] = ACTIONS(2232),
    [anon_sym_try] = ACTIONS(2232),
    [anon_sym_delete] = ACTIONS(2232),
    [anon_sym_throw] = ACTIONS(2232),
    [anon_sym_co_return] = ACTIONS(2232),
    [anon_sym_co_yield] = ACTIONS(2232),
    [anon_sym_R_DQUOTE] = ACTIONS(2234),
    [anon_sym_LR_DQUOTE] = ACTIONS(2234),
    [anon_sym_uR_DQUOTE] = ACTIONS(2234),
    [anon_sym_UR_DQUOTE] = ACTIONS(2234),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2234),
    [anon_sym_co_await] = ACTIONS(2232),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_requires] = ACTIONS(2232),
    [sym_this] = ACTIONS(2232),
    [anon_sym_discard] = ACTIONS(2232),
    [anon_sym_precise] = ACTIONS(2232),
    [anon_sym_shared] = ACTIONS(2232),
    [anon_sym_groupshared] = ACTIONS(2232),
    [anon_sym_uniform] = ACTIONS(2232),
    [anon_sym_row_major] = ACTIONS(2232),
    [anon_sym_column_major] = ACTIONS(2232),
    [anon_sym_globallycoherent] = ACTIONS(2232),
    [anon_sym_centroid] = ACTIONS(2232),
    [anon_sym_noperspective] = ACTIONS(2232),
    [anon_sym_nointerpolation] = ACTIONS(2232),
    [anon_sym_sample] = ACTIONS(2232),
    [anon_sym_linear] = ACTIONS(2232),
    [anon_sym_snorm] = ACTIONS(2232),
    [anon_sym_unorm] = ACTIONS(2232),
    [anon_sym_point] = ACTIONS(2232),
    [anon_sym_line] = ACTIONS(2232),
    [anon_sym_triangleadj] = ACTIONS(2232),
    [anon_sym_lineadj] = ACTIONS(2232),
    [anon_sym_triangle] = ACTIONS(2232),
    [anon_sym_cbuffer] = ACTIONS(2232),
    [anon_sym_interface] = ACTIONS(2232),
    [anon_sym_extension] = ACTIONS(2232),
  },
  [1240] = {
    [sym_identifier] = ACTIONS(2244),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2244),
    [anon_sym_PLUS] = ACTIONS(2244),
    [anon_sym_STAR] = ACTIONS(2246),
    [anon_sym_AMP] = ACTIONS(2246),
    [anon_sym_COLON] = ACTIONS(2244),
    [anon_sym_SEMI] = ACTIONS(2246),
    [anon_sym___extension__] = ACTIONS(2244),
    [anon_sym_typedef] = ACTIONS(2244),
    [anon_sym_in] = ACTIONS(2244),
    [anon_sym_out] = ACTIONS(2244),
    [anon_sym_inout] = ACTIONS(2244),
    [anon_sym_extern] = ACTIONS(2244),
    [anon_sym___attribute__] = ACTIONS(2244),
    [anon_sym_COLON_COLON] = ACTIONS(2246),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2246),
    [anon_sym___declspec] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_signed] = ACTIONS(2244),
    [anon_sym_unsigned] = ACTIONS(2244),
    [anon_sym_long] = ACTIONS(2244),
    [anon_sym_short] = ACTIONS(2244),
    [anon_sym_LBRACK] = ACTIONS(2244),
    [anon_sym_static] = ACTIONS(2244),
    [anon_sym_register] = ACTIONS(2244),
    [anon_sym_inline] = ACTIONS(2244),
    [anon_sym___inline] = ACTIONS(2244),
    [anon_sym___inline__] = ACTIONS(2244),
    [anon_sym___forceinline] = ACTIONS(2244),
    [anon_sym_thread_local] = ACTIONS(2244),
    [anon_sym___thread] = ACTIONS(2244),
    [anon_sym_const] = ACTIONS(2244),
    [anon_sym_constexpr] = ACTIONS(2244),
    [anon_sym_volatile] = ACTIONS(2244),
    [anon_sym_restrict] = ACTIONS(2244),
    [anon_sym___restrict__] = ACTIONS(2244),
    [anon_sym__Atomic] = ACTIONS(2244),
    [anon_sym__Noreturn] = ACTIONS(2244),
    [anon_sym_noreturn] = ACTIONS(2244),
    [anon_sym_mutable] = ACTIONS(2244),
    [anon_sym_constinit] = ACTIONS(2244),
    [anon_sym_consteval] = ACTIONS(2244),
    [anon_sym_alignas] = ACTIONS(2244),
    [anon_sym__Alignas] = ACTIONS(2244),
    [sym_primitive_type] = ACTIONS(2244),
    [anon_sym_enum] = ACTIONS(2244),
    [anon_sym_class] = ACTIONS(2244),
    [anon_sym_struct] = ACTIONS(2244),
    [anon_sym_union] = ACTIONS(2244),
    [anon_sym_if] = ACTIONS(2244),
    [anon_sym_else] = ACTIONS(2244),
    [anon_sym_switch] = ACTIONS(2244),
    [anon_sym_while] = ACTIONS(2244),
    [anon_sym_do] = ACTIONS(2244),
    [anon_sym_for] = ACTIONS(2244),
    [anon_sym_return] = ACTIONS(2244),
    [anon_sym_break] = ACTIONS(2244),
    [anon_sym_continue] = ACTIONS(2244),
    [anon_sym_goto] = ACTIONS(2244),
    [anon_sym___try] = ACTIONS(2244),
    [anon_sym___leave] = ACTIONS(2244),
    [anon_sym_not] = ACTIONS(2244),
    [anon_sym_compl] = ACTIONS(2244),
    [anon_sym_DASH_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_PLUS] = ACTIONS(2246),
    [anon_sym_sizeof] = ACTIONS(2244),
    [anon_sym___alignof__] = ACTIONS(2244),
    [anon_sym___alignof] = ACTIONS(2244),
    [anon_sym__alignof] = ACTIONS(2244),
    [anon_sym_alignof] = ACTIONS(2244),
    [anon_sym__Alignof] = ACTIONS(2244),
    [anon_sym_offsetof] = ACTIONS(2244),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2244),
    [anon_sym___asm__] = ACTIONS(2244),
    [sym_number_literal] = ACTIONS(2246),
    [anon_sym_L_SQUOTE] = ACTIONS(2246),
    [anon_sym_u_SQUOTE] = ACTIONS(2246),
    [anon_sym_U_SQUOTE] = ACTIONS(2246),
    [anon_sym_u8_SQUOTE] = ACTIONS(2246),
    [anon_sym_SQUOTE] = ACTIONS(2246),
    [anon_sym_L_DQUOTE] = ACTIONS(2246),
    [anon_sym_u_DQUOTE] = ACTIONS(2246),
    [anon_sym_U_DQUOTE] = ACTIONS(2246),
    [anon_sym_u8_DQUOTE] = ACTIONS(2246),
    [anon_sym_DQUOTE] = ACTIONS(2246),
    [sym_true] = ACTIONS(2244),
    [sym_false] = ACTIONS(2244),
    [anon_sym_NULL] = ACTIONS(2244),
    [anon_sym_nullptr] = ACTIONS(2244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2244),
    [anon_sym_let] = ACTIONS(2244),
    [anon_sym_This] = ACTIONS(2244),
    [anon_sym_decltype] = ACTIONS(2244),
    [anon_sym_final] = ACTIONS(2244),
    [anon_sym_override] = ACTIONS(2244),
    [sym_virtual] = ACTIONS(2244),
    [anon_sym_typename] = ACTIONS(2244),
    [anon_sym_template] = ACTIONS(2244),
    [anon_sym_try] = ACTIONS(2244),
    [anon_sym_delete] = ACTIONS(2244),
    [anon_sym_throw] = ACTIONS(2244),
    [anon_sym_co_return] = ACTIONS(2244),
    [anon_sym_co_yield] = ACTIONS(2244),
    [anon_sym_R_DQUOTE] = ACTIONS(2246),
    [anon_sym_LR_DQUOTE] = ACTIONS(2246),
    [anon_sym_uR_DQUOTE] = ACTIONS(2246),
    [anon_sym_UR_DQUOTE] = ACTIONS(2246),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2246),
    [anon_sym_co_await] = ACTIONS(2244),
    [anon_sym_new] = ACTIONS(2244),
    [anon_sym_requires] = ACTIONS(2244),
    [sym_this] = ACTIONS(2244),
    [anon_sym_discard] = ACTIONS(2244),
    [anon_sym_precise] = ACTIONS(2244),
    [anon_sym_shared] = ACTIONS(2244),
    [anon_sym_groupshared] = ACTIONS(2244),
    [anon_sym_uniform] = ACTIONS(2244),
    [anon_sym_row_major] = ACTIONS(2244),
    [anon_sym_column_major] = ACTIONS(2244),
    [anon_sym_globallycoherent] = ACTIONS(2244),
    [anon_sym_centroid] = ACTIONS(2244),
    [anon_sym_noperspective] = ACTIONS(2244),
    [anon_sym_nointerpolation] = ACTIONS(2244),
    [anon_sym_sample] = ACTIONS(2244),
    [anon_sym_linear] = ACTIONS(2244),
    [anon_sym_snorm] = ACTIONS(2244),
    [anon_sym_unorm] = ACTIONS(2244),
    [anon_sym_point] = ACTIONS(2244),
    [anon_sym_line] = ACTIONS(2244),
    [anon_sym_triangleadj] = ACTIONS(2244),
    [anon_sym_lineadj] = ACTIONS(2244),
    [anon_sym_triangle] = ACTIONS(2244),
    [anon_sym_cbuffer] = ACTIONS(2244),
    [anon_sym_interface] = ACTIONS(2244),
    [anon_sym_extension] = ACTIONS(2244),
  },
  [1241] = {
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_LPAREN2] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2254),
    [anon_sym_TILDE] = ACTIONS(2254),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2254),
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym_SEMI] = ACTIONS(2254),
    [anon_sym___extension__] = ACTIONS(2252),
    [anon_sym_typedef] = ACTIONS(2252),
    [anon_sym_in] = ACTIONS(2252),
    [anon_sym_out] = ACTIONS(2252),
    [anon_sym_inout] = ACTIONS(2252),
    [anon_sym_extern] = ACTIONS(2252),
    [anon_sym___attribute__] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2254),
    [anon_sym___declspec] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_signed] = ACTIONS(2252),
    [anon_sym_unsigned] = ACTIONS(2252),
    [anon_sym_long] = ACTIONS(2252),
    [anon_sym_short] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2252),
    [anon_sym_register] = ACTIONS(2252),
    [anon_sym_inline] = ACTIONS(2252),
    [anon_sym___inline] = ACTIONS(2252),
    [anon_sym___inline__] = ACTIONS(2252),
    [anon_sym___forceinline] = ACTIONS(2252),
    [anon_sym_thread_local] = ACTIONS(2252),
    [anon_sym___thread] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2252),
    [anon_sym_constexpr] = ACTIONS(2252),
    [anon_sym_volatile] = ACTIONS(2252),
    [anon_sym_restrict] = ACTIONS(2252),
    [anon_sym___restrict__] = ACTIONS(2252),
    [anon_sym__Atomic] = ACTIONS(2252),
    [anon_sym__Noreturn] = ACTIONS(2252),
    [anon_sym_noreturn] = ACTIONS(2252),
    [anon_sym_mutable] = ACTIONS(2252),
    [anon_sym_constinit] = ACTIONS(2252),
    [anon_sym_consteval] = ACTIONS(2252),
    [anon_sym_alignas] = ACTIONS(2252),
    [anon_sym__Alignas] = ACTIONS(2252),
    [sym_primitive_type] = ACTIONS(2252),
    [anon_sym_enum] = ACTIONS(2252),
    [anon_sym_class] = ACTIONS(2252),
    [anon_sym_struct] = ACTIONS(2252),
    [anon_sym_union] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_else] = ACTIONS(2252),
    [anon_sym_switch] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_do] = ACTIONS(2252),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2252),
    [anon_sym_goto] = ACTIONS(2252),
    [anon_sym___try] = ACTIONS(2252),
    [anon_sym___leave] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2252),
    [anon_sym_compl] = ACTIONS(2252),
    [anon_sym_DASH_DASH] = ACTIONS(2254),
    [anon_sym_PLUS_PLUS] = ACTIONS(2254),
    [anon_sym_sizeof] = ACTIONS(2252),
    [anon_sym___alignof__] = ACTIONS(2252),
    [anon_sym___alignof] = ACTIONS(2252),
    [anon_sym__alignof] = ACTIONS(2252),
    [anon_sym_alignof] = ACTIONS(2252),
    [anon_sym__Alignof] = ACTIONS(2252),
    [anon_sym_offsetof] = ACTIONS(2252),
    [anon_sym__Generic] = ACTIONS(2252),
    [anon_sym_asm] = ACTIONS(2252),
    [anon_sym___asm__] = ACTIONS(2252),
    [sym_number_literal] = ACTIONS(2254),
    [anon_sym_L_SQUOTE] = ACTIONS(2254),
    [anon_sym_u_SQUOTE] = ACTIONS(2254),
    [anon_sym_U_SQUOTE] = ACTIONS(2254),
    [anon_sym_u8_SQUOTE] = ACTIONS(2254),
    [anon_sym_SQUOTE] = ACTIONS(2254),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2252),
    [sym_false] = ACTIONS(2252),
    [anon_sym_NULL] = ACTIONS(2252),
    [anon_sym_nullptr] = ACTIONS(2252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_This] = ACTIONS(2252),
    [anon_sym_decltype] = ACTIONS(2252),
    [anon_sym_final] = ACTIONS(2252),
    [anon_sym_override] = ACTIONS(2252),
    [sym_virtual] = ACTIONS(2252),
    [anon_sym_typename] = ACTIONS(2252),
    [anon_sym_template] = ACTIONS(2252),
    [anon_sym_try] = ACTIONS(2252),
    [anon_sym_delete] = ACTIONS(2252),
    [anon_sym_throw] = ACTIONS(2252),
    [anon_sym_co_return] = ACTIONS(2252),
    [anon_sym_co_yield] = ACTIONS(2252),
    [anon_sym_R_DQUOTE] = ACTIONS(2254),
    [anon_sym_LR_DQUOTE] = ACTIONS(2254),
    [anon_sym_uR_DQUOTE] = ACTIONS(2254),
    [anon_sym_UR_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2254),
    [anon_sym_co_await] = ACTIONS(2252),
    [anon_sym_new] = ACTIONS(2252),
    [anon_sym_requires] = ACTIONS(2252),
    [sym_this] = ACTIONS(2252),
    [anon_sym_discard] = ACTIONS(2252),
    [anon_sym_precise] = ACTIONS(2252),
    [anon_sym_shared] = ACTIONS(2252),
    [anon_sym_groupshared] = ACTIONS(2252),
    [anon_sym_uniform] = ACTIONS(2252),
    [anon_sym_row_major] = ACTIONS(2252),
    [anon_sym_column_major] = ACTIONS(2252),
    [anon_sym_globallycoherent] = ACTIONS(2252),
    [anon_sym_centroid] = ACTIONS(2252),
    [anon_sym_noperspective] = ACTIONS(2252),
    [anon_sym_nointerpolation] = ACTIONS(2252),
    [anon_sym_sample] = ACTIONS(2252),
    [anon_sym_linear] = ACTIONS(2252),
    [anon_sym_snorm] = ACTIONS(2252),
    [anon_sym_unorm] = ACTIONS(2252),
    [anon_sym_point] = ACTIONS(2252),
    [anon_sym_line] = ACTIONS(2252),
    [anon_sym_triangleadj] = ACTIONS(2252),
    [anon_sym_lineadj] = ACTIONS(2252),
    [anon_sym_triangle] = ACTIONS(2252),
    [anon_sym_cbuffer] = ACTIONS(2252),
    [anon_sym_interface] = ACTIONS(2252),
    [anon_sym_extension] = ACTIONS(2252),
  },
  [1242] = {
    [sym_identifier] = ACTIONS(2363),
    [anon_sym_LPAREN2] = ACTIONS(2361),
    [anon_sym_BANG] = ACTIONS(2361),
    [anon_sym_TILDE] = ACTIONS(2361),
    [anon_sym_DASH] = ACTIONS(2363),
    [anon_sym_PLUS] = ACTIONS(2363),
    [anon_sym_STAR] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_COLON] = ACTIONS(2363),
    [anon_sym_SEMI] = ACTIONS(2361),
    [anon_sym___extension__] = ACTIONS(2363),
    [anon_sym_typedef] = ACTIONS(2363),
    [anon_sym_in] = ACTIONS(2363),
    [anon_sym_out] = ACTIONS(2363),
    [anon_sym_inout] = ACTIONS(2363),
    [anon_sym_extern] = ACTIONS(2363),
    [anon_sym___attribute__] = ACTIONS(2363),
    [anon_sym_COLON_COLON] = ACTIONS(2361),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2361),
    [anon_sym___declspec] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_signed] = ACTIONS(2363),
    [anon_sym_unsigned] = ACTIONS(2363),
    [anon_sym_long] = ACTIONS(2363),
    [anon_sym_short] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(2363),
    [anon_sym_static] = ACTIONS(2363),
    [anon_sym_register] = ACTIONS(2363),
    [anon_sym_inline] = ACTIONS(2363),
    [anon_sym___inline] = ACTIONS(2363),
    [anon_sym___inline__] = ACTIONS(2363),
    [anon_sym___forceinline] = ACTIONS(2363),
    [anon_sym_thread_local] = ACTIONS(2363),
    [anon_sym___thread] = ACTIONS(2363),
    [anon_sym_const] = ACTIONS(2363),
    [anon_sym_constexpr] = ACTIONS(2363),
    [anon_sym_volatile] = ACTIONS(2363),
    [anon_sym_restrict] = ACTIONS(2363),
    [anon_sym___restrict__] = ACTIONS(2363),
    [anon_sym__Atomic] = ACTIONS(2363),
    [anon_sym__Noreturn] = ACTIONS(2363),
    [anon_sym_noreturn] = ACTIONS(2363),
    [anon_sym_mutable] = ACTIONS(2363),
    [anon_sym_constinit] = ACTIONS(2363),
    [anon_sym_consteval] = ACTIONS(2363),
    [anon_sym_alignas] = ACTIONS(2363),
    [anon_sym__Alignas] = ACTIONS(2363),
    [sym_primitive_type] = ACTIONS(2363),
    [anon_sym_enum] = ACTIONS(2363),
    [anon_sym_class] = ACTIONS(2363),
    [anon_sym_struct] = ACTIONS(2363),
    [anon_sym_union] = ACTIONS(2363),
    [anon_sym_if] = ACTIONS(2363),
    [anon_sym_else] = ACTIONS(2363),
    [anon_sym_switch] = ACTIONS(2363),
    [anon_sym_while] = ACTIONS(2363),
    [anon_sym_do] = ACTIONS(2363),
    [anon_sym_for] = ACTIONS(2363),
    [anon_sym_return] = ACTIONS(2363),
    [anon_sym_break] = ACTIONS(2363),
    [anon_sym_continue] = ACTIONS(2363),
    [anon_sym_goto] = ACTIONS(2363),
    [anon_sym___try] = ACTIONS(2363),
    [anon_sym___leave] = ACTIONS(2363),
    [anon_sym_not] = ACTIONS(2363),
    [anon_sym_compl] = ACTIONS(2363),
    [anon_sym_DASH_DASH] = ACTIONS(2361),
    [anon_sym_PLUS_PLUS] = ACTIONS(2361),
    [anon_sym_sizeof] = ACTIONS(2363),
    [anon_sym___alignof__] = ACTIONS(2363),
    [anon_sym___alignof] = ACTIONS(2363),
    [anon_sym__alignof] = ACTIONS(2363),
    [anon_sym_alignof] = ACTIONS(2363),
    [anon_sym__Alignof] = ACTIONS(2363),
    [anon_sym_offsetof] = ACTIONS(2363),
    [anon_sym__Generic] = ACTIONS(2363),
    [anon_sym_asm] = ACTIONS(2363),
    [anon_sym___asm__] = ACTIONS(2363),
    [sym_number_literal] = ACTIONS(2361),
    [anon_sym_L_SQUOTE] = ACTIONS(2361),
    [anon_sym_u_SQUOTE] = ACTIONS(2361),
    [anon_sym_U_SQUOTE] = ACTIONS(2361),
    [anon_sym_u8_SQUOTE] = ACTIONS(2361),
    [anon_sym_SQUOTE] = ACTIONS(2361),
    [anon_sym_L_DQUOTE] = ACTIONS(2361),
    [anon_sym_u_DQUOTE] = ACTIONS(2361),
    [anon_sym_U_DQUOTE] = ACTIONS(2361),
    [anon_sym_u8_DQUOTE] = ACTIONS(2361),
    [anon_sym_DQUOTE] = ACTIONS(2361),
    [sym_true] = ACTIONS(2363),
    [sym_false] = ACTIONS(2363),
    [anon_sym_NULL] = ACTIONS(2363),
    [anon_sym_nullptr] = ACTIONS(2363),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2363),
    [anon_sym_let] = ACTIONS(2363),
    [anon_sym_This] = ACTIONS(2363),
    [anon_sym_decltype] = ACTIONS(2363),
    [anon_sym_final] = ACTIONS(2363),
    [anon_sym_override] = ACTIONS(2363),
    [sym_virtual] = ACTIONS(2363),
    [anon_sym_typename] = ACTIONS(2363),
    [anon_sym_template] = ACTIONS(2363),
    [anon_sym_try] = ACTIONS(2363),
    [anon_sym_delete] = ACTIONS(2363),
    [anon_sym_throw] = ACTIONS(2363),
    [anon_sym_co_return] = ACTIONS(2363),
    [anon_sym_co_yield] = ACTIONS(2363),
    [anon_sym_R_DQUOTE] = ACTIONS(2361),
    [anon_sym_LR_DQUOTE] = ACTIONS(2361),
    [anon_sym_uR_DQUOTE] = ACTIONS(2361),
    [anon_sym_UR_DQUOTE] = ACTIONS(2361),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2361),
    [anon_sym_co_await] = ACTIONS(2363),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_requires] = ACTIONS(2363),
    [sym_this] = ACTIONS(2363),
    [anon_sym_discard] = ACTIONS(2363),
    [anon_sym_precise] = ACTIONS(2363),
    [anon_sym_shared] = ACTIONS(2363),
    [anon_sym_groupshared] = ACTIONS(2363),
    [anon_sym_uniform] = ACTIONS(2363),
    [anon_sym_row_major] = ACTIONS(2363),
    [anon_sym_column_major] = ACTIONS(2363),
    [anon_sym_globallycoherent] = ACTIONS(2363),
    [anon_sym_centroid] = ACTIONS(2363),
    [anon_sym_noperspective] = ACTIONS(2363),
    [anon_sym_nointerpolation] = ACTIONS(2363),
    [anon_sym_sample] = ACTIONS(2363),
    [anon_sym_linear] = ACTIONS(2363),
    [anon_sym_snorm] = ACTIONS(2363),
    [anon_sym_unorm] = ACTIONS(2363),
    [anon_sym_point] = ACTIONS(2363),
    [anon_sym_line] = ACTIONS(2363),
    [anon_sym_triangleadj] = ACTIONS(2363),
    [anon_sym_lineadj] = ACTIONS(2363),
    [anon_sym_triangle] = ACTIONS(2363),
    [anon_sym_cbuffer] = ACTIONS(2363),
    [anon_sym_interface] = ACTIONS(2363),
    [anon_sym_extension] = ACTIONS(2363),
  },
  [1243] = {
    [sym_identifier] = ACTIONS(2190),
    [anon_sym_LPAREN2] = ACTIONS(2192),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2190),
    [anon_sym_PLUS] = ACTIONS(2190),
    [anon_sym_STAR] = ACTIONS(2192),
    [anon_sym_AMP] = ACTIONS(2192),
    [anon_sym_COLON] = ACTIONS(2190),
    [anon_sym_SEMI] = ACTIONS(2192),
    [anon_sym___extension__] = ACTIONS(2190),
    [anon_sym_typedef] = ACTIONS(2190),
    [anon_sym_in] = ACTIONS(2190),
    [anon_sym_out] = ACTIONS(2190),
    [anon_sym_inout] = ACTIONS(2190),
    [anon_sym_extern] = ACTIONS(2190),
    [anon_sym___attribute__] = ACTIONS(2190),
    [anon_sym_COLON_COLON] = ACTIONS(2192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2192),
    [anon_sym___declspec] = ACTIONS(2190),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [anon_sym_signed] = ACTIONS(2190),
    [anon_sym_unsigned] = ACTIONS(2190),
    [anon_sym_long] = ACTIONS(2190),
    [anon_sym_short] = ACTIONS(2190),
    [anon_sym_LBRACK] = ACTIONS(2190),
    [anon_sym_static] = ACTIONS(2190),
    [anon_sym_register] = ACTIONS(2190),
    [anon_sym_inline] = ACTIONS(2190),
    [anon_sym___inline] = ACTIONS(2190),
    [anon_sym___inline__] = ACTIONS(2190),
    [anon_sym___forceinline] = ACTIONS(2190),
    [anon_sym_thread_local] = ACTIONS(2190),
    [anon_sym___thread] = ACTIONS(2190),
    [anon_sym_const] = ACTIONS(2190),
    [anon_sym_constexpr] = ACTIONS(2190),
    [anon_sym_volatile] = ACTIONS(2190),
    [anon_sym_restrict] = ACTIONS(2190),
    [anon_sym___restrict__] = ACTIONS(2190),
    [anon_sym__Atomic] = ACTIONS(2190),
    [anon_sym__Noreturn] = ACTIONS(2190),
    [anon_sym_noreturn] = ACTIONS(2190),
    [anon_sym_mutable] = ACTIONS(2190),
    [anon_sym_constinit] = ACTIONS(2190),
    [anon_sym_consteval] = ACTIONS(2190),
    [anon_sym_alignas] = ACTIONS(2190),
    [anon_sym__Alignas] = ACTIONS(2190),
    [sym_primitive_type] = ACTIONS(2190),
    [anon_sym_enum] = ACTIONS(2190),
    [anon_sym_class] = ACTIONS(2190),
    [anon_sym_struct] = ACTIONS(2190),
    [anon_sym_union] = ACTIONS(2190),
    [anon_sym_if] = ACTIONS(2190),
    [anon_sym_else] = ACTIONS(2190),
    [anon_sym_switch] = ACTIONS(2190),
    [anon_sym_while] = ACTIONS(2190),
    [anon_sym_do] = ACTIONS(2190),
    [anon_sym_for] = ACTIONS(2190),
    [anon_sym_return] = ACTIONS(2190),
    [anon_sym_break] = ACTIONS(2190),
    [anon_sym_continue] = ACTIONS(2190),
    [anon_sym_goto] = ACTIONS(2190),
    [anon_sym___try] = ACTIONS(2190),
    [anon_sym___leave] = ACTIONS(2190),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_compl] = ACTIONS(2190),
    [anon_sym_DASH_DASH] = ACTIONS(2192),
    [anon_sym_PLUS_PLUS] = ACTIONS(2192),
    [anon_sym_sizeof] = ACTIONS(2190),
    [anon_sym___alignof__] = ACTIONS(2190),
    [anon_sym___alignof] = ACTIONS(2190),
    [anon_sym__alignof] = ACTIONS(2190),
    [anon_sym_alignof] = ACTIONS(2190),
    [anon_sym__Alignof] = ACTIONS(2190),
    [anon_sym_offsetof] = ACTIONS(2190),
    [anon_sym__Generic] = ACTIONS(2190),
    [anon_sym_asm] = ACTIONS(2190),
    [anon_sym___asm__] = ACTIONS(2190),
    [sym_number_literal] = ACTIONS(2192),
    [anon_sym_L_SQUOTE] = ACTIONS(2192),
    [anon_sym_u_SQUOTE] = ACTIONS(2192),
    [anon_sym_U_SQUOTE] = ACTIONS(2192),
    [anon_sym_u8_SQUOTE] = ACTIONS(2192),
    [anon_sym_SQUOTE] = ACTIONS(2192),
    [anon_sym_L_DQUOTE] = ACTIONS(2192),
    [anon_sym_u_DQUOTE] = ACTIONS(2192),
    [anon_sym_U_DQUOTE] = ACTIONS(2192),
    [anon_sym_u8_DQUOTE] = ACTIONS(2192),
    [anon_sym_DQUOTE] = ACTIONS(2192),
    [sym_true] = ACTIONS(2190),
    [sym_false] = ACTIONS(2190),
    [anon_sym_NULL] = ACTIONS(2190),
    [anon_sym_nullptr] = ACTIONS(2190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2190),
    [anon_sym_let] = ACTIONS(2190),
    [anon_sym_This] = ACTIONS(2190),
    [anon_sym_decltype] = ACTIONS(2190),
    [anon_sym_final] = ACTIONS(2190),
    [anon_sym_override] = ACTIONS(2190),
    [sym_virtual] = ACTIONS(2190),
    [anon_sym_typename] = ACTIONS(2190),
    [anon_sym_template] = ACTIONS(2190),
    [anon_sym_try] = ACTIONS(2190),
    [anon_sym_delete] = ACTIONS(2190),
    [anon_sym_throw] = ACTIONS(2190),
    [anon_sym_co_return] = ACTIONS(2190),
    [anon_sym_co_yield] = ACTIONS(2190),
    [anon_sym_R_DQUOTE] = ACTIONS(2192),
    [anon_sym_LR_DQUOTE] = ACTIONS(2192),
    [anon_sym_uR_DQUOTE] = ACTIONS(2192),
    [anon_sym_UR_DQUOTE] = ACTIONS(2192),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2192),
    [anon_sym_co_await] = ACTIONS(2190),
    [anon_sym_new] = ACTIONS(2190),
    [anon_sym_requires] = ACTIONS(2190),
    [sym_this] = ACTIONS(2190),
    [anon_sym_discard] = ACTIONS(2190),
    [anon_sym_precise] = ACTIONS(2190),
    [anon_sym_shared] = ACTIONS(2190),
    [anon_sym_groupshared] = ACTIONS(2190),
    [anon_sym_uniform] = ACTIONS(2190),
    [anon_sym_row_major] = ACTIONS(2190),
    [anon_sym_column_major] = ACTIONS(2190),
    [anon_sym_globallycoherent] = ACTIONS(2190),
    [anon_sym_centroid] = ACTIONS(2190),
    [anon_sym_noperspective] = ACTIONS(2190),
    [anon_sym_nointerpolation] = ACTIONS(2190),
    [anon_sym_sample] = ACTIONS(2190),
    [anon_sym_linear] = ACTIONS(2190),
    [anon_sym_snorm] = ACTIONS(2190),
    [anon_sym_unorm] = ACTIONS(2190),
    [anon_sym_point] = ACTIONS(2190),
    [anon_sym_line] = ACTIONS(2190),
    [anon_sym_triangleadj] = ACTIONS(2190),
    [anon_sym_lineadj] = ACTIONS(2190),
    [anon_sym_triangle] = ACTIONS(2190),
    [anon_sym_cbuffer] = ACTIONS(2190),
    [anon_sym_interface] = ACTIONS(2190),
    [anon_sym_extension] = ACTIONS(2190),
  },
  [1244] = {
    [sym_identifier] = ACTIONS(2194),
    [anon_sym_LPAREN2] = ACTIONS(2196),
    [anon_sym_BANG] = ACTIONS(2196),
    [anon_sym_TILDE] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2194),
    [anon_sym_PLUS] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(2196),
    [anon_sym_AMP] = ACTIONS(2196),
    [anon_sym_COLON] = ACTIONS(2194),
    [anon_sym_SEMI] = ACTIONS(2196),
    [anon_sym___extension__] = ACTIONS(2194),
    [anon_sym_typedef] = ACTIONS(2194),
    [anon_sym_in] = ACTIONS(2194),
    [anon_sym_out] = ACTIONS(2194),
    [anon_sym_inout] = ACTIONS(2194),
    [anon_sym_extern] = ACTIONS(2194),
    [anon_sym___attribute__] = ACTIONS(2194),
    [anon_sym_COLON_COLON] = ACTIONS(2196),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2196),
    [anon_sym___declspec] = ACTIONS(2194),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_signed] = ACTIONS(2194),
    [anon_sym_unsigned] = ACTIONS(2194),
    [anon_sym_long] = ACTIONS(2194),
    [anon_sym_short] = ACTIONS(2194),
    [anon_sym_LBRACK] = ACTIONS(2194),
    [anon_sym_static] = ACTIONS(2194),
    [anon_sym_register] = ACTIONS(2194),
    [anon_sym_inline] = ACTIONS(2194),
    [anon_sym___inline] = ACTIONS(2194),
    [anon_sym___inline__] = ACTIONS(2194),
    [anon_sym___forceinline] = ACTIONS(2194),
    [anon_sym_thread_local] = ACTIONS(2194),
    [anon_sym___thread] = ACTIONS(2194),
    [anon_sym_const] = ACTIONS(2194),
    [anon_sym_constexpr] = ACTIONS(2194),
    [anon_sym_volatile] = ACTIONS(2194),
    [anon_sym_restrict] = ACTIONS(2194),
    [anon_sym___restrict__] = ACTIONS(2194),
    [anon_sym__Atomic] = ACTIONS(2194),
    [anon_sym__Noreturn] = ACTIONS(2194),
    [anon_sym_noreturn] = ACTIONS(2194),
    [anon_sym_mutable] = ACTIONS(2194),
    [anon_sym_constinit] = ACTIONS(2194),
    [anon_sym_consteval] = ACTIONS(2194),
    [anon_sym_alignas] = ACTIONS(2194),
    [anon_sym__Alignas] = ACTIONS(2194),
    [sym_primitive_type] = ACTIONS(2194),
    [anon_sym_enum] = ACTIONS(2194),
    [anon_sym_class] = ACTIONS(2194),
    [anon_sym_struct] = ACTIONS(2194),
    [anon_sym_union] = ACTIONS(2194),
    [anon_sym_if] = ACTIONS(2194),
    [anon_sym_else] = ACTIONS(2194),
    [anon_sym_switch] = ACTIONS(2194),
    [anon_sym_while] = ACTIONS(2194),
    [anon_sym_do] = ACTIONS(2194),
    [anon_sym_for] = ACTIONS(2194),
    [anon_sym_return] = ACTIONS(2194),
    [anon_sym_break] = ACTIONS(2194),
    [anon_sym_continue] = ACTIONS(2194),
    [anon_sym_goto] = ACTIONS(2194),
    [anon_sym___try] = ACTIONS(2194),
    [anon_sym___leave] = ACTIONS(2194),
    [anon_sym_not] = ACTIONS(2194),
    [anon_sym_compl] = ACTIONS(2194),
    [anon_sym_DASH_DASH] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2196),
    [anon_sym_sizeof] = ACTIONS(2194),
    [anon_sym___alignof__] = ACTIONS(2194),
    [anon_sym___alignof] = ACTIONS(2194),
    [anon_sym__alignof] = ACTIONS(2194),
    [anon_sym_alignof] = ACTIONS(2194),
    [anon_sym__Alignof] = ACTIONS(2194),
    [anon_sym_offsetof] = ACTIONS(2194),
    [anon_sym__Generic] = ACTIONS(2194),
    [anon_sym_asm] = ACTIONS(2194),
    [anon_sym___asm__] = ACTIONS(2194),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_L_SQUOTE] = ACTIONS(2196),
    [anon_sym_u_SQUOTE] = ACTIONS(2196),
    [anon_sym_U_SQUOTE] = ACTIONS(2196),
    [anon_sym_u8_SQUOTE] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(2196),
    [anon_sym_L_DQUOTE] = ACTIONS(2196),
    [anon_sym_u_DQUOTE] = ACTIONS(2196),
    [anon_sym_U_DQUOTE] = ACTIONS(2196),
    [anon_sym_u8_DQUOTE] = ACTIONS(2196),
    [anon_sym_DQUOTE] = ACTIONS(2196),
    [sym_true] = ACTIONS(2194),
    [sym_false] = ACTIONS(2194),
    [anon_sym_NULL] = ACTIONS(2194),
    [anon_sym_nullptr] = ACTIONS(2194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2194),
    [anon_sym_let] = ACTIONS(2194),
    [anon_sym_This] = ACTIONS(2194),
    [anon_sym_decltype] = ACTIONS(2194),
    [anon_sym_final] = ACTIONS(2194),
    [anon_sym_override] = ACTIONS(2194),
    [sym_virtual] = ACTIONS(2194),
    [anon_sym_typename] = ACTIONS(2194),
    [anon_sym_template] = ACTIONS(2194),
    [anon_sym_try] = ACTIONS(2194),
    [anon_sym_delete] = ACTIONS(2194),
    [anon_sym_throw] = ACTIONS(2194),
    [anon_sym_co_return] = ACTIONS(2194),
    [anon_sym_co_yield] = ACTIONS(2194),
    [anon_sym_R_DQUOTE] = ACTIONS(2196),
    [anon_sym_LR_DQUOTE] = ACTIONS(2196),
    [anon_sym_uR_DQUOTE] = ACTIONS(2196),
    [anon_sym_UR_DQUOTE] = ACTIONS(2196),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2196),
    [anon_sym_co_await] = ACTIONS(2194),
    [anon_sym_new] = ACTIONS(2194),
    [anon_sym_requires] = ACTIONS(2194),
    [sym_this] = ACTIONS(2194),
    [anon_sym_discard] = ACTIONS(2194),
    [anon_sym_precise] = ACTIONS(2194),
    [anon_sym_shared] = ACTIONS(2194),
    [anon_sym_groupshared] = ACTIONS(2194),
    [anon_sym_uniform] = ACTIONS(2194),
    [anon_sym_row_major] = ACTIONS(2194),
    [anon_sym_column_major] = ACTIONS(2194),
    [anon_sym_globallycoherent] = ACTIONS(2194),
    [anon_sym_centroid] = ACTIONS(2194),
    [anon_sym_noperspective] = ACTIONS(2194),
    [anon_sym_nointerpolation] = ACTIONS(2194),
    [anon_sym_sample] = ACTIONS(2194),
    [anon_sym_linear] = ACTIONS(2194),
    [anon_sym_snorm] = ACTIONS(2194),
    [anon_sym_unorm] = ACTIONS(2194),
    [anon_sym_point] = ACTIONS(2194),
    [anon_sym_line] = ACTIONS(2194),
    [anon_sym_triangleadj] = ACTIONS(2194),
    [anon_sym_lineadj] = ACTIONS(2194),
    [anon_sym_triangle] = ACTIONS(2194),
    [anon_sym_cbuffer] = ACTIONS(2194),
    [anon_sym_interface] = ACTIONS(2194),
    [anon_sym_extension] = ACTIONS(2194),
  },
  [1245] = {
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_LPAREN2] = ACTIONS(2371),
    [anon_sym_BANG] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2371),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym___extension__] = ACTIONS(2373),
    [anon_sym_typedef] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_out] = ACTIONS(2373),
    [anon_sym_inout] = ACTIONS(2373),
    [anon_sym_extern] = ACTIONS(2373),
    [anon_sym___attribute__] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2371),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2371),
    [anon_sym___declspec] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_signed] = ACTIONS(2373),
    [anon_sym_unsigned] = ACTIONS(2373),
    [anon_sym_long] = ACTIONS(2373),
    [anon_sym_short] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2373),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_register] = ACTIONS(2373),
    [anon_sym_inline] = ACTIONS(2373),
    [anon_sym___inline] = ACTIONS(2373),
    [anon_sym___inline__] = ACTIONS(2373),
    [anon_sym___forceinline] = ACTIONS(2373),
    [anon_sym_thread_local] = ACTIONS(2373),
    [anon_sym___thread] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym___restrict__] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym__Noreturn] = ACTIONS(2373),
    [anon_sym_noreturn] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_constinit] = ACTIONS(2373),
    [anon_sym_consteval] = ACTIONS(2373),
    [anon_sym_alignas] = ACTIONS(2373),
    [anon_sym__Alignas] = ACTIONS(2373),
    [sym_primitive_type] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_class] = ACTIONS(2373),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_else] = ACTIONS(2373),
    [anon_sym_switch] = ACTIONS(2373),
    [anon_sym_while] = ACTIONS(2373),
    [anon_sym_do] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2373),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2373),
    [anon_sym_goto] = ACTIONS(2373),
    [anon_sym___try] = ACTIONS(2373),
    [anon_sym___leave] = ACTIONS(2373),
    [anon_sym_not] = ACTIONS(2373),
    [anon_sym_compl] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_sizeof] = ACTIONS(2373),
    [anon_sym___alignof__] = ACTIONS(2373),
    [anon_sym___alignof] = ACTIONS(2373),
    [anon_sym__alignof] = ACTIONS(2373),
    [anon_sym_alignof] = ACTIONS(2373),
    [anon_sym__Alignof] = ACTIONS(2373),
    [anon_sym_offsetof] = ACTIONS(2373),
    [anon_sym__Generic] = ACTIONS(2373),
    [anon_sym_asm] = ACTIONS(2373),
    [anon_sym___asm__] = ACTIONS(2373),
    [sym_number_literal] = ACTIONS(2371),
    [anon_sym_L_SQUOTE] = ACTIONS(2371),
    [anon_sym_u_SQUOTE] = ACTIONS(2371),
    [anon_sym_U_SQUOTE] = ACTIONS(2371),
    [anon_sym_u8_SQUOTE] = ACTIONS(2371),
    [anon_sym_SQUOTE] = ACTIONS(2371),
    [anon_sym_L_DQUOTE] = ACTIONS(2371),
    [anon_sym_u_DQUOTE] = ACTIONS(2371),
    [anon_sym_U_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8_DQUOTE] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [anon_sym_NULL] = ACTIONS(2373),
    [anon_sym_nullptr] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_This] = ACTIONS(2373),
    [anon_sym_decltype] = ACTIONS(2373),
    [anon_sym_final] = ACTIONS(2373),
    [anon_sym_override] = ACTIONS(2373),
    [sym_virtual] = ACTIONS(2373),
    [anon_sym_typename] = ACTIONS(2373),
    [anon_sym_template] = ACTIONS(2373),
    [anon_sym_try] = ACTIONS(2373),
    [anon_sym_delete] = ACTIONS(2373),
    [anon_sym_throw] = ACTIONS(2373),
    [anon_sym_co_return] = ACTIONS(2373),
    [anon_sym_co_yield] = ACTIONS(2373),
    [anon_sym_R_DQUOTE] = ACTIONS(2371),
    [anon_sym_LR_DQUOTE] = ACTIONS(2371),
    [anon_sym_uR_DQUOTE] = ACTIONS(2371),
    [anon_sym_UR_DQUOTE] = ACTIONS(2371),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2371),
    [anon_sym_co_await] = ACTIONS(2373),
    [anon_sym_new] = ACTIONS(2373),
    [anon_sym_requires] = ACTIONS(2373),
    [sym_this] = ACTIONS(2373),
    [anon_sym_discard] = ACTIONS(2373),
    [anon_sym_precise] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_groupshared] = ACTIONS(2373),
    [anon_sym_uniform] = ACTIONS(2373),
    [anon_sym_row_major] = ACTIONS(2373),
    [anon_sym_column_major] = ACTIONS(2373),
    [anon_sym_globallycoherent] = ACTIONS(2373),
    [anon_sym_centroid] = ACTIONS(2373),
    [anon_sym_noperspective] = ACTIONS(2373),
    [anon_sym_nointerpolation] = ACTIONS(2373),
    [anon_sym_sample] = ACTIONS(2373),
    [anon_sym_linear] = ACTIONS(2373),
    [anon_sym_snorm] = ACTIONS(2373),
    [anon_sym_unorm] = ACTIONS(2373),
    [anon_sym_point] = ACTIONS(2373),
    [anon_sym_line] = ACTIONS(2373),
    [anon_sym_triangleadj] = ACTIONS(2373),
    [anon_sym_lineadj] = ACTIONS(2373),
    [anon_sym_triangle] = ACTIONS(2373),
    [anon_sym_cbuffer] = ACTIONS(2373),
    [anon_sym_interface] = ACTIONS(2373),
    [anon_sym_extension] = ACTIONS(2373),
  },
  [1246] = {
    [sym_identifier] = ACTIONS(2210),
    [anon_sym_LPAREN2] = ACTIONS(2217),
    [anon_sym_BANG] = ACTIONS(2217),
    [anon_sym_TILDE] = ACTIONS(2217),
    [anon_sym_DASH] = ACTIONS(2210),
    [anon_sym_PLUS] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(2217),
    [anon_sym_AMP] = ACTIONS(2217),
    [anon_sym_COLON] = ACTIONS(2210),
    [anon_sym_SEMI] = ACTIONS(2217),
    [anon_sym___extension__] = ACTIONS(2210),
    [anon_sym_typedef] = ACTIONS(2210),
    [anon_sym_in] = ACTIONS(2210),
    [anon_sym_out] = ACTIONS(2210),
    [anon_sym_inout] = ACTIONS(2210),
    [anon_sym_extern] = ACTIONS(2210),
    [anon_sym___attribute__] = ACTIONS(2210),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2217),
    [anon_sym___declspec] = ACTIONS(2210),
    [anon_sym_LBRACE] = ACTIONS(2217),
    [anon_sym_signed] = ACTIONS(2210),
    [anon_sym_unsigned] = ACTIONS(2210),
    [anon_sym_long] = ACTIONS(2210),
    [anon_sym_short] = ACTIONS(2210),
    [anon_sym_LBRACK] = ACTIONS(2210),
    [anon_sym_static] = ACTIONS(2210),
    [anon_sym_register] = ACTIONS(2210),
    [anon_sym_inline] = ACTIONS(2210),
    [anon_sym___inline] = ACTIONS(2210),
    [anon_sym___inline__] = ACTIONS(2210),
    [anon_sym___forceinline] = ACTIONS(2210),
    [anon_sym_thread_local] = ACTIONS(2210),
    [anon_sym___thread] = ACTIONS(2210),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_constexpr] = ACTIONS(2210),
    [anon_sym_volatile] = ACTIONS(2210),
    [anon_sym_restrict] = ACTIONS(2210),
    [anon_sym___restrict__] = ACTIONS(2210),
    [anon_sym__Atomic] = ACTIONS(2210),
    [anon_sym__Noreturn] = ACTIONS(2210),
    [anon_sym_noreturn] = ACTIONS(2210),
    [anon_sym_mutable] = ACTIONS(2210),
    [anon_sym_constinit] = ACTIONS(2210),
    [anon_sym_consteval] = ACTIONS(2210),
    [anon_sym_alignas] = ACTIONS(2210),
    [anon_sym__Alignas] = ACTIONS(2210),
    [sym_primitive_type] = ACTIONS(2210),
    [anon_sym_enum] = ACTIONS(2210),
    [anon_sym_class] = ACTIONS(2210),
    [anon_sym_struct] = ACTIONS(2210),
    [anon_sym_union] = ACTIONS(2210),
    [anon_sym_if] = ACTIONS(2210),
    [anon_sym_else] = ACTIONS(2210),
    [anon_sym_switch] = ACTIONS(2210),
    [anon_sym_while] = ACTIONS(2210),
    [anon_sym_do] = ACTIONS(2210),
    [anon_sym_for] = ACTIONS(2210),
    [anon_sym_return] = ACTIONS(2210),
    [anon_sym_break] = ACTIONS(2210),
    [anon_sym_continue] = ACTIONS(2210),
    [anon_sym_goto] = ACTIONS(2210),
    [anon_sym___try] = ACTIONS(2210),
    [anon_sym___leave] = ACTIONS(2210),
    [anon_sym_not] = ACTIONS(2210),
    [anon_sym_compl] = ACTIONS(2210),
    [anon_sym_DASH_DASH] = ACTIONS(2217),
    [anon_sym_PLUS_PLUS] = ACTIONS(2217),
    [anon_sym_sizeof] = ACTIONS(2210),
    [anon_sym___alignof__] = ACTIONS(2210),
    [anon_sym___alignof] = ACTIONS(2210),
    [anon_sym__alignof] = ACTIONS(2210),
    [anon_sym_alignof] = ACTIONS(2210),
    [anon_sym__Alignof] = ACTIONS(2210),
    [anon_sym_offsetof] = ACTIONS(2210),
    [anon_sym__Generic] = ACTIONS(2210),
    [anon_sym_asm] = ACTIONS(2210),
    [anon_sym___asm__] = ACTIONS(2210),
    [sym_number_literal] = ACTIONS(2217),
    [anon_sym_L_SQUOTE] = ACTIONS(2217),
    [anon_sym_u_SQUOTE] = ACTIONS(2217),
    [anon_sym_U_SQUOTE] = ACTIONS(2217),
    [anon_sym_u8_SQUOTE] = ACTIONS(2217),
    [anon_sym_SQUOTE] = ACTIONS(2217),
    [anon_sym_L_DQUOTE] = ACTIONS(2217),
    [anon_sym_u_DQUOTE] = ACTIONS(2217),
    [anon_sym_U_DQUOTE] = ACTIONS(2217),
    [anon_sym_u8_DQUOTE] = ACTIONS(2217),
    [anon_sym_DQUOTE] = ACTIONS(2217),
    [sym_true] = ACTIONS(2210),
    [sym_false] = ACTIONS(2210),
    [anon_sym_NULL] = ACTIONS(2210),
    [anon_sym_nullptr] = ACTIONS(2210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2210),
    [anon_sym_let] = ACTIONS(2210),
    [anon_sym_This] = ACTIONS(2210),
    [anon_sym_decltype] = ACTIONS(2210),
    [anon_sym_final] = ACTIONS(2210),
    [anon_sym_override] = ACTIONS(2210),
    [sym_virtual] = ACTIONS(2210),
    [anon_sym_typename] = ACTIONS(2210),
    [anon_sym_template] = ACTIONS(2210),
    [anon_sym_try] = ACTIONS(2210),
    [anon_sym_delete] = ACTIONS(2210),
    [anon_sym_throw] = ACTIONS(2210),
    [anon_sym_co_return] = ACTIONS(2210),
    [anon_sym_co_yield] = ACTIONS(2210),
    [anon_sym_R_DQUOTE] = ACTIONS(2217),
    [anon_sym_LR_DQUOTE] = ACTIONS(2217),
    [anon_sym_uR_DQUOTE] = ACTIONS(2217),
    [anon_sym_UR_DQUOTE] = ACTIONS(2217),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2217),
    [anon_sym_co_await] = ACTIONS(2210),
    [anon_sym_new] = ACTIONS(2210),
    [anon_sym_requires] = ACTIONS(2210),
    [sym_this] = ACTIONS(2210),
    [anon_sym_discard] = ACTIONS(2210),
    [anon_sym_precise] = ACTIONS(2210),
    [anon_sym_shared] = ACTIONS(2210),
    [anon_sym_groupshared] = ACTIONS(2210),
    [anon_sym_uniform] = ACTIONS(2210),
    [anon_sym_row_major] = ACTIONS(2210),
    [anon_sym_column_major] = ACTIONS(2210),
    [anon_sym_globallycoherent] = ACTIONS(2210),
    [anon_sym_centroid] = ACTIONS(2210),
    [anon_sym_noperspective] = ACTIONS(2210),
    [anon_sym_nointerpolation] = ACTIONS(2210),
    [anon_sym_sample] = ACTIONS(2210),
    [anon_sym_linear] = ACTIONS(2210),
    [anon_sym_snorm] = ACTIONS(2210),
    [anon_sym_unorm] = ACTIONS(2210),
    [anon_sym_point] = ACTIONS(2210),
    [anon_sym_line] = ACTIONS(2210),
    [anon_sym_triangleadj] = ACTIONS(2210),
    [anon_sym_lineadj] = ACTIONS(2210),
    [anon_sym_triangle] = ACTIONS(2210),
    [anon_sym_cbuffer] = ACTIONS(2210),
    [anon_sym_interface] = ACTIONS(2210),
    [anon_sym_extension] = ACTIONS(2210),
  },
  [1247] = {
    [sym_identifier] = ACTIONS(2367),
    [anon_sym_LPAREN2] = ACTIONS(2365),
    [anon_sym_BANG] = ACTIONS(2365),
    [anon_sym_TILDE] = ACTIONS(2365),
    [anon_sym_DASH] = ACTIONS(2367),
    [anon_sym_PLUS] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2365),
    [anon_sym_AMP] = ACTIONS(2365),
    [anon_sym_COLON] = ACTIONS(2367),
    [anon_sym_SEMI] = ACTIONS(2365),
    [anon_sym___extension__] = ACTIONS(2367),
    [anon_sym_typedef] = ACTIONS(2367),
    [anon_sym_in] = ACTIONS(2367),
    [anon_sym_out] = ACTIONS(2367),
    [anon_sym_inout] = ACTIONS(2367),
    [anon_sym_extern] = ACTIONS(2367),
    [anon_sym___attribute__] = ACTIONS(2367),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2365),
    [anon_sym___declspec] = ACTIONS(2367),
    [anon_sym_LBRACE] = ACTIONS(2365),
    [anon_sym_signed] = ACTIONS(2367),
    [anon_sym_unsigned] = ACTIONS(2367),
    [anon_sym_long] = ACTIONS(2367),
    [anon_sym_short] = ACTIONS(2367),
    [anon_sym_LBRACK] = ACTIONS(2367),
    [anon_sym_static] = ACTIONS(2367),
    [anon_sym_register] = ACTIONS(2367),
    [anon_sym_inline] = ACTIONS(2367),
    [anon_sym___inline] = ACTIONS(2367),
    [anon_sym___inline__] = ACTIONS(2367),
    [anon_sym___forceinline] = ACTIONS(2367),
    [anon_sym_thread_local] = ACTIONS(2367),
    [anon_sym___thread] = ACTIONS(2367),
    [anon_sym_const] = ACTIONS(2367),
    [anon_sym_constexpr] = ACTIONS(2367),
    [anon_sym_volatile] = ACTIONS(2367),
    [anon_sym_restrict] = ACTIONS(2367),
    [anon_sym___restrict__] = ACTIONS(2367),
    [anon_sym__Atomic] = ACTIONS(2367),
    [anon_sym__Noreturn] = ACTIONS(2367),
    [anon_sym_noreturn] = ACTIONS(2367),
    [anon_sym_mutable] = ACTIONS(2367),
    [anon_sym_constinit] = ACTIONS(2367),
    [anon_sym_consteval] = ACTIONS(2367),
    [anon_sym_alignas] = ACTIONS(2367),
    [anon_sym__Alignas] = ACTIONS(2367),
    [sym_primitive_type] = ACTIONS(2367),
    [anon_sym_enum] = ACTIONS(2367),
    [anon_sym_class] = ACTIONS(2367),
    [anon_sym_struct] = ACTIONS(2367),
    [anon_sym_union] = ACTIONS(2367),
    [anon_sym_if] = ACTIONS(2367),
    [anon_sym_else] = ACTIONS(2367),
    [anon_sym_switch] = ACTIONS(2367),
    [anon_sym_while] = ACTIONS(2367),
    [anon_sym_do] = ACTIONS(2367),
    [anon_sym_for] = ACTIONS(2367),
    [anon_sym_return] = ACTIONS(2367),
    [anon_sym_break] = ACTIONS(2367),
    [anon_sym_continue] = ACTIONS(2367),
    [anon_sym_goto] = ACTIONS(2367),
    [anon_sym___try] = ACTIONS(2367),
    [anon_sym___leave] = ACTIONS(2367),
    [anon_sym_not] = ACTIONS(2367),
    [anon_sym_compl] = ACTIONS(2367),
    [anon_sym_DASH_DASH] = ACTIONS(2365),
    [anon_sym_PLUS_PLUS] = ACTIONS(2365),
    [anon_sym_sizeof] = ACTIONS(2367),
    [anon_sym___alignof__] = ACTIONS(2367),
    [anon_sym___alignof] = ACTIONS(2367),
    [anon_sym__alignof] = ACTIONS(2367),
    [anon_sym_alignof] = ACTIONS(2367),
    [anon_sym__Alignof] = ACTIONS(2367),
    [anon_sym_offsetof] = ACTIONS(2367),
    [anon_sym__Generic] = ACTIONS(2367),
    [anon_sym_asm] = ACTIONS(2367),
    [anon_sym___asm__] = ACTIONS(2367),
    [sym_number_literal] = ACTIONS(2365),
    [anon_sym_L_SQUOTE] = ACTIONS(2365),
    [anon_sym_u_SQUOTE] = ACTIONS(2365),
    [anon_sym_U_SQUOTE] = ACTIONS(2365),
    [anon_sym_u8_SQUOTE] = ACTIONS(2365),
    [anon_sym_SQUOTE] = ACTIONS(2365),
    [anon_sym_L_DQUOTE] = ACTIONS(2365),
    [anon_sym_u_DQUOTE] = ACTIONS(2365),
    [anon_sym_U_DQUOTE] = ACTIONS(2365),
    [anon_sym_u8_DQUOTE] = ACTIONS(2365),
    [anon_sym_DQUOTE] = ACTIONS(2365),
    [sym_true] = ACTIONS(2367),
    [sym_false] = ACTIONS(2367),
    [anon_sym_NULL] = ACTIONS(2367),
    [anon_sym_nullptr] = ACTIONS(2367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2367),
    [anon_sym_let] = ACTIONS(2367),
    [anon_sym_This] = ACTIONS(2367),
    [anon_sym_decltype] = ACTIONS(2367),
    [anon_sym_final] = ACTIONS(2367),
    [anon_sym_override] = ACTIONS(2367),
    [sym_virtual] = ACTIONS(2367),
    [anon_sym_typename] = ACTIONS(2367),
    [anon_sym_template] = ACTIONS(2367),
    [anon_sym_try] = ACTIONS(2367),
    [anon_sym_delete] = ACTIONS(2367),
    [anon_sym_throw] = ACTIONS(2367),
    [anon_sym_co_return] = ACTIONS(2367),
    [anon_sym_co_yield] = ACTIONS(2367),
    [anon_sym_R_DQUOTE] = ACTIONS(2365),
    [anon_sym_LR_DQUOTE] = ACTIONS(2365),
    [anon_sym_uR_DQUOTE] = ACTIONS(2365),
    [anon_sym_UR_DQUOTE] = ACTIONS(2365),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2365),
    [anon_sym_co_await] = ACTIONS(2367),
    [anon_sym_new] = ACTIONS(2367),
    [anon_sym_requires] = ACTIONS(2367),
    [sym_this] = ACTIONS(2367),
    [anon_sym_discard] = ACTIONS(2367),
    [anon_sym_precise] = ACTIONS(2367),
    [anon_sym_shared] = ACTIONS(2367),
    [anon_sym_groupshared] = ACTIONS(2367),
    [anon_sym_uniform] = ACTIONS(2367),
    [anon_sym_row_major] = ACTIONS(2367),
    [anon_sym_column_major] = ACTIONS(2367),
    [anon_sym_globallycoherent] = ACTIONS(2367),
    [anon_sym_centroid] = ACTIONS(2367),
    [anon_sym_noperspective] = ACTIONS(2367),
    [anon_sym_nointerpolation] = ACTIONS(2367),
    [anon_sym_sample] = ACTIONS(2367),
    [anon_sym_linear] = ACTIONS(2367),
    [anon_sym_snorm] = ACTIONS(2367),
    [anon_sym_unorm] = ACTIONS(2367),
    [anon_sym_point] = ACTIONS(2367),
    [anon_sym_line] = ACTIONS(2367),
    [anon_sym_triangleadj] = ACTIONS(2367),
    [anon_sym_lineadj] = ACTIONS(2367),
    [anon_sym_triangle] = ACTIONS(2367),
    [anon_sym_cbuffer] = ACTIONS(2367),
    [anon_sym_interface] = ACTIONS(2367),
    [anon_sym_extension] = ACTIONS(2367),
  },
  [1248] = {
    [sym_identifier] = ACTIONS(2240),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2242),
    [anon_sym_TILDE] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2240),
    [anon_sym_PLUS] = ACTIONS(2240),
    [anon_sym_STAR] = ACTIONS(2242),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_COLON] = ACTIONS(2240),
    [anon_sym_SEMI] = ACTIONS(2242),
    [anon_sym___extension__] = ACTIONS(2240),
    [anon_sym_typedef] = ACTIONS(2240),
    [anon_sym_in] = ACTIONS(2240),
    [anon_sym_out] = ACTIONS(2240),
    [anon_sym_inout] = ACTIONS(2240),
    [anon_sym_extern] = ACTIONS(2240),
    [anon_sym___attribute__] = ACTIONS(2240),
    [anon_sym_COLON_COLON] = ACTIONS(2242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2242),
    [anon_sym___declspec] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_signed] = ACTIONS(2240),
    [anon_sym_unsigned] = ACTIONS(2240),
    [anon_sym_long] = ACTIONS(2240),
    [anon_sym_short] = ACTIONS(2240),
    [anon_sym_LBRACK] = ACTIONS(2240),
    [anon_sym_static] = ACTIONS(2240),
    [anon_sym_register] = ACTIONS(2240),
    [anon_sym_inline] = ACTIONS(2240),
    [anon_sym___inline] = ACTIONS(2240),
    [anon_sym___inline__] = ACTIONS(2240),
    [anon_sym___forceinline] = ACTIONS(2240),
    [anon_sym_thread_local] = ACTIONS(2240),
    [anon_sym___thread] = ACTIONS(2240),
    [anon_sym_const] = ACTIONS(2240),
    [anon_sym_constexpr] = ACTIONS(2240),
    [anon_sym_volatile] = ACTIONS(2240),
    [anon_sym_restrict] = ACTIONS(2240),
    [anon_sym___restrict__] = ACTIONS(2240),
    [anon_sym__Atomic] = ACTIONS(2240),
    [anon_sym__Noreturn] = ACTIONS(2240),
    [anon_sym_noreturn] = ACTIONS(2240),
    [anon_sym_mutable] = ACTIONS(2240),
    [anon_sym_constinit] = ACTIONS(2240),
    [anon_sym_consteval] = ACTIONS(2240),
    [anon_sym_alignas] = ACTIONS(2240),
    [anon_sym__Alignas] = ACTIONS(2240),
    [sym_primitive_type] = ACTIONS(2240),
    [anon_sym_enum] = ACTIONS(2240),
    [anon_sym_class] = ACTIONS(2240),
    [anon_sym_struct] = ACTIONS(2240),
    [anon_sym_union] = ACTIONS(2240),
    [anon_sym_if] = ACTIONS(2240),
    [anon_sym_else] = ACTIONS(2240),
    [anon_sym_switch] = ACTIONS(2240),
    [anon_sym_while] = ACTIONS(2240),
    [anon_sym_do] = ACTIONS(2240),
    [anon_sym_for] = ACTIONS(2240),
    [anon_sym_return] = ACTIONS(2240),
    [anon_sym_break] = ACTIONS(2240),
    [anon_sym_continue] = ACTIONS(2240),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym___try] = ACTIONS(2240),
    [anon_sym___leave] = ACTIONS(2240),
    [anon_sym_not] = ACTIONS(2240),
    [anon_sym_compl] = ACTIONS(2240),
    [anon_sym_DASH_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_PLUS] = ACTIONS(2242),
    [anon_sym_sizeof] = ACTIONS(2240),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2240),
    [anon_sym__Generic] = ACTIONS(2240),
    [anon_sym_asm] = ACTIONS(2240),
    [anon_sym___asm__] = ACTIONS(2240),
    [sym_number_literal] = ACTIONS(2242),
    [anon_sym_L_SQUOTE] = ACTIONS(2242),
    [anon_sym_u_SQUOTE] = ACTIONS(2242),
    [anon_sym_U_SQUOTE] = ACTIONS(2242),
    [anon_sym_u8_SQUOTE] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(2242),
    [anon_sym_L_DQUOTE] = ACTIONS(2242),
    [anon_sym_u_DQUOTE] = ACTIONS(2242),
    [anon_sym_U_DQUOTE] = ACTIONS(2242),
    [anon_sym_u8_DQUOTE] = ACTIONS(2242),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [sym_true] = ACTIONS(2240),
    [sym_false] = ACTIONS(2240),
    [anon_sym_NULL] = ACTIONS(2240),
    [anon_sym_nullptr] = ACTIONS(2240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2240),
    [anon_sym_let] = ACTIONS(2240),
    [anon_sym_This] = ACTIONS(2240),
    [anon_sym_decltype] = ACTIONS(2240),
    [anon_sym_final] = ACTIONS(2240),
    [anon_sym_override] = ACTIONS(2240),
    [sym_virtual] = ACTIONS(2240),
    [anon_sym_typename] = ACTIONS(2240),
    [anon_sym_template] = ACTIONS(2240),
    [anon_sym_try] = ACTIONS(2240),
    [anon_sym_delete] = ACTIONS(2240),
    [anon_sym_throw] = ACTIONS(2240),
    [anon_sym_co_return] = ACTIONS(2240),
    [anon_sym_co_yield] = ACTIONS(2240),
    [anon_sym_R_DQUOTE] = ACTIONS(2242),
    [anon_sym_LR_DQUOTE] = ACTIONS(2242),
    [anon_sym_uR_DQUOTE] = ACTIONS(2242),
    [anon_sym_UR_DQUOTE] = ACTIONS(2242),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2242),
    [anon_sym_co_await] = ACTIONS(2240),
    [anon_sym_new] = ACTIONS(2240),
    [anon_sym_requires] = ACTIONS(2240),
    [sym_this] = ACTIONS(2240),
    [anon_sym_discard] = ACTIONS(2240),
    [anon_sym_precise] = ACTIONS(2240),
    [anon_sym_shared] = ACTIONS(2240),
    [anon_sym_groupshared] = ACTIONS(2240),
    [anon_sym_uniform] = ACTIONS(2240),
    [anon_sym_row_major] = ACTIONS(2240),
    [anon_sym_column_major] = ACTIONS(2240),
    [anon_sym_globallycoherent] = ACTIONS(2240),
    [anon_sym_centroid] = ACTIONS(2240),
    [anon_sym_noperspective] = ACTIONS(2240),
    [anon_sym_nointerpolation] = ACTIONS(2240),
    [anon_sym_sample] = ACTIONS(2240),
    [anon_sym_linear] = ACTIONS(2240),
    [anon_sym_snorm] = ACTIONS(2240),
    [anon_sym_unorm] = ACTIONS(2240),
    [anon_sym_point] = ACTIONS(2240),
    [anon_sym_line] = ACTIONS(2240),
    [anon_sym_triangleadj] = ACTIONS(2240),
    [anon_sym_lineadj] = ACTIONS(2240),
    [anon_sym_triangle] = ACTIONS(2240),
    [anon_sym_cbuffer] = ACTIONS(2240),
    [anon_sym_interface] = ACTIONS(2240),
    [anon_sym_extension] = ACTIONS(2240),
  },
  [1249] = {
    [sym_identifier] = ACTIONS(2202),
    [anon_sym_LPAREN2] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2204),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2202),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_STAR] = ACTIONS(2204),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_COLON] = ACTIONS(2202),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym___extension__] = ACTIONS(2202),
    [anon_sym_typedef] = ACTIONS(2202),
    [anon_sym_in] = ACTIONS(2202),
    [anon_sym_out] = ACTIONS(2202),
    [anon_sym_inout] = ACTIONS(2202),
    [anon_sym_extern] = ACTIONS(2202),
    [anon_sym___attribute__] = ACTIONS(2202),
    [anon_sym_COLON_COLON] = ACTIONS(2204),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2204),
    [anon_sym___declspec] = ACTIONS(2202),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_signed] = ACTIONS(2202),
    [anon_sym_unsigned] = ACTIONS(2202),
    [anon_sym_long] = ACTIONS(2202),
    [anon_sym_short] = ACTIONS(2202),
    [anon_sym_LBRACK] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2202),
    [anon_sym_register] = ACTIONS(2202),
    [anon_sym_inline] = ACTIONS(2202),
    [anon_sym___inline] = ACTIONS(2202),
    [anon_sym___inline__] = ACTIONS(2202),
    [anon_sym___forceinline] = ACTIONS(2202),
    [anon_sym_thread_local] = ACTIONS(2202),
    [anon_sym___thread] = ACTIONS(2202),
    [anon_sym_const] = ACTIONS(2202),
    [anon_sym_constexpr] = ACTIONS(2202),
    [anon_sym_volatile] = ACTIONS(2202),
    [anon_sym_restrict] = ACTIONS(2202),
    [anon_sym___restrict__] = ACTIONS(2202),
    [anon_sym__Atomic] = ACTIONS(2202),
    [anon_sym__Noreturn] = ACTIONS(2202),
    [anon_sym_noreturn] = ACTIONS(2202),
    [anon_sym_mutable] = ACTIONS(2202),
    [anon_sym_constinit] = ACTIONS(2202),
    [anon_sym_consteval] = ACTIONS(2202),
    [anon_sym_alignas] = ACTIONS(2202),
    [anon_sym__Alignas] = ACTIONS(2202),
    [sym_primitive_type] = ACTIONS(2202),
    [anon_sym_enum] = ACTIONS(2202),
    [anon_sym_class] = ACTIONS(2202),
    [anon_sym_struct] = ACTIONS(2202),
    [anon_sym_union] = ACTIONS(2202),
    [anon_sym_if] = ACTIONS(2202),
    [anon_sym_else] = ACTIONS(2202),
    [anon_sym_switch] = ACTIONS(2202),
    [anon_sym_while] = ACTIONS(2202),
    [anon_sym_do] = ACTIONS(2202),
    [anon_sym_for] = ACTIONS(2202),
    [anon_sym_return] = ACTIONS(2202),
    [anon_sym_break] = ACTIONS(2202),
    [anon_sym_continue] = ACTIONS(2202),
    [anon_sym_goto] = ACTIONS(2202),
    [anon_sym___try] = ACTIONS(2202),
    [anon_sym___leave] = ACTIONS(2202),
    [anon_sym_not] = ACTIONS(2202),
    [anon_sym_compl] = ACTIONS(2202),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_sizeof] = ACTIONS(2202),
    [anon_sym___alignof__] = ACTIONS(2202),
    [anon_sym___alignof] = ACTIONS(2202),
    [anon_sym__alignof] = ACTIONS(2202),
    [anon_sym_alignof] = ACTIONS(2202),
    [anon_sym__Alignof] = ACTIONS(2202),
    [anon_sym_offsetof] = ACTIONS(2202),
    [anon_sym__Generic] = ACTIONS(2202),
    [anon_sym_asm] = ACTIONS(2202),
    [anon_sym___asm__] = ACTIONS(2202),
    [sym_number_literal] = ACTIONS(2204),
    [anon_sym_L_SQUOTE] = ACTIONS(2204),
    [anon_sym_u_SQUOTE] = ACTIONS(2204),
    [anon_sym_U_SQUOTE] = ACTIONS(2204),
    [anon_sym_u8_SQUOTE] = ACTIONS(2204),
    [anon_sym_SQUOTE] = ACTIONS(2204),
    [anon_sym_L_DQUOTE] = ACTIONS(2204),
    [anon_sym_u_DQUOTE] = ACTIONS(2204),
    [anon_sym_U_DQUOTE] = ACTIONS(2204),
    [anon_sym_u8_DQUOTE] = ACTIONS(2204),
    [anon_sym_DQUOTE] = ACTIONS(2204),
    [sym_true] = ACTIONS(2202),
    [sym_false] = ACTIONS(2202),
    [anon_sym_NULL] = ACTIONS(2202),
    [anon_sym_nullptr] = ACTIONS(2202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2202),
    [anon_sym_let] = ACTIONS(2202),
    [anon_sym_This] = ACTIONS(2202),
    [anon_sym_decltype] = ACTIONS(2202),
    [anon_sym_final] = ACTIONS(2202),
    [anon_sym_override] = ACTIONS(2202),
    [sym_virtual] = ACTIONS(2202),
    [anon_sym_typename] = ACTIONS(2202),
    [anon_sym_template] = ACTIONS(2202),
    [anon_sym_try] = ACTIONS(2202),
    [anon_sym_delete] = ACTIONS(2202),
    [anon_sym_throw] = ACTIONS(2202),
    [anon_sym_co_return] = ACTIONS(2202),
    [anon_sym_co_yield] = ACTIONS(2202),
    [anon_sym_R_DQUOTE] = ACTIONS(2204),
    [anon_sym_LR_DQUOTE] = ACTIONS(2204),
    [anon_sym_uR_DQUOTE] = ACTIONS(2204),
    [anon_sym_UR_DQUOTE] = ACTIONS(2204),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2204),
    [anon_sym_co_await] = ACTIONS(2202),
    [anon_sym_new] = ACTIONS(2202),
    [anon_sym_requires] = ACTIONS(2202),
    [sym_this] = ACTIONS(2202),
    [anon_sym_discard] = ACTIONS(2202),
    [anon_sym_precise] = ACTIONS(2202),
    [anon_sym_shared] = ACTIONS(2202),
    [anon_sym_groupshared] = ACTIONS(2202),
    [anon_sym_uniform] = ACTIONS(2202),
    [anon_sym_row_major] = ACTIONS(2202),
    [anon_sym_column_major] = ACTIONS(2202),
    [anon_sym_globallycoherent] = ACTIONS(2202),
    [anon_sym_centroid] = ACTIONS(2202),
    [anon_sym_noperspective] = ACTIONS(2202),
    [anon_sym_nointerpolation] = ACTIONS(2202),
    [anon_sym_sample] = ACTIONS(2202),
    [anon_sym_linear] = ACTIONS(2202),
    [anon_sym_snorm] = ACTIONS(2202),
    [anon_sym_unorm] = ACTIONS(2202),
    [anon_sym_point] = ACTIONS(2202),
    [anon_sym_line] = ACTIONS(2202),
    [anon_sym_triangleadj] = ACTIONS(2202),
    [anon_sym_lineadj] = ACTIONS(2202),
    [anon_sym_triangle] = ACTIONS(2202),
    [anon_sym_cbuffer] = ACTIONS(2202),
    [anon_sym_interface] = ACTIONS(2202),
    [anon_sym_extension] = ACTIONS(2202),
  },
  [1250] = {
    [sym_identifier] = ACTIONS(2206),
    [anon_sym_LPAREN2] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2208),
    [anon_sym_TILDE] = ACTIONS(2208),
    [anon_sym_DASH] = ACTIONS(2206),
    [anon_sym_PLUS] = ACTIONS(2206),
    [anon_sym_STAR] = ACTIONS(2208),
    [anon_sym_AMP] = ACTIONS(2208),
    [anon_sym_COLON] = ACTIONS(2206),
    [anon_sym_SEMI] = ACTIONS(2208),
    [anon_sym___extension__] = ACTIONS(2206),
    [anon_sym_typedef] = ACTIONS(2206),
    [anon_sym_in] = ACTIONS(2206),
    [anon_sym_out] = ACTIONS(2206),
    [anon_sym_inout] = ACTIONS(2206),
    [anon_sym_extern] = ACTIONS(2206),
    [anon_sym___attribute__] = ACTIONS(2206),
    [anon_sym_COLON_COLON] = ACTIONS(2208),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2208),
    [anon_sym___declspec] = ACTIONS(2206),
    [anon_sym_LBRACE] = ACTIONS(2208),
    [anon_sym_signed] = ACTIONS(2206),
    [anon_sym_unsigned] = ACTIONS(2206),
    [anon_sym_long] = ACTIONS(2206),
    [anon_sym_short] = ACTIONS(2206),
    [anon_sym_LBRACK] = ACTIONS(2206),
    [anon_sym_static] = ACTIONS(2206),
    [anon_sym_register] = ACTIONS(2206),
    [anon_sym_inline] = ACTIONS(2206),
    [anon_sym___inline] = ACTIONS(2206),
    [anon_sym___inline__] = ACTIONS(2206),
    [anon_sym___forceinline] = ACTIONS(2206),
    [anon_sym_thread_local] = ACTIONS(2206),
    [anon_sym___thread] = ACTIONS(2206),
    [anon_sym_const] = ACTIONS(2206),
    [anon_sym_constexpr] = ACTIONS(2206),
    [anon_sym_volatile] = ACTIONS(2206),
    [anon_sym_restrict] = ACTIONS(2206),
    [anon_sym___restrict__] = ACTIONS(2206),
    [anon_sym__Atomic] = ACTIONS(2206),
    [anon_sym__Noreturn] = ACTIONS(2206),
    [anon_sym_noreturn] = ACTIONS(2206),
    [anon_sym_mutable] = ACTIONS(2206),
    [anon_sym_constinit] = ACTIONS(2206),
    [anon_sym_consteval] = ACTIONS(2206),
    [anon_sym_alignas] = ACTIONS(2206),
    [anon_sym__Alignas] = ACTIONS(2206),
    [sym_primitive_type] = ACTIONS(2206),
    [anon_sym_enum] = ACTIONS(2206),
    [anon_sym_class] = ACTIONS(2206),
    [anon_sym_struct] = ACTIONS(2206),
    [anon_sym_union] = ACTIONS(2206),
    [anon_sym_if] = ACTIONS(2206),
    [anon_sym_else] = ACTIONS(2206),
    [anon_sym_switch] = ACTIONS(2206),
    [anon_sym_while] = ACTIONS(2206),
    [anon_sym_do] = ACTIONS(2206),
    [anon_sym_for] = ACTIONS(2206),
    [anon_sym_return] = ACTIONS(2206),
    [anon_sym_break] = ACTIONS(2206),
    [anon_sym_continue] = ACTIONS(2206),
    [anon_sym_goto] = ACTIONS(2206),
    [anon_sym___try] = ACTIONS(2206),
    [anon_sym___leave] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_compl] = ACTIONS(2206),
    [anon_sym_DASH_DASH] = ACTIONS(2208),
    [anon_sym_PLUS_PLUS] = ACTIONS(2208),
    [anon_sym_sizeof] = ACTIONS(2206),
    [anon_sym___alignof__] = ACTIONS(2206),
    [anon_sym___alignof] = ACTIONS(2206),
    [anon_sym__alignof] = ACTIONS(2206),
    [anon_sym_alignof] = ACTIONS(2206),
    [anon_sym__Alignof] = ACTIONS(2206),
    [anon_sym_offsetof] = ACTIONS(2206),
    [anon_sym__Generic] = ACTIONS(2206),
    [anon_sym_asm] = ACTIONS(2206),
    [anon_sym___asm__] = ACTIONS(2206),
    [sym_number_literal] = ACTIONS(2208),
    [anon_sym_L_SQUOTE] = ACTIONS(2208),
    [anon_sym_u_SQUOTE] = ACTIONS(2208),
    [anon_sym_U_SQUOTE] = ACTIONS(2208),
    [anon_sym_u8_SQUOTE] = ACTIONS(2208),
    [anon_sym_SQUOTE] = ACTIONS(2208),
    [anon_sym_L_DQUOTE] = ACTIONS(2208),
    [anon_sym_u_DQUOTE] = ACTIONS(2208),
    [anon_sym_U_DQUOTE] = ACTIONS(2208),
    [anon_sym_u8_DQUOTE] = ACTIONS(2208),
    [anon_sym_DQUOTE] = ACTIONS(2208),
    [sym_true] = ACTIONS(2206),
    [sym_false] = ACTIONS(2206),
    [anon_sym_NULL] = ACTIONS(2206),
    [anon_sym_nullptr] = ACTIONS(2206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2206),
    [anon_sym_let] = ACTIONS(2206),
    [anon_sym_This] = ACTIONS(2206),
    [anon_sym_decltype] = ACTIONS(2206),
    [anon_sym_final] = ACTIONS(2206),
    [anon_sym_override] = ACTIONS(2206),
    [sym_virtual] = ACTIONS(2206),
    [anon_sym_typename] = ACTIONS(2206),
    [anon_sym_template] = ACTIONS(2206),
    [anon_sym_try] = ACTIONS(2206),
    [anon_sym_delete] = ACTIONS(2206),
    [anon_sym_throw] = ACTIONS(2206),
    [anon_sym_co_return] = ACTIONS(2206),
    [anon_sym_co_yield] = ACTIONS(2206),
    [anon_sym_R_DQUOTE] = ACTIONS(2208),
    [anon_sym_LR_DQUOTE] = ACTIONS(2208),
    [anon_sym_uR_DQUOTE] = ACTIONS(2208),
    [anon_sym_UR_DQUOTE] = ACTIONS(2208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2208),
    [anon_sym_co_await] = ACTIONS(2206),
    [anon_sym_new] = ACTIONS(2206),
    [anon_sym_requires] = ACTIONS(2206),
    [sym_this] = ACTIONS(2206),
    [anon_sym_discard] = ACTIONS(2206),
    [anon_sym_precise] = ACTIONS(2206),
    [anon_sym_shared] = ACTIONS(2206),
    [anon_sym_groupshared] = ACTIONS(2206),
    [anon_sym_uniform] = ACTIONS(2206),
    [anon_sym_row_major] = ACTIONS(2206),
    [anon_sym_column_major] = ACTIONS(2206),
    [anon_sym_globallycoherent] = ACTIONS(2206),
    [anon_sym_centroid] = ACTIONS(2206),
    [anon_sym_noperspective] = ACTIONS(2206),
    [anon_sym_nointerpolation] = ACTIONS(2206),
    [anon_sym_sample] = ACTIONS(2206),
    [anon_sym_linear] = ACTIONS(2206),
    [anon_sym_snorm] = ACTIONS(2206),
    [anon_sym_unorm] = ACTIONS(2206),
    [anon_sym_point] = ACTIONS(2206),
    [anon_sym_line] = ACTIONS(2206),
    [anon_sym_triangleadj] = ACTIONS(2206),
    [anon_sym_lineadj] = ACTIONS(2206),
    [anon_sym_triangle] = ACTIONS(2206),
    [anon_sym_cbuffer] = ACTIONS(2206),
    [anon_sym_interface] = ACTIONS(2206),
    [anon_sym_extension] = ACTIONS(2206),
  },
  [1251] = {
    [sym_identifier] = ACTIONS(2236),
    [anon_sym_LPAREN2] = ACTIONS(2238),
    [anon_sym_BANG] = ACTIONS(2238),
    [anon_sym_TILDE] = ACTIONS(2238),
    [anon_sym_DASH] = ACTIONS(2236),
    [anon_sym_PLUS] = ACTIONS(2236),
    [anon_sym_STAR] = ACTIONS(2238),
    [anon_sym_AMP] = ACTIONS(2238),
    [anon_sym_COLON] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(2238),
    [anon_sym___extension__] = ACTIONS(2236),
    [anon_sym_typedef] = ACTIONS(2236),
    [anon_sym_in] = ACTIONS(2236),
    [anon_sym_out] = ACTIONS(2236),
    [anon_sym_inout] = ACTIONS(2236),
    [anon_sym_extern] = ACTIONS(2236),
    [anon_sym___attribute__] = ACTIONS(2236),
    [anon_sym_COLON_COLON] = ACTIONS(2238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2238),
    [anon_sym___declspec] = ACTIONS(2236),
    [anon_sym_LBRACE] = ACTIONS(2238),
    [anon_sym_signed] = ACTIONS(2236),
    [anon_sym_unsigned] = ACTIONS(2236),
    [anon_sym_long] = ACTIONS(2236),
    [anon_sym_short] = ACTIONS(2236),
    [anon_sym_LBRACK] = ACTIONS(2236),
    [anon_sym_static] = ACTIONS(2236),
    [anon_sym_register] = ACTIONS(2236),
    [anon_sym_inline] = ACTIONS(2236),
    [anon_sym___inline] = ACTIONS(2236),
    [anon_sym___inline__] = ACTIONS(2236),
    [anon_sym___forceinline] = ACTIONS(2236),
    [anon_sym_thread_local] = ACTIONS(2236),
    [anon_sym___thread] = ACTIONS(2236),
    [anon_sym_const] = ACTIONS(2236),
    [anon_sym_constexpr] = ACTIONS(2236),
    [anon_sym_volatile] = ACTIONS(2236),
    [anon_sym_restrict] = ACTIONS(2236),
    [anon_sym___restrict__] = ACTIONS(2236),
    [anon_sym__Atomic] = ACTIONS(2236),
    [anon_sym__Noreturn] = ACTIONS(2236),
    [anon_sym_noreturn] = ACTIONS(2236),
    [anon_sym_mutable] = ACTIONS(2236),
    [anon_sym_constinit] = ACTIONS(2236),
    [anon_sym_consteval] = ACTIONS(2236),
    [anon_sym_alignas] = ACTIONS(2236),
    [anon_sym__Alignas] = ACTIONS(2236),
    [sym_primitive_type] = ACTIONS(2236),
    [anon_sym_enum] = ACTIONS(2236),
    [anon_sym_class] = ACTIONS(2236),
    [anon_sym_struct] = ACTIONS(2236),
    [anon_sym_union] = ACTIONS(2236),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_else] = ACTIONS(2236),
    [anon_sym_switch] = ACTIONS(2236),
    [anon_sym_while] = ACTIONS(2236),
    [anon_sym_do] = ACTIONS(2236),
    [anon_sym_for] = ACTIONS(2236),
    [anon_sym_return] = ACTIONS(2236),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2236),
    [anon_sym_goto] = ACTIONS(2236),
    [anon_sym___try] = ACTIONS(2236),
    [anon_sym___leave] = ACTIONS(2236),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_compl] = ACTIONS(2236),
    [anon_sym_DASH_DASH] = ACTIONS(2238),
    [anon_sym_PLUS_PLUS] = ACTIONS(2238),
    [anon_sym_sizeof] = ACTIONS(2236),
    [anon_sym___alignof__] = ACTIONS(2236),
    [anon_sym___alignof] = ACTIONS(2236),
    [anon_sym__alignof] = ACTIONS(2236),
    [anon_sym_alignof] = ACTIONS(2236),
    [anon_sym__Alignof] = ACTIONS(2236),
    [anon_sym_offsetof] = ACTIONS(2236),
    [anon_sym__Generic] = ACTIONS(2236),
    [anon_sym_asm] = ACTIONS(2236),
    [anon_sym___asm__] = ACTIONS(2236),
    [sym_number_literal] = ACTIONS(2238),
    [anon_sym_L_SQUOTE] = ACTIONS(2238),
    [anon_sym_u_SQUOTE] = ACTIONS(2238),
    [anon_sym_U_SQUOTE] = ACTIONS(2238),
    [anon_sym_u8_SQUOTE] = ACTIONS(2238),
    [anon_sym_SQUOTE] = ACTIONS(2238),
    [anon_sym_L_DQUOTE] = ACTIONS(2238),
    [anon_sym_u_DQUOTE] = ACTIONS(2238),
    [anon_sym_U_DQUOTE] = ACTIONS(2238),
    [anon_sym_u8_DQUOTE] = ACTIONS(2238),
    [anon_sym_DQUOTE] = ACTIONS(2238),
    [sym_true] = ACTIONS(2236),
    [sym_false] = ACTIONS(2236),
    [anon_sym_NULL] = ACTIONS(2236),
    [anon_sym_nullptr] = ACTIONS(2236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2236),
    [anon_sym_let] = ACTIONS(2236),
    [anon_sym_This] = ACTIONS(2236),
    [anon_sym_decltype] = ACTIONS(2236),
    [anon_sym_final] = ACTIONS(2236),
    [anon_sym_override] = ACTIONS(2236),
    [sym_virtual] = ACTIONS(2236),
    [anon_sym_typename] = ACTIONS(2236),
    [anon_sym_template] = ACTIONS(2236),
    [anon_sym_try] = ACTIONS(2236),
    [anon_sym_delete] = ACTIONS(2236),
    [anon_sym_throw] = ACTIONS(2236),
    [anon_sym_co_return] = ACTIONS(2236),
    [anon_sym_co_yield] = ACTIONS(2236),
    [anon_sym_R_DQUOTE] = ACTIONS(2238),
    [anon_sym_LR_DQUOTE] = ACTIONS(2238),
    [anon_sym_uR_DQUOTE] = ACTIONS(2238),
    [anon_sym_UR_DQUOTE] = ACTIONS(2238),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2238),
    [anon_sym_co_await] = ACTIONS(2236),
    [anon_sym_new] = ACTIONS(2236),
    [anon_sym_requires] = ACTIONS(2236),
    [sym_this] = ACTIONS(2236),
    [anon_sym_discard] = ACTIONS(2236),
    [anon_sym_precise] = ACTIONS(2236),
    [anon_sym_shared] = ACTIONS(2236),
    [anon_sym_groupshared] = ACTIONS(2236),
    [anon_sym_uniform] = ACTIONS(2236),
    [anon_sym_row_major] = ACTIONS(2236),
    [anon_sym_column_major] = ACTIONS(2236),
    [anon_sym_globallycoherent] = ACTIONS(2236),
    [anon_sym_centroid] = ACTIONS(2236),
    [anon_sym_noperspective] = ACTIONS(2236),
    [anon_sym_nointerpolation] = ACTIONS(2236),
    [anon_sym_sample] = ACTIONS(2236),
    [anon_sym_linear] = ACTIONS(2236),
    [anon_sym_snorm] = ACTIONS(2236),
    [anon_sym_unorm] = ACTIONS(2236),
    [anon_sym_point] = ACTIONS(2236),
    [anon_sym_line] = ACTIONS(2236),
    [anon_sym_triangleadj] = ACTIONS(2236),
    [anon_sym_lineadj] = ACTIONS(2236),
    [anon_sym_triangle] = ACTIONS(2236),
    [anon_sym_cbuffer] = ACTIONS(2236),
    [anon_sym_interface] = ACTIONS(2236),
    [anon_sym_extension] = ACTIONS(2236),
  },
  [1252] = {
    [sym_identifier] = ACTIONS(2224),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_BANG] = ACTIONS(2226),
    [anon_sym_TILDE] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_PLUS] = ACTIONS(2224),
    [anon_sym_STAR] = ACTIONS(2226),
    [anon_sym_AMP] = ACTIONS(2226),
    [anon_sym_COLON] = ACTIONS(2224),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym___extension__] = ACTIONS(2224),
    [anon_sym_typedef] = ACTIONS(2224),
    [anon_sym_in] = ACTIONS(2224),
    [anon_sym_out] = ACTIONS(2224),
    [anon_sym_inout] = ACTIONS(2224),
    [anon_sym_extern] = ACTIONS(2224),
    [anon_sym___attribute__] = ACTIONS(2224),
    [anon_sym_COLON_COLON] = ACTIONS(2226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2226),
    [anon_sym___declspec] = ACTIONS(2224),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_signed] = ACTIONS(2224),
    [anon_sym_unsigned] = ACTIONS(2224),
    [anon_sym_long] = ACTIONS(2224),
    [anon_sym_short] = ACTIONS(2224),
    [anon_sym_LBRACK] = ACTIONS(2224),
    [anon_sym_static] = ACTIONS(2224),
    [anon_sym_register] = ACTIONS(2224),
    [anon_sym_inline] = ACTIONS(2224),
    [anon_sym___inline] = ACTIONS(2224),
    [anon_sym___inline__] = ACTIONS(2224),
    [anon_sym___forceinline] = ACTIONS(2224),
    [anon_sym_thread_local] = ACTIONS(2224),
    [anon_sym___thread] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_constexpr] = ACTIONS(2224),
    [anon_sym_volatile] = ACTIONS(2224),
    [anon_sym_restrict] = ACTIONS(2224),
    [anon_sym___restrict__] = ACTIONS(2224),
    [anon_sym__Atomic] = ACTIONS(2224),
    [anon_sym__Noreturn] = ACTIONS(2224),
    [anon_sym_noreturn] = ACTIONS(2224),
    [anon_sym_mutable] = ACTIONS(2224),
    [anon_sym_constinit] = ACTIONS(2224),
    [anon_sym_consteval] = ACTIONS(2224),
    [anon_sym_alignas] = ACTIONS(2224),
    [anon_sym__Alignas] = ACTIONS(2224),
    [sym_primitive_type] = ACTIONS(2224),
    [anon_sym_enum] = ACTIONS(2224),
    [anon_sym_class] = ACTIONS(2224),
    [anon_sym_struct] = ACTIONS(2224),
    [anon_sym_union] = ACTIONS(2224),
    [anon_sym_if] = ACTIONS(2224),
    [anon_sym_else] = ACTIONS(2224),
    [anon_sym_switch] = ACTIONS(2224),
    [anon_sym_while] = ACTIONS(2224),
    [anon_sym_do] = ACTIONS(2224),
    [anon_sym_for] = ACTIONS(2224),
    [anon_sym_return] = ACTIONS(2224),
    [anon_sym_break] = ACTIONS(2224),
    [anon_sym_continue] = ACTIONS(2224),
    [anon_sym_goto] = ACTIONS(2224),
    [anon_sym___try] = ACTIONS(2224),
    [anon_sym___leave] = ACTIONS(2224),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_compl] = ACTIONS(2224),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_sizeof] = ACTIONS(2224),
    [anon_sym___alignof__] = ACTIONS(2224),
    [anon_sym___alignof] = ACTIONS(2224),
    [anon_sym__alignof] = ACTIONS(2224),
    [anon_sym_alignof] = ACTIONS(2224),
    [anon_sym__Alignof] = ACTIONS(2224),
    [anon_sym_offsetof] = ACTIONS(2224),
    [anon_sym__Generic] = ACTIONS(2224),
    [anon_sym_asm] = ACTIONS(2224),
    [anon_sym___asm__] = ACTIONS(2224),
    [sym_number_literal] = ACTIONS(2226),
    [anon_sym_L_SQUOTE] = ACTIONS(2226),
    [anon_sym_u_SQUOTE] = ACTIONS(2226),
    [anon_sym_U_SQUOTE] = ACTIONS(2226),
    [anon_sym_u8_SQUOTE] = ACTIONS(2226),
    [anon_sym_SQUOTE] = ACTIONS(2226),
    [anon_sym_L_DQUOTE] = ACTIONS(2226),
    [anon_sym_u_DQUOTE] = ACTIONS(2226),
    [anon_sym_U_DQUOTE] = ACTIONS(2226),
    [anon_sym_u8_DQUOTE] = ACTIONS(2226),
    [anon_sym_DQUOTE] = ACTIONS(2226),
    [sym_true] = ACTIONS(2224),
    [sym_false] = ACTIONS(2224),
    [anon_sym_NULL] = ACTIONS(2224),
    [anon_sym_nullptr] = ACTIONS(2224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2224),
    [anon_sym_let] = ACTIONS(2224),
    [anon_sym_This] = ACTIONS(2224),
    [anon_sym_decltype] = ACTIONS(2224),
    [anon_sym_final] = ACTIONS(2224),
    [anon_sym_override] = ACTIONS(2224),
    [sym_virtual] = ACTIONS(2224),
    [anon_sym_typename] = ACTIONS(2224),
    [anon_sym_template] = ACTIONS(2224),
    [anon_sym_try] = ACTIONS(2224),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_throw] = ACTIONS(2224),
    [anon_sym_co_return] = ACTIONS(2224),
    [anon_sym_co_yield] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(2226),
    [anon_sym_LR_DQUOTE] = ACTIONS(2226),
    [anon_sym_uR_DQUOTE] = ACTIONS(2226),
    [anon_sym_UR_DQUOTE] = ACTIONS(2226),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2226),
    [anon_sym_co_await] = ACTIONS(2224),
    [anon_sym_new] = ACTIONS(2224),
    [anon_sym_requires] = ACTIONS(2224),
    [sym_this] = ACTIONS(2224),
    [anon_sym_discard] = ACTIONS(2224),
    [anon_sym_precise] = ACTIONS(2224),
    [anon_sym_shared] = ACTIONS(2224),
    [anon_sym_groupshared] = ACTIONS(2224),
    [anon_sym_uniform] = ACTIONS(2224),
    [anon_sym_row_major] = ACTIONS(2224),
    [anon_sym_column_major] = ACTIONS(2224),
    [anon_sym_globallycoherent] = ACTIONS(2224),
    [anon_sym_centroid] = ACTIONS(2224),
    [anon_sym_noperspective] = ACTIONS(2224),
    [anon_sym_nointerpolation] = ACTIONS(2224),
    [anon_sym_sample] = ACTIONS(2224),
    [anon_sym_linear] = ACTIONS(2224),
    [anon_sym_snorm] = ACTIONS(2224),
    [anon_sym_unorm] = ACTIONS(2224),
    [anon_sym_point] = ACTIONS(2224),
    [anon_sym_line] = ACTIONS(2224),
    [anon_sym_triangleadj] = ACTIONS(2224),
    [anon_sym_lineadj] = ACTIONS(2224),
    [anon_sym_triangle] = ACTIONS(2224),
    [anon_sym_cbuffer] = ACTIONS(2224),
    [anon_sym_interface] = ACTIONS(2224),
    [anon_sym_extension] = ACTIONS(2224),
  },
  [1253] = {
    [sym_identifier] = ACTIONS(2198),
    [anon_sym_LPAREN2] = ACTIONS(2200),
    [anon_sym_BANG] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(2200),
    [anon_sym_AMP] = ACTIONS(2200),
    [anon_sym_COLON] = ACTIONS(2198),
    [anon_sym_SEMI] = ACTIONS(2200),
    [anon_sym___extension__] = ACTIONS(2198),
    [anon_sym_typedef] = ACTIONS(2198),
    [anon_sym_in] = ACTIONS(2198),
    [anon_sym_out] = ACTIONS(2198),
    [anon_sym_inout] = ACTIONS(2198),
    [anon_sym_extern] = ACTIONS(2198),
    [anon_sym___attribute__] = ACTIONS(2198),
    [anon_sym_COLON_COLON] = ACTIONS(2200),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2200),
    [anon_sym___declspec] = ACTIONS(2198),
    [anon_sym_LBRACE] = ACTIONS(2200),
    [anon_sym_signed] = ACTIONS(2198),
    [anon_sym_unsigned] = ACTIONS(2198),
    [anon_sym_long] = ACTIONS(2198),
    [anon_sym_short] = ACTIONS(2198),
    [anon_sym_LBRACK] = ACTIONS(2198),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_register] = ACTIONS(2198),
    [anon_sym_inline] = ACTIONS(2198),
    [anon_sym___inline] = ACTIONS(2198),
    [anon_sym___inline__] = ACTIONS(2198),
    [anon_sym___forceinline] = ACTIONS(2198),
    [anon_sym_thread_local] = ACTIONS(2198),
    [anon_sym___thread] = ACTIONS(2198),
    [anon_sym_const] = ACTIONS(2198),
    [anon_sym_constexpr] = ACTIONS(2198),
    [anon_sym_volatile] = ACTIONS(2198),
    [anon_sym_restrict] = ACTIONS(2198),
    [anon_sym___restrict__] = ACTIONS(2198),
    [anon_sym__Atomic] = ACTIONS(2198),
    [anon_sym__Noreturn] = ACTIONS(2198),
    [anon_sym_noreturn] = ACTIONS(2198),
    [anon_sym_mutable] = ACTIONS(2198),
    [anon_sym_constinit] = ACTIONS(2198),
    [anon_sym_consteval] = ACTIONS(2198),
    [anon_sym_alignas] = ACTIONS(2198),
    [anon_sym__Alignas] = ACTIONS(2198),
    [sym_primitive_type] = ACTIONS(2198),
    [anon_sym_enum] = ACTIONS(2198),
    [anon_sym_class] = ACTIONS(2198),
    [anon_sym_struct] = ACTIONS(2198),
    [anon_sym_union] = ACTIONS(2198),
    [anon_sym_if] = ACTIONS(2198),
    [anon_sym_else] = ACTIONS(2198),
    [anon_sym_switch] = ACTIONS(2198),
    [anon_sym_while] = ACTIONS(2198),
    [anon_sym_do] = ACTIONS(2198),
    [anon_sym_for] = ACTIONS(2198),
    [anon_sym_return] = ACTIONS(2198),
    [anon_sym_break] = ACTIONS(2198),
    [anon_sym_continue] = ACTIONS(2198),
    [anon_sym_goto] = ACTIONS(2198),
    [anon_sym___try] = ACTIONS(2198),
    [anon_sym___leave] = ACTIONS(2198),
    [anon_sym_not] = ACTIONS(2198),
    [anon_sym_compl] = ACTIONS(2198),
    [anon_sym_DASH_DASH] = ACTIONS(2200),
    [anon_sym_PLUS_PLUS] = ACTIONS(2200),
    [anon_sym_sizeof] = ACTIONS(2198),
    [anon_sym___alignof__] = ACTIONS(2198),
    [anon_sym___alignof] = ACTIONS(2198),
    [anon_sym__alignof] = ACTIONS(2198),
    [anon_sym_alignof] = ACTIONS(2198),
    [anon_sym__Alignof] = ACTIONS(2198),
    [anon_sym_offsetof] = ACTIONS(2198),
    [anon_sym__Generic] = ACTIONS(2198),
    [anon_sym_asm] = ACTIONS(2198),
    [anon_sym___asm__] = ACTIONS(2198),
    [sym_number_literal] = ACTIONS(2200),
    [anon_sym_L_SQUOTE] = ACTIONS(2200),
    [anon_sym_u_SQUOTE] = ACTIONS(2200),
    [anon_sym_U_SQUOTE] = ACTIONS(2200),
    [anon_sym_u8_SQUOTE] = ACTIONS(2200),
    [anon_sym_SQUOTE] = ACTIONS(2200),
    [anon_sym_L_DQUOTE] = ACTIONS(2200),
    [anon_sym_u_DQUOTE] = ACTIONS(2200),
    [anon_sym_U_DQUOTE] = ACTIONS(2200),
    [anon_sym_u8_DQUOTE] = ACTIONS(2200),
    [anon_sym_DQUOTE] = ACTIONS(2200),
    [sym_true] = ACTIONS(2198),
    [sym_false] = ACTIONS(2198),
    [anon_sym_NULL] = ACTIONS(2198),
    [anon_sym_nullptr] = ACTIONS(2198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2198),
    [anon_sym_let] = ACTIONS(2198),
    [anon_sym_This] = ACTIONS(2198),
    [anon_sym_decltype] = ACTIONS(2198),
    [anon_sym_final] = ACTIONS(2198),
    [anon_sym_override] = ACTIONS(2198),
    [sym_virtual] = ACTIONS(2198),
    [anon_sym_typename] = ACTIONS(2198),
    [anon_sym_template] = ACTIONS(2198),
    [anon_sym_try] = ACTIONS(2198),
    [anon_sym_delete] = ACTIONS(2198),
    [anon_sym_throw] = ACTIONS(2198),
    [anon_sym_co_return] = ACTIONS(2198),
    [anon_sym_co_yield] = ACTIONS(2198),
    [anon_sym_R_DQUOTE] = ACTIONS(2200),
    [anon_sym_LR_DQUOTE] = ACTIONS(2200),
    [anon_sym_uR_DQUOTE] = ACTIONS(2200),
    [anon_sym_UR_DQUOTE] = ACTIONS(2200),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2200),
    [anon_sym_co_await] = ACTIONS(2198),
    [anon_sym_new] = ACTIONS(2198),
    [anon_sym_requires] = ACTIONS(2198),
    [sym_this] = ACTIONS(2198),
    [anon_sym_discard] = ACTIONS(2198),
    [anon_sym_precise] = ACTIONS(2198),
    [anon_sym_shared] = ACTIONS(2198),
    [anon_sym_groupshared] = ACTIONS(2198),
    [anon_sym_uniform] = ACTIONS(2198),
    [anon_sym_row_major] = ACTIONS(2198),
    [anon_sym_column_major] = ACTIONS(2198),
    [anon_sym_globallycoherent] = ACTIONS(2198),
    [anon_sym_centroid] = ACTIONS(2198),
    [anon_sym_noperspective] = ACTIONS(2198),
    [anon_sym_nointerpolation] = ACTIONS(2198),
    [anon_sym_sample] = ACTIONS(2198),
    [anon_sym_linear] = ACTIONS(2198),
    [anon_sym_snorm] = ACTIONS(2198),
    [anon_sym_unorm] = ACTIONS(2198),
    [anon_sym_point] = ACTIONS(2198),
    [anon_sym_line] = ACTIONS(2198),
    [anon_sym_triangleadj] = ACTIONS(2198),
    [anon_sym_lineadj] = ACTIONS(2198),
    [anon_sym_triangle] = ACTIONS(2198),
    [anon_sym_cbuffer] = ACTIONS(2198),
    [anon_sym_interface] = ACTIONS(2198),
    [anon_sym_extension] = ACTIONS(2198),
  },
  [1254] = {
    [sym_identifier] = ACTIONS(2256),
    [anon_sym_LPAREN2] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [anon_sym_DASH] = ACTIONS(2256),
    [anon_sym_PLUS] = ACTIONS(2256),
    [anon_sym_STAR] = ACTIONS(2258),
    [anon_sym_AMP] = ACTIONS(2258),
    [anon_sym_COLON] = ACTIONS(2256),
    [anon_sym_SEMI] = ACTIONS(2258),
    [anon_sym___extension__] = ACTIONS(2256),
    [anon_sym_typedef] = ACTIONS(2256),
    [anon_sym_in] = ACTIONS(2256),
    [anon_sym_out] = ACTIONS(2256),
    [anon_sym_inout] = ACTIONS(2256),
    [anon_sym_extern] = ACTIONS(2256),
    [anon_sym___attribute__] = ACTIONS(2256),
    [anon_sym_COLON_COLON] = ACTIONS(2258),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2258),
    [anon_sym___declspec] = ACTIONS(2256),
    [anon_sym_LBRACE] = ACTIONS(2258),
    [anon_sym_signed] = ACTIONS(2256),
    [anon_sym_unsigned] = ACTIONS(2256),
    [anon_sym_long] = ACTIONS(2256),
    [anon_sym_short] = ACTIONS(2256),
    [anon_sym_LBRACK] = ACTIONS(2256),
    [anon_sym_static] = ACTIONS(2256),
    [anon_sym_register] = ACTIONS(2256),
    [anon_sym_inline] = ACTIONS(2256),
    [anon_sym___inline] = ACTIONS(2256),
    [anon_sym___inline__] = ACTIONS(2256),
    [anon_sym___forceinline] = ACTIONS(2256),
    [anon_sym_thread_local] = ACTIONS(2256),
    [anon_sym___thread] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_constexpr] = ACTIONS(2256),
    [anon_sym_volatile] = ACTIONS(2256),
    [anon_sym_restrict] = ACTIONS(2256),
    [anon_sym___restrict__] = ACTIONS(2256),
    [anon_sym__Atomic] = ACTIONS(2256),
    [anon_sym__Noreturn] = ACTIONS(2256),
    [anon_sym_noreturn] = ACTIONS(2256),
    [anon_sym_mutable] = ACTIONS(2256),
    [anon_sym_constinit] = ACTIONS(2256),
    [anon_sym_consteval] = ACTIONS(2256),
    [anon_sym_alignas] = ACTIONS(2256),
    [anon_sym__Alignas] = ACTIONS(2256),
    [sym_primitive_type] = ACTIONS(2256),
    [anon_sym_enum] = ACTIONS(2256),
    [anon_sym_class] = ACTIONS(2256),
    [anon_sym_struct] = ACTIONS(2256),
    [anon_sym_union] = ACTIONS(2256),
    [anon_sym_if] = ACTIONS(2256),
    [anon_sym_else] = ACTIONS(2256),
    [anon_sym_switch] = ACTIONS(2256),
    [anon_sym_while] = ACTIONS(2256),
    [anon_sym_do] = ACTIONS(2256),
    [anon_sym_for] = ACTIONS(2256),
    [anon_sym_return] = ACTIONS(2256),
    [anon_sym_break] = ACTIONS(2256),
    [anon_sym_continue] = ACTIONS(2256),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym___try] = ACTIONS(2256),
    [anon_sym___leave] = ACTIONS(2256),
    [anon_sym_not] = ACTIONS(2256),
    [anon_sym_compl] = ACTIONS(2256),
    [anon_sym_DASH_DASH] = ACTIONS(2258),
    [anon_sym_PLUS_PLUS] = ACTIONS(2258),
    [anon_sym_sizeof] = ACTIONS(2256),
    [anon_sym___alignof__] = ACTIONS(2256),
    [anon_sym___alignof] = ACTIONS(2256),
    [anon_sym__alignof] = ACTIONS(2256),
    [anon_sym_alignof] = ACTIONS(2256),
    [anon_sym__Alignof] = ACTIONS(2256),
    [anon_sym_offsetof] = ACTIONS(2256),
    [anon_sym__Generic] = ACTIONS(2256),
    [anon_sym_asm] = ACTIONS(2256),
    [anon_sym___asm__] = ACTIONS(2256),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_L_SQUOTE] = ACTIONS(2258),
    [anon_sym_u_SQUOTE] = ACTIONS(2258),
    [anon_sym_U_SQUOTE] = ACTIONS(2258),
    [anon_sym_u8_SQUOTE] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(2258),
    [anon_sym_L_DQUOTE] = ACTIONS(2258),
    [anon_sym_u_DQUOTE] = ACTIONS(2258),
    [anon_sym_U_DQUOTE] = ACTIONS(2258),
    [anon_sym_u8_DQUOTE] = ACTIONS(2258),
    [anon_sym_DQUOTE] = ACTIONS(2258),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2256),
    [anon_sym_nullptr] = ACTIONS(2256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_This] = ACTIONS(2256),
    [anon_sym_decltype] = ACTIONS(2256),
    [anon_sym_final] = ACTIONS(2256),
    [anon_sym_override] = ACTIONS(2256),
    [sym_virtual] = ACTIONS(2256),
    [anon_sym_typename] = ACTIONS(2256),
    [anon_sym_template] = ACTIONS(2256),
    [anon_sym_try] = ACTIONS(2256),
    [anon_sym_delete] = ACTIONS(2256),
    [anon_sym_throw] = ACTIONS(2256),
    [anon_sym_co_return] = ACTIONS(2256),
    [anon_sym_co_yield] = ACTIONS(2256),
    [anon_sym_R_DQUOTE] = ACTIONS(2258),
    [anon_sym_LR_DQUOTE] = ACTIONS(2258),
    [anon_sym_uR_DQUOTE] = ACTIONS(2258),
    [anon_sym_UR_DQUOTE] = ACTIONS(2258),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2258),
    [anon_sym_co_await] = ACTIONS(2256),
    [anon_sym_new] = ACTIONS(2256),
    [anon_sym_requires] = ACTIONS(2256),
    [sym_this] = ACTIONS(2256),
    [anon_sym_discard] = ACTIONS(2256),
    [anon_sym_precise] = ACTIONS(2256),
    [anon_sym_shared] = ACTIONS(2256),
    [anon_sym_groupshared] = ACTIONS(2256),
    [anon_sym_uniform] = ACTIONS(2256),
    [anon_sym_row_major] = ACTIONS(2256),
    [anon_sym_column_major] = ACTIONS(2256),
    [anon_sym_globallycoherent] = ACTIONS(2256),
    [anon_sym_centroid] = ACTIONS(2256),
    [anon_sym_noperspective] = ACTIONS(2256),
    [anon_sym_nointerpolation] = ACTIONS(2256),
    [anon_sym_sample] = ACTIONS(2256),
    [anon_sym_linear] = ACTIONS(2256),
    [anon_sym_snorm] = ACTIONS(2256),
    [anon_sym_unorm] = ACTIONS(2256),
    [anon_sym_point] = ACTIONS(2256),
    [anon_sym_line] = ACTIONS(2256),
    [anon_sym_triangleadj] = ACTIONS(2256),
    [anon_sym_lineadj] = ACTIONS(2256),
    [anon_sym_triangle] = ACTIONS(2256),
    [anon_sym_cbuffer] = ACTIONS(2256),
    [anon_sym_interface] = ACTIONS(2256),
    [anon_sym_extension] = ACTIONS(2256),
  },
  [1255] = {
    [sym_type_qualifier] = STATE(4248),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(4960),
    [sym_sized_type_specifier] = STATE(5826),
    [sym_enum_specifier] = STATE(5826),
    [sym_struct_specifier] = STATE(5826),
    [sym_union_specifier] = STATE(5826),
    [sym_expression] = STATE(5386),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_type_descriptor] = STATE(8470),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_placeholder_type_specifier] = STATE(5826),
    [sym_decltype] = STATE(5647),
    [sym_class_specifier] = STATE(5826),
    [sym__class_name] = STATE(9946),
    [sym_dependent_type] = STATE(5826),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_type_parameter_pack_expansion] = STATE(9855),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6860),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4414),
    [sym_interface_specifier] = STATE(5826),
    [sym_extension_specifier] = STATE(5826),
    [sym_associatedtype_specifier] = STATE(5826),
    [aux_sym__type_definition_type_repeat1] = STATE(4248),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4903),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_signed] = ACTIONS(4633),
    [anon_sym_unsigned] = ACTIONS(4633),
    [anon_sym_long] = ACTIONS(4633),
    [anon_sym_short] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4635),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_class] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4641),
    [anon_sym_union] = ACTIONS(4643),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4667),
    [anon_sym_let] = ACTIONS(4852),
    [anon_sym_This] = ACTIONS(4667),
    [anon_sym_decltype] = ACTIONS(4671),
    [anon_sym_typename] = ACTIONS(4673),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
    [anon_sym_interface] = ACTIONS(4687),
    [anon_sym_extension] = ACTIONS(4689),
  },
  [1256] = {
    [sym_identifier] = ACTIONS(2248),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2248),
    [anon_sym_PLUS] = ACTIONS(2248),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_COLON] = ACTIONS(2248),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym___extension__] = ACTIONS(2248),
    [anon_sym_typedef] = ACTIONS(2248),
    [anon_sym_in] = ACTIONS(2248),
    [anon_sym_out] = ACTIONS(2248),
    [anon_sym_inout] = ACTIONS(2248),
    [anon_sym_extern] = ACTIONS(2248),
    [anon_sym___attribute__] = ACTIONS(2248),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2250),
    [anon_sym___declspec] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_signed] = ACTIONS(2248),
    [anon_sym_unsigned] = ACTIONS(2248),
    [anon_sym_long] = ACTIONS(2248),
    [anon_sym_short] = ACTIONS(2248),
    [anon_sym_LBRACK] = ACTIONS(2248),
    [anon_sym_static] = ACTIONS(2248),
    [anon_sym_register] = ACTIONS(2248),
    [anon_sym_inline] = ACTIONS(2248),
    [anon_sym___inline] = ACTIONS(2248),
    [anon_sym___inline__] = ACTIONS(2248),
    [anon_sym___forceinline] = ACTIONS(2248),
    [anon_sym_thread_local] = ACTIONS(2248),
    [anon_sym___thread] = ACTIONS(2248),
    [anon_sym_const] = ACTIONS(2248),
    [anon_sym_constexpr] = ACTIONS(2248),
    [anon_sym_volatile] = ACTIONS(2248),
    [anon_sym_restrict] = ACTIONS(2248),
    [anon_sym___restrict__] = ACTIONS(2248),
    [anon_sym__Atomic] = ACTIONS(2248),
    [anon_sym__Noreturn] = ACTIONS(2248),
    [anon_sym_noreturn] = ACTIONS(2248),
    [anon_sym_mutable] = ACTIONS(2248),
    [anon_sym_constinit] = ACTIONS(2248),
    [anon_sym_consteval] = ACTIONS(2248),
    [anon_sym_alignas] = ACTIONS(2248),
    [anon_sym__Alignas] = ACTIONS(2248),
    [sym_primitive_type] = ACTIONS(2248),
    [anon_sym_enum] = ACTIONS(2248),
    [anon_sym_class] = ACTIONS(2248),
    [anon_sym_struct] = ACTIONS(2248),
    [anon_sym_union] = ACTIONS(2248),
    [anon_sym_if] = ACTIONS(2248),
    [anon_sym_else] = ACTIONS(2248),
    [anon_sym_switch] = ACTIONS(2248),
    [anon_sym_while] = ACTIONS(2248),
    [anon_sym_do] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2248),
    [anon_sym_break] = ACTIONS(2248),
    [anon_sym_continue] = ACTIONS(2248),
    [anon_sym_goto] = ACTIONS(2248),
    [anon_sym___try] = ACTIONS(2248),
    [anon_sym___leave] = ACTIONS(2248),
    [anon_sym_not] = ACTIONS(2248),
    [anon_sym_compl] = ACTIONS(2248),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_sizeof] = ACTIONS(2248),
    [anon_sym___alignof__] = ACTIONS(2248),
    [anon_sym___alignof] = ACTIONS(2248),
    [anon_sym__alignof] = ACTIONS(2248),
    [anon_sym_alignof] = ACTIONS(2248),
    [anon_sym__Alignof] = ACTIONS(2248),
    [anon_sym_offsetof] = ACTIONS(2248),
    [anon_sym__Generic] = ACTIONS(2248),
    [anon_sym_asm] = ACTIONS(2248),
    [anon_sym___asm__] = ACTIONS(2248),
    [sym_number_literal] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2250),
    [anon_sym_u_SQUOTE] = ACTIONS(2250),
    [anon_sym_U_SQUOTE] = ACTIONS(2250),
    [anon_sym_u8_SQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym_L_DQUOTE] = ACTIONS(2250),
    [anon_sym_u_DQUOTE] = ACTIONS(2250),
    [anon_sym_U_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [sym_true] = ACTIONS(2248),
    [sym_false] = ACTIONS(2248),
    [anon_sym_NULL] = ACTIONS(2248),
    [anon_sym_nullptr] = ACTIONS(2248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2248),
    [anon_sym_let] = ACTIONS(2248),
    [anon_sym_This] = ACTIONS(2248),
    [anon_sym_decltype] = ACTIONS(2248),
    [anon_sym_final] = ACTIONS(2248),
    [anon_sym_override] = ACTIONS(2248),
    [sym_virtual] = ACTIONS(2248),
    [anon_sym_typename] = ACTIONS(2248),
    [anon_sym_template] = ACTIONS(2248),
    [anon_sym_try] = ACTIONS(2248),
    [anon_sym_delete] = ACTIONS(2248),
    [anon_sym_throw] = ACTIONS(2248),
    [anon_sym_co_return] = ACTIONS(2248),
    [anon_sym_co_yield] = ACTIONS(2248),
    [anon_sym_R_DQUOTE] = ACTIONS(2250),
    [anon_sym_LR_DQUOTE] = ACTIONS(2250),
    [anon_sym_uR_DQUOTE] = ACTIONS(2250),
    [anon_sym_UR_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2250),
    [anon_sym_co_await] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2248),
    [anon_sym_requires] = ACTIONS(2248),
    [sym_this] = ACTIONS(2248),
    [anon_sym_discard] = ACTIONS(2248),
    [anon_sym_precise] = ACTIONS(2248),
    [anon_sym_shared] = ACTIONS(2248),
    [anon_sym_groupshared] = ACTIONS(2248),
    [anon_sym_uniform] = ACTIONS(2248),
    [anon_sym_row_major] = ACTIONS(2248),
    [anon_sym_column_major] = ACTIONS(2248),
    [anon_sym_globallycoherent] = ACTIONS(2248),
    [anon_sym_centroid] = ACTIONS(2248),
    [anon_sym_noperspective] = ACTIONS(2248),
    [anon_sym_nointerpolation] = ACTIONS(2248),
    [anon_sym_sample] = ACTIONS(2248),
    [anon_sym_linear] = ACTIONS(2248),
    [anon_sym_snorm] = ACTIONS(2248),
    [anon_sym_unorm] = ACTIONS(2248),
    [anon_sym_point] = ACTIONS(2248),
    [anon_sym_line] = ACTIONS(2248),
    [anon_sym_triangleadj] = ACTIONS(2248),
    [anon_sym_lineadj] = ACTIONS(2248),
    [anon_sym_triangle] = ACTIONS(2248),
    [anon_sym_cbuffer] = ACTIONS(2248),
    [anon_sym_interface] = ACTIONS(2248),
    [anon_sym_extension] = ACTIONS(2248),
  },
  [1257] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(5543),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_type_descriptor] = STATE(10149),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6821),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4081),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4854),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4856),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1258] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(5584),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_type_descriptor] = STATE(10737),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6821),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4081),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4854),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4856),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1259] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(5507),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_type_descriptor] = STATE(10288),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6821),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4081),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4854),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4856),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1260] = {
    [sym_string_literal] = STATE(3342),
    [sym_template_argument_list] = STATE(1461),
    [sym_raw_string_literal] = STATE(3342),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2639),
    [sym_identifier] = ACTIONS(2115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2130),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(4858),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON] = ACTIONS(4861),
    [anon_sym_SEMI] = ACTIONS(2130),
    [anon_sym___extension__] = ACTIONS(2115),
    [anon_sym_in] = ACTIONS(2115),
    [anon_sym_out] = ACTIONS(2115),
    [anon_sym_inout] = ACTIONS(2115),
    [anon_sym_extern] = ACTIONS(2115),
    [anon_sym___attribute__] = ACTIONS(2115),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2140),
    [anon_sym___declspec] = ACTIONS(2115),
    [anon_sym___based] = ACTIONS(2115),
    [anon_sym___cdecl] = ACTIONS(2115),
    [anon_sym___clrcall] = ACTIONS(2115),
    [anon_sym___stdcall] = ACTIONS(2115),
    [anon_sym___fastcall] = ACTIONS(2115),
    [anon_sym___thiscall] = ACTIONS(2115),
    [anon_sym___vectorcall] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_RBRACE] = ACTIONS(2117),
    [anon_sym_signed] = ACTIONS(4863),
    [anon_sym_unsigned] = ACTIONS(4863),
    [anon_sym_long] = ACTIONS(4863),
    [anon_sym_short] = ACTIONS(4863),
    [anon_sym_LBRACK] = ACTIONS(2148),
    [anon_sym_static] = ACTIONS(2115),
    [anon_sym_EQ] = ACTIONS(2152),
    [anon_sym_register] = ACTIONS(2115),
    [anon_sym_inline] = ACTIONS(2115),
    [anon_sym___inline] = ACTIONS(2115),
    [anon_sym___inline__] = ACTIONS(2115),
    [anon_sym___forceinline] = ACTIONS(2115),
    [anon_sym_thread_local] = ACTIONS(2115),
    [anon_sym___thread] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(2115),
    [anon_sym_constexpr] = ACTIONS(2115),
    [anon_sym_volatile] = ACTIONS(2115),
    [anon_sym_restrict] = ACTIONS(2115),
    [anon_sym___restrict__] = ACTIONS(2115),
    [anon_sym__Atomic] = ACTIONS(2115),
    [anon_sym__Noreturn] = ACTIONS(2115),
    [anon_sym_noreturn] = ACTIONS(2115),
    [anon_sym_mutable] = ACTIONS(2115),
    [anon_sym_constinit] = ACTIONS(2115),
    [anon_sym_consteval] = ACTIONS(2115),
    [anon_sym_alignas] = ACTIONS(2115),
    [anon_sym__Alignas] = ACTIONS(2115),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2154),
    [anon_sym_SLASH_EQ] = ACTIONS(2154),
    [anon_sym_PERCENT_EQ] = ACTIONS(2154),
    [anon_sym_PLUS_EQ] = ACTIONS(2154),
    [anon_sym_DASH_EQ] = ACTIONS(2154),
    [anon_sym_LT_LT_EQ] = ACTIONS(2154),
    [anon_sym_GT_GT_EQ] = ACTIONS(2154),
    [anon_sym_AMP_EQ] = ACTIONS(2154),
    [anon_sym_CARET_EQ] = ACTIONS(2154),
    [anon_sym_PIPE_EQ] = ACTIONS(2154),
    [anon_sym_and_eq] = ACTIONS(2152),
    [anon_sym_or_eq] = ACTIONS(2152),
    [anon_sym_xor_eq] = ACTIONS(2152),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2128),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2128),
    [anon_sym_not_eq] = ACTIONS(2128),
    [anon_sym_is] = ACTIONS(2128),
    [anon_sym_as] = ACTIONS(2128),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2125),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2115),
    [anon_sym_let] = ACTIONS(2115),
    [anon_sym_This] = ACTIONS(2115),
    [anon_sym_decltype] = ACTIONS(2115),
    [sym_virtual] = ACTIONS(2115),
    [anon_sym_template] = ACTIONS(2115),
    [anon_sym_operator] = ACTIONS(2115),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_precise] = ACTIONS(2115),
    [anon_sym_shared] = ACTIONS(2115),
    [anon_sym_groupshared] = ACTIONS(2115),
    [anon_sym_uniform] = ACTIONS(2115),
    [anon_sym_row_major] = ACTIONS(2115),
    [anon_sym_column_major] = ACTIONS(2115),
    [anon_sym_globallycoherent] = ACTIONS(2115),
    [anon_sym_centroid] = ACTIONS(2115),
    [anon_sym_noperspective] = ACTIONS(2115),
    [anon_sym_nointerpolation] = ACTIONS(2115),
    [anon_sym_sample] = ACTIONS(2115),
    [anon_sym_linear] = ACTIONS(2115),
    [anon_sym_snorm] = ACTIONS(2115),
    [anon_sym_unorm] = ACTIONS(2115),
    [anon_sym_point] = ACTIONS(2115),
    [anon_sym_line] = ACTIONS(2115),
    [anon_sym_triangleadj] = ACTIONS(2115),
    [anon_sym_lineadj] = ACTIONS(2115),
    [anon_sym_triangle] = ACTIONS(2115),
  },
  [1261] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(5614),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_type_descriptor] = STATE(10333),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6821),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4081),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4854),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4856),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1262] = {
    [sym_expression] = STATE(4535),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_initializer_list] = STATE(4641),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4410),
    [anon_sym_COMMA] = ACTIONS(4410),
    [anon_sym_RPAREN] = ACTIONS(4410),
    [anon_sym_LPAREN2] = ACTIONS(4410),
    [anon_sym_BANG] = ACTIONS(2289),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(4408),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_STAR] = ACTIONS(4408),
    [anon_sym_SLASH] = ACTIONS(4408),
    [anon_sym_PERCENT] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4408),
    [anon_sym_GT_EQ] = ACTIONS(4410),
    [anon_sym_LT_EQ] = ACTIONS(4408),
    [anon_sym_LT] = ACTIONS(4408),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACE] = ACTIONS(4867),
    [anon_sym_LBRACK] = ACTIONS(4410),
    [anon_sym_EQ] = ACTIONS(4408),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_QMARK] = ACTIONS(4410),
    [anon_sym_STAR_EQ] = ACTIONS(4410),
    [anon_sym_SLASH_EQ] = ACTIONS(4410),
    [anon_sym_PERCENT_EQ] = ACTIONS(4410),
    [anon_sym_PLUS_EQ] = ACTIONS(4410),
    [anon_sym_DASH_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_GT_EQ] = ACTIONS(4410),
    [anon_sym_AMP_EQ] = ACTIONS(4410),
    [anon_sym_CARET_EQ] = ACTIONS(4410),
    [anon_sym_PIPE_EQ] = ACTIONS(4410),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_LT_EQ_GT] = ACTIONS(4410),
    [anon_sym_or] = ACTIONS(4408),
    [anon_sym_and] = ACTIONS(4408),
    [anon_sym_bitor] = ACTIONS(4408),
    [anon_sym_xor] = ACTIONS(4408),
    [anon_sym_bitand] = ACTIONS(4408),
    [anon_sym_not_eq] = ACTIONS(4408),
    [anon_sym_is] = ACTIONS(4408),
    [anon_sym_as] = ACTIONS(4408),
    [anon_sym_DASH_DASH] = ACTIONS(4410),
    [anon_sym_PLUS_PLUS] = ACTIONS(4410),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [anon_sym_DOT] = ACTIONS(4408),
    [anon_sym_DOT_STAR] = ACTIONS(4410),
    [anon_sym_DASH_GT] = ACTIONS(4408),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4410),
    [sym_this] = ACTIONS(2325),
  },
  [1263] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(5573),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_type_descriptor] = STATE(10668),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6821),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4081),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4854),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4856),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1264] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(5546),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_type_descriptor] = STATE(10776),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6821),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4081),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4854),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4856),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1265] = {
    [sym_type_qualifier] = STATE(4297),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(5755),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_expression] = STATE(5487),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_type_descriptor] = STATE(10867),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_placeholder_type_specifier] = STATE(2888),
    [sym_decltype] = STATE(2860),
    [sym_class_specifier] = STATE(2888),
    [sym__class_name] = STATE(9700),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(6156),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6821),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(6335),
    [sym_user_defined_literal] = STATE(4081),
    [sym_interface_specifier] = STATE(2888),
    [sym_extension_specifier] = STATE(2888),
    [sym_associatedtype_specifier] = STATE(2888),
    [aux_sym__type_definition_type_repeat1] = STATE(4297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(4854),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(2766),
    [anon_sym_unsigned] = ACTIONS(2766),
    [anon_sym_long] = ACTIONS(2766),
    [anon_sym_short] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(4856),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2778),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2802),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_This] = ACTIONS(2802),
    [anon_sym_decltype] = ACTIONS(2804),
    [anon_sym_typename] = ACTIONS(2806),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_extension] = ACTIONS(2822),
  },
  [1266] = {
    [sym_else_clause] = STATE(1330),
    [sym_identifier] = ACTIONS(2836),
    [anon_sym_LPAREN2] = ACTIONS(2838),
    [anon_sym_BANG] = ACTIONS(2838),
    [anon_sym_TILDE] = ACTIONS(2838),
    [anon_sym_DASH] = ACTIONS(2836),
    [anon_sym_PLUS] = ACTIONS(2836),
    [anon_sym_STAR] = ACTIONS(2838),
    [anon_sym_AMP] = ACTIONS(2838),
    [anon_sym_SEMI] = ACTIONS(2838),
    [anon_sym___extension__] = ACTIONS(2836),
    [anon_sym_typedef] = ACTIONS(2836),
    [anon_sym_in] = ACTIONS(2836),
    [anon_sym_out] = ACTIONS(2836),
    [anon_sym_inout] = ACTIONS(2836),
    [anon_sym_extern] = ACTIONS(2836),
    [anon_sym___attribute__] = ACTIONS(2836),
    [anon_sym_COLON_COLON] = ACTIONS(2838),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2838),
    [anon_sym___declspec] = ACTIONS(2836),
    [anon_sym_LBRACE] = ACTIONS(2838),
    [anon_sym_signed] = ACTIONS(2836),
    [anon_sym_unsigned] = ACTIONS(2836),
    [anon_sym_long] = ACTIONS(2836),
    [anon_sym_short] = ACTIONS(2836),
    [anon_sym_LBRACK] = ACTIONS(2836),
    [anon_sym_static] = ACTIONS(2836),
    [anon_sym_register] = ACTIONS(2836),
    [anon_sym_inline] = ACTIONS(2836),
    [anon_sym___inline] = ACTIONS(2836),
    [anon_sym___inline__] = ACTIONS(2836),
    [anon_sym___forceinline] = ACTIONS(2836),
    [anon_sym_thread_local] = ACTIONS(2836),
    [anon_sym___thread] = ACTIONS(2836),
    [anon_sym_const] = ACTIONS(2836),
    [anon_sym_constexpr] = ACTIONS(2836),
    [anon_sym_volatile] = ACTIONS(2836),
    [anon_sym_restrict] = ACTIONS(2836),
    [anon_sym___restrict__] = ACTIONS(2836),
    [anon_sym__Atomic] = ACTIONS(2836),
    [anon_sym__Noreturn] = ACTIONS(2836),
    [anon_sym_noreturn] = ACTIONS(2836),
    [anon_sym_mutable] = ACTIONS(2836),
    [anon_sym_constinit] = ACTIONS(2836),
    [anon_sym_consteval] = ACTIONS(2836),
    [anon_sym_alignas] = ACTIONS(2836),
    [anon_sym__Alignas] = ACTIONS(2836),
    [sym_primitive_type] = ACTIONS(2836),
    [anon_sym_enum] = ACTIONS(2836),
    [anon_sym_class] = ACTIONS(2836),
    [anon_sym_struct] = ACTIONS(2836),
    [anon_sym_union] = ACTIONS(2836),
    [anon_sym_if] = ACTIONS(2836),
    [anon_sym_else] = ACTIONS(4871),
    [anon_sym_switch] = ACTIONS(2836),
    [anon_sym_while] = ACTIONS(2836),
    [anon_sym_do] = ACTIONS(2836),
    [anon_sym_for] = ACTIONS(2836),
    [anon_sym_return] = ACTIONS(2836),
    [anon_sym_break] = ACTIONS(2836),
    [anon_sym_continue] = ACTIONS(2836),
    [anon_sym_goto] = ACTIONS(2836),
    [anon_sym___try] = ACTIONS(2836),
    [anon_sym___leave] = ACTIONS(2836),
    [anon_sym_not] = ACTIONS(2836),
    [anon_sym_compl] = ACTIONS(2836),
    [anon_sym_DASH_DASH] = ACTIONS(2838),
    [anon_sym_PLUS_PLUS] = ACTIONS(2838),
    [anon_sym_sizeof] = ACTIONS(2836),
    [anon_sym___alignof__] = ACTIONS(2836),
    [anon_sym___alignof] = ACTIONS(2836),
    [anon_sym__alignof] = ACTIONS(2836),
    [anon_sym_alignof] = ACTIONS(2836),
    [anon_sym__Alignof] = ACTIONS(2836),
    [anon_sym_offsetof] = ACTIONS(2836),
    [anon_sym__Generic] = ACTIONS(2836),
    [anon_sym_asm] = ACTIONS(2836),
    [anon_sym___asm__] = ACTIONS(2836),
    [sym_number_literal] = ACTIONS(2838),
    [anon_sym_L_SQUOTE] = ACTIONS(2838),
    [anon_sym_u_SQUOTE] = ACTIONS(2838),
    [anon_sym_U_SQUOTE] = ACTIONS(2838),
    [anon_sym_u8_SQUOTE] = ACTIONS(2838),
    [anon_sym_SQUOTE] = ACTIONS(2838),
    [anon_sym_L_DQUOTE] = ACTIONS(2838),
    [anon_sym_u_DQUOTE] = ACTIONS(2838),
    [anon_sym_U_DQUOTE] = ACTIONS(2838),
    [anon_sym_u8_DQUOTE] = ACTIONS(2838),
    [anon_sym_DQUOTE] = ACTIONS(2838),
    [sym_true] = ACTIONS(2836),
    [sym_false] = ACTIONS(2836),
    [anon_sym_NULL] = ACTIONS(2836),
    [anon_sym_nullptr] = ACTIONS(2836),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2836),
    [anon_sym_let] = ACTIONS(2836),
    [anon_sym_This] = ACTIONS(2836),
    [anon_sym_decltype] = ACTIONS(2836),
    [sym_virtual] = ACTIONS(2836),
    [anon_sym_typename] = ACTIONS(2836),
    [anon_sym_template] = ACTIONS(2836),
    [anon_sym_try] = ACTIONS(2836),
    [anon_sym_delete] = ACTIONS(2836),
    [anon_sym_throw] = ACTIONS(2836),
    [anon_sym_co_return] = ACTIONS(2836),
    [anon_sym_co_yield] = ACTIONS(2836),
    [anon_sym_R_DQUOTE] = ACTIONS(2838),
    [anon_sym_LR_DQUOTE] = ACTIONS(2838),
    [anon_sym_uR_DQUOTE] = ACTIONS(2838),
    [anon_sym_UR_DQUOTE] = ACTIONS(2838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2838),
    [anon_sym_co_await] = ACTIONS(2836),
    [anon_sym_new] = ACTIONS(2836),
    [anon_sym_requires] = ACTIONS(2836),
    [sym_this] = ACTIONS(2836),
    [anon_sym_discard] = ACTIONS(2836),
    [anon_sym_precise] = ACTIONS(2836),
    [anon_sym_shared] = ACTIONS(2836),
    [anon_sym_groupshared] = ACTIONS(2836),
    [anon_sym_uniform] = ACTIONS(2836),
    [anon_sym_row_major] = ACTIONS(2836),
    [anon_sym_column_major] = ACTIONS(2836),
    [anon_sym_globallycoherent] = ACTIONS(2836),
    [anon_sym_centroid] = ACTIONS(2836),
    [anon_sym_noperspective] = ACTIONS(2836),
    [anon_sym_nointerpolation] = ACTIONS(2836),
    [anon_sym_sample] = ACTIONS(2836),
    [anon_sym_linear] = ACTIONS(2836),
    [anon_sym_snorm] = ACTIONS(2836),
    [anon_sym_unorm] = ACTIONS(2836),
    [anon_sym_point] = ACTIONS(2836),
    [anon_sym_line] = ACTIONS(2836),
    [anon_sym_triangleadj] = ACTIONS(2836),
    [anon_sym_lineadj] = ACTIONS(2836),
    [anon_sym_triangle] = ACTIONS(2836),
    [anon_sym_cbuffer] = ACTIONS(2836),
    [anon_sym_interface] = ACTIONS(2836),
    [anon_sym_extension] = ACTIONS(2836),
  },
  [1267] = {
    [sym_identifier] = ACTIONS(2355),
    [anon_sym_LPAREN2] = ACTIONS(2353),
    [anon_sym_BANG] = ACTIONS(2353),
    [anon_sym_TILDE] = ACTIONS(2353),
    [anon_sym_DASH] = ACTIONS(2355),
    [anon_sym_PLUS] = ACTIONS(2355),
    [anon_sym_STAR] = ACTIONS(2353),
    [anon_sym_AMP] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym___extension__] = ACTIONS(2355),
    [anon_sym_typedef] = ACTIONS(2355),
    [anon_sym_in] = ACTIONS(2355),
    [anon_sym_out] = ACTIONS(2355),
    [anon_sym_inout] = ACTIONS(2355),
    [anon_sym_extern] = ACTIONS(2355),
    [anon_sym___attribute__] = ACTIONS(2355),
    [anon_sym_COLON_COLON] = ACTIONS(2353),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2353),
    [anon_sym___declspec] = ACTIONS(2355),
    [anon_sym_LBRACE] = ACTIONS(2353),
    [anon_sym_signed] = ACTIONS(2355),
    [anon_sym_unsigned] = ACTIONS(2355),
    [anon_sym_long] = ACTIONS(2355),
    [anon_sym_short] = ACTIONS(2355),
    [anon_sym_LBRACK] = ACTIONS(2355),
    [anon_sym_static] = ACTIONS(2355),
    [anon_sym_register] = ACTIONS(2355),
    [anon_sym_inline] = ACTIONS(2355),
    [anon_sym___inline] = ACTIONS(2355),
    [anon_sym___inline__] = ACTIONS(2355),
    [anon_sym___forceinline] = ACTIONS(2355),
    [anon_sym_thread_local] = ACTIONS(2355),
    [anon_sym___thread] = ACTIONS(2355),
    [anon_sym_const] = ACTIONS(2355),
    [anon_sym_constexpr] = ACTIONS(2355),
    [anon_sym_volatile] = ACTIONS(2355),
    [anon_sym_restrict] = ACTIONS(2355),
    [anon_sym___restrict__] = ACTIONS(2355),
    [anon_sym__Atomic] = ACTIONS(2355),
    [anon_sym__Noreturn] = ACTIONS(2355),
    [anon_sym_noreturn] = ACTIONS(2355),
    [anon_sym_mutable] = ACTIONS(2355),
    [anon_sym_constinit] = ACTIONS(2355),
    [anon_sym_consteval] = ACTIONS(2355),
    [anon_sym_alignas] = ACTIONS(2355),
    [anon_sym__Alignas] = ACTIONS(2355),
    [sym_primitive_type] = ACTIONS(2355),
    [anon_sym_enum] = ACTIONS(2355),
    [anon_sym_class] = ACTIONS(2355),
    [anon_sym_struct] = ACTIONS(2355),
    [anon_sym_union] = ACTIONS(2355),
    [anon_sym_if] = ACTIONS(2355),
    [anon_sym_else] = ACTIONS(2355),
    [anon_sym_switch] = ACTIONS(2355),
    [anon_sym_while] = ACTIONS(2355),
    [anon_sym_do] = ACTIONS(2355),
    [anon_sym_for] = ACTIONS(2355),
    [anon_sym_return] = ACTIONS(2355),
    [anon_sym_break] = ACTIONS(2355),
    [anon_sym_continue] = ACTIONS(2355),
    [anon_sym_goto] = ACTIONS(2355),
    [anon_sym___try] = ACTIONS(2355),
    [anon_sym___leave] = ACTIONS(2355),
    [anon_sym_not] = ACTIONS(2355),
    [anon_sym_compl] = ACTIONS(2355),
    [anon_sym_DASH_DASH] = ACTIONS(2353),
    [anon_sym_PLUS_PLUS] = ACTIONS(2353),
    [anon_sym_sizeof] = ACTIONS(2355),
    [anon_sym___alignof__] = ACTIONS(2355),
    [anon_sym___alignof] = ACTIONS(2355),
    [anon_sym__alignof] = ACTIONS(2355),
    [anon_sym_alignof] = ACTIONS(2355),
    [anon_sym__Alignof] = ACTIONS(2355),
    [anon_sym_offsetof] = ACTIONS(2355),
    [anon_sym__Generic] = ACTIONS(2355),
    [anon_sym_asm] = ACTIONS(2355),
    [anon_sym___asm__] = ACTIONS(2355),
    [sym_number_literal] = ACTIONS(2353),
    [anon_sym_L_SQUOTE] = ACTIONS(2353),
    [anon_sym_u_SQUOTE] = ACTIONS(2353),
    [anon_sym_U_SQUOTE] = ACTIONS(2353),
    [anon_sym_u8_SQUOTE] = ACTIONS(2353),
    [anon_sym_SQUOTE] = ACTIONS(2353),
    [anon_sym_L_DQUOTE] = ACTIONS(2353),
    [anon_sym_u_DQUOTE] = ACTIONS(2353),
    [anon_sym_U_DQUOTE] = ACTIONS(2353),
    [anon_sym_u8_DQUOTE] = ACTIONS(2353),
    [anon_sym_DQUOTE] = ACTIONS(2353),
    [sym_true] = ACTIONS(2355),
    [sym_false] = ACTIONS(2355),
    [anon_sym_NULL] = ACTIONS(2355),
    [anon_sym_nullptr] = ACTIONS(2355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2355),
    [anon_sym_let] = ACTIONS(2355),
    [anon_sym_This] = ACTIONS(2355),
    [anon_sym_decltype] = ACTIONS(2355),
    [sym_virtual] = ACTIONS(2355),
    [anon_sym_typename] = ACTIONS(2355),
    [anon_sym_template] = ACTIONS(2355),
    [anon_sym_try] = ACTIONS(2355),
    [anon_sym_delete] = ACTIONS(2355),
    [anon_sym_throw] = ACTIONS(2355),
    [anon_sym_co_return] = ACTIONS(2355),
    [anon_sym_co_yield] = ACTIONS(2355),
    [anon_sym_catch] = ACTIONS(2355),
    [anon_sym_R_DQUOTE] = ACTIONS(2353),
    [anon_sym_LR_DQUOTE] = ACTIONS(2353),
    [anon_sym_uR_DQUOTE] = ACTIONS(2353),
    [anon_sym_UR_DQUOTE] = ACTIONS(2353),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2353),
    [anon_sym_co_await] = ACTIONS(2355),
    [anon_sym_new] = ACTIONS(2355),
    [anon_sym_requires] = ACTIONS(2355),
    [sym_this] = ACTIONS(2355),
    [anon_sym_discard] = ACTIONS(2355),
    [anon_sym_precise] = ACTIONS(2355),
    [anon_sym_shared] = ACTIONS(2355),
    [anon_sym_groupshared] = ACTIONS(2355),
    [anon_sym_uniform] = ACTIONS(2355),
    [anon_sym_row_major] = ACTIONS(2355),
    [anon_sym_column_major] = ACTIONS(2355),
    [anon_sym_globallycoherent] = ACTIONS(2355),
    [anon_sym_centroid] = ACTIONS(2355),
    [anon_sym_noperspective] = ACTIONS(2355),
    [anon_sym_nointerpolation] = ACTIONS(2355),
    [anon_sym_sample] = ACTIONS(2355),
    [anon_sym_linear] = ACTIONS(2355),
    [anon_sym_snorm] = ACTIONS(2355),
    [anon_sym_unorm] = ACTIONS(2355),
    [anon_sym_point] = ACTIONS(2355),
    [anon_sym_line] = ACTIONS(2355),
    [anon_sym_triangleadj] = ACTIONS(2355),
    [anon_sym_lineadj] = ACTIONS(2355),
    [anon_sym_triangle] = ACTIONS(2355),
    [anon_sym_cbuffer] = ACTIONS(2355),
    [anon_sym_interface] = ACTIONS(2355),
    [anon_sym_extension] = ACTIONS(2355),
  },
  [1268] = {
    [sym_identifier] = ACTIONS(2842),
    [anon_sym_LPAREN2] = ACTIONS(2844),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_TILDE] = ACTIONS(2844),
    [anon_sym_DASH] = ACTIONS(2842),
    [anon_sym_PLUS] = ACTIONS(2842),
    [anon_sym_STAR] = ACTIONS(2844),
    [anon_sym_AMP] = ACTIONS(2844),
    [anon_sym_SEMI] = ACTIONS(2844),
    [anon_sym___extension__] = ACTIONS(2842),
    [anon_sym_typedef] = ACTIONS(2842),
    [anon_sym_in] = ACTIONS(2842),
    [anon_sym_out] = ACTIONS(2842),
    [anon_sym_inout] = ACTIONS(2842),
    [anon_sym_extern] = ACTIONS(2842),
    [anon_sym___attribute__] = ACTIONS(2842),
    [anon_sym_COLON_COLON] = ACTIONS(2844),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2844),
    [anon_sym___declspec] = ACTIONS(2842),
    [anon_sym_LBRACE] = ACTIONS(2844),
    [anon_sym_signed] = ACTIONS(2842),
    [anon_sym_unsigned] = ACTIONS(2842),
    [anon_sym_long] = ACTIONS(2842),
    [anon_sym_short] = ACTIONS(2842),
    [anon_sym_LBRACK] = ACTIONS(2842),
    [anon_sym_static] = ACTIONS(2842),
    [anon_sym_register] = ACTIONS(2842),
    [anon_sym_inline] = ACTIONS(2842),
    [anon_sym___inline] = ACTIONS(2842),
    [anon_sym___inline__] = ACTIONS(2842),
    [anon_sym___forceinline] = ACTIONS(2842),
    [anon_sym_thread_local] = ACTIONS(2842),
    [anon_sym___thread] = ACTIONS(2842),
    [anon_sym_const] = ACTIONS(2842),
    [anon_sym_constexpr] = ACTIONS(2842),
    [anon_sym_volatile] = ACTIONS(2842),
    [anon_sym_restrict] = ACTIONS(2842),
    [anon_sym___restrict__] = ACTIONS(2842),
    [anon_sym__Atomic] = ACTIONS(2842),
    [anon_sym__Noreturn] = ACTIONS(2842),
    [anon_sym_noreturn] = ACTIONS(2842),
    [anon_sym_mutable] = ACTIONS(2842),
    [anon_sym_constinit] = ACTIONS(2842),
    [anon_sym_consteval] = ACTIONS(2842),
    [anon_sym_alignas] = ACTIONS(2842),
    [anon_sym__Alignas] = ACTIONS(2842),
    [sym_primitive_type] = ACTIONS(2842),
    [anon_sym_enum] = ACTIONS(2842),
    [anon_sym_class] = ACTIONS(2842),
    [anon_sym_struct] = ACTIONS(2842),
    [anon_sym_union] = ACTIONS(2842),
    [anon_sym_if] = ACTIONS(2842),
    [anon_sym_else] = ACTIONS(2842),
    [anon_sym_switch] = ACTIONS(2842),
    [anon_sym_while] = ACTIONS(2842),
    [anon_sym_do] = ACTIONS(2842),
    [anon_sym_for] = ACTIONS(2842),
    [anon_sym_return] = ACTIONS(2842),
    [anon_sym_break] = ACTIONS(2842),
    [anon_sym_continue] = ACTIONS(2842),
    [anon_sym_goto] = ACTIONS(2842),
    [anon_sym___try] = ACTIONS(2842),
    [anon_sym___leave] = ACTIONS(2842),
    [anon_sym_not] = ACTIONS(2842),
    [anon_sym_compl] = ACTIONS(2842),
    [anon_sym_DASH_DASH] = ACTIONS(2844),
    [anon_sym_PLUS_PLUS] = ACTIONS(2844),
    [anon_sym_sizeof] = ACTIONS(2842),
    [anon_sym___alignof__] = ACTIONS(2842),
    [anon_sym___alignof] = ACTIONS(2842),
    [anon_sym__alignof] = ACTIONS(2842),
    [anon_sym_alignof] = ACTIONS(2842),
    [anon_sym__Alignof] = ACTIONS(2842),
    [anon_sym_offsetof] = ACTIONS(2842),
    [anon_sym__Generic] = ACTIONS(2842),
    [anon_sym_asm] = ACTIONS(2842),
    [anon_sym___asm__] = ACTIONS(2842),
    [sym_number_literal] = ACTIONS(2844),
    [anon_sym_L_SQUOTE] = ACTIONS(2844),
    [anon_sym_u_SQUOTE] = ACTIONS(2844),
    [anon_sym_U_SQUOTE] = ACTIONS(2844),
    [anon_sym_u8_SQUOTE] = ACTIONS(2844),
    [anon_sym_SQUOTE] = ACTIONS(2844),
    [anon_sym_L_DQUOTE] = ACTIONS(2844),
    [anon_sym_u_DQUOTE] = ACTIONS(2844),
    [anon_sym_U_DQUOTE] = ACTIONS(2844),
    [anon_sym_u8_DQUOTE] = ACTIONS(2844),
    [anon_sym_DQUOTE] = ACTIONS(2844),
    [sym_true] = ACTIONS(2842),
    [sym_false] = ACTIONS(2842),
    [anon_sym_NULL] = ACTIONS(2842),
    [anon_sym_nullptr] = ACTIONS(2842),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2842),
    [anon_sym_let] = ACTIONS(2842),
    [anon_sym_This] = ACTIONS(2842),
    [anon_sym_decltype] = ACTIONS(2842),
    [sym_virtual] = ACTIONS(2842),
    [anon_sym_typename] = ACTIONS(2842),
    [anon_sym_template] = ACTIONS(2842),
    [anon_sym_try] = ACTIONS(2842),
    [anon_sym_delete] = ACTIONS(2842),
    [anon_sym_throw] = ACTIONS(2842),
    [anon_sym_co_return] = ACTIONS(2842),
    [anon_sym_co_yield] = ACTIONS(2842),
    [anon_sym_catch] = ACTIONS(2842),
    [anon_sym_R_DQUOTE] = ACTIONS(2844),
    [anon_sym_LR_DQUOTE] = ACTIONS(2844),
    [anon_sym_uR_DQUOTE] = ACTIONS(2844),
    [anon_sym_UR_DQUOTE] = ACTIONS(2844),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2844),
    [anon_sym_co_await] = ACTIONS(2842),
    [anon_sym_new] = ACTIONS(2842),
    [anon_sym_requires] = ACTIONS(2842),
    [sym_this] = ACTIONS(2842),
    [anon_sym_discard] = ACTIONS(2842),
    [anon_sym_precise] = ACTIONS(2842),
    [anon_sym_shared] = ACTIONS(2842),
    [anon_sym_groupshared] = ACTIONS(2842),
    [anon_sym_uniform] = ACTIONS(2842),
    [anon_sym_row_major] = ACTIONS(2842),
    [anon_sym_column_major] = ACTIONS(2842),
    [anon_sym_globallycoherent] = ACTIONS(2842),
    [anon_sym_centroid] = ACTIONS(2842),
    [anon_sym_noperspective] = ACTIONS(2842),
    [anon_sym_nointerpolation] = ACTIONS(2842),
    [anon_sym_sample] = ACTIONS(2842),
    [anon_sym_linear] = ACTIONS(2842),
    [anon_sym_snorm] = ACTIONS(2842),
    [anon_sym_unorm] = ACTIONS(2842),
    [anon_sym_point] = ACTIONS(2842),
    [anon_sym_line] = ACTIONS(2842),
    [anon_sym_triangleadj] = ACTIONS(2842),
    [anon_sym_lineadj] = ACTIONS(2842),
    [anon_sym_triangle] = ACTIONS(2842),
    [anon_sym_cbuffer] = ACTIONS(2842),
    [anon_sym_interface] = ACTIONS(2842),
    [anon_sym_extension] = ACTIONS(2842),
  },
  [1269] = {
    [sym_identifier] = ACTIONS(2359),
    [anon_sym_LPAREN2] = ACTIONS(2357),
    [anon_sym_BANG] = ACTIONS(2357),
    [anon_sym_TILDE] = ACTIONS(2357),
    [anon_sym_DASH] = ACTIONS(2359),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_STAR] = ACTIONS(2357),
    [anon_sym_AMP] = ACTIONS(2357),
    [anon_sym_SEMI] = ACTIONS(2357),
    [anon_sym___extension__] = ACTIONS(2359),
    [anon_sym_typedef] = ACTIONS(2359),
    [anon_sym_in] = ACTIONS(2359),
    [anon_sym_out] = ACTIONS(2359),
    [anon_sym_inout] = ACTIONS(2359),
    [anon_sym_extern] = ACTIONS(2359),
    [anon_sym___attribute__] = ACTIONS(2359),
    [anon_sym_COLON_COLON] = ACTIONS(2357),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2357),
    [anon_sym___declspec] = ACTIONS(2359),
    [anon_sym_LBRACE] = ACTIONS(2357),
    [anon_sym_signed] = ACTIONS(2359),
    [anon_sym_unsigned] = ACTIONS(2359),
    [anon_sym_long] = ACTIONS(2359),
    [anon_sym_short] = ACTIONS(2359),
    [anon_sym_LBRACK] = ACTIONS(2359),
    [anon_sym_static] = ACTIONS(2359),
    [anon_sym_register] = ACTIONS(2359),
    [anon_sym_inline] = ACTIONS(2359),
    [anon_sym___inline] = ACTIONS(2359),
    [anon_sym___inline__] = ACTIONS(2359),
    [anon_sym___forceinline] = ACTIONS(2359),
    [anon_sym_thread_local] = ACTIONS(2359),
    [anon_sym___thread] = ACTIONS(2359),
    [anon_sym_const] = ACTIONS(2359),
    [anon_sym_constexpr] = ACTIONS(2359),
    [anon_sym_volatile] = ACTIONS(2359),
    [anon_sym_restrict] = ACTIONS(2359),
    [anon_sym___restrict__] = ACTIONS(2359),
    [anon_sym__Atomic] = ACTIONS(2359),
    [anon_sym__Noreturn] = ACTIONS(2359),
    [anon_sym_noreturn] = ACTIONS(2359),
    [anon_sym_mutable] = ACTIONS(2359),
    [anon_sym_constinit] = ACTIONS(2359),
    [anon_sym_consteval] = ACTIONS(2359),
    [anon_sym_alignas] = ACTIONS(2359),
    [anon_sym__Alignas] = ACTIONS(2359),
    [sym_primitive_type] = ACTIONS(2359),
    [anon_sym_enum] = ACTIONS(2359),
    [anon_sym_class] = ACTIONS(2359),
    [anon_sym_struct] = ACTIONS(2359),
    [anon_sym_union] = ACTIONS(2359),
    [anon_sym_if] = ACTIONS(2359),
    [anon_sym_else] = ACTIONS(2359),
    [anon_sym_switch] = ACTIONS(2359),
    [anon_sym_while] = ACTIONS(2359),
    [anon_sym_do] = ACTIONS(2359),
    [anon_sym_for] = ACTIONS(2359),
    [anon_sym_return] = ACTIONS(2359),
    [anon_sym_break] = ACTIONS(2359),
    [anon_sym_continue] = ACTIONS(2359),
    [anon_sym_goto] = ACTIONS(2359),
    [anon_sym___try] = ACTIONS(2359),
    [anon_sym___leave] = ACTIONS(2359),
    [anon_sym_not] = ACTIONS(2359),
    [anon_sym_compl] = ACTIONS(2359),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
    [anon_sym_sizeof] = ACTIONS(2359),
    [anon_sym___alignof__] = ACTIONS(2359),
    [anon_sym___alignof] = ACTIONS(2359),
    [anon_sym__alignof] = ACTIONS(2359),
    [anon_sym_alignof] = ACTIONS(2359),
    [anon_sym__Alignof] = ACTIONS(2359),
    [anon_sym_offsetof] = ACTIONS(2359),
    [anon_sym__Generic] = ACTIONS(2359),
    [anon_sym_asm] = ACTIONS(2359),
    [anon_sym___asm__] = ACTIONS(2359),
    [sym_number_literal] = ACTIONS(2357),
    [anon_sym_L_SQUOTE] = ACTIONS(2357),
    [anon_sym_u_SQUOTE] = ACTIONS(2357),
    [anon_sym_U_SQUOTE] = ACTIONS(2357),
    [anon_sym_u8_SQUOTE] = ACTIONS(2357),
    [anon_sym_SQUOTE] = ACTIONS(2357),
    [anon_sym_L_DQUOTE] = ACTIONS(2357),
    [anon_sym_u_DQUOTE] = ACTIONS(2357),
    [anon_sym_U_DQUOTE] = ACTIONS(2357),
    [anon_sym_u8_DQUOTE] = ACTIONS(2357),
    [anon_sym_DQUOTE] = ACTIONS(2357),
    [sym_true] = ACTIONS(2359),
    [sym_false] = ACTIONS(2359),
    [anon_sym_NULL] = ACTIONS(2359),
    [anon_sym_nullptr] = ACTIONS(2359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2359),
    [anon_sym_let] = ACTIONS(2359),
    [anon_sym_This] = ACTIONS(2359),
    [anon_sym_decltype] = ACTIONS(2359),
    [sym_virtual] = ACTIONS(2359),
    [anon_sym_typename] = ACTIONS(2359),
    [anon_sym_template] = ACTIONS(2359),
    [anon_sym_try] = ACTIONS(2359),
    [anon_sym_delete] = ACTIONS(2359),
    [anon_sym_throw] = ACTIONS(2359),
    [anon_sym_co_return] = ACTIONS(2359),
    [anon_sym_co_yield] = ACTIONS(2359),
    [anon_sym_catch] = ACTIONS(2359),
    [anon_sym_R_DQUOTE] = ACTIONS(2357),
    [anon_sym_LR_DQUOTE] = ACTIONS(2357),
    [anon_sym_uR_DQUOTE] = ACTIONS(2357),
    [anon_sym_UR_DQUOTE] = ACTIONS(2357),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2357),
    [anon_sym_co_await] = ACTIONS(2359),
    [anon_sym_new] = ACTIONS(2359),
    [anon_sym_requires] = ACTIONS(2359),
    [sym_this] = ACTIONS(2359),
    [anon_sym_discard] = ACTIONS(2359),
    [anon_sym_precise] = ACTIONS(2359),
    [anon_sym_shared] = ACTIONS(2359),
    [anon_sym_groupshared] = ACTIONS(2359),
    [anon_sym_uniform] = ACTIONS(2359),
    [anon_sym_row_major] = ACTIONS(2359),
    [anon_sym_column_major] = ACTIONS(2359),
    [anon_sym_globallycoherent] = ACTIONS(2359),
    [anon_sym_centroid] = ACTIONS(2359),
    [anon_sym_noperspective] = ACTIONS(2359),
    [anon_sym_nointerpolation] = ACTIONS(2359),
    [anon_sym_sample] = ACTIONS(2359),
    [anon_sym_linear] = ACTIONS(2359),
    [anon_sym_snorm] = ACTIONS(2359),
    [anon_sym_unorm] = ACTIONS(2359),
    [anon_sym_point] = ACTIONS(2359),
    [anon_sym_line] = ACTIONS(2359),
    [anon_sym_triangleadj] = ACTIONS(2359),
    [anon_sym_lineadj] = ACTIONS(2359),
    [anon_sym_triangle] = ACTIONS(2359),
    [anon_sym_cbuffer] = ACTIONS(2359),
    [anon_sym_interface] = ACTIONS(2359),
    [anon_sym_extension] = ACTIONS(2359),
  },
  [1270] = {
    [sym_string_literal] = STATE(3342),
    [sym_template_argument_list] = STATE(1461),
    [sym_raw_string_literal] = STATE(3342),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2639),
    [sym_identifier] = ACTIONS(2115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2130),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(4858),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON] = ACTIONS(4873),
    [anon_sym_SEMI] = ACTIONS(2130),
    [anon_sym___extension__] = ACTIONS(2115),
    [anon_sym_in] = ACTIONS(2115),
    [anon_sym_out] = ACTIONS(2115),
    [anon_sym_inout] = ACTIONS(2115),
    [anon_sym_extern] = ACTIONS(2115),
    [anon_sym___attribute__] = ACTIONS(2115),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2140),
    [anon_sym___declspec] = ACTIONS(2115),
    [anon_sym___based] = ACTIONS(2115),
    [anon_sym___cdecl] = ACTIONS(2115),
    [anon_sym___clrcall] = ACTIONS(2115),
    [anon_sym___stdcall] = ACTIONS(2115),
    [anon_sym___fastcall] = ACTIONS(2115),
    [anon_sym___thiscall] = ACTIONS(2115),
    [anon_sym___vectorcall] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_signed] = ACTIONS(4863),
    [anon_sym_unsigned] = ACTIONS(4863),
    [anon_sym_long] = ACTIONS(4863),
    [anon_sym_short] = ACTIONS(4863),
    [anon_sym_LBRACK] = ACTIONS(2148),
    [anon_sym_static] = ACTIONS(2115),
    [anon_sym_EQ] = ACTIONS(2152),
    [anon_sym_register] = ACTIONS(2115),
    [anon_sym_inline] = ACTIONS(2115),
    [anon_sym___inline] = ACTIONS(2115),
    [anon_sym___inline__] = ACTIONS(2115),
    [anon_sym___forceinline] = ACTIONS(2115),
    [anon_sym_thread_local] = ACTIONS(2115),
    [anon_sym___thread] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(2115),
    [anon_sym_constexpr] = ACTIONS(2115),
    [anon_sym_volatile] = ACTIONS(2115),
    [anon_sym_restrict] = ACTIONS(2115),
    [anon_sym___restrict__] = ACTIONS(2115),
    [anon_sym__Atomic] = ACTIONS(2115),
    [anon_sym__Noreturn] = ACTIONS(2115),
    [anon_sym_noreturn] = ACTIONS(2115),
    [anon_sym_mutable] = ACTIONS(2115),
    [anon_sym_constinit] = ACTIONS(2115),
    [anon_sym_consteval] = ACTIONS(2115),
    [anon_sym_alignas] = ACTIONS(2115),
    [anon_sym__Alignas] = ACTIONS(2115),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2154),
    [anon_sym_SLASH_EQ] = ACTIONS(2154),
    [anon_sym_PERCENT_EQ] = ACTIONS(2154),
    [anon_sym_PLUS_EQ] = ACTIONS(2154),
    [anon_sym_DASH_EQ] = ACTIONS(2154),
    [anon_sym_LT_LT_EQ] = ACTIONS(2154),
    [anon_sym_GT_GT_EQ] = ACTIONS(2154),
    [anon_sym_AMP_EQ] = ACTIONS(2154),
    [anon_sym_CARET_EQ] = ACTIONS(2154),
    [anon_sym_PIPE_EQ] = ACTIONS(2154),
    [anon_sym_and_eq] = ACTIONS(2152),
    [anon_sym_or_eq] = ACTIONS(2152),
    [anon_sym_xor_eq] = ACTIONS(2152),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2128),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2128),
    [anon_sym_not_eq] = ACTIONS(2128),
    [anon_sym_is] = ACTIONS(2128),
    [anon_sym_as] = ACTIONS(2128),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2125),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2115),
    [anon_sym_let] = ACTIONS(2115),
    [anon_sym_This] = ACTIONS(2115),
    [anon_sym_decltype] = ACTIONS(2115),
    [sym_virtual] = ACTIONS(2115),
    [anon_sym_template] = ACTIONS(2115),
    [anon_sym_operator] = ACTIONS(2115),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_precise] = ACTIONS(2115),
    [anon_sym_shared] = ACTIONS(2115),
    [anon_sym_groupshared] = ACTIONS(2115),
    [anon_sym_uniform] = ACTIONS(2115),
    [anon_sym_row_major] = ACTIONS(2115),
    [anon_sym_column_major] = ACTIONS(2115),
    [anon_sym_globallycoherent] = ACTIONS(2115),
    [anon_sym_centroid] = ACTIONS(2115),
    [anon_sym_noperspective] = ACTIONS(2115),
    [anon_sym_nointerpolation] = ACTIONS(2115),
    [anon_sym_sample] = ACTIONS(2115),
    [anon_sym_linear] = ACTIONS(2115),
    [anon_sym_snorm] = ACTIONS(2115),
    [anon_sym_unorm] = ACTIONS(2115),
    [anon_sym_point] = ACTIONS(2115),
    [anon_sym_line] = ACTIONS(2115),
    [anon_sym_triangleadj] = ACTIONS(2115),
    [anon_sym_lineadj] = ACTIONS(2115),
    [anon_sym_triangle] = ACTIONS(2115),
  },
  [1271] = {
    [sym_string_literal] = STATE(3342),
    [sym_template_argument_list] = STATE(1461),
    [sym_raw_string_literal] = STATE(3342),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2639),
    [sym_identifier] = ACTIONS(2115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2130),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(4858),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON] = ACTIONS(2136),
    [anon_sym_SEMI] = ACTIONS(2130),
    [anon_sym___extension__] = ACTIONS(2115),
    [anon_sym_in] = ACTIONS(2115),
    [anon_sym_out] = ACTIONS(2115),
    [anon_sym_inout] = ACTIONS(2115),
    [anon_sym_extern] = ACTIONS(2115),
    [anon_sym___attribute__] = ACTIONS(2115),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2140),
    [anon_sym___declspec] = ACTIONS(2115),
    [anon_sym___based] = ACTIONS(2115),
    [anon_sym___cdecl] = ACTIONS(2115),
    [anon_sym___clrcall] = ACTIONS(2115),
    [anon_sym___stdcall] = ACTIONS(2115),
    [anon_sym___fastcall] = ACTIONS(2115),
    [anon_sym___thiscall] = ACTIONS(2115),
    [anon_sym___vectorcall] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_signed] = ACTIONS(4863),
    [anon_sym_unsigned] = ACTIONS(4863),
    [anon_sym_long] = ACTIONS(4863),
    [anon_sym_short] = ACTIONS(4863),
    [anon_sym_LBRACK] = ACTIONS(2148),
    [anon_sym_static] = ACTIONS(2115),
    [anon_sym_EQ] = ACTIONS(2152),
    [anon_sym_register] = ACTIONS(2115),
    [anon_sym_inline] = ACTIONS(2115),
    [anon_sym___inline] = ACTIONS(2115),
    [anon_sym___inline__] = ACTIONS(2115),
    [anon_sym___forceinline] = ACTIONS(2115),
    [anon_sym_thread_local] = ACTIONS(2115),
    [anon_sym___thread] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(2115),
    [anon_sym_constexpr] = ACTIONS(2115),
    [anon_sym_volatile] = ACTIONS(2115),
    [anon_sym_restrict] = ACTIONS(2115),
    [anon_sym___restrict__] = ACTIONS(2115),
    [anon_sym__Atomic] = ACTIONS(2115),
    [anon_sym__Noreturn] = ACTIONS(2115),
    [anon_sym_noreturn] = ACTIONS(2115),
    [anon_sym_mutable] = ACTIONS(2115),
    [anon_sym_constinit] = ACTIONS(2115),
    [anon_sym_consteval] = ACTIONS(2115),
    [anon_sym_alignas] = ACTIONS(2115),
    [anon_sym__Alignas] = ACTIONS(2115),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2154),
    [anon_sym_SLASH_EQ] = ACTIONS(2154),
    [anon_sym_PERCENT_EQ] = ACTIONS(2154),
    [anon_sym_PLUS_EQ] = ACTIONS(2154),
    [anon_sym_DASH_EQ] = ACTIONS(2154),
    [anon_sym_LT_LT_EQ] = ACTIONS(2154),
    [anon_sym_GT_GT_EQ] = ACTIONS(2154),
    [anon_sym_AMP_EQ] = ACTIONS(2154),
    [anon_sym_CARET_EQ] = ACTIONS(2154),
    [anon_sym_PIPE_EQ] = ACTIONS(2154),
    [anon_sym_and_eq] = ACTIONS(2152),
    [anon_sym_or_eq] = ACTIONS(2152),
    [anon_sym_xor_eq] = ACTIONS(2152),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2128),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2128),
    [anon_sym_not_eq] = ACTIONS(2128),
    [anon_sym_is] = ACTIONS(2128),
    [anon_sym_as] = ACTIONS(2128),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2125),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2115),
    [anon_sym_let] = ACTIONS(2115),
    [anon_sym_This] = ACTIONS(2115),
    [anon_sym_decltype] = ACTIONS(2115),
    [sym_virtual] = ACTIONS(2115),
    [anon_sym_template] = ACTIONS(2115),
    [anon_sym_operator] = ACTIONS(2115),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_precise] = ACTIONS(2115),
    [anon_sym_shared] = ACTIONS(2115),
    [anon_sym_groupshared] = ACTIONS(2115),
    [anon_sym_uniform] = ACTIONS(2115),
    [anon_sym_row_major] = ACTIONS(2115),
    [anon_sym_column_major] = ACTIONS(2115),
    [anon_sym_globallycoherent] = ACTIONS(2115),
    [anon_sym_centroid] = ACTIONS(2115),
    [anon_sym_noperspective] = ACTIONS(2115),
    [anon_sym_nointerpolation] = ACTIONS(2115),
    [anon_sym_sample] = ACTIONS(2115),
    [anon_sym_linear] = ACTIONS(2115),
    [anon_sym_snorm] = ACTIONS(2115),
    [anon_sym_unorm] = ACTIONS(2115),
    [anon_sym_point] = ACTIONS(2115),
    [anon_sym_line] = ACTIONS(2115),
    [anon_sym_triangleadj] = ACTIONS(2115),
    [anon_sym_lineadj] = ACTIONS(2115),
    [anon_sym_triangle] = ACTIONS(2115),
  },
  [1272] = {
    [sym_string_literal] = STATE(3342),
    [sym_template_argument_list] = STATE(1461),
    [sym_raw_string_literal] = STATE(3342),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2639),
    [sym_identifier] = ACTIONS(2115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2130),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(4858),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON] = ACTIONS(4875),
    [anon_sym_SEMI] = ACTIONS(2130),
    [anon_sym___extension__] = ACTIONS(2115),
    [anon_sym_in] = ACTIONS(2115),
    [anon_sym_out] = ACTIONS(2115),
    [anon_sym_inout] = ACTIONS(2115),
    [anon_sym_extern] = ACTIONS(2115),
    [anon_sym___attribute__] = ACTIONS(2115),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2140),
    [anon_sym___declspec] = ACTIONS(2115),
    [anon_sym___based] = ACTIONS(2115),
    [anon_sym___cdecl] = ACTIONS(2115),
    [anon_sym___clrcall] = ACTIONS(2115),
    [anon_sym___stdcall] = ACTIONS(2115),
    [anon_sym___fastcall] = ACTIONS(2115),
    [anon_sym___thiscall] = ACTIONS(2115),
    [anon_sym___vectorcall] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_signed] = ACTIONS(4863),
    [anon_sym_unsigned] = ACTIONS(4863),
    [anon_sym_long] = ACTIONS(4863),
    [anon_sym_short] = ACTIONS(4863),
    [anon_sym_LBRACK] = ACTIONS(2148),
    [anon_sym_static] = ACTIONS(2115),
    [anon_sym_EQ] = ACTIONS(2152),
    [anon_sym_register] = ACTIONS(2115),
    [anon_sym_inline] = ACTIONS(2115),
    [anon_sym___inline] = ACTIONS(2115),
    [anon_sym___inline__] = ACTIONS(2115),
    [anon_sym___forceinline] = ACTIONS(2115),
    [anon_sym_thread_local] = ACTIONS(2115),
    [anon_sym___thread] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(2115),
    [anon_sym_constexpr] = ACTIONS(2115),
    [anon_sym_volatile] = ACTIONS(2115),
    [anon_sym_restrict] = ACTIONS(2115),
    [anon_sym___restrict__] = ACTIONS(2115),
    [anon_sym__Atomic] = ACTIONS(2115),
    [anon_sym__Noreturn] = ACTIONS(2115),
    [anon_sym_noreturn] = ACTIONS(2115),
    [anon_sym_mutable] = ACTIONS(2115),
    [anon_sym_constinit] = ACTIONS(2115),
    [anon_sym_consteval] = ACTIONS(2115),
    [anon_sym_alignas] = ACTIONS(2115),
    [anon_sym__Alignas] = ACTIONS(2115),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2154),
    [anon_sym_SLASH_EQ] = ACTIONS(2154),
    [anon_sym_PERCENT_EQ] = ACTIONS(2154),
    [anon_sym_PLUS_EQ] = ACTIONS(2154),
    [anon_sym_DASH_EQ] = ACTIONS(2154),
    [anon_sym_LT_LT_EQ] = ACTIONS(2154),
    [anon_sym_GT_GT_EQ] = ACTIONS(2154),
    [anon_sym_AMP_EQ] = ACTIONS(2154),
    [anon_sym_CARET_EQ] = ACTIONS(2154),
    [anon_sym_PIPE_EQ] = ACTIONS(2154),
    [anon_sym_and_eq] = ACTIONS(2152),
    [anon_sym_or_eq] = ACTIONS(2152),
    [anon_sym_xor_eq] = ACTIONS(2152),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2128),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2128),
    [anon_sym_not_eq] = ACTIONS(2128),
    [anon_sym_is] = ACTIONS(2128),
    [anon_sym_as] = ACTIONS(2128),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2125),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2115),
    [anon_sym_let] = ACTIONS(2115),
    [anon_sym_This] = ACTIONS(2115),
    [anon_sym_decltype] = ACTIONS(2115),
    [sym_virtual] = ACTIONS(2115),
    [anon_sym_template] = ACTIONS(2115),
    [anon_sym_operator] = ACTIONS(2115),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_precise] = ACTIONS(2115),
    [anon_sym_shared] = ACTIONS(2115),
    [anon_sym_groupshared] = ACTIONS(2115),
    [anon_sym_uniform] = ACTIONS(2115),
    [anon_sym_row_major] = ACTIONS(2115),
    [anon_sym_column_major] = ACTIONS(2115),
    [anon_sym_globallycoherent] = ACTIONS(2115),
    [anon_sym_centroid] = ACTIONS(2115),
    [anon_sym_noperspective] = ACTIONS(2115),
    [anon_sym_nointerpolation] = ACTIONS(2115),
    [anon_sym_sample] = ACTIONS(2115),
    [anon_sym_linear] = ACTIONS(2115),
    [anon_sym_snorm] = ACTIONS(2115),
    [anon_sym_unorm] = ACTIONS(2115),
    [anon_sym_point] = ACTIONS(2115),
    [anon_sym_line] = ACTIONS(2115),
    [anon_sym_triangleadj] = ACTIONS(2115),
    [anon_sym_lineadj] = ACTIONS(2115),
    [anon_sym_triangle] = ACTIONS(2115),
  },
  [1273] = {
    [sym_else_clause] = STATE(1295),
    [sym_identifier] = ACTIONS(2846),
    [anon_sym_LPAREN2] = ACTIONS(2848),
    [anon_sym_BANG] = ACTIONS(2848),
    [anon_sym_TILDE] = ACTIONS(2848),
    [anon_sym_DASH] = ACTIONS(2846),
    [anon_sym_PLUS] = ACTIONS(2846),
    [anon_sym_STAR] = ACTIONS(2848),
    [anon_sym_AMP] = ACTIONS(2848),
    [anon_sym_SEMI] = ACTIONS(2848),
    [anon_sym___extension__] = ACTIONS(2846),
    [anon_sym_typedef] = ACTIONS(2846),
    [anon_sym_in] = ACTIONS(2846),
    [anon_sym_out] = ACTIONS(2846),
    [anon_sym_inout] = ACTIONS(2846),
    [anon_sym_extern] = ACTIONS(2846),
    [anon_sym___attribute__] = ACTIONS(2846),
    [anon_sym_COLON_COLON] = ACTIONS(2848),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2848),
    [anon_sym___declspec] = ACTIONS(2846),
    [anon_sym_LBRACE] = ACTIONS(2848),
    [anon_sym_signed] = ACTIONS(2846),
    [anon_sym_unsigned] = ACTIONS(2846),
    [anon_sym_long] = ACTIONS(2846),
    [anon_sym_short] = ACTIONS(2846),
    [anon_sym_LBRACK] = ACTIONS(2846),
    [anon_sym_static] = ACTIONS(2846),
    [anon_sym_register] = ACTIONS(2846),
    [anon_sym_inline] = ACTIONS(2846),
    [anon_sym___inline] = ACTIONS(2846),
    [anon_sym___inline__] = ACTIONS(2846),
    [anon_sym___forceinline] = ACTIONS(2846),
    [anon_sym_thread_local] = ACTIONS(2846),
    [anon_sym___thread] = ACTIONS(2846),
    [anon_sym_const] = ACTIONS(2846),
    [anon_sym_constexpr] = ACTIONS(2846),
    [anon_sym_volatile] = ACTIONS(2846),
    [anon_sym_restrict] = ACTIONS(2846),
    [anon_sym___restrict__] = ACTIONS(2846),
    [anon_sym__Atomic] = ACTIONS(2846),
    [anon_sym__Noreturn] = ACTIONS(2846),
    [anon_sym_noreturn] = ACTIONS(2846),
    [anon_sym_mutable] = ACTIONS(2846),
    [anon_sym_constinit] = ACTIONS(2846),
    [anon_sym_consteval] = ACTIONS(2846),
    [anon_sym_alignas] = ACTIONS(2846),
    [anon_sym__Alignas] = ACTIONS(2846),
    [sym_primitive_type] = ACTIONS(2846),
    [anon_sym_enum] = ACTIONS(2846),
    [anon_sym_class] = ACTIONS(2846),
    [anon_sym_struct] = ACTIONS(2846),
    [anon_sym_union] = ACTIONS(2846),
    [anon_sym_if] = ACTIONS(2846),
    [anon_sym_else] = ACTIONS(4871),
    [anon_sym_switch] = ACTIONS(2846),
    [anon_sym_while] = ACTIONS(2846),
    [anon_sym_do] = ACTIONS(2846),
    [anon_sym_for] = ACTIONS(2846),
    [anon_sym_return] = ACTIONS(2846),
    [anon_sym_break] = ACTIONS(2846),
    [anon_sym_continue] = ACTIONS(2846),
    [anon_sym_goto] = ACTIONS(2846),
    [anon_sym___try] = ACTIONS(2846),
    [anon_sym___leave] = ACTIONS(2846),
    [anon_sym_not] = ACTIONS(2846),
    [anon_sym_compl] = ACTIONS(2846),
    [anon_sym_DASH_DASH] = ACTIONS(2848),
    [anon_sym_PLUS_PLUS] = ACTIONS(2848),
    [anon_sym_sizeof] = ACTIONS(2846),
    [anon_sym___alignof__] = ACTIONS(2846),
    [anon_sym___alignof] = ACTIONS(2846),
    [anon_sym__alignof] = ACTIONS(2846),
    [anon_sym_alignof] = ACTIONS(2846),
    [anon_sym__Alignof] = ACTIONS(2846),
    [anon_sym_offsetof] = ACTIONS(2846),
    [anon_sym__Generic] = ACTIONS(2846),
    [anon_sym_asm] = ACTIONS(2846),
    [anon_sym___asm__] = ACTIONS(2846),
    [sym_number_literal] = ACTIONS(2848),
    [anon_sym_L_SQUOTE] = ACTIONS(2848),
    [anon_sym_u_SQUOTE] = ACTIONS(2848),
    [anon_sym_U_SQUOTE] = ACTIONS(2848),
    [anon_sym_u8_SQUOTE] = ACTIONS(2848),
    [anon_sym_SQUOTE] = ACTIONS(2848),
    [anon_sym_L_DQUOTE] = ACTIONS(2848),
    [anon_sym_u_DQUOTE] = ACTIONS(2848),
    [anon_sym_U_DQUOTE] = ACTIONS(2848),
    [anon_sym_u8_DQUOTE] = ACTIONS(2848),
    [anon_sym_DQUOTE] = ACTIONS(2848),
    [sym_true] = ACTIONS(2846),
    [sym_false] = ACTIONS(2846),
    [anon_sym_NULL] = ACTIONS(2846),
    [anon_sym_nullptr] = ACTIONS(2846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2846),
    [anon_sym_let] = ACTIONS(2846),
    [anon_sym_This] = ACTIONS(2846),
    [anon_sym_decltype] = ACTIONS(2846),
    [sym_virtual] = ACTIONS(2846),
    [anon_sym_typename] = ACTIONS(2846),
    [anon_sym_template] = ACTIONS(2846),
    [anon_sym_try] = ACTIONS(2846),
    [anon_sym_delete] = ACTIONS(2846),
    [anon_sym_throw] = ACTIONS(2846),
    [anon_sym_co_return] = ACTIONS(2846),
    [anon_sym_co_yield] = ACTIONS(2846),
    [anon_sym_R_DQUOTE] = ACTIONS(2848),
    [anon_sym_LR_DQUOTE] = ACTIONS(2848),
    [anon_sym_uR_DQUOTE] = ACTIONS(2848),
    [anon_sym_UR_DQUOTE] = ACTIONS(2848),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2848),
    [anon_sym_co_await] = ACTIONS(2846),
    [anon_sym_new] = ACTIONS(2846),
    [anon_sym_requires] = ACTIONS(2846),
    [sym_this] = ACTIONS(2846),
    [anon_sym_discard] = ACTIONS(2846),
    [anon_sym_precise] = ACTIONS(2846),
    [anon_sym_shared] = ACTIONS(2846),
    [anon_sym_groupshared] = ACTIONS(2846),
    [anon_sym_uniform] = ACTIONS(2846),
    [anon_sym_row_major] = ACTIONS(2846),
    [anon_sym_column_major] = ACTIONS(2846),
    [anon_sym_globallycoherent] = ACTIONS(2846),
    [anon_sym_centroid] = ACTIONS(2846),
    [anon_sym_noperspective] = ACTIONS(2846),
    [anon_sym_nointerpolation] = ACTIONS(2846),
    [anon_sym_sample] = ACTIONS(2846),
    [anon_sym_linear] = ACTIONS(2846),
    [anon_sym_snorm] = ACTIONS(2846),
    [anon_sym_unorm] = ACTIONS(2846),
    [anon_sym_point] = ACTIONS(2846),
    [anon_sym_line] = ACTIONS(2846),
    [anon_sym_triangleadj] = ACTIONS(2846),
    [anon_sym_lineadj] = ACTIONS(2846),
    [anon_sym_triangle] = ACTIONS(2846),
    [anon_sym_cbuffer] = ACTIONS(2846),
    [anon_sym_interface] = ACTIONS(2846),
    [anon_sym_extension] = ACTIONS(2846),
  },
  [1274] = {
    [sym_else_clause] = STATE(1278),
    [sym_identifier] = ACTIONS(2850),
    [anon_sym_LPAREN2] = ACTIONS(2852),
    [anon_sym_BANG] = ACTIONS(2852),
    [anon_sym_TILDE] = ACTIONS(2852),
    [anon_sym_DASH] = ACTIONS(2850),
    [anon_sym_PLUS] = ACTIONS(2850),
    [anon_sym_STAR] = ACTIONS(2852),
    [anon_sym_AMP] = ACTIONS(2852),
    [anon_sym_SEMI] = ACTIONS(2852),
    [anon_sym___extension__] = ACTIONS(2850),
    [anon_sym_typedef] = ACTIONS(2850),
    [anon_sym_in] = ACTIONS(2850),
    [anon_sym_out] = ACTIONS(2850),
    [anon_sym_inout] = ACTIONS(2850),
    [anon_sym_extern] = ACTIONS(2850),
    [anon_sym___attribute__] = ACTIONS(2850),
    [anon_sym_COLON_COLON] = ACTIONS(2852),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2852),
    [anon_sym___declspec] = ACTIONS(2850),
    [anon_sym_LBRACE] = ACTIONS(2852),
    [anon_sym_signed] = ACTIONS(2850),
    [anon_sym_unsigned] = ACTIONS(2850),
    [anon_sym_long] = ACTIONS(2850),
    [anon_sym_short] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2850),
    [anon_sym_static] = ACTIONS(2850),
    [anon_sym_register] = ACTIONS(2850),
    [anon_sym_inline] = ACTIONS(2850),
    [anon_sym___inline] = ACTIONS(2850),
    [anon_sym___inline__] = ACTIONS(2850),
    [anon_sym___forceinline] = ACTIONS(2850),
    [anon_sym_thread_local] = ACTIONS(2850),
    [anon_sym___thread] = ACTIONS(2850),
    [anon_sym_const] = ACTIONS(2850),
    [anon_sym_constexpr] = ACTIONS(2850),
    [anon_sym_volatile] = ACTIONS(2850),
    [anon_sym_restrict] = ACTIONS(2850),
    [anon_sym___restrict__] = ACTIONS(2850),
    [anon_sym__Atomic] = ACTIONS(2850),
    [anon_sym__Noreturn] = ACTIONS(2850),
    [anon_sym_noreturn] = ACTIONS(2850),
    [anon_sym_mutable] = ACTIONS(2850),
    [anon_sym_constinit] = ACTIONS(2850),
    [anon_sym_consteval] = ACTIONS(2850),
    [anon_sym_alignas] = ACTIONS(2850),
    [anon_sym__Alignas] = ACTIONS(2850),
    [sym_primitive_type] = ACTIONS(2850),
    [anon_sym_enum] = ACTIONS(2850),
    [anon_sym_class] = ACTIONS(2850),
    [anon_sym_struct] = ACTIONS(2850),
    [anon_sym_union] = ACTIONS(2850),
    [anon_sym_if] = ACTIONS(2850),
    [anon_sym_else] = ACTIONS(4871),
    [anon_sym_switch] = ACTIONS(2850),
    [anon_sym_while] = ACTIONS(2850),
    [anon_sym_do] = ACTIONS(2850),
    [anon_sym_for] = ACTIONS(2850),
    [anon_sym_return] = ACTIONS(2850),
    [anon_sym_break] = ACTIONS(2850),
    [anon_sym_continue] = ACTIONS(2850),
    [anon_sym_goto] = ACTIONS(2850),
    [anon_sym___try] = ACTIONS(2850),
    [anon_sym___leave] = ACTIONS(2850),
    [anon_sym_not] = ACTIONS(2850),
    [anon_sym_compl] = ACTIONS(2850),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_sizeof] = ACTIONS(2850),
    [anon_sym___alignof__] = ACTIONS(2850),
    [anon_sym___alignof] = ACTIONS(2850),
    [anon_sym__alignof] = ACTIONS(2850),
    [anon_sym_alignof] = ACTIONS(2850),
    [anon_sym__Alignof] = ACTIONS(2850),
    [anon_sym_offsetof] = ACTIONS(2850),
    [anon_sym__Generic] = ACTIONS(2850),
    [anon_sym_asm] = ACTIONS(2850),
    [anon_sym___asm__] = ACTIONS(2850),
    [sym_number_literal] = ACTIONS(2852),
    [anon_sym_L_SQUOTE] = ACTIONS(2852),
    [anon_sym_u_SQUOTE] = ACTIONS(2852),
    [anon_sym_U_SQUOTE] = ACTIONS(2852),
    [anon_sym_u8_SQUOTE] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2852),
    [anon_sym_L_DQUOTE] = ACTIONS(2852),
    [anon_sym_u_DQUOTE] = ACTIONS(2852),
    [anon_sym_U_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8_DQUOTE] = ACTIONS(2852),
    [anon_sym_DQUOTE] = ACTIONS(2852),
    [sym_true] = ACTIONS(2850),
    [sym_false] = ACTIONS(2850),
    [anon_sym_NULL] = ACTIONS(2850),
    [anon_sym_nullptr] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2850),
    [anon_sym_let] = ACTIONS(2850),
    [anon_sym_This] = ACTIONS(2850),
    [anon_sym_decltype] = ACTIONS(2850),
    [sym_virtual] = ACTIONS(2850),
    [anon_sym_typename] = ACTIONS(2850),
    [anon_sym_template] = ACTIONS(2850),
    [anon_sym_try] = ACTIONS(2850),
    [anon_sym_delete] = ACTIONS(2850),
    [anon_sym_throw] = ACTIONS(2850),
    [anon_sym_co_return] = ACTIONS(2850),
    [anon_sym_co_yield] = ACTIONS(2850),
    [anon_sym_R_DQUOTE] = ACTIONS(2852),
    [anon_sym_LR_DQUOTE] = ACTIONS(2852),
    [anon_sym_uR_DQUOTE] = ACTIONS(2852),
    [anon_sym_UR_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2852),
    [anon_sym_co_await] = ACTIONS(2850),
    [anon_sym_new] = ACTIONS(2850),
    [anon_sym_requires] = ACTIONS(2850),
    [sym_this] = ACTIONS(2850),
    [anon_sym_discard] = ACTIONS(2850),
    [anon_sym_precise] = ACTIONS(2850),
    [anon_sym_shared] = ACTIONS(2850),
    [anon_sym_groupshared] = ACTIONS(2850),
    [anon_sym_uniform] = ACTIONS(2850),
    [anon_sym_row_major] = ACTIONS(2850),
    [anon_sym_column_major] = ACTIONS(2850),
    [anon_sym_globallycoherent] = ACTIONS(2850),
    [anon_sym_centroid] = ACTIONS(2850),
    [anon_sym_noperspective] = ACTIONS(2850),
    [anon_sym_nointerpolation] = ACTIONS(2850),
    [anon_sym_sample] = ACTIONS(2850),
    [anon_sym_linear] = ACTIONS(2850),
    [anon_sym_snorm] = ACTIONS(2850),
    [anon_sym_unorm] = ACTIONS(2850),
    [anon_sym_point] = ACTIONS(2850),
    [anon_sym_line] = ACTIONS(2850),
    [anon_sym_triangleadj] = ACTIONS(2850),
    [anon_sym_lineadj] = ACTIONS(2850),
    [anon_sym_triangle] = ACTIONS(2850),
    [anon_sym_cbuffer] = ACTIONS(2850),
    [anon_sym_interface] = ACTIONS(2850),
    [anon_sym_extension] = ACTIONS(2850),
  },
  [1275] = {
    [sym_identifier] = ACTIONS(3002),
    [anon_sym_LPAREN2] = ACTIONS(3004),
    [anon_sym_BANG] = ACTIONS(3004),
    [anon_sym_TILDE] = ACTIONS(3004),
    [anon_sym_DASH] = ACTIONS(3002),
    [anon_sym_PLUS] = ACTIONS(3002),
    [anon_sym_STAR] = ACTIONS(3004),
    [anon_sym_AMP] = ACTIONS(3004),
    [anon_sym_SEMI] = ACTIONS(3004),
    [anon_sym___extension__] = ACTIONS(3002),
    [anon_sym_typedef] = ACTIONS(3002),
    [anon_sym_in] = ACTIONS(3002),
    [anon_sym_out] = ACTIONS(3002),
    [anon_sym_inout] = ACTIONS(3002),
    [anon_sym_extern] = ACTIONS(3002),
    [anon_sym___attribute__] = ACTIONS(3002),
    [anon_sym_COLON_COLON] = ACTIONS(3004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3004),
    [anon_sym___declspec] = ACTIONS(3002),
    [anon_sym_LBRACE] = ACTIONS(3004),
    [anon_sym_signed] = ACTIONS(3002),
    [anon_sym_unsigned] = ACTIONS(3002),
    [anon_sym_long] = ACTIONS(3002),
    [anon_sym_short] = ACTIONS(3002),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [anon_sym_static] = ACTIONS(3002),
    [anon_sym_register] = ACTIONS(3002),
    [anon_sym_inline] = ACTIONS(3002),
    [anon_sym___inline] = ACTIONS(3002),
    [anon_sym___inline__] = ACTIONS(3002),
    [anon_sym___forceinline] = ACTIONS(3002),
    [anon_sym_thread_local] = ACTIONS(3002),
    [anon_sym___thread] = ACTIONS(3002),
    [anon_sym_const] = ACTIONS(3002),
    [anon_sym_constexpr] = ACTIONS(3002),
    [anon_sym_volatile] = ACTIONS(3002),
    [anon_sym_restrict] = ACTIONS(3002),
    [anon_sym___restrict__] = ACTIONS(3002),
    [anon_sym__Atomic] = ACTIONS(3002),
    [anon_sym__Noreturn] = ACTIONS(3002),
    [anon_sym_noreturn] = ACTIONS(3002),
    [anon_sym_mutable] = ACTIONS(3002),
    [anon_sym_constinit] = ACTIONS(3002),
    [anon_sym_consteval] = ACTIONS(3002),
    [anon_sym_alignas] = ACTIONS(3002),
    [anon_sym__Alignas] = ACTIONS(3002),
    [sym_primitive_type] = ACTIONS(3002),
    [anon_sym_enum] = ACTIONS(3002),
    [anon_sym_class] = ACTIONS(3002),
    [anon_sym_struct] = ACTIONS(3002),
    [anon_sym_union] = ACTIONS(3002),
    [anon_sym_if] = ACTIONS(3002),
    [anon_sym_else] = ACTIONS(3002),
    [anon_sym_switch] = ACTIONS(3002),
    [anon_sym_while] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(3002),
    [anon_sym_for] = ACTIONS(3002),
    [anon_sym_return] = ACTIONS(3002),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_continue] = ACTIONS(3002),
    [anon_sym_goto] = ACTIONS(3002),
    [anon_sym___try] = ACTIONS(3002),
    [anon_sym___leave] = ACTIONS(3002),
    [anon_sym_not] = ACTIONS(3002),
    [anon_sym_compl] = ACTIONS(3002),
    [anon_sym_DASH_DASH] = ACTIONS(3004),
    [anon_sym_PLUS_PLUS] = ACTIONS(3004),
    [anon_sym_sizeof] = ACTIONS(3002),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3002),
    [anon_sym__Generic] = ACTIONS(3002),
    [anon_sym_asm] = ACTIONS(3002),
    [anon_sym___asm__] = ACTIONS(3002),
    [sym_number_literal] = ACTIONS(3004),
    [anon_sym_L_SQUOTE] = ACTIONS(3004),
    [anon_sym_u_SQUOTE] = ACTIONS(3004),
    [anon_sym_U_SQUOTE] = ACTIONS(3004),
    [anon_sym_u8_SQUOTE] = ACTIONS(3004),
    [anon_sym_SQUOTE] = ACTIONS(3004),
    [anon_sym_L_DQUOTE] = ACTIONS(3004),
    [anon_sym_u_DQUOTE] = ACTIONS(3004),
    [anon_sym_U_DQUOTE] = ACTIONS(3004),
    [anon_sym_u8_DQUOTE] = ACTIONS(3004),
    [anon_sym_DQUOTE] = ACTIONS(3004),
    [sym_true] = ACTIONS(3002),
    [sym_false] = ACTIONS(3002),
    [anon_sym_NULL] = ACTIONS(3002),
    [anon_sym_nullptr] = ACTIONS(3002),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3002),
    [anon_sym_let] = ACTIONS(3002),
    [anon_sym_This] = ACTIONS(3002),
    [anon_sym_decltype] = ACTIONS(3002),
    [sym_virtual] = ACTIONS(3002),
    [anon_sym_typename] = ACTIONS(3002),
    [anon_sym_template] = ACTIONS(3002),
    [anon_sym_try] = ACTIONS(3002),
    [anon_sym_delete] = ACTIONS(3002),
    [anon_sym_throw] = ACTIONS(3002),
    [anon_sym_co_return] = ACTIONS(3002),
    [anon_sym_co_yield] = ACTIONS(3002),
    [anon_sym_R_DQUOTE] = ACTIONS(3004),
    [anon_sym_LR_DQUOTE] = ACTIONS(3004),
    [anon_sym_uR_DQUOTE] = ACTIONS(3004),
    [anon_sym_UR_DQUOTE] = ACTIONS(3004),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3004),
    [anon_sym_co_await] = ACTIONS(3002),
    [anon_sym_new] = ACTIONS(3002),
    [anon_sym_requires] = ACTIONS(3002),
    [sym_this] = ACTIONS(3002),
    [anon_sym_discard] = ACTIONS(3002),
    [anon_sym_precise] = ACTIONS(3002),
    [anon_sym_shared] = ACTIONS(3002),
    [anon_sym_groupshared] = ACTIONS(3002),
    [anon_sym_uniform] = ACTIONS(3002),
    [anon_sym_row_major] = ACTIONS(3002),
    [anon_sym_column_major] = ACTIONS(3002),
    [anon_sym_globallycoherent] = ACTIONS(3002),
    [anon_sym_centroid] = ACTIONS(3002),
    [anon_sym_noperspective] = ACTIONS(3002),
    [anon_sym_nointerpolation] = ACTIONS(3002),
    [anon_sym_sample] = ACTIONS(3002),
    [anon_sym_linear] = ACTIONS(3002),
    [anon_sym_snorm] = ACTIONS(3002),
    [anon_sym_unorm] = ACTIONS(3002),
    [anon_sym_point] = ACTIONS(3002),
    [anon_sym_line] = ACTIONS(3002),
    [anon_sym_triangleadj] = ACTIONS(3002),
    [anon_sym_lineadj] = ACTIONS(3002),
    [anon_sym_triangle] = ACTIONS(3002),
    [anon_sym_cbuffer] = ACTIONS(3002),
    [anon_sym_interface] = ACTIONS(3002),
    [anon_sym_extension] = ACTIONS(3002),
  },
  [1276] = {
    [sym_identifier] = ACTIONS(3038),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3038),
    [anon_sym_PLUS] = ACTIONS(3038),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3040),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3038),
    [anon_sym_typedef] = ACTIONS(3038),
    [anon_sym_in] = ACTIONS(3038),
    [anon_sym_out] = ACTIONS(3038),
    [anon_sym_inout] = ACTIONS(3038),
    [anon_sym_extern] = ACTIONS(3038),
    [anon_sym___attribute__] = ACTIONS(3038),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3040),
    [anon_sym___declspec] = ACTIONS(3038),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_signed] = ACTIONS(3038),
    [anon_sym_unsigned] = ACTIONS(3038),
    [anon_sym_long] = ACTIONS(3038),
    [anon_sym_short] = ACTIONS(3038),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_static] = ACTIONS(3038),
    [anon_sym_register] = ACTIONS(3038),
    [anon_sym_inline] = ACTIONS(3038),
    [anon_sym___inline] = ACTIONS(3038),
    [anon_sym___inline__] = ACTIONS(3038),
    [anon_sym___forceinline] = ACTIONS(3038),
    [anon_sym_thread_local] = ACTIONS(3038),
    [anon_sym___thread] = ACTIONS(3038),
    [anon_sym_const] = ACTIONS(3038),
    [anon_sym_constexpr] = ACTIONS(3038),
    [anon_sym_volatile] = ACTIONS(3038),
    [anon_sym_restrict] = ACTIONS(3038),
    [anon_sym___restrict__] = ACTIONS(3038),
    [anon_sym__Atomic] = ACTIONS(3038),
    [anon_sym__Noreturn] = ACTIONS(3038),
    [anon_sym_noreturn] = ACTIONS(3038),
    [anon_sym_mutable] = ACTIONS(3038),
    [anon_sym_constinit] = ACTIONS(3038),
    [anon_sym_consteval] = ACTIONS(3038),
    [anon_sym_alignas] = ACTIONS(3038),
    [anon_sym__Alignas] = ACTIONS(3038),
    [sym_primitive_type] = ACTIONS(3038),
    [anon_sym_enum] = ACTIONS(3038),
    [anon_sym_class] = ACTIONS(3038),
    [anon_sym_struct] = ACTIONS(3038),
    [anon_sym_union] = ACTIONS(3038),
    [anon_sym_if] = ACTIONS(3038),
    [anon_sym_else] = ACTIONS(3038),
    [anon_sym_switch] = ACTIONS(3038),
    [anon_sym_while] = ACTIONS(3038),
    [anon_sym_do] = ACTIONS(3038),
    [anon_sym_for] = ACTIONS(3038),
    [anon_sym_return] = ACTIONS(3038),
    [anon_sym_break] = ACTIONS(3038),
    [anon_sym_continue] = ACTIONS(3038),
    [anon_sym_goto] = ACTIONS(3038),
    [anon_sym___try] = ACTIONS(3038),
    [anon_sym___leave] = ACTIONS(3038),
    [anon_sym_not] = ACTIONS(3038),
    [anon_sym_compl] = ACTIONS(3038),
    [anon_sym_DASH_DASH] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3040),
    [anon_sym_sizeof] = ACTIONS(3038),
    [anon_sym___alignof__] = ACTIONS(3038),
    [anon_sym___alignof] = ACTIONS(3038),
    [anon_sym__alignof] = ACTIONS(3038),
    [anon_sym_alignof] = ACTIONS(3038),
    [anon_sym__Alignof] = ACTIONS(3038),
    [anon_sym_offsetof] = ACTIONS(3038),
    [anon_sym__Generic] = ACTIONS(3038),
    [anon_sym_asm] = ACTIONS(3038),
    [anon_sym___asm__] = ACTIONS(3038),
    [sym_number_literal] = ACTIONS(3040),
    [anon_sym_L_SQUOTE] = ACTIONS(3040),
    [anon_sym_u_SQUOTE] = ACTIONS(3040),
    [anon_sym_U_SQUOTE] = ACTIONS(3040),
    [anon_sym_u8_SQUOTE] = ACTIONS(3040),
    [anon_sym_SQUOTE] = ACTIONS(3040),
    [anon_sym_L_DQUOTE] = ACTIONS(3040),
    [anon_sym_u_DQUOTE] = ACTIONS(3040),
    [anon_sym_U_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8_DQUOTE] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [sym_true] = ACTIONS(3038),
    [sym_false] = ACTIONS(3038),
    [anon_sym_NULL] = ACTIONS(3038),
    [anon_sym_nullptr] = ACTIONS(3038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3038),
    [anon_sym_let] = ACTIONS(3038),
    [anon_sym_This] = ACTIONS(3038),
    [anon_sym_decltype] = ACTIONS(3038),
    [sym_virtual] = ACTIONS(3038),
    [anon_sym_typename] = ACTIONS(3038),
    [anon_sym_template] = ACTIONS(3038),
    [anon_sym_try] = ACTIONS(3038),
    [anon_sym_delete] = ACTIONS(3038),
    [anon_sym_throw] = ACTIONS(3038),
    [anon_sym_co_return] = ACTIONS(3038),
    [anon_sym_co_yield] = ACTIONS(3038),
    [anon_sym_R_DQUOTE] = ACTIONS(3040),
    [anon_sym_LR_DQUOTE] = ACTIONS(3040),
    [anon_sym_uR_DQUOTE] = ACTIONS(3040),
    [anon_sym_UR_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3040),
    [anon_sym_co_await] = ACTIONS(3038),
    [anon_sym_new] = ACTIONS(3038),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3038),
    [anon_sym_discard] = ACTIONS(3038),
    [anon_sym_precise] = ACTIONS(3038),
    [anon_sym_shared] = ACTIONS(3038),
    [anon_sym_groupshared] = ACTIONS(3038),
    [anon_sym_uniform] = ACTIONS(3038),
    [anon_sym_row_major] = ACTIONS(3038),
    [anon_sym_column_major] = ACTIONS(3038),
    [anon_sym_globallycoherent] = ACTIONS(3038),
    [anon_sym_centroid] = ACTIONS(3038),
    [anon_sym_noperspective] = ACTIONS(3038),
    [anon_sym_nointerpolation] = ACTIONS(3038),
    [anon_sym_sample] = ACTIONS(3038),
    [anon_sym_linear] = ACTIONS(3038),
    [anon_sym_snorm] = ACTIONS(3038),
    [anon_sym_unorm] = ACTIONS(3038),
    [anon_sym_point] = ACTIONS(3038),
    [anon_sym_line] = ACTIONS(3038),
    [anon_sym_triangleadj] = ACTIONS(3038),
    [anon_sym_lineadj] = ACTIONS(3038),
    [anon_sym_triangle] = ACTIONS(3038),
    [anon_sym_cbuffer] = ACTIONS(3038),
    [anon_sym_interface] = ACTIONS(3038),
    [anon_sym_extension] = ACTIONS(3038),
  },
  [1277] = {
    [sym_identifier] = ACTIONS(3084),
    [anon_sym_LPAREN2] = ACTIONS(3086),
    [anon_sym_BANG] = ACTIONS(3086),
    [anon_sym_TILDE] = ACTIONS(3086),
    [anon_sym_DASH] = ACTIONS(3084),
    [anon_sym_PLUS] = ACTIONS(3084),
    [anon_sym_STAR] = ACTIONS(3086),
    [anon_sym_AMP] = ACTIONS(3086),
    [anon_sym_SEMI] = ACTIONS(3086),
    [anon_sym___extension__] = ACTIONS(3084),
    [anon_sym_typedef] = ACTIONS(3084),
    [anon_sym_in] = ACTIONS(3084),
    [anon_sym_out] = ACTIONS(3084),
    [anon_sym_inout] = ACTIONS(3084),
    [anon_sym_extern] = ACTIONS(3084),
    [anon_sym___attribute__] = ACTIONS(3084),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3086),
    [anon_sym___declspec] = ACTIONS(3084),
    [anon_sym_LBRACE] = ACTIONS(3086),
    [anon_sym_signed] = ACTIONS(3084),
    [anon_sym_unsigned] = ACTIONS(3084),
    [anon_sym_long] = ACTIONS(3084),
    [anon_sym_short] = ACTIONS(3084),
    [anon_sym_LBRACK] = ACTIONS(3084),
    [anon_sym_static] = ACTIONS(3084),
    [anon_sym_register] = ACTIONS(3084),
    [anon_sym_inline] = ACTIONS(3084),
    [anon_sym___inline] = ACTIONS(3084),
    [anon_sym___inline__] = ACTIONS(3084),
    [anon_sym___forceinline] = ACTIONS(3084),
    [anon_sym_thread_local] = ACTIONS(3084),
    [anon_sym___thread] = ACTIONS(3084),
    [anon_sym_const] = ACTIONS(3084),
    [anon_sym_constexpr] = ACTIONS(3084),
    [anon_sym_volatile] = ACTIONS(3084),
    [anon_sym_restrict] = ACTIONS(3084),
    [anon_sym___restrict__] = ACTIONS(3084),
    [anon_sym__Atomic] = ACTIONS(3084),
    [anon_sym__Noreturn] = ACTIONS(3084),
    [anon_sym_noreturn] = ACTIONS(3084),
    [anon_sym_mutable] = ACTIONS(3084),
    [anon_sym_constinit] = ACTIONS(3084),
    [anon_sym_consteval] = ACTIONS(3084),
    [anon_sym_alignas] = ACTIONS(3084),
    [anon_sym__Alignas] = ACTIONS(3084),
    [sym_primitive_type] = ACTIONS(3084),
    [anon_sym_enum] = ACTIONS(3084),
    [anon_sym_class] = ACTIONS(3084),
    [anon_sym_struct] = ACTIONS(3084),
    [anon_sym_union] = ACTIONS(3084),
    [anon_sym_if] = ACTIONS(3084),
    [anon_sym_else] = ACTIONS(3084),
    [anon_sym_switch] = ACTIONS(3084),
    [anon_sym_while] = ACTIONS(3084),
    [anon_sym_do] = ACTIONS(3084),
    [anon_sym_for] = ACTIONS(3084),
    [anon_sym_return] = ACTIONS(3084),
    [anon_sym_break] = ACTIONS(3084),
    [anon_sym_continue] = ACTIONS(3084),
    [anon_sym_goto] = ACTIONS(3084),
    [anon_sym___try] = ACTIONS(3084),
    [anon_sym___leave] = ACTIONS(3084),
    [anon_sym_not] = ACTIONS(3084),
    [anon_sym_compl] = ACTIONS(3084),
    [anon_sym_DASH_DASH] = ACTIONS(3086),
    [anon_sym_PLUS_PLUS] = ACTIONS(3086),
    [anon_sym_sizeof] = ACTIONS(3084),
    [anon_sym___alignof__] = ACTIONS(3084),
    [anon_sym___alignof] = ACTIONS(3084),
    [anon_sym__alignof] = ACTIONS(3084),
    [anon_sym_alignof] = ACTIONS(3084),
    [anon_sym__Alignof] = ACTIONS(3084),
    [anon_sym_offsetof] = ACTIONS(3084),
    [anon_sym__Generic] = ACTIONS(3084),
    [anon_sym_asm] = ACTIONS(3084),
    [anon_sym___asm__] = ACTIONS(3084),
    [sym_number_literal] = ACTIONS(3086),
    [anon_sym_L_SQUOTE] = ACTIONS(3086),
    [anon_sym_u_SQUOTE] = ACTIONS(3086),
    [anon_sym_U_SQUOTE] = ACTIONS(3086),
    [anon_sym_u8_SQUOTE] = ACTIONS(3086),
    [anon_sym_SQUOTE] = ACTIONS(3086),
    [anon_sym_L_DQUOTE] = ACTIONS(3086),
    [anon_sym_u_DQUOTE] = ACTIONS(3086),
    [anon_sym_U_DQUOTE] = ACTIONS(3086),
    [anon_sym_u8_DQUOTE] = ACTIONS(3086),
    [anon_sym_DQUOTE] = ACTIONS(3086),
    [sym_true] = ACTIONS(3084),
    [sym_false] = ACTIONS(3084),
    [anon_sym_NULL] = ACTIONS(3084),
    [anon_sym_nullptr] = ACTIONS(3084),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3084),
    [anon_sym_let] = ACTIONS(3084),
    [anon_sym_This] = ACTIONS(3084),
    [anon_sym_decltype] = ACTIONS(3084),
    [sym_virtual] = ACTIONS(3084),
    [anon_sym_typename] = ACTIONS(3084),
    [anon_sym_template] = ACTIONS(3084),
    [anon_sym_try] = ACTIONS(3084),
    [anon_sym_delete] = ACTIONS(3084),
    [anon_sym_throw] = ACTIONS(3084),
    [anon_sym_co_return] = ACTIONS(3084),
    [anon_sym_co_yield] = ACTIONS(3084),
    [anon_sym_R_DQUOTE] = ACTIONS(3086),
    [anon_sym_LR_DQUOTE] = ACTIONS(3086),
    [anon_sym_uR_DQUOTE] = ACTIONS(3086),
    [anon_sym_UR_DQUOTE] = ACTIONS(3086),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3086),
    [anon_sym_co_await] = ACTIONS(3084),
    [anon_sym_new] = ACTIONS(3084),
    [anon_sym_requires] = ACTIONS(3084),
    [sym_this] = ACTIONS(3084),
    [anon_sym_discard] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(3084),
    [anon_sym_shared] = ACTIONS(3084),
    [anon_sym_groupshared] = ACTIONS(3084),
    [anon_sym_uniform] = ACTIONS(3084),
    [anon_sym_row_major] = ACTIONS(3084),
    [anon_sym_column_major] = ACTIONS(3084),
    [anon_sym_globallycoherent] = ACTIONS(3084),
    [anon_sym_centroid] = ACTIONS(3084),
    [anon_sym_noperspective] = ACTIONS(3084),
    [anon_sym_nointerpolation] = ACTIONS(3084),
    [anon_sym_sample] = ACTIONS(3084),
    [anon_sym_linear] = ACTIONS(3084),
    [anon_sym_snorm] = ACTIONS(3084),
    [anon_sym_unorm] = ACTIONS(3084),
    [anon_sym_point] = ACTIONS(3084),
    [anon_sym_line] = ACTIONS(3084),
    [anon_sym_triangleadj] = ACTIONS(3084),
    [anon_sym_lineadj] = ACTIONS(3084),
    [anon_sym_triangle] = ACTIONS(3084),
    [anon_sym_cbuffer] = ACTIONS(3084),
    [anon_sym_interface] = ACTIONS(3084),
    [anon_sym_extension] = ACTIONS(3084),
  },
  [1278] = {
    [sym_identifier] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(3072),
    [anon_sym_out] = ACTIONS(3072),
    [anon_sym_inout] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym__Alignas] = ACTIONS(3072),
    [sym_primitive_type] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [sym_number_literal] = ACTIONS(3074),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3072),
    [anon_sym_let] = ACTIONS(3072),
    [anon_sym_This] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [sym_virtual] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
    [anon_sym_discard] = ACTIONS(3072),
    [anon_sym_precise] = ACTIONS(3072),
    [anon_sym_shared] = ACTIONS(3072),
    [anon_sym_groupshared] = ACTIONS(3072),
    [anon_sym_uniform] = ACTIONS(3072),
    [anon_sym_row_major] = ACTIONS(3072),
    [anon_sym_column_major] = ACTIONS(3072),
    [anon_sym_globallycoherent] = ACTIONS(3072),
    [anon_sym_centroid] = ACTIONS(3072),
    [anon_sym_noperspective] = ACTIONS(3072),
    [anon_sym_nointerpolation] = ACTIONS(3072),
    [anon_sym_sample] = ACTIONS(3072),
    [anon_sym_linear] = ACTIONS(3072),
    [anon_sym_snorm] = ACTIONS(3072),
    [anon_sym_unorm] = ACTIONS(3072),
    [anon_sym_point] = ACTIONS(3072),
    [anon_sym_line] = ACTIONS(3072),
    [anon_sym_triangleadj] = ACTIONS(3072),
    [anon_sym_lineadj] = ACTIONS(3072),
    [anon_sym_triangle] = ACTIONS(3072),
    [anon_sym_cbuffer] = ACTIONS(3072),
    [anon_sym_interface] = ACTIONS(3072),
    [anon_sym_extension] = ACTIONS(3072),
  },
  [1279] = {
    [sym_identifier] = ACTIONS(3162),
    [anon_sym_LPAREN2] = ACTIONS(3164),
    [anon_sym_BANG] = ACTIONS(3164),
    [anon_sym_TILDE] = ACTIONS(3164),
    [anon_sym_DASH] = ACTIONS(3162),
    [anon_sym_PLUS] = ACTIONS(3162),
    [anon_sym_STAR] = ACTIONS(3164),
    [anon_sym_AMP] = ACTIONS(3164),
    [anon_sym_SEMI] = ACTIONS(3164),
    [anon_sym___extension__] = ACTIONS(3162),
    [anon_sym_typedef] = ACTIONS(3162),
    [anon_sym_in] = ACTIONS(3162),
    [anon_sym_out] = ACTIONS(3162),
    [anon_sym_inout] = ACTIONS(3162),
    [anon_sym_extern] = ACTIONS(3162),
    [anon_sym___attribute__] = ACTIONS(3162),
    [anon_sym_COLON_COLON] = ACTIONS(3164),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3164),
    [anon_sym___declspec] = ACTIONS(3162),
    [anon_sym_LBRACE] = ACTIONS(3164),
    [anon_sym_signed] = ACTIONS(3162),
    [anon_sym_unsigned] = ACTIONS(3162),
    [anon_sym_long] = ACTIONS(3162),
    [anon_sym_short] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(3162),
    [anon_sym_static] = ACTIONS(3162),
    [anon_sym_register] = ACTIONS(3162),
    [anon_sym_inline] = ACTIONS(3162),
    [anon_sym___inline] = ACTIONS(3162),
    [anon_sym___inline__] = ACTIONS(3162),
    [anon_sym___forceinline] = ACTIONS(3162),
    [anon_sym_thread_local] = ACTIONS(3162),
    [anon_sym___thread] = ACTIONS(3162),
    [anon_sym_const] = ACTIONS(3162),
    [anon_sym_constexpr] = ACTIONS(3162),
    [anon_sym_volatile] = ACTIONS(3162),
    [anon_sym_restrict] = ACTIONS(3162),
    [anon_sym___restrict__] = ACTIONS(3162),
    [anon_sym__Atomic] = ACTIONS(3162),
    [anon_sym__Noreturn] = ACTIONS(3162),
    [anon_sym_noreturn] = ACTIONS(3162),
    [anon_sym_mutable] = ACTIONS(3162),
    [anon_sym_constinit] = ACTIONS(3162),
    [anon_sym_consteval] = ACTIONS(3162),
    [anon_sym_alignas] = ACTIONS(3162),
    [anon_sym__Alignas] = ACTIONS(3162),
    [sym_primitive_type] = ACTIONS(3162),
    [anon_sym_enum] = ACTIONS(3162),
    [anon_sym_class] = ACTIONS(3162),
    [anon_sym_struct] = ACTIONS(3162),
    [anon_sym_union] = ACTIONS(3162),
    [anon_sym_if] = ACTIONS(3162),
    [anon_sym_else] = ACTIONS(3162),
    [anon_sym_switch] = ACTIONS(3162),
    [anon_sym_while] = ACTIONS(3162),
    [anon_sym_do] = ACTIONS(3162),
    [anon_sym_for] = ACTIONS(3162),
    [anon_sym_return] = ACTIONS(3162),
    [anon_sym_break] = ACTIONS(3162),
    [anon_sym_continue] = ACTIONS(3162),
    [anon_sym_goto] = ACTIONS(3162),
    [anon_sym___try] = ACTIONS(3162),
    [anon_sym___leave] = ACTIONS(3162),
    [anon_sym_not] = ACTIONS(3162),
    [anon_sym_compl] = ACTIONS(3162),
    [anon_sym_DASH_DASH] = ACTIONS(3164),
    [anon_sym_PLUS_PLUS] = ACTIONS(3164),
    [anon_sym_sizeof] = ACTIONS(3162),
    [anon_sym___alignof__] = ACTIONS(3162),
    [anon_sym___alignof] = ACTIONS(3162),
    [anon_sym__alignof] = ACTIONS(3162),
    [anon_sym_alignof] = ACTIONS(3162),
    [anon_sym__Alignof] = ACTIONS(3162),
    [anon_sym_offsetof] = ACTIONS(3162),
    [anon_sym__Generic] = ACTIONS(3162),
    [anon_sym_asm] = ACTIONS(3162),
    [anon_sym___asm__] = ACTIONS(3162),
    [sym_number_literal] = ACTIONS(3164),
    [anon_sym_L_SQUOTE] = ACTIONS(3164),
    [anon_sym_u_SQUOTE] = ACTIONS(3164),
    [anon_sym_U_SQUOTE] = ACTIONS(3164),
    [anon_sym_u8_SQUOTE] = ACTIONS(3164),
    [anon_sym_SQUOTE] = ACTIONS(3164),
    [anon_sym_L_DQUOTE] = ACTIONS(3164),
    [anon_sym_u_DQUOTE] = ACTIONS(3164),
    [anon_sym_U_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8_DQUOTE] = ACTIONS(3164),
    [anon_sym_DQUOTE] = ACTIONS(3164),
    [sym_true] = ACTIONS(3162),
    [sym_false] = ACTIONS(3162),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3162),
    [anon_sym_let] = ACTIONS(3162),
    [anon_sym_This] = ACTIONS(3162),
    [anon_sym_decltype] = ACTIONS(3162),
    [sym_virtual] = ACTIONS(3162),
    [anon_sym_typename] = ACTIONS(3162),
    [anon_sym_template] = ACTIONS(3162),
    [anon_sym_try] = ACTIONS(3162),
    [anon_sym_delete] = ACTIONS(3162),
    [anon_sym_throw] = ACTIONS(3162),
    [anon_sym_co_return] = ACTIONS(3162),
    [anon_sym_co_yield] = ACTIONS(3162),
    [anon_sym_R_DQUOTE] = ACTIONS(3164),
    [anon_sym_LR_DQUOTE] = ACTIONS(3164),
    [anon_sym_uR_DQUOTE] = ACTIONS(3164),
    [anon_sym_UR_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3164),
    [anon_sym_co_await] = ACTIONS(3162),
    [anon_sym_new] = ACTIONS(3162),
    [anon_sym_requires] = ACTIONS(3162),
    [sym_this] = ACTIONS(3162),
    [anon_sym_discard] = ACTIONS(3162),
    [anon_sym_precise] = ACTIONS(3162),
    [anon_sym_shared] = ACTIONS(3162),
    [anon_sym_groupshared] = ACTIONS(3162),
    [anon_sym_uniform] = ACTIONS(3162),
    [anon_sym_row_major] = ACTIONS(3162),
    [anon_sym_column_major] = ACTIONS(3162),
    [anon_sym_globallycoherent] = ACTIONS(3162),
    [anon_sym_centroid] = ACTIONS(3162),
    [anon_sym_noperspective] = ACTIONS(3162),
    [anon_sym_nointerpolation] = ACTIONS(3162),
    [anon_sym_sample] = ACTIONS(3162),
    [anon_sym_linear] = ACTIONS(3162),
    [anon_sym_snorm] = ACTIONS(3162),
    [anon_sym_unorm] = ACTIONS(3162),
    [anon_sym_point] = ACTIONS(3162),
    [anon_sym_line] = ACTIONS(3162),
    [anon_sym_triangleadj] = ACTIONS(3162),
    [anon_sym_lineadj] = ACTIONS(3162),
    [anon_sym_triangle] = ACTIONS(3162),
    [anon_sym_cbuffer] = ACTIONS(3162),
    [anon_sym_interface] = ACTIONS(3162),
    [anon_sym_extension] = ACTIONS(3162),
  },
  [1280] = {
    [sym_identifier] = ACTIONS(2898),
    [anon_sym_LPAREN2] = ACTIONS(2900),
    [anon_sym_BANG] = ACTIONS(2900),
    [anon_sym_TILDE] = ACTIONS(2900),
    [anon_sym_DASH] = ACTIONS(2898),
    [anon_sym_PLUS] = ACTIONS(2898),
    [anon_sym_STAR] = ACTIONS(2900),
    [anon_sym_AMP] = ACTIONS(2900),
    [anon_sym_SEMI] = ACTIONS(2900),
    [anon_sym___extension__] = ACTIONS(2898),
    [anon_sym_typedef] = ACTIONS(2898),
    [anon_sym_in] = ACTIONS(2898),
    [anon_sym_out] = ACTIONS(2898),
    [anon_sym_inout] = ACTIONS(2898),
    [anon_sym_extern] = ACTIONS(2898),
    [anon_sym___attribute__] = ACTIONS(2898),
    [anon_sym_COLON_COLON] = ACTIONS(2900),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2900),
    [anon_sym___declspec] = ACTIONS(2898),
    [anon_sym_LBRACE] = ACTIONS(2900),
    [anon_sym_signed] = ACTIONS(2898),
    [anon_sym_unsigned] = ACTIONS(2898),
    [anon_sym_long] = ACTIONS(2898),
    [anon_sym_short] = ACTIONS(2898),
    [anon_sym_LBRACK] = ACTIONS(2898),
    [anon_sym_static] = ACTIONS(2898),
    [anon_sym_register] = ACTIONS(2898),
    [anon_sym_inline] = ACTIONS(2898),
    [anon_sym___inline] = ACTIONS(2898),
    [anon_sym___inline__] = ACTIONS(2898),
    [anon_sym___forceinline] = ACTIONS(2898),
    [anon_sym_thread_local] = ACTIONS(2898),
    [anon_sym___thread] = ACTIONS(2898),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_constexpr] = ACTIONS(2898),
    [anon_sym_volatile] = ACTIONS(2898),
    [anon_sym_restrict] = ACTIONS(2898),
    [anon_sym___restrict__] = ACTIONS(2898),
    [anon_sym__Atomic] = ACTIONS(2898),
    [anon_sym__Noreturn] = ACTIONS(2898),
    [anon_sym_noreturn] = ACTIONS(2898),
    [anon_sym_mutable] = ACTIONS(2898),
    [anon_sym_constinit] = ACTIONS(2898),
    [anon_sym_consteval] = ACTIONS(2898),
    [anon_sym_alignas] = ACTIONS(2898),
    [anon_sym__Alignas] = ACTIONS(2898),
    [sym_primitive_type] = ACTIONS(2898),
    [anon_sym_enum] = ACTIONS(2898),
    [anon_sym_class] = ACTIONS(2898),
    [anon_sym_struct] = ACTIONS(2898),
    [anon_sym_union] = ACTIONS(2898),
    [anon_sym_if] = ACTIONS(2898),
    [anon_sym_else] = ACTIONS(2898),
    [anon_sym_switch] = ACTIONS(2898),
    [anon_sym_while] = ACTIONS(2898),
    [anon_sym_do] = ACTIONS(2898),
    [anon_sym_for] = ACTIONS(2898),
    [anon_sym_return] = ACTIONS(2898),
    [anon_sym_break] = ACTIONS(2898),
    [anon_sym_continue] = ACTIONS(2898),
    [anon_sym_goto] = ACTIONS(2898),
    [anon_sym___try] = ACTIONS(2898),
    [anon_sym___leave] = ACTIONS(2898),
    [anon_sym_not] = ACTIONS(2898),
    [anon_sym_compl] = ACTIONS(2898),
    [anon_sym_DASH_DASH] = ACTIONS(2900),
    [anon_sym_PLUS_PLUS] = ACTIONS(2900),
    [anon_sym_sizeof] = ACTIONS(2898),
    [anon_sym___alignof__] = ACTIONS(2898),
    [anon_sym___alignof] = ACTIONS(2898),
    [anon_sym__alignof] = ACTIONS(2898),
    [anon_sym_alignof] = ACTIONS(2898),
    [anon_sym__Alignof] = ACTIONS(2898),
    [anon_sym_offsetof] = ACTIONS(2898),
    [anon_sym__Generic] = ACTIONS(2898),
    [anon_sym_asm] = ACTIONS(2898),
    [anon_sym___asm__] = ACTIONS(2898),
    [sym_number_literal] = ACTIONS(2900),
    [anon_sym_L_SQUOTE] = ACTIONS(2900),
    [anon_sym_u_SQUOTE] = ACTIONS(2900),
    [anon_sym_U_SQUOTE] = ACTIONS(2900),
    [anon_sym_u8_SQUOTE] = ACTIONS(2900),
    [anon_sym_SQUOTE] = ACTIONS(2900),
    [anon_sym_L_DQUOTE] = ACTIONS(2900),
    [anon_sym_u_DQUOTE] = ACTIONS(2900),
    [anon_sym_U_DQUOTE] = ACTIONS(2900),
    [anon_sym_u8_DQUOTE] = ACTIONS(2900),
    [anon_sym_DQUOTE] = ACTIONS(2900),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2898),
    [anon_sym_nullptr] = ACTIONS(2898),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2898),
    [anon_sym_let] = ACTIONS(2898),
    [anon_sym_This] = ACTIONS(2898),
    [anon_sym_decltype] = ACTIONS(2898),
    [sym_virtual] = ACTIONS(2898),
    [anon_sym_typename] = ACTIONS(2898),
    [anon_sym_template] = ACTIONS(2898),
    [anon_sym_try] = ACTIONS(2898),
    [anon_sym_delete] = ACTIONS(2898),
    [anon_sym_throw] = ACTIONS(2898),
    [anon_sym_co_return] = ACTIONS(2898),
    [anon_sym_co_yield] = ACTIONS(2898),
    [anon_sym_R_DQUOTE] = ACTIONS(2900),
    [anon_sym_LR_DQUOTE] = ACTIONS(2900),
    [anon_sym_uR_DQUOTE] = ACTIONS(2900),
    [anon_sym_UR_DQUOTE] = ACTIONS(2900),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2900),
    [anon_sym_co_await] = ACTIONS(2898),
    [anon_sym_new] = ACTIONS(2898),
    [anon_sym_requires] = ACTIONS(2898),
    [sym_this] = ACTIONS(2898),
    [anon_sym_discard] = ACTIONS(2898),
    [anon_sym_precise] = ACTIONS(2898),
    [anon_sym_shared] = ACTIONS(2898),
    [anon_sym_groupshared] = ACTIONS(2898),
    [anon_sym_uniform] = ACTIONS(2898),
    [anon_sym_row_major] = ACTIONS(2898),
    [anon_sym_column_major] = ACTIONS(2898),
    [anon_sym_globallycoherent] = ACTIONS(2898),
    [anon_sym_centroid] = ACTIONS(2898),
    [anon_sym_noperspective] = ACTIONS(2898),
    [anon_sym_nointerpolation] = ACTIONS(2898),
    [anon_sym_sample] = ACTIONS(2898),
    [anon_sym_linear] = ACTIONS(2898),
    [anon_sym_snorm] = ACTIONS(2898),
    [anon_sym_unorm] = ACTIONS(2898),
    [anon_sym_point] = ACTIONS(2898),
    [anon_sym_line] = ACTIONS(2898),
    [anon_sym_triangleadj] = ACTIONS(2898),
    [anon_sym_lineadj] = ACTIONS(2898),
    [anon_sym_triangle] = ACTIONS(2898),
    [anon_sym_cbuffer] = ACTIONS(2898),
    [anon_sym_interface] = ACTIONS(2898),
    [anon_sym_extension] = ACTIONS(2898),
  },
  [1281] = {
    [sym_identifier] = ACTIONS(3214),
    [anon_sym_LPAREN2] = ACTIONS(3216),
    [anon_sym_BANG] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_DASH] = ACTIONS(3214),
    [anon_sym_PLUS] = ACTIONS(3214),
    [anon_sym_STAR] = ACTIONS(3216),
    [anon_sym_AMP] = ACTIONS(3216),
    [anon_sym_SEMI] = ACTIONS(3216),
    [anon_sym___extension__] = ACTIONS(3214),
    [anon_sym_typedef] = ACTIONS(3214),
    [anon_sym_in] = ACTIONS(3214),
    [anon_sym_out] = ACTIONS(3214),
    [anon_sym_inout] = ACTIONS(3214),
    [anon_sym_extern] = ACTIONS(3214),
    [anon_sym___attribute__] = ACTIONS(3214),
    [anon_sym_COLON_COLON] = ACTIONS(3216),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3216),
    [anon_sym___declspec] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3216),
    [anon_sym_signed] = ACTIONS(3214),
    [anon_sym_unsigned] = ACTIONS(3214),
    [anon_sym_long] = ACTIONS(3214),
    [anon_sym_short] = ACTIONS(3214),
    [anon_sym_LBRACK] = ACTIONS(3214),
    [anon_sym_static] = ACTIONS(3214),
    [anon_sym_register] = ACTIONS(3214),
    [anon_sym_inline] = ACTIONS(3214),
    [anon_sym___inline] = ACTIONS(3214),
    [anon_sym___inline__] = ACTIONS(3214),
    [anon_sym___forceinline] = ACTIONS(3214),
    [anon_sym_thread_local] = ACTIONS(3214),
    [anon_sym___thread] = ACTIONS(3214),
    [anon_sym_const] = ACTIONS(3214),
    [anon_sym_constexpr] = ACTIONS(3214),
    [anon_sym_volatile] = ACTIONS(3214),
    [anon_sym_restrict] = ACTIONS(3214),
    [anon_sym___restrict__] = ACTIONS(3214),
    [anon_sym__Atomic] = ACTIONS(3214),
    [anon_sym__Noreturn] = ACTIONS(3214),
    [anon_sym_noreturn] = ACTIONS(3214),
    [anon_sym_mutable] = ACTIONS(3214),
    [anon_sym_constinit] = ACTIONS(3214),
    [anon_sym_consteval] = ACTIONS(3214),
    [anon_sym_alignas] = ACTIONS(3214),
    [anon_sym__Alignas] = ACTIONS(3214),
    [sym_primitive_type] = ACTIONS(3214),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3214),
    [anon_sym_struct] = ACTIONS(3214),
    [anon_sym_union] = ACTIONS(3214),
    [anon_sym_if] = ACTIONS(3214),
    [anon_sym_else] = ACTIONS(3214),
    [anon_sym_switch] = ACTIONS(3214),
    [anon_sym_while] = ACTIONS(3214),
    [anon_sym_do] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3214),
    [anon_sym_return] = ACTIONS(3214),
    [anon_sym_break] = ACTIONS(3214),
    [anon_sym_continue] = ACTIONS(3214),
    [anon_sym_goto] = ACTIONS(3214),
    [anon_sym___try] = ACTIONS(3214),
    [anon_sym___leave] = ACTIONS(3214),
    [anon_sym_not] = ACTIONS(3214),
    [anon_sym_compl] = ACTIONS(3214),
    [anon_sym_DASH_DASH] = ACTIONS(3216),
    [anon_sym_PLUS_PLUS] = ACTIONS(3216),
    [anon_sym_sizeof] = ACTIONS(3214),
    [anon_sym___alignof__] = ACTIONS(3214),
    [anon_sym___alignof] = ACTIONS(3214),
    [anon_sym__alignof] = ACTIONS(3214),
    [anon_sym_alignof] = ACTIONS(3214),
    [anon_sym__Alignof] = ACTIONS(3214),
    [anon_sym_offsetof] = ACTIONS(3214),
    [anon_sym__Generic] = ACTIONS(3214),
    [anon_sym_asm] = ACTIONS(3214),
    [anon_sym___asm__] = ACTIONS(3214),
    [sym_number_literal] = ACTIONS(3216),
    [anon_sym_L_SQUOTE] = ACTIONS(3216),
    [anon_sym_u_SQUOTE] = ACTIONS(3216),
    [anon_sym_U_SQUOTE] = ACTIONS(3216),
    [anon_sym_u8_SQUOTE] = ACTIONS(3216),
    [anon_sym_SQUOTE] = ACTIONS(3216),
    [anon_sym_L_DQUOTE] = ACTIONS(3216),
    [anon_sym_u_DQUOTE] = ACTIONS(3216),
    [anon_sym_U_DQUOTE] = ACTIONS(3216),
    [anon_sym_u8_DQUOTE] = ACTIONS(3216),
    [anon_sym_DQUOTE] = ACTIONS(3216),
    [sym_true] = ACTIONS(3214),
    [sym_false] = ACTIONS(3214),
    [anon_sym_NULL] = ACTIONS(3214),
    [anon_sym_nullptr] = ACTIONS(3214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3214),
    [anon_sym_let] = ACTIONS(3214),
    [anon_sym_This] = ACTIONS(3214),
    [anon_sym_decltype] = ACTIONS(3214),
    [sym_virtual] = ACTIONS(3214),
    [anon_sym_typename] = ACTIONS(3214),
    [anon_sym_template] = ACTIONS(3214),
    [anon_sym_try] = ACTIONS(3214),
    [anon_sym_delete] = ACTIONS(3214),
    [anon_sym_throw] = ACTIONS(3214),
    [anon_sym_co_return] = ACTIONS(3214),
    [anon_sym_co_yield] = ACTIONS(3214),
    [anon_sym_R_DQUOTE] = ACTIONS(3216),
    [anon_sym_LR_DQUOTE] = ACTIONS(3216),
    [anon_sym_uR_DQUOTE] = ACTIONS(3216),
    [anon_sym_UR_DQUOTE] = ACTIONS(3216),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3216),
    [anon_sym_co_await] = ACTIONS(3214),
    [anon_sym_new] = ACTIONS(3214),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(3214),
    [anon_sym_discard] = ACTIONS(3214),
    [anon_sym_precise] = ACTIONS(3214),
    [anon_sym_shared] = ACTIONS(3214),
    [anon_sym_groupshared] = ACTIONS(3214),
    [anon_sym_uniform] = ACTIONS(3214),
    [anon_sym_row_major] = ACTIONS(3214),
    [anon_sym_column_major] = ACTIONS(3214),
    [anon_sym_globallycoherent] = ACTIONS(3214),
    [anon_sym_centroid] = ACTIONS(3214),
    [anon_sym_noperspective] = ACTIONS(3214),
    [anon_sym_nointerpolation] = ACTIONS(3214),
    [anon_sym_sample] = ACTIONS(3214),
    [anon_sym_linear] = ACTIONS(3214),
    [anon_sym_snorm] = ACTIONS(3214),
    [anon_sym_unorm] = ACTIONS(3214),
    [anon_sym_point] = ACTIONS(3214),
    [anon_sym_line] = ACTIONS(3214),
    [anon_sym_triangleadj] = ACTIONS(3214),
    [anon_sym_lineadj] = ACTIONS(3214),
    [anon_sym_triangle] = ACTIONS(3214),
    [anon_sym_cbuffer] = ACTIONS(3214),
    [anon_sym_interface] = ACTIONS(3214),
    [anon_sym_extension] = ACTIONS(3214),
  },
  [1282] = {
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_LPAREN2] = ACTIONS(2904),
    [anon_sym_BANG] = ACTIONS(2904),
    [anon_sym_TILDE] = ACTIONS(2904),
    [anon_sym_DASH] = ACTIONS(2902),
    [anon_sym_PLUS] = ACTIONS(2902),
    [anon_sym_STAR] = ACTIONS(2904),
    [anon_sym_AMP] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(2904),
    [anon_sym___extension__] = ACTIONS(2902),
    [anon_sym_typedef] = ACTIONS(2902),
    [anon_sym_in] = ACTIONS(2902),
    [anon_sym_out] = ACTIONS(2902),
    [anon_sym_inout] = ACTIONS(2902),
    [anon_sym_extern] = ACTIONS(2902),
    [anon_sym___attribute__] = ACTIONS(2902),
    [anon_sym_COLON_COLON] = ACTIONS(2904),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2904),
    [anon_sym___declspec] = ACTIONS(2902),
    [anon_sym_LBRACE] = ACTIONS(2904),
    [anon_sym_signed] = ACTIONS(2902),
    [anon_sym_unsigned] = ACTIONS(2902),
    [anon_sym_long] = ACTIONS(2902),
    [anon_sym_short] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2902),
    [anon_sym_static] = ACTIONS(2902),
    [anon_sym_register] = ACTIONS(2902),
    [anon_sym_inline] = ACTIONS(2902),
    [anon_sym___inline] = ACTIONS(2902),
    [anon_sym___inline__] = ACTIONS(2902),
    [anon_sym___forceinline] = ACTIONS(2902),
    [anon_sym_thread_local] = ACTIONS(2902),
    [anon_sym___thread] = ACTIONS(2902),
    [anon_sym_const] = ACTIONS(2902),
    [anon_sym_constexpr] = ACTIONS(2902),
    [anon_sym_volatile] = ACTIONS(2902),
    [anon_sym_restrict] = ACTIONS(2902),
    [anon_sym___restrict__] = ACTIONS(2902),
    [anon_sym__Atomic] = ACTIONS(2902),
    [anon_sym__Noreturn] = ACTIONS(2902),
    [anon_sym_noreturn] = ACTIONS(2902),
    [anon_sym_mutable] = ACTIONS(2902),
    [anon_sym_constinit] = ACTIONS(2902),
    [anon_sym_consteval] = ACTIONS(2902),
    [anon_sym_alignas] = ACTIONS(2902),
    [anon_sym__Alignas] = ACTIONS(2902),
    [sym_primitive_type] = ACTIONS(2902),
    [anon_sym_enum] = ACTIONS(2902),
    [anon_sym_class] = ACTIONS(2902),
    [anon_sym_struct] = ACTIONS(2902),
    [anon_sym_union] = ACTIONS(2902),
    [anon_sym_if] = ACTIONS(2902),
    [anon_sym_else] = ACTIONS(2902),
    [anon_sym_switch] = ACTIONS(2902),
    [anon_sym_while] = ACTIONS(2902),
    [anon_sym_do] = ACTIONS(2902),
    [anon_sym_for] = ACTIONS(2902),
    [anon_sym_return] = ACTIONS(2902),
    [anon_sym_break] = ACTIONS(2902),
    [anon_sym_continue] = ACTIONS(2902),
    [anon_sym_goto] = ACTIONS(2902),
    [anon_sym___try] = ACTIONS(2902),
    [anon_sym___leave] = ACTIONS(2902),
    [anon_sym_not] = ACTIONS(2902),
    [anon_sym_compl] = ACTIONS(2902),
    [anon_sym_DASH_DASH] = ACTIONS(2904),
    [anon_sym_PLUS_PLUS] = ACTIONS(2904),
    [anon_sym_sizeof] = ACTIONS(2902),
    [anon_sym___alignof__] = ACTIONS(2902),
    [anon_sym___alignof] = ACTIONS(2902),
    [anon_sym__alignof] = ACTIONS(2902),
    [anon_sym_alignof] = ACTIONS(2902),
    [anon_sym__Alignof] = ACTIONS(2902),
    [anon_sym_offsetof] = ACTIONS(2902),
    [anon_sym__Generic] = ACTIONS(2902),
    [anon_sym_asm] = ACTIONS(2902),
    [anon_sym___asm__] = ACTIONS(2902),
    [sym_number_literal] = ACTIONS(2904),
    [anon_sym_L_SQUOTE] = ACTIONS(2904),
    [anon_sym_u_SQUOTE] = ACTIONS(2904),
    [anon_sym_U_SQUOTE] = ACTIONS(2904),
    [anon_sym_u8_SQUOTE] = ACTIONS(2904),
    [anon_sym_SQUOTE] = ACTIONS(2904),
    [anon_sym_L_DQUOTE] = ACTIONS(2904),
    [anon_sym_u_DQUOTE] = ACTIONS(2904),
    [anon_sym_U_DQUOTE] = ACTIONS(2904),
    [anon_sym_u8_DQUOTE] = ACTIONS(2904),
    [anon_sym_DQUOTE] = ACTIONS(2904),
    [sym_true] = ACTIONS(2902),
    [sym_false] = ACTIONS(2902),
    [anon_sym_NULL] = ACTIONS(2902),
    [anon_sym_nullptr] = ACTIONS(2902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2902),
    [anon_sym_let] = ACTIONS(2902),
    [anon_sym_This] = ACTIONS(2902),
    [anon_sym_decltype] = ACTIONS(2902),
    [sym_virtual] = ACTIONS(2902),
    [anon_sym_typename] = ACTIONS(2902),
    [anon_sym_template] = ACTIONS(2902),
    [anon_sym_try] = ACTIONS(2902),
    [anon_sym_delete] = ACTIONS(2902),
    [anon_sym_throw] = ACTIONS(2902),
    [anon_sym_co_return] = ACTIONS(2902),
    [anon_sym_co_yield] = ACTIONS(2902),
    [anon_sym_R_DQUOTE] = ACTIONS(2904),
    [anon_sym_LR_DQUOTE] = ACTIONS(2904),
    [anon_sym_uR_DQUOTE] = ACTIONS(2904),
    [anon_sym_UR_DQUOTE] = ACTIONS(2904),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2904),
    [anon_sym_co_await] = ACTIONS(2902),
    [anon_sym_new] = ACTIONS(2902),
    [anon_sym_requires] = ACTIONS(2902),
    [sym_this] = ACTIONS(2902),
    [anon_sym_discard] = ACTIONS(2902),
    [anon_sym_precise] = ACTIONS(2902),
    [anon_sym_shared] = ACTIONS(2902),
    [anon_sym_groupshared] = ACTIONS(2902),
    [anon_sym_uniform] = ACTIONS(2902),
    [anon_sym_row_major] = ACTIONS(2902),
    [anon_sym_column_major] = ACTIONS(2902),
    [anon_sym_globallycoherent] = ACTIONS(2902),
    [anon_sym_centroid] = ACTIONS(2902),
    [anon_sym_noperspective] = ACTIONS(2902),
    [anon_sym_nointerpolation] = ACTIONS(2902),
    [anon_sym_sample] = ACTIONS(2902),
    [anon_sym_linear] = ACTIONS(2902),
    [anon_sym_snorm] = ACTIONS(2902),
    [anon_sym_unorm] = ACTIONS(2902),
    [anon_sym_point] = ACTIONS(2902),
    [anon_sym_line] = ACTIONS(2902),
    [anon_sym_triangleadj] = ACTIONS(2902),
    [anon_sym_lineadj] = ACTIONS(2902),
    [anon_sym_triangle] = ACTIONS(2902),
    [anon_sym_cbuffer] = ACTIONS(2902),
    [anon_sym_interface] = ACTIONS(2902),
    [anon_sym_extension] = ACTIONS(2902),
  },
  [1283] = {
    [sym_identifier] = ACTIONS(3022),
    [anon_sym_LPAREN2] = ACTIONS(3024),
    [anon_sym_BANG] = ACTIONS(3024),
    [anon_sym_TILDE] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3022),
    [anon_sym_PLUS] = ACTIONS(3022),
    [anon_sym_STAR] = ACTIONS(3024),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym_SEMI] = ACTIONS(3024),
    [anon_sym___extension__] = ACTIONS(3022),
    [anon_sym_typedef] = ACTIONS(3022),
    [anon_sym_in] = ACTIONS(3022),
    [anon_sym_out] = ACTIONS(3022),
    [anon_sym_inout] = ACTIONS(3022),
    [anon_sym_extern] = ACTIONS(3022),
    [anon_sym___attribute__] = ACTIONS(3022),
    [anon_sym_COLON_COLON] = ACTIONS(3024),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3024),
    [anon_sym___declspec] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_signed] = ACTIONS(3022),
    [anon_sym_unsigned] = ACTIONS(3022),
    [anon_sym_long] = ACTIONS(3022),
    [anon_sym_short] = ACTIONS(3022),
    [anon_sym_LBRACK] = ACTIONS(3022),
    [anon_sym_static] = ACTIONS(3022),
    [anon_sym_register] = ACTIONS(3022),
    [anon_sym_inline] = ACTIONS(3022),
    [anon_sym___inline] = ACTIONS(3022),
    [anon_sym___inline__] = ACTIONS(3022),
    [anon_sym___forceinline] = ACTIONS(3022),
    [anon_sym_thread_local] = ACTIONS(3022),
    [anon_sym___thread] = ACTIONS(3022),
    [anon_sym_const] = ACTIONS(3022),
    [anon_sym_constexpr] = ACTIONS(3022),
    [anon_sym_volatile] = ACTIONS(3022),
    [anon_sym_restrict] = ACTIONS(3022),
    [anon_sym___restrict__] = ACTIONS(3022),
    [anon_sym__Atomic] = ACTIONS(3022),
    [anon_sym__Noreturn] = ACTIONS(3022),
    [anon_sym_noreturn] = ACTIONS(3022),
    [anon_sym_mutable] = ACTIONS(3022),
    [anon_sym_constinit] = ACTIONS(3022),
    [anon_sym_consteval] = ACTIONS(3022),
    [anon_sym_alignas] = ACTIONS(3022),
    [anon_sym__Alignas] = ACTIONS(3022),
    [sym_primitive_type] = ACTIONS(3022),
    [anon_sym_enum] = ACTIONS(3022),
    [anon_sym_class] = ACTIONS(3022),
    [anon_sym_struct] = ACTIONS(3022),
    [anon_sym_union] = ACTIONS(3022),
    [anon_sym_if] = ACTIONS(3022),
    [anon_sym_else] = ACTIONS(3022),
    [anon_sym_switch] = ACTIONS(3022),
    [anon_sym_while] = ACTIONS(3022),
    [anon_sym_do] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(3022),
    [anon_sym_return] = ACTIONS(3022),
    [anon_sym_break] = ACTIONS(3022),
    [anon_sym_continue] = ACTIONS(3022),
    [anon_sym_goto] = ACTIONS(3022),
    [anon_sym___try] = ACTIONS(3022),
    [anon_sym___leave] = ACTIONS(3022),
    [anon_sym_not] = ACTIONS(3022),
    [anon_sym_compl] = ACTIONS(3022),
    [anon_sym_DASH_DASH] = ACTIONS(3024),
    [anon_sym_PLUS_PLUS] = ACTIONS(3024),
    [anon_sym_sizeof] = ACTIONS(3022),
    [anon_sym___alignof__] = ACTIONS(3022),
    [anon_sym___alignof] = ACTIONS(3022),
    [anon_sym__alignof] = ACTIONS(3022),
    [anon_sym_alignof] = ACTIONS(3022),
    [anon_sym__Alignof] = ACTIONS(3022),
    [anon_sym_offsetof] = ACTIONS(3022),
    [anon_sym__Generic] = ACTIONS(3022),
    [anon_sym_asm] = ACTIONS(3022),
    [anon_sym___asm__] = ACTIONS(3022),
    [sym_number_literal] = ACTIONS(3024),
    [anon_sym_L_SQUOTE] = ACTIONS(3024),
    [anon_sym_u_SQUOTE] = ACTIONS(3024),
    [anon_sym_U_SQUOTE] = ACTIONS(3024),
    [anon_sym_u8_SQUOTE] = ACTIONS(3024),
    [anon_sym_SQUOTE] = ACTIONS(3024),
    [anon_sym_L_DQUOTE] = ACTIONS(3024),
    [anon_sym_u_DQUOTE] = ACTIONS(3024),
    [anon_sym_U_DQUOTE] = ACTIONS(3024),
    [anon_sym_u8_DQUOTE] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3024),
    [sym_true] = ACTIONS(3022),
    [sym_false] = ACTIONS(3022),
    [anon_sym_NULL] = ACTIONS(3022),
    [anon_sym_nullptr] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3022),
    [anon_sym_let] = ACTIONS(3022),
    [anon_sym_This] = ACTIONS(3022),
    [anon_sym_decltype] = ACTIONS(3022),
    [sym_virtual] = ACTIONS(3022),
    [anon_sym_typename] = ACTIONS(3022),
    [anon_sym_template] = ACTIONS(3022),
    [anon_sym_try] = ACTIONS(3022),
    [anon_sym_delete] = ACTIONS(3022),
    [anon_sym_throw] = ACTIONS(3022),
    [anon_sym_co_return] = ACTIONS(3022),
    [anon_sym_co_yield] = ACTIONS(3022),
    [anon_sym_R_DQUOTE] = ACTIONS(3024),
    [anon_sym_LR_DQUOTE] = ACTIONS(3024),
    [anon_sym_uR_DQUOTE] = ACTIONS(3024),
    [anon_sym_UR_DQUOTE] = ACTIONS(3024),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3024),
    [anon_sym_co_await] = ACTIONS(3022),
    [anon_sym_new] = ACTIONS(3022),
    [anon_sym_requires] = ACTIONS(3022),
    [sym_this] = ACTIONS(3022),
    [anon_sym_discard] = ACTIONS(3022),
    [anon_sym_precise] = ACTIONS(3022),
    [anon_sym_shared] = ACTIONS(3022),
    [anon_sym_groupshared] = ACTIONS(3022),
    [anon_sym_uniform] = ACTIONS(3022),
    [anon_sym_row_major] = ACTIONS(3022),
    [anon_sym_column_major] = ACTIONS(3022),
    [anon_sym_globallycoherent] = ACTIONS(3022),
    [anon_sym_centroid] = ACTIONS(3022),
    [anon_sym_noperspective] = ACTIONS(3022),
    [anon_sym_nointerpolation] = ACTIONS(3022),
    [anon_sym_sample] = ACTIONS(3022),
    [anon_sym_linear] = ACTIONS(3022),
    [anon_sym_snorm] = ACTIONS(3022),
    [anon_sym_unorm] = ACTIONS(3022),
    [anon_sym_point] = ACTIONS(3022),
    [anon_sym_line] = ACTIONS(3022),
    [anon_sym_triangleadj] = ACTIONS(3022),
    [anon_sym_lineadj] = ACTIONS(3022),
    [anon_sym_triangle] = ACTIONS(3022),
    [anon_sym_cbuffer] = ACTIONS(3022),
    [anon_sym_interface] = ACTIONS(3022),
    [anon_sym_extension] = ACTIONS(3022),
  },
  [1284] = {
    [sym_identifier] = ACTIONS(3018),
    [anon_sym_LPAREN2] = ACTIONS(3020),
    [anon_sym_BANG] = ACTIONS(3020),
    [anon_sym_TILDE] = ACTIONS(3020),
    [anon_sym_DASH] = ACTIONS(3018),
    [anon_sym_PLUS] = ACTIONS(3018),
    [anon_sym_STAR] = ACTIONS(3020),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym_SEMI] = ACTIONS(3020),
    [anon_sym___extension__] = ACTIONS(3018),
    [anon_sym_typedef] = ACTIONS(3018),
    [anon_sym_in] = ACTIONS(3018),
    [anon_sym_out] = ACTIONS(3018),
    [anon_sym_inout] = ACTIONS(3018),
    [anon_sym_extern] = ACTIONS(3018),
    [anon_sym___attribute__] = ACTIONS(3018),
    [anon_sym_COLON_COLON] = ACTIONS(3020),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3020),
    [anon_sym___declspec] = ACTIONS(3018),
    [anon_sym_LBRACE] = ACTIONS(3020),
    [anon_sym_signed] = ACTIONS(3018),
    [anon_sym_unsigned] = ACTIONS(3018),
    [anon_sym_long] = ACTIONS(3018),
    [anon_sym_short] = ACTIONS(3018),
    [anon_sym_LBRACK] = ACTIONS(3018),
    [anon_sym_static] = ACTIONS(3018),
    [anon_sym_register] = ACTIONS(3018),
    [anon_sym_inline] = ACTIONS(3018),
    [anon_sym___inline] = ACTIONS(3018),
    [anon_sym___inline__] = ACTIONS(3018),
    [anon_sym___forceinline] = ACTIONS(3018),
    [anon_sym_thread_local] = ACTIONS(3018),
    [anon_sym___thread] = ACTIONS(3018),
    [anon_sym_const] = ACTIONS(3018),
    [anon_sym_constexpr] = ACTIONS(3018),
    [anon_sym_volatile] = ACTIONS(3018),
    [anon_sym_restrict] = ACTIONS(3018),
    [anon_sym___restrict__] = ACTIONS(3018),
    [anon_sym__Atomic] = ACTIONS(3018),
    [anon_sym__Noreturn] = ACTIONS(3018),
    [anon_sym_noreturn] = ACTIONS(3018),
    [anon_sym_mutable] = ACTIONS(3018),
    [anon_sym_constinit] = ACTIONS(3018),
    [anon_sym_consteval] = ACTIONS(3018),
    [anon_sym_alignas] = ACTIONS(3018),
    [anon_sym__Alignas] = ACTIONS(3018),
    [sym_primitive_type] = ACTIONS(3018),
    [anon_sym_enum] = ACTIONS(3018),
    [anon_sym_class] = ACTIONS(3018),
    [anon_sym_struct] = ACTIONS(3018),
    [anon_sym_union] = ACTIONS(3018),
    [anon_sym_if] = ACTIONS(3018),
    [anon_sym_else] = ACTIONS(3018),
    [anon_sym_switch] = ACTIONS(3018),
    [anon_sym_while] = ACTIONS(3018),
    [anon_sym_do] = ACTIONS(3018),
    [anon_sym_for] = ACTIONS(3018),
    [anon_sym_return] = ACTIONS(3018),
    [anon_sym_break] = ACTIONS(3018),
    [anon_sym_continue] = ACTIONS(3018),
    [anon_sym_goto] = ACTIONS(3018),
    [anon_sym___try] = ACTIONS(3018),
    [anon_sym___leave] = ACTIONS(3018),
    [anon_sym_not] = ACTIONS(3018),
    [anon_sym_compl] = ACTIONS(3018),
    [anon_sym_DASH_DASH] = ACTIONS(3020),
    [anon_sym_PLUS_PLUS] = ACTIONS(3020),
    [anon_sym_sizeof] = ACTIONS(3018),
    [anon_sym___alignof__] = ACTIONS(3018),
    [anon_sym___alignof] = ACTIONS(3018),
    [anon_sym__alignof] = ACTIONS(3018),
    [anon_sym_alignof] = ACTIONS(3018),
    [anon_sym__Alignof] = ACTIONS(3018),
    [anon_sym_offsetof] = ACTIONS(3018),
    [anon_sym__Generic] = ACTIONS(3018),
    [anon_sym_asm] = ACTIONS(3018),
    [anon_sym___asm__] = ACTIONS(3018),
    [sym_number_literal] = ACTIONS(3020),
    [anon_sym_L_SQUOTE] = ACTIONS(3020),
    [anon_sym_u_SQUOTE] = ACTIONS(3020),
    [anon_sym_U_SQUOTE] = ACTIONS(3020),
    [anon_sym_u8_SQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3020),
    [anon_sym_L_DQUOTE] = ACTIONS(3020),
    [anon_sym_u_DQUOTE] = ACTIONS(3020),
    [anon_sym_U_DQUOTE] = ACTIONS(3020),
    [anon_sym_u8_DQUOTE] = ACTIONS(3020),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3018),
    [anon_sym_nullptr] = ACTIONS(3018),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3018),
    [anon_sym_let] = ACTIONS(3018),
    [anon_sym_This] = ACTIONS(3018),
    [anon_sym_decltype] = ACTIONS(3018),
    [sym_virtual] = ACTIONS(3018),
    [anon_sym_typename] = ACTIONS(3018),
    [anon_sym_template] = ACTIONS(3018),
    [anon_sym_try] = ACTIONS(3018),
    [anon_sym_delete] = ACTIONS(3018),
    [anon_sym_throw] = ACTIONS(3018),
    [anon_sym_co_return] = ACTIONS(3018),
    [anon_sym_co_yield] = ACTIONS(3018),
    [anon_sym_R_DQUOTE] = ACTIONS(3020),
    [anon_sym_LR_DQUOTE] = ACTIONS(3020),
    [anon_sym_uR_DQUOTE] = ACTIONS(3020),
    [anon_sym_UR_DQUOTE] = ACTIONS(3020),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3020),
    [anon_sym_co_await] = ACTIONS(3018),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_requires] = ACTIONS(3018),
    [sym_this] = ACTIONS(3018),
    [anon_sym_discard] = ACTIONS(3018),
    [anon_sym_precise] = ACTIONS(3018),
    [anon_sym_shared] = ACTIONS(3018),
    [anon_sym_groupshared] = ACTIONS(3018),
    [anon_sym_uniform] = ACTIONS(3018),
    [anon_sym_row_major] = ACTIONS(3018),
    [anon_sym_column_major] = ACTIONS(3018),
    [anon_sym_globallycoherent] = ACTIONS(3018),
    [anon_sym_centroid] = ACTIONS(3018),
    [anon_sym_noperspective] = ACTIONS(3018),
    [anon_sym_nointerpolation] = ACTIONS(3018),
    [anon_sym_sample] = ACTIONS(3018),
    [anon_sym_linear] = ACTIONS(3018),
    [anon_sym_snorm] = ACTIONS(3018),
    [anon_sym_unorm] = ACTIONS(3018),
    [anon_sym_point] = ACTIONS(3018),
    [anon_sym_line] = ACTIONS(3018),
    [anon_sym_triangleadj] = ACTIONS(3018),
    [anon_sym_lineadj] = ACTIONS(3018),
    [anon_sym_triangle] = ACTIONS(3018),
    [anon_sym_cbuffer] = ACTIONS(3018),
    [anon_sym_interface] = ACTIONS(3018),
    [anon_sym_extension] = ACTIONS(3018),
  },
  [1285] = {
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3316),
    [anon_sym_BANG] = ACTIONS(3316),
    [anon_sym_TILDE] = ACTIONS(3316),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_STAR] = ACTIONS(3316),
    [anon_sym_AMP] = ACTIONS(3316),
    [anon_sym_SEMI] = ACTIONS(3316),
    [anon_sym___extension__] = ACTIONS(3314),
    [anon_sym_typedef] = ACTIONS(3314),
    [anon_sym_in] = ACTIONS(3314),
    [anon_sym_out] = ACTIONS(3314),
    [anon_sym_inout] = ACTIONS(3314),
    [anon_sym_extern] = ACTIONS(3314),
    [anon_sym___attribute__] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3316),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3316),
    [anon_sym___declspec] = ACTIONS(3314),
    [anon_sym_LBRACE] = ACTIONS(3316),
    [anon_sym_signed] = ACTIONS(3314),
    [anon_sym_unsigned] = ACTIONS(3314),
    [anon_sym_long] = ACTIONS(3314),
    [anon_sym_short] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_static] = ACTIONS(3314),
    [anon_sym_register] = ACTIONS(3314),
    [anon_sym_inline] = ACTIONS(3314),
    [anon_sym___inline] = ACTIONS(3314),
    [anon_sym___inline__] = ACTIONS(3314),
    [anon_sym___forceinline] = ACTIONS(3314),
    [anon_sym_thread_local] = ACTIONS(3314),
    [anon_sym___thread] = ACTIONS(3314),
    [anon_sym_const] = ACTIONS(3314),
    [anon_sym_constexpr] = ACTIONS(3314),
    [anon_sym_volatile] = ACTIONS(3314),
    [anon_sym_restrict] = ACTIONS(3314),
    [anon_sym___restrict__] = ACTIONS(3314),
    [anon_sym__Atomic] = ACTIONS(3314),
    [anon_sym__Noreturn] = ACTIONS(3314),
    [anon_sym_noreturn] = ACTIONS(3314),
    [anon_sym_mutable] = ACTIONS(3314),
    [anon_sym_constinit] = ACTIONS(3314),
    [anon_sym_consteval] = ACTIONS(3314),
    [anon_sym_alignas] = ACTIONS(3314),
    [anon_sym__Alignas] = ACTIONS(3314),
    [sym_primitive_type] = ACTIONS(3314),
    [anon_sym_enum] = ACTIONS(3314),
    [anon_sym_class] = ACTIONS(3314),
    [anon_sym_struct] = ACTIONS(3314),
    [anon_sym_union] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_else] = ACTIONS(3314),
    [anon_sym_switch] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_break] = ACTIONS(3314),
    [anon_sym_continue] = ACTIONS(3314),
    [anon_sym_goto] = ACTIONS(3314),
    [anon_sym___try] = ACTIONS(3314),
    [anon_sym___leave] = ACTIONS(3314),
    [anon_sym_not] = ACTIONS(3314),
    [anon_sym_compl] = ACTIONS(3314),
    [anon_sym_DASH_DASH] = ACTIONS(3316),
    [anon_sym_PLUS_PLUS] = ACTIONS(3316),
    [anon_sym_sizeof] = ACTIONS(3314),
    [anon_sym___alignof__] = ACTIONS(3314),
    [anon_sym___alignof] = ACTIONS(3314),
    [anon_sym__alignof] = ACTIONS(3314),
    [anon_sym_alignof] = ACTIONS(3314),
    [anon_sym__Alignof] = ACTIONS(3314),
    [anon_sym_offsetof] = ACTIONS(3314),
    [anon_sym__Generic] = ACTIONS(3314),
    [anon_sym_asm] = ACTIONS(3314),
    [anon_sym___asm__] = ACTIONS(3314),
    [sym_number_literal] = ACTIONS(3316),
    [anon_sym_L_SQUOTE] = ACTIONS(3316),
    [anon_sym_u_SQUOTE] = ACTIONS(3316),
    [anon_sym_U_SQUOTE] = ACTIONS(3316),
    [anon_sym_u8_SQUOTE] = ACTIONS(3316),
    [anon_sym_SQUOTE] = ACTIONS(3316),
    [anon_sym_L_DQUOTE] = ACTIONS(3316),
    [anon_sym_u_DQUOTE] = ACTIONS(3316),
    [anon_sym_U_DQUOTE] = ACTIONS(3316),
    [anon_sym_u8_DQUOTE] = ACTIONS(3316),
    [anon_sym_DQUOTE] = ACTIONS(3316),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [anon_sym_NULL] = ACTIONS(3314),
    [anon_sym_nullptr] = ACTIONS(3314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_This] = ACTIONS(3314),
    [anon_sym_decltype] = ACTIONS(3314),
    [sym_virtual] = ACTIONS(3314),
    [anon_sym_typename] = ACTIONS(3314),
    [anon_sym_template] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_delete] = ACTIONS(3314),
    [anon_sym_throw] = ACTIONS(3314),
    [anon_sym_co_return] = ACTIONS(3314),
    [anon_sym_co_yield] = ACTIONS(3314),
    [anon_sym_R_DQUOTE] = ACTIONS(3316),
    [anon_sym_LR_DQUOTE] = ACTIONS(3316),
    [anon_sym_uR_DQUOTE] = ACTIONS(3316),
    [anon_sym_UR_DQUOTE] = ACTIONS(3316),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3316),
    [anon_sym_co_await] = ACTIONS(3314),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_requires] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [anon_sym_discard] = ACTIONS(3314),
    [anon_sym_precise] = ACTIONS(3314),
    [anon_sym_shared] = ACTIONS(3314),
    [anon_sym_groupshared] = ACTIONS(3314),
    [anon_sym_uniform] = ACTIONS(3314),
    [anon_sym_row_major] = ACTIONS(3314),
    [anon_sym_column_major] = ACTIONS(3314),
    [anon_sym_globallycoherent] = ACTIONS(3314),
    [anon_sym_centroid] = ACTIONS(3314),
    [anon_sym_noperspective] = ACTIONS(3314),
    [anon_sym_nointerpolation] = ACTIONS(3314),
    [anon_sym_sample] = ACTIONS(3314),
    [anon_sym_linear] = ACTIONS(3314),
    [anon_sym_snorm] = ACTIONS(3314),
    [anon_sym_unorm] = ACTIONS(3314),
    [anon_sym_point] = ACTIONS(3314),
    [anon_sym_line] = ACTIONS(3314),
    [anon_sym_triangleadj] = ACTIONS(3314),
    [anon_sym_lineadj] = ACTIONS(3314),
    [anon_sym_triangle] = ACTIONS(3314),
    [anon_sym_cbuffer] = ACTIONS(3314),
    [anon_sym_interface] = ACTIONS(3314),
    [anon_sym_extension] = ACTIONS(3314),
  },
  [1286] = {
    [sym_identifier] = ACTIONS(2950),
    [anon_sym_LPAREN2] = ACTIONS(2952),
    [anon_sym_BANG] = ACTIONS(2952),
    [anon_sym_TILDE] = ACTIONS(2952),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_STAR] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2952),
    [anon_sym_SEMI] = ACTIONS(2952),
    [anon_sym___extension__] = ACTIONS(2950),
    [anon_sym_typedef] = ACTIONS(2950),
    [anon_sym_in] = ACTIONS(2950),
    [anon_sym_out] = ACTIONS(2950),
    [anon_sym_inout] = ACTIONS(2950),
    [anon_sym_extern] = ACTIONS(2950),
    [anon_sym___attribute__] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2952),
    [anon_sym___declspec] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2952),
    [anon_sym_signed] = ACTIONS(2950),
    [anon_sym_unsigned] = ACTIONS(2950),
    [anon_sym_long] = ACTIONS(2950),
    [anon_sym_short] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_static] = ACTIONS(2950),
    [anon_sym_register] = ACTIONS(2950),
    [anon_sym_inline] = ACTIONS(2950),
    [anon_sym___inline] = ACTIONS(2950),
    [anon_sym___inline__] = ACTIONS(2950),
    [anon_sym___forceinline] = ACTIONS(2950),
    [anon_sym_thread_local] = ACTIONS(2950),
    [anon_sym___thread] = ACTIONS(2950),
    [anon_sym_const] = ACTIONS(2950),
    [anon_sym_constexpr] = ACTIONS(2950),
    [anon_sym_volatile] = ACTIONS(2950),
    [anon_sym_restrict] = ACTIONS(2950),
    [anon_sym___restrict__] = ACTIONS(2950),
    [anon_sym__Atomic] = ACTIONS(2950),
    [anon_sym__Noreturn] = ACTIONS(2950),
    [anon_sym_noreturn] = ACTIONS(2950),
    [anon_sym_mutable] = ACTIONS(2950),
    [anon_sym_constinit] = ACTIONS(2950),
    [anon_sym_consteval] = ACTIONS(2950),
    [anon_sym_alignas] = ACTIONS(2950),
    [anon_sym__Alignas] = ACTIONS(2950),
    [sym_primitive_type] = ACTIONS(2950),
    [anon_sym_enum] = ACTIONS(2950),
    [anon_sym_class] = ACTIONS(2950),
    [anon_sym_struct] = ACTIONS(2950),
    [anon_sym_union] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_else] = ACTIONS(2950),
    [anon_sym_switch] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_break] = ACTIONS(2950),
    [anon_sym_continue] = ACTIONS(2950),
    [anon_sym_goto] = ACTIONS(2950),
    [anon_sym___try] = ACTIONS(2950),
    [anon_sym___leave] = ACTIONS(2950),
    [anon_sym_not] = ACTIONS(2950),
    [anon_sym_compl] = ACTIONS(2950),
    [anon_sym_DASH_DASH] = ACTIONS(2952),
    [anon_sym_PLUS_PLUS] = ACTIONS(2952),
    [anon_sym_sizeof] = ACTIONS(2950),
    [anon_sym___alignof__] = ACTIONS(2950),
    [anon_sym___alignof] = ACTIONS(2950),
    [anon_sym__alignof] = ACTIONS(2950),
    [anon_sym_alignof] = ACTIONS(2950),
    [anon_sym__Alignof] = ACTIONS(2950),
    [anon_sym_offsetof] = ACTIONS(2950),
    [anon_sym__Generic] = ACTIONS(2950),
    [anon_sym_asm] = ACTIONS(2950),
    [anon_sym___asm__] = ACTIONS(2950),
    [sym_number_literal] = ACTIONS(2952),
    [anon_sym_L_SQUOTE] = ACTIONS(2952),
    [anon_sym_u_SQUOTE] = ACTIONS(2952),
    [anon_sym_U_SQUOTE] = ACTIONS(2952),
    [anon_sym_u8_SQUOTE] = ACTIONS(2952),
    [anon_sym_SQUOTE] = ACTIONS(2952),
    [anon_sym_L_DQUOTE] = ACTIONS(2952),
    [anon_sym_u_DQUOTE] = ACTIONS(2952),
    [anon_sym_U_DQUOTE] = ACTIONS(2952),
    [anon_sym_u8_DQUOTE] = ACTIONS(2952),
    [anon_sym_DQUOTE] = ACTIONS(2952),
    [sym_true] = ACTIONS(2950),
    [sym_false] = ACTIONS(2950),
    [anon_sym_NULL] = ACTIONS(2950),
    [anon_sym_nullptr] = ACTIONS(2950),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2950),
    [anon_sym_let] = ACTIONS(2950),
    [anon_sym_This] = ACTIONS(2950),
    [anon_sym_decltype] = ACTIONS(2950),
    [sym_virtual] = ACTIONS(2950),
    [anon_sym_typename] = ACTIONS(2950),
    [anon_sym_template] = ACTIONS(2950),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_delete] = ACTIONS(2950),
    [anon_sym_throw] = ACTIONS(2950),
    [anon_sym_co_return] = ACTIONS(2950),
    [anon_sym_co_yield] = ACTIONS(2950),
    [anon_sym_R_DQUOTE] = ACTIONS(2952),
    [anon_sym_LR_DQUOTE] = ACTIONS(2952),
    [anon_sym_uR_DQUOTE] = ACTIONS(2952),
    [anon_sym_UR_DQUOTE] = ACTIONS(2952),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2952),
    [anon_sym_co_await] = ACTIONS(2950),
    [anon_sym_new] = ACTIONS(2950),
    [anon_sym_requires] = ACTIONS(2950),
    [sym_this] = ACTIONS(2950),
    [anon_sym_discard] = ACTIONS(2950),
    [anon_sym_precise] = ACTIONS(2950),
    [anon_sym_shared] = ACTIONS(2950),
    [anon_sym_groupshared] = ACTIONS(2950),
    [anon_sym_uniform] = ACTIONS(2950),
    [anon_sym_row_major] = ACTIONS(2950),
    [anon_sym_column_major] = ACTIONS(2950),
    [anon_sym_globallycoherent] = ACTIONS(2950),
    [anon_sym_centroid] = ACTIONS(2950),
    [anon_sym_noperspective] = ACTIONS(2950),
    [anon_sym_nointerpolation] = ACTIONS(2950),
    [anon_sym_sample] = ACTIONS(2950),
    [anon_sym_linear] = ACTIONS(2950),
    [anon_sym_snorm] = ACTIONS(2950),
    [anon_sym_unorm] = ACTIONS(2950),
    [anon_sym_point] = ACTIONS(2950),
    [anon_sym_line] = ACTIONS(2950),
    [anon_sym_triangleadj] = ACTIONS(2950),
    [anon_sym_lineadj] = ACTIONS(2950),
    [anon_sym_triangle] = ACTIONS(2950),
    [anon_sym_cbuffer] = ACTIONS(2950),
    [anon_sym_interface] = ACTIONS(2950),
    [anon_sym_extension] = ACTIONS(2950),
  },
  [1287] = {
    [sym_identifier] = ACTIONS(2954),
    [anon_sym_LPAREN2] = ACTIONS(2956),
    [anon_sym_BANG] = ACTIONS(2956),
    [anon_sym_TILDE] = ACTIONS(2956),
    [anon_sym_DASH] = ACTIONS(2954),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_STAR] = ACTIONS(2956),
    [anon_sym_AMP] = ACTIONS(2956),
    [anon_sym_SEMI] = ACTIONS(2956),
    [anon_sym___extension__] = ACTIONS(2954),
    [anon_sym_typedef] = ACTIONS(2954),
    [anon_sym_in] = ACTIONS(2954),
    [anon_sym_out] = ACTIONS(2954),
    [anon_sym_inout] = ACTIONS(2954),
    [anon_sym_extern] = ACTIONS(2954),
    [anon_sym___attribute__] = ACTIONS(2954),
    [anon_sym_COLON_COLON] = ACTIONS(2956),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2956),
    [anon_sym___declspec] = ACTIONS(2954),
    [anon_sym_LBRACE] = ACTIONS(2956),
    [anon_sym_signed] = ACTIONS(2954),
    [anon_sym_unsigned] = ACTIONS(2954),
    [anon_sym_long] = ACTIONS(2954),
    [anon_sym_short] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_static] = ACTIONS(2954),
    [anon_sym_register] = ACTIONS(2954),
    [anon_sym_inline] = ACTIONS(2954),
    [anon_sym___inline] = ACTIONS(2954),
    [anon_sym___inline__] = ACTIONS(2954),
    [anon_sym___forceinline] = ACTIONS(2954),
    [anon_sym_thread_local] = ACTIONS(2954),
    [anon_sym___thread] = ACTIONS(2954),
    [anon_sym_const] = ACTIONS(2954),
    [anon_sym_constexpr] = ACTIONS(2954),
    [anon_sym_volatile] = ACTIONS(2954),
    [anon_sym_restrict] = ACTIONS(2954),
    [anon_sym___restrict__] = ACTIONS(2954),
    [anon_sym__Atomic] = ACTIONS(2954),
    [anon_sym__Noreturn] = ACTIONS(2954),
    [anon_sym_noreturn] = ACTIONS(2954),
    [anon_sym_mutable] = ACTIONS(2954),
    [anon_sym_constinit] = ACTIONS(2954),
    [anon_sym_consteval] = ACTIONS(2954),
    [anon_sym_alignas] = ACTIONS(2954),
    [anon_sym__Alignas] = ACTIONS(2954),
    [sym_primitive_type] = ACTIONS(2954),
    [anon_sym_enum] = ACTIONS(2954),
    [anon_sym_class] = ACTIONS(2954),
    [anon_sym_struct] = ACTIONS(2954),
    [anon_sym_union] = ACTIONS(2954),
    [anon_sym_if] = ACTIONS(2954),
    [anon_sym_else] = ACTIONS(2954),
    [anon_sym_switch] = ACTIONS(2954),
    [anon_sym_while] = ACTIONS(2954),
    [anon_sym_do] = ACTIONS(2954),
    [anon_sym_for] = ACTIONS(2954),
    [anon_sym_return] = ACTIONS(2954),
    [anon_sym_break] = ACTIONS(2954),
    [anon_sym_continue] = ACTIONS(2954),
    [anon_sym_goto] = ACTIONS(2954),
    [anon_sym___try] = ACTIONS(2954),
    [anon_sym___leave] = ACTIONS(2954),
    [anon_sym_not] = ACTIONS(2954),
    [anon_sym_compl] = ACTIONS(2954),
    [anon_sym_DASH_DASH] = ACTIONS(2956),
    [anon_sym_PLUS_PLUS] = ACTIONS(2956),
    [anon_sym_sizeof] = ACTIONS(2954),
    [anon_sym___alignof__] = ACTIONS(2954),
    [anon_sym___alignof] = ACTIONS(2954),
    [anon_sym__alignof] = ACTIONS(2954),
    [anon_sym_alignof] = ACTIONS(2954),
    [anon_sym__Alignof] = ACTIONS(2954),
    [anon_sym_offsetof] = ACTIONS(2954),
    [anon_sym__Generic] = ACTIONS(2954),
    [anon_sym_asm] = ACTIONS(2954),
    [anon_sym___asm__] = ACTIONS(2954),
    [sym_number_literal] = ACTIONS(2956),
    [anon_sym_L_SQUOTE] = ACTIONS(2956),
    [anon_sym_u_SQUOTE] = ACTIONS(2956),
    [anon_sym_U_SQUOTE] = ACTIONS(2956),
    [anon_sym_u8_SQUOTE] = ACTIONS(2956),
    [anon_sym_SQUOTE] = ACTIONS(2956),
    [anon_sym_L_DQUOTE] = ACTIONS(2956),
    [anon_sym_u_DQUOTE] = ACTIONS(2956),
    [anon_sym_U_DQUOTE] = ACTIONS(2956),
    [anon_sym_u8_DQUOTE] = ACTIONS(2956),
    [anon_sym_DQUOTE] = ACTIONS(2956),
    [sym_true] = ACTIONS(2954),
    [sym_false] = ACTIONS(2954),
    [anon_sym_NULL] = ACTIONS(2954),
    [anon_sym_nullptr] = ACTIONS(2954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2954),
    [anon_sym_let] = ACTIONS(2954),
    [anon_sym_This] = ACTIONS(2954),
    [anon_sym_decltype] = ACTIONS(2954),
    [sym_virtual] = ACTIONS(2954),
    [anon_sym_typename] = ACTIONS(2954),
    [anon_sym_template] = ACTIONS(2954),
    [anon_sym_try] = ACTIONS(2954),
    [anon_sym_delete] = ACTIONS(2954),
    [anon_sym_throw] = ACTIONS(2954),
    [anon_sym_co_return] = ACTIONS(2954),
    [anon_sym_co_yield] = ACTIONS(2954),
    [anon_sym_R_DQUOTE] = ACTIONS(2956),
    [anon_sym_LR_DQUOTE] = ACTIONS(2956),
    [anon_sym_uR_DQUOTE] = ACTIONS(2956),
    [anon_sym_UR_DQUOTE] = ACTIONS(2956),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2956),
    [anon_sym_co_await] = ACTIONS(2954),
    [anon_sym_new] = ACTIONS(2954),
    [anon_sym_requires] = ACTIONS(2954),
    [sym_this] = ACTIONS(2954),
    [anon_sym_discard] = ACTIONS(2954),
    [anon_sym_precise] = ACTIONS(2954),
    [anon_sym_shared] = ACTIONS(2954),
    [anon_sym_groupshared] = ACTIONS(2954),
    [anon_sym_uniform] = ACTIONS(2954),
    [anon_sym_row_major] = ACTIONS(2954),
    [anon_sym_column_major] = ACTIONS(2954),
    [anon_sym_globallycoherent] = ACTIONS(2954),
    [anon_sym_centroid] = ACTIONS(2954),
    [anon_sym_noperspective] = ACTIONS(2954),
    [anon_sym_nointerpolation] = ACTIONS(2954),
    [anon_sym_sample] = ACTIONS(2954),
    [anon_sym_linear] = ACTIONS(2954),
    [anon_sym_snorm] = ACTIONS(2954),
    [anon_sym_unorm] = ACTIONS(2954),
    [anon_sym_point] = ACTIONS(2954),
    [anon_sym_line] = ACTIONS(2954),
    [anon_sym_triangleadj] = ACTIONS(2954),
    [anon_sym_lineadj] = ACTIONS(2954),
    [anon_sym_triangle] = ACTIONS(2954),
    [anon_sym_cbuffer] = ACTIONS(2954),
    [anon_sym_interface] = ACTIONS(2954),
    [anon_sym_extension] = ACTIONS(2954),
  },
  [1288] = {
    [sym_identifier] = ACTIONS(2972),
    [anon_sym_LPAREN2] = ACTIONS(2974),
    [anon_sym_BANG] = ACTIONS(2974),
    [anon_sym_TILDE] = ACTIONS(2974),
    [anon_sym_DASH] = ACTIONS(2972),
    [anon_sym_PLUS] = ACTIONS(2972),
    [anon_sym_STAR] = ACTIONS(2974),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_SEMI] = ACTIONS(2974),
    [anon_sym___extension__] = ACTIONS(2972),
    [anon_sym_typedef] = ACTIONS(2972),
    [anon_sym_in] = ACTIONS(2972),
    [anon_sym_out] = ACTIONS(2972),
    [anon_sym_inout] = ACTIONS(2972),
    [anon_sym_extern] = ACTIONS(2972),
    [anon_sym___attribute__] = ACTIONS(2972),
    [anon_sym_COLON_COLON] = ACTIONS(2974),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2974),
    [anon_sym___declspec] = ACTIONS(2972),
    [anon_sym_LBRACE] = ACTIONS(2974),
    [anon_sym_signed] = ACTIONS(2972),
    [anon_sym_unsigned] = ACTIONS(2972),
    [anon_sym_long] = ACTIONS(2972),
    [anon_sym_short] = ACTIONS(2972),
    [anon_sym_LBRACK] = ACTIONS(2972),
    [anon_sym_static] = ACTIONS(2972),
    [anon_sym_register] = ACTIONS(2972),
    [anon_sym_inline] = ACTIONS(2972),
    [anon_sym___inline] = ACTIONS(2972),
    [anon_sym___inline__] = ACTIONS(2972),
    [anon_sym___forceinline] = ACTIONS(2972),
    [anon_sym_thread_local] = ACTIONS(2972),
    [anon_sym___thread] = ACTIONS(2972),
    [anon_sym_const] = ACTIONS(2972),
    [anon_sym_constexpr] = ACTIONS(2972),
    [anon_sym_volatile] = ACTIONS(2972),
    [anon_sym_restrict] = ACTIONS(2972),
    [anon_sym___restrict__] = ACTIONS(2972),
    [anon_sym__Atomic] = ACTIONS(2972),
    [anon_sym__Noreturn] = ACTIONS(2972),
    [anon_sym_noreturn] = ACTIONS(2972),
    [anon_sym_mutable] = ACTIONS(2972),
    [anon_sym_constinit] = ACTIONS(2972),
    [anon_sym_consteval] = ACTIONS(2972),
    [anon_sym_alignas] = ACTIONS(2972),
    [anon_sym__Alignas] = ACTIONS(2972),
    [sym_primitive_type] = ACTIONS(2972),
    [anon_sym_enum] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(2972),
    [anon_sym_struct] = ACTIONS(2972),
    [anon_sym_union] = ACTIONS(2972),
    [anon_sym_if] = ACTIONS(2972),
    [anon_sym_else] = ACTIONS(2972),
    [anon_sym_switch] = ACTIONS(2972),
    [anon_sym_while] = ACTIONS(2972),
    [anon_sym_do] = ACTIONS(2972),
    [anon_sym_for] = ACTIONS(2972),
    [anon_sym_return] = ACTIONS(2972),
    [anon_sym_break] = ACTIONS(2972),
    [anon_sym_continue] = ACTIONS(2972),
    [anon_sym_goto] = ACTIONS(2972),
    [anon_sym___try] = ACTIONS(2972),
    [anon_sym___leave] = ACTIONS(2972),
    [anon_sym_not] = ACTIONS(2972),
    [anon_sym_compl] = ACTIONS(2972),
    [anon_sym_DASH_DASH] = ACTIONS(2974),
    [anon_sym_PLUS_PLUS] = ACTIONS(2974),
    [anon_sym_sizeof] = ACTIONS(2972),
    [anon_sym___alignof__] = ACTIONS(2972),
    [anon_sym___alignof] = ACTIONS(2972),
    [anon_sym__alignof] = ACTIONS(2972),
    [anon_sym_alignof] = ACTIONS(2972),
    [anon_sym__Alignof] = ACTIONS(2972),
    [anon_sym_offsetof] = ACTIONS(2972),
    [anon_sym__Generic] = ACTIONS(2972),
    [anon_sym_asm] = ACTIONS(2972),
    [anon_sym___asm__] = ACTIONS(2972),
    [sym_number_literal] = ACTIONS(2974),
    [anon_sym_L_SQUOTE] = ACTIONS(2974),
    [anon_sym_u_SQUOTE] = ACTIONS(2974),
    [anon_sym_U_SQUOTE] = ACTIONS(2974),
    [anon_sym_u8_SQUOTE] = ACTIONS(2974),
    [anon_sym_SQUOTE] = ACTIONS(2974),
    [anon_sym_L_DQUOTE] = ACTIONS(2974),
    [anon_sym_u_DQUOTE] = ACTIONS(2974),
    [anon_sym_U_DQUOTE] = ACTIONS(2974),
    [anon_sym_u8_DQUOTE] = ACTIONS(2974),
    [anon_sym_DQUOTE] = ACTIONS(2974),
    [sym_true] = ACTIONS(2972),
    [sym_false] = ACTIONS(2972),
    [anon_sym_NULL] = ACTIONS(2972),
    [anon_sym_nullptr] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2972),
    [anon_sym_let] = ACTIONS(2972),
    [anon_sym_This] = ACTIONS(2972),
    [anon_sym_decltype] = ACTIONS(2972),
    [sym_virtual] = ACTIONS(2972),
    [anon_sym_typename] = ACTIONS(2972),
    [anon_sym_template] = ACTIONS(2972),
    [anon_sym_try] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2972),
    [anon_sym_throw] = ACTIONS(2972),
    [anon_sym_co_return] = ACTIONS(2972),
    [anon_sym_co_yield] = ACTIONS(2972),
    [anon_sym_R_DQUOTE] = ACTIONS(2974),
    [anon_sym_LR_DQUOTE] = ACTIONS(2974),
    [anon_sym_uR_DQUOTE] = ACTIONS(2974),
    [anon_sym_UR_DQUOTE] = ACTIONS(2974),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2974),
    [anon_sym_co_await] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2972),
    [anon_sym_requires] = ACTIONS(2972),
    [sym_this] = ACTIONS(2972),
    [anon_sym_discard] = ACTIONS(2972),
    [anon_sym_precise] = ACTIONS(2972),
    [anon_sym_shared] = ACTIONS(2972),
    [anon_sym_groupshared] = ACTIONS(2972),
    [anon_sym_uniform] = ACTIONS(2972),
    [anon_sym_row_major] = ACTIONS(2972),
    [anon_sym_column_major] = ACTIONS(2972),
    [anon_sym_globallycoherent] = ACTIONS(2972),
    [anon_sym_centroid] = ACTIONS(2972),
    [anon_sym_noperspective] = ACTIONS(2972),
    [anon_sym_nointerpolation] = ACTIONS(2972),
    [anon_sym_sample] = ACTIONS(2972),
    [anon_sym_linear] = ACTIONS(2972),
    [anon_sym_snorm] = ACTIONS(2972),
    [anon_sym_unorm] = ACTIONS(2972),
    [anon_sym_point] = ACTIONS(2972),
    [anon_sym_line] = ACTIONS(2972),
    [anon_sym_triangleadj] = ACTIONS(2972),
    [anon_sym_lineadj] = ACTIONS(2972),
    [anon_sym_triangle] = ACTIONS(2972),
    [anon_sym_cbuffer] = ACTIONS(2972),
    [anon_sym_interface] = ACTIONS(2972),
    [anon_sym_extension] = ACTIONS(2972),
  },
  [1289] = {
    [sym_identifier] = ACTIONS(3014),
    [anon_sym_LPAREN2] = ACTIONS(3016),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [anon_sym_DASH] = ACTIONS(3014),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_STAR] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3016),
    [anon_sym_SEMI] = ACTIONS(3016),
    [anon_sym___extension__] = ACTIONS(3014),
    [anon_sym_typedef] = ACTIONS(3014),
    [anon_sym_in] = ACTIONS(3014),
    [anon_sym_out] = ACTIONS(3014),
    [anon_sym_inout] = ACTIONS(3014),
    [anon_sym_extern] = ACTIONS(3014),
    [anon_sym___attribute__] = ACTIONS(3014),
    [anon_sym_COLON_COLON] = ACTIONS(3016),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3016),
    [anon_sym___declspec] = ACTIONS(3014),
    [anon_sym_LBRACE] = ACTIONS(3016),
    [anon_sym_signed] = ACTIONS(3014),
    [anon_sym_unsigned] = ACTIONS(3014),
    [anon_sym_long] = ACTIONS(3014),
    [anon_sym_short] = ACTIONS(3014),
    [anon_sym_LBRACK] = ACTIONS(3014),
    [anon_sym_static] = ACTIONS(3014),
    [anon_sym_register] = ACTIONS(3014),
    [anon_sym_inline] = ACTIONS(3014),
    [anon_sym___inline] = ACTIONS(3014),
    [anon_sym___inline__] = ACTIONS(3014),
    [anon_sym___forceinline] = ACTIONS(3014),
    [anon_sym_thread_local] = ACTIONS(3014),
    [anon_sym___thread] = ACTIONS(3014),
    [anon_sym_const] = ACTIONS(3014),
    [anon_sym_constexpr] = ACTIONS(3014),
    [anon_sym_volatile] = ACTIONS(3014),
    [anon_sym_restrict] = ACTIONS(3014),
    [anon_sym___restrict__] = ACTIONS(3014),
    [anon_sym__Atomic] = ACTIONS(3014),
    [anon_sym__Noreturn] = ACTIONS(3014),
    [anon_sym_noreturn] = ACTIONS(3014),
    [anon_sym_mutable] = ACTIONS(3014),
    [anon_sym_constinit] = ACTIONS(3014),
    [anon_sym_consteval] = ACTIONS(3014),
    [anon_sym_alignas] = ACTIONS(3014),
    [anon_sym__Alignas] = ACTIONS(3014),
    [sym_primitive_type] = ACTIONS(3014),
    [anon_sym_enum] = ACTIONS(3014),
    [anon_sym_class] = ACTIONS(3014),
    [anon_sym_struct] = ACTIONS(3014),
    [anon_sym_union] = ACTIONS(3014),
    [anon_sym_if] = ACTIONS(3014),
    [anon_sym_else] = ACTIONS(3014),
    [anon_sym_switch] = ACTIONS(3014),
    [anon_sym_while] = ACTIONS(3014),
    [anon_sym_do] = ACTIONS(3014),
    [anon_sym_for] = ACTIONS(3014),
    [anon_sym_return] = ACTIONS(3014),
    [anon_sym_break] = ACTIONS(3014),
    [anon_sym_continue] = ACTIONS(3014),
    [anon_sym_goto] = ACTIONS(3014),
    [anon_sym___try] = ACTIONS(3014),
    [anon_sym___leave] = ACTIONS(3014),
    [anon_sym_not] = ACTIONS(3014),
    [anon_sym_compl] = ACTIONS(3014),
    [anon_sym_DASH_DASH] = ACTIONS(3016),
    [anon_sym_PLUS_PLUS] = ACTIONS(3016),
    [anon_sym_sizeof] = ACTIONS(3014),
    [anon_sym___alignof__] = ACTIONS(3014),
    [anon_sym___alignof] = ACTIONS(3014),
    [anon_sym__alignof] = ACTIONS(3014),
    [anon_sym_alignof] = ACTIONS(3014),
    [anon_sym__Alignof] = ACTIONS(3014),
    [anon_sym_offsetof] = ACTIONS(3014),
    [anon_sym__Generic] = ACTIONS(3014),
    [anon_sym_asm] = ACTIONS(3014),
    [anon_sym___asm__] = ACTIONS(3014),
    [sym_number_literal] = ACTIONS(3016),
    [anon_sym_L_SQUOTE] = ACTIONS(3016),
    [anon_sym_u_SQUOTE] = ACTIONS(3016),
    [anon_sym_U_SQUOTE] = ACTIONS(3016),
    [anon_sym_u8_SQUOTE] = ACTIONS(3016),
    [anon_sym_SQUOTE] = ACTIONS(3016),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3014),
    [sym_false] = ACTIONS(3014),
    [anon_sym_NULL] = ACTIONS(3014),
    [anon_sym_nullptr] = ACTIONS(3014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3014),
    [anon_sym_let] = ACTIONS(3014),
    [anon_sym_This] = ACTIONS(3014),
    [anon_sym_decltype] = ACTIONS(3014),
    [sym_virtual] = ACTIONS(3014),
    [anon_sym_typename] = ACTIONS(3014),
    [anon_sym_template] = ACTIONS(3014),
    [anon_sym_try] = ACTIONS(3014),
    [anon_sym_delete] = ACTIONS(3014),
    [anon_sym_throw] = ACTIONS(3014),
    [anon_sym_co_return] = ACTIONS(3014),
    [anon_sym_co_yield] = ACTIONS(3014),
    [anon_sym_R_DQUOTE] = ACTIONS(3016),
    [anon_sym_LR_DQUOTE] = ACTIONS(3016),
    [anon_sym_uR_DQUOTE] = ACTIONS(3016),
    [anon_sym_UR_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3016),
    [anon_sym_co_await] = ACTIONS(3014),
    [anon_sym_new] = ACTIONS(3014),
    [anon_sym_requires] = ACTIONS(3014),
    [sym_this] = ACTIONS(3014),
    [anon_sym_discard] = ACTIONS(3014),
    [anon_sym_precise] = ACTIONS(3014),
    [anon_sym_shared] = ACTIONS(3014),
    [anon_sym_groupshared] = ACTIONS(3014),
    [anon_sym_uniform] = ACTIONS(3014),
    [anon_sym_row_major] = ACTIONS(3014),
    [anon_sym_column_major] = ACTIONS(3014),
    [anon_sym_globallycoherent] = ACTIONS(3014),
    [anon_sym_centroid] = ACTIONS(3014),
    [anon_sym_noperspective] = ACTIONS(3014),
    [anon_sym_nointerpolation] = ACTIONS(3014),
    [anon_sym_sample] = ACTIONS(3014),
    [anon_sym_linear] = ACTIONS(3014),
    [anon_sym_snorm] = ACTIONS(3014),
    [anon_sym_unorm] = ACTIONS(3014),
    [anon_sym_point] = ACTIONS(3014),
    [anon_sym_line] = ACTIONS(3014),
    [anon_sym_triangleadj] = ACTIONS(3014),
    [anon_sym_lineadj] = ACTIONS(3014),
    [anon_sym_triangle] = ACTIONS(3014),
    [anon_sym_cbuffer] = ACTIONS(3014),
    [anon_sym_interface] = ACTIONS(3014),
    [anon_sym_extension] = ACTIONS(3014),
  },
  [1290] = {
    [sym_identifier] = ACTIONS(3008),
    [anon_sym_LPAREN2] = ACTIONS(3010),
    [anon_sym_BANG] = ACTIONS(3010),
    [anon_sym_TILDE] = ACTIONS(3010),
    [anon_sym_DASH] = ACTIONS(3008),
    [anon_sym_PLUS] = ACTIONS(3008),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(3010),
    [anon_sym___extension__] = ACTIONS(3008),
    [anon_sym_typedef] = ACTIONS(3008),
    [anon_sym_in] = ACTIONS(3008),
    [anon_sym_out] = ACTIONS(3008),
    [anon_sym_inout] = ACTIONS(3008),
    [anon_sym_extern] = ACTIONS(3008),
    [anon_sym___attribute__] = ACTIONS(3008),
    [anon_sym_COLON_COLON] = ACTIONS(3010),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3010),
    [anon_sym___declspec] = ACTIONS(3008),
    [anon_sym_LBRACE] = ACTIONS(3010),
    [anon_sym_signed] = ACTIONS(3008),
    [anon_sym_unsigned] = ACTIONS(3008),
    [anon_sym_long] = ACTIONS(3008),
    [anon_sym_short] = ACTIONS(3008),
    [anon_sym_LBRACK] = ACTIONS(3008),
    [anon_sym_static] = ACTIONS(3008),
    [anon_sym_register] = ACTIONS(3008),
    [anon_sym_inline] = ACTIONS(3008),
    [anon_sym___inline] = ACTIONS(3008),
    [anon_sym___inline__] = ACTIONS(3008),
    [anon_sym___forceinline] = ACTIONS(3008),
    [anon_sym_thread_local] = ACTIONS(3008),
    [anon_sym___thread] = ACTIONS(3008),
    [anon_sym_const] = ACTIONS(3008),
    [anon_sym_constexpr] = ACTIONS(3008),
    [anon_sym_volatile] = ACTIONS(3008),
    [anon_sym_restrict] = ACTIONS(3008),
    [anon_sym___restrict__] = ACTIONS(3008),
    [anon_sym__Atomic] = ACTIONS(3008),
    [anon_sym__Noreturn] = ACTIONS(3008),
    [anon_sym_noreturn] = ACTIONS(3008),
    [anon_sym_mutable] = ACTIONS(3008),
    [anon_sym_constinit] = ACTIONS(3008),
    [anon_sym_consteval] = ACTIONS(3008),
    [anon_sym_alignas] = ACTIONS(3008),
    [anon_sym__Alignas] = ACTIONS(3008),
    [sym_primitive_type] = ACTIONS(3008),
    [anon_sym_enum] = ACTIONS(3008),
    [anon_sym_class] = ACTIONS(3008),
    [anon_sym_struct] = ACTIONS(3008),
    [anon_sym_union] = ACTIONS(3008),
    [anon_sym_if] = ACTIONS(3008),
    [anon_sym_else] = ACTIONS(3008),
    [anon_sym_switch] = ACTIONS(3008),
    [anon_sym_while] = ACTIONS(3008),
    [anon_sym_do] = ACTIONS(3008),
    [anon_sym_for] = ACTIONS(3008),
    [anon_sym_return] = ACTIONS(3008),
    [anon_sym_break] = ACTIONS(3008),
    [anon_sym_continue] = ACTIONS(3008),
    [anon_sym_goto] = ACTIONS(3008),
    [anon_sym___try] = ACTIONS(3008),
    [anon_sym___leave] = ACTIONS(3008),
    [anon_sym_not] = ACTIONS(3008),
    [anon_sym_compl] = ACTIONS(3008),
    [anon_sym_DASH_DASH] = ACTIONS(3010),
    [anon_sym_PLUS_PLUS] = ACTIONS(3010),
    [anon_sym_sizeof] = ACTIONS(3008),
    [anon_sym___alignof__] = ACTIONS(3008),
    [anon_sym___alignof] = ACTIONS(3008),
    [anon_sym__alignof] = ACTIONS(3008),
    [anon_sym_alignof] = ACTIONS(3008),
    [anon_sym__Alignof] = ACTIONS(3008),
    [anon_sym_offsetof] = ACTIONS(3008),
    [anon_sym__Generic] = ACTIONS(3008),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [sym_number_literal] = ACTIONS(3010),
    [anon_sym_L_SQUOTE] = ACTIONS(3010),
    [anon_sym_u_SQUOTE] = ACTIONS(3010),
    [anon_sym_U_SQUOTE] = ACTIONS(3010),
    [anon_sym_u8_SQUOTE] = ACTIONS(3010),
    [anon_sym_SQUOTE] = ACTIONS(3010),
    [anon_sym_L_DQUOTE] = ACTIONS(3010),
    [anon_sym_u_DQUOTE] = ACTIONS(3010),
    [anon_sym_U_DQUOTE] = ACTIONS(3010),
    [anon_sym_u8_DQUOTE] = ACTIONS(3010),
    [anon_sym_DQUOTE] = ACTIONS(3010),
    [sym_true] = ACTIONS(3008),
    [sym_false] = ACTIONS(3008),
    [anon_sym_NULL] = ACTIONS(3008),
    [anon_sym_nullptr] = ACTIONS(3008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3008),
    [anon_sym_let] = ACTIONS(3008),
    [anon_sym_This] = ACTIONS(3008),
    [anon_sym_decltype] = ACTIONS(3008),
    [sym_virtual] = ACTIONS(3008),
    [anon_sym_typename] = ACTIONS(3008),
    [anon_sym_template] = ACTIONS(3008),
    [anon_sym_try] = ACTIONS(3008),
    [anon_sym_delete] = ACTIONS(3008),
    [anon_sym_throw] = ACTIONS(3008),
    [anon_sym_co_return] = ACTIONS(3008),
    [anon_sym_co_yield] = ACTIONS(3008),
    [anon_sym_R_DQUOTE] = ACTIONS(3010),
    [anon_sym_LR_DQUOTE] = ACTIONS(3010),
    [anon_sym_uR_DQUOTE] = ACTIONS(3010),
    [anon_sym_UR_DQUOTE] = ACTIONS(3010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3010),
    [anon_sym_co_await] = ACTIONS(3008),
    [anon_sym_new] = ACTIONS(3008),
    [anon_sym_requires] = ACTIONS(3008),
    [sym_this] = ACTIONS(3008),
    [anon_sym_discard] = ACTIONS(3008),
    [anon_sym_precise] = ACTIONS(3008),
    [anon_sym_shared] = ACTIONS(3008),
    [anon_sym_groupshared] = ACTIONS(3008),
    [anon_sym_uniform] = ACTIONS(3008),
    [anon_sym_row_major] = ACTIONS(3008),
    [anon_sym_column_major] = ACTIONS(3008),
    [anon_sym_globallycoherent] = ACTIONS(3008),
    [anon_sym_centroid] = ACTIONS(3008),
    [anon_sym_noperspective] = ACTIONS(3008),
    [anon_sym_nointerpolation] = ACTIONS(3008),
    [anon_sym_sample] = ACTIONS(3008),
    [anon_sym_linear] = ACTIONS(3008),
    [anon_sym_snorm] = ACTIONS(3008),
    [anon_sym_unorm] = ACTIONS(3008),
    [anon_sym_point] = ACTIONS(3008),
    [anon_sym_line] = ACTIONS(3008),
    [anon_sym_triangleadj] = ACTIONS(3008),
    [anon_sym_lineadj] = ACTIONS(3008),
    [anon_sym_triangle] = ACTIONS(3008),
    [anon_sym_cbuffer] = ACTIONS(3008),
    [anon_sym_interface] = ACTIONS(3008),
    [anon_sym_extension] = ACTIONS(3008),
  },
  [1291] = {
    [sym_identifier] = ACTIONS(2978),
    [anon_sym_LPAREN2] = ACTIONS(2980),
    [anon_sym_BANG] = ACTIONS(2980),
    [anon_sym_TILDE] = ACTIONS(2980),
    [anon_sym_DASH] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_STAR] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2980),
    [anon_sym_SEMI] = ACTIONS(2980),
    [anon_sym___extension__] = ACTIONS(2978),
    [anon_sym_typedef] = ACTIONS(2978),
    [anon_sym_in] = ACTIONS(2978),
    [anon_sym_out] = ACTIONS(2978),
    [anon_sym_inout] = ACTIONS(2978),
    [anon_sym_extern] = ACTIONS(2978),
    [anon_sym___attribute__] = ACTIONS(2978),
    [anon_sym_COLON_COLON] = ACTIONS(2980),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2980),
    [anon_sym___declspec] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(2980),
    [anon_sym_signed] = ACTIONS(2978),
    [anon_sym_unsigned] = ACTIONS(2978),
    [anon_sym_long] = ACTIONS(2978),
    [anon_sym_short] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_static] = ACTIONS(2978),
    [anon_sym_register] = ACTIONS(2978),
    [anon_sym_inline] = ACTIONS(2978),
    [anon_sym___inline] = ACTIONS(2978),
    [anon_sym___inline__] = ACTIONS(2978),
    [anon_sym___forceinline] = ACTIONS(2978),
    [anon_sym_thread_local] = ACTIONS(2978),
    [anon_sym___thread] = ACTIONS(2978),
    [anon_sym_const] = ACTIONS(2978),
    [anon_sym_constexpr] = ACTIONS(2978),
    [anon_sym_volatile] = ACTIONS(2978),
    [anon_sym_restrict] = ACTIONS(2978),
    [anon_sym___restrict__] = ACTIONS(2978),
    [anon_sym__Atomic] = ACTIONS(2978),
    [anon_sym__Noreturn] = ACTIONS(2978),
    [anon_sym_noreturn] = ACTIONS(2978),
    [anon_sym_mutable] = ACTIONS(2978),
    [anon_sym_constinit] = ACTIONS(2978),
    [anon_sym_consteval] = ACTIONS(2978),
    [anon_sym_alignas] = ACTIONS(2978),
    [anon_sym__Alignas] = ACTIONS(2978),
    [sym_primitive_type] = ACTIONS(2978),
    [anon_sym_enum] = ACTIONS(2978),
    [anon_sym_class] = ACTIONS(2978),
    [anon_sym_struct] = ACTIONS(2978),
    [anon_sym_union] = ACTIONS(2978),
    [anon_sym_if] = ACTIONS(2978),
    [anon_sym_else] = ACTIONS(2978),
    [anon_sym_switch] = ACTIONS(2978),
    [anon_sym_while] = ACTIONS(2978),
    [anon_sym_do] = ACTIONS(2978),
    [anon_sym_for] = ACTIONS(2978),
    [anon_sym_return] = ACTIONS(2978),
    [anon_sym_break] = ACTIONS(2978),
    [anon_sym_continue] = ACTIONS(2978),
    [anon_sym_goto] = ACTIONS(2978),
    [anon_sym___try] = ACTIONS(2978),
    [anon_sym___leave] = ACTIONS(2978),
    [anon_sym_not] = ACTIONS(2978),
    [anon_sym_compl] = ACTIONS(2978),
    [anon_sym_DASH_DASH] = ACTIONS(2980),
    [anon_sym_PLUS_PLUS] = ACTIONS(2980),
    [anon_sym_sizeof] = ACTIONS(2978),
    [anon_sym___alignof__] = ACTIONS(2978),
    [anon_sym___alignof] = ACTIONS(2978),
    [anon_sym__alignof] = ACTIONS(2978),
    [anon_sym_alignof] = ACTIONS(2978),
    [anon_sym__Alignof] = ACTIONS(2978),
    [anon_sym_offsetof] = ACTIONS(2978),
    [anon_sym__Generic] = ACTIONS(2978),
    [anon_sym_asm] = ACTIONS(2978),
    [anon_sym___asm__] = ACTIONS(2978),
    [sym_number_literal] = ACTIONS(2980),
    [anon_sym_L_SQUOTE] = ACTIONS(2980),
    [anon_sym_u_SQUOTE] = ACTIONS(2980),
    [anon_sym_U_SQUOTE] = ACTIONS(2980),
    [anon_sym_u8_SQUOTE] = ACTIONS(2980),
    [anon_sym_SQUOTE] = ACTIONS(2980),
    [anon_sym_L_DQUOTE] = ACTIONS(2980),
    [anon_sym_u_DQUOTE] = ACTIONS(2980),
    [anon_sym_U_DQUOTE] = ACTIONS(2980),
    [anon_sym_u8_DQUOTE] = ACTIONS(2980),
    [anon_sym_DQUOTE] = ACTIONS(2980),
    [sym_true] = ACTIONS(2978),
    [sym_false] = ACTIONS(2978),
    [anon_sym_NULL] = ACTIONS(2978),
    [anon_sym_nullptr] = ACTIONS(2978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2978),
    [anon_sym_let] = ACTIONS(2978),
    [anon_sym_This] = ACTIONS(2978),
    [anon_sym_decltype] = ACTIONS(2978),
    [sym_virtual] = ACTIONS(2978),
    [anon_sym_typename] = ACTIONS(2978),
    [anon_sym_template] = ACTIONS(2978),
    [anon_sym_try] = ACTIONS(2978),
    [anon_sym_delete] = ACTIONS(2978),
    [anon_sym_throw] = ACTIONS(2978),
    [anon_sym_co_return] = ACTIONS(2978),
    [anon_sym_co_yield] = ACTIONS(2978),
    [anon_sym_R_DQUOTE] = ACTIONS(2980),
    [anon_sym_LR_DQUOTE] = ACTIONS(2980),
    [anon_sym_uR_DQUOTE] = ACTIONS(2980),
    [anon_sym_UR_DQUOTE] = ACTIONS(2980),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2980),
    [anon_sym_co_await] = ACTIONS(2978),
    [anon_sym_new] = ACTIONS(2978),
    [anon_sym_requires] = ACTIONS(2978),
    [sym_this] = ACTIONS(2978),
    [anon_sym_discard] = ACTIONS(2978),
    [anon_sym_precise] = ACTIONS(2978),
    [anon_sym_shared] = ACTIONS(2978),
    [anon_sym_groupshared] = ACTIONS(2978),
    [anon_sym_uniform] = ACTIONS(2978),
    [anon_sym_row_major] = ACTIONS(2978),
    [anon_sym_column_major] = ACTIONS(2978),
    [anon_sym_globallycoherent] = ACTIONS(2978),
    [anon_sym_centroid] = ACTIONS(2978),
    [anon_sym_noperspective] = ACTIONS(2978),
    [anon_sym_nointerpolation] = ACTIONS(2978),
    [anon_sym_sample] = ACTIONS(2978),
    [anon_sym_linear] = ACTIONS(2978),
    [anon_sym_snorm] = ACTIONS(2978),
    [anon_sym_unorm] = ACTIONS(2978),
    [anon_sym_point] = ACTIONS(2978),
    [anon_sym_line] = ACTIONS(2978),
    [anon_sym_triangleadj] = ACTIONS(2978),
    [anon_sym_lineadj] = ACTIONS(2978),
    [anon_sym_triangle] = ACTIONS(2978),
    [anon_sym_cbuffer] = ACTIONS(2978),
    [anon_sym_interface] = ACTIONS(2978),
    [anon_sym_extension] = ACTIONS(2978),
  },
  [1292] = {
    [sym_identifier] = ACTIONS(3298),
    [anon_sym_LPAREN2] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3298),
    [anon_sym_PLUS] = ACTIONS(3298),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_SEMI] = ACTIONS(3300),
    [anon_sym___extension__] = ACTIONS(3298),
    [anon_sym_typedef] = ACTIONS(3298),
    [anon_sym_in] = ACTIONS(3298),
    [anon_sym_out] = ACTIONS(3298),
    [anon_sym_inout] = ACTIONS(3298),
    [anon_sym_extern] = ACTIONS(3298),
    [anon_sym___attribute__] = ACTIONS(3298),
    [anon_sym_COLON_COLON] = ACTIONS(3300),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3300),
    [anon_sym___declspec] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_signed] = ACTIONS(3298),
    [anon_sym_unsigned] = ACTIONS(3298),
    [anon_sym_long] = ACTIONS(3298),
    [anon_sym_short] = ACTIONS(3298),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_static] = ACTIONS(3298),
    [anon_sym_register] = ACTIONS(3298),
    [anon_sym_inline] = ACTIONS(3298),
    [anon_sym___inline] = ACTIONS(3298),
    [anon_sym___inline__] = ACTIONS(3298),
    [anon_sym___forceinline] = ACTIONS(3298),
    [anon_sym_thread_local] = ACTIONS(3298),
    [anon_sym___thread] = ACTIONS(3298),
    [anon_sym_const] = ACTIONS(3298),
    [anon_sym_constexpr] = ACTIONS(3298),
    [anon_sym_volatile] = ACTIONS(3298),
    [anon_sym_restrict] = ACTIONS(3298),
    [anon_sym___restrict__] = ACTIONS(3298),
    [anon_sym__Atomic] = ACTIONS(3298),
    [anon_sym__Noreturn] = ACTIONS(3298),
    [anon_sym_noreturn] = ACTIONS(3298),
    [anon_sym_mutable] = ACTIONS(3298),
    [anon_sym_constinit] = ACTIONS(3298),
    [anon_sym_consteval] = ACTIONS(3298),
    [anon_sym_alignas] = ACTIONS(3298),
    [anon_sym__Alignas] = ACTIONS(3298),
    [sym_primitive_type] = ACTIONS(3298),
    [anon_sym_enum] = ACTIONS(3298),
    [anon_sym_class] = ACTIONS(3298),
    [anon_sym_struct] = ACTIONS(3298),
    [anon_sym_union] = ACTIONS(3298),
    [anon_sym_if] = ACTIONS(3298),
    [anon_sym_else] = ACTIONS(3298),
    [anon_sym_switch] = ACTIONS(3298),
    [anon_sym_while] = ACTIONS(3298),
    [anon_sym_do] = ACTIONS(3298),
    [anon_sym_for] = ACTIONS(3298),
    [anon_sym_return] = ACTIONS(3298),
    [anon_sym_break] = ACTIONS(3298),
    [anon_sym_continue] = ACTIONS(3298),
    [anon_sym_goto] = ACTIONS(3298),
    [anon_sym___try] = ACTIONS(3298),
    [anon_sym___leave] = ACTIONS(3298),
    [anon_sym_not] = ACTIONS(3298),
    [anon_sym_compl] = ACTIONS(3298),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_sizeof] = ACTIONS(3298),
    [anon_sym___alignof__] = ACTIONS(3298),
    [anon_sym___alignof] = ACTIONS(3298),
    [anon_sym__alignof] = ACTIONS(3298),
    [anon_sym_alignof] = ACTIONS(3298),
    [anon_sym__Alignof] = ACTIONS(3298),
    [anon_sym_offsetof] = ACTIONS(3298),
    [anon_sym__Generic] = ACTIONS(3298),
    [anon_sym_asm] = ACTIONS(3298),
    [anon_sym___asm__] = ACTIONS(3298),
    [sym_number_literal] = ACTIONS(3300),
    [anon_sym_L_SQUOTE] = ACTIONS(3300),
    [anon_sym_u_SQUOTE] = ACTIONS(3300),
    [anon_sym_U_SQUOTE] = ACTIONS(3300),
    [anon_sym_u8_SQUOTE] = ACTIONS(3300),
    [anon_sym_SQUOTE] = ACTIONS(3300),
    [anon_sym_L_DQUOTE] = ACTIONS(3300),
    [anon_sym_u_DQUOTE] = ACTIONS(3300),
    [anon_sym_U_DQUOTE] = ACTIONS(3300),
    [anon_sym_u8_DQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [sym_true] = ACTIONS(3298),
    [sym_false] = ACTIONS(3298),
    [anon_sym_NULL] = ACTIONS(3298),
    [anon_sym_nullptr] = ACTIONS(3298),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3298),
    [anon_sym_let] = ACTIONS(3298),
    [anon_sym_This] = ACTIONS(3298),
    [anon_sym_decltype] = ACTIONS(3298),
    [sym_virtual] = ACTIONS(3298),
    [anon_sym_typename] = ACTIONS(3298),
    [anon_sym_template] = ACTIONS(3298),
    [anon_sym_try] = ACTIONS(3298),
    [anon_sym_delete] = ACTIONS(3298),
    [anon_sym_throw] = ACTIONS(3298),
    [anon_sym_co_return] = ACTIONS(3298),
    [anon_sym_co_yield] = ACTIONS(3298),
    [anon_sym_R_DQUOTE] = ACTIONS(3300),
    [anon_sym_LR_DQUOTE] = ACTIONS(3300),
    [anon_sym_uR_DQUOTE] = ACTIONS(3300),
    [anon_sym_UR_DQUOTE] = ACTIONS(3300),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3300),
    [anon_sym_co_await] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3298),
    [anon_sym_requires] = ACTIONS(3298),
    [sym_this] = ACTIONS(3298),
    [anon_sym_discard] = ACTIONS(3298),
    [anon_sym_precise] = ACTIONS(3298),
    [anon_sym_shared] = ACTIONS(3298),
    [anon_sym_groupshared] = ACTIONS(3298),
    [anon_sym_uniform] = ACTIONS(3298),
    [anon_sym_row_major] = ACTIONS(3298),
    [anon_sym_column_major] = ACTIONS(3298),
    [anon_sym_globallycoherent] = ACTIONS(3298),
    [anon_sym_centroid] = ACTIONS(3298),
    [anon_sym_noperspective] = ACTIONS(3298),
    [anon_sym_nointerpolation] = ACTIONS(3298),
    [anon_sym_sample] = ACTIONS(3298),
    [anon_sym_linear] = ACTIONS(3298),
    [anon_sym_snorm] = ACTIONS(3298),
    [anon_sym_unorm] = ACTIONS(3298),
    [anon_sym_point] = ACTIONS(3298),
    [anon_sym_line] = ACTIONS(3298),
    [anon_sym_triangleadj] = ACTIONS(3298),
    [anon_sym_lineadj] = ACTIONS(3298),
    [anon_sym_triangle] = ACTIONS(3298),
    [anon_sym_cbuffer] = ACTIONS(3298),
    [anon_sym_interface] = ACTIONS(3298),
    [anon_sym_extension] = ACTIONS(3298),
  },
  [1293] = {
    [sym_identifier] = ACTIONS(2982),
    [anon_sym_LPAREN2] = ACTIONS(2984),
    [anon_sym_BANG] = ACTIONS(2984),
    [anon_sym_TILDE] = ACTIONS(2984),
    [anon_sym_DASH] = ACTIONS(2982),
    [anon_sym_PLUS] = ACTIONS(2982),
    [anon_sym_STAR] = ACTIONS(2984),
    [anon_sym_AMP] = ACTIONS(2984),
    [anon_sym_SEMI] = ACTIONS(2984),
    [anon_sym___extension__] = ACTIONS(2982),
    [anon_sym_typedef] = ACTIONS(2982),
    [anon_sym_in] = ACTIONS(2982),
    [anon_sym_out] = ACTIONS(2982),
    [anon_sym_inout] = ACTIONS(2982),
    [anon_sym_extern] = ACTIONS(2982),
    [anon_sym___attribute__] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2984),
    [anon_sym___declspec] = ACTIONS(2982),
    [anon_sym_LBRACE] = ACTIONS(2984),
    [anon_sym_signed] = ACTIONS(2982),
    [anon_sym_unsigned] = ACTIONS(2982),
    [anon_sym_long] = ACTIONS(2982),
    [anon_sym_short] = ACTIONS(2982),
    [anon_sym_LBRACK] = ACTIONS(2982),
    [anon_sym_static] = ACTIONS(2982),
    [anon_sym_register] = ACTIONS(2982),
    [anon_sym_inline] = ACTIONS(2982),
    [anon_sym___inline] = ACTIONS(2982),
    [anon_sym___inline__] = ACTIONS(2982),
    [anon_sym___forceinline] = ACTIONS(2982),
    [anon_sym_thread_local] = ACTIONS(2982),
    [anon_sym___thread] = ACTIONS(2982),
    [anon_sym_const] = ACTIONS(2982),
    [anon_sym_constexpr] = ACTIONS(2982),
    [anon_sym_volatile] = ACTIONS(2982),
    [anon_sym_restrict] = ACTIONS(2982),
    [anon_sym___restrict__] = ACTIONS(2982),
    [anon_sym__Atomic] = ACTIONS(2982),
    [anon_sym__Noreturn] = ACTIONS(2982),
    [anon_sym_noreturn] = ACTIONS(2982),
    [anon_sym_mutable] = ACTIONS(2982),
    [anon_sym_constinit] = ACTIONS(2982),
    [anon_sym_consteval] = ACTIONS(2982),
    [anon_sym_alignas] = ACTIONS(2982),
    [anon_sym__Alignas] = ACTIONS(2982),
    [sym_primitive_type] = ACTIONS(2982),
    [anon_sym_enum] = ACTIONS(2982),
    [anon_sym_class] = ACTIONS(2982),
    [anon_sym_struct] = ACTIONS(2982),
    [anon_sym_union] = ACTIONS(2982),
    [anon_sym_if] = ACTIONS(2982),
    [anon_sym_else] = ACTIONS(2982),
    [anon_sym_switch] = ACTIONS(2982),
    [anon_sym_while] = ACTIONS(2982),
    [anon_sym_do] = ACTIONS(2982),
    [anon_sym_for] = ACTIONS(2982),
    [anon_sym_return] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2982),
    [anon_sym_continue] = ACTIONS(2982),
    [anon_sym_goto] = ACTIONS(2982),
    [anon_sym___try] = ACTIONS(2982),
    [anon_sym___leave] = ACTIONS(2982),
    [anon_sym_not] = ACTIONS(2982),
    [anon_sym_compl] = ACTIONS(2982),
    [anon_sym_DASH_DASH] = ACTIONS(2984),
    [anon_sym_PLUS_PLUS] = ACTIONS(2984),
    [anon_sym_sizeof] = ACTIONS(2982),
    [anon_sym___alignof__] = ACTIONS(2982),
    [anon_sym___alignof] = ACTIONS(2982),
    [anon_sym__alignof] = ACTIONS(2982),
    [anon_sym_alignof] = ACTIONS(2982),
    [anon_sym__Alignof] = ACTIONS(2982),
    [anon_sym_offsetof] = ACTIONS(2982),
    [anon_sym__Generic] = ACTIONS(2982),
    [anon_sym_asm] = ACTIONS(2982),
    [anon_sym___asm__] = ACTIONS(2982),
    [sym_number_literal] = ACTIONS(2984),
    [anon_sym_L_SQUOTE] = ACTIONS(2984),
    [anon_sym_u_SQUOTE] = ACTIONS(2984),
    [anon_sym_U_SQUOTE] = ACTIONS(2984),
    [anon_sym_u8_SQUOTE] = ACTIONS(2984),
    [anon_sym_SQUOTE] = ACTIONS(2984),
    [anon_sym_L_DQUOTE] = ACTIONS(2984),
    [anon_sym_u_DQUOTE] = ACTIONS(2984),
    [anon_sym_U_DQUOTE] = ACTIONS(2984),
    [anon_sym_u8_DQUOTE] = ACTIONS(2984),
    [anon_sym_DQUOTE] = ACTIONS(2984),
    [sym_true] = ACTIONS(2982),
    [sym_false] = ACTIONS(2982),
    [anon_sym_NULL] = ACTIONS(2982),
    [anon_sym_nullptr] = ACTIONS(2982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2982),
    [anon_sym_let] = ACTIONS(2982),
    [anon_sym_This] = ACTIONS(2982),
    [anon_sym_decltype] = ACTIONS(2982),
    [sym_virtual] = ACTIONS(2982),
    [anon_sym_typename] = ACTIONS(2982),
    [anon_sym_template] = ACTIONS(2982),
    [anon_sym_try] = ACTIONS(2982),
    [anon_sym_delete] = ACTIONS(2982),
    [anon_sym_throw] = ACTIONS(2982),
    [anon_sym_co_return] = ACTIONS(2982),
    [anon_sym_co_yield] = ACTIONS(2982),
    [anon_sym_R_DQUOTE] = ACTIONS(2984),
    [anon_sym_LR_DQUOTE] = ACTIONS(2984),
    [anon_sym_uR_DQUOTE] = ACTIONS(2984),
    [anon_sym_UR_DQUOTE] = ACTIONS(2984),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2984),
    [anon_sym_co_await] = ACTIONS(2982),
    [anon_sym_new] = ACTIONS(2982),
    [anon_sym_requires] = ACTIONS(2982),
    [sym_this] = ACTIONS(2982),
    [anon_sym_discard] = ACTIONS(2982),
    [anon_sym_precise] = ACTIONS(2982),
    [anon_sym_shared] = ACTIONS(2982),
    [anon_sym_groupshared] = ACTIONS(2982),
    [anon_sym_uniform] = ACTIONS(2982),
    [anon_sym_row_major] = ACTIONS(2982),
    [anon_sym_column_major] = ACTIONS(2982),
    [anon_sym_globallycoherent] = ACTIONS(2982),
    [anon_sym_centroid] = ACTIONS(2982),
    [anon_sym_noperspective] = ACTIONS(2982),
    [anon_sym_nointerpolation] = ACTIONS(2982),
    [anon_sym_sample] = ACTIONS(2982),
    [anon_sym_linear] = ACTIONS(2982),
    [anon_sym_snorm] = ACTIONS(2982),
    [anon_sym_unorm] = ACTIONS(2982),
    [anon_sym_point] = ACTIONS(2982),
    [anon_sym_line] = ACTIONS(2982),
    [anon_sym_triangleadj] = ACTIONS(2982),
    [anon_sym_lineadj] = ACTIONS(2982),
    [anon_sym_triangle] = ACTIONS(2982),
    [anon_sym_cbuffer] = ACTIONS(2982),
    [anon_sym_interface] = ACTIONS(2982),
    [anon_sym_extension] = ACTIONS(2982),
  },
  [1294] = {
    [sym_identifier] = ACTIONS(3210),
    [anon_sym_LPAREN2] = ACTIONS(3212),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3210),
    [anon_sym_PLUS] = ACTIONS(3210),
    [anon_sym_STAR] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3212),
    [anon_sym_SEMI] = ACTIONS(3212),
    [anon_sym___extension__] = ACTIONS(3210),
    [anon_sym_typedef] = ACTIONS(3210),
    [anon_sym_in] = ACTIONS(3210),
    [anon_sym_out] = ACTIONS(3210),
    [anon_sym_inout] = ACTIONS(3210),
    [anon_sym_extern] = ACTIONS(3210),
    [anon_sym___attribute__] = ACTIONS(3210),
    [anon_sym_COLON_COLON] = ACTIONS(3212),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3212),
    [anon_sym___declspec] = ACTIONS(3210),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_signed] = ACTIONS(3210),
    [anon_sym_unsigned] = ACTIONS(3210),
    [anon_sym_long] = ACTIONS(3210),
    [anon_sym_short] = ACTIONS(3210),
    [anon_sym_LBRACK] = ACTIONS(3210),
    [anon_sym_static] = ACTIONS(3210),
    [anon_sym_register] = ACTIONS(3210),
    [anon_sym_inline] = ACTIONS(3210),
    [anon_sym___inline] = ACTIONS(3210),
    [anon_sym___inline__] = ACTIONS(3210),
    [anon_sym___forceinline] = ACTIONS(3210),
    [anon_sym_thread_local] = ACTIONS(3210),
    [anon_sym___thread] = ACTIONS(3210),
    [anon_sym_const] = ACTIONS(3210),
    [anon_sym_constexpr] = ACTIONS(3210),
    [anon_sym_volatile] = ACTIONS(3210),
    [anon_sym_restrict] = ACTIONS(3210),
    [anon_sym___restrict__] = ACTIONS(3210),
    [anon_sym__Atomic] = ACTIONS(3210),
    [anon_sym__Noreturn] = ACTIONS(3210),
    [anon_sym_noreturn] = ACTIONS(3210),
    [anon_sym_mutable] = ACTIONS(3210),
    [anon_sym_constinit] = ACTIONS(3210),
    [anon_sym_consteval] = ACTIONS(3210),
    [anon_sym_alignas] = ACTIONS(3210),
    [anon_sym__Alignas] = ACTIONS(3210),
    [sym_primitive_type] = ACTIONS(3210),
    [anon_sym_enum] = ACTIONS(3210),
    [anon_sym_class] = ACTIONS(3210),
    [anon_sym_struct] = ACTIONS(3210),
    [anon_sym_union] = ACTIONS(3210),
    [anon_sym_if] = ACTIONS(3210),
    [anon_sym_else] = ACTIONS(3210),
    [anon_sym_switch] = ACTIONS(3210),
    [anon_sym_while] = ACTIONS(3210),
    [anon_sym_do] = ACTIONS(3210),
    [anon_sym_for] = ACTIONS(3210),
    [anon_sym_return] = ACTIONS(3210),
    [anon_sym_break] = ACTIONS(3210),
    [anon_sym_continue] = ACTIONS(3210),
    [anon_sym_goto] = ACTIONS(3210),
    [anon_sym___try] = ACTIONS(3210),
    [anon_sym___leave] = ACTIONS(3210),
    [anon_sym_not] = ACTIONS(3210),
    [anon_sym_compl] = ACTIONS(3210),
    [anon_sym_DASH_DASH] = ACTIONS(3212),
    [anon_sym_PLUS_PLUS] = ACTIONS(3212),
    [anon_sym_sizeof] = ACTIONS(3210),
    [anon_sym___alignof__] = ACTIONS(3210),
    [anon_sym___alignof] = ACTIONS(3210),
    [anon_sym__alignof] = ACTIONS(3210),
    [anon_sym_alignof] = ACTIONS(3210),
    [anon_sym__Alignof] = ACTIONS(3210),
    [anon_sym_offsetof] = ACTIONS(3210),
    [anon_sym__Generic] = ACTIONS(3210),
    [anon_sym_asm] = ACTIONS(3210),
    [anon_sym___asm__] = ACTIONS(3210),
    [sym_number_literal] = ACTIONS(3212),
    [anon_sym_L_SQUOTE] = ACTIONS(3212),
    [anon_sym_u_SQUOTE] = ACTIONS(3212),
    [anon_sym_U_SQUOTE] = ACTIONS(3212),
    [anon_sym_u8_SQUOTE] = ACTIONS(3212),
    [anon_sym_SQUOTE] = ACTIONS(3212),
    [anon_sym_L_DQUOTE] = ACTIONS(3212),
    [anon_sym_u_DQUOTE] = ACTIONS(3212),
    [anon_sym_U_DQUOTE] = ACTIONS(3212),
    [anon_sym_u8_DQUOTE] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [sym_true] = ACTIONS(3210),
    [sym_false] = ACTIONS(3210),
    [anon_sym_NULL] = ACTIONS(3210),
    [anon_sym_nullptr] = ACTIONS(3210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3210),
    [anon_sym_let] = ACTIONS(3210),
    [anon_sym_This] = ACTIONS(3210),
    [anon_sym_decltype] = ACTIONS(3210),
    [sym_virtual] = ACTIONS(3210),
    [anon_sym_typename] = ACTIONS(3210),
    [anon_sym_template] = ACTIONS(3210),
    [anon_sym_try] = ACTIONS(3210),
    [anon_sym_delete] = ACTIONS(3210),
    [anon_sym_throw] = ACTIONS(3210),
    [anon_sym_co_return] = ACTIONS(3210),
    [anon_sym_co_yield] = ACTIONS(3210),
    [anon_sym_R_DQUOTE] = ACTIONS(3212),
    [anon_sym_LR_DQUOTE] = ACTIONS(3212),
    [anon_sym_uR_DQUOTE] = ACTIONS(3212),
    [anon_sym_UR_DQUOTE] = ACTIONS(3212),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3212),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3210),
    [anon_sym_requires] = ACTIONS(3210),
    [sym_this] = ACTIONS(3210),
    [anon_sym_discard] = ACTIONS(3210),
    [anon_sym_precise] = ACTIONS(3210),
    [anon_sym_shared] = ACTIONS(3210),
    [anon_sym_groupshared] = ACTIONS(3210),
    [anon_sym_uniform] = ACTIONS(3210),
    [anon_sym_row_major] = ACTIONS(3210),
    [anon_sym_column_major] = ACTIONS(3210),
    [anon_sym_globallycoherent] = ACTIONS(3210),
    [anon_sym_centroid] = ACTIONS(3210),
    [anon_sym_noperspective] = ACTIONS(3210),
    [anon_sym_nointerpolation] = ACTIONS(3210),
    [anon_sym_sample] = ACTIONS(3210),
    [anon_sym_linear] = ACTIONS(3210),
    [anon_sym_snorm] = ACTIONS(3210),
    [anon_sym_unorm] = ACTIONS(3210),
    [anon_sym_point] = ACTIONS(3210),
    [anon_sym_line] = ACTIONS(3210),
    [anon_sym_triangleadj] = ACTIONS(3210),
    [anon_sym_lineadj] = ACTIONS(3210),
    [anon_sym_triangle] = ACTIONS(3210),
    [anon_sym_cbuffer] = ACTIONS(3210),
    [anon_sym_interface] = ACTIONS(3210),
    [anon_sym_extension] = ACTIONS(3210),
  },
  [1295] = {
    [sym_identifier] = ACTIONS(3302),
    [anon_sym_LPAREN2] = ACTIONS(3304),
    [anon_sym_BANG] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_SEMI] = ACTIONS(3304),
    [anon_sym___extension__] = ACTIONS(3302),
    [anon_sym_typedef] = ACTIONS(3302),
    [anon_sym_in] = ACTIONS(3302),
    [anon_sym_out] = ACTIONS(3302),
    [anon_sym_inout] = ACTIONS(3302),
    [anon_sym_extern] = ACTIONS(3302),
    [anon_sym___attribute__] = ACTIONS(3302),
    [anon_sym_COLON_COLON] = ACTIONS(3304),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3304),
    [anon_sym___declspec] = ACTIONS(3302),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_signed] = ACTIONS(3302),
    [anon_sym_unsigned] = ACTIONS(3302),
    [anon_sym_long] = ACTIONS(3302),
    [anon_sym_short] = ACTIONS(3302),
    [anon_sym_LBRACK] = ACTIONS(3302),
    [anon_sym_static] = ACTIONS(3302),
    [anon_sym_register] = ACTIONS(3302),
    [anon_sym_inline] = ACTIONS(3302),
    [anon_sym___inline] = ACTIONS(3302),
    [anon_sym___inline__] = ACTIONS(3302),
    [anon_sym___forceinline] = ACTIONS(3302),
    [anon_sym_thread_local] = ACTIONS(3302),
    [anon_sym___thread] = ACTIONS(3302),
    [anon_sym_const] = ACTIONS(3302),
    [anon_sym_constexpr] = ACTIONS(3302),
    [anon_sym_volatile] = ACTIONS(3302),
    [anon_sym_restrict] = ACTIONS(3302),
    [anon_sym___restrict__] = ACTIONS(3302),
    [anon_sym__Atomic] = ACTIONS(3302),
    [anon_sym__Noreturn] = ACTIONS(3302),
    [anon_sym_noreturn] = ACTIONS(3302),
    [anon_sym_mutable] = ACTIONS(3302),
    [anon_sym_constinit] = ACTIONS(3302),
    [anon_sym_consteval] = ACTIONS(3302),
    [anon_sym_alignas] = ACTIONS(3302),
    [anon_sym__Alignas] = ACTIONS(3302),
    [sym_primitive_type] = ACTIONS(3302),
    [anon_sym_enum] = ACTIONS(3302),
    [anon_sym_class] = ACTIONS(3302),
    [anon_sym_struct] = ACTIONS(3302),
    [anon_sym_union] = ACTIONS(3302),
    [anon_sym_if] = ACTIONS(3302),
    [anon_sym_else] = ACTIONS(3302),
    [anon_sym_switch] = ACTIONS(3302),
    [anon_sym_while] = ACTIONS(3302),
    [anon_sym_do] = ACTIONS(3302),
    [anon_sym_for] = ACTIONS(3302),
    [anon_sym_return] = ACTIONS(3302),
    [anon_sym_break] = ACTIONS(3302),
    [anon_sym_continue] = ACTIONS(3302),
    [anon_sym_goto] = ACTIONS(3302),
    [anon_sym___try] = ACTIONS(3302),
    [anon_sym___leave] = ACTIONS(3302),
    [anon_sym_not] = ACTIONS(3302),
    [anon_sym_compl] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3304),
    [anon_sym_PLUS_PLUS] = ACTIONS(3304),
    [anon_sym_sizeof] = ACTIONS(3302),
    [anon_sym___alignof__] = ACTIONS(3302),
    [anon_sym___alignof] = ACTIONS(3302),
    [anon_sym__alignof] = ACTIONS(3302),
    [anon_sym_alignof] = ACTIONS(3302),
    [anon_sym__Alignof] = ACTIONS(3302),
    [anon_sym_offsetof] = ACTIONS(3302),
    [anon_sym__Generic] = ACTIONS(3302),
    [anon_sym_asm] = ACTIONS(3302),
    [anon_sym___asm__] = ACTIONS(3302),
    [sym_number_literal] = ACTIONS(3304),
    [anon_sym_L_SQUOTE] = ACTIONS(3304),
    [anon_sym_u_SQUOTE] = ACTIONS(3304),
    [anon_sym_U_SQUOTE] = ACTIONS(3304),
    [anon_sym_u8_SQUOTE] = ACTIONS(3304),
    [anon_sym_SQUOTE] = ACTIONS(3304),
    [anon_sym_L_DQUOTE] = ACTIONS(3304),
    [anon_sym_u_DQUOTE] = ACTIONS(3304),
    [anon_sym_U_DQUOTE] = ACTIONS(3304),
    [anon_sym_u8_DQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [sym_true] = ACTIONS(3302),
    [sym_false] = ACTIONS(3302),
    [anon_sym_NULL] = ACTIONS(3302),
    [anon_sym_nullptr] = ACTIONS(3302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3302),
    [anon_sym_let] = ACTIONS(3302),
    [anon_sym_This] = ACTIONS(3302),
    [anon_sym_decltype] = ACTIONS(3302),
    [sym_virtual] = ACTIONS(3302),
    [anon_sym_typename] = ACTIONS(3302),
    [anon_sym_template] = ACTIONS(3302),
    [anon_sym_try] = ACTIONS(3302),
    [anon_sym_delete] = ACTIONS(3302),
    [anon_sym_throw] = ACTIONS(3302),
    [anon_sym_co_return] = ACTIONS(3302),
    [anon_sym_co_yield] = ACTIONS(3302),
    [anon_sym_R_DQUOTE] = ACTIONS(3304),
    [anon_sym_LR_DQUOTE] = ACTIONS(3304),
    [anon_sym_uR_DQUOTE] = ACTIONS(3304),
    [anon_sym_UR_DQUOTE] = ACTIONS(3304),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3304),
    [anon_sym_co_await] = ACTIONS(3302),
    [anon_sym_new] = ACTIONS(3302),
    [anon_sym_requires] = ACTIONS(3302),
    [sym_this] = ACTIONS(3302),
    [anon_sym_discard] = ACTIONS(3302),
    [anon_sym_precise] = ACTIONS(3302),
    [anon_sym_shared] = ACTIONS(3302),
    [anon_sym_groupshared] = ACTIONS(3302),
    [anon_sym_uniform] = ACTIONS(3302),
    [anon_sym_row_major] = ACTIONS(3302),
    [anon_sym_column_major] = ACTIONS(3302),
    [anon_sym_globallycoherent] = ACTIONS(3302),
    [anon_sym_centroid] = ACTIONS(3302),
    [anon_sym_noperspective] = ACTIONS(3302),
    [anon_sym_nointerpolation] = ACTIONS(3302),
    [anon_sym_sample] = ACTIONS(3302),
    [anon_sym_linear] = ACTIONS(3302),
    [anon_sym_snorm] = ACTIONS(3302),
    [anon_sym_unorm] = ACTIONS(3302),
    [anon_sym_point] = ACTIONS(3302),
    [anon_sym_line] = ACTIONS(3302),
    [anon_sym_triangleadj] = ACTIONS(3302),
    [anon_sym_lineadj] = ACTIONS(3302),
    [anon_sym_triangle] = ACTIONS(3302),
    [anon_sym_cbuffer] = ACTIONS(3302),
    [anon_sym_interface] = ACTIONS(3302),
    [anon_sym_extension] = ACTIONS(3302),
  },
  [1296] = {
    [sym_identifier] = ACTIONS(3026),
    [anon_sym_LPAREN2] = ACTIONS(3028),
    [anon_sym_BANG] = ACTIONS(3028),
    [anon_sym_TILDE] = ACTIONS(3028),
    [anon_sym_DASH] = ACTIONS(3026),
    [anon_sym_PLUS] = ACTIONS(3026),
    [anon_sym_STAR] = ACTIONS(3028),
    [anon_sym_AMP] = ACTIONS(3028),
    [anon_sym_SEMI] = ACTIONS(3028),
    [anon_sym___extension__] = ACTIONS(3026),
    [anon_sym_typedef] = ACTIONS(3026),
    [anon_sym_in] = ACTIONS(3026),
    [anon_sym_out] = ACTIONS(3026),
    [anon_sym_inout] = ACTIONS(3026),
    [anon_sym_extern] = ACTIONS(3026),
    [anon_sym___attribute__] = ACTIONS(3026),
    [anon_sym_COLON_COLON] = ACTIONS(3028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3028),
    [anon_sym___declspec] = ACTIONS(3026),
    [anon_sym_LBRACE] = ACTIONS(3028),
    [anon_sym_signed] = ACTIONS(3026),
    [anon_sym_unsigned] = ACTIONS(3026),
    [anon_sym_long] = ACTIONS(3026),
    [anon_sym_short] = ACTIONS(3026),
    [anon_sym_LBRACK] = ACTIONS(3026),
    [anon_sym_static] = ACTIONS(3026),
    [anon_sym_register] = ACTIONS(3026),
    [anon_sym_inline] = ACTIONS(3026),
    [anon_sym___inline] = ACTIONS(3026),
    [anon_sym___inline__] = ACTIONS(3026),
    [anon_sym___forceinline] = ACTIONS(3026),
    [anon_sym_thread_local] = ACTIONS(3026),
    [anon_sym___thread] = ACTIONS(3026),
    [anon_sym_const] = ACTIONS(3026),
    [anon_sym_constexpr] = ACTIONS(3026),
    [anon_sym_volatile] = ACTIONS(3026),
    [anon_sym_restrict] = ACTIONS(3026),
    [anon_sym___restrict__] = ACTIONS(3026),
    [anon_sym__Atomic] = ACTIONS(3026),
    [anon_sym__Noreturn] = ACTIONS(3026),
    [anon_sym_noreturn] = ACTIONS(3026),
    [anon_sym_mutable] = ACTIONS(3026),
    [anon_sym_constinit] = ACTIONS(3026),
    [anon_sym_consteval] = ACTIONS(3026),
    [anon_sym_alignas] = ACTIONS(3026),
    [anon_sym__Alignas] = ACTIONS(3026),
    [sym_primitive_type] = ACTIONS(3026),
    [anon_sym_enum] = ACTIONS(3026),
    [anon_sym_class] = ACTIONS(3026),
    [anon_sym_struct] = ACTIONS(3026),
    [anon_sym_union] = ACTIONS(3026),
    [anon_sym_if] = ACTIONS(3026),
    [anon_sym_else] = ACTIONS(3026),
    [anon_sym_switch] = ACTIONS(3026),
    [anon_sym_while] = ACTIONS(3026),
    [anon_sym_do] = ACTIONS(3026),
    [anon_sym_for] = ACTIONS(3026),
    [anon_sym_return] = ACTIONS(3026),
    [anon_sym_break] = ACTIONS(3026),
    [anon_sym_continue] = ACTIONS(3026),
    [anon_sym_goto] = ACTIONS(3026),
    [anon_sym___try] = ACTIONS(3026),
    [anon_sym___leave] = ACTIONS(3026),
    [anon_sym_not] = ACTIONS(3026),
    [anon_sym_compl] = ACTIONS(3026),
    [anon_sym_DASH_DASH] = ACTIONS(3028),
    [anon_sym_PLUS_PLUS] = ACTIONS(3028),
    [anon_sym_sizeof] = ACTIONS(3026),
    [anon_sym___alignof__] = ACTIONS(3026),
    [anon_sym___alignof] = ACTIONS(3026),
    [anon_sym__alignof] = ACTIONS(3026),
    [anon_sym_alignof] = ACTIONS(3026),
    [anon_sym__Alignof] = ACTIONS(3026),
    [anon_sym_offsetof] = ACTIONS(3026),
    [anon_sym__Generic] = ACTIONS(3026),
    [anon_sym_asm] = ACTIONS(3026),
    [anon_sym___asm__] = ACTIONS(3026),
    [sym_number_literal] = ACTIONS(3028),
    [anon_sym_L_SQUOTE] = ACTIONS(3028),
    [anon_sym_u_SQUOTE] = ACTIONS(3028),
    [anon_sym_U_SQUOTE] = ACTIONS(3028),
    [anon_sym_u8_SQUOTE] = ACTIONS(3028),
    [anon_sym_SQUOTE] = ACTIONS(3028),
    [anon_sym_L_DQUOTE] = ACTIONS(3028),
    [anon_sym_u_DQUOTE] = ACTIONS(3028),
    [anon_sym_U_DQUOTE] = ACTIONS(3028),
    [anon_sym_u8_DQUOTE] = ACTIONS(3028),
    [anon_sym_DQUOTE] = ACTIONS(3028),
    [sym_true] = ACTIONS(3026),
    [sym_false] = ACTIONS(3026),
    [anon_sym_NULL] = ACTIONS(3026),
    [anon_sym_nullptr] = ACTIONS(3026),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3026),
    [anon_sym_let] = ACTIONS(3026),
    [anon_sym_This] = ACTIONS(3026),
    [anon_sym_decltype] = ACTIONS(3026),
    [sym_virtual] = ACTIONS(3026),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(3026),
    [anon_sym_try] = ACTIONS(3026),
    [anon_sym_delete] = ACTIONS(3026),
    [anon_sym_throw] = ACTIONS(3026),
    [anon_sym_co_return] = ACTIONS(3026),
    [anon_sym_co_yield] = ACTIONS(3026),
    [anon_sym_R_DQUOTE] = ACTIONS(3028),
    [anon_sym_LR_DQUOTE] = ACTIONS(3028),
    [anon_sym_uR_DQUOTE] = ACTIONS(3028),
    [anon_sym_UR_DQUOTE] = ACTIONS(3028),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3028),
    [anon_sym_co_await] = ACTIONS(3026),
    [anon_sym_new] = ACTIONS(3026),
    [anon_sym_requires] = ACTIONS(3026),
    [sym_this] = ACTIONS(3026),
    [anon_sym_discard] = ACTIONS(3026),
    [anon_sym_precise] = ACTIONS(3026),
    [anon_sym_shared] = ACTIONS(3026),
    [anon_sym_groupshared] = ACTIONS(3026),
    [anon_sym_uniform] = ACTIONS(3026),
    [anon_sym_row_major] = ACTIONS(3026),
    [anon_sym_column_major] = ACTIONS(3026),
    [anon_sym_globallycoherent] = ACTIONS(3026),
    [anon_sym_centroid] = ACTIONS(3026),
    [anon_sym_noperspective] = ACTIONS(3026),
    [anon_sym_nointerpolation] = ACTIONS(3026),
    [anon_sym_sample] = ACTIONS(3026),
    [anon_sym_linear] = ACTIONS(3026),
    [anon_sym_snorm] = ACTIONS(3026),
    [anon_sym_unorm] = ACTIONS(3026),
    [anon_sym_point] = ACTIONS(3026),
    [anon_sym_line] = ACTIONS(3026),
    [anon_sym_triangleadj] = ACTIONS(3026),
    [anon_sym_lineadj] = ACTIONS(3026),
    [anon_sym_triangle] = ACTIONS(3026),
    [anon_sym_cbuffer] = ACTIONS(3026),
    [anon_sym_interface] = ACTIONS(3026),
    [anon_sym_extension] = ACTIONS(3026),
  },
  [1297] = {
    [sym_identifier] = ACTIONS(3378),
    [anon_sym_LPAREN2] = ACTIONS(3380),
    [anon_sym_BANG] = ACTIONS(3380),
    [anon_sym_TILDE] = ACTIONS(3380),
    [anon_sym_DASH] = ACTIONS(3378),
    [anon_sym_PLUS] = ACTIONS(3378),
    [anon_sym_STAR] = ACTIONS(3380),
    [anon_sym_AMP] = ACTIONS(3380),
    [anon_sym_SEMI] = ACTIONS(3380),
    [anon_sym___extension__] = ACTIONS(3378),
    [anon_sym_typedef] = ACTIONS(3378),
    [anon_sym_in] = ACTIONS(3378),
    [anon_sym_out] = ACTIONS(3378),
    [anon_sym_inout] = ACTIONS(3378),
    [anon_sym_extern] = ACTIONS(3378),
    [anon_sym___attribute__] = ACTIONS(3378),
    [anon_sym_COLON_COLON] = ACTIONS(3380),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3380),
    [anon_sym___declspec] = ACTIONS(3378),
    [anon_sym_LBRACE] = ACTIONS(3380),
    [anon_sym_signed] = ACTIONS(3378),
    [anon_sym_unsigned] = ACTIONS(3378),
    [anon_sym_long] = ACTIONS(3378),
    [anon_sym_short] = ACTIONS(3378),
    [anon_sym_LBRACK] = ACTIONS(3378),
    [anon_sym_static] = ACTIONS(3378),
    [anon_sym_register] = ACTIONS(3378),
    [anon_sym_inline] = ACTIONS(3378),
    [anon_sym___inline] = ACTIONS(3378),
    [anon_sym___inline__] = ACTIONS(3378),
    [anon_sym___forceinline] = ACTIONS(3378),
    [anon_sym_thread_local] = ACTIONS(3378),
    [anon_sym___thread] = ACTIONS(3378),
    [anon_sym_const] = ACTIONS(3378),
    [anon_sym_constexpr] = ACTIONS(3378),
    [anon_sym_volatile] = ACTIONS(3378),
    [anon_sym_restrict] = ACTIONS(3378),
    [anon_sym___restrict__] = ACTIONS(3378),
    [anon_sym__Atomic] = ACTIONS(3378),
    [anon_sym__Noreturn] = ACTIONS(3378),
    [anon_sym_noreturn] = ACTIONS(3378),
    [anon_sym_mutable] = ACTIONS(3378),
    [anon_sym_constinit] = ACTIONS(3378),
    [anon_sym_consteval] = ACTIONS(3378),
    [anon_sym_alignas] = ACTIONS(3378),
    [anon_sym__Alignas] = ACTIONS(3378),
    [sym_primitive_type] = ACTIONS(3378),
    [anon_sym_enum] = ACTIONS(3378),
    [anon_sym_class] = ACTIONS(3378),
    [anon_sym_struct] = ACTIONS(3378),
    [anon_sym_union] = ACTIONS(3378),
    [anon_sym_if] = ACTIONS(3378),
    [anon_sym_else] = ACTIONS(3378),
    [anon_sym_switch] = ACTIONS(3378),
    [anon_sym_while] = ACTIONS(3378),
    [anon_sym_do] = ACTIONS(3378),
    [anon_sym_for] = ACTIONS(3378),
    [anon_sym_return] = ACTIONS(3378),
    [anon_sym_break] = ACTIONS(3378),
    [anon_sym_continue] = ACTIONS(3378),
    [anon_sym_goto] = ACTIONS(3378),
    [anon_sym___try] = ACTIONS(3378),
    [anon_sym___leave] = ACTIONS(3378),
    [anon_sym_not] = ACTIONS(3378),
    [anon_sym_compl] = ACTIONS(3378),
    [anon_sym_DASH_DASH] = ACTIONS(3380),
    [anon_sym_PLUS_PLUS] = ACTIONS(3380),
    [anon_sym_sizeof] = ACTIONS(3378),
    [anon_sym___alignof__] = ACTIONS(3378),
    [anon_sym___alignof] = ACTIONS(3378),
    [anon_sym__alignof] = ACTIONS(3378),
    [anon_sym_alignof] = ACTIONS(3378),
    [anon_sym__Alignof] = ACTIONS(3378),
    [anon_sym_offsetof] = ACTIONS(3378),
    [anon_sym__Generic] = ACTIONS(3378),
    [anon_sym_asm] = ACTIONS(3378),
    [anon_sym___asm__] = ACTIONS(3378),
    [sym_number_literal] = ACTIONS(3380),
    [anon_sym_L_SQUOTE] = ACTIONS(3380),
    [anon_sym_u_SQUOTE] = ACTIONS(3380),
    [anon_sym_U_SQUOTE] = ACTIONS(3380),
    [anon_sym_u8_SQUOTE] = ACTIONS(3380),
    [anon_sym_SQUOTE] = ACTIONS(3380),
    [anon_sym_L_DQUOTE] = ACTIONS(3380),
    [anon_sym_u_DQUOTE] = ACTIONS(3380),
    [anon_sym_U_DQUOTE] = ACTIONS(3380),
    [anon_sym_u8_DQUOTE] = ACTIONS(3380),
    [anon_sym_DQUOTE] = ACTIONS(3380),
    [sym_true] = ACTIONS(3378),
    [sym_false] = ACTIONS(3378),
    [anon_sym_NULL] = ACTIONS(3378),
    [anon_sym_nullptr] = ACTIONS(3378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3378),
    [anon_sym_let] = ACTIONS(3378),
    [anon_sym_This] = ACTIONS(3378),
    [anon_sym_decltype] = ACTIONS(3378),
    [sym_virtual] = ACTIONS(3378),
    [anon_sym_typename] = ACTIONS(3378),
    [anon_sym_template] = ACTIONS(3378),
    [anon_sym_try] = ACTIONS(3378),
    [anon_sym_delete] = ACTIONS(3378),
    [anon_sym_throw] = ACTIONS(3378),
    [anon_sym_co_return] = ACTIONS(3378),
    [anon_sym_co_yield] = ACTIONS(3378),
    [anon_sym_R_DQUOTE] = ACTIONS(3380),
    [anon_sym_LR_DQUOTE] = ACTIONS(3380),
    [anon_sym_uR_DQUOTE] = ACTIONS(3380),
    [anon_sym_UR_DQUOTE] = ACTIONS(3380),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3380),
    [anon_sym_co_await] = ACTIONS(3378),
    [anon_sym_new] = ACTIONS(3378),
    [anon_sym_requires] = ACTIONS(3378),
    [sym_this] = ACTIONS(3378),
    [anon_sym_discard] = ACTIONS(3378),
    [anon_sym_precise] = ACTIONS(3378),
    [anon_sym_shared] = ACTIONS(3378),
    [anon_sym_groupshared] = ACTIONS(3378),
    [anon_sym_uniform] = ACTIONS(3378),
    [anon_sym_row_major] = ACTIONS(3378),
    [anon_sym_column_major] = ACTIONS(3378),
    [anon_sym_globallycoherent] = ACTIONS(3378),
    [anon_sym_centroid] = ACTIONS(3378),
    [anon_sym_noperspective] = ACTIONS(3378),
    [anon_sym_nointerpolation] = ACTIONS(3378),
    [anon_sym_sample] = ACTIONS(3378),
    [anon_sym_linear] = ACTIONS(3378),
    [anon_sym_snorm] = ACTIONS(3378),
    [anon_sym_unorm] = ACTIONS(3378),
    [anon_sym_point] = ACTIONS(3378),
    [anon_sym_line] = ACTIONS(3378),
    [anon_sym_triangleadj] = ACTIONS(3378),
    [anon_sym_lineadj] = ACTIONS(3378),
    [anon_sym_triangle] = ACTIONS(3378),
    [anon_sym_cbuffer] = ACTIONS(3378),
    [anon_sym_interface] = ACTIONS(3378),
    [anon_sym_extension] = ACTIONS(3378),
  },
  [1298] = {
    [sym_identifier] = ACTIONS(3196),
    [anon_sym_LPAREN2] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3196),
    [anon_sym_PLUS] = ACTIONS(3196),
    [anon_sym_STAR] = ACTIONS(3198),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(3196),
    [anon_sym_typedef] = ACTIONS(3196),
    [anon_sym_in] = ACTIONS(3196),
    [anon_sym_out] = ACTIONS(3196),
    [anon_sym_inout] = ACTIONS(3196),
    [anon_sym_extern] = ACTIONS(3196),
    [anon_sym___attribute__] = ACTIONS(3196),
    [anon_sym_COLON_COLON] = ACTIONS(3198),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3198),
    [anon_sym___declspec] = ACTIONS(3196),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_signed] = ACTIONS(3196),
    [anon_sym_unsigned] = ACTIONS(3196),
    [anon_sym_long] = ACTIONS(3196),
    [anon_sym_short] = ACTIONS(3196),
    [anon_sym_LBRACK] = ACTIONS(3196),
    [anon_sym_static] = ACTIONS(3196),
    [anon_sym_register] = ACTIONS(3196),
    [anon_sym_inline] = ACTIONS(3196),
    [anon_sym___inline] = ACTIONS(3196),
    [anon_sym___inline__] = ACTIONS(3196),
    [anon_sym___forceinline] = ACTIONS(3196),
    [anon_sym_thread_local] = ACTIONS(3196),
    [anon_sym___thread] = ACTIONS(3196),
    [anon_sym_const] = ACTIONS(3196),
    [anon_sym_constexpr] = ACTIONS(3196),
    [anon_sym_volatile] = ACTIONS(3196),
    [anon_sym_restrict] = ACTIONS(3196),
    [anon_sym___restrict__] = ACTIONS(3196),
    [anon_sym__Atomic] = ACTIONS(3196),
    [anon_sym__Noreturn] = ACTIONS(3196),
    [anon_sym_noreturn] = ACTIONS(3196),
    [anon_sym_mutable] = ACTIONS(3196),
    [anon_sym_constinit] = ACTIONS(3196),
    [anon_sym_consteval] = ACTIONS(3196),
    [anon_sym_alignas] = ACTIONS(3196),
    [anon_sym__Alignas] = ACTIONS(3196),
    [sym_primitive_type] = ACTIONS(3196),
    [anon_sym_enum] = ACTIONS(3196),
    [anon_sym_class] = ACTIONS(3196),
    [anon_sym_struct] = ACTIONS(3196),
    [anon_sym_union] = ACTIONS(3196),
    [anon_sym_if] = ACTIONS(3196),
    [anon_sym_else] = ACTIONS(3196),
    [anon_sym_switch] = ACTIONS(3196),
    [anon_sym_while] = ACTIONS(3196),
    [anon_sym_do] = ACTIONS(3196),
    [anon_sym_for] = ACTIONS(3196),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_break] = ACTIONS(3196),
    [anon_sym_continue] = ACTIONS(3196),
    [anon_sym_goto] = ACTIONS(3196),
    [anon_sym___try] = ACTIONS(3196),
    [anon_sym___leave] = ACTIONS(3196),
    [anon_sym_not] = ACTIONS(3196),
    [anon_sym_compl] = ACTIONS(3196),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(3196),
    [anon_sym___alignof] = ACTIONS(3196),
    [anon_sym__alignof] = ACTIONS(3196),
    [anon_sym_alignof] = ACTIONS(3196),
    [anon_sym__Alignof] = ACTIONS(3196),
    [anon_sym_offsetof] = ACTIONS(3196),
    [anon_sym__Generic] = ACTIONS(3196),
    [anon_sym_asm] = ACTIONS(3196),
    [anon_sym___asm__] = ACTIONS(3196),
    [sym_number_literal] = ACTIONS(3198),
    [anon_sym_L_SQUOTE] = ACTIONS(3198),
    [anon_sym_u_SQUOTE] = ACTIONS(3198),
    [anon_sym_U_SQUOTE] = ACTIONS(3198),
    [anon_sym_u8_SQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_L_DQUOTE] = ACTIONS(3198),
    [anon_sym_u_DQUOTE] = ACTIONS(3198),
    [anon_sym_U_DQUOTE] = ACTIONS(3198),
    [anon_sym_u8_DQUOTE] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [sym_true] = ACTIONS(3196),
    [sym_false] = ACTIONS(3196),
    [anon_sym_NULL] = ACTIONS(3196),
    [anon_sym_nullptr] = ACTIONS(3196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3196),
    [anon_sym_let] = ACTIONS(3196),
    [anon_sym_This] = ACTIONS(3196),
    [anon_sym_decltype] = ACTIONS(3196),
    [sym_virtual] = ACTIONS(3196),
    [anon_sym_typename] = ACTIONS(3196),
    [anon_sym_template] = ACTIONS(3196),
    [anon_sym_try] = ACTIONS(3196),
    [anon_sym_delete] = ACTIONS(3196),
    [anon_sym_throw] = ACTIONS(3196),
    [anon_sym_co_return] = ACTIONS(3196),
    [anon_sym_co_yield] = ACTIONS(3196),
    [anon_sym_R_DQUOTE] = ACTIONS(3198),
    [anon_sym_LR_DQUOTE] = ACTIONS(3198),
    [anon_sym_uR_DQUOTE] = ACTIONS(3198),
    [anon_sym_UR_DQUOTE] = ACTIONS(3198),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3198),
    [anon_sym_co_await] = ACTIONS(3196),
    [anon_sym_new] = ACTIONS(3196),
    [anon_sym_requires] = ACTIONS(3196),
    [sym_this] = ACTIONS(3196),
    [anon_sym_discard] = ACTIONS(3196),
    [anon_sym_precise] = ACTIONS(3196),
    [anon_sym_shared] = ACTIONS(3196),
    [anon_sym_groupshared] = ACTIONS(3196),
    [anon_sym_uniform] = ACTIONS(3196),
    [anon_sym_row_major] = ACTIONS(3196),
    [anon_sym_column_major] = ACTIONS(3196),
    [anon_sym_globallycoherent] = ACTIONS(3196),
    [anon_sym_centroid] = ACTIONS(3196),
    [anon_sym_noperspective] = ACTIONS(3196),
    [anon_sym_nointerpolation] = ACTIONS(3196),
    [anon_sym_sample] = ACTIONS(3196),
    [anon_sym_linear] = ACTIONS(3196),
    [anon_sym_snorm] = ACTIONS(3196),
    [anon_sym_unorm] = ACTIONS(3196),
    [anon_sym_point] = ACTIONS(3196),
    [anon_sym_line] = ACTIONS(3196),
    [anon_sym_triangleadj] = ACTIONS(3196),
    [anon_sym_lineadj] = ACTIONS(3196),
    [anon_sym_triangle] = ACTIONS(3196),
    [anon_sym_cbuffer] = ACTIONS(3196),
    [anon_sym_interface] = ACTIONS(3196),
    [anon_sym_extension] = ACTIONS(3196),
  },
  [1299] = {
    [sym_identifier] = ACTIONS(3030),
    [anon_sym_LPAREN2] = ACTIONS(3032),
    [anon_sym_BANG] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym___extension__] = ACTIONS(3030),
    [anon_sym_typedef] = ACTIONS(3030),
    [anon_sym_in] = ACTIONS(3030),
    [anon_sym_out] = ACTIONS(3030),
    [anon_sym_inout] = ACTIONS(3030),
    [anon_sym_extern] = ACTIONS(3030),
    [anon_sym___attribute__] = ACTIONS(3030),
    [anon_sym_COLON_COLON] = ACTIONS(3032),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3032),
    [anon_sym___declspec] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_signed] = ACTIONS(3030),
    [anon_sym_unsigned] = ACTIONS(3030),
    [anon_sym_long] = ACTIONS(3030),
    [anon_sym_short] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_static] = ACTIONS(3030),
    [anon_sym_register] = ACTIONS(3030),
    [anon_sym_inline] = ACTIONS(3030),
    [anon_sym___inline] = ACTIONS(3030),
    [anon_sym___inline__] = ACTIONS(3030),
    [anon_sym___forceinline] = ACTIONS(3030),
    [anon_sym_thread_local] = ACTIONS(3030),
    [anon_sym___thread] = ACTIONS(3030),
    [anon_sym_const] = ACTIONS(3030),
    [anon_sym_constexpr] = ACTIONS(3030),
    [anon_sym_volatile] = ACTIONS(3030),
    [anon_sym_restrict] = ACTIONS(3030),
    [anon_sym___restrict__] = ACTIONS(3030),
    [anon_sym__Atomic] = ACTIONS(3030),
    [anon_sym__Noreturn] = ACTIONS(3030),
    [anon_sym_noreturn] = ACTIONS(3030),
    [anon_sym_mutable] = ACTIONS(3030),
    [anon_sym_constinit] = ACTIONS(3030),
    [anon_sym_consteval] = ACTIONS(3030),
    [anon_sym_alignas] = ACTIONS(3030),
    [anon_sym__Alignas] = ACTIONS(3030),
    [sym_primitive_type] = ACTIONS(3030),
    [anon_sym_enum] = ACTIONS(3030),
    [anon_sym_class] = ACTIONS(3030),
    [anon_sym_struct] = ACTIONS(3030),
    [anon_sym_union] = ACTIONS(3030),
    [anon_sym_if] = ACTIONS(3030),
    [anon_sym_else] = ACTIONS(3030),
    [anon_sym_switch] = ACTIONS(3030),
    [anon_sym_while] = ACTIONS(3030),
    [anon_sym_do] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3030),
    [anon_sym_return] = ACTIONS(3030),
    [anon_sym_break] = ACTIONS(3030),
    [anon_sym_continue] = ACTIONS(3030),
    [anon_sym_goto] = ACTIONS(3030),
    [anon_sym___try] = ACTIONS(3030),
    [anon_sym___leave] = ACTIONS(3030),
    [anon_sym_not] = ACTIONS(3030),
    [anon_sym_compl] = ACTIONS(3030),
    [anon_sym_DASH_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_PLUS] = ACTIONS(3032),
    [anon_sym_sizeof] = ACTIONS(3030),
    [anon_sym___alignof__] = ACTIONS(3030),
    [anon_sym___alignof] = ACTIONS(3030),
    [anon_sym__alignof] = ACTIONS(3030),
    [anon_sym_alignof] = ACTIONS(3030),
    [anon_sym__Alignof] = ACTIONS(3030),
    [anon_sym_offsetof] = ACTIONS(3030),
    [anon_sym__Generic] = ACTIONS(3030),
    [anon_sym_asm] = ACTIONS(3030),
    [anon_sym___asm__] = ACTIONS(3030),
    [sym_number_literal] = ACTIONS(3032),
    [anon_sym_L_SQUOTE] = ACTIONS(3032),
    [anon_sym_u_SQUOTE] = ACTIONS(3032),
    [anon_sym_U_SQUOTE] = ACTIONS(3032),
    [anon_sym_u8_SQUOTE] = ACTIONS(3032),
    [anon_sym_SQUOTE] = ACTIONS(3032),
    [anon_sym_L_DQUOTE] = ACTIONS(3032),
    [anon_sym_u_DQUOTE] = ACTIONS(3032),
    [anon_sym_U_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [sym_true] = ACTIONS(3030),
    [sym_false] = ACTIONS(3030),
    [anon_sym_NULL] = ACTIONS(3030),
    [anon_sym_nullptr] = ACTIONS(3030),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3030),
    [anon_sym_let] = ACTIONS(3030),
    [anon_sym_This] = ACTIONS(3030),
    [anon_sym_decltype] = ACTIONS(3030),
    [sym_virtual] = ACTIONS(3030),
    [anon_sym_typename] = ACTIONS(3030),
    [anon_sym_template] = ACTIONS(3030),
    [anon_sym_try] = ACTIONS(3030),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_throw] = ACTIONS(3030),
    [anon_sym_co_return] = ACTIONS(3030),
    [anon_sym_co_yield] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3030),
    [anon_sym_requires] = ACTIONS(3030),
    [sym_this] = ACTIONS(3030),
    [anon_sym_discard] = ACTIONS(3030),
    [anon_sym_precise] = ACTIONS(3030),
    [anon_sym_shared] = ACTIONS(3030),
    [anon_sym_groupshared] = ACTIONS(3030),
    [anon_sym_uniform] = ACTIONS(3030),
    [anon_sym_row_major] = ACTIONS(3030),
    [anon_sym_column_major] = ACTIONS(3030),
    [anon_sym_globallycoherent] = ACTIONS(3030),
    [anon_sym_centroid] = ACTIONS(3030),
    [anon_sym_noperspective] = ACTIONS(3030),
    [anon_sym_nointerpolation] = ACTIONS(3030),
    [anon_sym_sample] = ACTIONS(3030),
    [anon_sym_linear] = ACTIONS(3030),
    [anon_sym_snorm] = ACTIONS(3030),
    [anon_sym_unorm] = ACTIONS(3030),
    [anon_sym_point] = ACTIONS(3030),
    [anon_sym_line] = ACTIONS(3030),
    [anon_sym_triangleadj] = ACTIONS(3030),
    [anon_sym_lineadj] = ACTIONS(3030),
    [anon_sym_triangle] = ACTIONS(3030),
    [anon_sym_cbuffer] = ACTIONS(3030),
    [anon_sym_interface] = ACTIONS(3030),
    [anon_sym_extension] = ACTIONS(3030),
  },
  [1300] = {
    [sym_identifier] = ACTIONS(3238),
    [anon_sym_LPAREN2] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3238),
    [anon_sym_PLUS] = ACTIONS(3238),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_SEMI] = ACTIONS(3240),
    [anon_sym___extension__] = ACTIONS(3238),
    [anon_sym_typedef] = ACTIONS(3238),
    [anon_sym_in] = ACTIONS(3238),
    [anon_sym_out] = ACTIONS(3238),
    [anon_sym_inout] = ACTIONS(3238),
    [anon_sym_extern] = ACTIONS(3238),
    [anon_sym___attribute__] = ACTIONS(3238),
    [anon_sym_COLON_COLON] = ACTIONS(3240),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3240),
    [anon_sym___declspec] = ACTIONS(3238),
    [anon_sym_LBRACE] = ACTIONS(3240),
    [anon_sym_signed] = ACTIONS(3238),
    [anon_sym_unsigned] = ACTIONS(3238),
    [anon_sym_long] = ACTIONS(3238),
    [anon_sym_short] = ACTIONS(3238),
    [anon_sym_LBRACK] = ACTIONS(3238),
    [anon_sym_static] = ACTIONS(3238),
    [anon_sym_register] = ACTIONS(3238),
    [anon_sym_inline] = ACTIONS(3238),
    [anon_sym___inline] = ACTIONS(3238),
    [anon_sym___inline__] = ACTIONS(3238),
    [anon_sym___forceinline] = ACTIONS(3238),
    [anon_sym_thread_local] = ACTIONS(3238),
    [anon_sym___thread] = ACTIONS(3238),
    [anon_sym_const] = ACTIONS(3238),
    [anon_sym_constexpr] = ACTIONS(3238),
    [anon_sym_volatile] = ACTIONS(3238),
    [anon_sym_restrict] = ACTIONS(3238),
    [anon_sym___restrict__] = ACTIONS(3238),
    [anon_sym__Atomic] = ACTIONS(3238),
    [anon_sym__Noreturn] = ACTIONS(3238),
    [anon_sym_noreturn] = ACTIONS(3238),
    [anon_sym_mutable] = ACTIONS(3238),
    [anon_sym_constinit] = ACTIONS(3238),
    [anon_sym_consteval] = ACTIONS(3238),
    [anon_sym_alignas] = ACTIONS(3238),
    [anon_sym__Alignas] = ACTIONS(3238),
    [sym_primitive_type] = ACTIONS(3238),
    [anon_sym_enum] = ACTIONS(3238),
    [anon_sym_class] = ACTIONS(3238),
    [anon_sym_struct] = ACTIONS(3238),
    [anon_sym_union] = ACTIONS(3238),
    [anon_sym_if] = ACTIONS(3238),
    [anon_sym_else] = ACTIONS(3238),
    [anon_sym_switch] = ACTIONS(3238),
    [anon_sym_while] = ACTIONS(3238),
    [anon_sym_do] = ACTIONS(3238),
    [anon_sym_for] = ACTIONS(3238),
    [anon_sym_return] = ACTIONS(3238),
    [anon_sym_break] = ACTIONS(3238),
    [anon_sym_continue] = ACTIONS(3238),
    [anon_sym_goto] = ACTIONS(3238),
    [anon_sym___try] = ACTIONS(3238),
    [anon_sym___leave] = ACTIONS(3238),
    [anon_sym_not] = ACTIONS(3238),
    [anon_sym_compl] = ACTIONS(3238),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_sizeof] = ACTIONS(3238),
    [anon_sym___alignof__] = ACTIONS(3238),
    [anon_sym___alignof] = ACTIONS(3238),
    [anon_sym__alignof] = ACTIONS(3238),
    [anon_sym_alignof] = ACTIONS(3238),
    [anon_sym__Alignof] = ACTIONS(3238),
    [anon_sym_offsetof] = ACTIONS(3238),
    [anon_sym__Generic] = ACTIONS(3238),
    [anon_sym_asm] = ACTIONS(3238),
    [anon_sym___asm__] = ACTIONS(3238),
    [sym_number_literal] = ACTIONS(3240),
    [anon_sym_L_SQUOTE] = ACTIONS(3240),
    [anon_sym_u_SQUOTE] = ACTIONS(3240),
    [anon_sym_U_SQUOTE] = ACTIONS(3240),
    [anon_sym_u8_SQUOTE] = ACTIONS(3240),
    [anon_sym_SQUOTE] = ACTIONS(3240),
    [anon_sym_L_DQUOTE] = ACTIONS(3240),
    [anon_sym_u_DQUOTE] = ACTIONS(3240),
    [anon_sym_U_DQUOTE] = ACTIONS(3240),
    [anon_sym_u8_DQUOTE] = ACTIONS(3240),
    [anon_sym_DQUOTE] = ACTIONS(3240),
    [sym_true] = ACTIONS(3238),
    [sym_false] = ACTIONS(3238),
    [anon_sym_NULL] = ACTIONS(3238),
    [anon_sym_nullptr] = ACTIONS(3238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3238),
    [anon_sym_let] = ACTIONS(3238),
    [anon_sym_This] = ACTIONS(3238),
    [anon_sym_decltype] = ACTIONS(3238),
    [sym_virtual] = ACTIONS(3238),
    [anon_sym_typename] = ACTIONS(3238),
    [anon_sym_template] = ACTIONS(3238),
    [anon_sym_try] = ACTIONS(3238),
    [anon_sym_delete] = ACTIONS(3238),
    [anon_sym_throw] = ACTIONS(3238),
    [anon_sym_co_return] = ACTIONS(3238),
    [anon_sym_co_yield] = ACTIONS(3238),
    [anon_sym_R_DQUOTE] = ACTIONS(3240),
    [anon_sym_LR_DQUOTE] = ACTIONS(3240),
    [anon_sym_uR_DQUOTE] = ACTIONS(3240),
    [anon_sym_UR_DQUOTE] = ACTIONS(3240),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3240),
    [anon_sym_co_await] = ACTIONS(3238),
    [anon_sym_new] = ACTIONS(3238),
    [anon_sym_requires] = ACTIONS(3238),
    [sym_this] = ACTIONS(3238),
    [anon_sym_discard] = ACTIONS(3238),
    [anon_sym_precise] = ACTIONS(3238),
    [anon_sym_shared] = ACTIONS(3238),
    [anon_sym_groupshared] = ACTIONS(3238),
    [anon_sym_uniform] = ACTIONS(3238),
    [anon_sym_row_major] = ACTIONS(3238),
    [anon_sym_column_major] = ACTIONS(3238),
    [anon_sym_globallycoherent] = ACTIONS(3238),
    [anon_sym_centroid] = ACTIONS(3238),
    [anon_sym_noperspective] = ACTIONS(3238),
    [anon_sym_nointerpolation] = ACTIONS(3238),
    [anon_sym_sample] = ACTIONS(3238),
    [anon_sym_linear] = ACTIONS(3238),
    [anon_sym_snorm] = ACTIONS(3238),
    [anon_sym_unorm] = ACTIONS(3238),
    [anon_sym_point] = ACTIONS(3238),
    [anon_sym_line] = ACTIONS(3238),
    [anon_sym_triangleadj] = ACTIONS(3238),
    [anon_sym_lineadj] = ACTIONS(3238),
    [anon_sym_triangle] = ACTIONS(3238),
    [anon_sym_cbuffer] = ACTIONS(3238),
    [anon_sym_interface] = ACTIONS(3238),
    [anon_sym_extension] = ACTIONS(3238),
  },
  [1301] = {
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_LPAREN2] = ACTIONS(3244),
    [anon_sym_BANG] = ACTIONS(3244),
    [anon_sym_TILDE] = ACTIONS(3244),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_STAR] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3244),
    [anon_sym_SEMI] = ACTIONS(3244),
    [anon_sym___extension__] = ACTIONS(3242),
    [anon_sym_typedef] = ACTIONS(3242),
    [anon_sym_in] = ACTIONS(3242),
    [anon_sym_out] = ACTIONS(3242),
    [anon_sym_inout] = ACTIONS(3242),
    [anon_sym_extern] = ACTIONS(3242),
    [anon_sym___attribute__] = ACTIONS(3242),
    [anon_sym_COLON_COLON] = ACTIONS(3244),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3244),
    [anon_sym___declspec] = ACTIONS(3242),
    [anon_sym_LBRACE] = ACTIONS(3244),
    [anon_sym_signed] = ACTIONS(3242),
    [anon_sym_unsigned] = ACTIONS(3242),
    [anon_sym_long] = ACTIONS(3242),
    [anon_sym_short] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_static] = ACTIONS(3242),
    [anon_sym_register] = ACTIONS(3242),
    [anon_sym_inline] = ACTIONS(3242),
    [anon_sym___inline] = ACTIONS(3242),
    [anon_sym___inline__] = ACTIONS(3242),
    [anon_sym___forceinline] = ACTIONS(3242),
    [anon_sym_thread_local] = ACTIONS(3242),
    [anon_sym___thread] = ACTIONS(3242),
    [anon_sym_const] = ACTIONS(3242),
    [anon_sym_constexpr] = ACTIONS(3242),
    [anon_sym_volatile] = ACTIONS(3242),
    [anon_sym_restrict] = ACTIONS(3242),
    [anon_sym___restrict__] = ACTIONS(3242),
    [anon_sym__Atomic] = ACTIONS(3242),
    [anon_sym__Noreturn] = ACTIONS(3242),
    [anon_sym_noreturn] = ACTIONS(3242),
    [anon_sym_mutable] = ACTIONS(3242),
    [anon_sym_constinit] = ACTIONS(3242),
    [anon_sym_consteval] = ACTIONS(3242),
    [anon_sym_alignas] = ACTIONS(3242),
    [anon_sym__Alignas] = ACTIONS(3242),
    [sym_primitive_type] = ACTIONS(3242),
    [anon_sym_enum] = ACTIONS(3242),
    [anon_sym_class] = ACTIONS(3242),
    [anon_sym_struct] = ACTIONS(3242),
    [anon_sym_union] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_else] = ACTIONS(3242),
    [anon_sym_switch] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_break] = ACTIONS(3242),
    [anon_sym_continue] = ACTIONS(3242),
    [anon_sym_goto] = ACTIONS(3242),
    [anon_sym___try] = ACTIONS(3242),
    [anon_sym___leave] = ACTIONS(3242),
    [anon_sym_not] = ACTIONS(3242),
    [anon_sym_compl] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3244),
    [anon_sym_PLUS_PLUS] = ACTIONS(3244),
    [anon_sym_sizeof] = ACTIONS(3242),
    [anon_sym___alignof__] = ACTIONS(3242),
    [anon_sym___alignof] = ACTIONS(3242),
    [anon_sym__alignof] = ACTIONS(3242),
    [anon_sym_alignof] = ACTIONS(3242),
    [anon_sym__Alignof] = ACTIONS(3242),
    [anon_sym_offsetof] = ACTIONS(3242),
    [anon_sym__Generic] = ACTIONS(3242),
    [anon_sym_asm] = ACTIONS(3242),
    [anon_sym___asm__] = ACTIONS(3242),
    [sym_number_literal] = ACTIONS(3244),
    [anon_sym_L_SQUOTE] = ACTIONS(3244),
    [anon_sym_u_SQUOTE] = ACTIONS(3244),
    [anon_sym_U_SQUOTE] = ACTIONS(3244),
    [anon_sym_u8_SQUOTE] = ACTIONS(3244),
    [anon_sym_SQUOTE] = ACTIONS(3244),
    [anon_sym_L_DQUOTE] = ACTIONS(3244),
    [anon_sym_u_DQUOTE] = ACTIONS(3244),
    [anon_sym_U_DQUOTE] = ACTIONS(3244),
    [anon_sym_u8_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE] = ACTIONS(3244),
    [sym_true] = ACTIONS(3242),
    [sym_false] = ACTIONS(3242),
    [anon_sym_NULL] = ACTIONS(3242),
    [anon_sym_nullptr] = ACTIONS(3242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_This] = ACTIONS(3242),
    [anon_sym_decltype] = ACTIONS(3242),
    [sym_virtual] = ACTIONS(3242),
    [anon_sym_typename] = ACTIONS(3242),
    [anon_sym_template] = ACTIONS(3242),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_delete] = ACTIONS(3242),
    [anon_sym_throw] = ACTIONS(3242),
    [anon_sym_co_return] = ACTIONS(3242),
    [anon_sym_co_yield] = ACTIONS(3242),
    [anon_sym_R_DQUOTE] = ACTIONS(3244),
    [anon_sym_LR_DQUOTE] = ACTIONS(3244),
    [anon_sym_uR_DQUOTE] = ACTIONS(3244),
    [anon_sym_UR_DQUOTE] = ACTIONS(3244),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3244),
    [anon_sym_co_await] = ACTIONS(3242),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_requires] = ACTIONS(3242),
    [sym_this] = ACTIONS(3242),
    [anon_sym_discard] = ACTIONS(3242),
    [anon_sym_precise] = ACTIONS(3242),
    [anon_sym_shared] = ACTIONS(3242),
    [anon_sym_groupshared] = ACTIONS(3242),
    [anon_sym_uniform] = ACTIONS(3242),
    [anon_sym_row_major] = ACTIONS(3242),
    [anon_sym_column_major] = ACTIONS(3242),
    [anon_sym_globallycoherent] = ACTIONS(3242),
    [anon_sym_centroid] = ACTIONS(3242),
    [anon_sym_noperspective] = ACTIONS(3242),
    [anon_sym_nointerpolation] = ACTIONS(3242),
    [anon_sym_sample] = ACTIONS(3242),
    [anon_sym_linear] = ACTIONS(3242),
    [anon_sym_snorm] = ACTIONS(3242),
    [anon_sym_unorm] = ACTIONS(3242),
    [anon_sym_point] = ACTIONS(3242),
    [anon_sym_line] = ACTIONS(3242),
    [anon_sym_triangleadj] = ACTIONS(3242),
    [anon_sym_lineadj] = ACTIONS(3242),
    [anon_sym_triangle] = ACTIONS(3242),
    [anon_sym_cbuffer] = ACTIONS(3242),
    [anon_sym_interface] = ACTIONS(3242),
    [anon_sym_extension] = ACTIONS(3242),
  },
  [1302] = {
    [sym_identifier] = ACTIONS(3246),
    [anon_sym_LPAREN2] = ACTIONS(3248),
    [anon_sym_BANG] = ACTIONS(3248),
    [anon_sym_TILDE] = ACTIONS(3248),
    [anon_sym_DASH] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3246),
    [anon_sym_STAR] = ACTIONS(3248),
    [anon_sym_AMP] = ACTIONS(3248),
    [anon_sym_SEMI] = ACTIONS(3248),
    [anon_sym___extension__] = ACTIONS(3246),
    [anon_sym_typedef] = ACTIONS(3246),
    [anon_sym_in] = ACTIONS(3246),
    [anon_sym_out] = ACTIONS(3246),
    [anon_sym_inout] = ACTIONS(3246),
    [anon_sym_extern] = ACTIONS(3246),
    [anon_sym___attribute__] = ACTIONS(3246),
    [anon_sym_COLON_COLON] = ACTIONS(3248),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3248),
    [anon_sym___declspec] = ACTIONS(3246),
    [anon_sym_LBRACE] = ACTIONS(3248),
    [anon_sym_signed] = ACTIONS(3246),
    [anon_sym_unsigned] = ACTIONS(3246),
    [anon_sym_long] = ACTIONS(3246),
    [anon_sym_short] = ACTIONS(3246),
    [anon_sym_LBRACK] = ACTIONS(3246),
    [anon_sym_static] = ACTIONS(3246),
    [anon_sym_register] = ACTIONS(3246),
    [anon_sym_inline] = ACTIONS(3246),
    [anon_sym___inline] = ACTIONS(3246),
    [anon_sym___inline__] = ACTIONS(3246),
    [anon_sym___forceinline] = ACTIONS(3246),
    [anon_sym_thread_local] = ACTIONS(3246),
    [anon_sym___thread] = ACTIONS(3246),
    [anon_sym_const] = ACTIONS(3246),
    [anon_sym_constexpr] = ACTIONS(3246),
    [anon_sym_volatile] = ACTIONS(3246),
    [anon_sym_restrict] = ACTIONS(3246),
    [anon_sym___restrict__] = ACTIONS(3246),
    [anon_sym__Atomic] = ACTIONS(3246),
    [anon_sym__Noreturn] = ACTIONS(3246),
    [anon_sym_noreturn] = ACTIONS(3246),
    [anon_sym_mutable] = ACTIONS(3246),
    [anon_sym_constinit] = ACTIONS(3246),
    [anon_sym_consteval] = ACTIONS(3246),
    [anon_sym_alignas] = ACTIONS(3246),
    [anon_sym__Alignas] = ACTIONS(3246),
    [sym_primitive_type] = ACTIONS(3246),
    [anon_sym_enum] = ACTIONS(3246),
    [anon_sym_class] = ACTIONS(3246),
    [anon_sym_struct] = ACTIONS(3246),
    [anon_sym_union] = ACTIONS(3246),
    [anon_sym_if] = ACTIONS(3246),
    [anon_sym_else] = ACTIONS(3246),
    [anon_sym_switch] = ACTIONS(3246),
    [anon_sym_while] = ACTIONS(3246),
    [anon_sym_do] = ACTIONS(3246),
    [anon_sym_for] = ACTIONS(3246),
    [anon_sym_return] = ACTIONS(3246),
    [anon_sym_break] = ACTIONS(3246),
    [anon_sym_continue] = ACTIONS(3246),
    [anon_sym_goto] = ACTIONS(3246),
    [anon_sym___try] = ACTIONS(3246),
    [anon_sym___leave] = ACTIONS(3246),
    [anon_sym_not] = ACTIONS(3246),
    [anon_sym_compl] = ACTIONS(3246),
    [anon_sym_DASH_DASH] = ACTIONS(3248),
    [anon_sym_PLUS_PLUS] = ACTIONS(3248),
    [anon_sym_sizeof] = ACTIONS(3246),
    [anon_sym___alignof__] = ACTIONS(3246),
    [anon_sym___alignof] = ACTIONS(3246),
    [anon_sym__alignof] = ACTIONS(3246),
    [anon_sym_alignof] = ACTIONS(3246),
    [anon_sym__Alignof] = ACTIONS(3246),
    [anon_sym_offsetof] = ACTIONS(3246),
    [anon_sym__Generic] = ACTIONS(3246),
    [anon_sym_asm] = ACTIONS(3246),
    [anon_sym___asm__] = ACTIONS(3246),
    [sym_number_literal] = ACTIONS(3248),
    [anon_sym_L_SQUOTE] = ACTIONS(3248),
    [anon_sym_u_SQUOTE] = ACTIONS(3248),
    [anon_sym_U_SQUOTE] = ACTIONS(3248),
    [anon_sym_u8_SQUOTE] = ACTIONS(3248),
    [anon_sym_SQUOTE] = ACTIONS(3248),
    [anon_sym_L_DQUOTE] = ACTIONS(3248),
    [anon_sym_u_DQUOTE] = ACTIONS(3248),
    [anon_sym_U_DQUOTE] = ACTIONS(3248),
    [anon_sym_u8_DQUOTE] = ACTIONS(3248),
    [anon_sym_DQUOTE] = ACTIONS(3248),
    [sym_true] = ACTIONS(3246),
    [sym_false] = ACTIONS(3246),
    [anon_sym_NULL] = ACTIONS(3246),
    [anon_sym_nullptr] = ACTIONS(3246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3246),
    [anon_sym_let] = ACTIONS(3246),
    [anon_sym_This] = ACTIONS(3246),
    [anon_sym_decltype] = ACTIONS(3246),
    [sym_virtual] = ACTIONS(3246),
    [anon_sym_typename] = ACTIONS(3246),
    [anon_sym_template] = ACTIONS(3246),
    [anon_sym_try] = ACTIONS(3246),
    [anon_sym_delete] = ACTIONS(3246),
    [anon_sym_throw] = ACTIONS(3246),
    [anon_sym_co_return] = ACTIONS(3246),
    [anon_sym_co_yield] = ACTIONS(3246),
    [anon_sym_R_DQUOTE] = ACTIONS(3248),
    [anon_sym_LR_DQUOTE] = ACTIONS(3248),
    [anon_sym_uR_DQUOTE] = ACTIONS(3248),
    [anon_sym_UR_DQUOTE] = ACTIONS(3248),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3248),
    [anon_sym_co_await] = ACTIONS(3246),
    [anon_sym_new] = ACTIONS(3246),
    [anon_sym_requires] = ACTIONS(3246),
    [sym_this] = ACTIONS(3246),
    [anon_sym_discard] = ACTIONS(3246),
    [anon_sym_precise] = ACTIONS(3246),
    [anon_sym_shared] = ACTIONS(3246),
    [anon_sym_groupshared] = ACTIONS(3246),
    [anon_sym_uniform] = ACTIONS(3246),
    [anon_sym_row_major] = ACTIONS(3246),
    [anon_sym_column_major] = ACTIONS(3246),
    [anon_sym_globallycoherent] = ACTIONS(3246),
    [anon_sym_centroid] = ACTIONS(3246),
    [anon_sym_noperspective] = ACTIONS(3246),
    [anon_sym_nointerpolation] = ACTIONS(3246),
    [anon_sym_sample] = ACTIONS(3246),
    [anon_sym_linear] = ACTIONS(3246),
    [anon_sym_snorm] = ACTIONS(3246),
    [anon_sym_unorm] = ACTIONS(3246),
    [anon_sym_point] = ACTIONS(3246),
    [anon_sym_line] = ACTIONS(3246),
    [anon_sym_triangleadj] = ACTIONS(3246),
    [anon_sym_lineadj] = ACTIONS(3246),
    [anon_sym_triangle] = ACTIONS(3246),
    [anon_sym_cbuffer] = ACTIONS(3246),
    [anon_sym_interface] = ACTIONS(3246),
    [anon_sym_extension] = ACTIONS(3246),
  },
  [1303] = {
    [sym_identifier] = ACTIONS(3038),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3038),
    [anon_sym_PLUS] = ACTIONS(3038),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3040),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3038),
    [anon_sym_typedef] = ACTIONS(3038),
    [anon_sym_in] = ACTIONS(3038),
    [anon_sym_out] = ACTIONS(3038),
    [anon_sym_inout] = ACTIONS(3038),
    [anon_sym_extern] = ACTIONS(3038),
    [anon_sym___attribute__] = ACTIONS(3038),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3040),
    [anon_sym___declspec] = ACTIONS(3038),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_signed] = ACTIONS(3038),
    [anon_sym_unsigned] = ACTIONS(3038),
    [anon_sym_long] = ACTIONS(3038),
    [anon_sym_short] = ACTIONS(3038),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_static] = ACTIONS(3038),
    [anon_sym_register] = ACTIONS(3038),
    [anon_sym_inline] = ACTIONS(3038),
    [anon_sym___inline] = ACTIONS(3038),
    [anon_sym___inline__] = ACTIONS(3038),
    [anon_sym___forceinline] = ACTIONS(3038),
    [anon_sym_thread_local] = ACTIONS(3038),
    [anon_sym___thread] = ACTIONS(3038),
    [anon_sym_const] = ACTIONS(3038),
    [anon_sym_constexpr] = ACTIONS(3038),
    [anon_sym_volatile] = ACTIONS(3038),
    [anon_sym_restrict] = ACTIONS(3038),
    [anon_sym___restrict__] = ACTIONS(3038),
    [anon_sym__Atomic] = ACTIONS(3038),
    [anon_sym__Noreturn] = ACTIONS(3038),
    [anon_sym_noreturn] = ACTIONS(3038),
    [anon_sym_mutable] = ACTIONS(3038),
    [anon_sym_constinit] = ACTIONS(3038),
    [anon_sym_consteval] = ACTIONS(3038),
    [anon_sym_alignas] = ACTIONS(3038),
    [anon_sym__Alignas] = ACTIONS(3038),
    [sym_primitive_type] = ACTIONS(3038),
    [anon_sym_enum] = ACTIONS(3038),
    [anon_sym_class] = ACTIONS(3038),
    [anon_sym_struct] = ACTIONS(3038),
    [anon_sym_union] = ACTIONS(3038),
    [anon_sym_if] = ACTIONS(3038),
    [anon_sym_else] = ACTIONS(3038),
    [anon_sym_switch] = ACTIONS(3038),
    [anon_sym_while] = ACTIONS(3038),
    [anon_sym_do] = ACTIONS(3038),
    [anon_sym_for] = ACTIONS(3038),
    [anon_sym_return] = ACTIONS(3038),
    [anon_sym_break] = ACTIONS(3038),
    [anon_sym_continue] = ACTIONS(3038),
    [anon_sym_goto] = ACTIONS(3038),
    [anon_sym___try] = ACTIONS(3038),
    [anon_sym___leave] = ACTIONS(3038),
    [anon_sym_not] = ACTIONS(3038),
    [anon_sym_compl] = ACTIONS(3038),
    [anon_sym_DASH_DASH] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3040),
    [anon_sym_sizeof] = ACTIONS(3038),
    [anon_sym___alignof__] = ACTIONS(3038),
    [anon_sym___alignof] = ACTIONS(3038),
    [anon_sym__alignof] = ACTIONS(3038),
    [anon_sym_alignof] = ACTIONS(3038),
    [anon_sym__Alignof] = ACTIONS(3038),
    [anon_sym_offsetof] = ACTIONS(3038),
    [anon_sym__Generic] = ACTIONS(3038),
    [anon_sym_asm] = ACTIONS(3038),
    [anon_sym___asm__] = ACTIONS(3038),
    [sym_number_literal] = ACTIONS(3040),
    [anon_sym_L_SQUOTE] = ACTIONS(3040),
    [anon_sym_u_SQUOTE] = ACTIONS(3040),
    [anon_sym_U_SQUOTE] = ACTIONS(3040),
    [anon_sym_u8_SQUOTE] = ACTIONS(3040),
    [anon_sym_SQUOTE] = ACTIONS(3040),
    [anon_sym_L_DQUOTE] = ACTIONS(3040),
    [anon_sym_u_DQUOTE] = ACTIONS(3040),
    [anon_sym_U_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8_DQUOTE] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [sym_true] = ACTIONS(3038),
    [sym_false] = ACTIONS(3038),
    [anon_sym_NULL] = ACTIONS(3038),
    [anon_sym_nullptr] = ACTIONS(3038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3038),
    [anon_sym_let] = ACTIONS(3038),
    [anon_sym_This] = ACTIONS(3038),
    [anon_sym_decltype] = ACTIONS(3038),
    [sym_virtual] = ACTIONS(3038),
    [anon_sym_typename] = ACTIONS(3038),
    [anon_sym_template] = ACTIONS(3038),
    [anon_sym_try] = ACTIONS(3038),
    [anon_sym_delete] = ACTIONS(3038),
    [anon_sym_throw] = ACTIONS(3038),
    [anon_sym_co_return] = ACTIONS(3038),
    [anon_sym_co_yield] = ACTIONS(3038),
    [anon_sym_R_DQUOTE] = ACTIONS(3040),
    [anon_sym_LR_DQUOTE] = ACTIONS(3040),
    [anon_sym_uR_DQUOTE] = ACTIONS(3040),
    [anon_sym_UR_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3040),
    [anon_sym_co_await] = ACTIONS(3038),
    [anon_sym_new] = ACTIONS(3038),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3038),
    [anon_sym_discard] = ACTIONS(3038),
    [anon_sym_precise] = ACTIONS(3038),
    [anon_sym_shared] = ACTIONS(3038),
    [anon_sym_groupshared] = ACTIONS(3038),
    [anon_sym_uniform] = ACTIONS(3038),
    [anon_sym_row_major] = ACTIONS(3038),
    [anon_sym_column_major] = ACTIONS(3038),
    [anon_sym_globallycoherent] = ACTIONS(3038),
    [anon_sym_centroid] = ACTIONS(3038),
    [anon_sym_noperspective] = ACTIONS(3038),
    [anon_sym_nointerpolation] = ACTIONS(3038),
    [anon_sym_sample] = ACTIONS(3038),
    [anon_sym_linear] = ACTIONS(3038),
    [anon_sym_snorm] = ACTIONS(3038),
    [anon_sym_unorm] = ACTIONS(3038),
    [anon_sym_point] = ACTIONS(3038),
    [anon_sym_line] = ACTIONS(3038),
    [anon_sym_triangleadj] = ACTIONS(3038),
    [anon_sym_lineadj] = ACTIONS(3038),
    [anon_sym_triangle] = ACTIONS(3038),
    [anon_sym_cbuffer] = ACTIONS(3038),
    [anon_sym_interface] = ACTIONS(3038),
    [anon_sym_extension] = ACTIONS(3038),
  },
  [1304] = {
    [sym_identifier] = ACTIONS(3076),
    [anon_sym_LPAREN2] = ACTIONS(3078),
    [anon_sym_BANG] = ACTIONS(3078),
    [anon_sym_TILDE] = ACTIONS(3078),
    [anon_sym_DASH] = ACTIONS(3076),
    [anon_sym_PLUS] = ACTIONS(3076),
    [anon_sym_STAR] = ACTIONS(3078),
    [anon_sym_AMP] = ACTIONS(3078),
    [anon_sym_SEMI] = ACTIONS(3078),
    [anon_sym___extension__] = ACTIONS(3076),
    [anon_sym_typedef] = ACTIONS(3076),
    [anon_sym_in] = ACTIONS(3076),
    [anon_sym_out] = ACTIONS(3076),
    [anon_sym_inout] = ACTIONS(3076),
    [anon_sym_extern] = ACTIONS(3076),
    [anon_sym___attribute__] = ACTIONS(3076),
    [anon_sym_COLON_COLON] = ACTIONS(3078),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3078),
    [anon_sym___declspec] = ACTIONS(3076),
    [anon_sym_LBRACE] = ACTIONS(3078),
    [anon_sym_signed] = ACTIONS(3076),
    [anon_sym_unsigned] = ACTIONS(3076),
    [anon_sym_long] = ACTIONS(3076),
    [anon_sym_short] = ACTIONS(3076),
    [anon_sym_LBRACK] = ACTIONS(3076),
    [anon_sym_static] = ACTIONS(3076),
    [anon_sym_register] = ACTIONS(3076),
    [anon_sym_inline] = ACTIONS(3076),
    [anon_sym___inline] = ACTIONS(3076),
    [anon_sym___inline__] = ACTIONS(3076),
    [anon_sym___forceinline] = ACTIONS(3076),
    [anon_sym_thread_local] = ACTIONS(3076),
    [anon_sym___thread] = ACTIONS(3076),
    [anon_sym_const] = ACTIONS(3076),
    [anon_sym_constexpr] = ACTIONS(3076),
    [anon_sym_volatile] = ACTIONS(3076),
    [anon_sym_restrict] = ACTIONS(3076),
    [anon_sym___restrict__] = ACTIONS(3076),
    [anon_sym__Atomic] = ACTIONS(3076),
    [anon_sym__Noreturn] = ACTIONS(3076),
    [anon_sym_noreturn] = ACTIONS(3076),
    [anon_sym_mutable] = ACTIONS(3076),
    [anon_sym_constinit] = ACTIONS(3076),
    [anon_sym_consteval] = ACTIONS(3076),
    [anon_sym_alignas] = ACTIONS(3076),
    [anon_sym__Alignas] = ACTIONS(3076),
    [sym_primitive_type] = ACTIONS(3076),
    [anon_sym_enum] = ACTIONS(3076),
    [anon_sym_class] = ACTIONS(3076),
    [anon_sym_struct] = ACTIONS(3076),
    [anon_sym_union] = ACTIONS(3076),
    [anon_sym_if] = ACTIONS(3076),
    [anon_sym_else] = ACTIONS(3076),
    [anon_sym_switch] = ACTIONS(3076),
    [anon_sym_while] = ACTIONS(3076),
    [anon_sym_do] = ACTIONS(3076),
    [anon_sym_for] = ACTIONS(3076),
    [anon_sym_return] = ACTIONS(3076),
    [anon_sym_break] = ACTIONS(3076),
    [anon_sym_continue] = ACTIONS(3076),
    [anon_sym_goto] = ACTIONS(3076),
    [anon_sym___try] = ACTIONS(3076),
    [anon_sym___leave] = ACTIONS(3076),
    [anon_sym_not] = ACTIONS(3076),
    [anon_sym_compl] = ACTIONS(3076),
    [anon_sym_DASH_DASH] = ACTIONS(3078),
    [anon_sym_PLUS_PLUS] = ACTIONS(3078),
    [anon_sym_sizeof] = ACTIONS(3076),
    [anon_sym___alignof__] = ACTIONS(3076),
    [anon_sym___alignof] = ACTIONS(3076),
    [anon_sym__alignof] = ACTIONS(3076),
    [anon_sym_alignof] = ACTIONS(3076),
    [anon_sym__Alignof] = ACTIONS(3076),
    [anon_sym_offsetof] = ACTIONS(3076),
    [anon_sym__Generic] = ACTIONS(3076),
    [anon_sym_asm] = ACTIONS(3076),
    [anon_sym___asm__] = ACTIONS(3076),
    [sym_number_literal] = ACTIONS(3078),
    [anon_sym_L_SQUOTE] = ACTIONS(3078),
    [anon_sym_u_SQUOTE] = ACTIONS(3078),
    [anon_sym_U_SQUOTE] = ACTIONS(3078),
    [anon_sym_u8_SQUOTE] = ACTIONS(3078),
    [anon_sym_SQUOTE] = ACTIONS(3078),
    [anon_sym_L_DQUOTE] = ACTIONS(3078),
    [anon_sym_u_DQUOTE] = ACTIONS(3078),
    [anon_sym_U_DQUOTE] = ACTIONS(3078),
    [anon_sym_u8_DQUOTE] = ACTIONS(3078),
    [anon_sym_DQUOTE] = ACTIONS(3078),
    [sym_true] = ACTIONS(3076),
    [sym_false] = ACTIONS(3076),
    [anon_sym_NULL] = ACTIONS(3076),
    [anon_sym_nullptr] = ACTIONS(3076),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3076),
    [anon_sym_let] = ACTIONS(3076),
    [anon_sym_This] = ACTIONS(3076),
    [anon_sym_decltype] = ACTIONS(3076),
    [sym_virtual] = ACTIONS(3076),
    [anon_sym_typename] = ACTIONS(3076),
    [anon_sym_template] = ACTIONS(3076),
    [anon_sym_try] = ACTIONS(3076),
    [anon_sym_delete] = ACTIONS(3076),
    [anon_sym_throw] = ACTIONS(3076),
    [anon_sym_co_return] = ACTIONS(3076),
    [anon_sym_co_yield] = ACTIONS(3076),
    [anon_sym_R_DQUOTE] = ACTIONS(3078),
    [anon_sym_LR_DQUOTE] = ACTIONS(3078),
    [anon_sym_uR_DQUOTE] = ACTIONS(3078),
    [anon_sym_UR_DQUOTE] = ACTIONS(3078),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3078),
    [anon_sym_co_await] = ACTIONS(3076),
    [anon_sym_new] = ACTIONS(3076),
    [anon_sym_requires] = ACTIONS(3076),
    [sym_this] = ACTIONS(3076),
    [anon_sym_discard] = ACTIONS(3076),
    [anon_sym_precise] = ACTIONS(3076),
    [anon_sym_shared] = ACTIONS(3076),
    [anon_sym_groupshared] = ACTIONS(3076),
    [anon_sym_uniform] = ACTIONS(3076),
    [anon_sym_row_major] = ACTIONS(3076),
    [anon_sym_column_major] = ACTIONS(3076),
    [anon_sym_globallycoherent] = ACTIONS(3076),
    [anon_sym_centroid] = ACTIONS(3076),
    [anon_sym_noperspective] = ACTIONS(3076),
    [anon_sym_nointerpolation] = ACTIONS(3076),
    [anon_sym_sample] = ACTIONS(3076),
    [anon_sym_linear] = ACTIONS(3076),
    [anon_sym_snorm] = ACTIONS(3076),
    [anon_sym_unorm] = ACTIONS(3076),
    [anon_sym_point] = ACTIONS(3076),
    [anon_sym_line] = ACTIONS(3076),
    [anon_sym_triangleadj] = ACTIONS(3076),
    [anon_sym_lineadj] = ACTIONS(3076),
    [anon_sym_triangle] = ACTIONS(3076),
    [anon_sym_cbuffer] = ACTIONS(3076),
    [anon_sym_interface] = ACTIONS(3076),
    [anon_sym_extension] = ACTIONS(3076),
  },
  [1305] = {
    [sym_identifier] = ACTIONS(3222),
    [anon_sym_LPAREN2] = ACTIONS(3224),
    [anon_sym_BANG] = ACTIONS(3224),
    [anon_sym_TILDE] = ACTIONS(3224),
    [anon_sym_DASH] = ACTIONS(3222),
    [anon_sym_PLUS] = ACTIONS(3222),
    [anon_sym_STAR] = ACTIONS(3224),
    [anon_sym_AMP] = ACTIONS(3224),
    [anon_sym_SEMI] = ACTIONS(3224),
    [anon_sym___extension__] = ACTIONS(3222),
    [anon_sym_typedef] = ACTIONS(3222),
    [anon_sym_in] = ACTIONS(3222),
    [anon_sym_out] = ACTIONS(3222),
    [anon_sym_inout] = ACTIONS(3222),
    [anon_sym_extern] = ACTIONS(3222),
    [anon_sym___attribute__] = ACTIONS(3222),
    [anon_sym_COLON_COLON] = ACTIONS(3224),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3224),
    [anon_sym___declspec] = ACTIONS(3222),
    [anon_sym_LBRACE] = ACTIONS(3224),
    [anon_sym_signed] = ACTIONS(3222),
    [anon_sym_unsigned] = ACTIONS(3222),
    [anon_sym_long] = ACTIONS(3222),
    [anon_sym_short] = ACTIONS(3222),
    [anon_sym_LBRACK] = ACTIONS(3222),
    [anon_sym_static] = ACTIONS(3222),
    [anon_sym_register] = ACTIONS(3222),
    [anon_sym_inline] = ACTIONS(3222),
    [anon_sym___inline] = ACTIONS(3222),
    [anon_sym___inline__] = ACTIONS(3222),
    [anon_sym___forceinline] = ACTIONS(3222),
    [anon_sym_thread_local] = ACTIONS(3222),
    [anon_sym___thread] = ACTIONS(3222),
    [anon_sym_const] = ACTIONS(3222),
    [anon_sym_constexpr] = ACTIONS(3222),
    [anon_sym_volatile] = ACTIONS(3222),
    [anon_sym_restrict] = ACTIONS(3222),
    [anon_sym___restrict__] = ACTIONS(3222),
    [anon_sym__Atomic] = ACTIONS(3222),
    [anon_sym__Noreturn] = ACTIONS(3222),
    [anon_sym_noreturn] = ACTIONS(3222),
    [anon_sym_mutable] = ACTIONS(3222),
    [anon_sym_constinit] = ACTIONS(3222),
    [anon_sym_consteval] = ACTIONS(3222),
    [anon_sym_alignas] = ACTIONS(3222),
    [anon_sym__Alignas] = ACTIONS(3222),
    [sym_primitive_type] = ACTIONS(3222),
    [anon_sym_enum] = ACTIONS(3222),
    [anon_sym_class] = ACTIONS(3222),
    [anon_sym_struct] = ACTIONS(3222),
    [anon_sym_union] = ACTIONS(3222),
    [anon_sym_if] = ACTIONS(3222),
    [anon_sym_else] = ACTIONS(3222),
    [anon_sym_switch] = ACTIONS(3222),
    [anon_sym_while] = ACTIONS(3222),
    [anon_sym_do] = ACTIONS(3222),
    [anon_sym_for] = ACTIONS(3222),
    [anon_sym_return] = ACTIONS(3222),
    [anon_sym_break] = ACTIONS(3222),
    [anon_sym_continue] = ACTIONS(3222),
    [anon_sym_goto] = ACTIONS(3222),
    [anon_sym___try] = ACTIONS(3222),
    [anon_sym___leave] = ACTIONS(3222),
    [anon_sym_not] = ACTIONS(3222),
    [anon_sym_compl] = ACTIONS(3222),
    [anon_sym_DASH_DASH] = ACTIONS(3224),
    [anon_sym_PLUS_PLUS] = ACTIONS(3224),
    [anon_sym_sizeof] = ACTIONS(3222),
    [anon_sym___alignof__] = ACTIONS(3222),
    [anon_sym___alignof] = ACTIONS(3222),
    [anon_sym__alignof] = ACTIONS(3222),
    [anon_sym_alignof] = ACTIONS(3222),
    [anon_sym__Alignof] = ACTIONS(3222),
    [anon_sym_offsetof] = ACTIONS(3222),
    [anon_sym__Generic] = ACTIONS(3222),
    [anon_sym_asm] = ACTIONS(3222),
    [anon_sym___asm__] = ACTIONS(3222),
    [sym_number_literal] = ACTIONS(3224),
    [anon_sym_L_SQUOTE] = ACTIONS(3224),
    [anon_sym_u_SQUOTE] = ACTIONS(3224),
    [anon_sym_U_SQUOTE] = ACTIONS(3224),
    [anon_sym_u8_SQUOTE] = ACTIONS(3224),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_L_DQUOTE] = ACTIONS(3224),
    [anon_sym_u_DQUOTE] = ACTIONS(3224),
    [anon_sym_U_DQUOTE] = ACTIONS(3224),
    [anon_sym_u8_DQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3224),
    [sym_true] = ACTIONS(3222),
    [sym_false] = ACTIONS(3222),
    [anon_sym_NULL] = ACTIONS(3222),
    [anon_sym_nullptr] = ACTIONS(3222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3222),
    [anon_sym_let] = ACTIONS(3222),
    [anon_sym_This] = ACTIONS(3222),
    [anon_sym_decltype] = ACTIONS(3222),
    [sym_virtual] = ACTIONS(3222),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3222),
    [anon_sym_try] = ACTIONS(3222),
    [anon_sym_delete] = ACTIONS(3222),
    [anon_sym_throw] = ACTIONS(3222),
    [anon_sym_co_return] = ACTIONS(3222),
    [anon_sym_co_yield] = ACTIONS(3222),
    [anon_sym_R_DQUOTE] = ACTIONS(3224),
    [anon_sym_LR_DQUOTE] = ACTIONS(3224),
    [anon_sym_uR_DQUOTE] = ACTIONS(3224),
    [anon_sym_UR_DQUOTE] = ACTIONS(3224),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3224),
    [anon_sym_co_await] = ACTIONS(3222),
    [anon_sym_new] = ACTIONS(3222),
    [anon_sym_requires] = ACTIONS(3222),
    [sym_this] = ACTIONS(3222),
    [anon_sym_discard] = ACTIONS(3222),
    [anon_sym_precise] = ACTIONS(3222),
    [anon_sym_shared] = ACTIONS(3222),
    [anon_sym_groupshared] = ACTIONS(3222),
    [anon_sym_uniform] = ACTIONS(3222),
    [anon_sym_row_major] = ACTIONS(3222),
    [anon_sym_column_major] = ACTIONS(3222),
    [anon_sym_globallycoherent] = ACTIONS(3222),
    [anon_sym_centroid] = ACTIONS(3222),
    [anon_sym_noperspective] = ACTIONS(3222),
    [anon_sym_nointerpolation] = ACTIONS(3222),
    [anon_sym_sample] = ACTIONS(3222),
    [anon_sym_linear] = ACTIONS(3222),
    [anon_sym_snorm] = ACTIONS(3222),
    [anon_sym_unorm] = ACTIONS(3222),
    [anon_sym_point] = ACTIONS(3222),
    [anon_sym_line] = ACTIONS(3222),
    [anon_sym_triangleadj] = ACTIONS(3222),
    [anon_sym_lineadj] = ACTIONS(3222),
    [anon_sym_triangle] = ACTIONS(3222),
    [anon_sym_cbuffer] = ACTIONS(3222),
    [anon_sym_interface] = ACTIONS(3222),
    [anon_sym_extension] = ACTIONS(3222),
  },
  [1306] = {
    [sym_identifier] = ACTIONS(3092),
    [anon_sym_LPAREN2] = ACTIONS(3094),
    [anon_sym_BANG] = ACTIONS(3094),
    [anon_sym_TILDE] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_STAR] = ACTIONS(3094),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3094),
    [anon_sym___extension__] = ACTIONS(3092),
    [anon_sym_typedef] = ACTIONS(3092),
    [anon_sym_in] = ACTIONS(3092),
    [anon_sym_out] = ACTIONS(3092),
    [anon_sym_inout] = ACTIONS(3092),
    [anon_sym_extern] = ACTIONS(3092),
    [anon_sym___attribute__] = ACTIONS(3092),
    [anon_sym_COLON_COLON] = ACTIONS(3094),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3094),
    [anon_sym___declspec] = ACTIONS(3092),
    [anon_sym_LBRACE] = ACTIONS(3094),
    [anon_sym_signed] = ACTIONS(3092),
    [anon_sym_unsigned] = ACTIONS(3092),
    [anon_sym_long] = ACTIONS(3092),
    [anon_sym_short] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_static] = ACTIONS(3092),
    [anon_sym_register] = ACTIONS(3092),
    [anon_sym_inline] = ACTIONS(3092),
    [anon_sym___inline] = ACTIONS(3092),
    [anon_sym___inline__] = ACTIONS(3092),
    [anon_sym___forceinline] = ACTIONS(3092),
    [anon_sym_thread_local] = ACTIONS(3092),
    [anon_sym___thread] = ACTIONS(3092),
    [anon_sym_const] = ACTIONS(3092),
    [anon_sym_constexpr] = ACTIONS(3092),
    [anon_sym_volatile] = ACTIONS(3092),
    [anon_sym_restrict] = ACTIONS(3092),
    [anon_sym___restrict__] = ACTIONS(3092),
    [anon_sym__Atomic] = ACTIONS(3092),
    [anon_sym__Noreturn] = ACTIONS(3092),
    [anon_sym_noreturn] = ACTIONS(3092),
    [anon_sym_mutable] = ACTIONS(3092),
    [anon_sym_constinit] = ACTIONS(3092),
    [anon_sym_consteval] = ACTIONS(3092),
    [anon_sym_alignas] = ACTIONS(3092),
    [anon_sym__Alignas] = ACTIONS(3092),
    [sym_primitive_type] = ACTIONS(3092),
    [anon_sym_enum] = ACTIONS(3092),
    [anon_sym_class] = ACTIONS(3092),
    [anon_sym_struct] = ACTIONS(3092),
    [anon_sym_union] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_else] = ACTIONS(3092),
    [anon_sym_switch] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_break] = ACTIONS(3092),
    [anon_sym_continue] = ACTIONS(3092),
    [anon_sym_goto] = ACTIONS(3092),
    [anon_sym___try] = ACTIONS(3092),
    [anon_sym___leave] = ACTIONS(3092),
    [anon_sym_not] = ACTIONS(3092),
    [anon_sym_compl] = ACTIONS(3092),
    [anon_sym_DASH_DASH] = ACTIONS(3094),
    [anon_sym_PLUS_PLUS] = ACTIONS(3094),
    [anon_sym_sizeof] = ACTIONS(3092),
    [anon_sym___alignof__] = ACTIONS(3092),
    [anon_sym___alignof] = ACTIONS(3092),
    [anon_sym__alignof] = ACTIONS(3092),
    [anon_sym_alignof] = ACTIONS(3092),
    [anon_sym__Alignof] = ACTIONS(3092),
    [anon_sym_offsetof] = ACTIONS(3092),
    [anon_sym__Generic] = ACTIONS(3092),
    [anon_sym_asm] = ACTIONS(3092),
    [anon_sym___asm__] = ACTIONS(3092),
    [sym_number_literal] = ACTIONS(3094),
    [anon_sym_L_SQUOTE] = ACTIONS(3094),
    [anon_sym_u_SQUOTE] = ACTIONS(3094),
    [anon_sym_U_SQUOTE] = ACTIONS(3094),
    [anon_sym_u8_SQUOTE] = ACTIONS(3094),
    [anon_sym_SQUOTE] = ACTIONS(3094),
    [anon_sym_L_DQUOTE] = ACTIONS(3094),
    [anon_sym_u_DQUOTE] = ACTIONS(3094),
    [anon_sym_U_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8_DQUOTE] = ACTIONS(3094),
    [anon_sym_DQUOTE] = ACTIONS(3094),
    [sym_true] = ACTIONS(3092),
    [sym_false] = ACTIONS(3092),
    [anon_sym_NULL] = ACTIONS(3092),
    [anon_sym_nullptr] = ACTIONS(3092),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3092),
    [anon_sym_let] = ACTIONS(3092),
    [anon_sym_This] = ACTIONS(3092),
    [anon_sym_decltype] = ACTIONS(3092),
    [sym_virtual] = ACTIONS(3092),
    [anon_sym_typename] = ACTIONS(3092),
    [anon_sym_template] = ACTIONS(3092),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_delete] = ACTIONS(3092),
    [anon_sym_throw] = ACTIONS(3092),
    [anon_sym_co_return] = ACTIONS(3092),
    [anon_sym_co_yield] = ACTIONS(3092),
    [anon_sym_R_DQUOTE] = ACTIONS(3094),
    [anon_sym_LR_DQUOTE] = ACTIONS(3094),
    [anon_sym_uR_DQUOTE] = ACTIONS(3094),
    [anon_sym_UR_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3094),
    [anon_sym_co_await] = ACTIONS(3092),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_requires] = ACTIONS(3092),
    [sym_this] = ACTIONS(3092),
    [anon_sym_discard] = ACTIONS(3092),
    [anon_sym_precise] = ACTIONS(3092),
    [anon_sym_shared] = ACTIONS(3092),
    [anon_sym_groupshared] = ACTIONS(3092),
    [anon_sym_uniform] = ACTIONS(3092),
    [anon_sym_row_major] = ACTIONS(3092),
    [anon_sym_column_major] = ACTIONS(3092),
    [anon_sym_globallycoherent] = ACTIONS(3092),
    [anon_sym_centroid] = ACTIONS(3092),
    [anon_sym_noperspective] = ACTIONS(3092),
    [anon_sym_nointerpolation] = ACTIONS(3092),
    [anon_sym_sample] = ACTIONS(3092),
    [anon_sym_linear] = ACTIONS(3092),
    [anon_sym_snorm] = ACTIONS(3092),
    [anon_sym_unorm] = ACTIONS(3092),
    [anon_sym_point] = ACTIONS(3092),
    [anon_sym_line] = ACTIONS(3092),
    [anon_sym_triangleadj] = ACTIONS(3092),
    [anon_sym_lineadj] = ACTIONS(3092),
    [anon_sym_triangle] = ACTIONS(3092),
    [anon_sym_cbuffer] = ACTIONS(3092),
    [anon_sym_interface] = ACTIONS(3092),
    [anon_sym_extension] = ACTIONS(3092),
  },
  [1307] = {
    [sym_identifier] = ACTIONS(3250),
    [anon_sym_LPAREN2] = ACTIONS(3252),
    [anon_sym_BANG] = ACTIONS(3252),
    [anon_sym_TILDE] = ACTIONS(3252),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_STAR] = ACTIONS(3252),
    [anon_sym_AMP] = ACTIONS(3252),
    [anon_sym_SEMI] = ACTIONS(3252),
    [anon_sym___extension__] = ACTIONS(3250),
    [anon_sym_typedef] = ACTIONS(3250),
    [anon_sym_in] = ACTIONS(3250),
    [anon_sym_out] = ACTIONS(3250),
    [anon_sym_inout] = ACTIONS(3250),
    [anon_sym_extern] = ACTIONS(3250),
    [anon_sym___attribute__] = ACTIONS(3250),
    [anon_sym_COLON_COLON] = ACTIONS(3252),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3252),
    [anon_sym___declspec] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3252),
    [anon_sym_signed] = ACTIONS(3250),
    [anon_sym_unsigned] = ACTIONS(3250),
    [anon_sym_long] = ACTIONS(3250),
    [anon_sym_short] = ACTIONS(3250),
    [anon_sym_LBRACK] = ACTIONS(3250),
    [anon_sym_static] = ACTIONS(3250),
    [anon_sym_register] = ACTIONS(3250),
    [anon_sym_inline] = ACTIONS(3250),
    [anon_sym___inline] = ACTIONS(3250),
    [anon_sym___inline__] = ACTIONS(3250),
    [anon_sym___forceinline] = ACTIONS(3250),
    [anon_sym_thread_local] = ACTIONS(3250),
    [anon_sym___thread] = ACTIONS(3250),
    [anon_sym_const] = ACTIONS(3250),
    [anon_sym_constexpr] = ACTIONS(3250),
    [anon_sym_volatile] = ACTIONS(3250),
    [anon_sym_restrict] = ACTIONS(3250),
    [anon_sym___restrict__] = ACTIONS(3250),
    [anon_sym__Atomic] = ACTIONS(3250),
    [anon_sym__Noreturn] = ACTIONS(3250),
    [anon_sym_noreturn] = ACTIONS(3250),
    [anon_sym_mutable] = ACTIONS(3250),
    [anon_sym_constinit] = ACTIONS(3250),
    [anon_sym_consteval] = ACTIONS(3250),
    [anon_sym_alignas] = ACTIONS(3250),
    [anon_sym__Alignas] = ACTIONS(3250),
    [sym_primitive_type] = ACTIONS(3250),
    [anon_sym_enum] = ACTIONS(3250),
    [anon_sym_class] = ACTIONS(3250),
    [anon_sym_struct] = ACTIONS(3250),
    [anon_sym_union] = ACTIONS(3250),
    [anon_sym_if] = ACTIONS(3250),
    [anon_sym_else] = ACTIONS(3250),
    [anon_sym_switch] = ACTIONS(3250),
    [anon_sym_while] = ACTIONS(3250),
    [anon_sym_do] = ACTIONS(3250),
    [anon_sym_for] = ACTIONS(3250),
    [anon_sym_return] = ACTIONS(3250),
    [anon_sym_break] = ACTIONS(3250),
    [anon_sym_continue] = ACTIONS(3250),
    [anon_sym_goto] = ACTIONS(3250),
    [anon_sym___try] = ACTIONS(3250),
    [anon_sym___leave] = ACTIONS(3250),
    [anon_sym_not] = ACTIONS(3250),
    [anon_sym_compl] = ACTIONS(3250),
    [anon_sym_DASH_DASH] = ACTIONS(3252),
    [anon_sym_PLUS_PLUS] = ACTIONS(3252),
    [anon_sym_sizeof] = ACTIONS(3250),
    [anon_sym___alignof__] = ACTIONS(3250),
    [anon_sym___alignof] = ACTIONS(3250),
    [anon_sym__alignof] = ACTIONS(3250),
    [anon_sym_alignof] = ACTIONS(3250),
    [anon_sym__Alignof] = ACTIONS(3250),
    [anon_sym_offsetof] = ACTIONS(3250),
    [anon_sym__Generic] = ACTIONS(3250),
    [anon_sym_asm] = ACTIONS(3250),
    [anon_sym___asm__] = ACTIONS(3250),
    [sym_number_literal] = ACTIONS(3252),
    [anon_sym_L_SQUOTE] = ACTIONS(3252),
    [anon_sym_u_SQUOTE] = ACTIONS(3252),
    [anon_sym_U_SQUOTE] = ACTIONS(3252),
    [anon_sym_u8_SQUOTE] = ACTIONS(3252),
    [anon_sym_SQUOTE] = ACTIONS(3252),
    [anon_sym_L_DQUOTE] = ACTIONS(3252),
    [anon_sym_u_DQUOTE] = ACTIONS(3252),
    [anon_sym_U_DQUOTE] = ACTIONS(3252),
    [anon_sym_u8_DQUOTE] = ACTIONS(3252),
    [anon_sym_DQUOTE] = ACTIONS(3252),
    [sym_true] = ACTIONS(3250),
    [sym_false] = ACTIONS(3250),
    [anon_sym_NULL] = ACTIONS(3250),
    [anon_sym_nullptr] = ACTIONS(3250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3250),
    [anon_sym_let] = ACTIONS(3250),
    [anon_sym_This] = ACTIONS(3250),
    [anon_sym_decltype] = ACTIONS(3250),
    [sym_virtual] = ACTIONS(3250),
    [anon_sym_typename] = ACTIONS(3250),
    [anon_sym_template] = ACTIONS(3250),
    [anon_sym_try] = ACTIONS(3250),
    [anon_sym_delete] = ACTIONS(3250),
    [anon_sym_throw] = ACTIONS(3250),
    [anon_sym_co_return] = ACTIONS(3250),
    [anon_sym_co_yield] = ACTIONS(3250),
    [anon_sym_R_DQUOTE] = ACTIONS(3252),
    [anon_sym_LR_DQUOTE] = ACTIONS(3252),
    [anon_sym_uR_DQUOTE] = ACTIONS(3252),
    [anon_sym_UR_DQUOTE] = ACTIONS(3252),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3252),
    [anon_sym_co_await] = ACTIONS(3250),
    [anon_sym_new] = ACTIONS(3250),
    [anon_sym_requires] = ACTIONS(3250),
    [sym_this] = ACTIONS(3250),
    [anon_sym_discard] = ACTIONS(3250),
    [anon_sym_precise] = ACTIONS(3250),
    [anon_sym_shared] = ACTIONS(3250),
    [anon_sym_groupshared] = ACTIONS(3250),
    [anon_sym_uniform] = ACTIONS(3250),
    [anon_sym_row_major] = ACTIONS(3250),
    [anon_sym_column_major] = ACTIONS(3250),
    [anon_sym_globallycoherent] = ACTIONS(3250),
    [anon_sym_centroid] = ACTIONS(3250),
    [anon_sym_noperspective] = ACTIONS(3250),
    [anon_sym_nointerpolation] = ACTIONS(3250),
    [anon_sym_sample] = ACTIONS(3250),
    [anon_sym_linear] = ACTIONS(3250),
    [anon_sym_snorm] = ACTIONS(3250),
    [anon_sym_unorm] = ACTIONS(3250),
    [anon_sym_point] = ACTIONS(3250),
    [anon_sym_line] = ACTIONS(3250),
    [anon_sym_triangleadj] = ACTIONS(3250),
    [anon_sym_lineadj] = ACTIONS(3250),
    [anon_sym_triangle] = ACTIONS(3250),
    [anon_sym_cbuffer] = ACTIONS(3250),
    [anon_sym_interface] = ACTIONS(3250),
    [anon_sym_extension] = ACTIONS(3250),
  },
  [1308] = {
    [sym_identifier] = ACTIONS(3178),
    [anon_sym_LPAREN2] = ACTIONS(3180),
    [anon_sym_BANG] = ACTIONS(3180),
    [anon_sym_TILDE] = ACTIONS(3180),
    [anon_sym_DASH] = ACTIONS(3178),
    [anon_sym_PLUS] = ACTIONS(3178),
    [anon_sym_STAR] = ACTIONS(3180),
    [anon_sym_AMP] = ACTIONS(3180),
    [anon_sym_SEMI] = ACTIONS(3180),
    [anon_sym___extension__] = ACTIONS(3178),
    [anon_sym_typedef] = ACTIONS(3178),
    [anon_sym_in] = ACTIONS(3178),
    [anon_sym_out] = ACTIONS(3178),
    [anon_sym_inout] = ACTIONS(3178),
    [anon_sym_extern] = ACTIONS(3178),
    [anon_sym___attribute__] = ACTIONS(3178),
    [anon_sym_COLON_COLON] = ACTIONS(3180),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3180),
    [anon_sym___declspec] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(3180),
    [anon_sym_signed] = ACTIONS(3178),
    [anon_sym_unsigned] = ACTIONS(3178),
    [anon_sym_long] = ACTIONS(3178),
    [anon_sym_short] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(3178),
    [anon_sym_static] = ACTIONS(3178),
    [anon_sym_register] = ACTIONS(3178),
    [anon_sym_inline] = ACTIONS(3178),
    [anon_sym___inline] = ACTIONS(3178),
    [anon_sym___inline__] = ACTIONS(3178),
    [anon_sym___forceinline] = ACTIONS(3178),
    [anon_sym_thread_local] = ACTIONS(3178),
    [anon_sym___thread] = ACTIONS(3178),
    [anon_sym_const] = ACTIONS(3178),
    [anon_sym_constexpr] = ACTIONS(3178),
    [anon_sym_volatile] = ACTIONS(3178),
    [anon_sym_restrict] = ACTIONS(3178),
    [anon_sym___restrict__] = ACTIONS(3178),
    [anon_sym__Atomic] = ACTIONS(3178),
    [anon_sym__Noreturn] = ACTIONS(3178),
    [anon_sym_noreturn] = ACTIONS(3178),
    [anon_sym_mutable] = ACTIONS(3178),
    [anon_sym_constinit] = ACTIONS(3178),
    [anon_sym_consteval] = ACTIONS(3178),
    [anon_sym_alignas] = ACTIONS(3178),
    [anon_sym__Alignas] = ACTIONS(3178),
    [sym_primitive_type] = ACTIONS(3178),
    [anon_sym_enum] = ACTIONS(3178),
    [anon_sym_class] = ACTIONS(3178),
    [anon_sym_struct] = ACTIONS(3178),
    [anon_sym_union] = ACTIONS(3178),
    [anon_sym_if] = ACTIONS(3178),
    [anon_sym_else] = ACTIONS(3178),
    [anon_sym_switch] = ACTIONS(3178),
    [anon_sym_while] = ACTIONS(3178),
    [anon_sym_do] = ACTIONS(3178),
    [anon_sym_for] = ACTIONS(3178),
    [anon_sym_return] = ACTIONS(3178),
    [anon_sym_break] = ACTIONS(3178),
    [anon_sym_continue] = ACTIONS(3178),
    [anon_sym_goto] = ACTIONS(3178),
    [anon_sym___try] = ACTIONS(3178),
    [anon_sym___leave] = ACTIONS(3178),
    [anon_sym_not] = ACTIONS(3178),
    [anon_sym_compl] = ACTIONS(3178),
    [anon_sym_DASH_DASH] = ACTIONS(3180),
    [anon_sym_PLUS_PLUS] = ACTIONS(3180),
    [anon_sym_sizeof] = ACTIONS(3178),
    [anon_sym___alignof__] = ACTIONS(3178),
    [anon_sym___alignof] = ACTIONS(3178),
    [anon_sym__alignof] = ACTIONS(3178),
    [anon_sym_alignof] = ACTIONS(3178),
    [anon_sym__Alignof] = ACTIONS(3178),
    [anon_sym_offsetof] = ACTIONS(3178),
    [anon_sym__Generic] = ACTIONS(3178),
    [anon_sym_asm] = ACTIONS(3178),
    [anon_sym___asm__] = ACTIONS(3178),
    [sym_number_literal] = ACTIONS(3180),
    [anon_sym_L_SQUOTE] = ACTIONS(3180),
    [anon_sym_u_SQUOTE] = ACTIONS(3180),
    [anon_sym_U_SQUOTE] = ACTIONS(3180),
    [anon_sym_u8_SQUOTE] = ACTIONS(3180),
    [anon_sym_SQUOTE] = ACTIONS(3180),
    [anon_sym_L_DQUOTE] = ACTIONS(3180),
    [anon_sym_u_DQUOTE] = ACTIONS(3180),
    [anon_sym_U_DQUOTE] = ACTIONS(3180),
    [anon_sym_u8_DQUOTE] = ACTIONS(3180),
    [anon_sym_DQUOTE] = ACTIONS(3180),
    [sym_true] = ACTIONS(3178),
    [sym_false] = ACTIONS(3178),
    [anon_sym_NULL] = ACTIONS(3178),
    [anon_sym_nullptr] = ACTIONS(3178),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3178),
    [anon_sym_let] = ACTIONS(3178),
    [anon_sym_This] = ACTIONS(3178),
    [anon_sym_decltype] = ACTIONS(3178),
    [sym_virtual] = ACTIONS(3178),
    [anon_sym_typename] = ACTIONS(3178),
    [anon_sym_template] = ACTIONS(3178),
    [anon_sym_try] = ACTIONS(3178),
    [anon_sym_delete] = ACTIONS(3178),
    [anon_sym_throw] = ACTIONS(3178),
    [anon_sym_co_return] = ACTIONS(3178),
    [anon_sym_co_yield] = ACTIONS(3178),
    [anon_sym_R_DQUOTE] = ACTIONS(3180),
    [anon_sym_LR_DQUOTE] = ACTIONS(3180),
    [anon_sym_uR_DQUOTE] = ACTIONS(3180),
    [anon_sym_UR_DQUOTE] = ACTIONS(3180),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3180),
    [anon_sym_co_await] = ACTIONS(3178),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3178),
    [sym_this] = ACTIONS(3178),
    [anon_sym_discard] = ACTIONS(3178),
    [anon_sym_precise] = ACTIONS(3178),
    [anon_sym_shared] = ACTIONS(3178),
    [anon_sym_groupshared] = ACTIONS(3178),
    [anon_sym_uniform] = ACTIONS(3178),
    [anon_sym_row_major] = ACTIONS(3178),
    [anon_sym_column_major] = ACTIONS(3178),
    [anon_sym_globallycoherent] = ACTIONS(3178),
    [anon_sym_centroid] = ACTIONS(3178),
    [anon_sym_noperspective] = ACTIONS(3178),
    [anon_sym_nointerpolation] = ACTIONS(3178),
    [anon_sym_sample] = ACTIONS(3178),
    [anon_sym_linear] = ACTIONS(3178),
    [anon_sym_snorm] = ACTIONS(3178),
    [anon_sym_unorm] = ACTIONS(3178),
    [anon_sym_point] = ACTIONS(3178),
    [anon_sym_line] = ACTIONS(3178),
    [anon_sym_triangleadj] = ACTIONS(3178),
    [anon_sym_lineadj] = ACTIONS(3178),
    [anon_sym_triangle] = ACTIONS(3178),
    [anon_sym_cbuffer] = ACTIONS(3178),
    [anon_sym_interface] = ACTIONS(3178),
    [anon_sym_extension] = ACTIONS(3178),
  },
  [1309] = {
    [sym_identifier] = ACTIONS(3158),
    [anon_sym_LPAREN2] = ACTIONS(3160),
    [anon_sym_BANG] = ACTIONS(3160),
    [anon_sym_TILDE] = ACTIONS(3160),
    [anon_sym_DASH] = ACTIONS(3158),
    [anon_sym_PLUS] = ACTIONS(3158),
    [anon_sym_STAR] = ACTIONS(3160),
    [anon_sym_AMP] = ACTIONS(3160),
    [anon_sym_SEMI] = ACTIONS(3160),
    [anon_sym___extension__] = ACTIONS(3158),
    [anon_sym_typedef] = ACTIONS(3158),
    [anon_sym_in] = ACTIONS(3158),
    [anon_sym_out] = ACTIONS(3158),
    [anon_sym_inout] = ACTIONS(3158),
    [anon_sym_extern] = ACTIONS(3158),
    [anon_sym___attribute__] = ACTIONS(3158),
    [anon_sym_COLON_COLON] = ACTIONS(3160),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3160),
    [anon_sym___declspec] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3160),
    [anon_sym_signed] = ACTIONS(3158),
    [anon_sym_unsigned] = ACTIONS(3158),
    [anon_sym_long] = ACTIONS(3158),
    [anon_sym_short] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_static] = ACTIONS(3158),
    [anon_sym_register] = ACTIONS(3158),
    [anon_sym_inline] = ACTIONS(3158),
    [anon_sym___inline] = ACTIONS(3158),
    [anon_sym___inline__] = ACTIONS(3158),
    [anon_sym___forceinline] = ACTIONS(3158),
    [anon_sym_thread_local] = ACTIONS(3158),
    [anon_sym___thread] = ACTIONS(3158),
    [anon_sym_const] = ACTIONS(3158),
    [anon_sym_constexpr] = ACTIONS(3158),
    [anon_sym_volatile] = ACTIONS(3158),
    [anon_sym_restrict] = ACTIONS(3158),
    [anon_sym___restrict__] = ACTIONS(3158),
    [anon_sym__Atomic] = ACTIONS(3158),
    [anon_sym__Noreturn] = ACTIONS(3158),
    [anon_sym_noreturn] = ACTIONS(3158),
    [anon_sym_mutable] = ACTIONS(3158),
    [anon_sym_constinit] = ACTIONS(3158),
    [anon_sym_consteval] = ACTIONS(3158),
    [anon_sym_alignas] = ACTIONS(3158),
    [anon_sym__Alignas] = ACTIONS(3158),
    [sym_primitive_type] = ACTIONS(3158),
    [anon_sym_enum] = ACTIONS(3158),
    [anon_sym_class] = ACTIONS(3158),
    [anon_sym_struct] = ACTIONS(3158),
    [anon_sym_union] = ACTIONS(3158),
    [anon_sym_if] = ACTIONS(3158),
    [anon_sym_else] = ACTIONS(3158),
    [anon_sym_switch] = ACTIONS(3158),
    [anon_sym_while] = ACTIONS(3158),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_for] = ACTIONS(3158),
    [anon_sym_return] = ACTIONS(3158),
    [anon_sym_break] = ACTIONS(3158),
    [anon_sym_continue] = ACTIONS(3158),
    [anon_sym_goto] = ACTIONS(3158),
    [anon_sym___try] = ACTIONS(3158),
    [anon_sym___leave] = ACTIONS(3158),
    [anon_sym_not] = ACTIONS(3158),
    [anon_sym_compl] = ACTIONS(3158),
    [anon_sym_DASH_DASH] = ACTIONS(3160),
    [anon_sym_PLUS_PLUS] = ACTIONS(3160),
    [anon_sym_sizeof] = ACTIONS(3158),
    [anon_sym___alignof__] = ACTIONS(3158),
    [anon_sym___alignof] = ACTIONS(3158),
    [anon_sym__alignof] = ACTIONS(3158),
    [anon_sym_alignof] = ACTIONS(3158),
    [anon_sym__Alignof] = ACTIONS(3158),
    [anon_sym_offsetof] = ACTIONS(3158),
    [anon_sym__Generic] = ACTIONS(3158),
    [anon_sym_asm] = ACTIONS(3158),
    [anon_sym___asm__] = ACTIONS(3158),
    [sym_number_literal] = ACTIONS(3160),
    [anon_sym_L_SQUOTE] = ACTIONS(3160),
    [anon_sym_u_SQUOTE] = ACTIONS(3160),
    [anon_sym_U_SQUOTE] = ACTIONS(3160),
    [anon_sym_u8_SQUOTE] = ACTIONS(3160),
    [anon_sym_SQUOTE] = ACTIONS(3160),
    [anon_sym_L_DQUOTE] = ACTIONS(3160),
    [anon_sym_u_DQUOTE] = ACTIONS(3160),
    [anon_sym_U_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8_DQUOTE] = ACTIONS(3160),
    [anon_sym_DQUOTE] = ACTIONS(3160),
    [sym_true] = ACTIONS(3158),
    [sym_false] = ACTIONS(3158),
    [anon_sym_NULL] = ACTIONS(3158),
    [anon_sym_nullptr] = ACTIONS(3158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3158),
    [anon_sym_let] = ACTIONS(3158),
    [anon_sym_This] = ACTIONS(3158),
    [anon_sym_decltype] = ACTIONS(3158),
    [sym_virtual] = ACTIONS(3158),
    [anon_sym_typename] = ACTIONS(3158),
    [anon_sym_template] = ACTIONS(3158),
    [anon_sym_try] = ACTIONS(3158),
    [anon_sym_delete] = ACTIONS(3158),
    [anon_sym_throw] = ACTIONS(3158),
    [anon_sym_co_return] = ACTIONS(3158),
    [anon_sym_co_yield] = ACTIONS(3158),
    [anon_sym_R_DQUOTE] = ACTIONS(3160),
    [anon_sym_LR_DQUOTE] = ACTIONS(3160),
    [anon_sym_uR_DQUOTE] = ACTIONS(3160),
    [anon_sym_UR_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3160),
    [anon_sym_co_await] = ACTIONS(3158),
    [anon_sym_new] = ACTIONS(3158),
    [anon_sym_requires] = ACTIONS(3158),
    [sym_this] = ACTIONS(3158),
    [anon_sym_discard] = ACTIONS(3158),
    [anon_sym_precise] = ACTIONS(3158),
    [anon_sym_shared] = ACTIONS(3158),
    [anon_sym_groupshared] = ACTIONS(3158),
    [anon_sym_uniform] = ACTIONS(3158),
    [anon_sym_row_major] = ACTIONS(3158),
    [anon_sym_column_major] = ACTIONS(3158),
    [anon_sym_globallycoherent] = ACTIONS(3158),
    [anon_sym_centroid] = ACTIONS(3158),
    [anon_sym_noperspective] = ACTIONS(3158),
    [anon_sym_nointerpolation] = ACTIONS(3158),
    [anon_sym_sample] = ACTIONS(3158),
    [anon_sym_linear] = ACTIONS(3158),
    [anon_sym_snorm] = ACTIONS(3158),
    [anon_sym_unorm] = ACTIONS(3158),
    [anon_sym_point] = ACTIONS(3158),
    [anon_sym_line] = ACTIONS(3158),
    [anon_sym_triangleadj] = ACTIONS(3158),
    [anon_sym_lineadj] = ACTIONS(3158),
    [anon_sym_triangle] = ACTIONS(3158),
    [anon_sym_cbuffer] = ACTIONS(3158),
    [anon_sym_interface] = ACTIONS(3158),
    [anon_sym_extension] = ACTIONS(3158),
  },
  [1310] = {
    [sym_identifier] = ACTIONS(3182),
    [anon_sym_LPAREN2] = ACTIONS(3184),
    [anon_sym_BANG] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_DASH] = ACTIONS(3182),
    [anon_sym_PLUS] = ACTIONS(3182),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3184),
    [anon_sym_SEMI] = ACTIONS(3184),
    [anon_sym___extension__] = ACTIONS(3182),
    [anon_sym_typedef] = ACTIONS(3182),
    [anon_sym_in] = ACTIONS(3182),
    [anon_sym_out] = ACTIONS(3182),
    [anon_sym_inout] = ACTIONS(3182),
    [anon_sym_extern] = ACTIONS(3182),
    [anon_sym___attribute__] = ACTIONS(3182),
    [anon_sym_COLON_COLON] = ACTIONS(3184),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3184),
    [anon_sym___declspec] = ACTIONS(3182),
    [anon_sym_LBRACE] = ACTIONS(3184),
    [anon_sym_signed] = ACTIONS(3182),
    [anon_sym_unsigned] = ACTIONS(3182),
    [anon_sym_long] = ACTIONS(3182),
    [anon_sym_short] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3182),
    [anon_sym_register] = ACTIONS(3182),
    [anon_sym_inline] = ACTIONS(3182),
    [anon_sym___inline] = ACTIONS(3182),
    [anon_sym___inline__] = ACTIONS(3182),
    [anon_sym___forceinline] = ACTIONS(3182),
    [anon_sym_thread_local] = ACTIONS(3182),
    [anon_sym___thread] = ACTIONS(3182),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_constexpr] = ACTIONS(3182),
    [anon_sym_volatile] = ACTIONS(3182),
    [anon_sym_restrict] = ACTIONS(3182),
    [anon_sym___restrict__] = ACTIONS(3182),
    [anon_sym__Atomic] = ACTIONS(3182),
    [anon_sym__Noreturn] = ACTIONS(3182),
    [anon_sym_noreturn] = ACTIONS(3182),
    [anon_sym_mutable] = ACTIONS(3182),
    [anon_sym_constinit] = ACTIONS(3182),
    [anon_sym_consteval] = ACTIONS(3182),
    [anon_sym_alignas] = ACTIONS(3182),
    [anon_sym__Alignas] = ACTIONS(3182),
    [sym_primitive_type] = ACTIONS(3182),
    [anon_sym_enum] = ACTIONS(3182),
    [anon_sym_class] = ACTIONS(3182),
    [anon_sym_struct] = ACTIONS(3182),
    [anon_sym_union] = ACTIONS(3182),
    [anon_sym_if] = ACTIONS(3182),
    [anon_sym_else] = ACTIONS(3182),
    [anon_sym_switch] = ACTIONS(3182),
    [anon_sym_while] = ACTIONS(3182),
    [anon_sym_do] = ACTIONS(3182),
    [anon_sym_for] = ACTIONS(3182),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_break] = ACTIONS(3182),
    [anon_sym_continue] = ACTIONS(3182),
    [anon_sym_goto] = ACTIONS(3182),
    [anon_sym___try] = ACTIONS(3182),
    [anon_sym___leave] = ACTIONS(3182),
    [anon_sym_not] = ACTIONS(3182),
    [anon_sym_compl] = ACTIONS(3182),
    [anon_sym_DASH_DASH] = ACTIONS(3184),
    [anon_sym_PLUS_PLUS] = ACTIONS(3184),
    [anon_sym_sizeof] = ACTIONS(3182),
    [anon_sym___alignof__] = ACTIONS(3182),
    [anon_sym___alignof] = ACTIONS(3182),
    [anon_sym__alignof] = ACTIONS(3182),
    [anon_sym_alignof] = ACTIONS(3182),
    [anon_sym__Alignof] = ACTIONS(3182),
    [anon_sym_offsetof] = ACTIONS(3182),
    [anon_sym__Generic] = ACTIONS(3182),
    [anon_sym_asm] = ACTIONS(3182),
    [anon_sym___asm__] = ACTIONS(3182),
    [sym_number_literal] = ACTIONS(3184),
    [anon_sym_L_SQUOTE] = ACTIONS(3184),
    [anon_sym_u_SQUOTE] = ACTIONS(3184),
    [anon_sym_U_SQUOTE] = ACTIONS(3184),
    [anon_sym_u8_SQUOTE] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3184),
    [anon_sym_L_DQUOTE] = ACTIONS(3184),
    [anon_sym_u_DQUOTE] = ACTIONS(3184),
    [anon_sym_U_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8_DQUOTE] = ACTIONS(3184),
    [anon_sym_DQUOTE] = ACTIONS(3184),
    [sym_true] = ACTIONS(3182),
    [sym_false] = ACTIONS(3182),
    [anon_sym_NULL] = ACTIONS(3182),
    [anon_sym_nullptr] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3182),
    [anon_sym_let] = ACTIONS(3182),
    [anon_sym_This] = ACTIONS(3182),
    [anon_sym_decltype] = ACTIONS(3182),
    [sym_virtual] = ACTIONS(3182),
    [anon_sym_typename] = ACTIONS(3182),
    [anon_sym_template] = ACTIONS(3182),
    [anon_sym_try] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(3182),
    [anon_sym_throw] = ACTIONS(3182),
    [anon_sym_co_return] = ACTIONS(3182),
    [anon_sym_co_yield] = ACTIONS(3182),
    [anon_sym_R_DQUOTE] = ACTIONS(3184),
    [anon_sym_LR_DQUOTE] = ACTIONS(3184),
    [anon_sym_uR_DQUOTE] = ACTIONS(3184),
    [anon_sym_UR_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3184),
    [anon_sym_co_await] = ACTIONS(3182),
    [anon_sym_new] = ACTIONS(3182),
    [anon_sym_requires] = ACTIONS(3182),
    [sym_this] = ACTIONS(3182),
    [anon_sym_discard] = ACTIONS(3182),
    [anon_sym_precise] = ACTIONS(3182),
    [anon_sym_shared] = ACTIONS(3182),
    [anon_sym_groupshared] = ACTIONS(3182),
    [anon_sym_uniform] = ACTIONS(3182),
    [anon_sym_row_major] = ACTIONS(3182),
    [anon_sym_column_major] = ACTIONS(3182),
    [anon_sym_globallycoherent] = ACTIONS(3182),
    [anon_sym_centroid] = ACTIONS(3182),
    [anon_sym_noperspective] = ACTIONS(3182),
    [anon_sym_nointerpolation] = ACTIONS(3182),
    [anon_sym_sample] = ACTIONS(3182),
    [anon_sym_linear] = ACTIONS(3182),
    [anon_sym_snorm] = ACTIONS(3182),
    [anon_sym_unorm] = ACTIONS(3182),
    [anon_sym_point] = ACTIONS(3182),
    [anon_sym_line] = ACTIONS(3182),
    [anon_sym_triangleadj] = ACTIONS(3182),
    [anon_sym_lineadj] = ACTIONS(3182),
    [anon_sym_triangle] = ACTIONS(3182),
    [anon_sym_cbuffer] = ACTIONS(3182),
    [anon_sym_interface] = ACTIONS(3182),
    [anon_sym_extension] = ACTIONS(3182),
  },
  [1311] = {
    [sym__declaration_modifiers] = STATE(2299),
    [sym__declaration_specifiers] = STATE(4856),
    [sym_attribute_specifier] = STATE(2299),
    [sym_attribute_declaration] = STATE(2299),
    [sym_ms_declspec_modifier] = STATE(2299),
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_call_modifier] = STATE(5777),
    [sym__declarator] = STATE(8164),
    [sym__abstract_declarator] = STATE(8547),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_abstract_parenthesized_declarator] = STATE(7128),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_abstract_pointer_declarator] = STATE(7128),
    [sym_function_declarator] = STATE(7882),
    [sym_abstract_function_declarator] = STATE(7128),
    [sym_array_declarator] = STATE(7882),
    [sym_abstract_array_declarator] = STATE(7128),
    [sym_storage_class_specifier] = STATE(2299),
    [sym_type_qualifier] = STATE(2299),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2694),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_parameter_list] = STATE(4322),
    [sym_parameter_declaration] = STATE(9475),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_optional_parameter_declaration] = STATE(9475),
    [sym_variadic_parameter_declaration] = STATE(9475),
    [sym_reference_declarator] = STATE(7882),
    [sym_abstract_reference_declarator] = STATE(7128),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym__function_declarator_seq] = STATE(7135),
    [sym_template_type] = STATE(2715),
    [sym_template_function] = STATE(7882),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6829),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2299),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2299),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(4877),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4879),
    [anon_sym_RPAREN] = ACTIONS(4881),
    [anon_sym_LPAREN2] = ACTIONS(4883),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(4885),
    [anon_sym_AMP_AMP] = ACTIONS(4887),
    [anon_sym_AMP] = ACTIONS(4889),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_out] = ACTIONS(2293),
    [anon_sym_inout] = ACTIONS(2293),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4891),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(2764),
    [anon_sym___clrcall] = ACTIONS(2764),
    [anon_sym___stdcall] = ACTIONS(2764),
    [anon_sym___fastcall] = ACTIONS(2764),
    [anon_sym___thiscall] = ACTIONS(2764),
    [anon_sym___vectorcall] = ACTIONS(2764),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(4893),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2299),
    [anon_sym_class] = ACTIONS(2301),
    [anon_sym_struct] = ACTIONS(2303),
    [anon_sym_union] = ACTIONS(2305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(2293),
    [anon_sym_typename] = ACTIONS(2329),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(2808),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2341),
    [anon_sym_extension] = ACTIONS(2343),
  },
  [1312] = {
    [sym_identifier] = ACTIONS(3182),
    [anon_sym_LPAREN2] = ACTIONS(3184),
    [anon_sym_BANG] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_DASH] = ACTIONS(3182),
    [anon_sym_PLUS] = ACTIONS(3182),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3184),
    [anon_sym_SEMI] = ACTIONS(3184),
    [anon_sym___extension__] = ACTIONS(3182),
    [anon_sym_typedef] = ACTIONS(3182),
    [anon_sym_in] = ACTIONS(3182),
    [anon_sym_out] = ACTIONS(3182),
    [anon_sym_inout] = ACTIONS(3182),
    [anon_sym_extern] = ACTIONS(3182),
    [anon_sym___attribute__] = ACTIONS(3182),
    [anon_sym_COLON_COLON] = ACTIONS(3184),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3184),
    [anon_sym___declspec] = ACTIONS(3182),
    [anon_sym_LBRACE] = ACTIONS(3184),
    [anon_sym_signed] = ACTIONS(3182),
    [anon_sym_unsigned] = ACTIONS(3182),
    [anon_sym_long] = ACTIONS(3182),
    [anon_sym_short] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3182),
    [anon_sym_register] = ACTIONS(3182),
    [anon_sym_inline] = ACTIONS(3182),
    [anon_sym___inline] = ACTIONS(3182),
    [anon_sym___inline__] = ACTIONS(3182),
    [anon_sym___forceinline] = ACTIONS(3182),
    [anon_sym_thread_local] = ACTIONS(3182),
    [anon_sym___thread] = ACTIONS(3182),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_constexpr] = ACTIONS(3182),
    [anon_sym_volatile] = ACTIONS(3182),
    [anon_sym_restrict] = ACTIONS(3182),
    [anon_sym___restrict__] = ACTIONS(3182),
    [anon_sym__Atomic] = ACTIONS(3182),
    [anon_sym__Noreturn] = ACTIONS(3182),
    [anon_sym_noreturn] = ACTIONS(3182),
    [anon_sym_mutable] = ACTIONS(3182),
    [anon_sym_constinit] = ACTIONS(3182),
    [anon_sym_consteval] = ACTIONS(3182),
    [anon_sym_alignas] = ACTIONS(3182),
    [anon_sym__Alignas] = ACTIONS(3182),
    [sym_primitive_type] = ACTIONS(3182),
    [anon_sym_enum] = ACTIONS(3182),
    [anon_sym_class] = ACTIONS(3182),
    [anon_sym_struct] = ACTIONS(3182),
    [anon_sym_union] = ACTIONS(3182),
    [anon_sym_if] = ACTIONS(3182),
    [anon_sym_else] = ACTIONS(3182),
    [anon_sym_switch] = ACTIONS(3182),
    [anon_sym_while] = ACTIONS(3182),
    [anon_sym_do] = ACTIONS(3182),
    [anon_sym_for] = ACTIONS(3182),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_break] = ACTIONS(3182),
    [anon_sym_continue] = ACTIONS(3182),
    [anon_sym_goto] = ACTIONS(3182),
    [anon_sym___try] = ACTIONS(3182),
    [anon_sym___leave] = ACTIONS(3182),
    [anon_sym_not] = ACTIONS(3182),
    [anon_sym_compl] = ACTIONS(3182),
    [anon_sym_DASH_DASH] = ACTIONS(3184),
    [anon_sym_PLUS_PLUS] = ACTIONS(3184),
    [anon_sym_sizeof] = ACTIONS(3182),
    [anon_sym___alignof__] = ACTIONS(3182),
    [anon_sym___alignof] = ACTIONS(3182),
    [anon_sym__alignof] = ACTIONS(3182),
    [anon_sym_alignof] = ACTIONS(3182),
    [anon_sym__Alignof] = ACTIONS(3182),
    [anon_sym_offsetof] = ACTIONS(3182),
    [anon_sym__Generic] = ACTIONS(3182),
    [anon_sym_asm] = ACTIONS(3182),
    [anon_sym___asm__] = ACTIONS(3182),
    [sym_number_literal] = ACTIONS(3184),
    [anon_sym_L_SQUOTE] = ACTIONS(3184),
    [anon_sym_u_SQUOTE] = ACTIONS(3184),
    [anon_sym_U_SQUOTE] = ACTIONS(3184),
    [anon_sym_u8_SQUOTE] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3184),
    [anon_sym_L_DQUOTE] = ACTIONS(3184),
    [anon_sym_u_DQUOTE] = ACTIONS(3184),
    [anon_sym_U_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8_DQUOTE] = ACTIONS(3184),
    [anon_sym_DQUOTE] = ACTIONS(3184),
    [sym_true] = ACTIONS(3182),
    [sym_false] = ACTIONS(3182),
    [anon_sym_NULL] = ACTIONS(3182),
    [anon_sym_nullptr] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3182),
    [anon_sym_let] = ACTIONS(3182),
    [anon_sym_This] = ACTIONS(3182),
    [anon_sym_decltype] = ACTIONS(3182),
    [sym_virtual] = ACTIONS(3182),
    [anon_sym_typename] = ACTIONS(3182),
    [anon_sym_template] = ACTIONS(3182),
    [anon_sym_try] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(3182),
    [anon_sym_throw] = ACTIONS(3182),
    [anon_sym_co_return] = ACTIONS(3182),
    [anon_sym_co_yield] = ACTIONS(3182),
    [anon_sym_R_DQUOTE] = ACTIONS(3184),
    [anon_sym_LR_DQUOTE] = ACTIONS(3184),
    [anon_sym_uR_DQUOTE] = ACTIONS(3184),
    [anon_sym_UR_DQUOTE] = ACTIONS(3184),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3184),
    [anon_sym_co_await] = ACTIONS(3182),
    [anon_sym_new] = ACTIONS(3182),
    [anon_sym_requires] = ACTIONS(3182),
    [sym_this] = ACTIONS(3182),
    [anon_sym_discard] = ACTIONS(3182),
    [anon_sym_precise] = ACTIONS(3182),
    [anon_sym_shared] = ACTIONS(3182),
    [anon_sym_groupshared] = ACTIONS(3182),
    [anon_sym_uniform] = ACTIONS(3182),
    [anon_sym_row_major] = ACTIONS(3182),
    [anon_sym_column_major] = ACTIONS(3182),
    [anon_sym_globallycoherent] = ACTIONS(3182),
    [anon_sym_centroid] = ACTIONS(3182),
    [anon_sym_noperspective] = ACTIONS(3182),
    [anon_sym_nointerpolation] = ACTIONS(3182),
    [anon_sym_sample] = ACTIONS(3182),
    [anon_sym_linear] = ACTIONS(3182),
    [anon_sym_snorm] = ACTIONS(3182),
    [anon_sym_unorm] = ACTIONS(3182),
    [anon_sym_point] = ACTIONS(3182),
    [anon_sym_line] = ACTIONS(3182),
    [anon_sym_triangleadj] = ACTIONS(3182),
    [anon_sym_lineadj] = ACTIONS(3182),
    [anon_sym_triangle] = ACTIONS(3182),
    [anon_sym_cbuffer] = ACTIONS(3182),
    [anon_sym_interface] = ACTIONS(3182),
    [anon_sym_extension] = ACTIONS(3182),
  },
  [1313] = {
    [sym_identifier] = ACTIONS(3218),
    [anon_sym_LPAREN2] = ACTIONS(3220),
    [anon_sym_BANG] = ACTIONS(3220),
    [anon_sym_TILDE] = ACTIONS(3220),
    [anon_sym_DASH] = ACTIONS(3218),
    [anon_sym_PLUS] = ACTIONS(3218),
    [anon_sym_STAR] = ACTIONS(3220),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym_SEMI] = ACTIONS(3220),
    [anon_sym___extension__] = ACTIONS(3218),
    [anon_sym_typedef] = ACTIONS(3218),
    [anon_sym_in] = ACTIONS(3218),
    [anon_sym_out] = ACTIONS(3218),
    [anon_sym_inout] = ACTIONS(3218),
    [anon_sym_extern] = ACTIONS(3218),
    [anon_sym___attribute__] = ACTIONS(3218),
    [anon_sym_COLON_COLON] = ACTIONS(3220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3220),
    [anon_sym___declspec] = ACTIONS(3218),
    [anon_sym_LBRACE] = ACTIONS(3220),
    [anon_sym_signed] = ACTIONS(3218),
    [anon_sym_unsigned] = ACTIONS(3218),
    [anon_sym_long] = ACTIONS(3218),
    [anon_sym_short] = ACTIONS(3218),
    [anon_sym_LBRACK] = ACTIONS(3218),
    [anon_sym_static] = ACTIONS(3218),
    [anon_sym_register] = ACTIONS(3218),
    [anon_sym_inline] = ACTIONS(3218),
    [anon_sym___inline] = ACTIONS(3218),
    [anon_sym___inline__] = ACTIONS(3218),
    [anon_sym___forceinline] = ACTIONS(3218),
    [anon_sym_thread_local] = ACTIONS(3218),
    [anon_sym___thread] = ACTIONS(3218),
    [anon_sym_const] = ACTIONS(3218),
    [anon_sym_constexpr] = ACTIONS(3218),
    [anon_sym_volatile] = ACTIONS(3218),
    [anon_sym_restrict] = ACTIONS(3218),
    [anon_sym___restrict__] = ACTIONS(3218),
    [anon_sym__Atomic] = ACTIONS(3218),
    [anon_sym__Noreturn] = ACTIONS(3218),
    [anon_sym_noreturn] = ACTIONS(3218),
    [anon_sym_mutable] = ACTIONS(3218),
    [anon_sym_constinit] = ACTIONS(3218),
    [anon_sym_consteval] = ACTIONS(3218),
    [anon_sym_alignas] = ACTIONS(3218),
    [anon_sym__Alignas] = ACTIONS(3218),
    [sym_primitive_type] = ACTIONS(3218),
    [anon_sym_enum] = ACTIONS(3218),
    [anon_sym_class] = ACTIONS(3218),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3218),
    [anon_sym_if] = ACTIONS(3218),
    [anon_sym_else] = ACTIONS(3218),
    [anon_sym_switch] = ACTIONS(3218),
    [anon_sym_while] = ACTIONS(3218),
    [anon_sym_do] = ACTIONS(3218),
    [anon_sym_for] = ACTIONS(3218),
    [anon_sym_return] = ACTIONS(3218),
    [anon_sym_break] = ACTIONS(3218),
    [anon_sym_continue] = ACTIONS(3218),
    [anon_sym_goto] = ACTIONS(3218),
    [anon_sym___try] = ACTIONS(3218),
    [anon_sym___leave] = ACTIONS(3218),
    [anon_sym_not] = ACTIONS(3218),
    [anon_sym_compl] = ACTIONS(3218),
    [anon_sym_DASH_DASH] = ACTIONS(3220),
    [anon_sym_PLUS_PLUS] = ACTIONS(3220),
    [anon_sym_sizeof] = ACTIONS(3218),
    [anon_sym___alignof__] = ACTIONS(3218),
    [anon_sym___alignof] = ACTIONS(3218),
    [anon_sym__alignof] = ACTIONS(3218),
    [anon_sym_alignof] = ACTIONS(3218),
    [anon_sym__Alignof] = ACTIONS(3218),
    [anon_sym_offsetof] = ACTIONS(3218),
    [anon_sym__Generic] = ACTIONS(3218),
    [anon_sym_asm] = ACTIONS(3218),
    [anon_sym___asm__] = ACTIONS(3218),
    [sym_number_literal] = ACTIONS(3220),
    [anon_sym_L_SQUOTE] = ACTIONS(3220),
    [anon_sym_u_SQUOTE] = ACTIONS(3220),
    [anon_sym_U_SQUOTE] = ACTIONS(3220),
    [anon_sym_u8_SQUOTE] = ACTIONS(3220),
    [anon_sym_SQUOTE] = ACTIONS(3220),
    [anon_sym_L_DQUOTE] = ACTIONS(3220),
    [anon_sym_u_DQUOTE] = ACTIONS(3220),
    [anon_sym_U_DQUOTE] = ACTIONS(3220),
    [anon_sym_u8_DQUOTE] = ACTIONS(3220),
    [anon_sym_DQUOTE] = ACTIONS(3220),
    [sym_true] = ACTIONS(3218),
    [sym_false] = ACTIONS(3218),
    [anon_sym_NULL] = ACTIONS(3218),
    [anon_sym_nullptr] = ACTIONS(3218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3218),
    [anon_sym_let] = ACTIONS(3218),
    [anon_sym_This] = ACTIONS(3218),
    [anon_sym_decltype] = ACTIONS(3218),
    [sym_virtual] = ACTIONS(3218),
    [anon_sym_typename] = ACTIONS(3218),
    [anon_sym_template] = ACTIONS(3218),
    [anon_sym_try] = ACTIONS(3218),
    [anon_sym_delete] = ACTIONS(3218),
    [anon_sym_throw] = ACTIONS(3218),
    [anon_sym_co_return] = ACTIONS(3218),
    [anon_sym_co_yield] = ACTIONS(3218),
    [anon_sym_R_DQUOTE] = ACTIONS(3220),
    [anon_sym_LR_DQUOTE] = ACTIONS(3220),
    [anon_sym_uR_DQUOTE] = ACTIONS(3220),
    [anon_sym_UR_DQUOTE] = ACTIONS(3220),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3220),
    [anon_sym_co_await] = ACTIONS(3218),
    [anon_sym_new] = ACTIONS(3218),
    [anon_sym_requires] = ACTIONS(3218),
    [sym_this] = ACTIONS(3218),
    [anon_sym_discard] = ACTIONS(3218),
    [anon_sym_precise] = ACTIONS(3218),
    [anon_sym_shared] = ACTIONS(3218),
    [anon_sym_groupshared] = ACTIONS(3218),
    [anon_sym_uniform] = ACTIONS(3218),
    [anon_sym_row_major] = ACTIONS(3218),
    [anon_sym_column_major] = ACTIONS(3218),
    [anon_sym_globallycoherent] = ACTIONS(3218),
    [anon_sym_centroid] = ACTIONS(3218),
    [anon_sym_noperspective] = ACTIONS(3218),
    [anon_sym_nointerpolation] = ACTIONS(3218),
    [anon_sym_sample] = ACTIONS(3218),
    [anon_sym_linear] = ACTIONS(3218),
    [anon_sym_snorm] = ACTIONS(3218),
    [anon_sym_unorm] = ACTIONS(3218),
    [anon_sym_point] = ACTIONS(3218),
    [anon_sym_line] = ACTIONS(3218),
    [anon_sym_triangleadj] = ACTIONS(3218),
    [anon_sym_lineadj] = ACTIONS(3218),
    [anon_sym_triangle] = ACTIONS(3218),
    [anon_sym_cbuffer] = ACTIONS(3218),
    [anon_sym_interface] = ACTIONS(3218),
    [anon_sym_extension] = ACTIONS(3218),
  },
  [1314] = {
    [sym_identifier] = ACTIONS(4545),
    [anon_sym_LPAREN2] = ACTIONS(4547),
    [anon_sym_BANG] = ACTIONS(4547),
    [anon_sym_TILDE] = ACTIONS(4547),
    [anon_sym_DASH] = ACTIONS(4545),
    [anon_sym_PLUS] = ACTIONS(4545),
    [anon_sym_STAR] = ACTIONS(4547),
    [anon_sym_AMP] = ACTIONS(4547),
    [anon_sym_SEMI] = ACTIONS(4547),
    [anon_sym___extension__] = ACTIONS(4545),
    [anon_sym_in] = ACTIONS(4545),
    [anon_sym_out] = ACTIONS(4545),
    [anon_sym_inout] = ACTIONS(4545),
    [anon_sym_extern] = ACTIONS(4545),
    [anon_sym___attribute__] = ACTIONS(4545),
    [anon_sym_COLON_COLON] = ACTIONS(4547),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4547),
    [anon_sym___declspec] = ACTIONS(4545),
    [anon_sym_LBRACE] = ACTIONS(4547),
    [anon_sym_signed] = ACTIONS(4545),
    [anon_sym_unsigned] = ACTIONS(4545),
    [anon_sym_long] = ACTIONS(4545),
    [anon_sym_short] = ACTIONS(4545),
    [anon_sym_LBRACK] = ACTIONS(4545),
    [anon_sym_static] = ACTIONS(4545),
    [anon_sym_register] = ACTIONS(4545),
    [anon_sym_inline] = ACTIONS(4545),
    [anon_sym___inline] = ACTIONS(4545),
    [anon_sym___inline__] = ACTIONS(4545),
    [anon_sym___forceinline] = ACTIONS(4545),
    [anon_sym_thread_local] = ACTIONS(4545),
    [anon_sym___thread] = ACTIONS(4545),
    [anon_sym_const] = ACTIONS(4545),
    [anon_sym_constexpr] = ACTIONS(4545),
    [anon_sym_volatile] = ACTIONS(4545),
    [anon_sym_restrict] = ACTIONS(4545),
    [anon_sym___restrict__] = ACTIONS(4545),
    [anon_sym__Atomic] = ACTIONS(4545),
    [anon_sym__Noreturn] = ACTIONS(4545),
    [anon_sym_noreturn] = ACTIONS(4545),
    [anon_sym_mutable] = ACTIONS(4545),
    [anon_sym_constinit] = ACTIONS(4545),
    [anon_sym_consteval] = ACTIONS(4545),
    [anon_sym_alignas] = ACTIONS(4545),
    [anon_sym__Alignas] = ACTIONS(4545),
    [sym_primitive_type] = ACTIONS(4545),
    [anon_sym_enum] = ACTIONS(4545),
    [anon_sym_class] = ACTIONS(4545),
    [anon_sym_struct] = ACTIONS(4545),
    [anon_sym_union] = ACTIONS(4545),
    [anon_sym_if] = ACTIONS(4545),
    [anon_sym_switch] = ACTIONS(4545),
    [anon_sym_case] = ACTIONS(4545),
    [anon_sym_default] = ACTIONS(4545),
    [anon_sym_while] = ACTIONS(4545),
    [anon_sym_do] = ACTIONS(4545),
    [anon_sym_for] = ACTIONS(4545),
    [anon_sym_return] = ACTIONS(4545),
    [anon_sym_break] = ACTIONS(4545),
    [anon_sym_continue] = ACTIONS(4545),
    [anon_sym_goto] = ACTIONS(4545),
    [anon_sym___try] = ACTIONS(4545),
    [anon_sym___leave] = ACTIONS(4545),
    [anon_sym_not] = ACTIONS(4545),
    [anon_sym_compl] = ACTIONS(4545),
    [anon_sym_DASH_DASH] = ACTIONS(4547),
    [anon_sym_PLUS_PLUS] = ACTIONS(4547),
    [anon_sym_sizeof] = ACTIONS(4545),
    [anon_sym___alignof__] = ACTIONS(4545),
    [anon_sym___alignof] = ACTIONS(4545),
    [anon_sym__alignof] = ACTIONS(4545),
    [anon_sym_alignof] = ACTIONS(4545),
    [anon_sym__Alignof] = ACTIONS(4545),
    [anon_sym_offsetof] = ACTIONS(4545),
    [anon_sym__Generic] = ACTIONS(4545),
    [anon_sym_asm] = ACTIONS(4545),
    [anon_sym___asm__] = ACTIONS(4545),
    [sym_number_literal] = ACTIONS(4547),
    [anon_sym_L_SQUOTE] = ACTIONS(4547),
    [anon_sym_u_SQUOTE] = ACTIONS(4547),
    [anon_sym_U_SQUOTE] = ACTIONS(4547),
    [anon_sym_u8_SQUOTE] = ACTIONS(4547),
    [anon_sym_SQUOTE] = ACTIONS(4547),
    [anon_sym_L_DQUOTE] = ACTIONS(4547),
    [anon_sym_u_DQUOTE] = ACTIONS(4547),
    [anon_sym_U_DQUOTE] = ACTIONS(4547),
    [anon_sym_u8_DQUOTE] = ACTIONS(4547),
    [anon_sym_DQUOTE] = ACTIONS(4547),
    [sym_true] = ACTIONS(4545),
    [sym_false] = ACTIONS(4545),
    [anon_sym_NULL] = ACTIONS(4545),
    [anon_sym_nullptr] = ACTIONS(4545),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4545),
    [anon_sym_let] = ACTIONS(4545),
    [anon_sym_This] = ACTIONS(4545),
    [anon_sym_decltype] = ACTIONS(4545),
    [sym_virtual] = ACTIONS(4545),
    [anon_sym_typename] = ACTIONS(4545),
    [anon_sym_template] = ACTIONS(4545),
    [anon_sym_try] = ACTIONS(4545),
    [anon_sym_delete] = ACTIONS(4545),
    [anon_sym_throw] = ACTIONS(4545),
    [anon_sym_co_return] = ACTIONS(4545),
    [anon_sym_co_yield] = ACTIONS(4545),
    [anon_sym_R_DQUOTE] = ACTIONS(4547),
    [anon_sym_LR_DQUOTE] = ACTIONS(4547),
    [anon_sym_uR_DQUOTE] = ACTIONS(4547),
    [anon_sym_UR_DQUOTE] = ACTIONS(4547),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4547),
    [anon_sym_co_await] = ACTIONS(4545),
    [anon_sym_new] = ACTIONS(4545),
    [anon_sym_requires] = ACTIONS(4545),
    [sym_this] = ACTIONS(4545),
    [anon_sym_discard] = ACTIONS(4545),
    [anon_sym_precise] = ACTIONS(4545),
    [anon_sym_shared] = ACTIONS(4545),
    [anon_sym_groupshared] = ACTIONS(4545),
    [anon_sym_uniform] = ACTIONS(4545),
    [anon_sym_row_major] = ACTIONS(4545),
    [anon_sym_column_major] = ACTIONS(4545),
    [anon_sym_globallycoherent] = ACTIONS(4545),
    [anon_sym_centroid] = ACTIONS(4545),
    [anon_sym_noperspective] = ACTIONS(4545),
    [anon_sym_nointerpolation] = ACTIONS(4545),
    [anon_sym_sample] = ACTIONS(4545),
    [anon_sym_linear] = ACTIONS(4545),
    [anon_sym_snorm] = ACTIONS(4545),
    [anon_sym_unorm] = ACTIONS(4545),
    [anon_sym_point] = ACTIONS(4545),
    [anon_sym_line] = ACTIONS(4545),
    [anon_sym_triangleadj] = ACTIONS(4545),
    [anon_sym_lineadj] = ACTIONS(4545),
    [anon_sym_triangle] = ACTIONS(4545),
    [anon_sym_cbuffer] = ACTIONS(4545),
    [anon_sym_interface] = ACTIONS(4545),
    [anon_sym_extension] = ACTIONS(4545),
  },
  [1315] = {
    [sym_identifier] = ACTIONS(3330),
    [anon_sym_LPAREN2] = ACTIONS(3332),
    [anon_sym_BANG] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3332),
    [anon_sym_DASH] = ACTIONS(3330),
    [anon_sym_PLUS] = ACTIONS(3330),
    [anon_sym_STAR] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(3332),
    [anon_sym_SEMI] = ACTIONS(3332),
    [anon_sym___extension__] = ACTIONS(3330),
    [anon_sym_typedef] = ACTIONS(3330),
    [anon_sym_in] = ACTIONS(3330),
    [anon_sym_out] = ACTIONS(3330),
    [anon_sym_inout] = ACTIONS(3330),
    [anon_sym_extern] = ACTIONS(3330),
    [anon_sym___attribute__] = ACTIONS(3330),
    [anon_sym_COLON_COLON] = ACTIONS(3332),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3332),
    [anon_sym___declspec] = ACTIONS(3330),
    [anon_sym_LBRACE] = ACTIONS(3332),
    [anon_sym_signed] = ACTIONS(3330),
    [anon_sym_unsigned] = ACTIONS(3330),
    [anon_sym_long] = ACTIONS(3330),
    [anon_sym_short] = ACTIONS(3330),
    [anon_sym_LBRACK] = ACTIONS(3330),
    [anon_sym_static] = ACTIONS(3330),
    [anon_sym_register] = ACTIONS(3330),
    [anon_sym_inline] = ACTIONS(3330),
    [anon_sym___inline] = ACTIONS(3330),
    [anon_sym___inline__] = ACTIONS(3330),
    [anon_sym___forceinline] = ACTIONS(3330),
    [anon_sym_thread_local] = ACTIONS(3330),
    [anon_sym___thread] = ACTIONS(3330),
    [anon_sym_const] = ACTIONS(3330),
    [anon_sym_constexpr] = ACTIONS(3330),
    [anon_sym_volatile] = ACTIONS(3330),
    [anon_sym_restrict] = ACTIONS(3330),
    [anon_sym___restrict__] = ACTIONS(3330),
    [anon_sym__Atomic] = ACTIONS(3330),
    [anon_sym__Noreturn] = ACTIONS(3330),
    [anon_sym_noreturn] = ACTIONS(3330),
    [anon_sym_mutable] = ACTIONS(3330),
    [anon_sym_constinit] = ACTIONS(3330),
    [anon_sym_consteval] = ACTIONS(3330),
    [anon_sym_alignas] = ACTIONS(3330),
    [anon_sym__Alignas] = ACTIONS(3330),
    [sym_primitive_type] = ACTIONS(3330),
    [anon_sym_enum] = ACTIONS(3330),
    [anon_sym_class] = ACTIONS(3330),
    [anon_sym_struct] = ACTIONS(3330),
    [anon_sym_union] = ACTIONS(3330),
    [anon_sym_if] = ACTIONS(3330),
    [anon_sym_else] = ACTIONS(3330),
    [anon_sym_switch] = ACTIONS(3330),
    [anon_sym_while] = ACTIONS(3330),
    [anon_sym_do] = ACTIONS(3330),
    [anon_sym_for] = ACTIONS(3330),
    [anon_sym_return] = ACTIONS(3330),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_continue] = ACTIONS(3330),
    [anon_sym_goto] = ACTIONS(3330),
    [anon_sym___try] = ACTIONS(3330),
    [anon_sym___leave] = ACTIONS(3330),
    [anon_sym_not] = ACTIONS(3330),
    [anon_sym_compl] = ACTIONS(3330),
    [anon_sym_DASH_DASH] = ACTIONS(3332),
    [anon_sym_PLUS_PLUS] = ACTIONS(3332),
    [anon_sym_sizeof] = ACTIONS(3330),
    [anon_sym___alignof__] = ACTIONS(3330),
    [anon_sym___alignof] = ACTIONS(3330),
    [anon_sym__alignof] = ACTIONS(3330),
    [anon_sym_alignof] = ACTIONS(3330),
    [anon_sym__Alignof] = ACTIONS(3330),
    [anon_sym_offsetof] = ACTIONS(3330),
    [anon_sym__Generic] = ACTIONS(3330),
    [anon_sym_asm] = ACTIONS(3330),
    [anon_sym___asm__] = ACTIONS(3330),
    [sym_number_literal] = ACTIONS(3332),
    [anon_sym_L_SQUOTE] = ACTIONS(3332),
    [anon_sym_u_SQUOTE] = ACTIONS(3332),
    [anon_sym_U_SQUOTE] = ACTIONS(3332),
    [anon_sym_u8_SQUOTE] = ACTIONS(3332),
    [anon_sym_SQUOTE] = ACTIONS(3332),
    [anon_sym_L_DQUOTE] = ACTIONS(3332),
    [anon_sym_u_DQUOTE] = ACTIONS(3332),
    [anon_sym_U_DQUOTE] = ACTIONS(3332),
    [anon_sym_u8_DQUOTE] = ACTIONS(3332),
    [anon_sym_DQUOTE] = ACTIONS(3332),
    [sym_true] = ACTIONS(3330),
    [sym_false] = ACTIONS(3330),
    [anon_sym_NULL] = ACTIONS(3330),
    [anon_sym_nullptr] = ACTIONS(3330),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3330),
    [anon_sym_let] = ACTIONS(3330),
    [anon_sym_This] = ACTIONS(3330),
    [anon_sym_decltype] = ACTIONS(3330),
    [sym_virtual] = ACTIONS(3330),
    [anon_sym_typename] = ACTIONS(3330),
    [anon_sym_template] = ACTIONS(3330),
    [anon_sym_try] = ACTIONS(3330),
    [anon_sym_delete] = ACTIONS(3330),
    [anon_sym_throw] = ACTIONS(3330),
    [anon_sym_co_return] = ACTIONS(3330),
    [anon_sym_co_yield] = ACTIONS(3330),
    [anon_sym_R_DQUOTE] = ACTIONS(3332),
    [anon_sym_LR_DQUOTE] = ACTIONS(3332),
    [anon_sym_uR_DQUOTE] = ACTIONS(3332),
    [anon_sym_UR_DQUOTE] = ACTIONS(3332),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3332),
    [anon_sym_co_await] = ACTIONS(3330),
    [anon_sym_new] = ACTIONS(3330),
    [anon_sym_requires] = ACTIONS(3330),
    [sym_this] = ACTIONS(3330),
    [anon_sym_discard] = ACTIONS(3330),
    [anon_sym_precise] = ACTIONS(3330),
    [anon_sym_shared] = ACTIONS(3330),
    [anon_sym_groupshared] = ACTIONS(3330),
    [anon_sym_uniform] = ACTIONS(3330),
    [anon_sym_row_major] = ACTIONS(3330),
    [anon_sym_column_major] = ACTIONS(3330),
    [anon_sym_globallycoherent] = ACTIONS(3330),
    [anon_sym_centroid] = ACTIONS(3330),
    [anon_sym_noperspective] = ACTIONS(3330),
    [anon_sym_nointerpolation] = ACTIONS(3330),
    [anon_sym_sample] = ACTIONS(3330),
    [anon_sym_linear] = ACTIONS(3330),
    [anon_sym_snorm] = ACTIONS(3330),
    [anon_sym_unorm] = ACTIONS(3330),
    [anon_sym_point] = ACTIONS(3330),
    [anon_sym_line] = ACTIONS(3330),
    [anon_sym_triangleadj] = ACTIONS(3330),
    [anon_sym_lineadj] = ACTIONS(3330),
    [anon_sym_triangle] = ACTIONS(3330),
    [anon_sym_cbuffer] = ACTIONS(3330),
    [anon_sym_interface] = ACTIONS(3330),
    [anon_sym_extension] = ACTIONS(3330),
  },
  [1316] = {
    [sym_identifier] = ACTIONS(4573),
    [anon_sym_LPAREN2] = ACTIONS(4575),
    [anon_sym_BANG] = ACTIONS(4575),
    [anon_sym_TILDE] = ACTIONS(4575),
    [anon_sym_DASH] = ACTIONS(4573),
    [anon_sym_PLUS] = ACTIONS(4573),
    [anon_sym_STAR] = ACTIONS(4575),
    [anon_sym_AMP] = ACTIONS(4575),
    [anon_sym_SEMI] = ACTIONS(4575),
    [anon_sym___extension__] = ACTIONS(4573),
    [anon_sym_in] = ACTIONS(4573),
    [anon_sym_out] = ACTIONS(4573),
    [anon_sym_inout] = ACTIONS(4573),
    [anon_sym_extern] = ACTIONS(4573),
    [anon_sym___attribute__] = ACTIONS(4573),
    [anon_sym_COLON_COLON] = ACTIONS(4575),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4575),
    [anon_sym___declspec] = ACTIONS(4573),
    [anon_sym_LBRACE] = ACTIONS(4575),
    [anon_sym_signed] = ACTIONS(4573),
    [anon_sym_unsigned] = ACTIONS(4573),
    [anon_sym_long] = ACTIONS(4573),
    [anon_sym_short] = ACTIONS(4573),
    [anon_sym_LBRACK] = ACTIONS(4573),
    [anon_sym_static] = ACTIONS(4573),
    [anon_sym_register] = ACTIONS(4573),
    [anon_sym_inline] = ACTIONS(4573),
    [anon_sym___inline] = ACTIONS(4573),
    [anon_sym___inline__] = ACTIONS(4573),
    [anon_sym___forceinline] = ACTIONS(4573),
    [anon_sym_thread_local] = ACTIONS(4573),
    [anon_sym___thread] = ACTIONS(4573),
    [anon_sym_const] = ACTIONS(4573),
    [anon_sym_constexpr] = ACTIONS(4573),
    [anon_sym_volatile] = ACTIONS(4573),
    [anon_sym_restrict] = ACTIONS(4573),
    [anon_sym___restrict__] = ACTIONS(4573),
    [anon_sym__Atomic] = ACTIONS(4573),
    [anon_sym__Noreturn] = ACTIONS(4573),
    [anon_sym_noreturn] = ACTIONS(4573),
    [anon_sym_mutable] = ACTIONS(4573),
    [anon_sym_constinit] = ACTIONS(4573),
    [anon_sym_consteval] = ACTIONS(4573),
    [anon_sym_alignas] = ACTIONS(4573),
    [anon_sym__Alignas] = ACTIONS(4573),
    [sym_primitive_type] = ACTIONS(4573),
    [anon_sym_enum] = ACTIONS(4573),
    [anon_sym_class] = ACTIONS(4573),
    [anon_sym_struct] = ACTIONS(4573),
    [anon_sym_union] = ACTIONS(4573),
    [anon_sym_if] = ACTIONS(4573),
    [anon_sym_switch] = ACTIONS(4573),
    [anon_sym_case] = ACTIONS(4573),
    [anon_sym_default] = ACTIONS(4573),
    [anon_sym_while] = ACTIONS(4573),
    [anon_sym_do] = ACTIONS(4573),
    [anon_sym_for] = ACTIONS(4573),
    [anon_sym_return] = ACTIONS(4573),
    [anon_sym_break] = ACTIONS(4573),
    [anon_sym_continue] = ACTIONS(4573),
    [anon_sym_goto] = ACTIONS(4573),
    [anon_sym___try] = ACTIONS(4573),
    [anon_sym___leave] = ACTIONS(4573),
    [anon_sym_not] = ACTIONS(4573),
    [anon_sym_compl] = ACTIONS(4573),
    [anon_sym_DASH_DASH] = ACTIONS(4575),
    [anon_sym_PLUS_PLUS] = ACTIONS(4575),
    [anon_sym_sizeof] = ACTIONS(4573),
    [anon_sym___alignof__] = ACTIONS(4573),
    [anon_sym___alignof] = ACTIONS(4573),
    [anon_sym__alignof] = ACTIONS(4573),
    [anon_sym_alignof] = ACTIONS(4573),
    [anon_sym__Alignof] = ACTIONS(4573),
    [anon_sym_offsetof] = ACTIONS(4573),
    [anon_sym__Generic] = ACTIONS(4573),
    [anon_sym_asm] = ACTIONS(4573),
    [anon_sym___asm__] = ACTIONS(4573),
    [sym_number_literal] = ACTIONS(4575),
    [anon_sym_L_SQUOTE] = ACTIONS(4575),
    [anon_sym_u_SQUOTE] = ACTIONS(4575),
    [anon_sym_U_SQUOTE] = ACTIONS(4575),
    [anon_sym_u8_SQUOTE] = ACTIONS(4575),
    [anon_sym_SQUOTE] = ACTIONS(4575),
    [anon_sym_L_DQUOTE] = ACTIONS(4575),
    [anon_sym_u_DQUOTE] = ACTIONS(4575),
    [anon_sym_U_DQUOTE] = ACTIONS(4575),
    [anon_sym_u8_DQUOTE] = ACTIONS(4575),
    [anon_sym_DQUOTE] = ACTIONS(4575),
    [sym_true] = ACTIONS(4573),
    [sym_false] = ACTIONS(4573),
    [anon_sym_NULL] = ACTIONS(4573),
    [anon_sym_nullptr] = ACTIONS(4573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4573),
    [anon_sym_let] = ACTIONS(4573),
    [anon_sym_This] = ACTIONS(4573),
    [anon_sym_decltype] = ACTIONS(4573),
    [sym_virtual] = ACTIONS(4573),
    [anon_sym_typename] = ACTIONS(4573),
    [anon_sym_template] = ACTIONS(4573),
    [anon_sym_try] = ACTIONS(4573),
    [anon_sym_delete] = ACTIONS(4573),
    [anon_sym_throw] = ACTIONS(4573),
    [anon_sym_co_return] = ACTIONS(4573),
    [anon_sym_co_yield] = ACTIONS(4573),
    [anon_sym_R_DQUOTE] = ACTIONS(4575),
    [anon_sym_LR_DQUOTE] = ACTIONS(4575),
    [anon_sym_uR_DQUOTE] = ACTIONS(4575),
    [anon_sym_UR_DQUOTE] = ACTIONS(4575),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4575),
    [anon_sym_co_await] = ACTIONS(4573),
    [anon_sym_new] = ACTIONS(4573),
    [anon_sym_requires] = ACTIONS(4573),
    [sym_this] = ACTIONS(4573),
    [anon_sym_discard] = ACTIONS(4573),
    [anon_sym_precise] = ACTIONS(4573),
    [anon_sym_shared] = ACTIONS(4573),
    [anon_sym_groupshared] = ACTIONS(4573),
    [anon_sym_uniform] = ACTIONS(4573),
    [anon_sym_row_major] = ACTIONS(4573),
    [anon_sym_column_major] = ACTIONS(4573),
    [anon_sym_globallycoherent] = ACTIONS(4573),
    [anon_sym_centroid] = ACTIONS(4573),
    [anon_sym_noperspective] = ACTIONS(4573),
    [anon_sym_nointerpolation] = ACTIONS(4573),
    [anon_sym_sample] = ACTIONS(4573),
    [anon_sym_linear] = ACTIONS(4573),
    [anon_sym_snorm] = ACTIONS(4573),
    [anon_sym_unorm] = ACTIONS(4573),
    [anon_sym_point] = ACTIONS(4573),
    [anon_sym_line] = ACTIONS(4573),
    [anon_sym_triangleadj] = ACTIONS(4573),
    [anon_sym_lineadj] = ACTIONS(4573),
    [anon_sym_triangle] = ACTIONS(4573),
    [anon_sym_cbuffer] = ACTIONS(4573),
    [anon_sym_interface] = ACTIONS(4573),
    [anon_sym_extension] = ACTIONS(4573),
  },
  [1317] = {
    [sym_identifier] = ACTIONS(2491),
    [anon_sym_LPAREN2] = ACTIONS(2489),
    [anon_sym_BANG] = ACTIONS(2489),
    [anon_sym_TILDE] = ACTIONS(2489),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(2489),
    [anon_sym_AMP] = ACTIONS(2489),
    [anon_sym_SEMI] = ACTIONS(2489),
    [anon_sym___extension__] = ACTIONS(2491),
    [anon_sym_typedef] = ACTIONS(2491),
    [anon_sym_in] = ACTIONS(2491),
    [anon_sym_out] = ACTIONS(2491),
    [anon_sym_inout] = ACTIONS(2491),
    [anon_sym_extern] = ACTIONS(2491),
    [anon_sym___attribute__] = ACTIONS(2491),
    [anon_sym_COLON_COLON] = ACTIONS(2489),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2489),
    [anon_sym___declspec] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(2489),
    [anon_sym_signed] = ACTIONS(2491),
    [anon_sym_unsigned] = ACTIONS(2491),
    [anon_sym_long] = ACTIONS(2491),
    [anon_sym_short] = ACTIONS(2491),
    [anon_sym_LBRACK] = ACTIONS(2491),
    [anon_sym_static] = ACTIONS(2491),
    [anon_sym_register] = ACTIONS(2491),
    [anon_sym_inline] = ACTIONS(2491),
    [anon_sym___inline] = ACTIONS(2491),
    [anon_sym___inline__] = ACTIONS(2491),
    [anon_sym___forceinline] = ACTIONS(2491),
    [anon_sym_thread_local] = ACTIONS(2491),
    [anon_sym___thread] = ACTIONS(2491),
    [anon_sym_const] = ACTIONS(2491),
    [anon_sym_constexpr] = ACTIONS(2491),
    [anon_sym_volatile] = ACTIONS(2491),
    [anon_sym_restrict] = ACTIONS(2491),
    [anon_sym___restrict__] = ACTIONS(2491),
    [anon_sym__Atomic] = ACTIONS(2491),
    [anon_sym__Noreturn] = ACTIONS(2491),
    [anon_sym_noreturn] = ACTIONS(2491),
    [anon_sym_mutable] = ACTIONS(2491),
    [anon_sym_constinit] = ACTIONS(2491),
    [anon_sym_consteval] = ACTIONS(2491),
    [anon_sym_alignas] = ACTIONS(2491),
    [anon_sym__Alignas] = ACTIONS(2491),
    [sym_primitive_type] = ACTIONS(2491),
    [anon_sym_enum] = ACTIONS(2491),
    [anon_sym_class] = ACTIONS(2491),
    [anon_sym_struct] = ACTIONS(2491),
    [anon_sym_union] = ACTIONS(2491),
    [anon_sym_if] = ACTIONS(2491),
    [anon_sym_else] = ACTIONS(2491),
    [anon_sym_switch] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2491),
    [anon_sym_do] = ACTIONS(2491),
    [anon_sym_for] = ACTIONS(2491),
    [anon_sym_return] = ACTIONS(2491),
    [anon_sym_break] = ACTIONS(2491),
    [anon_sym_continue] = ACTIONS(2491),
    [anon_sym_goto] = ACTIONS(2491),
    [anon_sym___try] = ACTIONS(2491),
    [anon_sym___leave] = ACTIONS(2491),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(2489),
    [anon_sym_PLUS_PLUS] = ACTIONS(2489),
    [anon_sym_sizeof] = ACTIONS(2491),
    [anon_sym___alignof__] = ACTIONS(2491),
    [anon_sym___alignof] = ACTIONS(2491),
    [anon_sym__alignof] = ACTIONS(2491),
    [anon_sym_alignof] = ACTIONS(2491),
    [anon_sym__Alignof] = ACTIONS(2491),
    [anon_sym_offsetof] = ACTIONS(2491),
    [anon_sym__Generic] = ACTIONS(2491),
    [anon_sym_asm] = ACTIONS(2491),
    [anon_sym___asm__] = ACTIONS(2491),
    [sym_number_literal] = ACTIONS(2489),
    [anon_sym_L_SQUOTE] = ACTIONS(2489),
    [anon_sym_u_SQUOTE] = ACTIONS(2489),
    [anon_sym_U_SQUOTE] = ACTIONS(2489),
    [anon_sym_u8_SQUOTE] = ACTIONS(2489),
    [anon_sym_SQUOTE] = ACTIONS(2489),
    [anon_sym_L_DQUOTE] = ACTIONS(2489),
    [anon_sym_u_DQUOTE] = ACTIONS(2489),
    [anon_sym_U_DQUOTE] = ACTIONS(2489),
    [anon_sym_u8_DQUOTE] = ACTIONS(2489),
    [anon_sym_DQUOTE] = ACTIONS(2489),
    [sym_true] = ACTIONS(2491),
    [sym_false] = ACTIONS(2491),
    [anon_sym_NULL] = ACTIONS(2491),
    [anon_sym_nullptr] = ACTIONS(2491),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2491),
    [anon_sym_let] = ACTIONS(2491),
    [anon_sym_This] = ACTIONS(2491),
    [anon_sym_decltype] = ACTIONS(2491),
    [sym_virtual] = ACTIONS(2491),
    [anon_sym_typename] = ACTIONS(2491),
    [anon_sym_template] = ACTIONS(2491),
    [anon_sym_try] = ACTIONS(2491),
    [anon_sym_delete] = ACTIONS(2491),
    [anon_sym_throw] = ACTIONS(2491),
    [anon_sym_co_return] = ACTIONS(2491),
    [anon_sym_co_yield] = ACTIONS(2491),
    [anon_sym_R_DQUOTE] = ACTIONS(2489),
    [anon_sym_LR_DQUOTE] = ACTIONS(2489),
    [anon_sym_uR_DQUOTE] = ACTIONS(2489),
    [anon_sym_UR_DQUOTE] = ACTIONS(2489),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2489),
    [anon_sym_co_await] = ACTIONS(2491),
    [anon_sym_new] = ACTIONS(2491),
    [anon_sym_requires] = ACTIONS(2491),
    [sym_this] = ACTIONS(2491),
    [anon_sym_discard] = ACTIONS(2491),
    [anon_sym_precise] = ACTIONS(2491),
    [anon_sym_shared] = ACTIONS(2491),
    [anon_sym_groupshared] = ACTIONS(2491),
    [anon_sym_uniform] = ACTIONS(2491),
    [anon_sym_row_major] = ACTIONS(2491),
    [anon_sym_column_major] = ACTIONS(2491),
    [anon_sym_globallycoherent] = ACTIONS(2491),
    [anon_sym_centroid] = ACTIONS(2491),
    [anon_sym_noperspective] = ACTIONS(2491),
    [anon_sym_nointerpolation] = ACTIONS(2491),
    [anon_sym_sample] = ACTIONS(2491),
    [anon_sym_linear] = ACTIONS(2491),
    [anon_sym_snorm] = ACTIONS(2491),
    [anon_sym_unorm] = ACTIONS(2491),
    [anon_sym_point] = ACTIONS(2491),
    [anon_sym_line] = ACTIONS(2491),
    [anon_sym_triangleadj] = ACTIONS(2491),
    [anon_sym_lineadj] = ACTIONS(2491),
    [anon_sym_triangle] = ACTIONS(2491),
    [anon_sym_cbuffer] = ACTIONS(2491),
    [anon_sym_interface] = ACTIONS(2491),
    [anon_sym_extension] = ACTIONS(2491),
  },
  [1318] = {
    [sym_identifier] = ACTIONS(2536),
    [anon_sym_LPAREN2] = ACTIONS(2534),
    [anon_sym_BANG] = ACTIONS(2534),
    [anon_sym_TILDE] = ACTIONS(2534),
    [anon_sym_DASH] = ACTIONS(2536),
    [anon_sym_PLUS] = ACTIONS(2536),
    [anon_sym_STAR] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2534),
    [anon_sym___extension__] = ACTIONS(2536),
    [anon_sym_typedef] = ACTIONS(2536),
    [anon_sym_in] = ACTIONS(2536),
    [anon_sym_out] = ACTIONS(2536),
    [anon_sym_inout] = ACTIONS(2536),
    [anon_sym_extern] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(2534),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2534),
    [anon_sym___declspec] = ACTIONS(2536),
    [anon_sym_LBRACE] = ACTIONS(2534),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(2536),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_register] = ACTIONS(2536),
    [anon_sym_inline] = ACTIONS(2536),
    [anon_sym___inline] = ACTIONS(2536),
    [anon_sym___inline__] = ACTIONS(2536),
    [anon_sym___forceinline] = ACTIONS(2536),
    [anon_sym_thread_local] = ACTIONS(2536),
    [anon_sym___thread] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2536),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_class] = ACTIONS(2536),
    [anon_sym_struct] = ACTIONS(2536),
    [anon_sym_union] = ACTIONS(2536),
    [anon_sym_if] = ACTIONS(2536),
    [anon_sym_else] = ACTIONS(2536),
    [anon_sym_switch] = ACTIONS(2536),
    [anon_sym_while] = ACTIONS(2536),
    [anon_sym_do] = ACTIONS(2536),
    [anon_sym_for] = ACTIONS(2536),
    [anon_sym_return] = ACTIONS(2536),
    [anon_sym_break] = ACTIONS(2536),
    [anon_sym_continue] = ACTIONS(2536),
    [anon_sym_goto] = ACTIONS(2536),
    [anon_sym___try] = ACTIONS(2536),
    [anon_sym___leave] = ACTIONS(2536),
    [anon_sym_not] = ACTIONS(2536),
    [anon_sym_compl] = ACTIONS(2536),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_sizeof] = ACTIONS(2536),
    [anon_sym___alignof__] = ACTIONS(2536),
    [anon_sym___alignof] = ACTIONS(2536),
    [anon_sym__alignof] = ACTIONS(2536),
    [anon_sym_alignof] = ACTIONS(2536),
    [anon_sym__Alignof] = ACTIONS(2536),
    [anon_sym_offsetof] = ACTIONS(2536),
    [anon_sym__Generic] = ACTIONS(2536),
    [anon_sym_asm] = ACTIONS(2536),
    [anon_sym___asm__] = ACTIONS(2536),
    [sym_number_literal] = ACTIONS(2534),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2534),
    [anon_sym_u_DQUOTE] = ACTIONS(2534),
    [anon_sym_U_DQUOTE] = ACTIONS(2534),
    [anon_sym_u8_DQUOTE] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [sym_true] = ACTIONS(2536),
    [sym_false] = ACTIONS(2536),
    [anon_sym_NULL] = ACTIONS(2536),
    [anon_sym_nullptr] = ACTIONS(2536),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2536),
    [anon_sym_let] = ACTIONS(2536),
    [anon_sym_This] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2536),
    [sym_virtual] = ACTIONS(2536),
    [anon_sym_typename] = ACTIONS(2536),
    [anon_sym_template] = ACTIONS(2536),
    [anon_sym_try] = ACTIONS(2536),
    [anon_sym_delete] = ACTIONS(2536),
    [anon_sym_throw] = ACTIONS(2536),
    [anon_sym_co_return] = ACTIONS(2536),
    [anon_sym_co_yield] = ACTIONS(2536),
    [anon_sym_R_DQUOTE] = ACTIONS(2534),
    [anon_sym_LR_DQUOTE] = ACTIONS(2534),
    [anon_sym_uR_DQUOTE] = ACTIONS(2534),
    [anon_sym_UR_DQUOTE] = ACTIONS(2534),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2534),
    [anon_sym_co_await] = ACTIONS(2536),
    [anon_sym_new] = ACTIONS(2536),
    [anon_sym_requires] = ACTIONS(2536),
    [sym_this] = ACTIONS(2536),
    [anon_sym_discard] = ACTIONS(2536),
    [anon_sym_precise] = ACTIONS(2536),
    [anon_sym_shared] = ACTIONS(2536),
    [anon_sym_groupshared] = ACTIONS(2536),
    [anon_sym_uniform] = ACTIONS(2536),
    [anon_sym_row_major] = ACTIONS(2536),
    [anon_sym_column_major] = ACTIONS(2536),
    [anon_sym_globallycoherent] = ACTIONS(2536),
    [anon_sym_centroid] = ACTIONS(2536),
    [anon_sym_noperspective] = ACTIONS(2536),
    [anon_sym_nointerpolation] = ACTIONS(2536),
    [anon_sym_sample] = ACTIONS(2536),
    [anon_sym_linear] = ACTIONS(2536),
    [anon_sym_snorm] = ACTIONS(2536),
    [anon_sym_unorm] = ACTIONS(2536),
    [anon_sym_point] = ACTIONS(2536),
    [anon_sym_line] = ACTIONS(2536),
    [anon_sym_triangleadj] = ACTIONS(2536),
    [anon_sym_lineadj] = ACTIONS(2536),
    [anon_sym_triangle] = ACTIONS(2536),
    [anon_sym_cbuffer] = ACTIONS(2536),
    [anon_sym_interface] = ACTIONS(2536),
    [anon_sym_extension] = ACTIONS(2536),
  },
  [1319] = {
    [sym_identifier] = ACTIONS(4703),
    [anon_sym_LPAREN2] = ACTIONS(4709),
    [anon_sym_BANG] = ACTIONS(4709),
    [anon_sym_TILDE] = ACTIONS(4709),
    [anon_sym_DASH] = ACTIONS(4711),
    [anon_sym_PLUS] = ACTIONS(4711),
    [anon_sym_STAR] = ACTIONS(4709),
    [anon_sym_AMP] = ACTIONS(4709),
    [anon_sym_SEMI] = ACTIONS(4709),
    [anon_sym___extension__] = ACTIONS(4715),
    [anon_sym_in] = ACTIONS(4715),
    [anon_sym_out] = ACTIONS(4715),
    [anon_sym_inout] = ACTIONS(4715),
    [anon_sym_extern] = ACTIONS(4715),
    [anon_sym___attribute__] = ACTIONS(4715),
    [anon_sym_COLON_COLON] = ACTIONS(4706),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4706),
    [anon_sym___declspec] = ACTIONS(4715),
    [anon_sym_LBRACE] = ACTIONS(4709),
    [anon_sym_signed] = ACTIONS(4715),
    [anon_sym_unsigned] = ACTIONS(4715),
    [anon_sym_long] = ACTIONS(4715),
    [anon_sym_short] = ACTIONS(4715),
    [anon_sym_LBRACK] = ACTIONS(4711),
    [anon_sym_static] = ACTIONS(4715),
    [anon_sym_register] = ACTIONS(4715),
    [anon_sym_inline] = ACTIONS(4715),
    [anon_sym___inline] = ACTIONS(4715),
    [anon_sym___inline__] = ACTIONS(4715),
    [anon_sym___forceinline] = ACTIONS(4715),
    [anon_sym_thread_local] = ACTIONS(4715),
    [anon_sym___thread] = ACTIONS(4715),
    [anon_sym_const] = ACTIONS(4715),
    [anon_sym_constexpr] = ACTIONS(4715),
    [anon_sym_volatile] = ACTIONS(4715),
    [anon_sym_restrict] = ACTIONS(4715),
    [anon_sym___restrict__] = ACTIONS(4715),
    [anon_sym__Atomic] = ACTIONS(4715),
    [anon_sym__Noreturn] = ACTIONS(4715),
    [anon_sym_noreturn] = ACTIONS(4715),
    [anon_sym_mutable] = ACTIONS(4715),
    [anon_sym_constinit] = ACTIONS(4715),
    [anon_sym_consteval] = ACTIONS(4715),
    [anon_sym_alignas] = ACTIONS(4715),
    [anon_sym__Alignas] = ACTIONS(4715),
    [sym_primitive_type] = ACTIONS(4703),
    [anon_sym_enum] = ACTIONS(4715),
    [anon_sym_class] = ACTIONS(4715),
    [anon_sym_struct] = ACTIONS(4715),
    [anon_sym_union] = ACTIONS(4715),
    [anon_sym_if] = ACTIONS(4711),
    [anon_sym_switch] = ACTIONS(4711),
    [anon_sym_case] = ACTIONS(4711),
    [anon_sym_default] = ACTIONS(4711),
    [anon_sym_while] = ACTIONS(4711),
    [anon_sym_do] = ACTIONS(4711),
    [anon_sym_for] = ACTIONS(4711),
    [anon_sym_return] = ACTIONS(4711),
    [anon_sym_break] = ACTIONS(4711),
    [anon_sym_continue] = ACTIONS(4711),
    [anon_sym_goto] = ACTIONS(4711),
    [anon_sym___try] = ACTIONS(4711),
    [anon_sym___leave] = ACTIONS(4711),
    [anon_sym_not] = ACTIONS(4711),
    [anon_sym_compl] = ACTIONS(4711),
    [anon_sym_DASH_DASH] = ACTIONS(4709),
    [anon_sym_PLUS_PLUS] = ACTIONS(4709),
    [anon_sym_sizeof] = ACTIONS(4711),
    [anon_sym___alignof__] = ACTIONS(4711),
    [anon_sym___alignof] = ACTIONS(4711),
    [anon_sym__alignof] = ACTIONS(4711),
    [anon_sym_alignof] = ACTIONS(4711),
    [anon_sym__Alignof] = ACTIONS(4711),
    [anon_sym_offsetof] = ACTIONS(4711),
    [anon_sym__Generic] = ACTIONS(4711),
    [anon_sym_asm] = ACTIONS(4711),
    [anon_sym___asm__] = ACTIONS(4711),
    [sym_number_literal] = ACTIONS(4709),
    [anon_sym_L_SQUOTE] = ACTIONS(4709),
    [anon_sym_u_SQUOTE] = ACTIONS(4709),
    [anon_sym_U_SQUOTE] = ACTIONS(4709),
    [anon_sym_u8_SQUOTE] = ACTIONS(4709),
    [anon_sym_SQUOTE] = ACTIONS(4709),
    [anon_sym_L_DQUOTE] = ACTIONS(4709),
    [anon_sym_u_DQUOTE] = ACTIONS(4709),
    [anon_sym_U_DQUOTE] = ACTIONS(4709),
    [anon_sym_u8_DQUOTE] = ACTIONS(4709),
    [anon_sym_DQUOTE] = ACTIONS(4709),
    [sym_true] = ACTIONS(4711),
    [sym_false] = ACTIONS(4711),
    [anon_sym_NULL] = ACTIONS(4711),
    [anon_sym_nullptr] = ACTIONS(4711),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4715),
    [anon_sym_let] = ACTIONS(4715),
    [anon_sym_This] = ACTIONS(4715),
    [anon_sym_decltype] = ACTIONS(4703),
    [sym_virtual] = ACTIONS(4715),
    [anon_sym_typename] = ACTIONS(4715),
    [anon_sym_template] = ACTIONS(4703),
    [anon_sym_try] = ACTIONS(4711),
    [anon_sym_delete] = ACTIONS(4711),
    [anon_sym_throw] = ACTIONS(4711),
    [anon_sym_co_return] = ACTIONS(4711),
    [anon_sym_co_yield] = ACTIONS(4711),
    [anon_sym_R_DQUOTE] = ACTIONS(4709),
    [anon_sym_LR_DQUOTE] = ACTIONS(4709),
    [anon_sym_uR_DQUOTE] = ACTIONS(4709),
    [anon_sym_UR_DQUOTE] = ACTIONS(4709),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4709),
    [anon_sym_co_await] = ACTIONS(4711),
    [anon_sym_new] = ACTIONS(4711),
    [anon_sym_requires] = ACTIONS(4711),
    [sym_this] = ACTIONS(4711),
    [anon_sym_discard] = ACTIONS(4711),
    [anon_sym_precise] = ACTIONS(4715),
    [anon_sym_shared] = ACTIONS(4715),
    [anon_sym_groupshared] = ACTIONS(4715),
    [anon_sym_uniform] = ACTIONS(4715),
    [anon_sym_row_major] = ACTIONS(4715),
    [anon_sym_column_major] = ACTIONS(4715),
    [anon_sym_globallycoherent] = ACTIONS(4715),
    [anon_sym_centroid] = ACTIONS(4715),
    [anon_sym_noperspective] = ACTIONS(4715),
    [anon_sym_nointerpolation] = ACTIONS(4715),
    [anon_sym_sample] = ACTIONS(4715),
    [anon_sym_linear] = ACTIONS(4715),
    [anon_sym_snorm] = ACTIONS(4715),
    [anon_sym_unorm] = ACTIONS(4715),
    [anon_sym_point] = ACTIONS(4715),
    [anon_sym_line] = ACTIONS(4715),
    [anon_sym_triangleadj] = ACTIONS(4715),
    [anon_sym_lineadj] = ACTIONS(4715),
    [anon_sym_triangle] = ACTIONS(4715),
    [anon_sym_cbuffer] = ACTIONS(4711),
    [anon_sym_interface] = ACTIONS(4715),
    [anon_sym_extension] = ACTIONS(4715),
  },
  [1320] = {
    [sym_identifier] = ACTIONS(3322),
    [anon_sym_LPAREN2] = ACTIONS(3324),
    [anon_sym_BANG] = ACTIONS(3324),
    [anon_sym_TILDE] = ACTIONS(3324),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_STAR] = ACTIONS(3324),
    [anon_sym_AMP] = ACTIONS(3324),
    [anon_sym_SEMI] = ACTIONS(3324),
    [anon_sym___extension__] = ACTIONS(3322),
    [anon_sym_typedef] = ACTIONS(3322),
    [anon_sym_in] = ACTIONS(3322),
    [anon_sym_out] = ACTIONS(3322),
    [anon_sym_inout] = ACTIONS(3322),
    [anon_sym_extern] = ACTIONS(3322),
    [anon_sym___attribute__] = ACTIONS(3322),
    [anon_sym_COLON_COLON] = ACTIONS(3324),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3324),
    [anon_sym___declspec] = ACTIONS(3322),
    [anon_sym_LBRACE] = ACTIONS(3324),
    [anon_sym_signed] = ACTIONS(3322),
    [anon_sym_unsigned] = ACTIONS(3322),
    [anon_sym_long] = ACTIONS(3322),
    [anon_sym_short] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_static] = ACTIONS(3322),
    [anon_sym_register] = ACTIONS(3322),
    [anon_sym_inline] = ACTIONS(3322),
    [anon_sym___inline] = ACTIONS(3322),
    [anon_sym___inline__] = ACTIONS(3322),
    [anon_sym___forceinline] = ACTIONS(3322),
    [anon_sym_thread_local] = ACTIONS(3322),
    [anon_sym___thread] = ACTIONS(3322),
    [anon_sym_const] = ACTIONS(3322),
    [anon_sym_constexpr] = ACTIONS(3322),
    [anon_sym_volatile] = ACTIONS(3322),
    [anon_sym_restrict] = ACTIONS(3322),
    [anon_sym___restrict__] = ACTIONS(3322),
    [anon_sym__Atomic] = ACTIONS(3322),
    [anon_sym__Noreturn] = ACTIONS(3322),
    [anon_sym_noreturn] = ACTIONS(3322),
    [anon_sym_mutable] = ACTIONS(3322),
    [anon_sym_constinit] = ACTIONS(3322),
    [anon_sym_consteval] = ACTIONS(3322),
    [anon_sym_alignas] = ACTIONS(3322),
    [anon_sym__Alignas] = ACTIONS(3322),
    [sym_primitive_type] = ACTIONS(3322),
    [anon_sym_enum] = ACTIONS(3322),
    [anon_sym_class] = ACTIONS(3322),
    [anon_sym_struct] = ACTIONS(3322),
    [anon_sym_union] = ACTIONS(3322),
    [anon_sym_if] = ACTIONS(3322),
    [anon_sym_else] = ACTIONS(3322),
    [anon_sym_switch] = ACTIONS(3322),
    [anon_sym_while] = ACTIONS(3322),
    [anon_sym_do] = ACTIONS(3322),
    [anon_sym_for] = ACTIONS(3322),
    [anon_sym_return] = ACTIONS(3322),
    [anon_sym_break] = ACTIONS(3322),
    [anon_sym_continue] = ACTIONS(3322),
    [anon_sym_goto] = ACTIONS(3322),
    [anon_sym___try] = ACTIONS(3322),
    [anon_sym___leave] = ACTIONS(3322),
    [anon_sym_not] = ACTIONS(3322),
    [anon_sym_compl] = ACTIONS(3322),
    [anon_sym_DASH_DASH] = ACTIONS(3324),
    [anon_sym_PLUS_PLUS] = ACTIONS(3324),
    [anon_sym_sizeof] = ACTIONS(3322),
    [anon_sym___alignof__] = ACTIONS(3322),
    [anon_sym___alignof] = ACTIONS(3322),
    [anon_sym__alignof] = ACTIONS(3322),
    [anon_sym_alignof] = ACTIONS(3322),
    [anon_sym__Alignof] = ACTIONS(3322),
    [anon_sym_offsetof] = ACTIONS(3322),
    [anon_sym__Generic] = ACTIONS(3322),
    [anon_sym_asm] = ACTIONS(3322),
    [anon_sym___asm__] = ACTIONS(3322),
    [sym_number_literal] = ACTIONS(3324),
    [anon_sym_L_SQUOTE] = ACTIONS(3324),
    [anon_sym_u_SQUOTE] = ACTIONS(3324),
    [anon_sym_U_SQUOTE] = ACTIONS(3324),
    [anon_sym_u8_SQUOTE] = ACTIONS(3324),
    [anon_sym_SQUOTE] = ACTIONS(3324),
    [anon_sym_L_DQUOTE] = ACTIONS(3324),
    [anon_sym_u_DQUOTE] = ACTIONS(3324),
    [anon_sym_U_DQUOTE] = ACTIONS(3324),
    [anon_sym_u8_DQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE] = ACTIONS(3324),
    [sym_true] = ACTIONS(3322),
    [sym_false] = ACTIONS(3322),
    [anon_sym_NULL] = ACTIONS(3322),
    [anon_sym_nullptr] = ACTIONS(3322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3322),
    [anon_sym_let] = ACTIONS(3322),
    [anon_sym_This] = ACTIONS(3322),
    [anon_sym_decltype] = ACTIONS(3322),
    [sym_virtual] = ACTIONS(3322),
    [anon_sym_typename] = ACTIONS(3322),
    [anon_sym_template] = ACTIONS(3322),
    [anon_sym_try] = ACTIONS(3322),
    [anon_sym_delete] = ACTIONS(3322),
    [anon_sym_throw] = ACTIONS(3322),
    [anon_sym_co_return] = ACTIONS(3322),
    [anon_sym_co_yield] = ACTIONS(3322),
    [anon_sym_R_DQUOTE] = ACTIONS(3324),
    [anon_sym_LR_DQUOTE] = ACTIONS(3324),
    [anon_sym_uR_DQUOTE] = ACTIONS(3324),
    [anon_sym_UR_DQUOTE] = ACTIONS(3324),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3324),
    [anon_sym_co_await] = ACTIONS(3322),
    [anon_sym_new] = ACTIONS(3322),
    [anon_sym_requires] = ACTIONS(3322),
    [sym_this] = ACTIONS(3322),
    [anon_sym_discard] = ACTIONS(3322),
    [anon_sym_precise] = ACTIONS(3322),
    [anon_sym_shared] = ACTIONS(3322),
    [anon_sym_groupshared] = ACTIONS(3322),
    [anon_sym_uniform] = ACTIONS(3322),
    [anon_sym_row_major] = ACTIONS(3322),
    [anon_sym_column_major] = ACTIONS(3322),
    [anon_sym_globallycoherent] = ACTIONS(3322),
    [anon_sym_centroid] = ACTIONS(3322),
    [anon_sym_noperspective] = ACTIONS(3322),
    [anon_sym_nointerpolation] = ACTIONS(3322),
    [anon_sym_sample] = ACTIONS(3322),
    [anon_sym_linear] = ACTIONS(3322),
    [anon_sym_snorm] = ACTIONS(3322),
    [anon_sym_unorm] = ACTIONS(3322),
    [anon_sym_point] = ACTIONS(3322),
    [anon_sym_line] = ACTIONS(3322),
    [anon_sym_triangleadj] = ACTIONS(3322),
    [anon_sym_lineadj] = ACTIONS(3322),
    [anon_sym_triangle] = ACTIONS(3322),
    [anon_sym_cbuffer] = ACTIONS(3322),
    [anon_sym_interface] = ACTIONS(3322),
    [anon_sym_extension] = ACTIONS(3322),
  },
  [1321] = {
    [sym_identifier] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_BANG] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3034),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3036),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_in] = ACTIONS(3034),
    [anon_sym_out] = ACTIONS(3034),
    [anon_sym_inout] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym_LBRACE] = ACTIONS(3036),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [anon_sym_if] = ACTIONS(3034),
    [anon_sym_else] = ACTIONS(3034),
    [anon_sym_switch] = ACTIONS(3034),
    [anon_sym_while] = ACTIONS(3034),
    [anon_sym_do] = ACTIONS(3034),
    [anon_sym_for] = ACTIONS(3034),
    [anon_sym_return] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3034),
    [anon_sym_continue] = ACTIONS(3034),
    [anon_sym_goto] = ACTIONS(3034),
    [anon_sym___try] = ACTIONS(3034),
    [anon_sym___leave] = ACTIONS(3034),
    [anon_sym_not] = ACTIONS(3034),
    [anon_sym_compl] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_sizeof] = ACTIONS(3034),
    [anon_sym___alignof__] = ACTIONS(3034),
    [anon_sym___alignof] = ACTIONS(3034),
    [anon_sym__alignof] = ACTIONS(3034),
    [anon_sym_alignof] = ACTIONS(3034),
    [anon_sym__Alignof] = ACTIONS(3034),
    [anon_sym_offsetof] = ACTIONS(3034),
    [anon_sym__Generic] = ACTIONS(3034),
    [anon_sym_asm] = ACTIONS(3034),
    [anon_sym___asm__] = ACTIONS(3034),
    [sym_number_literal] = ACTIONS(3036),
    [anon_sym_L_SQUOTE] = ACTIONS(3036),
    [anon_sym_u_SQUOTE] = ACTIONS(3036),
    [anon_sym_U_SQUOTE] = ACTIONS(3036),
    [anon_sym_u8_SQUOTE] = ACTIONS(3036),
    [anon_sym_SQUOTE] = ACTIONS(3036),
    [anon_sym_L_DQUOTE] = ACTIONS(3036),
    [anon_sym_u_DQUOTE] = ACTIONS(3036),
    [anon_sym_U_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8_DQUOTE] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [sym_true] = ACTIONS(3034),
    [sym_false] = ACTIONS(3034),
    [anon_sym_NULL] = ACTIONS(3034),
    [anon_sym_nullptr] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_This] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [sym_virtual] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_try] = ACTIONS(3034),
    [anon_sym_delete] = ACTIONS(3034),
    [anon_sym_throw] = ACTIONS(3034),
    [anon_sym_co_return] = ACTIONS(3034),
    [anon_sym_co_yield] = ACTIONS(3034),
    [anon_sym_R_DQUOTE] = ACTIONS(3036),
    [anon_sym_LR_DQUOTE] = ACTIONS(3036),
    [anon_sym_uR_DQUOTE] = ACTIONS(3036),
    [anon_sym_UR_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3036),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3034),
    [anon_sym_requires] = ACTIONS(3034),
    [sym_this] = ACTIONS(3034),
    [anon_sym_discard] = ACTIONS(3034),
    [anon_sym_precise] = ACTIONS(3034),
    [anon_sym_shared] = ACTIONS(3034),
    [anon_sym_groupshared] = ACTIONS(3034),
    [anon_sym_uniform] = ACTIONS(3034),
    [anon_sym_row_major] = ACTIONS(3034),
    [anon_sym_column_major] = ACTIONS(3034),
    [anon_sym_globallycoherent] = ACTIONS(3034),
    [anon_sym_centroid] = ACTIONS(3034),
    [anon_sym_noperspective] = ACTIONS(3034),
    [anon_sym_nointerpolation] = ACTIONS(3034),
    [anon_sym_sample] = ACTIONS(3034),
    [anon_sym_linear] = ACTIONS(3034),
    [anon_sym_snorm] = ACTIONS(3034),
    [anon_sym_unorm] = ACTIONS(3034),
    [anon_sym_point] = ACTIONS(3034),
    [anon_sym_line] = ACTIONS(3034),
    [anon_sym_triangleadj] = ACTIONS(3034),
    [anon_sym_lineadj] = ACTIONS(3034),
    [anon_sym_triangle] = ACTIONS(3034),
    [anon_sym_cbuffer] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3034),
    [anon_sym_extension] = ACTIONS(3034),
  },
  [1322] = {
    [sym_identifier] = ACTIONS(3226),
    [anon_sym_LPAREN2] = ACTIONS(3228),
    [anon_sym_BANG] = ACTIONS(3228),
    [anon_sym_TILDE] = ACTIONS(3228),
    [anon_sym_DASH] = ACTIONS(3226),
    [anon_sym_PLUS] = ACTIONS(3226),
    [anon_sym_STAR] = ACTIONS(3228),
    [anon_sym_AMP] = ACTIONS(3228),
    [anon_sym_SEMI] = ACTIONS(3228),
    [anon_sym___extension__] = ACTIONS(3226),
    [anon_sym_typedef] = ACTIONS(3226),
    [anon_sym_in] = ACTIONS(3226),
    [anon_sym_out] = ACTIONS(3226),
    [anon_sym_inout] = ACTIONS(3226),
    [anon_sym_extern] = ACTIONS(3226),
    [anon_sym___attribute__] = ACTIONS(3226),
    [anon_sym_COLON_COLON] = ACTIONS(3228),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3228),
    [anon_sym___declspec] = ACTIONS(3226),
    [anon_sym_LBRACE] = ACTIONS(3228),
    [anon_sym_signed] = ACTIONS(3226),
    [anon_sym_unsigned] = ACTIONS(3226),
    [anon_sym_long] = ACTIONS(3226),
    [anon_sym_short] = ACTIONS(3226),
    [anon_sym_LBRACK] = ACTIONS(3226),
    [anon_sym_static] = ACTIONS(3226),
    [anon_sym_register] = ACTIONS(3226),
    [anon_sym_inline] = ACTIONS(3226),
    [anon_sym___inline] = ACTIONS(3226),
    [anon_sym___inline__] = ACTIONS(3226),
    [anon_sym___forceinline] = ACTIONS(3226),
    [anon_sym_thread_local] = ACTIONS(3226),
    [anon_sym___thread] = ACTIONS(3226),
    [anon_sym_const] = ACTIONS(3226),
    [anon_sym_constexpr] = ACTIONS(3226),
    [anon_sym_volatile] = ACTIONS(3226),
    [anon_sym_restrict] = ACTIONS(3226),
    [anon_sym___restrict__] = ACTIONS(3226),
    [anon_sym__Atomic] = ACTIONS(3226),
    [anon_sym__Noreturn] = ACTIONS(3226),
    [anon_sym_noreturn] = ACTIONS(3226),
    [anon_sym_mutable] = ACTIONS(3226),
    [anon_sym_constinit] = ACTIONS(3226),
    [anon_sym_consteval] = ACTIONS(3226),
    [anon_sym_alignas] = ACTIONS(3226),
    [anon_sym__Alignas] = ACTIONS(3226),
    [sym_primitive_type] = ACTIONS(3226),
    [anon_sym_enum] = ACTIONS(3226),
    [anon_sym_class] = ACTIONS(3226),
    [anon_sym_struct] = ACTIONS(3226),
    [anon_sym_union] = ACTIONS(3226),
    [anon_sym_if] = ACTIONS(3226),
    [anon_sym_else] = ACTIONS(3226),
    [anon_sym_switch] = ACTIONS(3226),
    [anon_sym_while] = ACTIONS(3226),
    [anon_sym_do] = ACTIONS(3226),
    [anon_sym_for] = ACTIONS(3226),
    [anon_sym_return] = ACTIONS(3226),
    [anon_sym_break] = ACTIONS(3226),
    [anon_sym_continue] = ACTIONS(3226),
    [anon_sym_goto] = ACTIONS(3226),
    [anon_sym___try] = ACTIONS(3226),
    [anon_sym___leave] = ACTIONS(3226),
    [anon_sym_not] = ACTIONS(3226),
    [anon_sym_compl] = ACTIONS(3226),
    [anon_sym_DASH_DASH] = ACTIONS(3228),
    [anon_sym_PLUS_PLUS] = ACTIONS(3228),
    [anon_sym_sizeof] = ACTIONS(3226),
    [anon_sym___alignof__] = ACTIONS(3226),
    [anon_sym___alignof] = ACTIONS(3226),
    [anon_sym__alignof] = ACTIONS(3226),
    [anon_sym_alignof] = ACTIONS(3226),
    [anon_sym__Alignof] = ACTIONS(3226),
    [anon_sym_offsetof] = ACTIONS(3226),
    [anon_sym__Generic] = ACTIONS(3226),
    [anon_sym_asm] = ACTIONS(3226),
    [anon_sym___asm__] = ACTIONS(3226),
    [sym_number_literal] = ACTIONS(3228),
    [anon_sym_L_SQUOTE] = ACTIONS(3228),
    [anon_sym_u_SQUOTE] = ACTIONS(3228),
    [anon_sym_U_SQUOTE] = ACTIONS(3228),
    [anon_sym_u8_SQUOTE] = ACTIONS(3228),
    [anon_sym_SQUOTE] = ACTIONS(3228),
    [anon_sym_L_DQUOTE] = ACTIONS(3228),
    [anon_sym_u_DQUOTE] = ACTIONS(3228),
    [anon_sym_U_DQUOTE] = ACTIONS(3228),
    [anon_sym_u8_DQUOTE] = ACTIONS(3228),
    [anon_sym_DQUOTE] = ACTIONS(3228),
    [sym_true] = ACTIONS(3226),
    [sym_false] = ACTIONS(3226),
    [anon_sym_NULL] = ACTIONS(3226),
    [anon_sym_nullptr] = ACTIONS(3226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3226),
    [anon_sym_let] = ACTIONS(3226),
    [anon_sym_This] = ACTIONS(3226),
    [anon_sym_decltype] = ACTIONS(3226),
    [sym_virtual] = ACTIONS(3226),
    [anon_sym_typename] = ACTIONS(3226),
    [anon_sym_template] = ACTIONS(3226),
    [anon_sym_try] = ACTIONS(3226),
    [anon_sym_delete] = ACTIONS(3226),
    [anon_sym_throw] = ACTIONS(3226),
    [anon_sym_co_return] = ACTIONS(3226),
    [anon_sym_co_yield] = ACTIONS(3226),
    [anon_sym_R_DQUOTE] = ACTIONS(3228),
    [anon_sym_LR_DQUOTE] = ACTIONS(3228),
    [anon_sym_uR_DQUOTE] = ACTIONS(3228),
    [anon_sym_UR_DQUOTE] = ACTIONS(3228),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3228),
    [anon_sym_co_await] = ACTIONS(3226),
    [anon_sym_new] = ACTIONS(3226),
    [anon_sym_requires] = ACTIONS(3226),
    [sym_this] = ACTIONS(3226),
    [anon_sym_discard] = ACTIONS(3226),
    [anon_sym_precise] = ACTIONS(3226),
    [anon_sym_shared] = ACTIONS(3226),
    [anon_sym_groupshared] = ACTIONS(3226),
    [anon_sym_uniform] = ACTIONS(3226),
    [anon_sym_row_major] = ACTIONS(3226),
    [anon_sym_column_major] = ACTIONS(3226),
    [anon_sym_globallycoherent] = ACTIONS(3226),
    [anon_sym_centroid] = ACTIONS(3226),
    [anon_sym_noperspective] = ACTIONS(3226),
    [anon_sym_nointerpolation] = ACTIONS(3226),
    [anon_sym_sample] = ACTIONS(3226),
    [anon_sym_linear] = ACTIONS(3226),
    [anon_sym_snorm] = ACTIONS(3226),
    [anon_sym_unorm] = ACTIONS(3226),
    [anon_sym_point] = ACTIONS(3226),
    [anon_sym_line] = ACTIONS(3226),
    [anon_sym_triangleadj] = ACTIONS(3226),
    [anon_sym_lineadj] = ACTIONS(3226),
    [anon_sym_triangle] = ACTIONS(3226),
    [anon_sym_cbuffer] = ACTIONS(3226),
    [anon_sym_interface] = ACTIONS(3226),
    [anon_sym_extension] = ACTIONS(3226),
  },
  [1323] = {
    [sym_identifier] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_BANG] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3034),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3036),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_in] = ACTIONS(3034),
    [anon_sym_out] = ACTIONS(3034),
    [anon_sym_inout] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym_LBRACE] = ACTIONS(3036),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [anon_sym_if] = ACTIONS(3034),
    [anon_sym_else] = ACTIONS(3034),
    [anon_sym_switch] = ACTIONS(3034),
    [anon_sym_while] = ACTIONS(3034),
    [anon_sym_do] = ACTIONS(3034),
    [anon_sym_for] = ACTIONS(3034),
    [anon_sym_return] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3034),
    [anon_sym_continue] = ACTIONS(3034),
    [anon_sym_goto] = ACTIONS(3034),
    [anon_sym___try] = ACTIONS(3034),
    [anon_sym___leave] = ACTIONS(3034),
    [anon_sym_not] = ACTIONS(3034),
    [anon_sym_compl] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_sizeof] = ACTIONS(3034),
    [anon_sym___alignof__] = ACTIONS(3034),
    [anon_sym___alignof] = ACTIONS(3034),
    [anon_sym__alignof] = ACTIONS(3034),
    [anon_sym_alignof] = ACTIONS(3034),
    [anon_sym__Alignof] = ACTIONS(3034),
    [anon_sym_offsetof] = ACTIONS(3034),
    [anon_sym__Generic] = ACTIONS(3034),
    [anon_sym_asm] = ACTIONS(3034),
    [anon_sym___asm__] = ACTIONS(3034),
    [sym_number_literal] = ACTIONS(3036),
    [anon_sym_L_SQUOTE] = ACTIONS(3036),
    [anon_sym_u_SQUOTE] = ACTIONS(3036),
    [anon_sym_U_SQUOTE] = ACTIONS(3036),
    [anon_sym_u8_SQUOTE] = ACTIONS(3036),
    [anon_sym_SQUOTE] = ACTIONS(3036),
    [anon_sym_L_DQUOTE] = ACTIONS(3036),
    [anon_sym_u_DQUOTE] = ACTIONS(3036),
    [anon_sym_U_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8_DQUOTE] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [sym_true] = ACTIONS(3034),
    [sym_false] = ACTIONS(3034),
    [anon_sym_NULL] = ACTIONS(3034),
    [anon_sym_nullptr] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_This] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [sym_virtual] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_try] = ACTIONS(3034),
    [anon_sym_delete] = ACTIONS(3034),
    [anon_sym_throw] = ACTIONS(3034),
    [anon_sym_co_return] = ACTIONS(3034),
    [anon_sym_co_yield] = ACTIONS(3034),
    [anon_sym_R_DQUOTE] = ACTIONS(3036),
    [anon_sym_LR_DQUOTE] = ACTIONS(3036),
    [anon_sym_uR_DQUOTE] = ACTIONS(3036),
    [anon_sym_UR_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3036),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3034),
    [anon_sym_requires] = ACTIONS(3034),
    [sym_this] = ACTIONS(3034),
    [anon_sym_discard] = ACTIONS(3034),
    [anon_sym_precise] = ACTIONS(3034),
    [anon_sym_shared] = ACTIONS(3034),
    [anon_sym_groupshared] = ACTIONS(3034),
    [anon_sym_uniform] = ACTIONS(3034),
    [anon_sym_row_major] = ACTIONS(3034),
    [anon_sym_column_major] = ACTIONS(3034),
    [anon_sym_globallycoherent] = ACTIONS(3034),
    [anon_sym_centroid] = ACTIONS(3034),
    [anon_sym_noperspective] = ACTIONS(3034),
    [anon_sym_nointerpolation] = ACTIONS(3034),
    [anon_sym_sample] = ACTIONS(3034),
    [anon_sym_linear] = ACTIONS(3034),
    [anon_sym_snorm] = ACTIONS(3034),
    [anon_sym_unorm] = ACTIONS(3034),
    [anon_sym_point] = ACTIONS(3034),
    [anon_sym_line] = ACTIONS(3034),
    [anon_sym_triangleadj] = ACTIONS(3034),
    [anon_sym_lineadj] = ACTIONS(3034),
    [anon_sym_triangle] = ACTIONS(3034),
    [anon_sym_cbuffer] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3034),
    [anon_sym_extension] = ACTIONS(3034),
  },
  [1324] = {
    [sym_identifier] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_BANG] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3034),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3036),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_in] = ACTIONS(3034),
    [anon_sym_out] = ACTIONS(3034),
    [anon_sym_inout] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym_LBRACE] = ACTIONS(3036),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [anon_sym_if] = ACTIONS(3034),
    [anon_sym_else] = ACTIONS(3034),
    [anon_sym_switch] = ACTIONS(3034),
    [anon_sym_while] = ACTIONS(3034),
    [anon_sym_do] = ACTIONS(3034),
    [anon_sym_for] = ACTIONS(3034),
    [anon_sym_return] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3034),
    [anon_sym_continue] = ACTIONS(3034),
    [anon_sym_goto] = ACTIONS(3034),
    [anon_sym___try] = ACTIONS(3034),
    [anon_sym___leave] = ACTIONS(3034),
    [anon_sym_not] = ACTIONS(3034),
    [anon_sym_compl] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_sizeof] = ACTIONS(3034),
    [anon_sym___alignof__] = ACTIONS(3034),
    [anon_sym___alignof] = ACTIONS(3034),
    [anon_sym__alignof] = ACTIONS(3034),
    [anon_sym_alignof] = ACTIONS(3034),
    [anon_sym__Alignof] = ACTIONS(3034),
    [anon_sym_offsetof] = ACTIONS(3034),
    [anon_sym__Generic] = ACTIONS(3034),
    [anon_sym_asm] = ACTIONS(3034),
    [anon_sym___asm__] = ACTIONS(3034),
    [sym_number_literal] = ACTIONS(3036),
    [anon_sym_L_SQUOTE] = ACTIONS(3036),
    [anon_sym_u_SQUOTE] = ACTIONS(3036),
    [anon_sym_U_SQUOTE] = ACTIONS(3036),
    [anon_sym_u8_SQUOTE] = ACTIONS(3036),
    [anon_sym_SQUOTE] = ACTIONS(3036),
    [anon_sym_L_DQUOTE] = ACTIONS(3036),
    [anon_sym_u_DQUOTE] = ACTIONS(3036),
    [anon_sym_U_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8_DQUOTE] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [sym_true] = ACTIONS(3034),
    [sym_false] = ACTIONS(3034),
    [anon_sym_NULL] = ACTIONS(3034),
    [anon_sym_nullptr] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_This] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [sym_virtual] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_try] = ACTIONS(3034),
    [anon_sym_delete] = ACTIONS(3034),
    [anon_sym_throw] = ACTIONS(3034),
    [anon_sym_co_return] = ACTIONS(3034),
    [anon_sym_co_yield] = ACTIONS(3034),
    [anon_sym_R_DQUOTE] = ACTIONS(3036),
    [anon_sym_LR_DQUOTE] = ACTIONS(3036),
    [anon_sym_uR_DQUOTE] = ACTIONS(3036),
    [anon_sym_UR_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3036),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3034),
    [anon_sym_requires] = ACTIONS(3034),
    [sym_this] = ACTIONS(3034),
    [anon_sym_discard] = ACTIONS(3034),
    [anon_sym_precise] = ACTIONS(3034),
    [anon_sym_shared] = ACTIONS(3034),
    [anon_sym_groupshared] = ACTIONS(3034),
    [anon_sym_uniform] = ACTIONS(3034),
    [anon_sym_row_major] = ACTIONS(3034),
    [anon_sym_column_major] = ACTIONS(3034),
    [anon_sym_globallycoherent] = ACTIONS(3034),
    [anon_sym_centroid] = ACTIONS(3034),
    [anon_sym_noperspective] = ACTIONS(3034),
    [anon_sym_nointerpolation] = ACTIONS(3034),
    [anon_sym_sample] = ACTIONS(3034),
    [anon_sym_linear] = ACTIONS(3034),
    [anon_sym_snorm] = ACTIONS(3034),
    [anon_sym_unorm] = ACTIONS(3034),
    [anon_sym_point] = ACTIONS(3034),
    [anon_sym_line] = ACTIONS(3034),
    [anon_sym_triangleadj] = ACTIONS(3034),
    [anon_sym_lineadj] = ACTIONS(3034),
    [anon_sym_triangle] = ACTIONS(3034),
    [anon_sym_cbuffer] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3034),
    [anon_sym_extension] = ACTIONS(3034),
  },
  [1325] = {
    [sym_identifier] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3346),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym___extension__] = ACTIONS(3344),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_in] = ACTIONS(3344),
    [anon_sym_out] = ACTIONS(3344),
    [anon_sym_inout] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym___attribute__] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3346),
    [anon_sym___declspec] = ACTIONS(3344),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_signed] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym___inline] = ACTIONS(3344),
    [anon_sym___inline__] = ACTIONS(3344),
    [anon_sym___forceinline] = ACTIONS(3344),
    [anon_sym_thread_local] = ACTIONS(3344),
    [anon_sym___thread] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym___restrict__] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym__Noreturn] = ACTIONS(3344),
    [anon_sym_noreturn] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_constinit] = ACTIONS(3344),
    [anon_sym_consteval] = ACTIONS(3344),
    [anon_sym_alignas] = ACTIONS(3344),
    [anon_sym__Alignas] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_class] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_switch] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_break] = ACTIONS(3344),
    [anon_sym_continue] = ACTIONS(3344),
    [anon_sym_goto] = ACTIONS(3344),
    [anon_sym___try] = ACTIONS(3344),
    [anon_sym___leave] = ACTIONS(3344),
    [anon_sym_not] = ACTIONS(3344),
    [anon_sym_compl] = ACTIONS(3344),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_sizeof] = ACTIONS(3344),
    [anon_sym___alignof__] = ACTIONS(3344),
    [anon_sym___alignof] = ACTIONS(3344),
    [anon_sym__alignof] = ACTIONS(3344),
    [anon_sym_alignof] = ACTIONS(3344),
    [anon_sym__Alignof] = ACTIONS(3344),
    [anon_sym_offsetof] = ACTIONS(3344),
    [anon_sym__Generic] = ACTIONS(3344),
    [anon_sym_asm] = ACTIONS(3344),
    [anon_sym___asm__] = ACTIONS(3344),
    [sym_number_literal] = ACTIONS(3346),
    [anon_sym_L_SQUOTE] = ACTIONS(3346),
    [anon_sym_u_SQUOTE] = ACTIONS(3346),
    [anon_sym_U_SQUOTE] = ACTIONS(3346),
    [anon_sym_u8_SQUOTE] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_L_DQUOTE] = ACTIONS(3346),
    [anon_sym_u_DQUOTE] = ACTIONS(3346),
    [anon_sym_U_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8_DQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [sym_true] = ACTIONS(3344),
    [sym_false] = ACTIONS(3344),
    [anon_sym_NULL] = ACTIONS(3344),
    [anon_sym_nullptr] = ACTIONS(3344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_This] = ACTIONS(3344),
    [anon_sym_decltype] = ACTIONS(3344),
    [sym_virtual] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_template] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_delete] = ACTIONS(3344),
    [anon_sym_throw] = ACTIONS(3344),
    [anon_sym_co_return] = ACTIONS(3344),
    [anon_sym_co_yield] = ACTIONS(3344),
    [anon_sym_R_DQUOTE] = ACTIONS(3346),
    [anon_sym_LR_DQUOTE] = ACTIONS(3346),
    [anon_sym_uR_DQUOTE] = ACTIONS(3346),
    [anon_sym_UR_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3346),
    [anon_sym_co_await] = ACTIONS(3344),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_requires] = ACTIONS(3344),
    [sym_this] = ACTIONS(3344),
    [anon_sym_discard] = ACTIONS(3344),
    [anon_sym_precise] = ACTIONS(3344),
    [anon_sym_shared] = ACTIONS(3344),
    [anon_sym_groupshared] = ACTIONS(3344),
    [anon_sym_uniform] = ACTIONS(3344),
    [anon_sym_row_major] = ACTIONS(3344),
    [anon_sym_column_major] = ACTIONS(3344),
    [anon_sym_globallycoherent] = ACTIONS(3344),
    [anon_sym_centroid] = ACTIONS(3344),
    [anon_sym_noperspective] = ACTIONS(3344),
    [anon_sym_nointerpolation] = ACTIONS(3344),
    [anon_sym_sample] = ACTIONS(3344),
    [anon_sym_linear] = ACTIONS(3344),
    [anon_sym_snorm] = ACTIONS(3344),
    [anon_sym_unorm] = ACTIONS(3344),
    [anon_sym_point] = ACTIONS(3344),
    [anon_sym_line] = ACTIONS(3344),
    [anon_sym_triangleadj] = ACTIONS(3344),
    [anon_sym_lineadj] = ACTIONS(3344),
    [anon_sym_triangle] = ACTIONS(3344),
    [anon_sym_cbuffer] = ACTIONS(3344),
    [anon_sym_interface] = ACTIONS(3344),
    [anon_sym_extension] = ACTIONS(3344),
  },
  [1326] = {
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(3320),
    [anon_sym_BANG] = ACTIONS(3320),
    [anon_sym_TILDE] = ACTIONS(3320),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3320),
    [anon_sym_AMP] = ACTIONS(3320),
    [anon_sym_SEMI] = ACTIONS(3320),
    [anon_sym___extension__] = ACTIONS(3318),
    [anon_sym_typedef] = ACTIONS(3318),
    [anon_sym_in] = ACTIONS(3318),
    [anon_sym_out] = ACTIONS(3318),
    [anon_sym_inout] = ACTIONS(3318),
    [anon_sym_extern] = ACTIONS(3318),
    [anon_sym___attribute__] = ACTIONS(3318),
    [anon_sym_COLON_COLON] = ACTIONS(3320),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3320),
    [anon_sym___declspec] = ACTIONS(3318),
    [anon_sym_LBRACE] = ACTIONS(3320),
    [anon_sym_signed] = ACTIONS(3318),
    [anon_sym_unsigned] = ACTIONS(3318),
    [anon_sym_long] = ACTIONS(3318),
    [anon_sym_short] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3318),
    [anon_sym_static] = ACTIONS(3318),
    [anon_sym_register] = ACTIONS(3318),
    [anon_sym_inline] = ACTIONS(3318),
    [anon_sym___inline] = ACTIONS(3318),
    [anon_sym___inline__] = ACTIONS(3318),
    [anon_sym___forceinline] = ACTIONS(3318),
    [anon_sym_thread_local] = ACTIONS(3318),
    [anon_sym___thread] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3318),
    [anon_sym_constexpr] = ACTIONS(3318),
    [anon_sym_volatile] = ACTIONS(3318),
    [anon_sym_restrict] = ACTIONS(3318),
    [anon_sym___restrict__] = ACTIONS(3318),
    [anon_sym__Atomic] = ACTIONS(3318),
    [anon_sym__Noreturn] = ACTIONS(3318),
    [anon_sym_noreturn] = ACTIONS(3318),
    [anon_sym_mutable] = ACTIONS(3318),
    [anon_sym_constinit] = ACTIONS(3318),
    [anon_sym_consteval] = ACTIONS(3318),
    [anon_sym_alignas] = ACTIONS(3318),
    [anon_sym__Alignas] = ACTIONS(3318),
    [sym_primitive_type] = ACTIONS(3318),
    [anon_sym_enum] = ACTIONS(3318),
    [anon_sym_class] = ACTIONS(3318),
    [anon_sym_struct] = ACTIONS(3318),
    [anon_sym_union] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_else] = ACTIONS(3318),
    [anon_sym_switch] = ACTIONS(3318),
    [anon_sym_while] = ACTIONS(3318),
    [anon_sym_do] = ACTIONS(3318),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_break] = ACTIONS(3318),
    [anon_sym_continue] = ACTIONS(3318),
    [anon_sym_goto] = ACTIONS(3318),
    [anon_sym___try] = ACTIONS(3318),
    [anon_sym___leave] = ACTIONS(3318),
    [anon_sym_not] = ACTIONS(3318),
    [anon_sym_compl] = ACTIONS(3318),
    [anon_sym_DASH_DASH] = ACTIONS(3320),
    [anon_sym_PLUS_PLUS] = ACTIONS(3320),
    [anon_sym_sizeof] = ACTIONS(3318),
    [anon_sym___alignof__] = ACTIONS(3318),
    [anon_sym___alignof] = ACTIONS(3318),
    [anon_sym__alignof] = ACTIONS(3318),
    [anon_sym_alignof] = ACTIONS(3318),
    [anon_sym__Alignof] = ACTIONS(3318),
    [anon_sym_offsetof] = ACTIONS(3318),
    [anon_sym__Generic] = ACTIONS(3318),
    [anon_sym_asm] = ACTIONS(3318),
    [anon_sym___asm__] = ACTIONS(3318),
    [sym_number_literal] = ACTIONS(3320),
    [anon_sym_L_SQUOTE] = ACTIONS(3320),
    [anon_sym_u_SQUOTE] = ACTIONS(3320),
    [anon_sym_U_SQUOTE] = ACTIONS(3320),
    [anon_sym_u8_SQUOTE] = ACTIONS(3320),
    [anon_sym_SQUOTE] = ACTIONS(3320),
    [anon_sym_L_DQUOTE] = ACTIONS(3320),
    [anon_sym_u_DQUOTE] = ACTIONS(3320),
    [anon_sym_U_DQUOTE] = ACTIONS(3320),
    [anon_sym_u8_DQUOTE] = ACTIONS(3320),
    [anon_sym_DQUOTE] = ACTIONS(3320),
    [sym_true] = ACTIONS(3318),
    [sym_false] = ACTIONS(3318),
    [anon_sym_NULL] = ACTIONS(3318),
    [anon_sym_nullptr] = ACTIONS(3318),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3318),
    [anon_sym_let] = ACTIONS(3318),
    [anon_sym_This] = ACTIONS(3318),
    [anon_sym_decltype] = ACTIONS(3318),
    [sym_virtual] = ACTIONS(3318),
    [anon_sym_typename] = ACTIONS(3318),
    [anon_sym_template] = ACTIONS(3318),
    [anon_sym_try] = ACTIONS(3318),
    [anon_sym_delete] = ACTIONS(3318),
    [anon_sym_throw] = ACTIONS(3318),
    [anon_sym_co_return] = ACTIONS(3318),
    [anon_sym_co_yield] = ACTIONS(3318),
    [anon_sym_R_DQUOTE] = ACTIONS(3320),
    [anon_sym_LR_DQUOTE] = ACTIONS(3320),
    [anon_sym_uR_DQUOTE] = ACTIONS(3320),
    [anon_sym_UR_DQUOTE] = ACTIONS(3320),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3320),
    [anon_sym_co_await] = ACTIONS(3318),
    [anon_sym_new] = ACTIONS(3318),
    [anon_sym_requires] = ACTIONS(3318),
    [sym_this] = ACTIONS(3318),
    [anon_sym_discard] = ACTIONS(3318),
    [anon_sym_precise] = ACTIONS(3318),
    [anon_sym_shared] = ACTIONS(3318),
    [anon_sym_groupshared] = ACTIONS(3318),
    [anon_sym_uniform] = ACTIONS(3318),
    [anon_sym_row_major] = ACTIONS(3318),
    [anon_sym_column_major] = ACTIONS(3318),
    [anon_sym_globallycoherent] = ACTIONS(3318),
    [anon_sym_centroid] = ACTIONS(3318),
    [anon_sym_noperspective] = ACTIONS(3318),
    [anon_sym_nointerpolation] = ACTIONS(3318),
    [anon_sym_sample] = ACTIONS(3318),
    [anon_sym_linear] = ACTIONS(3318),
    [anon_sym_snorm] = ACTIONS(3318),
    [anon_sym_unorm] = ACTIONS(3318),
    [anon_sym_point] = ACTIONS(3318),
    [anon_sym_line] = ACTIONS(3318),
    [anon_sym_triangleadj] = ACTIONS(3318),
    [anon_sym_lineadj] = ACTIONS(3318),
    [anon_sym_triangle] = ACTIONS(3318),
    [anon_sym_cbuffer] = ACTIONS(3318),
    [anon_sym_interface] = ACTIONS(3318),
    [anon_sym_extension] = ACTIONS(3318),
  },
  [1327] = {
    [sym_identifier] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3346),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym___extension__] = ACTIONS(3344),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_in] = ACTIONS(3344),
    [anon_sym_out] = ACTIONS(3344),
    [anon_sym_inout] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym___attribute__] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3346),
    [anon_sym___declspec] = ACTIONS(3344),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_signed] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym___inline] = ACTIONS(3344),
    [anon_sym___inline__] = ACTIONS(3344),
    [anon_sym___forceinline] = ACTIONS(3344),
    [anon_sym_thread_local] = ACTIONS(3344),
    [anon_sym___thread] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym___restrict__] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym__Noreturn] = ACTIONS(3344),
    [anon_sym_noreturn] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_constinit] = ACTIONS(3344),
    [anon_sym_consteval] = ACTIONS(3344),
    [anon_sym_alignas] = ACTIONS(3344),
    [anon_sym__Alignas] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_class] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_switch] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_break] = ACTIONS(3344),
    [anon_sym_continue] = ACTIONS(3344),
    [anon_sym_goto] = ACTIONS(3344),
    [anon_sym___try] = ACTIONS(3344),
    [anon_sym___leave] = ACTIONS(3344),
    [anon_sym_not] = ACTIONS(3344),
    [anon_sym_compl] = ACTIONS(3344),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_sizeof] = ACTIONS(3344),
    [anon_sym___alignof__] = ACTIONS(3344),
    [anon_sym___alignof] = ACTIONS(3344),
    [anon_sym__alignof] = ACTIONS(3344),
    [anon_sym_alignof] = ACTIONS(3344),
    [anon_sym__Alignof] = ACTIONS(3344),
    [anon_sym_offsetof] = ACTIONS(3344),
    [anon_sym__Generic] = ACTIONS(3344),
    [anon_sym_asm] = ACTIONS(3344),
    [anon_sym___asm__] = ACTIONS(3344),
    [sym_number_literal] = ACTIONS(3346),
    [anon_sym_L_SQUOTE] = ACTIONS(3346),
    [anon_sym_u_SQUOTE] = ACTIONS(3346),
    [anon_sym_U_SQUOTE] = ACTIONS(3346),
    [anon_sym_u8_SQUOTE] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_L_DQUOTE] = ACTIONS(3346),
    [anon_sym_u_DQUOTE] = ACTIONS(3346),
    [anon_sym_U_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8_DQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [sym_true] = ACTIONS(3344),
    [sym_false] = ACTIONS(3344),
    [anon_sym_NULL] = ACTIONS(3344),
    [anon_sym_nullptr] = ACTIONS(3344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_This] = ACTIONS(3344),
    [anon_sym_decltype] = ACTIONS(3344),
    [sym_virtual] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_template] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_delete] = ACTIONS(3344),
    [anon_sym_throw] = ACTIONS(3344),
    [anon_sym_co_return] = ACTIONS(3344),
    [anon_sym_co_yield] = ACTIONS(3344),
    [anon_sym_R_DQUOTE] = ACTIONS(3346),
    [anon_sym_LR_DQUOTE] = ACTIONS(3346),
    [anon_sym_uR_DQUOTE] = ACTIONS(3346),
    [anon_sym_UR_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3346),
    [anon_sym_co_await] = ACTIONS(3344),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_requires] = ACTIONS(3344),
    [sym_this] = ACTIONS(3344),
    [anon_sym_discard] = ACTIONS(3344),
    [anon_sym_precise] = ACTIONS(3344),
    [anon_sym_shared] = ACTIONS(3344),
    [anon_sym_groupshared] = ACTIONS(3344),
    [anon_sym_uniform] = ACTIONS(3344),
    [anon_sym_row_major] = ACTIONS(3344),
    [anon_sym_column_major] = ACTIONS(3344),
    [anon_sym_globallycoherent] = ACTIONS(3344),
    [anon_sym_centroid] = ACTIONS(3344),
    [anon_sym_noperspective] = ACTIONS(3344),
    [anon_sym_nointerpolation] = ACTIONS(3344),
    [anon_sym_sample] = ACTIONS(3344),
    [anon_sym_linear] = ACTIONS(3344),
    [anon_sym_snorm] = ACTIONS(3344),
    [anon_sym_unorm] = ACTIONS(3344),
    [anon_sym_point] = ACTIONS(3344),
    [anon_sym_line] = ACTIONS(3344),
    [anon_sym_triangleadj] = ACTIONS(3344),
    [anon_sym_lineadj] = ACTIONS(3344),
    [anon_sym_triangle] = ACTIONS(3344),
    [anon_sym_cbuffer] = ACTIONS(3344),
    [anon_sym_interface] = ACTIONS(3344),
    [anon_sym_extension] = ACTIONS(3344),
  },
  [1328] = {
    [sym_identifier] = ACTIONS(3374),
    [anon_sym_LPAREN2] = ACTIONS(3376),
    [anon_sym_BANG] = ACTIONS(3376),
    [anon_sym_TILDE] = ACTIONS(3376),
    [anon_sym_DASH] = ACTIONS(3374),
    [anon_sym_PLUS] = ACTIONS(3374),
    [anon_sym_STAR] = ACTIONS(3376),
    [anon_sym_AMP] = ACTIONS(3376),
    [anon_sym_SEMI] = ACTIONS(3376),
    [anon_sym___extension__] = ACTIONS(3374),
    [anon_sym_typedef] = ACTIONS(3374),
    [anon_sym_in] = ACTIONS(3374),
    [anon_sym_out] = ACTIONS(3374),
    [anon_sym_inout] = ACTIONS(3374),
    [anon_sym_extern] = ACTIONS(3374),
    [anon_sym___attribute__] = ACTIONS(3374),
    [anon_sym_COLON_COLON] = ACTIONS(3376),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3376),
    [anon_sym___declspec] = ACTIONS(3374),
    [anon_sym_LBRACE] = ACTIONS(3376),
    [anon_sym_signed] = ACTIONS(3374),
    [anon_sym_unsigned] = ACTIONS(3374),
    [anon_sym_long] = ACTIONS(3374),
    [anon_sym_short] = ACTIONS(3374),
    [anon_sym_LBRACK] = ACTIONS(3374),
    [anon_sym_static] = ACTIONS(3374),
    [anon_sym_register] = ACTIONS(3374),
    [anon_sym_inline] = ACTIONS(3374),
    [anon_sym___inline] = ACTIONS(3374),
    [anon_sym___inline__] = ACTIONS(3374),
    [anon_sym___forceinline] = ACTIONS(3374),
    [anon_sym_thread_local] = ACTIONS(3374),
    [anon_sym___thread] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3374),
    [anon_sym_constexpr] = ACTIONS(3374),
    [anon_sym_volatile] = ACTIONS(3374),
    [anon_sym_restrict] = ACTIONS(3374),
    [anon_sym___restrict__] = ACTIONS(3374),
    [anon_sym__Atomic] = ACTIONS(3374),
    [anon_sym__Noreturn] = ACTIONS(3374),
    [anon_sym_noreturn] = ACTIONS(3374),
    [anon_sym_mutable] = ACTIONS(3374),
    [anon_sym_constinit] = ACTIONS(3374),
    [anon_sym_consteval] = ACTIONS(3374),
    [anon_sym_alignas] = ACTIONS(3374),
    [anon_sym__Alignas] = ACTIONS(3374),
    [sym_primitive_type] = ACTIONS(3374),
    [anon_sym_enum] = ACTIONS(3374),
    [anon_sym_class] = ACTIONS(3374),
    [anon_sym_struct] = ACTIONS(3374),
    [anon_sym_union] = ACTIONS(3374),
    [anon_sym_if] = ACTIONS(3374),
    [anon_sym_else] = ACTIONS(3374),
    [anon_sym_switch] = ACTIONS(3374),
    [anon_sym_while] = ACTIONS(3374),
    [anon_sym_do] = ACTIONS(3374),
    [anon_sym_for] = ACTIONS(3374),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_break] = ACTIONS(3374),
    [anon_sym_continue] = ACTIONS(3374),
    [anon_sym_goto] = ACTIONS(3374),
    [anon_sym___try] = ACTIONS(3374),
    [anon_sym___leave] = ACTIONS(3374),
    [anon_sym_not] = ACTIONS(3374),
    [anon_sym_compl] = ACTIONS(3374),
    [anon_sym_DASH_DASH] = ACTIONS(3376),
    [anon_sym_PLUS_PLUS] = ACTIONS(3376),
    [anon_sym_sizeof] = ACTIONS(3374),
    [anon_sym___alignof__] = ACTIONS(3374),
    [anon_sym___alignof] = ACTIONS(3374),
    [anon_sym__alignof] = ACTIONS(3374),
    [anon_sym_alignof] = ACTIONS(3374),
    [anon_sym__Alignof] = ACTIONS(3374),
    [anon_sym_offsetof] = ACTIONS(3374),
    [anon_sym__Generic] = ACTIONS(3374),
    [anon_sym_asm] = ACTIONS(3374),
    [anon_sym___asm__] = ACTIONS(3374),
    [sym_number_literal] = ACTIONS(3376),
    [anon_sym_L_SQUOTE] = ACTIONS(3376),
    [anon_sym_u_SQUOTE] = ACTIONS(3376),
    [anon_sym_U_SQUOTE] = ACTIONS(3376),
    [anon_sym_u8_SQUOTE] = ACTIONS(3376),
    [anon_sym_SQUOTE] = ACTIONS(3376),
    [anon_sym_L_DQUOTE] = ACTIONS(3376),
    [anon_sym_u_DQUOTE] = ACTIONS(3376),
    [anon_sym_U_DQUOTE] = ACTIONS(3376),
    [anon_sym_u8_DQUOTE] = ACTIONS(3376),
    [anon_sym_DQUOTE] = ACTIONS(3376),
    [sym_true] = ACTIONS(3374),
    [sym_false] = ACTIONS(3374),
    [anon_sym_NULL] = ACTIONS(3374),
    [anon_sym_nullptr] = ACTIONS(3374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3374),
    [anon_sym_let] = ACTIONS(3374),
    [anon_sym_This] = ACTIONS(3374),
    [anon_sym_decltype] = ACTIONS(3374),
    [sym_virtual] = ACTIONS(3374),
    [anon_sym_typename] = ACTIONS(3374),
    [anon_sym_template] = ACTIONS(3374),
    [anon_sym_try] = ACTIONS(3374),
    [anon_sym_delete] = ACTIONS(3374),
    [anon_sym_throw] = ACTIONS(3374),
    [anon_sym_co_return] = ACTIONS(3374),
    [anon_sym_co_yield] = ACTIONS(3374),
    [anon_sym_R_DQUOTE] = ACTIONS(3376),
    [anon_sym_LR_DQUOTE] = ACTIONS(3376),
    [anon_sym_uR_DQUOTE] = ACTIONS(3376),
    [anon_sym_UR_DQUOTE] = ACTIONS(3376),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3376),
    [anon_sym_co_await] = ACTIONS(3374),
    [anon_sym_new] = ACTIONS(3374),
    [anon_sym_requires] = ACTIONS(3374),
    [sym_this] = ACTIONS(3374),
    [anon_sym_discard] = ACTIONS(3374),
    [anon_sym_precise] = ACTIONS(3374),
    [anon_sym_shared] = ACTIONS(3374),
    [anon_sym_groupshared] = ACTIONS(3374),
    [anon_sym_uniform] = ACTIONS(3374),
    [anon_sym_row_major] = ACTIONS(3374),
    [anon_sym_column_major] = ACTIONS(3374),
    [anon_sym_globallycoherent] = ACTIONS(3374),
    [anon_sym_centroid] = ACTIONS(3374),
    [anon_sym_noperspective] = ACTIONS(3374),
    [anon_sym_nointerpolation] = ACTIONS(3374),
    [anon_sym_sample] = ACTIONS(3374),
    [anon_sym_linear] = ACTIONS(3374),
    [anon_sym_snorm] = ACTIONS(3374),
    [anon_sym_unorm] = ACTIONS(3374),
    [anon_sym_point] = ACTIONS(3374),
    [anon_sym_line] = ACTIONS(3374),
    [anon_sym_triangleadj] = ACTIONS(3374),
    [anon_sym_lineadj] = ACTIONS(3374),
    [anon_sym_triangle] = ACTIONS(3374),
    [anon_sym_cbuffer] = ACTIONS(3374),
    [anon_sym_interface] = ACTIONS(3374),
    [anon_sym_extension] = ACTIONS(3374),
  },
  [1329] = {
    [sym_identifier] = ACTIONS(3230),
    [anon_sym_LPAREN2] = ACTIONS(3232),
    [anon_sym_BANG] = ACTIONS(3232),
    [anon_sym_TILDE] = ACTIONS(3232),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_STAR] = ACTIONS(3232),
    [anon_sym_AMP] = ACTIONS(3232),
    [anon_sym_SEMI] = ACTIONS(3232),
    [anon_sym___extension__] = ACTIONS(3230),
    [anon_sym_typedef] = ACTIONS(3230),
    [anon_sym_in] = ACTIONS(3230),
    [anon_sym_out] = ACTIONS(3230),
    [anon_sym_inout] = ACTIONS(3230),
    [anon_sym_extern] = ACTIONS(3230),
    [anon_sym___attribute__] = ACTIONS(3230),
    [anon_sym_COLON_COLON] = ACTIONS(3232),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3232),
    [anon_sym___declspec] = ACTIONS(3230),
    [anon_sym_LBRACE] = ACTIONS(3232),
    [anon_sym_signed] = ACTIONS(3230),
    [anon_sym_unsigned] = ACTIONS(3230),
    [anon_sym_long] = ACTIONS(3230),
    [anon_sym_short] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_static] = ACTIONS(3230),
    [anon_sym_register] = ACTIONS(3230),
    [anon_sym_inline] = ACTIONS(3230),
    [anon_sym___inline] = ACTIONS(3230),
    [anon_sym___inline__] = ACTIONS(3230),
    [anon_sym___forceinline] = ACTIONS(3230),
    [anon_sym_thread_local] = ACTIONS(3230),
    [anon_sym___thread] = ACTIONS(3230),
    [anon_sym_const] = ACTIONS(3230),
    [anon_sym_constexpr] = ACTIONS(3230),
    [anon_sym_volatile] = ACTIONS(3230),
    [anon_sym_restrict] = ACTIONS(3230),
    [anon_sym___restrict__] = ACTIONS(3230),
    [anon_sym__Atomic] = ACTIONS(3230),
    [anon_sym__Noreturn] = ACTIONS(3230),
    [anon_sym_noreturn] = ACTIONS(3230),
    [anon_sym_mutable] = ACTIONS(3230),
    [anon_sym_constinit] = ACTIONS(3230),
    [anon_sym_consteval] = ACTIONS(3230),
    [anon_sym_alignas] = ACTIONS(3230),
    [anon_sym__Alignas] = ACTIONS(3230),
    [sym_primitive_type] = ACTIONS(3230),
    [anon_sym_enum] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3230),
    [anon_sym_struct] = ACTIONS(3230),
    [anon_sym_union] = ACTIONS(3230),
    [anon_sym_if] = ACTIONS(3230),
    [anon_sym_else] = ACTIONS(3230),
    [anon_sym_switch] = ACTIONS(3230),
    [anon_sym_while] = ACTIONS(3230),
    [anon_sym_do] = ACTIONS(3230),
    [anon_sym_for] = ACTIONS(3230),
    [anon_sym_return] = ACTIONS(3230),
    [anon_sym_break] = ACTIONS(3230),
    [anon_sym_continue] = ACTIONS(3230),
    [anon_sym_goto] = ACTIONS(3230),
    [anon_sym___try] = ACTIONS(3230),
    [anon_sym___leave] = ACTIONS(3230),
    [anon_sym_not] = ACTIONS(3230),
    [anon_sym_compl] = ACTIONS(3230),
    [anon_sym_DASH_DASH] = ACTIONS(3232),
    [anon_sym_PLUS_PLUS] = ACTIONS(3232),
    [anon_sym_sizeof] = ACTIONS(3230),
    [anon_sym___alignof__] = ACTIONS(3230),
    [anon_sym___alignof] = ACTIONS(3230),
    [anon_sym__alignof] = ACTIONS(3230),
    [anon_sym_alignof] = ACTIONS(3230),
    [anon_sym__Alignof] = ACTIONS(3230),
    [anon_sym_offsetof] = ACTIONS(3230),
    [anon_sym__Generic] = ACTIONS(3230),
    [anon_sym_asm] = ACTIONS(3230),
    [anon_sym___asm__] = ACTIONS(3230),
    [sym_number_literal] = ACTIONS(3232),
    [anon_sym_L_SQUOTE] = ACTIONS(3232),
    [anon_sym_u_SQUOTE] = ACTIONS(3232),
    [anon_sym_U_SQUOTE] = ACTIONS(3232),
    [anon_sym_u8_SQUOTE] = ACTIONS(3232),
    [anon_sym_SQUOTE] = ACTIONS(3232),
    [anon_sym_L_DQUOTE] = ACTIONS(3232),
    [anon_sym_u_DQUOTE] = ACTIONS(3232),
    [anon_sym_U_DQUOTE] = ACTIONS(3232),
    [anon_sym_u8_DQUOTE] = ACTIONS(3232),
    [anon_sym_DQUOTE] = ACTIONS(3232),
    [sym_true] = ACTIONS(3230),
    [sym_false] = ACTIONS(3230),
    [anon_sym_NULL] = ACTIONS(3230),
    [anon_sym_nullptr] = ACTIONS(3230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3230),
    [anon_sym_let] = ACTIONS(3230),
    [anon_sym_This] = ACTIONS(3230),
    [anon_sym_decltype] = ACTIONS(3230),
    [sym_virtual] = ACTIONS(3230),
    [anon_sym_typename] = ACTIONS(3230),
    [anon_sym_template] = ACTIONS(3230),
    [anon_sym_try] = ACTIONS(3230),
    [anon_sym_delete] = ACTIONS(3230),
    [anon_sym_throw] = ACTIONS(3230),
    [anon_sym_co_return] = ACTIONS(3230),
    [anon_sym_co_yield] = ACTIONS(3230),
    [anon_sym_R_DQUOTE] = ACTIONS(3232),
    [anon_sym_LR_DQUOTE] = ACTIONS(3232),
    [anon_sym_uR_DQUOTE] = ACTIONS(3232),
    [anon_sym_UR_DQUOTE] = ACTIONS(3232),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3232),
    [anon_sym_co_await] = ACTIONS(3230),
    [anon_sym_new] = ACTIONS(3230),
    [anon_sym_requires] = ACTIONS(3230),
    [sym_this] = ACTIONS(3230),
    [anon_sym_discard] = ACTIONS(3230),
    [anon_sym_precise] = ACTIONS(3230),
    [anon_sym_shared] = ACTIONS(3230),
    [anon_sym_groupshared] = ACTIONS(3230),
    [anon_sym_uniform] = ACTIONS(3230),
    [anon_sym_row_major] = ACTIONS(3230),
    [anon_sym_column_major] = ACTIONS(3230),
    [anon_sym_globallycoherent] = ACTIONS(3230),
    [anon_sym_centroid] = ACTIONS(3230),
    [anon_sym_noperspective] = ACTIONS(3230),
    [anon_sym_nointerpolation] = ACTIONS(3230),
    [anon_sym_sample] = ACTIONS(3230),
    [anon_sym_linear] = ACTIONS(3230),
    [anon_sym_snorm] = ACTIONS(3230),
    [anon_sym_unorm] = ACTIONS(3230),
    [anon_sym_point] = ACTIONS(3230),
    [anon_sym_line] = ACTIONS(3230),
    [anon_sym_triangleadj] = ACTIONS(3230),
    [anon_sym_lineadj] = ACTIONS(3230),
    [anon_sym_triangle] = ACTIONS(3230),
    [anon_sym_cbuffer] = ACTIONS(3230),
    [anon_sym_interface] = ACTIONS(3230),
    [anon_sym_extension] = ACTIONS(3230),
  },
  [1330] = {
    [sym_identifier] = ACTIONS(3310),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_BANG] = ACTIONS(3312),
    [anon_sym_TILDE] = ACTIONS(3312),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3312),
    [anon_sym_SEMI] = ACTIONS(3312),
    [anon_sym___extension__] = ACTIONS(3310),
    [anon_sym_typedef] = ACTIONS(3310),
    [anon_sym_in] = ACTIONS(3310),
    [anon_sym_out] = ACTIONS(3310),
    [anon_sym_inout] = ACTIONS(3310),
    [anon_sym_extern] = ACTIONS(3310),
    [anon_sym___attribute__] = ACTIONS(3310),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3312),
    [anon_sym___declspec] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3312),
    [anon_sym_signed] = ACTIONS(3310),
    [anon_sym_unsigned] = ACTIONS(3310),
    [anon_sym_long] = ACTIONS(3310),
    [anon_sym_short] = ACTIONS(3310),
    [anon_sym_LBRACK] = ACTIONS(3310),
    [anon_sym_static] = ACTIONS(3310),
    [anon_sym_register] = ACTIONS(3310),
    [anon_sym_inline] = ACTIONS(3310),
    [anon_sym___inline] = ACTIONS(3310),
    [anon_sym___inline__] = ACTIONS(3310),
    [anon_sym___forceinline] = ACTIONS(3310),
    [anon_sym_thread_local] = ACTIONS(3310),
    [anon_sym___thread] = ACTIONS(3310),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_constexpr] = ACTIONS(3310),
    [anon_sym_volatile] = ACTIONS(3310),
    [anon_sym_restrict] = ACTIONS(3310),
    [anon_sym___restrict__] = ACTIONS(3310),
    [anon_sym__Atomic] = ACTIONS(3310),
    [anon_sym__Noreturn] = ACTIONS(3310),
    [anon_sym_noreturn] = ACTIONS(3310),
    [anon_sym_mutable] = ACTIONS(3310),
    [anon_sym_constinit] = ACTIONS(3310),
    [anon_sym_consteval] = ACTIONS(3310),
    [anon_sym_alignas] = ACTIONS(3310),
    [anon_sym__Alignas] = ACTIONS(3310),
    [sym_primitive_type] = ACTIONS(3310),
    [anon_sym_enum] = ACTIONS(3310),
    [anon_sym_class] = ACTIONS(3310),
    [anon_sym_struct] = ACTIONS(3310),
    [anon_sym_union] = ACTIONS(3310),
    [anon_sym_if] = ACTIONS(3310),
    [anon_sym_else] = ACTIONS(3310),
    [anon_sym_switch] = ACTIONS(3310),
    [anon_sym_while] = ACTIONS(3310),
    [anon_sym_do] = ACTIONS(3310),
    [anon_sym_for] = ACTIONS(3310),
    [anon_sym_return] = ACTIONS(3310),
    [anon_sym_break] = ACTIONS(3310),
    [anon_sym_continue] = ACTIONS(3310),
    [anon_sym_goto] = ACTIONS(3310),
    [anon_sym___try] = ACTIONS(3310),
    [anon_sym___leave] = ACTIONS(3310),
    [anon_sym_not] = ACTIONS(3310),
    [anon_sym_compl] = ACTIONS(3310),
    [anon_sym_DASH_DASH] = ACTIONS(3312),
    [anon_sym_PLUS_PLUS] = ACTIONS(3312),
    [anon_sym_sizeof] = ACTIONS(3310),
    [anon_sym___alignof__] = ACTIONS(3310),
    [anon_sym___alignof] = ACTIONS(3310),
    [anon_sym__alignof] = ACTIONS(3310),
    [anon_sym_alignof] = ACTIONS(3310),
    [anon_sym__Alignof] = ACTIONS(3310),
    [anon_sym_offsetof] = ACTIONS(3310),
    [anon_sym__Generic] = ACTIONS(3310),
    [anon_sym_asm] = ACTIONS(3310),
    [anon_sym___asm__] = ACTIONS(3310),
    [sym_number_literal] = ACTIONS(3312),
    [anon_sym_L_SQUOTE] = ACTIONS(3312),
    [anon_sym_u_SQUOTE] = ACTIONS(3312),
    [anon_sym_U_SQUOTE] = ACTIONS(3312),
    [anon_sym_u8_SQUOTE] = ACTIONS(3312),
    [anon_sym_SQUOTE] = ACTIONS(3312),
    [anon_sym_L_DQUOTE] = ACTIONS(3312),
    [anon_sym_u_DQUOTE] = ACTIONS(3312),
    [anon_sym_U_DQUOTE] = ACTIONS(3312),
    [anon_sym_u8_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE] = ACTIONS(3312),
    [sym_true] = ACTIONS(3310),
    [sym_false] = ACTIONS(3310),
    [anon_sym_NULL] = ACTIONS(3310),
    [anon_sym_nullptr] = ACTIONS(3310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3310),
    [anon_sym_let] = ACTIONS(3310),
    [anon_sym_This] = ACTIONS(3310),
    [anon_sym_decltype] = ACTIONS(3310),
    [sym_virtual] = ACTIONS(3310),
    [anon_sym_typename] = ACTIONS(3310),
    [anon_sym_template] = ACTIONS(3310),
    [anon_sym_try] = ACTIONS(3310),
    [anon_sym_delete] = ACTIONS(3310),
    [anon_sym_throw] = ACTIONS(3310),
    [anon_sym_co_return] = ACTIONS(3310),
    [anon_sym_co_yield] = ACTIONS(3310),
    [anon_sym_R_DQUOTE] = ACTIONS(3312),
    [anon_sym_LR_DQUOTE] = ACTIONS(3312),
    [anon_sym_uR_DQUOTE] = ACTIONS(3312),
    [anon_sym_UR_DQUOTE] = ACTIONS(3312),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3312),
    [anon_sym_co_await] = ACTIONS(3310),
    [anon_sym_new] = ACTIONS(3310),
    [anon_sym_requires] = ACTIONS(3310),
    [sym_this] = ACTIONS(3310),
    [anon_sym_discard] = ACTIONS(3310),
    [anon_sym_precise] = ACTIONS(3310),
    [anon_sym_shared] = ACTIONS(3310),
    [anon_sym_groupshared] = ACTIONS(3310),
    [anon_sym_uniform] = ACTIONS(3310),
    [anon_sym_row_major] = ACTIONS(3310),
    [anon_sym_column_major] = ACTIONS(3310),
    [anon_sym_globallycoherent] = ACTIONS(3310),
    [anon_sym_centroid] = ACTIONS(3310),
    [anon_sym_noperspective] = ACTIONS(3310),
    [anon_sym_nointerpolation] = ACTIONS(3310),
    [anon_sym_sample] = ACTIONS(3310),
    [anon_sym_linear] = ACTIONS(3310),
    [anon_sym_snorm] = ACTIONS(3310),
    [anon_sym_unorm] = ACTIONS(3310),
    [anon_sym_point] = ACTIONS(3310),
    [anon_sym_line] = ACTIONS(3310),
    [anon_sym_triangleadj] = ACTIONS(3310),
    [anon_sym_lineadj] = ACTIONS(3310),
    [anon_sym_triangle] = ACTIONS(3310),
    [anon_sym_cbuffer] = ACTIONS(3310),
    [anon_sym_interface] = ACTIONS(3310),
    [anon_sym_extension] = ACTIONS(3310),
  },
  [1331] = {
    [sym_identifier] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3346),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym___extension__] = ACTIONS(3344),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_in] = ACTIONS(3344),
    [anon_sym_out] = ACTIONS(3344),
    [anon_sym_inout] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym___attribute__] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3346),
    [anon_sym___declspec] = ACTIONS(3344),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_signed] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym___inline] = ACTIONS(3344),
    [anon_sym___inline__] = ACTIONS(3344),
    [anon_sym___forceinline] = ACTIONS(3344),
    [anon_sym_thread_local] = ACTIONS(3344),
    [anon_sym___thread] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym___restrict__] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym__Noreturn] = ACTIONS(3344),
    [anon_sym_noreturn] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_constinit] = ACTIONS(3344),
    [anon_sym_consteval] = ACTIONS(3344),
    [anon_sym_alignas] = ACTIONS(3344),
    [anon_sym__Alignas] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_class] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_switch] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_break] = ACTIONS(3344),
    [anon_sym_continue] = ACTIONS(3344),
    [anon_sym_goto] = ACTIONS(3344),
    [anon_sym___try] = ACTIONS(3344),
    [anon_sym___leave] = ACTIONS(3344),
    [anon_sym_not] = ACTIONS(3344),
    [anon_sym_compl] = ACTIONS(3344),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_sizeof] = ACTIONS(3344),
    [anon_sym___alignof__] = ACTIONS(3344),
    [anon_sym___alignof] = ACTIONS(3344),
    [anon_sym__alignof] = ACTIONS(3344),
    [anon_sym_alignof] = ACTIONS(3344),
    [anon_sym__Alignof] = ACTIONS(3344),
    [anon_sym_offsetof] = ACTIONS(3344),
    [anon_sym__Generic] = ACTIONS(3344),
    [anon_sym_asm] = ACTIONS(3344),
    [anon_sym___asm__] = ACTIONS(3344),
    [sym_number_literal] = ACTIONS(3346),
    [anon_sym_L_SQUOTE] = ACTIONS(3346),
    [anon_sym_u_SQUOTE] = ACTIONS(3346),
    [anon_sym_U_SQUOTE] = ACTIONS(3346),
    [anon_sym_u8_SQUOTE] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_L_DQUOTE] = ACTIONS(3346),
    [anon_sym_u_DQUOTE] = ACTIONS(3346),
    [anon_sym_U_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8_DQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [sym_true] = ACTIONS(3344),
    [sym_false] = ACTIONS(3344),
    [anon_sym_NULL] = ACTIONS(3344),
    [anon_sym_nullptr] = ACTIONS(3344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_This] = ACTIONS(3344),
    [anon_sym_decltype] = ACTIONS(3344),
    [sym_virtual] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_template] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_delete] = ACTIONS(3344),
    [anon_sym_throw] = ACTIONS(3344),
    [anon_sym_co_return] = ACTIONS(3344),
    [anon_sym_co_yield] = ACTIONS(3344),
    [anon_sym_R_DQUOTE] = ACTIONS(3346),
    [anon_sym_LR_DQUOTE] = ACTIONS(3346),
    [anon_sym_uR_DQUOTE] = ACTIONS(3346),
    [anon_sym_UR_DQUOTE] = ACTIONS(3346),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3346),
    [anon_sym_co_await] = ACTIONS(3344),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_requires] = ACTIONS(3344),
    [sym_this] = ACTIONS(3344),
    [anon_sym_discard] = ACTIONS(3344),
    [anon_sym_precise] = ACTIONS(3344),
    [anon_sym_shared] = ACTIONS(3344),
    [anon_sym_groupshared] = ACTIONS(3344),
    [anon_sym_uniform] = ACTIONS(3344),
    [anon_sym_row_major] = ACTIONS(3344),
    [anon_sym_column_major] = ACTIONS(3344),
    [anon_sym_globallycoherent] = ACTIONS(3344),
    [anon_sym_centroid] = ACTIONS(3344),
    [anon_sym_noperspective] = ACTIONS(3344),
    [anon_sym_nointerpolation] = ACTIONS(3344),
    [anon_sym_sample] = ACTIONS(3344),
    [anon_sym_linear] = ACTIONS(3344),
    [anon_sym_snorm] = ACTIONS(3344),
    [anon_sym_unorm] = ACTIONS(3344),
    [anon_sym_point] = ACTIONS(3344),
    [anon_sym_line] = ACTIONS(3344),
    [anon_sym_triangleadj] = ACTIONS(3344),
    [anon_sym_lineadj] = ACTIONS(3344),
    [anon_sym_triangle] = ACTIONS(3344),
    [anon_sym_cbuffer] = ACTIONS(3344),
    [anon_sym_interface] = ACTIONS(3344),
    [anon_sym_extension] = ACTIONS(3344),
  },
  [1332] = {
    [sym_identifier] = ACTIONS(3368),
    [anon_sym_LPAREN2] = ACTIONS(3370),
    [anon_sym_BANG] = ACTIONS(3370),
    [anon_sym_TILDE] = ACTIONS(3370),
    [anon_sym_DASH] = ACTIONS(3368),
    [anon_sym_PLUS] = ACTIONS(3368),
    [anon_sym_STAR] = ACTIONS(3370),
    [anon_sym_AMP] = ACTIONS(3370),
    [anon_sym_SEMI] = ACTIONS(3370),
    [anon_sym___extension__] = ACTIONS(3368),
    [anon_sym_typedef] = ACTIONS(3368),
    [anon_sym_in] = ACTIONS(3368),
    [anon_sym_out] = ACTIONS(3368),
    [anon_sym_inout] = ACTIONS(3368),
    [anon_sym_extern] = ACTIONS(3368),
    [anon_sym___attribute__] = ACTIONS(3368),
    [anon_sym_COLON_COLON] = ACTIONS(3370),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3370),
    [anon_sym___declspec] = ACTIONS(3368),
    [anon_sym_LBRACE] = ACTIONS(3370),
    [anon_sym_signed] = ACTIONS(3368),
    [anon_sym_unsigned] = ACTIONS(3368),
    [anon_sym_long] = ACTIONS(3368),
    [anon_sym_short] = ACTIONS(3368),
    [anon_sym_LBRACK] = ACTIONS(3368),
    [anon_sym_static] = ACTIONS(3368),
    [anon_sym_register] = ACTIONS(3368),
    [anon_sym_inline] = ACTIONS(3368),
    [anon_sym___inline] = ACTIONS(3368),
    [anon_sym___inline__] = ACTIONS(3368),
    [anon_sym___forceinline] = ACTIONS(3368),
    [anon_sym_thread_local] = ACTIONS(3368),
    [anon_sym___thread] = ACTIONS(3368),
    [anon_sym_const] = ACTIONS(3368),
    [anon_sym_constexpr] = ACTIONS(3368),
    [anon_sym_volatile] = ACTIONS(3368),
    [anon_sym_restrict] = ACTIONS(3368),
    [anon_sym___restrict__] = ACTIONS(3368),
    [anon_sym__Atomic] = ACTIONS(3368),
    [anon_sym__Noreturn] = ACTIONS(3368),
    [anon_sym_noreturn] = ACTIONS(3368),
    [anon_sym_mutable] = ACTIONS(3368),
    [anon_sym_constinit] = ACTIONS(3368),
    [anon_sym_consteval] = ACTIONS(3368),
    [anon_sym_alignas] = ACTIONS(3368),
    [anon_sym__Alignas] = ACTIONS(3368),
    [sym_primitive_type] = ACTIONS(3368),
    [anon_sym_enum] = ACTIONS(3368),
    [anon_sym_class] = ACTIONS(3368),
    [anon_sym_struct] = ACTIONS(3368),
    [anon_sym_union] = ACTIONS(3368),
    [anon_sym_if] = ACTIONS(3368),
    [anon_sym_else] = ACTIONS(3368),
    [anon_sym_switch] = ACTIONS(3368),
    [anon_sym_while] = ACTIONS(3368),
    [anon_sym_do] = ACTIONS(3368),
    [anon_sym_for] = ACTIONS(3368),
    [anon_sym_return] = ACTIONS(3368),
    [anon_sym_break] = ACTIONS(3368),
    [anon_sym_continue] = ACTIONS(3368),
    [anon_sym_goto] = ACTIONS(3368),
    [anon_sym___try] = ACTIONS(3368),
    [anon_sym___leave] = ACTIONS(3368),
    [anon_sym_not] = ACTIONS(3368),
    [anon_sym_compl] = ACTIONS(3368),
    [anon_sym_DASH_DASH] = ACTIONS(3370),
    [anon_sym_PLUS_PLUS] = ACTIONS(3370),
    [anon_sym_sizeof] = ACTIONS(3368),
    [anon_sym___alignof__] = ACTIONS(3368),
    [anon_sym___alignof] = ACTIONS(3368),
    [anon_sym__alignof] = ACTIONS(3368),
    [anon_sym_alignof] = ACTIONS(3368),
    [anon_sym__Alignof] = ACTIONS(3368),
    [anon_sym_offsetof] = ACTIONS(3368),
    [anon_sym__Generic] = ACTIONS(3368),
    [anon_sym_asm] = ACTIONS(3368),
    [anon_sym___asm__] = ACTIONS(3368),
    [sym_number_literal] = ACTIONS(3370),
    [anon_sym_L_SQUOTE] = ACTIONS(3370),
    [anon_sym_u_SQUOTE] = ACTIONS(3370),
    [anon_sym_U_SQUOTE] = ACTIONS(3370),
    [anon_sym_u8_SQUOTE] = ACTIONS(3370),
    [anon_sym_SQUOTE] = ACTIONS(3370),
    [anon_sym_L_DQUOTE] = ACTIONS(3370),
    [anon_sym_u_DQUOTE] = ACTIONS(3370),
    [anon_sym_U_DQUOTE] = ACTIONS(3370),
    [anon_sym_u8_DQUOTE] = ACTIONS(3370),
    [anon_sym_DQUOTE] = ACTIONS(3370),
    [sym_true] = ACTIONS(3368),
    [sym_false] = ACTIONS(3368),
    [anon_sym_NULL] = ACTIONS(3368),
    [anon_sym_nullptr] = ACTIONS(3368),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3368),
    [anon_sym_let] = ACTIONS(3368),
    [anon_sym_This] = ACTIONS(3368),
    [anon_sym_decltype] = ACTIONS(3368),
    [sym_virtual] = ACTIONS(3368),
    [anon_sym_typename] = ACTIONS(3368),
    [anon_sym_template] = ACTIONS(3368),
    [anon_sym_try] = ACTIONS(3368),
    [anon_sym_delete] = ACTIONS(3368),
    [anon_sym_throw] = ACTIONS(3368),
    [anon_sym_co_return] = ACTIONS(3368),
    [anon_sym_co_yield] = ACTIONS(3368),
    [anon_sym_R_DQUOTE] = ACTIONS(3370),
    [anon_sym_LR_DQUOTE] = ACTIONS(3370),
    [anon_sym_uR_DQUOTE] = ACTIONS(3370),
    [anon_sym_UR_DQUOTE] = ACTIONS(3370),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3370),
    [anon_sym_co_await] = ACTIONS(3368),
    [anon_sym_new] = ACTIONS(3368),
    [anon_sym_requires] = ACTIONS(3368),
    [sym_this] = ACTIONS(3368),
    [anon_sym_discard] = ACTIONS(3368),
    [anon_sym_precise] = ACTIONS(3368),
    [anon_sym_shared] = ACTIONS(3368),
    [anon_sym_groupshared] = ACTIONS(3368),
    [anon_sym_uniform] = ACTIONS(3368),
    [anon_sym_row_major] = ACTIONS(3368),
    [anon_sym_column_major] = ACTIONS(3368),
    [anon_sym_globallycoherent] = ACTIONS(3368),
    [anon_sym_centroid] = ACTIONS(3368),
    [anon_sym_noperspective] = ACTIONS(3368),
    [anon_sym_nointerpolation] = ACTIONS(3368),
    [anon_sym_sample] = ACTIONS(3368),
    [anon_sym_linear] = ACTIONS(3368),
    [anon_sym_snorm] = ACTIONS(3368),
    [anon_sym_unorm] = ACTIONS(3368),
    [anon_sym_point] = ACTIONS(3368),
    [anon_sym_line] = ACTIONS(3368),
    [anon_sym_triangleadj] = ACTIONS(3368),
    [anon_sym_lineadj] = ACTIONS(3368),
    [anon_sym_triangle] = ACTIONS(3368),
    [anon_sym_cbuffer] = ACTIONS(3368),
    [anon_sym_interface] = ACTIONS(3368),
    [anon_sym_extension] = ACTIONS(3368),
  },
  [1333] = {
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(3342),
    [anon_sym_BANG] = ACTIONS(3342),
    [anon_sym_TILDE] = ACTIONS(3342),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_STAR] = ACTIONS(3342),
    [anon_sym_AMP] = ACTIONS(3342),
    [anon_sym_SEMI] = ACTIONS(3342),
    [anon_sym___extension__] = ACTIONS(3340),
    [anon_sym_typedef] = ACTIONS(3340),
    [anon_sym_in] = ACTIONS(3340),
    [anon_sym_out] = ACTIONS(3340),
    [anon_sym_inout] = ACTIONS(3340),
    [anon_sym_extern] = ACTIONS(3340),
    [anon_sym___attribute__] = ACTIONS(3340),
    [anon_sym_COLON_COLON] = ACTIONS(3342),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3342),
    [anon_sym___declspec] = ACTIONS(3340),
    [anon_sym_LBRACE] = ACTIONS(3342),
    [anon_sym_signed] = ACTIONS(3340),
    [anon_sym_unsigned] = ACTIONS(3340),
    [anon_sym_long] = ACTIONS(3340),
    [anon_sym_short] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3340),
    [anon_sym_static] = ACTIONS(3340),
    [anon_sym_register] = ACTIONS(3340),
    [anon_sym_inline] = ACTIONS(3340),
    [anon_sym___inline] = ACTIONS(3340),
    [anon_sym___inline__] = ACTIONS(3340),
    [anon_sym___forceinline] = ACTIONS(3340),
    [anon_sym_thread_local] = ACTIONS(3340),
    [anon_sym___thread] = ACTIONS(3340),
    [anon_sym_const] = ACTIONS(3340),
    [anon_sym_constexpr] = ACTIONS(3340),
    [anon_sym_volatile] = ACTIONS(3340),
    [anon_sym_restrict] = ACTIONS(3340),
    [anon_sym___restrict__] = ACTIONS(3340),
    [anon_sym__Atomic] = ACTIONS(3340),
    [anon_sym__Noreturn] = ACTIONS(3340),
    [anon_sym_noreturn] = ACTIONS(3340),
    [anon_sym_mutable] = ACTIONS(3340),
    [anon_sym_constinit] = ACTIONS(3340),
    [anon_sym_consteval] = ACTIONS(3340),
    [anon_sym_alignas] = ACTIONS(3340),
    [anon_sym__Alignas] = ACTIONS(3340),
    [sym_primitive_type] = ACTIONS(3340),
    [anon_sym_enum] = ACTIONS(3340),
    [anon_sym_class] = ACTIONS(3340),
    [anon_sym_struct] = ACTIONS(3340),
    [anon_sym_union] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_else] = ACTIONS(3340),
    [anon_sym_switch] = ACTIONS(3340),
    [anon_sym_while] = ACTIONS(3340),
    [anon_sym_do] = ACTIONS(3340),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_break] = ACTIONS(3340),
    [anon_sym_continue] = ACTIONS(3340),
    [anon_sym_goto] = ACTIONS(3340),
    [anon_sym___try] = ACTIONS(3340),
    [anon_sym___leave] = ACTIONS(3340),
    [anon_sym_not] = ACTIONS(3340),
    [anon_sym_compl] = ACTIONS(3340),
    [anon_sym_DASH_DASH] = ACTIONS(3342),
    [anon_sym_PLUS_PLUS] = ACTIONS(3342),
    [anon_sym_sizeof] = ACTIONS(3340),
    [anon_sym___alignof__] = ACTIONS(3340),
    [anon_sym___alignof] = ACTIONS(3340),
    [anon_sym__alignof] = ACTIONS(3340),
    [anon_sym_alignof] = ACTIONS(3340),
    [anon_sym__Alignof] = ACTIONS(3340),
    [anon_sym_offsetof] = ACTIONS(3340),
    [anon_sym__Generic] = ACTIONS(3340),
    [anon_sym_asm] = ACTIONS(3340),
    [anon_sym___asm__] = ACTIONS(3340),
    [sym_number_literal] = ACTIONS(3342),
    [anon_sym_L_SQUOTE] = ACTIONS(3342),
    [anon_sym_u_SQUOTE] = ACTIONS(3342),
    [anon_sym_U_SQUOTE] = ACTIONS(3342),
    [anon_sym_u8_SQUOTE] = ACTIONS(3342),
    [anon_sym_SQUOTE] = ACTIONS(3342),
    [anon_sym_L_DQUOTE] = ACTIONS(3342),
    [anon_sym_u_DQUOTE] = ACTIONS(3342),
    [anon_sym_U_DQUOTE] = ACTIONS(3342),
    [anon_sym_u8_DQUOTE] = ACTIONS(3342),
    [anon_sym_DQUOTE] = ACTIONS(3342),
    [sym_true] = ACTIONS(3340),
    [sym_false] = ACTIONS(3340),
    [anon_sym_NULL] = ACTIONS(3340),
    [anon_sym_nullptr] = ACTIONS(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3340),
    [anon_sym_let] = ACTIONS(3340),
    [anon_sym_This] = ACTIONS(3340),
    [anon_sym_decltype] = ACTIONS(3340),
    [sym_virtual] = ACTIONS(3340),
    [anon_sym_typename] = ACTIONS(3340),
    [anon_sym_template] = ACTIONS(3340),
    [anon_sym_try] = ACTIONS(3340),
    [anon_sym_delete] = ACTIONS(3340),
    [anon_sym_throw] = ACTIONS(3340),
    [anon_sym_co_return] = ACTIONS(3340),
    [anon_sym_co_yield] = ACTIONS(3340),
    [anon_sym_R_DQUOTE] = ACTIONS(3342),
    [anon_sym_LR_DQUOTE] = ACTIONS(3342),
    [anon_sym_uR_DQUOTE] = ACTIONS(3342),
    [anon_sym_UR_DQUOTE] = ACTIONS(3342),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3342),
    [anon_sym_co_await] = ACTIONS(3340),
    [anon_sym_new] = ACTIONS(3340),
    [anon_sym_requires] = ACTIONS(3340),
    [sym_this] = ACTIONS(3340),
    [anon_sym_discard] = ACTIONS(3340),
    [anon_sym_precise] = ACTIONS(3340),
    [anon_sym_shared] = ACTIONS(3340),
    [anon_sym_groupshared] = ACTIONS(3340),
    [anon_sym_uniform] = ACTIONS(3340),
    [anon_sym_row_major] = ACTIONS(3340),
    [anon_sym_column_major] = ACTIONS(3340),
    [anon_sym_globallycoherent] = ACTIONS(3340),
    [anon_sym_centroid] = ACTIONS(3340),
    [anon_sym_noperspective] = ACTIONS(3340),
    [anon_sym_nointerpolation] = ACTIONS(3340),
    [anon_sym_sample] = ACTIONS(3340),
    [anon_sym_linear] = ACTIONS(3340),
    [anon_sym_snorm] = ACTIONS(3340),
    [anon_sym_unorm] = ACTIONS(3340),
    [anon_sym_point] = ACTIONS(3340),
    [anon_sym_line] = ACTIONS(3340),
    [anon_sym_triangleadj] = ACTIONS(3340),
    [anon_sym_lineadj] = ACTIONS(3340),
    [anon_sym_triangle] = ACTIONS(3340),
    [anon_sym_cbuffer] = ACTIONS(3340),
    [anon_sym_interface] = ACTIONS(3340),
    [anon_sym_extension] = ACTIONS(3340),
  },
  [1334] = {
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_LPAREN2] = ACTIONS(3236),
    [anon_sym_BANG] = ACTIONS(3236),
    [anon_sym_TILDE] = ACTIONS(3236),
    [anon_sym_DASH] = ACTIONS(3234),
    [anon_sym_PLUS] = ACTIONS(3234),
    [anon_sym_STAR] = ACTIONS(3236),
    [anon_sym_AMP] = ACTIONS(3236),
    [anon_sym_SEMI] = ACTIONS(3236),
    [anon_sym___extension__] = ACTIONS(3234),
    [anon_sym_typedef] = ACTIONS(3234),
    [anon_sym_in] = ACTIONS(3234),
    [anon_sym_out] = ACTIONS(3234),
    [anon_sym_inout] = ACTIONS(3234),
    [anon_sym_extern] = ACTIONS(3234),
    [anon_sym___attribute__] = ACTIONS(3234),
    [anon_sym_COLON_COLON] = ACTIONS(3236),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3236),
    [anon_sym___declspec] = ACTIONS(3234),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_signed] = ACTIONS(3234),
    [anon_sym_unsigned] = ACTIONS(3234),
    [anon_sym_long] = ACTIONS(3234),
    [anon_sym_short] = ACTIONS(3234),
    [anon_sym_LBRACK] = ACTIONS(3234),
    [anon_sym_static] = ACTIONS(3234),
    [anon_sym_register] = ACTIONS(3234),
    [anon_sym_inline] = ACTIONS(3234),
    [anon_sym___inline] = ACTIONS(3234),
    [anon_sym___inline__] = ACTIONS(3234),
    [anon_sym___forceinline] = ACTIONS(3234),
    [anon_sym_thread_local] = ACTIONS(3234),
    [anon_sym___thread] = ACTIONS(3234),
    [anon_sym_const] = ACTIONS(3234),
    [anon_sym_constexpr] = ACTIONS(3234),
    [anon_sym_volatile] = ACTIONS(3234),
    [anon_sym_restrict] = ACTIONS(3234),
    [anon_sym___restrict__] = ACTIONS(3234),
    [anon_sym__Atomic] = ACTIONS(3234),
    [anon_sym__Noreturn] = ACTIONS(3234),
    [anon_sym_noreturn] = ACTIONS(3234),
    [anon_sym_mutable] = ACTIONS(3234),
    [anon_sym_constinit] = ACTIONS(3234),
    [anon_sym_consteval] = ACTIONS(3234),
    [anon_sym_alignas] = ACTIONS(3234),
    [anon_sym__Alignas] = ACTIONS(3234),
    [sym_primitive_type] = ACTIONS(3234),
    [anon_sym_enum] = ACTIONS(3234),
    [anon_sym_class] = ACTIONS(3234),
    [anon_sym_struct] = ACTIONS(3234),
    [anon_sym_union] = ACTIONS(3234),
    [anon_sym_if] = ACTIONS(3234),
    [anon_sym_else] = ACTIONS(3234),
    [anon_sym_switch] = ACTIONS(3234),
    [anon_sym_while] = ACTIONS(3234),
    [anon_sym_do] = ACTIONS(3234),
    [anon_sym_for] = ACTIONS(3234),
    [anon_sym_return] = ACTIONS(3234),
    [anon_sym_break] = ACTIONS(3234),
    [anon_sym_continue] = ACTIONS(3234),
    [anon_sym_goto] = ACTIONS(3234),
    [anon_sym___try] = ACTIONS(3234),
    [anon_sym___leave] = ACTIONS(3234),
    [anon_sym_not] = ACTIONS(3234),
    [anon_sym_compl] = ACTIONS(3234),
    [anon_sym_DASH_DASH] = ACTIONS(3236),
    [anon_sym_PLUS_PLUS] = ACTIONS(3236),
    [anon_sym_sizeof] = ACTIONS(3234),
    [anon_sym___alignof__] = ACTIONS(3234),
    [anon_sym___alignof] = ACTIONS(3234),
    [anon_sym__alignof] = ACTIONS(3234),
    [anon_sym_alignof] = ACTIONS(3234),
    [anon_sym__Alignof] = ACTIONS(3234),
    [anon_sym_offsetof] = ACTIONS(3234),
    [anon_sym__Generic] = ACTIONS(3234),
    [anon_sym_asm] = ACTIONS(3234),
    [anon_sym___asm__] = ACTIONS(3234),
    [sym_number_literal] = ACTIONS(3236),
    [anon_sym_L_SQUOTE] = ACTIONS(3236),
    [anon_sym_u_SQUOTE] = ACTIONS(3236),
    [anon_sym_U_SQUOTE] = ACTIONS(3236),
    [anon_sym_u8_SQUOTE] = ACTIONS(3236),
    [anon_sym_SQUOTE] = ACTIONS(3236),
    [anon_sym_L_DQUOTE] = ACTIONS(3236),
    [anon_sym_u_DQUOTE] = ACTIONS(3236),
    [anon_sym_U_DQUOTE] = ACTIONS(3236),
    [anon_sym_u8_DQUOTE] = ACTIONS(3236),
    [anon_sym_DQUOTE] = ACTIONS(3236),
    [sym_true] = ACTIONS(3234),
    [sym_false] = ACTIONS(3234),
    [anon_sym_NULL] = ACTIONS(3234),
    [anon_sym_nullptr] = ACTIONS(3234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3234),
    [anon_sym_let] = ACTIONS(3234),
    [anon_sym_This] = ACTIONS(3234),
    [anon_sym_decltype] = ACTIONS(3234),
    [sym_virtual] = ACTIONS(3234),
    [anon_sym_typename] = ACTIONS(3234),
    [anon_sym_template] = ACTIONS(3234),
    [anon_sym_try] = ACTIONS(3234),
    [anon_sym_delete] = ACTIONS(3234),
    [anon_sym_throw] = ACTIONS(3234),
    [anon_sym_co_return] = ACTIONS(3234),
    [anon_sym_co_yield] = ACTIONS(3234),
    [anon_sym_R_DQUOTE] = ACTIONS(3236),
    [anon_sym_LR_DQUOTE] = ACTIONS(3236),
    [anon_sym_uR_DQUOTE] = ACTIONS(3236),
    [anon_sym_UR_DQUOTE] = ACTIONS(3236),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3236),
    [anon_sym_co_await] = ACTIONS(3234),
    [anon_sym_new] = ACTIONS(3234),
    [anon_sym_requires] = ACTIONS(3234),
    [sym_this] = ACTIONS(3234),
    [anon_sym_discard] = ACTIONS(3234),
    [anon_sym_precise] = ACTIONS(3234),
    [anon_sym_shared] = ACTIONS(3234),
    [anon_sym_groupshared] = ACTIONS(3234),
    [anon_sym_uniform] = ACTIONS(3234),
    [anon_sym_row_major] = ACTIONS(3234),
    [anon_sym_column_major] = ACTIONS(3234),
    [anon_sym_globallycoherent] = ACTIONS(3234),
    [anon_sym_centroid] = ACTIONS(3234),
    [anon_sym_noperspective] = ACTIONS(3234),
    [anon_sym_nointerpolation] = ACTIONS(3234),
    [anon_sym_sample] = ACTIONS(3234),
    [anon_sym_linear] = ACTIONS(3234),
    [anon_sym_snorm] = ACTIONS(3234),
    [anon_sym_unorm] = ACTIONS(3234),
    [anon_sym_point] = ACTIONS(3234),
    [anon_sym_line] = ACTIONS(3234),
    [anon_sym_triangleadj] = ACTIONS(3234),
    [anon_sym_lineadj] = ACTIONS(3234),
    [anon_sym_triangle] = ACTIONS(3234),
    [anon_sym_cbuffer] = ACTIONS(3234),
    [anon_sym_interface] = ACTIONS(3234),
    [anon_sym_extension] = ACTIONS(3234),
  },
  [1335] = {
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_unaligned_ptr_modifier] = STATE(4963),
    [sym_ms_pointer_modifier] = STATE(3985),
    [sym__declarator] = STATE(7899),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7882),
    [sym_array_declarator] = STATE(7882),
    [sym_type_qualifier] = STATE(4837),
    [sym_alignas_qualifier] = STATE(5665),
    [sym_expression] = STATE(3215),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4074),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6851),
    [sym_qualified_identifier] = STATE(4067),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(3335),
    [aux_sym__type_definition_type_repeat1] = STATE(4837),
    [aux_sym_pointer_declarator_repeat1] = STATE(3985),
    [sym_identifier] = ACTIONS(4895),
    [anon_sym_LPAREN2] = ACTIONS(4897),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4899),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(4901),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym___based] = ACTIONS(49),
    [sym_ms_restrict_modifier] = ACTIONS(4903),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(4903),
    [sym_ms_signed_ptr_modifier] = ACTIONS(4903),
    [anon_sym__unaligned] = ACTIONS(4905),
    [anon_sym___unaligned] = ACTIONS(4905),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_const] = ACTIONS(4901),
    [anon_sym_constexpr] = ACTIONS(4901),
    [anon_sym_volatile] = ACTIONS(4901),
    [anon_sym_restrict] = ACTIONS(4901),
    [anon_sym___restrict__] = ACTIONS(4901),
    [anon_sym__Atomic] = ACTIONS(4901),
    [anon_sym__Noreturn] = ACTIONS(4901),
    [anon_sym_noreturn] = ACTIONS(4901),
    [anon_sym_mutable] = ACTIONS(4901),
    [anon_sym_constinit] = ACTIONS(4901),
    [anon_sym_consteval] = ACTIONS(4901),
    [anon_sym_alignas] = ACTIONS(4907),
    [anon_sym__Alignas] = ACTIONS(4907),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(2808),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1336] = {
    [sym_ms_based_modifier] = STATE(10814),
    [sym_ms_unaligned_ptr_modifier] = STATE(4963),
    [sym_ms_pointer_modifier] = STATE(3985),
    [sym__declarator] = STATE(7899),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7882),
    [sym_array_declarator] = STATE(7882),
    [sym_type_qualifier] = STATE(4837),
    [sym_alignas_qualifier] = STATE(5665),
    [sym_expression] = STATE(3690),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4031),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6778),
    [sym_qualified_identifier] = STATE(4016),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4292),
    [aux_sym__type_definition_type_repeat1] = STATE(4837),
    [aux_sym_pointer_declarator_repeat1] = STATE(3985),
    [sym_identifier] = ACTIONS(4911),
    [anon_sym_LPAREN2] = ACTIONS(2750),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2754),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2758),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2760),
    [anon_sym___extension__] = ACTIONS(4901),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym___based] = ACTIONS(49),
    [sym_ms_restrict_modifier] = ACTIONS(4903),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(4903),
    [sym_ms_signed_ptr_modifier] = ACTIONS(4903),
    [anon_sym__unaligned] = ACTIONS(4905),
    [anon_sym___unaligned] = ACTIONS(4905),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_const] = ACTIONS(4901),
    [anon_sym_constexpr] = ACTIONS(4901),
    [anon_sym_volatile] = ACTIONS(4901),
    [anon_sym_restrict] = ACTIONS(4901),
    [anon_sym___restrict__] = ACTIONS(4901),
    [anon_sym__Atomic] = ACTIONS(4901),
    [anon_sym__Noreturn] = ACTIONS(4901),
    [anon_sym_noreturn] = ACTIONS(4901),
    [anon_sym_mutable] = ACTIONS(4901),
    [anon_sym_constinit] = ACTIONS(4901),
    [anon_sym_consteval] = ACTIONS(4901),
    [anon_sym_alignas] = ACTIONS(4907),
    [anon_sym__Alignas] = ACTIONS(4907),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(2808),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1337] = {
    [sym_string_literal] = STATE(3165),
    [sym_template_argument_list] = STATE(1419),
    [sym_raw_string_literal] = STATE(3165),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2639),
    [sym_identifier] = ACTIONS(2115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2130),
    [anon_sym_COMMA] = ACTIONS(2130),
    [anon_sym_RPAREN] = ACTIONS(2130),
    [anon_sym_LPAREN2] = ACTIONS(2130),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2130),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(4913),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON] = ACTIONS(2115),
    [anon_sym___extension__] = ACTIONS(2115),
    [anon_sym_in] = ACTIONS(2115),
    [anon_sym_out] = ACTIONS(2115),
    [anon_sym_inout] = ACTIONS(2115),
    [anon_sym_extern] = ACTIONS(2115),
    [anon_sym___attribute__] = ACTIONS(2115),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2123),
    [anon_sym___declspec] = ACTIONS(2115),
    [anon_sym___based] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_signed] = ACTIONS(4863),
    [anon_sym_unsigned] = ACTIONS(4863),
    [anon_sym_long] = ACTIONS(4863),
    [anon_sym_short] = ACTIONS(4863),
    [anon_sym_LBRACK] = ACTIONS(2125),
    [anon_sym_static] = ACTIONS(2115),
    [anon_sym_EQ] = ACTIONS(2125),
    [anon_sym_register] = ACTIONS(2115),
    [anon_sym_inline] = ACTIONS(2115),
    [anon_sym___inline] = ACTIONS(2115),
    [anon_sym___inline__] = ACTIONS(2115),
    [anon_sym___forceinline] = ACTIONS(2115),
    [anon_sym_thread_local] = ACTIONS(2115),
    [anon_sym___thread] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(2115),
    [anon_sym_constexpr] = ACTIONS(2115),
    [anon_sym_volatile] = ACTIONS(2115),
    [anon_sym_restrict] = ACTIONS(2115),
    [anon_sym___restrict__] = ACTIONS(2115),
    [anon_sym__Atomic] = ACTIONS(2115),
    [anon_sym__Noreturn] = ACTIONS(2115),
    [anon_sym_noreturn] = ACTIONS(2115),
    [anon_sym_mutable] = ACTIONS(2115),
    [anon_sym_constinit] = ACTIONS(2115),
    [anon_sym_consteval] = ACTIONS(2115),
    [anon_sym_alignas] = ACTIONS(2115),
    [anon_sym__Alignas] = ACTIONS(2115),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2117),
    [anon_sym_SLASH_EQ] = ACTIONS(2117),
    [anon_sym_PERCENT_EQ] = ACTIONS(2117),
    [anon_sym_PLUS_EQ] = ACTIONS(2117),
    [anon_sym_DASH_EQ] = ACTIONS(2117),
    [anon_sym_LT_LT_EQ] = ACTIONS(2117),
    [anon_sym_GT_GT_EQ] = ACTIONS(2117),
    [anon_sym_AMP_EQ] = ACTIONS(2117),
    [anon_sym_CARET_EQ] = ACTIONS(2117),
    [anon_sym_PIPE_EQ] = ACTIONS(2117),
    [anon_sym_and_eq] = ACTIONS(4916),
    [anon_sym_or_eq] = ACTIONS(4916),
    [anon_sym_xor_eq] = ACTIONS(4916),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2128),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2128),
    [anon_sym_not_eq] = ACTIONS(2128),
    [anon_sym_is] = ACTIONS(2128),
    [anon_sym_as] = ACTIONS(2128),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2125),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2128),
    [anon_sym_L_DQUOTE] = ACTIONS(4918),
    [anon_sym_u_DQUOTE] = ACTIONS(4918),
    [anon_sym_U_DQUOTE] = ACTIONS(4918),
    [anon_sym_u8_DQUOTE] = ACTIONS(4918),
    [anon_sym_DQUOTE] = ACTIONS(4918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2115),
    [anon_sym_let] = ACTIONS(2115),
    [anon_sym_This] = ACTIONS(2115),
    [anon_sym_decltype] = ACTIONS(2115),
    [sym_virtual] = ACTIONS(2115),
    [anon_sym_template] = ACTIONS(2115),
    [anon_sym_operator] = ACTIONS(2115),
    [anon_sym_R_DQUOTE] = ACTIONS(4920),
    [anon_sym_LR_DQUOTE] = ACTIONS(4920),
    [anon_sym_uR_DQUOTE] = ACTIONS(4920),
    [anon_sym_UR_DQUOTE] = ACTIONS(4920),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4920),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2117),
    [anon_sym_precise] = ACTIONS(2115),
    [anon_sym_shared] = ACTIONS(2115),
    [anon_sym_groupshared] = ACTIONS(2115),
    [anon_sym_uniform] = ACTIONS(2115),
    [anon_sym_row_major] = ACTIONS(2115),
    [anon_sym_column_major] = ACTIONS(2115),
    [anon_sym_globallycoherent] = ACTIONS(2115),
    [anon_sym_centroid] = ACTIONS(2115),
    [anon_sym_noperspective] = ACTIONS(2115),
    [anon_sym_nointerpolation] = ACTIONS(2115),
    [anon_sym_sample] = ACTIONS(2115),
    [anon_sym_linear] = ACTIONS(2115),
    [anon_sym_snorm] = ACTIONS(2115),
    [anon_sym_unorm] = ACTIONS(2115),
    [anon_sym_point] = ACTIONS(2115),
    [anon_sym_line] = ACTIONS(2115),
    [anon_sym_triangleadj] = ACTIONS(2115),
    [anon_sym_lineadj] = ACTIONS(2115),
    [anon_sym_triangle] = ACTIONS(2115),
  },
  [1338] = {
    [sym_string_literal] = STATE(3342),
    [sym_template_argument_list] = STATE(1527),
    [sym_raw_string_literal] = STATE(3342),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2639),
    [sym_identifier] = ACTIONS(2115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2130),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2130),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(4858),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON] = ACTIONS(4922),
    [anon_sym_SEMI] = ACTIONS(2117),
    [anon_sym___extension__] = ACTIONS(2115),
    [anon_sym_in] = ACTIONS(2115),
    [anon_sym_out] = ACTIONS(2115),
    [anon_sym_inout] = ACTIONS(2115),
    [anon_sym_extern] = ACTIONS(2115),
    [anon_sym___attribute__] = ACTIONS(2115),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2123),
    [anon_sym___declspec] = ACTIONS(2115),
    [anon_sym___based] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_signed] = ACTIONS(4863),
    [anon_sym_unsigned] = ACTIONS(4863),
    [anon_sym_long] = ACTIONS(4863),
    [anon_sym_short] = ACTIONS(4863),
    [anon_sym_LBRACK] = ACTIONS(2125),
    [anon_sym_static] = ACTIONS(2115),
    [anon_sym_EQ] = ACTIONS(2152),
    [anon_sym_register] = ACTIONS(2115),
    [anon_sym_inline] = ACTIONS(2115),
    [anon_sym___inline] = ACTIONS(2115),
    [anon_sym___inline__] = ACTIONS(2115),
    [anon_sym___forceinline] = ACTIONS(2115),
    [anon_sym_thread_local] = ACTIONS(2115),
    [anon_sym___thread] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(2115),
    [anon_sym_constexpr] = ACTIONS(2115),
    [anon_sym_volatile] = ACTIONS(2115),
    [anon_sym_restrict] = ACTIONS(2115),
    [anon_sym___restrict__] = ACTIONS(2115),
    [anon_sym__Atomic] = ACTIONS(2115),
    [anon_sym__Noreturn] = ACTIONS(2115),
    [anon_sym_noreturn] = ACTIONS(2115),
    [anon_sym_mutable] = ACTIONS(2115),
    [anon_sym_constinit] = ACTIONS(2115),
    [anon_sym_consteval] = ACTIONS(2115),
    [anon_sym_alignas] = ACTIONS(2115),
    [anon_sym__Alignas] = ACTIONS(2115),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2154),
    [anon_sym_SLASH_EQ] = ACTIONS(2154),
    [anon_sym_PERCENT_EQ] = ACTIONS(2154),
    [anon_sym_PLUS_EQ] = ACTIONS(2154),
    [anon_sym_DASH_EQ] = ACTIONS(2154),
    [anon_sym_LT_LT_EQ] = ACTIONS(2154),
    [anon_sym_GT_GT_EQ] = ACTIONS(2154),
    [anon_sym_AMP_EQ] = ACTIONS(2154),
    [anon_sym_CARET_EQ] = ACTIONS(2154),
    [anon_sym_PIPE_EQ] = ACTIONS(2154),
    [anon_sym_and_eq] = ACTIONS(2152),
    [anon_sym_or_eq] = ACTIONS(2152),
    [anon_sym_xor_eq] = ACTIONS(2152),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2128),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2128),
    [anon_sym_not_eq] = ACTIONS(2128),
    [anon_sym_is] = ACTIONS(2128),
    [anon_sym_as] = ACTIONS(2128),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2125),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2115),
    [anon_sym_let] = ACTIONS(2115),
    [anon_sym_This] = ACTIONS(2115),
    [anon_sym_decltype] = ACTIONS(2115),
    [sym_virtual] = ACTIONS(2115),
    [anon_sym_template] = ACTIONS(2115),
    [anon_sym_operator] = ACTIONS(2115),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_precise] = ACTIONS(2115),
    [anon_sym_shared] = ACTIONS(2115),
    [anon_sym_groupshared] = ACTIONS(2115),
    [anon_sym_uniform] = ACTIONS(2115),
    [anon_sym_row_major] = ACTIONS(2115),
    [anon_sym_column_major] = ACTIONS(2115),
    [anon_sym_globallycoherent] = ACTIONS(2115),
    [anon_sym_centroid] = ACTIONS(2115),
    [anon_sym_noperspective] = ACTIONS(2115),
    [anon_sym_nointerpolation] = ACTIONS(2115),
    [anon_sym_sample] = ACTIONS(2115),
    [anon_sym_linear] = ACTIONS(2115),
    [anon_sym_snorm] = ACTIONS(2115),
    [anon_sym_unorm] = ACTIONS(2115),
    [anon_sym_point] = ACTIONS(2115),
    [anon_sym_line] = ACTIONS(2115),
    [anon_sym_triangleadj] = ACTIONS(2115),
    [anon_sym_lineadj] = ACTIONS(2115),
    [anon_sym_triangle] = ACTIONS(2115),
  },
  [1339] = {
    [sym_string_literal] = STATE(3342),
    [sym_template_argument_list] = STATE(1527),
    [sym_raw_string_literal] = STATE(3342),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2639),
    [sym_identifier] = ACTIONS(2115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2130),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2130),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(4858),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON] = ACTIONS(2136),
    [anon_sym_SEMI] = ACTIONS(2117),
    [anon_sym___extension__] = ACTIONS(2115),
    [anon_sym_in] = ACTIONS(2115),
    [anon_sym_out] = ACTIONS(2115),
    [anon_sym_inout] = ACTIONS(2115),
    [anon_sym_extern] = ACTIONS(2115),
    [anon_sym___attribute__] = ACTIONS(2115),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2123),
    [anon_sym___declspec] = ACTIONS(2115),
    [anon_sym___based] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_signed] = ACTIONS(4863),
    [anon_sym_unsigned] = ACTIONS(4863),
    [anon_sym_long] = ACTIONS(4863),
    [anon_sym_short] = ACTIONS(4863),
    [anon_sym_LBRACK] = ACTIONS(2125),
    [anon_sym_static] = ACTIONS(2115),
    [anon_sym_EQ] = ACTIONS(2152),
    [anon_sym_register] = ACTIONS(2115),
    [anon_sym_inline] = ACTIONS(2115),
    [anon_sym___inline] = ACTIONS(2115),
    [anon_sym___inline__] = ACTIONS(2115),
    [anon_sym___forceinline] = ACTIONS(2115),
    [anon_sym_thread_local] = ACTIONS(2115),
    [anon_sym___thread] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(2115),
    [anon_sym_constexpr] = ACTIONS(2115),
    [anon_sym_volatile] = ACTIONS(2115),
    [anon_sym_restrict] = ACTIONS(2115),
    [anon_sym___restrict__] = ACTIONS(2115),
    [anon_sym__Atomic] = ACTIONS(2115),
    [anon_sym__Noreturn] = ACTIONS(2115),
    [anon_sym_noreturn] = ACTIONS(2115),
    [anon_sym_mutable] = ACTIONS(2115),
    [anon_sym_constinit] = ACTIONS(2115),
    [anon_sym_consteval] = ACTIONS(2115),
    [anon_sym_alignas] = ACTIONS(2115),
    [anon_sym__Alignas] = ACTIONS(2115),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2154),
    [anon_sym_SLASH_EQ] = ACTIONS(2154),
    [anon_sym_PERCENT_EQ] = ACTIONS(2154),
    [anon_sym_PLUS_EQ] = ACTIONS(2154),
    [anon_sym_DASH_EQ] = ACTIONS(2154),
    [anon_sym_LT_LT_EQ] = ACTIONS(2154),
    [anon_sym_GT_GT_EQ] = ACTIONS(2154),
    [anon_sym_AMP_EQ] = ACTIONS(2154),
    [anon_sym_CARET_EQ] = ACTIONS(2154),
    [anon_sym_PIPE_EQ] = ACTIONS(2154),
    [anon_sym_and_eq] = ACTIONS(2152),
    [anon_sym_or_eq] = ACTIONS(2152),
    [anon_sym_xor_eq] = ACTIONS(2152),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2128),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2128),
    [anon_sym_not_eq] = ACTIONS(2128),
    [anon_sym_is] = ACTIONS(2128),
    [anon_sym_as] = ACTIONS(2128),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2125),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2115),
    [anon_sym_let] = ACTIONS(2115),
    [anon_sym_This] = ACTIONS(2115),
    [anon_sym_decltype] = ACTIONS(2115),
    [sym_virtual] = ACTIONS(2115),
    [anon_sym_template] = ACTIONS(2115),
    [anon_sym_operator] = ACTIONS(2115),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_precise] = ACTIONS(2115),
    [anon_sym_shared] = ACTIONS(2115),
    [anon_sym_groupshared] = ACTIONS(2115),
    [anon_sym_uniform] = ACTIONS(2115),
    [anon_sym_row_major] = ACTIONS(2115),
    [anon_sym_column_major] = ACTIONS(2115),
    [anon_sym_globallycoherent] = ACTIONS(2115),
    [anon_sym_centroid] = ACTIONS(2115),
    [anon_sym_noperspective] = ACTIONS(2115),
    [anon_sym_nointerpolation] = ACTIONS(2115),
    [anon_sym_sample] = ACTIONS(2115),
    [anon_sym_linear] = ACTIONS(2115),
    [anon_sym_snorm] = ACTIONS(2115),
    [anon_sym_unorm] = ACTIONS(2115),
    [anon_sym_point] = ACTIONS(2115),
    [anon_sym_line] = ACTIONS(2115),
    [anon_sym_triangleadj] = ACTIONS(2115),
    [anon_sym_lineadj] = ACTIONS(2115),
    [anon_sym_triangle] = ACTIONS(2115),
  },
  [1340] = {
    [sym_string_literal] = STATE(3342),
    [sym_template_argument_list] = STATE(1527),
    [sym_raw_string_literal] = STATE(3342),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2639),
    [sym_identifier] = ACTIONS(2115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_RPAREN] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2130),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2130),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(4858),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_SEMI] = ACTIONS(2117),
    [anon_sym___extension__] = ACTIONS(2115),
    [anon_sym_in] = ACTIONS(2115),
    [anon_sym_out] = ACTIONS(2115),
    [anon_sym_inout] = ACTIONS(2115),
    [anon_sym_extern] = ACTIONS(2115),
    [anon_sym___attribute__] = ACTIONS(2115),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2123),
    [anon_sym___declspec] = ACTIONS(2115),
    [anon_sym___based] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_signed] = ACTIONS(4863),
    [anon_sym_unsigned] = ACTIONS(4863),
    [anon_sym_long] = ACTIONS(4863),
    [anon_sym_short] = ACTIONS(4863),
    [anon_sym_LBRACK] = ACTIONS(2125),
    [anon_sym_static] = ACTIONS(2115),
    [anon_sym_EQ] = ACTIONS(2152),
    [anon_sym_register] = ACTIONS(2115),
    [anon_sym_inline] = ACTIONS(2115),
    [anon_sym___inline] = ACTIONS(2115),
    [anon_sym___inline__] = ACTIONS(2115),
    [anon_sym___forceinline] = ACTIONS(2115),
    [anon_sym_thread_local] = ACTIONS(2115),
    [anon_sym___thread] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(2115),
    [anon_sym_constexpr] = ACTIONS(2115),
    [anon_sym_volatile] = ACTIONS(2115),
    [anon_sym_restrict] = ACTIONS(2115),
    [anon_sym___restrict__] = ACTIONS(2115),
    [anon_sym__Atomic] = ACTIONS(2115),
    [anon_sym__Noreturn] = ACTIONS(2115),
    [anon_sym_noreturn] = ACTIONS(2115),
    [anon_sym_mutable] = ACTIONS(2115),
    [anon_sym_constinit] = ACTIONS(2115),
    [anon_sym_consteval] = ACTIONS(2115),
    [anon_sym_alignas] = ACTIONS(2115),
    [anon_sym__Alignas] = ACTIONS(2115),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2154),
    [anon_sym_SLASH_EQ] = ACTIONS(2154),
    [anon_sym_PERCENT_EQ] = ACTIONS(2154),
    [anon_sym_PLUS_EQ] = ACTIONS(2154),
    [anon_sym_DASH_EQ] = ACTIONS(2154),
    [anon_sym_LT_LT_EQ] = ACTIONS(2154),
    [anon_sym_GT_GT_EQ] = ACTIONS(2154),
    [anon_sym_AMP_EQ] = ACTIONS(2154),
    [anon_sym_CARET_EQ] = ACTIONS(2154),
    [anon_sym_PIPE_EQ] = ACTIONS(2154),
    [anon_sym_and_eq] = ACTIONS(2152),
    [anon_sym_or_eq] = ACTIONS(2152),
    [anon_sym_xor_eq] = ACTIONS(2152),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2128),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2128),
    [anon_sym_not_eq] = ACTIONS(2128),
    [anon_sym_is] = ACTIONS(2128),
    [anon_sym_as] = ACTIONS(2128),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2125),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2115),
    [anon_sym_let] = ACTIONS(2115),
    [anon_sym_This] = ACTIONS(2115),
    [anon_sym_decltype] = ACTIONS(2115),
    [sym_virtual] = ACTIONS(2115),
    [anon_sym_template] = ACTIONS(2115),
    [anon_sym_operator] = ACTIONS(2115),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_precise] = ACTIONS(2115),
    [anon_sym_shared] = ACTIONS(2115),
    [anon_sym_groupshared] = ACTIONS(2115),
    [anon_sym_uniform] = ACTIONS(2115),
    [anon_sym_row_major] = ACTIONS(2115),
    [anon_sym_column_major] = ACTIONS(2115),
    [anon_sym_globallycoherent] = ACTIONS(2115),
    [anon_sym_centroid] = ACTIONS(2115),
    [anon_sym_noperspective] = ACTIONS(2115),
    [anon_sym_nointerpolation] = ACTIONS(2115),
    [anon_sym_sample] = ACTIONS(2115),
    [anon_sym_linear] = ACTIONS(2115),
    [anon_sym_snorm] = ACTIONS(2115),
    [anon_sym_unorm] = ACTIONS(2115),
    [anon_sym_point] = ACTIONS(2115),
    [anon_sym_line] = ACTIONS(2115),
    [anon_sym_triangleadj] = ACTIONS(2115),
    [anon_sym_lineadj] = ACTIONS(2115),
    [anon_sym_triangle] = ACTIONS(2115),
  },
  [1341] = {
    [sym_string_literal] = STATE(3342),
    [sym_template_argument_list] = STATE(1527),
    [sym_raw_string_literal] = STATE(3342),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2639),
    [sym_identifier] = ACTIONS(2115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2130),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2130),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(4858),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON] = ACTIONS(2163),
    [anon_sym_SEMI] = ACTIONS(2117),
    [anon_sym___extension__] = ACTIONS(2115),
    [anon_sym_in] = ACTIONS(2115),
    [anon_sym_out] = ACTIONS(2115),
    [anon_sym_inout] = ACTIONS(2115),
    [anon_sym_extern] = ACTIONS(2115),
    [anon_sym___attribute__] = ACTIONS(2115),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2123),
    [anon_sym___declspec] = ACTIONS(2115),
    [anon_sym___based] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_signed] = ACTIONS(4863),
    [anon_sym_unsigned] = ACTIONS(4863),
    [anon_sym_long] = ACTIONS(4863),
    [anon_sym_short] = ACTIONS(4863),
    [anon_sym_LBRACK] = ACTIONS(2125),
    [anon_sym_static] = ACTIONS(2115),
    [anon_sym_EQ] = ACTIONS(2152),
    [anon_sym_register] = ACTIONS(2115),
    [anon_sym_inline] = ACTIONS(2115),
    [anon_sym___inline] = ACTIONS(2115),
    [anon_sym___inline__] = ACTIONS(2115),
    [anon_sym___forceinline] = ACTIONS(2115),
    [anon_sym_thread_local] = ACTIONS(2115),
    [anon_sym___thread] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(2115),
    [anon_sym_constexpr] = ACTIONS(2115),
    [anon_sym_volatile] = ACTIONS(2115),
    [anon_sym_restrict] = ACTIONS(2115),
    [anon_sym___restrict__] = ACTIONS(2115),
    [anon_sym__Atomic] = ACTIONS(2115),
    [anon_sym__Noreturn] = ACTIONS(2115),
    [anon_sym_noreturn] = ACTIONS(2115),
    [anon_sym_mutable] = ACTIONS(2115),
    [anon_sym_constinit] = ACTIONS(2115),
    [anon_sym_consteval] = ACTIONS(2115),
    [anon_sym_alignas] = ACTIONS(2115),
    [anon_sym__Alignas] = ACTIONS(2115),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2154),
    [anon_sym_SLASH_EQ] = ACTIONS(2154),
    [anon_sym_PERCENT_EQ] = ACTIONS(2154),
    [anon_sym_PLUS_EQ] = ACTIONS(2154),
    [anon_sym_DASH_EQ] = ACTIONS(2154),
    [anon_sym_LT_LT_EQ] = ACTIONS(2154),
    [anon_sym_GT_GT_EQ] = ACTIONS(2154),
    [anon_sym_AMP_EQ] = ACTIONS(2154),
    [anon_sym_CARET_EQ] = ACTIONS(2154),
    [anon_sym_PIPE_EQ] = ACTIONS(2154),
    [anon_sym_and_eq] = ACTIONS(2152),
    [anon_sym_or_eq] = ACTIONS(2152),
    [anon_sym_xor_eq] = ACTIONS(2152),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2128),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2128),
    [anon_sym_not_eq] = ACTIONS(2128),
    [anon_sym_is] = ACTIONS(2128),
    [anon_sym_as] = ACTIONS(2128),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2125),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2115),
    [anon_sym_let] = ACTIONS(2115),
    [anon_sym_This] = ACTIONS(2115),
    [anon_sym_decltype] = ACTIONS(2115),
    [sym_virtual] = ACTIONS(2115),
    [anon_sym_template] = ACTIONS(2115),
    [anon_sym_operator] = ACTIONS(2115),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_precise] = ACTIONS(2115),
    [anon_sym_shared] = ACTIONS(2115),
    [anon_sym_groupshared] = ACTIONS(2115),
    [anon_sym_uniform] = ACTIONS(2115),
    [anon_sym_row_major] = ACTIONS(2115),
    [anon_sym_column_major] = ACTIONS(2115),
    [anon_sym_globallycoherent] = ACTIONS(2115),
    [anon_sym_centroid] = ACTIONS(2115),
    [anon_sym_noperspective] = ACTIONS(2115),
    [anon_sym_nointerpolation] = ACTIONS(2115),
    [anon_sym_sample] = ACTIONS(2115),
    [anon_sym_linear] = ACTIONS(2115),
    [anon_sym_snorm] = ACTIONS(2115),
    [anon_sym_unorm] = ACTIONS(2115),
    [anon_sym_point] = ACTIONS(2115),
    [anon_sym_line] = ACTIONS(2115),
    [anon_sym_triangleadj] = ACTIONS(2115),
    [anon_sym_lineadj] = ACTIONS(2115),
    [anon_sym_triangle] = ACTIONS(2115),
  },
  [1342] = {
    [sym_string_literal] = STATE(3342),
    [sym_template_argument_list] = STATE(1527),
    [sym_raw_string_literal] = STATE(3342),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2639),
    [sym_identifier] = ACTIONS(2115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2130),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2130),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(4858),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON] = ACTIONS(4875),
    [anon_sym_SEMI] = ACTIONS(2117),
    [anon_sym___extension__] = ACTIONS(2115),
    [anon_sym_in] = ACTIONS(2115),
    [anon_sym_out] = ACTIONS(2115),
    [anon_sym_inout] = ACTIONS(2115),
    [anon_sym_extern] = ACTIONS(2115),
    [anon_sym___attribute__] = ACTIONS(2115),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2123),
    [anon_sym___declspec] = ACTIONS(2115),
    [anon_sym___based] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_signed] = ACTIONS(4863),
    [anon_sym_unsigned] = ACTIONS(4863),
    [anon_sym_long] = ACTIONS(4863),
    [anon_sym_short] = ACTIONS(4863),
    [anon_sym_LBRACK] = ACTIONS(2125),
    [anon_sym_static] = ACTIONS(2115),
    [anon_sym_EQ] = ACTIONS(2152),
    [anon_sym_register] = ACTIONS(2115),
    [anon_sym_inline] = ACTIONS(2115),
    [anon_sym___inline] = ACTIONS(2115),
    [anon_sym___inline__] = ACTIONS(2115),
    [anon_sym___forceinline] = ACTIONS(2115),
    [anon_sym_thread_local] = ACTIONS(2115),
    [anon_sym___thread] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(2115),
    [anon_sym_constexpr] = ACTIONS(2115),
    [anon_sym_volatile] = ACTIONS(2115),
    [anon_sym_restrict] = ACTIONS(2115),
    [anon_sym___restrict__] = ACTIONS(2115),
    [anon_sym__Atomic] = ACTIONS(2115),
    [anon_sym__Noreturn] = ACTIONS(2115),
    [anon_sym_noreturn] = ACTIONS(2115),
    [anon_sym_mutable] = ACTIONS(2115),
    [anon_sym_constinit] = ACTIONS(2115),
    [anon_sym_consteval] = ACTIONS(2115),
    [anon_sym_alignas] = ACTIONS(2115),
    [anon_sym__Alignas] = ACTIONS(2115),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2154),
    [anon_sym_SLASH_EQ] = ACTIONS(2154),
    [anon_sym_PERCENT_EQ] = ACTIONS(2154),
    [anon_sym_PLUS_EQ] = ACTIONS(2154),
    [anon_sym_DASH_EQ] = ACTIONS(2154),
    [anon_sym_LT_LT_EQ] = ACTIONS(2154),
    [anon_sym_GT_GT_EQ] = ACTIONS(2154),
    [anon_sym_AMP_EQ] = ACTIONS(2154),
    [anon_sym_CARET_EQ] = ACTIONS(2154),
    [anon_sym_PIPE_EQ] = ACTIONS(2154),
    [anon_sym_and_eq] = ACTIONS(2152),
    [anon_sym_or_eq] = ACTIONS(2152),
    [anon_sym_xor_eq] = ACTIONS(2152),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2128),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2128),
    [anon_sym_not_eq] = ACTIONS(2128),
    [anon_sym_is] = ACTIONS(2128),
    [anon_sym_as] = ACTIONS(2128),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2125),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2115),
    [anon_sym_let] = ACTIONS(2115),
    [anon_sym_This] = ACTIONS(2115),
    [anon_sym_decltype] = ACTIONS(2115),
    [sym_virtual] = ACTIONS(2115),
    [anon_sym_template] = ACTIONS(2115),
    [anon_sym_operator] = ACTIONS(2115),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_precise] = ACTIONS(2115),
    [anon_sym_shared] = ACTIONS(2115),
    [anon_sym_groupshared] = ACTIONS(2115),
    [anon_sym_uniform] = ACTIONS(2115),
    [anon_sym_row_major] = ACTIONS(2115),
    [anon_sym_column_major] = ACTIONS(2115),
    [anon_sym_globallycoherent] = ACTIONS(2115),
    [anon_sym_centroid] = ACTIONS(2115),
    [anon_sym_noperspective] = ACTIONS(2115),
    [anon_sym_nointerpolation] = ACTIONS(2115),
    [anon_sym_sample] = ACTIONS(2115),
    [anon_sym_linear] = ACTIONS(2115),
    [anon_sym_snorm] = ACTIONS(2115),
    [anon_sym_unorm] = ACTIONS(2115),
    [anon_sym_point] = ACTIONS(2115),
    [anon_sym_line] = ACTIONS(2115),
    [anon_sym_triangleadj] = ACTIONS(2115),
    [anon_sym_lineadj] = ACTIONS(2115),
    [anon_sym_triangle] = ACTIONS(2115),
  },
  [1343] = {
    [sym_string_literal] = STATE(3342),
    [sym_template_argument_list] = STATE(1527),
    [sym_raw_string_literal] = STATE(3342),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2639),
    [sym_identifier] = ACTIONS(2115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2130),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2130),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(4858),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON] = ACTIONS(4873),
    [anon_sym_SEMI] = ACTIONS(2117),
    [anon_sym___extension__] = ACTIONS(2115),
    [anon_sym_in] = ACTIONS(2115),
    [anon_sym_out] = ACTIONS(2115),
    [anon_sym_inout] = ACTIONS(2115),
    [anon_sym_extern] = ACTIONS(2115),
    [anon_sym___attribute__] = ACTIONS(2115),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2123),
    [anon_sym___declspec] = ACTIONS(2115),
    [anon_sym___based] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_signed] = ACTIONS(4863),
    [anon_sym_unsigned] = ACTIONS(4863),
    [anon_sym_long] = ACTIONS(4863),
    [anon_sym_short] = ACTIONS(4863),
    [anon_sym_LBRACK] = ACTIONS(2125),
    [anon_sym_static] = ACTIONS(2115),
    [anon_sym_EQ] = ACTIONS(2152),
    [anon_sym_register] = ACTIONS(2115),
    [anon_sym_inline] = ACTIONS(2115),
    [anon_sym___inline] = ACTIONS(2115),
    [anon_sym___inline__] = ACTIONS(2115),
    [anon_sym___forceinline] = ACTIONS(2115),
    [anon_sym_thread_local] = ACTIONS(2115),
    [anon_sym___thread] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(2115),
    [anon_sym_constexpr] = ACTIONS(2115),
    [anon_sym_volatile] = ACTIONS(2115),
    [anon_sym_restrict] = ACTIONS(2115),
    [anon_sym___restrict__] = ACTIONS(2115),
    [anon_sym__Atomic] = ACTIONS(2115),
    [anon_sym__Noreturn] = ACTIONS(2115),
    [anon_sym_noreturn] = ACTIONS(2115),
    [anon_sym_mutable] = ACTIONS(2115),
    [anon_sym_constinit] = ACTIONS(2115),
    [anon_sym_consteval] = ACTIONS(2115),
    [anon_sym_alignas] = ACTIONS(2115),
    [anon_sym__Alignas] = ACTIONS(2115),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2154),
    [anon_sym_SLASH_EQ] = ACTIONS(2154),
    [anon_sym_PERCENT_EQ] = ACTIONS(2154),
    [anon_sym_PLUS_EQ] = ACTIONS(2154),
    [anon_sym_DASH_EQ] = ACTIONS(2154),
    [anon_sym_LT_LT_EQ] = ACTIONS(2154),
    [anon_sym_GT_GT_EQ] = ACTIONS(2154),
    [anon_sym_AMP_EQ] = ACTIONS(2154),
    [anon_sym_CARET_EQ] = ACTIONS(2154),
    [anon_sym_PIPE_EQ] = ACTIONS(2154),
    [anon_sym_and_eq] = ACTIONS(2152),
    [anon_sym_or_eq] = ACTIONS(2152),
    [anon_sym_xor_eq] = ACTIONS(2152),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2128),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2128),
    [anon_sym_not_eq] = ACTIONS(2128),
    [anon_sym_is] = ACTIONS(2128),
    [anon_sym_as] = ACTIONS(2128),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2125),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2115),
    [anon_sym_let] = ACTIONS(2115),
    [anon_sym_This] = ACTIONS(2115),
    [anon_sym_decltype] = ACTIONS(2115),
    [sym_virtual] = ACTIONS(2115),
    [anon_sym_template] = ACTIONS(2115),
    [anon_sym_operator] = ACTIONS(2115),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_precise] = ACTIONS(2115),
    [anon_sym_shared] = ACTIONS(2115),
    [anon_sym_groupshared] = ACTIONS(2115),
    [anon_sym_uniform] = ACTIONS(2115),
    [anon_sym_row_major] = ACTIONS(2115),
    [anon_sym_column_major] = ACTIONS(2115),
    [anon_sym_globallycoherent] = ACTIONS(2115),
    [anon_sym_centroid] = ACTIONS(2115),
    [anon_sym_noperspective] = ACTIONS(2115),
    [anon_sym_nointerpolation] = ACTIONS(2115),
    [anon_sym_sample] = ACTIONS(2115),
    [anon_sym_linear] = ACTIONS(2115),
    [anon_sym_snorm] = ACTIONS(2115),
    [anon_sym_unorm] = ACTIONS(2115),
    [anon_sym_point] = ACTIONS(2115),
    [anon_sym_line] = ACTIONS(2115),
    [anon_sym_triangleadj] = ACTIONS(2115),
    [anon_sym_lineadj] = ACTIONS(2115),
    [anon_sym_triangle] = ACTIONS(2115),
  },
  [1344] = {
    [sym_expression] = STATE(4615),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_initializer_list] = STATE(4714),
    [sym_char_literal] = STATE(4905),
    [sym_concatenated_string] = STATE(4902),
    [sym_string_literal] = STATE(3611),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3610),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(4408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4410),
    [anon_sym_COMMA] = ACTIONS(4410),
    [aux_sym_preproc_if_token2] = ACTIONS(4410),
    [aux_sym_preproc_else_token1] = ACTIONS(4410),
    [aux_sym_preproc_elif_token1] = ACTIONS(4408),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4410),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4410),
    [anon_sym_LPAREN2] = ACTIONS(4410),
    [anon_sym_BANG] = ACTIONS(4924),
    [anon_sym_TILDE] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4408),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_STAR] = ACTIONS(4410),
    [anon_sym_SLASH] = ACTIONS(4408),
    [anon_sym_PERCENT] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4410),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4408),
    [anon_sym_GT_EQ] = ACTIONS(4410),
    [anon_sym_LT_EQ] = ACTIONS(4408),
    [anon_sym_LT] = ACTIONS(4408),
    [anon_sym_LT_LT] = ACTIONS(4410),
    [anon_sym_GT_GT] = ACTIONS(4410),
    [anon_sym_COLON_COLON] = ACTIONS(4928),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4410),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_QMARK] = ACTIONS(4410),
    [anon_sym_not] = ACTIONS(4924),
    [anon_sym_compl] = ACTIONS(4924),
    [anon_sym_LT_EQ_GT] = ACTIONS(4410),
    [anon_sym_or] = ACTIONS(4408),
    [anon_sym_and] = ACTIONS(4408),
    [anon_sym_bitor] = ACTIONS(4408),
    [anon_sym_xor] = ACTIONS(4408),
    [anon_sym_bitand] = ACTIONS(4408),
    [anon_sym_not_eq] = ACTIONS(4408),
    [anon_sym_is] = ACTIONS(4408),
    [anon_sym_as] = ACTIONS(4408),
    [anon_sym_DASH_DASH] = ACTIONS(4410),
    [anon_sym_PLUS_PLUS] = ACTIONS(4410),
    [anon_sym_sizeof] = ACTIONS(4932),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(4408),
    [anon_sym_DOT_STAR] = ACTIONS(4410),
    [anon_sym_DASH_GT] = ACTIONS(4410),
    [sym_number_literal] = ACTIONS(4934),
    [anon_sym_L_SQUOTE] = ACTIONS(4936),
    [anon_sym_u_SQUOTE] = ACTIONS(4936),
    [anon_sym_U_SQUOTE] = ACTIONS(4936),
    [anon_sym_u8_SQUOTE] = ACTIONS(4936),
    [anon_sym_SQUOTE] = ACTIONS(4936),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4938),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_co_await] = ACTIONS(4940),
    [anon_sym_new] = ACTIONS(4942),
    [anon_sym_requires] = ACTIONS(4944),
    [sym_this] = ACTIONS(241),
  },
  [1345] = {
    [sym_expression] = STATE(4615),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(4714),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4410),
    [anon_sym_COMMA] = ACTIONS(4410),
    [anon_sym_RPAREN] = ACTIONS(4410),
    [anon_sym_LPAREN2] = ACTIONS(4410),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(4408),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_STAR] = ACTIONS(4410),
    [anon_sym_SLASH] = ACTIONS(4408),
    [anon_sym_PERCENT] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4410),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4408),
    [anon_sym_GT_EQ] = ACTIONS(4410),
    [anon_sym_LT_EQ] = ACTIONS(4408),
    [anon_sym_LT] = ACTIONS(4408),
    [anon_sym_LT_LT] = ACTIONS(4410),
    [anon_sym_GT_GT] = ACTIONS(4410),
    [anon_sym_SEMI] = ACTIONS(4410),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_RBRACE] = ACTIONS(4410),
    [anon_sym_LBRACK] = ACTIONS(4410),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_QMARK] = ACTIONS(4410),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_LT_EQ_GT] = ACTIONS(4410),
    [anon_sym_or] = ACTIONS(4408),
    [anon_sym_and] = ACTIONS(4408),
    [anon_sym_bitor] = ACTIONS(4408),
    [anon_sym_xor] = ACTIONS(4408),
    [anon_sym_bitand] = ACTIONS(4408),
    [anon_sym_not_eq] = ACTIONS(4408),
    [anon_sym_is] = ACTIONS(4408),
    [anon_sym_as] = ACTIONS(4408),
    [anon_sym_DASH_DASH] = ACTIONS(4410),
    [anon_sym_PLUS_PLUS] = ACTIONS(4410),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(4408),
    [anon_sym_DOT_STAR] = ACTIONS(4410),
    [anon_sym_DASH_GT] = ACTIONS(4410),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1346] = {
    [sym_expression] = STATE(4615),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_initializer_list] = STATE(4714),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4410),
    [anon_sym_COMMA] = ACTIONS(4410),
    [anon_sym_LPAREN2] = ACTIONS(4410),
    [anon_sym_BANG] = ACTIONS(4950),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4408),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_STAR] = ACTIONS(4410),
    [anon_sym_SLASH] = ACTIONS(4408),
    [anon_sym_PERCENT] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4410),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4408),
    [anon_sym_GT_EQ] = ACTIONS(4410),
    [anon_sym_LT_EQ] = ACTIONS(4408),
    [anon_sym_LT] = ACTIONS(4408),
    [anon_sym_LT_LT] = ACTIONS(4410),
    [anon_sym_GT_GT] = ACTIONS(4410),
    [anon_sym_SEMI] = ACTIONS(4410),
    [anon_sym___attribute__] = ACTIONS(4408),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4410),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_QMARK] = ACTIONS(4410),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_LT_EQ_GT] = ACTIONS(4410),
    [anon_sym_or] = ACTIONS(4408),
    [anon_sym_and] = ACTIONS(4408),
    [anon_sym_bitor] = ACTIONS(4408),
    [anon_sym_xor] = ACTIONS(4408),
    [anon_sym_bitand] = ACTIONS(4408),
    [anon_sym_not_eq] = ACTIONS(4408),
    [anon_sym_is] = ACTIONS(4408),
    [anon_sym_as] = ACTIONS(4408),
    [anon_sym_DASH_DASH] = ACTIONS(4410),
    [anon_sym_PLUS_PLUS] = ACTIONS(4410),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(4408),
    [anon_sym_DOT_STAR] = ACTIONS(4410),
    [anon_sym_DASH_GT] = ACTIONS(4410),
    [sym_number_literal] = ACTIONS(4958),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4964),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1347] = {
    [sym_expression] = STATE(5402),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_initializer_list] = STATE(4714),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4410),
    [anon_sym_COMMA] = ACTIONS(4410),
    [anon_sym_LPAREN2] = ACTIONS(4410),
    [anon_sym_BANG] = ACTIONS(4972),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4408),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_STAR] = ACTIONS(4410),
    [anon_sym_SLASH] = ACTIONS(4408),
    [anon_sym_PERCENT] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4410),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4408),
    [anon_sym_GT_EQ] = ACTIONS(4410),
    [anon_sym_LT_EQ] = ACTIONS(4408),
    [anon_sym_LT] = ACTIONS(4408),
    [anon_sym_LT_LT] = ACTIONS(4410),
    [anon_sym_GT_GT] = ACTIONS(4410),
    [anon_sym_COLON] = ACTIONS(4408),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4410),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_QMARK] = ACTIONS(4410),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_LT_EQ_GT] = ACTIONS(4410),
    [anon_sym_or] = ACTIONS(4408),
    [anon_sym_and] = ACTIONS(4408),
    [anon_sym_bitor] = ACTIONS(4408),
    [anon_sym_xor] = ACTIONS(4408),
    [anon_sym_bitand] = ACTIONS(4408),
    [anon_sym_not_eq] = ACTIONS(4408),
    [anon_sym_is] = ACTIONS(4408),
    [anon_sym_as] = ACTIONS(4408),
    [anon_sym_DASH_DASH] = ACTIONS(4410),
    [anon_sym_PLUS_PLUS] = ACTIONS(4410),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(4408),
    [anon_sym_DOT_STAR] = ACTIONS(4410),
    [anon_sym_DASH_GT] = ACTIONS(4410),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1348] = {
    [sym_expression] = STATE(4615),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_initializer_list] = STATE(4714),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4410),
    [anon_sym_COMMA] = ACTIONS(4410),
    [anon_sym_LPAREN2] = ACTIONS(4410),
    [anon_sym_BANG] = ACTIONS(4988),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4408),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_STAR] = ACTIONS(4410),
    [anon_sym_SLASH] = ACTIONS(4408),
    [anon_sym_PERCENT] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4410),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4408),
    [anon_sym_GT_EQ] = ACTIONS(4410),
    [anon_sym_LT_EQ] = ACTIONS(4408),
    [anon_sym_LT] = ACTIONS(4408),
    [anon_sym_LT_LT] = ACTIONS(4410),
    [anon_sym_GT_GT] = ACTIONS(4410),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4410),
    [anon_sym_RBRACK] = ACTIONS(4410),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_QMARK] = ACTIONS(4410),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_LT_EQ_GT] = ACTIONS(4410),
    [anon_sym_or] = ACTIONS(4408),
    [anon_sym_and] = ACTIONS(4408),
    [anon_sym_bitor] = ACTIONS(4408),
    [anon_sym_xor] = ACTIONS(4408),
    [anon_sym_bitand] = ACTIONS(4408),
    [anon_sym_not_eq] = ACTIONS(4408),
    [anon_sym_is] = ACTIONS(4408),
    [anon_sym_as] = ACTIONS(4408),
    [anon_sym_DASH_DASH] = ACTIONS(4410),
    [anon_sym_PLUS_PLUS] = ACTIONS(4410),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(4408),
    [anon_sym_DOT_STAR] = ACTIONS(4410),
    [anon_sym_DASH_GT] = ACTIONS(4410),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1349] = {
    [sym_expression] = STATE(5392),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_initializer_list] = STATE(5663),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4410),
    [anon_sym_COMMA] = ACTIONS(4410),
    [anon_sym_LPAREN2] = ACTIONS(4410),
    [anon_sym_BANG] = ACTIONS(4627),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4408),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_STAR] = ACTIONS(4410),
    [anon_sym_SLASH] = ACTIONS(4408),
    [anon_sym_PERCENT] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4410),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4408),
    [anon_sym_GT_EQ] = ACTIONS(4408),
    [anon_sym_LT_EQ] = ACTIONS(4408),
    [anon_sym_LT] = ACTIONS(4408),
    [anon_sym_LT_LT] = ACTIONS(4410),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACE] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(4410),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_QMARK] = ACTIONS(4410),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_LT_EQ_GT] = ACTIONS(4410),
    [anon_sym_or] = ACTIONS(4408),
    [anon_sym_and] = ACTIONS(4408),
    [anon_sym_bitor] = ACTIONS(4408),
    [anon_sym_xor] = ACTIONS(4408),
    [anon_sym_bitand] = ACTIONS(4408),
    [anon_sym_not_eq] = ACTIONS(4408),
    [anon_sym_is] = ACTIONS(4408),
    [anon_sym_as] = ACTIONS(4408),
    [anon_sym_DASH_DASH] = ACTIONS(4410),
    [anon_sym_PLUS_PLUS] = ACTIONS(4410),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [anon_sym_DOT] = ACTIONS(4408),
    [anon_sym_DOT_STAR] = ACTIONS(4410),
    [anon_sym_DASH_GT] = ACTIONS(4410),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(4410),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [1350] = {
    [sym_expression] = STATE(5576),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5006),
    [anon_sym_COMMA] = ACTIONS(5006),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4988),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_SLASH] = ACTIONS(5010),
    [anon_sym_PERCENT] = ACTIONS(5006),
    [anon_sym_PIPE_PIPE] = ACTIONS(5006),
    [anon_sym_AMP_AMP] = ACTIONS(5006),
    [anon_sym_PIPE] = ACTIONS(5010),
    [anon_sym_CARET] = ACTIONS(5006),
    [anon_sym_AMP] = ACTIONS(1570),
    [anon_sym_EQ_EQ] = ACTIONS(5006),
    [anon_sym_BANG_EQ] = ACTIONS(5006),
    [anon_sym_GT] = ACTIONS(5010),
    [anon_sym_GT_EQ] = ACTIONS(5006),
    [anon_sym_LT_EQ] = ACTIONS(5010),
    [anon_sym_LT] = ACTIONS(5010),
    [anon_sym_LT_LT] = ACTIONS(5006),
    [anon_sym_GT_GT] = ACTIONS(5006),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5006),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_QMARK] = ACTIONS(5006),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_LT_EQ_GT] = ACTIONS(5006),
    [anon_sym_or] = ACTIONS(5010),
    [anon_sym_and] = ACTIONS(5010),
    [anon_sym_bitor] = ACTIONS(5010),
    [anon_sym_xor] = ACTIONS(5010),
    [anon_sym_bitand] = ACTIONS(5010),
    [anon_sym_not_eq] = ACTIONS(5010),
    [anon_sym_is] = ACTIONS(5010),
    [anon_sym_as] = ACTIONS(5010),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(5010),
    [anon_sym_DOT_STAR] = ACTIONS(5006),
    [anon_sym_DASH_GT] = ACTIONS(5006),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1351] = {
    [sym_identifier] = ACTIONS(2244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(2246),
    [anon_sym_RPAREN] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2244),
    [anon_sym_PLUS] = ACTIONS(2244),
    [anon_sym_STAR] = ACTIONS(2244),
    [anon_sym_SLASH] = ACTIONS(2244),
    [anon_sym_PERCENT] = ACTIONS(2244),
    [anon_sym_PIPE_PIPE] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2244),
    [anon_sym_CARET] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2244),
    [anon_sym_EQ_EQ] = ACTIONS(2246),
    [anon_sym_BANG_EQ] = ACTIONS(2246),
    [anon_sym_GT] = ACTIONS(2244),
    [anon_sym_GT_EQ] = ACTIONS(2246),
    [anon_sym_LT_EQ] = ACTIONS(2244),
    [anon_sym_LT] = ACTIONS(2244),
    [anon_sym_LT_LT] = ACTIONS(2244),
    [anon_sym_GT_GT] = ACTIONS(2244),
    [anon_sym_SEMI] = ACTIONS(2246),
    [anon_sym___extension__] = ACTIONS(2244),
    [anon_sym_in] = ACTIONS(2244),
    [anon_sym_out] = ACTIONS(2244),
    [anon_sym_inout] = ACTIONS(2244),
    [anon_sym_extern] = ACTIONS(2244),
    [anon_sym___attribute__] = ACTIONS(2244),
    [anon_sym_COLON_COLON] = ACTIONS(2246),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2246),
    [anon_sym___declspec] = ACTIONS(2244),
    [anon_sym___based] = ACTIONS(2244),
    [anon_sym___cdecl] = ACTIONS(2244),
    [anon_sym___clrcall] = ACTIONS(2244),
    [anon_sym___stdcall] = ACTIONS(2244),
    [anon_sym___fastcall] = ACTIONS(2244),
    [anon_sym___thiscall] = ACTIONS(2244),
    [anon_sym___vectorcall] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_RBRACE] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2244),
    [anon_sym_static] = ACTIONS(2244),
    [anon_sym_EQ] = ACTIONS(2244),
    [anon_sym_register] = ACTIONS(2244),
    [anon_sym_inline] = ACTIONS(2244),
    [anon_sym___inline] = ACTIONS(2244),
    [anon_sym___inline__] = ACTIONS(2244),
    [anon_sym___forceinline] = ACTIONS(2244),
    [anon_sym_thread_local] = ACTIONS(2244),
    [anon_sym___thread] = ACTIONS(2244),
    [anon_sym_const] = ACTIONS(2244),
    [anon_sym_constexpr] = ACTIONS(2244),
    [anon_sym_volatile] = ACTIONS(2244),
    [anon_sym_restrict] = ACTIONS(2244),
    [anon_sym___restrict__] = ACTIONS(2244),
    [anon_sym__Atomic] = ACTIONS(2244),
    [anon_sym__Noreturn] = ACTIONS(2244),
    [anon_sym_noreturn] = ACTIONS(2244),
    [anon_sym_mutable] = ACTIONS(2244),
    [anon_sym_constinit] = ACTIONS(2244),
    [anon_sym_consteval] = ACTIONS(2244),
    [anon_sym_alignas] = ACTIONS(2244),
    [anon_sym__Alignas] = ACTIONS(2244),
    [anon_sym_QMARK] = ACTIONS(2246),
    [anon_sym_STAR_EQ] = ACTIONS(2246),
    [anon_sym_SLASH_EQ] = ACTIONS(2246),
    [anon_sym_PERCENT_EQ] = ACTIONS(2246),
    [anon_sym_PLUS_EQ] = ACTIONS(2246),
    [anon_sym_DASH_EQ] = ACTIONS(2246),
    [anon_sym_LT_LT_EQ] = ACTIONS(2246),
    [anon_sym_GT_GT_EQ] = ACTIONS(2246),
    [anon_sym_AMP_EQ] = ACTIONS(2246),
    [anon_sym_CARET_EQ] = ACTIONS(2246),
    [anon_sym_PIPE_EQ] = ACTIONS(2246),
    [anon_sym_and_eq] = ACTIONS(2244),
    [anon_sym_or_eq] = ACTIONS(2244),
    [anon_sym_xor_eq] = ACTIONS(2244),
    [anon_sym_LT_EQ_GT] = ACTIONS(2246),
    [anon_sym_or] = ACTIONS(2244),
    [anon_sym_and] = ACTIONS(2244),
    [anon_sym_bitor] = ACTIONS(2244),
    [anon_sym_xor] = ACTIONS(2244),
    [anon_sym_bitand] = ACTIONS(2244),
    [anon_sym_not_eq] = ACTIONS(2244),
    [anon_sym_is] = ACTIONS(2244),
    [anon_sym_as] = ACTIONS(2244),
    [anon_sym_DASH_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_PLUS] = ACTIONS(2246),
    [anon_sym_DOT] = ACTIONS(2244),
    [anon_sym_DOT_STAR] = ACTIONS(2246),
    [anon_sym_DASH_GT] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2244),
    [anon_sym_let] = ACTIONS(2244),
    [anon_sym_This] = ACTIONS(2244),
    [anon_sym_decltype] = ACTIONS(2244),
    [sym_virtual] = ACTIONS(2244),
    [anon_sym_template] = ACTIONS(2244),
    [anon_sym_operator] = ACTIONS(2244),
    [anon_sym_precise] = ACTIONS(2244),
    [anon_sym_shared] = ACTIONS(2244),
    [anon_sym_groupshared] = ACTIONS(2244),
    [anon_sym_uniform] = ACTIONS(2244),
    [anon_sym_row_major] = ACTIONS(2244),
    [anon_sym_column_major] = ACTIONS(2244),
    [anon_sym_globallycoherent] = ACTIONS(2244),
    [anon_sym_centroid] = ACTIONS(2244),
    [anon_sym_noperspective] = ACTIONS(2244),
    [anon_sym_nointerpolation] = ACTIONS(2244),
    [anon_sym_sample] = ACTIONS(2244),
    [anon_sym_linear] = ACTIONS(2244),
    [anon_sym_snorm] = ACTIONS(2244),
    [anon_sym_unorm] = ACTIONS(2244),
    [anon_sym_point] = ACTIONS(2244),
    [anon_sym_line] = ACTIONS(2244),
    [anon_sym_triangleadj] = ACTIONS(2244),
    [anon_sym_lineadj] = ACTIONS(2244),
    [anon_sym_triangle] = ACTIONS(2244),
  },
  [1352] = {
    [sym_identifier] = ACTIONS(2240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2242),
    [anon_sym_RPAREN] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_TILDE] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2240),
    [anon_sym_PLUS] = ACTIONS(2240),
    [anon_sym_STAR] = ACTIONS(2240),
    [anon_sym_SLASH] = ACTIONS(2240),
    [anon_sym_PERCENT] = ACTIONS(2240),
    [anon_sym_PIPE_PIPE] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_PIPE] = ACTIONS(2240),
    [anon_sym_CARET] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2240),
    [anon_sym_EQ_EQ] = ACTIONS(2242),
    [anon_sym_BANG_EQ] = ACTIONS(2242),
    [anon_sym_GT] = ACTIONS(2240),
    [anon_sym_GT_EQ] = ACTIONS(2242),
    [anon_sym_LT_EQ] = ACTIONS(2240),
    [anon_sym_LT] = ACTIONS(2240),
    [anon_sym_LT_LT] = ACTIONS(2240),
    [anon_sym_GT_GT] = ACTIONS(2240),
    [anon_sym_SEMI] = ACTIONS(2242),
    [anon_sym___extension__] = ACTIONS(2240),
    [anon_sym_in] = ACTIONS(2240),
    [anon_sym_out] = ACTIONS(2240),
    [anon_sym_inout] = ACTIONS(2240),
    [anon_sym_extern] = ACTIONS(2240),
    [anon_sym___attribute__] = ACTIONS(2240),
    [anon_sym_COLON_COLON] = ACTIONS(2242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2242),
    [anon_sym___declspec] = ACTIONS(2240),
    [anon_sym___based] = ACTIONS(2240),
    [anon_sym___cdecl] = ACTIONS(2240),
    [anon_sym___clrcall] = ACTIONS(2240),
    [anon_sym___stdcall] = ACTIONS(2240),
    [anon_sym___fastcall] = ACTIONS(2240),
    [anon_sym___thiscall] = ACTIONS(2240),
    [anon_sym___vectorcall] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_RBRACE] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2240),
    [anon_sym_static] = ACTIONS(2240),
    [anon_sym_EQ] = ACTIONS(2240),
    [anon_sym_register] = ACTIONS(2240),
    [anon_sym_inline] = ACTIONS(2240),
    [anon_sym___inline] = ACTIONS(2240),
    [anon_sym___inline__] = ACTIONS(2240),
    [anon_sym___forceinline] = ACTIONS(2240),
    [anon_sym_thread_local] = ACTIONS(2240),
    [anon_sym___thread] = ACTIONS(2240),
    [anon_sym_const] = ACTIONS(2240),
    [anon_sym_constexpr] = ACTIONS(2240),
    [anon_sym_volatile] = ACTIONS(2240),
    [anon_sym_restrict] = ACTIONS(2240),
    [anon_sym___restrict__] = ACTIONS(2240),
    [anon_sym__Atomic] = ACTIONS(2240),
    [anon_sym__Noreturn] = ACTIONS(2240),
    [anon_sym_noreturn] = ACTIONS(2240),
    [anon_sym_mutable] = ACTIONS(2240),
    [anon_sym_constinit] = ACTIONS(2240),
    [anon_sym_consteval] = ACTIONS(2240),
    [anon_sym_alignas] = ACTIONS(2240),
    [anon_sym__Alignas] = ACTIONS(2240),
    [anon_sym_QMARK] = ACTIONS(2242),
    [anon_sym_STAR_EQ] = ACTIONS(2242),
    [anon_sym_SLASH_EQ] = ACTIONS(2242),
    [anon_sym_PERCENT_EQ] = ACTIONS(2242),
    [anon_sym_PLUS_EQ] = ACTIONS(2242),
    [anon_sym_DASH_EQ] = ACTIONS(2242),
    [anon_sym_LT_LT_EQ] = ACTIONS(2242),
    [anon_sym_GT_GT_EQ] = ACTIONS(2242),
    [anon_sym_AMP_EQ] = ACTIONS(2242),
    [anon_sym_CARET_EQ] = ACTIONS(2242),
    [anon_sym_PIPE_EQ] = ACTIONS(2242),
    [anon_sym_and_eq] = ACTIONS(2240),
    [anon_sym_or_eq] = ACTIONS(2240),
    [anon_sym_xor_eq] = ACTIONS(2240),
    [anon_sym_LT_EQ_GT] = ACTIONS(2242),
    [anon_sym_or] = ACTIONS(2240),
    [anon_sym_and] = ACTIONS(2240),
    [anon_sym_bitor] = ACTIONS(2240),
    [anon_sym_xor] = ACTIONS(2240),
    [anon_sym_bitand] = ACTIONS(2240),
    [anon_sym_not_eq] = ACTIONS(2240),
    [anon_sym_is] = ACTIONS(2240),
    [anon_sym_as] = ACTIONS(2240),
    [anon_sym_DASH_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_PLUS] = ACTIONS(2242),
    [anon_sym_DOT] = ACTIONS(2240),
    [anon_sym_DOT_STAR] = ACTIONS(2242),
    [anon_sym_DASH_GT] = ACTIONS(2242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2240),
    [anon_sym_let] = ACTIONS(2240),
    [anon_sym_This] = ACTIONS(2240),
    [anon_sym_decltype] = ACTIONS(2240),
    [sym_virtual] = ACTIONS(2240),
    [anon_sym_template] = ACTIONS(2240),
    [anon_sym_operator] = ACTIONS(2240),
    [anon_sym_precise] = ACTIONS(2240),
    [anon_sym_shared] = ACTIONS(2240),
    [anon_sym_groupshared] = ACTIONS(2240),
    [anon_sym_uniform] = ACTIONS(2240),
    [anon_sym_row_major] = ACTIONS(2240),
    [anon_sym_column_major] = ACTIONS(2240),
    [anon_sym_globallycoherent] = ACTIONS(2240),
    [anon_sym_centroid] = ACTIONS(2240),
    [anon_sym_noperspective] = ACTIONS(2240),
    [anon_sym_nointerpolation] = ACTIONS(2240),
    [anon_sym_sample] = ACTIONS(2240),
    [anon_sym_linear] = ACTIONS(2240),
    [anon_sym_snorm] = ACTIONS(2240),
    [anon_sym_unorm] = ACTIONS(2240),
    [anon_sym_point] = ACTIONS(2240),
    [anon_sym_line] = ACTIONS(2240),
    [anon_sym_triangleadj] = ACTIONS(2240),
    [anon_sym_lineadj] = ACTIONS(2240),
    [anon_sym_triangle] = ACTIONS(2240),
  },
  [1353] = {
    [sym_identifier] = ACTIONS(2202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_RPAREN] = ACTIONS(2204),
    [anon_sym_LPAREN2] = ACTIONS(2204),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2202),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_STAR] = ACTIONS(2202),
    [anon_sym_SLASH] = ACTIONS(2202),
    [anon_sym_PERCENT] = ACTIONS(2202),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2202),
    [anon_sym_CARET] = ACTIONS(2202),
    [anon_sym_AMP] = ACTIONS(2202),
    [anon_sym_EQ_EQ] = ACTIONS(2204),
    [anon_sym_BANG_EQ] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(2202),
    [anon_sym_GT_EQ] = ACTIONS(2204),
    [anon_sym_LT_EQ] = ACTIONS(2202),
    [anon_sym_LT] = ACTIONS(2202),
    [anon_sym_LT_LT] = ACTIONS(2202),
    [anon_sym_GT_GT] = ACTIONS(2202),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym___extension__] = ACTIONS(2202),
    [anon_sym_in] = ACTIONS(2202),
    [anon_sym_out] = ACTIONS(2202),
    [anon_sym_inout] = ACTIONS(2202),
    [anon_sym_extern] = ACTIONS(2202),
    [anon_sym___attribute__] = ACTIONS(2202),
    [anon_sym_COLON_COLON] = ACTIONS(2204),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2204),
    [anon_sym___declspec] = ACTIONS(2202),
    [anon_sym___based] = ACTIONS(2202),
    [anon_sym___cdecl] = ACTIONS(2202),
    [anon_sym___clrcall] = ACTIONS(2202),
    [anon_sym___stdcall] = ACTIONS(2202),
    [anon_sym___fastcall] = ACTIONS(2202),
    [anon_sym___thiscall] = ACTIONS(2202),
    [anon_sym___vectorcall] = ACTIONS(2202),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2202),
    [anon_sym_EQ] = ACTIONS(2202),
    [anon_sym_register] = ACTIONS(2202),
    [anon_sym_inline] = ACTIONS(2202),
    [anon_sym___inline] = ACTIONS(2202),
    [anon_sym___inline__] = ACTIONS(2202),
    [anon_sym___forceinline] = ACTIONS(2202),
    [anon_sym_thread_local] = ACTIONS(2202),
    [anon_sym___thread] = ACTIONS(2202),
    [anon_sym_const] = ACTIONS(2202),
    [anon_sym_constexpr] = ACTIONS(2202),
    [anon_sym_volatile] = ACTIONS(2202),
    [anon_sym_restrict] = ACTIONS(2202),
    [anon_sym___restrict__] = ACTIONS(2202),
    [anon_sym__Atomic] = ACTIONS(2202),
    [anon_sym__Noreturn] = ACTIONS(2202),
    [anon_sym_noreturn] = ACTIONS(2202),
    [anon_sym_mutable] = ACTIONS(2202),
    [anon_sym_constinit] = ACTIONS(2202),
    [anon_sym_consteval] = ACTIONS(2202),
    [anon_sym_alignas] = ACTIONS(2202),
    [anon_sym__Alignas] = ACTIONS(2202),
    [anon_sym_QMARK] = ACTIONS(2204),
    [anon_sym_STAR_EQ] = ACTIONS(2204),
    [anon_sym_SLASH_EQ] = ACTIONS(2204),
    [anon_sym_PERCENT_EQ] = ACTIONS(2204),
    [anon_sym_PLUS_EQ] = ACTIONS(2204),
    [anon_sym_DASH_EQ] = ACTIONS(2204),
    [anon_sym_LT_LT_EQ] = ACTIONS(2204),
    [anon_sym_GT_GT_EQ] = ACTIONS(2204),
    [anon_sym_AMP_EQ] = ACTIONS(2204),
    [anon_sym_CARET_EQ] = ACTIONS(2204),
    [anon_sym_PIPE_EQ] = ACTIONS(2204),
    [anon_sym_and_eq] = ACTIONS(2202),
    [anon_sym_or_eq] = ACTIONS(2202),
    [anon_sym_xor_eq] = ACTIONS(2202),
    [anon_sym_LT_EQ_GT] = ACTIONS(2204),
    [anon_sym_or] = ACTIONS(2202),
    [anon_sym_and] = ACTIONS(2202),
    [anon_sym_bitor] = ACTIONS(2202),
    [anon_sym_xor] = ACTIONS(2202),
    [anon_sym_bitand] = ACTIONS(2202),
    [anon_sym_not_eq] = ACTIONS(2202),
    [anon_sym_is] = ACTIONS(2202),
    [anon_sym_as] = ACTIONS(2202),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(2202),
    [anon_sym_DOT_STAR] = ACTIONS(2204),
    [anon_sym_DASH_GT] = ACTIONS(2204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2202),
    [anon_sym_let] = ACTIONS(2202),
    [anon_sym_This] = ACTIONS(2202),
    [anon_sym_decltype] = ACTIONS(2202),
    [sym_virtual] = ACTIONS(2202),
    [anon_sym_template] = ACTIONS(2202),
    [anon_sym_operator] = ACTIONS(2202),
    [anon_sym_precise] = ACTIONS(2202),
    [anon_sym_shared] = ACTIONS(2202),
    [anon_sym_groupshared] = ACTIONS(2202),
    [anon_sym_uniform] = ACTIONS(2202),
    [anon_sym_row_major] = ACTIONS(2202),
    [anon_sym_column_major] = ACTIONS(2202),
    [anon_sym_globallycoherent] = ACTIONS(2202),
    [anon_sym_centroid] = ACTIONS(2202),
    [anon_sym_noperspective] = ACTIONS(2202),
    [anon_sym_nointerpolation] = ACTIONS(2202),
    [anon_sym_sample] = ACTIONS(2202),
    [anon_sym_linear] = ACTIONS(2202),
    [anon_sym_snorm] = ACTIONS(2202),
    [anon_sym_unorm] = ACTIONS(2202),
    [anon_sym_point] = ACTIONS(2202),
    [anon_sym_line] = ACTIONS(2202),
    [anon_sym_triangleadj] = ACTIONS(2202),
    [anon_sym_lineadj] = ACTIONS(2202),
    [anon_sym_triangle] = ACTIONS(2202),
  },
  [1354] = {
    [sym__declaration_modifiers] = STATE(2299),
    [sym__declaration_specifiers] = STATE(4856),
    [sym_attribute_specifier] = STATE(2299),
    [sym_attribute_declaration] = STATE(2299),
    [sym_ms_declspec_modifier] = STATE(2299),
    [sym_ms_call_modifier] = STATE(7573),
    [sym__abstract_declarator] = STATE(8574),
    [sym_abstract_parenthesized_declarator] = STATE(7128),
    [sym_abstract_pointer_declarator] = STATE(7128),
    [sym_abstract_function_declarator] = STATE(7128),
    [sym_abstract_array_declarator] = STATE(7128),
    [sym_storage_class_specifier] = STATE(2299),
    [sym_type_qualifier] = STATE(2299),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2694),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_parameter_list] = STATE(4322),
    [sym_parameter_declaration] = STATE(9475),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_optional_parameter_declaration] = STATE(9475),
    [sym_variadic_parameter_declaration] = STATE(9475),
    [sym_abstract_reference_declarator] = STATE(7128),
    [sym__function_declarator_seq] = STATE(7135),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8090),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2299),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2299),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(5014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4879),
    [anon_sym_RPAREN] = ACTIONS(4881),
    [anon_sym_LPAREN2] = ACTIONS(5016),
    [anon_sym_STAR] = ACTIONS(5018),
    [anon_sym_AMP_AMP] = ACTIONS(5020),
    [anon_sym_AMP] = ACTIONS(5022),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_out] = ACTIONS(2293),
    [anon_sym_inout] = ACTIONS(2293),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(5024),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(2764),
    [anon_sym___clrcall] = ACTIONS(2764),
    [anon_sym___stdcall] = ACTIONS(2764),
    [anon_sym___fastcall] = ACTIONS(2764),
    [anon_sym___thiscall] = ACTIONS(2764),
    [anon_sym___vectorcall] = ACTIONS(2764),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(5026),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2299),
    [anon_sym_class] = ACTIONS(2301),
    [anon_sym_struct] = ACTIONS(2303),
    [anon_sym_union] = ACTIONS(2305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(2293),
    [anon_sym_typename] = ACTIONS(2329),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2341),
    [anon_sym_extension] = ACTIONS(2343),
  },
  [1355] = {
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2254),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_RPAREN] = ACTIONS(2254),
    [anon_sym_LPAREN2] = ACTIONS(2254),
    [anon_sym_TILDE] = ACTIONS(2254),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_SLASH] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2252),
    [anon_sym_PIPE_PIPE] = ACTIONS(2254),
    [anon_sym_AMP_AMP] = ACTIONS(2254),
    [anon_sym_PIPE] = ACTIONS(2252),
    [anon_sym_CARET] = ACTIONS(2252),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_EQ_EQ] = ACTIONS(2254),
    [anon_sym_BANG_EQ] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2252),
    [anon_sym_GT_EQ] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2252),
    [anon_sym_LT_LT] = ACTIONS(2252),
    [anon_sym_GT_GT] = ACTIONS(2252),
    [anon_sym_SEMI] = ACTIONS(2254),
    [anon_sym___extension__] = ACTIONS(2252),
    [anon_sym_in] = ACTIONS(2252),
    [anon_sym_out] = ACTIONS(2252),
    [anon_sym_inout] = ACTIONS(2252),
    [anon_sym_extern] = ACTIONS(2252),
    [anon_sym___attribute__] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2254),
    [anon_sym___declspec] = ACTIONS(2252),
    [anon_sym___based] = ACTIONS(2252),
    [anon_sym___cdecl] = ACTIONS(2252),
    [anon_sym___clrcall] = ACTIONS(2252),
    [anon_sym___stdcall] = ACTIONS(2252),
    [anon_sym___fastcall] = ACTIONS(2252),
    [anon_sym___thiscall] = ACTIONS(2252),
    [anon_sym___vectorcall] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_RBRACE] = ACTIONS(2254),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2252),
    [anon_sym_EQ] = ACTIONS(2252),
    [anon_sym_register] = ACTIONS(2252),
    [anon_sym_inline] = ACTIONS(2252),
    [anon_sym___inline] = ACTIONS(2252),
    [anon_sym___inline__] = ACTIONS(2252),
    [anon_sym___forceinline] = ACTIONS(2252),
    [anon_sym_thread_local] = ACTIONS(2252),
    [anon_sym___thread] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2252),
    [anon_sym_constexpr] = ACTIONS(2252),
    [anon_sym_volatile] = ACTIONS(2252),
    [anon_sym_restrict] = ACTIONS(2252),
    [anon_sym___restrict__] = ACTIONS(2252),
    [anon_sym__Atomic] = ACTIONS(2252),
    [anon_sym__Noreturn] = ACTIONS(2252),
    [anon_sym_noreturn] = ACTIONS(2252),
    [anon_sym_mutable] = ACTIONS(2252),
    [anon_sym_constinit] = ACTIONS(2252),
    [anon_sym_consteval] = ACTIONS(2252),
    [anon_sym_alignas] = ACTIONS(2252),
    [anon_sym__Alignas] = ACTIONS(2252),
    [anon_sym_QMARK] = ACTIONS(2254),
    [anon_sym_STAR_EQ] = ACTIONS(2254),
    [anon_sym_SLASH_EQ] = ACTIONS(2254),
    [anon_sym_PERCENT_EQ] = ACTIONS(2254),
    [anon_sym_PLUS_EQ] = ACTIONS(2254),
    [anon_sym_DASH_EQ] = ACTIONS(2254),
    [anon_sym_LT_LT_EQ] = ACTIONS(2254),
    [anon_sym_GT_GT_EQ] = ACTIONS(2254),
    [anon_sym_AMP_EQ] = ACTIONS(2254),
    [anon_sym_CARET_EQ] = ACTIONS(2254),
    [anon_sym_PIPE_EQ] = ACTIONS(2254),
    [anon_sym_and_eq] = ACTIONS(2252),
    [anon_sym_or_eq] = ACTIONS(2252),
    [anon_sym_xor_eq] = ACTIONS(2252),
    [anon_sym_LT_EQ_GT] = ACTIONS(2254),
    [anon_sym_or] = ACTIONS(2252),
    [anon_sym_and] = ACTIONS(2252),
    [anon_sym_bitor] = ACTIONS(2252),
    [anon_sym_xor] = ACTIONS(2252),
    [anon_sym_bitand] = ACTIONS(2252),
    [anon_sym_not_eq] = ACTIONS(2252),
    [anon_sym_is] = ACTIONS(2252),
    [anon_sym_as] = ACTIONS(2252),
    [anon_sym_DASH_DASH] = ACTIONS(2254),
    [anon_sym_PLUS_PLUS] = ACTIONS(2254),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_DOT_STAR] = ACTIONS(2254),
    [anon_sym_DASH_GT] = ACTIONS(2254),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_This] = ACTIONS(2252),
    [anon_sym_decltype] = ACTIONS(2252),
    [sym_virtual] = ACTIONS(2252),
    [anon_sym_template] = ACTIONS(2252),
    [anon_sym_operator] = ACTIONS(2252),
    [anon_sym_precise] = ACTIONS(2252),
    [anon_sym_shared] = ACTIONS(2252),
    [anon_sym_groupshared] = ACTIONS(2252),
    [anon_sym_uniform] = ACTIONS(2252),
    [anon_sym_row_major] = ACTIONS(2252),
    [anon_sym_column_major] = ACTIONS(2252),
    [anon_sym_globallycoherent] = ACTIONS(2252),
    [anon_sym_centroid] = ACTIONS(2252),
    [anon_sym_noperspective] = ACTIONS(2252),
    [anon_sym_nointerpolation] = ACTIONS(2252),
    [anon_sym_sample] = ACTIONS(2252),
    [anon_sym_linear] = ACTIONS(2252),
    [anon_sym_snorm] = ACTIONS(2252),
    [anon_sym_unorm] = ACTIONS(2252),
    [anon_sym_point] = ACTIONS(2252),
    [anon_sym_line] = ACTIONS(2252),
    [anon_sym_triangleadj] = ACTIONS(2252),
    [anon_sym_lineadj] = ACTIONS(2252),
    [anon_sym_triangle] = ACTIONS(2252),
  },
  [1356] = {
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2230),
    [anon_sym_COMMA] = ACTIONS(2230),
    [anon_sym_RPAREN] = ACTIONS(2230),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_TILDE] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2228),
    [anon_sym_PLUS] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(2228),
    [anon_sym_SLASH] = ACTIONS(2228),
    [anon_sym_PERCENT] = ACTIONS(2228),
    [anon_sym_PIPE_PIPE] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_PIPE] = ACTIONS(2228),
    [anon_sym_CARET] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2228),
    [anon_sym_EQ_EQ] = ACTIONS(2230),
    [anon_sym_BANG_EQ] = ACTIONS(2230),
    [anon_sym_GT] = ACTIONS(2228),
    [anon_sym_GT_EQ] = ACTIONS(2230),
    [anon_sym_LT_EQ] = ACTIONS(2228),
    [anon_sym_LT] = ACTIONS(2228),
    [anon_sym_LT_LT] = ACTIONS(2228),
    [anon_sym_GT_GT] = ACTIONS(2228),
    [anon_sym_SEMI] = ACTIONS(2230),
    [anon_sym___extension__] = ACTIONS(2228),
    [anon_sym_in] = ACTIONS(2228),
    [anon_sym_out] = ACTIONS(2228),
    [anon_sym_inout] = ACTIONS(2228),
    [anon_sym_extern] = ACTIONS(2228),
    [anon_sym___attribute__] = ACTIONS(2228),
    [anon_sym_COLON_COLON] = ACTIONS(2230),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2230),
    [anon_sym___declspec] = ACTIONS(2228),
    [anon_sym___based] = ACTIONS(2228),
    [anon_sym___cdecl] = ACTIONS(2228),
    [anon_sym___clrcall] = ACTIONS(2228),
    [anon_sym___stdcall] = ACTIONS(2228),
    [anon_sym___fastcall] = ACTIONS(2228),
    [anon_sym___thiscall] = ACTIONS(2228),
    [anon_sym___vectorcall] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_RBRACE] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2228),
    [anon_sym_static] = ACTIONS(2228),
    [anon_sym_EQ] = ACTIONS(2228),
    [anon_sym_register] = ACTIONS(2228),
    [anon_sym_inline] = ACTIONS(2228),
    [anon_sym___inline] = ACTIONS(2228),
    [anon_sym___inline__] = ACTIONS(2228),
    [anon_sym___forceinline] = ACTIONS(2228),
    [anon_sym_thread_local] = ACTIONS(2228),
    [anon_sym___thread] = ACTIONS(2228),
    [anon_sym_const] = ACTIONS(2228),
    [anon_sym_constexpr] = ACTIONS(2228),
    [anon_sym_volatile] = ACTIONS(2228),
    [anon_sym_restrict] = ACTIONS(2228),
    [anon_sym___restrict__] = ACTIONS(2228),
    [anon_sym__Atomic] = ACTIONS(2228),
    [anon_sym__Noreturn] = ACTIONS(2228),
    [anon_sym_noreturn] = ACTIONS(2228),
    [anon_sym_mutable] = ACTIONS(2228),
    [anon_sym_constinit] = ACTIONS(2228),
    [anon_sym_consteval] = ACTIONS(2228),
    [anon_sym_alignas] = ACTIONS(2228),
    [anon_sym__Alignas] = ACTIONS(2228),
    [anon_sym_QMARK] = ACTIONS(2230),
    [anon_sym_STAR_EQ] = ACTIONS(2230),
    [anon_sym_SLASH_EQ] = ACTIONS(2230),
    [anon_sym_PERCENT_EQ] = ACTIONS(2230),
    [anon_sym_PLUS_EQ] = ACTIONS(2230),
    [anon_sym_DASH_EQ] = ACTIONS(2230),
    [anon_sym_LT_LT_EQ] = ACTIONS(2230),
    [anon_sym_GT_GT_EQ] = ACTIONS(2230),
    [anon_sym_AMP_EQ] = ACTIONS(2230),
    [anon_sym_CARET_EQ] = ACTIONS(2230),
    [anon_sym_PIPE_EQ] = ACTIONS(2230),
    [anon_sym_and_eq] = ACTIONS(2228),
    [anon_sym_or_eq] = ACTIONS(2228),
    [anon_sym_xor_eq] = ACTIONS(2228),
    [anon_sym_LT_EQ_GT] = ACTIONS(2230),
    [anon_sym_or] = ACTIONS(2228),
    [anon_sym_and] = ACTIONS(2228),
    [anon_sym_bitor] = ACTIONS(2228),
    [anon_sym_xor] = ACTIONS(2228),
    [anon_sym_bitand] = ACTIONS(2228),
    [anon_sym_not_eq] = ACTIONS(2228),
    [anon_sym_is] = ACTIONS(2228),
    [anon_sym_as] = ACTIONS(2228),
    [anon_sym_DASH_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_PLUS] = ACTIONS(2230),
    [anon_sym_DOT] = ACTIONS(2228),
    [anon_sym_DOT_STAR] = ACTIONS(2230),
    [anon_sym_DASH_GT] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(2228),
    [anon_sym_This] = ACTIONS(2228),
    [anon_sym_decltype] = ACTIONS(2228),
    [sym_virtual] = ACTIONS(2228),
    [anon_sym_template] = ACTIONS(2228),
    [anon_sym_operator] = ACTIONS(2228),
    [anon_sym_precise] = ACTIONS(2228),
    [anon_sym_shared] = ACTIONS(2228),
    [anon_sym_groupshared] = ACTIONS(2228),
    [anon_sym_uniform] = ACTIONS(2228),
    [anon_sym_row_major] = ACTIONS(2228),
    [anon_sym_column_major] = ACTIONS(2228),
    [anon_sym_globallycoherent] = ACTIONS(2228),
    [anon_sym_centroid] = ACTIONS(2228),
    [anon_sym_noperspective] = ACTIONS(2228),
    [anon_sym_nointerpolation] = ACTIONS(2228),
    [anon_sym_sample] = ACTIONS(2228),
    [anon_sym_linear] = ACTIONS(2228),
    [anon_sym_snorm] = ACTIONS(2228),
    [anon_sym_unorm] = ACTIONS(2228),
    [anon_sym_point] = ACTIONS(2228),
    [anon_sym_line] = ACTIONS(2228),
    [anon_sym_triangleadj] = ACTIONS(2228),
    [anon_sym_lineadj] = ACTIONS(2228),
    [anon_sym_triangle] = ACTIONS(2228),
  },
  [1357] = {
    [sym_identifier] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_LPAREN2] = ACTIONS(2188),
    [anon_sym_TILDE] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2186),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_STAR] = ACTIONS(2186),
    [anon_sym_SLASH] = ACTIONS(2186),
    [anon_sym_PERCENT] = ACTIONS(2186),
    [anon_sym_PIPE_PIPE] = ACTIONS(2188),
    [anon_sym_AMP_AMP] = ACTIONS(2188),
    [anon_sym_PIPE] = ACTIONS(2186),
    [anon_sym_CARET] = ACTIONS(2186),
    [anon_sym_AMP] = ACTIONS(2186),
    [anon_sym_EQ_EQ] = ACTIONS(2188),
    [anon_sym_BANG_EQ] = ACTIONS(2188),
    [anon_sym_GT] = ACTIONS(2186),
    [anon_sym_GT_EQ] = ACTIONS(2188),
    [anon_sym_LT_EQ] = ACTIONS(2186),
    [anon_sym_LT] = ACTIONS(2186),
    [anon_sym_LT_LT] = ACTIONS(2186),
    [anon_sym_GT_GT] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym___extension__] = ACTIONS(2186),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_out] = ACTIONS(2186),
    [anon_sym_inout] = ACTIONS(2186),
    [anon_sym_extern] = ACTIONS(2186),
    [anon_sym___attribute__] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2188),
    [anon_sym___declspec] = ACTIONS(2186),
    [anon_sym___based] = ACTIONS(2186),
    [anon_sym___cdecl] = ACTIONS(2186),
    [anon_sym___clrcall] = ACTIONS(2186),
    [anon_sym___stdcall] = ACTIONS(2186),
    [anon_sym___fastcall] = ACTIONS(2186),
    [anon_sym___thiscall] = ACTIONS(2186),
    [anon_sym___vectorcall] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_RBRACE] = ACTIONS(2188),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_static] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_register] = ACTIONS(2186),
    [anon_sym_inline] = ACTIONS(2186),
    [anon_sym___inline] = ACTIONS(2186),
    [anon_sym___inline__] = ACTIONS(2186),
    [anon_sym___forceinline] = ACTIONS(2186),
    [anon_sym_thread_local] = ACTIONS(2186),
    [anon_sym___thread] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_constexpr] = ACTIONS(2186),
    [anon_sym_volatile] = ACTIONS(2186),
    [anon_sym_restrict] = ACTIONS(2186),
    [anon_sym___restrict__] = ACTIONS(2186),
    [anon_sym__Atomic] = ACTIONS(2186),
    [anon_sym__Noreturn] = ACTIONS(2186),
    [anon_sym_noreturn] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_constinit] = ACTIONS(2186),
    [anon_sym_consteval] = ACTIONS(2186),
    [anon_sym_alignas] = ACTIONS(2186),
    [anon_sym__Alignas] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_STAR_EQ] = ACTIONS(2188),
    [anon_sym_SLASH_EQ] = ACTIONS(2188),
    [anon_sym_PERCENT_EQ] = ACTIONS(2188),
    [anon_sym_PLUS_EQ] = ACTIONS(2188),
    [anon_sym_DASH_EQ] = ACTIONS(2188),
    [anon_sym_LT_LT_EQ] = ACTIONS(2188),
    [anon_sym_GT_GT_EQ] = ACTIONS(2188),
    [anon_sym_AMP_EQ] = ACTIONS(2188),
    [anon_sym_CARET_EQ] = ACTIONS(2188),
    [anon_sym_PIPE_EQ] = ACTIONS(2188),
    [anon_sym_and_eq] = ACTIONS(2186),
    [anon_sym_or_eq] = ACTIONS(2186),
    [anon_sym_xor_eq] = ACTIONS(2186),
    [anon_sym_LT_EQ_GT] = ACTIONS(2188),
    [anon_sym_or] = ACTIONS(2186),
    [anon_sym_and] = ACTIONS(2186),
    [anon_sym_bitor] = ACTIONS(2186),
    [anon_sym_xor] = ACTIONS(2186),
    [anon_sym_bitand] = ACTIONS(2186),
    [anon_sym_not_eq] = ACTIONS(2186),
    [anon_sym_is] = ACTIONS(2186),
    [anon_sym_as] = ACTIONS(2186),
    [anon_sym_DASH_DASH] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2188),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOT_STAR] = ACTIONS(2188),
    [anon_sym_DASH_GT] = ACTIONS(2188),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_This] = ACTIONS(2186),
    [anon_sym_decltype] = ACTIONS(2186),
    [sym_virtual] = ACTIONS(2186),
    [anon_sym_template] = ACTIONS(2186),
    [anon_sym_operator] = ACTIONS(2186),
    [anon_sym_precise] = ACTIONS(2186),
    [anon_sym_shared] = ACTIONS(2186),
    [anon_sym_groupshared] = ACTIONS(2186),
    [anon_sym_uniform] = ACTIONS(2186),
    [anon_sym_row_major] = ACTIONS(2186),
    [anon_sym_column_major] = ACTIONS(2186),
    [anon_sym_globallycoherent] = ACTIONS(2186),
    [anon_sym_centroid] = ACTIONS(2186),
    [anon_sym_noperspective] = ACTIONS(2186),
    [anon_sym_nointerpolation] = ACTIONS(2186),
    [anon_sym_sample] = ACTIONS(2186),
    [anon_sym_linear] = ACTIONS(2186),
    [anon_sym_snorm] = ACTIONS(2186),
    [anon_sym_unorm] = ACTIONS(2186),
    [anon_sym_point] = ACTIONS(2186),
    [anon_sym_line] = ACTIONS(2186),
    [anon_sym_triangleadj] = ACTIONS(2186),
    [anon_sym_lineadj] = ACTIONS(2186),
    [anon_sym_triangle] = ACTIONS(2186),
  },
  [1358] = {
    [sym_identifier] = ACTIONS(2198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_COMMA] = ACTIONS(2200),
    [anon_sym_RPAREN] = ACTIONS(2200),
    [anon_sym_LPAREN2] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(2198),
    [anon_sym_SLASH] = ACTIONS(2198),
    [anon_sym_PERCENT] = ACTIONS(2198),
    [anon_sym_PIPE_PIPE] = ACTIONS(2200),
    [anon_sym_AMP_AMP] = ACTIONS(2200),
    [anon_sym_PIPE] = ACTIONS(2198),
    [anon_sym_CARET] = ACTIONS(2198),
    [anon_sym_AMP] = ACTIONS(2198),
    [anon_sym_EQ_EQ] = ACTIONS(2200),
    [anon_sym_BANG_EQ] = ACTIONS(2200),
    [anon_sym_GT] = ACTIONS(2198),
    [anon_sym_GT_EQ] = ACTIONS(2200),
    [anon_sym_LT_EQ] = ACTIONS(2198),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_LT_LT] = ACTIONS(2198),
    [anon_sym_GT_GT] = ACTIONS(2198),
    [anon_sym_SEMI] = ACTIONS(2200),
    [anon_sym___extension__] = ACTIONS(2198),
    [anon_sym_in] = ACTIONS(2198),
    [anon_sym_out] = ACTIONS(2198),
    [anon_sym_inout] = ACTIONS(2198),
    [anon_sym_extern] = ACTIONS(2198),
    [anon_sym___attribute__] = ACTIONS(2198),
    [anon_sym_COLON_COLON] = ACTIONS(2200),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2200),
    [anon_sym___declspec] = ACTIONS(2198),
    [anon_sym___based] = ACTIONS(2198),
    [anon_sym___cdecl] = ACTIONS(2198),
    [anon_sym___clrcall] = ACTIONS(2198),
    [anon_sym___stdcall] = ACTIONS(2198),
    [anon_sym___fastcall] = ACTIONS(2198),
    [anon_sym___thiscall] = ACTIONS(2198),
    [anon_sym___vectorcall] = ACTIONS(2198),
    [anon_sym_LBRACE] = ACTIONS(2200),
    [anon_sym_RBRACE] = ACTIONS(2200),
    [anon_sym_LBRACK] = ACTIONS(2198),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_EQ] = ACTIONS(2198),
    [anon_sym_register] = ACTIONS(2198),
    [anon_sym_inline] = ACTIONS(2198),
    [anon_sym___inline] = ACTIONS(2198),
    [anon_sym___inline__] = ACTIONS(2198),
    [anon_sym___forceinline] = ACTIONS(2198),
    [anon_sym_thread_local] = ACTIONS(2198),
    [anon_sym___thread] = ACTIONS(2198),
    [anon_sym_const] = ACTIONS(2198),
    [anon_sym_constexpr] = ACTIONS(2198),
    [anon_sym_volatile] = ACTIONS(2198),
    [anon_sym_restrict] = ACTIONS(2198),
    [anon_sym___restrict__] = ACTIONS(2198),
    [anon_sym__Atomic] = ACTIONS(2198),
    [anon_sym__Noreturn] = ACTIONS(2198),
    [anon_sym_noreturn] = ACTIONS(2198),
    [anon_sym_mutable] = ACTIONS(2198),
    [anon_sym_constinit] = ACTIONS(2198),
    [anon_sym_consteval] = ACTIONS(2198),
    [anon_sym_alignas] = ACTIONS(2198),
    [anon_sym__Alignas] = ACTIONS(2198),
    [anon_sym_QMARK] = ACTIONS(2200),
    [anon_sym_STAR_EQ] = ACTIONS(2200),
    [anon_sym_SLASH_EQ] = ACTIONS(2200),
    [anon_sym_PERCENT_EQ] = ACTIONS(2200),
    [anon_sym_PLUS_EQ] = ACTIONS(2200),
    [anon_sym_DASH_EQ] = ACTIONS(2200),
    [anon_sym_LT_LT_EQ] = ACTIONS(2200),
    [anon_sym_GT_GT_EQ] = ACTIONS(2200),
    [anon_sym_AMP_EQ] = ACTIONS(2200),
    [anon_sym_CARET_EQ] = ACTIONS(2200),
    [anon_sym_PIPE_EQ] = ACTIONS(2200),
    [anon_sym_and_eq] = ACTIONS(2198),
    [anon_sym_or_eq] = ACTIONS(2198),
    [anon_sym_xor_eq] = ACTIONS(2198),
    [anon_sym_LT_EQ_GT] = ACTIONS(2200),
    [anon_sym_or] = ACTIONS(2198),
    [anon_sym_and] = ACTIONS(2198),
    [anon_sym_bitor] = ACTIONS(2198),
    [anon_sym_xor] = ACTIONS(2198),
    [anon_sym_bitand] = ACTIONS(2198),
    [anon_sym_not_eq] = ACTIONS(2198),
    [anon_sym_is] = ACTIONS(2198),
    [anon_sym_as] = ACTIONS(2198),
    [anon_sym_DASH_DASH] = ACTIONS(2200),
    [anon_sym_PLUS_PLUS] = ACTIONS(2200),
    [anon_sym_DOT] = ACTIONS(2198),
    [anon_sym_DOT_STAR] = ACTIONS(2200),
    [anon_sym_DASH_GT] = ACTIONS(2200),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2198),
    [anon_sym_let] = ACTIONS(2198),
    [anon_sym_This] = ACTIONS(2198),
    [anon_sym_decltype] = ACTIONS(2198),
    [sym_virtual] = ACTIONS(2198),
    [anon_sym_template] = ACTIONS(2198),
    [anon_sym_operator] = ACTIONS(2198),
    [anon_sym_precise] = ACTIONS(2198),
    [anon_sym_shared] = ACTIONS(2198),
    [anon_sym_groupshared] = ACTIONS(2198),
    [anon_sym_uniform] = ACTIONS(2198),
    [anon_sym_row_major] = ACTIONS(2198),
    [anon_sym_column_major] = ACTIONS(2198),
    [anon_sym_globallycoherent] = ACTIONS(2198),
    [anon_sym_centroid] = ACTIONS(2198),
    [anon_sym_noperspective] = ACTIONS(2198),
    [anon_sym_nointerpolation] = ACTIONS(2198),
    [anon_sym_sample] = ACTIONS(2198),
    [anon_sym_linear] = ACTIONS(2198),
    [anon_sym_snorm] = ACTIONS(2198),
    [anon_sym_unorm] = ACTIONS(2198),
    [anon_sym_point] = ACTIONS(2198),
    [anon_sym_line] = ACTIONS(2198),
    [anon_sym_triangleadj] = ACTIONS(2198),
    [anon_sym_lineadj] = ACTIONS(2198),
    [anon_sym_triangle] = ACTIONS(2198),
  },
  [1359] = {
    [sym_identifier] = ACTIONS(2256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2258),
    [anon_sym_COMMA] = ACTIONS(2258),
    [anon_sym_RPAREN] = ACTIONS(2258),
    [anon_sym_LPAREN2] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [anon_sym_DASH] = ACTIONS(2256),
    [anon_sym_PLUS] = ACTIONS(2256),
    [anon_sym_STAR] = ACTIONS(2256),
    [anon_sym_SLASH] = ACTIONS(2256),
    [anon_sym_PERCENT] = ACTIONS(2256),
    [anon_sym_PIPE_PIPE] = ACTIONS(2258),
    [anon_sym_AMP_AMP] = ACTIONS(2258),
    [anon_sym_PIPE] = ACTIONS(2256),
    [anon_sym_CARET] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(2256),
    [anon_sym_EQ_EQ] = ACTIONS(2258),
    [anon_sym_BANG_EQ] = ACTIONS(2258),
    [anon_sym_GT] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2258),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_LT] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2256),
    [anon_sym_GT_GT] = ACTIONS(2256),
    [anon_sym_SEMI] = ACTIONS(2258),
    [anon_sym___extension__] = ACTIONS(2256),
    [anon_sym_in] = ACTIONS(2256),
    [anon_sym_out] = ACTIONS(2256),
    [anon_sym_inout] = ACTIONS(2256),
    [anon_sym_extern] = ACTIONS(2256),
    [anon_sym___attribute__] = ACTIONS(2256),
    [anon_sym_COLON_COLON] = ACTIONS(2258),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2258),
    [anon_sym___declspec] = ACTIONS(2256),
    [anon_sym___based] = ACTIONS(2256),
    [anon_sym___cdecl] = ACTIONS(2256),
    [anon_sym___clrcall] = ACTIONS(2256),
    [anon_sym___stdcall] = ACTIONS(2256),
    [anon_sym___fastcall] = ACTIONS(2256),
    [anon_sym___thiscall] = ACTIONS(2256),
    [anon_sym___vectorcall] = ACTIONS(2256),
    [anon_sym_LBRACE] = ACTIONS(2258),
    [anon_sym_RBRACE] = ACTIONS(2258),
    [anon_sym_LBRACK] = ACTIONS(2256),
    [anon_sym_static] = ACTIONS(2256),
    [anon_sym_EQ] = ACTIONS(2256),
    [anon_sym_register] = ACTIONS(2256),
    [anon_sym_inline] = ACTIONS(2256),
    [anon_sym___inline] = ACTIONS(2256),
    [anon_sym___inline__] = ACTIONS(2256),
    [anon_sym___forceinline] = ACTIONS(2256),
    [anon_sym_thread_local] = ACTIONS(2256),
    [anon_sym___thread] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_constexpr] = ACTIONS(2256),
    [anon_sym_volatile] = ACTIONS(2256),
    [anon_sym_restrict] = ACTIONS(2256),
    [anon_sym___restrict__] = ACTIONS(2256),
    [anon_sym__Atomic] = ACTIONS(2256),
    [anon_sym__Noreturn] = ACTIONS(2256),
    [anon_sym_noreturn] = ACTIONS(2256),
    [anon_sym_mutable] = ACTIONS(2256),
    [anon_sym_constinit] = ACTIONS(2256),
    [anon_sym_consteval] = ACTIONS(2256),
    [anon_sym_alignas] = ACTIONS(2256),
    [anon_sym__Alignas] = ACTIONS(2256),
    [anon_sym_QMARK] = ACTIONS(2258),
    [anon_sym_STAR_EQ] = ACTIONS(2258),
    [anon_sym_SLASH_EQ] = ACTIONS(2258),
    [anon_sym_PERCENT_EQ] = ACTIONS(2258),
    [anon_sym_PLUS_EQ] = ACTIONS(2258),
    [anon_sym_DASH_EQ] = ACTIONS(2258),
    [anon_sym_LT_LT_EQ] = ACTIONS(2258),
    [anon_sym_GT_GT_EQ] = ACTIONS(2258),
    [anon_sym_AMP_EQ] = ACTIONS(2258),
    [anon_sym_CARET_EQ] = ACTIONS(2258),
    [anon_sym_PIPE_EQ] = ACTIONS(2258),
    [anon_sym_and_eq] = ACTIONS(2256),
    [anon_sym_or_eq] = ACTIONS(2256),
    [anon_sym_xor_eq] = ACTIONS(2256),
    [anon_sym_LT_EQ_GT] = ACTIONS(2258),
    [anon_sym_or] = ACTIONS(2256),
    [anon_sym_and] = ACTIONS(2256),
    [anon_sym_bitor] = ACTIONS(2256),
    [anon_sym_xor] = ACTIONS(2256),
    [anon_sym_bitand] = ACTIONS(2256),
    [anon_sym_not_eq] = ACTIONS(2256),
    [anon_sym_is] = ACTIONS(2256),
    [anon_sym_as] = ACTIONS(2256),
    [anon_sym_DASH_DASH] = ACTIONS(2258),
    [anon_sym_PLUS_PLUS] = ACTIONS(2258),
    [anon_sym_DOT] = ACTIONS(2256),
    [anon_sym_DOT_STAR] = ACTIONS(2258),
    [anon_sym_DASH_GT] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_This] = ACTIONS(2256),
    [anon_sym_decltype] = ACTIONS(2256),
    [sym_virtual] = ACTIONS(2256),
    [anon_sym_template] = ACTIONS(2256),
    [anon_sym_operator] = ACTIONS(2256),
    [anon_sym_precise] = ACTIONS(2256),
    [anon_sym_shared] = ACTIONS(2256),
    [anon_sym_groupshared] = ACTIONS(2256),
    [anon_sym_uniform] = ACTIONS(2256),
    [anon_sym_row_major] = ACTIONS(2256),
    [anon_sym_column_major] = ACTIONS(2256),
    [anon_sym_globallycoherent] = ACTIONS(2256),
    [anon_sym_centroid] = ACTIONS(2256),
    [anon_sym_noperspective] = ACTIONS(2256),
    [anon_sym_nointerpolation] = ACTIONS(2256),
    [anon_sym_sample] = ACTIONS(2256),
    [anon_sym_linear] = ACTIONS(2256),
    [anon_sym_snorm] = ACTIONS(2256),
    [anon_sym_unorm] = ACTIONS(2256),
    [anon_sym_point] = ACTIONS(2256),
    [anon_sym_line] = ACTIONS(2256),
    [anon_sym_triangleadj] = ACTIONS(2256),
    [anon_sym_lineadj] = ACTIONS(2256),
    [anon_sym_triangle] = ACTIONS(2256),
  },
  [1360] = {
    [sym_identifier] = ACTIONS(2248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_RPAREN] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2248),
    [anon_sym_PLUS] = ACTIONS(2248),
    [anon_sym_STAR] = ACTIONS(2248),
    [anon_sym_SLASH] = ACTIONS(2248),
    [anon_sym_PERCENT] = ACTIONS(2248),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2248),
    [anon_sym_EQ_EQ] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_GT] = ACTIONS(2248),
    [anon_sym_GT_EQ] = ACTIONS(2250),
    [anon_sym_LT_EQ] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_LT_LT] = ACTIONS(2248),
    [anon_sym_GT_GT] = ACTIONS(2248),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym___extension__] = ACTIONS(2248),
    [anon_sym_in] = ACTIONS(2248),
    [anon_sym_out] = ACTIONS(2248),
    [anon_sym_inout] = ACTIONS(2248),
    [anon_sym_extern] = ACTIONS(2248),
    [anon_sym___attribute__] = ACTIONS(2248),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2250),
    [anon_sym___declspec] = ACTIONS(2248),
    [anon_sym___based] = ACTIONS(2248),
    [anon_sym___cdecl] = ACTIONS(2248),
    [anon_sym___clrcall] = ACTIONS(2248),
    [anon_sym___stdcall] = ACTIONS(2248),
    [anon_sym___fastcall] = ACTIONS(2248),
    [anon_sym___thiscall] = ACTIONS(2248),
    [anon_sym___vectorcall] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2248),
    [anon_sym_static] = ACTIONS(2248),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_register] = ACTIONS(2248),
    [anon_sym_inline] = ACTIONS(2248),
    [anon_sym___inline] = ACTIONS(2248),
    [anon_sym___inline__] = ACTIONS(2248),
    [anon_sym___forceinline] = ACTIONS(2248),
    [anon_sym_thread_local] = ACTIONS(2248),
    [anon_sym___thread] = ACTIONS(2248),
    [anon_sym_const] = ACTIONS(2248),
    [anon_sym_constexpr] = ACTIONS(2248),
    [anon_sym_volatile] = ACTIONS(2248),
    [anon_sym_restrict] = ACTIONS(2248),
    [anon_sym___restrict__] = ACTIONS(2248),
    [anon_sym__Atomic] = ACTIONS(2248),
    [anon_sym__Noreturn] = ACTIONS(2248),
    [anon_sym_noreturn] = ACTIONS(2248),
    [anon_sym_mutable] = ACTIONS(2248),
    [anon_sym_constinit] = ACTIONS(2248),
    [anon_sym_consteval] = ACTIONS(2248),
    [anon_sym_alignas] = ACTIONS(2248),
    [anon_sym__Alignas] = ACTIONS(2248),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_STAR_EQ] = ACTIONS(2250),
    [anon_sym_SLASH_EQ] = ACTIONS(2250),
    [anon_sym_PERCENT_EQ] = ACTIONS(2250),
    [anon_sym_PLUS_EQ] = ACTIONS(2250),
    [anon_sym_DASH_EQ] = ACTIONS(2250),
    [anon_sym_LT_LT_EQ] = ACTIONS(2250),
    [anon_sym_GT_GT_EQ] = ACTIONS(2250),
    [anon_sym_AMP_EQ] = ACTIONS(2250),
    [anon_sym_CARET_EQ] = ACTIONS(2250),
    [anon_sym_PIPE_EQ] = ACTIONS(2250),
    [anon_sym_and_eq] = ACTIONS(2248),
    [anon_sym_or_eq] = ACTIONS(2248),
    [anon_sym_xor_eq] = ACTIONS(2248),
    [anon_sym_LT_EQ_GT] = ACTIONS(2250),
    [anon_sym_or] = ACTIONS(2248),
    [anon_sym_and] = ACTIONS(2248),
    [anon_sym_bitor] = ACTIONS(2248),
    [anon_sym_xor] = ACTIONS(2248),
    [anon_sym_bitand] = ACTIONS(2248),
    [anon_sym_not_eq] = ACTIONS(2248),
    [anon_sym_is] = ACTIONS(2248),
    [anon_sym_as] = ACTIONS(2248),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2248),
    [anon_sym_DOT_STAR] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2248),
    [anon_sym_let] = ACTIONS(2248),
    [anon_sym_This] = ACTIONS(2248),
    [anon_sym_decltype] = ACTIONS(2248),
    [sym_virtual] = ACTIONS(2248),
    [anon_sym_template] = ACTIONS(2248),
    [anon_sym_operator] = ACTIONS(2248),
    [anon_sym_precise] = ACTIONS(2248),
    [anon_sym_shared] = ACTIONS(2248),
    [anon_sym_groupshared] = ACTIONS(2248),
    [anon_sym_uniform] = ACTIONS(2248),
    [anon_sym_row_major] = ACTIONS(2248),
    [anon_sym_column_major] = ACTIONS(2248),
    [anon_sym_globallycoherent] = ACTIONS(2248),
    [anon_sym_centroid] = ACTIONS(2248),
    [anon_sym_noperspective] = ACTIONS(2248),
    [anon_sym_nointerpolation] = ACTIONS(2248),
    [anon_sym_sample] = ACTIONS(2248),
    [anon_sym_linear] = ACTIONS(2248),
    [anon_sym_snorm] = ACTIONS(2248),
    [anon_sym_unorm] = ACTIONS(2248),
    [anon_sym_point] = ACTIONS(2248),
    [anon_sym_line] = ACTIONS(2248),
    [anon_sym_triangleadj] = ACTIONS(2248),
    [anon_sym_lineadj] = ACTIONS(2248),
    [anon_sym_triangle] = ACTIONS(2248),
  },
  [1361] = {
    [sym_template_argument_list] = STATE(1369),
    [sym_identifier] = ACTIONS(2169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2171),
    [anon_sym_COMMA] = ACTIONS(2171),
    [anon_sym_LPAREN2] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2171),
    [anon_sym_AMP_AMP] = ACTIONS(2173),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2171),
    [anon_sym_BANG_EQ] = ACTIONS(2171),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2171),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(5028),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_SEMI] = ACTIONS(2173),
    [anon_sym___extension__] = ACTIONS(2169),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_out] = ACTIONS(2169),
    [anon_sym_inout] = ACTIONS(2169),
    [anon_sym_extern] = ACTIONS(2169),
    [anon_sym___attribute__] = ACTIONS(2169),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2173),
    [anon_sym___declspec] = ACTIONS(2169),
    [anon_sym___based] = ACTIONS(2169),
    [anon_sym___cdecl] = ACTIONS(2169),
    [anon_sym___clrcall] = ACTIONS(2169),
    [anon_sym___stdcall] = ACTIONS(2169),
    [anon_sym___fastcall] = ACTIONS(2169),
    [anon_sym___thiscall] = ACTIONS(2169),
    [anon_sym___vectorcall] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2176),
    [anon_sym_RBRACE] = ACTIONS(2171),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2169),
    [anon_sym_EQ] = ACTIONS(2181),
    [anon_sym_register] = ACTIONS(2169),
    [anon_sym_inline] = ACTIONS(2169),
    [anon_sym___inline] = ACTIONS(2169),
    [anon_sym___inline__] = ACTIONS(2169),
    [anon_sym___forceinline] = ACTIONS(2169),
    [anon_sym_thread_local] = ACTIONS(2169),
    [anon_sym___thread] = ACTIONS(2169),
    [anon_sym_const] = ACTIONS(2169),
    [anon_sym_constexpr] = ACTIONS(2169),
    [anon_sym_volatile] = ACTIONS(2169),
    [anon_sym_restrict] = ACTIONS(2169),
    [anon_sym___restrict__] = ACTIONS(2169),
    [anon_sym__Atomic] = ACTIONS(2169),
    [anon_sym__Noreturn] = ACTIONS(2169),
    [anon_sym_noreturn] = ACTIONS(2169),
    [anon_sym_mutable] = ACTIONS(2169),
    [anon_sym_constinit] = ACTIONS(2169),
    [anon_sym_consteval] = ACTIONS(2169),
    [anon_sym_alignas] = ACTIONS(2169),
    [anon_sym__Alignas] = ACTIONS(2169),
    [anon_sym_QMARK] = ACTIONS(2171),
    [anon_sym_STAR_EQ] = ACTIONS(2171),
    [anon_sym_SLASH_EQ] = ACTIONS(2171),
    [anon_sym_PERCENT_EQ] = ACTIONS(2171),
    [anon_sym_PLUS_EQ] = ACTIONS(2171),
    [anon_sym_DASH_EQ] = ACTIONS(2171),
    [anon_sym_LT_LT_EQ] = ACTIONS(2171),
    [anon_sym_GT_GT_EQ] = ACTIONS(2171),
    [anon_sym_AMP_EQ] = ACTIONS(2171),
    [anon_sym_CARET_EQ] = ACTIONS(2171),
    [anon_sym_PIPE_EQ] = ACTIONS(2171),
    [anon_sym_and_eq] = ACTIONS(2181),
    [anon_sym_or_eq] = ACTIONS(2181),
    [anon_sym_xor_eq] = ACTIONS(2181),
    [anon_sym_LT_EQ_GT] = ACTIONS(2171),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2181),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2181),
    [anon_sym_not_eq] = ACTIONS(2181),
    [anon_sym_is] = ACTIONS(2181),
    [anon_sym_as] = ACTIONS(2181),
    [anon_sym_DASH_DASH] = ACTIONS(2171),
    [anon_sym_PLUS_PLUS] = ACTIONS(2171),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DOT_STAR] = ACTIONS(2171),
    [anon_sym_DASH_GT] = ACTIONS(2171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2169),
    [anon_sym_let] = ACTIONS(2169),
    [anon_sym_This] = ACTIONS(2169),
    [anon_sym_decltype] = ACTIONS(2169),
    [sym_virtual] = ACTIONS(2169),
    [anon_sym_template] = ACTIONS(2169),
    [anon_sym_operator] = ACTIONS(2169),
    [anon_sym_precise] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_groupshared] = ACTIONS(2169),
    [anon_sym_uniform] = ACTIONS(2169),
    [anon_sym_row_major] = ACTIONS(2169),
    [anon_sym_column_major] = ACTIONS(2169),
    [anon_sym_globallycoherent] = ACTIONS(2169),
    [anon_sym_centroid] = ACTIONS(2169),
    [anon_sym_noperspective] = ACTIONS(2169),
    [anon_sym_nointerpolation] = ACTIONS(2169),
    [anon_sym_sample] = ACTIONS(2169),
    [anon_sym_linear] = ACTIONS(2169),
    [anon_sym_snorm] = ACTIONS(2169),
    [anon_sym_unorm] = ACTIONS(2169),
    [anon_sym_point] = ACTIONS(2169),
    [anon_sym_line] = ACTIONS(2169),
    [anon_sym_triangleadj] = ACTIONS(2169),
    [anon_sym_lineadj] = ACTIONS(2169),
    [anon_sym_triangle] = ACTIONS(2169),
  },
  [1362] = {
    [sym_identifier] = ACTIONS(2224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2226),
    [anon_sym_COMMA] = ACTIONS(2226),
    [anon_sym_RPAREN] = ACTIONS(2226),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_TILDE] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_PLUS] = ACTIONS(2224),
    [anon_sym_STAR] = ACTIONS(2224),
    [anon_sym_SLASH] = ACTIONS(2224),
    [anon_sym_PERCENT] = ACTIONS(2224),
    [anon_sym_PIPE_PIPE] = ACTIONS(2226),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_PIPE] = ACTIONS(2224),
    [anon_sym_CARET] = ACTIONS(2224),
    [anon_sym_AMP] = ACTIONS(2224),
    [anon_sym_EQ_EQ] = ACTIONS(2226),
    [anon_sym_BANG_EQ] = ACTIONS(2226),
    [anon_sym_GT] = ACTIONS(2224),
    [anon_sym_GT_EQ] = ACTIONS(2226),
    [anon_sym_LT_EQ] = ACTIONS(2224),
    [anon_sym_LT] = ACTIONS(2224),
    [anon_sym_LT_LT] = ACTIONS(2224),
    [anon_sym_GT_GT] = ACTIONS(2224),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym___extension__] = ACTIONS(2224),
    [anon_sym_in] = ACTIONS(2224),
    [anon_sym_out] = ACTIONS(2224),
    [anon_sym_inout] = ACTIONS(2224),
    [anon_sym_extern] = ACTIONS(2224),
    [anon_sym___attribute__] = ACTIONS(2224),
    [anon_sym_COLON_COLON] = ACTIONS(2226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2226),
    [anon_sym___declspec] = ACTIONS(2224),
    [anon_sym___based] = ACTIONS(2224),
    [anon_sym___cdecl] = ACTIONS(2224),
    [anon_sym___clrcall] = ACTIONS(2224),
    [anon_sym___stdcall] = ACTIONS(2224),
    [anon_sym___fastcall] = ACTIONS(2224),
    [anon_sym___thiscall] = ACTIONS(2224),
    [anon_sym___vectorcall] = ACTIONS(2224),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_RBRACE] = ACTIONS(2226),
    [anon_sym_LBRACK] = ACTIONS(2224),
    [anon_sym_static] = ACTIONS(2224),
    [anon_sym_EQ] = ACTIONS(2224),
    [anon_sym_register] = ACTIONS(2224),
    [anon_sym_inline] = ACTIONS(2224),
    [anon_sym___inline] = ACTIONS(2224),
    [anon_sym___inline__] = ACTIONS(2224),
    [anon_sym___forceinline] = ACTIONS(2224),
    [anon_sym_thread_local] = ACTIONS(2224),
    [anon_sym___thread] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_constexpr] = ACTIONS(2224),
    [anon_sym_volatile] = ACTIONS(2224),
    [anon_sym_restrict] = ACTIONS(2224),
    [anon_sym___restrict__] = ACTIONS(2224),
    [anon_sym__Atomic] = ACTIONS(2224),
    [anon_sym__Noreturn] = ACTIONS(2224),
    [anon_sym_noreturn] = ACTIONS(2224),
    [anon_sym_mutable] = ACTIONS(2224),
    [anon_sym_constinit] = ACTIONS(2224),
    [anon_sym_consteval] = ACTIONS(2224),
    [anon_sym_alignas] = ACTIONS(2224),
    [anon_sym__Alignas] = ACTIONS(2224),
    [anon_sym_QMARK] = ACTIONS(2226),
    [anon_sym_STAR_EQ] = ACTIONS(2226),
    [anon_sym_SLASH_EQ] = ACTIONS(2226),
    [anon_sym_PERCENT_EQ] = ACTIONS(2226),
    [anon_sym_PLUS_EQ] = ACTIONS(2226),
    [anon_sym_DASH_EQ] = ACTIONS(2226),
    [anon_sym_LT_LT_EQ] = ACTIONS(2226),
    [anon_sym_GT_GT_EQ] = ACTIONS(2226),
    [anon_sym_AMP_EQ] = ACTIONS(2226),
    [anon_sym_CARET_EQ] = ACTIONS(2226),
    [anon_sym_PIPE_EQ] = ACTIONS(2226),
    [anon_sym_and_eq] = ACTIONS(2224),
    [anon_sym_or_eq] = ACTIONS(2224),
    [anon_sym_xor_eq] = ACTIONS(2224),
    [anon_sym_LT_EQ_GT] = ACTIONS(2226),
    [anon_sym_or] = ACTIONS(2224),
    [anon_sym_and] = ACTIONS(2224),
    [anon_sym_bitor] = ACTIONS(2224),
    [anon_sym_xor] = ACTIONS(2224),
    [anon_sym_bitand] = ACTIONS(2224),
    [anon_sym_not_eq] = ACTIONS(2224),
    [anon_sym_is] = ACTIONS(2224),
    [anon_sym_as] = ACTIONS(2224),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_DOT] = ACTIONS(2224),
    [anon_sym_DOT_STAR] = ACTIONS(2226),
    [anon_sym_DASH_GT] = ACTIONS(2226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2224),
    [anon_sym_let] = ACTIONS(2224),
    [anon_sym_This] = ACTIONS(2224),
    [anon_sym_decltype] = ACTIONS(2224),
    [sym_virtual] = ACTIONS(2224),
    [anon_sym_template] = ACTIONS(2224),
    [anon_sym_operator] = ACTIONS(2224),
    [anon_sym_precise] = ACTIONS(2224),
    [anon_sym_shared] = ACTIONS(2224),
    [anon_sym_groupshared] = ACTIONS(2224),
    [anon_sym_uniform] = ACTIONS(2224),
    [anon_sym_row_major] = ACTIONS(2224),
    [anon_sym_column_major] = ACTIONS(2224),
    [anon_sym_globallycoherent] = ACTIONS(2224),
    [anon_sym_centroid] = ACTIONS(2224),
    [anon_sym_noperspective] = ACTIONS(2224),
    [anon_sym_nointerpolation] = ACTIONS(2224),
    [anon_sym_sample] = ACTIONS(2224),
    [anon_sym_linear] = ACTIONS(2224),
    [anon_sym_snorm] = ACTIONS(2224),
    [anon_sym_unorm] = ACTIONS(2224),
    [anon_sym_point] = ACTIONS(2224),
    [anon_sym_line] = ACTIONS(2224),
    [anon_sym_triangleadj] = ACTIONS(2224),
    [anon_sym_lineadj] = ACTIONS(2224),
    [anon_sym_triangle] = ACTIONS(2224),
  },
  [1363] = {
    [sym_identifier] = ACTIONS(2206),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2208),
    [anon_sym_COMMA] = ACTIONS(2208),
    [anon_sym_RPAREN] = ACTIONS(2208),
    [anon_sym_LPAREN2] = ACTIONS(2208),
    [anon_sym_TILDE] = ACTIONS(2208),
    [anon_sym_DASH] = ACTIONS(2206),
    [anon_sym_PLUS] = ACTIONS(2206),
    [anon_sym_STAR] = ACTIONS(2206),
    [anon_sym_SLASH] = ACTIONS(2206),
    [anon_sym_PERCENT] = ACTIONS(2206),
    [anon_sym_PIPE_PIPE] = ACTIONS(2208),
    [anon_sym_AMP_AMP] = ACTIONS(2208),
    [anon_sym_PIPE] = ACTIONS(2206),
    [anon_sym_CARET] = ACTIONS(2206),
    [anon_sym_AMP] = ACTIONS(2206),
    [anon_sym_EQ_EQ] = ACTIONS(2208),
    [anon_sym_BANG_EQ] = ACTIONS(2208),
    [anon_sym_GT] = ACTIONS(2206),
    [anon_sym_GT_EQ] = ACTIONS(2208),
    [anon_sym_LT_EQ] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2206),
    [anon_sym_LT_LT] = ACTIONS(2206),
    [anon_sym_GT_GT] = ACTIONS(2206),
    [anon_sym_SEMI] = ACTIONS(2208),
    [anon_sym___extension__] = ACTIONS(2206),
    [anon_sym_in] = ACTIONS(2206),
    [anon_sym_out] = ACTIONS(2206),
    [anon_sym_inout] = ACTIONS(2206),
    [anon_sym_extern] = ACTIONS(2206),
    [anon_sym___attribute__] = ACTIONS(2206),
    [anon_sym_COLON_COLON] = ACTIONS(2208),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2208),
    [anon_sym___declspec] = ACTIONS(2206),
    [anon_sym___based] = ACTIONS(2206),
    [anon_sym___cdecl] = ACTIONS(2206),
    [anon_sym___clrcall] = ACTIONS(2206),
    [anon_sym___stdcall] = ACTIONS(2206),
    [anon_sym___fastcall] = ACTIONS(2206),
    [anon_sym___thiscall] = ACTIONS(2206),
    [anon_sym___vectorcall] = ACTIONS(2206),
    [anon_sym_LBRACE] = ACTIONS(2208),
    [anon_sym_RBRACE] = ACTIONS(2208),
    [anon_sym_LBRACK] = ACTIONS(2206),
    [anon_sym_static] = ACTIONS(2206),
    [anon_sym_EQ] = ACTIONS(2206),
    [anon_sym_register] = ACTIONS(2206),
    [anon_sym_inline] = ACTIONS(2206),
    [anon_sym___inline] = ACTIONS(2206),
    [anon_sym___inline__] = ACTIONS(2206),
    [anon_sym___forceinline] = ACTIONS(2206),
    [anon_sym_thread_local] = ACTIONS(2206),
    [anon_sym___thread] = ACTIONS(2206),
    [anon_sym_const] = ACTIONS(2206),
    [anon_sym_constexpr] = ACTIONS(2206),
    [anon_sym_volatile] = ACTIONS(2206),
    [anon_sym_restrict] = ACTIONS(2206),
    [anon_sym___restrict__] = ACTIONS(2206),
    [anon_sym__Atomic] = ACTIONS(2206),
    [anon_sym__Noreturn] = ACTIONS(2206),
    [anon_sym_noreturn] = ACTIONS(2206),
    [anon_sym_mutable] = ACTIONS(2206),
    [anon_sym_constinit] = ACTIONS(2206),
    [anon_sym_consteval] = ACTIONS(2206),
    [anon_sym_alignas] = ACTIONS(2206),
    [anon_sym__Alignas] = ACTIONS(2206),
    [anon_sym_QMARK] = ACTIONS(2208),
    [anon_sym_STAR_EQ] = ACTIONS(2208),
    [anon_sym_SLASH_EQ] = ACTIONS(2208),
    [anon_sym_PERCENT_EQ] = ACTIONS(2208),
    [anon_sym_PLUS_EQ] = ACTIONS(2208),
    [anon_sym_DASH_EQ] = ACTIONS(2208),
    [anon_sym_LT_LT_EQ] = ACTIONS(2208),
    [anon_sym_GT_GT_EQ] = ACTIONS(2208),
    [anon_sym_AMP_EQ] = ACTIONS(2208),
    [anon_sym_CARET_EQ] = ACTIONS(2208),
    [anon_sym_PIPE_EQ] = ACTIONS(2208),
    [anon_sym_and_eq] = ACTIONS(2206),
    [anon_sym_or_eq] = ACTIONS(2206),
    [anon_sym_xor_eq] = ACTIONS(2206),
    [anon_sym_LT_EQ_GT] = ACTIONS(2208),
    [anon_sym_or] = ACTIONS(2206),
    [anon_sym_and] = ACTIONS(2206),
    [anon_sym_bitor] = ACTIONS(2206),
    [anon_sym_xor] = ACTIONS(2206),
    [anon_sym_bitand] = ACTIONS(2206),
    [anon_sym_not_eq] = ACTIONS(2206),
    [anon_sym_is] = ACTIONS(2206),
    [anon_sym_as] = ACTIONS(2206),
    [anon_sym_DASH_DASH] = ACTIONS(2208),
    [anon_sym_PLUS_PLUS] = ACTIONS(2208),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_DOT_STAR] = ACTIONS(2208),
    [anon_sym_DASH_GT] = ACTIONS(2208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2206),
    [anon_sym_let] = ACTIONS(2206),
    [anon_sym_This] = ACTIONS(2206),
    [anon_sym_decltype] = ACTIONS(2206),
    [sym_virtual] = ACTIONS(2206),
    [anon_sym_template] = ACTIONS(2206),
    [anon_sym_operator] = ACTIONS(2206),
    [anon_sym_precise] = ACTIONS(2206),
    [anon_sym_shared] = ACTIONS(2206),
    [anon_sym_groupshared] = ACTIONS(2206),
    [anon_sym_uniform] = ACTIONS(2206),
    [anon_sym_row_major] = ACTIONS(2206),
    [anon_sym_column_major] = ACTIONS(2206),
    [anon_sym_globallycoherent] = ACTIONS(2206),
    [anon_sym_centroid] = ACTIONS(2206),
    [anon_sym_noperspective] = ACTIONS(2206),
    [anon_sym_nointerpolation] = ACTIONS(2206),
    [anon_sym_sample] = ACTIONS(2206),
    [anon_sym_linear] = ACTIONS(2206),
    [anon_sym_snorm] = ACTIONS(2206),
    [anon_sym_unorm] = ACTIONS(2206),
    [anon_sym_point] = ACTIONS(2206),
    [anon_sym_line] = ACTIONS(2206),
    [anon_sym_triangleadj] = ACTIONS(2206),
    [anon_sym_lineadj] = ACTIONS(2206),
    [anon_sym_triangle] = ACTIONS(2206),
  },
  [1364] = {
    [sym_identifier] = ACTIONS(2236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2238),
    [anon_sym_COMMA] = ACTIONS(2238),
    [anon_sym_RPAREN] = ACTIONS(2238),
    [anon_sym_LPAREN2] = ACTIONS(2238),
    [anon_sym_TILDE] = ACTIONS(2238),
    [anon_sym_DASH] = ACTIONS(2236),
    [anon_sym_PLUS] = ACTIONS(2236),
    [anon_sym_STAR] = ACTIONS(2236),
    [anon_sym_SLASH] = ACTIONS(2236),
    [anon_sym_PERCENT] = ACTIONS(2236),
    [anon_sym_PIPE_PIPE] = ACTIONS(2238),
    [anon_sym_AMP_AMP] = ACTIONS(2238),
    [anon_sym_PIPE] = ACTIONS(2236),
    [anon_sym_CARET] = ACTIONS(2236),
    [anon_sym_AMP] = ACTIONS(2236),
    [anon_sym_EQ_EQ] = ACTIONS(2238),
    [anon_sym_BANG_EQ] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2236),
    [anon_sym_GT_EQ] = ACTIONS(2238),
    [anon_sym_LT_EQ] = ACTIONS(2236),
    [anon_sym_LT] = ACTIONS(2236),
    [anon_sym_LT_LT] = ACTIONS(2236),
    [anon_sym_GT_GT] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(2238),
    [anon_sym___extension__] = ACTIONS(2236),
    [anon_sym_in] = ACTIONS(2236),
    [anon_sym_out] = ACTIONS(2236),
    [anon_sym_inout] = ACTIONS(2236),
    [anon_sym_extern] = ACTIONS(2236),
    [anon_sym___attribute__] = ACTIONS(2236),
    [anon_sym_COLON_COLON] = ACTIONS(2238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2238),
    [anon_sym___declspec] = ACTIONS(2236),
    [anon_sym___based] = ACTIONS(2236),
    [anon_sym___cdecl] = ACTIONS(2236),
    [anon_sym___clrcall] = ACTIONS(2236),
    [anon_sym___stdcall] = ACTIONS(2236),
    [anon_sym___fastcall] = ACTIONS(2236),
    [anon_sym___thiscall] = ACTIONS(2236),
    [anon_sym___vectorcall] = ACTIONS(2236),
    [anon_sym_LBRACE] = ACTIONS(2238),
    [anon_sym_RBRACE] = ACTIONS(2238),
    [anon_sym_LBRACK] = ACTIONS(2236),
    [anon_sym_static] = ACTIONS(2236),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_register] = ACTIONS(2236),
    [anon_sym_inline] = ACTIONS(2236),
    [anon_sym___inline] = ACTIONS(2236),
    [anon_sym___inline__] = ACTIONS(2236),
    [anon_sym___forceinline] = ACTIONS(2236),
    [anon_sym_thread_local] = ACTIONS(2236),
    [anon_sym___thread] = ACTIONS(2236),
    [anon_sym_const] = ACTIONS(2236),
    [anon_sym_constexpr] = ACTIONS(2236),
    [anon_sym_volatile] = ACTIONS(2236),
    [anon_sym_restrict] = ACTIONS(2236),
    [anon_sym___restrict__] = ACTIONS(2236),
    [anon_sym__Atomic] = ACTIONS(2236),
    [anon_sym__Noreturn] = ACTIONS(2236),
    [anon_sym_noreturn] = ACTIONS(2236),
    [anon_sym_mutable] = ACTIONS(2236),
    [anon_sym_constinit] = ACTIONS(2236),
    [anon_sym_consteval] = ACTIONS(2236),
    [anon_sym_alignas] = ACTIONS(2236),
    [anon_sym__Alignas] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2238),
    [anon_sym_SLASH_EQ] = ACTIONS(2238),
    [anon_sym_PERCENT_EQ] = ACTIONS(2238),
    [anon_sym_PLUS_EQ] = ACTIONS(2238),
    [anon_sym_DASH_EQ] = ACTIONS(2238),
    [anon_sym_LT_LT_EQ] = ACTIONS(2238),
    [anon_sym_GT_GT_EQ] = ACTIONS(2238),
    [anon_sym_AMP_EQ] = ACTIONS(2238),
    [anon_sym_CARET_EQ] = ACTIONS(2238),
    [anon_sym_PIPE_EQ] = ACTIONS(2238),
    [anon_sym_and_eq] = ACTIONS(2236),
    [anon_sym_or_eq] = ACTIONS(2236),
    [anon_sym_xor_eq] = ACTIONS(2236),
    [anon_sym_LT_EQ_GT] = ACTIONS(2238),
    [anon_sym_or] = ACTIONS(2236),
    [anon_sym_and] = ACTIONS(2236),
    [anon_sym_bitor] = ACTIONS(2236),
    [anon_sym_xor] = ACTIONS(2236),
    [anon_sym_bitand] = ACTIONS(2236),
    [anon_sym_not_eq] = ACTIONS(2236),
    [anon_sym_is] = ACTIONS(2236),
    [anon_sym_as] = ACTIONS(2236),
    [anon_sym_DASH_DASH] = ACTIONS(2238),
    [anon_sym_PLUS_PLUS] = ACTIONS(2238),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_DOT_STAR] = ACTIONS(2238),
    [anon_sym_DASH_GT] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2236),
    [anon_sym_let] = ACTIONS(2236),
    [anon_sym_This] = ACTIONS(2236),
    [anon_sym_decltype] = ACTIONS(2236),
    [sym_virtual] = ACTIONS(2236),
    [anon_sym_template] = ACTIONS(2236),
    [anon_sym_operator] = ACTIONS(2236),
    [anon_sym_precise] = ACTIONS(2236),
    [anon_sym_shared] = ACTIONS(2236),
    [anon_sym_groupshared] = ACTIONS(2236),
    [anon_sym_uniform] = ACTIONS(2236),
    [anon_sym_row_major] = ACTIONS(2236),
    [anon_sym_column_major] = ACTIONS(2236),
    [anon_sym_globallycoherent] = ACTIONS(2236),
    [anon_sym_centroid] = ACTIONS(2236),
    [anon_sym_noperspective] = ACTIONS(2236),
    [anon_sym_nointerpolation] = ACTIONS(2236),
    [anon_sym_sample] = ACTIONS(2236),
    [anon_sym_linear] = ACTIONS(2236),
    [anon_sym_snorm] = ACTIONS(2236),
    [anon_sym_unorm] = ACTIONS(2236),
    [anon_sym_point] = ACTIONS(2236),
    [anon_sym_line] = ACTIONS(2236),
    [anon_sym_triangleadj] = ACTIONS(2236),
    [anon_sym_lineadj] = ACTIONS(2236),
    [anon_sym_triangle] = ACTIONS(2236),
  },
  [1365] = {
    [sym__declaration_modifiers] = STATE(2299),
    [sym__declaration_specifiers] = STATE(4856),
    [sym_attribute_specifier] = STATE(2299),
    [sym_attribute_declaration] = STATE(2299),
    [sym_ms_declspec_modifier] = STATE(2299),
    [sym_ms_call_modifier] = STATE(7492),
    [sym__abstract_declarator] = STATE(8547),
    [sym_abstract_parenthesized_declarator] = STATE(7128),
    [sym_abstract_pointer_declarator] = STATE(7128),
    [sym_abstract_function_declarator] = STATE(7128),
    [sym_abstract_array_declarator] = STATE(7128),
    [sym_storage_class_specifier] = STATE(2299),
    [sym_type_qualifier] = STATE(2299),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2694),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_parameter_list] = STATE(4322),
    [sym_parameter_declaration] = STATE(9475),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_optional_parameter_declaration] = STATE(9475),
    [sym_variadic_parameter_declaration] = STATE(9475),
    [sym_abstract_reference_declarator] = STATE(7128),
    [sym__function_declarator_seq] = STATE(7135),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8090),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2299),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2299),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(5014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4879),
    [anon_sym_RPAREN] = ACTIONS(4881),
    [anon_sym_LPAREN2] = ACTIONS(5016),
    [anon_sym_STAR] = ACTIONS(5018),
    [anon_sym_AMP_AMP] = ACTIONS(5020),
    [anon_sym_AMP] = ACTIONS(5022),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_out] = ACTIONS(2293),
    [anon_sym_inout] = ACTIONS(2293),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(5024),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(2764),
    [anon_sym___clrcall] = ACTIONS(2764),
    [anon_sym___stdcall] = ACTIONS(2764),
    [anon_sym___fastcall] = ACTIONS(2764),
    [anon_sym___thiscall] = ACTIONS(2764),
    [anon_sym___vectorcall] = ACTIONS(2764),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(5026),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2299),
    [anon_sym_class] = ACTIONS(2301),
    [anon_sym_struct] = ACTIONS(2303),
    [anon_sym_union] = ACTIONS(2305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(2293),
    [anon_sym_typename] = ACTIONS(2329),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2341),
    [anon_sym_extension] = ACTIONS(2343),
  },
  [1366] = {
    [sym_identifier] = ACTIONS(2190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2192),
    [anon_sym_COMMA] = ACTIONS(2192),
    [anon_sym_RPAREN] = ACTIONS(2192),
    [anon_sym_LPAREN2] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2190),
    [anon_sym_PLUS] = ACTIONS(2190),
    [anon_sym_STAR] = ACTIONS(2190),
    [anon_sym_SLASH] = ACTIONS(2190),
    [anon_sym_PERCENT] = ACTIONS(2190),
    [anon_sym_PIPE_PIPE] = ACTIONS(2192),
    [anon_sym_AMP_AMP] = ACTIONS(2192),
    [anon_sym_PIPE] = ACTIONS(2190),
    [anon_sym_CARET] = ACTIONS(2190),
    [anon_sym_AMP] = ACTIONS(2190),
    [anon_sym_EQ_EQ] = ACTIONS(2192),
    [anon_sym_BANG_EQ] = ACTIONS(2192),
    [anon_sym_GT] = ACTIONS(2190),
    [anon_sym_GT_EQ] = ACTIONS(2192),
    [anon_sym_LT_EQ] = ACTIONS(2190),
    [anon_sym_LT] = ACTIONS(2190),
    [anon_sym_LT_LT] = ACTIONS(2190),
    [anon_sym_GT_GT] = ACTIONS(2190),
    [anon_sym_SEMI] = ACTIONS(2192),
    [anon_sym___extension__] = ACTIONS(2190),
    [anon_sym_in] = ACTIONS(2190),
    [anon_sym_out] = ACTIONS(2190),
    [anon_sym_inout] = ACTIONS(2190),
    [anon_sym_extern] = ACTIONS(2190),
    [anon_sym___attribute__] = ACTIONS(2190),
    [anon_sym_COLON_COLON] = ACTIONS(2192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2192),
    [anon_sym___declspec] = ACTIONS(2190),
    [anon_sym___based] = ACTIONS(2190),
    [anon_sym___cdecl] = ACTIONS(2190),
    [anon_sym___clrcall] = ACTIONS(2190),
    [anon_sym___stdcall] = ACTIONS(2190),
    [anon_sym___fastcall] = ACTIONS(2190),
    [anon_sym___thiscall] = ACTIONS(2190),
    [anon_sym___vectorcall] = ACTIONS(2190),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [anon_sym_RBRACE] = ACTIONS(2192),
    [anon_sym_LBRACK] = ACTIONS(2190),
    [anon_sym_static] = ACTIONS(2190),
    [anon_sym_EQ] = ACTIONS(2190),
    [anon_sym_register] = ACTIONS(2190),
    [anon_sym_inline] = ACTIONS(2190),
    [anon_sym___inline] = ACTIONS(2190),
    [anon_sym___inline__] = ACTIONS(2190),
    [anon_sym___forceinline] = ACTIONS(2190),
    [anon_sym_thread_local] = ACTIONS(2190),
    [anon_sym___thread] = ACTIONS(2190),
    [anon_sym_const] = ACTIONS(2190),
    [anon_sym_constexpr] = ACTIONS(2190),
    [anon_sym_volatile] = ACTIONS(2190),
    [anon_sym_restrict] = ACTIONS(2190),
    [anon_sym___restrict__] = ACTIONS(2190),
    [anon_sym__Atomic] = ACTIONS(2190),
    [anon_sym__Noreturn] = ACTIONS(2190),
    [anon_sym_noreturn] = ACTIONS(2190),
    [anon_sym_mutable] = ACTIONS(2190),
    [anon_sym_constinit] = ACTIONS(2190),
    [anon_sym_consteval] = ACTIONS(2190),
    [anon_sym_alignas] = ACTIONS(2190),
    [anon_sym__Alignas] = ACTIONS(2190),
    [anon_sym_QMARK] = ACTIONS(2192),
    [anon_sym_STAR_EQ] = ACTIONS(2192),
    [anon_sym_SLASH_EQ] = ACTIONS(2192),
    [anon_sym_PERCENT_EQ] = ACTIONS(2192),
    [anon_sym_PLUS_EQ] = ACTIONS(2192),
    [anon_sym_DASH_EQ] = ACTIONS(2192),
    [anon_sym_LT_LT_EQ] = ACTIONS(2192),
    [anon_sym_GT_GT_EQ] = ACTIONS(2192),
    [anon_sym_AMP_EQ] = ACTIONS(2192),
    [anon_sym_CARET_EQ] = ACTIONS(2192),
    [anon_sym_PIPE_EQ] = ACTIONS(2192),
    [anon_sym_and_eq] = ACTIONS(2190),
    [anon_sym_or_eq] = ACTIONS(2190),
    [anon_sym_xor_eq] = ACTIONS(2190),
    [anon_sym_LT_EQ_GT] = ACTIONS(2192),
    [anon_sym_or] = ACTIONS(2190),
    [anon_sym_and] = ACTIONS(2190),
    [anon_sym_bitor] = ACTIONS(2190),
    [anon_sym_xor] = ACTIONS(2190),
    [anon_sym_bitand] = ACTIONS(2190),
    [anon_sym_not_eq] = ACTIONS(2190),
    [anon_sym_is] = ACTIONS(2190),
    [anon_sym_as] = ACTIONS(2190),
    [anon_sym_DASH_DASH] = ACTIONS(2192),
    [anon_sym_PLUS_PLUS] = ACTIONS(2192),
    [anon_sym_DOT] = ACTIONS(2190),
    [anon_sym_DOT_STAR] = ACTIONS(2192),
    [anon_sym_DASH_GT] = ACTIONS(2192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2190),
    [anon_sym_let] = ACTIONS(2190),
    [anon_sym_This] = ACTIONS(2190),
    [anon_sym_decltype] = ACTIONS(2190),
    [sym_virtual] = ACTIONS(2190),
    [anon_sym_template] = ACTIONS(2190),
    [anon_sym_operator] = ACTIONS(2190),
    [anon_sym_precise] = ACTIONS(2190),
    [anon_sym_shared] = ACTIONS(2190),
    [anon_sym_groupshared] = ACTIONS(2190),
    [anon_sym_uniform] = ACTIONS(2190),
    [anon_sym_row_major] = ACTIONS(2190),
    [anon_sym_column_major] = ACTIONS(2190),
    [anon_sym_globallycoherent] = ACTIONS(2190),
    [anon_sym_centroid] = ACTIONS(2190),
    [anon_sym_noperspective] = ACTIONS(2190),
    [anon_sym_nointerpolation] = ACTIONS(2190),
    [anon_sym_sample] = ACTIONS(2190),
    [anon_sym_linear] = ACTIONS(2190),
    [anon_sym_snorm] = ACTIONS(2190),
    [anon_sym_unorm] = ACTIONS(2190),
    [anon_sym_point] = ACTIONS(2190),
    [anon_sym_line] = ACTIONS(2190),
    [anon_sym_triangleadj] = ACTIONS(2190),
    [anon_sym_lineadj] = ACTIONS(2190),
    [anon_sym_triangle] = ACTIONS(2190),
  },
  [1367] = {
    [sym_identifier] = ACTIONS(2194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2196),
    [anon_sym_COMMA] = ACTIONS(2196),
    [anon_sym_RPAREN] = ACTIONS(2196),
    [anon_sym_LPAREN2] = ACTIONS(2196),
    [anon_sym_TILDE] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2194),
    [anon_sym_PLUS] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(2194),
    [anon_sym_SLASH] = ACTIONS(2194),
    [anon_sym_PERCENT] = ACTIONS(2194),
    [anon_sym_PIPE_PIPE] = ACTIONS(2196),
    [anon_sym_AMP_AMP] = ACTIONS(2196),
    [anon_sym_PIPE] = ACTIONS(2194),
    [anon_sym_CARET] = ACTIONS(2194),
    [anon_sym_AMP] = ACTIONS(2194),
    [anon_sym_EQ_EQ] = ACTIONS(2196),
    [anon_sym_BANG_EQ] = ACTIONS(2196),
    [anon_sym_GT] = ACTIONS(2194),
    [anon_sym_GT_EQ] = ACTIONS(2196),
    [anon_sym_LT_EQ] = ACTIONS(2194),
    [anon_sym_LT] = ACTIONS(2194),
    [anon_sym_LT_LT] = ACTIONS(2194),
    [anon_sym_GT_GT] = ACTIONS(2194),
    [anon_sym_SEMI] = ACTIONS(2196),
    [anon_sym___extension__] = ACTIONS(2194),
    [anon_sym_in] = ACTIONS(2194),
    [anon_sym_out] = ACTIONS(2194),
    [anon_sym_inout] = ACTIONS(2194),
    [anon_sym_extern] = ACTIONS(2194),
    [anon_sym___attribute__] = ACTIONS(2194),
    [anon_sym_COLON_COLON] = ACTIONS(2196),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2196),
    [anon_sym___declspec] = ACTIONS(2194),
    [anon_sym___based] = ACTIONS(2194),
    [anon_sym___cdecl] = ACTIONS(2194),
    [anon_sym___clrcall] = ACTIONS(2194),
    [anon_sym___stdcall] = ACTIONS(2194),
    [anon_sym___fastcall] = ACTIONS(2194),
    [anon_sym___thiscall] = ACTIONS(2194),
    [anon_sym___vectorcall] = ACTIONS(2194),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_RBRACE] = ACTIONS(2196),
    [anon_sym_LBRACK] = ACTIONS(2194),
    [anon_sym_static] = ACTIONS(2194),
    [anon_sym_EQ] = ACTIONS(2194),
    [anon_sym_register] = ACTIONS(2194),
    [anon_sym_inline] = ACTIONS(2194),
    [anon_sym___inline] = ACTIONS(2194),
    [anon_sym___inline__] = ACTIONS(2194),
    [anon_sym___forceinline] = ACTIONS(2194),
    [anon_sym_thread_local] = ACTIONS(2194),
    [anon_sym___thread] = ACTIONS(2194),
    [anon_sym_const] = ACTIONS(2194),
    [anon_sym_constexpr] = ACTIONS(2194),
    [anon_sym_volatile] = ACTIONS(2194),
    [anon_sym_restrict] = ACTIONS(2194),
    [anon_sym___restrict__] = ACTIONS(2194),
    [anon_sym__Atomic] = ACTIONS(2194),
    [anon_sym__Noreturn] = ACTIONS(2194),
    [anon_sym_noreturn] = ACTIONS(2194),
    [anon_sym_mutable] = ACTIONS(2194),
    [anon_sym_constinit] = ACTIONS(2194),
    [anon_sym_consteval] = ACTIONS(2194),
    [anon_sym_alignas] = ACTIONS(2194),
    [anon_sym__Alignas] = ACTIONS(2194),
    [anon_sym_QMARK] = ACTIONS(2196),
    [anon_sym_STAR_EQ] = ACTIONS(2196),
    [anon_sym_SLASH_EQ] = ACTIONS(2196),
    [anon_sym_PERCENT_EQ] = ACTIONS(2196),
    [anon_sym_PLUS_EQ] = ACTIONS(2196),
    [anon_sym_DASH_EQ] = ACTIONS(2196),
    [anon_sym_LT_LT_EQ] = ACTIONS(2196),
    [anon_sym_GT_GT_EQ] = ACTIONS(2196),
    [anon_sym_AMP_EQ] = ACTIONS(2196),
    [anon_sym_CARET_EQ] = ACTIONS(2196),
    [anon_sym_PIPE_EQ] = ACTIONS(2196),
    [anon_sym_and_eq] = ACTIONS(2194),
    [anon_sym_or_eq] = ACTIONS(2194),
    [anon_sym_xor_eq] = ACTIONS(2194),
    [anon_sym_LT_EQ_GT] = ACTIONS(2196),
    [anon_sym_or] = ACTIONS(2194),
    [anon_sym_and] = ACTIONS(2194),
    [anon_sym_bitor] = ACTIONS(2194),
    [anon_sym_xor] = ACTIONS(2194),
    [anon_sym_bitand] = ACTIONS(2194),
    [anon_sym_not_eq] = ACTIONS(2194),
    [anon_sym_is] = ACTIONS(2194),
    [anon_sym_as] = ACTIONS(2194),
    [anon_sym_DASH_DASH] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2196),
    [anon_sym_DOT] = ACTIONS(2194),
    [anon_sym_DOT_STAR] = ACTIONS(2196),
    [anon_sym_DASH_GT] = ACTIONS(2196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2194),
    [anon_sym_let] = ACTIONS(2194),
    [anon_sym_This] = ACTIONS(2194),
    [anon_sym_decltype] = ACTIONS(2194),
    [sym_virtual] = ACTIONS(2194),
    [anon_sym_template] = ACTIONS(2194),
    [anon_sym_operator] = ACTIONS(2194),
    [anon_sym_precise] = ACTIONS(2194),
    [anon_sym_shared] = ACTIONS(2194),
    [anon_sym_groupshared] = ACTIONS(2194),
    [anon_sym_uniform] = ACTIONS(2194),
    [anon_sym_row_major] = ACTIONS(2194),
    [anon_sym_column_major] = ACTIONS(2194),
    [anon_sym_globallycoherent] = ACTIONS(2194),
    [anon_sym_centroid] = ACTIONS(2194),
    [anon_sym_noperspective] = ACTIONS(2194),
    [anon_sym_nointerpolation] = ACTIONS(2194),
    [anon_sym_sample] = ACTIONS(2194),
    [anon_sym_linear] = ACTIONS(2194),
    [anon_sym_snorm] = ACTIONS(2194),
    [anon_sym_unorm] = ACTIONS(2194),
    [anon_sym_point] = ACTIONS(2194),
    [anon_sym_line] = ACTIONS(2194),
    [anon_sym_triangleadj] = ACTIONS(2194),
    [anon_sym_lineadj] = ACTIONS(2194),
    [anon_sym_triangle] = ACTIONS(2194),
  },
  [1368] = {
    [sym_identifier] = ACTIONS(2232),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_COMMA] = ACTIONS(2234),
    [anon_sym_RPAREN] = ACTIONS(2234),
    [anon_sym_LPAREN2] = ACTIONS(2234),
    [anon_sym_TILDE] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2232),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_STAR] = ACTIONS(2232),
    [anon_sym_SLASH] = ACTIONS(2232),
    [anon_sym_PERCENT] = ACTIONS(2232),
    [anon_sym_PIPE_PIPE] = ACTIONS(2234),
    [anon_sym_AMP_AMP] = ACTIONS(2234),
    [anon_sym_PIPE] = ACTIONS(2232),
    [anon_sym_CARET] = ACTIONS(2232),
    [anon_sym_AMP] = ACTIONS(2232),
    [anon_sym_EQ_EQ] = ACTIONS(2234),
    [anon_sym_BANG_EQ] = ACTIONS(2234),
    [anon_sym_GT] = ACTIONS(2232),
    [anon_sym_GT_EQ] = ACTIONS(2234),
    [anon_sym_LT_EQ] = ACTIONS(2232),
    [anon_sym_LT] = ACTIONS(2232),
    [anon_sym_LT_LT] = ACTIONS(2232),
    [anon_sym_GT_GT] = ACTIONS(2232),
    [anon_sym_SEMI] = ACTIONS(2234),
    [anon_sym___extension__] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2232),
    [anon_sym_out] = ACTIONS(2232),
    [anon_sym_inout] = ACTIONS(2232),
    [anon_sym_extern] = ACTIONS(2232),
    [anon_sym___attribute__] = ACTIONS(2232),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2234),
    [anon_sym___declspec] = ACTIONS(2232),
    [anon_sym___based] = ACTIONS(2232),
    [anon_sym___cdecl] = ACTIONS(2232),
    [anon_sym___clrcall] = ACTIONS(2232),
    [anon_sym___stdcall] = ACTIONS(2232),
    [anon_sym___fastcall] = ACTIONS(2232),
    [anon_sym___thiscall] = ACTIONS(2232),
    [anon_sym___vectorcall] = ACTIONS(2232),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_RBRACE] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2232),
    [anon_sym_static] = ACTIONS(2232),
    [anon_sym_EQ] = ACTIONS(2232),
    [anon_sym_register] = ACTIONS(2232),
    [anon_sym_inline] = ACTIONS(2232),
    [anon_sym___inline] = ACTIONS(2232),
    [anon_sym___inline__] = ACTIONS(2232),
    [anon_sym___forceinline] = ACTIONS(2232),
    [anon_sym_thread_local] = ACTIONS(2232),
    [anon_sym___thread] = ACTIONS(2232),
    [anon_sym_const] = ACTIONS(2232),
    [anon_sym_constexpr] = ACTIONS(2232),
    [anon_sym_volatile] = ACTIONS(2232),
    [anon_sym_restrict] = ACTIONS(2232),
    [anon_sym___restrict__] = ACTIONS(2232),
    [anon_sym__Atomic] = ACTIONS(2232),
    [anon_sym__Noreturn] = ACTIONS(2232),
    [anon_sym_noreturn] = ACTIONS(2232),
    [anon_sym_mutable] = ACTIONS(2232),
    [anon_sym_constinit] = ACTIONS(2232),
    [anon_sym_consteval] = ACTIONS(2232),
    [anon_sym_alignas] = ACTIONS(2232),
    [anon_sym__Alignas] = ACTIONS(2232),
    [anon_sym_QMARK] = ACTIONS(2234),
    [anon_sym_STAR_EQ] = ACTIONS(2234),
    [anon_sym_SLASH_EQ] = ACTIONS(2234),
    [anon_sym_PERCENT_EQ] = ACTIONS(2234),
    [anon_sym_PLUS_EQ] = ACTIONS(2234),
    [anon_sym_DASH_EQ] = ACTIONS(2234),
    [anon_sym_LT_LT_EQ] = ACTIONS(2234),
    [anon_sym_GT_GT_EQ] = ACTIONS(2234),
    [anon_sym_AMP_EQ] = ACTIONS(2234),
    [anon_sym_CARET_EQ] = ACTIONS(2234),
    [anon_sym_PIPE_EQ] = ACTIONS(2234),
    [anon_sym_and_eq] = ACTIONS(2232),
    [anon_sym_or_eq] = ACTIONS(2232),
    [anon_sym_xor_eq] = ACTIONS(2232),
    [anon_sym_LT_EQ_GT] = ACTIONS(2234),
    [anon_sym_or] = ACTIONS(2232),
    [anon_sym_and] = ACTIONS(2232),
    [anon_sym_bitor] = ACTIONS(2232),
    [anon_sym_xor] = ACTIONS(2232),
    [anon_sym_bitand] = ACTIONS(2232),
    [anon_sym_not_eq] = ACTIONS(2232),
    [anon_sym_is] = ACTIONS(2232),
    [anon_sym_as] = ACTIONS(2232),
    [anon_sym_DASH_DASH] = ACTIONS(2234),
    [anon_sym_PLUS_PLUS] = ACTIONS(2234),
    [anon_sym_DOT] = ACTIONS(2232),
    [anon_sym_DOT_STAR] = ACTIONS(2234),
    [anon_sym_DASH_GT] = ACTIONS(2234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2232),
    [anon_sym_let] = ACTIONS(2232),
    [anon_sym_This] = ACTIONS(2232),
    [anon_sym_decltype] = ACTIONS(2232),
    [sym_virtual] = ACTIONS(2232),
    [anon_sym_template] = ACTIONS(2232),
    [anon_sym_operator] = ACTIONS(2232),
    [anon_sym_precise] = ACTIONS(2232),
    [anon_sym_shared] = ACTIONS(2232),
    [anon_sym_groupshared] = ACTIONS(2232),
    [anon_sym_uniform] = ACTIONS(2232),
    [anon_sym_row_major] = ACTIONS(2232),
    [anon_sym_column_major] = ACTIONS(2232),
    [anon_sym_globallycoherent] = ACTIONS(2232),
    [anon_sym_centroid] = ACTIONS(2232),
    [anon_sym_noperspective] = ACTIONS(2232),
    [anon_sym_nointerpolation] = ACTIONS(2232),
    [anon_sym_sample] = ACTIONS(2232),
    [anon_sym_linear] = ACTIONS(2232),
    [anon_sym_snorm] = ACTIONS(2232),
    [anon_sym_unorm] = ACTIONS(2232),
    [anon_sym_point] = ACTIONS(2232),
    [anon_sym_line] = ACTIONS(2232),
    [anon_sym_triangleadj] = ACTIONS(2232),
    [anon_sym_lineadj] = ACTIONS(2232),
    [anon_sym_triangle] = ACTIONS(2232),
  },
  [1369] = {
    [sym_identifier] = ACTIONS(2210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2212),
    [anon_sym_COMMA] = ACTIONS(2212),
    [anon_sym_LPAREN2] = ACTIONS(2214),
    [anon_sym_TILDE] = ACTIONS(2217),
    [anon_sym_DASH] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(2222),
    [anon_sym_STAR] = ACTIONS(2219),
    [anon_sym_SLASH] = ACTIONS(2222),
    [anon_sym_PERCENT] = ACTIONS(2222),
    [anon_sym_PIPE_PIPE] = ACTIONS(2212),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2222),
    [anon_sym_CARET] = ACTIONS(2222),
    [anon_sym_AMP] = ACTIONS(2219),
    [anon_sym_EQ_EQ] = ACTIONS(2212),
    [anon_sym_BANG_EQ] = ACTIONS(2212),
    [anon_sym_GT] = ACTIONS(2222),
    [anon_sym_GT_EQ] = ACTIONS(2212),
    [anon_sym_LT_EQ] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(2222),
    [anon_sym_LT_LT] = ACTIONS(2222),
    [anon_sym_GT_GT] = ACTIONS(2222),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym___extension__] = ACTIONS(2210),
    [anon_sym_in] = ACTIONS(2210),
    [anon_sym_out] = ACTIONS(2210),
    [anon_sym_inout] = ACTIONS(2210),
    [anon_sym_extern] = ACTIONS(2210),
    [anon_sym___attribute__] = ACTIONS(2210),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2214),
    [anon_sym___declspec] = ACTIONS(2210),
    [anon_sym___based] = ACTIONS(2210),
    [anon_sym___cdecl] = ACTIONS(2210),
    [anon_sym___clrcall] = ACTIONS(2210),
    [anon_sym___stdcall] = ACTIONS(2210),
    [anon_sym___fastcall] = ACTIONS(2210),
    [anon_sym___thiscall] = ACTIONS(2210),
    [anon_sym___vectorcall] = ACTIONS(2210),
    [anon_sym_LBRACE] = ACTIONS(2217),
    [anon_sym_RBRACE] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_static] = ACTIONS(2210),
    [anon_sym_EQ] = ACTIONS(2222),
    [anon_sym_register] = ACTIONS(2210),
    [anon_sym_inline] = ACTIONS(2210),
    [anon_sym___inline] = ACTIONS(2210),
    [anon_sym___inline__] = ACTIONS(2210),
    [anon_sym___forceinline] = ACTIONS(2210),
    [anon_sym_thread_local] = ACTIONS(2210),
    [anon_sym___thread] = ACTIONS(2210),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_constexpr] = ACTIONS(2210),
    [anon_sym_volatile] = ACTIONS(2210),
    [anon_sym_restrict] = ACTIONS(2210),
    [anon_sym___restrict__] = ACTIONS(2210),
    [anon_sym__Atomic] = ACTIONS(2210),
    [anon_sym__Noreturn] = ACTIONS(2210),
    [anon_sym_noreturn] = ACTIONS(2210),
    [anon_sym_mutable] = ACTIONS(2210),
    [anon_sym_constinit] = ACTIONS(2210),
    [anon_sym_consteval] = ACTIONS(2210),
    [anon_sym_alignas] = ACTIONS(2210),
    [anon_sym__Alignas] = ACTIONS(2210),
    [anon_sym_QMARK] = ACTIONS(2212),
    [anon_sym_STAR_EQ] = ACTIONS(2212),
    [anon_sym_SLASH_EQ] = ACTIONS(2212),
    [anon_sym_PERCENT_EQ] = ACTIONS(2212),
    [anon_sym_PLUS_EQ] = ACTIONS(2212),
    [anon_sym_DASH_EQ] = ACTIONS(2212),
    [anon_sym_LT_LT_EQ] = ACTIONS(2212),
    [anon_sym_GT_GT_EQ] = ACTIONS(2212),
    [anon_sym_AMP_EQ] = ACTIONS(2212),
    [anon_sym_CARET_EQ] = ACTIONS(2212),
    [anon_sym_PIPE_EQ] = ACTIONS(2212),
    [anon_sym_and_eq] = ACTIONS(2222),
    [anon_sym_or_eq] = ACTIONS(2222),
    [anon_sym_xor_eq] = ACTIONS(2222),
    [anon_sym_LT_EQ_GT] = ACTIONS(2212),
    [anon_sym_or] = ACTIONS(2222),
    [anon_sym_and] = ACTIONS(2222),
    [anon_sym_bitor] = ACTIONS(2222),
    [anon_sym_xor] = ACTIONS(2222),
    [anon_sym_bitand] = ACTIONS(2222),
    [anon_sym_not_eq] = ACTIONS(2222),
    [anon_sym_is] = ACTIONS(2222),
    [anon_sym_as] = ACTIONS(2222),
    [anon_sym_DASH_DASH] = ACTIONS(2212),
    [anon_sym_PLUS_PLUS] = ACTIONS(2212),
    [anon_sym_DOT] = ACTIONS(2219),
    [anon_sym_DOT_STAR] = ACTIONS(2212),
    [anon_sym_DASH_GT] = ACTIONS(2212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2210),
    [anon_sym_let] = ACTIONS(2210),
    [anon_sym_This] = ACTIONS(2210),
    [anon_sym_decltype] = ACTIONS(2210),
    [sym_virtual] = ACTIONS(2210),
    [anon_sym_template] = ACTIONS(2210),
    [anon_sym_operator] = ACTIONS(2210),
    [anon_sym_precise] = ACTIONS(2210),
    [anon_sym_shared] = ACTIONS(2210),
    [anon_sym_groupshared] = ACTIONS(2210),
    [anon_sym_uniform] = ACTIONS(2210),
    [anon_sym_row_major] = ACTIONS(2210),
    [anon_sym_column_major] = ACTIONS(2210),
    [anon_sym_globallycoherent] = ACTIONS(2210),
    [anon_sym_centroid] = ACTIONS(2210),
    [anon_sym_noperspective] = ACTIONS(2210),
    [anon_sym_nointerpolation] = ACTIONS(2210),
    [anon_sym_sample] = ACTIONS(2210),
    [anon_sym_linear] = ACTIONS(2210),
    [anon_sym_snorm] = ACTIONS(2210),
    [anon_sym_unorm] = ACTIONS(2210),
    [anon_sym_point] = ACTIONS(2210),
    [anon_sym_line] = ACTIONS(2210),
    [anon_sym_triangleadj] = ACTIONS(2210),
    [anon_sym_lineadj] = ACTIONS(2210),
    [anon_sym_triangle] = ACTIONS(2210),
  },
  [1370] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6418),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8229),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7882),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_parameter_list] = STATE(1086),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(3171),
    [sym_template_function] = STATE(7882),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6830),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(5031),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym_LT] = ACTIONS(5033),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(5035),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(2808),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1371] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6404),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8141),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7882),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_parameter_list] = STATE(1087),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(3171),
    [sym_template_function] = STATE(7882),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6830),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(5031),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym_LT] = ACTIONS(5033),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(5035),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(2808),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1372] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6378),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8142),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7882),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_parameter_list] = STATE(1085),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(3171),
    [sym_template_function] = STATE(7882),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6830),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(5031),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym_LT] = ACTIONS(5033),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(5035),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(2808),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1373] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6388),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8192),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7882),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_parameter_list] = STATE(1088),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(3171),
    [sym_template_function] = STATE(7882),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6830),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(5031),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym_LT] = ACTIONS(5033),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(5035),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(2808),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1374] = {
    [sym_identifier] = ACTIONS(3857),
    [anon_sym_LPAREN2] = ACTIONS(3862),
    [anon_sym_BANG] = ACTIONS(3862),
    [anon_sym_TILDE] = ACTIONS(3862),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_STAR] = ACTIONS(3862),
    [anon_sym_AMP] = ACTIONS(3862),
    [anon_sym___extension__] = ACTIONS(3857),
    [anon_sym_in] = ACTIONS(3857),
    [anon_sym_out] = ACTIONS(3857),
    [anon_sym_inout] = ACTIONS(3857),
    [anon_sym_extern] = ACTIONS(3857),
    [anon_sym___attribute__] = ACTIONS(3857),
    [anon_sym_COLON_COLON] = ACTIONS(3862),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3862),
    [anon_sym___declspec] = ACTIONS(3857),
    [anon_sym_signed] = ACTIONS(3857),
    [anon_sym_unsigned] = ACTIONS(3857),
    [anon_sym_long] = ACTIONS(3857),
    [anon_sym_short] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(3857),
    [anon_sym_static] = ACTIONS(3857),
    [anon_sym_register] = ACTIONS(3857),
    [anon_sym_inline] = ACTIONS(3857),
    [anon_sym___inline] = ACTIONS(3857),
    [anon_sym___inline__] = ACTIONS(3857),
    [anon_sym___forceinline] = ACTIONS(3857),
    [anon_sym_thread_local] = ACTIONS(3857),
    [anon_sym___thread] = ACTIONS(3857),
    [anon_sym_const] = ACTIONS(3857),
    [anon_sym_constexpr] = ACTIONS(3857),
    [anon_sym_volatile] = ACTIONS(3857),
    [anon_sym_restrict] = ACTIONS(3857),
    [anon_sym___restrict__] = ACTIONS(3857),
    [anon_sym__Atomic] = ACTIONS(3857),
    [anon_sym__Noreturn] = ACTIONS(3857),
    [anon_sym_noreturn] = ACTIONS(3857),
    [anon_sym_mutable] = ACTIONS(3857),
    [anon_sym_constinit] = ACTIONS(3857),
    [anon_sym_consteval] = ACTIONS(3857),
    [anon_sym_alignas] = ACTIONS(3857),
    [anon_sym__Alignas] = ACTIONS(3857),
    [sym_primitive_type] = ACTIONS(3857),
    [anon_sym_enum] = ACTIONS(3857),
    [anon_sym_class] = ACTIONS(3857),
    [anon_sym_struct] = ACTIONS(3857),
    [anon_sym_union] = ACTIONS(3857),
    [anon_sym_not] = ACTIONS(3857),
    [anon_sym_compl] = ACTIONS(3857),
    [anon_sym_DASH_DASH] = ACTIONS(3862),
    [anon_sym_PLUS_PLUS] = ACTIONS(3862),
    [anon_sym_sizeof] = ACTIONS(3857),
    [anon_sym___alignof__] = ACTIONS(3857),
    [anon_sym___alignof] = ACTIONS(3857),
    [anon_sym__alignof] = ACTIONS(3857),
    [anon_sym_alignof] = ACTIONS(3857),
    [anon_sym__Alignof] = ACTIONS(3857),
    [anon_sym_offsetof] = ACTIONS(3857),
    [anon_sym__Generic] = ACTIONS(3857),
    [anon_sym_asm] = ACTIONS(3857),
    [anon_sym___asm__] = ACTIONS(3857),
    [sym_number_literal] = ACTIONS(3862),
    [anon_sym_L_SQUOTE] = ACTIONS(3862),
    [anon_sym_u_SQUOTE] = ACTIONS(3862),
    [anon_sym_U_SQUOTE] = ACTIONS(3862),
    [anon_sym_u8_SQUOTE] = ACTIONS(3862),
    [anon_sym_SQUOTE] = ACTIONS(3862),
    [anon_sym_L_DQUOTE] = ACTIONS(3862),
    [anon_sym_u_DQUOTE] = ACTIONS(3862),
    [anon_sym_U_DQUOTE] = ACTIONS(3862),
    [anon_sym_u8_DQUOTE] = ACTIONS(3862),
    [anon_sym_DQUOTE] = ACTIONS(3862),
    [sym_true] = ACTIONS(3857),
    [sym_false] = ACTIONS(3857),
    [anon_sym_NULL] = ACTIONS(3857),
    [anon_sym_nullptr] = ACTIONS(3857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3857),
    [anon_sym_let] = ACTIONS(3857),
    [anon_sym_This] = ACTIONS(3857),
    [anon_sym_decltype] = ACTIONS(3857),
    [sym_virtual] = ACTIONS(3857),
    [anon_sym_typename] = ACTIONS(3857),
    [anon_sym_template] = ACTIONS(3857),
    [anon_sym_delete] = ACTIONS(3857),
    [anon_sym_R_DQUOTE] = ACTIONS(3862),
    [anon_sym_LR_DQUOTE] = ACTIONS(3862),
    [anon_sym_uR_DQUOTE] = ACTIONS(3862),
    [anon_sym_UR_DQUOTE] = ACTIONS(3862),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3862),
    [anon_sym_co_await] = ACTIONS(3857),
    [anon_sym_new] = ACTIONS(3857),
    [anon_sym_requires] = ACTIONS(3857),
    [sym_this] = ACTIONS(3857),
    [anon_sym_precise] = ACTIONS(3857),
    [anon_sym_shared] = ACTIONS(3857),
    [anon_sym_groupshared] = ACTIONS(3857),
    [anon_sym_uniform] = ACTIONS(3857),
    [anon_sym_row_major] = ACTIONS(3857),
    [anon_sym_column_major] = ACTIONS(3857),
    [anon_sym_globallycoherent] = ACTIONS(3857),
    [anon_sym_centroid] = ACTIONS(3857),
    [anon_sym_noperspective] = ACTIONS(3857),
    [anon_sym_nointerpolation] = ACTIONS(3857),
    [anon_sym_sample] = ACTIONS(3857),
    [anon_sym_linear] = ACTIONS(3857),
    [anon_sym_snorm] = ACTIONS(3857),
    [anon_sym_unorm] = ACTIONS(3857),
    [anon_sym_point] = ACTIONS(3857),
    [anon_sym_line] = ACTIONS(3857),
    [anon_sym_triangleadj] = ACTIONS(3857),
    [anon_sym_lineadj] = ACTIONS(3857),
    [anon_sym_triangle] = ACTIONS(3857),
    [anon_sym_interface] = ACTIONS(3857),
    [anon_sym_extension] = ACTIONS(3857),
  },
  [1375] = {
    [sym_template_argument_list] = STATE(1393),
    [sym_identifier] = ACTIONS(2169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2173),
    [anon_sym_COMMA] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(2173),
    [anon_sym_LPAREN2] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2171),
    [anon_sym_AMP_AMP] = ACTIONS(2173),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2171),
    [anon_sym_BANG_EQ] = ACTIONS(2171),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2171),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(5037),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(2169),
    [anon_sym___extension__] = ACTIONS(2169),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_out] = ACTIONS(2169),
    [anon_sym_inout] = ACTIONS(2169),
    [anon_sym_extern] = ACTIONS(2169),
    [anon_sym___attribute__] = ACTIONS(2169),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2176),
    [anon_sym___declspec] = ACTIONS(2169),
    [anon_sym___based] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2176),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2169),
    [anon_sym_EQ] = ACTIONS(2178),
    [anon_sym_register] = ACTIONS(2169),
    [anon_sym_inline] = ACTIONS(2169),
    [anon_sym___inline] = ACTIONS(2169),
    [anon_sym___inline__] = ACTIONS(2169),
    [anon_sym___forceinline] = ACTIONS(2169),
    [anon_sym_thread_local] = ACTIONS(2169),
    [anon_sym___thread] = ACTIONS(2169),
    [anon_sym_const] = ACTIONS(2169),
    [anon_sym_constexpr] = ACTIONS(2169),
    [anon_sym_volatile] = ACTIONS(2169),
    [anon_sym_restrict] = ACTIONS(2169),
    [anon_sym___restrict__] = ACTIONS(2169),
    [anon_sym__Atomic] = ACTIONS(2169),
    [anon_sym__Noreturn] = ACTIONS(2169),
    [anon_sym_noreturn] = ACTIONS(2169),
    [anon_sym_mutable] = ACTIONS(2169),
    [anon_sym_constinit] = ACTIONS(2169),
    [anon_sym_consteval] = ACTIONS(2169),
    [anon_sym_alignas] = ACTIONS(2169),
    [anon_sym__Alignas] = ACTIONS(2169),
    [anon_sym_QMARK] = ACTIONS(2171),
    [anon_sym_STAR_EQ] = ACTIONS(2171),
    [anon_sym_SLASH_EQ] = ACTIONS(2171),
    [anon_sym_PERCENT_EQ] = ACTIONS(2171),
    [anon_sym_PLUS_EQ] = ACTIONS(2171),
    [anon_sym_DASH_EQ] = ACTIONS(2171),
    [anon_sym_LT_LT_EQ] = ACTIONS(2171),
    [anon_sym_GT_GT_EQ] = ACTIONS(2171),
    [anon_sym_AMP_EQ] = ACTIONS(2171),
    [anon_sym_CARET_EQ] = ACTIONS(2171),
    [anon_sym_PIPE_EQ] = ACTIONS(2171),
    [anon_sym_and_eq] = ACTIONS(2181),
    [anon_sym_or_eq] = ACTIONS(2181),
    [anon_sym_xor_eq] = ACTIONS(2181),
    [anon_sym_LT_EQ_GT] = ACTIONS(2171),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2181),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2181),
    [anon_sym_not_eq] = ACTIONS(2181),
    [anon_sym_is] = ACTIONS(2181),
    [anon_sym_as] = ACTIONS(2181),
    [anon_sym_DASH_DASH] = ACTIONS(2171),
    [anon_sym_PLUS_PLUS] = ACTIONS(2171),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DOT_STAR] = ACTIONS(2171),
    [anon_sym_DASH_GT] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2169),
    [anon_sym_let] = ACTIONS(2169),
    [anon_sym_This] = ACTIONS(2169),
    [anon_sym_decltype] = ACTIONS(2169),
    [sym_virtual] = ACTIONS(2169),
    [anon_sym_template] = ACTIONS(2169),
    [anon_sym_operator] = ACTIONS(2169),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2171),
    [anon_sym_precise] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_groupshared] = ACTIONS(2169),
    [anon_sym_uniform] = ACTIONS(2169),
    [anon_sym_row_major] = ACTIONS(2169),
    [anon_sym_column_major] = ACTIONS(2169),
    [anon_sym_globallycoherent] = ACTIONS(2169),
    [anon_sym_centroid] = ACTIONS(2169),
    [anon_sym_noperspective] = ACTIONS(2169),
    [anon_sym_nointerpolation] = ACTIONS(2169),
    [anon_sym_sample] = ACTIONS(2169),
    [anon_sym_linear] = ACTIONS(2169),
    [anon_sym_snorm] = ACTIONS(2169),
    [anon_sym_unorm] = ACTIONS(2169),
    [anon_sym_point] = ACTIONS(2169),
    [anon_sym_line] = ACTIONS(2169),
    [anon_sym_triangleadj] = ACTIONS(2169),
    [anon_sym_lineadj] = ACTIONS(2169),
    [anon_sym_triangle] = ACTIONS(2169),
  },
  [1376] = {
    [sym_identifier] = ACTIONS(3406),
    [anon_sym_LPAREN2] = ACTIONS(3408),
    [anon_sym_BANG] = ACTIONS(3408),
    [anon_sym_TILDE] = ACTIONS(3408),
    [anon_sym_DASH] = ACTIONS(3406),
    [anon_sym_PLUS] = ACTIONS(3406),
    [anon_sym_STAR] = ACTIONS(3408),
    [anon_sym_AMP] = ACTIONS(3408),
    [anon_sym___extension__] = ACTIONS(3406),
    [anon_sym_in] = ACTIONS(3406),
    [anon_sym_out] = ACTIONS(3406),
    [anon_sym_inout] = ACTIONS(3406),
    [anon_sym_extern] = ACTIONS(3406),
    [anon_sym___attribute__] = ACTIONS(3406),
    [anon_sym_COLON_COLON] = ACTIONS(3408),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3408),
    [anon_sym___declspec] = ACTIONS(3406),
    [anon_sym_signed] = ACTIONS(3406),
    [anon_sym_unsigned] = ACTIONS(3406),
    [anon_sym_long] = ACTIONS(3406),
    [anon_sym_short] = ACTIONS(3406),
    [anon_sym_LBRACK] = ACTIONS(3406),
    [anon_sym_static] = ACTIONS(3406),
    [anon_sym_register] = ACTIONS(3406),
    [anon_sym_inline] = ACTIONS(3406),
    [anon_sym___inline] = ACTIONS(3406),
    [anon_sym___inline__] = ACTIONS(3406),
    [anon_sym___forceinline] = ACTIONS(3406),
    [anon_sym_thread_local] = ACTIONS(3406),
    [anon_sym___thread] = ACTIONS(3406),
    [anon_sym_const] = ACTIONS(3406),
    [anon_sym_constexpr] = ACTIONS(3406),
    [anon_sym_volatile] = ACTIONS(3406),
    [anon_sym_restrict] = ACTIONS(3406),
    [anon_sym___restrict__] = ACTIONS(3406),
    [anon_sym__Atomic] = ACTIONS(3406),
    [anon_sym__Noreturn] = ACTIONS(3406),
    [anon_sym_noreturn] = ACTIONS(3406),
    [anon_sym_mutable] = ACTIONS(3406),
    [anon_sym_constinit] = ACTIONS(3406),
    [anon_sym_consteval] = ACTIONS(3406),
    [anon_sym_alignas] = ACTIONS(3406),
    [anon_sym__Alignas] = ACTIONS(3406),
    [sym_primitive_type] = ACTIONS(3406),
    [anon_sym_enum] = ACTIONS(3406),
    [anon_sym_class] = ACTIONS(3406),
    [anon_sym_struct] = ACTIONS(3406),
    [anon_sym_union] = ACTIONS(3406),
    [anon_sym_not] = ACTIONS(3406),
    [anon_sym_compl] = ACTIONS(3406),
    [anon_sym_DASH_DASH] = ACTIONS(3408),
    [anon_sym_PLUS_PLUS] = ACTIONS(3408),
    [anon_sym_sizeof] = ACTIONS(3406),
    [anon_sym___alignof__] = ACTIONS(3406),
    [anon_sym___alignof] = ACTIONS(3406),
    [anon_sym__alignof] = ACTIONS(3406),
    [anon_sym_alignof] = ACTIONS(3406),
    [anon_sym__Alignof] = ACTIONS(3406),
    [anon_sym_offsetof] = ACTIONS(3406),
    [anon_sym__Generic] = ACTIONS(3406),
    [anon_sym_asm] = ACTIONS(3406),
    [anon_sym___asm__] = ACTIONS(3406),
    [sym_number_literal] = ACTIONS(3408),
    [anon_sym_L_SQUOTE] = ACTIONS(3408),
    [anon_sym_u_SQUOTE] = ACTIONS(3408),
    [anon_sym_U_SQUOTE] = ACTIONS(3408),
    [anon_sym_u8_SQUOTE] = ACTIONS(3408),
    [anon_sym_SQUOTE] = ACTIONS(3408),
    [anon_sym_L_DQUOTE] = ACTIONS(3408),
    [anon_sym_u_DQUOTE] = ACTIONS(3408),
    [anon_sym_U_DQUOTE] = ACTIONS(3408),
    [anon_sym_u8_DQUOTE] = ACTIONS(3408),
    [anon_sym_DQUOTE] = ACTIONS(3408),
    [sym_true] = ACTIONS(3406),
    [sym_false] = ACTIONS(3406),
    [anon_sym_NULL] = ACTIONS(3406),
    [anon_sym_nullptr] = ACTIONS(3406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3406),
    [anon_sym_let] = ACTIONS(3406),
    [anon_sym_This] = ACTIONS(3406),
    [anon_sym_decltype] = ACTIONS(3406),
    [sym_virtual] = ACTIONS(3406),
    [anon_sym_typename] = ACTIONS(3406),
    [anon_sym_template] = ACTIONS(3406),
    [anon_sym_delete] = ACTIONS(3406),
    [anon_sym_R_DQUOTE] = ACTIONS(3408),
    [anon_sym_LR_DQUOTE] = ACTIONS(3408),
    [anon_sym_uR_DQUOTE] = ACTIONS(3408),
    [anon_sym_UR_DQUOTE] = ACTIONS(3408),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3408),
    [anon_sym_co_await] = ACTIONS(3406),
    [anon_sym_new] = ACTIONS(3406),
    [anon_sym_requires] = ACTIONS(3406),
    [sym_this] = ACTIONS(3406),
    [anon_sym_precise] = ACTIONS(3406),
    [anon_sym_shared] = ACTIONS(3406),
    [anon_sym_groupshared] = ACTIONS(3406),
    [anon_sym_uniform] = ACTIONS(3406),
    [anon_sym_row_major] = ACTIONS(3406),
    [anon_sym_column_major] = ACTIONS(3406),
    [anon_sym_globallycoherent] = ACTIONS(3406),
    [anon_sym_centroid] = ACTIONS(3406),
    [anon_sym_noperspective] = ACTIONS(3406),
    [anon_sym_nointerpolation] = ACTIONS(3406),
    [anon_sym_sample] = ACTIONS(3406),
    [anon_sym_linear] = ACTIONS(3406),
    [anon_sym_snorm] = ACTIONS(3406),
    [anon_sym_unorm] = ACTIONS(3406),
    [anon_sym_point] = ACTIONS(3406),
    [anon_sym_line] = ACTIONS(3406),
    [anon_sym_triangleadj] = ACTIONS(3406),
    [anon_sym_lineadj] = ACTIONS(3406),
    [anon_sym_triangle] = ACTIONS(3406),
    [anon_sym_interface] = ACTIONS(3406),
    [anon_sym_extension] = ACTIONS(3406),
  },
  [1377] = {
    [sym_identifier] = ACTIONS(3669),
    [anon_sym_LPAREN2] = ACTIONS(3671),
    [anon_sym_BANG] = ACTIONS(3671),
    [anon_sym_TILDE] = ACTIONS(3671),
    [anon_sym_DASH] = ACTIONS(3669),
    [anon_sym_PLUS] = ACTIONS(3669),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_AMP] = ACTIONS(3671),
    [anon_sym___extension__] = ACTIONS(3669),
    [anon_sym_in] = ACTIONS(3669),
    [anon_sym_out] = ACTIONS(3669),
    [anon_sym_inout] = ACTIONS(3669),
    [anon_sym_extern] = ACTIONS(3669),
    [anon_sym___attribute__] = ACTIONS(3669),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3671),
    [anon_sym___declspec] = ACTIONS(3669),
    [anon_sym_signed] = ACTIONS(3669),
    [anon_sym_unsigned] = ACTIONS(3669),
    [anon_sym_long] = ACTIONS(3669),
    [anon_sym_short] = ACTIONS(3669),
    [anon_sym_LBRACK] = ACTIONS(3669),
    [anon_sym_static] = ACTIONS(3669),
    [anon_sym_register] = ACTIONS(3669),
    [anon_sym_inline] = ACTIONS(3669),
    [anon_sym___inline] = ACTIONS(3669),
    [anon_sym___inline__] = ACTIONS(3669),
    [anon_sym___forceinline] = ACTIONS(3669),
    [anon_sym_thread_local] = ACTIONS(3669),
    [anon_sym___thread] = ACTIONS(3669),
    [anon_sym_const] = ACTIONS(3669),
    [anon_sym_constexpr] = ACTIONS(3669),
    [anon_sym_volatile] = ACTIONS(3669),
    [anon_sym_restrict] = ACTIONS(3669),
    [anon_sym___restrict__] = ACTIONS(3669),
    [anon_sym__Atomic] = ACTIONS(3669),
    [anon_sym__Noreturn] = ACTIONS(3669),
    [anon_sym_noreturn] = ACTIONS(3669),
    [anon_sym_mutable] = ACTIONS(3669),
    [anon_sym_constinit] = ACTIONS(3669),
    [anon_sym_consteval] = ACTIONS(3669),
    [anon_sym_alignas] = ACTIONS(3669),
    [anon_sym__Alignas] = ACTIONS(3669),
    [sym_primitive_type] = ACTIONS(3669),
    [anon_sym_enum] = ACTIONS(3669),
    [anon_sym_class] = ACTIONS(3669),
    [anon_sym_struct] = ACTIONS(3669),
    [anon_sym_union] = ACTIONS(3669),
    [anon_sym_not] = ACTIONS(3669),
    [anon_sym_compl] = ACTIONS(3669),
    [anon_sym_DASH_DASH] = ACTIONS(3671),
    [anon_sym_PLUS_PLUS] = ACTIONS(3671),
    [anon_sym_sizeof] = ACTIONS(3669),
    [anon_sym___alignof__] = ACTIONS(3669),
    [anon_sym___alignof] = ACTIONS(3669),
    [anon_sym__alignof] = ACTIONS(3669),
    [anon_sym_alignof] = ACTIONS(3669),
    [anon_sym__Alignof] = ACTIONS(3669),
    [anon_sym_offsetof] = ACTIONS(3669),
    [anon_sym__Generic] = ACTIONS(3669),
    [anon_sym_asm] = ACTIONS(3669),
    [anon_sym___asm__] = ACTIONS(3669),
    [sym_number_literal] = ACTIONS(3671),
    [anon_sym_L_SQUOTE] = ACTIONS(3671),
    [anon_sym_u_SQUOTE] = ACTIONS(3671),
    [anon_sym_U_SQUOTE] = ACTIONS(3671),
    [anon_sym_u8_SQUOTE] = ACTIONS(3671),
    [anon_sym_SQUOTE] = ACTIONS(3671),
    [anon_sym_L_DQUOTE] = ACTIONS(3671),
    [anon_sym_u_DQUOTE] = ACTIONS(3671),
    [anon_sym_U_DQUOTE] = ACTIONS(3671),
    [anon_sym_u8_DQUOTE] = ACTIONS(3671),
    [anon_sym_DQUOTE] = ACTIONS(3671),
    [sym_true] = ACTIONS(3669),
    [sym_false] = ACTIONS(3669),
    [anon_sym_NULL] = ACTIONS(3669),
    [anon_sym_nullptr] = ACTIONS(3669),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3669),
    [anon_sym_let] = ACTIONS(3669),
    [anon_sym_This] = ACTIONS(3669),
    [anon_sym_decltype] = ACTIONS(3669),
    [sym_virtual] = ACTIONS(3669),
    [anon_sym_typename] = ACTIONS(3669),
    [anon_sym_template] = ACTIONS(3669),
    [anon_sym_delete] = ACTIONS(3669),
    [anon_sym_R_DQUOTE] = ACTIONS(3671),
    [anon_sym_LR_DQUOTE] = ACTIONS(3671),
    [anon_sym_uR_DQUOTE] = ACTIONS(3671),
    [anon_sym_UR_DQUOTE] = ACTIONS(3671),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3671),
    [anon_sym_co_await] = ACTIONS(3669),
    [anon_sym_new] = ACTIONS(3669),
    [anon_sym_requires] = ACTIONS(3669),
    [sym_this] = ACTIONS(3669),
    [anon_sym_precise] = ACTIONS(3669),
    [anon_sym_shared] = ACTIONS(3669),
    [anon_sym_groupshared] = ACTIONS(3669),
    [anon_sym_uniform] = ACTIONS(3669),
    [anon_sym_row_major] = ACTIONS(3669),
    [anon_sym_column_major] = ACTIONS(3669),
    [anon_sym_globallycoherent] = ACTIONS(3669),
    [anon_sym_centroid] = ACTIONS(3669),
    [anon_sym_noperspective] = ACTIONS(3669),
    [anon_sym_nointerpolation] = ACTIONS(3669),
    [anon_sym_sample] = ACTIONS(3669),
    [anon_sym_linear] = ACTIONS(3669),
    [anon_sym_snorm] = ACTIONS(3669),
    [anon_sym_unorm] = ACTIONS(3669),
    [anon_sym_point] = ACTIONS(3669),
    [anon_sym_line] = ACTIONS(3669),
    [anon_sym_triangleadj] = ACTIONS(3669),
    [anon_sym_lineadj] = ACTIONS(3669),
    [anon_sym_triangle] = ACTIONS(3669),
    [anon_sym_interface] = ACTIONS(3669),
    [anon_sym_extension] = ACTIONS(3669),
  },
  [1378] = {
    [sym_identifier] = ACTIONS(2202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_RPAREN] = ACTIONS(2204),
    [anon_sym_LPAREN2] = ACTIONS(2204),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2202),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_STAR] = ACTIONS(2202),
    [anon_sym_SLASH] = ACTIONS(2202),
    [anon_sym_PERCENT] = ACTIONS(2202),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2202),
    [anon_sym_CARET] = ACTIONS(2202),
    [anon_sym_AMP] = ACTIONS(2202),
    [anon_sym_EQ_EQ] = ACTIONS(2204),
    [anon_sym_BANG_EQ] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(2202),
    [anon_sym_GT_EQ] = ACTIONS(2204),
    [anon_sym_LT_EQ] = ACTIONS(2202),
    [anon_sym_LT] = ACTIONS(2202),
    [anon_sym_LT_LT] = ACTIONS(2202),
    [anon_sym_GT_GT] = ACTIONS(2202),
    [anon_sym_COLON] = ACTIONS(2202),
    [anon_sym___extension__] = ACTIONS(2202),
    [anon_sym_in] = ACTIONS(2202),
    [anon_sym_out] = ACTIONS(2202),
    [anon_sym_inout] = ACTIONS(2202),
    [anon_sym_extern] = ACTIONS(2202),
    [anon_sym___attribute__] = ACTIONS(2202),
    [anon_sym_COLON_COLON] = ACTIONS(2204),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2204),
    [anon_sym___declspec] = ACTIONS(2202),
    [anon_sym___based] = ACTIONS(2202),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2202),
    [anon_sym_EQ] = ACTIONS(2202),
    [anon_sym_register] = ACTIONS(2202),
    [anon_sym_inline] = ACTIONS(2202),
    [anon_sym___inline] = ACTIONS(2202),
    [anon_sym___inline__] = ACTIONS(2202),
    [anon_sym___forceinline] = ACTIONS(2202),
    [anon_sym_thread_local] = ACTIONS(2202),
    [anon_sym___thread] = ACTIONS(2202),
    [anon_sym_const] = ACTIONS(2202),
    [anon_sym_constexpr] = ACTIONS(2202),
    [anon_sym_volatile] = ACTIONS(2202),
    [anon_sym_restrict] = ACTIONS(2202),
    [anon_sym___restrict__] = ACTIONS(2202),
    [anon_sym__Atomic] = ACTIONS(2202),
    [anon_sym__Noreturn] = ACTIONS(2202),
    [anon_sym_noreturn] = ACTIONS(2202),
    [anon_sym_mutable] = ACTIONS(2202),
    [anon_sym_constinit] = ACTIONS(2202),
    [anon_sym_consteval] = ACTIONS(2202),
    [anon_sym_alignas] = ACTIONS(2202),
    [anon_sym__Alignas] = ACTIONS(2202),
    [anon_sym_QMARK] = ACTIONS(2204),
    [anon_sym_STAR_EQ] = ACTIONS(2204),
    [anon_sym_SLASH_EQ] = ACTIONS(2204),
    [anon_sym_PERCENT_EQ] = ACTIONS(2204),
    [anon_sym_PLUS_EQ] = ACTIONS(2204),
    [anon_sym_DASH_EQ] = ACTIONS(2204),
    [anon_sym_LT_LT_EQ] = ACTIONS(2204),
    [anon_sym_GT_GT_EQ] = ACTIONS(2204),
    [anon_sym_AMP_EQ] = ACTIONS(2204),
    [anon_sym_CARET_EQ] = ACTIONS(2204),
    [anon_sym_PIPE_EQ] = ACTIONS(2204),
    [anon_sym_and_eq] = ACTIONS(2202),
    [anon_sym_or_eq] = ACTIONS(2202),
    [anon_sym_xor_eq] = ACTIONS(2202),
    [anon_sym_LT_EQ_GT] = ACTIONS(2204),
    [anon_sym_or] = ACTIONS(2202),
    [anon_sym_and] = ACTIONS(2202),
    [anon_sym_bitor] = ACTIONS(2202),
    [anon_sym_xor] = ACTIONS(2202),
    [anon_sym_bitand] = ACTIONS(2202),
    [anon_sym_not_eq] = ACTIONS(2202),
    [anon_sym_is] = ACTIONS(2202),
    [anon_sym_as] = ACTIONS(2202),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(2202),
    [anon_sym_DOT_STAR] = ACTIONS(2204),
    [anon_sym_DASH_GT] = ACTIONS(2202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2202),
    [anon_sym_let] = ACTIONS(2202),
    [anon_sym_This] = ACTIONS(2202),
    [anon_sym_decltype] = ACTIONS(2202),
    [sym_virtual] = ACTIONS(2202),
    [anon_sym_template] = ACTIONS(2202),
    [anon_sym_operator] = ACTIONS(2202),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2204),
    [anon_sym_precise] = ACTIONS(2202),
    [anon_sym_shared] = ACTIONS(2202),
    [anon_sym_groupshared] = ACTIONS(2202),
    [anon_sym_uniform] = ACTIONS(2202),
    [anon_sym_row_major] = ACTIONS(2202),
    [anon_sym_column_major] = ACTIONS(2202),
    [anon_sym_globallycoherent] = ACTIONS(2202),
    [anon_sym_centroid] = ACTIONS(2202),
    [anon_sym_noperspective] = ACTIONS(2202),
    [anon_sym_nointerpolation] = ACTIONS(2202),
    [anon_sym_sample] = ACTIONS(2202),
    [anon_sym_linear] = ACTIONS(2202),
    [anon_sym_snorm] = ACTIONS(2202),
    [anon_sym_unorm] = ACTIONS(2202),
    [anon_sym_point] = ACTIONS(2202),
    [anon_sym_line] = ACTIONS(2202),
    [anon_sym_triangleadj] = ACTIONS(2202),
    [anon_sym_lineadj] = ACTIONS(2202),
    [anon_sym_triangle] = ACTIONS(2202),
  },
  [1379] = {
    [sym_template_argument_list] = STATE(1398),
    [sym_identifier] = ACTIONS(2169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2171),
    [anon_sym_COMMA] = ACTIONS(2171),
    [anon_sym_RPAREN] = ACTIONS(2171),
    [anon_sym_LPAREN2] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2171),
    [anon_sym_AMP_AMP] = ACTIONS(2173),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2171),
    [anon_sym_BANG_EQ] = ACTIONS(2171),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2171),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(5028),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_SEMI] = ACTIONS(2171),
    [anon_sym___extension__] = ACTIONS(2169),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_out] = ACTIONS(2169),
    [anon_sym_inout] = ACTIONS(2169),
    [anon_sym_extern] = ACTIONS(2169),
    [anon_sym___attribute__] = ACTIONS(2169),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2176),
    [anon_sym___declspec] = ACTIONS(2169),
    [anon_sym___based] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2176),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2169),
    [anon_sym_EQ] = ACTIONS(2181),
    [anon_sym_register] = ACTIONS(2169),
    [anon_sym_inline] = ACTIONS(2169),
    [anon_sym___inline] = ACTIONS(2169),
    [anon_sym___inline__] = ACTIONS(2169),
    [anon_sym___forceinline] = ACTIONS(2169),
    [anon_sym_thread_local] = ACTIONS(2169),
    [anon_sym___thread] = ACTIONS(2169),
    [anon_sym_const] = ACTIONS(2169),
    [anon_sym_constexpr] = ACTIONS(2169),
    [anon_sym_volatile] = ACTIONS(2169),
    [anon_sym_restrict] = ACTIONS(2169),
    [anon_sym___restrict__] = ACTIONS(2169),
    [anon_sym__Atomic] = ACTIONS(2169),
    [anon_sym__Noreturn] = ACTIONS(2169),
    [anon_sym_noreturn] = ACTIONS(2169),
    [anon_sym_mutable] = ACTIONS(2169),
    [anon_sym_constinit] = ACTIONS(2169),
    [anon_sym_consteval] = ACTIONS(2169),
    [anon_sym_alignas] = ACTIONS(2169),
    [anon_sym__Alignas] = ACTIONS(2169),
    [anon_sym_QMARK] = ACTIONS(2171),
    [anon_sym_STAR_EQ] = ACTIONS(2171),
    [anon_sym_SLASH_EQ] = ACTIONS(2171),
    [anon_sym_PERCENT_EQ] = ACTIONS(2171),
    [anon_sym_PLUS_EQ] = ACTIONS(2171),
    [anon_sym_DASH_EQ] = ACTIONS(2171),
    [anon_sym_LT_LT_EQ] = ACTIONS(2171),
    [anon_sym_GT_GT_EQ] = ACTIONS(2171),
    [anon_sym_AMP_EQ] = ACTIONS(2171),
    [anon_sym_CARET_EQ] = ACTIONS(2171),
    [anon_sym_PIPE_EQ] = ACTIONS(2171),
    [anon_sym_and_eq] = ACTIONS(2181),
    [anon_sym_or_eq] = ACTIONS(2181),
    [anon_sym_xor_eq] = ACTIONS(2181),
    [anon_sym_LT_EQ_GT] = ACTIONS(2171),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2181),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2181),
    [anon_sym_not_eq] = ACTIONS(2181),
    [anon_sym_is] = ACTIONS(2181),
    [anon_sym_as] = ACTIONS(2181),
    [anon_sym_DASH_DASH] = ACTIONS(2171),
    [anon_sym_PLUS_PLUS] = ACTIONS(2171),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DOT_STAR] = ACTIONS(2171),
    [anon_sym_DASH_GT] = ACTIONS(2171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2169),
    [anon_sym_let] = ACTIONS(2169),
    [anon_sym_This] = ACTIONS(2169),
    [anon_sym_decltype] = ACTIONS(2169),
    [sym_virtual] = ACTIONS(2169),
    [anon_sym_template] = ACTIONS(2169),
    [anon_sym_operator] = ACTIONS(2169),
    [anon_sym_precise] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_groupshared] = ACTIONS(2169),
    [anon_sym_uniform] = ACTIONS(2169),
    [anon_sym_row_major] = ACTIONS(2169),
    [anon_sym_column_major] = ACTIONS(2169),
    [anon_sym_globallycoherent] = ACTIONS(2169),
    [anon_sym_centroid] = ACTIONS(2169),
    [anon_sym_noperspective] = ACTIONS(2169),
    [anon_sym_nointerpolation] = ACTIONS(2169),
    [anon_sym_sample] = ACTIONS(2169),
    [anon_sym_linear] = ACTIONS(2169),
    [anon_sym_snorm] = ACTIONS(2169),
    [anon_sym_unorm] = ACTIONS(2169),
    [anon_sym_point] = ACTIONS(2169),
    [anon_sym_line] = ACTIONS(2169),
    [anon_sym_triangleadj] = ACTIONS(2169),
    [anon_sym_lineadj] = ACTIONS(2169),
    [anon_sym_triangle] = ACTIONS(2169),
  },
  [1380] = {
    [sym_identifier] = ACTIONS(2240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2242),
    [anon_sym_RPAREN] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_TILDE] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2240),
    [anon_sym_PLUS] = ACTIONS(2240),
    [anon_sym_STAR] = ACTIONS(2240),
    [anon_sym_SLASH] = ACTIONS(2240),
    [anon_sym_PERCENT] = ACTIONS(2240),
    [anon_sym_PIPE_PIPE] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_PIPE] = ACTIONS(2240),
    [anon_sym_CARET] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2240),
    [anon_sym_EQ_EQ] = ACTIONS(2242),
    [anon_sym_BANG_EQ] = ACTIONS(2242),
    [anon_sym_GT] = ACTIONS(2240),
    [anon_sym_GT_EQ] = ACTIONS(2242),
    [anon_sym_LT_EQ] = ACTIONS(2240),
    [anon_sym_LT] = ACTIONS(2240),
    [anon_sym_LT_LT] = ACTIONS(2240),
    [anon_sym_GT_GT] = ACTIONS(2240),
    [anon_sym_COLON] = ACTIONS(2240),
    [anon_sym___extension__] = ACTIONS(2240),
    [anon_sym_in] = ACTIONS(2240),
    [anon_sym_out] = ACTIONS(2240),
    [anon_sym_inout] = ACTIONS(2240),
    [anon_sym_extern] = ACTIONS(2240),
    [anon_sym___attribute__] = ACTIONS(2240),
    [anon_sym_COLON_COLON] = ACTIONS(2242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2242),
    [anon_sym___declspec] = ACTIONS(2240),
    [anon_sym___based] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2240),
    [anon_sym_static] = ACTIONS(2240),
    [anon_sym_EQ] = ACTIONS(2240),
    [anon_sym_register] = ACTIONS(2240),
    [anon_sym_inline] = ACTIONS(2240),
    [anon_sym___inline] = ACTIONS(2240),
    [anon_sym___inline__] = ACTIONS(2240),
    [anon_sym___forceinline] = ACTIONS(2240),
    [anon_sym_thread_local] = ACTIONS(2240),
    [anon_sym___thread] = ACTIONS(2240),
    [anon_sym_const] = ACTIONS(2240),
    [anon_sym_constexpr] = ACTIONS(2240),
    [anon_sym_volatile] = ACTIONS(2240),
    [anon_sym_restrict] = ACTIONS(2240),
    [anon_sym___restrict__] = ACTIONS(2240),
    [anon_sym__Atomic] = ACTIONS(2240),
    [anon_sym__Noreturn] = ACTIONS(2240),
    [anon_sym_noreturn] = ACTIONS(2240),
    [anon_sym_mutable] = ACTIONS(2240),
    [anon_sym_constinit] = ACTIONS(2240),
    [anon_sym_consteval] = ACTIONS(2240),
    [anon_sym_alignas] = ACTIONS(2240),
    [anon_sym__Alignas] = ACTIONS(2240),
    [anon_sym_QMARK] = ACTIONS(2242),
    [anon_sym_STAR_EQ] = ACTIONS(2242),
    [anon_sym_SLASH_EQ] = ACTIONS(2242),
    [anon_sym_PERCENT_EQ] = ACTIONS(2242),
    [anon_sym_PLUS_EQ] = ACTIONS(2242),
    [anon_sym_DASH_EQ] = ACTIONS(2242),
    [anon_sym_LT_LT_EQ] = ACTIONS(2242),
    [anon_sym_GT_GT_EQ] = ACTIONS(2242),
    [anon_sym_AMP_EQ] = ACTIONS(2242),
    [anon_sym_CARET_EQ] = ACTIONS(2242),
    [anon_sym_PIPE_EQ] = ACTIONS(2242),
    [anon_sym_and_eq] = ACTIONS(2240),
    [anon_sym_or_eq] = ACTIONS(2240),
    [anon_sym_xor_eq] = ACTIONS(2240),
    [anon_sym_LT_EQ_GT] = ACTIONS(2242),
    [anon_sym_or] = ACTIONS(2240),
    [anon_sym_and] = ACTIONS(2240),
    [anon_sym_bitor] = ACTIONS(2240),
    [anon_sym_xor] = ACTIONS(2240),
    [anon_sym_bitand] = ACTIONS(2240),
    [anon_sym_not_eq] = ACTIONS(2240),
    [anon_sym_is] = ACTIONS(2240),
    [anon_sym_as] = ACTIONS(2240),
    [anon_sym_DASH_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_PLUS] = ACTIONS(2242),
    [anon_sym_DOT] = ACTIONS(2240),
    [anon_sym_DOT_STAR] = ACTIONS(2242),
    [anon_sym_DASH_GT] = ACTIONS(2240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2240),
    [anon_sym_let] = ACTIONS(2240),
    [anon_sym_This] = ACTIONS(2240),
    [anon_sym_decltype] = ACTIONS(2240),
    [sym_virtual] = ACTIONS(2240),
    [anon_sym_template] = ACTIONS(2240),
    [anon_sym_operator] = ACTIONS(2240),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2242),
    [anon_sym_precise] = ACTIONS(2240),
    [anon_sym_shared] = ACTIONS(2240),
    [anon_sym_groupshared] = ACTIONS(2240),
    [anon_sym_uniform] = ACTIONS(2240),
    [anon_sym_row_major] = ACTIONS(2240),
    [anon_sym_column_major] = ACTIONS(2240),
    [anon_sym_globallycoherent] = ACTIONS(2240),
    [anon_sym_centroid] = ACTIONS(2240),
    [anon_sym_noperspective] = ACTIONS(2240),
    [anon_sym_nointerpolation] = ACTIONS(2240),
    [anon_sym_sample] = ACTIONS(2240),
    [anon_sym_linear] = ACTIONS(2240),
    [anon_sym_snorm] = ACTIONS(2240),
    [anon_sym_unorm] = ACTIONS(2240),
    [anon_sym_point] = ACTIONS(2240),
    [anon_sym_line] = ACTIONS(2240),
    [anon_sym_triangleadj] = ACTIONS(2240),
    [anon_sym_lineadj] = ACTIONS(2240),
    [anon_sym_triangle] = ACTIONS(2240),
  },
  [1381] = {
    [sym_identifier] = ACTIONS(2194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2196),
    [anon_sym_COMMA] = ACTIONS(2196),
    [anon_sym_RPAREN] = ACTIONS(2196),
    [anon_sym_LPAREN2] = ACTIONS(2196),
    [anon_sym_TILDE] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2194),
    [anon_sym_PLUS] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(2194),
    [anon_sym_SLASH] = ACTIONS(2194),
    [anon_sym_PERCENT] = ACTIONS(2194),
    [anon_sym_PIPE_PIPE] = ACTIONS(2196),
    [anon_sym_AMP_AMP] = ACTIONS(2196),
    [anon_sym_PIPE] = ACTIONS(2194),
    [anon_sym_CARET] = ACTIONS(2194),
    [anon_sym_AMP] = ACTIONS(2194),
    [anon_sym_EQ_EQ] = ACTIONS(2196),
    [anon_sym_BANG_EQ] = ACTIONS(2196),
    [anon_sym_GT] = ACTIONS(2194),
    [anon_sym_GT_EQ] = ACTIONS(2196),
    [anon_sym_LT_EQ] = ACTIONS(2194),
    [anon_sym_LT] = ACTIONS(2194),
    [anon_sym_LT_LT] = ACTIONS(2194),
    [anon_sym_GT_GT] = ACTIONS(2194),
    [anon_sym_COLON] = ACTIONS(2194),
    [anon_sym___extension__] = ACTIONS(2194),
    [anon_sym_in] = ACTIONS(2194),
    [anon_sym_out] = ACTIONS(2194),
    [anon_sym_inout] = ACTIONS(2194),
    [anon_sym_extern] = ACTIONS(2194),
    [anon_sym___attribute__] = ACTIONS(2194),
    [anon_sym_COLON_COLON] = ACTIONS(2196),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2196),
    [anon_sym___declspec] = ACTIONS(2194),
    [anon_sym___based] = ACTIONS(2194),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_LBRACK] = ACTIONS(2194),
    [anon_sym_static] = ACTIONS(2194),
    [anon_sym_EQ] = ACTIONS(2194),
    [anon_sym_register] = ACTIONS(2194),
    [anon_sym_inline] = ACTIONS(2194),
    [anon_sym___inline] = ACTIONS(2194),
    [anon_sym___inline__] = ACTIONS(2194),
    [anon_sym___forceinline] = ACTIONS(2194),
    [anon_sym_thread_local] = ACTIONS(2194),
    [anon_sym___thread] = ACTIONS(2194),
    [anon_sym_const] = ACTIONS(2194),
    [anon_sym_constexpr] = ACTIONS(2194),
    [anon_sym_volatile] = ACTIONS(2194),
    [anon_sym_restrict] = ACTIONS(2194),
    [anon_sym___restrict__] = ACTIONS(2194),
    [anon_sym__Atomic] = ACTIONS(2194),
    [anon_sym__Noreturn] = ACTIONS(2194),
    [anon_sym_noreturn] = ACTIONS(2194),
    [anon_sym_mutable] = ACTIONS(2194),
    [anon_sym_constinit] = ACTIONS(2194),
    [anon_sym_consteval] = ACTIONS(2194),
    [anon_sym_alignas] = ACTIONS(2194),
    [anon_sym__Alignas] = ACTIONS(2194),
    [anon_sym_QMARK] = ACTIONS(2196),
    [anon_sym_STAR_EQ] = ACTIONS(2196),
    [anon_sym_SLASH_EQ] = ACTIONS(2196),
    [anon_sym_PERCENT_EQ] = ACTIONS(2196),
    [anon_sym_PLUS_EQ] = ACTIONS(2196),
    [anon_sym_DASH_EQ] = ACTIONS(2196),
    [anon_sym_LT_LT_EQ] = ACTIONS(2196),
    [anon_sym_GT_GT_EQ] = ACTIONS(2196),
    [anon_sym_AMP_EQ] = ACTIONS(2196),
    [anon_sym_CARET_EQ] = ACTIONS(2196),
    [anon_sym_PIPE_EQ] = ACTIONS(2196),
    [anon_sym_and_eq] = ACTIONS(2194),
    [anon_sym_or_eq] = ACTIONS(2194),
    [anon_sym_xor_eq] = ACTIONS(2194),
    [anon_sym_LT_EQ_GT] = ACTIONS(2196),
    [anon_sym_or] = ACTIONS(2194),
    [anon_sym_and] = ACTIONS(2194),
    [anon_sym_bitor] = ACTIONS(2194),
    [anon_sym_xor] = ACTIONS(2194),
    [anon_sym_bitand] = ACTIONS(2194),
    [anon_sym_not_eq] = ACTIONS(2194),
    [anon_sym_is] = ACTIONS(2194),
    [anon_sym_as] = ACTIONS(2194),
    [anon_sym_DASH_DASH] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2196),
    [anon_sym_DOT] = ACTIONS(2194),
    [anon_sym_DOT_STAR] = ACTIONS(2196),
    [anon_sym_DASH_GT] = ACTIONS(2194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2194),
    [anon_sym_let] = ACTIONS(2194),
    [anon_sym_This] = ACTIONS(2194),
    [anon_sym_decltype] = ACTIONS(2194),
    [sym_virtual] = ACTIONS(2194),
    [anon_sym_template] = ACTIONS(2194),
    [anon_sym_operator] = ACTIONS(2194),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2196),
    [anon_sym_precise] = ACTIONS(2194),
    [anon_sym_shared] = ACTIONS(2194),
    [anon_sym_groupshared] = ACTIONS(2194),
    [anon_sym_uniform] = ACTIONS(2194),
    [anon_sym_row_major] = ACTIONS(2194),
    [anon_sym_column_major] = ACTIONS(2194),
    [anon_sym_globallycoherent] = ACTIONS(2194),
    [anon_sym_centroid] = ACTIONS(2194),
    [anon_sym_noperspective] = ACTIONS(2194),
    [anon_sym_nointerpolation] = ACTIONS(2194),
    [anon_sym_sample] = ACTIONS(2194),
    [anon_sym_linear] = ACTIONS(2194),
    [anon_sym_snorm] = ACTIONS(2194),
    [anon_sym_unorm] = ACTIONS(2194),
    [anon_sym_point] = ACTIONS(2194),
    [anon_sym_line] = ACTIONS(2194),
    [anon_sym_triangleadj] = ACTIONS(2194),
    [anon_sym_lineadj] = ACTIONS(2194),
    [anon_sym_triangle] = ACTIONS(2194),
  },
  [1382] = {
    [sym_identifier] = ACTIONS(2256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2258),
    [anon_sym_COMMA] = ACTIONS(2258),
    [anon_sym_RPAREN] = ACTIONS(2258),
    [anon_sym_LPAREN2] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [anon_sym_DASH] = ACTIONS(2256),
    [anon_sym_PLUS] = ACTIONS(2256),
    [anon_sym_STAR] = ACTIONS(2256),
    [anon_sym_SLASH] = ACTIONS(2256),
    [anon_sym_PERCENT] = ACTIONS(2256),
    [anon_sym_PIPE_PIPE] = ACTIONS(2258),
    [anon_sym_AMP_AMP] = ACTIONS(2258),
    [anon_sym_PIPE] = ACTIONS(2256),
    [anon_sym_CARET] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(2256),
    [anon_sym_EQ_EQ] = ACTIONS(2258),
    [anon_sym_BANG_EQ] = ACTIONS(2258),
    [anon_sym_GT] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2258),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_LT] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2256),
    [anon_sym_GT_GT] = ACTIONS(2256),
    [anon_sym_COLON] = ACTIONS(2256),
    [anon_sym___extension__] = ACTIONS(2256),
    [anon_sym_in] = ACTIONS(2256),
    [anon_sym_out] = ACTIONS(2256),
    [anon_sym_inout] = ACTIONS(2256),
    [anon_sym_extern] = ACTIONS(2256),
    [anon_sym___attribute__] = ACTIONS(2256),
    [anon_sym_COLON_COLON] = ACTIONS(2258),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2258),
    [anon_sym___declspec] = ACTIONS(2256),
    [anon_sym___based] = ACTIONS(2256),
    [anon_sym_LBRACE] = ACTIONS(2258),
    [anon_sym_LBRACK] = ACTIONS(2256),
    [anon_sym_static] = ACTIONS(2256),
    [anon_sym_EQ] = ACTIONS(2256),
    [anon_sym_register] = ACTIONS(2256),
    [anon_sym_inline] = ACTIONS(2256),
    [anon_sym___inline] = ACTIONS(2256),
    [anon_sym___inline__] = ACTIONS(2256),
    [anon_sym___forceinline] = ACTIONS(2256),
    [anon_sym_thread_local] = ACTIONS(2256),
    [anon_sym___thread] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_constexpr] = ACTIONS(2256),
    [anon_sym_volatile] = ACTIONS(2256),
    [anon_sym_restrict] = ACTIONS(2256),
    [anon_sym___restrict__] = ACTIONS(2256),
    [anon_sym__Atomic] = ACTIONS(2256),
    [anon_sym__Noreturn] = ACTIONS(2256),
    [anon_sym_noreturn] = ACTIONS(2256),
    [anon_sym_mutable] = ACTIONS(2256),
    [anon_sym_constinit] = ACTIONS(2256),
    [anon_sym_consteval] = ACTIONS(2256),
    [anon_sym_alignas] = ACTIONS(2256),
    [anon_sym__Alignas] = ACTIONS(2256),
    [anon_sym_QMARK] = ACTIONS(2258),
    [anon_sym_STAR_EQ] = ACTIONS(2258),
    [anon_sym_SLASH_EQ] = ACTIONS(2258),
    [anon_sym_PERCENT_EQ] = ACTIONS(2258),
    [anon_sym_PLUS_EQ] = ACTIONS(2258),
    [anon_sym_DASH_EQ] = ACTIONS(2258),
    [anon_sym_LT_LT_EQ] = ACTIONS(2258),
    [anon_sym_GT_GT_EQ] = ACTIONS(2258),
    [anon_sym_AMP_EQ] = ACTIONS(2258),
    [anon_sym_CARET_EQ] = ACTIONS(2258),
    [anon_sym_PIPE_EQ] = ACTIONS(2258),
    [anon_sym_and_eq] = ACTIONS(2256),
    [anon_sym_or_eq] = ACTIONS(2256),
    [anon_sym_xor_eq] = ACTIONS(2256),
    [anon_sym_LT_EQ_GT] = ACTIONS(2258),
    [anon_sym_or] = ACTIONS(2256),
    [anon_sym_and] = ACTIONS(2256),
    [anon_sym_bitor] = ACTIONS(2256),
    [anon_sym_xor] = ACTIONS(2256),
    [anon_sym_bitand] = ACTIONS(2256),
    [anon_sym_not_eq] = ACTIONS(2256),
    [anon_sym_is] = ACTIONS(2256),
    [anon_sym_as] = ACTIONS(2256),
    [anon_sym_DASH_DASH] = ACTIONS(2258),
    [anon_sym_PLUS_PLUS] = ACTIONS(2258),
    [anon_sym_DOT] = ACTIONS(2256),
    [anon_sym_DOT_STAR] = ACTIONS(2258),
    [anon_sym_DASH_GT] = ACTIONS(2256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_This] = ACTIONS(2256),
    [anon_sym_decltype] = ACTIONS(2256),
    [sym_virtual] = ACTIONS(2256),
    [anon_sym_template] = ACTIONS(2256),
    [anon_sym_operator] = ACTIONS(2256),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2258),
    [anon_sym_precise] = ACTIONS(2256),
    [anon_sym_shared] = ACTIONS(2256),
    [anon_sym_groupshared] = ACTIONS(2256),
    [anon_sym_uniform] = ACTIONS(2256),
    [anon_sym_row_major] = ACTIONS(2256),
    [anon_sym_column_major] = ACTIONS(2256),
    [anon_sym_globallycoherent] = ACTIONS(2256),
    [anon_sym_centroid] = ACTIONS(2256),
    [anon_sym_noperspective] = ACTIONS(2256),
    [anon_sym_nointerpolation] = ACTIONS(2256),
    [anon_sym_sample] = ACTIONS(2256),
    [anon_sym_linear] = ACTIONS(2256),
    [anon_sym_snorm] = ACTIONS(2256),
    [anon_sym_unorm] = ACTIONS(2256),
    [anon_sym_point] = ACTIONS(2256),
    [anon_sym_line] = ACTIONS(2256),
    [anon_sym_triangleadj] = ACTIONS(2256),
    [anon_sym_lineadj] = ACTIONS(2256),
    [anon_sym_triangle] = ACTIONS(2256),
  },
  [1383] = {
    [sym_identifier] = ACTIONS(2190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2192),
    [anon_sym_COMMA] = ACTIONS(2192),
    [anon_sym_RPAREN] = ACTIONS(2192),
    [anon_sym_LPAREN2] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2190),
    [anon_sym_PLUS] = ACTIONS(2190),
    [anon_sym_STAR] = ACTIONS(2190),
    [anon_sym_SLASH] = ACTIONS(2190),
    [anon_sym_PERCENT] = ACTIONS(2190),
    [anon_sym_PIPE_PIPE] = ACTIONS(2192),
    [anon_sym_AMP_AMP] = ACTIONS(2192),
    [anon_sym_PIPE] = ACTIONS(2190),
    [anon_sym_CARET] = ACTIONS(2190),
    [anon_sym_AMP] = ACTIONS(2190),
    [anon_sym_EQ_EQ] = ACTIONS(2192),
    [anon_sym_BANG_EQ] = ACTIONS(2192),
    [anon_sym_GT] = ACTIONS(2190),
    [anon_sym_GT_EQ] = ACTIONS(2192),
    [anon_sym_LT_EQ] = ACTIONS(2190),
    [anon_sym_LT] = ACTIONS(2190),
    [anon_sym_LT_LT] = ACTIONS(2190),
    [anon_sym_GT_GT] = ACTIONS(2190),
    [anon_sym_COLON] = ACTIONS(2190),
    [anon_sym___extension__] = ACTIONS(2190),
    [anon_sym_in] = ACTIONS(2190),
    [anon_sym_out] = ACTIONS(2190),
    [anon_sym_inout] = ACTIONS(2190),
    [anon_sym_extern] = ACTIONS(2190),
    [anon_sym___attribute__] = ACTIONS(2190),
    [anon_sym_COLON_COLON] = ACTIONS(2192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2192),
    [anon_sym___declspec] = ACTIONS(2190),
    [anon_sym___based] = ACTIONS(2190),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [anon_sym_LBRACK] = ACTIONS(2190),
    [anon_sym_static] = ACTIONS(2190),
    [anon_sym_EQ] = ACTIONS(2190),
    [anon_sym_register] = ACTIONS(2190),
    [anon_sym_inline] = ACTIONS(2190),
    [anon_sym___inline] = ACTIONS(2190),
    [anon_sym___inline__] = ACTIONS(2190),
    [anon_sym___forceinline] = ACTIONS(2190),
    [anon_sym_thread_local] = ACTIONS(2190),
    [anon_sym___thread] = ACTIONS(2190),
    [anon_sym_const] = ACTIONS(2190),
    [anon_sym_constexpr] = ACTIONS(2190),
    [anon_sym_volatile] = ACTIONS(2190),
    [anon_sym_restrict] = ACTIONS(2190),
    [anon_sym___restrict__] = ACTIONS(2190),
    [anon_sym__Atomic] = ACTIONS(2190),
    [anon_sym__Noreturn] = ACTIONS(2190),
    [anon_sym_noreturn] = ACTIONS(2190),
    [anon_sym_mutable] = ACTIONS(2190),
    [anon_sym_constinit] = ACTIONS(2190),
    [anon_sym_consteval] = ACTIONS(2190),
    [anon_sym_alignas] = ACTIONS(2190),
    [anon_sym__Alignas] = ACTIONS(2190),
    [anon_sym_QMARK] = ACTIONS(2192),
    [anon_sym_STAR_EQ] = ACTIONS(2192),
    [anon_sym_SLASH_EQ] = ACTIONS(2192),
    [anon_sym_PERCENT_EQ] = ACTIONS(2192),
    [anon_sym_PLUS_EQ] = ACTIONS(2192),
    [anon_sym_DASH_EQ] = ACTIONS(2192),
    [anon_sym_LT_LT_EQ] = ACTIONS(2192),
    [anon_sym_GT_GT_EQ] = ACTIONS(2192),
    [anon_sym_AMP_EQ] = ACTIONS(2192),
    [anon_sym_CARET_EQ] = ACTIONS(2192),
    [anon_sym_PIPE_EQ] = ACTIONS(2192),
    [anon_sym_and_eq] = ACTIONS(2190),
    [anon_sym_or_eq] = ACTIONS(2190),
    [anon_sym_xor_eq] = ACTIONS(2190),
    [anon_sym_LT_EQ_GT] = ACTIONS(2192),
    [anon_sym_or] = ACTIONS(2190),
    [anon_sym_and] = ACTIONS(2190),
    [anon_sym_bitor] = ACTIONS(2190),
    [anon_sym_xor] = ACTIONS(2190),
    [anon_sym_bitand] = ACTIONS(2190),
    [anon_sym_not_eq] = ACTIONS(2190),
    [anon_sym_is] = ACTIONS(2190),
    [anon_sym_as] = ACTIONS(2190),
    [anon_sym_DASH_DASH] = ACTIONS(2192),
    [anon_sym_PLUS_PLUS] = ACTIONS(2192),
    [anon_sym_DOT] = ACTIONS(2190),
    [anon_sym_DOT_STAR] = ACTIONS(2192),
    [anon_sym_DASH_GT] = ACTIONS(2190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2190),
    [anon_sym_let] = ACTIONS(2190),
    [anon_sym_This] = ACTIONS(2190),
    [anon_sym_decltype] = ACTIONS(2190),
    [sym_virtual] = ACTIONS(2190),
    [anon_sym_template] = ACTIONS(2190),
    [anon_sym_operator] = ACTIONS(2190),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2192),
    [anon_sym_precise] = ACTIONS(2190),
    [anon_sym_shared] = ACTIONS(2190),
    [anon_sym_groupshared] = ACTIONS(2190),
    [anon_sym_uniform] = ACTIONS(2190),
    [anon_sym_row_major] = ACTIONS(2190),
    [anon_sym_column_major] = ACTIONS(2190),
    [anon_sym_globallycoherent] = ACTIONS(2190),
    [anon_sym_centroid] = ACTIONS(2190),
    [anon_sym_noperspective] = ACTIONS(2190),
    [anon_sym_nointerpolation] = ACTIONS(2190),
    [anon_sym_sample] = ACTIONS(2190),
    [anon_sym_linear] = ACTIONS(2190),
    [anon_sym_snorm] = ACTIONS(2190),
    [anon_sym_unorm] = ACTIONS(2190),
    [anon_sym_point] = ACTIONS(2190),
    [anon_sym_line] = ACTIONS(2190),
    [anon_sym_triangleadj] = ACTIONS(2190),
    [anon_sym_lineadj] = ACTIONS(2190),
    [anon_sym_triangle] = ACTIONS(2190),
  },
  [1384] = {
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2254),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_RPAREN] = ACTIONS(2254),
    [anon_sym_LPAREN2] = ACTIONS(2254),
    [anon_sym_TILDE] = ACTIONS(2254),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_SLASH] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2252),
    [anon_sym_PIPE_PIPE] = ACTIONS(2254),
    [anon_sym_AMP_AMP] = ACTIONS(2254),
    [anon_sym_PIPE] = ACTIONS(2252),
    [anon_sym_CARET] = ACTIONS(2252),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_EQ_EQ] = ACTIONS(2254),
    [anon_sym_BANG_EQ] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2252),
    [anon_sym_GT_EQ] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2252),
    [anon_sym_LT_LT] = ACTIONS(2252),
    [anon_sym_GT_GT] = ACTIONS(2252),
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym___extension__] = ACTIONS(2252),
    [anon_sym_in] = ACTIONS(2252),
    [anon_sym_out] = ACTIONS(2252),
    [anon_sym_inout] = ACTIONS(2252),
    [anon_sym_extern] = ACTIONS(2252),
    [anon_sym___attribute__] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2254),
    [anon_sym___declspec] = ACTIONS(2252),
    [anon_sym___based] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2252),
    [anon_sym_EQ] = ACTIONS(2252),
    [anon_sym_register] = ACTIONS(2252),
    [anon_sym_inline] = ACTIONS(2252),
    [anon_sym___inline] = ACTIONS(2252),
    [anon_sym___inline__] = ACTIONS(2252),
    [anon_sym___forceinline] = ACTIONS(2252),
    [anon_sym_thread_local] = ACTIONS(2252),
    [anon_sym___thread] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2252),
    [anon_sym_constexpr] = ACTIONS(2252),
    [anon_sym_volatile] = ACTIONS(2252),
    [anon_sym_restrict] = ACTIONS(2252),
    [anon_sym___restrict__] = ACTIONS(2252),
    [anon_sym__Atomic] = ACTIONS(2252),
    [anon_sym__Noreturn] = ACTIONS(2252),
    [anon_sym_noreturn] = ACTIONS(2252),
    [anon_sym_mutable] = ACTIONS(2252),
    [anon_sym_constinit] = ACTIONS(2252),
    [anon_sym_consteval] = ACTIONS(2252),
    [anon_sym_alignas] = ACTIONS(2252),
    [anon_sym__Alignas] = ACTIONS(2252),
    [anon_sym_QMARK] = ACTIONS(2254),
    [anon_sym_STAR_EQ] = ACTIONS(2254),
    [anon_sym_SLASH_EQ] = ACTIONS(2254),
    [anon_sym_PERCENT_EQ] = ACTIONS(2254),
    [anon_sym_PLUS_EQ] = ACTIONS(2254),
    [anon_sym_DASH_EQ] = ACTIONS(2254),
    [anon_sym_LT_LT_EQ] = ACTIONS(2254),
    [anon_sym_GT_GT_EQ] = ACTIONS(2254),
    [anon_sym_AMP_EQ] = ACTIONS(2254),
    [anon_sym_CARET_EQ] = ACTIONS(2254),
    [anon_sym_PIPE_EQ] = ACTIONS(2254),
    [anon_sym_and_eq] = ACTIONS(2252),
    [anon_sym_or_eq] = ACTIONS(2252),
    [anon_sym_xor_eq] = ACTIONS(2252),
    [anon_sym_LT_EQ_GT] = ACTIONS(2254),
    [anon_sym_or] = ACTIONS(2252),
    [anon_sym_and] = ACTIONS(2252),
    [anon_sym_bitor] = ACTIONS(2252),
    [anon_sym_xor] = ACTIONS(2252),
    [anon_sym_bitand] = ACTIONS(2252),
    [anon_sym_not_eq] = ACTIONS(2252),
    [anon_sym_is] = ACTIONS(2252),
    [anon_sym_as] = ACTIONS(2252),
    [anon_sym_DASH_DASH] = ACTIONS(2254),
    [anon_sym_PLUS_PLUS] = ACTIONS(2254),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_DOT_STAR] = ACTIONS(2254),
    [anon_sym_DASH_GT] = ACTIONS(2252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_This] = ACTIONS(2252),
    [anon_sym_decltype] = ACTIONS(2252),
    [sym_virtual] = ACTIONS(2252),
    [anon_sym_template] = ACTIONS(2252),
    [anon_sym_operator] = ACTIONS(2252),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2254),
    [anon_sym_precise] = ACTIONS(2252),
    [anon_sym_shared] = ACTIONS(2252),
    [anon_sym_groupshared] = ACTIONS(2252),
    [anon_sym_uniform] = ACTIONS(2252),
    [anon_sym_row_major] = ACTIONS(2252),
    [anon_sym_column_major] = ACTIONS(2252),
    [anon_sym_globallycoherent] = ACTIONS(2252),
    [anon_sym_centroid] = ACTIONS(2252),
    [anon_sym_noperspective] = ACTIONS(2252),
    [anon_sym_nointerpolation] = ACTIONS(2252),
    [anon_sym_sample] = ACTIONS(2252),
    [anon_sym_linear] = ACTIONS(2252),
    [anon_sym_snorm] = ACTIONS(2252),
    [anon_sym_unorm] = ACTIONS(2252),
    [anon_sym_point] = ACTIONS(2252),
    [anon_sym_line] = ACTIONS(2252),
    [anon_sym_triangleadj] = ACTIONS(2252),
    [anon_sym_lineadj] = ACTIONS(2252),
    [anon_sym_triangle] = ACTIONS(2252),
  },
  [1385] = {
    [sym_identifier] = ACTIONS(2232),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_COMMA] = ACTIONS(2234),
    [anon_sym_RPAREN] = ACTIONS(2234),
    [anon_sym_LPAREN2] = ACTIONS(2234),
    [anon_sym_TILDE] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2232),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_STAR] = ACTIONS(2232),
    [anon_sym_SLASH] = ACTIONS(2232),
    [anon_sym_PERCENT] = ACTIONS(2232),
    [anon_sym_PIPE_PIPE] = ACTIONS(2234),
    [anon_sym_AMP_AMP] = ACTIONS(2234),
    [anon_sym_PIPE] = ACTIONS(2232),
    [anon_sym_CARET] = ACTIONS(2232),
    [anon_sym_AMP] = ACTIONS(2232),
    [anon_sym_EQ_EQ] = ACTIONS(2234),
    [anon_sym_BANG_EQ] = ACTIONS(2234),
    [anon_sym_GT] = ACTIONS(2232),
    [anon_sym_GT_EQ] = ACTIONS(2234),
    [anon_sym_LT_EQ] = ACTIONS(2232),
    [anon_sym_LT] = ACTIONS(2232),
    [anon_sym_LT_LT] = ACTIONS(2232),
    [anon_sym_GT_GT] = ACTIONS(2232),
    [anon_sym_COLON] = ACTIONS(2232),
    [anon_sym___extension__] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2232),
    [anon_sym_out] = ACTIONS(2232),
    [anon_sym_inout] = ACTIONS(2232),
    [anon_sym_extern] = ACTIONS(2232),
    [anon_sym___attribute__] = ACTIONS(2232),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2234),
    [anon_sym___declspec] = ACTIONS(2232),
    [anon_sym___based] = ACTIONS(2232),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2232),
    [anon_sym_static] = ACTIONS(2232),
    [anon_sym_EQ] = ACTIONS(2232),
    [anon_sym_register] = ACTIONS(2232),
    [anon_sym_inline] = ACTIONS(2232),
    [anon_sym___inline] = ACTIONS(2232),
    [anon_sym___inline__] = ACTIONS(2232),
    [anon_sym___forceinline] = ACTIONS(2232),
    [anon_sym_thread_local] = ACTIONS(2232),
    [anon_sym___thread] = ACTIONS(2232),
    [anon_sym_const] = ACTIONS(2232),
    [anon_sym_constexpr] = ACTIONS(2232),
    [anon_sym_volatile] = ACTIONS(2232),
    [anon_sym_restrict] = ACTIONS(2232),
    [anon_sym___restrict__] = ACTIONS(2232),
    [anon_sym__Atomic] = ACTIONS(2232),
    [anon_sym__Noreturn] = ACTIONS(2232),
    [anon_sym_noreturn] = ACTIONS(2232),
    [anon_sym_mutable] = ACTIONS(2232),
    [anon_sym_constinit] = ACTIONS(2232),
    [anon_sym_consteval] = ACTIONS(2232),
    [anon_sym_alignas] = ACTIONS(2232),
    [anon_sym__Alignas] = ACTIONS(2232),
    [anon_sym_QMARK] = ACTIONS(2234),
    [anon_sym_STAR_EQ] = ACTIONS(2234),
    [anon_sym_SLASH_EQ] = ACTIONS(2234),
    [anon_sym_PERCENT_EQ] = ACTIONS(2234),
    [anon_sym_PLUS_EQ] = ACTIONS(2234),
    [anon_sym_DASH_EQ] = ACTIONS(2234),
    [anon_sym_LT_LT_EQ] = ACTIONS(2234),
    [anon_sym_GT_GT_EQ] = ACTIONS(2234),
    [anon_sym_AMP_EQ] = ACTIONS(2234),
    [anon_sym_CARET_EQ] = ACTIONS(2234),
    [anon_sym_PIPE_EQ] = ACTIONS(2234),
    [anon_sym_and_eq] = ACTIONS(2232),
    [anon_sym_or_eq] = ACTIONS(2232),
    [anon_sym_xor_eq] = ACTIONS(2232),
    [anon_sym_LT_EQ_GT] = ACTIONS(2234),
    [anon_sym_or] = ACTIONS(2232),
    [anon_sym_and] = ACTIONS(2232),
    [anon_sym_bitor] = ACTIONS(2232),
    [anon_sym_xor] = ACTIONS(2232),
    [anon_sym_bitand] = ACTIONS(2232),
    [anon_sym_not_eq] = ACTIONS(2232),
    [anon_sym_is] = ACTIONS(2232),
    [anon_sym_as] = ACTIONS(2232),
    [anon_sym_DASH_DASH] = ACTIONS(2234),
    [anon_sym_PLUS_PLUS] = ACTIONS(2234),
    [anon_sym_DOT] = ACTIONS(2232),
    [anon_sym_DOT_STAR] = ACTIONS(2234),
    [anon_sym_DASH_GT] = ACTIONS(2232),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2232),
    [anon_sym_let] = ACTIONS(2232),
    [anon_sym_This] = ACTIONS(2232),
    [anon_sym_decltype] = ACTIONS(2232),
    [sym_virtual] = ACTIONS(2232),
    [anon_sym_template] = ACTIONS(2232),
    [anon_sym_operator] = ACTIONS(2232),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2234),
    [anon_sym_precise] = ACTIONS(2232),
    [anon_sym_shared] = ACTIONS(2232),
    [anon_sym_groupshared] = ACTIONS(2232),
    [anon_sym_uniform] = ACTIONS(2232),
    [anon_sym_row_major] = ACTIONS(2232),
    [anon_sym_column_major] = ACTIONS(2232),
    [anon_sym_globallycoherent] = ACTIONS(2232),
    [anon_sym_centroid] = ACTIONS(2232),
    [anon_sym_noperspective] = ACTIONS(2232),
    [anon_sym_nointerpolation] = ACTIONS(2232),
    [anon_sym_sample] = ACTIONS(2232),
    [anon_sym_linear] = ACTIONS(2232),
    [anon_sym_snorm] = ACTIONS(2232),
    [anon_sym_unorm] = ACTIONS(2232),
    [anon_sym_point] = ACTIONS(2232),
    [anon_sym_line] = ACTIONS(2232),
    [anon_sym_triangleadj] = ACTIONS(2232),
    [anon_sym_lineadj] = ACTIONS(2232),
    [anon_sym_triangle] = ACTIONS(2232),
  },
  [1386] = {
    [sym_identifier] = ACTIONS(2224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2226),
    [anon_sym_COMMA] = ACTIONS(2226),
    [anon_sym_RPAREN] = ACTIONS(2226),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_TILDE] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_PLUS] = ACTIONS(2224),
    [anon_sym_STAR] = ACTIONS(2224),
    [anon_sym_SLASH] = ACTIONS(2224),
    [anon_sym_PERCENT] = ACTIONS(2224),
    [anon_sym_PIPE_PIPE] = ACTIONS(2226),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_PIPE] = ACTIONS(2224),
    [anon_sym_CARET] = ACTIONS(2224),
    [anon_sym_AMP] = ACTIONS(2224),
    [anon_sym_EQ_EQ] = ACTIONS(2226),
    [anon_sym_BANG_EQ] = ACTIONS(2226),
    [anon_sym_GT] = ACTIONS(2224),
    [anon_sym_GT_EQ] = ACTIONS(2226),
    [anon_sym_LT_EQ] = ACTIONS(2224),
    [anon_sym_LT] = ACTIONS(2224),
    [anon_sym_LT_LT] = ACTIONS(2224),
    [anon_sym_GT_GT] = ACTIONS(2224),
    [anon_sym_COLON] = ACTIONS(2224),
    [anon_sym___extension__] = ACTIONS(2224),
    [anon_sym_in] = ACTIONS(2224),
    [anon_sym_out] = ACTIONS(2224),
    [anon_sym_inout] = ACTIONS(2224),
    [anon_sym_extern] = ACTIONS(2224),
    [anon_sym___attribute__] = ACTIONS(2224),
    [anon_sym_COLON_COLON] = ACTIONS(2226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2226),
    [anon_sym___declspec] = ACTIONS(2224),
    [anon_sym___based] = ACTIONS(2224),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_LBRACK] = ACTIONS(2224),
    [anon_sym_static] = ACTIONS(2224),
    [anon_sym_EQ] = ACTIONS(2224),
    [anon_sym_register] = ACTIONS(2224),
    [anon_sym_inline] = ACTIONS(2224),
    [anon_sym___inline] = ACTIONS(2224),
    [anon_sym___inline__] = ACTIONS(2224),
    [anon_sym___forceinline] = ACTIONS(2224),
    [anon_sym_thread_local] = ACTIONS(2224),
    [anon_sym___thread] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_constexpr] = ACTIONS(2224),
    [anon_sym_volatile] = ACTIONS(2224),
    [anon_sym_restrict] = ACTIONS(2224),
    [anon_sym___restrict__] = ACTIONS(2224),
    [anon_sym__Atomic] = ACTIONS(2224),
    [anon_sym__Noreturn] = ACTIONS(2224),
    [anon_sym_noreturn] = ACTIONS(2224),
    [anon_sym_mutable] = ACTIONS(2224),
    [anon_sym_constinit] = ACTIONS(2224),
    [anon_sym_consteval] = ACTIONS(2224),
    [anon_sym_alignas] = ACTIONS(2224),
    [anon_sym__Alignas] = ACTIONS(2224),
    [anon_sym_QMARK] = ACTIONS(2226),
    [anon_sym_STAR_EQ] = ACTIONS(2226),
    [anon_sym_SLASH_EQ] = ACTIONS(2226),
    [anon_sym_PERCENT_EQ] = ACTIONS(2226),
    [anon_sym_PLUS_EQ] = ACTIONS(2226),
    [anon_sym_DASH_EQ] = ACTIONS(2226),
    [anon_sym_LT_LT_EQ] = ACTIONS(2226),
    [anon_sym_GT_GT_EQ] = ACTIONS(2226),
    [anon_sym_AMP_EQ] = ACTIONS(2226),
    [anon_sym_CARET_EQ] = ACTIONS(2226),
    [anon_sym_PIPE_EQ] = ACTIONS(2226),
    [anon_sym_and_eq] = ACTIONS(2224),
    [anon_sym_or_eq] = ACTIONS(2224),
    [anon_sym_xor_eq] = ACTIONS(2224),
    [anon_sym_LT_EQ_GT] = ACTIONS(2226),
    [anon_sym_or] = ACTIONS(2224),
    [anon_sym_and] = ACTIONS(2224),
    [anon_sym_bitor] = ACTIONS(2224),
    [anon_sym_xor] = ACTIONS(2224),
    [anon_sym_bitand] = ACTIONS(2224),
    [anon_sym_not_eq] = ACTIONS(2224),
    [anon_sym_is] = ACTIONS(2224),
    [anon_sym_as] = ACTIONS(2224),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_DOT] = ACTIONS(2224),
    [anon_sym_DOT_STAR] = ACTIONS(2226),
    [anon_sym_DASH_GT] = ACTIONS(2224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2224),
    [anon_sym_let] = ACTIONS(2224),
    [anon_sym_This] = ACTIONS(2224),
    [anon_sym_decltype] = ACTIONS(2224),
    [sym_virtual] = ACTIONS(2224),
    [anon_sym_template] = ACTIONS(2224),
    [anon_sym_operator] = ACTIONS(2224),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2226),
    [anon_sym_precise] = ACTIONS(2224),
    [anon_sym_shared] = ACTIONS(2224),
    [anon_sym_groupshared] = ACTIONS(2224),
    [anon_sym_uniform] = ACTIONS(2224),
    [anon_sym_row_major] = ACTIONS(2224),
    [anon_sym_column_major] = ACTIONS(2224),
    [anon_sym_globallycoherent] = ACTIONS(2224),
    [anon_sym_centroid] = ACTIONS(2224),
    [anon_sym_noperspective] = ACTIONS(2224),
    [anon_sym_nointerpolation] = ACTIONS(2224),
    [anon_sym_sample] = ACTIONS(2224),
    [anon_sym_linear] = ACTIONS(2224),
    [anon_sym_snorm] = ACTIONS(2224),
    [anon_sym_unorm] = ACTIONS(2224),
    [anon_sym_point] = ACTIONS(2224),
    [anon_sym_line] = ACTIONS(2224),
    [anon_sym_triangleadj] = ACTIONS(2224),
    [anon_sym_lineadj] = ACTIONS(2224),
    [anon_sym_triangle] = ACTIONS(2224),
  },
  [1387] = {
    [sym_identifier] = ACTIONS(2244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(2246),
    [anon_sym_RPAREN] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2244),
    [anon_sym_PLUS] = ACTIONS(2244),
    [anon_sym_STAR] = ACTIONS(2244),
    [anon_sym_SLASH] = ACTIONS(2244),
    [anon_sym_PERCENT] = ACTIONS(2244),
    [anon_sym_PIPE_PIPE] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2244),
    [anon_sym_CARET] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2244),
    [anon_sym_EQ_EQ] = ACTIONS(2246),
    [anon_sym_BANG_EQ] = ACTIONS(2246),
    [anon_sym_GT] = ACTIONS(2244),
    [anon_sym_GT_EQ] = ACTIONS(2246),
    [anon_sym_LT_EQ] = ACTIONS(2244),
    [anon_sym_LT] = ACTIONS(2244),
    [anon_sym_LT_LT] = ACTIONS(2244),
    [anon_sym_GT_GT] = ACTIONS(2244),
    [anon_sym_COLON] = ACTIONS(2244),
    [anon_sym___extension__] = ACTIONS(2244),
    [anon_sym_in] = ACTIONS(2244),
    [anon_sym_out] = ACTIONS(2244),
    [anon_sym_inout] = ACTIONS(2244),
    [anon_sym_extern] = ACTIONS(2244),
    [anon_sym___attribute__] = ACTIONS(2244),
    [anon_sym_COLON_COLON] = ACTIONS(2246),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2246),
    [anon_sym___declspec] = ACTIONS(2244),
    [anon_sym___based] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2244),
    [anon_sym_static] = ACTIONS(2244),
    [anon_sym_EQ] = ACTIONS(2244),
    [anon_sym_register] = ACTIONS(2244),
    [anon_sym_inline] = ACTIONS(2244),
    [anon_sym___inline] = ACTIONS(2244),
    [anon_sym___inline__] = ACTIONS(2244),
    [anon_sym___forceinline] = ACTIONS(2244),
    [anon_sym_thread_local] = ACTIONS(2244),
    [anon_sym___thread] = ACTIONS(2244),
    [anon_sym_const] = ACTIONS(2244),
    [anon_sym_constexpr] = ACTIONS(2244),
    [anon_sym_volatile] = ACTIONS(2244),
    [anon_sym_restrict] = ACTIONS(2244),
    [anon_sym___restrict__] = ACTIONS(2244),
    [anon_sym__Atomic] = ACTIONS(2244),
    [anon_sym__Noreturn] = ACTIONS(2244),
    [anon_sym_noreturn] = ACTIONS(2244),
    [anon_sym_mutable] = ACTIONS(2244),
    [anon_sym_constinit] = ACTIONS(2244),
    [anon_sym_consteval] = ACTIONS(2244),
    [anon_sym_alignas] = ACTIONS(2244),
    [anon_sym__Alignas] = ACTIONS(2244),
    [anon_sym_QMARK] = ACTIONS(2246),
    [anon_sym_STAR_EQ] = ACTIONS(2246),
    [anon_sym_SLASH_EQ] = ACTIONS(2246),
    [anon_sym_PERCENT_EQ] = ACTIONS(2246),
    [anon_sym_PLUS_EQ] = ACTIONS(2246),
    [anon_sym_DASH_EQ] = ACTIONS(2246),
    [anon_sym_LT_LT_EQ] = ACTIONS(2246),
    [anon_sym_GT_GT_EQ] = ACTIONS(2246),
    [anon_sym_AMP_EQ] = ACTIONS(2246),
    [anon_sym_CARET_EQ] = ACTIONS(2246),
    [anon_sym_PIPE_EQ] = ACTIONS(2246),
    [anon_sym_and_eq] = ACTIONS(2244),
    [anon_sym_or_eq] = ACTIONS(2244),
    [anon_sym_xor_eq] = ACTIONS(2244),
    [anon_sym_LT_EQ_GT] = ACTIONS(2246),
    [anon_sym_or] = ACTIONS(2244),
    [anon_sym_and] = ACTIONS(2244),
    [anon_sym_bitor] = ACTIONS(2244),
    [anon_sym_xor] = ACTIONS(2244),
    [anon_sym_bitand] = ACTIONS(2244),
    [anon_sym_not_eq] = ACTIONS(2244),
    [anon_sym_is] = ACTIONS(2244),
    [anon_sym_as] = ACTIONS(2244),
    [anon_sym_DASH_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_PLUS] = ACTIONS(2246),
    [anon_sym_DOT] = ACTIONS(2244),
    [anon_sym_DOT_STAR] = ACTIONS(2246),
    [anon_sym_DASH_GT] = ACTIONS(2244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2244),
    [anon_sym_let] = ACTIONS(2244),
    [anon_sym_This] = ACTIONS(2244),
    [anon_sym_decltype] = ACTIONS(2244),
    [sym_virtual] = ACTIONS(2244),
    [anon_sym_template] = ACTIONS(2244),
    [anon_sym_operator] = ACTIONS(2244),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2246),
    [anon_sym_precise] = ACTIONS(2244),
    [anon_sym_shared] = ACTIONS(2244),
    [anon_sym_groupshared] = ACTIONS(2244),
    [anon_sym_uniform] = ACTIONS(2244),
    [anon_sym_row_major] = ACTIONS(2244),
    [anon_sym_column_major] = ACTIONS(2244),
    [anon_sym_globallycoherent] = ACTIONS(2244),
    [anon_sym_centroid] = ACTIONS(2244),
    [anon_sym_noperspective] = ACTIONS(2244),
    [anon_sym_nointerpolation] = ACTIONS(2244),
    [anon_sym_sample] = ACTIONS(2244),
    [anon_sym_linear] = ACTIONS(2244),
    [anon_sym_snorm] = ACTIONS(2244),
    [anon_sym_unorm] = ACTIONS(2244),
    [anon_sym_point] = ACTIONS(2244),
    [anon_sym_line] = ACTIONS(2244),
    [anon_sym_triangleadj] = ACTIONS(2244),
    [anon_sym_lineadj] = ACTIONS(2244),
    [anon_sym_triangle] = ACTIONS(2244),
  },
  [1388] = {
    [sym_identifier] = ACTIONS(2248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_RPAREN] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2248),
    [anon_sym_PLUS] = ACTIONS(2248),
    [anon_sym_STAR] = ACTIONS(2248),
    [anon_sym_SLASH] = ACTIONS(2248),
    [anon_sym_PERCENT] = ACTIONS(2248),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2248),
    [anon_sym_EQ_EQ] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_GT] = ACTIONS(2248),
    [anon_sym_GT_EQ] = ACTIONS(2250),
    [anon_sym_LT_EQ] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_LT_LT] = ACTIONS(2248),
    [anon_sym_GT_GT] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2248),
    [anon_sym___extension__] = ACTIONS(2248),
    [anon_sym_in] = ACTIONS(2248),
    [anon_sym_out] = ACTIONS(2248),
    [anon_sym_inout] = ACTIONS(2248),
    [anon_sym_extern] = ACTIONS(2248),
    [anon_sym___attribute__] = ACTIONS(2248),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2250),
    [anon_sym___declspec] = ACTIONS(2248),
    [anon_sym___based] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2248),
    [anon_sym_static] = ACTIONS(2248),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_register] = ACTIONS(2248),
    [anon_sym_inline] = ACTIONS(2248),
    [anon_sym___inline] = ACTIONS(2248),
    [anon_sym___inline__] = ACTIONS(2248),
    [anon_sym___forceinline] = ACTIONS(2248),
    [anon_sym_thread_local] = ACTIONS(2248),
    [anon_sym___thread] = ACTIONS(2248),
    [anon_sym_const] = ACTIONS(2248),
    [anon_sym_constexpr] = ACTIONS(2248),
    [anon_sym_volatile] = ACTIONS(2248),
    [anon_sym_restrict] = ACTIONS(2248),
    [anon_sym___restrict__] = ACTIONS(2248),
    [anon_sym__Atomic] = ACTIONS(2248),
    [anon_sym__Noreturn] = ACTIONS(2248),
    [anon_sym_noreturn] = ACTIONS(2248),
    [anon_sym_mutable] = ACTIONS(2248),
    [anon_sym_constinit] = ACTIONS(2248),
    [anon_sym_consteval] = ACTIONS(2248),
    [anon_sym_alignas] = ACTIONS(2248),
    [anon_sym__Alignas] = ACTIONS(2248),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_STAR_EQ] = ACTIONS(2250),
    [anon_sym_SLASH_EQ] = ACTIONS(2250),
    [anon_sym_PERCENT_EQ] = ACTIONS(2250),
    [anon_sym_PLUS_EQ] = ACTIONS(2250),
    [anon_sym_DASH_EQ] = ACTIONS(2250),
    [anon_sym_LT_LT_EQ] = ACTIONS(2250),
    [anon_sym_GT_GT_EQ] = ACTIONS(2250),
    [anon_sym_AMP_EQ] = ACTIONS(2250),
    [anon_sym_CARET_EQ] = ACTIONS(2250),
    [anon_sym_PIPE_EQ] = ACTIONS(2250),
    [anon_sym_and_eq] = ACTIONS(2248),
    [anon_sym_or_eq] = ACTIONS(2248),
    [anon_sym_xor_eq] = ACTIONS(2248),
    [anon_sym_LT_EQ_GT] = ACTIONS(2250),
    [anon_sym_or] = ACTIONS(2248),
    [anon_sym_and] = ACTIONS(2248),
    [anon_sym_bitor] = ACTIONS(2248),
    [anon_sym_xor] = ACTIONS(2248),
    [anon_sym_bitand] = ACTIONS(2248),
    [anon_sym_not_eq] = ACTIONS(2248),
    [anon_sym_is] = ACTIONS(2248),
    [anon_sym_as] = ACTIONS(2248),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2248),
    [anon_sym_DOT_STAR] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2248),
    [anon_sym_let] = ACTIONS(2248),
    [anon_sym_This] = ACTIONS(2248),
    [anon_sym_decltype] = ACTIONS(2248),
    [sym_virtual] = ACTIONS(2248),
    [anon_sym_template] = ACTIONS(2248),
    [anon_sym_operator] = ACTIONS(2248),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2250),
    [anon_sym_precise] = ACTIONS(2248),
    [anon_sym_shared] = ACTIONS(2248),
    [anon_sym_groupshared] = ACTIONS(2248),
    [anon_sym_uniform] = ACTIONS(2248),
    [anon_sym_row_major] = ACTIONS(2248),
    [anon_sym_column_major] = ACTIONS(2248),
    [anon_sym_globallycoherent] = ACTIONS(2248),
    [anon_sym_centroid] = ACTIONS(2248),
    [anon_sym_noperspective] = ACTIONS(2248),
    [anon_sym_nointerpolation] = ACTIONS(2248),
    [anon_sym_sample] = ACTIONS(2248),
    [anon_sym_linear] = ACTIONS(2248),
    [anon_sym_snorm] = ACTIONS(2248),
    [anon_sym_unorm] = ACTIONS(2248),
    [anon_sym_point] = ACTIONS(2248),
    [anon_sym_line] = ACTIONS(2248),
    [anon_sym_triangleadj] = ACTIONS(2248),
    [anon_sym_lineadj] = ACTIONS(2248),
    [anon_sym_triangle] = ACTIONS(2248),
  },
  [1389] = {
    [sym_identifier] = ACTIONS(2198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_COMMA] = ACTIONS(2200),
    [anon_sym_RPAREN] = ACTIONS(2200),
    [anon_sym_LPAREN2] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(2198),
    [anon_sym_SLASH] = ACTIONS(2198),
    [anon_sym_PERCENT] = ACTIONS(2198),
    [anon_sym_PIPE_PIPE] = ACTIONS(2200),
    [anon_sym_AMP_AMP] = ACTIONS(2200),
    [anon_sym_PIPE] = ACTIONS(2198),
    [anon_sym_CARET] = ACTIONS(2198),
    [anon_sym_AMP] = ACTIONS(2198),
    [anon_sym_EQ_EQ] = ACTIONS(2200),
    [anon_sym_BANG_EQ] = ACTIONS(2200),
    [anon_sym_GT] = ACTIONS(2198),
    [anon_sym_GT_EQ] = ACTIONS(2200),
    [anon_sym_LT_EQ] = ACTIONS(2198),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_LT_LT] = ACTIONS(2198),
    [anon_sym_GT_GT] = ACTIONS(2198),
    [anon_sym_COLON] = ACTIONS(2198),
    [anon_sym___extension__] = ACTIONS(2198),
    [anon_sym_in] = ACTIONS(2198),
    [anon_sym_out] = ACTIONS(2198),
    [anon_sym_inout] = ACTIONS(2198),
    [anon_sym_extern] = ACTIONS(2198),
    [anon_sym___attribute__] = ACTIONS(2198),
    [anon_sym_COLON_COLON] = ACTIONS(2200),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2200),
    [anon_sym___declspec] = ACTIONS(2198),
    [anon_sym___based] = ACTIONS(2198),
    [anon_sym_LBRACE] = ACTIONS(2200),
    [anon_sym_LBRACK] = ACTIONS(2198),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_EQ] = ACTIONS(2198),
    [anon_sym_register] = ACTIONS(2198),
    [anon_sym_inline] = ACTIONS(2198),
    [anon_sym___inline] = ACTIONS(2198),
    [anon_sym___inline__] = ACTIONS(2198),
    [anon_sym___forceinline] = ACTIONS(2198),
    [anon_sym_thread_local] = ACTIONS(2198),
    [anon_sym___thread] = ACTIONS(2198),
    [anon_sym_const] = ACTIONS(2198),
    [anon_sym_constexpr] = ACTIONS(2198),
    [anon_sym_volatile] = ACTIONS(2198),
    [anon_sym_restrict] = ACTIONS(2198),
    [anon_sym___restrict__] = ACTIONS(2198),
    [anon_sym__Atomic] = ACTIONS(2198),
    [anon_sym__Noreturn] = ACTIONS(2198),
    [anon_sym_noreturn] = ACTIONS(2198),
    [anon_sym_mutable] = ACTIONS(2198),
    [anon_sym_constinit] = ACTIONS(2198),
    [anon_sym_consteval] = ACTIONS(2198),
    [anon_sym_alignas] = ACTIONS(2198),
    [anon_sym__Alignas] = ACTIONS(2198),
    [anon_sym_QMARK] = ACTIONS(2200),
    [anon_sym_STAR_EQ] = ACTIONS(2200),
    [anon_sym_SLASH_EQ] = ACTIONS(2200),
    [anon_sym_PERCENT_EQ] = ACTIONS(2200),
    [anon_sym_PLUS_EQ] = ACTIONS(2200),
    [anon_sym_DASH_EQ] = ACTIONS(2200),
    [anon_sym_LT_LT_EQ] = ACTIONS(2200),
    [anon_sym_GT_GT_EQ] = ACTIONS(2200),
    [anon_sym_AMP_EQ] = ACTIONS(2200),
    [anon_sym_CARET_EQ] = ACTIONS(2200),
    [anon_sym_PIPE_EQ] = ACTIONS(2200),
    [anon_sym_and_eq] = ACTIONS(2198),
    [anon_sym_or_eq] = ACTIONS(2198),
    [anon_sym_xor_eq] = ACTIONS(2198),
    [anon_sym_LT_EQ_GT] = ACTIONS(2200),
    [anon_sym_or] = ACTIONS(2198),
    [anon_sym_and] = ACTIONS(2198),
    [anon_sym_bitor] = ACTIONS(2198),
    [anon_sym_xor] = ACTIONS(2198),
    [anon_sym_bitand] = ACTIONS(2198),
    [anon_sym_not_eq] = ACTIONS(2198),
    [anon_sym_is] = ACTIONS(2198),
    [anon_sym_as] = ACTIONS(2198),
    [anon_sym_DASH_DASH] = ACTIONS(2200),
    [anon_sym_PLUS_PLUS] = ACTIONS(2200),
    [anon_sym_DOT] = ACTIONS(2198),
    [anon_sym_DOT_STAR] = ACTIONS(2200),
    [anon_sym_DASH_GT] = ACTIONS(2198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2198),
    [anon_sym_let] = ACTIONS(2198),
    [anon_sym_This] = ACTIONS(2198),
    [anon_sym_decltype] = ACTIONS(2198),
    [sym_virtual] = ACTIONS(2198),
    [anon_sym_template] = ACTIONS(2198),
    [anon_sym_operator] = ACTIONS(2198),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2200),
    [anon_sym_precise] = ACTIONS(2198),
    [anon_sym_shared] = ACTIONS(2198),
    [anon_sym_groupshared] = ACTIONS(2198),
    [anon_sym_uniform] = ACTIONS(2198),
    [anon_sym_row_major] = ACTIONS(2198),
    [anon_sym_column_major] = ACTIONS(2198),
    [anon_sym_globallycoherent] = ACTIONS(2198),
    [anon_sym_centroid] = ACTIONS(2198),
    [anon_sym_noperspective] = ACTIONS(2198),
    [anon_sym_nointerpolation] = ACTIONS(2198),
    [anon_sym_sample] = ACTIONS(2198),
    [anon_sym_linear] = ACTIONS(2198),
    [anon_sym_snorm] = ACTIONS(2198),
    [anon_sym_unorm] = ACTIONS(2198),
    [anon_sym_point] = ACTIONS(2198),
    [anon_sym_line] = ACTIONS(2198),
    [anon_sym_triangleadj] = ACTIONS(2198),
    [anon_sym_lineadj] = ACTIONS(2198),
    [anon_sym_triangle] = ACTIONS(2198),
  },
  [1390] = {
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2230),
    [anon_sym_COMMA] = ACTIONS(2230),
    [anon_sym_RPAREN] = ACTIONS(2230),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_TILDE] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2228),
    [anon_sym_PLUS] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(2228),
    [anon_sym_SLASH] = ACTIONS(2228),
    [anon_sym_PERCENT] = ACTIONS(2228),
    [anon_sym_PIPE_PIPE] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_PIPE] = ACTIONS(2228),
    [anon_sym_CARET] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2228),
    [anon_sym_EQ_EQ] = ACTIONS(2230),
    [anon_sym_BANG_EQ] = ACTIONS(2230),
    [anon_sym_GT] = ACTIONS(2228),
    [anon_sym_GT_EQ] = ACTIONS(2230),
    [anon_sym_LT_EQ] = ACTIONS(2228),
    [anon_sym_LT] = ACTIONS(2228),
    [anon_sym_LT_LT] = ACTIONS(2228),
    [anon_sym_GT_GT] = ACTIONS(2228),
    [anon_sym_COLON] = ACTIONS(2228),
    [anon_sym___extension__] = ACTIONS(2228),
    [anon_sym_in] = ACTIONS(2228),
    [anon_sym_out] = ACTIONS(2228),
    [anon_sym_inout] = ACTIONS(2228),
    [anon_sym_extern] = ACTIONS(2228),
    [anon_sym___attribute__] = ACTIONS(2228),
    [anon_sym_COLON_COLON] = ACTIONS(2230),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2230),
    [anon_sym___declspec] = ACTIONS(2228),
    [anon_sym___based] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2228),
    [anon_sym_static] = ACTIONS(2228),
    [anon_sym_EQ] = ACTIONS(2228),
    [anon_sym_register] = ACTIONS(2228),
    [anon_sym_inline] = ACTIONS(2228),
    [anon_sym___inline] = ACTIONS(2228),
    [anon_sym___inline__] = ACTIONS(2228),
    [anon_sym___forceinline] = ACTIONS(2228),
    [anon_sym_thread_local] = ACTIONS(2228),
    [anon_sym___thread] = ACTIONS(2228),
    [anon_sym_const] = ACTIONS(2228),
    [anon_sym_constexpr] = ACTIONS(2228),
    [anon_sym_volatile] = ACTIONS(2228),
    [anon_sym_restrict] = ACTIONS(2228),
    [anon_sym___restrict__] = ACTIONS(2228),
    [anon_sym__Atomic] = ACTIONS(2228),
    [anon_sym__Noreturn] = ACTIONS(2228),
    [anon_sym_noreturn] = ACTIONS(2228),
    [anon_sym_mutable] = ACTIONS(2228),
    [anon_sym_constinit] = ACTIONS(2228),
    [anon_sym_consteval] = ACTIONS(2228),
    [anon_sym_alignas] = ACTIONS(2228),
    [anon_sym__Alignas] = ACTIONS(2228),
    [anon_sym_QMARK] = ACTIONS(2230),
    [anon_sym_STAR_EQ] = ACTIONS(2230),
    [anon_sym_SLASH_EQ] = ACTIONS(2230),
    [anon_sym_PERCENT_EQ] = ACTIONS(2230),
    [anon_sym_PLUS_EQ] = ACTIONS(2230),
    [anon_sym_DASH_EQ] = ACTIONS(2230),
    [anon_sym_LT_LT_EQ] = ACTIONS(2230),
    [anon_sym_GT_GT_EQ] = ACTIONS(2230),
    [anon_sym_AMP_EQ] = ACTIONS(2230),
    [anon_sym_CARET_EQ] = ACTIONS(2230),
    [anon_sym_PIPE_EQ] = ACTIONS(2230),
    [anon_sym_and_eq] = ACTIONS(2228),
    [anon_sym_or_eq] = ACTIONS(2228),
    [anon_sym_xor_eq] = ACTIONS(2228),
    [anon_sym_LT_EQ_GT] = ACTIONS(2230),
    [anon_sym_or] = ACTIONS(2228),
    [anon_sym_and] = ACTIONS(2228),
    [anon_sym_bitor] = ACTIONS(2228),
    [anon_sym_xor] = ACTIONS(2228),
    [anon_sym_bitand] = ACTIONS(2228),
    [anon_sym_not_eq] = ACTIONS(2228),
    [anon_sym_is] = ACTIONS(2228),
    [anon_sym_as] = ACTIONS(2228),
    [anon_sym_DASH_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_PLUS] = ACTIONS(2230),
    [anon_sym_DOT] = ACTIONS(2228),
    [anon_sym_DOT_STAR] = ACTIONS(2230),
    [anon_sym_DASH_GT] = ACTIONS(2228),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(2228),
    [anon_sym_This] = ACTIONS(2228),
    [anon_sym_decltype] = ACTIONS(2228),
    [sym_virtual] = ACTIONS(2228),
    [anon_sym_template] = ACTIONS(2228),
    [anon_sym_operator] = ACTIONS(2228),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2230),
    [anon_sym_precise] = ACTIONS(2228),
    [anon_sym_shared] = ACTIONS(2228),
    [anon_sym_groupshared] = ACTIONS(2228),
    [anon_sym_uniform] = ACTIONS(2228),
    [anon_sym_row_major] = ACTIONS(2228),
    [anon_sym_column_major] = ACTIONS(2228),
    [anon_sym_globallycoherent] = ACTIONS(2228),
    [anon_sym_centroid] = ACTIONS(2228),
    [anon_sym_noperspective] = ACTIONS(2228),
    [anon_sym_nointerpolation] = ACTIONS(2228),
    [anon_sym_sample] = ACTIONS(2228),
    [anon_sym_linear] = ACTIONS(2228),
    [anon_sym_snorm] = ACTIONS(2228),
    [anon_sym_unorm] = ACTIONS(2228),
    [anon_sym_point] = ACTIONS(2228),
    [anon_sym_line] = ACTIONS(2228),
    [anon_sym_triangleadj] = ACTIONS(2228),
    [anon_sym_lineadj] = ACTIONS(2228),
    [anon_sym_triangle] = ACTIONS(2228),
  },
  [1391] = {
    [sym_identifier] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_LPAREN2] = ACTIONS(2188),
    [anon_sym_TILDE] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2186),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_STAR] = ACTIONS(2186),
    [anon_sym_SLASH] = ACTIONS(2186),
    [anon_sym_PERCENT] = ACTIONS(2186),
    [anon_sym_PIPE_PIPE] = ACTIONS(2188),
    [anon_sym_AMP_AMP] = ACTIONS(2188),
    [anon_sym_PIPE] = ACTIONS(2186),
    [anon_sym_CARET] = ACTIONS(2186),
    [anon_sym_AMP] = ACTIONS(2186),
    [anon_sym_EQ_EQ] = ACTIONS(2188),
    [anon_sym_BANG_EQ] = ACTIONS(2188),
    [anon_sym_GT] = ACTIONS(2186),
    [anon_sym_GT_EQ] = ACTIONS(2188),
    [anon_sym_LT_EQ] = ACTIONS(2186),
    [anon_sym_LT] = ACTIONS(2186),
    [anon_sym_LT_LT] = ACTIONS(2186),
    [anon_sym_GT_GT] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym___extension__] = ACTIONS(2186),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_out] = ACTIONS(2186),
    [anon_sym_inout] = ACTIONS(2186),
    [anon_sym_extern] = ACTIONS(2186),
    [anon_sym___attribute__] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2188),
    [anon_sym___declspec] = ACTIONS(2186),
    [anon_sym___based] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_static] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_register] = ACTIONS(2186),
    [anon_sym_inline] = ACTIONS(2186),
    [anon_sym___inline] = ACTIONS(2186),
    [anon_sym___inline__] = ACTIONS(2186),
    [anon_sym___forceinline] = ACTIONS(2186),
    [anon_sym_thread_local] = ACTIONS(2186),
    [anon_sym___thread] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_constexpr] = ACTIONS(2186),
    [anon_sym_volatile] = ACTIONS(2186),
    [anon_sym_restrict] = ACTIONS(2186),
    [anon_sym___restrict__] = ACTIONS(2186),
    [anon_sym__Atomic] = ACTIONS(2186),
    [anon_sym__Noreturn] = ACTIONS(2186),
    [anon_sym_noreturn] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_constinit] = ACTIONS(2186),
    [anon_sym_consteval] = ACTIONS(2186),
    [anon_sym_alignas] = ACTIONS(2186),
    [anon_sym__Alignas] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_STAR_EQ] = ACTIONS(2188),
    [anon_sym_SLASH_EQ] = ACTIONS(2188),
    [anon_sym_PERCENT_EQ] = ACTIONS(2188),
    [anon_sym_PLUS_EQ] = ACTIONS(2188),
    [anon_sym_DASH_EQ] = ACTIONS(2188),
    [anon_sym_LT_LT_EQ] = ACTIONS(2188),
    [anon_sym_GT_GT_EQ] = ACTIONS(2188),
    [anon_sym_AMP_EQ] = ACTIONS(2188),
    [anon_sym_CARET_EQ] = ACTIONS(2188),
    [anon_sym_PIPE_EQ] = ACTIONS(2188),
    [anon_sym_and_eq] = ACTIONS(2186),
    [anon_sym_or_eq] = ACTIONS(2186),
    [anon_sym_xor_eq] = ACTIONS(2186),
    [anon_sym_LT_EQ_GT] = ACTIONS(2188),
    [anon_sym_or] = ACTIONS(2186),
    [anon_sym_and] = ACTIONS(2186),
    [anon_sym_bitor] = ACTIONS(2186),
    [anon_sym_xor] = ACTIONS(2186),
    [anon_sym_bitand] = ACTIONS(2186),
    [anon_sym_not_eq] = ACTIONS(2186),
    [anon_sym_is] = ACTIONS(2186),
    [anon_sym_as] = ACTIONS(2186),
    [anon_sym_DASH_DASH] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2188),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOT_STAR] = ACTIONS(2188),
    [anon_sym_DASH_GT] = ACTIONS(2186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_This] = ACTIONS(2186),
    [anon_sym_decltype] = ACTIONS(2186),
    [sym_virtual] = ACTIONS(2186),
    [anon_sym_template] = ACTIONS(2186),
    [anon_sym_operator] = ACTIONS(2186),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2188),
    [anon_sym_precise] = ACTIONS(2186),
    [anon_sym_shared] = ACTIONS(2186),
    [anon_sym_groupshared] = ACTIONS(2186),
    [anon_sym_uniform] = ACTIONS(2186),
    [anon_sym_row_major] = ACTIONS(2186),
    [anon_sym_column_major] = ACTIONS(2186),
    [anon_sym_globallycoherent] = ACTIONS(2186),
    [anon_sym_centroid] = ACTIONS(2186),
    [anon_sym_noperspective] = ACTIONS(2186),
    [anon_sym_nointerpolation] = ACTIONS(2186),
    [anon_sym_sample] = ACTIONS(2186),
    [anon_sym_linear] = ACTIONS(2186),
    [anon_sym_snorm] = ACTIONS(2186),
    [anon_sym_unorm] = ACTIONS(2186),
    [anon_sym_point] = ACTIONS(2186),
    [anon_sym_line] = ACTIONS(2186),
    [anon_sym_triangleadj] = ACTIONS(2186),
    [anon_sym_lineadj] = ACTIONS(2186),
    [anon_sym_triangle] = ACTIONS(2186),
  },
  [1392] = {
    [sym_identifier] = ACTIONS(2206),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2208),
    [anon_sym_COMMA] = ACTIONS(2208),
    [anon_sym_RPAREN] = ACTIONS(2208),
    [anon_sym_LPAREN2] = ACTIONS(2208),
    [anon_sym_TILDE] = ACTIONS(2208),
    [anon_sym_DASH] = ACTIONS(2206),
    [anon_sym_PLUS] = ACTIONS(2206),
    [anon_sym_STAR] = ACTIONS(2206),
    [anon_sym_SLASH] = ACTIONS(2206),
    [anon_sym_PERCENT] = ACTIONS(2206),
    [anon_sym_PIPE_PIPE] = ACTIONS(2208),
    [anon_sym_AMP_AMP] = ACTIONS(2208),
    [anon_sym_PIPE] = ACTIONS(2206),
    [anon_sym_CARET] = ACTIONS(2206),
    [anon_sym_AMP] = ACTIONS(2206),
    [anon_sym_EQ_EQ] = ACTIONS(2208),
    [anon_sym_BANG_EQ] = ACTIONS(2208),
    [anon_sym_GT] = ACTIONS(2206),
    [anon_sym_GT_EQ] = ACTIONS(2208),
    [anon_sym_LT_EQ] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2206),
    [anon_sym_LT_LT] = ACTIONS(2206),
    [anon_sym_GT_GT] = ACTIONS(2206),
    [anon_sym_COLON] = ACTIONS(2206),
    [anon_sym___extension__] = ACTIONS(2206),
    [anon_sym_in] = ACTIONS(2206),
    [anon_sym_out] = ACTIONS(2206),
    [anon_sym_inout] = ACTIONS(2206),
    [anon_sym_extern] = ACTIONS(2206),
    [anon_sym___attribute__] = ACTIONS(2206),
    [anon_sym_COLON_COLON] = ACTIONS(2208),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2208),
    [anon_sym___declspec] = ACTIONS(2206),
    [anon_sym___based] = ACTIONS(2206),
    [anon_sym_LBRACE] = ACTIONS(2208),
    [anon_sym_LBRACK] = ACTIONS(2206),
    [anon_sym_static] = ACTIONS(2206),
    [anon_sym_EQ] = ACTIONS(2206),
    [anon_sym_register] = ACTIONS(2206),
    [anon_sym_inline] = ACTIONS(2206),
    [anon_sym___inline] = ACTIONS(2206),
    [anon_sym___inline__] = ACTIONS(2206),
    [anon_sym___forceinline] = ACTIONS(2206),
    [anon_sym_thread_local] = ACTIONS(2206),
    [anon_sym___thread] = ACTIONS(2206),
    [anon_sym_const] = ACTIONS(2206),
    [anon_sym_constexpr] = ACTIONS(2206),
    [anon_sym_volatile] = ACTIONS(2206),
    [anon_sym_restrict] = ACTIONS(2206),
    [anon_sym___restrict__] = ACTIONS(2206),
    [anon_sym__Atomic] = ACTIONS(2206),
    [anon_sym__Noreturn] = ACTIONS(2206),
    [anon_sym_noreturn] = ACTIONS(2206),
    [anon_sym_mutable] = ACTIONS(2206),
    [anon_sym_constinit] = ACTIONS(2206),
    [anon_sym_consteval] = ACTIONS(2206),
    [anon_sym_alignas] = ACTIONS(2206),
    [anon_sym__Alignas] = ACTIONS(2206),
    [anon_sym_QMARK] = ACTIONS(2208),
    [anon_sym_STAR_EQ] = ACTIONS(2208),
    [anon_sym_SLASH_EQ] = ACTIONS(2208),
    [anon_sym_PERCENT_EQ] = ACTIONS(2208),
    [anon_sym_PLUS_EQ] = ACTIONS(2208),
    [anon_sym_DASH_EQ] = ACTIONS(2208),
    [anon_sym_LT_LT_EQ] = ACTIONS(2208),
    [anon_sym_GT_GT_EQ] = ACTIONS(2208),
    [anon_sym_AMP_EQ] = ACTIONS(2208),
    [anon_sym_CARET_EQ] = ACTIONS(2208),
    [anon_sym_PIPE_EQ] = ACTIONS(2208),
    [anon_sym_and_eq] = ACTIONS(2206),
    [anon_sym_or_eq] = ACTIONS(2206),
    [anon_sym_xor_eq] = ACTIONS(2206),
    [anon_sym_LT_EQ_GT] = ACTIONS(2208),
    [anon_sym_or] = ACTIONS(2206),
    [anon_sym_and] = ACTIONS(2206),
    [anon_sym_bitor] = ACTIONS(2206),
    [anon_sym_xor] = ACTIONS(2206),
    [anon_sym_bitand] = ACTIONS(2206),
    [anon_sym_not_eq] = ACTIONS(2206),
    [anon_sym_is] = ACTIONS(2206),
    [anon_sym_as] = ACTIONS(2206),
    [anon_sym_DASH_DASH] = ACTIONS(2208),
    [anon_sym_PLUS_PLUS] = ACTIONS(2208),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_DOT_STAR] = ACTIONS(2208),
    [anon_sym_DASH_GT] = ACTIONS(2206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2206),
    [anon_sym_let] = ACTIONS(2206),
    [anon_sym_This] = ACTIONS(2206),
    [anon_sym_decltype] = ACTIONS(2206),
    [sym_virtual] = ACTIONS(2206),
    [anon_sym_template] = ACTIONS(2206),
    [anon_sym_operator] = ACTIONS(2206),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2208),
    [anon_sym_precise] = ACTIONS(2206),
    [anon_sym_shared] = ACTIONS(2206),
    [anon_sym_groupshared] = ACTIONS(2206),
    [anon_sym_uniform] = ACTIONS(2206),
    [anon_sym_row_major] = ACTIONS(2206),
    [anon_sym_column_major] = ACTIONS(2206),
    [anon_sym_globallycoherent] = ACTIONS(2206),
    [anon_sym_centroid] = ACTIONS(2206),
    [anon_sym_noperspective] = ACTIONS(2206),
    [anon_sym_nointerpolation] = ACTIONS(2206),
    [anon_sym_sample] = ACTIONS(2206),
    [anon_sym_linear] = ACTIONS(2206),
    [anon_sym_snorm] = ACTIONS(2206),
    [anon_sym_unorm] = ACTIONS(2206),
    [anon_sym_point] = ACTIONS(2206),
    [anon_sym_line] = ACTIONS(2206),
    [anon_sym_triangleadj] = ACTIONS(2206),
    [anon_sym_lineadj] = ACTIONS(2206),
    [anon_sym_triangle] = ACTIONS(2206),
  },
  [1393] = {
    [sym_identifier] = ACTIONS(2210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2214),
    [anon_sym_COMMA] = ACTIONS(2214),
    [anon_sym_RPAREN] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(2214),
    [anon_sym_TILDE] = ACTIONS(2217),
    [anon_sym_DASH] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(2222),
    [anon_sym_STAR] = ACTIONS(2219),
    [anon_sym_SLASH] = ACTIONS(2222),
    [anon_sym_PERCENT] = ACTIONS(2222),
    [anon_sym_PIPE_PIPE] = ACTIONS(2212),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2222),
    [anon_sym_CARET] = ACTIONS(2222),
    [anon_sym_AMP] = ACTIONS(2219),
    [anon_sym_EQ_EQ] = ACTIONS(2212),
    [anon_sym_BANG_EQ] = ACTIONS(2212),
    [anon_sym_GT] = ACTIONS(2222),
    [anon_sym_GT_EQ] = ACTIONS(2212),
    [anon_sym_LT_EQ] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(2222),
    [anon_sym_LT_LT] = ACTIONS(2222),
    [anon_sym_GT_GT] = ACTIONS(2222),
    [anon_sym_COLON] = ACTIONS(2210),
    [anon_sym___extension__] = ACTIONS(2210),
    [anon_sym_in] = ACTIONS(2210),
    [anon_sym_out] = ACTIONS(2210),
    [anon_sym_inout] = ACTIONS(2210),
    [anon_sym_extern] = ACTIONS(2210),
    [anon_sym___attribute__] = ACTIONS(2210),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2217),
    [anon_sym___declspec] = ACTIONS(2210),
    [anon_sym___based] = ACTIONS(2210),
    [anon_sym_LBRACE] = ACTIONS(2217),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_static] = ACTIONS(2210),
    [anon_sym_EQ] = ACTIONS(2219),
    [anon_sym_register] = ACTIONS(2210),
    [anon_sym_inline] = ACTIONS(2210),
    [anon_sym___inline] = ACTIONS(2210),
    [anon_sym___inline__] = ACTIONS(2210),
    [anon_sym___forceinline] = ACTIONS(2210),
    [anon_sym_thread_local] = ACTIONS(2210),
    [anon_sym___thread] = ACTIONS(2210),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_constexpr] = ACTIONS(2210),
    [anon_sym_volatile] = ACTIONS(2210),
    [anon_sym_restrict] = ACTIONS(2210),
    [anon_sym___restrict__] = ACTIONS(2210),
    [anon_sym__Atomic] = ACTIONS(2210),
    [anon_sym__Noreturn] = ACTIONS(2210),
    [anon_sym_noreturn] = ACTIONS(2210),
    [anon_sym_mutable] = ACTIONS(2210),
    [anon_sym_constinit] = ACTIONS(2210),
    [anon_sym_consteval] = ACTIONS(2210),
    [anon_sym_alignas] = ACTIONS(2210),
    [anon_sym__Alignas] = ACTIONS(2210),
    [anon_sym_QMARK] = ACTIONS(2212),
    [anon_sym_STAR_EQ] = ACTIONS(2212),
    [anon_sym_SLASH_EQ] = ACTIONS(2212),
    [anon_sym_PERCENT_EQ] = ACTIONS(2212),
    [anon_sym_PLUS_EQ] = ACTIONS(2212),
    [anon_sym_DASH_EQ] = ACTIONS(2212),
    [anon_sym_LT_LT_EQ] = ACTIONS(2212),
    [anon_sym_GT_GT_EQ] = ACTIONS(2212),
    [anon_sym_AMP_EQ] = ACTIONS(2212),
    [anon_sym_CARET_EQ] = ACTIONS(2212),
    [anon_sym_PIPE_EQ] = ACTIONS(2212),
    [anon_sym_and_eq] = ACTIONS(2222),
    [anon_sym_or_eq] = ACTIONS(2222),
    [anon_sym_xor_eq] = ACTIONS(2222),
    [anon_sym_LT_EQ_GT] = ACTIONS(2212),
    [anon_sym_or] = ACTIONS(2222),
    [anon_sym_and] = ACTIONS(2222),
    [anon_sym_bitor] = ACTIONS(2222),
    [anon_sym_xor] = ACTIONS(2222),
    [anon_sym_bitand] = ACTIONS(2222),
    [anon_sym_not_eq] = ACTIONS(2222),
    [anon_sym_is] = ACTIONS(2222),
    [anon_sym_as] = ACTIONS(2222),
    [anon_sym_DASH_DASH] = ACTIONS(2212),
    [anon_sym_PLUS_PLUS] = ACTIONS(2212),
    [anon_sym_DOT] = ACTIONS(2219),
    [anon_sym_DOT_STAR] = ACTIONS(2212),
    [anon_sym_DASH_GT] = ACTIONS(2222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2210),
    [anon_sym_let] = ACTIONS(2210),
    [anon_sym_This] = ACTIONS(2210),
    [anon_sym_decltype] = ACTIONS(2210),
    [sym_virtual] = ACTIONS(2210),
    [anon_sym_template] = ACTIONS(2210),
    [anon_sym_operator] = ACTIONS(2210),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2212),
    [anon_sym_precise] = ACTIONS(2210),
    [anon_sym_shared] = ACTIONS(2210),
    [anon_sym_groupshared] = ACTIONS(2210),
    [anon_sym_uniform] = ACTIONS(2210),
    [anon_sym_row_major] = ACTIONS(2210),
    [anon_sym_column_major] = ACTIONS(2210),
    [anon_sym_globallycoherent] = ACTIONS(2210),
    [anon_sym_centroid] = ACTIONS(2210),
    [anon_sym_noperspective] = ACTIONS(2210),
    [anon_sym_nointerpolation] = ACTIONS(2210),
    [anon_sym_sample] = ACTIONS(2210),
    [anon_sym_linear] = ACTIONS(2210),
    [anon_sym_snorm] = ACTIONS(2210),
    [anon_sym_unorm] = ACTIONS(2210),
    [anon_sym_point] = ACTIONS(2210),
    [anon_sym_line] = ACTIONS(2210),
    [anon_sym_triangleadj] = ACTIONS(2210),
    [anon_sym_lineadj] = ACTIONS(2210),
    [anon_sym_triangle] = ACTIONS(2210),
  },
  [1394] = {
    [sym_identifier] = ACTIONS(2236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2238),
    [anon_sym_COMMA] = ACTIONS(2238),
    [anon_sym_RPAREN] = ACTIONS(2238),
    [anon_sym_LPAREN2] = ACTIONS(2238),
    [anon_sym_TILDE] = ACTIONS(2238),
    [anon_sym_DASH] = ACTIONS(2236),
    [anon_sym_PLUS] = ACTIONS(2236),
    [anon_sym_STAR] = ACTIONS(2236),
    [anon_sym_SLASH] = ACTIONS(2236),
    [anon_sym_PERCENT] = ACTIONS(2236),
    [anon_sym_PIPE_PIPE] = ACTIONS(2238),
    [anon_sym_AMP_AMP] = ACTIONS(2238),
    [anon_sym_PIPE] = ACTIONS(2236),
    [anon_sym_CARET] = ACTIONS(2236),
    [anon_sym_AMP] = ACTIONS(2236),
    [anon_sym_EQ_EQ] = ACTIONS(2238),
    [anon_sym_BANG_EQ] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2236),
    [anon_sym_GT_EQ] = ACTIONS(2238),
    [anon_sym_LT_EQ] = ACTIONS(2236),
    [anon_sym_LT] = ACTIONS(2236),
    [anon_sym_LT_LT] = ACTIONS(2236),
    [anon_sym_GT_GT] = ACTIONS(2236),
    [anon_sym_COLON] = ACTIONS(2236),
    [anon_sym___extension__] = ACTIONS(2236),
    [anon_sym_in] = ACTIONS(2236),
    [anon_sym_out] = ACTIONS(2236),
    [anon_sym_inout] = ACTIONS(2236),
    [anon_sym_extern] = ACTIONS(2236),
    [anon_sym___attribute__] = ACTIONS(2236),
    [anon_sym_COLON_COLON] = ACTIONS(2238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2238),
    [anon_sym___declspec] = ACTIONS(2236),
    [anon_sym___based] = ACTIONS(2236),
    [anon_sym_LBRACE] = ACTIONS(2238),
    [anon_sym_LBRACK] = ACTIONS(2236),
    [anon_sym_static] = ACTIONS(2236),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_register] = ACTIONS(2236),
    [anon_sym_inline] = ACTIONS(2236),
    [anon_sym___inline] = ACTIONS(2236),
    [anon_sym___inline__] = ACTIONS(2236),
    [anon_sym___forceinline] = ACTIONS(2236),
    [anon_sym_thread_local] = ACTIONS(2236),
    [anon_sym___thread] = ACTIONS(2236),
    [anon_sym_const] = ACTIONS(2236),
    [anon_sym_constexpr] = ACTIONS(2236),
    [anon_sym_volatile] = ACTIONS(2236),
    [anon_sym_restrict] = ACTIONS(2236),
    [anon_sym___restrict__] = ACTIONS(2236),
    [anon_sym__Atomic] = ACTIONS(2236),
    [anon_sym__Noreturn] = ACTIONS(2236),
    [anon_sym_noreturn] = ACTIONS(2236),
    [anon_sym_mutable] = ACTIONS(2236),
    [anon_sym_constinit] = ACTIONS(2236),
    [anon_sym_consteval] = ACTIONS(2236),
    [anon_sym_alignas] = ACTIONS(2236),
    [anon_sym__Alignas] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2238),
    [anon_sym_SLASH_EQ] = ACTIONS(2238),
    [anon_sym_PERCENT_EQ] = ACTIONS(2238),
    [anon_sym_PLUS_EQ] = ACTIONS(2238),
    [anon_sym_DASH_EQ] = ACTIONS(2238),
    [anon_sym_LT_LT_EQ] = ACTIONS(2238),
    [anon_sym_GT_GT_EQ] = ACTIONS(2238),
    [anon_sym_AMP_EQ] = ACTIONS(2238),
    [anon_sym_CARET_EQ] = ACTIONS(2238),
    [anon_sym_PIPE_EQ] = ACTIONS(2238),
    [anon_sym_and_eq] = ACTIONS(2236),
    [anon_sym_or_eq] = ACTIONS(2236),
    [anon_sym_xor_eq] = ACTIONS(2236),
    [anon_sym_LT_EQ_GT] = ACTIONS(2238),
    [anon_sym_or] = ACTIONS(2236),
    [anon_sym_and] = ACTIONS(2236),
    [anon_sym_bitor] = ACTIONS(2236),
    [anon_sym_xor] = ACTIONS(2236),
    [anon_sym_bitand] = ACTIONS(2236),
    [anon_sym_not_eq] = ACTIONS(2236),
    [anon_sym_is] = ACTIONS(2236),
    [anon_sym_as] = ACTIONS(2236),
    [anon_sym_DASH_DASH] = ACTIONS(2238),
    [anon_sym_PLUS_PLUS] = ACTIONS(2238),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_DOT_STAR] = ACTIONS(2238),
    [anon_sym_DASH_GT] = ACTIONS(2236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2236),
    [anon_sym_let] = ACTIONS(2236),
    [anon_sym_This] = ACTIONS(2236),
    [anon_sym_decltype] = ACTIONS(2236),
    [sym_virtual] = ACTIONS(2236),
    [anon_sym_template] = ACTIONS(2236),
    [anon_sym_operator] = ACTIONS(2236),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2238),
    [anon_sym_precise] = ACTIONS(2236),
    [anon_sym_shared] = ACTIONS(2236),
    [anon_sym_groupshared] = ACTIONS(2236),
    [anon_sym_uniform] = ACTIONS(2236),
    [anon_sym_row_major] = ACTIONS(2236),
    [anon_sym_column_major] = ACTIONS(2236),
    [anon_sym_globallycoherent] = ACTIONS(2236),
    [anon_sym_centroid] = ACTIONS(2236),
    [anon_sym_noperspective] = ACTIONS(2236),
    [anon_sym_nointerpolation] = ACTIONS(2236),
    [anon_sym_sample] = ACTIONS(2236),
    [anon_sym_linear] = ACTIONS(2236),
    [anon_sym_snorm] = ACTIONS(2236),
    [anon_sym_unorm] = ACTIONS(2236),
    [anon_sym_point] = ACTIONS(2236),
    [anon_sym_line] = ACTIONS(2236),
    [anon_sym_triangleadj] = ACTIONS(2236),
    [anon_sym_lineadj] = ACTIONS(2236),
    [anon_sym_triangle] = ACTIONS(2236),
  },
  [1395] = {
    [sym_type_qualifier] = STATE(2940),
    [sym_alignas_qualifier] = STATE(2994),
    [sym_expression] = STATE(5588),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [aux_sym_array_declarator_repeat1] = STATE(2940),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(5040),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(5042),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_static] = ACTIONS(5044),
    [anon_sym_RBRACK] = ACTIONS(5046),
    [anon_sym_const] = ACTIONS(5042),
    [anon_sym_constexpr] = ACTIONS(5042),
    [anon_sym_volatile] = ACTIONS(5042),
    [anon_sym_restrict] = ACTIONS(5042),
    [anon_sym___restrict__] = ACTIONS(5042),
    [anon_sym__Atomic] = ACTIONS(5042),
    [anon_sym__Noreturn] = ACTIONS(5042),
    [anon_sym_noreturn] = ACTIONS(5042),
    [anon_sym_mutable] = ACTIONS(5042),
    [anon_sym_constinit] = ACTIONS(5042),
    [anon_sym_consteval] = ACTIONS(5042),
    [anon_sym_alignas] = ACTIONS(5048),
    [anon_sym__Alignas] = ACTIONS(5048),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1396] = {
    [sym_type_qualifier] = STATE(2940),
    [sym_alignas_qualifier] = STATE(2994),
    [sym_expression] = STATE(5501),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [aux_sym_array_declarator_repeat1] = STATE(2940),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(5050),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(5042),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_static] = ACTIONS(5044),
    [anon_sym_RBRACK] = ACTIONS(5052),
    [anon_sym_const] = ACTIONS(5042),
    [anon_sym_constexpr] = ACTIONS(5042),
    [anon_sym_volatile] = ACTIONS(5042),
    [anon_sym_restrict] = ACTIONS(5042),
    [anon_sym___restrict__] = ACTIONS(5042),
    [anon_sym__Atomic] = ACTIONS(5042),
    [anon_sym__Noreturn] = ACTIONS(5042),
    [anon_sym_noreturn] = ACTIONS(5042),
    [anon_sym_mutable] = ACTIONS(5042),
    [anon_sym_constinit] = ACTIONS(5042),
    [anon_sym_consteval] = ACTIONS(5042),
    [anon_sym_alignas] = ACTIONS(5048),
    [anon_sym__Alignas] = ACTIONS(5048),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1397] = {
    [sym_type_qualifier] = STATE(1409),
    [sym_alignas_qualifier] = STATE(2994),
    [sym_expression] = STATE(5515),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [aux_sym_array_declarator_repeat1] = STATE(1409),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(5054),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(5042),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_static] = ACTIONS(5056),
    [anon_sym_RBRACK] = ACTIONS(5058),
    [anon_sym_const] = ACTIONS(5042),
    [anon_sym_constexpr] = ACTIONS(5042),
    [anon_sym_volatile] = ACTIONS(5042),
    [anon_sym_restrict] = ACTIONS(5042),
    [anon_sym___restrict__] = ACTIONS(5042),
    [anon_sym__Atomic] = ACTIONS(5042),
    [anon_sym__Noreturn] = ACTIONS(5042),
    [anon_sym_noreturn] = ACTIONS(5042),
    [anon_sym_mutable] = ACTIONS(5042),
    [anon_sym_constinit] = ACTIONS(5042),
    [anon_sym_consteval] = ACTIONS(5042),
    [anon_sym_alignas] = ACTIONS(5048),
    [anon_sym__Alignas] = ACTIONS(5048),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1398] = {
    [sym_identifier] = ACTIONS(2210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2212),
    [anon_sym_COMMA] = ACTIONS(2212),
    [anon_sym_RPAREN] = ACTIONS(2212),
    [anon_sym_LPAREN2] = ACTIONS(2214),
    [anon_sym_TILDE] = ACTIONS(2217),
    [anon_sym_DASH] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(2222),
    [anon_sym_STAR] = ACTIONS(2219),
    [anon_sym_SLASH] = ACTIONS(2222),
    [anon_sym_PERCENT] = ACTIONS(2222),
    [anon_sym_PIPE_PIPE] = ACTIONS(2212),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2222),
    [anon_sym_CARET] = ACTIONS(2222),
    [anon_sym_AMP] = ACTIONS(2219),
    [anon_sym_EQ_EQ] = ACTIONS(2212),
    [anon_sym_BANG_EQ] = ACTIONS(2212),
    [anon_sym_GT] = ACTIONS(2222),
    [anon_sym_GT_EQ] = ACTIONS(2212),
    [anon_sym_LT_EQ] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(2222),
    [anon_sym_LT_LT] = ACTIONS(2222),
    [anon_sym_GT_GT] = ACTIONS(2222),
    [anon_sym_SEMI] = ACTIONS(2212),
    [anon_sym___extension__] = ACTIONS(2210),
    [anon_sym_in] = ACTIONS(2210),
    [anon_sym_out] = ACTIONS(2210),
    [anon_sym_inout] = ACTIONS(2210),
    [anon_sym_extern] = ACTIONS(2210),
    [anon_sym___attribute__] = ACTIONS(2210),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2217),
    [anon_sym___declspec] = ACTIONS(2210),
    [anon_sym___based] = ACTIONS(2210),
    [anon_sym_LBRACE] = ACTIONS(2217),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_static] = ACTIONS(2210),
    [anon_sym_EQ] = ACTIONS(2222),
    [anon_sym_register] = ACTIONS(2210),
    [anon_sym_inline] = ACTIONS(2210),
    [anon_sym___inline] = ACTIONS(2210),
    [anon_sym___inline__] = ACTIONS(2210),
    [anon_sym___forceinline] = ACTIONS(2210),
    [anon_sym_thread_local] = ACTIONS(2210),
    [anon_sym___thread] = ACTIONS(2210),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_constexpr] = ACTIONS(2210),
    [anon_sym_volatile] = ACTIONS(2210),
    [anon_sym_restrict] = ACTIONS(2210),
    [anon_sym___restrict__] = ACTIONS(2210),
    [anon_sym__Atomic] = ACTIONS(2210),
    [anon_sym__Noreturn] = ACTIONS(2210),
    [anon_sym_noreturn] = ACTIONS(2210),
    [anon_sym_mutable] = ACTIONS(2210),
    [anon_sym_constinit] = ACTIONS(2210),
    [anon_sym_consteval] = ACTIONS(2210),
    [anon_sym_alignas] = ACTIONS(2210),
    [anon_sym__Alignas] = ACTIONS(2210),
    [anon_sym_QMARK] = ACTIONS(2212),
    [anon_sym_STAR_EQ] = ACTIONS(2212),
    [anon_sym_SLASH_EQ] = ACTIONS(2212),
    [anon_sym_PERCENT_EQ] = ACTIONS(2212),
    [anon_sym_PLUS_EQ] = ACTIONS(2212),
    [anon_sym_DASH_EQ] = ACTIONS(2212),
    [anon_sym_LT_LT_EQ] = ACTIONS(2212),
    [anon_sym_GT_GT_EQ] = ACTIONS(2212),
    [anon_sym_AMP_EQ] = ACTIONS(2212),
    [anon_sym_CARET_EQ] = ACTIONS(2212),
    [anon_sym_PIPE_EQ] = ACTIONS(2212),
    [anon_sym_and_eq] = ACTIONS(2222),
    [anon_sym_or_eq] = ACTIONS(2222),
    [anon_sym_xor_eq] = ACTIONS(2222),
    [anon_sym_LT_EQ_GT] = ACTIONS(2212),
    [anon_sym_or] = ACTIONS(2222),
    [anon_sym_and] = ACTIONS(2222),
    [anon_sym_bitor] = ACTIONS(2222),
    [anon_sym_xor] = ACTIONS(2222),
    [anon_sym_bitand] = ACTIONS(2222),
    [anon_sym_not_eq] = ACTIONS(2222),
    [anon_sym_is] = ACTIONS(2222),
    [anon_sym_as] = ACTIONS(2222),
    [anon_sym_DASH_DASH] = ACTIONS(2212),
    [anon_sym_PLUS_PLUS] = ACTIONS(2212),
    [anon_sym_DOT] = ACTIONS(2219),
    [anon_sym_DOT_STAR] = ACTIONS(2212),
    [anon_sym_DASH_GT] = ACTIONS(2212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2210),
    [anon_sym_let] = ACTIONS(2210),
    [anon_sym_This] = ACTIONS(2210),
    [anon_sym_decltype] = ACTIONS(2210),
    [sym_virtual] = ACTIONS(2210),
    [anon_sym_template] = ACTIONS(2210),
    [anon_sym_operator] = ACTIONS(2210),
    [anon_sym_precise] = ACTIONS(2210),
    [anon_sym_shared] = ACTIONS(2210),
    [anon_sym_groupshared] = ACTIONS(2210),
    [anon_sym_uniform] = ACTIONS(2210),
    [anon_sym_row_major] = ACTIONS(2210),
    [anon_sym_column_major] = ACTIONS(2210),
    [anon_sym_globallycoherent] = ACTIONS(2210),
    [anon_sym_centroid] = ACTIONS(2210),
    [anon_sym_noperspective] = ACTIONS(2210),
    [anon_sym_nointerpolation] = ACTIONS(2210),
    [anon_sym_sample] = ACTIONS(2210),
    [anon_sym_linear] = ACTIONS(2210),
    [anon_sym_snorm] = ACTIONS(2210),
    [anon_sym_unorm] = ACTIONS(2210),
    [anon_sym_point] = ACTIONS(2210),
    [anon_sym_line] = ACTIONS(2210),
    [anon_sym_triangleadj] = ACTIONS(2210),
    [anon_sym_lineadj] = ACTIONS(2210),
    [anon_sym_triangle] = ACTIONS(2210),
  },
  [1399] = {
    [sym_type_qualifier] = STATE(2940),
    [sym_alignas_qualifier] = STATE(2994),
    [sym_expression] = STATE(5506),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [aux_sym_array_declarator_repeat1] = STATE(2940),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(5060),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(5042),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_static] = ACTIONS(5044),
    [anon_sym_RBRACK] = ACTIONS(5062),
    [anon_sym_const] = ACTIONS(5042),
    [anon_sym_constexpr] = ACTIONS(5042),
    [anon_sym_volatile] = ACTIONS(5042),
    [anon_sym_restrict] = ACTIONS(5042),
    [anon_sym___restrict__] = ACTIONS(5042),
    [anon_sym__Atomic] = ACTIONS(5042),
    [anon_sym__Noreturn] = ACTIONS(5042),
    [anon_sym_noreturn] = ACTIONS(5042),
    [anon_sym_mutable] = ACTIONS(5042),
    [anon_sym_constinit] = ACTIONS(5042),
    [anon_sym_consteval] = ACTIONS(5042),
    [anon_sym_alignas] = ACTIONS(5048),
    [anon_sym__Alignas] = ACTIONS(5048),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1400] = {
    [sym_type_qualifier] = STATE(2940),
    [sym_alignas_qualifier] = STATE(2994),
    [sym_expression] = STATE(5571),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [aux_sym_array_declarator_repeat1] = STATE(2940),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(5064),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(5042),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_static] = ACTIONS(5044),
    [anon_sym_RBRACK] = ACTIONS(5066),
    [anon_sym_const] = ACTIONS(5042),
    [anon_sym_constexpr] = ACTIONS(5042),
    [anon_sym_volatile] = ACTIONS(5042),
    [anon_sym_restrict] = ACTIONS(5042),
    [anon_sym___restrict__] = ACTIONS(5042),
    [anon_sym__Atomic] = ACTIONS(5042),
    [anon_sym__Noreturn] = ACTIONS(5042),
    [anon_sym_noreturn] = ACTIONS(5042),
    [anon_sym_mutable] = ACTIONS(5042),
    [anon_sym_constinit] = ACTIONS(5042),
    [anon_sym_consteval] = ACTIONS(5042),
    [anon_sym_alignas] = ACTIONS(5048),
    [anon_sym__Alignas] = ACTIONS(5048),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1401] = {
    [sym_type_qualifier] = STATE(1399),
    [sym_alignas_qualifier] = STATE(2994),
    [sym_expression] = STATE(5520),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [aux_sym_array_declarator_repeat1] = STATE(1399),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(5068),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(5042),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_static] = ACTIONS(5070),
    [anon_sym_RBRACK] = ACTIONS(5072),
    [anon_sym_const] = ACTIONS(5042),
    [anon_sym_constexpr] = ACTIONS(5042),
    [anon_sym_volatile] = ACTIONS(5042),
    [anon_sym_restrict] = ACTIONS(5042),
    [anon_sym___restrict__] = ACTIONS(5042),
    [anon_sym__Atomic] = ACTIONS(5042),
    [anon_sym__Noreturn] = ACTIONS(5042),
    [anon_sym_noreturn] = ACTIONS(5042),
    [anon_sym_mutable] = ACTIONS(5042),
    [anon_sym_constinit] = ACTIONS(5042),
    [anon_sym_consteval] = ACTIONS(5042),
    [anon_sym_alignas] = ACTIONS(5048),
    [anon_sym__Alignas] = ACTIONS(5048),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1402] = {
    [sym_type_qualifier] = STATE(1395),
    [sym_alignas_qualifier] = STATE(2994),
    [sym_expression] = STATE(5499),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [aux_sym_array_declarator_repeat1] = STATE(1395),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(5074),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(5042),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_static] = ACTIONS(5076),
    [anon_sym_RBRACK] = ACTIONS(5078),
    [anon_sym_const] = ACTIONS(5042),
    [anon_sym_constexpr] = ACTIONS(5042),
    [anon_sym_volatile] = ACTIONS(5042),
    [anon_sym_restrict] = ACTIONS(5042),
    [anon_sym___restrict__] = ACTIONS(5042),
    [anon_sym__Atomic] = ACTIONS(5042),
    [anon_sym__Noreturn] = ACTIONS(5042),
    [anon_sym_noreturn] = ACTIONS(5042),
    [anon_sym_mutable] = ACTIONS(5042),
    [anon_sym_constinit] = ACTIONS(5042),
    [anon_sym_consteval] = ACTIONS(5042),
    [anon_sym_alignas] = ACTIONS(5048),
    [anon_sym__Alignas] = ACTIONS(5048),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1403] = {
    [sym_type_qualifier] = STATE(2940),
    [sym_alignas_qualifier] = STATE(2994),
    [sym_expression] = STATE(5494),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [aux_sym_array_declarator_repeat1] = STATE(2940),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(5080),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(5042),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_static] = ACTIONS(5044),
    [anon_sym_RBRACK] = ACTIONS(5082),
    [anon_sym_const] = ACTIONS(5042),
    [anon_sym_constexpr] = ACTIONS(5042),
    [anon_sym_volatile] = ACTIONS(5042),
    [anon_sym_restrict] = ACTIONS(5042),
    [anon_sym___restrict__] = ACTIONS(5042),
    [anon_sym__Atomic] = ACTIONS(5042),
    [anon_sym__Noreturn] = ACTIONS(5042),
    [anon_sym_noreturn] = ACTIONS(5042),
    [anon_sym_mutable] = ACTIONS(5042),
    [anon_sym_constinit] = ACTIONS(5042),
    [anon_sym_consteval] = ACTIONS(5042),
    [anon_sym_alignas] = ACTIONS(5048),
    [anon_sym__Alignas] = ACTIONS(5048),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1404] = {
    [sym_type_qualifier] = STATE(2940),
    [sym_alignas_qualifier] = STATE(2994),
    [sym_expression] = STATE(5540),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [aux_sym_array_declarator_repeat1] = STATE(2940),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(5084),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(5042),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_static] = ACTIONS(5044),
    [anon_sym_RBRACK] = ACTIONS(5086),
    [anon_sym_const] = ACTIONS(5042),
    [anon_sym_constexpr] = ACTIONS(5042),
    [anon_sym_volatile] = ACTIONS(5042),
    [anon_sym_restrict] = ACTIONS(5042),
    [anon_sym___restrict__] = ACTIONS(5042),
    [anon_sym__Atomic] = ACTIONS(5042),
    [anon_sym__Noreturn] = ACTIONS(5042),
    [anon_sym_noreturn] = ACTIONS(5042),
    [anon_sym_mutable] = ACTIONS(5042),
    [anon_sym_constinit] = ACTIONS(5042),
    [anon_sym_consteval] = ACTIONS(5042),
    [anon_sym_alignas] = ACTIONS(5048),
    [anon_sym__Alignas] = ACTIONS(5048),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1405] = {
    [sym_type_qualifier] = STATE(1400),
    [sym_alignas_qualifier] = STATE(2994),
    [sym_expression] = STATE(5575),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [aux_sym_array_declarator_repeat1] = STATE(1400),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(5088),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(5042),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_static] = ACTIONS(5090),
    [anon_sym_RBRACK] = ACTIONS(5092),
    [anon_sym_const] = ACTIONS(5042),
    [anon_sym_constexpr] = ACTIONS(5042),
    [anon_sym_volatile] = ACTIONS(5042),
    [anon_sym_restrict] = ACTIONS(5042),
    [anon_sym___restrict__] = ACTIONS(5042),
    [anon_sym__Atomic] = ACTIONS(5042),
    [anon_sym__Noreturn] = ACTIONS(5042),
    [anon_sym_noreturn] = ACTIONS(5042),
    [anon_sym_mutable] = ACTIONS(5042),
    [anon_sym_constinit] = ACTIONS(5042),
    [anon_sym_consteval] = ACTIONS(5042),
    [anon_sym_alignas] = ACTIONS(5048),
    [anon_sym__Alignas] = ACTIONS(5048),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1406] = {
    [sym_type_qualifier] = STATE(1414),
    [sym_alignas_qualifier] = STATE(2994),
    [sym_expression] = STATE(5478),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [aux_sym_array_declarator_repeat1] = STATE(1414),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(5094),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(5042),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_static] = ACTIONS(5096),
    [anon_sym_RBRACK] = ACTIONS(5098),
    [anon_sym_const] = ACTIONS(5042),
    [anon_sym_constexpr] = ACTIONS(5042),
    [anon_sym_volatile] = ACTIONS(5042),
    [anon_sym_restrict] = ACTIONS(5042),
    [anon_sym___restrict__] = ACTIONS(5042),
    [anon_sym__Atomic] = ACTIONS(5042),
    [anon_sym__Noreturn] = ACTIONS(5042),
    [anon_sym_noreturn] = ACTIONS(5042),
    [anon_sym_mutable] = ACTIONS(5042),
    [anon_sym_constinit] = ACTIONS(5042),
    [anon_sym_consteval] = ACTIONS(5042),
    [anon_sym_alignas] = ACTIONS(5048),
    [anon_sym__Alignas] = ACTIONS(5048),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1407] = {
    [sym_type_qualifier] = STATE(1396),
    [sym_alignas_qualifier] = STATE(2994),
    [sym_expression] = STATE(5483),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [aux_sym_array_declarator_repeat1] = STATE(1396),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(5100),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(5042),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_static] = ACTIONS(5102),
    [anon_sym_RBRACK] = ACTIONS(5104),
    [anon_sym_const] = ACTIONS(5042),
    [anon_sym_constexpr] = ACTIONS(5042),
    [anon_sym_volatile] = ACTIONS(5042),
    [anon_sym_restrict] = ACTIONS(5042),
    [anon_sym___restrict__] = ACTIONS(5042),
    [anon_sym__Atomic] = ACTIONS(5042),
    [anon_sym__Noreturn] = ACTIONS(5042),
    [anon_sym_noreturn] = ACTIONS(5042),
    [anon_sym_mutable] = ACTIONS(5042),
    [anon_sym_constinit] = ACTIONS(5042),
    [anon_sym_consteval] = ACTIONS(5042),
    [anon_sym_alignas] = ACTIONS(5048),
    [anon_sym__Alignas] = ACTIONS(5048),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1408] = {
    [sym_type_qualifier] = STATE(1396),
    [sym_alignas_qualifier] = STATE(2994),
    [sym_expression] = STATE(5483),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [aux_sym_array_declarator_repeat1] = STATE(1396),
    [sym_identifier] = ACTIONS(5106),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(5100),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(5042),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_static] = ACTIONS(5102),
    [anon_sym_RBRACK] = ACTIONS(5104),
    [anon_sym_const] = ACTIONS(5042),
    [anon_sym_constexpr] = ACTIONS(5042),
    [anon_sym_volatile] = ACTIONS(5042),
    [anon_sym_restrict] = ACTIONS(5042),
    [anon_sym___restrict__] = ACTIONS(5042),
    [anon_sym__Atomic] = ACTIONS(5042),
    [anon_sym__Noreturn] = ACTIONS(5042),
    [anon_sym_noreturn] = ACTIONS(5042),
    [anon_sym_mutable] = ACTIONS(5042),
    [anon_sym_constinit] = ACTIONS(5042),
    [anon_sym_consteval] = ACTIONS(5042),
    [anon_sym_alignas] = ACTIONS(5048),
    [anon_sym__Alignas] = ACTIONS(5048),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1409] = {
    [sym_type_qualifier] = STATE(2940),
    [sym_alignas_qualifier] = STATE(2994),
    [sym_expression] = STATE(5542),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [aux_sym_array_declarator_repeat1] = STATE(2940),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(5108),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(5042),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_static] = ACTIONS(5044),
    [anon_sym_RBRACK] = ACTIONS(5110),
    [anon_sym_const] = ACTIONS(5042),
    [anon_sym_constexpr] = ACTIONS(5042),
    [anon_sym_volatile] = ACTIONS(5042),
    [anon_sym_restrict] = ACTIONS(5042),
    [anon_sym___restrict__] = ACTIONS(5042),
    [anon_sym__Atomic] = ACTIONS(5042),
    [anon_sym__Noreturn] = ACTIONS(5042),
    [anon_sym_noreturn] = ACTIONS(5042),
    [anon_sym_mutable] = ACTIONS(5042),
    [anon_sym_constinit] = ACTIONS(5042),
    [anon_sym_consteval] = ACTIONS(5042),
    [anon_sym_alignas] = ACTIONS(5048),
    [anon_sym__Alignas] = ACTIONS(5048),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1410] = {
    [sym_type_qualifier] = STATE(1404),
    [sym_alignas_qualifier] = STATE(2994),
    [sym_expression] = STATE(5514),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [aux_sym_array_declarator_repeat1] = STATE(1404),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(5112),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(5042),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_static] = ACTIONS(5114),
    [anon_sym_RBRACK] = ACTIONS(5116),
    [anon_sym_const] = ACTIONS(5042),
    [anon_sym_constexpr] = ACTIONS(5042),
    [anon_sym_volatile] = ACTIONS(5042),
    [anon_sym_restrict] = ACTIONS(5042),
    [anon_sym___restrict__] = ACTIONS(5042),
    [anon_sym__Atomic] = ACTIONS(5042),
    [anon_sym__Noreturn] = ACTIONS(5042),
    [anon_sym_noreturn] = ACTIONS(5042),
    [anon_sym_mutable] = ACTIONS(5042),
    [anon_sym_constinit] = ACTIONS(5042),
    [anon_sym_consteval] = ACTIONS(5042),
    [anon_sym_alignas] = ACTIONS(5048),
    [anon_sym__Alignas] = ACTIONS(5048),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1411] = {
    [sym_type_qualifier] = STATE(1403),
    [sym_alignas_qualifier] = STATE(2994),
    [sym_expression] = STATE(5510),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [aux_sym_array_declarator_repeat1] = STATE(1403),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(5118),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(5042),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_static] = ACTIONS(5120),
    [anon_sym_RBRACK] = ACTIONS(5122),
    [anon_sym_const] = ACTIONS(5042),
    [anon_sym_constexpr] = ACTIONS(5042),
    [anon_sym_volatile] = ACTIONS(5042),
    [anon_sym_restrict] = ACTIONS(5042),
    [anon_sym___restrict__] = ACTIONS(5042),
    [anon_sym__Atomic] = ACTIONS(5042),
    [anon_sym__Noreturn] = ACTIONS(5042),
    [anon_sym_noreturn] = ACTIONS(5042),
    [anon_sym_mutable] = ACTIONS(5042),
    [anon_sym_constinit] = ACTIONS(5042),
    [anon_sym_consteval] = ACTIONS(5042),
    [anon_sym_alignas] = ACTIONS(5048),
    [anon_sym__Alignas] = ACTIONS(5048),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1412] = {
    [sym_type_qualifier] = STATE(2940),
    [sym_alignas_qualifier] = STATE(2994),
    [sym_expression] = STATE(5602),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [aux_sym_array_declarator_repeat1] = STATE(2940),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(5124),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(5042),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_static] = ACTIONS(5044),
    [anon_sym_RBRACK] = ACTIONS(5126),
    [anon_sym_const] = ACTIONS(5042),
    [anon_sym_constexpr] = ACTIONS(5042),
    [anon_sym_volatile] = ACTIONS(5042),
    [anon_sym_restrict] = ACTIONS(5042),
    [anon_sym___restrict__] = ACTIONS(5042),
    [anon_sym__Atomic] = ACTIONS(5042),
    [anon_sym__Noreturn] = ACTIONS(5042),
    [anon_sym_noreturn] = ACTIONS(5042),
    [anon_sym_mutable] = ACTIONS(5042),
    [anon_sym_constinit] = ACTIONS(5042),
    [anon_sym_consteval] = ACTIONS(5042),
    [anon_sym_alignas] = ACTIONS(5048),
    [anon_sym__Alignas] = ACTIONS(5048),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1413] = {
    [sym_type_qualifier] = STATE(1412),
    [sym_alignas_qualifier] = STATE(2994),
    [sym_expression] = STATE(5482),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [aux_sym_array_declarator_repeat1] = STATE(1412),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(5128),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(5042),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_static] = ACTIONS(5130),
    [anon_sym_RBRACK] = ACTIONS(5132),
    [anon_sym_const] = ACTIONS(5042),
    [anon_sym_constexpr] = ACTIONS(5042),
    [anon_sym_volatile] = ACTIONS(5042),
    [anon_sym_restrict] = ACTIONS(5042),
    [anon_sym___restrict__] = ACTIONS(5042),
    [anon_sym__Atomic] = ACTIONS(5042),
    [anon_sym__Noreturn] = ACTIONS(5042),
    [anon_sym_noreturn] = ACTIONS(5042),
    [anon_sym_mutable] = ACTIONS(5042),
    [anon_sym_constinit] = ACTIONS(5042),
    [anon_sym_consteval] = ACTIONS(5042),
    [anon_sym_alignas] = ACTIONS(5048),
    [anon_sym__Alignas] = ACTIONS(5048),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1414] = {
    [sym_type_qualifier] = STATE(2940),
    [sym_alignas_qualifier] = STATE(2994),
    [sym_expression] = STATE(5508),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [aux_sym_array_declarator_repeat1] = STATE(2940),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(5134),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(5042),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_static] = ACTIONS(5044),
    [anon_sym_RBRACK] = ACTIONS(5136),
    [anon_sym_const] = ACTIONS(5042),
    [anon_sym_constexpr] = ACTIONS(5042),
    [anon_sym_volatile] = ACTIONS(5042),
    [anon_sym_restrict] = ACTIONS(5042),
    [anon_sym___restrict__] = ACTIONS(5042),
    [anon_sym__Atomic] = ACTIONS(5042),
    [anon_sym__Noreturn] = ACTIONS(5042),
    [anon_sym_noreturn] = ACTIONS(5042),
    [anon_sym_mutable] = ACTIONS(5042),
    [anon_sym_constinit] = ACTIONS(5042),
    [anon_sym_consteval] = ACTIONS(5042),
    [anon_sym_alignas] = ACTIONS(5048),
    [anon_sym__Alignas] = ACTIONS(5048),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1415] = {
    [sym_type_qualifier] = STATE(1416),
    [sym_alignas_qualifier] = STATE(2994),
    [sym_expression] = STATE(5562),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [aux_sym_array_declarator_repeat1] = STATE(1416),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(5138),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(5042),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_static] = ACTIONS(5140),
    [anon_sym_RBRACK] = ACTIONS(5142),
    [anon_sym_const] = ACTIONS(5042),
    [anon_sym_constexpr] = ACTIONS(5042),
    [anon_sym_volatile] = ACTIONS(5042),
    [anon_sym_restrict] = ACTIONS(5042),
    [anon_sym___restrict__] = ACTIONS(5042),
    [anon_sym__Atomic] = ACTIONS(5042),
    [anon_sym__Noreturn] = ACTIONS(5042),
    [anon_sym_noreturn] = ACTIONS(5042),
    [anon_sym_mutable] = ACTIONS(5042),
    [anon_sym_constinit] = ACTIONS(5042),
    [anon_sym_consteval] = ACTIONS(5042),
    [anon_sym_alignas] = ACTIONS(5048),
    [anon_sym__Alignas] = ACTIONS(5048),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1416] = {
    [sym_type_qualifier] = STATE(2940),
    [sym_alignas_qualifier] = STATE(2994),
    [sym_expression] = STATE(5518),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [aux_sym_array_declarator_repeat1] = STATE(2940),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(5144),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(5042),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_static] = ACTIONS(5044),
    [anon_sym_RBRACK] = ACTIONS(5146),
    [anon_sym_const] = ACTIONS(5042),
    [anon_sym_constexpr] = ACTIONS(5042),
    [anon_sym_volatile] = ACTIONS(5042),
    [anon_sym_restrict] = ACTIONS(5042),
    [anon_sym___restrict__] = ACTIONS(5042),
    [anon_sym__Atomic] = ACTIONS(5042),
    [anon_sym__Noreturn] = ACTIONS(5042),
    [anon_sym_noreturn] = ACTIONS(5042),
    [anon_sym_mutable] = ACTIONS(5042),
    [anon_sym_constinit] = ACTIONS(5042),
    [anon_sym_consteval] = ACTIONS(5042),
    [anon_sym_alignas] = ACTIONS(5048),
    [anon_sym__Alignas] = ACTIONS(5048),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1417] = {
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2254),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_RPAREN] = ACTIONS(2254),
    [anon_sym_LPAREN2] = ACTIONS(2254),
    [anon_sym_TILDE] = ACTIONS(2254),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_SLASH] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2252),
    [anon_sym_PIPE_PIPE] = ACTIONS(2254),
    [anon_sym_AMP_AMP] = ACTIONS(2254),
    [anon_sym_PIPE] = ACTIONS(2252),
    [anon_sym_CARET] = ACTIONS(2252),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_EQ_EQ] = ACTIONS(2254),
    [anon_sym_BANG_EQ] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2252),
    [anon_sym_GT_EQ] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2252),
    [anon_sym_LT_LT] = ACTIONS(2252),
    [anon_sym_GT_GT] = ACTIONS(2252),
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym___extension__] = ACTIONS(2252),
    [anon_sym_in] = ACTIONS(2252),
    [anon_sym_out] = ACTIONS(2252),
    [anon_sym_inout] = ACTIONS(2252),
    [anon_sym_extern] = ACTIONS(2252),
    [anon_sym___attribute__] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2254),
    [anon_sym___declspec] = ACTIONS(2252),
    [anon_sym___based] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2252),
    [anon_sym_EQ] = ACTIONS(2252),
    [anon_sym_register] = ACTIONS(2252),
    [anon_sym_inline] = ACTIONS(2252),
    [anon_sym___inline] = ACTIONS(2252),
    [anon_sym___inline__] = ACTIONS(2252),
    [anon_sym___forceinline] = ACTIONS(2252),
    [anon_sym_thread_local] = ACTIONS(2252),
    [anon_sym___thread] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2252),
    [anon_sym_constexpr] = ACTIONS(2252),
    [anon_sym_volatile] = ACTIONS(2252),
    [anon_sym_restrict] = ACTIONS(2252),
    [anon_sym___restrict__] = ACTIONS(2252),
    [anon_sym__Atomic] = ACTIONS(2252),
    [anon_sym__Noreturn] = ACTIONS(2252),
    [anon_sym_noreturn] = ACTIONS(2252),
    [anon_sym_mutable] = ACTIONS(2252),
    [anon_sym_constinit] = ACTIONS(2252),
    [anon_sym_consteval] = ACTIONS(2252),
    [anon_sym_alignas] = ACTIONS(2252),
    [anon_sym__Alignas] = ACTIONS(2252),
    [anon_sym_QMARK] = ACTIONS(2254),
    [anon_sym_STAR_EQ] = ACTIONS(2254),
    [anon_sym_SLASH_EQ] = ACTIONS(2254),
    [anon_sym_PERCENT_EQ] = ACTIONS(2254),
    [anon_sym_PLUS_EQ] = ACTIONS(2254),
    [anon_sym_DASH_EQ] = ACTIONS(2254),
    [anon_sym_LT_LT_EQ] = ACTIONS(2254),
    [anon_sym_GT_GT_EQ] = ACTIONS(2254),
    [anon_sym_AMP_EQ] = ACTIONS(2254),
    [anon_sym_CARET_EQ] = ACTIONS(2254),
    [anon_sym_PIPE_EQ] = ACTIONS(2254),
    [anon_sym_LT_EQ_GT] = ACTIONS(2254),
    [anon_sym_or] = ACTIONS(2252),
    [anon_sym_and] = ACTIONS(2252),
    [anon_sym_bitor] = ACTIONS(2252),
    [anon_sym_xor] = ACTIONS(2252),
    [anon_sym_bitand] = ACTIONS(2252),
    [anon_sym_not_eq] = ACTIONS(2252),
    [anon_sym_is] = ACTIONS(2252),
    [anon_sym_as] = ACTIONS(2252),
    [anon_sym_DASH_DASH] = ACTIONS(2254),
    [anon_sym_PLUS_PLUS] = ACTIONS(2254),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_DOT_STAR] = ACTIONS(2254),
    [anon_sym_DASH_GT] = ACTIONS(2252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_This] = ACTIONS(2252),
    [anon_sym_decltype] = ACTIONS(2252),
    [sym_virtual] = ACTIONS(2252),
    [anon_sym_template] = ACTIONS(2252),
    [anon_sym_operator] = ACTIONS(2252),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2254),
    [anon_sym_precise] = ACTIONS(2252),
    [anon_sym_shared] = ACTIONS(2252),
    [anon_sym_groupshared] = ACTIONS(2252),
    [anon_sym_uniform] = ACTIONS(2252),
    [anon_sym_row_major] = ACTIONS(2252),
    [anon_sym_column_major] = ACTIONS(2252),
    [anon_sym_globallycoherent] = ACTIONS(2252),
    [anon_sym_centroid] = ACTIONS(2252),
    [anon_sym_noperspective] = ACTIONS(2252),
    [anon_sym_nointerpolation] = ACTIONS(2252),
    [anon_sym_sample] = ACTIONS(2252),
    [anon_sym_linear] = ACTIONS(2252),
    [anon_sym_snorm] = ACTIONS(2252),
    [anon_sym_unorm] = ACTIONS(2252),
    [anon_sym_point] = ACTIONS(2252),
    [anon_sym_line] = ACTIONS(2252),
    [anon_sym_triangleadj] = ACTIONS(2252),
    [anon_sym_lineadj] = ACTIONS(2252),
    [anon_sym_triangle] = ACTIONS(2252),
  },
  [1418] = {
    [sym_identifier] = ACTIONS(2202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_RPAREN] = ACTIONS(2204),
    [anon_sym_LPAREN2] = ACTIONS(2204),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2202),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_STAR] = ACTIONS(2202),
    [anon_sym_SLASH] = ACTIONS(2202),
    [anon_sym_PERCENT] = ACTIONS(2202),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2202),
    [anon_sym_CARET] = ACTIONS(2202),
    [anon_sym_AMP] = ACTIONS(2202),
    [anon_sym_EQ_EQ] = ACTIONS(2204),
    [anon_sym_BANG_EQ] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(2202),
    [anon_sym_GT_EQ] = ACTIONS(2204),
    [anon_sym_LT_EQ] = ACTIONS(2202),
    [anon_sym_LT] = ACTIONS(2202),
    [anon_sym_LT_LT] = ACTIONS(2202),
    [anon_sym_GT_GT] = ACTIONS(2202),
    [anon_sym_COLON] = ACTIONS(2202),
    [anon_sym___extension__] = ACTIONS(2202),
    [anon_sym_in] = ACTIONS(2202),
    [anon_sym_out] = ACTIONS(2202),
    [anon_sym_inout] = ACTIONS(2202),
    [anon_sym_extern] = ACTIONS(2202),
    [anon_sym___attribute__] = ACTIONS(2202),
    [anon_sym_COLON_COLON] = ACTIONS(2204),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2204),
    [anon_sym___declspec] = ACTIONS(2202),
    [anon_sym___based] = ACTIONS(2202),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2202),
    [anon_sym_EQ] = ACTIONS(2202),
    [anon_sym_register] = ACTIONS(2202),
    [anon_sym_inline] = ACTIONS(2202),
    [anon_sym___inline] = ACTIONS(2202),
    [anon_sym___inline__] = ACTIONS(2202),
    [anon_sym___forceinline] = ACTIONS(2202),
    [anon_sym_thread_local] = ACTIONS(2202),
    [anon_sym___thread] = ACTIONS(2202),
    [anon_sym_const] = ACTIONS(2202),
    [anon_sym_constexpr] = ACTIONS(2202),
    [anon_sym_volatile] = ACTIONS(2202),
    [anon_sym_restrict] = ACTIONS(2202),
    [anon_sym___restrict__] = ACTIONS(2202),
    [anon_sym__Atomic] = ACTIONS(2202),
    [anon_sym__Noreturn] = ACTIONS(2202),
    [anon_sym_noreturn] = ACTIONS(2202),
    [anon_sym_mutable] = ACTIONS(2202),
    [anon_sym_constinit] = ACTIONS(2202),
    [anon_sym_consteval] = ACTIONS(2202),
    [anon_sym_alignas] = ACTIONS(2202),
    [anon_sym__Alignas] = ACTIONS(2202),
    [anon_sym_QMARK] = ACTIONS(2204),
    [anon_sym_STAR_EQ] = ACTIONS(2204),
    [anon_sym_SLASH_EQ] = ACTIONS(2204),
    [anon_sym_PERCENT_EQ] = ACTIONS(2204),
    [anon_sym_PLUS_EQ] = ACTIONS(2204),
    [anon_sym_DASH_EQ] = ACTIONS(2204),
    [anon_sym_LT_LT_EQ] = ACTIONS(2204),
    [anon_sym_GT_GT_EQ] = ACTIONS(2204),
    [anon_sym_AMP_EQ] = ACTIONS(2204),
    [anon_sym_CARET_EQ] = ACTIONS(2204),
    [anon_sym_PIPE_EQ] = ACTIONS(2204),
    [anon_sym_LT_EQ_GT] = ACTIONS(2204),
    [anon_sym_or] = ACTIONS(2202),
    [anon_sym_and] = ACTIONS(2202),
    [anon_sym_bitor] = ACTIONS(2202),
    [anon_sym_xor] = ACTIONS(2202),
    [anon_sym_bitand] = ACTIONS(2202),
    [anon_sym_not_eq] = ACTIONS(2202),
    [anon_sym_is] = ACTIONS(2202),
    [anon_sym_as] = ACTIONS(2202),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(2202),
    [anon_sym_DOT_STAR] = ACTIONS(2204),
    [anon_sym_DASH_GT] = ACTIONS(2202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2202),
    [anon_sym_let] = ACTIONS(2202),
    [anon_sym_This] = ACTIONS(2202),
    [anon_sym_decltype] = ACTIONS(2202),
    [sym_virtual] = ACTIONS(2202),
    [anon_sym_template] = ACTIONS(2202),
    [anon_sym_operator] = ACTIONS(2202),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2204),
    [anon_sym_precise] = ACTIONS(2202),
    [anon_sym_shared] = ACTIONS(2202),
    [anon_sym_groupshared] = ACTIONS(2202),
    [anon_sym_uniform] = ACTIONS(2202),
    [anon_sym_row_major] = ACTIONS(2202),
    [anon_sym_column_major] = ACTIONS(2202),
    [anon_sym_globallycoherent] = ACTIONS(2202),
    [anon_sym_centroid] = ACTIONS(2202),
    [anon_sym_noperspective] = ACTIONS(2202),
    [anon_sym_nointerpolation] = ACTIONS(2202),
    [anon_sym_sample] = ACTIONS(2202),
    [anon_sym_linear] = ACTIONS(2202),
    [anon_sym_snorm] = ACTIONS(2202),
    [anon_sym_unorm] = ACTIONS(2202),
    [anon_sym_point] = ACTIONS(2202),
    [anon_sym_line] = ACTIONS(2202),
    [anon_sym_triangleadj] = ACTIONS(2202),
    [anon_sym_lineadj] = ACTIONS(2202),
    [anon_sym_triangle] = ACTIONS(2202),
  },
  [1419] = {
    [sym_identifier] = ACTIONS(2210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2214),
    [anon_sym_COMMA] = ACTIONS(2214),
    [anon_sym_RPAREN] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(2214),
    [anon_sym_TILDE] = ACTIONS(2217),
    [anon_sym_DASH] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(2222),
    [anon_sym_STAR] = ACTIONS(2219),
    [anon_sym_SLASH] = ACTIONS(2222),
    [anon_sym_PERCENT] = ACTIONS(2222),
    [anon_sym_PIPE_PIPE] = ACTIONS(2212),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2222),
    [anon_sym_CARET] = ACTIONS(2222),
    [anon_sym_AMP] = ACTIONS(2219),
    [anon_sym_EQ_EQ] = ACTIONS(2212),
    [anon_sym_BANG_EQ] = ACTIONS(2212),
    [anon_sym_GT] = ACTIONS(2222),
    [anon_sym_GT_EQ] = ACTIONS(2212),
    [anon_sym_LT_EQ] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(2222),
    [anon_sym_LT_LT] = ACTIONS(2222),
    [anon_sym_GT_GT] = ACTIONS(2222),
    [anon_sym_COLON] = ACTIONS(2210),
    [anon_sym___extension__] = ACTIONS(2210),
    [anon_sym_in] = ACTIONS(2210),
    [anon_sym_out] = ACTIONS(2210),
    [anon_sym_inout] = ACTIONS(2210),
    [anon_sym_extern] = ACTIONS(2210),
    [anon_sym___attribute__] = ACTIONS(2210),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2217),
    [anon_sym___declspec] = ACTIONS(2210),
    [anon_sym___based] = ACTIONS(2210),
    [anon_sym_LBRACE] = ACTIONS(2217),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_static] = ACTIONS(2210),
    [anon_sym_EQ] = ACTIONS(2219),
    [anon_sym_register] = ACTIONS(2210),
    [anon_sym_inline] = ACTIONS(2210),
    [anon_sym___inline] = ACTIONS(2210),
    [anon_sym___inline__] = ACTIONS(2210),
    [anon_sym___forceinline] = ACTIONS(2210),
    [anon_sym_thread_local] = ACTIONS(2210),
    [anon_sym___thread] = ACTIONS(2210),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_constexpr] = ACTIONS(2210),
    [anon_sym_volatile] = ACTIONS(2210),
    [anon_sym_restrict] = ACTIONS(2210),
    [anon_sym___restrict__] = ACTIONS(2210),
    [anon_sym__Atomic] = ACTIONS(2210),
    [anon_sym__Noreturn] = ACTIONS(2210),
    [anon_sym_noreturn] = ACTIONS(2210),
    [anon_sym_mutable] = ACTIONS(2210),
    [anon_sym_constinit] = ACTIONS(2210),
    [anon_sym_consteval] = ACTIONS(2210),
    [anon_sym_alignas] = ACTIONS(2210),
    [anon_sym__Alignas] = ACTIONS(2210),
    [anon_sym_QMARK] = ACTIONS(2212),
    [anon_sym_STAR_EQ] = ACTIONS(2212),
    [anon_sym_SLASH_EQ] = ACTIONS(2212),
    [anon_sym_PERCENT_EQ] = ACTIONS(2212),
    [anon_sym_PLUS_EQ] = ACTIONS(2212),
    [anon_sym_DASH_EQ] = ACTIONS(2212),
    [anon_sym_LT_LT_EQ] = ACTIONS(2212),
    [anon_sym_GT_GT_EQ] = ACTIONS(2212),
    [anon_sym_AMP_EQ] = ACTIONS(2212),
    [anon_sym_CARET_EQ] = ACTIONS(2212),
    [anon_sym_PIPE_EQ] = ACTIONS(2212),
    [anon_sym_LT_EQ_GT] = ACTIONS(2212),
    [anon_sym_or] = ACTIONS(2222),
    [anon_sym_and] = ACTIONS(2222),
    [anon_sym_bitor] = ACTIONS(2222),
    [anon_sym_xor] = ACTIONS(2222),
    [anon_sym_bitand] = ACTIONS(2222),
    [anon_sym_not_eq] = ACTIONS(2222),
    [anon_sym_is] = ACTIONS(2222),
    [anon_sym_as] = ACTIONS(2222),
    [anon_sym_DASH_DASH] = ACTIONS(2212),
    [anon_sym_PLUS_PLUS] = ACTIONS(2212),
    [anon_sym_DOT] = ACTIONS(2219),
    [anon_sym_DOT_STAR] = ACTIONS(2212),
    [anon_sym_DASH_GT] = ACTIONS(2222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2210),
    [anon_sym_let] = ACTIONS(2210),
    [anon_sym_This] = ACTIONS(2210),
    [anon_sym_decltype] = ACTIONS(2210),
    [sym_virtual] = ACTIONS(2210),
    [anon_sym_template] = ACTIONS(2210),
    [anon_sym_operator] = ACTIONS(2210),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2212),
    [anon_sym_precise] = ACTIONS(2210),
    [anon_sym_shared] = ACTIONS(2210),
    [anon_sym_groupshared] = ACTIONS(2210),
    [anon_sym_uniform] = ACTIONS(2210),
    [anon_sym_row_major] = ACTIONS(2210),
    [anon_sym_column_major] = ACTIONS(2210),
    [anon_sym_globallycoherent] = ACTIONS(2210),
    [anon_sym_centroid] = ACTIONS(2210),
    [anon_sym_noperspective] = ACTIONS(2210),
    [anon_sym_nointerpolation] = ACTIONS(2210),
    [anon_sym_sample] = ACTIONS(2210),
    [anon_sym_linear] = ACTIONS(2210),
    [anon_sym_snorm] = ACTIONS(2210),
    [anon_sym_unorm] = ACTIONS(2210),
    [anon_sym_point] = ACTIONS(2210),
    [anon_sym_line] = ACTIONS(2210),
    [anon_sym_triangleadj] = ACTIONS(2210),
    [anon_sym_lineadj] = ACTIONS(2210),
    [anon_sym_triangle] = ACTIONS(2210),
  },
  [1420] = {
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2230),
    [anon_sym_COMMA] = ACTIONS(2230),
    [anon_sym_RPAREN] = ACTIONS(2230),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_TILDE] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2228),
    [anon_sym_PLUS] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(2228),
    [anon_sym_SLASH] = ACTIONS(2228),
    [anon_sym_PERCENT] = ACTIONS(2228),
    [anon_sym_PIPE_PIPE] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_PIPE] = ACTIONS(2228),
    [anon_sym_CARET] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2228),
    [anon_sym_EQ_EQ] = ACTIONS(2230),
    [anon_sym_BANG_EQ] = ACTIONS(2230),
    [anon_sym_GT] = ACTIONS(2228),
    [anon_sym_GT_EQ] = ACTIONS(2230),
    [anon_sym_LT_EQ] = ACTIONS(2228),
    [anon_sym_LT] = ACTIONS(2228),
    [anon_sym_LT_LT] = ACTIONS(2228),
    [anon_sym_GT_GT] = ACTIONS(2228),
    [anon_sym_COLON] = ACTIONS(2228),
    [anon_sym___extension__] = ACTIONS(2228),
    [anon_sym_in] = ACTIONS(2228),
    [anon_sym_out] = ACTIONS(2228),
    [anon_sym_inout] = ACTIONS(2228),
    [anon_sym_extern] = ACTIONS(2228),
    [anon_sym___attribute__] = ACTIONS(2228),
    [anon_sym_COLON_COLON] = ACTIONS(2230),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2230),
    [anon_sym___declspec] = ACTIONS(2228),
    [anon_sym___based] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2228),
    [anon_sym_static] = ACTIONS(2228),
    [anon_sym_EQ] = ACTIONS(2228),
    [anon_sym_register] = ACTIONS(2228),
    [anon_sym_inline] = ACTIONS(2228),
    [anon_sym___inline] = ACTIONS(2228),
    [anon_sym___inline__] = ACTIONS(2228),
    [anon_sym___forceinline] = ACTIONS(2228),
    [anon_sym_thread_local] = ACTIONS(2228),
    [anon_sym___thread] = ACTIONS(2228),
    [anon_sym_const] = ACTIONS(2228),
    [anon_sym_constexpr] = ACTIONS(2228),
    [anon_sym_volatile] = ACTIONS(2228),
    [anon_sym_restrict] = ACTIONS(2228),
    [anon_sym___restrict__] = ACTIONS(2228),
    [anon_sym__Atomic] = ACTIONS(2228),
    [anon_sym__Noreturn] = ACTIONS(2228),
    [anon_sym_noreturn] = ACTIONS(2228),
    [anon_sym_mutable] = ACTIONS(2228),
    [anon_sym_constinit] = ACTIONS(2228),
    [anon_sym_consteval] = ACTIONS(2228),
    [anon_sym_alignas] = ACTIONS(2228),
    [anon_sym__Alignas] = ACTIONS(2228),
    [anon_sym_QMARK] = ACTIONS(2230),
    [anon_sym_STAR_EQ] = ACTIONS(2230),
    [anon_sym_SLASH_EQ] = ACTIONS(2230),
    [anon_sym_PERCENT_EQ] = ACTIONS(2230),
    [anon_sym_PLUS_EQ] = ACTIONS(2230),
    [anon_sym_DASH_EQ] = ACTIONS(2230),
    [anon_sym_LT_LT_EQ] = ACTIONS(2230),
    [anon_sym_GT_GT_EQ] = ACTIONS(2230),
    [anon_sym_AMP_EQ] = ACTIONS(2230),
    [anon_sym_CARET_EQ] = ACTIONS(2230),
    [anon_sym_PIPE_EQ] = ACTIONS(2230),
    [anon_sym_LT_EQ_GT] = ACTIONS(2230),
    [anon_sym_or] = ACTIONS(2228),
    [anon_sym_and] = ACTIONS(2228),
    [anon_sym_bitor] = ACTIONS(2228),
    [anon_sym_xor] = ACTIONS(2228),
    [anon_sym_bitand] = ACTIONS(2228),
    [anon_sym_not_eq] = ACTIONS(2228),
    [anon_sym_is] = ACTIONS(2228),
    [anon_sym_as] = ACTIONS(2228),
    [anon_sym_DASH_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_PLUS] = ACTIONS(2230),
    [anon_sym_DOT] = ACTIONS(2228),
    [anon_sym_DOT_STAR] = ACTIONS(2230),
    [anon_sym_DASH_GT] = ACTIONS(2228),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(2228),
    [anon_sym_This] = ACTIONS(2228),
    [anon_sym_decltype] = ACTIONS(2228),
    [sym_virtual] = ACTIONS(2228),
    [anon_sym_template] = ACTIONS(2228),
    [anon_sym_operator] = ACTIONS(2228),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2230),
    [anon_sym_precise] = ACTIONS(2228),
    [anon_sym_shared] = ACTIONS(2228),
    [anon_sym_groupshared] = ACTIONS(2228),
    [anon_sym_uniform] = ACTIONS(2228),
    [anon_sym_row_major] = ACTIONS(2228),
    [anon_sym_column_major] = ACTIONS(2228),
    [anon_sym_globallycoherent] = ACTIONS(2228),
    [anon_sym_centroid] = ACTIONS(2228),
    [anon_sym_noperspective] = ACTIONS(2228),
    [anon_sym_nointerpolation] = ACTIONS(2228),
    [anon_sym_sample] = ACTIONS(2228),
    [anon_sym_linear] = ACTIONS(2228),
    [anon_sym_snorm] = ACTIONS(2228),
    [anon_sym_unorm] = ACTIONS(2228),
    [anon_sym_point] = ACTIONS(2228),
    [anon_sym_line] = ACTIONS(2228),
    [anon_sym_triangleadj] = ACTIONS(2228),
    [anon_sym_lineadj] = ACTIONS(2228),
    [anon_sym_triangle] = ACTIONS(2228),
  },
  [1421] = {
    [sym_identifier] = ACTIONS(2232),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_COMMA] = ACTIONS(2234),
    [anon_sym_RPAREN] = ACTIONS(2234),
    [anon_sym_LPAREN2] = ACTIONS(2234),
    [anon_sym_TILDE] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2232),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_STAR] = ACTIONS(2232),
    [anon_sym_SLASH] = ACTIONS(2232),
    [anon_sym_PERCENT] = ACTIONS(2232),
    [anon_sym_PIPE_PIPE] = ACTIONS(2234),
    [anon_sym_AMP_AMP] = ACTIONS(2234),
    [anon_sym_PIPE] = ACTIONS(2232),
    [anon_sym_CARET] = ACTIONS(2232),
    [anon_sym_AMP] = ACTIONS(2232),
    [anon_sym_EQ_EQ] = ACTIONS(2234),
    [anon_sym_BANG_EQ] = ACTIONS(2234),
    [anon_sym_GT] = ACTIONS(2232),
    [anon_sym_GT_EQ] = ACTIONS(2234),
    [anon_sym_LT_EQ] = ACTIONS(2232),
    [anon_sym_LT] = ACTIONS(2232),
    [anon_sym_LT_LT] = ACTIONS(2232),
    [anon_sym_GT_GT] = ACTIONS(2232),
    [anon_sym_COLON] = ACTIONS(2232),
    [anon_sym___extension__] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2232),
    [anon_sym_out] = ACTIONS(2232),
    [anon_sym_inout] = ACTIONS(2232),
    [anon_sym_extern] = ACTIONS(2232),
    [anon_sym___attribute__] = ACTIONS(2232),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2234),
    [anon_sym___declspec] = ACTIONS(2232),
    [anon_sym___based] = ACTIONS(2232),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2232),
    [anon_sym_static] = ACTIONS(2232),
    [anon_sym_EQ] = ACTIONS(2232),
    [anon_sym_register] = ACTIONS(2232),
    [anon_sym_inline] = ACTIONS(2232),
    [anon_sym___inline] = ACTIONS(2232),
    [anon_sym___inline__] = ACTIONS(2232),
    [anon_sym___forceinline] = ACTIONS(2232),
    [anon_sym_thread_local] = ACTIONS(2232),
    [anon_sym___thread] = ACTIONS(2232),
    [anon_sym_const] = ACTIONS(2232),
    [anon_sym_constexpr] = ACTIONS(2232),
    [anon_sym_volatile] = ACTIONS(2232),
    [anon_sym_restrict] = ACTIONS(2232),
    [anon_sym___restrict__] = ACTIONS(2232),
    [anon_sym__Atomic] = ACTIONS(2232),
    [anon_sym__Noreturn] = ACTIONS(2232),
    [anon_sym_noreturn] = ACTIONS(2232),
    [anon_sym_mutable] = ACTIONS(2232),
    [anon_sym_constinit] = ACTIONS(2232),
    [anon_sym_consteval] = ACTIONS(2232),
    [anon_sym_alignas] = ACTIONS(2232),
    [anon_sym__Alignas] = ACTIONS(2232),
    [anon_sym_QMARK] = ACTIONS(2234),
    [anon_sym_STAR_EQ] = ACTIONS(2234),
    [anon_sym_SLASH_EQ] = ACTIONS(2234),
    [anon_sym_PERCENT_EQ] = ACTIONS(2234),
    [anon_sym_PLUS_EQ] = ACTIONS(2234),
    [anon_sym_DASH_EQ] = ACTIONS(2234),
    [anon_sym_LT_LT_EQ] = ACTIONS(2234),
    [anon_sym_GT_GT_EQ] = ACTIONS(2234),
    [anon_sym_AMP_EQ] = ACTIONS(2234),
    [anon_sym_CARET_EQ] = ACTIONS(2234),
    [anon_sym_PIPE_EQ] = ACTIONS(2234),
    [anon_sym_LT_EQ_GT] = ACTIONS(2234),
    [anon_sym_or] = ACTIONS(2232),
    [anon_sym_and] = ACTIONS(2232),
    [anon_sym_bitor] = ACTIONS(2232),
    [anon_sym_xor] = ACTIONS(2232),
    [anon_sym_bitand] = ACTIONS(2232),
    [anon_sym_not_eq] = ACTIONS(2232),
    [anon_sym_is] = ACTIONS(2232),
    [anon_sym_as] = ACTIONS(2232),
    [anon_sym_DASH_DASH] = ACTIONS(2234),
    [anon_sym_PLUS_PLUS] = ACTIONS(2234),
    [anon_sym_DOT] = ACTIONS(2232),
    [anon_sym_DOT_STAR] = ACTIONS(2234),
    [anon_sym_DASH_GT] = ACTIONS(2232),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2232),
    [anon_sym_let] = ACTIONS(2232),
    [anon_sym_This] = ACTIONS(2232),
    [anon_sym_decltype] = ACTIONS(2232),
    [sym_virtual] = ACTIONS(2232),
    [anon_sym_template] = ACTIONS(2232),
    [anon_sym_operator] = ACTIONS(2232),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2234),
    [anon_sym_precise] = ACTIONS(2232),
    [anon_sym_shared] = ACTIONS(2232),
    [anon_sym_groupshared] = ACTIONS(2232),
    [anon_sym_uniform] = ACTIONS(2232),
    [anon_sym_row_major] = ACTIONS(2232),
    [anon_sym_column_major] = ACTIONS(2232),
    [anon_sym_globallycoherent] = ACTIONS(2232),
    [anon_sym_centroid] = ACTIONS(2232),
    [anon_sym_noperspective] = ACTIONS(2232),
    [anon_sym_nointerpolation] = ACTIONS(2232),
    [anon_sym_sample] = ACTIONS(2232),
    [anon_sym_linear] = ACTIONS(2232),
    [anon_sym_snorm] = ACTIONS(2232),
    [anon_sym_unorm] = ACTIONS(2232),
    [anon_sym_point] = ACTIONS(2232),
    [anon_sym_line] = ACTIONS(2232),
    [anon_sym_triangleadj] = ACTIONS(2232),
    [anon_sym_lineadj] = ACTIONS(2232),
    [anon_sym_triangle] = ACTIONS(2232),
  },
  [1422] = {
    [sym_identifier] = ACTIONS(2244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(2246),
    [anon_sym_RPAREN] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2244),
    [anon_sym_PLUS] = ACTIONS(2244),
    [anon_sym_STAR] = ACTIONS(2244),
    [anon_sym_SLASH] = ACTIONS(2244),
    [anon_sym_PERCENT] = ACTIONS(2244),
    [anon_sym_PIPE_PIPE] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2244),
    [anon_sym_CARET] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2244),
    [anon_sym_EQ_EQ] = ACTIONS(2246),
    [anon_sym_BANG_EQ] = ACTIONS(2246),
    [anon_sym_GT] = ACTIONS(2244),
    [anon_sym_GT_EQ] = ACTIONS(2246),
    [anon_sym_LT_EQ] = ACTIONS(2244),
    [anon_sym_LT] = ACTIONS(2244),
    [anon_sym_LT_LT] = ACTIONS(2244),
    [anon_sym_GT_GT] = ACTIONS(2244),
    [anon_sym_COLON] = ACTIONS(2244),
    [anon_sym___extension__] = ACTIONS(2244),
    [anon_sym_in] = ACTIONS(2244),
    [anon_sym_out] = ACTIONS(2244),
    [anon_sym_inout] = ACTIONS(2244),
    [anon_sym_extern] = ACTIONS(2244),
    [anon_sym___attribute__] = ACTIONS(2244),
    [anon_sym_COLON_COLON] = ACTIONS(2246),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2246),
    [anon_sym___declspec] = ACTIONS(2244),
    [anon_sym___based] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2244),
    [anon_sym_static] = ACTIONS(2244),
    [anon_sym_EQ] = ACTIONS(2244),
    [anon_sym_register] = ACTIONS(2244),
    [anon_sym_inline] = ACTIONS(2244),
    [anon_sym___inline] = ACTIONS(2244),
    [anon_sym___inline__] = ACTIONS(2244),
    [anon_sym___forceinline] = ACTIONS(2244),
    [anon_sym_thread_local] = ACTIONS(2244),
    [anon_sym___thread] = ACTIONS(2244),
    [anon_sym_const] = ACTIONS(2244),
    [anon_sym_constexpr] = ACTIONS(2244),
    [anon_sym_volatile] = ACTIONS(2244),
    [anon_sym_restrict] = ACTIONS(2244),
    [anon_sym___restrict__] = ACTIONS(2244),
    [anon_sym__Atomic] = ACTIONS(2244),
    [anon_sym__Noreturn] = ACTIONS(2244),
    [anon_sym_noreturn] = ACTIONS(2244),
    [anon_sym_mutable] = ACTIONS(2244),
    [anon_sym_constinit] = ACTIONS(2244),
    [anon_sym_consteval] = ACTIONS(2244),
    [anon_sym_alignas] = ACTIONS(2244),
    [anon_sym__Alignas] = ACTIONS(2244),
    [anon_sym_QMARK] = ACTIONS(2246),
    [anon_sym_STAR_EQ] = ACTIONS(2246),
    [anon_sym_SLASH_EQ] = ACTIONS(2246),
    [anon_sym_PERCENT_EQ] = ACTIONS(2246),
    [anon_sym_PLUS_EQ] = ACTIONS(2246),
    [anon_sym_DASH_EQ] = ACTIONS(2246),
    [anon_sym_LT_LT_EQ] = ACTIONS(2246),
    [anon_sym_GT_GT_EQ] = ACTIONS(2246),
    [anon_sym_AMP_EQ] = ACTIONS(2246),
    [anon_sym_CARET_EQ] = ACTIONS(2246),
    [anon_sym_PIPE_EQ] = ACTIONS(2246),
    [anon_sym_LT_EQ_GT] = ACTIONS(2246),
    [anon_sym_or] = ACTIONS(2244),
    [anon_sym_and] = ACTIONS(2244),
    [anon_sym_bitor] = ACTIONS(2244),
    [anon_sym_xor] = ACTIONS(2244),
    [anon_sym_bitand] = ACTIONS(2244),
    [anon_sym_not_eq] = ACTIONS(2244),
    [anon_sym_is] = ACTIONS(2244),
    [anon_sym_as] = ACTIONS(2244),
    [anon_sym_DASH_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_PLUS] = ACTIONS(2246),
    [anon_sym_DOT] = ACTIONS(2244),
    [anon_sym_DOT_STAR] = ACTIONS(2246),
    [anon_sym_DASH_GT] = ACTIONS(2244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2244),
    [anon_sym_let] = ACTIONS(2244),
    [anon_sym_This] = ACTIONS(2244),
    [anon_sym_decltype] = ACTIONS(2244),
    [sym_virtual] = ACTIONS(2244),
    [anon_sym_template] = ACTIONS(2244),
    [anon_sym_operator] = ACTIONS(2244),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2246),
    [anon_sym_precise] = ACTIONS(2244),
    [anon_sym_shared] = ACTIONS(2244),
    [anon_sym_groupshared] = ACTIONS(2244),
    [anon_sym_uniform] = ACTIONS(2244),
    [anon_sym_row_major] = ACTIONS(2244),
    [anon_sym_column_major] = ACTIONS(2244),
    [anon_sym_globallycoherent] = ACTIONS(2244),
    [anon_sym_centroid] = ACTIONS(2244),
    [anon_sym_noperspective] = ACTIONS(2244),
    [anon_sym_nointerpolation] = ACTIONS(2244),
    [anon_sym_sample] = ACTIONS(2244),
    [anon_sym_linear] = ACTIONS(2244),
    [anon_sym_snorm] = ACTIONS(2244),
    [anon_sym_unorm] = ACTIONS(2244),
    [anon_sym_point] = ACTIONS(2244),
    [anon_sym_line] = ACTIONS(2244),
    [anon_sym_triangleadj] = ACTIONS(2244),
    [anon_sym_lineadj] = ACTIONS(2244),
    [anon_sym_triangle] = ACTIONS(2244),
  },
  [1423] = {
    [sym_identifier] = ACTIONS(2248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_RPAREN] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2248),
    [anon_sym_PLUS] = ACTIONS(2248),
    [anon_sym_STAR] = ACTIONS(2248),
    [anon_sym_SLASH] = ACTIONS(2248),
    [anon_sym_PERCENT] = ACTIONS(2248),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2248),
    [anon_sym_EQ_EQ] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_GT] = ACTIONS(2248),
    [anon_sym_GT_EQ] = ACTIONS(2250),
    [anon_sym_LT_EQ] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_LT_LT] = ACTIONS(2248),
    [anon_sym_GT_GT] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2248),
    [anon_sym___extension__] = ACTIONS(2248),
    [anon_sym_in] = ACTIONS(2248),
    [anon_sym_out] = ACTIONS(2248),
    [anon_sym_inout] = ACTIONS(2248),
    [anon_sym_extern] = ACTIONS(2248),
    [anon_sym___attribute__] = ACTIONS(2248),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2250),
    [anon_sym___declspec] = ACTIONS(2248),
    [anon_sym___based] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2248),
    [anon_sym_static] = ACTIONS(2248),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_register] = ACTIONS(2248),
    [anon_sym_inline] = ACTIONS(2248),
    [anon_sym___inline] = ACTIONS(2248),
    [anon_sym___inline__] = ACTIONS(2248),
    [anon_sym___forceinline] = ACTIONS(2248),
    [anon_sym_thread_local] = ACTIONS(2248),
    [anon_sym___thread] = ACTIONS(2248),
    [anon_sym_const] = ACTIONS(2248),
    [anon_sym_constexpr] = ACTIONS(2248),
    [anon_sym_volatile] = ACTIONS(2248),
    [anon_sym_restrict] = ACTIONS(2248),
    [anon_sym___restrict__] = ACTIONS(2248),
    [anon_sym__Atomic] = ACTIONS(2248),
    [anon_sym__Noreturn] = ACTIONS(2248),
    [anon_sym_noreturn] = ACTIONS(2248),
    [anon_sym_mutable] = ACTIONS(2248),
    [anon_sym_constinit] = ACTIONS(2248),
    [anon_sym_consteval] = ACTIONS(2248),
    [anon_sym_alignas] = ACTIONS(2248),
    [anon_sym__Alignas] = ACTIONS(2248),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_STAR_EQ] = ACTIONS(2250),
    [anon_sym_SLASH_EQ] = ACTIONS(2250),
    [anon_sym_PERCENT_EQ] = ACTIONS(2250),
    [anon_sym_PLUS_EQ] = ACTIONS(2250),
    [anon_sym_DASH_EQ] = ACTIONS(2250),
    [anon_sym_LT_LT_EQ] = ACTIONS(2250),
    [anon_sym_GT_GT_EQ] = ACTIONS(2250),
    [anon_sym_AMP_EQ] = ACTIONS(2250),
    [anon_sym_CARET_EQ] = ACTIONS(2250),
    [anon_sym_PIPE_EQ] = ACTIONS(2250),
    [anon_sym_LT_EQ_GT] = ACTIONS(2250),
    [anon_sym_or] = ACTIONS(2248),
    [anon_sym_and] = ACTIONS(2248),
    [anon_sym_bitor] = ACTIONS(2248),
    [anon_sym_xor] = ACTIONS(2248),
    [anon_sym_bitand] = ACTIONS(2248),
    [anon_sym_not_eq] = ACTIONS(2248),
    [anon_sym_is] = ACTIONS(2248),
    [anon_sym_as] = ACTIONS(2248),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2248),
    [anon_sym_DOT_STAR] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2248),
    [anon_sym_let] = ACTIONS(2248),
    [anon_sym_This] = ACTIONS(2248),
    [anon_sym_decltype] = ACTIONS(2248),
    [sym_virtual] = ACTIONS(2248),
    [anon_sym_template] = ACTIONS(2248),
    [anon_sym_operator] = ACTIONS(2248),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2250),
    [anon_sym_precise] = ACTIONS(2248),
    [anon_sym_shared] = ACTIONS(2248),
    [anon_sym_groupshared] = ACTIONS(2248),
    [anon_sym_uniform] = ACTIONS(2248),
    [anon_sym_row_major] = ACTIONS(2248),
    [anon_sym_column_major] = ACTIONS(2248),
    [anon_sym_globallycoherent] = ACTIONS(2248),
    [anon_sym_centroid] = ACTIONS(2248),
    [anon_sym_noperspective] = ACTIONS(2248),
    [anon_sym_nointerpolation] = ACTIONS(2248),
    [anon_sym_sample] = ACTIONS(2248),
    [anon_sym_linear] = ACTIONS(2248),
    [anon_sym_snorm] = ACTIONS(2248),
    [anon_sym_unorm] = ACTIONS(2248),
    [anon_sym_point] = ACTIONS(2248),
    [anon_sym_line] = ACTIONS(2248),
    [anon_sym_triangleadj] = ACTIONS(2248),
    [anon_sym_lineadj] = ACTIONS(2248),
    [anon_sym_triangle] = ACTIONS(2248),
  },
  [1424] = {
    [sym_identifier] = ACTIONS(2256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2258),
    [anon_sym_COMMA] = ACTIONS(2258),
    [anon_sym_RPAREN] = ACTIONS(2258),
    [anon_sym_LPAREN2] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [anon_sym_DASH] = ACTIONS(2256),
    [anon_sym_PLUS] = ACTIONS(2256),
    [anon_sym_STAR] = ACTIONS(2256),
    [anon_sym_SLASH] = ACTIONS(2256),
    [anon_sym_PERCENT] = ACTIONS(2256),
    [anon_sym_PIPE_PIPE] = ACTIONS(2258),
    [anon_sym_AMP_AMP] = ACTIONS(2258),
    [anon_sym_PIPE] = ACTIONS(2256),
    [anon_sym_CARET] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(2256),
    [anon_sym_EQ_EQ] = ACTIONS(2258),
    [anon_sym_BANG_EQ] = ACTIONS(2258),
    [anon_sym_GT] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2258),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_LT] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2256),
    [anon_sym_GT_GT] = ACTIONS(2256),
    [anon_sym_COLON] = ACTIONS(2256),
    [anon_sym___extension__] = ACTIONS(2256),
    [anon_sym_in] = ACTIONS(2256),
    [anon_sym_out] = ACTIONS(2256),
    [anon_sym_inout] = ACTIONS(2256),
    [anon_sym_extern] = ACTIONS(2256),
    [anon_sym___attribute__] = ACTIONS(2256),
    [anon_sym_COLON_COLON] = ACTIONS(2258),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2258),
    [anon_sym___declspec] = ACTIONS(2256),
    [anon_sym___based] = ACTIONS(2256),
    [anon_sym_LBRACE] = ACTIONS(2258),
    [anon_sym_LBRACK] = ACTIONS(2256),
    [anon_sym_static] = ACTIONS(2256),
    [anon_sym_EQ] = ACTIONS(2256),
    [anon_sym_register] = ACTIONS(2256),
    [anon_sym_inline] = ACTIONS(2256),
    [anon_sym___inline] = ACTIONS(2256),
    [anon_sym___inline__] = ACTIONS(2256),
    [anon_sym___forceinline] = ACTIONS(2256),
    [anon_sym_thread_local] = ACTIONS(2256),
    [anon_sym___thread] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_constexpr] = ACTIONS(2256),
    [anon_sym_volatile] = ACTIONS(2256),
    [anon_sym_restrict] = ACTIONS(2256),
    [anon_sym___restrict__] = ACTIONS(2256),
    [anon_sym__Atomic] = ACTIONS(2256),
    [anon_sym__Noreturn] = ACTIONS(2256),
    [anon_sym_noreturn] = ACTIONS(2256),
    [anon_sym_mutable] = ACTIONS(2256),
    [anon_sym_constinit] = ACTIONS(2256),
    [anon_sym_consteval] = ACTIONS(2256),
    [anon_sym_alignas] = ACTIONS(2256),
    [anon_sym__Alignas] = ACTIONS(2256),
    [anon_sym_QMARK] = ACTIONS(2258),
    [anon_sym_STAR_EQ] = ACTIONS(2258),
    [anon_sym_SLASH_EQ] = ACTIONS(2258),
    [anon_sym_PERCENT_EQ] = ACTIONS(2258),
    [anon_sym_PLUS_EQ] = ACTIONS(2258),
    [anon_sym_DASH_EQ] = ACTIONS(2258),
    [anon_sym_LT_LT_EQ] = ACTIONS(2258),
    [anon_sym_GT_GT_EQ] = ACTIONS(2258),
    [anon_sym_AMP_EQ] = ACTIONS(2258),
    [anon_sym_CARET_EQ] = ACTIONS(2258),
    [anon_sym_PIPE_EQ] = ACTIONS(2258),
    [anon_sym_LT_EQ_GT] = ACTIONS(2258),
    [anon_sym_or] = ACTIONS(2256),
    [anon_sym_and] = ACTIONS(2256),
    [anon_sym_bitor] = ACTIONS(2256),
    [anon_sym_xor] = ACTIONS(2256),
    [anon_sym_bitand] = ACTIONS(2256),
    [anon_sym_not_eq] = ACTIONS(2256),
    [anon_sym_is] = ACTIONS(2256),
    [anon_sym_as] = ACTIONS(2256),
    [anon_sym_DASH_DASH] = ACTIONS(2258),
    [anon_sym_PLUS_PLUS] = ACTIONS(2258),
    [anon_sym_DOT] = ACTIONS(2256),
    [anon_sym_DOT_STAR] = ACTIONS(2258),
    [anon_sym_DASH_GT] = ACTIONS(2256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_This] = ACTIONS(2256),
    [anon_sym_decltype] = ACTIONS(2256),
    [sym_virtual] = ACTIONS(2256),
    [anon_sym_template] = ACTIONS(2256),
    [anon_sym_operator] = ACTIONS(2256),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2258),
    [anon_sym_precise] = ACTIONS(2256),
    [anon_sym_shared] = ACTIONS(2256),
    [anon_sym_groupshared] = ACTIONS(2256),
    [anon_sym_uniform] = ACTIONS(2256),
    [anon_sym_row_major] = ACTIONS(2256),
    [anon_sym_column_major] = ACTIONS(2256),
    [anon_sym_globallycoherent] = ACTIONS(2256),
    [anon_sym_centroid] = ACTIONS(2256),
    [anon_sym_noperspective] = ACTIONS(2256),
    [anon_sym_nointerpolation] = ACTIONS(2256),
    [anon_sym_sample] = ACTIONS(2256),
    [anon_sym_linear] = ACTIONS(2256),
    [anon_sym_snorm] = ACTIONS(2256),
    [anon_sym_unorm] = ACTIONS(2256),
    [anon_sym_point] = ACTIONS(2256),
    [anon_sym_line] = ACTIONS(2256),
    [anon_sym_triangleadj] = ACTIONS(2256),
    [anon_sym_lineadj] = ACTIONS(2256),
    [anon_sym_triangle] = ACTIONS(2256),
  },
  [1425] = {
    [sym_identifier] = ACTIONS(2198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_COMMA] = ACTIONS(2200),
    [anon_sym_RPAREN] = ACTIONS(2200),
    [anon_sym_LPAREN2] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(2198),
    [anon_sym_SLASH] = ACTIONS(2198),
    [anon_sym_PERCENT] = ACTIONS(2198),
    [anon_sym_PIPE_PIPE] = ACTIONS(2200),
    [anon_sym_AMP_AMP] = ACTIONS(2200),
    [anon_sym_PIPE] = ACTIONS(2198),
    [anon_sym_CARET] = ACTIONS(2198),
    [anon_sym_AMP] = ACTIONS(2198),
    [anon_sym_EQ_EQ] = ACTIONS(2200),
    [anon_sym_BANG_EQ] = ACTIONS(2200),
    [anon_sym_GT] = ACTIONS(2198),
    [anon_sym_GT_EQ] = ACTIONS(2200),
    [anon_sym_LT_EQ] = ACTIONS(2198),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_LT_LT] = ACTIONS(2198),
    [anon_sym_GT_GT] = ACTIONS(2198),
    [anon_sym_COLON] = ACTIONS(2198),
    [anon_sym___extension__] = ACTIONS(2198),
    [anon_sym_in] = ACTIONS(2198),
    [anon_sym_out] = ACTIONS(2198),
    [anon_sym_inout] = ACTIONS(2198),
    [anon_sym_extern] = ACTIONS(2198),
    [anon_sym___attribute__] = ACTIONS(2198),
    [anon_sym_COLON_COLON] = ACTIONS(2200),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2200),
    [anon_sym___declspec] = ACTIONS(2198),
    [anon_sym___based] = ACTIONS(2198),
    [anon_sym_LBRACE] = ACTIONS(2200),
    [anon_sym_LBRACK] = ACTIONS(2198),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_EQ] = ACTIONS(2198),
    [anon_sym_register] = ACTIONS(2198),
    [anon_sym_inline] = ACTIONS(2198),
    [anon_sym___inline] = ACTIONS(2198),
    [anon_sym___inline__] = ACTIONS(2198),
    [anon_sym___forceinline] = ACTIONS(2198),
    [anon_sym_thread_local] = ACTIONS(2198),
    [anon_sym___thread] = ACTIONS(2198),
    [anon_sym_const] = ACTIONS(2198),
    [anon_sym_constexpr] = ACTIONS(2198),
    [anon_sym_volatile] = ACTIONS(2198),
    [anon_sym_restrict] = ACTIONS(2198),
    [anon_sym___restrict__] = ACTIONS(2198),
    [anon_sym__Atomic] = ACTIONS(2198),
    [anon_sym__Noreturn] = ACTIONS(2198),
    [anon_sym_noreturn] = ACTIONS(2198),
    [anon_sym_mutable] = ACTIONS(2198),
    [anon_sym_constinit] = ACTIONS(2198),
    [anon_sym_consteval] = ACTIONS(2198),
    [anon_sym_alignas] = ACTIONS(2198),
    [anon_sym__Alignas] = ACTIONS(2198),
    [anon_sym_QMARK] = ACTIONS(2200),
    [anon_sym_STAR_EQ] = ACTIONS(2200),
    [anon_sym_SLASH_EQ] = ACTIONS(2200),
    [anon_sym_PERCENT_EQ] = ACTIONS(2200),
    [anon_sym_PLUS_EQ] = ACTIONS(2200),
    [anon_sym_DASH_EQ] = ACTIONS(2200),
    [anon_sym_LT_LT_EQ] = ACTIONS(2200),
    [anon_sym_GT_GT_EQ] = ACTIONS(2200),
    [anon_sym_AMP_EQ] = ACTIONS(2200),
    [anon_sym_CARET_EQ] = ACTIONS(2200),
    [anon_sym_PIPE_EQ] = ACTIONS(2200),
    [anon_sym_LT_EQ_GT] = ACTIONS(2200),
    [anon_sym_or] = ACTIONS(2198),
    [anon_sym_and] = ACTIONS(2198),
    [anon_sym_bitor] = ACTIONS(2198),
    [anon_sym_xor] = ACTIONS(2198),
    [anon_sym_bitand] = ACTIONS(2198),
    [anon_sym_not_eq] = ACTIONS(2198),
    [anon_sym_is] = ACTIONS(2198),
    [anon_sym_as] = ACTIONS(2198),
    [anon_sym_DASH_DASH] = ACTIONS(2200),
    [anon_sym_PLUS_PLUS] = ACTIONS(2200),
    [anon_sym_DOT] = ACTIONS(2198),
    [anon_sym_DOT_STAR] = ACTIONS(2200),
    [anon_sym_DASH_GT] = ACTIONS(2198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2198),
    [anon_sym_let] = ACTIONS(2198),
    [anon_sym_This] = ACTIONS(2198),
    [anon_sym_decltype] = ACTIONS(2198),
    [sym_virtual] = ACTIONS(2198),
    [anon_sym_template] = ACTIONS(2198),
    [anon_sym_operator] = ACTIONS(2198),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2200),
    [anon_sym_precise] = ACTIONS(2198),
    [anon_sym_shared] = ACTIONS(2198),
    [anon_sym_groupshared] = ACTIONS(2198),
    [anon_sym_uniform] = ACTIONS(2198),
    [anon_sym_row_major] = ACTIONS(2198),
    [anon_sym_column_major] = ACTIONS(2198),
    [anon_sym_globallycoherent] = ACTIONS(2198),
    [anon_sym_centroid] = ACTIONS(2198),
    [anon_sym_noperspective] = ACTIONS(2198),
    [anon_sym_nointerpolation] = ACTIONS(2198),
    [anon_sym_sample] = ACTIONS(2198),
    [anon_sym_linear] = ACTIONS(2198),
    [anon_sym_snorm] = ACTIONS(2198),
    [anon_sym_unorm] = ACTIONS(2198),
    [anon_sym_point] = ACTIONS(2198),
    [anon_sym_line] = ACTIONS(2198),
    [anon_sym_triangleadj] = ACTIONS(2198),
    [anon_sym_lineadj] = ACTIONS(2198),
    [anon_sym_triangle] = ACTIONS(2198),
  },
  [1426] = {
    [sym_identifier] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_LPAREN2] = ACTIONS(2188),
    [anon_sym_TILDE] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2186),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_STAR] = ACTIONS(2186),
    [anon_sym_SLASH] = ACTIONS(2186),
    [anon_sym_PERCENT] = ACTIONS(2186),
    [anon_sym_PIPE_PIPE] = ACTIONS(2188),
    [anon_sym_AMP_AMP] = ACTIONS(2188),
    [anon_sym_PIPE] = ACTIONS(2186),
    [anon_sym_CARET] = ACTIONS(2186),
    [anon_sym_AMP] = ACTIONS(2186),
    [anon_sym_EQ_EQ] = ACTIONS(2188),
    [anon_sym_BANG_EQ] = ACTIONS(2188),
    [anon_sym_GT] = ACTIONS(2186),
    [anon_sym_GT_EQ] = ACTIONS(2188),
    [anon_sym_LT_EQ] = ACTIONS(2186),
    [anon_sym_LT] = ACTIONS(2186),
    [anon_sym_LT_LT] = ACTIONS(2186),
    [anon_sym_GT_GT] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym___extension__] = ACTIONS(2186),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_out] = ACTIONS(2186),
    [anon_sym_inout] = ACTIONS(2186),
    [anon_sym_extern] = ACTIONS(2186),
    [anon_sym___attribute__] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2188),
    [anon_sym___declspec] = ACTIONS(2186),
    [anon_sym___based] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_static] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_register] = ACTIONS(2186),
    [anon_sym_inline] = ACTIONS(2186),
    [anon_sym___inline] = ACTIONS(2186),
    [anon_sym___inline__] = ACTIONS(2186),
    [anon_sym___forceinline] = ACTIONS(2186),
    [anon_sym_thread_local] = ACTIONS(2186),
    [anon_sym___thread] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_constexpr] = ACTIONS(2186),
    [anon_sym_volatile] = ACTIONS(2186),
    [anon_sym_restrict] = ACTIONS(2186),
    [anon_sym___restrict__] = ACTIONS(2186),
    [anon_sym__Atomic] = ACTIONS(2186),
    [anon_sym__Noreturn] = ACTIONS(2186),
    [anon_sym_noreturn] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_constinit] = ACTIONS(2186),
    [anon_sym_consteval] = ACTIONS(2186),
    [anon_sym_alignas] = ACTIONS(2186),
    [anon_sym__Alignas] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_STAR_EQ] = ACTIONS(2188),
    [anon_sym_SLASH_EQ] = ACTIONS(2188),
    [anon_sym_PERCENT_EQ] = ACTIONS(2188),
    [anon_sym_PLUS_EQ] = ACTIONS(2188),
    [anon_sym_DASH_EQ] = ACTIONS(2188),
    [anon_sym_LT_LT_EQ] = ACTIONS(2188),
    [anon_sym_GT_GT_EQ] = ACTIONS(2188),
    [anon_sym_AMP_EQ] = ACTIONS(2188),
    [anon_sym_CARET_EQ] = ACTIONS(2188),
    [anon_sym_PIPE_EQ] = ACTIONS(2188),
    [anon_sym_LT_EQ_GT] = ACTIONS(2188),
    [anon_sym_or] = ACTIONS(2186),
    [anon_sym_and] = ACTIONS(2186),
    [anon_sym_bitor] = ACTIONS(2186),
    [anon_sym_xor] = ACTIONS(2186),
    [anon_sym_bitand] = ACTIONS(2186),
    [anon_sym_not_eq] = ACTIONS(2186),
    [anon_sym_is] = ACTIONS(2186),
    [anon_sym_as] = ACTIONS(2186),
    [anon_sym_DASH_DASH] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2188),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOT_STAR] = ACTIONS(2188),
    [anon_sym_DASH_GT] = ACTIONS(2186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_This] = ACTIONS(2186),
    [anon_sym_decltype] = ACTIONS(2186),
    [sym_virtual] = ACTIONS(2186),
    [anon_sym_template] = ACTIONS(2186),
    [anon_sym_operator] = ACTIONS(2186),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2188),
    [anon_sym_precise] = ACTIONS(2186),
    [anon_sym_shared] = ACTIONS(2186),
    [anon_sym_groupshared] = ACTIONS(2186),
    [anon_sym_uniform] = ACTIONS(2186),
    [anon_sym_row_major] = ACTIONS(2186),
    [anon_sym_column_major] = ACTIONS(2186),
    [anon_sym_globallycoherent] = ACTIONS(2186),
    [anon_sym_centroid] = ACTIONS(2186),
    [anon_sym_noperspective] = ACTIONS(2186),
    [anon_sym_nointerpolation] = ACTIONS(2186),
    [anon_sym_sample] = ACTIONS(2186),
    [anon_sym_linear] = ACTIONS(2186),
    [anon_sym_snorm] = ACTIONS(2186),
    [anon_sym_unorm] = ACTIONS(2186),
    [anon_sym_point] = ACTIONS(2186),
    [anon_sym_line] = ACTIONS(2186),
    [anon_sym_triangleadj] = ACTIONS(2186),
    [anon_sym_lineadj] = ACTIONS(2186),
    [anon_sym_triangle] = ACTIONS(2186),
  },
  [1427] = {
    [sym_identifier] = ACTIONS(2224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2226),
    [anon_sym_COMMA] = ACTIONS(2226),
    [anon_sym_RPAREN] = ACTIONS(2226),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_TILDE] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_PLUS] = ACTIONS(2224),
    [anon_sym_STAR] = ACTIONS(2224),
    [anon_sym_SLASH] = ACTIONS(2224),
    [anon_sym_PERCENT] = ACTIONS(2224),
    [anon_sym_PIPE_PIPE] = ACTIONS(2226),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_PIPE] = ACTIONS(2224),
    [anon_sym_CARET] = ACTIONS(2224),
    [anon_sym_AMP] = ACTIONS(2224),
    [anon_sym_EQ_EQ] = ACTIONS(2226),
    [anon_sym_BANG_EQ] = ACTIONS(2226),
    [anon_sym_GT] = ACTIONS(2224),
    [anon_sym_GT_EQ] = ACTIONS(2226),
    [anon_sym_LT_EQ] = ACTIONS(2224),
    [anon_sym_LT] = ACTIONS(2224),
    [anon_sym_LT_LT] = ACTIONS(2224),
    [anon_sym_GT_GT] = ACTIONS(2224),
    [anon_sym_COLON] = ACTIONS(2224),
    [anon_sym___extension__] = ACTIONS(2224),
    [anon_sym_in] = ACTIONS(2224),
    [anon_sym_out] = ACTIONS(2224),
    [anon_sym_inout] = ACTIONS(2224),
    [anon_sym_extern] = ACTIONS(2224),
    [anon_sym___attribute__] = ACTIONS(2224),
    [anon_sym_COLON_COLON] = ACTIONS(2226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2226),
    [anon_sym___declspec] = ACTIONS(2224),
    [anon_sym___based] = ACTIONS(2224),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_LBRACK] = ACTIONS(2224),
    [anon_sym_static] = ACTIONS(2224),
    [anon_sym_EQ] = ACTIONS(2224),
    [anon_sym_register] = ACTIONS(2224),
    [anon_sym_inline] = ACTIONS(2224),
    [anon_sym___inline] = ACTIONS(2224),
    [anon_sym___inline__] = ACTIONS(2224),
    [anon_sym___forceinline] = ACTIONS(2224),
    [anon_sym_thread_local] = ACTIONS(2224),
    [anon_sym___thread] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_constexpr] = ACTIONS(2224),
    [anon_sym_volatile] = ACTIONS(2224),
    [anon_sym_restrict] = ACTIONS(2224),
    [anon_sym___restrict__] = ACTIONS(2224),
    [anon_sym__Atomic] = ACTIONS(2224),
    [anon_sym__Noreturn] = ACTIONS(2224),
    [anon_sym_noreturn] = ACTIONS(2224),
    [anon_sym_mutable] = ACTIONS(2224),
    [anon_sym_constinit] = ACTIONS(2224),
    [anon_sym_consteval] = ACTIONS(2224),
    [anon_sym_alignas] = ACTIONS(2224),
    [anon_sym__Alignas] = ACTIONS(2224),
    [anon_sym_QMARK] = ACTIONS(2226),
    [anon_sym_STAR_EQ] = ACTIONS(2226),
    [anon_sym_SLASH_EQ] = ACTIONS(2226),
    [anon_sym_PERCENT_EQ] = ACTIONS(2226),
    [anon_sym_PLUS_EQ] = ACTIONS(2226),
    [anon_sym_DASH_EQ] = ACTIONS(2226),
    [anon_sym_LT_LT_EQ] = ACTIONS(2226),
    [anon_sym_GT_GT_EQ] = ACTIONS(2226),
    [anon_sym_AMP_EQ] = ACTIONS(2226),
    [anon_sym_CARET_EQ] = ACTIONS(2226),
    [anon_sym_PIPE_EQ] = ACTIONS(2226),
    [anon_sym_LT_EQ_GT] = ACTIONS(2226),
    [anon_sym_or] = ACTIONS(2224),
    [anon_sym_and] = ACTIONS(2224),
    [anon_sym_bitor] = ACTIONS(2224),
    [anon_sym_xor] = ACTIONS(2224),
    [anon_sym_bitand] = ACTIONS(2224),
    [anon_sym_not_eq] = ACTIONS(2224),
    [anon_sym_is] = ACTIONS(2224),
    [anon_sym_as] = ACTIONS(2224),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_DOT] = ACTIONS(2224),
    [anon_sym_DOT_STAR] = ACTIONS(2226),
    [anon_sym_DASH_GT] = ACTIONS(2224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2224),
    [anon_sym_let] = ACTIONS(2224),
    [anon_sym_This] = ACTIONS(2224),
    [anon_sym_decltype] = ACTIONS(2224),
    [sym_virtual] = ACTIONS(2224),
    [anon_sym_template] = ACTIONS(2224),
    [anon_sym_operator] = ACTIONS(2224),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2226),
    [anon_sym_precise] = ACTIONS(2224),
    [anon_sym_shared] = ACTIONS(2224),
    [anon_sym_groupshared] = ACTIONS(2224),
    [anon_sym_uniform] = ACTIONS(2224),
    [anon_sym_row_major] = ACTIONS(2224),
    [anon_sym_column_major] = ACTIONS(2224),
    [anon_sym_globallycoherent] = ACTIONS(2224),
    [anon_sym_centroid] = ACTIONS(2224),
    [anon_sym_noperspective] = ACTIONS(2224),
    [anon_sym_nointerpolation] = ACTIONS(2224),
    [anon_sym_sample] = ACTIONS(2224),
    [anon_sym_linear] = ACTIONS(2224),
    [anon_sym_snorm] = ACTIONS(2224),
    [anon_sym_unorm] = ACTIONS(2224),
    [anon_sym_point] = ACTIONS(2224),
    [anon_sym_line] = ACTIONS(2224),
    [anon_sym_triangleadj] = ACTIONS(2224),
    [anon_sym_lineadj] = ACTIONS(2224),
    [anon_sym_triangle] = ACTIONS(2224),
  },
  [1428] = {
    [sym_identifier] = ACTIONS(2236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2238),
    [anon_sym_COMMA] = ACTIONS(2238),
    [anon_sym_RPAREN] = ACTIONS(2238),
    [anon_sym_LPAREN2] = ACTIONS(2238),
    [anon_sym_TILDE] = ACTIONS(2238),
    [anon_sym_DASH] = ACTIONS(2236),
    [anon_sym_PLUS] = ACTIONS(2236),
    [anon_sym_STAR] = ACTIONS(2236),
    [anon_sym_SLASH] = ACTIONS(2236),
    [anon_sym_PERCENT] = ACTIONS(2236),
    [anon_sym_PIPE_PIPE] = ACTIONS(2238),
    [anon_sym_AMP_AMP] = ACTIONS(2238),
    [anon_sym_PIPE] = ACTIONS(2236),
    [anon_sym_CARET] = ACTIONS(2236),
    [anon_sym_AMP] = ACTIONS(2236),
    [anon_sym_EQ_EQ] = ACTIONS(2238),
    [anon_sym_BANG_EQ] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2236),
    [anon_sym_GT_EQ] = ACTIONS(2238),
    [anon_sym_LT_EQ] = ACTIONS(2236),
    [anon_sym_LT] = ACTIONS(2236),
    [anon_sym_LT_LT] = ACTIONS(2236),
    [anon_sym_GT_GT] = ACTIONS(2236),
    [anon_sym_COLON] = ACTIONS(2236),
    [anon_sym___extension__] = ACTIONS(2236),
    [anon_sym_in] = ACTIONS(2236),
    [anon_sym_out] = ACTIONS(2236),
    [anon_sym_inout] = ACTIONS(2236),
    [anon_sym_extern] = ACTIONS(2236),
    [anon_sym___attribute__] = ACTIONS(2236),
    [anon_sym_COLON_COLON] = ACTIONS(2238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2238),
    [anon_sym___declspec] = ACTIONS(2236),
    [anon_sym___based] = ACTIONS(2236),
    [anon_sym_LBRACE] = ACTIONS(2238),
    [anon_sym_LBRACK] = ACTIONS(2236),
    [anon_sym_static] = ACTIONS(2236),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_register] = ACTIONS(2236),
    [anon_sym_inline] = ACTIONS(2236),
    [anon_sym___inline] = ACTIONS(2236),
    [anon_sym___inline__] = ACTIONS(2236),
    [anon_sym___forceinline] = ACTIONS(2236),
    [anon_sym_thread_local] = ACTIONS(2236),
    [anon_sym___thread] = ACTIONS(2236),
    [anon_sym_const] = ACTIONS(2236),
    [anon_sym_constexpr] = ACTIONS(2236),
    [anon_sym_volatile] = ACTIONS(2236),
    [anon_sym_restrict] = ACTIONS(2236),
    [anon_sym___restrict__] = ACTIONS(2236),
    [anon_sym__Atomic] = ACTIONS(2236),
    [anon_sym__Noreturn] = ACTIONS(2236),
    [anon_sym_noreturn] = ACTIONS(2236),
    [anon_sym_mutable] = ACTIONS(2236),
    [anon_sym_constinit] = ACTIONS(2236),
    [anon_sym_consteval] = ACTIONS(2236),
    [anon_sym_alignas] = ACTIONS(2236),
    [anon_sym__Alignas] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2238),
    [anon_sym_SLASH_EQ] = ACTIONS(2238),
    [anon_sym_PERCENT_EQ] = ACTIONS(2238),
    [anon_sym_PLUS_EQ] = ACTIONS(2238),
    [anon_sym_DASH_EQ] = ACTIONS(2238),
    [anon_sym_LT_LT_EQ] = ACTIONS(2238),
    [anon_sym_GT_GT_EQ] = ACTIONS(2238),
    [anon_sym_AMP_EQ] = ACTIONS(2238),
    [anon_sym_CARET_EQ] = ACTIONS(2238),
    [anon_sym_PIPE_EQ] = ACTIONS(2238),
    [anon_sym_LT_EQ_GT] = ACTIONS(2238),
    [anon_sym_or] = ACTIONS(2236),
    [anon_sym_and] = ACTIONS(2236),
    [anon_sym_bitor] = ACTIONS(2236),
    [anon_sym_xor] = ACTIONS(2236),
    [anon_sym_bitand] = ACTIONS(2236),
    [anon_sym_not_eq] = ACTIONS(2236),
    [anon_sym_is] = ACTIONS(2236),
    [anon_sym_as] = ACTIONS(2236),
    [anon_sym_DASH_DASH] = ACTIONS(2238),
    [anon_sym_PLUS_PLUS] = ACTIONS(2238),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_DOT_STAR] = ACTIONS(2238),
    [anon_sym_DASH_GT] = ACTIONS(2236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2236),
    [anon_sym_let] = ACTIONS(2236),
    [anon_sym_This] = ACTIONS(2236),
    [anon_sym_decltype] = ACTIONS(2236),
    [sym_virtual] = ACTIONS(2236),
    [anon_sym_template] = ACTIONS(2236),
    [anon_sym_operator] = ACTIONS(2236),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2238),
    [anon_sym_precise] = ACTIONS(2236),
    [anon_sym_shared] = ACTIONS(2236),
    [anon_sym_groupshared] = ACTIONS(2236),
    [anon_sym_uniform] = ACTIONS(2236),
    [anon_sym_row_major] = ACTIONS(2236),
    [anon_sym_column_major] = ACTIONS(2236),
    [anon_sym_globallycoherent] = ACTIONS(2236),
    [anon_sym_centroid] = ACTIONS(2236),
    [anon_sym_noperspective] = ACTIONS(2236),
    [anon_sym_nointerpolation] = ACTIONS(2236),
    [anon_sym_sample] = ACTIONS(2236),
    [anon_sym_linear] = ACTIONS(2236),
    [anon_sym_snorm] = ACTIONS(2236),
    [anon_sym_unorm] = ACTIONS(2236),
    [anon_sym_point] = ACTIONS(2236),
    [anon_sym_line] = ACTIONS(2236),
    [anon_sym_triangleadj] = ACTIONS(2236),
    [anon_sym_lineadj] = ACTIONS(2236),
    [anon_sym_triangle] = ACTIONS(2236),
  },
  [1429] = {
    [sym_identifier] = ACTIONS(2190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2192),
    [anon_sym_COMMA] = ACTIONS(2192),
    [anon_sym_RPAREN] = ACTIONS(2192),
    [anon_sym_LPAREN2] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2190),
    [anon_sym_PLUS] = ACTIONS(2190),
    [anon_sym_STAR] = ACTIONS(2190),
    [anon_sym_SLASH] = ACTIONS(2190),
    [anon_sym_PERCENT] = ACTIONS(2190),
    [anon_sym_PIPE_PIPE] = ACTIONS(2192),
    [anon_sym_AMP_AMP] = ACTIONS(2192),
    [anon_sym_PIPE] = ACTIONS(2190),
    [anon_sym_CARET] = ACTIONS(2190),
    [anon_sym_AMP] = ACTIONS(2190),
    [anon_sym_EQ_EQ] = ACTIONS(2192),
    [anon_sym_BANG_EQ] = ACTIONS(2192),
    [anon_sym_GT] = ACTIONS(2190),
    [anon_sym_GT_EQ] = ACTIONS(2192),
    [anon_sym_LT_EQ] = ACTIONS(2190),
    [anon_sym_LT] = ACTIONS(2190),
    [anon_sym_LT_LT] = ACTIONS(2190),
    [anon_sym_GT_GT] = ACTIONS(2190),
    [anon_sym_COLON] = ACTIONS(2190),
    [anon_sym___extension__] = ACTIONS(2190),
    [anon_sym_in] = ACTIONS(2190),
    [anon_sym_out] = ACTIONS(2190),
    [anon_sym_inout] = ACTIONS(2190),
    [anon_sym_extern] = ACTIONS(2190),
    [anon_sym___attribute__] = ACTIONS(2190),
    [anon_sym_COLON_COLON] = ACTIONS(2192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2192),
    [anon_sym___declspec] = ACTIONS(2190),
    [anon_sym___based] = ACTIONS(2190),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [anon_sym_LBRACK] = ACTIONS(2190),
    [anon_sym_static] = ACTIONS(2190),
    [anon_sym_EQ] = ACTIONS(2190),
    [anon_sym_register] = ACTIONS(2190),
    [anon_sym_inline] = ACTIONS(2190),
    [anon_sym___inline] = ACTIONS(2190),
    [anon_sym___inline__] = ACTIONS(2190),
    [anon_sym___forceinline] = ACTIONS(2190),
    [anon_sym_thread_local] = ACTIONS(2190),
    [anon_sym___thread] = ACTIONS(2190),
    [anon_sym_const] = ACTIONS(2190),
    [anon_sym_constexpr] = ACTIONS(2190),
    [anon_sym_volatile] = ACTIONS(2190),
    [anon_sym_restrict] = ACTIONS(2190),
    [anon_sym___restrict__] = ACTIONS(2190),
    [anon_sym__Atomic] = ACTIONS(2190),
    [anon_sym__Noreturn] = ACTIONS(2190),
    [anon_sym_noreturn] = ACTIONS(2190),
    [anon_sym_mutable] = ACTIONS(2190),
    [anon_sym_constinit] = ACTIONS(2190),
    [anon_sym_consteval] = ACTIONS(2190),
    [anon_sym_alignas] = ACTIONS(2190),
    [anon_sym__Alignas] = ACTIONS(2190),
    [anon_sym_QMARK] = ACTIONS(2192),
    [anon_sym_STAR_EQ] = ACTIONS(2192),
    [anon_sym_SLASH_EQ] = ACTIONS(2192),
    [anon_sym_PERCENT_EQ] = ACTIONS(2192),
    [anon_sym_PLUS_EQ] = ACTIONS(2192),
    [anon_sym_DASH_EQ] = ACTIONS(2192),
    [anon_sym_LT_LT_EQ] = ACTIONS(2192),
    [anon_sym_GT_GT_EQ] = ACTIONS(2192),
    [anon_sym_AMP_EQ] = ACTIONS(2192),
    [anon_sym_CARET_EQ] = ACTIONS(2192),
    [anon_sym_PIPE_EQ] = ACTIONS(2192),
    [anon_sym_LT_EQ_GT] = ACTIONS(2192),
    [anon_sym_or] = ACTIONS(2190),
    [anon_sym_and] = ACTIONS(2190),
    [anon_sym_bitor] = ACTIONS(2190),
    [anon_sym_xor] = ACTIONS(2190),
    [anon_sym_bitand] = ACTIONS(2190),
    [anon_sym_not_eq] = ACTIONS(2190),
    [anon_sym_is] = ACTIONS(2190),
    [anon_sym_as] = ACTIONS(2190),
    [anon_sym_DASH_DASH] = ACTIONS(2192),
    [anon_sym_PLUS_PLUS] = ACTIONS(2192),
    [anon_sym_DOT] = ACTIONS(2190),
    [anon_sym_DOT_STAR] = ACTIONS(2192),
    [anon_sym_DASH_GT] = ACTIONS(2190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2190),
    [anon_sym_let] = ACTIONS(2190),
    [anon_sym_This] = ACTIONS(2190),
    [anon_sym_decltype] = ACTIONS(2190),
    [sym_virtual] = ACTIONS(2190),
    [anon_sym_template] = ACTIONS(2190),
    [anon_sym_operator] = ACTIONS(2190),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2192),
    [anon_sym_precise] = ACTIONS(2190),
    [anon_sym_shared] = ACTIONS(2190),
    [anon_sym_groupshared] = ACTIONS(2190),
    [anon_sym_uniform] = ACTIONS(2190),
    [anon_sym_row_major] = ACTIONS(2190),
    [anon_sym_column_major] = ACTIONS(2190),
    [anon_sym_globallycoherent] = ACTIONS(2190),
    [anon_sym_centroid] = ACTIONS(2190),
    [anon_sym_noperspective] = ACTIONS(2190),
    [anon_sym_nointerpolation] = ACTIONS(2190),
    [anon_sym_sample] = ACTIONS(2190),
    [anon_sym_linear] = ACTIONS(2190),
    [anon_sym_snorm] = ACTIONS(2190),
    [anon_sym_unorm] = ACTIONS(2190),
    [anon_sym_point] = ACTIONS(2190),
    [anon_sym_line] = ACTIONS(2190),
    [anon_sym_triangleadj] = ACTIONS(2190),
    [anon_sym_lineadj] = ACTIONS(2190),
    [anon_sym_triangle] = ACTIONS(2190),
  },
  [1430] = {
    [sym_identifier] = ACTIONS(2206),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2208),
    [anon_sym_COMMA] = ACTIONS(2208),
    [anon_sym_RPAREN] = ACTIONS(2208),
    [anon_sym_LPAREN2] = ACTIONS(2208),
    [anon_sym_TILDE] = ACTIONS(2208),
    [anon_sym_DASH] = ACTIONS(2206),
    [anon_sym_PLUS] = ACTIONS(2206),
    [anon_sym_STAR] = ACTIONS(2206),
    [anon_sym_SLASH] = ACTIONS(2206),
    [anon_sym_PERCENT] = ACTIONS(2206),
    [anon_sym_PIPE_PIPE] = ACTIONS(2208),
    [anon_sym_AMP_AMP] = ACTIONS(2208),
    [anon_sym_PIPE] = ACTIONS(2206),
    [anon_sym_CARET] = ACTIONS(2206),
    [anon_sym_AMP] = ACTIONS(2206),
    [anon_sym_EQ_EQ] = ACTIONS(2208),
    [anon_sym_BANG_EQ] = ACTIONS(2208),
    [anon_sym_GT] = ACTIONS(2206),
    [anon_sym_GT_EQ] = ACTIONS(2208),
    [anon_sym_LT_EQ] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2206),
    [anon_sym_LT_LT] = ACTIONS(2206),
    [anon_sym_GT_GT] = ACTIONS(2206),
    [anon_sym_COLON] = ACTIONS(2206),
    [anon_sym___extension__] = ACTIONS(2206),
    [anon_sym_in] = ACTIONS(2206),
    [anon_sym_out] = ACTIONS(2206),
    [anon_sym_inout] = ACTIONS(2206),
    [anon_sym_extern] = ACTIONS(2206),
    [anon_sym___attribute__] = ACTIONS(2206),
    [anon_sym_COLON_COLON] = ACTIONS(2208),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2208),
    [anon_sym___declspec] = ACTIONS(2206),
    [anon_sym___based] = ACTIONS(2206),
    [anon_sym_LBRACE] = ACTIONS(2208),
    [anon_sym_LBRACK] = ACTIONS(2206),
    [anon_sym_static] = ACTIONS(2206),
    [anon_sym_EQ] = ACTIONS(2206),
    [anon_sym_register] = ACTIONS(2206),
    [anon_sym_inline] = ACTIONS(2206),
    [anon_sym___inline] = ACTIONS(2206),
    [anon_sym___inline__] = ACTIONS(2206),
    [anon_sym___forceinline] = ACTIONS(2206),
    [anon_sym_thread_local] = ACTIONS(2206),
    [anon_sym___thread] = ACTIONS(2206),
    [anon_sym_const] = ACTIONS(2206),
    [anon_sym_constexpr] = ACTIONS(2206),
    [anon_sym_volatile] = ACTIONS(2206),
    [anon_sym_restrict] = ACTIONS(2206),
    [anon_sym___restrict__] = ACTIONS(2206),
    [anon_sym__Atomic] = ACTIONS(2206),
    [anon_sym__Noreturn] = ACTIONS(2206),
    [anon_sym_noreturn] = ACTIONS(2206),
    [anon_sym_mutable] = ACTIONS(2206),
    [anon_sym_constinit] = ACTIONS(2206),
    [anon_sym_consteval] = ACTIONS(2206),
    [anon_sym_alignas] = ACTIONS(2206),
    [anon_sym__Alignas] = ACTIONS(2206),
    [anon_sym_QMARK] = ACTIONS(2208),
    [anon_sym_STAR_EQ] = ACTIONS(2208),
    [anon_sym_SLASH_EQ] = ACTIONS(2208),
    [anon_sym_PERCENT_EQ] = ACTIONS(2208),
    [anon_sym_PLUS_EQ] = ACTIONS(2208),
    [anon_sym_DASH_EQ] = ACTIONS(2208),
    [anon_sym_LT_LT_EQ] = ACTIONS(2208),
    [anon_sym_GT_GT_EQ] = ACTIONS(2208),
    [anon_sym_AMP_EQ] = ACTIONS(2208),
    [anon_sym_CARET_EQ] = ACTIONS(2208),
    [anon_sym_PIPE_EQ] = ACTIONS(2208),
    [anon_sym_LT_EQ_GT] = ACTIONS(2208),
    [anon_sym_or] = ACTIONS(2206),
    [anon_sym_and] = ACTIONS(2206),
    [anon_sym_bitor] = ACTIONS(2206),
    [anon_sym_xor] = ACTIONS(2206),
    [anon_sym_bitand] = ACTIONS(2206),
    [anon_sym_not_eq] = ACTIONS(2206),
    [anon_sym_is] = ACTIONS(2206),
    [anon_sym_as] = ACTIONS(2206),
    [anon_sym_DASH_DASH] = ACTIONS(2208),
    [anon_sym_PLUS_PLUS] = ACTIONS(2208),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_DOT_STAR] = ACTIONS(2208),
    [anon_sym_DASH_GT] = ACTIONS(2206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2206),
    [anon_sym_let] = ACTIONS(2206),
    [anon_sym_This] = ACTIONS(2206),
    [anon_sym_decltype] = ACTIONS(2206),
    [sym_virtual] = ACTIONS(2206),
    [anon_sym_template] = ACTIONS(2206),
    [anon_sym_operator] = ACTIONS(2206),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2208),
    [anon_sym_precise] = ACTIONS(2206),
    [anon_sym_shared] = ACTIONS(2206),
    [anon_sym_groupshared] = ACTIONS(2206),
    [anon_sym_uniform] = ACTIONS(2206),
    [anon_sym_row_major] = ACTIONS(2206),
    [anon_sym_column_major] = ACTIONS(2206),
    [anon_sym_globallycoherent] = ACTIONS(2206),
    [anon_sym_centroid] = ACTIONS(2206),
    [anon_sym_noperspective] = ACTIONS(2206),
    [anon_sym_nointerpolation] = ACTIONS(2206),
    [anon_sym_sample] = ACTIONS(2206),
    [anon_sym_linear] = ACTIONS(2206),
    [anon_sym_snorm] = ACTIONS(2206),
    [anon_sym_unorm] = ACTIONS(2206),
    [anon_sym_point] = ACTIONS(2206),
    [anon_sym_line] = ACTIONS(2206),
    [anon_sym_triangleadj] = ACTIONS(2206),
    [anon_sym_lineadj] = ACTIONS(2206),
    [anon_sym_triangle] = ACTIONS(2206),
  },
  [1431] = {
    [sym_identifier] = ACTIONS(2194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2196),
    [anon_sym_COMMA] = ACTIONS(2196),
    [anon_sym_RPAREN] = ACTIONS(2196),
    [anon_sym_LPAREN2] = ACTIONS(2196),
    [anon_sym_TILDE] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2194),
    [anon_sym_PLUS] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(2194),
    [anon_sym_SLASH] = ACTIONS(2194),
    [anon_sym_PERCENT] = ACTIONS(2194),
    [anon_sym_PIPE_PIPE] = ACTIONS(2196),
    [anon_sym_AMP_AMP] = ACTIONS(2196),
    [anon_sym_PIPE] = ACTIONS(2194),
    [anon_sym_CARET] = ACTIONS(2194),
    [anon_sym_AMP] = ACTIONS(2194),
    [anon_sym_EQ_EQ] = ACTIONS(2196),
    [anon_sym_BANG_EQ] = ACTIONS(2196),
    [anon_sym_GT] = ACTIONS(2194),
    [anon_sym_GT_EQ] = ACTIONS(2196),
    [anon_sym_LT_EQ] = ACTIONS(2194),
    [anon_sym_LT] = ACTIONS(2194),
    [anon_sym_LT_LT] = ACTIONS(2194),
    [anon_sym_GT_GT] = ACTIONS(2194),
    [anon_sym_COLON] = ACTIONS(2194),
    [anon_sym___extension__] = ACTIONS(2194),
    [anon_sym_in] = ACTIONS(2194),
    [anon_sym_out] = ACTIONS(2194),
    [anon_sym_inout] = ACTIONS(2194),
    [anon_sym_extern] = ACTIONS(2194),
    [anon_sym___attribute__] = ACTIONS(2194),
    [anon_sym_COLON_COLON] = ACTIONS(2196),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2196),
    [anon_sym___declspec] = ACTIONS(2194),
    [anon_sym___based] = ACTIONS(2194),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_LBRACK] = ACTIONS(2194),
    [anon_sym_static] = ACTIONS(2194),
    [anon_sym_EQ] = ACTIONS(2194),
    [anon_sym_register] = ACTIONS(2194),
    [anon_sym_inline] = ACTIONS(2194),
    [anon_sym___inline] = ACTIONS(2194),
    [anon_sym___inline__] = ACTIONS(2194),
    [anon_sym___forceinline] = ACTIONS(2194),
    [anon_sym_thread_local] = ACTIONS(2194),
    [anon_sym___thread] = ACTIONS(2194),
    [anon_sym_const] = ACTIONS(2194),
    [anon_sym_constexpr] = ACTIONS(2194),
    [anon_sym_volatile] = ACTIONS(2194),
    [anon_sym_restrict] = ACTIONS(2194),
    [anon_sym___restrict__] = ACTIONS(2194),
    [anon_sym__Atomic] = ACTIONS(2194),
    [anon_sym__Noreturn] = ACTIONS(2194),
    [anon_sym_noreturn] = ACTIONS(2194),
    [anon_sym_mutable] = ACTIONS(2194),
    [anon_sym_constinit] = ACTIONS(2194),
    [anon_sym_consteval] = ACTIONS(2194),
    [anon_sym_alignas] = ACTIONS(2194),
    [anon_sym__Alignas] = ACTIONS(2194),
    [anon_sym_QMARK] = ACTIONS(2196),
    [anon_sym_STAR_EQ] = ACTIONS(2196),
    [anon_sym_SLASH_EQ] = ACTIONS(2196),
    [anon_sym_PERCENT_EQ] = ACTIONS(2196),
    [anon_sym_PLUS_EQ] = ACTIONS(2196),
    [anon_sym_DASH_EQ] = ACTIONS(2196),
    [anon_sym_LT_LT_EQ] = ACTIONS(2196),
    [anon_sym_GT_GT_EQ] = ACTIONS(2196),
    [anon_sym_AMP_EQ] = ACTIONS(2196),
    [anon_sym_CARET_EQ] = ACTIONS(2196),
    [anon_sym_PIPE_EQ] = ACTIONS(2196),
    [anon_sym_LT_EQ_GT] = ACTIONS(2196),
    [anon_sym_or] = ACTIONS(2194),
    [anon_sym_and] = ACTIONS(2194),
    [anon_sym_bitor] = ACTIONS(2194),
    [anon_sym_xor] = ACTIONS(2194),
    [anon_sym_bitand] = ACTIONS(2194),
    [anon_sym_not_eq] = ACTIONS(2194),
    [anon_sym_is] = ACTIONS(2194),
    [anon_sym_as] = ACTIONS(2194),
    [anon_sym_DASH_DASH] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2196),
    [anon_sym_DOT] = ACTIONS(2194),
    [anon_sym_DOT_STAR] = ACTIONS(2196),
    [anon_sym_DASH_GT] = ACTIONS(2194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2194),
    [anon_sym_let] = ACTIONS(2194),
    [anon_sym_This] = ACTIONS(2194),
    [anon_sym_decltype] = ACTIONS(2194),
    [sym_virtual] = ACTIONS(2194),
    [anon_sym_template] = ACTIONS(2194),
    [anon_sym_operator] = ACTIONS(2194),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2196),
    [anon_sym_precise] = ACTIONS(2194),
    [anon_sym_shared] = ACTIONS(2194),
    [anon_sym_groupshared] = ACTIONS(2194),
    [anon_sym_uniform] = ACTIONS(2194),
    [anon_sym_row_major] = ACTIONS(2194),
    [anon_sym_column_major] = ACTIONS(2194),
    [anon_sym_globallycoherent] = ACTIONS(2194),
    [anon_sym_centroid] = ACTIONS(2194),
    [anon_sym_noperspective] = ACTIONS(2194),
    [anon_sym_nointerpolation] = ACTIONS(2194),
    [anon_sym_sample] = ACTIONS(2194),
    [anon_sym_linear] = ACTIONS(2194),
    [anon_sym_snorm] = ACTIONS(2194),
    [anon_sym_unorm] = ACTIONS(2194),
    [anon_sym_point] = ACTIONS(2194),
    [anon_sym_line] = ACTIONS(2194),
    [anon_sym_triangleadj] = ACTIONS(2194),
    [anon_sym_lineadj] = ACTIONS(2194),
    [anon_sym_triangle] = ACTIONS(2194),
  },
  [1432] = {
    [sym_identifier] = ACTIONS(2240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2242),
    [anon_sym_RPAREN] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_TILDE] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2240),
    [anon_sym_PLUS] = ACTIONS(2240),
    [anon_sym_STAR] = ACTIONS(2240),
    [anon_sym_SLASH] = ACTIONS(2240),
    [anon_sym_PERCENT] = ACTIONS(2240),
    [anon_sym_PIPE_PIPE] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_PIPE] = ACTIONS(2240),
    [anon_sym_CARET] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2240),
    [anon_sym_EQ_EQ] = ACTIONS(2242),
    [anon_sym_BANG_EQ] = ACTIONS(2242),
    [anon_sym_GT] = ACTIONS(2240),
    [anon_sym_GT_EQ] = ACTIONS(2242),
    [anon_sym_LT_EQ] = ACTIONS(2240),
    [anon_sym_LT] = ACTIONS(2240),
    [anon_sym_LT_LT] = ACTIONS(2240),
    [anon_sym_GT_GT] = ACTIONS(2240),
    [anon_sym_COLON] = ACTIONS(2240),
    [anon_sym___extension__] = ACTIONS(2240),
    [anon_sym_in] = ACTIONS(2240),
    [anon_sym_out] = ACTIONS(2240),
    [anon_sym_inout] = ACTIONS(2240),
    [anon_sym_extern] = ACTIONS(2240),
    [anon_sym___attribute__] = ACTIONS(2240),
    [anon_sym_COLON_COLON] = ACTIONS(2242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2242),
    [anon_sym___declspec] = ACTIONS(2240),
    [anon_sym___based] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2240),
    [anon_sym_static] = ACTIONS(2240),
    [anon_sym_EQ] = ACTIONS(2240),
    [anon_sym_register] = ACTIONS(2240),
    [anon_sym_inline] = ACTIONS(2240),
    [anon_sym___inline] = ACTIONS(2240),
    [anon_sym___inline__] = ACTIONS(2240),
    [anon_sym___forceinline] = ACTIONS(2240),
    [anon_sym_thread_local] = ACTIONS(2240),
    [anon_sym___thread] = ACTIONS(2240),
    [anon_sym_const] = ACTIONS(2240),
    [anon_sym_constexpr] = ACTIONS(2240),
    [anon_sym_volatile] = ACTIONS(2240),
    [anon_sym_restrict] = ACTIONS(2240),
    [anon_sym___restrict__] = ACTIONS(2240),
    [anon_sym__Atomic] = ACTIONS(2240),
    [anon_sym__Noreturn] = ACTIONS(2240),
    [anon_sym_noreturn] = ACTIONS(2240),
    [anon_sym_mutable] = ACTIONS(2240),
    [anon_sym_constinit] = ACTIONS(2240),
    [anon_sym_consteval] = ACTIONS(2240),
    [anon_sym_alignas] = ACTIONS(2240),
    [anon_sym__Alignas] = ACTIONS(2240),
    [anon_sym_QMARK] = ACTIONS(2242),
    [anon_sym_STAR_EQ] = ACTIONS(2242),
    [anon_sym_SLASH_EQ] = ACTIONS(2242),
    [anon_sym_PERCENT_EQ] = ACTIONS(2242),
    [anon_sym_PLUS_EQ] = ACTIONS(2242),
    [anon_sym_DASH_EQ] = ACTIONS(2242),
    [anon_sym_LT_LT_EQ] = ACTIONS(2242),
    [anon_sym_GT_GT_EQ] = ACTIONS(2242),
    [anon_sym_AMP_EQ] = ACTIONS(2242),
    [anon_sym_CARET_EQ] = ACTIONS(2242),
    [anon_sym_PIPE_EQ] = ACTIONS(2242),
    [anon_sym_LT_EQ_GT] = ACTIONS(2242),
    [anon_sym_or] = ACTIONS(2240),
    [anon_sym_and] = ACTIONS(2240),
    [anon_sym_bitor] = ACTIONS(2240),
    [anon_sym_xor] = ACTIONS(2240),
    [anon_sym_bitand] = ACTIONS(2240),
    [anon_sym_not_eq] = ACTIONS(2240),
    [anon_sym_is] = ACTIONS(2240),
    [anon_sym_as] = ACTIONS(2240),
    [anon_sym_DASH_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_PLUS] = ACTIONS(2242),
    [anon_sym_DOT] = ACTIONS(2240),
    [anon_sym_DOT_STAR] = ACTIONS(2242),
    [anon_sym_DASH_GT] = ACTIONS(2240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2240),
    [anon_sym_let] = ACTIONS(2240),
    [anon_sym_This] = ACTIONS(2240),
    [anon_sym_decltype] = ACTIONS(2240),
    [sym_virtual] = ACTIONS(2240),
    [anon_sym_template] = ACTIONS(2240),
    [anon_sym_operator] = ACTIONS(2240),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2242),
    [anon_sym_precise] = ACTIONS(2240),
    [anon_sym_shared] = ACTIONS(2240),
    [anon_sym_groupshared] = ACTIONS(2240),
    [anon_sym_uniform] = ACTIONS(2240),
    [anon_sym_row_major] = ACTIONS(2240),
    [anon_sym_column_major] = ACTIONS(2240),
    [anon_sym_globallycoherent] = ACTIONS(2240),
    [anon_sym_centroid] = ACTIONS(2240),
    [anon_sym_noperspective] = ACTIONS(2240),
    [anon_sym_nointerpolation] = ACTIONS(2240),
    [anon_sym_sample] = ACTIONS(2240),
    [anon_sym_linear] = ACTIONS(2240),
    [anon_sym_snorm] = ACTIONS(2240),
    [anon_sym_unorm] = ACTIONS(2240),
    [anon_sym_point] = ACTIONS(2240),
    [anon_sym_line] = ACTIONS(2240),
    [anon_sym_triangleadj] = ACTIONS(2240),
    [anon_sym_lineadj] = ACTIONS(2240),
    [anon_sym_triangle] = ACTIONS(2240),
  },
  [1433] = {
    [sym_identifier] = ACTIONS(2198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_COMMA] = ACTIONS(2200),
    [anon_sym_RPAREN] = ACTIONS(2200),
    [anon_sym_LPAREN2] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(2200),
    [anon_sym_SLASH] = ACTIONS(2198),
    [anon_sym_PERCENT] = ACTIONS(2200),
    [anon_sym_PIPE_PIPE] = ACTIONS(2200),
    [anon_sym_AMP_AMP] = ACTIONS(2200),
    [anon_sym_PIPE] = ACTIONS(2198),
    [anon_sym_CARET] = ACTIONS(2200),
    [anon_sym_AMP] = ACTIONS(2198),
    [anon_sym_EQ_EQ] = ACTIONS(2200),
    [anon_sym_BANG_EQ] = ACTIONS(2200),
    [anon_sym_GT] = ACTIONS(2198),
    [anon_sym_GT_EQ] = ACTIONS(2200),
    [anon_sym_LT_EQ] = ACTIONS(2198),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_LT_LT] = ACTIONS(2200),
    [anon_sym_GT_GT] = ACTIONS(2200),
    [anon_sym_COLON] = ACTIONS(2198),
    [anon_sym_SEMI] = ACTIONS(2200),
    [anon_sym___extension__] = ACTIONS(2198),
    [anon_sym_in] = ACTIONS(2198),
    [anon_sym_out] = ACTIONS(2198),
    [anon_sym_inout] = ACTIONS(2198),
    [anon_sym_extern] = ACTIONS(2198),
    [anon_sym___attribute__] = ACTIONS(2198),
    [anon_sym_COLON_COLON] = ACTIONS(2200),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2200),
    [anon_sym___declspec] = ACTIONS(2198),
    [anon_sym___based] = ACTIONS(2198),
    [anon_sym___cdecl] = ACTIONS(2198),
    [anon_sym___clrcall] = ACTIONS(2198),
    [anon_sym___stdcall] = ACTIONS(2198),
    [anon_sym___fastcall] = ACTIONS(2198),
    [anon_sym___thiscall] = ACTIONS(2198),
    [anon_sym___vectorcall] = ACTIONS(2198),
    [anon_sym_LBRACE] = ACTIONS(2200),
    [anon_sym_RBRACE] = ACTIONS(2200),
    [anon_sym_LBRACK] = ACTIONS(2198),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_register] = ACTIONS(2198),
    [anon_sym_inline] = ACTIONS(2198),
    [anon_sym___inline] = ACTIONS(2198),
    [anon_sym___inline__] = ACTIONS(2198),
    [anon_sym___forceinline] = ACTIONS(2198),
    [anon_sym_thread_local] = ACTIONS(2198),
    [anon_sym___thread] = ACTIONS(2198),
    [anon_sym_const] = ACTIONS(2198),
    [anon_sym_constexpr] = ACTIONS(2198),
    [anon_sym_volatile] = ACTIONS(2198),
    [anon_sym_restrict] = ACTIONS(2198),
    [anon_sym___restrict__] = ACTIONS(2198),
    [anon_sym__Atomic] = ACTIONS(2198),
    [anon_sym__Noreturn] = ACTIONS(2198),
    [anon_sym_noreturn] = ACTIONS(2198),
    [anon_sym_mutable] = ACTIONS(2198),
    [anon_sym_constinit] = ACTIONS(2198),
    [anon_sym_consteval] = ACTIONS(2198),
    [anon_sym_alignas] = ACTIONS(2198),
    [anon_sym__Alignas] = ACTIONS(2198),
    [anon_sym_QMARK] = ACTIONS(2200),
    [anon_sym_LT_EQ_GT] = ACTIONS(2200),
    [anon_sym_or] = ACTIONS(2198),
    [anon_sym_and] = ACTIONS(2198),
    [anon_sym_bitor] = ACTIONS(2198),
    [anon_sym_xor] = ACTIONS(2198),
    [anon_sym_bitand] = ACTIONS(2198),
    [anon_sym_not_eq] = ACTIONS(2198),
    [anon_sym_is] = ACTIONS(2198),
    [anon_sym_as] = ACTIONS(2198),
    [anon_sym_DASH_DASH] = ACTIONS(2200),
    [anon_sym_PLUS_PLUS] = ACTIONS(2200),
    [anon_sym_DOT] = ACTIONS(2198),
    [anon_sym_DOT_STAR] = ACTIONS(2200),
    [anon_sym_DASH_GT] = ACTIONS(2200),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2198),
    [anon_sym_let] = ACTIONS(2198),
    [anon_sym_This] = ACTIONS(2198),
    [anon_sym_decltype] = ACTIONS(2198),
    [anon_sym_final] = ACTIONS(2198),
    [anon_sym_override] = ACTIONS(2198),
    [sym_virtual] = ACTIONS(2198),
    [anon_sym_template] = ACTIONS(2198),
    [anon_sym_operator] = ACTIONS(2198),
    [anon_sym_precise] = ACTIONS(2198),
    [anon_sym_shared] = ACTIONS(2198),
    [anon_sym_groupshared] = ACTIONS(2198),
    [anon_sym_uniform] = ACTIONS(2198),
    [anon_sym_row_major] = ACTIONS(2198),
    [anon_sym_column_major] = ACTIONS(2198),
    [anon_sym_globallycoherent] = ACTIONS(2198),
    [anon_sym_centroid] = ACTIONS(2198),
    [anon_sym_noperspective] = ACTIONS(2198),
    [anon_sym_nointerpolation] = ACTIONS(2198),
    [anon_sym_sample] = ACTIONS(2198),
    [anon_sym_linear] = ACTIONS(2198),
    [anon_sym_snorm] = ACTIONS(2198),
    [anon_sym_unorm] = ACTIONS(2198),
    [anon_sym_point] = ACTIONS(2198),
    [anon_sym_line] = ACTIONS(2198),
    [anon_sym_triangleadj] = ACTIONS(2198),
    [anon_sym_lineadj] = ACTIONS(2198),
    [anon_sym_triangle] = ACTIONS(2198),
  },
  [1434] = {
    [sym_identifier] = ACTIONS(2232),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_COMMA] = ACTIONS(2234),
    [anon_sym_RPAREN] = ACTIONS(2234),
    [anon_sym_LPAREN2] = ACTIONS(2234),
    [anon_sym_TILDE] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2232),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2232),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_PIPE_PIPE] = ACTIONS(2234),
    [anon_sym_AMP_AMP] = ACTIONS(2234),
    [anon_sym_PIPE] = ACTIONS(2232),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2232),
    [anon_sym_EQ_EQ] = ACTIONS(2234),
    [anon_sym_BANG_EQ] = ACTIONS(2234),
    [anon_sym_GT] = ACTIONS(2232),
    [anon_sym_GT_EQ] = ACTIONS(2234),
    [anon_sym_LT_EQ] = ACTIONS(2232),
    [anon_sym_LT] = ACTIONS(2232),
    [anon_sym_LT_LT] = ACTIONS(2234),
    [anon_sym_GT_GT] = ACTIONS(2234),
    [anon_sym_COLON] = ACTIONS(2232),
    [anon_sym_SEMI] = ACTIONS(2234),
    [anon_sym___extension__] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2232),
    [anon_sym_out] = ACTIONS(2232),
    [anon_sym_inout] = ACTIONS(2232),
    [anon_sym_extern] = ACTIONS(2232),
    [anon_sym___attribute__] = ACTIONS(2232),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2234),
    [anon_sym___declspec] = ACTIONS(2232),
    [anon_sym___based] = ACTIONS(2232),
    [anon_sym___cdecl] = ACTIONS(2232),
    [anon_sym___clrcall] = ACTIONS(2232),
    [anon_sym___stdcall] = ACTIONS(2232),
    [anon_sym___fastcall] = ACTIONS(2232),
    [anon_sym___thiscall] = ACTIONS(2232),
    [anon_sym___vectorcall] = ACTIONS(2232),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_RBRACE] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2232),
    [anon_sym_static] = ACTIONS(2232),
    [anon_sym_register] = ACTIONS(2232),
    [anon_sym_inline] = ACTIONS(2232),
    [anon_sym___inline] = ACTIONS(2232),
    [anon_sym___inline__] = ACTIONS(2232),
    [anon_sym___forceinline] = ACTIONS(2232),
    [anon_sym_thread_local] = ACTIONS(2232),
    [anon_sym___thread] = ACTIONS(2232),
    [anon_sym_const] = ACTIONS(2232),
    [anon_sym_constexpr] = ACTIONS(2232),
    [anon_sym_volatile] = ACTIONS(2232),
    [anon_sym_restrict] = ACTIONS(2232),
    [anon_sym___restrict__] = ACTIONS(2232),
    [anon_sym__Atomic] = ACTIONS(2232),
    [anon_sym__Noreturn] = ACTIONS(2232),
    [anon_sym_noreturn] = ACTIONS(2232),
    [anon_sym_mutable] = ACTIONS(2232),
    [anon_sym_constinit] = ACTIONS(2232),
    [anon_sym_consteval] = ACTIONS(2232),
    [anon_sym_alignas] = ACTIONS(2232),
    [anon_sym__Alignas] = ACTIONS(2232),
    [anon_sym_QMARK] = ACTIONS(2234),
    [anon_sym_LT_EQ_GT] = ACTIONS(2234),
    [anon_sym_or] = ACTIONS(2232),
    [anon_sym_and] = ACTIONS(2232),
    [anon_sym_bitor] = ACTIONS(2232),
    [anon_sym_xor] = ACTIONS(2232),
    [anon_sym_bitand] = ACTIONS(2232),
    [anon_sym_not_eq] = ACTIONS(2232),
    [anon_sym_is] = ACTIONS(2232),
    [anon_sym_as] = ACTIONS(2232),
    [anon_sym_DASH_DASH] = ACTIONS(2234),
    [anon_sym_PLUS_PLUS] = ACTIONS(2234),
    [anon_sym_DOT] = ACTIONS(2232),
    [anon_sym_DOT_STAR] = ACTIONS(2234),
    [anon_sym_DASH_GT] = ACTIONS(2234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2232),
    [anon_sym_let] = ACTIONS(2232),
    [anon_sym_This] = ACTIONS(2232),
    [anon_sym_decltype] = ACTIONS(2232),
    [anon_sym_final] = ACTIONS(2232),
    [anon_sym_override] = ACTIONS(2232),
    [sym_virtual] = ACTIONS(2232),
    [anon_sym_template] = ACTIONS(2232),
    [anon_sym_operator] = ACTIONS(2232),
    [anon_sym_precise] = ACTIONS(2232),
    [anon_sym_shared] = ACTIONS(2232),
    [anon_sym_groupshared] = ACTIONS(2232),
    [anon_sym_uniform] = ACTIONS(2232),
    [anon_sym_row_major] = ACTIONS(2232),
    [anon_sym_column_major] = ACTIONS(2232),
    [anon_sym_globallycoherent] = ACTIONS(2232),
    [anon_sym_centroid] = ACTIONS(2232),
    [anon_sym_noperspective] = ACTIONS(2232),
    [anon_sym_nointerpolation] = ACTIONS(2232),
    [anon_sym_sample] = ACTIONS(2232),
    [anon_sym_linear] = ACTIONS(2232),
    [anon_sym_snorm] = ACTIONS(2232),
    [anon_sym_unorm] = ACTIONS(2232),
    [anon_sym_point] = ACTIONS(2232),
    [anon_sym_line] = ACTIONS(2232),
    [anon_sym_triangleadj] = ACTIONS(2232),
    [anon_sym_lineadj] = ACTIONS(2232),
    [anon_sym_triangle] = ACTIONS(2232),
  },
  [1435] = {
    [sym_identifier] = ACTIONS(2194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2196),
    [anon_sym_COMMA] = ACTIONS(2196),
    [anon_sym_RPAREN] = ACTIONS(2196),
    [anon_sym_LPAREN2] = ACTIONS(2196),
    [anon_sym_TILDE] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2194),
    [anon_sym_PLUS] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(2196),
    [anon_sym_SLASH] = ACTIONS(2194),
    [anon_sym_PERCENT] = ACTIONS(2196),
    [anon_sym_PIPE_PIPE] = ACTIONS(2196),
    [anon_sym_AMP_AMP] = ACTIONS(2196),
    [anon_sym_PIPE] = ACTIONS(2194),
    [anon_sym_CARET] = ACTIONS(2196),
    [anon_sym_AMP] = ACTIONS(2194),
    [anon_sym_EQ_EQ] = ACTIONS(2196),
    [anon_sym_BANG_EQ] = ACTIONS(2196),
    [anon_sym_GT] = ACTIONS(2194),
    [anon_sym_GT_EQ] = ACTIONS(2196),
    [anon_sym_LT_EQ] = ACTIONS(2194),
    [anon_sym_LT] = ACTIONS(2194),
    [anon_sym_LT_LT] = ACTIONS(2196),
    [anon_sym_GT_GT] = ACTIONS(2196),
    [anon_sym_COLON] = ACTIONS(2194),
    [anon_sym_SEMI] = ACTIONS(2196),
    [anon_sym___extension__] = ACTIONS(2194),
    [anon_sym_in] = ACTIONS(2194),
    [anon_sym_out] = ACTIONS(2194),
    [anon_sym_inout] = ACTIONS(2194),
    [anon_sym_extern] = ACTIONS(2194),
    [anon_sym___attribute__] = ACTIONS(2194),
    [anon_sym_COLON_COLON] = ACTIONS(2196),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2196),
    [anon_sym___declspec] = ACTIONS(2194),
    [anon_sym___based] = ACTIONS(2194),
    [anon_sym___cdecl] = ACTIONS(2194),
    [anon_sym___clrcall] = ACTIONS(2194),
    [anon_sym___stdcall] = ACTIONS(2194),
    [anon_sym___fastcall] = ACTIONS(2194),
    [anon_sym___thiscall] = ACTIONS(2194),
    [anon_sym___vectorcall] = ACTIONS(2194),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_RBRACE] = ACTIONS(2196),
    [anon_sym_LBRACK] = ACTIONS(2194),
    [anon_sym_static] = ACTIONS(2194),
    [anon_sym_register] = ACTIONS(2194),
    [anon_sym_inline] = ACTIONS(2194),
    [anon_sym___inline] = ACTIONS(2194),
    [anon_sym___inline__] = ACTIONS(2194),
    [anon_sym___forceinline] = ACTIONS(2194),
    [anon_sym_thread_local] = ACTIONS(2194),
    [anon_sym___thread] = ACTIONS(2194),
    [anon_sym_const] = ACTIONS(2194),
    [anon_sym_constexpr] = ACTIONS(2194),
    [anon_sym_volatile] = ACTIONS(2194),
    [anon_sym_restrict] = ACTIONS(2194),
    [anon_sym___restrict__] = ACTIONS(2194),
    [anon_sym__Atomic] = ACTIONS(2194),
    [anon_sym__Noreturn] = ACTIONS(2194),
    [anon_sym_noreturn] = ACTIONS(2194),
    [anon_sym_mutable] = ACTIONS(2194),
    [anon_sym_constinit] = ACTIONS(2194),
    [anon_sym_consteval] = ACTIONS(2194),
    [anon_sym_alignas] = ACTIONS(2194),
    [anon_sym__Alignas] = ACTIONS(2194),
    [anon_sym_QMARK] = ACTIONS(2196),
    [anon_sym_LT_EQ_GT] = ACTIONS(2196),
    [anon_sym_or] = ACTIONS(2194),
    [anon_sym_and] = ACTIONS(2194),
    [anon_sym_bitor] = ACTIONS(2194),
    [anon_sym_xor] = ACTIONS(2194),
    [anon_sym_bitand] = ACTIONS(2194),
    [anon_sym_not_eq] = ACTIONS(2194),
    [anon_sym_is] = ACTIONS(2194),
    [anon_sym_as] = ACTIONS(2194),
    [anon_sym_DASH_DASH] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2196),
    [anon_sym_DOT] = ACTIONS(2194),
    [anon_sym_DOT_STAR] = ACTIONS(2196),
    [anon_sym_DASH_GT] = ACTIONS(2196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2194),
    [anon_sym_let] = ACTIONS(2194),
    [anon_sym_This] = ACTIONS(2194),
    [anon_sym_decltype] = ACTIONS(2194),
    [anon_sym_final] = ACTIONS(2194),
    [anon_sym_override] = ACTIONS(2194),
    [sym_virtual] = ACTIONS(2194),
    [anon_sym_template] = ACTIONS(2194),
    [anon_sym_operator] = ACTIONS(2194),
    [anon_sym_precise] = ACTIONS(2194),
    [anon_sym_shared] = ACTIONS(2194),
    [anon_sym_groupshared] = ACTIONS(2194),
    [anon_sym_uniform] = ACTIONS(2194),
    [anon_sym_row_major] = ACTIONS(2194),
    [anon_sym_column_major] = ACTIONS(2194),
    [anon_sym_globallycoherent] = ACTIONS(2194),
    [anon_sym_centroid] = ACTIONS(2194),
    [anon_sym_noperspective] = ACTIONS(2194),
    [anon_sym_nointerpolation] = ACTIONS(2194),
    [anon_sym_sample] = ACTIONS(2194),
    [anon_sym_linear] = ACTIONS(2194),
    [anon_sym_snorm] = ACTIONS(2194),
    [anon_sym_unorm] = ACTIONS(2194),
    [anon_sym_point] = ACTIONS(2194),
    [anon_sym_line] = ACTIONS(2194),
    [anon_sym_triangleadj] = ACTIONS(2194),
    [anon_sym_lineadj] = ACTIONS(2194),
    [anon_sym_triangle] = ACTIONS(2194),
  },
  [1436] = {
    [sym_identifier] = ACTIONS(2206),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2208),
    [anon_sym_COMMA] = ACTIONS(2208),
    [anon_sym_RPAREN] = ACTIONS(2208),
    [anon_sym_LPAREN2] = ACTIONS(2208),
    [anon_sym_TILDE] = ACTIONS(2208),
    [anon_sym_DASH] = ACTIONS(2206),
    [anon_sym_PLUS] = ACTIONS(2206),
    [anon_sym_STAR] = ACTIONS(2208),
    [anon_sym_SLASH] = ACTIONS(2206),
    [anon_sym_PERCENT] = ACTIONS(2208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2208),
    [anon_sym_AMP_AMP] = ACTIONS(2208),
    [anon_sym_PIPE] = ACTIONS(2206),
    [anon_sym_CARET] = ACTIONS(2208),
    [anon_sym_AMP] = ACTIONS(2206),
    [anon_sym_EQ_EQ] = ACTIONS(2208),
    [anon_sym_BANG_EQ] = ACTIONS(2208),
    [anon_sym_GT] = ACTIONS(2206),
    [anon_sym_GT_EQ] = ACTIONS(2208),
    [anon_sym_LT_EQ] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2206),
    [anon_sym_LT_LT] = ACTIONS(2208),
    [anon_sym_GT_GT] = ACTIONS(2208),
    [anon_sym_COLON] = ACTIONS(2206),
    [anon_sym_SEMI] = ACTIONS(2208),
    [anon_sym___extension__] = ACTIONS(2206),
    [anon_sym_in] = ACTIONS(2206),
    [anon_sym_out] = ACTIONS(2206),
    [anon_sym_inout] = ACTIONS(2206),
    [anon_sym_extern] = ACTIONS(2206),
    [anon_sym___attribute__] = ACTIONS(2206),
    [anon_sym_COLON_COLON] = ACTIONS(2208),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2208),
    [anon_sym___declspec] = ACTIONS(2206),
    [anon_sym___based] = ACTIONS(2206),
    [anon_sym___cdecl] = ACTIONS(2206),
    [anon_sym___clrcall] = ACTIONS(2206),
    [anon_sym___stdcall] = ACTIONS(2206),
    [anon_sym___fastcall] = ACTIONS(2206),
    [anon_sym___thiscall] = ACTIONS(2206),
    [anon_sym___vectorcall] = ACTIONS(2206),
    [anon_sym_LBRACE] = ACTIONS(2208),
    [anon_sym_RBRACE] = ACTIONS(2208),
    [anon_sym_LBRACK] = ACTIONS(2206),
    [anon_sym_static] = ACTIONS(2206),
    [anon_sym_register] = ACTIONS(2206),
    [anon_sym_inline] = ACTIONS(2206),
    [anon_sym___inline] = ACTIONS(2206),
    [anon_sym___inline__] = ACTIONS(2206),
    [anon_sym___forceinline] = ACTIONS(2206),
    [anon_sym_thread_local] = ACTIONS(2206),
    [anon_sym___thread] = ACTIONS(2206),
    [anon_sym_const] = ACTIONS(2206),
    [anon_sym_constexpr] = ACTIONS(2206),
    [anon_sym_volatile] = ACTIONS(2206),
    [anon_sym_restrict] = ACTIONS(2206),
    [anon_sym___restrict__] = ACTIONS(2206),
    [anon_sym__Atomic] = ACTIONS(2206),
    [anon_sym__Noreturn] = ACTIONS(2206),
    [anon_sym_noreturn] = ACTIONS(2206),
    [anon_sym_mutable] = ACTIONS(2206),
    [anon_sym_constinit] = ACTIONS(2206),
    [anon_sym_consteval] = ACTIONS(2206),
    [anon_sym_alignas] = ACTIONS(2206),
    [anon_sym__Alignas] = ACTIONS(2206),
    [anon_sym_QMARK] = ACTIONS(2208),
    [anon_sym_LT_EQ_GT] = ACTIONS(2208),
    [anon_sym_or] = ACTIONS(2206),
    [anon_sym_and] = ACTIONS(2206),
    [anon_sym_bitor] = ACTIONS(2206),
    [anon_sym_xor] = ACTIONS(2206),
    [anon_sym_bitand] = ACTIONS(2206),
    [anon_sym_not_eq] = ACTIONS(2206),
    [anon_sym_is] = ACTIONS(2206),
    [anon_sym_as] = ACTIONS(2206),
    [anon_sym_DASH_DASH] = ACTIONS(2208),
    [anon_sym_PLUS_PLUS] = ACTIONS(2208),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_DOT_STAR] = ACTIONS(2208),
    [anon_sym_DASH_GT] = ACTIONS(2208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2206),
    [anon_sym_let] = ACTIONS(2206),
    [anon_sym_This] = ACTIONS(2206),
    [anon_sym_decltype] = ACTIONS(2206),
    [anon_sym_final] = ACTIONS(2206),
    [anon_sym_override] = ACTIONS(2206),
    [sym_virtual] = ACTIONS(2206),
    [anon_sym_template] = ACTIONS(2206),
    [anon_sym_operator] = ACTIONS(2206),
    [anon_sym_precise] = ACTIONS(2206),
    [anon_sym_shared] = ACTIONS(2206),
    [anon_sym_groupshared] = ACTIONS(2206),
    [anon_sym_uniform] = ACTIONS(2206),
    [anon_sym_row_major] = ACTIONS(2206),
    [anon_sym_column_major] = ACTIONS(2206),
    [anon_sym_globallycoherent] = ACTIONS(2206),
    [anon_sym_centroid] = ACTIONS(2206),
    [anon_sym_noperspective] = ACTIONS(2206),
    [anon_sym_nointerpolation] = ACTIONS(2206),
    [anon_sym_sample] = ACTIONS(2206),
    [anon_sym_linear] = ACTIONS(2206),
    [anon_sym_snorm] = ACTIONS(2206),
    [anon_sym_unorm] = ACTIONS(2206),
    [anon_sym_point] = ACTIONS(2206),
    [anon_sym_line] = ACTIONS(2206),
    [anon_sym_triangleadj] = ACTIONS(2206),
    [anon_sym_lineadj] = ACTIONS(2206),
    [anon_sym_triangle] = ACTIONS(2206),
  },
  [1437] = {
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2230),
    [anon_sym_COMMA] = ACTIONS(2230),
    [anon_sym_RPAREN] = ACTIONS(2230),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_TILDE] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2228),
    [anon_sym_PLUS] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(2230),
    [anon_sym_SLASH] = ACTIONS(2228),
    [anon_sym_PERCENT] = ACTIONS(2230),
    [anon_sym_PIPE_PIPE] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_PIPE] = ACTIONS(2228),
    [anon_sym_CARET] = ACTIONS(2230),
    [anon_sym_AMP] = ACTIONS(2228),
    [anon_sym_EQ_EQ] = ACTIONS(2230),
    [anon_sym_BANG_EQ] = ACTIONS(2230),
    [anon_sym_GT] = ACTIONS(2228),
    [anon_sym_GT_EQ] = ACTIONS(2230),
    [anon_sym_LT_EQ] = ACTIONS(2228),
    [anon_sym_LT] = ACTIONS(2228),
    [anon_sym_LT_LT] = ACTIONS(2230),
    [anon_sym_GT_GT] = ACTIONS(2230),
    [anon_sym_COLON] = ACTIONS(2228),
    [anon_sym_SEMI] = ACTIONS(2230),
    [anon_sym___extension__] = ACTIONS(2228),
    [anon_sym_in] = ACTIONS(2228),
    [anon_sym_out] = ACTIONS(2228),
    [anon_sym_inout] = ACTIONS(2228),
    [anon_sym_extern] = ACTIONS(2228),
    [anon_sym___attribute__] = ACTIONS(2228),
    [anon_sym_COLON_COLON] = ACTIONS(2230),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2230),
    [anon_sym___declspec] = ACTIONS(2228),
    [anon_sym___based] = ACTIONS(2228),
    [anon_sym___cdecl] = ACTIONS(2228),
    [anon_sym___clrcall] = ACTIONS(2228),
    [anon_sym___stdcall] = ACTIONS(2228),
    [anon_sym___fastcall] = ACTIONS(2228),
    [anon_sym___thiscall] = ACTIONS(2228),
    [anon_sym___vectorcall] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_RBRACE] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2228),
    [anon_sym_static] = ACTIONS(2228),
    [anon_sym_register] = ACTIONS(2228),
    [anon_sym_inline] = ACTIONS(2228),
    [anon_sym___inline] = ACTIONS(2228),
    [anon_sym___inline__] = ACTIONS(2228),
    [anon_sym___forceinline] = ACTIONS(2228),
    [anon_sym_thread_local] = ACTIONS(2228),
    [anon_sym___thread] = ACTIONS(2228),
    [anon_sym_const] = ACTIONS(2228),
    [anon_sym_constexpr] = ACTIONS(2228),
    [anon_sym_volatile] = ACTIONS(2228),
    [anon_sym_restrict] = ACTIONS(2228),
    [anon_sym___restrict__] = ACTIONS(2228),
    [anon_sym__Atomic] = ACTIONS(2228),
    [anon_sym__Noreturn] = ACTIONS(2228),
    [anon_sym_noreturn] = ACTIONS(2228),
    [anon_sym_mutable] = ACTIONS(2228),
    [anon_sym_constinit] = ACTIONS(2228),
    [anon_sym_consteval] = ACTIONS(2228),
    [anon_sym_alignas] = ACTIONS(2228),
    [anon_sym__Alignas] = ACTIONS(2228),
    [anon_sym_QMARK] = ACTIONS(2230),
    [anon_sym_LT_EQ_GT] = ACTIONS(2230),
    [anon_sym_or] = ACTIONS(2228),
    [anon_sym_and] = ACTIONS(2228),
    [anon_sym_bitor] = ACTIONS(2228),
    [anon_sym_xor] = ACTIONS(2228),
    [anon_sym_bitand] = ACTIONS(2228),
    [anon_sym_not_eq] = ACTIONS(2228),
    [anon_sym_is] = ACTIONS(2228),
    [anon_sym_as] = ACTIONS(2228),
    [anon_sym_DASH_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_PLUS] = ACTIONS(2230),
    [anon_sym_DOT] = ACTIONS(2228),
    [anon_sym_DOT_STAR] = ACTIONS(2230),
    [anon_sym_DASH_GT] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(2228),
    [anon_sym_This] = ACTIONS(2228),
    [anon_sym_decltype] = ACTIONS(2228),
    [anon_sym_final] = ACTIONS(2228),
    [anon_sym_override] = ACTIONS(2228),
    [sym_virtual] = ACTIONS(2228),
    [anon_sym_template] = ACTIONS(2228),
    [anon_sym_operator] = ACTIONS(2228),
    [anon_sym_precise] = ACTIONS(2228),
    [anon_sym_shared] = ACTIONS(2228),
    [anon_sym_groupshared] = ACTIONS(2228),
    [anon_sym_uniform] = ACTIONS(2228),
    [anon_sym_row_major] = ACTIONS(2228),
    [anon_sym_column_major] = ACTIONS(2228),
    [anon_sym_globallycoherent] = ACTIONS(2228),
    [anon_sym_centroid] = ACTIONS(2228),
    [anon_sym_noperspective] = ACTIONS(2228),
    [anon_sym_nointerpolation] = ACTIONS(2228),
    [anon_sym_sample] = ACTIONS(2228),
    [anon_sym_linear] = ACTIONS(2228),
    [anon_sym_snorm] = ACTIONS(2228),
    [anon_sym_unorm] = ACTIONS(2228),
    [anon_sym_point] = ACTIONS(2228),
    [anon_sym_line] = ACTIONS(2228),
    [anon_sym_triangleadj] = ACTIONS(2228),
    [anon_sym_lineadj] = ACTIONS(2228),
    [anon_sym_triangle] = ACTIONS(2228),
  },
  [1438] = {
    [sym_identifier] = ACTIONS(2244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(2246),
    [anon_sym_RPAREN] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2244),
    [anon_sym_PLUS] = ACTIONS(2244),
    [anon_sym_STAR] = ACTIONS(2246),
    [anon_sym_SLASH] = ACTIONS(2244),
    [anon_sym_PERCENT] = ACTIONS(2246),
    [anon_sym_PIPE_PIPE] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2244),
    [anon_sym_CARET] = ACTIONS(2246),
    [anon_sym_AMP] = ACTIONS(2244),
    [anon_sym_EQ_EQ] = ACTIONS(2246),
    [anon_sym_BANG_EQ] = ACTIONS(2246),
    [anon_sym_GT] = ACTIONS(2244),
    [anon_sym_GT_EQ] = ACTIONS(2246),
    [anon_sym_LT_EQ] = ACTIONS(2244),
    [anon_sym_LT] = ACTIONS(2244),
    [anon_sym_LT_LT] = ACTIONS(2246),
    [anon_sym_GT_GT] = ACTIONS(2246),
    [anon_sym_COLON] = ACTIONS(2244),
    [anon_sym_SEMI] = ACTIONS(2246),
    [anon_sym___extension__] = ACTIONS(2244),
    [anon_sym_in] = ACTIONS(2244),
    [anon_sym_out] = ACTIONS(2244),
    [anon_sym_inout] = ACTIONS(2244),
    [anon_sym_extern] = ACTIONS(2244),
    [anon_sym___attribute__] = ACTIONS(2244),
    [anon_sym_COLON_COLON] = ACTIONS(2246),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2246),
    [anon_sym___declspec] = ACTIONS(2244),
    [anon_sym___based] = ACTIONS(2244),
    [anon_sym___cdecl] = ACTIONS(2244),
    [anon_sym___clrcall] = ACTIONS(2244),
    [anon_sym___stdcall] = ACTIONS(2244),
    [anon_sym___fastcall] = ACTIONS(2244),
    [anon_sym___thiscall] = ACTIONS(2244),
    [anon_sym___vectorcall] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_RBRACE] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2244),
    [anon_sym_static] = ACTIONS(2244),
    [anon_sym_register] = ACTIONS(2244),
    [anon_sym_inline] = ACTIONS(2244),
    [anon_sym___inline] = ACTIONS(2244),
    [anon_sym___inline__] = ACTIONS(2244),
    [anon_sym___forceinline] = ACTIONS(2244),
    [anon_sym_thread_local] = ACTIONS(2244),
    [anon_sym___thread] = ACTIONS(2244),
    [anon_sym_const] = ACTIONS(2244),
    [anon_sym_constexpr] = ACTIONS(2244),
    [anon_sym_volatile] = ACTIONS(2244),
    [anon_sym_restrict] = ACTIONS(2244),
    [anon_sym___restrict__] = ACTIONS(2244),
    [anon_sym__Atomic] = ACTIONS(2244),
    [anon_sym__Noreturn] = ACTIONS(2244),
    [anon_sym_noreturn] = ACTIONS(2244),
    [anon_sym_mutable] = ACTIONS(2244),
    [anon_sym_constinit] = ACTIONS(2244),
    [anon_sym_consteval] = ACTIONS(2244),
    [anon_sym_alignas] = ACTIONS(2244),
    [anon_sym__Alignas] = ACTIONS(2244),
    [anon_sym_QMARK] = ACTIONS(2246),
    [anon_sym_LT_EQ_GT] = ACTIONS(2246),
    [anon_sym_or] = ACTIONS(2244),
    [anon_sym_and] = ACTIONS(2244),
    [anon_sym_bitor] = ACTIONS(2244),
    [anon_sym_xor] = ACTIONS(2244),
    [anon_sym_bitand] = ACTIONS(2244),
    [anon_sym_not_eq] = ACTIONS(2244),
    [anon_sym_is] = ACTIONS(2244),
    [anon_sym_as] = ACTIONS(2244),
    [anon_sym_DASH_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_PLUS] = ACTIONS(2246),
    [anon_sym_DOT] = ACTIONS(2244),
    [anon_sym_DOT_STAR] = ACTIONS(2246),
    [anon_sym_DASH_GT] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2244),
    [anon_sym_let] = ACTIONS(2244),
    [anon_sym_This] = ACTIONS(2244),
    [anon_sym_decltype] = ACTIONS(2244),
    [anon_sym_final] = ACTIONS(2244),
    [anon_sym_override] = ACTIONS(2244),
    [sym_virtual] = ACTIONS(2244),
    [anon_sym_template] = ACTIONS(2244),
    [anon_sym_operator] = ACTIONS(2244),
    [anon_sym_precise] = ACTIONS(2244),
    [anon_sym_shared] = ACTIONS(2244),
    [anon_sym_groupshared] = ACTIONS(2244),
    [anon_sym_uniform] = ACTIONS(2244),
    [anon_sym_row_major] = ACTIONS(2244),
    [anon_sym_column_major] = ACTIONS(2244),
    [anon_sym_globallycoherent] = ACTIONS(2244),
    [anon_sym_centroid] = ACTIONS(2244),
    [anon_sym_noperspective] = ACTIONS(2244),
    [anon_sym_nointerpolation] = ACTIONS(2244),
    [anon_sym_sample] = ACTIONS(2244),
    [anon_sym_linear] = ACTIONS(2244),
    [anon_sym_snorm] = ACTIONS(2244),
    [anon_sym_unorm] = ACTIONS(2244),
    [anon_sym_point] = ACTIONS(2244),
    [anon_sym_line] = ACTIONS(2244),
    [anon_sym_triangleadj] = ACTIONS(2244),
    [anon_sym_lineadj] = ACTIONS(2244),
    [anon_sym_triangle] = ACTIONS(2244),
  },
  [1439] = {
    [sym_identifier] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_LPAREN2] = ACTIONS(2188),
    [anon_sym_TILDE] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2186),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_STAR] = ACTIONS(2188),
    [anon_sym_SLASH] = ACTIONS(2186),
    [anon_sym_PERCENT] = ACTIONS(2188),
    [anon_sym_PIPE_PIPE] = ACTIONS(2188),
    [anon_sym_AMP_AMP] = ACTIONS(2188),
    [anon_sym_PIPE] = ACTIONS(2186),
    [anon_sym_CARET] = ACTIONS(2188),
    [anon_sym_AMP] = ACTIONS(2186),
    [anon_sym_EQ_EQ] = ACTIONS(2188),
    [anon_sym_BANG_EQ] = ACTIONS(2188),
    [anon_sym_GT] = ACTIONS(2186),
    [anon_sym_GT_EQ] = ACTIONS(2188),
    [anon_sym_LT_EQ] = ACTIONS(2186),
    [anon_sym_LT] = ACTIONS(2186),
    [anon_sym_LT_LT] = ACTIONS(2188),
    [anon_sym_GT_GT] = ACTIONS(2188),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym___extension__] = ACTIONS(2186),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_out] = ACTIONS(2186),
    [anon_sym_inout] = ACTIONS(2186),
    [anon_sym_extern] = ACTIONS(2186),
    [anon_sym___attribute__] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2188),
    [anon_sym___declspec] = ACTIONS(2186),
    [anon_sym___based] = ACTIONS(2186),
    [anon_sym___cdecl] = ACTIONS(2186),
    [anon_sym___clrcall] = ACTIONS(2186),
    [anon_sym___stdcall] = ACTIONS(2186),
    [anon_sym___fastcall] = ACTIONS(2186),
    [anon_sym___thiscall] = ACTIONS(2186),
    [anon_sym___vectorcall] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_RBRACE] = ACTIONS(2188),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_static] = ACTIONS(2186),
    [anon_sym_register] = ACTIONS(2186),
    [anon_sym_inline] = ACTIONS(2186),
    [anon_sym___inline] = ACTIONS(2186),
    [anon_sym___inline__] = ACTIONS(2186),
    [anon_sym___forceinline] = ACTIONS(2186),
    [anon_sym_thread_local] = ACTIONS(2186),
    [anon_sym___thread] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_constexpr] = ACTIONS(2186),
    [anon_sym_volatile] = ACTIONS(2186),
    [anon_sym_restrict] = ACTIONS(2186),
    [anon_sym___restrict__] = ACTIONS(2186),
    [anon_sym__Atomic] = ACTIONS(2186),
    [anon_sym__Noreturn] = ACTIONS(2186),
    [anon_sym_noreturn] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_constinit] = ACTIONS(2186),
    [anon_sym_consteval] = ACTIONS(2186),
    [anon_sym_alignas] = ACTIONS(2186),
    [anon_sym__Alignas] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_LT_EQ_GT] = ACTIONS(2188),
    [anon_sym_or] = ACTIONS(2186),
    [anon_sym_and] = ACTIONS(2186),
    [anon_sym_bitor] = ACTIONS(2186),
    [anon_sym_xor] = ACTIONS(2186),
    [anon_sym_bitand] = ACTIONS(2186),
    [anon_sym_not_eq] = ACTIONS(2186),
    [anon_sym_is] = ACTIONS(2186),
    [anon_sym_as] = ACTIONS(2186),
    [anon_sym_DASH_DASH] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2188),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOT_STAR] = ACTIONS(2188),
    [anon_sym_DASH_GT] = ACTIONS(2188),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_This] = ACTIONS(2186),
    [anon_sym_decltype] = ACTIONS(2186),
    [anon_sym_final] = ACTIONS(2186),
    [anon_sym_override] = ACTIONS(2186),
    [sym_virtual] = ACTIONS(2186),
    [anon_sym_template] = ACTIONS(2186),
    [anon_sym_operator] = ACTIONS(2186),
    [anon_sym_precise] = ACTIONS(2186),
    [anon_sym_shared] = ACTIONS(2186),
    [anon_sym_groupshared] = ACTIONS(2186),
    [anon_sym_uniform] = ACTIONS(2186),
    [anon_sym_row_major] = ACTIONS(2186),
    [anon_sym_column_major] = ACTIONS(2186),
    [anon_sym_globallycoherent] = ACTIONS(2186),
    [anon_sym_centroid] = ACTIONS(2186),
    [anon_sym_noperspective] = ACTIONS(2186),
    [anon_sym_nointerpolation] = ACTIONS(2186),
    [anon_sym_sample] = ACTIONS(2186),
    [anon_sym_linear] = ACTIONS(2186),
    [anon_sym_snorm] = ACTIONS(2186),
    [anon_sym_unorm] = ACTIONS(2186),
    [anon_sym_point] = ACTIONS(2186),
    [anon_sym_line] = ACTIONS(2186),
    [anon_sym_triangleadj] = ACTIONS(2186),
    [anon_sym_lineadj] = ACTIONS(2186),
    [anon_sym_triangle] = ACTIONS(2186),
  },
  [1440] = {
    [sym_identifier] = ACTIONS(2236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2238),
    [anon_sym_COMMA] = ACTIONS(2238),
    [anon_sym_RPAREN] = ACTIONS(2238),
    [anon_sym_LPAREN2] = ACTIONS(2238),
    [anon_sym_TILDE] = ACTIONS(2238),
    [anon_sym_DASH] = ACTIONS(2236),
    [anon_sym_PLUS] = ACTIONS(2236),
    [anon_sym_STAR] = ACTIONS(2238),
    [anon_sym_SLASH] = ACTIONS(2236),
    [anon_sym_PERCENT] = ACTIONS(2238),
    [anon_sym_PIPE_PIPE] = ACTIONS(2238),
    [anon_sym_AMP_AMP] = ACTIONS(2238),
    [anon_sym_PIPE] = ACTIONS(2236),
    [anon_sym_CARET] = ACTIONS(2238),
    [anon_sym_AMP] = ACTIONS(2236),
    [anon_sym_EQ_EQ] = ACTIONS(2238),
    [anon_sym_BANG_EQ] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2236),
    [anon_sym_GT_EQ] = ACTIONS(2238),
    [anon_sym_LT_EQ] = ACTIONS(2236),
    [anon_sym_LT] = ACTIONS(2236),
    [anon_sym_LT_LT] = ACTIONS(2238),
    [anon_sym_GT_GT] = ACTIONS(2238),
    [anon_sym_COLON] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(2238),
    [anon_sym___extension__] = ACTIONS(2236),
    [anon_sym_in] = ACTIONS(2236),
    [anon_sym_out] = ACTIONS(2236),
    [anon_sym_inout] = ACTIONS(2236),
    [anon_sym_extern] = ACTIONS(2236),
    [anon_sym___attribute__] = ACTIONS(2236),
    [anon_sym_COLON_COLON] = ACTIONS(2238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2238),
    [anon_sym___declspec] = ACTIONS(2236),
    [anon_sym___based] = ACTIONS(2236),
    [anon_sym___cdecl] = ACTIONS(2236),
    [anon_sym___clrcall] = ACTIONS(2236),
    [anon_sym___stdcall] = ACTIONS(2236),
    [anon_sym___fastcall] = ACTIONS(2236),
    [anon_sym___thiscall] = ACTIONS(2236),
    [anon_sym___vectorcall] = ACTIONS(2236),
    [anon_sym_LBRACE] = ACTIONS(2238),
    [anon_sym_RBRACE] = ACTIONS(2238),
    [anon_sym_LBRACK] = ACTIONS(2236),
    [anon_sym_static] = ACTIONS(2236),
    [anon_sym_register] = ACTIONS(2236),
    [anon_sym_inline] = ACTIONS(2236),
    [anon_sym___inline] = ACTIONS(2236),
    [anon_sym___inline__] = ACTIONS(2236),
    [anon_sym___forceinline] = ACTIONS(2236),
    [anon_sym_thread_local] = ACTIONS(2236),
    [anon_sym___thread] = ACTIONS(2236),
    [anon_sym_const] = ACTIONS(2236),
    [anon_sym_constexpr] = ACTIONS(2236),
    [anon_sym_volatile] = ACTIONS(2236),
    [anon_sym_restrict] = ACTIONS(2236),
    [anon_sym___restrict__] = ACTIONS(2236),
    [anon_sym__Atomic] = ACTIONS(2236),
    [anon_sym__Noreturn] = ACTIONS(2236),
    [anon_sym_noreturn] = ACTIONS(2236),
    [anon_sym_mutable] = ACTIONS(2236),
    [anon_sym_constinit] = ACTIONS(2236),
    [anon_sym_consteval] = ACTIONS(2236),
    [anon_sym_alignas] = ACTIONS(2236),
    [anon_sym__Alignas] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_LT_EQ_GT] = ACTIONS(2238),
    [anon_sym_or] = ACTIONS(2236),
    [anon_sym_and] = ACTIONS(2236),
    [anon_sym_bitor] = ACTIONS(2236),
    [anon_sym_xor] = ACTIONS(2236),
    [anon_sym_bitand] = ACTIONS(2236),
    [anon_sym_not_eq] = ACTIONS(2236),
    [anon_sym_is] = ACTIONS(2236),
    [anon_sym_as] = ACTIONS(2236),
    [anon_sym_DASH_DASH] = ACTIONS(2238),
    [anon_sym_PLUS_PLUS] = ACTIONS(2238),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_DOT_STAR] = ACTIONS(2238),
    [anon_sym_DASH_GT] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2236),
    [anon_sym_let] = ACTIONS(2236),
    [anon_sym_This] = ACTIONS(2236),
    [anon_sym_decltype] = ACTIONS(2236),
    [anon_sym_final] = ACTIONS(2236),
    [anon_sym_override] = ACTIONS(2236),
    [sym_virtual] = ACTIONS(2236),
    [anon_sym_template] = ACTIONS(2236),
    [anon_sym_operator] = ACTIONS(2236),
    [anon_sym_precise] = ACTIONS(2236),
    [anon_sym_shared] = ACTIONS(2236),
    [anon_sym_groupshared] = ACTIONS(2236),
    [anon_sym_uniform] = ACTIONS(2236),
    [anon_sym_row_major] = ACTIONS(2236),
    [anon_sym_column_major] = ACTIONS(2236),
    [anon_sym_globallycoherent] = ACTIONS(2236),
    [anon_sym_centroid] = ACTIONS(2236),
    [anon_sym_noperspective] = ACTIONS(2236),
    [anon_sym_nointerpolation] = ACTIONS(2236),
    [anon_sym_sample] = ACTIONS(2236),
    [anon_sym_linear] = ACTIONS(2236),
    [anon_sym_snorm] = ACTIONS(2236),
    [anon_sym_unorm] = ACTIONS(2236),
    [anon_sym_point] = ACTIONS(2236),
    [anon_sym_line] = ACTIONS(2236),
    [anon_sym_triangleadj] = ACTIONS(2236),
    [anon_sym_lineadj] = ACTIONS(2236),
    [anon_sym_triangle] = ACTIONS(2236),
  },
  [1441] = {
    [sym_identifier] = ACTIONS(2256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2258),
    [anon_sym_COMMA] = ACTIONS(2258),
    [anon_sym_RPAREN] = ACTIONS(2258),
    [anon_sym_LPAREN2] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [anon_sym_DASH] = ACTIONS(2256),
    [anon_sym_PLUS] = ACTIONS(2256),
    [anon_sym_STAR] = ACTIONS(2258),
    [anon_sym_SLASH] = ACTIONS(2256),
    [anon_sym_PERCENT] = ACTIONS(2258),
    [anon_sym_PIPE_PIPE] = ACTIONS(2258),
    [anon_sym_AMP_AMP] = ACTIONS(2258),
    [anon_sym_PIPE] = ACTIONS(2256),
    [anon_sym_CARET] = ACTIONS(2258),
    [anon_sym_AMP] = ACTIONS(2256),
    [anon_sym_EQ_EQ] = ACTIONS(2258),
    [anon_sym_BANG_EQ] = ACTIONS(2258),
    [anon_sym_GT] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2258),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_LT] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_COLON] = ACTIONS(2256),
    [anon_sym_SEMI] = ACTIONS(2258),
    [anon_sym___extension__] = ACTIONS(2256),
    [anon_sym_in] = ACTIONS(2256),
    [anon_sym_out] = ACTIONS(2256),
    [anon_sym_inout] = ACTIONS(2256),
    [anon_sym_extern] = ACTIONS(2256),
    [anon_sym___attribute__] = ACTIONS(2256),
    [anon_sym_COLON_COLON] = ACTIONS(2258),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2258),
    [anon_sym___declspec] = ACTIONS(2256),
    [anon_sym___based] = ACTIONS(2256),
    [anon_sym___cdecl] = ACTIONS(2256),
    [anon_sym___clrcall] = ACTIONS(2256),
    [anon_sym___stdcall] = ACTIONS(2256),
    [anon_sym___fastcall] = ACTIONS(2256),
    [anon_sym___thiscall] = ACTIONS(2256),
    [anon_sym___vectorcall] = ACTIONS(2256),
    [anon_sym_LBRACE] = ACTIONS(2258),
    [anon_sym_RBRACE] = ACTIONS(2258),
    [anon_sym_LBRACK] = ACTIONS(2256),
    [anon_sym_static] = ACTIONS(2256),
    [anon_sym_register] = ACTIONS(2256),
    [anon_sym_inline] = ACTIONS(2256),
    [anon_sym___inline] = ACTIONS(2256),
    [anon_sym___inline__] = ACTIONS(2256),
    [anon_sym___forceinline] = ACTIONS(2256),
    [anon_sym_thread_local] = ACTIONS(2256),
    [anon_sym___thread] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_constexpr] = ACTIONS(2256),
    [anon_sym_volatile] = ACTIONS(2256),
    [anon_sym_restrict] = ACTIONS(2256),
    [anon_sym___restrict__] = ACTIONS(2256),
    [anon_sym__Atomic] = ACTIONS(2256),
    [anon_sym__Noreturn] = ACTIONS(2256),
    [anon_sym_noreturn] = ACTIONS(2256),
    [anon_sym_mutable] = ACTIONS(2256),
    [anon_sym_constinit] = ACTIONS(2256),
    [anon_sym_consteval] = ACTIONS(2256),
    [anon_sym_alignas] = ACTIONS(2256),
    [anon_sym__Alignas] = ACTIONS(2256),
    [anon_sym_QMARK] = ACTIONS(2258),
    [anon_sym_LT_EQ_GT] = ACTIONS(2258),
    [anon_sym_or] = ACTIONS(2256),
    [anon_sym_and] = ACTIONS(2256),
    [anon_sym_bitor] = ACTIONS(2256),
    [anon_sym_xor] = ACTIONS(2256),
    [anon_sym_bitand] = ACTIONS(2256),
    [anon_sym_not_eq] = ACTIONS(2256),
    [anon_sym_is] = ACTIONS(2256),
    [anon_sym_as] = ACTIONS(2256),
    [anon_sym_DASH_DASH] = ACTIONS(2258),
    [anon_sym_PLUS_PLUS] = ACTIONS(2258),
    [anon_sym_DOT] = ACTIONS(2256),
    [anon_sym_DOT_STAR] = ACTIONS(2258),
    [anon_sym_DASH_GT] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_This] = ACTIONS(2256),
    [anon_sym_decltype] = ACTIONS(2256),
    [anon_sym_final] = ACTIONS(2256),
    [anon_sym_override] = ACTIONS(2256),
    [sym_virtual] = ACTIONS(2256),
    [anon_sym_template] = ACTIONS(2256),
    [anon_sym_operator] = ACTIONS(2256),
    [anon_sym_precise] = ACTIONS(2256),
    [anon_sym_shared] = ACTIONS(2256),
    [anon_sym_groupshared] = ACTIONS(2256),
    [anon_sym_uniform] = ACTIONS(2256),
    [anon_sym_row_major] = ACTIONS(2256),
    [anon_sym_column_major] = ACTIONS(2256),
    [anon_sym_globallycoherent] = ACTIONS(2256),
    [anon_sym_centroid] = ACTIONS(2256),
    [anon_sym_noperspective] = ACTIONS(2256),
    [anon_sym_nointerpolation] = ACTIONS(2256),
    [anon_sym_sample] = ACTIONS(2256),
    [anon_sym_linear] = ACTIONS(2256),
    [anon_sym_snorm] = ACTIONS(2256),
    [anon_sym_unorm] = ACTIONS(2256),
    [anon_sym_point] = ACTIONS(2256),
    [anon_sym_line] = ACTIONS(2256),
    [anon_sym_triangleadj] = ACTIONS(2256),
    [anon_sym_lineadj] = ACTIONS(2256),
    [anon_sym_triangle] = ACTIONS(2256),
  },
  [1442] = {
    [sym_identifier] = ACTIONS(2248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_RPAREN] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2248),
    [anon_sym_PLUS] = ACTIONS(2248),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_SLASH] = ACTIONS(2248),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2248),
    [anon_sym_EQ_EQ] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_GT] = ACTIONS(2248),
    [anon_sym_GT_EQ] = ACTIONS(2250),
    [anon_sym_LT_EQ] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_LT_LT] = ACTIONS(2250),
    [anon_sym_GT_GT] = ACTIONS(2250),
    [anon_sym_COLON] = ACTIONS(2248),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym___extension__] = ACTIONS(2248),
    [anon_sym_in] = ACTIONS(2248),
    [anon_sym_out] = ACTIONS(2248),
    [anon_sym_inout] = ACTIONS(2248),
    [anon_sym_extern] = ACTIONS(2248),
    [anon_sym___attribute__] = ACTIONS(2248),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2250),
    [anon_sym___declspec] = ACTIONS(2248),
    [anon_sym___based] = ACTIONS(2248),
    [anon_sym___cdecl] = ACTIONS(2248),
    [anon_sym___clrcall] = ACTIONS(2248),
    [anon_sym___stdcall] = ACTIONS(2248),
    [anon_sym___fastcall] = ACTIONS(2248),
    [anon_sym___thiscall] = ACTIONS(2248),
    [anon_sym___vectorcall] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2248),
    [anon_sym_static] = ACTIONS(2248),
    [anon_sym_register] = ACTIONS(2248),
    [anon_sym_inline] = ACTIONS(2248),
    [anon_sym___inline] = ACTIONS(2248),
    [anon_sym___inline__] = ACTIONS(2248),
    [anon_sym___forceinline] = ACTIONS(2248),
    [anon_sym_thread_local] = ACTIONS(2248),
    [anon_sym___thread] = ACTIONS(2248),
    [anon_sym_const] = ACTIONS(2248),
    [anon_sym_constexpr] = ACTIONS(2248),
    [anon_sym_volatile] = ACTIONS(2248),
    [anon_sym_restrict] = ACTIONS(2248),
    [anon_sym___restrict__] = ACTIONS(2248),
    [anon_sym__Atomic] = ACTIONS(2248),
    [anon_sym__Noreturn] = ACTIONS(2248),
    [anon_sym_noreturn] = ACTIONS(2248),
    [anon_sym_mutable] = ACTIONS(2248),
    [anon_sym_constinit] = ACTIONS(2248),
    [anon_sym_consteval] = ACTIONS(2248),
    [anon_sym_alignas] = ACTIONS(2248),
    [anon_sym__Alignas] = ACTIONS(2248),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_LT_EQ_GT] = ACTIONS(2250),
    [anon_sym_or] = ACTIONS(2248),
    [anon_sym_and] = ACTIONS(2248),
    [anon_sym_bitor] = ACTIONS(2248),
    [anon_sym_xor] = ACTIONS(2248),
    [anon_sym_bitand] = ACTIONS(2248),
    [anon_sym_not_eq] = ACTIONS(2248),
    [anon_sym_is] = ACTIONS(2248),
    [anon_sym_as] = ACTIONS(2248),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2248),
    [anon_sym_DOT_STAR] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2248),
    [anon_sym_let] = ACTIONS(2248),
    [anon_sym_This] = ACTIONS(2248),
    [anon_sym_decltype] = ACTIONS(2248),
    [anon_sym_final] = ACTIONS(2248),
    [anon_sym_override] = ACTIONS(2248),
    [sym_virtual] = ACTIONS(2248),
    [anon_sym_template] = ACTIONS(2248),
    [anon_sym_operator] = ACTIONS(2248),
    [anon_sym_precise] = ACTIONS(2248),
    [anon_sym_shared] = ACTIONS(2248),
    [anon_sym_groupshared] = ACTIONS(2248),
    [anon_sym_uniform] = ACTIONS(2248),
    [anon_sym_row_major] = ACTIONS(2248),
    [anon_sym_column_major] = ACTIONS(2248),
    [anon_sym_globallycoherent] = ACTIONS(2248),
    [anon_sym_centroid] = ACTIONS(2248),
    [anon_sym_noperspective] = ACTIONS(2248),
    [anon_sym_nointerpolation] = ACTIONS(2248),
    [anon_sym_sample] = ACTIONS(2248),
    [anon_sym_linear] = ACTIONS(2248),
    [anon_sym_snorm] = ACTIONS(2248),
    [anon_sym_unorm] = ACTIONS(2248),
    [anon_sym_point] = ACTIONS(2248),
    [anon_sym_line] = ACTIONS(2248),
    [anon_sym_triangleadj] = ACTIONS(2248),
    [anon_sym_lineadj] = ACTIONS(2248),
    [anon_sym_triangle] = ACTIONS(2248),
  },
  [1443] = {
    [sym_identifier] = ACTIONS(2190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2192),
    [anon_sym_COMMA] = ACTIONS(2192),
    [anon_sym_RPAREN] = ACTIONS(2192),
    [anon_sym_LPAREN2] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2190),
    [anon_sym_PLUS] = ACTIONS(2190),
    [anon_sym_STAR] = ACTIONS(2192),
    [anon_sym_SLASH] = ACTIONS(2190),
    [anon_sym_PERCENT] = ACTIONS(2192),
    [anon_sym_PIPE_PIPE] = ACTIONS(2192),
    [anon_sym_AMP_AMP] = ACTIONS(2192),
    [anon_sym_PIPE] = ACTIONS(2190),
    [anon_sym_CARET] = ACTIONS(2192),
    [anon_sym_AMP] = ACTIONS(2190),
    [anon_sym_EQ_EQ] = ACTIONS(2192),
    [anon_sym_BANG_EQ] = ACTIONS(2192),
    [anon_sym_GT] = ACTIONS(2190),
    [anon_sym_GT_EQ] = ACTIONS(2192),
    [anon_sym_LT_EQ] = ACTIONS(2190),
    [anon_sym_LT] = ACTIONS(2190),
    [anon_sym_LT_LT] = ACTIONS(2192),
    [anon_sym_GT_GT] = ACTIONS(2192),
    [anon_sym_COLON] = ACTIONS(2190),
    [anon_sym_SEMI] = ACTIONS(2192),
    [anon_sym___extension__] = ACTIONS(2190),
    [anon_sym_in] = ACTIONS(2190),
    [anon_sym_out] = ACTIONS(2190),
    [anon_sym_inout] = ACTIONS(2190),
    [anon_sym_extern] = ACTIONS(2190),
    [anon_sym___attribute__] = ACTIONS(2190),
    [anon_sym_COLON_COLON] = ACTIONS(2192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2192),
    [anon_sym___declspec] = ACTIONS(2190),
    [anon_sym___based] = ACTIONS(2190),
    [anon_sym___cdecl] = ACTIONS(2190),
    [anon_sym___clrcall] = ACTIONS(2190),
    [anon_sym___stdcall] = ACTIONS(2190),
    [anon_sym___fastcall] = ACTIONS(2190),
    [anon_sym___thiscall] = ACTIONS(2190),
    [anon_sym___vectorcall] = ACTIONS(2190),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [anon_sym_RBRACE] = ACTIONS(2192),
    [anon_sym_LBRACK] = ACTIONS(2190),
    [anon_sym_static] = ACTIONS(2190),
    [anon_sym_register] = ACTIONS(2190),
    [anon_sym_inline] = ACTIONS(2190),
    [anon_sym___inline] = ACTIONS(2190),
    [anon_sym___inline__] = ACTIONS(2190),
    [anon_sym___forceinline] = ACTIONS(2190),
    [anon_sym_thread_local] = ACTIONS(2190),
    [anon_sym___thread] = ACTIONS(2190),
    [anon_sym_const] = ACTIONS(2190),
    [anon_sym_constexpr] = ACTIONS(2190),
    [anon_sym_volatile] = ACTIONS(2190),
    [anon_sym_restrict] = ACTIONS(2190),
    [anon_sym___restrict__] = ACTIONS(2190),
    [anon_sym__Atomic] = ACTIONS(2190),
    [anon_sym__Noreturn] = ACTIONS(2190),
    [anon_sym_noreturn] = ACTIONS(2190),
    [anon_sym_mutable] = ACTIONS(2190),
    [anon_sym_constinit] = ACTIONS(2190),
    [anon_sym_consteval] = ACTIONS(2190),
    [anon_sym_alignas] = ACTIONS(2190),
    [anon_sym__Alignas] = ACTIONS(2190),
    [anon_sym_QMARK] = ACTIONS(2192),
    [anon_sym_LT_EQ_GT] = ACTIONS(2192),
    [anon_sym_or] = ACTIONS(2190),
    [anon_sym_and] = ACTIONS(2190),
    [anon_sym_bitor] = ACTIONS(2190),
    [anon_sym_xor] = ACTIONS(2190),
    [anon_sym_bitand] = ACTIONS(2190),
    [anon_sym_not_eq] = ACTIONS(2190),
    [anon_sym_is] = ACTIONS(2190),
    [anon_sym_as] = ACTIONS(2190),
    [anon_sym_DASH_DASH] = ACTIONS(2192),
    [anon_sym_PLUS_PLUS] = ACTIONS(2192),
    [anon_sym_DOT] = ACTIONS(2190),
    [anon_sym_DOT_STAR] = ACTIONS(2192),
    [anon_sym_DASH_GT] = ACTIONS(2192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2190),
    [anon_sym_let] = ACTIONS(2190),
    [anon_sym_This] = ACTIONS(2190),
    [anon_sym_decltype] = ACTIONS(2190),
    [anon_sym_final] = ACTIONS(2190),
    [anon_sym_override] = ACTIONS(2190),
    [sym_virtual] = ACTIONS(2190),
    [anon_sym_template] = ACTIONS(2190),
    [anon_sym_operator] = ACTIONS(2190),
    [anon_sym_precise] = ACTIONS(2190),
    [anon_sym_shared] = ACTIONS(2190),
    [anon_sym_groupshared] = ACTIONS(2190),
    [anon_sym_uniform] = ACTIONS(2190),
    [anon_sym_row_major] = ACTIONS(2190),
    [anon_sym_column_major] = ACTIONS(2190),
    [anon_sym_globallycoherent] = ACTIONS(2190),
    [anon_sym_centroid] = ACTIONS(2190),
    [anon_sym_noperspective] = ACTIONS(2190),
    [anon_sym_nointerpolation] = ACTIONS(2190),
    [anon_sym_sample] = ACTIONS(2190),
    [anon_sym_linear] = ACTIONS(2190),
    [anon_sym_snorm] = ACTIONS(2190),
    [anon_sym_unorm] = ACTIONS(2190),
    [anon_sym_point] = ACTIONS(2190),
    [anon_sym_line] = ACTIONS(2190),
    [anon_sym_triangleadj] = ACTIONS(2190),
    [anon_sym_lineadj] = ACTIONS(2190),
    [anon_sym_triangle] = ACTIONS(2190),
  },
  [1444] = {
    [sym_identifier] = ACTIONS(2224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2226),
    [anon_sym_COMMA] = ACTIONS(2226),
    [anon_sym_RPAREN] = ACTIONS(2226),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_TILDE] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_PLUS] = ACTIONS(2224),
    [anon_sym_STAR] = ACTIONS(2226),
    [anon_sym_SLASH] = ACTIONS(2224),
    [anon_sym_PERCENT] = ACTIONS(2226),
    [anon_sym_PIPE_PIPE] = ACTIONS(2226),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_PIPE] = ACTIONS(2224),
    [anon_sym_CARET] = ACTIONS(2226),
    [anon_sym_AMP] = ACTIONS(2224),
    [anon_sym_EQ_EQ] = ACTIONS(2226),
    [anon_sym_BANG_EQ] = ACTIONS(2226),
    [anon_sym_GT] = ACTIONS(2224),
    [anon_sym_GT_EQ] = ACTIONS(2226),
    [anon_sym_LT_EQ] = ACTIONS(2224),
    [anon_sym_LT] = ACTIONS(2224),
    [anon_sym_LT_LT] = ACTIONS(2226),
    [anon_sym_GT_GT] = ACTIONS(2226),
    [anon_sym_COLON] = ACTIONS(2224),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym___extension__] = ACTIONS(2224),
    [anon_sym_in] = ACTIONS(2224),
    [anon_sym_out] = ACTIONS(2224),
    [anon_sym_inout] = ACTIONS(2224),
    [anon_sym_extern] = ACTIONS(2224),
    [anon_sym___attribute__] = ACTIONS(2224),
    [anon_sym_COLON_COLON] = ACTIONS(2226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2226),
    [anon_sym___declspec] = ACTIONS(2224),
    [anon_sym___based] = ACTIONS(2224),
    [anon_sym___cdecl] = ACTIONS(2224),
    [anon_sym___clrcall] = ACTIONS(2224),
    [anon_sym___stdcall] = ACTIONS(2224),
    [anon_sym___fastcall] = ACTIONS(2224),
    [anon_sym___thiscall] = ACTIONS(2224),
    [anon_sym___vectorcall] = ACTIONS(2224),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_RBRACE] = ACTIONS(2226),
    [anon_sym_LBRACK] = ACTIONS(2224),
    [anon_sym_static] = ACTIONS(2224),
    [anon_sym_register] = ACTIONS(2224),
    [anon_sym_inline] = ACTIONS(2224),
    [anon_sym___inline] = ACTIONS(2224),
    [anon_sym___inline__] = ACTIONS(2224),
    [anon_sym___forceinline] = ACTIONS(2224),
    [anon_sym_thread_local] = ACTIONS(2224),
    [anon_sym___thread] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_constexpr] = ACTIONS(2224),
    [anon_sym_volatile] = ACTIONS(2224),
    [anon_sym_restrict] = ACTIONS(2224),
    [anon_sym___restrict__] = ACTIONS(2224),
    [anon_sym__Atomic] = ACTIONS(2224),
    [anon_sym__Noreturn] = ACTIONS(2224),
    [anon_sym_noreturn] = ACTIONS(2224),
    [anon_sym_mutable] = ACTIONS(2224),
    [anon_sym_constinit] = ACTIONS(2224),
    [anon_sym_consteval] = ACTIONS(2224),
    [anon_sym_alignas] = ACTIONS(2224),
    [anon_sym__Alignas] = ACTIONS(2224),
    [anon_sym_QMARK] = ACTIONS(2226),
    [anon_sym_LT_EQ_GT] = ACTIONS(2226),
    [anon_sym_or] = ACTIONS(2224),
    [anon_sym_and] = ACTIONS(2224),
    [anon_sym_bitor] = ACTIONS(2224),
    [anon_sym_xor] = ACTIONS(2224),
    [anon_sym_bitand] = ACTIONS(2224),
    [anon_sym_not_eq] = ACTIONS(2224),
    [anon_sym_is] = ACTIONS(2224),
    [anon_sym_as] = ACTIONS(2224),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_DOT] = ACTIONS(2224),
    [anon_sym_DOT_STAR] = ACTIONS(2226),
    [anon_sym_DASH_GT] = ACTIONS(2226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2224),
    [anon_sym_let] = ACTIONS(2224),
    [anon_sym_This] = ACTIONS(2224),
    [anon_sym_decltype] = ACTIONS(2224),
    [anon_sym_final] = ACTIONS(2224),
    [anon_sym_override] = ACTIONS(2224),
    [sym_virtual] = ACTIONS(2224),
    [anon_sym_template] = ACTIONS(2224),
    [anon_sym_operator] = ACTIONS(2224),
    [anon_sym_precise] = ACTIONS(2224),
    [anon_sym_shared] = ACTIONS(2224),
    [anon_sym_groupshared] = ACTIONS(2224),
    [anon_sym_uniform] = ACTIONS(2224),
    [anon_sym_row_major] = ACTIONS(2224),
    [anon_sym_column_major] = ACTIONS(2224),
    [anon_sym_globallycoherent] = ACTIONS(2224),
    [anon_sym_centroid] = ACTIONS(2224),
    [anon_sym_noperspective] = ACTIONS(2224),
    [anon_sym_nointerpolation] = ACTIONS(2224),
    [anon_sym_sample] = ACTIONS(2224),
    [anon_sym_linear] = ACTIONS(2224),
    [anon_sym_snorm] = ACTIONS(2224),
    [anon_sym_unorm] = ACTIONS(2224),
    [anon_sym_point] = ACTIONS(2224),
    [anon_sym_line] = ACTIONS(2224),
    [anon_sym_triangleadj] = ACTIONS(2224),
    [anon_sym_lineadj] = ACTIONS(2224),
    [anon_sym_triangle] = ACTIONS(2224),
  },
  [1445] = {
    [sym_identifier] = ACTIONS(2202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_RPAREN] = ACTIONS(2204),
    [anon_sym_LPAREN2] = ACTIONS(2204),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2202),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_STAR] = ACTIONS(2204),
    [anon_sym_SLASH] = ACTIONS(2202),
    [anon_sym_PERCENT] = ACTIONS(2204),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2202),
    [anon_sym_CARET] = ACTIONS(2204),
    [anon_sym_AMP] = ACTIONS(2202),
    [anon_sym_EQ_EQ] = ACTIONS(2204),
    [anon_sym_BANG_EQ] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(2202),
    [anon_sym_GT_EQ] = ACTIONS(2204),
    [anon_sym_LT_EQ] = ACTIONS(2202),
    [anon_sym_LT] = ACTIONS(2202),
    [anon_sym_LT_LT] = ACTIONS(2204),
    [anon_sym_GT_GT] = ACTIONS(2204),
    [anon_sym_COLON] = ACTIONS(2202),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym___extension__] = ACTIONS(2202),
    [anon_sym_in] = ACTIONS(2202),
    [anon_sym_out] = ACTIONS(2202),
    [anon_sym_inout] = ACTIONS(2202),
    [anon_sym_extern] = ACTIONS(2202),
    [anon_sym___attribute__] = ACTIONS(2202),
    [anon_sym_COLON_COLON] = ACTIONS(2204),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2204),
    [anon_sym___declspec] = ACTIONS(2202),
    [anon_sym___based] = ACTIONS(2202),
    [anon_sym___cdecl] = ACTIONS(2202),
    [anon_sym___clrcall] = ACTIONS(2202),
    [anon_sym___stdcall] = ACTIONS(2202),
    [anon_sym___fastcall] = ACTIONS(2202),
    [anon_sym___thiscall] = ACTIONS(2202),
    [anon_sym___vectorcall] = ACTIONS(2202),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2202),
    [anon_sym_register] = ACTIONS(2202),
    [anon_sym_inline] = ACTIONS(2202),
    [anon_sym___inline] = ACTIONS(2202),
    [anon_sym___inline__] = ACTIONS(2202),
    [anon_sym___forceinline] = ACTIONS(2202),
    [anon_sym_thread_local] = ACTIONS(2202),
    [anon_sym___thread] = ACTIONS(2202),
    [anon_sym_const] = ACTIONS(2202),
    [anon_sym_constexpr] = ACTIONS(2202),
    [anon_sym_volatile] = ACTIONS(2202),
    [anon_sym_restrict] = ACTIONS(2202),
    [anon_sym___restrict__] = ACTIONS(2202),
    [anon_sym__Atomic] = ACTIONS(2202),
    [anon_sym__Noreturn] = ACTIONS(2202),
    [anon_sym_noreturn] = ACTIONS(2202),
    [anon_sym_mutable] = ACTIONS(2202),
    [anon_sym_constinit] = ACTIONS(2202),
    [anon_sym_consteval] = ACTIONS(2202),
    [anon_sym_alignas] = ACTIONS(2202),
    [anon_sym__Alignas] = ACTIONS(2202),
    [anon_sym_QMARK] = ACTIONS(2204),
    [anon_sym_LT_EQ_GT] = ACTIONS(2204),
    [anon_sym_or] = ACTIONS(2202),
    [anon_sym_and] = ACTIONS(2202),
    [anon_sym_bitor] = ACTIONS(2202),
    [anon_sym_xor] = ACTIONS(2202),
    [anon_sym_bitand] = ACTIONS(2202),
    [anon_sym_not_eq] = ACTIONS(2202),
    [anon_sym_is] = ACTIONS(2202),
    [anon_sym_as] = ACTIONS(2202),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(2202),
    [anon_sym_DOT_STAR] = ACTIONS(2204),
    [anon_sym_DASH_GT] = ACTIONS(2204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2202),
    [anon_sym_let] = ACTIONS(2202),
    [anon_sym_This] = ACTIONS(2202),
    [anon_sym_decltype] = ACTIONS(2202),
    [anon_sym_final] = ACTIONS(2202),
    [anon_sym_override] = ACTIONS(2202),
    [sym_virtual] = ACTIONS(2202),
    [anon_sym_template] = ACTIONS(2202),
    [anon_sym_operator] = ACTIONS(2202),
    [anon_sym_precise] = ACTIONS(2202),
    [anon_sym_shared] = ACTIONS(2202),
    [anon_sym_groupshared] = ACTIONS(2202),
    [anon_sym_uniform] = ACTIONS(2202),
    [anon_sym_row_major] = ACTIONS(2202),
    [anon_sym_column_major] = ACTIONS(2202),
    [anon_sym_globallycoherent] = ACTIONS(2202),
    [anon_sym_centroid] = ACTIONS(2202),
    [anon_sym_noperspective] = ACTIONS(2202),
    [anon_sym_nointerpolation] = ACTIONS(2202),
    [anon_sym_sample] = ACTIONS(2202),
    [anon_sym_linear] = ACTIONS(2202),
    [anon_sym_snorm] = ACTIONS(2202),
    [anon_sym_unorm] = ACTIONS(2202),
    [anon_sym_point] = ACTIONS(2202),
    [anon_sym_line] = ACTIONS(2202),
    [anon_sym_triangleadj] = ACTIONS(2202),
    [anon_sym_lineadj] = ACTIONS(2202),
    [anon_sym_triangle] = ACTIONS(2202),
  },
  [1446] = {
    [sym_identifier] = ACTIONS(2240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2242),
    [anon_sym_RPAREN] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_TILDE] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2240),
    [anon_sym_PLUS] = ACTIONS(2240),
    [anon_sym_STAR] = ACTIONS(2242),
    [anon_sym_SLASH] = ACTIONS(2240),
    [anon_sym_PERCENT] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_PIPE] = ACTIONS(2240),
    [anon_sym_CARET] = ACTIONS(2242),
    [anon_sym_AMP] = ACTIONS(2240),
    [anon_sym_EQ_EQ] = ACTIONS(2242),
    [anon_sym_BANG_EQ] = ACTIONS(2242),
    [anon_sym_GT] = ACTIONS(2240),
    [anon_sym_GT_EQ] = ACTIONS(2242),
    [anon_sym_LT_EQ] = ACTIONS(2240),
    [anon_sym_LT] = ACTIONS(2240),
    [anon_sym_LT_LT] = ACTIONS(2242),
    [anon_sym_GT_GT] = ACTIONS(2242),
    [anon_sym_COLON] = ACTIONS(2240),
    [anon_sym_SEMI] = ACTIONS(2242),
    [anon_sym___extension__] = ACTIONS(2240),
    [anon_sym_in] = ACTIONS(2240),
    [anon_sym_out] = ACTIONS(2240),
    [anon_sym_inout] = ACTIONS(2240),
    [anon_sym_extern] = ACTIONS(2240),
    [anon_sym___attribute__] = ACTIONS(2240),
    [anon_sym_COLON_COLON] = ACTIONS(2242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2242),
    [anon_sym___declspec] = ACTIONS(2240),
    [anon_sym___based] = ACTIONS(2240),
    [anon_sym___cdecl] = ACTIONS(2240),
    [anon_sym___clrcall] = ACTIONS(2240),
    [anon_sym___stdcall] = ACTIONS(2240),
    [anon_sym___fastcall] = ACTIONS(2240),
    [anon_sym___thiscall] = ACTIONS(2240),
    [anon_sym___vectorcall] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_RBRACE] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2240),
    [anon_sym_static] = ACTIONS(2240),
    [anon_sym_register] = ACTIONS(2240),
    [anon_sym_inline] = ACTIONS(2240),
    [anon_sym___inline] = ACTIONS(2240),
    [anon_sym___inline__] = ACTIONS(2240),
    [anon_sym___forceinline] = ACTIONS(2240),
    [anon_sym_thread_local] = ACTIONS(2240),
    [anon_sym___thread] = ACTIONS(2240),
    [anon_sym_const] = ACTIONS(2240),
    [anon_sym_constexpr] = ACTIONS(2240),
    [anon_sym_volatile] = ACTIONS(2240),
    [anon_sym_restrict] = ACTIONS(2240),
    [anon_sym___restrict__] = ACTIONS(2240),
    [anon_sym__Atomic] = ACTIONS(2240),
    [anon_sym__Noreturn] = ACTIONS(2240),
    [anon_sym_noreturn] = ACTIONS(2240),
    [anon_sym_mutable] = ACTIONS(2240),
    [anon_sym_constinit] = ACTIONS(2240),
    [anon_sym_consteval] = ACTIONS(2240),
    [anon_sym_alignas] = ACTIONS(2240),
    [anon_sym__Alignas] = ACTIONS(2240),
    [anon_sym_QMARK] = ACTIONS(2242),
    [anon_sym_LT_EQ_GT] = ACTIONS(2242),
    [anon_sym_or] = ACTIONS(2240),
    [anon_sym_and] = ACTIONS(2240),
    [anon_sym_bitor] = ACTIONS(2240),
    [anon_sym_xor] = ACTIONS(2240),
    [anon_sym_bitand] = ACTIONS(2240),
    [anon_sym_not_eq] = ACTIONS(2240),
    [anon_sym_is] = ACTIONS(2240),
    [anon_sym_as] = ACTIONS(2240),
    [anon_sym_DASH_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_PLUS] = ACTIONS(2242),
    [anon_sym_DOT] = ACTIONS(2240),
    [anon_sym_DOT_STAR] = ACTIONS(2242),
    [anon_sym_DASH_GT] = ACTIONS(2242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2240),
    [anon_sym_let] = ACTIONS(2240),
    [anon_sym_This] = ACTIONS(2240),
    [anon_sym_decltype] = ACTIONS(2240),
    [anon_sym_final] = ACTIONS(2240),
    [anon_sym_override] = ACTIONS(2240),
    [sym_virtual] = ACTIONS(2240),
    [anon_sym_template] = ACTIONS(2240),
    [anon_sym_operator] = ACTIONS(2240),
    [anon_sym_precise] = ACTIONS(2240),
    [anon_sym_shared] = ACTIONS(2240),
    [anon_sym_groupshared] = ACTIONS(2240),
    [anon_sym_uniform] = ACTIONS(2240),
    [anon_sym_row_major] = ACTIONS(2240),
    [anon_sym_column_major] = ACTIONS(2240),
    [anon_sym_globallycoherent] = ACTIONS(2240),
    [anon_sym_centroid] = ACTIONS(2240),
    [anon_sym_noperspective] = ACTIONS(2240),
    [anon_sym_nointerpolation] = ACTIONS(2240),
    [anon_sym_sample] = ACTIONS(2240),
    [anon_sym_linear] = ACTIONS(2240),
    [anon_sym_snorm] = ACTIONS(2240),
    [anon_sym_unorm] = ACTIONS(2240),
    [anon_sym_point] = ACTIONS(2240),
    [anon_sym_line] = ACTIONS(2240),
    [anon_sym_triangleadj] = ACTIONS(2240),
    [anon_sym_lineadj] = ACTIONS(2240),
    [anon_sym_triangle] = ACTIONS(2240),
  },
  [1447] = {
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2254),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_RPAREN] = ACTIONS(2254),
    [anon_sym_LPAREN2] = ACTIONS(2254),
    [anon_sym_TILDE] = ACTIONS(2254),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2254),
    [anon_sym_SLASH] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2254),
    [anon_sym_PIPE_PIPE] = ACTIONS(2254),
    [anon_sym_AMP_AMP] = ACTIONS(2254),
    [anon_sym_PIPE] = ACTIONS(2252),
    [anon_sym_CARET] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_EQ_EQ] = ACTIONS(2254),
    [anon_sym_BANG_EQ] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2252),
    [anon_sym_GT_EQ] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2252),
    [anon_sym_LT_LT] = ACTIONS(2254),
    [anon_sym_GT_GT] = ACTIONS(2254),
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym_SEMI] = ACTIONS(2254),
    [anon_sym___extension__] = ACTIONS(2252),
    [anon_sym_in] = ACTIONS(2252),
    [anon_sym_out] = ACTIONS(2252),
    [anon_sym_inout] = ACTIONS(2252),
    [anon_sym_extern] = ACTIONS(2252),
    [anon_sym___attribute__] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2254),
    [anon_sym___declspec] = ACTIONS(2252),
    [anon_sym___based] = ACTIONS(2252),
    [anon_sym___cdecl] = ACTIONS(2252),
    [anon_sym___clrcall] = ACTIONS(2252),
    [anon_sym___stdcall] = ACTIONS(2252),
    [anon_sym___fastcall] = ACTIONS(2252),
    [anon_sym___thiscall] = ACTIONS(2252),
    [anon_sym___vectorcall] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_RBRACE] = ACTIONS(2254),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2252),
    [anon_sym_register] = ACTIONS(2252),
    [anon_sym_inline] = ACTIONS(2252),
    [anon_sym___inline] = ACTIONS(2252),
    [anon_sym___inline__] = ACTIONS(2252),
    [anon_sym___forceinline] = ACTIONS(2252),
    [anon_sym_thread_local] = ACTIONS(2252),
    [anon_sym___thread] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2252),
    [anon_sym_constexpr] = ACTIONS(2252),
    [anon_sym_volatile] = ACTIONS(2252),
    [anon_sym_restrict] = ACTIONS(2252),
    [anon_sym___restrict__] = ACTIONS(2252),
    [anon_sym__Atomic] = ACTIONS(2252),
    [anon_sym__Noreturn] = ACTIONS(2252),
    [anon_sym_noreturn] = ACTIONS(2252),
    [anon_sym_mutable] = ACTIONS(2252),
    [anon_sym_constinit] = ACTIONS(2252),
    [anon_sym_consteval] = ACTIONS(2252),
    [anon_sym_alignas] = ACTIONS(2252),
    [anon_sym__Alignas] = ACTIONS(2252),
    [anon_sym_QMARK] = ACTIONS(2254),
    [anon_sym_LT_EQ_GT] = ACTIONS(2254),
    [anon_sym_or] = ACTIONS(2252),
    [anon_sym_and] = ACTIONS(2252),
    [anon_sym_bitor] = ACTIONS(2252),
    [anon_sym_xor] = ACTIONS(2252),
    [anon_sym_bitand] = ACTIONS(2252),
    [anon_sym_not_eq] = ACTIONS(2252),
    [anon_sym_is] = ACTIONS(2252),
    [anon_sym_as] = ACTIONS(2252),
    [anon_sym_DASH_DASH] = ACTIONS(2254),
    [anon_sym_PLUS_PLUS] = ACTIONS(2254),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_DOT_STAR] = ACTIONS(2254),
    [anon_sym_DASH_GT] = ACTIONS(2254),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_This] = ACTIONS(2252),
    [anon_sym_decltype] = ACTIONS(2252),
    [anon_sym_final] = ACTIONS(2252),
    [anon_sym_override] = ACTIONS(2252),
    [sym_virtual] = ACTIONS(2252),
    [anon_sym_template] = ACTIONS(2252),
    [anon_sym_operator] = ACTIONS(2252),
    [anon_sym_precise] = ACTIONS(2252),
    [anon_sym_shared] = ACTIONS(2252),
    [anon_sym_groupshared] = ACTIONS(2252),
    [anon_sym_uniform] = ACTIONS(2252),
    [anon_sym_row_major] = ACTIONS(2252),
    [anon_sym_column_major] = ACTIONS(2252),
    [anon_sym_globallycoherent] = ACTIONS(2252),
    [anon_sym_centroid] = ACTIONS(2252),
    [anon_sym_noperspective] = ACTIONS(2252),
    [anon_sym_nointerpolation] = ACTIONS(2252),
    [anon_sym_sample] = ACTIONS(2252),
    [anon_sym_linear] = ACTIONS(2252),
    [anon_sym_snorm] = ACTIONS(2252),
    [anon_sym_unorm] = ACTIONS(2252),
    [anon_sym_point] = ACTIONS(2252),
    [anon_sym_line] = ACTIONS(2252),
    [anon_sym_triangleadj] = ACTIONS(2252),
    [anon_sym_lineadj] = ACTIONS(2252),
    [anon_sym_triangle] = ACTIONS(2252),
  },
  [1448] = {
    [sym_function_definition] = STATE(1059),
    [sym_declaration] = STATE(1059),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5680),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_ms_call_modifier] = STATE(1937),
    [sym_declaration_list] = STATE(1059),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_hlsl_attribute] = STATE(1507),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(5148),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(5150),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1449] = {
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(7857),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7882),
    [sym_array_declarator] = STATE(7882),
    [sym_expression] = STATE(3690),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4031),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6778),
    [sym_qualified_identifier] = STATE(4016),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4911),
    [anon_sym_LPAREN2] = ACTIONS(2750),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2754),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2758),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2760),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(2808),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1450] = {
    [sym_function_definition] = STATE(992),
    [sym_declaration] = STATE(992),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5738),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_ms_call_modifier] = STATE(1856),
    [sym_declaration_list] = STATE(992),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_hlsl_attribute] = STATE(1510),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(5152),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(5150),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1451] = {
    [sym_function_definition] = STATE(483),
    [sym_declaration] = STATE(483),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5695),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_ms_call_modifier] = STATE(1831),
    [sym_declaration_list] = STATE(483),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_hlsl_attribute] = STATE(1506),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(5154),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(5150),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1452] = {
    [sym_function_definition] = STATE(813),
    [sym_declaration] = STATE(813),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_ms_call_modifier] = STATE(1835),
    [sym_declaration_list] = STATE(813),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_hlsl_attribute] = STATE(1508),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(5150),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1453] = {
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(7857),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7882),
    [sym_array_declarator] = STATE(7882),
    [sym_expression] = STATE(3215),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4074),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6851),
    [sym_qualified_identifier] = STATE(4067),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_operator_name] = STATE(7882),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4895),
    [anon_sym_LPAREN2] = ACTIONS(4897),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4899),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(2808),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1454] = {
    [sym_function_definition] = STATE(938),
    [sym_declaration] = STATE(938),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5643),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_ms_call_modifier] = STATE(1835),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(10401),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2904),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2900),
    [sym_qualifiers] = STATE(2038),
    [sym_hlsl_attribute] = STATE(1508),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(5158),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(5150),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(5160),
    [anon_sym_struct] = ACTIONS(5162),
    [anon_sym_union] = ACTIONS(5164),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1455] = {
    [sym_function_definition] = STATE(956),
    [sym_declaration] = STATE(956),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5738),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_ms_call_modifier] = STATE(1856),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(10756),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2904),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2900),
    [sym_qualifiers] = STATE(2038),
    [sym_hlsl_attribute] = STATE(1510),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(5158),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(5150),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(5166),
    [anon_sym_struct] = ACTIONS(5168),
    [anon_sym_union] = ACTIONS(5170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1456] = {
    [sym_function_definition] = STATE(1026),
    [sym_declaration] = STATE(1026),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5680),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_ms_call_modifier] = STATE(1937),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(10072),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2904),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2900),
    [sym_qualifiers] = STATE(2038),
    [sym_hlsl_attribute] = STATE(1507),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(5158),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(5150),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(5172),
    [anon_sym_struct] = ACTIONS(5174),
    [anon_sym_union] = ACTIONS(5176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1457] = {
    [sym_function_definition] = STATE(1571),
    [sym_declaration] = STATE(1571),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5707),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_ms_call_modifier] = STATE(1906),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(10828),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2904),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2900),
    [sym_qualifiers] = STATE(2038),
    [sym_hlsl_attribute] = STATE(1512),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(5158),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(5150),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(5178),
    [anon_sym_struct] = ACTIONS(5180),
    [anon_sym_union] = ACTIONS(5182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1458] = {
    [sym_function_definition] = STATE(451),
    [sym_declaration] = STATE(451),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5695),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_ms_call_modifier] = STATE(1831),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(10801),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2904),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2900),
    [sym_qualifiers] = STATE(2038),
    [sym_hlsl_attribute] = STATE(1506),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(5158),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(5150),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(5184),
    [anon_sym_struct] = ACTIONS(5186),
    [anon_sym_union] = ACTIONS(5188),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1459] = {
    [sym_function_definition] = STATE(2097),
    [sym_declaration] = STATE(2097),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5682),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_ms_call_modifier] = STATE(1908),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(10640),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2904),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2900),
    [sym_qualifiers] = STATE(2038),
    [sym_hlsl_attribute] = STATE(1514),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(5158),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(5150),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(5190),
    [anon_sym_struct] = ACTIONS(5192),
    [anon_sym_union] = ACTIONS(5194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1460] = {
    [sym_function_definition] = STATE(2215),
    [sym_declaration] = STATE(2215),
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5723),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_ms_call_modifier] = STATE(1865),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym__class_name] = STATE(10459),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2904),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2900),
    [sym_qualifiers] = STATE(2038),
    [sym_hlsl_attribute] = STATE(1511),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(5158),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(5150),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(5196),
    [anon_sym_struct] = ACTIONS(5198),
    [anon_sym_union] = ACTIONS(5200),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1461] = {
    [sym_identifier] = ACTIONS(2210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2212),
    [anon_sym_COMMA] = ACTIONS(2212),
    [anon_sym_LPAREN2] = ACTIONS(2214),
    [anon_sym_TILDE] = ACTIONS(2217),
    [anon_sym_DASH] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(2222),
    [anon_sym_STAR] = ACTIONS(2214),
    [anon_sym_SLASH] = ACTIONS(2222),
    [anon_sym_PERCENT] = ACTIONS(2212),
    [anon_sym_PIPE_PIPE] = ACTIONS(2212),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2222),
    [anon_sym_CARET] = ACTIONS(2212),
    [anon_sym_AMP] = ACTIONS(2219),
    [anon_sym_EQ_EQ] = ACTIONS(2212),
    [anon_sym_BANG_EQ] = ACTIONS(2212),
    [anon_sym_GT] = ACTIONS(2222),
    [anon_sym_GT_EQ] = ACTIONS(2212),
    [anon_sym_LT_EQ] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(2222),
    [anon_sym_LT_LT] = ACTIONS(2212),
    [anon_sym_GT_GT] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym___extension__] = ACTIONS(2210),
    [anon_sym_in] = ACTIONS(2210),
    [anon_sym_out] = ACTIONS(2210),
    [anon_sym_inout] = ACTIONS(2210),
    [anon_sym_extern] = ACTIONS(2210),
    [anon_sym___attribute__] = ACTIONS(2210),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2214),
    [anon_sym___declspec] = ACTIONS(2210),
    [anon_sym___based] = ACTIONS(2210),
    [anon_sym___cdecl] = ACTIONS(2210),
    [anon_sym___clrcall] = ACTIONS(2210),
    [anon_sym___stdcall] = ACTIONS(2210),
    [anon_sym___fastcall] = ACTIONS(2210),
    [anon_sym___thiscall] = ACTIONS(2210),
    [anon_sym___vectorcall] = ACTIONS(2210),
    [anon_sym_LBRACE] = ACTIONS(2217),
    [anon_sym_RBRACE] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_static] = ACTIONS(2210),
    [anon_sym_register] = ACTIONS(2210),
    [anon_sym_inline] = ACTIONS(2210),
    [anon_sym___inline] = ACTIONS(2210),
    [anon_sym___inline__] = ACTIONS(2210),
    [anon_sym___forceinline] = ACTIONS(2210),
    [anon_sym_thread_local] = ACTIONS(2210),
    [anon_sym___thread] = ACTIONS(2210),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_constexpr] = ACTIONS(2210),
    [anon_sym_volatile] = ACTIONS(2210),
    [anon_sym_restrict] = ACTIONS(2210),
    [anon_sym___restrict__] = ACTIONS(2210),
    [anon_sym__Atomic] = ACTIONS(2210),
    [anon_sym__Noreturn] = ACTIONS(2210),
    [anon_sym_noreturn] = ACTIONS(2210),
    [anon_sym_mutable] = ACTIONS(2210),
    [anon_sym_constinit] = ACTIONS(2210),
    [anon_sym_consteval] = ACTIONS(2210),
    [anon_sym_alignas] = ACTIONS(2210),
    [anon_sym__Alignas] = ACTIONS(2210),
    [anon_sym_QMARK] = ACTIONS(2212),
    [anon_sym_LT_EQ_GT] = ACTIONS(2212),
    [anon_sym_or] = ACTIONS(2222),
    [anon_sym_and] = ACTIONS(2222),
    [anon_sym_bitor] = ACTIONS(2222),
    [anon_sym_xor] = ACTIONS(2222),
    [anon_sym_bitand] = ACTIONS(2222),
    [anon_sym_not_eq] = ACTIONS(2222),
    [anon_sym_is] = ACTIONS(2222),
    [anon_sym_as] = ACTIONS(2222),
    [anon_sym_DASH_DASH] = ACTIONS(2212),
    [anon_sym_PLUS_PLUS] = ACTIONS(2212),
    [anon_sym_DOT] = ACTIONS(2219),
    [anon_sym_DOT_STAR] = ACTIONS(2212),
    [anon_sym_DASH_GT] = ACTIONS(2212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2210),
    [anon_sym_let] = ACTIONS(2210),
    [anon_sym_This] = ACTIONS(2210),
    [anon_sym_decltype] = ACTIONS(2210),
    [sym_virtual] = ACTIONS(2210),
    [anon_sym_template] = ACTIONS(2210),
    [anon_sym_operator] = ACTIONS(2210),
    [anon_sym_precise] = ACTIONS(2210),
    [anon_sym_shared] = ACTIONS(2210),
    [anon_sym_groupshared] = ACTIONS(2210),
    [anon_sym_uniform] = ACTIONS(2210),
    [anon_sym_row_major] = ACTIONS(2210),
    [anon_sym_column_major] = ACTIONS(2210),
    [anon_sym_globallycoherent] = ACTIONS(2210),
    [anon_sym_centroid] = ACTIONS(2210),
    [anon_sym_noperspective] = ACTIONS(2210),
    [anon_sym_nointerpolation] = ACTIONS(2210),
    [anon_sym_sample] = ACTIONS(2210),
    [anon_sym_linear] = ACTIONS(2210),
    [anon_sym_snorm] = ACTIONS(2210),
    [anon_sym_unorm] = ACTIONS(2210),
    [anon_sym_point] = ACTIONS(2210),
    [anon_sym_line] = ACTIONS(2210),
    [anon_sym_triangleadj] = ACTIONS(2210),
    [anon_sym_lineadj] = ACTIONS(2210),
    [anon_sym_triangle] = ACTIONS(2210),
  },
  [1462] = {
    [sym_expression_statement] = STATE(3680),
    [sym_expression] = STATE(5422),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10583),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_type_requirement] = STATE(1491),
    [sym_compound_requirement] = STATE(1491),
    [sym__requirement] = STATE(1491),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_requirement_seq_repeat1] = STATE(1491),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5202),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(5204),
    [anon_sym_RBRACE] = ACTIONS(5206),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_typename] = ACTIONS(5208),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1463] = {
    [sym_expression_statement] = STATE(3680),
    [sym_expression] = STATE(5422),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10583),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_type_requirement] = STATE(1491),
    [sym_compound_requirement] = STATE(1491),
    [sym__requirement] = STATE(1491),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_requirement_seq_repeat1] = STATE(1491),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5202),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(5204),
    [anon_sym_RBRACE] = ACTIONS(5210),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_typename] = ACTIONS(5208),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1464] = {
    [sym_expression] = STATE(5301),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(9283),
    [sym_initializer_pair] = STATE(9283),
    [sym_subscript_designator] = STATE(8254),
    [sym_subscript_range_designator] = STATE(8254),
    [sym_field_designator] = STATE(8254),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_initializer_pair_repeat1] = STATE(8254),
    [sym_identifier] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5214),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_RBRACE] = ACTIONS(5216),
    [anon_sym_LBRACK] = ACTIONS(5218),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(237),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1465] = {
    [sym_expression_statement] = STATE(3680),
    [sym_expression] = STATE(5422),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10583),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_type_requirement] = STATE(1491),
    [sym_compound_requirement] = STATE(1491),
    [sym__requirement] = STATE(1491),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_requirement_seq_repeat1] = STATE(1491),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5202),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(5204),
    [anon_sym_RBRACE] = ACTIONS(5220),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_typename] = ACTIONS(5208),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1466] = {
    [sym_expression] = STATE(5164),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(9455),
    [sym_initializer_pair] = STATE(9455),
    [sym_subscript_designator] = STATE(8254),
    [sym_subscript_range_designator] = STATE(8254),
    [sym_field_designator] = STATE(8254),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_initializer_pair_repeat1] = STATE(8254),
    [sym_identifier] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5222),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_RBRACE] = ACTIONS(5224),
    [anon_sym_LBRACK] = ACTIONS(5218),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(237),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1467] = {
    [sym_expression_statement] = STATE(3680),
    [sym_expression] = STATE(5422),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10583),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_type_requirement] = STATE(1491),
    [sym_compound_requirement] = STATE(1491),
    [sym__requirement] = STATE(1491),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_requirement_seq_repeat1] = STATE(1491),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5202),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(5204),
    [anon_sym_RBRACE] = ACTIONS(5226),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_typename] = ACTIONS(5208),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1468] = {
    [sym_expression_statement] = STATE(3680),
    [sym_expression] = STATE(5422),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10583),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_type_requirement] = STATE(1465),
    [sym_compound_requirement] = STATE(1465),
    [sym__requirement] = STATE(1465),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_requirement_seq_repeat1] = STATE(1465),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5202),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(5204),
    [anon_sym_RBRACE] = ACTIONS(5228),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_typename] = ACTIONS(5208),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1469] = {
    [sym_expression_statement] = STATE(3680),
    [sym_expression] = STATE(5422),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10583),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_type_requirement] = STATE(1491),
    [sym_compound_requirement] = STATE(1491),
    [sym__requirement] = STATE(1491),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_requirement_seq_repeat1] = STATE(1491),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5202),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(5204),
    [anon_sym_RBRACE] = ACTIONS(5230),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_typename] = ACTIONS(5208),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1470] = {
    [sym_expression] = STATE(5237),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(9278),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10020),
    [sym_initializer_pair] = STATE(10020),
    [sym_subscript_designator] = STATE(8254),
    [sym_subscript_range_designator] = STATE(8254),
    [sym_field_designator] = STATE(8254),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_initializer_pair_repeat1] = STATE(8254),
    [sym_identifier] = ACTIONS(5212),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_RBRACE] = ACTIONS(5232),
    [anon_sym_LBRACK] = ACTIONS(5218),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(237),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1471] = {
    [sym_expression_statement] = STATE(3680),
    [sym_expression] = STATE(5422),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10583),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_type_requirement] = STATE(1469),
    [sym_compound_requirement] = STATE(1469),
    [sym__requirement] = STATE(1469),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_requirement_seq_repeat1] = STATE(1469),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5202),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(5204),
    [anon_sym_RBRACE] = ACTIONS(5234),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_typename] = ACTIONS(5208),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1472] = {
    [sym_expression] = STATE(5154),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(9479),
    [sym_initializer_pair] = STATE(9479),
    [sym_subscript_designator] = STATE(8254),
    [sym_subscript_range_designator] = STATE(8254),
    [sym_field_designator] = STATE(8254),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_initializer_pair_repeat1] = STATE(8254),
    [sym_identifier] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_RBRACE] = ACTIONS(5238),
    [anon_sym_LBRACK] = ACTIONS(5218),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(237),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1473] = {
    [sym_expression] = STATE(5173),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(9302),
    [sym_initializer_pair] = STATE(9302),
    [sym_subscript_designator] = STATE(8254),
    [sym_subscript_range_designator] = STATE(8254),
    [sym_field_designator] = STATE(8254),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_initializer_pair_repeat1] = STATE(8254),
    [sym_identifier] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5240),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_RBRACE] = ACTIONS(5242),
    [anon_sym_LBRACK] = ACTIONS(5218),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(237),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1474] = {
    [sym_expression_statement] = STATE(3680),
    [sym_expression] = STATE(5422),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10583),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_type_requirement] = STATE(1478),
    [sym_compound_requirement] = STATE(1478),
    [sym__requirement] = STATE(1478),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_requirement_seq_repeat1] = STATE(1478),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5202),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(5204),
    [anon_sym_RBRACE] = ACTIONS(5244),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_typename] = ACTIONS(5208),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1475] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5988),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_ms_call_modifier] = STATE(1848),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(5246),
    [anon_sym_for] = ACTIONS(5248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1476] = {
    [sym_expression_statement] = STATE(3680),
    [sym_expression] = STATE(5422),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10583),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_type_requirement] = STATE(1467),
    [sym_compound_requirement] = STATE(1467),
    [sym__requirement] = STATE(1467),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_requirement_seq_repeat1] = STATE(1467),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5202),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(5204),
    [anon_sym_RBRACE] = ACTIONS(5250),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_typename] = ACTIONS(5208),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1477] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5966),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_ms_call_modifier] = STATE(1821),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(5252),
    [anon_sym_for] = ACTIONS(5254),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1478] = {
    [sym_expression_statement] = STATE(3680),
    [sym_expression] = STATE(5422),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10583),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_type_requirement] = STATE(1491),
    [sym_compound_requirement] = STATE(1491),
    [sym__requirement] = STATE(1491),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_requirement_seq_repeat1] = STATE(1491),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5202),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(5204),
    [anon_sym_RBRACE] = ACTIONS(5256),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_typename] = ACTIONS(5208),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1479] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5994),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_ms_call_modifier] = STATE(1870),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(5258),
    [anon_sym_for] = ACTIONS(5260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1480] = {
    [sym_expression] = STATE(5203),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(9584),
    [sym_initializer_pair] = STATE(9584),
    [sym_subscript_designator] = STATE(8254),
    [sym_subscript_range_designator] = STATE(8254),
    [sym_field_designator] = STATE(8254),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_initializer_pair_repeat1] = STATE(8254),
    [sym_identifier] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5262),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_RBRACE] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(5218),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(237),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1481] = {
    [sym_expression_statement] = STATE(3680),
    [sym_expression] = STATE(5422),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10583),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_type_requirement] = STATE(1482),
    [sym_compound_requirement] = STATE(1482),
    [sym__requirement] = STATE(1482),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_requirement_seq_repeat1] = STATE(1482),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5202),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(5204),
    [anon_sym_RBRACE] = ACTIONS(5266),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_typename] = ACTIONS(5208),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1482] = {
    [sym_expression_statement] = STATE(3680),
    [sym_expression] = STATE(5422),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10583),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_type_requirement] = STATE(1491),
    [sym_compound_requirement] = STATE(1491),
    [sym__requirement] = STATE(1491),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_requirement_seq_repeat1] = STATE(1491),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5202),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(5204),
    [anon_sym_RBRACE] = ACTIONS(5268),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_typename] = ACTIONS(5208),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1483] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5995),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_ms_call_modifier] = STATE(1861),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(5270),
    [anon_sym_for] = ACTIONS(5272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1484] = {
    [sym_expression] = STATE(5144),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(9006),
    [sym_initializer_pair] = STATE(9006),
    [sym_subscript_designator] = STATE(8254),
    [sym_subscript_range_designator] = STATE(8254),
    [sym_field_designator] = STATE(8254),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_initializer_pair_repeat1] = STATE(8254),
    [sym_identifier] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_RBRACE] = ACTIONS(5274),
    [anon_sym_LBRACK] = ACTIONS(5218),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(237),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1485] = {
    [sym_expression_statement] = STATE(3680),
    [sym_expression] = STATE(5422),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10583),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_type_requirement] = STATE(1491),
    [sym_compound_requirement] = STATE(1491),
    [sym__requirement] = STATE(1491),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_requirement_seq_repeat1] = STATE(1491),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5202),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(5204),
    [anon_sym_RBRACE] = ACTIONS(5276),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_typename] = ACTIONS(5208),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1486] = {
    [sym_expression_statement] = STATE(3680),
    [sym_expression] = STATE(5422),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10583),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_type_requirement] = STATE(1485),
    [sym_compound_requirement] = STATE(1485),
    [sym__requirement] = STATE(1485),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_requirement_seq_repeat1] = STATE(1485),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5202),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(5204),
    [anon_sym_RBRACE] = ACTIONS(5278),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_typename] = ACTIONS(5208),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1487] = {
    [sym_expression_statement] = STATE(3680),
    [sym_expression] = STATE(5422),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10583),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_type_requirement] = STATE(1462),
    [sym_compound_requirement] = STATE(1462),
    [sym__requirement] = STATE(1462),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_requirement_seq_repeat1] = STATE(1462),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5202),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(5204),
    [anon_sym_RBRACE] = ACTIONS(5280),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_typename] = ACTIONS(5208),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1488] = {
    [sym_expression_statement] = STATE(3680),
    [sym_expression] = STATE(5422),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10583),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_type_requirement] = STATE(1491),
    [sym_compound_requirement] = STATE(1491),
    [sym__requirement] = STATE(1491),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_requirement_seq_repeat1] = STATE(1491),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5202),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(5204),
    [anon_sym_RBRACE] = ACTIONS(5282),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_typename] = ACTIONS(5208),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1489] = {
    [sym_expression_statement] = STATE(3680),
    [sym_expression] = STATE(5422),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10583),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_type_requirement] = STATE(1488),
    [sym_compound_requirement] = STATE(1488),
    [sym__requirement] = STATE(1488),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_requirement_seq_repeat1] = STATE(1488),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5202),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(5204),
    [anon_sym_RBRACE] = ACTIONS(5284),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_typename] = ACTIONS(5208),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1490] = {
    [sym_expression_statement] = STATE(3680),
    [sym_expression] = STATE(5422),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10583),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_type_requirement] = STATE(1463),
    [sym_compound_requirement] = STATE(1463),
    [sym__requirement] = STATE(1463),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_requirement_seq_repeat1] = STATE(1463),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5202),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(5204),
    [anon_sym_RBRACE] = ACTIONS(5286),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_typename] = ACTIONS(5208),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1491] = {
    [sym_expression_statement] = STATE(3680),
    [sym_expression] = STATE(5422),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10583),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_type_requirement] = STATE(1491),
    [sym_compound_requirement] = STATE(1491),
    [sym__requirement] = STATE(1491),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_requirement_seq_repeat1] = STATE(1491),
    [sym_identifier] = ACTIONS(5288),
    [anon_sym_LPAREN2] = ACTIONS(5291),
    [anon_sym_BANG] = ACTIONS(5294),
    [anon_sym_TILDE] = ACTIONS(5294),
    [anon_sym_DASH] = ACTIONS(5297),
    [anon_sym_PLUS] = ACTIONS(5297),
    [anon_sym_STAR] = ACTIONS(5300),
    [anon_sym_AMP] = ACTIONS(5300),
    [anon_sym_SEMI] = ACTIONS(5303),
    [anon_sym_COLON_COLON] = ACTIONS(5306),
    [anon_sym_LBRACE] = ACTIONS(5309),
    [anon_sym_RBRACE] = ACTIONS(5312),
    [anon_sym_LBRACK] = ACTIONS(5314),
    [sym_primitive_type] = ACTIONS(5317),
    [anon_sym_not] = ACTIONS(5297),
    [anon_sym_compl] = ACTIONS(5297),
    [anon_sym_DASH_DASH] = ACTIONS(5320),
    [anon_sym_PLUS_PLUS] = ACTIONS(5320),
    [anon_sym_sizeof] = ACTIONS(5323),
    [anon_sym___alignof__] = ACTIONS(5326),
    [anon_sym___alignof] = ACTIONS(5326),
    [anon_sym__alignof] = ACTIONS(5326),
    [anon_sym_alignof] = ACTIONS(5326),
    [anon_sym__Alignof] = ACTIONS(5326),
    [anon_sym_offsetof] = ACTIONS(5329),
    [anon_sym__Generic] = ACTIONS(5332),
    [anon_sym_asm] = ACTIONS(5335),
    [anon_sym___asm__] = ACTIONS(5335),
    [sym_number_literal] = ACTIONS(5338),
    [anon_sym_L_SQUOTE] = ACTIONS(5341),
    [anon_sym_u_SQUOTE] = ACTIONS(5341),
    [anon_sym_U_SQUOTE] = ACTIONS(5341),
    [anon_sym_u8_SQUOTE] = ACTIONS(5341),
    [anon_sym_SQUOTE] = ACTIONS(5341),
    [anon_sym_L_DQUOTE] = ACTIONS(5344),
    [anon_sym_u_DQUOTE] = ACTIONS(5344),
    [anon_sym_U_DQUOTE] = ACTIONS(5344),
    [anon_sym_u8_DQUOTE] = ACTIONS(5344),
    [anon_sym_DQUOTE] = ACTIONS(5344),
    [sym_true] = ACTIONS(5347),
    [sym_false] = ACTIONS(5347),
    [anon_sym_NULL] = ACTIONS(5350),
    [anon_sym_nullptr] = ACTIONS(5350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(5353),
    [anon_sym_typename] = ACTIONS(5356),
    [anon_sym_template] = ACTIONS(5359),
    [anon_sym_delete] = ACTIONS(5362),
    [anon_sym_R_DQUOTE] = ACTIONS(5365),
    [anon_sym_LR_DQUOTE] = ACTIONS(5365),
    [anon_sym_uR_DQUOTE] = ACTIONS(5365),
    [anon_sym_UR_DQUOTE] = ACTIONS(5365),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5365),
    [anon_sym_co_await] = ACTIONS(5368),
    [anon_sym_new] = ACTIONS(5371),
    [anon_sym_requires] = ACTIONS(5374),
    [sym_this] = ACTIONS(5347),
  },
  [1492] = {
    [sym_expression] = STATE(5453),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10020),
    [sym_initializer_pair] = STATE(10020),
    [sym_subscript_designator] = STATE(8254),
    [sym_subscript_range_designator] = STATE(8254),
    [sym_field_designator] = STATE(8254),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_initializer_pair_repeat1] = STATE(8254),
    [sym_identifier] = ACTIONS(5212),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_RBRACE] = ACTIONS(5377),
    [anon_sym_LBRACK] = ACTIONS(5218),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(237),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1493] = {
    [sym_expression] = STATE(5453),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10020),
    [sym_initializer_pair] = STATE(10020),
    [sym_subscript_designator] = STATE(8254),
    [sym_subscript_range_designator] = STATE(8254),
    [sym_field_designator] = STATE(8254),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_initializer_pair_repeat1] = STATE(8254),
    [sym_identifier] = ACTIONS(5212),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_RBRACE] = ACTIONS(5379),
    [anon_sym_LBRACK] = ACTIONS(5218),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(237),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1494] = {
    [sym_expression] = STATE(5453),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10020),
    [sym_initializer_pair] = STATE(10020),
    [sym_subscript_designator] = STATE(8254),
    [sym_subscript_range_designator] = STATE(8254),
    [sym_field_designator] = STATE(8254),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_initializer_pair_repeat1] = STATE(8254),
    [sym_identifier] = ACTIONS(5212),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_RBRACE] = ACTIONS(5381),
    [anon_sym_LBRACK] = ACTIONS(5218),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(237),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1495] = {
    [sym_expression] = STATE(5453),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10020),
    [sym_initializer_pair] = STATE(10020),
    [sym_subscript_designator] = STATE(8254),
    [sym_subscript_range_designator] = STATE(8254),
    [sym_field_designator] = STATE(8254),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_initializer_pair_repeat1] = STATE(8254),
    [sym_identifier] = ACTIONS(5212),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_RBRACE] = ACTIONS(5383),
    [anon_sym_LBRACK] = ACTIONS(5218),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(237),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1496] = {
    [sym_expression] = STATE(5453),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10020),
    [sym_initializer_pair] = STATE(10020),
    [sym_subscript_designator] = STATE(8254),
    [sym_subscript_range_designator] = STATE(8254),
    [sym_field_designator] = STATE(8254),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_initializer_pair_repeat1] = STATE(8254),
    [sym_identifier] = ACTIONS(5212),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_RBRACE] = ACTIONS(5385),
    [anon_sym_LBRACK] = ACTIONS(5218),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(237),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1497] = {
    [sym_expression] = STATE(5453),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10020),
    [sym_initializer_pair] = STATE(10020),
    [sym_subscript_designator] = STATE(8254),
    [sym_subscript_range_designator] = STATE(8254),
    [sym_field_designator] = STATE(8254),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_initializer_pair_repeat1] = STATE(8254),
    [sym_identifier] = ACTIONS(5212),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_RBRACE] = ACTIONS(5387),
    [anon_sym_LBRACK] = ACTIONS(5218),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(237),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1498] = {
    [sym_expression] = STATE(5453),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10020),
    [sym_initializer_pair] = STATE(10020),
    [sym_subscript_designator] = STATE(8254),
    [sym_subscript_range_designator] = STATE(8254),
    [sym_field_designator] = STATE(8254),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_initializer_pair_repeat1] = STATE(8254),
    [sym_identifier] = ACTIONS(5212),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_RBRACE] = ACTIONS(5389),
    [anon_sym_LBRACK] = ACTIONS(5218),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(237),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1499] = {
    [sym_expression] = STATE(5453),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10020),
    [sym_initializer_pair] = STATE(10020),
    [sym_subscript_designator] = STATE(8254),
    [sym_subscript_range_designator] = STATE(8254),
    [sym_field_designator] = STATE(8254),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_initializer_pair_repeat1] = STATE(8254),
    [sym_identifier] = ACTIONS(5212),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_RBRACE] = ACTIONS(5391),
    [anon_sym_LBRACK] = ACTIONS(5218),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(237),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1500] = {
    [sym_expression] = STATE(5453),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10020),
    [sym_initializer_pair] = STATE(10020),
    [sym_subscript_designator] = STATE(8254),
    [sym_subscript_range_designator] = STATE(8254),
    [sym_field_designator] = STATE(8254),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_initializer_pair_repeat1] = STATE(8254),
    [sym_identifier] = ACTIONS(5212),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_RBRACE] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(5218),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(237),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1501] = {
    [sym__declaration_modifiers] = STATE(2299),
    [sym__declaration_specifiers] = STATE(4869),
    [sym_attribute_specifier] = STATE(2299),
    [sym_attribute_declaration] = STATE(2299),
    [sym_ms_declspec_modifier] = STATE(2299),
    [sym_storage_class_specifier] = STATE(2299),
    [sym_type_qualifier] = STATE(2299),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2694),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_parameter_declaration] = STATE(9626),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_type_parameter_declaration] = STATE(9626),
    [sym_variadic_type_parameter_declaration] = STATE(9626),
    [sym_optional_type_parameter_declaration] = STATE(9626),
    [sym_template_template_parameter_declaration] = STATE(9626),
    [sym_optional_parameter_declaration] = STATE(9626),
    [sym_variadic_parameter_declaration] = STATE(9626),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8090),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2299),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2299),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(5014),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_out] = ACTIONS(2293),
    [anon_sym_inout] = ACTIONS(2293),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(5024),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2299),
    [anon_sym_class] = ACTIONS(5395),
    [anon_sym_struct] = ACTIONS(2303),
    [anon_sym_union] = ACTIONS(2305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(2293),
    [anon_sym_typename] = ACTIONS(5397),
    [anon_sym_template] = ACTIONS(5399),
    [anon_sym_GT2] = ACTIONS(5401),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2341),
    [anon_sym_extension] = ACTIONS(2343),
  },
  [1502] = {
    [sym_expression] = STATE(5453),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10020),
    [sym_initializer_pair] = STATE(10020),
    [sym_subscript_designator] = STATE(8254),
    [sym_subscript_range_designator] = STATE(8254),
    [sym_field_designator] = STATE(8254),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_initializer_pair_repeat1] = STATE(8254),
    [sym_identifier] = ACTIONS(5212),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_RBRACE] = ACTIONS(5403),
    [anon_sym_LBRACK] = ACTIONS(5218),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(237),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1503] = {
    [sym__declaration_modifiers] = STATE(2299),
    [sym__declaration_specifiers] = STATE(4869),
    [sym_attribute_specifier] = STATE(2299),
    [sym_attribute_declaration] = STATE(2299),
    [sym_ms_declspec_modifier] = STATE(2299),
    [sym_storage_class_specifier] = STATE(2299),
    [sym_type_qualifier] = STATE(2299),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2694),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_parameter_declaration] = STATE(9237),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_type_parameter_declaration] = STATE(9237),
    [sym_variadic_type_parameter_declaration] = STATE(9237),
    [sym_optional_type_parameter_declaration] = STATE(9237),
    [sym_template_template_parameter_declaration] = STATE(9237),
    [sym_optional_parameter_declaration] = STATE(9237),
    [sym_variadic_parameter_declaration] = STATE(9237),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8090),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2299),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2299),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(5014),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_out] = ACTIONS(2293),
    [anon_sym_inout] = ACTIONS(2293),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(5024),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2299),
    [anon_sym_class] = ACTIONS(5395),
    [anon_sym_struct] = ACTIONS(2303),
    [anon_sym_union] = ACTIONS(2305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(2293),
    [anon_sym_typename] = ACTIONS(5397),
    [anon_sym_template] = ACTIONS(5399),
    [anon_sym_GT2] = ACTIONS(5405),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2341),
    [anon_sym_extension] = ACTIONS(2343),
  },
  [1504] = {
    [sym_expression] = STATE(5453),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10020),
    [sym_initializer_pair] = STATE(10020),
    [sym_subscript_designator] = STATE(8254),
    [sym_subscript_range_designator] = STATE(8254),
    [sym_field_designator] = STATE(8254),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_initializer_pair_repeat1] = STATE(8254),
    [sym_identifier] = ACTIONS(5212),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_RBRACE] = ACTIONS(5232),
    [anon_sym_LBRACK] = ACTIONS(5218),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(237),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1505] = {
    [sym_expression] = STATE(5453),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10020),
    [sym_initializer_pair] = STATE(10020),
    [sym_subscript_designator] = STATE(8254),
    [sym_subscript_range_designator] = STATE(8254),
    [sym_field_designator] = STATE(8254),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_initializer_pair_repeat1] = STATE(8254),
    [sym_identifier] = ACTIONS(5212),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_RBRACE] = ACTIONS(5407),
    [anon_sym_LBRACK] = ACTIONS(5218),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(237),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1506] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5988),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_ms_call_modifier] = STATE(1848),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1507] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5994),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_ms_call_modifier] = STATE(1870),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1508] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5966),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_ms_call_modifier] = STATE(1821),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1509] = {
    [sym_expression] = STATE(5453),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10020),
    [sym_initializer_pair] = STATE(10020),
    [sym_subscript_designator] = STATE(8254),
    [sym_subscript_range_designator] = STATE(8254),
    [sym_field_designator] = STATE(8254),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [aux_sym_initializer_pair_repeat1] = STATE(8254),
    [sym_identifier] = ACTIONS(5212),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(5218),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(237),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1510] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5995),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_ms_call_modifier] = STATE(1861),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1511] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5897),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_ms_call_modifier] = STATE(1900),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1512] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5866),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_ms_call_modifier] = STATE(1907),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1513] = {
    [sym__declaration_modifiers] = STATE(2299),
    [sym__declaration_specifiers] = STATE(4869),
    [sym_attribute_specifier] = STATE(2299),
    [sym_attribute_declaration] = STATE(2299),
    [sym_ms_declspec_modifier] = STATE(2299),
    [sym_storage_class_specifier] = STATE(2299),
    [sym_type_qualifier] = STATE(2299),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2694),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_parameter_declaration] = STATE(10010),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_type_parameter_declaration] = STATE(10010),
    [sym_variadic_type_parameter_declaration] = STATE(10010),
    [sym_optional_type_parameter_declaration] = STATE(10010),
    [sym_template_template_parameter_declaration] = STATE(10010),
    [sym_optional_parameter_declaration] = STATE(10010),
    [sym_variadic_parameter_declaration] = STATE(10010),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8090),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2299),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2299),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(5014),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_out] = ACTIONS(2293),
    [anon_sym_inout] = ACTIONS(2293),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(5024),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2299),
    [anon_sym_class] = ACTIONS(5395),
    [anon_sym_struct] = ACTIONS(2303),
    [anon_sym_union] = ACTIONS(2305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(2293),
    [anon_sym_typename] = ACTIONS(5397),
    [anon_sym_template] = ACTIONS(5399),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2341),
    [anon_sym_extension] = ACTIONS(2343),
  },
  [1514] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5929),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_ms_call_modifier] = STATE(1912),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1515] = {
    [sym_catch_clause] = STATE(1515),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1515),
    [sym_identifier] = ACTIONS(2731),
    [aux_sym_preproc_def_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token2] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2731),
    [aux_sym_preproc_else_token1] = ACTIONS(2731),
    [aux_sym_preproc_elif_token1] = ACTIONS(2731),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_AMP_AMP] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2731),
    [anon_sym___extension__] = ACTIONS(2731),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_in] = ACTIONS(2731),
    [anon_sym_out] = ACTIONS(2731),
    [anon_sym_inout] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym___based] = ACTIONS(2731),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym__Alignas] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2731),
    [anon_sym_let] = ACTIONS(2731),
    [anon_sym_This] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(2731),
    [sym_virtual] = ACTIONS(2731),
    [anon_sym_explicit] = ACTIONS(2731),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(2731),
    [anon_sym_operator] = ACTIONS(2731),
    [anon_sym_friend] = ACTIONS(2731),
    [anon_sym_public] = ACTIONS(2731),
    [anon_sym_private] = ACTIONS(2731),
    [anon_sym_protected] = ACTIONS(2731),
    [anon_sym_using] = ACTIONS(2731),
    [anon_sym_static_assert] = ACTIONS(2731),
    [anon_sym_catch] = ACTIONS(5409),
    [anon_sym_precise] = ACTIONS(2731),
    [anon_sym_shared] = ACTIONS(2731),
    [anon_sym_groupshared] = ACTIONS(2731),
    [anon_sym_uniform] = ACTIONS(2731),
    [anon_sym_row_major] = ACTIONS(2731),
    [anon_sym_column_major] = ACTIONS(2731),
    [anon_sym_globallycoherent] = ACTIONS(2731),
    [anon_sym_centroid] = ACTIONS(2731),
    [anon_sym_noperspective] = ACTIONS(2731),
    [anon_sym_nointerpolation] = ACTIONS(2731),
    [anon_sym_sample] = ACTIONS(2731),
    [anon_sym_linear] = ACTIONS(2731),
    [anon_sym_snorm] = ACTIONS(2731),
    [anon_sym_unorm] = ACTIONS(2731),
    [anon_sym_point] = ACTIONS(2731),
    [anon_sym_line] = ACTIONS(2731),
    [anon_sym_triangleadj] = ACTIONS(2731),
    [anon_sym_lineadj] = ACTIONS(2731),
    [anon_sym_triangle] = ACTIONS(2731),
    [anon_sym_interface] = ACTIONS(2731),
    [anon_sym_extension] = ACTIONS(2731),
    [anon_sym___init] = ACTIONS(2731),
    [anon_sym___subscript] = ACTIONS(2731),
    [anon_sym_property] = ACTIONS(2731),
    [anon_sym_associatedtype] = ACTIONS(2731),
  },
  [1516] = {
    [sym_catch_clause] = STATE(1515),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1515),
    [sym_identifier] = ACTIONS(2830),
    [aux_sym_preproc_def_token1] = ACTIONS(2830),
    [aux_sym_preproc_if_token1] = ACTIONS(2830),
    [aux_sym_preproc_if_token2] = ACTIONS(2830),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2830),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2830),
    [aux_sym_preproc_else_token1] = ACTIONS(2830),
    [aux_sym_preproc_elif_token1] = ACTIONS(2830),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2830),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2830),
    [sym_preproc_directive] = ACTIONS(2830),
    [anon_sym_LPAREN2] = ACTIONS(2832),
    [anon_sym_TILDE] = ACTIONS(2832),
    [anon_sym_STAR] = ACTIONS(2832),
    [anon_sym_AMP_AMP] = ACTIONS(2832),
    [anon_sym_AMP] = ACTIONS(2830),
    [anon_sym___extension__] = ACTIONS(2830),
    [anon_sym_typedef] = ACTIONS(2830),
    [anon_sym_in] = ACTIONS(2830),
    [anon_sym_out] = ACTIONS(2830),
    [anon_sym_inout] = ACTIONS(2830),
    [anon_sym_extern] = ACTIONS(2830),
    [anon_sym___attribute__] = ACTIONS(2830),
    [anon_sym_COLON_COLON] = ACTIONS(2832),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2832),
    [anon_sym___declspec] = ACTIONS(2830),
    [anon_sym___based] = ACTIONS(2830),
    [anon_sym_signed] = ACTIONS(2830),
    [anon_sym_unsigned] = ACTIONS(2830),
    [anon_sym_long] = ACTIONS(2830),
    [anon_sym_short] = ACTIONS(2830),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [anon_sym_static] = ACTIONS(2830),
    [anon_sym_register] = ACTIONS(2830),
    [anon_sym_inline] = ACTIONS(2830),
    [anon_sym___inline] = ACTIONS(2830),
    [anon_sym___inline__] = ACTIONS(2830),
    [anon_sym___forceinline] = ACTIONS(2830),
    [anon_sym_thread_local] = ACTIONS(2830),
    [anon_sym___thread] = ACTIONS(2830),
    [anon_sym_const] = ACTIONS(2830),
    [anon_sym_constexpr] = ACTIONS(2830),
    [anon_sym_volatile] = ACTIONS(2830),
    [anon_sym_restrict] = ACTIONS(2830),
    [anon_sym___restrict__] = ACTIONS(2830),
    [anon_sym__Atomic] = ACTIONS(2830),
    [anon_sym__Noreturn] = ACTIONS(2830),
    [anon_sym_noreturn] = ACTIONS(2830),
    [anon_sym_mutable] = ACTIONS(2830),
    [anon_sym_constinit] = ACTIONS(2830),
    [anon_sym_consteval] = ACTIONS(2830),
    [anon_sym_alignas] = ACTIONS(2830),
    [anon_sym__Alignas] = ACTIONS(2830),
    [sym_primitive_type] = ACTIONS(2830),
    [anon_sym_enum] = ACTIONS(2830),
    [anon_sym_class] = ACTIONS(2830),
    [anon_sym_struct] = ACTIONS(2830),
    [anon_sym_union] = ACTIONS(2830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2830),
    [anon_sym_let] = ACTIONS(2830),
    [anon_sym_This] = ACTIONS(2830),
    [anon_sym_decltype] = ACTIONS(2830),
    [sym_virtual] = ACTIONS(2830),
    [anon_sym_explicit] = ACTIONS(2830),
    [anon_sym_typename] = ACTIONS(2830),
    [anon_sym_template] = ACTIONS(2830),
    [anon_sym_operator] = ACTIONS(2830),
    [anon_sym_friend] = ACTIONS(2830),
    [anon_sym_public] = ACTIONS(2830),
    [anon_sym_private] = ACTIONS(2830),
    [anon_sym_protected] = ACTIONS(2830),
    [anon_sym_using] = ACTIONS(2830),
    [anon_sym_static_assert] = ACTIONS(2830),
    [anon_sym_catch] = ACTIONS(5412),
    [anon_sym_precise] = ACTIONS(2830),
    [anon_sym_shared] = ACTIONS(2830),
    [anon_sym_groupshared] = ACTIONS(2830),
    [anon_sym_uniform] = ACTIONS(2830),
    [anon_sym_row_major] = ACTIONS(2830),
    [anon_sym_column_major] = ACTIONS(2830),
    [anon_sym_globallycoherent] = ACTIONS(2830),
    [anon_sym_centroid] = ACTIONS(2830),
    [anon_sym_noperspective] = ACTIONS(2830),
    [anon_sym_nointerpolation] = ACTIONS(2830),
    [anon_sym_sample] = ACTIONS(2830),
    [anon_sym_linear] = ACTIONS(2830),
    [anon_sym_snorm] = ACTIONS(2830),
    [anon_sym_unorm] = ACTIONS(2830),
    [anon_sym_point] = ACTIONS(2830),
    [anon_sym_line] = ACTIONS(2830),
    [anon_sym_triangleadj] = ACTIONS(2830),
    [anon_sym_lineadj] = ACTIONS(2830),
    [anon_sym_triangle] = ACTIONS(2830),
    [anon_sym_interface] = ACTIONS(2830),
    [anon_sym_extension] = ACTIONS(2830),
    [anon_sym___init] = ACTIONS(2830),
    [anon_sym___subscript] = ACTIONS(2830),
    [anon_sym_property] = ACTIONS(2830),
    [anon_sym_associatedtype] = ACTIONS(2830),
  },
  [1517] = {
    [sym_catch_clause] = STATE(1515),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1515),
    [sym_identifier] = ACTIONS(2677),
    [aux_sym_preproc_def_token1] = ACTIONS(2677),
    [aux_sym_preproc_if_token1] = ACTIONS(2677),
    [aux_sym_preproc_if_token2] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2677),
    [aux_sym_preproc_else_token1] = ACTIONS(2677),
    [aux_sym_preproc_elif_token1] = ACTIONS(2677),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2677),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2677),
    [sym_preproc_directive] = ACTIONS(2677),
    [anon_sym_LPAREN2] = ACTIONS(2679),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2679),
    [anon_sym_AMP_AMP] = ACTIONS(2679),
    [anon_sym_AMP] = ACTIONS(2677),
    [anon_sym___extension__] = ACTIONS(2677),
    [anon_sym_typedef] = ACTIONS(2677),
    [anon_sym_in] = ACTIONS(2677),
    [anon_sym_out] = ACTIONS(2677),
    [anon_sym_inout] = ACTIONS(2677),
    [anon_sym_extern] = ACTIONS(2677),
    [anon_sym___attribute__] = ACTIONS(2677),
    [anon_sym_COLON_COLON] = ACTIONS(2679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2679),
    [anon_sym___declspec] = ACTIONS(2677),
    [anon_sym___based] = ACTIONS(2677),
    [anon_sym_signed] = ACTIONS(2677),
    [anon_sym_unsigned] = ACTIONS(2677),
    [anon_sym_long] = ACTIONS(2677),
    [anon_sym_short] = ACTIONS(2677),
    [anon_sym_LBRACK] = ACTIONS(2677),
    [anon_sym_static] = ACTIONS(2677),
    [anon_sym_register] = ACTIONS(2677),
    [anon_sym_inline] = ACTIONS(2677),
    [anon_sym___inline] = ACTIONS(2677),
    [anon_sym___inline__] = ACTIONS(2677),
    [anon_sym___forceinline] = ACTIONS(2677),
    [anon_sym_thread_local] = ACTIONS(2677),
    [anon_sym___thread] = ACTIONS(2677),
    [anon_sym_const] = ACTIONS(2677),
    [anon_sym_constexpr] = ACTIONS(2677),
    [anon_sym_volatile] = ACTIONS(2677),
    [anon_sym_restrict] = ACTIONS(2677),
    [anon_sym___restrict__] = ACTIONS(2677),
    [anon_sym__Atomic] = ACTIONS(2677),
    [anon_sym__Noreturn] = ACTIONS(2677),
    [anon_sym_noreturn] = ACTIONS(2677),
    [anon_sym_mutable] = ACTIONS(2677),
    [anon_sym_constinit] = ACTIONS(2677),
    [anon_sym_consteval] = ACTIONS(2677),
    [anon_sym_alignas] = ACTIONS(2677),
    [anon_sym__Alignas] = ACTIONS(2677),
    [sym_primitive_type] = ACTIONS(2677),
    [anon_sym_enum] = ACTIONS(2677),
    [anon_sym_class] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(2677),
    [anon_sym_union] = ACTIONS(2677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2677),
    [anon_sym_let] = ACTIONS(2677),
    [anon_sym_This] = ACTIONS(2677),
    [anon_sym_decltype] = ACTIONS(2677),
    [sym_virtual] = ACTIONS(2677),
    [anon_sym_explicit] = ACTIONS(2677),
    [anon_sym_typename] = ACTIONS(2677),
    [anon_sym_template] = ACTIONS(2677),
    [anon_sym_operator] = ACTIONS(2677),
    [anon_sym_friend] = ACTIONS(2677),
    [anon_sym_public] = ACTIONS(2677),
    [anon_sym_private] = ACTIONS(2677),
    [anon_sym_protected] = ACTIONS(2677),
    [anon_sym_using] = ACTIONS(2677),
    [anon_sym_static_assert] = ACTIONS(2677),
    [anon_sym_catch] = ACTIONS(5412),
    [anon_sym_precise] = ACTIONS(2677),
    [anon_sym_shared] = ACTIONS(2677),
    [anon_sym_groupshared] = ACTIONS(2677),
    [anon_sym_uniform] = ACTIONS(2677),
    [anon_sym_row_major] = ACTIONS(2677),
    [anon_sym_column_major] = ACTIONS(2677),
    [anon_sym_globallycoherent] = ACTIONS(2677),
    [anon_sym_centroid] = ACTIONS(2677),
    [anon_sym_noperspective] = ACTIONS(2677),
    [anon_sym_nointerpolation] = ACTIONS(2677),
    [anon_sym_sample] = ACTIONS(2677),
    [anon_sym_linear] = ACTIONS(2677),
    [anon_sym_snorm] = ACTIONS(2677),
    [anon_sym_unorm] = ACTIONS(2677),
    [anon_sym_point] = ACTIONS(2677),
    [anon_sym_line] = ACTIONS(2677),
    [anon_sym_triangleadj] = ACTIONS(2677),
    [anon_sym_lineadj] = ACTIONS(2677),
    [anon_sym_triangle] = ACTIONS(2677),
    [anon_sym_interface] = ACTIONS(2677),
    [anon_sym_extension] = ACTIONS(2677),
    [anon_sym___init] = ACTIONS(2677),
    [anon_sym___subscript] = ACTIONS(2677),
    [anon_sym_property] = ACTIONS(2677),
    [anon_sym_associatedtype] = ACTIONS(2677),
  },
  [1518] = {
    [sym_catch_clause] = STATE(1515),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1515),
    [sym_identifier] = ACTIONS(2744),
    [aux_sym_preproc_def_token1] = ACTIONS(2744),
    [aux_sym_preproc_if_token1] = ACTIONS(2744),
    [aux_sym_preproc_if_token2] = ACTIONS(2744),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2744),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2744),
    [aux_sym_preproc_else_token1] = ACTIONS(2744),
    [aux_sym_preproc_elif_token1] = ACTIONS(2744),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2744),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2744),
    [sym_preproc_directive] = ACTIONS(2744),
    [anon_sym_LPAREN2] = ACTIONS(2746),
    [anon_sym_TILDE] = ACTIONS(2746),
    [anon_sym_STAR] = ACTIONS(2746),
    [anon_sym_AMP_AMP] = ACTIONS(2746),
    [anon_sym_AMP] = ACTIONS(2744),
    [anon_sym___extension__] = ACTIONS(2744),
    [anon_sym_typedef] = ACTIONS(2744),
    [anon_sym_in] = ACTIONS(2744),
    [anon_sym_out] = ACTIONS(2744),
    [anon_sym_inout] = ACTIONS(2744),
    [anon_sym_extern] = ACTIONS(2744),
    [anon_sym___attribute__] = ACTIONS(2744),
    [anon_sym_COLON_COLON] = ACTIONS(2746),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2746),
    [anon_sym___declspec] = ACTIONS(2744),
    [anon_sym___based] = ACTIONS(2744),
    [anon_sym_signed] = ACTIONS(2744),
    [anon_sym_unsigned] = ACTIONS(2744),
    [anon_sym_long] = ACTIONS(2744),
    [anon_sym_short] = ACTIONS(2744),
    [anon_sym_LBRACK] = ACTIONS(2744),
    [anon_sym_static] = ACTIONS(2744),
    [anon_sym_register] = ACTIONS(2744),
    [anon_sym_inline] = ACTIONS(2744),
    [anon_sym___inline] = ACTIONS(2744),
    [anon_sym___inline__] = ACTIONS(2744),
    [anon_sym___forceinline] = ACTIONS(2744),
    [anon_sym_thread_local] = ACTIONS(2744),
    [anon_sym___thread] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_constexpr] = ACTIONS(2744),
    [anon_sym_volatile] = ACTIONS(2744),
    [anon_sym_restrict] = ACTIONS(2744),
    [anon_sym___restrict__] = ACTIONS(2744),
    [anon_sym__Atomic] = ACTIONS(2744),
    [anon_sym__Noreturn] = ACTIONS(2744),
    [anon_sym_noreturn] = ACTIONS(2744),
    [anon_sym_mutable] = ACTIONS(2744),
    [anon_sym_constinit] = ACTIONS(2744),
    [anon_sym_consteval] = ACTIONS(2744),
    [anon_sym_alignas] = ACTIONS(2744),
    [anon_sym__Alignas] = ACTIONS(2744),
    [sym_primitive_type] = ACTIONS(2744),
    [anon_sym_enum] = ACTIONS(2744),
    [anon_sym_class] = ACTIONS(2744),
    [anon_sym_struct] = ACTIONS(2744),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2744),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_This] = ACTIONS(2744),
    [anon_sym_decltype] = ACTIONS(2744),
    [sym_virtual] = ACTIONS(2744),
    [anon_sym_explicit] = ACTIONS(2744),
    [anon_sym_typename] = ACTIONS(2744),
    [anon_sym_template] = ACTIONS(2744),
    [anon_sym_operator] = ACTIONS(2744),
    [anon_sym_friend] = ACTIONS(2744),
    [anon_sym_public] = ACTIONS(2744),
    [anon_sym_private] = ACTIONS(2744),
    [anon_sym_protected] = ACTIONS(2744),
    [anon_sym_using] = ACTIONS(2744),
    [anon_sym_static_assert] = ACTIONS(2744),
    [anon_sym_catch] = ACTIONS(5412),
    [anon_sym_precise] = ACTIONS(2744),
    [anon_sym_shared] = ACTIONS(2744),
    [anon_sym_groupshared] = ACTIONS(2744),
    [anon_sym_uniform] = ACTIONS(2744),
    [anon_sym_row_major] = ACTIONS(2744),
    [anon_sym_column_major] = ACTIONS(2744),
    [anon_sym_globallycoherent] = ACTIONS(2744),
    [anon_sym_centroid] = ACTIONS(2744),
    [anon_sym_noperspective] = ACTIONS(2744),
    [anon_sym_nointerpolation] = ACTIONS(2744),
    [anon_sym_sample] = ACTIONS(2744),
    [anon_sym_linear] = ACTIONS(2744),
    [anon_sym_snorm] = ACTIONS(2744),
    [anon_sym_unorm] = ACTIONS(2744),
    [anon_sym_point] = ACTIONS(2744),
    [anon_sym_line] = ACTIONS(2744),
    [anon_sym_triangleadj] = ACTIONS(2744),
    [anon_sym_lineadj] = ACTIONS(2744),
    [anon_sym_triangle] = ACTIONS(2744),
    [anon_sym_interface] = ACTIONS(2744),
    [anon_sym_extension] = ACTIONS(2744),
    [anon_sym___init] = ACTIONS(2744),
    [anon_sym___subscript] = ACTIONS(2744),
    [anon_sym_property] = ACTIONS(2744),
    [anon_sym_associatedtype] = ACTIONS(2744),
  },
  [1519] = {
    [sym__declaration_modifiers] = STATE(2299),
    [sym__declaration_specifiers] = STATE(4856),
    [sym_attribute_specifier] = STATE(2299),
    [sym_attribute_declaration] = STATE(2299),
    [sym_ms_declspec_modifier] = STATE(2299),
    [sym_storage_class_specifier] = STATE(2299),
    [sym_type_qualifier] = STATE(2299),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2694),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_parameter_declaration] = STATE(9600),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_optional_parameter_declaration] = STATE(9600),
    [sym_variadic_parameter_declaration] = STATE(9600),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8090),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2299),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2299),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(5014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5414),
    [anon_sym_RPAREN] = ACTIONS(5416),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_out] = ACTIONS(2293),
    [anon_sym_inout] = ACTIONS(2293),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(5024),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2299),
    [anon_sym_class] = ACTIONS(2301),
    [anon_sym_struct] = ACTIONS(2303),
    [anon_sym_union] = ACTIONS(2305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(2293),
    [anon_sym_typename] = ACTIONS(2329),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2341),
    [anon_sym_extension] = ACTIONS(2343),
  },
  [1520] = {
    [sym_identifier] = ACTIONS(2359),
    [aux_sym_preproc_def_token1] = ACTIONS(2359),
    [anon_sym_COMMA] = ACTIONS(3834),
    [aux_sym_preproc_if_token1] = ACTIONS(2359),
    [aux_sym_preproc_if_token2] = ACTIONS(2359),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2359),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2359),
    [aux_sym_preproc_else_token1] = ACTIONS(2359),
    [aux_sym_preproc_elif_token1] = ACTIONS(2359),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2359),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2359),
    [sym_preproc_directive] = ACTIONS(2359),
    [anon_sym_LPAREN2] = ACTIONS(2357),
    [anon_sym_TILDE] = ACTIONS(2357),
    [anon_sym_STAR] = ACTIONS(2357),
    [anon_sym_AMP_AMP] = ACTIONS(2357),
    [anon_sym_AMP] = ACTIONS(2359),
    [anon_sym_SEMI] = ACTIONS(3834),
    [anon_sym___extension__] = ACTIONS(2359),
    [anon_sym_typedef] = ACTIONS(2359),
    [anon_sym_in] = ACTIONS(2359),
    [anon_sym_out] = ACTIONS(2359),
    [anon_sym_inout] = ACTIONS(2359),
    [anon_sym_extern] = ACTIONS(2359),
    [anon_sym___attribute__] = ACTIONS(5418),
    [anon_sym_COLON_COLON] = ACTIONS(2357),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2357),
    [anon_sym___declspec] = ACTIONS(2359),
    [anon_sym___based] = ACTIONS(2359),
    [anon_sym_signed] = ACTIONS(2359),
    [anon_sym_unsigned] = ACTIONS(2359),
    [anon_sym_long] = ACTIONS(2359),
    [anon_sym_short] = ACTIONS(2359),
    [anon_sym_LBRACK] = ACTIONS(2359),
    [anon_sym_static] = ACTIONS(2359),
    [anon_sym_register] = ACTIONS(2359),
    [anon_sym_inline] = ACTIONS(2359),
    [anon_sym___inline] = ACTIONS(2359),
    [anon_sym___inline__] = ACTIONS(2359),
    [anon_sym___forceinline] = ACTIONS(2359),
    [anon_sym_thread_local] = ACTIONS(2359),
    [anon_sym___thread] = ACTIONS(2359),
    [anon_sym_const] = ACTIONS(2359),
    [anon_sym_constexpr] = ACTIONS(2359),
    [anon_sym_volatile] = ACTIONS(2359),
    [anon_sym_restrict] = ACTIONS(2359),
    [anon_sym___restrict__] = ACTIONS(2359),
    [anon_sym__Atomic] = ACTIONS(2359),
    [anon_sym__Noreturn] = ACTIONS(2359),
    [anon_sym_noreturn] = ACTIONS(2359),
    [anon_sym_mutable] = ACTIONS(2359),
    [anon_sym_constinit] = ACTIONS(2359),
    [anon_sym_consteval] = ACTIONS(2359),
    [anon_sym_alignas] = ACTIONS(2359),
    [anon_sym__Alignas] = ACTIONS(2359),
    [sym_primitive_type] = ACTIONS(2359),
    [anon_sym_enum] = ACTIONS(2359),
    [anon_sym_class] = ACTIONS(2359),
    [anon_sym_struct] = ACTIONS(2359),
    [anon_sym_union] = ACTIONS(2359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2359),
    [anon_sym_let] = ACTIONS(2359),
    [anon_sym_This] = ACTIONS(2359),
    [anon_sym_decltype] = ACTIONS(2359),
    [sym_virtual] = ACTIONS(2359),
    [anon_sym_explicit] = ACTIONS(2359),
    [anon_sym_typename] = ACTIONS(2359),
    [anon_sym_template] = ACTIONS(2359),
    [anon_sym_operator] = ACTIONS(2359),
    [anon_sym_friend] = ACTIONS(2359),
    [anon_sym_public] = ACTIONS(2359),
    [anon_sym_private] = ACTIONS(2359),
    [anon_sym_protected] = ACTIONS(2359),
    [anon_sym_using] = ACTIONS(2359),
    [anon_sym_static_assert] = ACTIONS(2359),
    [anon_sym_precise] = ACTIONS(2359),
    [anon_sym_shared] = ACTIONS(2359),
    [anon_sym_groupshared] = ACTIONS(2359),
    [anon_sym_uniform] = ACTIONS(2359),
    [anon_sym_row_major] = ACTIONS(2359),
    [anon_sym_column_major] = ACTIONS(2359),
    [anon_sym_globallycoherent] = ACTIONS(2359),
    [anon_sym_centroid] = ACTIONS(2359),
    [anon_sym_noperspective] = ACTIONS(2359),
    [anon_sym_nointerpolation] = ACTIONS(2359),
    [anon_sym_sample] = ACTIONS(2359),
    [anon_sym_linear] = ACTIONS(2359),
    [anon_sym_snorm] = ACTIONS(2359),
    [anon_sym_unorm] = ACTIONS(2359),
    [anon_sym_point] = ACTIONS(2359),
    [anon_sym_line] = ACTIONS(2359),
    [anon_sym_triangleadj] = ACTIONS(2359),
    [anon_sym_lineadj] = ACTIONS(2359),
    [anon_sym_triangle] = ACTIONS(2359),
    [anon_sym_interface] = ACTIONS(2359),
    [anon_sym_extension] = ACTIONS(2359),
    [anon_sym___init] = ACTIONS(2359),
    [anon_sym___subscript] = ACTIONS(2359),
    [anon_sym_property] = ACTIONS(2359),
    [anon_sym_associatedtype] = ACTIONS(2359),
  },
  [1521] = {
    [sym__declaration_modifiers] = STATE(2299),
    [sym__declaration_specifiers] = STATE(4856),
    [sym_attribute_specifier] = STATE(2299),
    [sym_attribute_declaration] = STATE(2299),
    [sym_ms_declspec_modifier] = STATE(2299),
    [sym_storage_class_specifier] = STATE(2299),
    [sym_type_qualifier] = STATE(2299),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2694),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_parameter_declaration] = STATE(9475),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_optional_parameter_declaration] = STATE(9475),
    [sym_variadic_parameter_declaration] = STATE(9475),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8090),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2299),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2299),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(5014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4879),
    [anon_sym_RPAREN] = ACTIONS(4881),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_out] = ACTIONS(2293),
    [anon_sym_inout] = ACTIONS(2293),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(5024),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2299),
    [anon_sym_class] = ACTIONS(2301),
    [anon_sym_struct] = ACTIONS(2303),
    [anon_sym_union] = ACTIONS(2305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(2293),
    [anon_sym_typename] = ACTIONS(2329),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2341),
    [anon_sym_extension] = ACTIONS(2343),
  },
  [1522] = {
    [sym__declaration_modifiers] = STATE(2299),
    [sym__declaration_specifiers] = STATE(4856),
    [sym_attribute_specifier] = STATE(2299),
    [sym_attribute_declaration] = STATE(2299),
    [sym_ms_declspec_modifier] = STATE(2299),
    [sym_storage_class_specifier] = STATE(2299),
    [sym_type_qualifier] = STATE(2299),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2694),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_parameter_declaration] = STATE(9450),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_optional_parameter_declaration] = STATE(9450),
    [sym_variadic_parameter_declaration] = STATE(9450),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8090),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2299),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2299),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(5014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5420),
    [anon_sym_RPAREN] = ACTIONS(5422),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_out] = ACTIONS(2293),
    [anon_sym_inout] = ACTIONS(2293),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(5024),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2299),
    [anon_sym_class] = ACTIONS(2301),
    [anon_sym_struct] = ACTIONS(2303),
    [anon_sym_union] = ACTIONS(2305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(2293),
    [anon_sym_typename] = ACTIONS(2329),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2341),
    [anon_sym_extension] = ACTIONS(2343),
  },
  [1523] = {
    [sym__declaration_modifiers] = STATE(2299),
    [sym__declaration_specifiers] = STATE(4856),
    [sym_attribute_specifier] = STATE(2299),
    [sym_attribute_declaration] = STATE(2299),
    [sym_ms_declspec_modifier] = STATE(2299),
    [sym_storage_class_specifier] = STATE(2299),
    [sym_type_qualifier] = STATE(2299),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2694),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_parameter_declaration] = STATE(9230),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_optional_parameter_declaration] = STATE(9230),
    [sym_variadic_parameter_declaration] = STATE(9230),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8090),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2299),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2299),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(5014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5424),
    [anon_sym_RPAREN] = ACTIONS(5426),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_out] = ACTIONS(2293),
    [anon_sym_inout] = ACTIONS(2293),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(5024),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2299),
    [anon_sym_class] = ACTIONS(2301),
    [anon_sym_struct] = ACTIONS(2303),
    [anon_sym_union] = ACTIONS(2305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(2293),
    [anon_sym_typename] = ACTIONS(2329),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2341),
    [anon_sym_extension] = ACTIONS(2343),
  },
  [1524] = {
    [sym_compound_statement] = STATE(9386),
    [sym_expression] = STATE(5229),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(9386),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_RPAREN] = ACTIONS(5428),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(5430),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(5432),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1525] = {
    [sym_identifier] = ACTIONS(2842),
    [aux_sym_preproc_def_token1] = ACTIONS(2842),
    [aux_sym_preproc_if_token1] = ACTIONS(2842),
    [aux_sym_preproc_if_token2] = ACTIONS(2842),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2842),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2842),
    [aux_sym_preproc_else_token1] = ACTIONS(2842),
    [aux_sym_preproc_elif_token1] = ACTIONS(2842),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2842),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2842),
    [sym_preproc_directive] = ACTIONS(2842),
    [anon_sym_LPAREN2] = ACTIONS(2844),
    [anon_sym_TILDE] = ACTIONS(2844),
    [anon_sym_STAR] = ACTIONS(2844),
    [anon_sym_AMP_AMP] = ACTIONS(2844),
    [anon_sym_AMP] = ACTIONS(2842),
    [anon_sym___extension__] = ACTIONS(2842),
    [anon_sym_typedef] = ACTIONS(2842),
    [anon_sym_in] = ACTIONS(2842),
    [anon_sym_out] = ACTIONS(2842),
    [anon_sym_inout] = ACTIONS(2842),
    [anon_sym_extern] = ACTIONS(2842),
    [anon_sym___attribute__] = ACTIONS(2842),
    [anon_sym_COLON_COLON] = ACTIONS(2844),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2844),
    [anon_sym___declspec] = ACTIONS(2842),
    [anon_sym___based] = ACTIONS(2842),
    [anon_sym_signed] = ACTIONS(2842),
    [anon_sym_unsigned] = ACTIONS(2842),
    [anon_sym_long] = ACTIONS(2842),
    [anon_sym_short] = ACTIONS(2842),
    [anon_sym_LBRACK] = ACTIONS(2842),
    [anon_sym_static] = ACTIONS(2842),
    [anon_sym_register] = ACTIONS(2842),
    [anon_sym_inline] = ACTIONS(2842),
    [anon_sym___inline] = ACTIONS(2842),
    [anon_sym___inline__] = ACTIONS(2842),
    [anon_sym___forceinline] = ACTIONS(2842),
    [anon_sym_thread_local] = ACTIONS(2842),
    [anon_sym___thread] = ACTIONS(2842),
    [anon_sym_const] = ACTIONS(2842),
    [anon_sym_constexpr] = ACTIONS(2842),
    [anon_sym_volatile] = ACTIONS(2842),
    [anon_sym_restrict] = ACTIONS(2842),
    [anon_sym___restrict__] = ACTIONS(2842),
    [anon_sym__Atomic] = ACTIONS(2842),
    [anon_sym__Noreturn] = ACTIONS(2842),
    [anon_sym_noreturn] = ACTIONS(2842),
    [anon_sym_mutable] = ACTIONS(2842),
    [anon_sym_constinit] = ACTIONS(2842),
    [anon_sym_consteval] = ACTIONS(2842),
    [anon_sym_alignas] = ACTIONS(2842),
    [anon_sym__Alignas] = ACTIONS(2842),
    [sym_primitive_type] = ACTIONS(2842),
    [anon_sym_enum] = ACTIONS(2842),
    [anon_sym_class] = ACTIONS(2842),
    [anon_sym_struct] = ACTIONS(2842),
    [anon_sym_union] = ACTIONS(2842),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2842),
    [anon_sym_let] = ACTIONS(2842),
    [anon_sym_This] = ACTIONS(2842),
    [anon_sym_decltype] = ACTIONS(2842),
    [sym_virtual] = ACTIONS(2842),
    [anon_sym_explicit] = ACTIONS(2842),
    [anon_sym_typename] = ACTIONS(2842),
    [anon_sym_template] = ACTIONS(2842),
    [anon_sym_operator] = ACTIONS(2842),
    [anon_sym_friend] = ACTIONS(2842),
    [anon_sym_public] = ACTIONS(2842),
    [anon_sym_private] = ACTIONS(2842),
    [anon_sym_protected] = ACTIONS(2842),
    [anon_sym_using] = ACTIONS(2842),
    [anon_sym_static_assert] = ACTIONS(2842),
    [anon_sym_catch] = ACTIONS(2842),
    [anon_sym_precise] = ACTIONS(2842),
    [anon_sym_shared] = ACTIONS(2842),
    [anon_sym_groupshared] = ACTIONS(2842),
    [anon_sym_uniform] = ACTIONS(2842),
    [anon_sym_row_major] = ACTIONS(2842),
    [anon_sym_column_major] = ACTIONS(2842),
    [anon_sym_globallycoherent] = ACTIONS(2842),
    [anon_sym_centroid] = ACTIONS(2842),
    [anon_sym_noperspective] = ACTIONS(2842),
    [anon_sym_nointerpolation] = ACTIONS(2842),
    [anon_sym_sample] = ACTIONS(2842),
    [anon_sym_linear] = ACTIONS(2842),
    [anon_sym_snorm] = ACTIONS(2842),
    [anon_sym_unorm] = ACTIONS(2842),
    [anon_sym_point] = ACTIONS(2842),
    [anon_sym_line] = ACTIONS(2842),
    [anon_sym_triangleadj] = ACTIONS(2842),
    [anon_sym_lineadj] = ACTIONS(2842),
    [anon_sym_triangle] = ACTIONS(2842),
    [anon_sym_interface] = ACTIONS(2842),
    [anon_sym_extension] = ACTIONS(2842),
    [anon_sym___init] = ACTIONS(2842),
    [anon_sym___subscript] = ACTIONS(2842),
    [anon_sym_property] = ACTIONS(2842),
    [anon_sym_associatedtype] = ACTIONS(2842),
  },
  [1526] = {
    [sym_compound_statement] = STATE(9594),
    [sym_expression] = STATE(5126),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(9594),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_RPAREN] = ACTIONS(5434),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(5436),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(5432),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1527] = {
    [sym_identifier] = ACTIONS(2210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2212),
    [anon_sym_COMMA] = ACTIONS(2212),
    [anon_sym_RPAREN] = ACTIONS(2212),
    [anon_sym_LPAREN2] = ACTIONS(2214),
    [anon_sym_TILDE] = ACTIONS(2217),
    [anon_sym_DASH] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(2222),
    [anon_sym_STAR] = ACTIONS(2214),
    [anon_sym_SLASH] = ACTIONS(2222),
    [anon_sym_PERCENT] = ACTIONS(2212),
    [anon_sym_PIPE_PIPE] = ACTIONS(2212),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2222),
    [anon_sym_CARET] = ACTIONS(2212),
    [anon_sym_AMP] = ACTIONS(2219),
    [anon_sym_EQ_EQ] = ACTIONS(2212),
    [anon_sym_BANG_EQ] = ACTIONS(2212),
    [anon_sym_GT] = ACTIONS(2222),
    [anon_sym_GT_EQ] = ACTIONS(2212),
    [anon_sym_LT_EQ] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(2222),
    [anon_sym_LT_LT] = ACTIONS(2212),
    [anon_sym_GT_GT] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2212),
    [anon_sym___extension__] = ACTIONS(2210),
    [anon_sym_in] = ACTIONS(2210),
    [anon_sym_out] = ACTIONS(2210),
    [anon_sym_inout] = ACTIONS(2210),
    [anon_sym_extern] = ACTIONS(2210),
    [anon_sym___attribute__] = ACTIONS(2210),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2217),
    [anon_sym___declspec] = ACTIONS(2210),
    [anon_sym___based] = ACTIONS(2210),
    [anon_sym_LBRACE] = ACTIONS(2217),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_static] = ACTIONS(2210),
    [anon_sym_register] = ACTIONS(2210),
    [anon_sym_inline] = ACTIONS(2210),
    [anon_sym___inline] = ACTIONS(2210),
    [anon_sym___inline__] = ACTIONS(2210),
    [anon_sym___forceinline] = ACTIONS(2210),
    [anon_sym_thread_local] = ACTIONS(2210),
    [anon_sym___thread] = ACTIONS(2210),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_constexpr] = ACTIONS(2210),
    [anon_sym_volatile] = ACTIONS(2210),
    [anon_sym_restrict] = ACTIONS(2210),
    [anon_sym___restrict__] = ACTIONS(2210),
    [anon_sym__Atomic] = ACTIONS(2210),
    [anon_sym__Noreturn] = ACTIONS(2210),
    [anon_sym_noreturn] = ACTIONS(2210),
    [anon_sym_mutable] = ACTIONS(2210),
    [anon_sym_constinit] = ACTIONS(2210),
    [anon_sym_consteval] = ACTIONS(2210),
    [anon_sym_alignas] = ACTIONS(2210),
    [anon_sym__Alignas] = ACTIONS(2210),
    [anon_sym_QMARK] = ACTIONS(2212),
    [anon_sym_LT_EQ_GT] = ACTIONS(2212),
    [anon_sym_or] = ACTIONS(2222),
    [anon_sym_and] = ACTIONS(2222),
    [anon_sym_bitor] = ACTIONS(2222),
    [anon_sym_xor] = ACTIONS(2222),
    [anon_sym_bitand] = ACTIONS(2222),
    [anon_sym_not_eq] = ACTIONS(2222),
    [anon_sym_is] = ACTIONS(2222),
    [anon_sym_as] = ACTIONS(2222),
    [anon_sym_DASH_DASH] = ACTIONS(2212),
    [anon_sym_PLUS_PLUS] = ACTIONS(2212),
    [anon_sym_DOT] = ACTIONS(2219),
    [anon_sym_DOT_STAR] = ACTIONS(2212),
    [anon_sym_DASH_GT] = ACTIONS(2212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2210),
    [anon_sym_let] = ACTIONS(2210),
    [anon_sym_This] = ACTIONS(2210),
    [anon_sym_decltype] = ACTIONS(2210),
    [sym_virtual] = ACTIONS(2210),
    [anon_sym_template] = ACTIONS(2210),
    [anon_sym_operator] = ACTIONS(2210),
    [anon_sym_precise] = ACTIONS(2210),
    [anon_sym_shared] = ACTIONS(2210),
    [anon_sym_groupshared] = ACTIONS(2210),
    [anon_sym_uniform] = ACTIONS(2210),
    [anon_sym_row_major] = ACTIONS(2210),
    [anon_sym_column_major] = ACTIONS(2210),
    [anon_sym_globallycoherent] = ACTIONS(2210),
    [anon_sym_centroid] = ACTIONS(2210),
    [anon_sym_noperspective] = ACTIONS(2210),
    [anon_sym_nointerpolation] = ACTIONS(2210),
    [anon_sym_sample] = ACTIONS(2210),
    [anon_sym_linear] = ACTIONS(2210),
    [anon_sym_snorm] = ACTIONS(2210),
    [anon_sym_unorm] = ACTIONS(2210),
    [anon_sym_point] = ACTIONS(2210),
    [anon_sym_line] = ACTIONS(2210),
    [anon_sym_triangleadj] = ACTIONS(2210),
    [anon_sym_lineadj] = ACTIONS(2210),
    [anon_sym_triangle] = ACTIONS(2210),
  },
  [1528] = {
    [sym__declaration_modifiers] = STATE(2299),
    [sym__declaration_specifiers] = STATE(4856),
    [sym_attribute_specifier] = STATE(2299),
    [sym_attribute_declaration] = STATE(2299),
    [sym_ms_declspec_modifier] = STATE(2299),
    [sym_storage_class_specifier] = STATE(2299),
    [sym_type_qualifier] = STATE(2299),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2694),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_parameter_declaration] = STATE(9395),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_optional_parameter_declaration] = STATE(9395),
    [sym_variadic_parameter_declaration] = STATE(9395),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8090),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2299),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2299),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(5014),
    [anon_sym_RPAREN] = ACTIONS(2283),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_out] = ACTIONS(2293),
    [anon_sym_inout] = ACTIONS(2293),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(5024),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2299),
    [anon_sym_class] = ACTIONS(2301),
    [anon_sym_struct] = ACTIONS(2303),
    [anon_sym_union] = ACTIONS(2305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(2293),
    [anon_sym_typename] = ACTIONS(2329),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2341),
    [anon_sym_extension] = ACTIONS(2343),
  },
  [1529] = {
    [sym_compound_statement] = STATE(9439),
    [sym_expression] = STATE(5128),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(9439),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_RPAREN] = ACTIONS(5438),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(5440),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(5432),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1530] = {
    [sym__declaration_modifiers] = STATE(2299),
    [sym__declaration_specifiers] = STATE(4856),
    [sym_attribute_specifier] = STATE(2299),
    [sym_attribute_declaration] = STATE(2299),
    [sym_ms_declspec_modifier] = STATE(2299),
    [sym_storage_class_specifier] = STATE(2299),
    [sym_type_qualifier] = STATE(2299),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2694),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_parameter_declaration] = STATE(9837),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_optional_parameter_declaration] = STATE(9837),
    [sym_variadic_parameter_declaration] = STATE(9837),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8090),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2299),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2299),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(5014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5442),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_out] = ACTIONS(2293),
    [anon_sym_inout] = ACTIONS(2293),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(5024),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2299),
    [anon_sym_class] = ACTIONS(2301),
    [anon_sym_struct] = ACTIONS(2303),
    [anon_sym_union] = ACTIONS(2305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(2293),
    [anon_sym_typename] = ACTIONS(2329),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2341),
    [anon_sym_extension] = ACTIONS(2343),
  },
  [1531] = {
    [sym_identifier] = ACTIONS(2359),
    [aux_sym_preproc_def_token1] = ACTIONS(2359),
    [aux_sym_preproc_if_token1] = ACTIONS(2359),
    [aux_sym_preproc_if_token2] = ACTIONS(2359),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2359),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2359),
    [aux_sym_preproc_else_token1] = ACTIONS(2359),
    [aux_sym_preproc_elif_token1] = ACTIONS(2359),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2359),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2359),
    [sym_preproc_directive] = ACTIONS(2359),
    [anon_sym_LPAREN2] = ACTIONS(2357),
    [anon_sym_TILDE] = ACTIONS(2357),
    [anon_sym_STAR] = ACTIONS(2357),
    [anon_sym_AMP_AMP] = ACTIONS(2357),
    [anon_sym_AMP] = ACTIONS(2359),
    [anon_sym___extension__] = ACTIONS(2359),
    [anon_sym_typedef] = ACTIONS(2359),
    [anon_sym_in] = ACTIONS(2359),
    [anon_sym_out] = ACTIONS(2359),
    [anon_sym_inout] = ACTIONS(2359),
    [anon_sym_extern] = ACTIONS(2359),
    [anon_sym___attribute__] = ACTIONS(2359),
    [anon_sym_COLON_COLON] = ACTIONS(2357),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2357),
    [anon_sym___declspec] = ACTIONS(2359),
    [anon_sym___based] = ACTIONS(2359),
    [anon_sym_signed] = ACTIONS(2359),
    [anon_sym_unsigned] = ACTIONS(2359),
    [anon_sym_long] = ACTIONS(2359),
    [anon_sym_short] = ACTIONS(2359),
    [anon_sym_LBRACK] = ACTIONS(2359),
    [anon_sym_static] = ACTIONS(2359),
    [anon_sym_register] = ACTIONS(2359),
    [anon_sym_inline] = ACTIONS(2359),
    [anon_sym___inline] = ACTIONS(2359),
    [anon_sym___inline__] = ACTIONS(2359),
    [anon_sym___forceinline] = ACTIONS(2359),
    [anon_sym_thread_local] = ACTIONS(2359),
    [anon_sym___thread] = ACTIONS(2359),
    [anon_sym_const] = ACTIONS(2359),
    [anon_sym_constexpr] = ACTIONS(2359),
    [anon_sym_volatile] = ACTIONS(2359),
    [anon_sym_restrict] = ACTIONS(2359),
    [anon_sym___restrict__] = ACTIONS(2359),
    [anon_sym__Atomic] = ACTIONS(2359),
    [anon_sym__Noreturn] = ACTIONS(2359),
    [anon_sym_noreturn] = ACTIONS(2359),
    [anon_sym_mutable] = ACTIONS(2359),
    [anon_sym_constinit] = ACTIONS(2359),
    [anon_sym_consteval] = ACTIONS(2359),
    [anon_sym_alignas] = ACTIONS(2359),
    [anon_sym__Alignas] = ACTIONS(2359),
    [sym_primitive_type] = ACTIONS(2359),
    [anon_sym_enum] = ACTIONS(2359),
    [anon_sym_class] = ACTIONS(2359),
    [anon_sym_struct] = ACTIONS(2359),
    [anon_sym_union] = ACTIONS(2359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2359),
    [anon_sym_let] = ACTIONS(2359),
    [anon_sym_This] = ACTIONS(2359),
    [anon_sym_decltype] = ACTIONS(2359),
    [sym_virtual] = ACTIONS(2359),
    [anon_sym_explicit] = ACTIONS(2359),
    [anon_sym_typename] = ACTIONS(2359),
    [anon_sym_template] = ACTIONS(2359),
    [anon_sym_operator] = ACTIONS(2359),
    [anon_sym_friend] = ACTIONS(2359),
    [anon_sym_public] = ACTIONS(2359),
    [anon_sym_private] = ACTIONS(2359),
    [anon_sym_protected] = ACTIONS(2359),
    [anon_sym_using] = ACTIONS(2359),
    [anon_sym_static_assert] = ACTIONS(2359),
    [anon_sym_catch] = ACTIONS(2359),
    [anon_sym_precise] = ACTIONS(2359),
    [anon_sym_shared] = ACTIONS(2359),
    [anon_sym_groupshared] = ACTIONS(2359),
    [anon_sym_uniform] = ACTIONS(2359),
    [anon_sym_row_major] = ACTIONS(2359),
    [anon_sym_column_major] = ACTIONS(2359),
    [anon_sym_globallycoherent] = ACTIONS(2359),
    [anon_sym_centroid] = ACTIONS(2359),
    [anon_sym_noperspective] = ACTIONS(2359),
    [anon_sym_nointerpolation] = ACTIONS(2359),
    [anon_sym_sample] = ACTIONS(2359),
    [anon_sym_linear] = ACTIONS(2359),
    [anon_sym_snorm] = ACTIONS(2359),
    [anon_sym_unorm] = ACTIONS(2359),
    [anon_sym_point] = ACTIONS(2359),
    [anon_sym_line] = ACTIONS(2359),
    [anon_sym_triangleadj] = ACTIONS(2359),
    [anon_sym_lineadj] = ACTIONS(2359),
    [anon_sym_triangle] = ACTIONS(2359),
    [anon_sym_interface] = ACTIONS(2359),
    [anon_sym_extension] = ACTIONS(2359),
    [anon_sym___init] = ACTIONS(2359),
    [anon_sym___subscript] = ACTIONS(2359),
    [anon_sym_property] = ACTIONS(2359),
    [anon_sym_associatedtype] = ACTIONS(2359),
  },
  [1532] = {
    [sym_identifier] = ACTIONS(2355),
    [aux_sym_preproc_def_token1] = ACTIONS(2355),
    [aux_sym_preproc_if_token1] = ACTIONS(2355),
    [aux_sym_preproc_if_token2] = ACTIONS(2355),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2355),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2355),
    [aux_sym_preproc_else_token1] = ACTIONS(2355),
    [aux_sym_preproc_elif_token1] = ACTIONS(2355),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2355),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2355),
    [sym_preproc_directive] = ACTIONS(2355),
    [anon_sym_LPAREN2] = ACTIONS(2353),
    [anon_sym_TILDE] = ACTIONS(2353),
    [anon_sym_STAR] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(2353),
    [anon_sym_AMP] = ACTIONS(2355),
    [anon_sym___extension__] = ACTIONS(2355),
    [anon_sym_typedef] = ACTIONS(2355),
    [anon_sym_in] = ACTIONS(2355),
    [anon_sym_out] = ACTIONS(2355),
    [anon_sym_inout] = ACTIONS(2355),
    [anon_sym_extern] = ACTIONS(2355),
    [anon_sym___attribute__] = ACTIONS(2355),
    [anon_sym_COLON_COLON] = ACTIONS(2353),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2353),
    [anon_sym___declspec] = ACTIONS(2355),
    [anon_sym___based] = ACTIONS(2355),
    [anon_sym_signed] = ACTIONS(2355),
    [anon_sym_unsigned] = ACTIONS(2355),
    [anon_sym_long] = ACTIONS(2355),
    [anon_sym_short] = ACTIONS(2355),
    [anon_sym_LBRACK] = ACTIONS(2355),
    [anon_sym_static] = ACTIONS(2355),
    [anon_sym_register] = ACTIONS(2355),
    [anon_sym_inline] = ACTIONS(2355),
    [anon_sym___inline] = ACTIONS(2355),
    [anon_sym___inline__] = ACTIONS(2355),
    [anon_sym___forceinline] = ACTIONS(2355),
    [anon_sym_thread_local] = ACTIONS(2355),
    [anon_sym___thread] = ACTIONS(2355),
    [anon_sym_const] = ACTIONS(2355),
    [anon_sym_constexpr] = ACTIONS(2355),
    [anon_sym_volatile] = ACTIONS(2355),
    [anon_sym_restrict] = ACTIONS(2355),
    [anon_sym___restrict__] = ACTIONS(2355),
    [anon_sym__Atomic] = ACTIONS(2355),
    [anon_sym__Noreturn] = ACTIONS(2355),
    [anon_sym_noreturn] = ACTIONS(2355),
    [anon_sym_mutable] = ACTIONS(2355),
    [anon_sym_constinit] = ACTIONS(2355),
    [anon_sym_consteval] = ACTIONS(2355),
    [anon_sym_alignas] = ACTIONS(2355),
    [anon_sym__Alignas] = ACTIONS(2355),
    [sym_primitive_type] = ACTIONS(2355),
    [anon_sym_enum] = ACTIONS(2355),
    [anon_sym_class] = ACTIONS(2355),
    [anon_sym_struct] = ACTIONS(2355),
    [anon_sym_union] = ACTIONS(2355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2355),
    [anon_sym_let] = ACTIONS(2355),
    [anon_sym_This] = ACTIONS(2355),
    [anon_sym_decltype] = ACTIONS(2355),
    [sym_virtual] = ACTIONS(2355),
    [anon_sym_explicit] = ACTIONS(2355),
    [anon_sym_typename] = ACTIONS(2355),
    [anon_sym_template] = ACTIONS(2355),
    [anon_sym_operator] = ACTIONS(2355),
    [anon_sym_friend] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2355),
    [anon_sym_private] = ACTIONS(2355),
    [anon_sym_protected] = ACTIONS(2355),
    [anon_sym_using] = ACTIONS(2355),
    [anon_sym_static_assert] = ACTIONS(2355),
    [anon_sym_catch] = ACTIONS(2355),
    [anon_sym_precise] = ACTIONS(2355),
    [anon_sym_shared] = ACTIONS(2355),
    [anon_sym_groupshared] = ACTIONS(2355),
    [anon_sym_uniform] = ACTIONS(2355),
    [anon_sym_row_major] = ACTIONS(2355),
    [anon_sym_column_major] = ACTIONS(2355),
    [anon_sym_globallycoherent] = ACTIONS(2355),
    [anon_sym_centroid] = ACTIONS(2355),
    [anon_sym_noperspective] = ACTIONS(2355),
    [anon_sym_nointerpolation] = ACTIONS(2355),
    [anon_sym_sample] = ACTIONS(2355),
    [anon_sym_linear] = ACTIONS(2355),
    [anon_sym_snorm] = ACTIONS(2355),
    [anon_sym_unorm] = ACTIONS(2355),
    [anon_sym_point] = ACTIONS(2355),
    [anon_sym_line] = ACTIONS(2355),
    [anon_sym_triangleadj] = ACTIONS(2355),
    [anon_sym_lineadj] = ACTIONS(2355),
    [anon_sym_triangle] = ACTIONS(2355),
    [anon_sym_interface] = ACTIONS(2355),
    [anon_sym_extension] = ACTIONS(2355),
    [anon_sym___init] = ACTIONS(2355),
    [anon_sym___subscript] = ACTIONS(2355),
    [anon_sym_property] = ACTIONS(2355),
    [anon_sym_associatedtype] = ACTIONS(2355),
  },
  [1533] = {
    [sym_compound_statement] = STATE(9248),
    [sym_expression] = STATE(5171),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(9248),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_RPAREN] = ACTIONS(5444),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(5446),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(5432),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1534] = {
    [sym_compound_statement] = STATE(9414),
    [sym_expression] = STATE(5153),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(9414),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_RPAREN] = ACTIONS(5448),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(5450),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(5432),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1535] = {
    [sym_compound_statement] = STATE(9347),
    [sym_expression] = STATE(5141),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(9347),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_RPAREN] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(5432),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1536] = {
    [sym_compound_statement] = STATE(9298),
    [sym_expression] = STATE(5300),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(9298),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_RPAREN] = ACTIONS(5456),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(5458),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(5432),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1537] = {
    [sym_identifier] = ACTIONS(5460),
    [aux_sym_preproc_def_token1] = ACTIONS(5460),
    [aux_sym_preproc_if_token1] = ACTIONS(5460),
    [aux_sym_preproc_if_token2] = ACTIONS(5460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5460),
    [aux_sym_preproc_else_token1] = ACTIONS(5460),
    [aux_sym_preproc_elif_token1] = ACTIONS(5460),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5460),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5460),
    [sym_preproc_directive] = ACTIONS(5460),
    [anon_sym_LPAREN2] = ACTIONS(5462),
    [anon_sym_TILDE] = ACTIONS(5462),
    [anon_sym_STAR] = ACTIONS(5462),
    [anon_sym_AMP_AMP] = ACTIONS(5462),
    [anon_sym_AMP] = ACTIONS(5460),
    [anon_sym___extension__] = ACTIONS(5460),
    [anon_sym_typedef] = ACTIONS(5460),
    [anon_sym_in] = ACTIONS(5460),
    [anon_sym_out] = ACTIONS(5460),
    [anon_sym_inout] = ACTIONS(5460),
    [anon_sym_extern] = ACTIONS(5460),
    [anon_sym___attribute__] = ACTIONS(5460),
    [anon_sym_COLON_COLON] = ACTIONS(5462),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5462),
    [anon_sym___declspec] = ACTIONS(5460),
    [anon_sym___based] = ACTIONS(5460),
    [anon_sym_signed] = ACTIONS(5460),
    [anon_sym_unsigned] = ACTIONS(5460),
    [anon_sym_long] = ACTIONS(5460),
    [anon_sym_short] = ACTIONS(5460),
    [anon_sym_LBRACK] = ACTIONS(5460),
    [anon_sym_static] = ACTIONS(5460),
    [anon_sym_register] = ACTIONS(5460),
    [anon_sym_inline] = ACTIONS(5460),
    [anon_sym___inline] = ACTIONS(5460),
    [anon_sym___inline__] = ACTIONS(5460),
    [anon_sym___forceinline] = ACTIONS(5460),
    [anon_sym_thread_local] = ACTIONS(5460),
    [anon_sym___thread] = ACTIONS(5460),
    [anon_sym_const] = ACTIONS(5460),
    [anon_sym_constexpr] = ACTIONS(5460),
    [anon_sym_volatile] = ACTIONS(5460),
    [anon_sym_restrict] = ACTIONS(5460),
    [anon_sym___restrict__] = ACTIONS(5460),
    [anon_sym__Atomic] = ACTIONS(5460),
    [anon_sym__Noreturn] = ACTIONS(5460),
    [anon_sym_noreturn] = ACTIONS(5460),
    [anon_sym_mutable] = ACTIONS(5460),
    [anon_sym_constinit] = ACTIONS(5460),
    [anon_sym_consteval] = ACTIONS(5460),
    [anon_sym_alignas] = ACTIONS(5460),
    [anon_sym__Alignas] = ACTIONS(5460),
    [sym_primitive_type] = ACTIONS(5460),
    [anon_sym_enum] = ACTIONS(5460),
    [anon_sym_class] = ACTIONS(5460),
    [anon_sym_struct] = ACTIONS(5460),
    [anon_sym_union] = ACTIONS(5460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5460),
    [anon_sym_let] = ACTIONS(5460),
    [anon_sym_This] = ACTIONS(5460),
    [anon_sym_decltype] = ACTIONS(5460),
    [sym_virtual] = ACTIONS(5460),
    [anon_sym_explicit] = ACTIONS(5460),
    [anon_sym_typename] = ACTIONS(5460),
    [anon_sym_template] = ACTIONS(5460),
    [anon_sym_operator] = ACTIONS(5460),
    [anon_sym_friend] = ACTIONS(5460),
    [anon_sym_public] = ACTIONS(5460),
    [anon_sym_private] = ACTIONS(5460),
    [anon_sym_protected] = ACTIONS(5460),
    [anon_sym_using] = ACTIONS(5460),
    [anon_sym_static_assert] = ACTIONS(5460),
    [anon_sym_precise] = ACTIONS(5460),
    [anon_sym_shared] = ACTIONS(5460),
    [anon_sym_groupshared] = ACTIONS(5460),
    [anon_sym_uniform] = ACTIONS(5460),
    [anon_sym_row_major] = ACTIONS(5460),
    [anon_sym_column_major] = ACTIONS(5460),
    [anon_sym_globallycoherent] = ACTIONS(5460),
    [anon_sym_centroid] = ACTIONS(5460),
    [anon_sym_noperspective] = ACTIONS(5460),
    [anon_sym_nointerpolation] = ACTIONS(5460),
    [anon_sym_sample] = ACTIONS(5460),
    [anon_sym_linear] = ACTIONS(5460),
    [anon_sym_snorm] = ACTIONS(5460),
    [anon_sym_unorm] = ACTIONS(5460),
    [anon_sym_point] = ACTIONS(5460),
    [anon_sym_line] = ACTIONS(5460),
    [anon_sym_triangleadj] = ACTIONS(5460),
    [anon_sym_lineadj] = ACTIONS(5460),
    [anon_sym_triangle] = ACTIONS(5460),
    [anon_sym_interface] = ACTIONS(5460),
    [anon_sym_extension] = ACTIONS(5460),
    [anon_sym___init] = ACTIONS(5460),
    [anon_sym___subscript] = ACTIONS(5460),
    [anon_sym_property] = ACTIONS(5460),
    [anon_sym_associatedtype] = ACTIONS(5460),
  },
  [1538] = {
    [sym_identifier] = ACTIONS(5464),
    [aux_sym_preproc_def_token1] = ACTIONS(5464),
    [aux_sym_preproc_if_token1] = ACTIONS(5464),
    [aux_sym_preproc_if_token2] = ACTIONS(5464),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5464),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5464),
    [aux_sym_preproc_else_token1] = ACTIONS(5464),
    [aux_sym_preproc_elif_token1] = ACTIONS(5464),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5464),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5464),
    [sym_preproc_directive] = ACTIONS(5464),
    [anon_sym_LPAREN2] = ACTIONS(5466),
    [anon_sym_TILDE] = ACTIONS(5466),
    [anon_sym_STAR] = ACTIONS(5466),
    [anon_sym_AMP_AMP] = ACTIONS(5466),
    [anon_sym_AMP] = ACTIONS(5464),
    [anon_sym___extension__] = ACTIONS(5464),
    [anon_sym_typedef] = ACTIONS(5464),
    [anon_sym_in] = ACTIONS(5464),
    [anon_sym_out] = ACTIONS(5464),
    [anon_sym_inout] = ACTIONS(5464),
    [anon_sym_extern] = ACTIONS(5464),
    [anon_sym___attribute__] = ACTIONS(5464),
    [anon_sym_COLON_COLON] = ACTIONS(5466),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5466),
    [anon_sym___declspec] = ACTIONS(5464),
    [anon_sym___based] = ACTIONS(5464),
    [anon_sym_signed] = ACTIONS(5464),
    [anon_sym_unsigned] = ACTIONS(5464),
    [anon_sym_long] = ACTIONS(5464),
    [anon_sym_short] = ACTIONS(5464),
    [anon_sym_LBRACK] = ACTIONS(5464),
    [anon_sym_static] = ACTIONS(5464),
    [anon_sym_register] = ACTIONS(5464),
    [anon_sym_inline] = ACTIONS(5464),
    [anon_sym___inline] = ACTIONS(5464),
    [anon_sym___inline__] = ACTIONS(5464),
    [anon_sym___forceinline] = ACTIONS(5464),
    [anon_sym_thread_local] = ACTIONS(5464),
    [anon_sym___thread] = ACTIONS(5464),
    [anon_sym_const] = ACTIONS(5464),
    [anon_sym_constexpr] = ACTIONS(5464),
    [anon_sym_volatile] = ACTIONS(5464),
    [anon_sym_restrict] = ACTIONS(5464),
    [anon_sym___restrict__] = ACTIONS(5464),
    [anon_sym__Atomic] = ACTIONS(5464),
    [anon_sym__Noreturn] = ACTIONS(5464),
    [anon_sym_noreturn] = ACTIONS(5464),
    [anon_sym_mutable] = ACTIONS(5464),
    [anon_sym_constinit] = ACTIONS(5464),
    [anon_sym_consteval] = ACTIONS(5464),
    [anon_sym_alignas] = ACTIONS(5464),
    [anon_sym__Alignas] = ACTIONS(5464),
    [sym_primitive_type] = ACTIONS(5464),
    [anon_sym_enum] = ACTIONS(5464),
    [anon_sym_class] = ACTIONS(5464),
    [anon_sym_struct] = ACTIONS(5464),
    [anon_sym_union] = ACTIONS(5464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5464),
    [anon_sym_let] = ACTIONS(5464),
    [anon_sym_This] = ACTIONS(5464),
    [anon_sym_decltype] = ACTIONS(5464),
    [sym_virtual] = ACTIONS(5464),
    [anon_sym_explicit] = ACTIONS(5464),
    [anon_sym_typename] = ACTIONS(5464),
    [anon_sym_template] = ACTIONS(5464),
    [anon_sym_operator] = ACTIONS(5464),
    [anon_sym_friend] = ACTIONS(5464),
    [anon_sym_public] = ACTIONS(5464),
    [anon_sym_private] = ACTIONS(5464),
    [anon_sym_protected] = ACTIONS(5464),
    [anon_sym_using] = ACTIONS(5464),
    [anon_sym_static_assert] = ACTIONS(5464),
    [anon_sym_precise] = ACTIONS(5464),
    [anon_sym_shared] = ACTIONS(5464),
    [anon_sym_groupshared] = ACTIONS(5464),
    [anon_sym_uniform] = ACTIONS(5464),
    [anon_sym_row_major] = ACTIONS(5464),
    [anon_sym_column_major] = ACTIONS(5464),
    [anon_sym_globallycoherent] = ACTIONS(5464),
    [anon_sym_centroid] = ACTIONS(5464),
    [anon_sym_noperspective] = ACTIONS(5464),
    [anon_sym_nointerpolation] = ACTIONS(5464),
    [anon_sym_sample] = ACTIONS(5464),
    [anon_sym_linear] = ACTIONS(5464),
    [anon_sym_snorm] = ACTIONS(5464),
    [anon_sym_unorm] = ACTIONS(5464),
    [anon_sym_point] = ACTIONS(5464),
    [anon_sym_line] = ACTIONS(5464),
    [anon_sym_triangleadj] = ACTIONS(5464),
    [anon_sym_lineadj] = ACTIONS(5464),
    [anon_sym_triangle] = ACTIONS(5464),
    [anon_sym_interface] = ACTIONS(5464),
    [anon_sym_extension] = ACTIONS(5464),
    [anon_sym___init] = ACTIONS(5464),
    [anon_sym___subscript] = ACTIONS(5464),
    [anon_sym_property] = ACTIONS(5464),
    [anon_sym_associatedtype] = ACTIONS(5464),
  },
  [1539] = {
    [sym_identifier] = ACTIONS(3555),
    [aux_sym_preproc_def_token1] = ACTIONS(3555),
    [aux_sym_preproc_if_token1] = ACTIONS(3555),
    [aux_sym_preproc_if_token2] = ACTIONS(3555),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3555),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3555),
    [aux_sym_preproc_else_token1] = ACTIONS(3555),
    [aux_sym_preproc_elif_token1] = ACTIONS(3555),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3555),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3555),
    [sym_preproc_directive] = ACTIONS(3555),
    [anon_sym_LPAREN2] = ACTIONS(3557),
    [anon_sym_TILDE] = ACTIONS(3557),
    [anon_sym_STAR] = ACTIONS(3557),
    [anon_sym_AMP_AMP] = ACTIONS(3557),
    [anon_sym_AMP] = ACTIONS(3555),
    [anon_sym___extension__] = ACTIONS(3555),
    [anon_sym_typedef] = ACTIONS(3555),
    [anon_sym_in] = ACTIONS(3555),
    [anon_sym_out] = ACTIONS(3555),
    [anon_sym_inout] = ACTIONS(3555),
    [anon_sym_extern] = ACTIONS(3555),
    [anon_sym___attribute__] = ACTIONS(3555),
    [anon_sym_COLON_COLON] = ACTIONS(3557),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3557),
    [anon_sym___declspec] = ACTIONS(3555),
    [anon_sym___based] = ACTIONS(3555),
    [anon_sym_signed] = ACTIONS(3555),
    [anon_sym_unsigned] = ACTIONS(3555),
    [anon_sym_long] = ACTIONS(3555),
    [anon_sym_short] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3555),
    [anon_sym_static] = ACTIONS(3555),
    [anon_sym_register] = ACTIONS(3555),
    [anon_sym_inline] = ACTIONS(3555),
    [anon_sym___inline] = ACTIONS(3555),
    [anon_sym___inline__] = ACTIONS(3555),
    [anon_sym___forceinline] = ACTIONS(3555),
    [anon_sym_thread_local] = ACTIONS(3555),
    [anon_sym___thread] = ACTIONS(3555),
    [anon_sym_const] = ACTIONS(3555),
    [anon_sym_constexpr] = ACTIONS(3555),
    [anon_sym_volatile] = ACTIONS(3555),
    [anon_sym_restrict] = ACTIONS(3555),
    [anon_sym___restrict__] = ACTIONS(3555),
    [anon_sym__Atomic] = ACTIONS(3555),
    [anon_sym__Noreturn] = ACTIONS(3555),
    [anon_sym_noreturn] = ACTIONS(3555),
    [anon_sym_mutable] = ACTIONS(3555),
    [anon_sym_constinit] = ACTIONS(3555),
    [anon_sym_consteval] = ACTIONS(3555),
    [anon_sym_alignas] = ACTIONS(3555),
    [anon_sym__Alignas] = ACTIONS(3555),
    [sym_primitive_type] = ACTIONS(3555),
    [anon_sym_enum] = ACTIONS(3555),
    [anon_sym_class] = ACTIONS(3555),
    [anon_sym_struct] = ACTIONS(3555),
    [anon_sym_union] = ACTIONS(3555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3555),
    [anon_sym_let] = ACTIONS(3555),
    [anon_sym_This] = ACTIONS(3555),
    [anon_sym_decltype] = ACTIONS(3555),
    [sym_virtual] = ACTIONS(3555),
    [anon_sym_explicit] = ACTIONS(3555),
    [anon_sym_typename] = ACTIONS(3555),
    [anon_sym_template] = ACTIONS(3555),
    [anon_sym_operator] = ACTIONS(3555),
    [anon_sym_friend] = ACTIONS(3555),
    [anon_sym_public] = ACTIONS(3555),
    [anon_sym_private] = ACTIONS(3555),
    [anon_sym_protected] = ACTIONS(3555),
    [anon_sym_using] = ACTIONS(3555),
    [anon_sym_static_assert] = ACTIONS(3555),
    [anon_sym_precise] = ACTIONS(3555),
    [anon_sym_shared] = ACTIONS(3555),
    [anon_sym_groupshared] = ACTIONS(3555),
    [anon_sym_uniform] = ACTIONS(3555),
    [anon_sym_row_major] = ACTIONS(3555),
    [anon_sym_column_major] = ACTIONS(3555),
    [anon_sym_globallycoherent] = ACTIONS(3555),
    [anon_sym_centroid] = ACTIONS(3555),
    [anon_sym_noperspective] = ACTIONS(3555),
    [anon_sym_nointerpolation] = ACTIONS(3555),
    [anon_sym_sample] = ACTIONS(3555),
    [anon_sym_linear] = ACTIONS(3555),
    [anon_sym_snorm] = ACTIONS(3555),
    [anon_sym_unorm] = ACTIONS(3555),
    [anon_sym_point] = ACTIONS(3555),
    [anon_sym_line] = ACTIONS(3555),
    [anon_sym_triangleadj] = ACTIONS(3555),
    [anon_sym_lineadj] = ACTIONS(3555),
    [anon_sym_triangle] = ACTIONS(3555),
    [anon_sym_interface] = ACTIONS(3555),
    [anon_sym_extension] = ACTIONS(3555),
    [anon_sym___init] = ACTIONS(3555),
    [anon_sym___subscript] = ACTIONS(3555),
    [anon_sym_property] = ACTIONS(3555),
    [anon_sym_associatedtype] = ACTIONS(3555),
  },
  [1540] = {
    [sym_expression] = STATE(4230),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym__unary_left_fold] = STATE(10569),
    [sym__unary_right_fold] = STATE(10571),
    [sym__binary_fold] = STATE(10572),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1541] = {
    [sym_identifier] = ACTIONS(3547),
    [aux_sym_preproc_def_token1] = ACTIONS(3547),
    [aux_sym_preproc_if_token1] = ACTIONS(3547),
    [aux_sym_preproc_if_token2] = ACTIONS(3547),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3547),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3547),
    [aux_sym_preproc_else_token1] = ACTIONS(3547),
    [aux_sym_preproc_elif_token1] = ACTIONS(3547),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3547),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3547),
    [sym_preproc_directive] = ACTIONS(3547),
    [anon_sym_LPAREN2] = ACTIONS(3549),
    [anon_sym_TILDE] = ACTIONS(3549),
    [anon_sym_STAR] = ACTIONS(3549),
    [anon_sym_AMP_AMP] = ACTIONS(3549),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym___extension__] = ACTIONS(3547),
    [anon_sym_typedef] = ACTIONS(3547),
    [anon_sym_in] = ACTIONS(3547),
    [anon_sym_out] = ACTIONS(3547),
    [anon_sym_inout] = ACTIONS(3547),
    [anon_sym_extern] = ACTIONS(3547),
    [anon_sym___attribute__] = ACTIONS(3547),
    [anon_sym_COLON_COLON] = ACTIONS(3549),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3549),
    [anon_sym___declspec] = ACTIONS(3547),
    [anon_sym___based] = ACTIONS(3547),
    [anon_sym_signed] = ACTIONS(3547),
    [anon_sym_unsigned] = ACTIONS(3547),
    [anon_sym_long] = ACTIONS(3547),
    [anon_sym_short] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_static] = ACTIONS(3547),
    [anon_sym_register] = ACTIONS(3547),
    [anon_sym_inline] = ACTIONS(3547),
    [anon_sym___inline] = ACTIONS(3547),
    [anon_sym___inline__] = ACTIONS(3547),
    [anon_sym___forceinline] = ACTIONS(3547),
    [anon_sym_thread_local] = ACTIONS(3547),
    [anon_sym___thread] = ACTIONS(3547),
    [anon_sym_const] = ACTIONS(3547),
    [anon_sym_constexpr] = ACTIONS(3547),
    [anon_sym_volatile] = ACTIONS(3547),
    [anon_sym_restrict] = ACTIONS(3547),
    [anon_sym___restrict__] = ACTIONS(3547),
    [anon_sym__Atomic] = ACTIONS(3547),
    [anon_sym__Noreturn] = ACTIONS(3547),
    [anon_sym_noreturn] = ACTIONS(3547),
    [anon_sym_mutable] = ACTIONS(3547),
    [anon_sym_constinit] = ACTIONS(3547),
    [anon_sym_consteval] = ACTIONS(3547),
    [anon_sym_alignas] = ACTIONS(3547),
    [anon_sym__Alignas] = ACTIONS(3547),
    [sym_primitive_type] = ACTIONS(3547),
    [anon_sym_enum] = ACTIONS(3547),
    [anon_sym_class] = ACTIONS(3547),
    [anon_sym_struct] = ACTIONS(3547),
    [anon_sym_union] = ACTIONS(3547),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_This] = ACTIONS(3547),
    [anon_sym_decltype] = ACTIONS(3547),
    [sym_virtual] = ACTIONS(3547),
    [anon_sym_explicit] = ACTIONS(3547),
    [anon_sym_typename] = ACTIONS(3547),
    [anon_sym_template] = ACTIONS(3547),
    [anon_sym_operator] = ACTIONS(3547),
    [anon_sym_friend] = ACTIONS(3547),
    [anon_sym_public] = ACTIONS(3547),
    [anon_sym_private] = ACTIONS(3547),
    [anon_sym_protected] = ACTIONS(3547),
    [anon_sym_using] = ACTIONS(3547),
    [anon_sym_static_assert] = ACTIONS(3547),
    [anon_sym_precise] = ACTIONS(3547),
    [anon_sym_shared] = ACTIONS(3547),
    [anon_sym_groupshared] = ACTIONS(3547),
    [anon_sym_uniform] = ACTIONS(3547),
    [anon_sym_row_major] = ACTIONS(3547),
    [anon_sym_column_major] = ACTIONS(3547),
    [anon_sym_globallycoherent] = ACTIONS(3547),
    [anon_sym_centroid] = ACTIONS(3547),
    [anon_sym_noperspective] = ACTIONS(3547),
    [anon_sym_nointerpolation] = ACTIONS(3547),
    [anon_sym_sample] = ACTIONS(3547),
    [anon_sym_linear] = ACTIONS(3547),
    [anon_sym_snorm] = ACTIONS(3547),
    [anon_sym_unorm] = ACTIONS(3547),
    [anon_sym_point] = ACTIONS(3547),
    [anon_sym_line] = ACTIONS(3547),
    [anon_sym_triangleadj] = ACTIONS(3547),
    [anon_sym_lineadj] = ACTIONS(3547),
    [anon_sym_triangle] = ACTIONS(3547),
    [anon_sym_interface] = ACTIONS(3547),
    [anon_sym_extension] = ACTIONS(3547),
    [anon_sym___init] = ACTIONS(3547),
    [anon_sym___subscript] = ACTIONS(3547),
    [anon_sym_property] = ACTIONS(3547),
    [anon_sym_associatedtype] = ACTIONS(3547),
  },
  [1542] = {
    [sym_expression] = STATE(4054),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym__unary_left_fold] = STATE(10910),
    [sym__unary_right_fold] = STATE(10908),
    [sym__binary_fold] = STATE(10906),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1543] = {
    [sym_identifier] = ACTIONS(3539),
    [aux_sym_preproc_def_token1] = ACTIONS(3539),
    [aux_sym_preproc_if_token1] = ACTIONS(3539),
    [aux_sym_preproc_if_token2] = ACTIONS(3539),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3539),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3539),
    [aux_sym_preproc_else_token1] = ACTIONS(3539),
    [aux_sym_preproc_elif_token1] = ACTIONS(3539),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3539),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3539),
    [sym_preproc_directive] = ACTIONS(3539),
    [anon_sym_LPAREN2] = ACTIONS(3541),
    [anon_sym_TILDE] = ACTIONS(3541),
    [anon_sym_STAR] = ACTIONS(3541),
    [anon_sym_AMP_AMP] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym___extension__] = ACTIONS(3539),
    [anon_sym_typedef] = ACTIONS(3539),
    [anon_sym_in] = ACTIONS(3539),
    [anon_sym_out] = ACTIONS(3539),
    [anon_sym_inout] = ACTIONS(3539),
    [anon_sym_extern] = ACTIONS(3539),
    [anon_sym___attribute__] = ACTIONS(3539),
    [anon_sym_COLON_COLON] = ACTIONS(3541),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3541),
    [anon_sym___declspec] = ACTIONS(3539),
    [anon_sym___based] = ACTIONS(3539),
    [anon_sym_signed] = ACTIONS(3539),
    [anon_sym_unsigned] = ACTIONS(3539),
    [anon_sym_long] = ACTIONS(3539),
    [anon_sym_short] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_static] = ACTIONS(3539),
    [anon_sym_register] = ACTIONS(3539),
    [anon_sym_inline] = ACTIONS(3539),
    [anon_sym___inline] = ACTIONS(3539),
    [anon_sym___inline__] = ACTIONS(3539),
    [anon_sym___forceinline] = ACTIONS(3539),
    [anon_sym_thread_local] = ACTIONS(3539),
    [anon_sym___thread] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3539),
    [anon_sym_constexpr] = ACTIONS(3539),
    [anon_sym_volatile] = ACTIONS(3539),
    [anon_sym_restrict] = ACTIONS(3539),
    [anon_sym___restrict__] = ACTIONS(3539),
    [anon_sym__Atomic] = ACTIONS(3539),
    [anon_sym__Noreturn] = ACTIONS(3539),
    [anon_sym_noreturn] = ACTIONS(3539),
    [anon_sym_mutable] = ACTIONS(3539),
    [anon_sym_constinit] = ACTIONS(3539),
    [anon_sym_consteval] = ACTIONS(3539),
    [anon_sym_alignas] = ACTIONS(3539),
    [anon_sym__Alignas] = ACTIONS(3539),
    [sym_primitive_type] = ACTIONS(3539),
    [anon_sym_enum] = ACTIONS(3539),
    [anon_sym_class] = ACTIONS(3539),
    [anon_sym_struct] = ACTIONS(3539),
    [anon_sym_union] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_This] = ACTIONS(3539),
    [anon_sym_decltype] = ACTIONS(3539),
    [sym_virtual] = ACTIONS(3539),
    [anon_sym_explicit] = ACTIONS(3539),
    [anon_sym_typename] = ACTIONS(3539),
    [anon_sym_template] = ACTIONS(3539),
    [anon_sym_operator] = ACTIONS(3539),
    [anon_sym_friend] = ACTIONS(3539),
    [anon_sym_public] = ACTIONS(3539),
    [anon_sym_private] = ACTIONS(3539),
    [anon_sym_protected] = ACTIONS(3539),
    [anon_sym_using] = ACTIONS(3539),
    [anon_sym_static_assert] = ACTIONS(3539),
    [anon_sym_precise] = ACTIONS(3539),
    [anon_sym_shared] = ACTIONS(3539),
    [anon_sym_groupshared] = ACTIONS(3539),
    [anon_sym_uniform] = ACTIONS(3539),
    [anon_sym_row_major] = ACTIONS(3539),
    [anon_sym_column_major] = ACTIONS(3539),
    [anon_sym_globallycoherent] = ACTIONS(3539),
    [anon_sym_centroid] = ACTIONS(3539),
    [anon_sym_noperspective] = ACTIONS(3539),
    [anon_sym_nointerpolation] = ACTIONS(3539),
    [anon_sym_sample] = ACTIONS(3539),
    [anon_sym_linear] = ACTIONS(3539),
    [anon_sym_snorm] = ACTIONS(3539),
    [anon_sym_unorm] = ACTIONS(3539),
    [anon_sym_point] = ACTIONS(3539),
    [anon_sym_line] = ACTIONS(3539),
    [anon_sym_triangleadj] = ACTIONS(3539),
    [anon_sym_lineadj] = ACTIONS(3539),
    [anon_sym_triangle] = ACTIONS(3539),
    [anon_sym_interface] = ACTIONS(3539),
    [anon_sym_extension] = ACTIONS(3539),
    [anon_sym___init] = ACTIONS(3539),
    [anon_sym___subscript] = ACTIONS(3539),
    [anon_sym_property] = ACTIONS(3539),
    [anon_sym_associatedtype] = ACTIONS(3539),
  },
  [1544] = {
    [sym_expression] = STATE(3955),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym__unary_left_fold] = STATE(10796),
    [sym__unary_right_fold] = STATE(10795),
    [sym__binary_fold] = STATE(10794),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1545] = {
    [sym_identifier] = ACTIONS(3414),
    [aux_sym_preproc_def_token1] = ACTIONS(3414),
    [aux_sym_preproc_if_token1] = ACTIONS(3414),
    [aux_sym_preproc_if_token2] = ACTIONS(3414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3414),
    [aux_sym_preproc_else_token1] = ACTIONS(3414),
    [aux_sym_preproc_elif_token1] = ACTIONS(3414),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3414),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3414),
    [sym_preproc_directive] = ACTIONS(3414),
    [anon_sym_LPAREN2] = ACTIONS(3416),
    [anon_sym_TILDE] = ACTIONS(3416),
    [anon_sym_STAR] = ACTIONS(3416),
    [anon_sym_AMP_AMP] = ACTIONS(3416),
    [anon_sym_AMP] = ACTIONS(3414),
    [anon_sym___extension__] = ACTIONS(3414),
    [anon_sym_typedef] = ACTIONS(3414),
    [anon_sym_in] = ACTIONS(3414),
    [anon_sym_out] = ACTIONS(3414),
    [anon_sym_inout] = ACTIONS(3414),
    [anon_sym_extern] = ACTIONS(3414),
    [anon_sym___attribute__] = ACTIONS(3414),
    [anon_sym_COLON_COLON] = ACTIONS(3416),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3416),
    [anon_sym___declspec] = ACTIONS(3414),
    [anon_sym___based] = ACTIONS(3414),
    [anon_sym_signed] = ACTIONS(3414),
    [anon_sym_unsigned] = ACTIONS(3414),
    [anon_sym_long] = ACTIONS(3414),
    [anon_sym_short] = ACTIONS(3414),
    [anon_sym_LBRACK] = ACTIONS(3414),
    [anon_sym_static] = ACTIONS(3414),
    [anon_sym_register] = ACTIONS(3414),
    [anon_sym_inline] = ACTIONS(3414),
    [anon_sym___inline] = ACTIONS(3414),
    [anon_sym___inline__] = ACTIONS(3414),
    [anon_sym___forceinline] = ACTIONS(3414),
    [anon_sym_thread_local] = ACTIONS(3414),
    [anon_sym___thread] = ACTIONS(3414),
    [anon_sym_const] = ACTIONS(3414),
    [anon_sym_constexpr] = ACTIONS(3414),
    [anon_sym_volatile] = ACTIONS(3414),
    [anon_sym_restrict] = ACTIONS(3414),
    [anon_sym___restrict__] = ACTIONS(3414),
    [anon_sym__Atomic] = ACTIONS(3414),
    [anon_sym__Noreturn] = ACTIONS(3414),
    [anon_sym_noreturn] = ACTIONS(3414),
    [anon_sym_mutable] = ACTIONS(3414),
    [anon_sym_constinit] = ACTIONS(3414),
    [anon_sym_consteval] = ACTIONS(3414),
    [anon_sym_alignas] = ACTIONS(3414),
    [anon_sym__Alignas] = ACTIONS(3414),
    [sym_primitive_type] = ACTIONS(3414),
    [anon_sym_enum] = ACTIONS(3414),
    [anon_sym_class] = ACTIONS(3414),
    [anon_sym_struct] = ACTIONS(3414),
    [anon_sym_union] = ACTIONS(3414),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3414),
    [anon_sym_let] = ACTIONS(3414),
    [anon_sym_This] = ACTIONS(3414),
    [anon_sym_decltype] = ACTIONS(3414),
    [sym_virtual] = ACTIONS(3414),
    [anon_sym_explicit] = ACTIONS(3414),
    [anon_sym_typename] = ACTIONS(3414),
    [anon_sym_template] = ACTIONS(3414),
    [anon_sym_operator] = ACTIONS(3414),
    [anon_sym_friend] = ACTIONS(3414),
    [anon_sym_public] = ACTIONS(3414),
    [anon_sym_private] = ACTIONS(3414),
    [anon_sym_protected] = ACTIONS(3414),
    [anon_sym_using] = ACTIONS(3414),
    [anon_sym_static_assert] = ACTIONS(3414),
    [anon_sym_precise] = ACTIONS(3414),
    [anon_sym_shared] = ACTIONS(3414),
    [anon_sym_groupshared] = ACTIONS(3414),
    [anon_sym_uniform] = ACTIONS(3414),
    [anon_sym_row_major] = ACTIONS(3414),
    [anon_sym_column_major] = ACTIONS(3414),
    [anon_sym_globallycoherent] = ACTIONS(3414),
    [anon_sym_centroid] = ACTIONS(3414),
    [anon_sym_noperspective] = ACTIONS(3414),
    [anon_sym_nointerpolation] = ACTIONS(3414),
    [anon_sym_sample] = ACTIONS(3414),
    [anon_sym_linear] = ACTIONS(3414),
    [anon_sym_snorm] = ACTIONS(3414),
    [anon_sym_unorm] = ACTIONS(3414),
    [anon_sym_point] = ACTIONS(3414),
    [anon_sym_line] = ACTIONS(3414),
    [anon_sym_triangleadj] = ACTIONS(3414),
    [anon_sym_lineadj] = ACTIONS(3414),
    [anon_sym_triangle] = ACTIONS(3414),
    [anon_sym_interface] = ACTIONS(3414),
    [anon_sym_extension] = ACTIONS(3414),
    [anon_sym___init] = ACTIONS(3414),
    [anon_sym___subscript] = ACTIONS(3414),
    [anon_sym_property] = ACTIONS(3414),
    [anon_sym_associatedtype] = ACTIONS(3414),
  },
  [1546] = {
    [sym_expression] = STATE(3919),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym__unary_left_fold] = STATE(10516),
    [sym__unary_right_fold] = STATE(10070),
    [sym__binary_fold] = STATE(10558),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1547] = {
    [sym_identifier] = ACTIONS(3425),
    [aux_sym_preproc_def_token1] = ACTIONS(3425),
    [aux_sym_preproc_if_token1] = ACTIONS(3425),
    [aux_sym_preproc_if_token2] = ACTIONS(3425),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3425),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3425),
    [aux_sym_preproc_else_token1] = ACTIONS(3425),
    [aux_sym_preproc_elif_token1] = ACTIONS(3425),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3425),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3425),
    [sym_preproc_directive] = ACTIONS(3425),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3425),
    [anon_sym___extension__] = ACTIONS(3425),
    [anon_sym_typedef] = ACTIONS(3425),
    [anon_sym_in] = ACTIONS(3425),
    [anon_sym_out] = ACTIONS(3425),
    [anon_sym_inout] = ACTIONS(3425),
    [anon_sym_extern] = ACTIONS(3425),
    [anon_sym___attribute__] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(3427),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3427),
    [anon_sym___declspec] = ACTIONS(3425),
    [anon_sym___based] = ACTIONS(3425),
    [anon_sym_signed] = ACTIONS(3425),
    [anon_sym_unsigned] = ACTIONS(3425),
    [anon_sym_long] = ACTIONS(3425),
    [anon_sym_short] = ACTIONS(3425),
    [anon_sym_LBRACK] = ACTIONS(3425),
    [anon_sym_static] = ACTIONS(3425),
    [anon_sym_register] = ACTIONS(3425),
    [anon_sym_inline] = ACTIONS(3425),
    [anon_sym___inline] = ACTIONS(3425),
    [anon_sym___inline__] = ACTIONS(3425),
    [anon_sym___forceinline] = ACTIONS(3425),
    [anon_sym_thread_local] = ACTIONS(3425),
    [anon_sym___thread] = ACTIONS(3425),
    [anon_sym_const] = ACTIONS(3425),
    [anon_sym_constexpr] = ACTIONS(3425),
    [anon_sym_volatile] = ACTIONS(3425),
    [anon_sym_restrict] = ACTIONS(3425),
    [anon_sym___restrict__] = ACTIONS(3425),
    [anon_sym__Atomic] = ACTIONS(3425),
    [anon_sym__Noreturn] = ACTIONS(3425),
    [anon_sym_noreturn] = ACTIONS(3425),
    [anon_sym_mutable] = ACTIONS(3425),
    [anon_sym_constinit] = ACTIONS(3425),
    [anon_sym_consteval] = ACTIONS(3425),
    [anon_sym_alignas] = ACTIONS(3425),
    [anon_sym__Alignas] = ACTIONS(3425),
    [sym_primitive_type] = ACTIONS(3425),
    [anon_sym_enum] = ACTIONS(3425),
    [anon_sym_class] = ACTIONS(3425),
    [anon_sym_struct] = ACTIONS(3425),
    [anon_sym_union] = ACTIONS(3425),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3425),
    [anon_sym_let] = ACTIONS(3425),
    [anon_sym_This] = ACTIONS(3425),
    [anon_sym_decltype] = ACTIONS(3425),
    [sym_virtual] = ACTIONS(3425),
    [anon_sym_explicit] = ACTIONS(3425),
    [anon_sym_typename] = ACTIONS(3425),
    [anon_sym_template] = ACTIONS(3425),
    [anon_sym_operator] = ACTIONS(3425),
    [anon_sym_friend] = ACTIONS(3425),
    [anon_sym_public] = ACTIONS(3425),
    [anon_sym_private] = ACTIONS(3425),
    [anon_sym_protected] = ACTIONS(3425),
    [anon_sym_using] = ACTIONS(3425),
    [anon_sym_static_assert] = ACTIONS(3425),
    [anon_sym_precise] = ACTIONS(3425),
    [anon_sym_shared] = ACTIONS(3425),
    [anon_sym_groupshared] = ACTIONS(3425),
    [anon_sym_uniform] = ACTIONS(3425),
    [anon_sym_row_major] = ACTIONS(3425),
    [anon_sym_column_major] = ACTIONS(3425),
    [anon_sym_globallycoherent] = ACTIONS(3425),
    [anon_sym_centroid] = ACTIONS(3425),
    [anon_sym_noperspective] = ACTIONS(3425),
    [anon_sym_nointerpolation] = ACTIONS(3425),
    [anon_sym_sample] = ACTIONS(3425),
    [anon_sym_linear] = ACTIONS(3425),
    [anon_sym_snorm] = ACTIONS(3425),
    [anon_sym_unorm] = ACTIONS(3425),
    [anon_sym_point] = ACTIONS(3425),
    [anon_sym_line] = ACTIONS(3425),
    [anon_sym_triangleadj] = ACTIONS(3425),
    [anon_sym_lineadj] = ACTIONS(3425),
    [anon_sym_triangle] = ACTIONS(3425),
    [anon_sym_interface] = ACTIONS(3425),
    [anon_sym_extension] = ACTIONS(3425),
    [anon_sym___init] = ACTIONS(3425),
    [anon_sym___subscript] = ACTIONS(3425),
    [anon_sym_property] = ACTIONS(3425),
    [anon_sym_associatedtype] = ACTIONS(3425),
  },
  [1548] = {
    [sym_identifier] = ACTIONS(3637),
    [aux_sym_preproc_def_token1] = ACTIONS(3637),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_if_token2] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3637),
    [aux_sym_preproc_else_token1] = ACTIONS(3637),
    [aux_sym_preproc_elif_token1] = ACTIONS(3637),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3637),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3637),
    [sym_preproc_directive] = ACTIONS(3637),
    [anon_sym_LPAREN2] = ACTIONS(3639),
    [anon_sym_TILDE] = ACTIONS(3639),
    [anon_sym_STAR] = ACTIONS(3639),
    [anon_sym_AMP_AMP] = ACTIONS(3639),
    [anon_sym_AMP] = ACTIONS(3637),
    [anon_sym___extension__] = ACTIONS(3637),
    [anon_sym_typedef] = ACTIONS(3637),
    [anon_sym_in] = ACTIONS(3637),
    [anon_sym_out] = ACTIONS(3637),
    [anon_sym_inout] = ACTIONS(3637),
    [anon_sym_extern] = ACTIONS(3637),
    [anon_sym___attribute__] = ACTIONS(3637),
    [anon_sym_COLON_COLON] = ACTIONS(3639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3639),
    [anon_sym___declspec] = ACTIONS(3637),
    [anon_sym___based] = ACTIONS(3637),
    [anon_sym_signed] = ACTIONS(3637),
    [anon_sym_unsigned] = ACTIONS(3637),
    [anon_sym_long] = ACTIONS(3637),
    [anon_sym_short] = ACTIONS(3637),
    [anon_sym_LBRACK] = ACTIONS(3637),
    [anon_sym_static] = ACTIONS(3637),
    [anon_sym_register] = ACTIONS(3637),
    [anon_sym_inline] = ACTIONS(3637),
    [anon_sym___inline] = ACTIONS(3637),
    [anon_sym___inline__] = ACTIONS(3637),
    [anon_sym___forceinline] = ACTIONS(3637),
    [anon_sym_thread_local] = ACTIONS(3637),
    [anon_sym___thread] = ACTIONS(3637),
    [anon_sym_const] = ACTIONS(3637),
    [anon_sym_constexpr] = ACTIONS(3637),
    [anon_sym_volatile] = ACTIONS(3637),
    [anon_sym_restrict] = ACTIONS(3637),
    [anon_sym___restrict__] = ACTIONS(3637),
    [anon_sym__Atomic] = ACTIONS(3637),
    [anon_sym__Noreturn] = ACTIONS(3637),
    [anon_sym_noreturn] = ACTIONS(3637),
    [anon_sym_mutable] = ACTIONS(3637),
    [anon_sym_constinit] = ACTIONS(3637),
    [anon_sym_consteval] = ACTIONS(3637),
    [anon_sym_alignas] = ACTIONS(3637),
    [anon_sym__Alignas] = ACTIONS(3637),
    [sym_primitive_type] = ACTIONS(3637),
    [anon_sym_enum] = ACTIONS(3637),
    [anon_sym_class] = ACTIONS(3637),
    [anon_sym_struct] = ACTIONS(3637),
    [anon_sym_union] = ACTIONS(3637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3637),
    [anon_sym_let] = ACTIONS(3637),
    [anon_sym_This] = ACTIONS(3637),
    [anon_sym_decltype] = ACTIONS(3637),
    [sym_virtual] = ACTIONS(3637),
    [anon_sym_explicit] = ACTIONS(3637),
    [anon_sym_typename] = ACTIONS(3637),
    [anon_sym_template] = ACTIONS(3637),
    [anon_sym_operator] = ACTIONS(3637),
    [anon_sym_friend] = ACTIONS(3637),
    [anon_sym_public] = ACTIONS(3637),
    [anon_sym_private] = ACTIONS(3637),
    [anon_sym_protected] = ACTIONS(3637),
    [anon_sym_using] = ACTIONS(3637),
    [anon_sym_static_assert] = ACTIONS(3637),
    [anon_sym_precise] = ACTIONS(3637),
    [anon_sym_shared] = ACTIONS(3637),
    [anon_sym_groupshared] = ACTIONS(3637),
    [anon_sym_uniform] = ACTIONS(3637),
    [anon_sym_row_major] = ACTIONS(3637),
    [anon_sym_column_major] = ACTIONS(3637),
    [anon_sym_globallycoherent] = ACTIONS(3637),
    [anon_sym_centroid] = ACTIONS(3637),
    [anon_sym_noperspective] = ACTIONS(3637),
    [anon_sym_nointerpolation] = ACTIONS(3637),
    [anon_sym_sample] = ACTIONS(3637),
    [anon_sym_linear] = ACTIONS(3637),
    [anon_sym_snorm] = ACTIONS(3637),
    [anon_sym_unorm] = ACTIONS(3637),
    [anon_sym_point] = ACTIONS(3637),
    [anon_sym_line] = ACTIONS(3637),
    [anon_sym_triangleadj] = ACTIONS(3637),
    [anon_sym_lineadj] = ACTIONS(3637),
    [anon_sym_triangle] = ACTIONS(3637),
    [anon_sym_interface] = ACTIONS(3637),
    [anon_sym_extension] = ACTIONS(3637),
    [anon_sym___init] = ACTIONS(3637),
    [anon_sym___subscript] = ACTIONS(3637),
    [anon_sym_property] = ACTIONS(3637),
    [anon_sym_associatedtype] = ACTIONS(3637),
  },
  [1549] = {
    [sym_identifier] = ACTIONS(3629),
    [aux_sym_preproc_def_token1] = ACTIONS(3629),
    [aux_sym_preproc_if_token1] = ACTIONS(3629),
    [aux_sym_preproc_if_token2] = ACTIONS(3629),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3629),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3629),
    [aux_sym_preproc_else_token1] = ACTIONS(3629),
    [aux_sym_preproc_elif_token1] = ACTIONS(3629),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3629),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3629),
    [sym_preproc_directive] = ACTIONS(3629),
    [anon_sym_LPAREN2] = ACTIONS(3631),
    [anon_sym_TILDE] = ACTIONS(3631),
    [anon_sym_STAR] = ACTIONS(3631),
    [anon_sym_AMP_AMP] = ACTIONS(3631),
    [anon_sym_AMP] = ACTIONS(3629),
    [anon_sym___extension__] = ACTIONS(3629),
    [anon_sym_typedef] = ACTIONS(3629),
    [anon_sym_in] = ACTIONS(3629),
    [anon_sym_out] = ACTIONS(3629),
    [anon_sym_inout] = ACTIONS(3629),
    [anon_sym_extern] = ACTIONS(3629),
    [anon_sym___attribute__] = ACTIONS(3629),
    [anon_sym_COLON_COLON] = ACTIONS(3631),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3631),
    [anon_sym___declspec] = ACTIONS(3629),
    [anon_sym___based] = ACTIONS(3629),
    [anon_sym_signed] = ACTIONS(3629),
    [anon_sym_unsigned] = ACTIONS(3629),
    [anon_sym_long] = ACTIONS(3629),
    [anon_sym_short] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3629),
    [anon_sym_static] = ACTIONS(3629),
    [anon_sym_register] = ACTIONS(3629),
    [anon_sym_inline] = ACTIONS(3629),
    [anon_sym___inline] = ACTIONS(3629),
    [anon_sym___inline__] = ACTIONS(3629),
    [anon_sym___forceinline] = ACTIONS(3629),
    [anon_sym_thread_local] = ACTIONS(3629),
    [anon_sym___thread] = ACTIONS(3629),
    [anon_sym_const] = ACTIONS(3629),
    [anon_sym_constexpr] = ACTIONS(3629),
    [anon_sym_volatile] = ACTIONS(3629),
    [anon_sym_restrict] = ACTIONS(3629),
    [anon_sym___restrict__] = ACTIONS(3629),
    [anon_sym__Atomic] = ACTIONS(3629),
    [anon_sym__Noreturn] = ACTIONS(3629),
    [anon_sym_noreturn] = ACTIONS(3629),
    [anon_sym_mutable] = ACTIONS(3629),
    [anon_sym_constinit] = ACTIONS(3629),
    [anon_sym_consteval] = ACTIONS(3629),
    [anon_sym_alignas] = ACTIONS(3629),
    [anon_sym__Alignas] = ACTIONS(3629),
    [sym_primitive_type] = ACTIONS(3629),
    [anon_sym_enum] = ACTIONS(3629),
    [anon_sym_class] = ACTIONS(3629),
    [anon_sym_struct] = ACTIONS(3629),
    [anon_sym_union] = ACTIONS(3629),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3629),
    [anon_sym_let] = ACTIONS(3629),
    [anon_sym_This] = ACTIONS(3629),
    [anon_sym_decltype] = ACTIONS(3629),
    [sym_virtual] = ACTIONS(3629),
    [anon_sym_explicit] = ACTIONS(3629),
    [anon_sym_typename] = ACTIONS(3629),
    [anon_sym_template] = ACTIONS(3629),
    [anon_sym_operator] = ACTIONS(3629),
    [anon_sym_friend] = ACTIONS(3629),
    [anon_sym_public] = ACTIONS(3629),
    [anon_sym_private] = ACTIONS(3629),
    [anon_sym_protected] = ACTIONS(3629),
    [anon_sym_using] = ACTIONS(3629),
    [anon_sym_static_assert] = ACTIONS(3629),
    [anon_sym_precise] = ACTIONS(3629),
    [anon_sym_shared] = ACTIONS(3629),
    [anon_sym_groupshared] = ACTIONS(3629),
    [anon_sym_uniform] = ACTIONS(3629),
    [anon_sym_row_major] = ACTIONS(3629),
    [anon_sym_column_major] = ACTIONS(3629),
    [anon_sym_globallycoherent] = ACTIONS(3629),
    [anon_sym_centroid] = ACTIONS(3629),
    [anon_sym_noperspective] = ACTIONS(3629),
    [anon_sym_nointerpolation] = ACTIONS(3629),
    [anon_sym_sample] = ACTIONS(3629),
    [anon_sym_linear] = ACTIONS(3629),
    [anon_sym_snorm] = ACTIONS(3629),
    [anon_sym_unorm] = ACTIONS(3629),
    [anon_sym_point] = ACTIONS(3629),
    [anon_sym_line] = ACTIONS(3629),
    [anon_sym_triangleadj] = ACTIONS(3629),
    [anon_sym_lineadj] = ACTIONS(3629),
    [anon_sym_triangle] = ACTIONS(3629),
    [anon_sym_interface] = ACTIONS(3629),
    [anon_sym_extension] = ACTIONS(3629),
    [anon_sym___init] = ACTIONS(3629),
    [anon_sym___subscript] = ACTIONS(3629),
    [anon_sym_property] = ACTIONS(3629),
    [anon_sym_associatedtype] = ACTIONS(3629),
  },
  [1550] = {
    [sym_identifier] = ACTIONS(3475),
    [aux_sym_preproc_def_token1] = ACTIONS(3475),
    [aux_sym_preproc_if_token1] = ACTIONS(3475),
    [aux_sym_preproc_if_token2] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3475),
    [aux_sym_preproc_else_token1] = ACTIONS(3475),
    [aux_sym_preproc_elif_token1] = ACTIONS(3475),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3475),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3475),
    [sym_preproc_directive] = ACTIONS(3475),
    [anon_sym_LPAREN2] = ACTIONS(3477),
    [anon_sym_TILDE] = ACTIONS(3477),
    [anon_sym_STAR] = ACTIONS(3477),
    [anon_sym_AMP_AMP] = ACTIONS(3477),
    [anon_sym_AMP] = ACTIONS(3475),
    [anon_sym___extension__] = ACTIONS(3475),
    [anon_sym_typedef] = ACTIONS(3475),
    [anon_sym_in] = ACTIONS(3475),
    [anon_sym_out] = ACTIONS(3475),
    [anon_sym_inout] = ACTIONS(3475),
    [anon_sym_extern] = ACTIONS(3475),
    [anon_sym___attribute__] = ACTIONS(3475),
    [anon_sym_COLON_COLON] = ACTIONS(3477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3477),
    [anon_sym___declspec] = ACTIONS(3475),
    [anon_sym___based] = ACTIONS(3475),
    [anon_sym_signed] = ACTIONS(3475),
    [anon_sym_unsigned] = ACTIONS(3475),
    [anon_sym_long] = ACTIONS(3475),
    [anon_sym_short] = ACTIONS(3475),
    [anon_sym_LBRACK] = ACTIONS(3475),
    [anon_sym_static] = ACTIONS(3475),
    [anon_sym_register] = ACTIONS(3475),
    [anon_sym_inline] = ACTIONS(3475),
    [anon_sym___inline] = ACTIONS(3475),
    [anon_sym___inline__] = ACTIONS(3475),
    [anon_sym___forceinline] = ACTIONS(3475),
    [anon_sym_thread_local] = ACTIONS(3475),
    [anon_sym___thread] = ACTIONS(3475),
    [anon_sym_const] = ACTIONS(3475),
    [anon_sym_constexpr] = ACTIONS(3475),
    [anon_sym_volatile] = ACTIONS(3475),
    [anon_sym_restrict] = ACTIONS(3475),
    [anon_sym___restrict__] = ACTIONS(3475),
    [anon_sym__Atomic] = ACTIONS(3475),
    [anon_sym__Noreturn] = ACTIONS(3475),
    [anon_sym_noreturn] = ACTIONS(3475),
    [anon_sym_mutable] = ACTIONS(3475),
    [anon_sym_constinit] = ACTIONS(3475),
    [anon_sym_consteval] = ACTIONS(3475),
    [anon_sym_alignas] = ACTIONS(3475),
    [anon_sym__Alignas] = ACTIONS(3475),
    [sym_primitive_type] = ACTIONS(3475),
    [anon_sym_enum] = ACTIONS(3475),
    [anon_sym_class] = ACTIONS(3475),
    [anon_sym_struct] = ACTIONS(3475),
    [anon_sym_union] = ACTIONS(3475),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3475),
    [anon_sym_let] = ACTIONS(3475),
    [anon_sym_This] = ACTIONS(3475),
    [anon_sym_decltype] = ACTIONS(3475),
    [sym_virtual] = ACTIONS(3475),
    [anon_sym_explicit] = ACTIONS(3475),
    [anon_sym_typename] = ACTIONS(3475),
    [anon_sym_template] = ACTIONS(3475),
    [anon_sym_operator] = ACTIONS(3475),
    [anon_sym_friend] = ACTIONS(3475),
    [anon_sym_public] = ACTIONS(3475),
    [anon_sym_private] = ACTIONS(3475),
    [anon_sym_protected] = ACTIONS(3475),
    [anon_sym_using] = ACTIONS(3475),
    [anon_sym_static_assert] = ACTIONS(3475),
    [anon_sym_precise] = ACTIONS(3475),
    [anon_sym_shared] = ACTIONS(3475),
    [anon_sym_groupshared] = ACTIONS(3475),
    [anon_sym_uniform] = ACTIONS(3475),
    [anon_sym_row_major] = ACTIONS(3475),
    [anon_sym_column_major] = ACTIONS(3475),
    [anon_sym_globallycoherent] = ACTIONS(3475),
    [anon_sym_centroid] = ACTIONS(3475),
    [anon_sym_noperspective] = ACTIONS(3475),
    [anon_sym_nointerpolation] = ACTIONS(3475),
    [anon_sym_sample] = ACTIONS(3475),
    [anon_sym_linear] = ACTIONS(3475),
    [anon_sym_snorm] = ACTIONS(3475),
    [anon_sym_unorm] = ACTIONS(3475),
    [anon_sym_point] = ACTIONS(3475),
    [anon_sym_line] = ACTIONS(3475),
    [anon_sym_triangleadj] = ACTIONS(3475),
    [anon_sym_lineadj] = ACTIONS(3475),
    [anon_sym_triangle] = ACTIONS(3475),
    [anon_sym_interface] = ACTIONS(3475),
    [anon_sym_extension] = ACTIONS(3475),
    [anon_sym___init] = ACTIONS(3475),
    [anon_sym___subscript] = ACTIONS(3475),
    [anon_sym_property] = ACTIONS(3475),
    [anon_sym_associatedtype] = ACTIONS(3475),
  },
  [1551] = {
    [sym_identifier] = ACTIONS(3505),
    [aux_sym_preproc_def_token1] = ACTIONS(3505),
    [aux_sym_preproc_if_token1] = ACTIONS(3505),
    [aux_sym_preproc_if_token2] = ACTIONS(3505),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3505),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3505),
    [aux_sym_preproc_else_token1] = ACTIONS(3505),
    [aux_sym_preproc_elif_token1] = ACTIONS(3505),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3505),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3505),
    [sym_preproc_directive] = ACTIONS(3505),
    [anon_sym_LPAREN2] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3507),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym___extension__] = ACTIONS(3505),
    [anon_sym_typedef] = ACTIONS(3505),
    [anon_sym_in] = ACTIONS(3505),
    [anon_sym_out] = ACTIONS(3505),
    [anon_sym_inout] = ACTIONS(3505),
    [anon_sym_extern] = ACTIONS(3505),
    [anon_sym___attribute__] = ACTIONS(3505),
    [anon_sym_COLON_COLON] = ACTIONS(3507),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3507),
    [anon_sym___declspec] = ACTIONS(3505),
    [anon_sym___based] = ACTIONS(3505),
    [anon_sym_signed] = ACTIONS(3505),
    [anon_sym_unsigned] = ACTIONS(3505),
    [anon_sym_long] = ACTIONS(3505),
    [anon_sym_short] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_static] = ACTIONS(3505),
    [anon_sym_register] = ACTIONS(3505),
    [anon_sym_inline] = ACTIONS(3505),
    [anon_sym___inline] = ACTIONS(3505),
    [anon_sym___inline__] = ACTIONS(3505),
    [anon_sym___forceinline] = ACTIONS(3505),
    [anon_sym_thread_local] = ACTIONS(3505),
    [anon_sym___thread] = ACTIONS(3505),
    [anon_sym_const] = ACTIONS(3505),
    [anon_sym_constexpr] = ACTIONS(3505),
    [anon_sym_volatile] = ACTIONS(3505),
    [anon_sym_restrict] = ACTIONS(3505),
    [anon_sym___restrict__] = ACTIONS(3505),
    [anon_sym__Atomic] = ACTIONS(3505),
    [anon_sym__Noreturn] = ACTIONS(3505),
    [anon_sym_noreturn] = ACTIONS(3505),
    [anon_sym_mutable] = ACTIONS(3505),
    [anon_sym_constinit] = ACTIONS(3505),
    [anon_sym_consteval] = ACTIONS(3505),
    [anon_sym_alignas] = ACTIONS(3505),
    [anon_sym__Alignas] = ACTIONS(3505),
    [sym_primitive_type] = ACTIONS(3505),
    [anon_sym_enum] = ACTIONS(3505),
    [anon_sym_class] = ACTIONS(3505),
    [anon_sym_struct] = ACTIONS(3505),
    [anon_sym_union] = ACTIONS(3505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_This] = ACTIONS(3505),
    [anon_sym_decltype] = ACTIONS(3505),
    [sym_virtual] = ACTIONS(3505),
    [anon_sym_explicit] = ACTIONS(3505),
    [anon_sym_typename] = ACTIONS(3505),
    [anon_sym_template] = ACTIONS(3505),
    [anon_sym_operator] = ACTIONS(3505),
    [anon_sym_friend] = ACTIONS(3505),
    [anon_sym_public] = ACTIONS(3505),
    [anon_sym_private] = ACTIONS(3505),
    [anon_sym_protected] = ACTIONS(3505),
    [anon_sym_using] = ACTIONS(3505),
    [anon_sym_static_assert] = ACTIONS(3505),
    [anon_sym_precise] = ACTIONS(3505),
    [anon_sym_shared] = ACTIONS(3505),
    [anon_sym_groupshared] = ACTIONS(3505),
    [anon_sym_uniform] = ACTIONS(3505),
    [anon_sym_row_major] = ACTIONS(3505),
    [anon_sym_column_major] = ACTIONS(3505),
    [anon_sym_globallycoherent] = ACTIONS(3505),
    [anon_sym_centroid] = ACTIONS(3505),
    [anon_sym_noperspective] = ACTIONS(3505),
    [anon_sym_nointerpolation] = ACTIONS(3505),
    [anon_sym_sample] = ACTIONS(3505),
    [anon_sym_linear] = ACTIONS(3505),
    [anon_sym_snorm] = ACTIONS(3505),
    [anon_sym_unorm] = ACTIONS(3505),
    [anon_sym_point] = ACTIONS(3505),
    [anon_sym_line] = ACTIONS(3505),
    [anon_sym_triangleadj] = ACTIONS(3505),
    [anon_sym_lineadj] = ACTIONS(3505),
    [anon_sym_triangle] = ACTIONS(3505),
    [anon_sym_interface] = ACTIONS(3505),
    [anon_sym_extension] = ACTIONS(3505),
    [anon_sym___init] = ACTIONS(3505),
    [anon_sym___subscript] = ACTIONS(3505),
    [anon_sym_property] = ACTIONS(3505),
    [anon_sym_associatedtype] = ACTIONS(3505),
  },
  [1552] = {
    [sym__declaration_modifiers] = STATE(2299),
    [sym__declaration_specifiers] = STATE(4856),
    [sym_attribute_specifier] = STATE(2299),
    [sym_attribute_declaration] = STATE(2299),
    [sym_ms_declspec_modifier] = STATE(2299),
    [sym_storage_class_specifier] = STATE(2299),
    [sym_type_qualifier] = STATE(2299),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2694),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_parameter_declaration] = STATE(9988),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_optional_parameter_declaration] = STATE(9988),
    [sym_variadic_parameter_declaration] = STATE(9988),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8090),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2299),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2299),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(5014),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_out] = ACTIONS(2293),
    [anon_sym_inout] = ACTIONS(2293),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(5024),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2299),
    [anon_sym_class] = ACTIONS(2301),
    [anon_sym_struct] = ACTIONS(2303),
    [anon_sym_union] = ACTIONS(2305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(2293),
    [anon_sym_typename] = ACTIONS(2329),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2341),
    [anon_sym_extension] = ACTIONS(2343),
  },
  [1553] = {
    [sym_identifier] = ACTIONS(3633),
    [aux_sym_preproc_def_token1] = ACTIONS(3633),
    [aux_sym_preproc_if_token1] = ACTIONS(3633),
    [aux_sym_preproc_if_token2] = ACTIONS(3633),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3633),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3633),
    [aux_sym_preproc_else_token1] = ACTIONS(3633),
    [aux_sym_preproc_elif_token1] = ACTIONS(3633),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3633),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3633),
    [sym_preproc_directive] = ACTIONS(3633),
    [anon_sym_LPAREN2] = ACTIONS(3635),
    [anon_sym_TILDE] = ACTIONS(3635),
    [anon_sym_STAR] = ACTIONS(3635),
    [anon_sym_AMP_AMP] = ACTIONS(3635),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym___extension__] = ACTIONS(3633),
    [anon_sym_typedef] = ACTIONS(3633),
    [anon_sym_in] = ACTIONS(3633),
    [anon_sym_out] = ACTIONS(3633),
    [anon_sym_inout] = ACTIONS(3633),
    [anon_sym_extern] = ACTIONS(3633),
    [anon_sym___attribute__] = ACTIONS(3633),
    [anon_sym_COLON_COLON] = ACTIONS(3635),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3635),
    [anon_sym___declspec] = ACTIONS(3633),
    [anon_sym___based] = ACTIONS(3633),
    [anon_sym_signed] = ACTIONS(3633),
    [anon_sym_unsigned] = ACTIONS(3633),
    [anon_sym_long] = ACTIONS(3633),
    [anon_sym_short] = ACTIONS(3633),
    [anon_sym_LBRACK] = ACTIONS(3633),
    [anon_sym_static] = ACTIONS(3633),
    [anon_sym_register] = ACTIONS(3633),
    [anon_sym_inline] = ACTIONS(3633),
    [anon_sym___inline] = ACTIONS(3633),
    [anon_sym___inline__] = ACTIONS(3633),
    [anon_sym___forceinline] = ACTIONS(3633),
    [anon_sym_thread_local] = ACTIONS(3633),
    [anon_sym___thread] = ACTIONS(3633),
    [anon_sym_const] = ACTIONS(3633),
    [anon_sym_constexpr] = ACTIONS(3633),
    [anon_sym_volatile] = ACTIONS(3633),
    [anon_sym_restrict] = ACTIONS(3633),
    [anon_sym___restrict__] = ACTIONS(3633),
    [anon_sym__Atomic] = ACTIONS(3633),
    [anon_sym__Noreturn] = ACTIONS(3633),
    [anon_sym_noreturn] = ACTIONS(3633),
    [anon_sym_mutable] = ACTIONS(3633),
    [anon_sym_constinit] = ACTIONS(3633),
    [anon_sym_consteval] = ACTIONS(3633),
    [anon_sym_alignas] = ACTIONS(3633),
    [anon_sym__Alignas] = ACTIONS(3633),
    [sym_primitive_type] = ACTIONS(3633),
    [anon_sym_enum] = ACTIONS(3633),
    [anon_sym_class] = ACTIONS(3633),
    [anon_sym_struct] = ACTIONS(3633),
    [anon_sym_union] = ACTIONS(3633),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3633),
    [anon_sym_let] = ACTIONS(3633),
    [anon_sym_This] = ACTIONS(3633),
    [anon_sym_decltype] = ACTIONS(3633),
    [sym_virtual] = ACTIONS(3633),
    [anon_sym_explicit] = ACTIONS(3633),
    [anon_sym_typename] = ACTIONS(3633),
    [anon_sym_template] = ACTIONS(3633),
    [anon_sym_operator] = ACTIONS(3633),
    [anon_sym_friend] = ACTIONS(3633),
    [anon_sym_public] = ACTIONS(3633),
    [anon_sym_private] = ACTIONS(3633),
    [anon_sym_protected] = ACTIONS(3633),
    [anon_sym_using] = ACTIONS(3633),
    [anon_sym_static_assert] = ACTIONS(3633),
    [anon_sym_precise] = ACTIONS(3633),
    [anon_sym_shared] = ACTIONS(3633),
    [anon_sym_groupshared] = ACTIONS(3633),
    [anon_sym_uniform] = ACTIONS(3633),
    [anon_sym_row_major] = ACTIONS(3633),
    [anon_sym_column_major] = ACTIONS(3633),
    [anon_sym_globallycoherent] = ACTIONS(3633),
    [anon_sym_centroid] = ACTIONS(3633),
    [anon_sym_noperspective] = ACTIONS(3633),
    [anon_sym_nointerpolation] = ACTIONS(3633),
    [anon_sym_sample] = ACTIONS(3633),
    [anon_sym_linear] = ACTIONS(3633),
    [anon_sym_snorm] = ACTIONS(3633),
    [anon_sym_unorm] = ACTIONS(3633),
    [anon_sym_point] = ACTIONS(3633),
    [anon_sym_line] = ACTIONS(3633),
    [anon_sym_triangleadj] = ACTIONS(3633),
    [anon_sym_lineadj] = ACTIONS(3633),
    [anon_sym_triangle] = ACTIONS(3633),
    [anon_sym_interface] = ACTIONS(3633),
    [anon_sym_extension] = ACTIONS(3633),
    [anon_sym___init] = ACTIONS(3633),
    [anon_sym___subscript] = ACTIONS(3633),
    [anon_sym_property] = ACTIONS(3633),
    [anon_sym_associatedtype] = ACTIONS(3633),
  },
  [1554] = {
    [sym_identifier] = ACTIONS(3645),
    [aux_sym_preproc_def_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token2] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3645),
    [aux_sym_preproc_else_token1] = ACTIONS(3645),
    [aux_sym_preproc_elif_token1] = ACTIONS(3645),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3645),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3645),
    [sym_preproc_directive] = ACTIONS(3645),
    [anon_sym_LPAREN2] = ACTIONS(3647),
    [anon_sym_TILDE] = ACTIONS(3647),
    [anon_sym_STAR] = ACTIONS(3647),
    [anon_sym_AMP_AMP] = ACTIONS(3647),
    [anon_sym_AMP] = ACTIONS(3645),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3645),
    [anon_sym_in] = ACTIONS(3645),
    [anon_sym_out] = ACTIONS(3645),
    [anon_sym_inout] = ACTIONS(3645),
    [anon_sym_extern] = ACTIONS(3645),
    [anon_sym___attribute__] = ACTIONS(3645),
    [anon_sym_COLON_COLON] = ACTIONS(3647),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3647),
    [anon_sym___declspec] = ACTIONS(3645),
    [anon_sym___based] = ACTIONS(3645),
    [anon_sym_signed] = ACTIONS(3645),
    [anon_sym_unsigned] = ACTIONS(3645),
    [anon_sym_long] = ACTIONS(3645),
    [anon_sym_short] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_static] = ACTIONS(3645),
    [anon_sym_register] = ACTIONS(3645),
    [anon_sym_inline] = ACTIONS(3645),
    [anon_sym___inline] = ACTIONS(3645),
    [anon_sym___inline__] = ACTIONS(3645),
    [anon_sym___forceinline] = ACTIONS(3645),
    [anon_sym_thread_local] = ACTIONS(3645),
    [anon_sym___thread] = ACTIONS(3645),
    [anon_sym_const] = ACTIONS(3645),
    [anon_sym_constexpr] = ACTIONS(3645),
    [anon_sym_volatile] = ACTIONS(3645),
    [anon_sym_restrict] = ACTIONS(3645),
    [anon_sym___restrict__] = ACTIONS(3645),
    [anon_sym__Atomic] = ACTIONS(3645),
    [anon_sym__Noreturn] = ACTIONS(3645),
    [anon_sym_noreturn] = ACTIONS(3645),
    [anon_sym_mutable] = ACTIONS(3645),
    [anon_sym_constinit] = ACTIONS(3645),
    [anon_sym_consteval] = ACTIONS(3645),
    [anon_sym_alignas] = ACTIONS(3645),
    [anon_sym__Alignas] = ACTIONS(3645),
    [sym_primitive_type] = ACTIONS(3645),
    [anon_sym_enum] = ACTIONS(3645),
    [anon_sym_class] = ACTIONS(3645),
    [anon_sym_struct] = ACTIONS(3645),
    [anon_sym_union] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3645),
    [anon_sym_let] = ACTIONS(3645),
    [anon_sym_This] = ACTIONS(3645),
    [anon_sym_decltype] = ACTIONS(3645),
    [sym_virtual] = ACTIONS(3645),
    [anon_sym_explicit] = ACTIONS(3645),
    [anon_sym_typename] = ACTIONS(3645),
    [anon_sym_template] = ACTIONS(3645),
    [anon_sym_operator] = ACTIONS(3645),
    [anon_sym_friend] = ACTIONS(3645),
    [anon_sym_public] = ACTIONS(3645),
    [anon_sym_private] = ACTIONS(3645),
    [anon_sym_protected] = ACTIONS(3645),
    [anon_sym_using] = ACTIONS(3645),
    [anon_sym_static_assert] = ACTIONS(3645),
    [anon_sym_precise] = ACTIONS(3645),
    [anon_sym_shared] = ACTIONS(3645),
    [anon_sym_groupshared] = ACTIONS(3645),
    [anon_sym_uniform] = ACTIONS(3645),
    [anon_sym_row_major] = ACTIONS(3645),
    [anon_sym_column_major] = ACTIONS(3645),
    [anon_sym_globallycoherent] = ACTIONS(3645),
    [anon_sym_centroid] = ACTIONS(3645),
    [anon_sym_noperspective] = ACTIONS(3645),
    [anon_sym_nointerpolation] = ACTIONS(3645),
    [anon_sym_sample] = ACTIONS(3645),
    [anon_sym_linear] = ACTIONS(3645),
    [anon_sym_snorm] = ACTIONS(3645),
    [anon_sym_unorm] = ACTIONS(3645),
    [anon_sym_point] = ACTIONS(3645),
    [anon_sym_line] = ACTIONS(3645),
    [anon_sym_triangleadj] = ACTIONS(3645),
    [anon_sym_lineadj] = ACTIONS(3645),
    [anon_sym_triangle] = ACTIONS(3645),
    [anon_sym_interface] = ACTIONS(3645),
    [anon_sym_extension] = ACTIONS(3645),
    [anon_sym___init] = ACTIONS(3645),
    [anon_sym___subscript] = ACTIONS(3645),
    [anon_sym_property] = ACTIONS(3645),
    [anon_sym_associatedtype] = ACTIONS(3645),
  },
  [1555] = {
    [sym_expression] = STATE(4165),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym__unary_left_fold] = STATE(10726),
    [sym__unary_right_fold] = STATE(10725),
    [sym__binary_fold] = STATE(10724),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1556] = {
    [sym_identifier] = ACTIONS(3645),
    [aux_sym_preproc_def_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token2] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3645),
    [aux_sym_preproc_else_token1] = ACTIONS(3645),
    [aux_sym_preproc_elif_token1] = ACTIONS(3645),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3645),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3645),
    [sym_preproc_directive] = ACTIONS(3645),
    [anon_sym_LPAREN2] = ACTIONS(3647),
    [anon_sym_TILDE] = ACTIONS(3647),
    [anon_sym_STAR] = ACTIONS(3647),
    [anon_sym_AMP_AMP] = ACTIONS(3647),
    [anon_sym_AMP] = ACTIONS(3645),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3645),
    [anon_sym_in] = ACTIONS(3645),
    [anon_sym_out] = ACTIONS(3645),
    [anon_sym_inout] = ACTIONS(3645),
    [anon_sym_extern] = ACTIONS(3645),
    [anon_sym___attribute__] = ACTIONS(3645),
    [anon_sym_COLON_COLON] = ACTIONS(3647),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3647),
    [anon_sym___declspec] = ACTIONS(3645),
    [anon_sym___based] = ACTIONS(3645),
    [anon_sym_signed] = ACTIONS(3645),
    [anon_sym_unsigned] = ACTIONS(3645),
    [anon_sym_long] = ACTIONS(3645),
    [anon_sym_short] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_static] = ACTIONS(3645),
    [anon_sym_register] = ACTIONS(3645),
    [anon_sym_inline] = ACTIONS(3645),
    [anon_sym___inline] = ACTIONS(3645),
    [anon_sym___inline__] = ACTIONS(3645),
    [anon_sym___forceinline] = ACTIONS(3645),
    [anon_sym_thread_local] = ACTIONS(3645),
    [anon_sym___thread] = ACTIONS(3645),
    [anon_sym_const] = ACTIONS(3645),
    [anon_sym_constexpr] = ACTIONS(3645),
    [anon_sym_volatile] = ACTIONS(3645),
    [anon_sym_restrict] = ACTIONS(3645),
    [anon_sym___restrict__] = ACTIONS(3645),
    [anon_sym__Atomic] = ACTIONS(3645),
    [anon_sym__Noreturn] = ACTIONS(3645),
    [anon_sym_noreturn] = ACTIONS(3645),
    [anon_sym_mutable] = ACTIONS(3645),
    [anon_sym_constinit] = ACTIONS(3645),
    [anon_sym_consteval] = ACTIONS(3645),
    [anon_sym_alignas] = ACTIONS(3645),
    [anon_sym__Alignas] = ACTIONS(3645),
    [sym_primitive_type] = ACTIONS(3645),
    [anon_sym_enum] = ACTIONS(3645),
    [anon_sym_class] = ACTIONS(3645),
    [anon_sym_struct] = ACTIONS(3645),
    [anon_sym_union] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3645),
    [anon_sym_let] = ACTIONS(3645),
    [anon_sym_This] = ACTIONS(3645),
    [anon_sym_decltype] = ACTIONS(3645),
    [sym_virtual] = ACTIONS(3645),
    [anon_sym_explicit] = ACTIONS(3645),
    [anon_sym_typename] = ACTIONS(3645),
    [anon_sym_template] = ACTIONS(3645),
    [anon_sym_operator] = ACTIONS(3645),
    [anon_sym_friend] = ACTIONS(3645),
    [anon_sym_public] = ACTIONS(3645),
    [anon_sym_private] = ACTIONS(3645),
    [anon_sym_protected] = ACTIONS(3645),
    [anon_sym_using] = ACTIONS(3645),
    [anon_sym_static_assert] = ACTIONS(3645),
    [anon_sym_precise] = ACTIONS(3645),
    [anon_sym_shared] = ACTIONS(3645),
    [anon_sym_groupshared] = ACTIONS(3645),
    [anon_sym_uniform] = ACTIONS(3645),
    [anon_sym_row_major] = ACTIONS(3645),
    [anon_sym_column_major] = ACTIONS(3645),
    [anon_sym_globallycoherent] = ACTIONS(3645),
    [anon_sym_centroid] = ACTIONS(3645),
    [anon_sym_noperspective] = ACTIONS(3645),
    [anon_sym_nointerpolation] = ACTIONS(3645),
    [anon_sym_sample] = ACTIONS(3645),
    [anon_sym_linear] = ACTIONS(3645),
    [anon_sym_snorm] = ACTIONS(3645),
    [anon_sym_unorm] = ACTIONS(3645),
    [anon_sym_point] = ACTIONS(3645),
    [anon_sym_line] = ACTIONS(3645),
    [anon_sym_triangleadj] = ACTIONS(3645),
    [anon_sym_lineadj] = ACTIONS(3645),
    [anon_sym_triangle] = ACTIONS(3645),
    [anon_sym_interface] = ACTIONS(3645),
    [anon_sym_extension] = ACTIONS(3645),
    [anon_sym___init] = ACTIONS(3645),
    [anon_sym___subscript] = ACTIONS(3645),
    [anon_sym_property] = ACTIONS(3645),
    [anon_sym_associatedtype] = ACTIONS(3645),
  },
  [1557] = {
    [sym_identifier] = ACTIONS(3691),
    [aux_sym_preproc_def_token1] = ACTIONS(3691),
    [aux_sym_preproc_if_token1] = ACTIONS(3691),
    [aux_sym_preproc_if_token2] = ACTIONS(3691),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3691),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3691),
    [aux_sym_preproc_else_token1] = ACTIONS(3691),
    [aux_sym_preproc_elif_token1] = ACTIONS(3691),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3691),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3691),
    [sym_preproc_directive] = ACTIONS(3691),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3693),
    [anon_sym_STAR] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_AMP] = ACTIONS(3691),
    [anon_sym___extension__] = ACTIONS(3691),
    [anon_sym_typedef] = ACTIONS(3691),
    [anon_sym_in] = ACTIONS(3691),
    [anon_sym_out] = ACTIONS(3691),
    [anon_sym_inout] = ACTIONS(3691),
    [anon_sym_extern] = ACTIONS(3691),
    [anon_sym___attribute__] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3693),
    [anon_sym___declspec] = ACTIONS(3691),
    [anon_sym___based] = ACTIONS(3691),
    [anon_sym_signed] = ACTIONS(3691),
    [anon_sym_unsigned] = ACTIONS(3691),
    [anon_sym_long] = ACTIONS(3691),
    [anon_sym_short] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(3691),
    [anon_sym_static] = ACTIONS(3691),
    [anon_sym_register] = ACTIONS(3691),
    [anon_sym_inline] = ACTIONS(3691),
    [anon_sym___inline] = ACTIONS(3691),
    [anon_sym___inline__] = ACTIONS(3691),
    [anon_sym___forceinline] = ACTIONS(3691),
    [anon_sym_thread_local] = ACTIONS(3691),
    [anon_sym___thread] = ACTIONS(3691),
    [anon_sym_const] = ACTIONS(3691),
    [anon_sym_constexpr] = ACTIONS(3691),
    [anon_sym_volatile] = ACTIONS(3691),
    [anon_sym_restrict] = ACTIONS(3691),
    [anon_sym___restrict__] = ACTIONS(3691),
    [anon_sym__Atomic] = ACTIONS(3691),
    [anon_sym__Noreturn] = ACTIONS(3691),
    [anon_sym_noreturn] = ACTIONS(3691),
    [anon_sym_mutable] = ACTIONS(3691),
    [anon_sym_constinit] = ACTIONS(3691),
    [anon_sym_consteval] = ACTIONS(3691),
    [anon_sym_alignas] = ACTIONS(3691),
    [anon_sym__Alignas] = ACTIONS(3691),
    [sym_primitive_type] = ACTIONS(3691),
    [anon_sym_enum] = ACTIONS(3691),
    [anon_sym_class] = ACTIONS(3691),
    [anon_sym_struct] = ACTIONS(3691),
    [anon_sym_union] = ACTIONS(3691),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3691),
    [anon_sym_let] = ACTIONS(3691),
    [anon_sym_This] = ACTIONS(3691),
    [anon_sym_decltype] = ACTIONS(3691),
    [sym_virtual] = ACTIONS(3691),
    [anon_sym_explicit] = ACTIONS(3691),
    [anon_sym_typename] = ACTIONS(3691),
    [anon_sym_template] = ACTIONS(3691),
    [anon_sym_operator] = ACTIONS(3691),
    [anon_sym_friend] = ACTIONS(3691),
    [anon_sym_public] = ACTIONS(3691),
    [anon_sym_private] = ACTIONS(3691),
    [anon_sym_protected] = ACTIONS(3691),
    [anon_sym_using] = ACTIONS(3691),
    [anon_sym_static_assert] = ACTIONS(3691),
    [anon_sym_precise] = ACTIONS(3691),
    [anon_sym_shared] = ACTIONS(3691),
    [anon_sym_groupshared] = ACTIONS(3691),
    [anon_sym_uniform] = ACTIONS(3691),
    [anon_sym_row_major] = ACTIONS(3691),
    [anon_sym_column_major] = ACTIONS(3691),
    [anon_sym_globallycoherent] = ACTIONS(3691),
    [anon_sym_centroid] = ACTIONS(3691),
    [anon_sym_noperspective] = ACTIONS(3691),
    [anon_sym_nointerpolation] = ACTIONS(3691),
    [anon_sym_sample] = ACTIONS(3691),
    [anon_sym_linear] = ACTIONS(3691),
    [anon_sym_snorm] = ACTIONS(3691),
    [anon_sym_unorm] = ACTIONS(3691),
    [anon_sym_point] = ACTIONS(3691),
    [anon_sym_line] = ACTIONS(3691),
    [anon_sym_triangleadj] = ACTIONS(3691),
    [anon_sym_lineadj] = ACTIONS(3691),
    [anon_sym_triangle] = ACTIONS(3691),
    [anon_sym_interface] = ACTIONS(3691),
    [anon_sym_extension] = ACTIONS(3691),
    [anon_sym___init] = ACTIONS(3691),
    [anon_sym___subscript] = ACTIONS(3691),
    [anon_sym_property] = ACTIONS(3691),
    [anon_sym_associatedtype] = ACTIONS(3691),
  },
  [1558] = {
    [sym_identifier] = ACTIONS(3597),
    [aux_sym_preproc_def_token1] = ACTIONS(3597),
    [aux_sym_preproc_if_token1] = ACTIONS(3597),
    [aux_sym_preproc_if_token2] = ACTIONS(3597),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3597),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3597),
    [aux_sym_preproc_else_token1] = ACTIONS(3597),
    [aux_sym_preproc_elif_token1] = ACTIONS(3597),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3597),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3597),
    [sym_preproc_directive] = ACTIONS(3597),
    [anon_sym_LPAREN2] = ACTIONS(3599),
    [anon_sym_TILDE] = ACTIONS(3599),
    [anon_sym_STAR] = ACTIONS(3599),
    [anon_sym_AMP_AMP] = ACTIONS(3599),
    [anon_sym_AMP] = ACTIONS(3597),
    [anon_sym___extension__] = ACTIONS(3597),
    [anon_sym_typedef] = ACTIONS(3597),
    [anon_sym_in] = ACTIONS(3597),
    [anon_sym_out] = ACTIONS(3597),
    [anon_sym_inout] = ACTIONS(3597),
    [anon_sym_extern] = ACTIONS(3597),
    [anon_sym___attribute__] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3599),
    [anon_sym___declspec] = ACTIONS(3597),
    [anon_sym___based] = ACTIONS(3597),
    [anon_sym_signed] = ACTIONS(3597),
    [anon_sym_unsigned] = ACTIONS(3597),
    [anon_sym_long] = ACTIONS(3597),
    [anon_sym_short] = ACTIONS(3597),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_static] = ACTIONS(3597),
    [anon_sym_register] = ACTIONS(3597),
    [anon_sym_inline] = ACTIONS(3597),
    [anon_sym___inline] = ACTIONS(3597),
    [anon_sym___inline__] = ACTIONS(3597),
    [anon_sym___forceinline] = ACTIONS(3597),
    [anon_sym_thread_local] = ACTIONS(3597),
    [anon_sym___thread] = ACTIONS(3597),
    [anon_sym_const] = ACTIONS(3597),
    [anon_sym_constexpr] = ACTIONS(3597),
    [anon_sym_volatile] = ACTIONS(3597),
    [anon_sym_restrict] = ACTIONS(3597),
    [anon_sym___restrict__] = ACTIONS(3597),
    [anon_sym__Atomic] = ACTIONS(3597),
    [anon_sym__Noreturn] = ACTIONS(3597),
    [anon_sym_noreturn] = ACTIONS(3597),
    [anon_sym_mutable] = ACTIONS(3597),
    [anon_sym_constinit] = ACTIONS(3597),
    [anon_sym_consteval] = ACTIONS(3597),
    [anon_sym_alignas] = ACTIONS(3597),
    [anon_sym__Alignas] = ACTIONS(3597),
    [sym_primitive_type] = ACTIONS(3597),
    [anon_sym_enum] = ACTIONS(3597),
    [anon_sym_class] = ACTIONS(3597),
    [anon_sym_struct] = ACTIONS(3597),
    [anon_sym_union] = ACTIONS(3597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3597),
    [anon_sym_let] = ACTIONS(3597),
    [anon_sym_This] = ACTIONS(3597),
    [anon_sym_decltype] = ACTIONS(3597),
    [sym_virtual] = ACTIONS(3597),
    [anon_sym_explicit] = ACTIONS(3597),
    [anon_sym_typename] = ACTIONS(3597),
    [anon_sym_template] = ACTIONS(3597),
    [anon_sym_operator] = ACTIONS(3597),
    [anon_sym_friend] = ACTIONS(3597),
    [anon_sym_public] = ACTIONS(3597),
    [anon_sym_private] = ACTIONS(3597),
    [anon_sym_protected] = ACTIONS(3597),
    [anon_sym_using] = ACTIONS(3597),
    [anon_sym_static_assert] = ACTIONS(3597),
    [anon_sym_precise] = ACTIONS(3597),
    [anon_sym_shared] = ACTIONS(3597),
    [anon_sym_groupshared] = ACTIONS(3597),
    [anon_sym_uniform] = ACTIONS(3597),
    [anon_sym_row_major] = ACTIONS(3597),
    [anon_sym_column_major] = ACTIONS(3597),
    [anon_sym_globallycoherent] = ACTIONS(3597),
    [anon_sym_centroid] = ACTIONS(3597),
    [anon_sym_noperspective] = ACTIONS(3597),
    [anon_sym_nointerpolation] = ACTIONS(3597),
    [anon_sym_sample] = ACTIONS(3597),
    [anon_sym_linear] = ACTIONS(3597),
    [anon_sym_snorm] = ACTIONS(3597),
    [anon_sym_unorm] = ACTIONS(3597),
    [anon_sym_point] = ACTIONS(3597),
    [anon_sym_line] = ACTIONS(3597),
    [anon_sym_triangleadj] = ACTIONS(3597),
    [anon_sym_lineadj] = ACTIONS(3597),
    [anon_sym_triangle] = ACTIONS(3597),
    [anon_sym_interface] = ACTIONS(3597),
    [anon_sym_extension] = ACTIONS(3597),
    [anon_sym___init] = ACTIONS(3597),
    [anon_sym___subscript] = ACTIONS(3597),
    [anon_sym_property] = ACTIONS(3597),
    [anon_sym_associatedtype] = ACTIONS(3597),
  },
  [1559] = {
    [sym_identifier] = ACTIONS(3531),
    [aux_sym_preproc_def_token1] = ACTIONS(3531),
    [aux_sym_preproc_if_token1] = ACTIONS(3531),
    [aux_sym_preproc_if_token2] = ACTIONS(3531),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3531),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3531),
    [aux_sym_preproc_else_token1] = ACTIONS(3531),
    [aux_sym_preproc_elif_token1] = ACTIONS(3531),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3531),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3531),
    [sym_preproc_directive] = ACTIONS(3531),
    [anon_sym_LPAREN2] = ACTIONS(3533),
    [anon_sym_TILDE] = ACTIONS(3533),
    [anon_sym_STAR] = ACTIONS(3533),
    [anon_sym_AMP_AMP] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym___extension__] = ACTIONS(3531),
    [anon_sym_typedef] = ACTIONS(3531),
    [anon_sym_in] = ACTIONS(3531),
    [anon_sym_out] = ACTIONS(3531),
    [anon_sym_inout] = ACTIONS(3531),
    [anon_sym_extern] = ACTIONS(3531),
    [anon_sym___attribute__] = ACTIONS(3531),
    [anon_sym_COLON_COLON] = ACTIONS(3533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3533),
    [anon_sym___declspec] = ACTIONS(3531),
    [anon_sym___based] = ACTIONS(3531),
    [anon_sym_signed] = ACTIONS(3531),
    [anon_sym_unsigned] = ACTIONS(3531),
    [anon_sym_long] = ACTIONS(3531),
    [anon_sym_short] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_static] = ACTIONS(3531),
    [anon_sym_register] = ACTIONS(3531),
    [anon_sym_inline] = ACTIONS(3531),
    [anon_sym___inline] = ACTIONS(3531),
    [anon_sym___inline__] = ACTIONS(3531),
    [anon_sym___forceinline] = ACTIONS(3531),
    [anon_sym_thread_local] = ACTIONS(3531),
    [anon_sym___thread] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3531),
    [anon_sym_constexpr] = ACTIONS(3531),
    [anon_sym_volatile] = ACTIONS(3531),
    [anon_sym_restrict] = ACTIONS(3531),
    [anon_sym___restrict__] = ACTIONS(3531),
    [anon_sym__Atomic] = ACTIONS(3531),
    [anon_sym__Noreturn] = ACTIONS(3531),
    [anon_sym_noreturn] = ACTIONS(3531),
    [anon_sym_mutable] = ACTIONS(3531),
    [anon_sym_constinit] = ACTIONS(3531),
    [anon_sym_consteval] = ACTIONS(3531),
    [anon_sym_alignas] = ACTIONS(3531),
    [anon_sym__Alignas] = ACTIONS(3531),
    [sym_primitive_type] = ACTIONS(3531),
    [anon_sym_enum] = ACTIONS(3531),
    [anon_sym_class] = ACTIONS(3531),
    [anon_sym_struct] = ACTIONS(3531),
    [anon_sym_union] = ACTIONS(3531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_This] = ACTIONS(3531),
    [anon_sym_decltype] = ACTIONS(3531),
    [sym_virtual] = ACTIONS(3531),
    [anon_sym_explicit] = ACTIONS(3531),
    [anon_sym_typename] = ACTIONS(3531),
    [anon_sym_template] = ACTIONS(3531),
    [anon_sym_operator] = ACTIONS(3531),
    [anon_sym_friend] = ACTIONS(3531),
    [anon_sym_public] = ACTIONS(3531),
    [anon_sym_private] = ACTIONS(3531),
    [anon_sym_protected] = ACTIONS(3531),
    [anon_sym_using] = ACTIONS(3531),
    [anon_sym_static_assert] = ACTIONS(3531),
    [anon_sym_precise] = ACTIONS(3531),
    [anon_sym_shared] = ACTIONS(3531),
    [anon_sym_groupshared] = ACTIONS(3531),
    [anon_sym_uniform] = ACTIONS(3531),
    [anon_sym_row_major] = ACTIONS(3531),
    [anon_sym_column_major] = ACTIONS(3531),
    [anon_sym_globallycoherent] = ACTIONS(3531),
    [anon_sym_centroid] = ACTIONS(3531),
    [anon_sym_noperspective] = ACTIONS(3531),
    [anon_sym_nointerpolation] = ACTIONS(3531),
    [anon_sym_sample] = ACTIONS(3531),
    [anon_sym_linear] = ACTIONS(3531),
    [anon_sym_snorm] = ACTIONS(3531),
    [anon_sym_unorm] = ACTIONS(3531),
    [anon_sym_point] = ACTIONS(3531),
    [anon_sym_line] = ACTIONS(3531),
    [anon_sym_triangleadj] = ACTIONS(3531),
    [anon_sym_lineadj] = ACTIONS(3531),
    [anon_sym_triangle] = ACTIONS(3531),
    [anon_sym_interface] = ACTIONS(3531),
    [anon_sym_extension] = ACTIONS(3531),
    [anon_sym___init] = ACTIONS(3531),
    [anon_sym___subscript] = ACTIONS(3531),
    [anon_sym_property] = ACTIONS(3531),
    [anon_sym_associatedtype] = ACTIONS(3531),
  },
  [1560] = {
    [sym_identifier] = ACTIONS(3673),
    [aux_sym_preproc_def_token1] = ACTIONS(3673),
    [aux_sym_preproc_if_token1] = ACTIONS(3673),
    [aux_sym_preproc_if_token2] = ACTIONS(3673),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3673),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3673),
    [aux_sym_preproc_else_token1] = ACTIONS(3673),
    [aux_sym_preproc_elif_token1] = ACTIONS(3673),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3673),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3673),
    [sym_preproc_directive] = ACTIONS(3673),
    [anon_sym_LPAREN2] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3673),
    [anon_sym___extension__] = ACTIONS(3673),
    [anon_sym_typedef] = ACTIONS(3673),
    [anon_sym_in] = ACTIONS(3673),
    [anon_sym_out] = ACTIONS(3673),
    [anon_sym_inout] = ACTIONS(3673),
    [anon_sym_extern] = ACTIONS(3673),
    [anon_sym___attribute__] = ACTIONS(3673),
    [anon_sym_COLON_COLON] = ACTIONS(3675),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3675),
    [anon_sym___declspec] = ACTIONS(3673),
    [anon_sym___based] = ACTIONS(3673),
    [anon_sym_signed] = ACTIONS(3673),
    [anon_sym_unsigned] = ACTIONS(3673),
    [anon_sym_long] = ACTIONS(3673),
    [anon_sym_short] = ACTIONS(3673),
    [anon_sym_LBRACK] = ACTIONS(3673),
    [anon_sym_static] = ACTIONS(3673),
    [anon_sym_register] = ACTIONS(3673),
    [anon_sym_inline] = ACTIONS(3673),
    [anon_sym___inline] = ACTIONS(3673),
    [anon_sym___inline__] = ACTIONS(3673),
    [anon_sym___forceinline] = ACTIONS(3673),
    [anon_sym_thread_local] = ACTIONS(3673),
    [anon_sym___thread] = ACTIONS(3673),
    [anon_sym_const] = ACTIONS(3673),
    [anon_sym_constexpr] = ACTIONS(3673),
    [anon_sym_volatile] = ACTIONS(3673),
    [anon_sym_restrict] = ACTIONS(3673),
    [anon_sym___restrict__] = ACTIONS(3673),
    [anon_sym__Atomic] = ACTIONS(3673),
    [anon_sym__Noreturn] = ACTIONS(3673),
    [anon_sym_noreturn] = ACTIONS(3673),
    [anon_sym_mutable] = ACTIONS(3673),
    [anon_sym_constinit] = ACTIONS(3673),
    [anon_sym_consteval] = ACTIONS(3673),
    [anon_sym_alignas] = ACTIONS(3673),
    [anon_sym__Alignas] = ACTIONS(3673),
    [sym_primitive_type] = ACTIONS(3673),
    [anon_sym_enum] = ACTIONS(3673),
    [anon_sym_class] = ACTIONS(3673),
    [anon_sym_struct] = ACTIONS(3673),
    [anon_sym_union] = ACTIONS(3673),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3673),
    [anon_sym_let] = ACTIONS(3673),
    [anon_sym_This] = ACTIONS(3673),
    [anon_sym_decltype] = ACTIONS(3673),
    [sym_virtual] = ACTIONS(3673),
    [anon_sym_explicit] = ACTIONS(3673),
    [anon_sym_typename] = ACTIONS(3673),
    [anon_sym_template] = ACTIONS(3673),
    [anon_sym_operator] = ACTIONS(3673),
    [anon_sym_friend] = ACTIONS(3673),
    [anon_sym_public] = ACTIONS(3673),
    [anon_sym_private] = ACTIONS(3673),
    [anon_sym_protected] = ACTIONS(3673),
    [anon_sym_using] = ACTIONS(3673),
    [anon_sym_static_assert] = ACTIONS(3673),
    [anon_sym_precise] = ACTIONS(3673),
    [anon_sym_shared] = ACTIONS(3673),
    [anon_sym_groupshared] = ACTIONS(3673),
    [anon_sym_uniform] = ACTIONS(3673),
    [anon_sym_row_major] = ACTIONS(3673),
    [anon_sym_column_major] = ACTIONS(3673),
    [anon_sym_globallycoherent] = ACTIONS(3673),
    [anon_sym_centroid] = ACTIONS(3673),
    [anon_sym_noperspective] = ACTIONS(3673),
    [anon_sym_nointerpolation] = ACTIONS(3673),
    [anon_sym_sample] = ACTIONS(3673),
    [anon_sym_linear] = ACTIONS(3673),
    [anon_sym_snorm] = ACTIONS(3673),
    [anon_sym_unorm] = ACTIONS(3673),
    [anon_sym_point] = ACTIONS(3673),
    [anon_sym_line] = ACTIONS(3673),
    [anon_sym_triangleadj] = ACTIONS(3673),
    [anon_sym_lineadj] = ACTIONS(3673),
    [anon_sym_triangle] = ACTIONS(3673),
    [anon_sym_interface] = ACTIONS(3673),
    [anon_sym_extension] = ACTIONS(3673),
    [anon_sym___init] = ACTIONS(3673),
    [anon_sym___subscript] = ACTIONS(3673),
    [anon_sym_property] = ACTIONS(3673),
    [anon_sym_associatedtype] = ACTIONS(3673),
  },
  [1561] = {
    [sym_identifier] = ACTIONS(3665),
    [aux_sym_preproc_def_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token2] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3665),
    [aux_sym_preproc_else_token1] = ACTIONS(3665),
    [aux_sym_preproc_elif_token1] = ACTIONS(3665),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3665),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3665),
    [sym_preproc_directive] = ACTIONS(3665),
    [anon_sym_LPAREN2] = ACTIONS(3667),
    [anon_sym_TILDE] = ACTIONS(3667),
    [anon_sym_STAR] = ACTIONS(3667),
    [anon_sym_AMP_AMP] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym___extension__] = ACTIONS(3665),
    [anon_sym_typedef] = ACTIONS(3665),
    [anon_sym_in] = ACTIONS(3665),
    [anon_sym_out] = ACTIONS(3665),
    [anon_sym_inout] = ACTIONS(3665),
    [anon_sym_extern] = ACTIONS(3665),
    [anon_sym___attribute__] = ACTIONS(3665),
    [anon_sym_COLON_COLON] = ACTIONS(3667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3667),
    [anon_sym___declspec] = ACTIONS(3665),
    [anon_sym___based] = ACTIONS(3665),
    [anon_sym_signed] = ACTIONS(3665),
    [anon_sym_unsigned] = ACTIONS(3665),
    [anon_sym_long] = ACTIONS(3665),
    [anon_sym_short] = ACTIONS(3665),
    [anon_sym_LBRACK] = ACTIONS(3665),
    [anon_sym_static] = ACTIONS(3665),
    [anon_sym_register] = ACTIONS(3665),
    [anon_sym_inline] = ACTIONS(3665),
    [anon_sym___inline] = ACTIONS(3665),
    [anon_sym___inline__] = ACTIONS(3665),
    [anon_sym___forceinline] = ACTIONS(3665),
    [anon_sym_thread_local] = ACTIONS(3665),
    [anon_sym___thread] = ACTIONS(3665),
    [anon_sym_const] = ACTIONS(3665),
    [anon_sym_constexpr] = ACTIONS(3665),
    [anon_sym_volatile] = ACTIONS(3665),
    [anon_sym_restrict] = ACTIONS(3665),
    [anon_sym___restrict__] = ACTIONS(3665),
    [anon_sym__Atomic] = ACTIONS(3665),
    [anon_sym__Noreturn] = ACTIONS(3665),
    [anon_sym_noreturn] = ACTIONS(3665),
    [anon_sym_mutable] = ACTIONS(3665),
    [anon_sym_constinit] = ACTIONS(3665),
    [anon_sym_consteval] = ACTIONS(3665),
    [anon_sym_alignas] = ACTIONS(3665),
    [anon_sym__Alignas] = ACTIONS(3665),
    [sym_primitive_type] = ACTIONS(3665),
    [anon_sym_enum] = ACTIONS(3665),
    [anon_sym_class] = ACTIONS(3665),
    [anon_sym_struct] = ACTIONS(3665),
    [anon_sym_union] = ACTIONS(3665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3665),
    [anon_sym_let] = ACTIONS(3665),
    [anon_sym_This] = ACTIONS(3665),
    [anon_sym_decltype] = ACTIONS(3665),
    [sym_virtual] = ACTIONS(3665),
    [anon_sym_explicit] = ACTIONS(3665),
    [anon_sym_typename] = ACTIONS(3665),
    [anon_sym_template] = ACTIONS(3665),
    [anon_sym_operator] = ACTIONS(3665),
    [anon_sym_friend] = ACTIONS(3665),
    [anon_sym_public] = ACTIONS(3665),
    [anon_sym_private] = ACTIONS(3665),
    [anon_sym_protected] = ACTIONS(3665),
    [anon_sym_using] = ACTIONS(3665),
    [anon_sym_static_assert] = ACTIONS(3665),
    [anon_sym_precise] = ACTIONS(3665),
    [anon_sym_shared] = ACTIONS(3665),
    [anon_sym_groupshared] = ACTIONS(3665),
    [anon_sym_uniform] = ACTIONS(3665),
    [anon_sym_row_major] = ACTIONS(3665),
    [anon_sym_column_major] = ACTIONS(3665),
    [anon_sym_globallycoherent] = ACTIONS(3665),
    [anon_sym_centroid] = ACTIONS(3665),
    [anon_sym_noperspective] = ACTIONS(3665),
    [anon_sym_nointerpolation] = ACTIONS(3665),
    [anon_sym_sample] = ACTIONS(3665),
    [anon_sym_linear] = ACTIONS(3665),
    [anon_sym_snorm] = ACTIONS(3665),
    [anon_sym_unorm] = ACTIONS(3665),
    [anon_sym_point] = ACTIONS(3665),
    [anon_sym_line] = ACTIONS(3665),
    [anon_sym_triangleadj] = ACTIONS(3665),
    [anon_sym_lineadj] = ACTIONS(3665),
    [anon_sym_triangle] = ACTIONS(3665),
    [anon_sym_interface] = ACTIONS(3665),
    [anon_sym_extension] = ACTIONS(3665),
    [anon_sym___init] = ACTIONS(3665),
    [anon_sym___subscript] = ACTIONS(3665),
    [anon_sym_property] = ACTIONS(3665),
    [anon_sym_associatedtype] = ACTIONS(3665),
  },
  [1562] = {
    [sym_identifier] = ACTIONS(3665),
    [aux_sym_preproc_def_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token2] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3665),
    [aux_sym_preproc_else_token1] = ACTIONS(3665),
    [aux_sym_preproc_elif_token1] = ACTIONS(3665),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3665),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3665),
    [sym_preproc_directive] = ACTIONS(3665),
    [anon_sym_LPAREN2] = ACTIONS(3667),
    [anon_sym_TILDE] = ACTIONS(3667),
    [anon_sym_STAR] = ACTIONS(3667),
    [anon_sym_AMP_AMP] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym___extension__] = ACTIONS(3665),
    [anon_sym_typedef] = ACTIONS(3665),
    [anon_sym_in] = ACTIONS(3665),
    [anon_sym_out] = ACTIONS(3665),
    [anon_sym_inout] = ACTIONS(3665),
    [anon_sym_extern] = ACTIONS(3665),
    [anon_sym___attribute__] = ACTIONS(3665),
    [anon_sym_COLON_COLON] = ACTIONS(3667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3667),
    [anon_sym___declspec] = ACTIONS(3665),
    [anon_sym___based] = ACTIONS(3665),
    [anon_sym_signed] = ACTIONS(3665),
    [anon_sym_unsigned] = ACTIONS(3665),
    [anon_sym_long] = ACTIONS(3665),
    [anon_sym_short] = ACTIONS(3665),
    [anon_sym_LBRACK] = ACTIONS(3665),
    [anon_sym_static] = ACTIONS(3665),
    [anon_sym_register] = ACTIONS(3665),
    [anon_sym_inline] = ACTIONS(3665),
    [anon_sym___inline] = ACTIONS(3665),
    [anon_sym___inline__] = ACTIONS(3665),
    [anon_sym___forceinline] = ACTIONS(3665),
    [anon_sym_thread_local] = ACTIONS(3665),
    [anon_sym___thread] = ACTIONS(3665),
    [anon_sym_const] = ACTIONS(3665),
    [anon_sym_constexpr] = ACTIONS(3665),
    [anon_sym_volatile] = ACTIONS(3665),
    [anon_sym_restrict] = ACTIONS(3665),
    [anon_sym___restrict__] = ACTIONS(3665),
    [anon_sym__Atomic] = ACTIONS(3665),
    [anon_sym__Noreturn] = ACTIONS(3665),
    [anon_sym_noreturn] = ACTIONS(3665),
    [anon_sym_mutable] = ACTIONS(3665),
    [anon_sym_constinit] = ACTIONS(3665),
    [anon_sym_consteval] = ACTIONS(3665),
    [anon_sym_alignas] = ACTIONS(3665),
    [anon_sym__Alignas] = ACTIONS(3665),
    [sym_primitive_type] = ACTIONS(3665),
    [anon_sym_enum] = ACTIONS(3665),
    [anon_sym_class] = ACTIONS(3665),
    [anon_sym_struct] = ACTIONS(3665),
    [anon_sym_union] = ACTIONS(3665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3665),
    [anon_sym_let] = ACTIONS(3665),
    [anon_sym_This] = ACTIONS(3665),
    [anon_sym_decltype] = ACTIONS(3665),
    [sym_virtual] = ACTIONS(3665),
    [anon_sym_explicit] = ACTIONS(3665),
    [anon_sym_typename] = ACTIONS(3665),
    [anon_sym_template] = ACTIONS(3665),
    [anon_sym_operator] = ACTIONS(3665),
    [anon_sym_friend] = ACTIONS(3665),
    [anon_sym_public] = ACTIONS(3665),
    [anon_sym_private] = ACTIONS(3665),
    [anon_sym_protected] = ACTIONS(3665),
    [anon_sym_using] = ACTIONS(3665),
    [anon_sym_static_assert] = ACTIONS(3665),
    [anon_sym_precise] = ACTIONS(3665),
    [anon_sym_shared] = ACTIONS(3665),
    [anon_sym_groupshared] = ACTIONS(3665),
    [anon_sym_uniform] = ACTIONS(3665),
    [anon_sym_row_major] = ACTIONS(3665),
    [anon_sym_column_major] = ACTIONS(3665),
    [anon_sym_globallycoherent] = ACTIONS(3665),
    [anon_sym_centroid] = ACTIONS(3665),
    [anon_sym_noperspective] = ACTIONS(3665),
    [anon_sym_nointerpolation] = ACTIONS(3665),
    [anon_sym_sample] = ACTIONS(3665),
    [anon_sym_linear] = ACTIONS(3665),
    [anon_sym_snorm] = ACTIONS(3665),
    [anon_sym_unorm] = ACTIONS(3665),
    [anon_sym_point] = ACTIONS(3665),
    [anon_sym_line] = ACTIONS(3665),
    [anon_sym_triangleadj] = ACTIONS(3665),
    [anon_sym_lineadj] = ACTIONS(3665),
    [anon_sym_triangle] = ACTIONS(3665),
    [anon_sym_interface] = ACTIONS(3665),
    [anon_sym_extension] = ACTIONS(3665),
    [anon_sym___init] = ACTIONS(3665),
    [anon_sym___subscript] = ACTIONS(3665),
    [anon_sym_property] = ACTIONS(3665),
    [anon_sym_associatedtype] = ACTIONS(3665),
  },
  [1563] = {
    [sym_expression] = STATE(3828),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym__unary_left_fold] = STATE(10301),
    [sym__unary_right_fold] = STATE(10302),
    [sym__binary_fold] = STATE(10271),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1564] = {
    [sym_expression] = STATE(5440),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10473),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5468),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1565] = {
    [sym_expression] = STATE(5400),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10593),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10593),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5470),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1566] = {
    [sym_identifier] = ACTIONS(3649),
    [aux_sym_preproc_def_token1] = ACTIONS(3649),
    [aux_sym_preproc_if_token1] = ACTIONS(3649),
    [aux_sym_preproc_if_token2] = ACTIONS(3649),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3649),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3649),
    [aux_sym_preproc_else_token1] = ACTIONS(3649),
    [aux_sym_preproc_elif_token1] = ACTIONS(3649),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3649),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3649),
    [sym_preproc_directive] = ACTIONS(3649),
    [anon_sym_LPAREN2] = ACTIONS(3651),
    [anon_sym_TILDE] = ACTIONS(3651),
    [anon_sym_STAR] = ACTIONS(3651),
    [anon_sym_AMP_AMP] = ACTIONS(3651),
    [anon_sym_AMP] = ACTIONS(3649),
    [anon_sym___extension__] = ACTIONS(3649),
    [anon_sym_typedef] = ACTIONS(3649),
    [anon_sym_in] = ACTIONS(3649),
    [anon_sym_out] = ACTIONS(3649),
    [anon_sym_inout] = ACTIONS(3649),
    [anon_sym_extern] = ACTIONS(3649),
    [anon_sym___attribute__] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(3651),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3651),
    [anon_sym___declspec] = ACTIONS(3649),
    [anon_sym___based] = ACTIONS(3649),
    [anon_sym_signed] = ACTIONS(3649),
    [anon_sym_unsigned] = ACTIONS(3649),
    [anon_sym_long] = ACTIONS(3649),
    [anon_sym_short] = ACTIONS(3649),
    [anon_sym_LBRACK] = ACTIONS(3649),
    [anon_sym_static] = ACTIONS(3649),
    [anon_sym_register] = ACTIONS(3649),
    [anon_sym_inline] = ACTIONS(3649),
    [anon_sym___inline] = ACTIONS(3649),
    [anon_sym___inline__] = ACTIONS(3649),
    [anon_sym___forceinline] = ACTIONS(3649),
    [anon_sym_thread_local] = ACTIONS(3649),
    [anon_sym___thread] = ACTIONS(3649),
    [anon_sym_const] = ACTIONS(3649),
    [anon_sym_constexpr] = ACTIONS(3649),
    [anon_sym_volatile] = ACTIONS(3649),
    [anon_sym_restrict] = ACTIONS(3649),
    [anon_sym___restrict__] = ACTIONS(3649),
    [anon_sym__Atomic] = ACTIONS(3649),
    [anon_sym__Noreturn] = ACTIONS(3649),
    [anon_sym_noreturn] = ACTIONS(3649),
    [anon_sym_mutable] = ACTIONS(3649),
    [anon_sym_constinit] = ACTIONS(3649),
    [anon_sym_consteval] = ACTIONS(3649),
    [anon_sym_alignas] = ACTIONS(3649),
    [anon_sym__Alignas] = ACTIONS(3649),
    [sym_primitive_type] = ACTIONS(3649),
    [anon_sym_enum] = ACTIONS(3649),
    [anon_sym_class] = ACTIONS(3649),
    [anon_sym_struct] = ACTIONS(3649),
    [anon_sym_union] = ACTIONS(3649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3649),
    [anon_sym_let] = ACTIONS(3649),
    [anon_sym_This] = ACTIONS(3649),
    [anon_sym_decltype] = ACTIONS(3649),
    [sym_virtual] = ACTIONS(3649),
    [anon_sym_explicit] = ACTIONS(3649),
    [anon_sym_typename] = ACTIONS(3649),
    [anon_sym_template] = ACTIONS(3649),
    [anon_sym_operator] = ACTIONS(3649),
    [anon_sym_friend] = ACTIONS(3649),
    [anon_sym_public] = ACTIONS(3649),
    [anon_sym_private] = ACTIONS(3649),
    [anon_sym_protected] = ACTIONS(3649),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_static_assert] = ACTIONS(3649),
    [anon_sym_precise] = ACTIONS(3649),
    [anon_sym_shared] = ACTIONS(3649),
    [anon_sym_groupshared] = ACTIONS(3649),
    [anon_sym_uniform] = ACTIONS(3649),
    [anon_sym_row_major] = ACTIONS(3649),
    [anon_sym_column_major] = ACTIONS(3649),
    [anon_sym_globallycoherent] = ACTIONS(3649),
    [anon_sym_centroid] = ACTIONS(3649),
    [anon_sym_noperspective] = ACTIONS(3649),
    [anon_sym_nointerpolation] = ACTIONS(3649),
    [anon_sym_sample] = ACTIONS(3649),
    [anon_sym_linear] = ACTIONS(3649),
    [anon_sym_snorm] = ACTIONS(3649),
    [anon_sym_unorm] = ACTIONS(3649),
    [anon_sym_point] = ACTIONS(3649),
    [anon_sym_line] = ACTIONS(3649),
    [anon_sym_triangleadj] = ACTIONS(3649),
    [anon_sym_lineadj] = ACTIONS(3649),
    [anon_sym_triangle] = ACTIONS(3649),
    [anon_sym_interface] = ACTIONS(3649),
    [anon_sym_extension] = ACTIONS(3649),
    [anon_sym___init] = ACTIONS(3649),
    [anon_sym___subscript] = ACTIONS(3649),
    [anon_sym_property] = ACTIONS(3649),
    [anon_sym_associatedtype] = ACTIONS(3649),
  },
  [1567] = {
    [sym_identifier] = ACTIONS(3625),
    [aux_sym_preproc_def_token1] = ACTIONS(3625),
    [aux_sym_preproc_if_token1] = ACTIONS(3625),
    [aux_sym_preproc_if_token2] = ACTIONS(3625),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3625),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3625),
    [aux_sym_preproc_else_token1] = ACTIONS(3625),
    [aux_sym_preproc_elif_token1] = ACTIONS(3625),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3625),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3625),
    [sym_preproc_directive] = ACTIONS(3625),
    [anon_sym_LPAREN2] = ACTIONS(3627),
    [anon_sym_TILDE] = ACTIONS(3627),
    [anon_sym_STAR] = ACTIONS(3627),
    [anon_sym_AMP_AMP] = ACTIONS(3627),
    [anon_sym_AMP] = ACTIONS(3625),
    [anon_sym___extension__] = ACTIONS(3625),
    [anon_sym_typedef] = ACTIONS(3625),
    [anon_sym_in] = ACTIONS(3625),
    [anon_sym_out] = ACTIONS(3625),
    [anon_sym_inout] = ACTIONS(3625),
    [anon_sym_extern] = ACTIONS(3625),
    [anon_sym___attribute__] = ACTIONS(3625),
    [anon_sym_COLON_COLON] = ACTIONS(3627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3627),
    [anon_sym___declspec] = ACTIONS(3625),
    [anon_sym___based] = ACTIONS(3625),
    [anon_sym_signed] = ACTIONS(3625),
    [anon_sym_unsigned] = ACTIONS(3625),
    [anon_sym_long] = ACTIONS(3625),
    [anon_sym_short] = ACTIONS(3625),
    [anon_sym_LBRACK] = ACTIONS(3625),
    [anon_sym_static] = ACTIONS(3625),
    [anon_sym_register] = ACTIONS(3625),
    [anon_sym_inline] = ACTIONS(3625),
    [anon_sym___inline] = ACTIONS(3625),
    [anon_sym___inline__] = ACTIONS(3625),
    [anon_sym___forceinline] = ACTIONS(3625),
    [anon_sym_thread_local] = ACTIONS(3625),
    [anon_sym___thread] = ACTIONS(3625),
    [anon_sym_const] = ACTIONS(3625),
    [anon_sym_constexpr] = ACTIONS(3625),
    [anon_sym_volatile] = ACTIONS(3625),
    [anon_sym_restrict] = ACTIONS(3625),
    [anon_sym___restrict__] = ACTIONS(3625),
    [anon_sym__Atomic] = ACTIONS(3625),
    [anon_sym__Noreturn] = ACTIONS(3625),
    [anon_sym_noreturn] = ACTIONS(3625),
    [anon_sym_mutable] = ACTIONS(3625),
    [anon_sym_constinit] = ACTIONS(3625),
    [anon_sym_consteval] = ACTIONS(3625),
    [anon_sym_alignas] = ACTIONS(3625),
    [anon_sym__Alignas] = ACTIONS(3625),
    [sym_primitive_type] = ACTIONS(3625),
    [anon_sym_enum] = ACTIONS(3625),
    [anon_sym_class] = ACTIONS(3625),
    [anon_sym_struct] = ACTIONS(3625),
    [anon_sym_union] = ACTIONS(3625),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3625),
    [anon_sym_let] = ACTIONS(3625),
    [anon_sym_This] = ACTIONS(3625),
    [anon_sym_decltype] = ACTIONS(3625),
    [sym_virtual] = ACTIONS(3625),
    [anon_sym_explicit] = ACTIONS(3625),
    [anon_sym_typename] = ACTIONS(3625),
    [anon_sym_template] = ACTIONS(3625),
    [anon_sym_operator] = ACTIONS(3625),
    [anon_sym_friend] = ACTIONS(3625),
    [anon_sym_public] = ACTIONS(3625),
    [anon_sym_private] = ACTIONS(3625),
    [anon_sym_protected] = ACTIONS(3625),
    [anon_sym_using] = ACTIONS(3625),
    [anon_sym_static_assert] = ACTIONS(3625),
    [anon_sym_precise] = ACTIONS(3625),
    [anon_sym_shared] = ACTIONS(3625),
    [anon_sym_groupshared] = ACTIONS(3625),
    [anon_sym_uniform] = ACTIONS(3625),
    [anon_sym_row_major] = ACTIONS(3625),
    [anon_sym_column_major] = ACTIONS(3625),
    [anon_sym_globallycoherent] = ACTIONS(3625),
    [anon_sym_centroid] = ACTIONS(3625),
    [anon_sym_noperspective] = ACTIONS(3625),
    [anon_sym_nointerpolation] = ACTIONS(3625),
    [anon_sym_sample] = ACTIONS(3625),
    [anon_sym_linear] = ACTIONS(3625),
    [anon_sym_snorm] = ACTIONS(3625),
    [anon_sym_unorm] = ACTIONS(3625),
    [anon_sym_point] = ACTIONS(3625),
    [anon_sym_line] = ACTIONS(3625),
    [anon_sym_triangleadj] = ACTIONS(3625),
    [anon_sym_lineadj] = ACTIONS(3625),
    [anon_sym_triangle] = ACTIONS(3625),
    [anon_sym_interface] = ACTIONS(3625),
    [anon_sym_extension] = ACTIONS(3625),
    [anon_sym___init] = ACTIONS(3625),
    [anon_sym___subscript] = ACTIONS(3625),
    [anon_sym_property] = ACTIONS(3625),
    [anon_sym_associatedtype] = ACTIONS(3625),
  },
  [1568] = {
    [sym_identifier] = ACTIONS(3621),
    [aux_sym_preproc_def_token1] = ACTIONS(3621),
    [aux_sym_preproc_if_token1] = ACTIONS(3621),
    [aux_sym_preproc_if_token2] = ACTIONS(3621),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3621),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3621),
    [aux_sym_preproc_else_token1] = ACTIONS(3621),
    [aux_sym_preproc_elif_token1] = ACTIONS(3621),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3621),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3621),
    [sym_preproc_directive] = ACTIONS(3621),
    [anon_sym_LPAREN2] = ACTIONS(3623),
    [anon_sym_TILDE] = ACTIONS(3623),
    [anon_sym_STAR] = ACTIONS(3623),
    [anon_sym_AMP_AMP] = ACTIONS(3623),
    [anon_sym_AMP] = ACTIONS(3621),
    [anon_sym___extension__] = ACTIONS(3621),
    [anon_sym_typedef] = ACTIONS(3621),
    [anon_sym_in] = ACTIONS(3621),
    [anon_sym_out] = ACTIONS(3621),
    [anon_sym_inout] = ACTIONS(3621),
    [anon_sym_extern] = ACTIONS(3621),
    [anon_sym___attribute__] = ACTIONS(3621),
    [anon_sym_COLON_COLON] = ACTIONS(3623),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3623),
    [anon_sym___declspec] = ACTIONS(3621),
    [anon_sym___based] = ACTIONS(3621),
    [anon_sym_signed] = ACTIONS(3621),
    [anon_sym_unsigned] = ACTIONS(3621),
    [anon_sym_long] = ACTIONS(3621),
    [anon_sym_short] = ACTIONS(3621),
    [anon_sym_LBRACK] = ACTIONS(3621),
    [anon_sym_static] = ACTIONS(3621),
    [anon_sym_register] = ACTIONS(3621),
    [anon_sym_inline] = ACTIONS(3621),
    [anon_sym___inline] = ACTIONS(3621),
    [anon_sym___inline__] = ACTIONS(3621),
    [anon_sym___forceinline] = ACTIONS(3621),
    [anon_sym_thread_local] = ACTIONS(3621),
    [anon_sym___thread] = ACTIONS(3621),
    [anon_sym_const] = ACTIONS(3621),
    [anon_sym_constexpr] = ACTIONS(3621),
    [anon_sym_volatile] = ACTIONS(3621),
    [anon_sym_restrict] = ACTIONS(3621),
    [anon_sym___restrict__] = ACTIONS(3621),
    [anon_sym__Atomic] = ACTIONS(3621),
    [anon_sym__Noreturn] = ACTIONS(3621),
    [anon_sym_noreturn] = ACTIONS(3621),
    [anon_sym_mutable] = ACTIONS(3621),
    [anon_sym_constinit] = ACTIONS(3621),
    [anon_sym_consteval] = ACTIONS(3621),
    [anon_sym_alignas] = ACTIONS(3621),
    [anon_sym__Alignas] = ACTIONS(3621),
    [sym_primitive_type] = ACTIONS(3621),
    [anon_sym_enum] = ACTIONS(3621),
    [anon_sym_class] = ACTIONS(3621),
    [anon_sym_struct] = ACTIONS(3621),
    [anon_sym_union] = ACTIONS(3621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3621),
    [anon_sym_let] = ACTIONS(3621),
    [anon_sym_This] = ACTIONS(3621),
    [anon_sym_decltype] = ACTIONS(3621),
    [sym_virtual] = ACTIONS(3621),
    [anon_sym_explicit] = ACTIONS(3621),
    [anon_sym_typename] = ACTIONS(3621),
    [anon_sym_template] = ACTIONS(3621),
    [anon_sym_operator] = ACTIONS(3621),
    [anon_sym_friend] = ACTIONS(3621),
    [anon_sym_public] = ACTIONS(3621),
    [anon_sym_private] = ACTIONS(3621),
    [anon_sym_protected] = ACTIONS(3621),
    [anon_sym_using] = ACTIONS(3621),
    [anon_sym_static_assert] = ACTIONS(3621),
    [anon_sym_precise] = ACTIONS(3621),
    [anon_sym_shared] = ACTIONS(3621),
    [anon_sym_groupshared] = ACTIONS(3621),
    [anon_sym_uniform] = ACTIONS(3621),
    [anon_sym_row_major] = ACTIONS(3621),
    [anon_sym_column_major] = ACTIONS(3621),
    [anon_sym_globallycoherent] = ACTIONS(3621),
    [anon_sym_centroid] = ACTIONS(3621),
    [anon_sym_noperspective] = ACTIONS(3621),
    [anon_sym_nointerpolation] = ACTIONS(3621),
    [anon_sym_sample] = ACTIONS(3621),
    [anon_sym_linear] = ACTIONS(3621),
    [anon_sym_snorm] = ACTIONS(3621),
    [anon_sym_unorm] = ACTIONS(3621),
    [anon_sym_point] = ACTIONS(3621),
    [anon_sym_line] = ACTIONS(3621),
    [anon_sym_triangleadj] = ACTIONS(3621),
    [anon_sym_lineadj] = ACTIONS(3621),
    [anon_sym_triangle] = ACTIONS(3621),
    [anon_sym_interface] = ACTIONS(3621),
    [anon_sym_extension] = ACTIONS(3621),
    [anon_sym___init] = ACTIONS(3621),
    [anon_sym___subscript] = ACTIONS(3621),
    [anon_sym_property] = ACTIONS(3621),
    [anon_sym_associatedtype] = ACTIONS(3621),
  },
  [1569] = {
    [sym_identifier] = ACTIONS(3441),
    [aux_sym_preproc_def_token1] = ACTIONS(3441),
    [aux_sym_preproc_if_token1] = ACTIONS(3441),
    [aux_sym_preproc_if_token2] = ACTIONS(3441),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3441),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3441),
    [aux_sym_preproc_else_token1] = ACTIONS(3441),
    [aux_sym_preproc_elif_token1] = ACTIONS(3441),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3441),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3441),
    [sym_preproc_directive] = ACTIONS(3441),
    [anon_sym_LPAREN2] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(3443),
    [anon_sym_AMP_AMP] = ACTIONS(3443),
    [anon_sym_AMP] = ACTIONS(3441),
    [anon_sym___extension__] = ACTIONS(3441),
    [anon_sym_typedef] = ACTIONS(3441),
    [anon_sym_in] = ACTIONS(3441),
    [anon_sym_out] = ACTIONS(3441),
    [anon_sym_inout] = ACTIONS(3441),
    [anon_sym_extern] = ACTIONS(3441),
    [anon_sym___attribute__] = ACTIONS(3441),
    [anon_sym_COLON_COLON] = ACTIONS(3443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3443),
    [anon_sym___declspec] = ACTIONS(3441),
    [anon_sym___based] = ACTIONS(3441),
    [anon_sym_signed] = ACTIONS(3441),
    [anon_sym_unsigned] = ACTIONS(3441),
    [anon_sym_long] = ACTIONS(3441),
    [anon_sym_short] = ACTIONS(3441),
    [anon_sym_LBRACK] = ACTIONS(3441),
    [anon_sym_static] = ACTIONS(3441),
    [anon_sym_register] = ACTIONS(3441),
    [anon_sym_inline] = ACTIONS(3441),
    [anon_sym___inline] = ACTIONS(3441),
    [anon_sym___inline__] = ACTIONS(3441),
    [anon_sym___forceinline] = ACTIONS(3441),
    [anon_sym_thread_local] = ACTIONS(3441),
    [anon_sym___thread] = ACTIONS(3441),
    [anon_sym_const] = ACTIONS(3441),
    [anon_sym_constexpr] = ACTIONS(3441),
    [anon_sym_volatile] = ACTIONS(3441),
    [anon_sym_restrict] = ACTIONS(3441),
    [anon_sym___restrict__] = ACTIONS(3441),
    [anon_sym__Atomic] = ACTIONS(3441),
    [anon_sym__Noreturn] = ACTIONS(3441),
    [anon_sym_noreturn] = ACTIONS(3441),
    [anon_sym_mutable] = ACTIONS(3441),
    [anon_sym_constinit] = ACTIONS(3441),
    [anon_sym_consteval] = ACTIONS(3441),
    [anon_sym_alignas] = ACTIONS(3441),
    [anon_sym__Alignas] = ACTIONS(3441),
    [sym_primitive_type] = ACTIONS(3441),
    [anon_sym_enum] = ACTIONS(3441),
    [anon_sym_class] = ACTIONS(3441),
    [anon_sym_struct] = ACTIONS(3441),
    [anon_sym_union] = ACTIONS(3441),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3441),
    [anon_sym_let] = ACTIONS(3441),
    [anon_sym_This] = ACTIONS(3441),
    [anon_sym_decltype] = ACTIONS(3441),
    [sym_virtual] = ACTIONS(3441),
    [anon_sym_explicit] = ACTIONS(3441),
    [anon_sym_typename] = ACTIONS(3441),
    [anon_sym_template] = ACTIONS(3441),
    [anon_sym_operator] = ACTIONS(3441),
    [anon_sym_friend] = ACTIONS(3441),
    [anon_sym_public] = ACTIONS(3441),
    [anon_sym_private] = ACTIONS(3441),
    [anon_sym_protected] = ACTIONS(3441),
    [anon_sym_using] = ACTIONS(3441),
    [anon_sym_static_assert] = ACTIONS(3441),
    [anon_sym_precise] = ACTIONS(3441),
    [anon_sym_shared] = ACTIONS(3441),
    [anon_sym_groupshared] = ACTIONS(3441),
    [anon_sym_uniform] = ACTIONS(3441),
    [anon_sym_row_major] = ACTIONS(3441),
    [anon_sym_column_major] = ACTIONS(3441),
    [anon_sym_globallycoherent] = ACTIONS(3441),
    [anon_sym_centroid] = ACTIONS(3441),
    [anon_sym_noperspective] = ACTIONS(3441),
    [anon_sym_nointerpolation] = ACTIONS(3441),
    [anon_sym_sample] = ACTIONS(3441),
    [anon_sym_linear] = ACTIONS(3441),
    [anon_sym_snorm] = ACTIONS(3441),
    [anon_sym_unorm] = ACTIONS(3441),
    [anon_sym_point] = ACTIONS(3441),
    [anon_sym_line] = ACTIONS(3441),
    [anon_sym_triangleadj] = ACTIONS(3441),
    [anon_sym_lineadj] = ACTIONS(3441),
    [anon_sym_triangle] = ACTIONS(3441),
    [anon_sym_interface] = ACTIONS(3441),
    [anon_sym_extension] = ACTIONS(3441),
    [anon_sym___init] = ACTIONS(3441),
    [anon_sym___subscript] = ACTIONS(3441),
    [anon_sym_property] = ACTIONS(3441),
    [anon_sym_associatedtype] = ACTIONS(3441),
  },
  [1570] = {
    [sym_identifier] = ACTIONS(3617),
    [aux_sym_preproc_def_token1] = ACTIONS(3617),
    [aux_sym_preproc_if_token1] = ACTIONS(3617),
    [aux_sym_preproc_if_token2] = ACTIONS(3617),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3617),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3617),
    [aux_sym_preproc_else_token1] = ACTIONS(3617),
    [aux_sym_preproc_elif_token1] = ACTIONS(3617),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3617),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3617),
    [sym_preproc_directive] = ACTIONS(3617),
    [anon_sym_LPAREN2] = ACTIONS(3619),
    [anon_sym_TILDE] = ACTIONS(3619),
    [anon_sym_STAR] = ACTIONS(3619),
    [anon_sym_AMP_AMP] = ACTIONS(3619),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym___extension__] = ACTIONS(3617),
    [anon_sym_typedef] = ACTIONS(3617),
    [anon_sym_in] = ACTIONS(3617),
    [anon_sym_out] = ACTIONS(3617),
    [anon_sym_inout] = ACTIONS(3617),
    [anon_sym_extern] = ACTIONS(3617),
    [anon_sym___attribute__] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3619),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3619),
    [anon_sym___declspec] = ACTIONS(3617),
    [anon_sym___based] = ACTIONS(3617),
    [anon_sym_signed] = ACTIONS(3617),
    [anon_sym_unsigned] = ACTIONS(3617),
    [anon_sym_long] = ACTIONS(3617),
    [anon_sym_short] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_static] = ACTIONS(3617),
    [anon_sym_register] = ACTIONS(3617),
    [anon_sym_inline] = ACTIONS(3617),
    [anon_sym___inline] = ACTIONS(3617),
    [anon_sym___inline__] = ACTIONS(3617),
    [anon_sym___forceinline] = ACTIONS(3617),
    [anon_sym_thread_local] = ACTIONS(3617),
    [anon_sym___thread] = ACTIONS(3617),
    [anon_sym_const] = ACTIONS(3617),
    [anon_sym_constexpr] = ACTIONS(3617),
    [anon_sym_volatile] = ACTIONS(3617),
    [anon_sym_restrict] = ACTIONS(3617),
    [anon_sym___restrict__] = ACTIONS(3617),
    [anon_sym__Atomic] = ACTIONS(3617),
    [anon_sym__Noreturn] = ACTIONS(3617),
    [anon_sym_noreturn] = ACTIONS(3617),
    [anon_sym_mutable] = ACTIONS(3617),
    [anon_sym_constinit] = ACTIONS(3617),
    [anon_sym_consteval] = ACTIONS(3617),
    [anon_sym_alignas] = ACTIONS(3617),
    [anon_sym__Alignas] = ACTIONS(3617),
    [sym_primitive_type] = ACTIONS(3617),
    [anon_sym_enum] = ACTIONS(3617),
    [anon_sym_class] = ACTIONS(3617),
    [anon_sym_struct] = ACTIONS(3617),
    [anon_sym_union] = ACTIONS(3617),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3617),
    [anon_sym_let] = ACTIONS(3617),
    [anon_sym_This] = ACTIONS(3617),
    [anon_sym_decltype] = ACTIONS(3617),
    [sym_virtual] = ACTIONS(3617),
    [anon_sym_explicit] = ACTIONS(3617),
    [anon_sym_typename] = ACTIONS(3617),
    [anon_sym_template] = ACTIONS(3617),
    [anon_sym_operator] = ACTIONS(3617),
    [anon_sym_friend] = ACTIONS(3617),
    [anon_sym_public] = ACTIONS(3617),
    [anon_sym_private] = ACTIONS(3617),
    [anon_sym_protected] = ACTIONS(3617),
    [anon_sym_using] = ACTIONS(3617),
    [anon_sym_static_assert] = ACTIONS(3617),
    [anon_sym_precise] = ACTIONS(3617),
    [anon_sym_shared] = ACTIONS(3617),
    [anon_sym_groupshared] = ACTIONS(3617),
    [anon_sym_uniform] = ACTIONS(3617),
    [anon_sym_row_major] = ACTIONS(3617),
    [anon_sym_column_major] = ACTIONS(3617),
    [anon_sym_globallycoherent] = ACTIONS(3617),
    [anon_sym_centroid] = ACTIONS(3617),
    [anon_sym_noperspective] = ACTIONS(3617),
    [anon_sym_nointerpolation] = ACTIONS(3617),
    [anon_sym_sample] = ACTIONS(3617),
    [anon_sym_linear] = ACTIONS(3617),
    [anon_sym_snorm] = ACTIONS(3617),
    [anon_sym_unorm] = ACTIONS(3617),
    [anon_sym_point] = ACTIONS(3617),
    [anon_sym_line] = ACTIONS(3617),
    [anon_sym_triangleadj] = ACTIONS(3617),
    [anon_sym_lineadj] = ACTIONS(3617),
    [anon_sym_triangle] = ACTIONS(3617),
    [anon_sym_interface] = ACTIONS(3617),
    [anon_sym_extension] = ACTIONS(3617),
    [anon_sym___init] = ACTIONS(3617),
    [anon_sym___subscript] = ACTIONS(3617),
    [anon_sym_property] = ACTIONS(3617),
    [anon_sym_associatedtype] = ACTIONS(3617),
  },
  [1571] = {
    [sym_identifier] = ACTIONS(3445),
    [aux_sym_preproc_def_token1] = ACTIONS(3445),
    [aux_sym_preproc_if_token1] = ACTIONS(3445),
    [aux_sym_preproc_if_token2] = ACTIONS(3445),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3445),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3445),
    [aux_sym_preproc_else_token1] = ACTIONS(3445),
    [aux_sym_preproc_elif_token1] = ACTIONS(3445),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3445),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3445),
    [sym_preproc_directive] = ACTIONS(3445),
    [anon_sym_LPAREN2] = ACTIONS(3447),
    [anon_sym_TILDE] = ACTIONS(3447),
    [anon_sym_STAR] = ACTIONS(3447),
    [anon_sym_AMP_AMP] = ACTIONS(3447),
    [anon_sym_AMP] = ACTIONS(3445),
    [anon_sym___extension__] = ACTIONS(3445),
    [anon_sym_typedef] = ACTIONS(3445),
    [anon_sym_in] = ACTIONS(3445),
    [anon_sym_out] = ACTIONS(3445),
    [anon_sym_inout] = ACTIONS(3445),
    [anon_sym_extern] = ACTIONS(3445),
    [anon_sym___attribute__] = ACTIONS(3445),
    [anon_sym_COLON_COLON] = ACTIONS(3447),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3447),
    [anon_sym___declspec] = ACTIONS(3445),
    [anon_sym___based] = ACTIONS(3445),
    [anon_sym_signed] = ACTIONS(3445),
    [anon_sym_unsigned] = ACTIONS(3445),
    [anon_sym_long] = ACTIONS(3445),
    [anon_sym_short] = ACTIONS(3445),
    [anon_sym_LBRACK] = ACTIONS(3445),
    [anon_sym_static] = ACTIONS(3445),
    [anon_sym_register] = ACTIONS(3445),
    [anon_sym_inline] = ACTIONS(3445),
    [anon_sym___inline] = ACTIONS(3445),
    [anon_sym___inline__] = ACTIONS(3445),
    [anon_sym___forceinline] = ACTIONS(3445),
    [anon_sym_thread_local] = ACTIONS(3445),
    [anon_sym___thread] = ACTIONS(3445),
    [anon_sym_const] = ACTIONS(3445),
    [anon_sym_constexpr] = ACTIONS(3445),
    [anon_sym_volatile] = ACTIONS(3445),
    [anon_sym_restrict] = ACTIONS(3445),
    [anon_sym___restrict__] = ACTIONS(3445),
    [anon_sym__Atomic] = ACTIONS(3445),
    [anon_sym__Noreturn] = ACTIONS(3445),
    [anon_sym_noreturn] = ACTIONS(3445),
    [anon_sym_mutable] = ACTIONS(3445),
    [anon_sym_constinit] = ACTIONS(3445),
    [anon_sym_consteval] = ACTIONS(3445),
    [anon_sym_alignas] = ACTIONS(3445),
    [anon_sym__Alignas] = ACTIONS(3445),
    [sym_primitive_type] = ACTIONS(3445),
    [anon_sym_enum] = ACTIONS(3445),
    [anon_sym_class] = ACTIONS(3445),
    [anon_sym_struct] = ACTIONS(3445),
    [anon_sym_union] = ACTIONS(3445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3445),
    [anon_sym_let] = ACTIONS(3445),
    [anon_sym_This] = ACTIONS(3445),
    [anon_sym_decltype] = ACTIONS(3445),
    [sym_virtual] = ACTIONS(3445),
    [anon_sym_explicit] = ACTIONS(3445),
    [anon_sym_typename] = ACTIONS(3445),
    [anon_sym_template] = ACTIONS(3445),
    [anon_sym_operator] = ACTIONS(3445),
    [anon_sym_friend] = ACTIONS(3445),
    [anon_sym_public] = ACTIONS(3445),
    [anon_sym_private] = ACTIONS(3445),
    [anon_sym_protected] = ACTIONS(3445),
    [anon_sym_using] = ACTIONS(3445),
    [anon_sym_static_assert] = ACTIONS(3445),
    [anon_sym_precise] = ACTIONS(3445),
    [anon_sym_shared] = ACTIONS(3445),
    [anon_sym_groupshared] = ACTIONS(3445),
    [anon_sym_uniform] = ACTIONS(3445),
    [anon_sym_row_major] = ACTIONS(3445),
    [anon_sym_column_major] = ACTIONS(3445),
    [anon_sym_globallycoherent] = ACTIONS(3445),
    [anon_sym_centroid] = ACTIONS(3445),
    [anon_sym_noperspective] = ACTIONS(3445),
    [anon_sym_nointerpolation] = ACTIONS(3445),
    [anon_sym_sample] = ACTIONS(3445),
    [anon_sym_linear] = ACTIONS(3445),
    [anon_sym_snorm] = ACTIONS(3445),
    [anon_sym_unorm] = ACTIONS(3445),
    [anon_sym_point] = ACTIONS(3445),
    [anon_sym_line] = ACTIONS(3445),
    [anon_sym_triangleadj] = ACTIONS(3445),
    [anon_sym_lineadj] = ACTIONS(3445),
    [anon_sym_triangle] = ACTIONS(3445),
    [anon_sym_interface] = ACTIONS(3445),
    [anon_sym_extension] = ACTIONS(3445),
    [anon_sym___init] = ACTIONS(3445),
    [anon_sym___subscript] = ACTIONS(3445),
    [anon_sym_property] = ACTIONS(3445),
    [anon_sym_associatedtype] = ACTIONS(3445),
  },
  [1572] = {
    [sym_identifier] = ACTIONS(3609),
    [aux_sym_preproc_def_token1] = ACTIONS(3609),
    [aux_sym_preproc_if_token1] = ACTIONS(3609),
    [aux_sym_preproc_if_token2] = ACTIONS(3609),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3609),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3609),
    [aux_sym_preproc_else_token1] = ACTIONS(3609),
    [aux_sym_preproc_elif_token1] = ACTIONS(3609),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3609),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3609),
    [sym_preproc_directive] = ACTIONS(3609),
    [anon_sym_LPAREN2] = ACTIONS(3611),
    [anon_sym_TILDE] = ACTIONS(3611),
    [anon_sym_STAR] = ACTIONS(3611),
    [anon_sym_AMP_AMP] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3609),
    [anon_sym___extension__] = ACTIONS(3609),
    [anon_sym_typedef] = ACTIONS(3609),
    [anon_sym_in] = ACTIONS(3609),
    [anon_sym_out] = ACTIONS(3609),
    [anon_sym_inout] = ACTIONS(3609),
    [anon_sym_extern] = ACTIONS(3609),
    [anon_sym___attribute__] = ACTIONS(3609),
    [anon_sym_COLON_COLON] = ACTIONS(3611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3611),
    [anon_sym___declspec] = ACTIONS(3609),
    [anon_sym___based] = ACTIONS(3609),
    [anon_sym_signed] = ACTIONS(3609),
    [anon_sym_unsigned] = ACTIONS(3609),
    [anon_sym_long] = ACTIONS(3609),
    [anon_sym_short] = ACTIONS(3609),
    [anon_sym_LBRACK] = ACTIONS(3609),
    [anon_sym_static] = ACTIONS(3609),
    [anon_sym_register] = ACTIONS(3609),
    [anon_sym_inline] = ACTIONS(3609),
    [anon_sym___inline] = ACTIONS(3609),
    [anon_sym___inline__] = ACTIONS(3609),
    [anon_sym___forceinline] = ACTIONS(3609),
    [anon_sym_thread_local] = ACTIONS(3609),
    [anon_sym___thread] = ACTIONS(3609),
    [anon_sym_const] = ACTIONS(3609),
    [anon_sym_constexpr] = ACTIONS(3609),
    [anon_sym_volatile] = ACTIONS(3609),
    [anon_sym_restrict] = ACTIONS(3609),
    [anon_sym___restrict__] = ACTIONS(3609),
    [anon_sym__Atomic] = ACTIONS(3609),
    [anon_sym__Noreturn] = ACTIONS(3609),
    [anon_sym_noreturn] = ACTIONS(3609),
    [anon_sym_mutable] = ACTIONS(3609),
    [anon_sym_constinit] = ACTIONS(3609),
    [anon_sym_consteval] = ACTIONS(3609),
    [anon_sym_alignas] = ACTIONS(3609),
    [anon_sym__Alignas] = ACTIONS(3609),
    [sym_primitive_type] = ACTIONS(3609),
    [anon_sym_enum] = ACTIONS(3609),
    [anon_sym_class] = ACTIONS(3609),
    [anon_sym_struct] = ACTIONS(3609),
    [anon_sym_union] = ACTIONS(3609),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3609),
    [anon_sym_let] = ACTIONS(3609),
    [anon_sym_This] = ACTIONS(3609),
    [anon_sym_decltype] = ACTIONS(3609),
    [sym_virtual] = ACTIONS(3609),
    [anon_sym_explicit] = ACTIONS(3609),
    [anon_sym_typename] = ACTIONS(3609),
    [anon_sym_template] = ACTIONS(3609),
    [anon_sym_operator] = ACTIONS(3609),
    [anon_sym_friend] = ACTIONS(3609),
    [anon_sym_public] = ACTIONS(3609),
    [anon_sym_private] = ACTIONS(3609),
    [anon_sym_protected] = ACTIONS(3609),
    [anon_sym_using] = ACTIONS(3609),
    [anon_sym_static_assert] = ACTIONS(3609),
    [anon_sym_precise] = ACTIONS(3609),
    [anon_sym_shared] = ACTIONS(3609),
    [anon_sym_groupshared] = ACTIONS(3609),
    [anon_sym_uniform] = ACTIONS(3609),
    [anon_sym_row_major] = ACTIONS(3609),
    [anon_sym_column_major] = ACTIONS(3609),
    [anon_sym_globallycoherent] = ACTIONS(3609),
    [anon_sym_centroid] = ACTIONS(3609),
    [anon_sym_noperspective] = ACTIONS(3609),
    [anon_sym_nointerpolation] = ACTIONS(3609),
    [anon_sym_sample] = ACTIONS(3609),
    [anon_sym_linear] = ACTIONS(3609),
    [anon_sym_snorm] = ACTIONS(3609),
    [anon_sym_unorm] = ACTIONS(3609),
    [anon_sym_point] = ACTIONS(3609),
    [anon_sym_line] = ACTIONS(3609),
    [anon_sym_triangleadj] = ACTIONS(3609),
    [anon_sym_lineadj] = ACTIONS(3609),
    [anon_sym_triangle] = ACTIONS(3609),
    [anon_sym_interface] = ACTIONS(3609),
    [anon_sym_extension] = ACTIONS(3609),
    [anon_sym___init] = ACTIONS(3609),
    [anon_sym___subscript] = ACTIONS(3609),
    [anon_sym_property] = ACTIONS(3609),
    [anon_sym_associatedtype] = ACTIONS(3609),
  },
  [1573] = {
    [sym_identifier] = ACTIONS(3605),
    [aux_sym_preproc_def_token1] = ACTIONS(3605),
    [aux_sym_preproc_if_token1] = ACTIONS(3605),
    [aux_sym_preproc_if_token2] = ACTIONS(3605),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3605),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3605),
    [aux_sym_preproc_else_token1] = ACTIONS(3605),
    [aux_sym_preproc_elif_token1] = ACTIONS(3605),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3605),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3605),
    [sym_preproc_directive] = ACTIONS(3605),
    [anon_sym_LPAREN2] = ACTIONS(3607),
    [anon_sym_TILDE] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(3607),
    [anon_sym_AMP_AMP] = ACTIONS(3607),
    [anon_sym_AMP] = ACTIONS(3605),
    [anon_sym___extension__] = ACTIONS(3605),
    [anon_sym_typedef] = ACTIONS(3605),
    [anon_sym_in] = ACTIONS(3605),
    [anon_sym_out] = ACTIONS(3605),
    [anon_sym_inout] = ACTIONS(3605),
    [anon_sym_extern] = ACTIONS(3605),
    [anon_sym___attribute__] = ACTIONS(3605),
    [anon_sym_COLON_COLON] = ACTIONS(3607),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3607),
    [anon_sym___declspec] = ACTIONS(3605),
    [anon_sym___based] = ACTIONS(3605),
    [anon_sym_signed] = ACTIONS(3605),
    [anon_sym_unsigned] = ACTIONS(3605),
    [anon_sym_long] = ACTIONS(3605),
    [anon_sym_short] = ACTIONS(3605),
    [anon_sym_LBRACK] = ACTIONS(3605),
    [anon_sym_static] = ACTIONS(3605),
    [anon_sym_register] = ACTIONS(3605),
    [anon_sym_inline] = ACTIONS(3605),
    [anon_sym___inline] = ACTIONS(3605),
    [anon_sym___inline__] = ACTIONS(3605),
    [anon_sym___forceinline] = ACTIONS(3605),
    [anon_sym_thread_local] = ACTIONS(3605),
    [anon_sym___thread] = ACTIONS(3605),
    [anon_sym_const] = ACTIONS(3605),
    [anon_sym_constexpr] = ACTIONS(3605),
    [anon_sym_volatile] = ACTIONS(3605),
    [anon_sym_restrict] = ACTIONS(3605),
    [anon_sym___restrict__] = ACTIONS(3605),
    [anon_sym__Atomic] = ACTIONS(3605),
    [anon_sym__Noreturn] = ACTIONS(3605),
    [anon_sym_noreturn] = ACTIONS(3605),
    [anon_sym_mutable] = ACTIONS(3605),
    [anon_sym_constinit] = ACTIONS(3605),
    [anon_sym_consteval] = ACTIONS(3605),
    [anon_sym_alignas] = ACTIONS(3605),
    [anon_sym__Alignas] = ACTIONS(3605),
    [sym_primitive_type] = ACTIONS(3605),
    [anon_sym_enum] = ACTIONS(3605),
    [anon_sym_class] = ACTIONS(3605),
    [anon_sym_struct] = ACTIONS(3605),
    [anon_sym_union] = ACTIONS(3605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3605),
    [anon_sym_let] = ACTIONS(3605),
    [anon_sym_This] = ACTIONS(3605),
    [anon_sym_decltype] = ACTIONS(3605),
    [sym_virtual] = ACTIONS(3605),
    [anon_sym_explicit] = ACTIONS(3605),
    [anon_sym_typename] = ACTIONS(3605),
    [anon_sym_template] = ACTIONS(3605),
    [anon_sym_operator] = ACTIONS(3605),
    [anon_sym_friend] = ACTIONS(3605),
    [anon_sym_public] = ACTIONS(3605),
    [anon_sym_private] = ACTIONS(3605),
    [anon_sym_protected] = ACTIONS(3605),
    [anon_sym_using] = ACTIONS(3605),
    [anon_sym_static_assert] = ACTIONS(3605),
    [anon_sym_precise] = ACTIONS(3605),
    [anon_sym_shared] = ACTIONS(3605),
    [anon_sym_groupshared] = ACTIONS(3605),
    [anon_sym_uniform] = ACTIONS(3605),
    [anon_sym_row_major] = ACTIONS(3605),
    [anon_sym_column_major] = ACTIONS(3605),
    [anon_sym_globallycoherent] = ACTIONS(3605),
    [anon_sym_centroid] = ACTIONS(3605),
    [anon_sym_noperspective] = ACTIONS(3605),
    [anon_sym_nointerpolation] = ACTIONS(3605),
    [anon_sym_sample] = ACTIONS(3605),
    [anon_sym_linear] = ACTIONS(3605),
    [anon_sym_snorm] = ACTIONS(3605),
    [anon_sym_unorm] = ACTIONS(3605),
    [anon_sym_point] = ACTIONS(3605),
    [anon_sym_line] = ACTIONS(3605),
    [anon_sym_triangleadj] = ACTIONS(3605),
    [anon_sym_lineadj] = ACTIONS(3605),
    [anon_sym_triangle] = ACTIONS(3605),
    [anon_sym_interface] = ACTIONS(3605),
    [anon_sym_extension] = ACTIONS(3605),
    [anon_sym___init] = ACTIONS(3605),
    [anon_sym___subscript] = ACTIONS(3605),
    [anon_sym_property] = ACTIONS(3605),
    [anon_sym_associatedtype] = ACTIONS(3605),
  },
  [1574] = {
    [sym_identifier] = ACTIONS(3587),
    [aux_sym_preproc_def_token1] = ACTIONS(3587),
    [aux_sym_preproc_if_token1] = ACTIONS(3587),
    [aux_sym_preproc_if_token2] = ACTIONS(3587),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3587),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3587),
    [aux_sym_preproc_else_token1] = ACTIONS(3587),
    [aux_sym_preproc_elif_token1] = ACTIONS(3587),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3587),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3587),
    [sym_preproc_directive] = ACTIONS(3587),
    [anon_sym_LPAREN2] = ACTIONS(3589),
    [anon_sym_TILDE] = ACTIONS(3589),
    [anon_sym_STAR] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3587),
    [anon_sym___extension__] = ACTIONS(3587),
    [anon_sym_typedef] = ACTIONS(3587),
    [anon_sym_in] = ACTIONS(3587),
    [anon_sym_out] = ACTIONS(3587),
    [anon_sym_inout] = ACTIONS(3587),
    [anon_sym_extern] = ACTIONS(3587),
    [anon_sym___attribute__] = ACTIONS(3587),
    [anon_sym_COLON_COLON] = ACTIONS(3589),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3589),
    [anon_sym___declspec] = ACTIONS(3587),
    [anon_sym___based] = ACTIONS(3587),
    [anon_sym_signed] = ACTIONS(3587),
    [anon_sym_unsigned] = ACTIONS(3587),
    [anon_sym_long] = ACTIONS(3587),
    [anon_sym_short] = ACTIONS(3587),
    [anon_sym_LBRACK] = ACTIONS(3587),
    [anon_sym_static] = ACTIONS(3587),
    [anon_sym_register] = ACTIONS(3587),
    [anon_sym_inline] = ACTIONS(3587),
    [anon_sym___inline] = ACTIONS(3587),
    [anon_sym___inline__] = ACTIONS(3587),
    [anon_sym___forceinline] = ACTIONS(3587),
    [anon_sym_thread_local] = ACTIONS(3587),
    [anon_sym___thread] = ACTIONS(3587),
    [anon_sym_const] = ACTIONS(3587),
    [anon_sym_constexpr] = ACTIONS(3587),
    [anon_sym_volatile] = ACTIONS(3587),
    [anon_sym_restrict] = ACTIONS(3587),
    [anon_sym___restrict__] = ACTIONS(3587),
    [anon_sym__Atomic] = ACTIONS(3587),
    [anon_sym__Noreturn] = ACTIONS(3587),
    [anon_sym_noreturn] = ACTIONS(3587),
    [anon_sym_mutable] = ACTIONS(3587),
    [anon_sym_constinit] = ACTIONS(3587),
    [anon_sym_consteval] = ACTIONS(3587),
    [anon_sym_alignas] = ACTIONS(3587),
    [anon_sym__Alignas] = ACTIONS(3587),
    [sym_primitive_type] = ACTIONS(3587),
    [anon_sym_enum] = ACTIONS(3587),
    [anon_sym_class] = ACTIONS(3587),
    [anon_sym_struct] = ACTIONS(3587),
    [anon_sym_union] = ACTIONS(3587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3587),
    [anon_sym_let] = ACTIONS(3587),
    [anon_sym_This] = ACTIONS(3587),
    [anon_sym_decltype] = ACTIONS(3587),
    [sym_virtual] = ACTIONS(3587),
    [anon_sym_explicit] = ACTIONS(3587),
    [anon_sym_typename] = ACTIONS(3587),
    [anon_sym_template] = ACTIONS(3587),
    [anon_sym_operator] = ACTIONS(3587),
    [anon_sym_friend] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3587),
    [anon_sym_private] = ACTIONS(3587),
    [anon_sym_protected] = ACTIONS(3587),
    [anon_sym_using] = ACTIONS(3587),
    [anon_sym_static_assert] = ACTIONS(3587),
    [anon_sym_precise] = ACTIONS(3587),
    [anon_sym_shared] = ACTIONS(3587),
    [anon_sym_groupshared] = ACTIONS(3587),
    [anon_sym_uniform] = ACTIONS(3587),
    [anon_sym_row_major] = ACTIONS(3587),
    [anon_sym_column_major] = ACTIONS(3587),
    [anon_sym_globallycoherent] = ACTIONS(3587),
    [anon_sym_centroid] = ACTIONS(3587),
    [anon_sym_noperspective] = ACTIONS(3587),
    [anon_sym_nointerpolation] = ACTIONS(3587),
    [anon_sym_sample] = ACTIONS(3587),
    [anon_sym_linear] = ACTIONS(3587),
    [anon_sym_snorm] = ACTIONS(3587),
    [anon_sym_unorm] = ACTIONS(3587),
    [anon_sym_point] = ACTIONS(3587),
    [anon_sym_line] = ACTIONS(3587),
    [anon_sym_triangleadj] = ACTIONS(3587),
    [anon_sym_lineadj] = ACTIONS(3587),
    [anon_sym_triangle] = ACTIONS(3587),
    [anon_sym_interface] = ACTIONS(3587),
    [anon_sym_extension] = ACTIONS(3587),
    [anon_sym___init] = ACTIONS(3587),
    [anon_sym___subscript] = ACTIONS(3587),
    [anon_sym_property] = ACTIONS(3587),
    [anon_sym_associatedtype] = ACTIONS(3587),
  },
  [1575] = {
    [sym_identifier] = ACTIONS(3703),
    [aux_sym_preproc_def_token1] = ACTIONS(3703),
    [aux_sym_preproc_if_token1] = ACTIONS(3703),
    [aux_sym_preproc_if_token2] = ACTIONS(3703),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3703),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3703),
    [aux_sym_preproc_else_token1] = ACTIONS(3703),
    [aux_sym_preproc_elif_token1] = ACTIONS(3703),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3703),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3703),
    [sym_preproc_directive] = ACTIONS(3703),
    [anon_sym_LPAREN2] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3705),
    [anon_sym_STAR] = ACTIONS(3705),
    [anon_sym_AMP_AMP] = ACTIONS(3705),
    [anon_sym_AMP] = ACTIONS(3703),
    [anon_sym___extension__] = ACTIONS(3703),
    [anon_sym_typedef] = ACTIONS(3703),
    [anon_sym_in] = ACTIONS(3703),
    [anon_sym_out] = ACTIONS(3703),
    [anon_sym_inout] = ACTIONS(3703),
    [anon_sym_extern] = ACTIONS(3703),
    [anon_sym___attribute__] = ACTIONS(3703),
    [anon_sym_COLON_COLON] = ACTIONS(3705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3705),
    [anon_sym___declspec] = ACTIONS(3703),
    [anon_sym___based] = ACTIONS(3703),
    [anon_sym_signed] = ACTIONS(3703),
    [anon_sym_unsigned] = ACTIONS(3703),
    [anon_sym_long] = ACTIONS(3703),
    [anon_sym_short] = ACTIONS(3703),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_static] = ACTIONS(3703),
    [anon_sym_register] = ACTIONS(3703),
    [anon_sym_inline] = ACTIONS(3703),
    [anon_sym___inline] = ACTIONS(3703),
    [anon_sym___inline__] = ACTIONS(3703),
    [anon_sym___forceinline] = ACTIONS(3703),
    [anon_sym_thread_local] = ACTIONS(3703),
    [anon_sym___thread] = ACTIONS(3703),
    [anon_sym_const] = ACTIONS(3703),
    [anon_sym_constexpr] = ACTIONS(3703),
    [anon_sym_volatile] = ACTIONS(3703),
    [anon_sym_restrict] = ACTIONS(3703),
    [anon_sym___restrict__] = ACTIONS(3703),
    [anon_sym__Atomic] = ACTIONS(3703),
    [anon_sym__Noreturn] = ACTIONS(3703),
    [anon_sym_noreturn] = ACTIONS(3703),
    [anon_sym_mutable] = ACTIONS(3703),
    [anon_sym_constinit] = ACTIONS(3703),
    [anon_sym_consteval] = ACTIONS(3703),
    [anon_sym_alignas] = ACTIONS(3703),
    [anon_sym__Alignas] = ACTIONS(3703),
    [sym_primitive_type] = ACTIONS(3703),
    [anon_sym_enum] = ACTIONS(3703),
    [anon_sym_class] = ACTIONS(3703),
    [anon_sym_struct] = ACTIONS(3703),
    [anon_sym_union] = ACTIONS(3703),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3703),
    [anon_sym_let] = ACTIONS(3703),
    [anon_sym_This] = ACTIONS(3703),
    [anon_sym_decltype] = ACTIONS(3703),
    [sym_virtual] = ACTIONS(3703),
    [anon_sym_explicit] = ACTIONS(3703),
    [anon_sym_typename] = ACTIONS(3703),
    [anon_sym_template] = ACTIONS(3703),
    [anon_sym_operator] = ACTIONS(3703),
    [anon_sym_friend] = ACTIONS(3703),
    [anon_sym_public] = ACTIONS(3703),
    [anon_sym_private] = ACTIONS(3703),
    [anon_sym_protected] = ACTIONS(3703),
    [anon_sym_using] = ACTIONS(3703),
    [anon_sym_static_assert] = ACTIONS(3703),
    [anon_sym_precise] = ACTIONS(3703),
    [anon_sym_shared] = ACTIONS(3703),
    [anon_sym_groupshared] = ACTIONS(3703),
    [anon_sym_uniform] = ACTIONS(3703),
    [anon_sym_row_major] = ACTIONS(3703),
    [anon_sym_column_major] = ACTIONS(3703),
    [anon_sym_globallycoherent] = ACTIONS(3703),
    [anon_sym_centroid] = ACTIONS(3703),
    [anon_sym_noperspective] = ACTIONS(3703),
    [anon_sym_nointerpolation] = ACTIONS(3703),
    [anon_sym_sample] = ACTIONS(3703),
    [anon_sym_linear] = ACTIONS(3703),
    [anon_sym_snorm] = ACTIONS(3703),
    [anon_sym_unorm] = ACTIONS(3703),
    [anon_sym_point] = ACTIONS(3703),
    [anon_sym_line] = ACTIONS(3703),
    [anon_sym_triangleadj] = ACTIONS(3703),
    [anon_sym_lineadj] = ACTIONS(3703),
    [anon_sym_triangle] = ACTIONS(3703),
    [anon_sym_interface] = ACTIONS(3703),
    [anon_sym_extension] = ACTIONS(3703),
    [anon_sym___init] = ACTIONS(3703),
    [anon_sym___subscript] = ACTIONS(3703),
    [anon_sym_property] = ACTIONS(3703),
    [anon_sym_associatedtype] = ACTIONS(3703),
  },
  [1576] = {
    [sym_identifier] = ACTIONS(3497),
    [aux_sym_preproc_def_token1] = ACTIONS(3497),
    [aux_sym_preproc_if_token1] = ACTIONS(3497),
    [aux_sym_preproc_if_token2] = ACTIONS(3497),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3497),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3497),
    [aux_sym_preproc_else_token1] = ACTIONS(3497),
    [aux_sym_preproc_elif_token1] = ACTIONS(3497),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3497),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3497),
    [sym_preproc_directive] = ACTIONS(3497),
    [anon_sym_LPAREN2] = ACTIONS(3499),
    [anon_sym_TILDE] = ACTIONS(3499),
    [anon_sym_STAR] = ACTIONS(3499),
    [anon_sym_AMP_AMP] = ACTIONS(3499),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym___extension__] = ACTIONS(3497),
    [anon_sym_typedef] = ACTIONS(3497),
    [anon_sym_in] = ACTIONS(3497),
    [anon_sym_out] = ACTIONS(3497),
    [anon_sym_inout] = ACTIONS(3497),
    [anon_sym_extern] = ACTIONS(3497),
    [anon_sym___attribute__] = ACTIONS(3497),
    [anon_sym_COLON_COLON] = ACTIONS(3499),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3499),
    [anon_sym___declspec] = ACTIONS(3497),
    [anon_sym___based] = ACTIONS(3497),
    [anon_sym_signed] = ACTIONS(3497),
    [anon_sym_unsigned] = ACTIONS(3497),
    [anon_sym_long] = ACTIONS(3497),
    [anon_sym_short] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3497),
    [anon_sym_static] = ACTIONS(3497),
    [anon_sym_register] = ACTIONS(3497),
    [anon_sym_inline] = ACTIONS(3497),
    [anon_sym___inline] = ACTIONS(3497),
    [anon_sym___inline__] = ACTIONS(3497),
    [anon_sym___forceinline] = ACTIONS(3497),
    [anon_sym_thread_local] = ACTIONS(3497),
    [anon_sym___thread] = ACTIONS(3497),
    [anon_sym_const] = ACTIONS(3497),
    [anon_sym_constexpr] = ACTIONS(3497),
    [anon_sym_volatile] = ACTIONS(3497),
    [anon_sym_restrict] = ACTIONS(3497),
    [anon_sym___restrict__] = ACTIONS(3497),
    [anon_sym__Atomic] = ACTIONS(3497),
    [anon_sym__Noreturn] = ACTIONS(3497),
    [anon_sym_noreturn] = ACTIONS(3497),
    [anon_sym_mutable] = ACTIONS(3497),
    [anon_sym_constinit] = ACTIONS(3497),
    [anon_sym_consteval] = ACTIONS(3497),
    [anon_sym_alignas] = ACTIONS(3497),
    [anon_sym__Alignas] = ACTIONS(3497),
    [sym_primitive_type] = ACTIONS(3497),
    [anon_sym_enum] = ACTIONS(3497),
    [anon_sym_class] = ACTIONS(3497),
    [anon_sym_struct] = ACTIONS(3497),
    [anon_sym_union] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3497),
    [anon_sym_let] = ACTIONS(3497),
    [anon_sym_This] = ACTIONS(3497),
    [anon_sym_decltype] = ACTIONS(3497),
    [sym_virtual] = ACTIONS(3497),
    [anon_sym_explicit] = ACTIONS(3497),
    [anon_sym_typename] = ACTIONS(3497),
    [anon_sym_template] = ACTIONS(3497),
    [anon_sym_operator] = ACTIONS(3497),
    [anon_sym_friend] = ACTIONS(3497),
    [anon_sym_public] = ACTIONS(3497),
    [anon_sym_private] = ACTIONS(3497),
    [anon_sym_protected] = ACTIONS(3497),
    [anon_sym_using] = ACTIONS(3497),
    [anon_sym_static_assert] = ACTIONS(3497),
    [anon_sym_precise] = ACTIONS(3497),
    [anon_sym_shared] = ACTIONS(3497),
    [anon_sym_groupshared] = ACTIONS(3497),
    [anon_sym_uniform] = ACTIONS(3497),
    [anon_sym_row_major] = ACTIONS(3497),
    [anon_sym_column_major] = ACTIONS(3497),
    [anon_sym_globallycoherent] = ACTIONS(3497),
    [anon_sym_centroid] = ACTIONS(3497),
    [anon_sym_noperspective] = ACTIONS(3497),
    [anon_sym_nointerpolation] = ACTIONS(3497),
    [anon_sym_sample] = ACTIONS(3497),
    [anon_sym_linear] = ACTIONS(3497),
    [anon_sym_snorm] = ACTIONS(3497),
    [anon_sym_unorm] = ACTIONS(3497),
    [anon_sym_point] = ACTIONS(3497),
    [anon_sym_line] = ACTIONS(3497),
    [anon_sym_triangleadj] = ACTIONS(3497),
    [anon_sym_lineadj] = ACTIONS(3497),
    [anon_sym_triangle] = ACTIONS(3497),
    [anon_sym_interface] = ACTIONS(3497),
    [anon_sym_extension] = ACTIONS(3497),
    [anon_sym___init] = ACTIONS(3497),
    [anon_sym___subscript] = ACTIONS(3497),
    [anon_sym_property] = ACTIONS(3497),
    [anon_sym_associatedtype] = ACTIONS(3497),
  },
  [1577] = {
    [sym_identifier] = ACTIONS(3497),
    [aux_sym_preproc_def_token1] = ACTIONS(3497),
    [aux_sym_preproc_if_token1] = ACTIONS(3497),
    [aux_sym_preproc_if_token2] = ACTIONS(3497),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3497),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3497),
    [aux_sym_preproc_else_token1] = ACTIONS(3497),
    [aux_sym_preproc_elif_token1] = ACTIONS(3497),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3497),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3497),
    [sym_preproc_directive] = ACTIONS(3497),
    [anon_sym_LPAREN2] = ACTIONS(3499),
    [anon_sym_TILDE] = ACTIONS(3499),
    [anon_sym_STAR] = ACTIONS(3499),
    [anon_sym_AMP_AMP] = ACTIONS(3499),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym___extension__] = ACTIONS(3497),
    [anon_sym_typedef] = ACTIONS(3497),
    [anon_sym_in] = ACTIONS(3497),
    [anon_sym_out] = ACTIONS(3497),
    [anon_sym_inout] = ACTIONS(3497),
    [anon_sym_extern] = ACTIONS(3497),
    [anon_sym___attribute__] = ACTIONS(3497),
    [anon_sym_COLON_COLON] = ACTIONS(3499),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3499),
    [anon_sym___declspec] = ACTIONS(3497),
    [anon_sym___based] = ACTIONS(3497),
    [anon_sym_signed] = ACTIONS(3497),
    [anon_sym_unsigned] = ACTIONS(3497),
    [anon_sym_long] = ACTIONS(3497),
    [anon_sym_short] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3497),
    [anon_sym_static] = ACTIONS(3497),
    [anon_sym_register] = ACTIONS(3497),
    [anon_sym_inline] = ACTIONS(3497),
    [anon_sym___inline] = ACTIONS(3497),
    [anon_sym___inline__] = ACTIONS(3497),
    [anon_sym___forceinline] = ACTIONS(3497),
    [anon_sym_thread_local] = ACTIONS(3497),
    [anon_sym___thread] = ACTIONS(3497),
    [anon_sym_const] = ACTIONS(3497),
    [anon_sym_constexpr] = ACTIONS(3497),
    [anon_sym_volatile] = ACTIONS(3497),
    [anon_sym_restrict] = ACTIONS(3497),
    [anon_sym___restrict__] = ACTIONS(3497),
    [anon_sym__Atomic] = ACTIONS(3497),
    [anon_sym__Noreturn] = ACTIONS(3497),
    [anon_sym_noreturn] = ACTIONS(3497),
    [anon_sym_mutable] = ACTIONS(3497),
    [anon_sym_constinit] = ACTIONS(3497),
    [anon_sym_consteval] = ACTIONS(3497),
    [anon_sym_alignas] = ACTIONS(3497),
    [anon_sym__Alignas] = ACTIONS(3497),
    [sym_primitive_type] = ACTIONS(3497),
    [anon_sym_enum] = ACTIONS(3497),
    [anon_sym_class] = ACTIONS(3497),
    [anon_sym_struct] = ACTIONS(3497),
    [anon_sym_union] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3497),
    [anon_sym_let] = ACTIONS(3497),
    [anon_sym_This] = ACTIONS(3497),
    [anon_sym_decltype] = ACTIONS(3497),
    [sym_virtual] = ACTIONS(3497),
    [anon_sym_explicit] = ACTIONS(3497),
    [anon_sym_typename] = ACTIONS(3497),
    [anon_sym_template] = ACTIONS(3497),
    [anon_sym_operator] = ACTIONS(3497),
    [anon_sym_friend] = ACTIONS(3497),
    [anon_sym_public] = ACTIONS(3497),
    [anon_sym_private] = ACTIONS(3497),
    [anon_sym_protected] = ACTIONS(3497),
    [anon_sym_using] = ACTIONS(3497),
    [anon_sym_static_assert] = ACTIONS(3497),
    [anon_sym_precise] = ACTIONS(3497),
    [anon_sym_shared] = ACTIONS(3497),
    [anon_sym_groupshared] = ACTIONS(3497),
    [anon_sym_uniform] = ACTIONS(3497),
    [anon_sym_row_major] = ACTIONS(3497),
    [anon_sym_column_major] = ACTIONS(3497),
    [anon_sym_globallycoherent] = ACTIONS(3497),
    [anon_sym_centroid] = ACTIONS(3497),
    [anon_sym_noperspective] = ACTIONS(3497),
    [anon_sym_nointerpolation] = ACTIONS(3497),
    [anon_sym_sample] = ACTIONS(3497),
    [anon_sym_linear] = ACTIONS(3497),
    [anon_sym_snorm] = ACTIONS(3497),
    [anon_sym_unorm] = ACTIONS(3497),
    [anon_sym_point] = ACTIONS(3497),
    [anon_sym_line] = ACTIONS(3497),
    [anon_sym_triangleadj] = ACTIONS(3497),
    [anon_sym_lineadj] = ACTIONS(3497),
    [anon_sym_triangle] = ACTIONS(3497),
    [anon_sym_interface] = ACTIONS(3497),
    [anon_sym_extension] = ACTIONS(3497),
    [anon_sym___init] = ACTIONS(3497),
    [anon_sym___subscript] = ACTIONS(3497),
    [anon_sym_property] = ACTIONS(3497),
    [anon_sym_associatedtype] = ACTIONS(3497),
  },
  [1578] = {
    [sym_identifier] = ACTIONS(3034),
    [aux_sym_preproc_def_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token2] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3034),
    [aux_sym_preproc_else_token1] = ACTIONS(3034),
    [aux_sym_preproc_elif_token1] = ACTIONS(3034),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_in] = ACTIONS(3034),
    [anon_sym_out] = ACTIONS(3034),
    [anon_sym_inout] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym___based] = ACTIONS(3034),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_This] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [sym_virtual] = ACTIONS(3034),
    [anon_sym_explicit] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_operator] = ACTIONS(3034),
    [anon_sym_friend] = ACTIONS(3034),
    [anon_sym_public] = ACTIONS(3034),
    [anon_sym_private] = ACTIONS(3034),
    [anon_sym_protected] = ACTIONS(3034),
    [anon_sym_using] = ACTIONS(3034),
    [anon_sym_static_assert] = ACTIONS(3034),
    [anon_sym_precise] = ACTIONS(3034),
    [anon_sym_shared] = ACTIONS(3034),
    [anon_sym_groupshared] = ACTIONS(3034),
    [anon_sym_uniform] = ACTIONS(3034),
    [anon_sym_row_major] = ACTIONS(3034),
    [anon_sym_column_major] = ACTIONS(3034),
    [anon_sym_globallycoherent] = ACTIONS(3034),
    [anon_sym_centroid] = ACTIONS(3034),
    [anon_sym_noperspective] = ACTIONS(3034),
    [anon_sym_nointerpolation] = ACTIONS(3034),
    [anon_sym_sample] = ACTIONS(3034),
    [anon_sym_linear] = ACTIONS(3034),
    [anon_sym_snorm] = ACTIONS(3034),
    [anon_sym_unorm] = ACTIONS(3034),
    [anon_sym_point] = ACTIONS(3034),
    [anon_sym_line] = ACTIONS(3034),
    [anon_sym_triangleadj] = ACTIONS(3034),
    [anon_sym_lineadj] = ACTIONS(3034),
    [anon_sym_triangle] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3034),
    [anon_sym_extension] = ACTIONS(3034),
    [anon_sym___init] = ACTIONS(3034),
    [anon_sym___subscript] = ACTIONS(3034),
    [anon_sym_property] = ACTIONS(3034),
    [anon_sym_associatedtype] = ACTIONS(3034),
  },
  [1579] = {
    [sym_identifier] = ACTIONS(3034),
    [aux_sym_preproc_def_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token2] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3034),
    [aux_sym_preproc_else_token1] = ACTIONS(3034),
    [aux_sym_preproc_elif_token1] = ACTIONS(3034),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_in] = ACTIONS(3034),
    [anon_sym_out] = ACTIONS(3034),
    [anon_sym_inout] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym___based] = ACTIONS(3034),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_This] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [sym_virtual] = ACTIONS(3034),
    [anon_sym_explicit] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_operator] = ACTIONS(3034),
    [anon_sym_friend] = ACTIONS(3034),
    [anon_sym_public] = ACTIONS(3034),
    [anon_sym_private] = ACTIONS(3034),
    [anon_sym_protected] = ACTIONS(3034),
    [anon_sym_using] = ACTIONS(3034),
    [anon_sym_static_assert] = ACTIONS(3034),
    [anon_sym_precise] = ACTIONS(3034),
    [anon_sym_shared] = ACTIONS(3034),
    [anon_sym_groupshared] = ACTIONS(3034),
    [anon_sym_uniform] = ACTIONS(3034),
    [anon_sym_row_major] = ACTIONS(3034),
    [anon_sym_column_major] = ACTIONS(3034),
    [anon_sym_globallycoherent] = ACTIONS(3034),
    [anon_sym_centroid] = ACTIONS(3034),
    [anon_sym_noperspective] = ACTIONS(3034),
    [anon_sym_nointerpolation] = ACTIONS(3034),
    [anon_sym_sample] = ACTIONS(3034),
    [anon_sym_linear] = ACTIONS(3034),
    [anon_sym_snorm] = ACTIONS(3034),
    [anon_sym_unorm] = ACTIONS(3034),
    [anon_sym_point] = ACTIONS(3034),
    [anon_sym_line] = ACTIONS(3034),
    [anon_sym_triangleadj] = ACTIONS(3034),
    [anon_sym_lineadj] = ACTIONS(3034),
    [anon_sym_triangle] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3034),
    [anon_sym_extension] = ACTIONS(3034),
    [anon_sym___init] = ACTIONS(3034),
    [anon_sym___subscript] = ACTIONS(3034),
    [anon_sym_property] = ACTIONS(3034),
    [anon_sym_associatedtype] = ACTIONS(3034),
  },
  [1580] = {
    [sym_identifier] = ACTIONS(3034),
    [aux_sym_preproc_def_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token2] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3034),
    [aux_sym_preproc_else_token1] = ACTIONS(3034),
    [aux_sym_preproc_elif_token1] = ACTIONS(3034),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_in] = ACTIONS(3034),
    [anon_sym_out] = ACTIONS(3034),
    [anon_sym_inout] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym___based] = ACTIONS(3034),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_This] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [sym_virtual] = ACTIONS(3034),
    [anon_sym_explicit] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_operator] = ACTIONS(3034),
    [anon_sym_friend] = ACTIONS(3034),
    [anon_sym_public] = ACTIONS(3034),
    [anon_sym_private] = ACTIONS(3034),
    [anon_sym_protected] = ACTIONS(3034),
    [anon_sym_using] = ACTIONS(3034),
    [anon_sym_static_assert] = ACTIONS(3034),
    [anon_sym_precise] = ACTIONS(3034),
    [anon_sym_shared] = ACTIONS(3034),
    [anon_sym_groupshared] = ACTIONS(3034),
    [anon_sym_uniform] = ACTIONS(3034),
    [anon_sym_row_major] = ACTIONS(3034),
    [anon_sym_column_major] = ACTIONS(3034),
    [anon_sym_globallycoherent] = ACTIONS(3034),
    [anon_sym_centroid] = ACTIONS(3034),
    [anon_sym_noperspective] = ACTIONS(3034),
    [anon_sym_nointerpolation] = ACTIONS(3034),
    [anon_sym_sample] = ACTIONS(3034),
    [anon_sym_linear] = ACTIONS(3034),
    [anon_sym_snorm] = ACTIONS(3034),
    [anon_sym_unorm] = ACTIONS(3034),
    [anon_sym_point] = ACTIONS(3034),
    [anon_sym_line] = ACTIONS(3034),
    [anon_sym_triangleadj] = ACTIONS(3034),
    [anon_sym_lineadj] = ACTIONS(3034),
    [anon_sym_triangle] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3034),
    [anon_sym_extension] = ACTIONS(3034),
    [anon_sym___init] = ACTIONS(3034),
    [anon_sym___subscript] = ACTIONS(3034),
    [anon_sym_property] = ACTIONS(3034),
    [anon_sym_associatedtype] = ACTIONS(3034),
  },
  [1581] = {
    [sym_compound_statement] = STATE(10034),
    [sym_expression] = STATE(5457),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10034),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym___extension__] = ACTIONS(5472),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(5432),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1582] = {
    [sym_identifier] = ACTIONS(5474),
    [aux_sym_preproc_def_token1] = ACTIONS(5474),
    [aux_sym_preproc_if_token1] = ACTIONS(5474),
    [aux_sym_preproc_if_token2] = ACTIONS(5474),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5474),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5474),
    [aux_sym_preproc_else_token1] = ACTIONS(5474),
    [aux_sym_preproc_elif_token1] = ACTIONS(5474),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5474),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5474),
    [sym_preproc_directive] = ACTIONS(5474),
    [anon_sym_LPAREN2] = ACTIONS(5476),
    [anon_sym_TILDE] = ACTIONS(5476),
    [anon_sym_STAR] = ACTIONS(5476),
    [anon_sym_AMP_AMP] = ACTIONS(5476),
    [anon_sym_AMP] = ACTIONS(5474),
    [anon_sym___extension__] = ACTIONS(5474),
    [anon_sym_typedef] = ACTIONS(5474),
    [anon_sym_in] = ACTIONS(5474),
    [anon_sym_out] = ACTIONS(5474),
    [anon_sym_inout] = ACTIONS(5474),
    [anon_sym_extern] = ACTIONS(5474),
    [anon_sym___attribute__] = ACTIONS(5474),
    [anon_sym_COLON_COLON] = ACTIONS(5476),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5476),
    [anon_sym___declspec] = ACTIONS(5474),
    [anon_sym___based] = ACTIONS(5474),
    [anon_sym_signed] = ACTIONS(5474),
    [anon_sym_unsigned] = ACTIONS(5474),
    [anon_sym_long] = ACTIONS(5474),
    [anon_sym_short] = ACTIONS(5474),
    [anon_sym_LBRACK] = ACTIONS(5474),
    [anon_sym_static] = ACTIONS(5474),
    [anon_sym_register] = ACTIONS(5474),
    [anon_sym_inline] = ACTIONS(5474),
    [anon_sym___inline] = ACTIONS(5474),
    [anon_sym___inline__] = ACTIONS(5474),
    [anon_sym___forceinline] = ACTIONS(5474),
    [anon_sym_thread_local] = ACTIONS(5474),
    [anon_sym___thread] = ACTIONS(5474),
    [anon_sym_const] = ACTIONS(5474),
    [anon_sym_constexpr] = ACTIONS(5474),
    [anon_sym_volatile] = ACTIONS(5474),
    [anon_sym_restrict] = ACTIONS(5474),
    [anon_sym___restrict__] = ACTIONS(5474),
    [anon_sym__Atomic] = ACTIONS(5474),
    [anon_sym__Noreturn] = ACTIONS(5474),
    [anon_sym_noreturn] = ACTIONS(5474),
    [anon_sym_mutable] = ACTIONS(5474),
    [anon_sym_constinit] = ACTIONS(5474),
    [anon_sym_consteval] = ACTIONS(5474),
    [anon_sym_alignas] = ACTIONS(5474),
    [anon_sym__Alignas] = ACTIONS(5474),
    [sym_primitive_type] = ACTIONS(5474),
    [anon_sym_enum] = ACTIONS(5474),
    [anon_sym_class] = ACTIONS(5474),
    [anon_sym_struct] = ACTIONS(5474),
    [anon_sym_union] = ACTIONS(5474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5474),
    [anon_sym_let] = ACTIONS(5474),
    [anon_sym_This] = ACTIONS(5474),
    [anon_sym_decltype] = ACTIONS(5474),
    [sym_virtual] = ACTIONS(5474),
    [anon_sym_explicit] = ACTIONS(5474),
    [anon_sym_typename] = ACTIONS(5474),
    [anon_sym_template] = ACTIONS(5474),
    [anon_sym_operator] = ACTIONS(5474),
    [anon_sym_friend] = ACTIONS(5474),
    [anon_sym_public] = ACTIONS(5474),
    [anon_sym_private] = ACTIONS(5474),
    [anon_sym_protected] = ACTIONS(5474),
    [anon_sym_using] = ACTIONS(5474),
    [anon_sym_static_assert] = ACTIONS(5474),
    [anon_sym_precise] = ACTIONS(5474),
    [anon_sym_shared] = ACTIONS(5474),
    [anon_sym_groupshared] = ACTIONS(5474),
    [anon_sym_uniform] = ACTIONS(5474),
    [anon_sym_row_major] = ACTIONS(5474),
    [anon_sym_column_major] = ACTIONS(5474),
    [anon_sym_globallycoherent] = ACTIONS(5474),
    [anon_sym_centroid] = ACTIONS(5474),
    [anon_sym_noperspective] = ACTIONS(5474),
    [anon_sym_nointerpolation] = ACTIONS(5474),
    [anon_sym_sample] = ACTIONS(5474),
    [anon_sym_linear] = ACTIONS(5474),
    [anon_sym_snorm] = ACTIONS(5474),
    [anon_sym_unorm] = ACTIONS(5474),
    [anon_sym_point] = ACTIONS(5474),
    [anon_sym_line] = ACTIONS(5474),
    [anon_sym_triangleadj] = ACTIONS(5474),
    [anon_sym_lineadj] = ACTIONS(5474),
    [anon_sym_triangle] = ACTIONS(5474),
    [anon_sym_interface] = ACTIONS(5474),
    [anon_sym_extension] = ACTIONS(5474),
    [anon_sym___init] = ACTIONS(5474),
    [anon_sym___subscript] = ACTIONS(5474),
    [anon_sym_property] = ACTIONS(5474),
    [anon_sym_associatedtype] = ACTIONS(5474),
  },
  [1583] = {
    [sym_identifier] = ACTIONS(5478),
    [aux_sym_preproc_def_token1] = ACTIONS(5478),
    [aux_sym_preproc_if_token1] = ACTIONS(5478),
    [aux_sym_preproc_if_token2] = ACTIONS(5478),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5478),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5478),
    [aux_sym_preproc_else_token1] = ACTIONS(5478),
    [aux_sym_preproc_elif_token1] = ACTIONS(5478),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5478),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5478),
    [sym_preproc_directive] = ACTIONS(5478),
    [anon_sym_LPAREN2] = ACTIONS(5480),
    [anon_sym_TILDE] = ACTIONS(5480),
    [anon_sym_STAR] = ACTIONS(5480),
    [anon_sym_AMP_AMP] = ACTIONS(5480),
    [anon_sym_AMP] = ACTIONS(5478),
    [anon_sym___extension__] = ACTIONS(5478),
    [anon_sym_typedef] = ACTIONS(5478),
    [anon_sym_in] = ACTIONS(5478),
    [anon_sym_out] = ACTIONS(5478),
    [anon_sym_inout] = ACTIONS(5478),
    [anon_sym_extern] = ACTIONS(5478),
    [anon_sym___attribute__] = ACTIONS(5478),
    [anon_sym_COLON_COLON] = ACTIONS(5480),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5480),
    [anon_sym___declspec] = ACTIONS(5478),
    [anon_sym___based] = ACTIONS(5478),
    [anon_sym_signed] = ACTIONS(5478),
    [anon_sym_unsigned] = ACTIONS(5478),
    [anon_sym_long] = ACTIONS(5478),
    [anon_sym_short] = ACTIONS(5478),
    [anon_sym_LBRACK] = ACTIONS(5478),
    [anon_sym_static] = ACTIONS(5478),
    [anon_sym_register] = ACTIONS(5478),
    [anon_sym_inline] = ACTIONS(5478),
    [anon_sym___inline] = ACTIONS(5478),
    [anon_sym___inline__] = ACTIONS(5478),
    [anon_sym___forceinline] = ACTIONS(5478),
    [anon_sym_thread_local] = ACTIONS(5478),
    [anon_sym___thread] = ACTIONS(5478),
    [anon_sym_const] = ACTIONS(5478),
    [anon_sym_constexpr] = ACTIONS(5478),
    [anon_sym_volatile] = ACTIONS(5478),
    [anon_sym_restrict] = ACTIONS(5478),
    [anon_sym___restrict__] = ACTIONS(5478),
    [anon_sym__Atomic] = ACTIONS(5478),
    [anon_sym__Noreturn] = ACTIONS(5478),
    [anon_sym_noreturn] = ACTIONS(5478),
    [anon_sym_mutable] = ACTIONS(5478),
    [anon_sym_constinit] = ACTIONS(5478),
    [anon_sym_consteval] = ACTIONS(5478),
    [anon_sym_alignas] = ACTIONS(5478),
    [anon_sym__Alignas] = ACTIONS(5478),
    [sym_primitive_type] = ACTIONS(5478),
    [anon_sym_enum] = ACTIONS(5478),
    [anon_sym_class] = ACTIONS(5478),
    [anon_sym_struct] = ACTIONS(5478),
    [anon_sym_union] = ACTIONS(5478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5478),
    [anon_sym_let] = ACTIONS(5478),
    [anon_sym_This] = ACTIONS(5478),
    [anon_sym_decltype] = ACTIONS(5478),
    [sym_virtual] = ACTIONS(5478),
    [anon_sym_explicit] = ACTIONS(5478),
    [anon_sym_typename] = ACTIONS(5478),
    [anon_sym_template] = ACTIONS(5478),
    [anon_sym_operator] = ACTIONS(5478),
    [anon_sym_friend] = ACTIONS(5478),
    [anon_sym_public] = ACTIONS(5478),
    [anon_sym_private] = ACTIONS(5478),
    [anon_sym_protected] = ACTIONS(5478),
    [anon_sym_using] = ACTIONS(5478),
    [anon_sym_static_assert] = ACTIONS(5478),
    [anon_sym_precise] = ACTIONS(5478),
    [anon_sym_shared] = ACTIONS(5478),
    [anon_sym_groupshared] = ACTIONS(5478),
    [anon_sym_uniform] = ACTIONS(5478),
    [anon_sym_row_major] = ACTIONS(5478),
    [anon_sym_column_major] = ACTIONS(5478),
    [anon_sym_globallycoherent] = ACTIONS(5478),
    [anon_sym_centroid] = ACTIONS(5478),
    [anon_sym_noperspective] = ACTIONS(5478),
    [anon_sym_nointerpolation] = ACTIONS(5478),
    [anon_sym_sample] = ACTIONS(5478),
    [anon_sym_linear] = ACTIONS(5478),
    [anon_sym_snorm] = ACTIONS(5478),
    [anon_sym_unorm] = ACTIONS(5478),
    [anon_sym_point] = ACTIONS(5478),
    [anon_sym_line] = ACTIONS(5478),
    [anon_sym_triangleadj] = ACTIONS(5478),
    [anon_sym_lineadj] = ACTIONS(5478),
    [anon_sym_triangle] = ACTIONS(5478),
    [anon_sym_interface] = ACTIONS(5478),
    [anon_sym_extension] = ACTIONS(5478),
    [anon_sym___init] = ACTIONS(5478),
    [anon_sym___subscript] = ACTIONS(5478),
    [anon_sym_property] = ACTIONS(5478),
    [anon_sym_associatedtype] = ACTIONS(5478),
  },
  [1584] = {
    [sym_identifier] = ACTIONS(3222),
    [aux_sym_preproc_def_token1] = ACTIONS(3222),
    [aux_sym_preproc_if_token1] = ACTIONS(3222),
    [aux_sym_preproc_if_token2] = ACTIONS(3222),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3222),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3222),
    [aux_sym_preproc_else_token1] = ACTIONS(3222),
    [aux_sym_preproc_elif_token1] = ACTIONS(3222),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3222),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3222),
    [sym_preproc_directive] = ACTIONS(3222),
    [anon_sym_LPAREN2] = ACTIONS(3224),
    [anon_sym_TILDE] = ACTIONS(3224),
    [anon_sym_STAR] = ACTIONS(3224),
    [anon_sym_AMP_AMP] = ACTIONS(3224),
    [anon_sym_AMP] = ACTIONS(3222),
    [anon_sym___extension__] = ACTIONS(3222),
    [anon_sym_typedef] = ACTIONS(3222),
    [anon_sym_in] = ACTIONS(3222),
    [anon_sym_out] = ACTIONS(3222),
    [anon_sym_inout] = ACTIONS(3222),
    [anon_sym_extern] = ACTIONS(3222),
    [anon_sym___attribute__] = ACTIONS(3222),
    [anon_sym_COLON_COLON] = ACTIONS(3224),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3224),
    [anon_sym___declspec] = ACTIONS(3222),
    [anon_sym___based] = ACTIONS(3222),
    [anon_sym_signed] = ACTIONS(3222),
    [anon_sym_unsigned] = ACTIONS(3222),
    [anon_sym_long] = ACTIONS(3222),
    [anon_sym_short] = ACTIONS(3222),
    [anon_sym_LBRACK] = ACTIONS(3222),
    [anon_sym_static] = ACTIONS(3222),
    [anon_sym_register] = ACTIONS(3222),
    [anon_sym_inline] = ACTIONS(3222),
    [anon_sym___inline] = ACTIONS(3222),
    [anon_sym___inline__] = ACTIONS(3222),
    [anon_sym___forceinline] = ACTIONS(3222),
    [anon_sym_thread_local] = ACTIONS(3222),
    [anon_sym___thread] = ACTIONS(3222),
    [anon_sym_const] = ACTIONS(3222),
    [anon_sym_constexpr] = ACTIONS(3222),
    [anon_sym_volatile] = ACTIONS(3222),
    [anon_sym_restrict] = ACTIONS(3222),
    [anon_sym___restrict__] = ACTIONS(3222),
    [anon_sym__Atomic] = ACTIONS(3222),
    [anon_sym__Noreturn] = ACTIONS(3222),
    [anon_sym_noreturn] = ACTIONS(3222),
    [anon_sym_mutable] = ACTIONS(3222),
    [anon_sym_constinit] = ACTIONS(3222),
    [anon_sym_consteval] = ACTIONS(3222),
    [anon_sym_alignas] = ACTIONS(3222),
    [anon_sym__Alignas] = ACTIONS(3222),
    [sym_primitive_type] = ACTIONS(3222),
    [anon_sym_enum] = ACTIONS(3222),
    [anon_sym_class] = ACTIONS(3222),
    [anon_sym_struct] = ACTIONS(3222),
    [anon_sym_union] = ACTIONS(3222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3222),
    [anon_sym_let] = ACTIONS(3222),
    [anon_sym_This] = ACTIONS(3222),
    [anon_sym_decltype] = ACTIONS(3222),
    [sym_virtual] = ACTIONS(3222),
    [anon_sym_explicit] = ACTIONS(3222),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3222),
    [anon_sym_operator] = ACTIONS(3222),
    [anon_sym_friend] = ACTIONS(3222),
    [anon_sym_public] = ACTIONS(3222),
    [anon_sym_private] = ACTIONS(3222),
    [anon_sym_protected] = ACTIONS(3222),
    [anon_sym_using] = ACTIONS(3222),
    [anon_sym_static_assert] = ACTIONS(3222),
    [anon_sym_precise] = ACTIONS(3222),
    [anon_sym_shared] = ACTIONS(3222),
    [anon_sym_groupshared] = ACTIONS(3222),
    [anon_sym_uniform] = ACTIONS(3222),
    [anon_sym_row_major] = ACTIONS(3222),
    [anon_sym_column_major] = ACTIONS(3222),
    [anon_sym_globallycoherent] = ACTIONS(3222),
    [anon_sym_centroid] = ACTIONS(3222),
    [anon_sym_noperspective] = ACTIONS(3222),
    [anon_sym_nointerpolation] = ACTIONS(3222),
    [anon_sym_sample] = ACTIONS(3222),
    [anon_sym_linear] = ACTIONS(3222),
    [anon_sym_snorm] = ACTIONS(3222),
    [anon_sym_unorm] = ACTIONS(3222),
    [anon_sym_point] = ACTIONS(3222),
    [anon_sym_line] = ACTIONS(3222),
    [anon_sym_triangleadj] = ACTIONS(3222),
    [anon_sym_lineadj] = ACTIONS(3222),
    [anon_sym_triangle] = ACTIONS(3222),
    [anon_sym_interface] = ACTIONS(3222),
    [anon_sym_extension] = ACTIONS(3222),
    [anon_sym___init] = ACTIONS(3222),
    [anon_sym___subscript] = ACTIONS(3222),
    [anon_sym_property] = ACTIONS(3222),
    [anon_sym_associatedtype] = ACTIONS(3222),
  },
  [1585] = {
    [sym_expression] = STATE(5466),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10888),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10888),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5482),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1586] = {
    [sym_expression] = STATE(5361),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10319),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10319),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5484),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1587] = {
    [sym_identifier] = ACTIONS(3344),
    [aux_sym_preproc_def_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token2] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3344),
    [aux_sym_preproc_else_token1] = ACTIONS(3344),
    [aux_sym_preproc_elif_token1] = ACTIONS(3344),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3344),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3344),
    [sym_preproc_directive] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym___extension__] = ACTIONS(3344),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_in] = ACTIONS(3344),
    [anon_sym_out] = ACTIONS(3344),
    [anon_sym_inout] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym___attribute__] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3346),
    [anon_sym___declspec] = ACTIONS(3344),
    [anon_sym___based] = ACTIONS(3344),
    [anon_sym_signed] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym___inline] = ACTIONS(3344),
    [anon_sym___inline__] = ACTIONS(3344),
    [anon_sym___forceinline] = ACTIONS(3344),
    [anon_sym_thread_local] = ACTIONS(3344),
    [anon_sym___thread] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym___restrict__] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym__Noreturn] = ACTIONS(3344),
    [anon_sym_noreturn] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_constinit] = ACTIONS(3344),
    [anon_sym_consteval] = ACTIONS(3344),
    [anon_sym_alignas] = ACTIONS(3344),
    [anon_sym__Alignas] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_class] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_This] = ACTIONS(3344),
    [anon_sym_decltype] = ACTIONS(3344),
    [sym_virtual] = ACTIONS(3344),
    [anon_sym_explicit] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_template] = ACTIONS(3344),
    [anon_sym_operator] = ACTIONS(3344),
    [anon_sym_friend] = ACTIONS(3344),
    [anon_sym_public] = ACTIONS(3344),
    [anon_sym_private] = ACTIONS(3344),
    [anon_sym_protected] = ACTIONS(3344),
    [anon_sym_using] = ACTIONS(3344),
    [anon_sym_static_assert] = ACTIONS(3344),
    [anon_sym_precise] = ACTIONS(3344),
    [anon_sym_shared] = ACTIONS(3344),
    [anon_sym_groupshared] = ACTIONS(3344),
    [anon_sym_uniform] = ACTIONS(3344),
    [anon_sym_row_major] = ACTIONS(3344),
    [anon_sym_column_major] = ACTIONS(3344),
    [anon_sym_globallycoherent] = ACTIONS(3344),
    [anon_sym_centroid] = ACTIONS(3344),
    [anon_sym_noperspective] = ACTIONS(3344),
    [anon_sym_nointerpolation] = ACTIONS(3344),
    [anon_sym_sample] = ACTIONS(3344),
    [anon_sym_linear] = ACTIONS(3344),
    [anon_sym_snorm] = ACTIONS(3344),
    [anon_sym_unorm] = ACTIONS(3344),
    [anon_sym_point] = ACTIONS(3344),
    [anon_sym_line] = ACTIONS(3344),
    [anon_sym_triangleadj] = ACTIONS(3344),
    [anon_sym_lineadj] = ACTIONS(3344),
    [anon_sym_triangle] = ACTIONS(3344),
    [anon_sym_interface] = ACTIONS(3344),
    [anon_sym_extension] = ACTIONS(3344),
    [anon_sym___init] = ACTIONS(3344),
    [anon_sym___subscript] = ACTIONS(3344),
    [anon_sym_property] = ACTIONS(3344),
    [anon_sym_associatedtype] = ACTIONS(3344),
  },
  [1588] = {
    [sym_identifier] = ACTIONS(3344),
    [aux_sym_preproc_def_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token2] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3344),
    [aux_sym_preproc_else_token1] = ACTIONS(3344),
    [aux_sym_preproc_elif_token1] = ACTIONS(3344),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3344),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3344),
    [sym_preproc_directive] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym___extension__] = ACTIONS(3344),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_in] = ACTIONS(3344),
    [anon_sym_out] = ACTIONS(3344),
    [anon_sym_inout] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym___attribute__] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3346),
    [anon_sym___declspec] = ACTIONS(3344),
    [anon_sym___based] = ACTIONS(3344),
    [anon_sym_signed] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym___inline] = ACTIONS(3344),
    [anon_sym___inline__] = ACTIONS(3344),
    [anon_sym___forceinline] = ACTIONS(3344),
    [anon_sym_thread_local] = ACTIONS(3344),
    [anon_sym___thread] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym___restrict__] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym__Noreturn] = ACTIONS(3344),
    [anon_sym_noreturn] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_constinit] = ACTIONS(3344),
    [anon_sym_consteval] = ACTIONS(3344),
    [anon_sym_alignas] = ACTIONS(3344),
    [anon_sym__Alignas] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_class] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_This] = ACTIONS(3344),
    [anon_sym_decltype] = ACTIONS(3344),
    [sym_virtual] = ACTIONS(3344),
    [anon_sym_explicit] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_template] = ACTIONS(3344),
    [anon_sym_operator] = ACTIONS(3344),
    [anon_sym_friend] = ACTIONS(3344),
    [anon_sym_public] = ACTIONS(3344),
    [anon_sym_private] = ACTIONS(3344),
    [anon_sym_protected] = ACTIONS(3344),
    [anon_sym_using] = ACTIONS(3344),
    [anon_sym_static_assert] = ACTIONS(3344),
    [anon_sym_precise] = ACTIONS(3344),
    [anon_sym_shared] = ACTIONS(3344),
    [anon_sym_groupshared] = ACTIONS(3344),
    [anon_sym_uniform] = ACTIONS(3344),
    [anon_sym_row_major] = ACTIONS(3344),
    [anon_sym_column_major] = ACTIONS(3344),
    [anon_sym_globallycoherent] = ACTIONS(3344),
    [anon_sym_centroid] = ACTIONS(3344),
    [anon_sym_noperspective] = ACTIONS(3344),
    [anon_sym_nointerpolation] = ACTIONS(3344),
    [anon_sym_sample] = ACTIONS(3344),
    [anon_sym_linear] = ACTIONS(3344),
    [anon_sym_snorm] = ACTIONS(3344),
    [anon_sym_unorm] = ACTIONS(3344),
    [anon_sym_point] = ACTIONS(3344),
    [anon_sym_line] = ACTIONS(3344),
    [anon_sym_triangleadj] = ACTIONS(3344),
    [anon_sym_lineadj] = ACTIONS(3344),
    [anon_sym_triangle] = ACTIONS(3344),
    [anon_sym_interface] = ACTIONS(3344),
    [anon_sym_extension] = ACTIONS(3344),
    [anon_sym___init] = ACTIONS(3344),
    [anon_sym___subscript] = ACTIONS(3344),
    [anon_sym_property] = ACTIONS(3344),
    [anon_sym_associatedtype] = ACTIONS(3344),
  },
  [1589] = {
    [sym_identifier] = ACTIONS(3613),
    [aux_sym_preproc_def_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token2] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3613),
    [aux_sym_preproc_else_token1] = ACTIONS(3613),
    [aux_sym_preproc_elif_token1] = ACTIONS(3613),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3613),
    [sym_preproc_directive] = ACTIONS(3613),
    [anon_sym_LPAREN2] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym___extension__] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3613),
    [anon_sym_in] = ACTIONS(3613),
    [anon_sym_out] = ACTIONS(3613),
    [anon_sym_inout] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym___attribute__] = ACTIONS(3613),
    [anon_sym_COLON_COLON] = ACTIONS(3615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3615),
    [anon_sym___declspec] = ACTIONS(3613),
    [anon_sym___based] = ACTIONS(3613),
    [anon_sym_signed] = ACTIONS(3613),
    [anon_sym_unsigned] = ACTIONS(3613),
    [anon_sym_long] = ACTIONS(3613),
    [anon_sym_short] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_register] = ACTIONS(3613),
    [anon_sym_inline] = ACTIONS(3613),
    [anon_sym___inline] = ACTIONS(3613),
    [anon_sym___inline__] = ACTIONS(3613),
    [anon_sym___forceinline] = ACTIONS(3613),
    [anon_sym_thread_local] = ACTIONS(3613),
    [anon_sym___thread] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_constexpr] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_restrict] = ACTIONS(3613),
    [anon_sym___restrict__] = ACTIONS(3613),
    [anon_sym__Atomic] = ACTIONS(3613),
    [anon_sym__Noreturn] = ACTIONS(3613),
    [anon_sym_noreturn] = ACTIONS(3613),
    [anon_sym_mutable] = ACTIONS(3613),
    [anon_sym_constinit] = ACTIONS(3613),
    [anon_sym_consteval] = ACTIONS(3613),
    [anon_sym_alignas] = ACTIONS(3613),
    [anon_sym__Alignas] = ACTIONS(3613),
    [sym_primitive_type] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_union] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_This] = ACTIONS(3613),
    [anon_sym_decltype] = ACTIONS(3613),
    [sym_virtual] = ACTIONS(3613),
    [anon_sym_explicit] = ACTIONS(3613),
    [anon_sym_typename] = ACTIONS(3613),
    [anon_sym_template] = ACTIONS(3613),
    [anon_sym_operator] = ACTIONS(3613),
    [anon_sym_friend] = ACTIONS(3613),
    [anon_sym_public] = ACTIONS(3613),
    [anon_sym_private] = ACTIONS(3613),
    [anon_sym_protected] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_static_assert] = ACTIONS(3613),
    [anon_sym_precise] = ACTIONS(3613),
    [anon_sym_shared] = ACTIONS(3613),
    [anon_sym_groupshared] = ACTIONS(3613),
    [anon_sym_uniform] = ACTIONS(3613),
    [anon_sym_row_major] = ACTIONS(3613),
    [anon_sym_column_major] = ACTIONS(3613),
    [anon_sym_globallycoherent] = ACTIONS(3613),
    [anon_sym_centroid] = ACTIONS(3613),
    [anon_sym_noperspective] = ACTIONS(3613),
    [anon_sym_nointerpolation] = ACTIONS(3613),
    [anon_sym_sample] = ACTIONS(3613),
    [anon_sym_linear] = ACTIONS(3613),
    [anon_sym_snorm] = ACTIONS(3613),
    [anon_sym_unorm] = ACTIONS(3613),
    [anon_sym_point] = ACTIONS(3613),
    [anon_sym_line] = ACTIONS(3613),
    [anon_sym_triangleadj] = ACTIONS(3613),
    [anon_sym_lineadj] = ACTIONS(3613),
    [anon_sym_triangle] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_extension] = ACTIONS(3613),
    [anon_sym___init] = ACTIONS(3613),
    [anon_sym___subscript] = ACTIONS(3613),
    [anon_sym_property] = ACTIONS(3613),
    [anon_sym_associatedtype] = ACTIONS(3613),
  },
  [1590] = {
    [sym_identifier] = ACTIONS(3613),
    [aux_sym_preproc_def_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token2] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3613),
    [aux_sym_preproc_else_token1] = ACTIONS(3613),
    [aux_sym_preproc_elif_token1] = ACTIONS(3613),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3613),
    [sym_preproc_directive] = ACTIONS(3613),
    [anon_sym_LPAREN2] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym___extension__] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3613),
    [anon_sym_in] = ACTIONS(3613),
    [anon_sym_out] = ACTIONS(3613),
    [anon_sym_inout] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym___attribute__] = ACTIONS(3613),
    [anon_sym_COLON_COLON] = ACTIONS(3615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3615),
    [anon_sym___declspec] = ACTIONS(3613),
    [anon_sym___based] = ACTIONS(3613),
    [anon_sym_signed] = ACTIONS(3613),
    [anon_sym_unsigned] = ACTIONS(3613),
    [anon_sym_long] = ACTIONS(3613),
    [anon_sym_short] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_register] = ACTIONS(3613),
    [anon_sym_inline] = ACTIONS(3613),
    [anon_sym___inline] = ACTIONS(3613),
    [anon_sym___inline__] = ACTIONS(3613),
    [anon_sym___forceinline] = ACTIONS(3613),
    [anon_sym_thread_local] = ACTIONS(3613),
    [anon_sym___thread] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_constexpr] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_restrict] = ACTIONS(3613),
    [anon_sym___restrict__] = ACTIONS(3613),
    [anon_sym__Atomic] = ACTIONS(3613),
    [anon_sym__Noreturn] = ACTIONS(3613),
    [anon_sym_noreturn] = ACTIONS(3613),
    [anon_sym_mutable] = ACTIONS(3613),
    [anon_sym_constinit] = ACTIONS(3613),
    [anon_sym_consteval] = ACTIONS(3613),
    [anon_sym_alignas] = ACTIONS(3613),
    [anon_sym__Alignas] = ACTIONS(3613),
    [sym_primitive_type] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_union] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_This] = ACTIONS(3613),
    [anon_sym_decltype] = ACTIONS(3613),
    [sym_virtual] = ACTIONS(3613),
    [anon_sym_explicit] = ACTIONS(3613),
    [anon_sym_typename] = ACTIONS(3613),
    [anon_sym_template] = ACTIONS(3613),
    [anon_sym_operator] = ACTIONS(3613),
    [anon_sym_friend] = ACTIONS(3613),
    [anon_sym_public] = ACTIONS(3613),
    [anon_sym_private] = ACTIONS(3613),
    [anon_sym_protected] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_static_assert] = ACTIONS(3613),
    [anon_sym_precise] = ACTIONS(3613),
    [anon_sym_shared] = ACTIONS(3613),
    [anon_sym_groupshared] = ACTIONS(3613),
    [anon_sym_uniform] = ACTIONS(3613),
    [anon_sym_row_major] = ACTIONS(3613),
    [anon_sym_column_major] = ACTIONS(3613),
    [anon_sym_globallycoherent] = ACTIONS(3613),
    [anon_sym_centroid] = ACTIONS(3613),
    [anon_sym_noperspective] = ACTIONS(3613),
    [anon_sym_nointerpolation] = ACTIONS(3613),
    [anon_sym_sample] = ACTIONS(3613),
    [anon_sym_linear] = ACTIONS(3613),
    [anon_sym_snorm] = ACTIONS(3613),
    [anon_sym_unorm] = ACTIONS(3613),
    [anon_sym_point] = ACTIONS(3613),
    [anon_sym_line] = ACTIONS(3613),
    [anon_sym_triangleadj] = ACTIONS(3613),
    [anon_sym_lineadj] = ACTIONS(3613),
    [anon_sym_triangle] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_extension] = ACTIONS(3613),
    [anon_sym___init] = ACTIONS(3613),
    [anon_sym___subscript] = ACTIONS(3613),
    [anon_sym_property] = ACTIONS(3613),
    [anon_sym_associatedtype] = ACTIONS(3613),
  },
  [1591] = {
    [sym_identifier] = ACTIONS(3344),
    [aux_sym_preproc_def_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token2] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3344),
    [aux_sym_preproc_else_token1] = ACTIONS(3344),
    [aux_sym_preproc_elif_token1] = ACTIONS(3344),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3344),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3344),
    [sym_preproc_directive] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym___extension__] = ACTIONS(3344),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_in] = ACTIONS(3344),
    [anon_sym_out] = ACTIONS(3344),
    [anon_sym_inout] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym___attribute__] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3346),
    [anon_sym___declspec] = ACTIONS(3344),
    [anon_sym___based] = ACTIONS(3344),
    [anon_sym_signed] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym___inline] = ACTIONS(3344),
    [anon_sym___inline__] = ACTIONS(3344),
    [anon_sym___forceinline] = ACTIONS(3344),
    [anon_sym_thread_local] = ACTIONS(3344),
    [anon_sym___thread] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym___restrict__] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym__Noreturn] = ACTIONS(3344),
    [anon_sym_noreturn] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_constinit] = ACTIONS(3344),
    [anon_sym_consteval] = ACTIONS(3344),
    [anon_sym_alignas] = ACTIONS(3344),
    [anon_sym__Alignas] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_class] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_This] = ACTIONS(3344),
    [anon_sym_decltype] = ACTIONS(3344),
    [sym_virtual] = ACTIONS(3344),
    [anon_sym_explicit] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_template] = ACTIONS(3344),
    [anon_sym_operator] = ACTIONS(3344),
    [anon_sym_friend] = ACTIONS(3344),
    [anon_sym_public] = ACTIONS(3344),
    [anon_sym_private] = ACTIONS(3344),
    [anon_sym_protected] = ACTIONS(3344),
    [anon_sym_using] = ACTIONS(3344),
    [anon_sym_static_assert] = ACTIONS(3344),
    [anon_sym_precise] = ACTIONS(3344),
    [anon_sym_shared] = ACTIONS(3344),
    [anon_sym_groupshared] = ACTIONS(3344),
    [anon_sym_uniform] = ACTIONS(3344),
    [anon_sym_row_major] = ACTIONS(3344),
    [anon_sym_column_major] = ACTIONS(3344),
    [anon_sym_globallycoherent] = ACTIONS(3344),
    [anon_sym_centroid] = ACTIONS(3344),
    [anon_sym_noperspective] = ACTIONS(3344),
    [anon_sym_nointerpolation] = ACTIONS(3344),
    [anon_sym_sample] = ACTIONS(3344),
    [anon_sym_linear] = ACTIONS(3344),
    [anon_sym_snorm] = ACTIONS(3344),
    [anon_sym_unorm] = ACTIONS(3344),
    [anon_sym_point] = ACTIONS(3344),
    [anon_sym_line] = ACTIONS(3344),
    [anon_sym_triangleadj] = ACTIONS(3344),
    [anon_sym_lineadj] = ACTIONS(3344),
    [anon_sym_triangle] = ACTIONS(3344),
    [anon_sym_interface] = ACTIONS(3344),
    [anon_sym_extension] = ACTIONS(3344),
    [anon_sym___init] = ACTIONS(3344),
    [anon_sym___subscript] = ACTIONS(3344),
    [anon_sym_property] = ACTIONS(3344),
    [anon_sym_associatedtype] = ACTIONS(3344),
  },
  [1592] = {
    [sym_identifier] = ACTIONS(3613),
    [aux_sym_preproc_def_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token2] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3613),
    [aux_sym_preproc_else_token1] = ACTIONS(3613),
    [aux_sym_preproc_elif_token1] = ACTIONS(3613),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3613),
    [sym_preproc_directive] = ACTIONS(3613),
    [anon_sym_LPAREN2] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym___extension__] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3613),
    [anon_sym_in] = ACTIONS(3613),
    [anon_sym_out] = ACTIONS(3613),
    [anon_sym_inout] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym___attribute__] = ACTIONS(3613),
    [anon_sym_COLON_COLON] = ACTIONS(3615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3615),
    [anon_sym___declspec] = ACTIONS(3613),
    [anon_sym___based] = ACTIONS(3613),
    [anon_sym_signed] = ACTIONS(3613),
    [anon_sym_unsigned] = ACTIONS(3613),
    [anon_sym_long] = ACTIONS(3613),
    [anon_sym_short] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_register] = ACTIONS(3613),
    [anon_sym_inline] = ACTIONS(3613),
    [anon_sym___inline] = ACTIONS(3613),
    [anon_sym___inline__] = ACTIONS(3613),
    [anon_sym___forceinline] = ACTIONS(3613),
    [anon_sym_thread_local] = ACTIONS(3613),
    [anon_sym___thread] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_constexpr] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_restrict] = ACTIONS(3613),
    [anon_sym___restrict__] = ACTIONS(3613),
    [anon_sym__Atomic] = ACTIONS(3613),
    [anon_sym__Noreturn] = ACTIONS(3613),
    [anon_sym_noreturn] = ACTIONS(3613),
    [anon_sym_mutable] = ACTIONS(3613),
    [anon_sym_constinit] = ACTIONS(3613),
    [anon_sym_consteval] = ACTIONS(3613),
    [anon_sym_alignas] = ACTIONS(3613),
    [anon_sym__Alignas] = ACTIONS(3613),
    [sym_primitive_type] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_union] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_This] = ACTIONS(3613),
    [anon_sym_decltype] = ACTIONS(3613),
    [sym_virtual] = ACTIONS(3613),
    [anon_sym_explicit] = ACTIONS(3613),
    [anon_sym_typename] = ACTIONS(3613),
    [anon_sym_template] = ACTIONS(3613),
    [anon_sym_operator] = ACTIONS(3613),
    [anon_sym_friend] = ACTIONS(3613),
    [anon_sym_public] = ACTIONS(3613),
    [anon_sym_private] = ACTIONS(3613),
    [anon_sym_protected] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_static_assert] = ACTIONS(3613),
    [anon_sym_precise] = ACTIONS(3613),
    [anon_sym_shared] = ACTIONS(3613),
    [anon_sym_groupshared] = ACTIONS(3613),
    [anon_sym_uniform] = ACTIONS(3613),
    [anon_sym_row_major] = ACTIONS(3613),
    [anon_sym_column_major] = ACTIONS(3613),
    [anon_sym_globallycoherent] = ACTIONS(3613),
    [anon_sym_centroid] = ACTIONS(3613),
    [anon_sym_noperspective] = ACTIONS(3613),
    [anon_sym_nointerpolation] = ACTIONS(3613),
    [anon_sym_sample] = ACTIONS(3613),
    [anon_sym_linear] = ACTIONS(3613),
    [anon_sym_snorm] = ACTIONS(3613),
    [anon_sym_unorm] = ACTIONS(3613),
    [anon_sym_point] = ACTIONS(3613),
    [anon_sym_line] = ACTIONS(3613),
    [anon_sym_triangleadj] = ACTIONS(3613),
    [anon_sym_lineadj] = ACTIONS(3613),
    [anon_sym_triangle] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_extension] = ACTIONS(3613),
    [anon_sym___init] = ACTIONS(3613),
    [anon_sym___subscript] = ACTIONS(3613),
    [anon_sym_property] = ACTIONS(3613),
    [anon_sym_associatedtype] = ACTIONS(3613),
  },
  [1593] = {
    [sym_identifier] = ACTIONS(3374),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token2] = ACTIONS(3374),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3374),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3374),
    [aux_sym_preproc_else_token1] = ACTIONS(3374),
    [aux_sym_preproc_elif_token1] = ACTIONS(3374),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3374),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3374),
    [sym_preproc_directive] = ACTIONS(3374),
    [anon_sym_LPAREN2] = ACTIONS(3376),
    [anon_sym_TILDE] = ACTIONS(3376),
    [anon_sym_STAR] = ACTIONS(3376),
    [anon_sym_AMP_AMP] = ACTIONS(3376),
    [anon_sym_AMP] = ACTIONS(3374),
    [anon_sym___extension__] = ACTIONS(3374),
    [anon_sym_typedef] = ACTIONS(3374),
    [anon_sym_in] = ACTIONS(3374),
    [anon_sym_out] = ACTIONS(3374),
    [anon_sym_inout] = ACTIONS(3374),
    [anon_sym_extern] = ACTIONS(3374),
    [anon_sym___attribute__] = ACTIONS(3374),
    [anon_sym_COLON_COLON] = ACTIONS(3376),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3376),
    [anon_sym___declspec] = ACTIONS(3374),
    [anon_sym___based] = ACTIONS(3374),
    [anon_sym_signed] = ACTIONS(3374),
    [anon_sym_unsigned] = ACTIONS(3374),
    [anon_sym_long] = ACTIONS(3374),
    [anon_sym_short] = ACTIONS(3374),
    [anon_sym_LBRACK] = ACTIONS(3374),
    [anon_sym_static] = ACTIONS(3374),
    [anon_sym_register] = ACTIONS(3374),
    [anon_sym_inline] = ACTIONS(3374),
    [anon_sym___inline] = ACTIONS(3374),
    [anon_sym___inline__] = ACTIONS(3374),
    [anon_sym___forceinline] = ACTIONS(3374),
    [anon_sym_thread_local] = ACTIONS(3374),
    [anon_sym___thread] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3374),
    [anon_sym_constexpr] = ACTIONS(3374),
    [anon_sym_volatile] = ACTIONS(3374),
    [anon_sym_restrict] = ACTIONS(3374),
    [anon_sym___restrict__] = ACTIONS(3374),
    [anon_sym__Atomic] = ACTIONS(3374),
    [anon_sym__Noreturn] = ACTIONS(3374),
    [anon_sym_noreturn] = ACTIONS(3374),
    [anon_sym_mutable] = ACTIONS(3374),
    [anon_sym_constinit] = ACTIONS(3374),
    [anon_sym_consteval] = ACTIONS(3374),
    [anon_sym_alignas] = ACTIONS(3374),
    [anon_sym__Alignas] = ACTIONS(3374),
    [sym_primitive_type] = ACTIONS(3374),
    [anon_sym_enum] = ACTIONS(3374),
    [anon_sym_class] = ACTIONS(3374),
    [anon_sym_struct] = ACTIONS(3374),
    [anon_sym_union] = ACTIONS(3374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3374),
    [anon_sym_let] = ACTIONS(3374),
    [anon_sym_This] = ACTIONS(3374),
    [anon_sym_decltype] = ACTIONS(3374),
    [sym_virtual] = ACTIONS(3374),
    [anon_sym_explicit] = ACTIONS(3374),
    [anon_sym_typename] = ACTIONS(3374),
    [anon_sym_template] = ACTIONS(3374),
    [anon_sym_operator] = ACTIONS(3374),
    [anon_sym_friend] = ACTIONS(3374),
    [anon_sym_public] = ACTIONS(3374),
    [anon_sym_private] = ACTIONS(3374),
    [anon_sym_protected] = ACTIONS(3374),
    [anon_sym_using] = ACTIONS(3374),
    [anon_sym_static_assert] = ACTIONS(3374),
    [anon_sym_precise] = ACTIONS(3374),
    [anon_sym_shared] = ACTIONS(3374),
    [anon_sym_groupshared] = ACTIONS(3374),
    [anon_sym_uniform] = ACTIONS(3374),
    [anon_sym_row_major] = ACTIONS(3374),
    [anon_sym_column_major] = ACTIONS(3374),
    [anon_sym_globallycoherent] = ACTIONS(3374),
    [anon_sym_centroid] = ACTIONS(3374),
    [anon_sym_noperspective] = ACTIONS(3374),
    [anon_sym_nointerpolation] = ACTIONS(3374),
    [anon_sym_sample] = ACTIONS(3374),
    [anon_sym_linear] = ACTIONS(3374),
    [anon_sym_snorm] = ACTIONS(3374),
    [anon_sym_unorm] = ACTIONS(3374),
    [anon_sym_point] = ACTIONS(3374),
    [anon_sym_line] = ACTIONS(3374),
    [anon_sym_triangleadj] = ACTIONS(3374),
    [anon_sym_lineadj] = ACTIONS(3374),
    [anon_sym_triangle] = ACTIONS(3374),
    [anon_sym_interface] = ACTIONS(3374),
    [anon_sym_extension] = ACTIONS(3374),
    [anon_sym___init] = ACTIONS(3374),
    [anon_sym___subscript] = ACTIONS(3374),
    [anon_sym_property] = ACTIONS(3374),
    [anon_sym_associatedtype] = ACTIONS(3374),
  },
  [1594] = {
    [sym_identifier] = ACTIONS(3368),
    [aux_sym_preproc_def_token1] = ACTIONS(3368),
    [aux_sym_preproc_if_token1] = ACTIONS(3368),
    [aux_sym_preproc_if_token2] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3368),
    [aux_sym_preproc_else_token1] = ACTIONS(3368),
    [aux_sym_preproc_elif_token1] = ACTIONS(3368),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3368),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3368),
    [sym_preproc_directive] = ACTIONS(3368),
    [anon_sym_LPAREN2] = ACTIONS(3370),
    [anon_sym_TILDE] = ACTIONS(3370),
    [anon_sym_STAR] = ACTIONS(3370),
    [anon_sym_AMP_AMP] = ACTIONS(3370),
    [anon_sym_AMP] = ACTIONS(3368),
    [anon_sym___extension__] = ACTIONS(3368),
    [anon_sym_typedef] = ACTIONS(3368),
    [anon_sym_in] = ACTIONS(3368),
    [anon_sym_out] = ACTIONS(3368),
    [anon_sym_inout] = ACTIONS(3368),
    [anon_sym_extern] = ACTIONS(3368),
    [anon_sym___attribute__] = ACTIONS(3368),
    [anon_sym_COLON_COLON] = ACTIONS(3370),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3370),
    [anon_sym___declspec] = ACTIONS(3368),
    [anon_sym___based] = ACTIONS(3368),
    [anon_sym_signed] = ACTIONS(3368),
    [anon_sym_unsigned] = ACTIONS(3368),
    [anon_sym_long] = ACTIONS(3368),
    [anon_sym_short] = ACTIONS(3368),
    [anon_sym_LBRACK] = ACTIONS(3368),
    [anon_sym_static] = ACTIONS(3368),
    [anon_sym_register] = ACTIONS(3368),
    [anon_sym_inline] = ACTIONS(3368),
    [anon_sym___inline] = ACTIONS(3368),
    [anon_sym___inline__] = ACTIONS(3368),
    [anon_sym___forceinline] = ACTIONS(3368),
    [anon_sym_thread_local] = ACTIONS(3368),
    [anon_sym___thread] = ACTIONS(3368),
    [anon_sym_const] = ACTIONS(3368),
    [anon_sym_constexpr] = ACTIONS(3368),
    [anon_sym_volatile] = ACTIONS(3368),
    [anon_sym_restrict] = ACTIONS(3368),
    [anon_sym___restrict__] = ACTIONS(3368),
    [anon_sym__Atomic] = ACTIONS(3368),
    [anon_sym__Noreturn] = ACTIONS(3368),
    [anon_sym_noreturn] = ACTIONS(3368),
    [anon_sym_mutable] = ACTIONS(3368),
    [anon_sym_constinit] = ACTIONS(3368),
    [anon_sym_consteval] = ACTIONS(3368),
    [anon_sym_alignas] = ACTIONS(3368),
    [anon_sym__Alignas] = ACTIONS(3368),
    [sym_primitive_type] = ACTIONS(3368),
    [anon_sym_enum] = ACTIONS(3368),
    [anon_sym_class] = ACTIONS(3368),
    [anon_sym_struct] = ACTIONS(3368),
    [anon_sym_union] = ACTIONS(3368),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3368),
    [anon_sym_let] = ACTIONS(3368),
    [anon_sym_This] = ACTIONS(3368),
    [anon_sym_decltype] = ACTIONS(3368),
    [sym_virtual] = ACTIONS(3368),
    [anon_sym_explicit] = ACTIONS(3368),
    [anon_sym_typename] = ACTIONS(3368),
    [anon_sym_template] = ACTIONS(3368),
    [anon_sym_operator] = ACTIONS(3368),
    [anon_sym_friend] = ACTIONS(3368),
    [anon_sym_public] = ACTIONS(3368),
    [anon_sym_private] = ACTIONS(3368),
    [anon_sym_protected] = ACTIONS(3368),
    [anon_sym_using] = ACTIONS(3368),
    [anon_sym_static_assert] = ACTIONS(3368),
    [anon_sym_precise] = ACTIONS(3368),
    [anon_sym_shared] = ACTIONS(3368),
    [anon_sym_groupshared] = ACTIONS(3368),
    [anon_sym_uniform] = ACTIONS(3368),
    [anon_sym_row_major] = ACTIONS(3368),
    [anon_sym_column_major] = ACTIONS(3368),
    [anon_sym_globallycoherent] = ACTIONS(3368),
    [anon_sym_centroid] = ACTIONS(3368),
    [anon_sym_noperspective] = ACTIONS(3368),
    [anon_sym_nointerpolation] = ACTIONS(3368),
    [anon_sym_sample] = ACTIONS(3368),
    [anon_sym_linear] = ACTIONS(3368),
    [anon_sym_snorm] = ACTIONS(3368),
    [anon_sym_unorm] = ACTIONS(3368),
    [anon_sym_point] = ACTIONS(3368),
    [anon_sym_line] = ACTIONS(3368),
    [anon_sym_triangleadj] = ACTIONS(3368),
    [anon_sym_lineadj] = ACTIONS(3368),
    [anon_sym_triangle] = ACTIONS(3368),
    [anon_sym_interface] = ACTIONS(3368),
    [anon_sym_extension] = ACTIONS(3368),
    [anon_sym___init] = ACTIONS(3368),
    [anon_sym___subscript] = ACTIONS(3368),
    [anon_sym_property] = ACTIONS(3368),
    [anon_sym_associatedtype] = ACTIONS(3368),
  },
  [1595] = {
    [sym_identifier] = ACTIONS(3613),
    [aux_sym_preproc_def_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token2] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3613),
    [aux_sym_preproc_else_token1] = ACTIONS(3613),
    [aux_sym_preproc_elif_token1] = ACTIONS(3613),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3613),
    [sym_preproc_directive] = ACTIONS(3613),
    [anon_sym_LPAREN2] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym___extension__] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3613),
    [anon_sym_in] = ACTIONS(3613),
    [anon_sym_out] = ACTIONS(3613),
    [anon_sym_inout] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym___attribute__] = ACTIONS(3613),
    [anon_sym_COLON_COLON] = ACTIONS(3615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3615),
    [anon_sym___declspec] = ACTIONS(3613),
    [anon_sym___based] = ACTIONS(3613),
    [anon_sym_signed] = ACTIONS(3613),
    [anon_sym_unsigned] = ACTIONS(3613),
    [anon_sym_long] = ACTIONS(3613),
    [anon_sym_short] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_register] = ACTIONS(3613),
    [anon_sym_inline] = ACTIONS(3613),
    [anon_sym___inline] = ACTIONS(3613),
    [anon_sym___inline__] = ACTIONS(3613),
    [anon_sym___forceinline] = ACTIONS(3613),
    [anon_sym_thread_local] = ACTIONS(3613),
    [anon_sym___thread] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_constexpr] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_restrict] = ACTIONS(3613),
    [anon_sym___restrict__] = ACTIONS(3613),
    [anon_sym__Atomic] = ACTIONS(3613),
    [anon_sym__Noreturn] = ACTIONS(3613),
    [anon_sym_noreturn] = ACTIONS(3613),
    [anon_sym_mutable] = ACTIONS(3613),
    [anon_sym_constinit] = ACTIONS(3613),
    [anon_sym_consteval] = ACTIONS(3613),
    [anon_sym_alignas] = ACTIONS(3613),
    [anon_sym__Alignas] = ACTIONS(3613),
    [sym_primitive_type] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_union] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_This] = ACTIONS(3613),
    [anon_sym_decltype] = ACTIONS(3613),
    [sym_virtual] = ACTIONS(3613),
    [anon_sym_explicit] = ACTIONS(3613),
    [anon_sym_typename] = ACTIONS(3613),
    [anon_sym_template] = ACTIONS(3613),
    [anon_sym_operator] = ACTIONS(3613),
    [anon_sym_friend] = ACTIONS(3613),
    [anon_sym_public] = ACTIONS(3613),
    [anon_sym_private] = ACTIONS(3613),
    [anon_sym_protected] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_static_assert] = ACTIONS(3613),
    [anon_sym_precise] = ACTIONS(3613),
    [anon_sym_shared] = ACTIONS(3613),
    [anon_sym_groupshared] = ACTIONS(3613),
    [anon_sym_uniform] = ACTIONS(3613),
    [anon_sym_row_major] = ACTIONS(3613),
    [anon_sym_column_major] = ACTIONS(3613),
    [anon_sym_globallycoherent] = ACTIONS(3613),
    [anon_sym_centroid] = ACTIONS(3613),
    [anon_sym_noperspective] = ACTIONS(3613),
    [anon_sym_nointerpolation] = ACTIONS(3613),
    [anon_sym_sample] = ACTIONS(3613),
    [anon_sym_linear] = ACTIONS(3613),
    [anon_sym_snorm] = ACTIONS(3613),
    [anon_sym_unorm] = ACTIONS(3613),
    [anon_sym_point] = ACTIONS(3613),
    [anon_sym_line] = ACTIONS(3613),
    [anon_sym_triangleadj] = ACTIONS(3613),
    [anon_sym_lineadj] = ACTIONS(3613),
    [anon_sym_triangle] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_extension] = ACTIONS(3613),
    [anon_sym___init] = ACTIONS(3613),
    [anon_sym___subscript] = ACTIONS(3613),
    [anon_sym_property] = ACTIONS(3613),
    [anon_sym_associatedtype] = ACTIONS(3613),
  },
  [1596] = {
    [sym_expression] = STATE(4001),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym__unary_left_fold] = STATE(10609),
    [sym__unary_right_fold] = STATE(10604),
    [sym__binary_fold] = STATE(10603),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1597] = {
    [sym_expression] = STATE(4988),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_initializer_list] = STATE(8546),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_default] = ACTIONS(5490),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(5494),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(5496),
    [anon_sym_0] = ACTIONS(5498),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1598] = {
    [sym_identifier] = ACTIONS(3406),
    [aux_sym_preproc_def_token1] = ACTIONS(3406),
    [aux_sym_preproc_if_token1] = ACTIONS(3406),
    [aux_sym_preproc_if_token2] = ACTIONS(3406),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3406),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3406),
    [aux_sym_preproc_else_token1] = ACTIONS(3406),
    [aux_sym_preproc_elif_token1] = ACTIONS(3406),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3406),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3406),
    [sym_preproc_directive] = ACTIONS(3406),
    [anon_sym_LPAREN2] = ACTIONS(3408),
    [anon_sym_TILDE] = ACTIONS(3408),
    [anon_sym_STAR] = ACTIONS(3408),
    [anon_sym_AMP_AMP] = ACTIONS(3408),
    [anon_sym_AMP] = ACTIONS(3406),
    [anon_sym___extension__] = ACTIONS(3406),
    [anon_sym_typedef] = ACTIONS(3406),
    [anon_sym_in] = ACTIONS(3406),
    [anon_sym_out] = ACTIONS(3406),
    [anon_sym_inout] = ACTIONS(3406),
    [anon_sym_extern] = ACTIONS(3406),
    [anon_sym___attribute__] = ACTIONS(3406),
    [anon_sym_COLON_COLON] = ACTIONS(3408),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3408),
    [anon_sym___declspec] = ACTIONS(3406),
    [anon_sym___based] = ACTIONS(3406),
    [anon_sym_signed] = ACTIONS(3406),
    [anon_sym_unsigned] = ACTIONS(3406),
    [anon_sym_long] = ACTIONS(3406),
    [anon_sym_short] = ACTIONS(3406),
    [anon_sym_LBRACK] = ACTIONS(3406),
    [anon_sym_static] = ACTIONS(3406),
    [anon_sym_register] = ACTIONS(3406),
    [anon_sym_inline] = ACTIONS(3406),
    [anon_sym___inline] = ACTIONS(3406),
    [anon_sym___inline__] = ACTIONS(3406),
    [anon_sym___forceinline] = ACTIONS(3406),
    [anon_sym_thread_local] = ACTIONS(3406),
    [anon_sym___thread] = ACTIONS(3406),
    [anon_sym_const] = ACTIONS(3406),
    [anon_sym_constexpr] = ACTIONS(3406),
    [anon_sym_volatile] = ACTIONS(3406),
    [anon_sym_restrict] = ACTIONS(3406),
    [anon_sym___restrict__] = ACTIONS(3406),
    [anon_sym__Atomic] = ACTIONS(3406),
    [anon_sym__Noreturn] = ACTIONS(3406),
    [anon_sym_noreturn] = ACTIONS(3406),
    [anon_sym_mutable] = ACTIONS(3406),
    [anon_sym_constinit] = ACTIONS(3406),
    [anon_sym_consteval] = ACTIONS(3406),
    [anon_sym_alignas] = ACTIONS(3406),
    [anon_sym__Alignas] = ACTIONS(3406),
    [sym_primitive_type] = ACTIONS(3406),
    [anon_sym_enum] = ACTIONS(3406),
    [anon_sym_class] = ACTIONS(3406),
    [anon_sym_struct] = ACTIONS(3406),
    [anon_sym_union] = ACTIONS(3406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3406),
    [anon_sym_let] = ACTIONS(3406),
    [anon_sym_This] = ACTIONS(3406),
    [anon_sym_decltype] = ACTIONS(3406),
    [sym_virtual] = ACTIONS(3406),
    [anon_sym_explicit] = ACTIONS(3406),
    [anon_sym_typename] = ACTIONS(3406),
    [anon_sym_template] = ACTIONS(3406),
    [anon_sym_operator] = ACTIONS(3406),
    [anon_sym_friend] = ACTIONS(3406),
    [anon_sym_public] = ACTIONS(3406),
    [anon_sym_private] = ACTIONS(3406),
    [anon_sym_protected] = ACTIONS(3406),
    [anon_sym_using] = ACTIONS(3406),
    [anon_sym_static_assert] = ACTIONS(3406),
    [anon_sym_precise] = ACTIONS(3406),
    [anon_sym_shared] = ACTIONS(3406),
    [anon_sym_groupshared] = ACTIONS(3406),
    [anon_sym_uniform] = ACTIONS(3406),
    [anon_sym_row_major] = ACTIONS(3406),
    [anon_sym_column_major] = ACTIONS(3406),
    [anon_sym_globallycoherent] = ACTIONS(3406),
    [anon_sym_centroid] = ACTIONS(3406),
    [anon_sym_noperspective] = ACTIONS(3406),
    [anon_sym_nointerpolation] = ACTIONS(3406),
    [anon_sym_sample] = ACTIONS(3406),
    [anon_sym_linear] = ACTIONS(3406),
    [anon_sym_snorm] = ACTIONS(3406),
    [anon_sym_unorm] = ACTIONS(3406),
    [anon_sym_point] = ACTIONS(3406),
    [anon_sym_line] = ACTIONS(3406),
    [anon_sym_triangleadj] = ACTIONS(3406),
    [anon_sym_lineadj] = ACTIONS(3406),
    [anon_sym_triangle] = ACTIONS(3406),
    [anon_sym_interface] = ACTIONS(3406),
    [anon_sym_extension] = ACTIONS(3406),
    [anon_sym___init] = ACTIONS(3406),
    [anon_sym___subscript] = ACTIONS(3406),
    [anon_sym_property] = ACTIONS(3406),
    [anon_sym_associatedtype] = ACTIONS(3406),
  },
  [1599] = {
    [sym_identifier] = ACTIONS(3182),
    [aux_sym_preproc_def_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token2] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [aux_sym_preproc_else_token1] = ACTIONS(3182),
    [aux_sym_preproc_elif_token1] = ACTIONS(3182),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3182),
    [sym_preproc_directive] = ACTIONS(3182),
    [anon_sym_LPAREN2] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_AMP_AMP] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3182),
    [anon_sym___extension__] = ACTIONS(3182),
    [anon_sym_typedef] = ACTIONS(3182),
    [anon_sym_in] = ACTIONS(3182),
    [anon_sym_out] = ACTIONS(3182),
    [anon_sym_inout] = ACTIONS(3182),
    [anon_sym_extern] = ACTIONS(3182),
    [anon_sym___attribute__] = ACTIONS(3182),
    [anon_sym_COLON_COLON] = ACTIONS(3184),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3184),
    [anon_sym___declspec] = ACTIONS(3182),
    [anon_sym___based] = ACTIONS(3182),
    [anon_sym_signed] = ACTIONS(3182),
    [anon_sym_unsigned] = ACTIONS(3182),
    [anon_sym_long] = ACTIONS(3182),
    [anon_sym_short] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3182),
    [anon_sym_register] = ACTIONS(3182),
    [anon_sym_inline] = ACTIONS(3182),
    [anon_sym___inline] = ACTIONS(3182),
    [anon_sym___inline__] = ACTIONS(3182),
    [anon_sym___forceinline] = ACTIONS(3182),
    [anon_sym_thread_local] = ACTIONS(3182),
    [anon_sym___thread] = ACTIONS(3182),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_constexpr] = ACTIONS(3182),
    [anon_sym_volatile] = ACTIONS(3182),
    [anon_sym_restrict] = ACTIONS(3182),
    [anon_sym___restrict__] = ACTIONS(3182),
    [anon_sym__Atomic] = ACTIONS(3182),
    [anon_sym__Noreturn] = ACTIONS(3182),
    [anon_sym_noreturn] = ACTIONS(3182),
    [anon_sym_mutable] = ACTIONS(3182),
    [anon_sym_constinit] = ACTIONS(3182),
    [anon_sym_consteval] = ACTIONS(3182),
    [anon_sym_alignas] = ACTIONS(3182),
    [anon_sym__Alignas] = ACTIONS(3182),
    [sym_primitive_type] = ACTIONS(3182),
    [anon_sym_enum] = ACTIONS(3182),
    [anon_sym_class] = ACTIONS(3182),
    [anon_sym_struct] = ACTIONS(3182),
    [anon_sym_union] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3182),
    [anon_sym_let] = ACTIONS(3182),
    [anon_sym_This] = ACTIONS(3182),
    [anon_sym_decltype] = ACTIONS(3182),
    [sym_virtual] = ACTIONS(3182),
    [anon_sym_explicit] = ACTIONS(3182),
    [anon_sym_typename] = ACTIONS(3182),
    [anon_sym_template] = ACTIONS(3182),
    [anon_sym_operator] = ACTIONS(3182),
    [anon_sym_friend] = ACTIONS(3182),
    [anon_sym_public] = ACTIONS(3182),
    [anon_sym_private] = ACTIONS(3182),
    [anon_sym_protected] = ACTIONS(3182),
    [anon_sym_using] = ACTIONS(3182),
    [anon_sym_static_assert] = ACTIONS(3182),
    [anon_sym_precise] = ACTIONS(3182),
    [anon_sym_shared] = ACTIONS(3182),
    [anon_sym_groupshared] = ACTIONS(3182),
    [anon_sym_uniform] = ACTIONS(3182),
    [anon_sym_row_major] = ACTIONS(3182),
    [anon_sym_column_major] = ACTIONS(3182),
    [anon_sym_globallycoherent] = ACTIONS(3182),
    [anon_sym_centroid] = ACTIONS(3182),
    [anon_sym_noperspective] = ACTIONS(3182),
    [anon_sym_nointerpolation] = ACTIONS(3182),
    [anon_sym_sample] = ACTIONS(3182),
    [anon_sym_linear] = ACTIONS(3182),
    [anon_sym_snorm] = ACTIONS(3182),
    [anon_sym_unorm] = ACTIONS(3182),
    [anon_sym_point] = ACTIONS(3182),
    [anon_sym_line] = ACTIONS(3182),
    [anon_sym_triangleadj] = ACTIONS(3182),
    [anon_sym_lineadj] = ACTIONS(3182),
    [anon_sym_triangle] = ACTIONS(3182),
    [anon_sym_interface] = ACTIONS(3182),
    [anon_sym_extension] = ACTIONS(3182),
    [anon_sym___init] = ACTIONS(3182),
    [anon_sym___subscript] = ACTIONS(3182),
    [anon_sym_property] = ACTIONS(3182),
    [anon_sym_associatedtype] = ACTIONS(3182),
  },
  [1600] = {
    [sym_identifier] = ACTIONS(3601),
    [aux_sym_preproc_def_token1] = ACTIONS(3601),
    [aux_sym_preproc_if_token1] = ACTIONS(3601),
    [aux_sym_preproc_if_token2] = ACTIONS(3601),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3601),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3601),
    [aux_sym_preproc_else_token1] = ACTIONS(3601),
    [aux_sym_preproc_elif_token1] = ACTIONS(3601),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3601),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3601),
    [sym_preproc_directive] = ACTIONS(3601),
    [anon_sym_LPAREN2] = ACTIONS(3603),
    [anon_sym_TILDE] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(3603),
    [anon_sym_AMP_AMP] = ACTIONS(3603),
    [anon_sym_AMP] = ACTIONS(3601),
    [anon_sym___extension__] = ACTIONS(3601),
    [anon_sym_typedef] = ACTIONS(3601),
    [anon_sym_in] = ACTIONS(3601),
    [anon_sym_out] = ACTIONS(3601),
    [anon_sym_inout] = ACTIONS(3601),
    [anon_sym_extern] = ACTIONS(3601),
    [anon_sym___attribute__] = ACTIONS(3601),
    [anon_sym_COLON_COLON] = ACTIONS(3603),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3603),
    [anon_sym___declspec] = ACTIONS(3601),
    [anon_sym___based] = ACTIONS(3601),
    [anon_sym_signed] = ACTIONS(3601),
    [anon_sym_unsigned] = ACTIONS(3601),
    [anon_sym_long] = ACTIONS(3601),
    [anon_sym_short] = ACTIONS(3601),
    [anon_sym_LBRACK] = ACTIONS(3601),
    [anon_sym_static] = ACTIONS(3601),
    [anon_sym_register] = ACTIONS(3601),
    [anon_sym_inline] = ACTIONS(3601),
    [anon_sym___inline] = ACTIONS(3601),
    [anon_sym___inline__] = ACTIONS(3601),
    [anon_sym___forceinline] = ACTIONS(3601),
    [anon_sym_thread_local] = ACTIONS(3601),
    [anon_sym___thread] = ACTIONS(3601),
    [anon_sym_const] = ACTIONS(3601),
    [anon_sym_constexpr] = ACTIONS(3601),
    [anon_sym_volatile] = ACTIONS(3601),
    [anon_sym_restrict] = ACTIONS(3601),
    [anon_sym___restrict__] = ACTIONS(3601),
    [anon_sym__Atomic] = ACTIONS(3601),
    [anon_sym__Noreturn] = ACTIONS(3601),
    [anon_sym_noreturn] = ACTIONS(3601),
    [anon_sym_mutable] = ACTIONS(3601),
    [anon_sym_constinit] = ACTIONS(3601),
    [anon_sym_consteval] = ACTIONS(3601),
    [anon_sym_alignas] = ACTIONS(3601),
    [anon_sym__Alignas] = ACTIONS(3601),
    [sym_primitive_type] = ACTIONS(3601),
    [anon_sym_enum] = ACTIONS(3601),
    [anon_sym_class] = ACTIONS(3601),
    [anon_sym_struct] = ACTIONS(3601),
    [anon_sym_union] = ACTIONS(3601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3601),
    [anon_sym_let] = ACTIONS(3601),
    [anon_sym_This] = ACTIONS(3601),
    [anon_sym_decltype] = ACTIONS(3601),
    [sym_virtual] = ACTIONS(3601),
    [anon_sym_explicit] = ACTIONS(3601),
    [anon_sym_typename] = ACTIONS(3601),
    [anon_sym_template] = ACTIONS(3601),
    [anon_sym_operator] = ACTIONS(3601),
    [anon_sym_friend] = ACTIONS(3601),
    [anon_sym_public] = ACTIONS(3601),
    [anon_sym_private] = ACTIONS(3601),
    [anon_sym_protected] = ACTIONS(3601),
    [anon_sym_using] = ACTIONS(3601),
    [anon_sym_static_assert] = ACTIONS(3601),
    [anon_sym_precise] = ACTIONS(3601),
    [anon_sym_shared] = ACTIONS(3601),
    [anon_sym_groupshared] = ACTIONS(3601),
    [anon_sym_uniform] = ACTIONS(3601),
    [anon_sym_row_major] = ACTIONS(3601),
    [anon_sym_column_major] = ACTIONS(3601),
    [anon_sym_globallycoherent] = ACTIONS(3601),
    [anon_sym_centroid] = ACTIONS(3601),
    [anon_sym_noperspective] = ACTIONS(3601),
    [anon_sym_nointerpolation] = ACTIONS(3601),
    [anon_sym_sample] = ACTIONS(3601),
    [anon_sym_linear] = ACTIONS(3601),
    [anon_sym_snorm] = ACTIONS(3601),
    [anon_sym_unorm] = ACTIONS(3601),
    [anon_sym_point] = ACTIONS(3601),
    [anon_sym_line] = ACTIONS(3601),
    [anon_sym_triangleadj] = ACTIONS(3601),
    [anon_sym_lineadj] = ACTIONS(3601),
    [anon_sym_triangle] = ACTIONS(3601),
    [anon_sym_interface] = ACTIONS(3601),
    [anon_sym_extension] = ACTIONS(3601),
    [anon_sym___init] = ACTIONS(3601),
    [anon_sym___subscript] = ACTIONS(3601),
    [anon_sym_property] = ACTIONS(3601),
    [anon_sym_associatedtype] = ACTIONS(3601),
  },
  [1601] = {
    [sym_identifier] = ACTIONS(3535),
    [aux_sym_preproc_def_token1] = ACTIONS(3535),
    [aux_sym_preproc_if_token1] = ACTIONS(3535),
    [aux_sym_preproc_if_token2] = ACTIONS(3535),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3535),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3535),
    [aux_sym_preproc_else_token1] = ACTIONS(3535),
    [aux_sym_preproc_elif_token1] = ACTIONS(3535),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3535),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3535),
    [sym_preproc_directive] = ACTIONS(3535),
    [anon_sym_LPAREN2] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3537),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym___extension__] = ACTIONS(3535),
    [anon_sym_typedef] = ACTIONS(3535),
    [anon_sym_in] = ACTIONS(3535),
    [anon_sym_out] = ACTIONS(3535),
    [anon_sym_inout] = ACTIONS(3535),
    [anon_sym_extern] = ACTIONS(3535),
    [anon_sym___attribute__] = ACTIONS(3535),
    [anon_sym_COLON_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3537),
    [anon_sym___declspec] = ACTIONS(3535),
    [anon_sym___based] = ACTIONS(3535),
    [anon_sym_signed] = ACTIONS(3535),
    [anon_sym_unsigned] = ACTIONS(3535),
    [anon_sym_long] = ACTIONS(3535),
    [anon_sym_short] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_static] = ACTIONS(3535),
    [anon_sym_register] = ACTIONS(3535),
    [anon_sym_inline] = ACTIONS(3535),
    [anon_sym___inline] = ACTIONS(3535),
    [anon_sym___inline__] = ACTIONS(3535),
    [anon_sym___forceinline] = ACTIONS(3535),
    [anon_sym_thread_local] = ACTIONS(3535),
    [anon_sym___thread] = ACTIONS(3535),
    [anon_sym_const] = ACTIONS(3535),
    [anon_sym_constexpr] = ACTIONS(3535),
    [anon_sym_volatile] = ACTIONS(3535),
    [anon_sym_restrict] = ACTIONS(3535),
    [anon_sym___restrict__] = ACTIONS(3535),
    [anon_sym__Atomic] = ACTIONS(3535),
    [anon_sym__Noreturn] = ACTIONS(3535),
    [anon_sym_noreturn] = ACTIONS(3535),
    [anon_sym_mutable] = ACTIONS(3535),
    [anon_sym_constinit] = ACTIONS(3535),
    [anon_sym_consteval] = ACTIONS(3535),
    [anon_sym_alignas] = ACTIONS(3535),
    [anon_sym__Alignas] = ACTIONS(3535),
    [sym_primitive_type] = ACTIONS(3535),
    [anon_sym_enum] = ACTIONS(3535),
    [anon_sym_class] = ACTIONS(3535),
    [anon_sym_struct] = ACTIONS(3535),
    [anon_sym_union] = ACTIONS(3535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3535),
    [anon_sym_let] = ACTIONS(3535),
    [anon_sym_This] = ACTIONS(3535),
    [anon_sym_decltype] = ACTIONS(3535),
    [sym_virtual] = ACTIONS(3535),
    [anon_sym_explicit] = ACTIONS(3535),
    [anon_sym_typename] = ACTIONS(3535),
    [anon_sym_template] = ACTIONS(3535),
    [anon_sym_operator] = ACTIONS(3535),
    [anon_sym_friend] = ACTIONS(3535),
    [anon_sym_public] = ACTIONS(3535),
    [anon_sym_private] = ACTIONS(3535),
    [anon_sym_protected] = ACTIONS(3535),
    [anon_sym_using] = ACTIONS(3535),
    [anon_sym_static_assert] = ACTIONS(3535),
    [anon_sym_precise] = ACTIONS(3535),
    [anon_sym_shared] = ACTIONS(3535),
    [anon_sym_groupshared] = ACTIONS(3535),
    [anon_sym_uniform] = ACTIONS(3535),
    [anon_sym_row_major] = ACTIONS(3535),
    [anon_sym_column_major] = ACTIONS(3535),
    [anon_sym_globallycoherent] = ACTIONS(3535),
    [anon_sym_centroid] = ACTIONS(3535),
    [anon_sym_noperspective] = ACTIONS(3535),
    [anon_sym_nointerpolation] = ACTIONS(3535),
    [anon_sym_sample] = ACTIONS(3535),
    [anon_sym_linear] = ACTIONS(3535),
    [anon_sym_snorm] = ACTIONS(3535),
    [anon_sym_unorm] = ACTIONS(3535),
    [anon_sym_point] = ACTIONS(3535),
    [anon_sym_line] = ACTIONS(3535),
    [anon_sym_triangleadj] = ACTIONS(3535),
    [anon_sym_lineadj] = ACTIONS(3535),
    [anon_sym_triangle] = ACTIONS(3535),
    [anon_sym_interface] = ACTIONS(3535),
    [anon_sym_extension] = ACTIONS(3535),
    [anon_sym___init] = ACTIONS(3535),
    [anon_sym___subscript] = ACTIONS(3535),
    [anon_sym_property] = ACTIONS(3535),
    [anon_sym_associatedtype] = ACTIONS(3535),
  },
  [1602] = {
    [sym_identifier] = ACTIONS(3182),
    [aux_sym_preproc_def_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token2] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [aux_sym_preproc_else_token1] = ACTIONS(3182),
    [aux_sym_preproc_elif_token1] = ACTIONS(3182),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3182),
    [sym_preproc_directive] = ACTIONS(3182),
    [anon_sym_LPAREN2] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_AMP_AMP] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3182),
    [anon_sym___extension__] = ACTIONS(3182),
    [anon_sym_typedef] = ACTIONS(3182),
    [anon_sym_in] = ACTIONS(3182),
    [anon_sym_out] = ACTIONS(3182),
    [anon_sym_inout] = ACTIONS(3182),
    [anon_sym_extern] = ACTIONS(3182),
    [anon_sym___attribute__] = ACTIONS(3182),
    [anon_sym_COLON_COLON] = ACTIONS(3184),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3184),
    [anon_sym___declspec] = ACTIONS(3182),
    [anon_sym___based] = ACTIONS(3182),
    [anon_sym_signed] = ACTIONS(3182),
    [anon_sym_unsigned] = ACTIONS(3182),
    [anon_sym_long] = ACTIONS(3182),
    [anon_sym_short] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3182),
    [anon_sym_register] = ACTIONS(3182),
    [anon_sym_inline] = ACTIONS(3182),
    [anon_sym___inline] = ACTIONS(3182),
    [anon_sym___inline__] = ACTIONS(3182),
    [anon_sym___forceinline] = ACTIONS(3182),
    [anon_sym_thread_local] = ACTIONS(3182),
    [anon_sym___thread] = ACTIONS(3182),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_constexpr] = ACTIONS(3182),
    [anon_sym_volatile] = ACTIONS(3182),
    [anon_sym_restrict] = ACTIONS(3182),
    [anon_sym___restrict__] = ACTIONS(3182),
    [anon_sym__Atomic] = ACTIONS(3182),
    [anon_sym__Noreturn] = ACTIONS(3182),
    [anon_sym_noreturn] = ACTIONS(3182),
    [anon_sym_mutable] = ACTIONS(3182),
    [anon_sym_constinit] = ACTIONS(3182),
    [anon_sym_consteval] = ACTIONS(3182),
    [anon_sym_alignas] = ACTIONS(3182),
    [anon_sym__Alignas] = ACTIONS(3182),
    [sym_primitive_type] = ACTIONS(3182),
    [anon_sym_enum] = ACTIONS(3182),
    [anon_sym_class] = ACTIONS(3182),
    [anon_sym_struct] = ACTIONS(3182),
    [anon_sym_union] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3182),
    [anon_sym_let] = ACTIONS(3182),
    [anon_sym_This] = ACTIONS(3182),
    [anon_sym_decltype] = ACTIONS(3182),
    [sym_virtual] = ACTIONS(3182),
    [anon_sym_explicit] = ACTIONS(3182),
    [anon_sym_typename] = ACTIONS(3182),
    [anon_sym_template] = ACTIONS(3182),
    [anon_sym_operator] = ACTIONS(3182),
    [anon_sym_friend] = ACTIONS(3182),
    [anon_sym_public] = ACTIONS(3182),
    [anon_sym_private] = ACTIONS(3182),
    [anon_sym_protected] = ACTIONS(3182),
    [anon_sym_using] = ACTIONS(3182),
    [anon_sym_static_assert] = ACTIONS(3182),
    [anon_sym_precise] = ACTIONS(3182),
    [anon_sym_shared] = ACTIONS(3182),
    [anon_sym_groupshared] = ACTIONS(3182),
    [anon_sym_uniform] = ACTIONS(3182),
    [anon_sym_row_major] = ACTIONS(3182),
    [anon_sym_column_major] = ACTIONS(3182),
    [anon_sym_globallycoherent] = ACTIONS(3182),
    [anon_sym_centroid] = ACTIONS(3182),
    [anon_sym_noperspective] = ACTIONS(3182),
    [anon_sym_nointerpolation] = ACTIONS(3182),
    [anon_sym_sample] = ACTIONS(3182),
    [anon_sym_linear] = ACTIONS(3182),
    [anon_sym_snorm] = ACTIONS(3182),
    [anon_sym_unorm] = ACTIONS(3182),
    [anon_sym_point] = ACTIONS(3182),
    [anon_sym_line] = ACTIONS(3182),
    [anon_sym_triangleadj] = ACTIONS(3182),
    [anon_sym_lineadj] = ACTIONS(3182),
    [anon_sym_triangle] = ACTIONS(3182),
    [anon_sym_interface] = ACTIONS(3182),
    [anon_sym_extension] = ACTIONS(3182),
    [anon_sym___init] = ACTIONS(3182),
    [anon_sym___subscript] = ACTIONS(3182),
    [anon_sym_property] = ACTIONS(3182),
    [anon_sym_associatedtype] = ACTIONS(3182),
  },
  [1603] = {
    [sym_identifier] = ACTIONS(2982),
    [aux_sym_preproc_def_token1] = ACTIONS(2982),
    [aux_sym_preproc_if_token1] = ACTIONS(2982),
    [aux_sym_preproc_if_token2] = ACTIONS(2982),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2982),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2982),
    [aux_sym_preproc_else_token1] = ACTIONS(2982),
    [aux_sym_preproc_elif_token1] = ACTIONS(2982),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2982),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2982),
    [sym_preproc_directive] = ACTIONS(2982),
    [anon_sym_LPAREN2] = ACTIONS(2984),
    [anon_sym_TILDE] = ACTIONS(2984),
    [anon_sym_STAR] = ACTIONS(2984),
    [anon_sym_AMP_AMP] = ACTIONS(2984),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(2982),
    [anon_sym_typedef] = ACTIONS(2982),
    [anon_sym_in] = ACTIONS(2982),
    [anon_sym_out] = ACTIONS(2982),
    [anon_sym_inout] = ACTIONS(2982),
    [anon_sym_extern] = ACTIONS(2982),
    [anon_sym___attribute__] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2984),
    [anon_sym___declspec] = ACTIONS(2982),
    [anon_sym___based] = ACTIONS(2982),
    [anon_sym_signed] = ACTIONS(2982),
    [anon_sym_unsigned] = ACTIONS(2982),
    [anon_sym_long] = ACTIONS(2982),
    [anon_sym_short] = ACTIONS(2982),
    [anon_sym_LBRACK] = ACTIONS(2982),
    [anon_sym_static] = ACTIONS(2982),
    [anon_sym_register] = ACTIONS(2982),
    [anon_sym_inline] = ACTIONS(2982),
    [anon_sym___inline] = ACTIONS(2982),
    [anon_sym___inline__] = ACTIONS(2982),
    [anon_sym___forceinline] = ACTIONS(2982),
    [anon_sym_thread_local] = ACTIONS(2982),
    [anon_sym___thread] = ACTIONS(2982),
    [anon_sym_const] = ACTIONS(2982),
    [anon_sym_constexpr] = ACTIONS(2982),
    [anon_sym_volatile] = ACTIONS(2982),
    [anon_sym_restrict] = ACTIONS(2982),
    [anon_sym___restrict__] = ACTIONS(2982),
    [anon_sym__Atomic] = ACTIONS(2982),
    [anon_sym__Noreturn] = ACTIONS(2982),
    [anon_sym_noreturn] = ACTIONS(2982),
    [anon_sym_mutable] = ACTIONS(2982),
    [anon_sym_constinit] = ACTIONS(2982),
    [anon_sym_consteval] = ACTIONS(2982),
    [anon_sym_alignas] = ACTIONS(2982),
    [anon_sym__Alignas] = ACTIONS(2982),
    [sym_primitive_type] = ACTIONS(2982),
    [anon_sym_enum] = ACTIONS(2982),
    [anon_sym_class] = ACTIONS(2982),
    [anon_sym_struct] = ACTIONS(2982),
    [anon_sym_union] = ACTIONS(2982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2982),
    [anon_sym_let] = ACTIONS(2982),
    [anon_sym_This] = ACTIONS(2982),
    [anon_sym_decltype] = ACTIONS(2982),
    [sym_virtual] = ACTIONS(2982),
    [anon_sym_explicit] = ACTIONS(2982),
    [anon_sym_typename] = ACTIONS(2982),
    [anon_sym_template] = ACTIONS(2982),
    [anon_sym_operator] = ACTIONS(2982),
    [anon_sym_friend] = ACTIONS(2982),
    [anon_sym_public] = ACTIONS(2982),
    [anon_sym_private] = ACTIONS(2982),
    [anon_sym_protected] = ACTIONS(2982),
    [anon_sym_using] = ACTIONS(2982),
    [anon_sym_static_assert] = ACTIONS(2982),
    [anon_sym_precise] = ACTIONS(2982),
    [anon_sym_shared] = ACTIONS(2982),
    [anon_sym_groupshared] = ACTIONS(2982),
    [anon_sym_uniform] = ACTIONS(2982),
    [anon_sym_row_major] = ACTIONS(2982),
    [anon_sym_column_major] = ACTIONS(2982),
    [anon_sym_globallycoherent] = ACTIONS(2982),
    [anon_sym_centroid] = ACTIONS(2982),
    [anon_sym_noperspective] = ACTIONS(2982),
    [anon_sym_nointerpolation] = ACTIONS(2982),
    [anon_sym_sample] = ACTIONS(2982),
    [anon_sym_linear] = ACTIONS(2982),
    [anon_sym_snorm] = ACTIONS(2982),
    [anon_sym_unorm] = ACTIONS(2982),
    [anon_sym_point] = ACTIONS(2982),
    [anon_sym_line] = ACTIONS(2982),
    [anon_sym_triangleadj] = ACTIONS(2982),
    [anon_sym_lineadj] = ACTIONS(2982),
    [anon_sym_triangle] = ACTIONS(2982),
    [anon_sym_interface] = ACTIONS(2982),
    [anon_sym_extension] = ACTIONS(2982),
    [anon_sym___init] = ACTIONS(2982),
    [anon_sym___subscript] = ACTIONS(2982),
    [anon_sym_property] = ACTIONS(2982),
    [anon_sym_associatedtype] = ACTIONS(2982),
  },
  [1604] = {
    [sym_identifier] = ACTIONS(5460),
    [aux_sym_preproc_def_token1] = ACTIONS(5460),
    [aux_sym_preproc_if_token1] = ACTIONS(5460),
    [aux_sym_preproc_if_token2] = ACTIONS(5460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5460),
    [aux_sym_preproc_else_token1] = ACTIONS(5460),
    [aux_sym_preproc_elif_token1] = ACTIONS(5460),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5460),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5460),
    [sym_preproc_directive] = ACTIONS(5460),
    [anon_sym_LPAREN2] = ACTIONS(5462),
    [anon_sym_TILDE] = ACTIONS(5462),
    [anon_sym_STAR] = ACTIONS(5462),
    [anon_sym_AMP_AMP] = ACTIONS(5462),
    [anon_sym_AMP] = ACTIONS(5460),
    [anon_sym___extension__] = ACTIONS(5460),
    [anon_sym_typedef] = ACTIONS(5460),
    [anon_sym_in] = ACTIONS(5460),
    [anon_sym_out] = ACTIONS(5460),
    [anon_sym_inout] = ACTIONS(5460),
    [anon_sym_extern] = ACTIONS(5460),
    [anon_sym___attribute__] = ACTIONS(5460),
    [anon_sym_COLON_COLON] = ACTIONS(5462),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5462),
    [anon_sym___declspec] = ACTIONS(5460),
    [anon_sym___based] = ACTIONS(5460),
    [anon_sym_signed] = ACTIONS(5460),
    [anon_sym_unsigned] = ACTIONS(5460),
    [anon_sym_long] = ACTIONS(5460),
    [anon_sym_short] = ACTIONS(5460),
    [anon_sym_LBRACK] = ACTIONS(5460),
    [anon_sym_static] = ACTIONS(5460),
    [anon_sym_register] = ACTIONS(5460),
    [anon_sym_inline] = ACTIONS(5460),
    [anon_sym___inline] = ACTIONS(5460),
    [anon_sym___inline__] = ACTIONS(5460),
    [anon_sym___forceinline] = ACTIONS(5460),
    [anon_sym_thread_local] = ACTIONS(5460),
    [anon_sym___thread] = ACTIONS(5460),
    [anon_sym_const] = ACTIONS(5460),
    [anon_sym_constexpr] = ACTIONS(5460),
    [anon_sym_volatile] = ACTIONS(5460),
    [anon_sym_restrict] = ACTIONS(5460),
    [anon_sym___restrict__] = ACTIONS(5460),
    [anon_sym__Atomic] = ACTIONS(5460),
    [anon_sym__Noreturn] = ACTIONS(5460),
    [anon_sym_noreturn] = ACTIONS(5460),
    [anon_sym_mutable] = ACTIONS(5460),
    [anon_sym_constinit] = ACTIONS(5460),
    [anon_sym_consteval] = ACTIONS(5460),
    [anon_sym_alignas] = ACTIONS(5460),
    [anon_sym__Alignas] = ACTIONS(5460),
    [sym_primitive_type] = ACTIONS(5460),
    [anon_sym_enum] = ACTIONS(5460),
    [anon_sym_class] = ACTIONS(5460),
    [anon_sym_struct] = ACTIONS(5460),
    [anon_sym_union] = ACTIONS(5460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5460),
    [anon_sym_let] = ACTIONS(5460),
    [anon_sym_This] = ACTIONS(5460),
    [anon_sym_decltype] = ACTIONS(5460),
    [sym_virtual] = ACTIONS(5460),
    [anon_sym_explicit] = ACTIONS(5460),
    [anon_sym_typename] = ACTIONS(5460),
    [anon_sym_template] = ACTIONS(5460),
    [anon_sym_operator] = ACTIONS(5460),
    [anon_sym_friend] = ACTIONS(5460),
    [anon_sym_public] = ACTIONS(5460),
    [anon_sym_private] = ACTIONS(5460),
    [anon_sym_protected] = ACTIONS(5460),
    [anon_sym_using] = ACTIONS(5460),
    [anon_sym_static_assert] = ACTIONS(5460),
    [anon_sym_precise] = ACTIONS(5460),
    [anon_sym_shared] = ACTIONS(5460),
    [anon_sym_groupshared] = ACTIONS(5460),
    [anon_sym_uniform] = ACTIONS(5460),
    [anon_sym_row_major] = ACTIONS(5460),
    [anon_sym_column_major] = ACTIONS(5460),
    [anon_sym_globallycoherent] = ACTIONS(5460),
    [anon_sym_centroid] = ACTIONS(5460),
    [anon_sym_noperspective] = ACTIONS(5460),
    [anon_sym_nointerpolation] = ACTIONS(5460),
    [anon_sym_sample] = ACTIONS(5460),
    [anon_sym_linear] = ACTIONS(5460),
    [anon_sym_snorm] = ACTIONS(5460),
    [anon_sym_unorm] = ACTIONS(5460),
    [anon_sym_point] = ACTIONS(5460),
    [anon_sym_line] = ACTIONS(5460),
    [anon_sym_triangleadj] = ACTIONS(5460),
    [anon_sym_lineadj] = ACTIONS(5460),
    [anon_sym_triangle] = ACTIONS(5460),
    [anon_sym_interface] = ACTIONS(5460),
    [anon_sym_extension] = ACTIONS(5460),
    [anon_sym___init] = ACTIONS(5460),
    [anon_sym___subscript] = ACTIONS(5460),
    [anon_sym_property] = ACTIONS(5460),
    [anon_sym_associatedtype] = ACTIONS(5460),
  },
  [1605] = {
    [sym_identifier] = ACTIONS(5500),
    [aux_sym_preproc_def_token1] = ACTIONS(5500),
    [aux_sym_preproc_if_token1] = ACTIONS(5500),
    [aux_sym_preproc_if_token2] = ACTIONS(5500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5500),
    [aux_sym_preproc_else_token1] = ACTIONS(5500),
    [aux_sym_preproc_elif_token1] = ACTIONS(5500),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5500),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5500),
    [sym_preproc_directive] = ACTIONS(5500),
    [anon_sym_LPAREN2] = ACTIONS(5502),
    [anon_sym_TILDE] = ACTIONS(5502),
    [anon_sym_STAR] = ACTIONS(5502),
    [anon_sym_AMP_AMP] = ACTIONS(5502),
    [anon_sym_AMP] = ACTIONS(5500),
    [anon_sym___extension__] = ACTIONS(5500),
    [anon_sym_typedef] = ACTIONS(5500),
    [anon_sym_in] = ACTIONS(5500),
    [anon_sym_out] = ACTIONS(5500),
    [anon_sym_inout] = ACTIONS(5500),
    [anon_sym_extern] = ACTIONS(5500),
    [anon_sym___attribute__] = ACTIONS(5500),
    [anon_sym_COLON_COLON] = ACTIONS(5502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5502),
    [anon_sym___declspec] = ACTIONS(5500),
    [anon_sym___based] = ACTIONS(5500),
    [anon_sym_signed] = ACTIONS(5500),
    [anon_sym_unsigned] = ACTIONS(5500),
    [anon_sym_long] = ACTIONS(5500),
    [anon_sym_short] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5500),
    [anon_sym_static] = ACTIONS(5500),
    [anon_sym_register] = ACTIONS(5500),
    [anon_sym_inline] = ACTIONS(5500),
    [anon_sym___inline] = ACTIONS(5500),
    [anon_sym___inline__] = ACTIONS(5500),
    [anon_sym___forceinline] = ACTIONS(5500),
    [anon_sym_thread_local] = ACTIONS(5500),
    [anon_sym___thread] = ACTIONS(5500),
    [anon_sym_const] = ACTIONS(5500),
    [anon_sym_constexpr] = ACTIONS(5500),
    [anon_sym_volatile] = ACTIONS(5500),
    [anon_sym_restrict] = ACTIONS(5500),
    [anon_sym___restrict__] = ACTIONS(5500),
    [anon_sym__Atomic] = ACTIONS(5500),
    [anon_sym__Noreturn] = ACTIONS(5500),
    [anon_sym_noreturn] = ACTIONS(5500),
    [anon_sym_mutable] = ACTIONS(5500),
    [anon_sym_constinit] = ACTIONS(5500),
    [anon_sym_consteval] = ACTIONS(5500),
    [anon_sym_alignas] = ACTIONS(5500),
    [anon_sym__Alignas] = ACTIONS(5500),
    [sym_primitive_type] = ACTIONS(5500),
    [anon_sym_enum] = ACTIONS(5500),
    [anon_sym_class] = ACTIONS(5500),
    [anon_sym_struct] = ACTIONS(5500),
    [anon_sym_union] = ACTIONS(5500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5500),
    [anon_sym_let] = ACTIONS(5500),
    [anon_sym_This] = ACTIONS(5500),
    [anon_sym_decltype] = ACTIONS(5500),
    [sym_virtual] = ACTIONS(5500),
    [anon_sym_explicit] = ACTIONS(5500),
    [anon_sym_typename] = ACTIONS(5500),
    [anon_sym_template] = ACTIONS(5500),
    [anon_sym_operator] = ACTIONS(5500),
    [anon_sym_friend] = ACTIONS(5500),
    [anon_sym_public] = ACTIONS(5500),
    [anon_sym_private] = ACTIONS(5500),
    [anon_sym_protected] = ACTIONS(5500),
    [anon_sym_using] = ACTIONS(5500),
    [anon_sym_static_assert] = ACTIONS(5500),
    [anon_sym_precise] = ACTIONS(5500),
    [anon_sym_shared] = ACTIONS(5500),
    [anon_sym_groupshared] = ACTIONS(5500),
    [anon_sym_uniform] = ACTIONS(5500),
    [anon_sym_row_major] = ACTIONS(5500),
    [anon_sym_column_major] = ACTIONS(5500),
    [anon_sym_globallycoherent] = ACTIONS(5500),
    [anon_sym_centroid] = ACTIONS(5500),
    [anon_sym_noperspective] = ACTIONS(5500),
    [anon_sym_nointerpolation] = ACTIONS(5500),
    [anon_sym_sample] = ACTIONS(5500),
    [anon_sym_linear] = ACTIONS(5500),
    [anon_sym_snorm] = ACTIONS(5500),
    [anon_sym_unorm] = ACTIONS(5500),
    [anon_sym_point] = ACTIONS(5500),
    [anon_sym_line] = ACTIONS(5500),
    [anon_sym_triangleadj] = ACTIONS(5500),
    [anon_sym_lineadj] = ACTIONS(5500),
    [anon_sym_triangle] = ACTIONS(5500),
    [anon_sym_interface] = ACTIONS(5500),
    [anon_sym_extension] = ACTIONS(5500),
    [anon_sym___init] = ACTIONS(5500),
    [anon_sym___subscript] = ACTIONS(5500),
    [anon_sym_property] = ACTIONS(5500),
    [anon_sym_associatedtype] = ACTIONS(5500),
  },
  [1606] = {
    [sym_expression] = STATE(4984),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_initializer_list] = STATE(8570),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_default] = ACTIONS(5504),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(5494),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(5506),
    [anon_sym_0] = ACTIONS(5508),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1607] = {
    [sym_identifier] = ACTIONS(3669),
    [aux_sym_preproc_def_token1] = ACTIONS(3669),
    [aux_sym_preproc_if_token1] = ACTIONS(3669),
    [aux_sym_preproc_if_token2] = ACTIONS(3669),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3669),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3669),
    [aux_sym_preproc_else_token1] = ACTIONS(3669),
    [aux_sym_preproc_elif_token1] = ACTIONS(3669),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3669),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3669),
    [sym_preproc_directive] = ACTIONS(3669),
    [anon_sym_LPAREN2] = ACTIONS(3671),
    [anon_sym_TILDE] = ACTIONS(3671),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3671),
    [anon_sym_AMP] = ACTIONS(3669),
    [anon_sym___extension__] = ACTIONS(3669),
    [anon_sym_typedef] = ACTIONS(3669),
    [anon_sym_in] = ACTIONS(3669),
    [anon_sym_out] = ACTIONS(3669),
    [anon_sym_inout] = ACTIONS(3669),
    [anon_sym_extern] = ACTIONS(3669),
    [anon_sym___attribute__] = ACTIONS(3669),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3671),
    [anon_sym___declspec] = ACTIONS(3669),
    [anon_sym___based] = ACTIONS(3669),
    [anon_sym_signed] = ACTIONS(3669),
    [anon_sym_unsigned] = ACTIONS(3669),
    [anon_sym_long] = ACTIONS(3669),
    [anon_sym_short] = ACTIONS(3669),
    [anon_sym_LBRACK] = ACTIONS(3669),
    [anon_sym_static] = ACTIONS(3669),
    [anon_sym_register] = ACTIONS(3669),
    [anon_sym_inline] = ACTIONS(3669),
    [anon_sym___inline] = ACTIONS(3669),
    [anon_sym___inline__] = ACTIONS(3669),
    [anon_sym___forceinline] = ACTIONS(3669),
    [anon_sym_thread_local] = ACTIONS(3669),
    [anon_sym___thread] = ACTIONS(3669),
    [anon_sym_const] = ACTIONS(3669),
    [anon_sym_constexpr] = ACTIONS(3669),
    [anon_sym_volatile] = ACTIONS(3669),
    [anon_sym_restrict] = ACTIONS(3669),
    [anon_sym___restrict__] = ACTIONS(3669),
    [anon_sym__Atomic] = ACTIONS(3669),
    [anon_sym__Noreturn] = ACTIONS(3669),
    [anon_sym_noreturn] = ACTIONS(3669),
    [anon_sym_mutable] = ACTIONS(3669),
    [anon_sym_constinit] = ACTIONS(3669),
    [anon_sym_consteval] = ACTIONS(3669),
    [anon_sym_alignas] = ACTIONS(3669),
    [anon_sym__Alignas] = ACTIONS(3669),
    [sym_primitive_type] = ACTIONS(3669),
    [anon_sym_enum] = ACTIONS(3669),
    [anon_sym_class] = ACTIONS(3669),
    [anon_sym_struct] = ACTIONS(3669),
    [anon_sym_union] = ACTIONS(3669),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3669),
    [anon_sym_let] = ACTIONS(3669),
    [anon_sym_This] = ACTIONS(3669),
    [anon_sym_decltype] = ACTIONS(3669),
    [sym_virtual] = ACTIONS(3669),
    [anon_sym_explicit] = ACTIONS(3669),
    [anon_sym_typename] = ACTIONS(3669),
    [anon_sym_template] = ACTIONS(3669),
    [anon_sym_operator] = ACTIONS(3669),
    [anon_sym_friend] = ACTIONS(3669),
    [anon_sym_public] = ACTIONS(3669),
    [anon_sym_private] = ACTIONS(3669),
    [anon_sym_protected] = ACTIONS(3669),
    [anon_sym_using] = ACTIONS(3669),
    [anon_sym_static_assert] = ACTIONS(3669),
    [anon_sym_precise] = ACTIONS(3669),
    [anon_sym_shared] = ACTIONS(3669),
    [anon_sym_groupshared] = ACTIONS(3669),
    [anon_sym_uniform] = ACTIONS(3669),
    [anon_sym_row_major] = ACTIONS(3669),
    [anon_sym_column_major] = ACTIONS(3669),
    [anon_sym_globallycoherent] = ACTIONS(3669),
    [anon_sym_centroid] = ACTIONS(3669),
    [anon_sym_noperspective] = ACTIONS(3669),
    [anon_sym_nointerpolation] = ACTIONS(3669),
    [anon_sym_sample] = ACTIONS(3669),
    [anon_sym_linear] = ACTIONS(3669),
    [anon_sym_snorm] = ACTIONS(3669),
    [anon_sym_unorm] = ACTIONS(3669),
    [anon_sym_point] = ACTIONS(3669),
    [anon_sym_line] = ACTIONS(3669),
    [anon_sym_triangleadj] = ACTIONS(3669),
    [anon_sym_lineadj] = ACTIONS(3669),
    [anon_sym_triangle] = ACTIONS(3669),
    [anon_sym_interface] = ACTIONS(3669),
    [anon_sym_extension] = ACTIONS(3669),
    [anon_sym___init] = ACTIONS(3669),
    [anon_sym___subscript] = ACTIONS(3669),
    [anon_sym_property] = ACTIONS(3669),
    [anon_sym_associatedtype] = ACTIONS(3669),
  },
  [1608] = {
    [sym_expression] = STATE(4214),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym__unary_left_fold] = STATE(10439),
    [sym__unary_right_fold] = STATE(10553),
    [sym__binary_fold] = STATE(10552),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1609] = {
    [sym_identifier] = ACTIONS(3038),
    [aux_sym_preproc_def_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token2] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3038),
    [aux_sym_preproc_else_token1] = ACTIONS(3038),
    [aux_sym_preproc_elif_token1] = ACTIONS(3038),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3038),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3038),
    [sym_preproc_directive] = ACTIONS(3038),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3038),
    [anon_sym___extension__] = ACTIONS(3038),
    [anon_sym_typedef] = ACTIONS(3038),
    [anon_sym_in] = ACTIONS(3038),
    [anon_sym_out] = ACTIONS(3038),
    [anon_sym_inout] = ACTIONS(3038),
    [anon_sym_extern] = ACTIONS(3038),
    [anon_sym___attribute__] = ACTIONS(3038),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3040),
    [anon_sym___declspec] = ACTIONS(3038),
    [anon_sym___based] = ACTIONS(3038),
    [anon_sym_signed] = ACTIONS(3038),
    [anon_sym_unsigned] = ACTIONS(3038),
    [anon_sym_long] = ACTIONS(3038),
    [anon_sym_short] = ACTIONS(3038),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_static] = ACTIONS(3038),
    [anon_sym_register] = ACTIONS(3038),
    [anon_sym_inline] = ACTIONS(3038),
    [anon_sym___inline] = ACTIONS(3038),
    [anon_sym___inline__] = ACTIONS(3038),
    [anon_sym___forceinline] = ACTIONS(3038),
    [anon_sym_thread_local] = ACTIONS(3038),
    [anon_sym___thread] = ACTIONS(3038),
    [anon_sym_const] = ACTIONS(3038),
    [anon_sym_constexpr] = ACTIONS(3038),
    [anon_sym_volatile] = ACTIONS(3038),
    [anon_sym_restrict] = ACTIONS(3038),
    [anon_sym___restrict__] = ACTIONS(3038),
    [anon_sym__Atomic] = ACTIONS(3038),
    [anon_sym__Noreturn] = ACTIONS(3038),
    [anon_sym_noreturn] = ACTIONS(3038),
    [anon_sym_mutable] = ACTIONS(3038),
    [anon_sym_constinit] = ACTIONS(3038),
    [anon_sym_consteval] = ACTIONS(3038),
    [anon_sym_alignas] = ACTIONS(3038),
    [anon_sym__Alignas] = ACTIONS(3038),
    [sym_primitive_type] = ACTIONS(3038),
    [anon_sym_enum] = ACTIONS(3038),
    [anon_sym_class] = ACTIONS(3038),
    [anon_sym_struct] = ACTIONS(3038),
    [anon_sym_union] = ACTIONS(3038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3038),
    [anon_sym_let] = ACTIONS(3038),
    [anon_sym_This] = ACTIONS(3038),
    [anon_sym_decltype] = ACTIONS(3038),
    [sym_virtual] = ACTIONS(3038),
    [anon_sym_explicit] = ACTIONS(3038),
    [anon_sym_typename] = ACTIONS(3038),
    [anon_sym_template] = ACTIONS(3038),
    [anon_sym_operator] = ACTIONS(3038),
    [anon_sym_friend] = ACTIONS(3038),
    [anon_sym_public] = ACTIONS(3038),
    [anon_sym_private] = ACTIONS(3038),
    [anon_sym_protected] = ACTIONS(3038),
    [anon_sym_using] = ACTIONS(3038),
    [anon_sym_static_assert] = ACTIONS(3038),
    [anon_sym_precise] = ACTIONS(3038),
    [anon_sym_shared] = ACTIONS(3038),
    [anon_sym_groupshared] = ACTIONS(3038),
    [anon_sym_uniform] = ACTIONS(3038),
    [anon_sym_row_major] = ACTIONS(3038),
    [anon_sym_column_major] = ACTIONS(3038),
    [anon_sym_globallycoherent] = ACTIONS(3038),
    [anon_sym_centroid] = ACTIONS(3038),
    [anon_sym_noperspective] = ACTIONS(3038),
    [anon_sym_nointerpolation] = ACTIONS(3038),
    [anon_sym_sample] = ACTIONS(3038),
    [anon_sym_linear] = ACTIONS(3038),
    [anon_sym_snorm] = ACTIONS(3038),
    [anon_sym_unorm] = ACTIONS(3038),
    [anon_sym_point] = ACTIONS(3038),
    [anon_sym_line] = ACTIONS(3038),
    [anon_sym_triangleadj] = ACTIONS(3038),
    [anon_sym_lineadj] = ACTIONS(3038),
    [anon_sym_triangle] = ACTIONS(3038),
    [anon_sym_interface] = ACTIONS(3038),
    [anon_sym_extension] = ACTIONS(3038),
    [anon_sym___init] = ACTIONS(3038),
    [anon_sym___subscript] = ACTIONS(3038),
    [anon_sym_property] = ACTIONS(3038),
    [anon_sym_associatedtype] = ACTIONS(3038),
  },
  [1610] = {
    [sym_identifier] = ACTIONS(3038),
    [aux_sym_preproc_def_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token2] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3038),
    [aux_sym_preproc_else_token1] = ACTIONS(3038),
    [aux_sym_preproc_elif_token1] = ACTIONS(3038),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3038),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3038),
    [sym_preproc_directive] = ACTIONS(3038),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3038),
    [anon_sym___extension__] = ACTIONS(3038),
    [anon_sym_typedef] = ACTIONS(3038),
    [anon_sym_in] = ACTIONS(3038),
    [anon_sym_out] = ACTIONS(3038),
    [anon_sym_inout] = ACTIONS(3038),
    [anon_sym_extern] = ACTIONS(3038),
    [anon_sym___attribute__] = ACTIONS(3038),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3040),
    [anon_sym___declspec] = ACTIONS(3038),
    [anon_sym___based] = ACTIONS(3038),
    [anon_sym_signed] = ACTIONS(3038),
    [anon_sym_unsigned] = ACTIONS(3038),
    [anon_sym_long] = ACTIONS(3038),
    [anon_sym_short] = ACTIONS(3038),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_static] = ACTIONS(3038),
    [anon_sym_register] = ACTIONS(3038),
    [anon_sym_inline] = ACTIONS(3038),
    [anon_sym___inline] = ACTIONS(3038),
    [anon_sym___inline__] = ACTIONS(3038),
    [anon_sym___forceinline] = ACTIONS(3038),
    [anon_sym_thread_local] = ACTIONS(3038),
    [anon_sym___thread] = ACTIONS(3038),
    [anon_sym_const] = ACTIONS(3038),
    [anon_sym_constexpr] = ACTIONS(3038),
    [anon_sym_volatile] = ACTIONS(3038),
    [anon_sym_restrict] = ACTIONS(3038),
    [anon_sym___restrict__] = ACTIONS(3038),
    [anon_sym__Atomic] = ACTIONS(3038),
    [anon_sym__Noreturn] = ACTIONS(3038),
    [anon_sym_noreturn] = ACTIONS(3038),
    [anon_sym_mutable] = ACTIONS(3038),
    [anon_sym_constinit] = ACTIONS(3038),
    [anon_sym_consteval] = ACTIONS(3038),
    [anon_sym_alignas] = ACTIONS(3038),
    [anon_sym__Alignas] = ACTIONS(3038),
    [sym_primitive_type] = ACTIONS(3038),
    [anon_sym_enum] = ACTIONS(3038),
    [anon_sym_class] = ACTIONS(3038),
    [anon_sym_struct] = ACTIONS(3038),
    [anon_sym_union] = ACTIONS(3038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3038),
    [anon_sym_let] = ACTIONS(3038),
    [anon_sym_This] = ACTIONS(3038),
    [anon_sym_decltype] = ACTIONS(3038),
    [sym_virtual] = ACTIONS(3038),
    [anon_sym_explicit] = ACTIONS(3038),
    [anon_sym_typename] = ACTIONS(3038),
    [anon_sym_template] = ACTIONS(3038),
    [anon_sym_operator] = ACTIONS(3038),
    [anon_sym_friend] = ACTIONS(3038),
    [anon_sym_public] = ACTIONS(3038),
    [anon_sym_private] = ACTIONS(3038),
    [anon_sym_protected] = ACTIONS(3038),
    [anon_sym_using] = ACTIONS(3038),
    [anon_sym_static_assert] = ACTIONS(3038),
    [anon_sym_precise] = ACTIONS(3038),
    [anon_sym_shared] = ACTIONS(3038),
    [anon_sym_groupshared] = ACTIONS(3038),
    [anon_sym_uniform] = ACTIONS(3038),
    [anon_sym_row_major] = ACTIONS(3038),
    [anon_sym_column_major] = ACTIONS(3038),
    [anon_sym_globallycoherent] = ACTIONS(3038),
    [anon_sym_centroid] = ACTIONS(3038),
    [anon_sym_noperspective] = ACTIONS(3038),
    [anon_sym_nointerpolation] = ACTIONS(3038),
    [anon_sym_sample] = ACTIONS(3038),
    [anon_sym_linear] = ACTIONS(3038),
    [anon_sym_snorm] = ACTIONS(3038),
    [anon_sym_unorm] = ACTIONS(3038),
    [anon_sym_point] = ACTIONS(3038),
    [anon_sym_line] = ACTIONS(3038),
    [anon_sym_triangleadj] = ACTIONS(3038),
    [anon_sym_lineadj] = ACTIONS(3038),
    [anon_sym_triangle] = ACTIONS(3038),
    [anon_sym_interface] = ACTIONS(3038),
    [anon_sym_extension] = ACTIONS(3038),
    [anon_sym___init] = ACTIONS(3038),
    [anon_sym___subscript] = ACTIONS(3038),
    [anon_sym_property] = ACTIONS(3038),
    [anon_sym_associatedtype] = ACTIONS(3038),
  },
  [1611] = {
    [sym_identifier] = ACTIONS(5510),
    [aux_sym_preproc_def_token1] = ACTIONS(5510),
    [aux_sym_preproc_if_token1] = ACTIONS(5510),
    [aux_sym_preproc_if_token2] = ACTIONS(5510),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5510),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5510),
    [aux_sym_preproc_else_token1] = ACTIONS(5510),
    [aux_sym_preproc_elif_token1] = ACTIONS(5510),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5510),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5510),
    [sym_preproc_directive] = ACTIONS(5510),
    [anon_sym_LPAREN2] = ACTIONS(5512),
    [anon_sym_TILDE] = ACTIONS(5512),
    [anon_sym_STAR] = ACTIONS(5512),
    [anon_sym_AMP_AMP] = ACTIONS(5512),
    [anon_sym_AMP] = ACTIONS(5510),
    [anon_sym___extension__] = ACTIONS(5510),
    [anon_sym_typedef] = ACTIONS(5510),
    [anon_sym_in] = ACTIONS(5510),
    [anon_sym_out] = ACTIONS(5510),
    [anon_sym_inout] = ACTIONS(5510),
    [anon_sym_extern] = ACTIONS(5510),
    [anon_sym___attribute__] = ACTIONS(5510),
    [anon_sym_COLON_COLON] = ACTIONS(5512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5512),
    [anon_sym___declspec] = ACTIONS(5510),
    [anon_sym___based] = ACTIONS(5510),
    [anon_sym_signed] = ACTIONS(5510),
    [anon_sym_unsigned] = ACTIONS(5510),
    [anon_sym_long] = ACTIONS(5510),
    [anon_sym_short] = ACTIONS(5510),
    [anon_sym_LBRACK] = ACTIONS(5510),
    [anon_sym_static] = ACTIONS(5510),
    [anon_sym_register] = ACTIONS(5510),
    [anon_sym_inline] = ACTIONS(5510),
    [anon_sym___inline] = ACTIONS(5510),
    [anon_sym___inline__] = ACTIONS(5510),
    [anon_sym___forceinline] = ACTIONS(5510),
    [anon_sym_thread_local] = ACTIONS(5510),
    [anon_sym___thread] = ACTIONS(5510),
    [anon_sym_const] = ACTIONS(5510),
    [anon_sym_constexpr] = ACTIONS(5510),
    [anon_sym_volatile] = ACTIONS(5510),
    [anon_sym_restrict] = ACTIONS(5510),
    [anon_sym___restrict__] = ACTIONS(5510),
    [anon_sym__Atomic] = ACTIONS(5510),
    [anon_sym__Noreturn] = ACTIONS(5510),
    [anon_sym_noreturn] = ACTIONS(5510),
    [anon_sym_mutable] = ACTIONS(5510),
    [anon_sym_constinit] = ACTIONS(5510),
    [anon_sym_consteval] = ACTIONS(5510),
    [anon_sym_alignas] = ACTIONS(5510),
    [anon_sym__Alignas] = ACTIONS(5510),
    [sym_primitive_type] = ACTIONS(5510),
    [anon_sym_enum] = ACTIONS(5510),
    [anon_sym_class] = ACTIONS(5510),
    [anon_sym_struct] = ACTIONS(5510),
    [anon_sym_union] = ACTIONS(5510),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5510),
    [anon_sym_let] = ACTIONS(5510),
    [anon_sym_This] = ACTIONS(5510),
    [anon_sym_decltype] = ACTIONS(5510),
    [sym_virtual] = ACTIONS(5510),
    [anon_sym_explicit] = ACTIONS(5510),
    [anon_sym_typename] = ACTIONS(5510),
    [anon_sym_template] = ACTIONS(5510),
    [anon_sym_operator] = ACTIONS(5510),
    [anon_sym_friend] = ACTIONS(5510),
    [anon_sym_public] = ACTIONS(5510),
    [anon_sym_private] = ACTIONS(5510),
    [anon_sym_protected] = ACTIONS(5510),
    [anon_sym_using] = ACTIONS(5510),
    [anon_sym_static_assert] = ACTIONS(5510),
    [anon_sym_precise] = ACTIONS(5510),
    [anon_sym_shared] = ACTIONS(5510),
    [anon_sym_groupshared] = ACTIONS(5510),
    [anon_sym_uniform] = ACTIONS(5510),
    [anon_sym_row_major] = ACTIONS(5510),
    [anon_sym_column_major] = ACTIONS(5510),
    [anon_sym_globallycoherent] = ACTIONS(5510),
    [anon_sym_centroid] = ACTIONS(5510),
    [anon_sym_noperspective] = ACTIONS(5510),
    [anon_sym_nointerpolation] = ACTIONS(5510),
    [anon_sym_sample] = ACTIONS(5510),
    [anon_sym_linear] = ACTIONS(5510),
    [anon_sym_snorm] = ACTIONS(5510),
    [anon_sym_unorm] = ACTIONS(5510),
    [anon_sym_point] = ACTIONS(5510),
    [anon_sym_line] = ACTIONS(5510),
    [anon_sym_triangleadj] = ACTIONS(5510),
    [anon_sym_lineadj] = ACTIONS(5510),
    [anon_sym_triangle] = ACTIONS(5510),
    [anon_sym_interface] = ACTIONS(5510),
    [anon_sym_extension] = ACTIONS(5510),
    [anon_sym___init] = ACTIONS(5510),
    [anon_sym___subscript] = ACTIONS(5510),
    [anon_sym_property] = ACTIONS(5510),
    [anon_sym_associatedtype] = ACTIONS(5510),
  },
  [1612] = {
    [sym_identifier] = ACTIONS(5514),
    [aux_sym_preproc_def_token1] = ACTIONS(5514),
    [aux_sym_preproc_if_token1] = ACTIONS(5514),
    [aux_sym_preproc_if_token2] = ACTIONS(5514),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5514),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5514),
    [aux_sym_preproc_else_token1] = ACTIONS(5514),
    [aux_sym_preproc_elif_token1] = ACTIONS(5514),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5514),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5514),
    [sym_preproc_directive] = ACTIONS(5514),
    [anon_sym_LPAREN2] = ACTIONS(5516),
    [anon_sym_TILDE] = ACTIONS(5516),
    [anon_sym_STAR] = ACTIONS(5516),
    [anon_sym_AMP_AMP] = ACTIONS(5516),
    [anon_sym_AMP] = ACTIONS(5514),
    [anon_sym___extension__] = ACTIONS(5514),
    [anon_sym_typedef] = ACTIONS(5514),
    [anon_sym_in] = ACTIONS(5514),
    [anon_sym_out] = ACTIONS(5514),
    [anon_sym_inout] = ACTIONS(5514),
    [anon_sym_extern] = ACTIONS(5514),
    [anon_sym___attribute__] = ACTIONS(5514),
    [anon_sym_COLON_COLON] = ACTIONS(5516),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5516),
    [anon_sym___declspec] = ACTIONS(5514),
    [anon_sym___based] = ACTIONS(5514),
    [anon_sym_signed] = ACTIONS(5514),
    [anon_sym_unsigned] = ACTIONS(5514),
    [anon_sym_long] = ACTIONS(5514),
    [anon_sym_short] = ACTIONS(5514),
    [anon_sym_LBRACK] = ACTIONS(5514),
    [anon_sym_static] = ACTIONS(5514),
    [anon_sym_register] = ACTIONS(5514),
    [anon_sym_inline] = ACTIONS(5514),
    [anon_sym___inline] = ACTIONS(5514),
    [anon_sym___inline__] = ACTIONS(5514),
    [anon_sym___forceinline] = ACTIONS(5514),
    [anon_sym_thread_local] = ACTIONS(5514),
    [anon_sym___thread] = ACTIONS(5514),
    [anon_sym_const] = ACTIONS(5514),
    [anon_sym_constexpr] = ACTIONS(5514),
    [anon_sym_volatile] = ACTIONS(5514),
    [anon_sym_restrict] = ACTIONS(5514),
    [anon_sym___restrict__] = ACTIONS(5514),
    [anon_sym__Atomic] = ACTIONS(5514),
    [anon_sym__Noreturn] = ACTIONS(5514),
    [anon_sym_noreturn] = ACTIONS(5514),
    [anon_sym_mutable] = ACTIONS(5514),
    [anon_sym_constinit] = ACTIONS(5514),
    [anon_sym_consteval] = ACTIONS(5514),
    [anon_sym_alignas] = ACTIONS(5514),
    [anon_sym__Alignas] = ACTIONS(5514),
    [sym_primitive_type] = ACTIONS(5514),
    [anon_sym_enum] = ACTIONS(5514),
    [anon_sym_class] = ACTIONS(5514),
    [anon_sym_struct] = ACTIONS(5514),
    [anon_sym_union] = ACTIONS(5514),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5514),
    [anon_sym_let] = ACTIONS(5514),
    [anon_sym_This] = ACTIONS(5514),
    [anon_sym_decltype] = ACTIONS(5514),
    [sym_virtual] = ACTIONS(5514),
    [anon_sym_explicit] = ACTIONS(5514),
    [anon_sym_typename] = ACTIONS(5514),
    [anon_sym_template] = ACTIONS(5514),
    [anon_sym_operator] = ACTIONS(5514),
    [anon_sym_friend] = ACTIONS(5514),
    [anon_sym_public] = ACTIONS(5514),
    [anon_sym_private] = ACTIONS(5514),
    [anon_sym_protected] = ACTIONS(5514),
    [anon_sym_using] = ACTIONS(5514),
    [anon_sym_static_assert] = ACTIONS(5514),
    [anon_sym_precise] = ACTIONS(5514),
    [anon_sym_shared] = ACTIONS(5514),
    [anon_sym_groupshared] = ACTIONS(5514),
    [anon_sym_uniform] = ACTIONS(5514),
    [anon_sym_row_major] = ACTIONS(5514),
    [anon_sym_column_major] = ACTIONS(5514),
    [anon_sym_globallycoherent] = ACTIONS(5514),
    [anon_sym_centroid] = ACTIONS(5514),
    [anon_sym_noperspective] = ACTIONS(5514),
    [anon_sym_nointerpolation] = ACTIONS(5514),
    [anon_sym_sample] = ACTIONS(5514),
    [anon_sym_linear] = ACTIONS(5514),
    [anon_sym_snorm] = ACTIONS(5514),
    [anon_sym_unorm] = ACTIONS(5514),
    [anon_sym_point] = ACTIONS(5514),
    [anon_sym_line] = ACTIONS(5514),
    [anon_sym_triangleadj] = ACTIONS(5514),
    [anon_sym_lineadj] = ACTIONS(5514),
    [anon_sym_triangle] = ACTIONS(5514),
    [anon_sym_interface] = ACTIONS(5514),
    [anon_sym_extension] = ACTIONS(5514),
    [anon_sym___init] = ACTIONS(5514),
    [anon_sym___subscript] = ACTIONS(5514),
    [anon_sym_property] = ACTIONS(5514),
    [anon_sym_associatedtype] = ACTIONS(5514),
  },
  [1613] = {
    [sym_identifier] = ACTIONS(5518),
    [aux_sym_preproc_def_token1] = ACTIONS(5518),
    [aux_sym_preproc_if_token1] = ACTIONS(5518),
    [aux_sym_preproc_if_token2] = ACTIONS(5518),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5518),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5518),
    [aux_sym_preproc_else_token1] = ACTIONS(5518),
    [aux_sym_preproc_elif_token1] = ACTIONS(5518),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5518),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5518),
    [sym_preproc_directive] = ACTIONS(5518),
    [anon_sym_LPAREN2] = ACTIONS(5520),
    [anon_sym_TILDE] = ACTIONS(5520),
    [anon_sym_STAR] = ACTIONS(5520),
    [anon_sym_AMP_AMP] = ACTIONS(5520),
    [anon_sym_AMP] = ACTIONS(5518),
    [anon_sym___extension__] = ACTIONS(5518),
    [anon_sym_typedef] = ACTIONS(5518),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_inout] = ACTIONS(5518),
    [anon_sym_extern] = ACTIONS(5518),
    [anon_sym___attribute__] = ACTIONS(5518),
    [anon_sym_COLON_COLON] = ACTIONS(5520),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5520),
    [anon_sym___declspec] = ACTIONS(5518),
    [anon_sym___based] = ACTIONS(5518),
    [anon_sym_signed] = ACTIONS(5518),
    [anon_sym_unsigned] = ACTIONS(5518),
    [anon_sym_long] = ACTIONS(5518),
    [anon_sym_short] = ACTIONS(5518),
    [anon_sym_LBRACK] = ACTIONS(5518),
    [anon_sym_static] = ACTIONS(5518),
    [anon_sym_register] = ACTIONS(5518),
    [anon_sym_inline] = ACTIONS(5518),
    [anon_sym___inline] = ACTIONS(5518),
    [anon_sym___inline__] = ACTIONS(5518),
    [anon_sym___forceinline] = ACTIONS(5518),
    [anon_sym_thread_local] = ACTIONS(5518),
    [anon_sym___thread] = ACTIONS(5518),
    [anon_sym_const] = ACTIONS(5518),
    [anon_sym_constexpr] = ACTIONS(5518),
    [anon_sym_volatile] = ACTIONS(5518),
    [anon_sym_restrict] = ACTIONS(5518),
    [anon_sym___restrict__] = ACTIONS(5518),
    [anon_sym__Atomic] = ACTIONS(5518),
    [anon_sym__Noreturn] = ACTIONS(5518),
    [anon_sym_noreturn] = ACTIONS(5518),
    [anon_sym_mutable] = ACTIONS(5518),
    [anon_sym_constinit] = ACTIONS(5518),
    [anon_sym_consteval] = ACTIONS(5518),
    [anon_sym_alignas] = ACTIONS(5518),
    [anon_sym__Alignas] = ACTIONS(5518),
    [sym_primitive_type] = ACTIONS(5518),
    [anon_sym_enum] = ACTIONS(5518),
    [anon_sym_class] = ACTIONS(5518),
    [anon_sym_struct] = ACTIONS(5518),
    [anon_sym_union] = ACTIONS(5518),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5518),
    [anon_sym_let] = ACTIONS(5518),
    [anon_sym_This] = ACTIONS(5518),
    [anon_sym_decltype] = ACTIONS(5518),
    [sym_virtual] = ACTIONS(5518),
    [anon_sym_explicit] = ACTIONS(5518),
    [anon_sym_typename] = ACTIONS(5518),
    [anon_sym_template] = ACTIONS(5518),
    [anon_sym_operator] = ACTIONS(5518),
    [anon_sym_friend] = ACTIONS(5518),
    [anon_sym_public] = ACTIONS(5518),
    [anon_sym_private] = ACTIONS(5518),
    [anon_sym_protected] = ACTIONS(5518),
    [anon_sym_using] = ACTIONS(5518),
    [anon_sym_static_assert] = ACTIONS(5518),
    [anon_sym_precise] = ACTIONS(5518),
    [anon_sym_shared] = ACTIONS(5518),
    [anon_sym_groupshared] = ACTIONS(5518),
    [anon_sym_uniform] = ACTIONS(5518),
    [anon_sym_row_major] = ACTIONS(5518),
    [anon_sym_column_major] = ACTIONS(5518),
    [anon_sym_globallycoherent] = ACTIONS(5518),
    [anon_sym_centroid] = ACTIONS(5518),
    [anon_sym_noperspective] = ACTIONS(5518),
    [anon_sym_nointerpolation] = ACTIONS(5518),
    [anon_sym_sample] = ACTIONS(5518),
    [anon_sym_linear] = ACTIONS(5518),
    [anon_sym_snorm] = ACTIONS(5518),
    [anon_sym_unorm] = ACTIONS(5518),
    [anon_sym_point] = ACTIONS(5518),
    [anon_sym_line] = ACTIONS(5518),
    [anon_sym_triangleadj] = ACTIONS(5518),
    [anon_sym_lineadj] = ACTIONS(5518),
    [anon_sym_triangle] = ACTIONS(5518),
    [anon_sym_interface] = ACTIONS(5518),
    [anon_sym_extension] = ACTIONS(5518),
    [anon_sym___init] = ACTIONS(5518),
    [anon_sym___subscript] = ACTIONS(5518),
    [anon_sym_property] = ACTIONS(5518),
    [anon_sym_associatedtype] = ACTIONS(5518),
  },
  [1614] = {
    [sym_identifier] = ACTIONS(5522),
    [aux_sym_preproc_def_token1] = ACTIONS(5522),
    [aux_sym_preproc_if_token1] = ACTIONS(5522),
    [aux_sym_preproc_if_token2] = ACTIONS(5522),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5522),
    [aux_sym_preproc_else_token1] = ACTIONS(5522),
    [aux_sym_preproc_elif_token1] = ACTIONS(5522),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5522),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5522),
    [sym_preproc_directive] = ACTIONS(5522),
    [anon_sym_LPAREN2] = ACTIONS(5524),
    [anon_sym_TILDE] = ACTIONS(5524),
    [anon_sym_STAR] = ACTIONS(5524),
    [anon_sym_AMP_AMP] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5522),
    [anon_sym___extension__] = ACTIONS(5522),
    [anon_sym_typedef] = ACTIONS(5522),
    [anon_sym_in] = ACTIONS(5522),
    [anon_sym_out] = ACTIONS(5522),
    [anon_sym_inout] = ACTIONS(5522),
    [anon_sym_extern] = ACTIONS(5522),
    [anon_sym___attribute__] = ACTIONS(5522),
    [anon_sym_COLON_COLON] = ACTIONS(5524),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5524),
    [anon_sym___declspec] = ACTIONS(5522),
    [anon_sym___based] = ACTIONS(5522),
    [anon_sym_signed] = ACTIONS(5522),
    [anon_sym_unsigned] = ACTIONS(5522),
    [anon_sym_long] = ACTIONS(5522),
    [anon_sym_short] = ACTIONS(5522),
    [anon_sym_LBRACK] = ACTIONS(5522),
    [anon_sym_static] = ACTIONS(5522),
    [anon_sym_register] = ACTIONS(5522),
    [anon_sym_inline] = ACTIONS(5522),
    [anon_sym___inline] = ACTIONS(5522),
    [anon_sym___inline__] = ACTIONS(5522),
    [anon_sym___forceinline] = ACTIONS(5522),
    [anon_sym_thread_local] = ACTIONS(5522),
    [anon_sym___thread] = ACTIONS(5522),
    [anon_sym_const] = ACTIONS(5522),
    [anon_sym_constexpr] = ACTIONS(5522),
    [anon_sym_volatile] = ACTIONS(5522),
    [anon_sym_restrict] = ACTIONS(5522),
    [anon_sym___restrict__] = ACTIONS(5522),
    [anon_sym__Atomic] = ACTIONS(5522),
    [anon_sym__Noreturn] = ACTIONS(5522),
    [anon_sym_noreturn] = ACTIONS(5522),
    [anon_sym_mutable] = ACTIONS(5522),
    [anon_sym_constinit] = ACTIONS(5522),
    [anon_sym_consteval] = ACTIONS(5522),
    [anon_sym_alignas] = ACTIONS(5522),
    [anon_sym__Alignas] = ACTIONS(5522),
    [sym_primitive_type] = ACTIONS(5522),
    [anon_sym_enum] = ACTIONS(5522),
    [anon_sym_class] = ACTIONS(5522),
    [anon_sym_struct] = ACTIONS(5522),
    [anon_sym_union] = ACTIONS(5522),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5522),
    [anon_sym_let] = ACTIONS(5522),
    [anon_sym_This] = ACTIONS(5522),
    [anon_sym_decltype] = ACTIONS(5522),
    [sym_virtual] = ACTIONS(5522),
    [anon_sym_explicit] = ACTIONS(5522),
    [anon_sym_typename] = ACTIONS(5522),
    [anon_sym_template] = ACTIONS(5522),
    [anon_sym_operator] = ACTIONS(5522),
    [anon_sym_friend] = ACTIONS(5522),
    [anon_sym_public] = ACTIONS(5522),
    [anon_sym_private] = ACTIONS(5522),
    [anon_sym_protected] = ACTIONS(5522),
    [anon_sym_using] = ACTIONS(5522),
    [anon_sym_static_assert] = ACTIONS(5522),
    [anon_sym_precise] = ACTIONS(5522),
    [anon_sym_shared] = ACTIONS(5522),
    [anon_sym_groupshared] = ACTIONS(5522),
    [anon_sym_uniform] = ACTIONS(5522),
    [anon_sym_row_major] = ACTIONS(5522),
    [anon_sym_column_major] = ACTIONS(5522),
    [anon_sym_globallycoherent] = ACTIONS(5522),
    [anon_sym_centroid] = ACTIONS(5522),
    [anon_sym_noperspective] = ACTIONS(5522),
    [anon_sym_nointerpolation] = ACTIONS(5522),
    [anon_sym_sample] = ACTIONS(5522),
    [anon_sym_linear] = ACTIONS(5522),
    [anon_sym_snorm] = ACTIONS(5522),
    [anon_sym_unorm] = ACTIONS(5522),
    [anon_sym_point] = ACTIONS(5522),
    [anon_sym_line] = ACTIONS(5522),
    [anon_sym_triangleadj] = ACTIONS(5522),
    [anon_sym_lineadj] = ACTIONS(5522),
    [anon_sym_triangle] = ACTIONS(5522),
    [anon_sym_interface] = ACTIONS(5522),
    [anon_sym_extension] = ACTIONS(5522),
    [anon_sym___init] = ACTIONS(5522),
    [anon_sym___subscript] = ACTIONS(5522),
    [anon_sym_property] = ACTIONS(5522),
    [anon_sym_associatedtype] = ACTIONS(5522),
  },
  [1615] = {
    [sym_identifier] = ACTIONS(5518),
    [aux_sym_preproc_def_token1] = ACTIONS(5518),
    [aux_sym_preproc_if_token1] = ACTIONS(5518),
    [aux_sym_preproc_if_token2] = ACTIONS(5518),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5518),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5518),
    [aux_sym_preproc_else_token1] = ACTIONS(5518),
    [aux_sym_preproc_elif_token1] = ACTIONS(5518),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5518),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5518),
    [sym_preproc_directive] = ACTIONS(5518),
    [anon_sym_LPAREN2] = ACTIONS(5520),
    [anon_sym_TILDE] = ACTIONS(5520),
    [anon_sym_STAR] = ACTIONS(5520),
    [anon_sym_AMP_AMP] = ACTIONS(5520),
    [anon_sym_AMP] = ACTIONS(5518),
    [anon_sym___extension__] = ACTIONS(5518),
    [anon_sym_typedef] = ACTIONS(5518),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_inout] = ACTIONS(5518),
    [anon_sym_extern] = ACTIONS(5518),
    [anon_sym___attribute__] = ACTIONS(5518),
    [anon_sym_COLON_COLON] = ACTIONS(5520),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5520),
    [anon_sym___declspec] = ACTIONS(5518),
    [anon_sym___based] = ACTIONS(5518),
    [anon_sym_signed] = ACTIONS(5518),
    [anon_sym_unsigned] = ACTIONS(5518),
    [anon_sym_long] = ACTIONS(5518),
    [anon_sym_short] = ACTIONS(5518),
    [anon_sym_LBRACK] = ACTIONS(5518),
    [anon_sym_static] = ACTIONS(5518),
    [anon_sym_register] = ACTIONS(5518),
    [anon_sym_inline] = ACTIONS(5518),
    [anon_sym___inline] = ACTIONS(5518),
    [anon_sym___inline__] = ACTIONS(5518),
    [anon_sym___forceinline] = ACTIONS(5518),
    [anon_sym_thread_local] = ACTIONS(5518),
    [anon_sym___thread] = ACTIONS(5518),
    [anon_sym_const] = ACTIONS(5518),
    [anon_sym_constexpr] = ACTIONS(5518),
    [anon_sym_volatile] = ACTIONS(5518),
    [anon_sym_restrict] = ACTIONS(5518),
    [anon_sym___restrict__] = ACTIONS(5518),
    [anon_sym__Atomic] = ACTIONS(5518),
    [anon_sym__Noreturn] = ACTIONS(5518),
    [anon_sym_noreturn] = ACTIONS(5518),
    [anon_sym_mutable] = ACTIONS(5518),
    [anon_sym_constinit] = ACTIONS(5518),
    [anon_sym_consteval] = ACTIONS(5518),
    [anon_sym_alignas] = ACTIONS(5518),
    [anon_sym__Alignas] = ACTIONS(5518),
    [sym_primitive_type] = ACTIONS(5518),
    [anon_sym_enum] = ACTIONS(5518),
    [anon_sym_class] = ACTIONS(5518),
    [anon_sym_struct] = ACTIONS(5518),
    [anon_sym_union] = ACTIONS(5518),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5518),
    [anon_sym_let] = ACTIONS(5518),
    [anon_sym_This] = ACTIONS(5518),
    [anon_sym_decltype] = ACTIONS(5518),
    [sym_virtual] = ACTIONS(5518),
    [anon_sym_explicit] = ACTIONS(5518),
    [anon_sym_typename] = ACTIONS(5518),
    [anon_sym_template] = ACTIONS(5518),
    [anon_sym_operator] = ACTIONS(5518),
    [anon_sym_friend] = ACTIONS(5518),
    [anon_sym_public] = ACTIONS(5518),
    [anon_sym_private] = ACTIONS(5518),
    [anon_sym_protected] = ACTIONS(5518),
    [anon_sym_using] = ACTIONS(5518),
    [anon_sym_static_assert] = ACTIONS(5518),
    [anon_sym_precise] = ACTIONS(5518),
    [anon_sym_shared] = ACTIONS(5518),
    [anon_sym_groupshared] = ACTIONS(5518),
    [anon_sym_uniform] = ACTIONS(5518),
    [anon_sym_row_major] = ACTIONS(5518),
    [anon_sym_column_major] = ACTIONS(5518),
    [anon_sym_globallycoherent] = ACTIONS(5518),
    [anon_sym_centroid] = ACTIONS(5518),
    [anon_sym_noperspective] = ACTIONS(5518),
    [anon_sym_nointerpolation] = ACTIONS(5518),
    [anon_sym_sample] = ACTIONS(5518),
    [anon_sym_linear] = ACTIONS(5518),
    [anon_sym_snorm] = ACTIONS(5518),
    [anon_sym_unorm] = ACTIONS(5518),
    [anon_sym_point] = ACTIONS(5518),
    [anon_sym_line] = ACTIONS(5518),
    [anon_sym_triangleadj] = ACTIONS(5518),
    [anon_sym_lineadj] = ACTIONS(5518),
    [anon_sym_triangle] = ACTIONS(5518),
    [anon_sym_interface] = ACTIONS(5518),
    [anon_sym_extension] = ACTIONS(5518),
    [anon_sym___init] = ACTIONS(5518),
    [anon_sym___subscript] = ACTIONS(5518),
    [anon_sym_property] = ACTIONS(5518),
    [anon_sym_associatedtype] = ACTIONS(5518),
  },
  [1616] = {
    [sym_identifier] = ACTIONS(5522),
    [aux_sym_preproc_def_token1] = ACTIONS(5522),
    [aux_sym_preproc_if_token1] = ACTIONS(5522),
    [aux_sym_preproc_if_token2] = ACTIONS(5522),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5522),
    [aux_sym_preproc_else_token1] = ACTIONS(5522),
    [aux_sym_preproc_elif_token1] = ACTIONS(5522),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5522),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5522),
    [sym_preproc_directive] = ACTIONS(5522),
    [anon_sym_LPAREN2] = ACTIONS(5524),
    [anon_sym_TILDE] = ACTIONS(5524),
    [anon_sym_STAR] = ACTIONS(5524),
    [anon_sym_AMP_AMP] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5522),
    [anon_sym___extension__] = ACTIONS(5522),
    [anon_sym_typedef] = ACTIONS(5522),
    [anon_sym_in] = ACTIONS(5522),
    [anon_sym_out] = ACTIONS(5522),
    [anon_sym_inout] = ACTIONS(5522),
    [anon_sym_extern] = ACTIONS(5522),
    [anon_sym___attribute__] = ACTIONS(5522),
    [anon_sym_COLON_COLON] = ACTIONS(5524),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5524),
    [anon_sym___declspec] = ACTIONS(5522),
    [anon_sym___based] = ACTIONS(5522),
    [anon_sym_signed] = ACTIONS(5522),
    [anon_sym_unsigned] = ACTIONS(5522),
    [anon_sym_long] = ACTIONS(5522),
    [anon_sym_short] = ACTIONS(5522),
    [anon_sym_LBRACK] = ACTIONS(5522),
    [anon_sym_static] = ACTIONS(5522),
    [anon_sym_register] = ACTIONS(5522),
    [anon_sym_inline] = ACTIONS(5522),
    [anon_sym___inline] = ACTIONS(5522),
    [anon_sym___inline__] = ACTIONS(5522),
    [anon_sym___forceinline] = ACTIONS(5522),
    [anon_sym_thread_local] = ACTIONS(5522),
    [anon_sym___thread] = ACTIONS(5522),
    [anon_sym_const] = ACTIONS(5522),
    [anon_sym_constexpr] = ACTIONS(5522),
    [anon_sym_volatile] = ACTIONS(5522),
    [anon_sym_restrict] = ACTIONS(5522),
    [anon_sym___restrict__] = ACTIONS(5522),
    [anon_sym__Atomic] = ACTIONS(5522),
    [anon_sym__Noreturn] = ACTIONS(5522),
    [anon_sym_noreturn] = ACTIONS(5522),
    [anon_sym_mutable] = ACTIONS(5522),
    [anon_sym_constinit] = ACTIONS(5522),
    [anon_sym_consteval] = ACTIONS(5522),
    [anon_sym_alignas] = ACTIONS(5522),
    [anon_sym__Alignas] = ACTIONS(5522),
    [sym_primitive_type] = ACTIONS(5522),
    [anon_sym_enum] = ACTIONS(5522),
    [anon_sym_class] = ACTIONS(5522),
    [anon_sym_struct] = ACTIONS(5522),
    [anon_sym_union] = ACTIONS(5522),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5522),
    [anon_sym_let] = ACTIONS(5522),
    [anon_sym_This] = ACTIONS(5522),
    [anon_sym_decltype] = ACTIONS(5522),
    [sym_virtual] = ACTIONS(5522),
    [anon_sym_explicit] = ACTIONS(5522),
    [anon_sym_typename] = ACTIONS(5522),
    [anon_sym_template] = ACTIONS(5522),
    [anon_sym_operator] = ACTIONS(5522),
    [anon_sym_friend] = ACTIONS(5522),
    [anon_sym_public] = ACTIONS(5522),
    [anon_sym_private] = ACTIONS(5522),
    [anon_sym_protected] = ACTIONS(5522),
    [anon_sym_using] = ACTIONS(5522),
    [anon_sym_static_assert] = ACTIONS(5522),
    [anon_sym_precise] = ACTIONS(5522),
    [anon_sym_shared] = ACTIONS(5522),
    [anon_sym_groupshared] = ACTIONS(5522),
    [anon_sym_uniform] = ACTIONS(5522),
    [anon_sym_row_major] = ACTIONS(5522),
    [anon_sym_column_major] = ACTIONS(5522),
    [anon_sym_globallycoherent] = ACTIONS(5522),
    [anon_sym_centroid] = ACTIONS(5522),
    [anon_sym_noperspective] = ACTIONS(5522),
    [anon_sym_nointerpolation] = ACTIONS(5522),
    [anon_sym_sample] = ACTIONS(5522),
    [anon_sym_linear] = ACTIONS(5522),
    [anon_sym_snorm] = ACTIONS(5522),
    [anon_sym_unorm] = ACTIONS(5522),
    [anon_sym_point] = ACTIONS(5522),
    [anon_sym_line] = ACTIONS(5522),
    [anon_sym_triangleadj] = ACTIONS(5522),
    [anon_sym_lineadj] = ACTIONS(5522),
    [anon_sym_triangle] = ACTIONS(5522),
    [anon_sym_interface] = ACTIONS(5522),
    [anon_sym_extension] = ACTIONS(5522),
    [anon_sym___init] = ACTIONS(5522),
    [anon_sym___subscript] = ACTIONS(5522),
    [anon_sym_property] = ACTIONS(5522),
    [anon_sym_associatedtype] = ACTIONS(5522),
  },
  [1617] = {
    [sym_identifier] = ACTIONS(5526),
    [aux_sym_preproc_def_token1] = ACTIONS(5526),
    [aux_sym_preproc_if_token1] = ACTIONS(5526),
    [aux_sym_preproc_if_token2] = ACTIONS(5526),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5526),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5526),
    [aux_sym_preproc_else_token1] = ACTIONS(5526),
    [aux_sym_preproc_elif_token1] = ACTIONS(5526),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5526),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5526),
    [sym_preproc_directive] = ACTIONS(5526),
    [anon_sym_LPAREN2] = ACTIONS(5528),
    [anon_sym_TILDE] = ACTIONS(5528),
    [anon_sym_STAR] = ACTIONS(5528),
    [anon_sym_AMP_AMP] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5526),
    [anon_sym___extension__] = ACTIONS(5526),
    [anon_sym_typedef] = ACTIONS(5526),
    [anon_sym_in] = ACTIONS(5526),
    [anon_sym_out] = ACTIONS(5526),
    [anon_sym_inout] = ACTIONS(5526),
    [anon_sym_extern] = ACTIONS(5526),
    [anon_sym___attribute__] = ACTIONS(5526),
    [anon_sym_COLON_COLON] = ACTIONS(5528),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5528),
    [anon_sym___declspec] = ACTIONS(5526),
    [anon_sym___based] = ACTIONS(5526),
    [anon_sym_signed] = ACTIONS(5526),
    [anon_sym_unsigned] = ACTIONS(5526),
    [anon_sym_long] = ACTIONS(5526),
    [anon_sym_short] = ACTIONS(5526),
    [anon_sym_LBRACK] = ACTIONS(5526),
    [anon_sym_static] = ACTIONS(5526),
    [anon_sym_register] = ACTIONS(5526),
    [anon_sym_inline] = ACTIONS(5526),
    [anon_sym___inline] = ACTIONS(5526),
    [anon_sym___inline__] = ACTIONS(5526),
    [anon_sym___forceinline] = ACTIONS(5526),
    [anon_sym_thread_local] = ACTIONS(5526),
    [anon_sym___thread] = ACTIONS(5526),
    [anon_sym_const] = ACTIONS(5526),
    [anon_sym_constexpr] = ACTIONS(5526),
    [anon_sym_volatile] = ACTIONS(5526),
    [anon_sym_restrict] = ACTIONS(5526),
    [anon_sym___restrict__] = ACTIONS(5526),
    [anon_sym__Atomic] = ACTIONS(5526),
    [anon_sym__Noreturn] = ACTIONS(5526),
    [anon_sym_noreturn] = ACTIONS(5526),
    [anon_sym_mutable] = ACTIONS(5526),
    [anon_sym_constinit] = ACTIONS(5526),
    [anon_sym_consteval] = ACTIONS(5526),
    [anon_sym_alignas] = ACTIONS(5526),
    [anon_sym__Alignas] = ACTIONS(5526),
    [sym_primitive_type] = ACTIONS(5526),
    [anon_sym_enum] = ACTIONS(5526),
    [anon_sym_class] = ACTIONS(5526),
    [anon_sym_struct] = ACTIONS(5526),
    [anon_sym_union] = ACTIONS(5526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5526),
    [anon_sym_let] = ACTIONS(5526),
    [anon_sym_This] = ACTIONS(5526),
    [anon_sym_decltype] = ACTIONS(5526),
    [sym_virtual] = ACTIONS(5526),
    [anon_sym_explicit] = ACTIONS(5526),
    [anon_sym_typename] = ACTIONS(5526),
    [anon_sym_template] = ACTIONS(5526),
    [anon_sym_operator] = ACTIONS(5526),
    [anon_sym_friend] = ACTIONS(5526),
    [anon_sym_public] = ACTIONS(5526),
    [anon_sym_private] = ACTIONS(5526),
    [anon_sym_protected] = ACTIONS(5526),
    [anon_sym_using] = ACTIONS(5526),
    [anon_sym_static_assert] = ACTIONS(5526),
    [anon_sym_precise] = ACTIONS(5526),
    [anon_sym_shared] = ACTIONS(5526),
    [anon_sym_groupshared] = ACTIONS(5526),
    [anon_sym_uniform] = ACTIONS(5526),
    [anon_sym_row_major] = ACTIONS(5526),
    [anon_sym_column_major] = ACTIONS(5526),
    [anon_sym_globallycoherent] = ACTIONS(5526),
    [anon_sym_centroid] = ACTIONS(5526),
    [anon_sym_noperspective] = ACTIONS(5526),
    [anon_sym_nointerpolation] = ACTIONS(5526),
    [anon_sym_sample] = ACTIONS(5526),
    [anon_sym_linear] = ACTIONS(5526),
    [anon_sym_snorm] = ACTIONS(5526),
    [anon_sym_unorm] = ACTIONS(5526),
    [anon_sym_point] = ACTIONS(5526),
    [anon_sym_line] = ACTIONS(5526),
    [anon_sym_triangleadj] = ACTIONS(5526),
    [anon_sym_lineadj] = ACTIONS(5526),
    [anon_sym_triangle] = ACTIONS(5526),
    [anon_sym_interface] = ACTIONS(5526),
    [anon_sym_extension] = ACTIONS(5526),
    [anon_sym___init] = ACTIONS(5526),
    [anon_sym___subscript] = ACTIONS(5526),
    [anon_sym_property] = ACTIONS(5526),
    [anon_sym_associatedtype] = ACTIONS(5526),
  },
  [1618] = {
    [sym_expression] = STATE(5398),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10369),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10369),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5530),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1619] = {
    [sym_identifier] = ACTIONS(5532),
    [aux_sym_preproc_def_token1] = ACTIONS(5532),
    [aux_sym_preproc_if_token1] = ACTIONS(5532),
    [aux_sym_preproc_if_token2] = ACTIONS(5532),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5532),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5532),
    [aux_sym_preproc_else_token1] = ACTIONS(5532),
    [aux_sym_preproc_elif_token1] = ACTIONS(5532),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5532),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5532),
    [sym_preproc_directive] = ACTIONS(5532),
    [anon_sym_LPAREN2] = ACTIONS(5534),
    [anon_sym_TILDE] = ACTIONS(5534),
    [anon_sym_STAR] = ACTIONS(5534),
    [anon_sym_AMP_AMP] = ACTIONS(5534),
    [anon_sym_AMP] = ACTIONS(5532),
    [anon_sym___extension__] = ACTIONS(5532),
    [anon_sym_typedef] = ACTIONS(5532),
    [anon_sym_in] = ACTIONS(5532),
    [anon_sym_out] = ACTIONS(5532),
    [anon_sym_inout] = ACTIONS(5532),
    [anon_sym_extern] = ACTIONS(5532),
    [anon_sym___attribute__] = ACTIONS(5532),
    [anon_sym_COLON_COLON] = ACTIONS(5534),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5534),
    [anon_sym___declspec] = ACTIONS(5532),
    [anon_sym___based] = ACTIONS(5532),
    [anon_sym_signed] = ACTIONS(5532),
    [anon_sym_unsigned] = ACTIONS(5532),
    [anon_sym_long] = ACTIONS(5532),
    [anon_sym_short] = ACTIONS(5532),
    [anon_sym_LBRACK] = ACTIONS(5532),
    [anon_sym_static] = ACTIONS(5532),
    [anon_sym_register] = ACTIONS(5532),
    [anon_sym_inline] = ACTIONS(5532),
    [anon_sym___inline] = ACTIONS(5532),
    [anon_sym___inline__] = ACTIONS(5532),
    [anon_sym___forceinline] = ACTIONS(5532),
    [anon_sym_thread_local] = ACTIONS(5532),
    [anon_sym___thread] = ACTIONS(5532),
    [anon_sym_const] = ACTIONS(5532),
    [anon_sym_constexpr] = ACTIONS(5532),
    [anon_sym_volatile] = ACTIONS(5532),
    [anon_sym_restrict] = ACTIONS(5532),
    [anon_sym___restrict__] = ACTIONS(5532),
    [anon_sym__Atomic] = ACTIONS(5532),
    [anon_sym__Noreturn] = ACTIONS(5532),
    [anon_sym_noreturn] = ACTIONS(5532),
    [anon_sym_mutable] = ACTIONS(5532),
    [anon_sym_constinit] = ACTIONS(5532),
    [anon_sym_consteval] = ACTIONS(5532),
    [anon_sym_alignas] = ACTIONS(5532),
    [anon_sym__Alignas] = ACTIONS(5532),
    [sym_primitive_type] = ACTIONS(5532),
    [anon_sym_enum] = ACTIONS(5532),
    [anon_sym_class] = ACTIONS(5532),
    [anon_sym_struct] = ACTIONS(5532),
    [anon_sym_union] = ACTIONS(5532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5532),
    [anon_sym_let] = ACTIONS(5532),
    [anon_sym_This] = ACTIONS(5532),
    [anon_sym_decltype] = ACTIONS(5532),
    [sym_virtual] = ACTIONS(5532),
    [anon_sym_explicit] = ACTIONS(5532),
    [anon_sym_typename] = ACTIONS(5532),
    [anon_sym_template] = ACTIONS(5532),
    [anon_sym_operator] = ACTIONS(5532),
    [anon_sym_friend] = ACTIONS(5532),
    [anon_sym_public] = ACTIONS(5532),
    [anon_sym_private] = ACTIONS(5532),
    [anon_sym_protected] = ACTIONS(5532),
    [anon_sym_using] = ACTIONS(5532),
    [anon_sym_static_assert] = ACTIONS(5532),
    [anon_sym_precise] = ACTIONS(5532),
    [anon_sym_shared] = ACTIONS(5532),
    [anon_sym_groupshared] = ACTIONS(5532),
    [anon_sym_uniform] = ACTIONS(5532),
    [anon_sym_row_major] = ACTIONS(5532),
    [anon_sym_column_major] = ACTIONS(5532),
    [anon_sym_globallycoherent] = ACTIONS(5532),
    [anon_sym_centroid] = ACTIONS(5532),
    [anon_sym_noperspective] = ACTIONS(5532),
    [anon_sym_nointerpolation] = ACTIONS(5532),
    [anon_sym_sample] = ACTIONS(5532),
    [anon_sym_linear] = ACTIONS(5532),
    [anon_sym_snorm] = ACTIONS(5532),
    [anon_sym_unorm] = ACTIONS(5532),
    [anon_sym_point] = ACTIONS(5532),
    [anon_sym_line] = ACTIONS(5532),
    [anon_sym_triangleadj] = ACTIONS(5532),
    [anon_sym_lineadj] = ACTIONS(5532),
    [anon_sym_triangle] = ACTIONS(5532),
    [anon_sym_interface] = ACTIONS(5532),
    [anon_sym_extension] = ACTIONS(5532),
    [anon_sym___init] = ACTIONS(5532),
    [anon_sym___subscript] = ACTIONS(5532),
    [anon_sym_property] = ACTIONS(5532),
    [anon_sym_associatedtype] = ACTIONS(5532),
  },
  [1620] = {
    [sym_identifier] = ACTIONS(5536),
    [aux_sym_preproc_def_token1] = ACTIONS(5536),
    [aux_sym_preproc_if_token1] = ACTIONS(5536),
    [aux_sym_preproc_if_token2] = ACTIONS(5536),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5536),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5536),
    [aux_sym_preproc_else_token1] = ACTIONS(5536),
    [aux_sym_preproc_elif_token1] = ACTIONS(5536),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5536),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5536),
    [sym_preproc_directive] = ACTIONS(5536),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_TILDE] = ACTIONS(5538),
    [anon_sym_STAR] = ACTIONS(5538),
    [anon_sym_AMP_AMP] = ACTIONS(5538),
    [anon_sym_AMP] = ACTIONS(5536),
    [anon_sym___extension__] = ACTIONS(5536),
    [anon_sym_typedef] = ACTIONS(5536),
    [anon_sym_in] = ACTIONS(5536),
    [anon_sym_out] = ACTIONS(5536),
    [anon_sym_inout] = ACTIONS(5536),
    [anon_sym_extern] = ACTIONS(5536),
    [anon_sym___attribute__] = ACTIONS(5536),
    [anon_sym_COLON_COLON] = ACTIONS(5538),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5538),
    [anon_sym___declspec] = ACTIONS(5536),
    [anon_sym___based] = ACTIONS(5536),
    [anon_sym_signed] = ACTIONS(5536),
    [anon_sym_unsigned] = ACTIONS(5536),
    [anon_sym_long] = ACTIONS(5536),
    [anon_sym_short] = ACTIONS(5536),
    [anon_sym_LBRACK] = ACTIONS(5536),
    [anon_sym_static] = ACTIONS(5536),
    [anon_sym_register] = ACTIONS(5536),
    [anon_sym_inline] = ACTIONS(5536),
    [anon_sym___inline] = ACTIONS(5536),
    [anon_sym___inline__] = ACTIONS(5536),
    [anon_sym___forceinline] = ACTIONS(5536),
    [anon_sym_thread_local] = ACTIONS(5536),
    [anon_sym___thread] = ACTIONS(5536),
    [anon_sym_const] = ACTIONS(5536),
    [anon_sym_constexpr] = ACTIONS(5536),
    [anon_sym_volatile] = ACTIONS(5536),
    [anon_sym_restrict] = ACTIONS(5536),
    [anon_sym___restrict__] = ACTIONS(5536),
    [anon_sym__Atomic] = ACTIONS(5536),
    [anon_sym__Noreturn] = ACTIONS(5536),
    [anon_sym_noreturn] = ACTIONS(5536),
    [anon_sym_mutable] = ACTIONS(5536),
    [anon_sym_constinit] = ACTIONS(5536),
    [anon_sym_consteval] = ACTIONS(5536),
    [anon_sym_alignas] = ACTIONS(5536),
    [anon_sym__Alignas] = ACTIONS(5536),
    [sym_primitive_type] = ACTIONS(5536),
    [anon_sym_enum] = ACTIONS(5536),
    [anon_sym_class] = ACTIONS(5536),
    [anon_sym_struct] = ACTIONS(5536),
    [anon_sym_union] = ACTIONS(5536),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5536),
    [anon_sym_let] = ACTIONS(5536),
    [anon_sym_This] = ACTIONS(5536),
    [anon_sym_decltype] = ACTIONS(5536),
    [sym_virtual] = ACTIONS(5536),
    [anon_sym_explicit] = ACTIONS(5536),
    [anon_sym_typename] = ACTIONS(5536),
    [anon_sym_template] = ACTIONS(5536),
    [anon_sym_operator] = ACTIONS(5536),
    [anon_sym_friend] = ACTIONS(5536),
    [anon_sym_public] = ACTIONS(5536),
    [anon_sym_private] = ACTIONS(5536),
    [anon_sym_protected] = ACTIONS(5536),
    [anon_sym_using] = ACTIONS(5536),
    [anon_sym_static_assert] = ACTIONS(5536),
    [anon_sym_precise] = ACTIONS(5536),
    [anon_sym_shared] = ACTIONS(5536),
    [anon_sym_groupshared] = ACTIONS(5536),
    [anon_sym_uniform] = ACTIONS(5536),
    [anon_sym_row_major] = ACTIONS(5536),
    [anon_sym_column_major] = ACTIONS(5536),
    [anon_sym_globallycoherent] = ACTIONS(5536),
    [anon_sym_centroid] = ACTIONS(5536),
    [anon_sym_noperspective] = ACTIONS(5536),
    [anon_sym_nointerpolation] = ACTIONS(5536),
    [anon_sym_sample] = ACTIONS(5536),
    [anon_sym_linear] = ACTIONS(5536),
    [anon_sym_snorm] = ACTIONS(5536),
    [anon_sym_unorm] = ACTIONS(5536),
    [anon_sym_point] = ACTIONS(5536),
    [anon_sym_line] = ACTIONS(5536),
    [anon_sym_triangleadj] = ACTIONS(5536),
    [anon_sym_lineadj] = ACTIONS(5536),
    [anon_sym_triangle] = ACTIONS(5536),
    [anon_sym_interface] = ACTIONS(5536),
    [anon_sym_extension] = ACTIONS(5536),
    [anon_sym___init] = ACTIONS(5536),
    [anon_sym___subscript] = ACTIONS(5536),
    [anon_sym_property] = ACTIONS(5536),
    [anon_sym_associatedtype] = ACTIONS(5536),
  },
  [1621] = {
    [sym_identifier] = ACTIONS(5540),
    [aux_sym_preproc_def_token1] = ACTIONS(5540),
    [aux_sym_preproc_if_token1] = ACTIONS(5540),
    [aux_sym_preproc_if_token2] = ACTIONS(5540),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5540),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5540),
    [aux_sym_preproc_else_token1] = ACTIONS(5540),
    [aux_sym_preproc_elif_token1] = ACTIONS(5540),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5540),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5540),
    [sym_preproc_directive] = ACTIONS(5540),
    [anon_sym_LPAREN2] = ACTIONS(5542),
    [anon_sym_TILDE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP_AMP] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5540),
    [anon_sym___extension__] = ACTIONS(5540),
    [anon_sym_typedef] = ACTIONS(5540),
    [anon_sym_in] = ACTIONS(5540),
    [anon_sym_out] = ACTIONS(5540),
    [anon_sym_inout] = ACTIONS(5540),
    [anon_sym_extern] = ACTIONS(5540),
    [anon_sym___attribute__] = ACTIONS(5540),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5542),
    [anon_sym___declspec] = ACTIONS(5540),
    [anon_sym___based] = ACTIONS(5540),
    [anon_sym_signed] = ACTIONS(5540),
    [anon_sym_unsigned] = ACTIONS(5540),
    [anon_sym_long] = ACTIONS(5540),
    [anon_sym_short] = ACTIONS(5540),
    [anon_sym_LBRACK] = ACTIONS(5540),
    [anon_sym_static] = ACTIONS(5540),
    [anon_sym_register] = ACTIONS(5540),
    [anon_sym_inline] = ACTIONS(5540),
    [anon_sym___inline] = ACTIONS(5540),
    [anon_sym___inline__] = ACTIONS(5540),
    [anon_sym___forceinline] = ACTIONS(5540),
    [anon_sym_thread_local] = ACTIONS(5540),
    [anon_sym___thread] = ACTIONS(5540),
    [anon_sym_const] = ACTIONS(5540),
    [anon_sym_constexpr] = ACTIONS(5540),
    [anon_sym_volatile] = ACTIONS(5540),
    [anon_sym_restrict] = ACTIONS(5540),
    [anon_sym___restrict__] = ACTIONS(5540),
    [anon_sym__Atomic] = ACTIONS(5540),
    [anon_sym__Noreturn] = ACTIONS(5540),
    [anon_sym_noreturn] = ACTIONS(5540),
    [anon_sym_mutable] = ACTIONS(5540),
    [anon_sym_constinit] = ACTIONS(5540),
    [anon_sym_consteval] = ACTIONS(5540),
    [anon_sym_alignas] = ACTIONS(5540),
    [anon_sym__Alignas] = ACTIONS(5540),
    [sym_primitive_type] = ACTIONS(5540),
    [anon_sym_enum] = ACTIONS(5540),
    [anon_sym_class] = ACTIONS(5540),
    [anon_sym_struct] = ACTIONS(5540),
    [anon_sym_union] = ACTIONS(5540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5540),
    [anon_sym_let] = ACTIONS(5540),
    [anon_sym_This] = ACTIONS(5540),
    [anon_sym_decltype] = ACTIONS(5540),
    [sym_virtual] = ACTIONS(5540),
    [anon_sym_explicit] = ACTIONS(5540),
    [anon_sym_typename] = ACTIONS(5540),
    [anon_sym_template] = ACTIONS(5540),
    [anon_sym_operator] = ACTIONS(5540),
    [anon_sym_friend] = ACTIONS(5540),
    [anon_sym_public] = ACTIONS(5540),
    [anon_sym_private] = ACTIONS(5540),
    [anon_sym_protected] = ACTIONS(5540),
    [anon_sym_using] = ACTIONS(5540),
    [anon_sym_static_assert] = ACTIONS(5540),
    [anon_sym_precise] = ACTIONS(5540),
    [anon_sym_shared] = ACTIONS(5540),
    [anon_sym_groupshared] = ACTIONS(5540),
    [anon_sym_uniform] = ACTIONS(5540),
    [anon_sym_row_major] = ACTIONS(5540),
    [anon_sym_column_major] = ACTIONS(5540),
    [anon_sym_globallycoherent] = ACTIONS(5540),
    [anon_sym_centroid] = ACTIONS(5540),
    [anon_sym_noperspective] = ACTIONS(5540),
    [anon_sym_nointerpolation] = ACTIONS(5540),
    [anon_sym_sample] = ACTIONS(5540),
    [anon_sym_linear] = ACTIONS(5540),
    [anon_sym_snorm] = ACTIONS(5540),
    [anon_sym_unorm] = ACTIONS(5540),
    [anon_sym_point] = ACTIONS(5540),
    [anon_sym_line] = ACTIONS(5540),
    [anon_sym_triangleadj] = ACTIONS(5540),
    [anon_sym_lineadj] = ACTIONS(5540),
    [anon_sym_triangle] = ACTIONS(5540),
    [anon_sym_interface] = ACTIONS(5540),
    [anon_sym_extension] = ACTIONS(5540),
    [anon_sym___init] = ACTIONS(5540),
    [anon_sym___subscript] = ACTIONS(5540),
    [anon_sym_property] = ACTIONS(5540),
    [anon_sym_associatedtype] = ACTIONS(5540),
  },
  [1622] = {
    [sym_identifier] = ACTIONS(5544),
    [aux_sym_preproc_def_token1] = ACTIONS(5544),
    [aux_sym_preproc_if_token1] = ACTIONS(5544),
    [aux_sym_preproc_if_token2] = ACTIONS(5544),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5544),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5544),
    [aux_sym_preproc_else_token1] = ACTIONS(5544),
    [aux_sym_preproc_elif_token1] = ACTIONS(5544),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5544),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5544),
    [sym_preproc_directive] = ACTIONS(5544),
    [anon_sym_LPAREN2] = ACTIONS(5546),
    [anon_sym_TILDE] = ACTIONS(5546),
    [anon_sym_STAR] = ACTIONS(5546),
    [anon_sym_AMP_AMP] = ACTIONS(5546),
    [anon_sym_AMP] = ACTIONS(5544),
    [anon_sym___extension__] = ACTIONS(5544),
    [anon_sym_typedef] = ACTIONS(5544),
    [anon_sym_in] = ACTIONS(5544),
    [anon_sym_out] = ACTIONS(5544),
    [anon_sym_inout] = ACTIONS(5544),
    [anon_sym_extern] = ACTIONS(5544),
    [anon_sym___attribute__] = ACTIONS(5544),
    [anon_sym_COLON_COLON] = ACTIONS(5546),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5546),
    [anon_sym___declspec] = ACTIONS(5544),
    [anon_sym___based] = ACTIONS(5544),
    [anon_sym_signed] = ACTIONS(5544),
    [anon_sym_unsigned] = ACTIONS(5544),
    [anon_sym_long] = ACTIONS(5544),
    [anon_sym_short] = ACTIONS(5544),
    [anon_sym_LBRACK] = ACTIONS(5544),
    [anon_sym_static] = ACTIONS(5544),
    [anon_sym_register] = ACTIONS(5544),
    [anon_sym_inline] = ACTIONS(5544),
    [anon_sym___inline] = ACTIONS(5544),
    [anon_sym___inline__] = ACTIONS(5544),
    [anon_sym___forceinline] = ACTIONS(5544),
    [anon_sym_thread_local] = ACTIONS(5544),
    [anon_sym___thread] = ACTIONS(5544),
    [anon_sym_const] = ACTIONS(5544),
    [anon_sym_constexpr] = ACTIONS(5544),
    [anon_sym_volatile] = ACTIONS(5544),
    [anon_sym_restrict] = ACTIONS(5544),
    [anon_sym___restrict__] = ACTIONS(5544),
    [anon_sym__Atomic] = ACTIONS(5544),
    [anon_sym__Noreturn] = ACTIONS(5544),
    [anon_sym_noreturn] = ACTIONS(5544),
    [anon_sym_mutable] = ACTIONS(5544),
    [anon_sym_constinit] = ACTIONS(5544),
    [anon_sym_consteval] = ACTIONS(5544),
    [anon_sym_alignas] = ACTIONS(5544),
    [anon_sym__Alignas] = ACTIONS(5544),
    [sym_primitive_type] = ACTIONS(5544),
    [anon_sym_enum] = ACTIONS(5544),
    [anon_sym_class] = ACTIONS(5544),
    [anon_sym_struct] = ACTIONS(5544),
    [anon_sym_union] = ACTIONS(5544),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5544),
    [anon_sym_let] = ACTIONS(5544),
    [anon_sym_This] = ACTIONS(5544),
    [anon_sym_decltype] = ACTIONS(5544),
    [sym_virtual] = ACTIONS(5544),
    [anon_sym_explicit] = ACTIONS(5544),
    [anon_sym_typename] = ACTIONS(5544),
    [anon_sym_template] = ACTIONS(5544),
    [anon_sym_operator] = ACTIONS(5544),
    [anon_sym_friend] = ACTIONS(5544),
    [anon_sym_public] = ACTIONS(5544),
    [anon_sym_private] = ACTIONS(5544),
    [anon_sym_protected] = ACTIONS(5544),
    [anon_sym_using] = ACTIONS(5544),
    [anon_sym_static_assert] = ACTIONS(5544),
    [anon_sym_precise] = ACTIONS(5544),
    [anon_sym_shared] = ACTIONS(5544),
    [anon_sym_groupshared] = ACTIONS(5544),
    [anon_sym_uniform] = ACTIONS(5544),
    [anon_sym_row_major] = ACTIONS(5544),
    [anon_sym_column_major] = ACTIONS(5544),
    [anon_sym_globallycoherent] = ACTIONS(5544),
    [anon_sym_centroid] = ACTIONS(5544),
    [anon_sym_noperspective] = ACTIONS(5544),
    [anon_sym_nointerpolation] = ACTIONS(5544),
    [anon_sym_sample] = ACTIONS(5544),
    [anon_sym_linear] = ACTIONS(5544),
    [anon_sym_snorm] = ACTIONS(5544),
    [anon_sym_unorm] = ACTIONS(5544),
    [anon_sym_point] = ACTIONS(5544),
    [anon_sym_line] = ACTIONS(5544),
    [anon_sym_triangleadj] = ACTIONS(5544),
    [anon_sym_lineadj] = ACTIONS(5544),
    [anon_sym_triangle] = ACTIONS(5544),
    [anon_sym_interface] = ACTIONS(5544),
    [anon_sym_extension] = ACTIONS(5544),
    [anon_sym___init] = ACTIONS(5544),
    [anon_sym___subscript] = ACTIONS(5544),
    [anon_sym_property] = ACTIONS(5544),
    [anon_sym_associatedtype] = ACTIONS(5544),
  },
  [1623] = {
    [sym_identifier] = ACTIONS(5548),
    [aux_sym_preproc_def_token1] = ACTIONS(5548),
    [aux_sym_preproc_if_token1] = ACTIONS(5548),
    [aux_sym_preproc_if_token2] = ACTIONS(5548),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5548),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5548),
    [aux_sym_preproc_else_token1] = ACTIONS(5548),
    [aux_sym_preproc_elif_token1] = ACTIONS(5548),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5548),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5548),
    [sym_preproc_directive] = ACTIONS(5548),
    [anon_sym_LPAREN2] = ACTIONS(5550),
    [anon_sym_TILDE] = ACTIONS(5550),
    [anon_sym_STAR] = ACTIONS(5550),
    [anon_sym_AMP_AMP] = ACTIONS(5550),
    [anon_sym_AMP] = ACTIONS(5548),
    [anon_sym___extension__] = ACTIONS(5548),
    [anon_sym_typedef] = ACTIONS(5548),
    [anon_sym_in] = ACTIONS(5548),
    [anon_sym_out] = ACTIONS(5548),
    [anon_sym_inout] = ACTIONS(5548),
    [anon_sym_extern] = ACTIONS(5548),
    [anon_sym___attribute__] = ACTIONS(5548),
    [anon_sym_COLON_COLON] = ACTIONS(5550),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5550),
    [anon_sym___declspec] = ACTIONS(5548),
    [anon_sym___based] = ACTIONS(5548),
    [anon_sym_signed] = ACTIONS(5548),
    [anon_sym_unsigned] = ACTIONS(5548),
    [anon_sym_long] = ACTIONS(5548),
    [anon_sym_short] = ACTIONS(5548),
    [anon_sym_LBRACK] = ACTIONS(5548),
    [anon_sym_static] = ACTIONS(5548),
    [anon_sym_register] = ACTIONS(5548),
    [anon_sym_inline] = ACTIONS(5548),
    [anon_sym___inline] = ACTIONS(5548),
    [anon_sym___inline__] = ACTIONS(5548),
    [anon_sym___forceinline] = ACTIONS(5548),
    [anon_sym_thread_local] = ACTIONS(5548),
    [anon_sym___thread] = ACTIONS(5548),
    [anon_sym_const] = ACTIONS(5548),
    [anon_sym_constexpr] = ACTIONS(5548),
    [anon_sym_volatile] = ACTIONS(5548),
    [anon_sym_restrict] = ACTIONS(5548),
    [anon_sym___restrict__] = ACTIONS(5548),
    [anon_sym__Atomic] = ACTIONS(5548),
    [anon_sym__Noreturn] = ACTIONS(5548),
    [anon_sym_noreturn] = ACTIONS(5548),
    [anon_sym_mutable] = ACTIONS(5548),
    [anon_sym_constinit] = ACTIONS(5548),
    [anon_sym_consteval] = ACTIONS(5548),
    [anon_sym_alignas] = ACTIONS(5548),
    [anon_sym__Alignas] = ACTIONS(5548),
    [sym_primitive_type] = ACTIONS(5548),
    [anon_sym_enum] = ACTIONS(5548),
    [anon_sym_class] = ACTIONS(5548),
    [anon_sym_struct] = ACTIONS(5548),
    [anon_sym_union] = ACTIONS(5548),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5548),
    [anon_sym_let] = ACTIONS(5548),
    [anon_sym_This] = ACTIONS(5548),
    [anon_sym_decltype] = ACTIONS(5548),
    [sym_virtual] = ACTIONS(5548),
    [anon_sym_explicit] = ACTIONS(5548),
    [anon_sym_typename] = ACTIONS(5548),
    [anon_sym_template] = ACTIONS(5548),
    [anon_sym_operator] = ACTIONS(5548),
    [anon_sym_friend] = ACTIONS(5548),
    [anon_sym_public] = ACTIONS(5548),
    [anon_sym_private] = ACTIONS(5548),
    [anon_sym_protected] = ACTIONS(5548),
    [anon_sym_using] = ACTIONS(5548),
    [anon_sym_static_assert] = ACTIONS(5548),
    [anon_sym_precise] = ACTIONS(5548),
    [anon_sym_shared] = ACTIONS(5548),
    [anon_sym_groupshared] = ACTIONS(5548),
    [anon_sym_uniform] = ACTIONS(5548),
    [anon_sym_row_major] = ACTIONS(5548),
    [anon_sym_column_major] = ACTIONS(5548),
    [anon_sym_globallycoherent] = ACTIONS(5548),
    [anon_sym_centroid] = ACTIONS(5548),
    [anon_sym_noperspective] = ACTIONS(5548),
    [anon_sym_nointerpolation] = ACTIONS(5548),
    [anon_sym_sample] = ACTIONS(5548),
    [anon_sym_linear] = ACTIONS(5548),
    [anon_sym_snorm] = ACTIONS(5548),
    [anon_sym_unorm] = ACTIONS(5548),
    [anon_sym_point] = ACTIONS(5548),
    [anon_sym_line] = ACTIONS(5548),
    [anon_sym_triangleadj] = ACTIONS(5548),
    [anon_sym_lineadj] = ACTIONS(5548),
    [anon_sym_triangle] = ACTIONS(5548),
    [anon_sym_interface] = ACTIONS(5548),
    [anon_sym_extension] = ACTIONS(5548),
    [anon_sym___init] = ACTIONS(5548),
    [anon_sym___subscript] = ACTIONS(5548),
    [anon_sym_property] = ACTIONS(5548),
    [anon_sym_associatedtype] = ACTIONS(5548),
  },
  [1624] = {
    [sym_identifier] = ACTIONS(5552),
    [aux_sym_preproc_def_token1] = ACTIONS(5552),
    [aux_sym_preproc_if_token1] = ACTIONS(5552),
    [aux_sym_preproc_if_token2] = ACTIONS(5552),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5552),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5552),
    [aux_sym_preproc_else_token1] = ACTIONS(5552),
    [aux_sym_preproc_elif_token1] = ACTIONS(5552),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5552),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5552),
    [sym_preproc_directive] = ACTIONS(5552),
    [anon_sym_LPAREN2] = ACTIONS(5554),
    [anon_sym_TILDE] = ACTIONS(5554),
    [anon_sym_STAR] = ACTIONS(5554),
    [anon_sym_AMP_AMP] = ACTIONS(5554),
    [anon_sym_AMP] = ACTIONS(5552),
    [anon_sym___extension__] = ACTIONS(5552),
    [anon_sym_typedef] = ACTIONS(5552),
    [anon_sym_in] = ACTIONS(5552),
    [anon_sym_out] = ACTIONS(5552),
    [anon_sym_inout] = ACTIONS(5552),
    [anon_sym_extern] = ACTIONS(5552),
    [anon_sym___attribute__] = ACTIONS(5552),
    [anon_sym_COLON_COLON] = ACTIONS(5554),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5554),
    [anon_sym___declspec] = ACTIONS(5552),
    [anon_sym___based] = ACTIONS(5552),
    [anon_sym_signed] = ACTIONS(5552),
    [anon_sym_unsigned] = ACTIONS(5552),
    [anon_sym_long] = ACTIONS(5552),
    [anon_sym_short] = ACTIONS(5552),
    [anon_sym_LBRACK] = ACTIONS(5552),
    [anon_sym_static] = ACTIONS(5552),
    [anon_sym_register] = ACTIONS(5552),
    [anon_sym_inline] = ACTIONS(5552),
    [anon_sym___inline] = ACTIONS(5552),
    [anon_sym___inline__] = ACTIONS(5552),
    [anon_sym___forceinline] = ACTIONS(5552),
    [anon_sym_thread_local] = ACTIONS(5552),
    [anon_sym___thread] = ACTIONS(5552),
    [anon_sym_const] = ACTIONS(5552),
    [anon_sym_constexpr] = ACTIONS(5552),
    [anon_sym_volatile] = ACTIONS(5552),
    [anon_sym_restrict] = ACTIONS(5552),
    [anon_sym___restrict__] = ACTIONS(5552),
    [anon_sym__Atomic] = ACTIONS(5552),
    [anon_sym__Noreturn] = ACTIONS(5552),
    [anon_sym_noreturn] = ACTIONS(5552),
    [anon_sym_mutable] = ACTIONS(5552),
    [anon_sym_constinit] = ACTIONS(5552),
    [anon_sym_consteval] = ACTIONS(5552),
    [anon_sym_alignas] = ACTIONS(5552),
    [anon_sym__Alignas] = ACTIONS(5552),
    [sym_primitive_type] = ACTIONS(5552),
    [anon_sym_enum] = ACTIONS(5552),
    [anon_sym_class] = ACTIONS(5552),
    [anon_sym_struct] = ACTIONS(5552),
    [anon_sym_union] = ACTIONS(5552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5552),
    [anon_sym_let] = ACTIONS(5552),
    [anon_sym_This] = ACTIONS(5552),
    [anon_sym_decltype] = ACTIONS(5552),
    [sym_virtual] = ACTIONS(5552),
    [anon_sym_explicit] = ACTIONS(5552),
    [anon_sym_typename] = ACTIONS(5552),
    [anon_sym_template] = ACTIONS(5552),
    [anon_sym_operator] = ACTIONS(5552),
    [anon_sym_friend] = ACTIONS(5552),
    [anon_sym_public] = ACTIONS(5552),
    [anon_sym_private] = ACTIONS(5552),
    [anon_sym_protected] = ACTIONS(5552),
    [anon_sym_using] = ACTIONS(5552),
    [anon_sym_static_assert] = ACTIONS(5552),
    [anon_sym_precise] = ACTIONS(5552),
    [anon_sym_shared] = ACTIONS(5552),
    [anon_sym_groupshared] = ACTIONS(5552),
    [anon_sym_uniform] = ACTIONS(5552),
    [anon_sym_row_major] = ACTIONS(5552),
    [anon_sym_column_major] = ACTIONS(5552),
    [anon_sym_globallycoherent] = ACTIONS(5552),
    [anon_sym_centroid] = ACTIONS(5552),
    [anon_sym_noperspective] = ACTIONS(5552),
    [anon_sym_nointerpolation] = ACTIONS(5552),
    [anon_sym_sample] = ACTIONS(5552),
    [anon_sym_linear] = ACTIONS(5552),
    [anon_sym_snorm] = ACTIONS(5552),
    [anon_sym_unorm] = ACTIONS(5552),
    [anon_sym_point] = ACTIONS(5552),
    [anon_sym_line] = ACTIONS(5552),
    [anon_sym_triangleadj] = ACTIONS(5552),
    [anon_sym_lineadj] = ACTIONS(5552),
    [anon_sym_triangle] = ACTIONS(5552),
    [anon_sym_interface] = ACTIONS(5552),
    [anon_sym_extension] = ACTIONS(5552),
    [anon_sym___init] = ACTIONS(5552),
    [anon_sym___subscript] = ACTIONS(5552),
    [anon_sym_property] = ACTIONS(5552),
    [anon_sym_associatedtype] = ACTIONS(5552),
  },
  [1625] = {
    [sym_identifier] = ACTIONS(5556),
    [aux_sym_preproc_def_token1] = ACTIONS(5556),
    [aux_sym_preproc_if_token1] = ACTIONS(5556),
    [aux_sym_preproc_if_token2] = ACTIONS(5556),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5556),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5556),
    [aux_sym_preproc_else_token1] = ACTIONS(5556),
    [aux_sym_preproc_elif_token1] = ACTIONS(5556),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5556),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5556),
    [sym_preproc_directive] = ACTIONS(5556),
    [anon_sym_LPAREN2] = ACTIONS(5558),
    [anon_sym_TILDE] = ACTIONS(5558),
    [anon_sym_STAR] = ACTIONS(5558),
    [anon_sym_AMP_AMP] = ACTIONS(5558),
    [anon_sym_AMP] = ACTIONS(5556),
    [anon_sym___extension__] = ACTIONS(5556),
    [anon_sym_typedef] = ACTIONS(5556),
    [anon_sym_in] = ACTIONS(5556),
    [anon_sym_out] = ACTIONS(5556),
    [anon_sym_inout] = ACTIONS(5556),
    [anon_sym_extern] = ACTIONS(5556),
    [anon_sym___attribute__] = ACTIONS(5556),
    [anon_sym_COLON_COLON] = ACTIONS(5558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5558),
    [anon_sym___declspec] = ACTIONS(5556),
    [anon_sym___based] = ACTIONS(5556),
    [anon_sym_signed] = ACTIONS(5556),
    [anon_sym_unsigned] = ACTIONS(5556),
    [anon_sym_long] = ACTIONS(5556),
    [anon_sym_short] = ACTIONS(5556),
    [anon_sym_LBRACK] = ACTIONS(5556),
    [anon_sym_static] = ACTIONS(5556),
    [anon_sym_register] = ACTIONS(5556),
    [anon_sym_inline] = ACTIONS(5556),
    [anon_sym___inline] = ACTIONS(5556),
    [anon_sym___inline__] = ACTIONS(5556),
    [anon_sym___forceinline] = ACTIONS(5556),
    [anon_sym_thread_local] = ACTIONS(5556),
    [anon_sym___thread] = ACTIONS(5556),
    [anon_sym_const] = ACTIONS(5556),
    [anon_sym_constexpr] = ACTIONS(5556),
    [anon_sym_volatile] = ACTIONS(5556),
    [anon_sym_restrict] = ACTIONS(5556),
    [anon_sym___restrict__] = ACTIONS(5556),
    [anon_sym__Atomic] = ACTIONS(5556),
    [anon_sym__Noreturn] = ACTIONS(5556),
    [anon_sym_noreturn] = ACTIONS(5556),
    [anon_sym_mutable] = ACTIONS(5556),
    [anon_sym_constinit] = ACTIONS(5556),
    [anon_sym_consteval] = ACTIONS(5556),
    [anon_sym_alignas] = ACTIONS(5556),
    [anon_sym__Alignas] = ACTIONS(5556),
    [sym_primitive_type] = ACTIONS(5556),
    [anon_sym_enum] = ACTIONS(5556),
    [anon_sym_class] = ACTIONS(5556),
    [anon_sym_struct] = ACTIONS(5556),
    [anon_sym_union] = ACTIONS(5556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5556),
    [anon_sym_let] = ACTIONS(5556),
    [anon_sym_This] = ACTIONS(5556),
    [anon_sym_decltype] = ACTIONS(5556),
    [sym_virtual] = ACTIONS(5556),
    [anon_sym_explicit] = ACTIONS(5556),
    [anon_sym_typename] = ACTIONS(5556),
    [anon_sym_template] = ACTIONS(5556),
    [anon_sym_operator] = ACTIONS(5556),
    [anon_sym_friend] = ACTIONS(5556),
    [anon_sym_public] = ACTIONS(5556),
    [anon_sym_private] = ACTIONS(5556),
    [anon_sym_protected] = ACTIONS(5556),
    [anon_sym_using] = ACTIONS(5556),
    [anon_sym_static_assert] = ACTIONS(5556),
    [anon_sym_precise] = ACTIONS(5556),
    [anon_sym_shared] = ACTIONS(5556),
    [anon_sym_groupshared] = ACTIONS(5556),
    [anon_sym_uniform] = ACTIONS(5556),
    [anon_sym_row_major] = ACTIONS(5556),
    [anon_sym_column_major] = ACTIONS(5556),
    [anon_sym_globallycoherent] = ACTIONS(5556),
    [anon_sym_centroid] = ACTIONS(5556),
    [anon_sym_noperspective] = ACTIONS(5556),
    [anon_sym_nointerpolation] = ACTIONS(5556),
    [anon_sym_sample] = ACTIONS(5556),
    [anon_sym_linear] = ACTIONS(5556),
    [anon_sym_snorm] = ACTIONS(5556),
    [anon_sym_unorm] = ACTIONS(5556),
    [anon_sym_point] = ACTIONS(5556),
    [anon_sym_line] = ACTIONS(5556),
    [anon_sym_triangleadj] = ACTIONS(5556),
    [anon_sym_lineadj] = ACTIONS(5556),
    [anon_sym_triangle] = ACTIONS(5556),
    [anon_sym_interface] = ACTIONS(5556),
    [anon_sym_extension] = ACTIONS(5556),
    [anon_sym___init] = ACTIONS(5556),
    [anon_sym___subscript] = ACTIONS(5556),
    [anon_sym_property] = ACTIONS(5556),
    [anon_sym_associatedtype] = ACTIONS(5556),
  },
  [1626] = {
    [sym_identifier] = ACTIONS(5560),
    [aux_sym_preproc_def_token1] = ACTIONS(5560),
    [aux_sym_preproc_if_token1] = ACTIONS(5560),
    [aux_sym_preproc_if_token2] = ACTIONS(5560),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5560),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5560),
    [aux_sym_preproc_else_token1] = ACTIONS(5560),
    [aux_sym_preproc_elif_token1] = ACTIONS(5560),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5560),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5560),
    [sym_preproc_directive] = ACTIONS(5560),
    [anon_sym_LPAREN2] = ACTIONS(5562),
    [anon_sym_TILDE] = ACTIONS(5562),
    [anon_sym_STAR] = ACTIONS(5562),
    [anon_sym_AMP_AMP] = ACTIONS(5562),
    [anon_sym_AMP] = ACTIONS(5560),
    [anon_sym___extension__] = ACTIONS(5560),
    [anon_sym_typedef] = ACTIONS(5560),
    [anon_sym_in] = ACTIONS(5560),
    [anon_sym_out] = ACTIONS(5560),
    [anon_sym_inout] = ACTIONS(5560),
    [anon_sym_extern] = ACTIONS(5560),
    [anon_sym___attribute__] = ACTIONS(5560),
    [anon_sym_COLON_COLON] = ACTIONS(5562),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5562),
    [anon_sym___declspec] = ACTIONS(5560),
    [anon_sym___based] = ACTIONS(5560),
    [anon_sym_signed] = ACTIONS(5560),
    [anon_sym_unsigned] = ACTIONS(5560),
    [anon_sym_long] = ACTIONS(5560),
    [anon_sym_short] = ACTIONS(5560),
    [anon_sym_LBRACK] = ACTIONS(5560),
    [anon_sym_static] = ACTIONS(5560),
    [anon_sym_register] = ACTIONS(5560),
    [anon_sym_inline] = ACTIONS(5560),
    [anon_sym___inline] = ACTIONS(5560),
    [anon_sym___inline__] = ACTIONS(5560),
    [anon_sym___forceinline] = ACTIONS(5560),
    [anon_sym_thread_local] = ACTIONS(5560),
    [anon_sym___thread] = ACTIONS(5560),
    [anon_sym_const] = ACTIONS(5560),
    [anon_sym_constexpr] = ACTIONS(5560),
    [anon_sym_volatile] = ACTIONS(5560),
    [anon_sym_restrict] = ACTIONS(5560),
    [anon_sym___restrict__] = ACTIONS(5560),
    [anon_sym__Atomic] = ACTIONS(5560),
    [anon_sym__Noreturn] = ACTIONS(5560),
    [anon_sym_noreturn] = ACTIONS(5560),
    [anon_sym_mutable] = ACTIONS(5560),
    [anon_sym_constinit] = ACTIONS(5560),
    [anon_sym_consteval] = ACTIONS(5560),
    [anon_sym_alignas] = ACTIONS(5560),
    [anon_sym__Alignas] = ACTIONS(5560),
    [sym_primitive_type] = ACTIONS(5560),
    [anon_sym_enum] = ACTIONS(5560),
    [anon_sym_class] = ACTIONS(5560),
    [anon_sym_struct] = ACTIONS(5560),
    [anon_sym_union] = ACTIONS(5560),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5560),
    [anon_sym_let] = ACTIONS(5560),
    [anon_sym_This] = ACTIONS(5560),
    [anon_sym_decltype] = ACTIONS(5560),
    [sym_virtual] = ACTIONS(5560),
    [anon_sym_explicit] = ACTIONS(5560),
    [anon_sym_typename] = ACTIONS(5560),
    [anon_sym_template] = ACTIONS(5560),
    [anon_sym_operator] = ACTIONS(5560),
    [anon_sym_friend] = ACTIONS(5560),
    [anon_sym_public] = ACTIONS(5560),
    [anon_sym_private] = ACTIONS(5560),
    [anon_sym_protected] = ACTIONS(5560),
    [anon_sym_using] = ACTIONS(5560),
    [anon_sym_static_assert] = ACTIONS(5560),
    [anon_sym_precise] = ACTIONS(5560),
    [anon_sym_shared] = ACTIONS(5560),
    [anon_sym_groupshared] = ACTIONS(5560),
    [anon_sym_uniform] = ACTIONS(5560),
    [anon_sym_row_major] = ACTIONS(5560),
    [anon_sym_column_major] = ACTIONS(5560),
    [anon_sym_globallycoherent] = ACTIONS(5560),
    [anon_sym_centroid] = ACTIONS(5560),
    [anon_sym_noperspective] = ACTIONS(5560),
    [anon_sym_nointerpolation] = ACTIONS(5560),
    [anon_sym_sample] = ACTIONS(5560),
    [anon_sym_linear] = ACTIONS(5560),
    [anon_sym_snorm] = ACTIONS(5560),
    [anon_sym_unorm] = ACTIONS(5560),
    [anon_sym_point] = ACTIONS(5560),
    [anon_sym_line] = ACTIONS(5560),
    [anon_sym_triangleadj] = ACTIONS(5560),
    [anon_sym_lineadj] = ACTIONS(5560),
    [anon_sym_triangle] = ACTIONS(5560),
    [anon_sym_interface] = ACTIONS(5560),
    [anon_sym_extension] = ACTIONS(5560),
    [anon_sym___init] = ACTIONS(5560),
    [anon_sym___subscript] = ACTIONS(5560),
    [anon_sym_property] = ACTIONS(5560),
    [anon_sym_associatedtype] = ACTIONS(5560),
  },
  [1627] = {
    [sym_identifier] = ACTIONS(5564),
    [aux_sym_preproc_def_token1] = ACTIONS(5564),
    [aux_sym_preproc_if_token1] = ACTIONS(5564),
    [aux_sym_preproc_if_token2] = ACTIONS(5564),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5564),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5564),
    [aux_sym_preproc_else_token1] = ACTIONS(5564),
    [aux_sym_preproc_elif_token1] = ACTIONS(5564),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5564),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5564),
    [sym_preproc_directive] = ACTIONS(5564),
    [anon_sym_LPAREN2] = ACTIONS(5566),
    [anon_sym_TILDE] = ACTIONS(5566),
    [anon_sym_STAR] = ACTIONS(5566),
    [anon_sym_AMP_AMP] = ACTIONS(5566),
    [anon_sym_AMP] = ACTIONS(5564),
    [anon_sym___extension__] = ACTIONS(5564),
    [anon_sym_typedef] = ACTIONS(5564),
    [anon_sym_in] = ACTIONS(5564),
    [anon_sym_out] = ACTIONS(5564),
    [anon_sym_inout] = ACTIONS(5564),
    [anon_sym_extern] = ACTIONS(5564),
    [anon_sym___attribute__] = ACTIONS(5564),
    [anon_sym_COLON_COLON] = ACTIONS(5566),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5566),
    [anon_sym___declspec] = ACTIONS(5564),
    [anon_sym___based] = ACTIONS(5564),
    [anon_sym_signed] = ACTIONS(5564),
    [anon_sym_unsigned] = ACTIONS(5564),
    [anon_sym_long] = ACTIONS(5564),
    [anon_sym_short] = ACTIONS(5564),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_static] = ACTIONS(5564),
    [anon_sym_register] = ACTIONS(5564),
    [anon_sym_inline] = ACTIONS(5564),
    [anon_sym___inline] = ACTIONS(5564),
    [anon_sym___inline__] = ACTIONS(5564),
    [anon_sym___forceinline] = ACTIONS(5564),
    [anon_sym_thread_local] = ACTIONS(5564),
    [anon_sym___thread] = ACTIONS(5564),
    [anon_sym_const] = ACTIONS(5564),
    [anon_sym_constexpr] = ACTIONS(5564),
    [anon_sym_volatile] = ACTIONS(5564),
    [anon_sym_restrict] = ACTIONS(5564),
    [anon_sym___restrict__] = ACTIONS(5564),
    [anon_sym__Atomic] = ACTIONS(5564),
    [anon_sym__Noreturn] = ACTIONS(5564),
    [anon_sym_noreturn] = ACTIONS(5564),
    [anon_sym_mutable] = ACTIONS(5564),
    [anon_sym_constinit] = ACTIONS(5564),
    [anon_sym_consteval] = ACTIONS(5564),
    [anon_sym_alignas] = ACTIONS(5564),
    [anon_sym__Alignas] = ACTIONS(5564),
    [sym_primitive_type] = ACTIONS(5564),
    [anon_sym_enum] = ACTIONS(5564),
    [anon_sym_class] = ACTIONS(5564),
    [anon_sym_struct] = ACTIONS(5564),
    [anon_sym_union] = ACTIONS(5564),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5564),
    [anon_sym_let] = ACTIONS(5564),
    [anon_sym_This] = ACTIONS(5564),
    [anon_sym_decltype] = ACTIONS(5564),
    [sym_virtual] = ACTIONS(5564),
    [anon_sym_explicit] = ACTIONS(5564),
    [anon_sym_typename] = ACTIONS(5564),
    [anon_sym_template] = ACTIONS(5564),
    [anon_sym_operator] = ACTIONS(5564),
    [anon_sym_friend] = ACTIONS(5564),
    [anon_sym_public] = ACTIONS(5564),
    [anon_sym_private] = ACTIONS(5564),
    [anon_sym_protected] = ACTIONS(5564),
    [anon_sym_using] = ACTIONS(5564),
    [anon_sym_static_assert] = ACTIONS(5564),
    [anon_sym_precise] = ACTIONS(5564),
    [anon_sym_shared] = ACTIONS(5564),
    [anon_sym_groupshared] = ACTIONS(5564),
    [anon_sym_uniform] = ACTIONS(5564),
    [anon_sym_row_major] = ACTIONS(5564),
    [anon_sym_column_major] = ACTIONS(5564),
    [anon_sym_globallycoherent] = ACTIONS(5564),
    [anon_sym_centroid] = ACTIONS(5564),
    [anon_sym_noperspective] = ACTIONS(5564),
    [anon_sym_nointerpolation] = ACTIONS(5564),
    [anon_sym_sample] = ACTIONS(5564),
    [anon_sym_linear] = ACTIONS(5564),
    [anon_sym_snorm] = ACTIONS(5564),
    [anon_sym_unorm] = ACTIONS(5564),
    [anon_sym_point] = ACTIONS(5564),
    [anon_sym_line] = ACTIONS(5564),
    [anon_sym_triangleadj] = ACTIONS(5564),
    [anon_sym_lineadj] = ACTIONS(5564),
    [anon_sym_triangle] = ACTIONS(5564),
    [anon_sym_interface] = ACTIONS(5564),
    [anon_sym_extension] = ACTIONS(5564),
    [anon_sym___init] = ACTIONS(5564),
    [anon_sym___subscript] = ACTIONS(5564),
    [anon_sym_property] = ACTIONS(5564),
    [anon_sym_associatedtype] = ACTIONS(5564),
  },
  [1628] = {
    [sym_identifier] = ACTIONS(5568),
    [aux_sym_preproc_def_token1] = ACTIONS(5568),
    [aux_sym_preproc_if_token1] = ACTIONS(5568),
    [aux_sym_preproc_if_token2] = ACTIONS(5568),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5568),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5568),
    [aux_sym_preproc_else_token1] = ACTIONS(5568),
    [aux_sym_preproc_elif_token1] = ACTIONS(5568),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5568),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5568),
    [sym_preproc_directive] = ACTIONS(5568),
    [anon_sym_LPAREN2] = ACTIONS(5570),
    [anon_sym_TILDE] = ACTIONS(5570),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_AMP_AMP] = ACTIONS(5570),
    [anon_sym_AMP] = ACTIONS(5568),
    [anon_sym___extension__] = ACTIONS(5568),
    [anon_sym_typedef] = ACTIONS(5568),
    [anon_sym_in] = ACTIONS(5568),
    [anon_sym_out] = ACTIONS(5568),
    [anon_sym_inout] = ACTIONS(5568),
    [anon_sym_extern] = ACTIONS(5568),
    [anon_sym___attribute__] = ACTIONS(5568),
    [anon_sym_COLON_COLON] = ACTIONS(5570),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5570),
    [anon_sym___declspec] = ACTIONS(5568),
    [anon_sym___based] = ACTIONS(5568),
    [anon_sym_signed] = ACTIONS(5568),
    [anon_sym_unsigned] = ACTIONS(5568),
    [anon_sym_long] = ACTIONS(5568),
    [anon_sym_short] = ACTIONS(5568),
    [anon_sym_LBRACK] = ACTIONS(5568),
    [anon_sym_static] = ACTIONS(5568),
    [anon_sym_register] = ACTIONS(5568),
    [anon_sym_inline] = ACTIONS(5568),
    [anon_sym___inline] = ACTIONS(5568),
    [anon_sym___inline__] = ACTIONS(5568),
    [anon_sym___forceinline] = ACTIONS(5568),
    [anon_sym_thread_local] = ACTIONS(5568),
    [anon_sym___thread] = ACTIONS(5568),
    [anon_sym_const] = ACTIONS(5568),
    [anon_sym_constexpr] = ACTIONS(5568),
    [anon_sym_volatile] = ACTIONS(5568),
    [anon_sym_restrict] = ACTIONS(5568),
    [anon_sym___restrict__] = ACTIONS(5568),
    [anon_sym__Atomic] = ACTIONS(5568),
    [anon_sym__Noreturn] = ACTIONS(5568),
    [anon_sym_noreturn] = ACTIONS(5568),
    [anon_sym_mutable] = ACTIONS(5568),
    [anon_sym_constinit] = ACTIONS(5568),
    [anon_sym_consteval] = ACTIONS(5568),
    [anon_sym_alignas] = ACTIONS(5568),
    [anon_sym__Alignas] = ACTIONS(5568),
    [sym_primitive_type] = ACTIONS(5568),
    [anon_sym_enum] = ACTIONS(5568),
    [anon_sym_class] = ACTIONS(5568),
    [anon_sym_struct] = ACTIONS(5568),
    [anon_sym_union] = ACTIONS(5568),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5568),
    [anon_sym_let] = ACTIONS(5568),
    [anon_sym_This] = ACTIONS(5568),
    [anon_sym_decltype] = ACTIONS(5568),
    [sym_virtual] = ACTIONS(5568),
    [anon_sym_explicit] = ACTIONS(5568),
    [anon_sym_typename] = ACTIONS(5568),
    [anon_sym_template] = ACTIONS(5568),
    [anon_sym_operator] = ACTIONS(5568),
    [anon_sym_friend] = ACTIONS(5568),
    [anon_sym_public] = ACTIONS(5568),
    [anon_sym_private] = ACTIONS(5568),
    [anon_sym_protected] = ACTIONS(5568),
    [anon_sym_using] = ACTIONS(5568),
    [anon_sym_static_assert] = ACTIONS(5568),
    [anon_sym_precise] = ACTIONS(5568),
    [anon_sym_shared] = ACTIONS(5568),
    [anon_sym_groupshared] = ACTIONS(5568),
    [anon_sym_uniform] = ACTIONS(5568),
    [anon_sym_row_major] = ACTIONS(5568),
    [anon_sym_column_major] = ACTIONS(5568),
    [anon_sym_globallycoherent] = ACTIONS(5568),
    [anon_sym_centroid] = ACTIONS(5568),
    [anon_sym_noperspective] = ACTIONS(5568),
    [anon_sym_nointerpolation] = ACTIONS(5568),
    [anon_sym_sample] = ACTIONS(5568),
    [anon_sym_linear] = ACTIONS(5568),
    [anon_sym_snorm] = ACTIONS(5568),
    [anon_sym_unorm] = ACTIONS(5568),
    [anon_sym_point] = ACTIONS(5568),
    [anon_sym_line] = ACTIONS(5568),
    [anon_sym_triangleadj] = ACTIONS(5568),
    [anon_sym_lineadj] = ACTIONS(5568),
    [anon_sym_triangle] = ACTIONS(5568),
    [anon_sym_interface] = ACTIONS(5568),
    [anon_sym_extension] = ACTIONS(5568),
    [anon_sym___init] = ACTIONS(5568),
    [anon_sym___subscript] = ACTIONS(5568),
    [anon_sym_property] = ACTIONS(5568),
    [anon_sym_associatedtype] = ACTIONS(5568),
  },
  [1629] = {
    [sym_identifier] = ACTIONS(5572),
    [aux_sym_preproc_def_token1] = ACTIONS(5572),
    [aux_sym_preproc_if_token1] = ACTIONS(5572),
    [aux_sym_preproc_if_token2] = ACTIONS(5572),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5572),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5572),
    [aux_sym_preproc_else_token1] = ACTIONS(5572),
    [aux_sym_preproc_elif_token1] = ACTIONS(5572),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5572),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5572),
    [sym_preproc_directive] = ACTIONS(5572),
    [anon_sym_LPAREN2] = ACTIONS(5574),
    [anon_sym_TILDE] = ACTIONS(5574),
    [anon_sym_STAR] = ACTIONS(5574),
    [anon_sym_AMP_AMP] = ACTIONS(5574),
    [anon_sym_AMP] = ACTIONS(5572),
    [anon_sym___extension__] = ACTIONS(5572),
    [anon_sym_typedef] = ACTIONS(5572),
    [anon_sym_in] = ACTIONS(5572),
    [anon_sym_out] = ACTIONS(5572),
    [anon_sym_inout] = ACTIONS(5572),
    [anon_sym_extern] = ACTIONS(5572),
    [anon_sym___attribute__] = ACTIONS(5572),
    [anon_sym_COLON_COLON] = ACTIONS(5574),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5574),
    [anon_sym___declspec] = ACTIONS(5572),
    [anon_sym___based] = ACTIONS(5572),
    [anon_sym_signed] = ACTIONS(5572),
    [anon_sym_unsigned] = ACTIONS(5572),
    [anon_sym_long] = ACTIONS(5572),
    [anon_sym_short] = ACTIONS(5572),
    [anon_sym_LBRACK] = ACTIONS(5572),
    [anon_sym_static] = ACTIONS(5572),
    [anon_sym_register] = ACTIONS(5572),
    [anon_sym_inline] = ACTIONS(5572),
    [anon_sym___inline] = ACTIONS(5572),
    [anon_sym___inline__] = ACTIONS(5572),
    [anon_sym___forceinline] = ACTIONS(5572),
    [anon_sym_thread_local] = ACTIONS(5572),
    [anon_sym___thread] = ACTIONS(5572),
    [anon_sym_const] = ACTIONS(5572),
    [anon_sym_constexpr] = ACTIONS(5572),
    [anon_sym_volatile] = ACTIONS(5572),
    [anon_sym_restrict] = ACTIONS(5572),
    [anon_sym___restrict__] = ACTIONS(5572),
    [anon_sym__Atomic] = ACTIONS(5572),
    [anon_sym__Noreturn] = ACTIONS(5572),
    [anon_sym_noreturn] = ACTIONS(5572),
    [anon_sym_mutable] = ACTIONS(5572),
    [anon_sym_constinit] = ACTIONS(5572),
    [anon_sym_consteval] = ACTIONS(5572),
    [anon_sym_alignas] = ACTIONS(5572),
    [anon_sym__Alignas] = ACTIONS(5572),
    [sym_primitive_type] = ACTIONS(5572),
    [anon_sym_enum] = ACTIONS(5572),
    [anon_sym_class] = ACTIONS(5572),
    [anon_sym_struct] = ACTIONS(5572),
    [anon_sym_union] = ACTIONS(5572),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5572),
    [anon_sym_let] = ACTIONS(5572),
    [anon_sym_This] = ACTIONS(5572),
    [anon_sym_decltype] = ACTIONS(5572),
    [sym_virtual] = ACTIONS(5572),
    [anon_sym_explicit] = ACTIONS(5572),
    [anon_sym_typename] = ACTIONS(5572),
    [anon_sym_template] = ACTIONS(5572),
    [anon_sym_operator] = ACTIONS(5572),
    [anon_sym_friend] = ACTIONS(5572),
    [anon_sym_public] = ACTIONS(5572),
    [anon_sym_private] = ACTIONS(5572),
    [anon_sym_protected] = ACTIONS(5572),
    [anon_sym_using] = ACTIONS(5572),
    [anon_sym_static_assert] = ACTIONS(5572),
    [anon_sym_precise] = ACTIONS(5572),
    [anon_sym_shared] = ACTIONS(5572),
    [anon_sym_groupshared] = ACTIONS(5572),
    [anon_sym_uniform] = ACTIONS(5572),
    [anon_sym_row_major] = ACTIONS(5572),
    [anon_sym_column_major] = ACTIONS(5572),
    [anon_sym_globallycoherent] = ACTIONS(5572),
    [anon_sym_centroid] = ACTIONS(5572),
    [anon_sym_noperspective] = ACTIONS(5572),
    [anon_sym_nointerpolation] = ACTIONS(5572),
    [anon_sym_sample] = ACTIONS(5572),
    [anon_sym_linear] = ACTIONS(5572),
    [anon_sym_snorm] = ACTIONS(5572),
    [anon_sym_unorm] = ACTIONS(5572),
    [anon_sym_point] = ACTIONS(5572),
    [anon_sym_line] = ACTIONS(5572),
    [anon_sym_triangleadj] = ACTIONS(5572),
    [anon_sym_lineadj] = ACTIONS(5572),
    [anon_sym_triangle] = ACTIONS(5572),
    [anon_sym_interface] = ACTIONS(5572),
    [anon_sym_extension] = ACTIONS(5572),
    [anon_sym___init] = ACTIONS(5572),
    [anon_sym___subscript] = ACTIONS(5572),
    [anon_sym_property] = ACTIONS(5572),
    [anon_sym_associatedtype] = ACTIONS(5572),
  },
  [1630] = {
    [sym_expression] = STATE(4138),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym__unary_left_fold] = STATE(10708),
    [sym__unary_right_fold] = STATE(10705),
    [sym__binary_fold] = STATE(10700),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2281),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1631] = {
    [sym_identifier] = ACTIONS(5572),
    [aux_sym_preproc_def_token1] = ACTIONS(5572),
    [aux_sym_preproc_if_token1] = ACTIONS(5572),
    [aux_sym_preproc_if_token2] = ACTIONS(5572),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5572),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5572),
    [aux_sym_preproc_else_token1] = ACTIONS(5572),
    [aux_sym_preproc_elif_token1] = ACTIONS(5572),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5572),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5572),
    [sym_preproc_directive] = ACTIONS(5572),
    [anon_sym_LPAREN2] = ACTIONS(5574),
    [anon_sym_TILDE] = ACTIONS(5574),
    [anon_sym_STAR] = ACTIONS(5574),
    [anon_sym_AMP_AMP] = ACTIONS(5574),
    [anon_sym_AMP] = ACTIONS(5572),
    [anon_sym___extension__] = ACTIONS(5572),
    [anon_sym_typedef] = ACTIONS(5572),
    [anon_sym_in] = ACTIONS(5572),
    [anon_sym_out] = ACTIONS(5572),
    [anon_sym_inout] = ACTIONS(5572),
    [anon_sym_extern] = ACTIONS(5572),
    [anon_sym___attribute__] = ACTIONS(5572),
    [anon_sym_COLON_COLON] = ACTIONS(5574),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5574),
    [anon_sym___declspec] = ACTIONS(5572),
    [anon_sym___based] = ACTIONS(5572),
    [anon_sym_signed] = ACTIONS(5572),
    [anon_sym_unsigned] = ACTIONS(5572),
    [anon_sym_long] = ACTIONS(5572),
    [anon_sym_short] = ACTIONS(5572),
    [anon_sym_LBRACK] = ACTIONS(5572),
    [anon_sym_static] = ACTIONS(5572),
    [anon_sym_register] = ACTIONS(5572),
    [anon_sym_inline] = ACTIONS(5572),
    [anon_sym___inline] = ACTIONS(5572),
    [anon_sym___inline__] = ACTIONS(5572),
    [anon_sym___forceinline] = ACTIONS(5572),
    [anon_sym_thread_local] = ACTIONS(5572),
    [anon_sym___thread] = ACTIONS(5572),
    [anon_sym_const] = ACTIONS(5572),
    [anon_sym_constexpr] = ACTIONS(5572),
    [anon_sym_volatile] = ACTIONS(5572),
    [anon_sym_restrict] = ACTIONS(5572),
    [anon_sym___restrict__] = ACTIONS(5572),
    [anon_sym__Atomic] = ACTIONS(5572),
    [anon_sym__Noreturn] = ACTIONS(5572),
    [anon_sym_noreturn] = ACTIONS(5572),
    [anon_sym_mutable] = ACTIONS(5572),
    [anon_sym_constinit] = ACTIONS(5572),
    [anon_sym_consteval] = ACTIONS(5572),
    [anon_sym_alignas] = ACTIONS(5572),
    [anon_sym__Alignas] = ACTIONS(5572),
    [sym_primitive_type] = ACTIONS(5572),
    [anon_sym_enum] = ACTIONS(5572),
    [anon_sym_class] = ACTIONS(5572),
    [anon_sym_struct] = ACTIONS(5572),
    [anon_sym_union] = ACTIONS(5572),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5572),
    [anon_sym_let] = ACTIONS(5572),
    [anon_sym_This] = ACTIONS(5572),
    [anon_sym_decltype] = ACTIONS(5572),
    [sym_virtual] = ACTIONS(5572),
    [anon_sym_explicit] = ACTIONS(5572),
    [anon_sym_typename] = ACTIONS(5572),
    [anon_sym_template] = ACTIONS(5572),
    [anon_sym_operator] = ACTIONS(5572),
    [anon_sym_friend] = ACTIONS(5572),
    [anon_sym_public] = ACTIONS(5572),
    [anon_sym_private] = ACTIONS(5572),
    [anon_sym_protected] = ACTIONS(5572),
    [anon_sym_using] = ACTIONS(5572),
    [anon_sym_static_assert] = ACTIONS(5572),
    [anon_sym_precise] = ACTIONS(5572),
    [anon_sym_shared] = ACTIONS(5572),
    [anon_sym_groupshared] = ACTIONS(5572),
    [anon_sym_uniform] = ACTIONS(5572),
    [anon_sym_row_major] = ACTIONS(5572),
    [anon_sym_column_major] = ACTIONS(5572),
    [anon_sym_globallycoherent] = ACTIONS(5572),
    [anon_sym_centroid] = ACTIONS(5572),
    [anon_sym_noperspective] = ACTIONS(5572),
    [anon_sym_nointerpolation] = ACTIONS(5572),
    [anon_sym_sample] = ACTIONS(5572),
    [anon_sym_linear] = ACTIONS(5572),
    [anon_sym_snorm] = ACTIONS(5572),
    [anon_sym_unorm] = ACTIONS(5572),
    [anon_sym_point] = ACTIONS(5572),
    [anon_sym_line] = ACTIONS(5572),
    [anon_sym_triangleadj] = ACTIONS(5572),
    [anon_sym_lineadj] = ACTIONS(5572),
    [anon_sym_triangle] = ACTIONS(5572),
    [anon_sym_interface] = ACTIONS(5572),
    [anon_sym_extension] = ACTIONS(5572),
    [anon_sym___init] = ACTIONS(5572),
    [anon_sym___subscript] = ACTIONS(5572),
    [anon_sym_property] = ACTIONS(5572),
    [anon_sym_associatedtype] = ACTIONS(5572),
  },
  [1632] = {
    [sym_identifier] = ACTIONS(3437),
    [aux_sym_preproc_def_token1] = ACTIONS(3437),
    [aux_sym_preproc_if_token1] = ACTIONS(3437),
    [aux_sym_preproc_if_token2] = ACTIONS(3437),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3437),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3437),
    [aux_sym_preproc_else_token1] = ACTIONS(3437),
    [aux_sym_preproc_elif_token1] = ACTIONS(3437),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3437),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3437),
    [sym_preproc_directive] = ACTIONS(3437),
    [anon_sym_LPAREN2] = ACTIONS(3439),
    [anon_sym_TILDE] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(3439),
    [anon_sym_AMP_AMP] = ACTIONS(3439),
    [anon_sym_AMP] = ACTIONS(3437),
    [anon_sym___extension__] = ACTIONS(3437),
    [anon_sym_typedef] = ACTIONS(3437),
    [anon_sym_in] = ACTIONS(3437),
    [anon_sym_out] = ACTIONS(3437),
    [anon_sym_inout] = ACTIONS(3437),
    [anon_sym_extern] = ACTIONS(3437),
    [anon_sym___attribute__] = ACTIONS(3437),
    [anon_sym_COLON_COLON] = ACTIONS(3439),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3439),
    [anon_sym___declspec] = ACTIONS(3437),
    [anon_sym___based] = ACTIONS(3437),
    [anon_sym_signed] = ACTIONS(3437),
    [anon_sym_unsigned] = ACTIONS(3437),
    [anon_sym_long] = ACTIONS(3437),
    [anon_sym_short] = ACTIONS(3437),
    [anon_sym_LBRACK] = ACTIONS(3437),
    [anon_sym_static] = ACTIONS(3437),
    [anon_sym_register] = ACTIONS(3437),
    [anon_sym_inline] = ACTIONS(3437),
    [anon_sym___inline] = ACTIONS(3437),
    [anon_sym___inline__] = ACTIONS(3437),
    [anon_sym___forceinline] = ACTIONS(3437),
    [anon_sym_thread_local] = ACTIONS(3437),
    [anon_sym___thread] = ACTIONS(3437),
    [anon_sym_const] = ACTIONS(3437),
    [anon_sym_constexpr] = ACTIONS(3437),
    [anon_sym_volatile] = ACTIONS(3437),
    [anon_sym_restrict] = ACTIONS(3437),
    [anon_sym___restrict__] = ACTIONS(3437),
    [anon_sym__Atomic] = ACTIONS(3437),
    [anon_sym__Noreturn] = ACTIONS(3437),
    [anon_sym_noreturn] = ACTIONS(3437),
    [anon_sym_mutable] = ACTIONS(3437),
    [anon_sym_constinit] = ACTIONS(3437),
    [anon_sym_consteval] = ACTIONS(3437),
    [anon_sym_alignas] = ACTIONS(3437),
    [anon_sym__Alignas] = ACTIONS(3437),
    [sym_primitive_type] = ACTIONS(3437),
    [anon_sym_enum] = ACTIONS(3437),
    [anon_sym_class] = ACTIONS(3437),
    [anon_sym_struct] = ACTIONS(3437),
    [anon_sym_union] = ACTIONS(3437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3437),
    [anon_sym_let] = ACTIONS(3437),
    [anon_sym_This] = ACTIONS(3437),
    [anon_sym_decltype] = ACTIONS(3437),
    [sym_virtual] = ACTIONS(3437),
    [anon_sym_explicit] = ACTIONS(3437),
    [anon_sym_typename] = ACTIONS(3437),
    [anon_sym_template] = ACTIONS(3437),
    [anon_sym_operator] = ACTIONS(3437),
    [anon_sym_friend] = ACTIONS(3437),
    [anon_sym_public] = ACTIONS(3437),
    [anon_sym_private] = ACTIONS(3437),
    [anon_sym_protected] = ACTIONS(3437),
    [anon_sym_using] = ACTIONS(3437),
    [anon_sym_static_assert] = ACTIONS(3437),
    [anon_sym_precise] = ACTIONS(3437),
    [anon_sym_shared] = ACTIONS(3437),
    [anon_sym_groupshared] = ACTIONS(3437),
    [anon_sym_uniform] = ACTIONS(3437),
    [anon_sym_row_major] = ACTIONS(3437),
    [anon_sym_column_major] = ACTIONS(3437),
    [anon_sym_globallycoherent] = ACTIONS(3437),
    [anon_sym_centroid] = ACTIONS(3437),
    [anon_sym_noperspective] = ACTIONS(3437),
    [anon_sym_nointerpolation] = ACTIONS(3437),
    [anon_sym_sample] = ACTIONS(3437),
    [anon_sym_linear] = ACTIONS(3437),
    [anon_sym_snorm] = ACTIONS(3437),
    [anon_sym_unorm] = ACTIONS(3437),
    [anon_sym_point] = ACTIONS(3437),
    [anon_sym_line] = ACTIONS(3437),
    [anon_sym_triangleadj] = ACTIONS(3437),
    [anon_sym_lineadj] = ACTIONS(3437),
    [anon_sym_triangle] = ACTIONS(3437),
    [anon_sym_interface] = ACTIONS(3437),
    [anon_sym_extension] = ACTIONS(3437),
    [anon_sym___init] = ACTIONS(3437),
    [anon_sym___subscript] = ACTIONS(3437),
    [anon_sym_property] = ACTIONS(3437),
    [anon_sym_associatedtype] = ACTIONS(3437),
  },
  [1633] = {
    [sym_identifier] = ACTIONS(3433),
    [aux_sym_preproc_def_token1] = ACTIONS(3433),
    [aux_sym_preproc_if_token1] = ACTIONS(3433),
    [aux_sym_preproc_if_token2] = ACTIONS(3433),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3433),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3433),
    [aux_sym_preproc_else_token1] = ACTIONS(3433),
    [aux_sym_preproc_elif_token1] = ACTIONS(3433),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3433),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3433),
    [sym_preproc_directive] = ACTIONS(3433),
    [anon_sym_LPAREN2] = ACTIONS(3435),
    [anon_sym_TILDE] = ACTIONS(3435),
    [anon_sym_STAR] = ACTIONS(3435),
    [anon_sym_AMP_AMP] = ACTIONS(3435),
    [anon_sym_AMP] = ACTIONS(3433),
    [anon_sym___extension__] = ACTIONS(3433),
    [anon_sym_typedef] = ACTIONS(3433),
    [anon_sym_in] = ACTIONS(3433),
    [anon_sym_out] = ACTIONS(3433),
    [anon_sym_inout] = ACTIONS(3433),
    [anon_sym_extern] = ACTIONS(3433),
    [anon_sym___attribute__] = ACTIONS(3433),
    [anon_sym_COLON_COLON] = ACTIONS(3435),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3435),
    [anon_sym___declspec] = ACTIONS(3433),
    [anon_sym___based] = ACTIONS(3433),
    [anon_sym_signed] = ACTIONS(3433),
    [anon_sym_unsigned] = ACTIONS(3433),
    [anon_sym_long] = ACTIONS(3433),
    [anon_sym_short] = ACTIONS(3433),
    [anon_sym_LBRACK] = ACTIONS(3433),
    [anon_sym_static] = ACTIONS(3433),
    [anon_sym_register] = ACTIONS(3433),
    [anon_sym_inline] = ACTIONS(3433),
    [anon_sym___inline] = ACTIONS(3433),
    [anon_sym___inline__] = ACTIONS(3433),
    [anon_sym___forceinline] = ACTIONS(3433),
    [anon_sym_thread_local] = ACTIONS(3433),
    [anon_sym___thread] = ACTIONS(3433),
    [anon_sym_const] = ACTIONS(3433),
    [anon_sym_constexpr] = ACTIONS(3433),
    [anon_sym_volatile] = ACTIONS(3433),
    [anon_sym_restrict] = ACTIONS(3433),
    [anon_sym___restrict__] = ACTIONS(3433),
    [anon_sym__Atomic] = ACTIONS(3433),
    [anon_sym__Noreturn] = ACTIONS(3433),
    [anon_sym_noreturn] = ACTIONS(3433),
    [anon_sym_mutable] = ACTIONS(3433),
    [anon_sym_constinit] = ACTIONS(3433),
    [anon_sym_consteval] = ACTIONS(3433),
    [anon_sym_alignas] = ACTIONS(3433),
    [anon_sym__Alignas] = ACTIONS(3433),
    [sym_primitive_type] = ACTIONS(3433),
    [anon_sym_enum] = ACTIONS(3433),
    [anon_sym_class] = ACTIONS(3433),
    [anon_sym_struct] = ACTIONS(3433),
    [anon_sym_union] = ACTIONS(3433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3433),
    [anon_sym_let] = ACTIONS(3433),
    [anon_sym_This] = ACTIONS(3433),
    [anon_sym_decltype] = ACTIONS(3433),
    [sym_virtual] = ACTIONS(3433),
    [anon_sym_explicit] = ACTIONS(3433),
    [anon_sym_typename] = ACTIONS(3433),
    [anon_sym_template] = ACTIONS(3433),
    [anon_sym_operator] = ACTIONS(3433),
    [anon_sym_friend] = ACTIONS(3433),
    [anon_sym_public] = ACTIONS(3433),
    [anon_sym_private] = ACTIONS(3433),
    [anon_sym_protected] = ACTIONS(3433),
    [anon_sym_using] = ACTIONS(3433),
    [anon_sym_static_assert] = ACTIONS(3433),
    [anon_sym_precise] = ACTIONS(3433),
    [anon_sym_shared] = ACTIONS(3433),
    [anon_sym_groupshared] = ACTIONS(3433),
    [anon_sym_uniform] = ACTIONS(3433),
    [anon_sym_row_major] = ACTIONS(3433),
    [anon_sym_column_major] = ACTIONS(3433),
    [anon_sym_globallycoherent] = ACTIONS(3433),
    [anon_sym_centroid] = ACTIONS(3433),
    [anon_sym_noperspective] = ACTIONS(3433),
    [anon_sym_nointerpolation] = ACTIONS(3433),
    [anon_sym_sample] = ACTIONS(3433),
    [anon_sym_linear] = ACTIONS(3433),
    [anon_sym_snorm] = ACTIONS(3433),
    [anon_sym_unorm] = ACTIONS(3433),
    [anon_sym_point] = ACTIONS(3433),
    [anon_sym_line] = ACTIONS(3433),
    [anon_sym_triangleadj] = ACTIONS(3433),
    [anon_sym_lineadj] = ACTIONS(3433),
    [anon_sym_triangle] = ACTIONS(3433),
    [anon_sym_interface] = ACTIONS(3433),
    [anon_sym_extension] = ACTIONS(3433),
    [anon_sym___init] = ACTIONS(3433),
    [anon_sym___subscript] = ACTIONS(3433),
    [anon_sym_property] = ACTIONS(3433),
    [anon_sym_associatedtype] = ACTIONS(3433),
  },
  [1634] = {
    [sym_expression] = STATE(4959),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_initializer_list] = STATE(8576),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_default] = ACTIONS(5576),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(5494),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(5578),
    [anon_sym_0] = ACTIONS(5580),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1635] = {
    [sym_identifier] = ACTIONS(5572),
    [aux_sym_preproc_def_token1] = ACTIONS(5572),
    [aux_sym_preproc_if_token1] = ACTIONS(5572),
    [aux_sym_preproc_if_token2] = ACTIONS(5572),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5572),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5572),
    [aux_sym_preproc_else_token1] = ACTIONS(5572),
    [aux_sym_preproc_elif_token1] = ACTIONS(5572),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5572),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5572),
    [sym_preproc_directive] = ACTIONS(5572),
    [anon_sym_LPAREN2] = ACTIONS(5574),
    [anon_sym_TILDE] = ACTIONS(5574),
    [anon_sym_STAR] = ACTIONS(5574),
    [anon_sym_AMP_AMP] = ACTIONS(5574),
    [anon_sym_AMP] = ACTIONS(5572),
    [anon_sym___extension__] = ACTIONS(5572),
    [anon_sym_typedef] = ACTIONS(5572),
    [anon_sym_in] = ACTIONS(5572),
    [anon_sym_out] = ACTIONS(5572),
    [anon_sym_inout] = ACTIONS(5572),
    [anon_sym_extern] = ACTIONS(5572),
    [anon_sym___attribute__] = ACTIONS(5572),
    [anon_sym_COLON_COLON] = ACTIONS(5574),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5574),
    [anon_sym___declspec] = ACTIONS(5572),
    [anon_sym___based] = ACTIONS(5572),
    [anon_sym_signed] = ACTIONS(5572),
    [anon_sym_unsigned] = ACTIONS(5572),
    [anon_sym_long] = ACTIONS(5572),
    [anon_sym_short] = ACTIONS(5572),
    [anon_sym_LBRACK] = ACTIONS(5572),
    [anon_sym_static] = ACTIONS(5572),
    [anon_sym_register] = ACTIONS(5572),
    [anon_sym_inline] = ACTIONS(5572),
    [anon_sym___inline] = ACTIONS(5572),
    [anon_sym___inline__] = ACTIONS(5572),
    [anon_sym___forceinline] = ACTIONS(5572),
    [anon_sym_thread_local] = ACTIONS(5572),
    [anon_sym___thread] = ACTIONS(5572),
    [anon_sym_const] = ACTIONS(5572),
    [anon_sym_constexpr] = ACTIONS(5572),
    [anon_sym_volatile] = ACTIONS(5572),
    [anon_sym_restrict] = ACTIONS(5572),
    [anon_sym___restrict__] = ACTIONS(5572),
    [anon_sym__Atomic] = ACTIONS(5572),
    [anon_sym__Noreturn] = ACTIONS(5572),
    [anon_sym_noreturn] = ACTIONS(5572),
    [anon_sym_mutable] = ACTIONS(5572),
    [anon_sym_constinit] = ACTIONS(5572),
    [anon_sym_consteval] = ACTIONS(5572),
    [anon_sym_alignas] = ACTIONS(5572),
    [anon_sym__Alignas] = ACTIONS(5572),
    [sym_primitive_type] = ACTIONS(5572),
    [anon_sym_enum] = ACTIONS(5572),
    [anon_sym_class] = ACTIONS(5572),
    [anon_sym_struct] = ACTIONS(5572),
    [anon_sym_union] = ACTIONS(5572),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5572),
    [anon_sym_let] = ACTIONS(5572),
    [anon_sym_This] = ACTIONS(5572),
    [anon_sym_decltype] = ACTIONS(5572),
    [sym_virtual] = ACTIONS(5572),
    [anon_sym_explicit] = ACTIONS(5572),
    [anon_sym_typename] = ACTIONS(5572),
    [anon_sym_template] = ACTIONS(5572),
    [anon_sym_operator] = ACTIONS(5572),
    [anon_sym_friend] = ACTIONS(5572),
    [anon_sym_public] = ACTIONS(5572),
    [anon_sym_private] = ACTIONS(5572),
    [anon_sym_protected] = ACTIONS(5572),
    [anon_sym_using] = ACTIONS(5572),
    [anon_sym_static_assert] = ACTIONS(5572),
    [anon_sym_precise] = ACTIONS(5572),
    [anon_sym_shared] = ACTIONS(5572),
    [anon_sym_groupshared] = ACTIONS(5572),
    [anon_sym_uniform] = ACTIONS(5572),
    [anon_sym_row_major] = ACTIONS(5572),
    [anon_sym_column_major] = ACTIONS(5572),
    [anon_sym_globallycoherent] = ACTIONS(5572),
    [anon_sym_centroid] = ACTIONS(5572),
    [anon_sym_noperspective] = ACTIONS(5572),
    [anon_sym_nointerpolation] = ACTIONS(5572),
    [anon_sym_sample] = ACTIONS(5572),
    [anon_sym_linear] = ACTIONS(5572),
    [anon_sym_snorm] = ACTIONS(5572),
    [anon_sym_unorm] = ACTIONS(5572),
    [anon_sym_point] = ACTIONS(5572),
    [anon_sym_line] = ACTIONS(5572),
    [anon_sym_triangleadj] = ACTIONS(5572),
    [anon_sym_lineadj] = ACTIONS(5572),
    [anon_sym_triangle] = ACTIONS(5572),
    [anon_sym_interface] = ACTIONS(5572),
    [anon_sym_extension] = ACTIONS(5572),
    [anon_sym___init] = ACTIONS(5572),
    [anon_sym___subscript] = ACTIONS(5572),
    [anon_sym_property] = ACTIONS(5572),
    [anon_sym_associatedtype] = ACTIONS(5572),
  },
  [1636] = {
    [sym_identifier] = ACTIONS(3429),
    [aux_sym_preproc_def_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token2] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3429),
    [aux_sym_preproc_else_token1] = ACTIONS(3429),
    [aux_sym_preproc_elif_token1] = ACTIONS(3429),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3429),
    [sym_preproc_directive] = ACTIONS(3429),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym___extension__] = ACTIONS(3429),
    [anon_sym_typedef] = ACTIONS(3429),
    [anon_sym_in] = ACTIONS(3429),
    [anon_sym_out] = ACTIONS(3429),
    [anon_sym_inout] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym___attribute__] = ACTIONS(3429),
    [anon_sym_COLON_COLON] = ACTIONS(3431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3431),
    [anon_sym___declspec] = ACTIONS(3429),
    [anon_sym___based] = ACTIONS(3429),
    [anon_sym_signed] = ACTIONS(3429),
    [anon_sym_unsigned] = ACTIONS(3429),
    [anon_sym_long] = ACTIONS(3429),
    [anon_sym_short] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_register] = ACTIONS(3429),
    [anon_sym_inline] = ACTIONS(3429),
    [anon_sym___inline] = ACTIONS(3429),
    [anon_sym___inline__] = ACTIONS(3429),
    [anon_sym___forceinline] = ACTIONS(3429),
    [anon_sym_thread_local] = ACTIONS(3429),
    [anon_sym___thread] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_constexpr] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_restrict] = ACTIONS(3429),
    [anon_sym___restrict__] = ACTIONS(3429),
    [anon_sym__Atomic] = ACTIONS(3429),
    [anon_sym__Noreturn] = ACTIONS(3429),
    [anon_sym_noreturn] = ACTIONS(3429),
    [anon_sym_mutable] = ACTIONS(3429),
    [anon_sym_constinit] = ACTIONS(3429),
    [anon_sym_consteval] = ACTIONS(3429),
    [anon_sym_alignas] = ACTIONS(3429),
    [anon_sym__Alignas] = ACTIONS(3429),
    [sym_primitive_type] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_This] = ACTIONS(3429),
    [anon_sym_decltype] = ACTIONS(3429),
    [sym_virtual] = ACTIONS(3429),
    [anon_sym_explicit] = ACTIONS(3429),
    [anon_sym_typename] = ACTIONS(3429),
    [anon_sym_template] = ACTIONS(3429),
    [anon_sym_operator] = ACTIONS(3429),
    [anon_sym_friend] = ACTIONS(3429),
    [anon_sym_public] = ACTIONS(3429),
    [anon_sym_private] = ACTIONS(3429),
    [anon_sym_protected] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_static_assert] = ACTIONS(3429),
    [anon_sym_precise] = ACTIONS(3429),
    [anon_sym_shared] = ACTIONS(3429),
    [anon_sym_groupshared] = ACTIONS(3429),
    [anon_sym_uniform] = ACTIONS(3429),
    [anon_sym_row_major] = ACTIONS(3429),
    [anon_sym_column_major] = ACTIONS(3429),
    [anon_sym_globallycoherent] = ACTIONS(3429),
    [anon_sym_centroid] = ACTIONS(3429),
    [anon_sym_noperspective] = ACTIONS(3429),
    [anon_sym_nointerpolation] = ACTIONS(3429),
    [anon_sym_sample] = ACTIONS(3429),
    [anon_sym_linear] = ACTIONS(3429),
    [anon_sym_snorm] = ACTIONS(3429),
    [anon_sym_unorm] = ACTIONS(3429),
    [anon_sym_point] = ACTIONS(3429),
    [anon_sym_line] = ACTIONS(3429),
    [anon_sym_triangleadj] = ACTIONS(3429),
    [anon_sym_lineadj] = ACTIONS(3429),
    [anon_sym_triangle] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_extension] = ACTIONS(3429),
    [anon_sym___init] = ACTIONS(3429),
    [anon_sym___subscript] = ACTIONS(3429),
    [anon_sym_property] = ACTIONS(3429),
    [anon_sym_associatedtype] = ACTIONS(3429),
  },
  [1637] = {
    [sym_identifier] = ACTIONS(3429),
    [aux_sym_preproc_def_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token2] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3429),
    [aux_sym_preproc_else_token1] = ACTIONS(3429),
    [aux_sym_preproc_elif_token1] = ACTIONS(3429),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3429),
    [sym_preproc_directive] = ACTIONS(3429),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym___extension__] = ACTIONS(3429),
    [anon_sym_typedef] = ACTIONS(3429),
    [anon_sym_in] = ACTIONS(3429),
    [anon_sym_out] = ACTIONS(3429),
    [anon_sym_inout] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym___attribute__] = ACTIONS(3429),
    [anon_sym_COLON_COLON] = ACTIONS(3431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3431),
    [anon_sym___declspec] = ACTIONS(3429),
    [anon_sym___based] = ACTIONS(3429),
    [anon_sym_signed] = ACTIONS(3429),
    [anon_sym_unsigned] = ACTIONS(3429),
    [anon_sym_long] = ACTIONS(3429),
    [anon_sym_short] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_register] = ACTIONS(3429),
    [anon_sym_inline] = ACTIONS(3429),
    [anon_sym___inline] = ACTIONS(3429),
    [anon_sym___inline__] = ACTIONS(3429),
    [anon_sym___forceinline] = ACTIONS(3429),
    [anon_sym_thread_local] = ACTIONS(3429),
    [anon_sym___thread] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_constexpr] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_restrict] = ACTIONS(3429),
    [anon_sym___restrict__] = ACTIONS(3429),
    [anon_sym__Atomic] = ACTIONS(3429),
    [anon_sym__Noreturn] = ACTIONS(3429),
    [anon_sym_noreturn] = ACTIONS(3429),
    [anon_sym_mutable] = ACTIONS(3429),
    [anon_sym_constinit] = ACTIONS(3429),
    [anon_sym_consteval] = ACTIONS(3429),
    [anon_sym_alignas] = ACTIONS(3429),
    [anon_sym__Alignas] = ACTIONS(3429),
    [sym_primitive_type] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_This] = ACTIONS(3429),
    [anon_sym_decltype] = ACTIONS(3429),
    [sym_virtual] = ACTIONS(3429),
    [anon_sym_explicit] = ACTIONS(3429),
    [anon_sym_typename] = ACTIONS(3429),
    [anon_sym_template] = ACTIONS(3429),
    [anon_sym_operator] = ACTIONS(3429),
    [anon_sym_friend] = ACTIONS(3429),
    [anon_sym_public] = ACTIONS(3429),
    [anon_sym_private] = ACTIONS(3429),
    [anon_sym_protected] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_static_assert] = ACTIONS(3429),
    [anon_sym_precise] = ACTIONS(3429),
    [anon_sym_shared] = ACTIONS(3429),
    [anon_sym_groupshared] = ACTIONS(3429),
    [anon_sym_uniform] = ACTIONS(3429),
    [anon_sym_row_major] = ACTIONS(3429),
    [anon_sym_column_major] = ACTIONS(3429),
    [anon_sym_globallycoherent] = ACTIONS(3429),
    [anon_sym_centroid] = ACTIONS(3429),
    [anon_sym_noperspective] = ACTIONS(3429),
    [anon_sym_nointerpolation] = ACTIONS(3429),
    [anon_sym_sample] = ACTIONS(3429),
    [anon_sym_linear] = ACTIONS(3429),
    [anon_sym_snorm] = ACTIONS(3429),
    [anon_sym_unorm] = ACTIONS(3429),
    [anon_sym_point] = ACTIONS(3429),
    [anon_sym_line] = ACTIONS(3429),
    [anon_sym_triangleadj] = ACTIONS(3429),
    [anon_sym_lineadj] = ACTIONS(3429),
    [anon_sym_triangle] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_extension] = ACTIONS(3429),
    [anon_sym___init] = ACTIONS(3429),
    [anon_sym___subscript] = ACTIONS(3429),
    [anon_sym_property] = ACTIONS(3429),
    [anon_sym_associatedtype] = ACTIONS(3429),
  },
  [1638] = {
    [sym_identifier] = ACTIONS(5582),
    [aux_sym_preproc_def_token1] = ACTIONS(5582),
    [aux_sym_preproc_if_token1] = ACTIONS(5582),
    [aux_sym_preproc_if_token2] = ACTIONS(5582),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5582),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5582),
    [aux_sym_preproc_else_token1] = ACTIONS(5582),
    [aux_sym_preproc_elif_token1] = ACTIONS(5582),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5582),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5582),
    [sym_preproc_directive] = ACTIONS(5582),
    [anon_sym_LPAREN2] = ACTIONS(5584),
    [anon_sym_TILDE] = ACTIONS(5584),
    [anon_sym_STAR] = ACTIONS(5584),
    [anon_sym_AMP_AMP] = ACTIONS(5584),
    [anon_sym_AMP] = ACTIONS(5582),
    [anon_sym___extension__] = ACTIONS(5582),
    [anon_sym_typedef] = ACTIONS(5582),
    [anon_sym_in] = ACTIONS(5582),
    [anon_sym_out] = ACTIONS(5582),
    [anon_sym_inout] = ACTIONS(5582),
    [anon_sym_extern] = ACTIONS(5582),
    [anon_sym___attribute__] = ACTIONS(5582),
    [anon_sym_COLON_COLON] = ACTIONS(5584),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5584),
    [anon_sym___declspec] = ACTIONS(5582),
    [anon_sym___based] = ACTIONS(5582),
    [anon_sym_signed] = ACTIONS(5582),
    [anon_sym_unsigned] = ACTIONS(5582),
    [anon_sym_long] = ACTIONS(5582),
    [anon_sym_short] = ACTIONS(5582),
    [anon_sym_LBRACK] = ACTIONS(5582),
    [anon_sym_static] = ACTIONS(5582),
    [anon_sym_register] = ACTIONS(5582),
    [anon_sym_inline] = ACTIONS(5582),
    [anon_sym___inline] = ACTIONS(5582),
    [anon_sym___inline__] = ACTIONS(5582),
    [anon_sym___forceinline] = ACTIONS(5582),
    [anon_sym_thread_local] = ACTIONS(5582),
    [anon_sym___thread] = ACTIONS(5582),
    [anon_sym_const] = ACTIONS(5582),
    [anon_sym_constexpr] = ACTIONS(5582),
    [anon_sym_volatile] = ACTIONS(5582),
    [anon_sym_restrict] = ACTIONS(5582),
    [anon_sym___restrict__] = ACTIONS(5582),
    [anon_sym__Atomic] = ACTIONS(5582),
    [anon_sym__Noreturn] = ACTIONS(5582),
    [anon_sym_noreturn] = ACTIONS(5582),
    [anon_sym_mutable] = ACTIONS(5582),
    [anon_sym_constinit] = ACTIONS(5582),
    [anon_sym_consteval] = ACTIONS(5582),
    [anon_sym_alignas] = ACTIONS(5582),
    [anon_sym__Alignas] = ACTIONS(5582),
    [sym_primitive_type] = ACTIONS(5582),
    [anon_sym_enum] = ACTIONS(5582),
    [anon_sym_class] = ACTIONS(5582),
    [anon_sym_struct] = ACTIONS(5582),
    [anon_sym_union] = ACTIONS(5582),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5582),
    [anon_sym_let] = ACTIONS(5582),
    [anon_sym_This] = ACTIONS(5582),
    [anon_sym_decltype] = ACTIONS(5582),
    [sym_virtual] = ACTIONS(5582),
    [anon_sym_explicit] = ACTIONS(5582),
    [anon_sym_typename] = ACTIONS(5582),
    [anon_sym_template] = ACTIONS(5582),
    [anon_sym_operator] = ACTIONS(5582),
    [anon_sym_friend] = ACTIONS(5582),
    [anon_sym_public] = ACTIONS(5582),
    [anon_sym_private] = ACTIONS(5582),
    [anon_sym_protected] = ACTIONS(5582),
    [anon_sym_using] = ACTIONS(5582),
    [anon_sym_static_assert] = ACTIONS(5582),
    [anon_sym_precise] = ACTIONS(5582),
    [anon_sym_shared] = ACTIONS(5582),
    [anon_sym_groupshared] = ACTIONS(5582),
    [anon_sym_uniform] = ACTIONS(5582),
    [anon_sym_row_major] = ACTIONS(5582),
    [anon_sym_column_major] = ACTIONS(5582),
    [anon_sym_globallycoherent] = ACTIONS(5582),
    [anon_sym_centroid] = ACTIONS(5582),
    [anon_sym_noperspective] = ACTIONS(5582),
    [anon_sym_nointerpolation] = ACTIONS(5582),
    [anon_sym_sample] = ACTIONS(5582),
    [anon_sym_linear] = ACTIONS(5582),
    [anon_sym_snorm] = ACTIONS(5582),
    [anon_sym_unorm] = ACTIONS(5582),
    [anon_sym_point] = ACTIONS(5582),
    [anon_sym_line] = ACTIONS(5582),
    [anon_sym_triangleadj] = ACTIONS(5582),
    [anon_sym_lineadj] = ACTIONS(5582),
    [anon_sym_triangle] = ACTIONS(5582),
    [anon_sym_interface] = ACTIONS(5582),
    [anon_sym_extension] = ACTIONS(5582),
    [anon_sym___init] = ACTIONS(5582),
    [anon_sym___subscript] = ACTIONS(5582),
    [anon_sym_property] = ACTIONS(5582),
    [anon_sym_associatedtype] = ACTIONS(5582),
  },
  [1639] = {
    [sym_identifier] = ACTIONS(5586),
    [aux_sym_preproc_def_token1] = ACTIONS(5586),
    [aux_sym_preproc_if_token1] = ACTIONS(5586),
    [aux_sym_preproc_if_token2] = ACTIONS(5586),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5586),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5586),
    [aux_sym_preproc_else_token1] = ACTIONS(5586),
    [aux_sym_preproc_elif_token1] = ACTIONS(5586),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5586),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5586),
    [sym_preproc_directive] = ACTIONS(5586),
    [anon_sym_LPAREN2] = ACTIONS(5588),
    [anon_sym_TILDE] = ACTIONS(5588),
    [anon_sym_STAR] = ACTIONS(5588),
    [anon_sym_AMP_AMP] = ACTIONS(5588),
    [anon_sym_AMP] = ACTIONS(5586),
    [anon_sym___extension__] = ACTIONS(5586),
    [anon_sym_typedef] = ACTIONS(5586),
    [anon_sym_in] = ACTIONS(5586),
    [anon_sym_out] = ACTIONS(5586),
    [anon_sym_inout] = ACTIONS(5586),
    [anon_sym_extern] = ACTIONS(5586),
    [anon_sym___attribute__] = ACTIONS(5586),
    [anon_sym_COLON_COLON] = ACTIONS(5588),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5588),
    [anon_sym___declspec] = ACTIONS(5586),
    [anon_sym___based] = ACTIONS(5586),
    [anon_sym_signed] = ACTIONS(5586),
    [anon_sym_unsigned] = ACTIONS(5586),
    [anon_sym_long] = ACTIONS(5586),
    [anon_sym_short] = ACTIONS(5586),
    [anon_sym_LBRACK] = ACTIONS(5586),
    [anon_sym_static] = ACTIONS(5586),
    [anon_sym_register] = ACTIONS(5586),
    [anon_sym_inline] = ACTIONS(5586),
    [anon_sym___inline] = ACTIONS(5586),
    [anon_sym___inline__] = ACTIONS(5586),
    [anon_sym___forceinline] = ACTIONS(5586),
    [anon_sym_thread_local] = ACTIONS(5586),
    [anon_sym___thread] = ACTIONS(5586),
    [anon_sym_const] = ACTIONS(5586),
    [anon_sym_constexpr] = ACTIONS(5586),
    [anon_sym_volatile] = ACTIONS(5586),
    [anon_sym_restrict] = ACTIONS(5586),
    [anon_sym___restrict__] = ACTIONS(5586),
    [anon_sym__Atomic] = ACTIONS(5586),
    [anon_sym__Noreturn] = ACTIONS(5586),
    [anon_sym_noreturn] = ACTIONS(5586),
    [anon_sym_mutable] = ACTIONS(5586),
    [anon_sym_constinit] = ACTIONS(5586),
    [anon_sym_consteval] = ACTIONS(5586),
    [anon_sym_alignas] = ACTIONS(5586),
    [anon_sym__Alignas] = ACTIONS(5586),
    [sym_primitive_type] = ACTIONS(5586),
    [anon_sym_enum] = ACTIONS(5586),
    [anon_sym_class] = ACTIONS(5586),
    [anon_sym_struct] = ACTIONS(5586),
    [anon_sym_union] = ACTIONS(5586),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5586),
    [anon_sym_let] = ACTIONS(5586),
    [anon_sym_This] = ACTIONS(5586),
    [anon_sym_decltype] = ACTIONS(5586),
    [sym_virtual] = ACTIONS(5586),
    [anon_sym_explicit] = ACTIONS(5586),
    [anon_sym_typename] = ACTIONS(5586),
    [anon_sym_template] = ACTIONS(5586),
    [anon_sym_operator] = ACTIONS(5586),
    [anon_sym_friend] = ACTIONS(5586),
    [anon_sym_public] = ACTIONS(5586),
    [anon_sym_private] = ACTIONS(5586),
    [anon_sym_protected] = ACTIONS(5586),
    [anon_sym_using] = ACTIONS(5586),
    [anon_sym_static_assert] = ACTIONS(5586),
    [anon_sym_precise] = ACTIONS(5586),
    [anon_sym_shared] = ACTIONS(5586),
    [anon_sym_groupshared] = ACTIONS(5586),
    [anon_sym_uniform] = ACTIONS(5586),
    [anon_sym_row_major] = ACTIONS(5586),
    [anon_sym_column_major] = ACTIONS(5586),
    [anon_sym_globallycoherent] = ACTIONS(5586),
    [anon_sym_centroid] = ACTIONS(5586),
    [anon_sym_noperspective] = ACTIONS(5586),
    [anon_sym_nointerpolation] = ACTIONS(5586),
    [anon_sym_sample] = ACTIONS(5586),
    [anon_sym_linear] = ACTIONS(5586),
    [anon_sym_snorm] = ACTIONS(5586),
    [anon_sym_unorm] = ACTIONS(5586),
    [anon_sym_point] = ACTIONS(5586),
    [anon_sym_line] = ACTIONS(5586),
    [anon_sym_triangleadj] = ACTIONS(5586),
    [anon_sym_lineadj] = ACTIONS(5586),
    [anon_sym_triangle] = ACTIONS(5586),
    [anon_sym_interface] = ACTIONS(5586),
    [anon_sym_extension] = ACTIONS(5586),
    [anon_sym___init] = ACTIONS(5586),
    [anon_sym___subscript] = ACTIONS(5586),
    [anon_sym_property] = ACTIONS(5586),
    [anon_sym_associatedtype] = ACTIONS(5586),
  },
  [1640] = {
    [sym_identifier] = ACTIONS(5590),
    [aux_sym_preproc_def_token1] = ACTIONS(5590),
    [aux_sym_preproc_if_token1] = ACTIONS(5590),
    [aux_sym_preproc_if_token2] = ACTIONS(5590),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5590),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5590),
    [aux_sym_preproc_else_token1] = ACTIONS(5590),
    [aux_sym_preproc_elif_token1] = ACTIONS(5590),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5590),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5590),
    [sym_preproc_directive] = ACTIONS(5590),
    [anon_sym_LPAREN2] = ACTIONS(5592),
    [anon_sym_TILDE] = ACTIONS(5592),
    [anon_sym_STAR] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym___extension__] = ACTIONS(5590),
    [anon_sym_typedef] = ACTIONS(5590),
    [anon_sym_in] = ACTIONS(5590),
    [anon_sym_out] = ACTIONS(5590),
    [anon_sym_inout] = ACTIONS(5590),
    [anon_sym_extern] = ACTIONS(5590),
    [anon_sym___attribute__] = ACTIONS(5590),
    [anon_sym_COLON_COLON] = ACTIONS(5592),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5592),
    [anon_sym___declspec] = ACTIONS(5590),
    [anon_sym___based] = ACTIONS(5590),
    [anon_sym_signed] = ACTIONS(5590),
    [anon_sym_unsigned] = ACTIONS(5590),
    [anon_sym_long] = ACTIONS(5590),
    [anon_sym_short] = ACTIONS(5590),
    [anon_sym_LBRACK] = ACTIONS(5590),
    [anon_sym_static] = ACTIONS(5590),
    [anon_sym_register] = ACTIONS(5590),
    [anon_sym_inline] = ACTIONS(5590),
    [anon_sym___inline] = ACTIONS(5590),
    [anon_sym___inline__] = ACTIONS(5590),
    [anon_sym___forceinline] = ACTIONS(5590),
    [anon_sym_thread_local] = ACTIONS(5590),
    [anon_sym___thread] = ACTIONS(5590),
    [anon_sym_const] = ACTIONS(5590),
    [anon_sym_constexpr] = ACTIONS(5590),
    [anon_sym_volatile] = ACTIONS(5590),
    [anon_sym_restrict] = ACTIONS(5590),
    [anon_sym___restrict__] = ACTIONS(5590),
    [anon_sym__Atomic] = ACTIONS(5590),
    [anon_sym__Noreturn] = ACTIONS(5590),
    [anon_sym_noreturn] = ACTIONS(5590),
    [anon_sym_mutable] = ACTIONS(5590),
    [anon_sym_constinit] = ACTIONS(5590),
    [anon_sym_consteval] = ACTIONS(5590),
    [anon_sym_alignas] = ACTIONS(5590),
    [anon_sym__Alignas] = ACTIONS(5590),
    [sym_primitive_type] = ACTIONS(5590),
    [anon_sym_enum] = ACTIONS(5590),
    [anon_sym_class] = ACTIONS(5590),
    [anon_sym_struct] = ACTIONS(5590),
    [anon_sym_union] = ACTIONS(5590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5590),
    [anon_sym_let] = ACTIONS(5590),
    [anon_sym_This] = ACTIONS(5590),
    [anon_sym_decltype] = ACTIONS(5590),
    [sym_virtual] = ACTIONS(5590),
    [anon_sym_explicit] = ACTIONS(5590),
    [anon_sym_typename] = ACTIONS(5590),
    [anon_sym_template] = ACTIONS(5590),
    [anon_sym_operator] = ACTIONS(5590),
    [anon_sym_friend] = ACTIONS(5590),
    [anon_sym_public] = ACTIONS(5590),
    [anon_sym_private] = ACTIONS(5590),
    [anon_sym_protected] = ACTIONS(5590),
    [anon_sym_using] = ACTIONS(5590),
    [anon_sym_static_assert] = ACTIONS(5590),
    [anon_sym_precise] = ACTIONS(5590),
    [anon_sym_shared] = ACTIONS(5590),
    [anon_sym_groupshared] = ACTIONS(5590),
    [anon_sym_uniform] = ACTIONS(5590),
    [anon_sym_row_major] = ACTIONS(5590),
    [anon_sym_column_major] = ACTIONS(5590),
    [anon_sym_globallycoherent] = ACTIONS(5590),
    [anon_sym_centroid] = ACTIONS(5590),
    [anon_sym_noperspective] = ACTIONS(5590),
    [anon_sym_nointerpolation] = ACTIONS(5590),
    [anon_sym_sample] = ACTIONS(5590),
    [anon_sym_linear] = ACTIONS(5590),
    [anon_sym_snorm] = ACTIONS(5590),
    [anon_sym_unorm] = ACTIONS(5590),
    [anon_sym_point] = ACTIONS(5590),
    [anon_sym_line] = ACTIONS(5590),
    [anon_sym_triangleadj] = ACTIONS(5590),
    [anon_sym_lineadj] = ACTIONS(5590),
    [anon_sym_triangle] = ACTIONS(5590),
    [anon_sym_interface] = ACTIONS(5590),
    [anon_sym_extension] = ACTIONS(5590),
    [anon_sym___init] = ACTIONS(5590),
    [anon_sym___subscript] = ACTIONS(5590),
    [anon_sym_property] = ACTIONS(5590),
    [anon_sym_associatedtype] = ACTIONS(5590),
  },
  [1641] = {
    [sym_identifier] = ACTIONS(5594),
    [aux_sym_preproc_def_token1] = ACTIONS(5594),
    [aux_sym_preproc_if_token1] = ACTIONS(5594),
    [aux_sym_preproc_if_token2] = ACTIONS(5594),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5594),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5594),
    [aux_sym_preproc_else_token1] = ACTIONS(5594),
    [aux_sym_preproc_elif_token1] = ACTIONS(5594),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5594),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5594),
    [sym_preproc_directive] = ACTIONS(5594),
    [anon_sym_LPAREN2] = ACTIONS(5596),
    [anon_sym_TILDE] = ACTIONS(5596),
    [anon_sym_STAR] = ACTIONS(5596),
    [anon_sym_AMP_AMP] = ACTIONS(5596),
    [anon_sym_AMP] = ACTIONS(5594),
    [anon_sym___extension__] = ACTIONS(5594),
    [anon_sym_typedef] = ACTIONS(5594),
    [anon_sym_in] = ACTIONS(5594),
    [anon_sym_out] = ACTIONS(5594),
    [anon_sym_inout] = ACTIONS(5594),
    [anon_sym_extern] = ACTIONS(5594),
    [anon_sym___attribute__] = ACTIONS(5594),
    [anon_sym_COLON_COLON] = ACTIONS(5596),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5596),
    [anon_sym___declspec] = ACTIONS(5594),
    [anon_sym___based] = ACTIONS(5594),
    [anon_sym_signed] = ACTIONS(5594),
    [anon_sym_unsigned] = ACTIONS(5594),
    [anon_sym_long] = ACTIONS(5594),
    [anon_sym_short] = ACTIONS(5594),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_static] = ACTIONS(5594),
    [anon_sym_register] = ACTIONS(5594),
    [anon_sym_inline] = ACTIONS(5594),
    [anon_sym___inline] = ACTIONS(5594),
    [anon_sym___inline__] = ACTIONS(5594),
    [anon_sym___forceinline] = ACTIONS(5594),
    [anon_sym_thread_local] = ACTIONS(5594),
    [anon_sym___thread] = ACTIONS(5594),
    [anon_sym_const] = ACTIONS(5594),
    [anon_sym_constexpr] = ACTIONS(5594),
    [anon_sym_volatile] = ACTIONS(5594),
    [anon_sym_restrict] = ACTIONS(5594),
    [anon_sym___restrict__] = ACTIONS(5594),
    [anon_sym__Atomic] = ACTIONS(5594),
    [anon_sym__Noreturn] = ACTIONS(5594),
    [anon_sym_noreturn] = ACTIONS(5594),
    [anon_sym_mutable] = ACTIONS(5594),
    [anon_sym_constinit] = ACTIONS(5594),
    [anon_sym_consteval] = ACTIONS(5594),
    [anon_sym_alignas] = ACTIONS(5594),
    [anon_sym__Alignas] = ACTIONS(5594),
    [sym_primitive_type] = ACTIONS(5594),
    [anon_sym_enum] = ACTIONS(5594),
    [anon_sym_class] = ACTIONS(5594),
    [anon_sym_struct] = ACTIONS(5594),
    [anon_sym_union] = ACTIONS(5594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5594),
    [anon_sym_let] = ACTIONS(5594),
    [anon_sym_This] = ACTIONS(5594),
    [anon_sym_decltype] = ACTIONS(5594),
    [sym_virtual] = ACTIONS(5594),
    [anon_sym_explicit] = ACTIONS(5594),
    [anon_sym_typename] = ACTIONS(5594),
    [anon_sym_template] = ACTIONS(5594),
    [anon_sym_operator] = ACTIONS(5594),
    [anon_sym_friend] = ACTIONS(5594),
    [anon_sym_public] = ACTIONS(5594),
    [anon_sym_private] = ACTIONS(5594),
    [anon_sym_protected] = ACTIONS(5594),
    [anon_sym_using] = ACTIONS(5594),
    [anon_sym_static_assert] = ACTIONS(5594),
    [anon_sym_precise] = ACTIONS(5594),
    [anon_sym_shared] = ACTIONS(5594),
    [anon_sym_groupshared] = ACTIONS(5594),
    [anon_sym_uniform] = ACTIONS(5594),
    [anon_sym_row_major] = ACTIONS(5594),
    [anon_sym_column_major] = ACTIONS(5594),
    [anon_sym_globallycoherent] = ACTIONS(5594),
    [anon_sym_centroid] = ACTIONS(5594),
    [anon_sym_noperspective] = ACTIONS(5594),
    [anon_sym_nointerpolation] = ACTIONS(5594),
    [anon_sym_sample] = ACTIONS(5594),
    [anon_sym_linear] = ACTIONS(5594),
    [anon_sym_snorm] = ACTIONS(5594),
    [anon_sym_unorm] = ACTIONS(5594),
    [anon_sym_point] = ACTIONS(5594),
    [anon_sym_line] = ACTIONS(5594),
    [anon_sym_triangleadj] = ACTIONS(5594),
    [anon_sym_lineadj] = ACTIONS(5594),
    [anon_sym_triangle] = ACTIONS(5594),
    [anon_sym_interface] = ACTIONS(5594),
    [anon_sym_extension] = ACTIONS(5594),
    [anon_sym___init] = ACTIONS(5594),
    [anon_sym___subscript] = ACTIONS(5594),
    [anon_sym_property] = ACTIONS(5594),
    [anon_sym_associatedtype] = ACTIONS(5594),
  },
  [1642] = {
    [sym_identifier] = ACTIONS(5598),
    [aux_sym_preproc_def_token1] = ACTIONS(5598),
    [aux_sym_preproc_if_token1] = ACTIONS(5598),
    [aux_sym_preproc_if_token2] = ACTIONS(5598),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5598),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5598),
    [aux_sym_preproc_else_token1] = ACTIONS(5598),
    [aux_sym_preproc_elif_token1] = ACTIONS(5598),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5598),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5598),
    [sym_preproc_directive] = ACTIONS(5598),
    [anon_sym_LPAREN2] = ACTIONS(5600),
    [anon_sym_TILDE] = ACTIONS(5600),
    [anon_sym_STAR] = ACTIONS(5600),
    [anon_sym_AMP_AMP] = ACTIONS(5600),
    [anon_sym_AMP] = ACTIONS(5598),
    [anon_sym___extension__] = ACTIONS(5598),
    [anon_sym_typedef] = ACTIONS(5598),
    [anon_sym_in] = ACTIONS(5598),
    [anon_sym_out] = ACTIONS(5598),
    [anon_sym_inout] = ACTIONS(5598),
    [anon_sym_extern] = ACTIONS(5598),
    [anon_sym___attribute__] = ACTIONS(5598),
    [anon_sym_COLON_COLON] = ACTIONS(5600),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5600),
    [anon_sym___declspec] = ACTIONS(5598),
    [anon_sym___based] = ACTIONS(5598),
    [anon_sym_signed] = ACTIONS(5598),
    [anon_sym_unsigned] = ACTIONS(5598),
    [anon_sym_long] = ACTIONS(5598),
    [anon_sym_short] = ACTIONS(5598),
    [anon_sym_LBRACK] = ACTIONS(5598),
    [anon_sym_static] = ACTIONS(5598),
    [anon_sym_register] = ACTIONS(5598),
    [anon_sym_inline] = ACTIONS(5598),
    [anon_sym___inline] = ACTIONS(5598),
    [anon_sym___inline__] = ACTIONS(5598),
    [anon_sym___forceinline] = ACTIONS(5598),
    [anon_sym_thread_local] = ACTIONS(5598),
    [anon_sym___thread] = ACTIONS(5598),
    [anon_sym_const] = ACTIONS(5598),
    [anon_sym_constexpr] = ACTIONS(5598),
    [anon_sym_volatile] = ACTIONS(5598),
    [anon_sym_restrict] = ACTIONS(5598),
    [anon_sym___restrict__] = ACTIONS(5598),
    [anon_sym__Atomic] = ACTIONS(5598),
    [anon_sym__Noreturn] = ACTIONS(5598),
    [anon_sym_noreturn] = ACTIONS(5598),
    [anon_sym_mutable] = ACTIONS(5598),
    [anon_sym_constinit] = ACTIONS(5598),
    [anon_sym_consteval] = ACTIONS(5598),
    [anon_sym_alignas] = ACTIONS(5598),
    [anon_sym__Alignas] = ACTIONS(5598),
    [sym_primitive_type] = ACTIONS(5598),
    [anon_sym_enum] = ACTIONS(5598),
    [anon_sym_class] = ACTIONS(5598),
    [anon_sym_struct] = ACTIONS(5598),
    [anon_sym_union] = ACTIONS(5598),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5598),
    [anon_sym_let] = ACTIONS(5598),
    [anon_sym_This] = ACTIONS(5598),
    [anon_sym_decltype] = ACTIONS(5598),
    [sym_virtual] = ACTIONS(5598),
    [anon_sym_explicit] = ACTIONS(5598),
    [anon_sym_typename] = ACTIONS(5598),
    [anon_sym_template] = ACTIONS(5598),
    [anon_sym_operator] = ACTIONS(5598),
    [anon_sym_friend] = ACTIONS(5598),
    [anon_sym_public] = ACTIONS(5598),
    [anon_sym_private] = ACTIONS(5598),
    [anon_sym_protected] = ACTIONS(5598),
    [anon_sym_using] = ACTIONS(5598),
    [anon_sym_static_assert] = ACTIONS(5598),
    [anon_sym_precise] = ACTIONS(5598),
    [anon_sym_shared] = ACTIONS(5598),
    [anon_sym_groupshared] = ACTIONS(5598),
    [anon_sym_uniform] = ACTIONS(5598),
    [anon_sym_row_major] = ACTIONS(5598),
    [anon_sym_column_major] = ACTIONS(5598),
    [anon_sym_globallycoherent] = ACTIONS(5598),
    [anon_sym_centroid] = ACTIONS(5598),
    [anon_sym_noperspective] = ACTIONS(5598),
    [anon_sym_nointerpolation] = ACTIONS(5598),
    [anon_sym_sample] = ACTIONS(5598),
    [anon_sym_linear] = ACTIONS(5598),
    [anon_sym_snorm] = ACTIONS(5598),
    [anon_sym_unorm] = ACTIONS(5598),
    [anon_sym_point] = ACTIONS(5598),
    [anon_sym_line] = ACTIONS(5598),
    [anon_sym_triangleadj] = ACTIONS(5598),
    [anon_sym_lineadj] = ACTIONS(5598),
    [anon_sym_triangle] = ACTIONS(5598),
    [anon_sym_interface] = ACTIONS(5598),
    [anon_sym_extension] = ACTIONS(5598),
    [anon_sym___init] = ACTIONS(5598),
    [anon_sym___subscript] = ACTIONS(5598),
    [anon_sym_property] = ACTIONS(5598),
    [anon_sym_associatedtype] = ACTIONS(5598),
  },
  [1643] = {
    [sym_identifier] = ACTIONS(3418),
    [aux_sym_preproc_def_token1] = ACTIONS(3418),
    [aux_sym_preproc_if_token1] = ACTIONS(3418),
    [aux_sym_preproc_if_token2] = ACTIONS(3418),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3418),
    [aux_sym_preproc_else_token1] = ACTIONS(3418),
    [aux_sym_preproc_elif_token1] = ACTIONS(3418),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3418),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3418),
    [sym_preproc_directive] = ACTIONS(3418),
    [anon_sym_LPAREN2] = ACTIONS(3420),
    [anon_sym_TILDE] = ACTIONS(3420),
    [anon_sym_STAR] = ACTIONS(3420),
    [anon_sym_AMP_AMP] = ACTIONS(3420),
    [anon_sym_AMP] = ACTIONS(3418),
    [anon_sym___extension__] = ACTIONS(3418),
    [anon_sym_typedef] = ACTIONS(3418),
    [anon_sym_in] = ACTIONS(3418),
    [anon_sym_out] = ACTIONS(3418),
    [anon_sym_inout] = ACTIONS(3418),
    [anon_sym_extern] = ACTIONS(3418),
    [anon_sym___attribute__] = ACTIONS(3418),
    [anon_sym_COLON_COLON] = ACTIONS(3420),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3420),
    [anon_sym___declspec] = ACTIONS(3418),
    [anon_sym___based] = ACTIONS(3418),
    [anon_sym_signed] = ACTIONS(3418),
    [anon_sym_unsigned] = ACTIONS(3418),
    [anon_sym_long] = ACTIONS(3418),
    [anon_sym_short] = ACTIONS(3418),
    [anon_sym_LBRACK] = ACTIONS(3418),
    [anon_sym_static] = ACTIONS(3418),
    [anon_sym_register] = ACTIONS(3418),
    [anon_sym_inline] = ACTIONS(3418),
    [anon_sym___inline] = ACTIONS(3418),
    [anon_sym___inline__] = ACTIONS(3418),
    [anon_sym___forceinline] = ACTIONS(3418),
    [anon_sym_thread_local] = ACTIONS(3418),
    [anon_sym___thread] = ACTIONS(3418),
    [anon_sym_const] = ACTIONS(3418),
    [anon_sym_constexpr] = ACTIONS(3418),
    [anon_sym_volatile] = ACTIONS(3418),
    [anon_sym_restrict] = ACTIONS(3418),
    [anon_sym___restrict__] = ACTIONS(3418),
    [anon_sym__Atomic] = ACTIONS(3418),
    [anon_sym__Noreturn] = ACTIONS(3418),
    [anon_sym_noreturn] = ACTIONS(3418),
    [anon_sym_mutable] = ACTIONS(3418),
    [anon_sym_constinit] = ACTIONS(3418),
    [anon_sym_consteval] = ACTIONS(3418),
    [anon_sym_alignas] = ACTIONS(3418),
    [anon_sym__Alignas] = ACTIONS(3418),
    [sym_primitive_type] = ACTIONS(3418),
    [anon_sym_enum] = ACTIONS(3418),
    [anon_sym_class] = ACTIONS(3418),
    [anon_sym_struct] = ACTIONS(3418),
    [anon_sym_union] = ACTIONS(3418),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3418),
    [anon_sym_let] = ACTIONS(3418),
    [anon_sym_This] = ACTIONS(3418),
    [anon_sym_decltype] = ACTIONS(3418),
    [sym_virtual] = ACTIONS(3418),
    [anon_sym_explicit] = ACTIONS(3418),
    [anon_sym_typename] = ACTIONS(3418),
    [anon_sym_template] = ACTIONS(3418),
    [anon_sym_operator] = ACTIONS(3418),
    [anon_sym_friend] = ACTIONS(3418),
    [anon_sym_public] = ACTIONS(3418),
    [anon_sym_private] = ACTIONS(3418),
    [anon_sym_protected] = ACTIONS(3418),
    [anon_sym_using] = ACTIONS(3418),
    [anon_sym_static_assert] = ACTIONS(3418),
    [anon_sym_precise] = ACTIONS(3418),
    [anon_sym_shared] = ACTIONS(3418),
    [anon_sym_groupshared] = ACTIONS(3418),
    [anon_sym_uniform] = ACTIONS(3418),
    [anon_sym_row_major] = ACTIONS(3418),
    [anon_sym_column_major] = ACTIONS(3418),
    [anon_sym_globallycoherent] = ACTIONS(3418),
    [anon_sym_centroid] = ACTIONS(3418),
    [anon_sym_noperspective] = ACTIONS(3418),
    [anon_sym_nointerpolation] = ACTIONS(3418),
    [anon_sym_sample] = ACTIONS(3418),
    [anon_sym_linear] = ACTIONS(3418),
    [anon_sym_snorm] = ACTIONS(3418),
    [anon_sym_unorm] = ACTIONS(3418),
    [anon_sym_point] = ACTIONS(3418),
    [anon_sym_line] = ACTIONS(3418),
    [anon_sym_triangleadj] = ACTIONS(3418),
    [anon_sym_lineadj] = ACTIONS(3418),
    [anon_sym_triangle] = ACTIONS(3418),
    [anon_sym_interface] = ACTIONS(3418),
    [anon_sym_extension] = ACTIONS(3418),
    [anon_sym___init] = ACTIONS(3418),
    [anon_sym___subscript] = ACTIONS(3418),
    [anon_sym_property] = ACTIONS(3418),
    [anon_sym_associatedtype] = ACTIONS(3418),
  },
  [1644] = {
    [sym_identifier] = ACTIONS(5598),
    [aux_sym_preproc_def_token1] = ACTIONS(5598),
    [aux_sym_preproc_if_token1] = ACTIONS(5598),
    [aux_sym_preproc_if_token2] = ACTIONS(5598),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5598),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5598),
    [aux_sym_preproc_else_token1] = ACTIONS(5598),
    [aux_sym_preproc_elif_token1] = ACTIONS(5598),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5598),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5598),
    [sym_preproc_directive] = ACTIONS(5598),
    [anon_sym_LPAREN2] = ACTIONS(5600),
    [anon_sym_TILDE] = ACTIONS(5600),
    [anon_sym_STAR] = ACTIONS(5600),
    [anon_sym_AMP_AMP] = ACTIONS(5600),
    [anon_sym_AMP] = ACTIONS(5598),
    [anon_sym___extension__] = ACTIONS(5598),
    [anon_sym_typedef] = ACTIONS(5598),
    [anon_sym_in] = ACTIONS(5598),
    [anon_sym_out] = ACTIONS(5598),
    [anon_sym_inout] = ACTIONS(5598),
    [anon_sym_extern] = ACTIONS(5598),
    [anon_sym___attribute__] = ACTIONS(5598),
    [anon_sym_COLON_COLON] = ACTIONS(5600),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5600),
    [anon_sym___declspec] = ACTIONS(5598),
    [anon_sym___based] = ACTIONS(5598),
    [anon_sym_signed] = ACTIONS(5598),
    [anon_sym_unsigned] = ACTIONS(5598),
    [anon_sym_long] = ACTIONS(5598),
    [anon_sym_short] = ACTIONS(5598),
    [anon_sym_LBRACK] = ACTIONS(5598),
    [anon_sym_static] = ACTIONS(5598),
    [anon_sym_register] = ACTIONS(5598),
    [anon_sym_inline] = ACTIONS(5598),
    [anon_sym___inline] = ACTIONS(5598),
    [anon_sym___inline__] = ACTIONS(5598),
    [anon_sym___forceinline] = ACTIONS(5598),
    [anon_sym_thread_local] = ACTIONS(5598),
    [anon_sym___thread] = ACTIONS(5598),
    [anon_sym_const] = ACTIONS(5598),
    [anon_sym_constexpr] = ACTIONS(5598),
    [anon_sym_volatile] = ACTIONS(5598),
    [anon_sym_restrict] = ACTIONS(5598),
    [anon_sym___restrict__] = ACTIONS(5598),
    [anon_sym__Atomic] = ACTIONS(5598),
    [anon_sym__Noreturn] = ACTIONS(5598),
    [anon_sym_noreturn] = ACTIONS(5598),
    [anon_sym_mutable] = ACTIONS(5598),
    [anon_sym_constinit] = ACTIONS(5598),
    [anon_sym_consteval] = ACTIONS(5598),
    [anon_sym_alignas] = ACTIONS(5598),
    [anon_sym__Alignas] = ACTIONS(5598),
    [sym_primitive_type] = ACTIONS(5598),
    [anon_sym_enum] = ACTIONS(5598),
    [anon_sym_class] = ACTIONS(5598),
    [anon_sym_struct] = ACTIONS(5598),
    [anon_sym_union] = ACTIONS(5598),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5598),
    [anon_sym_let] = ACTIONS(5598),
    [anon_sym_This] = ACTIONS(5598),
    [anon_sym_decltype] = ACTIONS(5598),
    [sym_virtual] = ACTIONS(5598),
    [anon_sym_explicit] = ACTIONS(5598),
    [anon_sym_typename] = ACTIONS(5598),
    [anon_sym_template] = ACTIONS(5598),
    [anon_sym_operator] = ACTIONS(5598),
    [anon_sym_friend] = ACTIONS(5598),
    [anon_sym_public] = ACTIONS(5598),
    [anon_sym_private] = ACTIONS(5598),
    [anon_sym_protected] = ACTIONS(5598),
    [anon_sym_using] = ACTIONS(5598),
    [anon_sym_static_assert] = ACTIONS(5598),
    [anon_sym_precise] = ACTIONS(5598),
    [anon_sym_shared] = ACTIONS(5598),
    [anon_sym_groupshared] = ACTIONS(5598),
    [anon_sym_uniform] = ACTIONS(5598),
    [anon_sym_row_major] = ACTIONS(5598),
    [anon_sym_column_major] = ACTIONS(5598),
    [anon_sym_globallycoherent] = ACTIONS(5598),
    [anon_sym_centroid] = ACTIONS(5598),
    [anon_sym_noperspective] = ACTIONS(5598),
    [anon_sym_nointerpolation] = ACTIONS(5598),
    [anon_sym_sample] = ACTIONS(5598),
    [anon_sym_linear] = ACTIONS(5598),
    [anon_sym_snorm] = ACTIONS(5598),
    [anon_sym_unorm] = ACTIONS(5598),
    [anon_sym_point] = ACTIONS(5598),
    [anon_sym_line] = ACTIONS(5598),
    [anon_sym_triangleadj] = ACTIONS(5598),
    [anon_sym_lineadj] = ACTIONS(5598),
    [anon_sym_triangle] = ACTIONS(5598),
    [anon_sym_interface] = ACTIONS(5598),
    [anon_sym_extension] = ACTIONS(5598),
    [anon_sym___init] = ACTIONS(5598),
    [anon_sym___subscript] = ACTIONS(5598),
    [anon_sym_property] = ACTIONS(5598),
    [anon_sym_associatedtype] = ACTIONS(5598),
  },
  [1645] = {
    [sym_identifier] = ACTIONS(5602),
    [aux_sym_preproc_def_token1] = ACTIONS(5602),
    [aux_sym_preproc_if_token1] = ACTIONS(5602),
    [aux_sym_preproc_if_token2] = ACTIONS(5602),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5602),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5602),
    [aux_sym_preproc_else_token1] = ACTIONS(5602),
    [aux_sym_preproc_elif_token1] = ACTIONS(5602),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5602),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5602),
    [sym_preproc_directive] = ACTIONS(5602),
    [anon_sym_LPAREN2] = ACTIONS(5604),
    [anon_sym_TILDE] = ACTIONS(5604),
    [anon_sym_STAR] = ACTIONS(5604),
    [anon_sym_AMP_AMP] = ACTIONS(5604),
    [anon_sym_AMP] = ACTIONS(5602),
    [anon_sym___extension__] = ACTIONS(5602),
    [anon_sym_typedef] = ACTIONS(5602),
    [anon_sym_in] = ACTIONS(5602),
    [anon_sym_out] = ACTIONS(5602),
    [anon_sym_inout] = ACTIONS(5602),
    [anon_sym_extern] = ACTIONS(5602),
    [anon_sym___attribute__] = ACTIONS(5602),
    [anon_sym_COLON_COLON] = ACTIONS(5604),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5604),
    [anon_sym___declspec] = ACTIONS(5602),
    [anon_sym___based] = ACTIONS(5602),
    [anon_sym_signed] = ACTIONS(5602),
    [anon_sym_unsigned] = ACTIONS(5602),
    [anon_sym_long] = ACTIONS(5602),
    [anon_sym_short] = ACTIONS(5602),
    [anon_sym_LBRACK] = ACTIONS(5602),
    [anon_sym_static] = ACTIONS(5602),
    [anon_sym_register] = ACTIONS(5602),
    [anon_sym_inline] = ACTIONS(5602),
    [anon_sym___inline] = ACTIONS(5602),
    [anon_sym___inline__] = ACTIONS(5602),
    [anon_sym___forceinline] = ACTIONS(5602),
    [anon_sym_thread_local] = ACTIONS(5602),
    [anon_sym___thread] = ACTIONS(5602),
    [anon_sym_const] = ACTIONS(5602),
    [anon_sym_constexpr] = ACTIONS(5602),
    [anon_sym_volatile] = ACTIONS(5602),
    [anon_sym_restrict] = ACTIONS(5602),
    [anon_sym___restrict__] = ACTIONS(5602),
    [anon_sym__Atomic] = ACTIONS(5602),
    [anon_sym__Noreturn] = ACTIONS(5602),
    [anon_sym_noreturn] = ACTIONS(5602),
    [anon_sym_mutable] = ACTIONS(5602),
    [anon_sym_constinit] = ACTIONS(5602),
    [anon_sym_consteval] = ACTIONS(5602),
    [anon_sym_alignas] = ACTIONS(5602),
    [anon_sym__Alignas] = ACTIONS(5602),
    [sym_primitive_type] = ACTIONS(5602),
    [anon_sym_enum] = ACTIONS(5602),
    [anon_sym_class] = ACTIONS(5602),
    [anon_sym_struct] = ACTIONS(5602),
    [anon_sym_union] = ACTIONS(5602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5602),
    [anon_sym_let] = ACTIONS(5602),
    [anon_sym_This] = ACTIONS(5602),
    [anon_sym_decltype] = ACTIONS(5602),
    [sym_virtual] = ACTIONS(5602),
    [anon_sym_explicit] = ACTIONS(5602),
    [anon_sym_typename] = ACTIONS(5602),
    [anon_sym_template] = ACTIONS(5602),
    [anon_sym_operator] = ACTIONS(5602),
    [anon_sym_friend] = ACTIONS(5602),
    [anon_sym_public] = ACTIONS(5602),
    [anon_sym_private] = ACTIONS(5602),
    [anon_sym_protected] = ACTIONS(5602),
    [anon_sym_using] = ACTIONS(5602),
    [anon_sym_static_assert] = ACTIONS(5602),
    [anon_sym_precise] = ACTIONS(5602),
    [anon_sym_shared] = ACTIONS(5602),
    [anon_sym_groupshared] = ACTIONS(5602),
    [anon_sym_uniform] = ACTIONS(5602),
    [anon_sym_row_major] = ACTIONS(5602),
    [anon_sym_column_major] = ACTIONS(5602),
    [anon_sym_globallycoherent] = ACTIONS(5602),
    [anon_sym_centroid] = ACTIONS(5602),
    [anon_sym_noperspective] = ACTIONS(5602),
    [anon_sym_nointerpolation] = ACTIONS(5602),
    [anon_sym_sample] = ACTIONS(5602),
    [anon_sym_linear] = ACTIONS(5602),
    [anon_sym_snorm] = ACTIONS(5602),
    [anon_sym_unorm] = ACTIONS(5602),
    [anon_sym_point] = ACTIONS(5602),
    [anon_sym_line] = ACTIONS(5602),
    [anon_sym_triangleadj] = ACTIONS(5602),
    [anon_sym_lineadj] = ACTIONS(5602),
    [anon_sym_triangle] = ACTIONS(5602),
    [anon_sym_interface] = ACTIONS(5602),
    [anon_sym_extension] = ACTIONS(5602),
    [anon_sym___init] = ACTIONS(5602),
    [anon_sym___subscript] = ACTIONS(5602),
    [anon_sym_property] = ACTIONS(5602),
    [anon_sym_associatedtype] = ACTIONS(5602),
  },
  [1646] = {
    [sym_identifier] = ACTIONS(5606),
    [aux_sym_preproc_def_token1] = ACTIONS(5606),
    [aux_sym_preproc_if_token1] = ACTIONS(5606),
    [aux_sym_preproc_if_token2] = ACTIONS(5606),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5606),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5606),
    [aux_sym_preproc_else_token1] = ACTIONS(5606),
    [aux_sym_preproc_elif_token1] = ACTIONS(5606),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5606),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5606),
    [sym_preproc_directive] = ACTIONS(5606),
    [anon_sym_LPAREN2] = ACTIONS(5608),
    [anon_sym_TILDE] = ACTIONS(5608),
    [anon_sym_STAR] = ACTIONS(5608),
    [anon_sym_AMP_AMP] = ACTIONS(5608),
    [anon_sym_AMP] = ACTIONS(5606),
    [anon_sym___extension__] = ACTIONS(5606),
    [anon_sym_typedef] = ACTIONS(5606),
    [anon_sym_in] = ACTIONS(5606),
    [anon_sym_out] = ACTIONS(5606),
    [anon_sym_inout] = ACTIONS(5606),
    [anon_sym_extern] = ACTIONS(5606),
    [anon_sym___attribute__] = ACTIONS(5606),
    [anon_sym_COLON_COLON] = ACTIONS(5608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5608),
    [anon_sym___declspec] = ACTIONS(5606),
    [anon_sym___based] = ACTIONS(5606),
    [anon_sym_signed] = ACTIONS(5606),
    [anon_sym_unsigned] = ACTIONS(5606),
    [anon_sym_long] = ACTIONS(5606),
    [anon_sym_short] = ACTIONS(5606),
    [anon_sym_LBRACK] = ACTIONS(5606),
    [anon_sym_static] = ACTIONS(5606),
    [anon_sym_register] = ACTIONS(5606),
    [anon_sym_inline] = ACTIONS(5606),
    [anon_sym___inline] = ACTIONS(5606),
    [anon_sym___inline__] = ACTIONS(5606),
    [anon_sym___forceinline] = ACTIONS(5606),
    [anon_sym_thread_local] = ACTIONS(5606),
    [anon_sym___thread] = ACTIONS(5606),
    [anon_sym_const] = ACTIONS(5606),
    [anon_sym_constexpr] = ACTIONS(5606),
    [anon_sym_volatile] = ACTIONS(5606),
    [anon_sym_restrict] = ACTIONS(5606),
    [anon_sym___restrict__] = ACTIONS(5606),
    [anon_sym__Atomic] = ACTIONS(5606),
    [anon_sym__Noreturn] = ACTIONS(5606),
    [anon_sym_noreturn] = ACTIONS(5606),
    [anon_sym_mutable] = ACTIONS(5606),
    [anon_sym_constinit] = ACTIONS(5606),
    [anon_sym_consteval] = ACTIONS(5606),
    [anon_sym_alignas] = ACTIONS(5606),
    [anon_sym__Alignas] = ACTIONS(5606),
    [sym_primitive_type] = ACTIONS(5606),
    [anon_sym_enum] = ACTIONS(5606),
    [anon_sym_class] = ACTIONS(5606),
    [anon_sym_struct] = ACTIONS(5606),
    [anon_sym_union] = ACTIONS(5606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5606),
    [anon_sym_let] = ACTIONS(5606),
    [anon_sym_This] = ACTIONS(5606),
    [anon_sym_decltype] = ACTIONS(5606),
    [sym_virtual] = ACTIONS(5606),
    [anon_sym_explicit] = ACTIONS(5606),
    [anon_sym_typename] = ACTIONS(5606),
    [anon_sym_template] = ACTIONS(5606),
    [anon_sym_operator] = ACTIONS(5606),
    [anon_sym_friend] = ACTIONS(5606),
    [anon_sym_public] = ACTIONS(5606),
    [anon_sym_private] = ACTIONS(5606),
    [anon_sym_protected] = ACTIONS(5606),
    [anon_sym_using] = ACTIONS(5606),
    [anon_sym_static_assert] = ACTIONS(5606),
    [anon_sym_precise] = ACTIONS(5606),
    [anon_sym_shared] = ACTIONS(5606),
    [anon_sym_groupshared] = ACTIONS(5606),
    [anon_sym_uniform] = ACTIONS(5606),
    [anon_sym_row_major] = ACTIONS(5606),
    [anon_sym_column_major] = ACTIONS(5606),
    [anon_sym_globallycoherent] = ACTIONS(5606),
    [anon_sym_centroid] = ACTIONS(5606),
    [anon_sym_noperspective] = ACTIONS(5606),
    [anon_sym_nointerpolation] = ACTIONS(5606),
    [anon_sym_sample] = ACTIONS(5606),
    [anon_sym_linear] = ACTIONS(5606),
    [anon_sym_snorm] = ACTIONS(5606),
    [anon_sym_unorm] = ACTIONS(5606),
    [anon_sym_point] = ACTIONS(5606),
    [anon_sym_line] = ACTIONS(5606),
    [anon_sym_triangleadj] = ACTIONS(5606),
    [anon_sym_lineadj] = ACTIONS(5606),
    [anon_sym_triangle] = ACTIONS(5606),
    [anon_sym_interface] = ACTIONS(5606),
    [anon_sym_extension] = ACTIONS(5606),
    [anon_sym___init] = ACTIONS(5606),
    [anon_sym___subscript] = ACTIONS(5606),
    [anon_sym_property] = ACTIONS(5606),
    [anon_sym_associatedtype] = ACTIONS(5606),
  },
  [1647] = {
    [sym_identifier] = ACTIONS(5610),
    [aux_sym_preproc_def_token1] = ACTIONS(5610),
    [aux_sym_preproc_if_token1] = ACTIONS(5610),
    [aux_sym_preproc_if_token2] = ACTIONS(5610),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5610),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5610),
    [aux_sym_preproc_else_token1] = ACTIONS(5610),
    [aux_sym_preproc_elif_token1] = ACTIONS(5610),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5610),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5610),
    [sym_preproc_directive] = ACTIONS(5610),
    [anon_sym_LPAREN2] = ACTIONS(5612),
    [anon_sym_TILDE] = ACTIONS(5612),
    [anon_sym_STAR] = ACTIONS(5612),
    [anon_sym_AMP_AMP] = ACTIONS(5612),
    [anon_sym_AMP] = ACTIONS(5610),
    [anon_sym___extension__] = ACTIONS(5610),
    [anon_sym_typedef] = ACTIONS(5610),
    [anon_sym_in] = ACTIONS(5610),
    [anon_sym_out] = ACTIONS(5610),
    [anon_sym_inout] = ACTIONS(5610),
    [anon_sym_extern] = ACTIONS(5610),
    [anon_sym___attribute__] = ACTIONS(5610),
    [anon_sym_COLON_COLON] = ACTIONS(5612),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5612),
    [anon_sym___declspec] = ACTIONS(5610),
    [anon_sym___based] = ACTIONS(5610),
    [anon_sym_signed] = ACTIONS(5610),
    [anon_sym_unsigned] = ACTIONS(5610),
    [anon_sym_long] = ACTIONS(5610),
    [anon_sym_short] = ACTIONS(5610),
    [anon_sym_LBRACK] = ACTIONS(5610),
    [anon_sym_static] = ACTIONS(5610),
    [anon_sym_register] = ACTIONS(5610),
    [anon_sym_inline] = ACTIONS(5610),
    [anon_sym___inline] = ACTIONS(5610),
    [anon_sym___inline__] = ACTIONS(5610),
    [anon_sym___forceinline] = ACTIONS(5610),
    [anon_sym_thread_local] = ACTIONS(5610),
    [anon_sym___thread] = ACTIONS(5610),
    [anon_sym_const] = ACTIONS(5610),
    [anon_sym_constexpr] = ACTIONS(5610),
    [anon_sym_volatile] = ACTIONS(5610),
    [anon_sym_restrict] = ACTIONS(5610),
    [anon_sym___restrict__] = ACTIONS(5610),
    [anon_sym__Atomic] = ACTIONS(5610),
    [anon_sym__Noreturn] = ACTIONS(5610),
    [anon_sym_noreturn] = ACTIONS(5610),
    [anon_sym_mutable] = ACTIONS(5610),
    [anon_sym_constinit] = ACTIONS(5610),
    [anon_sym_consteval] = ACTIONS(5610),
    [anon_sym_alignas] = ACTIONS(5610),
    [anon_sym__Alignas] = ACTIONS(5610),
    [sym_primitive_type] = ACTIONS(5610),
    [anon_sym_enum] = ACTIONS(5610),
    [anon_sym_class] = ACTIONS(5610),
    [anon_sym_struct] = ACTIONS(5610),
    [anon_sym_union] = ACTIONS(5610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5610),
    [anon_sym_let] = ACTIONS(5610),
    [anon_sym_This] = ACTIONS(5610),
    [anon_sym_decltype] = ACTIONS(5610),
    [sym_virtual] = ACTIONS(5610),
    [anon_sym_explicit] = ACTIONS(5610),
    [anon_sym_typename] = ACTIONS(5610),
    [anon_sym_template] = ACTIONS(5610),
    [anon_sym_operator] = ACTIONS(5610),
    [anon_sym_friend] = ACTIONS(5610),
    [anon_sym_public] = ACTIONS(5610),
    [anon_sym_private] = ACTIONS(5610),
    [anon_sym_protected] = ACTIONS(5610),
    [anon_sym_using] = ACTIONS(5610),
    [anon_sym_static_assert] = ACTIONS(5610),
    [anon_sym_precise] = ACTIONS(5610),
    [anon_sym_shared] = ACTIONS(5610),
    [anon_sym_groupshared] = ACTIONS(5610),
    [anon_sym_uniform] = ACTIONS(5610),
    [anon_sym_row_major] = ACTIONS(5610),
    [anon_sym_column_major] = ACTIONS(5610),
    [anon_sym_globallycoherent] = ACTIONS(5610),
    [anon_sym_centroid] = ACTIONS(5610),
    [anon_sym_noperspective] = ACTIONS(5610),
    [anon_sym_nointerpolation] = ACTIONS(5610),
    [anon_sym_sample] = ACTIONS(5610),
    [anon_sym_linear] = ACTIONS(5610),
    [anon_sym_snorm] = ACTIONS(5610),
    [anon_sym_unorm] = ACTIONS(5610),
    [anon_sym_point] = ACTIONS(5610),
    [anon_sym_line] = ACTIONS(5610),
    [anon_sym_triangleadj] = ACTIONS(5610),
    [anon_sym_lineadj] = ACTIONS(5610),
    [anon_sym_triangle] = ACTIONS(5610),
    [anon_sym_interface] = ACTIONS(5610),
    [anon_sym_extension] = ACTIONS(5610),
    [anon_sym___init] = ACTIONS(5610),
    [anon_sym___subscript] = ACTIONS(5610),
    [anon_sym_property] = ACTIONS(5610),
    [anon_sym_associatedtype] = ACTIONS(5610),
  },
  [1648] = {
    [sym_identifier] = ACTIONS(5614),
    [aux_sym_preproc_def_token1] = ACTIONS(5614),
    [aux_sym_preproc_if_token1] = ACTIONS(5614),
    [aux_sym_preproc_if_token2] = ACTIONS(5614),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5614),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5614),
    [aux_sym_preproc_else_token1] = ACTIONS(5614),
    [aux_sym_preproc_elif_token1] = ACTIONS(5614),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5614),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5614),
    [sym_preproc_directive] = ACTIONS(5614),
    [anon_sym_LPAREN2] = ACTIONS(5616),
    [anon_sym_TILDE] = ACTIONS(5616),
    [anon_sym_STAR] = ACTIONS(5616),
    [anon_sym_AMP_AMP] = ACTIONS(5616),
    [anon_sym_AMP] = ACTIONS(5614),
    [anon_sym___extension__] = ACTIONS(5614),
    [anon_sym_typedef] = ACTIONS(5614),
    [anon_sym_in] = ACTIONS(5614),
    [anon_sym_out] = ACTIONS(5614),
    [anon_sym_inout] = ACTIONS(5614),
    [anon_sym_extern] = ACTIONS(5614),
    [anon_sym___attribute__] = ACTIONS(5614),
    [anon_sym_COLON_COLON] = ACTIONS(5616),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5616),
    [anon_sym___declspec] = ACTIONS(5614),
    [anon_sym___based] = ACTIONS(5614),
    [anon_sym_signed] = ACTIONS(5614),
    [anon_sym_unsigned] = ACTIONS(5614),
    [anon_sym_long] = ACTIONS(5614),
    [anon_sym_short] = ACTIONS(5614),
    [anon_sym_LBRACK] = ACTIONS(5614),
    [anon_sym_static] = ACTIONS(5614),
    [anon_sym_register] = ACTIONS(5614),
    [anon_sym_inline] = ACTIONS(5614),
    [anon_sym___inline] = ACTIONS(5614),
    [anon_sym___inline__] = ACTIONS(5614),
    [anon_sym___forceinline] = ACTIONS(5614),
    [anon_sym_thread_local] = ACTIONS(5614),
    [anon_sym___thread] = ACTIONS(5614),
    [anon_sym_const] = ACTIONS(5614),
    [anon_sym_constexpr] = ACTIONS(5614),
    [anon_sym_volatile] = ACTIONS(5614),
    [anon_sym_restrict] = ACTIONS(5614),
    [anon_sym___restrict__] = ACTIONS(5614),
    [anon_sym__Atomic] = ACTIONS(5614),
    [anon_sym__Noreturn] = ACTIONS(5614),
    [anon_sym_noreturn] = ACTIONS(5614),
    [anon_sym_mutable] = ACTIONS(5614),
    [anon_sym_constinit] = ACTIONS(5614),
    [anon_sym_consteval] = ACTIONS(5614),
    [anon_sym_alignas] = ACTIONS(5614),
    [anon_sym__Alignas] = ACTIONS(5614),
    [sym_primitive_type] = ACTIONS(5614),
    [anon_sym_enum] = ACTIONS(5614),
    [anon_sym_class] = ACTIONS(5614),
    [anon_sym_struct] = ACTIONS(5614),
    [anon_sym_union] = ACTIONS(5614),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5614),
    [anon_sym_let] = ACTIONS(5614),
    [anon_sym_This] = ACTIONS(5614),
    [anon_sym_decltype] = ACTIONS(5614),
    [sym_virtual] = ACTIONS(5614),
    [anon_sym_explicit] = ACTIONS(5614),
    [anon_sym_typename] = ACTIONS(5614),
    [anon_sym_template] = ACTIONS(5614),
    [anon_sym_operator] = ACTIONS(5614),
    [anon_sym_friend] = ACTIONS(5614),
    [anon_sym_public] = ACTIONS(5614),
    [anon_sym_private] = ACTIONS(5614),
    [anon_sym_protected] = ACTIONS(5614),
    [anon_sym_using] = ACTIONS(5614),
    [anon_sym_static_assert] = ACTIONS(5614),
    [anon_sym_precise] = ACTIONS(5614),
    [anon_sym_shared] = ACTIONS(5614),
    [anon_sym_groupshared] = ACTIONS(5614),
    [anon_sym_uniform] = ACTIONS(5614),
    [anon_sym_row_major] = ACTIONS(5614),
    [anon_sym_column_major] = ACTIONS(5614),
    [anon_sym_globallycoherent] = ACTIONS(5614),
    [anon_sym_centroid] = ACTIONS(5614),
    [anon_sym_noperspective] = ACTIONS(5614),
    [anon_sym_nointerpolation] = ACTIONS(5614),
    [anon_sym_sample] = ACTIONS(5614),
    [anon_sym_linear] = ACTIONS(5614),
    [anon_sym_snorm] = ACTIONS(5614),
    [anon_sym_unorm] = ACTIONS(5614),
    [anon_sym_point] = ACTIONS(5614),
    [anon_sym_line] = ACTIONS(5614),
    [anon_sym_triangleadj] = ACTIONS(5614),
    [anon_sym_lineadj] = ACTIONS(5614),
    [anon_sym_triangle] = ACTIONS(5614),
    [anon_sym_interface] = ACTIONS(5614),
    [anon_sym_extension] = ACTIONS(5614),
    [anon_sym___init] = ACTIONS(5614),
    [anon_sym___subscript] = ACTIONS(5614),
    [anon_sym_property] = ACTIONS(5614),
    [anon_sym_associatedtype] = ACTIONS(5614),
  },
  [1649] = {
    [sym_identifier] = ACTIONS(5618),
    [aux_sym_preproc_def_token1] = ACTIONS(5618),
    [aux_sym_preproc_if_token1] = ACTIONS(5618),
    [aux_sym_preproc_if_token2] = ACTIONS(5618),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5618),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5618),
    [aux_sym_preproc_else_token1] = ACTIONS(5618),
    [aux_sym_preproc_elif_token1] = ACTIONS(5618),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5618),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5618),
    [sym_preproc_directive] = ACTIONS(5618),
    [anon_sym_LPAREN2] = ACTIONS(5620),
    [anon_sym_TILDE] = ACTIONS(5620),
    [anon_sym_STAR] = ACTIONS(5620),
    [anon_sym_AMP_AMP] = ACTIONS(5620),
    [anon_sym_AMP] = ACTIONS(5618),
    [anon_sym___extension__] = ACTIONS(5618),
    [anon_sym_typedef] = ACTIONS(5618),
    [anon_sym_in] = ACTIONS(5618),
    [anon_sym_out] = ACTIONS(5618),
    [anon_sym_inout] = ACTIONS(5618),
    [anon_sym_extern] = ACTIONS(5618),
    [anon_sym___attribute__] = ACTIONS(5618),
    [anon_sym_COLON_COLON] = ACTIONS(5620),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5620),
    [anon_sym___declspec] = ACTIONS(5618),
    [anon_sym___based] = ACTIONS(5618),
    [anon_sym_signed] = ACTIONS(5618),
    [anon_sym_unsigned] = ACTIONS(5618),
    [anon_sym_long] = ACTIONS(5618),
    [anon_sym_short] = ACTIONS(5618),
    [anon_sym_LBRACK] = ACTIONS(5618),
    [anon_sym_static] = ACTIONS(5618),
    [anon_sym_register] = ACTIONS(5618),
    [anon_sym_inline] = ACTIONS(5618),
    [anon_sym___inline] = ACTIONS(5618),
    [anon_sym___inline__] = ACTIONS(5618),
    [anon_sym___forceinline] = ACTIONS(5618),
    [anon_sym_thread_local] = ACTIONS(5618),
    [anon_sym___thread] = ACTIONS(5618),
    [anon_sym_const] = ACTIONS(5618),
    [anon_sym_constexpr] = ACTIONS(5618),
    [anon_sym_volatile] = ACTIONS(5618),
    [anon_sym_restrict] = ACTIONS(5618),
    [anon_sym___restrict__] = ACTIONS(5618),
    [anon_sym__Atomic] = ACTIONS(5618),
    [anon_sym__Noreturn] = ACTIONS(5618),
    [anon_sym_noreturn] = ACTIONS(5618),
    [anon_sym_mutable] = ACTIONS(5618),
    [anon_sym_constinit] = ACTIONS(5618),
    [anon_sym_consteval] = ACTIONS(5618),
    [anon_sym_alignas] = ACTIONS(5618),
    [anon_sym__Alignas] = ACTIONS(5618),
    [sym_primitive_type] = ACTIONS(5618),
    [anon_sym_enum] = ACTIONS(5618),
    [anon_sym_class] = ACTIONS(5618),
    [anon_sym_struct] = ACTIONS(5618),
    [anon_sym_union] = ACTIONS(5618),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5618),
    [anon_sym_let] = ACTIONS(5618),
    [anon_sym_This] = ACTIONS(5618),
    [anon_sym_decltype] = ACTIONS(5618),
    [sym_virtual] = ACTIONS(5618),
    [anon_sym_explicit] = ACTIONS(5618),
    [anon_sym_typename] = ACTIONS(5618),
    [anon_sym_template] = ACTIONS(5618),
    [anon_sym_operator] = ACTIONS(5618),
    [anon_sym_friend] = ACTIONS(5618),
    [anon_sym_public] = ACTIONS(5618),
    [anon_sym_private] = ACTIONS(5618),
    [anon_sym_protected] = ACTIONS(5618),
    [anon_sym_using] = ACTIONS(5618),
    [anon_sym_static_assert] = ACTIONS(5618),
    [anon_sym_precise] = ACTIONS(5618),
    [anon_sym_shared] = ACTIONS(5618),
    [anon_sym_groupshared] = ACTIONS(5618),
    [anon_sym_uniform] = ACTIONS(5618),
    [anon_sym_row_major] = ACTIONS(5618),
    [anon_sym_column_major] = ACTIONS(5618),
    [anon_sym_globallycoherent] = ACTIONS(5618),
    [anon_sym_centroid] = ACTIONS(5618),
    [anon_sym_noperspective] = ACTIONS(5618),
    [anon_sym_nointerpolation] = ACTIONS(5618),
    [anon_sym_sample] = ACTIONS(5618),
    [anon_sym_linear] = ACTIONS(5618),
    [anon_sym_snorm] = ACTIONS(5618),
    [anon_sym_unorm] = ACTIONS(5618),
    [anon_sym_point] = ACTIONS(5618),
    [anon_sym_line] = ACTIONS(5618),
    [anon_sym_triangleadj] = ACTIONS(5618),
    [anon_sym_lineadj] = ACTIONS(5618),
    [anon_sym_triangle] = ACTIONS(5618),
    [anon_sym_interface] = ACTIONS(5618),
    [anon_sym_extension] = ACTIONS(5618),
    [anon_sym___init] = ACTIONS(5618),
    [anon_sym___subscript] = ACTIONS(5618),
    [anon_sym_property] = ACTIONS(5618),
    [anon_sym_associatedtype] = ACTIONS(5618),
  },
  [1650] = {
    [sym_identifier] = ACTIONS(5622),
    [aux_sym_preproc_def_token1] = ACTIONS(5622),
    [aux_sym_preproc_if_token1] = ACTIONS(5622),
    [aux_sym_preproc_if_token2] = ACTIONS(5622),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5622),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5622),
    [aux_sym_preproc_else_token1] = ACTIONS(5622),
    [aux_sym_preproc_elif_token1] = ACTIONS(5622),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5622),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5622),
    [sym_preproc_directive] = ACTIONS(5622),
    [anon_sym_LPAREN2] = ACTIONS(5624),
    [anon_sym_TILDE] = ACTIONS(5624),
    [anon_sym_STAR] = ACTIONS(5624),
    [anon_sym_AMP_AMP] = ACTIONS(5624),
    [anon_sym_AMP] = ACTIONS(5622),
    [anon_sym___extension__] = ACTIONS(5622),
    [anon_sym_typedef] = ACTIONS(5622),
    [anon_sym_in] = ACTIONS(5622),
    [anon_sym_out] = ACTIONS(5622),
    [anon_sym_inout] = ACTIONS(5622),
    [anon_sym_extern] = ACTIONS(5622),
    [anon_sym___attribute__] = ACTIONS(5622),
    [anon_sym_COLON_COLON] = ACTIONS(5624),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5624),
    [anon_sym___declspec] = ACTIONS(5622),
    [anon_sym___based] = ACTIONS(5622),
    [anon_sym_signed] = ACTIONS(5622),
    [anon_sym_unsigned] = ACTIONS(5622),
    [anon_sym_long] = ACTIONS(5622),
    [anon_sym_short] = ACTIONS(5622),
    [anon_sym_LBRACK] = ACTIONS(5622),
    [anon_sym_static] = ACTIONS(5622),
    [anon_sym_register] = ACTIONS(5622),
    [anon_sym_inline] = ACTIONS(5622),
    [anon_sym___inline] = ACTIONS(5622),
    [anon_sym___inline__] = ACTIONS(5622),
    [anon_sym___forceinline] = ACTIONS(5622),
    [anon_sym_thread_local] = ACTIONS(5622),
    [anon_sym___thread] = ACTIONS(5622),
    [anon_sym_const] = ACTIONS(5622),
    [anon_sym_constexpr] = ACTIONS(5622),
    [anon_sym_volatile] = ACTIONS(5622),
    [anon_sym_restrict] = ACTIONS(5622),
    [anon_sym___restrict__] = ACTIONS(5622),
    [anon_sym__Atomic] = ACTIONS(5622),
    [anon_sym__Noreturn] = ACTIONS(5622),
    [anon_sym_noreturn] = ACTIONS(5622),
    [anon_sym_mutable] = ACTIONS(5622),
    [anon_sym_constinit] = ACTIONS(5622),
    [anon_sym_consteval] = ACTIONS(5622),
    [anon_sym_alignas] = ACTIONS(5622),
    [anon_sym__Alignas] = ACTIONS(5622),
    [sym_primitive_type] = ACTIONS(5622),
    [anon_sym_enum] = ACTIONS(5622),
    [anon_sym_class] = ACTIONS(5622),
    [anon_sym_struct] = ACTIONS(5622),
    [anon_sym_union] = ACTIONS(5622),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5622),
    [anon_sym_let] = ACTIONS(5622),
    [anon_sym_This] = ACTIONS(5622),
    [anon_sym_decltype] = ACTIONS(5622),
    [sym_virtual] = ACTIONS(5622),
    [anon_sym_explicit] = ACTIONS(5622),
    [anon_sym_typename] = ACTIONS(5622),
    [anon_sym_template] = ACTIONS(5622),
    [anon_sym_operator] = ACTIONS(5622),
    [anon_sym_friend] = ACTIONS(5622),
    [anon_sym_public] = ACTIONS(5622),
    [anon_sym_private] = ACTIONS(5622),
    [anon_sym_protected] = ACTIONS(5622),
    [anon_sym_using] = ACTIONS(5622),
    [anon_sym_static_assert] = ACTIONS(5622),
    [anon_sym_precise] = ACTIONS(5622),
    [anon_sym_shared] = ACTIONS(5622),
    [anon_sym_groupshared] = ACTIONS(5622),
    [anon_sym_uniform] = ACTIONS(5622),
    [anon_sym_row_major] = ACTIONS(5622),
    [anon_sym_column_major] = ACTIONS(5622),
    [anon_sym_globallycoherent] = ACTIONS(5622),
    [anon_sym_centroid] = ACTIONS(5622),
    [anon_sym_noperspective] = ACTIONS(5622),
    [anon_sym_nointerpolation] = ACTIONS(5622),
    [anon_sym_sample] = ACTIONS(5622),
    [anon_sym_linear] = ACTIONS(5622),
    [anon_sym_snorm] = ACTIONS(5622),
    [anon_sym_unorm] = ACTIONS(5622),
    [anon_sym_point] = ACTIONS(5622),
    [anon_sym_line] = ACTIONS(5622),
    [anon_sym_triangleadj] = ACTIONS(5622),
    [anon_sym_lineadj] = ACTIONS(5622),
    [anon_sym_triangle] = ACTIONS(5622),
    [anon_sym_interface] = ACTIONS(5622),
    [anon_sym_extension] = ACTIONS(5622),
    [anon_sym___init] = ACTIONS(5622),
    [anon_sym___subscript] = ACTIONS(5622),
    [anon_sym_property] = ACTIONS(5622),
    [anon_sym_associatedtype] = ACTIONS(5622),
  },
  [1651] = {
    [sym_identifier] = ACTIONS(5564),
    [aux_sym_preproc_def_token1] = ACTIONS(5564),
    [aux_sym_preproc_if_token1] = ACTIONS(5564),
    [aux_sym_preproc_if_token2] = ACTIONS(5564),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5564),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5564),
    [aux_sym_preproc_else_token1] = ACTIONS(5564),
    [aux_sym_preproc_elif_token1] = ACTIONS(5564),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5564),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5564),
    [sym_preproc_directive] = ACTIONS(5564),
    [anon_sym_LPAREN2] = ACTIONS(5566),
    [anon_sym_TILDE] = ACTIONS(5566),
    [anon_sym_STAR] = ACTIONS(5566),
    [anon_sym_AMP_AMP] = ACTIONS(5566),
    [anon_sym_AMP] = ACTIONS(5564),
    [anon_sym___extension__] = ACTIONS(5564),
    [anon_sym_typedef] = ACTIONS(5564),
    [anon_sym_in] = ACTIONS(5564),
    [anon_sym_out] = ACTIONS(5564),
    [anon_sym_inout] = ACTIONS(5564),
    [anon_sym_extern] = ACTIONS(5564),
    [anon_sym___attribute__] = ACTIONS(5564),
    [anon_sym_COLON_COLON] = ACTIONS(5566),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5566),
    [anon_sym___declspec] = ACTIONS(5564),
    [anon_sym___based] = ACTIONS(5564),
    [anon_sym_signed] = ACTIONS(5564),
    [anon_sym_unsigned] = ACTIONS(5564),
    [anon_sym_long] = ACTIONS(5564),
    [anon_sym_short] = ACTIONS(5564),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_static] = ACTIONS(5564),
    [anon_sym_register] = ACTIONS(5564),
    [anon_sym_inline] = ACTIONS(5564),
    [anon_sym___inline] = ACTIONS(5564),
    [anon_sym___inline__] = ACTIONS(5564),
    [anon_sym___forceinline] = ACTIONS(5564),
    [anon_sym_thread_local] = ACTIONS(5564),
    [anon_sym___thread] = ACTIONS(5564),
    [anon_sym_const] = ACTIONS(5564),
    [anon_sym_constexpr] = ACTIONS(5564),
    [anon_sym_volatile] = ACTIONS(5564),
    [anon_sym_restrict] = ACTIONS(5564),
    [anon_sym___restrict__] = ACTIONS(5564),
    [anon_sym__Atomic] = ACTIONS(5564),
    [anon_sym__Noreturn] = ACTIONS(5564),
    [anon_sym_noreturn] = ACTIONS(5564),
    [anon_sym_mutable] = ACTIONS(5564),
    [anon_sym_constinit] = ACTIONS(5564),
    [anon_sym_consteval] = ACTIONS(5564),
    [anon_sym_alignas] = ACTIONS(5564),
    [anon_sym__Alignas] = ACTIONS(5564),
    [sym_primitive_type] = ACTIONS(5564),
    [anon_sym_enum] = ACTIONS(5564),
    [anon_sym_class] = ACTIONS(5564),
    [anon_sym_struct] = ACTIONS(5564),
    [anon_sym_union] = ACTIONS(5564),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5564),
    [anon_sym_let] = ACTIONS(5564),
    [anon_sym_This] = ACTIONS(5564),
    [anon_sym_decltype] = ACTIONS(5564),
    [sym_virtual] = ACTIONS(5564),
    [anon_sym_explicit] = ACTIONS(5564),
    [anon_sym_typename] = ACTIONS(5564),
    [anon_sym_template] = ACTIONS(5564),
    [anon_sym_operator] = ACTIONS(5564),
    [anon_sym_friend] = ACTIONS(5564),
    [anon_sym_public] = ACTIONS(5564),
    [anon_sym_private] = ACTIONS(5564),
    [anon_sym_protected] = ACTIONS(5564),
    [anon_sym_using] = ACTIONS(5564),
    [anon_sym_static_assert] = ACTIONS(5564),
    [anon_sym_precise] = ACTIONS(5564),
    [anon_sym_shared] = ACTIONS(5564),
    [anon_sym_groupshared] = ACTIONS(5564),
    [anon_sym_uniform] = ACTIONS(5564),
    [anon_sym_row_major] = ACTIONS(5564),
    [anon_sym_column_major] = ACTIONS(5564),
    [anon_sym_globallycoherent] = ACTIONS(5564),
    [anon_sym_centroid] = ACTIONS(5564),
    [anon_sym_noperspective] = ACTIONS(5564),
    [anon_sym_nointerpolation] = ACTIONS(5564),
    [anon_sym_sample] = ACTIONS(5564),
    [anon_sym_linear] = ACTIONS(5564),
    [anon_sym_snorm] = ACTIONS(5564),
    [anon_sym_unorm] = ACTIONS(5564),
    [anon_sym_point] = ACTIONS(5564),
    [anon_sym_line] = ACTIONS(5564),
    [anon_sym_triangleadj] = ACTIONS(5564),
    [anon_sym_lineadj] = ACTIONS(5564),
    [anon_sym_triangle] = ACTIONS(5564),
    [anon_sym_interface] = ACTIONS(5564),
    [anon_sym_extension] = ACTIONS(5564),
    [anon_sym___init] = ACTIONS(5564),
    [anon_sym___subscript] = ACTIONS(5564),
    [anon_sym_property] = ACTIONS(5564),
    [anon_sym_associatedtype] = ACTIONS(5564),
  },
  [1652] = {
    [sym_identifier] = ACTIONS(3467),
    [aux_sym_preproc_def_token1] = ACTIONS(3467),
    [aux_sym_preproc_if_token1] = ACTIONS(3467),
    [aux_sym_preproc_if_token2] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3467),
    [aux_sym_preproc_else_token1] = ACTIONS(3467),
    [aux_sym_preproc_elif_token1] = ACTIONS(3467),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3467),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3467),
    [sym_preproc_directive] = ACTIONS(3467),
    [anon_sym_LPAREN2] = ACTIONS(3469),
    [anon_sym_TILDE] = ACTIONS(3469),
    [anon_sym_STAR] = ACTIONS(3469),
    [anon_sym_AMP_AMP] = ACTIONS(3469),
    [anon_sym_AMP] = ACTIONS(3467),
    [anon_sym___extension__] = ACTIONS(3467),
    [anon_sym_typedef] = ACTIONS(3467),
    [anon_sym_in] = ACTIONS(3467),
    [anon_sym_out] = ACTIONS(3467),
    [anon_sym_inout] = ACTIONS(3467),
    [anon_sym_extern] = ACTIONS(3467),
    [anon_sym___attribute__] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(3469),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3469),
    [anon_sym___declspec] = ACTIONS(3467),
    [anon_sym___based] = ACTIONS(3467),
    [anon_sym_signed] = ACTIONS(3467),
    [anon_sym_unsigned] = ACTIONS(3467),
    [anon_sym_long] = ACTIONS(3467),
    [anon_sym_short] = ACTIONS(3467),
    [anon_sym_LBRACK] = ACTIONS(3467),
    [anon_sym_static] = ACTIONS(3467),
    [anon_sym_register] = ACTIONS(3467),
    [anon_sym_inline] = ACTIONS(3467),
    [anon_sym___inline] = ACTIONS(3467),
    [anon_sym___inline__] = ACTIONS(3467),
    [anon_sym___forceinline] = ACTIONS(3467),
    [anon_sym_thread_local] = ACTIONS(3467),
    [anon_sym___thread] = ACTIONS(3467),
    [anon_sym_const] = ACTIONS(3467),
    [anon_sym_constexpr] = ACTIONS(3467),
    [anon_sym_volatile] = ACTIONS(3467),
    [anon_sym_restrict] = ACTIONS(3467),
    [anon_sym___restrict__] = ACTIONS(3467),
    [anon_sym__Atomic] = ACTIONS(3467),
    [anon_sym__Noreturn] = ACTIONS(3467),
    [anon_sym_noreturn] = ACTIONS(3467),
    [anon_sym_mutable] = ACTIONS(3467),
    [anon_sym_constinit] = ACTIONS(3467),
    [anon_sym_consteval] = ACTIONS(3467),
    [anon_sym_alignas] = ACTIONS(3467),
    [anon_sym__Alignas] = ACTIONS(3467),
    [sym_primitive_type] = ACTIONS(3467),
    [anon_sym_enum] = ACTIONS(3467),
    [anon_sym_class] = ACTIONS(3467),
    [anon_sym_struct] = ACTIONS(3467),
    [anon_sym_union] = ACTIONS(3467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3467),
    [anon_sym_let] = ACTIONS(3467),
    [anon_sym_This] = ACTIONS(3467),
    [anon_sym_decltype] = ACTIONS(3467),
    [sym_virtual] = ACTIONS(3467),
    [anon_sym_explicit] = ACTIONS(3467),
    [anon_sym_typename] = ACTIONS(3467),
    [anon_sym_template] = ACTIONS(3467),
    [anon_sym_operator] = ACTIONS(3467),
    [anon_sym_friend] = ACTIONS(3467),
    [anon_sym_public] = ACTIONS(3467),
    [anon_sym_private] = ACTIONS(3467),
    [anon_sym_protected] = ACTIONS(3467),
    [anon_sym_using] = ACTIONS(3467),
    [anon_sym_static_assert] = ACTIONS(3467),
    [anon_sym_precise] = ACTIONS(3467),
    [anon_sym_shared] = ACTIONS(3467),
    [anon_sym_groupshared] = ACTIONS(3467),
    [anon_sym_uniform] = ACTIONS(3467),
    [anon_sym_row_major] = ACTIONS(3467),
    [anon_sym_column_major] = ACTIONS(3467),
    [anon_sym_globallycoherent] = ACTIONS(3467),
    [anon_sym_centroid] = ACTIONS(3467),
    [anon_sym_noperspective] = ACTIONS(3467),
    [anon_sym_nointerpolation] = ACTIONS(3467),
    [anon_sym_sample] = ACTIONS(3467),
    [anon_sym_linear] = ACTIONS(3467),
    [anon_sym_snorm] = ACTIONS(3467),
    [anon_sym_unorm] = ACTIONS(3467),
    [anon_sym_point] = ACTIONS(3467),
    [anon_sym_line] = ACTIONS(3467),
    [anon_sym_triangleadj] = ACTIONS(3467),
    [anon_sym_lineadj] = ACTIONS(3467),
    [anon_sym_triangle] = ACTIONS(3467),
    [anon_sym_interface] = ACTIONS(3467),
    [anon_sym_extension] = ACTIONS(3467),
    [anon_sym___init] = ACTIONS(3467),
    [anon_sym___subscript] = ACTIONS(3467),
    [anon_sym_property] = ACTIONS(3467),
    [anon_sym_associatedtype] = ACTIONS(3467),
  },
  [1653] = {
    [sym_identifier] = ACTIONS(3513),
    [aux_sym_preproc_def_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token2] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3513),
    [aux_sym_preproc_else_token1] = ACTIONS(3513),
    [aux_sym_preproc_elif_token1] = ACTIONS(3513),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3513),
    [sym_preproc_directive] = ACTIONS(3513),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3513),
    [anon_sym___extension__] = ACTIONS(3513),
    [anon_sym_typedef] = ACTIONS(3513),
    [anon_sym_in] = ACTIONS(3513),
    [anon_sym_out] = ACTIONS(3513),
    [anon_sym_inout] = ACTIONS(3513),
    [anon_sym_extern] = ACTIONS(3513),
    [anon_sym___attribute__] = ACTIONS(3513),
    [anon_sym_COLON_COLON] = ACTIONS(3515),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3515),
    [anon_sym___declspec] = ACTIONS(3513),
    [anon_sym___based] = ACTIONS(3513),
    [anon_sym_signed] = ACTIONS(3513),
    [anon_sym_unsigned] = ACTIONS(3513),
    [anon_sym_long] = ACTIONS(3513),
    [anon_sym_short] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_register] = ACTIONS(3513),
    [anon_sym_inline] = ACTIONS(3513),
    [anon_sym___inline] = ACTIONS(3513),
    [anon_sym___inline__] = ACTIONS(3513),
    [anon_sym___forceinline] = ACTIONS(3513),
    [anon_sym_thread_local] = ACTIONS(3513),
    [anon_sym___thread] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [anon_sym_constexpr] = ACTIONS(3513),
    [anon_sym_volatile] = ACTIONS(3513),
    [anon_sym_restrict] = ACTIONS(3513),
    [anon_sym___restrict__] = ACTIONS(3513),
    [anon_sym__Atomic] = ACTIONS(3513),
    [anon_sym__Noreturn] = ACTIONS(3513),
    [anon_sym_noreturn] = ACTIONS(3513),
    [anon_sym_mutable] = ACTIONS(3513),
    [anon_sym_constinit] = ACTIONS(3513),
    [anon_sym_consteval] = ACTIONS(3513),
    [anon_sym_alignas] = ACTIONS(3513),
    [anon_sym__Alignas] = ACTIONS(3513),
    [sym_primitive_type] = ACTIONS(3513),
    [anon_sym_enum] = ACTIONS(3513),
    [anon_sym_class] = ACTIONS(3513),
    [anon_sym_struct] = ACTIONS(3513),
    [anon_sym_union] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3513),
    [anon_sym_let] = ACTIONS(3513),
    [anon_sym_This] = ACTIONS(3513),
    [anon_sym_decltype] = ACTIONS(3513),
    [sym_virtual] = ACTIONS(3513),
    [anon_sym_explicit] = ACTIONS(3513),
    [anon_sym_typename] = ACTIONS(3513),
    [anon_sym_template] = ACTIONS(3513),
    [anon_sym_operator] = ACTIONS(3513),
    [anon_sym_friend] = ACTIONS(3513),
    [anon_sym_public] = ACTIONS(3513),
    [anon_sym_private] = ACTIONS(3513),
    [anon_sym_protected] = ACTIONS(3513),
    [anon_sym_using] = ACTIONS(3513),
    [anon_sym_static_assert] = ACTIONS(3513),
    [anon_sym_precise] = ACTIONS(3513),
    [anon_sym_shared] = ACTIONS(3513),
    [anon_sym_groupshared] = ACTIONS(3513),
    [anon_sym_uniform] = ACTIONS(3513),
    [anon_sym_row_major] = ACTIONS(3513),
    [anon_sym_column_major] = ACTIONS(3513),
    [anon_sym_globallycoherent] = ACTIONS(3513),
    [anon_sym_centroid] = ACTIONS(3513),
    [anon_sym_noperspective] = ACTIONS(3513),
    [anon_sym_nointerpolation] = ACTIONS(3513),
    [anon_sym_sample] = ACTIONS(3513),
    [anon_sym_linear] = ACTIONS(3513),
    [anon_sym_snorm] = ACTIONS(3513),
    [anon_sym_unorm] = ACTIONS(3513),
    [anon_sym_point] = ACTIONS(3513),
    [anon_sym_line] = ACTIONS(3513),
    [anon_sym_triangleadj] = ACTIONS(3513),
    [anon_sym_lineadj] = ACTIONS(3513),
    [anon_sym_triangle] = ACTIONS(3513),
    [anon_sym_interface] = ACTIONS(3513),
    [anon_sym_extension] = ACTIONS(3513),
    [anon_sym___init] = ACTIONS(3513),
    [anon_sym___subscript] = ACTIONS(3513),
    [anon_sym_property] = ACTIONS(3513),
    [anon_sym_associatedtype] = ACTIONS(3513),
  },
  [1654] = {
    [sym_identifier] = ACTIONS(3471),
    [aux_sym_preproc_def_token1] = ACTIONS(3471),
    [aux_sym_preproc_if_token1] = ACTIONS(3471),
    [aux_sym_preproc_if_token2] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3471),
    [aux_sym_preproc_else_token1] = ACTIONS(3471),
    [aux_sym_preproc_elif_token1] = ACTIONS(3471),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3471),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3471),
    [sym_preproc_directive] = ACTIONS(3471),
    [anon_sym_LPAREN2] = ACTIONS(3473),
    [anon_sym_TILDE] = ACTIONS(3473),
    [anon_sym_STAR] = ACTIONS(3473),
    [anon_sym_AMP_AMP] = ACTIONS(3473),
    [anon_sym_AMP] = ACTIONS(3471),
    [anon_sym___extension__] = ACTIONS(3471),
    [anon_sym_typedef] = ACTIONS(3471),
    [anon_sym_in] = ACTIONS(3471),
    [anon_sym_out] = ACTIONS(3471),
    [anon_sym_inout] = ACTIONS(3471),
    [anon_sym_extern] = ACTIONS(3471),
    [anon_sym___attribute__] = ACTIONS(3471),
    [anon_sym_COLON_COLON] = ACTIONS(3473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3473),
    [anon_sym___declspec] = ACTIONS(3471),
    [anon_sym___based] = ACTIONS(3471),
    [anon_sym_signed] = ACTIONS(3471),
    [anon_sym_unsigned] = ACTIONS(3471),
    [anon_sym_long] = ACTIONS(3471),
    [anon_sym_short] = ACTIONS(3471),
    [anon_sym_LBRACK] = ACTIONS(3471),
    [anon_sym_static] = ACTIONS(3471),
    [anon_sym_register] = ACTIONS(3471),
    [anon_sym_inline] = ACTIONS(3471),
    [anon_sym___inline] = ACTIONS(3471),
    [anon_sym___inline__] = ACTIONS(3471),
    [anon_sym___forceinline] = ACTIONS(3471),
    [anon_sym_thread_local] = ACTIONS(3471),
    [anon_sym___thread] = ACTIONS(3471),
    [anon_sym_const] = ACTIONS(3471),
    [anon_sym_constexpr] = ACTIONS(3471),
    [anon_sym_volatile] = ACTIONS(3471),
    [anon_sym_restrict] = ACTIONS(3471),
    [anon_sym___restrict__] = ACTIONS(3471),
    [anon_sym__Atomic] = ACTIONS(3471),
    [anon_sym__Noreturn] = ACTIONS(3471),
    [anon_sym_noreturn] = ACTIONS(3471),
    [anon_sym_mutable] = ACTIONS(3471),
    [anon_sym_constinit] = ACTIONS(3471),
    [anon_sym_consteval] = ACTIONS(3471),
    [anon_sym_alignas] = ACTIONS(3471),
    [anon_sym__Alignas] = ACTIONS(3471),
    [sym_primitive_type] = ACTIONS(3471),
    [anon_sym_enum] = ACTIONS(3471),
    [anon_sym_class] = ACTIONS(3471),
    [anon_sym_struct] = ACTIONS(3471),
    [anon_sym_union] = ACTIONS(3471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3471),
    [anon_sym_let] = ACTIONS(3471),
    [anon_sym_This] = ACTIONS(3471),
    [anon_sym_decltype] = ACTIONS(3471),
    [sym_virtual] = ACTIONS(3471),
    [anon_sym_explicit] = ACTIONS(3471),
    [anon_sym_typename] = ACTIONS(3471),
    [anon_sym_template] = ACTIONS(3471),
    [anon_sym_operator] = ACTIONS(3471),
    [anon_sym_friend] = ACTIONS(3471),
    [anon_sym_public] = ACTIONS(3471),
    [anon_sym_private] = ACTIONS(3471),
    [anon_sym_protected] = ACTIONS(3471),
    [anon_sym_using] = ACTIONS(3471),
    [anon_sym_static_assert] = ACTIONS(3471),
    [anon_sym_precise] = ACTIONS(3471),
    [anon_sym_shared] = ACTIONS(3471),
    [anon_sym_groupshared] = ACTIONS(3471),
    [anon_sym_uniform] = ACTIONS(3471),
    [anon_sym_row_major] = ACTIONS(3471),
    [anon_sym_column_major] = ACTIONS(3471),
    [anon_sym_globallycoherent] = ACTIONS(3471),
    [anon_sym_centroid] = ACTIONS(3471),
    [anon_sym_noperspective] = ACTIONS(3471),
    [anon_sym_nointerpolation] = ACTIONS(3471),
    [anon_sym_sample] = ACTIONS(3471),
    [anon_sym_linear] = ACTIONS(3471),
    [anon_sym_snorm] = ACTIONS(3471),
    [anon_sym_unorm] = ACTIONS(3471),
    [anon_sym_point] = ACTIONS(3471),
    [anon_sym_line] = ACTIONS(3471),
    [anon_sym_triangleadj] = ACTIONS(3471),
    [anon_sym_lineadj] = ACTIONS(3471),
    [anon_sym_triangle] = ACTIONS(3471),
    [anon_sym_interface] = ACTIONS(3471),
    [anon_sym_extension] = ACTIONS(3471),
    [anon_sym___init] = ACTIONS(3471),
    [anon_sym___subscript] = ACTIONS(3471),
    [anon_sym_property] = ACTIONS(3471),
    [anon_sym_associatedtype] = ACTIONS(3471),
  },
  [1655] = {
    [sym_identifier] = ACTIONS(3489),
    [aux_sym_preproc_def_token1] = ACTIONS(3489),
    [aux_sym_preproc_if_token1] = ACTIONS(3489),
    [aux_sym_preproc_if_token2] = ACTIONS(3489),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3489),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3489),
    [aux_sym_preproc_else_token1] = ACTIONS(3489),
    [aux_sym_preproc_elif_token1] = ACTIONS(3489),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3489),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3489),
    [sym_preproc_directive] = ACTIONS(3489),
    [anon_sym_LPAREN2] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3491),
    [anon_sym_STAR] = ACTIONS(3491),
    [anon_sym_AMP_AMP] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3489),
    [anon_sym___extension__] = ACTIONS(3489),
    [anon_sym_typedef] = ACTIONS(3489),
    [anon_sym_in] = ACTIONS(3489),
    [anon_sym_out] = ACTIONS(3489),
    [anon_sym_inout] = ACTIONS(3489),
    [anon_sym_extern] = ACTIONS(3489),
    [anon_sym___attribute__] = ACTIONS(3489),
    [anon_sym_COLON_COLON] = ACTIONS(3491),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3491),
    [anon_sym___declspec] = ACTIONS(3489),
    [anon_sym___based] = ACTIONS(3489),
    [anon_sym_signed] = ACTIONS(3489),
    [anon_sym_unsigned] = ACTIONS(3489),
    [anon_sym_long] = ACTIONS(3489),
    [anon_sym_short] = ACTIONS(3489),
    [anon_sym_LBRACK] = ACTIONS(3489),
    [anon_sym_static] = ACTIONS(3489),
    [anon_sym_register] = ACTIONS(3489),
    [anon_sym_inline] = ACTIONS(3489),
    [anon_sym___inline] = ACTIONS(3489),
    [anon_sym___inline__] = ACTIONS(3489),
    [anon_sym___forceinline] = ACTIONS(3489),
    [anon_sym_thread_local] = ACTIONS(3489),
    [anon_sym___thread] = ACTIONS(3489),
    [anon_sym_const] = ACTIONS(3489),
    [anon_sym_constexpr] = ACTIONS(3489),
    [anon_sym_volatile] = ACTIONS(3489),
    [anon_sym_restrict] = ACTIONS(3489),
    [anon_sym___restrict__] = ACTIONS(3489),
    [anon_sym__Atomic] = ACTIONS(3489),
    [anon_sym__Noreturn] = ACTIONS(3489),
    [anon_sym_noreturn] = ACTIONS(3489),
    [anon_sym_mutable] = ACTIONS(3489),
    [anon_sym_constinit] = ACTIONS(3489),
    [anon_sym_consteval] = ACTIONS(3489),
    [anon_sym_alignas] = ACTIONS(3489),
    [anon_sym__Alignas] = ACTIONS(3489),
    [sym_primitive_type] = ACTIONS(3489),
    [anon_sym_enum] = ACTIONS(3489),
    [anon_sym_class] = ACTIONS(3489),
    [anon_sym_struct] = ACTIONS(3489),
    [anon_sym_union] = ACTIONS(3489),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3489),
    [anon_sym_let] = ACTIONS(3489),
    [anon_sym_This] = ACTIONS(3489),
    [anon_sym_decltype] = ACTIONS(3489),
    [sym_virtual] = ACTIONS(3489),
    [anon_sym_explicit] = ACTIONS(3489),
    [anon_sym_typename] = ACTIONS(3489),
    [anon_sym_template] = ACTIONS(3489),
    [anon_sym_operator] = ACTIONS(3489),
    [anon_sym_friend] = ACTIONS(3489),
    [anon_sym_public] = ACTIONS(3489),
    [anon_sym_private] = ACTIONS(3489),
    [anon_sym_protected] = ACTIONS(3489),
    [anon_sym_using] = ACTIONS(3489),
    [anon_sym_static_assert] = ACTIONS(3489),
    [anon_sym_precise] = ACTIONS(3489),
    [anon_sym_shared] = ACTIONS(3489),
    [anon_sym_groupshared] = ACTIONS(3489),
    [anon_sym_uniform] = ACTIONS(3489),
    [anon_sym_row_major] = ACTIONS(3489),
    [anon_sym_column_major] = ACTIONS(3489),
    [anon_sym_globallycoherent] = ACTIONS(3489),
    [anon_sym_centroid] = ACTIONS(3489),
    [anon_sym_noperspective] = ACTIONS(3489),
    [anon_sym_nointerpolation] = ACTIONS(3489),
    [anon_sym_sample] = ACTIONS(3489),
    [anon_sym_linear] = ACTIONS(3489),
    [anon_sym_snorm] = ACTIONS(3489),
    [anon_sym_unorm] = ACTIONS(3489),
    [anon_sym_point] = ACTIONS(3489),
    [anon_sym_line] = ACTIONS(3489),
    [anon_sym_triangleadj] = ACTIONS(3489),
    [anon_sym_lineadj] = ACTIONS(3489),
    [anon_sym_triangle] = ACTIONS(3489),
    [anon_sym_interface] = ACTIONS(3489),
    [anon_sym_extension] = ACTIONS(3489),
    [anon_sym___init] = ACTIONS(3489),
    [anon_sym___subscript] = ACTIONS(3489),
    [anon_sym_property] = ACTIONS(3489),
    [anon_sym_associatedtype] = ACTIONS(3489),
  },
  [1656] = {
    [sym_identifier] = ACTIONS(3501),
    [aux_sym_preproc_def_token1] = ACTIONS(3501),
    [aux_sym_preproc_if_token1] = ACTIONS(3501),
    [aux_sym_preproc_if_token2] = ACTIONS(3501),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3501),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3501),
    [aux_sym_preproc_else_token1] = ACTIONS(3501),
    [aux_sym_preproc_elif_token1] = ACTIONS(3501),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3501),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3501),
    [sym_preproc_directive] = ACTIONS(3501),
    [anon_sym_LPAREN2] = ACTIONS(3503),
    [anon_sym_TILDE] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(3503),
    [anon_sym_AMP_AMP] = ACTIONS(3503),
    [anon_sym_AMP] = ACTIONS(3501),
    [anon_sym___extension__] = ACTIONS(3501),
    [anon_sym_typedef] = ACTIONS(3501),
    [anon_sym_in] = ACTIONS(3501),
    [anon_sym_out] = ACTIONS(3501),
    [anon_sym_inout] = ACTIONS(3501),
    [anon_sym_extern] = ACTIONS(3501),
    [anon_sym___attribute__] = ACTIONS(3501),
    [anon_sym_COLON_COLON] = ACTIONS(3503),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3503),
    [anon_sym___declspec] = ACTIONS(3501),
    [anon_sym___based] = ACTIONS(3501),
    [anon_sym_signed] = ACTIONS(3501),
    [anon_sym_unsigned] = ACTIONS(3501),
    [anon_sym_long] = ACTIONS(3501),
    [anon_sym_short] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(3501),
    [anon_sym_static] = ACTIONS(3501),
    [anon_sym_register] = ACTIONS(3501),
    [anon_sym_inline] = ACTIONS(3501),
    [anon_sym___inline] = ACTIONS(3501),
    [anon_sym___inline__] = ACTIONS(3501),
    [anon_sym___forceinline] = ACTIONS(3501),
    [anon_sym_thread_local] = ACTIONS(3501),
    [anon_sym___thread] = ACTIONS(3501),
    [anon_sym_const] = ACTIONS(3501),
    [anon_sym_constexpr] = ACTIONS(3501),
    [anon_sym_volatile] = ACTIONS(3501),
    [anon_sym_restrict] = ACTIONS(3501),
    [anon_sym___restrict__] = ACTIONS(3501),
    [anon_sym__Atomic] = ACTIONS(3501),
    [anon_sym__Noreturn] = ACTIONS(3501),
    [anon_sym_noreturn] = ACTIONS(3501),
    [anon_sym_mutable] = ACTIONS(3501),
    [anon_sym_constinit] = ACTIONS(3501),
    [anon_sym_consteval] = ACTIONS(3501),
    [anon_sym_alignas] = ACTIONS(3501),
    [anon_sym__Alignas] = ACTIONS(3501),
    [sym_primitive_type] = ACTIONS(3501),
    [anon_sym_enum] = ACTIONS(3501),
    [anon_sym_class] = ACTIONS(3501),
    [anon_sym_struct] = ACTIONS(3501),
    [anon_sym_union] = ACTIONS(3501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3501),
    [anon_sym_let] = ACTIONS(3501),
    [anon_sym_This] = ACTIONS(3501),
    [anon_sym_decltype] = ACTIONS(3501),
    [sym_virtual] = ACTIONS(3501),
    [anon_sym_explicit] = ACTIONS(3501),
    [anon_sym_typename] = ACTIONS(3501),
    [anon_sym_template] = ACTIONS(3501),
    [anon_sym_operator] = ACTIONS(3501),
    [anon_sym_friend] = ACTIONS(3501),
    [anon_sym_public] = ACTIONS(3501),
    [anon_sym_private] = ACTIONS(3501),
    [anon_sym_protected] = ACTIONS(3501),
    [anon_sym_using] = ACTIONS(3501),
    [anon_sym_static_assert] = ACTIONS(3501),
    [anon_sym_precise] = ACTIONS(3501),
    [anon_sym_shared] = ACTIONS(3501),
    [anon_sym_groupshared] = ACTIONS(3501),
    [anon_sym_uniform] = ACTIONS(3501),
    [anon_sym_row_major] = ACTIONS(3501),
    [anon_sym_column_major] = ACTIONS(3501),
    [anon_sym_globallycoherent] = ACTIONS(3501),
    [anon_sym_centroid] = ACTIONS(3501),
    [anon_sym_noperspective] = ACTIONS(3501),
    [anon_sym_nointerpolation] = ACTIONS(3501),
    [anon_sym_sample] = ACTIONS(3501),
    [anon_sym_linear] = ACTIONS(3501),
    [anon_sym_snorm] = ACTIONS(3501),
    [anon_sym_unorm] = ACTIONS(3501),
    [anon_sym_point] = ACTIONS(3501),
    [anon_sym_line] = ACTIONS(3501),
    [anon_sym_triangleadj] = ACTIONS(3501),
    [anon_sym_lineadj] = ACTIONS(3501),
    [anon_sym_triangle] = ACTIONS(3501),
    [anon_sym_interface] = ACTIONS(3501),
    [anon_sym_extension] = ACTIONS(3501),
    [anon_sym___init] = ACTIONS(3501),
    [anon_sym___subscript] = ACTIONS(3501),
    [anon_sym_property] = ACTIONS(3501),
    [anon_sym_associatedtype] = ACTIONS(3501),
  },
  [1657] = {
    [sym_identifier] = ACTIONS(3410),
    [aux_sym_preproc_def_token1] = ACTIONS(3410),
    [aux_sym_preproc_if_token1] = ACTIONS(3410),
    [aux_sym_preproc_if_token2] = ACTIONS(3410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3410),
    [aux_sym_preproc_else_token1] = ACTIONS(3410),
    [aux_sym_preproc_elif_token1] = ACTIONS(3410),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3410),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3410),
    [sym_preproc_directive] = ACTIONS(3410),
    [anon_sym_LPAREN2] = ACTIONS(3412),
    [anon_sym_TILDE] = ACTIONS(3412),
    [anon_sym_STAR] = ACTIONS(3412),
    [anon_sym_AMP_AMP] = ACTIONS(3412),
    [anon_sym_AMP] = ACTIONS(3410),
    [anon_sym___extension__] = ACTIONS(3410),
    [anon_sym_typedef] = ACTIONS(3410),
    [anon_sym_in] = ACTIONS(3410),
    [anon_sym_out] = ACTIONS(3410),
    [anon_sym_inout] = ACTIONS(3410),
    [anon_sym_extern] = ACTIONS(3410),
    [anon_sym___attribute__] = ACTIONS(3410),
    [anon_sym_COLON_COLON] = ACTIONS(3412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3412),
    [anon_sym___declspec] = ACTIONS(3410),
    [anon_sym___based] = ACTIONS(3410),
    [anon_sym_signed] = ACTIONS(3410),
    [anon_sym_unsigned] = ACTIONS(3410),
    [anon_sym_long] = ACTIONS(3410),
    [anon_sym_short] = ACTIONS(3410),
    [anon_sym_LBRACK] = ACTIONS(3410),
    [anon_sym_static] = ACTIONS(3410),
    [anon_sym_register] = ACTIONS(3410),
    [anon_sym_inline] = ACTIONS(3410),
    [anon_sym___inline] = ACTIONS(3410),
    [anon_sym___inline__] = ACTIONS(3410),
    [anon_sym___forceinline] = ACTIONS(3410),
    [anon_sym_thread_local] = ACTIONS(3410),
    [anon_sym___thread] = ACTIONS(3410),
    [anon_sym_const] = ACTIONS(3410),
    [anon_sym_constexpr] = ACTIONS(3410),
    [anon_sym_volatile] = ACTIONS(3410),
    [anon_sym_restrict] = ACTIONS(3410),
    [anon_sym___restrict__] = ACTIONS(3410),
    [anon_sym__Atomic] = ACTIONS(3410),
    [anon_sym__Noreturn] = ACTIONS(3410),
    [anon_sym_noreturn] = ACTIONS(3410),
    [anon_sym_mutable] = ACTIONS(3410),
    [anon_sym_constinit] = ACTIONS(3410),
    [anon_sym_consteval] = ACTIONS(3410),
    [anon_sym_alignas] = ACTIONS(3410),
    [anon_sym__Alignas] = ACTIONS(3410),
    [sym_primitive_type] = ACTIONS(3410),
    [anon_sym_enum] = ACTIONS(3410),
    [anon_sym_class] = ACTIONS(3410),
    [anon_sym_struct] = ACTIONS(3410),
    [anon_sym_union] = ACTIONS(3410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3410),
    [anon_sym_let] = ACTIONS(3410),
    [anon_sym_This] = ACTIONS(3410),
    [anon_sym_decltype] = ACTIONS(3410),
    [sym_virtual] = ACTIONS(3410),
    [anon_sym_explicit] = ACTIONS(3410),
    [anon_sym_typename] = ACTIONS(3410),
    [anon_sym_template] = ACTIONS(3410),
    [anon_sym_operator] = ACTIONS(3410),
    [anon_sym_friend] = ACTIONS(3410),
    [anon_sym_public] = ACTIONS(3410),
    [anon_sym_private] = ACTIONS(3410),
    [anon_sym_protected] = ACTIONS(3410),
    [anon_sym_using] = ACTIONS(3410),
    [anon_sym_static_assert] = ACTIONS(3410),
    [anon_sym_precise] = ACTIONS(3410),
    [anon_sym_shared] = ACTIONS(3410),
    [anon_sym_groupshared] = ACTIONS(3410),
    [anon_sym_uniform] = ACTIONS(3410),
    [anon_sym_row_major] = ACTIONS(3410),
    [anon_sym_column_major] = ACTIONS(3410),
    [anon_sym_globallycoherent] = ACTIONS(3410),
    [anon_sym_centroid] = ACTIONS(3410),
    [anon_sym_noperspective] = ACTIONS(3410),
    [anon_sym_nointerpolation] = ACTIONS(3410),
    [anon_sym_sample] = ACTIONS(3410),
    [anon_sym_linear] = ACTIONS(3410),
    [anon_sym_snorm] = ACTIONS(3410),
    [anon_sym_unorm] = ACTIONS(3410),
    [anon_sym_point] = ACTIONS(3410),
    [anon_sym_line] = ACTIONS(3410),
    [anon_sym_triangleadj] = ACTIONS(3410),
    [anon_sym_lineadj] = ACTIONS(3410),
    [anon_sym_triangle] = ACTIONS(3410),
    [anon_sym_interface] = ACTIONS(3410),
    [anon_sym_extension] = ACTIONS(3410),
    [anon_sym___init] = ACTIONS(3410),
    [anon_sym___subscript] = ACTIONS(3410),
    [anon_sym_property] = ACTIONS(3410),
    [anon_sym_associatedtype] = ACTIONS(3410),
  },
  [1658] = {
    [sym_identifier] = ACTIONS(5626),
    [aux_sym_preproc_def_token1] = ACTIONS(5626),
    [aux_sym_preproc_if_token1] = ACTIONS(5626),
    [aux_sym_preproc_if_token2] = ACTIONS(5626),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5626),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5626),
    [aux_sym_preproc_else_token1] = ACTIONS(5626),
    [aux_sym_preproc_elif_token1] = ACTIONS(5626),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5626),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5626),
    [sym_preproc_directive] = ACTIONS(5626),
    [anon_sym_LPAREN2] = ACTIONS(5628),
    [anon_sym_TILDE] = ACTIONS(5628),
    [anon_sym_STAR] = ACTIONS(5628),
    [anon_sym_AMP_AMP] = ACTIONS(5628),
    [anon_sym_AMP] = ACTIONS(5626),
    [anon_sym___extension__] = ACTIONS(5626),
    [anon_sym_typedef] = ACTIONS(5626),
    [anon_sym_in] = ACTIONS(5626),
    [anon_sym_out] = ACTIONS(5626),
    [anon_sym_inout] = ACTIONS(5626),
    [anon_sym_extern] = ACTIONS(5626),
    [anon_sym___attribute__] = ACTIONS(5626),
    [anon_sym_COLON_COLON] = ACTIONS(5628),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5628),
    [anon_sym___declspec] = ACTIONS(5626),
    [anon_sym___based] = ACTIONS(5626),
    [anon_sym_signed] = ACTIONS(5626),
    [anon_sym_unsigned] = ACTIONS(5626),
    [anon_sym_long] = ACTIONS(5626),
    [anon_sym_short] = ACTIONS(5626),
    [anon_sym_LBRACK] = ACTIONS(5626),
    [anon_sym_static] = ACTIONS(5626),
    [anon_sym_register] = ACTIONS(5626),
    [anon_sym_inline] = ACTIONS(5626),
    [anon_sym___inline] = ACTIONS(5626),
    [anon_sym___inline__] = ACTIONS(5626),
    [anon_sym___forceinline] = ACTIONS(5626),
    [anon_sym_thread_local] = ACTIONS(5626),
    [anon_sym___thread] = ACTIONS(5626),
    [anon_sym_const] = ACTIONS(5626),
    [anon_sym_constexpr] = ACTIONS(5626),
    [anon_sym_volatile] = ACTIONS(5626),
    [anon_sym_restrict] = ACTIONS(5626),
    [anon_sym___restrict__] = ACTIONS(5626),
    [anon_sym__Atomic] = ACTIONS(5626),
    [anon_sym__Noreturn] = ACTIONS(5626),
    [anon_sym_noreturn] = ACTIONS(5626),
    [anon_sym_mutable] = ACTIONS(5626),
    [anon_sym_constinit] = ACTIONS(5626),
    [anon_sym_consteval] = ACTIONS(5626),
    [anon_sym_alignas] = ACTIONS(5626),
    [anon_sym__Alignas] = ACTIONS(5626),
    [sym_primitive_type] = ACTIONS(5626),
    [anon_sym_enum] = ACTIONS(5626),
    [anon_sym_class] = ACTIONS(5626),
    [anon_sym_struct] = ACTIONS(5626),
    [anon_sym_union] = ACTIONS(5626),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5626),
    [anon_sym_let] = ACTIONS(5626),
    [anon_sym_This] = ACTIONS(5626),
    [anon_sym_decltype] = ACTIONS(5626),
    [sym_virtual] = ACTIONS(5626),
    [anon_sym_explicit] = ACTIONS(5626),
    [anon_sym_typename] = ACTIONS(5626),
    [anon_sym_template] = ACTIONS(5626),
    [anon_sym_operator] = ACTIONS(5626),
    [anon_sym_friend] = ACTIONS(5626),
    [anon_sym_public] = ACTIONS(5626),
    [anon_sym_private] = ACTIONS(5626),
    [anon_sym_protected] = ACTIONS(5626),
    [anon_sym_using] = ACTIONS(5626),
    [anon_sym_static_assert] = ACTIONS(5626),
    [anon_sym_precise] = ACTIONS(5626),
    [anon_sym_shared] = ACTIONS(5626),
    [anon_sym_groupshared] = ACTIONS(5626),
    [anon_sym_uniform] = ACTIONS(5626),
    [anon_sym_row_major] = ACTIONS(5626),
    [anon_sym_column_major] = ACTIONS(5626),
    [anon_sym_globallycoherent] = ACTIONS(5626),
    [anon_sym_centroid] = ACTIONS(5626),
    [anon_sym_noperspective] = ACTIONS(5626),
    [anon_sym_nointerpolation] = ACTIONS(5626),
    [anon_sym_sample] = ACTIONS(5626),
    [anon_sym_linear] = ACTIONS(5626),
    [anon_sym_snorm] = ACTIONS(5626),
    [anon_sym_unorm] = ACTIONS(5626),
    [anon_sym_point] = ACTIONS(5626),
    [anon_sym_line] = ACTIONS(5626),
    [anon_sym_triangleadj] = ACTIONS(5626),
    [anon_sym_lineadj] = ACTIONS(5626),
    [anon_sym_triangle] = ACTIONS(5626),
    [anon_sym_interface] = ACTIONS(5626),
    [anon_sym_extension] = ACTIONS(5626),
    [anon_sym___init] = ACTIONS(5626),
    [anon_sym___subscript] = ACTIONS(5626),
    [anon_sym_property] = ACTIONS(5626),
    [anon_sym_associatedtype] = ACTIONS(5626),
  },
  [1659] = {
    [sym_identifier] = ACTIONS(3410),
    [aux_sym_preproc_def_token1] = ACTIONS(3410),
    [aux_sym_preproc_if_token1] = ACTIONS(3410),
    [aux_sym_preproc_if_token2] = ACTIONS(3410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3410),
    [aux_sym_preproc_else_token1] = ACTIONS(3410),
    [aux_sym_preproc_elif_token1] = ACTIONS(3410),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3410),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3410),
    [sym_preproc_directive] = ACTIONS(3410),
    [anon_sym_LPAREN2] = ACTIONS(3412),
    [anon_sym_TILDE] = ACTIONS(3412),
    [anon_sym_STAR] = ACTIONS(3412),
    [anon_sym_AMP_AMP] = ACTIONS(3412),
    [anon_sym_AMP] = ACTIONS(3410),
    [anon_sym___extension__] = ACTIONS(3410),
    [anon_sym_typedef] = ACTIONS(3410),
    [anon_sym_in] = ACTIONS(3410),
    [anon_sym_out] = ACTIONS(3410),
    [anon_sym_inout] = ACTIONS(3410),
    [anon_sym_extern] = ACTIONS(3410),
    [anon_sym___attribute__] = ACTIONS(3410),
    [anon_sym_COLON_COLON] = ACTIONS(3412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3412),
    [anon_sym___declspec] = ACTIONS(3410),
    [anon_sym___based] = ACTIONS(3410),
    [anon_sym_signed] = ACTIONS(3410),
    [anon_sym_unsigned] = ACTIONS(3410),
    [anon_sym_long] = ACTIONS(3410),
    [anon_sym_short] = ACTIONS(3410),
    [anon_sym_LBRACK] = ACTIONS(3410),
    [anon_sym_static] = ACTIONS(3410),
    [anon_sym_register] = ACTIONS(3410),
    [anon_sym_inline] = ACTIONS(3410),
    [anon_sym___inline] = ACTIONS(3410),
    [anon_sym___inline__] = ACTIONS(3410),
    [anon_sym___forceinline] = ACTIONS(3410),
    [anon_sym_thread_local] = ACTIONS(3410),
    [anon_sym___thread] = ACTIONS(3410),
    [anon_sym_const] = ACTIONS(3410),
    [anon_sym_constexpr] = ACTIONS(3410),
    [anon_sym_volatile] = ACTIONS(3410),
    [anon_sym_restrict] = ACTIONS(3410),
    [anon_sym___restrict__] = ACTIONS(3410),
    [anon_sym__Atomic] = ACTIONS(3410),
    [anon_sym__Noreturn] = ACTIONS(3410),
    [anon_sym_noreturn] = ACTIONS(3410),
    [anon_sym_mutable] = ACTIONS(3410),
    [anon_sym_constinit] = ACTIONS(3410),
    [anon_sym_consteval] = ACTIONS(3410),
    [anon_sym_alignas] = ACTIONS(3410),
    [anon_sym__Alignas] = ACTIONS(3410),
    [sym_primitive_type] = ACTIONS(3410),
    [anon_sym_enum] = ACTIONS(3410),
    [anon_sym_class] = ACTIONS(3410),
    [anon_sym_struct] = ACTIONS(3410),
    [anon_sym_union] = ACTIONS(3410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3410),
    [anon_sym_let] = ACTIONS(3410),
    [anon_sym_This] = ACTIONS(3410),
    [anon_sym_decltype] = ACTIONS(3410),
    [sym_virtual] = ACTIONS(3410),
    [anon_sym_explicit] = ACTIONS(3410),
    [anon_sym_typename] = ACTIONS(3410),
    [anon_sym_template] = ACTIONS(3410),
    [anon_sym_operator] = ACTIONS(3410),
    [anon_sym_friend] = ACTIONS(3410),
    [anon_sym_public] = ACTIONS(3410),
    [anon_sym_private] = ACTIONS(3410),
    [anon_sym_protected] = ACTIONS(3410),
    [anon_sym_using] = ACTIONS(3410),
    [anon_sym_static_assert] = ACTIONS(3410),
    [anon_sym_precise] = ACTIONS(3410),
    [anon_sym_shared] = ACTIONS(3410),
    [anon_sym_groupshared] = ACTIONS(3410),
    [anon_sym_uniform] = ACTIONS(3410),
    [anon_sym_row_major] = ACTIONS(3410),
    [anon_sym_column_major] = ACTIONS(3410),
    [anon_sym_globallycoherent] = ACTIONS(3410),
    [anon_sym_centroid] = ACTIONS(3410),
    [anon_sym_noperspective] = ACTIONS(3410),
    [anon_sym_nointerpolation] = ACTIONS(3410),
    [anon_sym_sample] = ACTIONS(3410),
    [anon_sym_linear] = ACTIONS(3410),
    [anon_sym_snorm] = ACTIONS(3410),
    [anon_sym_unorm] = ACTIONS(3410),
    [anon_sym_point] = ACTIONS(3410),
    [anon_sym_line] = ACTIONS(3410),
    [anon_sym_triangleadj] = ACTIONS(3410),
    [anon_sym_lineadj] = ACTIONS(3410),
    [anon_sym_triangle] = ACTIONS(3410),
    [anon_sym_interface] = ACTIONS(3410),
    [anon_sym_extension] = ACTIONS(3410),
    [anon_sym___init] = ACTIONS(3410),
    [anon_sym___subscript] = ACTIONS(3410),
    [anon_sym_property] = ACTIONS(3410),
    [anon_sym_associatedtype] = ACTIONS(3410),
  },
  [1660] = {
    [sym_identifier] = ACTIONS(5630),
    [aux_sym_preproc_def_token1] = ACTIONS(5630),
    [aux_sym_preproc_if_token1] = ACTIONS(5630),
    [aux_sym_preproc_if_token2] = ACTIONS(5630),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5630),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5630),
    [aux_sym_preproc_else_token1] = ACTIONS(5630),
    [aux_sym_preproc_elif_token1] = ACTIONS(5630),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5630),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5630),
    [sym_preproc_directive] = ACTIONS(5630),
    [anon_sym_LPAREN2] = ACTIONS(5632),
    [anon_sym_TILDE] = ACTIONS(5632),
    [anon_sym_STAR] = ACTIONS(5632),
    [anon_sym_AMP_AMP] = ACTIONS(5632),
    [anon_sym_AMP] = ACTIONS(5630),
    [anon_sym___extension__] = ACTIONS(5630),
    [anon_sym_typedef] = ACTIONS(5630),
    [anon_sym_in] = ACTIONS(5630),
    [anon_sym_out] = ACTIONS(5630),
    [anon_sym_inout] = ACTIONS(5630),
    [anon_sym_extern] = ACTIONS(5630),
    [anon_sym___attribute__] = ACTIONS(5630),
    [anon_sym_COLON_COLON] = ACTIONS(5632),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5632),
    [anon_sym___declspec] = ACTIONS(5630),
    [anon_sym___based] = ACTIONS(5630),
    [anon_sym_signed] = ACTIONS(5630),
    [anon_sym_unsigned] = ACTIONS(5630),
    [anon_sym_long] = ACTIONS(5630),
    [anon_sym_short] = ACTIONS(5630),
    [anon_sym_LBRACK] = ACTIONS(5630),
    [anon_sym_static] = ACTIONS(5630),
    [anon_sym_register] = ACTIONS(5630),
    [anon_sym_inline] = ACTIONS(5630),
    [anon_sym___inline] = ACTIONS(5630),
    [anon_sym___inline__] = ACTIONS(5630),
    [anon_sym___forceinline] = ACTIONS(5630),
    [anon_sym_thread_local] = ACTIONS(5630),
    [anon_sym___thread] = ACTIONS(5630),
    [anon_sym_const] = ACTIONS(5630),
    [anon_sym_constexpr] = ACTIONS(5630),
    [anon_sym_volatile] = ACTIONS(5630),
    [anon_sym_restrict] = ACTIONS(5630),
    [anon_sym___restrict__] = ACTIONS(5630),
    [anon_sym__Atomic] = ACTIONS(5630),
    [anon_sym__Noreturn] = ACTIONS(5630),
    [anon_sym_noreturn] = ACTIONS(5630),
    [anon_sym_mutable] = ACTIONS(5630),
    [anon_sym_constinit] = ACTIONS(5630),
    [anon_sym_consteval] = ACTIONS(5630),
    [anon_sym_alignas] = ACTIONS(5630),
    [anon_sym__Alignas] = ACTIONS(5630),
    [sym_primitive_type] = ACTIONS(5630),
    [anon_sym_enum] = ACTIONS(5630),
    [anon_sym_class] = ACTIONS(5630),
    [anon_sym_struct] = ACTIONS(5630),
    [anon_sym_union] = ACTIONS(5630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5630),
    [anon_sym_let] = ACTIONS(5630),
    [anon_sym_This] = ACTIONS(5630),
    [anon_sym_decltype] = ACTIONS(5630),
    [sym_virtual] = ACTIONS(5630),
    [anon_sym_explicit] = ACTIONS(5630),
    [anon_sym_typename] = ACTIONS(5630),
    [anon_sym_template] = ACTIONS(5630),
    [anon_sym_operator] = ACTIONS(5630),
    [anon_sym_friend] = ACTIONS(5630),
    [anon_sym_public] = ACTIONS(5630),
    [anon_sym_private] = ACTIONS(5630),
    [anon_sym_protected] = ACTIONS(5630),
    [anon_sym_using] = ACTIONS(5630),
    [anon_sym_static_assert] = ACTIONS(5630),
    [anon_sym_precise] = ACTIONS(5630),
    [anon_sym_shared] = ACTIONS(5630),
    [anon_sym_groupshared] = ACTIONS(5630),
    [anon_sym_uniform] = ACTIONS(5630),
    [anon_sym_row_major] = ACTIONS(5630),
    [anon_sym_column_major] = ACTIONS(5630),
    [anon_sym_globallycoherent] = ACTIONS(5630),
    [anon_sym_centroid] = ACTIONS(5630),
    [anon_sym_noperspective] = ACTIONS(5630),
    [anon_sym_nointerpolation] = ACTIONS(5630),
    [anon_sym_sample] = ACTIONS(5630),
    [anon_sym_linear] = ACTIONS(5630),
    [anon_sym_snorm] = ACTIONS(5630),
    [anon_sym_unorm] = ACTIONS(5630),
    [anon_sym_point] = ACTIONS(5630),
    [anon_sym_line] = ACTIONS(5630),
    [anon_sym_triangleadj] = ACTIONS(5630),
    [anon_sym_lineadj] = ACTIONS(5630),
    [anon_sym_triangle] = ACTIONS(5630),
    [anon_sym_interface] = ACTIONS(5630),
    [anon_sym_extension] = ACTIONS(5630),
    [anon_sym___init] = ACTIONS(5630),
    [anon_sym___subscript] = ACTIONS(5630),
    [anon_sym_property] = ACTIONS(5630),
    [anon_sym_associatedtype] = ACTIONS(5630),
  },
  [1661] = {
    [sym_identifier] = ACTIONS(5634),
    [aux_sym_preproc_def_token1] = ACTIONS(5634),
    [aux_sym_preproc_if_token1] = ACTIONS(5634),
    [aux_sym_preproc_if_token2] = ACTIONS(5634),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5634),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5634),
    [aux_sym_preproc_else_token1] = ACTIONS(5634),
    [aux_sym_preproc_elif_token1] = ACTIONS(5634),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5634),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5634),
    [sym_preproc_directive] = ACTIONS(5634),
    [anon_sym_LPAREN2] = ACTIONS(5636),
    [anon_sym_TILDE] = ACTIONS(5636),
    [anon_sym_STAR] = ACTIONS(5636),
    [anon_sym_AMP_AMP] = ACTIONS(5636),
    [anon_sym_AMP] = ACTIONS(5634),
    [anon_sym___extension__] = ACTIONS(5634),
    [anon_sym_typedef] = ACTIONS(5634),
    [anon_sym_in] = ACTIONS(5634),
    [anon_sym_out] = ACTIONS(5634),
    [anon_sym_inout] = ACTIONS(5634),
    [anon_sym_extern] = ACTIONS(5634),
    [anon_sym___attribute__] = ACTIONS(5634),
    [anon_sym_COLON_COLON] = ACTIONS(5636),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5636),
    [anon_sym___declspec] = ACTIONS(5634),
    [anon_sym___based] = ACTIONS(5634),
    [anon_sym_signed] = ACTIONS(5634),
    [anon_sym_unsigned] = ACTIONS(5634),
    [anon_sym_long] = ACTIONS(5634),
    [anon_sym_short] = ACTIONS(5634),
    [anon_sym_LBRACK] = ACTIONS(5634),
    [anon_sym_static] = ACTIONS(5634),
    [anon_sym_register] = ACTIONS(5634),
    [anon_sym_inline] = ACTIONS(5634),
    [anon_sym___inline] = ACTIONS(5634),
    [anon_sym___inline__] = ACTIONS(5634),
    [anon_sym___forceinline] = ACTIONS(5634),
    [anon_sym_thread_local] = ACTIONS(5634),
    [anon_sym___thread] = ACTIONS(5634),
    [anon_sym_const] = ACTIONS(5634),
    [anon_sym_constexpr] = ACTIONS(5634),
    [anon_sym_volatile] = ACTIONS(5634),
    [anon_sym_restrict] = ACTIONS(5634),
    [anon_sym___restrict__] = ACTIONS(5634),
    [anon_sym__Atomic] = ACTIONS(5634),
    [anon_sym__Noreturn] = ACTIONS(5634),
    [anon_sym_noreturn] = ACTIONS(5634),
    [anon_sym_mutable] = ACTIONS(5634),
    [anon_sym_constinit] = ACTIONS(5634),
    [anon_sym_consteval] = ACTIONS(5634),
    [anon_sym_alignas] = ACTIONS(5634),
    [anon_sym__Alignas] = ACTIONS(5634),
    [sym_primitive_type] = ACTIONS(5634),
    [anon_sym_enum] = ACTIONS(5634),
    [anon_sym_class] = ACTIONS(5634),
    [anon_sym_struct] = ACTIONS(5634),
    [anon_sym_union] = ACTIONS(5634),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5634),
    [anon_sym_let] = ACTIONS(5634),
    [anon_sym_This] = ACTIONS(5634),
    [anon_sym_decltype] = ACTIONS(5634),
    [sym_virtual] = ACTIONS(5634),
    [anon_sym_explicit] = ACTIONS(5634),
    [anon_sym_typename] = ACTIONS(5634),
    [anon_sym_template] = ACTIONS(5634),
    [anon_sym_operator] = ACTIONS(5634),
    [anon_sym_friend] = ACTIONS(5634),
    [anon_sym_public] = ACTIONS(5634),
    [anon_sym_private] = ACTIONS(5634),
    [anon_sym_protected] = ACTIONS(5634),
    [anon_sym_using] = ACTIONS(5634),
    [anon_sym_static_assert] = ACTIONS(5634),
    [anon_sym_precise] = ACTIONS(5634),
    [anon_sym_shared] = ACTIONS(5634),
    [anon_sym_groupshared] = ACTIONS(5634),
    [anon_sym_uniform] = ACTIONS(5634),
    [anon_sym_row_major] = ACTIONS(5634),
    [anon_sym_column_major] = ACTIONS(5634),
    [anon_sym_globallycoherent] = ACTIONS(5634),
    [anon_sym_centroid] = ACTIONS(5634),
    [anon_sym_noperspective] = ACTIONS(5634),
    [anon_sym_nointerpolation] = ACTIONS(5634),
    [anon_sym_sample] = ACTIONS(5634),
    [anon_sym_linear] = ACTIONS(5634),
    [anon_sym_snorm] = ACTIONS(5634),
    [anon_sym_unorm] = ACTIONS(5634),
    [anon_sym_point] = ACTIONS(5634),
    [anon_sym_line] = ACTIONS(5634),
    [anon_sym_triangleadj] = ACTIONS(5634),
    [anon_sym_lineadj] = ACTIONS(5634),
    [anon_sym_triangle] = ACTIONS(5634),
    [anon_sym_interface] = ACTIONS(5634),
    [anon_sym_extension] = ACTIONS(5634),
    [anon_sym___init] = ACTIONS(5634),
    [anon_sym___subscript] = ACTIONS(5634),
    [anon_sym_property] = ACTIONS(5634),
    [anon_sym_associatedtype] = ACTIONS(5634),
  },
  [1662] = {
    [sym_identifier] = ACTIONS(5638),
    [aux_sym_preproc_def_token1] = ACTIONS(5638),
    [aux_sym_preproc_if_token1] = ACTIONS(5638),
    [aux_sym_preproc_if_token2] = ACTIONS(5638),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5638),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5638),
    [aux_sym_preproc_else_token1] = ACTIONS(5638),
    [aux_sym_preproc_elif_token1] = ACTIONS(5638),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5638),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5638),
    [sym_preproc_directive] = ACTIONS(5638),
    [anon_sym_LPAREN2] = ACTIONS(5640),
    [anon_sym_TILDE] = ACTIONS(5640),
    [anon_sym_STAR] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5638),
    [anon_sym___extension__] = ACTIONS(5638),
    [anon_sym_typedef] = ACTIONS(5638),
    [anon_sym_in] = ACTIONS(5638),
    [anon_sym_out] = ACTIONS(5638),
    [anon_sym_inout] = ACTIONS(5638),
    [anon_sym_extern] = ACTIONS(5638),
    [anon_sym___attribute__] = ACTIONS(5638),
    [anon_sym_COLON_COLON] = ACTIONS(5640),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5640),
    [anon_sym___declspec] = ACTIONS(5638),
    [anon_sym___based] = ACTIONS(5638),
    [anon_sym_signed] = ACTIONS(5638),
    [anon_sym_unsigned] = ACTIONS(5638),
    [anon_sym_long] = ACTIONS(5638),
    [anon_sym_short] = ACTIONS(5638),
    [anon_sym_LBRACK] = ACTIONS(5638),
    [anon_sym_static] = ACTIONS(5638),
    [anon_sym_register] = ACTIONS(5638),
    [anon_sym_inline] = ACTIONS(5638),
    [anon_sym___inline] = ACTIONS(5638),
    [anon_sym___inline__] = ACTIONS(5638),
    [anon_sym___forceinline] = ACTIONS(5638),
    [anon_sym_thread_local] = ACTIONS(5638),
    [anon_sym___thread] = ACTIONS(5638),
    [anon_sym_const] = ACTIONS(5638),
    [anon_sym_constexpr] = ACTIONS(5638),
    [anon_sym_volatile] = ACTIONS(5638),
    [anon_sym_restrict] = ACTIONS(5638),
    [anon_sym___restrict__] = ACTIONS(5638),
    [anon_sym__Atomic] = ACTIONS(5638),
    [anon_sym__Noreturn] = ACTIONS(5638),
    [anon_sym_noreturn] = ACTIONS(5638),
    [anon_sym_mutable] = ACTIONS(5638),
    [anon_sym_constinit] = ACTIONS(5638),
    [anon_sym_consteval] = ACTIONS(5638),
    [anon_sym_alignas] = ACTIONS(5638),
    [anon_sym__Alignas] = ACTIONS(5638),
    [sym_primitive_type] = ACTIONS(5638),
    [anon_sym_enum] = ACTIONS(5638),
    [anon_sym_class] = ACTIONS(5638),
    [anon_sym_struct] = ACTIONS(5638),
    [anon_sym_union] = ACTIONS(5638),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5638),
    [anon_sym_let] = ACTIONS(5638),
    [anon_sym_This] = ACTIONS(5638),
    [anon_sym_decltype] = ACTIONS(5638),
    [sym_virtual] = ACTIONS(5638),
    [anon_sym_explicit] = ACTIONS(5638),
    [anon_sym_typename] = ACTIONS(5638),
    [anon_sym_template] = ACTIONS(5638),
    [anon_sym_operator] = ACTIONS(5638),
    [anon_sym_friend] = ACTIONS(5638),
    [anon_sym_public] = ACTIONS(5638),
    [anon_sym_private] = ACTIONS(5638),
    [anon_sym_protected] = ACTIONS(5638),
    [anon_sym_using] = ACTIONS(5638),
    [anon_sym_static_assert] = ACTIONS(5638),
    [anon_sym_precise] = ACTIONS(5638),
    [anon_sym_shared] = ACTIONS(5638),
    [anon_sym_groupshared] = ACTIONS(5638),
    [anon_sym_uniform] = ACTIONS(5638),
    [anon_sym_row_major] = ACTIONS(5638),
    [anon_sym_column_major] = ACTIONS(5638),
    [anon_sym_globallycoherent] = ACTIONS(5638),
    [anon_sym_centroid] = ACTIONS(5638),
    [anon_sym_noperspective] = ACTIONS(5638),
    [anon_sym_nointerpolation] = ACTIONS(5638),
    [anon_sym_sample] = ACTIONS(5638),
    [anon_sym_linear] = ACTIONS(5638),
    [anon_sym_snorm] = ACTIONS(5638),
    [anon_sym_unorm] = ACTIONS(5638),
    [anon_sym_point] = ACTIONS(5638),
    [anon_sym_line] = ACTIONS(5638),
    [anon_sym_triangleadj] = ACTIONS(5638),
    [anon_sym_lineadj] = ACTIONS(5638),
    [anon_sym_triangle] = ACTIONS(5638),
    [anon_sym_interface] = ACTIONS(5638),
    [anon_sym_extension] = ACTIONS(5638),
    [anon_sym___init] = ACTIONS(5638),
    [anon_sym___subscript] = ACTIONS(5638),
    [anon_sym_property] = ACTIONS(5638),
    [anon_sym_associatedtype] = ACTIONS(5638),
  },
  [1663] = {
    [sym_identifier] = ACTIONS(3429),
    [aux_sym_preproc_def_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token2] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3429),
    [aux_sym_preproc_else_token1] = ACTIONS(3429),
    [aux_sym_preproc_elif_token1] = ACTIONS(3429),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3429),
    [sym_preproc_directive] = ACTIONS(3429),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym___extension__] = ACTIONS(3429),
    [anon_sym_typedef] = ACTIONS(3429),
    [anon_sym_in] = ACTIONS(3429),
    [anon_sym_out] = ACTIONS(3429),
    [anon_sym_inout] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym___attribute__] = ACTIONS(3429),
    [anon_sym_COLON_COLON] = ACTIONS(3431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3431),
    [anon_sym___declspec] = ACTIONS(3429),
    [anon_sym___based] = ACTIONS(3429),
    [anon_sym_signed] = ACTIONS(3429),
    [anon_sym_unsigned] = ACTIONS(3429),
    [anon_sym_long] = ACTIONS(3429),
    [anon_sym_short] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_register] = ACTIONS(3429),
    [anon_sym_inline] = ACTIONS(3429),
    [anon_sym___inline] = ACTIONS(3429),
    [anon_sym___inline__] = ACTIONS(3429),
    [anon_sym___forceinline] = ACTIONS(3429),
    [anon_sym_thread_local] = ACTIONS(3429),
    [anon_sym___thread] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_constexpr] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_restrict] = ACTIONS(3429),
    [anon_sym___restrict__] = ACTIONS(3429),
    [anon_sym__Atomic] = ACTIONS(3429),
    [anon_sym__Noreturn] = ACTIONS(3429),
    [anon_sym_noreturn] = ACTIONS(3429),
    [anon_sym_mutable] = ACTIONS(3429),
    [anon_sym_constinit] = ACTIONS(3429),
    [anon_sym_consteval] = ACTIONS(3429),
    [anon_sym_alignas] = ACTIONS(3429),
    [anon_sym__Alignas] = ACTIONS(3429),
    [sym_primitive_type] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_This] = ACTIONS(3429),
    [anon_sym_decltype] = ACTIONS(3429),
    [sym_virtual] = ACTIONS(3429),
    [anon_sym_explicit] = ACTIONS(3429),
    [anon_sym_typename] = ACTIONS(3429),
    [anon_sym_template] = ACTIONS(3429),
    [anon_sym_operator] = ACTIONS(3429),
    [anon_sym_friend] = ACTIONS(3429),
    [anon_sym_public] = ACTIONS(3429),
    [anon_sym_private] = ACTIONS(3429),
    [anon_sym_protected] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_static_assert] = ACTIONS(3429),
    [anon_sym_precise] = ACTIONS(3429),
    [anon_sym_shared] = ACTIONS(3429),
    [anon_sym_groupshared] = ACTIONS(3429),
    [anon_sym_uniform] = ACTIONS(3429),
    [anon_sym_row_major] = ACTIONS(3429),
    [anon_sym_column_major] = ACTIONS(3429),
    [anon_sym_globallycoherent] = ACTIONS(3429),
    [anon_sym_centroid] = ACTIONS(3429),
    [anon_sym_noperspective] = ACTIONS(3429),
    [anon_sym_nointerpolation] = ACTIONS(3429),
    [anon_sym_sample] = ACTIONS(3429),
    [anon_sym_linear] = ACTIONS(3429),
    [anon_sym_snorm] = ACTIONS(3429),
    [anon_sym_unorm] = ACTIONS(3429),
    [anon_sym_point] = ACTIONS(3429),
    [anon_sym_line] = ACTIONS(3429),
    [anon_sym_triangleadj] = ACTIONS(3429),
    [anon_sym_lineadj] = ACTIONS(3429),
    [anon_sym_triangle] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_extension] = ACTIONS(3429),
    [anon_sym___init] = ACTIONS(3429),
    [anon_sym___subscript] = ACTIONS(3429),
    [anon_sym_property] = ACTIONS(3429),
    [anon_sym_associatedtype] = ACTIONS(3429),
  },
  [1664] = {
    [sym_identifier] = ACTIONS(3429),
    [aux_sym_preproc_def_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token2] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3429),
    [aux_sym_preproc_else_token1] = ACTIONS(3429),
    [aux_sym_preproc_elif_token1] = ACTIONS(3429),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3429),
    [sym_preproc_directive] = ACTIONS(3429),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym___extension__] = ACTIONS(3429),
    [anon_sym_typedef] = ACTIONS(3429),
    [anon_sym_in] = ACTIONS(3429),
    [anon_sym_out] = ACTIONS(3429),
    [anon_sym_inout] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym___attribute__] = ACTIONS(3429),
    [anon_sym_COLON_COLON] = ACTIONS(3431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3431),
    [anon_sym___declspec] = ACTIONS(3429),
    [anon_sym___based] = ACTIONS(3429),
    [anon_sym_signed] = ACTIONS(3429),
    [anon_sym_unsigned] = ACTIONS(3429),
    [anon_sym_long] = ACTIONS(3429),
    [anon_sym_short] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_register] = ACTIONS(3429),
    [anon_sym_inline] = ACTIONS(3429),
    [anon_sym___inline] = ACTIONS(3429),
    [anon_sym___inline__] = ACTIONS(3429),
    [anon_sym___forceinline] = ACTIONS(3429),
    [anon_sym_thread_local] = ACTIONS(3429),
    [anon_sym___thread] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_constexpr] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_restrict] = ACTIONS(3429),
    [anon_sym___restrict__] = ACTIONS(3429),
    [anon_sym__Atomic] = ACTIONS(3429),
    [anon_sym__Noreturn] = ACTIONS(3429),
    [anon_sym_noreturn] = ACTIONS(3429),
    [anon_sym_mutable] = ACTIONS(3429),
    [anon_sym_constinit] = ACTIONS(3429),
    [anon_sym_consteval] = ACTIONS(3429),
    [anon_sym_alignas] = ACTIONS(3429),
    [anon_sym__Alignas] = ACTIONS(3429),
    [sym_primitive_type] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_This] = ACTIONS(3429),
    [anon_sym_decltype] = ACTIONS(3429),
    [sym_virtual] = ACTIONS(3429),
    [anon_sym_explicit] = ACTIONS(3429),
    [anon_sym_typename] = ACTIONS(3429),
    [anon_sym_template] = ACTIONS(3429),
    [anon_sym_operator] = ACTIONS(3429),
    [anon_sym_friend] = ACTIONS(3429),
    [anon_sym_public] = ACTIONS(3429),
    [anon_sym_private] = ACTIONS(3429),
    [anon_sym_protected] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_static_assert] = ACTIONS(3429),
    [anon_sym_precise] = ACTIONS(3429),
    [anon_sym_shared] = ACTIONS(3429),
    [anon_sym_groupshared] = ACTIONS(3429),
    [anon_sym_uniform] = ACTIONS(3429),
    [anon_sym_row_major] = ACTIONS(3429),
    [anon_sym_column_major] = ACTIONS(3429),
    [anon_sym_globallycoherent] = ACTIONS(3429),
    [anon_sym_centroid] = ACTIONS(3429),
    [anon_sym_noperspective] = ACTIONS(3429),
    [anon_sym_nointerpolation] = ACTIONS(3429),
    [anon_sym_sample] = ACTIONS(3429),
    [anon_sym_linear] = ACTIONS(3429),
    [anon_sym_snorm] = ACTIONS(3429),
    [anon_sym_unorm] = ACTIONS(3429),
    [anon_sym_point] = ACTIONS(3429),
    [anon_sym_line] = ACTIONS(3429),
    [anon_sym_triangleadj] = ACTIONS(3429),
    [anon_sym_lineadj] = ACTIONS(3429),
    [anon_sym_triangle] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_extension] = ACTIONS(3429),
    [anon_sym___init] = ACTIONS(3429),
    [anon_sym___subscript] = ACTIONS(3429),
    [anon_sym_property] = ACTIONS(3429),
    [anon_sym_associatedtype] = ACTIONS(3429),
  },
  [1665] = {
    [sym_identifier] = ACTIONS(5642),
    [aux_sym_preproc_def_token1] = ACTIONS(5642),
    [aux_sym_preproc_if_token1] = ACTIONS(5642),
    [aux_sym_preproc_if_token2] = ACTIONS(5642),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5642),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5642),
    [aux_sym_preproc_else_token1] = ACTIONS(5642),
    [aux_sym_preproc_elif_token1] = ACTIONS(5642),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5642),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5642),
    [sym_preproc_directive] = ACTIONS(5642),
    [anon_sym_LPAREN2] = ACTIONS(5644),
    [anon_sym_TILDE] = ACTIONS(5644),
    [anon_sym_STAR] = ACTIONS(5644),
    [anon_sym_AMP_AMP] = ACTIONS(5644),
    [anon_sym_AMP] = ACTIONS(5642),
    [anon_sym___extension__] = ACTIONS(5642),
    [anon_sym_typedef] = ACTIONS(5642),
    [anon_sym_in] = ACTIONS(5642),
    [anon_sym_out] = ACTIONS(5642),
    [anon_sym_inout] = ACTIONS(5642),
    [anon_sym_extern] = ACTIONS(5642),
    [anon_sym___attribute__] = ACTIONS(5642),
    [anon_sym_COLON_COLON] = ACTIONS(5644),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5644),
    [anon_sym___declspec] = ACTIONS(5642),
    [anon_sym___based] = ACTIONS(5642),
    [anon_sym_signed] = ACTIONS(5642),
    [anon_sym_unsigned] = ACTIONS(5642),
    [anon_sym_long] = ACTIONS(5642),
    [anon_sym_short] = ACTIONS(5642),
    [anon_sym_LBRACK] = ACTIONS(5642),
    [anon_sym_static] = ACTIONS(5642),
    [anon_sym_register] = ACTIONS(5642),
    [anon_sym_inline] = ACTIONS(5642),
    [anon_sym___inline] = ACTIONS(5642),
    [anon_sym___inline__] = ACTIONS(5642),
    [anon_sym___forceinline] = ACTIONS(5642),
    [anon_sym_thread_local] = ACTIONS(5642),
    [anon_sym___thread] = ACTIONS(5642),
    [anon_sym_const] = ACTIONS(5642),
    [anon_sym_constexpr] = ACTIONS(5642),
    [anon_sym_volatile] = ACTIONS(5642),
    [anon_sym_restrict] = ACTIONS(5642),
    [anon_sym___restrict__] = ACTIONS(5642),
    [anon_sym__Atomic] = ACTIONS(5642),
    [anon_sym__Noreturn] = ACTIONS(5642),
    [anon_sym_noreturn] = ACTIONS(5642),
    [anon_sym_mutable] = ACTIONS(5642),
    [anon_sym_constinit] = ACTIONS(5642),
    [anon_sym_consteval] = ACTIONS(5642),
    [anon_sym_alignas] = ACTIONS(5642),
    [anon_sym__Alignas] = ACTIONS(5642),
    [sym_primitive_type] = ACTIONS(5642),
    [anon_sym_enum] = ACTIONS(5642),
    [anon_sym_class] = ACTIONS(5642),
    [anon_sym_struct] = ACTIONS(5642),
    [anon_sym_union] = ACTIONS(5642),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5642),
    [anon_sym_let] = ACTIONS(5642),
    [anon_sym_This] = ACTIONS(5642),
    [anon_sym_decltype] = ACTIONS(5642),
    [sym_virtual] = ACTIONS(5642),
    [anon_sym_explicit] = ACTIONS(5642),
    [anon_sym_typename] = ACTIONS(5642),
    [anon_sym_template] = ACTIONS(5642),
    [anon_sym_operator] = ACTIONS(5642),
    [anon_sym_friend] = ACTIONS(5642),
    [anon_sym_public] = ACTIONS(5642),
    [anon_sym_private] = ACTIONS(5642),
    [anon_sym_protected] = ACTIONS(5642),
    [anon_sym_using] = ACTIONS(5642),
    [anon_sym_static_assert] = ACTIONS(5642),
    [anon_sym_precise] = ACTIONS(5642),
    [anon_sym_shared] = ACTIONS(5642),
    [anon_sym_groupshared] = ACTIONS(5642),
    [anon_sym_uniform] = ACTIONS(5642),
    [anon_sym_row_major] = ACTIONS(5642),
    [anon_sym_column_major] = ACTIONS(5642),
    [anon_sym_globallycoherent] = ACTIONS(5642),
    [anon_sym_centroid] = ACTIONS(5642),
    [anon_sym_noperspective] = ACTIONS(5642),
    [anon_sym_nointerpolation] = ACTIONS(5642),
    [anon_sym_sample] = ACTIONS(5642),
    [anon_sym_linear] = ACTIONS(5642),
    [anon_sym_snorm] = ACTIONS(5642),
    [anon_sym_unorm] = ACTIONS(5642),
    [anon_sym_point] = ACTIONS(5642),
    [anon_sym_line] = ACTIONS(5642),
    [anon_sym_triangleadj] = ACTIONS(5642),
    [anon_sym_lineadj] = ACTIONS(5642),
    [anon_sym_triangle] = ACTIONS(5642),
    [anon_sym_interface] = ACTIONS(5642),
    [anon_sym_extension] = ACTIONS(5642),
    [anon_sym___init] = ACTIONS(5642),
    [anon_sym___subscript] = ACTIONS(5642),
    [anon_sym_property] = ACTIONS(5642),
    [anon_sym_associatedtype] = ACTIONS(5642),
  },
  [1666] = {
    [sym_identifier] = ACTIONS(5464),
    [aux_sym_preproc_def_token1] = ACTIONS(5464),
    [aux_sym_preproc_if_token1] = ACTIONS(5464),
    [aux_sym_preproc_if_token2] = ACTIONS(5464),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5464),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5464),
    [aux_sym_preproc_else_token1] = ACTIONS(5464),
    [aux_sym_preproc_elif_token1] = ACTIONS(5464),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5464),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5464),
    [sym_preproc_directive] = ACTIONS(5464),
    [anon_sym_LPAREN2] = ACTIONS(5466),
    [anon_sym_TILDE] = ACTIONS(5466),
    [anon_sym_STAR] = ACTIONS(5466),
    [anon_sym_AMP_AMP] = ACTIONS(5466),
    [anon_sym_AMP] = ACTIONS(5464),
    [anon_sym___extension__] = ACTIONS(5464),
    [anon_sym_typedef] = ACTIONS(5464),
    [anon_sym_in] = ACTIONS(5464),
    [anon_sym_out] = ACTIONS(5464),
    [anon_sym_inout] = ACTIONS(5464),
    [anon_sym_extern] = ACTIONS(5464),
    [anon_sym___attribute__] = ACTIONS(5464),
    [anon_sym_COLON_COLON] = ACTIONS(5466),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5466),
    [anon_sym___declspec] = ACTIONS(5464),
    [anon_sym___based] = ACTIONS(5464),
    [anon_sym_signed] = ACTIONS(5464),
    [anon_sym_unsigned] = ACTIONS(5464),
    [anon_sym_long] = ACTIONS(5464),
    [anon_sym_short] = ACTIONS(5464),
    [anon_sym_LBRACK] = ACTIONS(5464),
    [anon_sym_static] = ACTIONS(5464),
    [anon_sym_register] = ACTIONS(5464),
    [anon_sym_inline] = ACTIONS(5464),
    [anon_sym___inline] = ACTIONS(5464),
    [anon_sym___inline__] = ACTIONS(5464),
    [anon_sym___forceinline] = ACTIONS(5464),
    [anon_sym_thread_local] = ACTIONS(5464),
    [anon_sym___thread] = ACTIONS(5464),
    [anon_sym_const] = ACTIONS(5464),
    [anon_sym_constexpr] = ACTIONS(5464),
    [anon_sym_volatile] = ACTIONS(5464),
    [anon_sym_restrict] = ACTIONS(5464),
    [anon_sym___restrict__] = ACTIONS(5464),
    [anon_sym__Atomic] = ACTIONS(5464),
    [anon_sym__Noreturn] = ACTIONS(5464),
    [anon_sym_noreturn] = ACTIONS(5464),
    [anon_sym_mutable] = ACTIONS(5464),
    [anon_sym_constinit] = ACTIONS(5464),
    [anon_sym_consteval] = ACTIONS(5464),
    [anon_sym_alignas] = ACTIONS(5464),
    [anon_sym__Alignas] = ACTIONS(5464),
    [sym_primitive_type] = ACTIONS(5464),
    [anon_sym_enum] = ACTIONS(5464),
    [anon_sym_class] = ACTIONS(5464),
    [anon_sym_struct] = ACTIONS(5464),
    [anon_sym_union] = ACTIONS(5464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5464),
    [anon_sym_let] = ACTIONS(5464),
    [anon_sym_This] = ACTIONS(5464),
    [anon_sym_decltype] = ACTIONS(5464),
    [sym_virtual] = ACTIONS(5464),
    [anon_sym_explicit] = ACTIONS(5464),
    [anon_sym_typename] = ACTIONS(5464),
    [anon_sym_template] = ACTIONS(5464),
    [anon_sym_operator] = ACTIONS(5464),
    [anon_sym_friend] = ACTIONS(5464),
    [anon_sym_public] = ACTIONS(5464),
    [anon_sym_private] = ACTIONS(5464),
    [anon_sym_protected] = ACTIONS(5464),
    [anon_sym_using] = ACTIONS(5464),
    [anon_sym_static_assert] = ACTIONS(5464),
    [anon_sym_precise] = ACTIONS(5464),
    [anon_sym_shared] = ACTIONS(5464),
    [anon_sym_groupshared] = ACTIONS(5464),
    [anon_sym_uniform] = ACTIONS(5464),
    [anon_sym_row_major] = ACTIONS(5464),
    [anon_sym_column_major] = ACTIONS(5464),
    [anon_sym_globallycoherent] = ACTIONS(5464),
    [anon_sym_centroid] = ACTIONS(5464),
    [anon_sym_noperspective] = ACTIONS(5464),
    [anon_sym_nointerpolation] = ACTIONS(5464),
    [anon_sym_sample] = ACTIONS(5464),
    [anon_sym_linear] = ACTIONS(5464),
    [anon_sym_snorm] = ACTIONS(5464),
    [anon_sym_unorm] = ACTIONS(5464),
    [anon_sym_point] = ACTIONS(5464),
    [anon_sym_line] = ACTIONS(5464),
    [anon_sym_triangleadj] = ACTIONS(5464),
    [anon_sym_lineadj] = ACTIONS(5464),
    [anon_sym_triangle] = ACTIONS(5464),
    [anon_sym_interface] = ACTIONS(5464),
    [anon_sym_extension] = ACTIONS(5464),
    [anon_sym___init] = ACTIONS(5464),
    [anon_sym___subscript] = ACTIONS(5464),
    [anon_sym_property] = ACTIONS(5464),
    [anon_sym_associatedtype] = ACTIONS(5464),
  },
  [1667] = {
    [sym_identifier] = ACTIONS(5646),
    [aux_sym_preproc_def_token1] = ACTIONS(5646),
    [aux_sym_preproc_if_token1] = ACTIONS(5646),
    [aux_sym_preproc_if_token2] = ACTIONS(5646),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5646),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5646),
    [aux_sym_preproc_else_token1] = ACTIONS(5646),
    [aux_sym_preproc_elif_token1] = ACTIONS(5646),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5646),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5646),
    [sym_preproc_directive] = ACTIONS(5646),
    [anon_sym_LPAREN2] = ACTIONS(5648),
    [anon_sym_TILDE] = ACTIONS(5648),
    [anon_sym_STAR] = ACTIONS(5648),
    [anon_sym_AMP_AMP] = ACTIONS(5648),
    [anon_sym_AMP] = ACTIONS(5646),
    [anon_sym___extension__] = ACTIONS(5646),
    [anon_sym_typedef] = ACTIONS(5646),
    [anon_sym_in] = ACTIONS(5646),
    [anon_sym_out] = ACTIONS(5646),
    [anon_sym_inout] = ACTIONS(5646),
    [anon_sym_extern] = ACTIONS(5646),
    [anon_sym___attribute__] = ACTIONS(5646),
    [anon_sym_COLON_COLON] = ACTIONS(5648),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5648),
    [anon_sym___declspec] = ACTIONS(5646),
    [anon_sym___based] = ACTIONS(5646),
    [anon_sym_signed] = ACTIONS(5646),
    [anon_sym_unsigned] = ACTIONS(5646),
    [anon_sym_long] = ACTIONS(5646),
    [anon_sym_short] = ACTIONS(5646),
    [anon_sym_LBRACK] = ACTIONS(5646),
    [anon_sym_static] = ACTIONS(5646),
    [anon_sym_register] = ACTIONS(5646),
    [anon_sym_inline] = ACTIONS(5646),
    [anon_sym___inline] = ACTIONS(5646),
    [anon_sym___inline__] = ACTIONS(5646),
    [anon_sym___forceinline] = ACTIONS(5646),
    [anon_sym_thread_local] = ACTIONS(5646),
    [anon_sym___thread] = ACTIONS(5646),
    [anon_sym_const] = ACTIONS(5646),
    [anon_sym_constexpr] = ACTIONS(5646),
    [anon_sym_volatile] = ACTIONS(5646),
    [anon_sym_restrict] = ACTIONS(5646),
    [anon_sym___restrict__] = ACTIONS(5646),
    [anon_sym__Atomic] = ACTIONS(5646),
    [anon_sym__Noreturn] = ACTIONS(5646),
    [anon_sym_noreturn] = ACTIONS(5646),
    [anon_sym_mutable] = ACTIONS(5646),
    [anon_sym_constinit] = ACTIONS(5646),
    [anon_sym_consteval] = ACTIONS(5646),
    [anon_sym_alignas] = ACTIONS(5646),
    [anon_sym__Alignas] = ACTIONS(5646),
    [sym_primitive_type] = ACTIONS(5646),
    [anon_sym_enum] = ACTIONS(5646),
    [anon_sym_class] = ACTIONS(5646),
    [anon_sym_struct] = ACTIONS(5646),
    [anon_sym_union] = ACTIONS(5646),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5646),
    [anon_sym_let] = ACTIONS(5646),
    [anon_sym_This] = ACTIONS(5646),
    [anon_sym_decltype] = ACTIONS(5646),
    [sym_virtual] = ACTIONS(5646),
    [anon_sym_explicit] = ACTIONS(5646),
    [anon_sym_typename] = ACTIONS(5646),
    [anon_sym_template] = ACTIONS(5646),
    [anon_sym_operator] = ACTIONS(5646),
    [anon_sym_friend] = ACTIONS(5646),
    [anon_sym_public] = ACTIONS(5646),
    [anon_sym_private] = ACTIONS(5646),
    [anon_sym_protected] = ACTIONS(5646),
    [anon_sym_using] = ACTIONS(5646),
    [anon_sym_static_assert] = ACTIONS(5646),
    [anon_sym_precise] = ACTIONS(5646),
    [anon_sym_shared] = ACTIONS(5646),
    [anon_sym_groupshared] = ACTIONS(5646),
    [anon_sym_uniform] = ACTIONS(5646),
    [anon_sym_row_major] = ACTIONS(5646),
    [anon_sym_column_major] = ACTIONS(5646),
    [anon_sym_globallycoherent] = ACTIONS(5646),
    [anon_sym_centroid] = ACTIONS(5646),
    [anon_sym_noperspective] = ACTIONS(5646),
    [anon_sym_nointerpolation] = ACTIONS(5646),
    [anon_sym_sample] = ACTIONS(5646),
    [anon_sym_linear] = ACTIONS(5646),
    [anon_sym_snorm] = ACTIONS(5646),
    [anon_sym_unorm] = ACTIONS(5646),
    [anon_sym_point] = ACTIONS(5646),
    [anon_sym_line] = ACTIONS(5646),
    [anon_sym_triangleadj] = ACTIONS(5646),
    [anon_sym_lineadj] = ACTIONS(5646),
    [anon_sym_triangle] = ACTIONS(5646),
    [anon_sym_interface] = ACTIONS(5646),
    [anon_sym_extension] = ACTIONS(5646),
    [anon_sym___init] = ACTIONS(5646),
    [anon_sym___subscript] = ACTIONS(5646),
    [anon_sym_property] = ACTIONS(5646),
    [anon_sym_associatedtype] = ACTIONS(5646),
  },
  [1668] = {
    [sym_identifier] = ACTIONS(5650),
    [aux_sym_preproc_def_token1] = ACTIONS(5650),
    [aux_sym_preproc_if_token1] = ACTIONS(5650),
    [aux_sym_preproc_if_token2] = ACTIONS(5650),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5650),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5650),
    [aux_sym_preproc_else_token1] = ACTIONS(5650),
    [aux_sym_preproc_elif_token1] = ACTIONS(5650),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5650),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5650),
    [sym_preproc_directive] = ACTIONS(5650),
    [anon_sym_LPAREN2] = ACTIONS(5652),
    [anon_sym_TILDE] = ACTIONS(5652),
    [anon_sym_STAR] = ACTIONS(5652),
    [anon_sym_AMP_AMP] = ACTIONS(5652),
    [anon_sym_AMP] = ACTIONS(5650),
    [anon_sym___extension__] = ACTIONS(5650),
    [anon_sym_typedef] = ACTIONS(5650),
    [anon_sym_in] = ACTIONS(5650),
    [anon_sym_out] = ACTIONS(5650),
    [anon_sym_inout] = ACTIONS(5650),
    [anon_sym_extern] = ACTIONS(5650),
    [anon_sym___attribute__] = ACTIONS(5650),
    [anon_sym_COLON_COLON] = ACTIONS(5652),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5652),
    [anon_sym___declspec] = ACTIONS(5650),
    [anon_sym___based] = ACTIONS(5650),
    [anon_sym_signed] = ACTIONS(5650),
    [anon_sym_unsigned] = ACTIONS(5650),
    [anon_sym_long] = ACTIONS(5650),
    [anon_sym_short] = ACTIONS(5650),
    [anon_sym_LBRACK] = ACTIONS(5650),
    [anon_sym_static] = ACTIONS(5650),
    [anon_sym_register] = ACTIONS(5650),
    [anon_sym_inline] = ACTIONS(5650),
    [anon_sym___inline] = ACTIONS(5650),
    [anon_sym___inline__] = ACTIONS(5650),
    [anon_sym___forceinline] = ACTIONS(5650),
    [anon_sym_thread_local] = ACTIONS(5650),
    [anon_sym___thread] = ACTIONS(5650),
    [anon_sym_const] = ACTIONS(5650),
    [anon_sym_constexpr] = ACTIONS(5650),
    [anon_sym_volatile] = ACTIONS(5650),
    [anon_sym_restrict] = ACTIONS(5650),
    [anon_sym___restrict__] = ACTIONS(5650),
    [anon_sym__Atomic] = ACTIONS(5650),
    [anon_sym__Noreturn] = ACTIONS(5650),
    [anon_sym_noreturn] = ACTIONS(5650),
    [anon_sym_mutable] = ACTIONS(5650),
    [anon_sym_constinit] = ACTIONS(5650),
    [anon_sym_consteval] = ACTIONS(5650),
    [anon_sym_alignas] = ACTIONS(5650),
    [anon_sym__Alignas] = ACTIONS(5650),
    [sym_primitive_type] = ACTIONS(5650),
    [anon_sym_enum] = ACTIONS(5650),
    [anon_sym_class] = ACTIONS(5650),
    [anon_sym_struct] = ACTIONS(5650),
    [anon_sym_union] = ACTIONS(5650),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5650),
    [anon_sym_let] = ACTIONS(5650),
    [anon_sym_This] = ACTIONS(5650),
    [anon_sym_decltype] = ACTIONS(5650),
    [sym_virtual] = ACTIONS(5650),
    [anon_sym_explicit] = ACTIONS(5650),
    [anon_sym_typename] = ACTIONS(5650),
    [anon_sym_template] = ACTIONS(5650),
    [anon_sym_operator] = ACTIONS(5650),
    [anon_sym_friend] = ACTIONS(5650),
    [anon_sym_public] = ACTIONS(5650),
    [anon_sym_private] = ACTIONS(5650),
    [anon_sym_protected] = ACTIONS(5650),
    [anon_sym_using] = ACTIONS(5650),
    [anon_sym_static_assert] = ACTIONS(5650),
    [anon_sym_precise] = ACTIONS(5650),
    [anon_sym_shared] = ACTIONS(5650),
    [anon_sym_groupshared] = ACTIONS(5650),
    [anon_sym_uniform] = ACTIONS(5650),
    [anon_sym_row_major] = ACTIONS(5650),
    [anon_sym_column_major] = ACTIONS(5650),
    [anon_sym_globallycoherent] = ACTIONS(5650),
    [anon_sym_centroid] = ACTIONS(5650),
    [anon_sym_noperspective] = ACTIONS(5650),
    [anon_sym_nointerpolation] = ACTIONS(5650),
    [anon_sym_sample] = ACTIONS(5650),
    [anon_sym_linear] = ACTIONS(5650),
    [anon_sym_snorm] = ACTIONS(5650),
    [anon_sym_unorm] = ACTIONS(5650),
    [anon_sym_point] = ACTIONS(5650),
    [anon_sym_line] = ACTIONS(5650),
    [anon_sym_triangleadj] = ACTIONS(5650),
    [anon_sym_lineadj] = ACTIONS(5650),
    [anon_sym_triangle] = ACTIONS(5650),
    [anon_sym_interface] = ACTIONS(5650),
    [anon_sym_extension] = ACTIONS(5650),
    [anon_sym___init] = ACTIONS(5650),
    [anon_sym___subscript] = ACTIONS(5650),
    [anon_sym_property] = ACTIONS(5650),
    [anon_sym_associatedtype] = ACTIONS(5650),
  },
  [1669] = {
    [sym_expression] = STATE(5161),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_initializer_list] = STATE(9579),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5654),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1670] = {
    [sym_expression] = STATE(5365),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5656),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1671] = {
    [sym_expression] = STATE(5140),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5664),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1672] = {
    [sym_expression] = STATE(5140),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5668),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1673] = {
    [sym_expression] = STATE(5231),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5670),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1674] = {
    [sym_expression] = STATE(5140),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(5672),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5670),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1675] = {
    [sym_expression] = STATE(5140),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5674),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1676] = {
    [sym_expression] = STATE(4553),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5656),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1677] = {
    [sym_expression] = STATE(5140),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5676),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1678] = {
    [sym_expression] = STATE(5359),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5656),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [1679] = {
    [sym_expression] = STATE(5140),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5678),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1680] = {
    [sym_expression] = STATE(4444),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5656),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1681] = {
    [sym_catch_clause] = STATE(1707),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1707),
    [sym_identifier] = ACTIONS(2677),
    [aux_sym_preproc_def_token1] = ACTIONS(2677),
    [aux_sym_preproc_if_token1] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2677),
    [sym_preproc_directive] = ACTIONS(2677),
    [anon_sym_LPAREN2] = ACTIONS(2679),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2679),
    [anon_sym_AMP_AMP] = ACTIONS(2679),
    [anon_sym_AMP] = ACTIONS(2677),
    [anon_sym___extension__] = ACTIONS(2677),
    [anon_sym_typedef] = ACTIONS(2677),
    [anon_sym_in] = ACTIONS(2677),
    [anon_sym_out] = ACTIONS(2677),
    [anon_sym_inout] = ACTIONS(2677),
    [anon_sym_extern] = ACTIONS(2677),
    [anon_sym___attribute__] = ACTIONS(2677),
    [anon_sym_COLON_COLON] = ACTIONS(2679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2679),
    [anon_sym___declspec] = ACTIONS(2677),
    [anon_sym___based] = ACTIONS(2677),
    [anon_sym_RBRACE] = ACTIONS(2679),
    [anon_sym_signed] = ACTIONS(2677),
    [anon_sym_unsigned] = ACTIONS(2677),
    [anon_sym_long] = ACTIONS(2677),
    [anon_sym_short] = ACTIONS(2677),
    [anon_sym_LBRACK] = ACTIONS(2677),
    [anon_sym_static] = ACTIONS(2677),
    [anon_sym_register] = ACTIONS(2677),
    [anon_sym_inline] = ACTIONS(2677),
    [anon_sym___inline] = ACTIONS(2677),
    [anon_sym___inline__] = ACTIONS(2677),
    [anon_sym___forceinline] = ACTIONS(2677),
    [anon_sym_thread_local] = ACTIONS(2677),
    [anon_sym___thread] = ACTIONS(2677),
    [anon_sym_const] = ACTIONS(2677),
    [anon_sym_constexpr] = ACTIONS(2677),
    [anon_sym_volatile] = ACTIONS(2677),
    [anon_sym_restrict] = ACTIONS(2677),
    [anon_sym___restrict__] = ACTIONS(2677),
    [anon_sym__Atomic] = ACTIONS(2677),
    [anon_sym__Noreturn] = ACTIONS(2677),
    [anon_sym_noreturn] = ACTIONS(2677),
    [anon_sym_mutable] = ACTIONS(2677),
    [anon_sym_constinit] = ACTIONS(2677),
    [anon_sym_consteval] = ACTIONS(2677),
    [anon_sym_alignas] = ACTIONS(2677),
    [anon_sym__Alignas] = ACTIONS(2677),
    [sym_primitive_type] = ACTIONS(2677),
    [anon_sym_enum] = ACTIONS(2677),
    [anon_sym_class] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(2677),
    [anon_sym_union] = ACTIONS(2677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2677),
    [anon_sym_let] = ACTIONS(2677),
    [anon_sym_This] = ACTIONS(2677),
    [anon_sym_decltype] = ACTIONS(2677),
    [sym_virtual] = ACTIONS(2677),
    [anon_sym_explicit] = ACTIONS(2677),
    [anon_sym_typename] = ACTIONS(2677),
    [anon_sym_template] = ACTIONS(2677),
    [anon_sym_operator] = ACTIONS(2677),
    [anon_sym_friend] = ACTIONS(2677),
    [anon_sym_public] = ACTIONS(2677),
    [anon_sym_private] = ACTIONS(2677),
    [anon_sym_protected] = ACTIONS(2677),
    [anon_sym_using] = ACTIONS(2677),
    [anon_sym_static_assert] = ACTIONS(2677),
    [anon_sym_catch] = ACTIONS(5680),
    [anon_sym_precise] = ACTIONS(2677),
    [anon_sym_shared] = ACTIONS(2677),
    [anon_sym_groupshared] = ACTIONS(2677),
    [anon_sym_uniform] = ACTIONS(2677),
    [anon_sym_row_major] = ACTIONS(2677),
    [anon_sym_column_major] = ACTIONS(2677),
    [anon_sym_globallycoherent] = ACTIONS(2677),
    [anon_sym_centroid] = ACTIONS(2677),
    [anon_sym_noperspective] = ACTIONS(2677),
    [anon_sym_nointerpolation] = ACTIONS(2677),
    [anon_sym_sample] = ACTIONS(2677),
    [anon_sym_linear] = ACTIONS(2677),
    [anon_sym_snorm] = ACTIONS(2677),
    [anon_sym_unorm] = ACTIONS(2677),
    [anon_sym_point] = ACTIONS(2677),
    [anon_sym_line] = ACTIONS(2677),
    [anon_sym_triangleadj] = ACTIONS(2677),
    [anon_sym_lineadj] = ACTIONS(2677),
    [anon_sym_triangle] = ACTIONS(2677),
    [anon_sym_interface] = ACTIONS(2677),
    [anon_sym_extension] = ACTIONS(2677),
    [anon_sym___init] = ACTIONS(2677),
    [anon_sym___subscript] = ACTIONS(2677),
    [anon_sym_property] = ACTIONS(2677),
    [anon_sym_associatedtype] = ACTIONS(2677),
  },
  [1682] = {
    [sym_expression] = STATE(5140),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5682),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1683] = {
    [sym_expression] = STATE(5140),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5684),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1684] = {
    [sym_expression] = STATE(5140),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5686),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1685] = {
    [sym_expression] = STATE(5285),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_initializer_list] = STATE(9191),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5688),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1686] = {
    [sym_expression] = STATE(5140),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5690),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1687] = {
    [sym_catch_clause] = STATE(1734),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1734),
    [sym_identifier] = ACTIONS(2677),
    [aux_sym_preproc_def_token1] = ACTIONS(2677),
    [aux_sym_preproc_if_token1] = ACTIONS(2677),
    [aux_sym_preproc_if_token2] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2677),
    [sym_preproc_directive] = ACTIONS(2677),
    [anon_sym_LPAREN2] = ACTIONS(2679),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2679),
    [anon_sym_AMP_AMP] = ACTIONS(2679),
    [anon_sym_AMP] = ACTIONS(2677),
    [anon_sym___extension__] = ACTIONS(2677),
    [anon_sym_typedef] = ACTIONS(2677),
    [anon_sym_in] = ACTIONS(2677),
    [anon_sym_out] = ACTIONS(2677),
    [anon_sym_inout] = ACTIONS(2677),
    [anon_sym_extern] = ACTIONS(2677),
    [anon_sym___attribute__] = ACTIONS(2677),
    [anon_sym_COLON_COLON] = ACTIONS(2679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2679),
    [anon_sym___declspec] = ACTIONS(2677),
    [anon_sym___based] = ACTIONS(2677),
    [anon_sym_signed] = ACTIONS(2677),
    [anon_sym_unsigned] = ACTIONS(2677),
    [anon_sym_long] = ACTIONS(2677),
    [anon_sym_short] = ACTIONS(2677),
    [anon_sym_LBRACK] = ACTIONS(2677),
    [anon_sym_static] = ACTIONS(2677),
    [anon_sym_register] = ACTIONS(2677),
    [anon_sym_inline] = ACTIONS(2677),
    [anon_sym___inline] = ACTIONS(2677),
    [anon_sym___inline__] = ACTIONS(2677),
    [anon_sym___forceinline] = ACTIONS(2677),
    [anon_sym_thread_local] = ACTIONS(2677),
    [anon_sym___thread] = ACTIONS(2677),
    [anon_sym_const] = ACTIONS(2677),
    [anon_sym_constexpr] = ACTIONS(2677),
    [anon_sym_volatile] = ACTIONS(2677),
    [anon_sym_restrict] = ACTIONS(2677),
    [anon_sym___restrict__] = ACTIONS(2677),
    [anon_sym__Atomic] = ACTIONS(2677),
    [anon_sym__Noreturn] = ACTIONS(2677),
    [anon_sym_noreturn] = ACTIONS(2677),
    [anon_sym_mutable] = ACTIONS(2677),
    [anon_sym_constinit] = ACTIONS(2677),
    [anon_sym_consteval] = ACTIONS(2677),
    [anon_sym_alignas] = ACTIONS(2677),
    [anon_sym__Alignas] = ACTIONS(2677),
    [sym_primitive_type] = ACTIONS(2677),
    [anon_sym_enum] = ACTIONS(2677),
    [anon_sym_class] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(2677),
    [anon_sym_union] = ACTIONS(2677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2677),
    [anon_sym_let] = ACTIONS(2677),
    [anon_sym_This] = ACTIONS(2677),
    [anon_sym_decltype] = ACTIONS(2677),
    [sym_virtual] = ACTIONS(2677),
    [anon_sym_explicit] = ACTIONS(2677),
    [anon_sym_typename] = ACTIONS(2677),
    [anon_sym_template] = ACTIONS(2677),
    [anon_sym_operator] = ACTIONS(2677),
    [anon_sym_friend] = ACTIONS(2677),
    [anon_sym_public] = ACTIONS(2677),
    [anon_sym_private] = ACTIONS(2677),
    [anon_sym_protected] = ACTIONS(2677),
    [anon_sym_using] = ACTIONS(2677),
    [anon_sym_static_assert] = ACTIONS(2677),
    [anon_sym_catch] = ACTIONS(5692),
    [anon_sym_precise] = ACTIONS(2677),
    [anon_sym_shared] = ACTIONS(2677),
    [anon_sym_groupshared] = ACTIONS(2677),
    [anon_sym_uniform] = ACTIONS(2677),
    [anon_sym_row_major] = ACTIONS(2677),
    [anon_sym_column_major] = ACTIONS(2677),
    [anon_sym_globallycoherent] = ACTIONS(2677),
    [anon_sym_centroid] = ACTIONS(2677),
    [anon_sym_noperspective] = ACTIONS(2677),
    [anon_sym_nointerpolation] = ACTIONS(2677),
    [anon_sym_sample] = ACTIONS(2677),
    [anon_sym_linear] = ACTIONS(2677),
    [anon_sym_snorm] = ACTIONS(2677),
    [anon_sym_unorm] = ACTIONS(2677),
    [anon_sym_point] = ACTIONS(2677),
    [anon_sym_line] = ACTIONS(2677),
    [anon_sym_triangleadj] = ACTIONS(2677),
    [anon_sym_lineadj] = ACTIONS(2677),
    [anon_sym_triangle] = ACTIONS(2677),
    [anon_sym_interface] = ACTIONS(2677),
    [anon_sym_extension] = ACTIONS(2677),
    [anon_sym___init] = ACTIONS(2677),
    [anon_sym___subscript] = ACTIONS(2677),
    [anon_sym_property] = ACTIONS(2677),
    [anon_sym_associatedtype] = ACTIONS(2677),
  },
  [1688] = {
    [sym_expression] = STATE(5140),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5694),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1689] = {
    [sym_catch_clause] = STATE(1734),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1734),
    [sym_identifier] = ACTIONS(2744),
    [aux_sym_preproc_def_token1] = ACTIONS(2744),
    [aux_sym_preproc_if_token1] = ACTIONS(2744),
    [aux_sym_preproc_if_token2] = ACTIONS(2744),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2744),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2744),
    [sym_preproc_directive] = ACTIONS(2744),
    [anon_sym_LPAREN2] = ACTIONS(2746),
    [anon_sym_TILDE] = ACTIONS(2746),
    [anon_sym_STAR] = ACTIONS(2746),
    [anon_sym_AMP_AMP] = ACTIONS(2746),
    [anon_sym_AMP] = ACTIONS(2744),
    [anon_sym___extension__] = ACTIONS(2744),
    [anon_sym_typedef] = ACTIONS(2744),
    [anon_sym_in] = ACTIONS(2744),
    [anon_sym_out] = ACTIONS(2744),
    [anon_sym_inout] = ACTIONS(2744),
    [anon_sym_extern] = ACTIONS(2744),
    [anon_sym___attribute__] = ACTIONS(2744),
    [anon_sym_COLON_COLON] = ACTIONS(2746),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2746),
    [anon_sym___declspec] = ACTIONS(2744),
    [anon_sym___based] = ACTIONS(2744),
    [anon_sym_signed] = ACTIONS(2744),
    [anon_sym_unsigned] = ACTIONS(2744),
    [anon_sym_long] = ACTIONS(2744),
    [anon_sym_short] = ACTIONS(2744),
    [anon_sym_LBRACK] = ACTIONS(2744),
    [anon_sym_static] = ACTIONS(2744),
    [anon_sym_register] = ACTIONS(2744),
    [anon_sym_inline] = ACTIONS(2744),
    [anon_sym___inline] = ACTIONS(2744),
    [anon_sym___inline__] = ACTIONS(2744),
    [anon_sym___forceinline] = ACTIONS(2744),
    [anon_sym_thread_local] = ACTIONS(2744),
    [anon_sym___thread] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_constexpr] = ACTIONS(2744),
    [anon_sym_volatile] = ACTIONS(2744),
    [anon_sym_restrict] = ACTIONS(2744),
    [anon_sym___restrict__] = ACTIONS(2744),
    [anon_sym__Atomic] = ACTIONS(2744),
    [anon_sym__Noreturn] = ACTIONS(2744),
    [anon_sym_noreturn] = ACTIONS(2744),
    [anon_sym_mutable] = ACTIONS(2744),
    [anon_sym_constinit] = ACTIONS(2744),
    [anon_sym_consteval] = ACTIONS(2744),
    [anon_sym_alignas] = ACTIONS(2744),
    [anon_sym__Alignas] = ACTIONS(2744),
    [sym_primitive_type] = ACTIONS(2744),
    [anon_sym_enum] = ACTIONS(2744),
    [anon_sym_class] = ACTIONS(2744),
    [anon_sym_struct] = ACTIONS(2744),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2744),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_This] = ACTIONS(2744),
    [anon_sym_decltype] = ACTIONS(2744),
    [sym_virtual] = ACTIONS(2744),
    [anon_sym_explicit] = ACTIONS(2744),
    [anon_sym_typename] = ACTIONS(2744),
    [anon_sym_template] = ACTIONS(2744),
    [anon_sym_operator] = ACTIONS(2744),
    [anon_sym_friend] = ACTIONS(2744),
    [anon_sym_public] = ACTIONS(2744),
    [anon_sym_private] = ACTIONS(2744),
    [anon_sym_protected] = ACTIONS(2744),
    [anon_sym_using] = ACTIONS(2744),
    [anon_sym_static_assert] = ACTIONS(2744),
    [anon_sym_catch] = ACTIONS(5692),
    [anon_sym_precise] = ACTIONS(2744),
    [anon_sym_shared] = ACTIONS(2744),
    [anon_sym_groupshared] = ACTIONS(2744),
    [anon_sym_uniform] = ACTIONS(2744),
    [anon_sym_row_major] = ACTIONS(2744),
    [anon_sym_column_major] = ACTIONS(2744),
    [anon_sym_globallycoherent] = ACTIONS(2744),
    [anon_sym_centroid] = ACTIONS(2744),
    [anon_sym_noperspective] = ACTIONS(2744),
    [anon_sym_nointerpolation] = ACTIONS(2744),
    [anon_sym_sample] = ACTIONS(2744),
    [anon_sym_linear] = ACTIONS(2744),
    [anon_sym_snorm] = ACTIONS(2744),
    [anon_sym_unorm] = ACTIONS(2744),
    [anon_sym_point] = ACTIONS(2744),
    [anon_sym_line] = ACTIONS(2744),
    [anon_sym_triangleadj] = ACTIONS(2744),
    [anon_sym_lineadj] = ACTIONS(2744),
    [anon_sym_triangle] = ACTIONS(2744),
    [anon_sym_interface] = ACTIONS(2744),
    [anon_sym_extension] = ACTIONS(2744),
    [anon_sym___init] = ACTIONS(2744),
    [anon_sym___subscript] = ACTIONS(2744),
    [anon_sym_property] = ACTIONS(2744),
    [anon_sym_associatedtype] = ACTIONS(2744),
  },
  [1690] = {
    [sym_expression] = STATE(5140),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1691] = {
    [sym_expression] = STATE(5140),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5670),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1692] = {
    [sym_expression] = STATE(3737),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5656),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1693] = {
    [sym_expression] = STATE(5140),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1694] = {
    [sym_expression] = STATE(3589),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5656),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1695] = {
    [sym_expression] = STATE(5140),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5700),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1696] = {
    [sym_expression] = STATE(5132),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(5672),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5670),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1697] = {
    [sym_expression] = STATE(5541),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10377),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5702),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1698] = {
    [sym_expression] = STATE(4889),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4905),
    [sym_concatenated_string] = STATE(4902),
    [sym_string_literal] = STATE(3611),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3610),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(5705),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_BANG] = ACTIONS(4926),
    [anon_sym_TILDE] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5656),
    [anon_sym_COLON_COLON] = ACTIONS(4928),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4924),
    [anon_sym_compl] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(5707),
    [anon_sym_PLUS_PLUS] = ACTIONS(5707),
    [anon_sym_sizeof] = ACTIONS(4932),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4934),
    [anon_sym_L_SQUOTE] = ACTIONS(4936),
    [anon_sym_u_SQUOTE] = ACTIONS(4936),
    [anon_sym_U_SQUOTE] = ACTIONS(4936),
    [anon_sym_u8_SQUOTE] = ACTIONS(4936),
    [anon_sym_SQUOTE] = ACTIONS(4936),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4938),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_co_await] = ACTIONS(4940),
    [anon_sym_new] = ACTIONS(4942),
    [anon_sym_requires] = ACTIONS(4944),
    [sym_this] = ACTIONS(241),
  },
  [1699] = {
    [sym_expression] = STATE(5140),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5709),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1700] = {
    [sym_expression] = STATE(5105),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5656),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1701] = {
    [sym_expression] = STATE(5363),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5656),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1702] = {
    [sym_expression] = STATE(4057),
    [sym__string] = STATE(4545),
    [sym_conditional_expression] = STATE(4545),
    [sym_assignment_expression] = STATE(4545),
    [sym_pointer_expression] = STATE(4540),
    [sym_unary_expression] = STATE(4545),
    [sym_binary_expression] = STATE(4545),
    [sym_update_expression] = STATE(4545),
    [sym_cast_expression] = STATE(4545),
    [sym_sizeof_expression] = STATE(4545),
    [sym_alignof_expression] = STATE(4545),
    [sym_offsetof_expression] = STATE(4545),
    [sym_generic_expression] = STATE(4545),
    [sym_subscript_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_gnu_asm_expression] = STATE(4545),
    [sym_field_expression] = STATE(4540),
    [sym_compound_literal_expression] = STATE(4545),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_char_literal] = STATE(4286),
    [sym_concatenated_string] = STATE(4290),
    [sym_string_literal] = STATE(3166),
    [sym_null] = STATE(4545),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9673),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4545),
    [sym_raw_string_literal] = STATE(3169),
    [sym_co_await_expression] = STATE(4545),
    [sym_new_expression] = STATE(4545),
    [sym_delete_expression] = STATE(4545),
    [sym_requires_clause] = STATE(4545),
    [sym_requires_expression] = STATE(4545),
    [sym_lambda_expression] = STATE(4545),
    [sym_lambda_capture_specifier] = STATE(7034),
    [sym_fold_expression] = STATE(4545),
    [sym_parameter_pack_expansion] = STATE(4545),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4540),
    [sym_qualified_type_identifier] = STATE(9673),
    [sym_user_defined_literal] = STATE(4540),
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_BANG] = ACTIONS(4733),
    [anon_sym_TILDE] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4731),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5656),
    [anon_sym_COLON_COLON] = ACTIONS(4735),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [sym_primitive_type] = ACTIONS(4739),
    [anon_sym_not] = ACTIONS(4731),
    [anon_sym_compl] = ACTIONS(4731),
    [anon_sym_DASH_DASH] = ACTIONS(5711),
    [anon_sym_PLUS_PLUS] = ACTIONS(5711),
    [anon_sym_sizeof] = ACTIONS(4741),
    [anon_sym___alignof__] = ACTIONS(4743),
    [anon_sym___alignof] = ACTIONS(4743),
    [anon_sym__alignof] = ACTIONS(4743),
    [anon_sym_alignof] = ACTIONS(4743),
    [anon_sym__Alignof] = ACTIONS(4743),
    [anon_sym_offsetof] = ACTIONS(4745),
    [anon_sym__Generic] = ACTIONS(4747),
    [anon_sym_asm] = ACTIONS(4749),
    [anon_sym___asm__] = ACTIONS(4749),
    [sym_number_literal] = ACTIONS(4751),
    [anon_sym_L_SQUOTE] = ACTIONS(4753),
    [anon_sym_u_SQUOTE] = ACTIONS(4753),
    [anon_sym_U_SQUOTE] = ACTIONS(4753),
    [anon_sym_u8_SQUOTE] = ACTIONS(4753),
    [anon_sym_SQUOTE] = ACTIONS(4753),
    [anon_sym_L_DQUOTE] = ACTIONS(4755),
    [anon_sym_u_DQUOTE] = ACTIONS(4755),
    [anon_sym_U_DQUOTE] = ACTIONS(4755),
    [anon_sym_u8_DQUOTE] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [anon_sym_NULL] = ACTIONS(4759),
    [anon_sym_nullptr] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4761),
    [anon_sym_R_DQUOTE] = ACTIONS(4763),
    [anon_sym_LR_DQUOTE] = ACTIONS(4763),
    [anon_sym_uR_DQUOTE] = ACTIONS(4763),
    [anon_sym_UR_DQUOTE] = ACTIONS(4763),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4763),
    [anon_sym_co_await] = ACTIONS(4765),
    [anon_sym_new] = ACTIONS(4767),
    [anon_sym_requires] = ACTIONS(4769),
    [sym_this] = ACTIONS(4757),
  },
  [1703] = {
    [sym_expression] = STATE(5329),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5656),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [1704] = {
    [sym_expression] = STATE(3853),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_BANG] = ACTIONS(4611),
    [anon_sym_TILDE] = ACTIONS(4611),
    [anon_sym_DASH] = ACTIONS(4609),
    [anon_sym_PLUS] = ACTIONS(4609),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5656),
    [anon_sym_COLON_COLON] = ACTIONS(4613),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4609),
    [anon_sym_compl] = ACTIONS(4609),
    [anon_sym_DASH_DASH] = ACTIONS(5713),
    [anon_sym_PLUS_PLUS] = ACTIONS(5713),
    [anon_sym_sizeof] = ACTIONS(4615),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4617),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4619),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1705] = {
    [sym_expression] = STATE(3870),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_BANG] = ACTIONS(4611),
    [anon_sym_TILDE] = ACTIONS(4611),
    [anon_sym_DASH] = ACTIONS(4609),
    [anon_sym_PLUS] = ACTIONS(4609),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5656),
    [anon_sym_COLON_COLON] = ACTIONS(4613),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4609),
    [anon_sym_compl] = ACTIONS(4609),
    [anon_sym_DASH_DASH] = ACTIONS(5713),
    [anon_sym_PLUS_PLUS] = ACTIONS(5713),
    [anon_sym_sizeof] = ACTIONS(4615),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4617),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4619),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1706] = {
    [sym_expression] = STATE(5143),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5670),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1707] = {
    [sym_catch_clause] = STATE(1707),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1707),
    [sym_identifier] = ACTIONS(2731),
    [aux_sym_preproc_def_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_AMP_AMP] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2731),
    [anon_sym___extension__] = ACTIONS(2731),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_in] = ACTIONS(2731),
    [anon_sym_out] = ACTIONS(2731),
    [anon_sym_inout] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym___based] = ACTIONS(2731),
    [anon_sym_RBRACE] = ACTIONS(2733),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym__Alignas] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2731),
    [anon_sym_let] = ACTIONS(2731),
    [anon_sym_This] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(2731),
    [sym_virtual] = ACTIONS(2731),
    [anon_sym_explicit] = ACTIONS(2731),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(2731),
    [anon_sym_operator] = ACTIONS(2731),
    [anon_sym_friend] = ACTIONS(2731),
    [anon_sym_public] = ACTIONS(2731),
    [anon_sym_private] = ACTIONS(2731),
    [anon_sym_protected] = ACTIONS(2731),
    [anon_sym_using] = ACTIONS(2731),
    [anon_sym_static_assert] = ACTIONS(2731),
    [anon_sym_catch] = ACTIONS(5715),
    [anon_sym_precise] = ACTIONS(2731),
    [anon_sym_shared] = ACTIONS(2731),
    [anon_sym_groupshared] = ACTIONS(2731),
    [anon_sym_uniform] = ACTIONS(2731),
    [anon_sym_row_major] = ACTIONS(2731),
    [anon_sym_column_major] = ACTIONS(2731),
    [anon_sym_globallycoherent] = ACTIONS(2731),
    [anon_sym_centroid] = ACTIONS(2731),
    [anon_sym_noperspective] = ACTIONS(2731),
    [anon_sym_nointerpolation] = ACTIONS(2731),
    [anon_sym_sample] = ACTIONS(2731),
    [anon_sym_linear] = ACTIONS(2731),
    [anon_sym_snorm] = ACTIONS(2731),
    [anon_sym_unorm] = ACTIONS(2731),
    [anon_sym_point] = ACTIONS(2731),
    [anon_sym_line] = ACTIONS(2731),
    [anon_sym_triangleadj] = ACTIONS(2731),
    [anon_sym_lineadj] = ACTIONS(2731),
    [anon_sym_triangle] = ACTIONS(2731),
    [anon_sym_interface] = ACTIONS(2731),
    [anon_sym_extension] = ACTIONS(2731),
    [anon_sym___init] = ACTIONS(2731),
    [anon_sym___subscript] = ACTIONS(2731),
    [anon_sym_property] = ACTIONS(2731),
    [anon_sym_associatedtype] = ACTIONS(2731),
  },
  [1708] = {
    [sym_expression] = STATE(5179),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5656),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4958),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4964),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1709] = {
    [sym_expression] = STATE(5159),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(5672),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5670),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1710] = {
    [sym_expression] = STATE(5140),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5718),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1711] = {
    [sym_expression] = STATE(5140),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5720),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1712] = {
    [sym_expression] = STATE(4875),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4905),
    [sym_concatenated_string] = STATE(4902),
    [sym_string_literal] = STATE(3611),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3610),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(5705),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_BANG] = ACTIONS(4926),
    [anon_sym_TILDE] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5656),
    [anon_sym_COLON_COLON] = ACTIONS(4928),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4924),
    [anon_sym_compl] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(5707),
    [anon_sym_PLUS_PLUS] = ACTIONS(5707),
    [anon_sym_sizeof] = ACTIONS(4932),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4934),
    [anon_sym_L_SQUOTE] = ACTIONS(4936),
    [anon_sym_u_SQUOTE] = ACTIONS(4936),
    [anon_sym_U_SQUOTE] = ACTIONS(4936),
    [anon_sym_u8_SQUOTE] = ACTIONS(4936),
    [anon_sym_SQUOTE] = ACTIONS(4936),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4938),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_co_await] = ACTIONS(4940),
    [anon_sym_new] = ACTIONS(4942),
    [anon_sym_requires] = ACTIONS(4944),
    [sym_this] = ACTIONS(241),
  },
  [1713] = {
    [sym_expression] = STATE(5140),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5722),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1714] = {
    [sym_expression] = STATE(5140),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5724),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1715] = {
    [sym_expression] = STATE(5174),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_initializer_list] = STATE(9271),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5726),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1716] = {
    [sym_catch_clause] = STATE(1707),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1707),
    [sym_identifier] = ACTIONS(2744),
    [aux_sym_preproc_def_token1] = ACTIONS(2744),
    [aux_sym_preproc_if_token1] = ACTIONS(2744),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2744),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2744),
    [sym_preproc_directive] = ACTIONS(2744),
    [anon_sym_LPAREN2] = ACTIONS(2746),
    [anon_sym_TILDE] = ACTIONS(2746),
    [anon_sym_STAR] = ACTIONS(2746),
    [anon_sym_AMP_AMP] = ACTIONS(2746),
    [anon_sym_AMP] = ACTIONS(2744),
    [anon_sym___extension__] = ACTIONS(2744),
    [anon_sym_typedef] = ACTIONS(2744),
    [anon_sym_in] = ACTIONS(2744),
    [anon_sym_out] = ACTIONS(2744),
    [anon_sym_inout] = ACTIONS(2744),
    [anon_sym_extern] = ACTIONS(2744),
    [anon_sym___attribute__] = ACTIONS(2744),
    [anon_sym_COLON_COLON] = ACTIONS(2746),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2746),
    [anon_sym___declspec] = ACTIONS(2744),
    [anon_sym___based] = ACTIONS(2744),
    [anon_sym_RBRACE] = ACTIONS(2746),
    [anon_sym_signed] = ACTIONS(2744),
    [anon_sym_unsigned] = ACTIONS(2744),
    [anon_sym_long] = ACTIONS(2744),
    [anon_sym_short] = ACTIONS(2744),
    [anon_sym_LBRACK] = ACTIONS(2744),
    [anon_sym_static] = ACTIONS(2744),
    [anon_sym_register] = ACTIONS(2744),
    [anon_sym_inline] = ACTIONS(2744),
    [anon_sym___inline] = ACTIONS(2744),
    [anon_sym___inline__] = ACTIONS(2744),
    [anon_sym___forceinline] = ACTIONS(2744),
    [anon_sym_thread_local] = ACTIONS(2744),
    [anon_sym___thread] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_constexpr] = ACTIONS(2744),
    [anon_sym_volatile] = ACTIONS(2744),
    [anon_sym_restrict] = ACTIONS(2744),
    [anon_sym___restrict__] = ACTIONS(2744),
    [anon_sym__Atomic] = ACTIONS(2744),
    [anon_sym__Noreturn] = ACTIONS(2744),
    [anon_sym_noreturn] = ACTIONS(2744),
    [anon_sym_mutable] = ACTIONS(2744),
    [anon_sym_constinit] = ACTIONS(2744),
    [anon_sym_consteval] = ACTIONS(2744),
    [anon_sym_alignas] = ACTIONS(2744),
    [anon_sym__Alignas] = ACTIONS(2744),
    [sym_primitive_type] = ACTIONS(2744),
    [anon_sym_enum] = ACTIONS(2744),
    [anon_sym_class] = ACTIONS(2744),
    [anon_sym_struct] = ACTIONS(2744),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2744),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_This] = ACTIONS(2744),
    [anon_sym_decltype] = ACTIONS(2744),
    [sym_virtual] = ACTIONS(2744),
    [anon_sym_explicit] = ACTIONS(2744),
    [anon_sym_typename] = ACTIONS(2744),
    [anon_sym_template] = ACTIONS(2744),
    [anon_sym_operator] = ACTIONS(2744),
    [anon_sym_friend] = ACTIONS(2744),
    [anon_sym_public] = ACTIONS(2744),
    [anon_sym_private] = ACTIONS(2744),
    [anon_sym_protected] = ACTIONS(2744),
    [anon_sym_using] = ACTIONS(2744),
    [anon_sym_static_assert] = ACTIONS(2744),
    [anon_sym_catch] = ACTIONS(5680),
    [anon_sym_precise] = ACTIONS(2744),
    [anon_sym_shared] = ACTIONS(2744),
    [anon_sym_groupshared] = ACTIONS(2744),
    [anon_sym_uniform] = ACTIONS(2744),
    [anon_sym_row_major] = ACTIONS(2744),
    [anon_sym_column_major] = ACTIONS(2744),
    [anon_sym_globallycoherent] = ACTIONS(2744),
    [anon_sym_centroid] = ACTIONS(2744),
    [anon_sym_noperspective] = ACTIONS(2744),
    [anon_sym_nointerpolation] = ACTIONS(2744),
    [anon_sym_sample] = ACTIONS(2744),
    [anon_sym_linear] = ACTIONS(2744),
    [anon_sym_snorm] = ACTIONS(2744),
    [anon_sym_unorm] = ACTIONS(2744),
    [anon_sym_point] = ACTIONS(2744),
    [anon_sym_line] = ACTIONS(2744),
    [anon_sym_triangleadj] = ACTIONS(2744),
    [anon_sym_lineadj] = ACTIONS(2744),
    [anon_sym_triangle] = ACTIONS(2744),
    [anon_sym_interface] = ACTIONS(2744),
    [anon_sym_extension] = ACTIONS(2744),
    [anon_sym___init] = ACTIONS(2744),
    [anon_sym___subscript] = ACTIONS(2744),
    [anon_sym_property] = ACTIONS(2744),
    [anon_sym_associatedtype] = ACTIONS(2744),
  },
  [1717] = {
    [sym_expression] = STATE(5140),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5728),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1718] = {
    [sym_expression] = STATE(3702),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(4134),
    [sym_concatenated_string] = STATE(4159),
    [sym_string_literal] = STATE(3152),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(3145),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4587),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_BANG] = ACTIONS(4591),
    [anon_sym_TILDE] = ACTIONS(4591),
    [anon_sym_DASH] = ACTIONS(4589),
    [anon_sym_PLUS] = ACTIONS(4589),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5656),
    [anon_sym_COLON_COLON] = ACTIONS(4593),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4589),
    [anon_sym_compl] = ACTIONS(4589),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_sizeof] = ACTIONS(4595),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4597),
    [anon_sym_L_SQUOTE] = ACTIONS(4599),
    [anon_sym_u_SQUOTE] = ACTIONS(4599),
    [anon_sym_U_SQUOTE] = ACTIONS(4599),
    [anon_sym_u8_SQUOTE] = ACTIONS(4599),
    [anon_sym_SQUOTE] = ACTIONS(4599),
    [anon_sym_L_DQUOTE] = ACTIONS(4601),
    [anon_sym_u_DQUOTE] = ACTIONS(4601),
    [anon_sym_U_DQUOTE] = ACTIONS(4601),
    [anon_sym_u8_DQUOTE] = ACTIONS(4601),
    [anon_sym_DQUOTE] = ACTIONS(4601),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4603),
    [anon_sym_R_DQUOTE] = ACTIONS(4605),
    [anon_sym_LR_DQUOTE] = ACTIONS(4605),
    [anon_sym_uR_DQUOTE] = ACTIONS(4605),
    [anon_sym_UR_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4605),
    [anon_sym_co_await] = ACTIONS(4607),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1719] = {
    [sym_catch_clause] = STATE(1707),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1707),
    [sym_identifier] = ACTIONS(2830),
    [aux_sym_preproc_def_token1] = ACTIONS(2830),
    [aux_sym_preproc_if_token1] = ACTIONS(2830),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2830),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2830),
    [sym_preproc_directive] = ACTIONS(2830),
    [anon_sym_LPAREN2] = ACTIONS(2832),
    [anon_sym_TILDE] = ACTIONS(2832),
    [anon_sym_STAR] = ACTIONS(2832),
    [anon_sym_AMP_AMP] = ACTIONS(2832),
    [anon_sym_AMP] = ACTIONS(2830),
    [anon_sym___extension__] = ACTIONS(2830),
    [anon_sym_typedef] = ACTIONS(2830),
    [anon_sym_in] = ACTIONS(2830),
    [anon_sym_out] = ACTIONS(2830),
    [anon_sym_inout] = ACTIONS(2830),
    [anon_sym_extern] = ACTIONS(2830),
    [anon_sym___attribute__] = ACTIONS(2830),
    [anon_sym_COLON_COLON] = ACTIONS(2832),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2832),
    [anon_sym___declspec] = ACTIONS(2830),
    [anon_sym___based] = ACTIONS(2830),
    [anon_sym_RBRACE] = ACTIONS(2832),
    [anon_sym_signed] = ACTIONS(2830),
    [anon_sym_unsigned] = ACTIONS(2830),
    [anon_sym_long] = ACTIONS(2830),
    [anon_sym_short] = ACTIONS(2830),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [anon_sym_static] = ACTIONS(2830),
    [anon_sym_register] = ACTIONS(2830),
    [anon_sym_inline] = ACTIONS(2830),
    [anon_sym___inline] = ACTIONS(2830),
    [anon_sym___inline__] = ACTIONS(2830),
    [anon_sym___forceinline] = ACTIONS(2830),
    [anon_sym_thread_local] = ACTIONS(2830),
    [anon_sym___thread] = ACTIONS(2830),
    [anon_sym_const] = ACTIONS(2830),
    [anon_sym_constexpr] = ACTIONS(2830),
    [anon_sym_volatile] = ACTIONS(2830),
    [anon_sym_restrict] = ACTIONS(2830),
    [anon_sym___restrict__] = ACTIONS(2830),
    [anon_sym__Atomic] = ACTIONS(2830),
    [anon_sym__Noreturn] = ACTIONS(2830),
    [anon_sym_noreturn] = ACTIONS(2830),
    [anon_sym_mutable] = ACTIONS(2830),
    [anon_sym_constinit] = ACTIONS(2830),
    [anon_sym_consteval] = ACTIONS(2830),
    [anon_sym_alignas] = ACTIONS(2830),
    [anon_sym__Alignas] = ACTIONS(2830),
    [sym_primitive_type] = ACTIONS(2830),
    [anon_sym_enum] = ACTIONS(2830),
    [anon_sym_class] = ACTIONS(2830),
    [anon_sym_struct] = ACTIONS(2830),
    [anon_sym_union] = ACTIONS(2830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2830),
    [anon_sym_let] = ACTIONS(2830),
    [anon_sym_This] = ACTIONS(2830),
    [anon_sym_decltype] = ACTIONS(2830),
    [sym_virtual] = ACTIONS(2830),
    [anon_sym_explicit] = ACTIONS(2830),
    [anon_sym_typename] = ACTIONS(2830),
    [anon_sym_template] = ACTIONS(2830),
    [anon_sym_operator] = ACTIONS(2830),
    [anon_sym_friend] = ACTIONS(2830),
    [anon_sym_public] = ACTIONS(2830),
    [anon_sym_private] = ACTIONS(2830),
    [anon_sym_protected] = ACTIONS(2830),
    [anon_sym_using] = ACTIONS(2830),
    [anon_sym_static_assert] = ACTIONS(2830),
    [anon_sym_catch] = ACTIONS(5680),
    [anon_sym_precise] = ACTIONS(2830),
    [anon_sym_shared] = ACTIONS(2830),
    [anon_sym_groupshared] = ACTIONS(2830),
    [anon_sym_uniform] = ACTIONS(2830),
    [anon_sym_row_major] = ACTIONS(2830),
    [anon_sym_column_major] = ACTIONS(2830),
    [anon_sym_globallycoherent] = ACTIONS(2830),
    [anon_sym_centroid] = ACTIONS(2830),
    [anon_sym_noperspective] = ACTIONS(2830),
    [anon_sym_nointerpolation] = ACTIONS(2830),
    [anon_sym_sample] = ACTIONS(2830),
    [anon_sym_linear] = ACTIONS(2830),
    [anon_sym_snorm] = ACTIONS(2830),
    [anon_sym_unorm] = ACTIONS(2830),
    [anon_sym_point] = ACTIONS(2830),
    [anon_sym_line] = ACTIONS(2830),
    [anon_sym_triangleadj] = ACTIONS(2830),
    [anon_sym_lineadj] = ACTIONS(2830),
    [anon_sym_triangle] = ACTIONS(2830),
    [anon_sym_interface] = ACTIONS(2830),
    [anon_sym_extension] = ACTIONS(2830),
    [anon_sym___init] = ACTIONS(2830),
    [anon_sym___subscript] = ACTIONS(2830),
    [anon_sym_property] = ACTIONS(2830),
    [anon_sym_associatedtype] = ACTIONS(2830),
  },
  [1720] = {
    [sym_expression] = STATE(5541),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10377),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5732),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1721] = {
    [sym_expression] = STATE(5140),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5735),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1722] = {
    [sym_expression] = STATE(4196),
    [sym__string] = STATE(4545),
    [sym_conditional_expression] = STATE(4545),
    [sym_assignment_expression] = STATE(4545),
    [sym_pointer_expression] = STATE(4540),
    [sym_unary_expression] = STATE(4545),
    [sym_binary_expression] = STATE(4545),
    [sym_update_expression] = STATE(4545),
    [sym_cast_expression] = STATE(4545),
    [sym_sizeof_expression] = STATE(4545),
    [sym_alignof_expression] = STATE(4545),
    [sym_offsetof_expression] = STATE(4545),
    [sym_generic_expression] = STATE(4545),
    [sym_subscript_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_gnu_asm_expression] = STATE(4545),
    [sym_field_expression] = STATE(4540),
    [sym_compound_literal_expression] = STATE(4545),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_char_literal] = STATE(4286),
    [sym_concatenated_string] = STATE(4290),
    [sym_string_literal] = STATE(3166),
    [sym_null] = STATE(4545),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9673),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4545),
    [sym_raw_string_literal] = STATE(3169),
    [sym_co_await_expression] = STATE(4545),
    [sym_new_expression] = STATE(4545),
    [sym_delete_expression] = STATE(4545),
    [sym_requires_clause] = STATE(4545),
    [sym_requires_expression] = STATE(4545),
    [sym_lambda_expression] = STATE(4545),
    [sym_lambda_capture_specifier] = STATE(7034),
    [sym_fold_expression] = STATE(4545),
    [sym_parameter_pack_expansion] = STATE(4545),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4540),
    [sym_qualified_type_identifier] = STATE(9673),
    [sym_user_defined_literal] = STATE(4540),
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_BANG] = ACTIONS(4733),
    [anon_sym_TILDE] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4731),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5656),
    [anon_sym_COLON_COLON] = ACTIONS(4735),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [sym_primitive_type] = ACTIONS(4739),
    [anon_sym_not] = ACTIONS(4731),
    [anon_sym_compl] = ACTIONS(4731),
    [anon_sym_DASH_DASH] = ACTIONS(5711),
    [anon_sym_PLUS_PLUS] = ACTIONS(5711),
    [anon_sym_sizeof] = ACTIONS(4741),
    [anon_sym___alignof__] = ACTIONS(4743),
    [anon_sym___alignof] = ACTIONS(4743),
    [anon_sym__alignof] = ACTIONS(4743),
    [anon_sym_alignof] = ACTIONS(4743),
    [anon_sym__Alignof] = ACTIONS(4743),
    [anon_sym_offsetof] = ACTIONS(4745),
    [anon_sym__Generic] = ACTIONS(4747),
    [anon_sym_asm] = ACTIONS(4749),
    [anon_sym___asm__] = ACTIONS(4749),
    [sym_number_literal] = ACTIONS(4751),
    [anon_sym_L_SQUOTE] = ACTIONS(4753),
    [anon_sym_u_SQUOTE] = ACTIONS(4753),
    [anon_sym_U_SQUOTE] = ACTIONS(4753),
    [anon_sym_u8_SQUOTE] = ACTIONS(4753),
    [anon_sym_SQUOTE] = ACTIONS(4753),
    [anon_sym_L_DQUOTE] = ACTIONS(4755),
    [anon_sym_u_DQUOTE] = ACTIONS(4755),
    [anon_sym_U_DQUOTE] = ACTIONS(4755),
    [anon_sym_u8_DQUOTE] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [anon_sym_NULL] = ACTIONS(4759),
    [anon_sym_nullptr] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4761),
    [anon_sym_R_DQUOTE] = ACTIONS(4763),
    [anon_sym_LR_DQUOTE] = ACTIONS(4763),
    [anon_sym_uR_DQUOTE] = ACTIONS(4763),
    [anon_sym_UR_DQUOTE] = ACTIONS(4763),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4763),
    [anon_sym_co_await] = ACTIONS(4765),
    [anon_sym_new] = ACTIONS(4767),
    [anon_sym_requires] = ACTIONS(4769),
    [sym_this] = ACTIONS(4757),
  },
  [1723] = {
    [sym_expression] = STATE(5140),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5737),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1724] = {
    [sym_expression] = STATE(3511),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5656),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1725] = {
    [sym_expression] = STATE(5073),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5656),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1726] = {
    [sym_expression] = STATE(5140),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5739),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1727] = {
    [sym_catch_clause] = STATE(1734),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1734),
    [sym_identifier] = ACTIONS(2830),
    [aux_sym_preproc_def_token1] = ACTIONS(2830),
    [aux_sym_preproc_if_token1] = ACTIONS(2830),
    [aux_sym_preproc_if_token2] = ACTIONS(2830),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2830),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2830),
    [sym_preproc_directive] = ACTIONS(2830),
    [anon_sym_LPAREN2] = ACTIONS(2832),
    [anon_sym_TILDE] = ACTIONS(2832),
    [anon_sym_STAR] = ACTIONS(2832),
    [anon_sym_AMP_AMP] = ACTIONS(2832),
    [anon_sym_AMP] = ACTIONS(2830),
    [anon_sym___extension__] = ACTIONS(2830),
    [anon_sym_typedef] = ACTIONS(2830),
    [anon_sym_in] = ACTIONS(2830),
    [anon_sym_out] = ACTIONS(2830),
    [anon_sym_inout] = ACTIONS(2830),
    [anon_sym_extern] = ACTIONS(2830),
    [anon_sym___attribute__] = ACTIONS(2830),
    [anon_sym_COLON_COLON] = ACTIONS(2832),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2832),
    [anon_sym___declspec] = ACTIONS(2830),
    [anon_sym___based] = ACTIONS(2830),
    [anon_sym_signed] = ACTIONS(2830),
    [anon_sym_unsigned] = ACTIONS(2830),
    [anon_sym_long] = ACTIONS(2830),
    [anon_sym_short] = ACTIONS(2830),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [anon_sym_static] = ACTIONS(2830),
    [anon_sym_register] = ACTIONS(2830),
    [anon_sym_inline] = ACTIONS(2830),
    [anon_sym___inline] = ACTIONS(2830),
    [anon_sym___inline__] = ACTIONS(2830),
    [anon_sym___forceinline] = ACTIONS(2830),
    [anon_sym_thread_local] = ACTIONS(2830),
    [anon_sym___thread] = ACTIONS(2830),
    [anon_sym_const] = ACTIONS(2830),
    [anon_sym_constexpr] = ACTIONS(2830),
    [anon_sym_volatile] = ACTIONS(2830),
    [anon_sym_restrict] = ACTIONS(2830),
    [anon_sym___restrict__] = ACTIONS(2830),
    [anon_sym__Atomic] = ACTIONS(2830),
    [anon_sym__Noreturn] = ACTIONS(2830),
    [anon_sym_noreturn] = ACTIONS(2830),
    [anon_sym_mutable] = ACTIONS(2830),
    [anon_sym_constinit] = ACTIONS(2830),
    [anon_sym_consteval] = ACTIONS(2830),
    [anon_sym_alignas] = ACTIONS(2830),
    [anon_sym__Alignas] = ACTIONS(2830),
    [sym_primitive_type] = ACTIONS(2830),
    [anon_sym_enum] = ACTIONS(2830),
    [anon_sym_class] = ACTIONS(2830),
    [anon_sym_struct] = ACTIONS(2830),
    [anon_sym_union] = ACTIONS(2830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2830),
    [anon_sym_let] = ACTIONS(2830),
    [anon_sym_This] = ACTIONS(2830),
    [anon_sym_decltype] = ACTIONS(2830),
    [sym_virtual] = ACTIONS(2830),
    [anon_sym_explicit] = ACTIONS(2830),
    [anon_sym_typename] = ACTIONS(2830),
    [anon_sym_template] = ACTIONS(2830),
    [anon_sym_operator] = ACTIONS(2830),
    [anon_sym_friend] = ACTIONS(2830),
    [anon_sym_public] = ACTIONS(2830),
    [anon_sym_private] = ACTIONS(2830),
    [anon_sym_protected] = ACTIONS(2830),
    [anon_sym_using] = ACTIONS(2830),
    [anon_sym_static_assert] = ACTIONS(2830),
    [anon_sym_catch] = ACTIONS(5692),
    [anon_sym_precise] = ACTIONS(2830),
    [anon_sym_shared] = ACTIONS(2830),
    [anon_sym_groupshared] = ACTIONS(2830),
    [anon_sym_uniform] = ACTIONS(2830),
    [anon_sym_row_major] = ACTIONS(2830),
    [anon_sym_column_major] = ACTIONS(2830),
    [anon_sym_globallycoherent] = ACTIONS(2830),
    [anon_sym_centroid] = ACTIONS(2830),
    [anon_sym_noperspective] = ACTIONS(2830),
    [anon_sym_nointerpolation] = ACTIONS(2830),
    [anon_sym_sample] = ACTIONS(2830),
    [anon_sym_linear] = ACTIONS(2830),
    [anon_sym_snorm] = ACTIONS(2830),
    [anon_sym_unorm] = ACTIONS(2830),
    [anon_sym_point] = ACTIONS(2830),
    [anon_sym_line] = ACTIONS(2830),
    [anon_sym_triangleadj] = ACTIONS(2830),
    [anon_sym_lineadj] = ACTIONS(2830),
    [anon_sym_triangle] = ACTIONS(2830),
    [anon_sym_interface] = ACTIONS(2830),
    [anon_sym_extension] = ACTIONS(2830),
    [anon_sym___init] = ACTIONS(2830),
    [anon_sym___subscript] = ACTIONS(2830),
    [anon_sym_property] = ACTIONS(2830),
    [anon_sym_associatedtype] = ACTIONS(2830),
  },
  [1728] = {
    [sym_expression] = STATE(5541),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10377),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5741),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1729] = {
    [sym_expression] = STATE(5140),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5744),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1730] = {
    [sym_expression] = STATE(5140),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5746),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1731] = {
    [sym_expression] = STATE(5429),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5656),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1732] = {
    [sym_expression] = STATE(5140),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5748),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1733] = {
    [sym_expression] = STATE(5189),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5656),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4958),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4964),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1734] = {
    [sym_catch_clause] = STATE(1734),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1734),
    [sym_identifier] = ACTIONS(2731),
    [aux_sym_preproc_def_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token2] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_AMP_AMP] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2731),
    [anon_sym___extension__] = ACTIONS(2731),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_in] = ACTIONS(2731),
    [anon_sym_out] = ACTIONS(2731),
    [anon_sym_inout] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym___based] = ACTIONS(2731),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym__Alignas] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2731),
    [anon_sym_let] = ACTIONS(2731),
    [anon_sym_This] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(2731),
    [sym_virtual] = ACTIONS(2731),
    [anon_sym_explicit] = ACTIONS(2731),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(2731),
    [anon_sym_operator] = ACTIONS(2731),
    [anon_sym_friend] = ACTIONS(2731),
    [anon_sym_public] = ACTIONS(2731),
    [anon_sym_private] = ACTIONS(2731),
    [anon_sym_protected] = ACTIONS(2731),
    [anon_sym_using] = ACTIONS(2731),
    [anon_sym_static_assert] = ACTIONS(2731),
    [anon_sym_catch] = ACTIONS(5750),
    [anon_sym_precise] = ACTIONS(2731),
    [anon_sym_shared] = ACTIONS(2731),
    [anon_sym_groupshared] = ACTIONS(2731),
    [anon_sym_uniform] = ACTIONS(2731),
    [anon_sym_row_major] = ACTIONS(2731),
    [anon_sym_column_major] = ACTIONS(2731),
    [anon_sym_globallycoherent] = ACTIONS(2731),
    [anon_sym_centroid] = ACTIONS(2731),
    [anon_sym_noperspective] = ACTIONS(2731),
    [anon_sym_nointerpolation] = ACTIONS(2731),
    [anon_sym_sample] = ACTIONS(2731),
    [anon_sym_linear] = ACTIONS(2731),
    [anon_sym_snorm] = ACTIONS(2731),
    [anon_sym_unorm] = ACTIONS(2731),
    [anon_sym_point] = ACTIONS(2731),
    [anon_sym_line] = ACTIONS(2731),
    [anon_sym_triangleadj] = ACTIONS(2731),
    [anon_sym_lineadj] = ACTIONS(2731),
    [anon_sym_triangle] = ACTIONS(2731),
    [anon_sym_interface] = ACTIONS(2731),
    [anon_sym_extension] = ACTIONS(2731),
    [anon_sym___init] = ACTIONS(2731),
    [anon_sym___subscript] = ACTIONS(2731),
    [anon_sym_property] = ACTIONS(2731),
    [anon_sym_associatedtype] = ACTIONS(2731),
  },
  [1735] = {
    [sym_expression] = STATE(3703),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(4134),
    [sym_concatenated_string] = STATE(4159),
    [sym_string_literal] = STATE(3152),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(3145),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4587),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_BANG] = ACTIONS(4591),
    [anon_sym_TILDE] = ACTIONS(4591),
    [anon_sym_DASH] = ACTIONS(4589),
    [anon_sym_PLUS] = ACTIONS(4589),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5656),
    [anon_sym_COLON_COLON] = ACTIONS(4593),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4589),
    [anon_sym_compl] = ACTIONS(4589),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_sizeof] = ACTIONS(4595),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4597),
    [anon_sym_L_SQUOTE] = ACTIONS(4599),
    [anon_sym_u_SQUOTE] = ACTIONS(4599),
    [anon_sym_U_SQUOTE] = ACTIONS(4599),
    [anon_sym_u8_SQUOTE] = ACTIONS(4599),
    [anon_sym_SQUOTE] = ACTIONS(4599),
    [anon_sym_L_DQUOTE] = ACTIONS(4601),
    [anon_sym_u_DQUOTE] = ACTIONS(4601),
    [anon_sym_U_DQUOTE] = ACTIONS(4601),
    [anon_sym_u8_DQUOTE] = ACTIONS(4601),
    [anon_sym_DQUOTE] = ACTIONS(4601),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4603),
    [anon_sym_R_DQUOTE] = ACTIONS(4605),
    [anon_sym_LR_DQUOTE] = ACTIONS(4605),
    [anon_sym_uR_DQUOTE] = ACTIONS(4605),
    [anon_sym_UR_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4605),
    [anon_sym_co_await] = ACTIONS(4607),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1736] = {
    [sym_expression] = STATE(5541),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10377),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5753),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1737] = {
    [sym_expression] = STATE(3704),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5656),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1738] = {
    [sym_expression] = STATE(3466),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3481),
    [sym_concatenated_string] = STATE(3486),
    [sym_string_literal] = STATE(2963),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2960),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4412),
    [anon_sym_PLUS] = ACTIONS(4412),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5656),
    [anon_sym_COLON_COLON] = ACTIONS(4416),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4412),
    [anon_sym_compl] = ACTIONS(4412),
    [anon_sym_DASH_DASH] = ACTIONS(5756),
    [anon_sym_PLUS_PLUS] = ACTIONS(5756),
    [anon_sym_sizeof] = ACTIONS(4422),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4432),
    [anon_sym_L_SQUOTE] = ACTIONS(4434),
    [anon_sym_u_SQUOTE] = ACTIONS(4434),
    [anon_sym_U_SQUOTE] = ACTIONS(4434),
    [anon_sym_u8_SQUOTE] = ACTIONS(4434),
    [anon_sym_SQUOTE] = ACTIONS(4434),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4442),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [anon_sym_co_await] = ACTIONS(4446),
    [anon_sym_new] = ACTIONS(4448),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1739] = {
    [sym_expression] = STATE(5394),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5656),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1740] = {
    [sym_expression] = STATE(5541),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10377),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5758),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1741] = {
    [sym_expression] = STATE(3416),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3481),
    [sym_concatenated_string] = STATE(3486),
    [sym_string_literal] = STATE(2963),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2960),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4412),
    [anon_sym_PLUS] = ACTIONS(4412),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5656),
    [anon_sym_COLON_COLON] = ACTIONS(4416),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4412),
    [anon_sym_compl] = ACTIONS(4412),
    [anon_sym_DASH_DASH] = ACTIONS(5756),
    [anon_sym_PLUS_PLUS] = ACTIONS(5756),
    [anon_sym_sizeof] = ACTIONS(4422),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4432),
    [anon_sym_L_SQUOTE] = ACTIONS(4434),
    [anon_sym_u_SQUOTE] = ACTIONS(4434),
    [anon_sym_U_SQUOTE] = ACTIONS(4434),
    [anon_sym_u8_SQUOTE] = ACTIONS(4434),
    [anon_sym_SQUOTE] = ACTIONS(4434),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4442),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [anon_sym_co_await] = ACTIONS(4446),
    [anon_sym_new] = ACTIONS(4448),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1742] = {
    [sym_expression] = STATE(5541),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10377),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5761),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1743] = {
    [sym_expression] = STATE(5541),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10377),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5764),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1744] = {
    [sym_expression] = STATE(5140),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_lambda_default_capture] = STATE(10006),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5767),
    [anon_sym_EQ] = ACTIONS(5666),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1745] = {
    [sym_expression] = STATE(5541),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10377),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5769),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1746] = {
    [sym_expression] = STATE(5541),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10377),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5772),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1747] = {
    [sym_expression] = STATE(5541),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10377),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5775),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1748] = {
    [sym_expression] = STATE(5541),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10377),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5778),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1749] = {
    [sym_expression] = STATE(3852),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_initializer_list] = STATE(3277),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5781),
    [anon_sym_BANG] = ACTIONS(4611),
    [anon_sym_TILDE] = ACTIONS(4611),
    [anon_sym_DASH] = ACTIONS(4609),
    [anon_sym_PLUS] = ACTIONS(4609),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4613),
    [anon_sym_LBRACE] = ACTIONS(4418),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4609),
    [anon_sym_compl] = ACTIONS(4609),
    [anon_sym_DASH_DASH] = ACTIONS(5713),
    [anon_sym_PLUS_PLUS] = ACTIONS(5713),
    [anon_sym_sizeof] = ACTIONS(4615),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4617),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4619),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1750] = {
    [sym_expression] = STATE(5391),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(9702),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1751] = {
    [sym_expression] = STATE(3205),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_initializer_list] = STATE(3277),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACE] = ACTIONS(4418),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1752] = {
    [sym_expression] = STATE(5315),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10255),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON] = ACTIONS(5789),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1753] = {
    [sym_expression] = STATE(5414),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10251),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_RPAREN] = ACTIONS(5791),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1754] = {
    [sym_expression] = STATE(5541),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10377),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1755] = {
    [sym_expression] = STATE(5399),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10270),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON] = ACTIONS(5793),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1756] = {
    [sym_expression] = STATE(3205),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_initializer_list] = STATE(3277),
    [sym_char_literal] = STATE(3481),
    [sym_concatenated_string] = STATE(3486),
    [sym_string_literal] = STATE(2963),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2960),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5795),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4412),
    [anon_sym_PLUS] = ACTIONS(4412),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4416),
    [anon_sym_LBRACE] = ACTIONS(4418),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4412),
    [anon_sym_compl] = ACTIONS(4412),
    [anon_sym_DASH_DASH] = ACTIONS(5756),
    [anon_sym_PLUS_PLUS] = ACTIONS(5756),
    [anon_sym_sizeof] = ACTIONS(4422),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4432),
    [anon_sym_L_SQUOTE] = ACTIONS(4434),
    [anon_sym_u_SQUOTE] = ACTIONS(4434),
    [anon_sym_U_SQUOTE] = ACTIONS(4434),
    [anon_sym_u8_SQUOTE] = ACTIONS(4434),
    [anon_sym_SQUOTE] = ACTIONS(4434),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4442),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [anon_sym_co_await] = ACTIONS(4446),
    [anon_sym_new] = ACTIONS(4448),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1757] = {
    [sym_expression] = STATE(5338),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10498),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(3876),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1758] = {
    [sym_expression] = STATE(4551),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_initializer_list] = STATE(4682),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACE] = ACTIONS(4867),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1759] = {
    [sym_expression] = STATE(5335),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10368),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON] = ACTIONS(5799),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1760] = {
    [sym_expression] = STATE(5462),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10524),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_RPAREN] = ACTIONS(5801),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1761] = {
    [sym_expression] = STATE(5318),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10841),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON] = ACTIONS(5803),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1762] = {
    [sym_expression] = STATE(4615),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_initializer_list] = STATE(4714),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1763] = {
    [sym_expression] = STATE(5456),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10527),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_RPAREN] = ACTIONS(5805),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1764] = {
    [sym_expression] = STATE(5423),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10397),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON] = ACTIONS(5807),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1765] = {
    [sym_expression] = STATE(3215),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_COMMA] = ACTIONS(5809),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5809),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1766] = {
    [sym_expression] = STATE(4615),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_initializer_list] = STATE(4714),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4958),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4964),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1767] = {
    [sym_expression] = STATE(3916),
    [sym__string] = STATE(3316),
    [sym_comma_expression] = STATE(10715),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym__assignment_expression_lhs] = STATE(10673),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1768] = {
    [sym_expression] = STATE(5130),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_initializer_list] = STATE(9552),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4958),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4964),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1769] = {
    [sym_expression] = STATE(5339),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10503),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1770] = {
    [sym_expression] = STATE(5413),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10228),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_RPAREN] = ACTIONS(5811),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1771] = {
    [sym_expression] = STATE(5342),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_initializer_list] = STATE(5720),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACE] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [1772] = {
    [sym_expression] = STATE(3749),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_initializer_list] = STATE(4375),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1773] = {
    [sym_expression] = STATE(5470),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10833),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON] = ACTIONS(5813),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1774] = {
    [sym_expression] = STATE(5468),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10159),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON] = ACTIONS(5815),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1775] = {
    [sym_expression] = STATE(5206),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(9702),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1776] = {
    [sym_expression] = STATE(5395),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_initializer_list] = STATE(4725),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1777] = {
    [sym_expression] = STATE(5402),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_initializer_list] = STATE(4714),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1778] = {
    [sym_expression] = STATE(5344),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_initializer_list] = STATE(9843),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1779] = {
    [sym_expression] = STATE(5336),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10806),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON] = ACTIONS(5817),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1780] = {
    [sym_expression] = STATE(5403),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_initializer_list] = STATE(4725),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1781] = {
    [sym_expression] = STATE(3205),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_initializer_list] = STATE(3277),
    [sym_char_literal] = STATE(4134),
    [sym_concatenated_string] = STATE(4159),
    [sym_string_literal] = STATE(3152),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(3145),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4587),
    [anon_sym_LPAREN2] = ACTIONS(5819),
    [anon_sym_BANG] = ACTIONS(4591),
    [anon_sym_TILDE] = ACTIONS(4591),
    [anon_sym_DASH] = ACTIONS(4589),
    [anon_sym_PLUS] = ACTIONS(4589),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4593),
    [anon_sym_LBRACE] = ACTIONS(4418),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4589),
    [anon_sym_compl] = ACTIONS(4589),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_sizeof] = ACTIONS(4595),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4597),
    [anon_sym_L_SQUOTE] = ACTIONS(4599),
    [anon_sym_u_SQUOTE] = ACTIONS(4599),
    [anon_sym_U_SQUOTE] = ACTIONS(4599),
    [anon_sym_u8_SQUOTE] = ACTIONS(4599),
    [anon_sym_SQUOTE] = ACTIONS(4599),
    [anon_sym_L_DQUOTE] = ACTIONS(4601),
    [anon_sym_u_DQUOTE] = ACTIONS(4601),
    [anon_sym_U_DQUOTE] = ACTIONS(4601),
    [anon_sym_u8_DQUOTE] = ACTIONS(4601),
    [anon_sym_DQUOTE] = ACTIONS(4601),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4603),
    [anon_sym_R_DQUOTE] = ACTIONS(4605),
    [anon_sym_LR_DQUOTE] = ACTIONS(4605),
    [anon_sym_uR_DQUOTE] = ACTIONS(4605),
    [anon_sym_UR_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4605),
    [anon_sym_co_await] = ACTIONS(4607),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1782] = {
    [sym_expression] = STATE(4535),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_initializer_list] = STATE(4641),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACE] = ACTIONS(4867),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1783] = {
    [sym_identifier] = ACTIONS(2359),
    [aux_sym_preproc_def_token1] = ACTIONS(2359),
    [anon_sym_COMMA] = ACTIONS(3834),
    [aux_sym_preproc_if_token1] = ACTIONS(2359),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2359),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2359),
    [sym_preproc_directive] = ACTIONS(2359),
    [anon_sym_LPAREN2] = ACTIONS(2357),
    [anon_sym_TILDE] = ACTIONS(2357),
    [anon_sym_STAR] = ACTIONS(2357),
    [anon_sym_AMP_AMP] = ACTIONS(2357),
    [anon_sym_AMP] = ACTIONS(2359),
    [anon_sym_SEMI] = ACTIONS(3834),
    [anon_sym___extension__] = ACTIONS(2359),
    [anon_sym_typedef] = ACTIONS(2359),
    [anon_sym_in] = ACTIONS(2359),
    [anon_sym_out] = ACTIONS(2359),
    [anon_sym_inout] = ACTIONS(2359),
    [anon_sym_extern] = ACTIONS(2359),
    [anon_sym___attribute__] = ACTIONS(5418),
    [anon_sym_COLON_COLON] = ACTIONS(2357),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2357),
    [anon_sym___declspec] = ACTIONS(2359),
    [anon_sym___based] = ACTIONS(2359),
    [anon_sym_RBRACE] = ACTIONS(2357),
    [anon_sym_signed] = ACTIONS(2359),
    [anon_sym_unsigned] = ACTIONS(2359),
    [anon_sym_long] = ACTIONS(2359),
    [anon_sym_short] = ACTIONS(2359),
    [anon_sym_LBRACK] = ACTIONS(2359),
    [anon_sym_static] = ACTIONS(2359),
    [anon_sym_register] = ACTIONS(2359),
    [anon_sym_inline] = ACTIONS(2359),
    [anon_sym___inline] = ACTIONS(2359),
    [anon_sym___inline__] = ACTIONS(2359),
    [anon_sym___forceinline] = ACTIONS(2359),
    [anon_sym_thread_local] = ACTIONS(2359),
    [anon_sym___thread] = ACTIONS(2359),
    [anon_sym_const] = ACTIONS(2359),
    [anon_sym_constexpr] = ACTIONS(2359),
    [anon_sym_volatile] = ACTIONS(2359),
    [anon_sym_restrict] = ACTIONS(2359),
    [anon_sym___restrict__] = ACTIONS(2359),
    [anon_sym__Atomic] = ACTIONS(2359),
    [anon_sym__Noreturn] = ACTIONS(2359),
    [anon_sym_noreturn] = ACTIONS(2359),
    [anon_sym_mutable] = ACTIONS(2359),
    [anon_sym_constinit] = ACTIONS(2359),
    [anon_sym_consteval] = ACTIONS(2359),
    [anon_sym_alignas] = ACTIONS(2359),
    [anon_sym__Alignas] = ACTIONS(2359),
    [sym_primitive_type] = ACTIONS(2359),
    [anon_sym_enum] = ACTIONS(2359),
    [anon_sym_class] = ACTIONS(2359),
    [anon_sym_struct] = ACTIONS(2359),
    [anon_sym_union] = ACTIONS(2359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2359),
    [anon_sym_let] = ACTIONS(2359),
    [anon_sym_This] = ACTIONS(2359),
    [anon_sym_decltype] = ACTIONS(2359),
    [sym_virtual] = ACTIONS(2359),
    [anon_sym_explicit] = ACTIONS(2359),
    [anon_sym_typename] = ACTIONS(2359),
    [anon_sym_template] = ACTIONS(2359),
    [anon_sym_operator] = ACTIONS(2359),
    [anon_sym_friend] = ACTIONS(2359),
    [anon_sym_public] = ACTIONS(2359),
    [anon_sym_private] = ACTIONS(2359),
    [anon_sym_protected] = ACTIONS(2359),
    [anon_sym_using] = ACTIONS(2359),
    [anon_sym_static_assert] = ACTIONS(2359),
    [anon_sym_precise] = ACTIONS(2359),
    [anon_sym_shared] = ACTIONS(2359),
    [anon_sym_groupshared] = ACTIONS(2359),
    [anon_sym_uniform] = ACTIONS(2359),
    [anon_sym_row_major] = ACTIONS(2359),
    [anon_sym_column_major] = ACTIONS(2359),
    [anon_sym_globallycoherent] = ACTIONS(2359),
    [anon_sym_centroid] = ACTIONS(2359),
    [anon_sym_noperspective] = ACTIONS(2359),
    [anon_sym_nointerpolation] = ACTIONS(2359),
    [anon_sym_sample] = ACTIONS(2359),
    [anon_sym_linear] = ACTIONS(2359),
    [anon_sym_snorm] = ACTIONS(2359),
    [anon_sym_unorm] = ACTIONS(2359),
    [anon_sym_point] = ACTIONS(2359),
    [anon_sym_line] = ACTIONS(2359),
    [anon_sym_triangleadj] = ACTIONS(2359),
    [anon_sym_lineadj] = ACTIONS(2359),
    [anon_sym_triangle] = ACTIONS(2359),
    [anon_sym_interface] = ACTIONS(2359),
    [anon_sym_extension] = ACTIONS(2359),
    [anon_sym___init] = ACTIONS(2359),
    [anon_sym___subscript] = ACTIONS(2359),
    [anon_sym_property] = ACTIONS(2359),
    [anon_sym_associatedtype] = ACTIONS(2359),
  },
  [1784] = {
    [sym_expression] = STATE(5401),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10786),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON] = ACTIONS(5821),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1785] = {
    [sym_expression] = STATE(5196),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(9278),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5823),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1786] = {
    [sym_expression] = STATE(5355),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10587),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON] = ACTIONS(5826),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1787] = {
    [sym_expression] = STATE(4201),
    [sym__string] = STATE(4545),
    [sym_conditional_expression] = STATE(4545),
    [sym_assignment_expression] = STATE(4545),
    [sym_pointer_expression] = STATE(4540),
    [sym_unary_expression] = STATE(4545),
    [sym_binary_expression] = STATE(4545),
    [sym_update_expression] = STATE(4545),
    [sym_cast_expression] = STATE(4545),
    [sym_sizeof_expression] = STATE(4545),
    [sym_alignof_expression] = STATE(4545),
    [sym_offsetof_expression] = STATE(4545),
    [sym_generic_expression] = STATE(4545),
    [sym_subscript_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_gnu_asm_expression] = STATE(4545),
    [sym_field_expression] = STATE(4540),
    [sym_compound_literal_expression] = STATE(4545),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_initializer_list] = STATE(4492),
    [sym_char_literal] = STATE(4286),
    [sym_concatenated_string] = STATE(4290),
    [sym_string_literal] = STATE(3166),
    [sym_null] = STATE(4545),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9673),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4545),
    [sym_raw_string_literal] = STATE(3169),
    [sym_co_await_expression] = STATE(4545),
    [sym_new_expression] = STATE(4545),
    [sym_delete_expression] = STATE(4545),
    [sym_requires_clause] = STATE(4545),
    [sym_requires_expression] = STATE(4545),
    [sym_lambda_expression] = STATE(4545),
    [sym_lambda_capture_specifier] = STATE(7034),
    [sym_fold_expression] = STATE(4545),
    [sym_parameter_pack_expansion] = STATE(4545),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4540),
    [sym_qualified_type_identifier] = STATE(9673),
    [sym_user_defined_literal] = STATE(4540),
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_LPAREN2] = ACTIONS(5828),
    [anon_sym_BANG] = ACTIONS(4733),
    [anon_sym_TILDE] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4731),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4735),
    [anon_sym_LBRACE] = ACTIONS(4737),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4739),
    [anon_sym_not] = ACTIONS(4731),
    [anon_sym_compl] = ACTIONS(4731),
    [anon_sym_DASH_DASH] = ACTIONS(5711),
    [anon_sym_PLUS_PLUS] = ACTIONS(5711),
    [anon_sym_sizeof] = ACTIONS(4741),
    [anon_sym___alignof__] = ACTIONS(4743),
    [anon_sym___alignof] = ACTIONS(4743),
    [anon_sym__alignof] = ACTIONS(4743),
    [anon_sym_alignof] = ACTIONS(4743),
    [anon_sym__Alignof] = ACTIONS(4743),
    [anon_sym_offsetof] = ACTIONS(4745),
    [anon_sym__Generic] = ACTIONS(4747),
    [anon_sym_asm] = ACTIONS(4749),
    [anon_sym___asm__] = ACTIONS(4749),
    [sym_number_literal] = ACTIONS(4751),
    [anon_sym_L_SQUOTE] = ACTIONS(4753),
    [anon_sym_u_SQUOTE] = ACTIONS(4753),
    [anon_sym_U_SQUOTE] = ACTIONS(4753),
    [anon_sym_u8_SQUOTE] = ACTIONS(4753),
    [anon_sym_SQUOTE] = ACTIONS(4753),
    [anon_sym_L_DQUOTE] = ACTIONS(4755),
    [anon_sym_u_DQUOTE] = ACTIONS(4755),
    [anon_sym_U_DQUOTE] = ACTIONS(4755),
    [anon_sym_u8_DQUOTE] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [anon_sym_NULL] = ACTIONS(4759),
    [anon_sym_nullptr] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4761),
    [anon_sym_R_DQUOTE] = ACTIONS(4763),
    [anon_sym_LR_DQUOTE] = ACTIONS(4763),
    [anon_sym_uR_DQUOTE] = ACTIONS(4763),
    [anon_sym_UR_DQUOTE] = ACTIONS(4763),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4763),
    [anon_sym_co_await] = ACTIONS(4765),
    [anon_sym_new] = ACTIONS(4767),
    [anon_sym_requires] = ACTIONS(4769),
    [sym_this] = ACTIONS(4757),
  },
  [1788] = {
    [sym_expression] = STATE(5372),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10643),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON] = ACTIONS(5830),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1789] = {
    [sym_expression] = STATE(5024),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10249),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1790] = {
    [sym_expression] = STATE(5404),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10261),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON] = ACTIONS(5832),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1791] = {
    [sym_expression] = STATE(4615),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_initializer_list] = STATE(4714),
    [sym_char_literal] = STATE(4905),
    [sym_concatenated_string] = STATE(4902),
    [sym_string_literal] = STATE(3611),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3610),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(5705),
    [anon_sym_LPAREN2] = ACTIONS(5834),
    [anon_sym_BANG] = ACTIONS(4926),
    [anon_sym_TILDE] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4928),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4924),
    [anon_sym_compl] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(5707),
    [anon_sym_PLUS_PLUS] = ACTIONS(5707),
    [anon_sym_sizeof] = ACTIONS(4932),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4934),
    [anon_sym_L_SQUOTE] = ACTIONS(4936),
    [anon_sym_u_SQUOTE] = ACTIONS(4936),
    [anon_sym_U_SQUOTE] = ACTIONS(4936),
    [anon_sym_u8_SQUOTE] = ACTIONS(4936),
    [anon_sym_SQUOTE] = ACTIONS(4936),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4938),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_co_await] = ACTIONS(4940),
    [anon_sym_new] = ACTIONS(4942),
    [anon_sym_requires] = ACTIONS(4944),
    [sym_this] = ACTIONS(241),
  },
  [1792] = {
    [sym_expression] = STATE(5392),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_initializer_list] = STATE(5663),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACE] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [1793] = {
    [sym_expression] = STATE(5397),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10759),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON] = ACTIONS(5836),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1794] = {
    [sym_expression] = STATE(5454),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(9902),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1795] = {
    [sym_expression] = STATE(5438),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(9684),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1796] = {
    [sym_expression] = STATE(5447),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10376),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_RPAREN] = ACTIONS(5838),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1797] = {
    [sym_expression] = STATE(4615),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(4714),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1798] = {
    [sym_expression] = STATE(5528),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(10392),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1799] = {
    [sym_expression] = STATE(5460),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10522),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(3897),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1800] = {
    [sym_expression] = STATE(5416),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(10248),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_RPAREN] = ACTIONS(5840),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1801] = {
    [sym_identifier] = ACTIONS(2359),
    [aux_sym_preproc_def_token1] = ACTIONS(2359),
    [anon_sym_COMMA] = ACTIONS(3834),
    [aux_sym_preproc_if_token1] = ACTIONS(2359),
    [aux_sym_preproc_if_token2] = ACTIONS(2359),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2359),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2359),
    [sym_preproc_directive] = ACTIONS(2359),
    [anon_sym_LPAREN2] = ACTIONS(2357),
    [anon_sym_TILDE] = ACTIONS(2357),
    [anon_sym_STAR] = ACTIONS(2357),
    [anon_sym_AMP_AMP] = ACTIONS(2357),
    [anon_sym_AMP] = ACTIONS(2359),
    [anon_sym_SEMI] = ACTIONS(3834),
    [anon_sym___extension__] = ACTIONS(2359),
    [anon_sym_typedef] = ACTIONS(2359),
    [anon_sym_in] = ACTIONS(2359),
    [anon_sym_out] = ACTIONS(2359),
    [anon_sym_inout] = ACTIONS(2359),
    [anon_sym_extern] = ACTIONS(2359),
    [anon_sym___attribute__] = ACTIONS(5418),
    [anon_sym_COLON_COLON] = ACTIONS(2357),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2357),
    [anon_sym___declspec] = ACTIONS(2359),
    [anon_sym___based] = ACTIONS(2359),
    [anon_sym_signed] = ACTIONS(2359),
    [anon_sym_unsigned] = ACTIONS(2359),
    [anon_sym_long] = ACTIONS(2359),
    [anon_sym_short] = ACTIONS(2359),
    [anon_sym_LBRACK] = ACTIONS(2359),
    [anon_sym_static] = ACTIONS(2359),
    [anon_sym_register] = ACTIONS(2359),
    [anon_sym_inline] = ACTIONS(2359),
    [anon_sym___inline] = ACTIONS(2359),
    [anon_sym___inline__] = ACTIONS(2359),
    [anon_sym___forceinline] = ACTIONS(2359),
    [anon_sym_thread_local] = ACTIONS(2359),
    [anon_sym___thread] = ACTIONS(2359),
    [anon_sym_const] = ACTIONS(2359),
    [anon_sym_constexpr] = ACTIONS(2359),
    [anon_sym_volatile] = ACTIONS(2359),
    [anon_sym_restrict] = ACTIONS(2359),
    [anon_sym___restrict__] = ACTIONS(2359),
    [anon_sym__Atomic] = ACTIONS(2359),
    [anon_sym__Noreturn] = ACTIONS(2359),
    [anon_sym_noreturn] = ACTIONS(2359),
    [anon_sym_mutable] = ACTIONS(2359),
    [anon_sym_constinit] = ACTIONS(2359),
    [anon_sym_consteval] = ACTIONS(2359),
    [anon_sym_alignas] = ACTIONS(2359),
    [anon_sym__Alignas] = ACTIONS(2359),
    [sym_primitive_type] = ACTIONS(2359),
    [anon_sym_enum] = ACTIONS(2359),
    [anon_sym_class] = ACTIONS(2359),
    [anon_sym_struct] = ACTIONS(2359),
    [anon_sym_union] = ACTIONS(2359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2359),
    [anon_sym_let] = ACTIONS(2359),
    [anon_sym_This] = ACTIONS(2359),
    [anon_sym_decltype] = ACTIONS(2359),
    [sym_virtual] = ACTIONS(2359),
    [anon_sym_explicit] = ACTIONS(2359),
    [anon_sym_typename] = ACTIONS(2359),
    [anon_sym_template] = ACTIONS(2359),
    [anon_sym_operator] = ACTIONS(2359),
    [anon_sym_friend] = ACTIONS(2359),
    [anon_sym_public] = ACTIONS(2359),
    [anon_sym_private] = ACTIONS(2359),
    [anon_sym_protected] = ACTIONS(2359),
    [anon_sym_using] = ACTIONS(2359),
    [anon_sym_static_assert] = ACTIONS(2359),
    [anon_sym_precise] = ACTIONS(2359),
    [anon_sym_shared] = ACTIONS(2359),
    [anon_sym_groupshared] = ACTIONS(2359),
    [anon_sym_uniform] = ACTIONS(2359),
    [anon_sym_row_major] = ACTIONS(2359),
    [anon_sym_column_major] = ACTIONS(2359),
    [anon_sym_globallycoherent] = ACTIONS(2359),
    [anon_sym_centroid] = ACTIONS(2359),
    [anon_sym_noperspective] = ACTIONS(2359),
    [anon_sym_nointerpolation] = ACTIONS(2359),
    [anon_sym_sample] = ACTIONS(2359),
    [anon_sym_linear] = ACTIONS(2359),
    [anon_sym_snorm] = ACTIONS(2359),
    [anon_sym_unorm] = ACTIONS(2359),
    [anon_sym_point] = ACTIONS(2359),
    [anon_sym_line] = ACTIONS(2359),
    [anon_sym_triangleadj] = ACTIONS(2359),
    [anon_sym_lineadj] = ACTIONS(2359),
    [anon_sym_triangle] = ACTIONS(2359),
    [anon_sym_interface] = ACTIONS(2359),
    [anon_sym_extension] = ACTIONS(2359),
    [anon_sym___init] = ACTIONS(2359),
    [anon_sym___subscript] = ACTIONS(2359),
    [anon_sym_property] = ACTIONS(2359),
    [anon_sym_associatedtype] = ACTIONS(2359),
  },
  [1802] = {
    [sym_expression] = STATE(5160),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_initializer_list] = STATE(4725),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4958),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4964),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1803] = {
    [sym_expression] = STATE(4876),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_initializer_list] = STATE(4725),
    [sym_char_literal] = STATE(4905),
    [sym_concatenated_string] = STATE(4902),
    [sym_string_literal] = STATE(3611),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3610),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(5705),
    [anon_sym_LPAREN2] = ACTIONS(5834),
    [anon_sym_BANG] = ACTIONS(4926),
    [anon_sym_TILDE] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4928),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4924),
    [anon_sym_compl] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(5707),
    [anon_sym_PLUS_PLUS] = ACTIONS(5707),
    [anon_sym_sizeof] = ACTIONS(4932),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4934),
    [anon_sym_L_SQUOTE] = ACTIONS(4936),
    [anon_sym_u_SQUOTE] = ACTIONS(4936),
    [anon_sym_U_SQUOTE] = ACTIONS(4936),
    [anon_sym_u8_SQUOTE] = ACTIONS(4936),
    [anon_sym_SQUOTE] = ACTIONS(4936),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4938),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_co_await] = ACTIONS(4940),
    [anon_sym_new] = ACTIONS(4942),
    [anon_sym_requires] = ACTIONS(4944),
    [sym_this] = ACTIONS(241),
  },
  [1804] = {
    [sym_expression] = STATE(5095),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_initializer_list] = STATE(4725),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1805] = {
    [sym_expression] = STATE(3215),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5842),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1806] = {
    [sym_identifier] = ACTIONS(2359),
    [aux_sym_preproc_def_token1] = ACTIONS(2359),
    [aux_sym_preproc_if_token1] = ACTIONS(2359),
    [aux_sym_preproc_if_token2] = ACTIONS(2359),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2359),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2359),
    [sym_preproc_directive] = ACTIONS(2359),
    [anon_sym_LPAREN2] = ACTIONS(2357),
    [anon_sym_TILDE] = ACTIONS(2357),
    [anon_sym_STAR] = ACTIONS(2357),
    [anon_sym_AMP_AMP] = ACTIONS(2357),
    [anon_sym_AMP] = ACTIONS(2359),
    [anon_sym___extension__] = ACTIONS(2359),
    [anon_sym_typedef] = ACTIONS(2359),
    [anon_sym_in] = ACTIONS(2359),
    [anon_sym_out] = ACTIONS(2359),
    [anon_sym_inout] = ACTIONS(2359),
    [anon_sym_extern] = ACTIONS(2359),
    [anon_sym___attribute__] = ACTIONS(2359),
    [anon_sym_COLON_COLON] = ACTIONS(2357),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2357),
    [anon_sym___declspec] = ACTIONS(2359),
    [anon_sym___based] = ACTIONS(2359),
    [anon_sym_signed] = ACTIONS(2359),
    [anon_sym_unsigned] = ACTIONS(2359),
    [anon_sym_long] = ACTIONS(2359),
    [anon_sym_short] = ACTIONS(2359),
    [anon_sym_LBRACK] = ACTIONS(2359),
    [anon_sym_static] = ACTIONS(2359),
    [anon_sym_register] = ACTIONS(2359),
    [anon_sym_inline] = ACTIONS(2359),
    [anon_sym___inline] = ACTIONS(2359),
    [anon_sym___inline__] = ACTIONS(2359),
    [anon_sym___forceinline] = ACTIONS(2359),
    [anon_sym_thread_local] = ACTIONS(2359),
    [anon_sym___thread] = ACTIONS(2359),
    [anon_sym_const] = ACTIONS(2359),
    [anon_sym_constexpr] = ACTIONS(2359),
    [anon_sym_volatile] = ACTIONS(2359),
    [anon_sym_restrict] = ACTIONS(2359),
    [anon_sym___restrict__] = ACTIONS(2359),
    [anon_sym__Atomic] = ACTIONS(2359),
    [anon_sym__Noreturn] = ACTIONS(2359),
    [anon_sym_noreturn] = ACTIONS(2359),
    [anon_sym_mutable] = ACTIONS(2359),
    [anon_sym_constinit] = ACTIONS(2359),
    [anon_sym_consteval] = ACTIONS(2359),
    [anon_sym_alignas] = ACTIONS(2359),
    [anon_sym__Alignas] = ACTIONS(2359),
    [sym_primitive_type] = ACTIONS(2359),
    [anon_sym_enum] = ACTIONS(2359),
    [anon_sym_class] = ACTIONS(2359),
    [anon_sym_struct] = ACTIONS(2359),
    [anon_sym_union] = ACTIONS(2359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2359),
    [anon_sym_let] = ACTIONS(2359),
    [anon_sym_This] = ACTIONS(2359),
    [anon_sym_decltype] = ACTIONS(2359),
    [sym_virtual] = ACTIONS(2359),
    [anon_sym_explicit] = ACTIONS(2359),
    [anon_sym_typename] = ACTIONS(2359),
    [anon_sym_template] = ACTIONS(2359),
    [anon_sym_operator] = ACTIONS(2359),
    [anon_sym_friend] = ACTIONS(2359),
    [anon_sym_public] = ACTIONS(2359),
    [anon_sym_private] = ACTIONS(2359),
    [anon_sym_protected] = ACTIONS(2359),
    [anon_sym_using] = ACTIONS(2359),
    [anon_sym_static_assert] = ACTIONS(2359),
    [anon_sym_catch] = ACTIONS(2359),
    [anon_sym_precise] = ACTIONS(2359),
    [anon_sym_shared] = ACTIONS(2359),
    [anon_sym_groupshared] = ACTIONS(2359),
    [anon_sym_uniform] = ACTIONS(2359),
    [anon_sym_row_major] = ACTIONS(2359),
    [anon_sym_column_major] = ACTIONS(2359),
    [anon_sym_globallycoherent] = ACTIONS(2359),
    [anon_sym_centroid] = ACTIONS(2359),
    [anon_sym_noperspective] = ACTIONS(2359),
    [anon_sym_nointerpolation] = ACTIONS(2359),
    [anon_sym_sample] = ACTIONS(2359),
    [anon_sym_linear] = ACTIONS(2359),
    [anon_sym_snorm] = ACTIONS(2359),
    [anon_sym_unorm] = ACTIONS(2359),
    [anon_sym_point] = ACTIONS(2359),
    [anon_sym_line] = ACTIONS(2359),
    [anon_sym_triangleadj] = ACTIONS(2359),
    [anon_sym_lineadj] = ACTIONS(2359),
    [anon_sym_triangle] = ACTIONS(2359),
    [anon_sym_interface] = ACTIONS(2359),
    [anon_sym_extension] = ACTIONS(2359),
    [anon_sym___init] = ACTIONS(2359),
    [anon_sym___subscript] = ACTIONS(2359),
    [anon_sym_property] = ACTIONS(2359),
    [anon_sym_associatedtype] = ACTIONS(2359),
  },
  [1807] = {
    [sym_expression] = STATE(3745),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5844),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1808] = {
    [sym_expression] = STATE(5558),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5847),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1809] = {
    [sym_identifier] = ACTIONS(2359),
    [aux_sym_preproc_def_token1] = ACTIONS(2359),
    [aux_sym_preproc_if_token1] = ACTIONS(2359),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2359),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2359),
    [sym_preproc_directive] = ACTIONS(2359),
    [anon_sym_LPAREN2] = ACTIONS(2357),
    [anon_sym_TILDE] = ACTIONS(2357),
    [anon_sym_STAR] = ACTIONS(2357),
    [anon_sym_AMP_AMP] = ACTIONS(2357),
    [anon_sym_AMP] = ACTIONS(2359),
    [anon_sym___extension__] = ACTIONS(2359),
    [anon_sym_typedef] = ACTIONS(2359),
    [anon_sym_in] = ACTIONS(2359),
    [anon_sym_out] = ACTIONS(2359),
    [anon_sym_inout] = ACTIONS(2359),
    [anon_sym_extern] = ACTIONS(2359),
    [anon_sym___attribute__] = ACTIONS(2359),
    [anon_sym_COLON_COLON] = ACTIONS(2357),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2357),
    [anon_sym___declspec] = ACTIONS(2359),
    [anon_sym___based] = ACTIONS(2359),
    [anon_sym_RBRACE] = ACTIONS(2357),
    [anon_sym_signed] = ACTIONS(2359),
    [anon_sym_unsigned] = ACTIONS(2359),
    [anon_sym_long] = ACTIONS(2359),
    [anon_sym_short] = ACTIONS(2359),
    [anon_sym_LBRACK] = ACTIONS(2359),
    [anon_sym_static] = ACTIONS(2359),
    [anon_sym_register] = ACTIONS(2359),
    [anon_sym_inline] = ACTIONS(2359),
    [anon_sym___inline] = ACTIONS(2359),
    [anon_sym___inline__] = ACTIONS(2359),
    [anon_sym___forceinline] = ACTIONS(2359),
    [anon_sym_thread_local] = ACTIONS(2359),
    [anon_sym___thread] = ACTIONS(2359),
    [anon_sym_const] = ACTIONS(2359),
    [anon_sym_constexpr] = ACTIONS(2359),
    [anon_sym_volatile] = ACTIONS(2359),
    [anon_sym_restrict] = ACTIONS(2359),
    [anon_sym___restrict__] = ACTIONS(2359),
    [anon_sym__Atomic] = ACTIONS(2359),
    [anon_sym__Noreturn] = ACTIONS(2359),
    [anon_sym_noreturn] = ACTIONS(2359),
    [anon_sym_mutable] = ACTIONS(2359),
    [anon_sym_constinit] = ACTIONS(2359),
    [anon_sym_consteval] = ACTIONS(2359),
    [anon_sym_alignas] = ACTIONS(2359),
    [anon_sym__Alignas] = ACTIONS(2359),
    [sym_primitive_type] = ACTIONS(2359),
    [anon_sym_enum] = ACTIONS(2359),
    [anon_sym_class] = ACTIONS(2359),
    [anon_sym_struct] = ACTIONS(2359),
    [anon_sym_union] = ACTIONS(2359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2359),
    [anon_sym_let] = ACTIONS(2359),
    [anon_sym_This] = ACTIONS(2359),
    [anon_sym_decltype] = ACTIONS(2359),
    [sym_virtual] = ACTIONS(2359),
    [anon_sym_explicit] = ACTIONS(2359),
    [anon_sym_typename] = ACTIONS(2359),
    [anon_sym_template] = ACTIONS(2359),
    [anon_sym_operator] = ACTIONS(2359),
    [anon_sym_friend] = ACTIONS(2359),
    [anon_sym_public] = ACTIONS(2359),
    [anon_sym_private] = ACTIONS(2359),
    [anon_sym_protected] = ACTIONS(2359),
    [anon_sym_using] = ACTIONS(2359),
    [anon_sym_static_assert] = ACTIONS(2359),
    [anon_sym_catch] = ACTIONS(2359),
    [anon_sym_precise] = ACTIONS(2359),
    [anon_sym_shared] = ACTIONS(2359),
    [anon_sym_groupshared] = ACTIONS(2359),
    [anon_sym_uniform] = ACTIONS(2359),
    [anon_sym_row_major] = ACTIONS(2359),
    [anon_sym_column_major] = ACTIONS(2359),
    [anon_sym_globallycoherent] = ACTIONS(2359),
    [anon_sym_centroid] = ACTIONS(2359),
    [anon_sym_noperspective] = ACTIONS(2359),
    [anon_sym_nointerpolation] = ACTIONS(2359),
    [anon_sym_sample] = ACTIONS(2359),
    [anon_sym_linear] = ACTIONS(2359),
    [anon_sym_snorm] = ACTIONS(2359),
    [anon_sym_unorm] = ACTIONS(2359),
    [anon_sym_point] = ACTIONS(2359),
    [anon_sym_line] = ACTIONS(2359),
    [anon_sym_triangleadj] = ACTIONS(2359),
    [anon_sym_lineadj] = ACTIONS(2359),
    [anon_sym_triangle] = ACTIONS(2359),
    [anon_sym_interface] = ACTIONS(2359),
    [anon_sym_extension] = ACTIONS(2359),
    [anon_sym___init] = ACTIONS(2359),
    [anon_sym___subscript] = ACTIONS(2359),
    [anon_sym_property] = ACTIONS(2359),
    [anon_sym_associatedtype] = ACTIONS(2359),
  },
  [1810] = {
    [sym_expression] = STATE(3747),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5849),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1811] = {
    [sym_expression] = STATE(3790),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_LPAREN2] = ACTIONS(5854),
    [anon_sym_BANG] = ACTIONS(4611),
    [anon_sym_TILDE] = ACTIONS(4611),
    [anon_sym_DASH] = ACTIONS(4609),
    [anon_sym_PLUS] = ACTIONS(4609),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4613),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4609),
    [anon_sym_compl] = ACTIONS(4609),
    [anon_sym_DASH_DASH] = ACTIONS(5713),
    [anon_sym_PLUS_PLUS] = ACTIONS(5713),
    [anon_sym_sizeof] = ACTIONS(4615),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4617),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4619),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1812] = {
    [sym_expression] = STATE(5491),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1813] = {
    [sym_identifier] = ACTIONS(2355),
    [aux_sym_preproc_def_token1] = ACTIONS(2355),
    [aux_sym_preproc_if_token1] = ACTIONS(2355),
    [aux_sym_preproc_if_token2] = ACTIONS(2355),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2355),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2355),
    [sym_preproc_directive] = ACTIONS(2355),
    [anon_sym_LPAREN2] = ACTIONS(2353),
    [anon_sym_TILDE] = ACTIONS(2353),
    [anon_sym_STAR] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(2353),
    [anon_sym_AMP] = ACTIONS(2355),
    [anon_sym___extension__] = ACTIONS(2355),
    [anon_sym_typedef] = ACTIONS(2355),
    [anon_sym_in] = ACTIONS(2355),
    [anon_sym_out] = ACTIONS(2355),
    [anon_sym_inout] = ACTIONS(2355),
    [anon_sym_extern] = ACTIONS(2355),
    [anon_sym___attribute__] = ACTIONS(2355),
    [anon_sym_COLON_COLON] = ACTIONS(2353),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2353),
    [anon_sym___declspec] = ACTIONS(2355),
    [anon_sym___based] = ACTIONS(2355),
    [anon_sym_signed] = ACTIONS(2355),
    [anon_sym_unsigned] = ACTIONS(2355),
    [anon_sym_long] = ACTIONS(2355),
    [anon_sym_short] = ACTIONS(2355),
    [anon_sym_LBRACK] = ACTIONS(2355),
    [anon_sym_static] = ACTIONS(2355),
    [anon_sym_register] = ACTIONS(2355),
    [anon_sym_inline] = ACTIONS(2355),
    [anon_sym___inline] = ACTIONS(2355),
    [anon_sym___inline__] = ACTIONS(2355),
    [anon_sym___forceinline] = ACTIONS(2355),
    [anon_sym_thread_local] = ACTIONS(2355),
    [anon_sym___thread] = ACTIONS(2355),
    [anon_sym_const] = ACTIONS(2355),
    [anon_sym_constexpr] = ACTIONS(2355),
    [anon_sym_volatile] = ACTIONS(2355),
    [anon_sym_restrict] = ACTIONS(2355),
    [anon_sym___restrict__] = ACTIONS(2355),
    [anon_sym__Atomic] = ACTIONS(2355),
    [anon_sym__Noreturn] = ACTIONS(2355),
    [anon_sym_noreturn] = ACTIONS(2355),
    [anon_sym_mutable] = ACTIONS(2355),
    [anon_sym_constinit] = ACTIONS(2355),
    [anon_sym_consteval] = ACTIONS(2355),
    [anon_sym_alignas] = ACTIONS(2355),
    [anon_sym__Alignas] = ACTIONS(2355),
    [sym_primitive_type] = ACTIONS(2355),
    [anon_sym_enum] = ACTIONS(2355),
    [anon_sym_class] = ACTIONS(2355),
    [anon_sym_struct] = ACTIONS(2355),
    [anon_sym_union] = ACTIONS(2355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2355),
    [anon_sym_let] = ACTIONS(2355),
    [anon_sym_This] = ACTIONS(2355),
    [anon_sym_decltype] = ACTIONS(2355),
    [sym_virtual] = ACTIONS(2355),
    [anon_sym_explicit] = ACTIONS(2355),
    [anon_sym_typename] = ACTIONS(2355),
    [anon_sym_template] = ACTIONS(2355),
    [anon_sym_operator] = ACTIONS(2355),
    [anon_sym_friend] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2355),
    [anon_sym_private] = ACTIONS(2355),
    [anon_sym_protected] = ACTIONS(2355),
    [anon_sym_using] = ACTIONS(2355),
    [anon_sym_static_assert] = ACTIONS(2355),
    [anon_sym_catch] = ACTIONS(2355),
    [anon_sym_precise] = ACTIONS(2355),
    [anon_sym_shared] = ACTIONS(2355),
    [anon_sym_groupshared] = ACTIONS(2355),
    [anon_sym_uniform] = ACTIONS(2355),
    [anon_sym_row_major] = ACTIONS(2355),
    [anon_sym_column_major] = ACTIONS(2355),
    [anon_sym_globallycoherent] = ACTIONS(2355),
    [anon_sym_centroid] = ACTIONS(2355),
    [anon_sym_noperspective] = ACTIONS(2355),
    [anon_sym_nointerpolation] = ACTIONS(2355),
    [anon_sym_sample] = ACTIONS(2355),
    [anon_sym_linear] = ACTIONS(2355),
    [anon_sym_snorm] = ACTIONS(2355),
    [anon_sym_unorm] = ACTIONS(2355),
    [anon_sym_point] = ACTIONS(2355),
    [anon_sym_line] = ACTIONS(2355),
    [anon_sym_triangleadj] = ACTIONS(2355),
    [anon_sym_lineadj] = ACTIONS(2355),
    [anon_sym_triangle] = ACTIONS(2355),
    [anon_sym_interface] = ACTIONS(2355),
    [anon_sym_extension] = ACTIONS(2355),
    [anon_sym___init] = ACTIONS(2355),
    [anon_sym___subscript] = ACTIONS(2355),
    [anon_sym_property] = ACTIONS(2355),
    [anon_sym_associatedtype] = ACTIONS(2355),
  },
  [1814] = {
    [sym_identifier] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_LPAREN2] = ACTIONS(5860),
    [anon_sym_TILDE] = ACTIONS(5860),
    [anon_sym_STAR] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym___extension__] = ACTIONS(5858),
    [anon_sym_in] = ACTIONS(5858),
    [anon_sym_out] = ACTIONS(5858),
    [anon_sym_inout] = ACTIONS(5858),
    [anon_sym_extern] = ACTIONS(5858),
    [anon_sym___attribute__] = ACTIONS(5858),
    [anon_sym_COLON_COLON] = ACTIONS(5860),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5860),
    [anon_sym___declspec] = ACTIONS(5858),
    [anon_sym___based] = ACTIONS(5858),
    [anon_sym___cdecl] = ACTIONS(5858),
    [anon_sym___clrcall] = ACTIONS(5858),
    [anon_sym___stdcall] = ACTIONS(5858),
    [anon_sym___fastcall] = ACTIONS(5858),
    [anon_sym___thiscall] = ACTIONS(5858),
    [anon_sym___vectorcall] = ACTIONS(5858),
    [anon_sym_signed] = ACTIONS(5858),
    [anon_sym_unsigned] = ACTIONS(5858),
    [anon_sym_long] = ACTIONS(5858),
    [anon_sym_short] = ACTIONS(5858),
    [anon_sym_LBRACK] = ACTIONS(5858),
    [anon_sym_static] = ACTIONS(5858),
    [anon_sym_register] = ACTIONS(5858),
    [anon_sym_inline] = ACTIONS(5858),
    [anon_sym___inline] = ACTIONS(5858),
    [anon_sym___inline__] = ACTIONS(5858),
    [anon_sym___forceinline] = ACTIONS(5858),
    [anon_sym_thread_local] = ACTIONS(5858),
    [anon_sym___thread] = ACTIONS(5858),
    [anon_sym_const] = ACTIONS(5858),
    [anon_sym_constexpr] = ACTIONS(5858),
    [anon_sym_volatile] = ACTIONS(5858),
    [anon_sym_restrict] = ACTIONS(5858),
    [anon_sym___restrict__] = ACTIONS(5858),
    [anon_sym__Atomic] = ACTIONS(5858),
    [anon_sym__Noreturn] = ACTIONS(5858),
    [anon_sym_noreturn] = ACTIONS(5858),
    [anon_sym_mutable] = ACTIONS(5858),
    [anon_sym_constinit] = ACTIONS(5858),
    [anon_sym_consteval] = ACTIONS(5858),
    [anon_sym_alignas] = ACTIONS(5858),
    [anon_sym__Alignas] = ACTIONS(5858),
    [sym_primitive_type] = ACTIONS(5858),
    [anon_sym_enum] = ACTIONS(5858),
    [anon_sym_class] = ACTIONS(5858),
    [anon_sym_struct] = ACTIONS(5858),
    [anon_sym_union] = ACTIONS(5858),
    [anon_sym_or] = ACTIONS(5858),
    [anon_sym_and] = ACTIONS(5858),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5858),
    [anon_sym_let] = ACTIONS(5858),
    [anon_sym_This] = ACTIONS(5858),
    [anon_sym_decltype] = ACTIONS(5858),
    [anon_sym_final] = ACTIONS(5858),
    [anon_sym_override] = ACTIONS(5858),
    [sym_virtual] = ACTIONS(5858),
    [anon_sym_explicit] = ACTIONS(5858),
    [anon_sym_typename] = ACTIONS(5858),
    [anon_sym_template] = ACTIONS(5858),
    [anon_sym_operator] = ACTIONS(5858),
    [anon_sym_friend] = ACTIONS(5858),
    [anon_sym_using] = ACTIONS(5858),
    [anon_sym_concept] = ACTIONS(5858),
    [anon_sym_requires] = ACTIONS(5858),
    [anon_sym_precise] = ACTIONS(5858),
    [anon_sym_shared] = ACTIONS(5858),
    [anon_sym_groupshared] = ACTIONS(5858),
    [anon_sym_uniform] = ACTIONS(5858),
    [anon_sym_row_major] = ACTIONS(5858),
    [anon_sym_column_major] = ACTIONS(5858),
    [anon_sym_globallycoherent] = ACTIONS(5858),
    [anon_sym_centroid] = ACTIONS(5858),
    [anon_sym_noperspective] = ACTIONS(5858),
    [anon_sym_nointerpolation] = ACTIONS(5858),
    [anon_sym_sample] = ACTIONS(5858),
    [anon_sym_linear] = ACTIONS(5858),
    [anon_sym_snorm] = ACTIONS(5858),
    [anon_sym_unorm] = ACTIONS(5858),
    [anon_sym_point] = ACTIONS(5858),
    [anon_sym_line] = ACTIONS(5858),
    [anon_sym_triangleadj] = ACTIONS(5858),
    [anon_sym_lineadj] = ACTIONS(5858),
    [anon_sym_triangle] = ACTIONS(5858),
    [anon_sym_interface] = ACTIONS(5858),
    [anon_sym_extension] = ACTIONS(5858),
    [anon_sym_where] = ACTIONS(5858),
  },
  [1815] = {
    [sym_expression] = STATE(3746),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5862),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1816] = {
    [sym_expression] = STATE(5419),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5865),
    [anon_sym_LPAREN2] = ACTIONS(5867),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [1817] = {
    [sym_expression] = STATE(5492),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5869),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1818] = {
    [sym_identifier] = ACTIONS(2355),
    [aux_sym_preproc_def_token1] = ACTIONS(2355),
    [aux_sym_preproc_if_token1] = ACTIONS(2355),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2355),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2355),
    [sym_preproc_directive] = ACTIONS(2355),
    [anon_sym_LPAREN2] = ACTIONS(2353),
    [anon_sym_TILDE] = ACTIONS(2353),
    [anon_sym_STAR] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(2353),
    [anon_sym_AMP] = ACTIONS(2355),
    [anon_sym___extension__] = ACTIONS(2355),
    [anon_sym_typedef] = ACTIONS(2355),
    [anon_sym_in] = ACTIONS(2355),
    [anon_sym_out] = ACTIONS(2355),
    [anon_sym_inout] = ACTIONS(2355),
    [anon_sym_extern] = ACTIONS(2355),
    [anon_sym___attribute__] = ACTIONS(2355),
    [anon_sym_COLON_COLON] = ACTIONS(2353),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2353),
    [anon_sym___declspec] = ACTIONS(2355),
    [anon_sym___based] = ACTIONS(2355),
    [anon_sym_RBRACE] = ACTIONS(2353),
    [anon_sym_signed] = ACTIONS(2355),
    [anon_sym_unsigned] = ACTIONS(2355),
    [anon_sym_long] = ACTIONS(2355),
    [anon_sym_short] = ACTIONS(2355),
    [anon_sym_LBRACK] = ACTIONS(2355),
    [anon_sym_static] = ACTIONS(2355),
    [anon_sym_register] = ACTIONS(2355),
    [anon_sym_inline] = ACTIONS(2355),
    [anon_sym___inline] = ACTIONS(2355),
    [anon_sym___inline__] = ACTIONS(2355),
    [anon_sym___forceinline] = ACTIONS(2355),
    [anon_sym_thread_local] = ACTIONS(2355),
    [anon_sym___thread] = ACTIONS(2355),
    [anon_sym_const] = ACTIONS(2355),
    [anon_sym_constexpr] = ACTIONS(2355),
    [anon_sym_volatile] = ACTIONS(2355),
    [anon_sym_restrict] = ACTIONS(2355),
    [anon_sym___restrict__] = ACTIONS(2355),
    [anon_sym__Atomic] = ACTIONS(2355),
    [anon_sym__Noreturn] = ACTIONS(2355),
    [anon_sym_noreturn] = ACTIONS(2355),
    [anon_sym_mutable] = ACTIONS(2355),
    [anon_sym_constinit] = ACTIONS(2355),
    [anon_sym_consteval] = ACTIONS(2355),
    [anon_sym_alignas] = ACTIONS(2355),
    [anon_sym__Alignas] = ACTIONS(2355),
    [sym_primitive_type] = ACTIONS(2355),
    [anon_sym_enum] = ACTIONS(2355),
    [anon_sym_class] = ACTIONS(2355),
    [anon_sym_struct] = ACTIONS(2355),
    [anon_sym_union] = ACTIONS(2355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2355),
    [anon_sym_let] = ACTIONS(2355),
    [anon_sym_This] = ACTIONS(2355),
    [anon_sym_decltype] = ACTIONS(2355),
    [sym_virtual] = ACTIONS(2355),
    [anon_sym_explicit] = ACTIONS(2355),
    [anon_sym_typename] = ACTIONS(2355),
    [anon_sym_template] = ACTIONS(2355),
    [anon_sym_operator] = ACTIONS(2355),
    [anon_sym_friend] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2355),
    [anon_sym_private] = ACTIONS(2355),
    [anon_sym_protected] = ACTIONS(2355),
    [anon_sym_using] = ACTIONS(2355),
    [anon_sym_static_assert] = ACTIONS(2355),
    [anon_sym_catch] = ACTIONS(2355),
    [anon_sym_precise] = ACTIONS(2355),
    [anon_sym_shared] = ACTIONS(2355),
    [anon_sym_groupshared] = ACTIONS(2355),
    [anon_sym_uniform] = ACTIONS(2355),
    [anon_sym_row_major] = ACTIONS(2355),
    [anon_sym_column_major] = ACTIONS(2355),
    [anon_sym_globallycoherent] = ACTIONS(2355),
    [anon_sym_centroid] = ACTIONS(2355),
    [anon_sym_noperspective] = ACTIONS(2355),
    [anon_sym_nointerpolation] = ACTIONS(2355),
    [anon_sym_sample] = ACTIONS(2355),
    [anon_sym_linear] = ACTIONS(2355),
    [anon_sym_snorm] = ACTIONS(2355),
    [anon_sym_unorm] = ACTIONS(2355),
    [anon_sym_point] = ACTIONS(2355),
    [anon_sym_line] = ACTIONS(2355),
    [anon_sym_triangleadj] = ACTIONS(2355),
    [anon_sym_lineadj] = ACTIONS(2355),
    [anon_sym_triangle] = ACTIONS(2355),
    [anon_sym_interface] = ACTIONS(2355),
    [anon_sym_extension] = ACTIONS(2355),
    [anon_sym___init] = ACTIONS(2355),
    [anon_sym___subscript] = ACTIONS(2355),
    [anon_sym_property] = ACTIONS(2355),
    [anon_sym_associatedtype] = ACTIONS(2355),
  },
  [1819] = {
    [sym_identifier] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_LPAREN2] = ACTIONS(5860),
    [anon_sym_TILDE] = ACTIONS(5860),
    [anon_sym_STAR] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym___extension__] = ACTIONS(5858),
    [anon_sym_in] = ACTIONS(5858),
    [anon_sym_out] = ACTIONS(5858),
    [anon_sym_inout] = ACTIONS(5858),
    [anon_sym_extern] = ACTIONS(5858),
    [anon_sym___attribute__] = ACTIONS(5858),
    [anon_sym_COLON_COLON] = ACTIONS(5860),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5860),
    [anon_sym___declspec] = ACTIONS(5858),
    [anon_sym___based] = ACTIONS(5858),
    [anon_sym___cdecl] = ACTIONS(5858),
    [anon_sym___clrcall] = ACTIONS(5858),
    [anon_sym___stdcall] = ACTIONS(5858),
    [anon_sym___fastcall] = ACTIONS(5858),
    [anon_sym___thiscall] = ACTIONS(5858),
    [anon_sym___vectorcall] = ACTIONS(5858),
    [anon_sym_signed] = ACTIONS(5858),
    [anon_sym_unsigned] = ACTIONS(5858),
    [anon_sym_long] = ACTIONS(5858),
    [anon_sym_short] = ACTIONS(5858),
    [anon_sym_LBRACK] = ACTIONS(5858),
    [anon_sym_static] = ACTIONS(5858),
    [anon_sym_register] = ACTIONS(5858),
    [anon_sym_inline] = ACTIONS(5858),
    [anon_sym___inline] = ACTIONS(5858),
    [anon_sym___inline__] = ACTIONS(5858),
    [anon_sym___forceinline] = ACTIONS(5858),
    [anon_sym_thread_local] = ACTIONS(5858),
    [anon_sym___thread] = ACTIONS(5858),
    [anon_sym_const] = ACTIONS(5858),
    [anon_sym_constexpr] = ACTIONS(5858),
    [anon_sym_volatile] = ACTIONS(5858),
    [anon_sym_restrict] = ACTIONS(5858),
    [anon_sym___restrict__] = ACTIONS(5858),
    [anon_sym__Atomic] = ACTIONS(5858),
    [anon_sym__Noreturn] = ACTIONS(5858),
    [anon_sym_noreturn] = ACTIONS(5858),
    [anon_sym_mutable] = ACTIONS(5858),
    [anon_sym_constinit] = ACTIONS(5858),
    [anon_sym_consteval] = ACTIONS(5858),
    [anon_sym_alignas] = ACTIONS(5858),
    [anon_sym__Alignas] = ACTIONS(5858),
    [sym_primitive_type] = ACTIONS(5858),
    [anon_sym_enum] = ACTIONS(5858),
    [anon_sym_class] = ACTIONS(5858),
    [anon_sym_struct] = ACTIONS(5858),
    [anon_sym_union] = ACTIONS(5858),
    [anon_sym_or] = ACTIONS(5858),
    [anon_sym_and] = ACTIONS(5858),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5858),
    [anon_sym_let] = ACTIONS(5858),
    [anon_sym_This] = ACTIONS(5858),
    [anon_sym_decltype] = ACTIONS(5858),
    [anon_sym_final] = ACTIONS(5858),
    [anon_sym_override] = ACTIONS(5858),
    [sym_virtual] = ACTIONS(5858),
    [anon_sym_explicit] = ACTIONS(5858),
    [anon_sym_typename] = ACTIONS(5858),
    [anon_sym_template] = ACTIONS(5858),
    [anon_sym_operator] = ACTIONS(5858),
    [anon_sym_friend] = ACTIONS(5858),
    [anon_sym_using] = ACTIONS(5858),
    [anon_sym_concept] = ACTIONS(5858),
    [anon_sym_requires] = ACTIONS(5858),
    [anon_sym_precise] = ACTIONS(5858),
    [anon_sym_shared] = ACTIONS(5858),
    [anon_sym_groupshared] = ACTIONS(5858),
    [anon_sym_uniform] = ACTIONS(5858),
    [anon_sym_row_major] = ACTIONS(5858),
    [anon_sym_column_major] = ACTIONS(5858),
    [anon_sym_globallycoherent] = ACTIONS(5858),
    [anon_sym_centroid] = ACTIONS(5858),
    [anon_sym_noperspective] = ACTIONS(5858),
    [anon_sym_nointerpolation] = ACTIONS(5858),
    [anon_sym_sample] = ACTIONS(5858),
    [anon_sym_linear] = ACTIONS(5858),
    [anon_sym_snorm] = ACTIONS(5858),
    [anon_sym_unorm] = ACTIONS(5858),
    [anon_sym_point] = ACTIONS(5858),
    [anon_sym_line] = ACTIONS(5858),
    [anon_sym_triangleadj] = ACTIONS(5858),
    [anon_sym_lineadj] = ACTIONS(5858),
    [anon_sym_triangle] = ACTIONS(5858),
    [anon_sym_interface] = ACTIONS(5858),
    [anon_sym_extension] = ACTIONS(5858),
    [anon_sym_where] = ACTIONS(5858),
  },
  [1820] = {
    [sym_expression] = STATE(3215),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5871),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1821] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5948),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1822] = {
    [sym_expression] = STATE(5559),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5873),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1823] = {
    [sym_expression] = STATE(5591),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5875),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1824] = {
    [sym_expression] = STATE(5590),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5877),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1825] = {
    [sym_expression] = STATE(5211),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_SEMI] = ACTIONS(5879),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACK] = ACTIONS(5881),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4958),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4964),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1826] = {
    [sym_expression] = STATE(3743),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5883),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1827] = {
    [sym_identifier] = ACTIONS(5886),
    [anon_sym_COMMA] = ACTIONS(5888),
    [anon_sym_RPAREN] = ACTIONS(5888),
    [anon_sym_LPAREN2] = ACTIONS(5888),
    [anon_sym_TILDE] = ACTIONS(5888),
    [anon_sym_STAR] = ACTIONS(5888),
    [anon_sym_PIPE_PIPE] = ACTIONS(5888),
    [anon_sym_AMP_AMP] = ACTIONS(5888),
    [anon_sym_AMP] = ACTIONS(5886),
    [anon_sym___extension__] = ACTIONS(5886),
    [anon_sym_in] = ACTIONS(5886),
    [anon_sym_out] = ACTIONS(5886),
    [anon_sym_inout] = ACTIONS(5886),
    [anon_sym_extern] = ACTIONS(5886),
    [anon_sym___attribute__] = ACTIONS(5886),
    [anon_sym_COLON_COLON] = ACTIONS(5888),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5888),
    [anon_sym___declspec] = ACTIONS(5886),
    [anon_sym___based] = ACTIONS(5886),
    [anon_sym___cdecl] = ACTIONS(5886),
    [anon_sym___clrcall] = ACTIONS(5886),
    [anon_sym___stdcall] = ACTIONS(5886),
    [anon_sym___fastcall] = ACTIONS(5886),
    [anon_sym___thiscall] = ACTIONS(5886),
    [anon_sym___vectorcall] = ACTIONS(5886),
    [anon_sym_signed] = ACTIONS(5886),
    [anon_sym_unsigned] = ACTIONS(5886),
    [anon_sym_long] = ACTIONS(5886),
    [anon_sym_short] = ACTIONS(5886),
    [anon_sym_LBRACK] = ACTIONS(5886),
    [anon_sym_static] = ACTIONS(5886),
    [anon_sym_register] = ACTIONS(5886),
    [anon_sym_inline] = ACTIONS(5886),
    [anon_sym___inline] = ACTIONS(5886),
    [anon_sym___inline__] = ACTIONS(5886),
    [anon_sym___forceinline] = ACTIONS(5886),
    [anon_sym_thread_local] = ACTIONS(5886),
    [anon_sym___thread] = ACTIONS(5886),
    [anon_sym_const] = ACTIONS(5886),
    [anon_sym_constexpr] = ACTIONS(5886),
    [anon_sym_volatile] = ACTIONS(5886),
    [anon_sym_restrict] = ACTIONS(5886),
    [anon_sym___restrict__] = ACTIONS(5886),
    [anon_sym__Atomic] = ACTIONS(5886),
    [anon_sym__Noreturn] = ACTIONS(5886),
    [anon_sym_noreturn] = ACTIONS(5886),
    [anon_sym_mutable] = ACTIONS(5886),
    [anon_sym_constinit] = ACTIONS(5886),
    [anon_sym_consteval] = ACTIONS(5886),
    [anon_sym_alignas] = ACTIONS(5886),
    [anon_sym__Alignas] = ACTIONS(5886),
    [sym_primitive_type] = ACTIONS(5886),
    [anon_sym_enum] = ACTIONS(5886),
    [anon_sym_class] = ACTIONS(5886),
    [anon_sym_struct] = ACTIONS(5886),
    [anon_sym_union] = ACTIONS(5886),
    [anon_sym_or] = ACTIONS(5886),
    [anon_sym_and] = ACTIONS(5886),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5886),
    [anon_sym_let] = ACTIONS(5886),
    [anon_sym_This] = ACTIONS(5886),
    [anon_sym_decltype] = ACTIONS(5886),
    [anon_sym_final] = ACTIONS(5886),
    [anon_sym_override] = ACTIONS(5886),
    [sym_virtual] = ACTIONS(5886),
    [anon_sym_explicit] = ACTIONS(5886),
    [anon_sym_typename] = ACTIONS(5886),
    [anon_sym_template] = ACTIONS(5886),
    [anon_sym_operator] = ACTIONS(5886),
    [anon_sym_friend] = ACTIONS(5886),
    [anon_sym_using] = ACTIONS(5886),
    [anon_sym_concept] = ACTIONS(5886),
    [anon_sym_requires] = ACTIONS(5886),
    [anon_sym_precise] = ACTIONS(5886),
    [anon_sym_shared] = ACTIONS(5886),
    [anon_sym_groupshared] = ACTIONS(5886),
    [anon_sym_uniform] = ACTIONS(5886),
    [anon_sym_row_major] = ACTIONS(5886),
    [anon_sym_column_major] = ACTIONS(5886),
    [anon_sym_globallycoherent] = ACTIONS(5886),
    [anon_sym_centroid] = ACTIONS(5886),
    [anon_sym_noperspective] = ACTIONS(5886),
    [anon_sym_nointerpolation] = ACTIONS(5886),
    [anon_sym_sample] = ACTIONS(5886),
    [anon_sym_linear] = ACTIONS(5886),
    [anon_sym_snorm] = ACTIONS(5886),
    [anon_sym_unorm] = ACTIONS(5886),
    [anon_sym_point] = ACTIONS(5886),
    [anon_sym_line] = ACTIONS(5886),
    [anon_sym_triangleadj] = ACTIONS(5886),
    [anon_sym_lineadj] = ACTIONS(5886),
    [anon_sym_triangle] = ACTIONS(5886),
    [anon_sym_interface] = ACTIONS(5886),
    [anon_sym_extension] = ACTIONS(5886),
    [anon_sym_where] = ACTIONS(5886),
  },
  [1828] = {
    [sym_expression] = STATE(3225),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_LPAREN2] = ACTIONS(5890),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1829] = {
    [sym_identifier] = ACTIONS(5892),
    [anon_sym_COMMA] = ACTIONS(5894),
    [anon_sym_RPAREN] = ACTIONS(5894),
    [anon_sym_LPAREN2] = ACTIONS(5894),
    [anon_sym_TILDE] = ACTIONS(5894),
    [anon_sym_STAR] = ACTIONS(5894),
    [anon_sym_PIPE_PIPE] = ACTIONS(5894),
    [anon_sym_AMP_AMP] = ACTIONS(5894),
    [anon_sym_AMP] = ACTIONS(5892),
    [anon_sym___extension__] = ACTIONS(5892),
    [anon_sym_in] = ACTIONS(5892),
    [anon_sym_out] = ACTIONS(5892),
    [anon_sym_inout] = ACTIONS(5892),
    [anon_sym_extern] = ACTIONS(5892),
    [anon_sym___attribute__] = ACTIONS(5892),
    [anon_sym_COLON_COLON] = ACTIONS(5894),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5894),
    [anon_sym___declspec] = ACTIONS(5892),
    [anon_sym___based] = ACTIONS(5892),
    [anon_sym___cdecl] = ACTIONS(5892),
    [anon_sym___clrcall] = ACTIONS(5892),
    [anon_sym___stdcall] = ACTIONS(5892),
    [anon_sym___fastcall] = ACTIONS(5892),
    [anon_sym___thiscall] = ACTIONS(5892),
    [anon_sym___vectorcall] = ACTIONS(5892),
    [anon_sym_signed] = ACTIONS(5892),
    [anon_sym_unsigned] = ACTIONS(5892),
    [anon_sym_long] = ACTIONS(5892),
    [anon_sym_short] = ACTIONS(5892),
    [anon_sym_LBRACK] = ACTIONS(5892),
    [anon_sym_static] = ACTIONS(5892),
    [anon_sym_register] = ACTIONS(5892),
    [anon_sym_inline] = ACTIONS(5892),
    [anon_sym___inline] = ACTIONS(5892),
    [anon_sym___inline__] = ACTIONS(5892),
    [anon_sym___forceinline] = ACTIONS(5892),
    [anon_sym_thread_local] = ACTIONS(5892),
    [anon_sym___thread] = ACTIONS(5892),
    [anon_sym_const] = ACTIONS(5892),
    [anon_sym_constexpr] = ACTIONS(5892),
    [anon_sym_volatile] = ACTIONS(5892),
    [anon_sym_restrict] = ACTIONS(5892),
    [anon_sym___restrict__] = ACTIONS(5892),
    [anon_sym__Atomic] = ACTIONS(5892),
    [anon_sym__Noreturn] = ACTIONS(5892),
    [anon_sym_noreturn] = ACTIONS(5892),
    [anon_sym_mutable] = ACTIONS(5892),
    [anon_sym_constinit] = ACTIONS(5892),
    [anon_sym_consteval] = ACTIONS(5892),
    [anon_sym_alignas] = ACTIONS(5892),
    [anon_sym__Alignas] = ACTIONS(5892),
    [sym_primitive_type] = ACTIONS(5892),
    [anon_sym_enum] = ACTIONS(5892),
    [anon_sym_class] = ACTIONS(5892),
    [anon_sym_struct] = ACTIONS(5892),
    [anon_sym_union] = ACTIONS(5892),
    [anon_sym_or] = ACTIONS(5892),
    [anon_sym_and] = ACTIONS(5892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5892),
    [anon_sym_let] = ACTIONS(5892),
    [anon_sym_This] = ACTIONS(5892),
    [anon_sym_decltype] = ACTIONS(5892),
    [anon_sym_final] = ACTIONS(5892),
    [anon_sym_override] = ACTIONS(5892),
    [sym_virtual] = ACTIONS(5892),
    [anon_sym_explicit] = ACTIONS(5892),
    [anon_sym_typename] = ACTIONS(5892),
    [anon_sym_template] = ACTIONS(5892),
    [anon_sym_operator] = ACTIONS(5892),
    [anon_sym_friend] = ACTIONS(5892),
    [anon_sym_using] = ACTIONS(5892),
    [anon_sym_concept] = ACTIONS(5892),
    [anon_sym_requires] = ACTIONS(5892),
    [anon_sym_precise] = ACTIONS(5892),
    [anon_sym_shared] = ACTIONS(5892),
    [anon_sym_groupshared] = ACTIONS(5892),
    [anon_sym_uniform] = ACTIONS(5892),
    [anon_sym_row_major] = ACTIONS(5892),
    [anon_sym_column_major] = ACTIONS(5892),
    [anon_sym_globallycoherent] = ACTIONS(5892),
    [anon_sym_centroid] = ACTIONS(5892),
    [anon_sym_noperspective] = ACTIONS(5892),
    [anon_sym_nointerpolation] = ACTIONS(5892),
    [anon_sym_sample] = ACTIONS(5892),
    [anon_sym_linear] = ACTIONS(5892),
    [anon_sym_snorm] = ACTIONS(5892),
    [anon_sym_unorm] = ACTIONS(5892),
    [anon_sym_point] = ACTIONS(5892),
    [anon_sym_line] = ACTIONS(5892),
    [anon_sym_triangleadj] = ACTIONS(5892),
    [anon_sym_lineadj] = ACTIONS(5892),
    [anon_sym_triangle] = ACTIONS(5892),
    [anon_sym_interface] = ACTIONS(5892),
    [anon_sym_extension] = ACTIONS(5892),
    [anon_sym_where] = ACTIONS(5892),
  },
  [1830] = {
    [sym_identifier] = ACTIONS(5896),
    [anon_sym_COMMA] = ACTIONS(5898),
    [anon_sym_RPAREN] = ACTIONS(5898),
    [anon_sym_LPAREN2] = ACTIONS(5898),
    [anon_sym_TILDE] = ACTIONS(5898),
    [anon_sym_STAR] = ACTIONS(5898),
    [anon_sym_PIPE_PIPE] = ACTIONS(5898),
    [anon_sym_AMP_AMP] = ACTIONS(5898),
    [anon_sym_AMP] = ACTIONS(5896),
    [anon_sym___extension__] = ACTIONS(5896),
    [anon_sym_in] = ACTIONS(5896),
    [anon_sym_out] = ACTIONS(5896),
    [anon_sym_inout] = ACTIONS(5896),
    [anon_sym_extern] = ACTIONS(5896),
    [anon_sym___attribute__] = ACTIONS(5896),
    [anon_sym_COLON_COLON] = ACTIONS(5898),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5898),
    [anon_sym___declspec] = ACTIONS(5896),
    [anon_sym___based] = ACTIONS(5896),
    [anon_sym___cdecl] = ACTIONS(5896),
    [anon_sym___clrcall] = ACTIONS(5896),
    [anon_sym___stdcall] = ACTIONS(5896),
    [anon_sym___fastcall] = ACTIONS(5896),
    [anon_sym___thiscall] = ACTIONS(5896),
    [anon_sym___vectorcall] = ACTIONS(5896),
    [anon_sym_signed] = ACTIONS(5896),
    [anon_sym_unsigned] = ACTIONS(5896),
    [anon_sym_long] = ACTIONS(5896),
    [anon_sym_short] = ACTIONS(5896),
    [anon_sym_LBRACK] = ACTIONS(5896),
    [anon_sym_static] = ACTIONS(5896),
    [anon_sym_register] = ACTIONS(5896),
    [anon_sym_inline] = ACTIONS(5896),
    [anon_sym___inline] = ACTIONS(5896),
    [anon_sym___inline__] = ACTIONS(5896),
    [anon_sym___forceinline] = ACTIONS(5896),
    [anon_sym_thread_local] = ACTIONS(5896),
    [anon_sym___thread] = ACTIONS(5896),
    [anon_sym_const] = ACTIONS(5896),
    [anon_sym_constexpr] = ACTIONS(5896),
    [anon_sym_volatile] = ACTIONS(5896),
    [anon_sym_restrict] = ACTIONS(5896),
    [anon_sym___restrict__] = ACTIONS(5896),
    [anon_sym__Atomic] = ACTIONS(5896),
    [anon_sym__Noreturn] = ACTIONS(5896),
    [anon_sym_noreturn] = ACTIONS(5896),
    [anon_sym_mutable] = ACTIONS(5896),
    [anon_sym_constinit] = ACTIONS(5896),
    [anon_sym_consteval] = ACTIONS(5896),
    [anon_sym_alignas] = ACTIONS(5896),
    [anon_sym__Alignas] = ACTIONS(5896),
    [sym_primitive_type] = ACTIONS(5896),
    [anon_sym_enum] = ACTIONS(5896),
    [anon_sym_class] = ACTIONS(5896),
    [anon_sym_struct] = ACTIONS(5896),
    [anon_sym_union] = ACTIONS(5896),
    [anon_sym_or] = ACTIONS(5896),
    [anon_sym_and] = ACTIONS(5896),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5896),
    [anon_sym_let] = ACTIONS(5896),
    [anon_sym_This] = ACTIONS(5896),
    [anon_sym_decltype] = ACTIONS(5896),
    [anon_sym_final] = ACTIONS(5896),
    [anon_sym_override] = ACTIONS(5896),
    [sym_virtual] = ACTIONS(5896),
    [anon_sym_explicit] = ACTIONS(5896),
    [anon_sym_typename] = ACTIONS(5896),
    [anon_sym_template] = ACTIONS(5896),
    [anon_sym_operator] = ACTIONS(5896),
    [anon_sym_friend] = ACTIONS(5896),
    [anon_sym_using] = ACTIONS(5896),
    [anon_sym_concept] = ACTIONS(5896),
    [anon_sym_requires] = ACTIONS(5896),
    [anon_sym_precise] = ACTIONS(5896),
    [anon_sym_shared] = ACTIONS(5896),
    [anon_sym_groupshared] = ACTIONS(5896),
    [anon_sym_uniform] = ACTIONS(5896),
    [anon_sym_row_major] = ACTIONS(5896),
    [anon_sym_column_major] = ACTIONS(5896),
    [anon_sym_globallycoherent] = ACTIONS(5896),
    [anon_sym_centroid] = ACTIONS(5896),
    [anon_sym_noperspective] = ACTIONS(5896),
    [anon_sym_nointerpolation] = ACTIONS(5896),
    [anon_sym_sample] = ACTIONS(5896),
    [anon_sym_linear] = ACTIONS(5896),
    [anon_sym_snorm] = ACTIONS(5896),
    [anon_sym_unorm] = ACTIONS(5896),
    [anon_sym_point] = ACTIONS(5896),
    [anon_sym_line] = ACTIONS(5896),
    [anon_sym_triangleadj] = ACTIONS(5896),
    [anon_sym_lineadj] = ACTIONS(5896),
    [anon_sym_triangle] = ACTIONS(5896),
    [anon_sym_interface] = ACTIONS(5896),
    [anon_sym_extension] = ACTIONS(5896),
    [anon_sym_where] = ACTIONS(5896),
  },
  [1831] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5968),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1832] = {
    [sym_expression] = STATE(3215),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5900),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1833] = {
    [sym_expression] = STATE(3742),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5902),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1834] = {
    [sym_expression] = STATE(3741),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5905),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1835] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5975),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1836] = {
    [sym_expression] = STATE(5533),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5908),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1837] = {
    [sym_expression] = STATE(5534),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5910),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1838] = {
    [sym_expression] = STATE(4676),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5912),
    [anon_sym_LPAREN2] = ACTIONS(5914),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1839] = {
    [sym_expression] = STATE(5426),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(9278),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1840] = {
    [sym_expression] = STATE(3696),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5916),
    [anon_sym_LPAREN2] = ACTIONS(5918),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1841] = {
    [sym_expression] = STATE(3215),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5920),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1842] = {
    [sym_expression] = STATE(3738),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5922),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1843] = {
    [sym_identifier] = ACTIONS(5925),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_RPAREN] = ACTIONS(5927),
    [anon_sym_LPAREN2] = ACTIONS(5927),
    [anon_sym_TILDE] = ACTIONS(5927),
    [anon_sym_STAR] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(5927),
    [anon_sym_AMP_AMP] = ACTIONS(5927),
    [anon_sym_AMP] = ACTIONS(5925),
    [anon_sym___extension__] = ACTIONS(5925),
    [anon_sym_in] = ACTIONS(5925),
    [anon_sym_out] = ACTIONS(5925),
    [anon_sym_inout] = ACTIONS(5925),
    [anon_sym_extern] = ACTIONS(5925),
    [anon_sym___attribute__] = ACTIONS(5925),
    [anon_sym_COLON_COLON] = ACTIONS(5927),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5927),
    [anon_sym___declspec] = ACTIONS(5925),
    [anon_sym___based] = ACTIONS(5925),
    [anon_sym___cdecl] = ACTIONS(5925),
    [anon_sym___clrcall] = ACTIONS(5925),
    [anon_sym___stdcall] = ACTIONS(5925),
    [anon_sym___fastcall] = ACTIONS(5925),
    [anon_sym___thiscall] = ACTIONS(5925),
    [anon_sym___vectorcall] = ACTIONS(5925),
    [anon_sym_signed] = ACTIONS(5925),
    [anon_sym_unsigned] = ACTIONS(5925),
    [anon_sym_long] = ACTIONS(5925),
    [anon_sym_short] = ACTIONS(5925),
    [anon_sym_LBRACK] = ACTIONS(5925),
    [anon_sym_static] = ACTIONS(5925),
    [anon_sym_register] = ACTIONS(5925),
    [anon_sym_inline] = ACTIONS(5925),
    [anon_sym___inline] = ACTIONS(5925),
    [anon_sym___inline__] = ACTIONS(5925),
    [anon_sym___forceinline] = ACTIONS(5925),
    [anon_sym_thread_local] = ACTIONS(5925),
    [anon_sym___thread] = ACTIONS(5925),
    [anon_sym_const] = ACTIONS(5925),
    [anon_sym_constexpr] = ACTIONS(5925),
    [anon_sym_volatile] = ACTIONS(5925),
    [anon_sym_restrict] = ACTIONS(5925),
    [anon_sym___restrict__] = ACTIONS(5925),
    [anon_sym__Atomic] = ACTIONS(5925),
    [anon_sym__Noreturn] = ACTIONS(5925),
    [anon_sym_noreturn] = ACTIONS(5925),
    [anon_sym_mutable] = ACTIONS(5925),
    [anon_sym_constinit] = ACTIONS(5925),
    [anon_sym_consteval] = ACTIONS(5925),
    [anon_sym_alignas] = ACTIONS(5925),
    [anon_sym__Alignas] = ACTIONS(5925),
    [sym_primitive_type] = ACTIONS(5925),
    [anon_sym_enum] = ACTIONS(5925),
    [anon_sym_class] = ACTIONS(5925),
    [anon_sym_struct] = ACTIONS(5925),
    [anon_sym_union] = ACTIONS(5925),
    [anon_sym_or] = ACTIONS(5925),
    [anon_sym_and] = ACTIONS(5925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5925),
    [anon_sym_let] = ACTIONS(5925),
    [anon_sym_This] = ACTIONS(5925),
    [anon_sym_decltype] = ACTIONS(5925),
    [anon_sym_final] = ACTIONS(5925),
    [anon_sym_override] = ACTIONS(5925),
    [sym_virtual] = ACTIONS(5925),
    [anon_sym_explicit] = ACTIONS(5925),
    [anon_sym_typename] = ACTIONS(5925),
    [anon_sym_template] = ACTIONS(5925),
    [anon_sym_operator] = ACTIONS(5925),
    [anon_sym_friend] = ACTIONS(5925),
    [anon_sym_using] = ACTIONS(5925),
    [anon_sym_concept] = ACTIONS(5925),
    [anon_sym_requires] = ACTIONS(5925),
    [anon_sym_precise] = ACTIONS(5925),
    [anon_sym_shared] = ACTIONS(5925),
    [anon_sym_groupshared] = ACTIONS(5925),
    [anon_sym_uniform] = ACTIONS(5925),
    [anon_sym_row_major] = ACTIONS(5925),
    [anon_sym_column_major] = ACTIONS(5925),
    [anon_sym_globallycoherent] = ACTIONS(5925),
    [anon_sym_centroid] = ACTIONS(5925),
    [anon_sym_noperspective] = ACTIONS(5925),
    [anon_sym_nointerpolation] = ACTIONS(5925),
    [anon_sym_sample] = ACTIONS(5925),
    [anon_sym_linear] = ACTIONS(5925),
    [anon_sym_snorm] = ACTIONS(5925),
    [anon_sym_unorm] = ACTIONS(5925),
    [anon_sym_point] = ACTIONS(5925),
    [anon_sym_line] = ACTIONS(5925),
    [anon_sym_triangleadj] = ACTIONS(5925),
    [anon_sym_lineadj] = ACTIONS(5925),
    [anon_sym_triangle] = ACTIONS(5925),
    [anon_sym_interface] = ACTIONS(5925),
    [anon_sym_extension] = ACTIONS(5925),
    [anon_sym_where] = ACTIONS(5925),
  },
  [1844] = {
    [sym_identifier] = ACTIONS(2842),
    [aux_sym_preproc_def_token1] = ACTIONS(2842),
    [aux_sym_preproc_if_token1] = ACTIONS(2842),
    [aux_sym_preproc_if_token2] = ACTIONS(2842),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2842),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2842),
    [sym_preproc_directive] = ACTIONS(2842),
    [anon_sym_LPAREN2] = ACTIONS(2844),
    [anon_sym_TILDE] = ACTIONS(2844),
    [anon_sym_STAR] = ACTIONS(2844),
    [anon_sym_AMP_AMP] = ACTIONS(2844),
    [anon_sym_AMP] = ACTIONS(2842),
    [anon_sym___extension__] = ACTIONS(2842),
    [anon_sym_typedef] = ACTIONS(2842),
    [anon_sym_in] = ACTIONS(2842),
    [anon_sym_out] = ACTIONS(2842),
    [anon_sym_inout] = ACTIONS(2842),
    [anon_sym_extern] = ACTIONS(2842),
    [anon_sym___attribute__] = ACTIONS(2842),
    [anon_sym_COLON_COLON] = ACTIONS(2844),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2844),
    [anon_sym___declspec] = ACTIONS(2842),
    [anon_sym___based] = ACTIONS(2842),
    [anon_sym_signed] = ACTIONS(2842),
    [anon_sym_unsigned] = ACTIONS(2842),
    [anon_sym_long] = ACTIONS(2842),
    [anon_sym_short] = ACTIONS(2842),
    [anon_sym_LBRACK] = ACTIONS(2842),
    [anon_sym_static] = ACTIONS(2842),
    [anon_sym_register] = ACTIONS(2842),
    [anon_sym_inline] = ACTIONS(2842),
    [anon_sym___inline] = ACTIONS(2842),
    [anon_sym___inline__] = ACTIONS(2842),
    [anon_sym___forceinline] = ACTIONS(2842),
    [anon_sym_thread_local] = ACTIONS(2842),
    [anon_sym___thread] = ACTIONS(2842),
    [anon_sym_const] = ACTIONS(2842),
    [anon_sym_constexpr] = ACTIONS(2842),
    [anon_sym_volatile] = ACTIONS(2842),
    [anon_sym_restrict] = ACTIONS(2842),
    [anon_sym___restrict__] = ACTIONS(2842),
    [anon_sym__Atomic] = ACTIONS(2842),
    [anon_sym__Noreturn] = ACTIONS(2842),
    [anon_sym_noreturn] = ACTIONS(2842),
    [anon_sym_mutable] = ACTIONS(2842),
    [anon_sym_constinit] = ACTIONS(2842),
    [anon_sym_consteval] = ACTIONS(2842),
    [anon_sym_alignas] = ACTIONS(2842),
    [anon_sym__Alignas] = ACTIONS(2842),
    [sym_primitive_type] = ACTIONS(2842),
    [anon_sym_enum] = ACTIONS(2842),
    [anon_sym_class] = ACTIONS(2842),
    [anon_sym_struct] = ACTIONS(2842),
    [anon_sym_union] = ACTIONS(2842),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2842),
    [anon_sym_let] = ACTIONS(2842),
    [anon_sym_This] = ACTIONS(2842),
    [anon_sym_decltype] = ACTIONS(2842),
    [sym_virtual] = ACTIONS(2842),
    [anon_sym_explicit] = ACTIONS(2842),
    [anon_sym_typename] = ACTIONS(2842),
    [anon_sym_template] = ACTIONS(2842),
    [anon_sym_operator] = ACTIONS(2842),
    [anon_sym_friend] = ACTIONS(2842),
    [anon_sym_public] = ACTIONS(2842),
    [anon_sym_private] = ACTIONS(2842),
    [anon_sym_protected] = ACTIONS(2842),
    [anon_sym_using] = ACTIONS(2842),
    [anon_sym_static_assert] = ACTIONS(2842),
    [anon_sym_catch] = ACTIONS(2842),
    [anon_sym_precise] = ACTIONS(2842),
    [anon_sym_shared] = ACTIONS(2842),
    [anon_sym_groupshared] = ACTIONS(2842),
    [anon_sym_uniform] = ACTIONS(2842),
    [anon_sym_row_major] = ACTIONS(2842),
    [anon_sym_column_major] = ACTIONS(2842),
    [anon_sym_globallycoherent] = ACTIONS(2842),
    [anon_sym_centroid] = ACTIONS(2842),
    [anon_sym_noperspective] = ACTIONS(2842),
    [anon_sym_nointerpolation] = ACTIONS(2842),
    [anon_sym_sample] = ACTIONS(2842),
    [anon_sym_linear] = ACTIONS(2842),
    [anon_sym_snorm] = ACTIONS(2842),
    [anon_sym_unorm] = ACTIONS(2842),
    [anon_sym_point] = ACTIONS(2842),
    [anon_sym_line] = ACTIONS(2842),
    [anon_sym_triangleadj] = ACTIONS(2842),
    [anon_sym_lineadj] = ACTIONS(2842),
    [anon_sym_triangle] = ACTIONS(2842),
    [anon_sym_interface] = ACTIONS(2842),
    [anon_sym_extension] = ACTIONS(2842),
    [anon_sym___init] = ACTIONS(2842),
    [anon_sym___subscript] = ACTIONS(2842),
    [anon_sym_property] = ACTIONS(2842),
    [anon_sym_associatedtype] = ACTIONS(2842),
  },
  [1845] = {
    [sym_expression] = STATE(3215),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5929),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1846] = {
    [sym_expression] = STATE(3225),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3481),
    [sym_concatenated_string] = STATE(3486),
    [sym_string_literal] = STATE(2963),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2960),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_LPAREN2] = ACTIONS(5931),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4412),
    [anon_sym_PLUS] = ACTIONS(4412),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4416),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4412),
    [anon_sym_compl] = ACTIONS(4412),
    [anon_sym_DASH_DASH] = ACTIONS(5756),
    [anon_sym_PLUS_PLUS] = ACTIONS(5756),
    [anon_sym_sizeof] = ACTIONS(4422),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4432),
    [anon_sym_L_SQUOTE] = ACTIONS(4434),
    [anon_sym_u_SQUOTE] = ACTIONS(4434),
    [anon_sym_U_SQUOTE] = ACTIONS(4434),
    [anon_sym_u8_SQUOTE] = ACTIONS(4434),
    [anon_sym_SQUOTE] = ACTIONS(4434),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4442),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [anon_sym_co_await] = ACTIONS(4446),
    [anon_sym_new] = ACTIONS(4448),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1847] = {
    [sym_identifier] = ACTIONS(5933),
    [anon_sym_COMMA] = ACTIONS(5935),
    [anon_sym_RPAREN] = ACTIONS(5935),
    [anon_sym_LPAREN2] = ACTIONS(5935),
    [anon_sym_TILDE] = ACTIONS(5935),
    [anon_sym_STAR] = ACTIONS(5935),
    [anon_sym_PIPE_PIPE] = ACTIONS(5935),
    [anon_sym_AMP_AMP] = ACTIONS(5935),
    [anon_sym_AMP] = ACTIONS(5933),
    [anon_sym___extension__] = ACTIONS(5933),
    [anon_sym_in] = ACTIONS(5933),
    [anon_sym_out] = ACTIONS(5933),
    [anon_sym_inout] = ACTIONS(5933),
    [anon_sym_extern] = ACTIONS(5933),
    [anon_sym___attribute__] = ACTIONS(5933),
    [anon_sym_COLON_COLON] = ACTIONS(5935),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5935),
    [anon_sym___declspec] = ACTIONS(5933),
    [anon_sym___based] = ACTIONS(5933),
    [anon_sym___cdecl] = ACTIONS(5933),
    [anon_sym___clrcall] = ACTIONS(5933),
    [anon_sym___stdcall] = ACTIONS(5933),
    [anon_sym___fastcall] = ACTIONS(5933),
    [anon_sym___thiscall] = ACTIONS(5933),
    [anon_sym___vectorcall] = ACTIONS(5933),
    [anon_sym_signed] = ACTIONS(5933),
    [anon_sym_unsigned] = ACTIONS(5933),
    [anon_sym_long] = ACTIONS(5933),
    [anon_sym_short] = ACTIONS(5933),
    [anon_sym_LBRACK] = ACTIONS(5933),
    [anon_sym_static] = ACTIONS(5933),
    [anon_sym_register] = ACTIONS(5933),
    [anon_sym_inline] = ACTIONS(5933),
    [anon_sym___inline] = ACTIONS(5933),
    [anon_sym___inline__] = ACTIONS(5933),
    [anon_sym___forceinline] = ACTIONS(5933),
    [anon_sym_thread_local] = ACTIONS(5933),
    [anon_sym___thread] = ACTIONS(5933),
    [anon_sym_const] = ACTIONS(5933),
    [anon_sym_constexpr] = ACTIONS(5933),
    [anon_sym_volatile] = ACTIONS(5933),
    [anon_sym_restrict] = ACTIONS(5933),
    [anon_sym___restrict__] = ACTIONS(5933),
    [anon_sym__Atomic] = ACTIONS(5933),
    [anon_sym__Noreturn] = ACTIONS(5933),
    [anon_sym_noreturn] = ACTIONS(5933),
    [anon_sym_mutable] = ACTIONS(5933),
    [anon_sym_constinit] = ACTIONS(5933),
    [anon_sym_consteval] = ACTIONS(5933),
    [anon_sym_alignas] = ACTIONS(5933),
    [anon_sym__Alignas] = ACTIONS(5933),
    [sym_primitive_type] = ACTIONS(5933),
    [anon_sym_enum] = ACTIONS(5933),
    [anon_sym_class] = ACTIONS(5933),
    [anon_sym_struct] = ACTIONS(5933),
    [anon_sym_union] = ACTIONS(5933),
    [anon_sym_or] = ACTIONS(5933),
    [anon_sym_and] = ACTIONS(5933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5933),
    [anon_sym_let] = ACTIONS(5933),
    [anon_sym_This] = ACTIONS(5933),
    [anon_sym_decltype] = ACTIONS(5933),
    [anon_sym_final] = ACTIONS(5933),
    [anon_sym_override] = ACTIONS(5933),
    [sym_virtual] = ACTIONS(5933),
    [anon_sym_explicit] = ACTIONS(5933),
    [anon_sym_typename] = ACTIONS(5933),
    [anon_sym_template] = ACTIONS(5933),
    [anon_sym_operator] = ACTIONS(5933),
    [anon_sym_friend] = ACTIONS(5933),
    [anon_sym_using] = ACTIONS(5933),
    [anon_sym_concept] = ACTIONS(5933),
    [anon_sym_requires] = ACTIONS(5933),
    [anon_sym_precise] = ACTIONS(5933),
    [anon_sym_shared] = ACTIONS(5933),
    [anon_sym_groupshared] = ACTIONS(5933),
    [anon_sym_uniform] = ACTIONS(5933),
    [anon_sym_row_major] = ACTIONS(5933),
    [anon_sym_column_major] = ACTIONS(5933),
    [anon_sym_globallycoherent] = ACTIONS(5933),
    [anon_sym_centroid] = ACTIONS(5933),
    [anon_sym_noperspective] = ACTIONS(5933),
    [anon_sym_nointerpolation] = ACTIONS(5933),
    [anon_sym_sample] = ACTIONS(5933),
    [anon_sym_linear] = ACTIONS(5933),
    [anon_sym_snorm] = ACTIONS(5933),
    [anon_sym_unorm] = ACTIONS(5933),
    [anon_sym_point] = ACTIONS(5933),
    [anon_sym_line] = ACTIONS(5933),
    [anon_sym_triangleadj] = ACTIONS(5933),
    [anon_sym_lineadj] = ACTIONS(5933),
    [anon_sym_triangle] = ACTIONS(5933),
    [anon_sym_interface] = ACTIONS(5933),
    [anon_sym_extension] = ACTIONS(5933),
    [anon_sym_where] = ACTIONS(5933),
  },
  [1848] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5956),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1849] = {
    [sym_identifier] = ACTIONS(5937),
    [anon_sym_COMMA] = ACTIONS(5939),
    [anon_sym_RPAREN] = ACTIONS(5939),
    [anon_sym_LPAREN2] = ACTIONS(5939),
    [anon_sym_TILDE] = ACTIONS(5939),
    [anon_sym_STAR] = ACTIONS(5939),
    [anon_sym_PIPE_PIPE] = ACTIONS(5939),
    [anon_sym_AMP_AMP] = ACTIONS(5939),
    [anon_sym_AMP] = ACTIONS(5937),
    [anon_sym___extension__] = ACTIONS(5937),
    [anon_sym_in] = ACTIONS(5937),
    [anon_sym_out] = ACTIONS(5937),
    [anon_sym_inout] = ACTIONS(5937),
    [anon_sym_extern] = ACTIONS(5937),
    [anon_sym___attribute__] = ACTIONS(5937),
    [anon_sym_COLON_COLON] = ACTIONS(5939),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5939),
    [anon_sym___declspec] = ACTIONS(5937),
    [anon_sym___based] = ACTIONS(5937),
    [anon_sym___cdecl] = ACTIONS(5937),
    [anon_sym___clrcall] = ACTIONS(5937),
    [anon_sym___stdcall] = ACTIONS(5937),
    [anon_sym___fastcall] = ACTIONS(5937),
    [anon_sym___thiscall] = ACTIONS(5937),
    [anon_sym___vectorcall] = ACTIONS(5937),
    [anon_sym_signed] = ACTIONS(5937),
    [anon_sym_unsigned] = ACTIONS(5937),
    [anon_sym_long] = ACTIONS(5937),
    [anon_sym_short] = ACTIONS(5937),
    [anon_sym_LBRACK] = ACTIONS(5937),
    [anon_sym_static] = ACTIONS(5937),
    [anon_sym_register] = ACTIONS(5937),
    [anon_sym_inline] = ACTIONS(5937),
    [anon_sym___inline] = ACTIONS(5937),
    [anon_sym___inline__] = ACTIONS(5937),
    [anon_sym___forceinline] = ACTIONS(5937),
    [anon_sym_thread_local] = ACTIONS(5937),
    [anon_sym___thread] = ACTIONS(5937),
    [anon_sym_const] = ACTIONS(5937),
    [anon_sym_constexpr] = ACTIONS(5937),
    [anon_sym_volatile] = ACTIONS(5937),
    [anon_sym_restrict] = ACTIONS(5937),
    [anon_sym___restrict__] = ACTIONS(5937),
    [anon_sym__Atomic] = ACTIONS(5937),
    [anon_sym__Noreturn] = ACTIONS(5937),
    [anon_sym_noreturn] = ACTIONS(5937),
    [anon_sym_mutable] = ACTIONS(5937),
    [anon_sym_constinit] = ACTIONS(5937),
    [anon_sym_consteval] = ACTIONS(5937),
    [anon_sym_alignas] = ACTIONS(5937),
    [anon_sym__Alignas] = ACTIONS(5937),
    [sym_primitive_type] = ACTIONS(5937),
    [anon_sym_enum] = ACTIONS(5937),
    [anon_sym_class] = ACTIONS(5937),
    [anon_sym_struct] = ACTIONS(5937),
    [anon_sym_union] = ACTIONS(5937),
    [anon_sym_or] = ACTIONS(5937),
    [anon_sym_and] = ACTIONS(5937),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5937),
    [anon_sym_let] = ACTIONS(5937),
    [anon_sym_This] = ACTIONS(5937),
    [anon_sym_decltype] = ACTIONS(5937),
    [anon_sym_final] = ACTIONS(5937),
    [anon_sym_override] = ACTIONS(5937),
    [sym_virtual] = ACTIONS(5937),
    [anon_sym_explicit] = ACTIONS(5937),
    [anon_sym_typename] = ACTIONS(5937),
    [anon_sym_template] = ACTIONS(5937),
    [anon_sym_operator] = ACTIONS(5937),
    [anon_sym_friend] = ACTIONS(5937),
    [anon_sym_using] = ACTIONS(5937),
    [anon_sym_concept] = ACTIONS(5937),
    [anon_sym_requires] = ACTIONS(5937),
    [anon_sym_precise] = ACTIONS(5937),
    [anon_sym_shared] = ACTIONS(5937),
    [anon_sym_groupshared] = ACTIONS(5937),
    [anon_sym_uniform] = ACTIONS(5937),
    [anon_sym_row_major] = ACTIONS(5937),
    [anon_sym_column_major] = ACTIONS(5937),
    [anon_sym_globallycoherent] = ACTIONS(5937),
    [anon_sym_centroid] = ACTIONS(5937),
    [anon_sym_noperspective] = ACTIONS(5937),
    [anon_sym_nointerpolation] = ACTIONS(5937),
    [anon_sym_sample] = ACTIONS(5937),
    [anon_sym_linear] = ACTIONS(5937),
    [anon_sym_snorm] = ACTIONS(5937),
    [anon_sym_unorm] = ACTIONS(5937),
    [anon_sym_point] = ACTIONS(5937),
    [anon_sym_line] = ACTIONS(5937),
    [anon_sym_triangleadj] = ACTIONS(5937),
    [anon_sym_lineadj] = ACTIONS(5937),
    [anon_sym_triangle] = ACTIONS(5937),
    [anon_sym_interface] = ACTIONS(5937),
    [anon_sym_extension] = ACTIONS(5937),
    [anon_sym_where] = ACTIONS(5937),
  },
  [1850] = {
    [sym_identifier] = ACTIONS(5941),
    [anon_sym_COMMA] = ACTIONS(5943),
    [anon_sym_RPAREN] = ACTIONS(5943),
    [anon_sym_LPAREN2] = ACTIONS(5943),
    [anon_sym_TILDE] = ACTIONS(5943),
    [anon_sym_STAR] = ACTIONS(5943),
    [anon_sym_PIPE_PIPE] = ACTIONS(5943),
    [anon_sym_AMP_AMP] = ACTIONS(5943),
    [anon_sym_AMP] = ACTIONS(5941),
    [anon_sym___extension__] = ACTIONS(5941),
    [anon_sym_in] = ACTIONS(5941),
    [anon_sym_out] = ACTIONS(5941),
    [anon_sym_inout] = ACTIONS(5941),
    [anon_sym_extern] = ACTIONS(5941),
    [anon_sym___attribute__] = ACTIONS(5941),
    [anon_sym_COLON_COLON] = ACTIONS(5943),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5943),
    [anon_sym___declspec] = ACTIONS(5941),
    [anon_sym___based] = ACTIONS(5941),
    [anon_sym___cdecl] = ACTIONS(5941),
    [anon_sym___clrcall] = ACTIONS(5941),
    [anon_sym___stdcall] = ACTIONS(5941),
    [anon_sym___fastcall] = ACTIONS(5941),
    [anon_sym___thiscall] = ACTIONS(5941),
    [anon_sym___vectorcall] = ACTIONS(5941),
    [anon_sym_signed] = ACTIONS(5941),
    [anon_sym_unsigned] = ACTIONS(5941),
    [anon_sym_long] = ACTIONS(5941),
    [anon_sym_short] = ACTIONS(5941),
    [anon_sym_LBRACK] = ACTIONS(5941),
    [anon_sym_static] = ACTIONS(5941),
    [anon_sym_register] = ACTIONS(5941),
    [anon_sym_inline] = ACTIONS(5941),
    [anon_sym___inline] = ACTIONS(5941),
    [anon_sym___inline__] = ACTIONS(5941),
    [anon_sym___forceinline] = ACTIONS(5941),
    [anon_sym_thread_local] = ACTIONS(5941),
    [anon_sym___thread] = ACTIONS(5941),
    [anon_sym_const] = ACTIONS(5941),
    [anon_sym_constexpr] = ACTIONS(5941),
    [anon_sym_volatile] = ACTIONS(5941),
    [anon_sym_restrict] = ACTIONS(5941),
    [anon_sym___restrict__] = ACTIONS(5941),
    [anon_sym__Atomic] = ACTIONS(5941),
    [anon_sym__Noreturn] = ACTIONS(5941),
    [anon_sym_noreturn] = ACTIONS(5941),
    [anon_sym_mutable] = ACTIONS(5941),
    [anon_sym_constinit] = ACTIONS(5941),
    [anon_sym_consteval] = ACTIONS(5941),
    [anon_sym_alignas] = ACTIONS(5941),
    [anon_sym__Alignas] = ACTIONS(5941),
    [sym_primitive_type] = ACTIONS(5941),
    [anon_sym_enum] = ACTIONS(5941),
    [anon_sym_class] = ACTIONS(5941),
    [anon_sym_struct] = ACTIONS(5941),
    [anon_sym_union] = ACTIONS(5941),
    [anon_sym_or] = ACTIONS(5941),
    [anon_sym_and] = ACTIONS(5941),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5941),
    [anon_sym_let] = ACTIONS(5941),
    [anon_sym_This] = ACTIONS(5941),
    [anon_sym_decltype] = ACTIONS(5941),
    [anon_sym_final] = ACTIONS(5941),
    [anon_sym_override] = ACTIONS(5941),
    [sym_virtual] = ACTIONS(5941),
    [anon_sym_explicit] = ACTIONS(5941),
    [anon_sym_typename] = ACTIONS(5941),
    [anon_sym_template] = ACTIONS(5941),
    [anon_sym_operator] = ACTIONS(5941),
    [anon_sym_friend] = ACTIONS(5941),
    [anon_sym_using] = ACTIONS(5941),
    [anon_sym_concept] = ACTIONS(5941),
    [anon_sym_requires] = ACTIONS(5941),
    [anon_sym_precise] = ACTIONS(5941),
    [anon_sym_shared] = ACTIONS(5941),
    [anon_sym_groupshared] = ACTIONS(5941),
    [anon_sym_uniform] = ACTIONS(5941),
    [anon_sym_row_major] = ACTIONS(5941),
    [anon_sym_column_major] = ACTIONS(5941),
    [anon_sym_globallycoherent] = ACTIONS(5941),
    [anon_sym_centroid] = ACTIONS(5941),
    [anon_sym_noperspective] = ACTIONS(5941),
    [anon_sym_nointerpolation] = ACTIONS(5941),
    [anon_sym_sample] = ACTIONS(5941),
    [anon_sym_linear] = ACTIONS(5941),
    [anon_sym_snorm] = ACTIONS(5941),
    [anon_sym_unorm] = ACTIONS(5941),
    [anon_sym_point] = ACTIONS(5941),
    [anon_sym_line] = ACTIONS(5941),
    [anon_sym_triangleadj] = ACTIONS(5941),
    [anon_sym_lineadj] = ACTIONS(5941),
    [anon_sym_triangle] = ACTIONS(5941),
    [anon_sym_interface] = ACTIONS(5941),
    [anon_sym_extension] = ACTIONS(5941),
    [anon_sym_where] = ACTIONS(5941),
  },
  [1851] = {
    [sym_expression] = STATE(4676),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5912),
    [anon_sym_LPAREN2] = ACTIONS(5945),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1852] = {
    [sym_expression] = STATE(3215),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5947),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1853] = {
    [sym_expression] = STATE(3215),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5949),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1854] = {
    [sym_expression] = STATE(3225),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(4134),
    [sym_concatenated_string] = STATE(4159),
    [sym_string_literal] = STATE(3152),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(3145),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_LPAREN2] = ACTIONS(5951),
    [anon_sym_BANG] = ACTIONS(4591),
    [anon_sym_TILDE] = ACTIONS(4591),
    [anon_sym_DASH] = ACTIONS(4589),
    [anon_sym_PLUS] = ACTIONS(4589),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4593),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4589),
    [anon_sym_compl] = ACTIONS(4589),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_sizeof] = ACTIONS(4595),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4597),
    [anon_sym_L_SQUOTE] = ACTIONS(4599),
    [anon_sym_u_SQUOTE] = ACTIONS(4599),
    [anon_sym_U_SQUOTE] = ACTIONS(4599),
    [anon_sym_u8_SQUOTE] = ACTIONS(4599),
    [anon_sym_SQUOTE] = ACTIONS(4599),
    [anon_sym_L_DQUOTE] = ACTIONS(4601),
    [anon_sym_u_DQUOTE] = ACTIONS(4601),
    [anon_sym_U_DQUOTE] = ACTIONS(4601),
    [anon_sym_u8_DQUOTE] = ACTIONS(4601),
    [anon_sym_DQUOTE] = ACTIONS(4601),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4603),
    [anon_sym_R_DQUOTE] = ACTIONS(4605),
    [anon_sym_LR_DQUOTE] = ACTIONS(4605),
    [anon_sym_uR_DQUOTE] = ACTIONS(4605),
    [anon_sym_UR_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4605),
    [anon_sym_co_await] = ACTIONS(4607),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1855] = {
    [sym_identifier] = ACTIONS(5953),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_LPAREN2] = ACTIONS(5955),
    [anon_sym_TILDE] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_PIPE_PIPE] = ACTIONS(5955),
    [anon_sym_AMP_AMP] = ACTIONS(5955),
    [anon_sym_AMP] = ACTIONS(5953),
    [anon_sym___extension__] = ACTIONS(5953),
    [anon_sym_in] = ACTIONS(5953),
    [anon_sym_out] = ACTIONS(5953),
    [anon_sym_inout] = ACTIONS(5953),
    [anon_sym_extern] = ACTIONS(5953),
    [anon_sym___attribute__] = ACTIONS(5953),
    [anon_sym_COLON_COLON] = ACTIONS(5955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5955),
    [anon_sym___declspec] = ACTIONS(5953),
    [anon_sym___based] = ACTIONS(5953),
    [anon_sym___cdecl] = ACTIONS(5953),
    [anon_sym___clrcall] = ACTIONS(5953),
    [anon_sym___stdcall] = ACTIONS(5953),
    [anon_sym___fastcall] = ACTIONS(5953),
    [anon_sym___thiscall] = ACTIONS(5953),
    [anon_sym___vectorcall] = ACTIONS(5953),
    [anon_sym_signed] = ACTIONS(5953),
    [anon_sym_unsigned] = ACTIONS(5953),
    [anon_sym_long] = ACTIONS(5953),
    [anon_sym_short] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5953),
    [anon_sym_static] = ACTIONS(5953),
    [anon_sym_register] = ACTIONS(5953),
    [anon_sym_inline] = ACTIONS(5953),
    [anon_sym___inline] = ACTIONS(5953),
    [anon_sym___inline__] = ACTIONS(5953),
    [anon_sym___forceinline] = ACTIONS(5953),
    [anon_sym_thread_local] = ACTIONS(5953),
    [anon_sym___thread] = ACTIONS(5953),
    [anon_sym_const] = ACTIONS(5953),
    [anon_sym_constexpr] = ACTIONS(5953),
    [anon_sym_volatile] = ACTIONS(5953),
    [anon_sym_restrict] = ACTIONS(5953),
    [anon_sym___restrict__] = ACTIONS(5953),
    [anon_sym__Atomic] = ACTIONS(5953),
    [anon_sym__Noreturn] = ACTIONS(5953),
    [anon_sym_noreturn] = ACTIONS(5953),
    [anon_sym_mutable] = ACTIONS(5953),
    [anon_sym_constinit] = ACTIONS(5953),
    [anon_sym_consteval] = ACTIONS(5953),
    [anon_sym_alignas] = ACTIONS(5953),
    [anon_sym__Alignas] = ACTIONS(5953),
    [sym_primitive_type] = ACTIONS(5953),
    [anon_sym_enum] = ACTIONS(5953),
    [anon_sym_class] = ACTIONS(5953),
    [anon_sym_struct] = ACTIONS(5953),
    [anon_sym_union] = ACTIONS(5953),
    [anon_sym_or] = ACTIONS(5953),
    [anon_sym_and] = ACTIONS(5953),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5953),
    [anon_sym_let] = ACTIONS(5953),
    [anon_sym_This] = ACTIONS(5953),
    [anon_sym_decltype] = ACTIONS(5953),
    [anon_sym_final] = ACTIONS(5953),
    [anon_sym_override] = ACTIONS(5953),
    [sym_virtual] = ACTIONS(5953),
    [anon_sym_explicit] = ACTIONS(5953),
    [anon_sym_typename] = ACTIONS(5953),
    [anon_sym_template] = ACTIONS(5953),
    [anon_sym_operator] = ACTIONS(5953),
    [anon_sym_friend] = ACTIONS(5953),
    [anon_sym_using] = ACTIONS(5953),
    [anon_sym_concept] = ACTIONS(5953),
    [anon_sym_requires] = ACTIONS(5953),
    [anon_sym_precise] = ACTIONS(5953),
    [anon_sym_shared] = ACTIONS(5953),
    [anon_sym_groupshared] = ACTIONS(5953),
    [anon_sym_uniform] = ACTIONS(5953),
    [anon_sym_row_major] = ACTIONS(5953),
    [anon_sym_column_major] = ACTIONS(5953),
    [anon_sym_globallycoherent] = ACTIONS(5953),
    [anon_sym_centroid] = ACTIONS(5953),
    [anon_sym_noperspective] = ACTIONS(5953),
    [anon_sym_nointerpolation] = ACTIONS(5953),
    [anon_sym_sample] = ACTIONS(5953),
    [anon_sym_linear] = ACTIONS(5953),
    [anon_sym_snorm] = ACTIONS(5953),
    [anon_sym_unorm] = ACTIONS(5953),
    [anon_sym_point] = ACTIONS(5953),
    [anon_sym_line] = ACTIONS(5953),
    [anon_sym_triangleadj] = ACTIONS(5953),
    [anon_sym_lineadj] = ACTIONS(5953),
    [anon_sym_triangle] = ACTIONS(5953),
    [anon_sym_interface] = ACTIONS(5953),
    [anon_sym_extension] = ACTIONS(5953),
    [anon_sym_where] = ACTIONS(5953),
  },
  [1856] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5989),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1857] = {
    [sym_expression] = STATE(3215),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5957),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1858] = {
    [sym_expression] = STATE(3215),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5959),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1859] = {
    [sym_identifier] = ACTIONS(5961),
    [anon_sym_COMMA] = ACTIONS(5963),
    [anon_sym_RPAREN] = ACTIONS(5963),
    [anon_sym_LPAREN2] = ACTIONS(5963),
    [anon_sym_TILDE] = ACTIONS(5963),
    [anon_sym_STAR] = ACTIONS(5963),
    [anon_sym_PIPE_PIPE] = ACTIONS(5963),
    [anon_sym_AMP_AMP] = ACTIONS(5963),
    [anon_sym_AMP] = ACTIONS(5961),
    [anon_sym___extension__] = ACTIONS(5961),
    [anon_sym_in] = ACTIONS(5961),
    [anon_sym_out] = ACTIONS(5961),
    [anon_sym_inout] = ACTIONS(5961),
    [anon_sym_extern] = ACTIONS(5961),
    [anon_sym___attribute__] = ACTIONS(5961),
    [anon_sym_COLON_COLON] = ACTIONS(5963),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5963),
    [anon_sym___declspec] = ACTIONS(5961),
    [anon_sym___based] = ACTIONS(5961),
    [anon_sym___cdecl] = ACTIONS(5961),
    [anon_sym___clrcall] = ACTIONS(5961),
    [anon_sym___stdcall] = ACTIONS(5961),
    [anon_sym___fastcall] = ACTIONS(5961),
    [anon_sym___thiscall] = ACTIONS(5961),
    [anon_sym___vectorcall] = ACTIONS(5961),
    [anon_sym_signed] = ACTIONS(5961),
    [anon_sym_unsigned] = ACTIONS(5961),
    [anon_sym_long] = ACTIONS(5961),
    [anon_sym_short] = ACTIONS(5961),
    [anon_sym_LBRACK] = ACTIONS(5961),
    [anon_sym_static] = ACTIONS(5961),
    [anon_sym_register] = ACTIONS(5961),
    [anon_sym_inline] = ACTIONS(5961),
    [anon_sym___inline] = ACTIONS(5961),
    [anon_sym___inline__] = ACTIONS(5961),
    [anon_sym___forceinline] = ACTIONS(5961),
    [anon_sym_thread_local] = ACTIONS(5961),
    [anon_sym___thread] = ACTIONS(5961),
    [anon_sym_const] = ACTIONS(5961),
    [anon_sym_constexpr] = ACTIONS(5961),
    [anon_sym_volatile] = ACTIONS(5961),
    [anon_sym_restrict] = ACTIONS(5961),
    [anon_sym___restrict__] = ACTIONS(5961),
    [anon_sym__Atomic] = ACTIONS(5961),
    [anon_sym__Noreturn] = ACTIONS(5961),
    [anon_sym_noreturn] = ACTIONS(5961),
    [anon_sym_mutable] = ACTIONS(5961),
    [anon_sym_constinit] = ACTIONS(5961),
    [anon_sym_consteval] = ACTIONS(5961),
    [anon_sym_alignas] = ACTIONS(5961),
    [anon_sym__Alignas] = ACTIONS(5961),
    [sym_primitive_type] = ACTIONS(5961),
    [anon_sym_enum] = ACTIONS(5961),
    [anon_sym_class] = ACTIONS(5961),
    [anon_sym_struct] = ACTIONS(5961),
    [anon_sym_union] = ACTIONS(5961),
    [anon_sym_or] = ACTIONS(5961),
    [anon_sym_and] = ACTIONS(5961),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5961),
    [anon_sym_let] = ACTIONS(5961),
    [anon_sym_This] = ACTIONS(5961),
    [anon_sym_decltype] = ACTIONS(5961),
    [anon_sym_final] = ACTIONS(5961),
    [anon_sym_override] = ACTIONS(5961),
    [sym_virtual] = ACTIONS(5961),
    [anon_sym_explicit] = ACTIONS(5961),
    [anon_sym_typename] = ACTIONS(5961),
    [anon_sym_template] = ACTIONS(5961),
    [anon_sym_operator] = ACTIONS(5961),
    [anon_sym_friend] = ACTIONS(5961),
    [anon_sym_using] = ACTIONS(5961),
    [anon_sym_concept] = ACTIONS(5961),
    [anon_sym_requires] = ACTIONS(5961),
    [anon_sym_precise] = ACTIONS(5961),
    [anon_sym_shared] = ACTIONS(5961),
    [anon_sym_groupshared] = ACTIONS(5961),
    [anon_sym_uniform] = ACTIONS(5961),
    [anon_sym_row_major] = ACTIONS(5961),
    [anon_sym_column_major] = ACTIONS(5961),
    [anon_sym_globallycoherent] = ACTIONS(5961),
    [anon_sym_centroid] = ACTIONS(5961),
    [anon_sym_noperspective] = ACTIONS(5961),
    [anon_sym_nointerpolation] = ACTIONS(5961),
    [anon_sym_sample] = ACTIONS(5961),
    [anon_sym_linear] = ACTIONS(5961),
    [anon_sym_snorm] = ACTIONS(5961),
    [anon_sym_unorm] = ACTIONS(5961),
    [anon_sym_point] = ACTIONS(5961),
    [anon_sym_line] = ACTIONS(5961),
    [anon_sym_triangleadj] = ACTIONS(5961),
    [anon_sym_lineadj] = ACTIONS(5961),
    [anon_sym_triangle] = ACTIONS(5961),
    [anon_sym_interface] = ACTIONS(5961),
    [anon_sym_extension] = ACTIONS(5961),
    [anon_sym_where] = ACTIONS(5961),
  },
  [1860] = {
    [sym_expression] = STATE(3215),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5965),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1861] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6011),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1862] = {
    [sym_expression] = STATE(3215),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5967),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1863] = {
    [sym_identifier] = ACTIONS(2842),
    [aux_sym_preproc_def_token1] = ACTIONS(2842),
    [aux_sym_preproc_if_token1] = ACTIONS(2842),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2842),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2842),
    [sym_preproc_directive] = ACTIONS(2842),
    [anon_sym_LPAREN2] = ACTIONS(2844),
    [anon_sym_TILDE] = ACTIONS(2844),
    [anon_sym_STAR] = ACTIONS(2844),
    [anon_sym_AMP_AMP] = ACTIONS(2844),
    [anon_sym_AMP] = ACTIONS(2842),
    [anon_sym___extension__] = ACTIONS(2842),
    [anon_sym_typedef] = ACTIONS(2842),
    [anon_sym_in] = ACTIONS(2842),
    [anon_sym_out] = ACTIONS(2842),
    [anon_sym_inout] = ACTIONS(2842),
    [anon_sym_extern] = ACTIONS(2842),
    [anon_sym___attribute__] = ACTIONS(2842),
    [anon_sym_COLON_COLON] = ACTIONS(2844),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2844),
    [anon_sym___declspec] = ACTIONS(2842),
    [anon_sym___based] = ACTIONS(2842),
    [anon_sym_RBRACE] = ACTIONS(2844),
    [anon_sym_signed] = ACTIONS(2842),
    [anon_sym_unsigned] = ACTIONS(2842),
    [anon_sym_long] = ACTIONS(2842),
    [anon_sym_short] = ACTIONS(2842),
    [anon_sym_LBRACK] = ACTIONS(2842),
    [anon_sym_static] = ACTIONS(2842),
    [anon_sym_register] = ACTIONS(2842),
    [anon_sym_inline] = ACTIONS(2842),
    [anon_sym___inline] = ACTIONS(2842),
    [anon_sym___inline__] = ACTIONS(2842),
    [anon_sym___forceinline] = ACTIONS(2842),
    [anon_sym_thread_local] = ACTIONS(2842),
    [anon_sym___thread] = ACTIONS(2842),
    [anon_sym_const] = ACTIONS(2842),
    [anon_sym_constexpr] = ACTIONS(2842),
    [anon_sym_volatile] = ACTIONS(2842),
    [anon_sym_restrict] = ACTIONS(2842),
    [anon_sym___restrict__] = ACTIONS(2842),
    [anon_sym__Atomic] = ACTIONS(2842),
    [anon_sym__Noreturn] = ACTIONS(2842),
    [anon_sym_noreturn] = ACTIONS(2842),
    [anon_sym_mutable] = ACTIONS(2842),
    [anon_sym_constinit] = ACTIONS(2842),
    [anon_sym_consteval] = ACTIONS(2842),
    [anon_sym_alignas] = ACTIONS(2842),
    [anon_sym__Alignas] = ACTIONS(2842),
    [sym_primitive_type] = ACTIONS(2842),
    [anon_sym_enum] = ACTIONS(2842),
    [anon_sym_class] = ACTIONS(2842),
    [anon_sym_struct] = ACTIONS(2842),
    [anon_sym_union] = ACTIONS(2842),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2842),
    [anon_sym_let] = ACTIONS(2842),
    [anon_sym_This] = ACTIONS(2842),
    [anon_sym_decltype] = ACTIONS(2842),
    [sym_virtual] = ACTIONS(2842),
    [anon_sym_explicit] = ACTIONS(2842),
    [anon_sym_typename] = ACTIONS(2842),
    [anon_sym_template] = ACTIONS(2842),
    [anon_sym_operator] = ACTIONS(2842),
    [anon_sym_friend] = ACTIONS(2842),
    [anon_sym_public] = ACTIONS(2842),
    [anon_sym_private] = ACTIONS(2842),
    [anon_sym_protected] = ACTIONS(2842),
    [anon_sym_using] = ACTIONS(2842),
    [anon_sym_static_assert] = ACTIONS(2842),
    [anon_sym_catch] = ACTIONS(2842),
    [anon_sym_precise] = ACTIONS(2842),
    [anon_sym_shared] = ACTIONS(2842),
    [anon_sym_groupshared] = ACTIONS(2842),
    [anon_sym_uniform] = ACTIONS(2842),
    [anon_sym_row_major] = ACTIONS(2842),
    [anon_sym_column_major] = ACTIONS(2842),
    [anon_sym_globallycoherent] = ACTIONS(2842),
    [anon_sym_centroid] = ACTIONS(2842),
    [anon_sym_noperspective] = ACTIONS(2842),
    [anon_sym_nointerpolation] = ACTIONS(2842),
    [anon_sym_sample] = ACTIONS(2842),
    [anon_sym_linear] = ACTIONS(2842),
    [anon_sym_snorm] = ACTIONS(2842),
    [anon_sym_unorm] = ACTIONS(2842),
    [anon_sym_point] = ACTIONS(2842),
    [anon_sym_line] = ACTIONS(2842),
    [anon_sym_triangleadj] = ACTIONS(2842),
    [anon_sym_lineadj] = ACTIONS(2842),
    [anon_sym_triangle] = ACTIONS(2842),
    [anon_sym_interface] = ACTIONS(2842),
    [anon_sym_extension] = ACTIONS(2842),
    [anon_sym___init] = ACTIONS(2842),
    [anon_sym___subscript] = ACTIONS(2842),
    [anon_sym_property] = ACTIONS(2842),
    [anon_sym_associatedtype] = ACTIONS(2842),
  },
  [1864] = {
    [sym_expression] = STATE(3215),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5969),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1865] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5899),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1866] = {
    [sym_expression] = STATE(5211),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_SEMI] = ACTIONS(5971),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACK] = ACTIONS(5881),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4958),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4964),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1867] = {
    [sym_identifier] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_LPAREN2] = ACTIONS(5860),
    [anon_sym_TILDE] = ACTIONS(5860),
    [anon_sym_STAR] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym___extension__] = ACTIONS(5858),
    [anon_sym_in] = ACTIONS(5858),
    [anon_sym_out] = ACTIONS(5858),
    [anon_sym_inout] = ACTIONS(5858),
    [anon_sym_extern] = ACTIONS(5858),
    [anon_sym___attribute__] = ACTIONS(5858),
    [anon_sym_COLON_COLON] = ACTIONS(5860),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5860),
    [anon_sym___declspec] = ACTIONS(5858),
    [anon_sym___based] = ACTIONS(5858),
    [anon_sym___cdecl] = ACTIONS(5858),
    [anon_sym___clrcall] = ACTIONS(5858),
    [anon_sym___stdcall] = ACTIONS(5858),
    [anon_sym___fastcall] = ACTIONS(5858),
    [anon_sym___thiscall] = ACTIONS(5858),
    [anon_sym___vectorcall] = ACTIONS(5858),
    [anon_sym_signed] = ACTIONS(5858),
    [anon_sym_unsigned] = ACTIONS(5858),
    [anon_sym_long] = ACTIONS(5858),
    [anon_sym_short] = ACTIONS(5858),
    [anon_sym_LBRACK] = ACTIONS(5858),
    [anon_sym_static] = ACTIONS(5858),
    [anon_sym_register] = ACTIONS(5858),
    [anon_sym_inline] = ACTIONS(5858),
    [anon_sym___inline] = ACTIONS(5858),
    [anon_sym___inline__] = ACTIONS(5858),
    [anon_sym___forceinline] = ACTIONS(5858),
    [anon_sym_thread_local] = ACTIONS(5858),
    [anon_sym___thread] = ACTIONS(5858),
    [anon_sym_const] = ACTIONS(5858),
    [anon_sym_constexpr] = ACTIONS(5858),
    [anon_sym_volatile] = ACTIONS(5858),
    [anon_sym_restrict] = ACTIONS(5858),
    [anon_sym___restrict__] = ACTIONS(5858),
    [anon_sym__Atomic] = ACTIONS(5858),
    [anon_sym__Noreturn] = ACTIONS(5858),
    [anon_sym_noreturn] = ACTIONS(5858),
    [anon_sym_mutable] = ACTIONS(5858),
    [anon_sym_constinit] = ACTIONS(5858),
    [anon_sym_consteval] = ACTIONS(5858),
    [anon_sym_alignas] = ACTIONS(5858),
    [anon_sym__Alignas] = ACTIONS(5858),
    [sym_primitive_type] = ACTIONS(5858),
    [anon_sym_enum] = ACTIONS(5858),
    [anon_sym_class] = ACTIONS(5858),
    [anon_sym_struct] = ACTIONS(5858),
    [anon_sym_union] = ACTIONS(5858),
    [anon_sym_or] = ACTIONS(5858),
    [anon_sym_and] = ACTIONS(5858),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5858),
    [anon_sym_let] = ACTIONS(5858),
    [anon_sym_This] = ACTIONS(5858),
    [anon_sym_decltype] = ACTIONS(5858),
    [anon_sym_final] = ACTIONS(5858),
    [anon_sym_override] = ACTIONS(5858),
    [sym_virtual] = ACTIONS(5858),
    [anon_sym_explicit] = ACTIONS(5858),
    [anon_sym_typename] = ACTIONS(5858),
    [anon_sym_template] = ACTIONS(5858),
    [anon_sym_operator] = ACTIONS(5858),
    [anon_sym_friend] = ACTIONS(5858),
    [anon_sym_using] = ACTIONS(5858),
    [anon_sym_concept] = ACTIONS(5858),
    [anon_sym_requires] = ACTIONS(5858),
    [anon_sym_precise] = ACTIONS(5858),
    [anon_sym_shared] = ACTIONS(5858),
    [anon_sym_groupshared] = ACTIONS(5858),
    [anon_sym_uniform] = ACTIONS(5858),
    [anon_sym_row_major] = ACTIONS(5858),
    [anon_sym_column_major] = ACTIONS(5858),
    [anon_sym_globallycoherent] = ACTIONS(5858),
    [anon_sym_centroid] = ACTIONS(5858),
    [anon_sym_noperspective] = ACTIONS(5858),
    [anon_sym_nointerpolation] = ACTIONS(5858),
    [anon_sym_sample] = ACTIONS(5858),
    [anon_sym_linear] = ACTIONS(5858),
    [anon_sym_snorm] = ACTIONS(5858),
    [anon_sym_unorm] = ACTIONS(5858),
    [anon_sym_point] = ACTIONS(5858),
    [anon_sym_line] = ACTIONS(5858),
    [anon_sym_triangleadj] = ACTIONS(5858),
    [anon_sym_lineadj] = ACTIONS(5858),
    [anon_sym_triangle] = ACTIONS(5858),
    [anon_sym_interface] = ACTIONS(5858),
    [anon_sym_extension] = ACTIONS(5858),
    [anon_sym_where] = ACTIONS(5858),
  },
  [1868] = {
    [sym_expression] = STATE(4437),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5973),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1869] = {
    [sym_expression] = STATE(4434),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5844),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1870] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5908),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1871] = {
    [sym_expression] = STATE(4432),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5883),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1872] = {
    [sym_expression] = STATE(4424),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5902),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1873] = {
    [sym_expression] = STATE(4554),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5905),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1874] = {
    [sym_expression] = STATE(4421),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5922),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1875] = {
    [sym_expression] = STATE(4561),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5976),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1876] = {
    [sym_expression] = STATE(5551),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(5979),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1877] = {
    [sym_expression] = STATE(4561),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5981),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1878] = {
    [sym_expression] = STATE(4451),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5984),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1879] = {
    [sym_expression] = STATE(4451),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5987),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1880] = {
    [sym_expression] = STATE(4451),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5990),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1881] = {
    [sym_expression] = STATE(3215),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5993),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1882] = {
    [sym_expression] = STATE(3215),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(5995),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1883] = {
    [sym_expression] = STATE(4451),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5849),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1884] = {
    [sym_expression] = STATE(4437),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5862),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1885] = {
    [sym_expression] = STATE(4437),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5997),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1886] = {
    [sym_expression] = STATE(4434),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6000),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1887] = {
    [sym_expression] = STATE(4432),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6003),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1888] = {
    [sym_expression] = STATE(4533),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6006),
    [anon_sym_LPAREN2] = ACTIONS(6008),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1889] = {
    [sym_expression] = STATE(4424),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6010),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1890] = {
    [sym_expression] = STATE(3215),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(6013),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1891] = {
    [sym_expression] = STATE(4554),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6015),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1892] = {
    [sym_expression] = STATE(4421),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6018),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1893] = {
    [sym_expression] = STATE(4418),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6021),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1894] = {
    [sym_expression] = STATE(4069),
    [sym__string] = STATE(4545),
    [sym_conditional_expression] = STATE(4545),
    [sym_assignment_expression] = STATE(4545),
    [sym_pointer_expression] = STATE(4540),
    [sym_unary_expression] = STATE(4545),
    [sym_binary_expression] = STATE(4545),
    [sym_update_expression] = STATE(4545),
    [sym_cast_expression] = STATE(4545),
    [sym_sizeof_expression] = STATE(4545),
    [sym_alignof_expression] = STATE(4545),
    [sym_offsetof_expression] = STATE(4545),
    [sym_generic_expression] = STATE(4545),
    [sym_subscript_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_gnu_asm_expression] = STATE(4545),
    [sym_field_expression] = STATE(4540),
    [sym_compound_literal_expression] = STATE(4545),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_char_literal] = STATE(4286),
    [sym_concatenated_string] = STATE(4290),
    [sym_string_literal] = STATE(3166),
    [sym_null] = STATE(4545),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9673),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4545),
    [sym_raw_string_literal] = STATE(3169),
    [sym_co_await_expression] = STATE(4545),
    [sym_new_expression] = STATE(4545),
    [sym_delete_expression] = STATE(4545),
    [sym_requires_clause] = STATE(4545),
    [sym_requires_expression] = STATE(4545),
    [sym_lambda_expression] = STATE(4545),
    [sym_lambda_capture_specifier] = STATE(7034),
    [sym_fold_expression] = STATE(4545),
    [sym_parameter_pack_expansion] = STATE(4545),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4540),
    [sym_qualified_type_identifier] = STATE(9673),
    [sym_user_defined_literal] = STATE(4540),
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6024),
    [anon_sym_LPAREN2] = ACTIONS(6026),
    [anon_sym_BANG] = ACTIONS(4733),
    [anon_sym_TILDE] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4731),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4735),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4739),
    [anon_sym_not] = ACTIONS(4731),
    [anon_sym_compl] = ACTIONS(4731),
    [anon_sym_DASH_DASH] = ACTIONS(5711),
    [anon_sym_PLUS_PLUS] = ACTIONS(5711),
    [anon_sym_sizeof] = ACTIONS(4741),
    [anon_sym___alignof__] = ACTIONS(4743),
    [anon_sym___alignof] = ACTIONS(4743),
    [anon_sym__alignof] = ACTIONS(4743),
    [anon_sym_alignof] = ACTIONS(4743),
    [anon_sym__Alignof] = ACTIONS(4743),
    [anon_sym_offsetof] = ACTIONS(4745),
    [anon_sym__Generic] = ACTIONS(4747),
    [anon_sym_asm] = ACTIONS(4749),
    [anon_sym___asm__] = ACTIONS(4749),
    [sym_number_literal] = ACTIONS(4751),
    [anon_sym_L_SQUOTE] = ACTIONS(4753),
    [anon_sym_u_SQUOTE] = ACTIONS(4753),
    [anon_sym_U_SQUOTE] = ACTIONS(4753),
    [anon_sym_u8_SQUOTE] = ACTIONS(4753),
    [anon_sym_SQUOTE] = ACTIONS(4753),
    [anon_sym_L_DQUOTE] = ACTIONS(4755),
    [anon_sym_u_DQUOTE] = ACTIONS(4755),
    [anon_sym_U_DQUOTE] = ACTIONS(4755),
    [anon_sym_u8_DQUOTE] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [anon_sym_NULL] = ACTIONS(4759),
    [anon_sym_nullptr] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4761),
    [anon_sym_R_DQUOTE] = ACTIONS(4763),
    [anon_sym_LR_DQUOTE] = ACTIONS(4763),
    [anon_sym_uR_DQUOTE] = ACTIONS(4763),
    [anon_sym_UR_DQUOTE] = ACTIONS(4763),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4763),
    [anon_sym_co_await] = ACTIONS(4765),
    [anon_sym_new] = ACTIONS(4767),
    [anon_sym_requires] = ACTIONS(4769),
    [sym_this] = ACTIONS(4757),
  },
  [1895] = {
    [sym_expression] = STATE(3726),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6028),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1896] = {
    [sym_expression] = STATE(4418),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6031),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1897] = {
    [sym_expression] = STATE(4418),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6034),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1898] = {
    [sym_expression] = STATE(4499),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6037),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1899] = {
    [sym_expression] = STATE(4499),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6028),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [1900] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5874),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1901] = {
    [sym_expression] = STATE(3726),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6037),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1902] = {
    [sym_expression] = STATE(5556),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(6040),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1903] = {
    [sym_expression] = STATE(3734),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6034),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1904] = {
    [sym_expression] = STATE(3734),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6031),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1905] = {
    [sym_expression] = STATE(4676),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4905),
    [sym_concatenated_string] = STATE(4902),
    [sym_string_literal] = STATE(3611),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3610),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(5705),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5912),
    [anon_sym_LPAREN2] = ACTIONS(6042),
    [anon_sym_BANG] = ACTIONS(4926),
    [anon_sym_TILDE] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4928),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4924),
    [anon_sym_compl] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(5707),
    [anon_sym_PLUS_PLUS] = ACTIONS(5707),
    [anon_sym_sizeof] = ACTIONS(4932),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4934),
    [anon_sym_L_SQUOTE] = ACTIONS(4936),
    [anon_sym_u_SQUOTE] = ACTIONS(4936),
    [anon_sym_U_SQUOTE] = ACTIONS(4936),
    [anon_sym_u8_SQUOTE] = ACTIONS(4936),
    [anon_sym_SQUOTE] = ACTIONS(4936),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4938),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_co_await] = ACTIONS(4940),
    [anon_sym_new] = ACTIONS(4942),
    [anon_sym_requires] = ACTIONS(4944),
    [sym_this] = ACTIONS(241),
  },
  [1906] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5930),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1907] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5910),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1908] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5925),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1909] = {
    [sym_identifier] = ACTIONS(6044),
    [anon_sym_COMMA] = ACTIONS(6046),
    [anon_sym_RPAREN] = ACTIONS(6046),
    [anon_sym_LPAREN2] = ACTIONS(6046),
    [anon_sym_TILDE] = ACTIONS(6046),
    [anon_sym_STAR] = ACTIONS(6046),
    [anon_sym_PIPE_PIPE] = ACTIONS(6046),
    [anon_sym_AMP_AMP] = ACTIONS(6046),
    [anon_sym_AMP] = ACTIONS(6044),
    [anon_sym___extension__] = ACTIONS(6044),
    [anon_sym_in] = ACTIONS(6044),
    [anon_sym_out] = ACTIONS(6044),
    [anon_sym_inout] = ACTIONS(6044),
    [anon_sym_extern] = ACTIONS(6044),
    [anon_sym___attribute__] = ACTIONS(6044),
    [anon_sym_COLON_COLON] = ACTIONS(6046),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6046),
    [anon_sym___declspec] = ACTIONS(6044),
    [anon_sym___based] = ACTIONS(6044),
    [anon_sym___cdecl] = ACTIONS(6044),
    [anon_sym___clrcall] = ACTIONS(6044),
    [anon_sym___stdcall] = ACTIONS(6044),
    [anon_sym___fastcall] = ACTIONS(6044),
    [anon_sym___thiscall] = ACTIONS(6044),
    [anon_sym___vectorcall] = ACTIONS(6044),
    [anon_sym_signed] = ACTIONS(6044),
    [anon_sym_unsigned] = ACTIONS(6044),
    [anon_sym_long] = ACTIONS(6044),
    [anon_sym_short] = ACTIONS(6044),
    [anon_sym_LBRACK] = ACTIONS(6044),
    [anon_sym_static] = ACTIONS(6044),
    [anon_sym_register] = ACTIONS(6044),
    [anon_sym_inline] = ACTIONS(6044),
    [anon_sym___inline] = ACTIONS(6044),
    [anon_sym___inline__] = ACTIONS(6044),
    [anon_sym___forceinline] = ACTIONS(6044),
    [anon_sym_thread_local] = ACTIONS(6044),
    [anon_sym___thread] = ACTIONS(6044),
    [anon_sym_const] = ACTIONS(6044),
    [anon_sym_constexpr] = ACTIONS(6044),
    [anon_sym_volatile] = ACTIONS(6044),
    [anon_sym_restrict] = ACTIONS(6044),
    [anon_sym___restrict__] = ACTIONS(6044),
    [anon_sym__Atomic] = ACTIONS(6044),
    [anon_sym__Noreturn] = ACTIONS(6044),
    [anon_sym_noreturn] = ACTIONS(6044),
    [anon_sym_mutable] = ACTIONS(6044),
    [anon_sym_constinit] = ACTIONS(6044),
    [anon_sym_consteval] = ACTIONS(6044),
    [anon_sym_alignas] = ACTIONS(6044),
    [anon_sym__Alignas] = ACTIONS(6044),
    [sym_primitive_type] = ACTIONS(6044),
    [anon_sym_enum] = ACTIONS(6044),
    [anon_sym_class] = ACTIONS(6044),
    [anon_sym_struct] = ACTIONS(6044),
    [anon_sym_union] = ACTIONS(6044),
    [anon_sym_or] = ACTIONS(6044),
    [anon_sym_and] = ACTIONS(6044),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6044),
    [anon_sym_let] = ACTIONS(6044),
    [anon_sym_This] = ACTIONS(6044),
    [anon_sym_decltype] = ACTIONS(6044),
    [anon_sym_final] = ACTIONS(6044),
    [anon_sym_override] = ACTIONS(6044),
    [sym_virtual] = ACTIONS(6044),
    [anon_sym_explicit] = ACTIONS(6044),
    [anon_sym_typename] = ACTIONS(6044),
    [anon_sym_template] = ACTIONS(6044),
    [anon_sym_operator] = ACTIONS(6044),
    [anon_sym_friend] = ACTIONS(6044),
    [anon_sym_using] = ACTIONS(6044),
    [anon_sym_concept] = ACTIONS(6044),
    [anon_sym_requires] = ACTIONS(6044),
    [anon_sym_precise] = ACTIONS(6044),
    [anon_sym_shared] = ACTIONS(6044),
    [anon_sym_groupshared] = ACTIONS(6044),
    [anon_sym_uniform] = ACTIONS(6044),
    [anon_sym_row_major] = ACTIONS(6044),
    [anon_sym_column_major] = ACTIONS(6044),
    [anon_sym_globallycoherent] = ACTIONS(6044),
    [anon_sym_centroid] = ACTIONS(6044),
    [anon_sym_noperspective] = ACTIONS(6044),
    [anon_sym_nointerpolation] = ACTIONS(6044),
    [anon_sym_sample] = ACTIONS(6044),
    [anon_sym_linear] = ACTIONS(6044),
    [anon_sym_snorm] = ACTIONS(6044),
    [anon_sym_unorm] = ACTIONS(6044),
    [anon_sym_point] = ACTIONS(6044),
    [anon_sym_line] = ACTIONS(6044),
    [anon_sym_triangleadj] = ACTIONS(6044),
    [anon_sym_lineadj] = ACTIONS(6044),
    [anon_sym_triangle] = ACTIONS(6044),
    [anon_sym_interface] = ACTIONS(6044),
    [anon_sym_extension] = ACTIONS(6044),
    [anon_sym_where] = ACTIONS(6044),
  },
  [1910] = {
    [sym_expression] = STATE(3215),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(6048),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1911] = {
    [sym_expression] = STATE(3734),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6021),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1912] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5935),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1913] = {
    [sym_expression] = STATE(5196),
    [sym__string] = STATE(4704),
    [sym_comma_expression] = STATE(9278),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1914] = {
    [sym_expression] = STATE(3215),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(6050),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1915] = {
    [sym_expression] = STATE(3738),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6018),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1916] = {
    [sym_expression] = STATE(3215),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(6052),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1917] = {
    [sym_expression] = STATE(3741),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6015),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1918] = {
    [sym_expression] = STATE(3742),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6010),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1919] = {
    [sym_expression] = STATE(5211),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_SEMI] = ACTIONS(6054),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACK] = ACTIONS(5881),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4958),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4964),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1920] = {
    [sym_identifier] = ACTIONS(6056),
    [anon_sym_COMMA] = ACTIONS(6058),
    [anon_sym_RPAREN] = ACTIONS(6058),
    [anon_sym_LPAREN2] = ACTIONS(6058),
    [anon_sym_TILDE] = ACTIONS(6058),
    [anon_sym_STAR] = ACTIONS(6058),
    [anon_sym_PIPE_PIPE] = ACTIONS(6058),
    [anon_sym_AMP_AMP] = ACTIONS(6058),
    [anon_sym_AMP] = ACTIONS(6056),
    [anon_sym___extension__] = ACTIONS(6056),
    [anon_sym_in] = ACTIONS(6056),
    [anon_sym_out] = ACTIONS(6056),
    [anon_sym_inout] = ACTIONS(6056),
    [anon_sym_extern] = ACTIONS(6056),
    [anon_sym___attribute__] = ACTIONS(6056),
    [anon_sym_COLON_COLON] = ACTIONS(6058),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6058),
    [anon_sym___declspec] = ACTIONS(6056),
    [anon_sym___based] = ACTIONS(6056),
    [anon_sym___cdecl] = ACTIONS(6056),
    [anon_sym___clrcall] = ACTIONS(6056),
    [anon_sym___stdcall] = ACTIONS(6056),
    [anon_sym___fastcall] = ACTIONS(6056),
    [anon_sym___thiscall] = ACTIONS(6056),
    [anon_sym___vectorcall] = ACTIONS(6056),
    [anon_sym_signed] = ACTIONS(6056),
    [anon_sym_unsigned] = ACTIONS(6056),
    [anon_sym_long] = ACTIONS(6056),
    [anon_sym_short] = ACTIONS(6056),
    [anon_sym_LBRACK] = ACTIONS(6056),
    [anon_sym_static] = ACTIONS(6056),
    [anon_sym_register] = ACTIONS(6056),
    [anon_sym_inline] = ACTIONS(6056),
    [anon_sym___inline] = ACTIONS(6056),
    [anon_sym___inline__] = ACTIONS(6056),
    [anon_sym___forceinline] = ACTIONS(6056),
    [anon_sym_thread_local] = ACTIONS(6056),
    [anon_sym___thread] = ACTIONS(6056),
    [anon_sym_const] = ACTIONS(6056),
    [anon_sym_constexpr] = ACTIONS(6056),
    [anon_sym_volatile] = ACTIONS(6056),
    [anon_sym_restrict] = ACTIONS(6056),
    [anon_sym___restrict__] = ACTIONS(6056),
    [anon_sym__Atomic] = ACTIONS(6056),
    [anon_sym__Noreturn] = ACTIONS(6056),
    [anon_sym_noreturn] = ACTIONS(6056),
    [anon_sym_mutable] = ACTIONS(6056),
    [anon_sym_constinit] = ACTIONS(6056),
    [anon_sym_consteval] = ACTIONS(6056),
    [anon_sym_alignas] = ACTIONS(6056),
    [anon_sym__Alignas] = ACTIONS(6056),
    [sym_primitive_type] = ACTIONS(6056),
    [anon_sym_enum] = ACTIONS(6056),
    [anon_sym_class] = ACTIONS(6056),
    [anon_sym_struct] = ACTIONS(6056),
    [anon_sym_union] = ACTIONS(6056),
    [anon_sym_or] = ACTIONS(6056),
    [anon_sym_and] = ACTIONS(6056),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6056),
    [anon_sym_let] = ACTIONS(6056),
    [anon_sym_This] = ACTIONS(6056),
    [anon_sym_decltype] = ACTIONS(6056),
    [anon_sym_final] = ACTIONS(6056),
    [anon_sym_override] = ACTIONS(6056),
    [sym_virtual] = ACTIONS(6056),
    [anon_sym_explicit] = ACTIONS(6056),
    [anon_sym_typename] = ACTIONS(6056),
    [anon_sym_template] = ACTIONS(6056),
    [anon_sym_operator] = ACTIONS(6056),
    [anon_sym_friend] = ACTIONS(6056),
    [anon_sym_using] = ACTIONS(6056),
    [anon_sym_concept] = ACTIONS(6056),
    [anon_sym_requires] = ACTIONS(6056),
    [anon_sym_precise] = ACTIONS(6056),
    [anon_sym_shared] = ACTIONS(6056),
    [anon_sym_groupshared] = ACTIONS(6056),
    [anon_sym_uniform] = ACTIONS(6056),
    [anon_sym_row_major] = ACTIONS(6056),
    [anon_sym_column_major] = ACTIONS(6056),
    [anon_sym_globallycoherent] = ACTIONS(6056),
    [anon_sym_centroid] = ACTIONS(6056),
    [anon_sym_noperspective] = ACTIONS(6056),
    [anon_sym_nointerpolation] = ACTIONS(6056),
    [anon_sym_sample] = ACTIONS(6056),
    [anon_sym_linear] = ACTIONS(6056),
    [anon_sym_snorm] = ACTIONS(6056),
    [anon_sym_unorm] = ACTIONS(6056),
    [anon_sym_point] = ACTIONS(6056),
    [anon_sym_line] = ACTIONS(6056),
    [anon_sym_triangleadj] = ACTIONS(6056),
    [anon_sym_lineadj] = ACTIONS(6056),
    [anon_sym_triangle] = ACTIONS(6056),
    [anon_sym_interface] = ACTIONS(6056),
    [anon_sym_extension] = ACTIONS(6056),
    [anon_sym_where] = ACTIONS(6056),
  },
  [1921] = {
    [sym_identifier] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6062),
    [anon_sym_RPAREN] = ACTIONS(6062),
    [anon_sym_LPAREN2] = ACTIONS(6062),
    [anon_sym_TILDE] = ACTIONS(6062),
    [anon_sym_STAR] = ACTIONS(6062),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6060),
    [anon_sym___extension__] = ACTIONS(6060),
    [anon_sym_in] = ACTIONS(6060),
    [anon_sym_out] = ACTIONS(6060),
    [anon_sym_inout] = ACTIONS(6060),
    [anon_sym_extern] = ACTIONS(6060),
    [anon_sym___attribute__] = ACTIONS(6060),
    [anon_sym_COLON_COLON] = ACTIONS(6062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6062),
    [anon_sym___declspec] = ACTIONS(6060),
    [anon_sym___based] = ACTIONS(6060),
    [anon_sym___cdecl] = ACTIONS(6060),
    [anon_sym___clrcall] = ACTIONS(6060),
    [anon_sym___stdcall] = ACTIONS(6060),
    [anon_sym___fastcall] = ACTIONS(6060),
    [anon_sym___thiscall] = ACTIONS(6060),
    [anon_sym___vectorcall] = ACTIONS(6060),
    [anon_sym_signed] = ACTIONS(6060),
    [anon_sym_unsigned] = ACTIONS(6060),
    [anon_sym_long] = ACTIONS(6060),
    [anon_sym_short] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_static] = ACTIONS(6060),
    [anon_sym_register] = ACTIONS(6060),
    [anon_sym_inline] = ACTIONS(6060),
    [anon_sym___inline] = ACTIONS(6060),
    [anon_sym___inline__] = ACTIONS(6060),
    [anon_sym___forceinline] = ACTIONS(6060),
    [anon_sym_thread_local] = ACTIONS(6060),
    [anon_sym___thread] = ACTIONS(6060),
    [anon_sym_const] = ACTIONS(6060),
    [anon_sym_constexpr] = ACTIONS(6060),
    [anon_sym_volatile] = ACTIONS(6060),
    [anon_sym_restrict] = ACTIONS(6060),
    [anon_sym___restrict__] = ACTIONS(6060),
    [anon_sym__Atomic] = ACTIONS(6060),
    [anon_sym__Noreturn] = ACTIONS(6060),
    [anon_sym_noreturn] = ACTIONS(6060),
    [anon_sym_mutable] = ACTIONS(6060),
    [anon_sym_constinit] = ACTIONS(6060),
    [anon_sym_consteval] = ACTIONS(6060),
    [anon_sym_alignas] = ACTIONS(6060),
    [anon_sym__Alignas] = ACTIONS(6060),
    [sym_primitive_type] = ACTIONS(6060),
    [anon_sym_enum] = ACTIONS(6060),
    [anon_sym_class] = ACTIONS(6060),
    [anon_sym_struct] = ACTIONS(6060),
    [anon_sym_union] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6060),
    [anon_sym_let] = ACTIONS(6060),
    [anon_sym_This] = ACTIONS(6060),
    [anon_sym_decltype] = ACTIONS(6060),
    [anon_sym_final] = ACTIONS(6060),
    [anon_sym_override] = ACTIONS(6060),
    [sym_virtual] = ACTIONS(6060),
    [anon_sym_explicit] = ACTIONS(6060),
    [anon_sym_typename] = ACTIONS(6060),
    [anon_sym_template] = ACTIONS(6060),
    [anon_sym_operator] = ACTIONS(6060),
    [anon_sym_friend] = ACTIONS(6060),
    [anon_sym_using] = ACTIONS(6060),
    [anon_sym_concept] = ACTIONS(6060),
    [anon_sym_requires] = ACTIONS(6060),
    [anon_sym_precise] = ACTIONS(6060),
    [anon_sym_shared] = ACTIONS(6060),
    [anon_sym_groupshared] = ACTIONS(6060),
    [anon_sym_uniform] = ACTIONS(6060),
    [anon_sym_row_major] = ACTIONS(6060),
    [anon_sym_column_major] = ACTIONS(6060),
    [anon_sym_globallycoherent] = ACTIONS(6060),
    [anon_sym_centroid] = ACTIONS(6060),
    [anon_sym_noperspective] = ACTIONS(6060),
    [anon_sym_nointerpolation] = ACTIONS(6060),
    [anon_sym_sample] = ACTIONS(6060),
    [anon_sym_linear] = ACTIONS(6060),
    [anon_sym_snorm] = ACTIONS(6060),
    [anon_sym_unorm] = ACTIONS(6060),
    [anon_sym_point] = ACTIONS(6060),
    [anon_sym_line] = ACTIONS(6060),
    [anon_sym_triangleadj] = ACTIONS(6060),
    [anon_sym_lineadj] = ACTIONS(6060),
    [anon_sym_triangle] = ACTIONS(6060),
    [anon_sym_interface] = ACTIONS(6060),
    [anon_sym_extension] = ACTIONS(6060),
    [anon_sym_where] = ACTIONS(6060),
  },
  [1922] = {
    [sym_expression] = STATE(4676),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5912),
    [anon_sym_LPAREN2] = ACTIONS(6064),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4958),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4964),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1923] = {
    [sym_expression] = STATE(3215),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(6066),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1924] = {
    [sym_expression] = STATE(3743),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6003),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1925] = {
    [sym_expression] = STATE(5354),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5912),
    [anon_sym_LPAREN2] = ACTIONS(6068),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1926] = {
    [sym_expression] = STATE(3750),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5976),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1927] = {
    [sym_expression] = STATE(3750),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5981),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1928] = {
    [sym_expression] = STATE(3746),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5973),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1929] = {
    [sym_expression] = STATE(3215),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(6070),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1930] = {
    [sym_expression] = STATE(3747),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5984),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1931] = {
    [sym_expression] = STATE(5536),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_RPAREN] = ACTIONS(6072),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1932] = {
    [sym_expression] = STATE(3747),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5990),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1933] = {
    [sym_expression] = STATE(3747),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5987),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1934] = {
    [sym_expression] = STATE(3745),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6000),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1935] = {
    [sym_expression] = STATE(3746),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5997),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1936] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(6385),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1937] = {
    [sym__declaration_modifiers] = STATE(2038),
    [sym__declaration_specifiers] = STATE(5973),
    [sym_attribute_specifier] = STATE(2038),
    [sym_attribute_declaration] = STATE(2038),
    [sym_ms_declspec_modifier] = STATE(2038),
    [sym_storage_class_specifier] = STATE(2038),
    [sym_type_qualifier] = STATE(2038),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2696),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2038),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2038),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(1572),
    [anon_sym_out] = ACTIONS(1572),
    [anon_sym_inout] = ACTIONS(1572),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(1572),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [1938] = {
    [sym_expression] = STATE(4592),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1939] = {
    [sym_expression] = STATE(5259),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [1940] = {
    [sym_expression] = STATE(3700),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1941] = {
    [sym_expression] = STATE(5217),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1942] = {
    [sym_expression] = STATE(5216),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1943] = {
    [sym_expression] = STATE(3818),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5781),
    [anon_sym_BANG] = ACTIONS(4611),
    [anon_sym_TILDE] = ACTIONS(4611),
    [anon_sym_DASH] = ACTIONS(4609),
    [anon_sym_PLUS] = ACTIONS(4609),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4613),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4609),
    [anon_sym_compl] = ACTIONS(4609),
    [anon_sym_DASH_DASH] = ACTIONS(5713),
    [anon_sym_PLUS_PLUS] = ACTIONS(5713),
    [anon_sym_sizeof] = ACTIONS(4615),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4617),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4619),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1944] = {
    [sym_expression] = STATE(5471),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1945] = {
    [sym_expression] = STATE(5269),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [1946] = {
    [sym_identifier] = ACTIONS(3410),
    [aux_sym_preproc_def_token1] = ACTIONS(3410),
    [aux_sym_preproc_if_token1] = ACTIONS(3410),
    [aux_sym_preproc_if_token2] = ACTIONS(3410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3410),
    [sym_preproc_directive] = ACTIONS(3410),
    [anon_sym_LPAREN2] = ACTIONS(3412),
    [anon_sym_TILDE] = ACTIONS(3412),
    [anon_sym_STAR] = ACTIONS(3412),
    [anon_sym_AMP_AMP] = ACTIONS(3412),
    [anon_sym_AMP] = ACTIONS(3410),
    [anon_sym___extension__] = ACTIONS(3410),
    [anon_sym_typedef] = ACTIONS(3410),
    [anon_sym_in] = ACTIONS(3410),
    [anon_sym_out] = ACTIONS(3410),
    [anon_sym_inout] = ACTIONS(3410),
    [anon_sym_extern] = ACTIONS(3410),
    [anon_sym___attribute__] = ACTIONS(3410),
    [anon_sym_COLON_COLON] = ACTIONS(3412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3412),
    [anon_sym___declspec] = ACTIONS(3410),
    [anon_sym___based] = ACTIONS(3410),
    [anon_sym_signed] = ACTIONS(3410),
    [anon_sym_unsigned] = ACTIONS(3410),
    [anon_sym_long] = ACTIONS(3410),
    [anon_sym_short] = ACTIONS(3410),
    [anon_sym_LBRACK] = ACTIONS(3410),
    [anon_sym_static] = ACTIONS(3410),
    [anon_sym_register] = ACTIONS(3410),
    [anon_sym_inline] = ACTIONS(3410),
    [anon_sym___inline] = ACTIONS(3410),
    [anon_sym___inline__] = ACTIONS(3410),
    [anon_sym___forceinline] = ACTIONS(3410),
    [anon_sym_thread_local] = ACTIONS(3410),
    [anon_sym___thread] = ACTIONS(3410),
    [anon_sym_const] = ACTIONS(3410),
    [anon_sym_constexpr] = ACTIONS(3410),
    [anon_sym_volatile] = ACTIONS(3410),
    [anon_sym_restrict] = ACTIONS(3410),
    [anon_sym___restrict__] = ACTIONS(3410),
    [anon_sym__Atomic] = ACTIONS(3410),
    [anon_sym__Noreturn] = ACTIONS(3410),
    [anon_sym_noreturn] = ACTIONS(3410),
    [anon_sym_mutable] = ACTIONS(3410),
    [anon_sym_constinit] = ACTIONS(3410),
    [anon_sym_consteval] = ACTIONS(3410),
    [anon_sym_alignas] = ACTIONS(3410),
    [anon_sym__Alignas] = ACTIONS(3410),
    [sym_primitive_type] = ACTIONS(3410),
    [anon_sym_enum] = ACTIONS(3410),
    [anon_sym_class] = ACTIONS(3410),
    [anon_sym_struct] = ACTIONS(3410),
    [anon_sym_union] = ACTIONS(3410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3410),
    [anon_sym_let] = ACTIONS(3410),
    [anon_sym_This] = ACTIONS(3410),
    [anon_sym_decltype] = ACTIONS(3410),
    [sym_virtual] = ACTIONS(3410),
    [anon_sym_explicit] = ACTIONS(3410),
    [anon_sym_typename] = ACTIONS(3410),
    [anon_sym_template] = ACTIONS(3410),
    [anon_sym_operator] = ACTIONS(3410),
    [anon_sym_friend] = ACTIONS(3410),
    [anon_sym_public] = ACTIONS(3410),
    [anon_sym_private] = ACTIONS(3410),
    [anon_sym_protected] = ACTIONS(3410),
    [anon_sym_using] = ACTIONS(3410),
    [anon_sym_static_assert] = ACTIONS(3410),
    [anon_sym_precise] = ACTIONS(3410),
    [anon_sym_shared] = ACTIONS(3410),
    [anon_sym_groupshared] = ACTIONS(3410),
    [anon_sym_uniform] = ACTIONS(3410),
    [anon_sym_row_major] = ACTIONS(3410),
    [anon_sym_column_major] = ACTIONS(3410),
    [anon_sym_globallycoherent] = ACTIONS(3410),
    [anon_sym_centroid] = ACTIONS(3410),
    [anon_sym_noperspective] = ACTIONS(3410),
    [anon_sym_nointerpolation] = ACTIONS(3410),
    [anon_sym_sample] = ACTIONS(3410),
    [anon_sym_linear] = ACTIONS(3410),
    [anon_sym_snorm] = ACTIONS(3410),
    [anon_sym_unorm] = ACTIONS(3410),
    [anon_sym_point] = ACTIONS(3410),
    [anon_sym_line] = ACTIONS(3410),
    [anon_sym_triangleadj] = ACTIONS(3410),
    [anon_sym_lineadj] = ACTIONS(3410),
    [anon_sym_triangle] = ACTIONS(3410),
    [anon_sym_interface] = ACTIONS(3410),
    [anon_sym_extension] = ACTIONS(3410),
    [anon_sym___init] = ACTIONS(3410),
    [anon_sym___subscript] = ACTIONS(3410),
    [anon_sym_property] = ACTIONS(3410),
    [anon_sym_associatedtype] = ACTIONS(3410),
  },
  [1947] = {
    [sym_expression] = STATE(3813),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5781),
    [anon_sym_BANG] = ACTIONS(4611),
    [anon_sym_TILDE] = ACTIONS(4611),
    [anon_sym_DASH] = ACTIONS(4609),
    [anon_sym_PLUS] = ACTIONS(4609),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4613),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4609),
    [anon_sym_compl] = ACTIONS(4609),
    [anon_sym_DASH_DASH] = ACTIONS(5713),
    [anon_sym_PLUS_PLUS] = ACTIONS(5713),
    [anon_sym_sizeof] = ACTIONS(4615),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4617),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4619),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1948] = {
    [sym_expression] = STATE(3806),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5781),
    [anon_sym_BANG] = ACTIONS(4611),
    [anon_sym_TILDE] = ACTIONS(4611),
    [anon_sym_DASH] = ACTIONS(4609),
    [anon_sym_PLUS] = ACTIONS(4609),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4613),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4609),
    [anon_sym_compl] = ACTIONS(4609),
    [anon_sym_DASH_DASH] = ACTIONS(5713),
    [anon_sym_PLUS_PLUS] = ACTIONS(5713),
    [anon_sym_sizeof] = ACTIONS(4615),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4617),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4619),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1949] = {
    [sym_identifier] = ACTIONS(3410),
    [aux_sym_preproc_def_token1] = ACTIONS(3410),
    [aux_sym_preproc_if_token1] = ACTIONS(3410),
    [aux_sym_preproc_if_token2] = ACTIONS(3410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3410),
    [sym_preproc_directive] = ACTIONS(3410),
    [anon_sym_LPAREN2] = ACTIONS(3412),
    [anon_sym_TILDE] = ACTIONS(3412),
    [anon_sym_STAR] = ACTIONS(3412),
    [anon_sym_AMP_AMP] = ACTIONS(3412),
    [anon_sym_AMP] = ACTIONS(3410),
    [anon_sym___extension__] = ACTIONS(3410),
    [anon_sym_typedef] = ACTIONS(3410),
    [anon_sym_in] = ACTIONS(3410),
    [anon_sym_out] = ACTIONS(3410),
    [anon_sym_inout] = ACTIONS(3410),
    [anon_sym_extern] = ACTIONS(3410),
    [anon_sym___attribute__] = ACTIONS(3410),
    [anon_sym_COLON_COLON] = ACTIONS(3412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3412),
    [anon_sym___declspec] = ACTIONS(3410),
    [anon_sym___based] = ACTIONS(3410),
    [anon_sym_signed] = ACTIONS(3410),
    [anon_sym_unsigned] = ACTIONS(3410),
    [anon_sym_long] = ACTIONS(3410),
    [anon_sym_short] = ACTIONS(3410),
    [anon_sym_LBRACK] = ACTIONS(3410),
    [anon_sym_static] = ACTIONS(3410),
    [anon_sym_register] = ACTIONS(3410),
    [anon_sym_inline] = ACTIONS(3410),
    [anon_sym___inline] = ACTIONS(3410),
    [anon_sym___inline__] = ACTIONS(3410),
    [anon_sym___forceinline] = ACTIONS(3410),
    [anon_sym_thread_local] = ACTIONS(3410),
    [anon_sym___thread] = ACTIONS(3410),
    [anon_sym_const] = ACTIONS(3410),
    [anon_sym_constexpr] = ACTIONS(3410),
    [anon_sym_volatile] = ACTIONS(3410),
    [anon_sym_restrict] = ACTIONS(3410),
    [anon_sym___restrict__] = ACTIONS(3410),
    [anon_sym__Atomic] = ACTIONS(3410),
    [anon_sym__Noreturn] = ACTIONS(3410),
    [anon_sym_noreturn] = ACTIONS(3410),
    [anon_sym_mutable] = ACTIONS(3410),
    [anon_sym_constinit] = ACTIONS(3410),
    [anon_sym_consteval] = ACTIONS(3410),
    [anon_sym_alignas] = ACTIONS(3410),
    [anon_sym__Alignas] = ACTIONS(3410),
    [sym_primitive_type] = ACTIONS(3410),
    [anon_sym_enum] = ACTIONS(3410),
    [anon_sym_class] = ACTIONS(3410),
    [anon_sym_struct] = ACTIONS(3410),
    [anon_sym_union] = ACTIONS(3410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3410),
    [anon_sym_let] = ACTIONS(3410),
    [anon_sym_This] = ACTIONS(3410),
    [anon_sym_decltype] = ACTIONS(3410),
    [sym_virtual] = ACTIONS(3410),
    [anon_sym_explicit] = ACTIONS(3410),
    [anon_sym_typename] = ACTIONS(3410),
    [anon_sym_template] = ACTIONS(3410),
    [anon_sym_operator] = ACTIONS(3410),
    [anon_sym_friend] = ACTIONS(3410),
    [anon_sym_public] = ACTIONS(3410),
    [anon_sym_private] = ACTIONS(3410),
    [anon_sym_protected] = ACTIONS(3410),
    [anon_sym_using] = ACTIONS(3410),
    [anon_sym_static_assert] = ACTIONS(3410),
    [anon_sym_precise] = ACTIONS(3410),
    [anon_sym_shared] = ACTIONS(3410),
    [anon_sym_groupshared] = ACTIONS(3410),
    [anon_sym_uniform] = ACTIONS(3410),
    [anon_sym_row_major] = ACTIONS(3410),
    [anon_sym_column_major] = ACTIONS(3410),
    [anon_sym_globallycoherent] = ACTIONS(3410),
    [anon_sym_centroid] = ACTIONS(3410),
    [anon_sym_noperspective] = ACTIONS(3410),
    [anon_sym_nointerpolation] = ACTIONS(3410),
    [anon_sym_sample] = ACTIONS(3410),
    [anon_sym_linear] = ACTIONS(3410),
    [anon_sym_snorm] = ACTIONS(3410),
    [anon_sym_unorm] = ACTIONS(3410),
    [anon_sym_point] = ACTIONS(3410),
    [anon_sym_line] = ACTIONS(3410),
    [anon_sym_triangleadj] = ACTIONS(3410),
    [anon_sym_lineadj] = ACTIONS(3410),
    [anon_sym_triangle] = ACTIONS(3410),
    [anon_sym_interface] = ACTIONS(3410),
    [anon_sym_extension] = ACTIONS(3410),
    [anon_sym___init] = ACTIONS(3410),
    [anon_sym___subscript] = ACTIONS(3410),
    [anon_sym_property] = ACTIONS(3410),
    [anon_sym_associatedtype] = ACTIONS(3410),
  },
  [1950] = {
    [sym_expression] = STATE(3805),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5781),
    [anon_sym_BANG] = ACTIONS(4611),
    [anon_sym_TILDE] = ACTIONS(4611),
    [anon_sym_DASH] = ACTIONS(4609),
    [anon_sym_PLUS] = ACTIONS(4609),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4613),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4609),
    [anon_sym_compl] = ACTIONS(4609),
    [anon_sym_DASH_DASH] = ACTIONS(5713),
    [anon_sym_PLUS_PLUS] = ACTIONS(5713),
    [anon_sym_sizeof] = ACTIONS(4615),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4617),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4619),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1951] = {
    [sym_expression] = STATE(5569),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1952] = {
    [sym_expression] = STATE(5223),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1953] = {
    [sym_expression] = STATE(5226),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [1954] = {
    [sym_expression] = STATE(3690),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1955] = {
    [sym_expression] = STATE(3804),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5781),
    [anon_sym_BANG] = ACTIONS(4611),
    [anon_sym_TILDE] = ACTIONS(4611),
    [anon_sym_DASH] = ACTIONS(4609),
    [anon_sym_PLUS] = ACTIONS(4609),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4613),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4609),
    [anon_sym_compl] = ACTIONS(4609),
    [anon_sym_DASH_DASH] = ACTIONS(5713),
    [anon_sym_PLUS_PLUS] = ACTIONS(5713),
    [anon_sym_sizeof] = ACTIONS(4615),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4617),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4619),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1956] = {
    [sym_expression] = STATE(5566),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1957] = {
    [sym_expression] = STATE(3518),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1958] = {
    [sym_expression] = STATE(5212),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1959] = {
    [sym_identifier] = ACTIONS(3513),
    [aux_sym_preproc_def_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token2] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3513),
    [sym_preproc_directive] = ACTIONS(3513),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3513),
    [anon_sym___extension__] = ACTIONS(3513),
    [anon_sym_typedef] = ACTIONS(3513),
    [anon_sym_in] = ACTIONS(3513),
    [anon_sym_out] = ACTIONS(3513),
    [anon_sym_inout] = ACTIONS(3513),
    [anon_sym_extern] = ACTIONS(3513),
    [anon_sym___attribute__] = ACTIONS(3513),
    [anon_sym_COLON_COLON] = ACTIONS(3515),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3515),
    [anon_sym___declspec] = ACTIONS(3513),
    [anon_sym___based] = ACTIONS(3513),
    [anon_sym_signed] = ACTIONS(3513),
    [anon_sym_unsigned] = ACTIONS(3513),
    [anon_sym_long] = ACTIONS(3513),
    [anon_sym_short] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_register] = ACTIONS(3513),
    [anon_sym_inline] = ACTIONS(3513),
    [anon_sym___inline] = ACTIONS(3513),
    [anon_sym___inline__] = ACTIONS(3513),
    [anon_sym___forceinline] = ACTIONS(3513),
    [anon_sym_thread_local] = ACTIONS(3513),
    [anon_sym___thread] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [anon_sym_constexpr] = ACTIONS(3513),
    [anon_sym_volatile] = ACTIONS(3513),
    [anon_sym_restrict] = ACTIONS(3513),
    [anon_sym___restrict__] = ACTIONS(3513),
    [anon_sym__Atomic] = ACTIONS(3513),
    [anon_sym__Noreturn] = ACTIONS(3513),
    [anon_sym_noreturn] = ACTIONS(3513),
    [anon_sym_mutable] = ACTIONS(3513),
    [anon_sym_constinit] = ACTIONS(3513),
    [anon_sym_consteval] = ACTIONS(3513),
    [anon_sym_alignas] = ACTIONS(3513),
    [anon_sym__Alignas] = ACTIONS(3513),
    [sym_primitive_type] = ACTIONS(3513),
    [anon_sym_enum] = ACTIONS(3513),
    [anon_sym_class] = ACTIONS(3513),
    [anon_sym_struct] = ACTIONS(3513),
    [anon_sym_union] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3513),
    [anon_sym_let] = ACTIONS(3513),
    [anon_sym_This] = ACTIONS(3513),
    [anon_sym_decltype] = ACTIONS(3513),
    [sym_virtual] = ACTIONS(3513),
    [anon_sym_explicit] = ACTIONS(3513),
    [anon_sym_typename] = ACTIONS(3513),
    [anon_sym_template] = ACTIONS(3513),
    [anon_sym_operator] = ACTIONS(3513),
    [anon_sym_friend] = ACTIONS(3513),
    [anon_sym_public] = ACTIONS(3513),
    [anon_sym_private] = ACTIONS(3513),
    [anon_sym_protected] = ACTIONS(3513),
    [anon_sym_using] = ACTIONS(3513),
    [anon_sym_static_assert] = ACTIONS(3513),
    [anon_sym_precise] = ACTIONS(3513),
    [anon_sym_shared] = ACTIONS(3513),
    [anon_sym_groupshared] = ACTIONS(3513),
    [anon_sym_uniform] = ACTIONS(3513),
    [anon_sym_row_major] = ACTIONS(3513),
    [anon_sym_column_major] = ACTIONS(3513),
    [anon_sym_globallycoherent] = ACTIONS(3513),
    [anon_sym_centroid] = ACTIONS(3513),
    [anon_sym_noperspective] = ACTIONS(3513),
    [anon_sym_nointerpolation] = ACTIONS(3513),
    [anon_sym_sample] = ACTIONS(3513),
    [anon_sym_linear] = ACTIONS(3513),
    [anon_sym_snorm] = ACTIONS(3513),
    [anon_sym_unorm] = ACTIONS(3513),
    [anon_sym_point] = ACTIONS(3513),
    [anon_sym_line] = ACTIONS(3513),
    [anon_sym_triangleadj] = ACTIONS(3513),
    [anon_sym_lineadj] = ACTIONS(3513),
    [anon_sym_triangle] = ACTIONS(3513),
    [anon_sym_interface] = ACTIONS(3513),
    [anon_sym_extension] = ACTIONS(3513),
    [anon_sym___init] = ACTIONS(3513),
    [anon_sym___subscript] = ACTIONS(3513),
    [anon_sym_property] = ACTIONS(3513),
    [anon_sym_associatedtype] = ACTIONS(3513),
  },
  [1960] = {
    [sym_expression] = STATE(5564),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1961] = {
    [sym_expression] = STATE(4121),
    [sym__string] = STATE(4545),
    [sym_conditional_expression] = STATE(4545),
    [sym_assignment_expression] = STATE(4545),
    [sym_pointer_expression] = STATE(4540),
    [sym_unary_expression] = STATE(4545),
    [sym_binary_expression] = STATE(4545),
    [sym_update_expression] = STATE(4545),
    [sym_cast_expression] = STATE(4545),
    [sym_sizeof_expression] = STATE(4545),
    [sym_alignof_expression] = STATE(4545),
    [sym_offsetof_expression] = STATE(4545),
    [sym_generic_expression] = STATE(4545),
    [sym_subscript_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_gnu_asm_expression] = STATE(4545),
    [sym_field_expression] = STATE(4540),
    [sym_compound_literal_expression] = STATE(4545),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_char_literal] = STATE(4286),
    [sym_concatenated_string] = STATE(4290),
    [sym_string_literal] = STATE(3166),
    [sym_null] = STATE(4545),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9673),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4545),
    [sym_raw_string_literal] = STATE(3169),
    [sym_co_await_expression] = STATE(4545),
    [sym_new_expression] = STATE(4545),
    [sym_delete_expression] = STATE(4545),
    [sym_requires_clause] = STATE(4545),
    [sym_requires_expression] = STATE(4545),
    [sym_lambda_expression] = STATE(4545),
    [sym_lambda_capture_specifier] = STATE(7034),
    [sym_fold_expression] = STATE(4545),
    [sym_parameter_pack_expansion] = STATE(4545),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4540),
    [sym_qualified_type_identifier] = STATE(9673),
    [sym_user_defined_literal] = STATE(4540),
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_LPAREN2] = ACTIONS(5828),
    [anon_sym_BANG] = ACTIONS(4733),
    [anon_sym_TILDE] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4731),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4735),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [sym_primitive_type] = ACTIONS(4739),
    [anon_sym_not] = ACTIONS(4731),
    [anon_sym_compl] = ACTIONS(4731),
    [anon_sym_DASH_DASH] = ACTIONS(5711),
    [anon_sym_PLUS_PLUS] = ACTIONS(5711),
    [anon_sym_sizeof] = ACTIONS(4741),
    [anon_sym___alignof__] = ACTIONS(4743),
    [anon_sym___alignof] = ACTIONS(4743),
    [anon_sym__alignof] = ACTIONS(4743),
    [anon_sym_alignof] = ACTIONS(4743),
    [anon_sym__Alignof] = ACTIONS(4743),
    [anon_sym_offsetof] = ACTIONS(4745),
    [anon_sym__Generic] = ACTIONS(4747),
    [anon_sym_asm] = ACTIONS(4749),
    [anon_sym___asm__] = ACTIONS(4749),
    [sym_number_literal] = ACTIONS(4751),
    [anon_sym_L_SQUOTE] = ACTIONS(4753),
    [anon_sym_u_SQUOTE] = ACTIONS(4753),
    [anon_sym_U_SQUOTE] = ACTIONS(4753),
    [anon_sym_u8_SQUOTE] = ACTIONS(4753),
    [anon_sym_SQUOTE] = ACTIONS(4753),
    [anon_sym_L_DQUOTE] = ACTIONS(4755),
    [anon_sym_u_DQUOTE] = ACTIONS(4755),
    [anon_sym_U_DQUOTE] = ACTIONS(4755),
    [anon_sym_u8_DQUOTE] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [anon_sym_NULL] = ACTIONS(4759),
    [anon_sym_nullptr] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4761),
    [anon_sym_R_DQUOTE] = ACTIONS(4763),
    [anon_sym_LR_DQUOTE] = ACTIONS(4763),
    [anon_sym_uR_DQUOTE] = ACTIONS(4763),
    [anon_sym_UR_DQUOTE] = ACTIONS(4763),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4763),
    [anon_sym_co_await] = ACTIONS(4765),
    [anon_sym_new] = ACTIONS(4767),
    [anon_sym_requires] = ACTIONS(4769),
    [sym_this] = ACTIONS(4757),
  },
  [1962] = {
    [sym_identifier] = ACTIONS(5526),
    [aux_sym_preproc_def_token1] = ACTIONS(5526),
    [aux_sym_preproc_if_token1] = ACTIONS(5526),
    [aux_sym_preproc_if_token2] = ACTIONS(5526),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5526),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5526),
    [sym_preproc_directive] = ACTIONS(5526),
    [anon_sym_LPAREN2] = ACTIONS(5528),
    [anon_sym_TILDE] = ACTIONS(5528),
    [anon_sym_STAR] = ACTIONS(5528),
    [anon_sym_AMP_AMP] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5526),
    [anon_sym___extension__] = ACTIONS(5526),
    [anon_sym_typedef] = ACTIONS(5526),
    [anon_sym_in] = ACTIONS(5526),
    [anon_sym_out] = ACTIONS(5526),
    [anon_sym_inout] = ACTIONS(5526),
    [anon_sym_extern] = ACTIONS(5526),
    [anon_sym___attribute__] = ACTIONS(5526),
    [anon_sym_COLON_COLON] = ACTIONS(5528),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5528),
    [anon_sym___declspec] = ACTIONS(5526),
    [anon_sym___based] = ACTIONS(5526),
    [anon_sym_signed] = ACTIONS(5526),
    [anon_sym_unsigned] = ACTIONS(5526),
    [anon_sym_long] = ACTIONS(5526),
    [anon_sym_short] = ACTIONS(5526),
    [anon_sym_LBRACK] = ACTIONS(5526),
    [anon_sym_static] = ACTIONS(5526),
    [anon_sym_register] = ACTIONS(5526),
    [anon_sym_inline] = ACTIONS(5526),
    [anon_sym___inline] = ACTIONS(5526),
    [anon_sym___inline__] = ACTIONS(5526),
    [anon_sym___forceinline] = ACTIONS(5526),
    [anon_sym_thread_local] = ACTIONS(5526),
    [anon_sym___thread] = ACTIONS(5526),
    [anon_sym_const] = ACTIONS(5526),
    [anon_sym_constexpr] = ACTIONS(5526),
    [anon_sym_volatile] = ACTIONS(5526),
    [anon_sym_restrict] = ACTIONS(5526),
    [anon_sym___restrict__] = ACTIONS(5526),
    [anon_sym__Atomic] = ACTIONS(5526),
    [anon_sym__Noreturn] = ACTIONS(5526),
    [anon_sym_noreturn] = ACTIONS(5526),
    [anon_sym_mutable] = ACTIONS(5526),
    [anon_sym_constinit] = ACTIONS(5526),
    [anon_sym_consteval] = ACTIONS(5526),
    [anon_sym_alignas] = ACTIONS(5526),
    [anon_sym__Alignas] = ACTIONS(5526),
    [sym_primitive_type] = ACTIONS(5526),
    [anon_sym_enum] = ACTIONS(5526),
    [anon_sym_class] = ACTIONS(5526),
    [anon_sym_struct] = ACTIONS(5526),
    [anon_sym_union] = ACTIONS(5526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5526),
    [anon_sym_let] = ACTIONS(5526),
    [anon_sym_This] = ACTIONS(5526),
    [anon_sym_decltype] = ACTIONS(5526),
    [sym_virtual] = ACTIONS(5526),
    [anon_sym_explicit] = ACTIONS(5526),
    [anon_sym_typename] = ACTIONS(5526),
    [anon_sym_template] = ACTIONS(5526),
    [anon_sym_operator] = ACTIONS(5526),
    [anon_sym_friend] = ACTIONS(5526),
    [anon_sym_public] = ACTIONS(5526),
    [anon_sym_private] = ACTIONS(5526),
    [anon_sym_protected] = ACTIONS(5526),
    [anon_sym_using] = ACTIONS(5526),
    [anon_sym_static_assert] = ACTIONS(5526),
    [anon_sym_precise] = ACTIONS(5526),
    [anon_sym_shared] = ACTIONS(5526),
    [anon_sym_groupshared] = ACTIONS(5526),
    [anon_sym_uniform] = ACTIONS(5526),
    [anon_sym_row_major] = ACTIONS(5526),
    [anon_sym_column_major] = ACTIONS(5526),
    [anon_sym_globallycoherent] = ACTIONS(5526),
    [anon_sym_centroid] = ACTIONS(5526),
    [anon_sym_noperspective] = ACTIONS(5526),
    [anon_sym_nointerpolation] = ACTIONS(5526),
    [anon_sym_sample] = ACTIONS(5526),
    [anon_sym_linear] = ACTIONS(5526),
    [anon_sym_snorm] = ACTIONS(5526),
    [anon_sym_unorm] = ACTIONS(5526),
    [anon_sym_point] = ACTIONS(5526),
    [anon_sym_line] = ACTIONS(5526),
    [anon_sym_triangleadj] = ACTIONS(5526),
    [anon_sym_lineadj] = ACTIONS(5526),
    [anon_sym_triangle] = ACTIONS(5526),
    [anon_sym_interface] = ACTIONS(5526),
    [anon_sym_extension] = ACTIONS(5526),
    [anon_sym___init] = ACTIONS(5526),
    [anon_sym___subscript] = ACTIONS(5526),
    [anon_sym_property] = ACTIONS(5526),
    [anon_sym_associatedtype] = ACTIONS(5526),
  },
  [1963] = {
    [sym_identifier] = ACTIONS(3501),
    [aux_sym_preproc_def_token1] = ACTIONS(3501),
    [aux_sym_preproc_if_token1] = ACTIONS(3501),
    [aux_sym_preproc_if_token2] = ACTIONS(3501),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3501),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3501),
    [sym_preproc_directive] = ACTIONS(3501),
    [anon_sym_LPAREN2] = ACTIONS(3503),
    [anon_sym_TILDE] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(3503),
    [anon_sym_AMP_AMP] = ACTIONS(3503),
    [anon_sym_AMP] = ACTIONS(3501),
    [anon_sym___extension__] = ACTIONS(3501),
    [anon_sym_typedef] = ACTIONS(3501),
    [anon_sym_in] = ACTIONS(3501),
    [anon_sym_out] = ACTIONS(3501),
    [anon_sym_inout] = ACTIONS(3501),
    [anon_sym_extern] = ACTIONS(3501),
    [anon_sym___attribute__] = ACTIONS(3501),
    [anon_sym_COLON_COLON] = ACTIONS(3503),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3503),
    [anon_sym___declspec] = ACTIONS(3501),
    [anon_sym___based] = ACTIONS(3501),
    [anon_sym_signed] = ACTIONS(3501),
    [anon_sym_unsigned] = ACTIONS(3501),
    [anon_sym_long] = ACTIONS(3501),
    [anon_sym_short] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(3501),
    [anon_sym_static] = ACTIONS(3501),
    [anon_sym_register] = ACTIONS(3501),
    [anon_sym_inline] = ACTIONS(3501),
    [anon_sym___inline] = ACTIONS(3501),
    [anon_sym___inline__] = ACTIONS(3501),
    [anon_sym___forceinline] = ACTIONS(3501),
    [anon_sym_thread_local] = ACTIONS(3501),
    [anon_sym___thread] = ACTIONS(3501),
    [anon_sym_const] = ACTIONS(3501),
    [anon_sym_constexpr] = ACTIONS(3501),
    [anon_sym_volatile] = ACTIONS(3501),
    [anon_sym_restrict] = ACTIONS(3501),
    [anon_sym___restrict__] = ACTIONS(3501),
    [anon_sym__Atomic] = ACTIONS(3501),
    [anon_sym__Noreturn] = ACTIONS(3501),
    [anon_sym_noreturn] = ACTIONS(3501),
    [anon_sym_mutable] = ACTIONS(3501),
    [anon_sym_constinit] = ACTIONS(3501),
    [anon_sym_consteval] = ACTIONS(3501),
    [anon_sym_alignas] = ACTIONS(3501),
    [anon_sym__Alignas] = ACTIONS(3501),
    [sym_primitive_type] = ACTIONS(3501),
    [anon_sym_enum] = ACTIONS(3501),
    [anon_sym_class] = ACTIONS(3501),
    [anon_sym_struct] = ACTIONS(3501),
    [anon_sym_union] = ACTIONS(3501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3501),
    [anon_sym_let] = ACTIONS(3501),
    [anon_sym_This] = ACTIONS(3501),
    [anon_sym_decltype] = ACTIONS(3501),
    [sym_virtual] = ACTIONS(3501),
    [anon_sym_explicit] = ACTIONS(3501),
    [anon_sym_typename] = ACTIONS(3501),
    [anon_sym_template] = ACTIONS(3501),
    [anon_sym_operator] = ACTIONS(3501),
    [anon_sym_friend] = ACTIONS(3501),
    [anon_sym_public] = ACTIONS(3501),
    [anon_sym_private] = ACTIONS(3501),
    [anon_sym_protected] = ACTIONS(3501),
    [anon_sym_using] = ACTIONS(3501),
    [anon_sym_static_assert] = ACTIONS(3501),
    [anon_sym_precise] = ACTIONS(3501),
    [anon_sym_shared] = ACTIONS(3501),
    [anon_sym_groupshared] = ACTIONS(3501),
    [anon_sym_uniform] = ACTIONS(3501),
    [anon_sym_row_major] = ACTIONS(3501),
    [anon_sym_column_major] = ACTIONS(3501),
    [anon_sym_globallycoherent] = ACTIONS(3501),
    [anon_sym_centroid] = ACTIONS(3501),
    [anon_sym_noperspective] = ACTIONS(3501),
    [anon_sym_nointerpolation] = ACTIONS(3501),
    [anon_sym_sample] = ACTIONS(3501),
    [anon_sym_linear] = ACTIONS(3501),
    [anon_sym_snorm] = ACTIONS(3501),
    [anon_sym_unorm] = ACTIONS(3501),
    [anon_sym_point] = ACTIONS(3501),
    [anon_sym_line] = ACTIONS(3501),
    [anon_sym_triangleadj] = ACTIONS(3501),
    [anon_sym_lineadj] = ACTIONS(3501),
    [anon_sym_triangle] = ACTIONS(3501),
    [anon_sym_interface] = ACTIONS(3501),
    [anon_sym_extension] = ACTIONS(3501),
    [anon_sym___init] = ACTIONS(3501),
    [anon_sym___subscript] = ACTIONS(3501),
    [anon_sym_property] = ACTIONS(3501),
    [anon_sym_associatedtype] = ACTIONS(3501),
  },
  [1964] = {
    [sym_identifier] = ACTIONS(5536),
    [aux_sym_preproc_def_token1] = ACTIONS(5536),
    [aux_sym_preproc_if_token1] = ACTIONS(5536),
    [aux_sym_preproc_if_token2] = ACTIONS(5536),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5536),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5536),
    [sym_preproc_directive] = ACTIONS(5536),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_TILDE] = ACTIONS(5538),
    [anon_sym_STAR] = ACTIONS(5538),
    [anon_sym_AMP_AMP] = ACTIONS(5538),
    [anon_sym_AMP] = ACTIONS(5536),
    [anon_sym___extension__] = ACTIONS(5536),
    [anon_sym_typedef] = ACTIONS(5536),
    [anon_sym_in] = ACTIONS(5536),
    [anon_sym_out] = ACTIONS(5536),
    [anon_sym_inout] = ACTIONS(5536),
    [anon_sym_extern] = ACTIONS(5536),
    [anon_sym___attribute__] = ACTIONS(5536),
    [anon_sym_COLON_COLON] = ACTIONS(5538),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5538),
    [anon_sym___declspec] = ACTIONS(5536),
    [anon_sym___based] = ACTIONS(5536),
    [anon_sym_signed] = ACTIONS(5536),
    [anon_sym_unsigned] = ACTIONS(5536),
    [anon_sym_long] = ACTIONS(5536),
    [anon_sym_short] = ACTIONS(5536),
    [anon_sym_LBRACK] = ACTIONS(5536),
    [anon_sym_static] = ACTIONS(5536),
    [anon_sym_register] = ACTIONS(5536),
    [anon_sym_inline] = ACTIONS(5536),
    [anon_sym___inline] = ACTIONS(5536),
    [anon_sym___inline__] = ACTIONS(5536),
    [anon_sym___forceinline] = ACTIONS(5536),
    [anon_sym_thread_local] = ACTIONS(5536),
    [anon_sym___thread] = ACTIONS(5536),
    [anon_sym_const] = ACTIONS(5536),
    [anon_sym_constexpr] = ACTIONS(5536),
    [anon_sym_volatile] = ACTIONS(5536),
    [anon_sym_restrict] = ACTIONS(5536),
    [anon_sym___restrict__] = ACTIONS(5536),
    [anon_sym__Atomic] = ACTIONS(5536),
    [anon_sym__Noreturn] = ACTIONS(5536),
    [anon_sym_noreturn] = ACTIONS(5536),
    [anon_sym_mutable] = ACTIONS(5536),
    [anon_sym_constinit] = ACTIONS(5536),
    [anon_sym_consteval] = ACTIONS(5536),
    [anon_sym_alignas] = ACTIONS(5536),
    [anon_sym__Alignas] = ACTIONS(5536),
    [sym_primitive_type] = ACTIONS(5536),
    [anon_sym_enum] = ACTIONS(5536),
    [anon_sym_class] = ACTIONS(5536),
    [anon_sym_struct] = ACTIONS(5536),
    [anon_sym_union] = ACTIONS(5536),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5536),
    [anon_sym_let] = ACTIONS(5536),
    [anon_sym_This] = ACTIONS(5536),
    [anon_sym_decltype] = ACTIONS(5536),
    [sym_virtual] = ACTIONS(5536),
    [anon_sym_explicit] = ACTIONS(5536),
    [anon_sym_typename] = ACTIONS(5536),
    [anon_sym_template] = ACTIONS(5536),
    [anon_sym_operator] = ACTIONS(5536),
    [anon_sym_friend] = ACTIONS(5536),
    [anon_sym_public] = ACTIONS(5536),
    [anon_sym_private] = ACTIONS(5536),
    [anon_sym_protected] = ACTIONS(5536),
    [anon_sym_using] = ACTIONS(5536),
    [anon_sym_static_assert] = ACTIONS(5536),
    [anon_sym_precise] = ACTIONS(5536),
    [anon_sym_shared] = ACTIONS(5536),
    [anon_sym_groupshared] = ACTIONS(5536),
    [anon_sym_uniform] = ACTIONS(5536),
    [anon_sym_row_major] = ACTIONS(5536),
    [anon_sym_column_major] = ACTIONS(5536),
    [anon_sym_globallycoherent] = ACTIONS(5536),
    [anon_sym_centroid] = ACTIONS(5536),
    [anon_sym_noperspective] = ACTIONS(5536),
    [anon_sym_nointerpolation] = ACTIONS(5536),
    [anon_sym_sample] = ACTIONS(5536),
    [anon_sym_linear] = ACTIONS(5536),
    [anon_sym_snorm] = ACTIONS(5536),
    [anon_sym_unorm] = ACTIONS(5536),
    [anon_sym_point] = ACTIONS(5536),
    [anon_sym_line] = ACTIONS(5536),
    [anon_sym_triangleadj] = ACTIONS(5536),
    [anon_sym_lineadj] = ACTIONS(5536),
    [anon_sym_triangle] = ACTIONS(5536),
    [anon_sym_interface] = ACTIONS(5536),
    [anon_sym_extension] = ACTIONS(5536),
    [anon_sym___init] = ACTIONS(5536),
    [anon_sym___subscript] = ACTIONS(5536),
    [anon_sym_property] = ACTIONS(5536),
    [anon_sym_associatedtype] = ACTIONS(5536),
  },
  [1965] = {
    [sym_expression] = STATE(3711),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [1966] = {
    [sym_expression] = STATE(4181),
    [sym__string] = STATE(4545),
    [sym_conditional_expression] = STATE(4545),
    [sym_assignment_expression] = STATE(4545),
    [sym_pointer_expression] = STATE(4540),
    [sym_unary_expression] = STATE(4545),
    [sym_binary_expression] = STATE(4545),
    [sym_update_expression] = STATE(4545),
    [sym_cast_expression] = STATE(4545),
    [sym_sizeof_expression] = STATE(4545),
    [sym_alignof_expression] = STATE(4545),
    [sym_offsetof_expression] = STATE(4545),
    [sym_generic_expression] = STATE(4545),
    [sym_subscript_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_gnu_asm_expression] = STATE(4545),
    [sym_field_expression] = STATE(4540),
    [sym_compound_literal_expression] = STATE(4545),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_char_literal] = STATE(4286),
    [sym_concatenated_string] = STATE(4290),
    [sym_string_literal] = STATE(3166),
    [sym_null] = STATE(4545),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9673),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4545),
    [sym_raw_string_literal] = STATE(3169),
    [sym_co_await_expression] = STATE(4545),
    [sym_new_expression] = STATE(4545),
    [sym_delete_expression] = STATE(4545),
    [sym_requires_clause] = STATE(4545),
    [sym_requires_expression] = STATE(4545),
    [sym_lambda_expression] = STATE(4545),
    [sym_lambda_capture_specifier] = STATE(7034),
    [sym_fold_expression] = STATE(4545),
    [sym_parameter_pack_expansion] = STATE(4545),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4540),
    [sym_qualified_type_identifier] = STATE(9673),
    [sym_user_defined_literal] = STATE(4540),
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_LPAREN2] = ACTIONS(5828),
    [anon_sym_BANG] = ACTIONS(4733),
    [anon_sym_TILDE] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4731),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4735),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4739),
    [anon_sym_not] = ACTIONS(4731),
    [anon_sym_compl] = ACTIONS(4731),
    [anon_sym_DASH_DASH] = ACTIONS(5711),
    [anon_sym_PLUS_PLUS] = ACTIONS(5711),
    [anon_sym_sizeof] = ACTIONS(4741),
    [anon_sym___alignof__] = ACTIONS(4743),
    [anon_sym___alignof] = ACTIONS(4743),
    [anon_sym__alignof] = ACTIONS(4743),
    [anon_sym_alignof] = ACTIONS(4743),
    [anon_sym__Alignof] = ACTIONS(4743),
    [anon_sym_offsetof] = ACTIONS(4745),
    [anon_sym__Generic] = ACTIONS(4747),
    [anon_sym_asm] = ACTIONS(4749),
    [anon_sym___asm__] = ACTIONS(4749),
    [sym_number_literal] = ACTIONS(4751),
    [anon_sym_L_SQUOTE] = ACTIONS(4753),
    [anon_sym_u_SQUOTE] = ACTIONS(4753),
    [anon_sym_U_SQUOTE] = ACTIONS(4753),
    [anon_sym_u8_SQUOTE] = ACTIONS(4753),
    [anon_sym_SQUOTE] = ACTIONS(4753),
    [anon_sym_L_DQUOTE] = ACTIONS(4755),
    [anon_sym_u_DQUOTE] = ACTIONS(4755),
    [anon_sym_U_DQUOTE] = ACTIONS(4755),
    [anon_sym_u8_DQUOTE] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [anon_sym_NULL] = ACTIONS(4759),
    [anon_sym_nullptr] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4761),
    [anon_sym_R_DQUOTE] = ACTIONS(4763),
    [anon_sym_LR_DQUOTE] = ACTIONS(4763),
    [anon_sym_uR_DQUOTE] = ACTIONS(4763),
    [anon_sym_UR_DQUOTE] = ACTIONS(4763),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4763),
    [anon_sym_co_await] = ACTIONS(4765),
    [anon_sym_new] = ACTIONS(4767),
    [anon_sym_requires] = ACTIONS(4769),
    [sym_this] = ACTIONS(4757),
  },
  [1967] = {
    [sym_expression] = STATE(4188),
    [sym__string] = STATE(4545),
    [sym_conditional_expression] = STATE(4545),
    [sym_assignment_expression] = STATE(4545),
    [sym_pointer_expression] = STATE(4540),
    [sym_unary_expression] = STATE(4545),
    [sym_binary_expression] = STATE(4545),
    [sym_update_expression] = STATE(4545),
    [sym_cast_expression] = STATE(4545),
    [sym_sizeof_expression] = STATE(4545),
    [sym_alignof_expression] = STATE(4545),
    [sym_offsetof_expression] = STATE(4545),
    [sym_generic_expression] = STATE(4545),
    [sym_subscript_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_gnu_asm_expression] = STATE(4545),
    [sym_field_expression] = STATE(4540),
    [sym_compound_literal_expression] = STATE(4545),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_char_literal] = STATE(4286),
    [sym_concatenated_string] = STATE(4290),
    [sym_string_literal] = STATE(3166),
    [sym_null] = STATE(4545),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9673),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4545),
    [sym_raw_string_literal] = STATE(3169),
    [sym_co_await_expression] = STATE(4545),
    [sym_new_expression] = STATE(4545),
    [sym_delete_expression] = STATE(4545),
    [sym_requires_clause] = STATE(4545),
    [sym_requires_expression] = STATE(4545),
    [sym_lambda_expression] = STATE(4545),
    [sym_lambda_capture_specifier] = STATE(7034),
    [sym_fold_expression] = STATE(4545),
    [sym_parameter_pack_expansion] = STATE(4545),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4540),
    [sym_qualified_type_identifier] = STATE(9673),
    [sym_user_defined_literal] = STATE(4540),
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_LPAREN2] = ACTIONS(5828),
    [anon_sym_BANG] = ACTIONS(4733),
    [anon_sym_TILDE] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4731),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4735),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4739),
    [anon_sym_not] = ACTIONS(4731),
    [anon_sym_compl] = ACTIONS(4731),
    [anon_sym_DASH_DASH] = ACTIONS(5711),
    [anon_sym_PLUS_PLUS] = ACTIONS(5711),
    [anon_sym_sizeof] = ACTIONS(4741),
    [anon_sym___alignof__] = ACTIONS(4743),
    [anon_sym___alignof] = ACTIONS(4743),
    [anon_sym__alignof] = ACTIONS(4743),
    [anon_sym_alignof] = ACTIONS(4743),
    [anon_sym__Alignof] = ACTIONS(4743),
    [anon_sym_offsetof] = ACTIONS(4745),
    [anon_sym__Generic] = ACTIONS(4747),
    [anon_sym_asm] = ACTIONS(4749),
    [anon_sym___asm__] = ACTIONS(4749),
    [sym_number_literal] = ACTIONS(4751),
    [anon_sym_L_SQUOTE] = ACTIONS(4753),
    [anon_sym_u_SQUOTE] = ACTIONS(4753),
    [anon_sym_U_SQUOTE] = ACTIONS(4753),
    [anon_sym_u8_SQUOTE] = ACTIONS(4753),
    [anon_sym_SQUOTE] = ACTIONS(4753),
    [anon_sym_L_DQUOTE] = ACTIONS(4755),
    [anon_sym_u_DQUOTE] = ACTIONS(4755),
    [anon_sym_U_DQUOTE] = ACTIONS(4755),
    [anon_sym_u8_DQUOTE] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [anon_sym_NULL] = ACTIONS(4759),
    [anon_sym_nullptr] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4761),
    [anon_sym_R_DQUOTE] = ACTIONS(4763),
    [anon_sym_LR_DQUOTE] = ACTIONS(4763),
    [anon_sym_uR_DQUOTE] = ACTIONS(4763),
    [anon_sym_UR_DQUOTE] = ACTIONS(4763),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4763),
    [anon_sym_co_await] = ACTIONS(4765),
    [anon_sym_new] = ACTIONS(4767),
    [anon_sym_requires] = ACTIONS(4769),
    [sym_this] = ACTIONS(4757),
  },
  [1968] = {
    [sym_expression] = STATE(4180),
    [sym__string] = STATE(4545),
    [sym_conditional_expression] = STATE(4545),
    [sym_assignment_expression] = STATE(4545),
    [sym_pointer_expression] = STATE(4540),
    [sym_unary_expression] = STATE(4545),
    [sym_binary_expression] = STATE(4545),
    [sym_update_expression] = STATE(4545),
    [sym_cast_expression] = STATE(4545),
    [sym_sizeof_expression] = STATE(4545),
    [sym_alignof_expression] = STATE(4545),
    [sym_offsetof_expression] = STATE(4545),
    [sym_generic_expression] = STATE(4545),
    [sym_subscript_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_gnu_asm_expression] = STATE(4545),
    [sym_field_expression] = STATE(4540),
    [sym_compound_literal_expression] = STATE(4545),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_char_literal] = STATE(4286),
    [sym_concatenated_string] = STATE(4290),
    [sym_string_literal] = STATE(3166),
    [sym_null] = STATE(4545),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9673),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4545),
    [sym_raw_string_literal] = STATE(3169),
    [sym_co_await_expression] = STATE(4545),
    [sym_new_expression] = STATE(4545),
    [sym_delete_expression] = STATE(4545),
    [sym_requires_clause] = STATE(4545),
    [sym_requires_expression] = STATE(4545),
    [sym_lambda_expression] = STATE(4545),
    [sym_lambda_capture_specifier] = STATE(7034),
    [sym_fold_expression] = STATE(4545),
    [sym_parameter_pack_expansion] = STATE(4545),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4540),
    [sym_qualified_type_identifier] = STATE(9673),
    [sym_user_defined_literal] = STATE(4540),
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_LPAREN2] = ACTIONS(5828),
    [anon_sym_BANG] = ACTIONS(4733),
    [anon_sym_TILDE] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4731),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4735),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4739),
    [anon_sym_not] = ACTIONS(4731),
    [anon_sym_compl] = ACTIONS(4731),
    [anon_sym_DASH_DASH] = ACTIONS(5711),
    [anon_sym_PLUS_PLUS] = ACTIONS(5711),
    [anon_sym_sizeof] = ACTIONS(4741),
    [anon_sym___alignof__] = ACTIONS(4743),
    [anon_sym___alignof] = ACTIONS(4743),
    [anon_sym__alignof] = ACTIONS(4743),
    [anon_sym_alignof] = ACTIONS(4743),
    [anon_sym__Alignof] = ACTIONS(4743),
    [anon_sym_offsetof] = ACTIONS(4745),
    [anon_sym__Generic] = ACTIONS(4747),
    [anon_sym_asm] = ACTIONS(4749),
    [anon_sym___asm__] = ACTIONS(4749),
    [sym_number_literal] = ACTIONS(4751),
    [anon_sym_L_SQUOTE] = ACTIONS(4753),
    [anon_sym_u_SQUOTE] = ACTIONS(4753),
    [anon_sym_U_SQUOTE] = ACTIONS(4753),
    [anon_sym_u8_SQUOTE] = ACTIONS(4753),
    [anon_sym_SQUOTE] = ACTIONS(4753),
    [anon_sym_L_DQUOTE] = ACTIONS(4755),
    [anon_sym_u_DQUOTE] = ACTIONS(4755),
    [anon_sym_U_DQUOTE] = ACTIONS(4755),
    [anon_sym_u8_DQUOTE] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [anon_sym_NULL] = ACTIONS(4759),
    [anon_sym_nullptr] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4761),
    [anon_sym_R_DQUOTE] = ACTIONS(4763),
    [anon_sym_LR_DQUOTE] = ACTIONS(4763),
    [anon_sym_uR_DQUOTE] = ACTIONS(4763),
    [anon_sym_UR_DQUOTE] = ACTIONS(4763),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4763),
    [anon_sym_co_await] = ACTIONS(4765),
    [anon_sym_new] = ACTIONS(4767),
    [anon_sym_requires] = ACTIONS(4769),
    [sym_this] = ACTIONS(4757),
  },
  [1969] = {
    [sym_expression] = STATE(4654),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4958),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4964),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1970] = {
    [sym_identifier] = ACTIONS(3429),
    [aux_sym_preproc_def_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token2] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3429),
    [sym_preproc_directive] = ACTIONS(3429),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym___extension__] = ACTIONS(3429),
    [anon_sym_typedef] = ACTIONS(3429),
    [anon_sym_in] = ACTIONS(3429),
    [anon_sym_out] = ACTIONS(3429),
    [anon_sym_inout] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym___attribute__] = ACTIONS(3429),
    [anon_sym_COLON_COLON] = ACTIONS(3431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3431),
    [anon_sym___declspec] = ACTIONS(3429),
    [anon_sym___based] = ACTIONS(3429),
    [anon_sym_signed] = ACTIONS(3429),
    [anon_sym_unsigned] = ACTIONS(3429),
    [anon_sym_long] = ACTIONS(3429),
    [anon_sym_short] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_register] = ACTIONS(3429),
    [anon_sym_inline] = ACTIONS(3429),
    [anon_sym___inline] = ACTIONS(3429),
    [anon_sym___inline__] = ACTIONS(3429),
    [anon_sym___forceinline] = ACTIONS(3429),
    [anon_sym_thread_local] = ACTIONS(3429),
    [anon_sym___thread] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_constexpr] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_restrict] = ACTIONS(3429),
    [anon_sym___restrict__] = ACTIONS(3429),
    [anon_sym__Atomic] = ACTIONS(3429),
    [anon_sym__Noreturn] = ACTIONS(3429),
    [anon_sym_noreturn] = ACTIONS(3429),
    [anon_sym_mutable] = ACTIONS(3429),
    [anon_sym_constinit] = ACTIONS(3429),
    [anon_sym_consteval] = ACTIONS(3429),
    [anon_sym_alignas] = ACTIONS(3429),
    [anon_sym__Alignas] = ACTIONS(3429),
    [sym_primitive_type] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_This] = ACTIONS(3429),
    [anon_sym_decltype] = ACTIONS(3429),
    [sym_virtual] = ACTIONS(3429),
    [anon_sym_explicit] = ACTIONS(3429),
    [anon_sym_typename] = ACTIONS(3429),
    [anon_sym_template] = ACTIONS(3429),
    [anon_sym_operator] = ACTIONS(3429),
    [anon_sym_friend] = ACTIONS(3429),
    [anon_sym_public] = ACTIONS(3429),
    [anon_sym_private] = ACTIONS(3429),
    [anon_sym_protected] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_static_assert] = ACTIONS(3429),
    [anon_sym_precise] = ACTIONS(3429),
    [anon_sym_shared] = ACTIONS(3429),
    [anon_sym_groupshared] = ACTIONS(3429),
    [anon_sym_uniform] = ACTIONS(3429),
    [anon_sym_row_major] = ACTIONS(3429),
    [anon_sym_column_major] = ACTIONS(3429),
    [anon_sym_globallycoherent] = ACTIONS(3429),
    [anon_sym_centroid] = ACTIONS(3429),
    [anon_sym_noperspective] = ACTIONS(3429),
    [anon_sym_nointerpolation] = ACTIONS(3429),
    [anon_sym_sample] = ACTIONS(3429),
    [anon_sym_linear] = ACTIONS(3429),
    [anon_sym_snorm] = ACTIONS(3429),
    [anon_sym_unorm] = ACTIONS(3429),
    [anon_sym_point] = ACTIONS(3429),
    [anon_sym_line] = ACTIONS(3429),
    [anon_sym_triangleadj] = ACTIONS(3429),
    [anon_sym_lineadj] = ACTIONS(3429),
    [anon_sym_triangle] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_extension] = ACTIONS(3429),
    [anon_sym___init] = ACTIONS(3429),
    [anon_sym___subscript] = ACTIONS(3429),
    [anon_sym_property] = ACTIONS(3429),
    [anon_sym_associatedtype] = ACTIONS(3429),
  },
  [1971] = {
    [sym_identifier] = ACTIONS(5544),
    [aux_sym_preproc_def_token1] = ACTIONS(5544),
    [aux_sym_preproc_if_token1] = ACTIONS(5544),
    [aux_sym_preproc_if_token2] = ACTIONS(5544),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5544),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5544),
    [sym_preproc_directive] = ACTIONS(5544),
    [anon_sym_LPAREN2] = ACTIONS(5546),
    [anon_sym_TILDE] = ACTIONS(5546),
    [anon_sym_STAR] = ACTIONS(5546),
    [anon_sym_AMP_AMP] = ACTIONS(5546),
    [anon_sym_AMP] = ACTIONS(5544),
    [anon_sym___extension__] = ACTIONS(5544),
    [anon_sym_typedef] = ACTIONS(5544),
    [anon_sym_in] = ACTIONS(5544),
    [anon_sym_out] = ACTIONS(5544),
    [anon_sym_inout] = ACTIONS(5544),
    [anon_sym_extern] = ACTIONS(5544),
    [anon_sym___attribute__] = ACTIONS(5544),
    [anon_sym_COLON_COLON] = ACTIONS(5546),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5546),
    [anon_sym___declspec] = ACTIONS(5544),
    [anon_sym___based] = ACTIONS(5544),
    [anon_sym_signed] = ACTIONS(5544),
    [anon_sym_unsigned] = ACTIONS(5544),
    [anon_sym_long] = ACTIONS(5544),
    [anon_sym_short] = ACTIONS(5544),
    [anon_sym_LBRACK] = ACTIONS(5544),
    [anon_sym_static] = ACTIONS(5544),
    [anon_sym_register] = ACTIONS(5544),
    [anon_sym_inline] = ACTIONS(5544),
    [anon_sym___inline] = ACTIONS(5544),
    [anon_sym___inline__] = ACTIONS(5544),
    [anon_sym___forceinline] = ACTIONS(5544),
    [anon_sym_thread_local] = ACTIONS(5544),
    [anon_sym___thread] = ACTIONS(5544),
    [anon_sym_const] = ACTIONS(5544),
    [anon_sym_constexpr] = ACTIONS(5544),
    [anon_sym_volatile] = ACTIONS(5544),
    [anon_sym_restrict] = ACTIONS(5544),
    [anon_sym___restrict__] = ACTIONS(5544),
    [anon_sym__Atomic] = ACTIONS(5544),
    [anon_sym__Noreturn] = ACTIONS(5544),
    [anon_sym_noreturn] = ACTIONS(5544),
    [anon_sym_mutable] = ACTIONS(5544),
    [anon_sym_constinit] = ACTIONS(5544),
    [anon_sym_consteval] = ACTIONS(5544),
    [anon_sym_alignas] = ACTIONS(5544),
    [anon_sym__Alignas] = ACTIONS(5544),
    [sym_primitive_type] = ACTIONS(5544),
    [anon_sym_enum] = ACTIONS(5544),
    [anon_sym_class] = ACTIONS(5544),
    [anon_sym_struct] = ACTIONS(5544),
    [anon_sym_union] = ACTIONS(5544),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5544),
    [anon_sym_let] = ACTIONS(5544),
    [anon_sym_This] = ACTIONS(5544),
    [anon_sym_decltype] = ACTIONS(5544),
    [sym_virtual] = ACTIONS(5544),
    [anon_sym_explicit] = ACTIONS(5544),
    [anon_sym_typename] = ACTIONS(5544),
    [anon_sym_template] = ACTIONS(5544),
    [anon_sym_operator] = ACTIONS(5544),
    [anon_sym_friend] = ACTIONS(5544),
    [anon_sym_public] = ACTIONS(5544),
    [anon_sym_private] = ACTIONS(5544),
    [anon_sym_protected] = ACTIONS(5544),
    [anon_sym_using] = ACTIONS(5544),
    [anon_sym_static_assert] = ACTIONS(5544),
    [anon_sym_precise] = ACTIONS(5544),
    [anon_sym_shared] = ACTIONS(5544),
    [anon_sym_groupshared] = ACTIONS(5544),
    [anon_sym_uniform] = ACTIONS(5544),
    [anon_sym_row_major] = ACTIONS(5544),
    [anon_sym_column_major] = ACTIONS(5544),
    [anon_sym_globallycoherent] = ACTIONS(5544),
    [anon_sym_centroid] = ACTIONS(5544),
    [anon_sym_noperspective] = ACTIONS(5544),
    [anon_sym_nointerpolation] = ACTIONS(5544),
    [anon_sym_sample] = ACTIONS(5544),
    [anon_sym_linear] = ACTIONS(5544),
    [anon_sym_snorm] = ACTIONS(5544),
    [anon_sym_unorm] = ACTIONS(5544),
    [anon_sym_point] = ACTIONS(5544),
    [anon_sym_line] = ACTIONS(5544),
    [anon_sym_triangleadj] = ACTIONS(5544),
    [anon_sym_lineadj] = ACTIONS(5544),
    [anon_sym_triangle] = ACTIONS(5544),
    [anon_sym_interface] = ACTIONS(5544),
    [anon_sym_extension] = ACTIONS(5544),
    [anon_sym___init] = ACTIONS(5544),
    [anon_sym___subscript] = ACTIONS(5544),
    [anon_sym_property] = ACTIONS(5544),
    [anon_sym_associatedtype] = ACTIONS(5544),
  },
  [1972] = {
    [sym_identifier] = ACTIONS(3429),
    [aux_sym_preproc_def_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token2] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3429),
    [sym_preproc_directive] = ACTIONS(3429),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym___extension__] = ACTIONS(3429),
    [anon_sym_typedef] = ACTIONS(3429),
    [anon_sym_in] = ACTIONS(3429),
    [anon_sym_out] = ACTIONS(3429),
    [anon_sym_inout] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym___attribute__] = ACTIONS(3429),
    [anon_sym_COLON_COLON] = ACTIONS(3431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3431),
    [anon_sym___declspec] = ACTIONS(3429),
    [anon_sym___based] = ACTIONS(3429),
    [anon_sym_signed] = ACTIONS(3429),
    [anon_sym_unsigned] = ACTIONS(3429),
    [anon_sym_long] = ACTIONS(3429),
    [anon_sym_short] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_register] = ACTIONS(3429),
    [anon_sym_inline] = ACTIONS(3429),
    [anon_sym___inline] = ACTIONS(3429),
    [anon_sym___inline__] = ACTIONS(3429),
    [anon_sym___forceinline] = ACTIONS(3429),
    [anon_sym_thread_local] = ACTIONS(3429),
    [anon_sym___thread] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_constexpr] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_restrict] = ACTIONS(3429),
    [anon_sym___restrict__] = ACTIONS(3429),
    [anon_sym__Atomic] = ACTIONS(3429),
    [anon_sym__Noreturn] = ACTIONS(3429),
    [anon_sym_noreturn] = ACTIONS(3429),
    [anon_sym_mutable] = ACTIONS(3429),
    [anon_sym_constinit] = ACTIONS(3429),
    [anon_sym_consteval] = ACTIONS(3429),
    [anon_sym_alignas] = ACTIONS(3429),
    [anon_sym__Alignas] = ACTIONS(3429),
    [sym_primitive_type] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_This] = ACTIONS(3429),
    [anon_sym_decltype] = ACTIONS(3429),
    [sym_virtual] = ACTIONS(3429),
    [anon_sym_explicit] = ACTIONS(3429),
    [anon_sym_typename] = ACTIONS(3429),
    [anon_sym_template] = ACTIONS(3429),
    [anon_sym_operator] = ACTIONS(3429),
    [anon_sym_friend] = ACTIONS(3429),
    [anon_sym_public] = ACTIONS(3429),
    [anon_sym_private] = ACTIONS(3429),
    [anon_sym_protected] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_static_assert] = ACTIONS(3429),
    [anon_sym_precise] = ACTIONS(3429),
    [anon_sym_shared] = ACTIONS(3429),
    [anon_sym_groupshared] = ACTIONS(3429),
    [anon_sym_uniform] = ACTIONS(3429),
    [anon_sym_row_major] = ACTIONS(3429),
    [anon_sym_column_major] = ACTIONS(3429),
    [anon_sym_globallycoherent] = ACTIONS(3429),
    [anon_sym_centroid] = ACTIONS(3429),
    [anon_sym_noperspective] = ACTIONS(3429),
    [anon_sym_nointerpolation] = ACTIONS(3429),
    [anon_sym_sample] = ACTIONS(3429),
    [anon_sym_linear] = ACTIONS(3429),
    [anon_sym_snorm] = ACTIONS(3429),
    [anon_sym_unorm] = ACTIONS(3429),
    [anon_sym_point] = ACTIONS(3429),
    [anon_sym_line] = ACTIONS(3429),
    [anon_sym_triangleadj] = ACTIONS(3429),
    [anon_sym_lineadj] = ACTIONS(3429),
    [anon_sym_triangle] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_extension] = ACTIONS(3429),
    [anon_sym___init] = ACTIONS(3429),
    [anon_sym___subscript] = ACTIONS(3429),
    [anon_sym_property] = ACTIONS(3429),
    [anon_sym_associatedtype] = ACTIONS(3429),
  },
  [1973] = {
    [sym_expression] = STATE(4078),
    [sym__string] = STATE(4545),
    [sym_conditional_expression] = STATE(4545),
    [sym_assignment_expression] = STATE(4545),
    [sym_pointer_expression] = STATE(4540),
    [sym_unary_expression] = STATE(4545),
    [sym_binary_expression] = STATE(4545),
    [sym_update_expression] = STATE(4545),
    [sym_cast_expression] = STATE(4545),
    [sym_sizeof_expression] = STATE(4545),
    [sym_alignof_expression] = STATE(4545),
    [sym_offsetof_expression] = STATE(4545),
    [sym_generic_expression] = STATE(4545),
    [sym_subscript_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_gnu_asm_expression] = STATE(4545),
    [sym_field_expression] = STATE(4540),
    [sym_compound_literal_expression] = STATE(4545),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_char_literal] = STATE(4286),
    [sym_concatenated_string] = STATE(4290),
    [sym_string_literal] = STATE(3166),
    [sym_null] = STATE(4545),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9673),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4545),
    [sym_raw_string_literal] = STATE(3169),
    [sym_co_await_expression] = STATE(4545),
    [sym_new_expression] = STATE(4545),
    [sym_delete_expression] = STATE(4545),
    [sym_requires_clause] = STATE(4545),
    [sym_requires_expression] = STATE(4545),
    [sym_lambda_expression] = STATE(4545),
    [sym_lambda_capture_specifier] = STATE(7034),
    [sym_fold_expression] = STATE(4545),
    [sym_parameter_pack_expansion] = STATE(4545),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4540),
    [sym_qualified_type_identifier] = STATE(9673),
    [sym_user_defined_literal] = STATE(4540),
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_LPAREN2] = ACTIONS(5828),
    [anon_sym_BANG] = ACTIONS(4733),
    [anon_sym_TILDE] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4731),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4735),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4739),
    [anon_sym_not] = ACTIONS(4731),
    [anon_sym_compl] = ACTIONS(4731),
    [anon_sym_DASH_DASH] = ACTIONS(5711),
    [anon_sym_PLUS_PLUS] = ACTIONS(5711),
    [anon_sym_sizeof] = ACTIONS(4741),
    [anon_sym___alignof__] = ACTIONS(4743),
    [anon_sym___alignof] = ACTIONS(4743),
    [anon_sym__alignof] = ACTIONS(4743),
    [anon_sym_alignof] = ACTIONS(4743),
    [anon_sym__Alignof] = ACTIONS(4743),
    [anon_sym_offsetof] = ACTIONS(4745),
    [anon_sym__Generic] = ACTIONS(4747),
    [anon_sym_asm] = ACTIONS(4749),
    [anon_sym___asm__] = ACTIONS(4749),
    [sym_number_literal] = ACTIONS(4751),
    [anon_sym_L_SQUOTE] = ACTIONS(4753),
    [anon_sym_u_SQUOTE] = ACTIONS(4753),
    [anon_sym_U_SQUOTE] = ACTIONS(4753),
    [anon_sym_u8_SQUOTE] = ACTIONS(4753),
    [anon_sym_SQUOTE] = ACTIONS(4753),
    [anon_sym_L_DQUOTE] = ACTIONS(4755),
    [anon_sym_u_DQUOTE] = ACTIONS(4755),
    [anon_sym_U_DQUOTE] = ACTIONS(4755),
    [anon_sym_u8_DQUOTE] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [anon_sym_NULL] = ACTIONS(4759),
    [anon_sym_nullptr] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4761),
    [anon_sym_R_DQUOTE] = ACTIONS(4763),
    [anon_sym_LR_DQUOTE] = ACTIONS(4763),
    [anon_sym_uR_DQUOTE] = ACTIONS(4763),
    [anon_sym_UR_DQUOTE] = ACTIONS(4763),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4763),
    [anon_sym_co_await] = ACTIONS(4765),
    [anon_sym_new] = ACTIONS(4767),
    [anon_sym_requires] = ACTIONS(4769),
    [sym_this] = ACTIONS(4757),
  },
  [1974] = {
    [sym_identifier] = ACTIONS(5552),
    [aux_sym_preproc_def_token1] = ACTIONS(5552),
    [aux_sym_preproc_if_token1] = ACTIONS(5552),
    [aux_sym_preproc_if_token2] = ACTIONS(5552),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5552),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5552),
    [sym_preproc_directive] = ACTIONS(5552),
    [anon_sym_LPAREN2] = ACTIONS(5554),
    [anon_sym_TILDE] = ACTIONS(5554),
    [anon_sym_STAR] = ACTIONS(5554),
    [anon_sym_AMP_AMP] = ACTIONS(5554),
    [anon_sym_AMP] = ACTIONS(5552),
    [anon_sym___extension__] = ACTIONS(5552),
    [anon_sym_typedef] = ACTIONS(5552),
    [anon_sym_in] = ACTIONS(5552),
    [anon_sym_out] = ACTIONS(5552),
    [anon_sym_inout] = ACTIONS(5552),
    [anon_sym_extern] = ACTIONS(5552),
    [anon_sym___attribute__] = ACTIONS(5552),
    [anon_sym_COLON_COLON] = ACTIONS(5554),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5554),
    [anon_sym___declspec] = ACTIONS(5552),
    [anon_sym___based] = ACTIONS(5552),
    [anon_sym_signed] = ACTIONS(5552),
    [anon_sym_unsigned] = ACTIONS(5552),
    [anon_sym_long] = ACTIONS(5552),
    [anon_sym_short] = ACTIONS(5552),
    [anon_sym_LBRACK] = ACTIONS(5552),
    [anon_sym_static] = ACTIONS(5552),
    [anon_sym_register] = ACTIONS(5552),
    [anon_sym_inline] = ACTIONS(5552),
    [anon_sym___inline] = ACTIONS(5552),
    [anon_sym___inline__] = ACTIONS(5552),
    [anon_sym___forceinline] = ACTIONS(5552),
    [anon_sym_thread_local] = ACTIONS(5552),
    [anon_sym___thread] = ACTIONS(5552),
    [anon_sym_const] = ACTIONS(5552),
    [anon_sym_constexpr] = ACTIONS(5552),
    [anon_sym_volatile] = ACTIONS(5552),
    [anon_sym_restrict] = ACTIONS(5552),
    [anon_sym___restrict__] = ACTIONS(5552),
    [anon_sym__Atomic] = ACTIONS(5552),
    [anon_sym__Noreturn] = ACTIONS(5552),
    [anon_sym_noreturn] = ACTIONS(5552),
    [anon_sym_mutable] = ACTIONS(5552),
    [anon_sym_constinit] = ACTIONS(5552),
    [anon_sym_consteval] = ACTIONS(5552),
    [anon_sym_alignas] = ACTIONS(5552),
    [anon_sym__Alignas] = ACTIONS(5552),
    [sym_primitive_type] = ACTIONS(5552),
    [anon_sym_enum] = ACTIONS(5552),
    [anon_sym_class] = ACTIONS(5552),
    [anon_sym_struct] = ACTIONS(5552),
    [anon_sym_union] = ACTIONS(5552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5552),
    [anon_sym_let] = ACTIONS(5552),
    [anon_sym_This] = ACTIONS(5552),
    [anon_sym_decltype] = ACTIONS(5552),
    [sym_virtual] = ACTIONS(5552),
    [anon_sym_explicit] = ACTIONS(5552),
    [anon_sym_typename] = ACTIONS(5552),
    [anon_sym_template] = ACTIONS(5552),
    [anon_sym_operator] = ACTIONS(5552),
    [anon_sym_friend] = ACTIONS(5552),
    [anon_sym_public] = ACTIONS(5552),
    [anon_sym_private] = ACTIONS(5552),
    [anon_sym_protected] = ACTIONS(5552),
    [anon_sym_using] = ACTIONS(5552),
    [anon_sym_static_assert] = ACTIONS(5552),
    [anon_sym_precise] = ACTIONS(5552),
    [anon_sym_shared] = ACTIONS(5552),
    [anon_sym_groupshared] = ACTIONS(5552),
    [anon_sym_uniform] = ACTIONS(5552),
    [anon_sym_row_major] = ACTIONS(5552),
    [anon_sym_column_major] = ACTIONS(5552),
    [anon_sym_globallycoherent] = ACTIONS(5552),
    [anon_sym_centroid] = ACTIONS(5552),
    [anon_sym_noperspective] = ACTIONS(5552),
    [anon_sym_nointerpolation] = ACTIONS(5552),
    [anon_sym_sample] = ACTIONS(5552),
    [anon_sym_linear] = ACTIONS(5552),
    [anon_sym_snorm] = ACTIONS(5552),
    [anon_sym_unorm] = ACTIONS(5552),
    [anon_sym_point] = ACTIONS(5552),
    [anon_sym_line] = ACTIONS(5552),
    [anon_sym_triangleadj] = ACTIONS(5552),
    [anon_sym_lineadj] = ACTIONS(5552),
    [anon_sym_triangle] = ACTIONS(5552),
    [anon_sym_interface] = ACTIONS(5552),
    [anon_sym_extension] = ACTIONS(5552),
    [anon_sym___init] = ACTIONS(5552),
    [anon_sym___subscript] = ACTIONS(5552),
    [anon_sym_property] = ACTIONS(5552),
    [anon_sym_associatedtype] = ACTIONS(5552),
  },
  [1975] = {
    [sym_expression] = STATE(4179),
    [sym__string] = STATE(4545),
    [sym_conditional_expression] = STATE(4545),
    [sym_assignment_expression] = STATE(4545),
    [sym_pointer_expression] = STATE(4540),
    [sym_unary_expression] = STATE(4545),
    [sym_binary_expression] = STATE(4545),
    [sym_update_expression] = STATE(4545),
    [sym_cast_expression] = STATE(4545),
    [sym_sizeof_expression] = STATE(4545),
    [sym_alignof_expression] = STATE(4545),
    [sym_offsetof_expression] = STATE(4545),
    [sym_generic_expression] = STATE(4545),
    [sym_subscript_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_gnu_asm_expression] = STATE(4545),
    [sym_field_expression] = STATE(4540),
    [sym_compound_literal_expression] = STATE(4545),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_char_literal] = STATE(4286),
    [sym_concatenated_string] = STATE(4290),
    [sym_string_literal] = STATE(3166),
    [sym_null] = STATE(4545),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9673),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4545),
    [sym_raw_string_literal] = STATE(3169),
    [sym_co_await_expression] = STATE(4545),
    [sym_new_expression] = STATE(4545),
    [sym_delete_expression] = STATE(4545),
    [sym_requires_clause] = STATE(4545),
    [sym_requires_expression] = STATE(4545),
    [sym_lambda_expression] = STATE(4545),
    [sym_lambda_capture_specifier] = STATE(7034),
    [sym_fold_expression] = STATE(4545),
    [sym_parameter_pack_expansion] = STATE(4545),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4540),
    [sym_qualified_type_identifier] = STATE(9673),
    [sym_user_defined_literal] = STATE(4540),
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_LPAREN2] = ACTIONS(5828),
    [anon_sym_BANG] = ACTIONS(4733),
    [anon_sym_TILDE] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4731),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4735),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4739),
    [anon_sym_not] = ACTIONS(4731),
    [anon_sym_compl] = ACTIONS(4731),
    [anon_sym_DASH_DASH] = ACTIONS(5711),
    [anon_sym_PLUS_PLUS] = ACTIONS(5711),
    [anon_sym_sizeof] = ACTIONS(4741),
    [anon_sym___alignof__] = ACTIONS(4743),
    [anon_sym___alignof] = ACTIONS(4743),
    [anon_sym__alignof] = ACTIONS(4743),
    [anon_sym_alignof] = ACTIONS(4743),
    [anon_sym__Alignof] = ACTIONS(4743),
    [anon_sym_offsetof] = ACTIONS(4745),
    [anon_sym__Generic] = ACTIONS(4747),
    [anon_sym_asm] = ACTIONS(4749),
    [anon_sym___asm__] = ACTIONS(4749),
    [sym_number_literal] = ACTIONS(4751),
    [anon_sym_L_SQUOTE] = ACTIONS(4753),
    [anon_sym_u_SQUOTE] = ACTIONS(4753),
    [anon_sym_U_SQUOTE] = ACTIONS(4753),
    [anon_sym_u8_SQUOTE] = ACTIONS(4753),
    [anon_sym_SQUOTE] = ACTIONS(4753),
    [anon_sym_L_DQUOTE] = ACTIONS(4755),
    [anon_sym_u_DQUOTE] = ACTIONS(4755),
    [anon_sym_U_DQUOTE] = ACTIONS(4755),
    [anon_sym_u8_DQUOTE] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [anon_sym_NULL] = ACTIONS(4759),
    [anon_sym_nullptr] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4761),
    [anon_sym_R_DQUOTE] = ACTIONS(4763),
    [anon_sym_LR_DQUOTE] = ACTIONS(4763),
    [anon_sym_uR_DQUOTE] = ACTIONS(4763),
    [anon_sym_UR_DQUOTE] = ACTIONS(4763),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4763),
    [anon_sym_co_await] = ACTIONS(4765),
    [anon_sym_new] = ACTIONS(4767),
    [anon_sym_requires] = ACTIONS(4769),
    [sym_this] = ACTIONS(4757),
  },
  [1976] = {
    [sym_expression] = STATE(4077),
    [sym__string] = STATE(4545),
    [sym_conditional_expression] = STATE(4545),
    [sym_assignment_expression] = STATE(4545),
    [sym_pointer_expression] = STATE(4540),
    [sym_unary_expression] = STATE(4545),
    [sym_binary_expression] = STATE(4545),
    [sym_update_expression] = STATE(4545),
    [sym_cast_expression] = STATE(4545),
    [sym_sizeof_expression] = STATE(4545),
    [sym_alignof_expression] = STATE(4545),
    [sym_offsetof_expression] = STATE(4545),
    [sym_generic_expression] = STATE(4545),
    [sym_subscript_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_gnu_asm_expression] = STATE(4545),
    [sym_field_expression] = STATE(4540),
    [sym_compound_literal_expression] = STATE(4545),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_char_literal] = STATE(4286),
    [sym_concatenated_string] = STATE(4290),
    [sym_string_literal] = STATE(3166),
    [sym_null] = STATE(4545),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9673),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4545),
    [sym_raw_string_literal] = STATE(3169),
    [sym_co_await_expression] = STATE(4545),
    [sym_new_expression] = STATE(4545),
    [sym_delete_expression] = STATE(4545),
    [sym_requires_clause] = STATE(4545),
    [sym_requires_expression] = STATE(4545),
    [sym_lambda_expression] = STATE(4545),
    [sym_lambda_capture_specifier] = STATE(7034),
    [sym_fold_expression] = STATE(4545),
    [sym_parameter_pack_expansion] = STATE(4545),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4540),
    [sym_qualified_type_identifier] = STATE(9673),
    [sym_user_defined_literal] = STATE(4540),
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_LPAREN2] = ACTIONS(5828),
    [anon_sym_BANG] = ACTIONS(4733),
    [anon_sym_TILDE] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4731),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4735),
    [anon_sym_LBRACK] = ACTIONS(6078),
    [sym_primitive_type] = ACTIONS(4739),
    [anon_sym_not] = ACTIONS(4731),
    [anon_sym_compl] = ACTIONS(4731),
    [anon_sym_DASH_DASH] = ACTIONS(5711),
    [anon_sym_PLUS_PLUS] = ACTIONS(5711),
    [anon_sym_sizeof] = ACTIONS(4741),
    [anon_sym___alignof__] = ACTIONS(4743),
    [anon_sym___alignof] = ACTIONS(4743),
    [anon_sym__alignof] = ACTIONS(4743),
    [anon_sym_alignof] = ACTIONS(4743),
    [anon_sym__Alignof] = ACTIONS(4743),
    [anon_sym_offsetof] = ACTIONS(4745),
    [anon_sym__Generic] = ACTIONS(4747),
    [anon_sym_asm] = ACTIONS(4749),
    [anon_sym___asm__] = ACTIONS(4749),
    [sym_number_literal] = ACTIONS(4751),
    [anon_sym_L_SQUOTE] = ACTIONS(4753),
    [anon_sym_u_SQUOTE] = ACTIONS(4753),
    [anon_sym_U_SQUOTE] = ACTIONS(4753),
    [anon_sym_u8_SQUOTE] = ACTIONS(4753),
    [anon_sym_SQUOTE] = ACTIONS(4753),
    [anon_sym_L_DQUOTE] = ACTIONS(4755),
    [anon_sym_u_DQUOTE] = ACTIONS(4755),
    [anon_sym_U_DQUOTE] = ACTIONS(4755),
    [anon_sym_u8_DQUOTE] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [anon_sym_NULL] = ACTIONS(4759),
    [anon_sym_nullptr] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4761),
    [anon_sym_R_DQUOTE] = ACTIONS(4763),
    [anon_sym_LR_DQUOTE] = ACTIONS(4763),
    [anon_sym_uR_DQUOTE] = ACTIONS(4763),
    [anon_sym_UR_DQUOTE] = ACTIONS(4763),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4763),
    [anon_sym_co_await] = ACTIONS(4765),
    [anon_sym_new] = ACTIONS(4767),
    [anon_sym_requires] = ACTIONS(4769),
    [sym_this] = ACTIONS(4757),
  },
  [1977] = {
    [sym_expression] = STATE(4178),
    [sym__string] = STATE(4545),
    [sym_conditional_expression] = STATE(4545),
    [sym_assignment_expression] = STATE(4545),
    [sym_pointer_expression] = STATE(4540),
    [sym_unary_expression] = STATE(4545),
    [sym_binary_expression] = STATE(4545),
    [sym_update_expression] = STATE(4545),
    [sym_cast_expression] = STATE(4545),
    [sym_sizeof_expression] = STATE(4545),
    [sym_alignof_expression] = STATE(4545),
    [sym_offsetof_expression] = STATE(4545),
    [sym_generic_expression] = STATE(4545),
    [sym_subscript_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_gnu_asm_expression] = STATE(4545),
    [sym_field_expression] = STATE(4540),
    [sym_compound_literal_expression] = STATE(4545),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_char_literal] = STATE(4286),
    [sym_concatenated_string] = STATE(4290),
    [sym_string_literal] = STATE(3166),
    [sym_null] = STATE(4545),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9673),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4545),
    [sym_raw_string_literal] = STATE(3169),
    [sym_co_await_expression] = STATE(4545),
    [sym_new_expression] = STATE(4545),
    [sym_delete_expression] = STATE(4545),
    [sym_requires_clause] = STATE(4545),
    [sym_requires_expression] = STATE(4545),
    [sym_lambda_expression] = STATE(4545),
    [sym_lambda_capture_specifier] = STATE(7034),
    [sym_fold_expression] = STATE(4545),
    [sym_parameter_pack_expansion] = STATE(4545),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4540),
    [sym_qualified_type_identifier] = STATE(9673),
    [sym_user_defined_literal] = STATE(4540),
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_LPAREN2] = ACTIONS(5828),
    [anon_sym_BANG] = ACTIONS(4733),
    [anon_sym_TILDE] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4731),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4735),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4739),
    [anon_sym_not] = ACTIONS(4731),
    [anon_sym_compl] = ACTIONS(4731),
    [anon_sym_DASH_DASH] = ACTIONS(5711),
    [anon_sym_PLUS_PLUS] = ACTIONS(5711),
    [anon_sym_sizeof] = ACTIONS(4741),
    [anon_sym___alignof__] = ACTIONS(4743),
    [anon_sym___alignof] = ACTIONS(4743),
    [anon_sym__alignof] = ACTIONS(4743),
    [anon_sym_alignof] = ACTIONS(4743),
    [anon_sym__Alignof] = ACTIONS(4743),
    [anon_sym_offsetof] = ACTIONS(4745),
    [anon_sym__Generic] = ACTIONS(4747),
    [anon_sym_asm] = ACTIONS(4749),
    [anon_sym___asm__] = ACTIONS(4749),
    [sym_number_literal] = ACTIONS(4751),
    [anon_sym_L_SQUOTE] = ACTIONS(4753),
    [anon_sym_u_SQUOTE] = ACTIONS(4753),
    [anon_sym_U_SQUOTE] = ACTIONS(4753),
    [anon_sym_u8_SQUOTE] = ACTIONS(4753),
    [anon_sym_SQUOTE] = ACTIONS(4753),
    [anon_sym_L_DQUOTE] = ACTIONS(4755),
    [anon_sym_u_DQUOTE] = ACTIONS(4755),
    [anon_sym_U_DQUOTE] = ACTIONS(4755),
    [anon_sym_u8_DQUOTE] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [anon_sym_NULL] = ACTIONS(4759),
    [anon_sym_nullptr] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4761),
    [anon_sym_R_DQUOTE] = ACTIONS(4763),
    [anon_sym_LR_DQUOTE] = ACTIONS(4763),
    [anon_sym_uR_DQUOTE] = ACTIONS(4763),
    [anon_sym_UR_DQUOTE] = ACTIONS(4763),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4763),
    [anon_sym_co_await] = ACTIONS(4765),
    [anon_sym_new] = ACTIONS(4767),
    [anon_sym_requires] = ACTIONS(4769),
    [sym_this] = ACTIONS(4757),
  },
  [1978] = {
    [sym_identifier] = ACTIONS(3475),
    [aux_sym_preproc_def_token1] = ACTIONS(3475),
    [aux_sym_preproc_if_token1] = ACTIONS(3475),
    [aux_sym_preproc_if_token2] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3475),
    [sym_preproc_directive] = ACTIONS(3475),
    [anon_sym_LPAREN2] = ACTIONS(3477),
    [anon_sym_TILDE] = ACTIONS(3477),
    [anon_sym_STAR] = ACTIONS(3477),
    [anon_sym_AMP_AMP] = ACTIONS(3477),
    [anon_sym_AMP] = ACTIONS(3475),
    [anon_sym___extension__] = ACTIONS(3475),
    [anon_sym_typedef] = ACTIONS(3475),
    [anon_sym_in] = ACTIONS(3475),
    [anon_sym_out] = ACTIONS(3475),
    [anon_sym_inout] = ACTIONS(3475),
    [anon_sym_extern] = ACTIONS(3475),
    [anon_sym___attribute__] = ACTIONS(3475),
    [anon_sym_COLON_COLON] = ACTIONS(3477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3477),
    [anon_sym___declspec] = ACTIONS(3475),
    [anon_sym___based] = ACTIONS(3475),
    [anon_sym_signed] = ACTIONS(3475),
    [anon_sym_unsigned] = ACTIONS(3475),
    [anon_sym_long] = ACTIONS(3475),
    [anon_sym_short] = ACTIONS(3475),
    [anon_sym_LBRACK] = ACTIONS(3475),
    [anon_sym_static] = ACTIONS(3475),
    [anon_sym_register] = ACTIONS(3475),
    [anon_sym_inline] = ACTIONS(3475),
    [anon_sym___inline] = ACTIONS(3475),
    [anon_sym___inline__] = ACTIONS(3475),
    [anon_sym___forceinline] = ACTIONS(3475),
    [anon_sym_thread_local] = ACTIONS(3475),
    [anon_sym___thread] = ACTIONS(3475),
    [anon_sym_const] = ACTIONS(3475),
    [anon_sym_constexpr] = ACTIONS(3475),
    [anon_sym_volatile] = ACTIONS(3475),
    [anon_sym_restrict] = ACTIONS(3475),
    [anon_sym___restrict__] = ACTIONS(3475),
    [anon_sym__Atomic] = ACTIONS(3475),
    [anon_sym__Noreturn] = ACTIONS(3475),
    [anon_sym_noreturn] = ACTIONS(3475),
    [anon_sym_mutable] = ACTIONS(3475),
    [anon_sym_constinit] = ACTIONS(3475),
    [anon_sym_consteval] = ACTIONS(3475),
    [anon_sym_alignas] = ACTIONS(3475),
    [anon_sym__Alignas] = ACTIONS(3475),
    [sym_primitive_type] = ACTIONS(3475),
    [anon_sym_enum] = ACTIONS(3475),
    [anon_sym_class] = ACTIONS(3475),
    [anon_sym_struct] = ACTIONS(3475),
    [anon_sym_union] = ACTIONS(3475),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3475),
    [anon_sym_let] = ACTIONS(3475),
    [anon_sym_This] = ACTIONS(3475),
    [anon_sym_decltype] = ACTIONS(3475),
    [sym_virtual] = ACTIONS(3475),
    [anon_sym_explicit] = ACTIONS(3475),
    [anon_sym_typename] = ACTIONS(3475),
    [anon_sym_template] = ACTIONS(3475),
    [anon_sym_operator] = ACTIONS(3475),
    [anon_sym_friend] = ACTIONS(3475),
    [anon_sym_public] = ACTIONS(3475),
    [anon_sym_private] = ACTIONS(3475),
    [anon_sym_protected] = ACTIONS(3475),
    [anon_sym_using] = ACTIONS(3475),
    [anon_sym_static_assert] = ACTIONS(3475),
    [anon_sym_precise] = ACTIONS(3475),
    [anon_sym_shared] = ACTIONS(3475),
    [anon_sym_groupshared] = ACTIONS(3475),
    [anon_sym_uniform] = ACTIONS(3475),
    [anon_sym_row_major] = ACTIONS(3475),
    [anon_sym_column_major] = ACTIONS(3475),
    [anon_sym_globallycoherent] = ACTIONS(3475),
    [anon_sym_centroid] = ACTIONS(3475),
    [anon_sym_noperspective] = ACTIONS(3475),
    [anon_sym_nointerpolation] = ACTIONS(3475),
    [anon_sym_sample] = ACTIONS(3475),
    [anon_sym_linear] = ACTIONS(3475),
    [anon_sym_snorm] = ACTIONS(3475),
    [anon_sym_unorm] = ACTIONS(3475),
    [anon_sym_point] = ACTIONS(3475),
    [anon_sym_line] = ACTIONS(3475),
    [anon_sym_triangleadj] = ACTIONS(3475),
    [anon_sym_lineadj] = ACTIONS(3475),
    [anon_sym_triangle] = ACTIONS(3475),
    [anon_sym_interface] = ACTIONS(3475),
    [anon_sym_extension] = ACTIONS(3475),
    [anon_sym___init] = ACTIONS(3475),
    [anon_sym___subscript] = ACTIONS(3475),
    [anon_sym_property] = ACTIONS(3475),
    [anon_sym_associatedtype] = ACTIONS(3475),
  },
  [1979] = {
    [sym_identifier] = ACTIONS(5556),
    [aux_sym_preproc_def_token1] = ACTIONS(5556),
    [aux_sym_preproc_if_token1] = ACTIONS(5556),
    [aux_sym_preproc_if_token2] = ACTIONS(5556),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5556),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5556),
    [sym_preproc_directive] = ACTIONS(5556),
    [anon_sym_LPAREN2] = ACTIONS(5558),
    [anon_sym_TILDE] = ACTIONS(5558),
    [anon_sym_STAR] = ACTIONS(5558),
    [anon_sym_AMP_AMP] = ACTIONS(5558),
    [anon_sym_AMP] = ACTIONS(5556),
    [anon_sym___extension__] = ACTIONS(5556),
    [anon_sym_typedef] = ACTIONS(5556),
    [anon_sym_in] = ACTIONS(5556),
    [anon_sym_out] = ACTIONS(5556),
    [anon_sym_inout] = ACTIONS(5556),
    [anon_sym_extern] = ACTIONS(5556),
    [anon_sym___attribute__] = ACTIONS(5556),
    [anon_sym_COLON_COLON] = ACTIONS(5558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5558),
    [anon_sym___declspec] = ACTIONS(5556),
    [anon_sym___based] = ACTIONS(5556),
    [anon_sym_signed] = ACTIONS(5556),
    [anon_sym_unsigned] = ACTIONS(5556),
    [anon_sym_long] = ACTIONS(5556),
    [anon_sym_short] = ACTIONS(5556),
    [anon_sym_LBRACK] = ACTIONS(5556),
    [anon_sym_static] = ACTIONS(5556),
    [anon_sym_register] = ACTIONS(5556),
    [anon_sym_inline] = ACTIONS(5556),
    [anon_sym___inline] = ACTIONS(5556),
    [anon_sym___inline__] = ACTIONS(5556),
    [anon_sym___forceinline] = ACTIONS(5556),
    [anon_sym_thread_local] = ACTIONS(5556),
    [anon_sym___thread] = ACTIONS(5556),
    [anon_sym_const] = ACTIONS(5556),
    [anon_sym_constexpr] = ACTIONS(5556),
    [anon_sym_volatile] = ACTIONS(5556),
    [anon_sym_restrict] = ACTIONS(5556),
    [anon_sym___restrict__] = ACTIONS(5556),
    [anon_sym__Atomic] = ACTIONS(5556),
    [anon_sym__Noreturn] = ACTIONS(5556),
    [anon_sym_noreturn] = ACTIONS(5556),
    [anon_sym_mutable] = ACTIONS(5556),
    [anon_sym_constinit] = ACTIONS(5556),
    [anon_sym_consteval] = ACTIONS(5556),
    [anon_sym_alignas] = ACTIONS(5556),
    [anon_sym__Alignas] = ACTIONS(5556),
    [sym_primitive_type] = ACTIONS(5556),
    [anon_sym_enum] = ACTIONS(5556),
    [anon_sym_class] = ACTIONS(5556),
    [anon_sym_struct] = ACTIONS(5556),
    [anon_sym_union] = ACTIONS(5556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5556),
    [anon_sym_let] = ACTIONS(5556),
    [anon_sym_This] = ACTIONS(5556),
    [anon_sym_decltype] = ACTIONS(5556),
    [sym_virtual] = ACTIONS(5556),
    [anon_sym_explicit] = ACTIONS(5556),
    [anon_sym_typename] = ACTIONS(5556),
    [anon_sym_template] = ACTIONS(5556),
    [anon_sym_operator] = ACTIONS(5556),
    [anon_sym_friend] = ACTIONS(5556),
    [anon_sym_public] = ACTIONS(5556),
    [anon_sym_private] = ACTIONS(5556),
    [anon_sym_protected] = ACTIONS(5556),
    [anon_sym_using] = ACTIONS(5556),
    [anon_sym_static_assert] = ACTIONS(5556),
    [anon_sym_precise] = ACTIONS(5556),
    [anon_sym_shared] = ACTIONS(5556),
    [anon_sym_groupshared] = ACTIONS(5556),
    [anon_sym_uniform] = ACTIONS(5556),
    [anon_sym_row_major] = ACTIONS(5556),
    [anon_sym_column_major] = ACTIONS(5556),
    [anon_sym_globallycoherent] = ACTIONS(5556),
    [anon_sym_centroid] = ACTIONS(5556),
    [anon_sym_noperspective] = ACTIONS(5556),
    [anon_sym_nointerpolation] = ACTIONS(5556),
    [anon_sym_sample] = ACTIONS(5556),
    [anon_sym_linear] = ACTIONS(5556),
    [anon_sym_snorm] = ACTIONS(5556),
    [anon_sym_unorm] = ACTIONS(5556),
    [anon_sym_point] = ACTIONS(5556),
    [anon_sym_line] = ACTIONS(5556),
    [anon_sym_triangleadj] = ACTIONS(5556),
    [anon_sym_lineadj] = ACTIONS(5556),
    [anon_sym_triangle] = ACTIONS(5556),
    [anon_sym_interface] = ACTIONS(5556),
    [anon_sym_extension] = ACTIONS(5556),
    [anon_sym___init] = ACTIONS(5556),
    [anon_sym___subscript] = ACTIONS(5556),
    [anon_sym_property] = ACTIONS(5556),
    [anon_sym_associatedtype] = ACTIONS(5556),
  },
  [1980] = {
    [sym_identifier] = ACTIONS(3489),
    [aux_sym_preproc_def_token1] = ACTIONS(3489),
    [aux_sym_preproc_if_token1] = ACTIONS(3489),
    [aux_sym_preproc_if_token2] = ACTIONS(3489),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3489),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3489),
    [sym_preproc_directive] = ACTIONS(3489),
    [anon_sym_LPAREN2] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3491),
    [anon_sym_STAR] = ACTIONS(3491),
    [anon_sym_AMP_AMP] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3489),
    [anon_sym___extension__] = ACTIONS(3489),
    [anon_sym_typedef] = ACTIONS(3489),
    [anon_sym_in] = ACTIONS(3489),
    [anon_sym_out] = ACTIONS(3489),
    [anon_sym_inout] = ACTIONS(3489),
    [anon_sym_extern] = ACTIONS(3489),
    [anon_sym___attribute__] = ACTIONS(3489),
    [anon_sym_COLON_COLON] = ACTIONS(3491),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3491),
    [anon_sym___declspec] = ACTIONS(3489),
    [anon_sym___based] = ACTIONS(3489),
    [anon_sym_signed] = ACTIONS(3489),
    [anon_sym_unsigned] = ACTIONS(3489),
    [anon_sym_long] = ACTIONS(3489),
    [anon_sym_short] = ACTIONS(3489),
    [anon_sym_LBRACK] = ACTIONS(3489),
    [anon_sym_static] = ACTIONS(3489),
    [anon_sym_register] = ACTIONS(3489),
    [anon_sym_inline] = ACTIONS(3489),
    [anon_sym___inline] = ACTIONS(3489),
    [anon_sym___inline__] = ACTIONS(3489),
    [anon_sym___forceinline] = ACTIONS(3489),
    [anon_sym_thread_local] = ACTIONS(3489),
    [anon_sym___thread] = ACTIONS(3489),
    [anon_sym_const] = ACTIONS(3489),
    [anon_sym_constexpr] = ACTIONS(3489),
    [anon_sym_volatile] = ACTIONS(3489),
    [anon_sym_restrict] = ACTIONS(3489),
    [anon_sym___restrict__] = ACTIONS(3489),
    [anon_sym__Atomic] = ACTIONS(3489),
    [anon_sym__Noreturn] = ACTIONS(3489),
    [anon_sym_noreturn] = ACTIONS(3489),
    [anon_sym_mutable] = ACTIONS(3489),
    [anon_sym_constinit] = ACTIONS(3489),
    [anon_sym_consteval] = ACTIONS(3489),
    [anon_sym_alignas] = ACTIONS(3489),
    [anon_sym__Alignas] = ACTIONS(3489),
    [sym_primitive_type] = ACTIONS(3489),
    [anon_sym_enum] = ACTIONS(3489),
    [anon_sym_class] = ACTIONS(3489),
    [anon_sym_struct] = ACTIONS(3489),
    [anon_sym_union] = ACTIONS(3489),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3489),
    [anon_sym_let] = ACTIONS(3489),
    [anon_sym_This] = ACTIONS(3489),
    [anon_sym_decltype] = ACTIONS(3489),
    [sym_virtual] = ACTIONS(3489),
    [anon_sym_explicit] = ACTIONS(3489),
    [anon_sym_typename] = ACTIONS(3489),
    [anon_sym_template] = ACTIONS(3489),
    [anon_sym_operator] = ACTIONS(3489),
    [anon_sym_friend] = ACTIONS(3489),
    [anon_sym_public] = ACTIONS(3489),
    [anon_sym_private] = ACTIONS(3489),
    [anon_sym_protected] = ACTIONS(3489),
    [anon_sym_using] = ACTIONS(3489),
    [anon_sym_static_assert] = ACTIONS(3489),
    [anon_sym_precise] = ACTIONS(3489),
    [anon_sym_shared] = ACTIONS(3489),
    [anon_sym_groupshared] = ACTIONS(3489),
    [anon_sym_uniform] = ACTIONS(3489),
    [anon_sym_row_major] = ACTIONS(3489),
    [anon_sym_column_major] = ACTIONS(3489),
    [anon_sym_globallycoherent] = ACTIONS(3489),
    [anon_sym_centroid] = ACTIONS(3489),
    [anon_sym_noperspective] = ACTIONS(3489),
    [anon_sym_nointerpolation] = ACTIONS(3489),
    [anon_sym_sample] = ACTIONS(3489),
    [anon_sym_linear] = ACTIONS(3489),
    [anon_sym_snorm] = ACTIONS(3489),
    [anon_sym_unorm] = ACTIONS(3489),
    [anon_sym_point] = ACTIONS(3489),
    [anon_sym_line] = ACTIONS(3489),
    [anon_sym_triangleadj] = ACTIONS(3489),
    [anon_sym_lineadj] = ACTIONS(3489),
    [anon_sym_triangle] = ACTIONS(3489),
    [anon_sym_interface] = ACTIONS(3489),
    [anon_sym_extension] = ACTIONS(3489),
    [anon_sym___init] = ACTIONS(3489),
    [anon_sym___subscript] = ACTIONS(3489),
    [anon_sym_property] = ACTIONS(3489),
    [anon_sym_associatedtype] = ACTIONS(3489),
  },
  [1981] = {
    [sym_identifier] = ACTIONS(5564),
    [aux_sym_preproc_def_token1] = ACTIONS(5564),
    [aux_sym_preproc_if_token1] = ACTIONS(5564),
    [aux_sym_preproc_if_token2] = ACTIONS(5564),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5564),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5564),
    [sym_preproc_directive] = ACTIONS(5564),
    [anon_sym_LPAREN2] = ACTIONS(5566),
    [anon_sym_TILDE] = ACTIONS(5566),
    [anon_sym_STAR] = ACTIONS(5566),
    [anon_sym_AMP_AMP] = ACTIONS(5566),
    [anon_sym_AMP] = ACTIONS(5564),
    [anon_sym___extension__] = ACTIONS(5564),
    [anon_sym_typedef] = ACTIONS(5564),
    [anon_sym_in] = ACTIONS(5564),
    [anon_sym_out] = ACTIONS(5564),
    [anon_sym_inout] = ACTIONS(5564),
    [anon_sym_extern] = ACTIONS(5564),
    [anon_sym___attribute__] = ACTIONS(5564),
    [anon_sym_COLON_COLON] = ACTIONS(5566),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5566),
    [anon_sym___declspec] = ACTIONS(5564),
    [anon_sym___based] = ACTIONS(5564),
    [anon_sym_signed] = ACTIONS(5564),
    [anon_sym_unsigned] = ACTIONS(5564),
    [anon_sym_long] = ACTIONS(5564),
    [anon_sym_short] = ACTIONS(5564),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_static] = ACTIONS(5564),
    [anon_sym_register] = ACTIONS(5564),
    [anon_sym_inline] = ACTIONS(5564),
    [anon_sym___inline] = ACTIONS(5564),
    [anon_sym___inline__] = ACTIONS(5564),
    [anon_sym___forceinline] = ACTIONS(5564),
    [anon_sym_thread_local] = ACTIONS(5564),
    [anon_sym___thread] = ACTIONS(5564),
    [anon_sym_const] = ACTIONS(5564),
    [anon_sym_constexpr] = ACTIONS(5564),
    [anon_sym_volatile] = ACTIONS(5564),
    [anon_sym_restrict] = ACTIONS(5564),
    [anon_sym___restrict__] = ACTIONS(5564),
    [anon_sym__Atomic] = ACTIONS(5564),
    [anon_sym__Noreturn] = ACTIONS(5564),
    [anon_sym_noreturn] = ACTIONS(5564),
    [anon_sym_mutable] = ACTIONS(5564),
    [anon_sym_constinit] = ACTIONS(5564),
    [anon_sym_consteval] = ACTIONS(5564),
    [anon_sym_alignas] = ACTIONS(5564),
    [anon_sym__Alignas] = ACTIONS(5564),
    [sym_primitive_type] = ACTIONS(5564),
    [anon_sym_enum] = ACTIONS(5564),
    [anon_sym_class] = ACTIONS(5564),
    [anon_sym_struct] = ACTIONS(5564),
    [anon_sym_union] = ACTIONS(5564),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5564),
    [anon_sym_let] = ACTIONS(5564),
    [anon_sym_This] = ACTIONS(5564),
    [anon_sym_decltype] = ACTIONS(5564),
    [sym_virtual] = ACTIONS(5564),
    [anon_sym_explicit] = ACTIONS(5564),
    [anon_sym_typename] = ACTIONS(5564),
    [anon_sym_template] = ACTIONS(5564),
    [anon_sym_operator] = ACTIONS(5564),
    [anon_sym_friend] = ACTIONS(5564),
    [anon_sym_public] = ACTIONS(5564),
    [anon_sym_private] = ACTIONS(5564),
    [anon_sym_protected] = ACTIONS(5564),
    [anon_sym_using] = ACTIONS(5564),
    [anon_sym_static_assert] = ACTIONS(5564),
    [anon_sym_precise] = ACTIONS(5564),
    [anon_sym_shared] = ACTIONS(5564),
    [anon_sym_groupshared] = ACTIONS(5564),
    [anon_sym_uniform] = ACTIONS(5564),
    [anon_sym_row_major] = ACTIONS(5564),
    [anon_sym_column_major] = ACTIONS(5564),
    [anon_sym_globallycoherent] = ACTIONS(5564),
    [anon_sym_centroid] = ACTIONS(5564),
    [anon_sym_noperspective] = ACTIONS(5564),
    [anon_sym_nointerpolation] = ACTIONS(5564),
    [anon_sym_sample] = ACTIONS(5564),
    [anon_sym_linear] = ACTIONS(5564),
    [anon_sym_snorm] = ACTIONS(5564),
    [anon_sym_unorm] = ACTIONS(5564),
    [anon_sym_point] = ACTIONS(5564),
    [anon_sym_line] = ACTIONS(5564),
    [anon_sym_triangleadj] = ACTIONS(5564),
    [anon_sym_lineadj] = ACTIONS(5564),
    [anon_sym_triangle] = ACTIONS(5564),
    [anon_sym_interface] = ACTIONS(5564),
    [anon_sym_extension] = ACTIONS(5564),
    [anon_sym___init] = ACTIONS(5564),
    [anon_sym___subscript] = ACTIONS(5564),
    [anon_sym_property] = ACTIONS(5564),
    [anon_sym_associatedtype] = ACTIONS(5564),
  },
  [1982] = {
    [sym_identifier] = ACTIONS(5572),
    [aux_sym_preproc_def_token1] = ACTIONS(5572),
    [aux_sym_preproc_if_token1] = ACTIONS(5572),
    [aux_sym_preproc_if_token2] = ACTIONS(5572),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5572),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5572),
    [sym_preproc_directive] = ACTIONS(5572),
    [anon_sym_LPAREN2] = ACTIONS(5574),
    [anon_sym_TILDE] = ACTIONS(5574),
    [anon_sym_STAR] = ACTIONS(5574),
    [anon_sym_AMP_AMP] = ACTIONS(5574),
    [anon_sym_AMP] = ACTIONS(5572),
    [anon_sym___extension__] = ACTIONS(5572),
    [anon_sym_typedef] = ACTIONS(5572),
    [anon_sym_in] = ACTIONS(5572),
    [anon_sym_out] = ACTIONS(5572),
    [anon_sym_inout] = ACTIONS(5572),
    [anon_sym_extern] = ACTIONS(5572),
    [anon_sym___attribute__] = ACTIONS(5572),
    [anon_sym_COLON_COLON] = ACTIONS(5574),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5574),
    [anon_sym___declspec] = ACTIONS(5572),
    [anon_sym___based] = ACTIONS(5572),
    [anon_sym_signed] = ACTIONS(5572),
    [anon_sym_unsigned] = ACTIONS(5572),
    [anon_sym_long] = ACTIONS(5572),
    [anon_sym_short] = ACTIONS(5572),
    [anon_sym_LBRACK] = ACTIONS(5572),
    [anon_sym_static] = ACTIONS(5572),
    [anon_sym_register] = ACTIONS(5572),
    [anon_sym_inline] = ACTIONS(5572),
    [anon_sym___inline] = ACTIONS(5572),
    [anon_sym___inline__] = ACTIONS(5572),
    [anon_sym___forceinline] = ACTIONS(5572),
    [anon_sym_thread_local] = ACTIONS(5572),
    [anon_sym___thread] = ACTIONS(5572),
    [anon_sym_const] = ACTIONS(5572),
    [anon_sym_constexpr] = ACTIONS(5572),
    [anon_sym_volatile] = ACTIONS(5572),
    [anon_sym_restrict] = ACTIONS(5572),
    [anon_sym___restrict__] = ACTIONS(5572),
    [anon_sym__Atomic] = ACTIONS(5572),
    [anon_sym__Noreturn] = ACTIONS(5572),
    [anon_sym_noreturn] = ACTIONS(5572),
    [anon_sym_mutable] = ACTIONS(5572),
    [anon_sym_constinit] = ACTIONS(5572),
    [anon_sym_consteval] = ACTIONS(5572),
    [anon_sym_alignas] = ACTIONS(5572),
    [anon_sym__Alignas] = ACTIONS(5572),
    [sym_primitive_type] = ACTIONS(5572),
    [anon_sym_enum] = ACTIONS(5572),
    [anon_sym_class] = ACTIONS(5572),
    [anon_sym_struct] = ACTIONS(5572),
    [anon_sym_union] = ACTIONS(5572),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5572),
    [anon_sym_let] = ACTIONS(5572),
    [anon_sym_This] = ACTIONS(5572),
    [anon_sym_decltype] = ACTIONS(5572),
    [sym_virtual] = ACTIONS(5572),
    [anon_sym_explicit] = ACTIONS(5572),
    [anon_sym_typename] = ACTIONS(5572),
    [anon_sym_template] = ACTIONS(5572),
    [anon_sym_operator] = ACTIONS(5572),
    [anon_sym_friend] = ACTIONS(5572),
    [anon_sym_public] = ACTIONS(5572),
    [anon_sym_private] = ACTIONS(5572),
    [anon_sym_protected] = ACTIONS(5572),
    [anon_sym_using] = ACTIONS(5572),
    [anon_sym_static_assert] = ACTIONS(5572),
    [anon_sym_precise] = ACTIONS(5572),
    [anon_sym_shared] = ACTIONS(5572),
    [anon_sym_groupshared] = ACTIONS(5572),
    [anon_sym_uniform] = ACTIONS(5572),
    [anon_sym_row_major] = ACTIONS(5572),
    [anon_sym_column_major] = ACTIONS(5572),
    [anon_sym_globallycoherent] = ACTIONS(5572),
    [anon_sym_centroid] = ACTIONS(5572),
    [anon_sym_noperspective] = ACTIONS(5572),
    [anon_sym_nointerpolation] = ACTIONS(5572),
    [anon_sym_sample] = ACTIONS(5572),
    [anon_sym_linear] = ACTIONS(5572),
    [anon_sym_snorm] = ACTIONS(5572),
    [anon_sym_unorm] = ACTIONS(5572),
    [anon_sym_point] = ACTIONS(5572),
    [anon_sym_line] = ACTIONS(5572),
    [anon_sym_triangleadj] = ACTIONS(5572),
    [anon_sym_lineadj] = ACTIONS(5572),
    [anon_sym_triangle] = ACTIONS(5572),
    [anon_sym_interface] = ACTIONS(5572),
    [anon_sym_extension] = ACTIONS(5572),
    [anon_sym___init] = ACTIONS(5572),
    [anon_sym___subscript] = ACTIONS(5572),
    [anon_sym_property] = ACTIONS(5572),
    [anon_sym_associatedtype] = ACTIONS(5572),
  },
  [1983] = {
    [sym_identifier] = ACTIONS(5572),
    [aux_sym_preproc_def_token1] = ACTIONS(5572),
    [aux_sym_preproc_if_token1] = ACTIONS(5572),
    [aux_sym_preproc_if_token2] = ACTIONS(5572),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5572),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5572),
    [sym_preproc_directive] = ACTIONS(5572),
    [anon_sym_LPAREN2] = ACTIONS(5574),
    [anon_sym_TILDE] = ACTIONS(5574),
    [anon_sym_STAR] = ACTIONS(5574),
    [anon_sym_AMP_AMP] = ACTIONS(5574),
    [anon_sym_AMP] = ACTIONS(5572),
    [anon_sym___extension__] = ACTIONS(5572),
    [anon_sym_typedef] = ACTIONS(5572),
    [anon_sym_in] = ACTIONS(5572),
    [anon_sym_out] = ACTIONS(5572),
    [anon_sym_inout] = ACTIONS(5572),
    [anon_sym_extern] = ACTIONS(5572),
    [anon_sym___attribute__] = ACTIONS(5572),
    [anon_sym_COLON_COLON] = ACTIONS(5574),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5574),
    [anon_sym___declspec] = ACTIONS(5572),
    [anon_sym___based] = ACTIONS(5572),
    [anon_sym_signed] = ACTIONS(5572),
    [anon_sym_unsigned] = ACTIONS(5572),
    [anon_sym_long] = ACTIONS(5572),
    [anon_sym_short] = ACTIONS(5572),
    [anon_sym_LBRACK] = ACTIONS(5572),
    [anon_sym_static] = ACTIONS(5572),
    [anon_sym_register] = ACTIONS(5572),
    [anon_sym_inline] = ACTIONS(5572),
    [anon_sym___inline] = ACTIONS(5572),
    [anon_sym___inline__] = ACTIONS(5572),
    [anon_sym___forceinline] = ACTIONS(5572),
    [anon_sym_thread_local] = ACTIONS(5572),
    [anon_sym___thread] = ACTIONS(5572),
    [anon_sym_const] = ACTIONS(5572),
    [anon_sym_constexpr] = ACTIONS(5572),
    [anon_sym_volatile] = ACTIONS(5572),
    [anon_sym_restrict] = ACTIONS(5572),
    [anon_sym___restrict__] = ACTIONS(5572),
    [anon_sym__Atomic] = ACTIONS(5572),
    [anon_sym__Noreturn] = ACTIONS(5572),
    [anon_sym_noreturn] = ACTIONS(5572),
    [anon_sym_mutable] = ACTIONS(5572),
    [anon_sym_constinit] = ACTIONS(5572),
    [anon_sym_consteval] = ACTIONS(5572),
    [anon_sym_alignas] = ACTIONS(5572),
    [anon_sym__Alignas] = ACTIONS(5572),
    [sym_primitive_type] = ACTIONS(5572),
    [anon_sym_enum] = ACTIONS(5572),
    [anon_sym_class] = ACTIONS(5572),
    [anon_sym_struct] = ACTIONS(5572),
    [anon_sym_union] = ACTIONS(5572),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5572),
    [anon_sym_let] = ACTIONS(5572),
    [anon_sym_This] = ACTIONS(5572),
    [anon_sym_decltype] = ACTIONS(5572),
    [sym_virtual] = ACTIONS(5572),
    [anon_sym_explicit] = ACTIONS(5572),
    [anon_sym_typename] = ACTIONS(5572),
    [anon_sym_template] = ACTIONS(5572),
    [anon_sym_operator] = ACTIONS(5572),
    [anon_sym_friend] = ACTIONS(5572),
    [anon_sym_public] = ACTIONS(5572),
    [anon_sym_private] = ACTIONS(5572),
    [anon_sym_protected] = ACTIONS(5572),
    [anon_sym_using] = ACTIONS(5572),
    [anon_sym_static_assert] = ACTIONS(5572),
    [anon_sym_precise] = ACTIONS(5572),
    [anon_sym_shared] = ACTIONS(5572),
    [anon_sym_groupshared] = ACTIONS(5572),
    [anon_sym_uniform] = ACTIONS(5572),
    [anon_sym_row_major] = ACTIONS(5572),
    [anon_sym_column_major] = ACTIONS(5572),
    [anon_sym_globallycoherent] = ACTIONS(5572),
    [anon_sym_centroid] = ACTIONS(5572),
    [anon_sym_noperspective] = ACTIONS(5572),
    [anon_sym_nointerpolation] = ACTIONS(5572),
    [anon_sym_sample] = ACTIONS(5572),
    [anon_sym_linear] = ACTIONS(5572),
    [anon_sym_snorm] = ACTIONS(5572),
    [anon_sym_unorm] = ACTIONS(5572),
    [anon_sym_point] = ACTIONS(5572),
    [anon_sym_line] = ACTIONS(5572),
    [anon_sym_triangleadj] = ACTIONS(5572),
    [anon_sym_lineadj] = ACTIONS(5572),
    [anon_sym_triangle] = ACTIONS(5572),
    [anon_sym_interface] = ACTIONS(5572),
    [anon_sym_extension] = ACTIONS(5572),
    [anon_sym___init] = ACTIONS(5572),
    [anon_sym___subscript] = ACTIONS(5572),
    [anon_sym_property] = ACTIONS(5572),
    [anon_sym_associatedtype] = ACTIONS(5572),
  },
  [1984] = {
    [sym_identifier] = ACTIONS(3471),
    [aux_sym_preproc_def_token1] = ACTIONS(3471),
    [aux_sym_preproc_if_token1] = ACTIONS(3471),
    [aux_sym_preproc_if_token2] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3471),
    [sym_preproc_directive] = ACTIONS(3471),
    [anon_sym_LPAREN2] = ACTIONS(3473),
    [anon_sym_TILDE] = ACTIONS(3473),
    [anon_sym_STAR] = ACTIONS(3473),
    [anon_sym_AMP_AMP] = ACTIONS(3473),
    [anon_sym_AMP] = ACTIONS(3471),
    [anon_sym___extension__] = ACTIONS(3471),
    [anon_sym_typedef] = ACTIONS(3471),
    [anon_sym_in] = ACTIONS(3471),
    [anon_sym_out] = ACTIONS(3471),
    [anon_sym_inout] = ACTIONS(3471),
    [anon_sym_extern] = ACTIONS(3471),
    [anon_sym___attribute__] = ACTIONS(3471),
    [anon_sym_COLON_COLON] = ACTIONS(3473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3473),
    [anon_sym___declspec] = ACTIONS(3471),
    [anon_sym___based] = ACTIONS(3471),
    [anon_sym_signed] = ACTIONS(3471),
    [anon_sym_unsigned] = ACTIONS(3471),
    [anon_sym_long] = ACTIONS(3471),
    [anon_sym_short] = ACTIONS(3471),
    [anon_sym_LBRACK] = ACTIONS(3471),
    [anon_sym_static] = ACTIONS(3471),
    [anon_sym_register] = ACTIONS(3471),
    [anon_sym_inline] = ACTIONS(3471),
    [anon_sym___inline] = ACTIONS(3471),
    [anon_sym___inline__] = ACTIONS(3471),
    [anon_sym___forceinline] = ACTIONS(3471),
    [anon_sym_thread_local] = ACTIONS(3471),
    [anon_sym___thread] = ACTIONS(3471),
    [anon_sym_const] = ACTIONS(3471),
    [anon_sym_constexpr] = ACTIONS(3471),
    [anon_sym_volatile] = ACTIONS(3471),
    [anon_sym_restrict] = ACTIONS(3471),
    [anon_sym___restrict__] = ACTIONS(3471),
    [anon_sym__Atomic] = ACTIONS(3471),
    [anon_sym__Noreturn] = ACTIONS(3471),
    [anon_sym_noreturn] = ACTIONS(3471),
    [anon_sym_mutable] = ACTIONS(3471),
    [anon_sym_constinit] = ACTIONS(3471),
    [anon_sym_consteval] = ACTIONS(3471),
    [anon_sym_alignas] = ACTIONS(3471),
    [anon_sym__Alignas] = ACTIONS(3471),
    [sym_primitive_type] = ACTIONS(3471),
    [anon_sym_enum] = ACTIONS(3471),
    [anon_sym_class] = ACTIONS(3471),
    [anon_sym_struct] = ACTIONS(3471),
    [anon_sym_union] = ACTIONS(3471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3471),
    [anon_sym_let] = ACTIONS(3471),
    [anon_sym_This] = ACTIONS(3471),
    [anon_sym_decltype] = ACTIONS(3471),
    [sym_virtual] = ACTIONS(3471),
    [anon_sym_explicit] = ACTIONS(3471),
    [anon_sym_typename] = ACTIONS(3471),
    [anon_sym_template] = ACTIONS(3471),
    [anon_sym_operator] = ACTIONS(3471),
    [anon_sym_friend] = ACTIONS(3471),
    [anon_sym_public] = ACTIONS(3471),
    [anon_sym_private] = ACTIONS(3471),
    [anon_sym_protected] = ACTIONS(3471),
    [anon_sym_using] = ACTIONS(3471),
    [anon_sym_static_assert] = ACTIONS(3471),
    [anon_sym_precise] = ACTIONS(3471),
    [anon_sym_shared] = ACTIONS(3471),
    [anon_sym_groupshared] = ACTIONS(3471),
    [anon_sym_uniform] = ACTIONS(3471),
    [anon_sym_row_major] = ACTIONS(3471),
    [anon_sym_column_major] = ACTIONS(3471),
    [anon_sym_globallycoherent] = ACTIONS(3471),
    [anon_sym_centroid] = ACTIONS(3471),
    [anon_sym_noperspective] = ACTIONS(3471),
    [anon_sym_nointerpolation] = ACTIONS(3471),
    [anon_sym_sample] = ACTIONS(3471),
    [anon_sym_linear] = ACTIONS(3471),
    [anon_sym_snorm] = ACTIONS(3471),
    [anon_sym_unorm] = ACTIONS(3471),
    [anon_sym_point] = ACTIONS(3471),
    [anon_sym_line] = ACTIONS(3471),
    [anon_sym_triangleadj] = ACTIONS(3471),
    [anon_sym_lineadj] = ACTIONS(3471),
    [anon_sym_triangle] = ACTIONS(3471),
    [anon_sym_interface] = ACTIONS(3471),
    [anon_sym_extension] = ACTIONS(3471),
    [anon_sym___init] = ACTIONS(3471),
    [anon_sym___subscript] = ACTIONS(3471),
    [anon_sym_property] = ACTIONS(3471),
    [anon_sym_associatedtype] = ACTIONS(3471),
  },
  [1985] = {
    [sym_identifier] = ACTIONS(3467),
    [aux_sym_preproc_def_token1] = ACTIONS(3467),
    [aux_sym_preproc_if_token1] = ACTIONS(3467),
    [aux_sym_preproc_if_token2] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3467),
    [sym_preproc_directive] = ACTIONS(3467),
    [anon_sym_LPAREN2] = ACTIONS(3469),
    [anon_sym_TILDE] = ACTIONS(3469),
    [anon_sym_STAR] = ACTIONS(3469),
    [anon_sym_AMP_AMP] = ACTIONS(3469),
    [anon_sym_AMP] = ACTIONS(3467),
    [anon_sym___extension__] = ACTIONS(3467),
    [anon_sym_typedef] = ACTIONS(3467),
    [anon_sym_in] = ACTIONS(3467),
    [anon_sym_out] = ACTIONS(3467),
    [anon_sym_inout] = ACTIONS(3467),
    [anon_sym_extern] = ACTIONS(3467),
    [anon_sym___attribute__] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(3469),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3469),
    [anon_sym___declspec] = ACTIONS(3467),
    [anon_sym___based] = ACTIONS(3467),
    [anon_sym_signed] = ACTIONS(3467),
    [anon_sym_unsigned] = ACTIONS(3467),
    [anon_sym_long] = ACTIONS(3467),
    [anon_sym_short] = ACTIONS(3467),
    [anon_sym_LBRACK] = ACTIONS(3467),
    [anon_sym_static] = ACTIONS(3467),
    [anon_sym_register] = ACTIONS(3467),
    [anon_sym_inline] = ACTIONS(3467),
    [anon_sym___inline] = ACTIONS(3467),
    [anon_sym___inline__] = ACTIONS(3467),
    [anon_sym___forceinline] = ACTIONS(3467),
    [anon_sym_thread_local] = ACTIONS(3467),
    [anon_sym___thread] = ACTIONS(3467),
    [anon_sym_const] = ACTIONS(3467),
    [anon_sym_constexpr] = ACTIONS(3467),
    [anon_sym_volatile] = ACTIONS(3467),
    [anon_sym_restrict] = ACTIONS(3467),
    [anon_sym___restrict__] = ACTIONS(3467),
    [anon_sym__Atomic] = ACTIONS(3467),
    [anon_sym__Noreturn] = ACTIONS(3467),
    [anon_sym_noreturn] = ACTIONS(3467),
    [anon_sym_mutable] = ACTIONS(3467),
    [anon_sym_constinit] = ACTIONS(3467),
    [anon_sym_consteval] = ACTIONS(3467),
    [anon_sym_alignas] = ACTIONS(3467),
    [anon_sym__Alignas] = ACTIONS(3467),
    [sym_primitive_type] = ACTIONS(3467),
    [anon_sym_enum] = ACTIONS(3467),
    [anon_sym_class] = ACTIONS(3467),
    [anon_sym_struct] = ACTIONS(3467),
    [anon_sym_union] = ACTIONS(3467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3467),
    [anon_sym_let] = ACTIONS(3467),
    [anon_sym_This] = ACTIONS(3467),
    [anon_sym_decltype] = ACTIONS(3467),
    [sym_virtual] = ACTIONS(3467),
    [anon_sym_explicit] = ACTIONS(3467),
    [anon_sym_typename] = ACTIONS(3467),
    [anon_sym_template] = ACTIONS(3467),
    [anon_sym_operator] = ACTIONS(3467),
    [anon_sym_friend] = ACTIONS(3467),
    [anon_sym_public] = ACTIONS(3467),
    [anon_sym_private] = ACTIONS(3467),
    [anon_sym_protected] = ACTIONS(3467),
    [anon_sym_using] = ACTIONS(3467),
    [anon_sym_static_assert] = ACTIONS(3467),
    [anon_sym_precise] = ACTIONS(3467),
    [anon_sym_shared] = ACTIONS(3467),
    [anon_sym_groupshared] = ACTIONS(3467),
    [anon_sym_uniform] = ACTIONS(3467),
    [anon_sym_row_major] = ACTIONS(3467),
    [anon_sym_column_major] = ACTIONS(3467),
    [anon_sym_globallycoherent] = ACTIONS(3467),
    [anon_sym_centroid] = ACTIONS(3467),
    [anon_sym_noperspective] = ACTIONS(3467),
    [anon_sym_nointerpolation] = ACTIONS(3467),
    [anon_sym_sample] = ACTIONS(3467),
    [anon_sym_linear] = ACTIONS(3467),
    [anon_sym_snorm] = ACTIONS(3467),
    [anon_sym_unorm] = ACTIONS(3467),
    [anon_sym_point] = ACTIONS(3467),
    [anon_sym_line] = ACTIONS(3467),
    [anon_sym_triangleadj] = ACTIONS(3467),
    [anon_sym_lineadj] = ACTIONS(3467),
    [anon_sym_triangle] = ACTIONS(3467),
    [anon_sym_interface] = ACTIONS(3467),
    [anon_sym_extension] = ACTIONS(3467),
    [anon_sym___init] = ACTIONS(3467),
    [anon_sym___subscript] = ACTIONS(3467),
    [anon_sym_property] = ACTIONS(3467),
    [anon_sym_associatedtype] = ACTIONS(3467),
  },
  [1986] = {
    [sym_identifier] = ACTIONS(5572),
    [aux_sym_preproc_def_token1] = ACTIONS(5572),
    [aux_sym_preproc_if_token1] = ACTIONS(5572),
    [aux_sym_preproc_if_token2] = ACTIONS(5572),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5572),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5572),
    [sym_preproc_directive] = ACTIONS(5572),
    [anon_sym_LPAREN2] = ACTIONS(5574),
    [anon_sym_TILDE] = ACTIONS(5574),
    [anon_sym_STAR] = ACTIONS(5574),
    [anon_sym_AMP_AMP] = ACTIONS(5574),
    [anon_sym_AMP] = ACTIONS(5572),
    [anon_sym___extension__] = ACTIONS(5572),
    [anon_sym_typedef] = ACTIONS(5572),
    [anon_sym_in] = ACTIONS(5572),
    [anon_sym_out] = ACTIONS(5572),
    [anon_sym_inout] = ACTIONS(5572),
    [anon_sym_extern] = ACTIONS(5572),
    [anon_sym___attribute__] = ACTIONS(5572),
    [anon_sym_COLON_COLON] = ACTIONS(5574),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5574),
    [anon_sym___declspec] = ACTIONS(5572),
    [anon_sym___based] = ACTIONS(5572),
    [anon_sym_signed] = ACTIONS(5572),
    [anon_sym_unsigned] = ACTIONS(5572),
    [anon_sym_long] = ACTIONS(5572),
    [anon_sym_short] = ACTIONS(5572),
    [anon_sym_LBRACK] = ACTIONS(5572),
    [anon_sym_static] = ACTIONS(5572),
    [anon_sym_register] = ACTIONS(5572),
    [anon_sym_inline] = ACTIONS(5572),
    [anon_sym___inline] = ACTIONS(5572),
    [anon_sym___inline__] = ACTIONS(5572),
    [anon_sym___forceinline] = ACTIONS(5572),
    [anon_sym_thread_local] = ACTIONS(5572),
    [anon_sym___thread] = ACTIONS(5572),
    [anon_sym_const] = ACTIONS(5572),
    [anon_sym_constexpr] = ACTIONS(5572),
    [anon_sym_volatile] = ACTIONS(5572),
    [anon_sym_restrict] = ACTIONS(5572),
    [anon_sym___restrict__] = ACTIONS(5572),
    [anon_sym__Atomic] = ACTIONS(5572),
    [anon_sym__Noreturn] = ACTIONS(5572),
    [anon_sym_noreturn] = ACTIONS(5572),
    [anon_sym_mutable] = ACTIONS(5572),
    [anon_sym_constinit] = ACTIONS(5572),
    [anon_sym_consteval] = ACTIONS(5572),
    [anon_sym_alignas] = ACTIONS(5572),
    [anon_sym__Alignas] = ACTIONS(5572),
    [sym_primitive_type] = ACTIONS(5572),
    [anon_sym_enum] = ACTIONS(5572),
    [anon_sym_class] = ACTIONS(5572),
    [anon_sym_struct] = ACTIONS(5572),
    [anon_sym_union] = ACTIONS(5572),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5572),
    [anon_sym_let] = ACTIONS(5572),
    [anon_sym_This] = ACTIONS(5572),
    [anon_sym_decltype] = ACTIONS(5572),
    [sym_virtual] = ACTIONS(5572),
    [anon_sym_explicit] = ACTIONS(5572),
    [anon_sym_typename] = ACTIONS(5572),
    [anon_sym_template] = ACTIONS(5572),
    [anon_sym_operator] = ACTIONS(5572),
    [anon_sym_friend] = ACTIONS(5572),
    [anon_sym_public] = ACTIONS(5572),
    [anon_sym_private] = ACTIONS(5572),
    [anon_sym_protected] = ACTIONS(5572),
    [anon_sym_using] = ACTIONS(5572),
    [anon_sym_static_assert] = ACTIONS(5572),
    [anon_sym_precise] = ACTIONS(5572),
    [anon_sym_shared] = ACTIONS(5572),
    [anon_sym_groupshared] = ACTIONS(5572),
    [anon_sym_uniform] = ACTIONS(5572),
    [anon_sym_row_major] = ACTIONS(5572),
    [anon_sym_column_major] = ACTIONS(5572),
    [anon_sym_globallycoherent] = ACTIONS(5572),
    [anon_sym_centroid] = ACTIONS(5572),
    [anon_sym_noperspective] = ACTIONS(5572),
    [anon_sym_nointerpolation] = ACTIONS(5572),
    [anon_sym_sample] = ACTIONS(5572),
    [anon_sym_linear] = ACTIONS(5572),
    [anon_sym_snorm] = ACTIONS(5572),
    [anon_sym_unorm] = ACTIONS(5572),
    [anon_sym_point] = ACTIONS(5572),
    [anon_sym_line] = ACTIONS(5572),
    [anon_sym_triangleadj] = ACTIONS(5572),
    [anon_sym_lineadj] = ACTIONS(5572),
    [anon_sym_triangle] = ACTIONS(5572),
    [anon_sym_interface] = ACTIONS(5572),
    [anon_sym_extension] = ACTIONS(5572),
    [anon_sym___init] = ACTIONS(5572),
    [anon_sym___subscript] = ACTIONS(5572),
    [anon_sym_property] = ACTIONS(5572),
    [anon_sym_associatedtype] = ACTIONS(5572),
  },
  [1987] = {
    [sym_identifier] = ACTIONS(5564),
    [aux_sym_preproc_def_token1] = ACTIONS(5564),
    [aux_sym_preproc_if_token1] = ACTIONS(5564),
    [aux_sym_preproc_if_token2] = ACTIONS(5564),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5564),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5564),
    [sym_preproc_directive] = ACTIONS(5564),
    [anon_sym_LPAREN2] = ACTIONS(5566),
    [anon_sym_TILDE] = ACTIONS(5566),
    [anon_sym_STAR] = ACTIONS(5566),
    [anon_sym_AMP_AMP] = ACTIONS(5566),
    [anon_sym_AMP] = ACTIONS(5564),
    [anon_sym___extension__] = ACTIONS(5564),
    [anon_sym_typedef] = ACTIONS(5564),
    [anon_sym_in] = ACTIONS(5564),
    [anon_sym_out] = ACTIONS(5564),
    [anon_sym_inout] = ACTIONS(5564),
    [anon_sym_extern] = ACTIONS(5564),
    [anon_sym___attribute__] = ACTIONS(5564),
    [anon_sym_COLON_COLON] = ACTIONS(5566),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5566),
    [anon_sym___declspec] = ACTIONS(5564),
    [anon_sym___based] = ACTIONS(5564),
    [anon_sym_signed] = ACTIONS(5564),
    [anon_sym_unsigned] = ACTIONS(5564),
    [anon_sym_long] = ACTIONS(5564),
    [anon_sym_short] = ACTIONS(5564),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_static] = ACTIONS(5564),
    [anon_sym_register] = ACTIONS(5564),
    [anon_sym_inline] = ACTIONS(5564),
    [anon_sym___inline] = ACTIONS(5564),
    [anon_sym___inline__] = ACTIONS(5564),
    [anon_sym___forceinline] = ACTIONS(5564),
    [anon_sym_thread_local] = ACTIONS(5564),
    [anon_sym___thread] = ACTIONS(5564),
    [anon_sym_const] = ACTIONS(5564),
    [anon_sym_constexpr] = ACTIONS(5564),
    [anon_sym_volatile] = ACTIONS(5564),
    [anon_sym_restrict] = ACTIONS(5564),
    [anon_sym___restrict__] = ACTIONS(5564),
    [anon_sym__Atomic] = ACTIONS(5564),
    [anon_sym__Noreturn] = ACTIONS(5564),
    [anon_sym_noreturn] = ACTIONS(5564),
    [anon_sym_mutable] = ACTIONS(5564),
    [anon_sym_constinit] = ACTIONS(5564),
    [anon_sym_consteval] = ACTIONS(5564),
    [anon_sym_alignas] = ACTIONS(5564),
    [anon_sym__Alignas] = ACTIONS(5564),
    [sym_primitive_type] = ACTIONS(5564),
    [anon_sym_enum] = ACTIONS(5564),
    [anon_sym_class] = ACTIONS(5564),
    [anon_sym_struct] = ACTIONS(5564),
    [anon_sym_union] = ACTIONS(5564),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5564),
    [anon_sym_let] = ACTIONS(5564),
    [anon_sym_This] = ACTIONS(5564),
    [anon_sym_decltype] = ACTIONS(5564),
    [sym_virtual] = ACTIONS(5564),
    [anon_sym_explicit] = ACTIONS(5564),
    [anon_sym_typename] = ACTIONS(5564),
    [anon_sym_template] = ACTIONS(5564),
    [anon_sym_operator] = ACTIONS(5564),
    [anon_sym_friend] = ACTIONS(5564),
    [anon_sym_public] = ACTIONS(5564),
    [anon_sym_private] = ACTIONS(5564),
    [anon_sym_protected] = ACTIONS(5564),
    [anon_sym_using] = ACTIONS(5564),
    [anon_sym_static_assert] = ACTIONS(5564),
    [anon_sym_precise] = ACTIONS(5564),
    [anon_sym_shared] = ACTIONS(5564),
    [anon_sym_groupshared] = ACTIONS(5564),
    [anon_sym_uniform] = ACTIONS(5564),
    [anon_sym_row_major] = ACTIONS(5564),
    [anon_sym_column_major] = ACTIONS(5564),
    [anon_sym_globallycoherent] = ACTIONS(5564),
    [anon_sym_centroid] = ACTIONS(5564),
    [anon_sym_noperspective] = ACTIONS(5564),
    [anon_sym_nointerpolation] = ACTIONS(5564),
    [anon_sym_sample] = ACTIONS(5564),
    [anon_sym_linear] = ACTIONS(5564),
    [anon_sym_snorm] = ACTIONS(5564),
    [anon_sym_unorm] = ACTIONS(5564),
    [anon_sym_point] = ACTIONS(5564),
    [anon_sym_line] = ACTIONS(5564),
    [anon_sym_triangleadj] = ACTIONS(5564),
    [anon_sym_lineadj] = ACTIONS(5564),
    [anon_sym_triangle] = ACTIONS(5564),
    [anon_sym_interface] = ACTIONS(5564),
    [anon_sym_extension] = ACTIONS(5564),
    [anon_sym___init] = ACTIONS(5564),
    [anon_sym___subscript] = ACTIONS(5564),
    [anon_sym_property] = ACTIONS(5564),
    [anon_sym_associatedtype] = ACTIONS(5564),
  },
  [1988] = {
    [sym_expression] = STATE(4599),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4958),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4964),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1989] = {
    [sym_expression] = STATE(5547),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1990] = {
    [sym_expression] = STATE(5574),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [1991] = {
    [sym_expression] = STATE(3835),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5781),
    [anon_sym_BANG] = ACTIONS(4611),
    [anon_sym_TILDE] = ACTIONS(4611),
    [anon_sym_DASH] = ACTIONS(4609),
    [anon_sym_PLUS] = ACTIONS(4609),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4613),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4609),
    [anon_sym_compl] = ACTIONS(4609),
    [anon_sym_DASH_DASH] = ACTIONS(5713),
    [anon_sym_PLUS_PLUS] = ACTIONS(5713),
    [anon_sym_sizeof] = ACTIONS(4615),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4617),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4619),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1992] = {
    [sym_expression] = STATE(3758),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(4134),
    [sym_concatenated_string] = STATE(4159),
    [sym_string_literal] = STATE(3152),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(3145),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4587),
    [anon_sym_LPAREN2] = ACTIONS(5819),
    [anon_sym_BANG] = ACTIONS(4591),
    [anon_sym_TILDE] = ACTIONS(4591),
    [anon_sym_DASH] = ACTIONS(4589),
    [anon_sym_PLUS] = ACTIONS(4589),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4593),
    [anon_sym_LBRACK] = ACTIONS(6080),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4589),
    [anon_sym_compl] = ACTIONS(4589),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_sizeof] = ACTIONS(4595),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4597),
    [anon_sym_L_SQUOTE] = ACTIONS(4599),
    [anon_sym_u_SQUOTE] = ACTIONS(4599),
    [anon_sym_U_SQUOTE] = ACTIONS(4599),
    [anon_sym_u8_SQUOTE] = ACTIONS(4599),
    [anon_sym_SQUOTE] = ACTIONS(4599),
    [anon_sym_L_DQUOTE] = ACTIONS(4601),
    [anon_sym_u_DQUOTE] = ACTIONS(4601),
    [anon_sym_U_DQUOTE] = ACTIONS(4601),
    [anon_sym_u8_DQUOTE] = ACTIONS(4601),
    [anon_sym_DQUOTE] = ACTIONS(4601),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4603),
    [anon_sym_R_DQUOTE] = ACTIONS(4605),
    [anon_sym_LR_DQUOTE] = ACTIONS(4605),
    [anon_sym_uR_DQUOTE] = ACTIONS(4605),
    [anon_sym_UR_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4605),
    [anon_sym_co_await] = ACTIONS(4607),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1993] = {
    [sym_expression] = STATE(3714),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(4134),
    [sym_concatenated_string] = STATE(4159),
    [sym_string_literal] = STATE(3152),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(3145),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4587),
    [anon_sym_LPAREN2] = ACTIONS(5819),
    [anon_sym_BANG] = ACTIONS(4591),
    [anon_sym_TILDE] = ACTIONS(4591),
    [anon_sym_DASH] = ACTIONS(4589),
    [anon_sym_PLUS] = ACTIONS(4589),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4593),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4589),
    [anon_sym_compl] = ACTIONS(4589),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_sizeof] = ACTIONS(4595),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4597),
    [anon_sym_L_SQUOTE] = ACTIONS(4599),
    [anon_sym_u_SQUOTE] = ACTIONS(4599),
    [anon_sym_U_SQUOTE] = ACTIONS(4599),
    [anon_sym_u8_SQUOTE] = ACTIONS(4599),
    [anon_sym_SQUOTE] = ACTIONS(4599),
    [anon_sym_L_DQUOTE] = ACTIONS(4601),
    [anon_sym_u_DQUOTE] = ACTIONS(4601),
    [anon_sym_U_DQUOTE] = ACTIONS(4601),
    [anon_sym_u8_DQUOTE] = ACTIONS(4601),
    [anon_sym_DQUOTE] = ACTIONS(4601),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4603),
    [anon_sym_R_DQUOTE] = ACTIONS(4605),
    [anon_sym_LR_DQUOTE] = ACTIONS(4605),
    [anon_sym_uR_DQUOTE] = ACTIONS(4605),
    [anon_sym_UR_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4605),
    [anon_sym_co_await] = ACTIONS(4607),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1994] = {
    [sym_expression] = STATE(4034),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5781),
    [anon_sym_BANG] = ACTIONS(4611),
    [anon_sym_TILDE] = ACTIONS(4611),
    [anon_sym_DASH] = ACTIONS(4609),
    [anon_sym_PLUS] = ACTIONS(4609),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4613),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4609),
    [anon_sym_compl] = ACTIONS(4609),
    [anon_sym_DASH_DASH] = ACTIONS(5713),
    [anon_sym_PLUS_PLUS] = ACTIONS(5713),
    [anon_sym_sizeof] = ACTIONS(4615),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4617),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4619),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1995] = {
    [sym_identifier] = ACTIONS(3418),
    [aux_sym_preproc_def_token1] = ACTIONS(3418),
    [aux_sym_preproc_if_token1] = ACTIONS(3418),
    [aux_sym_preproc_if_token2] = ACTIONS(3418),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3418),
    [sym_preproc_directive] = ACTIONS(3418),
    [anon_sym_LPAREN2] = ACTIONS(3420),
    [anon_sym_TILDE] = ACTIONS(3420),
    [anon_sym_STAR] = ACTIONS(3420),
    [anon_sym_AMP_AMP] = ACTIONS(3420),
    [anon_sym_AMP] = ACTIONS(3418),
    [anon_sym___extension__] = ACTIONS(3418),
    [anon_sym_typedef] = ACTIONS(3418),
    [anon_sym_in] = ACTIONS(3418),
    [anon_sym_out] = ACTIONS(3418),
    [anon_sym_inout] = ACTIONS(3418),
    [anon_sym_extern] = ACTIONS(3418),
    [anon_sym___attribute__] = ACTIONS(3418),
    [anon_sym_COLON_COLON] = ACTIONS(3420),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3420),
    [anon_sym___declspec] = ACTIONS(3418),
    [anon_sym___based] = ACTIONS(3418),
    [anon_sym_signed] = ACTIONS(3418),
    [anon_sym_unsigned] = ACTIONS(3418),
    [anon_sym_long] = ACTIONS(3418),
    [anon_sym_short] = ACTIONS(3418),
    [anon_sym_LBRACK] = ACTIONS(3418),
    [anon_sym_static] = ACTIONS(3418),
    [anon_sym_register] = ACTIONS(3418),
    [anon_sym_inline] = ACTIONS(3418),
    [anon_sym___inline] = ACTIONS(3418),
    [anon_sym___inline__] = ACTIONS(3418),
    [anon_sym___forceinline] = ACTIONS(3418),
    [anon_sym_thread_local] = ACTIONS(3418),
    [anon_sym___thread] = ACTIONS(3418),
    [anon_sym_const] = ACTIONS(3418),
    [anon_sym_constexpr] = ACTIONS(3418),
    [anon_sym_volatile] = ACTIONS(3418),
    [anon_sym_restrict] = ACTIONS(3418),
    [anon_sym___restrict__] = ACTIONS(3418),
    [anon_sym__Atomic] = ACTIONS(3418),
    [anon_sym__Noreturn] = ACTIONS(3418),
    [anon_sym_noreturn] = ACTIONS(3418),
    [anon_sym_mutable] = ACTIONS(3418),
    [anon_sym_constinit] = ACTIONS(3418),
    [anon_sym_consteval] = ACTIONS(3418),
    [anon_sym_alignas] = ACTIONS(3418),
    [anon_sym__Alignas] = ACTIONS(3418),
    [sym_primitive_type] = ACTIONS(3418),
    [anon_sym_enum] = ACTIONS(3418),
    [anon_sym_class] = ACTIONS(3418),
    [anon_sym_struct] = ACTIONS(3418),
    [anon_sym_union] = ACTIONS(3418),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3418),
    [anon_sym_let] = ACTIONS(3418),
    [anon_sym_This] = ACTIONS(3418),
    [anon_sym_decltype] = ACTIONS(3418),
    [sym_virtual] = ACTIONS(3418),
    [anon_sym_explicit] = ACTIONS(3418),
    [anon_sym_typename] = ACTIONS(3418),
    [anon_sym_template] = ACTIONS(3418),
    [anon_sym_operator] = ACTIONS(3418),
    [anon_sym_friend] = ACTIONS(3418),
    [anon_sym_public] = ACTIONS(3418),
    [anon_sym_private] = ACTIONS(3418),
    [anon_sym_protected] = ACTIONS(3418),
    [anon_sym_using] = ACTIONS(3418),
    [anon_sym_static_assert] = ACTIONS(3418),
    [anon_sym_precise] = ACTIONS(3418),
    [anon_sym_shared] = ACTIONS(3418),
    [anon_sym_groupshared] = ACTIONS(3418),
    [anon_sym_uniform] = ACTIONS(3418),
    [anon_sym_row_major] = ACTIONS(3418),
    [anon_sym_column_major] = ACTIONS(3418),
    [anon_sym_globallycoherent] = ACTIONS(3418),
    [anon_sym_centroid] = ACTIONS(3418),
    [anon_sym_noperspective] = ACTIONS(3418),
    [anon_sym_nointerpolation] = ACTIONS(3418),
    [anon_sym_sample] = ACTIONS(3418),
    [anon_sym_linear] = ACTIONS(3418),
    [anon_sym_snorm] = ACTIONS(3418),
    [anon_sym_unorm] = ACTIONS(3418),
    [anon_sym_point] = ACTIONS(3418),
    [anon_sym_line] = ACTIONS(3418),
    [anon_sym_triangleadj] = ACTIONS(3418),
    [anon_sym_lineadj] = ACTIONS(3418),
    [anon_sym_triangle] = ACTIONS(3418),
    [anon_sym_interface] = ACTIONS(3418),
    [anon_sym_extension] = ACTIONS(3418),
    [anon_sym___init] = ACTIONS(3418),
    [anon_sym___subscript] = ACTIONS(3418),
    [anon_sym_property] = ACTIONS(3418),
    [anon_sym_associatedtype] = ACTIONS(3418),
  },
  [1996] = {
    [sym_expression] = STATE(3836),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5781),
    [anon_sym_BANG] = ACTIONS(4611),
    [anon_sym_TILDE] = ACTIONS(4611),
    [anon_sym_DASH] = ACTIONS(4609),
    [anon_sym_PLUS] = ACTIONS(4609),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4613),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4609),
    [anon_sym_compl] = ACTIONS(4609),
    [anon_sym_DASH_DASH] = ACTIONS(5713),
    [anon_sym_PLUS_PLUS] = ACTIONS(5713),
    [anon_sym_sizeof] = ACTIONS(4615),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4617),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4619),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1997] = {
    [sym_expression] = STATE(3838),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5781),
    [anon_sym_BANG] = ACTIONS(4611),
    [anon_sym_TILDE] = ACTIONS(4611),
    [anon_sym_DASH] = ACTIONS(4609),
    [anon_sym_PLUS] = ACTIONS(4609),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4613),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4609),
    [anon_sym_compl] = ACTIONS(4609),
    [anon_sym_DASH_DASH] = ACTIONS(5713),
    [anon_sym_PLUS_PLUS] = ACTIONS(5713),
    [anon_sym_sizeof] = ACTIONS(4615),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4617),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4619),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [1998] = {
    [sym_identifier] = ACTIONS(3429),
    [aux_sym_preproc_def_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token2] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3429),
    [sym_preproc_directive] = ACTIONS(3429),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym___extension__] = ACTIONS(3429),
    [anon_sym_typedef] = ACTIONS(3429),
    [anon_sym_in] = ACTIONS(3429),
    [anon_sym_out] = ACTIONS(3429),
    [anon_sym_inout] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym___attribute__] = ACTIONS(3429),
    [anon_sym_COLON_COLON] = ACTIONS(3431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3431),
    [anon_sym___declspec] = ACTIONS(3429),
    [anon_sym___based] = ACTIONS(3429),
    [anon_sym_signed] = ACTIONS(3429),
    [anon_sym_unsigned] = ACTIONS(3429),
    [anon_sym_long] = ACTIONS(3429),
    [anon_sym_short] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_register] = ACTIONS(3429),
    [anon_sym_inline] = ACTIONS(3429),
    [anon_sym___inline] = ACTIONS(3429),
    [anon_sym___inline__] = ACTIONS(3429),
    [anon_sym___forceinline] = ACTIONS(3429),
    [anon_sym_thread_local] = ACTIONS(3429),
    [anon_sym___thread] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_constexpr] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_restrict] = ACTIONS(3429),
    [anon_sym___restrict__] = ACTIONS(3429),
    [anon_sym__Atomic] = ACTIONS(3429),
    [anon_sym__Noreturn] = ACTIONS(3429),
    [anon_sym_noreturn] = ACTIONS(3429),
    [anon_sym_mutable] = ACTIONS(3429),
    [anon_sym_constinit] = ACTIONS(3429),
    [anon_sym_consteval] = ACTIONS(3429),
    [anon_sym_alignas] = ACTIONS(3429),
    [anon_sym__Alignas] = ACTIONS(3429),
    [sym_primitive_type] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_This] = ACTIONS(3429),
    [anon_sym_decltype] = ACTIONS(3429),
    [sym_virtual] = ACTIONS(3429),
    [anon_sym_explicit] = ACTIONS(3429),
    [anon_sym_typename] = ACTIONS(3429),
    [anon_sym_template] = ACTIONS(3429),
    [anon_sym_operator] = ACTIONS(3429),
    [anon_sym_friend] = ACTIONS(3429),
    [anon_sym_public] = ACTIONS(3429),
    [anon_sym_private] = ACTIONS(3429),
    [anon_sym_protected] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_static_assert] = ACTIONS(3429),
    [anon_sym_precise] = ACTIONS(3429),
    [anon_sym_shared] = ACTIONS(3429),
    [anon_sym_groupshared] = ACTIONS(3429),
    [anon_sym_uniform] = ACTIONS(3429),
    [anon_sym_row_major] = ACTIONS(3429),
    [anon_sym_column_major] = ACTIONS(3429),
    [anon_sym_globallycoherent] = ACTIONS(3429),
    [anon_sym_centroid] = ACTIONS(3429),
    [anon_sym_noperspective] = ACTIONS(3429),
    [anon_sym_nointerpolation] = ACTIONS(3429),
    [anon_sym_sample] = ACTIONS(3429),
    [anon_sym_linear] = ACTIONS(3429),
    [anon_sym_snorm] = ACTIONS(3429),
    [anon_sym_unorm] = ACTIONS(3429),
    [anon_sym_point] = ACTIONS(3429),
    [anon_sym_line] = ACTIONS(3429),
    [anon_sym_triangleadj] = ACTIONS(3429),
    [anon_sym_lineadj] = ACTIONS(3429),
    [anon_sym_triangle] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_extension] = ACTIONS(3429),
    [anon_sym___init] = ACTIONS(3429),
    [anon_sym___subscript] = ACTIONS(3429),
    [anon_sym_property] = ACTIONS(3429),
    [anon_sym_associatedtype] = ACTIONS(3429),
  },
  [1999] = {
    [sym_identifier] = ACTIONS(3429),
    [aux_sym_preproc_def_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token2] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3429),
    [sym_preproc_directive] = ACTIONS(3429),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym___extension__] = ACTIONS(3429),
    [anon_sym_typedef] = ACTIONS(3429),
    [anon_sym_in] = ACTIONS(3429),
    [anon_sym_out] = ACTIONS(3429),
    [anon_sym_inout] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym___attribute__] = ACTIONS(3429),
    [anon_sym_COLON_COLON] = ACTIONS(3431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3431),
    [anon_sym___declspec] = ACTIONS(3429),
    [anon_sym___based] = ACTIONS(3429),
    [anon_sym_signed] = ACTIONS(3429),
    [anon_sym_unsigned] = ACTIONS(3429),
    [anon_sym_long] = ACTIONS(3429),
    [anon_sym_short] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_register] = ACTIONS(3429),
    [anon_sym_inline] = ACTIONS(3429),
    [anon_sym___inline] = ACTIONS(3429),
    [anon_sym___inline__] = ACTIONS(3429),
    [anon_sym___forceinline] = ACTIONS(3429),
    [anon_sym_thread_local] = ACTIONS(3429),
    [anon_sym___thread] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_constexpr] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_restrict] = ACTIONS(3429),
    [anon_sym___restrict__] = ACTIONS(3429),
    [anon_sym__Atomic] = ACTIONS(3429),
    [anon_sym__Noreturn] = ACTIONS(3429),
    [anon_sym_noreturn] = ACTIONS(3429),
    [anon_sym_mutable] = ACTIONS(3429),
    [anon_sym_constinit] = ACTIONS(3429),
    [anon_sym_consteval] = ACTIONS(3429),
    [anon_sym_alignas] = ACTIONS(3429),
    [anon_sym__Alignas] = ACTIONS(3429),
    [sym_primitive_type] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_This] = ACTIONS(3429),
    [anon_sym_decltype] = ACTIONS(3429),
    [sym_virtual] = ACTIONS(3429),
    [anon_sym_explicit] = ACTIONS(3429),
    [anon_sym_typename] = ACTIONS(3429),
    [anon_sym_template] = ACTIONS(3429),
    [anon_sym_operator] = ACTIONS(3429),
    [anon_sym_friend] = ACTIONS(3429),
    [anon_sym_public] = ACTIONS(3429),
    [anon_sym_private] = ACTIONS(3429),
    [anon_sym_protected] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_static_assert] = ACTIONS(3429),
    [anon_sym_precise] = ACTIONS(3429),
    [anon_sym_shared] = ACTIONS(3429),
    [anon_sym_groupshared] = ACTIONS(3429),
    [anon_sym_uniform] = ACTIONS(3429),
    [anon_sym_row_major] = ACTIONS(3429),
    [anon_sym_column_major] = ACTIONS(3429),
    [anon_sym_globallycoherent] = ACTIONS(3429),
    [anon_sym_centroid] = ACTIONS(3429),
    [anon_sym_noperspective] = ACTIONS(3429),
    [anon_sym_nointerpolation] = ACTIONS(3429),
    [anon_sym_sample] = ACTIONS(3429),
    [anon_sym_linear] = ACTIONS(3429),
    [anon_sym_snorm] = ACTIONS(3429),
    [anon_sym_unorm] = ACTIONS(3429),
    [anon_sym_point] = ACTIONS(3429),
    [anon_sym_line] = ACTIONS(3429),
    [anon_sym_triangleadj] = ACTIONS(3429),
    [anon_sym_lineadj] = ACTIONS(3429),
    [anon_sym_triangle] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_extension] = ACTIONS(3429),
    [anon_sym___init] = ACTIONS(3429),
    [anon_sym___subscript] = ACTIONS(3429),
    [anon_sym_property] = ACTIONS(3429),
    [anon_sym_associatedtype] = ACTIONS(3429),
  },
  [2000] = {
    [sym_expression] = STATE(5485),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2001] = {
    [sym_expression] = STATE(5239),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2002] = {
    [sym_expression] = STATE(4177),
    [sym__string] = STATE(4545),
    [sym_conditional_expression] = STATE(4545),
    [sym_assignment_expression] = STATE(4545),
    [sym_pointer_expression] = STATE(4540),
    [sym_unary_expression] = STATE(4545),
    [sym_binary_expression] = STATE(4545),
    [sym_update_expression] = STATE(4545),
    [sym_cast_expression] = STATE(4545),
    [sym_sizeof_expression] = STATE(4545),
    [sym_alignof_expression] = STATE(4545),
    [sym_offsetof_expression] = STATE(4545),
    [sym_generic_expression] = STATE(4545),
    [sym_subscript_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_gnu_asm_expression] = STATE(4545),
    [sym_field_expression] = STATE(4540),
    [sym_compound_literal_expression] = STATE(4545),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_char_literal] = STATE(4286),
    [sym_concatenated_string] = STATE(4290),
    [sym_string_literal] = STATE(3166),
    [sym_null] = STATE(4545),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9673),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4545),
    [sym_raw_string_literal] = STATE(3169),
    [sym_co_await_expression] = STATE(4545),
    [sym_new_expression] = STATE(4545),
    [sym_delete_expression] = STATE(4545),
    [sym_requires_clause] = STATE(4545),
    [sym_requires_expression] = STATE(4545),
    [sym_lambda_expression] = STATE(4545),
    [sym_lambda_capture_specifier] = STATE(7034),
    [sym_fold_expression] = STATE(4545),
    [sym_parameter_pack_expansion] = STATE(4545),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4540),
    [sym_qualified_type_identifier] = STATE(9673),
    [sym_user_defined_literal] = STATE(4540),
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_LPAREN2] = ACTIONS(5828),
    [anon_sym_BANG] = ACTIONS(4733),
    [anon_sym_TILDE] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4731),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4735),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4739),
    [anon_sym_not] = ACTIONS(4731),
    [anon_sym_compl] = ACTIONS(4731),
    [anon_sym_DASH_DASH] = ACTIONS(5711),
    [anon_sym_PLUS_PLUS] = ACTIONS(5711),
    [anon_sym_sizeof] = ACTIONS(4741),
    [anon_sym___alignof__] = ACTIONS(4743),
    [anon_sym___alignof] = ACTIONS(4743),
    [anon_sym__alignof] = ACTIONS(4743),
    [anon_sym_alignof] = ACTIONS(4743),
    [anon_sym__Alignof] = ACTIONS(4743),
    [anon_sym_offsetof] = ACTIONS(4745),
    [anon_sym__Generic] = ACTIONS(4747),
    [anon_sym_asm] = ACTIONS(4749),
    [anon_sym___asm__] = ACTIONS(4749),
    [sym_number_literal] = ACTIONS(4751),
    [anon_sym_L_SQUOTE] = ACTIONS(4753),
    [anon_sym_u_SQUOTE] = ACTIONS(4753),
    [anon_sym_U_SQUOTE] = ACTIONS(4753),
    [anon_sym_u8_SQUOTE] = ACTIONS(4753),
    [anon_sym_SQUOTE] = ACTIONS(4753),
    [anon_sym_L_DQUOTE] = ACTIONS(4755),
    [anon_sym_u_DQUOTE] = ACTIONS(4755),
    [anon_sym_U_DQUOTE] = ACTIONS(4755),
    [anon_sym_u8_DQUOTE] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [anon_sym_NULL] = ACTIONS(4759),
    [anon_sym_nullptr] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4761),
    [anon_sym_R_DQUOTE] = ACTIONS(4763),
    [anon_sym_LR_DQUOTE] = ACTIONS(4763),
    [anon_sym_uR_DQUOTE] = ACTIONS(4763),
    [anon_sym_UR_DQUOTE] = ACTIONS(4763),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4763),
    [anon_sym_co_await] = ACTIONS(4765),
    [anon_sym_new] = ACTIONS(4767),
    [anon_sym_requires] = ACTIONS(4769),
    [sym_this] = ACTIONS(4757),
  },
  [2003] = {
    [sym_expression] = STATE(5580),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2004] = {
    [sym_identifier] = ACTIONS(3433),
    [aux_sym_preproc_def_token1] = ACTIONS(3433),
    [aux_sym_preproc_if_token1] = ACTIONS(3433),
    [aux_sym_preproc_if_token2] = ACTIONS(3433),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3433),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3433),
    [sym_preproc_directive] = ACTIONS(3433),
    [anon_sym_LPAREN2] = ACTIONS(3435),
    [anon_sym_TILDE] = ACTIONS(3435),
    [anon_sym_STAR] = ACTIONS(3435),
    [anon_sym_AMP_AMP] = ACTIONS(3435),
    [anon_sym_AMP] = ACTIONS(3433),
    [anon_sym___extension__] = ACTIONS(3433),
    [anon_sym_typedef] = ACTIONS(3433),
    [anon_sym_in] = ACTIONS(3433),
    [anon_sym_out] = ACTIONS(3433),
    [anon_sym_inout] = ACTIONS(3433),
    [anon_sym_extern] = ACTIONS(3433),
    [anon_sym___attribute__] = ACTIONS(3433),
    [anon_sym_COLON_COLON] = ACTIONS(3435),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3435),
    [anon_sym___declspec] = ACTIONS(3433),
    [anon_sym___based] = ACTIONS(3433),
    [anon_sym_signed] = ACTIONS(3433),
    [anon_sym_unsigned] = ACTIONS(3433),
    [anon_sym_long] = ACTIONS(3433),
    [anon_sym_short] = ACTIONS(3433),
    [anon_sym_LBRACK] = ACTIONS(3433),
    [anon_sym_static] = ACTIONS(3433),
    [anon_sym_register] = ACTIONS(3433),
    [anon_sym_inline] = ACTIONS(3433),
    [anon_sym___inline] = ACTIONS(3433),
    [anon_sym___inline__] = ACTIONS(3433),
    [anon_sym___forceinline] = ACTIONS(3433),
    [anon_sym_thread_local] = ACTIONS(3433),
    [anon_sym___thread] = ACTIONS(3433),
    [anon_sym_const] = ACTIONS(3433),
    [anon_sym_constexpr] = ACTIONS(3433),
    [anon_sym_volatile] = ACTIONS(3433),
    [anon_sym_restrict] = ACTIONS(3433),
    [anon_sym___restrict__] = ACTIONS(3433),
    [anon_sym__Atomic] = ACTIONS(3433),
    [anon_sym__Noreturn] = ACTIONS(3433),
    [anon_sym_noreturn] = ACTIONS(3433),
    [anon_sym_mutable] = ACTIONS(3433),
    [anon_sym_constinit] = ACTIONS(3433),
    [anon_sym_consteval] = ACTIONS(3433),
    [anon_sym_alignas] = ACTIONS(3433),
    [anon_sym__Alignas] = ACTIONS(3433),
    [sym_primitive_type] = ACTIONS(3433),
    [anon_sym_enum] = ACTIONS(3433),
    [anon_sym_class] = ACTIONS(3433),
    [anon_sym_struct] = ACTIONS(3433),
    [anon_sym_union] = ACTIONS(3433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3433),
    [anon_sym_let] = ACTIONS(3433),
    [anon_sym_This] = ACTIONS(3433),
    [anon_sym_decltype] = ACTIONS(3433),
    [sym_virtual] = ACTIONS(3433),
    [anon_sym_explicit] = ACTIONS(3433),
    [anon_sym_typename] = ACTIONS(3433),
    [anon_sym_template] = ACTIONS(3433),
    [anon_sym_operator] = ACTIONS(3433),
    [anon_sym_friend] = ACTIONS(3433),
    [anon_sym_public] = ACTIONS(3433),
    [anon_sym_private] = ACTIONS(3433),
    [anon_sym_protected] = ACTIONS(3433),
    [anon_sym_using] = ACTIONS(3433),
    [anon_sym_static_assert] = ACTIONS(3433),
    [anon_sym_precise] = ACTIONS(3433),
    [anon_sym_shared] = ACTIONS(3433),
    [anon_sym_groupshared] = ACTIONS(3433),
    [anon_sym_uniform] = ACTIONS(3433),
    [anon_sym_row_major] = ACTIONS(3433),
    [anon_sym_column_major] = ACTIONS(3433),
    [anon_sym_globallycoherent] = ACTIONS(3433),
    [anon_sym_centroid] = ACTIONS(3433),
    [anon_sym_noperspective] = ACTIONS(3433),
    [anon_sym_nointerpolation] = ACTIONS(3433),
    [anon_sym_sample] = ACTIONS(3433),
    [anon_sym_linear] = ACTIONS(3433),
    [anon_sym_snorm] = ACTIONS(3433),
    [anon_sym_unorm] = ACTIONS(3433),
    [anon_sym_point] = ACTIONS(3433),
    [anon_sym_line] = ACTIONS(3433),
    [anon_sym_triangleadj] = ACTIONS(3433),
    [anon_sym_lineadj] = ACTIONS(3433),
    [anon_sym_triangle] = ACTIONS(3433),
    [anon_sym_interface] = ACTIONS(3433),
    [anon_sym_extension] = ACTIONS(3433),
    [anon_sym___init] = ACTIONS(3433),
    [anon_sym___subscript] = ACTIONS(3433),
    [anon_sym_property] = ACTIONS(3433),
    [anon_sym_associatedtype] = ACTIONS(3433),
  },
  [2005] = {
    [sym_expression] = STATE(5241),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2006] = {
    [sym_identifier] = ACTIONS(3437),
    [aux_sym_preproc_def_token1] = ACTIONS(3437),
    [aux_sym_preproc_if_token1] = ACTIONS(3437),
    [aux_sym_preproc_if_token2] = ACTIONS(3437),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3437),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3437),
    [sym_preproc_directive] = ACTIONS(3437),
    [anon_sym_LPAREN2] = ACTIONS(3439),
    [anon_sym_TILDE] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(3439),
    [anon_sym_AMP_AMP] = ACTIONS(3439),
    [anon_sym_AMP] = ACTIONS(3437),
    [anon_sym___extension__] = ACTIONS(3437),
    [anon_sym_typedef] = ACTIONS(3437),
    [anon_sym_in] = ACTIONS(3437),
    [anon_sym_out] = ACTIONS(3437),
    [anon_sym_inout] = ACTIONS(3437),
    [anon_sym_extern] = ACTIONS(3437),
    [anon_sym___attribute__] = ACTIONS(3437),
    [anon_sym_COLON_COLON] = ACTIONS(3439),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3439),
    [anon_sym___declspec] = ACTIONS(3437),
    [anon_sym___based] = ACTIONS(3437),
    [anon_sym_signed] = ACTIONS(3437),
    [anon_sym_unsigned] = ACTIONS(3437),
    [anon_sym_long] = ACTIONS(3437),
    [anon_sym_short] = ACTIONS(3437),
    [anon_sym_LBRACK] = ACTIONS(3437),
    [anon_sym_static] = ACTIONS(3437),
    [anon_sym_register] = ACTIONS(3437),
    [anon_sym_inline] = ACTIONS(3437),
    [anon_sym___inline] = ACTIONS(3437),
    [anon_sym___inline__] = ACTIONS(3437),
    [anon_sym___forceinline] = ACTIONS(3437),
    [anon_sym_thread_local] = ACTIONS(3437),
    [anon_sym___thread] = ACTIONS(3437),
    [anon_sym_const] = ACTIONS(3437),
    [anon_sym_constexpr] = ACTIONS(3437),
    [anon_sym_volatile] = ACTIONS(3437),
    [anon_sym_restrict] = ACTIONS(3437),
    [anon_sym___restrict__] = ACTIONS(3437),
    [anon_sym__Atomic] = ACTIONS(3437),
    [anon_sym__Noreturn] = ACTIONS(3437),
    [anon_sym_noreturn] = ACTIONS(3437),
    [anon_sym_mutable] = ACTIONS(3437),
    [anon_sym_constinit] = ACTIONS(3437),
    [anon_sym_consteval] = ACTIONS(3437),
    [anon_sym_alignas] = ACTIONS(3437),
    [anon_sym__Alignas] = ACTIONS(3437),
    [sym_primitive_type] = ACTIONS(3437),
    [anon_sym_enum] = ACTIONS(3437),
    [anon_sym_class] = ACTIONS(3437),
    [anon_sym_struct] = ACTIONS(3437),
    [anon_sym_union] = ACTIONS(3437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3437),
    [anon_sym_let] = ACTIONS(3437),
    [anon_sym_This] = ACTIONS(3437),
    [anon_sym_decltype] = ACTIONS(3437),
    [sym_virtual] = ACTIONS(3437),
    [anon_sym_explicit] = ACTIONS(3437),
    [anon_sym_typename] = ACTIONS(3437),
    [anon_sym_template] = ACTIONS(3437),
    [anon_sym_operator] = ACTIONS(3437),
    [anon_sym_friend] = ACTIONS(3437),
    [anon_sym_public] = ACTIONS(3437),
    [anon_sym_private] = ACTIONS(3437),
    [anon_sym_protected] = ACTIONS(3437),
    [anon_sym_using] = ACTIONS(3437),
    [anon_sym_static_assert] = ACTIONS(3437),
    [anon_sym_precise] = ACTIONS(3437),
    [anon_sym_shared] = ACTIONS(3437),
    [anon_sym_groupshared] = ACTIONS(3437),
    [anon_sym_uniform] = ACTIONS(3437),
    [anon_sym_row_major] = ACTIONS(3437),
    [anon_sym_column_major] = ACTIONS(3437),
    [anon_sym_globallycoherent] = ACTIONS(3437),
    [anon_sym_centroid] = ACTIONS(3437),
    [anon_sym_noperspective] = ACTIONS(3437),
    [anon_sym_nointerpolation] = ACTIONS(3437),
    [anon_sym_sample] = ACTIONS(3437),
    [anon_sym_linear] = ACTIONS(3437),
    [anon_sym_snorm] = ACTIONS(3437),
    [anon_sym_unorm] = ACTIONS(3437),
    [anon_sym_point] = ACTIONS(3437),
    [anon_sym_line] = ACTIONS(3437),
    [anon_sym_triangleadj] = ACTIONS(3437),
    [anon_sym_lineadj] = ACTIONS(3437),
    [anon_sym_triangle] = ACTIONS(3437),
    [anon_sym_interface] = ACTIONS(3437),
    [anon_sym_extension] = ACTIONS(3437),
    [anon_sym___init] = ACTIONS(3437),
    [anon_sym___subscript] = ACTIONS(3437),
    [anon_sym_property] = ACTIONS(3437),
    [anon_sym_associatedtype] = ACTIONS(3437),
  },
  [2007] = {
    [sym_expression] = STATE(5242),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2008] = {
    [sym_expression] = STATE(3840),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5781),
    [anon_sym_BANG] = ACTIONS(4611),
    [anon_sym_TILDE] = ACTIONS(4611),
    [anon_sym_DASH] = ACTIONS(4609),
    [anon_sym_PLUS] = ACTIONS(4609),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4613),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4609),
    [anon_sym_compl] = ACTIONS(4609),
    [anon_sym_DASH_DASH] = ACTIONS(5713),
    [anon_sym_PLUS_PLUS] = ACTIONS(5713),
    [anon_sym_sizeof] = ACTIONS(4615),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4617),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4619),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2009] = {
    [sym_expression] = STATE(3736),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(4134),
    [sym_concatenated_string] = STATE(4159),
    [sym_string_literal] = STATE(3152),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(3145),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4587),
    [anon_sym_LPAREN2] = ACTIONS(5819),
    [anon_sym_BANG] = ACTIONS(4591),
    [anon_sym_TILDE] = ACTIONS(4591),
    [anon_sym_DASH] = ACTIONS(4589),
    [anon_sym_PLUS] = ACTIONS(4589),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4593),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4589),
    [anon_sym_compl] = ACTIONS(4589),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_sizeof] = ACTIONS(4595),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4597),
    [anon_sym_L_SQUOTE] = ACTIONS(4599),
    [anon_sym_u_SQUOTE] = ACTIONS(4599),
    [anon_sym_U_SQUOTE] = ACTIONS(4599),
    [anon_sym_u8_SQUOTE] = ACTIONS(4599),
    [anon_sym_SQUOTE] = ACTIONS(4599),
    [anon_sym_L_DQUOTE] = ACTIONS(4601),
    [anon_sym_u_DQUOTE] = ACTIONS(4601),
    [anon_sym_U_DQUOTE] = ACTIONS(4601),
    [anon_sym_u8_DQUOTE] = ACTIONS(4601),
    [anon_sym_DQUOTE] = ACTIONS(4601),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4603),
    [anon_sym_R_DQUOTE] = ACTIONS(4605),
    [anon_sym_LR_DQUOTE] = ACTIONS(4605),
    [anon_sym_uR_DQUOTE] = ACTIONS(4605),
    [anon_sym_UR_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4605),
    [anon_sym_co_await] = ACTIONS(4607),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2010] = {
    [sym_identifier] = ACTIONS(3645),
    [aux_sym_preproc_def_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token1] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3645),
    [sym_preproc_directive] = ACTIONS(3645),
    [anon_sym_LPAREN2] = ACTIONS(3647),
    [anon_sym_TILDE] = ACTIONS(3647),
    [anon_sym_STAR] = ACTIONS(3647),
    [anon_sym_AMP_AMP] = ACTIONS(3647),
    [anon_sym_AMP] = ACTIONS(3645),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3645),
    [anon_sym_in] = ACTIONS(3645),
    [anon_sym_out] = ACTIONS(3645),
    [anon_sym_inout] = ACTIONS(3645),
    [anon_sym_extern] = ACTIONS(3645),
    [anon_sym___attribute__] = ACTIONS(3645),
    [anon_sym_COLON_COLON] = ACTIONS(3647),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3647),
    [anon_sym___declspec] = ACTIONS(3645),
    [anon_sym___based] = ACTIONS(3645),
    [anon_sym_RBRACE] = ACTIONS(3647),
    [anon_sym_signed] = ACTIONS(3645),
    [anon_sym_unsigned] = ACTIONS(3645),
    [anon_sym_long] = ACTIONS(3645),
    [anon_sym_short] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_static] = ACTIONS(3645),
    [anon_sym_register] = ACTIONS(3645),
    [anon_sym_inline] = ACTIONS(3645),
    [anon_sym___inline] = ACTIONS(3645),
    [anon_sym___inline__] = ACTIONS(3645),
    [anon_sym___forceinline] = ACTIONS(3645),
    [anon_sym_thread_local] = ACTIONS(3645),
    [anon_sym___thread] = ACTIONS(3645),
    [anon_sym_const] = ACTIONS(3645),
    [anon_sym_constexpr] = ACTIONS(3645),
    [anon_sym_volatile] = ACTIONS(3645),
    [anon_sym_restrict] = ACTIONS(3645),
    [anon_sym___restrict__] = ACTIONS(3645),
    [anon_sym__Atomic] = ACTIONS(3645),
    [anon_sym__Noreturn] = ACTIONS(3645),
    [anon_sym_noreturn] = ACTIONS(3645),
    [anon_sym_mutable] = ACTIONS(3645),
    [anon_sym_constinit] = ACTIONS(3645),
    [anon_sym_consteval] = ACTIONS(3645),
    [anon_sym_alignas] = ACTIONS(3645),
    [anon_sym__Alignas] = ACTIONS(3645),
    [sym_primitive_type] = ACTIONS(3645),
    [anon_sym_enum] = ACTIONS(3645),
    [anon_sym_class] = ACTIONS(3645),
    [anon_sym_struct] = ACTIONS(3645),
    [anon_sym_union] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3645),
    [anon_sym_let] = ACTIONS(3645),
    [anon_sym_This] = ACTIONS(3645),
    [anon_sym_decltype] = ACTIONS(3645),
    [sym_virtual] = ACTIONS(3645),
    [anon_sym_explicit] = ACTIONS(3645),
    [anon_sym_typename] = ACTIONS(3645),
    [anon_sym_template] = ACTIONS(3645),
    [anon_sym_operator] = ACTIONS(3645),
    [anon_sym_friend] = ACTIONS(3645),
    [anon_sym_public] = ACTIONS(3645),
    [anon_sym_private] = ACTIONS(3645),
    [anon_sym_protected] = ACTIONS(3645),
    [anon_sym_using] = ACTIONS(3645),
    [anon_sym_static_assert] = ACTIONS(3645),
    [anon_sym_precise] = ACTIONS(3645),
    [anon_sym_shared] = ACTIONS(3645),
    [anon_sym_groupshared] = ACTIONS(3645),
    [anon_sym_uniform] = ACTIONS(3645),
    [anon_sym_row_major] = ACTIONS(3645),
    [anon_sym_column_major] = ACTIONS(3645),
    [anon_sym_globallycoherent] = ACTIONS(3645),
    [anon_sym_centroid] = ACTIONS(3645),
    [anon_sym_noperspective] = ACTIONS(3645),
    [anon_sym_nointerpolation] = ACTIONS(3645),
    [anon_sym_sample] = ACTIONS(3645),
    [anon_sym_linear] = ACTIONS(3645),
    [anon_sym_snorm] = ACTIONS(3645),
    [anon_sym_unorm] = ACTIONS(3645),
    [anon_sym_point] = ACTIONS(3645),
    [anon_sym_line] = ACTIONS(3645),
    [anon_sym_triangleadj] = ACTIONS(3645),
    [anon_sym_lineadj] = ACTIONS(3645),
    [anon_sym_triangle] = ACTIONS(3645),
    [anon_sym_interface] = ACTIONS(3645),
    [anon_sym_extension] = ACTIONS(3645),
    [anon_sym___init] = ACTIONS(3645),
    [anon_sym___subscript] = ACTIONS(3645),
    [anon_sym_property] = ACTIONS(3645),
    [anon_sym_associatedtype] = ACTIONS(3645),
  },
  [2011] = {
    [sym_identifier] = ACTIONS(3645),
    [aux_sym_preproc_def_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token1] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3645),
    [sym_preproc_directive] = ACTIONS(3645),
    [anon_sym_LPAREN2] = ACTIONS(3647),
    [anon_sym_TILDE] = ACTIONS(3647),
    [anon_sym_STAR] = ACTIONS(3647),
    [anon_sym_AMP_AMP] = ACTIONS(3647),
    [anon_sym_AMP] = ACTIONS(3645),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3645),
    [anon_sym_in] = ACTIONS(3645),
    [anon_sym_out] = ACTIONS(3645),
    [anon_sym_inout] = ACTIONS(3645),
    [anon_sym_extern] = ACTIONS(3645),
    [anon_sym___attribute__] = ACTIONS(3645),
    [anon_sym_COLON_COLON] = ACTIONS(3647),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3647),
    [anon_sym___declspec] = ACTIONS(3645),
    [anon_sym___based] = ACTIONS(3645),
    [anon_sym_RBRACE] = ACTIONS(3647),
    [anon_sym_signed] = ACTIONS(3645),
    [anon_sym_unsigned] = ACTIONS(3645),
    [anon_sym_long] = ACTIONS(3645),
    [anon_sym_short] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_static] = ACTIONS(3645),
    [anon_sym_register] = ACTIONS(3645),
    [anon_sym_inline] = ACTIONS(3645),
    [anon_sym___inline] = ACTIONS(3645),
    [anon_sym___inline__] = ACTIONS(3645),
    [anon_sym___forceinline] = ACTIONS(3645),
    [anon_sym_thread_local] = ACTIONS(3645),
    [anon_sym___thread] = ACTIONS(3645),
    [anon_sym_const] = ACTIONS(3645),
    [anon_sym_constexpr] = ACTIONS(3645),
    [anon_sym_volatile] = ACTIONS(3645),
    [anon_sym_restrict] = ACTIONS(3645),
    [anon_sym___restrict__] = ACTIONS(3645),
    [anon_sym__Atomic] = ACTIONS(3645),
    [anon_sym__Noreturn] = ACTIONS(3645),
    [anon_sym_noreturn] = ACTIONS(3645),
    [anon_sym_mutable] = ACTIONS(3645),
    [anon_sym_constinit] = ACTIONS(3645),
    [anon_sym_consteval] = ACTIONS(3645),
    [anon_sym_alignas] = ACTIONS(3645),
    [anon_sym__Alignas] = ACTIONS(3645),
    [sym_primitive_type] = ACTIONS(3645),
    [anon_sym_enum] = ACTIONS(3645),
    [anon_sym_class] = ACTIONS(3645),
    [anon_sym_struct] = ACTIONS(3645),
    [anon_sym_union] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3645),
    [anon_sym_let] = ACTIONS(3645),
    [anon_sym_This] = ACTIONS(3645),
    [anon_sym_decltype] = ACTIONS(3645),
    [sym_virtual] = ACTIONS(3645),
    [anon_sym_explicit] = ACTIONS(3645),
    [anon_sym_typename] = ACTIONS(3645),
    [anon_sym_template] = ACTIONS(3645),
    [anon_sym_operator] = ACTIONS(3645),
    [anon_sym_friend] = ACTIONS(3645),
    [anon_sym_public] = ACTIONS(3645),
    [anon_sym_private] = ACTIONS(3645),
    [anon_sym_protected] = ACTIONS(3645),
    [anon_sym_using] = ACTIONS(3645),
    [anon_sym_static_assert] = ACTIONS(3645),
    [anon_sym_precise] = ACTIONS(3645),
    [anon_sym_shared] = ACTIONS(3645),
    [anon_sym_groupshared] = ACTIONS(3645),
    [anon_sym_uniform] = ACTIONS(3645),
    [anon_sym_row_major] = ACTIONS(3645),
    [anon_sym_column_major] = ACTIONS(3645),
    [anon_sym_globallycoherent] = ACTIONS(3645),
    [anon_sym_centroid] = ACTIONS(3645),
    [anon_sym_noperspective] = ACTIONS(3645),
    [anon_sym_nointerpolation] = ACTIONS(3645),
    [anon_sym_sample] = ACTIONS(3645),
    [anon_sym_linear] = ACTIONS(3645),
    [anon_sym_snorm] = ACTIONS(3645),
    [anon_sym_unorm] = ACTIONS(3645),
    [anon_sym_point] = ACTIONS(3645),
    [anon_sym_line] = ACTIONS(3645),
    [anon_sym_triangleadj] = ACTIONS(3645),
    [anon_sym_lineadj] = ACTIONS(3645),
    [anon_sym_triangle] = ACTIONS(3645),
    [anon_sym_interface] = ACTIONS(3645),
    [anon_sym_extension] = ACTIONS(3645),
    [anon_sym___init] = ACTIONS(3645),
    [anon_sym___subscript] = ACTIONS(3645),
    [anon_sym_property] = ACTIONS(3645),
    [anon_sym_associatedtype] = ACTIONS(3645),
  },
  [2012] = {
    [sym_expression] = STATE(3215),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2013] = {
    [sym_expression] = STATE(3842),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5781),
    [anon_sym_BANG] = ACTIONS(4611),
    [anon_sym_TILDE] = ACTIONS(4611),
    [anon_sym_DASH] = ACTIONS(4609),
    [anon_sym_PLUS] = ACTIONS(4609),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4613),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4609),
    [anon_sym_compl] = ACTIONS(4609),
    [anon_sym_DASH_DASH] = ACTIONS(5713),
    [anon_sym_PLUS_PLUS] = ACTIONS(5713),
    [anon_sym_sizeof] = ACTIONS(4615),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4617),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4619),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2014] = {
    [sym_expression] = STATE(5581),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2015] = {
    [sym_expression] = STATE(5244),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2016] = {
    [sym_expression] = STATE(5193),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2017] = {
    [sym_expression] = STATE(5597),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2018] = {
    [sym_expression] = STATE(3792),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5781),
    [anon_sym_BANG] = ACTIONS(4611),
    [anon_sym_TILDE] = ACTIONS(4611),
    [anon_sym_DASH] = ACTIONS(4609),
    [anon_sym_PLUS] = ACTIONS(4609),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4613),
    [anon_sym_LBRACK] = ACTIONS(6082),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4609),
    [anon_sym_compl] = ACTIONS(4609),
    [anon_sym_DASH_DASH] = ACTIONS(5713),
    [anon_sym_PLUS_PLUS] = ACTIONS(5713),
    [anon_sym_sizeof] = ACTIONS(4615),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4617),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4619),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2019] = {
    [sym_expression] = STATE(5245),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2020] = {
    [sym_expression] = STATE(5351),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2021] = {
    [sym_expression] = STATE(3441),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3481),
    [sym_concatenated_string] = STATE(3486),
    [sym_string_literal] = STATE(2963),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2960),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5795),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4412),
    [anon_sym_PLUS] = ACTIONS(4412),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4416),
    [anon_sym_LBRACK] = ACTIONS(6084),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4412),
    [anon_sym_compl] = ACTIONS(4412),
    [anon_sym_DASH_DASH] = ACTIONS(5756),
    [anon_sym_PLUS_PLUS] = ACTIONS(5756),
    [anon_sym_sizeof] = ACTIONS(4422),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4432),
    [anon_sym_L_SQUOTE] = ACTIONS(4434),
    [anon_sym_u_SQUOTE] = ACTIONS(4434),
    [anon_sym_U_SQUOTE] = ACTIONS(4434),
    [anon_sym_u8_SQUOTE] = ACTIONS(4434),
    [anon_sym_SQUOTE] = ACTIONS(4434),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4442),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [anon_sym_co_await] = ACTIONS(4446),
    [anon_sym_new] = ACTIONS(4448),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2022] = {
    [sym_expression] = STATE(5192),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2023] = {
    [sym_expression] = STATE(5442),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2024] = {
    [sym_expression] = STATE(3595),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2025] = {
    [sym_expression] = STATE(3212),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2026] = {
    [sym_expression] = STATE(3591),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2027] = {
    [sym_expression] = STATE(3579),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2028] = {
    [sym_expression] = STATE(3576),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2029] = {
    [sym_expression] = STATE(3575),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2030] = {
    [sym_expression] = STATE(3568),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2031] = {
    [sym_expression] = STATE(3564),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2032] = {
    [sym_expression] = STATE(3556),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2033] = {
    [sym_expression] = STATE(3520),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2034] = {
    [sym_expression] = STATE(3754),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [2035] = {
    [sym_identifier] = ACTIONS(3531),
    [aux_sym_preproc_def_token1] = ACTIONS(3531),
    [aux_sym_preproc_if_token1] = ACTIONS(3531),
    [aux_sym_preproc_if_token2] = ACTIONS(3531),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3531),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3531),
    [sym_preproc_directive] = ACTIONS(3531),
    [anon_sym_LPAREN2] = ACTIONS(3533),
    [anon_sym_TILDE] = ACTIONS(3533),
    [anon_sym_STAR] = ACTIONS(3533),
    [anon_sym_AMP_AMP] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym___extension__] = ACTIONS(3531),
    [anon_sym_typedef] = ACTIONS(3531),
    [anon_sym_in] = ACTIONS(3531),
    [anon_sym_out] = ACTIONS(3531),
    [anon_sym_inout] = ACTIONS(3531),
    [anon_sym_extern] = ACTIONS(3531),
    [anon_sym___attribute__] = ACTIONS(3531),
    [anon_sym_COLON_COLON] = ACTIONS(3533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3533),
    [anon_sym___declspec] = ACTIONS(3531),
    [anon_sym___based] = ACTIONS(3531),
    [anon_sym_signed] = ACTIONS(3531),
    [anon_sym_unsigned] = ACTIONS(3531),
    [anon_sym_long] = ACTIONS(3531),
    [anon_sym_short] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_static] = ACTIONS(3531),
    [anon_sym_register] = ACTIONS(3531),
    [anon_sym_inline] = ACTIONS(3531),
    [anon_sym___inline] = ACTIONS(3531),
    [anon_sym___inline__] = ACTIONS(3531),
    [anon_sym___forceinline] = ACTIONS(3531),
    [anon_sym_thread_local] = ACTIONS(3531),
    [anon_sym___thread] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3531),
    [anon_sym_constexpr] = ACTIONS(3531),
    [anon_sym_volatile] = ACTIONS(3531),
    [anon_sym_restrict] = ACTIONS(3531),
    [anon_sym___restrict__] = ACTIONS(3531),
    [anon_sym__Atomic] = ACTIONS(3531),
    [anon_sym__Noreturn] = ACTIONS(3531),
    [anon_sym_noreturn] = ACTIONS(3531),
    [anon_sym_mutable] = ACTIONS(3531),
    [anon_sym_constinit] = ACTIONS(3531),
    [anon_sym_consteval] = ACTIONS(3531),
    [anon_sym_alignas] = ACTIONS(3531),
    [anon_sym__Alignas] = ACTIONS(3531),
    [sym_primitive_type] = ACTIONS(3531),
    [anon_sym_enum] = ACTIONS(3531),
    [anon_sym_class] = ACTIONS(3531),
    [anon_sym_struct] = ACTIONS(3531),
    [anon_sym_union] = ACTIONS(3531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_This] = ACTIONS(3531),
    [anon_sym_decltype] = ACTIONS(3531),
    [sym_virtual] = ACTIONS(3531),
    [anon_sym_explicit] = ACTIONS(3531),
    [anon_sym_typename] = ACTIONS(3531),
    [anon_sym_template] = ACTIONS(3531),
    [anon_sym_operator] = ACTIONS(3531),
    [anon_sym_friend] = ACTIONS(3531),
    [anon_sym_public] = ACTIONS(3531),
    [anon_sym_private] = ACTIONS(3531),
    [anon_sym_protected] = ACTIONS(3531),
    [anon_sym_using] = ACTIONS(3531),
    [anon_sym_static_assert] = ACTIONS(3531),
    [anon_sym_precise] = ACTIONS(3531),
    [anon_sym_shared] = ACTIONS(3531),
    [anon_sym_groupshared] = ACTIONS(3531),
    [anon_sym_uniform] = ACTIONS(3531),
    [anon_sym_row_major] = ACTIONS(3531),
    [anon_sym_column_major] = ACTIONS(3531),
    [anon_sym_globallycoherent] = ACTIONS(3531),
    [anon_sym_centroid] = ACTIONS(3531),
    [anon_sym_noperspective] = ACTIONS(3531),
    [anon_sym_nointerpolation] = ACTIONS(3531),
    [anon_sym_sample] = ACTIONS(3531),
    [anon_sym_linear] = ACTIONS(3531),
    [anon_sym_snorm] = ACTIONS(3531),
    [anon_sym_unorm] = ACTIONS(3531),
    [anon_sym_point] = ACTIONS(3531),
    [anon_sym_line] = ACTIONS(3531),
    [anon_sym_triangleadj] = ACTIONS(3531),
    [anon_sym_lineadj] = ACTIONS(3531),
    [anon_sym_triangle] = ACTIONS(3531),
    [anon_sym_interface] = ACTIONS(3531),
    [anon_sym_extension] = ACTIONS(3531),
    [anon_sym___init] = ACTIONS(3531),
    [anon_sym___subscript] = ACTIONS(3531),
    [anon_sym_property] = ACTIONS(3531),
    [anon_sym_associatedtype] = ACTIONS(3531),
  },
  [2036] = {
    [sym_expression] = STATE(5589),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2037] = {
    [sym_identifier] = ACTIONS(3597),
    [aux_sym_preproc_def_token1] = ACTIONS(3597),
    [aux_sym_preproc_if_token1] = ACTIONS(3597),
    [aux_sym_preproc_if_token2] = ACTIONS(3597),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3597),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3597),
    [sym_preproc_directive] = ACTIONS(3597),
    [anon_sym_LPAREN2] = ACTIONS(3599),
    [anon_sym_TILDE] = ACTIONS(3599),
    [anon_sym_STAR] = ACTIONS(3599),
    [anon_sym_AMP_AMP] = ACTIONS(3599),
    [anon_sym_AMP] = ACTIONS(3597),
    [anon_sym___extension__] = ACTIONS(3597),
    [anon_sym_typedef] = ACTIONS(3597),
    [anon_sym_in] = ACTIONS(3597),
    [anon_sym_out] = ACTIONS(3597),
    [anon_sym_inout] = ACTIONS(3597),
    [anon_sym_extern] = ACTIONS(3597),
    [anon_sym___attribute__] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3599),
    [anon_sym___declspec] = ACTIONS(3597),
    [anon_sym___based] = ACTIONS(3597),
    [anon_sym_signed] = ACTIONS(3597),
    [anon_sym_unsigned] = ACTIONS(3597),
    [anon_sym_long] = ACTIONS(3597),
    [anon_sym_short] = ACTIONS(3597),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_static] = ACTIONS(3597),
    [anon_sym_register] = ACTIONS(3597),
    [anon_sym_inline] = ACTIONS(3597),
    [anon_sym___inline] = ACTIONS(3597),
    [anon_sym___inline__] = ACTIONS(3597),
    [anon_sym___forceinline] = ACTIONS(3597),
    [anon_sym_thread_local] = ACTIONS(3597),
    [anon_sym___thread] = ACTIONS(3597),
    [anon_sym_const] = ACTIONS(3597),
    [anon_sym_constexpr] = ACTIONS(3597),
    [anon_sym_volatile] = ACTIONS(3597),
    [anon_sym_restrict] = ACTIONS(3597),
    [anon_sym___restrict__] = ACTIONS(3597),
    [anon_sym__Atomic] = ACTIONS(3597),
    [anon_sym__Noreturn] = ACTIONS(3597),
    [anon_sym_noreturn] = ACTIONS(3597),
    [anon_sym_mutable] = ACTIONS(3597),
    [anon_sym_constinit] = ACTIONS(3597),
    [anon_sym_consteval] = ACTIONS(3597),
    [anon_sym_alignas] = ACTIONS(3597),
    [anon_sym__Alignas] = ACTIONS(3597),
    [sym_primitive_type] = ACTIONS(3597),
    [anon_sym_enum] = ACTIONS(3597),
    [anon_sym_class] = ACTIONS(3597),
    [anon_sym_struct] = ACTIONS(3597),
    [anon_sym_union] = ACTIONS(3597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3597),
    [anon_sym_let] = ACTIONS(3597),
    [anon_sym_This] = ACTIONS(3597),
    [anon_sym_decltype] = ACTIONS(3597),
    [sym_virtual] = ACTIONS(3597),
    [anon_sym_explicit] = ACTIONS(3597),
    [anon_sym_typename] = ACTIONS(3597),
    [anon_sym_template] = ACTIONS(3597),
    [anon_sym_operator] = ACTIONS(3597),
    [anon_sym_friend] = ACTIONS(3597),
    [anon_sym_public] = ACTIONS(3597),
    [anon_sym_private] = ACTIONS(3597),
    [anon_sym_protected] = ACTIONS(3597),
    [anon_sym_using] = ACTIONS(3597),
    [anon_sym_static_assert] = ACTIONS(3597),
    [anon_sym_precise] = ACTIONS(3597),
    [anon_sym_shared] = ACTIONS(3597),
    [anon_sym_groupshared] = ACTIONS(3597),
    [anon_sym_uniform] = ACTIONS(3597),
    [anon_sym_row_major] = ACTIONS(3597),
    [anon_sym_column_major] = ACTIONS(3597),
    [anon_sym_globallycoherent] = ACTIONS(3597),
    [anon_sym_centroid] = ACTIONS(3597),
    [anon_sym_noperspective] = ACTIONS(3597),
    [anon_sym_nointerpolation] = ACTIONS(3597),
    [anon_sym_sample] = ACTIONS(3597),
    [anon_sym_linear] = ACTIONS(3597),
    [anon_sym_snorm] = ACTIONS(3597),
    [anon_sym_unorm] = ACTIONS(3597),
    [anon_sym_point] = ACTIONS(3597),
    [anon_sym_line] = ACTIONS(3597),
    [anon_sym_triangleadj] = ACTIONS(3597),
    [anon_sym_lineadj] = ACTIONS(3597),
    [anon_sym_triangle] = ACTIONS(3597),
    [anon_sym_interface] = ACTIONS(3597),
    [anon_sym_extension] = ACTIONS(3597),
    [anon_sym___init] = ACTIONS(3597),
    [anon_sym___subscript] = ACTIONS(3597),
    [anon_sym_property] = ACTIONS(3597),
    [anon_sym_associatedtype] = ACTIONS(3597),
  },
  [2038] = {
    [sym__declaration_modifiers] = STATE(2777),
    [sym_attribute_specifier] = STATE(2777),
    [sym_attribute_declaration] = STATE(2777),
    [sym_ms_declspec_modifier] = STATE(2777),
    [sym_storage_class_specifier] = STATE(2777),
    [sym_type_qualifier] = STATE(2777),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2687),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2777),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2777),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(6086),
    [anon_sym_out] = ACTIONS(6086),
    [anon_sym_inout] = ACTIONS(6086),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(203),
    [anon_sym_class] = ACTIONS(205),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_union] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(6086),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_extension] = ACTIONS(273),
  },
  [2039] = {
    [sym_expression] = STATE(5254),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2040] = {
    [sym_expression] = STATE(5257),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2041] = {
    [sym_expression] = STATE(5200),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2042] = {
    [sym_expression] = STATE(4599),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4905),
    [sym_concatenated_string] = STATE(4902),
    [sym_string_literal] = STATE(3611),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3610),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(5705),
    [anon_sym_LPAREN2] = ACTIONS(5834),
    [anon_sym_BANG] = ACTIONS(4926),
    [anon_sym_TILDE] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4928),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4924),
    [anon_sym_compl] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(5707),
    [anon_sym_PLUS_PLUS] = ACTIONS(5707),
    [anon_sym_sizeof] = ACTIONS(4932),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4934),
    [anon_sym_L_SQUOTE] = ACTIONS(4936),
    [anon_sym_u_SQUOTE] = ACTIONS(4936),
    [anon_sym_U_SQUOTE] = ACTIONS(4936),
    [anon_sym_u8_SQUOTE] = ACTIONS(4936),
    [anon_sym_SQUOTE] = ACTIONS(4936),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4938),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_co_await] = ACTIONS(4940),
    [anon_sym_new] = ACTIONS(4942),
    [anon_sym_requires] = ACTIONS(4944),
    [sym_this] = ACTIONS(241),
  },
  [2043] = {
    [sym_identifier] = ACTIONS(3497),
    [aux_sym_preproc_def_token1] = ACTIONS(3497),
    [aux_sym_preproc_if_token1] = ACTIONS(3497),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3497),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3497),
    [sym_preproc_directive] = ACTIONS(3497),
    [anon_sym_LPAREN2] = ACTIONS(3499),
    [anon_sym_TILDE] = ACTIONS(3499),
    [anon_sym_STAR] = ACTIONS(3499),
    [anon_sym_AMP_AMP] = ACTIONS(3499),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym___extension__] = ACTIONS(3497),
    [anon_sym_typedef] = ACTIONS(3497),
    [anon_sym_in] = ACTIONS(3497),
    [anon_sym_out] = ACTIONS(3497),
    [anon_sym_inout] = ACTIONS(3497),
    [anon_sym_extern] = ACTIONS(3497),
    [anon_sym___attribute__] = ACTIONS(3497),
    [anon_sym_COLON_COLON] = ACTIONS(3499),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3499),
    [anon_sym___declspec] = ACTIONS(3497),
    [anon_sym___based] = ACTIONS(3497),
    [anon_sym_RBRACE] = ACTIONS(3499),
    [anon_sym_signed] = ACTIONS(3497),
    [anon_sym_unsigned] = ACTIONS(3497),
    [anon_sym_long] = ACTIONS(3497),
    [anon_sym_short] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3497),
    [anon_sym_static] = ACTIONS(3497),
    [anon_sym_register] = ACTIONS(3497),
    [anon_sym_inline] = ACTIONS(3497),
    [anon_sym___inline] = ACTIONS(3497),
    [anon_sym___inline__] = ACTIONS(3497),
    [anon_sym___forceinline] = ACTIONS(3497),
    [anon_sym_thread_local] = ACTIONS(3497),
    [anon_sym___thread] = ACTIONS(3497),
    [anon_sym_const] = ACTIONS(3497),
    [anon_sym_constexpr] = ACTIONS(3497),
    [anon_sym_volatile] = ACTIONS(3497),
    [anon_sym_restrict] = ACTIONS(3497),
    [anon_sym___restrict__] = ACTIONS(3497),
    [anon_sym__Atomic] = ACTIONS(3497),
    [anon_sym__Noreturn] = ACTIONS(3497),
    [anon_sym_noreturn] = ACTIONS(3497),
    [anon_sym_mutable] = ACTIONS(3497),
    [anon_sym_constinit] = ACTIONS(3497),
    [anon_sym_consteval] = ACTIONS(3497),
    [anon_sym_alignas] = ACTIONS(3497),
    [anon_sym__Alignas] = ACTIONS(3497),
    [sym_primitive_type] = ACTIONS(3497),
    [anon_sym_enum] = ACTIONS(3497),
    [anon_sym_class] = ACTIONS(3497),
    [anon_sym_struct] = ACTIONS(3497),
    [anon_sym_union] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3497),
    [anon_sym_let] = ACTIONS(3497),
    [anon_sym_This] = ACTIONS(3497),
    [anon_sym_decltype] = ACTIONS(3497),
    [sym_virtual] = ACTIONS(3497),
    [anon_sym_explicit] = ACTIONS(3497),
    [anon_sym_typename] = ACTIONS(3497),
    [anon_sym_template] = ACTIONS(3497),
    [anon_sym_operator] = ACTIONS(3497),
    [anon_sym_friend] = ACTIONS(3497),
    [anon_sym_public] = ACTIONS(3497),
    [anon_sym_private] = ACTIONS(3497),
    [anon_sym_protected] = ACTIONS(3497),
    [anon_sym_using] = ACTIONS(3497),
    [anon_sym_static_assert] = ACTIONS(3497),
    [anon_sym_precise] = ACTIONS(3497),
    [anon_sym_shared] = ACTIONS(3497),
    [anon_sym_groupshared] = ACTIONS(3497),
    [anon_sym_uniform] = ACTIONS(3497),
    [anon_sym_row_major] = ACTIONS(3497),
    [anon_sym_column_major] = ACTIONS(3497),
    [anon_sym_globallycoherent] = ACTIONS(3497),
    [anon_sym_centroid] = ACTIONS(3497),
    [anon_sym_noperspective] = ACTIONS(3497),
    [anon_sym_nointerpolation] = ACTIONS(3497),
    [anon_sym_sample] = ACTIONS(3497),
    [anon_sym_linear] = ACTIONS(3497),
    [anon_sym_snorm] = ACTIONS(3497),
    [anon_sym_unorm] = ACTIONS(3497),
    [anon_sym_point] = ACTIONS(3497),
    [anon_sym_line] = ACTIONS(3497),
    [anon_sym_triangleadj] = ACTIONS(3497),
    [anon_sym_lineadj] = ACTIONS(3497),
    [anon_sym_triangle] = ACTIONS(3497),
    [anon_sym_interface] = ACTIONS(3497),
    [anon_sym_extension] = ACTIONS(3497),
    [anon_sym___init] = ACTIONS(3497),
    [anon_sym___subscript] = ACTIONS(3497),
    [anon_sym_property] = ACTIONS(3497),
    [anon_sym_associatedtype] = ACTIONS(3497),
  },
  [2044] = {
    [sym_expression] = STATE(4654),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4905),
    [sym_concatenated_string] = STATE(4902),
    [sym_string_literal] = STATE(3611),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3610),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(5705),
    [anon_sym_LPAREN2] = ACTIONS(5834),
    [anon_sym_BANG] = ACTIONS(4926),
    [anon_sym_TILDE] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4928),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4924),
    [anon_sym_compl] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(5707),
    [anon_sym_PLUS_PLUS] = ACTIONS(5707),
    [anon_sym_sizeof] = ACTIONS(4932),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4934),
    [anon_sym_L_SQUOTE] = ACTIONS(4936),
    [anon_sym_u_SQUOTE] = ACTIONS(4936),
    [anon_sym_U_SQUOTE] = ACTIONS(4936),
    [anon_sym_u8_SQUOTE] = ACTIONS(4936),
    [anon_sym_SQUOTE] = ACTIONS(4936),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4938),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_co_await] = ACTIONS(4940),
    [anon_sym_new] = ACTIONS(4942),
    [anon_sym_requires] = ACTIONS(4944),
    [sym_this] = ACTIONS(241),
  },
  [2045] = {
    [sym_expression] = STATE(5532),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2046] = {
    [sym_identifier] = ACTIONS(3497),
    [aux_sym_preproc_def_token1] = ACTIONS(3497),
    [aux_sym_preproc_if_token1] = ACTIONS(3497),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3497),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3497),
    [sym_preproc_directive] = ACTIONS(3497),
    [anon_sym_LPAREN2] = ACTIONS(3499),
    [anon_sym_TILDE] = ACTIONS(3499),
    [anon_sym_STAR] = ACTIONS(3499),
    [anon_sym_AMP_AMP] = ACTIONS(3499),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym___extension__] = ACTIONS(3497),
    [anon_sym_typedef] = ACTIONS(3497),
    [anon_sym_in] = ACTIONS(3497),
    [anon_sym_out] = ACTIONS(3497),
    [anon_sym_inout] = ACTIONS(3497),
    [anon_sym_extern] = ACTIONS(3497),
    [anon_sym___attribute__] = ACTIONS(3497),
    [anon_sym_COLON_COLON] = ACTIONS(3499),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3499),
    [anon_sym___declspec] = ACTIONS(3497),
    [anon_sym___based] = ACTIONS(3497),
    [anon_sym_RBRACE] = ACTIONS(3499),
    [anon_sym_signed] = ACTIONS(3497),
    [anon_sym_unsigned] = ACTIONS(3497),
    [anon_sym_long] = ACTIONS(3497),
    [anon_sym_short] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3497),
    [anon_sym_static] = ACTIONS(3497),
    [anon_sym_register] = ACTIONS(3497),
    [anon_sym_inline] = ACTIONS(3497),
    [anon_sym___inline] = ACTIONS(3497),
    [anon_sym___inline__] = ACTIONS(3497),
    [anon_sym___forceinline] = ACTIONS(3497),
    [anon_sym_thread_local] = ACTIONS(3497),
    [anon_sym___thread] = ACTIONS(3497),
    [anon_sym_const] = ACTIONS(3497),
    [anon_sym_constexpr] = ACTIONS(3497),
    [anon_sym_volatile] = ACTIONS(3497),
    [anon_sym_restrict] = ACTIONS(3497),
    [anon_sym___restrict__] = ACTIONS(3497),
    [anon_sym__Atomic] = ACTIONS(3497),
    [anon_sym__Noreturn] = ACTIONS(3497),
    [anon_sym_noreturn] = ACTIONS(3497),
    [anon_sym_mutable] = ACTIONS(3497),
    [anon_sym_constinit] = ACTIONS(3497),
    [anon_sym_consteval] = ACTIONS(3497),
    [anon_sym_alignas] = ACTIONS(3497),
    [anon_sym__Alignas] = ACTIONS(3497),
    [sym_primitive_type] = ACTIONS(3497),
    [anon_sym_enum] = ACTIONS(3497),
    [anon_sym_class] = ACTIONS(3497),
    [anon_sym_struct] = ACTIONS(3497),
    [anon_sym_union] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3497),
    [anon_sym_let] = ACTIONS(3497),
    [anon_sym_This] = ACTIONS(3497),
    [anon_sym_decltype] = ACTIONS(3497),
    [sym_virtual] = ACTIONS(3497),
    [anon_sym_explicit] = ACTIONS(3497),
    [anon_sym_typename] = ACTIONS(3497),
    [anon_sym_template] = ACTIONS(3497),
    [anon_sym_operator] = ACTIONS(3497),
    [anon_sym_friend] = ACTIONS(3497),
    [anon_sym_public] = ACTIONS(3497),
    [anon_sym_private] = ACTIONS(3497),
    [anon_sym_protected] = ACTIONS(3497),
    [anon_sym_using] = ACTIONS(3497),
    [anon_sym_static_assert] = ACTIONS(3497),
    [anon_sym_precise] = ACTIONS(3497),
    [anon_sym_shared] = ACTIONS(3497),
    [anon_sym_groupshared] = ACTIONS(3497),
    [anon_sym_uniform] = ACTIONS(3497),
    [anon_sym_row_major] = ACTIONS(3497),
    [anon_sym_column_major] = ACTIONS(3497),
    [anon_sym_globallycoherent] = ACTIONS(3497),
    [anon_sym_centroid] = ACTIONS(3497),
    [anon_sym_noperspective] = ACTIONS(3497),
    [anon_sym_nointerpolation] = ACTIONS(3497),
    [anon_sym_sample] = ACTIONS(3497),
    [anon_sym_linear] = ACTIONS(3497),
    [anon_sym_snorm] = ACTIONS(3497),
    [anon_sym_unorm] = ACTIONS(3497),
    [anon_sym_point] = ACTIONS(3497),
    [anon_sym_line] = ACTIONS(3497),
    [anon_sym_triangleadj] = ACTIONS(3497),
    [anon_sym_lineadj] = ACTIONS(3497),
    [anon_sym_triangle] = ACTIONS(3497),
    [anon_sym_interface] = ACTIONS(3497),
    [anon_sym_extension] = ACTIONS(3497),
    [anon_sym___init] = ACTIONS(3497),
    [anon_sym___subscript] = ACTIONS(3497),
    [anon_sym_property] = ACTIONS(3497),
    [anon_sym_associatedtype] = ACTIONS(3497),
  },
  [2047] = {
    [sym_expression] = STATE(5230),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2048] = {
    [sym_identifier] = ACTIONS(3613),
    [aux_sym_preproc_def_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3613),
    [sym_preproc_directive] = ACTIONS(3613),
    [anon_sym_LPAREN2] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym___extension__] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3613),
    [anon_sym_in] = ACTIONS(3613),
    [anon_sym_out] = ACTIONS(3613),
    [anon_sym_inout] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym___attribute__] = ACTIONS(3613),
    [anon_sym_COLON_COLON] = ACTIONS(3615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3615),
    [anon_sym___declspec] = ACTIONS(3613),
    [anon_sym___based] = ACTIONS(3613),
    [anon_sym_RBRACE] = ACTIONS(3615),
    [anon_sym_signed] = ACTIONS(3613),
    [anon_sym_unsigned] = ACTIONS(3613),
    [anon_sym_long] = ACTIONS(3613),
    [anon_sym_short] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_register] = ACTIONS(3613),
    [anon_sym_inline] = ACTIONS(3613),
    [anon_sym___inline] = ACTIONS(3613),
    [anon_sym___inline__] = ACTIONS(3613),
    [anon_sym___forceinline] = ACTIONS(3613),
    [anon_sym_thread_local] = ACTIONS(3613),
    [anon_sym___thread] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_constexpr] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_restrict] = ACTIONS(3613),
    [anon_sym___restrict__] = ACTIONS(3613),
    [anon_sym__Atomic] = ACTIONS(3613),
    [anon_sym__Noreturn] = ACTIONS(3613),
    [anon_sym_noreturn] = ACTIONS(3613),
    [anon_sym_mutable] = ACTIONS(3613),
    [anon_sym_constinit] = ACTIONS(3613),
    [anon_sym_consteval] = ACTIONS(3613),
    [anon_sym_alignas] = ACTIONS(3613),
    [anon_sym__Alignas] = ACTIONS(3613),
    [sym_primitive_type] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_union] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_This] = ACTIONS(3613),
    [anon_sym_decltype] = ACTIONS(3613),
    [sym_virtual] = ACTIONS(3613),
    [anon_sym_explicit] = ACTIONS(3613),
    [anon_sym_typename] = ACTIONS(3613),
    [anon_sym_template] = ACTIONS(3613),
    [anon_sym_operator] = ACTIONS(3613),
    [anon_sym_friend] = ACTIONS(3613),
    [anon_sym_public] = ACTIONS(3613),
    [anon_sym_private] = ACTIONS(3613),
    [anon_sym_protected] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_static_assert] = ACTIONS(3613),
    [anon_sym_precise] = ACTIONS(3613),
    [anon_sym_shared] = ACTIONS(3613),
    [anon_sym_groupshared] = ACTIONS(3613),
    [anon_sym_uniform] = ACTIONS(3613),
    [anon_sym_row_major] = ACTIONS(3613),
    [anon_sym_column_major] = ACTIONS(3613),
    [anon_sym_globallycoherent] = ACTIONS(3613),
    [anon_sym_centroid] = ACTIONS(3613),
    [anon_sym_noperspective] = ACTIONS(3613),
    [anon_sym_nointerpolation] = ACTIONS(3613),
    [anon_sym_sample] = ACTIONS(3613),
    [anon_sym_linear] = ACTIONS(3613),
    [anon_sym_snorm] = ACTIONS(3613),
    [anon_sym_unorm] = ACTIONS(3613),
    [anon_sym_point] = ACTIONS(3613),
    [anon_sym_line] = ACTIONS(3613),
    [anon_sym_triangleadj] = ACTIONS(3613),
    [anon_sym_lineadj] = ACTIONS(3613),
    [anon_sym_triangle] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_extension] = ACTIONS(3613),
    [anon_sym___init] = ACTIONS(3613),
    [anon_sym___subscript] = ACTIONS(3613),
    [anon_sym_property] = ACTIONS(3613),
    [anon_sym_associatedtype] = ACTIONS(3613),
  },
  [2049] = {
    [sym_identifier] = ACTIONS(3613),
    [aux_sym_preproc_def_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3613),
    [sym_preproc_directive] = ACTIONS(3613),
    [anon_sym_LPAREN2] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym___extension__] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3613),
    [anon_sym_in] = ACTIONS(3613),
    [anon_sym_out] = ACTIONS(3613),
    [anon_sym_inout] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym___attribute__] = ACTIONS(3613),
    [anon_sym_COLON_COLON] = ACTIONS(3615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3615),
    [anon_sym___declspec] = ACTIONS(3613),
    [anon_sym___based] = ACTIONS(3613),
    [anon_sym_RBRACE] = ACTIONS(3615),
    [anon_sym_signed] = ACTIONS(3613),
    [anon_sym_unsigned] = ACTIONS(3613),
    [anon_sym_long] = ACTIONS(3613),
    [anon_sym_short] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_register] = ACTIONS(3613),
    [anon_sym_inline] = ACTIONS(3613),
    [anon_sym___inline] = ACTIONS(3613),
    [anon_sym___inline__] = ACTIONS(3613),
    [anon_sym___forceinline] = ACTIONS(3613),
    [anon_sym_thread_local] = ACTIONS(3613),
    [anon_sym___thread] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_constexpr] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_restrict] = ACTIONS(3613),
    [anon_sym___restrict__] = ACTIONS(3613),
    [anon_sym__Atomic] = ACTIONS(3613),
    [anon_sym__Noreturn] = ACTIONS(3613),
    [anon_sym_noreturn] = ACTIONS(3613),
    [anon_sym_mutable] = ACTIONS(3613),
    [anon_sym_constinit] = ACTIONS(3613),
    [anon_sym_consteval] = ACTIONS(3613),
    [anon_sym_alignas] = ACTIONS(3613),
    [anon_sym__Alignas] = ACTIONS(3613),
    [sym_primitive_type] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_union] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_This] = ACTIONS(3613),
    [anon_sym_decltype] = ACTIONS(3613),
    [sym_virtual] = ACTIONS(3613),
    [anon_sym_explicit] = ACTIONS(3613),
    [anon_sym_typename] = ACTIONS(3613),
    [anon_sym_template] = ACTIONS(3613),
    [anon_sym_operator] = ACTIONS(3613),
    [anon_sym_friend] = ACTIONS(3613),
    [anon_sym_public] = ACTIONS(3613),
    [anon_sym_private] = ACTIONS(3613),
    [anon_sym_protected] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_static_assert] = ACTIONS(3613),
    [anon_sym_precise] = ACTIONS(3613),
    [anon_sym_shared] = ACTIONS(3613),
    [anon_sym_groupshared] = ACTIONS(3613),
    [anon_sym_uniform] = ACTIONS(3613),
    [anon_sym_row_major] = ACTIONS(3613),
    [anon_sym_column_major] = ACTIONS(3613),
    [anon_sym_globallycoherent] = ACTIONS(3613),
    [anon_sym_centroid] = ACTIONS(3613),
    [anon_sym_noperspective] = ACTIONS(3613),
    [anon_sym_nointerpolation] = ACTIONS(3613),
    [anon_sym_sample] = ACTIONS(3613),
    [anon_sym_linear] = ACTIONS(3613),
    [anon_sym_snorm] = ACTIONS(3613),
    [anon_sym_unorm] = ACTIONS(3613),
    [anon_sym_point] = ACTIONS(3613),
    [anon_sym_line] = ACTIONS(3613),
    [anon_sym_triangleadj] = ACTIONS(3613),
    [anon_sym_lineadj] = ACTIONS(3613),
    [anon_sym_triangle] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_extension] = ACTIONS(3613),
    [anon_sym___init] = ACTIONS(3613),
    [anon_sym___subscript] = ACTIONS(3613),
    [anon_sym_property] = ACTIONS(3613),
    [anon_sym_associatedtype] = ACTIONS(3613),
  },
  [2050] = {
    [sym_expression] = STATE(5191),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2051] = {
    [sym_expression] = STATE(3229),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3481),
    [sym_concatenated_string] = STATE(3486),
    [sym_string_literal] = STATE(2963),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2960),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5795),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4412),
    [anon_sym_PLUS] = ACTIONS(4412),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4416),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4412),
    [anon_sym_compl] = ACTIONS(4412),
    [anon_sym_DASH_DASH] = ACTIONS(5756),
    [anon_sym_PLUS_PLUS] = ACTIONS(5756),
    [anon_sym_sizeof] = ACTIONS(4422),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4432),
    [anon_sym_L_SQUOTE] = ACTIONS(4434),
    [anon_sym_u_SQUOTE] = ACTIONS(4434),
    [anon_sym_U_SQUOTE] = ACTIONS(4434),
    [anon_sym_u8_SQUOTE] = ACTIONS(4434),
    [anon_sym_SQUOTE] = ACTIONS(4434),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4442),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [anon_sym_co_await] = ACTIONS(4446),
    [anon_sym_new] = ACTIONS(4448),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2052] = {
    [sym_expression] = STATE(5443),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2053] = {
    [sym_identifier] = ACTIONS(5478),
    [aux_sym_preproc_def_token1] = ACTIONS(5478),
    [aux_sym_preproc_if_token1] = ACTIONS(5478),
    [aux_sym_preproc_if_token2] = ACTIONS(5478),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5478),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5478),
    [sym_preproc_directive] = ACTIONS(5478),
    [anon_sym_LPAREN2] = ACTIONS(5480),
    [anon_sym_TILDE] = ACTIONS(5480),
    [anon_sym_STAR] = ACTIONS(5480),
    [anon_sym_AMP_AMP] = ACTIONS(5480),
    [anon_sym_AMP] = ACTIONS(5478),
    [anon_sym___extension__] = ACTIONS(5478),
    [anon_sym_typedef] = ACTIONS(5478),
    [anon_sym_in] = ACTIONS(5478),
    [anon_sym_out] = ACTIONS(5478),
    [anon_sym_inout] = ACTIONS(5478),
    [anon_sym_extern] = ACTIONS(5478),
    [anon_sym___attribute__] = ACTIONS(5478),
    [anon_sym_COLON_COLON] = ACTIONS(5480),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5480),
    [anon_sym___declspec] = ACTIONS(5478),
    [anon_sym___based] = ACTIONS(5478),
    [anon_sym_signed] = ACTIONS(5478),
    [anon_sym_unsigned] = ACTIONS(5478),
    [anon_sym_long] = ACTIONS(5478),
    [anon_sym_short] = ACTIONS(5478),
    [anon_sym_LBRACK] = ACTIONS(5478),
    [anon_sym_static] = ACTIONS(5478),
    [anon_sym_register] = ACTIONS(5478),
    [anon_sym_inline] = ACTIONS(5478),
    [anon_sym___inline] = ACTIONS(5478),
    [anon_sym___inline__] = ACTIONS(5478),
    [anon_sym___forceinline] = ACTIONS(5478),
    [anon_sym_thread_local] = ACTIONS(5478),
    [anon_sym___thread] = ACTIONS(5478),
    [anon_sym_const] = ACTIONS(5478),
    [anon_sym_constexpr] = ACTIONS(5478),
    [anon_sym_volatile] = ACTIONS(5478),
    [anon_sym_restrict] = ACTIONS(5478),
    [anon_sym___restrict__] = ACTIONS(5478),
    [anon_sym__Atomic] = ACTIONS(5478),
    [anon_sym__Noreturn] = ACTIONS(5478),
    [anon_sym_noreturn] = ACTIONS(5478),
    [anon_sym_mutable] = ACTIONS(5478),
    [anon_sym_constinit] = ACTIONS(5478),
    [anon_sym_consteval] = ACTIONS(5478),
    [anon_sym_alignas] = ACTIONS(5478),
    [anon_sym__Alignas] = ACTIONS(5478),
    [sym_primitive_type] = ACTIONS(5478),
    [anon_sym_enum] = ACTIONS(5478),
    [anon_sym_class] = ACTIONS(5478),
    [anon_sym_struct] = ACTIONS(5478),
    [anon_sym_union] = ACTIONS(5478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5478),
    [anon_sym_let] = ACTIONS(5478),
    [anon_sym_This] = ACTIONS(5478),
    [anon_sym_decltype] = ACTIONS(5478),
    [sym_virtual] = ACTIONS(5478),
    [anon_sym_explicit] = ACTIONS(5478),
    [anon_sym_typename] = ACTIONS(5478),
    [anon_sym_template] = ACTIONS(5478),
    [anon_sym_operator] = ACTIONS(5478),
    [anon_sym_friend] = ACTIONS(5478),
    [anon_sym_public] = ACTIONS(5478),
    [anon_sym_private] = ACTIONS(5478),
    [anon_sym_protected] = ACTIONS(5478),
    [anon_sym_using] = ACTIONS(5478),
    [anon_sym_static_assert] = ACTIONS(5478),
    [anon_sym_precise] = ACTIONS(5478),
    [anon_sym_shared] = ACTIONS(5478),
    [anon_sym_groupshared] = ACTIONS(5478),
    [anon_sym_uniform] = ACTIONS(5478),
    [anon_sym_row_major] = ACTIONS(5478),
    [anon_sym_column_major] = ACTIONS(5478),
    [anon_sym_globallycoherent] = ACTIONS(5478),
    [anon_sym_centroid] = ACTIONS(5478),
    [anon_sym_noperspective] = ACTIONS(5478),
    [anon_sym_nointerpolation] = ACTIONS(5478),
    [anon_sym_sample] = ACTIONS(5478),
    [anon_sym_linear] = ACTIONS(5478),
    [anon_sym_snorm] = ACTIONS(5478),
    [anon_sym_unorm] = ACTIONS(5478),
    [anon_sym_point] = ACTIONS(5478),
    [anon_sym_line] = ACTIONS(5478),
    [anon_sym_triangleadj] = ACTIONS(5478),
    [anon_sym_lineadj] = ACTIONS(5478),
    [anon_sym_triangle] = ACTIONS(5478),
    [anon_sym_interface] = ACTIONS(5478),
    [anon_sym_extension] = ACTIONS(5478),
    [anon_sym___init] = ACTIONS(5478),
    [anon_sym___subscript] = ACTIONS(5478),
    [anon_sym_property] = ACTIONS(5478),
    [anon_sym_associatedtype] = ACTIONS(5478),
  },
  [2054] = {
    [sym_expression] = STATE(3793),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5781),
    [anon_sym_BANG] = ACTIONS(4611),
    [anon_sym_TILDE] = ACTIONS(4611),
    [anon_sym_DASH] = ACTIONS(4609),
    [anon_sym_PLUS] = ACTIONS(4609),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4613),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4609),
    [anon_sym_compl] = ACTIONS(4609),
    [anon_sym_DASH_DASH] = ACTIONS(5713),
    [anon_sym_PLUS_PLUS] = ACTIONS(5713),
    [anon_sym_sizeof] = ACTIONS(4615),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4617),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4619),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2055] = {
    [sym_identifier] = ACTIONS(5572),
    [aux_sym_preproc_def_token1] = ACTIONS(5572),
    [aux_sym_preproc_if_token1] = ACTIONS(5572),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5572),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5572),
    [sym_preproc_directive] = ACTIONS(5572),
    [anon_sym_LPAREN2] = ACTIONS(5574),
    [anon_sym_TILDE] = ACTIONS(5574),
    [anon_sym_STAR] = ACTIONS(5574),
    [anon_sym_AMP_AMP] = ACTIONS(5574),
    [anon_sym_AMP] = ACTIONS(5572),
    [anon_sym___extension__] = ACTIONS(5572),
    [anon_sym_typedef] = ACTIONS(5572),
    [anon_sym_in] = ACTIONS(5572),
    [anon_sym_out] = ACTIONS(5572),
    [anon_sym_inout] = ACTIONS(5572),
    [anon_sym_extern] = ACTIONS(5572),
    [anon_sym___attribute__] = ACTIONS(5572),
    [anon_sym_COLON_COLON] = ACTIONS(5574),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5574),
    [anon_sym___declspec] = ACTIONS(5572),
    [anon_sym___based] = ACTIONS(5572),
    [anon_sym_RBRACE] = ACTIONS(5574),
    [anon_sym_signed] = ACTIONS(5572),
    [anon_sym_unsigned] = ACTIONS(5572),
    [anon_sym_long] = ACTIONS(5572),
    [anon_sym_short] = ACTIONS(5572),
    [anon_sym_LBRACK] = ACTIONS(5572),
    [anon_sym_static] = ACTIONS(5572),
    [anon_sym_register] = ACTIONS(5572),
    [anon_sym_inline] = ACTIONS(5572),
    [anon_sym___inline] = ACTIONS(5572),
    [anon_sym___inline__] = ACTIONS(5572),
    [anon_sym___forceinline] = ACTIONS(5572),
    [anon_sym_thread_local] = ACTIONS(5572),
    [anon_sym___thread] = ACTIONS(5572),
    [anon_sym_const] = ACTIONS(5572),
    [anon_sym_constexpr] = ACTIONS(5572),
    [anon_sym_volatile] = ACTIONS(5572),
    [anon_sym_restrict] = ACTIONS(5572),
    [anon_sym___restrict__] = ACTIONS(5572),
    [anon_sym__Atomic] = ACTIONS(5572),
    [anon_sym__Noreturn] = ACTIONS(5572),
    [anon_sym_noreturn] = ACTIONS(5572),
    [anon_sym_mutable] = ACTIONS(5572),
    [anon_sym_constinit] = ACTIONS(5572),
    [anon_sym_consteval] = ACTIONS(5572),
    [anon_sym_alignas] = ACTIONS(5572),
    [anon_sym__Alignas] = ACTIONS(5572),
    [sym_primitive_type] = ACTIONS(5572),
    [anon_sym_enum] = ACTIONS(5572),
    [anon_sym_class] = ACTIONS(5572),
    [anon_sym_struct] = ACTIONS(5572),
    [anon_sym_union] = ACTIONS(5572),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5572),
    [anon_sym_let] = ACTIONS(5572),
    [anon_sym_This] = ACTIONS(5572),
    [anon_sym_decltype] = ACTIONS(5572),
    [sym_virtual] = ACTIONS(5572),
    [anon_sym_explicit] = ACTIONS(5572),
    [anon_sym_typename] = ACTIONS(5572),
    [anon_sym_template] = ACTIONS(5572),
    [anon_sym_operator] = ACTIONS(5572),
    [anon_sym_friend] = ACTIONS(5572),
    [anon_sym_public] = ACTIONS(5572),
    [anon_sym_private] = ACTIONS(5572),
    [anon_sym_protected] = ACTIONS(5572),
    [anon_sym_using] = ACTIONS(5572),
    [anon_sym_static_assert] = ACTIONS(5572),
    [anon_sym_precise] = ACTIONS(5572),
    [anon_sym_shared] = ACTIONS(5572),
    [anon_sym_groupshared] = ACTIONS(5572),
    [anon_sym_uniform] = ACTIONS(5572),
    [anon_sym_row_major] = ACTIONS(5572),
    [anon_sym_column_major] = ACTIONS(5572),
    [anon_sym_globallycoherent] = ACTIONS(5572),
    [anon_sym_centroid] = ACTIONS(5572),
    [anon_sym_noperspective] = ACTIONS(5572),
    [anon_sym_nointerpolation] = ACTIONS(5572),
    [anon_sym_sample] = ACTIONS(5572),
    [anon_sym_linear] = ACTIONS(5572),
    [anon_sym_snorm] = ACTIONS(5572),
    [anon_sym_unorm] = ACTIONS(5572),
    [anon_sym_point] = ACTIONS(5572),
    [anon_sym_line] = ACTIONS(5572),
    [anon_sym_triangleadj] = ACTIONS(5572),
    [anon_sym_lineadj] = ACTIONS(5572),
    [anon_sym_triangle] = ACTIONS(5572),
    [anon_sym_interface] = ACTIONS(5572),
    [anon_sym_extension] = ACTIONS(5572),
    [anon_sym___init] = ACTIONS(5572),
    [anon_sym___subscript] = ACTIONS(5572),
    [anon_sym_property] = ACTIONS(5572),
    [anon_sym_associatedtype] = ACTIONS(5572),
  },
  [2056] = {
    [sym_expression] = STATE(3797),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5781),
    [anon_sym_BANG] = ACTIONS(4611),
    [anon_sym_TILDE] = ACTIONS(4611),
    [anon_sym_DASH] = ACTIONS(4609),
    [anon_sym_PLUS] = ACTIONS(4609),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4613),
    [anon_sym_LBRACK] = ACTIONS(6088),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4609),
    [anon_sym_compl] = ACTIONS(4609),
    [anon_sym_DASH_DASH] = ACTIONS(5713),
    [anon_sym_PLUS_PLUS] = ACTIONS(5713),
    [anon_sym_sizeof] = ACTIONS(4615),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4617),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4619),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2057] = {
    [sym_identifier] = ACTIONS(3613),
    [aux_sym_preproc_def_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3613),
    [sym_preproc_directive] = ACTIONS(3613),
    [anon_sym_LPAREN2] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym___extension__] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3613),
    [anon_sym_in] = ACTIONS(3613),
    [anon_sym_out] = ACTIONS(3613),
    [anon_sym_inout] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym___attribute__] = ACTIONS(3613),
    [anon_sym_COLON_COLON] = ACTIONS(3615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3615),
    [anon_sym___declspec] = ACTIONS(3613),
    [anon_sym___based] = ACTIONS(3613),
    [anon_sym_RBRACE] = ACTIONS(3615),
    [anon_sym_signed] = ACTIONS(3613),
    [anon_sym_unsigned] = ACTIONS(3613),
    [anon_sym_long] = ACTIONS(3613),
    [anon_sym_short] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_register] = ACTIONS(3613),
    [anon_sym_inline] = ACTIONS(3613),
    [anon_sym___inline] = ACTIONS(3613),
    [anon_sym___inline__] = ACTIONS(3613),
    [anon_sym___forceinline] = ACTIONS(3613),
    [anon_sym_thread_local] = ACTIONS(3613),
    [anon_sym___thread] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_constexpr] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_restrict] = ACTIONS(3613),
    [anon_sym___restrict__] = ACTIONS(3613),
    [anon_sym__Atomic] = ACTIONS(3613),
    [anon_sym__Noreturn] = ACTIONS(3613),
    [anon_sym_noreturn] = ACTIONS(3613),
    [anon_sym_mutable] = ACTIONS(3613),
    [anon_sym_constinit] = ACTIONS(3613),
    [anon_sym_consteval] = ACTIONS(3613),
    [anon_sym_alignas] = ACTIONS(3613),
    [anon_sym__Alignas] = ACTIONS(3613),
    [sym_primitive_type] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_union] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_This] = ACTIONS(3613),
    [anon_sym_decltype] = ACTIONS(3613),
    [sym_virtual] = ACTIONS(3613),
    [anon_sym_explicit] = ACTIONS(3613),
    [anon_sym_typename] = ACTIONS(3613),
    [anon_sym_template] = ACTIONS(3613),
    [anon_sym_operator] = ACTIONS(3613),
    [anon_sym_friend] = ACTIONS(3613),
    [anon_sym_public] = ACTIONS(3613),
    [anon_sym_private] = ACTIONS(3613),
    [anon_sym_protected] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_static_assert] = ACTIONS(3613),
    [anon_sym_precise] = ACTIONS(3613),
    [anon_sym_shared] = ACTIONS(3613),
    [anon_sym_groupshared] = ACTIONS(3613),
    [anon_sym_uniform] = ACTIONS(3613),
    [anon_sym_row_major] = ACTIONS(3613),
    [anon_sym_column_major] = ACTIONS(3613),
    [anon_sym_globallycoherent] = ACTIONS(3613),
    [anon_sym_centroid] = ACTIONS(3613),
    [anon_sym_noperspective] = ACTIONS(3613),
    [anon_sym_nointerpolation] = ACTIONS(3613),
    [anon_sym_sample] = ACTIONS(3613),
    [anon_sym_linear] = ACTIONS(3613),
    [anon_sym_snorm] = ACTIONS(3613),
    [anon_sym_unorm] = ACTIONS(3613),
    [anon_sym_point] = ACTIONS(3613),
    [anon_sym_line] = ACTIONS(3613),
    [anon_sym_triangleadj] = ACTIONS(3613),
    [anon_sym_lineadj] = ACTIONS(3613),
    [anon_sym_triangle] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_extension] = ACTIONS(3613),
    [anon_sym___init] = ACTIONS(3613),
    [anon_sym___subscript] = ACTIONS(3613),
    [anon_sym_property] = ACTIONS(3613),
    [anon_sym_associatedtype] = ACTIONS(3613),
  },
  [2058] = {
    [sym_identifier] = ACTIONS(5474),
    [aux_sym_preproc_def_token1] = ACTIONS(5474),
    [aux_sym_preproc_if_token1] = ACTIONS(5474),
    [aux_sym_preproc_if_token2] = ACTIONS(5474),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5474),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5474),
    [sym_preproc_directive] = ACTIONS(5474),
    [anon_sym_LPAREN2] = ACTIONS(5476),
    [anon_sym_TILDE] = ACTIONS(5476),
    [anon_sym_STAR] = ACTIONS(5476),
    [anon_sym_AMP_AMP] = ACTIONS(5476),
    [anon_sym_AMP] = ACTIONS(5474),
    [anon_sym___extension__] = ACTIONS(5474),
    [anon_sym_typedef] = ACTIONS(5474),
    [anon_sym_in] = ACTIONS(5474),
    [anon_sym_out] = ACTIONS(5474),
    [anon_sym_inout] = ACTIONS(5474),
    [anon_sym_extern] = ACTIONS(5474),
    [anon_sym___attribute__] = ACTIONS(5474),
    [anon_sym_COLON_COLON] = ACTIONS(5476),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5476),
    [anon_sym___declspec] = ACTIONS(5474),
    [anon_sym___based] = ACTIONS(5474),
    [anon_sym_signed] = ACTIONS(5474),
    [anon_sym_unsigned] = ACTIONS(5474),
    [anon_sym_long] = ACTIONS(5474),
    [anon_sym_short] = ACTIONS(5474),
    [anon_sym_LBRACK] = ACTIONS(5474),
    [anon_sym_static] = ACTIONS(5474),
    [anon_sym_register] = ACTIONS(5474),
    [anon_sym_inline] = ACTIONS(5474),
    [anon_sym___inline] = ACTIONS(5474),
    [anon_sym___inline__] = ACTIONS(5474),
    [anon_sym___forceinline] = ACTIONS(5474),
    [anon_sym_thread_local] = ACTIONS(5474),
    [anon_sym___thread] = ACTIONS(5474),
    [anon_sym_const] = ACTIONS(5474),
    [anon_sym_constexpr] = ACTIONS(5474),
    [anon_sym_volatile] = ACTIONS(5474),
    [anon_sym_restrict] = ACTIONS(5474),
    [anon_sym___restrict__] = ACTIONS(5474),
    [anon_sym__Atomic] = ACTIONS(5474),
    [anon_sym__Noreturn] = ACTIONS(5474),
    [anon_sym_noreturn] = ACTIONS(5474),
    [anon_sym_mutable] = ACTIONS(5474),
    [anon_sym_constinit] = ACTIONS(5474),
    [anon_sym_consteval] = ACTIONS(5474),
    [anon_sym_alignas] = ACTIONS(5474),
    [anon_sym__Alignas] = ACTIONS(5474),
    [sym_primitive_type] = ACTIONS(5474),
    [anon_sym_enum] = ACTIONS(5474),
    [anon_sym_class] = ACTIONS(5474),
    [anon_sym_struct] = ACTIONS(5474),
    [anon_sym_union] = ACTIONS(5474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5474),
    [anon_sym_let] = ACTIONS(5474),
    [anon_sym_This] = ACTIONS(5474),
    [anon_sym_decltype] = ACTIONS(5474),
    [sym_virtual] = ACTIONS(5474),
    [anon_sym_explicit] = ACTIONS(5474),
    [anon_sym_typename] = ACTIONS(5474),
    [anon_sym_template] = ACTIONS(5474),
    [anon_sym_operator] = ACTIONS(5474),
    [anon_sym_friend] = ACTIONS(5474),
    [anon_sym_public] = ACTIONS(5474),
    [anon_sym_private] = ACTIONS(5474),
    [anon_sym_protected] = ACTIONS(5474),
    [anon_sym_using] = ACTIONS(5474),
    [anon_sym_static_assert] = ACTIONS(5474),
    [anon_sym_precise] = ACTIONS(5474),
    [anon_sym_shared] = ACTIONS(5474),
    [anon_sym_groupshared] = ACTIONS(5474),
    [anon_sym_uniform] = ACTIONS(5474),
    [anon_sym_row_major] = ACTIONS(5474),
    [anon_sym_column_major] = ACTIONS(5474),
    [anon_sym_globallycoherent] = ACTIONS(5474),
    [anon_sym_centroid] = ACTIONS(5474),
    [anon_sym_noperspective] = ACTIONS(5474),
    [anon_sym_nointerpolation] = ACTIONS(5474),
    [anon_sym_sample] = ACTIONS(5474),
    [anon_sym_linear] = ACTIONS(5474),
    [anon_sym_snorm] = ACTIONS(5474),
    [anon_sym_unorm] = ACTIONS(5474),
    [anon_sym_point] = ACTIONS(5474),
    [anon_sym_line] = ACTIONS(5474),
    [anon_sym_triangleadj] = ACTIONS(5474),
    [anon_sym_lineadj] = ACTIONS(5474),
    [anon_sym_triangle] = ACTIONS(5474),
    [anon_sym_interface] = ACTIONS(5474),
    [anon_sym_extension] = ACTIONS(5474),
    [anon_sym___init] = ACTIONS(5474),
    [anon_sym___subscript] = ACTIONS(5474),
    [anon_sym_property] = ACTIONS(5474),
    [anon_sym_associatedtype] = ACTIONS(5474),
  },
  [2059] = {
    [sym_identifier] = ACTIONS(5626),
    [aux_sym_preproc_def_token1] = ACTIONS(5626),
    [aux_sym_preproc_if_token1] = ACTIONS(5626),
    [aux_sym_preproc_if_token2] = ACTIONS(5626),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5626),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5626),
    [sym_preproc_directive] = ACTIONS(5626),
    [anon_sym_LPAREN2] = ACTIONS(5628),
    [anon_sym_TILDE] = ACTIONS(5628),
    [anon_sym_STAR] = ACTIONS(5628),
    [anon_sym_AMP_AMP] = ACTIONS(5628),
    [anon_sym_AMP] = ACTIONS(5626),
    [anon_sym___extension__] = ACTIONS(5626),
    [anon_sym_typedef] = ACTIONS(5626),
    [anon_sym_in] = ACTIONS(5626),
    [anon_sym_out] = ACTIONS(5626),
    [anon_sym_inout] = ACTIONS(5626),
    [anon_sym_extern] = ACTIONS(5626),
    [anon_sym___attribute__] = ACTIONS(5626),
    [anon_sym_COLON_COLON] = ACTIONS(5628),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5628),
    [anon_sym___declspec] = ACTIONS(5626),
    [anon_sym___based] = ACTIONS(5626),
    [anon_sym_signed] = ACTIONS(5626),
    [anon_sym_unsigned] = ACTIONS(5626),
    [anon_sym_long] = ACTIONS(5626),
    [anon_sym_short] = ACTIONS(5626),
    [anon_sym_LBRACK] = ACTIONS(5626),
    [anon_sym_static] = ACTIONS(5626),
    [anon_sym_register] = ACTIONS(5626),
    [anon_sym_inline] = ACTIONS(5626),
    [anon_sym___inline] = ACTIONS(5626),
    [anon_sym___inline__] = ACTIONS(5626),
    [anon_sym___forceinline] = ACTIONS(5626),
    [anon_sym_thread_local] = ACTIONS(5626),
    [anon_sym___thread] = ACTIONS(5626),
    [anon_sym_const] = ACTIONS(5626),
    [anon_sym_constexpr] = ACTIONS(5626),
    [anon_sym_volatile] = ACTIONS(5626),
    [anon_sym_restrict] = ACTIONS(5626),
    [anon_sym___restrict__] = ACTIONS(5626),
    [anon_sym__Atomic] = ACTIONS(5626),
    [anon_sym__Noreturn] = ACTIONS(5626),
    [anon_sym_noreturn] = ACTIONS(5626),
    [anon_sym_mutable] = ACTIONS(5626),
    [anon_sym_constinit] = ACTIONS(5626),
    [anon_sym_consteval] = ACTIONS(5626),
    [anon_sym_alignas] = ACTIONS(5626),
    [anon_sym__Alignas] = ACTIONS(5626),
    [sym_primitive_type] = ACTIONS(5626),
    [anon_sym_enum] = ACTIONS(5626),
    [anon_sym_class] = ACTIONS(5626),
    [anon_sym_struct] = ACTIONS(5626),
    [anon_sym_union] = ACTIONS(5626),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5626),
    [anon_sym_let] = ACTIONS(5626),
    [anon_sym_This] = ACTIONS(5626),
    [anon_sym_decltype] = ACTIONS(5626),
    [sym_virtual] = ACTIONS(5626),
    [anon_sym_explicit] = ACTIONS(5626),
    [anon_sym_typename] = ACTIONS(5626),
    [anon_sym_template] = ACTIONS(5626),
    [anon_sym_operator] = ACTIONS(5626),
    [anon_sym_friend] = ACTIONS(5626),
    [anon_sym_public] = ACTIONS(5626),
    [anon_sym_private] = ACTIONS(5626),
    [anon_sym_protected] = ACTIONS(5626),
    [anon_sym_using] = ACTIONS(5626),
    [anon_sym_static_assert] = ACTIONS(5626),
    [anon_sym_precise] = ACTIONS(5626),
    [anon_sym_shared] = ACTIONS(5626),
    [anon_sym_groupshared] = ACTIONS(5626),
    [anon_sym_uniform] = ACTIONS(5626),
    [anon_sym_row_major] = ACTIONS(5626),
    [anon_sym_column_major] = ACTIONS(5626),
    [anon_sym_globallycoherent] = ACTIONS(5626),
    [anon_sym_centroid] = ACTIONS(5626),
    [anon_sym_noperspective] = ACTIONS(5626),
    [anon_sym_nointerpolation] = ACTIONS(5626),
    [anon_sym_sample] = ACTIONS(5626),
    [anon_sym_linear] = ACTIONS(5626),
    [anon_sym_snorm] = ACTIONS(5626),
    [anon_sym_unorm] = ACTIONS(5626),
    [anon_sym_point] = ACTIONS(5626),
    [anon_sym_line] = ACTIONS(5626),
    [anon_sym_triangleadj] = ACTIONS(5626),
    [anon_sym_lineadj] = ACTIONS(5626),
    [anon_sym_triangle] = ACTIONS(5626),
    [anon_sym_interface] = ACTIONS(5626),
    [anon_sym_extension] = ACTIONS(5626),
    [anon_sym___init] = ACTIONS(5626),
    [anon_sym___subscript] = ACTIONS(5626),
    [anon_sym_property] = ACTIONS(5626),
    [anon_sym_associatedtype] = ACTIONS(5626),
  },
  [2060] = {
    [sym_identifier] = ACTIONS(5630),
    [aux_sym_preproc_def_token1] = ACTIONS(5630),
    [aux_sym_preproc_if_token1] = ACTIONS(5630),
    [aux_sym_preproc_if_token2] = ACTIONS(5630),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5630),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5630),
    [sym_preproc_directive] = ACTIONS(5630),
    [anon_sym_LPAREN2] = ACTIONS(5632),
    [anon_sym_TILDE] = ACTIONS(5632),
    [anon_sym_STAR] = ACTIONS(5632),
    [anon_sym_AMP_AMP] = ACTIONS(5632),
    [anon_sym_AMP] = ACTIONS(5630),
    [anon_sym___extension__] = ACTIONS(5630),
    [anon_sym_typedef] = ACTIONS(5630),
    [anon_sym_in] = ACTIONS(5630),
    [anon_sym_out] = ACTIONS(5630),
    [anon_sym_inout] = ACTIONS(5630),
    [anon_sym_extern] = ACTIONS(5630),
    [anon_sym___attribute__] = ACTIONS(5630),
    [anon_sym_COLON_COLON] = ACTIONS(5632),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5632),
    [anon_sym___declspec] = ACTIONS(5630),
    [anon_sym___based] = ACTIONS(5630),
    [anon_sym_signed] = ACTIONS(5630),
    [anon_sym_unsigned] = ACTIONS(5630),
    [anon_sym_long] = ACTIONS(5630),
    [anon_sym_short] = ACTIONS(5630),
    [anon_sym_LBRACK] = ACTIONS(5630),
    [anon_sym_static] = ACTIONS(5630),
    [anon_sym_register] = ACTIONS(5630),
    [anon_sym_inline] = ACTIONS(5630),
    [anon_sym___inline] = ACTIONS(5630),
    [anon_sym___inline__] = ACTIONS(5630),
    [anon_sym___forceinline] = ACTIONS(5630),
    [anon_sym_thread_local] = ACTIONS(5630),
    [anon_sym___thread] = ACTIONS(5630),
    [anon_sym_const] = ACTIONS(5630),
    [anon_sym_constexpr] = ACTIONS(5630),
    [anon_sym_volatile] = ACTIONS(5630),
    [anon_sym_restrict] = ACTIONS(5630),
    [anon_sym___restrict__] = ACTIONS(5630),
    [anon_sym__Atomic] = ACTIONS(5630),
    [anon_sym__Noreturn] = ACTIONS(5630),
    [anon_sym_noreturn] = ACTIONS(5630),
    [anon_sym_mutable] = ACTIONS(5630),
    [anon_sym_constinit] = ACTIONS(5630),
    [anon_sym_consteval] = ACTIONS(5630),
    [anon_sym_alignas] = ACTIONS(5630),
    [anon_sym__Alignas] = ACTIONS(5630),
    [sym_primitive_type] = ACTIONS(5630),
    [anon_sym_enum] = ACTIONS(5630),
    [anon_sym_class] = ACTIONS(5630),
    [anon_sym_struct] = ACTIONS(5630),
    [anon_sym_union] = ACTIONS(5630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5630),
    [anon_sym_let] = ACTIONS(5630),
    [anon_sym_This] = ACTIONS(5630),
    [anon_sym_decltype] = ACTIONS(5630),
    [sym_virtual] = ACTIONS(5630),
    [anon_sym_explicit] = ACTIONS(5630),
    [anon_sym_typename] = ACTIONS(5630),
    [anon_sym_template] = ACTIONS(5630),
    [anon_sym_operator] = ACTIONS(5630),
    [anon_sym_friend] = ACTIONS(5630),
    [anon_sym_public] = ACTIONS(5630),
    [anon_sym_private] = ACTIONS(5630),
    [anon_sym_protected] = ACTIONS(5630),
    [anon_sym_using] = ACTIONS(5630),
    [anon_sym_static_assert] = ACTIONS(5630),
    [anon_sym_precise] = ACTIONS(5630),
    [anon_sym_shared] = ACTIONS(5630),
    [anon_sym_groupshared] = ACTIONS(5630),
    [anon_sym_uniform] = ACTIONS(5630),
    [anon_sym_row_major] = ACTIONS(5630),
    [anon_sym_column_major] = ACTIONS(5630),
    [anon_sym_globallycoherent] = ACTIONS(5630),
    [anon_sym_centroid] = ACTIONS(5630),
    [anon_sym_noperspective] = ACTIONS(5630),
    [anon_sym_nointerpolation] = ACTIONS(5630),
    [anon_sym_sample] = ACTIONS(5630),
    [anon_sym_linear] = ACTIONS(5630),
    [anon_sym_snorm] = ACTIONS(5630),
    [anon_sym_unorm] = ACTIONS(5630),
    [anon_sym_point] = ACTIONS(5630),
    [anon_sym_line] = ACTIONS(5630),
    [anon_sym_triangleadj] = ACTIONS(5630),
    [anon_sym_lineadj] = ACTIONS(5630),
    [anon_sym_triangle] = ACTIONS(5630),
    [anon_sym_interface] = ACTIONS(5630),
    [anon_sym_extension] = ACTIONS(5630),
    [anon_sym___init] = ACTIONS(5630),
    [anon_sym___subscript] = ACTIONS(5630),
    [anon_sym_property] = ACTIONS(5630),
    [anon_sym_associatedtype] = ACTIONS(5630),
  },
  [2061] = {
    [sym_identifier] = ACTIONS(3613),
    [aux_sym_preproc_def_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3613),
    [sym_preproc_directive] = ACTIONS(3613),
    [anon_sym_LPAREN2] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym___extension__] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3613),
    [anon_sym_in] = ACTIONS(3613),
    [anon_sym_out] = ACTIONS(3613),
    [anon_sym_inout] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym___attribute__] = ACTIONS(3613),
    [anon_sym_COLON_COLON] = ACTIONS(3615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3615),
    [anon_sym___declspec] = ACTIONS(3613),
    [anon_sym___based] = ACTIONS(3613),
    [anon_sym_RBRACE] = ACTIONS(3615),
    [anon_sym_signed] = ACTIONS(3613),
    [anon_sym_unsigned] = ACTIONS(3613),
    [anon_sym_long] = ACTIONS(3613),
    [anon_sym_short] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_register] = ACTIONS(3613),
    [anon_sym_inline] = ACTIONS(3613),
    [anon_sym___inline] = ACTIONS(3613),
    [anon_sym___inline__] = ACTIONS(3613),
    [anon_sym___forceinline] = ACTIONS(3613),
    [anon_sym_thread_local] = ACTIONS(3613),
    [anon_sym___thread] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_constexpr] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_restrict] = ACTIONS(3613),
    [anon_sym___restrict__] = ACTIONS(3613),
    [anon_sym__Atomic] = ACTIONS(3613),
    [anon_sym__Noreturn] = ACTIONS(3613),
    [anon_sym_noreturn] = ACTIONS(3613),
    [anon_sym_mutable] = ACTIONS(3613),
    [anon_sym_constinit] = ACTIONS(3613),
    [anon_sym_consteval] = ACTIONS(3613),
    [anon_sym_alignas] = ACTIONS(3613),
    [anon_sym__Alignas] = ACTIONS(3613),
    [sym_primitive_type] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_union] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_This] = ACTIONS(3613),
    [anon_sym_decltype] = ACTIONS(3613),
    [sym_virtual] = ACTIONS(3613),
    [anon_sym_explicit] = ACTIONS(3613),
    [anon_sym_typename] = ACTIONS(3613),
    [anon_sym_template] = ACTIONS(3613),
    [anon_sym_operator] = ACTIONS(3613),
    [anon_sym_friend] = ACTIONS(3613),
    [anon_sym_public] = ACTIONS(3613),
    [anon_sym_private] = ACTIONS(3613),
    [anon_sym_protected] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_static_assert] = ACTIONS(3613),
    [anon_sym_precise] = ACTIONS(3613),
    [anon_sym_shared] = ACTIONS(3613),
    [anon_sym_groupshared] = ACTIONS(3613),
    [anon_sym_uniform] = ACTIONS(3613),
    [anon_sym_row_major] = ACTIONS(3613),
    [anon_sym_column_major] = ACTIONS(3613),
    [anon_sym_globallycoherent] = ACTIONS(3613),
    [anon_sym_centroid] = ACTIONS(3613),
    [anon_sym_noperspective] = ACTIONS(3613),
    [anon_sym_nointerpolation] = ACTIONS(3613),
    [anon_sym_sample] = ACTIONS(3613),
    [anon_sym_linear] = ACTIONS(3613),
    [anon_sym_snorm] = ACTIONS(3613),
    [anon_sym_unorm] = ACTIONS(3613),
    [anon_sym_point] = ACTIONS(3613),
    [anon_sym_line] = ACTIONS(3613),
    [anon_sym_triangleadj] = ACTIONS(3613),
    [anon_sym_lineadj] = ACTIONS(3613),
    [anon_sym_triangle] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_extension] = ACTIONS(3613),
    [anon_sym___init] = ACTIONS(3613),
    [anon_sym___subscript] = ACTIONS(3613),
    [anon_sym_property] = ACTIONS(3613),
    [anon_sym_associatedtype] = ACTIONS(3613),
  },
  [2062] = {
    [sym_identifier] = ACTIONS(5634),
    [aux_sym_preproc_def_token1] = ACTIONS(5634),
    [aux_sym_preproc_if_token1] = ACTIONS(5634),
    [aux_sym_preproc_if_token2] = ACTIONS(5634),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5634),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5634),
    [sym_preproc_directive] = ACTIONS(5634),
    [anon_sym_LPAREN2] = ACTIONS(5636),
    [anon_sym_TILDE] = ACTIONS(5636),
    [anon_sym_STAR] = ACTIONS(5636),
    [anon_sym_AMP_AMP] = ACTIONS(5636),
    [anon_sym_AMP] = ACTIONS(5634),
    [anon_sym___extension__] = ACTIONS(5634),
    [anon_sym_typedef] = ACTIONS(5634),
    [anon_sym_in] = ACTIONS(5634),
    [anon_sym_out] = ACTIONS(5634),
    [anon_sym_inout] = ACTIONS(5634),
    [anon_sym_extern] = ACTIONS(5634),
    [anon_sym___attribute__] = ACTIONS(5634),
    [anon_sym_COLON_COLON] = ACTIONS(5636),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5636),
    [anon_sym___declspec] = ACTIONS(5634),
    [anon_sym___based] = ACTIONS(5634),
    [anon_sym_signed] = ACTIONS(5634),
    [anon_sym_unsigned] = ACTIONS(5634),
    [anon_sym_long] = ACTIONS(5634),
    [anon_sym_short] = ACTIONS(5634),
    [anon_sym_LBRACK] = ACTIONS(5634),
    [anon_sym_static] = ACTIONS(5634),
    [anon_sym_register] = ACTIONS(5634),
    [anon_sym_inline] = ACTIONS(5634),
    [anon_sym___inline] = ACTIONS(5634),
    [anon_sym___inline__] = ACTIONS(5634),
    [anon_sym___forceinline] = ACTIONS(5634),
    [anon_sym_thread_local] = ACTIONS(5634),
    [anon_sym___thread] = ACTIONS(5634),
    [anon_sym_const] = ACTIONS(5634),
    [anon_sym_constexpr] = ACTIONS(5634),
    [anon_sym_volatile] = ACTIONS(5634),
    [anon_sym_restrict] = ACTIONS(5634),
    [anon_sym___restrict__] = ACTIONS(5634),
    [anon_sym__Atomic] = ACTIONS(5634),
    [anon_sym__Noreturn] = ACTIONS(5634),
    [anon_sym_noreturn] = ACTIONS(5634),
    [anon_sym_mutable] = ACTIONS(5634),
    [anon_sym_constinit] = ACTIONS(5634),
    [anon_sym_consteval] = ACTIONS(5634),
    [anon_sym_alignas] = ACTIONS(5634),
    [anon_sym__Alignas] = ACTIONS(5634),
    [sym_primitive_type] = ACTIONS(5634),
    [anon_sym_enum] = ACTIONS(5634),
    [anon_sym_class] = ACTIONS(5634),
    [anon_sym_struct] = ACTIONS(5634),
    [anon_sym_union] = ACTIONS(5634),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5634),
    [anon_sym_let] = ACTIONS(5634),
    [anon_sym_This] = ACTIONS(5634),
    [anon_sym_decltype] = ACTIONS(5634),
    [sym_virtual] = ACTIONS(5634),
    [anon_sym_explicit] = ACTIONS(5634),
    [anon_sym_typename] = ACTIONS(5634),
    [anon_sym_template] = ACTIONS(5634),
    [anon_sym_operator] = ACTIONS(5634),
    [anon_sym_friend] = ACTIONS(5634),
    [anon_sym_public] = ACTIONS(5634),
    [anon_sym_private] = ACTIONS(5634),
    [anon_sym_protected] = ACTIONS(5634),
    [anon_sym_using] = ACTIONS(5634),
    [anon_sym_static_assert] = ACTIONS(5634),
    [anon_sym_precise] = ACTIONS(5634),
    [anon_sym_shared] = ACTIONS(5634),
    [anon_sym_groupshared] = ACTIONS(5634),
    [anon_sym_uniform] = ACTIONS(5634),
    [anon_sym_row_major] = ACTIONS(5634),
    [anon_sym_column_major] = ACTIONS(5634),
    [anon_sym_globallycoherent] = ACTIONS(5634),
    [anon_sym_centroid] = ACTIONS(5634),
    [anon_sym_noperspective] = ACTIONS(5634),
    [anon_sym_nointerpolation] = ACTIONS(5634),
    [anon_sym_sample] = ACTIONS(5634),
    [anon_sym_linear] = ACTIONS(5634),
    [anon_sym_snorm] = ACTIONS(5634),
    [anon_sym_unorm] = ACTIONS(5634),
    [anon_sym_point] = ACTIONS(5634),
    [anon_sym_line] = ACTIONS(5634),
    [anon_sym_triangleadj] = ACTIONS(5634),
    [anon_sym_lineadj] = ACTIONS(5634),
    [anon_sym_triangle] = ACTIONS(5634),
    [anon_sym_interface] = ACTIONS(5634),
    [anon_sym_extension] = ACTIONS(5634),
    [anon_sym___init] = ACTIONS(5634),
    [anon_sym___subscript] = ACTIONS(5634),
    [anon_sym_property] = ACTIONS(5634),
    [anon_sym_associatedtype] = ACTIONS(5634),
  },
  [2063] = {
    [sym_expression] = STATE(5531),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2064] = {
    [sym_identifier] = ACTIONS(5638),
    [aux_sym_preproc_def_token1] = ACTIONS(5638),
    [aux_sym_preproc_if_token1] = ACTIONS(5638),
    [aux_sym_preproc_if_token2] = ACTIONS(5638),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5638),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5638),
    [sym_preproc_directive] = ACTIONS(5638),
    [anon_sym_LPAREN2] = ACTIONS(5640),
    [anon_sym_TILDE] = ACTIONS(5640),
    [anon_sym_STAR] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5638),
    [anon_sym___extension__] = ACTIONS(5638),
    [anon_sym_typedef] = ACTIONS(5638),
    [anon_sym_in] = ACTIONS(5638),
    [anon_sym_out] = ACTIONS(5638),
    [anon_sym_inout] = ACTIONS(5638),
    [anon_sym_extern] = ACTIONS(5638),
    [anon_sym___attribute__] = ACTIONS(5638),
    [anon_sym_COLON_COLON] = ACTIONS(5640),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5640),
    [anon_sym___declspec] = ACTIONS(5638),
    [anon_sym___based] = ACTIONS(5638),
    [anon_sym_signed] = ACTIONS(5638),
    [anon_sym_unsigned] = ACTIONS(5638),
    [anon_sym_long] = ACTIONS(5638),
    [anon_sym_short] = ACTIONS(5638),
    [anon_sym_LBRACK] = ACTIONS(5638),
    [anon_sym_static] = ACTIONS(5638),
    [anon_sym_register] = ACTIONS(5638),
    [anon_sym_inline] = ACTIONS(5638),
    [anon_sym___inline] = ACTIONS(5638),
    [anon_sym___inline__] = ACTIONS(5638),
    [anon_sym___forceinline] = ACTIONS(5638),
    [anon_sym_thread_local] = ACTIONS(5638),
    [anon_sym___thread] = ACTIONS(5638),
    [anon_sym_const] = ACTIONS(5638),
    [anon_sym_constexpr] = ACTIONS(5638),
    [anon_sym_volatile] = ACTIONS(5638),
    [anon_sym_restrict] = ACTIONS(5638),
    [anon_sym___restrict__] = ACTIONS(5638),
    [anon_sym__Atomic] = ACTIONS(5638),
    [anon_sym__Noreturn] = ACTIONS(5638),
    [anon_sym_noreturn] = ACTIONS(5638),
    [anon_sym_mutable] = ACTIONS(5638),
    [anon_sym_constinit] = ACTIONS(5638),
    [anon_sym_consteval] = ACTIONS(5638),
    [anon_sym_alignas] = ACTIONS(5638),
    [anon_sym__Alignas] = ACTIONS(5638),
    [sym_primitive_type] = ACTIONS(5638),
    [anon_sym_enum] = ACTIONS(5638),
    [anon_sym_class] = ACTIONS(5638),
    [anon_sym_struct] = ACTIONS(5638),
    [anon_sym_union] = ACTIONS(5638),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5638),
    [anon_sym_let] = ACTIONS(5638),
    [anon_sym_This] = ACTIONS(5638),
    [anon_sym_decltype] = ACTIONS(5638),
    [sym_virtual] = ACTIONS(5638),
    [anon_sym_explicit] = ACTIONS(5638),
    [anon_sym_typename] = ACTIONS(5638),
    [anon_sym_template] = ACTIONS(5638),
    [anon_sym_operator] = ACTIONS(5638),
    [anon_sym_friend] = ACTIONS(5638),
    [anon_sym_public] = ACTIONS(5638),
    [anon_sym_private] = ACTIONS(5638),
    [anon_sym_protected] = ACTIONS(5638),
    [anon_sym_using] = ACTIONS(5638),
    [anon_sym_static_assert] = ACTIONS(5638),
    [anon_sym_precise] = ACTIONS(5638),
    [anon_sym_shared] = ACTIONS(5638),
    [anon_sym_groupshared] = ACTIONS(5638),
    [anon_sym_uniform] = ACTIONS(5638),
    [anon_sym_row_major] = ACTIONS(5638),
    [anon_sym_column_major] = ACTIONS(5638),
    [anon_sym_globallycoherent] = ACTIONS(5638),
    [anon_sym_centroid] = ACTIONS(5638),
    [anon_sym_noperspective] = ACTIONS(5638),
    [anon_sym_nointerpolation] = ACTIONS(5638),
    [anon_sym_sample] = ACTIONS(5638),
    [anon_sym_linear] = ACTIONS(5638),
    [anon_sym_snorm] = ACTIONS(5638),
    [anon_sym_unorm] = ACTIONS(5638),
    [anon_sym_point] = ACTIONS(5638),
    [anon_sym_line] = ACTIONS(5638),
    [anon_sym_triangleadj] = ACTIONS(5638),
    [anon_sym_lineadj] = ACTIONS(5638),
    [anon_sym_triangle] = ACTIONS(5638),
    [anon_sym_interface] = ACTIONS(5638),
    [anon_sym_extension] = ACTIONS(5638),
    [anon_sym___init] = ACTIONS(5638),
    [anon_sym___subscript] = ACTIONS(5638),
    [anon_sym_property] = ACTIONS(5638),
    [anon_sym_associatedtype] = ACTIONS(5638),
  },
  [2065] = {
    [sym_identifier] = ACTIONS(5642),
    [aux_sym_preproc_def_token1] = ACTIONS(5642),
    [aux_sym_preproc_if_token1] = ACTIONS(5642),
    [aux_sym_preproc_if_token2] = ACTIONS(5642),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5642),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5642),
    [sym_preproc_directive] = ACTIONS(5642),
    [anon_sym_LPAREN2] = ACTIONS(5644),
    [anon_sym_TILDE] = ACTIONS(5644),
    [anon_sym_STAR] = ACTIONS(5644),
    [anon_sym_AMP_AMP] = ACTIONS(5644),
    [anon_sym_AMP] = ACTIONS(5642),
    [anon_sym___extension__] = ACTIONS(5642),
    [anon_sym_typedef] = ACTIONS(5642),
    [anon_sym_in] = ACTIONS(5642),
    [anon_sym_out] = ACTIONS(5642),
    [anon_sym_inout] = ACTIONS(5642),
    [anon_sym_extern] = ACTIONS(5642),
    [anon_sym___attribute__] = ACTIONS(5642),
    [anon_sym_COLON_COLON] = ACTIONS(5644),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5644),
    [anon_sym___declspec] = ACTIONS(5642),
    [anon_sym___based] = ACTIONS(5642),
    [anon_sym_signed] = ACTIONS(5642),
    [anon_sym_unsigned] = ACTIONS(5642),
    [anon_sym_long] = ACTIONS(5642),
    [anon_sym_short] = ACTIONS(5642),
    [anon_sym_LBRACK] = ACTIONS(5642),
    [anon_sym_static] = ACTIONS(5642),
    [anon_sym_register] = ACTIONS(5642),
    [anon_sym_inline] = ACTIONS(5642),
    [anon_sym___inline] = ACTIONS(5642),
    [anon_sym___inline__] = ACTIONS(5642),
    [anon_sym___forceinline] = ACTIONS(5642),
    [anon_sym_thread_local] = ACTIONS(5642),
    [anon_sym___thread] = ACTIONS(5642),
    [anon_sym_const] = ACTIONS(5642),
    [anon_sym_constexpr] = ACTIONS(5642),
    [anon_sym_volatile] = ACTIONS(5642),
    [anon_sym_restrict] = ACTIONS(5642),
    [anon_sym___restrict__] = ACTIONS(5642),
    [anon_sym__Atomic] = ACTIONS(5642),
    [anon_sym__Noreturn] = ACTIONS(5642),
    [anon_sym_noreturn] = ACTIONS(5642),
    [anon_sym_mutable] = ACTIONS(5642),
    [anon_sym_constinit] = ACTIONS(5642),
    [anon_sym_consteval] = ACTIONS(5642),
    [anon_sym_alignas] = ACTIONS(5642),
    [anon_sym__Alignas] = ACTIONS(5642),
    [sym_primitive_type] = ACTIONS(5642),
    [anon_sym_enum] = ACTIONS(5642),
    [anon_sym_class] = ACTIONS(5642),
    [anon_sym_struct] = ACTIONS(5642),
    [anon_sym_union] = ACTIONS(5642),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5642),
    [anon_sym_let] = ACTIONS(5642),
    [anon_sym_This] = ACTIONS(5642),
    [anon_sym_decltype] = ACTIONS(5642),
    [sym_virtual] = ACTIONS(5642),
    [anon_sym_explicit] = ACTIONS(5642),
    [anon_sym_typename] = ACTIONS(5642),
    [anon_sym_template] = ACTIONS(5642),
    [anon_sym_operator] = ACTIONS(5642),
    [anon_sym_friend] = ACTIONS(5642),
    [anon_sym_public] = ACTIONS(5642),
    [anon_sym_private] = ACTIONS(5642),
    [anon_sym_protected] = ACTIONS(5642),
    [anon_sym_using] = ACTIONS(5642),
    [anon_sym_static_assert] = ACTIONS(5642),
    [anon_sym_precise] = ACTIONS(5642),
    [anon_sym_shared] = ACTIONS(5642),
    [anon_sym_groupshared] = ACTIONS(5642),
    [anon_sym_uniform] = ACTIONS(5642),
    [anon_sym_row_major] = ACTIONS(5642),
    [anon_sym_column_major] = ACTIONS(5642),
    [anon_sym_globallycoherent] = ACTIONS(5642),
    [anon_sym_centroid] = ACTIONS(5642),
    [anon_sym_noperspective] = ACTIONS(5642),
    [anon_sym_nointerpolation] = ACTIONS(5642),
    [anon_sym_sample] = ACTIONS(5642),
    [anon_sym_linear] = ACTIONS(5642),
    [anon_sym_snorm] = ACTIONS(5642),
    [anon_sym_unorm] = ACTIONS(5642),
    [anon_sym_point] = ACTIONS(5642),
    [anon_sym_line] = ACTIONS(5642),
    [anon_sym_triangleadj] = ACTIONS(5642),
    [anon_sym_lineadj] = ACTIONS(5642),
    [anon_sym_triangle] = ACTIONS(5642),
    [anon_sym_interface] = ACTIONS(5642),
    [anon_sym_extension] = ACTIONS(5642),
    [anon_sym___init] = ACTIONS(5642),
    [anon_sym___subscript] = ACTIONS(5642),
    [anon_sym_property] = ACTIONS(5642),
    [anon_sym_associatedtype] = ACTIONS(5642),
  },
  [2066] = {
    [sym_expression] = STATE(5187),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2067] = {
    [sym_expression] = STATE(5186),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2068] = {
    [sym_expression] = STATE(5504),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2069] = {
    [sym_expression] = STATE(5502),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2070] = {
    [sym_identifier] = ACTIONS(5464),
    [aux_sym_preproc_def_token1] = ACTIONS(5464),
    [aux_sym_preproc_if_token1] = ACTIONS(5464),
    [aux_sym_preproc_if_token2] = ACTIONS(5464),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5464),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5464),
    [sym_preproc_directive] = ACTIONS(5464),
    [anon_sym_LPAREN2] = ACTIONS(5466),
    [anon_sym_TILDE] = ACTIONS(5466),
    [anon_sym_STAR] = ACTIONS(5466),
    [anon_sym_AMP_AMP] = ACTIONS(5466),
    [anon_sym_AMP] = ACTIONS(5464),
    [anon_sym___extension__] = ACTIONS(5464),
    [anon_sym_typedef] = ACTIONS(5464),
    [anon_sym_in] = ACTIONS(5464),
    [anon_sym_out] = ACTIONS(5464),
    [anon_sym_inout] = ACTIONS(5464),
    [anon_sym_extern] = ACTIONS(5464),
    [anon_sym___attribute__] = ACTIONS(5464),
    [anon_sym_COLON_COLON] = ACTIONS(5466),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5466),
    [anon_sym___declspec] = ACTIONS(5464),
    [anon_sym___based] = ACTIONS(5464),
    [anon_sym_signed] = ACTIONS(5464),
    [anon_sym_unsigned] = ACTIONS(5464),
    [anon_sym_long] = ACTIONS(5464),
    [anon_sym_short] = ACTIONS(5464),
    [anon_sym_LBRACK] = ACTIONS(5464),
    [anon_sym_static] = ACTIONS(5464),
    [anon_sym_register] = ACTIONS(5464),
    [anon_sym_inline] = ACTIONS(5464),
    [anon_sym___inline] = ACTIONS(5464),
    [anon_sym___inline__] = ACTIONS(5464),
    [anon_sym___forceinline] = ACTIONS(5464),
    [anon_sym_thread_local] = ACTIONS(5464),
    [anon_sym___thread] = ACTIONS(5464),
    [anon_sym_const] = ACTIONS(5464),
    [anon_sym_constexpr] = ACTIONS(5464),
    [anon_sym_volatile] = ACTIONS(5464),
    [anon_sym_restrict] = ACTIONS(5464),
    [anon_sym___restrict__] = ACTIONS(5464),
    [anon_sym__Atomic] = ACTIONS(5464),
    [anon_sym__Noreturn] = ACTIONS(5464),
    [anon_sym_noreturn] = ACTIONS(5464),
    [anon_sym_mutable] = ACTIONS(5464),
    [anon_sym_constinit] = ACTIONS(5464),
    [anon_sym_consteval] = ACTIONS(5464),
    [anon_sym_alignas] = ACTIONS(5464),
    [anon_sym__Alignas] = ACTIONS(5464),
    [sym_primitive_type] = ACTIONS(5464),
    [anon_sym_enum] = ACTIONS(5464),
    [anon_sym_class] = ACTIONS(5464),
    [anon_sym_struct] = ACTIONS(5464),
    [anon_sym_union] = ACTIONS(5464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5464),
    [anon_sym_let] = ACTIONS(5464),
    [anon_sym_This] = ACTIONS(5464),
    [anon_sym_decltype] = ACTIONS(5464),
    [sym_virtual] = ACTIONS(5464),
    [anon_sym_explicit] = ACTIONS(5464),
    [anon_sym_typename] = ACTIONS(5464),
    [anon_sym_template] = ACTIONS(5464),
    [anon_sym_operator] = ACTIONS(5464),
    [anon_sym_friend] = ACTIONS(5464),
    [anon_sym_public] = ACTIONS(5464),
    [anon_sym_private] = ACTIONS(5464),
    [anon_sym_protected] = ACTIONS(5464),
    [anon_sym_using] = ACTIONS(5464),
    [anon_sym_static_assert] = ACTIONS(5464),
    [anon_sym_precise] = ACTIONS(5464),
    [anon_sym_shared] = ACTIONS(5464),
    [anon_sym_groupshared] = ACTIONS(5464),
    [anon_sym_uniform] = ACTIONS(5464),
    [anon_sym_row_major] = ACTIONS(5464),
    [anon_sym_column_major] = ACTIONS(5464),
    [anon_sym_globallycoherent] = ACTIONS(5464),
    [anon_sym_centroid] = ACTIONS(5464),
    [anon_sym_noperspective] = ACTIONS(5464),
    [anon_sym_nointerpolation] = ACTIONS(5464),
    [anon_sym_sample] = ACTIONS(5464),
    [anon_sym_linear] = ACTIONS(5464),
    [anon_sym_snorm] = ACTIONS(5464),
    [anon_sym_unorm] = ACTIONS(5464),
    [anon_sym_point] = ACTIONS(5464),
    [anon_sym_line] = ACTIONS(5464),
    [anon_sym_triangleadj] = ACTIONS(5464),
    [anon_sym_lineadj] = ACTIONS(5464),
    [anon_sym_triangle] = ACTIONS(5464),
    [anon_sym_interface] = ACTIONS(5464),
    [anon_sym_extension] = ACTIONS(5464),
    [anon_sym___init] = ACTIONS(5464),
    [anon_sym___subscript] = ACTIONS(5464),
    [anon_sym_property] = ACTIONS(5464),
    [anon_sym_associatedtype] = ACTIONS(5464),
  },
  [2071] = {
    [sym_expression] = STATE(5435),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2072] = {
    [sym_identifier] = ACTIONS(5464),
    [aux_sym_preproc_def_token1] = ACTIONS(5464),
    [aux_sym_preproc_if_token1] = ACTIONS(5464),
    [aux_sym_preproc_if_token2] = ACTIONS(5464),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5464),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5464),
    [sym_preproc_directive] = ACTIONS(5464),
    [anon_sym_LPAREN2] = ACTIONS(5466),
    [anon_sym_TILDE] = ACTIONS(5466),
    [anon_sym_STAR] = ACTIONS(5466),
    [anon_sym_AMP_AMP] = ACTIONS(5466),
    [anon_sym_AMP] = ACTIONS(5464),
    [anon_sym___extension__] = ACTIONS(5464),
    [anon_sym_typedef] = ACTIONS(5464),
    [anon_sym_in] = ACTIONS(5464),
    [anon_sym_out] = ACTIONS(5464),
    [anon_sym_inout] = ACTIONS(5464),
    [anon_sym_extern] = ACTIONS(5464),
    [anon_sym___attribute__] = ACTIONS(5464),
    [anon_sym_COLON_COLON] = ACTIONS(5466),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5466),
    [anon_sym___declspec] = ACTIONS(5464),
    [anon_sym___based] = ACTIONS(5464),
    [anon_sym_signed] = ACTIONS(5464),
    [anon_sym_unsigned] = ACTIONS(5464),
    [anon_sym_long] = ACTIONS(5464),
    [anon_sym_short] = ACTIONS(5464),
    [anon_sym_LBRACK] = ACTIONS(5464),
    [anon_sym_static] = ACTIONS(5464),
    [anon_sym_register] = ACTIONS(5464),
    [anon_sym_inline] = ACTIONS(5464),
    [anon_sym___inline] = ACTIONS(5464),
    [anon_sym___inline__] = ACTIONS(5464),
    [anon_sym___forceinline] = ACTIONS(5464),
    [anon_sym_thread_local] = ACTIONS(5464),
    [anon_sym___thread] = ACTIONS(5464),
    [anon_sym_const] = ACTIONS(5464),
    [anon_sym_constexpr] = ACTIONS(5464),
    [anon_sym_volatile] = ACTIONS(5464),
    [anon_sym_restrict] = ACTIONS(5464),
    [anon_sym___restrict__] = ACTIONS(5464),
    [anon_sym__Atomic] = ACTIONS(5464),
    [anon_sym__Noreturn] = ACTIONS(5464),
    [anon_sym_noreturn] = ACTIONS(5464),
    [anon_sym_mutable] = ACTIONS(5464),
    [anon_sym_constinit] = ACTIONS(5464),
    [anon_sym_consteval] = ACTIONS(5464),
    [anon_sym_alignas] = ACTIONS(5464),
    [anon_sym__Alignas] = ACTIONS(5464),
    [sym_primitive_type] = ACTIONS(5464),
    [anon_sym_enum] = ACTIONS(5464),
    [anon_sym_class] = ACTIONS(5464),
    [anon_sym_struct] = ACTIONS(5464),
    [anon_sym_union] = ACTIONS(5464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5464),
    [anon_sym_let] = ACTIONS(5464),
    [anon_sym_This] = ACTIONS(5464),
    [anon_sym_decltype] = ACTIONS(5464),
    [sym_virtual] = ACTIONS(5464),
    [anon_sym_explicit] = ACTIONS(5464),
    [anon_sym_typename] = ACTIONS(5464),
    [anon_sym_template] = ACTIONS(5464),
    [anon_sym_operator] = ACTIONS(5464),
    [anon_sym_friend] = ACTIONS(5464),
    [anon_sym_public] = ACTIONS(5464),
    [anon_sym_private] = ACTIONS(5464),
    [anon_sym_protected] = ACTIONS(5464),
    [anon_sym_using] = ACTIONS(5464),
    [anon_sym_static_assert] = ACTIONS(5464),
    [anon_sym_precise] = ACTIONS(5464),
    [anon_sym_shared] = ACTIONS(5464),
    [anon_sym_groupshared] = ACTIONS(5464),
    [anon_sym_uniform] = ACTIONS(5464),
    [anon_sym_row_major] = ACTIONS(5464),
    [anon_sym_column_major] = ACTIONS(5464),
    [anon_sym_globallycoherent] = ACTIONS(5464),
    [anon_sym_centroid] = ACTIONS(5464),
    [anon_sym_noperspective] = ACTIONS(5464),
    [anon_sym_nointerpolation] = ACTIONS(5464),
    [anon_sym_sample] = ACTIONS(5464),
    [anon_sym_linear] = ACTIONS(5464),
    [anon_sym_snorm] = ACTIONS(5464),
    [anon_sym_unorm] = ACTIONS(5464),
    [anon_sym_point] = ACTIONS(5464),
    [anon_sym_line] = ACTIONS(5464),
    [anon_sym_triangleadj] = ACTIONS(5464),
    [anon_sym_lineadj] = ACTIONS(5464),
    [anon_sym_triangle] = ACTIONS(5464),
    [anon_sym_interface] = ACTIONS(5464),
    [anon_sym_extension] = ACTIONS(5464),
    [anon_sym___init] = ACTIONS(5464),
    [anon_sym___subscript] = ACTIONS(5464),
    [anon_sym_property] = ACTIONS(5464),
    [anon_sym_associatedtype] = ACTIONS(5464),
  },
  [2073] = {
    [sym_identifier] = ACTIONS(5650),
    [aux_sym_preproc_def_token1] = ACTIONS(5650),
    [aux_sym_preproc_if_token1] = ACTIONS(5650),
    [aux_sym_preproc_if_token2] = ACTIONS(5650),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5650),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5650),
    [sym_preproc_directive] = ACTIONS(5650),
    [anon_sym_LPAREN2] = ACTIONS(5652),
    [anon_sym_TILDE] = ACTIONS(5652),
    [anon_sym_STAR] = ACTIONS(5652),
    [anon_sym_AMP_AMP] = ACTIONS(5652),
    [anon_sym_AMP] = ACTIONS(5650),
    [anon_sym___extension__] = ACTIONS(5650),
    [anon_sym_typedef] = ACTIONS(5650),
    [anon_sym_in] = ACTIONS(5650),
    [anon_sym_out] = ACTIONS(5650),
    [anon_sym_inout] = ACTIONS(5650),
    [anon_sym_extern] = ACTIONS(5650),
    [anon_sym___attribute__] = ACTIONS(5650),
    [anon_sym_COLON_COLON] = ACTIONS(5652),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5652),
    [anon_sym___declspec] = ACTIONS(5650),
    [anon_sym___based] = ACTIONS(5650),
    [anon_sym_signed] = ACTIONS(5650),
    [anon_sym_unsigned] = ACTIONS(5650),
    [anon_sym_long] = ACTIONS(5650),
    [anon_sym_short] = ACTIONS(5650),
    [anon_sym_LBRACK] = ACTIONS(5650),
    [anon_sym_static] = ACTIONS(5650),
    [anon_sym_register] = ACTIONS(5650),
    [anon_sym_inline] = ACTIONS(5650),
    [anon_sym___inline] = ACTIONS(5650),
    [anon_sym___inline__] = ACTIONS(5650),
    [anon_sym___forceinline] = ACTIONS(5650),
    [anon_sym_thread_local] = ACTIONS(5650),
    [anon_sym___thread] = ACTIONS(5650),
    [anon_sym_const] = ACTIONS(5650),
    [anon_sym_constexpr] = ACTIONS(5650),
    [anon_sym_volatile] = ACTIONS(5650),
    [anon_sym_restrict] = ACTIONS(5650),
    [anon_sym___restrict__] = ACTIONS(5650),
    [anon_sym__Atomic] = ACTIONS(5650),
    [anon_sym__Noreturn] = ACTIONS(5650),
    [anon_sym_noreturn] = ACTIONS(5650),
    [anon_sym_mutable] = ACTIONS(5650),
    [anon_sym_constinit] = ACTIONS(5650),
    [anon_sym_consteval] = ACTIONS(5650),
    [anon_sym_alignas] = ACTIONS(5650),
    [anon_sym__Alignas] = ACTIONS(5650),
    [sym_primitive_type] = ACTIONS(5650),
    [anon_sym_enum] = ACTIONS(5650),
    [anon_sym_class] = ACTIONS(5650),
    [anon_sym_struct] = ACTIONS(5650),
    [anon_sym_union] = ACTIONS(5650),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5650),
    [anon_sym_let] = ACTIONS(5650),
    [anon_sym_This] = ACTIONS(5650),
    [anon_sym_decltype] = ACTIONS(5650),
    [sym_virtual] = ACTIONS(5650),
    [anon_sym_explicit] = ACTIONS(5650),
    [anon_sym_typename] = ACTIONS(5650),
    [anon_sym_template] = ACTIONS(5650),
    [anon_sym_operator] = ACTIONS(5650),
    [anon_sym_friend] = ACTIONS(5650),
    [anon_sym_public] = ACTIONS(5650),
    [anon_sym_private] = ACTIONS(5650),
    [anon_sym_protected] = ACTIONS(5650),
    [anon_sym_using] = ACTIONS(5650),
    [anon_sym_static_assert] = ACTIONS(5650),
    [anon_sym_precise] = ACTIONS(5650),
    [anon_sym_shared] = ACTIONS(5650),
    [anon_sym_groupshared] = ACTIONS(5650),
    [anon_sym_uniform] = ACTIONS(5650),
    [anon_sym_row_major] = ACTIONS(5650),
    [anon_sym_column_major] = ACTIONS(5650),
    [anon_sym_globallycoherent] = ACTIONS(5650),
    [anon_sym_centroid] = ACTIONS(5650),
    [anon_sym_noperspective] = ACTIONS(5650),
    [anon_sym_nointerpolation] = ACTIONS(5650),
    [anon_sym_sample] = ACTIONS(5650),
    [anon_sym_linear] = ACTIONS(5650),
    [anon_sym_snorm] = ACTIONS(5650),
    [anon_sym_unorm] = ACTIONS(5650),
    [anon_sym_point] = ACTIONS(5650),
    [anon_sym_line] = ACTIONS(5650),
    [anon_sym_triangleadj] = ACTIONS(5650),
    [anon_sym_lineadj] = ACTIONS(5650),
    [anon_sym_triangle] = ACTIONS(5650),
    [anon_sym_interface] = ACTIONS(5650),
    [anon_sym_extension] = ACTIONS(5650),
    [anon_sym___init] = ACTIONS(5650),
    [anon_sym___subscript] = ACTIONS(5650),
    [anon_sym_property] = ACTIONS(5650),
    [anon_sym_associatedtype] = ACTIONS(5650),
  },
  [2074] = {
    [sym_identifier] = ACTIONS(5646),
    [aux_sym_preproc_def_token1] = ACTIONS(5646),
    [aux_sym_preproc_if_token1] = ACTIONS(5646),
    [aux_sym_preproc_if_token2] = ACTIONS(5646),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5646),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5646),
    [sym_preproc_directive] = ACTIONS(5646),
    [anon_sym_LPAREN2] = ACTIONS(5648),
    [anon_sym_TILDE] = ACTIONS(5648),
    [anon_sym_STAR] = ACTIONS(5648),
    [anon_sym_AMP_AMP] = ACTIONS(5648),
    [anon_sym_AMP] = ACTIONS(5646),
    [anon_sym___extension__] = ACTIONS(5646),
    [anon_sym_typedef] = ACTIONS(5646),
    [anon_sym_in] = ACTIONS(5646),
    [anon_sym_out] = ACTIONS(5646),
    [anon_sym_inout] = ACTIONS(5646),
    [anon_sym_extern] = ACTIONS(5646),
    [anon_sym___attribute__] = ACTIONS(5646),
    [anon_sym_COLON_COLON] = ACTIONS(5648),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5648),
    [anon_sym___declspec] = ACTIONS(5646),
    [anon_sym___based] = ACTIONS(5646),
    [anon_sym_signed] = ACTIONS(5646),
    [anon_sym_unsigned] = ACTIONS(5646),
    [anon_sym_long] = ACTIONS(5646),
    [anon_sym_short] = ACTIONS(5646),
    [anon_sym_LBRACK] = ACTIONS(5646),
    [anon_sym_static] = ACTIONS(5646),
    [anon_sym_register] = ACTIONS(5646),
    [anon_sym_inline] = ACTIONS(5646),
    [anon_sym___inline] = ACTIONS(5646),
    [anon_sym___inline__] = ACTIONS(5646),
    [anon_sym___forceinline] = ACTIONS(5646),
    [anon_sym_thread_local] = ACTIONS(5646),
    [anon_sym___thread] = ACTIONS(5646),
    [anon_sym_const] = ACTIONS(5646),
    [anon_sym_constexpr] = ACTIONS(5646),
    [anon_sym_volatile] = ACTIONS(5646),
    [anon_sym_restrict] = ACTIONS(5646),
    [anon_sym___restrict__] = ACTIONS(5646),
    [anon_sym__Atomic] = ACTIONS(5646),
    [anon_sym__Noreturn] = ACTIONS(5646),
    [anon_sym_noreturn] = ACTIONS(5646),
    [anon_sym_mutable] = ACTIONS(5646),
    [anon_sym_constinit] = ACTIONS(5646),
    [anon_sym_consteval] = ACTIONS(5646),
    [anon_sym_alignas] = ACTIONS(5646),
    [anon_sym__Alignas] = ACTIONS(5646),
    [sym_primitive_type] = ACTIONS(5646),
    [anon_sym_enum] = ACTIONS(5646),
    [anon_sym_class] = ACTIONS(5646),
    [anon_sym_struct] = ACTIONS(5646),
    [anon_sym_union] = ACTIONS(5646),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5646),
    [anon_sym_let] = ACTIONS(5646),
    [anon_sym_This] = ACTIONS(5646),
    [anon_sym_decltype] = ACTIONS(5646),
    [sym_virtual] = ACTIONS(5646),
    [anon_sym_explicit] = ACTIONS(5646),
    [anon_sym_typename] = ACTIONS(5646),
    [anon_sym_template] = ACTIONS(5646),
    [anon_sym_operator] = ACTIONS(5646),
    [anon_sym_friend] = ACTIONS(5646),
    [anon_sym_public] = ACTIONS(5646),
    [anon_sym_private] = ACTIONS(5646),
    [anon_sym_protected] = ACTIONS(5646),
    [anon_sym_using] = ACTIONS(5646),
    [anon_sym_static_assert] = ACTIONS(5646),
    [anon_sym_precise] = ACTIONS(5646),
    [anon_sym_shared] = ACTIONS(5646),
    [anon_sym_groupshared] = ACTIONS(5646),
    [anon_sym_uniform] = ACTIONS(5646),
    [anon_sym_row_major] = ACTIONS(5646),
    [anon_sym_column_major] = ACTIONS(5646),
    [anon_sym_globallycoherent] = ACTIONS(5646),
    [anon_sym_centroid] = ACTIONS(5646),
    [anon_sym_noperspective] = ACTIONS(5646),
    [anon_sym_nointerpolation] = ACTIONS(5646),
    [anon_sym_sample] = ACTIONS(5646),
    [anon_sym_linear] = ACTIONS(5646),
    [anon_sym_snorm] = ACTIONS(5646),
    [anon_sym_unorm] = ACTIONS(5646),
    [anon_sym_point] = ACTIONS(5646),
    [anon_sym_line] = ACTIONS(5646),
    [anon_sym_triangleadj] = ACTIONS(5646),
    [anon_sym_lineadj] = ACTIONS(5646),
    [anon_sym_triangle] = ACTIONS(5646),
    [anon_sym_interface] = ACTIONS(5646),
    [anon_sym_extension] = ACTIONS(5646),
    [anon_sym___init] = ACTIONS(5646),
    [anon_sym___subscript] = ACTIONS(5646),
    [anon_sym_property] = ACTIONS(5646),
    [anon_sym_associatedtype] = ACTIONS(5646),
  },
  [2075] = {
    [sym_expression] = STATE(5383),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2076] = {
    [sym_expression] = STATE(5258),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2077] = {
    [sym_expression] = STATE(3843),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5781),
    [anon_sym_BANG] = ACTIONS(4611),
    [anon_sym_TILDE] = ACTIONS(4611),
    [anon_sym_DASH] = ACTIONS(4609),
    [anon_sym_PLUS] = ACTIONS(4609),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4613),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4609),
    [anon_sym_compl] = ACTIONS(4609),
    [anon_sym_DASH_DASH] = ACTIONS(5713),
    [anon_sym_PLUS_PLUS] = ACTIONS(5713),
    [anon_sym_sizeof] = ACTIONS(4615),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4617),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4619),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2078] = {
    [sym_identifier] = ACTIONS(3038),
    [aux_sym_preproc_def_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3038),
    [sym_preproc_directive] = ACTIONS(3038),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3038),
    [anon_sym___extension__] = ACTIONS(3038),
    [anon_sym_typedef] = ACTIONS(3038),
    [anon_sym_in] = ACTIONS(3038),
    [anon_sym_out] = ACTIONS(3038),
    [anon_sym_inout] = ACTIONS(3038),
    [anon_sym_extern] = ACTIONS(3038),
    [anon_sym___attribute__] = ACTIONS(3038),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3040),
    [anon_sym___declspec] = ACTIONS(3038),
    [anon_sym___based] = ACTIONS(3038),
    [anon_sym_RBRACE] = ACTIONS(3040),
    [anon_sym_signed] = ACTIONS(3038),
    [anon_sym_unsigned] = ACTIONS(3038),
    [anon_sym_long] = ACTIONS(3038),
    [anon_sym_short] = ACTIONS(3038),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_static] = ACTIONS(3038),
    [anon_sym_register] = ACTIONS(3038),
    [anon_sym_inline] = ACTIONS(3038),
    [anon_sym___inline] = ACTIONS(3038),
    [anon_sym___inline__] = ACTIONS(3038),
    [anon_sym___forceinline] = ACTIONS(3038),
    [anon_sym_thread_local] = ACTIONS(3038),
    [anon_sym___thread] = ACTIONS(3038),
    [anon_sym_const] = ACTIONS(3038),
    [anon_sym_constexpr] = ACTIONS(3038),
    [anon_sym_volatile] = ACTIONS(3038),
    [anon_sym_restrict] = ACTIONS(3038),
    [anon_sym___restrict__] = ACTIONS(3038),
    [anon_sym__Atomic] = ACTIONS(3038),
    [anon_sym__Noreturn] = ACTIONS(3038),
    [anon_sym_noreturn] = ACTIONS(3038),
    [anon_sym_mutable] = ACTIONS(3038),
    [anon_sym_constinit] = ACTIONS(3038),
    [anon_sym_consteval] = ACTIONS(3038),
    [anon_sym_alignas] = ACTIONS(3038),
    [anon_sym__Alignas] = ACTIONS(3038),
    [sym_primitive_type] = ACTIONS(3038),
    [anon_sym_enum] = ACTIONS(3038),
    [anon_sym_class] = ACTIONS(3038),
    [anon_sym_struct] = ACTIONS(3038),
    [anon_sym_union] = ACTIONS(3038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3038),
    [anon_sym_let] = ACTIONS(3038),
    [anon_sym_This] = ACTIONS(3038),
    [anon_sym_decltype] = ACTIONS(3038),
    [sym_virtual] = ACTIONS(3038),
    [anon_sym_explicit] = ACTIONS(3038),
    [anon_sym_typename] = ACTIONS(3038),
    [anon_sym_template] = ACTIONS(3038),
    [anon_sym_operator] = ACTIONS(3038),
    [anon_sym_friend] = ACTIONS(3038),
    [anon_sym_public] = ACTIONS(3038),
    [anon_sym_private] = ACTIONS(3038),
    [anon_sym_protected] = ACTIONS(3038),
    [anon_sym_using] = ACTIONS(3038),
    [anon_sym_static_assert] = ACTIONS(3038),
    [anon_sym_precise] = ACTIONS(3038),
    [anon_sym_shared] = ACTIONS(3038),
    [anon_sym_groupshared] = ACTIONS(3038),
    [anon_sym_uniform] = ACTIONS(3038),
    [anon_sym_row_major] = ACTIONS(3038),
    [anon_sym_column_major] = ACTIONS(3038),
    [anon_sym_globallycoherent] = ACTIONS(3038),
    [anon_sym_centroid] = ACTIONS(3038),
    [anon_sym_noperspective] = ACTIONS(3038),
    [anon_sym_nointerpolation] = ACTIONS(3038),
    [anon_sym_sample] = ACTIONS(3038),
    [anon_sym_linear] = ACTIONS(3038),
    [anon_sym_snorm] = ACTIONS(3038),
    [anon_sym_unorm] = ACTIONS(3038),
    [anon_sym_point] = ACTIONS(3038),
    [anon_sym_line] = ACTIONS(3038),
    [anon_sym_triangleadj] = ACTIONS(3038),
    [anon_sym_lineadj] = ACTIONS(3038),
    [anon_sym_triangle] = ACTIONS(3038),
    [anon_sym_interface] = ACTIONS(3038),
    [anon_sym_extension] = ACTIONS(3038),
    [anon_sym___init] = ACTIONS(3038),
    [anon_sym___subscript] = ACTIONS(3038),
    [anon_sym_property] = ACTIONS(3038),
    [anon_sym_associatedtype] = ACTIONS(3038),
  },
  [2079] = {
    [sym_expression] = STATE(5181),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2080] = {
    [sym_expression] = STATE(5475),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2081] = {
    [sym_identifier] = ACTIONS(3441),
    [aux_sym_preproc_def_token1] = ACTIONS(3441),
    [aux_sym_preproc_if_token1] = ACTIONS(3441),
    [aux_sym_preproc_if_token2] = ACTIONS(3441),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3441),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3441),
    [sym_preproc_directive] = ACTIONS(3441),
    [anon_sym_LPAREN2] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(3443),
    [anon_sym_AMP_AMP] = ACTIONS(3443),
    [anon_sym_AMP] = ACTIONS(3441),
    [anon_sym___extension__] = ACTIONS(3441),
    [anon_sym_typedef] = ACTIONS(3441),
    [anon_sym_in] = ACTIONS(3441),
    [anon_sym_out] = ACTIONS(3441),
    [anon_sym_inout] = ACTIONS(3441),
    [anon_sym_extern] = ACTIONS(3441),
    [anon_sym___attribute__] = ACTIONS(3441),
    [anon_sym_COLON_COLON] = ACTIONS(3443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3443),
    [anon_sym___declspec] = ACTIONS(3441),
    [anon_sym___based] = ACTIONS(3441),
    [anon_sym_signed] = ACTIONS(3441),
    [anon_sym_unsigned] = ACTIONS(3441),
    [anon_sym_long] = ACTIONS(3441),
    [anon_sym_short] = ACTIONS(3441),
    [anon_sym_LBRACK] = ACTIONS(3441),
    [anon_sym_static] = ACTIONS(3441),
    [anon_sym_register] = ACTIONS(3441),
    [anon_sym_inline] = ACTIONS(3441),
    [anon_sym___inline] = ACTIONS(3441),
    [anon_sym___inline__] = ACTIONS(3441),
    [anon_sym___forceinline] = ACTIONS(3441),
    [anon_sym_thread_local] = ACTIONS(3441),
    [anon_sym___thread] = ACTIONS(3441),
    [anon_sym_const] = ACTIONS(3441),
    [anon_sym_constexpr] = ACTIONS(3441),
    [anon_sym_volatile] = ACTIONS(3441),
    [anon_sym_restrict] = ACTIONS(3441),
    [anon_sym___restrict__] = ACTIONS(3441),
    [anon_sym__Atomic] = ACTIONS(3441),
    [anon_sym__Noreturn] = ACTIONS(3441),
    [anon_sym_noreturn] = ACTIONS(3441),
    [anon_sym_mutable] = ACTIONS(3441),
    [anon_sym_constinit] = ACTIONS(3441),
    [anon_sym_consteval] = ACTIONS(3441),
    [anon_sym_alignas] = ACTIONS(3441),
    [anon_sym__Alignas] = ACTIONS(3441),
    [sym_primitive_type] = ACTIONS(3441),
    [anon_sym_enum] = ACTIONS(3441),
    [anon_sym_class] = ACTIONS(3441),
    [anon_sym_struct] = ACTIONS(3441),
    [anon_sym_union] = ACTIONS(3441),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3441),
    [anon_sym_let] = ACTIONS(3441),
    [anon_sym_This] = ACTIONS(3441),
    [anon_sym_decltype] = ACTIONS(3441),
    [sym_virtual] = ACTIONS(3441),
    [anon_sym_explicit] = ACTIONS(3441),
    [anon_sym_typename] = ACTIONS(3441),
    [anon_sym_template] = ACTIONS(3441),
    [anon_sym_operator] = ACTIONS(3441),
    [anon_sym_friend] = ACTIONS(3441),
    [anon_sym_public] = ACTIONS(3441),
    [anon_sym_private] = ACTIONS(3441),
    [anon_sym_protected] = ACTIONS(3441),
    [anon_sym_using] = ACTIONS(3441),
    [anon_sym_static_assert] = ACTIONS(3441),
    [anon_sym_precise] = ACTIONS(3441),
    [anon_sym_shared] = ACTIONS(3441),
    [anon_sym_groupshared] = ACTIONS(3441),
    [anon_sym_uniform] = ACTIONS(3441),
    [anon_sym_row_major] = ACTIONS(3441),
    [anon_sym_column_major] = ACTIONS(3441),
    [anon_sym_globallycoherent] = ACTIONS(3441),
    [anon_sym_centroid] = ACTIONS(3441),
    [anon_sym_noperspective] = ACTIONS(3441),
    [anon_sym_nointerpolation] = ACTIONS(3441),
    [anon_sym_sample] = ACTIONS(3441),
    [anon_sym_linear] = ACTIONS(3441),
    [anon_sym_snorm] = ACTIONS(3441),
    [anon_sym_unorm] = ACTIONS(3441),
    [anon_sym_point] = ACTIONS(3441),
    [anon_sym_line] = ACTIONS(3441),
    [anon_sym_triangleadj] = ACTIONS(3441),
    [anon_sym_lineadj] = ACTIONS(3441),
    [anon_sym_triangle] = ACTIONS(3441),
    [anon_sym_interface] = ACTIONS(3441),
    [anon_sym_extension] = ACTIONS(3441),
    [anon_sym___init] = ACTIONS(3441),
    [anon_sym___subscript] = ACTIONS(3441),
    [anon_sym_property] = ACTIONS(3441),
    [anon_sym_associatedtype] = ACTIONS(3441),
  },
  [2082] = {
    [sym_identifier] = ACTIONS(5460),
    [aux_sym_preproc_def_token1] = ACTIONS(5460),
    [aux_sym_preproc_if_token1] = ACTIONS(5460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5460),
    [sym_preproc_directive] = ACTIONS(5460),
    [anon_sym_LPAREN2] = ACTIONS(5462),
    [anon_sym_TILDE] = ACTIONS(5462),
    [anon_sym_STAR] = ACTIONS(5462),
    [anon_sym_AMP_AMP] = ACTIONS(5462),
    [anon_sym_AMP] = ACTIONS(5460),
    [anon_sym___extension__] = ACTIONS(5460),
    [anon_sym_typedef] = ACTIONS(5460),
    [anon_sym_in] = ACTIONS(5460),
    [anon_sym_out] = ACTIONS(5460),
    [anon_sym_inout] = ACTIONS(5460),
    [anon_sym_extern] = ACTIONS(5460),
    [anon_sym___attribute__] = ACTIONS(5460),
    [anon_sym_COLON_COLON] = ACTIONS(5462),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5462),
    [anon_sym___declspec] = ACTIONS(5460),
    [anon_sym___based] = ACTIONS(5460),
    [anon_sym_RBRACE] = ACTIONS(5462),
    [anon_sym_signed] = ACTIONS(5460),
    [anon_sym_unsigned] = ACTIONS(5460),
    [anon_sym_long] = ACTIONS(5460),
    [anon_sym_short] = ACTIONS(5460),
    [anon_sym_LBRACK] = ACTIONS(5460),
    [anon_sym_static] = ACTIONS(5460),
    [anon_sym_register] = ACTIONS(5460),
    [anon_sym_inline] = ACTIONS(5460),
    [anon_sym___inline] = ACTIONS(5460),
    [anon_sym___inline__] = ACTIONS(5460),
    [anon_sym___forceinline] = ACTIONS(5460),
    [anon_sym_thread_local] = ACTIONS(5460),
    [anon_sym___thread] = ACTIONS(5460),
    [anon_sym_const] = ACTIONS(5460),
    [anon_sym_constexpr] = ACTIONS(5460),
    [anon_sym_volatile] = ACTIONS(5460),
    [anon_sym_restrict] = ACTIONS(5460),
    [anon_sym___restrict__] = ACTIONS(5460),
    [anon_sym__Atomic] = ACTIONS(5460),
    [anon_sym__Noreturn] = ACTIONS(5460),
    [anon_sym_noreturn] = ACTIONS(5460),
    [anon_sym_mutable] = ACTIONS(5460),
    [anon_sym_constinit] = ACTIONS(5460),
    [anon_sym_consteval] = ACTIONS(5460),
    [anon_sym_alignas] = ACTIONS(5460),
    [anon_sym__Alignas] = ACTIONS(5460),
    [sym_primitive_type] = ACTIONS(5460),
    [anon_sym_enum] = ACTIONS(5460),
    [anon_sym_class] = ACTIONS(5460),
    [anon_sym_struct] = ACTIONS(5460),
    [anon_sym_union] = ACTIONS(5460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5460),
    [anon_sym_let] = ACTIONS(5460),
    [anon_sym_This] = ACTIONS(5460),
    [anon_sym_decltype] = ACTIONS(5460),
    [sym_virtual] = ACTIONS(5460),
    [anon_sym_explicit] = ACTIONS(5460),
    [anon_sym_typename] = ACTIONS(5460),
    [anon_sym_template] = ACTIONS(5460),
    [anon_sym_operator] = ACTIONS(5460),
    [anon_sym_friend] = ACTIONS(5460),
    [anon_sym_public] = ACTIONS(5460),
    [anon_sym_private] = ACTIONS(5460),
    [anon_sym_protected] = ACTIONS(5460),
    [anon_sym_using] = ACTIONS(5460),
    [anon_sym_static_assert] = ACTIONS(5460),
    [anon_sym_precise] = ACTIONS(5460),
    [anon_sym_shared] = ACTIONS(5460),
    [anon_sym_groupshared] = ACTIONS(5460),
    [anon_sym_uniform] = ACTIONS(5460),
    [anon_sym_row_major] = ACTIONS(5460),
    [anon_sym_column_major] = ACTIONS(5460),
    [anon_sym_globallycoherent] = ACTIONS(5460),
    [anon_sym_centroid] = ACTIONS(5460),
    [anon_sym_noperspective] = ACTIONS(5460),
    [anon_sym_nointerpolation] = ACTIONS(5460),
    [anon_sym_sample] = ACTIONS(5460),
    [anon_sym_linear] = ACTIONS(5460),
    [anon_sym_snorm] = ACTIONS(5460),
    [anon_sym_unorm] = ACTIONS(5460),
    [anon_sym_point] = ACTIONS(5460),
    [anon_sym_line] = ACTIONS(5460),
    [anon_sym_triangleadj] = ACTIONS(5460),
    [anon_sym_lineadj] = ACTIONS(5460),
    [anon_sym_triangle] = ACTIONS(5460),
    [anon_sym_interface] = ACTIONS(5460),
    [anon_sym_extension] = ACTIONS(5460),
    [anon_sym___init] = ACTIONS(5460),
    [anon_sym___subscript] = ACTIONS(5460),
    [anon_sym_property] = ACTIONS(5460),
    [anon_sym_associatedtype] = ACTIONS(5460),
  },
  [2083] = {
    [sym_identifier] = ACTIONS(5460),
    [aux_sym_preproc_def_token1] = ACTIONS(5460),
    [aux_sym_preproc_if_token1] = ACTIONS(5460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5460),
    [sym_preproc_directive] = ACTIONS(5460),
    [anon_sym_LPAREN2] = ACTIONS(5462),
    [anon_sym_TILDE] = ACTIONS(5462),
    [anon_sym_STAR] = ACTIONS(5462),
    [anon_sym_AMP_AMP] = ACTIONS(5462),
    [anon_sym_AMP] = ACTIONS(5460),
    [anon_sym___extension__] = ACTIONS(5460),
    [anon_sym_typedef] = ACTIONS(5460),
    [anon_sym_in] = ACTIONS(5460),
    [anon_sym_out] = ACTIONS(5460),
    [anon_sym_inout] = ACTIONS(5460),
    [anon_sym_extern] = ACTIONS(5460),
    [anon_sym___attribute__] = ACTIONS(5460),
    [anon_sym_COLON_COLON] = ACTIONS(5462),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5462),
    [anon_sym___declspec] = ACTIONS(5460),
    [anon_sym___based] = ACTIONS(5460),
    [anon_sym_RBRACE] = ACTIONS(5462),
    [anon_sym_signed] = ACTIONS(5460),
    [anon_sym_unsigned] = ACTIONS(5460),
    [anon_sym_long] = ACTIONS(5460),
    [anon_sym_short] = ACTIONS(5460),
    [anon_sym_LBRACK] = ACTIONS(5460),
    [anon_sym_static] = ACTIONS(5460),
    [anon_sym_register] = ACTIONS(5460),
    [anon_sym_inline] = ACTIONS(5460),
    [anon_sym___inline] = ACTIONS(5460),
    [anon_sym___inline__] = ACTIONS(5460),
    [anon_sym___forceinline] = ACTIONS(5460),
    [anon_sym_thread_local] = ACTIONS(5460),
    [anon_sym___thread] = ACTIONS(5460),
    [anon_sym_const] = ACTIONS(5460),
    [anon_sym_constexpr] = ACTIONS(5460),
    [anon_sym_volatile] = ACTIONS(5460),
    [anon_sym_restrict] = ACTIONS(5460),
    [anon_sym___restrict__] = ACTIONS(5460),
    [anon_sym__Atomic] = ACTIONS(5460),
    [anon_sym__Noreturn] = ACTIONS(5460),
    [anon_sym_noreturn] = ACTIONS(5460),
    [anon_sym_mutable] = ACTIONS(5460),
    [anon_sym_constinit] = ACTIONS(5460),
    [anon_sym_consteval] = ACTIONS(5460),
    [anon_sym_alignas] = ACTIONS(5460),
    [anon_sym__Alignas] = ACTIONS(5460),
    [sym_primitive_type] = ACTIONS(5460),
    [anon_sym_enum] = ACTIONS(5460),
    [anon_sym_class] = ACTIONS(5460),
    [anon_sym_struct] = ACTIONS(5460),
    [anon_sym_union] = ACTIONS(5460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5460),
    [anon_sym_let] = ACTIONS(5460),
    [anon_sym_This] = ACTIONS(5460),
    [anon_sym_decltype] = ACTIONS(5460),
    [sym_virtual] = ACTIONS(5460),
    [anon_sym_explicit] = ACTIONS(5460),
    [anon_sym_typename] = ACTIONS(5460),
    [anon_sym_template] = ACTIONS(5460),
    [anon_sym_operator] = ACTIONS(5460),
    [anon_sym_friend] = ACTIONS(5460),
    [anon_sym_public] = ACTIONS(5460),
    [anon_sym_private] = ACTIONS(5460),
    [anon_sym_protected] = ACTIONS(5460),
    [anon_sym_using] = ACTIONS(5460),
    [anon_sym_static_assert] = ACTIONS(5460),
    [anon_sym_precise] = ACTIONS(5460),
    [anon_sym_shared] = ACTIONS(5460),
    [anon_sym_groupshared] = ACTIONS(5460),
    [anon_sym_uniform] = ACTIONS(5460),
    [anon_sym_row_major] = ACTIONS(5460),
    [anon_sym_column_major] = ACTIONS(5460),
    [anon_sym_globallycoherent] = ACTIONS(5460),
    [anon_sym_centroid] = ACTIONS(5460),
    [anon_sym_noperspective] = ACTIONS(5460),
    [anon_sym_nointerpolation] = ACTIONS(5460),
    [anon_sym_sample] = ACTIONS(5460),
    [anon_sym_linear] = ACTIONS(5460),
    [anon_sym_snorm] = ACTIONS(5460),
    [anon_sym_unorm] = ACTIONS(5460),
    [anon_sym_point] = ACTIONS(5460),
    [anon_sym_line] = ACTIONS(5460),
    [anon_sym_triangleadj] = ACTIONS(5460),
    [anon_sym_lineadj] = ACTIONS(5460),
    [anon_sym_triangle] = ACTIONS(5460),
    [anon_sym_interface] = ACTIONS(5460),
    [anon_sym_extension] = ACTIONS(5460),
    [anon_sym___init] = ACTIONS(5460),
    [anon_sym___subscript] = ACTIONS(5460),
    [anon_sym_property] = ACTIONS(5460),
    [anon_sym_associatedtype] = ACTIONS(5460),
  },
  [2084] = {
    [sym_identifier] = ACTIONS(5500),
    [aux_sym_preproc_def_token1] = ACTIONS(5500),
    [aux_sym_preproc_if_token1] = ACTIONS(5500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5500),
    [sym_preproc_directive] = ACTIONS(5500),
    [anon_sym_LPAREN2] = ACTIONS(5502),
    [anon_sym_TILDE] = ACTIONS(5502),
    [anon_sym_STAR] = ACTIONS(5502),
    [anon_sym_AMP_AMP] = ACTIONS(5502),
    [anon_sym_AMP] = ACTIONS(5500),
    [anon_sym___extension__] = ACTIONS(5500),
    [anon_sym_typedef] = ACTIONS(5500),
    [anon_sym_in] = ACTIONS(5500),
    [anon_sym_out] = ACTIONS(5500),
    [anon_sym_inout] = ACTIONS(5500),
    [anon_sym_extern] = ACTIONS(5500),
    [anon_sym___attribute__] = ACTIONS(5500),
    [anon_sym_COLON_COLON] = ACTIONS(5502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5502),
    [anon_sym___declspec] = ACTIONS(5500),
    [anon_sym___based] = ACTIONS(5500),
    [anon_sym_RBRACE] = ACTIONS(5502),
    [anon_sym_signed] = ACTIONS(5500),
    [anon_sym_unsigned] = ACTIONS(5500),
    [anon_sym_long] = ACTIONS(5500),
    [anon_sym_short] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5500),
    [anon_sym_static] = ACTIONS(5500),
    [anon_sym_register] = ACTIONS(5500),
    [anon_sym_inline] = ACTIONS(5500),
    [anon_sym___inline] = ACTIONS(5500),
    [anon_sym___inline__] = ACTIONS(5500),
    [anon_sym___forceinline] = ACTIONS(5500),
    [anon_sym_thread_local] = ACTIONS(5500),
    [anon_sym___thread] = ACTIONS(5500),
    [anon_sym_const] = ACTIONS(5500),
    [anon_sym_constexpr] = ACTIONS(5500),
    [anon_sym_volatile] = ACTIONS(5500),
    [anon_sym_restrict] = ACTIONS(5500),
    [anon_sym___restrict__] = ACTIONS(5500),
    [anon_sym__Atomic] = ACTIONS(5500),
    [anon_sym__Noreturn] = ACTIONS(5500),
    [anon_sym_noreturn] = ACTIONS(5500),
    [anon_sym_mutable] = ACTIONS(5500),
    [anon_sym_constinit] = ACTIONS(5500),
    [anon_sym_consteval] = ACTIONS(5500),
    [anon_sym_alignas] = ACTIONS(5500),
    [anon_sym__Alignas] = ACTIONS(5500),
    [sym_primitive_type] = ACTIONS(5500),
    [anon_sym_enum] = ACTIONS(5500),
    [anon_sym_class] = ACTIONS(5500),
    [anon_sym_struct] = ACTIONS(5500),
    [anon_sym_union] = ACTIONS(5500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5500),
    [anon_sym_let] = ACTIONS(5500),
    [anon_sym_This] = ACTIONS(5500),
    [anon_sym_decltype] = ACTIONS(5500),
    [sym_virtual] = ACTIONS(5500),
    [anon_sym_explicit] = ACTIONS(5500),
    [anon_sym_typename] = ACTIONS(5500),
    [anon_sym_template] = ACTIONS(5500),
    [anon_sym_operator] = ACTIONS(5500),
    [anon_sym_friend] = ACTIONS(5500),
    [anon_sym_public] = ACTIONS(5500),
    [anon_sym_private] = ACTIONS(5500),
    [anon_sym_protected] = ACTIONS(5500),
    [anon_sym_using] = ACTIONS(5500),
    [anon_sym_static_assert] = ACTIONS(5500),
    [anon_sym_precise] = ACTIONS(5500),
    [anon_sym_shared] = ACTIONS(5500),
    [anon_sym_groupshared] = ACTIONS(5500),
    [anon_sym_uniform] = ACTIONS(5500),
    [anon_sym_row_major] = ACTIONS(5500),
    [anon_sym_column_major] = ACTIONS(5500),
    [anon_sym_globallycoherent] = ACTIONS(5500),
    [anon_sym_centroid] = ACTIONS(5500),
    [anon_sym_noperspective] = ACTIONS(5500),
    [anon_sym_nointerpolation] = ACTIONS(5500),
    [anon_sym_sample] = ACTIONS(5500),
    [anon_sym_linear] = ACTIONS(5500),
    [anon_sym_snorm] = ACTIONS(5500),
    [anon_sym_unorm] = ACTIONS(5500),
    [anon_sym_point] = ACTIONS(5500),
    [anon_sym_line] = ACTIONS(5500),
    [anon_sym_triangleadj] = ACTIONS(5500),
    [anon_sym_lineadj] = ACTIONS(5500),
    [anon_sym_triangle] = ACTIONS(5500),
    [anon_sym_interface] = ACTIONS(5500),
    [anon_sym_extension] = ACTIONS(5500),
    [anon_sym___init] = ACTIONS(5500),
    [anon_sym___subscript] = ACTIONS(5500),
    [anon_sym_property] = ACTIONS(5500),
    [anon_sym_associatedtype] = ACTIONS(5500),
  },
  [2085] = {
    [sym_identifier] = ACTIONS(3629),
    [aux_sym_preproc_def_token1] = ACTIONS(3629),
    [aux_sym_preproc_if_token1] = ACTIONS(3629),
    [aux_sym_preproc_if_token2] = ACTIONS(3629),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3629),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3629),
    [sym_preproc_directive] = ACTIONS(3629),
    [anon_sym_LPAREN2] = ACTIONS(3631),
    [anon_sym_TILDE] = ACTIONS(3631),
    [anon_sym_STAR] = ACTIONS(3631),
    [anon_sym_AMP_AMP] = ACTIONS(3631),
    [anon_sym_AMP] = ACTIONS(3629),
    [anon_sym___extension__] = ACTIONS(3629),
    [anon_sym_typedef] = ACTIONS(3629),
    [anon_sym_in] = ACTIONS(3629),
    [anon_sym_out] = ACTIONS(3629),
    [anon_sym_inout] = ACTIONS(3629),
    [anon_sym_extern] = ACTIONS(3629),
    [anon_sym___attribute__] = ACTIONS(3629),
    [anon_sym_COLON_COLON] = ACTIONS(3631),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3631),
    [anon_sym___declspec] = ACTIONS(3629),
    [anon_sym___based] = ACTIONS(3629),
    [anon_sym_signed] = ACTIONS(3629),
    [anon_sym_unsigned] = ACTIONS(3629),
    [anon_sym_long] = ACTIONS(3629),
    [anon_sym_short] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3629),
    [anon_sym_static] = ACTIONS(3629),
    [anon_sym_register] = ACTIONS(3629),
    [anon_sym_inline] = ACTIONS(3629),
    [anon_sym___inline] = ACTIONS(3629),
    [anon_sym___inline__] = ACTIONS(3629),
    [anon_sym___forceinline] = ACTIONS(3629),
    [anon_sym_thread_local] = ACTIONS(3629),
    [anon_sym___thread] = ACTIONS(3629),
    [anon_sym_const] = ACTIONS(3629),
    [anon_sym_constexpr] = ACTIONS(3629),
    [anon_sym_volatile] = ACTIONS(3629),
    [anon_sym_restrict] = ACTIONS(3629),
    [anon_sym___restrict__] = ACTIONS(3629),
    [anon_sym__Atomic] = ACTIONS(3629),
    [anon_sym__Noreturn] = ACTIONS(3629),
    [anon_sym_noreturn] = ACTIONS(3629),
    [anon_sym_mutable] = ACTIONS(3629),
    [anon_sym_constinit] = ACTIONS(3629),
    [anon_sym_consteval] = ACTIONS(3629),
    [anon_sym_alignas] = ACTIONS(3629),
    [anon_sym__Alignas] = ACTIONS(3629),
    [sym_primitive_type] = ACTIONS(3629),
    [anon_sym_enum] = ACTIONS(3629),
    [anon_sym_class] = ACTIONS(3629),
    [anon_sym_struct] = ACTIONS(3629),
    [anon_sym_union] = ACTIONS(3629),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3629),
    [anon_sym_let] = ACTIONS(3629),
    [anon_sym_This] = ACTIONS(3629),
    [anon_sym_decltype] = ACTIONS(3629),
    [sym_virtual] = ACTIONS(3629),
    [anon_sym_explicit] = ACTIONS(3629),
    [anon_sym_typename] = ACTIONS(3629),
    [anon_sym_template] = ACTIONS(3629),
    [anon_sym_operator] = ACTIONS(3629),
    [anon_sym_friend] = ACTIONS(3629),
    [anon_sym_public] = ACTIONS(3629),
    [anon_sym_private] = ACTIONS(3629),
    [anon_sym_protected] = ACTIONS(3629),
    [anon_sym_using] = ACTIONS(3629),
    [anon_sym_static_assert] = ACTIONS(3629),
    [anon_sym_precise] = ACTIONS(3629),
    [anon_sym_shared] = ACTIONS(3629),
    [anon_sym_groupshared] = ACTIONS(3629),
    [anon_sym_uniform] = ACTIONS(3629),
    [anon_sym_row_major] = ACTIONS(3629),
    [anon_sym_column_major] = ACTIONS(3629),
    [anon_sym_globallycoherent] = ACTIONS(3629),
    [anon_sym_centroid] = ACTIONS(3629),
    [anon_sym_noperspective] = ACTIONS(3629),
    [anon_sym_nointerpolation] = ACTIONS(3629),
    [anon_sym_sample] = ACTIONS(3629),
    [anon_sym_linear] = ACTIONS(3629),
    [anon_sym_snorm] = ACTIONS(3629),
    [anon_sym_unorm] = ACTIONS(3629),
    [anon_sym_point] = ACTIONS(3629),
    [anon_sym_line] = ACTIONS(3629),
    [anon_sym_triangleadj] = ACTIONS(3629),
    [anon_sym_lineadj] = ACTIONS(3629),
    [anon_sym_triangle] = ACTIONS(3629),
    [anon_sym_interface] = ACTIONS(3629),
    [anon_sym_extension] = ACTIONS(3629),
    [anon_sym___init] = ACTIONS(3629),
    [anon_sym___subscript] = ACTIONS(3629),
    [anon_sym_property] = ACTIONS(3629),
    [anon_sym_associatedtype] = ACTIONS(3629),
  },
  [2086] = {
    [sym_expression] = STATE(4184),
    [sym__string] = STATE(4545),
    [sym_conditional_expression] = STATE(4545),
    [sym_assignment_expression] = STATE(4545),
    [sym_pointer_expression] = STATE(4540),
    [sym_unary_expression] = STATE(4545),
    [sym_binary_expression] = STATE(4545),
    [sym_update_expression] = STATE(4545),
    [sym_cast_expression] = STATE(4545),
    [sym_sizeof_expression] = STATE(4545),
    [sym_alignof_expression] = STATE(4545),
    [sym_offsetof_expression] = STATE(4545),
    [sym_generic_expression] = STATE(4545),
    [sym_subscript_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_gnu_asm_expression] = STATE(4545),
    [sym_field_expression] = STATE(4540),
    [sym_compound_literal_expression] = STATE(4545),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_char_literal] = STATE(4286),
    [sym_concatenated_string] = STATE(4290),
    [sym_string_literal] = STATE(3166),
    [sym_null] = STATE(4545),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9673),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4545),
    [sym_raw_string_literal] = STATE(3169),
    [sym_co_await_expression] = STATE(4545),
    [sym_new_expression] = STATE(4545),
    [sym_delete_expression] = STATE(4545),
    [sym_requires_clause] = STATE(4545),
    [sym_requires_expression] = STATE(4545),
    [sym_lambda_expression] = STATE(4545),
    [sym_lambda_capture_specifier] = STATE(7034),
    [sym_fold_expression] = STATE(4545),
    [sym_parameter_pack_expansion] = STATE(4545),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4540),
    [sym_qualified_type_identifier] = STATE(9673),
    [sym_user_defined_literal] = STATE(4540),
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_LPAREN2] = ACTIONS(5828),
    [anon_sym_BANG] = ACTIONS(4733),
    [anon_sym_TILDE] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4731),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4735),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4739),
    [anon_sym_not] = ACTIONS(4731),
    [anon_sym_compl] = ACTIONS(4731),
    [anon_sym_DASH_DASH] = ACTIONS(5711),
    [anon_sym_PLUS_PLUS] = ACTIONS(5711),
    [anon_sym_sizeof] = ACTIONS(4741),
    [anon_sym___alignof__] = ACTIONS(4743),
    [anon_sym___alignof] = ACTIONS(4743),
    [anon_sym__alignof] = ACTIONS(4743),
    [anon_sym_alignof] = ACTIONS(4743),
    [anon_sym__Alignof] = ACTIONS(4743),
    [anon_sym_offsetof] = ACTIONS(4745),
    [anon_sym__Generic] = ACTIONS(4747),
    [anon_sym_asm] = ACTIONS(4749),
    [anon_sym___asm__] = ACTIONS(4749),
    [sym_number_literal] = ACTIONS(4751),
    [anon_sym_L_SQUOTE] = ACTIONS(4753),
    [anon_sym_u_SQUOTE] = ACTIONS(4753),
    [anon_sym_U_SQUOTE] = ACTIONS(4753),
    [anon_sym_u8_SQUOTE] = ACTIONS(4753),
    [anon_sym_SQUOTE] = ACTIONS(4753),
    [anon_sym_L_DQUOTE] = ACTIONS(4755),
    [anon_sym_u_DQUOTE] = ACTIONS(4755),
    [anon_sym_U_DQUOTE] = ACTIONS(4755),
    [anon_sym_u8_DQUOTE] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [anon_sym_NULL] = ACTIONS(4759),
    [anon_sym_nullptr] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4761),
    [anon_sym_R_DQUOTE] = ACTIONS(4763),
    [anon_sym_LR_DQUOTE] = ACTIONS(4763),
    [anon_sym_uR_DQUOTE] = ACTIONS(4763),
    [anon_sym_UR_DQUOTE] = ACTIONS(4763),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4763),
    [anon_sym_co_await] = ACTIONS(4765),
    [anon_sym_new] = ACTIONS(4767),
    [anon_sym_requires] = ACTIONS(4769),
    [sym_this] = ACTIONS(4757),
  },
  [2087] = {
    [sym_expression] = STATE(4068),
    [sym__string] = STATE(4545),
    [sym_conditional_expression] = STATE(4545),
    [sym_assignment_expression] = STATE(4545),
    [sym_pointer_expression] = STATE(4540),
    [sym_unary_expression] = STATE(4545),
    [sym_binary_expression] = STATE(4545),
    [sym_update_expression] = STATE(4545),
    [sym_cast_expression] = STATE(4545),
    [sym_sizeof_expression] = STATE(4545),
    [sym_alignof_expression] = STATE(4545),
    [sym_offsetof_expression] = STATE(4545),
    [sym_generic_expression] = STATE(4545),
    [sym_subscript_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_gnu_asm_expression] = STATE(4545),
    [sym_field_expression] = STATE(4540),
    [sym_compound_literal_expression] = STATE(4545),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_char_literal] = STATE(4286),
    [sym_concatenated_string] = STATE(4290),
    [sym_string_literal] = STATE(3166),
    [sym_null] = STATE(4545),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9673),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4545),
    [sym_raw_string_literal] = STATE(3169),
    [sym_co_await_expression] = STATE(4545),
    [sym_new_expression] = STATE(4545),
    [sym_delete_expression] = STATE(4545),
    [sym_requires_clause] = STATE(4545),
    [sym_requires_expression] = STATE(4545),
    [sym_lambda_expression] = STATE(4545),
    [sym_lambda_capture_specifier] = STATE(7034),
    [sym_fold_expression] = STATE(4545),
    [sym_parameter_pack_expansion] = STATE(4545),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4540),
    [sym_qualified_type_identifier] = STATE(9673),
    [sym_user_defined_literal] = STATE(4540),
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_LPAREN2] = ACTIONS(5828),
    [anon_sym_BANG] = ACTIONS(4733),
    [anon_sym_TILDE] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4731),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4735),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4739),
    [anon_sym_not] = ACTIONS(4731),
    [anon_sym_compl] = ACTIONS(4731),
    [anon_sym_DASH_DASH] = ACTIONS(5711),
    [anon_sym_PLUS_PLUS] = ACTIONS(5711),
    [anon_sym_sizeof] = ACTIONS(4741),
    [anon_sym___alignof__] = ACTIONS(4743),
    [anon_sym___alignof] = ACTIONS(4743),
    [anon_sym__alignof] = ACTIONS(4743),
    [anon_sym_alignof] = ACTIONS(4743),
    [anon_sym__Alignof] = ACTIONS(4743),
    [anon_sym_offsetof] = ACTIONS(4745),
    [anon_sym__Generic] = ACTIONS(4747),
    [anon_sym_asm] = ACTIONS(4749),
    [anon_sym___asm__] = ACTIONS(4749),
    [sym_number_literal] = ACTIONS(4751),
    [anon_sym_L_SQUOTE] = ACTIONS(4753),
    [anon_sym_u_SQUOTE] = ACTIONS(4753),
    [anon_sym_U_SQUOTE] = ACTIONS(4753),
    [anon_sym_u8_SQUOTE] = ACTIONS(4753),
    [anon_sym_SQUOTE] = ACTIONS(4753),
    [anon_sym_L_DQUOTE] = ACTIONS(4755),
    [anon_sym_u_DQUOTE] = ACTIONS(4755),
    [anon_sym_U_DQUOTE] = ACTIONS(4755),
    [anon_sym_u8_DQUOTE] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [anon_sym_NULL] = ACTIONS(4759),
    [anon_sym_nullptr] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4761),
    [anon_sym_R_DQUOTE] = ACTIONS(4763),
    [anon_sym_LR_DQUOTE] = ACTIONS(4763),
    [anon_sym_uR_DQUOTE] = ACTIONS(4763),
    [anon_sym_UR_DQUOTE] = ACTIONS(4763),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4763),
    [anon_sym_co_await] = ACTIONS(4765),
    [anon_sym_new] = ACTIONS(4767),
    [anon_sym_requires] = ACTIONS(4769),
    [sym_this] = ACTIONS(4757),
  },
  [2088] = {
    [sym_expression] = STATE(4049),
    [sym__string] = STATE(4545),
    [sym_conditional_expression] = STATE(4545),
    [sym_assignment_expression] = STATE(4545),
    [sym_pointer_expression] = STATE(4540),
    [sym_unary_expression] = STATE(4545),
    [sym_binary_expression] = STATE(4545),
    [sym_update_expression] = STATE(4545),
    [sym_cast_expression] = STATE(4545),
    [sym_sizeof_expression] = STATE(4545),
    [sym_alignof_expression] = STATE(4545),
    [sym_offsetof_expression] = STATE(4545),
    [sym_generic_expression] = STATE(4545),
    [sym_subscript_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_gnu_asm_expression] = STATE(4545),
    [sym_field_expression] = STATE(4540),
    [sym_compound_literal_expression] = STATE(4545),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_char_literal] = STATE(4286),
    [sym_concatenated_string] = STATE(4290),
    [sym_string_literal] = STATE(3166),
    [sym_null] = STATE(4545),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9673),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4545),
    [sym_raw_string_literal] = STATE(3169),
    [sym_co_await_expression] = STATE(4545),
    [sym_new_expression] = STATE(4545),
    [sym_delete_expression] = STATE(4545),
    [sym_requires_clause] = STATE(4545),
    [sym_requires_expression] = STATE(4545),
    [sym_lambda_expression] = STATE(4545),
    [sym_lambda_capture_specifier] = STATE(7034),
    [sym_fold_expression] = STATE(4545),
    [sym_parameter_pack_expansion] = STATE(4545),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4540),
    [sym_qualified_type_identifier] = STATE(9673),
    [sym_user_defined_literal] = STATE(4540),
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_LPAREN2] = ACTIONS(5828),
    [anon_sym_BANG] = ACTIONS(4733),
    [anon_sym_TILDE] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4731),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4735),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4739),
    [anon_sym_not] = ACTIONS(4731),
    [anon_sym_compl] = ACTIONS(4731),
    [anon_sym_DASH_DASH] = ACTIONS(5711),
    [anon_sym_PLUS_PLUS] = ACTIONS(5711),
    [anon_sym_sizeof] = ACTIONS(4741),
    [anon_sym___alignof__] = ACTIONS(4743),
    [anon_sym___alignof] = ACTIONS(4743),
    [anon_sym__alignof] = ACTIONS(4743),
    [anon_sym_alignof] = ACTIONS(4743),
    [anon_sym__Alignof] = ACTIONS(4743),
    [anon_sym_offsetof] = ACTIONS(4745),
    [anon_sym__Generic] = ACTIONS(4747),
    [anon_sym_asm] = ACTIONS(4749),
    [anon_sym___asm__] = ACTIONS(4749),
    [sym_number_literal] = ACTIONS(4751),
    [anon_sym_L_SQUOTE] = ACTIONS(4753),
    [anon_sym_u_SQUOTE] = ACTIONS(4753),
    [anon_sym_U_SQUOTE] = ACTIONS(4753),
    [anon_sym_u8_SQUOTE] = ACTIONS(4753),
    [anon_sym_SQUOTE] = ACTIONS(4753),
    [anon_sym_L_DQUOTE] = ACTIONS(4755),
    [anon_sym_u_DQUOTE] = ACTIONS(4755),
    [anon_sym_U_DQUOTE] = ACTIONS(4755),
    [anon_sym_u8_DQUOTE] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [anon_sym_NULL] = ACTIONS(4759),
    [anon_sym_nullptr] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4761),
    [anon_sym_R_DQUOTE] = ACTIONS(4763),
    [anon_sym_LR_DQUOTE] = ACTIONS(4763),
    [anon_sym_uR_DQUOTE] = ACTIONS(4763),
    [anon_sym_UR_DQUOTE] = ACTIONS(4763),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4763),
    [anon_sym_co_await] = ACTIONS(4765),
    [anon_sym_new] = ACTIONS(4767),
    [anon_sym_requires] = ACTIONS(4769),
    [sym_this] = ACTIONS(4757),
  },
  [2089] = {
    [sym_expression] = STATE(3854),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5781),
    [anon_sym_BANG] = ACTIONS(4611),
    [anon_sym_TILDE] = ACTIONS(4611),
    [anon_sym_DASH] = ACTIONS(4609),
    [anon_sym_PLUS] = ACTIONS(4609),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4613),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4609),
    [anon_sym_compl] = ACTIONS(4609),
    [anon_sym_DASH_DASH] = ACTIONS(5713),
    [anon_sym_PLUS_PLUS] = ACTIONS(5713),
    [anon_sym_sizeof] = ACTIONS(4615),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4617),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4619),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2090] = {
    [sym_expression] = STATE(3877),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5781),
    [anon_sym_BANG] = ACTIONS(4611),
    [anon_sym_TILDE] = ACTIONS(4611),
    [anon_sym_DASH] = ACTIONS(4609),
    [anon_sym_PLUS] = ACTIONS(4609),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4613),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4609),
    [anon_sym_compl] = ACTIONS(4609),
    [anon_sym_DASH_DASH] = ACTIONS(5713),
    [anon_sym_PLUS_PLUS] = ACTIONS(5713),
    [anon_sym_sizeof] = ACTIONS(4615),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4617),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4619),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2091] = {
    [sym_expression] = STATE(3447),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3481),
    [sym_concatenated_string] = STATE(3486),
    [sym_string_literal] = STATE(2963),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2960),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5795),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4412),
    [anon_sym_PLUS] = ACTIONS(4412),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4416),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4412),
    [anon_sym_compl] = ACTIONS(4412),
    [anon_sym_DASH_DASH] = ACTIONS(5756),
    [anon_sym_PLUS_PLUS] = ACTIONS(5756),
    [anon_sym_sizeof] = ACTIONS(4422),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4432),
    [anon_sym_L_SQUOTE] = ACTIONS(4434),
    [anon_sym_u_SQUOTE] = ACTIONS(4434),
    [anon_sym_U_SQUOTE] = ACTIONS(4434),
    [anon_sym_u8_SQUOTE] = ACTIONS(4434),
    [anon_sym_SQUOTE] = ACTIONS(4434),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4442),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [anon_sym_co_await] = ACTIONS(4446),
    [anon_sym_new] = ACTIONS(4448),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2092] = {
    [sym_expression] = STATE(3419),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3481),
    [sym_concatenated_string] = STATE(3486),
    [sym_string_literal] = STATE(2963),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2960),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5795),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4412),
    [anon_sym_PLUS] = ACTIONS(4412),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4416),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4412),
    [anon_sym_compl] = ACTIONS(4412),
    [anon_sym_DASH_DASH] = ACTIONS(5756),
    [anon_sym_PLUS_PLUS] = ACTIONS(5756),
    [anon_sym_sizeof] = ACTIONS(4422),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4432),
    [anon_sym_L_SQUOTE] = ACTIONS(4434),
    [anon_sym_u_SQUOTE] = ACTIONS(4434),
    [anon_sym_U_SQUOTE] = ACTIONS(4434),
    [anon_sym_u8_SQUOTE] = ACTIONS(4434),
    [anon_sym_SQUOTE] = ACTIONS(4434),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4442),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [anon_sym_co_await] = ACTIONS(4446),
    [anon_sym_new] = ACTIONS(4448),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2093] = {
    [sym_expression] = STATE(5346),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2094] = {
    [sym_expression] = STATE(3420),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3481),
    [sym_concatenated_string] = STATE(3486),
    [sym_string_literal] = STATE(2963),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2960),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5795),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4412),
    [anon_sym_PLUS] = ACTIONS(4412),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4416),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4412),
    [anon_sym_compl] = ACTIONS(4412),
    [anon_sym_DASH_DASH] = ACTIONS(5756),
    [anon_sym_PLUS_PLUS] = ACTIONS(5756),
    [anon_sym_sizeof] = ACTIONS(4422),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4432),
    [anon_sym_L_SQUOTE] = ACTIONS(4434),
    [anon_sym_u_SQUOTE] = ACTIONS(4434),
    [anon_sym_U_SQUOTE] = ACTIONS(4434),
    [anon_sym_u8_SQUOTE] = ACTIONS(4434),
    [anon_sym_SQUOTE] = ACTIONS(4434),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4442),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [anon_sym_co_await] = ACTIONS(4446),
    [anon_sym_new] = ACTIONS(4448),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2095] = {
    [sym_expression] = STATE(3464),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3481),
    [sym_concatenated_string] = STATE(3486),
    [sym_string_literal] = STATE(2963),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2960),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5795),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4412),
    [anon_sym_PLUS] = ACTIONS(4412),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4416),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4412),
    [anon_sym_compl] = ACTIONS(4412),
    [anon_sym_DASH_DASH] = ACTIONS(5756),
    [anon_sym_PLUS_PLUS] = ACTIONS(5756),
    [anon_sym_sizeof] = ACTIONS(4422),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4432),
    [anon_sym_L_SQUOTE] = ACTIONS(4434),
    [anon_sym_u_SQUOTE] = ACTIONS(4434),
    [anon_sym_U_SQUOTE] = ACTIONS(4434),
    [anon_sym_u8_SQUOTE] = ACTIONS(4434),
    [anon_sym_SQUOTE] = ACTIONS(4434),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4442),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [anon_sym_co_await] = ACTIONS(4446),
    [anon_sym_new] = ACTIONS(4448),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2096] = {
    [sym_expression] = STATE(5360),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(6090),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2097] = {
    [sym_identifier] = ACTIONS(3445),
    [aux_sym_preproc_def_token1] = ACTIONS(3445),
    [aux_sym_preproc_if_token1] = ACTIONS(3445),
    [aux_sym_preproc_if_token2] = ACTIONS(3445),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3445),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3445),
    [sym_preproc_directive] = ACTIONS(3445),
    [anon_sym_LPAREN2] = ACTIONS(3447),
    [anon_sym_TILDE] = ACTIONS(3447),
    [anon_sym_STAR] = ACTIONS(3447),
    [anon_sym_AMP_AMP] = ACTIONS(3447),
    [anon_sym_AMP] = ACTIONS(3445),
    [anon_sym___extension__] = ACTIONS(3445),
    [anon_sym_typedef] = ACTIONS(3445),
    [anon_sym_in] = ACTIONS(3445),
    [anon_sym_out] = ACTIONS(3445),
    [anon_sym_inout] = ACTIONS(3445),
    [anon_sym_extern] = ACTIONS(3445),
    [anon_sym___attribute__] = ACTIONS(3445),
    [anon_sym_COLON_COLON] = ACTIONS(3447),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3447),
    [anon_sym___declspec] = ACTIONS(3445),
    [anon_sym___based] = ACTIONS(3445),
    [anon_sym_signed] = ACTIONS(3445),
    [anon_sym_unsigned] = ACTIONS(3445),
    [anon_sym_long] = ACTIONS(3445),
    [anon_sym_short] = ACTIONS(3445),
    [anon_sym_LBRACK] = ACTIONS(3445),
    [anon_sym_static] = ACTIONS(3445),
    [anon_sym_register] = ACTIONS(3445),
    [anon_sym_inline] = ACTIONS(3445),
    [anon_sym___inline] = ACTIONS(3445),
    [anon_sym___inline__] = ACTIONS(3445),
    [anon_sym___forceinline] = ACTIONS(3445),
    [anon_sym_thread_local] = ACTIONS(3445),
    [anon_sym___thread] = ACTIONS(3445),
    [anon_sym_const] = ACTIONS(3445),
    [anon_sym_constexpr] = ACTIONS(3445),
    [anon_sym_volatile] = ACTIONS(3445),
    [anon_sym_restrict] = ACTIONS(3445),
    [anon_sym___restrict__] = ACTIONS(3445),
    [anon_sym__Atomic] = ACTIONS(3445),
    [anon_sym__Noreturn] = ACTIONS(3445),
    [anon_sym_noreturn] = ACTIONS(3445),
    [anon_sym_mutable] = ACTIONS(3445),
    [anon_sym_constinit] = ACTIONS(3445),
    [anon_sym_consteval] = ACTIONS(3445),
    [anon_sym_alignas] = ACTIONS(3445),
    [anon_sym__Alignas] = ACTIONS(3445),
    [sym_primitive_type] = ACTIONS(3445),
    [anon_sym_enum] = ACTIONS(3445),
    [anon_sym_class] = ACTIONS(3445),
    [anon_sym_struct] = ACTIONS(3445),
    [anon_sym_union] = ACTIONS(3445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3445),
    [anon_sym_let] = ACTIONS(3445),
    [anon_sym_This] = ACTIONS(3445),
    [anon_sym_decltype] = ACTIONS(3445),
    [sym_virtual] = ACTIONS(3445),
    [anon_sym_explicit] = ACTIONS(3445),
    [anon_sym_typename] = ACTIONS(3445),
    [anon_sym_template] = ACTIONS(3445),
    [anon_sym_operator] = ACTIONS(3445),
    [anon_sym_friend] = ACTIONS(3445),
    [anon_sym_public] = ACTIONS(3445),
    [anon_sym_private] = ACTIONS(3445),
    [anon_sym_protected] = ACTIONS(3445),
    [anon_sym_using] = ACTIONS(3445),
    [anon_sym_static_assert] = ACTIONS(3445),
    [anon_sym_precise] = ACTIONS(3445),
    [anon_sym_shared] = ACTIONS(3445),
    [anon_sym_groupshared] = ACTIONS(3445),
    [anon_sym_uniform] = ACTIONS(3445),
    [anon_sym_row_major] = ACTIONS(3445),
    [anon_sym_column_major] = ACTIONS(3445),
    [anon_sym_globallycoherent] = ACTIONS(3445),
    [anon_sym_centroid] = ACTIONS(3445),
    [anon_sym_noperspective] = ACTIONS(3445),
    [anon_sym_nointerpolation] = ACTIONS(3445),
    [anon_sym_sample] = ACTIONS(3445),
    [anon_sym_linear] = ACTIONS(3445),
    [anon_sym_snorm] = ACTIONS(3445),
    [anon_sym_unorm] = ACTIONS(3445),
    [anon_sym_point] = ACTIONS(3445),
    [anon_sym_line] = ACTIONS(3445),
    [anon_sym_triangleadj] = ACTIONS(3445),
    [anon_sym_lineadj] = ACTIONS(3445),
    [anon_sym_triangle] = ACTIONS(3445),
    [anon_sym_interface] = ACTIONS(3445),
    [anon_sym_extension] = ACTIONS(3445),
    [anon_sym___init] = ACTIONS(3445),
    [anon_sym___subscript] = ACTIONS(3445),
    [anon_sym_property] = ACTIONS(3445),
    [anon_sym_associatedtype] = ACTIONS(3445),
  },
  [2098] = {
    [sym_expression] = STATE(3426),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3481),
    [sym_concatenated_string] = STATE(3486),
    [sym_string_literal] = STATE(2963),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2960),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5795),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4412),
    [anon_sym_PLUS] = ACTIONS(4412),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4416),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4412),
    [anon_sym_compl] = ACTIONS(4412),
    [anon_sym_DASH_DASH] = ACTIONS(5756),
    [anon_sym_PLUS_PLUS] = ACTIONS(5756),
    [anon_sym_sizeof] = ACTIONS(4422),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4432),
    [anon_sym_L_SQUOTE] = ACTIONS(4434),
    [anon_sym_u_SQUOTE] = ACTIONS(4434),
    [anon_sym_U_SQUOTE] = ACTIONS(4434),
    [anon_sym_u8_SQUOTE] = ACTIONS(4434),
    [anon_sym_SQUOTE] = ACTIONS(4434),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4442),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [anon_sym_co_await] = ACTIONS(4446),
    [anon_sym_new] = ACTIONS(4448),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2099] = {
    [sym_expression] = STATE(5565),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(5106),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2100] = {
    [sym_expression] = STATE(5396),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(6092),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2101] = {
    [sym_expression] = STATE(3427),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3481),
    [sym_concatenated_string] = STATE(3486),
    [sym_string_literal] = STATE(2963),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2960),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5795),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4412),
    [anon_sym_PLUS] = ACTIONS(4412),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4416),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4412),
    [anon_sym_compl] = ACTIONS(4412),
    [anon_sym_DASH_DASH] = ACTIONS(5756),
    [anon_sym_PLUS_PLUS] = ACTIONS(5756),
    [anon_sym_sizeof] = ACTIONS(4422),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4432),
    [anon_sym_L_SQUOTE] = ACTIONS(4434),
    [anon_sym_u_SQUOTE] = ACTIONS(4434),
    [anon_sym_U_SQUOTE] = ACTIONS(4434),
    [anon_sym_u8_SQUOTE] = ACTIONS(4434),
    [anon_sym_SQUOTE] = ACTIONS(4434),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4442),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [anon_sym_co_await] = ACTIONS(4446),
    [anon_sym_new] = ACTIONS(4448),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2102] = {
    [sym_expression] = STATE(3428),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3481),
    [sym_concatenated_string] = STATE(3486),
    [sym_string_literal] = STATE(2963),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2960),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5795),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4412),
    [anon_sym_PLUS] = ACTIONS(4412),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4416),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4412),
    [anon_sym_compl] = ACTIONS(4412),
    [anon_sym_DASH_DASH] = ACTIONS(5756),
    [anon_sym_PLUS_PLUS] = ACTIONS(5756),
    [anon_sym_sizeof] = ACTIONS(4422),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4432),
    [anon_sym_L_SQUOTE] = ACTIONS(4434),
    [anon_sym_u_SQUOTE] = ACTIONS(4434),
    [anon_sym_U_SQUOTE] = ACTIONS(4434),
    [anon_sym_u8_SQUOTE] = ACTIONS(4434),
    [anon_sym_SQUOTE] = ACTIONS(4434),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4442),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [anon_sym_co_await] = ACTIONS(4446),
    [anon_sym_new] = ACTIONS(4448),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2103] = {
    [sym_expression] = STATE(5057),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2104] = {
    [sym_expression] = STATE(3430),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3481),
    [sym_concatenated_string] = STATE(3486),
    [sym_string_literal] = STATE(2963),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2960),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5795),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4412),
    [anon_sym_PLUS] = ACTIONS(4412),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4416),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4412),
    [anon_sym_compl] = ACTIONS(4412),
    [anon_sym_DASH_DASH] = ACTIONS(5756),
    [anon_sym_PLUS_PLUS] = ACTIONS(5756),
    [anon_sym_sizeof] = ACTIONS(4422),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4432),
    [anon_sym_L_SQUOTE] = ACTIONS(4434),
    [anon_sym_u_SQUOTE] = ACTIONS(4434),
    [anon_sym_U_SQUOTE] = ACTIONS(4434),
    [anon_sym_u8_SQUOTE] = ACTIONS(4434),
    [anon_sym_SQUOTE] = ACTIONS(4434),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4442),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [anon_sym_co_await] = ACTIONS(4446),
    [anon_sym_new] = ACTIONS(4448),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2105] = {
    [sym_expression] = STATE(3212),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3481),
    [sym_concatenated_string] = STATE(3486),
    [sym_string_literal] = STATE(2963),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2960),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5795),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4412),
    [anon_sym_PLUS] = ACTIONS(4412),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4416),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4412),
    [anon_sym_compl] = ACTIONS(4412),
    [anon_sym_DASH_DASH] = ACTIONS(5756),
    [anon_sym_PLUS_PLUS] = ACTIONS(5756),
    [anon_sym_sizeof] = ACTIONS(4422),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4432),
    [anon_sym_L_SQUOTE] = ACTIONS(4434),
    [anon_sym_u_SQUOTE] = ACTIONS(4434),
    [anon_sym_U_SQUOTE] = ACTIONS(4434),
    [anon_sym_u8_SQUOTE] = ACTIONS(4434),
    [anon_sym_SQUOTE] = ACTIONS(4434),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4442),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [anon_sym_co_await] = ACTIONS(4446),
    [anon_sym_new] = ACTIONS(4448),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2106] = {
    [sym_expression] = STATE(3445),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3481),
    [sym_concatenated_string] = STATE(3486),
    [sym_string_literal] = STATE(2963),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2960),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5795),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4412),
    [anon_sym_PLUS] = ACTIONS(4412),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4416),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4412),
    [anon_sym_compl] = ACTIONS(4412),
    [anon_sym_DASH_DASH] = ACTIONS(5756),
    [anon_sym_PLUS_PLUS] = ACTIONS(5756),
    [anon_sym_sizeof] = ACTIONS(4422),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4432),
    [anon_sym_L_SQUOTE] = ACTIONS(4434),
    [anon_sym_u_SQUOTE] = ACTIONS(4434),
    [anon_sym_U_SQUOTE] = ACTIONS(4434),
    [anon_sym_u8_SQUOTE] = ACTIONS(4434),
    [anon_sym_SQUOTE] = ACTIONS(4434),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4442),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [anon_sym_co_await] = ACTIONS(4446),
    [anon_sym_new] = ACTIONS(4448),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2107] = {
    [sym_identifier] = ACTIONS(3414),
    [aux_sym_preproc_def_token1] = ACTIONS(3414),
    [aux_sym_preproc_if_token1] = ACTIONS(3414),
    [aux_sym_preproc_if_token2] = ACTIONS(3414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3414),
    [sym_preproc_directive] = ACTIONS(3414),
    [anon_sym_LPAREN2] = ACTIONS(3416),
    [anon_sym_TILDE] = ACTIONS(3416),
    [anon_sym_STAR] = ACTIONS(3416),
    [anon_sym_AMP_AMP] = ACTIONS(3416),
    [anon_sym_AMP] = ACTIONS(3414),
    [anon_sym___extension__] = ACTIONS(3414),
    [anon_sym_typedef] = ACTIONS(3414),
    [anon_sym_in] = ACTIONS(3414),
    [anon_sym_out] = ACTIONS(3414),
    [anon_sym_inout] = ACTIONS(3414),
    [anon_sym_extern] = ACTIONS(3414),
    [anon_sym___attribute__] = ACTIONS(3414),
    [anon_sym_COLON_COLON] = ACTIONS(3416),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3416),
    [anon_sym___declspec] = ACTIONS(3414),
    [anon_sym___based] = ACTIONS(3414),
    [anon_sym_signed] = ACTIONS(3414),
    [anon_sym_unsigned] = ACTIONS(3414),
    [anon_sym_long] = ACTIONS(3414),
    [anon_sym_short] = ACTIONS(3414),
    [anon_sym_LBRACK] = ACTIONS(3414),
    [anon_sym_static] = ACTIONS(3414),
    [anon_sym_register] = ACTIONS(3414),
    [anon_sym_inline] = ACTIONS(3414),
    [anon_sym___inline] = ACTIONS(3414),
    [anon_sym___inline__] = ACTIONS(3414),
    [anon_sym___forceinline] = ACTIONS(3414),
    [anon_sym_thread_local] = ACTIONS(3414),
    [anon_sym___thread] = ACTIONS(3414),
    [anon_sym_const] = ACTIONS(3414),
    [anon_sym_constexpr] = ACTIONS(3414),
    [anon_sym_volatile] = ACTIONS(3414),
    [anon_sym_restrict] = ACTIONS(3414),
    [anon_sym___restrict__] = ACTIONS(3414),
    [anon_sym__Atomic] = ACTIONS(3414),
    [anon_sym__Noreturn] = ACTIONS(3414),
    [anon_sym_noreturn] = ACTIONS(3414),
    [anon_sym_mutable] = ACTIONS(3414),
    [anon_sym_constinit] = ACTIONS(3414),
    [anon_sym_consteval] = ACTIONS(3414),
    [anon_sym_alignas] = ACTIONS(3414),
    [anon_sym__Alignas] = ACTIONS(3414),
    [sym_primitive_type] = ACTIONS(3414),
    [anon_sym_enum] = ACTIONS(3414),
    [anon_sym_class] = ACTIONS(3414),
    [anon_sym_struct] = ACTIONS(3414),
    [anon_sym_union] = ACTIONS(3414),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3414),
    [anon_sym_let] = ACTIONS(3414),
    [anon_sym_This] = ACTIONS(3414),
    [anon_sym_decltype] = ACTIONS(3414),
    [sym_virtual] = ACTIONS(3414),
    [anon_sym_explicit] = ACTIONS(3414),
    [anon_sym_typename] = ACTIONS(3414),
    [anon_sym_template] = ACTIONS(3414),
    [anon_sym_operator] = ACTIONS(3414),
    [anon_sym_friend] = ACTIONS(3414),
    [anon_sym_public] = ACTIONS(3414),
    [anon_sym_private] = ACTIONS(3414),
    [anon_sym_protected] = ACTIONS(3414),
    [anon_sym_using] = ACTIONS(3414),
    [anon_sym_static_assert] = ACTIONS(3414),
    [anon_sym_precise] = ACTIONS(3414),
    [anon_sym_shared] = ACTIONS(3414),
    [anon_sym_groupshared] = ACTIONS(3414),
    [anon_sym_uniform] = ACTIONS(3414),
    [anon_sym_row_major] = ACTIONS(3414),
    [anon_sym_column_major] = ACTIONS(3414),
    [anon_sym_globallycoherent] = ACTIONS(3414),
    [anon_sym_centroid] = ACTIONS(3414),
    [anon_sym_noperspective] = ACTIONS(3414),
    [anon_sym_nointerpolation] = ACTIONS(3414),
    [anon_sym_sample] = ACTIONS(3414),
    [anon_sym_linear] = ACTIONS(3414),
    [anon_sym_snorm] = ACTIONS(3414),
    [anon_sym_unorm] = ACTIONS(3414),
    [anon_sym_point] = ACTIONS(3414),
    [anon_sym_line] = ACTIONS(3414),
    [anon_sym_triangleadj] = ACTIONS(3414),
    [anon_sym_lineadj] = ACTIONS(3414),
    [anon_sym_triangle] = ACTIONS(3414),
    [anon_sym_interface] = ACTIONS(3414),
    [anon_sym_extension] = ACTIONS(3414),
    [anon_sym___init] = ACTIONS(3414),
    [anon_sym___subscript] = ACTIONS(3414),
    [anon_sym_property] = ACTIONS(3414),
    [anon_sym_associatedtype] = ACTIONS(3414),
  },
  [2108] = {
    [sym_expression] = STATE(5449),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2109] = {
    [sym_identifier] = ACTIONS(3601),
    [aux_sym_preproc_def_token1] = ACTIONS(3601),
    [aux_sym_preproc_if_token1] = ACTIONS(3601),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3601),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3601),
    [sym_preproc_directive] = ACTIONS(3601),
    [anon_sym_LPAREN2] = ACTIONS(3603),
    [anon_sym_TILDE] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(3603),
    [anon_sym_AMP_AMP] = ACTIONS(3603),
    [anon_sym_AMP] = ACTIONS(3601),
    [anon_sym___extension__] = ACTIONS(3601),
    [anon_sym_typedef] = ACTIONS(3601),
    [anon_sym_in] = ACTIONS(3601),
    [anon_sym_out] = ACTIONS(3601),
    [anon_sym_inout] = ACTIONS(3601),
    [anon_sym_extern] = ACTIONS(3601),
    [anon_sym___attribute__] = ACTIONS(3601),
    [anon_sym_COLON_COLON] = ACTIONS(3603),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3603),
    [anon_sym___declspec] = ACTIONS(3601),
    [anon_sym___based] = ACTIONS(3601),
    [anon_sym_RBRACE] = ACTIONS(3603),
    [anon_sym_signed] = ACTIONS(3601),
    [anon_sym_unsigned] = ACTIONS(3601),
    [anon_sym_long] = ACTIONS(3601),
    [anon_sym_short] = ACTIONS(3601),
    [anon_sym_LBRACK] = ACTIONS(3601),
    [anon_sym_static] = ACTIONS(3601),
    [anon_sym_register] = ACTIONS(3601),
    [anon_sym_inline] = ACTIONS(3601),
    [anon_sym___inline] = ACTIONS(3601),
    [anon_sym___inline__] = ACTIONS(3601),
    [anon_sym___forceinline] = ACTIONS(3601),
    [anon_sym_thread_local] = ACTIONS(3601),
    [anon_sym___thread] = ACTIONS(3601),
    [anon_sym_const] = ACTIONS(3601),
    [anon_sym_constexpr] = ACTIONS(3601),
    [anon_sym_volatile] = ACTIONS(3601),
    [anon_sym_restrict] = ACTIONS(3601),
    [anon_sym___restrict__] = ACTIONS(3601),
    [anon_sym__Atomic] = ACTIONS(3601),
    [anon_sym__Noreturn] = ACTIONS(3601),
    [anon_sym_noreturn] = ACTIONS(3601),
    [anon_sym_mutable] = ACTIONS(3601),
    [anon_sym_constinit] = ACTIONS(3601),
    [anon_sym_consteval] = ACTIONS(3601),
    [anon_sym_alignas] = ACTIONS(3601),
    [anon_sym__Alignas] = ACTIONS(3601),
    [sym_primitive_type] = ACTIONS(3601),
    [anon_sym_enum] = ACTIONS(3601),
    [anon_sym_class] = ACTIONS(3601),
    [anon_sym_struct] = ACTIONS(3601),
    [anon_sym_union] = ACTIONS(3601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3601),
    [anon_sym_let] = ACTIONS(3601),
    [anon_sym_This] = ACTIONS(3601),
    [anon_sym_decltype] = ACTIONS(3601),
    [sym_virtual] = ACTIONS(3601),
    [anon_sym_explicit] = ACTIONS(3601),
    [anon_sym_typename] = ACTIONS(3601),
    [anon_sym_template] = ACTIONS(3601),
    [anon_sym_operator] = ACTIONS(3601),
    [anon_sym_friend] = ACTIONS(3601),
    [anon_sym_public] = ACTIONS(3601),
    [anon_sym_private] = ACTIONS(3601),
    [anon_sym_protected] = ACTIONS(3601),
    [anon_sym_using] = ACTIONS(3601),
    [anon_sym_static_assert] = ACTIONS(3601),
    [anon_sym_precise] = ACTIONS(3601),
    [anon_sym_shared] = ACTIONS(3601),
    [anon_sym_groupshared] = ACTIONS(3601),
    [anon_sym_uniform] = ACTIONS(3601),
    [anon_sym_row_major] = ACTIONS(3601),
    [anon_sym_column_major] = ACTIONS(3601),
    [anon_sym_globallycoherent] = ACTIONS(3601),
    [anon_sym_centroid] = ACTIONS(3601),
    [anon_sym_noperspective] = ACTIONS(3601),
    [anon_sym_nointerpolation] = ACTIONS(3601),
    [anon_sym_sample] = ACTIONS(3601),
    [anon_sym_linear] = ACTIONS(3601),
    [anon_sym_snorm] = ACTIONS(3601),
    [anon_sym_unorm] = ACTIONS(3601),
    [anon_sym_point] = ACTIONS(3601),
    [anon_sym_line] = ACTIONS(3601),
    [anon_sym_triangleadj] = ACTIONS(3601),
    [anon_sym_lineadj] = ACTIONS(3601),
    [anon_sym_triangle] = ACTIONS(3601),
    [anon_sym_interface] = ACTIONS(3601),
    [anon_sym_extension] = ACTIONS(3601),
    [anon_sym___init] = ACTIONS(3601),
    [anon_sym___subscript] = ACTIONS(3601),
    [anon_sym_property] = ACTIONS(3601),
    [anon_sym_associatedtype] = ACTIONS(3601),
  },
  [2110] = {
    [sym_identifier] = ACTIONS(5510),
    [aux_sym_preproc_def_token1] = ACTIONS(5510),
    [aux_sym_preproc_if_token1] = ACTIONS(5510),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5510),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5510),
    [sym_preproc_directive] = ACTIONS(5510),
    [anon_sym_LPAREN2] = ACTIONS(5512),
    [anon_sym_TILDE] = ACTIONS(5512),
    [anon_sym_STAR] = ACTIONS(5512),
    [anon_sym_AMP_AMP] = ACTIONS(5512),
    [anon_sym_AMP] = ACTIONS(5510),
    [anon_sym___extension__] = ACTIONS(5510),
    [anon_sym_typedef] = ACTIONS(5510),
    [anon_sym_in] = ACTIONS(5510),
    [anon_sym_out] = ACTIONS(5510),
    [anon_sym_inout] = ACTIONS(5510),
    [anon_sym_extern] = ACTIONS(5510),
    [anon_sym___attribute__] = ACTIONS(5510),
    [anon_sym_COLON_COLON] = ACTIONS(5512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5512),
    [anon_sym___declspec] = ACTIONS(5510),
    [anon_sym___based] = ACTIONS(5510),
    [anon_sym_RBRACE] = ACTIONS(5512),
    [anon_sym_signed] = ACTIONS(5510),
    [anon_sym_unsigned] = ACTIONS(5510),
    [anon_sym_long] = ACTIONS(5510),
    [anon_sym_short] = ACTIONS(5510),
    [anon_sym_LBRACK] = ACTIONS(5510),
    [anon_sym_static] = ACTIONS(5510),
    [anon_sym_register] = ACTIONS(5510),
    [anon_sym_inline] = ACTIONS(5510),
    [anon_sym___inline] = ACTIONS(5510),
    [anon_sym___inline__] = ACTIONS(5510),
    [anon_sym___forceinline] = ACTIONS(5510),
    [anon_sym_thread_local] = ACTIONS(5510),
    [anon_sym___thread] = ACTIONS(5510),
    [anon_sym_const] = ACTIONS(5510),
    [anon_sym_constexpr] = ACTIONS(5510),
    [anon_sym_volatile] = ACTIONS(5510),
    [anon_sym_restrict] = ACTIONS(5510),
    [anon_sym___restrict__] = ACTIONS(5510),
    [anon_sym__Atomic] = ACTIONS(5510),
    [anon_sym__Noreturn] = ACTIONS(5510),
    [anon_sym_noreturn] = ACTIONS(5510),
    [anon_sym_mutable] = ACTIONS(5510),
    [anon_sym_constinit] = ACTIONS(5510),
    [anon_sym_consteval] = ACTIONS(5510),
    [anon_sym_alignas] = ACTIONS(5510),
    [anon_sym__Alignas] = ACTIONS(5510),
    [sym_primitive_type] = ACTIONS(5510),
    [anon_sym_enum] = ACTIONS(5510),
    [anon_sym_class] = ACTIONS(5510),
    [anon_sym_struct] = ACTIONS(5510),
    [anon_sym_union] = ACTIONS(5510),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5510),
    [anon_sym_let] = ACTIONS(5510),
    [anon_sym_This] = ACTIONS(5510),
    [anon_sym_decltype] = ACTIONS(5510),
    [sym_virtual] = ACTIONS(5510),
    [anon_sym_explicit] = ACTIONS(5510),
    [anon_sym_typename] = ACTIONS(5510),
    [anon_sym_template] = ACTIONS(5510),
    [anon_sym_operator] = ACTIONS(5510),
    [anon_sym_friend] = ACTIONS(5510),
    [anon_sym_public] = ACTIONS(5510),
    [anon_sym_private] = ACTIONS(5510),
    [anon_sym_protected] = ACTIONS(5510),
    [anon_sym_using] = ACTIONS(5510),
    [anon_sym_static_assert] = ACTIONS(5510),
    [anon_sym_precise] = ACTIONS(5510),
    [anon_sym_shared] = ACTIONS(5510),
    [anon_sym_groupshared] = ACTIONS(5510),
    [anon_sym_uniform] = ACTIONS(5510),
    [anon_sym_row_major] = ACTIONS(5510),
    [anon_sym_column_major] = ACTIONS(5510),
    [anon_sym_globallycoherent] = ACTIONS(5510),
    [anon_sym_centroid] = ACTIONS(5510),
    [anon_sym_noperspective] = ACTIONS(5510),
    [anon_sym_nointerpolation] = ACTIONS(5510),
    [anon_sym_sample] = ACTIONS(5510),
    [anon_sym_linear] = ACTIONS(5510),
    [anon_sym_snorm] = ACTIONS(5510),
    [anon_sym_unorm] = ACTIONS(5510),
    [anon_sym_point] = ACTIONS(5510),
    [anon_sym_line] = ACTIONS(5510),
    [anon_sym_triangleadj] = ACTIONS(5510),
    [anon_sym_lineadj] = ACTIONS(5510),
    [anon_sym_triangle] = ACTIONS(5510),
    [anon_sym_interface] = ACTIONS(5510),
    [anon_sym_extension] = ACTIONS(5510),
    [anon_sym___init] = ACTIONS(5510),
    [anon_sym___subscript] = ACTIONS(5510),
    [anon_sym_property] = ACTIONS(5510),
    [anon_sym_associatedtype] = ACTIONS(5510),
  },
  [2111] = {
    [sym_expression] = STATE(5484),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2112] = {
    [sym_expression] = STATE(5260),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2113] = {
    [sym_expression] = STATE(5606),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2114] = {
    [sym_identifier] = ACTIONS(3441),
    [aux_sym_preproc_def_token1] = ACTIONS(3441),
    [aux_sym_preproc_if_token1] = ACTIONS(3441),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3441),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3441),
    [sym_preproc_directive] = ACTIONS(3441),
    [anon_sym_LPAREN2] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(3443),
    [anon_sym_AMP_AMP] = ACTIONS(3443),
    [anon_sym_AMP] = ACTIONS(3441),
    [anon_sym___extension__] = ACTIONS(3441),
    [anon_sym_typedef] = ACTIONS(3441),
    [anon_sym_in] = ACTIONS(3441),
    [anon_sym_out] = ACTIONS(3441),
    [anon_sym_inout] = ACTIONS(3441),
    [anon_sym_extern] = ACTIONS(3441),
    [anon_sym___attribute__] = ACTIONS(3441),
    [anon_sym_COLON_COLON] = ACTIONS(3443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3443),
    [anon_sym___declspec] = ACTIONS(3441),
    [anon_sym___based] = ACTIONS(3441),
    [anon_sym_RBRACE] = ACTIONS(3443),
    [anon_sym_signed] = ACTIONS(3441),
    [anon_sym_unsigned] = ACTIONS(3441),
    [anon_sym_long] = ACTIONS(3441),
    [anon_sym_short] = ACTIONS(3441),
    [anon_sym_LBRACK] = ACTIONS(3441),
    [anon_sym_static] = ACTIONS(3441),
    [anon_sym_register] = ACTIONS(3441),
    [anon_sym_inline] = ACTIONS(3441),
    [anon_sym___inline] = ACTIONS(3441),
    [anon_sym___inline__] = ACTIONS(3441),
    [anon_sym___forceinline] = ACTIONS(3441),
    [anon_sym_thread_local] = ACTIONS(3441),
    [anon_sym___thread] = ACTIONS(3441),
    [anon_sym_const] = ACTIONS(3441),
    [anon_sym_constexpr] = ACTIONS(3441),
    [anon_sym_volatile] = ACTIONS(3441),
    [anon_sym_restrict] = ACTIONS(3441),
    [anon_sym___restrict__] = ACTIONS(3441),
    [anon_sym__Atomic] = ACTIONS(3441),
    [anon_sym__Noreturn] = ACTIONS(3441),
    [anon_sym_noreturn] = ACTIONS(3441),
    [anon_sym_mutable] = ACTIONS(3441),
    [anon_sym_constinit] = ACTIONS(3441),
    [anon_sym_consteval] = ACTIONS(3441),
    [anon_sym_alignas] = ACTIONS(3441),
    [anon_sym__Alignas] = ACTIONS(3441),
    [sym_primitive_type] = ACTIONS(3441),
    [anon_sym_enum] = ACTIONS(3441),
    [anon_sym_class] = ACTIONS(3441),
    [anon_sym_struct] = ACTIONS(3441),
    [anon_sym_union] = ACTIONS(3441),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3441),
    [anon_sym_let] = ACTIONS(3441),
    [anon_sym_This] = ACTIONS(3441),
    [anon_sym_decltype] = ACTIONS(3441),
    [sym_virtual] = ACTIONS(3441),
    [anon_sym_explicit] = ACTIONS(3441),
    [anon_sym_typename] = ACTIONS(3441),
    [anon_sym_template] = ACTIONS(3441),
    [anon_sym_operator] = ACTIONS(3441),
    [anon_sym_friend] = ACTIONS(3441),
    [anon_sym_public] = ACTIONS(3441),
    [anon_sym_private] = ACTIONS(3441),
    [anon_sym_protected] = ACTIONS(3441),
    [anon_sym_using] = ACTIONS(3441),
    [anon_sym_static_assert] = ACTIONS(3441),
    [anon_sym_precise] = ACTIONS(3441),
    [anon_sym_shared] = ACTIONS(3441),
    [anon_sym_groupshared] = ACTIONS(3441),
    [anon_sym_uniform] = ACTIONS(3441),
    [anon_sym_row_major] = ACTIONS(3441),
    [anon_sym_column_major] = ACTIONS(3441),
    [anon_sym_globallycoherent] = ACTIONS(3441),
    [anon_sym_centroid] = ACTIONS(3441),
    [anon_sym_noperspective] = ACTIONS(3441),
    [anon_sym_nointerpolation] = ACTIONS(3441),
    [anon_sym_sample] = ACTIONS(3441),
    [anon_sym_linear] = ACTIONS(3441),
    [anon_sym_snorm] = ACTIONS(3441),
    [anon_sym_unorm] = ACTIONS(3441),
    [anon_sym_point] = ACTIONS(3441),
    [anon_sym_line] = ACTIONS(3441),
    [anon_sym_triangleadj] = ACTIONS(3441),
    [anon_sym_lineadj] = ACTIONS(3441),
    [anon_sym_triangle] = ACTIONS(3441),
    [anon_sym_interface] = ACTIONS(3441),
    [anon_sym_extension] = ACTIONS(3441),
    [anon_sym___init] = ACTIONS(3441),
    [anon_sym___subscript] = ACTIONS(3441),
    [anon_sym_property] = ACTIONS(3441),
    [anon_sym_associatedtype] = ACTIONS(3441),
  },
  [2115] = {
    [sym_identifier] = ACTIONS(5514),
    [aux_sym_preproc_def_token1] = ACTIONS(5514),
    [aux_sym_preproc_if_token1] = ACTIONS(5514),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5514),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5514),
    [sym_preproc_directive] = ACTIONS(5514),
    [anon_sym_LPAREN2] = ACTIONS(5516),
    [anon_sym_TILDE] = ACTIONS(5516),
    [anon_sym_STAR] = ACTIONS(5516),
    [anon_sym_AMP_AMP] = ACTIONS(5516),
    [anon_sym_AMP] = ACTIONS(5514),
    [anon_sym___extension__] = ACTIONS(5514),
    [anon_sym_typedef] = ACTIONS(5514),
    [anon_sym_in] = ACTIONS(5514),
    [anon_sym_out] = ACTIONS(5514),
    [anon_sym_inout] = ACTIONS(5514),
    [anon_sym_extern] = ACTIONS(5514),
    [anon_sym___attribute__] = ACTIONS(5514),
    [anon_sym_COLON_COLON] = ACTIONS(5516),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5516),
    [anon_sym___declspec] = ACTIONS(5514),
    [anon_sym___based] = ACTIONS(5514),
    [anon_sym_RBRACE] = ACTIONS(5516),
    [anon_sym_signed] = ACTIONS(5514),
    [anon_sym_unsigned] = ACTIONS(5514),
    [anon_sym_long] = ACTIONS(5514),
    [anon_sym_short] = ACTIONS(5514),
    [anon_sym_LBRACK] = ACTIONS(5514),
    [anon_sym_static] = ACTIONS(5514),
    [anon_sym_register] = ACTIONS(5514),
    [anon_sym_inline] = ACTIONS(5514),
    [anon_sym___inline] = ACTIONS(5514),
    [anon_sym___inline__] = ACTIONS(5514),
    [anon_sym___forceinline] = ACTIONS(5514),
    [anon_sym_thread_local] = ACTIONS(5514),
    [anon_sym___thread] = ACTIONS(5514),
    [anon_sym_const] = ACTIONS(5514),
    [anon_sym_constexpr] = ACTIONS(5514),
    [anon_sym_volatile] = ACTIONS(5514),
    [anon_sym_restrict] = ACTIONS(5514),
    [anon_sym___restrict__] = ACTIONS(5514),
    [anon_sym__Atomic] = ACTIONS(5514),
    [anon_sym__Noreturn] = ACTIONS(5514),
    [anon_sym_noreturn] = ACTIONS(5514),
    [anon_sym_mutable] = ACTIONS(5514),
    [anon_sym_constinit] = ACTIONS(5514),
    [anon_sym_consteval] = ACTIONS(5514),
    [anon_sym_alignas] = ACTIONS(5514),
    [anon_sym__Alignas] = ACTIONS(5514),
    [sym_primitive_type] = ACTIONS(5514),
    [anon_sym_enum] = ACTIONS(5514),
    [anon_sym_class] = ACTIONS(5514),
    [anon_sym_struct] = ACTIONS(5514),
    [anon_sym_union] = ACTIONS(5514),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5514),
    [anon_sym_let] = ACTIONS(5514),
    [anon_sym_This] = ACTIONS(5514),
    [anon_sym_decltype] = ACTIONS(5514),
    [sym_virtual] = ACTIONS(5514),
    [anon_sym_explicit] = ACTIONS(5514),
    [anon_sym_typename] = ACTIONS(5514),
    [anon_sym_template] = ACTIONS(5514),
    [anon_sym_operator] = ACTIONS(5514),
    [anon_sym_friend] = ACTIONS(5514),
    [anon_sym_public] = ACTIONS(5514),
    [anon_sym_private] = ACTIONS(5514),
    [anon_sym_protected] = ACTIONS(5514),
    [anon_sym_using] = ACTIONS(5514),
    [anon_sym_static_assert] = ACTIONS(5514),
    [anon_sym_precise] = ACTIONS(5514),
    [anon_sym_shared] = ACTIONS(5514),
    [anon_sym_groupshared] = ACTIONS(5514),
    [anon_sym_uniform] = ACTIONS(5514),
    [anon_sym_row_major] = ACTIONS(5514),
    [anon_sym_column_major] = ACTIONS(5514),
    [anon_sym_globallycoherent] = ACTIONS(5514),
    [anon_sym_centroid] = ACTIONS(5514),
    [anon_sym_noperspective] = ACTIONS(5514),
    [anon_sym_nointerpolation] = ACTIONS(5514),
    [anon_sym_sample] = ACTIONS(5514),
    [anon_sym_linear] = ACTIONS(5514),
    [anon_sym_snorm] = ACTIONS(5514),
    [anon_sym_unorm] = ACTIONS(5514),
    [anon_sym_point] = ACTIONS(5514),
    [anon_sym_line] = ACTIONS(5514),
    [anon_sym_triangleadj] = ACTIONS(5514),
    [anon_sym_lineadj] = ACTIONS(5514),
    [anon_sym_triangle] = ACTIONS(5514),
    [anon_sym_interface] = ACTIONS(5514),
    [anon_sym_extension] = ACTIONS(5514),
    [anon_sym___init] = ACTIONS(5514),
    [anon_sym___subscript] = ACTIONS(5514),
    [anon_sym_property] = ACTIONS(5514),
    [anon_sym_associatedtype] = ACTIONS(5514),
  },
  [2116] = {
    [sym_identifier] = ACTIONS(3425),
    [aux_sym_preproc_def_token1] = ACTIONS(3425),
    [aux_sym_preproc_if_token1] = ACTIONS(3425),
    [aux_sym_preproc_if_token2] = ACTIONS(3425),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3425),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3425),
    [sym_preproc_directive] = ACTIONS(3425),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3425),
    [anon_sym___extension__] = ACTIONS(3425),
    [anon_sym_typedef] = ACTIONS(3425),
    [anon_sym_in] = ACTIONS(3425),
    [anon_sym_out] = ACTIONS(3425),
    [anon_sym_inout] = ACTIONS(3425),
    [anon_sym_extern] = ACTIONS(3425),
    [anon_sym___attribute__] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(3427),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3427),
    [anon_sym___declspec] = ACTIONS(3425),
    [anon_sym___based] = ACTIONS(3425),
    [anon_sym_signed] = ACTIONS(3425),
    [anon_sym_unsigned] = ACTIONS(3425),
    [anon_sym_long] = ACTIONS(3425),
    [anon_sym_short] = ACTIONS(3425),
    [anon_sym_LBRACK] = ACTIONS(3425),
    [anon_sym_static] = ACTIONS(3425),
    [anon_sym_register] = ACTIONS(3425),
    [anon_sym_inline] = ACTIONS(3425),
    [anon_sym___inline] = ACTIONS(3425),
    [anon_sym___inline__] = ACTIONS(3425),
    [anon_sym___forceinline] = ACTIONS(3425),
    [anon_sym_thread_local] = ACTIONS(3425),
    [anon_sym___thread] = ACTIONS(3425),
    [anon_sym_const] = ACTIONS(3425),
    [anon_sym_constexpr] = ACTIONS(3425),
    [anon_sym_volatile] = ACTIONS(3425),
    [anon_sym_restrict] = ACTIONS(3425),
    [anon_sym___restrict__] = ACTIONS(3425),
    [anon_sym__Atomic] = ACTIONS(3425),
    [anon_sym__Noreturn] = ACTIONS(3425),
    [anon_sym_noreturn] = ACTIONS(3425),
    [anon_sym_mutable] = ACTIONS(3425),
    [anon_sym_constinit] = ACTIONS(3425),
    [anon_sym_consteval] = ACTIONS(3425),
    [anon_sym_alignas] = ACTIONS(3425),
    [anon_sym__Alignas] = ACTIONS(3425),
    [sym_primitive_type] = ACTIONS(3425),
    [anon_sym_enum] = ACTIONS(3425),
    [anon_sym_class] = ACTIONS(3425),
    [anon_sym_struct] = ACTIONS(3425),
    [anon_sym_union] = ACTIONS(3425),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3425),
    [anon_sym_let] = ACTIONS(3425),
    [anon_sym_This] = ACTIONS(3425),
    [anon_sym_decltype] = ACTIONS(3425),
    [sym_virtual] = ACTIONS(3425),
    [anon_sym_explicit] = ACTIONS(3425),
    [anon_sym_typename] = ACTIONS(3425),
    [anon_sym_template] = ACTIONS(3425),
    [anon_sym_operator] = ACTIONS(3425),
    [anon_sym_friend] = ACTIONS(3425),
    [anon_sym_public] = ACTIONS(3425),
    [anon_sym_private] = ACTIONS(3425),
    [anon_sym_protected] = ACTIONS(3425),
    [anon_sym_using] = ACTIONS(3425),
    [anon_sym_static_assert] = ACTIONS(3425),
    [anon_sym_precise] = ACTIONS(3425),
    [anon_sym_shared] = ACTIONS(3425),
    [anon_sym_groupshared] = ACTIONS(3425),
    [anon_sym_uniform] = ACTIONS(3425),
    [anon_sym_row_major] = ACTIONS(3425),
    [anon_sym_column_major] = ACTIONS(3425),
    [anon_sym_globallycoherent] = ACTIONS(3425),
    [anon_sym_centroid] = ACTIONS(3425),
    [anon_sym_noperspective] = ACTIONS(3425),
    [anon_sym_nointerpolation] = ACTIONS(3425),
    [anon_sym_sample] = ACTIONS(3425),
    [anon_sym_linear] = ACTIONS(3425),
    [anon_sym_snorm] = ACTIONS(3425),
    [anon_sym_unorm] = ACTIONS(3425),
    [anon_sym_point] = ACTIONS(3425),
    [anon_sym_line] = ACTIONS(3425),
    [anon_sym_triangleadj] = ACTIONS(3425),
    [anon_sym_lineadj] = ACTIONS(3425),
    [anon_sym_triangle] = ACTIONS(3425),
    [anon_sym_interface] = ACTIONS(3425),
    [anon_sym_extension] = ACTIONS(3425),
    [anon_sym___init] = ACTIONS(3425),
    [anon_sym___subscript] = ACTIONS(3425),
    [anon_sym_property] = ACTIONS(3425),
    [anon_sym_associatedtype] = ACTIONS(3425),
  },
  [2117] = {
    [sym_expression] = STATE(5267),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2118] = {
    [sym_expression] = STATE(5490),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2119] = {
    [sym_identifier] = ACTIONS(3535),
    [aux_sym_preproc_def_token1] = ACTIONS(3535),
    [aux_sym_preproc_if_token1] = ACTIONS(3535),
    [aux_sym_preproc_if_token2] = ACTIONS(3535),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3535),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3535),
    [sym_preproc_directive] = ACTIONS(3535),
    [anon_sym_LPAREN2] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3537),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym___extension__] = ACTIONS(3535),
    [anon_sym_typedef] = ACTIONS(3535),
    [anon_sym_in] = ACTIONS(3535),
    [anon_sym_out] = ACTIONS(3535),
    [anon_sym_inout] = ACTIONS(3535),
    [anon_sym_extern] = ACTIONS(3535),
    [anon_sym___attribute__] = ACTIONS(3535),
    [anon_sym_COLON_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3537),
    [anon_sym___declspec] = ACTIONS(3535),
    [anon_sym___based] = ACTIONS(3535),
    [anon_sym_signed] = ACTIONS(3535),
    [anon_sym_unsigned] = ACTIONS(3535),
    [anon_sym_long] = ACTIONS(3535),
    [anon_sym_short] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_static] = ACTIONS(3535),
    [anon_sym_register] = ACTIONS(3535),
    [anon_sym_inline] = ACTIONS(3535),
    [anon_sym___inline] = ACTIONS(3535),
    [anon_sym___inline__] = ACTIONS(3535),
    [anon_sym___forceinline] = ACTIONS(3535),
    [anon_sym_thread_local] = ACTIONS(3535),
    [anon_sym___thread] = ACTIONS(3535),
    [anon_sym_const] = ACTIONS(3535),
    [anon_sym_constexpr] = ACTIONS(3535),
    [anon_sym_volatile] = ACTIONS(3535),
    [anon_sym_restrict] = ACTIONS(3535),
    [anon_sym___restrict__] = ACTIONS(3535),
    [anon_sym__Atomic] = ACTIONS(3535),
    [anon_sym__Noreturn] = ACTIONS(3535),
    [anon_sym_noreturn] = ACTIONS(3535),
    [anon_sym_mutable] = ACTIONS(3535),
    [anon_sym_constinit] = ACTIONS(3535),
    [anon_sym_consteval] = ACTIONS(3535),
    [anon_sym_alignas] = ACTIONS(3535),
    [anon_sym__Alignas] = ACTIONS(3535),
    [sym_primitive_type] = ACTIONS(3535),
    [anon_sym_enum] = ACTIONS(3535),
    [anon_sym_class] = ACTIONS(3535),
    [anon_sym_struct] = ACTIONS(3535),
    [anon_sym_union] = ACTIONS(3535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3535),
    [anon_sym_let] = ACTIONS(3535),
    [anon_sym_This] = ACTIONS(3535),
    [anon_sym_decltype] = ACTIONS(3535),
    [sym_virtual] = ACTIONS(3535),
    [anon_sym_explicit] = ACTIONS(3535),
    [anon_sym_typename] = ACTIONS(3535),
    [anon_sym_template] = ACTIONS(3535),
    [anon_sym_operator] = ACTIONS(3535),
    [anon_sym_friend] = ACTIONS(3535),
    [anon_sym_public] = ACTIONS(3535),
    [anon_sym_private] = ACTIONS(3535),
    [anon_sym_protected] = ACTIONS(3535),
    [anon_sym_using] = ACTIONS(3535),
    [anon_sym_static_assert] = ACTIONS(3535),
    [anon_sym_precise] = ACTIONS(3535),
    [anon_sym_shared] = ACTIONS(3535),
    [anon_sym_groupshared] = ACTIONS(3535),
    [anon_sym_uniform] = ACTIONS(3535),
    [anon_sym_row_major] = ACTIONS(3535),
    [anon_sym_column_major] = ACTIONS(3535),
    [anon_sym_globallycoherent] = ACTIONS(3535),
    [anon_sym_centroid] = ACTIONS(3535),
    [anon_sym_noperspective] = ACTIONS(3535),
    [anon_sym_nointerpolation] = ACTIONS(3535),
    [anon_sym_sample] = ACTIONS(3535),
    [anon_sym_linear] = ACTIONS(3535),
    [anon_sym_snorm] = ACTIONS(3535),
    [anon_sym_unorm] = ACTIONS(3535),
    [anon_sym_point] = ACTIONS(3535),
    [anon_sym_line] = ACTIONS(3535),
    [anon_sym_triangleadj] = ACTIONS(3535),
    [anon_sym_lineadj] = ACTIONS(3535),
    [anon_sym_triangle] = ACTIONS(3535),
    [anon_sym_interface] = ACTIONS(3535),
    [anon_sym_extension] = ACTIONS(3535),
    [anon_sym___init] = ACTIONS(3535),
    [anon_sym___subscript] = ACTIONS(3535),
    [anon_sym_property] = ACTIONS(3535),
    [anon_sym_associatedtype] = ACTIONS(3535),
  },
  [2120] = {
    [sym_identifier] = ACTIONS(3601),
    [aux_sym_preproc_def_token1] = ACTIONS(3601),
    [aux_sym_preproc_if_token1] = ACTIONS(3601),
    [aux_sym_preproc_if_token2] = ACTIONS(3601),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3601),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3601),
    [sym_preproc_directive] = ACTIONS(3601),
    [anon_sym_LPAREN2] = ACTIONS(3603),
    [anon_sym_TILDE] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(3603),
    [anon_sym_AMP_AMP] = ACTIONS(3603),
    [anon_sym_AMP] = ACTIONS(3601),
    [anon_sym___extension__] = ACTIONS(3601),
    [anon_sym_typedef] = ACTIONS(3601),
    [anon_sym_in] = ACTIONS(3601),
    [anon_sym_out] = ACTIONS(3601),
    [anon_sym_inout] = ACTIONS(3601),
    [anon_sym_extern] = ACTIONS(3601),
    [anon_sym___attribute__] = ACTIONS(3601),
    [anon_sym_COLON_COLON] = ACTIONS(3603),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3603),
    [anon_sym___declspec] = ACTIONS(3601),
    [anon_sym___based] = ACTIONS(3601),
    [anon_sym_signed] = ACTIONS(3601),
    [anon_sym_unsigned] = ACTIONS(3601),
    [anon_sym_long] = ACTIONS(3601),
    [anon_sym_short] = ACTIONS(3601),
    [anon_sym_LBRACK] = ACTIONS(3601),
    [anon_sym_static] = ACTIONS(3601),
    [anon_sym_register] = ACTIONS(3601),
    [anon_sym_inline] = ACTIONS(3601),
    [anon_sym___inline] = ACTIONS(3601),
    [anon_sym___inline__] = ACTIONS(3601),
    [anon_sym___forceinline] = ACTIONS(3601),
    [anon_sym_thread_local] = ACTIONS(3601),
    [anon_sym___thread] = ACTIONS(3601),
    [anon_sym_const] = ACTIONS(3601),
    [anon_sym_constexpr] = ACTIONS(3601),
    [anon_sym_volatile] = ACTIONS(3601),
    [anon_sym_restrict] = ACTIONS(3601),
    [anon_sym___restrict__] = ACTIONS(3601),
    [anon_sym__Atomic] = ACTIONS(3601),
    [anon_sym__Noreturn] = ACTIONS(3601),
    [anon_sym_noreturn] = ACTIONS(3601),
    [anon_sym_mutable] = ACTIONS(3601),
    [anon_sym_constinit] = ACTIONS(3601),
    [anon_sym_consteval] = ACTIONS(3601),
    [anon_sym_alignas] = ACTIONS(3601),
    [anon_sym__Alignas] = ACTIONS(3601),
    [sym_primitive_type] = ACTIONS(3601),
    [anon_sym_enum] = ACTIONS(3601),
    [anon_sym_class] = ACTIONS(3601),
    [anon_sym_struct] = ACTIONS(3601),
    [anon_sym_union] = ACTIONS(3601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3601),
    [anon_sym_let] = ACTIONS(3601),
    [anon_sym_This] = ACTIONS(3601),
    [anon_sym_decltype] = ACTIONS(3601),
    [sym_virtual] = ACTIONS(3601),
    [anon_sym_explicit] = ACTIONS(3601),
    [anon_sym_typename] = ACTIONS(3601),
    [anon_sym_template] = ACTIONS(3601),
    [anon_sym_operator] = ACTIONS(3601),
    [anon_sym_friend] = ACTIONS(3601),
    [anon_sym_public] = ACTIONS(3601),
    [anon_sym_private] = ACTIONS(3601),
    [anon_sym_protected] = ACTIONS(3601),
    [anon_sym_using] = ACTIONS(3601),
    [anon_sym_static_assert] = ACTIONS(3601),
    [anon_sym_precise] = ACTIONS(3601),
    [anon_sym_shared] = ACTIONS(3601),
    [anon_sym_groupshared] = ACTIONS(3601),
    [anon_sym_uniform] = ACTIONS(3601),
    [anon_sym_row_major] = ACTIONS(3601),
    [anon_sym_column_major] = ACTIONS(3601),
    [anon_sym_globallycoherent] = ACTIONS(3601),
    [anon_sym_centroid] = ACTIONS(3601),
    [anon_sym_noperspective] = ACTIONS(3601),
    [anon_sym_nointerpolation] = ACTIONS(3601),
    [anon_sym_sample] = ACTIONS(3601),
    [anon_sym_linear] = ACTIONS(3601),
    [anon_sym_snorm] = ACTIONS(3601),
    [anon_sym_unorm] = ACTIONS(3601),
    [anon_sym_point] = ACTIONS(3601),
    [anon_sym_line] = ACTIONS(3601),
    [anon_sym_triangleadj] = ACTIONS(3601),
    [anon_sym_lineadj] = ACTIONS(3601),
    [anon_sym_triangle] = ACTIONS(3601),
    [anon_sym_interface] = ACTIONS(3601),
    [anon_sym_extension] = ACTIONS(3601),
    [anon_sym___init] = ACTIONS(3601),
    [anon_sym___subscript] = ACTIONS(3601),
    [anon_sym_property] = ACTIONS(3601),
    [anon_sym_associatedtype] = ACTIONS(3601),
  },
  [2121] = {
    [sym_identifier] = ACTIONS(5518),
    [aux_sym_preproc_def_token1] = ACTIONS(5518),
    [aux_sym_preproc_if_token1] = ACTIONS(5518),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5518),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5518),
    [sym_preproc_directive] = ACTIONS(5518),
    [anon_sym_LPAREN2] = ACTIONS(5520),
    [anon_sym_TILDE] = ACTIONS(5520),
    [anon_sym_STAR] = ACTIONS(5520),
    [anon_sym_AMP_AMP] = ACTIONS(5520),
    [anon_sym_AMP] = ACTIONS(5518),
    [anon_sym___extension__] = ACTIONS(5518),
    [anon_sym_typedef] = ACTIONS(5518),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_inout] = ACTIONS(5518),
    [anon_sym_extern] = ACTIONS(5518),
    [anon_sym___attribute__] = ACTIONS(5518),
    [anon_sym_COLON_COLON] = ACTIONS(5520),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5520),
    [anon_sym___declspec] = ACTIONS(5518),
    [anon_sym___based] = ACTIONS(5518),
    [anon_sym_RBRACE] = ACTIONS(5520),
    [anon_sym_signed] = ACTIONS(5518),
    [anon_sym_unsigned] = ACTIONS(5518),
    [anon_sym_long] = ACTIONS(5518),
    [anon_sym_short] = ACTIONS(5518),
    [anon_sym_LBRACK] = ACTIONS(5518),
    [anon_sym_static] = ACTIONS(5518),
    [anon_sym_register] = ACTIONS(5518),
    [anon_sym_inline] = ACTIONS(5518),
    [anon_sym___inline] = ACTIONS(5518),
    [anon_sym___inline__] = ACTIONS(5518),
    [anon_sym___forceinline] = ACTIONS(5518),
    [anon_sym_thread_local] = ACTIONS(5518),
    [anon_sym___thread] = ACTIONS(5518),
    [anon_sym_const] = ACTIONS(5518),
    [anon_sym_constexpr] = ACTIONS(5518),
    [anon_sym_volatile] = ACTIONS(5518),
    [anon_sym_restrict] = ACTIONS(5518),
    [anon_sym___restrict__] = ACTIONS(5518),
    [anon_sym__Atomic] = ACTIONS(5518),
    [anon_sym__Noreturn] = ACTIONS(5518),
    [anon_sym_noreturn] = ACTIONS(5518),
    [anon_sym_mutable] = ACTIONS(5518),
    [anon_sym_constinit] = ACTIONS(5518),
    [anon_sym_consteval] = ACTIONS(5518),
    [anon_sym_alignas] = ACTIONS(5518),
    [anon_sym__Alignas] = ACTIONS(5518),
    [sym_primitive_type] = ACTIONS(5518),
    [anon_sym_enum] = ACTIONS(5518),
    [anon_sym_class] = ACTIONS(5518),
    [anon_sym_struct] = ACTIONS(5518),
    [anon_sym_union] = ACTIONS(5518),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5518),
    [anon_sym_let] = ACTIONS(5518),
    [anon_sym_This] = ACTIONS(5518),
    [anon_sym_decltype] = ACTIONS(5518),
    [sym_virtual] = ACTIONS(5518),
    [anon_sym_explicit] = ACTIONS(5518),
    [anon_sym_typename] = ACTIONS(5518),
    [anon_sym_template] = ACTIONS(5518),
    [anon_sym_operator] = ACTIONS(5518),
    [anon_sym_friend] = ACTIONS(5518),
    [anon_sym_public] = ACTIONS(5518),
    [anon_sym_private] = ACTIONS(5518),
    [anon_sym_protected] = ACTIONS(5518),
    [anon_sym_using] = ACTIONS(5518),
    [anon_sym_static_assert] = ACTIONS(5518),
    [anon_sym_precise] = ACTIONS(5518),
    [anon_sym_shared] = ACTIONS(5518),
    [anon_sym_groupshared] = ACTIONS(5518),
    [anon_sym_uniform] = ACTIONS(5518),
    [anon_sym_row_major] = ACTIONS(5518),
    [anon_sym_column_major] = ACTIONS(5518),
    [anon_sym_globallycoherent] = ACTIONS(5518),
    [anon_sym_centroid] = ACTIONS(5518),
    [anon_sym_noperspective] = ACTIONS(5518),
    [anon_sym_nointerpolation] = ACTIONS(5518),
    [anon_sym_sample] = ACTIONS(5518),
    [anon_sym_linear] = ACTIONS(5518),
    [anon_sym_snorm] = ACTIONS(5518),
    [anon_sym_unorm] = ACTIONS(5518),
    [anon_sym_point] = ACTIONS(5518),
    [anon_sym_line] = ACTIONS(5518),
    [anon_sym_triangleadj] = ACTIONS(5518),
    [anon_sym_lineadj] = ACTIONS(5518),
    [anon_sym_triangle] = ACTIONS(5518),
    [anon_sym_interface] = ACTIONS(5518),
    [anon_sym_extension] = ACTIONS(5518),
    [anon_sym___init] = ACTIONS(5518),
    [anon_sym___subscript] = ACTIONS(5518),
    [anon_sym_property] = ACTIONS(5518),
    [anon_sym_associatedtype] = ACTIONS(5518),
  },
  [2122] = {
    [sym_expression] = STATE(5114),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(6094),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2123] = {
    [sym_identifier] = ACTIONS(5522),
    [aux_sym_preproc_def_token1] = ACTIONS(5522),
    [aux_sym_preproc_if_token1] = ACTIONS(5522),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5522),
    [sym_preproc_directive] = ACTIONS(5522),
    [anon_sym_LPAREN2] = ACTIONS(5524),
    [anon_sym_TILDE] = ACTIONS(5524),
    [anon_sym_STAR] = ACTIONS(5524),
    [anon_sym_AMP_AMP] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5522),
    [anon_sym___extension__] = ACTIONS(5522),
    [anon_sym_typedef] = ACTIONS(5522),
    [anon_sym_in] = ACTIONS(5522),
    [anon_sym_out] = ACTIONS(5522),
    [anon_sym_inout] = ACTIONS(5522),
    [anon_sym_extern] = ACTIONS(5522),
    [anon_sym___attribute__] = ACTIONS(5522),
    [anon_sym_COLON_COLON] = ACTIONS(5524),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5524),
    [anon_sym___declspec] = ACTIONS(5522),
    [anon_sym___based] = ACTIONS(5522),
    [anon_sym_RBRACE] = ACTIONS(5524),
    [anon_sym_signed] = ACTIONS(5522),
    [anon_sym_unsigned] = ACTIONS(5522),
    [anon_sym_long] = ACTIONS(5522),
    [anon_sym_short] = ACTIONS(5522),
    [anon_sym_LBRACK] = ACTIONS(5522),
    [anon_sym_static] = ACTIONS(5522),
    [anon_sym_register] = ACTIONS(5522),
    [anon_sym_inline] = ACTIONS(5522),
    [anon_sym___inline] = ACTIONS(5522),
    [anon_sym___inline__] = ACTIONS(5522),
    [anon_sym___forceinline] = ACTIONS(5522),
    [anon_sym_thread_local] = ACTIONS(5522),
    [anon_sym___thread] = ACTIONS(5522),
    [anon_sym_const] = ACTIONS(5522),
    [anon_sym_constexpr] = ACTIONS(5522),
    [anon_sym_volatile] = ACTIONS(5522),
    [anon_sym_restrict] = ACTIONS(5522),
    [anon_sym___restrict__] = ACTIONS(5522),
    [anon_sym__Atomic] = ACTIONS(5522),
    [anon_sym__Noreturn] = ACTIONS(5522),
    [anon_sym_noreturn] = ACTIONS(5522),
    [anon_sym_mutable] = ACTIONS(5522),
    [anon_sym_constinit] = ACTIONS(5522),
    [anon_sym_consteval] = ACTIONS(5522),
    [anon_sym_alignas] = ACTIONS(5522),
    [anon_sym__Alignas] = ACTIONS(5522),
    [sym_primitive_type] = ACTIONS(5522),
    [anon_sym_enum] = ACTIONS(5522),
    [anon_sym_class] = ACTIONS(5522),
    [anon_sym_struct] = ACTIONS(5522),
    [anon_sym_union] = ACTIONS(5522),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5522),
    [anon_sym_let] = ACTIONS(5522),
    [anon_sym_This] = ACTIONS(5522),
    [anon_sym_decltype] = ACTIONS(5522),
    [sym_virtual] = ACTIONS(5522),
    [anon_sym_explicit] = ACTIONS(5522),
    [anon_sym_typename] = ACTIONS(5522),
    [anon_sym_template] = ACTIONS(5522),
    [anon_sym_operator] = ACTIONS(5522),
    [anon_sym_friend] = ACTIONS(5522),
    [anon_sym_public] = ACTIONS(5522),
    [anon_sym_private] = ACTIONS(5522),
    [anon_sym_protected] = ACTIONS(5522),
    [anon_sym_using] = ACTIONS(5522),
    [anon_sym_static_assert] = ACTIONS(5522),
    [anon_sym_precise] = ACTIONS(5522),
    [anon_sym_shared] = ACTIONS(5522),
    [anon_sym_groupshared] = ACTIONS(5522),
    [anon_sym_uniform] = ACTIONS(5522),
    [anon_sym_row_major] = ACTIONS(5522),
    [anon_sym_column_major] = ACTIONS(5522),
    [anon_sym_globallycoherent] = ACTIONS(5522),
    [anon_sym_centroid] = ACTIONS(5522),
    [anon_sym_noperspective] = ACTIONS(5522),
    [anon_sym_nointerpolation] = ACTIONS(5522),
    [anon_sym_sample] = ACTIONS(5522),
    [anon_sym_linear] = ACTIONS(5522),
    [anon_sym_snorm] = ACTIONS(5522),
    [anon_sym_unorm] = ACTIONS(5522),
    [anon_sym_point] = ACTIONS(5522),
    [anon_sym_line] = ACTIONS(5522),
    [anon_sym_triangleadj] = ACTIONS(5522),
    [anon_sym_lineadj] = ACTIONS(5522),
    [anon_sym_triangle] = ACTIONS(5522),
    [anon_sym_interface] = ACTIONS(5522),
    [anon_sym_extension] = ACTIONS(5522),
    [anon_sym___init] = ACTIONS(5522),
    [anon_sym___subscript] = ACTIONS(5522),
    [anon_sym_property] = ACTIONS(5522),
    [anon_sym_associatedtype] = ACTIONS(5522),
  },
  [2124] = {
    [sym_expression] = STATE(5451),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2125] = {
    [sym_expression] = STATE(5268),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2126] = {
    [sym_expression] = STATE(5496),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2127] = {
    [sym_identifier] = ACTIONS(5518),
    [aux_sym_preproc_def_token1] = ACTIONS(5518),
    [aux_sym_preproc_if_token1] = ACTIONS(5518),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5518),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5518),
    [sym_preproc_directive] = ACTIONS(5518),
    [anon_sym_LPAREN2] = ACTIONS(5520),
    [anon_sym_TILDE] = ACTIONS(5520),
    [anon_sym_STAR] = ACTIONS(5520),
    [anon_sym_AMP_AMP] = ACTIONS(5520),
    [anon_sym_AMP] = ACTIONS(5518),
    [anon_sym___extension__] = ACTIONS(5518),
    [anon_sym_typedef] = ACTIONS(5518),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_inout] = ACTIONS(5518),
    [anon_sym_extern] = ACTIONS(5518),
    [anon_sym___attribute__] = ACTIONS(5518),
    [anon_sym_COLON_COLON] = ACTIONS(5520),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5520),
    [anon_sym___declspec] = ACTIONS(5518),
    [anon_sym___based] = ACTIONS(5518),
    [anon_sym_RBRACE] = ACTIONS(5520),
    [anon_sym_signed] = ACTIONS(5518),
    [anon_sym_unsigned] = ACTIONS(5518),
    [anon_sym_long] = ACTIONS(5518),
    [anon_sym_short] = ACTIONS(5518),
    [anon_sym_LBRACK] = ACTIONS(5518),
    [anon_sym_static] = ACTIONS(5518),
    [anon_sym_register] = ACTIONS(5518),
    [anon_sym_inline] = ACTIONS(5518),
    [anon_sym___inline] = ACTIONS(5518),
    [anon_sym___inline__] = ACTIONS(5518),
    [anon_sym___forceinline] = ACTIONS(5518),
    [anon_sym_thread_local] = ACTIONS(5518),
    [anon_sym___thread] = ACTIONS(5518),
    [anon_sym_const] = ACTIONS(5518),
    [anon_sym_constexpr] = ACTIONS(5518),
    [anon_sym_volatile] = ACTIONS(5518),
    [anon_sym_restrict] = ACTIONS(5518),
    [anon_sym___restrict__] = ACTIONS(5518),
    [anon_sym__Atomic] = ACTIONS(5518),
    [anon_sym__Noreturn] = ACTIONS(5518),
    [anon_sym_noreturn] = ACTIONS(5518),
    [anon_sym_mutable] = ACTIONS(5518),
    [anon_sym_constinit] = ACTIONS(5518),
    [anon_sym_consteval] = ACTIONS(5518),
    [anon_sym_alignas] = ACTIONS(5518),
    [anon_sym__Alignas] = ACTIONS(5518),
    [sym_primitive_type] = ACTIONS(5518),
    [anon_sym_enum] = ACTIONS(5518),
    [anon_sym_class] = ACTIONS(5518),
    [anon_sym_struct] = ACTIONS(5518),
    [anon_sym_union] = ACTIONS(5518),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5518),
    [anon_sym_let] = ACTIONS(5518),
    [anon_sym_This] = ACTIONS(5518),
    [anon_sym_decltype] = ACTIONS(5518),
    [sym_virtual] = ACTIONS(5518),
    [anon_sym_explicit] = ACTIONS(5518),
    [anon_sym_typename] = ACTIONS(5518),
    [anon_sym_template] = ACTIONS(5518),
    [anon_sym_operator] = ACTIONS(5518),
    [anon_sym_friend] = ACTIONS(5518),
    [anon_sym_public] = ACTIONS(5518),
    [anon_sym_private] = ACTIONS(5518),
    [anon_sym_protected] = ACTIONS(5518),
    [anon_sym_using] = ACTIONS(5518),
    [anon_sym_static_assert] = ACTIONS(5518),
    [anon_sym_precise] = ACTIONS(5518),
    [anon_sym_shared] = ACTIONS(5518),
    [anon_sym_groupshared] = ACTIONS(5518),
    [anon_sym_uniform] = ACTIONS(5518),
    [anon_sym_row_major] = ACTIONS(5518),
    [anon_sym_column_major] = ACTIONS(5518),
    [anon_sym_globallycoherent] = ACTIONS(5518),
    [anon_sym_centroid] = ACTIONS(5518),
    [anon_sym_noperspective] = ACTIONS(5518),
    [anon_sym_nointerpolation] = ACTIONS(5518),
    [anon_sym_sample] = ACTIONS(5518),
    [anon_sym_linear] = ACTIONS(5518),
    [anon_sym_snorm] = ACTIONS(5518),
    [anon_sym_unorm] = ACTIONS(5518),
    [anon_sym_point] = ACTIONS(5518),
    [anon_sym_line] = ACTIONS(5518),
    [anon_sym_triangleadj] = ACTIONS(5518),
    [anon_sym_lineadj] = ACTIONS(5518),
    [anon_sym_triangle] = ACTIONS(5518),
    [anon_sym_interface] = ACTIONS(5518),
    [anon_sym_extension] = ACTIONS(5518),
    [anon_sym___init] = ACTIONS(5518),
    [anon_sym___subscript] = ACTIONS(5518),
    [anon_sym_property] = ACTIONS(5518),
    [anon_sym_associatedtype] = ACTIONS(5518),
  },
  [2128] = {
    [sym_identifier] = ACTIONS(5522),
    [aux_sym_preproc_def_token1] = ACTIONS(5522),
    [aux_sym_preproc_if_token1] = ACTIONS(5522),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5522),
    [sym_preproc_directive] = ACTIONS(5522),
    [anon_sym_LPAREN2] = ACTIONS(5524),
    [anon_sym_TILDE] = ACTIONS(5524),
    [anon_sym_STAR] = ACTIONS(5524),
    [anon_sym_AMP_AMP] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5522),
    [anon_sym___extension__] = ACTIONS(5522),
    [anon_sym_typedef] = ACTIONS(5522),
    [anon_sym_in] = ACTIONS(5522),
    [anon_sym_out] = ACTIONS(5522),
    [anon_sym_inout] = ACTIONS(5522),
    [anon_sym_extern] = ACTIONS(5522),
    [anon_sym___attribute__] = ACTIONS(5522),
    [anon_sym_COLON_COLON] = ACTIONS(5524),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5524),
    [anon_sym___declspec] = ACTIONS(5522),
    [anon_sym___based] = ACTIONS(5522),
    [anon_sym_RBRACE] = ACTIONS(5524),
    [anon_sym_signed] = ACTIONS(5522),
    [anon_sym_unsigned] = ACTIONS(5522),
    [anon_sym_long] = ACTIONS(5522),
    [anon_sym_short] = ACTIONS(5522),
    [anon_sym_LBRACK] = ACTIONS(5522),
    [anon_sym_static] = ACTIONS(5522),
    [anon_sym_register] = ACTIONS(5522),
    [anon_sym_inline] = ACTIONS(5522),
    [anon_sym___inline] = ACTIONS(5522),
    [anon_sym___inline__] = ACTIONS(5522),
    [anon_sym___forceinline] = ACTIONS(5522),
    [anon_sym_thread_local] = ACTIONS(5522),
    [anon_sym___thread] = ACTIONS(5522),
    [anon_sym_const] = ACTIONS(5522),
    [anon_sym_constexpr] = ACTIONS(5522),
    [anon_sym_volatile] = ACTIONS(5522),
    [anon_sym_restrict] = ACTIONS(5522),
    [anon_sym___restrict__] = ACTIONS(5522),
    [anon_sym__Atomic] = ACTIONS(5522),
    [anon_sym__Noreturn] = ACTIONS(5522),
    [anon_sym_noreturn] = ACTIONS(5522),
    [anon_sym_mutable] = ACTIONS(5522),
    [anon_sym_constinit] = ACTIONS(5522),
    [anon_sym_consteval] = ACTIONS(5522),
    [anon_sym_alignas] = ACTIONS(5522),
    [anon_sym__Alignas] = ACTIONS(5522),
    [sym_primitive_type] = ACTIONS(5522),
    [anon_sym_enum] = ACTIONS(5522),
    [anon_sym_class] = ACTIONS(5522),
    [anon_sym_struct] = ACTIONS(5522),
    [anon_sym_union] = ACTIONS(5522),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5522),
    [anon_sym_let] = ACTIONS(5522),
    [anon_sym_This] = ACTIONS(5522),
    [anon_sym_decltype] = ACTIONS(5522),
    [sym_virtual] = ACTIONS(5522),
    [anon_sym_explicit] = ACTIONS(5522),
    [anon_sym_typename] = ACTIONS(5522),
    [anon_sym_template] = ACTIONS(5522),
    [anon_sym_operator] = ACTIONS(5522),
    [anon_sym_friend] = ACTIONS(5522),
    [anon_sym_public] = ACTIONS(5522),
    [anon_sym_private] = ACTIONS(5522),
    [anon_sym_protected] = ACTIONS(5522),
    [anon_sym_using] = ACTIONS(5522),
    [anon_sym_static_assert] = ACTIONS(5522),
    [anon_sym_precise] = ACTIONS(5522),
    [anon_sym_shared] = ACTIONS(5522),
    [anon_sym_groupshared] = ACTIONS(5522),
    [anon_sym_uniform] = ACTIONS(5522),
    [anon_sym_row_major] = ACTIONS(5522),
    [anon_sym_column_major] = ACTIONS(5522),
    [anon_sym_globallycoherent] = ACTIONS(5522),
    [anon_sym_centroid] = ACTIONS(5522),
    [anon_sym_noperspective] = ACTIONS(5522),
    [anon_sym_nointerpolation] = ACTIONS(5522),
    [anon_sym_sample] = ACTIONS(5522),
    [anon_sym_linear] = ACTIONS(5522),
    [anon_sym_snorm] = ACTIONS(5522),
    [anon_sym_unorm] = ACTIONS(5522),
    [anon_sym_point] = ACTIONS(5522),
    [anon_sym_line] = ACTIONS(5522),
    [anon_sym_triangleadj] = ACTIONS(5522),
    [anon_sym_lineadj] = ACTIONS(5522),
    [anon_sym_triangle] = ACTIONS(5522),
    [anon_sym_interface] = ACTIONS(5522),
    [anon_sym_extension] = ACTIONS(5522),
    [anon_sym___init] = ACTIONS(5522),
    [anon_sym___subscript] = ACTIONS(5522),
    [anon_sym_property] = ACTIONS(5522),
    [anon_sym_associatedtype] = ACTIONS(5522),
  },
  [2129] = {
    [sym_expression] = STATE(4183),
    [sym__string] = STATE(4545),
    [sym_conditional_expression] = STATE(4545),
    [sym_assignment_expression] = STATE(4545),
    [sym_pointer_expression] = STATE(4540),
    [sym_unary_expression] = STATE(4545),
    [sym_binary_expression] = STATE(4545),
    [sym_update_expression] = STATE(4545),
    [sym_cast_expression] = STATE(4545),
    [sym_sizeof_expression] = STATE(4545),
    [sym_alignof_expression] = STATE(4545),
    [sym_offsetof_expression] = STATE(4545),
    [sym_generic_expression] = STATE(4545),
    [sym_subscript_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_gnu_asm_expression] = STATE(4545),
    [sym_field_expression] = STATE(4540),
    [sym_compound_literal_expression] = STATE(4545),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_char_literal] = STATE(4286),
    [sym_concatenated_string] = STATE(4290),
    [sym_string_literal] = STATE(3166),
    [sym_null] = STATE(4545),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9673),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4545),
    [sym_raw_string_literal] = STATE(3169),
    [sym_co_await_expression] = STATE(4545),
    [sym_new_expression] = STATE(4545),
    [sym_delete_expression] = STATE(4545),
    [sym_requires_clause] = STATE(4545),
    [sym_requires_expression] = STATE(4545),
    [sym_lambda_expression] = STATE(4545),
    [sym_lambda_capture_specifier] = STATE(7034),
    [sym_fold_expression] = STATE(4545),
    [sym_parameter_pack_expansion] = STATE(4545),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4540),
    [sym_qualified_type_identifier] = STATE(9673),
    [sym_user_defined_literal] = STATE(4540),
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_LPAREN2] = ACTIONS(5828),
    [anon_sym_BANG] = ACTIONS(4733),
    [anon_sym_TILDE] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4731),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4735),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4739),
    [anon_sym_not] = ACTIONS(4731),
    [anon_sym_compl] = ACTIONS(4731),
    [anon_sym_DASH_DASH] = ACTIONS(5711),
    [anon_sym_PLUS_PLUS] = ACTIONS(5711),
    [anon_sym_sizeof] = ACTIONS(4741),
    [anon_sym___alignof__] = ACTIONS(4743),
    [anon_sym___alignof] = ACTIONS(4743),
    [anon_sym__alignof] = ACTIONS(4743),
    [anon_sym_alignof] = ACTIONS(4743),
    [anon_sym__Alignof] = ACTIONS(4743),
    [anon_sym_offsetof] = ACTIONS(4745),
    [anon_sym__Generic] = ACTIONS(4747),
    [anon_sym_asm] = ACTIONS(4749),
    [anon_sym___asm__] = ACTIONS(4749),
    [sym_number_literal] = ACTIONS(4751),
    [anon_sym_L_SQUOTE] = ACTIONS(4753),
    [anon_sym_u_SQUOTE] = ACTIONS(4753),
    [anon_sym_U_SQUOTE] = ACTIONS(4753),
    [anon_sym_u8_SQUOTE] = ACTIONS(4753),
    [anon_sym_SQUOTE] = ACTIONS(4753),
    [anon_sym_L_DQUOTE] = ACTIONS(4755),
    [anon_sym_u_DQUOTE] = ACTIONS(4755),
    [anon_sym_U_DQUOTE] = ACTIONS(4755),
    [anon_sym_u8_DQUOTE] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [anon_sym_NULL] = ACTIONS(4759),
    [anon_sym_nullptr] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4761),
    [anon_sym_R_DQUOTE] = ACTIONS(4763),
    [anon_sym_LR_DQUOTE] = ACTIONS(4763),
    [anon_sym_uR_DQUOTE] = ACTIONS(4763),
    [anon_sym_UR_DQUOTE] = ACTIONS(4763),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4763),
    [anon_sym_co_await] = ACTIONS(4765),
    [anon_sym_new] = ACTIONS(4767),
    [anon_sym_requires] = ACTIONS(4769),
    [sym_this] = ACTIONS(4757),
  },
  [2130] = {
    [sym_expression] = STATE(3213),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(4134),
    [sym_concatenated_string] = STATE(4159),
    [sym_string_literal] = STATE(3152),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(3145),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4587),
    [anon_sym_LPAREN2] = ACTIONS(5819),
    [anon_sym_BANG] = ACTIONS(4591),
    [anon_sym_TILDE] = ACTIONS(4591),
    [anon_sym_DASH] = ACTIONS(4589),
    [anon_sym_PLUS] = ACTIONS(4589),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4593),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4589),
    [anon_sym_compl] = ACTIONS(4589),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_sizeof] = ACTIONS(4595),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4597),
    [anon_sym_L_SQUOTE] = ACTIONS(4599),
    [anon_sym_u_SQUOTE] = ACTIONS(4599),
    [anon_sym_U_SQUOTE] = ACTIONS(4599),
    [anon_sym_u8_SQUOTE] = ACTIONS(4599),
    [anon_sym_SQUOTE] = ACTIONS(4599),
    [anon_sym_L_DQUOTE] = ACTIONS(4601),
    [anon_sym_u_DQUOTE] = ACTIONS(4601),
    [anon_sym_U_DQUOTE] = ACTIONS(4601),
    [anon_sym_u8_DQUOTE] = ACTIONS(4601),
    [anon_sym_DQUOTE] = ACTIONS(4601),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4603),
    [anon_sym_R_DQUOTE] = ACTIONS(4605),
    [anon_sym_LR_DQUOTE] = ACTIONS(4605),
    [anon_sym_uR_DQUOTE] = ACTIONS(4605),
    [anon_sym_UR_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4605),
    [anon_sym_co_await] = ACTIONS(4607),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2131] = {
    [sym_expression] = STATE(5376),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2132] = {
    [sym_expression] = STATE(4599),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(6096),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2133] = {
    [sym_expression] = STATE(3224),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(4134),
    [sym_concatenated_string] = STATE(4159),
    [sym_string_literal] = STATE(3152),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(3145),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4587),
    [anon_sym_LPAREN2] = ACTIONS(5819),
    [anon_sym_BANG] = ACTIONS(4591),
    [anon_sym_TILDE] = ACTIONS(4591),
    [anon_sym_DASH] = ACTIONS(4589),
    [anon_sym_PLUS] = ACTIONS(4589),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4593),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4589),
    [anon_sym_compl] = ACTIONS(4589),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_sizeof] = ACTIONS(4595),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4597),
    [anon_sym_L_SQUOTE] = ACTIONS(4599),
    [anon_sym_u_SQUOTE] = ACTIONS(4599),
    [anon_sym_U_SQUOTE] = ACTIONS(4599),
    [anon_sym_u8_SQUOTE] = ACTIONS(4599),
    [anon_sym_SQUOTE] = ACTIONS(4599),
    [anon_sym_L_DQUOTE] = ACTIONS(4601),
    [anon_sym_u_DQUOTE] = ACTIONS(4601),
    [anon_sym_U_DQUOTE] = ACTIONS(4601),
    [anon_sym_u8_DQUOTE] = ACTIONS(4601),
    [anon_sym_DQUOTE] = ACTIONS(4601),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4603),
    [anon_sym_R_DQUOTE] = ACTIONS(4605),
    [anon_sym_LR_DQUOTE] = ACTIONS(4605),
    [anon_sym_uR_DQUOTE] = ACTIONS(4605),
    [anon_sym_UR_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4605),
    [anon_sym_co_await] = ACTIONS(4607),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2134] = {
    [sym_expression] = STATE(4886),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4905),
    [sym_concatenated_string] = STATE(4902),
    [sym_string_literal] = STATE(3611),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3610),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(5705),
    [anon_sym_LPAREN2] = ACTIONS(5834),
    [anon_sym_BANG] = ACTIONS(4926),
    [anon_sym_TILDE] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4928),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4924),
    [anon_sym_compl] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(5707),
    [anon_sym_PLUS_PLUS] = ACTIONS(5707),
    [anon_sym_sizeof] = ACTIONS(4932),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4934),
    [anon_sym_L_SQUOTE] = ACTIONS(4936),
    [anon_sym_u_SQUOTE] = ACTIONS(4936),
    [anon_sym_U_SQUOTE] = ACTIONS(4936),
    [anon_sym_u8_SQUOTE] = ACTIONS(4936),
    [anon_sym_SQUOTE] = ACTIONS(4936),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4938),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_co_await] = ACTIONS(4940),
    [anon_sym_new] = ACTIONS(4942),
    [anon_sym_requires] = ACTIONS(4944),
    [sym_this] = ACTIONS(241),
  },
  [2135] = {
    [sym_expression] = STATE(5213),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2136] = {
    [sym_identifier] = ACTIONS(5622),
    [aux_sym_preproc_def_token1] = ACTIONS(5622),
    [aux_sym_preproc_if_token1] = ACTIONS(5622),
    [aux_sym_preproc_if_token2] = ACTIONS(5622),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5622),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5622),
    [sym_preproc_directive] = ACTIONS(5622),
    [anon_sym_LPAREN2] = ACTIONS(5624),
    [anon_sym_TILDE] = ACTIONS(5624),
    [anon_sym_STAR] = ACTIONS(5624),
    [anon_sym_AMP_AMP] = ACTIONS(5624),
    [anon_sym_AMP] = ACTIONS(5622),
    [anon_sym___extension__] = ACTIONS(5622),
    [anon_sym_typedef] = ACTIONS(5622),
    [anon_sym_in] = ACTIONS(5622),
    [anon_sym_out] = ACTIONS(5622),
    [anon_sym_inout] = ACTIONS(5622),
    [anon_sym_extern] = ACTIONS(5622),
    [anon_sym___attribute__] = ACTIONS(5622),
    [anon_sym_COLON_COLON] = ACTIONS(5624),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5624),
    [anon_sym___declspec] = ACTIONS(5622),
    [anon_sym___based] = ACTIONS(5622),
    [anon_sym_signed] = ACTIONS(5622),
    [anon_sym_unsigned] = ACTIONS(5622),
    [anon_sym_long] = ACTIONS(5622),
    [anon_sym_short] = ACTIONS(5622),
    [anon_sym_LBRACK] = ACTIONS(5622),
    [anon_sym_static] = ACTIONS(5622),
    [anon_sym_register] = ACTIONS(5622),
    [anon_sym_inline] = ACTIONS(5622),
    [anon_sym___inline] = ACTIONS(5622),
    [anon_sym___inline__] = ACTIONS(5622),
    [anon_sym___forceinline] = ACTIONS(5622),
    [anon_sym_thread_local] = ACTIONS(5622),
    [anon_sym___thread] = ACTIONS(5622),
    [anon_sym_const] = ACTIONS(5622),
    [anon_sym_constexpr] = ACTIONS(5622),
    [anon_sym_volatile] = ACTIONS(5622),
    [anon_sym_restrict] = ACTIONS(5622),
    [anon_sym___restrict__] = ACTIONS(5622),
    [anon_sym__Atomic] = ACTIONS(5622),
    [anon_sym__Noreturn] = ACTIONS(5622),
    [anon_sym_noreturn] = ACTIONS(5622),
    [anon_sym_mutable] = ACTIONS(5622),
    [anon_sym_constinit] = ACTIONS(5622),
    [anon_sym_consteval] = ACTIONS(5622),
    [anon_sym_alignas] = ACTIONS(5622),
    [anon_sym__Alignas] = ACTIONS(5622),
    [sym_primitive_type] = ACTIONS(5622),
    [anon_sym_enum] = ACTIONS(5622),
    [anon_sym_class] = ACTIONS(5622),
    [anon_sym_struct] = ACTIONS(5622),
    [anon_sym_union] = ACTIONS(5622),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5622),
    [anon_sym_let] = ACTIONS(5622),
    [anon_sym_This] = ACTIONS(5622),
    [anon_sym_decltype] = ACTIONS(5622),
    [sym_virtual] = ACTIONS(5622),
    [anon_sym_explicit] = ACTIONS(5622),
    [anon_sym_typename] = ACTIONS(5622),
    [anon_sym_template] = ACTIONS(5622),
    [anon_sym_operator] = ACTIONS(5622),
    [anon_sym_friend] = ACTIONS(5622),
    [anon_sym_public] = ACTIONS(5622),
    [anon_sym_private] = ACTIONS(5622),
    [anon_sym_protected] = ACTIONS(5622),
    [anon_sym_using] = ACTIONS(5622),
    [anon_sym_static_assert] = ACTIONS(5622),
    [anon_sym_precise] = ACTIONS(5622),
    [anon_sym_shared] = ACTIONS(5622),
    [anon_sym_groupshared] = ACTIONS(5622),
    [anon_sym_uniform] = ACTIONS(5622),
    [anon_sym_row_major] = ACTIONS(5622),
    [anon_sym_column_major] = ACTIONS(5622),
    [anon_sym_globallycoherent] = ACTIONS(5622),
    [anon_sym_centroid] = ACTIONS(5622),
    [anon_sym_noperspective] = ACTIONS(5622),
    [anon_sym_nointerpolation] = ACTIONS(5622),
    [anon_sym_sample] = ACTIONS(5622),
    [anon_sym_linear] = ACTIONS(5622),
    [anon_sym_snorm] = ACTIONS(5622),
    [anon_sym_unorm] = ACTIONS(5622),
    [anon_sym_point] = ACTIONS(5622),
    [anon_sym_line] = ACTIONS(5622),
    [anon_sym_triangleadj] = ACTIONS(5622),
    [anon_sym_lineadj] = ACTIONS(5622),
    [anon_sym_triangle] = ACTIONS(5622),
    [anon_sym_interface] = ACTIONS(5622),
    [anon_sym_extension] = ACTIONS(5622),
    [anon_sym___init] = ACTIONS(5622),
    [anon_sym___subscript] = ACTIONS(5622),
    [anon_sym_property] = ACTIONS(5622),
    [anon_sym_associatedtype] = ACTIONS(5622),
  },
  [2137] = {
    [sym_identifier] = ACTIONS(3613),
    [aux_sym_preproc_def_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token2] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3613),
    [sym_preproc_directive] = ACTIONS(3613),
    [anon_sym_LPAREN2] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym___extension__] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3613),
    [anon_sym_in] = ACTIONS(3613),
    [anon_sym_out] = ACTIONS(3613),
    [anon_sym_inout] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym___attribute__] = ACTIONS(3613),
    [anon_sym_COLON_COLON] = ACTIONS(3615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3615),
    [anon_sym___declspec] = ACTIONS(3613),
    [anon_sym___based] = ACTIONS(3613),
    [anon_sym_signed] = ACTIONS(3613),
    [anon_sym_unsigned] = ACTIONS(3613),
    [anon_sym_long] = ACTIONS(3613),
    [anon_sym_short] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_register] = ACTIONS(3613),
    [anon_sym_inline] = ACTIONS(3613),
    [anon_sym___inline] = ACTIONS(3613),
    [anon_sym___inline__] = ACTIONS(3613),
    [anon_sym___forceinline] = ACTIONS(3613),
    [anon_sym_thread_local] = ACTIONS(3613),
    [anon_sym___thread] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_constexpr] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_restrict] = ACTIONS(3613),
    [anon_sym___restrict__] = ACTIONS(3613),
    [anon_sym__Atomic] = ACTIONS(3613),
    [anon_sym__Noreturn] = ACTIONS(3613),
    [anon_sym_noreturn] = ACTIONS(3613),
    [anon_sym_mutable] = ACTIONS(3613),
    [anon_sym_constinit] = ACTIONS(3613),
    [anon_sym_consteval] = ACTIONS(3613),
    [anon_sym_alignas] = ACTIONS(3613),
    [anon_sym__Alignas] = ACTIONS(3613),
    [sym_primitive_type] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_union] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_This] = ACTIONS(3613),
    [anon_sym_decltype] = ACTIONS(3613),
    [sym_virtual] = ACTIONS(3613),
    [anon_sym_explicit] = ACTIONS(3613),
    [anon_sym_typename] = ACTIONS(3613),
    [anon_sym_template] = ACTIONS(3613),
    [anon_sym_operator] = ACTIONS(3613),
    [anon_sym_friend] = ACTIONS(3613),
    [anon_sym_public] = ACTIONS(3613),
    [anon_sym_private] = ACTIONS(3613),
    [anon_sym_protected] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_static_assert] = ACTIONS(3613),
    [anon_sym_precise] = ACTIONS(3613),
    [anon_sym_shared] = ACTIONS(3613),
    [anon_sym_groupshared] = ACTIONS(3613),
    [anon_sym_uniform] = ACTIONS(3613),
    [anon_sym_row_major] = ACTIONS(3613),
    [anon_sym_column_major] = ACTIONS(3613),
    [anon_sym_globallycoherent] = ACTIONS(3613),
    [anon_sym_centroid] = ACTIONS(3613),
    [anon_sym_noperspective] = ACTIONS(3613),
    [anon_sym_nointerpolation] = ACTIONS(3613),
    [anon_sym_sample] = ACTIONS(3613),
    [anon_sym_linear] = ACTIONS(3613),
    [anon_sym_snorm] = ACTIONS(3613),
    [anon_sym_unorm] = ACTIONS(3613),
    [anon_sym_point] = ACTIONS(3613),
    [anon_sym_line] = ACTIONS(3613),
    [anon_sym_triangleadj] = ACTIONS(3613),
    [anon_sym_lineadj] = ACTIONS(3613),
    [anon_sym_triangle] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_extension] = ACTIONS(3613),
    [anon_sym___init] = ACTIONS(3613),
    [anon_sym___subscript] = ACTIONS(3613),
    [anon_sym_property] = ACTIONS(3613),
    [anon_sym_associatedtype] = ACTIONS(3613),
  },
  [2138] = {
    [sym_identifier] = ACTIONS(5618),
    [aux_sym_preproc_def_token1] = ACTIONS(5618),
    [aux_sym_preproc_if_token1] = ACTIONS(5618),
    [aux_sym_preproc_if_token2] = ACTIONS(5618),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5618),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5618),
    [sym_preproc_directive] = ACTIONS(5618),
    [anon_sym_LPAREN2] = ACTIONS(5620),
    [anon_sym_TILDE] = ACTIONS(5620),
    [anon_sym_STAR] = ACTIONS(5620),
    [anon_sym_AMP_AMP] = ACTIONS(5620),
    [anon_sym_AMP] = ACTIONS(5618),
    [anon_sym___extension__] = ACTIONS(5618),
    [anon_sym_typedef] = ACTIONS(5618),
    [anon_sym_in] = ACTIONS(5618),
    [anon_sym_out] = ACTIONS(5618),
    [anon_sym_inout] = ACTIONS(5618),
    [anon_sym_extern] = ACTIONS(5618),
    [anon_sym___attribute__] = ACTIONS(5618),
    [anon_sym_COLON_COLON] = ACTIONS(5620),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5620),
    [anon_sym___declspec] = ACTIONS(5618),
    [anon_sym___based] = ACTIONS(5618),
    [anon_sym_signed] = ACTIONS(5618),
    [anon_sym_unsigned] = ACTIONS(5618),
    [anon_sym_long] = ACTIONS(5618),
    [anon_sym_short] = ACTIONS(5618),
    [anon_sym_LBRACK] = ACTIONS(5618),
    [anon_sym_static] = ACTIONS(5618),
    [anon_sym_register] = ACTIONS(5618),
    [anon_sym_inline] = ACTIONS(5618),
    [anon_sym___inline] = ACTIONS(5618),
    [anon_sym___inline__] = ACTIONS(5618),
    [anon_sym___forceinline] = ACTIONS(5618),
    [anon_sym_thread_local] = ACTIONS(5618),
    [anon_sym___thread] = ACTIONS(5618),
    [anon_sym_const] = ACTIONS(5618),
    [anon_sym_constexpr] = ACTIONS(5618),
    [anon_sym_volatile] = ACTIONS(5618),
    [anon_sym_restrict] = ACTIONS(5618),
    [anon_sym___restrict__] = ACTIONS(5618),
    [anon_sym__Atomic] = ACTIONS(5618),
    [anon_sym__Noreturn] = ACTIONS(5618),
    [anon_sym_noreturn] = ACTIONS(5618),
    [anon_sym_mutable] = ACTIONS(5618),
    [anon_sym_constinit] = ACTIONS(5618),
    [anon_sym_consteval] = ACTIONS(5618),
    [anon_sym_alignas] = ACTIONS(5618),
    [anon_sym__Alignas] = ACTIONS(5618),
    [sym_primitive_type] = ACTIONS(5618),
    [anon_sym_enum] = ACTIONS(5618),
    [anon_sym_class] = ACTIONS(5618),
    [anon_sym_struct] = ACTIONS(5618),
    [anon_sym_union] = ACTIONS(5618),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5618),
    [anon_sym_let] = ACTIONS(5618),
    [anon_sym_This] = ACTIONS(5618),
    [anon_sym_decltype] = ACTIONS(5618),
    [sym_virtual] = ACTIONS(5618),
    [anon_sym_explicit] = ACTIONS(5618),
    [anon_sym_typename] = ACTIONS(5618),
    [anon_sym_template] = ACTIONS(5618),
    [anon_sym_operator] = ACTIONS(5618),
    [anon_sym_friend] = ACTIONS(5618),
    [anon_sym_public] = ACTIONS(5618),
    [anon_sym_private] = ACTIONS(5618),
    [anon_sym_protected] = ACTIONS(5618),
    [anon_sym_using] = ACTIONS(5618),
    [anon_sym_static_assert] = ACTIONS(5618),
    [anon_sym_precise] = ACTIONS(5618),
    [anon_sym_shared] = ACTIONS(5618),
    [anon_sym_groupshared] = ACTIONS(5618),
    [anon_sym_uniform] = ACTIONS(5618),
    [anon_sym_row_major] = ACTIONS(5618),
    [anon_sym_column_major] = ACTIONS(5618),
    [anon_sym_globallycoherent] = ACTIONS(5618),
    [anon_sym_centroid] = ACTIONS(5618),
    [anon_sym_noperspective] = ACTIONS(5618),
    [anon_sym_nointerpolation] = ACTIONS(5618),
    [anon_sym_sample] = ACTIONS(5618),
    [anon_sym_linear] = ACTIONS(5618),
    [anon_sym_snorm] = ACTIONS(5618),
    [anon_sym_unorm] = ACTIONS(5618),
    [anon_sym_point] = ACTIONS(5618),
    [anon_sym_line] = ACTIONS(5618),
    [anon_sym_triangleadj] = ACTIONS(5618),
    [anon_sym_lineadj] = ACTIONS(5618),
    [anon_sym_triangle] = ACTIONS(5618),
    [anon_sym_interface] = ACTIONS(5618),
    [anon_sym_extension] = ACTIONS(5618),
    [anon_sym___init] = ACTIONS(5618),
    [anon_sym___subscript] = ACTIONS(5618),
    [anon_sym_property] = ACTIONS(5618),
    [anon_sym_associatedtype] = ACTIONS(5618),
  },
  [2139] = {
    [sym_identifier] = ACTIONS(5614),
    [aux_sym_preproc_def_token1] = ACTIONS(5614),
    [aux_sym_preproc_if_token1] = ACTIONS(5614),
    [aux_sym_preproc_if_token2] = ACTIONS(5614),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5614),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5614),
    [sym_preproc_directive] = ACTIONS(5614),
    [anon_sym_LPAREN2] = ACTIONS(5616),
    [anon_sym_TILDE] = ACTIONS(5616),
    [anon_sym_STAR] = ACTIONS(5616),
    [anon_sym_AMP_AMP] = ACTIONS(5616),
    [anon_sym_AMP] = ACTIONS(5614),
    [anon_sym___extension__] = ACTIONS(5614),
    [anon_sym_typedef] = ACTIONS(5614),
    [anon_sym_in] = ACTIONS(5614),
    [anon_sym_out] = ACTIONS(5614),
    [anon_sym_inout] = ACTIONS(5614),
    [anon_sym_extern] = ACTIONS(5614),
    [anon_sym___attribute__] = ACTIONS(5614),
    [anon_sym_COLON_COLON] = ACTIONS(5616),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5616),
    [anon_sym___declspec] = ACTIONS(5614),
    [anon_sym___based] = ACTIONS(5614),
    [anon_sym_signed] = ACTIONS(5614),
    [anon_sym_unsigned] = ACTIONS(5614),
    [anon_sym_long] = ACTIONS(5614),
    [anon_sym_short] = ACTIONS(5614),
    [anon_sym_LBRACK] = ACTIONS(5614),
    [anon_sym_static] = ACTIONS(5614),
    [anon_sym_register] = ACTIONS(5614),
    [anon_sym_inline] = ACTIONS(5614),
    [anon_sym___inline] = ACTIONS(5614),
    [anon_sym___inline__] = ACTIONS(5614),
    [anon_sym___forceinline] = ACTIONS(5614),
    [anon_sym_thread_local] = ACTIONS(5614),
    [anon_sym___thread] = ACTIONS(5614),
    [anon_sym_const] = ACTIONS(5614),
    [anon_sym_constexpr] = ACTIONS(5614),
    [anon_sym_volatile] = ACTIONS(5614),
    [anon_sym_restrict] = ACTIONS(5614),
    [anon_sym___restrict__] = ACTIONS(5614),
    [anon_sym__Atomic] = ACTIONS(5614),
    [anon_sym__Noreturn] = ACTIONS(5614),
    [anon_sym_noreturn] = ACTIONS(5614),
    [anon_sym_mutable] = ACTIONS(5614),
    [anon_sym_constinit] = ACTIONS(5614),
    [anon_sym_consteval] = ACTIONS(5614),
    [anon_sym_alignas] = ACTIONS(5614),
    [anon_sym__Alignas] = ACTIONS(5614),
    [sym_primitive_type] = ACTIONS(5614),
    [anon_sym_enum] = ACTIONS(5614),
    [anon_sym_class] = ACTIONS(5614),
    [anon_sym_struct] = ACTIONS(5614),
    [anon_sym_union] = ACTIONS(5614),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5614),
    [anon_sym_let] = ACTIONS(5614),
    [anon_sym_This] = ACTIONS(5614),
    [anon_sym_decltype] = ACTIONS(5614),
    [sym_virtual] = ACTIONS(5614),
    [anon_sym_explicit] = ACTIONS(5614),
    [anon_sym_typename] = ACTIONS(5614),
    [anon_sym_template] = ACTIONS(5614),
    [anon_sym_operator] = ACTIONS(5614),
    [anon_sym_friend] = ACTIONS(5614),
    [anon_sym_public] = ACTIONS(5614),
    [anon_sym_private] = ACTIONS(5614),
    [anon_sym_protected] = ACTIONS(5614),
    [anon_sym_using] = ACTIONS(5614),
    [anon_sym_static_assert] = ACTIONS(5614),
    [anon_sym_precise] = ACTIONS(5614),
    [anon_sym_shared] = ACTIONS(5614),
    [anon_sym_groupshared] = ACTIONS(5614),
    [anon_sym_uniform] = ACTIONS(5614),
    [anon_sym_row_major] = ACTIONS(5614),
    [anon_sym_column_major] = ACTIONS(5614),
    [anon_sym_globallycoherent] = ACTIONS(5614),
    [anon_sym_centroid] = ACTIONS(5614),
    [anon_sym_noperspective] = ACTIONS(5614),
    [anon_sym_nointerpolation] = ACTIONS(5614),
    [anon_sym_sample] = ACTIONS(5614),
    [anon_sym_linear] = ACTIONS(5614),
    [anon_sym_snorm] = ACTIONS(5614),
    [anon_sym_unorm] = ACTIONS(5614),
    [anon_sym_point] = ACTIONS(5614),
    [anon_sym_line] = ACTIONS(5614),
    [anon_sym_triangleadj] = ACTIONS(5614),
    [anon_sym_lineadj] = ACTIONS(5614),
    [anon_sym_triangle] = ACTIONS(5614),
    [anon_sym_interface] = ACTIONS(5614),
    [anon_sym_extension] = ACTIONS(5614),
    [anon_sym___init] = ACTIONS(5614),
    [anon_sym___subscript] = ACTIONS(5614),
    [anon_sym_property] = ACTIONS(5614),
    [anon_sym_associatedtype] = ACTIONS(5614),
  },
  [2140] = {
    [sym_identifier] = ACTIONS(3613),
    [aux_sym_preproc_def_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token2] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3613),
    [sym_preproc_directive] = ACTIONS(3613),
    [anon_sym_LPAREN2] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym___extension__] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3613),
    [anon_sym_in] = ACTIONS(3613),
    [anon_sym_out] = ACTIONS(3613),
    [anon_sym_inout] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym___attribute__] = ACTIONS(3613),
    [anon_sym_COLON_COLON] = ACTIONS(3615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3615),
    [anon_sym___declspec] = ACTIONS(3613),
    [anon_sym___based] = ACTIONS(3613),
    [anon_sym_signed] = ACTIONS(3613),
    [anon_sym_unsigned] = ACTIONS(3613),
    [anon_sym_long] = ACTIONS(3613),
    [anon_sym_short] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_register] = ACTIONS(3613),
    [anon_sym_inline] = ACTIONS(3613),
    [anon_sym___inline] = ACTIONS(3613),
    [anon_sym___inline__] = ACTIONS(3613),
    [anon_sym___forceinline] = ACTIONS(3613),
    [anon_sym_thread_local] = ACTIONS(3613),
    [anon_sym___thread] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_constexpr] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_restrict] = ACTIONS(3613),
    [anon_sym___restrict__] = ACTIONS(3613),
    [anon_sym__Atomic] = ACTIONS(3613),
    [anon_sym__Noreturn] = ACTIONS(3613),
    [anon_sym_noreturn] = ACTIONS(3613),
    [anon_sym_mutable] = ACTIONS(3613),
    [anon_sym_constinit] = ACTIONS(3613),
    [anon_sym_consteval] = ACTIONS(3613),
    [anon_sym_alignas] = ACTIONS(3613),
    [anon_sym__Alignas] = ACTIONS(3613),
    [sym_primitive_type] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_union] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_This] = ACTIONS(3613),
    [anon_sym_decltype] = ACTIONS(3613),
    [sym_virtual] = ACTIONS(3613),
    [anon_sym_explicit] = ACTIONS(3613),
    [anon_sym_typename] = ACTIONS(3613),
    [anon_sym_template] = ACTIONS(3613),
    [anon_sym_operator] = ACTIONS(3613),
    [anon_sym_friend] = ACTIONS(3613),
    [anon_sym_public] = ACTIONS(3613),
    [anon_sym_private] = ACTIONS(3613),
    [anon_sym_protected] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_static_assert] = ACTIONS(3613),
    [anon_sym_precise] = ACTIONS(3613),
    [anon_sym_shared] = ACTIONS(3613),
    [anon_sym_groupshared] = ACTIONS(3613),
    [anon_sym_uniform] = ACTIONS(3613),
    [anon_sym_row_major] = ACTIONS(3613),
    [anon_sym_column_major] = ACTIONS(3613),
    [anon_sym_globallycoherent] = ACTIONS(3613),
    [anon_sym_centroid] = ACTIONS(3613),
    [anon_sym_noperspective] = ACTIONS(3613),
    [anon_sym_nointerpolation] = ACTIONS(3613),
    [anon_sym_sample] = ACTIONS(3613),
    [anon_sym_linear] = ACTIONS(3613),
    [anon_sym_snorm] = ACTIONS(3613),
    [anon_sym_unorm] = ACTIONS(3613),
    [anon_sym_point] = ACTIONS(3613),
    [anon_sym_line] = ACTIONS(3613),
    [anon_sym_triangleadj] = ACTIONS(3613),
    [anon_sym_lineadj] = ACTIONS(3613),
    [anon_sym_triangle] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_extension] = ACTIONS(3613),
    [anon_sym___init] = ACTIONS(3613),
    [anon_sym___subscript] = ACTIONS(3613),
    [anon_sym_property] = ACTIONS(3613),
    [anon_sym_associatedtype] = ACTIONS(3613),
  },
  [2141] = {
    [sym_identifier] = ACTIONS(5610),
    [aux_sym_preproc_def_token1] = ACTIONS(5610),
    [aux_sym_preproc_if_token1] = ACTIONS(5610),
    [aux_sym_preproc_if_token2] = ACTIONS(5610),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5610),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5610),
    [sym_preproc_directive] = ACTIONS(5610),
    [anon_sym_LPAREN2] = ACTIONS(5612),
    [anon_sym_TILDE] = ACTIONS(5612),
    [anon_sym_STAR] = ACTIONS(5612),
    [anon_sym_AMP_AMP] = ACTIONS(5612),
    [anon_sym_AMP] = ACTIONS(5610),
    [anon_sym___extension__] = ACTIONS(5610),
    [anon_sym_typedef] = ACTIONS(5610),
    [anon_sym_in] = ACTIONS(5610),
    [anon_sym_out] = ACTIONS(5610),
    [anon_sym_inout] = ACTIONS(5610),
    [anon_sym_extern] = ACTIONS(5610),
    [anon_sym___attribute__] = ACTIONS(5610),
    [anon_sym_COLON_COLON] = ACTIONS(5612),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5612),
    [anon_sym___declspec] = ACTIONS(5610),
    [anon_sym___based] = ACTIONS(5610),
    [anon_sym_signed] = ACTIONS(5610),
    [anon_sym_unsigned] = ACTIONS(5610),
    [anon_sym_long] = ACTIONS(5610),
    [anon_sym_short] = ACTIONS(5610),
    [anon_sym_LBRACK] = ACTIONS(5610),
    [anon_sym_static] = ACTIONS(5610),
    [anon_sym_register] = ACTIONS(5610),
    [anon_sym_inline] = ACTIONS(5610),
    [anon_sym___inline] = ACTIONS(5610),
    [anon_sym___inline__] = ACTIONS(5610),
    [anon_sym___forceinline] = ACTIONS(5610),
    [anon_sym_thread_local] = ACTIONS(5610),
    [anon_sym___thread] = ACTIONS(5610),
    [anon_sym_const] = ACTIONS(5610),
    [anon_sym_constexpr] = ACTIONS(5610),
    [anon_sym_volatile] = ACTIONS(5610),
    [anon_sym_restrict] = ACTIONS(5610),
    [anon_sym___restrict__] = ACTIONS(5610),
    [anon_sym__Atomic] = ACTIONS(5610),
    [anon_sym__Noreturn] = ACTIONS(5610),
    [anon_sym_noreturn] = ACTIONS(5610),
    [anon_sym_mutable] = ACTIONS(5610),
    [anon_sym_constinit] = ACTIONS(5610),
    [anon_sym_consteval] = ACTIONS(5610),
    [anon_sym_alignas] = ACTIONS(5610),
    [anon_sym__Alignas] = ACTIONS(5610),
    [sym_primitive_type] = ACTIONS(5610),
    [anon_sym_enum] = ACTIONS(5610),
    [anon_sym_class] = ACTIONS(5610),
    [anon_sym_struct] = ACTIONS(5610),
    [anon_sym_union] = ACTIONS(5610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5610),
    [anon_sym_let] = ACTIONS(5610),
    [anon_sym_This] = ACTIONS(5610),
    [anon_sym_decltype] = ACTIONS(5610),
    [sym_virtual] = ACTIONS(5610),
    [anon_sym_explicit] = ACTIONS(5610),
    [anon_sym_typename] = ACTIONS(5610),
    [anon_sym_template] = ACTIONS(5610),
    [anon_sym_operator] = ACTIONS(5610),
    [anon_sym_friend] = ACTIONS(5610),
    [anon_sym_public] = ACTIONS(5610),
    [anon_sym_private] = ACTIONS(5610),
    [anon_sym_protected] = ACTIONS(5610),
    [anon_sym_using] = ACTIONS(5610),
    [anon_sym_static_assert] = ACTIONS(5610),
    [anon_sym_precise] = ACTIONS(5610),
    [anon_sym_shared] = ACTIONS(5610),
    [anon_sym_groupshared] = ACTIONS(5610),
    [anon_sym_uniform] = ACTIONS(5610),
    [anon_sym_row_major] = ACTIONS(5610),
    [anon_sym_column_major] = ACTIONS(5610),
    [anon_sym_globallycoherent] = ACTIONS(5610),
    [anon_sym_centroid] = ACTIONS(5610),
    [anon_sym_noperspective] = ACTIONS(5610),
    [anon_sym_nointerpolation] = ACTIONS(5610),
    [anon_sym_sample] = ACTIONS(5610),
    [anon_sym_linear] = ACTIONS(5610),
    [anon_sym_snorm] = ACTIONS(5610),
    [anon_sym_unorm] = ACTIONS(5610),
    [anon_sym_point] = ACTIONS(5610),
    [anon_sym_line] = ACTIONS(5610),
    [anon_sym_triangleadj] = ACTIONS(5610),
    [anon_sym_lineadj] = ACTIONS(5610),
    [anon_sym_triangle] = ACTIONS(5610),
    [anon_sym_interface] = ACTIONS(5610),
    [anon_sym_extension] = ACTIONS(5610),
    [anon_sym___init] = ACTIONS(5610),
    [anon_sym___subscript] = ACTIONS(5610),
    [anon_sym_property] = ACTIONS(5610),
    [anon_sym_associatedtype] = ACTIONS(5610),
  },
  [2142] = {
    [sym_identifier] = ACTIONS(5606),
    [aux_sym_preproc_def_token1] = ACTIONS(5606),
    [aux_sym_preproc_if_token1] = ACTIONS(5606),
    [aux_sym_preproc_if_token2] = ACTIONS(5606),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5606),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5606),
    [sym_preproc_directive] = ACTIONS(5606),
    [anon_sym_LPAREN2] = ACTIONS(5608),
    [anon_sym_TILDE] = ACTIONS(5608),
    [anon_sym_STAR] = ACTIONS(5608),
    [anon_sym_AMP_AMP] = ACTIONS(5608),
    [anon_sym_AMP] = ACTIONS(5606),
    [anon_sym___extension__] = ACTIONS(5606),
    [anon_sym_typedef] = ACTIONS(5606),
    [anon_sym_in] = ACTIONS(5606),
    [anon_sym_out] = ACTIONS(5606),
    [anon_sym_inout] = ACTIONS(5606),
    [anon_sym_extern] = ACTIONS(5606),
    [anon_sym___attribute__] = ACTIONS(5606),
    [anon_sym_COLON_COLON] = ACTIONS(5608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5608),
    [anon_sym___declspec] = ACTIONS(5606),
    [anon_sym___based] = ACTIONS(5606),
    [anon_sym_signed] = ACTIONS(5606),
    [anon_sym_unsigned] = ACTIONS(5606),
    [anon_sym_long] = ACTIONS(5606),
    [anon_sym_short] = ACTIONS(5606),
    [anon_sym_LBRACK] = ACTIONS(5606),
    [anon_sym_static] = ACTIONS(5606),
    [anon_sym_register] = ACTIONS(5606),
    [anon_sym_inline] = ACTIONS(5606),
    [anon_sym___inline] = ACTIONS(5606),
    [anon_sym___inline__] = ACTIONS(5606),
    [anon_sym___forceinline] = ACTIONS(5606),
    [anon_sym_thread_local] = ACTIONS(5606),
    [anon_sym___thread] = ACTIONS(5606),
    [anon_sym_const] = ACTIONS(5606),
    [anon_sym_constexpr] = ACTIONS(5606),
    [anon_sym_volatile] = ACTIONS(5606),
    [anon_sym_restrict] = ACTIONS(5606),
    [anon_sym___restrict__] = ACTIONS(5606),
    [anon_sym__Atomic] = ACTIONS(5606),
    [anon_sym__Noreturn] = ACTIONS(5606),
    [anon_sym_noreturn] = ACTIONS(5606),
    [anon_sym_mutable] = ACTIONS(5606),
    [anon_sym_constinit] = ACTIONS(5606),
    [anon_sym_consteval] = ACTIONS(5606),
    [anon_sym_alignas] = ACTIONS(5606),
    [anon_sym__Alignas] = ACTIONS(5606),
    [sym_primitive_type] = ACTIONS(5606),
    [anon_sym_enum] = ACTIONS(5606),
    [anon_sym_class] = ACTIONS(5606),
    [anon_sym_struct] = ACTIONS(5606),
    [anon_sym_union] = ACTIONS(5606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5606),
    [anon_sym_let] = ACTIONS(5606),
    [anon_sym_This] = ACTIONS(5606),
    [anon_sym_decltype] = ACTIONS(5606),
    [sym_virtual] = ACTIONS(5606),
    [anon_sym_explicit] = ACTIONS(5606),
    [anon_sym_typename] = ACTIONS(5606),
    [anon_sym_template] = ACTIONS(5606),
    [anon_sym_operator] = ACTIONS(5606),
    [anon_sym_friend] = ACTIONS(5606),
    [anon_sym_public] = ACTIONS(5606),
    [anon_sym_private] = ACTIONS(5606),
    [anon_sym_protected] = ACTIONS(5606),
    [anon_sym_using] = ACTIONS(5606),
    [anon_sym_static_assert] = ACTIONS(5606),
    [anon_sym_precise] = ACTIONS(5606),
    [anon_sym_shared] = ACTIONS(5606),
    [anon_sym_groupshared] = ACTIONS(5606),
    [anon_sym_uniform] = ACTIONS(5606),
    [anon_sym_row_major] = ACTIONS(5606),
    [anon_sym_column_major] = ACTIONS(5606),
    [anon_sym_globallycoherent] = ACTIONS(5606),
    [anon_sym_centroid] = ACTIONS(5606),
    [anon_sym_noperspective] = ACTIONS(5606),
    [anon_sym_nointerpolation] = ACTIONS(5606),
    [anon_sym_sample] = ACTIONS(5606),
    [anon_sym_linear] = ACTIONS(5606),
    [anon_sym_snorm] = ACTIONS(5606),
    [anon_sym_unorm] = ACTIONS(5606),
    [anon_sym_point] = ACTIONS(5606),
    [anon_sym_line] = ACTIONS(5606),
    [anon_sym_triangleadj] = ACTIONS(5606),
    [anon_sym_lineadj] = ACTIONS(5606),
    [anon_sym_triangle] = ACTIONS(5606),
    [anon_sym_interface] = ACTIONS(5606),
    [anon_sym_extension] = ACTIONS(5606),
    [anon_sym___init] = ACTIONS(5606),
    [anon_sym___subscript] = ACTIONS(5606),
    [anon_sym_property] = ACTIONS(5606),
    [anon_sym_associatedtype] = ACTIONS(5606),
  },
  [2143] = {
    [sym_identifier] = ACTIONS(5602),
    [aux_sym_preproc_def_token1] = ACTIONS(5602),
    [aux_sym_preproc_if_token1] = ACTIONS(5602),
    [aux_sym_preproc_if_token2] = ACTIONS(5602),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5602),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5602),
    [sym_preproc_directive] = ACTIONS(5602),
    [anon_sym_LPAREN2] = ACTIONS(5604),
    [anon_sym_TILDE] = ACTIONS(5604),
    [anon_sym_STAR] = ACTIONS(5604),
    [anon_sym_AMP_AMP] = ACTIONS(5604),
    [anon_sym_AMP] = ACTIONS(5602),
    [anon_sym___extension__] = ACTIONS(5602),
    [anon_sym_typedef] = ACTIONS(5602),
    [anon_sym_in] = ACTIONS(5602),
    [anon_sym_out] = ACTIONS(5602),
    [anon_sym_inout] = ACTIONS(5602),
    [anon_sym_extern] = ACTIONS(5602),
    [anon_sym___attribute__] = ACTIONS(5602),
    [anon_sym_COLON_COLON] = ACTIONS(5604),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5604),
    [anon_sym___declspec] = ACTIONS(5602),
    [anon_sym___based] = ACTIONS(5602),
    [anon_sym_signed] = ACTIONS(5602),
    [anon_sym_unsigned] = ACTIONS(5602),
    [anon_sym_long] = ACTIONS(5602),
    [anon_sym_short] = ACTIONS(5602),
    [anon_sym_LBRACK] = ACTIONS(5602),
    [anon_sym_static] = ACTIONS(5602),
    [anon_sym_register] = ACTIONS(5602),
    [anon_sym_inline] = ACTIONS(5602),
    [anon_sym___inline] = ACTIONS(5602),
    [anon_sym___inline__] = ACTIONS(5602),
    [anon_sym___forceinline] = ACTIONS(5602),
    [anon_sym_thread_local] = ACTIONS(5602),
    [anon_sym___thread] = ACTIONS(5602),
    [anon_sym_const] = ACTIONS(5602),
    [anon_sym_constexpr] = ACTIONS(5602),
    [anon_sym_volatile] = ACTIONS(5602),
    [anon_sym_restrict] = ACTIONS(5602),
    [anon_sym___restrict__] = ACTIONS(5602),
    [anon_sym__Atomic] = ACTIONS(5602),
    [anon_sym__Noreturn] = ACTIONS(5602),
    [anon_sym_noreturn] = ACTIONS(5602),
    [anon_sym_mutable] = ACTIONS(5602),
    [anon_sym_constinit] = ACTIONS(5602),
    [anon_sym_consteval] = ACTIONS(5602),
    [anon_sym_alignas] = ACTIONS(5602),
    [anon_sym__Alignas] = ACTIONS(5602),
    [sym_primitive_type] = ACTIONS(5602),
    [anon_sym_enum] = ACTIONS(5602),
    [anon_sym_class] = ACTIONS(5602),
    [anon_sym_struct] = ACTIONS(5602),
    [anon_sym_union] = ACTIONS(5602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5602),
    [anon_sym_let] = ACTIONS(5602),
    [anon_sym_This] = ACTIONS(5602),
    [anon_sym_decltype] = ACTIONS(5602),
    [sym_virtual] = ACTIONS(5602),
    [anon_sym_explicit] = ACTIONS(5602),
    [anon_sym_typename] = ACTIONS(5602),
    [anon_sym_template] = ACTIONS(5602),
    [anon_sym_operator] = ACTIONS(5602),
    [anon_sym_friend] = ACTIONS(5602),
    [anon_sym_public] = ACTIONS(5602),
    [anon_sym_private] = ACTIONS(5602),
    [anon_sym_protected] = ACTIONS(5602),
    [anon_sym_using] = ACTIONS(5602),
    [anon_sym_static_assert] = ACTIONS(5602),
    [anon_sym_precise] = ACTIONS(5602),
    [anon_sym_shared] = ACTIONS(5602),
    [anon_sym_groupshared] = ACTIONS(5602),
    [anon_sym_uniform] = ACTIONS(5602),
    [anon_sym_row_major] = ACTIONS(5602),
    [anon_sym_column_major] = ACTIONS(5602),
    [anon_sym_globallycoherent] = ACTIONS(5602),
    [anon_sym_centroid] = ACTIONS(5602),
    [anon_sym_noperspective] = ACTIONS(5602),
    [anon_sym_nointerpolation] = ACTIONS(5602),
    [anon_sym_sample] = ACTIONS(5602),
    [anon_sym_linear] = ACTIONS(5602),
    [anon_sym_snorm] = ACTIONS(5602),
    [anon_sym_unorm] = ACTIONS(5602),
    [anon_sym_point] = ACTIONS(5602),
    [anon_sym_line] = ACTIONS(5602),
    [anon_sym_triangleadj] = ACTIONS(5602),
    [anon_sym_lineadj] = ACTIONS(5602),
    [anon_sym_triangle] = ACTIONS(5602),
    [anon_sym_interface] = ACTIONS(5602),
    [anon_sym_extension] = ACTIONS(5602),
    [anon_sym___init] = ACTIONS(5602),
    [anon_sym___subscript] = ACTIONS(5602),
    [anon_sym_property] = ACTIONS(5602),
    [anon_sym_associatedtype] = ACTIONS(5602),
  },
  [2144] = {
    [sym_identifier] = ACTIONS(5598),
    [aux_sym_preproc_def_token1] = ACTIONS(5598),
    [aux_sym_preproc_if_token1] = ACTIONS(5598),
    [aux_sym_preproc_if_token2] = ACTIONS(5598),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5598),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5598),
    [sym_preproc_directive] = ACTIONS(5598),
    [anon_sym_LPAREN2] = ACTIONS(5600),
    [anon_sym_TILDE] = ACTIONS(5600),
    [anon_sym_STAR] = ACTIONS(5600),
    [anon_sym_AMP_AMP] = ACTIONS(5600),
    [anon_sym_AMP] = ACTIONS(5598),
    [anon_sym___extension__] = ACTIONS(5598),
    [anon_sym_typedef] = ACTIONS(5598),
    [anon_sym_in] = ACTIONS(5598),
    [anon_sym_out] = ACTIONS(5598),
    [anon_sym_inout] = ACTIONS(5598),
    [anon_sym_extern] = ACTIONS(5598),
    [anon_sym___attribute__] = ACTIONS(5598),
    [anon_sym_COLON_COLON] = ACTIONS(5600),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5600),
    [anon_sym___declspec] = ACTIONS(5598),
    [anon_sym___based] = ACTIONS(5598),
    [anon_sym_signed] = ACTIONS(5598),
    [anon_sym_unsigned] = ACTIONS(5598),
    [anon_sym_long] = ACTIONS(5598),
    [anon_sym_short] = ACTIONS(5598),
    [anon_sym_LBRACK] = ACTIONS(5598),
    [anon_sym_static] = ACTIONS(5598),
    [anon_sym_register] = ACTIONS(5598),
    [anon_sym_inline] = ACTIONS(5598),
    [anon_sym___inline] = ACTIONS(5598),
    [anon_sym___inline__] = ACTIONS(5598),
    [anon_sym___forceinline] = ACTIONS(5598),
    [anon_sym_thread_local] = ACTIONS(5598),
    [anon_sym___thread] = ACTIONS(5598),
    [anon_sym_const] = ACTIONS(5598),
    [anon_sym_constexpr] = ACTIONS(5598),
    [anon_sym_volatile] = ACTIONS(5598),
    [anon_sym_restrict] = ACTIONS(5598),
    [anon_sym___restrict__] = ACTIONS(5598),
    [anon_sym__Atomic] = ACTIONS(5598),
    [anon_sym__Noreturn] = ACTIONS(5598),
    [anon_sym_noreturn] = ACTIONS(5598),
    [anon_sym_mutable] = ACTIONS(5598),
    [anon_sym_constinit] = ACTIONS(5598),
    [anon_sym_consteval] = ACTIONS(5598),
    [anon_sym_alignas] = ACTIONS(5598),
    [anon_sym__Alignas] = ACTIONS(5598),
    [sym_primitive_type] = ACTIONS(5598),
    [anon_sym_enum] = ACTIONS(5598),
    [anon_sym_class] = ACTIONS(5598),
    [anon_sym_struct] = ACTIONS(5598),
    [anon_sym_union] = ACTIONS(5598),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5598),
    [anon_sym_let] = ACTIONS(5598),
    [anon_sym_This] = ACTIONS(5598),
    [anon_sym_decltype] = ACTIONS(5598),
    [sym_virtual] = ACTIONS(5598),
    [anon_sym_explicit] = ACTIONS(5598),
    [anon_sym_typename] = ACTIONS(5598),
    [anon_sym_template] = ACTIONS(5598),
    [anon_sym_operator] = ACTIONS(5598),
    [anon_sym_friend] = ACTIONS(5598),
    [anon_sym_public] = ACTIONS(5598),
    [anon_sym_private] = ACTIONS(5598),
    [anon_sym_protected] = ACTIONS(5598),
    [anon_sym_using] = ACTIONS(5598),
    [anon_sym_static_assert] = ACTIONS(5598),
    [anon_sym_precise] = ACTIONS(5598),
    [anon_sym_shared] = ACTIONS(5598),
    [anon_sym_groupshared] = ACTIONS(5598),
    [anon_sym_uniform] = ACTIONS(5598),
    [anon_sym_row_major] = ACTIONS(5598),
    [anon_sym_column_major] = ACTIONS(5598),
    [anon_sym_globallycoherent] = ACTIONS(5598),
    [anon_sym_centroid] = ACTIONS(5598),
    [anon_sym_noperspective] = ACTIONS(5598),
    [anon_sym_nointerpolation] = ACTIONS(5598),
    [anon_sym_sample] = ACTIONS(5598),
    [anon_sym_linear] = ACTIONS(5598),
    [anon_sym_snorm] = ACTIONS(5598),
    [anon_sym_unorm] = ACTIONS(5598),
    [anon_sym_point] = ACTIONS(5598),
    [anon_sym_line] = ACTIONS(5598),
    [anon_sym_triangleadj] = ACTIONS(5598),
    [anon_sym_lineadj] = ACTIONS(5598),
    [anon_sym_triangle] = ACTIONS(5598),
    [anon_sym_interface] = ACTIONS(5598),
    [anon_sym_extension] = ACTIONS(5598),
    [anon_sym___init] = ACTIONS(5598),
    [anon_sym___subscript] = ACTIONS(5598),
    [anon_sym_property] = ACTIONS(5598),
    [anon_sym_associatedtype] = ACTIONS(5598),
  },
  [2145] = {
    [sym_identifier] = ACTIONS(5532),
    [aux_sym_preproc_def_token1] = ACTIONS(5532),
    [aux_sym_preproc_if_token1] = ACTIONS(5532),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5532),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5532),
    [sym_preproc_directive] = ACTIONS(5532),
    [anon_sym_LPAREN2] = ACTIONS(5534),
    [anon_sym_TILDE] = ACTIONS(5534),
    [anon_sym_STAR] = ACTIONS(5534),
    [anon_sym_AMP_AMP] = ACTIONS(5534),
    [anon_sym_AMP] = ACTIONS(5532),
    [anon_sym___extension__] = ACTIONS(5532),
    [anon_sym_typedef] = ACTIONS(5532),
    [anon_sym_in] = ACTIONS(5532),
    [anon_sym_out] = ACTIONS(5532),
    [anon_sym_inout] = ACTIONS(5532),
    [anon_sym_extern] = ACTIONS(5532),
    [anon_sym___attribute__] = ACTIONS(5532),
    [anon_sym_COLON_COLON] = ACTIONS(5534),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5534),
    [anon_sym___declspec] = ACTIONS(5532),
    [anon_sym___based] = ACTIONS(5532),
    [anon_sym_RBRACE] = ACTIONS(5534),
    [anon_sym_signed] = ACTIONS(5532),
    [anon_sym_unsigned] = ACTIONS(5532),
    [anon_sym_long] = ACTIONS(5532),
    [anon_sym_short] = ACTIONS(5532),
    [anon_sym_LBRACK] = ACTIONS(5532),
    [anon_sym_static] = ACTIONS(5532),
    [anon_sym_register] = ACTIONS(5532),
    [anon_sym_inline] = ACTIONS(5532),
    [anon_sym___inline] = ACTIONS(5532),
    [anon_sym___inline__] = ACTIONS(5532),
    [anon_sym___forceinline] = ACTIONS(5532),
    [anon_sym_thread_local] = ACTIONS(5532),
    [anon_sym___thread] = ACTIONS(5532),
    [anon_sym_const] = ACTIONS(5532),
    [anon_sym_constexpr] = ACTIONS(5532),
    [anon_sym_volatile] = ACTIONS(5532),
    [anon_sym_restrict] = ACTIONS(5532),
    [anon_sym___restrict__] = ACTIONS(5532),
    [anon_sym__Atomic] = ACTIONS(5532),
    [anon_sym__Noreturn] = ACTIONS(5532),
    [anon_sym_noreturn] = ACTIONS(5532),
    [anon_sym_mutable] = ACTIONS(5532),
    [anon_sym_constinit] = ACTIONS(5532),
    [anon_sym_consteval] = ACTIONS(5532),
    [anon_sym_alignas] = ACTIONS(5532),
    [anon_sym__Alignas] = ACTIONS(5532),
    [sym_primitive_type] = ACTIONS(5532),
    [anon_sym_enum] = ACTIONS(5532),
    [anon_sym_class] = ACTIONS(5532),
    [anon_sym_struct] = ACTIONS(5532),
    [anon_sym_union] = ACTIONS(5532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5532),
    [anon_sym_let] = ACTIONS(5532),
    [anon_sym_This] = ACTIONS(5532),
    [anon_sym_decltype] = ACTIONS(5532),
    [sym_virtual] = ACTIONS(5532),
    [anon_sym_explicit] = ACTIONS(5532),
    [anon_sym_typename] = ACTIONS(5532),
    [anon_sym_template] = ACTIONS(5532),
    [anon_sym_operator] = ACTIONS(5532),
    [anon_sym_friend] = ACTIONS(5532),
    [anon_sym_public] = ACTIONS(5532),
    [anon_sym_private] = ACTIONS(5532),
    [anon_sym_protected] = ACTIONS(5532),
    [anon_sym_using] = ACTIONS(5532),
    [anon_sym_static_assert] = ACTIONS(5532),
    [anon_sym_precise] = ACTIONS(5532),
    [anon_sym_shared] = ACTIONS(5532),
    [anon_sym_groupshared] = ACTIONS(5532),
    [anon_sym_uniform] = ACTIONS(5532),
    [anon_sym_row_major] = ACTIONS(5532),
    [anon_sym_column_major] = ACTIONS(5532),
    [anon_sym_globallycoherent] = ACTIONS(5532),
    [anon_sym_centroid] = ACTIONS(5532),
    [anon_sym_noperspective] = ACTIONS(5532),
    [anon_sym_nointerpolation] = ACTIONS(5532),
    [anon_sym_sample] = ACTIONS(5532),
    [anon_sym_linear] = ACTIONS(5532),
    [anon_sym_snorm] = ACTIONS(5532),
    [anon_sym_unorm] = ACTIONS(5532),
    [anon_sym_point] = ACTIONS(5532),
    [anon_sym_line] = ACTIONS(5532),
    [anon_sym_triangleadj] = ACTIONS(5532),
    [anon_sym_lineadj] = ACTIONS(5532),
    [anon_sym_triangle] = ACTIONS(5532),
    [anon_sym_interface] = ACTIONS(5532),
    [anon_sym_extension] = ACTIONS(5532),
    [anon_sym___init] = ACTIONS(5532),
    [anon_sym___subscript] = ACTIONS(5532),
    [anon_sym_property] = ACTIONS(5532),
    [anon_sym_associatedtype] = ACTIONS(5532),
  },
  [2146] = {
    [sym_identifier] = ACTIONS(5598),
    [aux_sym_preproc_def_token1] = ACTIONS(5598),
    [aux_sym_preproc_if_token1] = ACTIONS(5598),
    [aux_sym_preproc_if_token2] = ACTIONS(5598),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5598),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5598),
    [sym_preproc_directive] = ACTIONS(5598),
    [anon_sym_LPAREN2] = ACTIONS(5600),
    [anon_sym_TILDE] = ACTIONS(5600),
    [anon_sym_STAR] = ACTIONS(5600),
    [anon_sym_AMP_AMP] = ACTIONS(5600),
    [anon_sym_AMP] = ACTIONS(5598),
    [anon_sym___extension__] = ACTIONS(5598),
    [anon_sym_typedef] = ACTIONS(5598),
    [anon_sym_in] = ACTIONS(5598),
    [anon_sym_out] = ACTIONS(5598),
    [anon_sym_inout] = ACTIONS(5598),
    [anon_sym_extern] = ACTIONS(5598),
    [anon_sym___attribute__] = ACTIONS(5598),
    [anon_sym_COLON_COLON] = ACTIONS(5600),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5600),
    [anon_sym___declspec] = ACTIONS(5598),
    [anon_sym___based] = ACTIONS(5598),
    [anon_sym_signed] = ACTIONS(5598),
    [anon_sym_unsigned] = ACTIONS(5598),
    [anon_sym_long] = ACTIONS(5598),
    [anon_sym_short] = ACTIONS(5598),
    [anon_sym_LBRACK] = ACTIONS(5598),
    [anon_sym_static] = ACTIONS(5598),
    [anon_sym_register] = ACTIONS(5598),
    [anon_sym_inline] = ACTIONS(5598),
    [anon_sym___inline] = ACTIONS(5598),
    [anon_sym___inline__] = ACTIONS(5598),
    [anon_sym___forceinline] = ACTIONS(5598),
    [anon_sym_thread_local] = ACTIONS(5598),
    [anon_sym___thread] = ACTIONS(5598),
    [anon_sym_const] = ACTIONS(5598),
    [anon_sym_constexpr] = ACTIONS(5598),
    [anon_sym_volatile] = ACTIONS(5598),
    [anon_sym_restrict] = ACTIONS(5598),
    [anon_sym___restrict__] = ACTIONS(5598),
    [anon_sym__Atomic] = ACTIONS(5598),
    [anon_sym__Noreturn] = ACTIONS(5598),
    [anon_sym_noreturn] = ACTIONS(5598),
    [anon_sym_mutable] = ACTIONS(5598),
    [anon_sym_constinit] = ACTIONS(5598),
    [anon_sym_consteval] = ACTIONS(5598),
    [anon_sym_alignas] = ACTIONS(5598),
    [anon_sym__Alignas] = ACTIONS(5598),
    [sym_primitive_type] = ACTIONS(5598),
    [anon_sym_enum] = ACTIONS(5598),
    [anon_sym_class] = ACTIONS(5598),
    [anon_sym_struct] = ACTIONS(5598),
    [anon_sym_union] = ACTIONS(5598),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5598),
    [anon_sym_let] = ACTIONS(5598),
    [anon_sym_This] = ACTIONS(5598),
    [anon_sym_decltype] = ACTIONS(5598),
    [sym_virtual] = ACTIONS(5598),
    [anon_sym_explicit] = ACTIONS(5598),
    [anon_sym_typename] = ACTIONS(5598),
    [anon_sym_template] = ACTIONS(5598),
    [anon_sym_operator] = ACTIONS(5598),
    [anon_sym_friend] = ACTIONS(5598),
    [anon_sym_public] = ACTIONS(5598),
    [anon_sym_private] = ACTIONS(5598),
    [anon_sym_protected] = ACTIONS(5598),
    [anon_sym_using] = ACTIONS(5598),
    [anon_sym_static_assert] = ACTIONS(5598),
    [anon_sym_precise] = ACTIONS(5598),
    [anon_sym_shared] = ACTIONS(5598),
    [anon_sym_groupshared] = ACTIONS(5598),
    [anon_sym_uniform] = ACTIONS(5598),
    [anon_sym_row_major] = ACTIONS(5598),
    [anon_sym_column_major] = ACTIONS(5598),
    [anon_sym_globallycoherent] = ACTIONS(5598),
    [anon_sym_centroid] = ACTIONS(5598),
    [anon_sym_noperspective] = ACTIONS(5598),
    [anon_sym_nointerpolation] = ACTIONS(5598),
    [anon_sym_sample] = ACTIONS(5598),
    [anon_sym_linear] = ACTIONS(5598),
    [anon_sym_snorm] = ACTIONS(5598),
    [anon_sym_unorm] = ACTIONS(5598),
    [anon_sym_point] = ACTIONS(5598),
    [anon_sym_line] = ACTIONS(5598),
    [anon_sym_triangleadj] = ACTIONS(5598),
    [anon_sym_lineadj] = ACTIONS(5598),
    [anon_sym_triangle] = ACTIONS(5598),
    [anon_sym_interface] = ACTIONS(5598),
    [anon_sym_extension] = ACTIONS(5598),
    [anon_sym___init] = ACTIONS(5598),
    [anon_sym___subscript] = ACTIONS(5598),
    [anon_sym_property] = ACTIONS(5598),
    [anon_sym_associatedtype] = ACTIONS(5598),
  },
  [2147] = {
    [sym_identifier] = ACTIONS(5594),
    [aux_sym_preproc_def_token1] = ACTIONS(5594),
    [aux_sym_preproc_if_token1] = ACTIONS(5594),
    [aux_sym_preproc_if_token2] = ACTIONS(5594),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5594),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5594),
    [sym_preproc_directive] = ACTIONS(5594),
    [anon_sym_LPAREN2] = ACTIONS(5596),
    [anon_sym_TILDE] = ACTIONS(5596),
    [anon_sym_STAR] = ACTIONS(5596),
    [anon_sym_AMP_AMP] = ACTIONS(5596),
    [anon_sym_AMP] = ACTIONS(5594),
    [anon_sym___extension__] = ACTIONS(5594),
    [anon_sym_typedef] = ACTIONS(5594),
    [anon_sym_in] = ACTIONS(5594),
    [anon_sym_out] = ACTIONS(5594),
    [anon_sym_inout] = ACTIONS(5594),
    [anon_sym_extern] = ACTIONS(5594),
    [anon_sym___attribute__] = ACTIONS(5594),
    [anon_sym_COLON_COLON] = ACTIONS(5596),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5596),
    [anon_sym___declspec] = ACTIONS(5594),
    [anon_sym___based] = ACTIONS(5594),
    [anon_sym_signed] = ACTIONS(5594),
    [anon_sym_unsigned] = ACTIONS(5594),
    [anon_sym_long] = ACTIONS(5594),
    [anon_sym_short] = ACTIONS(5594),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_static] = ACTIONS(5594),
    [anon_sym_register] = ACTIONS(5594),
    [anon_sym_inline] = ACTIONS(5594),
    [anon_sym___inline] = ACTIONS(5594),
    [anon_sym___inline__] = ACTIONS(5594),
    [anon_sym___forceinline] = ACTIONS(5594),
    [anon_sym_thread_local] = ACTIONS(5594),
    [anon_sym___thread] = ACTIONS(5594),
    [anon_sym_const] = ACTIONS(5594),
    [anon_sym_constexpr] = ACTIONS(5594),
    [anon_sym_volatile] = ACTIONS(5594),
    [anon_sym_restrict] = ACTIONS(5594),
    [anon_sym___restrict__] = ACTIONS(5594),
    [anon_sym__Atomic] = ACTIONS(5594),
    [anon_sym__Noreturn] = ACTIONS(5594),
    [anon_sym_noreturn] = ACTIONS(5594),
    [anon_sym_mutable] = ACTIONS(5594),
    [anon_sym_constinit] = ACTIONS(5594),
    [anon_sym_consteval] = ACTIONS(5594),
    [anon_sym_alignas] = ACTIONS(5594),
    [anon_sym__Alignas] = ACTIONS(5594),
    [sym_primitive_type] = ACTIONS(5594),
    [anon_sym_enum] = ACTIONS(5594),
    [anon_sym_class] = ACTIONS(5594),
    [anon_sym_struct] = ACTIONS(5594),
    [anon_sym_union] = ACTIONS(5594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5594),
    [anon_sym_let] = ACTIONS(5594),
    [anon_sym_This] = ACTIONS(5594),
    [anon_sym_decltype] = ACTIONS(5594),
    [sym_virtual] = ACTIONS(5594),
    [anon_sym_explicit] = ACTIONS(5594),
    [anon_sym_typename] = ACTIONS(5594),
    [anon_sym_template] = ACTIONS(5594),
    [anon_sym_operator] = ACTIONS(5594),
    [anon_sym_friend] = ACTIONS(5594),
    [anon_sym_public] = ACTIONS(5594),
    [anon_sym_private] = ACTIONS(5594),
    [anon_sym_protected] = ACTIONS(5594),
    [anon_sym_using] = ACTIONS(5594),
    [anon_sym_static_assert] = ACTIONS(5594),
    [anon_sym_precise] = ACTIONS(5594),
    [anon_sym_shared] = ACTIONS(5594),
    [anon_sym_groupshared] = ACTIONS(5594),
    [anon_sym_uniform] = ACTIONS(5594),
    [anon_sym_row_major] = ACTIONS(5594),
    [anon_sym_column_major] = ACTIONS(5594),
    [anon_sym_globallycoherent] = ACTIONS(5594),
    [anon_sym_centroid] = ACTIONS(5594),
    [anon_sym_noperspective] = ACTIONS(5594),
    [anon_sym_nointerpolation] = ACTIONS(5594),
    [anon_sym_sample] = ACTIONS(5594),
    [anon_sym_linear] = ACTIONS(5594),
    [anon_sym_snorm] = ACTIONS(5594),
    [anon_sym_unorm] = ACTIONS(5594),
    [anon_sym_point] = ACTIONS(5594),
    [anon_sym_line] = ACTIONS(5594),
    [anon_sym_triangleadj] = ACTIONS(5594),
    [anon_sym_lineadj] = ACTIONS(5594),
    [anon_sym_triangle] = ACTIONS(5594),
    [anon_sym_interface] = ACTIONS(5594),
    [anon_sym_extension] = ACTIONS(5594),
    [anon_sym___init] = ACTIONS(5594),
    [anon_sym___subscript] = ACTIONS(5594),
    [anon_sym_property] = ACTIONS(5594),
    [anon_sym_associatedtype] = ACTIONS(5594),
  },
  [2148] = {
    [sym_identifier] = ACTIONS(5590),
    [aux_sym_preproc_def_token1] = ACTIONS(5590),
    [aux_sym_preproc_if_token1] = ACTIONS(5590),
    [aux_sym_preproc_if_token2] = ACTIONS(5590),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5590),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5590),
    [sym_preproc_directive] = ACTIONS(5590),
    [anon_sym_LPAREN2] = ACTIONS(5592),
    [anon_sym_TILDE] = ACTIONS(5592),
    [anon_sym_STAR] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym___extension__] = ACTIONS(5590),
    [anon_sym_typedef] = ACTIONS(5590),
    [anon_sym_in] = ACTIONS(5590),
    [anon_sym_out] = ACTIONS(5590),
    [anon_sym_inout] = ACTIONS(5590),
    [anon_sym_extern] = ACTIONS(5590),
    [anon_sym___attribute__] = ACTIONS(5590),
    [anon_sym_COLON_COLON] = ACTIONS(5592),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5592),
    [anon_sym___declspec] = ACTIONS(5590),
    [anon_sym___based] = ACTIONS(5590),
    [anon_sym_signed] = ACTIONS(5590),
    [anon_sym_unsigned] = ACTIONS(5590),
    [anon_sym_long] = ACTIONS(5590),
    [anon_sym_short] = ACTIONS(5590),
    [anon_sym_LBRACK] = ACTIONS(5590),
    [anon_sym_static] = ACTIONS(5590),
    [anon_sym_register] = ACTIONS(5590),
    [anon_sym_inline] = ACTIONS(5590),
    [anon_sym___inline] = ACTIONS(5590),
    [anon_sym___inline__] = ACTIONS(5590),
    [anon_sym___forceinline] = ACTIONS(5590),
    [anon_sym_thread_local] = ACTIONS(5590),
    [anon_sym___thread] = ACTIONS(5590),
    [anon_sym_const] = ACTIONS(5590),
    [anon_sym_constexpr] = ACTIONS(5590),
    [anon_sym_volatile] = ACTIONS(5590),
    [anon_sym_restrict] = ACTIONS(5590),
    [anon_sym___restrict__] = ACTIONS(5590),
    [anon_sym__Atomic] = ACTIONS(5590),
    [anon_sym__Noreturn] = ACTIONS(5590),
    [anon_sym_noreturn] = ACTIONS(5590),
    [anon_sym_mutable] = ACTIONS(5590),
    [anon_sym_constinit] = ACTIONS(5590),
    [anon_sym_consteval] = ACTIONS(5590),
    [anon_sym_alignas] = ACTIONS(5590),
    [anon_sym__Alignas] = ACTIONS(5590),
    [sym_primitive_type] = ACTIONS(5590),
    [anon_sym_enum] = ACTIONS(5590),
    [anon_sym_class] = ACTIONS(5590),
    [anon_sym_struct] = ACTIONS(5590),
    [anon_sym_union] = ACTIONS(5590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5590),
    [anon_sym_let] = ACTIONS(5590),
    [anon_sym_This] = ACTIONS(5590),
    [anon_sym_decltype] = ACTIONS(5590),
    [sym_virtual] = ACTIONS(5590),
    [anon_sym_explicit] = ACTIONS(5590),
    [anon_sym_typename] = ACTIONS(5590),
    [anon_sym_template] = ACTIONS(5590),
    [anon_sym_operator] = ACTIONS(5590),
    [anon_sym_friend] = ACTIONS(5590),
    [anon_sym_public] = ACTIONS(5590),
    [anon_sym_private] = ACTIONS(5590),
    [anon_sym_protected] = ACTIONS(5590),
    [anon_sym_using] = ACTIONS(5590),
    [anon_sym_static_assert] = ACTIONS(5590),
    [anon_sym_precise] = ACTIONS(5590),
    [anon_sym_shared] = ACTIONS(5590),
    [anon_sym_groupshared] = ACTIONS(5590),
    [anon_sym_uniform] = ACTIONS(5590),
    [anon_sym_row_major] = ACTIONS(5590),
    [anon_sym_column_major] = ACTIONS(5590),
    [anon_sym_globallycoherent] = ACTIONS(5590),
    [anon_sym_centroid] = ACTIONS(5590),
    [anon_sym_noperspective] = ACTIONS(5590),
    [anon_sym_nointerpolation] = ACTIONS(5590),
    [anon_sym_sample] = ACTIONS(5590),
    [anon_sym_linear] = ACTIONS(5590),
    [anon_sym_snorm] = ACTIONS(5590),
    [anon_sym_unorm] = ACTIONS(5590),
    [anon_sym_point] = ACTIONS(5590),
    [anon_sym_line] = ACTIONS(5590),
    [anon_sym_triangleadj] = ACTIONS(5590),
    [anon_sym_lineadj] = ACTIONS(5590),
    [anon_sym_triangle] = ACTIONS(5590),
    [anon_sym_interface] = ACTIONS(5590),
    [anon_sym_extension] = ACTIONS(5590),
    [anon_sym___init] = ACTIONS(5590),
    [anon_sym___subscript] = ACTIONS(5590),
    [anon_sym_property] = ACTIONS(5590),
    [anon_sym_associatedtype] = ACTIONS(5590),
  },
  [2149] = {
    [sym_identifier] = ACTIONS(5586),
    [aux_sym_preproc_def_token1] = ACTIONS(5586),
    [aux_sym_preproc_if_token1] = ACTIONS(5586),
    [aux_sym_preproc_if_token2] = ACTIONS(5586),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5586),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5586),
    [sym_preproc_directive] = ACTIONS(5586),
    [anon_sym_LPAREN2] = ACTIONS(5588),
    [anon_sym_TILDE] = ACTIONS(5588),
    [anon_sym_STAR] = ACTIONS(5588),
    [anon_sym_AMP_AMP] = ACTIONS(5588),
    [anon_sym_AMP] = ACTIONS(5586),
    [anon_sym___extension__] = ACTIONS(5586),
    [anon_sym_typedef] = ACTIONS(5586),
    [anon_sym_in] = ACTIONS(5586),
    [anon_sym_out] = ACTIONS(5586),
    [anon_sym_inout] = ACTIONS(5586),
    [anon_sym_extern] = ACTIONS(5586),
    [anon_sym___attribute__] = ACTIONS(5586),
    [anon_sym_COLON_COLON] = ACTIONS(5588),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5588),
    [anon_sym___declspec] = ACTIONS(5586),
    [anon_sym___based] = ACTIONS(5586),
    [anon_sym_signed] = ACTIONS(5586),
    [anon_sym_unsigned] = ACTIONS(5586),
    [anon_sym_long] = ACTIONS(5586),
    [anon_sym_short] = ACTIONS(5586),
    [anon_sym_LBRACK] = ACTIONS(5586),
    [anon_sym_static] = ACTIONS(5586),
    [anon_sym_register] = ACTIONS(5586),
    [anon_sym_inline] = ACTIONS(5586),
    [anon_sym___inline] = ACTIONS(5586),
    [anon_sym___inline__] = ACTIONS(5586),
    [anon_sym___forceinline] = ACTIONS(5586),
    [anon_sym_thread_local] = ACTIONS(5586),
    [anon_sym___thread] = ACTIONS(5586),
    [anon_sym_const] = ACTIONS(5586),
    [anon_sym_constexpr] = ACTIONS(5586),
    [anon_sym_volatile] = ACTIONS(5586),
    [anon_sym_restrict] = ACTIONS(5586),
    [anon_sym___restrict__] = ACTIONS(5586),
    [anon_sym__Atomic] = ACTIONS(5586),
    [anon_sym__Noreturn] = ACTIONS(5586),
    [anon_sym_noreturn] = ACTIONS(5586),
    [anon_sym_mutable] = ACTIONS(5586),
    [anon_sym_constinit] = ACTIONS(5586),
    [anon_sym_consteval] = ACTIONS(5586),
    [anon_sym_alignas] = ACTIONS(5586),
    [anon_sym__Alignas] = ACTIONS(5586),
    [sym_primitive_type] = ACTIONS(5586),
    [anon_sym_enum] = ACTIONS(5586),
    [anon_sym_class] = ACTIONS(5586),
    [anon_sym_struct] = ACTIONS(5586),
    [anon_sym_union] = ACTIONS(5586),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5586),
    [anon_sym_let] = ACTIONS(5586),
    [anon_sym_This] = ACTIONS(5586),
    [anon_sym_decltype] = ACTIONS(5586),
    [sym_virtual] = ACTIONS(5586),
    [anon_sym_explicit] = ACTIONS(5586),
    [anon_sym_typename] = ACTIONS(5586),
    [anon_sym_template] = ACTIONS(5586),
    [anon_sym_operator] = ACTIONS(5586),
    [anon_sym_friend] = ACTIONS(5586),
    [anon_sym_public] = ACTIONS(5586),
    [anon_sym_private] = ACTIONS(5586),
    [anon_sym_protected] = ACTIONS(5586),
    [anon_sym_using] = ACTIONS(5586),
    [anon_sym_static_assert] = ACTIONS(5586),
    [anon_sym_precise] = ACTIONS(5586),
    [anon_sym_shared] = ACTIONS(5586),
    [anon_sym_groupshared] = ACTIONS(5586),
    [anon_sym_uniform] = ACTIONS(5586),
    [anon_sym_row_major] = ACTIONS(5586),
    [anon_sym_column_major] = ACTIONS(5586),
    [anon_sym_globallycoherent] = ACTIONS(5586),
    [anon_sym_centroid] = ACTIONS(5586),
    [anon_sym_noperspective] = ACTIONS(5586),
    [anon_sym_nointerpolation] = ACTIONS(5586),
    [anon_sym_sample] = ACTIONS(5586),
    [anon_sym_linear] = ACTIONS(5586),
    [anon_sym_snorm] = ACTIONS(5586),
    [anon_sym_unorm] = ACTIONS(5586),
    [anon_sym_point] = ACTIONS(5586),
    [anon_sym_line] = ACTIONS(5586),
    [anon_sym_triangleadj] = ACTIONS(5586),
    [anon_sym_lineadj] = ACTIONS(5586),
    [anon_sym_triangle] = ACTIONS(5586),
    [anon_sym_interface] = ACTIONS(5586),
    [anon_sym_extension] = ACTIONS(5586),
    [anon_sym___init] = ACTIONS(5586),
    [anon_sym___subscript] = ACTIONS(5586),
    [anon_sym_property] = ACTIONS(5586),
    [anon_sym_associatedtype] = ACTIONS(5586),
  },
  [2150] = {
    [sym_identifier] = ACTIONS(5582),
    [aux_sym_preproc_def_token1] = ACTIONS(5582),
    [aux_sym_preproc_if_token1] = ACTIONS(5582),
    [aux_sym_preproc_if_token2] = ACTIONS(5582),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5582),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5582),
    [sym_preproc_directive] = ACTIONS(5582),
    [anon_sym_LPAREN2] = ACTIONS(5584),
    [anon_sym_TILDE] = ACTIONS(5584),
    [anon_sym_STAR] = ACTIONS(5584),
    [anon_sym_AMP_AMP] = ACTIONS(5584),
    [anon_sym_AMP] = ACTIONS(5582),
    [anon_sym___extension__] = ACTIONS(5582),
    [anon_sym_typedef] = ACTIONS(5582),
    [anon_sym_in] = ACTIONS(5582),
    [anon_sym_out] = ACTIONS(5582),
    [anon_sym_inout] = ACTIONS(5582),
    [anon_sym_extern] = ACTIONS(5582),
    [anon_sym___attribute__] = ACTIONS(5582),
    [anon_sym_COLON_COLON] = ACTIONS(5584),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5584),
    [anon_sym___declspec] = ACTIONS(5582),
    [anon_sym___based] = ACTIONS(5582),
    [anon_sym_signed] = ACTIONS(5582),
    [anon_sym_unsigned] = ACTIONS(5582),
    [anon_sym_long] = ACTIONS(5582),
    [anon_sym_short] = ACTIONS(5582),
    [anon_sym_LBRACK] = ACTIONS(5582),
    [anon_sym_static] = ACTIONS(5582),
    [anon_sym_register] = ACTIONS(5582),
    [anon_sym_inline] = ACTIONS(5582),
    [anon_sym___inline] = ACTIONS(5582),
    [anon_sym___inline__] = ACTIONS(5582),
    [anon_sym___forceinline] = ACTIONS(5582),
    [anon_sym_thread_local] = ACTIONS(5582),
    [anon_sym___thread] = ACTIONS(5582),
    [anon_sym_const] = ACTIONS(5582),
    [anon_sym_constexpr] = ACTIONS(5582),
    [anon_sym_volatile] = ACTIONS(5582),
    [anon_sym_restrict] = ACTIONS(5582),
    [anon_sym___restrict__] = ACTIONS(5582),
    [anon_sym__Atomic] = ACTIONS(5582),
    [anon_sym__Noreturn] = ACTIONS(5582),
    [anon_sym_noreturn] = ACTIONS(5582),
    [anon_sym_mutable] = ACTIONS(5582),
    [anon_sym_constinit] = ACTIONS(5582),
    [anon_sym_consteval] = ACTIONS(5582),
    [anon_sym_alignas] = ACTIONS(5582),
    [anon_sym__Alignas] = ACTIONS(5582),
    [sym_primitive_type] = ACTIONS(5582),
    [anon_sym_enum] = ACTIONS(5582),
    [anon_sym_class] = ACTIONS(5582),
    [anon_sym_struct] = ACTIONS(5582),
    [anon_sym_union] = ACTIONS(5582),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5582),
    [anon_sym_let] = ACTIONS(5582),
    [anon_sym_This] = ACTIONS(5582),
    [anon_sym_decltype] = ACTIONS(5582),
    [sym_virtual] = ACTIONS(5582),
    [anon_sym_explicit] = ACTIONS(5582),
    [anon_sym_typename] = ACTIONS(5582),
    [anon_sym_template] = ACTIONS(5582),
    [anon_sym_operator] = ACTIONS(5582),
    [anon_sym_friend] = ACTIONS(5582),
    [anon_sym_public] = ACTIONS(5582),
    [anon_sym_private] = ACTIONS(5582),
    [anon_sym_protected] = ACTIONS(5582),
    [anon_sym_using] = ACTIONS(5582),
    [anon_sym_static_assert] = ACTIONS(5582),
    [anon_sym_precise] = ACTIONS(5582),
    [anon_sym_shared] = ACTIONS(5582),
    [anon_sym_groupshared] = ACTIONS(5582),
    [anon_sym_uniform] = ACTIONS(5582),
    [anon_sym_row_major] = ACTIONS(5582),
    [anon_sym_column_major] = ACTIONS(5582),
    [anon_sym_globallycoherent] = ACTIONS(5582),
    [anon_sym_centroid] = ACTIONS(5582),
    [anon_sym_noperspective] = ACTIONS(5582),
    [anon_sym_nointerpolation] = ACTIONS(5582),
    [anon_sym_sample] = ACTIONS(5582),
    [anon_sym_linear] = ACTIONS(5582),
    [anon_sym_snorm] = ACTIONS(5582),
    [anon_sym_unorm] = ACTIONS(5582),
    [anon_sym_point] = ACTIONS(5582),
    [anon_sym_line] = ACTIONS(5582),
    [anon_sym_triangleadj] = ACTIONS(5582),
    [anon_sym_lineadj] = ACTIONS(5582),
    [anon_sym_triangle] = ACTIONS(5582),
    [anon_sym_interface] = ACTIONS(5582),
    [anon_sym_extension] = ACTIONS(5582),
    [anon_sym___init] = ACTIONS(5582),
    [anon_sym___subscript] = ACTIONS(5582),
    [anon_sym_property] = ACTIONS(5582),
    [anon_sym_associatedtype] = ACTIONS(5582),
  },
  [2151] = {
    [sym_expression] = STATE(3566),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2152] = {
    [sym_identifier] = ACTIONS(5568),
    [aux_sym_preproc_def_token1] = ACTIONS(5568),
    [aux_sym_preproc_if_token1] = ACTIONS(5568),
    [aux_sym_preproc_if_token2] = ACTIONS(5568),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5568),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5568),
    [sym_preproc_directive] = ACTIONS(5568),
    [anon_sym_LPAREN2] = ACTIONS(5570),
    [anon_sym_TILDE] = ACTIONS(5570),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_AMP_AMP] = ACTIONS(5570),
    [anon_sym_AMP] = ACTIONS(5568),
    [anon_sym___extension__] = ACTIONS(5568),
    [anon_sym_typedef] = ACTIONS(5568),
    [anon_sym_in] = ACTIONS(5568),
    [anon_sym_out] = ACTIONS(5568),
    [anon_sym_inout] = ACTIONS(5568),
    [anon_sym_extern] = ACTIONS(5568),
    [anon_sym___attribute__] = ACTIONS(5568),
    [anon_sym_COLON_COLON] = ACTIONS(5570),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5570),
    [anon_sym___declspec] = ACTIONS(5568),
    [anon_sym___based] = ACTIONS(5568),
    [anon_sym_signed] = ACTIONS(5568),
    [anon_sym_unsigned] = ACTIONS(5568),
    [anon_sym_long] = ACTIONS(5568),
    [anon_sym_short] = ACTIONS(5568),
    [anon_sym_LBRACK] = ACTIONS(5568),
    [anon_sym_static] = ACTIONS(5568),
    [anon_sym_register] = ACTIONS(5568),
    [anon_sym_inline] = ACTIONS(5568),
    [anon_sym___inline] = ACTIONS(5568),
    [anon_sym___inline__] = ACTIONS(5568),
    [anon_sym___forceinline] = ACTIONS(5568),
    [anon_sym_thread_local] = ACTIONS(5568),
    [anon_sym___thread] = ACTIONS(5568),
    [anon_sym_const] = ACTIONS(5568),
    [anon_sym_constexpr] = ACTIONS(5568),
    [anon_sym_volatile] = ACTIONS(5568),
    [anon_sym_restrict] = ACTIONS(5568),
    [anon_sym___restrict__] = ACTIONS(5568),
    [anon_sym__Atomic] = ACTIONS(5568),
    [anon_sym__Noreturn] = ACTIONS(5568),
    [anon_sym_noreturn] = ACTIONS(5568),
    [anon_sym_mutable] = ACTIONS(5568),
    [anon_sym_constinit] = ACTIONS(5568),
    [anon_sym_consteval] = ACTIONS(5568),
    [anon_sym_alignas] = ACTIONS(5568),
    [anon_sym__Alignas] = ACTIONS(5568),
    [sym_primitive_type] = ACTIONS(5568),
    [anon_sym_enum] = ACTIONS(5568),
    [anon_sym_class] = ACTIONS(5568),
    [anon_sym_struct] = ACTIONS(5568),
    [anon_sym_union] = ACTIONS(5568),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5568),
    [anon_sym_let] = ACTIONS(5568),
    [anon_sym_This] = ACTIONS(5568),
    [anon_sym_decltype] = ACTIONS(5568),
    [sym_virtual] = ACTIONS(5568),
    [anon_sym_explicit] = ACTIONS(5568),
    [anon_sym_typename] = ACTIONS(5568),
    [anon_sym_template] = ACTIONS(5568),
    [anon_sym_operator] = ACTIONS(5568),
    [anon_sym_friend] = ACTIONS(5568),
    [anon_sym_public] = ACTIONS(5568),
    [anon_sym_private] = ACTIONS(5568),
    [anon_sym_protected] = ACTIONS(5568),
    [anon_sym_using] = ACTIONS(5568),
    [anon_sym_static_assert] = ACTIONS(5568),
    [anon_sym_precise] = ACTIONS(5568),
    [anon_sym_shared] = ACTIONS(5568),
    [anon_sym_groupshared] = ACTIONS(5568),
    [anon_sym_uniform] = ACTIONS(5568),
    [anon_sym_row_major] = ACTIONS(5568),
    [anon_sym_column_major] = ACTIONS(5568),
    [anon_sym_globallycoherent] = ACTIONS(5568),
    [anon_sym_centroid] = ACTIONS(5568),
    [anon_sym_noperspective] = ACTIONS(5568),
    [anon_sym_nointerpolation] = ACTIONS(5568),
    [anon_sym_sample] = ACTIONS(5568),
    [anon_sym_linear] = ACTIONS(5568),
    [anon_sym_snorm] = ACTIONS(5568),
    [anon_sym_unorm] = ACTIONS(5568),
    [anon_sym_point] = ACTIONS(5568),
    [anon_sym_line] = ACTIONS(5568),
    [anon_sym_triangleadj] = ACTIONS(5568),
    [anon_sym_lineadj] = ACTIONS(5568),
    [anon_sym_triangle] = ACTIONS(5568),
    [anon_sym_interface] = ACTIONS(5568),
    [anon_sym_extension] = ACTIONS(5568),
    [anon_sym___init] = ACTIONS(5568),
    [anon_sym___subscript] = ACTIONS(5568),
    [anon_sym_property] = ACTIONS(5568),
    [anon_sym_associatedtype] = ACTIONS(5568),
  },
  [2153] = {
    [sym_identifier] = ACTIONS(5540),
    [aux_sym_preproc_def_token1] = ACTIONS(5540),
    [aux_sym_preproc_if_token1] = ACTIONS(5540),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5540),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5540),
    [sym_preproc_directive] = ACTIONS(5540),
    [anon_sym_LPAREN2] = ACTIONS(5542),
    [anon_sym_TILDE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP_AMP] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5540),
    [anon_sym___extension__] = ACTIONS(5540),
    [anon_sym_typedef] = ACTIONS(5540),
    [anon_sym_in] = ACTIONS(5540),
    [anon_sym_out] = ACTIONS(5540),
    [anon_sym_inout] = ACTIONS(5540),
    [anon_sym_extern] = ACTIONS(5540),
    [anon_sym___attribute__] = ACTIONS(5540),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5542),
    [anon_sym___declspec] = ACTIONS(5540),
    [anon_sym___based] = ACTIONS(5540),
    [anon_sym_RBRACE] = ACTIONS(5542),
    [anon_sym_signed] = ACTIONS(5540),
    [anon_sym_unsigned] = ACTIONS(5540),
    [anon_sym_long] = ACTIONS(5540),
    [anon_sym_short] = ACTIONS(5540),
    [anon_sym_LBRACK] = ACTIONS(5540),
    [anon_sym_static] = ACTIONS(5540),
    [anon_sym_register] = ACTIONS(5540),
    [anon_sym_inline] = ACTIONS(5540),
    [anon_sym___inline] = ACTIONS(5540),
    [anon_sym___inline__] = ACTIONS(5540),
    [anon_sym___forceinline] = ACTIONS(5540),
    [anon_sym_thread_local] = ACTIONS(5540),
    [anon_sym___thread] = ACTIONS(5540),
    [anon_sym_const] = ACTIONS(5540),
    [anon_sym_constexpr] = ACTIONS(5540),
    [anon_sym_volatile] = ACTIONS(5540),
    [anon_sym_restrict] = ACTIONS(5540),
    [anon_sym___restrict__] = ACTIONS(5540),
    [anon_sym__Atomic] = ACTIONS(5540),
    [anon_sym__Noreturn] = ACTIONS(5540),
    [anon_sym_noreturn] = ACTIONS(5540),
    [anon_sym_mutable] = ACTIONS(5540),
    [anon_sym_constinit] = ACTIONS(5540),
    [anon_sym_consteval] = ACTIONS(5540),
    [anon_sym_alignas] = ACTIONS(5540),
    [anon_sym__Alignas] = ACTIONS(5540),
    [sym_primitive_type] = ACTIONS(5540),
    [anon_sym_enum] = ACTIONS(5540),
    [anon_sym_class] = ACTIONS(5540),
    [anon_sym_struct] = ACTIONS(5540),
    [anon_sym_union] = ACTIONS(5540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5540),
    [anon_sym_let] = ACTIONS(5540),
    [anon_sym_This] = ACTIONS(5540),
    [anon_sym_decltype] = ACTIONS(5540),
    [sym_virtual] = ACTIONS(5540),
    [anon_sym_explicit] = ACTIONS(5540),
    [anon_sym_typename] = ACTIONS(5540),
    [anon_sym_template] = ACTIONS(5540),
    [anon_sym_operator] = ACTIONS(5540),
    [anon_sym_friend] = ACTIONS(5540),
    [anon_sym_public] = ACTIONS(5540),
    [anon_sym_private] = ACTIONS(5540),
    [anon_sym_protected] = ACTIONS(5540),
    [anon_sym_using] = ACTIONS(5540),
    [anon_sym_static_assert] = ACTIONS(5540),
    [anon_sym_precise] = ACTIONS(5540),
    [anon_sym_shared] = ACTIONS(5540),
    [anon_sym_groupshared] = ACTIONS(5540),
    [anon_sym_uniform] = ACTIONS(5540),
    [anon_sym_row_major] = ACTIONS(5540),
    [anon_sym_column_major] = ACTIONS(5540),
    [anon_sym_globallycoherent] = ACTIONS(5540),
    [anon_sym_centroid] = ACTIONS(5540),
    [anon_sym_noperspective] = ACTIONS(5540),
    [anon_sym_nointerpolation] = ACTIONS(5540),
    [anon_sym_sample] = ACTIONS(5540),
    [anon_sym_linear] = ACTIONS(5540),
    [anon_sym_snorm] = ACTIONS(5540),
    [anon_sym_unorm] = ACTIONS(5540),
    [anon_sym_point] = ACTIONS(5540),
    [anon_sym_line] = ACTIONS(5540),
    [anon_sym_triangleadj] = ACTIONS(5540),
    [anon_sym_lineadj] = ACTIONS(5540),
    [anon_sym_triangle] = ACTIONS(5540),
    [anon_sym_interface] = ACTIONS(5540),
    [anon_sym_extension] = ACTIONS(5540),
    [anon_sym___init] = ACTIONS(5540),
    [anon_sym___subscript] = ACTIONS(5540),
    [anon_sym_property] = ACTIONS(5540),
    [anon_sym_associatedtype] = ACTIONS(5540),
  },
  [2154] = {
    [sym_expression] = STATE(5275),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2155] = {
    [sym_expression] = STATE(5270),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2156] = {
    [sym_expression] = STATE(5579),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2157] = {
    [sym_identifier] = ACTIONS(5560),
    [aux_sym_preproc_def_token1] = ACTIONS(5560),
    [aux_sym_preproc_if_token1] = ACTIONS(5560),
    [aux_sym_preproc_if_token2] = ACTIONS(5560),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5560),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5560),
    [sym_preproc_directive] = ACTIONS(5560),
    [anon_sym_LPAREN2] = ACTIONS(5562),
    [anon_sym_TILDE] = ACTIONS(5562),
    [anon_sym_STAR] = ACTIONS(5562),
    [anon_sym_AMP_AMP] = ACTIONS(5562),
    [anon_sym_AMP] = ACTIONS(5560),
    [anon_sym___extension__] = ACTIONS(5560),
    [anon_sym_typedef] = ACTIONS(5560),
    [anon_sym_in] = ACTIONS(5560),
    [anon_sym_out] = ACTIONS(5560),
    [anon_sym_inout] = ACTIONS(5560),
    [anon_sym_extern] = ACTIONS(5560),
    [anon_sym___attribute__] = ACTIONS(5560),
    [anon_sym_COLON_COLON] = ACTIONS(5562),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5562),
    [anon_sym___declspec] = ACTIONS(5560),
    [anon_sym___based] = ACTIONS(5560),
    [anon_sym_signed] = ACTIONS(5560),
    [anon_sym_unsigned] = ACTIONS(5560),
    [anon_sym_long] = ACTIONS(5560),
    [anon_sym_short] = ACTIONS(5560),
    [anon_sym_LBRACK] = ACTIONS(5560),
    [anon_sym_static] = ACTIONS(5560),
    [anon_sym_register] = ACTIONS(5560),
    [anon_sym_inline] = ACTIONS(5560),
    [anon_sym___inline] = ACTIONS(5560),
    [anon_sym___inline__] = ACTIONS(5560),
    [anon_sym___forceinline] = ACTIONS(5560),
    [anon_sym_thread_local] = ACTIONS(5560),
    [anon_sym___thread] = ACTIONS(5560),
    [anon_sym_const] = ACTIONS(5560),
    [anon_sym_constexpr] = ACTIONS(5560),
    [anon_sym_volatile] = ACTIONS(5560),
    [anon_sym_restrict] = ACTIONS(5560),
    [anon_sym___restrict__] = ACTIONS(5560),
    [anon_sym__Atomic] = ACTIONS(5560),
    [anon_sym__Noreturn] = ACTIONS(5560),
    [anon_sym_noreturn] = ACTIONS(5560),
    [anon_sym_mutable] = ACTIONS(5560),
    [anon_sym_constinit] = ACTIONS(5560),
    [anon_sym_consteval] = ACTIONS(5560),
    [anon_sym_alignas] = ACTIONS(5560),
    [anon_sym__Alignas] = ACTIONS(5560),
    [sym_primitive_type] = ACTIONS(5560),
    [anon_sym_enum] = ACTIONS(5560),
    [anon_sym_class] = ACTIONS(5560),
    [anon_sym_struct] = ACTIONS(5560),
    [anon_sym_union] = ACTIONS(5560),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5560),
    [anon_sym_let] = ACTIONS(5560),
    [anon_sym_This] = ACTIONS(5560),
    [anon_sym_decltype] = ACTIONS(5560),
    [sym_virtual] = ACTIONS(5560),
    [anon_sym_explicit] = ACTIONS(5560),
    [anon_sym_typename] = ACTIONS(5560),
    [anon_sym_template] = ACTIONS(5560),
    [anon_sym_operator] = ACTIONS(5560),
    [anon_sym_friend] = ACTIONS(5560),
    [anon_sym_public] = ACTIONS(5560),
    [anon_sym_private] = ACTIONS(5560),
    [anon_sym_protected] = ACTIONS(5560),
    [anon_sym_using] = ACTIONS(5560),
    [anon_sym_static_assert] = ACTIONS(5560),
    [anon_sym_precise] = ACTIONS(5560),
    [anon_sym_shared] = ACTIONS(5560),
    [anon_sym_groupshared] = ACTIONS(5560),
    [anon_sym_uniform] = ACTIONS(5560),
    [anon_sym_row_major] = ACTIONS(5560),
    [anon_sym_column_major] = ACTIONS(5560),
    [anon_sym_globallycoherent] = ACTIONS(5560),
    [anon_sym_centroid] = ACTIONS(5560),
    [anon_sym_noperspective] = ACTIONS(5560),
    [anon_sym_nointerpolation] = ACTIONS(5560),
    [anon_sym_sample] = ACTIONS(5560),
    [anon_sym_linear] = ACTIONS(5560),
    [anon_sym_snorm] = ACTIONS(5560),
    [anon_sym_unorm] = ACTIONS(5560),
    [anon_sym_point] = ACTIONS(5560),
    [anon_sym_line] = ACTIONS(5560),
    [anon_sym_triangleadj] = ACTIONS(5560),
    [anon_sym_lineadj] = ACTIONS(5560),
    [anon_sym_triangle] = ACTIONS(5560),
    [anon_sym_interface] = ACTIONS(5560),
    [anon_sym_extension] = ACTIONS(5560),
    [anon_sym___init] = ACTIONS(5560),
    [anon_sym___subscript] = ACTIONS(5560),
    [anon_sym_property] = ACTIONS(5560),
    [anon_sym_associatedtype] = ACTIONS(5560),
  },
  [2158] = {
    [sym_identifier] = ACTIONS(5548),
    [aux_sym_preproc_def_token1] = ACTIONS(5548),
    [aux_sym_preproc_if_token1] = ACTIONS(5548),
    [aux_sym_preproc_if_token2] = ACTIONS(5548),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5548),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5548),
    [sym_preproc_directive] = ACTIONS(5548),
    [anon_sym_LPAREN2] = ACTIONS(5550),
    [anon_sym_TILDE] = ACTIONS(5550),
    [anon_sym_STAR] = ACTIONS(5550),
    [anon_sym_AMP_AMP] = ACTIONS(5550),
    [anon_sym_AMP] = ACTIONS(5548),
    [anon_sym___extension__] = ACTIONS(5548),
    [anon_sym_typedef] = ACTIONS(5548),
    [anon_sym_in] = ACTIONS(5548),
    [anon_sym_out] = ACTIONS(5548),
    [anon_sym_inout] = ACTIONS(5548),
    [anon_sym_extern] = ACTIONS(5548),
    [anon_sym___attribute__] = ACTIONS(5548),
    [anon_sym_COLON_COLON] = ACTIONS(5550),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5550),
    [anon_sym___declspec] = ACTIONS(5548),
    [anon_sym___based] = ACTIONS(5548),
    [anon_sym_signed] = ACTIONS(5548),
    [anon_sym_unsigned] = ACTIONS(5548),
    [anon_sym_long] = ACTIONS(5548),
    [anon_sym_short] = ACTIONS(5548),
    [anon_sym_LBRACK] = ACTIONS(5548),
    [anon_sym_static] = ACTIONS(5548),
    [anon_sym_register] = ACTIONS(5548),
    [anon_sym_inline] = ACTIONS(5548),
    [anon_sym___inline] = ACTIONS(5548),
    [anon_sym___inline__] = ACTIONS(5548),
    [anon_sym___forceinline] = ACTIONS(5548),
    [anon_sym_thread_local] = ACTIONS(5548),
    [anon_sym___thread] = ACTIONS(5548),
    [anon_sym_const] = ACTIONS(5548),
    [anon_sym_constexpr] = ACTIONS(5548),
    [anon_sym_volatile] = ACTIONS(5548),
    [anon_sym_restrict] = ACTIONS(5548),
    [anon_sym___restrict__] = ACTIONS(5548),
    [anon_sym__Atomic] = ACTIONS(5548),
    [anon_sym__Noreturn] = ACTIONS(5548),
    [anon_sym_noreturn] = ACTIONS(5548),
    [anon_sym_mutable] = ACTIONS(5548),
    [anon_sym_constinit] = ACTIONS(5548),
    [anon_sym_consteval] = ACTIONS(5548),
    [anon_sym_alignas] = ACTIONS(5548),
    [anon_sym__Alignas] = ACTIONS(5548),
    [sym_primitive_type] = ACTIONS(5548),
    [anon_sym_enum] = ACTIONS(5548),
    [anon_sym_class] = ACTIONS(5548),
    [anon_sym_struct] = ACTIONS(5548),
    [anon_sym_union] = ACTIONS(5548),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5548),
    [anon_sym_let] = ACTIONS(5548),
    [anon_sym_This] = ACTIONS(5548),
    [anon_sym_decltype] = ACTIONS(5548),
    [sym_virtual] = ACTIONS(5548),
    [anon_sym_explicit] = ACTIONS(5548),
    [anon_sym_typename] = ACTIONS(5548),
    [anon_sym_template] = ACTIONS(5548),
    [anon_sym_operator] = ACTIONS(5548),
    [anon_sym_friend] = ACTIONS(5548),
    [anon_sym_public] = ACTIONS(5548),
    [anon_sym_private] = ACTIONS(5548),
    [anon_sym_protected] = ACTIONS(5548),
    [anon_sym_using] = ACTIONS(5548),
    [anon_sym_static_assert] = ACTIONS(5548),
    [anon_sym_precise] = ACTIONS(5548),
    [anon_sym_shared] = ACTIONS(5548),
    [anon_sym_groupshared] = ACTIONS(5548),
    [anon_sym_uniform] = ACTIONS(5548),
    [anon_sym_row_major] = ACTIONS(5548),
    [anon_sym_column_major] = ACTIONS(5548),
    [anon_sym_globallycoherent] = ACTIONS(5548),
    [anon_sym_centroid] = ACTIONS(5548),
    [anon_sym_noperspective] = ACTIONS(5548),
    [anon_sym_nointerpolation] = ACTIONS(5548),
    [anon_sym_sample] = ACTIONS(5548),
    [anon_sym_linear] = ACTIONS(5548),
    [anon_sym_snorm] = ACTIONS(5548),
    [anon_sym_unorm] = ACTIONS(5548),
    [anon_sym_point] = ACTIONS(5548),
    [anon_sym_line] = ACTIONS(5548),
    [anon_sym_triangleadj] = ACTIONS(5548),
    [anon_sym_lineadj] = ACTIONS(5548),
    [anon_sym_triangle] = ACTIONS(5548),
    [anon_sym_interface] = ACTIONS(5548),
    [anon_sym_extension] = ACTIONS(5548),
    [anon_sym___init] = ACTIONS(5548),
    [anon_sym___subscript] = ACTIONS(5548),
    [anon_sym_property] = ACTIONS(5548),
    [anon_sym_associatedtype] = ACTIONS(5548),
  },
  [2159] = {
    [sym_identifier] = ACTIONS(3429),
    [aux_sym_preproc_def_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3429),
    [sym_preproc_directive] = ACTIONS(3429),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym___extension__] = ACTIONS(3429),
    [anon_sym_typedef] = ACTIONS(3429),
    [anon_sym_in] = ACTIONS(3429),
    [anon_sym_out] = ACTIONS(3429),
    [anon_sym_inout] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym___attribute__] = ACTIONS(3429),
    [anon_sym_COLON_COLON] = ACTIONS(3431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3431),
    [anon_sym___declspec] = ACTIONS(3429),
    [anon_sym___based] = ACTIONS(3429),
    [anon_sym_RBRACE] = ACTIONS(3431),
    [anon_sym_signed] = ACTIONS(3429),
    [anon_sym_unsigned] = ACTIONS(3429),
    [anon_sym_long] = ACTIONS(3429),
    [anon_sym_short] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_register] = ACTIONS(3429),
    [anon_sym_inline] = ACTIONS(3429),
    [anon_sym___inline] = ACTIONS(3429),
    [anon_sym___inline__] = ACTIONS(3429),
    [anon_sym___forceinline] = ACTIONS(3429),
    [anon_sym_thread_local] = ACTIONS(3429),
    [anon_sym___thread] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_constexpr] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_restrict] = ACTIONS(3429),
    [anon_sym___restrict__] = ACTIONS(3429),
    [anon_sym__Atomic] = ACTIONS(3429),
    [anon_sym__Noreturn] = ACTIONS(3429),
    [anon_sym_noreturn] = ACTIONS(3429),
    [anon_sym_mutable] = ACTIONS(3429),
    [anon_sym_constinit] = ACTIONS(3429),
    [anon_sym_consteval] = ACTIONS(3429),
    [anon_sym_alignas] = ACTIONS(3429),
    [anon_sym__Alignas] = ACTIONS(3429),
    [sym_primitive_type] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_This] = ACTIONS(3429),
    [anon_sym_decltype] = ACTIONS(3429),
    [sym_virtual] = ACTIONS(3429),
    [anon_sym_explicit] = ACTIONS(3429),
    [anon_sym_typename] = ACTIONS(3429),
    [anon_sym_template] = ACTIONS(3429),
    [anon_sym_operator] = ACTIONS(3429),
    [anon_sym_friend] = ACTIONS(3429),
    [anon_sym_public] = ACTIONS(3429),
    [anon_sym_private] = ACTIONS(3429),
    [anon_sym_protected] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_static_assert] = ACTIONS(3429),
    [anon_sym_precise] = ACTIONS(3429),
    [anon_sym_shared] = ACTIONS(3429),
    [anon_sym_groupshared] = ACTIONS(3429),
    [anon_sym_uniform] = ACTIONS(3429),
    [anon_sym_row_major] = ACTIONS(3429),
    [anon_sym_column_major] = ACTIONS(3429),
    [anon_sym_globallycoherent] = ACTIONS(3429),
    [anon_sym_centroid] = ACTIONS(3429),
    [anon_sym_noperspective] = ACTIONS(3429),
    [anon_sym_nointerpolation] = ACTIONS(3429),
    [anon_sym_sample] = ACTIONS(3429),
    [anon_sym_linear] = ACTIONS(3429),
    [anon_sym_snorm] = ACTIONS(3429),
    [anon_sym_unorm] = ACTIONS(3429),
    [anon_sym_point] = ACTIONS(3429),
    [anon_sym_line] = ACTIONS(3429),
    [anon_sym_triangleadj] = ACTIONS(3429),
    [anon_sym_lineadj] = ACTIONS(3429),
    [anon_sym_triangle] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_extension] = ACTIONS(3429),
    [anon_sym___init] = ACTIONS(3429),
    [anon_sym___subscript] = ACTIONS(3429),
    [anon_sym_property] = ACTIONS(3429),
    [anon_sym_associatedtype] = ACTIONS(3429),
  },
  [2160] = {
    [sym_identifier] = ACTIONS(5540),
    [aux_sym_preproc_def_token1] = ACTIONS(5540),
    [aux_sym_preproc_if_token1] = ACTIONS(5540),
    [aux_sym_preproc_if_token2] = ACTIONS(5540),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5540),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5540),
    [sym_preproc_directive] = ACTIONS(5540),
    [anon_sym_LPAREN2] = ACTIONS(5542),
    [anon_sym_TILDE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP_AMP] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5540),
    [anon_sym___extension__] = ACTIONS(5540),
    [anon_sym_typedef] = ACTIONS(5540),
    [anon_sym_in] = ACTIONS(5540),
    [anon_sym_out] = ACTIONS(5540),
    [anon_sym_inout] = ACTIONS(5540),
    [anon_sym_extern] = ACTIONS(5540),
    [anon_sym___attribute__] = ACTIONS(5540),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5542),
    [anon_sym___declspec] = ACTIONS(5540),
    [anon_sym___based] = ACTIONS(5540),
    [anon_sym_signed] = ACTIONS(5540),
    [anon_sym_unsigned] = ACTIONS(5540),
    [anon_sym_long] = ACTIONS(5540),
    [anon_sym_short] = ACTIONS(5540),
    [anon_sym_LBRACK] = ACTIONS(5540),
    [anon_sym_static] = ACTIONS(5540),
    [anon_sym_register] = ACTIONS(5540),
    [anon_sym_inline] = ACTIONS(5540),
    [anon_sym___inline] = ACTIONS(5540),
    [anon_sym___inline__] = ACTIONS(5540),
    [anon_sym___forceinline] = ACTIONS(5540),
    [anon_sym_thread_local] = ACTIONS(5540),
    [anon_sym___thread] = ACTIONS(5540),
    [anon_sym_const] = ACTIONS(5540),
    [anon_sym_constexpr] = ACTIONS(5540),
    [anon_sym_volatile] = ACTIONS(5540),
    [anon_sym_restrict] = ACTIONS(5540),
    [anon_sym___restrict__] = ACTIONS(5540),
    [anon_sym__Atomic] = ACTIONS(5540),
    [anon_sym__Noreturn] = ACTIONS(5540),
    [anon_sym_noreturn] = ACTIONS(5540),
    [anon_sym_mutable] = ACTIONS(5540),
    [anon_sym_constinit] = ACTIONS(5540),
    [anon_sym_consteval] = ACTIONS(5540),
    [anon_sym_alignas] = ACTIONS(5540),
    [anon_sym__Alignas] = ACTIONS(5540),
    [sym_primitive_type] = ACTIONS(5540),
    [anon_sym_enum] = ACTIONS(5540),
    [anon_sym_class] = ACTIONS(5540),
    [anon_sym_struct] = ACTIONS(5540),
    [anon_sym_union] = ACTIONS(5540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5540),
    [anon_sym_let] = ACTIONS(5540),
    [anon_sym_This] = ACTIONS(5540),
    [anon_sym_decltype] = ACTIONS(5540),
    [sym_virtual] = ACTIONS(5540),
    [anon_sym_explicit] = ACTIONS(5540),
    [anon_sym_typename] = ACTIONS(5540),
    [anon_sym_template] = ACTIONS(5540),
    [anon_sym_operator] = ACTIONS(5540),
    [anon_sym_friend] = ACTIONS(5540),
    [anon_sym_public] = ACTIONS(5540),
    [anon_sym_private] = ACTIONS(5540),
    [anon_sym_protected] = ACTIONS(5540),
    [anon_sym_using] = ACTIONS(5540),
    [anon_sym_static_assert] = ACTIONS(5540),
    [anon_sym_precise] = ACTIONS(5540),
    [anon_sym_shared] = ACTIONS(5540),
    [anon_sym_groupshared] = ACTIONS(5540),
    [anon_sym_uniform] = ACTIONS(5540),
    [anon_sym_row_major] = ACTIONS(5540),
    [anon_sym_column_major] = ACTIONS(5540),
    [anon_sym_globallycoherent] = ACTIONS(5540),
    [anon_sym_centroid] = ACTIONS(5540),
    [anon_sym_noperspective] = ACTIONS(5540),
    [anon_sym_nointerpolation] = ACTIONS(5540),
    [anon_sym_sample] = ACTIONS(5540),
    [anon_sym_linear] = ACTIONS(5540),
    [anon_sym_snorm] = ACTIONS(5540),
    [anon_sym_unorm] = ACTIONS(5540),
    [anon_sym_point] = ACTIONS(5540),
    [anon_sym_line] = ACTIONS(5540),
    [anon_sym_triangleadj] = ACTIONS(5540),
    [anon_sym_lineadj] = ACTIONS(5540),
    [anon_sym_triangle] = ACTIONS(5540),
    [anon_sym_interface] = ACTIONS(5540),
    [anon_sym_extension] = ACTIONS(5540),
    [anon_sym___init] = ACTIONS(5540),
    [anon_sym___subscript] = ACTIONS(5540),
    [anon_sym_property] = ACTIONS(5540),
    [anon_sym_associatedtype] = ACTIONS(5540),
  },
  [2161] = {
    [sym_identifier] = ACTIONS(3429),
    [aux_sym_preproc_def_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3429),
    [sym_preproc_directive] = ACTIONS(3429),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym___extension__] = ACTIONS(3429),
    [anon_sym_typedef] = ACTIONS(3429),
    [anon_sym_in] = ACTIONS(3429),
    [anon_sym_out] = ACTIONS(3429),
    [anon_sym_inout] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym___attribute__] = ACTIONS(3429),
    [anon_sym_COLON_COLON] = ACTIONS(3431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3431),
    [anon_sym___declspec] = ACTIONS(3429),
    [anon_sym___based] = ACTIONS(3429),
    [anon_sym_RBRACE] = ACTIONS(3431),
    [anon_sym_signed] = ACTIONS(3429),
    [anon_sym_unsigned] = ACTIONS(3429),
    [anon_sym_long] = ACTIONS(3429),
    [anon_sym_short] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_register] = ACTIONS(3429),
    [anon_sym_inline] = ACTIONS(3429),
    [anon_sym___inline] = ACTIONS(3429),
    [anon_sym___inline__] = ACTIONS(3429),
    [anon_sym___forceinline] = ACTIONS(3429),
    [anon_sym_thread_local] = ACTIONS(3429),
    [anon_sym___thread] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_constexpr] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_restrict] = ACTIONS(3429),
    [anon_sym___restrict__] = ACTIONS(3429),
    [anon_sym__Atomic] = ACTIONS(3429),
    [anon_sym__Noreturn] = ACTIONS(3429),
    [anon_sym_noreturn] = ACTIONS(3429),
    [anon_sym_mutable] = ACTIONS(3429),
    [anon_sym_constinit] = ACTIONS(3429),
    [anon_sym_consteval] = ACTIONS(3429),
    [anon_sym_alignas] = ACTIONS(3429),
    [anon_sym__Alignas] = ACTIONS(3429),
    [sym_primitive_type] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_This] = ACTIONS(3429),
    [anon_sym_decltype] = ACTIONS(3429),
    [sym_virtual] = ACTIONS(3429),
    [anon_sym_explicit] = ACTIONS(3429),
    [anon_sym_typename] = ACTIONS(3429),
    [anon_sym_template] = ACTIONS(3429),
    [anon_sym_operator] = ACTIONS(3429),
    [anon_sym_friend] = ACTIONS(3429),
    [anon_sym_public] = ACTIONS(3429),
    [anon_sym_private] = ACTIONS(3429),
    [anon_sym_protected] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_static_assert] = ACTIONS(3429),
    [anon_sym_precise] = ACTIONS(3429),
    [anon_sym_shared] = ACTIONS(3429),
    [anon_sym_groupshared] = ACTIONS(3429),
    [anon_sym_uniform] = ACTIONS(3429),
    [anon_sym_row_major] = ACTIONS(3429),
    [anon_sym_column_major] = ACTIONS(3429),
    [anon_sym_globallycoherent] = ACTIONS(3429),
    [anon_sym_centroid] = ACTIONS(3429),
    [anon_sym_noperspective] = ACTIONS(3429),
    [anon_sym_nointerpolation] = ACTIONS(3429),
    [anon_sym_sample] = ACTIONS(3429),
    [anon_sym_linear] = ACTIONS(3429),
    [anon_sym_snorm] = ACTIONS(3429),
    [anon_sym_unorm] = ACTIONS(3429),
    [anon_sym_point] = ACTIONS(3429),
    [anon_sym_line] = ACTIONS(3429),
    [anon_sym_triangleadj] = ACTIONS(3429),
    [anon_sym_lineadj] = ACTIONS(3429),
    [anon_sym_triangle] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_extension] = ACTIONS(3429),
    [anon_sym___init] = ACTIONS(3429),
    [anon_sym___subscript] = ACTIONS(3429),
    [anon_sym_property] = ACTIONS(3429),
    [anon_sym_associatedtype] = ACTIONS(3429),
  },
  [2162] = {
    [sym_identifier] = ACTIONS(5548),
    [aux_sym_preproc_def_token1] = ACTIONS(5548),
    [aux_sym_preproc_if_token1] = ACTIONS(5548),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5548),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5548),
    [sym_preproc_directive] = ACTIONS(5548),
    [anon_sym_LPAREN2] = ACTIONS(5550),
    [anon_sym_TILDE] = ACTIONS(5550),
    [anon_sym_STAR] = ACTIONS(5550),
    [anon_sym_AMP_AMP] = ACTIONS(5550),
    [anon_sym_AMP] = ACTIONS(5548),
    [anon_sym___extension__] = ACTIONS(5548),
    [anon_sym_typedef] = ACTIONS(5548),
    [anon_sym_in] = ACTIONS(5548),
    [anon_sym_out] = ACTIONS(5548),
    [anon_sym_inout] = ACTIONS(5548),
    [anon_sym_extern] = ACTIONS(5548),
    [anon_sym___attribute__] = ACTIONS(5548),
    [anon_sym_COLON_COLON] = ACTIONS(5550),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5550),
    [anon_sym___declspec] = ACTIONS(5548),
    [anon_sym___based] = ACTIONS(5548),
    [anon_sym_RBRACE] = ACTIONS(5550),
    [anon_sym_signed] = ACTIONS(5548),
    [anon_sym_unsigned] = ACTIONS(5548),
    [anon_sym_long] = ACTIONS(5548),
    [anon_sym_short] = ACTIONS(5548),
    [anon_sym_LBRACK] = ACTIONS(5548),
    [anon_sym_static] = ACTIONS(5548),
    [anon_sym_register] = ACTIONS(5548),
    [anon_sym_inline] = ACTIONS(5548),
    [anon_sym___inline] = ACTIONS(5548),
    [anon_sym___inline__] = ACTIONS(5548),
    [anon_sym___forceinline] = ACTIONS(5548),
    [anon_sym_thread_local] = ACTIONS(5548),
    [anon_sym___thread] = ACTIONS(5548),
    [anon_sym_const] = ACTIONS(5548),
    [anon_sym_constexpr] = ACTIONS(5548),
    [anon_sym_volatile] = ACTIONS(5548),
    [anon_sym_restrict] = ACTIONS(5548),
    [anon_sym___restrict__] = ACTIONS(5548),
    [anon_sym__Atomic] = ACTIONS(5548),
    [anon_sym__Noreturn] = ACTIONS(5548),
    [anon_sym_noreturn] = ACTIONS(5548),
    [anon_sym_mutable] = ACTIONS(5548),
    [anon_sym_constinit] = ACTIONS(5548),
    [anon_sym_consteval] = ACTIONS(5548),
    [anon_sym_alignas] = ACTIONS(5548),
    [anon_sym__Alignas] = ACTIONS(5548),
    [sym_primitive_type] = ACTIONS(5548),
    [anon_sym_enum] = ACTIONS(5548),
    [anon_sym_class] = ACTIONS(5548),
    [anon_sym_struct] = ACTIONS(5548),
    [anon_sym_union] = ACTIONS(5548),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5548),
    [anon_sym_let] = ACTIONS(5548),
    [anon_sym_This] = ACTIONS(5548),
    [anon_sym_decltype] = ACTIONS(5548),
    [sym_virtual] = ACTIONS(5548),
    [anon_sym_explicit] = ACTIONS(5548),
    [anon_sym_typename] = ACTIONS(5548),
    [anon_sym_template] = ACTIONS(5548),
    [anon_sym_operator] = ACTIONS(5548),
    [anon_sym_friend] = ACTIONS(5548),
    [anon_sym_public] = ACTIONS(5548),
    [anon_sym_private] = ACTIONS(5548),
    [anon_sym_protected] = ACTIONS(5548),
    [anon_sym_using] = ACTIONS(5548),
    [anon_sym_static_assert] = ACTIONS(5548),
    [anon_sym_precise] = ACTIONS(5548),
    [anon_sym_shared] = ACTIONS(5548),
    [anon_sym_groupshared] = ACTIONS(5548),
    [anon_sym_uniform] = ACTIONS(5548),
    [anon_sym_row_major] = ACTIONS(5548),
    [anon_sym_column_major] = ACTIONS(5548),
    [anon_sym_globallycoherent] = ACTIONS(5548),
    [anon_sym_centroid] = ACTIONS(5548),
    [anon_sym_noperspective] = ACTIONS(5548),
    [anon_sym_nointerpolation] = ACTIONS(5548),
    [anon_sym_sample] = ACTIONS(5548),
    [anon_sym_linear] = ACTIONS(5548),
    [anon_sym_snorm] = ACTIONS(5548),
    [anon_sym_unorm] = ACTIONS(5548),
    [anon_sym_point] = ACTIONS(5548),
    [anon_sym_line] = ACTIONS(5548),
    [anon_sym_triangleadj] = ACTIONS(5548),
    [anon_sym_lineadj] = ACTIONS(5548),
    [anon_sym_triangle] = ACTIONS(5548),
    [anon_sym_interface] = ACTIONS(5548),
    [anon_sym_extension] = ACTIONS(5548),
    [anon_sym___init] = ACTIONS(5548),
    [anon_sym___subscript] = ACTIONS(5548),
    [anon_sym_property] = ACTIONS(5548),
    [anon_sym_associatedtype] = ACTIONS(5548),
  },
  [2163] = {
    [sym_identifier] = ACTIONS(3613),
    [aux_sym_preproc_def_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token2] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3613),
    [sym_preproc_directive] = ACTIONS(3613),
    [anon_sym_LPAREN2] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym___extension__] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3613),
    [anon_sym_in] = ACTIONS(3613),
    [anon_sym_out] = ACTIONS(3613),
    [anon_sym_inout] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym___attribute__] = ACTIONS(3613),
    [anon_sym_COLON_COLON] = ACTIONS(3615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3615),
    [anon_sym___declspec] = ACTIONS(3613),
    [anon_sym___based] = ACTIONS(3613),
    [anon_sym_signed] = ACTIONS(3613),
    [anon_sym_unsigned] = ACTIONS(3613),
    [anon_sym_long] = ACTIONS(3613),
    [anon_sym_short] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_register] = ACTIONS(3613),
    [anon_sym_inline] = ACTIONS(3613),
    [anon_sym___inline] = ACTIONS(3613),
    [anon_sym___inline__] = ACTIONS(3613),
    [anon_sym___forceinline] = ACTIONS(3613),
    [anon_sym_thread_local] = ACTIONS(3613),
    [anon_sym___thread] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_constexpr] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_restrict] = ACTIONS(3613),
    [anon_sym___restrict__] = ACTIONS(3613),
    [anon_sym__Atomic] = ACTIONS(3613),
    [anon_sym__Noreturn] = ACTIONS(3613),
    [anon_sym_noreturn] = ACTIONS(3613),
    [anon_sym_mutable] = ACTIONS(3613),
    [anon_sym_constinit] = ACTIONS(3613),
    [anon_sym_consteval] = ACTIONS(3613),
    [anon_sym_alignas] = ACTIONS(3613),
    [anon_sym__Alignas] = ACTIONS(3613),
    [sym_primitive_type] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_union] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_This] = ACTIONS(3613),
    [anon_sym_decltype] = ACTIONS(3613),
    [sym_virtual] = ACTIONS(3613),
    [anon_sym_explicit] = ACTIONS(3613),
    [anon_sym_typename] = ACTIONS(3613),
    [anon_sym_template] = ACTIONS(3613),
    [anon_sym_operator] = ACTIONS(3613),
    [anon_sym_friend] = ACTIONS(3613),
    [anon_sym_public] = ACTIONS(3613),
    [anon_sym_private] = ACTIONS(3613),
    [anon_sym_protected] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_static_assert] = ACTIONS(3613),
    [anon_sym_precise] = ACTIONS(3613),
    [anon_sym_shared] = ACTIONS(3613),
    [anon_sym_groupshared] = ACTIONS(3613),
    [anon_sym_uniform] = ACTIONS(3613),
    [anon_sym_row_major] = ACTIONS(3613),
    [anon_sym_column_major] = ACTIONS(3613),
    [anon_sym_globallycoherent] = ACTIONS(3613),
    [anon_sym_centroid] = ACTIONS(3613),
    [anon_sym_noperspective] = ACTIONS(3613),
    [anon_sym_nointerpolation] = ACTIONS(3613),
    [anon_sym_sample] = ACTIONS(3613),
    [anon_sym_linear] = ACTIONS(3613),
    [anon_sym_snorm] = ACTIONS(3613),
    [anon_sym_unorm] = ACTIONS(3613),
    [anon_sym_point] = ACTIONS(3613),
    [anon_sym_line] = ACTIONS(3613),
    [anon_sym_triangleadj] = ACTIONS(3613),
    [anon_sym_lineadj] = ACTIONS(3613),
    [anon_sym_triangle] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_extension] = ACTIONS(3613),
    [anon_sym___init] = ACTIONS(3613),
    [anon_sym___subscript] = ACTIONS(3613),
    [anon_sym_property] = ACTIONS(3613),
    [anon_sym_associatedtype] = ACTIONS(3613),
  },
  [2164] = {
    [sym_expression] = STATE(4877),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4905),
    [sym_concatenated_string] = STATE(4902),
    [sym_string_literal] = STATE(3611),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3610),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(5705),
    [anon_sym_LPAREN2] = ACTIONS(5834),
    [anon_sym_BANG] = ACTIONS(4926),
    [anon_sym_TILDE] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4928),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4924),
    [anon_sym_compl] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(5707),
    [anon_sym_PLUS_PLUS] = ACTIONS(5707),
    [anon_sym_sizeof] = ACTIONS(4932),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4934),
    [anon_sym_L_SQUOTE] = ACTIONS(4936),
    [anon_sym_u_SQUOTE] = ACTIONS(4936),
    [anon_sym_U_SQUOTE] = ACTIONS(4936),
    [anon_sym_u8_SQUOTE] = ACTIONS(4936),
    [anon_sym_SQUOTE] = ACTIONS(4936),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4938),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_co_await] = ACTIONS(4940),
    [anon_sym_new] = ACTIONS(4942),
    [anon_sym_requires] = ACTIONS(4944),
    [sym_this] = ACTIONS(241),
  },
  [2165] = {
    [sym_identifier] = ACTIONS(3613),
    [aux_sym_preproc_def_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token2] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3613),
    [sym_preproc_directive] = ACTIONS(3613),
    [anon_sym_LPAREN2] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym___extension__] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3613),
    [anon_sym_in] = ACTIONS(3613),
    [anon_sym_out] = ACTIONS(3613),
    [anon_sym_inout] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym___attribute__] = ACTIONS(3613),
    [anon_sym_COLON_COLON] = ACTIONS(3615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3615),
    [anon_sym___declspec] = ACTIONS(3613),
    [anon_sym___based] = ACTIONS(3613),
    [anon_sym_signed] = ACTIONS(3613),
    [anon_sym_unsigned] = ACTIONS(3613),
    [anon_sym_long] = ACTIONS(3613),
    [anon_sym_short] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_register] = ACTIONS(3613),
    [anon_sym_inline] = ACTIONS(3613),
    [anon_sym___inline] = ACTIONS(3613),
    [anon_sym___inline__] = ACTIONS(3613),
    [anon_sym___forceinline] = ACTIONS(3613),
    [anon_sym_thread_local] = ACTIONS(3613),
    [anon_sym___thread] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_constexpr] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_restrict] = ACTIONS(3613),
    [anon_sym___restrict__] = ACTIONS(3613),
    [anon_sym__Atomic] = ACTIONS(3613),
    [anon_sym__Noreturn] = ACTIONS(3613),
    [anon_sym_noreturn] = ACTIONS(3613),
    [anon_sym_mutable] = ACTIONS(3613),
    [anon_sym_constinit] = ACTIONS(3613),
    [anon_sym_consteval] = ACTIONS(3613),
    [anon_sym_alignas] = ACTIONS(3613),
    [anon_sym__Alignas] = ACTIONS(3613),
    [sym_primitive_type] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_union] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_This] = ACTIONS(3613),
    [anon_sym_decltype] = ACTIONS(3613),
    [sym_virtual] = ACTIONS(3613),
    [anon_sym_explicit] = ACTIONS(3613),
    [anon_sym_typename] = ACTIONS(3613),
    [anon_sym_template] = ACTIONS(3613),
    [anon_sym_operator] = ACTIONS(3613),
    [anon_sym_friend] = ACTIONS(3613),
    [anon_sym_public] = ACTIONS(3613),
    [anon_sym_private] = ACTIONS(3613),
    [anon_sym_protected] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_static_assert] = ACTIONS(3613),
    [anon_sym_precise] = ACTIONS(3613),
    [anon_sym_shared] = ACTIONS(3613),
    [anon_sym_groupshared] = ACTIONS(3613),
    [anon_sym_uniform] = ACTIONS(3613),
    [anon_sym_row_major] = ACTIONS(3613),
    [anon_sym_column_major] = ACTIONS(3613),
    [anon_sym_globallycoherent] = ACTIONS(3613),
    [anon_sym_centroid] = ACTIONS(3613),
    [anon_sym_noperspective] = ACTIONS(3613),
    [anon_sym_nointerpolation] = ACTIONS(3613),
    [anon_sym_sample] = ACTIONS(3613),
    [anon_sym_linear] = ACTIONS(3613),
    [anon_sym_snorm] = ACTIONS(3613),
    [anon_sym_unorm] = ACTIONS(3613),
    [anon_sym_point] = ACTIONS(3613),
    [anon_sym_line] = ACTIONS(3613),
    [anon_sym_triangleadj] = ACTIONS(3613),
    [anon_sym_lineadj] = ACTIONS(3613),
    [anon_sym_triangle] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_extension] = ACTIONS(3613),
    [anon_sym___init] = ACTIONS(3613),
    [anon_sym___subscript] = ACTIONS(3613),
    [anon_sym_property] = ACTIONS(3613),
    [anon_sym_associatedtype] = ACTIONS(3613),
  },
  [2166] = {
    [sym_identifier] = ACTIONS(3034),
    [aux_sym_preproc_def_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_in] = ACTIONS(3034),
    [anon_sym_out] = ACTIONS(3034),
    [anon_sym_inout] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym___based] = ACTIONS(3034),
    [anon_sym_RBRACE] = ACTIONS(3036),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_This] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [sym_virtual] = ACTIONS(3034),
    [anon_sym_explicit] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_operator] = ACTIONS(3034),
    [anon_sym_friend] = ACTIONS(3034),
    [anon_sym_public] = ACTIONS(3034),
    [anon_sym_private] = ACTIONS(3034),
    [anon_sym_protected] = ACTIONS(3034),
    [anon_sym_using] = ACTIONS(3034),
    [anon_sym_static_assert] = ACTIONS(3034),
    [anon_sym_precise] = ACTIONS(3034),
    [anon_sym_shared] = ACTIONS(3034),
    [anon_sym_groupshared] = ACTIONS(3034),
    [anon_sym_uniform] = ACTIONS(3034),
    [anon_sym_row_major] = ACTIONS(3034),
    [anon_sym_column_major] = ACTIONS(3034),
    [anon_sym_globallycoherent] = ACTIONS(3034),
    [anon_sym_centroid] = ACTIONS(3034),
    [anon_sym_noperspective] = ACTIONS(3034),
    [anon_sym_nointerpolation] = ACTIONS(3034),
    [anon_sym_sample] = ACTIONS(3034),
    [anon_sym_linear] = ACTIONS(3034),
    [anon_sym_snorm] = ACTIONS(3034),
    [anon_sym_unorm] = ACTIONS(3034),
    [anon_sym_point] = ACTIONS(3034),
    [anon_sym_line] = ACTIONS(3034),
    [anon_sym_triangleadj] = ACTIONS(3034),
    [anon_sym_lineadj] = ACTIONS(3034),
    [anon_sym_triangle] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3034),
    [anon_sym_extension] = ACTIONS(3034),
    [anon_sym___init] = ACTIONS(3034),
    [anon_sym___subscript] = ACTIONS(3034),
    [anon_sym_property] = ACTIONS(3034),
    [anon_sym_associatedtype] = ACTIONS(3034),
  },
  [2167] = {
    [sym_expression] = STATE(3698),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [2168] = {
    [sym_expression] = STATE(4480),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [2169] = {
    [sym_identifier] = ACTIONS(5532),
    [aux_sym_preproc_def_token1] = ACTIONS(5532),
    [aux_sym_preproc_if_token1] = ACTIONS(5532),
    [aux_sym_preproc_if_token2] = ACTIONS(5532),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5532),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5532),
    [sym_preproc_directive] = ACTIONS(5532),
    [anon_sym_LPAREN2] = ACTIONS(5534),
    [anon_sym_TILDE] = ACTIONS(5534),
    [anon_sym_STAR] = ACTIONS(5534),
    [anon_sym_AMP_AMP] = ACTIONS(5534),
    [anon_sym_AMP] = ACTIONS(5532),
    [anon_sym___extension__] = ACTIONS(5532),
    [anon_sym_typedef] = ACTIONS(5532),
    [anon_sym_in] = ACTIONS(5532),
    [anon_sym_out] = ACTIONS(5532),
    [anon_sym_inout] = ACTIONS(5532),
    [anon_sym_extern] = ACTIONS(5532),
    [anon_sym___attribute__] = ACTIONS(5532),
    [anon_sym_COLON_COLON] = ACTIONS(5534),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5534),
    [anon_sym___declspec] = ACTIONS(5532),
    [anon_sym___based] = ACTIONS(5532),
    [anon_sym_signed] = ACTIONS(5532),
    [anon_sym_unsigned] = ACTIONS(5532),
    [anon_sym_long] = ACTIONS(5532),
    [anon_sym_short] = ACTIONS(5532),
    [anon_sym_LBRACK] = ACTIONS(5532),
    [anon_sym_static] = ACTIONS(5532),
    [anon_sym_register] = ACTIONS(5532),
    [anon_sym_inline] = ACTIONS(5532),
    [anon_sym___inline] = ACTIONS(5532),
    [anon_sym___inline__] = ACTIONS(5532),
    [anon_sym___forceinline] = ACTIONS(5532),
    [anon_sym_thread_local] = ACTIONS(5532),
    [anon_sym___thread] = ACTIONS(5532),
    [anon_sym_const] = ACTIONS(5532),
    [anon_sym_constexpr] = ACTIONS(5532),
    [anon_sym_volatile] = ACTIONS(5532),
    [anon_sym_restrict] = ACTIONS(5532),
    [anon_sym___restrict__] = ACTIONS(5532),
    [anon_sym__Atomic] = ACTIONS(5532),
    [anon_sym__Noreturn] = ACTIONS(5532),
    [anon_sym_noreturn] = ACTIONS(5532),
    [anon_sym_mutable] = ACTIONS(5532),
    [anon_sym_constinit] = ACTIONS(5532),
    [anon_sym_consteval] = ACTIONS(5532),
    [anon_sym_alignas] = ACTIONS(5532),
    [anon_sym__Alignas] = ACTIONS(5532),
    [sym_primitive_type] = ACTIONS(5532),
    [anon_sym_enum] = ACTIONS(5532),
    [anon_sym_class] = ACTIONS(5532),
    [anon_sym_struct] = ACTIONS(5532),
    [anon_sym_union] = ACTIONS(5532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5532),
    [anon_sym_let] = ACTIONS(5532),
    [anon_sym_This] = ACTIONS(5532),
    [anon_sym_decltype] = ACTIONS(5532),
    [sym_virtual] = ACTIONS(5532),
    [anon_sym_explicit] = ACTIONS(5532),
    [anon_sym_typename] = ACTIONS(5532),
    [anon_sym_template] = ACTIONS(5532),
    [anon_sym_operator] = ACTIONS(5532),
    [anon_sym_friend] = ACTIONS(5532),
    [anon_sym_public] = ACTIONS(5532),
    [anon_sym_private] = ACTIONS(5532),
    [anon_sym_protected] = ACTIONS(5532),
    [anon_sym_using] = ACTIONS(5532),
    [anon_sym_static_assert] = ACTIONS(5532),
    [anon_sym_precise] = ACTIONS(5532),
    [anon_sym_shared] = ACTIONS(5532),
    [anon_sym_groupshared] = ACTIONS(5532),
    [anon_sym_uniform] = ACTIONS(5532),
    [anon_sym_row_major] = ACTIONS(5532),
    [anon_sym_column_major] = ACTIONS(5532),
    [anon_sym_globallycoherent] = ACTIONS(5532),
    [anon_sym_centroid] = ACTIONS(5532),
    [anon_sym_noperspective] = ACTIONS(5532),
    [anon_sym_nointerpolation] = ACTIONS(5532),
    [anon_sym_sample] = ACTIONS(5532),
    [anon_sym_linear] = ACTIONS(5532),
    [anon_sym_snorm] = ACTIONS(5532),
    [anon_sym_unorm] = ACTIONS(5532),
    [anon_sym_point] = ACTIONS(5532),
    [anon_sym_line] = ACTIONS(5532),
    [anon_sym_triangleadj] = ACTIONS(5532),
    [anon_sym_lineadj] = ACTIONS(5532),
    [anon_sym_triangle] = ACTIONS(5532),
    [anon_sym_interface] = ACTIONS(5532),
    [anon_sym_extension] = ACTIONS(5532),
    [anon_sym___init] = ACTIONS(5532),
    [anon_sym___subscript] = ACTIONS(5532),
    [anon_sym_property] = ACTIONS(5532),
    [anon_sym_associatedtype] = ACTIONS(5532),
  },
  [2170] = {
    [sym_identifier] = ACTIONS(5522),
    [aux_sym_preproc_def_token1] = ACTIONS(5522),
    [aux_sym_preproc_if_token1] = ACTIONS(5522),
    [aux_sym_preproc_if_token2] = ACTIONS(5522),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5522),
    [sym_preproc_directive] = ACTIONS(5522),
    [anon_sym_LPAREN2] = ACTIONS(5524),
    [anon_sym_TILDE] = ACTIONS(5524),
    [anon_sym_STAR] = ACTIONS(5524),
    [anon_sym_AMP_AMP] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5522),
    [anon_sym___extension__] = ACTIONS(5522),
    [anon_sym_typedef] = ACTIONS(5522),
    [anon_sym_in] = ACTIONS(5522),
    [anon_sym_out] = ACTIONS(5522),
    [anon_sym_inout] = ACTIONS(5522),
    [anon_sym_extern] = ACTIONS(5522),
    [anon_sym___attribute__] = ACTIONS(5522),
    [anon_sym_COLON_COLON] = ACTIONS(5524),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5524),
    [anon_sym___declspec] = ACTIONS(5522),
    [anon_sym___based] = ACTIONS(5522),
    [anon_sym_signed] = ACTIONS(5522),
    [anon_sym_unsigned] = ACTIONS(5522),
    [anon_sym_long] = ACTIONS(5522),
    [anon_sym_short] = ACTIONS(5522),
    [anon_sym_LBRACK] = ACTIONS(5522),
    [anon_sym_static] = ACTIONS(5522),
    [anon_sym_register] = ACTIONS(5522),
    [anon_sym_inline] = ACTIONS(5522),
    [anon_sym___inline] = ACTIONS(5522),
    [anon_sym___inline__] = ACTIONS(5522),
    [anon_sym___forceinline] = ACTIONS(5522),
    [anon_sym_thread_local] = ACTIONS(5522),
    [anon_sym___thread] = ACTIONS(5522),
    [anon_sym_const] = ACTIONS(5522),
    [anon_sym_constexpr] = ACTIONS(5522),
    [anon_sym_volatile] = ACTIONS(5522),
    [anon_sym_restrict] = ACTIONS(5522),
    [anon_sym___restrict__] = ACTIONS(5522),
    [anon_sym__Atomic] = ACTIONS(5522),
    [anon_sym__Noreturn] = ACTIONS(5522),
    [anon_sym_noreturn] = ACTIONS(5522),
    [anon_sym_mutable] = ACTIONS(5522),
    [anon_sym_constinit] = ACTIONS(5522),
    [anon_sym_consteval] = ACTIONS(5522),
    [anon_sym_alignas] = ACTIONS(5522),
    [anon_sym__Alignas] = ACTIONS(5522),
    [sym_primitive_type] = ACTIONS(5522),
    [anon_sym_enum] = ACTIONS(5522),
    [anon_sym_class] = ACTIONS(5522),
    [anon_sym_struct] = ACTIONS(5522),
    [anon_sym_union] = ACTIONS(5522),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5522),
    [anon_sym_let] = ACTIONS(5522),
    [anon_sym_This] = ACTIONS(5522),
    [anon_sym_decltype] = ACTIONS(5522),
    [sym_virtual] = ACTIONS(5522),
    [anon_sym_explicit] = ACTIONS(5522),
    [anon_sym_typename] = ACTIONS(5522),
    [anon_sym_template] = ACTIONS(5522),
    [anon_sym_operator] = ACTIONS(5522),
    [anon_sym_friend] = ACTIONS(5522),
    [anon_sym_public] = ACTIONS(5522),
    [anon_sym_private] = ACTIONS(5522),
    [anon_sym_protected] = ACTIONS(5522),
    [anon_sym_using] = ACTIONS(5522),
    [anon_sym_static_assert] = ACTIONS(5522),
    [anon_sym_precise] = ACTIONS(5522),
    [anon_sym_shared] = ACTIONS(5522),
    [anon_sym_groupshared] = ACTIONS(5522),
    [anon_sym_uniform] = ACTIONS(5522),
    [anon_sym_row_major] = ACTIONS(5522),
    [anon_sym_column_major] = ACTIONS(5522),
    [anon_sym_globallycoherent] = ACTIONS(5522),
    [anon_sym_centroid] = ACTIONS(5522),
    [anon_sym_noperspective] = ACTIONS(5522),
    [anon_sym_nointerpolation] = ACTIONS(5522),
    [anon_sym_sample] = ACTIONS(5522),
    [anon_sym_linear] = ACTIONS(5522),
    [anon_sym_snorm] = ACTIONS(5522),
    [anon_sym_unorm] = ACTIONS(5522),
    [anon_sym_point] = ACTIONS(5522),
    [anon_sym_line] = ACTIONS(5522),
    [anon_sym_triangleadj] = ACTIONS(5522),
    [anon_sym_lineadj] = ACTIONS(5522),
    [anon_sym_triangle] = ACTIONS(5522),
    [anon_sym_interface] = ACTIONS(5522),
    [anon_sym_extension] = ACTIONS(5522),
    [anon_sym___init] = ACTIONS(5522),
    [anon_sym___subscript] = ACTIONS(5522),
    [anon_sym_property] = ACTIONS(5522),
    [anon_sym_associatedtype] = ACTIONS(5522),
  },
  [2171] = {
    [sym_expression] = STATE(3213),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3481),
    [sym_concatenated_string] = STATE(3486),
    [sym_string_literal] = STATE(2963),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2960),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5795),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4412),
    [anon_sym_PLUS] = ACTIONS(4412),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4416),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4412),
    [anon_sym_compl] = ACTIONS(4412),
    [anon_sym_DASH_DASH] = ACTIONS(5756),
    [anon_sym_PLUS_PLUS] = ACTIONS(5756),
    [anon_sym_sizeof] = ACTIONS(4422),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4432),
    [anon_sym_L_SQUOTE] = ACTIONS(4434),
    [anon_sym_u_SQUOTE] = ACTIONS(4434),
    [anon_sym_U_SQUOTE] = ACTIONS(4434),
    [anon_sym_u8_SQUOTE] = ACTIONS(4434),
    [anon_sym_SQUOTE] = ACTIONS(4434),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4442),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [anon_sym_co_await] = ACTIONS(4446),
    [anon_sym_new] = ACTIONS(4448),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2172] = {
    [sym_expression] = STATE(3224),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3481),
    [sym_concatenated_string] = STATE(3486),
    [sym_string_literal] = STATE(2963),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2960),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5795),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4412),
    [anon_sym_PLUS] = ACTIONS(4412),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4416),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4412),
    [anon_sym_compl] = ACTIONS(4412),
    [anon_sym_DASH_DASH] = ACTIONS(5756),
    [anon_sym_PLUS_PLUS] = ACTIONS(5756),
    [anon_sym_sizeof] = ACTIONS(4422),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4432),
    [anon_sym_L_SQUOTE] = ACTIONS(4434),
    [anon_sym_u_SQUOTE] = ACTIONS(4434),
    [anon_sym_U_SQUOTE] = ACTIONS(4434),
    [anon_sym_u8_SQUOTE] = ACTIONS(4434),
    [anon_sym_SQUOTE] = ACTIONS(4434),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4442),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [anon_sym_co_await] = ACTIONS(4446),
    [anon_sym_new] = ACTIONS(4448),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2173] = {
    [sym_identifier] = ACTIONS(3497),
    [aux_sym_preproc_def_token1] = ACTIONS(3497),
    [aux_sym_preproc_if_token1] = ACTIONS(3497),
    [aux_sym_preproc_if_token2] = ACTIONS(3497),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3497),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3497),
    [sym_preproc_directive] = ACTIONS(3497),
    [anon_sym_LPAREN2] = ACTIONS(3499),
    [anon_sym_TILDE] = ACTIONS(3499),
    [anon_sym_STAR] = ACTIONS(3499),
    [anon_sym_AMP_AMP] = ACTIONS(3499),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym___extension__] = ACTIONS(3497),
    [anon_sym_typedef] = ACTIONS(3497),
    [anon_sym_in] = ACTIONS(3497),
    [anon_sym_out] = ACTIONS(3497),
    [anon_sym_inout] = ACTIONS(3497),
    [anon_sym_extern] = ACTIONS(3497),
    [anon_sym___attribute__] = ACTIONS(3497),
    [anon_sym_COLON_COLON] = ACTIONS(3499),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3499),
    [anon_sym___declspec] = ACTIONS(3497),
    [anon_sym___based] = ACTIONS(3497),
    [anon_sym_signed] = ACTIONS(3497),
    [anon_sym_unsigned] = ACTIONS(3497),
    [anon_sym_long] = ACTIONS(3497),
    [anon_sym_short] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3497),
    [anon_sym_static] = ACTIONS(3497),
    [anon_sym_register] = ACTIONS(3497),
    [anon_sym_inline] = ACTIONS(3497),
    [anon_sym___inline] = ACTIONS(3497),
    [anon_sym___inline__] = ACTIONS(3497),
    [anon_sym___forceinline] = ACTIONS(3497),
    [anon_sym_thread_local] = ACTIONS(3497),
    [anon_sym___thread] = ACTIONS(3497),
    [anon_sym_const] = ACTIONS(3497),
    [anon_sym_constexpr] = ACTIONS(3497),
    [anon_sym_volatile] = ACTIONS(3497),
    [anon_sym_restrict] = ACTIONS(3497),
    [anon_sym___restrict__] = ACTIONS(3497),
    [anon_sym__Atomic] = ACTIONS(3497),
    [anon_sym__Noreturn] = ACTIONS(3497),
    [anon_sym_noreturn] = ACTIONS(3497),
    [anon_sym_mutable] = ACTIONS(3497),
    [anon_sym_constinit] = ACTIONS(3497),
    [anon_sym_consteval] = ACTIONS(3497),
    [anon_sym_alignas] = ACTIONS(3497),
    [anon_sym__Alignas] = ACTIONS(3497),
    [sym_primitive_type] = ACTIONS(3497),
    [anon_sym_enum] = ACTIONS(3497),
    [anon_sym_class] = ACTIONS(3497),
    [anon_sym_struct] = ACTIONS(3497),
    [anon_sym_union] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3497),
    [anon_sym_let] = ACTIONS(3497),
    [anon_sym_This] = ACTIONS(3497),
    [anon_sym_decltype] = ACTIONS(3497),
    [sym_virtual] = ACTIONS(3497),
    [anon_sym_explicit] = ACTIONS(3497),
    [anon_sym_typename] = ACTIONS(3497),
    [anon_sym_template] = ACTIONS(3497),
    [anon_sym_operator] = ACTIONS(3497),
    [anon_sym_friend] = ACTIONS(3497),
    [anon_sym_public] = ACTIONS(3497),
    [anon_sym_private] = ACTIONS(3497),
    [anon_sym_protected] = ACTIONS(3497),
    [anon_sym_using] = ACTIONS(3497),
    [anon_sym_static_assert] = ACTIONS(3497),
    [anon_sym_precise] = ACTIONS(3497),
    [anon_sym_shared] = ACTIONS(3497),
    [anon_sym_groupshared] = ACTIONS(3497),
    [anon_sym_uniform] = ACTIONS(3497),
    [anon_sym_row_major] = ACTIONS(3497),
    [anon_sym_column_major] = ACTIONS(3497),
    [anon_sym_globallycoherent] = ACTIONS(3497),
    [anon_sym_centroid] = ACTIONS(3497),
    [anon_sym_noperspective] = ACTIONS(3497),
    [anon_sym_nointerpolation] = ACTIONS(3497),
    [anon_sym_sample] = ACTIONS(3497),
    [anon_sym_linear] = ACTIONS(3497),
    [anon_sym_snorm] = ACTIONS(3497),
    [anon_sym_unorm] = ACTIONS(3497),
    [anon_sym_point] = ACTIONS(3497),
    [anon_sym_line] = ACTIONS(3497),
    [anon_sym_triangleadj] = ACTIONS(3497),
    [anon_sym_lineadj] = ACTIONS(3497),
    [anon_sym_triangle] = ACTIONS(3497),
    [anon_sym_interface] = ACTIONS(3497),
    [anon_sym_extension] = ACTIONS(3497),
    [anon_sym___init] = ACTIONS(3497),
    [anon_sym___subscript] = ACTIONS(3497),
    [anon_sym_property] = ACTIONS(3497),
    [anon_sym_associatedtype] = ACTIONS(3497),
  },
  [2174] = {
    [sym_expression] = STATE(5464),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2175] = {
    [sym_identifier] = ACTIONS(5518),
    [aux_sym_preproc_def_token1] = ACTIONS(5518),
    [aux_sym_preproc_if_token1] = ACTIONS(5518),
    [aux_sym_preproc_if_token2] = ACTIONS(5518),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5518),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5518),
    [sym_preproc_directive] = ACTIONS(5518),
    [anon_sym_LPAREN2] = ACTIONS(5520),
    [anon_sym_TILDE] = ACTIONS(5520),
    [anon_sym_STAR] = ACTIONS(5520),
    [anon_sym_AMP_AMP] = ACTIONS(5520),
    [anon_sym_AMP] = ACTIONS(5518),
    [anon_sym___extension__] = ACTIONS(5518),
    [anon_sym_typedef] = ACTIONS(5518),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_inout] = ACTIONS(5518),
    [anon_sym_extern] = ACTIONS(5518),
    [anon_sym___attribute__] = ACTIONS(5518),
    [anon_sym_COLON_COLON] = ACTIONS(5520),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5520),
    [anon_sym___declspec] = ACTIONS(5518),
    [anon_sym___based] = ACTIONS(5518),
    [anon_sym_signed] = ACTIONS(5518),
    [anon_sym_unsigned] = ACTIONS(5518),
    [anon_sym_long] = ACTIONS(5518),
    [anon_sym_short] = ACTIONS(5518),
    [anon_sym_LBRACK] = ACTIONS(5518),
    [anon_sym_static] = ACTIONS(5518),
    [anon_sym_register] = ACTIONS(5518),
    [anon_sym_inline] = ACTIONS(5518),
    [anon_sym___inline] = ACTIONS(5518),
    [anon_sym___inline__] = ACTIONS(5518),
    [anon_sym___forceinline] = ACTIONS(5518),
    [anon_sym_thread_local] = ACTIONS(5518),
    [anon_sym___thread] = ACTIONS(5518),
    [anon_sym_const] = ACTIONS(5518),
    [anon_sym_constexpr] = ACTIONS(5518),
    [anon_sym_volatile] = ACTIONS(5518),
    [anon_sym_restrict] = ACTIONS(5518),
    [anon_sym___restrict__] = ACTIONS(5518),
    [anon_sym__Atomic] = ACTIONS(5518),
    [anon_sym__Noreturn] = ACTIONS(5518),
    [anon_sym_noreturn] = ACTIONS(5518),
    [anon_sym_mutable] = ACTIONS(5518),
    [anon_sym_constinit] = ACTIONS(5518),
    [anon_sym_consteval] = ACTIONS(5518),
    [anon_sym_alignas] = ACTIONS(5518),
    [anon_sym__Alignas] = ACTIONS(5518),
    [sym_primitive_type] = ACTIONS(5518),
    [anon_sym_enum] = ACTIONS(5518),
    [anon_sym_class] = ACTIONS(5518),
    [anon_sym_struct] = ACTIONS(5518),
    [anon_sym_union] = ACTIONS(5518),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5518),
    [anon_sym_let] = ACTIONS(5518),
    [anon_sym_This] = ACTIONS(5518),
    [anon_sym_decltype] = ACTIONS(5518),
    [sym_virtual] = ACTIONS(5518),
    [anon_sym_explicit] = ACTIONS(5518),
    [anon_sym_typename] = ACTIONS(5518),
    [anon_sym_template] = ACTIONS(5518),
    [anon_sym_operator] = ACTIONS(5518),
    [anon_sym_friend] = ACTIONS(5518),
    [anon_sym_public] = ACTIONS(5518),
    [anon_sym_private] = ACTIONS(5518),
    [anon_sym_protected] = ACTIONS(5518),
    [anon_sym_using] = ACTIONS(5518),
    [anon_sym_static_assert] = ACTIONS(5518),
    [anon_sym_precise] = ACTIONS(5518),
    [anon_sym_shared] = ACTIONS(5518),
    [anon_sym_groupshared] = ACTIONS(5518),
    [anon_sym_uniform] = ACTIONS(5518),
    [anon_sym_row_major] = ACTIONS(5518),
    [anon_sym_column_major] = ACTIONS(5518),
    [anon_sym_globallycoherent] = ACTIONS(5518),
    [anon_sym_centroid] = ACTIONS(5518),
    [anon_sym_noperspective] = ACTIONS(5518),
    [anon_sym_nointerpolation] = ACTIONS(5518),
    [anon_sym_sample] = ACTIONS(5518),
    [anon_sym_linear] = ACTIONS(5518),
    [anon_sym_snorm] = ACTIONS(5518),
    [anon_sym_unorm] = ACTIONS(5518),
    [anon_sym_point] = ACTIONS(5518),
    [anon_sym_line] = ACTIONS(5518),
    [anon_sym_triangleadj] = ACTIONS(5518),
    [anon_sym_lineadj] = ACTIONS(5518),
    [anon_sym_triangle] = ACTIONS(5518),
    [anon_sym_interface] = ACTIONS(5518),
    [anon_sym_extension] = ACTIONS(5518),
    [anon_sym___init] = ACTIONS(5518),
    [anon_sym___subscript] = ACTIONS(5518),
    [anon_sym_property] = ACTIONS(5518),
    [anon_sym_associatedtype] = ACTIONS(5518),
  },
  [2176] = {
    [sym_identifier] = ACTIONS(5522),
    [aux_sym_preproc_def_token1] = ACTIONS(5522),
    [aux_sym_preproc_if_token1] = ACTIONS(5522),
    [aux_sym_preproc_if_token2] = ACTIONS(5522),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5522),
    [sym_preproc_directive] = ACTIONS(5522),
    [anon_sym_LPAREN2] = ACTIONS(5524),
    [anon_sym_TILDE] = ACTIONS(5524),
    [anon_sym_STAR] = ACTIONS(5524),
    [anon_sym_AMP_AMP] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5522),
    [anon_sym___extension__] = ACTIONS(5522),
    [anon_sym_typedef] = ACTIONS(5522),
    [anon_sym_in] = ACTIONS(5522),
    [anon_sym_out] = ACTIONS(5522),
    [anon_sym_inout] = ACTIONS(5522),
    [anon_sym_extern] = ACTIONS(5522),
    [anon_sym___attribute__] = ACTIONS(5522),
    [anon_sym_COLON_COLON] = ACTIONS(5524),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5524),
    [anon_sym___declspec] = ACTIONS(5522),
    [anon_sym___based] = ACTIONS(5522),
    [anon_sym_signed] = ACTIONS(5522),
    [anon_sym_unsigned] = ACTIONS(5522),
    [anon_sym_long] = ACTIONS(5522),
    [anon_sym_short] = ACTIONS(5522),
    [anon_sym_LBRACK] = ACTIONS(5522),
    [anon_sym_static] = ACTIONS(5522),
    [anon_sym_register] = ACTIONS(5522),
    [anon_sym_inline] = ACTIONS(5522),
    [anon_sym___inline] = ACTIONS(5522),
    [anon_sym___inline__] = ACTIONS(5522),
    [anon_sym___forceinline] = ACTIONS(5522),
    [anon_sym_thread_local] = ACTIONS(5522),
    [anon_sym___thread] = ACTIONS(5522),
    [anon_sym_const] = ACTIONS(5522),
    [anon_sym_constexpr] = ACTIONS(5522),
    [anon_sym_volatile] = ACTIONS(5522),
    [anon_sym_restrict] = ACTIONS(5522),
    [anon_sym___restrict__] = ACTIONS(5522),
    [anon_sym__Atomic] = ACTIONS(5522),
    [anon_sym__Noreturn] = ACTIONS(5522),
    [anon_sym_noreturn] = ACTIONS(5522),
    [anon_sym_mutable] = ACTIONS(5522),
    [anon_sym_constinit] = ACTIONS(5522),
    [anon_sym_consteval] = ACTIONS(5522),
    [anon_sym_alignas] = ACTIONS(5522),
    [anon_sym__Alignas] = ACTIONS(5522),
    [sym_primitive_type] = ACTIONS(5522),
    [anon_sym_enum] = ACTIONS(5522),
    [anon_sym_class] = ACTIONS(5522),
    [anon_sym_struct] = ACTIONS(5522),
    [anon_sym_union] = ACTIONS(5522),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5522),
    [anon_sym_let] = ACTIONS(5522),
    [anon_sym_This] = ACTIONS(5522),
    [anon_sym_decltype] = ACTIONS(5522),
    [sym_virtual] = ACTIONS(5522),
    [anon_sym_explicit] = ACTIONS(5522),
    [anon_sym_typename] = ACTIONS(5522),
    [anon_sym_template] = ACTIONS(5522),
    [anon_sym_operator] = ACTIONS(5522),
    [anon_sym_friend] = ACTIONS(5522),
    [anon_sym_public] = ACTIONS(5522),
    [anon_sym_private] = ACTIONS(5522),
    [anon_sym_protected] = ACTIONS(5522),
    [anon_sym_using] = ACTIONS(5522),
    [anon_sym_static_assert] = ACTIONS(5522),
    [anon_sym_precise] = ACTIONS(5522),
    [anon_sym_shared] = ACTIONS(5522),
    [anon_sym_groupshared] = ACTIONS(5522),
    [anon_sym_uniform] = ACTIONS(5522),
    [anon_sym_row_major] = ACTIONS(5522),
    [anon_sym_column_major] = ACTIONS(5522),
    [anon_sym_globallycoherent] = ACTIONS(5522),
    [anon_sym_centroid] = ACTIONS(5522),
    [anon_sym_noperspective] = ACTIONS(5522),
    [anon_sym_nointerpolation] = ACTIONS(5522),
    [anon_sym_sample] = ACTIONS(5522),
    [anon_sym_linear] = ACTIONS(5522),
    [anon_sym_snorm] = ACTIONS(5522),
    [anon_sym_unorm] = ACTIONS(5522),
    [anon_sym_point] = ACTIONS(5522),
    [anon_sym_line] = ACTIONS(5522),
    [anon_sym_triangleadj] = ACTIONS(5522),
    [anon_sym_lineadj] = ACTIONS(5522),
    [anon_sym_triangle] = ACTIONS(5522),
    [anon_sym_interface] = ACTIONS(5522),
    [anon_sym_extension] = ACTIONS(5522),
    [anon_sym___init] = ACTIONS(5522),
    [anon_sym___subscript] = ACTIONS(5522),
    [anon_sym_property] = ACTIONS(5522),
    [anon_sym_associatedtype] = ACTIONS(5522),
  },
  [2177] = {
    [sym_identifier] = ACTIONS(5560),
    [aux_sym_preproc_def_token1] = ACTIONS(5560),
    [aux_sym_preproc_if_token1] = ACTIONS(5560),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5560),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5560),
    [sym_preproc_directive] = ACTIONS(5560),
    [anon_sym_LPAREN2] = ACTIONS(5562),
    [anon_sym_TILDE] = ACTIONS(5562),
    [anon_sym_STAR] = ACTIONS(5562),
    [anon_sym_AMP_AMP] = ACTIONS(5562),
    [anon_sym_AMP] = ACTIONS(5560),
    [anon_sym___extension__] = ACTIONS(5560),
    [anon_sym_typedef] = ACTIONS(5560),
    [anon_sym_in] = ACTIONS(5560),
    [anon_sym_out] = ACTIONS(5560),
    [anon_sym_inout] = ACTIONS(5560),
    [anon_sym_extern] = ACTIONS(5560),
    [anon_sym___attribute__] = ACTIONS(5560),
    [anon_sym_COLON_COLON] = ACTIONS(5562),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5562),
    [anon_sym___declspec] = ACTIONS(5560),
    [anon_sym___based] = ACTIONS(5560),
    [anon_sym_RBRACE] = ACTIONS(5562),
    [anon_sym_signed] = ACTIONS(5560),
    [anon_sym_unsigned] = ACTIONS(5560),
    [anon_sym_long] = ACTIONS(5560),
    [anon_sym_short] = ACTIONS(5560),
    [anon_sym_LBRACK] = ACTIONS(5560),
    [anon_sym_static] = ACTIONS(5560),
    [anon_sym_register] = ACTIONS(5560),
    [anon_sym_inline] = ACTIONS(5560),
    [anon_sym___inline] = ACTIONS(5560),
    [anon_sym___inline__] = ACTIONS(5560),
    [anon_sym___forceinline] = ACTIONS(5560),
    [anon_sym_thread_local] = ACTIONS(5560),
    [anon_sym___thread] = ACTIONS(5560),
    [anon_sym_const] = ACTIONS(5560),
    [anon_sym_constexpr] = ACTIONS(5560),
    [anon_sym_volatile] = ACTIONS(5560),
    [anon_sym_restrict] = ACTIONS(5560),
    [anon_sym___restrict__] = ACTIONS(5560),
    [anon_sym__Atomic] = ACTIONS(5560),
    [anon_sym__Noreturn] = ACTIONS(5560),
    [anon_sym_noreturn] = ACTIONS(5560),
    [anon_sym_mutable] = ACTIONS(5560),
    [anon_sym_constinit] = ACTIONS(5560),
    [anon_sym_consteval] = ACTIONS(5560),
    [anon_sym_alignas] = ACTIONS(5560),
    [anon_sym__Alignas] = ACTIONS(5560),
    [sym_primitive_type] = ACTIONS(5560),
    [anon_sym_enum] = ACTIONS(5560),
    [anon_sym_class] = ACTIONS(5560),
    [anon_sym_struct] = ACTIONS(5560),
    [anon_sym_union] = ACTIONS(5560),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5560),
    [anon_sym_let] = ACTIONS(5560),
    [anon_sym_This] = ACTIONS(5560),
    [anon_sym_decltype] = ACTIONS(5560),
    [sym_virtual] = ACTIONS(5560),
    [anon_sym_explicit] = ACTIONS(5560),
    [anon_sym_typename] = ACTIONS(5560),
    [anon_sym_template] = ACTIONS(5560),
    [anon_sym_operator] = ACTIONS(5560),
    [anon_sym_friend] = ACTIONS(5560),
    [anon_sym_public] = ACTIONS(5560),
    [anon_sym_private] = ACTIONS(5560),
    [anon_sym_protected] = ACTIONS(5560),
    [anon_sym_using] = ACTIONS(5560),
    [anon_sym_static_assert] = ACTIONS(5560),
    [anon_sym_precise] = ACTIONS(5560),
    [anon_sym_shared] = ACTIONS(5560),
    [anon_sym_groupshared] = ACTIONS(5560),
    [anon_sym_uniform] = ACTIONS(5560),
    [anon_sym_row_major] = ACTIONS(5560),
    [anon_sym_column_major] = ACTIONS(5560),
    [anon_sym_globallycoherent] = ACTIONS(5560),
    [anon_sym_centroid] = ACTIONS(5560),
    [anon_sym_noperspective] = ACTIONS(5560),
    [anon_sym_nointerpolation] = ACTIONS(5560),
    [anon_sym_sample] = ACTIONS(5560),
    [anon_sym_linear] = ACTIONS(5560),
    [anon_sym_snorm] = ACTIONS(5560),
    [anon_sym_unorm] = ACTIONS(5560),
    [anon_sym_point] = ACTIONS(5560),
    [anon_sym_line] = ACTIONS(5560),
    [anon_sym_triangleadj] = ACTIONS(5560),
    [anon_sym_lineadj] = ACTIONS(5560),
    [anon_sym_triangle] = ACTIONS(5560),
    [anon_sym_interface] = ACTIONS(5560),
    [anon_sym_extension] = ACTIONS(5560),
    [anon_sym___init] = ACTIONS(5560),
    [anon_sym___subscript] = ACTIONS(5560),
    [anon_sym_property] = ACTIONS(5560),
    [anon_sym_associatedtype] = ACTIONS(5560),
  },
  [2178] = {
    [sym_identifier] = ACTIONS(5518),
    [aux_sym_preproc_def_token1] = ACTIONS(5518),
    [aux_sym_preproc_if_token1] = ACTIONS(5518),
    [aux_sym_preproc_if_token2] = ACTIONS(5518),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5518),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5518),
    [sym_preproc_directive] = ACTIONS(5518),
    [anon_sym_LPAREN2] = ACTIONS(5520),
    [anon_sym_TILDE] = ACTIONS(5520),
    [anon_sym_STAR] = ACTIONS(5520),
    [anon_sym_AMP_AMP] = ACTIONS(5520),
    [anon_sym_AMP] = ACTIONS(5518),
    [anon_sym___extension__] = ACTIONS(5518),
    [anon_sym_typedef] = ACTIONS(5518),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_inout] = ACTIONS(5518),
    [anon_sym_extern] = ACTIONS(5518),
    [anon_sym___attribute__] = ACTIONS(5518),
    [anon_sym_COLON_COLON] = ACTIONS(5520),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5520),
    [anon_sym___declspec] = ACTIONS(5518),
    [anon_sym___based] = ACTIONS(5518),
    [anon_sym_signed] = ACTIONS(5518),
    [anon_sym_unsigned] = ACTIONS(5518),
    [anon_sym_long] = ACTIONS(5518),
    [anon_sym_short] = ACTIONS(5518),
    [anon_sym_LBRACK] = ACTIONS(5518),
    [anon_sym_static] = ACTIONS(5518),
    [anon_sym_register] = ACTIONS(5518),
    [anon_sym_inline] = ACTIONS(5518),
    [anon_sym___inline] = ACTIONS(5518),
    [anon_sym___inline__] = ACTIONS(5518),
    [anon_sym___forceinline] = ACTIONS(5518),
    [anon_sym_thread_local] = ACTIONS(5518),
    [anon_sym___thread] = ACTIONS(5518),
    [anon_sym_const] = ACTIONS(5518),
    [anon_sym_constexpr] = ACTIONS(5518),
    [anon_sym_volatile] = ACTIONS(5518),
    [anon_sym_restrict] = ACTIONS(5518),
    [anon_sym___restrict__] = ACTIONS(5518),
    [anon_sym__Atomic] = ACTIONS(5518),
    [anon_sym__Noreturn] = ACTIONS(5518),
    [anon_sym_noreturn] = ACTIONS(5518),
    [anon_sym_mutable] = ACTIONS(5518),
    [anon_sym_constinit] = ACTIONS(5518),
    [anon_sym_consteval] = ACTIONS(5518),
    [anon_sym_alignas] = ACTIONS(5518),
    [anon_sym__Alignas] = ACTIONS(5518),
    [sym_primitive_type] = ACTIONS(5518),
    [anon_sym_enum] = ACTIONS(5518),
    [anon_sym_class] = ACTIONS(5518),
    [anon_sym_struct] = ACTIONS(5518),
    [anon_sym_union] = ACTIONS(5518),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5518),
    [anon_sym_let] = ACTIONS(5518),
    [anon_sym_This] = ACTIONS(5518),
    [anon_sym_decltype] = ACTIONS(5518),
    [sym_virtual] = ACTIONS(5518),
    [anon_sym_explicit] = ACTIONS(5518),
    [anon_sym_typename] = ACTIONS(5518),
    [anon_sym_template] = ACTIONS(5518),
    [anon_sym_operator] = ACTIONS(5518),
    [anon_sym_friend] = ACTIONS(5518),
    [anon_sym_public] = ACTIONS(5518),
    [anon_sym_private] = ACTIONS(5518),
    [anon_sym_protected] = ACTIONS(5518),
    [anon_sym_using] = ACTIONS(5518),
    [anon_sym_static_assert] = ACTIONS(5518),
    [anon_sym_precise] = ACTIONS(5518),
    [anon_sym_shared] = ACTIONS(5518),
    [anon_sym_groupshared] = ACTIONS(5518),
    [anon_sym_uniform] = ACTIONS(5518),
    [anon_sym_row_major] = ACTIONS(5518),
    [anon_sym_column_major] = ACTIONS(5518),
    [anon_sym_globallycoherent] = ACTIONS(5518),
    [anon_sym_centroid] = ACTIONS(5518),
    [anon_sym_noperspective] = ACTIONS(5518),
    [anon_sym_nointerpolation] = ACTIONS(5518),
    [anon_sym_sample] = ACTIONS(5518),
    [anon_sym_linear] = ACTIONS(5518),
    [anon_sym_snorm] = ACTIONS(5518),
    [anon_sym_unorm] = ACTIONS(5518),
    [anon_sym_point] = ACTIONS(5518),
    [anon_sym_line] = ACTIONS(5518),
    [anon_sym_triangleadj] = ACTIONS(5518),
    [anon_sym_lineadj] = ACTIONS(5518),
    [anon_sym_triangle] = ACTIONS(5518),
    [anon_sym_interface] = ACTIONS(5518),
    [anon_sym_extension] = ACTIONS(5518),
    [anon_sym___init] = ACTIONS(5518),
    [anon_sym___subscript] = ACTIONS(5518),
    [anon_sym_property] = ACTIONS(5518),
    [anon_sym_associatedtype] = ACTIONS(5518),
  },
  [2179] = {
    [sym_expression] = STATE(4599),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2180] = {
    [sym_identifier] = ACTIONS(3497),
    [aux_sym_preproc_def_token1] = ACTIONS(3497),
    [aux_sym_preproc_if_token1] = ACTIONS(3497),
    [aux_sym_preproc_if_token2] = ACTIONS(3497),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3497),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3497),
    [sym_preproc_directive] = ACTIONS(3497),
    [anon_sym_LPAREN2] = ACTIONS(3499),
    [anon_sym_TILDE] = ACTIONS(3499),
    [anon_sym_STAR] = ACTIONS(3499),
    [anon_sym_AMP_AMP] = ACTIONS(3499),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym___extension__] = ACTIONS(3497),
    [anon_sym_typedef] = ACTIONS(3497),
    [anon_sym_in] = ACTIONS(3497),
    [anon_sym_out] = ACTIONS(3497),
    [anon_sym_inout] = ACTIONS(3497),
    [anon_sym_extern] = ACTIONS(3497),
    [anon_sym___attribute__] = ACTIONS(3497),
    [anon_sym_COLON_COLON] = ACTIONS(3499),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3499),
    [anon_sym___declspec] = ACTIONS(3497),
    [anon_sym___based] = ACTIONS(3497),
    [anon_sym_signed] = ACTIONS(3497),
    [anon_sym_unsigned] = ACTIONS(3497),
    [anon_sym_long] = ACTIONS(3497),
    [anon_sym_short] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3497),
    [anon_sym_static] = ACTIONS(3497),
    [anon_sym_register] = ACTIONS(3497),
    [anon_sym_inline] = ACTIONS(3497),
    [anon_sym___inline] = ACTIONS(3497),
    [anon_sym___inline__] = ACTIONS(3497),
    [anon_sym___forceinline] = ACTIONS(3497),
    [anon_sym_thread_local] = ACTIONS(3497),
    [anon_sym___thread] = ACTIONS(3497),
    [anon_sym_const] = ACTIONS(3497),
    [anon_sym_constexpr] = ACTIONS(3497),
    [anon_sym_volatile] = ACTIONS(3497),
    [anon_sym_restrict] = ACTIONS(3497),
    [anon_sym___restrict__] = ACTIONS(3497),
    [anon_sym__Atomic] = ACTIONS(3497),
    [anon_sym__Noreturn] = ACTIONS(3497),
    [anon_sym_noreturn] = ACTIONS(3497),
    [anon_sym_mutable] = ACTIONS(3497),
    [anon_sym_constinit] = ACTIONS(3497),
    [anon_sym_consteval] = ACTIONS(3497),
    [anon_sym_alignas] = ACTIONS(3497),
    [anon_sym__Alignas] = ACTIONS(3497),
    [sym_primitive_type] = ACTIONS(3497),
    [anon_sym_enum] = ACTIONS(3497),
    [anon_sym_class] = ACTIONS(3497),
    [anon_sym_struct] = ACTIONS(3497),
    [anon_sym_union] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3497),
    [anon_sym_let] = ACTIONS(3497),
    [anon_sym_This] = ACTIONS(3497),
    [anon_sym_decltype] = ACTIONS(3497),
    [sym_virtual] = ACTIONS(3497),
    [anon_sym_explicit] = ACTIONS(3497),
    [anon_sym_typename] = ACTIONS(3497),
    [anon_sym_template] = ACTIONS(3497),
    [anon_sym_operator] = ACTIONS(3497),
    [anon_sym_friend] = ACTIONS(3497),
    [anon_sym_public] = ACTIONS(3497),
    [anon_sym_private] = ACTIONS(3497),
    [anon_sym_protected] = ACTIONS(3497),
    [anon_sym_using] = ACTIONS(3497),
    [anon_sym_static_assert] = ACTIONS(3497),
    [anon_sym_precise] = ACTIONS(3497),
    [anon_sym_shared] = ACTIONS(3497),
    [anon_sym_groupshared] = ACTIONS(3497),
    [anon_sym_uniform] = ACTIONS(3497),
    [anon_sym_row_major] = ACTIONS(3497),
    [anon_sym_column_major] = ACTIONS(3497),
    [anon_sym_globallycoherent] = ACTIONS(3497),
    [anon_sym_centroid] = ACTIONS(3497),
    [anon_sym_noperspective] = ACTIONS(3497),
    [anon_sym_nointerpolation] = ACTIONS(3497),
    [anon_sym_sample] = ACTIONS(3497),
    [anon_sym_linear] = ACTIONS(3497),
    [anon_sym_snorm] = ACTIONS(3497),
    [anon_sym_unorm] = ACTIONS(3497),
    [anon_sym_point] = ACTIONS(3497),
    [anon_sym_line] = ACTIONS(3497),
    [anon_sym_triangleadj] = ACTIONS(3497),
    [anon_sym_lineadj] = ACTIONS(3497),
    [anon_sym_triangle] = ACTIONS(3497),
    [anon_sym_interface] = ACTIONS(3497),
    [anon_sym_extension] = ACTIONS(3497),
    [anon_sym___init] = ACTIONS(3497),
    [anon_sym___subscript] = ACTIONS(3497),
    [anon_sym_property] = ACTIONS(3497),
    [anon_sym_associatedtype] = ACTIONS(3497),
  },
  [2181] = {
    [sym_identifier] = ACTIONS(3703),
    [aux_sym_preproc_def_token1] = ACTIONS(3703),
    [aux_sym_preproc_if_token1] = ACTIONS(3703),
    [aux_sym_preproc_if_token2] = ACTIONS(3703),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3703),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3703),
    [sym_preproc_directive] = ACTIONS(3703),
    [anon_sym_LPAREN2] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3705),
    [anon_sym_STAR] = ACTIONS(3705),
    [anon_sym_AMP_AMP] = ACTIONS(3705),
    [anon_sym_AMP] = ACTIONS(3703),
    [anon_sym___extension__] = ACTIONS(3703),
    [anon_sym_typedef] = ACTIONS(3703),
    [anon_sym_in] = ACTIONS(3703),
    [anon_sym_out] = ACTIONS(3703),
    [anon_sym_inout] = ACTIONS(3703),
    [anon_sym_extern] = ACTIONS(3703),
    [anon_sym___attribute__] = ACTIONS(3703),
    [anon_sym_COLON_COLON] = ACTIONS(3705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3705),
    [anon_sym___declspec] = ACTIONS(3703),
    [anon_sym___based] = ACTIONS(3703),
    [anon_sym_signed] = ACTIONS(3703),
    [anon_sym_unsigned] = ACTIONS(3703),
    [anon_sym_long] = ACTIONS(3703),
    [anon_sym_short] = ACTIONS(3703),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_static] = ACTIONS(3703),
    [anon_sym_register] = ACTIONS(3703),
    [anon_sym_inline] = ACTIONS(3703),
    [anon_sym___inline] = ACTIONS(3703),
    [anon_sym___inline__] = ACTIONS(3703),
    [anon_sym___forceinline] = ACTIONS(3703),
    [anon_sym_thread_local] = ACTIONS(3703),
    [anon_sym___thread] = ACTIONS(3703),
    [anon_sym_const] = ACTIONS(3703),
    [anon_sym_constexpr] = ACTIONS(3703),
    [anon_sym_volatile] = ACTIONS(3703),
    [anon_sym_restrict] = ACTIONS(3703),
    [anon_sym___restrict__] = ACTIONS(3703),
    [anon_sym__Atomic] = ACTIONS(3703),
    [anon_sym__Noreturn] = ACTIONS(3703),
    [anon_sym_noreturn] = ACTIONS(3703),
    [anon_sym_mutable] = ACTIONS(3703),
    [anon_sym_constinit] = ACTIONS(3703),
    [anon_sym_consteval] = ACTIONS(3703),
    [anon_sym_alignas] = ACTIONS(3703),
    [anon_sym__Alignas] = ACTIONS(3703),
    [sym_primitive_type] = ACTIONS(3703),
    [anon_sym_enum] = ACTIONS(3703),
    [anon_sym_class] = ACTIONS(3703),
    [anon_sym_struct] = ACTIONS(3703),
    [anon_sym_union] = ACTIONS(3703),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3703),
    [anon_sym_let] = ACTIONS(3703),
    [anon_sym_This] = ACTIONS(3703),
    [anon_sym_decltype] = ACTIONS(3703),
    [sym_virtual] = ACTIONS(3703),
    [anon_sym_explicit] = ACTIONS(3703),
    [anon_sym_typename] = ACTIONS(3703),
    [anon_sym_template] = ACTIONS(3703),
    [anon_sym_operator] = ACTIONS(3703),
    [anon_sym_friend] = ACTIONS(3703),
    [anon_sym_public] = ACTIONS(3703),
    [anon_sym_private] = ACTIONS(3703),
    [anon_sym_protected] = ACTIONS(3703),
    [anon_sym_using] = ACTIONS(3703),
    [anon_sym_static_assert] = ACTIONS(3703),
    [anon_sym_precise] = ACTIONS(3703),
    [anon_sym_shared] = ACTIONS(3703),
    [anon_sym_groupshared] = ACTIONS(3703),
    [anon_sym_uniform] = ACTIONS(3703),
    [anon_sym_row_major] = ACTIONS(3703),
    [anon_sym_column_major] = ACTIONS(3703),
    [anon_sym_globallycoherent] = ACTIONS(3703),
    [anon_sym_centroid] = ACTIONS(3703),
    [anon_sym_noperspective] = ACTIONS(3703),
    [anon_sym_nointerpolation] = ACTIONS(3703),
    [anon_sym_sample] = ACTIONS(3703),
    [anon_sym_linear] = ACTIONS(3703),
    [anon_sym_snorm] = ACTIONS(3703),
    [anon_sym_unorm] = ACTIONS(3703),
    [anon_sym_point] = ACTIONS(3703),
    [anon_sym_line] = ACTIONS(3703),
    [anon_sym_triangleadj] = ACTIONS(3703),
    [anon_sym_lineadj] = ACTIONS(3703),
    [anon_sym_triangle] = ACTIONS(3703),
    [anon_sym_interface] = ACTIONS(3703),
    [anon_sym_extension] = ACTIONS(3703),
    [anon_sym___init] = ACTIONS(3703),
    [anon_sym___subscript] = ACTIONS(3703),
    [anon_sym_property] = ACTIONS(3703),
    [anon_sym_associatedtype] = ACTIONS(3703),
  },
  [2182] = {
    [sym_expression] = STATE(3698),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(6098),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [2183] = {
    [sym_identifier] = ACTIONS(3633),
    [aux_sym_preproc_def_token1] = ACTIONS(3633),
    [aux_sym_preproc_if_token1] = ACTIONS(3633),
    [aux_sym_preproc_if_token2] = ACTIONS(3633),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3633),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3633),
    [sym_preproc_directive] = ACTIONS(3633),
    [anon_sym_LPAREN2] = ACTIONS(3635),
    [anon_sym_TILDE] = ACTIONS(3635),
    [anon_sym_STAR] = ACTIONS(3635),
    [anon_sym_AMP_AMP] = ACTIONS(3635),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym___extension__] = ACTIONS(3633),
    [anon_sym_typedef] = ACTIONS(3633),
    [anon_sym_in] = ACTIONS(3633),
    [anon_sym_out] = ACTIONS(3633),
    [anon_sym_inout] = ACTIONS(3633),
    [anon_sym_extern] = ACTIONS(3633),
    [anon_sym___attribute__] = ACTIONS(3633),
    [anon_sym_COLON_COLON] = ACTIONS(3635),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3635),
    [anon_sym___declspec] = ACTIONS(3633),
    [anon_sym___based] = ACTIONS(3633),
    [anon_sym_signed] = ACTIONS(3633),
    [anon_sym_unsigned] = ACTIONS(3633),
    [anon_sym_long] = ACTIONS(3633),
    [anon_sym_short] = ACTIONS(3633),
    [anon_sym_LBRACK] = ACTIONS(3633),
    [anon_sym_static] = ACTIONS(3633),
    [anon_sym_register] = ACTIONS(3633),
    [anon_sym_inline] = ACTIONS(3633),
    [anon_sym___inline] = ACTIONS(3633),
    [anon_sym___inline__] = ACTIONS(3633),
    [anon_sym___forceinline] = ACTIONS(3633),
    [anon_sym_thread_local] = ACTIONS(3633),
    [anon_sym___thread] = ACTIONS(3633),
    [anon_sym_const] = ACTIONS(3633),
    [anon_sym_constexpr] = ACTIONS(3633),
    [anon_sym_volatile] = ACTIONS(3633),
    [anon_sym_restrict] = ACTIONS(3633),
    [anon_sym___restrict__] = ACTIONS(3633),
    [anon_sym__Atomic] = ACTIONS(3633),
    [anon_sym__Noreturn] = ACTIONS(3633),
    [anon_sym_noreturn] = ACTIONS(3633),
    [anon_sym_mutable] = ACTIONS(3633),
    [anon_sym_constinit] = ACTIONS(3633),
    [anon_sym_consteval] = ACTIONS(3633),
    [anon_sym_alignas] = ACTIONS(3633),
    [anon_sym__Alignas] = ACTIONS(3633),
    [sym_primitive_type] = ACTIONS(3633),
    [anon_sym_enum] = ACTIONS(3633),
    [anon_sym_class] = ACTIONS(3633),
    [anon_sym_struct] = ACTIONS(3633),
    [anon_sym_union] = ACTIONS(3633),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3633),
    [anon_sym_let] = ACTIONS(3633),
    [anon_sym_This] = ACTIONS(3633),
    [anon_sym_decltype] = ACTIONS(3633),
    [sym_virtual] = ACTIONS(3633),
    [anon_sym_explicit] = ACTIONS(3633),
    [anon_sym_typename] = ACTIONS(3633),
    [anon_sym_template] = ACTIONS(3633),
    [anon_sym_operator] = ACTIONS(3633),
    [anon_sym_friend] = ACTIONS(3633),
    [anon_sym_public] = ACTIONS(3633),
    [anon_sym_private] = ACTIONS(3633),
    [anon_sym_protected] = ACTIONS(3633),
    [anon_sym_using] = ACTIONS(3633),
    [anon_sym_static_assert] = ACTIONS(3633),
    [anon_sym_precise] = ACTIONS(3633),
    [anon_sym_shared] = ACTIONS(3633),
    [anon_sym_groupshared] = ACTIONS(3633),
    [anon_sym_uniform] = ACTIONS(3633),
    [anon_sym_row_major] = ACTIONS(3633),
    [anon_sym_column_major] = ACTIONS(3633),
    [anon_sym_globallycoherent] = ACTIONS(3633),
    [anon_sym_centroid] = ACTIONS(3633),
    [anon_sym_noperspective] = ACTIONS(3633),
    [anon_sym_nointerpolation] = ACTIONS(3633),
    [anon_sym_sample] = ACTIONS(3633),
    [anon_sym_linear] = ACTIONS(3633),
    [anon_sym_snorm] = ACTIONS(3633),
    [anon_sym_unorm] = ACTIONS(3633),
    [anon_sym_point] = ACTIONS(3633),
    [anon_sym_line] = ACTIONS(3633),
    [anon_sym_triangleadj] = ACTIONS(3633),
    [anon_sym_lineadj] = ACTIONS(3633),
    [anon_sym_triangle] = ACTIONS(3633),
    [anon_sym_interface] = ACTIONS(3633),
    [anon_sym_extension] = ACTIONS(3633),
    [anon_sym___init] = ACTIONS(3633),
    [anon_sym___subscript] = ACTIONS(3633),
    [anon_sym_property] = ACTIONS(3633),
    [anon_sym_associatedtype] = ACTIONS(3633),
  },
  [2184] = {
    [sym_expression] = STATE(3695),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [2185] = {
    [sym_expression] = STATE(5211),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACK] = ACTIONS(5881),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4958),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4964),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2186] = {
    [sym_expression] = STATE(4592),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4958),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4964),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2187] = {
    [sym_identifier] = ACTIONS(3429),
    [aux_sym_preproc_def_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3429),
    [sym_preproc_directive] = ACTIONS(3429),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym___extension__] = ACTIONS(3429),
    [anon_sym_typedef] = ACTIONS(3429),
    [anon_sym_in] = ACTIONS(3429),
    [anon_sym_out] = ACTIONS(3429),
    [anon_sym_inout] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym___attribute__] = ACTIONS(3429),
    [anon_sym_COLON_COLON] = ACTIONS(3431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3431),
    [anon_sym___declspec] = ACTIONS(3429),
    [anon_sym___based] = ACTIONS(3429),
    [anon_sym_RBRACE] = ACTIONS(3431),
    [anon_sym_signed] = ACTIONS(3429),
    [anon_sym_unsigned] = ACTIONS(3429),
    [anon_sym_long] = ACTIONS(3429),
    [anon_sym_short] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_register] = ACTIONS(3429),
    [anon_sym_inline] = ACTIONS(3429),
    [anon_sym___inline] = ACTIONS(3429),
    [anon_sym___inline__] = ACTIONS(3429),
    [anon_sym___forceinline] = ACTIONS(3429),
    [anon_sym_thread_local] = ACTIONS(3429),
    [anon_sym___thread] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_constexpr] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_restrict] = ACTIONS(3429),
    [anon_sym___restrict__] = ACTIONS(3429),
    [anon_sym__Atomic] = ACTIONS(3429),
    [anon_sym__Noreturn] = ACTIONS(3429),
    [anon_sym_noreturn] = ACTIONS(3429),
    [anon_sym_mutable] = ACTIONS(3429),
    [anon_sym_constinit] = ACTIONS(3429),
    [anon_sym_consteval] = ACTIONS(3429),
    [anon_sym_alignas] = ACTIONS(3429),
    [anon_sym__Alignas] = ACTIONS(3429),
    [sym_primitive_type] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_This] = ACTIONS(3429),
    [anon_sym_decltype] = ACTIONS(3429),
    [sym_virtual] = ACTIONS(3429),
    [anon_sym_explicit] = ACTIONS(3429),
    [anon_sym_typename] = ACTIONS(3429),
    [anon_sym_template] = ACTIONS(3429),
    [anon_sym_operator] = ACTIONS(3429),
    [anon_sym_friend] = ACTIONS(3429),
    [anon_sym_public] = ACTIONS(3429),
    [anon_sym_private] = ACTIONS(3429),
    [anon_sym_protected] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_static_assert] = ACTIONS(3429),
    [anon_sym_precise] = ACTIONS(3429),
    [anon_sym_shared] = ACTIONS(3429),
    [anon_sym_groupshared] = ACTIONS(3429),
    [anon_sym_uniform] = ACTIONS(3429),
    [anon_sym_row_major] = ACTIONS(3429),
    [anon_sym_column_major] = ACTIONS(3429),
    [anon_sym_globallycoherent] = ACTIONS(3429),
    [anon_sym_centroid] = ACTIONS(3429),
    [anon_sym_noperspective] = ACTIONS(3429),
    [anon_sym_nointerpolation] = ACTIONS(3429),
    [anon_sym_sample] = ACTIONS(3429),
    [anon_sym_linear] = ACTIONS(3429),
    [anon_sym_snorm] = ACTIONS(3429),
    [anon_sym_unorm] = ACTIONS(3429),
    [anon_sym_point] = ACTIONS(3429),
    [anon_sym_line] = ACTIONS(3429),
    [anon_sym_triangleadj] = ACTIONS(3429),
    [anon_sym_lineadj] = ACTIONS(3429),
    [anon_sym_triangle] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_extension] = ACTIONS(3429),
    [anon_sym___init] = ACTIONS(3429),
    [anon_sym___subscript] = ACTIONS(3429),
    [anon_sym_property] = ACTIONS(3429),
    [anon_sym_associatedtype] = ACTIONS(3429),
  },
  [2188] = {
    [sym_identifier] = ACTIONS(5514),
    [aux_sym_preproc_def_token1] = ACTIONS(5514),
    [aux_sym_preproc_if_token1] = ACTIONS(5514),
    [aux_sym_preproc_if_token2] = ACTIONS(5514),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5514),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5514),
    [sym_preproc_directive] = ACTIONS(5514),
    [anon_sym_LPAREN2] = ACTIONS(5516),
    [anon_sym_TILDE] = ACTIONS(5516),
    [anon_sym_STAR] = ACTIONS(5516),
    [anon_sym_AMP_AMP] = ACTIONS(5516),
    [anon_sym_AMP] = ACTIONS(5514),
    [anon_sym___extension__] = ACTIONS(5514),
    [anon_sym_typedef] = ACTIONS(5514),
    [anon_sym_in] = ACTIONS(5514),
    [anon_sym_out] = ACTIONS(5514),
    [anon_sym_inout] = ACTIONS(5514),
    [anon_sym_extern] = ACTIONS(5514),
    [anon_sym___attribute__] = ACTIONS(5514),
    [anon_sym_COLON_COLON] = ACTIONS(5516),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5516),
    [anon_sym___declspec] = ACTIONS(5514),
    [anon_sym___based] = ACTIONS(5514),
    [anon_sym_signed] = ACTIONS(5514),
    [anon_sym_unsigned] = ACTIONS(5514),
    [anon_sym_long] = ACTIONS(5514),
    [anon_sym_short] = ACTIONS(5514),
    [anon_sym_LBRACK] = ACTIONS(5514),
    [anon_sym_static] = ACTIONS(5514),
    [anon_sym_register] = ACTIONS(5514),
    [anon_sym_inline] = ACTIONS(5514),
    [anon_sym___inline] = ACTIONS(5514),
    [anon_sym___inline__] = ACTIONS(5514),
    [anon_sym___forceinline] = ACTIONS(5514),
    [anon_sym_thread_local] = ACTIONS(5514),
    [anon_sym___thread] = ACTIONS(5514),
    [anon_sym_const] = ACTIONS(5514),
    [anon_sym_constexpr] = ACTIONS(5514),
    [anon_sym_volatile] = ACTIONS(5514),
    [anon_sym_restrict] = ACTIONS(5514),
    [anon_sym___restrict__] = ACTIONS(5514),
    [anon_sym__Atomic] = ACTIONS(5514),
    [anon_sym__Noreturn] = ACTIONS(5514),
    [anon_sym_noreturn] = ACTIONS(5514),
    [anon_sym_mutable] = ACTIONS(5514),
    [anon_sym_constinit] = ACTIONS(5514),
    [anon_sym_consteval] = ACTIONS(5514),
    [anon_sym_alignas] = ACTIONS(5514),
    [anon_sym__Alignas] = ACTIONS(5514),
    [sym_primitive_type] = ACTIONS(5514),
    [anon_sym_enum] = ACTIONS(5514),
    [anon_sym_class] = ACTIONS(5514),
    [anon_sym_struct] = ACTIONS(5514),
    [anon_sym_union] = ACTIONS(5514),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5514),
    [anon_sym_let] = ACTIONS(5514),
    [anon_sym_This] = ACTIONS(5514),
    [anon_sym_decltype] = ACTIONS(5514),
    [sym_virtual] = ACTIONS(5514),
    [anon_sym_explicit] = ACTIONS(5514),
    [anon_sym_typename] = ACTIONS(5514),
    [anon_sym_template] = ACTIONS(5514),
    [anon_sym_operator] = ACTIONS(5514),
    [anon_sym_friend] = ACTIONS(5514),
    [anon_sym_public] = ACTIONS(5514),
    [anon_sym_private] = ACTIONS(5514),
    [anon_sym_protected] = ACTIONS(5514),
    [anon_sym_using] = ACTIONS(5514),
    [anon_sym_static_assert] = ACTIONS(5514),
    [anon_sym_precise] = ACTIONS(5514),
    [anon_sym_shared] = ACTIONS(5514),
    [anon_sym_groupshared] = ACTIONS(5514),
    [anon_sym_uniform] = ACTIONS(5514),
    [anon_sym_row_major] = ACTIONS(5514),
    [anon_sym_column_major] = ACTIONS(5514),
    [anon_sym_globallycoherent] = ACTIONS(5514),
    [anon_sym_centroid] = ACTIONS(5514),
    [anon_sym_noperspective] = ACTIONS(5514),
    [anon_sym_nointerpolation] = ACTIONS(5514),
    [anon_sym_sample] = ACTIONS(5514),
    [anon_sym_linear] = ACTIONS(5514),
    [anon_sym_snorm] = ACTIONS(5514),
    [anon_sym_unorm] = ACTIONS(5514),
    [anon_sym_point] = ACTIONS(5514),
    [anon_sym_line] = ACTIONS(5514),
    [anon_sym_triangleadj] = ACTIONS(5514),
    [anon_sym_lineadj] = ACTIONS(5514),
    [anon_sym_triangle] = ACTIONS(5514),
    [anon_sym_interface] = ACTIONS(5514),
    [anon_sym_extension] = ACTIONS(5514),
    [anon_sym___init] = ACTIONS(5514),
    [anon_sym___subscript] = ACTIONS(5514),
    [anon_sym_property] = ACTIONS(5514),
    [anon_sym_associatedtype] = ACTIONS(5514),
  },
  [2189] = {
    [sym_identifier] = ACTIONS(3429),
    [aux_sym_preproc_def_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3429),
    [sym_preproc_directive] = ACTIONS(3429),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym___extension__] = ACTIONS(3429),
    [anon_sym_typedef] = ACTIONS(3429),
    [anon_sym_in] = ACTIONS(3429),
    [anon_sym_out] = ACTIONS(3429),
    [anon_sym_inout] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym___attribute__] = ACTIONS(3429),
    [anon_sym_COLON_COLON] = ACTIONS(3431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3431),
    [anon_sym___declspec] = ACTIONS(3429),
    [anon_sym___based] = ACTIONS(3429),
    [anon_sym_RBRACE] = ACTIONS(3431),
    [anon_sym_signed] = ACTIONS(3429),
    [anon_sym_unsigned] = ACTIONS(3429),
    [anon_sym_long] = ACTIONS(3429),
    [anon_sym_short] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_register] = ACTIONS(3429),
    [anon_sym_inline] = ACTIONS(3429),
    [anon_sym___inline] = ACTIONS(3429),
    [anon_sym___inline__] = ACTIONS(3429),
    [anon_sym___forceinline] = ACTIONS(3429),
    [anon_sym_thread_local] = ACTIONS(3429),
    [anon_sym___thread] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_constexpr] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_restrict] = ACTIONS(3429),
    [anon_sym___restrict__] = ACTIONS(3429),
    [anon_sym__Atomic] = ACTIONS(3429),
    [anon_sym__Noreturn] = ACTIONS(3429),
    [anon_sym_noreturn] = ACTIONS(3429),
    [anon_sym_mutable] = ACTIONS(3429),
    [anon_sym_constinit] = ACTIONS(3429),
    [anon_sym_consteval] = ACTIONS(3429),
    [anon_sym_alignas] = ACTIONS(3429),
    [anon_sym__Alignas] = ACTIONS(3429),
    [sym_primitive_type] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_This] = ACTIONS(3429),
    [anon_sym_decltype] = ACTIONS(3429),
    [sym_virtual] = ACTIONS(3429),
    [anon_sym_explicit] = ACTIONS(3429),
    [anon_sym_typename] = ACTIONS(3429),
    [anon_sym_template] = ACTIONS(3429),
    [anon_sym_operator] = ACTIONS(3429),
    [anon_sym_friend] = ACTIONS(3429),
    [anon_sym_public] = ACTIONS(3429),
    [anon_sym_private] = ACTIONS(3429),
    [anon_sym_protected] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_static_assert] = ACTIONS(3429),
    [anon_sym_precise] = ACTIONS(3429),
    [anon_sym_shared] = ACTIONS(3429),
    [anon_sym_groupshared] = ACTIONS(3429),
    [anon_sym_uniform] = ACTIONS(3429),
    [anon_sym_row_major] = ACTIONS(3429),
    [anon_sym_column_major] = ACTIONS(3429),
    [anon_sym_globallycoherent] = ACTIONS(3429),
    [anon_sym_centroid] = ACTIONS(3429),
    [anon_sym_noperspective] = ACTIONS(3429),
    [anon_sym_nointerpolation] = ACTIONS(3429),
    [anon_sym_sample] = ACTIONS(3429),
    [anon_sym_linear] = ACTIONS(3429),
    [anon_sym_snorm] = ACTIONS(3429),
    [anon_sym_unorm] = ACTIONS(3429),
    [anon_sym_point] = ACTIONS(3429),
    [anon_sym_line] = ACTIONS(3429),
    [anon_sym_triangleadj] = ACTIONS(3429),
    [anon_sym_lineadj] = ACTIONS(3429),
    [anon_sym_triangle] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_extension] = ACTIONS(3429),
    [anon_sym___init] = ACTIONS(3429),
    [anon_sym___subscript] = ACTIONS(3429),
    [anon_sym_property] = ACTIONS(3429),
    [anon_sym_associatedtype] = ACTIONS(3429),
  },
  [2190] = {
    [sym_expression] = STATE(5616),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2191] = {
    [sym__declaration_modifiers] = STATE(2777),
    [sym_attribute_specifier] = STATE(2777),
    [sym_attribute_declaration] = STATE(2777),
    [sym_ms_declspec_modifier] = STATE(2777),
    [sym_storage_class_specifier] = STATE(2777),
    [sym_type_qualifier] = STATE(2777),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(3049),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2777),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2777),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3133),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(6086),
    [anon_sym_out] = ACTIONS(6086),
    [anon_sym_inout] = ACTIONS(6086),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(3977),
    [anon_sym_unsigned] = ACTIONS(3977),
    [anon_sym_long] = ACTIONS(3977),
    [anon_sym_short] = ACTIONS(3977),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(3979),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(6086),
    [anon_sym_typename] = ACTIONS(3981),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
  },
  [2192] = {
    [sym_identifier] = ACTIONS(3410),
    [aux_sym_preproc_def_token1] = ACTIONS(3410),
    [aux_sym_preproc_if_token1] = ACTIONS(3410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3410),
    [sym_preproc_directive] = ACTIONS(3410),
    [anon_sym_LPAREN2] = ACTIONS(3412),
    [anon_sym_TILDE] = ACTIONS(3412),
    [anon_sym_STAR] = ACTIONS(3412),
    [anon_sym_AMP_AMP] = ACTIONS(3412),
    [anon_sym_AMP] = ACTIONS(3410),
    [anon_sym___extension__] = ACTIONS(3410),
    [anon_sym_typedef] = ACTIONS(3410),
    [anon_sym_in] = ACTIONS(3410),
    [anon_sym_out] = ACTIONS(3410),
    [anon_sym_inout] = ACTIONS(3410),
    [anon_sym_extern] = ACTIONS(3410),
    [anon_sym___attribute__] = ACTIONS(3410),
    [anon_sym_COLON_COLON] = ACTIONS(3412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3412),
    [anon_sym___declspec] = ACTIONS(3410),
    [anon_sym___based] = ACTIONS(3410),
    [anon_sym_RBRACE] = ACTIONS(3412),
    [anon_sym_signed] = ACTIONS(3410),
    [anon_sym_unsigned] = ACTIONS(3410),
    [anon_sym_long] = ACTIONS(3410),
    [anon_sym_short] = ACTIONS(3410),
    [anon_sym_LBRACK] = ACTIONS(3410),
    [anon_sym_static] = ACTIONS(3410),
    [anon_sym_register] = ACTIONS(3410),
    [anon_sym_inline] = ACTIONS(3410),
    [anon_sym___inline] = ACTIONS(3410),
    [anon_sym___inline__] = ACTIONS(3410),
    [anon_sym___forceinline] = ACTIONS(3410),
    [anon_sym_thread_local] = ACTIONS(3410),
    [anon_sym___thread] = ACTIONS(3410),
    [anon_sym_const] = ACTIONS(3410),
    [anon_sym_constexpr] = ACTIONS(3410),
    [anon_sym_volatile] = ACTIONS(3410),
    [anon_sym_restrict] = ACTIONS(3410),
    [anon_sym___restrict__] = ACTIONS(3410),
    [anon_sym__Atomic] = ACTIONS(3410),
    [anon_sym__Noreturn] = ACTIONS(3410),
    [anon_sym_noreturn] = ACTIONS(3410),
    [anon_sym_mutable] = ACTIONS(3410),
    [anon_sym_constinit] = ACTIONS(3410),
    [anon_sym_consteval] = ACTIONS(3410),
    [anon_sym_alignas] = ACTIONS(3410),
    [anon_sym__Alignas] = ACTIONS(3410),
    [sym_primitive_type] = ACTIONS(3410),
    [anon_sym_enum] = ACTIONS(3410),
    [anon_sym_class] = ACTIONS(3410),
    [anon_sym_struct] = ACTIONS(3410),
    [anon_sym_union] = ACTIONS(3410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3410),
    [anon_sym_let] = ACTIONS(3410),
    [anon_sym_This] = ACTIONS(3410),
    [anon_sym_decltype] = ACTIONS(3410),
    [sym_virtual] = ACTIONS(3410),
    [anon_sym_explicit] = ACTIONS(3410),
    [anon_sym_typename] = ACTIONS(3410),
    [anon_sym_template] = ACTIONS(3410),
    [anon_sym_operator] = ACTIONS(3410),
    [anon_sym_friend] = ACTIONS(3410),
    [anon_sym_public] = ACTIONS(3410),
    [anon_sym_private] = ACTIONS(3410),
    [anon_sym_protected] = ACTIONS(3410),
    [anon_sym_using] = ACTIONS(3410),
    [anon_sym_static_assert] = ACTIONS(3410),
    [anon_sym_precise] = ACTIONS(3410),
    [anon_sym_shared] = ACTIONS(3410),
    [anon_sym_groupshared] = ACTIONS(3410),
    [anon_sym_uniform] = ACTIONS(3410),
    [anon_sym_row_major] = ACTIONS(3410),
    [anon_sym_column_major] = ACTIONS(3410),
    [anon_sym_globallycoherent] = ACTIONS(3410),
    [anon_sym_centroid] = ACTIONS(3410),
    [anon_sym_noperspective] = ACTIONS(3410),
    [anon_sym_nointerpolation] = ACTIONS(3410),
    [anon_sym_sample] = ACTIONS(3410),
    [anon_sym_linear] = ACTIONS(3410),
    [anon_sym_snorm] = ACTIONS(3410),
    [anon_sym_unorm] = ACTIONS(3410),
    [anon_sym_point] = ACTIONS(3410),
    [anon_sym_line] = ACTIONS(3410),
    [anon_sym_triangleadj] = ACTIONS(3410),
    [anon_sym_lineadj] = ACTIONS(3410),
    [anon_sym_triangle] = ACTIONS(3410),
    [anon_sym_interface] = ACTIONS(3410),
    [anon_sym_extension] = ACTIONS(3410),
    [anon_sym___init] = ACTIONS(3410),
    [anon_sym___subscript] = ACTIONS(3410),
    [anon_sym_property] = ACTIONS(3410),
    [anon_sym_associatedtype] = ACTIONS(3410),
  },
  [2193] = {
    [sym_identifier] = ACTIONS(3410),
    [aux_sym_preproc_def_token1] = ACTIONS(3410),
    [aux_sym_preproc_if_token1] = ACTIONS(3410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3410),
    [sym_preproc_directive] = ACTIONS(3410),
    [anon_sym_LPAREN2] = ACTIONS(3412),
    [anon_sym_TILDE] = ACTIONS(3412),
    [anon_sym_STAR] = ACTIONS(3412),
    [anon_sym_AMP_AMP] = ACTIONS(3412),
    [anon_sym_AMP] = ACTIONS(3410),
    [anon_sym___extension__] = ACTIONS(3410),
    [anon_sym_typedef] = ACTIONS(3410),
    [anon_sym_in] = ACTIONS(3410),
    [anon_sym_out] = ACTIONS(3410),
    [anon_sym_inout] = ACTIONS(3410),
    [anon_sym_extern] = ACTIONS(3410),
    [anon_sym___attribute__] = ACTIONS(3410),
    [anon_sym_COLON_COLON] = ACTIONS(3412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3412),
    [anon_sym___declspec] = ACTIONS(3410),
    [anon_sym___based] = ACTIONS(3410),
    [anon_sym_RBRACE] = ACTIONS(3412),
    [anon_sym_signed] = ACTIONS(3410),
    [anon_sym_unsigned] = ACTIONS(3410),
    [anon_sym_long] = ACTIONS(3410),
    [anon_sym_short] = ACTIONS(3410),
    [anon_sym_LBRACK] = ACTIONS(3410),
    [anon_sym_static] = ACTIONS(3410),
    [anon_sym_register] = ACTIONS(3410),
    [anon_sym_inline] = ACTIONS(3410),
    [anon_sym___inline] = ACTIONS(3410),
    [anon_sym___inline__] = ACTIONS(3410),
    [anon_sym___forceinline] = ACTIONS(3410),
    [anon_sym_thread_local] = ACTIONS(3410),
    [anon_sym___thread] = ACTIONS(3410),
    [anon_sym_const] = ACTIONS(3410),
    [anon_sym_constexpr] = ACTIONS(3410),
    [anon_sym_volatile] = ACTIONS(3410),
    [anon_sym_restrict] = ACTIONS(3410),
    [anon_sym___restrict__] = ACTIONS(3410),
    [anon_sym__Atomic] = ACTIONS(3410),
    [anon_sym__Noreturn] = ACTIONS(3410),
    [anon_sym_noreturn] = ACTIONS(3410),
    [anon_sym_mutable] = ACTIONS(3410),
    [anon_sym_constinit] = ACTIONS(3410),
    [anon_sym_consteval] = ACTIONS(3410),
    [anon_sym_alignas] = ACTIONS(3410),
    [anon_sym__Alignas] = ACTIONS(3410),
    [sym_primitive_type] = ACTIONS(3410),
    [anon_sym_enum] = ACTIONS(3410),
    [anon_sym_class] = ACTIONS(3410),
    [anon_sym_struct] = ACTIONS(3410),
    [anon_sym_union] = ACTIONS(3410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3410),
    [anon_sym_let] = ACTIONS(3410),
    [anon_sym_This] = ACTIONS(3410),
    [anon_sym_decltype] = ACTIONS(3410),
    [sym_virtual] = ACTIONS(3410),
    [anon_sym_explicit] = ACTIONS(3410),
    [anon_sym_typename] = ACTIONS(3410),
    [anon_sym_template] = ACTIONS(3410),
    [anon_sym_operator] = ACTIONS(3410),
    [anon_sym_friend] = ACTIONS(3410),
    [anon_sym_public] = ACTIONS(3410),
    [anon_sym_private] = ACTIONS(3410),
    [anon_sym_protected] = ACTIONS(3410),
    [anon_sym_using] = ACTIONS(3410),
    [anon_sym_static_assert] = ACTIONS(3410),
    [anon_sym_precise] = ACTIONS(3410),
    [anon_sym_shared] = ACTIONS(3410),
    [anon_sym_groupshared] = ACTIONS(3410),
    [anon_sym_uniform] = ACTIONS(3410),
    [anon_sym_row_major] = ACTIONS(3410),
    [anon_sym_column_major] = ACTIONS(3410),
    [anon_sym_globallycoherent] = ACTIONS(3410),
    [anon_sym_centroid] = ACTIONS(3410),
    [anon_sym_noperspective] = ACTIONS(3410),
    [anon_sym_nointerpolation] = ACTIONS(3410),
    [anon_sym_sample] = ACTIONS(3410),
    [anon_sym_linear] = ACTIONS(3410),
    [anon_sym_snorm] = ACTIONS(3410),
    [anon_sym_unorm] = ACTIONS(3410),
    [anon_sym_point] = ACTIONS(3410),
    [anon_sym_line] = ACTIONS(3410),
    [anon_sym_triangleadj] = ACTIONS(3410),
    [anon_sym_lineadj] = ACTIONS(3410),
    [anon_sym_triangle] = ACTIONS(3410),
    [anon_sym_interface] = ACTIONS(3410),
    [anon_sym_extension] = ACTIONS(3410),
    [anon_sym___init] = ACTIONS(3410),
    [anon_sym___subscript] = ACTIONS(3410),
    [anon_sym_property] = ACTIONS(3410),
    [anon_sym_associatedtype] = ACTIONS(3410),
  },
  [2194] = {
    [sym_identifier] = ACTIONS(5510),
    [aux_sym_preproc_def_token1] = ACTIONS(5510),
    [aux_sym_preproc_if_token1] = ACTIONS(5510),
    [aux_sym_preproc_if_token2] = ACTIONS(5510),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5510),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5510),
    [sym_preproc_directive] = ACTIONS(5510),
    [anon_sym_LPAREN2] = ACTIONS(5512),
    [anon_sym_TILDE] = ACTIONS(5512),
    [anon_sym_STAR] = ACTIONS(5512),
    [anon_sym_AMP_AMP] = ACTIONS(5512),
    [anon_sym_AMP] = ACTIONS(5510),
    [anon_sym___extension__] = ACTIONS(5510),
    [anon_sym_typedef] = ACTIONS(5510),
    [anon_sym_in] = ACTIONS(5510),
    [anon_sym_out] = ACTIONS(5510),
    [anon_sym_inout] = ACTIONS(5510),
    [anon_sym_extern] = ACTIONS(5510),
    [anon_sym___attribute__] = ACTIONS(5510),
    [anon_sym_COLON_COLON] = ACTIONS(5512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5512),
    [anon_sym___declspec] = ACTIONS(5510),
    [anon_sym___based] = ACTIONS(5510),
    [anon_sym_signed] = ACTIONS(5510),
    [anon_sym_unsigned] = ACTIONS(5510),
    [anon_sym_long] = ACTIONS(5510),
    [anon_sym_short] = ACTIONS(5510),
    [anon_sym_LBRACK] = ACTIONS(5510),
    [anon_sym_static] = ACTIONS(5510),
    [anon_sym_register] = ACTIONS(5510),
    [anon_sym_inline] = ACTIONS(5510),
    [anon_sym___inline] = ACTIONS(5510),
    [anon_sym___inline__] = ACTIONS(5510),
    [anon_sym___forceinline] = ACTIONS(5510),
    [anon_sym_thread_local] = ACTIONS(5510),
    [anon_sym___thread] = ACTIONS(5510),
    [anon_sym_const] = ACTIONS(5510),
    [anon_sym_constexpr] = ACTIONS(5510),
    [anon_sym_volatile] = ACTIONS(5510),
    [anon_sym_restrict] = ACTIONS(5510),
    [anon_sym___restrict__] = ACTIONS(5510),
    [anon_sym__Atomic] = ACTIONS(5510),
    [anon_sym__Noreturn] = ACTIONS(5510),
    [anon_sym_noreturn] = ACTIONS(5510),
    [anon_sym_mutable] = ACTIONS(5510),
    [anon_sym_constinit] = ACTIONS(5510),
    [anon_sym_consteval] = ACTIONS(5510),
    [anon_sym_alignas] = ACTIONS(5510),
    [anon_sym__Alignas] = ACTIONS(5510),
    [sym_primitive_type] = ACTIONS(5510),
    [anon_sym_enum] = ACTIONS(5510),
    [anon_sym_class] = ACTIONS(5510),
    [anon_sym_struct] = ACTIONS(5510),
    [anon_sym_union] = ACTIONS(5510),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5510),
    [anon_sym_let] = ACTIONS(5510),
    [anon_sym_This] = ACTIONS(5510),
    [anon_sym_decltype] = ACTIONS(5510),
    [sym_virtual] = ACTIONS(5510),
    [anon_sym_explicit] = ACTIONS(5510),
    [anon_sym_typename] = ACTIONS(5510),
    [anon_sym_template] = ACTIONS(5510),
    [anon_sym_operator] = ACTIONS(5510),
    [anon_sym_friend] = ACTIONS(5510),
    [anon_sym_public] = ACTIONS(5510),
    [anon_sym_private] = ACTIONS(5510),
    [anon_sym_protected] = ACTIONS(5510),
    [anon_sym_using] = ACTIONS(5510),
    [anon_sym_static_assert] = ACTIONS(5510),
    [anon_sym_precise] = ACTIONS(5510),
    [anon_sym_shared] = ACTIONS(5510),
    [anon_sym_groupshared] = ACTIONS(5510),
    [anon_sym_uniform] = ACTIONS(5510),
    [anon_sym_row_major] = ACTIONS(5510),
    [anon_sym_column_major] = ACTIONS(5510),
    [anon_sym_globallycoherent] = ACTIONS(5510),
    [anon_sym_centroid] = ACTIONS(5510),
    [anon_sym_noperspective] = ACTIONS(5510),
    [anon_sym_nointerpolation] = ACTIONS(5510),
    [anon_sym_sample] = ACTIONS(5510),
    [anon_sym_linear] = ACTIONS(5510),
    [anon_sym_snorm] = ACTIONS(5510),
    [anon_sym_unorm] = ACTIONS(5510),
    [anon_sym_point] = ACTIONS(5510),
    [anon_sym_line] = ACTIONS(5510),
    [anon_sym_triangleadj] = ACTIONS(5510),
    [anon_sym_lineadj] = ACTIONS(5510),
    [anon_sym_triangle] = ACTIONS(5510),
    [anon_sym_interface] = ACTIONS(5510),
    [anon_sym_extension] = ACTIONS(5510),
    [anon_sym___init] = ACTIONS(5510),
    [anon_sym___subscript] = ACTIONS(5510),
    [anon_sym_property] = ACTIONS(5510),
    [anon_sym_associatedtype] = ACTIONS(5510),
  },
  [2195] = {
    [sym_identifier] = ACTIONS(5500),
    [aux_sym_preproc_def_token1] = ACTIONS(5500),
    [aux_sym_preproc_if_token1] = ACTIONS(5500),
    [aux_sym_preproc_if_token2] = ACTIONS(5500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5500),
    [sym_preproc_directive] = ACTIONS(5500),
    [anon_sym_LPAREN2] = ACTIONS(5502),
    [anon_sym_TILDE] = ACTIONS(5502),
    [anon_sym_STAR] = ACTIONS(5502),
    [anon_sym_AMP_AMP] = ACTIONS(5502),
    [anon_sym_AMP] = ACTIONS(5500),
    [anon_sym___extension__] = ACTIONS(5500),
    [anon_sym_typedef] = ACTIONS(5500),
    [anon_sym_in] = ACTIONS(5500),
    [anon_sym_out] = ACTIONS(5500),
    [anon_sym_inout] = ACTIONS(5500),
    [anon_sym_extern] = ACTIONS(5500),
    [anon_sym___attribute__] = ACTIONS(5500),
    [anon_sym_COLON_COLON] = ACTIONS(5502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5502),
    [anon_sym___declspec] = ACTIONS(5500),
    [anon_sym___based] = ACTIONS(5500),
    [anon_sym_signed] = ACTIONS(5500),
    [anon_sym_unsigned] = ACTIONS(5500),
    [anon_sym_long] = ACTIONS(5500),
    [anon_sym_short] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5500),
    [anon_sym_static] = ACTIONS(5500),
    [anon_sym_register] = ACTIONS(5500),
    [anon_sym_inline] = ACTIONS(5500),
    [anon_sym___inline] = ACTIONS(5500),
    [anon_sym___inline__] = ACTIONS(5500),
    [anon_sym___forceinline] = ACTIONS(5500),
    [anon_sym_thread_local] = ACTIONS(5500),
    [anon_sym___thread] = ACTIONS(5500),
    [anon_sym_const] = ACTIONS(5500),
    [anon_sym_constexpr] = ACTIONS(5500),
    [anon_sym_volatile] = ACTIONS(5500),
    [anon_sym_restrict] = ACTIONS(5500),
    [anon_sym___restrict__] = ACTIONS(5500),
    [anon_sym__Atomic] = ACTIONS(5500),
    [anon_sym__Noreturn] = ACTIONS(5500),
    [anon_sym_noreturn] = ACTIONS(5500),
    [anon_sym_mutable] = ACTIONS(5500),
    [anon_sym_constinit] = ACTIONS(5500),
    [anon_sym_consteval] = ACTIONS(5500),
    [anon_sym_alignas] = ACTIONS(5500),
    [anon_sym__Alignas] = ACTIONS(5500),
    [sym_primitive_type] = ACTIONS(5500),
    [anon_sym_enum] = ACTIONS(5500),
    [anon_sym_class] = ACTIONS(5500),
    [anon_sym_struct] = ACTIONS(5500),
    [anon_sym_union] = ACTIONS(5500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5500),
    [anon_sym_let] = ACTIONS(5500),
    [anon_sym_This] = ACTIONS(5500),
    [anon_sym_decltype] = ACTIONS(5500),
    [sym_virtual] = ACTIONS(5500),
    [anon_sym_explicit] = ACTIONS(5500),
    [anon_sym_typename] = ACTIONS(5500),
    [anon_sym_template] = ACTIONS(5500),
    [anon_sym_operator] = ACTIONS(5500),
    [anon_sym_friend] = ACTIONS(5500),
    [anon_sym_public] = ACTIONS(5500),
    [anon_sym_private] = ACTIONS(5500),
    [anon_sym_protected] = ACTIONS(5500),
    [anon_sym_using] = ACTIONS(5500),
    [anon_sym_static_assert] = ACTIONS(5500),
    [anon_sym_precise] = ACTIONS(5500),
    [anon_sym_shared] = ACTIONS(5500),
    [anon_sym_groupshared] = ACTIONS(5500),
    [anon_sym_uniform] = ACTIONS(5500),
    [anon_sym_row_major] = ACTIONS(5500),
    [anon_sym_column_major] = ACTIONS(5500),
    [anon_sym_globallycoherent] = ACTIONS(5500),
    [anon_sym_centroid] = ACTIONS(5500),
    [anon_sym_noperspective] = ACTIONS(5500),
    [anon_sym_nointerpolation] = ACTIONS(5500),
    [anon_sym_sample] = ACTIONS(5500),
    [anon_sym_linear] = ACTIONS(5500),
    [anon_sym_snorm] = ACTIONS(5500),
    [anon_sym_unorm] = ACTIONS(5500),
    [anon_sym_point] = ACTIONS(5500),
    [anon_sym_line] = ACTIONS(5500),
    [anon_sym_triangleadj] = ACTIONS(5500),
    [anon_sym_lineadj] = ACTIONS(5500),
    [anon_sym_triangle] = ACTIONS(5500),
    [anon_sym_interface] = ACTIONS(5500),
    [anon_sym_extension] = ACTIONS(5500),
    [anon_sym___init] = ACTIONS(5500),
    [anon_sym___subscript] = ACTIONS(5500),
    [anon_sym_property] = ACTIONS(5500),
    [anon_sym_associatedtype] = ACTIONS(5500),
  },
  [2196] = {
    [sym_identifier] = ACTIONS(3034),
    [aux_sym_preproc_def_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_in] = ACTIONS(3034),
    [anon_sym_out] = ACTIONS(3034),
    [anon_sym_inout] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym___based] = ACTIONS(3034),
    [anon_sym_RBRACE] = ACTIONS(3036),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_This] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [sym_virtual] = ACTIONS(3034),
    [anon_sym_explicit] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_operator] = ACTIONS(3034),
    [anon_sym_friend] = ACTIONS(3034),
    [anon_sym_public] = ACTIONS(3034),
    [anon_sym_private] = ACTIONS(3034),
    [anon_sym_protected] = ACTIONS(3034),
    [anon_sym_using] = ACTIONS(3034),
    [anon_sym_static_assert] = ACTIONS(3034),
    [anon_sym_precise] = ACTIONS(3034),
    [anon_sym_shared] = ACTIONS(3034),
    [anon_sym_groupshared] = ACTIONS(3034),
    [anon_sym_uniform] = ACTIONS(3034),
    [anon_sym_row_major] = ACTIONS(3034),
    [anon_sym_column_major] = ACTIONS(3034),
    [anon_sym_globallycoherent] = ACTIONS(3034),
    [anon_sym_centroid] = ACTIONS(3034),
    [anon_sym_noperspective] = ACTIONS(3034),
    [anon_sym_nointerpolation] = ACTIONS(3034),
    [anon_sym_sample] = ACTIONS(3034),
    [anon_sym_linear] = ACTIONS(3034),
    [anon_sym_snorm] = ACTIONS(3034),
    [anon_sym_unorm] = ACTIONS(3034),
    [anon_sym_point] = ACTIONS(3034),
    [anon_sym_line] = ACTIONS(3034),
    [anon_sym_triangleadj] = ACTIONS(3034),
    [anon_sym_lineadj] = ACTIONS(3034),
    [anon_sym_triangle] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3034),
    [anon_sym_extension] = ACTIONS(3034),
    [anon_sym___init] = ACTIONS(3034),
    [anon_sym___subscript] = ACTIONS(3034),
    [anon_sym_property] = ACTIONS(3034),
    [anon_sym_associatedtype] = ACTIONS(3034),
  },
  [2197] = {
    [sym_identifier] = ACTIONS(5478),
    [aux_sym_preproc_def_token1] = ACTIONS(5478),
    [aux_sym_preproc_if_token1] = ACTIONS(5478),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5478),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5478),
    [sym_preproc_directive] = ACTIONS(5478),
    [anon_sym_LPAREN2] = ACTIONS(5480),
    [anon_sym_TILDE] = ACTIONS(5480),
    [anon_sym_STAR] = ACTIONS(5480),
    [anon_sym_AMP_AMP] = ACTIONS(5480),
    [anon_sym_AMP] = ACTIONS(5478),
    [anon_sym___extension__] = ACTIONS(5478),
    [anon_sym_typedef] = ACTIONS(5478),
    [anon_sym_in] = ACTIONS(5478),
    [anon_sym_out] = ACTIONS(5478),
    [anon_sym_inout] = ACTIONS(5478),
    [anon_sym_extern] = ACTIONS(5478),
    [anon_sym___attribute__] = ACTIONS(5478),
    [anon_sym_COLON_COLON] = ACTIONS(5480),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5480),
    [anon_sym___declspec] = ACTIONS(5478),
    [anon_sym___based] = ACTIONS(5478),
    [anon_sym_RBRACE] = ACTIONS(5480),
    [anon_sym_signed] = ACTIONS(5478),
    [anon_sym_unsigned] = ACTIONS(5478),
    [anon_sym_long] = ACTIONS(5478),
    [anon_sym_short] = ACTIONS(5478),
    [anon_sym_LBRACK] = ACTIONS(5478),
    [anon_sym_static] = ACTIONS(5478),
    [anon_sym_register] = ACTIONS(5478),
    [anon_sym_inline] = ACTIONS(5478),
    [anon_sym___inline] = ACTIONS(5478),
    [anon_sym___inline__] = ACTIONS(5478),
    [anon_sym___forceinline] = ACTIONS(5478),
    [anon_sym_thread_local] = ACTIONS(5478),
    [anon_sym___thread] = ACTIONS(5478),
    [anon_sym_const] = ACTIONS(5478),
    [anon_sym_constexpr] = ACTIONS(5478),
    [anon_sym_volatile] = ACTIONS(5478),
    [anon_sym_restrict] = ACTIONS(5478),
    [anon_sym___restrict__] = ACTIONS(5478),
    [anon_sym__Atomic] = ACTIONS(5478),
    [anon_sym__Noreturn] = ACTIONS(5478),
    [anon_sym_noreturn] = ACTIONS(5478),
    [anon_sym_mutable] = ACTIONS(5478),
    [anon_sym_constinit] = ACTIONS(5478),
    [anon_sym_consteval] = ACTIONS(5478),
    [anon_sym_alignas] = ACTIONS(5478),
    [anon_sym__Alignas] = ACTIONS(5478),
    [sym_primitive_type] = ACTIONS(5478),
    [anon_sym_enum] = ACTIONS(5478),
    [anon_sym_class] = ACTIONS(5478),
    [anon_sym_struct] = ACTIONS(5478),
    [anon_sym_union] = ACTIONS(5478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5478),
    [anon_sym_let] = ACTIONS(5478),
    [anon_sym_This] = ACTIONS(5478),
    [anon_sym_decltype] = ACTIONS(5478),
    [sym_virtual] = ACTIONS(5478),
    [anon_sym_explicit] = ACTIONS(5478),
    [anon_sym_typename] = ACTIONS(5478),
    [anon_sym_template] = ACTIONS(5478),
    [anon_sym_operator] = ACTIONS(5478),
    [anon_sym_friend] = ACTIONS(5478),
    [anon_sym_public] = ACTIONS(5478),
    [anon_sym_private] = ACTIONS(5478),
    [anon_sym_protected] = ACTIONS(5478),
    [anon_sym_using] = ACTIONS(5478),
    [anon_sym_static_assert] = ACTIONS(5478),
    [anon_sym_precise] = ACTIONS(5478),
    [anon_sym_shared] = ACTIONS(5478),
    [anon_sym_groupshared] = ACTIONS(5478),
    [anon_sym_uniform] = ACTIONS(5478),
    [anon_sym_row_major] = ACTIONS(5478),
    [anon_sym_column_major] = ACTIONS(5478),
    [anon_sym_globallycoherent] = ACTIONS(5478),
    [anon_sym_centroid] = ACTIONS(5478),
    [anon_sym_noperspective] = ACTIONS(5478),
    [anon_sym_nointerpolation] = ACTIONS(5478),
    [anon_sym_sample] = ACTIONS(5478),
    [anon_sym_linear] = ACTIONS(5478),
    [anon_sym_snorm] = ACTIONS(5478),
    [anon_sym_unorm] = ACTIONS(5478),
    [anon_sym_point] = ACTIONS(5478),
    [anon_sym_line] = ACTIONS(5478),
    [anon_sym_triangleadj] = ACTIONS(5478),
    [anon_sym_lineadj] = ACTIONS(5478),
    [anon_sym_triangle] = ACTIONS(5478),
    [anon_sym_interface] = ACTIONS(5478),
    [anon_sym_extension] = ACTIONS(5478),
    [anon_sym___init] = ACTIONS(5478),
    [anon_sym___subscript] = ACTIONS(5478),
    [anon_sym_property] = ACTIONS(5478),
    [anon_sym_associatedtype] = ACTIONS(5478),
  },
  [2198] = {
    [sym_identifier] = ACTIONS(5460),
    [aux_sym_preproc_def_token1] = ACTIONS(5460),
    [aux_sym_preproc_if_token1] = ACTIONS(5460),
    [aux_sym_preproc_if_token2] = ACTIONS(5460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5460),
    [sym_preproc_directive] = ACTIONS(5460),
    [anon_sym_LPAREN2] = ACTIONS(5462),
    [anon_sym_TILDE] = ACTIONS(5462),
    [anon_sym_STAR] = ACTIONS(5462),
    [anon_sym_AMP_AMP] = ACTIONS(5462),
    [anon_sym_AMP] = ACTIONS(5460),
    [anon_sym___extension__] = ACTIONS(5460),
    [anon_sym_typedef] = ACTIONS(5460),
    [anon_sym_in] = ACTIONS(5460),
    [anon_sym_out] = ACTIONS(5460),
    [anon_sym_inout] = ACTIONS(5460),
    [anon_sym_extern] = ACTIONS(5460),
    [anon_sym___attribute__] = ACTIONS(5460),
    [anon_sym_COLON_COLON] = ACTIONS(5462),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5462),
    [anon_sym___declspec] = ACTIONS(5460),
    [anon_sym___based] = ACTIONS(5460),
    [anon_sym_signed] = ACTIONS(5460),
    [anon_sym_unsigned] = ACTIONS(5460),
    [anon_sym_long] = ACTIONS(5460),
    [anon_sym_short] = ACTIONS(5460),
    [anon_sym_LBRACK] = ACTIONS(5460),
    [anon_sym_static] = ACTIONS(5460),
    [anon_sym_register] = ACTIONS(5460),
    [anon_sym_inline] = ACTIONS(5460),
    [anon_sym___inline] = ACTIONS(5460),
    [anon_sym___inline__] = ACTIONS(5460),
    [anon_sym___forceinline] = ACTIONS(5460),
    [anon_sym_thread_local] = ACTIONS(5460),
    [anon_sym___thread] = ACTIONS(5460),
    [anon_sym_const] = ACTIONS(5460),
    [anon_sym_constexpr] = ACTIONS(5460),
    [anon_sym_volatile] = ACTIONS(5460),
    [anon_sym_restrict] = ACTIONS(5460),
    [anon_sym___restrict__] = ACTIONS(5460),
    [anon_sym__Atomic] = ACTIONS(5460),
    [anon_sym__Noreturn] = ACTIONS(5460),
    [anon_sym_noreturn] = ACTIONS(5460),
    [anon_sym_mutable] = ACTIONS(5460),
    [anon_sym_constinit] = ACTIONS(5460),
    [anon_sym_consteval] = ACTIONS(5460),
    [anon_sym_alignas] = ACTIONS(5460),
    [anon_sym__Alignas] = ACTIONS(5460),
    [sym_primitive_type] = ACTIONS(5460),
    [anon_sym_enum] = ACTIONS(5460),
    [anon_sym_class] = ACTIONS(5460),
    [anon_sym_struct] = ACTIONS(5460),
    [anon_sym_union] = ACTIONS(5460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5460),
    [anon_sym_let] = ACTIONS(5460),
    [anon_sym_This] = ACTIONS(5460),
    [anon_sym_decltype] = ACTIONS(5460),
    [sym_virtual] = ACTIONS(5460),
    [anon_sym_explicit] = ACTIONS(5460),
    [anon_sym_typename] = ACTIONS(5460),
    [anon_sym_template] = ACTIONS(5460),
    [anon_sym_operator] = ACTIONS(5460),
    [anon_sym_friend] = ACTIONS(5460),
    [anon_sym_public] = ACTIONS(5460),
    [anon_sym_private] = ACTIONS(5460),
    [anon_sym_protected] = ACTIONS(5460),
    [anon_sym_using] = ACTIONS(5460),
    [anon_sym_static_assert] = ACTIONS(5460),
    [anon_sym_precise] = ACTIONS(5460),
    [anon_sym_shared] = ACTIONS(5460),
    [anon_sym_groupshared] = ACTIONS(5460),
    [anon_sym_uniform] = ACTIONS(5460),
    [anon_sym_row_major] = ACTIONS(5460),
    [anon_sym_column_major] = ACTIONS(5460),
    [anon_sym_globallycoherent] = ACTIONS(5460),
    [anon_sym_centroid] = ACTIONS(5460),
    [anon_sym_noperspective] = ACTIONS(5460),
    [anon_sym_nointerpolation] = ACTIONS(5460),
    [anon_sym_sample] = ACTIONS(5460),
    [anon_sym_linear] = ACTIONS(5460),
    [anon_sym_snorm] = ACTIONS(5460),
    [anon_sym_unorm] = ACTIONS(5460),
    [anon_sym_point] = ACTIONS(5460),
    [anon_sym_line] = ACTIONS(5460),
    [anon_sym_triangleadj] = ACTIONS(5460),
    [anon_sym_lineadj] = ACTIONS(5460),
    [anon_sym_triangle] = ACTIONS(5460),
    [anon_sym_interface] = ACTIONS(5460),
    [anon_sym_extension] = ACTIONS(5460),
    [anon_sym___init] = ACTIONS(5460),
    [anon_sym___subscript] = ACTIONS(5460),
    [anon_sym_property] = ACTIONS(5460),
    [anon_sym_associatedtype] = ACTIONS(5460),
  },
  [2199] = {
    [sym_identifier] = ACTIONS(5460),
    [aux_sym_preproc_def_token1] = ACTIONS(5460),
    [aux_sym_preproc_if_token1] = ACTIONS(5460),
    [aux_sym_preproc_if_token2] = ACTIONS(5460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5460),
    [sym_preproc_directive] = ACTIONS(5460),
    [anon_sym_LPAREN2] = ACTIONS(5462),
    [anon_sym_TILDE] = ACTIONS(5462),
    [anon_sym_STAR] = ACTIONS(5462),
    [anon_sym_AMP_AMP] = ACTIONS(5462),
    [anon_sym_AMP] = ACTIONS(5460),
    [anon_sym___extension__] = ACTIONS(5460),
    [anon_sym_typedef] = ACTIONS(5460),
    [anon_sym_in] = ACTIONS(5460),
    [anon_sym_out] = ACTIONS(5460),
    [anon_sym_inout] = ACTIONS(5460),
    [anon_sym_extern] = ACTIONS(5460),
    [anon_sym___attribute__] = ACTIONS(5460),
    [anon_sym_COLON_COLON] = ACTIONS(5462),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5462),
    [anon_sym___declspec] = ACTIONS(5460),
    [anon_sym___based] = ACTIONS(5460),
    [anon_sym_signed] = ACTIONS(5460),
    [anon_sym_unsigned] = ACTIONS(5460),
    [anon_sym_long] = ACTIONS(5460),
    [anon_sym_short] = ACTIONS(5460),
    [anon_sym_LBRACK] = ACTIONS(5460),
    [anon_sym_static] = ACTIONS(5460),
    [anon_sym_register] = ACTIONS(5460),
    [anon_sym_inline] = ACTIONS(5460),
    [anon_sym___inline] = ACTIONS(5460),
    [anon_sym___inline__] = ACTIONS(5460),
    [anon_sym___forceinline] = ACTIONS(5460),
    [anon_sym_thread_local] = ACTIONS(5460),
    [anon_sym___thread] = ACTIONS(5460),
    [anon_sym_const] = ACTIONS(5460),
    [anon_sym_constexpr] = ACTIONS(5460),
    [anon_sym_volatile] = ACTIONS(5460),
    [anon_sym_restrict] = ACTIONS(5460),
    [anon_sym___restrict__] = ACTIONS(5460),
    [anon_sym__Atomic] = ACTIONS(5460),
    [anon_sym__Noreturn] = ACTIONS(5460),
    [anon_sym_noreturn] = ACTIONS(5460),
    [anon_sym_mutable] = ACTIONS(5460),
    [anon_sym_constinit] = ACTIONS(5460),
    [anon_sym_consteval] = ACTIONS(5460),
    [anon_sym_alignas] = ACTIONS(5460),
    [anon_sym__Alignas] = ACTIONS(5460),
    [sym_primitive_type] = ACTIONS(5460),
    [anon_sym_enum] = ACTIONS(5460),
    [anon_sym_class] = ACTIONS(5460),
    [anon_sym_struct] = ACTIONS(5460),
    [anon_sym_union] = ACTIONS(5460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5460),
    [anon_sym_let] = ACTIONS(5460),
    [anon_sym_This] = ACTIONS(5460),
    [anon_sym_decltype] = ACTIONS(5460),
    [sym_virtual] = ACTIONS(5460),
    [anon_sym_explicit] = ACTIONS(5460),
    [anon_sym_typename] = ACTIONS(5460),
    [anon_sym_template] = ACTIONS(5460),
    [anon_sym_operator] = ACTIONS(5460),
    [anon_sym_friend] = ACTIONS(5460),
    [anon_sym_public] = ACTIONS(5460),
    [anon_sym_private] = ACTIONS(5460),
    [anon_sym_protected] = ACTIONS(5460),
    [anon_sym_using] = ACTIONS(5460),
    [anon_sym_static_assert] = ACTIONS(5460),
    [anon_sym_precise] = ACTIONS(5460),
    [anon_sym_shared] = ACTIONS(5460),
    [anon_sym_groupshared] = ACTIONS(5460),
    [anon_sym_uniform] = ACTIONS(5460),
    [anon_sym_row_major] = ACTIONS(5460),
    [anon_sym_column_major] = ACTIONS(5460),
    [anon_sym_globallycoherent] = ACTIONS(5460),
    [anon_sym_centroid] = ACTIONS(5460),
    [anon_sym_noperspective] = ACTIONS(5460),
    [anon_sym_nointerpolation] = ACTIONS(5460),
    [anon_sym_sample] = ACTIONS(5460),
    [anon_sym_linear] = ACTIONS(5460),
    [anon_sym_snorm] = ACTIONS(5460),
    [anon_sym_unorm] = ACTIONS(5460),
    [anon_sym_point] = ACTIONS(5460),
    [anon_sym_line] = ACTIONS(5460),
    [anon_sym_triangleadj] = ACTIONS(5460),
    [anon_sym_lineadj] = ACTIONS(5460),
    [anon_sym_triangle] = ACTIONS(5460),
    [anon_sym_interface] = ACTIONS(5460),
    [anon_sym_extension] = ACTIONS(5460),
    [anon_sym___init] = ACTIONS(5460),
    [anon_sym___subscript] = ACTIONS(5460),
    [anon_sym_property] = ACTIONS(5460),
    [anon_sym_associatedtype] = ACTIONS(5460),
  },
  [2200] = {
    [sym_identifier] = ACTIONS(5474),
    [aux_sym_preproc_def_token1] = ACTIONS(5474),
    [aux_sym_preproc_if_token1] = ACTIONS(5474),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5474),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5474),
    [sym_preproc_directive] = ACTIONS(5474),
    [anon_sym_LPAREN2] = ACTIONS(5476),
    [anon_sym_TILDE] = ACTIONS(5476),
    [anon_sym_STAR] = ACTIONS(5476),
    [anon_sym_AMP_AMP] = ACTIONS(5476),
    [anon_sym_AMP] = ACTIONS(5474),
    [anon_sym___extension__] = ACTIONS(5474),
    [anon_sym_typedef] = ACTIONS(5474),
    [anon_sym_in] = ACTIONS(5474),
    [anon_sym_out] = ACTIONS(5474),
    [anon_sym_inout] = ACTIONS(5474),
    [anon_sym_extern] = ACTIONS(5474),
    [anon_sym___attribute__] = ACTIONS(5474),
    [anon_sym_COLON_COLON] = ACTIONS(5476),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5476),
    [anon_sym___declspec] = ACTIONS(5474),
    [anon_sym___based] = ACTIONS(5474),
    [anon_sym_RBRACE] = ACTIONS(5476),
    [anon_sym_signed] = ACTIONS(5474),
    [anon_sym_unsigned] = ACTIONS(5474),
    [anon_sym_long] = ACTIONS(5474),
    [anon_sym_short] = ACTIONS(5474),
    [anon_sym_LBRACK] = ACTIONS(5474),
    [anon_sym_static] = ACTIONS(5474),
    [anon_sym_register] = ACTIONS(5474),
    [anon_sym_inline] = ACTIONS(5474),
    [anon_sym___inline] = ACTIONS(5474),
    [anon_sym___inline__] = ACTIONS(5474),
    [anon_sym___forceinline] = ACTIONS(5474),
    [anon_sym_thread_local] = ACTIONS(5474),
    [anon_sym___thread] = ACTIONS(5474),
    [anon_sym_const] = ACTIONS(5474),
    [anon_sym_constexpr] = ACTIONS(5474),
    [anon_sym_volatile] = ACTIONS(5474),
    [anon_sym_restrict] = ACTIONS(5474),
    [anon_sym___restrict__] = ACTIONS(5474),
    [anon_sym__Atomic] = ACTIONS(5474),
    [anon_sym__Noreturn] = ACTIONS(5474),
    [anon_sym_noreturn] = ACTIONS(5474),
    [anon_sym_mutable] = ACTIONS(5474),
    [anon_sym_constinit] = ACTIONS(5474),
    [anon_sym_consteval] = ACTIONS(5474),
    [anon_sym_alignas] = ACTIONS(5474),
    [anon_sym__Alignas] = ACTIONS(5474),
    [sym_primitive_type] = ACTIONS(5474),
    [anon_sym_enum] = ACTIONS(5474),
    [anon_sym_class] = ACTIONS(5474),
    [anon_sym_struct] = ACTIONS(5474),
    [anon_sym_union] = ACTIONS(5474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5474),
    [anon_sym_let] = ACTIONS(5474),
    [anon_sym_This] = ACTIONS(5474),
    [anon_sym_decltype] = ACTIONS(5474),
    [sym_virtual] = ACTIONS(5474),
    [anon_sym_explicit] = ACTIONS(5474),
    [anon_sym_typename] = ACTIONS(5474),
    [anon_sym_template] = ACTIONS(5474),
    [anon_sym_operator] = ACTIONS(5474),
    [anon_sym_friend] = ACTIONS(5474),
    [anon_sym_public] = ACTIONS(5474),
    [anon_sym_private] = ACTIONS(5474),
    [anon_sym_protected] = ACTIONS(5474),
    [anon_sym_using] = ACTIONS(5474),
    [anon_sym_static_assert] = ACTIONS(5474),
    [anon_sym_precise] = ACTIONS(5474),
    [anon_sym_shared] = ACTIONS(5474),
    [anon_sym_groupshared] = ACTIONS(5474),
    [anon_sym_uniform] = ACTIONS(5474),
    [anon_sym_row_major] = ACTIONS(5474),
    [anon_sym_column_major] = ACTIONS(5474),
    [anon_sym_globallycoherent] = ACTIONS(5474),
    [anon_sym_centroid] = ACTIONS(5474),
    [anon_sym_noperspective] = ACTIONS(5474),
    [anon_sym_nointerpolation] = ACTIONS(5474),
    [anon_sym_sample] = ACTIONS(5474),
    [anon_sym_linear] = ACTIONS(5474),
    [anon_sym_snorm] = ACTIONS(5474),
    [anon_sym_unorm] = ACTIONS(5474),
    [anon_sym_point] = ACTIONS(5474),
    [anon_sym_line] = ACTIONS(5474),
    [anon_sym_triangleadj] = ACTIONS(5474),
    [anon_sym_lineadj] = ACTIONS(5474),
    [anon_sym_triangle] = ACTIONS(5474),
    [anon_sym_interface] = ACTIONS(5474),
    [anon_sym_extension] = ACTIONS(5474),
    [anon_sym___init] = ACTIONS(5474),
    [anon_sym___subscript] = ACTIONS(5474),
    [anon_sym_property] = ACTIONS(5474),
    [anon_sym_associatedtype] = ACTIONS(5474),
  },
  [2201] = {
    [sym_identifier] = ACTIONS(3034),
    [aux_sym_preproc_def_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_in] = ACTIONS(3034),
    [anon_sym_out] = ACTIONS(3034),
    [anon_sym_inout] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym___based] = ACTIONS(3034),
    [anon_sym_RBRACE] = ACTIONS(3036),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_This] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [sym_virtual] = ACTIONS(3034),
    [anon_sym_explicit] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_operator] = ACTIONS(3034),
    [anon_sym_friend] = ACTIONS(3034),
    [anon_sym_public] = ACTIONS(3034),
    [anon_sym_private] = ACTIONS(3034),
    [anon_sym_protected] = ACTIONS(3034),
    [anon_sym_using] = ACTIONS(3034),
    [anon_sym_static_assert] = ACTIONS(3034),
    [anon_sym_precise] = ACTIONS(3034),
    [anon_sym_shared] = ACTIONS(3034),
    [anon_sym_groupshared] = ACTIONS(3034),
    [anon_sym_uniform] = ACTIONS(3034),
    [anon_sym_row_major] = ACTIONS(3034),
    [anon_sym_column_major] = ACTIONS(3034),
    [anon_sym_globallycoherent] = ACTIONS(3034),
    [anon_sym_centroid] = ACTIONS(3034),
    [anon_sym_noperspective] = ACTIONS(3034),
    [anon_sym_nointerpolation] = ACTIONS(3034),
    [anon_sym_sample] = ACTIONS(3034),
    [anon_sym_linear] = ACTIONS(3034),
    [anon_sym_snorm] = ACTIONS(3034),
    [anon_sym_unorm] = ACTIONS(3034),
    [anon_sym_point] = ACTIONS(3034),
    [anon_sym_line] = ACTIONS(3034),
    [anon_sym_triangleadj] = ACTIONS(3034),
    [anon_sym_lineadj] = ACTIONS(3034),
    [anon_sym_triangle] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3034),
    [anon_sym_extension] = ACTIONS(3034),
    [anon_sym___init] = ACTIONS(3034),
    [anon_sym___subscript] = ACTIONS(3034),
    [anon_sym_property] = ACTIONS(3034),
    [anon_sym_associatedtype] = ACTIONS(3034),
  },
  [2202] = {
    [sym_expression] = STATE(3962),
    [sym__string] = STATE(4545),
    [sym_conditional_expression] = STATE(4545),
    [sym_assignment_expression] = STATE(4545),
    [sym_pointer_expression] = STATE(4540),
    [sym_unary_expression] = STATE(4545),
    [sym_binary_expression] = STATE(4545),
    [sym_update_expression] = STATE(4545),
    [sym_cast_expression] = STATE(4545),
    [sym_sizeof_expression] = STATE(4545),
    [sym_alignof_expression] = STATE(4545),
    [sym_offsetof_expression] = STATE(4545),
    [sym_generic_expression] = STATE(4545),
    [sym_subscript_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_gnu_asm_expression] = STATE(4545),
    [sym_field_expression] = STATE(4540),
    [sym_compound_literal_expression] = STATE(4545),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_char_literal] = STATE(4286),
    [sym_concatenated_string] = STATE(4290),
    [sym_string_literal] = STATE(3166),
    [sym_null] = STATE(4545),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9673),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4545),
    [sym_raw_string_literal] = STATE(3169),
    [sym_co_await_expression] = STATE(4545),
    [sym_new_expression] = STATE(4545),
    [sym_delete_expression] = STATE(4545),
    [sym_requires_clause] = STATE(4545),
    [sym_requires_expression] = STATE(4545),
    [sym_lambda_expression] = STATE(4545),
    [sym_lambda_capture_specifier] = STATE(7034),
    [sym_fold_expression] = STATE(4545),
    [sym_parameter_pack_expansion] = STATE(4545),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4540),
    [sym_qualified_type_identifier] = STATE(9673),
    [sym_user_defined_literal] = STATE(4540),
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_LPAREN2] = ACTIONS(5828),
    [anon_sym_BANG] = ACTIONS(4733),
    [anon_sym_TILDE] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4731),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4735),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4739),
    [anon_sym_not] = ACTIONS(4731),
    [anon_sym_compl] = ACTIONS(4731),
    [anon_sym_DASH_DASH] = ACTIONS(5711),
    [anon_sym_PLUS_PLUS] = ACTIONS(5711),
    [anon_sym_sizeof] = ACTIONS(4741),
    [anon_sym___alignof__] = ACTIONS(4743),
    [anon_sym___alignof] = ACTIONS(4743),
    [anon_sym__alignof] = ACTIONS(4743),
    [anon_sym_alignof] = ACTIONS(4743),
    [anon_sym__Alignof] = ACTIONS(4743),
    [anon_sym_offsetof] = ACTIONS(4745),
    [anon_sym__Generic] = ACTIONS(4747),
    [anon_sym_asm] = ACTIONS(4749),
    [anon_sym___asm__] = ACTIONS(4749),
    [sym_number_literal] = ACTIONS(4751),
    [anon_sym_L_SQUOTE] = ACTIONS(4753),
    [anon_sym_u_SQUOTE] = ACTIONS(4753),
    [anon_sym_U_SQUOTE] = ACTIONS(4753),
    [anon_sym_u8_SQUOTE] = ACTIONS(4753),
    [anon_sym_SQUOTE] = ACTIONS(4753),
    [anon_sym_L_DQUOTE] = ACTIONS(4755),
    [anon_sym_u_DQUOTE] = ACTIONS(4755),
    [anon_sym_U_DQUOTE] = ACTIONS(4755),
    [anon_sym_u8_DQUOTE] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [anon_sym_NULL] = ACTIONS(4759),
    [anon_sym_nullptr] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4761),
    [anon_sym_R_DQUOTE] = ACTIONS(4763),
    [anon_sym_LR_DQUOTE] = ACTIONS(4763),
    [anon_sym_uR_DQUOTE] = ACTIONS(4763),
    [anon_sym_UR_DQUOTE] = ACTIONS(4763),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4763),
    [anon_sym_co_await] = ACTIONS(4765),
    [anon_sym_new] = ACTIONS(4767),
    [anon_sym_requires] = ACTIONS(4769),
    [sym_this] = ACTIONS(4757),
  },
  [2203] = {
    [sym_expression] = STATE(4093),
    [sym__string] = STATE(4545),
    [sym_conditional_expression] = STATE(4545),
    [sym_assignment_expression] = STATE(4545),
    [sym_pointer_expression] = STATE(4540),
    [sym_unary_expression] = STATE(4545),
    [sym_binary_expression] = STATE(4545),
    [sym_update_expression] = STATE(4545),
    [sym_cast_expression] = STATE(4545),
    [sym_sizeof_expression] = STATE(4545),
    [sym_alignof_expression] = STATE(4545),
    [sym_offsetof_expression] = STATE(4545),
    [sym_generic_expression] = STATE(4545),
    [sym_subscript_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_gnu_asm_expression] = STATE(4545),
    [sym_field_expression] = STATE(4540),
    [sym_compound_literal_expression] = STATE(4545),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_char_literal] = STATE(4286),
    [sym_concatenated_string] = STATE(4290),
    [sym_string_literal] = STATE(3166),
    [sym_null] = STATE(4545),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9673),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4545),
    [sym_raw_string_literal] = STATE(3169),
    [sym_co_await_expression] = STATE(4545),
    [sym_new_expression] = STATE(4545),
    [sym_delete_expression] = STATE(4545),
    [sym_requires_clause] = STATE(4545),
    [sym_requires_expression] = STATE(4545),
    [sym_lambda_expression] = STATE(4545),
    [sym_lambda_capture_specifier] = STATE(7034),
    [sym_fold_expression] = STATE(4545),
    [sym_parameter_pack_expansion] = STATE(4545),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4540),
    [sym_qualified_type_identifier] = STATE(9673),
    [sym_user_defined_literal] = STATE(4540),
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_LPAREN2] = ACTIONS(5828),
    [anon_sym_BANG] = ACTIONS(4733),
    [anon_sym_TILDE] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4731),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4735),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4739),
    [anon_sym_not] = ACTIONS(4731),
    [anon_sym_compl] = ACTIONS(4731),
    [anon_sym_DASH_DASH] = ACTIONS(5711),
    [anon_sym_PLUS_PLUS] = ACTIONS(5711),
    [anon_sym_sizeof] = ACTIONS(4741),
    [anon_sym___alignof__] = ACTIONS(4743),
    [anon_sym___alignof] = ACTIONS(4743),
    [anon_sym__alignof] = ACTIONS(4743),
    [anon_sym_alignof] = ACTIONS(4743),
    [anon_sym__Alignof] = ACTIONS(4743),
    [anon_sym_offsetof] = ACTIONS(4745),
    [anon_sym__Generic] = ACTIONS(4747),
    [anon_sym_asm] = ACTIONS(4749),
    [anon_sym___asm__] = ACTIONS(4749),
    [sym_number_literal] = ACTIONS(4751),
    [anon_sym_L_SQUOTE] = ACTIONS(4753),
    [anon_sym_u_SQUOTE] = ACTIONS(4753),
    [anon_sym_U_SQUOTE] = ACTIONS(4753),
    [anon_sym_u8_SQUOTE] = ACTIONS(4753),
    [anon_sym_SQUOTE] = ACTIONS(4753),
    [anon_sym_L_DQUOTE] = ACTIONS(4755),
    [anon_sym_u_DQUOTE] = ACTIONS(4755),
    [anon_sym_U_DQUOTE] = ACTIONS(4755),
    [anon_sym_u8_DQUOTE] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [anon_sym_NULL] = ACTIONS(4759),
    [anon_sym_nullptr] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4761),
    [anon_sym_R_DQUOTE] = ACTIONS(4763),
    [anon_sym_LR_DQUOTE] = ACTIONS(4763),
    [anon_sym_uR_DQUOTE] = ACTIONS(4763),
    [anon_sym_UR_DQUOTE] = ACTIONS(4763),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4763),
    [anon_sym_co_await] = ACTIONS(4765),
    [anon_sym_new] = ACTIONS(4767),
    [anon_sym_requires] = ACTIONS(4769),
    [sym_this] = ACTIONS(4757),
  },
  [2204] = {
    [sym_expression] = STATE(5407),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2205] = {
    [sym_expression] = STATE(5585),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2206] = {
    [sym_expression] = STATE(5432),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(6100),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2207] = {
    [sym_expression] = STATE(5314),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2208] = {
    [sym_identifier] = ACTIONS(3629),
    [aux_sym_preproc_def_token1] = ACTIONS(3629),
    [aux_sym_preproc_if_token1] = ACTIONS(3629),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3629),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3629),
    [sym_preproc_directive] = ACTIONS(3629),
    [anon_sym_LPAREN2] = ACTIONS(3631),
    [anon_sym_TILDE] = ACTIONS(3631),
    [anon_sym_STAR] = ACTIONS(3631),
    [anon_sym_AMP_AMP] = ACTIONS(3631),
    [anon_sym_AMP] = ACTIONS(3629),
    [anon_sym___extension__] = ACTIONS(3629),
    [anon_sym_typedef] = ACTIONS(3629),
    [anon_sym_in] = ACTIONS(3629),
    [anon_sym_out] = ACTIONS(3629),
    [anon_sym_inout] = ACTIONS(3629),
    [anon_sym_extern] = ACTIONS(3629),
    [anon_sym___attribute__] = ACTIONS(3629),
    [anon_sym_COLON_COLON] = ACTIONS(3631),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3631),
    [anon_sym___declspec] = ACTIONS(3629),
    [anon_sym___based] = ACTIONS(3629),
    [anon_sym_RBRACE] = ACTIONS(3631),
    [anon_sym_signed] = ACTIONS(3629),
    [anon_sym_unsigned] = ACTIONS(3629),
    [anon_sym_long] = ACTIONS(3629),
    [anon_sym_short] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3629),
    [anon_sym_static] = ACTIONS(3629),
    [anon_sym_register] = ACTIONS(3629),
    [anon_sym_inline] = ACTIONS(3629),
    [anon_sym___inline] = ACTIONS(3629),
    [anon_sym___inline__] = ACTIONS(3629),
    [anon_sym___forceinline] = ACTIONS(3629),
    [anon_sym_thread_local] = ACTIONS(3629),
    [anon_sym___thread] = ACTIONS(3629),
    [anon_sym_const] = ACTIONS(3629),
    [anon_sym_constexpr] = ACTIONS(3629),
    [anon_sym_volatile] = ACTIONS(3629),
    [anon_sym_restrict] = ACTIONS(3629),
    [anon_sym___restrict__] = ACTIONS(3629),
    [anon_sym__Atomic] = ACTIONS(3629),
    [anon_sym__Noreturn] = ACTIONS(3629),
    [anon_sym_noreturn] = ACTIONS(3629),
    [anon_sym_mutable] = ACTIONS(3629),
    [anon_sym_constinit] = ACTIONS(3629),
    [anon_sym_consteval] = ACTIONS(3629),
    [anon_sym_alignas] = ACTIONS(3629),
    [anon_sym__Alignas] = ACTIONS(3629),
    [sym_primitive_type] = ACTIONS(3629),
    [anon_sym_enum] = ACTIONS(3629),
    [anon_sym_class] = ACTIONS(3629),
    [anon_sym_struct] = ACTIONS(3629),
    [anon_sym_union] = ACTIONS(3629),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3629),
    [anon_sym_let] = ACTIONS(3629),
    [anon_sym_This] = ACTIONS(3629),
    [anon_sym_decltype] = ACTIONS(3629),
    [sym_virtual] = ACTIONS(3629),
    [anon_sym_explicit] = ACTIONS(3629),
    [anon_sym_typename] = ACTIONS(3629),
    [anon_sym_template] = ACTIONS(3629),
    [anon_sym_operator] = ACTIONS(3629),
    [anon_sym_friend] = ACTIONS(3629),
    [anon_sym_public] = ACTIONS(3629),
    [anon_sym_private] = ACTIONS(3629),
    [anon_sym_protected] = ACTIONS(3629),
    [anon_sym_using] = ACTIONS(3629),
    [anon_sym_static_assert] = ACTIONS(3629),
    [anon_sym_precise] = ACTIONS(3629),
    [anon_sym_shared] = ACTIONS(3629),
    [anon_sym_groupshared] = ACTIONS(3629),
    [anon_sym_uniform] = ACTIONS(3629),
    [anon_sym_row_major] = ACTIONS(3629),
    [anon_sym_column_major] = ACTIONS(3629),
    [anon_sym_globallycoherent] = ACTIONS(3629),
    [anon_sym_centroid] = ACTIONS(3629),
    [anon_sym_noperspective] = ACTIONS(3629),
    [anon_sym_nointerpolation] = ACTIONS(3629),
    [anon_sym_sample] = ACTIONS(3629),
    [anon_sym_linear] = ACTIONS(3629),
    [anon_sym_snorm] = ACTIONS(3629),
    [anon_sym_unorm] = ACTIONS(3629),
    [anon_sym_point] = ACTIONS(3629),
    [anon_sym_line] = ACTIONS(3629),
    [anon_sym_triangleadj] = ACTIONS(3629),
    [anon_sym_lineadj] = ACTIONS(3629),
    [anon_sym_triangle] = ACTIONS(3629),
    [anon_sym_interface] = ACTIONS(3629),
    [anon_sym_extension] = ACTIONS(3629),
    [anon_sym___init] = ACTIONS(3629),
    [anon_sym___subscript] = ACTIONS(3629),
    [anon_sym_property] = ACTIONS(3629),
    [anon_sym_associatedtype] = ACTIONS(3629),
  },
  [2209] = {
    [sym_expression] = STATE(3786),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5781),
    [anon_sym_BANG] = ACTIONS(4611),
    [anon_sym_TILDE] = ACTIONS(4611),
    [anon_sym_DASH] = ACTIONS(4609),
    [anon_sym_PLUS] = ACTIONS(4609),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4613),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4609),
    [anon_sym_compl] = ACTIONS(4609),
    [anon_sym_DASH_DASH] = ACTIONS(5713),
    [anon_sym_PLUS_PLUS] = ACTIONS(5713),
    [anon_sym_sizeof] = ACTIONS(4615),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4617),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4619),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2210] = {
    [sym_expression] = STATE(5583),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2211] = {
    [sym_expression] = STATE(3783),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5781),
    [anon_sym_BANG] = ACTIONS(4611),
    [anon_sym_TILDE] = ACTIONS(4611),
    [anon_sym_DASH] = ACTIONS(4609),
    [anon_sym_PLUS] = ACTIONS(4609),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4613),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4609),
    [anon_sym_compl] = ACTIONS(4609),
    [anon_sym_DASH_DASH] = ACTIONS(5713),
    [anon_sym_PLUS_PLUS] = ACTIONS(5713),
    [anon_sym_sizeof] = ACTIONS(4615),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4617),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4619),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2212] = {
    [sym_identifier] = ACTIONS(3587),
    [aux_sym_preproc_def_token1] = ACTIONS(3587),
    [aux_sym_preproc_if_token1] = ACTIONS(3587),
    [aux_sym_preproc_if_token2] = ACTIONS(3587),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3587),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3587),
    [sym_preproc_directive] = ACTIONS(3587),
    [anon_sym_LPAREN2] = ACTIONS(3589),
    [anon_sym_TILDE] = ACTIONS(3589),
    [anon_sym_STAR] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3587),
    [anon_sym___extension__] = ACTIONS(3587),
    [anon_sym_typedef] = ACTIONS(3587),
    [anon_sym_in] = ACTIONS(3587),
    [anon_sym_out] = ACTIONS(3587),
    [anon_sym_inout] = ACTIONS(3587),
    [anon_sym_extern] = ACTIONS(3587),
    [anon_sym___attribute__] = ACTIONS(3587),
    [anon_sym_COLON_COLON] = ACTIONS(3589),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3589),
    [anon_sym___declspec] = ACTIONS(3587),
    [anon_sym___based] = ACTIONS(3587),
    [anon_sym_signed] = ACTIONS(3587),
    [anon_sym_unsigned] = ACTIONS(3587),
    [anon_sym_long] = ACTIONS(3587),
    [anon_sym_short] = ACTIONS(3587),
    [anon_sym_LBRACK] = ACTIONS(3587),
    [anon_sym_static] = ACTIONS(3587),
    [anon_sym_register] = ACTIONS(3587),
    [anon_sym_inline] = ACTIONS(3587),
    [anon_sym___inline] = ACTIONS(3587),
    [anon_sym___inline__] = ACTIONS(3587),
    [anon_sym___forceinline] = ACTIONS(3587),
    [anon_sym_thread_local] = ACTIONS(3587),
    [anon_sym___thread] = ACTIONS(3587),
    [anon_sym_const] = ACTIONS(3587),
    [anon_sym_constexpr] = ACTIONS(3587),
    [anon_sym_volatile] = ACTIONS(3587),
    [anon_sym_restrict] = ACTIONS(3587),
    [anon_sym___restrict__] = ACTIONS(3587),
    [anon_sym__Atomic] = ACTIONS(3587),
    [anon_sym__Noreturn] = ACTIONS(3587),
    [anon_sym_noreturn] = ACTIONS(3587),
    [anon_sym_mutable] = ACTIONS(3587),
    [anon_sym_constinit] = ACTIONS(3587),
    [anon_sym_consteval] = ACTIONS(3587),
    [anon_sym_alignas] = ACTIONS(3587),
    [anon_sym__Alignas] = ACTIONS(3587),
    [sym_primitive_type] = ACTIONS(3587),
    [anon_sym_enum] = ACTIONS(3587),
    [anon_sym_class] = ACTIONS(3587),
    [anon_sym_struct] = ACTIONS(3587),
    [anon_sym_union] = ACTIONS(3587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3587),
    [anon_sym_let] = ACTIONS(3587),
    [anon_sym_This] = ACTIONS(3587),
    [anon_sym_decltype] = ACTIONS(3587),
    [sym_virtual] = ACTIONS(3587),
    [anon_sym_explicit] = ACTIONS(3587),
    [anon_sym_typename] = ACTIONS(3587),
    [anon_sym_template] = ACTIONS(3587),
    [anon_sym_operator] = ACTIONS(3587),
    [anon_sym_friend] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3587),
    [anon_sym_private] = ACTIONS(3587),
    [anon_sym_protected] = ACTIONS(3587),
    [anon_sym_using] = ACTIONS(3587),
    [anon_sym_static_assert] = ACTIONS(3587),
    [anon_sym_precise] = ACTIONS(3587),
    [anon_sym_shared] = ACTIONS(3587),
    [anon_sym_groupshared] = ACTIONS(3587),
    [anon_sym_uniform] = ACTIONS(3587),
    [anon_sym_row_major] = ACTIONS(3587),
    [anon_sym_column_major] = ACTIONS(3587),
    [anon_sym_globallycoherent] = ACTIONS(3587),
    [anon_sym_centroid] = ACTIONS(3587),
    [anon_sym_noperspective] = ACTIONS(3587),
    [anon_sym_nointerpolation] = ACTIONS(3587),
    [anon_sym_sample] = ACTIONS(3587),
    [anon_sym_linear] = ACTIONS(3587),
    [anon_sym_snorm] = ACTIONS(3587),
    [anon_sym_unorm] = ACTIONS(3587),
    [anon_sym_point] = ACTIONS(3587),
    [anon_sym_line] = ACTIONS(3587),
    [anon_sym_triangleadj] = ACTIONS(3587),
    [anon_sym_lineadj] = ACTIONS(3587),
    [anon_sym_triangle] = ACTIONS(3587),
    [anon_sym_interface] = ACTIONS(3587),
    [anon_sym_extension] = ACTIONS(3587),
    [anon_sym___init] = ACTIONS(3587),
    [anon_sym___subscript] = ACTIONS(3587),
    [anon_sym_property] = ACTIONS(3587),
    [anon_sym_associatedtype] = ACTIONS(3587),
  },
  [2213] = {
    [sym_expression] = STATE(5152),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACK] = ACTIONS(6102),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4958),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4964),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2214] = {
    [sym_identifier] = ACTIONS(3617),
    [aux_sym_preproc_def_token1] = ACTIONS(3617),
    [aux_sym_preproc_if_token1] = ACTIONS(3617),
    [aux_sym_preproc_if_token2] = ACTIONS(3617),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3617),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3617),
    [sym_preproc_directive] = ACTIONS(3617),
    [anon_sym_LPAREN2] = ACTIONS(3619),
    [anon_sym_TILDE] = ACTIONS(3619),
    [anon_sym_STAR] = ACTIONS(3619),
    [anon_sym_AMP_AMP] = ACTIONS(3619),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym___extension__] = ACTIONS(3617),
    [anon_sym_typedef] = ACTIONS(3617),
    [anon_sym_in] = ACTIONS(3617),
    [anon_sym_out] = ACTIONS(3617),
    [anon_sym_inout] = ACTIONS(3617),
    [anon_sym_extern] = ACTIONS(3617),
    [anon_sym___attribute__] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3619),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3619),
    [anon_sym___declspec] = ACTIONS(3617),
    [anon_sym___based] = ACTIONS(3617),
    [anon_sym_signed] = ACTIONS(3617),
    [anon_sym_unsigned] = ACTIONS(3617),
    [anon_sym_long] = ACTIONS(3617),
    [anon_sym_short] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_static] = ACTIONS(3617),
    [anon_sym_register] = ACTIONS(3617),
    [anon_sym_inline] = ACTIONS(3617),
    [anon_sym___inline] = ACTIONS(3617),
    [anon_sym___inline__] = ACTIONS(3617),
    [anon_sym___forceinline] = ACTIONS(3617),
    [anon_sym_thread_local] = ACTIONS(3617),
    [anon_sym___thread] = ACTIONS(3617),
    [anon_sym_const] = ACTIONS(3617),
    [anon_sym_constexpr] = ACTIONS(3617),
    [anon_sym_volatile] = ACTIONS(3617),
    [anon_sym_restrict] = ACTIONS(3617),
    [anon_sym___restrict__] = ACTIONS(3617),
    [anon_sym__Atomic] = ACTIONS(3617),
    [anon_sym__Noreturn] = ACTIONS(3617),
    [anon_sym_noreturn] = ACTIONS(3617),
    [anon_sym_mutable] = ACTIONS(3617),
    [anon_sym_constinit] = ACTIONS(3617),
    [anon_sym_consteval] = ACTIONS(3617),
    [anon_sym_alignas] = ACTIONS(3617),
    [anon_sym__Alignas] = ACTIONS(3617),
    [sym_primitive_type] = ACTIONS(3617),
    [anon_sym_enum] = ACTIONS(3617),
    [anon_sym_class] = ACTIONS(3617),
    [anon_sym_struct] = ACTIONS(3617),
    [anon_sym_union] = ACTIONS(3617),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3617),
    [anon_sym_let] = ACTIONS(3617),
    [anon_sym_This] = ACTIONS(3617),
    [anon_sym_decltype] = ACTIONS(3617),
    [sym_virtual] = ACTIONS(3617),
    [anon_sym_explicit] = ACTIONS(3617),
    [anon_sym_typename] = ACTIONS(3617),
    [anon_sym_template] = ACTIONS(3617),
    [anon_sym_operator] = ACTIONS(3617),
    [anon_sym_friend] = ACTIONS(3617),
    [anon_sym_public] = ACTIONS(3617),
    [anon_sym_private] = ACTIONS(3617),
    [anon_sym_protected] = ACTIONS(3617),
    [anon_sym_using] = ACTIONS(3617),
    [anon_sym_static_assert] = ACTIONS(3617),
    [anon_sym_precise] = ACTIONS(3617),
    [anon_sym_shared] = ACTIONS(3617),
    [anon_sym_groupshared] = ACTIONS(3617),
    [anon_sym_uniform] = ACTIONS(3617),
    [anon_sym_row_major] = ACTIONS(3617),
    [anon_sym_column_major] = ACTIONS(3617),
    [anon_sym_globallycoherent] = ACTIONS(3617),
    [anon_sym_centroid] = ACTIONS(3617),
    [anon_sym_noperspective] = ACTIONS(3617),
    [anon_sym_nointerpolation] = ACTIONS(3617),
    [anon_sym_sample] = ACTIONS(3617),
    [anon_sym_linear] = ACTIONS(3617),
    [anon_sym_snorm] = ACTIONS(3617),
    [anon_sym_unorm] = ACTIONS(3617),
    [anon_sym_point] = ACTIONS(3617),
    [anon_sym_line] = ACTIONS(3617),
    [anon_sym_triangleadj] = ACTIONS(3617),
    [anon_sym_lineadj] = ACTIONS(3617),
    [anon_sym_triangle] = ACTIONS(3617),
    [anon_sym_interface] = ACTIONS(3617),
    [anon_sym_extension] = ACTIONS(3617),
    [anon_sym___init] = ACTIONS(3617),
    [anon_sym___subscript] = ACTIONS(3617),
    [anon_sym_property] = ACTIONS(3617),
    [anon_sym_associatedtype] = ACTIONS(3617),
  },
  [2215] = {
    [sym_identifier] = ACTIONS(3445),
    [aux_sym_preproc_def_token1] = ACTIONS(3445),
    [aux_sym_preproc_if_token1] = ACTIONS(3445),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3445),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3445),
    [sym_preproc_directive] = ACTIONS(3445),
    [anon_sym_LPAREN2] = ACTIONS(3447),
    [anon_sym_TILDE] = ACTIONS(3447),
    [anon_sym_STAR] = ACTIONS(3447),
    [anon_sym_AMP_AMP] = ACTIONS(3447),
    [anon_sym_AMP] = ACTIONS(3445),
    [anon_sym___extension__] = ACTIONS(3445),
    [anon_sym_typedef] = ACTIONS(3445),
    [anon_sym_in] = ACTIONS(3445),
    [anon_sym_out] = ACTIONS(3445),
    [anon_sym_inout] = ACTIONS(3445),
    [anon_sym_extern] = ACTIONS(3445),
    [anon_sym___attribute__] = ACTIONS(3445),
    [anon_sym_COLON_COLON] = ACTIONS(3447),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3447),
    [anon_sym___declspec] = ACTIONS(3445),
    [anon_sym___based] = ACTIONS(3445),
    [anon_sym_RBRACE] = ACTIONS(3447),
    [anon_sym_signed] = ACTIONS(3445),
    [anon_sym_unsigned] = ACTIONS(3445),
    [anon_sym_long] = ACTIONS(3445),
    [anon_sym_short] = ACTIONS(3445),
    [anon_sym_LBRACK] = ACTIONS(3445),
    [anon_sym_static] = ACTIONS(3445),
    [anon_sym_register] = ACTIONS(3445),
    [anon_sym_inline] = ACTIONS(3445),
    [anon_sym___inline] = ACTIONS(3445),
    [anon_sym___inline__] = ACTIONS(3445),
    [anon_sym___forceinline] = ACTIONS(3445),
    [anon_sym_thread_local] = ACTIONS(3445),
    [anon_sym___thread] = ACTIONS(3445),
    [anon_sym_const] = ACTIONS(3445),
    [anon_sym_constexpr] = ACTIONS(3445),
    [anon_sym_volatile] = ACTIONS(3445),
    [anon_sym_restrict] = ACTIONS(3445),
    [anon_sym___restrict__] = ACTIONS(3445),
    [anon_sym__Atomic] = ACTIONS(3445),
    [anon_sym__Noreturn] = ACTIONS(3445),
    [anon_sym_noreturn] = ACTIONS(3445),
    [anon_sym_mutable] = ACTIONS(3445),
    [anon_sym_constinit] = ACTIONS(3445),
    [anon_sym_consteval] = ACTIONS(3445),
    [anon_sym_alignas] = ACTIONS(3445),
    [anon_sym__Alignas] = ACTIONS(3445),
    [sym_primitive_type] = ACTIONS(3445),
    [anon_sym_enum] = ACTIONS(3445),
    [anon_sym_class] = ACTIONS(3445),
    [anon_sym_struct] = ACTIONS(3445),
    [anon_sym_union] = ACTIONS(3445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3445),
    [anon_sym_let] = ACTIONS(3445),
    [anon_sym_This] = ACTIONS(3445),
    [anon_sym_decltype] = ACTIONS(3445),
    [sym_virtual] = ACTIONS(3445),
    [anon_sym_explicit] = ACTIONS(3445),
    [anon_sym_typename] = ACTIONS(3445),
    [anon_sym_template] = ACTIONS(3445),
    [anon_sym_operator] = ACTIONS(3445),
    [anon_sym_friend] = ACTIONS(3445),
    [anon_sym_public] = ACTIONS(3445),
    [anon_sym_private] = ACTIONS(3445),
    [anon_sym_protected] = ACTIONS(3445),
    [anon_sym_using] = ACTIONS(3445),
    [anon_sym_static_assert] = ACTIONS(3445),
    [anon_sym_precise] = ACTIONS(3445),
    [anon_sym_shared] = ACTIONS(3445),
    [anon_sym_groupshared] = ACTIONS(3445),
    [anon_sym_uniform] = ACTIONS(3445),
    [anon_sym_row_major] = ACTIONS(3445),
    [anon_sym_column_major] = ACTIONS(3445),
    [anon_sym_globallycoherent] = ACTIONS(3445),
    [anon_sym_centroid] = ACTIONS(3445),
    [anon_sym_noperspective] = ACTIONS(3445),
    [anon_sym_nointerpolation] = ACTIONS(3445),
    [anon_sym_sample] = ACTIONS(3445),
    [anon_sym_linear] = ACTIONS(3445),
    [anon_sym_snorm] = ACTIONS(3445),
    [anon_sym_unorm] = ACTIONS(3445),
    [anon_sym_point] = ACTIONS(3445),
    [anon_sym_line] = ACTIONS(3445),
    [anon_sym_triangleadj] = ACTIONS(3445),
    [anon_sym_lineadj] = ACTIONS(3445),
    [anon_sym_triangle] = ACTIONS(3445),
    [anon_sym_interface] = ACTIONS(3445),
    [anon_sym_extension] = ACTIONS(3445),
    [anon_sym___init] = ACTIONS(3445),
    [anon_sym___subscript] = ACTIONS(3445),
    [anon_sym_property] = ACTIONS(3445),
    [anon_sym_associatedtype] = ACTIONS(3445),
  },
  [2216] = {
    [sym_expression] = STATE(5157),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2217] = {
    [sym_expression] = STATE(5156),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2218] = {
    [sym_identifier] = ACTIONS(3645),
    [aux_sym_preproc_def_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token2] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3645),
    [sym_preproc_directive] = ACTIONS(3645),
    [anon_sym_LPAREN2] = ACTIONS(3647),
    [anon_sym_TILDE] = ACTIONS(3647),
    [anon_sym_STAR] = ACTIONS(3647),
    [anon_sym_AMP_AMP] = ACTIONS(3647),
    [anon_sym_AMP] = ACTIONS(3645),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3645),
    [anon_sym_in] = ACTIONS(3645),
    [anon_sym_out] = ACTIONS(3645),
    [anon_sym_inout] = ACTIONS(3645),
    [anon_sym_extern] = ACTIONS(3645),
    [anon_sym___attribute__] = ACTIONS(3645),
    [anon_sym_COLON_COLON] = ACTIONS(3647),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3647),
    [anon_sym___declspec] = ACTIONS(3645),
    [anon_sym___based] = ACTIONS(3645),
    [anon_sym_signed] = ACTIONS(3645),
    [anon_sym_unsigned] = ACTIONS(3645),
    [anon_sym_long] = ACTIONS(3645),
    [anon_sym_short] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_static] = ACTIONS(3645),
    [anon_sym_register] = ACTIONS(3645),
    [anon_sym_inline] = ACTIONS(3645),
    [anon_sym___inline] = ACTIONS(3645),
    [anon_sym___inline__] = ACTIONS(3645),
    [anon_sym___forceinline] = ACTIONS(3645),
    [anon_sym_thread_local] = ACTIONS(3645),
    [anon_sym___thread] = ACTIONS(3645),
    [anon_sym_const] = ACTIONS(3645),
    [anon_sym_constexpr] = ACTIONS(3645),
    [anon_sym_volatile] = ACTIONS(3645),
    [anon_sym_restrict] = ACTIONS(3645),
    [anon_sym___restrict__] = ACTIONS(3645),
    [anon_sym__Atomic] = ACTIONS(3645),
    [anon_sym__Noreturn] = ACTIONS(3645),
    [anon_sym_noreturn] = ACTIONS(3645),
    [anon_sym_mutable] = ACTIONS(3645),
    [anon_sym_constinit] = ACTIONS(3645),
    [anon_sym_consteval] = ACTIONS(3645),
    [anon_sym_alignas] = ACTIONS(3645),
    [anon_sym__Alignas] = ACTIONS(3645),
    [sym_primitive_type] = ACTIONS(3645),
    [anon_sym_enum] = ACTIONS(3645),
    [anon_sym_class] = ACTIONS(3645),
    [anon_sym_struct] = ACTIONS(3645),
    [anon_sym_union] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3645),
    [anon_sym_let] = ACTIONS(3645),
    [anon_sym_This] = ACTIONS(3645),
    [anon_sym_decltype] = ACTIONS(3645),
    [sym_virtual] = ACTIONS(3645),
    [anon_sym_explicit] = ACTIONS(3645),
    [anon_sym_typename] = ACTIONS(3645),
    [anon_sym_template] = ACTIONS(3645),
    [anon_sym_operator] = ACTIONS(3645),
    [anon_sym_friend] = ACTIONS(3645),
    [anon_sym_public] = ACTIONS(3645),
    [anon_sym_private] = ACTIONS(3645),
    [anon_sym_protected] = ACTIONS(3645),
    [anon_sym_using] = ACTIONS(3645),
    [anon_sym_static_assert] = ACTIONS(3645),
    [anon_sym_precise] = ACTIONS(3645),
    [anon_sym_shared] = ACTIONS(3645),
    [anon_sym_groupshared] = ACTIONS(3645),
    [anon_sym_uniform] = ACTIONS(3645),
    [anon_sym_row_major] = ACTIONS(3645),
    [anon_sym_column_major] = ACTIONS(3645),
    [anon_sym_globallycoherent] = ACTIONS(3645),
    [anon_sym_centroid] = ACTIONS(3645),
    [anon_sym_noperspective] = ACTIONS(3645),
    [anon_sym_nointerpolation] = ACTIONS(3645),
    [anon_sym_sample] = ACTIONS(3645),
    [anon_sym_linear] = ACTIONS(3645),
    [anon_sym_snorm] = ACTIONS(3645),
    [anon_sym_unorm] = ACTIONS(3645),
    [anon_sym_point] = ACTIONS(3645),
    [anon_sym_line] = ACTIONS(3645),
    [anon_sym_triangleadj] = ACTIONS(3645),
    [anon_sym_lineadj] = ACTIONS(3645),
    [anon_sym_triangle] = ACTIONS(3645),
    [anon_sym_interface] = ACTIONS(3645),
    [anon_sym_extension] = ACTIONS(3645),
    [anon_sym___init] = ACTIONS(3645),
    [anon_sym___subscript] = ACTIONS(3645),
    [anon_sym_property] = ACTIONS(3645),
    [anon_sym_associatedtype] = ACTIONS(3645),
  },
  [2219] = {
    [sym_identifier] = ACTIONS(3645),
    [aux_sym_preproc_def_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token2] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3645),
    [sym_preproc_directive] = ACTIONS(3645),
    [anon_sym_LPAREN2] = ACTIONS(3647),
    [anon_sym_TILDE] = ACTIONS(3647),
    [anon_sym_STAR] = ACTIONS(3647),
    [anon_sym_AMP_AMP] = ACTIONS(3647),
    [anon_sym_AMP] = ACTIONS(3645),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3645),
    [anon_sym_in] = ACTIONS(3645),
    [anon_sym_out] = ACTIONS(3645),
    [anon_sym_inout] = ACTIONS(3645),
    [anon_sym_extern] = ACTIONS(3645),
    [anon_sym___attribute__] = ACTIONS(3645),
    [anon_sym_COLON_COLON] = ACTIONS(3647),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3647),
    [anon_sym___declspec] = ACTIONS(3645),
    [anon_sym___based] = ACTIONS(3645),
    [anon_sym_signed] = ACTIONS(3645),
    [anon_sym_unsigned] = ACTIONS(3645),
    [anon_sym_long] = ACTIONS(3645),
    [anon_sym_short] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_static] = ACTIONS(3645),
    [anon_sym_register] = ACTIONS(3645),
    [anon_sym_inline] = ACTIONS(3645),
    [anon_sym___inline] = ACTIONS(3645),
    [anon_sym___inline__] = ACTIONS(3645),
    [anon_sym___forceinline] = ACTIONS(3645),
    [anon_sym_thread_local] = ACTIONS(3645),
    [anon_sym___thread] = ACTIONS(3645),
    [anon_sym_const] = ACTIONS(3645),
    [anon_sym_constexpr] = ACTIONS(3645),
    [anon_sym_volatile] = ACTIONS(3645),
    [anon_sym_restrict] = ACTIONS(3645),
    [anon_sym___restrict__] = ACTIONS(3645),
    [anon_sym__Atomic] = ACTIONS(3645),
    [anon_sym__Noreturn] = ACTIONS(3645),
    [anon_sym_noreturn] = ACTIONS(3645),
    [anon_sym_mutable] = ACTIONS(3645),
    [anon_sym_constinit] = ACTIONS(3645),
    [anon_sym_consteval] = ACTIONS(3645),
    [anon_sym_alignas] = ACTIONS(3645),
    [anon_sym__Alignas] = ACTIONS(3645),
    [sym_primitive_type] = ACTIONS(3645),
    [anon_sym_enum] = ACTIONS(3645),
    [anon_sym_class] = ACTIONS(3645),
    [anon_sym_struct] = ACTIONS(3645),
    [anon_sym_union] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3645),
    [anon_sym_let] = ACTIONS(3645),
    [anon_sym_This] = ACTIONS(3645),
    [anon_sym_decltype] = ACTIONS(3645),
    [sym_virtual] = ACTIONS(3645),
    [anon_sym_explicit] = ACTIONS(3645),
    [anon_sym_typename] = ACTIONS(3645),
    [anon_sym_template] = ACTIONS(3645),
    [anon_sym_operator] = ACTIONS(3645),
    [anon_sym_friend] = ACTIONS(3645),
    [anon_sym_public] = ACTIONS(3645),
    [anon_sym_private] = ACTIONS(3645),
    [anon_sym_protected] = ACTIONS(3645),
    [anon_sym_using] = ACTIONS(3645),
    [anon_sym_static_assert] = ACTIONS(3645),
    [anon_sym_precise] = ACTIONS(3645),
    [anon_sym_shared] = ACTIONS(3645),
    [anon_sym_groupshared] = ACTIONS(3645),
    [anon_sym_uniform] = ACTIONS(3645),
    [anon_sym_row_major] = ACTIONS(3645),
    [anon_sym_column_major] = ACTIONS(3645),
    [anon_sym_globallycoherent] = ACTIONS(3645),
    [anon_sym_centroid] = ACTIONS(3645),
    [anon_sym_noperspective] = ACTIONS(3645),
    [anon_sym_nointerpolation] = ACTIONS(3645),
    [anon_sym_sample] = ACTIONS(3645),
    [anon_sym_linear] = ACTIONS(3645),
    [anon_sym_snorm] = ACTIONS(3645),
    [anon_sym_unorm] = ACTIONS(3645),
    [anon_sym_point] = ACTIONS(3645),
    [anon_sym_line] = ACTIONS(3645),
    [anon_sym_triangleadj] = ACTIONS(3645),
    [anon_sym_lineadj] = ACTIONS(3645),
    [anon_sym_triangle] = ACTIONS(3645),
    [anon_sym_interface] = ACTIONS(3645),
    [anon_sym_extension] = ACTIONS(3645),
    [anon_sym___init] = ACTIONS(3645),
    [anon_sym___subscript] = ACTIONS(3645),
    [anon_sym_property] = ACTIONS(3645),
    [anon_sym_associatedtype] = ACTIONS(3645),
  },
  [2220] = {
    [sym_expression] = STATE(5526),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2221] = {
    [sym_expression] = STATE(4885),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4905),
    [sym_concatenated_string] = STATE(4902),
    [sym_string_literal] = STATE(3611),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3610),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(5705),
    [anon_sym_LPAREN2] = ACTIONS(5834),
    [anon_sym_BANG] = ACTIONS(4926),
    [anon_sym_TILDE] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4928),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4924),
    [anon_sym_compl] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(5707),
    [anon_sym_PLUS_PLUS] = ACTIONS(5707),
    [anon_sym_sizeof] = ACTIONS(4932),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4934),
    [anon_sym_L_SQUOTE] = ACTIONS(4936),
    [anon_sym_u_SQUOTE] = ACTIONS(4936),
    [anon_sym_U_SQUOTE] = ACTIONS(4936),
    [anon_sym_u8_SQUOTE] = ACTIONS(4936),
    [anon_sym_SQUOTE] = ACTIONS(4936),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4938),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_co_await] = ACTIONS(4940),
    [anon_sym_new] = ACTIONS(4942),
    [anon_sym_requires] = ACTIONS(4944),
    [sym_this] = ACTIONS(241),
  },
  [2222] = {
    [sym_expression] = STATE(5350),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(6104),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2223] = {
    [sym_identifier] = ACTIONS(3637),
    [aux_sym_preproc_def_token1] = ACTIONS(3637),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_if_token2] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3637),
    [sym_preproc_directive] = ACTIONS(3637),
    [anon_sym_LPAREN2] = ACTIONS(3639),
    [anon_sym_TILDE] = ACTIONS(3639),
    [anon_sym_STAR] = ACTIONS(3639),
    [anon_sym_AMP_AMP] = ACTIONS(3639),
    [anon_sym_AMP] = ACTIONS(3637),
    [anon_sym___extension__] = ACTIONS(3637),
    [anon_sym_typedef] = ACTIONS(3637),
    [anon_sym_in] = ACTIONS(3637),
    [anon_sym_out] = ACTIONS(3637),
    [anon_sym_inout] = ACTIONS(3637),
    [anon_sym_extern] = ACTIONS(3637),
    [anon_sym___attribute__] = ACTIONS(3637),
    [anon_sym_COLON_COLON] = ACTIONS(3639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3639),
    [anon_sym___declspec] = ACTIONS(3637),
    [anon_sym___based] = ACTIONS(3637),
    [anon_sym_signed] = ACTIONS(3637),
    [anon_sym_unsigned] = ACTIONS(3637),
    [anon_sym_long] = ACTIONS(3637),
    [anon_sym_short] = ACTIONS(3637),
    [anon_sym_LBRACK] = ACTIONS(3637),
    [anon_sym_static] = ACTIONS(3637),
    [anon_sym_register] = ACTIONS(3637),
    [anon_sym_inline] = ACTIONS(3637),
    [anon_sym___inline] = ACTIONS(3637),
    [anon_sym___inline__] = ACTIONS(3637),
    [anon_sym___forceinline] = ACTIONS(3637),
    [anon_sym_thread_local] = ACTIONS(3637),
    [anon_sym___thread] = ACTIONS(3637),
    [anon_sym_const] = ACTIONS(3637),
    [anon_sym_constexpr] = ACTIONS(3637),
    [anon_sym_volatile] = ACTIONS(3637),
    [anon_sym_restrict] = ACTIONS(3637),
    [anon_sym___restrict__] = ACTIONS(3637),
    [anon_sym__Atomic] = ACTIONS(3637),
    [anon_sym__Noreturn] = ACTIONS(3637),
    [anon_sym_noreturn] = ACTIONS(3637),
    [anon_sym_mutable] = ACTIONS(3637),
    [anon_sym_constinit] = ACTIONS(3637),
    [anon_sym_consteval] = ACTIONS(3637),
    [anon_sym_alignas] = ACTIONS(3637),
    [anon_sym__Alignas] = ACTIONS(3637),
    [sym_primitive_type] = ACTIONS(3637),
    [anon_sym_enum] = ACTIONS(3637),
    [anon_sym_class] = ACTIONS(3637),
    [anon_sym_struct] = ACTIONS(3637),
    [anon_sym_union] = ACTIONS(3637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3637),
    [anon_sym_let] = ACTIONS(3637),
    [anon_sym_This] = ACTIONS(3637),
    [anon_sym_decltype] = ACTIONS(3637),
    [sym_virtual] = ACTIONS(3637),
    [anon_sym_explicit] = ACTIONS(3637),
    [anon_sym_typename] = ACTIONS(3637),
    [anon_sym_template] = ACTIONS(3637),
    [anon_sym_operator] = ACTIONS(3637),
    [anon_sym_friend] = ACTIONS(3637),
    [anon_sym_public] = ACTIONS(3637),
    [anon_sym_private] = ACTIONS(3637),
    [anon_sym_protected] = ACTIONS(3637),
    [anon_sym_using] = ACTIONS(3637),
    [anon_sym_static_assert] = ACTIONS(3637),
    [anon_sym_precise] = ACTIONS(3637),
    [anon_sym_shared] = ACTIONS(3637),
    [anon_sym_groupshared] = ACTIONS(3637),
    [anon_sym_uniform] = ACTIONS(3637),
    [anon_sym_row_major] = ACTIONS(3637),
    [anon_sym_column_major] = ACTIONS(3637),
    [anon_sym_globallycoherent] = ACTIONS(3637),
    [anon_sym_centroid] = ACTIONS(3637),
    [anon_sym_noperspective] = ACTIONS(3637),
    [anon_sym_nointerpolation] = ACTIONS(3637),
    [anon_sym_sample] = ACTIONS(3637),
    [anon_sym_linear] = ACTIONS(3637),
    [anon_sym_snorm] = ACTIONS(3637),
    [anon_sym_unorm] = ACTIONS(3637),
    [anon_sym_point] = ACTIONS(3637),
    [anon_sym_line] = ACTIONS(3637),
    [anon_sym_triangleadj] = ACTIONS(3637),
    [anon_sym_lineadj] = ACTIONS(3637),
    [anon_sym_triangle] = ACTIONS(3637),
    [anon_sym_interface] = ACTIONS(3637),
    [anon_sym_extension] = ACTIONS(3637),
    [anon_sym___init] = ACTIONS(3637),
    [anon_sym___subscript] = ACTIONS(3637),
    [anon_sym_property] = ACTIONS(3637),
    [anon_sym_associatedtype] = ACTIONS(3637),
  },
  [2224] = {
    [sym_expression] = STATE(4884),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4905),
    [sym_concatenated_string] = STATE(4902),
    [sym_string_literal] = STATE(3611),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3610),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(5705),
    [anon_sym_LPAREN2] = ACTIONS(5834),
    [anon_sym_BANG] = ACTIONS(4926),
    [anon_sym_TILDE] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4928),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4924),
    [anon_sym_compl] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(5707),
    [anon_sym_PLUS_PLUS] = ACTIONS(5707),
    [anon_sym_sizeof] = ACTIONS(4932),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4934),
    [anon_sym_L_SQUOTE] = ACTIONS(4936),
    [anon_sym_u_SQUOTE] = ACTIONS(4936),
    [anon_sym_U_SQUOTE] = ACTIONS(4936),
    [anon_sym_u8_SQUOTE] = ACTIONS(4936),
    [anon_sym_SQUOTE] = ACTIONS(4936),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4938),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_co_await] = ACTIONS(4940),
    [anon_sym_new] = ACTIONS(4942),
    [anon_sym_requires] = ACTIONS(4944),
    [sym_this] = ACTIONS(241),
  },
  [2225] = {
    [sym_expression] = STATE(5353),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2226] = {
    [sym_expression] = STATE(5524),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2227] = {
    [sym_expression] = STATE(4559),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [2228] = {
    [sym_expression] = STATE(3710),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [2229] = {
    [sym_expression] = STATE(5523),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2230] = {
    [sym_expression] = STATE(5445),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2231] = {
    [sym_expression] = STATE(5565),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2232] = {
    [sym_expression] = STATE(5276),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2233] = {
    [sym_expression] = STATE(5570),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2234] = {
    [sym_expression] = STATE(5612),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2235] = {
    [sym_identifier] = ACTIONS(3505),
    [aux_sym_preproc_def_token1] = ACTIONS(3505),
    [aux_sym_preproc_if_token1] = ACTIONS(3505),
    [aux_sym_preproc_if_token2] = ACTIONS(3505),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3505),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3505),
    [sym_preproc_directive] = ACTIONS(3505),
    [anon_sym_LPAREN2] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3507),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym___extension__] = ACTIONS(3505),
    [anon_sym_typedef] = ACTIONS(3505),
    [anon_sym_in] = ACTIONS(3505),
    [anon_sym_out] = ACTIONS(3505),
    [anon_sym_inout] = ACTIONS(3505),
    [anon_sym_extern] = ACTIONS(3505),
    [anon_sym___attribute__] = ACTIONS(3505),
    [anon_sym_COLON_COLON] = ACTIONS(3507),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3507),
    [anon_sym___declspec] = ACTIONS(3505),
    [anon_sym___based] = ACTIONS(3505),
    [anon_sym_signed] = ACTIONS(3505),
    [anon_sym_unsigned] = ACTIONS(3505),
    [anon_sym_long] = ACTIONS(3505),
    [anon_sym_short] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_static] = ACTIONS(3505),
    [anon_sym_register] = ACTIONS(3505),
    [anon_sym_inline] = ACTIONS(3505),
    [anon_sym___inline] = ACTIONS(3505),
    [anon_sym___inline__] = ACTIONS(3505),
    [anon_sym___forceinline] = ACTIONS(3505),
    [anon_sym_thread_local] = ACTIONS(3505),
    [anon_sym___thread] = ACTIONS(3505),
    [anon_sym_const] = ACTIONS(3505),
    [anon_sym_constexpr] = ACTIONS(3505),
    [anon_sym_volatile] = ACTIONS(3505),
    [anon_sym_restrict] = ACTIONS(3505),
    [anon_sym___restrict__] = ACTIONS(3505),
    [anon_sym__Atomic] = ACTIONS(3505),
    [anon_sym__Noreturn] = ACTIONS(3505),
    [anon_sym_noreturn] = ACTIONS(3505),
    [anon_sym_mutable] = ACTIONS(3505),
    [anon_sym_constinit] = ACTIONS(3505),
    [anon_sym_consteval] = ACTIONS(3505),
    [anon_sym_alignas] = ACTIONS(3505),
    [anon_sym__Alignas] = ACTIONS(3505),
    [sym_primitive_type] = ACTIONS(3505),
    [anon_sym_enum] = ACTIONS(3505),
    [anon_sym_class] = ACTIONS(3505),
    [anon_sym_struct] = ACTIONS(3505),
    [anon_sym_union] = ACTIONS(3505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_This] = ACTIONS(3505),
    [anon_sym_decltype] = ACTIONS(3505),
    [sym_virtual] = ACTIONS(3505),
    [anon_sym_explicit] = ACTIONS(3505),
    [anon_sym_typename] = ACTIONS(3505),
    [anon_sym_template] = ACTIONS(3505),
    [anon_sym_operator] = ACTIONS(3505),
    [anon_sym_friend] = ACTIONS(3505),
    [anon_sym_public] = ACTIONS(3505),
    [anon_sym_private] = ACTIONS(3505),
    [anon_sym_protected] = ACTIONS(3505),
    [anon_sym_using] = ACTIONS(3505),
    [anon_sym_static_assert] = ACTIONS(3505),
    [anon_sym_precise] = ACTIONS(3505),
    [anon_sym_shared] = ACTIONS(3505),
    [anon_sym_groupshared] = ACTIONS(3505),
    [anon_sym_uniform] = ACTIONS(3505),
    [anon_sym_row_major] = ACTIONS(3505),
    [anon_sym_column_major] = ACTIONS(3505),
    [anon_sym_globallycoherent] = ACTIONS(3505),
    [anon_sym_centroid] = ACTIONS(3505),
    [anon_sym_noperspective] = ACTIONS(3505),
    [anon_sym_nointerpolation] = ACTIONS(3505),
    [anon_sym_sample] = ACTIONS(3505),
    [anon_sym_linear] = ACTIONS(3505),
    [anon_sym_snorm] = ACTIONS(3505),
    [anon_sym_unorm] = ACTIONS(3505),
    [anon_sym_point] = ACTIONS(3505),
    [anon_sym_line] = ACTIONS(3505),
    [anon_sym_triangleadj] = ACTIONS(3505),
    [anon_sym_lineadj] = ACTIONS(3505),
    [anon_sym_triangle] = ACTIONS(3505),
    [anon_sym_interface] = ACTIONS(3505),
    [anon_sym_extension] = ACTIONS(3505),
    [anon_sym___init] = ACTIONS(3505),
    [anon_sym___subscript] = ACTIONS(3505),
    [anon_sym_property] = ACTIONS(3505),
    [anon_sym_associatedtype] = ACTIONS(3505),
  },
  [2236] = {
    [sym_expression] = STATE(5424),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2237] = {
    [sym_expression] = STATE(5155),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2238] = {
    [sym_identifier] = ACTIONS(3665),
    [aux_sym_preproc_def_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3665),
    [sym_preproc_directive] = ACTIONS(3665),
    [anon_sym_LPAREN2] = ACTIONS(3667),
    [anon_sym_TILDE] = ACTIONS(3667),
    [anon_sym_STAR] = ACTIONS(3667),
    [anon_sym_AMP_AMP] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym___extension__] = ACTIONS(3665),
    [anon_sym_typedef] = ACTIONS(3665),
    [anon_sym_in] = ACTIONS(3665),
    [anon_sym_out] = ACTIONS(3665),
    [anon_sym_inout] = ACTIONS(3665),
    [anon_sym_extern] = ACTIONS(3665),
    [anon_sym___attribute__] = ACTIONS(3665),
    [anon_sym_COLON_COLON] = ACTIONS(3667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3667),
    [anon_sym___declspec] = ACTIONS(3665),
    [anon_sym___based] = ACTIONS(3665),
    [anon_sym_RBRACE] = ACTIONS(3667),
    [anon_sym_signed] = ACTIONS(3665),
    [anon_sym_unsigned] = ACTIONS(3665),
    [anon_sym_long] = ACTIONS(3665),
    [anon_sym_short] = ACTIONS(3665),
    [anon_sym_LBRACK] = ACTIONS(3665),
    [anon_sym_static] = ACTIONS(3665),
    [anon_sym_register] = ACTIONS(3665),
    [anon_sym_inline] = ACTIONS(3665),
    [anon_sym___inline] = ACTIONS(3665),
    [anon_sym___inline__] = ACTIONS(3665),
    [anon_sym___forceinline] = ACTIONS(3665),
    [anon_sym_thread_local] = ACTIONS(3665),
    [anon_sym___thread] = ACTIONS(3665),
    [anon_sym_const] = ACTIONS(3665),
    [anon_sym_constexpr] = ACTIONS(3665),
    [anon_sym_volatile] = ACTIONS(3665),
    [anon_sym_restrict] = ACTIONS(3665),
    [anon_sym___restrict__] = ACTIONS(3665),
    [anon_sym__Atomic] = ACTIONS(3665),
    [anon_sym__Noreturn] = ACTIONS(3665),
    [anon_sym_noreturn] = ACTIONS(3665),
    [anon_sym_mutable] = ACTIONS(3665),
    [anon_sym_constinit] = ACTIONS(3665),
    [anon_sym_consteval] = ACTIONS(3665),
    [anon_sym_alignas] = ACTIONS(3665),
    [anon_sym__Alignas] = ACTIONS(3665),
    [sym_primitive_type] = ACTIONS(3665),
    [anon_sym_enum] = ACTIONS(3665),
    [anon_sym_class] = ACTIONS(3665),
    [anon_sym_struct] = ACTIONS(3665),
    [anon_sym_union] = ACTIONS(3665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3665),
    [anon_sym_let] = ACTIONS(3665),
    [anon_sym_This] = ACTIONS(3665),
    [anon_sym_decltype] = ACTIONS(3665),
    [sym_virtual] = ACTIONS(3665),
    [anon_sym_explicit] = ACTIONS(3665),
    [anon_sym_typename] = ACTIONS(3665),
    [anon_sym_template] = ACTIONS(3665),
    [anon_sym_operator] = ACTIONS(3665),
    [anon_sym_friend] = ACTIONS(3665),
    [anon_sym_public] = ACTIONS(3665),
    [anon_sym_private] = ACTIONS(3665),
    [anon_sym_protected] = ACTIONS(3665),
    [anon_sym_using] = ACTIONS(3665),
    [anon_sym_static_assert] = ACTIONS(3665),
    [anon_sym_precise] = ACTIONS(3665),
    [anon_sym_shared] = ACTIONS(3665),
    [anon_sym_groupshared] = ACTIONS(3665),
    [anon_sym_uniform] = ACTIONS(3665),
    [anon_sym_row_major] = ACTIONS(3665),
    [anon_sym_column_major] = ACTIONS(3665),
    [anon_sym_globallycoherent] = ACTIONS(3665),
    [anon_sym_centroid] = ACTIONS(3665),
    [anon_sym_noperspective] = ACTIONS(3665),
    [anon_sym_nointerpolation] = ACTIONS(3665),
    [anon_sym_sample] = ACTIONS(3665),
    [anon_sym_linear] = ACTIONS(3665),
    [anon_sym_snorm] = ACTIONS(3665),
    [anon_sym_unorm] = ACTIONS(3665),
    [anon_sym_point] = ACTIONS(3665),
    [anon_sym_line] = ACTIONS(3665),
    [anon_sym_triangleadj] = ACTIONS(3665),
    [anon_sym_lineadj] = ACTIONS(3665),
    [anon_sym_triangle] = ACTIONS(3665),
    [anon_sym_interface] = ACTIONS(3665),
    [anon_sym_extension] = ACTIONS(3665),
    [anon_sym___init] = ACTIONS(3665),
    [anon_sym___subscript] = ACTIONS(3665),
    [anon_sym_property] = ACTIONS(3665),
    [anon_sym_associatedtype] = ACTIONS(3665),
  },
  [2239] = {
    [sym_identifier] = ACTIONS(3665),
    [aux_sym_preproc_def_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3665),
    [sym_preproc_directive] = ACTIONS(3665),
    [anon_sym_LPAREN2] = ACTIONS(3667),
    [anon_sym_TILDE] = ACTIONS(3667),
    [anon_sym_STAR] = ACTIONS(3667),
    [anon_sym_AMP_AMP] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym___extension__] = ACTIONS(3665),
    [anon_sym_typedef] = ACTIONS(3665),
    [anon_sym_in] = ACTIONS(3665),
    [anon_sym_out] = ACTIONS(3665),
    [anon_sym_inout] = ACTIONS(3665),
    [anon_sym_extern] = ACTIONS(3665),
    [anon_sym___attribute__] = ACTIONS(3665),
    [anon_sym_COLON_COLON] = ACTIONS(3667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3667),
    [anon_sym___declspec] = ACTIONS(3665),
    [anon_sym___based] = ACTIONS(3665),
    [anon_sym_RBRACE] = ACTIONS(3667),
    [anon_sym_signed] = ACTIONS(3665),
    [anon_sym_unsigned] = ACTIONS(3665),
    [anon_sym_long] = ACTIONS(3665),
    [anon_sym_short] = ACTIONS(3665),
    [anon_sym_LBRACK] = ACTIONS(3665),
    [anon_sym_static] = ACTIONS(3665),
    [anon_sym_register] = ACTIONS(3665),
    [anon_sym_inline] = ACTIONS(3665),
    [anon_sym___inline] = ACTIONS(3665),
    [anon_sym___inline__] = ACTIONS(3665),
    [anon_sym___forceinline] = ACTIONS(3665),
    [anon_sym_thread_local] = ACTIONS(3665),
    [anon_sym___thread] = ACTIONS(3665),
    [anon_sym_const] = ACTIONS(3665),
    [anon_sym_constexpr] = ACTIONS(3665),
    [anon_sym_volatile] = ACTIONS(3665),
    [anon_sym_restrict] = ACTIONS(3665),
    [anon_sym___restrict__] = ACTIONS(3665),
    [anon_sym__Atomic] = ACTIONS(3665),
    [anon_sym__Noreturn] = ACTIONS(3665),
    [anon_sym_noreturn] = ACTIONS(3665),
    [anon_sym_mutable] = ACTIONS(3665),
    [anon_sym_constinit] = ACTIONS(3665),
    [anon_sym_consteval] = ACTIONS(3665),
    [anon_sym_alignas] = ACTIONS(3665),
    [anon_sym__Alignas] = ACTIONS(3665),
    [sym_primitive_type] = ACTIONS(3665),
    [anon_sym_enum] = ACTIONS(3665),
    [anon_sym_class] = ACTIONS(3665),
    [anon_sym_struct] = ACTIONS(3665),
    [anon_sym_union] = ACTIONS(3665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3665),
    [anon_sym_let] = ACTIONS(3665),
    [anon_sym_This] = ACTIONS(3665),
    [anon_sym_decltype] = ACTIONS(3665),
    [sym_virtual] = ACTIONS(3665),
    [anon_sym_explicit] = ACTIONS(3665),
    [anon_sym_typename] = ACTIONS(3665),
    [anon_sym_template] = ACTIONS(3665),
    [anon_sym_operator] = ACTIONS(3665),
    [anon_sym_friend] = ACTIONS(3665),
    [anon_sym_public] = ACTIONS(3665),
    [anon_sym_private] = ACTIONS(3665),
    [anon_sym_protected] = ACTIONS(3665),
    [anon_sym_using] = ACTIONS(3665),
    [anon_sym_static_assert] = ACTIONS(3665),
    [anon_sym_precise] = ACTIONS(3665),
    [anon_sym_shared] = ACTIONS(3665),
    [anon_sym_groupshared] = ACTIONS(3665),
    [anon_sym_uniform] = ACTIONS(3665),
    [anon_sym_row_major] = ACTIONS(3665),
    [anon_sym_column_major] = ACTIONS(3665),
    [anon_sym_globallycoherent] = ACTIONS(3665),
    [anon_sym_centroid] = ACTIONS(3665),
    [anon_sym_noperspective] = ACTIONS(3665),
    [anon_sym_nointerpolation] = ACTIONS(3665),
    [anon_sym_sample] = ACTIONS(3665),
    [anon_sym_linear] = ACTIONS(3665),
    [anon_sym_snorm] = ACTIONS(3665),
    [anon_sym_unorm] = ACTIONS(3665),
    [anon_sym_point] = ACTIONS(3665),
    [anon_sym_line] = ACTIONS(3665),
    [anon_sym_triangleadj] = ACTIONS(3665),
    [anon_sym_lineadj] = ACTIONS(3665),
    [anon_sym_triangle] = ACTIONS(3665),
    [anon_sym_interface] = ACTIONS(3665),
    [anon_sym_extension] = ACTIONS(3665),
    [anon_sym___init] = ACTIONS(3665),
    [anon_sym___subscript] = ACTIONS(3665),
    [anon_sym_property] = ACTIONS(3665),
    [anon_sym_associatedtype] = ACTIONS(3665),
  },
  [2240] = {
    [sym_identifier] = ACTIONS(3605),
    [aux_sym_preproc_def_token1] = ACTIONS(3605),
    [aux_sym_preproc_if_token1] = ACTIONS(3605),
    [aux_sym_preproc_if_token2] = ACTIONS(3605),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3605),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3605),
    [sym_preproc_directive] = ACTIONS(3605),
    [anon_sym_LPAREN2] = ACTIONS(3607),
    [anon_sym_TILDE] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(3607),
    [anon_sym_AMP_AMP] = ACTIONS(3607),
    [anon_sym_AMP] = ACTIONS(3605),
    [anon_sym___extension__] = ACTIONS(3605),
    [anon_sym_typedef] = ACTIONS(3605),
    [anon_sym_in] = ACTIONS(3605),
    [anon_sym_out] = ACTIONS(3605),
    [anon_sym_inout] = ACTIONS(3605),
    [anon_sym_extern] = ACTIONS(3605),
    [anon_sym___attribute__] = ACTIONS(3605),
    [anon_sym_COLON_COLON] = ACTIONS(3607),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3607),
    [anon_sym___declspec] = ACTIONS(3605),
    [anon_sym___based] = ACTIONS(3605),
    [anon_sym_signed] = ACTIONS(3605),
    [anon_sym_unsigned] = ACTIONS(3605),
    [anon_sym_long] = ACTIONS(3605),
    [anon_sym_short] = ACTIONS(3605),
    [anon_sym_LBRACK] = ACTIONS(3605),
    [anon_sym_static] = ACTIONS(3605),
    [anon_sym_register] = ACTIONS(3605),
    [anon_sym_inline] = ACTIONS(3605),
    [anon_sym___inline] = ACTIONS(3605),
    [anon_sym___inline__] = ACTIONS(3605),
    [anon_sym___forceinline] = ACTIONS(3605),
    [anon_sym_thread_local] = ACTIONS(3605),
    [anon_sym___thread] = ACTIONS(3605),
    [anon_sym_const] = ACTIONS(3605),
    [anon_sym_constexpr] = ACTIONS(3605),
    [anon_sym_volatile] = ACTIONS(3605),
    [anon_sym_restrict] = ACTIONS(3605),
    [anon_sym___restrict__] = ACTIONS(3605),
    [anon_sym__Atomic] = ACTIONS(3605),
    [anon_sym__Noreturn] = ACTIONS(3605),
    [anon_sym_noreturn] = ACTIONS(3605),
    [anon_sym_mutable] = ACTIONS(3605),
    [anon_sym_constinit] = ACTIONS(3605),
    [anon_sym_consteval] = ACTIONS(3605),
    [anon_sym_alignas] = ACTIONS(3605),
    [anon_sym__Alignas] = ACTIONS(3605),
    [sym_primitive_type] = ACTIONS(3605),
    [anon_sym_enum] = ACTIONS(3605),
    [anon_sym_class] = ACTIONS(3605),
    [anon_sym_struct] = ACTIONS(3605),
    [anon_sym_union] = ACTIONS(3605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3605),
    [anon_sym_let] = ACTIONS(3605),
    [anon_sym_This] = ACTIONS(3605),
    [anon_sym_decltype] = ACTIONS(3605),
    [sym_virtual] = ACTIONS(3605),
    [anon_sym_explicit] = ACTIONS(3605),
    [anon_sym_typename] = ACTIONS(3605),
    [anon_sym_template] = ACTIONS(3605),
    [anon_sym_operator] = ACTIONS(3605),
    [anon_sym_friend] = ACTIONS(3605),
    [anon_sym_public] = ACTIONS(3605),
    [anon_sym_private] = ACTIONS(3605),
    [anon_sym_protected] = ACTIONS(3605),
    [anon_sym_using] = ACTIONS(3605),
    [anon_sym_static_assert] = ACTIONS(3605),
    [anon_sym_precise] = ACTIONS(3605),
    [anon_sym_shared] = ACTIONS(3605),
    [anon_sym_groupshared] = ACTIONS(3605),
    [anon_sym_uniform] = ACTIONS(3605),
    [anon_sym_row_major] = ACTIONS(3605),
    [anon_sym_column_major] = ACTIONS(3605),
    [anon_sym_globallycoherent] = ACTIONS(3605),
    [anon_sym_centroid] = ACTIONS(3605),
    [anon_sym_noperspective] = ACTIONS(3605),
    [anon_sym_nointerpolation] = ACTIONS(3605),
    [anon_sym_sample] = ACTIONS(3605),
    [anon_sym_linear] = ACTIONS(3605),
    [anon_sym_snorm] = ACTIONS(3605),
    [anon_sym_unorm] = ACTIONS(3605),
    [anon_sym_point] = ACTIONS(3605),
    [anon_sym_line] = ACTIONS(3605),
    [anon_sym_triangleadj] = ACTIONS(3605),
    [anon_sym_lineadj] = ACTIONS(3605),
    [anon_sym_triangle] = ACTIONS(3605),
    [anon_sym_interface] = ACTIONS(3605),
    [anon_sym_extension] = ACTIONS(3605),
    [anon_sym___init] = ACTIONS(3605),
    [anon_sym___subscript] = ACTIONS(3605),
    [anon_sym_property] = ACTIONS(3605),
    [anon_sym_associatedtype] = ACTIONS(3605),
  },
  [2241] = {
    [sym_identifier] = ACTIONS(3555),
    [aux_sym_preproc_def_token1] = ACTIONS(3555),
    [aux_sym_preproc_if_token1] = ACTIONS(3555),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3555),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3555),
    [sym_preproc_directive] = ACTIONS(3555),
    [anon_sym_LPAREN2] = ACTIONS(3557),
    [anon_sym_TILDE] = ACTIONS(3557),
    [anon_sym_STAR] = ACTIONS(3557),
    [anon_sym_AMP_AMP] = ACTIONS(3557),
    [anon_sym_AMP] = ACTIONS(3555),
    [anon_sym___extension__] = ACTIONS(3555),
    [anon_sym_typedef] = ACTIONS(3555),
    [anon_sym_in] = ACTIONS(3555),
    [anon_sym_out] = ACTIONS(3555),
    [anon_sym_inout] = ACTIONS(3555),
    [anon_sym_extern] = ACTIONS(3555),
    [anon_sym___attribute__] = ACTIONS(3555),
    [anon_sym_COLON_COLON] = ACTIONS(3557),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3557),
    [anon_sym___declspec] = ACTIONS(3555),
    [anon_sym___based] = ACTIONS(3555),
    [anon_sym_RBRACE] = ACTIONS(3557),
    [anon_sym_signed] = ACTIONS(3555),
    [anon_sym_unsigned] = ACTIONS(3555),
    [anon_sym_long] = ACTIONS(3555),
    [anon_sym_short] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3555),
    [anon_sym_static] = ACTIONS(3555),
    [anon_sym_register] = ACTIONS(3555),
    [anon_sym_inline] = ACTIONS(3555),
    [anon_sym___inline] = ACTIONS(3555),
    [anon_sym___inline__] = ACTIONS(3555),
    [anon_sym___forceinline] = ACTIONS(3555),
    [anon_sym_thread_local] = ACTIONS(3555),
    [anon_sym___thread] = ACTIONS(3555),
    [anon_sym_const] = ACTIONS(3555),
    [anon_sym_constexpr] = ACTIONS(3555),
    [anon_sym_volatile] = ACTIONS(3555),
    [anon_sym_restrict] = ACTIONS(3555),
    [anon_sym___restrict__] = ACTIONS(3555),
    [anon_sym__Atomic] = ACTIONS(3555),
    [anon_sym__Noreturn] = ACTIONS(3555),
    [anon_sym_noreturn] = ACTIONS(3555),
    [anon_sym_mutable] = ACTIONS(3555),
    [anon_sym_constinit] = ACTIONS(3555),
    [anon_sym_consteval] = ACTIONS(3555),
    [anon_sym_alignas] = ACTIONS(3555),
    [anon_sym__Alignas] = ACTIONS(3555),
    [sym_primitive_type] = ACTIONS(3555),
    [anon_sym_enum] = ACTIONS(3555),
    [anon_sym_class] = ACTIONS(3555),
    [anon_sym_struct] = ACTIONS(3555),
    [anon_sym_union] = ACTIONS(3555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3555),
    [anon_sym_let] = ACTIONS(3555),
    [anon_sym_This] = ACTIONS(3555),
    [anon_sym_decltype] = ACTIONS(3555),
    [sym_virtual] = ACTIONS(3555),
    [anon_sym_explicit] = ACTIONS(3555),
    [anon_sym_typename] = ACTIONS(3555),
    [anon_sym_template] = ACTIONS(3555),
    [anon_sym_operator] = ACTIONS(3555),
    [anon_sym_friend] = ACTIONS(3555),
    [anon_sym_public] = ACTIONS(3555),
    [anon_sym_private] = ACTIONS(3555),
    [anon_sym_protected] = ACTIONS(3555),
    [anon_sym_using] = ACTIONS(3555),
    [anon_sym_static_assert] = ACTIONS(3555),
    [anon_sym_precise] = ACTIONS(3555),
    [anon_sym_shared] = ACTIONS(3555),
    [anon_sym_groupshared] = ACTIONS(3555),
    [anon_sym_uniform] = ACTIONS(3555),
    [anon_sym_row_major] = ACTIONS(3555),
    [anon_sym_column_major] = ACTIONS(3555),
    [anon_sym_globallycoherent] = ACTIONS(3555),
    [anon_sym_centroid] = ACTIONS(3555),
    [anon_sym_noperspective] = ACTIONS(3555),
    [anon_sym_nointerpolation] = ACTIONS(3555),
    [anon_sym_sample] = ACTIONS(3555),
    [anon_sym_linear] = ACTIONS(3555),
    [anon_sym_snorm] = ACTIONS(3555),
    [anon_sym_unorm] = ACTIONS(3555),
    [anon_sym_point] = ACTIONS(3555),
    [anon_sym_line] = ACTIONS(3555),
    [anon_sym_triangleadj] = ACTIONS(3555),
    [anon_sym_lineadj] = ACTIONS(3555),
    [anon_sym_triangle] = ACTIONS(3555),
    [anon_sym_interface] = ACTIONS(3555),
    [anon_sym_extension] = ACTIONS(3555),
    [anon_sym___init] = ACTIONS(3555),
    [anon_sym___subscript] = ACTIONS(3555),
    [anon_sym_property] = ACTIONS(3555),
    [anon_sym_associatedtype] = ACTIONS(3555),
  },
  [2242] = {
    [sym_expression] = STATE(5178),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2243] = {
    [sym_expression] = STATE(5586),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2244] = {
    [sym_expression] = STATE(4883),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4905),
    [sym_concatenated_string] = STATE(4902),
    [sym_string_literal] = STATE(3611),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3610),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(5705),
    [anon_sym_LPAREN2] = ACTIONS(5834),
    [anon_sym_BANG] = ACTIONS(4926),
    [anon_sym_TILDE] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4928),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4924),
    [anon_sym_compl] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(5707),
    [anon_sym_PLUS_PLUS] = ACTIONS(5707),
    [anon_sym_sizeof] = ACTIONS(4932),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4934),
    [anon_sym_L_SQUOTE] = ACTIONS(4936),
    [anon_sym_u_SQUOTE] = ACTIONS(4936),
    [anon_sym_U_SQUOTE] = ACTIONS(4936),
    [anon_sym_u8_SQUOTE] = ACTIONS(4936),
    [anon_sym_SQUOTE] = ACTIONS(4936),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4938),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_co_await] = ACTIONS(4940),
    [anon_sym_new] = ACTIONS(4942),
    [anon_sym_requires] = ACTIONS(4944),
    [sym_this] = ACTIONS(241),
  },
  [2245] = {
    [sym_identifier] = ACTIONS(3609),
    [aux_sym_preproc_def_token1] = ACTIONS(3609),
    [aux_sym_preproc_if_token1] = ACTIONS(3609),
    [aux_sym_preproc_if_token2] = ACTIONS(3609),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3609),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3609),
    [sym_preproc_directive] = ACTIONS(3609),
    [anon_sym_LPAREN2] = ACTIONS(3611),
    [anon_sym_TILDE] = ACTIONS(3611),
    [anon_sym_STAR] = ACTIONS(3611),
    [anon_sym_AMP_AMP] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3609),
    [anon_sym___extension__] = ACTIONS(3609),
    [anon_sym_typedef] = ACTIONS(3609),
    [anon_sym_in] = ACTIONS(3609),
    [anon_sym_out] = ACTIONS(3609),
    [anon_sym_inout] = ACTIONS(3609),
    [anon_sym_extern] = ACTIONS(3609),
    [anon_sym___attribute__] = ACTIONS(3609),
    [anon_sym_COLON_COLON] = ACTIONS(3611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3611),
    [anon_sym___declspec] = ACTIONS(3609),
    [anon_sym___based] = ACTIONS(3609),
    [anon_sym_signed] = ACTIONS(3609),
    [anon_sym_unsigned] = ACTIONS(3609),
    [anon_sym_long] = ACTIONS(3609),
    [anon_sym_short] = ACTIONS(3609),
    [anon_sym_LBRACK] = ACTIONS(3609),
    [anon_sym_static] = ACTIONS(3609),
    [anon_sym_register] = ACTIONS(3609),
    [anon_sym_inline] = ACTIONS(3609),
    [anon_sym___inline] = ACTIONS(3609),
    [anon_sym___inline__] = ACTIONS(3609),
    [anon_sym___forceinline] = ACTIONS(3609),
    [anon_sym_thread_local] = ACTIONS(3609),
    [anon_sym___thread] = ACTIONS(3609),
    [anon_sym_const] = ACTIONS(3609),
    [anon_sym_constexpr] = ACTIONS(3609),
    [anon_sym_volatile] = ACTIONS(3609),
    [anon_sym_restrict] = ACTIONS(3609),
    [anon_sym___restrict__] = ACTIONS(3609),
    [anon_sym__Atomic] = ACTIONS(3609),
    [anon_sym__Noreturn] = ACTIONS(3609),
    [anon_sym_noreturn] = ACTIONS(3609),
    [anon_sym_mutable] = ACTIONS(3609),
    [anon_sym_constinit] = ACTIONS(3609),
    [anon_sym_consteval] = ACTIONS(3609),
    [anon_sym_alignas] = ACTIONS(3609),
    [anon_sym__Alignas] = ACTIONS(3609),
    [sym_primitive_type] = ACTIONS(3609),
    [anon_sym_enum] = ACTIONS(3609),
    [anon_sym_class] = ACTIONS(3609),
    [anon_sym_struct] = ACTIONS(3609),
    [anon_sym_union] = ACTIONS(3609),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3609),
    [anon_sym_let] = ACTIONS(3609),
    [anon_sym_This] = ACTIONS(3609),
    [anon_sym_decltype] = ACTIONS(3609),
    [sym_virtual] = ACTIONS(3609),
    [anon_sym_explicit] = ACTIONS(3609),
    [anon_sym_typename] = ACTIONS(3609),
    [anon_sym_template] = ACTIONS(3609),
    [anon_sym_operator] = ACTIONS(3609),
    [anon_sym_friend] = ACTIONS(3609),
    [anon_sym_public] = ACTIONS(3609),
    [anon_sym_private] = ACTIONS(3609),
    [anon_sym_protected] = ACTIONS(3609),
    [anon_sym_using] = ACTIONS(3609),
    [anon_sym_static_assert] = ACTIONS(3609),
    [anon_sym_precise] = ACTIONS(3609),
    [anon_sym_shared] = ACTIONS(3609),
    [anon_sym_groupshared] = ACTIONS(3609),
    [anon_sym_uniform] = ACTIONS(3609),
    [anon_sym_row_major] = ACTIONS(3609),
    [anon_sym_column_major] = ACTIONS(3609),
    [anon_sym_globallycoherent] = ACTIONS(3609),
    [anon_sym_centroid] = ACTIONS(3609),
    [anon_sym_noperspective] = ACTIONS(3609),
    [anon_sym_nointerpolation] = ACTIONS(3609),
    [anon_sym_sample] = ACTIONS(3609),
    [anon_sym_linear] = ACTIONS(3609),
    [anon_sym_snorm] = ACTIONS(3609),
    [anon_sym_unorm] = ACTIONS(3609),
    [anon_sym_point] = ACTIONS(3609),
    [anon_sym_line] = ACTIONS(3609),
    [anon_sym_triangleadj] = ACTIONS(3609),
    [anon_sym_lineadj] = ACTIONS(3609),
    [anon_sym_triangle] = ACTIONS(3609),
    [anon_sym_interface] = ACTIONS(3609),
    [anon_sym_extension] = ACTIONS(3609),
    [anon_sym___init] = ACTIONS(3609),
    [anon_sym___subscript] = ACTIONS(3609),
    [anon_sym_property] = ACTIONS(3609),
    [anon_sym_associatedtype] = ACTIONS(3609),
  },
  [2246] = {
    [sym_identifier] = ACTIONS(3547),
    [aux_sym_preproc_def_token1] = ACTIONS(3547),
    [aux_sym_preproc_if_token1] = ACTIONS(3547),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3547),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3547),
    [sym_preproc_directive] = ACTIONS(3547),
    [anon_sym_LPAREN2] = ACTIONS(3549),
    [anon_sym_TILDE] = ACTIONS(3549),
    [anon_sym_STAR] = ACTIONS(3549),
    [anon_sym_AMP_AMP] = ACTIONS(3549),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym___extension__] = ACTIONS(3547),
    [anon_sym_typedef] = ACTIONS(3547),
    [anon_sym_in] = ACTIONS(3547),
    [anon_sym_out] = ACTIONS(3547),
    [anon_sym_inout] = ACTIONS(3547),
    [anon_sym_extern] = ACTIONS(3547),
    [anon_sym___attribute__] = ACTIONS(3547),
    [anon_sym_COLON_COLON] = ACTIONS(3549),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3549),
    [anon_sym___declspec] = ACTIONS(3547),
    [anon_sym___based] = ACTIONS(3547),
    [anon_sym_RBRACE] = ACTIONS(3549),
    [anon_sym_signed] = ACTIONS(3547),
    [anon_sym_unsigned] = ACTIONS(3547),
    [anon_sym_long] = ACTIONS(3547),
    [anon_sym_short] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_static] = ACTIONS(3547),
    [anon_sym_register] = ACTIONS(3547),
    [anon_sym_inline] = ACTIONS(3547),
    [anon_sym___inline] = ACTIONS(3547),
    [anon_sym___inline__] = ACTIONS(3547),
    [anon_sym___forceinline] = ACTIONS(3547),
    [anon_sym_thread_local] = ACTIONS(3547),
    [anon_sym___thread] = ACTIONS(3547),
    [anon_sym_const] = ACTIONS(3547),
    [anon_sym_constexpr] = ACTIONS(3547),
    [anon_sym_volatile] = ACTIONS(3547),
    [anon_sym_restrict] = ACTIONS(3547),
    [anon_sym___restrict__] = ACTIONS(3547),
    [anon_sym__Atomic] = ACTIONS(3547),
    [anon_sym__Noreturn] = ACTIONS(3547),
    [anon_sym_noreturn] = ACTIONS(3547),
    [anon_sym_mutable] = ACTIONS(3547),
    [anon_sym_constinit] = ACTIONS(3547),
    [anon_sym_consteval] = ACTIONS(3547),
    [anon_sym_alignas] = ACTIONS(3547),
    [anon_sym__Alignas] = ACTIONS(3547),
    [sym_primitive_type] = ACTIONS(3547),
    [anon_sym_enum] = ACTIONS(3547),
    [anon_sym_class] = ACTIONS(3547),
    [anon_sym_struct] = ACTIONS(3547),
    [anon_sym_union] = ACTIONS(3547),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_This] = ACTIONS(3547),
    [anon_sym_decltype] = ACTIONS(3547),
    [sym_virtual] = ACTIONS(3547),
    [anon_sym_explicit] = ACTIONS(3547),
    [anon_sym_typename] = ACTIONS(3547),
    [anon_sym_template] = ACTIONS(3547),
    [anon_sym_operator] = ACTIONS(3547),
    [anon_sym_friend] = ACTIONS(3547),
    [anon_sym_public] = ACTIONS(3547),
    [anon_sym_private] = ACTIONS(3547),
    [anon_sym_protected] = ACTIONS(3547),
    [anon_sym_using] = ACTIONS(3547),
    [anon_sym_static_assert] = ACTIONS(3547),
    [anon_sym_precise] = ACTIONS(3547),
    [anon_sym_shared] = ACTIONS(3547),
    [anon_sym_groupshared] = ACTIONS(3547),
    [anon_sym_uniform] = ACTIONS(3547),
    [anon_sym_row_major] = ACTIONS(3547),
    [anon_sym_column_major] = ACTIONS(3547),
    [anon_sym_globallycoherent] = ACTIONS(3547),
    [anon_sym_centroid] = ACTIONS(3547),
    [anon_sym_noperspective] = ACTIONS(3547),
    [anon_sym_nointerpolation] = ACTIONS(3547),
    [anon_sym_sample] = ACTIONS(3547),
    [anon_sym_linear] = ACTIONS(3547),
    [anon_sym_snorm] = ACTIONS(3547),
    [anon_sym_unorm] = ACTIONS(3547),
    [anon_sym_point] = ACTIONS(3547),
    [anon_sym_line] = ACTIONS(3547),
    [anon_sym_triangleadj] = ACTIONS(3547),
    [anon_sym_lineadj] = ACTIONS(3547),
    [anon_sym_triangle] = ACTIONS(3547),
    [anon_sym_interface] = ACTIONS(3547),
    [anon_sym_extension] = ACTIONS(3547),
    [anon_sym___init] = ACTIONS(3547),
    [anon_sym___subscript] = ACTIONS(3547),
    [anon_sym_property] = ACTIONS(3547),
    [anon_sym_associatedtype] = ACTIONS(3547),
  },
  [2247] = {
    [sym_expression] = STATE(5436),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2248] = {
    [sym_expression] = STATE(5281),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2249] = {
    [sym_expression] = STATE(5467),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2250] = {
    [sym_expression] = STATE(5461),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2251] = {
    [sym_identifier] = ACTIONS(5602),
    [aux_sym_preproc_def_token1] = ACTIONS(5602),
    [aux_sym_preproc_if_token1] = ACTIONS(5602),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5602),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5602),
    [sym_preproc_directive] = ACTIONS(5602),
    [anon_sym_LPAREN2] = ACTIONS(5604),
    [anon_sym_TILDE] = ACTIONS(5604),
    [anon_sym_STAR] = ACTIONS(5604),
    [anon_sym_AMP_AMP] = ACTIONS(5604),
    [anon_sym_AMP] = ACTIONS(5602),
    [anon_sym___extension__] = ACTIONS(5602),
    [anon_sym_typedef] = ACTIONS(5602),
    [anon_sym_in] = ACTIONS(5602),
    [anon_sym_out] = ACTIONS(5602),
    [anon_sym_inout] = ACTIONS(5602),
    [anon_sym_extern] = ACTIONS(5602),
    [anon_sym___attribute__] = ACTIONS(5602),
    [anon_sym_COLON_COLON] = ACTIONS(5604),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5604),
    [anon_sym___declspec] = ACTIONS(5602),
    [anon_sym___based] = ACTIONS(5602),
    [anon_sym_RBRACE] = ACTIONS(5604),
    [anon_sym_signed] = ACTIONS(5602),
    [anon_sym_unsigned] = ACTIONS(5602),
    [anon_sym_long] = ACTIONS(5602),
    [anon_sym_short] = ACTIONS(5602),
    [anon_sym_LBRACK] = ACTIONS(5602),
    [anon_sym_static] = ACTIONS(5602),
    [anon_sym_register] = ACTIONS(5602),
    [anon_sym_inline] = ACTIONS(5602),
    [anon_sym___inline] = ACTIONS(5602),
    [anon_sym___inline__] = ACTIONS(5602),
    [anon_sym___forceinline] = ACTIONS(5602),
    [anon_sym_thread_local] = ACTIONS(5602),
    [anon_sym___thread] = ACTIONS(5602),
    [anon_sym_const] = ACTIONS(5602),
    [anon_sym_constexpr] = ACTIONS(5602),
    [anon_sym_volatile] = ACTIONS(5602),
    [anon_sym_restrict] = ACTIONS(5602),
    [anon_sym___restrict__] = ACTIONS(5602),
    [anon_sym__Atomic] = ACTIONS(5602),
    [anon_sym__Noreturn] = ACTIONS(5602),
    [anon_sym_noreturn] = ACTIONS(5602),
    [anon_sym_mutable] = ACTIONS(5602),
    [anon_sym_constinit] = ACTIONS(5602),
    [anon_sym_consteval] = ACTIONS(5602),
    [anon_sym_alignas] = ACTIONS(5602),
    [anon_sym__Alignas] = ACTIONS(5602),
    [sym_primitive_type] = ACTIONS(5602),
    [anon_sym_enum] = ACTIONS(5602),
    [anon_sym_class] = ACTIONS(5602),
    [anon_sym_struct] = ACTIONS(5602),
    [anon_sym_union] = ACTIONS(5602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5602),
    [anon_sym_let] = ACTIONS(5602),
    [anon_sym_This] = ACTIONS(5602),
    [anon_sym_decltype] = ACTIONS(5602),
    [sym_virtual] = ACTIONS(5602),
    [anon_sym_explicit] = ACTIONS(5602),
    [anon_sym_typename] = ACTIONS(5602),
    [anon_sym_template] = ACTIONS(5602),
    [anon_sym_operator] = ACTIONS(5602),
    [anon_sym_friend] = ACTIONS(5602),
    [anon_sym_public] = ACTIONS(5602),
    [anon_sym_private] = ACTIONS(5602),
    [anon_sym_protected] = ACTIONS(5602),
    [anon_sym_using] = ACTIONS(5602),
    [anon_sym_static_assert] = ACTIONS(5602),
    [anon_sym_precise] = ACTIONS(5602),
    [anon_sym_shared] = ACTIONS(5602),
    [anon_sym_groupshared] = ACTIONS(5602),
    [anon_sym_uniform] = ACTIONS(5602),
    [anon_sym_row_major] = ACTIONS(5602),
    [anon_sym_column_major] = ACTIONS(5602),
    [anon_sym_globallycoherent] = ACTIONS(5602),
    [anon_sym_centroid] = ACTIONS(5602),
    [anon_sym_noperspective] = ACTIONS(5602),
    [anon_sym_nointerpolation] = ACTIONS(5602),
    [anon_sym_sample] = ACTIONS(5602),
    [anon_sym_linear] = ACTIONS(5602),
    [anon_sym_snorm] = ACTIONS(5602),
    [anon_sym_unorm] = ACTIONS(5602),
    [anon_sym_point] = ACTIONS(5602),
    [anon_sym_line] = ACTIONS(5602),
    [anon_sym_triangleadj] = ACTIONS(5602),
    [anon_sym_lineadj] = ACTIONS(5602),
    [anon_sym_triangle] = ACTIONS(5602),
    [anon_sym_interface] = ACTIONS(5602),
    [anon_sym_extension] = ACTIONS(5602),
    [anon_sym___init] = ACTIONS(5602),
    [anon_sym___subscript] = ACTIONS(5602),
    [anon_sym_property] = ACTIONS(5602),
    [anon_sym_associatedtype] = ACTIONS(5602),
  },
  [2252] = {
    [sym_identifier] = ACTIONS(3539),
    [aux_sym_preproc_def_token1] = ACTIONS(3539),
    [aux_sym_preproc_if_token1] = ACTIONS(3539),
    [aux_sym_preproc_if_token2] = ACTIONS(3539),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3539),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3539),
    [sym_preproc_directive] = ACTIONS(3539),
    [anon_sym_LPAREN2] = ACTIONS(3541),
    [anon_sym_TILDE] = ACTIONS(3541),
    [anon_sym_STAR] = ACTIONS(3541),
    [anon_sym_AMP_AMP] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym___extension__] = ACTIONS(3539),
    [anon_sym_typedef] = ACTIONS(3539),
    [anon_sym_in] = ACTIONS(3539),
    [anon_sym_out] = ACTIONS(3539),
    [anon_sym_inout] = ACTIONS(3539),
    [anon_sym_extern] = ACTIONS(3539),
    [anon_sym___attribute__] = ACTIONS(3539),
    [anon_sym_COLON_COLON] = ACTIONS(3541),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3541),
    [anon_sym___declspec] = ACTIONS(3539),
    [anon_sym___based] = ACTIONS(3539),
    [anon_sym_signed] = ACTIONS(3539),
    [anon_sym_unsigned] = ACTIONS(3539),
    [anon_sym_long] = ACTIONS(3539),
    [anon_sym_short] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_static] = ACTIONS(3539),
    [anon_sym_register] = ACTIONS(3539),
    [anon_sym_inline] = ACTIONS(3539),
    [anon_sym___inline] = ACTIONS(3539),
    [anon_sym___inline__] = ACTIONS(3539),
    [anon_sym___forceinline] = ACTIONS(3539),
    [anon_sym_thread_local] = ACTIONS(3539),
    [anon_sym___thread] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3539),
    [anon_sym_constexpr] = ACTIONS(3539),
    [anon_sym_volatile] = ACTIONS(3539),
    [anon_sym_restrict] = ACTIONS(3539),
    [anon_sym___restrict__] = ACTIONS(3539),
    [anon_sym__Atomic] = ACTIONS(3539),
    [anon_sym__Noreturn] = ACTIONS(3539),
    [anon_sym_noreturn] = ACTIONS(3539),
    [anon_sym_mutable] = ACTIONS(3539),
    [anon_sym_constinit] = ACTIONS(3539),
    [anon_sym_consteval] = ACTIONS(3539),
    [anon_sym_alignas] = ACTIONS(3539),
    [anon_sym__Alignas] = ACTIONS(3539),
    [sym_primitive_type] = ACTIONS(3539),
    [anon_sym_enum] = ACTIONS(3539),
    [anon_sym_class] = ACTIONS(3539),
    [anon_sym_struct] = ACTIONS(3539),
    [anon_sym_union] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_This] = ACTIONS(3539),
    [anon_sym_decltype] = ACTIONS(3539),
    [sym_virtual] = ACTIONS(3539),
    [anon_sym_explicit] = ACTIONS(3539),
    [anon_sym_typename] = ACTIONS(3539),
    [anon_sym_template] = ACTIONS(3539),
    [anon_sym_operator] = ACTIONS(3539),
    [anon_sym_friend] = ACTIONS(3539),
    [anon_sym_public] = ACTIONS(3539),
    [anon_sym_private] = ACTIONS(3539),
    [anon_sym_protected] = ACTIONS(3539),
    [anon_sym_using] = ACTIONS(3539),
    [anon_sym_static_assert] = ACTIONS(3539),
    [anon_sym_precise] = ACTIONS(3539),
    [anon_sym_shared] = ACTIONS(3539),
    [anon_sym_groupshared] = ACTIONS(3539),
    [anon_sym_uniform] = ACTIONS(3539),
    [anon_sym_row_major] = ACTIONS(3539),
    [anon_sym_column_major] = ACTIONS(3539),
    [anon_sym_globallycoherent] = ACTIONS(3539),
    [anon_sym_centroid] = ACTIONS(3539),
    [anon_sym_noperspective] = ACTIONS(3539),
    [anon_sym_nointerpolation] = ACTIONS(3539),
    [anon_sym_sample] = ACTIONS(3539),
    [anon_sym_linear] = ACTIONS(3539),
    [anon_sym_snorm] = ACTIONS(3539),
    [anon_sym_unorm] = ACTIONS(3539),
    [anon_sym_point] = ACTIONS(3539),
    [anon_sym_line] = ACTIONS(3539),
    [anon_sym_triangleadj] = ACTIONS(3539),
    [anon_sym_lineadj] = ACTIONS(3539),
    [anon_sym_triangle] = ACTIONS(3539),
    [anon_sym_interface] = ACTIONS(3539),
    [anon_sym_extension] = ACTIONS(3539),
    [anon_sym___init] = ACTIONS(3539),
    [anon_sym___subscript] = ACTIONS(3539),
    [anon_sym_property] = ACTIONS(3539),
    [anon_sym_associatedtype] = ACTIONS(3539),
  },
  [2253] = {
    [sym_expression] = STATE(5539),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2254] = {
    [sym_expression] = STATE(5617),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2255] = {
    [sym_expression] = STATE(4882),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4905),
    [sym_concatenated_string] = STATE(4902),
    [sym_string_literal] = STATE(3611),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3610),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(5705),
    [anon_sym_LPAREN2] = ACTIONS(5834),
    [anon_sym_BANG] = ACTIONS(4926),
    [anon_sym_TILDE] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4928),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4924),
    [anon_sym_compl] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(5707),
    [anon_sym_PLUS_PLUS] = ACTIONS(5707),
    [anon_sym_sizeof] = ACTIONS(4932),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4934),
    [anon_sym_L_SQUOTE] = ACTIONS(4936),
    [anon_sym_u_SQUOTE] = ACTIONS(4936),
    [anon_sym_U_SQUOTE] = ACTIONS(4936),
    [anon_sym_u8_SQUOTE] = ACTIONS(4936),
    [anon_sym_SQUOTE] = ACTIONS(4936),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4938),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_co_await] = ACTIONS(4940),
    [anon_sym_new] = ACTIONS(4942),
    [anon_sym_requires] = ACTIONS(4944),
    [sym_this] = ACTIONS(241),
  },
  [2256] = {
    [sym_expression] = STATE(4499),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [2257] = {
    [sym_expression] = STATE(4418),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [2258] = {
    [sym_expression] = STATE(5538),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2259] = {
    [sym_identifier] = ACTIONS(3621),
    [aux_sym_preproc_def_token1] = ACTIONS(3621),
    [aux_sym_preproc_if_token1] = ACTIONS(3621),
    [aux_sym_preproc_if_token2] = ACTIONS(3621),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3621),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3621),
    [sym_preproc_directive] = ACTIONS(3621),
    [anon_sym_LPAREN2] = ACTIONS(3623),
    [anon_sym_TILDE] = ACTIONS(3623),
    [anon_sym_STAR] = ACTIONS(3623),
    [anon_sym_AMP_AMP] = ACTIONS(3623),
    [anon_sym_AMP] = ACTIONS(3621),
    [anon_sym___extension__] = ACTIONS(3621),
    [anon_sym_typedef] = ACTIONS(3621),
    [anon_sym_in] = ACTIONS(3621),
    [anon_sym_out] = ACTIONS(3621),
    [anon_sym_inout] = ACTIONS(3621),
    [anon_sym_extern] = ACTIONS(3621),
    [anon_sym___attribute__] = ACTIONS(3621),
    [anon_sym_COLON_COLON] = ACTIONS(3623),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3623),
    [anon_sym___declspec] = ACTIONS(3621),
    [anon_sym___based] = ACTIONS(3621),
    [anon_sym_signed] = ACTIONS(3621),
    [anon_sym_unsigned] = ACTIONS(3621),
    [anon_sym_long] = ACTIONS(3621),
    [anon_sym_short] = ACTIONS(3621),
    [anon_sym_LBRACK] = ACTIONS(3621),
    [anon_sym_static] = ACTIONS(3621),
    [anon_sym_register] = ACTIONS(3621),
    [anon_sym_inline] = ACTIONS(3621),
    [anon_sym___inline] = ACTIONS(3621),
    [anon_sym___inline__] = ACTIONS(3621),
    [anon_sym___forceinline] = ACTIONS(3621),
    [anon_sym_thread_local] = ACTIONS(3621),
    [anon_sym___thread] = ACTIONS(3621),
    [anon_sym_const] = ACTIONS(3621),
    [anon_sym_constexpr] = ACTIONS(3621),
    [anon_sym_volatile] = ACTIONS(3621),
    [anon_sym_restrict] = ACTIONS(3621),
    [anon_sym___restrict__] = ACTIONS(3621),
    [anon_sym__Atomic] = ACTIONS(3621),
    [anon_sym__Noreturn] = ACTIONS(3621),
    [anon_sym_noreturn] = ACTIONS(3621),
    [anon_sym_mutable] = ACTIONS(3621),
    [anon_sym_constinit] = ACTIONS(3621),
    [anon_sym_consteval] = ACTIONS(3621),
    [anon_sym_alignas] = ACTIONS(3621),
    [anon_sym__Alignas] = ACTIONS(3621),
    [sym_primitive_type] = ACTIONS(3621),
    [anon_sym_enum] = ACTIONS(3621),
    [anon_sym_class] = ACTIONS(3621),
    [anon_sym_struct] = ACTIONS(3621),
    [anon_sym_union] = ACTIONS(3621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3621),
    [anon_sym_let] = ACTIONS(3621),
    [anon_sym_This] = ACTIONS(3621),
    [anon_sym_decltype] = ACTIONS(3621),
    [sym_virtual] = ACTIONS(3621),
    [anon_sym_explicit] = ACTIONS(3621),
    [anon_sym_typename] = ACTIONS(3621),
    [anon_sym_template] = ACTIONS(3621),
    [anon_sym_operator] = ACTIONS(3621),
    [anon_sym_friend] = ACTIONS(3621),
    [anon_sym_public] = ACTIONS(3621),
    [anon_sym_private] = ACTIONS(3621),
    [anon_sym_protected] = ACTIONS(3621),
    [anon_sym_using] = ACTIONS(3621),
    [anon_sym_static_assert] = ACTIONS(3621),
    [anon_sym_precise] = ACTIONS(3621),
    [anon_sym_shared] = ACTIONS(3621),
    [anon_sym_groupshared] = ACTIONS(3621),
    [anon_sym_uniform] = ACTIONS(3621),
    [anon_sym_row_major] = ACTIONS(3621),
    [anon_sym_column_major] = ACTIONS(3621),
    [anon_sym_globallycoherent] = ACTIONS(3621),
    [anon_sym_centroid] = ACTIONS(3621),
    [anon_sym_noperspective] = ACTIONS(3621),
    [anon_sym_nointerpolation] = ACTIONS(3621),
    [anon_sym_sample] = ACTIONS(3621),
    [anon_sym_linear] = ACTIONS(3621),
    [anon_sym_snorm] = ACTIONS(3621),
    [anon_sym_unorm] = ACTIONS(3621),
    [anon_sym_point] = ACTIONS(3621),
    [anon_sym_line] = ACTIONS(3621),
    [anon_sym_triangleadj] = ACTIONS(3621),
    [anon_sym_lineadj] = ACTIONS(3621),
    [anon_sym_triangle] = ACTIONS(3621),
    [anon_sym_interface] = ACTIONS(3621),
    [anon_sym_extension] = ACTIONS(3621),
    [anon_sym___init] = ACTIONS(3621),
    [anon_sym___subscript] = ACTIONS(3621),
    [anon_sym_property] = ACTIONS(3621),
    [anon_sym_associatedtype] = ACTIONS(3621),
  },
  [2260] = {
    [sym_expression] = STATE(4421),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [2261] = {
    [sym_expression] = STATE(4554),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [2262] = {
    [sym_identifier] = ACTIONS(3501),
    [aux_sym_preproc_def_token1] = ACTIONS(3501),
    [aux_sym_preproc_if_token1] = ACTIONS(3501),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3501),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3501),
    [sym_preproc_directive] = ACTIONS(3501),
    [anon_sym_LPAREN2] = ACTIONS(3503),
    [anon_sym_TILDE] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(3503),
    [anon_sym_AMP_AMP] = ACTIONS(3503),
    [anon_sym_AMP] = ACTIONS(3501),
    [anon_sym___extension__] = ACTIONS(3501),
    [anon_sym_typedef] = ACTIONS(3501),
    [anon_sym_in] = ACTIONS(3501),
    [anon_sym_out] = ACTIONS(3501),
    [anon_sym_inout] = ACTIONS(3501),
    [anon_sym_extern] = ACTIONS(3501),
    [anon_sym___attribute__] = ACTIONS(3501),
    [anon_sym_COLON_COLON] = ACTIONS(3503),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3503),
    [anon_sym___declspec] = ACTIONS(3501),
    [anon_sym___based] = ACTIONS(3501),
    [anon_sym_RBRACE] = ACTIONS(3503),
    [anon_sym_signed] = ACTIONS(3501),
    [anon_sym_unsigned] = ACTIONS(3501),
    [anon_sym_long] = ACTIONS(3501),
    [anon_sym_short] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(3501),
    [anon_sym_static] = ACTIONS(3501),
    [anon_sym_register] = ACTIONS(3501),
    [anon_sym_inline] = ACTIONS(3501),
    [anon_sym___inline] = ACTIONS(3501),
    [anon_sym___inline__] = ACTIONS(3501),
    [anon_sym___forceinline] = ACTIONS(3501),
    [anon_sym_thread_local] = ACTIONS(3501),
    [anon_sym___thread] = ACTIONS(3501),
    [anon_sym_const] = ACTIONS(3501),
    [anon_sym_constexpr] = ACTIONS(3501),
    [anon_sym_volatile] = ACTIONS(3501),
    [anon_sym_restrict] = ACTIONS(3501),
    [anon_sym___restrict__] = ACTIONS(3501),
    [anon_sym__Atomic] = ACTIONS(3501),
    [anon_sym__Noreturn] = ACTIONS(3501),
    [anon_sym_noreturn] = ACTIONS(3501),
    [anon_sym_mutable] = ACTIONS(3501),
    [anon_sym_constinit] = ACTIONS(3501),
    [anon_sym_consteval] = ACTIONS(3501),
    [anon_sym_alignas] = ACTIONS(3501),
    [anon_sym__Alignas] = ACTIONS(3501),
    [sym_primitive_type] = ACTIONS(3501),
    [anon_sym_enum] = ACTIONS(3501),
    [anon_sym_class] = ACTIONS(3501),
    [anon_sym_struct] = ACTIONS(3501),
    [anon_sym_union] = ACTIONS(3501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3501),
    [anon_sym_let] = ACTIONS(3501),
    [anon_sym_This] = ACTIONS(3501),
    [anon_sym_decltype] = ACTIONS(3501),
    [sym_virtual] = ACTIONS(3501),
    [anon_sym_explicit] = ACTIONS(3501),
    [anon_sym_typename] = ACTIONS(3501),
    [anon_sym_template] = ACTIONS(3501),
    [anon_sym_operator] = ACTIONS(3501),
    [anon_sym_friend] = ACTIONS(3501),
    [anon_sym_public] = ACTIONS(3501),
    [anon_sym_private] = ACTIONS(3501),
    [anon_sym_protected] = ACTIONS(3501),
    [anon_sym_using] = ACTIONS(3501),
    [anon_sym_static_assert] = ACTIONS(3501),
    [anon_sym_precise] = ACTIONS(3501),
    [anon_sym_shared] = ACTIONS(3501),
    [anon_sym_groupshared] = ACTIONS(3501),
    [anon_sym_uniform] = ACTIONS(3501),
    [anon_sym_row_major] = ACTIONS(3501),
    [anon_sym_column_major] = ACTIONS(3501),
    [anon_sym_globallycoherent] = ACTIONS(3501),
    [anon_sym_centroid] = ACTIONS(3501),
    [anon_sym_noperspective] = ACTIONS(3501),
    [anon_sym_nointerpolation] = ACTIONS(3501),
    [anon_sym_sample] = ACTIONS(3501),
    [anon_sym_linear] = ACTIONS(3501),
    [anon_sym_snorm] = ACTIONS(3501),
    [anon_sym_unorm] = ACTIONS(3501),
    [anon_sym_point] = ACTIONS(3501),
    [anon_sym_line] = ACTIONS(3501),
    [anon_sym_triangleadj] = ACTIONS(3501),
    [anon_sym_lineadj] = ACTIONS(3501),
    [anon_sym_triangle] = ACTIONS(3501),
    [anon_sym_interface] = ACTIONS(3501),
    [anon_sym_extension] = ACTIONS(3501),
    [anon_sym___init] = ACTIONS(3501),
    [anon_sym___subscript] = ACTIONS(3501),
    [anon_sym_property] = ACTIONS(3501),
    [anon_sym_associatedtype] = ACTIONS(3501),
  },
  [2263] = {
    [sym_expression] = STATE(4881),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4905),
    [sym_concatenated_string] = STATE(4902),
    [sym_string_literal] = STATE(3611),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3610),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(5705),
    [anon_sym_LPAREN2] = ACTIONS(5834),
    [anon_sym_BANG] = ACTIONS(4926),
    [anon_sym_TILDE] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4928),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4924),
    [anon_sym_compl] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(5707),
    [anon_sym_PLUS_PLUS] = ACTIONS(5707),
    [anon_sym_sizeof] = ACTIONS(4932),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4934),
    [anon_sym_L_SQUOTE] = ACTIONS(4936),
    [anon_sym_u_SQUOTE] = ACTIONS(4936),
    [anon_sym_U_SQUOTE] = ACTIONS(4936),
    [anon_sym_u8_SQUOTE] = ACTIONS(4936),
    [anon_sym_SQUOTE] = ACTIONS(4936),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4938),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_co_await] = ACTIONS(4940),
    [anon_sym_new] = ACTIONS(4942),
    [anon_sym_requires] = ACTIONS(4944),
    [sym_this] = ACTIONS(241),
  },
  [2264] = {
    [sym_expression] = STATE(5525),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2265] = {
    [sym_expression] = STATE(4424),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [2266] = {
    [sym_expression] = STATE(5162),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4958),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4964),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2267] = {
    [sym_expression] = STATE(4432),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [2268] = {
    [sym_expression] = STATE(4677),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4958),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4964),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2269] = {
    [sym_expression] = STATE(5618),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2270] = {
    [sym_expression] = STATE(5148),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2271] = {
    [sym_expression] = STATE(5406),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2272] = {
    [sym_expression] = STATE(5368),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(6106),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2273] = {
    [sym_expression] = STATE(5147),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2274] = {
    [sym_expression] = STATE(5530),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2275] = {
    [sym_expression] = STATE(5535),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2276] = {
    [sym_expression] = STATE(5163),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4958),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4964),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2277] = {
    [sym_expression] = STATE(5127),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4958),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4964),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2278] = {
    [sym_expression] = STATE(5220),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2279] = {
    [sym_expression] = STATE(5166),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4958),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4964),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2280] = {
    [sym_identifier] = ACTIONS(5568),
    [aux_sym_preproc_def_token1] = ACTIONS(5568),
    [aux_sym_preproc_if_token1] = ACTIONS(5568),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5568),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5568),
    [sym_preproc_directive] = ACTIONS(5568),
    [anon_sym_LPAREN2] = ACTIONS(5570),
    [anon_sym_TILDE] = ACTIONS(5570),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_AMP_AMP] = ACTIONS(5570),
    [anon_sym_AMP] = ACTIONS(5568),
    [anon_sym___extension__] = ACTIONS(5568),
    [anon_sym_typedef] = ACTIONS(5568),
    [anon_sym_in] = ACTIONS(5568),
    [anon_sym_out] = ACTIONS(5568),
    [anon_sym_inout] = ACTIONS(5568),
    [anon_sym_extern] = ACTIONS(5568),
    [anon_sym___attribute__] = ACTIONS(5568),
    [anon_sym_COLON_COLON] = ACTIONS(5570),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5570),
    [anon_sym___declspec] = ACTIONS(5568),
    [anon_sym___based] = ACTIONS(5568),
    [anon_sym_RBRACE] = ACTIONS(5570),
    [anon_sym_signed] = ACTIONS(5568),
    [anon_sym_unsigned] = ACTIONS(5568),
    [anon_sym_long] = ACTIONS(5568),
    [anon_sym_short] = ACTIONS(5568),
    [anon_sym_LBRACK] = ACTIONS(5568),
    [anon_sym_static] = ACTIONS(5568),
    [anon_sym_register] = ACTIONS(5568),
    [anon_sym_inline] = ACTIONS(5568),
    [anon_sym___inline] = ACTIONS(5568),
    [anon_sym___inline__] = ACTIONS(5568),
    [anon_sym___forceinline] = ACTIONS(5568),
    [anon_sym_thread_local] = ACTIONS(5568),
    [anon_sym___thread] = ACTIONS(5568),
    [anon_sym_const] = ACTIONS(5568),
    [anon_sym_constexpr] = ACTIONS(5568),
    [anon_sym_volatile] = ACTIONS(5568),
    [anon_sym_restrict] = ACTIONS(5568),
    [anon_sym___restrict__] = ACTIONS(5568),
    [anon_sym__Atomic] = ACTIONS(5568),
    [anon_sym__Noreturn] = ACTIONS(5568),
    [anon_sym_noreturn] = ACTIONS(5568),
    [anon_sym_mutable] = ACTIONS(5568),
    [anon_sym_constinit] = ACTIONS(5568),
    [anon_sym_consteval] = ACTIONS(5568),
    [anon_sym_alignas] = ACTIONS(5568),
    [anon_sym__Alignas] = ACTIONS(5568),
    [sym_primitive_type] = ACTIONS(5568),
    [anon_sym_enum] = ACTIONS(5568),
    [anon_sym_class] = ACTIONS(5568),
    [anon_sym_struct] = ACTIONS(5568),
    [anon_sym_union] = ACTIONS(5568),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5568),
    [anon_sym_let] = ACTIONS(5568),
    [anon_sym_This] = ACTIONS(5568),
    [anon_sym_decltype] = ACTIONS(5568),
    [sym_virtual] = ACTIONS(5568),
    [anon_sym_explicit] = ACTIONS(5568),
    [anon_sym_typename] = ACTIONS(5568),
    [anon_sym_template] = ACTIONS(5568),
    [anon_sym_operator] = ACTIONS(5568),
    [anon_sym_friend] = ACTIONS(5568),
    [anon_sym_public] = ACTIONS(5568),
    [anon_sym_private] = ACTIONS(5568),
    [anon_sym_protected] = ACTIONS(5568),
    [anon_sym_using] = ACTIONS(5568),
    [anon_sym_static_assert] = ACTIONS(5568),
    [anon_sym_precise] = ACTIONS(5568),
    [anon_sym_shared] = ACTIONS(5568),
    [anon_sym_groupshared] = ACTIONS(5568),
    [anon_sym_uniform] = ACTIONS(5568),
    [anon_sym_row_major] = ACTIONS(5568),
    [anon_sym_column_major] = ACTIONS(5568),
    [anon_sym_globallycoherent] = ACTIONS(5568),
    [anon_sym_centroid] = ACTIONS(5568),
    [anon_sym_noperspective] = ACTIONS(5568),
    [anon_sym_nointerpolation] = ACTIONS(5568),
    [anon_sym_sample] = ACTIONS(5568),
    [anon_sym_linear] = ACTIONS(5568),
    [anon_sym_snorm] = ACTIONS(5568),
    [anon_sym_unorm] = ACTIONS(5568),
    [anon_sym_point] = ACTIONS(5568),
    [anon_sym_line] = ACTIONS(5568),
    [anon_sym_triangleadj] = ACTIONS(5568),
    [anon_sym_lineadj] = ACTIONS(5568),
    [anon_sym_triangle] = ACTIONS(5568),
    [anon_sym_interface] = ACTIONS(5568),
    [anon_sym_extension] = ACTIONS(5568),
    [anon_sym___init] = ACTIONS(5568),
    [anon_sym___subscript] = ACTIONS(5568),
    [anon_sym_property] = ACTIONS(5568),
    [anon_sym_associatedtype] = ACTIONS(5568),
  },
  [2281] = {
    [sym_expression] = STATE(5167),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4958),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4964),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2282] = {
    [sym_identifier] = ACTIONS(5582),
    [aux_sym_preproc_def_token1] = ACTIONS(5582),
    [aux_sym_preproc_if_token1] = ACTIONS(5582),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5582),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5582),
    [sym_preproc_directive] = ACTIONS(5582),
    [anon_sym_LPAREN2] = ACTIONS(5584),
    [anon_sym_TILDE] = ACTIONS(5584),
    [anon_sym_STAR] = ACTIONS(5584),
    [anon_sym_AMP_AMP] = ACTIONS(5584),
    [anon_sym_AMP] = ACTIONS(5582),
    [anon_sym___extension__] = ACTIONS(5582),
    [anon_sym_typedef] = ACTIONS(5582),
    [anon_sym_in] = ACTIONS(5582),
    [anon_sym_out] = ACTIONS(5582),
    [anon_sym_inout] = ACTIONS(5582),
    [anon_sym_extern] = ACTIONS(5582),
    [anon_sym___attribute__] = ACTIONS(5582),
    [anon_sym_COLON_COLON] = ACTIONS(5584),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5584),
    [anon_sym___declspec] = ACTIONS(5582),
    [anon_sym___based] = ACTIONS(5582),
    [anon_sym_RBRACE] = ACTIONS(5584),
    [anon_sym_signed] = ACTIONS(5582),
    [anon_sym_unsigned] = ACTIONS(5582),
    [anon_sym_long] = ACTIONS(5582),
    [anon_sym_short] = ACTIONS(5582),
    [anon_sym_LBRACK] = ACTIONS(5582),
    [anon_sym_static] = ACTIONS(5582),
    [anon_sym_register] = ACTIONS(5582),
    [anon_sym_inline] = ACTIONS(5582),
    [anon_sym___inline] = ACTIONS(5582),
    [anon_sym___inline__] = ACTIONS(5582),
    [anon_sym___forceinline] = ACTIONS(5582),
    [anon_sym_thread_local] = ACTIONS(5582),
    [anon_sym___thread] = ACTIONS(5582),
    [anon_sym_const] = ACTIONS(5582),
    [anon_sym_constexpr] = ACTIONS(5582),
    [anon_sym_volatile] = ACTIONS(5582),
    [anon_sym_restrict] = ACTIONS(5582),
    [anon_sym___restrict__] = ACTIONS(5582),
    [anon_sym__Atomic] = ACTIONS(5582),
    [anon_sym__Noreturn] = ACTIONS(5582),
    [anon_sym_noreturn] = ACTIONS(5582),
    [anon_sym_mutable] = ACTIONS(5582),
    [anon_sym_constinit] = ACTIONS(5582),
    [anon_sym_consteval] = ACTIONS(5582),
    [anon_sym_alignas] = ACTIONS(5582),
    [anon_sym__Alignas] = ACTIONS(5582),
    [sym_primitive_type] = ACTIONS(5582),
    [anon_sym_enum] = ACTIONS(5582),
    [anon_sym_class] = ACTIONS(5582),
    [anon_sym_struct] = ACTIONS(5582),
    [anon_sym_union] = ACTIONS(5582),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5582),
    [anon_sym_let] = ACTIONS(5582),
    [anon_sym_This] = ACTIONS(5582),
    [anon_sym_decltype] = ACTIONS(5582),
    [sym_virtual] = ACTIONS(5582),
    [anon_sym_explicit] = ACTIONS(5582),
    [anon_sym_typename] = ACTIONS(5582),
    [anon_sym_template] = ACTIONS(5582),
    [anon_sym_operator] = ACTIONS(5582),
    [anon_sym_friend] = ACTIONS(5582),
    [anon_sym_public] = ACTIONS(5582),
    [anon_sym_private] = ACTIONS(5582),
    [anon_sym_protected] = ACTIONS(5582),
    [anon_sym_using] = ACTIONS(5582),
    [anon_sym_static_assert] = ACTIONS(5582),
    [anon_sym_precise] = ACTIONS(5582),
    [anon_sym_shared] = ACTIONS(5582),
    [anon_sym_groupshared] = ACTIONS(5582),
    [anon_sym_uniform] = ACTIONS(5582),
    [anon_sym_row_major] = ACTIONS(5582),
    [anon_sym_column_major] = ACTIONS(5582),
    [anon_sym_globallycoherent] = ACTIONS(5582),
    [anon_sym_centroid] = ACTIONS(5582),
    [anon_sym_noperspective] = ACTIONS(5582),
    [anon_sym_nointerpolation] = ACTIONS(5582),
    [anon_sym_sample] = ACTIONS(5582),
    [anon_sym_linear] = ACTIONS(5582),
    [anon_sym_snorm] = ACTIONS(5582),
    [anon_sym_unorm] = ACTIONS(5582),
    [anon_sym_point] = ACTIONS(5582),
    [anon_sym_line] = ACTIONS(5582),
    [anon_sym_triangleadj] = ACTIONS(5582),
    [anon_sym_lineadj] = ACTIONS(5582),
    [anon_sym_triangle] = ACTIONS(5582),
    [anon_sym_interface] = ACTIONS(5582),
    [anon_sym_extension] = ACTIONS(5582),
    [anon_sym___init] = ACTIONS(5582),
    [anon_sym___subscript] = ACTIONS(5582),
    [anon_sym_property] = ACTIONS(5582),
    [anon_sym_associatedtype] = ACTIONS(5582),
  },
  [2283] = {
    [sym_expression] = STATE(4434),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [2284] = {
    [sym_expression] = STATE(4437),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [2285] = {
    [sym_identifier] = ACTIONS(5586),
    [aux_sym_preproc_def_token1] = ACTIONS(5586),
    [aux_sym_preproc_if_token1] = ACTIONS(5586),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5586),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5586),
    [sym_preproc_directive] = ACTIONS(5586),
    [anon_sym_LPAREN2] = ACTIONS(5588),
    [anon_sym_TILDE] = ACTIONS(5588),
    [anon_sym_STAR] = ACTIONS(5588),
    [anon_sym_AMP_AMP] = ACTIONS(5588),
    [anon_sym_AMP] = ACTIONS(5586),
    [anon_sym___extension__] = ACTIONS(5586),
    [anon_sym_typedef] = ACTIONS(5586),
    [anon_sym_in] = ACTIONS(5586),
    [anon_sym_out] = ACTIONS(5586),
    [anon_sym_inout] = ACTIONS(5586),
    [anon_sym_extern] = ACTIONS(5586),
    [anon_sym___attribute__] = ACTIONS(5586),
    [anon_sym_COLON_COLON] = ACTIONS(5588),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5588),
    [anon_sym___declspec] = ACTIONS(5586),
    [anon_sym___based] = ACTIONS(5586),
    [anon_sym_RBRACE] = ACTIONS(5588),
    [anon_sym_signed] = ACTIONS(5586),
    [anon_sym_unsigned] = ACTIONS(5586),
    [anon_sym_long] = ACTIONS(5586),
    [anon_sym_short] = ACTIONS(5586),
    [anon_sym_LBRACK] = ACTIONS(5586),
    [anon_sym_static] = ACTIONS(5586),
    [anon_sym_register] = ACTIONS(5586),
    [anon_sym_inline] = ACTIONS(5586),
    [anon_sym___inline] = ACTIONS(5586),
    [anon_sym___inline__] = ACTIONS(5586),
    [anon_sym___forceinline] = ACTIONS(5586),
    [anon_sym_thread_local] = ACTIONS(5586),
    [anon_sym___thread] = ACTIONS(5586),
    [anon_sym_const] = ACTIONS(5586),
    [anon_sym_constexpr] = ACTIONS(5586),
    [anon_sym_volatile] = ACTIONS(5586),
    [anon_sym_restrict] = ACTIONS(5586),
    [anon_sym___restrict__] = ACTIONS(5586),
    [anon_sym__Atomic] = ACTIONS(5586),
    [anon_sym__Noreturn] = ACTIONS(5586),
    [anon_sym_noreturn] = ACTIONS(5586),
    [anon_sym_mutable] = ACTIONS(5586),
    [anon_sym_constinit] = ACTIONS(5586),
    [anon_sym_consteval] = ACTIONS(5586),
    [anon_sym_alignas] = ACTIONS(5586),
    [anon_sym__Alignas] = ACTIONS(5586),
    [sym_primitive_type] = ACTIONS(5586),
    [anon_sym_enum] = ACTIONS(5586),
    [anon_sym_class] = ACTIONS(5586),
    [anon_sym_struct] = ACTIONS(5586),
    [anon_sym_union] = ACTIONS(5586),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5586),
    [anon_sym_let] = ACTIONS(5586),
    [anon_sym_This] = ACTIONS(5586),
    [anon_sym_decltype] = ACTIONS(5586),
    [sym_virtual] = ACTIONS(5586),
    [anon_sym_explicit] = ACTIONS(5586),
    [anon_sym_typename] = ACTIONS(5586),
    [anon_sym_template] = ACTIONS(5586),
    [anon_sym_operator] = ACTIONS(5586),
    [anon_sym_friend] = ACTIONS(5586),
    [anon_sym_public] = ACTIONS(5586),
    [anon_sym_private] = ACTIONS(5586),
    [anon_sym_protected] = ACTIONS(5586),
    [anon_sym_using] = ACTIONS(5586),
    [anon_sym_static_assert] = ACTIONS(5586),
    [anon_sym_precise] = ACTIONS(5586),
    [anon_sym_shared] = ACTIONS(5586),
    [anon_sym_groupshared] = ACTIONS(5586),
    [anon_sym_uniform] = ACTIONS(5586),
    [anon_sym_row_major] = ACTIONS(5586),
    [anon_sym_column_major] = ACTIONS(5586),
    [anon_sym_globallycoherent] = ACTIONS(5586),
    [anon_sym_centroid] = ACTIONS(5586),
    [anon_sym_noperspective] = ACTIONS(5586),
    [anon_sym_nointerpolation] = ACTIONS(5586),
    [anon_sym_sample] = ACTIONS(5586),
    [anon_sym_linear] = ACTIONS(5586),
    [anon_sym_snorm] = ACTIONS(5586),
    [anon_sym_unorm] = ACTIONS(5586),
    [anon_sym_point] = ACTIONS(5586),
    [anon_sym_line] = ACTIONS(5586),
    [anon_sym_triangleadj] = ACTIONS(5586),
    [anon_sym_lineadj] = ACTIONS(5586),
    [anon_sym_triangle] = ACTIONS(5586),
    [anon_sym_interface] = ACTIONS(5586),
    [anon_sym_extension] = ACTIONS(5586),
    [anon_sym___init] = ACTIONS(5586),
    [anon_sym___subscript] = ACTIONS(5586),
    [anon_sym_property] = ACTIONS(5586),
    [anon_sym_associatedtype] = ACTIONS(5586),
  },
  [2286] = {
    [sym_expression] = STATE(5168),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4958),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4964),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2287] = {
    [sym_expression] = STATE(5347),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2288] = {
    [sym_identifier] = ACTIONS(5590),
    [aux_sym_preproc_def_token1] = ACTIONS(5590),
    [aux_sym_preproc_if_token1] = ACTIONS(5590),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5590),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5590),
    [sym_preproc_directive] = ACTIONS(5590),
    [anon_sym_LPAREN2] = ACTIONS(5592),
    [anon_sym_TILDE] = ACTIONS(5592),
    [anon_sym_STAR] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym___extension__] = ACTIONS(5590),
    [anon_sym_typedef] = ACTIONS(5590),
    [anon_sym_in] = ACTIONS(5590),
    [anon_sym_out] = ACTIONS(5590),
    [anon_sym_inout] = ACTIONS(5590),
    [anon_sym_extern] = ACTIONS(5590),
    [anon_sym___attribute__] = ACTIONS(5590),
    [anon_sym_COLON_COLON] = ACTIONS(5592),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5592),
    [anon_sym___declspec] = ACTIONS(5590),
    [anon_sym___based] = ACTIONS(5590),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [anon_sym_signed] = ACTIONS(5590),
    [anon_sym_unsigned] = ACTIONS(5590),
    [anon_sym_long] = ACTIONS(5590),
    [anon_sym_short] = ACTIONS(5590),
    [anon_sym_LBRACK] = ACTIONS(5590),
    [anon_sym_static] = ACTIONS(5590),
    [anon_sym_register] = ACTIONS(5590),
    [anon_sym_inline] = ACTIONS(5590),
    [anon_sym___inline] = ACTIONS(5590),
    [anon_sym___inline__] = ACTIONS(5590),
    [anon_sym___forceinline] = ACTIONS(5590),
    [anon_sym_thread_local] = ACTIONS(5590),
    [anon_sym___thread] = ACTIONS(5590),
    [anon_sym_const] = ACTIONS(5590),
    [anon_sym_constexpr] = ACTIONS(5590),
    [anon_sym_volatile] = ACTIONS(5590),
    [anon_sym_restrict] = ACTIONS(5590),
    [anon_sym___restrict__] = ACTIONS(5590),
    [anon_sym__Atomic] = ACTIONS(5590),
    [anon_sym__Noreturn] = ACTIONS(5590),
    [anon_sym_noreturn] = ACTIONS(5590),
    [anon_sym_mutable] = ACTIONS(5590),
    [anon_sym_constinit] = ACTIONS(5590),
    [anon_sym_consteval] = ACTIONS(5590),
    [anon_sym_alignas] = ACTIONS(5590),
    [anon_sym__Alignas] = ACTIONS(5590),
    [sym_primitive_type] = ACTIONS(5590),
    [anon_sym_enum] = ACTIONS(5590),
    [anon_sym_class] = ACTIONS(5590),
    [anon_sym_struct] = ACTIONS(5590),
    [anon_sym_union] = ACTIONS(5590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5590),
    [anon_sym_let] = ACTIONS(5590),
    [anon_sym_This] = ACTIONS(5590),
    [anon_sym_decltype] = ACTIONS(5590),
    [sym_virtual] = ACTIONS(5590),
    [anon_sym_explicit] = ACTIONS(5590),
    [anon_sym_typename] = ACTIONS(5590),
    [anon_sym_template] = ACTIONS(5590),
    [anon_sym_operator] = ACTIONS(5590),
    [anon_sym_friend] = ACTIONS(5590),
    [anon_sym_public] = ACTIONS(5590),
    [anon_sym_private] = ACTIONS(5590),
    [anon_sym_protected] = ACTIONS(5590),
    [anon_sym_using] = ACTIONS(5590),
    [anon_sym_static_assert] = ACTIONS(5590),
    [anon_sym_precise] = ACTIONS(5590),
    [anon_sym_shared] = ACTIONS(5590),
    [anon_sym_groupshared] = ACTIONS(5590),
    [anon_sym_uniform] = ACTIONS(5590),
    [anon_sym_row_major] = ACTIONS(5590),
    [anon_sym_column_major] = ACTIONS(5590),
    [anon_sym_globallycoherent] = ACTIONS(5590),
    [anon_sym_centroid] = ACTIONS(5590),
    [anon_sym_noperspective] = ACTIONS(5590),
    [anon_sym_nointerpolation] = ACTIONS(5590),
    [anon_sym_sample] = ACTIONS(5590),
    [anon_sym_linear] = ACTIONS(5590),
    [anon_sym_snorm] = ACTIONS(5590),
    [anon_sym_unorm] = ACTIONS(5590),
    [anon_sym_point] = ACTIONS(5590),
    [anon_sym_line] = ACTIONS(5590),
    [anon_sym_triangleadj] = ACTIONS(5590),
    [anon_sym_lineadj] = ACTIONS(5590),
    [anon_sym_triangle] = ACTIONS(5590),
    [anon_sym_interface] = ACTIONS(5590),
    [anon_sym_extension] = ACTIONS(5590),
    [anon_sym___init] = ACTIONS(5590),
    [anon_sym___subscript] = ACTIONS(5590),
    [anon_sym_property] = ACTIONS(5590),
    [anon_sym_associatedtype] = ACTIONS(5590),
  },
  [2289] = {
    [sym_identifier] = ACTIONS(5594),
    [aux_sym_preproc_def_token1] = ACTIONS(5594),
    [aux_sym_preproc_if_token1] = ACTIONS(5594),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5594),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5594),
    [sym_preproc_directive] = ACTIONS(5594),
    [anon_sym_LPAREN2] = ACTIONS(5596),
    [anon_sym_TILDE] = ACTIONS(5596),
    [anon_sym_STAR] = ACTIONS(5596),
    [anon_sym_AMP_AMP] = ACTIONS(5596),
    [anon_sym_AMP] = ACTIONS(5594),
    [anon_sym___extension__] = ACTIONS(5594),
    [anon_sym_typedef] = ACTIONS(5594),
    [anon_sym_in] = ACTIONS(5594),
    [anon_sym_out] = ACTIONS(5594),
    [anon_sym_inout] = ACTIONS(5594),
    [anon_sym_extern] = ACTIONS(5594),
    [anon_sym___attribute__] = ACTIONS(5594),
    [anon_sym_COLON_COLON] = ACTIONS(5596),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5596),
    [anon_sym___declspec] = ACTIONS(5594),
    [anon_sym___based] = ACTIONS(5594),
    [anon_sym_RBRACE] = ACTIONS(5596),
    [anon_sym_signed] = ACTIONS(5594),
    [anon_sym_unsigned] = ACTIONS(5594),
    [anon_sym_long] = ACTIONS(5594),
    [anon_sym_short] = ACTIONS(5594),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_static] = ACTIONS(5594),
    [anon_sym_register] = ACTIONS(5594),
    [anon_sym_inline] = ACTIONS(5594),
    [anon_sym___inline] = ACTIONS(5594),
    [anon_sym___inline__] = ACTIONS(5594),
    [anon_sym___forceinline] = ACTIONS(5594),
    [anon_sym_thread_local] = ACTIONS(5594),
    [anon_sym___thread] = ACTIONS(5594),
    [anon_sym_const] = ACTIONS(5594),
    [anon_sym_constexpr] = ACTIONS(5594),
    [anon_sym_volatile] = ACTIONS(5594),
    [anon_sym_restrict] = ACTIONS(5594),
    [anon_sym___restrict__] = ACTIONS(5594),
    [anon_sym__Atomic] = ACTIONS(5594),
    [anon_sym__Noreturn] = ACTIONS(5594),
    [anon_sym_noreturn] = ACTIONS(5594),
    [anon_sym_mutable] = ACTIONS(5594),
    [anon_sym_constinit] = ACTIONS(5594),
    [anon_sym_consteval] = ACTIONS(5594),
    [anon_sym_alignas] = ACTIONS(5594),
    [anon_sym__Alignas] = ACTIONS(5594),
    [sym_primitive_type] = ACTIONS(5594),
    [anon_sym_enum] = ACTIONS(5594),
    [anon_sym_class] = ACTIONS(5594),
    [anon_sym_struct] = ACTIONS(5594),
    [anon_sym_union] = ACTIONS(5594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5594),
    [anon_sym_let] = ACTIONS(5594),
    [anon_sym_This] = ACTIONS(5594),
    [anon_sym_decltype] = ACTIONS(5594),
    [sym_virtual] = ACTIONS(5594),
    [anon_sym_explicit] = ACTIONS(5594),
    [anon_sym_typename] = ACTIONS(5594),
    [anon_sym_template] = ACTIONS(5594),
    [anon_sym_operator] = ACTIONS(5594),
    [anon_sym_friend] = ACTIONS(5594),
    [anon_sym_public] = ACTIONS(5594),
    [anon_sym_private] = ACTIONS(5594),
    [anon_sym_protected] = ACTIONS(5594),
    [anon_sym_using] = ACTIONS(5594),
    [anon_sym_static_assert] = ACTIONS(5594),
    [anon_sym_precise] = ACTIONS(5594),
    [anon_sym_shared] = ACTIONS(5594),
    [anon_sym_groupshared] = ACTIONS(5594),
    [anon_sym_uniform] = ACTIONS(5594),
    [anon_sym_row_major] = ACTIONS(5594),
    [anon_sym_column_major] = ACTIONS(5594),
    [anon_sym_globallycoherent] = ACTIONS(5594),
    [anon_sym_centroid] = ACTIONS(5594),
    [anon_sym_noperspective] = ACTIONS(5594),
    [anon_sym_nointerpolation] = ACTIONS(5594),
    [anon_sym_sample] = ACTIONS(5594),
    [anon_sym_linear] = ACTIONS(5594),
    [anon_sym_snorm] = ACTIONS(5594),
    [anon_sym_unorm] = ACTIONS(5594),
    [anon_sym_point] = ACTIONS(5594),
    [anon_sym_line] = ACTIONS(5594),
    [anon_sym_triangleadj] = ACTIONS(5594),
    [anon_sym_lineadj] = ACTIONS(5594),
    [anon_sym_triangle] = ACTIONS(5594),
    [anon_sym_interface] = ACTIONS(5594),
    [anon_sym_extension] = ACTIONS(5594),
    [anon_sym___init] = ACTIONS(5594),
    [anon_sym___subscript] = ACTIONS(5594),
    [anon_sym_property] = ACTIONS(5594),
    [anon_sym_associatedtype] = ACTIONS(5594),
  },
  [2290] = {
    [sym_expression] = STATE(5169),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4958),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4964),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2291] = {
    [sym_expression] = STATE(5503),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2292] = {
    [sym_expression] = STATE(4451),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [2293] = {
    [sym_expression] = STATE(4561),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [2294] = {
    [sym_expression] = STATE(5321),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2295] = {
    [sym_identifier] = ACTIONS(3414),
    [aux_sym_preproc_def_token1] = ACTIONS(3414),
    [aux_sym_preproc_if_token1] = ACTIONS(3414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3414),
    [sym_preproc_directive] = ACTIONS(3414),
    [anon_sym_LPAREN2] = ACTIONS(3416),
    [anon_sym_TILDE] = ACTIONS(3416),
    [anon_sym_STAR] = ACTIONS(3416),
    [anon_sym_AMP_AMP] = ACTIONS(3416),
    [anon_sym_AMP] = ACTIONS(3414),
    [anon_sym___extension__] = ACTIONS(3414),
    [anon_sym_typedef] = ACTIONS(3414),
    [anon_sym_in] = ACTIONS(3414),
    [anon_sym_out] = ACTIONS(3414),
    [anon_sym_inout] = ACTIONS(3414),
    [anon_sym_extern] = ACTIONS(3414),
    [anon_sym___attribute__] = ACTIONS(3414),
    [anon_sym_COLON_COLON] = ACTIONS(3416),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3416),
    [anon_sym___declspec] = ACTIONS(3414),
    [anon_sym___based] = ACTIONS(3414),
    [anon_sym_RBRACE] = ACTIONS(3416),
    [anon_sym_signed] = ACTIONS(3414),
    [anon_sym_unsigned] = ACTIONS(3414),
    [anon_sym_long] = ACTIONS(3414),
    [anon_sym_short] = ACTIONS(3414),
    [anon_sym_LBRACK] = ACTIONS(3414),
    [anon_sym_static] = ACTIONS(3414),
    [anon_sym_register] = ACTIONS(3414),
    [anon_sym_inline] = ACTIONS(3414),
    [anon_sym___inline] = ACTIONS(3414),
    [anon_sym___inline__] = ACTIONS(3414),
    [anon_sym___forceinline] = ACTIONS(3414),
    [anon_sym_thread_local] = ACTIONS(3414),
    [anon_sym___thread] = ACTIONS(3414),
    [anon_sym_const] = ACTIONS(3414),
    [anon_sym_constexpr] = ACTIONS(3414),
    [anon_sym_volatile] = ACTIONS(3414),
    [anon_sym_restrict] = ACTIONS(3414),
    [anon_sym___restrict__] = ACTIONS(3414),
    [anon_sym__Atomic] = ACTIONS(3414),
    [anon_sym__Noreturn] = ACTIONS(3414),
    [anon_sym_noreturn] = ACTIONS(3414),
    [anon_sym_mutable] = ACTIONS(3414),
    [anon_sym_constinit] = ACTIONS(3414),
    [anon_sym_consteval] = ACTIONS(3414),
    [anon_sym_alignas] = ACTIONS(3414),
    [anon_sym__Alignas] = ACTIONS(3414),
    [sym_primitive_type] = ACTIONS(3414),
    [anon_sym_enum] = ACTIONS(3414),
    [anon_sym_class] = ACTIONS(3414),
    [anon_sym_struct] = ACTIONS(3414),
    [anon_sym_union] = ACTIONS(3414),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3414),
    [anon_sym_let] = ACTIONS(3414),
    [anon_sym_This] = ACTIONS(3414),
    [anon_sym_decltype] = ACTIONS(3414),
    [sym_virtual] = ACTIONS(3414),
    [anon_sym_explicit] = ACTIONS(3414),
    [anon_sym_typename] = ACTIONS(3414),
    [anon_sym_template] = ACTIONS(3414),
    [anon_sym_operator] = ACTIONS(3414),
    [anon_sym_friend] = ACTIONS(3414),
    [anon_sym_public] = ACTIONS(3414),
    [anon_sym_private] = ACTIONS(3414),
    [anon_sym_protected] = ACTIONS(3414),
    [anon_sym_using] = ACTIONS(3414),
    [anon_sym_static_assert] = ACTIONS(3414),
    [anon_sym_precise] = ACTIONS(3414),
    [anon_sym_shared] = ACTIONS(3414),
    [anon_sym_groupshared] = ACTIONS(3414),
    [anon_sym_uniform] = ACTIONS(3414),
    [anon_sym_row_major] = ACTIONS(3414),
    [anon_sym_column_major] = ACTIONS(3414),
    [anon_sym_globallycoherent] = ACTIONS(3414),
    [anon_sym_centroid] = ACTIONS(3414),
    [anon_sym_noperspective] = ACTIONS(3414),
    [anon_sym_nointerpolation] = ACTIONS(3414),
    [anon_sym_sample] = ACTIONS(3414),
    [anon_sym_linear] = ACTIONS(3414),
    [anon_sym_snorm] = ACTIONS(3414),
    [anon_sym_unorm] = ACTIONS(3414),
    [anon_sym_point] = ACTIONS(3414),
    [anon_sym_line] = ACTIONS(3414),
    [anon_sym_triangleadj] = ACTIONS(3414),
    [anon_sym_lineadj] = ACTIONS(3414),
    [anon_sym_triangle] = ACTIONS(3414),
    [anon_sym_interface] = ACTIONS(3414),
    [anon_sym_extension] = ACTIONS(3414),
    [anon_sym___init] = ACTIONS(3414),
    [anon_sym___subscript] = ACTIONS(3414),
    [anon_sym_property] = ACTIONS(3414),
    [anon_sym_associatedtype] = ACTIONS(3414),
  },
  [2296] = {
    [sym_identifier] = ACTIONS(3425),
    [aux_sym_preproc_def_token1] = ACTIONS(3425),
    [aux_sym_preproc_if_token1] = ACTIONS(3425),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3425),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3425),
    [sym_preproc_directive] = ACTIONS(3425),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3425),
    [anon_sym___extension__] = ACTIONS(3425),
    [anon_sym_typedef] = ACTIONS(3425),
    [anon_sym_in] = ACTIONS(3425),
    [anon_sym_out] = ACTIONS(3425),
    [anon_sym_inout] = ACTIONS(3425),
    [anon_sym_extern] = ACTIONS(3425),
    [anon_sym___attribute__] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(3427),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3427),
    [anon_sym___declspec] = ACTIONS(3425),
    [anon_sym___based] = ACTIONS(3425),
    [anon_sym_RBRACE] = ACTIONS(3427),
    [anon_sym_signed] = ACTIONS(3425),
    [anon_sym_unsigned] = ACTIONS(3425),
    [anon_sym_long] = ACTIONS(3425),
    [anon_sym_short] = ACTIONS(3425),
    [anon_sym_LBRACK] = ACTIONS(3425),
    [anon_sym_static] = ACTIONS(3425),
    [anon_sym_register] = ACTIONS(3425),
    [anon_sym_inline] = ACTIONS(3425),
    [anon_sym___inline] = ACTIONS(3425),
    [anon_sym___inline__] = ACTIONS(3425),
    [anon_sym___forceinline] = ACTIONS(3425),
    [anon_sym_thread_local] = ACTIONS(3425),
    [anon_sym___thread] = ACTIONS(3425),
    [anon_sym_const] = ACTIONS(3425),
    [anon_sym_constexpr] = ACTIONS(3425),
    [anon_sym_volatile] = ACTIONS(3425),
    [anon_sym_restrict] = ACTIONS(3425),
    [anon_sym___restrict__] = ACTIONS(3425),
    [anon_sym__Atomic] = ACTIONS(3425),
    [anon_sym__Noreturn] = ACTIONS(3425),
    [anon_sym_noreturn] = ACTIONS(3425),
    [anon_sym_mutable] = ACTIONS(3425),
    [anon_sym_constinit] = ACTIONS(3425),
    [anon_sym_consteval] = ACTIONS(3425),
    [anon_sym_alignas] = ACTIONS(3425),
    [anon_sym__Alignas] = ACTIONS(3425),
    [sym_primitive_type] = ACTIONS(3425),
    [anon_sym_enum] = ACTIONS(3425),
    [anon_sym_class] = ACTIONS(3425),
    [anon_sym_struct] = ACTIONS(3425),
    [anon_sym_union] = ACTIONS(3425),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3425),
    [anon_sym_let] = ACTIONS(3425),
    [anon_sym_This] = ACTIONS(3425),
    [anon_sym_decltype] = ACTIONS(3425),
    [sym_virtual] = ACTIONS(3425),
    [anon_sym_explicit] = ACTIONS(3425),
    [anon_sym_typename] = ACTIONS(3425),
    [anon_sym_template] = ACTIONS(3425),
    [anon_sym_operator] = ACTIONS(3425),
    [anon_sym_friend] = ACTIONS(3425),
    [anon_sym_public] = ACTIONS(3425),
    [anon_sym_private] = ACTIONS(3425),
    [anon_sym_protected] = ACTIONS(3425),
    [anon_sym_using] = ACTIONS(3425),
    [anon_sym_static_assert] = ACTIONS(3425),
    [anon_sym_precise] = ACTIONS(3425),
    [anon_sym_shared] = ACTIONS(3425),
    [anon_sym_groupshared] = ACTIONS(3425),
    [anon_sym_uniform] = ACTIONS(3425),
    [anon_sym_row_major] = ACTIONS(3425),
    [anon_sym_column_major] = ACTIONS(3425),
    [anon_sym_globallycoherent] = ACTIONS(3425),
    [anon_sym_centroid] = ACTIONS(3425),
    [anon_sym_noperspective] = ACTIONS(3425),
    [anon_sym_nointerpolation] = ACTIONS(3425),
    [anon_sym_sample] = ACTIONS(3425),
    [anon_sym_linear] = ACTIONS(3425),
    [anon_sym_snorm] = ACTIONS(3425),
    [anon_sym_unorm] = ACTIONS(3425),
    [anon_sym_point] = ACTIONS(3425),
    [anon_sym_line] = ACTIONS(3425),
    [anon_sym_triangleadj] = ACTIONS(3425),
    [anon_sym_lineadj] = ACTIONS(3425),
    [anon_sym_triangle] = ACTIONS(3425),
    [anon_sym_interface] = ACTIONS(3425),
    [anon_sym_extension] = ACTIONS(3425),
    [anon_sym___init] = ACTIONS(3425),
    [anon_sym___subscript] = ACTIONS(3425),
    [anon_sym_property] = ACTIONS(3425),
    [anon_sym_associatedtype] = ACTIONS(3425),
  },
  [2297] = {
    [sym_identifier] = ACTIONS(3038),
    [aux_sym_preproc_def_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3038),
    [sym_preproc_directive] = ACTIONS(3038),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3038),
    [anon_sym___extension__] = ACTIONS(3038),
    [anon_sym_typedef] = ACTIONS(3038),
    [anon_sym_in] = ACTIONS(3038),
    [anon_sym_out] = ACTIONS(3038),
    [anon_sym_inout] = ACTIONS(3038),
    [anon_sym_extern] = ACTIONS(3038),
    [anon_sym___attribute__] = ACTIONS(3038),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3040),
    [anon_sym___declspec] = ACTIONS(3038),
    [anon_sym___based] = ACTIONS(3038),
    [anon_sym_RBRACE] = ACTIONS(3040),
    [anon_sym_signed] = ACTIONS(3038),
    [anon_sym_unsigned] = ACTIONS(3038),
    [anon_sym_long] = ACTIONS(3038),
    [anon_sym_short] = ACTIONS(3038),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_static] = ACTIONS(3038),
    [anon_sym_register] = ACTIONS(3038),
    [anon_sym_inline] = ACTIONS(3038),
    [anon_sym___inline] = ACTIONS(3038),
    [anon_sym___inline__] = ACTIONS(3038),
    [anon_sym___forceinline] = ACTIONS(3038),
    [anon_sym_thread_local] = ACTIONS(3038),
    [anon_sym___thread] = ACTIONS(3038),
    [anon_sym_const] = ACTIONS(3038),
    [anon_sym_constexpr] = ACTIONS(3038),
    [anon_sym_volatile] = ACTIONS(3038),
    [anon_sym_restrict] = ACTIONS(3038),
    [anon_sym___restrict__] = ACTIONS(3038),
    [anon_sym__Atomic] = ACTIONS(3038),
    [anon_sym__Noreturn] = ACTIONS(3038),
    [anon_sym_noreturn] = ACTIONS(3038),
    [anon_sym_mutable] = ACTIONS(3038),
    [anon_sym_constinit] = ACTIONS(3038),
    [anon_sym_consteval] = ACTIONS(3038),
    [anon_sym_alignas] = ACTIONS(3038),
    [anon_sym__Alignas] = ACTIONS(3038),
    [sym_primitive_type] = ACTIONS(3038),
    [anon_sym_enum] = ACTIONS(3038),
    [anon_sym_class] = ACTIONS(3038),
    [anon_sym_struct] = ACTIONS(3038),
    [anon_sym_union] = ACTIONS(3038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3038),
    [anon_sym_let] = ACTIONS(3038),
    [anon_sym_This] = ACTIONS(3038),
    [anon_sym_decltype] = ACTIONS(3038),
    [sym_virtual] = ACTIONS(3038),
    [anon_sym_explicit] = ACTIONS(3038),
    [anon_sym_typename] = ACTIONS(3038),
    [anon_sym_template] = ACTIONS(3038),
    [anon_sym_operator] = ACTIONS(3038),
    [anon_sym_friend] = ACTIONS(3038),
    [anon_sym_public] = ACTIONS(3038),
    [anon_sym_private] = ACTIONS(3038),
    [anon_sym_protected] = ACTIONS(3038),
    [anon_sym_using] = ACTIONS(3038),
    [anon_sym_static_assert] = ACTIONS(3038),
    [anon_sym_precise] = ACTIONS(3038),
    [anon_sym_shared] = ACTIONS(3038),
    [anon_sym_groupshared] = ACTIONS(3038),
    [anon_sym_uniform] = ACTIONS(3038),
    [anon_sym_row_major] = ACTIONS(3038),
    [anon_sym_column_major] = ACTIONS(3038),
    [anon_sym_globallycoherent] = ACTIONS(3038),
    [anon_sym_centroid] = ACTIONS(3038),
    [anon_sym_noperspective] = ACTIONS(3038),
    [anon_sym_nointerpolation] = ACTIONS(3038),
    [anon_sym_sample] = ACTIONS(3038),
    [anon_sym_linear] = ACTIONS(3038),
    [anon_sym_snorm] = ACTIONS(3038),
    [anon_sym_unorm] = ACTIONS(3038),
    [anon_sym_point] = ACTIONS(3038),
    [anon_sym_line] = ACTIONS(3038),
    [anon_sym_triangleadj] = ACTIONS(3038),
    [anon_sym_lineadj] = ACTIONS(3038),
    [anon_sym_triangle] = ACTIONS(3038),
    [anon_sym_interface] = ACTIONS(3038),
    [anon_sym_extension] = ACTIONS(3038),
    [anon_sym___init] = ACTIONS(3038),
    [anon_sym___subscript] = ACTIONS(3038),
    [anon_sym_property] = ACTIONS(3038),
    [anon_sym_associatedtype] = ACTIONS(3038),
  },
  [2298] = {
    [sym_expression] = STATE(5207),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2299] = {
    [sym__declaration_modifiers] = STATE(2777),
    [sym_attribute_specifier] = STATE(2777),
    [sym_attribute_declaration] = STATE(2777),
    [sym_ms_declspec_modifier] = STATE(2777),
    [sym_storage_class_specifier] = STATE(2777),
    [sym_type_qualifier] = STATE(2777),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2688),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8090),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2777),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2777),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(5014),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(6086),
    [anon_sym_out] = ACTIONS(6086),
    [anon_sym_inout] = ACTIONS(6086),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(5024),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2299),
    [anon_sym_class] = ACTIONS(2301),
    [anon_sym_struct] = ACTIONS(2303),
    [anon_sym_union] = ACTIONS(2305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(6086),
    [anon_sym_typename] = ACTIONS(2329),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2341),
    [anon_sym_extension] = ACTIONS(2343),
  },
  [2300] = {
    [sym_expression] = STATE(5142),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2301] = {
    [sym_expression] = STATE(4874),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4905),
    [sym_concatenated_string] = STATE(4902),
    [sym_string_literal] = STATE(3611),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3610),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(5705),
    [anon_sym_LPAREN2] = ACTIONS(5834),
    [anon_sym_BANG] = ACTIONS(4926),
    [anon_sym_TILDE] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4928),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4924),
    [anon_sym_compl] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(5707),
    [anon_sym_PLUS_PLUS] = ACTIONS(5707),
    [anon_sym_sizeof] = ACTIONS(4932),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4934),
    [anon_sym_L_SQUOTE] = ACTIONS(4936),
    [anon_sym_u_SQUOTE] = ACTIONS(4936),
    [anon_sym_U_SQUOTE] = ACTIONS(4936),
    [anon_sym_u8_SQUOTE] = ACTIONS(4936),
    [anon_sym_SQUOTE] = ACTIONS(4936),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4938),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_co_await] = ACTIONS(4940),
    [anon_sym_new] = ACTIONS(4942),
    [anon_sym_requires] = ACTIONS(4944),
    [sym_this] = ACTIONS(241),
  },
  [2302] = {
    [sym_identifier] = ACTIONS(3038),
    [aux_sym_preproc_def_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token2] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3038),
    [sym_preproc_directive] = ACTIONS(3038),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3038),
    [anon_sym___extension__] = ACTIONS(3038),
    [anon_sym_typedef] = ACTIONS(3038),
    [anon_sym_in] = ACTIONS(3038),
    [anon_sym_out] = ACTIONS(3038),
    [anon_sym_inout] = ACTIONS(3038),
    [anon_sym_extern] = ACTIONS(3038),
    [anon_sym___attribute__] = ACTIONS(3038),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3040),
    [anon_sym___declspec] = ACTIONS(3038),
    [anon_sym___based] = ACTIONS(3038),
    [anon_sym_signed] = ACTIONS(3038),
    [anon_sym_unsigned] = ACTIONS(3038),
    [anon_sym_long] = ACTIONS(3038),
    [anon_sym_short] = ACTIONS(3038),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_static] = ACTIONS(3038),
    [anon_sym_register] = ACTIONS(3038),
    [anon_sym_inline] = ACTIONS(3038),
    [anon_sym___inline] = ACTIONS(3038),
    [anon_sym___inline__] = ACTIONS(3038),
    [anon_sym___forceinline] = ACTIONS(3038),
    [anon_sym_thread_local] = ACTIONS(3038),
    [anon_sym___thread] = ACTIONS(3038),
    [anon_sym_const] = ACTIONS(3038),
    [anon_sym_constexpr] = ACTIONS(3038),
    [anon_sym_volatile] = ACTIONS(3038),
    [anon_sym_restrict] = ACTIONS(3038),
    [anon_sym___restrict__] = ACTIONS(3038),
    [anon_sym__Atomic] = ACTIONS(3038),
    [anon_sym__Noreturn] = ACTIONS(3038),
    [anon_sym_noreturn] = ACTIONS(3038),
    [anon_sym_mutable] = ACTIONS(3038),
    [anon_sym_constinit] = ACTIONS(3038),
    [anon_sym_consteval] = ACTIONS(3038),
    [anon_sym_alignas] = ACTIONS(3038),
    [anon_sym__Alignas] = ACTIONS(3038),
    [sym_primitive_type] = ACTIONS(3038),
    [anon_sym_enum] = ACTIONS(3038),
    [anon_sym_class] = ACTIONS(3038),
    [anon_sym_struct] = ACTIONS(3038),
    [anon_sym_union] = ACTIONS(3038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3038),
    [anon_sym_let] = ACTIONS(3038),
    [anon_sym_This] = ACTIONS(3038),
    [anon_sym_decltype] = ACTIONS(3038),
    [sym_virtual] = ACTIONS(3038),
    [anon_sym_explicit] = ACTIONS(3038),
    [anon_sym_typename] = ACTIONS(3038),
    [anon_sym_template] = ACTIONS(3038),
    [anon_sym_operator] = ACTIONS(3038),
    [anon_sym_friend] = ACTIONS(3038),
    [anon_sym_public] = ACTIONS(3038),
    [anon_sym_private] = ACTIONS(3038),
    [anon_sym_protected] = ACTIONS(3038),
    [anon_sym_using] = ACTIONS(3038),
    [anon_sym_static_assert] = ACTIONS(3038),
    [anon_sym_precise] = ACTIONS(3038),
    [anon_sym_shared] = ACTIONS(3038),
    [anon_sym_groupshared] = ACTIONS(3038),
    [anon_sym_uniform] = ACTIONS(3038),
    [anon_sym_row_major] = ACTIONS(3038),
    [anon_sym_column_major] = ACTIONS(3038),
    [anon_sym_globallycoherent] = ACTIONS(3038),
    [anon_sym_centroid] = ACTIONS(3038),
    [anon_sym_noperspective] = ACTIONS(3038),
    [anon_sym_nointerpolation] = ACTIONS(3038),
    [anon_sym_sample] = ACTIONS(3038),
    [anon_sym_linear] = ACTIONS(3038),
    [anon_sym_snorm] = ACTIONS(3038),
    [anon_sym_unorm] = ACTIONS(3038),
    [anon_sym_point] = ACTIONS(3038),
    [anon_sym_line] = ACTIONS(3038),
    [anon_sym_triangleadj] = ACTIONS(3038),
    [anon_sym_lineadj] = ACTIONS(3038),
    [anon_sym_triangle] = ACTIONS(3038),
    [anon_sym_interface] = ACTIONS(3038),
    [anon_sym_extension] = ACTIONS(3038),
    [anon_sym___init] = ACTIONS(3038),
    [anon_sym___subscript] = ACTIONS(3038),
    [anon_sym_property] = ACTIONS(3038),
    [anon_sym_associatedtype] = ACTIONS(3038),
  },
  [2303] = {
    [sym_identifier] = ACTIONS(3038),
    [aux_sym_preproc_def_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token2] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3038),
    [sym_preproc_directive] = ACTIONS(3038),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3038),
    [anon_sym___extension__] = ACTIONS(3038),
    [anon_sym_typedef] = ACTIONS(3038),
    [anon_sym_in] = ACTIONS(3038),
    [anon_sym_out] = ACTIONS(3038),
    [anon_sym_inout] = ACTIONS(3038),
    [anon_sym_extern] = ACTIONS(3038),
    [anon_sym___attribute__] = ACTIONS(3038),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3040),
    [anon_sym___declspec] = ACTIONS(3038),
    [anon_sym___based] = ACTIONS(3038),
    [anon_sym_signed] = ACTIONS(3038),
    [anon_sym_unsigned] = ACTIONS(3038),
    [anon_sym_long] = ACTIONS(3038),
    [anon_sym_short] = ACTIONS(3038),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_static] = ACTIONS(3038),
    [anon_sym_register] = ACTIONS(3038),
    [anon_sym_inline] = ACTIONS(3038),
    [anon_sym___inline] = ACTIONS(3038),
    [anon_sym___inline__] = ACTIONS(3038),
    [anon_sym___forceinline] = ACTIONS(3038),
    [anon_sym_thread_local] = ACTIONS(3038),
    [anon_sym___thread] = ACTIONS(3038),
    [anon_sym_const] = ACTIONS(3038),
    [anon_sym_constexpr] = ACTIONS(3038),
    [anon_sym_volatile] = ACTIONS(3038),
    [anon_sym_restrict] = ACTIONS(3038),
    [anon_sym___restrict__] = ACTIONS(3038),
    [anon_sym__Atomic] = ACTIONS(3038),
    [anon_sym__Noreturn] = ACTIONS(3038),
    [anon_sym_noreturn] = ACTIONS(3038),
    [anon_sym_mutable] = ACTIONS(3038),
    [anon_sym_constinit] = ACTIONS(3038),
    [anon_sym_consteval] = ACTIONS(3038),
    [anon_sym_alignas] = ACTIONS(3038),
    [anon_sym__Alignas] = ACTIONS(3038),
    [sym_primitive_type] = ACTIONS(3038),
    [anon_sym_enum] = ACTIONS(3038),
    [anon_sym_class] = ACTIONS(3038),
    [anon_sym_struct] = ACTIONS(3038),
    [anon_sym_union] = ACTIONS(3038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3038),
    [anon_sym_let] = ACTIONS(3038),
    [anon_sym_This] = ACTIONS(3038),
    [anon_sym_decltype] = ACTIONS(3038),
    [sym_virtual] = ACTIONS(3038),
    [anon_sym_explicit] = ACTIONS(3038),
    [anon_sym_typename] = ACTIONS(3038),
    [anon_sym_template] = ACTIONS(3038),
    [anon_sym_operator] = ACTIONS(3038),
    [anon_sym_friend] = ACTIONS(3038),
    [anon_sym_public] = ACTIONS(3038),
    [anon_sym_private] = ACTIONS(3038),
    [anon_sym_protected] = ACTIONS(3038),
    [anon_sym_using] = ACTIONS(3038),
    [anon_sym_static_assert] = ACTIONS(3038),
    [anon_sym_precise] = ACTIONS(3038),
    [anon_sym_shared] = ACTIONS(3038),
    [anon_sym_groupshared] = ACTIONS(3038),
    [anon_sym_uniform] = ACTIONS(3038),
    [anon_sym_row_major] = ACTIONS(3038),
    [anon_sym_column_major] = ACTIONS(3038),
    [anon_sym_globallycoherent] = ACTIONS(3038),
    [anon_sym_centroid] = ACTIONS(3038),
    [anon_sym_noperspective] = ACTIONS(3038),
    [anon_sym_nointerpolation] = ACTIONS(3038),
    [anon_sym_sample] = ACTIONS(3038),
    [anon_sym_linear] = ACTIONS(3038),
    [anon_sym_snorm] = ACTIONS(3038),
    [anon_sym_unorm] = ACTIONS(3038),
    [anon_sym_point] = ACTIONS(3038),
    [anon_sym_line] = ACTIONS(3038),
    [anon_sym_triangleadj] = ACTIONS(3038),
    [anon_sym_lineadj] = ACTIONS(3038),
    [anon_sym_triangle] = ACTIONS(3038),
    [anon_sym_interface] = ACTIONS(3038),
    [anon_sym_extension] = ACTIONS(3038),
    [anon_sym___init] = ACTIONS(3038),
    [anon_sym___subscript] = ACTIONS(3038),
    [anon_sym_property] = ACTIONS(3038),
    [anon_sym_associatedtype] = ACTIONS(3038),
  },
  [2304] = {
    [sym_expression] = STATE(5545),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2305] = {
    [sym_expression] = STATE(5587),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2306] = {
    [sym_identifier] = ACTIONS(3475),
    [aux_sym_preproc_def_token1] = ACTIONS(3475),
    [aux_sym_preproc_if_token1] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3475),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3475),
    [sym_preproc_directive] = ACTIONS(3475),
    [anon_sym_LPAREN2] = ACTIONS(3477),
    [anon_sym_TILDE] = ACTIONS(3477),
    [anon_sym_STAR] = ACTIONS(3477),
    [anon_sym_AMP_AMP] = ACTIONS(3477),
    [anon_sym_AMP] = ACTIONS(3475),
    [anon_sym___extension__] = ACTIONS(3475),
    [anon_sym_typedef] = ACTIONS(3475),
    [anon_sym_in] = ACTIONS(3475),
    [anon_sym_out] = ACTIONS(3475),
    [anon_sym_inout] = ACTIONS(3475),
    [anon_sym_extern] = ACTIONS(3475),
    [anon_sym___attribute__] = ACTIONS(3475),
    [anon_sym_COLON_COLON] = ACTIONS(3477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3477),
    [anon_sym___declspec] = ACTIONS(3475),
    [anon_sym___based] = ACTIONS(3475),
    [anon_sym_RBRACE] = ACTIONS(3477),
    [anon_sym_signed] = ACTIONS(3475),
    [anon_sym_unsigned] = ACTIONS(3475),
    [anon_sym_long] = ACTIONS(3475),
    [anon_sym_short] = ACTIONS(3475),
    [anon_sym_LBRACK] = ACTIONS(3475),
    [anon_sym_static] = ACTIONS(3475),
    [anon_sym_register] = ACTIONS(3475),
    [anon_sym_inline] = ACTIONS(3475),
    [anon_sym___inline] = ACTIONS(3475),
    [anon_sym___inline__] = ACTIONS(3475),
    [anon_sym___forceinline] = ACTIONS(3475),
    [anon_sym_thread_local] = ACTIONS(3475),
    [anon_sym___thread] = ACTIONS(3475),
    [anon_sym_const] = ACTIONS(3475),
    [anon_sym_constexpr] = ACTIONS(3475),
    [anon_sym_volatile] = ACTIONS(3475),
    [anon_sym_restrict] = ACTIONS(3475),
    [anon_sym___restrict__] = ACTIONS(3475),
    [anon_sym__Atomic] = ACTIONS(3475),
    [anon_sym__Noreturn] = ACTIONS(3475),
    [anon_sym_noreturn] = ACTIONS(3475),
    [anon_sym_mutable] = ACTIONS(3475),
    [anon_sym_constinit] = ACTIONS(3475),
    [anon_sym_consteval] = ACTIONS(3475),
    [anon_sym_alignas] = ACTIONS(3475),
    [anon_sym__Alignas] = ACTIONS(3475),
    [sym_primitive_type] = ACTIONS(3475),
    [anon_sym_enum] = ACTIONS(3475),
    [anon_sym_class] = ACTIONS(3475),
    [anon_sym_struct] = ACTIONS(3475),
    [anon_sym_union] = ACTIONS(3475),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3475),
    [anon_sym_let] = ACTIONS(3475),
    [anon_sym_This] = ACTIONS(3475),
    [anon_sym_decltype] = ACTIONS(3475),
    [sym_virtual] = ACTIONS(3475),
    [anon_sym_explicit] = ACTIONS(3475),
    [anon_sym_typename] = ACTIONS(3475),
    [anon_sym_template] = ACTIONS(3475),
    [anon_sym_operator] = ACTIONS(3475),
    [anon_sym_friend] = ACTIONS(3475),
    [anon_sym_public] = ACTIONS(3475),
    [anon_sym_private] = ACTIONS(3475),
    [anon_sym_protected] = ACTIONS(3475),
    [anon_sym_using] = ACTIONS(3475),
    [anon_sym_static_assert] = ACTIONS(3475),
    [anon_sym_precise] = ACTIONS(3475),
    [anon_sym_shared] = ACTIONS(3475),
    [anon_sym_groupshared] = ACTIONS(3475),
    [anon_sym_uniform] = ACTIONS(3475),
    [anon_sym_row_major] = ACTIONS(3475),
    [anon_sym_column_major] = ACTIONS(3475),
    [anon_sym_globallycoherent] = ACTIONS(3475),
    [anon_sym_centroid] = ACTIONS(3475),
    [anon_sym_noperspective] = ACTIONS(3475),
    [anon_sym_nointerpolation] = ACTIONS(3475),
    [anon_sym_sample] = ACTIONS(3475),
    [anon_sym_linear] = ACTIONS(3475),
    [anon_sym_snorm] = ACTIONS(3475),
    [anon_sym_unorm] = ACTIONS(3475),
    [anon_sym_point] = ACTIONS(3475),
    [anon_sym_line] = ACTIONS(3475),
    [anon_sym_triangleadj] = ACTIONS(3475),
    [anon_sym_lineadj] = ACTIONS(3475),
    [anon_sym_triangle] = ACTIONS(3475),
    [anon_sym_interface] = ACTIONS(3475),
    [anon_sym_extension] = ACTIONS(3475),
    [anon_sym___init] = ACTIONS(3475),
    [anon_sym___subscript] = ACTIONS(3475),
    [anon_sym_property] = ACTIONS(3475),
    [anon_sym_associatedtype] = ACTIONS(3475),
  },
  [2307] = {
    [sym_expression] = STATE(5170),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4958),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4964),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2308] = {
    [sym_identifier] = ACTIONS(5598),
    [aux_sym_preproc_def_token1] = ACTIONS(5598),
    [aux_sym_preproc_if_token1] = ACTIONS(5598),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5598),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5598),
    [sym_preproc_directive] = ACTIONS(5598),
    [anon_sym_LPAREN2] = ACTIONS(5600),
    [anon_sym_TILDE] = ACTIONS(5600),
    [anon_sym_STAR] = ACTIONS(5600),
    [anon_sym_AMP_AMP] = ACTIONS(5600),
    [anon_sym_AMP] = ACTIONS(5598),
    [anon_sym___extension__] = ACTIONS(5598),
    [anon_sym_typedef] = ACTIONS(5598),
    [anon_sym_in] = ACTIONS(5598),
    [anon_sym_out] = ACTIONS(5598),
    [anon_sym_inout] = ACTIONS(5598),
    [anon_sym_extern] = ACTIONS(5598),
    [anon_sym___attribute__] = ACTIONS(5598),
    [anon_sym_COLON_COLON] = ACTIONS(5600),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5600),
    [anon_sym___declspec] = ACTIONS(5598),
    [anon_sym___based] = ACTIONS(5598),
    [anon_sym_RBRACE] = ACTIONS(5600),
    [anon_sym_signed] = ACTIONS(5598),
    [anon_sym_unsigned] = ACTIONS(5598),
    [anon_sym_long] = ACTIONS(5598),
    [anon_sym_short] = ACTIONS(5598),
    [anon_sym_LBRACK] = ACTIONS(5598),
    [anon_sym_static] = ACTIONS(5598),
    [anon_sym_register] = ACTIONS(5598),
    [anon_sym_inline] = ACTIONS(5598),
    [anon_sym___inline] = ACTIONS(5598),
    [anon_sym___inline__] = ACTIONS(5598),
    [anon_sym___forceinline] = ACTIONS(5598),
    [anon_sym_thread_local] = ACTIONS(5598),
    [anon_sym___thread] = ACTIONS(5598),
    [anon_sym_const] = ACTIONS(5598),
    [anon_sym_constexpr] = ACTIONS(5598),
    [anon_sym_volatile] = ACTIONS(5598),
    [anon_sym_restrict] = ACTIONS(5598),
    [anon_sym___restrict__] = ACTIONS(5598),
    [anon_sym__Atomic] = ACTIONS(5598),
    [anon_sym__Noreturn] = ACTIONS(5598),
    [anon_sym_noreturn] = ACTIONS(5598),
    [anon_sym_mutable] = ACTIONS(5598),
    [anon_sym_constinit] = ACTIONS(5598),
    [anon_sym_consteval] = ACTIONS(5598),
    [anon_sym_alignas] = ACTIONS(5598),
    [anon_sym__Alignas] = ACTIONS(5598),
    [sym_primitive_type] = ACTIONS(5598),
    [anon_sym_enum] = ACTIONS(5598),
    [anon_sym_class] = ACTIONS(5598),
    [anon_sym_struct] = ACTIONS(5598),
    [anon_sym_union] = ACTIONS(5598),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5598),
    [anon_sym_let] = ACTIONS(5598),
    [anon_sym_This] = ACTIONS(5598),
    [anon_sym_decltype] = ACTIONS(5598),
    [sym_virtual] = ACTIONS(5598),
    [anon_sym_explicit] = ACTIONS(5598),
    [anon_sym_typename] = ACTIONS(5598),
    [anon_sym_template] = ACTIONS(5598),
    [anon_sym_operator] = ACTIONS(5598),
    [anon_sym_friend] = ACTIONS(5598),
    [anon_sym_public] = ACTIONS(5598),
    [anon_sym_private] = ACTIONS(5598),
    [anon_sym_protected] = ACTIONS(5598),
    [anon_sym_using] = ACTIONS(5598),
    [anon_sym_static_assert] = ACTIONS(5598),
    [anon_sym_precise] = ACTIONS(5598),
    [anon_sym_shared] = ACTIONS(5598),
    [anon_sym_groupshared] = ACTIONS(5598),
    [anon_sym_uniform] = ACTIONS(5598),
    [anon_sym_row_major] = ACTIONS(5598),
    [anon_sym_column_major] = ACTIONS(5598),
    [anon_sym_globallycoherent] = ACTIONS(5598),
    [anon_sym_centroid] = ACTIONS(5598),
    [anon_sym_noperspective] = ACTIONS(5598),
    [anon_sym_nointerpolation] = ACTIONS(5598),
    [anon_sym_sample] = ACTIONS(5598),
    [anon_sym_linear] = ACTIONS(5598),
    [anon_sym_snorm] = ACTIONS(5598),
    [anon_sym_unorm] = ACTIONS(5598),
    [anon_sym_point] = ACTIONS(5598),
    [anon_sym_line] = ACTIONS(5598),
    [anon_sym_triangleadj] = ACTIONS(5598),
    [anon_sym_lineadj] = ACTIONS(5598),
    [anon_sym_triangle] = ACTIONS(5598),
    [anon_sym_interface] = ACTIONS(5598),
    [anon_sym_extension] = ACTIONS(5598),
    [anon_sym___init] = ACTIONS(5598),
    [anon_sym___subscript] = ACTIONS(5598),
    [anon_sym_property] = ACTIONS(5598),
    [anon_sym_associatedtype] = ACTIONS(5598),
  },
  [2309] = {
    [sym_expression] = STATE(5408),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2310] = {
    [sym_expression] = STATE(5172),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4958),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4964),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2311] = {
    [sym_expression] = STATE(5283),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2312] = {
    [sym_expression] = STATE(4677),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2313] = {
    [sym_expression] = STATE(3592),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2314] = {
    [sym_expression] = STATE(3750),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [2315] = {
    [sym_expression] = STATE(3747),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [2316] = {
    [sym_expression] = STATE(3746),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [2317] = {
    [sym_identifier] = ACTIONS(5598),
    [aux_sym_preproc_def_token1] = ACTIONS(5598),
    [aux_sym_preproc_if_token1] = ACTIONS(5598),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5598),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5598),
    [sym_preproc_directive] = ACTIONS(5598),
    [anon_sym_LPAREN2] = ACTIONS(5600),
    [anon_sym_TILDE] = ACTIONS(5600),
    [anon_sym_STAR] = ACTIONS(5600),
    [anon_sym_AMP_AMP] = ACTIONS(5600),
    [anon_sym_AMP] = ACTIONS(5598),
    [anon_sym___extension__] = ACTIONS(5598),
    [anon_sym_typedef] = ACTIONS(5598),
    [anon_sym_in] = ACTIONS(5598),
    [anon_sym_out] = ACTIONS(5598),
    [anon_sym_inout] = ACTIONS(5598),
    [anon_sym_extern] = ACTIONS(5598),
    [anon_sym___attribute__] = ACTIONS(5598),
    [anon_sym_COLON_COLON] = ACTIONS(5600),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5600),
    [anon_sym___declspec] = ACTIONS(5598),
    [anon_sym___based] = ACTIONS(5598),
    [anon_sym_RBRACE] = ACTIONS(5600),
    [anon_sym_signed] = ACTIONS(5598),
    [anon_sym_unsigned] = ACTIONS(5598),
    [anon_sym_long] = ACTIONS(5598),
    [anon_sym_short] = ACTIONS(5598),
    [anon_sym_LBRACK] = ACTIONS(5598),
    [anon_sym_static] = ACTIONS(5598),
    [anon_sym_register] = ACTIONS(5598),
    [anon_sym_inline] = ACTIONS(5598),
    [anon_sym___inline] = ACTIONS(5598),
    [anon_sym___inline__] = ACTIONS(5598),
    [anon_sym___forceinline] = ACTIONS(5598),
    [anon_sym_thread_local] = ACTIONS(5598),
    [anon_sym___thread] = ACTIONS(5598),
    [anon_sym_const] = ACTIONS(5598),
    [anon_sym_constexpr] = ACTIONS(5598),
    [anon_sym_volatile] = ACTIONS(5598),
    [anon_sym_restrict] = ACTIONS(5598),
    [anon_sym___restrict__] = ACTIONS(5598),
    [anon_sym__Atomic] = ACTIONS(5598),
    [anon_sym__Noreturn] = ACTIONS(5598),
    [anon_sym_noreturn] = ACTIONS(5598),
    [anon_sym_mutable] = ACTIONS(5598),
    [anon_sym_constinit] = ACTIONS(5598),
    [anon_sym_consteval] = ACTIONS(5598),
    [anon_sym_alignas] = ACTIONS(5598),
    [anon_sym__Alignas] = ACTIONS(5598),
    [sym_primitive_type] = ACTIONS(5598),
    [anon_sym_enum] = ACTIONS(5598),
    [anon_sym_class] = ACTIONS(5598),
    [anon_sym_struct] = ACTIONS(5598),
    [anon_sym_union] = ACTIONS(5598),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5598),
    [anon_sym_let] = ACTIONS(5598),
    [anon_sym_This] = ACTIONS(5598),
    [anon_sym_decltype] = ACTIONS(5598),
    [sym_virtual] = ACTIONS(5598),
    [anon_sym_explicit] = ACTIONS(5598),
    [anon_sym_typename] = ACTIONS(5598),
    [anon_sym_template] = ACTIONS(5598),
    [anon_sym_operator] = ACTIONS(5598),
    [anon_sym_friend] = ACTIONS(5598),
    [anon_sym_public] = ACTIONS(5598),
    [anon_sym_private] = ACTIONS(5598),
    [anon_sym_protected] = ACTIONS(5598),
    [anon_sym_using] = ACTIONS(5598),
    [anon_sym_static_assert] = ACTIONS(5598),
    [anon_sym_precise] = ACTIONS(5598),
    [anon_sym_shared] = ACTIONS(5598),
    [anon_sym_groupshared] = ACTIONS(5598),
    [anon_sym_uniform] = ACTIONS(5598),
    [anon_sym_row_major] = ACTIONS(5598),
    [anon_sym_column_major] = ACTIONS(5598),
    [anon_sym_globallycoherent] = ACTIONS(5598),
    [anon_sym_centroid] = ACTIONS(5598),
    [anon_sym_noperspective] = ACTIONS(5598),
    [anon_sym_nointerpolation] = ACTIONS(5598),
    [anon_sym_sample] = ACTIONS(5598),
    [anon_sym_linear] = ACTIONS(5598),
    [anon_sym_snorm] = ACTIONS(5598),
    [anon_sym_unorm] = ACTIONS(5598),
    [anon_sym_point] = ACTIONS(5598),
    [anon_sym_line] = ACTIONS(5598),
    [anon_sym_triangleadj] = ACTIONS(5598),
    [anon_sym_lineadj] = ACTIONS(5598),
    [anon_sym_triangle] = ACTIONS(5598),
    [anon_sym_interface] = ACTIONS(5598),
    [anon_sym_extension] = ACTIONS(5598),
    [anon_sym___init] = ACTIONS(5598),
    [anon_sym___subscript] = ACTIONS(5598),
    [anon_sym_property] = ACTIONS(5598),
    [anon_sym_associatedtype] = ACTIONS(5598),
  },
  [2318] = {
    [sym_expression] = STATE(3745),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [2319] = {
    [sym_expression] = STATE(5175),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4958),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4964),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2320] = {
    [sym_expression] = STATE(5409),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2321] = {
    [sym_expression] = STATE(3743),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [2322] = {
    [sym_identifier] = ACTIONS(3844),
    [anon_sym_COMMA] = ACTIONS(3846),
    [anon_sym_RPAREN] = ACTIONS(3846),
    [anon_sym_LPAREN2] = ACTIONS(3846),
    [anon_sym_TILDE] = ACTIONS(3846),
    [anon_sym_STAR] = ACTIONS(3846),
    [anon_sym_AMP_AMP] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3844),
    [anon_sym_SEMI] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(3844),
    [anon_sym_in] = ACTIONS(3844),
    [anon_sym_out] = ACTIONS(3844),
    [anon_sym_inout] = ACTIONS(3844),
    [anon_sym_extern] = ACTIONS(3844),
    [anon_sym___attribute__] = ACTIONS(3844),
    [anon_sym_COLON_COLON] = ACTIONS(3846),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3846),
    [anon_sym___declspec] = ACTIONS(3844),
    [anon_sym___based] = ACTIONS(3844),
    [anon_sym_LBRACE] = ACTIONS(3846),
    [anon_sym_signed] = ACTIONS(3844),
    [anon_sym_unsigned] = ACTIONS(3844),
    [anon_sym_long] = ACTIONS(3844),
    [anon_sym_short] = ACTIONS(3844),
    [anon_sym_LBRACK] = ACTIONS(3844),
    [anon_sym_static] = ACTIONS(3844),
    [anon_sym_EQ] = ACTIONS(3846),
    [anon_sym_register] = ACTIONS(3844),
    [anon_sym_inline] = ACTIONS(3844),
    [anon_sym___inline] = ACTIONS(3844),
    [anon_sym___inline__] = ACTIONS(3844),
    [anon_sym___forceinline] = ACTIONS(3844),
    [anon_sym_thread_local] = ACTIONS(3844),
    [anon_sym___thread] = ACTIONS(3844),
    [anon_sym_const] = ACTIONS(3844),
    [anon_sym_constexpr] = ACTIONS(3844),
    [anon_sym_volatile] = ACTIONS(3844),
    [anon_sym_restrict] = ACTIONS(3844),
    [anon_sym___restrict__] = ACTIONS(3844),
    [anon_sym__Atomic] = ACTIONS(3844),
    [anon_sym__Noreturn] = ACTIONS(3844),
    [anon_sym_noreturn] = ACTIONS(3844),
    [anon_sym_mutable] = ACTIONS(3844),
    [anon_sym_constinit] = ACTIONS(3844),
    [anon_sym_consteval] = ACTIONS(3844),
    [anon_sym_alignas] = ACTIONS(3844),
    [anon_sym__Alignas] = ACTIONS(3844),
    [sym_primitive_type] = ACTIONS(3844),
    [anon_sym_enum] = ACTIONS(3844),
    [anon_sym_class] = ACTIONS(3844),
    [anon_sym_struct] = ACTIONS(3844),
    [anon_sym_union] = ACTIONS(3844),
    [anon_sym_asm] = ACTIONS(3844),
    [anon_sym___asm__] = ACTIONS(3844),
    [anon_sym_DOT] = ACTIONS(3846),
    [anon_sym_DASH_GT] = ACTIONS(3846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3844),
    [anon_sym_let] = ACTIONS(3844),
    [anon_sym_This] = ACTIONS(3844),
    [anon_sym_decltype] = ACTIONS(3844),
    [anon_sym_final] = ACTIONS(3844),
    [anon_sym_override] = ACTIONS(3844),
    [sym_virtual] = ACTIONS(3844),
    [anon_sym_explicit] = ACTIONS(3844),
    [anon_sym_typename] = ACTIONS(3844),
    [anon_sym_template] = ACTIONS(3844),
    [anon_sym_GT2] = ACTIONS(3846),
    [anon_sym_operator] = ACTIONS(3844),
    [anon_sym_try] = ACTIONS(3844),
    [anon_sym_noexcept] = ACTIONS(3844),
    [anon_sym_throw] = ACTIONS(3844),
    [anon_sym_requires] = ACTIONS(3844),
    [anon_sym_precise] = ACTIONS(3844),
    [anon_sym_shared] = ACTIONS(3844),
    [anon_sym_groupshared] = ACTIONS(3844),
    [anon_sym_uniform] = ACTIONS(3844),
    [anon_sym_row_major] = ACTIONS(3844),
    [anon_sym_column_major] = ACTIONS(3844),
    [anon_sym_globallycoherent] = ACTIONS(3844),
    [anon_sym_centroid] = ACTIONS(3844),
    [anon_sym_noperspective] = ACTIONS(3844),
    [anon_sym_nointerpolation] = ACTIONS(3844),
    [anon_sym_sample] = ACTIONS(3844),
    [anon_sym_linear] = ACTIONS(3844),
    [anon_sym_snorm] = ACTIONS(3844),
    [anon_sym_unorm] = ACTIONS(3844),
    [anon_sym_point] = ACTIONS(3844),
    [anon_sym_line] = ACTIONS(3844),
    [anon_sym_triangleadj] = ACTIONS(3844),
    [anon_sym_lineadj] = ACTIONS(3844),
    [anon_sym_triangle] = ACTIONS(3844),
    [anon_sym_interface] = ACTIONS(3844),
    [anon_sym_extension] = ACTIONS(3844),
    [anon_sym_where] = ACTIONS(3844),
  },
  [2323] = {
    [sym_expression] = STATE(5410),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2324] = {
    [sym_expression] = STATE(5619),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2325] = {
    [sym_expression] = STATE(5411),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2326] = {
    [sym_expression] = STATE(5415),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2327] = {
    [sym_expression] = STATE(5417),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2328] = {
    [sym_expression] = STATE(4532),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [2329] = {
    [sym_expression] = STATE(4560),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [2330] = {
    [sym_expression] = STATE(4592),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2331] = {
    [sym_expression] = STATE(5418),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2332] = {
    [sym_expression] = STATE(5420),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2333] = {
    [sym_expression] = STATE(5421),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2334] = {
    [sym_expression] = STATE(5412),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(6108),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2335] = {
    [sym_expression] = STATE(3742),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [2336] = {
    [sym_expression] = STATE(5455),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2337] = {
    [sym_identifier] = ACTIONS(3539),
    [aux_sym_preproc_def_token1] = ACTIONS(3539),
    [aux_sym_preproc_if_token1] = ACTIONS(3539),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3539),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3539),
    [sym_preproc_directive] = ACTIONS(3539),
    [anon_sym_LPAREN2] = ACTIONS(3541),
    [anon_sym_TILDE] = ACTIONS(3541),
    [anon_sym_STAR] = ACTIONS(3541),
    [anon_sym_AMP_AMP] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym___extension__] = ACTIONS(3539),
    [anon_sym_typedef] = ACTIONS(3539),
    [anon_sym_in] = ACTIONS(3539),
    [anon_sym_out] = ACTIONS(3539),
    [anon_sym_inout] = ACTIONS(3539),
    [anon_sym_extern] = ACTIONS(3539),
    [anon_sym___attribute__] = ACTIONS(3539),
    [anon_sym_COLON_COLON] = ACTIONS(3541),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3541),
    [anon_sym___declspec] = ACTIONS(3539),
    [anon_sym___based] = ACTIONS(3539),
    [anon_sym_RBRACE] = ACTIONS(3541),
    [anon_sym_signed] = ACTIONS(3539),
    [anon_sym_unsigned] = ACTIONS(3539),
    [anon_sym_long] = ACTIONS(3539),
    [anon_sym_short] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_static] = ACTIONS(3539),
    [anon_sym_register] = ACTIONS(3539),
    [anon_sym_inline] = ACTIONS(3539),
    [anon_sym___inline] = ACTIONS(3539),
    [anon_sym___inline__] = ACTIONS(3539),
    [anon_sym___forceinline] = ACTIONS(3539),
    [anon_sym_thread_local] = ACTIONS(3539),
    [anon_sym___thread] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3539),
    [anon_sym_constexpr] = ACTIONS(3539),
    [anon_sym_volatile] = ACTIONS(3539),
    [anon_sym_restrict] = ACTIONS(3539),
    [anon_sym___restrict__] = ACTIONS(3539),
    [anon_sym__Atomic] = ACTIONS(3539),
    [anon_sym__Noreturn] = ACTIONS(3539),
    [anon_sym_noreturn] = ACTIONS(3539),
    [anon_sym_mutable] = ACTIONS(3539),
    [anon_sym_constinit] = ACTIONS(3539),
    [anon_sym_consteval] = ACTIONS(3539),
    [anon_sym_alignas] = ACTIONS(3539),
    [anon_sym__Alignas] = ACTIONS(3539),
    [sym_primitive_type] = ACTIONS(3539),
    [anon_sym_enum] = ACTIONS(3539),
    [anon_sym_class] = ACTIONS(3539),
    [anon_sym_struct] = ACTIONS(3539),
    [anon_sym_union] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_This] = ACTIONS(3539),
    [anon_sym_decltype] = ACTIONS(3539),
    [sym_virtual] = ACTIONS(3539),
    [anon_sym_explicit] = ACTIONS(3539),
    [anon_sym_typename] = ACTIONS(3539),
    [anon_sym_template] = ACTIONS(3539),
    [anon_sym_operator] = ACTIONS(3539),
    [anon_sym_friend] = ACTIONS(3539),
    [anon_sym_public] = ACTIONS(3539),
    [anon_sym_private] = ACTIONS(3539),
    [anon_sym_protected] = ACTIONS(3539),
    [anon_sym_using] = ACTIONS(3539),
    [anon_sym_static_assert] = ACTIONS(3539),
    [anon_sym_precise] = ACTIONS(3539),
    [anon_sym_shared] = ACTIONS(3539),
    [anon_sym_groupshared] = ACTIONS(3539),
    [anon_sym_uniform] = ACTIONS(3539),
    [anon_sym_row_major] = ACTIONS(3539),
    [anon_sym_column_major] = ACTIONS(3539),
    [anon_sym_globallycoherent] = ACTIONS(3539),
    [anon_sym_centroid] = ACTIONS(3539),
    [anon_sym_noperspective] = ACTIONS(3539),
    [anon_sym_nointerpolation] = ACTIONS(3539),
    [anon_sym_sample] = ACTIONS(3539),
    [anon_sym_linear] = ACTIONS(3539),
    [anon_sym_snorm] = ACTIONS(3539),
    [anon_sym_unorm] = ACTIONS(3539),
    [anon_sym_point] = ACTIONS(3539),
    [anon_sym_line] = ACTIONS(3539),
    [anon_sym_triangleadj] = ACTIONS(3539),
    [anon_sym_lineadj] = ACTIONS(3539),
    [anon_sym_triangle] = ACTIONS(3539),
    [anon_sym_interface] = ACTIONS(3539),
    [anon_sym_extension] = ACTIONS(3539),
    [anon_sym___init] = ACTIONS(3539),
    [anon_sym___subscript] = ACTIONS(3539),
    [anon_sym_property] = ACTIONS(3539),
    [anon_sym_associatedtype] = ACTIONS(3539),
  },
  [2338] = {
    [sym_expression] = STATE(4489),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [2339] = {
    [sym_expression] = STATE(5425),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2340] = {
    [sym_expression] = STATE(5480),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2341] = {
    [sym_expression] = STATE(5390),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2342] = {
    [sym_expression] = STATE(4654),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2343] = {
    [sym_expression] = STATE(5550),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2344] = {
    [sym_expression] = STATE(3741),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [2345] = {
    [sym_expression] = STATE(3738),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [2346] = {
    [sym_expression] = STATE(3734),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [2347] = {
    [sym_expression] = STATE(4599),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2348] = {
    [sym_expression] = STATE(3726),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [2349] = {
    [sym_identifier] = ACTIONS(3505),
    [aux_sym_preproc_def_token1] = ACTIONS(3505),
    [aux_sym_preproc_if_token1] = ACTIONS(3505),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3505),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3505),
    [sym_preproc_directive] = ACTIONS(3505),
    [anon_sym_LPAREN2] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3507),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym___extension__] = ACTIONS(3505),
    [anon_sym_typedef] = ACTIONS(3505),
    [anon_sym_in] = ACTIONS(3505),
    [anon_sym_out] = ACTIONS(3505),
    [anon_sym_inout] = ACTIONS(3505),
    [anon_sym_extern] = ACTIONS(3505),
    [anon_sym___attribute__] = ACTIONS(3505),
    [anon_sym_COLON_COLON] = ACTIONS(3507),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3507),
    [anon_sym___declspec] = ACTIONS(3505),
    [anon_sym___based] = ACTIONS(3505),
    [anon_sym_RBRACE] = ACTIONS(3507),
    [anon_sym_signed] = ACTIONS(3505),
    [anon_sym_unsigned] = ACTIONS(3505),
    [anon_sym_long] = ACTIONS(3505),
    [anon_sym_short] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_static] = ACTIONS(3505),
    [anon_sym_register] = ACTIONS(3505),
    [anon_sym_inline] = ACTIONS(3505),
    [anon_sym___inline] = ACTIONS(3505),
    [anon_sym___inline__] = ACTIONS(3505),
    [anon_sym___forceinline] = ACTIONS(3505),
    [anon_sym_thread_local] = ACTIONS(3505),
    [anon_sym___thread] = ACTIONS(3505),
    [anon_sym_const] = ACTIONS(3505),
    [anon_sym_constexpr] = ACTIONS(3505),
    [anon_sym_volatile] = ACTIONS(3505),
    [anon_sym_restrict] = ACTIONS(3505),
    [anon_sym___restrict__] = ACTIONS(3505),
    [anon_sym__Atomic] = ACTIONS(3505),
    [anon_sym__Noreturn] = ACTIONS(3505),
    [anon_sym_noreturn] = ACTIONS(3505),
    [anon_sym_mutable] = ACTIONS(3505),
    [anon_sym_constinit] = ACTIONS(3505),
    [anon_sym_consteval] = ACTIONS(3505),
    [anon_sym_alignas] = ACTIONS(3505),
    [anon_sym__Alignas] = ACTIONS(3505),
    [sym_primitive_type] = ACTIONS(3505),
    [anon_sym_enum] = ACTIONS(3505),
    [anon_sym_class] = ACTIONS(3505),
    [anon_sym_struct] = ACTIONS(3505),
    [anon_sym_union] = ACTIONS(3505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_This] = ACTIONS(3505),
    [anon_sym_decltype] = ACTIONS(3505),
    [sym_virtual] = ACTIONS(3505),
    [anon_sym_explicit] = ACTIONS(3505),
    [anon_sym_typename] = ACTIONS(3505),
    [anon_sym_template] = ACTIONS(3505),
    [anon_sym_operator] = ACTIONS(3505),
    [anon_sym_friend] = ACTIONS(3505),
    [anon_sym_public] = ACTIONS(3505),
    [anon_sym_private] = ACTIONS(3505),
    [anon_sym_protected] = ACTIONS(3505),
    [anon_sym_using] = ACTIONS(3505),
    [anon_sym_static_assert] = ACTIONS(3505),
    [anon_sym_precise] = ACTIONS(3505),
    [anon_sym_shared] = ACTIONS(3505),
    [anon_sym_groupshared] = ACTIONS(3505),
    [anon_sym_uniform] = ACTIONS(3505),
    [anon_sym_row_major] = ACTIONS(3505),
    [anon_sym_column_major] = ACTIONS(3505),
    [anon_sym_globallycoherent] = ACTIONS(3505),
    [anon_sym_centroid] = ACTIONS(3505),
    [anon_sym_noperspective] = ACTIONS(3505),
    [anon_sym_nointerpolation] = ACTIONS(3505),
    [anon_sym_sample] = ACTIONS(3505),
    [anon_sym_linear] = ACTIONS(3505),
    [anon_sym_snorm] = ACTIONS(3505),
    [anon_sym_unorm] = ACTIONS(3505),
    [anon_sym_point] = ACTIONS(3505),
    [anon_sym_line] = ACTIONS(3505),
    [anon_sym_triangleadj] = ACTIONS(3505),
    [anon_sym_lineadj] = ACTIONS(3505),
    [anon_sym_triangle] = ACTIONS(3505),
    [anon_sym_interface] = ACTIONS(3505),
    [anon_sym_extension] = ACTIONS(3505),
    [anon_sym___init] = ACTIONS(3505),
    [anon_sym___subscript] = ACTIONS(3505),
    [anon_sym_property] = ACTIONS(3505),
    [anon_sym_associatedtype] = ACTIONS(3505),
  },
  [2350] = {
    [sym_expression] = STATE(5232),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2351] = {
    [sym_identifier] = ACTIONS(3555),
    [aux_sym_preproc_def_token1] = ACTIONS(3555),
    [aux_sym_preproc_if_token1] = ACTIONS(3555),
    [aux_sym_preproc_if_token2] = ACTIONS(3555),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3555),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3555),
    [sym_preproc_directive] = ACTIONS(3555),
    [anon_sym_LPAREN2] = ACTIONS(3557),
    [anon_sym_TILDE] = ACTIONS(3557),
    [anon_sym_STAR] = ACTIONS(3557),
    [anon_sym_AMP_AMP] = ACTIONS(3557),
    [anon_sym_AMP] = ACTIONS(3555),
    [anon_sym___extension__] = ACTIONS(3555),
    [anon_sym_typedef] = ACTIONS(3555),
    [anon_sym_in] = ACTIONS(3555),
    [anon_sym_out] = ACTIONS(3555),
    [anon_sym_inout] = ACTIONS(3555),
    [anon_sym_extern] = ACTIONS(3555),
    [anon_sym___attribute__] = ACTIONS(3555),
    [anon_sym_COLON_COLON] = ACTIONS(3557),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3557),
    [anon_sym___declspec] = ACTIONS(3555),
    [anon_sym___based] = ACTIONS(3555),
    [anon_sym_signed] = ACTIONS(3555),
    [anon_sym_unsigned] = ACTIONS(3555),
    [anon_sym_long] = ACTIONS(3555),
    [anon_sym_short] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3555),
    [anon_sym_static] = ACTIONS(3555),
    [anon_sym_register] = ACTIONS(3555),
    [anon_sym_inline] = ACTIONS(3555),
    [anon_sym___inline] = ACTIONS(3555),
    [anon_sym___inline__] = ACTIONS(3555),
    [anon_sym___forceinline] = ACTIONS(3555),
    [anon_sym_thread_local] = ACTIONS(3555),
    [anon_sym___thread] = ACTIONS(3555),
    [anon_sym_const] = ACTIONS(3555),
    [anon_sym_constexpr] = ACTIONS(3555),
    [anon_sym_volatile] = ACTIONS(3555),
    [anon_sym_restrict] = ACTIONS(3555),
    [anon_sym___restrict__] = ACTIONS(3555),
    [anon_sym__Atomic] = ACTIONS(3555),
    [anon_sym__Noreturn] = ACTIONS(3555),
    [anon_sym_noreturn] = ACTIONS(3555),
    [anon_sym_mutable] = ACTIONS(3555),
    [anon_sym_constinit] = ACTIONS(3555),
    [anon_sym_consteval] = ACTIONS(3555),
    [anon_sym_alignas] = ACTIONS(3555),
    [anon_sym__Alignas] = ACTIONS(3555),
    [sym_primitive_type] = ACTIONS(3555),
    [anon_sym_enum] = ACTIONS(3555),
    [anon_sym_class] = ACTIONS(3555),
    [anon_sym_struct] = ACTIONS(3555),
    [anon_sym_union] = ACTIONS(3555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3555),
    [anon_sym_let] = ACTIONS(3555),
    [anon_sym_This] = ACTIONS(3555),
    [anon_sym_decltype] = ACTIONS(3555),
    [sym_virtual] = ACTIONS(3555),
    [anon_sym_explicit] = ACTIONS(3555),
    [anon_sym_typename] = ACTIONS(3555),
    [anon_sym_template] = ACTIONS(3555),
    [anon_sym_operator] = ACTIONS(3555),
    [anon_sym_friend] = ACTIONS(3555),
    [anon_sym_public] = ACTIONS(3555),
    [anon_sym_private] = ACTIONS(3555),
    [anon_sym_protected] = ACTIONS(3555),
    [anon_sym_using] = ACTIONS(3555),
    [anon_sym_static_assert] = ACTIONS(3555),
    [anon_sym_precise] = ACTIONS(3555),
    [anon_sym_shared] = ACTIONS(3555),
    [anon_sym_groupshared] = ACTIONS(3555),
    [anon_sym_uniform] = ACTIONS(3555),
    [anon_sym_row_major] = ACTIONS(3555),
    [anon_sym_column_major] = ACTIONS(3555),
    [anon_sym_globallycoherent] = ACTIONS(3555),
    [anon_sym_centroid] = ACTIONS(3555),
    [anon_sym_noperspective] = ACTIONS(3555),
    [anon_sym_nointerpolation] = ACTIONS(3555),
    [anon_sym_sample] = ACTIONS(3555),
    [anon_sym_linear] = ACTIONS(3555),
    [anon_sym_snorm] = ACTIONS(3555),
    [anon_sym_unorm] = ACTIONS(3555),
    [anon_sym_point] = ACTIONS(3555),
    [anon_sym_line] = ACTIONS(3555),
    [anon_sym_triangleadj] = ACTIONS(3555),
    [anon_sym_lineadj] = ACTIONS(3555),
    [anon_sym_triangle] = ACTIONS(3555),
    [anon_sym_interface] = ACTIONS(3555),
    [anon_sym_extension] = ACTIONS(3555),
    [anon_sym___init] = ACTIONS(3555),
    [anon_sym___subscript] = ACTIONS(3555),
    [anon_sym_property] = ACTIONS(3555),
    [anon_sym_associatedtype] = ACTIONS(3555),
  },
  [2352] = {
    [sym_identifier] = ACTIONS(3625),
    [aux_sym_preproc_def_token1] = ACTIONS(3625),
    [aux_sym_preproc_if_token1] = ACTIONS(3625),
    [aux_sym_preproc_if_token2] = ACTIONS(3625),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3625),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3625),
    [sym_preproc_directive] = ACTIONS(3625),
    [anon_sym_LPAREN2] = ACTIONS(3627),
    [anon_sym_TILDE] = ACTIONS(3627),
    [anon_sym_STAR] = ACTIONS(3627),
    [anon_sym_AMP_AMP] = ACTIONS(3627),
    [anon_sym_AMP] = ACTIONS(3625),
    [anon_sym___extension__] = ACTIONS(3625),
    [anon_sym_typedef] = ACTIONS(3625),
    [anon_sym_in] = ACTIONS(3625),
    [anon_sym_out] = ACTIONS(3625),
    [anon_sym_inout] = ACTIONS(3625),
    [anon_sym_extern] = ACTIONS(3625),
    [anon_sym___attribute__] = ACTIONS(3625),
    [anon_sym_COLON_COLON] = ACTIONS(3627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3627),
    [anon_sym___declspec] = ACTIONS(3625),
    [anon_sym___based] = ACTIONS(3625),
    [anon_sym_signed] = ACTIONS(3625),
    [anon_sym_unsigned] = ACTIONS(3625),
    [anon_sym_long] = ACTIONS(3625),
    [anon_sym_short] = ACTIONS(3625),
    [anon_sym_LBRACK] = ACTIONS(3625),
    [anon_sym_static] = ACTIONS(3625),
    [anon_sym_register] = ACTIONS(3625),
    [anon_sym_inline] = ACTIONS(3625),
    [anon_sym___inline] = ACTIONS(3625),
    [anon_sym___inline__] = ACTIONS(3625),
    [anon_sym___forceinline] = ACTIONS(3625),
    [anon_sym_thread_local] = ACTIONS(3625),
    [anon_sym___thread] = ACTIONS(3625),
    [anon_sym_const] = ACTIONS(3625),
    [anon_sym_constexpr] = ACTIONS(3625),
    [anon_sym_volatile] = ACTIONS(3625),
    [anon_sym_restrict] = ACTIONS(3625),
    [anon_sym___restrict__] = ACTIONS(3625),
    [anon_sym__Atomic] = ACTIONS(3625),
    [anon_sym__Noreturn] = ACTIONS(3625),
    [anon_sym_noreturn] = ACTIONS(3625),
    [anon_sym_mutable] = ACTIONS(3625),
    [anon_sym_constinit] = ACTIONS(3625),
    [anon_sym_consteval] = ACTIONS(3625),
    [anon_sym_alignas] = ACTIONS(3625),
    [anon_sym__Alignas] = ACTIONS(3625),
    [sym_primitive_type] = ACTIONS(3625),
    [anon_sym_enum] = ACTIONS(3625),
    [anon_sym_class] = ACTIONS(3625),
    [anon_sym_struct] = ACTIONS(3625),
    [anon_sym_union] = ACTIONS(3625),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3625),
    [anon_sym_let] = ACTIONS(3625),
    [anon_sym_This] = ACTIONS(3625),
    [anon_sym_decltype] = ACTIONS(3625),
    [sym_virtual] = ACTIONS(3625),
    [anon_sym_explicit] = ACTIONS(3625),
    [anon_sym_typename] = ACTIONS(3625),
    [anon_sym_template] = ACTIONS(3625),
    [anon_sym_operator] = ACTIONS(3625),
    [anon_sym_friend] = ACTIONS(3625),
    [anon_sym_public] = ACTIONS(3625),
    [anon_sym_private] = ACTIONS(3625),
    [anon_sym_protected] = ACTIONS(3625),
    [anon_sym_using] = ACTIONS(3625),
    [anon_sym_static_assert] = ACTIONS(3625),
    [anon_sym_precise] = ACTIONS(3625),
    [anon_sym_shared] = ACTIONS(3625),
    [anon_sym_groupshared] = ACTIONS(3625),
    [anon_sym_uniform] = ACTIONS(3625),
    [anon_sym_row_major] = ACTIONS(3625),
    [anon_sym_column_major] = ACTIONS(3625),
    [anon_sym_globallycoherent] = ACTIONS(3625),
    [anon_sym_centroid] = ACTIONS(3625),
    [anon_sym_noperspective] = ACTIONS(3625),
    [anon_sym_nointerpolation] = ACTIONS(3625),
    [anon_sym_sample] = ACTIONS(3625),
    [anon_sym_linear] = ACTIONS(3625),
    [anon_sym_snorm] = ACTIONS(3625),
    [anon_sym_unorm] = ACTIONS(3625),
    [anon_sym_point] = ACTIONS(3625),
    [anon_sym_line] = ACTIONS(3625),
    [anon_sym_triangleadj] = ACTIONS(3625),
    [anon_sym_lineadj] = ACTIONS(3625),
    [anon_sym_triangle] = ACTIONS(3625),
    [anon_sym_interface] = ACTIONS(3625),
    [anon_sym_extension] = ACTIONS(3625),
    [anon_sym___init] = ACTIONS(3625),
    [anon_sym___subscript] = ACTIONS(3625),
    [anon_sym_property] = ACTIONS(3625),
    [anon_sym_associatedtype] = ACTIONS(3625),
  },
  [2353] = {
    [sym_expression] = STATE(5431),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2354] = {
    [sym_expression] = STATE(3735),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(4134),
    [sym_concatenated_string] = STATE(4159),
    [sym_string_literal] = STATE(3152),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(3145),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4587),
    [anon_sym_LPAREN2] = ACTIONS(5819),
    [anon_sym_BANG] = ACTIONS(4591),
    [anon_sym_TILDE] = ACTIONS(4591),
    [anon_sym_DASH] = ACTIONS(4589),
    [anon_sym_PLUS] = ACTIONS(4589),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4593),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4589),
    [anon_sym_compl] = ACTIONS(4589),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_sizeof] = ACTIONS(4595),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4597),
    [anon_sym_L_SQUOTE] = ACTIONS(4599),
    [anon_sym_u_SQUOTE] = ACTIONS(4599),
    [anon_sym_U_SQUOTE] = ACTIONS(4599),
    [anon_sym_u8_SQUOTE] = ACTIONS(4599),
    [anon_sym_SQUOTE] = ACTIONS(4599),
    [anon_sym_L_DQUOTE] = ACTIONS(4601),
    [anon_sym_u_DQUOTE] = ACTIONS(4601),
    [anon_sym_U_DQUOTE] = ACTIONS(4601),
    [anon_sym_u8_DQUOTE] = ACTIONS(4601),
    [anon_sym_DQUOTE] = ACTIONS(4601),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4603),
    [anon_sym_R_DQUOTE] = ACTIONS(4605),
    [anon_sym_LR_DQUOTE] = ACTIONS(4605),
    [anon_sym_uR_DQUOTE] = ACTIONS(4605),
    [anon_sym_UR_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4605),
    [anon_sym_co_await] = ACTIONS(4607),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2355] = {
    [sym_expression] = STATE(4861),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4905),
    [sym_concatenated_string] = STATE(4902),
    [sym_string_literal] = STATE(3611),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3610),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(5705),
    [anon_sym_LPAREN2] = ACTIONS(5834),
    [anon_sym_BANG] = ACTIONS(4926),
    [anon_sym_TILDE] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4928),
    [anon_sym_LBRACK] = ACTIONS(6110),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4924),
    [anon_sym_compl] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(5707),
    [anon_sym_PLUS_PLUS] = ACTIONS(5707),
    [anon_sym_sizeof] = ACTIONS(4932),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4934),
    [anon_sym_L_SQUOTE] = ACTIONS(4936),
    [anon_sym_u_SQUOTE] = ACTIONS(4936),
    [anon_sym_U_SQUOTE] = ACTIONS(4936),
    [anon_sym_u8_SQUOTE] = ACTIONS(4936),
    [anon_sym_SQUOTE] = ACTIONS(4936),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4938),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_co_await] = ACTIONS(4940),
    [anon_sym_new] = ACTIONS(4942),
    [anon_sym_requires] = ACTIONS(4944),
    [sym_this] = ACTIONS(241),
  },
  [2356] = {
    [sym_identifier] = ACTIONS(5606),
    [aux_sym_preproc_def_token1] = ACTIONS(5606),
    [aux_sym_preproc_if_token1] = ACTIONS(5606),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5606),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5606),
    [sym_preproc_directive] = ACTIONS(5606),
    [anon_sym_LPAREN2] = ACTIONS(5608),
    [anon_sym_TILDE] = ACTIONS(5608),
    [anon_sym_STAR] = ACTIONS(5608),
    [anon_sym_AMP_AMP] = ACTIONS(5608),
    [anon_sym_AMP] = ACTIONS(5606),
    [anon_sym___extension__] = ACTIONS(5606),
    [anon_sym_typedef] = ACTIONS(5606),
    [anon_sym_in] = ACTIONS(5606),
    [anon_sym_out] = ACTIONS(5606),
    [anon_sym_inout] = ACTIONS(5606),
    [anon_sym_extern] = ACTIONS(5606),
    [anon_sym___attribute__] = ACTIONS(5606),
    [anon_sym_COLON_COLON] = ACTIONS(5608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5608),
    [anon_sym___declspec] = ACTIONS(5606),
    [anon_sym___based] = ACTIONS(5606),
    [anon_sym_RBRACE] = ACTIONS(5608),
    [anon_sym_signed] = ACTIONS(5606),
    [anon_sym_unsigned] = ACTIONS(5606),
    [anon_sym_long] = ACTIONS(5606),
    [anon_sym_short] = ACTIONS(5606),
    [anon_sym_LBRACK] = ACTIONS(5606),
    [anon_sym_static] = ACTIONS(5606),
    [anon_sym_register] = ACTIONS(5606),
    [anon_sym_inline] = ACTIONS(5606),
    [anon_sym___inline] = ACTIONS(5606),
    [anon_sym___inline__] = ACTIONS(5606),
    [anon_sym___forceinline] = ACTIONS(5606),
    [anon_sym_thread_local] = ACTIONS(5606),
    [anon_sym___thread] = ACTIONS(5606),
    [anon_sym_const] = ACTIONS(5606),
    [anon_sym_constexpr] = ACTIONS(5606),
    [anon_sym_volatile] = ACTIONS(5606),
    [anon_sym_restrict] = ACTIONS(5606),
    [anon_sym___restrict__] = ACTIONS(5606),
    [anon_sym__Atomic] = ACTIONS(5606),
    [anon_sym__Noreturn] = ACTIONS(5606),
    [anon_sym_noreturn] = ACTIONS(5606),
    [anon_sym_mutable] = ACTIONS(5606),
    [anon_sym_constinit] = ACTIONS(5606),
    [anon_sym_consteval] = ACTIONS(5606),
    [anon_sym_alignas] = ACTIONS(5606),
    [anon_sym__Alignas] = ACTIONS(5606),
    [sym_primitive_type] = ACTIONS(5606),
    [anon_sym_enum] = ACTIONS(5606),
    [anon_sym_class] = ACTIONS(5606),
    [anon_sym_struct] = ACTIONS(5606),
    [anon_sym_union] = ACTIONS(5606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5606),
    [anon_sym_let] = ACTIONS(5606),
    [anon_sym_This] = ACTIONS(5606),
    [anon_sym_decltype] = ACTIONS(5606),
    [sym_virtual] = ACTIONS(5606),
    [anon_sym_explicit] = ACTIONS(5606),
    [anon_sym_typename] = ACTIONS(5606),
    [anon_sym_template] = ACTIONS(5606),
    [anon_sym_operator] = ACTIONS(5606),
    [anon_sym_friend] = ACTIONS(5606),
    [anon_sym_public] = ACTIONS(5606),
    [anon_sym_private] = ACTIONS(5606),
    [anon_sym_protected] = ACTIONS(5606),
    [anon_sym_using] = ACTIONS(5606),
    [anon_sym_static_assert] = ACTIONS(5606),
    [anon_sym_precise] = ACTIONS(5606),
    [anon_sym_shared] = ACTIONS(5606),
    [anon_sym_groupshared] = ACTIONS(5606),
    [anon_sym_uniform] = ACTIONS(5606),
    [anon_sym_row_major] = ACTIONS(5606),
    [anon_sym_column_major] = ACTIONS(5606),
    [anon_sym_globallycoherent] = ACTIONS(5606),
    [anon_sym_centroid] = ACTIONS(5606),
    [anon_sym_noperspective] = ACTIONS(5606),
    [anon_sym_nointerpolation] = ACTIONS(5606),
    [anon_sym_sample] = ACTIONS(5606),
    [anon_sym_linear] = ACTIONS(5606),
    [anon_sym_snorm] = ACTIONS(5606),
    [anon_sym_unorm] = ACTIONS(5606),
    [anon_sym_point] = ACTIONS(5606),
    [anon_sym_line] = ACTIONS(5606),
    [anon_sym_triangleadj] = ACTIONS(5606),
    [anon_sym_lineadj] = ACTIONS(5606),
    [anon_sym_triangle] = ACTIONS(5606),
    [anon_sym_interface] = ACTIONS(5606),
    [anon_sym_extension] = ACTIONS(5606),
    [anon_sym___init] = ACTIONS(5606),
    [anon_sym___subscript] = ACTIONS(5606),
    [anon_sym_property] = ACTIONS(5606),
    [anon_sym_associatedtype] = ACTIONS(5606),
  },
  [2357] = {
    [sym_identifier] = ACTIONS(3669),
    [aux_sym_preproc_def_token1] = ACTIONS(3669),
    [aux_sym_preproc_if_token1] = ACTIONS(3669),
    [aux_sym_preproc_if_token2] = ACTIONS(3669),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3669),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3669),
    [sym_preproc_directive] = ACTIONS(3669),
    [anon_sym_LPAREN2] = ACTIONS(3671),
    [anon_sym_TILDE] = ACTIONS(3671),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3671),
    [anon_sym_AMP] = ACTIONS(3669),
    [anon_sym___extension__] = ACTIONS(3669),
    [anon_sym_typedef] = ACTIONS(3669),
    [anon_sym_in] = ACTIONS(3669),
    [anon_sym_out] = ACTIONS(3669),
    [anon_sym_inout] = ACTIONS(3669),
    [anon_sym_extern] = ACTIONS(3669),
    [anon_sym___attribute__] = ACTIONS(3669),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3671),
    [anon_sym___declspec] = ACTIONS(3669),
    [anon_sym___based] = ACTIONS(3669),
    [anon_sym_signed] = ACTIONS(3669),
    [anon_sym_unsigned] = ACTIONS(3669),
    [anon_sym_long] = ACTIONS(3669),
    [anon_sym_short] = ACTIONS(3669),
    [anon_sym_LBRACK] = ACTIONS(3669),
    [anon_sym_static] = ACTIONS(3669),
    [anon_sym_register] = ACTIONS(3669),
    [anon_sym_inline] = ACTIONS(3669),
    [anon_sym___inline] = ACTIONS(3669),
    [anon_sym___inline__] = ACTIONS(3669),
    [anon_sym___forceinline] = ACTIONS(3669),
    [anon_sym_thread_local] = ACTIONS(3669),
    [anon_sym___thread] = ACTIONS(3669),
    [anon_sym_const] = ACTIONS(3669),
    [anon_sym_constexpr] = ACTIONS(3669),
    [anon_sym_volatile] = ACTIONS(3669),
    [anon_sym_restrict] = ACTIONS(3669),
    [anon_sym___restrict__] = ACTIONS(3669),
    [anon_sym__Atomic] = ACTIONS(3669),
    [anon_sym__Noreturn] = ACTIONS(3669),
    [anon_sym_noreturn] = ACTIONS(3669),
    [anon_sym_mutable] = ACTIONS(3669),
    [anon_sym_constinit] = ACTIONS(3669),
    [anon_sym_consteval] = ACTIONS(3669),
    [anon_sym_alignas] = ACTIONS(3669),
    [anon_sym__Alignas] = ACTIONS(3669),
    [sym_primitive_type] = ACTIONS(3669),
    [anon_sym_enum] = ACTIONS(3669),
    [anon_sym_class] = ACTIONS(3669),
    [anon_sym_struct] = ACTIONS(3669),
    [anon_sym_union] = ACTIONS(3669),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3669),
    [anon_sym_let] = ACTIONS(3669),
    [anon_sym_This] = ACTIONS(3669),
    [anon_sym_decltype] = ACTIONS(3669),
    [sym_virtual] = ACTIONS(3669),
    [anon_sym_explicit] = ACTIONS(3669),
    [anon_sym_typename] = ACTIONS(3669),
    [anon_sym_template] = ACTIONS(3669),
    [anon_sym_operator] = ACTIONS(3669),
    [anon_sym_friend] = ACTIONS(3669),
    [anon_sym_public] = ACTIONS(3669),
    [anon_sym_private] = ACTIONS(3669),
    [anon_sym_protected] = ACTIONS(3669),
    [anon_sym_using] = ACTIONS(3669),
    [anon_sym_static_assert] = ACTIONS(3669),
    [anon_sym_precise] = ACTIONS(3669),
    [anon_sym_shared] = ACTIONS(3669),
    [anon_sym_groupshared] = ACTIONS(3669),
    [anon_sym_uniform] = ACTIONS(3669),
    [anon_sym_row_major] = ACTIONS(3669),
    [anon_sym_column_major] = ACTIONS(3669),
    [anon_sym_globallycoherent] = ACTIONS(3669),
    [anon_sym_centroid] = ACTIONS(3669),
    [anon_sym_noperspective] = ACTIONS(3669),
    [anon_sym_nointerpolation] = ACTIONS(3669),
    [anon_sym_sample] = ACTIONS(3669),
    [anon_sym_linear] = ACTIONS(3669),
    [anon_sym_snorm] = ACTIONS(3669),
    [anon_sym_unorm] = ACTIONS(3669),
    [anon_sym_point] = ACTIONS(3669),
    [anon_sym_line] = ACTIONS(3669),
    [anon_sym_triangleadj] = ACTIONS(3669),
    [anon_sym_lineadj] = ACTIONS(3669),
    [anon_sym_triangle] = ACTIONS(3669),
    [anon_sym_interface] = ACTIONS(3669),
    [anon_sym_extension] = ACTIONS(3669),
    [anon_sym___init] = ACTIONS(3669),
    [anon_sym___subscript] = ACTIONS(3669),
    [anon_sym_property] = ACTIONS(3669),
    [anon_sym_associatedtype] = ACTIONS(3669),
  },
  [2358] = {
    [sym_identifier] = ACTIONS(2982),
    [aux_sym_preproc_def_token1] = ACTIONS(2982),
    [aux_sym_preproc_if_token1] = ACTIONS(2982),
    [aux_sym_preproc_if_token2] = ACTIONS(2982),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2982),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2982),
    [sym_preproc_directive] = ACTIONS(2982),
    [anon_sym_LPAREN2] = ACTIONS(2984),
    [anon_sym_TILDE] = ACTIONS(2984),
    [anon_sym_STAR] = ACTIONS(2984),
    [anon_sym_AMP_AMP] = ACTIONS(2984),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(2982),
    [anon_sym_typedef] = ACTIONS(2982),
    [anon_sym_in] = ACTIONS(2982),
    [anon_sym_out] = ACTIONS(2982),
    [anon_sym_inout] = ACTIONS(2982),
    [anon_sym_extern] = ACTIONS(2982),
    [anon_sym___attribute__] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2984),
    [anon_sym___declspec] = ACTIONS(2982),
    [anon_sym___based] = ACTIONS(2982),
    [anon_sym_signed] = ACTIONS(2982),
    [anon_sym_unsigned] = ACTIONS(2982),
    [anon_sym_long] = ACTIONS(2982),
    [anon_sym_short] = ACTIONS(2982),
    [anon_sym_LBRACK] = ACTIONS(2982),
    [anon_sym_static] = ACTIONS(2982),
    [anon_sym_register] = ACTIONS(2982),
    [anon_sym_inline] = ACTIONS(2982),
    [anon_sym___inline] = ACTIONS(2982),
    [anon_sym___inline__] = ACTIONS(2982),
    [anon_sym___forceinline] = ACTIONS(2982),
    [anon_sym_thread_local] = ACTIONS(2982),
    [anon_sym___thread] = ACTIONS(2982),
    [anon_sym_const] = ACTIONS(2982),
    [anon_sym_constexpr] = ACTIONS(2982),
    [anon_sym_volatile] = ACTIONS(2982),
    [anon_sym_restrict] = ACTIONS(2982),
    [anon_sym___restrict__] = ACTIONS(2982),
    [anon_sym__Atomic] = ACTIONS(2982),
    [anon_sym__Noreturn] = ACTIONS(2982),
    [anon_sym_noreturn] = ACTIONS(2982),
    [anon_sym_mutable] = ACTIONS(2982),
    [anon_sym_constinit] = ACTIONS(2982),
    [anon_sym_consteval] = ACTIONS(2982),
    [anon_sym_alignas] = ACTIONS(2982),
    [anon_sym__Alignas] = ACTIONS(2982),
    [sym_primitive_type] = ACTIONS(2982),
    [anon_sym_enum] = ACTIONS(2982),
    [anon_sym_class] = ACTIONS(2982),
    [anon_sym_struct] = ACTIONS(2982),
    [anon_sym_union] = ACTIONS(2982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2982),
    [anon_sym_let] = ACTIONS(2982),
    [anon_sym_This] = ACTIONS(2982),
    [anon_sym_decltype] = ACTIONS(2982),
    [sym_virtual] = ACTIONS(2982),
    [anon_sym_explicit] = ACTIONS(2982),
    [anon_sym_typename] = ACTIONS(2982),
    [anon_sym_template] = ACTIONS(2982),
    [anon_sym_operator] = ACTIONS(2982),
    [anon_sym_friend] = ACTIONS(2982),
    [anon_sym_public] = ACTIONS(2982),
    [anon_sym_private] = ACTIONS(2982),
    [anon_sym_protected] = ACTIONS(2982),
    [anon_sym_using] = ACTIONS(2982),
    [anon_sym_static_assert] = ACTIONS(2982),
    [anon_sym_precise] = ACTIONS(2982),
    [anon_sym_shared] = ACTIONS(2982),
    [anon_sym_groupshared] = ACTIONS(2982),
    [anon_sym_uniform] = ACTIONS(2982),
    [anon_sym_row_major] = ACTIONS(2982),
    [anon_sym_column_major] = ACTIONS(2982),
    [anon_sym_globallycoherent] = ACTIONS(2982),
    [anon_sym_centroid] = ACTIONS(2982),
    [anon_sym_noperspective] = ACTIONS(2982),
    [anon_sym_nointerpolation] = ACTIONS(2982),
    [anon_sym_sample] = ACTIONS(2982),
    [anon_sym_linear] = ACTIONS(2982),
    [anon_sym_snorm] = ACTIONS(2982),
    [anon_sym_unorm] = ACTIONS(2982),
    [anon_sym_point] = ACTIONS(2982),
    [anon_sym_line] = ACTIONS(2982),
    [anon_sym_triangleadj] = ACTIONS(2982),
    [anon_sym_lineadj] = ACTIONS(2982),
    [anon_sym_triangle] = ACTIONS(2982),
    [anon_sym_interface] = ACTIONS(2982),
    [anon_sym_extension] = ACTIONS(2982),
    [anon_sym___init] = ACTIONS(2982),
    [anon_sym___subscript] = ACTIONS(2982),
    [anon_sym_property] = ACTIONS(2982),
    [anon_sym_associatedtype] = ACTIONS(2982),
  },
  [2359] = {
    [sym_expression] = STATE(5472),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2360] = {
    [sym_expression] = STATE(5065),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2361] = {
    [sym_identifier] = ACTIONS(3547),
    [aux_sym_preproc_def_token1] = ACTIONS(3547),
    [aux_sym_preproc_if_token1] = ACTIONS(3547),
    [aux_sym_preproc_if_token2] = ACTIONS(3547),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3547),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3547),
    [sym_preproc_directive] = ACTIONS(3547),
    [anon_sym_LPAREN2] = ACTIONS(3549),
    [anon_sym_TILDE] = ACTIONS(3549),
    [anon_sym_STAR] = ACTIONS(3549),
    [anon_sym_AMP_AMP] = ACTIONS(3549),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym___extension__] = ACTIONS(3547),
    [anon_sym_typedef] = ACTIONS(3547),
    [anon_sym_in] = ACTIONS(3547),
    [anon_sym_out] = ACTIONS(3547),
    [anon_sym_inout] = ACTIONS(3547),
    [anon_sym_extern] = ACTIONS(3547),
    [anon_sym___attribute__] = ACTIONS(3547),
    [anon_sym_COLON_COLON] = ACTIONS(3549),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3549),
    [anon_sym___declspec] = ACTIONS(3547),
    [anon_sym___based] = ACTIONS(3547),
    [anon_sym_signed] = ACTIONS(3547),
    [anon_sym_unsigned] = ACTIONS(3547),
    [anon_sym_long] = ACTIONS(3547),
    [anon_sym_short] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_static] = ACTIONS(3547),
    [anon_sym_register] = ACTIONS(3547),
    [anon_sym_inline] = ACTIONS(3547),
    [anon_sym___inline] = ACTIONS(3547),
    [anon_sym___inline__] = ACTIONS(3547),
    [anon_sym___forceinline] = ACTIONS(3547),
    [anon_sym_thread_local] = ACTIONS(3547),
    [anon_sym___thread] = ACTIONS(3547),
    [anon_sym_const] = ACTIONS(3547),
    [anon_sym_constexpr] = ACTIONS(3547),
    [anon_sym_volatile] = ACTIONS(3547),
    [anon_sym_restrict] = ACTIONS(3547),
    [anon_sym___restrict__] = ACTIONS(3547),
    [anon_sym__Atomic] = ACTIONS(3547),
    [anon_sym__Noreturn] = ACTIONS(3547),
    [anon_sym_noreturn] = ACTIONS(3547),
    [anon_sym_mutable] = ACTIONS(3547),
    [anon_sym_constinit] = ACTIONS(3547),
    [anon_sym_consteval] = ACTIONS(3547),
    [anon_sym_alignas] = ACTIONS(3547),
    [anon_sym__Alignas] = ACTIONS(3547),
    [sym_primitive_type] = ACTIONS(3547),
    [anon_sym_enum] = ACTIONS(3547),
    [anon_sym_class] = ACTIONS(3547),
    [anon_sym_struct] = ACTIONS(3547),
    [anon_sym_union] = ACTIONS(3547),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_This] = ACTIONS(3547),
    [anon_sym_decltype] = ACTIONS(3547),
    [sym_virtual] = ACTIONS(3547),
    [anon_sym_explicit] = ACTIONS(3547),
    [anon_sym_typename] = ACTIONS(3547),
    [anon_sym_template] = ACTIONS(3547),
    [anon_sym_operator] = ACTIONS(3547),
    [anon_sym_friend] = ACTIONS(3547),
    [anon_sym_public] = ACTIONS(3547),
    [anon_sym_private] = ACTIONS(3547),
    [anon_sym_protected] = ACTIONS(3547),
    [anon_sym_using] = ACTIONS(3547),
    [anon_sym_static_assert] = ACTIONS(3547),
    [anon_sym_precise] = ACTIONS(3547),
    [anon_sym_shared] = ACTIONS(3547),
    [anon_sym_groupshared] = ACTIONS(3547),
    [anon_sym_uniform] = ACTIONS(3547),
    [anon_sym_row_major] = ACTIONS(3547),
    [anon_sym_column_major] = ACTIONS(3547),
    [anon_sym_globallycoherent] = ACTIONS(3547),
    [anon_sym_centroid] = ACTIONS(3547),
    [anon_sym_noperspective] = ACTIONS(3547),
    [anon_sym_nointerpolation] = ACTIONS(3547),
    [anon_sym_sample] = ACTIONS(3547),
    [anon_sym_linear] = ACTIONS(3547),
    [anon_sym_snorm] = ACTIONS(3547),
    [anon_sym_unorm] = ACTIONS(3547),
    [anon_sym_point] = ACTIONS(3547),
    [anon_sym_line] = ACTIONS(3547),
    [anon_sym_triangleadj] = ACTIONS(3547),
    [anon_sym_lineadj] = ACTIONS(3547),
    [anon_sym_triangle] = ACTIONS(3547),
    [anon_sym_interface] = ACTIONS(3547),
    [anon_sym_extension] = ACTIONS(3547),
    [anon_sym___init] = ACTIONS(3547),
    [anon_sym___subscript] = ACTIONS(3547),
    [anon_sym_property] = ACTIONS(3547),
    [anon_sym_associatedtype] = ACTIONS(3547),
  },
  [2362] = {
    [sym_expression] = STATE(5495),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2363] = {
    [sym_expression] = STATE(4677),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2364] = {
    [sym_expression] = STATE(5061),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2365] = {
    [sym_expression] = STATE(5182),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2366] = {
    [sym_expression] = STATE(5183),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2367] = {
    [sym_expression] = STATE(5059),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2368] = {
    [sym_identifier] = ACTIONS(5610),
    [aux_sym_preproc_def_token1] = ACTIONS(5610),
    [aux_sym_preproc_if_token1] = ACTIONS(5610),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5610),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5610),
    [sym_preproc_directive] = ACTIONS(5610),
    [anon_sym_LPAREN2] = ACTIONS(5612),
    [anon_sym_TILDE] = ACTIONS(5612),
    [anon_sym_STAR] = ACTIONS(5612),
    [anon_sym_AMP_AMP] = ACTIONS(5612),
    [anon_sym_AMP] = ACTIONS(5610),
    [anon_sym___extension__] = ACTIONS(5610),
    [anon_sym_typedef] = ACTIONS(5610),
    [anon_sym_in] = ACTIONS(5610),
    [anon_sym_out] = ACTIONS(5610),
    [anon_sym_inout] = ACTIONS(5610),
    [anon_sym_extern] = ACTIONS(5610),
    [anon_sym___attribute__] = ACTIONS(5610),
    [anon_sym_COLON_COLON] = ACTIONS(5612),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5612),
    [anon_sym___declspec] = ACTIONS(5610),
    [anon_sym___based] = ACTIONS(5610),
    [anon_sym_RBRACE] = ACTIONS(5612),
    [anon_sym_signed] = ACTIONS(5610),
    [anon_sym_unsigned] = ACTIONS(5610),
    [anon_sym_long] = ACTIONS(5610),
    [anon_sym_short] = ACTIONS(5610),
    [anon_sym_LBRACK] = ACTIONS(5610),
    [anon_sym_static] = ACTIONS(5610),
    [anon_sym_register] = ACTIONS(5610),
    [anon_sym_inline] = ACTIONS(5610),
    [anon_sym___inline] = ACTIONS(5610),
    [anon_sym___inline__] = ACTIONS(5610),
    [anon_sym___forceinline] = ACTIONS(5610),
    [anon_sym_thread_local] = ACTIONS(5610),
    [anon_sym___thread] = ACTIONS(5610),
    [anon_sym_const] = ACTIONS(5610),
    [anon_sym_constexpr] = ACTIONS(5610),
    [anon_sym_volatile] = ACTIONS(5610),
    [anon_sym_restrict] = ACTIONS(5610),
    [anon_sym___restrict__] = ACTIONS(5610),
    [anon_sym__Atomic] = ACTIONS(5610),
    [anon_sym__Noreturn] = ACTIONS(5610),
    [anon_sym_noreturn] = ACTIONS(5610),
    [anon_sym_mutable] = ACTIONS(5610),
    [anon_sym_constinit] = ACTIONS(5610),
    [anon_sym_consteval] = ACTIONS(5610),
    [anon_sym_alignas] = ACTIONS(5610),
    [anon_sym__Alignas] = ACTIONS(5610),
    [sym_primitive_type] = ACTIONS(5610),
    [anon_sym_enum] = ACTIONS(5610),
    [anon_sym_class] = ACTIONS(5610),
    [anon_sym_struct] = ACTIONS(5610),
    [anon_sym_union] = ACTIONS(5610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5610),
    [anon_sym_let] = ACTIONS(5610),
    [anon_sym_This] = ACTIONS(5610),
    [anon_sym_decltype] = ACTIONS(5610),
    [sym_virtual] = ACTIONS(5610),
    [anon_sym_explicit] = ACTIONS(5610),
    [anon_sym_typename] = ACTIONS(5610),
    [anon_sym_template] = ACTIONS(5610),
    [anon_sym_operator] = ACTIONS(5610),
    [anon_sym_friend] = ACTIONS(5610),
    [anon_sym_public] = ACTIONS(5610),
    [anon_sym_private] = ACTIONS(5610),
    [anon_sym_protected] = ACTIONS(5610),
    [anon_sym_using] = ACTIONS(5610),
    [anon_sym_static_assert] = ACTIONS(5610),
    [anon_sym_precise] = ACTIONS(5610),
    [anon_sym_shared] = ACTIONS(5610),
    [anon_sym_groupshared] = ACTIONS(5610),
    [anon_sym_uniform] = ACTIONS(5610),
    [anon_sym_row_major] = ACTIONS(5610),
    [anon_sym_column_major] = ACTIONS(5610),
    [anon_sym_globallycoherent] = ACTIONS(5610),
    [anon_sym_centroid] = ACTIONS(5610),
    [anon_sym_noperspective] = ACTIONS(5610),
    [anon_sym_nointerpolation] = ACTIONS(5610),
    [anon_sym_sample] = ACTIONS(5610),
    [anon_sym_linear] = ACTIONS(5610),
    [anon_sym_snorm] = ACTIONS(5610),
    [anon_sym_unorm] = ACTIONS(5610),
    [anon_sym_point] = ACTIONS(5610),
    [anon_sym_line] = ACTIONS(5610),
    [anon_sym_triangleadj] = ACTIONS(5610),
    [anon_sym_lineadj] = ACTIONS(5610),
    [anon_sym_triangle] = ACTIONS(5610),
    [anon_sym_interface] = ACTIONS(5610),
    [anon_sym_extension] = ACTIONS(5610),
    [anon_sym___init] = ACTIONS(5610),
    [anon_sym___subscript] = ACTIONS(5610),
    [anon_sym_property] = ACTIONS(5610),
    [anon_sym_associatedtype] = ACTIONS(5610),
  },
  [2369] = {
    [sym_expression] = STATE(5582),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2370] = {
    [sym_expression] = STATE(3721),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(4134),
    [sym_concatenated_string] = STATE(4159),
    [sym_string_literal] = STATE(3152),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(3145),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4587),
    [anon_sym_LPAREN2] = ACTIONS(5819),
    [anon_sym_BANG] = ACTIONS(4591),
    [anon_sym_TILDE] = ACTIONS(4591),
    [anon_sym_DASH] = ACTIONS(4589),
    [anon_sym_PLUS] = ACTIONS(4589),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4593),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4589),
    [anon_sym_compl] = ACTIONS(4589),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_sizeof] = ACTIONS(4595),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4597),
    [anon_sym_L_SQUOTE] = ACTIONS(4599),
    [anon_sym_u_SQUOTE] = ACTIONS(4599),
    [anon_sym_U_SQUOTE] = ACTIONS(4599),
    [anon_sym_u8_SQUOTE] = ACTIONS(4599),
    [anon_sym_SQUOTE] = ACTIONS(4599),
    [anon_sym_L_DQUOTE] = ACTIONS(4601),
    [anon_sym_u_DQUOTE] = ACTIONS(4601),
    [anon_sym_U_DQUOTE] = ACTIONS(4601),
    [anon_sym_u8_DQUOTE] = ACTIONS(4601),
    [anon_sym_DQUOTE] = ACTIONS(4601),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4603),
    [anon_sym_R_DQUOTE] = ACTIONS(4605),
    [anon_sym_LR_DQUOTE] = ACTIONS(4605),
    [anon_sym_uR_DQUOTE] = ACTIONS(4605),
    [anon_sym_UR_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4605),
    [anon_sym_co_await] = ACTIONS(4607),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2371] = {
    [sym_expression] = STATE(5053),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2372] = {
    [sym_expression] = STATE(4550),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(6112),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [2373] = {
    [sym_identifier] = ACTIONS(3182),
    [aux_sym_preproc_def_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token2] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [sym_preproc_directive] = ACTIONS(3182),
    [anon_sym_LPAREN2] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_AMP_AMP] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3182),
    [anon_sym___extension__] = ACTIONS(3182),
    [anon_sym_typedef] = ACTIONS(3182),
    [anon_sym_in] = ACTIONS(3182),
    [anon_sym_out] = ACTIONS(3182),
    [anon_sym_inout] = ACTIONS(3182),
    [anon_sym_extern] = ACTIONS(3182),
    [anon_sym___attribute__] = ACTIONS(3182),
    [anon_sym_COLON_COLON] = ACTIONS(3184),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3184),
    [anon_sym___declspec] = ACTIONS(3182),
    [anon_sym___based] = ACTIONS(3182),
    [anon_sym_signed] = ACTIONS(3182),
    [anon_sym_unsigned] = ACTIONS(3182),
    [anon_sym_long] = ACTIONS(3182),
    [anon_sym_short] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3182),
    [anon_sym_register] = ACTIONS(3182),
    [anon_sym_inline] = ACTIONS(3182),
    [anon_sym___inline] = ACTIONS(3182),
    [anon_sym___inline__] = ACTIONS(3182),
    [anon_sym___forceinline] = ACTIONS(3182),
    [anon_sym_thread_local] = ACTIONS(3182),
    [anon_sym___thread] = ACTIONS(3182),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_constexpr] = ACTIONS(3182),
    [anon_sym_volatile] = ACTIONS(3182),
    [anon_sym_restrict] = ACTIONS(3182),
    [anon_sym___restrict__] = ACTIONS(3182),
    [anon_sym__Atomic] = ACTIONS(3182),
    [anon_sym__Noreturn] = ACTIONS(3182),
    [anon_sym_noreturn] = ACTIONS(3182),
    [anon_sym_mutable] = ACTIONS(3182),
    [anon_sym_constinit] = ACTIONS(3182),
    [anon_sym_consteval] = ACTIONS(3182),
    [anon_sym_alignas] = ACTIONS(3182),
    [anon_sym__Alignas] = ACTIONS(3182),
    [sym_primitive_type] = ACTIONS(3182),
    [anon_sym_enum] = ACTIONS(3182),
    [anon_sym_class] = ACTIONS(3182),
    [anon_sym_struct] = ACTIONS(3182),
    [anon_sym_union] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3182),
    [anon_sym_let] = ACTIONS(3182),
    [anon_sym_This] = ACTIONS(3182),
    [anon_sym_decltype] = ACTIONS(3182),
    [sym_virtual] = ACTIONS(3182),
    [anon_sym_explicit] = ACTIONS(3182),
    [anon_sym_typename] = ACTIONS(3182),
    [anon_sym_template] = ACTIONS(3182),
    [anon_sym_operator] = ACTIONS(3182),
    [anon_sym_friend] = ACTIONS(3182),
    [anon_sym_public] = ACTIONS(3182),
    [anon_sym_private] = ACTIONS(3182),
    [anon_sym_protected] = ACTIONS(3182),
    [anon_sym_using] = ACTIONS(3182),
    [anon_sym_static_assert] = ACTIONS(3182),
    [anon_sym_precise] = ACTIONS(3182),
    [anon_sym_shared] = ACTIONS(3182),
    [anon_sym_groupshared] = ACTIONS(3182),
    [anon_sym_uniform] = ACTIONS(3182),
    [anon_sym_row_major] = ACTIONS(3182),
    [anon_sym_column_major] = ACTIONS(3182),
    [anon_sym_globallycoherent] = ACTIONS(3182),
    [anon_sym_centroid] = ACTIONS(3182),
    [anon_sym_noperspective] = ACTIONS(3182),
    [anon_sym_nointerpolation] = ACTIONS(3182),
    [anon_sym_sample] = ACTIONS(3182),
    [anon_sym_linear] = ACTIONS(3182),
    [anon_sym_snorm] = ACTIONS(3182),
    [anon_sym_unorm] = ACTIONS(3182),
    [anon_sym_point] = ACTIONS(3182),
    [anon_sym_line] = ACTIONS(3182),
    [anon_sym_triangleadj] = ACTIONS(3182),
    [anon_sym_lineadj] = ACTIONS(3182),
    [anon_sym_triangle] = ACTIONS(3182),
    [anon_sym_interface] = ACTIONS(3182),
    [anon_sym_extension] = ACTIONS(3182),
    [anon_sym___init] = ACTIONS(3182),
    [anon_sym___subscript] = ACTIONS(3182),
    [anon_sym_property] = ACTIONS(3182),
    [anon_sym_associatedtype] = ACTIONS(3182),
  },
  [2374] = {
    [sym_expression] = STATE(4880),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4905),
    [sym_concatenated_string] = STATE(4902),
    [sym_string_literal] = STATE(3611),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3610),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(5705),
    [anon_sym_LPAREN2] = ACTIONS(5834),
    [anon_sym_BANG] = ACTIONS(4926),
    [anon_sym_TILDE] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4928),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4924),
    [anon_sym_compl] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(5707),
    [anon_sym_PLUS_PLUS] = ACTIONS(5707),
    [anon_sym_sizeof] = ACTIONS(4932),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4934),
    [anon_sym_L_SQUOTE] = ACTIONS(4936),
    [anon_sym_u_SQUOTE] = ACTIONS(4936),
    [anon_sym_U_SQUOTE] = ACTIONS(4936),
    [anon_sym_u8_SQUOTE] = ACTIONS(4936),
    [anon_sym_SQUOTE] = ACTIONS(4936),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4938),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_co_await] = ACTIONS(4940),
    [anon_sym_new] = ACTIONS(4942),
    [anon_sym_requires] = ACTIONS(4944),
    [sym_this] = ACTIONS(241),
  },
  [2375] = {
    [sym_identifier] = ACTIONS(5614),
    [aux_sym_preproc_def_token1] = ACTIONS(5614),
    [aux_sym_preproc_if_token1] = ACTIONS(5614),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5614),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5614),
    [sym_preproc_directive] = ACTIONS(5614),
    [anon_sym_LPAREN2] = ACTIONS(5616),
    [anon_sym_TILDE] = ACTIONS(5616),
    [anon_sym_STAR] = ACTIONS(5616),
    [anon_sym_AMP_AMP] = ACTIONS(5616),
    [anon_sym_AMP] = ACTIONS(5614),
    [anon_sym___extension__] = ACTIONS(5614),
    [anon_sym_typedef] = ACTIONS(5614),
    [anon_sym_in] = ACTIONS(5614),
    [anon_sym_out] = ACTIONS(5614),
    [anon_sym_inout] = ACTIONS(5614),
    [anon_sym_extern] = ACTIONS(5614),
    [anon_sym___attribute__] = ACTIONS(5614),
    [anon_sym_COLON_COLON] = ACTIONS(5616),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5616),
    [anon_sym___declspec] = ACTIONS(5614),
    [anon_sym___based] = ACTIONS(5614),
    [anon_sym_RBRACE] = ACTIONS(5616),
    [anon_sym_signed] = ACTIONS(5614),
    [anon_sym_unsigned] = ACTIONS(5614),
    [anon_sym_long] = ACTIONS(5614),
    [anon_sym_short] = ACTIONS(5614),
    [anon_sym_LBRACK] = ACTIONS(5614),
    [anon_sym_static] = ACTIONS(5614),
    [anon_sym_register] = ACTIONS(5614),
    [anon_sym_inline] = ACTIONS(5614),
    [anon_sym___inline] = ACTIONS(5614),
    [anon_sym___inline__] = ACTIONS(5614),
    [anon_sym___forceinline] = ACTIONS(5614),
    [anon_sym_thread_local] = ACTIONS(5614),
    [anon_sym___thread] = ACTIONS(5614),
    [anon_sym_const] = ACTIONS(5614),
    [anon_sym_constexpr] = ACTIONS(5614),
    [anon_sym_volatile] = ACTIONS(5614),
    [anon_sym_restrict] = ACTIONS(5614),
    [anon_sym___restrict__] = ACTIONS(5614),
    [anon_sym__Atomic] = ACTIONS(5614),
    [anon_sym__Noreturn] = ACTIONS(5614),
    [anon_sym_noreturn] = ACTIONS(5614),
    [anon_sym_mutable] = ACTIONS(5614),
    [anon_sym_constinit] = ACTIONS(5614),
    [anon_sym_consteval] = ACTIONS(5614),
    [anon_sym_alignas] = ACTIONS(5614),
    [anon_sym__Alignas] = ACTIONS(5614),
    [sym_primitive_type] = ACTIONS(5614),
    [anon_sym_enum] = ACTIONS(5614),
    [anon_sym_class] = ACTIONS(5614),
    [anon_sym_struct] = ACTIONS(5614),
    [anon_sym_union] = ACTIONS(5614),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5614),
    [anon_sym_let] = ACTIONS(5614),
    [anon_sym_This] = ACTIONS(5614),
    [anon_sym_decltype] = ACTIONS(5614),
    [sym_virtual] = ACTIONS(5614),
    [anon_sym_explicit] = ACTIONS(5614),
    [anon_sym_typename] = ACTIONS(5614),
    [anon_sym_template] = ACTIONS(5614),
    [anon_sym_operator] = ACTIONS(5614),
    [anon_sym_friend] = ACTIONS(5614),
    [anon_sym_public] = ACTIONS(5614),
    [anon_sym_private] = ACTIONS(5614),
    [anon_sym_protected] = ACTIONS(5614),
    [anon_sym_using] = ACTIONS(5614),
    [anon_sym_static_assert] = ACTIONS(5614),
    [anon_sym_precise] = ACTIONS(5614),
    [anon_sym_shared] = ACTIONS(5614),
    [anon_sym_groupshared] = ACTIONS(5614),
    [anon_sym_uniform] = ACTIONS(5614),
    [anon_sym_row_major] = ACTIONS(5614),
    [anon_sym_column_major] = ACTIONS(5614),
    [anon_sym_globallycoherent] = ACTIONS(5614),
    [anon_sym_centroid] = ACTIONS(5614),
    [anon_sym_noperspective] = ACTIONS(5614),
    [anon_sym_nointerpolation] = ACTIONS(5614),
    [anon_sym_sample] = ACTIONS(5614),
    [anon_sym_linear] = ACTIONS(5614),
    [anon_sym_snorm] = ACTIONS(5614),
    [anon_sym_unorm] = ACTIONS(5614),
    [anon_sym_point] = ACTIONS(5614),
    [anon_sym_line] = ACTIONS(5614),
    [anon_sym_triangleadj] = ACTIONS(5614),
    [anon_sym_lineadj] = ACTIONS(5614),
    [anon_sym_triangle] = ACTIONS(5614),
    [anon_sym_interface] = ACTIONS(5614),
    [anon_sym_extension] = ACTIONS(5614),
    [anon_sym___init] = ACTIONS(5614),
    [anon_sym___subscript] = ACTIONS(5614),
    [anon_sym_property] = ACTIONS(5614),
    [anon_sym_associatedtype] = ACTIONS(5614),
  },
  [2376] = {
    [sym_expression] = STATE(5047),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2377] = {
    [sym_identifier] = ACTIONS(3182),
    [aux_sym_preproc_def_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token2] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [sym_preproc_directive] = ACTIONS(3182),
    [anon_sym_LPAREN2] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_AMP_AMP] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3182),
    [anon_sym___extension__] = ACTIONS(3182),
    [anon_sym_typedef] = ACTIONS(3182),
    [anon_sym_in] = ACTIONS(3182),
    [anon_sym_out] = ACTIONS(3182),
    [anon_sym_inout] = ACTIONS(3182),
    [anon_sym_extern] = ACTIONS(3182),
    [anon_sym___attribute__] = ACTIONS(3182),
    [anon_sym_COLON_COLON] = ACTIONS(3184),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3184),
    [anon_sym___declspec] = ACTIONS(3182),
    [anon_sym___based] = ACTIONS(3182),
    [anon_sym_signed] = ACTIONS(3182),
    [anon_sym_unsigned] = ACTIONS(3182),
    [anon_sym_long] = ACTIONS(3182),
    [anon_sym_short] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3182),
    [anon_sym_register] = ACTIONS(3182),
    [anon_sym_inline] = ACTIONS(3182),
    [anon_sym___inline] = ACTIONS(3182),
    [anon_sym___inline__] = ACTIONS(3182),
    [anon_sym___forceinline] = ACTIONS(3182),
    [anon_sym_thread_local] = ACTIONS(3182),
    [anon_sym___thread] = ACTIONS(3182),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_constexpr] = ACTIONS(3182),
    [anon_sym_volatile] = ACTIONS(3182),
    [anon_sym_restrict] = ACTIONS(3182),
    [anon_sym___restrict__] = ACTIONS(3182),
    [anon_sym__Atomic] = ACTIONS(3182),
    [anon_sym__Noreturn] = ACTIONS(3182),
    [anon_sym_noreturn] = ACTIONS(3182),
    [anon_sym_mutable] = ACTIONS(3182),
    [anon_sym_constinit] = ACTIONS(3182),
    [anon_sym_consteval] = ACTIONS(3182),
    [anon_sym_alignas] = ACTIONS(3182),
    [anon_sym__Alignas] = ACTIONS(3182),
    [sym_primitive_type] = ACTIONS(3182),
    [anon_sym_enum] = ACTIONS(3182),
    [anon_sym_class] = ACTIONS(3182),
    [anon_sym_struct] = ACTIONS(3182),
    [anon_sym_union] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3182),
    [anon_sym_let] = ACTIONS(3182),
    [anon_sym_This] = ACTIONS(3182),
    [anon_sym_decltype] = ACTIONS(3182),
    [sym_virtual] = ACTIONS(3182),
    [anon_sym_explicit] = ACTIONS(3182),
    [anon_sym_typename] = ACTIONS(3182),
    [anon_sym_template] = ACTIONS(3182),
    [anon_sym_operator] = ACTIONS(3182),
    [anon_sym_friend] = ACTIONS(3182),
    [anon_sym_public] = ACTIONS(3182),
    [anon_sym_private] = ACTIONS(3182),
    [anon_sym_protected] = ACTIONS(3182),
    [anon_sym_using] = ACTIONS(3182),
    [anon_sym_static_assert] = ACTIONS(3182),
    [anon_sym_precise] = ACTIONS(3182),
    [anon_sym_shared] = ACTIONS(3182),
    [anon_sym_groupshared] = ACTIONS(3182),
    [anon_sym_uniform] = ACTIONS(3182),
    [anon_sym_row_major] = ACTIONS(3182),
    [anon_sym_column_major] = ACTIONS(3182),
    [anon_sym_globallycoherent] = ACTIONS(3182),
    [anon_sym_centroid] = ACTIONS(3182),
    [anon_sym_noperspective] = ACTIONS(3182),
    [anon_sym_nointerpolation] = ACTIONS(3182),
    [anon_sym_sample] = ACTIONS(3182),
    [anon_sym_linear] = ACTIONS(3182),
    [anon_sym_snorm] = ACTIONS(3182),
    [anon_sym_unorm] = ACTIONS(3182),
    [anon_sym_point] = ACTIONS(3182),
    [anon_sym_line] = ACTIONS(3182),
    [anon_sym_triangleadj] = ACTIONS(3182),
    [anon_sym_lineadj] = ACTIONS(3182),
    [anon_sym_triangle] = ACTIONS(3182),
    [anon_sym_interface] = ACTIONS(3182),
    [anon_sym_extension] = ACTIONS(3182),
    [anon_sym___init] = ACTIONS(3182),
    [anon_sym___subscript] = ACTIONS(3182),
    [anon_sym_property] = ACTIONS(3182),
    [anon_sym_associatedtype] = ACTIONS(3182),
  },
  [2378] = {
    [sym_expression] = STATE(5511),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2379] = {
    [sym_identifier] = ACTIONS(3406),
    [aux_sym_preproc_def_token1] = ACTIONS(3406),
    [aux_sym_preproc_if_token1] = ACTIONS(3406),
    [aux_sym_preproc_if_token2] = ACTIONS(3406),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3406),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3406),
    [sym_preproc_directive] = ACTIONS(3406),
    [anon_sym_LPAREN2] = ACTIONS(3408),
    [anon_sym_TILDE] = ACTIONS(3408),
    [anon_sym_STAR] = ACTIONS(3408),
    [anon_sym_AMP_AMP] = ACTIONS(3408),
    [anon_sym_AMP] = ACTIONS(3406),
    [anon_sym___extension__] = ACTIONS(3406),
    [anon_sym_typedef] = ACTIONS(3406),
    [anon_sym_in] = ACTIONS(3406),
    [anon_sym_out] = ACTIONS(3406),
    [anon_sym_inout] = ACTIONS(3406),
    [anon_sym_extern] = ACTIONS(3406),
    [anon_sym___attribute__] = ACTIONS(3406),
    [anon_sym_COLON_COLON] = ACTIONS(3408),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3408),
    [anon_sym___declspec] = ACTIONS(3406),
    [anon_sym___based] = ACTIONS(3406),
    [anon_sym_signed] = ACTIONS(3406),
    [anon_sym_unsigned] = ACTIONS(3406),
    [anon_sym_long] = ACTIONS(3406),
    [anon_sym_short] = ACTIONS(3406),
    [anon_sym_LBRACK] = ACTIONS(3406),
    [anon_sym_static] = ACTIONS(3406),
    [anon_sym_register] = ACTIONS(3406),
    [anon_sym_inline] = ACTIONS(3406),
    [anon_sym___inline] = ACTIONS(3406),
    [anon_sym___inline__] = ACTIONS(3406),
    [anon_sym___forceinline] = ACTIONS(3406),
    [anon_sym_thread_local] = ACTIONS(3406),
    [anon_sym___thread] = ACTIONS(3406),
    [anon_sym_const] = ACTIONS(3406),
    [anon_sym_constexpr] = ACTIONS(3406),
    [anon_sym_volatile] = ACTIONS(3406),
    [anon_sym_restrict] = ACTIONS(3406),
    [anon_sym___restrict__] = ACTIONS(3406),
    [anon_sym__Atomic] = ACTIONS(3406),
    [anon_sym__Noreturn] = ACTIONS(3406),
    [anon_sym_noreturn] = ACTIONS(3406),
    [anon_sym_mutable] = ACTIONS(3406),
    [anon_sym_constinit] = ACTIONS(3406),
    [anon_sym_consteval] = ACTIONS(3406),
    [anon_sym_alignas] = ACTIONS(3406),
    [anon_sym__Alignas] = ACTIONS(3406),
    [sym_primitive_type] = ACTIONS(3406),
    [anon_sym_enum] = ACTIONS(3406),
    [anon_sym_class] = ACTIONS(3406),
    [anon_sym_struct] = ACTIONS(3406),
    [anon_sym_union] = ACTIONS(3406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3406),
    [anon_sym_let] = ACTIONS(3406),
    [anon_sym_This] = ACTIONS(3406),
    [anon_sym_decltype] = ACTIONS(3406),
    [sym_virtual] = ACTIONS(3406),
    [anon_sym_explicit] = ACTIONS(3406),
    [anon_sym_typename] = ACTIONS(3406),
    [anon_sym_template] = ACTIONS(3406),
    [anon_sym_operator] = ACTIONS(3406),
    [anon_sym_friend] = ACTIONS(3406),
    [anon_sym_public] = ACTIONS(3406),
    [anon_sym_private] = ACTIONS(3406),
    [anon_sym_protected] = ACTIONS(3406),
    [anon_sym_using] = ACTIONS(3406),
    [anon_sym_static_assert] = ACTIONS(3406),
    [anon_sym_precise] = ACTIONS(3406),
    [anon_sym_shared] = ACTIONS(3406),
    [anon_sym_groupshared] = ACTIONS(3406),
    [anon_sym_uniform] = ACTIONS(3406),
    [anon_sym_row_major] = ACTIONS(3406),
    [anon_sym_column_major] = ACTIONS(3406),
    [anon_sym_globallycoherent] = ACTIONS(3406),
    [anon_sym_centroid] = ACTIONS(3406),
    [anon_sym_noperspective] = ACTIONS(3406),
    [anon_sym_nointerpolation] = ACTIONS(3406),
    [anon_sym_sample] = ACTIONS(3406),
    [anon_sym_linear] = ACTIONS(3406),
    [anon_sym_snorm] = ACTIONS(3406),
    [anon_sym_unorm] = ACTIONS(3406),
    [anon_sym_point] = ACTIONS(3406),
    [anon_sym_line] = ACTIONS(3406),
    [anon_sym_triangleadj] = ACTIONS(3406),
    [anon_sym_lineadj] = ACTIONS(3406),
    [anon_sym_triangle] = ACTIONS(3406),
    [anon_sym_interface] = ACTIONS(3406),
    [anon_sym_extension] = ACTIONS(3406),
    [anon_sym___init] = ACTIONS(3406),
    [anon_sym___subscript] = ACTIONS(3406),
    [anon_sym_property] = ACTIONS(3406),
    [anon_sym_associatedtype] = ACTIONS(3406),
  },
  [2380] = {
    [sym_expression] = STATE(5553),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2381] = {
    [sym_expression] = STATE(3755),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [2382] = {
    [sym_expression] = STATE(5367),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2383] = {
    [sym_expression] = STATE(3722),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(4134),
    [sym_concatenated_string] = STATE(4159),
    [sym_string_literal] = STATE(3152),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(3145),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4587),
    [anon_sym_LPAREN2] = ACTIONS(5819),
    [anon_sym_BANG] = ACTIONS(4591),
    [anon_sym_TILDE] = ACTIONS(4591),
    [anon_sym_DASH] = ACTIONS(4589),
    [anon_sym_PLUS] = ACTIONS(4589),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4593),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4589),
    [anon_sym_compl] = ACTIONS(4589),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_sizeof] = ACTIONS(4595),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4597),
    [anon_sym_L_SQUOTE] = ACTIONS(4599),
    [anon_sym_u_SQUOTE] = ACTIONS(4599),
    [anon_sym_U_SQUOTE] = ACTIONS(4599),
    [anon_sym_u8_SQUOTE] = ACTIONS(4599),
    [anon_sym_SQUOTE] = ACTIONS(4599),
    [anon_sym_L_DQUOTE] = ACTIONS(4601),
    [anon_sym_u_DQUOTE] = ACTIONS(4601),
    [anon_sym_U_DQUOTE] = ACTIONS(4601),
    [anon_sym_u8_DQUOTE] = ACTIONS(4601),
    [anon_sym_DQUOTE] = ACTIONS(4601),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4603),
    [anon_sym_R_DQUOTE] = ACTIONS(4605),
    [anon_sym_LR_DQUOTE] = ACTIONS(4605),
    [anon_sym_uR_DQUOTE] = ACTIONS(4605),
    [anon_sym_UR_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4605),
    [anon_sym_co_await] = ACTIONS(4607),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2384] = {
    [sym_expression] = STATE(3724),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(4134),
    [sym_concatenated_string] = STATE(4159),
    [sym_string_literal] = STATE(3152),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(3145),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4587),
    [anon_sym_LPAREN2] = ACTIONS(5819),
    [anon_sym_BANG] = ACTIONS(4591),
    [anon_sym_TILDE] = ACTIONS(4591),
    [anon_sym_DASH] = ACTIONS(4589),
    [anon_sym_PLUS] = ACTIONS(4589),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4593),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4589),
    [anon_sym_compl] = ACTIONS(4589),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_sizeof] = ACTIONS(4595),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4597),
    [anon_sym_L_SQUOTE] = ACTIONS(4599),
    [anon_sym_u_SQUOTE] = ACTIONS(4599),
    [anon_sym_U_SQUOTE] = ACTIONS(4599),
    [anon_sym_u8_SQUOTE] = ACTIONS(4599),
    [anon_sym_SQUOTE] = ACTIONS(4599),
    [anon_sym_L_DQUOTE] = ACTIONS(4601),
    [anon_sym_u_DQUOTE] = ACTIONS(4601),
    [anon_sym_U_DQUOTE] = ACTIONS(4601),
    [anon_sym_u8_DQUOTE] = ACTIONS(4601),
    [anon_sym_DQUOTE] = ACTIONS(4601),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4603),
    [anon_sym_R_DQUOTE] = ACTIONS(4605),
    [anon_sym_LR_DQUOTE] = ACTIONS(4605),
    [anon_sym_uR_DQUOTE] = ACTIONS(4605),
    [anon_sym_UR_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4605),
    [anon_sym_co_await] = ACTIONS(4607),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2385] = {
    [sym_expression] = STATE(4536),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [2386] = {
    [sym_expression] = STATE(4534),
    [sym__string] = STATE(4638),
    [sym_conditional_expression] = STATE(4638),
    [sym_assignment_expression] = STATE(4638),
    [sym_pointer_expression] = STATE(4251),
    [sym_unary_expression] = STATE(4638),
    [sym_binary_expression] = STATE(4638),
    [sym_update_expression] = STATE(4638),
    [sym_cast_expression] = STATE(4638),
    [sym_sizeof_expression] = STATE(4638),
    [sym_alignof_expression] = STATE(4638),
    [sym_offsetof_expression] = STATE(4638),
    [sym_generic_expression] = STATE(4638),
    [sym_subscript_expression] = STATE(4251),
    [sym_call_expression] = STATE(4251),
    [sym_gnu_asm_expression] = STATE(4638),
    [sym_field_expression] = STATE(4251),
    [sym_compound_literal_expression] = STATE(4638),
    [sym_parenthesized_expression] = STATE(4251),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4575),
    [sym_string_literal] = STATE(3302),
    [sym_null] = STATE(4638),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9991),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4638),
    [sym_raw_string_literal] = STATE(3242),
    [sym_co_await_expression] = STATE(4638),
    [sym_new_expression] = STATE(4638),
    [sym_delete_expression] = STATE(4638),
    [sym_requires_clause] = STATE(4638),
    [sym_requires_expression] = STATE(4638),
    [sym_lambda_expression] = STATE(4638),
    [sym_lambda_capture_specifier] = STATE(7062),
    [sym_fold_expression] = STATE(4638),
    [sym_parameter_pack_expansion] = STATE(4638),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4251),
    [sym_qualified_type_identifier] = STATE(9991),
    [sym_user_defined_literal] = STATE(4251),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_LPAREN2] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(6114),
    [sym_primitive_type] = ACTIONS(4869),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_compl] = ACTIONS(2289),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_sizeof] = ACTIONS(2309),
    [anon_sym___alignof__] = ACTIONS(2311),
    [anon_sym___alignof] = ACTIONS(2311),
    [anon_sym__alignof] = ACTIONS(2311),
    [anon_sym_alignof] = ACTIONS(2311),
    [anon_sym__Alignof] = ACTIONS(2311),
    [anon_sym_offsetof] = ACTIONS(2313),
    [anon_sym__Generic] = ACTIONS(2315),
    [anon_sym_asm] = ACTIONS(2317),
    [anon_sym___asm__] = ACTIONS(2317),
    [sym_number_literal] = ACTIONS(2319),
    [anon_sym_L_SQUOTE] = ACTIONS(2321),
    [anon_sym_u_SQUOTE] = ACTIONS(2321),
    [anon_sym_U_SQUOTE] = ACTIONS(2321),
    [anon_sym_u8_SQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [anon_sym_L_DQUOTE] = ACTIONS(2323),
    [anon_sym_u_DQUOTE] = ACTIONS(2323),
    [anon_sym_U_DQUOTE] = ACTIONS(2323),
    [anon_sym_u8_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [anon_sym_NULL] = ACTIONS(2327),
    [anon_sym_nullptr] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2331),
    [anon_sym_R_DQUOTE] = ACTIONS(2333),
    [anon_sym_LR_DQUOTE] = ACTIONS(2333),
    [anon_sym_uR_DQUOTE] = ACTIONS(2333),
    [anon_sym_UR_DQUOTE] = ACTIONS(2333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2333),
    [anon_sym_co_await] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_requires] = ACTIONS(2339),
    [sym_this] = ACTIONS(2325),
  },
  [2387] = {
    [sym_identifier] = ACTIONS(5618),
    [aux_sym_preproc_def_token1] = ACTIONS(5618),
    [aux_sym_preproc_if_token1] = ACTIONS(5618),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5618),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5618),
    [sym_preproc_directive] = ACTIONS(5618),
    [anon_sym_LPAREN2] = ACTIONS(5620),
    [anon_sym_TILDE] = ACTIONS(5620),
    [anon_sym_STAR] = ACTIONS(5620),
    [anon_sym_AMP_AMP] = ACTIONS(5620),
    [anon_sym_AMP] = ACTIONS(5618),
    [anon_sym___extension__] = ACTIONS(5618),
    [anon_sym_typedef] = ACTIONS(5618),
    [anon_sym_in] = ACTIONS(5618),
    [anon_sym_out] = ACTIONS(5618),
    [anon_sym_inout] = ACTIONS(5618),
    [anon_sym_extern] = ACTIONS(5618),
    [anon_sym___attribute__] = ACTIONS(5618),
    [anon_sym_COLON_COLON] = ACTIONS(5620),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5620),
    [anon_sym___declspec] = ACTIONS(5618),
    [anon_sym___based] = ACTIONS(5618),
    [anon_sym_RBRACE] = ACTIONS(5620),
    [anon_sym_signed] = ACTIONS(5618),
    [anon_sym_unsigned] = ACTIONS(5618),
    [anon_sym_long] = ACTIONS(5618),
    [anon_sym_short] = ACTIONS(5618),
    [anon_sym_LBRACK] = ACTIONS(5618),
    [anon_sym_static] = ACTIONS(5618),
    [anon_sym_register] = ACTIONS(5618),
    [anon_sym_inline] = ACTIONS(5618),
    [anon_sym___inline] = ACTIONS(5618),
    [anon_sym___inline__] = ACTIONS(5618),
    [anon_sym___forceinline] = ACTIONS(5618),
    [anon_sym_thread_local] = ACTIONS(5618),
    [anon_sym___thread] = ACTIONS(5618),
    [anon_sym_const] = ACTIONS(5618),
    [anon_sym_constexpr] = ACTIONS(5618),
    [anon_sym_volatile] = ACTIONS(5618),
    [anon_sym_restrict] = ACTIONS(5618),
    [anon_sym___restrict__] = ACTIONS(5618),
    [anon_sym__Atomic] = ACTIONS(5618),
    [anon_sym__Noreturn] = ACTIONS(5618),
    [anon_sym_noreturn] = ACTIONS(5618),
    [anon_sym_mutable] = ACTIONS(5618),
    [anon_sym_constinit] = ACTIONS(5618),
    [anon_sym_consteval] = ACTIONS(5618),
    [anon_sym_alignas] = ACTIONS(5618),
    [anon_sym__Alignas] = ACTIONS(5618),
    [sym_primitive_type] = ACTIONS(5618),
    [anon_sym_enum] = ACTIONS(5618),
    [anon_sym_class] = ACTIONS(5618),
    [anon_sym_struct] = ACTIONS(5618),
    [anon_sym_union] = ACTIONS(5618),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5618),
    [anon_sym_let] = ACTIONS(5618),
    [anon_sym_This] = ACTIONS(5618),
    [anon_sym_decltype] = ACTIONS(5618),
    [sym_virtual] = ACTIONS(5618),
    [anon_sym_explicit] = ACTIONS(5618),
    [anon_sym_typename] = ACTIONS(5618),
    [anon_sym_template] = ACTIONS(5618),
    [anon_sym_operator] = ACTIONS(5618),
    [anon_sym_friend] = ACTIONS(5618),
    [anon_sym_public] = ACTIONS(5618),
    [anon_sym_private] = ACTIONS(5618),
    [anon_sym_protected] = ACTIONS(5618),
    [anon_sym_using] = ACTIONS(5618),
    [anon_sym_static_assert] = ACTIONS(5618),
    [anon_sym_precise] = ACTIONS(5618),
    [anon_sym_shared] = ACTIONS(5618),
    [anon_sym_groupshared] = ACTIONS(5618),
    [anon_sym_uniform] = ACTIONS(5618),
    [anon_sym_row_major] = ACTIONS(5618),
    [anon_sym_column_major] = ACTIONS(5618),
    [anon_sym_globallycoherent] = ACTIONS(5618),
    [anon_sym_centroid] = ACTIONS(5618),
    [anon_sym_noperspective] = ACTIONS(5618),
    [anon_sym_nointerpolation] = ACTIONS(5618),
    [anon_sym_sample] = ACTIONS(5618),
    [anon_sym_linear] = ACTIONS(5618),
    [anon_sym_snorm] = ACTIONS(5618),
    [anon_sym_unorm] = ACTIONS(5618),
    [anon_sym_point] = ACTIONS(5618),
    [anon_sym_line] = ACTIONS(5618),
    [anon_sym_triangleadj] = ACTIONS(5618),
    [anon_sym_lineadj] = ACTIONS(5618),
    [anon_sym_triangle] = ACTIONS(5618),
    [anon_sym_interface] = ACTIONS(5618),
    [anon_sym_extension] = ACTIONS(5618),
    [anon_sym___init] = ACTIONS(5618),
    [anon_sym___subscript] = ACTIONS(5618),
    [anon_sym_property] = ACTIONS(5618),
    [anon_sym_associatedtype] = ACTIONS(5618),
  },
  [2388] = {
    [sym_expression] = STATE(5299),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2389] = {
    [sym_expression] = STATE(5303),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2390] = {
    [sym_expression] = STATE(5045),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2391] = {
    [sym_expression] = STATE(5305),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2392] = {
    [sym_expression] = STATE(3215),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(4134),
    [sym_concatenated_string] = STATE(4159),
    [sym_string_literal] = STATE(3152),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(3145),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4587),
    [anon_sym_LPAREN2] = ACTIONS(5819),
    [anon_sym_BANG] = ACTIONS(4591),
    [anon_sym_TILDE] = ACTIONS(4591),
    [anon_sym_DASH] = ACTIONS(4589),
    [anon_sym_PLUS] = ACTIONS(4589),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4593),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4589),
    [anon_sym_compl] = ACTIONS(4589),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_sizeof] = ACTIONS(4595),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4597),
    [anon_sym_L_SQUOTE] = ACTIONS(4599),
    [anon_sym_u_SQUOTE] = ACTIONS(4599),
    [anon_sym_U_SQUOTE] = ACTIONS(4599),
    [anon_sym_u8_SQUOTE] = ACTIONS(4599),
    [anon_sym_SQUOTE] = ACTIONS(4599),
    [anon_sym_L_DQUOTE] = ACTIONS(4601),
    [anon_sym_u_DQUOTE] = ACTIONS(4601),
    [anon_sym_U_DQUOTE] = ACTIONS(4601),
    [anon_sym_u8_DQUOTE] = ACTIONS(4601),
    [anon_sym_DQUOTE] = ACTIONS(4601),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4603),
    [anon_sym_R_DQUOTE] = ACTIONS(4605),
    [anon_sym_LR_DQUOTE] = ACTIONS(4605),
    [anon_sym_uR_DQUOTE] = ACTIONS(4605),
    [anon_sym_UR_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4605),
    [anon_sym_co_await] = ACTIONS(4607),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2393] = {
    [sym_expression] = STATE(5552),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2394] = {
    [sym_identifier] = ACTIONS(5622),
    [aux_sym_preproc_def_token1] = ACTIONS(5622),
    [aux_sym_preproc_if_token1] = ACTIONS(5622),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5622),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5622),
    [sym_preproc_directive] = ACTIONS(5622),
    [anon_sym_LPAREN2] = ACTIONS(5624),
    [anon_sym_TILDE] = ACTIONS(5624),
    [anon_sym_STAR] = ACTIONS(5624),
    [anon_sym_AMP_AMP] = ACTIONS(5624),
    [anon_sym_AMP] = ACTIONS(5622),
    [anon_sym___extension__] = ACTIONS(5622),
    [anon_sym_typedef] = ACTIONS(5622),
    [anon_sym_in] = ACTIONS(5622),
    [anon_sym_out] = ACTIONS(5622),
    [anon_sym_inout] = ACTIONS(5622),
    [anon_sym_extern] = ACTIONS(5622),
    [anon_sym___attribute__] = ACTIONS(5622),
    [anon_sym_COLON_COLON] = ACTIONS(5624),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5624),
    [anon_sym___declspec] = ACTIONS(5622),
    [anon_sym___based] = ACTIONS(5622),
    [anon_sym_RBRACE] = ACTIONS(5624),
    [anon_sym_signed] = ACTIONS(5622),
    [anon_sym_unsigned] = ACTIONS(5622),
    [anon_sym_long] = ACTIONS(5622),
    [anon_sym_short] = ACTIONS(5622),
    [anon_sym_LBRACK] = ACTIONS(5622),
    [anon_sym_static] = ACTIONS(5622),
    [anon_sym_register] = ACTIONS(5622),
    [anon_sym_inline] = ACTIONS(5622),
    [anon_sym___inline] = ACTIONS(5622),
    [anon_sym___inline__] = ACTIONS(5622),
    [anon_sym___forceinline] = ACTIONS(5622),
    [anon_sym_thread_local] = ACTIONS(5622),
    [anon_sym___thread] = ACTIONS(5622),
    [anon_sym_const] = ACTIONS(5622),
    [anon_sym_constexpr] = ACTIONS(5622),
    [anon_sym_volatile] = ACTIONS(5622),
    [anon_sym_restrict] = ACTIONS(5622),
    [anon_sym___restrict__] = ACTIONS(5622),
    [anon_sym__Atomic] = ACTIONS(5622),
    [anon_sym__Noreturn] = ACTIONS(5622),
    [anon_sym_noreturn] = ACTIONS(5622),
    [anon_sym_mutable] = ACTIONS(5622),
    [anon_sym_constinit] = ACTIONS(5622),
    [anon_sym_consteval] = ACTIONS(5622),
    [anon_sym_alignas] = ACTIONS(5622),
    [anon_sym__Alignas] = ACTIONS(5622),
    [sym_primitive_type] = ACTIONS(5622),
    [anon_sym_enum] = ACTIONS(5622),
    [anon_sym_class] = ACTIONS(5622),
    [anon_sym_struct] = ACTIONS(5622),
    [anon_sym_union] = ACTIONS(5622),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5622),
    [anon_sym_let] = ACTIONS(5622),
    [anon_sym_This] = ACTIONS(5622),
    [anon_sym_decltype] = ACTIONS(5622),
    [sym_virtual] = ACTIONS(5622),
    [anon_sym_explicit] = ACTIONS(5622),
    [anon_sym_typename] = ACTIONS(5622),
    [anon_sym_template] = ACTIONS(5622),
    [anon_sym_operator] = ACTIONS(5622),
    [anon_sym_friend] = ACTIONS(5622),
    [anon_sym_public] = ACTIONS(5622),
    [anon_sym_private] = ACTIONS(5622),
    [anon_sym_protected] = ACTIONS(5622),
    [anon_sym_using] = ACTIONS(5622),
    [anon_sym_static_assert] = ACTIONS(5622),
    [anon_sym_precise] = ACTIONS(5622),
    [anon_sym_shared] = ACTIONS(5622),
    [anon_sym_groupshared] = ACTIONS(5622),
    [anon_sym_uniform] = ACTIONS(5622),
    [anon_sym_row_major] = ACTIONS(5622),
    [anon_sym_column_major] = ACTIONS(5622),
    [anon_sym_globallycoherent] = ACTIONS(5622),
    [anon_sym_centroid] = ACTIONS(5622),
    [anon_sym_noperspective] = ACTIONS(5622),
    [anon_sym_nointerpolation] = ACTIONS(5622),
    [anon_sym_sample] = ACTIONS(5622),
    [anon_sym_linear] = ACTIONS(5622),
    [anon_sym_snorm] = ACTIONS(5622),
    [anon_sym_unorm] = ACTIONS(5622),
    [anon_sym_point] = ACTIONS(5622),
    [anon_sym_line] = ACTIONS(5622),
    [anon_sym_triangleadj] = ACTIONS(5622),
    [anon_sym_lineadj] = ACTIONS(5622),
    [anon_sym_triangle] = ACTIONS(5622),
    [anon_sym_interface] = ACTIONS(5622),
    [anon_sym_extension] = ACTIONS(5622),
    [anon_sym___init] = ACTIONS(5622),
    [anon_sym___subscript] = ACTIONS(5622),
    [anon_sym_property] = ACTIONS(5622),
    [anon_sym_associatedtype] = ACTIONS(5622),
  },
  [2395] = {
    [sym_expression] = STATE(5306),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2396] = {
    [sym_expression] = STATE(5439),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2397] = {
    [sym_expression] = STATE(3725),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(4134),
    [sym_concatenated_string] = STATE(4159),
    [sym_string_literal] = STATE(3152),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(3145),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4587),
    [anon_sym_LPAREN2] = ACTIONS(5819),
    [anon_sym_BANG] = ACTIONS(4591),
    [anon_sym_TILDE] = ACTIONS(4591),
    [anon_sym_DASH] = ACTIONS(4589),
    [anon_sym_PLUS] = ACTIONS(4589),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4593),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4589),
    [anon_sym_compl] = ACTIONS(4589),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_sizeof] = ACTIONS(4595),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4597),
    [anon_sym_L_SQUOTE] = ACTIONS(4599),
    [anon_sym_u_SQUOTE] = ACTIONS(4599),
    [anon_sym_U_SQUOTE] = ACTIONS(4599),
    [anon_sym_u8_SQUOTE] = ACTIONS(4599),
    [anon_sym_SQUOTE] = ACTIONS(4599),
    [anon_sym_L_DQUOTE] = ACTIONS(4601),
    [anon_sym_u_DQUOTE] = ACTIONS(4601),
    [anon_sym_U_DQUOTE] = ACTIONS(4601),
    [anon_sym_u8_DQUOTE] = ACTIONS(4601),
    [anon_sym_DQUOTE] = ACTIONS(4601),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4603),
    [anon_sym_R_DQUOTE] = ACTIONS(4605),
    [anon_sym_LR_DQUOTE] = ACTIONS(4605),
    [anon_sym_uR_DQUOTE] = ACTIONS(4605),
    [anon_sym_UR_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4605),
    [anon_sym_co_await] = ACTIONS(4607),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2398] = {
    [sym_expression] = STATE(5197),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2399] = {
    [sym_expression] = STATE(5042),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2400] = {
    [sym_expression] = STATE(5041),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2401] = {
    [sym_expression] = STATE(4182),
    [sym__string] = STATE(4545),
    [sym_conditional_expression] = STATE(4545),
    [sym_assignment_expression] = STATE(4545),
    [sym_pointer_expression] = STATE(4540),
    [sym_unary_expression] = STATE(4545),
    [sym_binary_expression] = STATE(4545),
    [sym_update_expression] = STATE(4545),
    [sym_cast_expression] = STATE(4545),
    [sym_sizeof_expression] = STATE(4545),
    [sym_alignof_expression] = STATE(4545),
    [sym_offsetof_expression] = STATE(4545),
    [sym_generic_expression] = STATE(4545),
    [sym_subscript_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_gnu_asm_expression] = STATE(4545),
    [sym_field_expression] = STATE(4540),
    [sym_compound_literal_expression] = STATE(4545),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_char_literal] = STATE(4286),
    [sym_concatenated_string] = STATE(4290),
    [sym_string_literal] = STATE(3166),
    [sym_null] = STATE(4545),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9673),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4545),
    [sym_raw_string_literal] = STATE(3169),
    [sym_co_await_expression] = STATE(4545),
    [sym_new_expression] = STATE(4545),
    [sym_delete_expression] = STATE(4545),
    [sym_requires_clause] = STATE(4545),
    [sym_requires_expression] = STATE(4545),
    [sym_lambda_expression] = STATE(4545),
    [sym_lambda_capture_specifier] = STATE(7034),
    [sym_fold_expression] = STATE(4545),
    [sym_parameter_pack_expansion] = STATE(4545),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4540),
    [sym_qualified_type_identifier] = STATE(9673),
    [sym_user_defined_literal] = STATE(4540),
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_LPAREN2] = ACTIONS(5828),
    [anon_sym_BANG] = ACTIONS(4733),
    [anon_sym_TILDE] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4731),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4735),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4739),
    [anon_sym_not] = ACTIONS(4731),
    [anon_sym_compl] = ACTIONS(4731),
    [anon_sym_DASH_DASH] = ACTIONS(5711),
    [anon_sym_PLUS_PLUS] = ACTIONS(5711),
    [anon_sym_sizeof] = ACTIONS(4741),
    [anon_sym___alignof__] = ACTIONS(4743),
    [anon_sym___alignof] = ACTIONS(4743),
    [anon_sym__alignof] = ACTIONS(4743),
    [anon_sym_alignof] = ACTIONS(4743),
    [anon_sym__Alignof] = ACTIONS(4743),
    [anon_sym_offsetof] = ACTIONS(4745),
    [anon_sym__Generic] = ACTIONS(4747),
    [anon_sym_asm] = ACTIONS(4749),
    [anon_sym___asm__] = ACTIONS(4749),
    [sym_number_literal] = ACTIONS(4751),
    [anon_sym_L_SQUOTE] = ACTIONS(4753),
    [anon_sym_u_SQUOTE] = ACTIONS(4753),
    [anon_sym_U_SQUOTE] = ACTIONS(4753),
    [anon_sym_u8_SQUOTE] = ACTIONS(4753),
    [anon_sym_SQUOTE] = ACTIONS(4753),
    [anon_sym_L_DQUOTE] = ACTIONS(4755),
    [anon_sym_u_DQUOTE] = ACTIONS(4755),
    [anon_sym_U_DQUOTE] = ACTIONS(4755),
    [anon_sym_u8_DQUOTE] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [anon_sym_NULL] = ACTIONS(4759),
    [anon_sym_nullptr] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4761),
    [anon_sym_R_DQUOTE] = ACTIONS(4763),
    [anon_sym_LR_DQUOTE] = ACTIONS(4763),
    [anon_sym_uR_DQUOTE] = ACTIONS(4763),
    [anon_sym_UR_DQUOTE] = ACTIONS(4763),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4763),
    [anon_sym_co_await] = ACTIONS(4765),
    [anon_sym_new] = ACTIONS(4767),
    [anon_sym_requires] = ACTIONS(4769),
    [sym_this] = ACTIONS(4757),
  },
  [2402] = {
    [sym_expression] = STATE(5198),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2403] = {
    [sym_expression] = STATE(5199),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2404] = {
    [sym_expression] = STATE(5389),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2405] = {
    [sym_expression] = STATE(5387),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2406] = {
    [sym_expression] = STATE(5385),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2407] = {
    [sym_expression] = STATE(5188),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4958),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4964),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2408] = {
    [sym_identifier] = ACTIONS(3637),
    [aux_sym_preproc_def_token1] = ACTIONS(3637),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3637),
    [sym_preproc_directive] = ACTIONS(3637),
    [anon_sym_LPAREN2] = ACTIONS(3639),
    [anon_sym_TILDE] = ACTIONS(3639),
    [anon_sym_STAR] = ACTIONS(3639),
    [anon_sym_AMP_AMP] = ACTIONS(3639),
    [anon_sym_AMP] = ACTIONS(3637),
    [anon_sym___extension__] = ACTIONS(3637),
    [anon_sym_typedef] = ACTIONS(3637),
    [anon_sym_in] = ACTIONS(3637),
    [anon_sym_out] = ACTIONS(3637),
    [anon_sym_inout] = ACTIONS(3637),
    [anon_sym_extern] = ACTIONS(3637),
    [anon_sym___attribute__] = ACTIONS(3637),
    [anon_sym_COLON_COLON] = ACTIONS(3639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3639),
    [anon_sym___declspec] = ACTIONS(3637),
    [anon_sym___based] = ACTIONS(3637),
    [anon_sym_RBRACE] = ACTIONS(3639),
    [anon_sym_signed] = ACTIONS(3637),
    [anon_sym_unsigned] = ACTIONS(3637),
    [anon_sym_long] = ACTIONS(3637),
    [anon_sym_short] = ACTIONS(3637),
    [anon_sym_LBRACK] = ACTIONS(3637),
    [anon_sym_static] = ACTIONS(3637),
    [anon_sym_register] = ACTIONS(3637),
    [anon_sym_inline] = ACTIONS(3637),
    [anon_sym___inline] = ACTIONS(3637),
    [anon_sym___inline__] = ACTIONS(3637),
    [anon_sym___forceinline] = ACTIONS(3637),
    [anon_sym_thread_local] = ACTIONS(3637),
    [anon_sym___thread] = ACTIONS(3637),
    [anon_sym_const] = ACTIONS(3637),
    [anon_sym_constexpr] = ACTIONS(3637),
    [anon_sym_volatile] = ACTIONS(3637),
    [anon_sym_restrict] = ACTIONS(3637),
    [anon_sym___restrict__] = ACTIONS(3637),
    [anon_sym__Atomic] = ACTIONS(3637),
    [anon_sym__Noreturn] = ACTIONS(3637),
    [anon_sym_noreturn] = ACTIONS(3637),
    [anon_sym_mutable] = ACTIONS(3637),
    [anon_sym_constinit] = ACTIONS(3637),
    [anon_sym_consteval] = ACTIONS(3637),
    [anon_sym_alignas] = ACTIONS(3637),
    [anon_sym__Alignas] = ACTIONS(3637),
    [sym_primitive_type] = ACTIONS(3637),
    [anon_sym_enum] = ACTIONS(3637),
    [anon_sym_class] = ACTIONS(3637),
    [anon_sym_struct] = ACTIONS(3637),
    [anon_sym_union] = ACTIONS(3637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3637),
    [anon_sym_let] = ACTIONS(3637),
    [anon_sym_This] = ACTIONS(3637),
    [anon_sym_decltype] = ACTIONS(3637),
    [sym_virtual] = ACTIONS(3637),
    [anon_sym_explicit] = ACTIONS(3637),
    [anon_sym_typename] = ACTIONS(3637),
    [anon_sym_template] = ACTIONS(3637),
    [anon_sym_operator] = ACTIONS(3637),
    [anon_sym_friend] = ACTIONS(3637),
    [anon_sym_public] = ACTIONS(3637),
    [anon_sym_private] = ACTIONS(3637),
    [anon_sym_protected] = ACTIONS(3637),
    [anon_sym_using] = ACTIONS(3637),
    [anon_sym_static_assert] = ACTIONS(3637),
    [anon_sym_precise] = ACTIONS(3637),
    [anon_sym_shared] = ACTIONS(3637),
    [anon_sym_groupshared] = ACTIONS(3637),
    [anon_sym_uniform] = ACTIONS(3637),
    [anon_sym_row_major] = ACTIONS(3637),
    [anon_sym_column_major] = ACTIONS(3637),
    [anon_sym_globallycoherent] = ACTIONS(3637),
    [anon_sym_centroid] = ACTIONS(3637),
    [anon_sym_noperspective] = ACTIONS(3637),
    [anon_sym_nointerpolation] = ACTIONS(3637),
    [anon_sym_sample] = ACTIONS(3637),
    [anon_sym_linear] = ACTIONS(3637),
    [anon_sym_snorm] = ACTIONS(3637),
    [anon_sym_unorm] = ACTIONS(3637),
    [anon_sym_point] = ACTIONS(3637),
    [anon_sym_line] = ACTIONS(3637),
    [anon_sym_triangleadj] = ACTIONS(3637),
    [anon_sym_lineadj] = ACTIONS(3637),
    [anon_sym_triangle] = ACTIONS(3637),
    [anon_sym_interface] = ACTIONS(3637),
    [anon_sym_extension] = ACTIONS(3637),
    [anon_sym___init] = ACTIONS(3637),
    [anon_sym___subscript] = ACTIONS(3637),
    [anon_sym_property] = ACTIONS(3637),
    [anon_sym_associatedtype] = ACTIONS(3637),
  },
  [2409] = {
    [sym_expression] = STATE(3727),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(4134),
    [sym_concatenated_string] = STATE(4159),
    [sym_string_literal] = STATE(3152),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(3145),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4587),
    [anon_sym_LPAREN2] = ACTIONS(5819),
    [anon_sym_BANG] = ACTIONS(4591),
    [anon_sym_TILDE] = ACTIONS(4591),
    [anon_sym_DASH] = ACTIONS(4589),
    [anon_sym_PLUS] = ACTIONS(4589),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4593),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4589),
    [anon_sym_compl] = ACTIONS(4589),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_sizeof] = ACTIONS(4595),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4597),
    [anon_sym_L_SQUOTE] = ACTIONS(4599),
    [anon_sym_u_SQUOTE] = ACTIONS(4599),
    [anon_sym_U_SQUOTE] = ACTIONS(4599),
    [anon_sym_u8_SQUOTE] = ACTIONS(4599),
    [anon_sym_SQUOTE] = ACTIONS(4599),
    [anon_sym_L_DQUOTE] = ACTIONS(4601),
    [anon_sym_u_DQUOTE] = ACTIONS(4601),
    [anon_sym_U_DQUOTE] = ACTIONS(4601),
    [anon_sym_u8_DQUOTE] = ACTIONS(4601),
    [anon_sym_DQUOTE] = ACTIONS(4601),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4603),
    [anon_sym_R_DQUOTE] = ACTIONS(4605),
    [anon_sym_LR_DQUOTE] = ACTIONS(4605),
    [anon_sym_uR_DQUOTE] = ACTIONS(4605),
    [anon_sym_UR_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4605),
    [anon_sym_co_await] = ACTIONS(4607),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2410] = {
    [sym_expression] = STATE(3728),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(4134),
    [sym_concatenated_string] = STATE(4159),
    [sym_string_literal] = STATE(3152),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(3145),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4587),
    [anon_sym_LPAREN2] = ACTIONS(5819),
    [anon_sym_BANG] = ACTIONS(4591),
    [anon_sym_TILDE] = ACTIONS(4591),
    [anon_sym_DASH] = ACTIONS(4589),
    [anon_sym_PLUS] = ACTIONS(4589),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4593),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4589),
    [anon_sym_compl] = ACTIONS(4589),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_sizeof] = ACTIONS(4595),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4597),
    [anon_sym_L_SQUOTE] = ACTIONS(4599),
    [anon_sym_u_SQUOTE] = ACTIONS(4599),
    [anon_sym_U_SQUOTE] = ACTIONS(4599),
    [anon_sym_u8_SQUOTE] = ACTIONS(4599),
    [anon_sym_SQUOTE] = ACTIONS(4599),
    [anon_sym_L_DQUOTE] = ACTIONS(4601),
    [anon_sym_u_DQUOTE] = ACTIONS(4601),
    [anon_sym_U_DQUOTE] = ACTIONS(4601),
    [anon_sym_u8_DQUOTE] = ACTIONS(4601),
    [anon_sym_DQUOTE] = ACTIONS(4601),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4603),
    [anon_sym_R_DQUOTE] = ACTIONS(4605),
    [anon_sym_LR_DQUOTE] = ACTIONS(4605),
    [anon_sym_uR_DQUOTE] = ACTIONS(4605),
    [anon_sym_UR_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4605),
    [anon_sym_co_await] = ACTIONS(4607),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2411] = {
    [sym_expression] = STATE(5308),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2412] = {
    [sym_identifier] = ACTIONS(5564),
    [aux_sym_preproc_def_token1] = ACTIONS(5564),
    [aux_sym_preproc_if_token1] = ACTIONS(5564),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5564),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5564),
    [sym_preproc_directive] = ACTIONS(5564),
    [anon_sym_LPAREN2] = ACTIONS(5566),
    [anon_sym_TILDE] = ACTIONS(5566),
    [anon_sym_STAR] = ACTIONS(5566),
    [anon_sym_AMP_AMP] = ACTIONS(5566),
    [anon_sym_AMP] = ACTIONS(5564),
    [anon_sym___extension__] = ACTIONS(5564),
    [anon_sym_typedef] = ACTIONS(5564),
    [anon_sym_in] = ACTIONS(5564),
    [anon_sym_out] = ACTIONS(5564),
    [anon_sym_inout] = ACTIONS(5564),
    [anon_sym_extern] = ACTIONS(5564),
    [anon_sym___attribute__] = ACTIONS(5564),
    [anon_sym_COLON_COLON] = ACTIONS(5566),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5566),
    [anon_sym___declspec] = ACTIONS(5564),
    [anon_sym___based] = ACTIONS(5564),
    [anon_sym_RBRACE] = ACTIONS(5566),
    [anon_sym_signed] = ACTIONS(5564),
    [anon_sym_unsigned] = ACTIONS(5564),
    [anon_sym_long] = ACTIONS(5564),
    [anon_sym_short] = ACTIONS(5564),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_static] = ACTIONS(5564),
    [anon_sym_register] = ACTIONS(5564),
    [anon_sym_inline] = ACTIONS(5564),
    [anon_sym___inline] = ACTIONS(5564),
    [anon_sym___inline__] = ACTIONS(5564),
    [anon_sym___forceinline] = ACTIONS(5564),
    [anon_sym_thread_local] = ACTIONS(5564),
    [anon_sym___thread] = ACTIONS(5564),
    [anon_sym_const] = ACTIONS(5564),
    [anon_sym_constexpr] = ACTIONS(5564),
    [anon_sym_volatile] = ACTIONS(5564),
    [anon_sym_restrict] = ACTIONS(5564),
    [anon_sym___restrict__] = ACTIONS(5564),
    [anon_sym__Atomic] = ACTIONS(5564),
    [anon_sym__Noreturn] = ACTIONS(5564),
    [anon_sym_noreturn] = ACTIONS(5564),
    [anon_sym_mutable] = ACTIONS(5564),
    [anon_sym_constinit] = ACTIONS(5564),
    [anon_sym_consteval] = ACTIONS(5564),
    [anon_sym_alignas] = ACTIONS(5564),
    [anon_sym__Alignas] = ACTIONS(5564),
    [sym_primitive_type] = ACTIONS(5564),
    [anon_sym_enum] = ACTIONS(5564),
    [anon_sym_class] = ACTIONS(5564),
    [anon_sym_struct] = ACTIONS(5564),
    [anon_sym_union] = ACTIONS(5564),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5564),
    [anon_sym_let] = ACTIONS(5564),
    [anon_sym_This] = ACTIONS(5564),
    [anon_sym_decltype] = ACTIONS(5564),
    [sym_virtual] = ACTIONS(5564),
    [anon_sym_explicit] = ACTIONS(5564),
    [anon_sym_typename] = ACTIONS(5564),
    [anon_sym_template] = ACTIONS(5564),
    [anon_sym_operator] = ACTIONS(5564),
    [anon_sym_friend] = ACTIONS(5564),
    [anon_sym_public] = ACTIONS(5564),
    [anon_sym_private] = ACTIONS(5564),
    [anon_sym_protected] = ACTIONS(5564),
    [anon_sym_using] = ACTIONS(5564),
    [anon_sym_static_assert] = ACTIONS(5564),
    [anon_sym_precise] = ACTIONS(5564),
    [anon_sym_shared] = ACTIONS(5564),
    [anon_sym_groupshared] = ACTIONS(5564),
    [anon_sym_uniform] = ACTIONS(5564),
    [anon_sym_row_major] = ACTIONS(5564),
    [anon_sym_column_major] = ACTIONS(5564),
    [anon_sym_globallycoherent] = ACTIONS(5564),
    [anon_sym_centroid] = ACTIONS(5564),
    [anon_sym_noperspective] = ACTIONS(5564),
    [anon_sym_nointerpolation] = ACTIONS(5564),
    [anon_sym_sample] = ACTIONS(5564),
    [anon_sym_linear] = ACTIONS(5564),
    [anon_sym_snorm] = ACTIONS(5564),
    [anon_sym_unorm] = ACTIONS(5564),
    [anon_sym_point] = ACTIONS(5564),
    [anon_sym_line] = ACTIONS(5564),
    [anon_sym_triangleadj] = ACTIONS(5564),
    [anon_sym_lineadj] = ACTIONS(5564),
    [anon_sym_triangle] = ACTIONS(5564),
    [anon_sym_interface] = ACTIONS(5564),
    [anon_sym_extension] = ACTIONS(5564),
    [anon_sym___init] = ACTIONS(5564),
    [anon_sym___subscript] = ACTIONS(5564),
    [anon_sym_property] = ACTIONS(5564),
    [anon_sym_associatedtype] = ACTIONS(5564),
  },
  [2413] = {
    [sym_expression] = STATE(5039),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2414] = {
    [sym_expression] = STATE(5234),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2415] = {
    [sym_expression] = STATE(5382),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2416] = {
    [sym_expression] = STATE(3729),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(4134),
    [sym_concatenated_string] = STATE(4159),
    [sym_string_literal] = STATE(3152),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(3145),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4587),
    [anon_sym_LPAREN2] = ACTIONS(5819),
    [anon_sym_BANG] = ACTIONS(4591),
    [anon_sym_TILDE] = ACTIONS(4591),
    [anon_sym_DASH] = ACTIONS(4589),
    [anon_sym_PLUS] = ACTIONS(4589),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4593),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4589),
    [anon_sym_compl] = ACTIONS(4589),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_sizeof] = ACTIONS(4595),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4597),
    [anon_sym_L_SQUOTE] = ACTIONS(4599),
    [anon_sym_u_SQUOTE] = ACTIONS(4599),
    [anon_sym_U_SQUOTE] = ACTIONS(4599),
    [anon_sym_u8_SQUOTE] = ACTIONS(4599),
    [anon_sym_SQUOTE] = ACTIONS(4599),
    [anon_sym_L_DQUOTE] = ACTIONS(4601),
    [anon_sym_u_DQUOTE] = ACTIONS(4601),
    [anon_sym_U_DQUOTE] = ACTIONS(4601),
    [anon_sym_u8_DQUOTE] = ACTIONS(4601),
    [anon_sym_DQUOTE] = ACTIONS(4601),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4603),
    [anon_sym_R_DQUOTE] = ACTIONS(4605),
    [anon_sym_LR_DQUOTE] = ACTIONS(4605),
    [anon_sym_uR_DQUOTE] = ACTIONS(4605),
    [anon_sym_UR_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4605),
    [anon_sym_co_await] = ACTIONS(4607),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2417] = {
    [sym_identifier] = ACTIONS(3691),
    [aux_sym_preproc_def_token1] = ACTIONS(3691),
    [aux_sym_preproc_if_token1] = ACTIONS(3691),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3691),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3691),
    [sym_preproc_directive] = ACTIONS(3691),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3693),
    [anon_sym_STAR] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_AMP] = ACTIONS(3691),
    [anon_sym___extension__] = ACTIONS(3691),
    [anon_sym_typedef] = ACTIONS(3691),
    [anon_sym_in] = ACTIONS(3691),
    [anon_sym_out] = ACTIONS(3691),
    [anon_sym_inout] = ACTIONS(3691),
    [anon_sym_extern] = ACTIONS(3691),
    [anon_sym___attribute__] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3693),
    [anon_sym___declspec] = ACTIONS(3691),
    [anon_sym___based] = ACTIONS(3691),
    [anon_sym_RBRACE] = ACTIONS(3693),
    [anon_sym_signed] = ACTIONS(3691),
    [anon_sym_unsigned] = ACTIONS(3691),
    [anon_sym_long] = ACTIONS(3691),
    [anon_sym_short] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(3691),
    [anon_sym_static] = ACTIONS(3691),
    [anon_sym_register] = ACTIONS(3691),
    [anon_sym_inline] = ACTIONS(3691),
    [anon_sym___inline] = ACTIONS(3691),
    [anon_sym___inline__] = ACTIONS(3691),
    [anon_sym___forceinline] = ACTIONS(3691),
    [anon_sym_thread_local] = ACTIONS(3691),
    [anon_sym___thread] = ACTIONS(3691),
    [anon_sym_const] = ACTIONS(3691),
    [anon_sym_constexpr] = ACTIONS(3691),
    [anon_sym_volatile] = ACTIONS(3691),
    [anon_sym_restrict] = ACTIONS(3691),
    [anon_sym___restrict__] = ACTIONS(3691),
    [anon_sym__Atomic] = ACTIONS(3691),
    [anon_sym__Noreturn] = ACTIONS(3691),
    [anon_sym_noreturn] = ACTIONS(3691),
    [anon_sym_mutable] = ACTIONS(3691),
    [anon_sym_constinit] = ACTIONS(3691),
    [anon_sym_consteval] = ACTIONS(3691),
    [anon_sym_alignas] = ACTIONS(3691),
    [anon_sym__Alignas] = ACTIONS(3691),
    [sym_primitive_type] = ACTIONS(3691),
    [anon_sym_enum] = ACTIONS(3691),
    [anon_sym_class] = ACTIONS(3691),
    [anon_sym_struct] = ACTIONS(3691),
    [anon_sym_union] = ACTIONS(3691),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3691),
    [anon_sym_let] = ACTIONS(3691),
    [anon_sym_This] = ACTIONS(3691),
    [anon_sym_decltype] = ACTIONS(3691),
    [sym_virtual] = ACTIONS(3691),
    [anon_sym_explicit] = ACTIONS(3691),
    [anon_sym_typename] = ACTIONS(3691),
    [anon_sym_template] = ACTIONS(3691),
    [anon_sym_operator] = ACTIONS(3691),
    [anon_sym_friend] = ACTIONS(3691),
    [anon_sym_public] = ACTIONS(3691),
    [anon_sym_private] = ACTIONS(3691),
    [anon_sym_protected] = ACTIONS(3691),
    [anon_sym_using] = ACTIONS(3691),
    [anon_sym_static_assert] = ACTIONS(3691),
    [anon_sym_precise] = ACTIONS(3691),
    [anon_sym_shared] = ACTIONS(3691),
    [anon_sym_groupshared] = ACTIONS(3691),
    [anon_sym_uniform] = ACTIONS(3691),
    [anon_sym_row_major] = ACTIONS(3691),
    [anon_sym_column_major] = ACTIONS(3691),
    [anon_sym_globallycoherent] = ACTIONS(3691),
    [anon_sym_centroid] = ACTIONS(3691),
    [anon_sym_noperspective] = ACTIONS(3691),
    [anon_sym_nointerpolation] = ACTIONS(3691),
    [anon_sym_sample] = ACTIONS(3691),
    [anon_sym_linear] = ACTIONS(3691),
    [anon_sym_snorm] = ACTIONS(3691),
    [anon_sym_unorm] = ACTIONS(3691),
    [anon_sym_point] = ACTIONS(3691),
    [anon_sym_line] = ACTIONS(3691),
    [anon_sym_triangleadj] = ACTIONS(3691),
    [anon_sym_lineadj] = ACTIONS(3691),
    [anon_sym_triangle] = ACTIONS(3691),
    [anon_sym_interface] = ACTIONS(3691),
    [anon_sym_extension] = ACTIONS(3691),
    [anon_sym___init] = ACTIONS(3691),
    [anon_sym___subscript] = ACTIONS(3691),
    [anon_sym_property] = ACTIONS(3691),
    [anon_sym_associatedtype] = ACTIONS(3691),
  },
  [2418] = {
    [sym_expression] = STATE(4592),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4905),
    [sym_concatenated_string] = STATE(4902),
    [sym_string_literal] = STATE(3611),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3610),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(5705),
    [anon_sym_LPAREN2] = ACTIONS(5834),
    [anon_sym_BANG] = ACTIONS(4926),
    [anon_sym_TILDE] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4928),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4924),
    [anon_sym_compl] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(5707),
    [anon_sym_PLUS_PLUS] = ACTIONS(5707),
    [anon_sym_sizeof] = ACTIONS(4932),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4934),
    [anon_sym_L_SQUOTE] = ACTIONS(4936),
    [anon_sym_u_SQUOTE] = ACTIONS(4936),
    [anon_sym_U_SQUOTE] = ACTIONS(4936),
    [anon_sym_u8_SQUOTE] = ACTIONS(4936),
    [anon_sym_SQUOTE] = ACTIONS(4936),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4938),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_co_await] = ACTIONS(4940),
    [anon_sym_new] = ACTIONS(4942),
    [anon_sym_requires] = ACTIONS(4944),
    [sym_this] = ACTIONS(241),
  },
  [2419] = {
    [sym_expression] = STATE(3586),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(6116),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2420] = {
    [sym_expression] = STATE(4852),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4905),
    [sym_concatenated_string] = STATE(4902),
    [sym_string_literal] = STATE(3611),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3610),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(5705),
    [anon_sym_LPAREN2] = ACTIONS(5834),
    [anon_sym_BANG] = ACTIONS(4926),
    [anon_sym_TILDE] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4928),
    [anon_sym_LBRACK] = ACTIONS(6118),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4924),
    [anon_sym_compl] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(5707),
    [anon_sym_PLUS_PLUS] = ACTIONS(5707),
    [anon_sym_sizeof] = ACTIONS(4932),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4934),
    [anon_sym_L_SQUOTE] = ACTIONS(4936),
    [anon_sym_u_SQUOTE] = ACTIONS(4936),
    [anon_sym_U_SQUOTE] = ACTIONS(4936),
    [anon_sym_u8_SQUOTE] = ACTIONS(4936),
    [anon_sym_SQUOTE] = ACTIONS(4936),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4938),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_co_await] = ACTIONS(4940),
    [anon_sym_new] = ACTIONS(4942),
    [anon_sym_requires] = ACTIONS(4944),
    [sym_this] = ACTIONS(241),
  },
  [2421] = {
    [sym_expression] = STATE(5486),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2422] = {
    [sym_expression] = STATE(3224),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2423] = {
    [sym_expression] = STATE(3213),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(6120),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2424] = {
    [sym_expression] = STATE(3213),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2425] = {
    [sym_expression] = STATE(3459),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3481),
    [sym_concatenated_string] = STATE(3486),
    [sym_string_literal] = STATE(2963),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2960),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5795),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4412),
    [anon_sym_PLUS] = ACTIONS(4412),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4416),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4412),
    [anon_sym_compl] = ACTIONS(4412),
    [anon_sym_DASH_DASH] = ACTIONS(5756),
    [anon_sym_PLUS_PLUS] = ACTIONS(5756),
    [anon_sym_sizeof] = ACTIONS(4422),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4432),
    [anon_sym_L_SQUOTE] = ACTIONS(4434),
    [anon_sym_u_SQUOTE] = ACTIONS(4434),
    [anon_sym_U_SQUOTE] = ACTIONS(4434),
    [anon_sym_u8_SQUOTE] = ACTIONS(4434),
    [anon_sym_SQUOTE] = ACTIONS(4434),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4442),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [anon_sym_co_await] = ACTIONS(4446),
    [anon_sym_new] = ACTIONS(4448),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2426] = {
    [sym_identifier] = ACTIONS(3673),
    [aux_sym_preproc_def_token1] = ACTIONS(3673),
    [aux_sym_preproc_if_token1] = ACTIONS(3673),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3673),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3673),
    [sym_preproc_directive] = ACTIONS(3673),
    [anon_sym_LPAREN2] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3673),
    [anon_sym___extension__] = ACTIONS(3673),
    [anon_sym_typedef] = ACTIONS(3673),
    [anon_sym_in] = ACTIONS(3673),
    [anon_sym_out] = ACTIONS(3673),
    [anon_sym_inout] = ACTIONS(3673),
    [anon_sym_extern] = ACTIONS(3673),
    [anon_sym___attribute__] = ACTIONS(3673),
    [anon_sym_COLON_COLON] = ACTIONS(3675),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3675),
    [anon_sym___declspec] = ACTIONS(3673),
    [anon_sym___based] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(3675),
    [anon_sym_signed] = ACTIONS(3673),
    [anon_sym_unsigned] = ACTIONS(3673),
    [anon_sym_long] = ACTIONS(3673),
    [anon_sym_short] = ACTIONS(3673),
    [anon_sym_LBRACK] = ACTIONS(3673),
    [anon_sym_static] = ACTIONS(3673),
    [anon_sym_register] = ACTIONS(3673),
    [anon_sym_inline] = ACTIONS(3673),
    [anon_sym___inline] = ACTIONS(3673),
    [anon_sym___inline__] = ACTIONS(3673),
    [anon_sym___forceinline] = ACTIONS(3673),
    [anon_sym_thread_local] = ACTIONS(3673),
    [anon_sym___thread] = ACTIONS(3673),
    [anon_sym_const] = ACTIONS(3673),
    [anon_sym_constexpr] = ACTIONS(3673),
    [anon_sym_volatile] = ACTIONS(3673),
    [anon_sym_restrict] = ACTIONS(3673),
    [anon_sym___restrict__] = ACTIONS(3673),
    [anon_sym__Atomic] = ACTIONS(3673),
    [anon_sym__Noreturn] = ACTIONS(3673),
    [anon_sym_noreturn] = ACTIONS(3673),
    [anon_sym_mutable] = ACTIONS(3673),
    [anon_sym_constinit] = ACTIONS(3673),
    [anon_sym_consteval] = ACTIONS(3673),
    [anon_sym_alignas] = ACTIONS(3673),
    [anon_sym__Alignas] = ACTIONS(3673),
    [sym_primitive_type] = ACTIONS(3673),
    [anon_sym_enum] = ACTIONS(3673),
    [anon_sym_class] = ACTIONS(3673),
    [anon_sym_struct] = ACTIONS(3673),
    [anon_sym_union] = ACTIONS(3673),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3673),
    [anon_sym_let] = ACTIONS(3673),
    [anon_sym_This] = ACTIONS(3673),
    [anon_sym_decltype] = ACTIONS(3673),
    [sym_virtual] = ACTIONS(3673),
    [anon_sym_explicit] = ACTIONS(3673),
    [anon_sym_typename] = ACTIONS(3673),
    [anon_sym_template] = ACTIONS(3673),
    [anon_sym_operator] = ACTIONS(3673),
    [anon_sym_friend] = ACTIONS(3673),
    [anon_sym_public] = ACTIONS(3673),
    [anon_sym_private] = ACTIONS(3673),
    [anon_sym_protected] = ACTIONS(3673),
    [anon_sym_using] = ACTIONS(3673),
    [anon_sym_static_assert] = ACTIONS(3673),
    [anon_sym_precise] = ACTIONS(3673),
    [anon_sym_shared] = ACTIONS(3673),
    [anon_sym_groupshared] = ACTIONS(3673),
    [anon_sym_uniform] = ACTIONS(3673),
    [anon_sym_row_major] = ACTIONS(3673),
    [anon_sym_column_major] = ACTIONS(3673),
    [anon_sym_globallycoherent] = ACTIONS(3673),
    [anon_sym_centroid] = ACTIONS(3673),
    [anon_sym_noperspective] = ACTIONS(3673),
    [anon_sym_nointerpolation] = ACTIONS(3673),
    [anon_sym_sample] = ACTIONS(3673),
    [anon_sym_linear] = ACTIONS(3673),
    [anon_sym_snorm] = ACTIONS(3673),
    [anon_sym_unorm] = ACTIONS(3673),
    [anon_sym_point] = ACTIONS(3673),
    [anon_sym_line] = ACTIONS(3673),
    [anon_sym_triangleadj] = ACTIONS(3673),
    [anon_sym_lineadj] = ACTIONS(3673),
    [anon_sym_triangle] = ACTIONS(3673),
    [anon_sym_interface] = ACTIONS(3673),
    [anon_sym_extension] = ACTIONS(3673),
    [anon_sym___init] = ACTIONS(3673),
    [anon_sym___subscript] = ACTIONS(3673),
    [anon_sym_property] = ACTIONS(3673),
    [anon_sym_associatedtype] = ACTIONS(3673),
  },
  [2427] = {
    [sym_expression] = STATE(3212),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(4134),
    [sym_concatenated_string] = STATE(4159),
    [sym_string_literal] = STATE(3152),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(3145),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4587),
    [anon_sym_LPAREN2] = ACTIONS(5819),
    [anon_sym_BANG] = ACTIONS(4591),
    [anon_sym_TILDE] = ACTIONS(4591),
    [anon_sym_DASH] = ACTIONS(4589),
    [anon_sym_PLUS] = ACTIONS(4589),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4593),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4589),
    [anon_sym_compl] = ACTIONS(4589),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_sizeof] = ACTIONS(4595),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4597),
    [anon_sym_L_SQUOTE] = ACTIONS(4599),
    [anon_sym_u_SQUOTE] = ACTIONS(4599),
    [anon_sym_U_SQUOTE] = ACTIONS(4599),
    [anon_sym_u8_SQUOTE] = ACTIONS(4599),
    [anon_sym_SQUOTE] = ACTIONS(4599),
    [anon_sym_L_DQUOTE] = ACTIONS(4601),
    [anon_sym_u_DQUOTE] = ACTIONS(4601),
    [anon_sym_U_DQUOTE] = ACTIONS(4601),
    [anon_sym_u8_DQUOTE] = ACTIONS(4601),
    [anon_sym_DQUOTE] = ACTIONS(4601),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4603),
    [anon_sym_R_DQUOTE] = ACTIONS(4605),
    [anon_sym_LR_DQUOTE] = ACTIONS(4605),
    [anon_sym_uR_DQUOTE] = ACTIONS(4605),
    [anon_sym_UR_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4605),
    [anon_sym_co_await] = ACTIONS(4607),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2428] = {
    [sym_identifier] = ACTIONS(3669),
    [aux_sym_preproc_def_token1] = ACTIONS(3669),
    [aux_sym_preproc_if_token1] = ACTIONS(3669),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3669),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3669),
    [sym_preproc_directive] = ACTIONS(3669),
    [anon_sym_LPAREN2] = ACTIONS(3671),
    [anon_sym_TILDE] = ACTIONS(3671),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3671),
    [anon_sym_AMP] = ACTIONS(3669),
    [anon_sym___extension__] = ACTIONS(3669),
    [anon_sym_typedef] = ACTIONS(3669),
    [anon_sym_in] = ACTIONS(3669),
    [anon_sym_out] = ACTIONS(3669),
    [anon_sym_inout] = ACTIONS(3669),
    [anon_sym_extern] = ACTIONS(3669),
    [anon_sym___attribute__] = ACTIONS(3669),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3671),
    [anon_sym___declspec] = ACTIONS(3669),
    [anon_sym___based] = ACTIONS(3669),
    [anon_sym_RBRACE] = ACTIONS(3671),
    [anon_sym_signed] = ACTIONS(3669),
    [anon_sym_unsigned] = ACTIONS(3669),
    [anon_sym_long] = ACTIONS(3669),
    [anon_sym_short] = ACTIONS(3669),
    [anon_sym_LBRACK] = ACTIONS(3669),
    [anon_sym_static] = ACTIONS(3669),
    [anon_sym_register] = ACTIONS(3669),
    [anon_sym_inline] = ACTIONS(3669),
    [anon_sym___inline] = ACTIONS(3669),
    [anon_sym___inline__] = ACTIONS(3669),
    [anon_sym___forceinline] = ACTIONS(3669),
    [anon_sym_thread_local] = ACTIONS(3669),
    [anon_sym___thread] = ACTIONS(3669),
    [anon_sym_const] = ACTIONS(3669),
    [anon_sym_constexpr] = ACTIONS(3669),
    [anon_sym_volatile] = ACTIONS(3669),
    [anon_sym_restrict] = ACTIONS(3669),
    [anon_sym___restrict__] = ACTIONS(3669),
    [anon_sym__Atomic] = ACTIONS(3669),
    [anon_sym__Noreturn] = ACTIONS(3669),
    [anon_sym_noreturn] = ACTIONS(3669),
    [anon_sym_mutable] = ACTIONS(3669),
    [anon_sym_constinit] = ACTIONS(3669),
    [anon_sym_consteval] = ACTIONS(3669),
    [anon_sym_alignas] = ACTIONS(3669),
    [anon_sym__Alignas] = ACTIONS(3669),
    [sym_primitive_type] = ACTIONS(3669),
    [anon_sym_enum] = ACTIONS(3669),
    [anon_sym_class] = ACTIONS(3669),
    [anon_sym_struct] = ACTIONS(3669),
    [anon_sym_union] = ACTIONS(3669),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3669),
    [anon_sym_let] = ACTIONS(3669),
    [anon_sym_This] = ACTIONS(3669),
    [anon_sym_decltype] = ACTIONS(3669),
    [sym_virtual] = ACTIONS(3669),
    [anon_sym_explicit] = ACTIONS(3669),
    [anon_sym_typename] = ACTIONS(3669),
    [anon_sym_template] = ACTIONS(3669),
    [anon_sym_operator] = ACTIONS(3669),
    [anon_sym_friend] = ACTIONS(3669),
    [anon_sym_public] = ACTIONS(3669),
    [anon_sym_private] = ACTIONS(3669),
    [anon_sym_protected] = ACTIONS(3669),
    [anon_sym_using] = ACTIONS(3669),
    [anon_sym_static_assert] = ACTIONS(3669),
    [anon_sym_precise] = ACTIONS(3669),
    [anon_sym_shared] = ACTIONS(3669),
    [anon_sym_groupshared] = ACTIONS(3669),
    [anon_sym_uniform] = ACTIONS(3669),
    [anon_sym_row_major] = ACTIONS(3669),
    [anon_sym_column_major] = ACTIONS(3669),
    [anon_sym_globallycoherent] = ACTIONS(3669),
    [anon_sym_centroid] = ACTIONS(3669),
    [anon_sym_noperspective] = ACTIONS(3669),
    [anon_sym_nointerpolation] = ACTIONS(3669),
    [anon_sym_sample] = ACTIONS(3669),
    [anon_sym_linear] = ACTIONS(3669),
    [anon_sym_snorm] = ACTIONS(3669),
    [anon_sym_unorm] = ACTIONS(3669),
    [anon_sym_point] = ACTIONS(3669),
    [anon_sym_line] = ACTIONS(3669),
    [anon_sym_triangleadj] = ACTIONS(3669),
    [anon_sym_lineadj] = ACTIONS(3669),
    [anon_sym_triangle] = ACTIONS(3669),
    [anon_sym_interface] = ACTIONS(3669),
    [anon_sym_extension] = ACTIONS(3669),
    [anon_sym___init] = ACTIONS(3669),
    [anon_sym___subscript] = ACTIONS(3669),
    [anon_sym_property] = ACTIONS(3669),
    [anon_sym_associatedtype] = ACTIONS(3669),
  },
  [2429] = {
    [sym_expression] = STATE(5380),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2430] = {
    [sym_expression] = STATE(4891),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4905),
    [sym_concatenated_string] = STATE(4902),
    [sym_string_literal] = STATE(3611),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3610),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(5705),
    [anon_sym_LPAREN2] = ACTIONS(5834),
    [anon_sym_BANG] = ACTIONS(4926),
    [anon_sym_TILDE] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4928),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4924),
    [anon_sym_compl] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(5707),
    [anon_sym_PLUS_PLUS] = ACTIONS(5707),
    [anon_sym_sizeof] = ACTIONS(4932),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4934),
    [anon_sym_L_SQUOTE] = ACTIONS(4936),
    [anon_sym_u_SQUOTE] = ACTIONS(4936),
    [anon_sym_U_SQUOTE] = ACTIONS(4936),
    [anon_sym_u8_SQUOTE] = ACTIONS(4936),
    [anon_sym_SQUOTE] = ACTIONS(4936),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4938),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_co_await] = ACTIONS(4940),
    [anon_sym_new] = ACTIONS(4942),
    [anon_sym_requires] = ACTIONS(4944),
    [sym_this] = ACTIONS(241),
  },
  [2431] = {
    [sym_expression] = STATE(4866),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4905),
    [sym_concatenated_string] = STATE(4902),
    [sym_string_literal] = STATE(3611),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3610),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(5705),
    [anon_sym_LPAREN2] = ACTIONS(5834),
    [anon_sym_BANG] = ACTIONS(4926),
    [anon_sym_TILDE] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4928),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4924),
    [anon_sym_compl] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(5707),
    [anon_sym_PLUS_PLUS] = ACTIONS(5707),
    [anon_sym_sizeof] = ACTIONS(4932),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4934),
    [anon_sym_L_SQUOTE] = ACTIONS(4936),
    [anon_sym_u_SQUOTE] = ACTIONS(4936),
    [anon_sym_U_SQUOTE] = ACTIONS(4936),
    [anon_sym_u8_SQUOTE] = ACTIONS(4936),
    [anon_sym_SQUOTE] = ACTIONS(4936),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4938),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_co_await] = ACTIONS(4940),
    [anon_sym_new] = ACTIONS(4942),
    [anon_sym_requires] = ACTIONS(4944),
    [sym_this] = ACTIONS(241),
  },
  [2432] = {
    [sym_expression] = STATE(3733),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(4134),
    [sym_concatenated_string] = STATE(4159),
    [sym_string_literal] = STATE(3152),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(3145),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4587),
    [anon_sym_LPAREN2] = ACTIONS(5819),
    [anon_sym_BANG] = ACTIONS(4591),
    [anon_sym_TILDE] = ACTIONS(4591),
    [anon_sym_DASH] = ACTIONS(4589),
    [anon_sym_PLUS] = ACTIONS(4589),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4593),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4589),
    [anon_sym_compl] = ACTIONS(4589),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_sizeof] = ACTIONS(4595),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4597),
    [anon_sym_L_SQUOTE] = ACTIONS(4599),
    [anon_sym_u_SQUOTE] = ACTIONS(4599),
    [anon_sym_U_SQUOTE] = ACTIONS(4599),
    [anon_sym_u8_SQUOTE] = ACTIONS(4599),
    [anon_sym_SQUOTE] = ACTIONS(4599),
    [anon_sym_L_DQUOTE] = ACTIONS(4601),
    [anon_sym_u_DQUOTE] = ACTIONS(4601),
    [anon_sym_U_DQUOTE] = ACTIONS(4601),
    [anon_sym_u8_DQUOTE] = ACTIONS(4601),
    [anon_sym_DQUOTE] = ACTIONS(4601),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4603),
    [anon_sym_R_DQUOTE] = ACTIONS(4605),
    [anon_sym_LR_DQUOTE] = ACTIONS(4605),
    [anon_sym_uR_DQUOTE] = ACTIONS(4605),
    [anon_sym_UR_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4605),
    [anon_sym_co_await] = ACTIONS(4607),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2433] = {
    [sym_expression] = STATE(5373),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2434] = {
    [sym_expression] = STATE(3452),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3481),
    [sym_concatenated_string] = STATE(3486),
    [sym_string_literal] = STATE(2963),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2960),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5795),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4412),
    [anon_sym_PLUS] = ACTIONS(4412),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4416),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4412),
    [anon_sym_compl] = ACTIONS(4412),
    [anon_sym_DASH_DASH] = ACTIONS(5756),
    [anon_sym_PLUS_PLUS] = ACTIONS(5756),
    [anon_sym_sizeof] = ACTIONS(4422),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4432),
    [anon_sym_L_SQUOTE] = ACTIONS(4434),
    [anon_sym_u_SQUOTE] = ACTIONS(4434),
    [anon_sym_U_SQUOTE] = ACTIONS(4434),
    [anon_sym_u8_SQUOTE] = ACTIONS(4434),
    [anon_sym_SQUOTE] = ACTIONS(4434),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4442),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [anon_sym_co_await] = ACTIONS(4446),
    [anon_sym_new] = ACTIONS(4448),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2435] = {
    [sym__declaration_modifiers] = STATE(2777),
    [sym_attribute_specifier] = STATE(2777),
    [sym_attribute_declaration] = STATE(2777),
    [sym_ms_declspec_modifier] = STATE(2777),
    [sym_storage_class_specifier] = STATE(2777),
    [sym_type_qualifier] = STATE(2777),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_type_specifier] = STATE(2945),
    [sym_sized_type_specifier] = STATE(2741),
    [sym_enum_specifier] = STATE(2741),
    [sym_struct_specifier] = STATE(2741),
    [sym_union_specifier] = STATE(2741),
    [sym_placeholder_type_specifier] = STATE(2741),
    [sym_decltype] = STATE(2715),
    [sym_class_specifier] = STATE(2741),
    [sym_dependent_type] = STATE(2741),
    [sym_template_type] = STATE(2715),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(8094),
    [sym_qualified_type_identifier] = STATE(2718),
    [sym_qualifiers] = STATE(2777),
    [sym_interface_specifier] = STATE(2741),
    [sym_extension_specifier] = STATE(2741),
    [sym_associatedtype_specifier] = STATE(2741),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2777),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2632),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym_in] = ACTIONS(6086),
    [anon_sym_out] = ACTIONS(6086),
    [anon_sym_inout] = ACTIONS(6086),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(195),
    [anon_sym_unsigned] = ACTIONS(195),
    [anon_sym_long] = ACTIONS(195),
    [anon_sym_short] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_struct] = ACTIONS(2415),
    [anon_sym_union] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(243),
    [anon_sym_let] = ACTIONS(243),
    [anon_sym_This] = ACTIONS(243),
    [anon_sym_decltype] = ACTIONS(245),
    [sym_virtual] = ACTIONS(6086),
    [anon_sym_typename] = ACTIONS(2419),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_precise] = ACTIONS(159),
    [anon_sym_shared] = ACTIONS(159),
    [anon_sym_groupshared] = ACTIONS(159),
    [anon_sym_uniform] = ACTIONS(159),
    [anon_sym_row_major] = ACTIONS(159),
    [anon_sym_column_major] = ACTIONS(159),
    [anon_sym_globallycoherent] = ACTIONS(159),
    [anon_sym_centroid] = ACTIONS(159),
    [anon_sym_noperspective] = ACTIONS(159),
    [anon_sym_nointerpolation] = ACTIONS(159),
    [anon_sym_sample] = ACTIONS(159),
    [anon_sym_linear] = ACTIONS(159),
    [anon_sym_snorm] = ACTIONS(159),
    [anon_sym_unorm] = ACTIONS(159),
    [anon_sym_point] = ACTIONS(159),
    [anon_sym_line] = ACTIONS(159),
    [anon_sym_triangleadj] = ACTIONS(159),
    [anon_sym_lineadj] = ACTIONS(159),
    [anon_sym_triangle] = ACTIONS(159),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_extension] = ACTIONS(2433),
  },
  [2436] = {
    [sym_expression] = STATE(5370),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2437] = {
    [sym_expression] = STATE(5190),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4958),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4964),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2438] = {
    [sym_expression] = STATE(5236),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2439] = {
    [sym_identifier] = ACTIONS(5572),
    [aux_sym_preproc_def_token1] = ACTIONS(5572),
    [aux_sym_preproc_if_token1] = ACTIONS(5572),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5572),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5572),
    [sym_preproc_directive] = ACTIONS(5572),
    [anon_sym_LPAREN2] = ACTIONS(5574),
    [anon_sym_TILDE] = ACTIONS(5574),
    [anon_sym_STAR] = ACTIONS(5574),
    [anon_sym_AMP_AMP] = ACTIONS(5574),
    [anon_sym_AMP] = ACTIONS(5572),
    [anon_sym___extension__] = ACTIONS(5572),
    [anon_sym_typedef] = ACTIONS(5572),
    [anon_sym_in] = ACTIONS(5572),
    [anon_sym_out] = ACTIONS(5572),
    [anon_sym_inout] = ACTIONS(5572),
    [anon_sym_extern] = ACTIONS(5572),
    [anon_sym___attribute__] = ACTIONS(5572),
    [anon_sym_COLON_COLON] = ACTIONS(5574),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5574),
    [anon_sym___declspec] = ACTIONS(5572),
    [anon_sym___based] = ACTIONS(5572),
    [anon_sym_RBRACE] = ACTIONS(5574),
    [anon_sym_signed] = ACTIONS(5572),
    [anon_sym_unsigned] = ACTIONS(5572),
    [anon_sym_long] = ACTIONS(5572),
    [anon_sym_short] = ACTIONS(5572),
    [anon_sym_LBRACK] = ACTIONS(5572),
    [anon_sym_static] = ACTIONS(5572),
    [anon_sym_register] = ACTIONS(5572),
    [anon_sym_inline] = ACTIONS(5572),
    [anon_sym___inline] = ACTIONS(5572),
    [anon_sym___inline__] = ACTIONS(5572),
    [anon_sym___forceinline] = ACTIONS(5572),
    [anon_sym_thread_local] = ACTIONS(5572),
    [anon_sym___thread] = ACTIONS(5572),
    [anon_sym_const] = ACTIONS(5572),
    [anon_sym_constexpr] = ACTIONS(5572),
    [anon_sym_volatile] = ACTIONS(5572),
    [anon_sym_restrict] = ACTIONS(5572),
    [anon_sym___restrict__] = ACTIONS(5572),
    [anon_sym__Atomic] = ACTIONS(5572),
    [anon_sym__Noreturn] = ACTIONS(5572),
    [anon_sym_noreturn] = ACTIONS(5572),
    [anon_sym_mutable] = ACTIONS(5572),
    [anon_sym_constinit] = ACTIONS(5572),
    [anon_sym_consteval] = ACTIONS(5572),
    [anon_sym_alignas] = ACTIONS(5572),
    [anon_sym__Alignas] = ACTIONS(5572),
    [sym_primitive_type] = ACTIONS(5572),
    [anon_sym_enum] = ACTIONS(5572),
    [anon_sym_class] = ACTIONS(5572),
    [anon_sym_struct] = ACTIONS(5572),
    [anon_sym_union] = ACTIONS(5572),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5572),
    [anon_sym_let] = ACTIONS(5572),
    [anon_sym_This] = ACTIONS(5572),
    [anon_sym_decltype] = ACTIONS(5572),
    [sym_virtual] = ACTIONS(5572),
    [anon_sym_explicit] = ACTIONS(5572),
    [anon_sym_typename] = ACTIONS(5572),
    [anon_sym_template] = ACTIONS(5572),
    [anon_sym_operator] = ACTIONS(5572),
    [anon_sym_friend] = ACTIONS(5572),
    [anon_sym_public] = ACTIONS(5572),
    [anon_sym_private] = ACTIONS(5572),
    [anon_sym_protected] = ACTIONS(5572),
    [anon_sym_using] = ACTIONS(5572),
    [anon_sym_static_assert] = ACTIONS(5572),
    [anon_sym_precise] = ACTIONS(5572),
    [anon_sym_shared] = ACTIONS(5572),
    [anon_sym_groupshared] = ACTIONS(5572),
    [anon_sym_uniform] = ACTIONS(5572),
    [anon_sym_row_major] = ACTIONS(5572),
    [anon_sym_column_major] = ACTIONS(5572),
    [anon_sym_globallycoherent] = ACTIONS(5572),
    [anon_sym_centroid] = ACTIONS(5572),
    [anon_sym_noperspective] = ACTIONS(5572),
    [anon_sym_nointerpolation] = ACTIONS(5572),
    [anon_sym_sample] = ACTIONS(5572),
    [anon_sym_linear] = ACTIONS(5572),
    [anon_sym_snorm] = ACTIONS(5572),
    [anon_sym_unorm] = ACTIONS(5572),
    [anon_sym_point] = ACTIONS(5572),
    [anon_sym_line] = ACTIONS(5572),
    [anon_sym_triangleadj] = ACTIONS(5572),
    [anon_sym_lineadj] = ACTIONS(5572),
    [anon_sym_triangle] = ACTIONS(5572),
    [anon_sym_interface] = ACTIONS(5572),
    [anon_sym_extension] = ACTIONS(5572),
    [anon_sym___init] = ACTIONS(5572),
    [anon_sym___subscript] = ACTIONS(5572),
    [anon_sym_property] = ACTIONS(5572),
    [anon_sym_associatedtype] = ACTIONS(5572),
  },
  [2440] = {
    [sym_identifier] = ACTIONS(3368),
    [aux_sym_preproc_def_token1] = ACTIONS(3368),
    [aux_sym_preproc_if_token1] = ACTIONS(3368),
    [aux_sym_preproc_if_token2] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3368),
    [sym_preproc_directive] = ACTIONS(3368),
    [anon_sym_LPAREN2] = ACTIONS(3370),
    [anon_sym_TILDE] = ACTIONS(3370),
    [anon_sym_STAR] = ACTIONS(3370),
    [anon_sym_AMP_AMP] = ACTIONS(3370),
    [anon_sym_AMP] = ACTIONS(3368),
    [anon_sym___extension__] = ACTIONS(3368),
    [anon_sym_typedef] = ACTIONS(3368),
    [anon_sym_in] = ACTIONS(3368),
    [anon_sym_out] = ACTIONS(3368),
    [anon_sym_inout] = ACTIONS(3368),
    [anon_sym_extern] = ACTIONS(3368),
    [anon_sym___attribute__] = ACTIONS(3368),
    [anon_sym_COLON_COLON] = ACTIONS(3370),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3370),
    [anon_sym___declspec] = ACTIONS(3368),
    [anon_sym___based] = ACTIONS(3368),
    [anon_sym_signed] = ACTIONS(3368),
    [anon_sym_unsigned] = ACTIONS(3368),
    [anon_sym_long] = ACTIONS(3368),
    [anon_sym_short] = ACTIONS(3368),
    [anon_sym_LBRACK] = ACTIONS(3368),
    [anon_sym_static] = ACTIONS(3368),
    [anon_sym_register] = ACTIONS(3368),
    [anon_sym_inline] = ACTIONS(3368),
    [anon_sym___inline] = ACTIONS(3368),
    [anon_sym___inline__] = ACTIONS(3368),
    [anon_sym___forceinline] = ACTIONS(3368),
    [anon_sym_thread_local] = ACTIONS(3368),
    [anon_sym___thread] = ACTIONS(3368),
    [anon_sym_const] = ACTIONS(3368),
    [anon_sym_constexpr] = ACTIONS(3368),
    [anon_sym_volatile] = ACTIONS(3368),
    [anon_sym_restrict] = ACTIONS(3368),
    [anon_sym___restrict__] = ACTIONS(3368),
    [anon_sym__Atomic] = ACTIONS(3368),
    [anon_sym__Noreturn] = ACTIONS(3368),
    [anon_sym_noreturn] = ACTIONS(3368),
    [anon_sym_mutable] = ACTIONS(3368),
    [anon_sym_constinit] = ACTIONS(3368),
    [anon_sym_consteval] = ACTIONS(3368),
    [anon_sym_alignas] = ACTIONS(3368),
    [anon_sym__Alignas] = ACTIONS(3368),
    [sym_primitive_type] = ACTIONS(3368),
    [anon_sym_enum] = ACTIONS(3368),
    [anon_sym_class] = ACTIONS(3368),
    [anon_sym_struct] = ACTIONS(3368),
    [anon_sym_union] = ACTIONS(3368),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3368),
    [anon_sym_let] = ACTIONS(3368),
    [anon_sym_This] = ACTIONS(3368),
    [anon_sym_decltype] = ACTIONS(3368),
    [sym_virtual] = ACTIONS(3368),
    [anon_sym_explicit] = ACTIONS(3368),
    [anon_sym_typename] = ACTIONS(3368),
    [anon_sym_template] = ACTIONS(3368),
    [anon_sym_operator] = ACTIONS(3368),
    [anon_sym_friend] = ACTIONS(3368),
    [anon_sym_public] = ACTIONS(3368),
    [anon_sym_private] = ACTIONS(3368),
    [anon_sym_protected] = ACTIONS(3368),
    [anon_sym_using] = ACTIONS(3368),
    [anon_sym_static_assert] = ACTIONS(3368),
    [anon_sym_precise] = ACTIONS(3368),
    [anon_sym_shared] = ACTIONS(3368),
    [anon_sym_groupshared] = ACTIONS(3368),
    [anon_sym_uniform] = ACTIONS(3368),
    [anon_sym_row_major] = ACTIONS(3368),
    [anon_sym_column_major] = ACTIONS(3368),
    [anon_sym_globallycoherent] = ACTIONS(3368),
    [anon_sym_centroid] = ACTIONS(3368),
    [anon_sym_noperspective] = ACTIONS(3368),
    [anon_sym_nointerpolation] = ACTIONS(3368),
    [anon_sym_sample] = ACTIONS(3368),
    [anon_sym_linear] = ACTIONS(3368),
    [anon_sym_snorm] = ACTIONS(3368),
    [anon_sym_unorm] = ACTIONS(3368),
    [anon_sym_point] = ACTIONS(3368),
    [anon_sym_line] = ACTIONS(3368),
    [anon_sym_triangleadj] = ACTIONS(3368),
    [anon_sym_lineadj] = ACTIONS(3368),
    [anon_sym_triangle] = ACTIONS(3368),
    [anon_sym_interface] = ACTIONS(3368),
    [anon_sym_extension] = ACTIONS(3368),
    [anon_sym___init] = ACTIONS(3368),
    [anon_sym___subscript] = ACTIONS(3368),
    [anon_sym_property] = ACTIONS(3368),
    [anon_sym_associatedtype] = ACTIONS(3368),
  },
  [2441] = {
    [sym_identifier] = ACTIONS(3374),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token2] = ACTIONS(3374),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3374),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3374),
    [sym_preproc_directive] = ACTIONS(3374),
    [anon_sym_LPAREN2] = ACTIONS(3376),
    [anon_sym_TILDE] = ACTIONS(3376),
    [anon_sym_STAR] = ACTIONS(3376),
    [anon_sym_AMP_AMP] = ACTIONS(3376),
    [anon_sym_AMP] = ACTIONS(3374),
    [anon_sym___extension__] = ACTIONS(3374),
    [anon_sym_typedef] = ACTIONS(3374),
    [anon_sym_in] = ACTIONS(3374),
    [anon_sym_out] = ACTIONS(3374),
    [anon_sym_inout] = ACTIONS(3374),
    [anon_sym_extern] = ACTIONS(3374),
    [anon_sym___attribute__] = ACTIONS(3374),
    [anon_sym_COLON_COLON] = ACTIONS(3376),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3376),
    [anon_sym___declspec] = ACTIONS(3374),
    [anon_sym___based] = ACTIONS(3374),
    [anon_sym_signed] = ACTIONS(3374),
    [anon_sym_unsigned] = ACTIONS(3374),
    [anon_sym_long] = ACTIONS(3374),
    [anon_sym_short] = ACTIONS(3374),
    [anon_sym_LBRACK] = ACTIONS(3374),
    [anon_sym_static] = ACTIONS(3374),
    [anon_sym_register] = ACTIONS(3374),
    [anon_sym_inline] = ACTIONS(3374),
    [anon_sym___inline] = ACTIONS(3374),
    [anon_sym___inline__] = ACTIONS(3374),
    [anon_sym___forceinline] = ACTIONS(3374),
    [anon_sym_thread_local] = ACTIONS(3374),
    [anon_sym___thread] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3374),
    [anon_sym_constexpr] = ACTIONS(3374),
    [anon_sym_volatile] = ACTIONS(3374),
    [anon_sym_restrict] = ACTIONS(3374),
    [anon_sym___restrict__] = ACTIONS(3374),
    [anon_sym__Atomic] = ACTIONS(3374),
    [anon_sym__Noreturn] = ACTIONS(3374),
    [anon_sym_noreturn] = ACTIONS(3374),
    [anon_sym_mutable] = ACTIONS(3374),
    [anon_sym_constinit] = ACTIONS(3374),
    [anon_sym_consteval] = ACTIONS(3374),
    [anon_sym_alignas] = ACTIONS(3374),
    [anon_sym__Alignas] = ACTIONS(3374),
    [sym_primitive_type] = ACTIONS(3374),
    [anon_sym_enum] = ACTIONS(3374),
    [anon_sym_class] = ACTIONS(3374),
    [anon_sym_struct] = ACTIONS(3374),
    [anon_sym_union] = ACTIONS(3374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3374),
    [anon_sym_let] = ACTIONS(3374),
    [anon_sym_This] = ACTIONS(3374),
    [anon_sym_decltype] = ACTIONS(3374),
    [sym_virtual] = ACTIONS(3374),
    [anon_sym_explicit] = ACTIONS(3374),
    [anon_sym_typename] = ACTIONS(3374),
    [anon_sym_template] = ACTIONS(3374),
    [anon_sym_operator] = ACTIONS(3374),
    [anon_sym_friend] = ACTIONS(3374),
    [anon_sym_public] = ACTIONS(3374),
    [anon_sym_private] = ACTIONS(3374),
    [anon_sym_protected] = ACTIONS(3374),
    [anon_sym_using] = ACTIONS(3374),
    [anon_sym_static_assert] = ACTIONS(3374),
    [anon_sym_precise] = ACTIONS(3374),
    [anon_sym_shared] = ACTIONS(3374),
    [anon_sym_groupshared] = ACTIONS(3374),
    [anon_sym_uniform] = ACTIONS(3374),
    [anon_sym_row_major] = ACTIONS(3374),
    [anon_sym_column_major] = ACTIONS(3374),
    [anon_sym_globallycoherent] = ACTIONS(3374),
    [anon_sym_centroid] = ACTIONS(3374),
    [anon_sym_noperspective] = ACTIONS(3374),
    [anon_sym_nointerpolation] = ACTIONS(3374),
    [anon_sym_sample] = ACTIONS(3374),
    [anon_sym_linear] = ACTIONS(3374),
    [anon_sym_snorm] = ACTIONS(3374),
    [anon_sym_unorm] = ACTIONS(3374),
    [anon_sym_point] = ACTIONS(3374),
    [anon_sym_line] = ACTIONS(3374),
    [anon_sym_triangleadj] = ACTIONS(3374),
    [anon_sym_lineadj] = ACTIONS(3374),
    [anon_sym_triangle] = ACTIONS(3374),
    [anon_sym_interface] = ACTIONS(3374),
    [anon_sym_extension] = ACTIONS(3374),
    [anon_sym___init] = ACTIONS(3374),
    [anon_sym___subscript] = ACTIONS(3374),
    [anon_sym_property] = ACTIONS(3374),
    [anon_sym_associatedtype] = ACTIONS(3374),
  },
  [2442] = {
    [sym_identifier] = ACTIONS(3344),
    [aux_sym_preproc_def_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token2] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3344),
    [sym_preproc_directive] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym___extension__] = ACTIONS(3344),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_in] = ACTIONS(3344),
    [anon_sym_out] = ACTIONS(3344),
    [anon_sym_inout] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym___attribute__] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3346),
    [anon_sym___declspec] = ACTIONS(3344),
    [anon_sym___based] = ACTIONS(3344),
    [anon_sym_signed] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym___inline] = ACTIONS(3344),
    [anon_sym___inline__] = ACTIONS(3344),
    [anon_sym___forceinline] = ACTIONS(3344),
    [anon_sym_thread_local] = ACTIONS(3344),
    [anon_sym___thread] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym___restrict__] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym__Noreturn] = ACTIONS(3344),
    [anon_sym_noreturn] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_constinit] = ACTIONS(3344),
    [anon_sym_consteval] = ACTIONS(3344),
    [anon_sym_alignas] = ACTIONS(3344),
    [anon_sym__Alignas] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_class] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_This] = ACTIONS(3344),
    [anon_sym_decltype] = ACTIONS(3344),
    [sym_virtual] = ACTIONS(3344),
    [anon_sym_explicit] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_template] = ACTIONS(3344),
    [anon_sym_operator] = ACTIONS(3344),
    [anon_sym_friend] = ACTIONS(3344),
    [anon_sym_public] = ACTIONS(3344),
    [anon_sym_private] = ACTIONS(3344),
    [anon_sym_protected] = ACTIONS(3344),
    [anon_sym_using] = ACTIONS(3344),
    [anon_sym_static_assert] = ACTIONS(3344),
    [anon_sym_precise] = ACTIONS(3344),
    [anon_sym_shared] = ACTIONS(3344),
    [anon_sym_groupshared] = ACTIONS(3344),
    [anon_sym_uniform] = ACTIONS(3344),
    [anon_sym_row_major] = ACTIONS(3344),
    [anon_sym_column_major] = ACTIONS(3344),
    [anon_sym_globallycoherent] = ACTIONS(3344),
    [anon_sym_centroid] = ACTIONS(3344),
    [anon_sym_noperspective] = ACTIONS(3344),
    [anon_sym_nointerpolation] = ACTIONS(3344),
    [anon_sym_sample] = ACTIONS(3344),
    [anon_sym_linear] = ACTIONS(3344),
    [anon_sym_snorm] = ACTIONS(3344),
    [anon_sym_unorm] = ACTIONS(3344),
    [anon_sym_point] = ACTIONS(3344),
    [anon_sym_line] = ACTIONS(3344),
    [anon_sym_triangleadj] = ACTIONS(3344),
    [anon_sym_lineadj] = ACTIONS(3344),
    [anon_sym_triangle] = ACTIONS(3344),
    [anon_sym_interface] = ACTIONS(3344),
    [anon_sym_extension] = ACTIONS(3344),
    [anon_sym___init] = ACTIONS(3344),
    [anon_sym___subscript] = ACTIONS(3344),
    [anon_sym_property] = ACTIONS(3344),
    [anon_sym_associatedtype] = ACTIONS(3344),
  },
  [2443] = {
    [sym_identifier] = ACTIONS(3344),
    [aux_sym_preproc_def_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token2] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3344),
    [sym_preproc_directive] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym___extension__] = ACTIONS(3344),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_in] = ACTIONS(3344),
    [anon_sym_out] = ACTIONS(3344),
    [anon_sym_inout] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym___attribute__] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3346),
    [anon_sym___declspec] = ACTIONS(3344),
    [anon_sym___based] = ACTIONS(3344),
    [anon_sym_signed] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym___inline] = ACTIONS(3344),
    [anon_sym___inline__] = ACTIONS(3344),
    [anon_sym___forceinline] = ACTIONS(3344),
    [anon_sym_thread_local] = ACTIONS(3344),
    [anon_sym___thread] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym___restrict__] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym__Noreturn] = ACTIONS(3344),
    [anon_sym_noreturn] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_constinit] = ACTIONS(3344),
    [anon_sym_consteval] = ACTIONS(3344),
    [anon_sym_alignas] = ACTIONS(3344),
    [anon_sym__Alignas] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_class] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_This] = ACTIONS(3344),
    [anon_sym_decltype] = ACTIONS(3344),
    [sym_virtual] = ACTIONS(3344),
    [anon_sym_explicit] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_template] = ACTIONS(3344),
    [anon_sym_operator] = ACTIONS(3344),
    [anon_sym_friend] = ACTIONS(3344),
    [anon_sym_public] = ACTIONS(3344),
    [anon_sym_private] = ACTIONS(3344),
    [anon_sym_protected] = ACTIONS(3344),
    [anon_sym_using] = ACTIONS(3344),
    [anon_sym_static_assert] = ACTIONS(3344),
    [anon_sym_precise] = ACTIONS(3344),
    [anon_sym_shared] = ACTIONS(3344),
    [anon_sym_groupshared] = ACTIONS(3344),
    [anon_sym_uniform] = ACTIONS(3344),
    [anon_sym_row_major] = ACTIONS(3344),
    [anon_sym_column_major] = ACTIONS(3344),
    [anon_sym_globallycoherent] = ACTIONS(3344),
    [anon_sym_centroid] = ACTIONS(3344),
    [anon_sym_noperspective] = ACTIONS(3344),
    [anon_sym_nointerpolation] = ACTIONS(3344),
    [anon_sym_sample] = ACTIONS(3344),
    [anon_sym_linear] = ACTIONS(3344),
    [anon_sym_snorm] = ACTIONS(3344),
    [anon_sym_unorm] = ACTIONS(3344),
    [anon_sym_point] = ACTIONS(3344),
    [anon_sym_line] = ACTIONS(3344),
    [anon_sym_triangleadj] = ACTIONS(3344),
    [anon_sym_lineadj] = ACTIONS(3344),
    [anon_sym_triangle] = ACTIONS(3344),
    [anon_sym_interface] = ACTIONS(3344),
    [anon_sym_extension] = ACTIONS(3344),
    [anon_sym___init] = ACTIONS(3344),
    [anon_sym___subscript] = ACTIONS(3344),
    [anon_sym_property] = ACTIONS(3344),
    [anon_sym_associatedtype] = ACTIONS(3344),
  },
  [2444] = {
    [sym_expression] = STATE(5273),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2445] = {
    [sym_identifier] = ACTIONS(3182),
    [aux_sym_preproc_def_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [sym_preproc_directive] = ACTIONS(3182),
    [anon_sym_LPAREN2] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_AMP_AMP] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3182),
    [anon_sym___extension__] = ACTIONS(3182),
    [anon_sym_typedef] = ACTIONS(3182),
    [anon_sym_in] = ACTIONS(3182),
    [anon_sym_out] = ACTIONS(3182),
    [anon_sym_inout] = ACTIONS(3182),
    [anon_sym_extern] = ACTIONS(3182),
    [anon_sym___attribute__] = ACTIONS(3182),
    [anon_sym_COLON_COLON] = ACTIONS(3184),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3184),
    [anon_sym___declspec] = ACTIONS(3182),
    [anon_sym___based] = ACTIONS(3182),
    [anon_sym_RBRACE] = ACTIONS(3184),
    [anon_sym_signed] = ACTIONS(3182),
    [anon_sym_unsigned] = ACTIONS(3182),
    [anon_sym_long] = ACTIONS(3182),
    [anon_sym_short] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3182),
    [anon_sym_register] = ACTIONS(3182),
    [anon_sym_inline] = ACTIONS(3182),
    [anon_sym___inline] = ACTIONS(3182),
    [anon_sym___inline__] = ACTIONS(3182),
    [anon_sym___forceinline] = ACTIONS(3182),
    [anon_sym_thread_local] = ACTIONS(3182),
    [anon_sym___thread] = ACTIONS(3182),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_constexpr] = ACTIONS(3182),
    [anon_sym_volatile] = ACTIONS(3182),
    [anon_sym_restrict] = ACTIONS(3182),
    [anon_sym___restrict__] = ACTIONS(3182),
    [anon_sym__Atomic] = ACTIONS(3182),
    [anon_sym__Noreturn] = ACTIONS(3182),
    [anon_sym_noreturn] = ACTIONS(3182),
    [anon_sym_mutable] = ACTIONS(3182),
    [anon_sym_constinit] = ACTIONS(3182),
    [anon_sym_consteval] = ACTIONS(3182),
    [anon_sym_alignas] = ACTIONS(3182),
    [anon_sym__Alignas] = ACTIONS(3182),
    [sym_primitive_type] = ACTIONS(3182),
    [anon_sym_enum] = ACTIONS(3182),
    [anon_sym_class] = ACTIONS(3182),
    [anon_sym_struct] = ACTIONS(3182),
    [anon_sym_union] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3182),
    [anon_sym_let] = ACTIONS(3182),
    [anon_sym_This] = ACTIONS(3182),
    [anon_sym_decltype] = ACTIONS(3182),
    [sym_virtual] = ACTIONS(3182),
    [anon_sym_explicit] = ACTIONS(3182),
    [anon_sym_typename] = ACTIONS(3182),
    [anon_sym_template] = ACTIONS(3182),
    [anon_sym_operator] = ACTIONS(3182),
    [anon_sym_friend] = ACTIONS(3182),
    [anon_sym_public] = ACTIONS(3182),
    [anon_sym_private] = ACTIONS(3182),
    [anon_sym_protected] = ACTIONS(3182),
    [anon_sym_using] = ACTIONS(3182),
    [anon_sym_static_assert] = ACTIONS(3182),
    [anon_sym_precise] = ACTIONS(3182),
    [anon_sym_shared] = ACTIONS(3182),
    [anon_sym_groupshared] = ACTIONS(3182),
    [anon_sym_uniform] = ACTIONS(3182),
    [anon_sym_row_major] = ACTIONS(3182),
    [anon_sym_column_major] = ACTIONS(3182),
    [anon_sym_globallycoherent] = ACTIONS(3182),
    [anon_sym_centroid] = ACTIONS(3182),
    [anon_sym_noperspective] = ACTIONS(3182),
    [anon_sym_nointerpolation] = ACTIONS(3182),
    [anon_sym_sample] = ACTIONS(3182),
    [anon_sym_linear] = ACTIONS(3182),
    [anon_sym_snorm] = ACTIONS(3182),
    [anon_sym_unorm] = ACTIONS(3182),
    [anon_sym_point] = ACTIONS(3182),
    [anon_sym_line] = ACTIONS(3182),
    [anon_sym_triangleadj] = ACTIONS(3182),
    [anon_sym_lineadj] = ACTIONS(3182),
    [anon_sym_triangle] = ACTIONS(3182),
    [anon_sym_interface] = ACTIONS(3182),
    [anon_sym_extension] = ACTIONS(3182),
    [anon_sym___init] = ACTIONS(3182),
    [anon_sym___subscript] = ACTIONS(3182),
    [anon_sym_property] = ACTIONS(3182),
    [anon_sym_associatedtype] = ACTIONS(3182),
  },
  [2446] = {
    [sym_expression] = STATE(3229),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2447] = {
    [sym_expression] = STATE(3517),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3577),
    [sym_concatenated_string] = STATE(3573),
    [sym_string_literal] = STATE(2971),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2985),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5785),
    [anon_sym_BANG] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(6122),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4551),
    [anon_sym_compl] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4909),
    [anon_sym_sizeof] = ACTIONS(4557),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4559),
    [anon_sym_L_SQUOTE] = ACTIONS(4561),
    [anon_sym_u_SQUOTE] = ACTIONS(4561),
    [anon_sym_U_SQUOTE] = ACTIONS(4561),
    [anon_sym_u8_SQUOTE] = ACTIONS(4561),
    [anon_sym_SQUOTE] = ACTIONS(4561),
    [anon_sym_L_DQUOTE] = ACTIONS(4563),
    [anon_sym_u_DQUOTE] = ACTIONS(4563),
    [anon_sym_U_DQUOTE] = ACTIONS(4563),
    [anon_sym_u8_DQUOTE] = ACTIONS(4563),
    [anon_sym_DQUOTE] = ACTIONS(4563),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4565),
    [anon_sym_R_DQUOTE] = ACTIONS(4567),
    [anon_sym_LR_DQUOTE] = ACTIONS(4567),
    [anon_sym_uR_DQUOTE] = ACTIONS(4567),
    [anon_sym_UR_DQUOTE] = ACTIONS(4567),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4567),
    [anon_sym_co_await] = ACTIONS(4569),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2448] = {
    [sym_expression] = STATE(5246),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2449] = {
    [sym_identifier] = ACTIONS(2982),
    [aux_sym_preproc_def_token1] = ACTIONS(2982),
    [aux_sym_preproc_if_token1] = ACTIONS(2982),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2982),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2982),
    [sym_preproc_directive] = ACTIONS(2982),
    [anon_sym_LPAREN2] = ACTIONS(2984),
    [anon_sym_TILDE] = ACTIONS(2984),
    [anon_sym_STAR] = ACTIONS(2984),
    [anon_sym_AMP_AMP] = ACTIONS(2984),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(2982),
    [anon_sym_typedef] = ACTIONS(2982),
    [anon_sym_in] = ACTIONS(2982),
    [anon_sym_out] = ACTIONS(2982),
    [anon_sym_inout] = ACTIONS(2982),
    [anon_sym_extern] = ACTIONS(2982),
    [anon_sym___attribute__] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2984),
    [anon_sym___declspec] = ACTIONS(2982),
    [anon_sym___based] = ACTIONS(2982),
    [anon_sym_RBRACE] = ACTIONS(2984),
    [anon_sym_signed] = ACTIONS(2982),
    [anon_sym_unsigned] = ACTIONS(2982),
    [anon_sym_long] = ACTIONS(2982),
    [anon_sym_short] = ACTIONS(2982),
    [anon_sym_LBRACK] = ACTIONS(2982),
    [anon_sym_static] = ACTIONS(2982),
    [anon_sym_register] = ACTIONS(2982),
    [anon_sym_inline] = ACTIONS(2982),
    [anon_sym___inline] = ACTIONS(2982),
    [anon_sym___inline__] = ACTIONS(2982),
    [anon_sym___forceinline] = ACTIONS(2982),
    [anon_sym_thread_local] = ACTIONS(2982),
    [anon_sym___thread] = ACTIONS(2982),
    [anon_sym_const] = ACTIONS(2982),
    [anon_sym_constexpr] = ACTIONS(2982),
    [anon_sym_volatile] = ACTIONS(2982),
    [anon_sym_restrict] = ACTIONS(2982),
    [anon_sym___restrict__] = ACTIONS(2982),
    [anon_sym__Atomic] = ACTIONS(2982),
    [anon_sym__Noreturn] = ACTIONS(2982),
    [anon_sym_noreturn] = ACTIONS(2982),
    [anon_sym_mutable] = ACTIONS(2982),
    [anon_sym_constinit] = ACTIONS(2982),
    [anon_sym_consteval] = ACTIONS(2982),
    [anon_sym_alignas] = ACTIONS(2982),
    [anon_sym__Alignas] = ACTIONS(2982),
    [sym_primitive_type] = ACTIONS(2982),
    [anon_sym_enum] = ACTIONS(2982),
    [anon_sym_class] = ACTIONS(2982),
    [anon_sym_struct] = ACTIONS(2982),
    [anon_sym_union] = ACTIONS(2982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2982),
    [anon_sym_let] = ACTIONS(2982),
    [anon_sym_This] = ACTIONS(2982),
    [anon_sym_decltype] = ACTIONS(2982),
    [sym_virtual] = ACTIONS(2982),
    [anon_sym_explicit] = ACTIONS(2982),
    [anon_sym_typename] = ACTIONS(2982),
    [anon_sym_template] = ACTIONS(2982),
    [anon_sym_operator] = ACTIONS(2982),
    [anon_sym_friend] = ACTIONS(2982),
    [anon_sym_public] = ACTIONS(2982),
    [anon_sym_private] = ACTIONS(2982),
    [anon_sym_protected] = ACTIONS(2982),
    [anon_sym_using] = ACTIONS(2982),
    [anon_sym_static_assert] = ACTIONS(2982),
    [anon_sym_precise] = ACTIONS(2982),
    [anon_sym_shared] = ACTIONS(2982),
    [anon_sym_groupshared] = ACTIONS(2982),
    [anon_sym_uniform] = ACTIONS(2982),
    [anon_sym_row_major] = ACTIONS(2982),
    [anon_sym_column_major] = ACTIONS(2982),
    [anon_sym_globallycoherent] = ACTIONS(2982),
    [anon_sym_centroid] = ACTIONS(2982),
    [anon_sym_noperspective] = ACTIONS(2982),
    [anon_sym_nointerpolation] = ACTIONS(2982),
    [anon_sym_sample] = ACTIONS(2982),
    [anon_sym_linear] = ACTIONS(2982),
    [anon_sym_snorm] = ACTIONS(2982),
    [anon_sym_unorm] = ACTIONS(2982),
    [anon_sym_point] = ACTIONS(2982),
    [anon_sym_line] = ACTIONS(2982),
    [anon_sym_triangleadj] = ACTIONS(2982),
    [anon_sym_lineadj] = ACTIONS(2982),
    [anon_sym_triangle] = ACTIONS(2982),
    [anon_sym_interface] = ACTIONS(2982),
    [anon_sym_extension] = ACTIONS(2982),
    [anon_sym___init] = ACTIONS(2982),
    [anon_sym___subscript] = ACTIONS(2982),
    [anon_sym_property] = ACTIONS(2982),
    [anon_sym_associatedtype] = ACTIONS(2982),
  },
  [2450] = {
    [sym_expression] = STATE(5248),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2451] = {
    [sym_identifier] = ACTIONS(3703),
    [aux_sym_preproc_def_token1] = ACTIONS(3703),
    [aux_sym_preproc_if_token1] = ACTIONS(3703),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3703),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3703),
    [sym_preproc_directive] = ACTIONS(3703),
    [anon_sym_LPAREN2] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3705),
    [anon_sym_STAR] = ACTIONS(3705),
    [anon_sym_AMP_AMP] = ACTIONS(3705),
    [anon_sym_AMP] = ACTIONS(3703),
    [anon_sym___extension__] = ACTIONS(3703),
    [anon_sym_typedef] = ACTIONS(3703),
    [anon_sym_in] = ACTIONS(3703),
    [anon_sym_out] = ACTIONS(3703),
    [anon_sym_inout] = ACTIONS(3703),
    [anon_sym_extern] = ACTIONS(3703),
    [anon_sym___attribute__] = ACTIONS(3703),
    [anon_sym_COLON_COLON] = ACTIONS(3705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3705),
    [anon_sym___declspec] = ACTIONS(3703),
    [anon_sym___based] = ACTIONS(3703),
    [anon_sym_RBRACE] = ACTIONS(3705),
    [anon_sym_signed] = ACTIONS(3703),
    [anon_sym_unsigned] = ACTIONS(3703),
    [anon_sym_long] = ACTIONS(3703),
    [anon_sym_short] = ACTIONS(3703),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_static] = ACTIONS(3703),
    [anon_sym_register] = ACTIONS(3703),
    [anon_sym_inline] = ACTIONS(3703),
    [anon_sym___inline] = ACTIONS(3703),
    [anon_sym___inline__] = ACTIONS(3703),
    [anon_sym___forceinline] = ACTIONS(3703),
    [anon_sym_thread_local] = ACTIONS(3703),
    [anon_sym___thread] = ACTIONS(3703),
    [anon_sym_const] = ACTIONS(3703),
    [anon_sym_constexpr] = ACTIONS(3703),
    [anon_sym_volatile] = ACTIONS(3703),
    [anon_sym_restrict] = ACTIONS(3703),
    [anon_sym___restrict__] = ACTIONS(3703),
    [anon_sym__Atomic] = ACTIONS(3703),
    [anon_sym__Noreturn] = ACTIONS(3703),
    [anon_sym_noreturn] = ACTIONS(3703),
    [anon_sym_mutable] = ACTIONS(3703),
    [anon_sym_constinit] = ACTIONS(3703),
    [anon_sym_consteval] = ACTIONS(3703),
    [anon_sym_alignas] = ACTIONS(3703),
    [anon_sym__Alignas] = ACTIONS(3703),
    [sym_primitive_type] = ACTIONS(3703),
    [anon_sym_enum] = ACTIONS(3703),
    [anon_sym_class] = ACTIONS(3703),
    [anon_sym_struct] = ACTIONS(3703),
    [anon_sym_union] = ACTIONS(3703),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3703),
    [anon_sym_let] = ACTIONS(3703),
    [anon_sym_This] = ACTIONS(3703),
    [anon_sym_decltype] = ACTIONS(3703),
    [sym_virtual] = ACTIONS(3703),
    [anon_sym_explicit] = ACTIONS(3703),
    [anon_sym_typename] = ACTIONS(3703),
    [anon_sym_template] = ACTIONS(3703),
    [anon_sym_operator] = ACTIONS(3703),
    [anon_sym_friend] = ACTIONS(3703),
    [anon_sym_public] = ACTIONS(3703),
    [anon_sym_private] = ACTIONS(3703),
    [anon_sym_protected] = ACTIONS(3703),
    [anon_sym_using] = ACTIONS(3703),
    [anon_sym_static_assert] = ACTIONS(3703),
    [anon_sym_precise] = ACTIONS(3703),
    [anon_sym_shared] = ACTIONS(3703),
    [anon_sym_groupshared] = ACTIONS(3703),
    [anon_sym_uniform] = ACTIONS(3703),
    [anon_sym_row_major] = ACTIONS(3703),
    [anon_sym_column_major] = ACTIONS(3703),
    [anon_sym_globallycoherent] = ACTIONS(3703),
    [anon_sym_centroid] = ACTIONS(3703),
    [anon_sym_noperspective] = ACTIONS(3703),
    [anon_sym_nointerpolation] = ACTIONS(3703),
    [anon_sym_sample] = ACTIONS(3703),
    [anon_sym_linear] = ACTIONS(3703),
    [anon_sym_snorm] = ACTIONS(3703),
    [anon_sym_unorm] = ACTIONS(3703),
    [anon_sym_point] = ACTIONS(3703),
    [anon_sym_line] = ACTIONS(3703),
    [anon_sym_triangleadj] = ACTIONS(3703),
    [anon_sym_lineadj] = ACTIONS(3703),
    [anon_sym_triangle] = ACTIONS(3703),
    [anon_sym_interface] = ACTIONS(3703),
    [anon_sym_extension] = ACTIONS(3703),
    [anon_sym___init] = ACTIONS(3703),
    [anon_sym___subscript] = ACTIONS(3703),
    [anon_sym_property] = ACTIONS(3703),
    [anon_sym_associatedtype] = ACTIONS(3703),
  },
  [2452] = {
    [sym_expression] = STATE(5251),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2453] = {
    [sym_expression] = STATE(5253),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2454] = {
    [sym_expression] = STATE(4677),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4905),
    [sym_concatenated_string] = STATE(4902),
    [sym_string_literal] = STATE(3611),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3610),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(5705),
    [anon_sym_LPAREN2] = ACTIONS(5834),
    [anon_sym_BANG] = ACTIONS(4926),
    [anon_sym_TILDE] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4928),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4924),
    [anon_sym_compl] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(5707),
    [anon_sym_PLUS_PLUS] = ACTIONS(5707),
    [anon_sym_sizeof] = ACTIONS(4932),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4934),
    [anon_sym_L_SQUOTE] = ACTIONS(4936),
    [anon_sym_u_SQUOTE] = ACTIONS(4936),
    [anon_sym_U_SQUOTE] = ACTIONS(4936),
    [anon_sym_u8_SQUOTE] = ACTIONS(4936),
    [anon_sym_SQUOTE] = ACTIONS(4936),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4938),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_co_await] = ACTIONS(4940),
    [anon_sym_new] = ACTIONS(4942),
    [anon_sym_requires] = ACTIONS(4944),
    [sym_this] = ACTIONS(241),
  },
  [2455] = {
    [sym_expression] = STATE(5044),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2456] = {
    [sym_expression] = STATE(5256),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2457] = {
    [sym_expression] = STATE(5428),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2458] = {
    [sym_expression] = STATE(5427),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2459] = {
    [sym_identifier] = ACTIONS(3535),
    [aux_sym_preproc_def_token1] = ACTIONS(3535),
    [aux_sym_preproc_if_token1] = ACTIONS(3535),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3535),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3535),
    [sym_preproc_directive] = ACTIONS(3535),
    [anon_sym_LPAREN2] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3537),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym___extension__] = ACTIONS(3535),
    [anon_sym_typedef] = ACTIONS(3535),
    [anon_sym_in] = ACTIONS(3535),
    [anon_sym_out] = ACTIONS(3535),
    [anon_sym_inout] = ACTIONS(3535),
    [anon_sym_extern] = ACTIONS(3535),
    [anon_sym___attribute__] = ACTIONS(3535),
    [anon_sym_COLON_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3537),
    [anon_sym___declspec] = ACTIONS(3535),
    [anon_sym___based] = ACTIONS(3535),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_signed] = ACTIONS(3535),
    [anon_sym_unsigned] = ACTIONS(3535),
    [anon_sym_long] = ACTIONS(3535),
    [anon_sym_short] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_static] = ACTIONS(3535),
    [anon_sym_register] = ACTIONS(3535),
    [anon_sym_inline] = ACTIONS(3535),
    [anon_sym___inline] = ACTIONS(3535),
    [anon_sym___inline__] = ACTIONS(3535),
    [anon_sym___forceinline] = ACTIONS(3535),
    [anon_sym_thread_local] = ACTIONS(3535),
    [anon_sym___thread] = ACTIONS(3535),
    [anon_sym_const] = ACTIONS(3535),
    [anon_sym_constexpr] = ACTIONS(3535),
    [anon_sym_volatile] = ACTIONS(3535),
    [anon_sym_restrict] = ACTIONS(3535),
    [anon_sym___restrict__] = ACTIONS(3535),
    [anon_sym__Atomic] = ACTIONS(3535),
    [anon_sym__Noreturn] = ACTIONS(3535),
    [anon_sym_noreturn] = ACTIONS(3535),
    [anon_sym_mutable] = ACTIONS(3535),
    [anon_sym_constinit] = ACTIONS(3535),
    [anon_sym_consteval] = ACTIONS(3535),
    [anon_sym_alignas] = ACTIONS(3535),
    [anon_sym__Alignas] = ACTIONS(3535),
    [sym_primitive_type] = ACTIONS(3535),
    [anon_sym_enum] = ACTIONS(3535),
    [anon_sym_class] = ACTIONS(3535),
    [anon_sym_struct] = ACTIONS(3535),
    [anon_sym_union] = ACTIONS(3535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3535),
    [anon_sym_let] = ACTIONS(3535),
    [anon_sym_This] = ACTIONS(3535),
    [anon_sym_decltype] = ACTIONS(3535),
    [sym_virtual] = ACTIONS(3535),
    [anon_sym_explicit] = ACTIONS(3535),
    [anon_sym_typename] = ACTIONS(3535),
    [anon_sym_template] = ACTIONS(3535),
    [anon_sym_operator] = ACTIONS(3535),
    [anon_sym_friend] = ACTIONS(3535),
    [anon_sym_public] = ACTIONS(3535),
    [anon_sym_private] = ACTIONS(3535),
    [anon_sym_protected] = ACTIONS(3535),
    [anon_sym_using] = ACTIONS(3535),
    [anon_sym_static_assert] = ACTIONS(3535),
    [anon_sym_precise] = ACTIONS(3535),
    [anon_sym_shared] = ACTIONS(3535),
    [anon_sym_groupshared] = ACTIONS(3535),
    [anon_sym_uniform] = ACTIONS(3535),
    [anon_sym_row_major] = ACTIONS(3535),
    [anon_sym_column_major] = ACTIONS(3535),
    [anon_sym_globallycoherent] = ACTIONS(3535),
    [anon_sym_centroid] = ACTIONS(3535),
    [anon_sym_noperspective] = ACTIONS(3535),
    [anon_sym_nointerpolation] = ACTIONS(3535),
    [anon_sym_sample] = ACTIONS(3535),
    [anon_sym_linear] = ACTIONS(3535),
    [anon_sym_snorm] = ACTIONS(3535),
    [anon_sym_unorm] = ACTIONS(3535),
    [anon_sym_point] = ACTIONS(3535),
    [anon_sym_line] = ACTIONS(3535),
    [anon_sym_triangleadj] = ACTIONS(3535),
    [anon_sym_lineadj] = ACTIONS(3535),
    [anon_sym_triangle] = ACTIONS(3535),
    [anon_sym_interface] = ACTIONS(3535),
    [anon_sym_extension] = ACTIONS(3535),
    [anon_sym___init] = ACTIONS(3535),
    [anon_sym___subscript] = ACTIONS(3535),
    [anon_sym_property] = ACTIONS(3535),
    [anon_sym_associatedtype] = ACTIONS(3535),
  },
  [2460] = {
    [sym_identifier] = ACTIONS(3406),
    [aux_sym_preproc_def_token1] = ACTIONS(3406),
    [aux_sym_preproc_if_token1] = ACTIONS(3406),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3406),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3406),
    [sym_preproc_directive] = ACTIONS(3406),
    [anon_sym_LPAREN2] = ACTIONS(3408),
    [anon_sym_TILDE] = ACTIONS(3408),
    [anon_sym_STAR] = ACTIONS(3408),
    [anon_sym_AMP_AMP] = ACTIONS(3408),
    [anon_sym_AMP] = ACTIONS(3406),
    [anon_sym___extension__] = ACTIONS(3406),
    [anon_sym_typedef] = ACTIONS(3406),
    [anon_sym_in] = ACTIONS(3406),
    [anon_sym_out] = ACTIONS(3406),
    [anon_sym_inout] = ACTIONS(3406),
    [anon_sym_extern] = ACTIONS(3406),
    [anon_sym___attribute__] = ACTIONS(3406),
    [anon_sym_COLON_COLON] = ACTIONS(3408),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3408),
    [anon_sym___declspec] = ACTIONS(3406),
    [anon_sym___based] = ACTIONS(3406),
    [anon_sym_RBRACE] = ACTIONS(3408),
    [anon_sym_signed] = ACTIONS(3406),
    [anon_sym_unsigned] = ACTIONS(3406),
    [anon_sym_long] = ACTIONS(3406),
    [anon_sym_short] = ACTIONS(3406),
    [anon_sym_LBRACK] = ACTIONS(3406),
    [anon_sym_static] = ACTIONS(3406),
    [anon_sym_register] = ACTIONS(3406),
    [anon_sym_inline] = ACTIONS(3406),
    [anon_sym___inline] = ACTIONS(3406),
    [anon_sym___inline__] = ACTIONS(3406),
    [anon_sym___forceinline] = ACTIONS(3406),
    [anon_sym_thread_local] = ACTIONS(3406),
    [anon_sym___thread] = ACTIONS(3406),
    [anon_sym_const] = ACTIONS(3406),
    [anon_sym_constexpr] = ACTIONS(3406),
    [anon_sym_volatile] = ACTIONS(3406),
    [anon_sym_restrict] = ACTIONS(3406),
    [anon_sym___restrict__] = ACTIONS(3406),
    [anon_sym__Atomic] = ACTIONS(3406),
    [anon_sym__Noreturn] = ACTIONS(3406),
    [anon_sym_noreturn] = ACTIONS(3406),
    [anon_sym_mutable] = ACTIONS(3406),
    [anon_sym_constinit] = ACTIONS(3406),
    [anon_sym_consteval] = ACTIONS(3406),
    [anon_sym_alignas] = ACTIONS(3406),
    [anon_sym__Alignas] = ACTIONS(3406),
    [sym_primitive_type] = ACTIONS(3406),
    [anon_sym_enum] = ACTIONS(3406),
    [anon_sym_class] = ACTIONS(3406),
    [anon_sym_struct] = ACTIONS(3406),
    [anon_sym_union] = ACTIONS(3406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3406),
    [anon_sym_let] = ACTIONS(3406),
    [anon_sym_This] = ACTIONS(3406),
    [anon_sym_decltype] = ACTIONS(3406),
    [sym_virtual] = ACTIONS(3406),
    [anon_sym_explicit] = ACTIONS(3406),
    [anon_sym_typename] = ACTIONS(3406),
    [anon_sym_template] = ACTIONS(3406),
    [anon_sym_operator] = ACTIONS(3406),
    [anon_sym_friend] = ACTIONS(3406),
    [anon_sym_public] = ACTIONS(3406),
    [anon_sym_private] = ACTIONS(3406),
    [anon_sym_protected] = ACTIONS(3406),
    [anon_sym_using] = ACTIONS(3406),
    [anon_sym_static_assert] = ACTIONS(3406),
    [anon_sym_precise] = ACTIONS(3406),
    [anon_sym_shared] = ACTIONS(3406),
    [anon_sym_groupshared] = ACTIONS(3406),
    [anon_sym_uniform] = ACTIONS(3406),
    [anon_sym_row_major] = ACTIONS(3406),
    [anon_sym_column_major] = ACTIONS(3406),
    [anon_sym_globallycoherent] = ACTIONS(3406),
    [anon_sym_centroid] = ACTIONS(3406),
    [anon_sym_noperspective] = ACTIONS(3406),
    [anon_sym_nointerpolation] = ACTIONS(3406),
    [anon_sym_sample] = ACTIONS(3406),
    [anon_sym_linear] = ACTIONS(3406),
    [anon_sym_snorm] = ACTIONS(3406),
    [anon_sym_unorm] = ACTIONS(3406),
    [anon_sym_point] = ACTIONS(3406),
    [anon_sym_line] = ACTIONS(3406),
    [anon_sym_triangleadj] = ACTIONS(3406),
    [anon_sym_lineadj] = ACTIONS(3406),
    [anon_sym_triangle] = ACTIONS(3406),
    [anon_sym_interface] = ACTIONS(3406),
    [anon_sym_extension] = ACTIONS(3406),
    [anon_sym___init] = ACTIONS(3406),
    [anon_sym___subscript] = ACTIONS(3406),
    [anon_sym_property] = ACTIONS(3406),
    [anon_sym_associatedtype] = ACTIONS(3406),
  },
  [2461] = {
    [sym_expression] = STATE(3699),
    [sym__string] = STATE(4324),
    [sym_conditional_expression] = STATE(4324),
    [sym_assignment_expression] = STATE(4324),
    [sym_pointer_expression] = STATE(4292),
    [sym_unary_expression] = STATE(4324),
    [sym_binary_expression] = STATE(4324),
    [sym_update_expression] = STATE(4324),
    [sym_cast_expression] = STATE(4324),
    [sym_sizeof_expression] = STATE(4324),
    [sym_alignof_expression] = STATE(4324),
    [sym_offsetof_expression] = STATE(4324),
    [sym_generic_expression] = STATE(4324),
    [sym_subscript_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_gnu_asm_expression] = STATE(4324),
    [sym_field_expression] = STATE(4292),
    [sym_compound_literal_expression] = STATE(4324),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_char_literal] = STATE(4066),
    [sym_concatenated_string] = STATE(4089),
    [sym_string_literal] = STATE(3118),
    [sym_null] = STATE(4324),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9813),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4324),
    [sym_raw_string_literal] = STATE(3143),
    [sym_co_await_expression] = STATE(4324),
    [sym_new_expression] = STATE(4324),
    [sym_delete_expression] = STATE(4324),
    [sym_requires_clause] = STATE(4324),
    [sym_requires_expression] = STATE(4324),
    [sym_lambda_expression] = STATE(4324),
    [sym_lambda_capture_specifier] = STATE(7029),
    [sym_fold_expression] = STATE(4324),
    [sym_parameter_pack_expansion] = STATE(4324),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6765),
    [sym_qualified_identifier] = STATE(4292),
    [sym_qualified_type_identifier] = STATE(9813),
    [sym_user_defined_literal] = STATE(4292),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(6124),
    [sym_primitive_type] = ACTIONS(4585),
    [anon_sym_not] = ACTIONS(2756),
    [anon_sym_compl] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_sizeof] = ACTIONS(2782),
    [anon_sym___alignof__] = ACTIONS(2784),
    [anon_sym___alignof] = ACTIONS(2784),
    [anon_sym__alignof] = ACTIONS(2784),
    [anon_sym_alignof] = ACTIONS(2784),
    [anon_sym__Alignof] = ACTIONS(2784),
    [anon_sym_offsetof] = ACTIONS(2786),
    [anon_sym__Generic] = ACTIONS(2788),
    [anon_sym_asm] = ACTIONS(2790),
    [anon_sym___asm__] = ACTIONS(2790),
    [sym_number_literal] = ACTIONS(2792),
    [anon_sym_L_SQUOTE] = ACTIONS(2794),
    [anon_sym_u_SQUOTE] = ACTIONS(2794),
    [anon_sym_U_SQUOTE] = ACTIONS(2794),
    [anon_sym_u8_SQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [anon_sym_L_DQUOTE] = ACTIONS(2796),
    [anon_sym_u_DQUOTE] = ACTIONS(2796),
    [anon_sym_U_DQUOTE] = ACTIONS(2796),
    [anon_sym_u8_DQUOTE] = ACTIONS(2796),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [anon_sym_NULL] = ACTIONS(2800),
    [anon_sym_nullptr] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(2810),
    [anon_sym_R_DQUOTE] = ACTIONS(2812),
    [anon_sym_LR_DQUOTE] = ACTIONS(2812),
    [anon_sym_uR_DQUOTE] = ACTIONS(2812),
    [anon_sym_UR_DQUOTE] = ACTIONS(2812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2812),
    [anon_sym_co_await] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2798),
  },
  [2462] = {
    [sym_expression] = STATE(4890),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4905),
    [sym_concatenated_string] = STATE(4902),
    [sym_string_literal] = STATE(3611),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3610),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(5705),
    [anon_sym_LPAREN2] = ACTIONS(5834),
    [anon_sym_BANG] = ACTIONS(4926),
    [anon_sym_TILDE] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4928),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4924),
    [anon_sym_compl] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(5707),
    [anon_sym_PLUS_PLUS] = ACTIONS(5707),
    [anon_sym_sizeof] = ACTIONS(4932),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4934),
    [anon_sym_L_SQUOTE] = ACTIONS(4936),
    [anon_sym_u_SQUOTE] = ACTIONS(4936),
    [anon_sym_U_SQUOTE] = ACTIONS(4936),
    [anon_sym_u8_SQUOTE] = ACTIONS(4936),
    [anon_sym_SQUOTE] = ACTIONS(4936),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4938),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_co_await] = ACTIONS(4940),
    [anon_sym_new] = ACTIONS(4942),
    [anon_sym_requires] = ACTIONS(4944),
    [sym_this] = ACTIONS(241),
  },
  [2463] = {
    [sym_expression] = STATE(5222),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2464] = {
    [sym_identifier] = ACTIONS(3182),
    [aux_sym_preproc_def_token1] = ACTIONS(3182),
    [aux_sym_preproc_if_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [sym_preproc_directive] = ACTIONS(3182),
    [anon_sym_LPAREN2] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_AMP_AMP] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3182),
    [anon_sym___extension__] = ACTIONS(3182),
    [anon_sym_typedef] = ACTIONS(3182),
    [anon_sym_in] = ACTIONS(3182),
    [anon_sym_out] = ACTIONS(3182),
    [anon_sym_inout] = ACTIONS(3182),
    [anon_sym_extern] = ACTIONS(3182),
    [anon_sym___attribute__] = ACTIONS(3182),
    [anon_sym_COLON_COLON] = ACTIONS(3184),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3184),
    [anon_sym___declspec] = ACTIONS(3182),
    [anon_sym___based] = ACTIONS(3182),
    [anon_sym_RBRACE] = ACTIONS(3184),
    [anon_sym_signed] = ACTIONS(3182),
    [anon_sym_unsigned] = ACTIONS(3182),
    [anon_sym_long] = ACTIONS(3182),
    [anon_sym_short] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3182),
    [anon_sym_register] = ACTIONS(3182),
    [anon_sym_inline] = ACTIONS(3182),
    [anon_sym___inline] = ACTIONS(3182),
    [anon_sym___inline__] = ACTIONS(3182),
    [anon_sym___forceinline] = ACTIONS(3182),
    [anon_sym_thread_local] = ACTIONS(3182),
    [anon_sym___thread] = ACTIONS(3182),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_constexpr] = ACTIONS(3182),
    [anon_sym_volatile] = ACTIONS(3182),
    [anon_sym_restrict] = ACTIONS(3182),
    [anon_sym___restrict__] = ACTIONS(3182),
    [anon_sym__Atomic] = ACTIONS(3182),
    [anon_sym__Noreturn] = ACTIONS(3182),
    [anon_sym_noreturn] = ACTIONS(3182),
    [anon_sym_mutable] = ACTIONS(3182),
    [anon_sym_constinit] = ACTIONS(3182),
    [anon_sym_consteval] = ACTIONS(3182),
    [anon_sym_alignas] = ACTIONS(3182),
    [anon_sym__Alignas] = ACTIONS(3182),
    [sym_primitive_type] = ACTIONS(3182),
    [anon_sym_enum] = ACTIONS(3182),
    [anon_sym_class] = ACTIONS(3182),
    [anon_sym_struct] = ACTIONS(3182),
    [anon_sym_union] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3182),
    [anon_sym_let] = ACTIONS(3182),
    [anon_sym_This] = ACTIONS(3182),
    [anon_sym_decltype] = ACTIONS(3182),
    [sym_virtual] = ACTIONS(3182),
    [anon_sym_explicit] = ACTIONS(3182),
    [anon_sym_typename] = ACTIONS(3182),
    [anon_sym_template] = ACTIONS(3182),
    [anon_sym_operator] = ACTIONS(3182),
    [anon_sym_friend] = ACTIONS(3182),
    [anon_sym_public] = ACTIONS(3182),
    [anon_sym_private] = ACTIONS(3182),
    [anon_sym_protected] = ACTIONS(3182),
    [anon_sym_using] = ACTIONS(3182),
    [anon_sym_static_assert] = ACTIONS(3182),
    [anon_sym_precise] = ACTIONS(3182),
    [anon_sym_shared] = ACTIONS(3182),
    [anon_sym_groupshared] = ACTIONS(3182),
    [anon_sym_uniform] = ACTIONS(3182),
    [anon_sym_row_major] = ACTIONS(3182),
    [anon_sym_column_major] = ACTIONS(3182),
    [anon_sym_globallycoherent] = ACTIONS(3182),
    [anon_sym_centroid] = ACTIONS(3182),
    [anon_sym_noperspective] = ACTIONS(3182),
    [anon_sym_nointerpolation] = ACTIONS(3182),
    [anon_sym_sample] = ACTIONS(3182),
    [anon_sym_linear] = ACTIONS(3182),
    [anon_sym_snorm] = ACTIONS(3182),
    [anon_sym_unorm] = ACTIONS(3182),
    [anon_sym_point] = ACTIONS(3182),
    [anon_sym_line] = ACTIONS(3182),
    [anon_sym_triangleadj] = ACTIONS(3182),
    [anon_sym_lineadj] = ACTIONS(3182),
    [anon_sym_triangle] = ACTIONS(3182),
    [anon_sym_interface] = ACTIONS(3182),
    [anon_sym_extension] = ACTIONS(3182),
    [anon_sym___init] = ACTIONS(3182),
    [anon_sym___subscript] = ACTIONS(3182),
    [anon_sym_property] = ACTIONS(3182),
    [anon_sym_associatedtype] = ACTIONS(3182),
  },
  [2465] = {
    [sym_expression] = STATE(5265),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2466] = {
    [sym_expression] = STATE(5224),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2467] = {
    [sym_expression] = STATE(5271),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2468] = {
    [sym_expression] = STATE(5277),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2469] = {
    [sym_expression] = STATE(5278),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2470] = {
    [sym_expression] = STATE(5282),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2471] = {
    [sym_expression] = STATE(5284),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2472] = {
    [sym_expression] = STATE(5289),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2473] = {
    [sym_identifier] = ACTIONS(3368),
    [aux_sym_preproc_def_token1] = ACTIONS(3368),
    [aux_sym_preproc_if_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3368),
    [sym_preproc_directive] = ACTIONS(3368),
    [anon_sym_LPAREN2] = ACTIONS(3370),
    [anon_sym_TILDE] = ACTIONS(3370),
    [anon_sym_STAR] = ACTIONS(3370),
    [anon_sym_AMP_AMP] = ACTIONS(3370),
    [anon_sym_AMP] = ACTIONS(3368),
    [anon_sym___extension__] = ACTIONS(3368),
    [anon_sym_typedef] = ACTIONS(3368),
    [anon_sym_in] = ACTIONS(3368),
    [anon_sym_out] = ACTIONS(3368),
    [anon_sym_inout] = ACTIONS(3368),
    [anon_sym_extern] = ACTIONS(3368),
    [anon_sym___attribute__] = ACTIONS(3368),
    [anon_sym_COLON_COLON] = ACTIONS(3370),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3370),
    [anon_sym___declspec] = ACTIONS(3368),
    [anon_sym___based] = ACTIONS(3368),
    [anon_sym_RBRACE] = ACTIONS(3370),
    [anon_sym_signed] = ACTIONS(3368),
    [anon_sym_unsigned] = ACTIONS(3368),
    [anon_sym_long] = ACTIONS(3368),
    [anon_sym_short] = ACTIONS(3368),
    [anon_sym_LBRACK] = ACTIONS(3368),
    [anon_sym_static] = ACTIONS(3368),
    [anon_sym_register] = ACTIONS(3368),
    [anon_sym_inline] = ACTIONS(3368),
    [anon_sym___inline] = ACTIONS(3368),
    [anon_sym___inline__] = ACTIONS(3368),
    [anon_sym___forceinline] = ACTIONS(3368),
    [anon_sym_thread_local] = ACTIONS(3368),
    [anon_sym___thread] = ACTIONS(3368),
    [anon_sym_const] = ACTIONS(3368),
    [anon_sym_constexpr] = ACTIONS(3368),
    [anon_sym_volatile] = ACTIONS(3368),
    [anon_sym_restrict] = ACTIONS(3368),
    [anon_sym___restrict__] = ACTIONS(3368),
    [anon_sym__Atomic] = ACTIONS(3368),
    [anon_sym__Noreturn] = ACTIONS(3368),
    [anon_sym_noreturn] = ACTIONS(3368),
    [anon_sym_mutable] = ACTIONS(3368),
    [anon_sym_constinit] = ACTIONS(3368),
    [anon_sym_consteval] = ACTIONS(3368),
    [anon_sym_alignas] = ACTIONS(3368),
    [anon_sym__Alignas] = ACTIONS(3368),
    [sym_primitive_type] = ACTIONS(3368),
    [anon_sym_enum] = ACTIONS(3368),
    [anon_sym_class] = ACTIONS(3368),
    [anon_sym_struct] = ACTIONS(3368),
    [anon_sym_union] = ACTIONS(3368),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3368),
    [anon_sym_let] = ACTIONS(3368),
    [anon_sym_This] = ACTIONS(3368),
    [anon_sym_decltype] = ACTIONS(3368),
    [sym_virtual] = ACTIONS(3368),
    [anon_sym_explicit] = ACTIONS(3368),
    [anon_sym_typename] = ACTIONS(3368),
    [anon_sym_template] = ACTIONS(3368),
    [anon_sym_operator] = ACTIONS(3368),
    [anon_sym_friend] = ACTIONS(3368),
    [anon_sym_public] = ACTIONS(3368),
    [anon_sym_private] = ACTIONS(3368),
    [anon_sym_protected] = ACTIONS(3368),
    [anon_sym_using] = ACTIONS(3368),
    [anon_sym_static_assert] = ACTIONS(3368),
    [anon_sym_precise] = ACTIONS(3368),
    [anon_sym_shared] = ACTIONS(3368),
    [anon_sym_groupshared] = ACTIONS(3368),
    [anon_sym_uniform] = ACTIONS(3368),
    [anon_sym_row_major] = ACTIONS(3368),
    [anon_sym_column_major] = ACTIONS(3368),
    [anon_sym_globallycoherent] = ACTIONS(3368),
    [anon_sym_centroid] = ACTIONS(3368),
    [anon_sym_noperspective] = ACTIONS(3368),
    [anon_sym_nointerpolation] = ACTIONS(3368),
    [anon_sym_sample] = ACTIONS(3368),
    [anon_sym_linear] = ACTIONS(3368),
    [anon_sym_snorm] = ACTIONS(3368),
    [anon_sym_unorm] = ACTIONS(3368),
    [anon_sym_point] = ACTIONS(3368),
    [anon_sym_line] = ACTIONS(3368),
    [anon_sym_triangleadj] = ACTIONS(3368),
    [anon_sym_lineadj] = ACTIONS(3368),
    [anon_sym_triangle] = ACTIONS(3368),
    [anon_sym_interface] = ACTIONS(3368),
    [anon_sym_extension] = ACTIONS(3368),
    [anon_sym___init] = ACTIONS(3368),
    [anon_sym___subscript] = ACTIONS(3368),
    [anon_sym_property] = ACTIONS(3368),
    [anon_sym_associatedtype] = ACTIONS(3368),
  },
  [2474] = {
    [sym_identifier] = ACTIONS(3374),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3374),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3374),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3374),
    [sym_preproc_directive] = ACTIONS(3374),
    [anon_sym_LPAREN2] = ACTIONS(3376),
    [anon_sym_TILDE] = ACTIONS(3376),
    [anon_sym_STAR] = ACTIONS(3376),
    [anon_sym_AMP_AMP] = ACTIONS(3376),
    [anon_sym_AMP] = ACTIONS(3374),
    [anon_sym___extension__] = ACTIONS(3374),
    [anon_sym_typedef] = ACTIONS(3374),
    [anon_sym_in] = ACTIONS(3374),
    [anon_sym_out] = ACTIONS(3374),
    [anon_sym_inout] = ACTIONS(3374),
    [anon_sym_extern] = ACTIONS(3374),
    [anon_sym___attribute__] = ACTIONS(3374),
    [anon_sym_COLON_COLON] = ACTIONS(3376),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3376),
    [anon_sym___declspec] = ACTIONS(3374),
    [anon_sym___based] = ACTIONS(3374),
    [anon_sym_RBRACE] = ACTIONS(3376),
    [anon_sym_signed] = ACTIONS(3374),
    [anon_sym_unsigned] = ACTIONS(3374),
    [anon_sym_long] = ACTIONS(3374),
    [anon_sym_short] = ACTIONS(3374),
    [anon_sym_LBRACK] = ACTIONS(3374),
    [anon_sym_static] = ACTIONS(3374),
    [anon_sym_register] = ACTIONS(3374),
    [anon_sym_inline] = ACTIONS(3374),
    [anon_sym___inline] = ACTIONS(3374),
    [anon_sym___inline__] = ACTIONS(3374),
    [anon_sym___forceinline] = ACTIONS(3374),
    [anon_sym_thread_local] = ACTIONS(3374),
    [anon_sym___thread] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3374),
    [anon_sym_constexpr] = ACTIONS(3374),
    [anon_sym_volatile] = ACTIONS(3374),
    [anon_sym_restrict] = ACTIONS(3374),
    [anon_sym___restrict__] = ACTIONS(3374),
    [anon_sym__Atomic] = ACTIONS(3374),
    [anon_sym__Noreturn] = ACTIONS(3374),
    [anon_sym_noreturn] = ACTIONS(3374),
    [anon_sym_mutable] = ACTIONS(3374),
    [anon_sym_constinit] = ACTIONS(3374),
    [anon_sym_consteval] = ACTIONS(3374),
    [anon_sym_alignas] = ACTIONS(3374),
    [anon_sym__Alignas] = ACTIONS(3374),
    [sym_primitive_type] = ACTIONS(3374),
    [anon_sym_enum] = ACTIONS(3374),
    [anon_sym_class] = ACTIONS(3374),
    [anon_sym_struct] = ACTIONS(3374),
    [anon_sym_union] = ACTIONS(3374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3374),
    [anon_sym_let] = ACTIONS(3374),
    [anon_sym_This] = ACTIONS(3374),
    [anon_sym_decltype] = ACTIONS(3374),
    [sym_virtual] = ACTIONS(3374),
    [anon_sym_explicit] = ACTIONS(3374),
    [anon_sym_typename] = ACTIONS(3374),
    [anon_sym_template] = ACTIONS(3374),
    [anon_sym_operator] = ACTIONS(3374),
    [anon_sym_friend] = ACTIONS(3374),
    [anon_sym_public] = ACTIONS(3374),
    [anon_sym_private] = ACTIONS(3374),
    [anon_sym_protected] = ACTIONS(3374),
    [anon_sym_using] = ACTIONS(3374),
    [anon_sym_static_assert] = ACTIONS(3374),
    [anon_sym_precise] = ACTIONS(3374),
    [anon_sym_shared] = ACTIONS(3374),
    [anon_sym_groupshared] = ACTIONS(3374),
    [anon_sym_uniform] = ACTIONS(3374),
    [anon_sym_row_major] = ACTIONS(3374),
    [anon_sym_column_major] = ACTIONS(3374),
    [anon_sym_globallycoherent] = ACTIONS(3374),
    [anon_sym_centroid] = ACTIONS(3374),
    [anon_sym_noperspective] = ACTIONS(3374),
    [anon_sym_nointerpolation] = ACTIONS(3374),
    [anon_sym_sample] = ACTIONS(3374),
    [anon_sym_linear] = ACTIONS(3374),
    [anon_sym_snorm] = ACTIONS(3374),
    [anon_sym_unorm] = ACTIONS(3374),
    [anon_sym_point] = ACTIONS(3374),
    [anon_sym_line] = ACTIONS(3374),
    [anon_sym_triangleadj] = ACTIONS(3374),
    [anon_sym_lineadj] = ACTIONS(3374),
    [anon_sym_triangle] = ACTIONS(3374),
    [anon_sym_interface] = ACTIONS(3374),
    [anon_sym_extension] = ACTIONS(3374),
    [anon_sym___init] = ACTIONS(3374),
    [anon_sym___subscript] = ACTIONS(3374),
    [anon_sym_property] = ACTIONS(3374),
    [anon_sym_associatedtype] = ACTIONS(3374),
  },
  [2475] = {
    [sym_expression] = STATE(5290),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2476] = {
    [sym_identifier] = ACTIONS(3437),
    [aux_sym_preproc_def_token1] = ACTIONS(3437),
    [aux_sym_preproc_if_token1] = ACTIONS(3437),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3437),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3437),
    [sym_preproc_directive] = ACTIONS(3437),
    [anon_sym_LPAREN2] = ACTIONS(3439),
    [anon_sym_TILDE] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(3439),
    [anon_sym_AMP_AMP] = ACTIONS(3439),
    [anon_sym_AMP] = ACTIONS(3437),
    [anon_sym___extension__] = ACTIONS(3437),
    [anon_sym_typedef] = ACTIONS(3437),
    [anon_sym_in] = ACTIONS(3437),
    [anon_sym_out] = ACTIONS(3437),
    [anon_sym_inout] = ACTIONS(3437),
    [anon_sym_extern] = ACTIONS(3437),
    [anon_sym___attribute__] = ACTIONS(3437),
    [anon_sym_COLON_COLON] = ACTIONS(3439),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3439),
    [anon_sym___declspec] = ACTIONS(3437),
    [anon_sym___based] = ACTIONS(3437),
    [anon_sym_RBRACE] = ACTIONS(3439),
    [anon_sym_signed] = ACTIONS(3437),
    [anon_sym_unsigned] = ACTIONS(3437),
    [anon_sym_long] = ACTIONS(3437),
    [anon_sym_short] = ACTIONS(3437),
    [anon_sym_LBRACK] = ACTIONS(3437),
    [anon_sym_static] = ACTIONS(3437),
    [anon_sym_register] = ACTIONS(3437),
    [anon_sym_inline] = ACTIONS(3437),
    [anon_sym___inline] = ACTIONS(3437),
    [anon_sym___inline__] = ACTIONS(3437),
    [anon_sym___forceinline] = ACTIONS(3437),
    [anon_sym_thread_local] = ACTIONS(3437),
    [anon_sym___thread] = ACTIONS(3437),
    [anon_sym_const] = ACTIONS(3437),
    [anon_sym_constexpr] = ACTIONS(3437),
    [anon_sym_volatile] = ACTIONS(3437),
    [anon_sym_restrict] = ACTIONS(3437),
    [anon_sym___restrict__] = ACTIONS(3437),
    [anon_sym__Atomic] = ACTIONS(3437),
    [anon_sym__Noreturn] = ACTIONS(3437),
    [anon_sym_noreturn] = ACTIONS(3437),
    [anon_sym_mutable] = ACTIONS(3437),
    [anon_sym_constinit] = ACTIONS(3437),
    [anon_sym_consteval] = ACTIONS(3437),
    [anon_sym_alignas] = ACTIONS(3437),
    [anon_sym__Alignas] = ACTIONS(3437),
    [sym_primitive_type] = ACTIONS(3437),
    [anon_sym_enum] = ACTIONS(3437),
    [anon_sym_class] = ACTIONS(3437),
    [anon_sym_struct] = ACTIONS(3437),
    [anon_sym_union] = ACTIONS(3437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3437),
    [anon_sym_let] = ACTIONS(3437),
    [anon_sym_This] = ACTIONS(3437),
    [anon_sym_decltype] = ACTIONS(3437),
    [sym_virtual] = ACTIONS(3437),
    [anon_sym_explicit] = ACTIONS(3437),
    [anon_sym_typename] = ACTIONS(3437),
    [anon_sym_template] = ACTIONS(3437),
    [anon_sym_operator] = ACTIONS(3437),
    [anon_sym_friend] = ACTIONS(3437),
    [anon_sym_public] = ACTIONS(3437),
    [anon_sym_private] = ACTIONS(3437),
    [anon_sym_protected] = ACTIONS(3437),
    [anon_sym_using] = ACTIONS(3437),
    [anon_sym_static_assert] = ACTIONS(3437),
    [anon_sym_precise] = ACTIONS(3437),
    [anon_sym_shared] = ACTIONS(3437),
    [anon_sym_groupshared] = ACTIONS(3437),
    [anon_sym_uniform] = ACTIONS(3437),
    [anon_sym_row_major] = ACTIONS(3437),
    [anon_sym_column_major] = ACTIONS(3437),
    [anon_sym_globallycoherent] = ACTIONS(3437),
    [anon_sym_centroid] = ACTIONS(3437),
    [anon_sym_noperspective] = ACTIONS(3437),
    [anon_sym_nointerpolation] = ACTIONS(3437),
    [anon_sym_sample] = ACTIONS(3437),
    [anon_sym_linear] = ACTIONS(3437),
    [anon_sym_snorm] = ACTIONS(3437),
    [anon_sym_unorm] = ACTIONS(3437),
    [anon_sym_point] = ACTIONS(3437),
    [anon_sym_line] = ACTIONS(3437),
    [anon_sym_triangleadj] = ACTIONS(3437),
    [anon_sym_lineadj] = ACTIONS(3437),
    [anon_sym_triangle] = ACTIONS(3437),
    [anon_sym_interface] = ACTIONS(3437),
    [anon_sym_extension] = ACTIONS(3437),
    [anon_sym___init] = ACTIONS(3437),
    [anon_sym___subscript] = ACTIONS(3437),
    [anon_sym_property] = ACTIONS(3437),
    [anon_sym_associatedtype] = ACTIONS(3437),
  },
  [2477] = {
    [sym_identifier] = ACTIONS(3433),
    [aux_sym_preproc_def_token1] = ACTIONS(3433),
    [aux_sym_preproc_if_token1] = ACTIONS(3433),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3433),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3433),
    [sym_preproc_directive] = ACTIONS(3433),
    [anon_sym_LPAREN2] = ACTIONS(3435),
    [anon_sym_TILDE] = ACTIONS(3435),
    [anon_sym_STAR] = ACTIONS(3435),
    [anon_sym_AMP_AMP] = ACTIONS(3435),
    [anon_sym_AMP] = ACTIONS(3433),
    [anon_sym___extension__] = ACTIONS(3433),
    [anon_sym_typedef] = ACTIONS(3433),
    [anon_sym_in] = ACTIONS(3433),
    [anon_sym_out] = ACTIONS(3433),
    [anon_sym_inout] = ACTIONS(3433),
    [anon_sym_extern] = ACTIONS(3433),
    [anon_sym___attribute__] = ACTIONS(3433),
    [anon_sym_COLON_COLON] = ACTIONS(3435),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3435),
    [anon_sym___declspec] = ACTIONS(3433),
    [anon_sym___based] = ACTIONS(3433),
    [anon_sym_RBRACE] = ACTIONS(3435),
    [anon_sym_signed] = ACTIONS(3433),
    [anon_sym_unsigned] = ACTIONS(3433),
    [anon_sym_long] = ACTIONS(3433),
    [anon_sym_short] = ACTIONS(3433),
    [anon_sym_LBRACK] = ACTIONS(3433),
    [anon_sym_static] = ACTIONS(3433),
    [anon_sym_register] = ACTIONS(3433),
    [anon_sym_inline] = ACTIONS(3433),
    [anon_sym___inline] = ACTIONS(3433),
    [anon_sym___inline__] = ACTIONS(3433),
    [anon_sym___forceinline] = ACTIONS(3433),
    [anon_sym_thread_local] = ACTIONS(3433),
    [anon_sym___thread] = ACTIONS(3433),
    [anon_sym_const] = ACTIONS(3433),
    [anon_sym_constexpr] = ACTIONS(3433),
    [anon_sym_volatile] = ACTIONS(3433),
    [anon_sym_restrict] = ACTIONS(3433),
    [anon_sym___restrict__] = ACTIONS(3433),
    [anon_sym__Atomic] = ACTIONS(3433),
    [anon_sym__Noreturn] = ACTIONS(3433),
    [anon_sym_noreturn] = ACTIONS(3433),
    [anon_sym_mutable] = ACTIONS(3433),
    [anon_sym_constinit] = ACTIONS(3433),
    [anon_sym_consteval] = ACTIONS(3433),
    [anon_sym_alignas] = ACTIONS(3433),
    [anon_sym__Alignas] = ACTIONS(3433),
    [sym_primitive_type] = ACTIONS(3433),
    [anon_sym_enum] = ACTIONS(3433),
    [anon_sym_class] = ACTIONS(3433),
    [anon_sym_struct] = ACTIONS(3433),
    [anon_sym_union] = ACTIONS(3433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3433),
    [anon_sym_let] = ACTIONS(3433),
    [anon_sym_This] = ACTIONS(3433),
    [anon_sym_decltype] = ACTIONS(3433),
    [sym_virtual] = ACTIONS(3433),
    [anon_sym_explicit] = ACTIONS(3433),
    [anon_sym_typename] = ACTIONS(3433),
    [anon_sym_template] = ACTIONS(3433),
    [anon_sym_operator] = ACTIONS(3433),
    [anon_sym_friend] = ACTIONS(3433),
    [anon_sym_public] = ACTIONS(3433),
    [anon_sym_private] = ACTIONS(3433),
    [anon_sym_protected] = ACTIONS(3433),
    [anon_sym_using] = ACTIONS(3433),
    [anon_sym_static_assert] = ACTIONS(3433),
    [anon_sym_precise] = ACTIONS(3433),
    [anon_sym_shared] = ACTIONS(3433),
    [anon_sym_groupshared] = ACTIONS(3433),
    [anon_sym_uniform] = ACTIONS(3433),
    [anon_sym_row_major] = ACTIONS(3433),
    [anon_sym_column_major] = ACTIONS(3433),
    [anon_sym_globallycoherent] = ACTIONS(3433),
    [anon_sym_centroid] = ACTIONS(3433),
    [anon_sym_noperspective] = ACTIONS(3433),
    [anon_sym_nointerpolation] = ACTIONS(3433),
    [anon_sym_sample] = ACTIONS(3433),
    [anon_sym_linear] = ACTIONS(3433),
    [anon_sym_snorm] = ACTIONS(3433),
    [anon_sym_unorm] = ACTIONS(3433),
    [anon_sym_point] = ACTIONS(3433),
    [anon_sym_line] = ACTIONS(3433),
    [anon_sym_triangleadj] = ACTIONS(3433),
    [anon_sym_lineadj] = ACTIONS(3433),
    [anon_sym_triangle] = ACTIONS(3433),
    [anon_sym_interface] = ACTIONS(3433),
    [anon_sym_extension] = ACTIONS(3433),
    [anon_sym___init] = ACTIONS(3433),
    [anon_sym___subscript] = ACTIONS(3433),
    [anon_sym_property] = ACTIONS(3433),
    [anon_sym_associatedtype] = ACTIONS(3433),
  },
  [2478] = {
    [sym_expression] = STATE(5292),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2479] = {
    [sym_expression] = STATE(5489),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2480] = {
    [sym_identifier] = ACTIONS(3418),
    [aux_sym_preproc_def_token1] = ACTIONS(3418),
    [aux_sym_preproc_if_token1] = ACTIONS(3418),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3418),
    [sym_preproc_directive] = ACTIONS(3418),
    [anon_sym_LPAREN2] = ACTIONS(3420),
    [anon_sym_TILDE] = ACTIONS(3420),
    [anon_sym_STAR] = ACTIONS(3420),
    [anon_sym_AMP_AMP] = ACTIONS(3420),
    [anon_sym_AMP] = ACTIONS(3418),
    [anon_sym___extension__] = ACTIONS(3418),
    [anon_sym_typedef] = ACTIONS(3418),
    [anon_sym_in] = ACTIONS(3418),
    [anon_sym_out] = ACTIONS(3418),
    [anon_sym_inout] = ACTIONS(3418),
    [anon_sym_extern] = ACTIONS(3418),
    [anon_sym___attribute__] = ACTIONS(3418),
    [anon_sym_COLON_COLON] = ACTIONS(3420),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3420),
    [anon_sym___declspec] = ACTIONS(3418),
    [anon_sym___based] = ACTIONS(3418),
    [anon_sym_RBRACE] = ACTIONS(3420),
    [anon_sym_signed] = ACTIONS(3418),
    [anon_sym_unsigned] = ACTIONS(3418),
    [anon_sym_long] = ACTIONS(3418),
    [anon_sym_short] = ACTIONS(3418),
    [anon_sym_LBRACK] = ACTIONS(3418),
    [anon_sym_static] = ACTIONS(3418),
    [anon_sym_register] = ACTIONS(3418),
    [anon_sym_inline] = ACTIONS(3418),
    [anon_sym___inline] = ACTIONS(3418),
    [anon_sym___inline__] = ACTIONS(3418),
    [anon_sym___forceinline] = ACTIONS(3418),
    [anon_sym_thread_local] = ACTIONS(3418),
    [anon_sym___thread] = ACTIONS(3418),
    [anon_sym_const] = ACTIONS(3418),
    [anon_sym_constexpr] = ACTIONS(3418),
    [anon_sym_volatile] = ACTIONS(3418),
    [anon_sym_restrict] = ACTIONS(3418),
    [anon_sym___restrict__] = ACTIONS(3418),
    [anon_sym__Atomic] = ACTIONS(3418),
    [anon_sym__Noreturn] = ACTIONS(3418),
    [anon_sym_noreturn] = ACTIONS(3418),
    [anon_sym_mutable] = ACTIONS(3418),
    [anon_sym_constinit] = ACTIONS(3418),
    [anon_sym_consteval] = ACTIONS(3418),
    [anon_sym_alignas] = ACTIONS(3418),
    [anon_sym__Alignas] = ACTIONS(3418),
    [sym_primitive_type] = ACTIONS(3418),
    [anon_sym_enum] = ACTIONS(3418),
    [anon_sym_class] = ACTIONS(3418),
    [anon_sym_struct] = ACTIONS(3418),
    [anon_sym_union] = ACTIONS(3418),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3418),
    [anon_sym_let] = ACTIONS(3418),
    [anon_sym_This] = ACTIONS(3418),
    [anon_sym_decltype] = ACTIONS(3418),
    [sym_virtual] = ACTIONS(3418),
    [anon_sym_explicit] = ACTIONS(3418),
    [anon_sym_typename] = ACTIONS(3418),
    [anon_sym_template] = ACTIONS(3418),
    [anon_sym_operator] = ACTIONS(3418),
    [anon_sym_friend] = ACTIONS(3418),
    [anon_sym_public] = ACTIONS(3418),
    [anon_sym_private] = ACTIONS(3418),
    [anon_sym_protected] = ACTIONS(3418),
    [anon_sym_using] = ACTIONS(3418),
    [anon_sym_static_assert] = ACTIONS(3418),
    [anon_sym_precise] = ACTIONS(3418),
    [anon_sym_shared] = ACTIONS(3418),
    [anon_sym_groupshared] = ACTIONS(3418),
    [anon_sym_uniform] = ACTIONS(3418),
    [anon_sym_row_major] = ACTIONS(3418),
    [anon_sym_column_major] = ACTIONS(3418),
    [anon_sym_globallycoherent] = ACTIONS(3418),
    [anon_sym_centroid] = ACTIONS(3418),
    [anon_sym_noperspective] = ACTIONS(3418),
    [anon_sym_nointerpolation] = ACTIONS(3418),
    [anon_sym_sample] = ACTIONS(3418),
    [anon_sym_linear] = ACTIONS(3418),
    [anon_sym_snorm] = ACTIONS(3418),
    [anon_sym_unorm] = ACTIONS(3418),
    [anon_sym_point] = ACTIONS(3418),
    [anon_sym_line] = ACTIONS(3418),
    [anon_sym_triangleadj] = ACTIONS(3418),
    [anon_sym_lineadj] = ACTIONS(3418),
    [anon_sym_triangle] = ACTIONS(3418),
    [anon_sym_interface] = ACTIONS(3418),
    [anon_sym_extension] = ACTIONS(3418),
    [anon_sym___init] = ACTIONS(3418),
    [anon_sym___subscript] = ACTIONS(3418),
    [anon_sym_property] = ACTIONS(3418),
    [anon_sym_associatedtype] = ACTIONS(3418),
  },
  [2481] = {
    [sym_expression] = STATE(5384),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2482] = {
    [sym_expression] = STATE(5557),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2483] = {
    [sym_expression] = STATE(5324),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2484] = {
    [sym_identifier] = ACTIONS(3467),
    [aux_sym_preproc_def_token1] = ACTIONS(3467),
    [aux_sym_preproc_if_token1] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3467),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3467),
    [sym_preproc_directive] = ACTIONS(3467),
    [anon_sym_LPAREN2] = ACTIONS(3469),
    [anon_sym_TILDE] = ACTIONS(3469),
    [anon_sym_STAR] = ACTIONS(3469),
    [anon_sym_AMP_AMP] = ACTIONS(3469),
    [anon_sym_AMP] = ACTIONS(3467),
    [anon_sym___extension__] = ACTIONS(3467),
    [anon_sym_typedef] = ACTIONS(3467),
    [anon_sym_in] = ACTIONS(3467),
    [anon_sym_out] = ACTIONS(3467),
    [anon_sym_inout] = ACTIONS(3467),
    [anon_sym_extern] = ACTIONS(3467),
    [anon_sym___attribute__] = ACTIONS(3467),
    [anon_sym_COLON_COLON] = ACTIONS(3469),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3469),
    [anon_sym___declspec] = ACTIONS(3467),
    [anon_sym___based] = ACTIONS(3467),
    [anon_sym_RBRACE] = ACTIONS(3469),
    [anon_sym_signed] = ACTIONS(3467),
    [anon_sym_unsigned] = ACTIONS(3467),
    [anon_sym_long] = ACTIONS(3467),
    [anon_sym_short] = ACTIONS(3467),
    [anon_sym_LBRACK] = ACTIONS(3467),
    [anon_sym_static] = ACTIONS(3467),
    [anon_sym_register] = ACTIONS(3467),
    [anon_sym_inline] = ACTIONS(3467),
    [anon_sym___inline] = ACTIONS(3467),
    [anon_sym___inline__] = ACTIONS(3467),
    [anon_sym___forceinline] = ACTIONS(3467),
    [anon_sym_thread_local] = ACTIONS(3467),
    [anon_sym___thread] = ACTIONS(3467),
    [anon_sym_const] = ACTIONS(3467),
    [anon_sym_constexpr] = ACTIONS(3467),
    [anon_sym_volatile] = ACTIONS(3467),
    [anon_sym_restrict] = ACTIONS(3467),
    [anon_sym___restrict__] = ACTIONS(3467),
    [anon_sym__Atomic] = ACTIONS(3467),
    [anon_sym__Noreturn] = ACTIONS(3467),
    [anon_sym_noreturn] = ACTIONS(3467),
    [anon_sym_mutable] = ACTIONS(3467),
    [anon_sym_constinit] = ACTIONS(3467),
    [anon_sym_consteval] = ACTIONS(3467),
    [anon_sym_alignas] = ACTIONS(3467),
    [anon_sym__Alignas] = ACTIONS(3467),
    [sym_primitive_type] = ACTIONS(3467),
    [anon_sym_enum] = ACTIONS(3467),
    [anon_sym_class] = ACTIONS(3467),
    [anon_sym_struct] = ACTIONS(3467),
    [anon_sym_union] = ACTIONS(3467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3467),
    [anon_sym_let] = ACTIONS(3467),
    [anon_sym_This] = ACTIONS(3467),
    [anon_sym_decltype] = ACTIONS(3467),
    [sym_virtual] = ACTIONS(3467),
    [anon_sym_explicit] = ACTIONS(3467),
    [anon_sym_typename] = ACTIONS(3467),
    [anon_sym_template] = ACTIONS(3467),
    [anon_sym_operator] = ACTIONS(3467),
    [anon_sym_friend] = ACTIONS(3467),
    [anon_sym_public] = ACTIONS(3467),
    [anon_sym_private] = ACTIONS(3467),
    [anon_sym_protected] = ACTIONS(3467),
    [anon_sym_using] = ACTIONS(3467),
    [anon_sym_static_assert] = ACTIONS(3467),
    [anon_sym_precise] = ACTIONS(3467),
    [anon_sym_shared] = ACTIONS(3467),
    [anon_sym_groupshared] = ACTIONS(3467),
    [anon_sym_uniform] = ACTIONS(3467),
    [anon_sym_row_major] = ACTIONS(3467),
    [anon_sym_column_major] = ACTIONS(3467),
    [anon_sym_globallycoherent] = ACTIONS(3467),
    [anon_sym_centroid] = ACTIONS(3467),
    [anon_sym_noperspective] = ACTIONS(3467),
    [anon_sym_nointerpolation] = ACTIONS(3467),
    [anon_sym_sample] = ACTIONS(3467),
    [anon_sym_linear] = ACTIONS(3467),
    [anon_sym_snorm] = ACTIONS(3467),
    [anon_sym_unorm] = ACTIONS(3467),
    [anon_sym_point] = ACTIONS(3467),
    [anon_sym_line] = ACTIONS(3467),
    [anon_sym_triangleadj] = ACTIONS(3467),
    [anon_sym_lineadj] = ACTIONS(3467),
    [anon_sym_triangle] = ACTIONS(3467),
    [anon_sym_interface] = ACTIONS(3467),
    [anon_sym_extension] = ACTIONS(3467),
    [anon_sym___init] = ACTIONS(3467),
    [anon_sym___subscript] = ACTIONS(3467),
    [anon_sym_property] = ACTIONS(3467),
    [anon_sym_associatedtype] = ACTIONS(3467),
  },
  [2485] = {
    [sym_identifier] = ACTIONS(3471),
    [aux_sym_preproc_def_token1] = ACTIONS(3471),
    [aux_sym_preproc_if_token1] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3471),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3471),
    [sym_preproc_directive] = ACTIONS(3471),
    [anon_sym_LPAREN2] = ACTIONS(3473),
    [anon_sym_TILDE] = ACTIONS(3473),
    [anon_sym_STAR] = ACTIONS(3473),
    [anon_sym_AMP_AMP] = ACTIONS(3473),
    [anon_sym_AMP] = ACTIONS(3471),
    [anon_sym___extension__] = ACTIONS(3471),
    [anon_sym_typedef] = ACTIONS(3471),
    [anon_sym_in] = ACTIONS(3471),
    [anon_sym_out] = ACTIONS(3471),
    [anon_sym_inout] = ACTIONS(3471),
    [anon_sym_extern] = ACTIONS(3471),
    [anon_sym___attribute__] = ACTIONS(3471),
    [anon_sym_COLON_COLON] = ACTIONS(3473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3473),
    [anon_sym___declspec] = ACTIONS(3471),
    [anon_sym___based] = ACTIONS(3471),
    [anon_sym_RBRACE] = ACTIONS(3473),
    [anon_sym_signed] = ACTIONS(3471),
    [anon_sym_unsigned] = ACTIONS(3471),
    [anon_sym_long] = ACTIONS(3471),
    [anon_sym_short] = ACTIONS(3471),
    [anon_sym_LBRACK] = ACTIONS(3471),
    [anon_sym_static] = ACTIONS(3471),
    [anon_sym_register] = ACTIONS(3471),
    [anon_sym_inline] = ACTIONS(3471),
    [anon_sym___inline] = ACTIONS(3471),
    [anon_sym___inline__] = ACTIONS(3471),
    [anon_sym___forceinline] = ACTIONS(3471),
    [anon_sym_thread_local] = ACTIONS(3471),
    [anon_sym___thread] = ACTIONS(3471),
    [anon_sym_const] = ACTIONS(3471),
    [anon_sym_constexpr] = ACTIONS(3471),
    [anon_sym_volatile] = ACTIONS(3471),
    [anon_sym_restrict] = ACTIONS(3471),
    [anon_sym___restrict__] = ACTIONS(3471),
    [anon_sym__Atomic] = ACTIONS(3471),
    [anon_sym__Noreturn] = ACTIONS(3471),
    [anon_sym_noreturn] = ACTIONS(3471),
    [anon_sym_mutable] = ACTIONS(3471),
    [anon_sym_constinit] = ACTIONS(3471),
    [anon_sym_consteval] = ACTIONS(3471),
    [anon_sym_alignas] = ACTIONS(3471),
    [anon_sym__Alignas] = ACTIONS(3471),
    [sym_primitive_type] = ACTIONS(3471),
    [anon_sym_enum] = ACTIONS(3471),
    [anon_sym_class] = ACTIONS(3471),
    [anon_sym_struct] = ACTIONS(3471),
    [anon_sym_union] = ACTIONS(3471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3471),
    [anon_sym_let] = ACTIONS(3471),
    [anon_sym_This] = ACTIONS(3471),
    [anon_sym_decltype] = ACTIONS(3471),
    [sym_virtual] = ACTIONS(3471),
    [anon_sym_explicit] = ACTIONS(3471),
    [anon_sym_typename] = ACTIONS(3471),
    [anon_sym_template] = ACTIONS(3471),
    [anon_sym_operator] = ACTIONS(3471),
    [anon_sym_friend] = ACTIONS(3471),
    [anon_sym_public] = ACTIONS(3471),
    [anon_sym_private] = ACTIONS(3471),
    [anon_sym_protected] = ACTIONS(3471),
    [anon_sym_using] = ACTIONS(3471),
    [anon_sym_static_assert] = ACTIONS(3471),
    [anon_sym_precise] = ACTIONS(3471),
    [anon_sym_shared] = ACTIONS(3471),
    [anon_sym_groupshared] = ACTIONS(3471),
    [anon_sym_uniform] = ACTIONS(3471),
    [anon_sym_row_major] = ACTIONS(3471),
    [anon_sym_column_major] = ACTIONS(3471),
    [anon_sym_globallycoherent] = ACTIONS(3471),
    [anon_sym_centroid] = ACTIONS(3471),
    [anon_sym_noperspective] = ACTIONS(3471),
    [anon_sym_nointerpolation] = ACTIONS(3471),
    [anon_sym_sample] = ACTIONS(3471),
    [anon_sym_linear] = ACTIONS(3471),
    [anon_sym_snorm] = ACTIONS(3471),
    [anon_sym_unorm] = ACTIONS(3471),
    [anon_sym_point] = ACTIONS(3471),
    [anon_sym_line] = ACTIONS(3471),
    [anon_sym_triangleadj] = ACTIONS(3471),
    [anon_sym_lineadj] = ACTIONS(3471),
    [anon_sym_triangle] = ACTIONS(3471),
    [anon_sym_interface] = ACTIONS(3471),
    [anon_sym_extension] = ACTIONS(3471),
    [anon_sym___init] = ACTIONS(3471),
    [anon_sym___subscript] = ACTIONS(3471),
    [anon_sym_property] = ACTIONS(3471),
    [anon_sym_associatedtype] = ACTIONS(3471),
  },
  [2486] = {
    [sym_identifier] = ACTIONS(3489),
    [aux_sym_preproc_def_token1] = ACTIONS(3489),
    [aux_sym_preproc_if_token1] = ACTIONS(3489),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3489),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3489),
    [sym_preproc_directive] = ACTIONS(3489),
    [anon_sym_LPAREN2] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3491),
    [anon_sym_STAR] = ACTIONS(3491),
    [anon_sym_AMP_AMP] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3489),
    [anon_sym___extension__] = ACTIONS(3489),
    [anon_sym_typedef] = ACTIONS(3489),
    [anon_sym_in] = ACTIONS(3489),
    [anon_sym_out] = ACTIONS(3489),
    [anon_sym_inout] = ACTIONS(3489),
    [anon_sym_extern] = ACTIONS(3489),
    [anon_sym___attribute__] = ACTIONS(3489),
    [anon_sym_COLON_COLON] = ACTIONS(3491),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3491),
    [anon_sym___declspec] = ACTIONS(3489),
    [anon_sym___based] = ACTIONS(3489),
    [anon_sym_RBRACE] = ACTIONS(3491),
    [anon_sym_signed] = ACTIONS(3489),
    [anon_sym_unsigned] = ACTIONS(3489),
    [anon_sym_long] = ACTIONS(3489),
    [anon_sym_short] = ACTIONS(3489),
    [anon_sym_LBRACK] = ACTIONS(3489),
    [anon_sym_static] = ACTIONS(3489),
    [anon_sym_register] = ACTIONS(3489),
    [anon_sym_inline] = ACTIONS(3489),
    [anon_sym___inline] = ACTIONS(3489),
    [anon_sym___inline__] = ACTIONS(3489),
    [anon_sym___forceinline] = ACTIONS(3489),
    [anon_sym_thread_local] = ACTIONS(3489),
    [anon_sym___thread] = ACTIONS(3489),
    [anon_sym_const] = ACTIONS(3489),
    [anon_sym_constexpr] = ACTIONS(3489),
    [anon_sym_volatile] = ACTIONS(3489),
    [anon_sym_restrict] = ACTIONS(3489),
    [anon_sym___restrict__] = ACTIONS(3489),
    [anon_sym__Atomic] = ACTIONS(3489),
    [anon_sym__Noreturn] = ACTIONS(3489),
    [anon_sym_noreturn] = ACTIONS(3489),
    [anon_sym_mutable] = ACTIONS(3489),
    [anon_sym_constinit] = ACTIONS(3489),
    [anon_sym_consteval] = ACTIONS(3489),
    [anon_sym_alignas] = ACTIONS(3489),
    [anon_sym__Alignas] = ACTIONS(3489),
    [sym_primitive_type] = ACTIONS(3489),
    [anon_sym_enum] = ACTIONS(3489),
    [anon_sym_class] = ACTIONS(3489),
    [anon_sym_struct] = ACTIONS(3489),
    [anon_sym_union] = ACTIONS(3489),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3489),
    [anon_sym_let] = ACTIONS(3489),
    [anon_sym_This] = ACTIONS(3489),
    [anon_sym_decltype] = ACTIONS(3489),
    [sym_virtual] = ACTIONS(3489),
    [anon_sym_explicit] = ACTIONS(3489),
    [anon_sym_typename] = ACTIONS(3489),
    [anon_sym_template] = ACTIONS(3489),
    [anon_sym_operator] = ACTIONS(3489),
    [anon_sym_friend] = ACTIONS(3489),
    [anon_sym_public] = ACTIONS(3489),
    [anon_sym_private] = ACTIONS(3489),
    [anon_sym_protected] = ACTIONS(3489),
    [anon_sym_using] = ACTIONS(3489),
    [anon_sym_static_assert] = ACTIONS(3489),
    [anon_sym_precise] = ACTIONS(3489),
    [anon_sym_shared] = ACTIONS(3489),
    [anon_sym_groupshared] = ACTIONS(3489),
    [anon_sym_uniform] = ACTIONS(3489),
    [anon_sym_row_major] = ACTIONS(3489),
    [anon_sym_column_major] = ACTIONS(3489),
    [anon_sym_globallycoherent] = ACTIONS(3489),
    [anon_sym_centroid] = ACTIONS(3489),
    [anon_sym_noperspective] = ACTIONS(3489),
    [anon_sym_nointerpolation] = ACTIONS(3489),
    [anon_sym_sample] = ACTIONS(3489),
    [anon_sym_linear] = ACTIONS(3489),
    [anon_sym_snorm] = ACTIONS(3489),
    [anon_sym_unorm] = ACTIONS(3489),
    [anon_sym_point] = ACTIONS(3489),
    [anon_sym_line] = ACTIONS(3489),
    [anon_sym_triangleadj] = ACTIONS(3489),
    [anon_sym_lineadj] = ACTIONS(3489),
    [anon_sym_triangle] = ACTIONS(3489),
    [anon_sym_interface] = ACTIONS(3489),
    [anon_sym_extension] = ACTIONS(3489),
    [anon_sym___init] = ACTIONS(3489),
    [anon_sym___subscript] = ACTIONS(3489),
    [anon_sym_property] = ACTIONS(3489),
    [anon_sym_associatedtype] = ACTIONS(3489),
  },
  [2487] = {
    [sym_identifier] = ACTIONS(3344),
    [aux_sym_preproc_def_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token2] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3344),
    [sym_preproc_directive] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym___extension__] = ACTIONS(3344),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_in] = ACTIONS(3344),
    [anon_sym_out] = ACTIONS(3344),
    [anon_sym_inout] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym___attribute__] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3346),
    [anon_sym___declspec] = ACTIONS(3344),
    [anon_sym___based] = ACTIONS(3344),
    [anon_sym_signed] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym___inline] = ACTIONS(3344),
    [anon_sym___inline__] = ACTIONS(3344),
    [anon_sym___forceinline] = ACTIONS(3344),
    [anon_sym_thread_local] = ACTIONS(3344),
    [anon_sym___thread] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym___restrict__] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym__Noreturn] = ACTIONS(3344),
    [anon_sym_noreturn] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_constinit] = ACTIONS(3344),
    [anon_sym_consteval] = ACTIONS(3344),
    [anon_sym_alignas] = ACTIONS(3344),
    [anon_sym__Alignas] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_class] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_This] = ACTIONS(3344),
    [anon_sym_decltype] = ACTIONS(3344),
    [sym_virtual] = ACTIONS(3344),
    [anon_sym_explicit] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_template] = ACTIONS(3344),
    [anon_sym_operator] = ACTIONS(3344),
    [anon_sym_friend] = ACTIONS(3344),
    [anon_sym_public] = ACTIONS(3344),
    [anon_sym_private] = ACTIONS(3344),
    [anon_sym_protected] = ACTIONS(3344),
    [anon_sym_using] = ACTIONS(3344),
    [anon_sym_static_assert] = ACTIONS(3344),
    [anon_sym_precise] = ACTIONS(3344),
    [anon_sym_shared] = ACTIONS(3344),
    [anon_sym_groupshared] = ACTIONS(3344),
    [anon_sym_uniform] = ACTIONS(3344),
    [anon_sym_row_major] = ACTIONS(3344),
    [anon_sym_column_major] = ACTIONS(3344),
    [anon_sym_globallycoherent] = ACTIONS(3344),
    [anon_sym_centroid] = ACTIONS(3344),
    [anon_sym_noperspective] = ACTIONS(3344),
    [anon_sym_nointerpolation] = ACTIONS(3344),
    [anon_sym_sample] = ACTIONS(3344),
    [anon_sym_linear] = ACTIONS(3344),
    [anon_sym_snorm] = ACTIONS(3344),
    [anon_sym_unorm] = ACTIONS(3344),
    [anon_sym_point] = ACTIONS(3344),
    [anon_sym_line] = ACTIONS(3344),
    [anon_sym_triangleadj] = ACTIONS(3344),
    [anon_sym_lineadj] = ACTIONS(3344),
    [anon_sym_triangle] = ACTIONS(3344),
    [anon_sym_interface] = ACTIONS(3344),
    [anon_sym_extension] = ACTIONS(3344),
    [anon_sym___init] = ACTIONS(3344),
    [anon_sym___subscript] = ACTIONS(3344),
    [anon_sym_property] = ACTIONS(3344),
    [anon_sym_associatedtype] = ACTIONS(3344),
  },
  [2488] = {
    [sym_expression] = STATE(5293),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2489] = {
    [sym_identifier] = ACTIONS(5626),
    [aux_sym_preproc_def_token1] = ACTIONS(5626),
    [aux_sym_preproc_if_token1] = ACTIONS(5626),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5626),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5626),
    [sym_preproc_directive] = ACTIONS(5626),
    [anon_sym_LPAREN2] = ACTIONS(5628),
    [anon_sym_TILDE] = ACTIONS(5628),
    [anon_sym_STAR] = ACTIONS(5628),
    [anon_sym_AMP_AMP] = ACTIONS(5628),
    [anon_sym_AMP] = ACTIONS(5626),
    [anon_sym___extension__] = ACTIONS(5626),
    [anon_sym_typedef] = ACTIONS(5626),
    [anon_sym_in] = ACTIONS(5626),
    [anon_sym_out] = ACTIONS(5626),
    [anon_sym_inout] = ACTIONS(5626),
    [anon_sym_extern] = ACTIONS(5626),
    [anon_sym___attribute__] = ACTIONS(5626),
    [anon_sym_COLON_COLON] = ACTIONS(5628),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5628),
    [anon_sym___declspec] = ACTIONS(5626),
    [anon_sym___based] = ACTIONS(5626),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_signed] = ACTIONS(5626),
    [anon_sym_unsigned] = ACTIONS(5626),
    [anon_sym_long] = ACTIONS(5626),
    [anon_sym_short] = ACTIONS(5626),
    [anon_sym_LBRACK] = ACTIONS(5626),
    [anon_sym_static] = ACTIONS(5626),
    [anon_sym_register] = ACTIONS(5626),
    [anon_sym_inline] = ACTIONS(5626),
    [anon_sym___inline] = ACTIONS(5626),
    [anon_sym___inline__] = ACTIONS(5626),
    [anon_sym___forceinline] = ACTIONS(5626),
    [anon_sym_thread_local] = ACTIONS(5626),
    [anon_sym___thread] = ACTIONS(5626),
    [anon_sym_const] = ACTIONS(5626),
    [anon_sym_constexpr] = ACTIONS(5626),
    [anon_sym_volatile] = ACTIONS(5626),
    [anon_sym_restrict] = ACTIONS(5626),
    [anon_sym___restrict__] = ACTIONS(5626),
    [anon_sym__Atomic] = ACTIONS(5626),
    [anon_sym__Noreturn] = ACTIONS(5626),
    [anon_sym_noreturn] = ACTIONS(5626),
    [anon_sym_mutable] = ACTIONS(5626),
    [anon_sym_constinit] = ACTIONS(5626),
    [anon_sym_consteval] = ACTIONS(5626),
    [anon_sym_alignas] = ACTIONS(5626),
    [anon_sym__Alignas] = ACTIONS(5626),
    [sym_primitive_type] = ACTIONS(5626),
    [anon_sym_enum] = ACTIONS(5626),
    [anon_sym_class] = ACTIONS(5626),
    [anon_sym_struct] = ACTIONS(5626),
    [anon_sym_union] = ACTIONS(5626),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5626),
    [anon_sym_let] = ACTIONS(5626),
    [anon_sym_This] = ACTIONS(5626),
    [anon_sym_decltype] = ACTIONS(5626),
    [sym_virtual] = ACTIONS(5626),
    [anon_sym_explicit] = ACTIONS(5626),
    [anon_sym_typename] = ACTIONS(5626),
    [anon_sym_template] = ACTIONS(5626),
    [anon_sym_operator] = ACTIONS(5626),
    [anon_sym_friend] = ACTIONS(5626),
    [anon_sym_public] = ACTIONS(5626),
    [anon_sym_private] = ACTIONS(5626),
    [anon_sym_protected] = ACTIONS(5626),
    [anon_sym_using] = ACTIONS(5626),
    [anon_sym_static_assert] = ACTIONS(5626),
    [anon_sym_precise] = ACTIONS(5626),
    [anon_sym_shared] = ACTIONS(5626),
    [anon_sym_groupshared] = ACTIONS(5626),
    [anon_sym_uniform] = ACTIONS(5626),
    [anon_sym_row_major] = ACTIONS(5626),
    [anon_sym_column_major] = ACTIONS(5626),
    [anon_sym_globallycoherent] = ACTIONS(5626),
    [anon_sym_centroid] = ACTIONS(5626),
    [anon_sym_noperspective] = ACTIONS(5626),
    [anon_sym_nointerpolation] = ACTIONS(5626),
    [anon_sym_sample] = ACTIONS(5626),
    [anon_sym_linear] = ACTIONS(5626),
    [anon_sym_snorm] = ACTIONS(5626),
    [anon_sym_unorm] = ACTIONS(5626),
    [anon_sym_point] = ACTIONS(5626),
    [anon_sym_line] = ACTIONS(5626),
    [anon_sym_triangleadj] = ACTIONS(5626),
    [anon_sym_lineadj] = ACTIONS(5626),
    [anon_sym_triangle] = ACTIONS(5626),
    [anon_sym_interface] = ACTIONS(5626),
    [anon_sym_extension] = ACTIONS(5626),
    [anon_sym___init] = ACTIONS(5626),
    [anon_sym___subscript] = ACTIONS(5626),
    [anon_sym_property] = ACTIONS(5626),
    [anon_sym_associatedtype] = ACTIONS(5626),
  },
  [2490] = {
    [sym_expression] = STATE(5296),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2491] = {
    [sym_expression] = STATE(5297),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2492] = {
    [sym_expression] = STATE(5517),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2493] = {
    [sym_expression] = STATE(5312),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2494] = {
    [sym_expression] = STATE(5369),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2495] = {
    [sym_expression] = STATE(5221),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2496] = {
    [sym_expression] = STATE(5311),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2497] = {
    [sym_identifier] = ACTIONS(3513),
    [aux_sym_preproc_def_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3513),
    [sym_preproc_directive] = ACTIONS(3513),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3513),
    [anon_sym___extension__] = ACTIONS(3513),
    [anon_sym_typedef] = ACTIONS(3513),
    [anon_sym_in] = ACTIONS(3513),
    [anon_sym_out] = ACTIONS(3513),
    [anon_sym_inout] = ACTIONS(3513),
    [anon_sym_extern] = ACTIONS(3513),
    [anon_sym___attribute__] = ACTIONS(3513),
    [anon_sym_COLON_COLON] = ACTIONS(3515),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3515),
    [anon_sym___declspec] = ACTIONS(3513),
    [anon_sym___based] = ACTIONS(3513),
    [anon_sym_RBRACE] = ACTIONS(3515),
    [anon_sym_signed] = ACTIONS(3513),
    [anon_sym_unsigned] = ACTIONS(3513),
    [anon_sym_long] = ACTIONS(3513),
    [anon_sym_short] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_register] = ACTIONS(3513),
    [anon_sym_inline] = ACTIONS(3513),
    [anon_sym___inline] = ACTIONS(3513),
    [anon_sym___inline__] = ACTIONS(3513),
    [anon_sym___forceinline] = ACTIONS(3513),
    [anon_sym_thread_local] = ACTIONS(3513),
    [anon_sym___thread] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [anon_sym_constexpr] = ACTIONS(3513),
    [anon_sym_volatile] = ACTIONS(3513),
    [anon_sym_restrict] = ACTIONS(3513),
    [anon_sym___restrict__] = ACTIONS(3513),
    [anon_sym__Atomic] = ACTIONS(3513),
    [anon_sym__Noreturn] = ACTIONS(3513),
    [anon_sym_noreturn] = ACTIONS(3513),
    [anon_sym_mutable] = ACTIONS(3513),
    [anon_sym_constinit] = ACTIONS(3513),
    [anon_sym_consteval] = ACTIONS(3513),
    [anon_sym_alignas] = ACTIONS(3513),
    [anon_sym__Alignas] = ACTIONS(3513),
    [sym_primitive_type] = ACTIONS(3513),
    [anon_sym_enum] = ACTIONS(3513),
    [anon_sym_class] = ACTIONS(3513),
    [anon_sym_struct] = ACTIONS(3513),
    [anon_sym_union] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3513),
    [anon_sym_let] = ACTIONS(3513),
    [anon_sym_This] = ACTIONS(3513),
    [anon_sym_decltype] = ACTIONS(3513),
    [sym_virtual] = ACTIONS(3513),
    [anon_sym_explicit] = ACTIONS(3513),
    [anon_sym_typename] = ACTIONS(3513),
    [anon_sym_template] = ACTIONS(3513),
    [anon_sym_operator] = ACTIONS(3513),
    [anon_sym_friend] = ACTIONS(3513),
    [anon_sym_public] = ACTIONS(3513),
    [anon_sym_private] = ACTIONS(3513),
    [anon_sym_protected] = ACTIONS(3513),
    [anon_sym_using] = ACTIONS(3513),
    [anon_sym_static_assert] = ACTIONS(3513),
    [anon_sym_precise] = ACTIONS(3513),
    [anon_sym_shared] = ACTIONS(3513),
    [anon_sym_groupshared] = ACTIONS(3513),
    [anon_sym_uniform] = ACTIONS(3513),
    [anon_sym_row_major] = ACTIONS(3513),
    [anon_sym_column_major] = ACTIONS(3513),
    [anon_sym_globallycoherent] = ACTIONS(3513),
    [anon_sym_centroid] = ACTIONS(3513),
    [anon_sym_noperspective] = ACTIONS(3513),
    [anon_sym_nointerpolation] = ACTIONS(3513),
    [anon_sym_sample] = ACTIONS(3513),
    [anon_sym_linear] = ACTIONS(3513),
    [anon_sym_snorm] = ACTIONS(3513),
    [anon_sym_unorm] = ACTIONS(3513),
    [anon_sym_point] = ACTIONS(3513),
    [anon_sym_line] = ACTIONS(3513),
    [anon_sym_triangleadj] = ACTIONS(3513),
    [anon_sym_lineadj] = ACTIONS(3513),
    [anon_sym_triangle] = ACTIONS(3513),
    [anon_sym_interface] = ACTIONS(3513),
    [anon_sym_extension] = ACTIONS(3513),
    [anon_sym___init] = ACTIONS(3513),
    [anon_sym___subscript] = ACTIONS(3513),
    [anon_sym_property] = ACTIONS(3513),
    [anon_sym_associatedtype] = ACTIONS(3513),
  },
  [2498] = {
    [sym_identifier] = ACTIONS(3691),
    [aux_sym_preproc_def_token1] = ACTIONS(3691),
    [aux_sym_preproc_if_token1] = ACTIONS(3691),
    [aux_sym_preproc_if_token2] = ACTIONS(3691),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3691),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3691),
    [sym_preproc_directive] = ACTIONS(3691),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3693),
    [anon_sym_STAR] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_AMP] = ACTIONS(3691),
    [anon_sym___extension__] = ACTIONS(3691),
    [anon_sym_typedef] = ACTIONS(3691),
    [anon_sym_in] = ACTIONS(3691),
    [anon_sym_out] = ACTIONS(3691),
    [anon_sym_inout] = ACTIONS(3691),
    [anon_sym_extern] = ACTIONS(3691),
    [anon_sym___attribute__] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3693),
    [anon_sym___declspec] = ACTIONS(3691),
    [anon_sym___based] = ACTIONS(3691),
    [anon_sym_signed] = ACTIONS(3691),
    [anon_sym_unsigned] = ACTIONS(3691),
    [anon_sym_long] = ACTIONS(3691),
    [anon_sym_short] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(3691),
    [anon_sym_static] = ACTIONS(3691),
    [anon_sym_register] = ACTIONS(3691),
    [anon_sym_inline] = ACTIONS(3691),
    [anon_sym___inline] = ACTIONS(3691),
    [anon_sym___inline__] = ACTIONS(3691),
    [anon_sym___forceinline] = ACTIONS(3691),
    [anon_sym_thread_local] = ACTIONS(3691),
    [anon_sym___thread] = ACTIONS(3691),
    [anon_sym_const] = ACTIONS(3691),
    [anon_sym_constexpr] = ACTIONS(3691),
    [anon_sym_volatile] = ACTIONS(3691),
    [anon_sym_restrict] = ACTIONS(3691),
    [anon_sym___restrict__] = ACTIONS(3691),
    [anon_sym__Atomic] = ACTIONS(3691),
    [anon_sym__Noreturn] = ACTIONS(3691),
    [anon_sym_noreturn] = ACTIONS(3691),
    [anon_sym_mutable] = ACTIONS(3691),
    [anon_sym_constinit] = ACTIONS(3691),
    [anon_sym_consteval] = ACTIONS(3691),
    [anon_sym_alignas] = ACTIONS(3691),
    [anon_sym__Alignas] = ACTIONS(3691),
    [sym_primitive_type] = ACTIONS(3691),
    [anon_sym_enum] = ACTIONS(3691),
    [anon_sym_class] = ACTIONS(3691),
    [anon_sym_struct] = ACTIONS(3691),
    [anon_sym_union] = ACTIONS(3691),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3691),
    [anon_sym_let] = ACTIONS(3691),
    [anon_sym_This] = ACTIONS(3691),
    [anon_sym_decltype] = ACTIONS(3691),
    [sym_virtual] = ACTIONS(3691),
    [anon_sym_explicit] = ACTIONS(3691),
    [anon_sym_typename] = ACTIONS(3691),
    [anon_sym_template] = ACTIONS(3691),
    [anon_sym_operator] = ACTIONS(3691),
    [anon_sym_friend] = ACTIONS(3691),
    [anon_sym_public] = ACTIONS(3691),
    [anon_sym_private] = ACTIONS(3691),
    [anon_sym_protected] = ACTIONS(3691),
    [anon_sym_using] = ACTIONS(3691),
    [anon_sym_static_assert] = ACTIONS(3691),
    [anon_sym_precise] = ACTIONS(3691),
    [anon_sym_shared] = ACTIONS(3691),
    [anon_sym_groupshared] = ACTIONS(3691),
    [anon_sym_uniform] = ACTIONS(3691),
    [anon_sym_row_major] = ACTIONS(3691),
    [anon_sym_column_major] = ACTIONS(3691),
    [anon_sym_globallycoherent] = ACTIONS(3691),
    [anon_sym_centroid] = ACTIONS(3691),
    [anon_sym_noperspective] = ACTIONS(3691),
    [anon_sym_nointerpolation] = ACTIONS(3691),
    [anon_sym_sample] = ACTIONS(3691),
    [anon_sym_linear] = ACTIONS(3691),
    [anon_sym_snorm] = ACTIONS(3691),
    [anon_sym_unorm] = ACTIONS(3691),
    [anon_sym_point] = ACTIONS(3691),
    [anon_sym_line] = ACTIONS(3691),
    [anon_sym_triangleadj] = ACTIONS(3691),
    [anon_sym_lineadj] = ACTIONS(3691),
    [anon_sym_triangle] = ACTIONS(3691),
    [anon_sym_interface] = ACTIONS(3691),
    [anon_sym_extension] = ACTIONS(3691),
    [anon_sym___init] = ACTIONS(3691),
    [anon_sym___subscript] = ACTIONS(3691),
    [anon_sym_property] = ACTIONS(3691),
    [anon_sym_associatedtype] = ACTIONS(3691),
  },
  [2499] = {
    [sym_expression] = STATE(5577),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2500] = {
    [sym_expression] = STATE(5309),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2501] = {
    [sym_expression] = STATE(5366),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2502] = {
    [sym_expression] = STATE(5225),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2503] = {
    [sym_expression] = STATE(5598),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2504] = {
    [sym_identifier] = ACTIONS(5572),
    [aux_sym_preproc_def_token1] = ACTIONS(5572),
    [aux_sym_preproc_if_token1] = ACTIONS(5572),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5572),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5572),
    [sym_preproc_directive] = ACTIONS(5572),
    [anon_sym_LPAREN2] = ACTIONS(5574),
    [anon_sym_TILDE] = ACTIONS(5574),
    [anon_sym_STAR] = ACTIONS(5574),
    [anon_sym_AMP_AMP] = ACTIONS(5574),
    [anon_sym_AMP] = ACTIONS(5572),
    [anon_sym___extension__] = ACTIONS(5572),
    [anon_sym_typedef] = ACTIONS(5572),
    [anon_sym_in] = ACTIONS(5572),
    [anon_sym_out] = ACTIONS(5572),
    [anon_sym_inout] = ACTIONS(5572),
    [anon_sym_extern] = ACTIONS(5572),
    [anon_sym___attribute__] = ACTIONS(5572),
    [anon_sym_COLON_COLON] = ACTIONS(5574),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5574),
    [anon_sym___declspec] = ACTIONS(5572),
    [anon_sym___based] = ACTIONS(5572),
    [anon_sym_RBRACE] = ACTIONS(5574),
    [anon_sym_signed] = ACTIONS(5572),
    [anon_sym_unsigned] = ACTIONS(5572),
    [anon_sym_long] = ACTIONS(5572),
    [anon_sym_short] = ACTIONS(5572),
    [anon_sym_LBRACK] = ACTIONS(5572),
    [anon_sym_static] = ACTIONS(5572),
    [anon_sym_register] = ACTIONS(5572),
    [anon_sym_inline] = ACTIONS(5572),
    [anon_sym___inline] = ACTIONS(5572),
    [anon_sym___inline__] = ACTIONS(5572),
    [anon_sym___forceinline] = ACTIONS(5572),
    [anon_sym_thread_local] = ACTIONS(5572),
    [anon_sym___thread] = ACTIONS(5572),
    [anon_sym_const] = ACTIONS(5572),
    [anon_sym_constexpr] = ACTIONS(5572),
    [anon_sym_volatile] = ACTIONS(5572),
    [anon_sym_restrict] = ACTIONS(5572),
    [anon_sym___restrict__] = ACTIONS(5572),
    [anon_sym__Atomic] = ACTIONS(5572),
    [anon_sym__Noreturn] = ACTIONS(5572),
    [anon_sym_noreturn] = ACTIONS(5572),
    [anon_sym_mutable] = ACTIONS(5572),
    [anon_sym_constinit] = ACTIONS(5572),
    [anon_sym_consteval] = ACTIONS(5572),
    [anon_sym_alignas] = ACTIONS(5572),
    [anon_sym__Alignas] = ACTIONS(5572),
    [sym_primitive_type] = ACTIONS(5572),
    [anon_sym_enum] = ACTIONS(5572),
    [anon_sym_class] = ACTIONS(5572),
    [anon_sym_struct] = ACTIONS(5572),
    [anon_sym_union] = ACTIONS(5572),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5572),
    [anon_sym_let] = ACTIONS(5572),
    [anon_sym_This] = ACTIONS(5572),
    [anon_sym_decltype] = ACTIONS(5572),
    [sym_virtual] = ACTIONS(5572),
    [anon_sym_explicit] = ACTIONS(5572),
    [anon_sym_typename] = ACTIONS(5572),
    [anon_sym_template] = ACTIONS(5572),
    [anon_sym_operator] = ACTIONS(5572),
    [anon_sym_friend] = ACTIONS(5572),
    [anon_sym_public] = ACTIONS(5572),
    [anon_sym_private] = ACTIONS(5572),
    [anon_sym_protected] = ACTIONS(5572),
    [anon_sym_using] = ACTIONS(5572),
    [anon_sym_static_assert] = ACTIONS(5572),
    [anon_sym_precise] = ACTIONS(5572),
    [anon_sym_shared] = ACTIONS(5572),
    [anon_sym_groupshared] = ACTIONS(5572),
    [anon_sym_uniform] = ACTIONS(5572),
    [anon_sym_row_major] = ACTIONS(5572),
    [anon_sym_column_major] = ACTIONS(5572),
    [anon_sym_globallycoherent] = ACTIONS(5572),
    [anon_sym_centroid] = ACTIONS(5572),
    [anon_sym_noperspective] = ACTIONS(5572),
    [anon_sym_nointerpolation] = ACTIONS(5572),
    [anon_sym_sample] = ACTIONS(5572),
    [anon_sym_linear] = ACTIONS(5572),
    [anon_sym_snorm] = ACTIONS(5572),
    [anon_sym_unorm] = ACTIONS(5572),
    [anon_sym_point] = ACTIONS(5572),
    [anon_sym_line] = ACTIONS(5572),
    [anon_sym_triangleadj] = ACTIONS(5572),
    [anon_sym_lineadj] = ACTIONS(5572),
    [anon_sym_triangle] = ACTIONS(5572),
    [anon_sym_interface] = ACTIONS(5572),
    [anon_sym_extension] = ACTIONS(5572),
    [anon_sym___init] = ACTIONS(5572),
    [anon_sym___subscript] = ACTIONS(5572),
    [anon_sym_property] = ACTIONS(5572),
    [anon_sym_associatedtype] = ACTIONS(5572),
  },
  [2505] = {
    [sym_expression] = STATE(5364),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2506] = {
    [sym_expression] = STATE(5046),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(6126),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2507] = {
    [sym_expression] = STATE(4185),
    [sym__string] = STATE(4545),
    [sym_conditional_expression] = STATE(4545),
    [sym_assignment_expression] = STATE(4545),
    [sym_pointer_expression] = STATE(4540),
    [sym_unary_expression] = STATE(4545),
    [sym_binary_expression] = STATE(4545),
    [sym_update_expression] = STATE(4545),
    [sym_cast_expression] = STATE(4545),
    [sym_sizeof_expression] = STATE(4545),
    [sym_alignof_expression] = STATE(4545),
    [sym_offsetof_expression] = STATE(4545),
    [sym_generic_expression] = STATE(4545),
    [sym_subscript_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_gnu_asm_expression] = STATE(4545),
    [sym_field_expression] = STATE(4540),
    [sym_compound_literal_expression] = STATE(4545),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_char_literal] = STATE(4286),
    [sym_concatenated_string] = STATE(4290),
    [sym_string_literal] = STATE(3166),
    [sym_null] = STATE(4545),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9673),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4545),
    [sym_raw_string_literal] = STATE(3169),
    [sym_co_await_expression] = STATE(4545),
    [sym_new_expression] = STATE(4545),
    [sym_delete_expression] = STATE(4545),
    [sym_requires_clause] = STATE(4545),
    [sym_requires_expression] = STATE(4545),
    [sym_lambda_expression] = STATE(4545),
    [sym_lambda_capture_specifier] = STATE(7034),
    [sym_fold_expression] = STATE(4545),
    [sym_parameter_pack_expansion] = STATE(4545),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4540),
    [sym_qualified_type_identifier] = STATE(9673),
    [sym_user_defined_literal] = STATE(4540),
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_LPAREN2] = ACTIONS(5828),
    [anon_sym_BANG] = ACTIONS(4733),
    [anon_sym_TILDE] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4731),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4735),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4739),
    [anon_sym_not] = ACTIONS(4731),
    [anon_sym_compl] = ACTIONS(4731),
    [anon_sym_DASH_DASH] = ACTIONS(5711),
    [anon_sym_PLUS_PLUS] = ACTIONS(5711),
    [anon_sym_sizeof] = ACTIONS(4741),
    [anon_sym___alignof__] = ACTIONS(4743),
    [anon_sym___alignof] = ACTIONS(4743),
    [anon_sym__alignof] = ACTIONS(4743),
    [anon_sym_alignof] = ACTIONS(4743),
    [anon_sym__Alignof] = ACTIONS(4743),
    [anon_sym_offsetof] = ACTIONS(4745),
    [anon_sym__Generic] = ACTIONS(4747),
    [anon_sym_asm] = ACTIONS(4749),
    [anon_sym___asm__] = ACTIONS(4749),
    [sym_number_literal] = ACTIONS(4751),
    [anon_sym_L_SQUOTE] = ACTIONS(4753),
    [anon_sym_u_SQUOTE] = ACTIONS(4753),
    [anon_sym_U_SQUOTE] = ACTIONS(4753),
    [anon_sym_u8_SQUOTE] = ACTIONS(4753),
    [anon_sym_SQUOTE] = ACTIONS(4753),
    [anon_sym_L_DQUOTE] = ACTIONS(4755),
    [anon_sym_u_DQUOTE] = ACTIONS(4755),
    [anon_sym_U_DQUOTE] = ACTIONS(4755),
    [anon_sym_u8_DQUOTE] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [anon_sym_NULL] = ACTIONS(4759),
    [anon_sym_nullptr] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4761),
    [anon_sym_R_DQUOTE] = ACTIONS(4763),
    [anon_sym_LR_DQUOTE] = ACTIONS(4763),
    [anon_sym_uR_DQUOTE] = ACTIONS(4763),
    [anon_sym_UR_DQUOTE] = ACTIONS(4763),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4763),
    [anon_sym_co_await] = ACTIONS(4765),
    [anon_sym_new] = ACTIONS(4767),
    [anon_sym_requires] = ACTIONS(4769),
    [sym_this] = ACTIONS(4757),
  },
  [2508] = {
    [sym_expression] = STATE(3694),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(4134),
    [sym_concatenated_string] = STATE(4159),
    [sym_string_literal] = STATE(3152),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(3145),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4587),
    [anon_sym_LPAREN2] = ACTIONS(5819),
    [anon_sym_BANG] = ACTIONS(4591),
    [anon_sym_TILDE] = ACTIONS(4591),
    [anon_sym_DASH] = ACTIONS(4589),
    [anon_sym_PLUS] = ACTIONS(4589),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4593),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4589),
    [anon_sym_compl] = ACTIONS(4589),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_sizeof] = ACTIONS(4595),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4597),
    [anon_sym_L_SQUOTE] = ACTIONS(4599),
    [anon_sym_u_SQUOTE] = ACTIONS(4599),
    [anon_sym_U_SQUOTE] = ACTIONS(4599),
    [anon_sym_u8_SQUOTE] = ACTIONS(4599),
    [anon_sym_SQUOTE] = ACTIONS(4599),
    [anon_sym_L_DQUOTE] = ACTIONS(4601),
    [anon_sym_u_DQUOTE] = ACTIONS(4601),
    [anon_sym_U_DQUOTE] = ACTIONS(4601),
    [anon_sym_u8_DQUOTE] = ACTIONS(4601),
    [anon_sym_DQUOTE] = ACTIONS(4601),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4603),
    [anon_sym_R_DQUOTE] = ACTIONS(4605),
    [anon_sym_LR_DQUOTE] = ACTIONS(4605),
    [anon_sym_uR_DQUOTE] = ACTIONS(4605),
    [anon_sym_UR_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4605),
    [anon_sym_co_await] = ACTIONS(4607),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2509] = {
    [sym_expression] = STATE(5362),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2510] = {
    [sym_identifier] = ACTIONS(3597),
    [aux_sym_preproc_def_token1] = ACTIONS(3597),
    [aux_sym_preproc_if_token1] = ACTIONS(3597),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3597),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3597),
    [sym_preproc_directive] = ACTIONS(3597),
    [anon_sym_LPAREN2] = ACTIONS(3599),
    [anon_sym_TILDE] = ACTIONS(3599),
    [anon_sym_STAR] = ACTIONS(3599),
    [anon_sym_AMP_AMP] = ACTIONS(3599),
    [anon_sym_AMP] = ACTIONS(3597),
    [anon_sym___extension__] = ACTIONS(3597),
    [anon_sym_typedef] = ACTIONS(3597),
    [anon_sym_in] = ACTIONS(3597),
    [anon_sym_out] = ACTIONS(3597),
    [anon_sym_inout] = ACTIONS(3597),
    [anon_sym_extern] = ACTIONS(3597),
    [anon_sym___attribute__] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3599),
    [anon_sym___declspec] = ACTIONS(3597),
    [anon_sym___based] = ACTIONS(3597),
    [anon_sym_RBRACE] = ACTIONS(3599),
    [anon_sym_signed] = ACTIONS(3597),
    [anon_sym_unsigned] = ACTIONS(3597),
    [anon_sym_long] = ACTIONS(3597),
    [anon_sym_short] = ACTIONS(3597),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_static] = ACTIONS(3597),
    [anon_sym_register] = ACTIONS(3597),
    [anon_sym_inline] = ACTIONS(3597),
    [anon_sym___inline] = ACTIONS(3597),
    [anon_sym___inline__] = ACTIONS(3597),
    [anon_sym___forceinline] = ACTIONS(3597),
    [anon_sym_thread_local] = ACTIONS(3597),
    [anon_sym___thread] = ACTIONS(3597),
    [anon_sym_const] = ACTIONS(3597),
    [anon_sym_constexpr] = ACTIONS(3597),
    [anon_sym_volatile] = ACTIONS(3597),
    [anon_sym_restrict] = ACTIONS(3597),
    [anon_sym___restrict__] = ACTIONS(3597),
    [anon_sym__Atomic] = ACTIONS(3597),
    [anon_sym__Noreturn] = ACTIONS(3597),
    [anon_sym_noreturn] = ACTIONS(3597),
    [anon_sym_mutable] = ACTIONS(3597),
    [anon_sym_constinit] = ACTIONS(3597),
    [anon_sym_consteval] = ACTIONS(3597),
    [anon_sym_alignas] = ACTIONS(3597),
    [anon_sym__Alignas] = ACTIONS(3597),
    [sym_primitive_type] = ACTIONS(3597),
    [anon_sym_enum] = ACTIONS(3597),
    [anon_sym_class] = ACTIONS(3597),
    [anon_sym_struct] = ACTIONS(3597),
    [anon_sym_union] = ACTIONS(3597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3597),
    [anon_sym_let] = ACTIONS(3597),
    [anon_sym_This] = ACTIONS(3597),
    [anon_sym_decltype] = ACTIONS(3597),
    [sym_virtual] = ACTIONS(3597),
    [anon_sym_explicit] = ACTIONS(3597),
    [anon_sym_typename] = ACTIONS(3597),
    [anon_sym_template] = ACTIONS(3597),
    [anon_sym_operator] = ACTIONS(3597),
    [anon_sym_friend] = ACTIONS(3597),
    [anon_sym_public] = ACTIONS(3597),
    [anon_sym_private] = ACTIONS(3597),
    [anon_sym_protected] = ACTIONS(3597),
    [anon_sym_using] = ACTIONS(3597),
    [anon_sym_static_assert] = ACTIONS(3597),
    [anon_sym_precise] = ACTIONS(3597),
    [anon_sym_shared] = ACTIONS(3597),
    [anon_sym_groupshared] = ACTIONS(3597),
    [anon_sym_uniform] = ACTIONS(3597),
    [anon_sym_row_major] = ACTIONS(3597),
    [anon_sym_column_major] = ACTIONS(3597),
    [anon_sym_globallycoherent] = ACTIONS(3597),
    [anon_sym_centroid] = ACTIONS(3597),
    [anon_sym_noperspective] = ACTIONS(3597),
    [anon_sym_nointerpolation] = ACTIONS(3597),
    [anon_sym_sample] = ACTIONS(3597),
    [anon_sym_linear] = ACTIONS(3597),
    [anon_sym_snorm] = ACTIONS(3597),
    [anon_sym_unorm] = ACTIONS(3597),
    [anon_sym_point] = ACTIONS(3597),
    [anon_sym_line] = ACTIONS(3597),
    [anon_sym_triangleadj] = ACTIONS(3597),
    [anon_sym_lineadj] = ACTIONS(3597),
    [anon_sym_triangle] = ACTIONS(3597),
    [anon_sym_interface] = ACTIONS(3597),
    [anon_sym_extension] = ACTIONS(3597),
    [anon_sym___init] = ACTIONS(3597),
    [anon_sym___subscript] = ACTIONS(3597),
    [anon_sym_property] = ACTIONS(3597),
    [anon_sym_associatedtype] = ACTIONS(3597),
  },
  [2511] = {
    [sym_identifier] = ACTIONS(5526),
    [aux_sym_preproc_def_token1] = ACTIONS(5526),
    [aux_sym_preproc_if_token1] = ACTIONS(5526),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5526),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5526),
    [sym_preproc_directive] = ACTIONS(5526),
    [anon_sym_LPAREN2] = ACTIONS(5528),
    [anon_sym_TILDE] = ACTIONS(5528),
    [anon_sym_STAR] = ACTIONS(5528),
    [anon_sym_AMP_AMP] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5526),
    [anon_sym___extension__] = ACTIONS(5526),
    [anon_sym_typedef] = ACTIONS(5526),
    [anon_sym_in] = ACTIONS(5526),
    [anon_sym_out] = ACTIONS(5526),
    [anon_sym_inout] = ACTIONS(5526),
    [anon_sym_extern] = ACTIONS(5526),
    [anon_sym___attribute__] = ACTIONS(5526),
    [anon_sym_COLON_COLON] = ACTIONS(5528),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5528),
    [anon_sym___declspec] = ACTIONS(5526),
    [anon_sym___based] = ACTIONS(5526),
    [anon_sym_RBRACE] = ACTIONS(5528),
    [anon_sym_signed] = ACTIONS(5526),
    [anon_sym_unsigned] = ACTIONS(5526),
    [anon_sym_long] = ACTIONS(5526),
    [anon_sym_short] = ACTIONS(5526),
    [anon_sym_LBRACK] = ACTIONS(5526),
    [anon_sym_static] = ACTIONS(5526),
    [anon_sym_register] = ACTIONS(5526),
    [anon_sym_inline] = ACTIONS(5526),
    [anon_sym___inline] = ACTIONS(5526),
    [anon_sym___inline__] = ACTIONS(5526),
    [anon_sym___forceinline] = ACTIONS(5526),
    [anon_sym_thread_local] = ACTIONS(5526),
    [anon_sym___thread] = ACTIONS(5526),
    [anon_sym_const] = ACTIONS(5526),
    [anon_sym_constexpr] = ACTIONS(5526),
    [anon_sym_volatile] = ACTIONS(5526),
    [anon_sym_restrict] = ACTIONS(5526),
    [anon_sym___restrict__] = ACTIONS(5526),
    [anon_sym__Atomic] = ACTIONS(5526),
    [anon_sym__Noreturn] = ACTIONS(5526),
    [anon_sym_noreturn] = ACTIONS(5526),
    [anon_sym_mutable] = ACTIONS(5526),
    [anon_sym_constinit] = ACTIONS(5526),
    [anon_sym_consteval] = ACTIONS(5526),
    [anon_sym_alignas] = ACTIONS(5526),
    [anon_sym__Alignas] = ACTIONS(5526),
    [sym_primitive_type] = ACTIONS(5526),
    [anon_sym_enum] = ACTIONS(5526),
    [anon_sym_class] = ACTIONS(5526),
    [anon_sym_struct] = ACTIONS(5526),
    [anon_sym_union] = ACTIONS(5526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5526),
    [anon_sym_let] = ACTIONS(5526),
    [anon_sym_This] = ACTIONS(5526),
    [anon_sym_decltype] = ACTIONS(5526),
    [sym_virtual] = ACTIONS(5526),
    [anon_sym_explicit] = ACTIONS(5526),
    [anon_sym_typename] = ACTIONS(5526),
    [anon_sym_template] = ACTIONS(5526),
    [anon_sym_operator] = ACTIONS(5526),
    [anon_sym_friend] = ACTIONS(5526),
    [anon_sym_public] = ACTIONS(5526),
    [anon_sym_private] = ACTIONS(5526),
    [anon_sym_protected] = ACTIONS(5526),
    [anon_sym_using] = ACTIONS(5526),
    [anon_sym_static_assert] = ACTIONS(5526),
    [anon_sym_precise] = ACTIONS(5526),
    [anon_sym_shared] = ACTIONS(5526),
    [anon_sym_groupshared] = ACTIONS(5526),
    [anon_sym_uniform] = ACTIONS(5526),
    [anon_sym_row_major] = ACTIONS(5526),
    [anon_sym_column_major] = ACTIONS(5526),
    [anon_sym_globallycoherent] = ACTIONS(5526),
    [anon_sym_centroid] = ACTIONS(5526),
    [anon_sym_noperspective] = ACTIONS(5526),
    [anon_sym_nointerpolation] = ACTIONS(5526),
    [anon_sym_sample] = ACTIONS(5526),
    [anon_sym_linear] = ACTIONS(5526),
    [anon_sym_snorm] = ACTIONS(5526),
    [anon_sym_unorm] = ACTIONS(5526),
    [anon_sym_point] = ACTIONS(5526),
    [anon_sym_line] = ACTIONS(5526),
    [anon_sym_triangleadj] = ACTIONS(5526),
    [anon_sym_lineadj] = ACTIONS(5526),
    [anon_sym_triangle] = ACTIONS(5526),
    [anon_sym_interface] = ACTIONS(5526),
    [anon_sym_extension] = ACTIONS(5526),
    [anon_sym___init] = ACTIONS(5526),
    [anon_sym___subscript] = ACTIONS(5526),
    [anon_sym_property] = ACTIONS(5526),
    [anon_sym_associatedtype] = ACTIONS(5526),
  },
  [2512] = {
    [sym_expression] = STATE(4854),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4905),
    [sym_concatenated_string] = STATE(4902),
    [sym_string_literal] = STATE(3611),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3610),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(5705),
    [anon_sym_LPAREN2] = ACTIONS(5834),
    [anon_sym_BANG] = ACTIONS(4926),
    [anon_sym_TILDE] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4928),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4924),
    [anon_sym_compl] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(5707),
    [anon_sym_PLUS_PLUS] = ACTIONS(5707),
    [anon_sym_sizeof] = ACTIONS(4932),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4934),
    [anon_sym_L_SQUOTE] = ACTIONS(4936),
    [anon_sym_u_SQUOTE] = ACTIONS(4936),
    [anon_sym_U_SQUOTE] = ACTIONS(4936),
    [anon_sym_u8_SQUOTE] = ACTIONS(4936),
    [anon_sym_SQUOTE] = ACTIONS(4936),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4938),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
    [anon_sym_co_await] = ACTIONS(4940),
    [anon_sym_new] = ACTIONS(4942),
    [anon_sym_requires] = ACTIONS(4944),
    [sym_this] = ACTIONS(241),
  },
  [2513] = {
    [sym_expression] = STATE(5357),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2514] = {
    [sym_identifier] = ACTIONS(3649),
    [aux_sym_preproc_def_token1] = ACTIONS(3649),
    [aux_sym_preproc_if_token1] = ACTIONS(3649),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3649),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3649),
    [sym_preproc_directive] = ACTIONS(3649),
    [anon_sym_LPAREN2] = ACTIONS(3651),
    [anon_sym_TILDE] = ACTIONS(3651),
    [anon_sym_STAR] = ACTIONS(3651),
    [anon_sym_AMP_AMP] = ACTIONS(3651),
    [anon_sym_AMP] = ACTIONS(3649),
    [anon_sym___extension__] = ACTIONS(3649),
    [anon_sym_typedef] = ACTIONS(3649),
    [anon_sym_in] = ACTIONS(3649),
    [anon_sym_out] = ACTIONS(3649),
    [anon_sym_inout] = ACTIONS(3649),
    [anon_sym_extern] = ACTIONS(3649),
    [anon_sym___attribute__] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(3651),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3651),
    [anon_sym___declspec] = ACTIONS(3649),
    [anon_sym___based] = ACTIONS(3649),
    [anon_sym_RBRACE] = ACTIONS(3651),
    [anon_sym_signed] = ACTIONS(3649),
    [anon_sym_unsigned] = ACTIONS(3649),
    [anon_sym_long] = ACTIONS(3649),
    [anon_sym_short] = ACTIONS(3649),
    [anon_sym_LBRACK] = ACTIONS(3649),
    [anon_sym_static] = ACTIONS(3649),
    [anon_sym_register] = ACTIONS(3649),
    [anon_sym_inline] = ACTIONS(3649),
    [anon_sym___inline] = ACTIONS(3649),
    [anon_sym___inline__] = ACTIONS(3649),
    [anon_sym___forceinline] = ACTIONS(3649),
    [anon_sym_thread_local] = ACTIONS(3649),
    [anon_sym___thread] = ACTIONS(3649),
    [anon_sym_const] = ACTIONS(3649),
    [anon_sym_constexpr] = ACTIONS(3649),
    [anon_sym_volatile] = ACTIONS(3649),
    [anon_sym_restrict] = ACTIONS(3649),
    [anon_sym___restrict__] = ACTIONS(3649),
    [anon_sym__Atomic] = ACTIONS(3649),
    [anon_sym__Noreturn] = ACTIONS(3649),
    [anon_sym_noreturn] = ACTIONS(3649),
    [anon_sym_mutable] = ACTIONS(3649),
    [anon_sym_constinit] = ACTIONS(3649),
    [anon_sym_consteval] = ACTIONS(3649),
    [anon_sym_alignas] = ACTIONS(3649),
    [anon_sym__Alignas] = ACTIONS(3649),
    [sym_primitive_type] = ACTIONS(3649),
    [anon_sym_enum] = ACTIONS(3649),
    [anon_sym_class] = ACTIONS(3649),
    [anon_sym_struct] = ACTIONS(3649),
    [anon_sym_union] = ACTIONS(3649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3649),
    [anon_sym_let] = ACTIONS(3649),
    [anon_sym_This] = ACTIONS(3649),
    [anon_sym_decltype] = ACTIONS(3649),
    [sym_virtual] = ACTIONS(3649),
    [anon_sym_explicit] = ACTIONS(3649),
    [anon_sym_typename] = ACTIONS(3649),
    [anon_sym_template] = ACTIONS(3649),
    [anon_sym_operator] = ACTIONS(3649),
    [anon_sym_friend] = ACTIONS(3649),
    [anon_sym_public] = ACTIONS(3649),
    [anon_sym_private] = ACTIONS(3649),
    [anon_sym_protected] = ACTIONS(3649),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_static_assert] = ACTIONS(3649),
    [anon_sym_precise] = ACTIONS(3649),
    [anon_sym_shared] = ACTIONS(3649),
    [anon_sym_groupshared] = ACTIONS(3649),
    [anon_sym_uniform] = ACTIONS(3649),
    [anon_sym_row_major] = ACTIONS(3649),
    [anon_sym_column_major] = ACTIONS(3649),
    [anon_sym_globallycoherent] = ACTIONS(3649),
    [anon_sym_centroid] = ACTIONS(3649),
    [anon_sym_noperspective] = ACTIONS(3649),
    [anon_sym_nointerpolation] = ACTIONS(3649),
    [anon_sym_sample] = ACTIONS(3649),
    [anon_sym_linear] = ACTIONS(3649),
    [anon_sym_snorm] = ACTIONS(3649),
    [anon_sym_unorm] = ACTIONS(3649),
    [anon_sym_point] = ACTIONS(3649),
    [anon_sym_line] = ACTIONS(3649),
    [anon_sym_triangleadj] = ACTIONS(3649),
    [anon_sym_lineadj] = ACTIONS(3649),
    [anon_sym_triangle] = ACTIONS(3649),
    [anon_sym_interface] = ACTIONS(3649),
    [anon_sym_extension] = ACTIONS(3649),
    [anon_sym___init] = ACTIONS(3649),
    [anon_sym___subscript] = ACTIONS(3649),
    [anon_sym_property] = ACTIONS(3649),
    [anon_sym_associatedtype] = ACTIONS(3649),
  },
  [2515] = {
    [sym_expression] = STATE(5356),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2516] = {
    [sym_identifier] = ACTIONS(3531),
    [aux_sym_preproc_def_token1] = ACTIONS(3531),
    [aux_sym_preproc_if_token1] = ACTIONS(3531),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3531),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3531),
    [sym_preproc_directive] = ACTIONS(3531),
    [anon_sym_LPAREN2] = ACTIONS(3533),
    [anon_sym_TILDE] = ACTIONS(3533),
    [anon_sym_STAR] = ACTIONS(3533),
    [anon_sym_AMP_AMP] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym___extension__] = ACTIONS(3531),
    [anon_sym_typedef] = ACTIONS(3531),
    [anon_sym_in] = ACTIONS(3531),
    [anon_sym_out] = ACTIONS(3531),
    [anon_sym_inout] = ACTIONS(3531),
    [anon_sym_extern] = ACTIONS(3531),
    [anon_sym___attribute__] = ACTIONS(3531),
    [anon_sym_COLON_COLON] = ACTIONS(3533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3533),
    [anon_sym___declspec] = ACTIONS(3531),
    [anon_sym___based] = ACTIONS(3531),
    [anon_sym_RBRACE] = ACTIONS(3533),
    [anon_sym_signed] = ACTIONS(3531),
    [anon_sym_unsigned] = ACTIONS(3531),
    [anon_sym_long] = ACTIONS(3531),
    [anon_sym_short] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_static] = ACTIONS(3531),
    [anon_sym_register] = ACTIONS(3531),
    [anon_sym_inline] = ACTIONS(3531),
    [anon_sym___inline] = ACTIONS(3531),
    [anon_sym___inline__] = ACTIONS(3531),
    [anon_sym___forceinline] = ACTIONS(3531),
    [anon_sym_thread_local] = ACTIONS(3531),
    [anon_sym___thread] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3531),
    [anon_sym_constexpr] = ACTIONS(3531),
    [anon_sym_volatile] = ACTIONS(3531),
    [anon_sym_restrict] = ACTIONS(3531),
    [anon_sym___restrict__] = ACTIONS(3531),
    [anon_sym__Atomic] = ACTIONS(3531),
    [anon_sym__Noreturn] = ACTIONS(3531),
    [anon_sym_noreturn] = ACTIONS(3531),
    [anon_sym_mutable] = ACTIONS(3531),
    [anon_sym_constinit] = ACTIONS(3531),
    [anon_sym_consteval] = ACTIONS(3531),
    [anon_sym_alignas] = ACTIONS(3531),
    [anon_sym__Alignas] = ACTIONS(3531),
    [sym_primitive_type] = ACTIONS(3531),
    [anon_sym_enum] = ACTIONS(3531),
    [anon_sym_class] = ACTIONS(3531),
    [anon_sym_struct] = ACTIONS(3531),
    [anon_sym_union] = ACTIONS(3531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_This] = ACTIONS(3531),
    [anon_sym_decltype] = ACTIONS(3531),
    [sym_virtual] = ACTIONS(3531),
    [anon_sym_explicit] = ACTIONS(3531),
    [anon_sym_typename] = ACTIONS(3531),
    [anon_sym_template] = ACTIONS(3531),
    [anon_sym_operator] = ACTIONS(3531),
    [anon_sym_friend] = ACTIONS(3531),
    [anon_sym_public] = ACTIONS(3531),
    [anon_sym_private] = ACTIONS(3531),
    [anon_sym_protected] = ACTIONS(3531),
    [anon_sym_using] = ACTIONS(3531),
    [anon_sym_static_assert] = ACTIONS(3531),
    [anon_sym_precise] = ACTIONS(3531),
    [anon_sym_shared] = ACTIONS(3531),
    [anon_sym_groupshared] = ACTIONS(3531),
    [anon_sym_uniform] = ACTIONS(3531),
    [anon_sym_row_major] = ACTIONS(3531),
    [anon_sym_column_major] = ACTIONS(3531),
    [anon_sym_globallycoherent] = ACTIONS(3531),
    [anon_sym_centroid] = ACTIONS(3531),
    [anon_sym_noperspective] = ACTIONS(3531),
    [anon_sym_nointerpolation] = ACTIONS(3531),
    [anon_sym_sample] = ACTIONS(3531),
    [anon_sym_linear] = ACTIONS(3531),
    [anon_sym_snorm] = ACTIONS(3531),
    [anon_sym_unorm] = ACTIONS(3531),
    [anon_sym_point] = ACTIONS(3531),
    [anon_sym_line] = ACTIONS(3531),
    [anon_sym_triangleadj] = ACTIONS(3531),
    [anon_sym_lineadj] = ACTIONS(3531),
    [anon_sym_triangle] = ACTIONS(3531),
    [anon_sym_interface] = ACTIONS(3531),
    [anon_sym_extension] = ACTIONS(3531),
    [anon_sym___init] = ACTIONS(3531),
    [anon_sym___subscript] = ACTIONS(3531),
    [anon_sym_property] = ACTIONS(3531),
    [anon_sym_associatedtype] = ACTIONS(3531),
  },
  [2517] = {
    [sym_identifier] = ACTIONS(5536),
    [aux_sym_preproc_def_token1] = ACTIONS(5536),
    [aux_sym_preproc_if_token1] = ACTIONS(5536),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5536),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5536),
    [sym_preproc_directive] = ACTIONS(5536),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_TILDE] = ACTIONS(5538),
    [anon_sym_STAR] = ACTIONS(5538),
    [anon_sym_AMP_AMP] = ACTIONS(5538),
    [anon_sym_AMP] = ACTIONS(5536),
    [anon_sym___extension__] = ACTIONS(5536),
    [anon_sym_typedef] = ACTIONS(5536),
    [anon_sym_in] = ACTIONS(5536),
    [anon_sym_out] = ACTIONS(5536),
    [anon_sym_inout] = ACTIONS(5536),
    [anon_sym_extern] = ACTIONS(5536),
    [anon_sym___attribute__] = ACTIONS(5536),
    [anon_sym_COLON_COLON] = ACTIONS(5538),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5538),
    [anon_sym___declspec] = ACTIONS(5536),
    [anon_sym___based] = ACTIONS(5536),
    [anon_sym_RBRACE] = ACTIONS(5538),
    [anon_sym_signed] = ACTIONS(5536),
    [anon_sym_unsigned] = ACTIONS(5536),
    [anon_sym_long] = ACTIONS(5536),
    [anon_sym_short] = ACTIONS(5536),
    [anon_sym_LBRACK] = ACTIONS(5536),
    [anon_sym_static] = ACTIONS(5536),
    [anon_sym_register] = ACTIONS(5536),
    [anon_sym_inline] = ACTIONS(5536),
    [anon_sym___inline] = ACTIONS(5536),
    [anon_sym___inline__] = ACTIONS(5536),
    [anon_sym___forceinline] = ACTIONS(5536),
    [anon_sym_thread_local] = ACTIONS(5536),
    [anon_sym___thread] = ACTIONS(5536),
    [anon_sym_const] = ACTIONS(5536),
    [anon_sym_constexpr] = ACTIONS(5536),
    [anon_sym_volatile] = ACTIONS(5536),
    [anon_sym_restrict] = ACTIONS(5536),
    [anon_sym___restrict__] = ACTIONS(5536),
    [anon_sym__Atomic] = ACTIONS(5536),
    [anon_sym__Noreturn] = ACTIONS(5536),
    [anon_sym_noreturn] = ACTIONS(5536),
    [anon_sym_mutable] = ACTIONS(5536),
    [anon_sym_constinit] = ACTIONS(5536),
    [anon_sym_consteval] = ACTIONS(5536),
    [anon_sym_alignas] = ACTIONS(5536),
    [anon_sym__Alignas] = ACTIONS(5536),
    [sym_primitive_type] = ACTIONS(5536),
    [anon_sym_enum] = ACTIONS(5536),
    [anon_sym_class] = ACTIONS(5536),
    [anon_sym_struct] = ACTIONS(5536),
    [anon_sym_union] = ACTIONS(5536),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5536),
    [anon_sym_let] = ACTIONS(5536),
    [anon_sym_This] = ACTIONS(5536),
    [anon_sym_decltype] = ACTIONS(5536),
    [sym_virtual] = ACTIONS(5536),
    [anon_sym_explicit] = ACTIONS(5536),
    [anon_sym_typename] = ACTIONS(5536),
    [anon_sym_template] = ACTIONS(5536),
    [anon_sym_operator] = ACTIONS(5536),
    [anon_sym_friend] = ACTIONS(5536),
    [anon_sym_public] = ACTIONS(5536),
    [anon_sym_private] = ACTIONS(5536),
    [anon_sym_protected] = ACTIONS(5536),
    [anon_sym_using] = ACTIONS(5536),
    [anon_sym_static_assert] = ACTIONS(5536),
    [anon_sym_precise] = ACTIONS(5536),
    [anon_sym_shared] = ACTIONS(5536),
    [anon_sym_groupshared] = ACTIONS(5536),
    [anon_sym_uniform] = ACTIONS(5536),
    [anon_sym_row_major] = ACTIONS(5536),
    [anon_sym_column_major] = ACTIONS(5536),
    [anon_sym_globallycoherent] = ACTIONS(5536),
    [anon_sym_centroid] = ACTIONS(5536),
    [anon_sym_noperspective] = ACTIONS(5536),
    [anon_sym_nointerpolation] = ACTIONS(5536),
    [anon_sym_sample] = ACTIONS(5536),
    [anon_sym_linear] = ACTIONS(5536),
    [anon_sym_snorm] = ACTIONS(5536),
    [anon_sym_unorm] = ACTIONS(5536),
    [anon_sym_point] = ACTIONS(5536),
    [anon_sym_line] = ACTIONS(5536),
    [anon_sym_triangleadj] = ACTIONS(5536),
    [anon_sym_lineadj] = ACTIONS(5536),
    [anon_sym_triangle] = ACTIONS(5536),
    [anon_sym_interface] = ACTIONS(5536),
    [anon_sym_extension] = ACTIONS(5536),
    [anon_sym___init] = ACTIONS(5536),
    [anon_sym___subscript] = ACTIONS(5536),
    [anon_sym_property] = ACTIONS(5536),
    [anon_sym_associatedtype] = ACTIONS(5536),
  },
  [2518] = {
    [sym_expression] = STATE(5348),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2519] = {
    [sym_identifier] = ACTIONS(3344),
    [aux_sym_preproc_def_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3344),
    [sym_preproc_directive] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym___extension__] = ACTIONS(3344),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_in] = ACTIONS(3344),
    [anon_sym_out] = ACTIONS(3344),
    [anon_sym_inout] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym___attribute__] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3346),
    [anon_sym___declspec] = ACTIONS(3344),
    [anon_sym___based] = ACTIONS(3344),
    [anon_sym_RBRACE] = ACTIONS(3346),
    [anon_sym_signed] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym___inline] = ACTIONS(3344),
    [anon_sym___inline__] = ACTIONS(3344),
    [anon_sym___forceinline] = ACTIONS(3344),
    [anon_sym_thread_local] = ACTIONS(3344),
    [anon_sym___thread] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym___restrict__] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym__Noreturn] = ACTIONS(3344),
    [anon_sym_noreturn] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_constinit] = ACTIONS(3344),
    [anon_sym_consteval] = ACTIONS(3344),
    [anon_sym_alignas] = ACTIONS(3344),
    [anon_sym__Alignas] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_class] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_This] = ACTIONS(3344),
    [anon_sym_decltype] = ACTIONS(3344),
    [sym_virtual] = ACTIONS(3344),
    [anon_sym_explicit] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_template] = ACTIONS(3344),
    [anon_sym_operator] = ACTIONS(3344),
    [anon_sym_friend] = ACTIONS(3344),
    [anon_sym_public] = ACTIONS(3344),
    [anon_sym_private] = ACTIONS(3344),
    [anon_sym_protected] = ACTIONS(3344),
    [anon_sym_using] = ACTIONS(3344),
    [anon_sym_static_assert] = ACTIONS(3344),
    [anon_sym_precise] = ACTIONS(3344),
    [anon_sym_shared] = ACTIONS(3344),
    [anon_sym_groupshared] = ACTIONS(3344),
    [anon_sym_uniform] = ACTIONS(3344),
    [anon_sym_row_major] = ACTIONS(3344),
    [anon_sym_column_major] = ACTIONS(3344),
    [anon_sym_globallycoherent] = ACTIONS(3344),
    [anon_sym_centroid] = ACTIONS(3344),
    [anon_sym_noperspective] = ACTIONS(3344),
    [anon_sym_nointerpolation] = ACTIONS(3344),
    [anon_sym_sample] = ACTIONS(3344),
    [anon_sym_linear] = ACTIONS(3344),
    [anon_sym_snorm] = ACTIONS(3344),
    [anon_sym_unorm] = ACTIONS(3344),
    [anon_sym_point] = ACTIONS(3344),
    [anon_sym_line] = ACTIONS(3344),
    [anon_sym_triangleadj] = ACTIONS(3344),
    [anon_sym_lineadj] = ACTIONS(3344),
    [anon_sym_triangle] = ACTIONS(3344),
    [anon_sym_interface] = ACTIONS(3344),
    [anon_sym_extension] = ACTIONS(3344),
    [anon_sym___init] = ACTIONS(3344),
    [anon_sym___subscript] = ACTIONS(3344),
    [anon_sym_property] = ACTIONS(3344),
    [anon_sym_associatedtype] = ACTIONS(3344),
  },
  [2520] = {
    [sym_identifier] = ACTIONS(3344),
    [aux_sym_preproc_def_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3344),
    [sym_preproc_directive] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym___extension__] = ACTIONS(3344),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_in] = ACTIONS(3344),
    [anon_sym_out] = ACTIONS(3344),
    [anon_sym_inout] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym___attribute__] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3346),
    [anon_sym___declspec] = ACTIONS(3344),
    [anon_sym___based] = ACTIONS(3344),
    [anon_sym_RBRACE] = ACTIONS(3346),
    [anon_sym_signed] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym___inline] = ACTIONS(3344),
    [anon_sym___inline__] = ACTIONS(3344),
    [anon_sym___forceinline] = ACTIONS(3344),
    [anon_sym_thread_local] = ACTIONS(3344),
    [anon_sym___thread] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym___restrict__] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym__Noreturn] = ACTIONS(3344),
    [anon_sym_noreturn] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_constinit] = ACTIONS(3344),
    [anon_sym_consteval] = ACTIONS(3344),
    [anon_sym_alignas] = ACTIONS(3344),
    [anon_sym__Alignas] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_class] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_This] = ACTIONS(3344),
    [anon_sym_decltype] = ACTIONS(3344),
    [sym_virtual] = ACTIONS(3344),
    [anon_sym_explicit] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_template] = ACTIONS(3344),
    [anon_sym_operator] = ACTIONS(3344),
    [anon_sym_friend] = ACTIONS(3344),
    [anon_sym_public] = ACTIONS(3344),
    [anon_sym_private] = ACTIONS(3344),
    [anon_sym_protected] = ACTIONS(3344),
    [anon_sym_using] = ACTIONS(3344),
    [anon_sym_static_assert] = ACTIONS(3344),
    [anon_sym_precise] = ACTIONS(3344),
    [anon_sym_shared] = ACTIONS(3344),
    [anon_sym_groupshared] = ACTIONS(3344),
    [anon_sym_uniform] = ACTIONS(3344),
    [anon_sym_row_major] = ACTIONS(3344),
    [anon_sym_column_major] = ACTIONS(3344),
    [anon_sym_globallycoherent] = ACTIONS(3344),
    [anon_sym_centroid] = ACTIONS(3344),
    [anon_sym_noperspective] = ACTIONS(3344),
    [anon_sym_nointerpolation] = ACTIONS(3344),
    [anon_sym_sample] = ACTIONS(3344),
    [anon_sym_linear] = ACTIONS(3344),
    [anon_sym_snorm] = ACTIONS(3344),
    [anon_sym_unorm] = ACTIONS(3344),
    [anon_sym_point] = ACTIONS(3344),
    [anon_sym_line] = ACTIONS(3344),
    [anon_sym_triangleadj] = ACTIONS(3344),
    [anon_sym_lineadj] = ACTIONS(3344),
    [anon_sym_triangle] = ACTIONS(3344),
    [anon_sym_interface] = ACTIONS(3344),
    [anon_sym_extension] = ACTIONS(3344),
    [anon_sym___init] = ACTIONS(3344),
    [anon_sym___subscript] = ACTIONS(3344),
    [anon_sym_property] = ACTIONS(3344),
    [anon_sym_associatedtype] = ACTIONS(3344),
  },
  [2521] = {
    [sym_identifier] = ACTIONS(3344),
    [aux_sym_preproc_def_token1] = ACTIONS(3344),
    [aux_sym_preproc_if_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3344),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3344),
    [sym_preproc_directive] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym___extension__] = ACTIONS(3344),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_in] = ACTIONS(3344),
    [anon_sym_out] = ACTIONS(3344),
    [anon_sym_inout] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym___attribute__] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3346),
    [anon_sym___declspec] = ACTIONS(3344),
    [anon_sym___based] = ACTIONS(3344),
    [anon_sym_RBRACE] = ACTIONS(3346),
    [anon_sym_signed] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym___inline] = ACTIONS(3344),
    [anon_sym___inline__] = ACTIONS(3344),
    [anon_sym___forceinline] = ACTIONS(3344),
    [anon_sym_thread_local] = ACTIONS(3344),
    [anon_sym___thread] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym___restrict__] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym__Noreturn] = ACTIONS(3344),
    [anon_sym_noreturn] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_constinit] = ACTIONS(3344),
    [anon_sym_consteval] = ACTIONS(3344),
    [anon_sym_alignas] = ACTIONS(3344),
    [anon_sym__Alignas] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_class] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_This] = ACTIONS(3344),
    [anon_sym_decltype] = ACTIONS(3344),
    [sym_virtual] = ACTIONS(3344),
    [anon_sym_explicit] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_template] = ACTIONS(3344),
    [anon_sym_operator] = ACTIONS(3344),
    [anon_sym_friend] = ACTIONS(3344),
    [anon_sym_public] = ACTIONS(3344),
    [anon_sym_private] = ACTIONS(3344),
    [anon_sym_protected] = ACTIONS(3344),
    [anon_sym_using] = ACTIONS(3344),
    [anon_sym_static_assert] = ACTIONS(3344),
    [anon_sym_precise] = ACTIONS(3344),
    [anon_sym_shared] = ACTIONS(3344),
    [anon_sym_groupshared] = ACTIONS(3344),
    [anon_sym_uniform] = ACTIONS(3344),
    [anon_sym_row_major] = ACTIONS(3344),
    [anon_sym_column_major] = ACTIONS(3344),
    [anon_sym_globallycoherent] = ACTIONS(3344),
    [anon_sym_centroid] = ACTIONS(3344),
    [anon_sym_noperspective] = ACTIONS(3344),
    [anon_sym_nointerpolation] = ACTIONS(3344),
    [anon_sym_sample] = ACTIONS(3344),
    [anon_sym_linear] = ACTIONS(3344),
    [anon_sym_snorm] = ACTIONS(3344),
    [anon_sym_unorm] = ACTIONS(3344),
    [anon_sym_point] = ACTIONS(3344),
    [anon_sym_line] = ACTIONS(3344),
    [anon_sym_triangleadj] = ACTIONS(3344),
    [anon_sym_lineadj] = ACTIONS(3344),
    [anon_sym_triangle] = ACTIONS(3344),
    [anon_sym_interface] = ACTIONS(3344),
    [anon_sym_extension] = ACTIONS(3344),
    [anon_sym___init] = ACTIONS(3344),
    [anon_sym___subscript] = ACTIONS(3344),
    [anon_sym_property] = ACTIONS(3344),
    [anon_sym_associatedtype] = ACTIONS(3344),
  },
  [2522] = {
    [sym_expression] = STATE(5333),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2523] = {
    [sym_identifier] = ACTIONS(5544),
    [aux_sym_preproc_def_token1] = ACTIONS(5544),
    [aux_sym_preproc_if_token1] = ACTIONS(5544),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5544),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5544),
    [sym_preproc_directive] = ACTIONS(5544),
    [anon_sym_LPAREN2] = ACTIONS(5546),
    [anon_sym_TILDE] = ACTIONS(5546),
    [anon_sym_STAR] = ACTIONS(5546),
    [anon_sym_AMP_AMP] = ACTIONS(5546),
    [anon_sym_AMP] = ACTIONS(5544),
    [anon_sym___extension__] = ACTIONS(5544),
    [anon_sym_typedef] = ACTIONS(5544),
    [anon_sym_in] = ACTIONS(5544),
    [anon_sym_out] = ACTIONS(5544),
    [anon_sym_inout] = ACTIONS(5544),
    [anon_sym_extern] = ACTIONS(5544),
    [anon_sym___attribute__] = ACTIONS(5544),
    [anon_sym_COLON_COLON] = ACTIONS(5546),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5546),
    [anon_sym___declspec] = ACTIONS(5544),
    [anon_sym___based] = ACTIONS(5544),
    [anon_sym_RBRACE] = ACTIONS(5546),
    [anon_sym_signed] = ACTIONS(5544),
    [anon_sym_unsigned] = ACTIONS(5544),
    [anon_sym_long] = ACTIONS(5544),
    [anon_sym_short] = ACTIONS(5544),
    [anon_sym_LBRACK] = ACTIONS(5544),
    [anon_sym_static] = ACTIONS(5544),
    [anon_sym_register] = ACTIONS(5544),
    [anon_sym_inline] = ACTIONS(5544),
    [anon_sym___inline] = ACTIONS(5544),
    [anon_sym___inline__] = ACTIONS(5544),
    [anon_sym___forceinline] = ACTIONS(5544),
    [anon_sym_thread_local] = ACTIONS(5544),
    [anon_sym___thread] = ACTIONS(5544),
    [anon_sym_const] = ACTIONS(5544),
    [anon_sym_constexpr] = ACTIONS(5544),
    [anon_sym_volatile] = ACTIONS(5544),
    [anon_sym_restrict] = ACTIONS(5544),
    [anon_sym___restrict__] = ACTIONS(5544),
    [anon_sym__Atomic] = ACTIONS(5544),
    [anon_sym__Noreturn] = ACTIONS(5544),
    [anon_sym_noreturn] = ACTIONS(5544),
    [anon_sym_mutable] = ACTIONS(5544),
    [anon_sym_constinit] = ACTIONS(5544),
    [anon_sym_consteval] = ACTIONS(5544),
    [anon_sym_alignas] = ACTIONS(5544),
    [anon_sym__Alignas] = ACTIONS(5544),
    [sym_primitive_type] = ACTIONS(5544),
    [anon_sym_enum] = ACTIONS(5544),
    [anon_sym_class] = ACTIONS(5544),
    [anon_sym_struct] = ACTIONS(5544),
    [anon_sym_union] = ACTIONS(5544),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5544),
    [anon_sym_let] = ACTIONS(5544),
    [anon_sym_This] = ACTIONS(5544),
    [anon_sym_decltype] = ACTIONS(5544),
    [sym_virtual] = ACTIONS(5544),
    [anon_sym_explicit] = ACTIONS(5544),
    [anon_sym_typename] = ACTIONS(5544),
    [anon_sym_template] = ACTIONS(5544),
    [anon_sym_operator] = ACTIONS(5544),
    [anon_sym_friend] = ACTIONS(5544),
    [anon_sym_public] = ACTIONS(5544),
    [anon_sym_private] = ACTIONS(5544),
    [anon_sym_protected] = ACTIONS(5544),
    [anon_sym_using] = ACTIONS(5544),
    [anon_sym_static_assert] = ACTIONS(5544),
    [anon_sym_precise] = ACTIONS(5544),
    [anon_sym_shared] = ACTIONS(5544),
    [anon_sym_groupshared] = ACTIONS(5544),
    [anon_sym_uniform] = ACTIONS(5544),
    [anon_sym_row_major] = ACTIONS(5544),
    [anon_sym_column_major] = ACTIONS(5544),
    [anon_sym_globallycoherent] = ACTIONS(5544),
    [anon_sym_centroid] = ACTIONS(5544),
    [anon_sym_noperspective] = ACTIONS(5544),
    [anon_sym_nointerpolation] = ACTIONS(5544),
    [anon_sym_sample] = ACTIONS(5544),
    [anon_sym_linear] = ACTIONS(5544),
    [anon_sym_snorm] = ACTIONS(5544),
    [anon_sym_unorm] = ACTIONS(5544),
    [anon_sym_point] = ACTIONS(5544),
    [anon_sym_line] = ACTIONS(5544),
    [anon_sym_triangleadj] = ACTIONS(5544),
    [anon_sym_lineadj] = ACTIONS(5544),
    [anon_sym_triangle] = ACTIONS(5544),
    [anon_sym_interface] = ACTIONS(5544),
    [anon_sym_extension] = ACTIONS(5544),
    [anon_sym___init] = ACTIONS(5544),
    [anon_sym___subscript] = ACTIONS(5544),
    [anon_sym_property] = ACTIONS(5544),
    [anon_sym_associatedtype] = ACTIONS(5544),
  },
  [2524] = {
    [sym_expression] = STATE(5129),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2525] = {
    [sym_identifier] = ACTIONS(5630),
    [aux_sym_preproc_def_token1] = ACTIONS(5630),
    [aux_sym_preproc_if_token1] = ACTIONS(5630),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5630),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5630),
    [sym_preproc_directive] = ACTIONS(5630),
    [anon_sym_LPAREN2] = ACTIONS(5632),
    [anon_sym_TILDE] = ACTIONS(5632),
    [anon_sym_STAR] = ACTIONS(5632),
    [anon_sym_AMP_AMP] = ACTIONS(5632),
    [anon_sym_AMP] = ACTIONS(5630),
    [anon_sym___extension__] = ACTIONS(5630),
    [anon_sym_typedef] = ACTIONS(5630),
    [anon_sym_in] = ACTIONS(5630),
    [anon_sym_out] = ACTIONS(5630),
    [anon_sym_inout] = ACTIONS(5630),
    [anon_sym_extern] = ACTIONS(5630),
    [anon_sym___attribute__] = ACTIONS(5630),
    [anon_sym_COLON_COLON] = ACTIONS(5632),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5632),
    [anon_sym___declspec] = ACTIONS(5630),
    [anon_sym___based] = ACTIONS(5630),
    [anon_sym_RBRACE] = ACTIONS(5632),
    [anon_sym_signed] = ACTIONS(5630),
    [anon_sym_unsigned] = ACTIONS(5630),
    [anon_sym_long] = ACTIONS(5630),
    [anon_sym_short] = ACTIONS(5630),
    [anon_sym_LBRACK] = ACTIONS(5630),
    [anon_sym_static] = ACTIONS(5630),
    [anon_sym_register] = ACTIONS(5630),
    [anon_sym_inline] = ACTIONS(5630),
    [anon_sym___inline] = ACTIONS(5630),
    [anon_sym___inline__] = ACTIONS(5630),
    [anon_sym___forceinline] = ACTIONS(5630),
    [anon_sym_thread_local] = ACTIONS(5630),
    [anon_sym___thread] = ACTIONS(5630),
    [anon_sym_const] = ACTIONS(5630),
    [anon_sym_constexpr] = ACTIONS(5630),
    [anon_sym_volatile] = ACTIONS(5630),
    [anon_sym_restrict] = ACTIONS(5630),
    [anon_sym___restrict__] = ACTIONS(5630),
    [anon_sym__Atomic] = ACTIONS(5630),
    [anon_sym__Noreturn] = ACTIONS(5630),
    [anon_sym_noreturn] = ACTIONS(5630),
    [anon_sym_mutable] = ACTIONS(5630),
    [anon_sym_constinit] = ACTIONS(5630),
    [anon_sym_consteval] = ACTIONS(5630),
    [anon_sym_alignas] = ACTIONS(5630),
    [anon_sym__Alignas] = ACTIONS(5630),
    [sym_primitive_type] = ACTIONS(5630),
    [anon_sym_enum] = ACTIONS(5630),
    [anon_sym_class] = ACTIONS(5630),
    [anon_sym_struct] = ACTIONS(5630),
    [anon_sym_union] = ACTIONS(5630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5630),
    [anon_sym_let] = ACTIONS(5630),
    [anon_sym_This] = ACTIONS(5630),
    [anon_sym_decltype] = ACTIONS(5630),
    [sym_virtual] = ACTIONS(5630),
    [anon_sym_explicit] = ACTIONS(5630),
    [anon_sym_typename] = ACTIONS(5630),
    [anon_sym_template] = ACTIONS(5630),
    [anon_sym_operator] = ACTIONS(5630),
    [anon_sym_friend] = ACTIONS(5630),
    [anon_sym_public] = ACTIONS(5630),
    [anon_sym_private] = ACTIONS(5630),
    [anon_sym_protected] = ACTIONS(5630),
    [anon_sym_using] = ACTIONS(5630),
    [anon_sym_static_assert] = ACTIONS(5630),
    [anon_sym_precise] = ACTIONS(5630),
    [anon_sym_shared] = ACTIONS(5630),
    [anon_sym_groupshared] = ACTIONS(5630),
    [anon_sym_uniform] = ACTIONS(5630),
    [anon_sym_row_major] = ACTIONS(5630),
    [anon_sym_column_major] = ACTIONS(5630),
    [anon_sym_globallycoherent] = ACTIONS(5630),
    [anon_sym_centroid] = ACTIONS(5630),
    [anon_sym_noperspective] = ACTIONS(5630),
    [anon_sym_nointerpolation] = ACTIONS(5630),
    [anon_sym_sample] = ACTIONS(5630),
    [anon_sym_linear] = ACTIONS(5630),
    [anon_sym_snorm] = ACTIONS(5630),
    [anon_sym_unorm] = ACTIONS(5630),
    [anon_sym_point] = ACTIONS(5630),
    [anon_sym_line] = ACTIONS(5630),
    [anon_sym_triangleadj] = ACTIONS(5630),
    [anon_sym_lineadj] = ACTIONS(5630),
    [anon_sym_triangle] = ACTIONS(5630),
    [anon_sym_interface] = ACTIONS(5630),
    [anon_sym_extension] = ACTIONS(5630),
    [anon_sym___init] = ACTIONS(5630),
    [anon_sym___subscript] = ACTIONS(5630),
    [anon_sym_property] = ACTIONS(5630),
    [anon_sym_associatedtype] = ACTIONS(5630),
  },
  [2526] = {
    [sym_identifier] = ACTIONS(5634),
    [aux_sym_preproc_def_token1] = ACTIONS(5634),
    [aux_sym_preproc_if_token1] = ACTIONS(5634),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5634),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5634),
    [sym_preproc_directive] = ACTIONS(5634),
    [anon_sym_LPAREN2] = ACTIONS(5636),
    [anon_sym_TILDE] = ACTIONS(5636),
    [anon_sym_STAR] = ACTIONS(5636),
    [anon_sym_AMP_AMP] = ACTIONS(5636),
    [anon_sym_AMP] = ACTIONS(5634),
    [anon_sym___extension__] = ACTIONS(5634),
    [anon_sym_typedef] = ACTIONS(5634),
    [anon_sym_in] = ACTIONS(5634),
    [anon_sym_out] = ACTIONS(5634),
    [anon_sym_inout] = ACTIONS(5634),
    [anon_sym_extern] = ACTIONS(5634),
    [anon_sym___attribute__] = ACTIONS(5634),
    [anon_sym_COLON_COLON] = ACTIONS(5636),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5636),
    [anon_sym___declspec] = ACTIONS(5634),
    [anon_sym___based] = ACTIONS(5634),
    [anon_sym_RBRACE] = ACTIONS(5636),
    [anon_sym_signed] = ACTIONS(5634),
    [anon_sym_unsigned] = ACTIONS(5634),
    [anon_sym_long] = ACTIONS(5634),
    [anon_sym_short] = ACTIONS(5634),
    [anon_sym_LBRACK] = ACTIONS(5634),
    [anon_sym_static] = ACTIONS(5634),
    [anon_sym_register] = ACTIONS(5634),
    [anon_sym_inline] = ACTIONS(5634),
    [anon_sym___inline] = ACTIONS(5634),
    [anon_sym___inline__] = ACTIONS(5634),
    [anon_sym___forceinline] = ACTIONS(5634),
    [anon_sym_thread_local] = ACTIONS(5634),
    [anon_sym___thread] = ACTIONS(5634),
    [anon_sym_const] = ACTIONS(5634),
    [anon_sym_constexpr] = ACTIONS(5634),
    [anon_sym_volatile] = ACTIONS(5634),
    [anon_sym_restrict] = ACTIONS(5634),
    [anon_sym___restrict__] = ACTIONS(5634),
    [anon_sym__Atomic] = ACTIONS(5634),
    [anon_sym__Noreturn] = ACTIONS(5634),
    [anon_sym_noreturn] = ACTIONS(5634),
    [anon_sym_mutable] = ACTIONS(5634),
    [anon_sym_constinit] = ACTIONS(5634),
    [anon_sym_consteval] = ACTIONS(5634),
    [anon_sym_alignas] = ACTIONS(5634),
    [anon_sym__Alignas] = ACTIONS(5634),
    [sym_primitive_type] = ACTIONS(5634),
    [anon_sym_enum] = ACTIONS(5634),
    [anon_sym_class] = ACTIONS(5634),
    [anon_sym_struct] = ACTIONS(5634),
    [anon_sym_union] = ACTIONS(5634),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5634),
    [anon_sym_let] = ACTIONS(5634),
    [anon_sym_This] = ACTIONS(5634),
    [anon_sym_decltype] = ACTIONS(5634),
    [sym_virtual] = ACTIONS(5634),
    [anon_sym_explicit] = ACTIONS(5634),
    [anon_sym_typename] = ACTIONS(5634),
    [anon_sym_template] = ACTIONS(5634),
    [anon_sym_operator] = ACTIONS(5634),
    [anon_sym_friend] = ACTIONS(5634),
    [anon_sym_public] = ACTIONS(5634),
    [anon_sym_private] = ACTIONS(5634),
    [anon_sym_protected] = ACTIONS(5634),
    [anon_sym_using] = ACTIONS(5634),
    [anon_sym_static_assert] = ACTIONS(5634),
    [anon_sym_precise] = ACTIONS(5634),
    [anon_sym_shared] = ACTIONS(5634),
    [anon_sym_groupshared] = ACTIONS(5634),
    [anon_sym_uniform] = ACTIONS(5634),
    [anon_sym_row_major] = ACTIONS(5634),
    [anon_sym_column_major] = ACTIONS(5634),
    [anon_sym_globallycoherent] = ACTIONS(5634),
    [anon_sym_centroid] = ACTIONS(5634),
    [anon_sym_noperspective] = ACTIONS(5634),
    [anon_sym_nointerpolation] = ACTIONS(5634),
    [anon_sym_sample] = ACTIONS(5634),
    [anon_sym_linear] = ACTIONS(5634),
    [anon_sym_snorm] = ACTIONS(5634),
    [anon_sym_unorm] = ACTIONS(5634),
    [anon_sym_point] = ACTIONS(5634),
    [anon_sym_line] = ACTIONS(5634),
    [anon_sym_triangleadj] = ACTIONS(5634),
    [anon_sym_lineadj] = ACTIONS(5634),
    [anon_sym_triangle] = ACTIONS(5634),
    [anon_sym_interface] = ACTIONS(5634),
    [anon_sym_extension] = ACTIONS(5634),
    [anon_sym___init] = ACTIONS(5634),
    [anon_sym___subscript] = ACTIONS(5634),
    [anon_sym_property] = ACTIONS(5634),
    [anon_sym_associatedtype] = ACTIONS(5634),
  },
  [2527] = {
    [sym_expression] = STATE(5332),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2528] = {
    [sym_expression] = STATE(5331),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2529] = {
    [sym_expression] = STATE(5330),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2530] = {
    [sym_expression] = STATE(5567),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2531] = {
    [sym_expression] = STATE(5328),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2532] = {
    [sym_expression] = STATE(5327),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2533] = {
    [sym_expression] = STATE(5326),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2534] = {
    [sym_expression] = STATE(5325),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2535] = {
    [sym_identifier] = ACTIONS(5564),
    [aux_sym_preproc_def_token1] = ACTIONS(5564),
    [aux_sym_preproc_if_token1] = ACTIONS(5564),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5564),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5564),
    [sym_preproc_directive] = ACTIONS(5564),
    [anon_sym_LPAREN2] = ACTIONS(5566),
    [anon_sym_TILDE] = ACTIONS(5566),
    [anon_sym_STAR] = ACTIONS(5566),
    [anon_sym_AMP_AMP] = ACTIONS(5566),
    [anon_sym_AMP] = ACTIONS(5564),
    [anon_sym___extension__] = ACTIONS(5564),
    [anon_sym_typedef] = ACTIONS(5564),
    [anon_sym_in] = ACTIONS(5564),
    [anon_sym_out] = ACTIONS(5564),
    [anon_sym_inout] = ACTIONS(5564),
    [anon_sym_extern] = ACTIONS(5564),
    [anon_sym___attribute__] = ACTIONS(5564),
    [anon_sym_COLON_COLON] = ACTIONS(5566),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5566),
    [anon_sym___declspec] = ACTIONS(5564),
    [anon_sym___based] = ACTIONS(5564),
    [anon_sym_RBRACE] = ACTIONS(5566),
    [anon_sym_signed] = ACTIONS(5564),
    [anon_sym_unsigned] = ACTIONS(5564),
    [anon_sym_long] = ACTIONS(5564),
    [anon_sym_short] = ACTIONS(5564),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_static] = ACTIONS(5564),
    [anon_sym_register] = ACTIONS(5564),
    [anon_sym_inline] = ACTIONS(5564),
    [anon_sym___inline] = ACTIONS(5564),
    [anon_sym___inline__] = ACTIONS(5564),
    [anon_sym___forceinline] = ACTIONS(5564),
    [anon_sym_thread_local] = ACTIONS(5564),
    [anon_sym___thread] = ACTIONS(5564),
    [anon_sym_const] = ACTIONS(5564),
    [anon_sym_constexpr] = ACTIONS(5564),
    [anon_sym_volatile] = ACTIONS(5564),
    [anon_sym_restrict] = ACTIONS(5564),
    [anon_sym___restrict__] = ACTIONS(5564),
    [anon_sym__Atomic] = ACTIONS(5564),
    [anon_sym__Noreturn] = ACTIONS(5564),
    [anon_sym_noreturn] = ACTIONS(5564),
    [anon_sym_mutable] = ACTIONS(5564),
    [anon_sym_constinit] = ACTIONS(5564),
    [anon_sym_consteval] = ACTIONS(5564),
    [anon_sym_alignas] = ACTIONS(5564),
    [anon_sym__Alignas] = ACTIONS(5564),
    [sym_primitive_type] = ACTIONS(5564),
    [anon_sym_enum] = ACTIONS(5564),
    [anon_sym_class] = ACTIONS(5564),
    [anon_sym_struct] = ACTIONS(5564),
    [anon_sym_union] = ACTIONS(5564),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5564),
    [anon_sym_let] = ACTIONS(5564),
    [anon_sym_This] = ACTIONS(5564),
    [anon_sym_decltype] = ACTIONS(5564),
    [sym_virtual] = ACTIONS(5564),
    [anon_sym_explicit] = ACTIONS(5564),
    [anon_sym_typename] = ACTIONS(5564),
    [anon_sym_template] = ACTIONS(5564),
    [anon_sym_operator] = ACTIONS(5564),
    [anon_sym_friend] = ACTIONS(5564),
    [anon_sym_public] = ACTIONS(5564),
    [anon_sym_private] = ACTIONS(5564),
    [anon_sym_protected] = ACTIONS(5564),
    [anon_sym_using] = ACTIONS(5564),
    [anon_sym_static_assert] = ACTIONS(5564),
    [anon_sym_precise] = ACTIONS(5564),
    [anon_sym_shared] = ACTIONS(5564),
    [anon_sym_groupshared] = ACTIONS(5564),
    [anon_sym_uniform] = ACTIONS(5564),
    [anon_sym_row_major] = ACTIONS(5564),
    [anon_sym_column_major] = ACTIONS(5564),
    [anon_sym_globallycoherent] = ACTIONS(5564),
    [anon_sym_centroid] = ACTIONS(5564),
    [anon_sym_noperspective] = ACTIONS(5564),
    [anon_sym_nointerpolation] = ACTIONS(5564),
    [anon_sym_sample] = ACTIONS(5564),
    [anon_sym_linear] = ACTIONS(5564),
    [anon_sym_snorm] = ACTIONS(5564),
    [anon_sym_unorm] = ACTIONS(5564),
    [anon_sym_point] = ACTIONS(5564),
    [anon_sym_line] = ACTIONS(5564),
    [anon_sym_triangleadj] = ACTIONS(5564),
    [anon_sym_lineadj] = ACTIONS(5564),
    [anon_sym_triangle] = ACTIONS(5564),
    [anon_sym_interface] = ACTIONS(5564),
    [anon_sym_extension] = ACTIONS(5564),
    [anon_sym___init] = ACTIONS(5564),
    [anon_sym___subscript] = ACTIONS(5564),
    [anon_sym_property] = ACTIONS(5564),
    [anon_sym_associatedtype] = ACTIONS(5564),
  },
  [2536] = {
    [sym_expression] = STATE(5322),
    [sym__string] = STATE(5717),
    [sym_conditional_expression] = STATE(5717),
    [sym_assignment_expression] = STATE(5717),
    [sym_pointer_expression] = STATE(4414),
    [sym_unary_expression] = STATE(5717),
    [sym_binary_expression] = STATE(5717),
    [sym_update_expression] = STATE(5717),
    [sym_cast_expression] = STATE(5717),
    [sym_sizeof_expression] = STATE(5717),
    [sym_alignof_expression] = STATE(5717),
    [sym_offsetof_expression] = STATE(5717),
    [sym_generic_expression] = STATE(5717),
    [sym_subscript_expression] = STATE(4414),
    [sym_call_expression] = STATE(4414),
    [sym_gnu_asm_expression] = STATE(5717),
    [sym_field_expression] = STATE(4414),
    [sym_compound_literal_expression] = STATE(5717),
    [sym_parenthesized_expression] = STATE(4414),
    [sym_char_literal] = STATE(5544),
    [sym_concatenated_string] = STATE(5521),
    [sym_string_literal] = STATE(4591),
    [sym_null] = STATE(5717),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9946),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(5717),
    [sym_raw_string_literal] = STATE(4589),
    [sym_co_await_expression] = STATE(5717),
    [sym_new_expression] = STATE(5717),
    [sym_delete_expression] = STATE(5717),
    [sym_requires_clause] = STATE(5717),
    [sym_requires_expression] = STATE(5717),
    [sym_lambda_expression] = STATE(5717),
    [sym_lambda_capture_specifier] = STATE(7044),
    [sym_fold_expression] = STATE(5717),
    [sym_parameter_pack_expansion] = STATE(5717),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4414),
    [sym_qualified_type_identifier] = STATE(9946),
    [sym_user_defined_literal] = STATE(4414),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_not] = ACTIONS(4627),
    [anon_sym_compl] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4645),
    [anon_sym_sizeof] = ACTIONS(4647),
    [anon_sym___alignof__] = ACTIONS(4649),
    [anon_sym___alignof] = ACTIONS(4649),
    [anon_sym__alignof] = ACTIONS(4649),
    [anon_sym_alignof] = ACTIONS(4649),
    [anon_sym__Alignof] = ACTIONS(4649),
    [anon_sym_offsetof] = ACTIONS(4651),
    [anon_sym__Generic] = ACTIONS(4653),
    [anon_sym_asm] = ACTIONS(4655),
    [anon_sym___asm__] = ACTIONS(4655),
    [sym_number_literal] = ACTIONS(4657),
    [anon_sym_L_SQUOTE] = ACTIONS(4659),
    [anon_sym_u_SQUOTE] = ACTIONS(4659),
    [anon_sym_U_SQUOTE] = ACTIONS(4659),
    [anon_sym_u8_SQUOTE] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4659),
    [anon_sym_L_DQUOTE] = ACTIONS(4661),
    [anon_sym_u_DQUOTE] = ACTIONS(4661),
    [anon_sym_U_DQUOTE] = ACTIONS(4661),
    [anon_sym_u8_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(4661),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [anon_sym_NULL] = ACTIONS(4665),
    [anon_sym_nullptr] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4677),
    [anon_sym_R_DQUOTE] = ACTIONS(4679),
    [anon_sym_LR_DQUOTE] = ACTIONS(4679),
    [anon_sym_uR_DQUOTE] = ACTIONS(4679),
    [anon_sym_UR_DQUOTE] = ACTIONS(4679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4679),
    [anon_sym_co_await] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_requires] = ACTIONS(4685),
    [sym_this] = ACTIONS(4663),
  },
  [2537] = {
    [sym_expression] = STATE(5613),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2538] = {
    [sym_expression] = STATE(4186),
    [sym__string] = STATE(4545),
    [sym_conditional_expression] = STATE(4545),
    [sym_assignment_expression] = STATE(4545),
    [sym_pointer_expression] = STATE(4540),
    [sym_unary_expression] = STATE(4545),
    [sym_binary_expression] = STATE(4545),
    [sym_update_expression] = STATE(4545),
    [sym_cast_expression] = STATE(4545),
    [sym_sizeof_expression] = STATE(4545),
    [sym_alignof_expression] = STATE(4545),
    [sym_offsetof_expression] = STATE(4545),
    [sym_generic_expression] = STATE(4545),
    [sym_subscript_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_gnu_asm_expression] = STATE(4545),
    [sym_field_expression] = STATE(4540),
    [sym_compound_literal_expression] = STATE(4545),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_char_literal] = STATE(4286),
    [sym_concatenated_string] = STATE(4290),
    [sym_string_literal] = STATE(3166),
    [sym_null] = STATE(4545),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9673),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4545),
    [sym_raw_string_literal] = STATE(3169),
    [sym_co_await_expression] = STATE(4545),
    [sym_new_expression] = STATE(4545),
    [sym_delete_expression] = STATE(4545),
    [sym_requires_clause] = STATE(4545),
    [sym_requires_expression] = STATE(4545),
    [sym_lambda_expression] = STATE(4545),
    [sym_lambda_capture_specifier] = STATE(7034),
    [sym_fold_expression] = STATE(4545),
    [sym_parameter_pack_expansion] = STATE(4545),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4540),
    [sym_qualified_type_identifier] = STATE(9673),
    [sym_user_defined_literal] = STATE(4540),
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_LPAREN2] = ACTIONS(5828),
    [anon_sym_BANG] = ACTIONS(4733),
    [anon_sym_TILDE] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4731),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4735),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4739),
    [anon_sym_not] = ACTIONS(4731),
    [anon_sym_compl] = ACTIONS(4731),
    [anon_sym_DASH_DASH] = ACTIONS(5711),
    [anon_sym_PLUS_PLUS] = ACTIONS(5711),
    [anon_sym_sizeof] = ACTIONS(4741),
    [anon_sym___alignof__] = ACTIONS(4743),
    [anon_sym___alignof] = ACTIONS(4743),
    [anon_sym__alignof] = ACTIONS(4743),
    [anon_sym_alignof] = ACTIONS(4743),
    [anon_sym__Alignof] = ACTIONS(4743),
    [anon_sym_offsetof] = ACTIONS(4745),
    [anon_sym__Generic] = ACTIONS(4747),
    [anon_sym_asm] = ACTIONS(4749),
    [anon_sym___asm__] = ACTIONS(4749),
    [sym_number_literal] = ACTIONS(4751),
    [anon_sym_L_SQUOTE] = ACTIONS(4753),
    [anon_sym_u_SQUOTE] = ACTIONS(4753),
    [anon_sym_U_SQUOTE] = ACTIONS(4753),
    [anon_sym_u8_SQUOTE] = ACTIONS(4753),
    [anon_sym_SQUOTE] = ACTIONS(4753),
    [anon_sym_L_DQUOTE] = ACTIONS(4755),
    [anon_sym_u_DQUOTE] = ACTIONS(4755),
    [anon_sym_U_DQUOTE] = ACTIONS(4755),
    [anon_sym_u8_DQUOTE] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [anon_sym_NULL] = ACTIONS(4759),
    [anon_sym_nullptr] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4761),
    [anon_sym_R_DQUOTE] = ACTIONS(4763),
    [anon_sym_LR_DQUOTE] = ACTIONS(4763),
    [anon_sym_uR_DQUOTE] = ACTIONS(4763),
    [anon_sym_UR_DQUOTE] = ACTIONS(4763),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4763),
    [anon_sym_co_await] = ACTIONS(4765),
    [anon_sym_new] = ACTIONS(4767),
    [anon_sym_requires] = ACTIONS(4769),
    [sym_this] = ACTIONS(4757),
  },
  [2539] = {
    [sym_expression] = STATE(3449),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3481),
    [sym_concatenated_string] = STATE(3486),
    [sym_string_literal] = STATE(2963),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2960),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5795),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4412),
    [anon_sym_PLUS] = ACTIONS(4412),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4416),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4412),
    [anon_sym_compl] = ACTIONS(4412),
    [anon_sym_DASH_DASH] = ACTIONS(5756),
    [anon_sym_PLUS_PLUS] = ACTIONS(5756),
    [anon_sym_sizeof] = ACTIONS(4422),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4432),
    [anon_sym_L_SQUOTE] = ACTIONS(4434),
    [anon_sym_u_SQUOTE] = ACTIONS(4434),
    [anon_sym_U_SQUOTE] = ACTIONS(4434),
    [anon_sym_u8_SQUOTE] = ACTIONS(4434),
    [anon_sym_SQUOTE] = ACTIONS(4434),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4442),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [anon_sym_co_await] = ACTIONS(4446),
    [anon_sym_new] = ACTIONS(4448),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2540] = {
    [sym_identifier] = ACTIONS(3633),
    [aux_sym_preproc_def_token1] = ACTIONS(3633),
    [aux_sym_preproc_if_token1] = ACTIONS(3633),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3633),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3633),
    [sym_preproc_directive] = ACTIONS(3633),
    [anon_sym_LPAREN2] = ACTIONS(3635),
    [anon_sym_TILDE] = ACTIONS(3635),
    [anon_sym_STAR] = ACTIONS(3635),
    [anon_sym_AMP_AMP] = ACTIONS(3635),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym___extension__] = ACTIONS(3633),
    [anon_sym_typedef] = ACTIONS(3633),
    [anon_sym_in] = ACTIONS(3633),
    [anon_sym_out] = ACTIONS(3633),
    [anon_sym_inout] = ACTIONS(3633),
    [anon_sym_extern] = ACTIONS(3633),
    [anon_sym___attribute__] = ACTIONS(3633),
    [anon_sym_COLON_COLON] = ACTIONS(3635),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3635),
    [anon_sym___declspec] = ACTIONS(3633),
    [anon_sym___based] = ACTIONS(3633),
    [anon_sym_RBRACE] = ACTIONS(3635),
    [anon_sym_signed] = ACTIONS(3633),
    [anon_sym_unsigned] = ACTIONS(3633),
    [anon_sym_long] = ACTIONS(3633),
    [anon_sym_short] = ACTIONS(3633),
    [anon_sym_LBRACK] = ACTIONS(3633),
    [anon_sym_static] = ACTIONS(3633),
    [anon_sym_register] = ACTIONS(3633),
    [anon_sym_inline] = ACTIONS(3633),
    [anon_sym___inline] = ACTIONS(3633),
    [anon_sym___inline__] = ACTIONS(3633),
    [anon_sym___forceinline] = ACTIONS(3633),
    [anon_sym_thread_local] = ACTIONS(3633),
    [anon_sym___thread] = ACTIONS(3633),
    [anon_sym_const] = ACTIONS(3633),
    [anon_sym_constexpr] = ACTIONS(3633),
    [anon_sym_volatile] = ACTIONS(3633),
    [anon_sym_restrict] = ACTIONS(3633),
    [anon_sym___restrict__] = ACTIONS(3633),
    [anon_sym__Atomic] = ACTIONS(3633),
    [anon_sym__Noreturn] = ACTIONS(3633),
    [anon_sym_noreturn] = ACTIONS(3633),
    [anon_sym_mutable] = ACTIONS(3633),
    [anon_sym_constinit] = ACTIONS(3633),
    [anon_sym_consteval] = ACTIONS(3633),
    [anon_sym_alignas] = ACTIONS(3633),
    [anon_sym__Alignas] = ACTIONS(3633),
    [sym_primitive_type] = ACTIONS(3633),
    [anon_sym_enum] = ACTIONS(3633),
    [anon_sym_class] = ACTIONS(3633),
    [anon_sym_struct] = ACTIONS(3633),
    [anon_sym_union] = ACTIONS(3633),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3633),
    [anon_sym_let] = ACTIONS(3633),
    [anon_sym_This] = ACTIONS(3633),
    [anon_sym_decltype] = ACTIONS(3633),
    [sym_virtual] = ACTIONS(3633),
    [anon_sym_explicit] = ACTIONS(3633),
    [anon_sym_typename] = ACTIONS(3633),
    [anon_sym_template] = ACTIONS(3633),
    [anon_sym_operator] = ACTIONS(3633),
    [anon_sym_friend] = ACTIONS(3633),
    [anon_sym_public] = ACTIONS(3633),
    [anon_sym_private] = ACTIONS(3633),
    [anon_sym_protected] = ACTIONS(3633),
    [anon_sym_using] = ACTIONS(3633),
    [anon_sym_static_assert] = ACTIONS(3633),
    [anon_sym_precise] = ACTIONS(3633),
    [anon_sym_shared] = ACTIONS(3633),
    [anon_sym_groupshared] = ACTIONS(3633),
    [anon_sym_uniform] = ACTIONS(3633),
    [anon_sym_row_major] = ACTIONS(3633),
    [anon_sym_column_major] = ACTIONS(3633),
    [anon_sym_globallycoherent] = ACTIONS(3633),
    [anon_sym_centroid] = ACTIONS(3633),
    [anon_sym_noperspective] = ACTIONS(3633),
    [anon_sym_nointerpolation] = ACTIONS(3633),
    [anon_sym_sample] = ACTIONS(3633),
    [anon_sym_linear] = ACTIONS(3633),
    [anon_sym_snorm] = ACTIONS(3633),
    [anon_sym_unorm] = ACTIONS(3633),
    [anon_sym_point] = ACTIONS(3633),
    [anon_sym_line] = ACTIONS(3633),
    [anon_sym_triangleadj] = ACTIONS(3633),
    [anon_sym_lineadj] = ACTIONS(3633),
    [anon_sym_triangle] = ACTIONS(3633),
    [anon_sym_interface] = ACTIONS(3633),
    [anon_sym_extension] = ACTIONS(3633),
    [anon_sym___init] = ACTIONS(3633),
    [anon_sym___subscript] = ACTIONS(3633),
    [anon_sym_property] = ACTIONS(3633),
    [anon_sym_associatedtype] = ACTIONS(3633),
  },
  [2541] = {
    [sym_identifier] = ACTIONS(5638),
    [aux_sym_preproc_def_token1] = ACTIONS(5638),
    [aux_sym_preproc_if_token1] = ACTIONS(5638),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5638),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5638),
    [sym_preproc_directive] = ACTIONS(5638),
    [anon_sym_LPAREN2] = ACTIONS(5640),
    [anon_sym_TILDE] = ACTIONS(5640),
    [anon_sym_STAR] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5638),
    [anon_sym___extension__] = ACTIONS(5638),
    [anon_sym_typedef] = ACTIONS(5638),
    [anon_sym_in] = ACTIONS(5638),
    [anon_sym_out] = ACTIONS(5638),
    [anon_sym_inout] = ACTIONS(5638),
    [anon_sym_extern] = ACTIONS(5638),
    [anon_sym___attribute__] = ACTIONS(5638),
    [anon_sym_COLON_COLON] = ACTIONS(5640),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5640),
    [anon_sym___declspec] = ACTIONS(5638),
    [anon_sym___based] = ACTIONS(5638),
    [anon_sym_RBRACE] = ACTIONS(5640),
    [anon_sym_signed] = ACTIONS(5638),
    [anon_sym_unsigned] = ACTIONS(5638),
    [anon_sym_long] = ACTIONS(5638),
    [anon_sym_short] = ACTIONS(5638),
    [anon_sym_LBRACK] = ACTIONS(5638),
    [anon_sym_static] = ACTIONS(5638),
    [anon_sym_register] = ACTIONS(5638),
    [anon_sym_inline] = ACTIONS(5638),
    [anon_sym___inline] = ACTIONS(5638),
    [anon_sym___inline__] = ACTIONS(5638),
    [anon_sym___forceinline] = ACTIONS(5638),
    [anon_sym_thread_local] = ACTIONS(5638),
    [anon_sym___thread] = ACTIONS(5638),
    [anon_sym_const] = ACTIONS(5638),
    [anon_sym_constexpr] = ACTIONS(5638),
    [anon_sym_volatile] = ACTIONS(5638),
    [anon_sym_restrict] = ACTIONS(5638),
    [anon_sym___restrict__] = ACTIONS(5638),
    [anon_sym__Atomic] = ACTIONS(5638),
    [anon_sym__Noreturn] = ACTIONS(5638),
    [anon_sym_noreturn] = ACTIONS(5638),
    [anon_sym_mutable] = ACTIONS(5638),
    [anon_sym_constinit] = ACTIONS(5638),
    [anon_sym_consteval] = ACTIONS(5638),
    [anon_sym_alignas] = ACTIONS(5638),
    [anon_sym__Alignas] = ACTIONS(5638),
    [sym_primitive_type] = ACTIONS(5638),
    [anon_sym_enum] = ACTIONS(5638),
    [anon_sym_class] = ACTIONS(5638),
    [anon_sym_struct] = ACTIONS(5638),
    [anon_sym_union] = ACTIONS(5638),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5638),
    [anon_sym_let] = ACTIONS(5638),
    [anon_sym_This] = ACTIONS(5638),
    [anon_sym_decltype] = ACTIONS(5638),
    [sym_virtual] = ACTIONS(5638),
    [anon_sym_explicit] = ACTIONS(5638),
    [anon_sym_typename] = ACTIONS(5638),
    [anon_sym_template] = ACTIONS(5638),
    [anon_sym_operator] = ACTIONS(5638),
    [anon_sym_friend] = ACTIONS(5638),
    [anon_sym_public] = ACTIONS(5638),
    [anon_sym_private] = ACTIONS(5638),
    [anon_sym_protected] = ACTIONS(5638),
    [anon_sym_using] = ACTIONS(5638),
    [anon_sym_static_assert] = ACTIONS(5638),
    [anon_sym_precise] = ACTIONS(5638),
    [anon_sym_shared] = ACTIONS(5638),
    [anon_sym_groupshared] = ACTIONS(5638),
    [anon_sym_uniform] = ACTIONS(5638),
    [anon_sym_row_major] = ACTIONS(5638),
    [anon_sym_column_major] = ACTIONS(5638),
    [anon_sym_globallycoherent] = ACTIONS(5638),
    [anon_sym_centroid] = ACTIONS(5638),
    [anon_sym_noperspective] = ACTIONS(5638),
    [anon_sym_nointerpolation] = ACTIONS(5638),
    [anon_sym_sample] = ACTIONS(5638),
    [anon_sym_linear] = ACTIONS(5638),
    [anon_sym_snorm] = ACTIONS(5638),
    [anon_sym_unorm] = ACTIONS(5638),
    [anon_sym_point] = ACTIONS(5638),
    [anon_sym_line] = ACTIONS(5638),
    [anon_sym_triangleadj] = ACTIONS(5638),
    [anon_sym_lineadj] = ACTIONS(5638),
    [anon_sym_triangle] = ACTIONS(5638),
    [anon_sym_interface] = ACTIONS(5638),
    [anon_sym_extension] = ACTIONS(5638),
    [anon_sym___init] = ACTIONS(5638),
    [anon_sym___subscript] = ACTIONS(5638),
    [anon_sym_property] = ACTIONS(5638),
    [anon_sym_associatedtype] = ACTIONS(5638),
  },
  [2542] = {
    [sym_expression] = STATE(3446),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3481),
    [sym_concatenated_string] = STATE(3486),
    [sym_string_literal] = STATE(2963),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2960),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5795),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4412),
    [anon_sym_PLUS] = ACTIONS(4412),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4416),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4412),
    [anon_sym_compl] = ACTIONS(4412),
    [anon_sym_DASH_DASH] = ACTIONS(5756),
    [anon_sym_PLUS_PLUS] = ACTIONS(5756),
    [anon_sym_sizeof] = ACTIONS(4422),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4432),
    [anon_sym_L_SQUOTE] = ACTIONS(4434),
    [anon_sym_u_SQUOTE] = ACTIONS(4434),
    [anon_sym_U_SQUOTE] = ACTIONS(4434),
    [anon_sym_u8_SQUOTE] = ACTIONS(4434),
    [anon_sym_SQUOTE] = ACTIONS(4434),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4442),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [anon_sym_co_await] = ACTIONS(4446),
    [anon_sym_new] = ACTIONS(4448),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2543] = {
    [sym_identifier] = ACTIONS(3034),
    [aux_sym_preproc_def_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token2] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_in] = ACTIONS(3034),
    [anon_sym_out] = ACTIONS(3034),
    [anon_sym_inout] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym___based] = ACTIONS(3034),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_This] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [sym_virtual] = ACTIONS(3034),
    [anon_sym_explicit] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_operator] = ACTIONS(3034),
    [anon_sym_friend] = ACTIONS(3034),
    [anon_sym_public] = ACTIONS(3034),
    [anon_sym_private] = ACTIONS(3034),
    [anon_sym_protected] = ACTIONS(3034),
    [anon_sym_using] = ACTIONS(3034),
    [anon_sym_static_assert] = ACTIONS(3034),
    [anon_sym_precise] = ACTIONS(3034),
    [anon_sym_shared] = ACTIONS(3034),
    [anon_sym_groupshared] = ACTIONS(3034),
    [anon_sym_uniform] = ACTIONS(3034),
    [anon_sym_row_major] = ACTIONS(3034),
    [anon_sym_column_major] = ACTIONS(3034),
    [anon_sym_globallycoherent] = ACTIONS(3034),
    [anon_sym_centroid] = ACTIONS(3034),
    [anon_sym_noperspective] = ACTIONS(3034),
    [anon_sym_nointerpolation] = ACTIONS(3034),
    [anon_sym_sample] = ACTIONS(3034),
    [anon_sym_linear] = ACTIONS(3034),
    [anon_sym_snorm] = ACTIONS(3034),
    [anon_sym_unorm] = ACTIONS(3034),
    [anon_sym_point] = ACTIONS(3034),
    [anon_sym_line] = ACTIONS(3034),
    [anon_sym_triangleadj] = ACTIONS(3034),
    [anon_sym_lineadj] = ACTIONS(3034),
    [anon_sym_triangle] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3034),
    [anon_sym_extension] = ACTIONS(3034),
    [anon_sym___init] = ACTIONS(3034),
    [anon_sym___subscript] = ACTIONS(3034),
    [anon_sym_property] = ACTIONS(3034),
    [anon_sym_associatedtype] = ACTIONS(3034),
  },
  [2544] = {
    [sym_identifier] = ACTIONS(3222),
    [aux_sym_preproc_def_token1] = ACTIONS(3222),
    [aux_sym_preproc_if_token1] = ACTIONS(3222),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3222),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3222),
    [sym_preproc_directive] = ACTIONS(3222),
    [anon_sym_LPAREN2] = ACTIONS(3224),
    [anon_sym_TILDE] = ACTIONS(3224),
    [anon_sym_STAR] = ACTIONS(3224),
    [anon_sym_AMP_AMP] = ACTIONS(3224),
    [anon_sym_AMP] = ACTIONS(3222),
    [anon_sym___extension__] = ACTIONS(3222),
    [anon_sym_typedef] = ACTIONS(3222),
    [anon_sym_in] = ACTIONS(3222),
    [anon_sym_out] = ACTIONS(3222),
    [anon_sym_inout] = ACTIONS(3222),
    [anon_sym_extern] = ACTIONS(3222),
    [anon_sym___attribute__] = ACTIONS(3222),
    [anon_sym_COLON_COLON] = ACTIONS(3224),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3224),
    [anon_sym___declspec] = ACTIONS(3222),
    [anon_sym___based] = ACTIONS(3222),
    [anon_sym_RBRACE] = ACTIONS(3224),
    [anon_sym_signed] = ACTIONS(3222),
    [anon_sym_unsigned] = ACTIONS(3222),
    [anon_sym_long] = ACTIONS(3222),
    [anon_sym_short] = ACTIONS(3222),
    [anon_sym_LBRACK] = ACTIONS(3222),
    [anon_sym_static] = ACTIONS(3222),
    [anon_sym_register] = ACTIONS(3222),
    [anon_sym_inline] = ACTIONS(3222),
    [anon_sym___inline] = ACTIONS(3222),
    [anon_sym___inline__] = ACTIONS(3222),
    [anon_sym___forceinline] = ACTIONS(3222),
    [anon_sym_thread_local] = ACTIONS(3222),
    [anon_sym___thread] = ACTIONS(3222),
    [anon_sym_const] = ACTIONS(3222),
    [anon_sym_constexpr] = ACTIONS(3222),
    [anon_sym_volatile] = ACTIONS(3222),
    [anon_sym_restrict] = ACTIONS(3222),
    [anon_sym___restrict__] = ACTIONS(3222),
    [anon_sym__Atomic] = ACTIONS(3222),
    [anon_sym__Noreturn] = ACTIONS(3222),
    [anon_sym_noreturn] = ACTIONS(3222),
    [anon_sym_mutable] = ACTIONS(3222),
    [anon_sym_constinit] = ACTIONS(3222),
    [anon_sym_consteval] = ACTIONS(3222),
    [anon_sym_alignas] = ACTIONS(3222),
    [anon_sym__Alignas] = ACTIONS(3222),
    [sym_primitive_type] = ACTIONS(3222),
    [anon_sym_enum] = ACTIONS(3222),
    [anon_sym_class] = ACTIONS(3222),
    [anon_sym_struct] = ACTIONS(3222),
    [anon_sym_union] = ACTIONS(3222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3222),
    [anon_sym_let] = ACTIONS(3222),
    [anon_sym_This] = ACTIONS(3222),
    [anon_sym_decltype] = ACTIONS(3222),
    [sym_virtual] = ACTIONS(3222),
    [anon_sym_explicit] = ACTIONS(3222),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3222),
    [anon_sym_operator] = ACTIONS(3222),
    [anon_sym_friend] = ACTIONS(3222),
    [anon_sym_public] = ACTIONS(3222),
    [anon_sym_private] = ACTIONS(3222),
    [anon_sym_protected] = ACTIONS(3222),
    [anon_sym_using] = ACTIONS(3222),
    [anon_sym_static_assert] = ACTIONS(3222),
    [anon_sym_precise] = ACTIONS(3222),
    [anon_sym_shared] = ACTIONS(3222),
    [anon_sym_groupshared] = ACTIONS(3222),
    [anon_sym_uniform] = ACTIONS(3222),
    [anon_sym_row_major] = ACTIONS(3222),
    [anon_sym_column_major] = ACTIONS(3222),
    [anon_sym_globallycoherent] = ACTIONS(3222),
    [anon_sym_centroid] = ACTIONS(3222),
    [anon_sym_noperspective] = ACTIONS(3222),
    [anon_sym_nointerpolation] = ACTIONS(3222),
    [anon_sym_sample] = ACTIONS(3222),
    [anon_sym_linear] = ACTIONS(3222),
    [anon_sym_snorm] = ACTIONS(3222),
    [anon_sym_unorm] = ACTIONS(3222),
    [anon_sym_point] = ACTIONS(3222),
    [anon_sym_line] = ACTIONS(3222),
    [anon_sym_triangleadj] = ACTIONS(3222),
    [anon_sym_lineadj] = ACTIONS(3222),
    [anon_sym_triangle] = ACTIONS(3222),
    [anon_sym_interface] = ACTIONS(3222),
    [anon_sym_extension] = ACTIONS(3222),
    [anon_sym___init] = ACTIONS(3222),
    [anon_sym___subscript] = ACTIONS(3222),
    [anon_sym_property] = ACTIONS(3222),
    [anon_sym_associatedtype] = ACTIONS(3222),
  },
  [2545] = {
    [sym_identifier] = ACTIONS(3034),
    [aux_sym_preproc_def_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token2] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_in] = ACTIONS(3034),
    [anon_sym_out] = ACTIONS(3034),
    [anon_sym_inout] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym___based] = ACTIONS(3034),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_This] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [sym_virtual] = ACTIONS(3034),
    [anon_sym_explicit] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_operator] = ACTIONS(3034),
    [anon_sym_friend] = ACTIONS(3034),
    [anon_sym_public] = ACTIONS(3034),
    [anon_sym_private] = ACTIONS(3034),
    [anon_sym_protected] = ACTIONS(3034),
    [anon_sym_using] = ACTIONS(3034),
    [anon_sym_static_assert] = ACTIONS(3034),
    [anon_sym_precise] = ACTIONS(3034),
    [anon_sym_shared] = ACTIONS(3034),
    [anon_sym_groupshared] = ACTIONS(3034),
    [anon_sym_uniform] = ACTIONS(3034),
    [anon_sym_row_major] = ACTIONS(3034),
    [anon_sym_column_major] = ACTIONS(3034),
    [anon_sym_globallycoherent] = ACTIONS(3034),
    [anon_sym_centroid] = ACTIONS(3034),
    [anon_sym_noperspective] = ACTIONS(3034),
    [anon_sym_nointerpolation] = ACTIONS(3034),
    [anon_sym_sample] = ACTIONS(3034),
    [anon_sym_linear] = ACTIONS(3034),
    [anon_sym_snorm] = ACTIONS(3034),
    [anon_sym_unorm] = ACTIONS(3034),
    [anon_sym_point] = ACTIONS(3034),
    [anon_sym_line] = ACTIONS(3034),
    [anon_sym_triangleadj] = ACTIONS(3034),
    [anon_sym_lineadj] = ACTIONS(3034),
    [anon_sym_triangle] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3034),
    [anon_sym_extension] = ACTIONS(3034),
    [anon_sym___init] = ACTIONS(3034),
    [anon_sym___subscript] = ACTIONS(3034),
    [anon_sym_property] = ACTIONS(3034),
    [anon_sym_associatedtype] = ACTIONS(3034),
  },
  [2546] = {
    [sym_identifier] = ACTIONS(3034),
    [aux_sym_preproc_def_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token2] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_in] = ACTIONS(3034),
    [anon_sym_out] = ACTIONS(3034),
    [anon_sym_inout] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym___based] = ACTIONS(3034),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_This] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [sym_virtual] = ACTIONS(3034),
    [anon_sym_explicit] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_operator] = ACTIONS(3034),
    [anon_sym_friend] = ACTIONS(3034),
    [anon_sym_public] = ACTIONS(3034),
    [anon_sym_private] = ACTIONS(3034),
    [anon_sym_protected] = ACTIONS(3034),
    [anon_sym_using] = ACTIONS(3034),
    [anon_sym_static_assert] = ACTIONS(3034),
    [anon_sym_precise] = ACTIONS(3034),
    [anon_sym_shared] = ACTIONS(3034),
    [anon_sym_groupshared] = ACTIONS(3034),
    [anon_sym_uniform] = ACTIONS(3034),
    [anon_sym_row_major] = ACTIONS(3034),
    [anon_sym_column_major] = ACTIONS(3034),
    [anon_sym_globallycoherent] = ACTIONS(3034),
    [anon_sym_centroid] = ACTIONS(3034),
    [anon_sym_noperspective] = ACTIONS(3034),
    [anon_sym_nointerpolation] = ACTIONS(3034),
    [anon_sym_sample] = ACTIONS(3034),
    [anon_sym_linear] = ACTIONS(3034),
    [anon_sym_snorm] = ACTIONS(3034),
    [anon_sym_unorm] = ACTIONS(3034),
    [anon_sym_point] = ACTIONS(3034),
    [anon_sym_line] = ACTIONS(3034),
    [anon_sym_triangleadj] = ACTIONS(3034),
    [anon_sym_lineadj] = ACTIONS(3034),
    [anon_sym_triangle] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3034),
    [anon_sym_extension] = ACTIONS(3034),
    [anon_sym___init] = ACTIONS(3034),
    [anon_sym___subscript] = ACTIONS(3034),
    [anon_sym_property] = ACTIONS(3034),
    [anon_sym_associatedtype] = ACTIONS(3034),
  },
  [2547] = {
    [sym_expression] = STATE(5146),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2548] = {
    [sym_expression] = STATE(3215),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(3481),
    [sym_concatenated_string] = STATE(3486),
    [sym_string_literal] = STATE(2963),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(2960),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_LPAREN2] = ACTIONS(5795),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4412),
    [anon_sym_PLUS] = ACTIONS(4412),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_COLON_COLON] = ACTIONS(4416),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4412),
    [anon_sym_compl] = ACTIONS(4412),
    [anon_sym_DASH_DASH] = ACTIONS(5756),
    [anon_sym_PLUS_PLUS] = ACTIONS(5756),
    [anon_sym_sizeof] = ACTIONS(4422),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4432),
    [anon_sym_L_SQUOTE] = ACTIONS(4434),
    [anon_sym_u_SQUOTE] = ACTIONS(4434),
    [anon_sym_U_SQUOTE] = ACTIONS(4434),
    [anon_sym_u8_SQUOTE] = ACTIONS(4434),
    [anon_sym_SQUOTE] = ACTIONS(4434),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4442),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [anon_sym_co_await] = ACTIONS(4446),
    [anon_sym_new] = ACTIONS(4448),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2549] = {
    [sym_expression] = STATE(4654),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2550] = {
    [sym_identifier] = ACTIONS(5552),
    [aux_sym_preproc_def_token1] = ACTIONS(5552),
    [aux_sym_preproc_if_token1] = ACTIONS(5552),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5552),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5552),
    [sym_preproc_directive] = ACTIONS(5552),
    [anon_sym_LPAREN2] = ACTIONS(5554),
    [anon_sym_TILDE] = ACTIONS(5554),
    [anon_sym_STAR] = ACTIONS(5554),
    [anon_sym_AMP_AMP] = ACTIONS(5554),
    [anon_sym_AMP] = ACTIONS(5552),
    [anon_sym___extension__] = ACTIONS(5552),
    [anon_sym_typedef] = ACTIONS(5552),
    [anon_sym_in] = ACTIONS(5552),
    [anon_sym_out] = ACTIONS(5552),
    [anon_sym_inout] = ACTIONS(5552),
    [anon_sym_extern] = ACTIONS(5552),
    [anon_sym___attribute__] = ACTIONS(5552),
    [anon_sym_COLON_COLON] = ACTIONS(5554),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5554),
    [anon_sym___declspec] = ACTIONS(5552),
    [anon_sym___based] = ACTIONS(5552),
    [anon_sym_RBRACE] = ACTIONS(5554),
    [anon_sym_signed] = ACTIONS(5552),
    [anon_sym_unsigned] = ACTIONS(5552),
    [anon_sym_long] = ACTIONS(5552),
    [anon_sym_short] = ACTIONS(5552),
    [anon_sym_LBRACK] = ACTIONS(5552),
    [anon_sym_static] = ACTIONS(5552),
    [anon_sym_register] = ACTIONS(5552),
    [anon_sym_inline] = ACTIONS(5552),
    [anon_sym___inline] = ACTIONS(5552),
    [anon_sym___inline__] = ACTIONS(5552),
    [anon_sym___forceinline] = ACTIONS(5552),
    [anon_sym_thread_local] = ACTIONS(5552),
    [anon_sym___thread] = ACTIONS(5552),
    [anon_sym_const] = ACTIONS(5552),
    [anon_sym_constexpr] = ACTIONS(5552),
    [anon_sym_volatile] = ACTIONS(5552),
    [anon_sym_restrict] = ACTIONS(5552),
    [anon_sym___restrict__] = ACTIONS(5552),
    [anon_sym__Atomic] = ACTIONS(5552),
    [anon_sym__Noreturn] = ACTIONS(5552),
    [anon_sym_noreturn] = ACTIONS(5552),
    [anon_sym_mutable] = ACTIONS(5552),
    [anon_sym_constinit] = ACTIONS(5552),
    [anon_sym_consteval] = ACTIONS(5552),
    [anon_sym_alignas] = ACTIONS(5552),
    [anon_sym__Alignas] = ACTIONS(5552),
    [sym_primitive_type] = ACTIONS(5552),
    [anon_sym_enum] = ACTIONS(5552),
    [anon_sym_class] = ACTIONS(5552),
    [anon_sym_struct] = ACTIONS(5552),
    [anon_sym_union] = ACTIONS(5552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5552),
    [anon_sym_let] = ACTIONS(5552),
    [anon_sym_This] = ACTIONS(5552),
    [anon_sym_decltype] = ACTIONS(5552),
    [sym_virtual] = ACTIONS(5552),
    [anon_sym_explicit] = ACTIONS(5552),
    [anon_sym_typename] = ACTIONS(5552),
    [anon_sym_template] = ACTIONS(5552),
    [anon_sym_operator] = ACTIONS(5552),
    [anon_sym_friend] = ACTIONS(5552),
    [anon_sym_public] = ACTIONS(5552),
    [anon_sym_private] = ACTIONS(5552),
    [anon_sym_protected] = ACTIONS(5552),
    [anon_sym_using] = ACTIONS(5552),
    [anon_sym_static_assert] = ACTIONS(5552),
    [anon_sym_precise] = ACTIONS(5552),
    [anon_sym_shared] = ACTIONS(5552),
    [anon_sym_groupshared] = ACTIONS(5552),
    [anon_sym_uniform] = ACTIONS(5552),
    [anon_sym_row_major] = ACTIONS(5552),
    [anon_sym_column_major] = ACTIONS(5552),
    [anon_sym_globallycoherent] = ACTIONS(5552),
    [anon_sym_centroid] = ACTIONS(5552),
    [anon_sym_noperspective] = ACTIONS(5552),
    [anon_sym_nointerpolation] = ACTIONS(5552),
    [anon_sym_sample] = ACTIONS(5552),
    [anon_sym_linear] = ACTIONS(5552),
    [anon_sym_snorm] = ACTIONS(5552),
    [anon_sym_unorm] = ACTIONS(5552),
    [anon_sym_point] = ACTIONS(5552),
    [anon_sym_line] = ACTIONS(5552),
    [anon_sym_triangleadj] = ACTIONS(5552),
    [anon_sym_lineadj] = ACTIONS(5552),
    [anon_sym_triangle] = ACTIONS(5552),
    [anon_sym_interface] = ACTIONS(5552),
    [anon_sym_extension] = ACTIONS(5552),
    [anon_sym___init] = ACTIONS(5552),
    [anon_sym___subscript] = ACTIONS(5552),
    [anon_sym_property] = ACTIONS(5552),
    [anon_sym_associatedtype] = ACTIONS(5552),
  },
  [2551] = {
    [sym_expression] = STATE(5266),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2552] = {
    [sym_expression] = STATE(5033),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2553] = {
    [sym_identifier] = ACTIONS(3649),
    [aux_sym_preproc_def_token1] = ACTIONS(3649),
    [aux_sym_preproc_if_token1] = ACTIONS(3649),
    [aux_sym_preproc_if_token2] = ACTIONS(3649),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3649),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3649),
    [sym_preproc_directive] = ACTIONS(3649),
    [anon_sym_LPAREN2] = ACTIONS(3651),
    [anon_sym_TILDE] = ACTIONS(3651),
    [anon_sym_STAR] = ACTIONS(3651),
    [anon_sym_AMP_AMP] = ACTIONS(3651),
    [anon_sym_AMP] = ACTIONS(3649),
    [anon_sym___extension__] = ACTIONS(3649),
    [anon_sym_typedef] = ACTIONS(3649),
    [anon_sym_in] = ACTIONS(3649),
    [anon_sym_out] = ACTIONS(3649),
    [anon_sym_inout] = ACTIONS(3649),
    [anon_sym_extern] = ACTIONS(3649),
    [anon_sym___attribute__] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(3651),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3651),
    [anon_sym___declspec] = ACTIONS(3649),
    [anon_sym___based] = ACTIONS(3649),
    [anon_sym_signed] = ACTIONS(3649),
    [anon_sym_unsigned] = ACTIONS(3649),
    [anon_sym_long] = ACTIONS(3649),
    [anon_sym_short] = ACTIONS(3649),
    [anon_sym_LBRACK] = ACTIONS(3649),
    [anon_sym_static] = ACTIONS(3649),
    [anon_sym_register] = ACTIONS(3649),
    [anon_sym_inline] = ACTIONS(3649),
    [anon_sym___inline] = ACTIONS(3649),
    [anon_sym___inline__] = ACTIONS(3649),
    [anon_sym___forceinline] = ACTIONS(3649),
    [anon_sym_thread_local] = ACTIONS(3649),
    [anon_sym___thread] = ACTIONS(3649),
    [anon_sym_const] = ACTIONS(3649),
    [anon_sym_constexpr] = ACTIONS(3649),
    [anon_sym_volatile] = ACTIONS(3649),
    [anon_sym_restrict] = ACTIONS(3649),
    [anon_sym___restrict__] = ACTIONS(3649),
    [anon_sym__Atomic] = ACTIONS(3649),
    [anon_sym__Noreturn] = ACTIONS(3649),
    [anon_sym_noreturn] = ACTIONS(3649),
    [anon_sym_mutable] = ACTIONS(3649),
    [anon_sym_constinit] = ACTIONS(3649),
    [anon_sym_consteval] = ACTIONS(3649),
    [anon_sym_alignas] = ACTIONS(3649),
    [anon_sym__Alignas] = ACTIONS(3649),
    [sym_primitive_type] = ACTIONS(3649),
    [anon_sym_enum] = ACTIONS(3649),
    [anon_sym_class] = ACTIONS(3649),
    [anon_sym_struct] = ACTIONS(3649),
    [anon_sym_union] = ACTIONS(3649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3649),
    [anon_sym_let] = ACTIONS(3649),
    [anon_sym_This] = ACTIONS(3649),
    [anon_sym_decltype] = ACTIONS(3649),
    [sym_virtual] = ACTIONS(3649),
    [anon_sym_explicit] = ACTIONS(3649),
    [anon_sym_typename] = ACTIONS(3649),
    [anon_sym_template] = ACTIONS(3649),
    [anon_sym_operator] = ACTIONS(3649),
    [anon_sym_friend] = ACTIONS(3649),
    [anon_sym_public] = ACTIONS(3649),
    [anon_sym_private] = ACTIONS(3649),
    [anon_sym_protected] = ACTIONS(3649),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_static_assert] = ACTIONS(3649),
    [anon_sym_precise] = ACTIONS(3649),
    [anon_sym_shared] = ACTIONS(3649),
    [anon_sym_groupshared] = ACTIONS(3649),
    [anon_sym_uniform] = ACTIONS(3649),
    [anon_sym_row_major] = ACTIONS(3649),
    [anon_sym_column_major] = ACTIONS(3649),
    [anon_sym_globallycoherent] = ACTIONS(3649),
    [anon_sym_centroid] = ACTIONS(3649),
    [anon_sym_noperspective] = ACTIONS(3649),
    [anon_sym_nointerpolation] = ACTIONS(3649),
    [anon_sym_sample] = ACTIONS(3649),
    [anon_sym_linear] = ACTIONS(3649),
    [anon_sym_snorm] = ACTIONS(3649),
    [anon_sym_unorm] = ACTIONS(3649),
    [anon_sym_point] = ACTIONS(3649),
    [anon_sym_line] = ACTIONS(3649),
    [anon_sym_triangleadj] = ACTIONS(3649),
    [anon_sym_lineadj] = ACTIONS(3649),
    [anon_sym_triangle] = ACTIONS(3649),
    [anon_sym_interface] = ACTIONS(3649),
    [anon_sym_extension] = ACTIONS(3649),
    [anon_sym___init] = ACTIONS(3649),
    [anon_sym___subscript] = ACTIONS(3649),
    [anon_sym_property] = ACTIONS(3649),
    [anon_sym_associatedtype] = ACTIONS(3649),
  },
  [2554] = {
    [sym_identifier] = ACTIONS(5642),
    [aux_sym_preproc_def_token1] = ACTIONS(5642),
    [aux_sym_preproc_if_token1] = ACTIONS(5642),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5642),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5642),
    [sym_preproc_directive] = ACTIONS(5642),
    [anon_sym_LPAREN2] = ACTIONS(5644),
    [anon_sym_TILDE] = ACTIONS(5644),
    [anon_sym_STAR] = ACTIONS(5644),
    [anon_sym_AMP_AMP] = ACTIONS(5644),
    [anon_sym_AMP] = ACTIONS(5642),
    [anon_sym___extension__] = ACTIONS(5642),
    [anon_sym_typedef] = ACTIONS(5642),
    [anon_sym_in] = ACTIONS(5642),
    [anon_sym_out] = ACTIONS(5642),
    [anon_sym_inout] = ACTIONS(5642),
    [anon_sym_extern] = ACTIONS(5642),
    [anon_sym___attribute__] = ACTIONS(5642),
    [anon_sym_COLON_COLON] = ACTIONS(5644),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5644),
    [anon_sym___declspec] = ACTIONS(5642),
    [anon_sym___based] = ACTIONS(5642),
    [anon_sym_RBRACE] = ACTIONS(5644),
    [anon_sym_signed] = ACTIONS(5642),
    [anon_sym_unsigned] = ACTIONS(5642),
    [anon_sym_long] = ACTIONS(5642),
    [anon_sym_short] = ACTIONS(5642),
    [anon_sym_LBRACK] = ACTIONS(5642),
    [anon_sym_static] = ACTIONS(5642),
    [anon_sym_register] = ACTIONS(5642),
    [anon_sym_inline] = ACTIONS(5642),
    [anon_sym___inline] = ACTIONS(5642),
    [anon_sym___inline__] = ACTIONS(5642),
    [anon_sym___forceinline] = ACTIONS(5642),
    [anon_sym_thread_local] = ACTIONS(5642),
    [anon_sym___thread] = ACTIONS(5642),
    [anon_sym_const] = ACTIONS(5642),
    [anon_sym_constexpr] = ACTIONS(5642),
    [anon_sym_volatile] = ACTIONS(5642),
    [anon_sym_restrict] = ACTIONS(5642),
    [anon_sym___restrict__] = ACTIONS(5642),
    [anon_sym__Atomic] = ACTIONS(5642),
    [anon_sym__Noreturn] = ACTIONS(5642),
    [anon_sym_noreturn] = ACTIONS(5642),
    [anon_sym_mutable] = ACTIONS(5642),
    [anon_sym_constinit] = ACTIONS(5642),
    [anon_sym_consteval] = ACTIONS(5642),
    [anon_sym_alignas] = ACTIONS(5642),
    [anon_sym__Alignas] = ACTIONS(5642),
    [sym_primitive_type] = ACTIONS(5642),
    [anon_sym_enum] = ACTIONS(5642),
    [anon_sym_class] = ACTIONS(5642),
    [anon_sym_struct] = ACTIONS(5642),
    [anon_sym_union] = ACTIONS(5642),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5642),
    [anon_sym_let] = ACTIONS(5642),
    [anon_sym_This] = ACTIONS(5642),
    [anon_sym_decltype] = ACTIONS(5642),
    [sym_virtual] = ACTIONS(5642),
    [anon_sym_explicit] = ACTIONS(5642),
    [anon_sym_typename] = ACTIONS(5642),
    [anon_sym_template] = ACTIONS(5642),
    [anon_sym_operator] = ACTIONS(5642),
    [anon_sym_friend] = ACTIONS(5642),
    [anon_sym_public] = ACTIONS(5642),
    [anon_sym_private] = ACTIONS(5642),
    [anon_sym_protected] = ACTIONS(5642),
    [anon_sym_using] = ACTIONS(5642),
    [anon_sym_static_assert] = ACTIONS(5642),
    [anon_sym_precise] = ACTIONS(5642),
    [anon_sym_shared] = ACTIONS(5642),
    [anon_sym_groupshared] = ACTIONS(5642),
    [anon_sym_uniform] = ACTIONS(5642),
    [anon_sym_row_major] = ACTIONS(5642),
    [anon_sym_column_major] = ACTIONS(5642),
    [anon_sym_globallycoherent] = ACTIONS(5642),
    [anon_sym_centroid] = ACTIONS(5642),
    [anon_sym_noperspective] = ACTIONS(5642),
    [anon_sym_nointerpolation] = ACTIONS(5642),
    [anon_sym_sample] = ACTIONS(5642),
    [anon_sym_linear] = ACTIONS(5642),
    [anon_sym_snorm] = ACTIONS(5642),
    [anon_sym_unorm] = ACTIONS(5642),
    [anon_sym_point] = ACTIONS(5642),
    [anon_sym_line] = ACTIONS(5642),
    [anon_sym_triangleadj] = ACTIONS(5642),
    [anon_sym_lineadj] = ACTIONS(5642),
    [anon_sym_triangle] = ACTIONS(5642),
    [anon_sym_interface] = ACTIONS(5642),
    [anon_sym_extension] = ACTIONS(5642),
    [anon_sym___init] = ACTIONS(5642),
    [anon_sym___subscript] = ACTIONS(5642),
    [anon_sym_property] = ACTIONS(5642),
    [anon_sym_associatedtype] = ACTIONS(5642),
  },
  [2555] = {
    [sym_expression] = STATE(5210),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4254),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4254),
    [sym_call_expression] = STATE(4254),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4254),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4254),
    [sym_char_literal] = STATE(5393),
    [sym_concatenated_string] = STATE(5317),
    [sym_string_literal] = STATE(4417),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(4413),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4254),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4254),
    [sym_identifier] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_compl] = ACTIONS(4950),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(4956),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4958),
    [anon_sym_L_SQUOTE] = ACTIONS(4960),
    [anon_sym_u_SQUOTE] = ACTIONS(4960),
    [anon_sym_U_SQUOTE] = ACTIONS(4960),
    [anon_sym_u8_SQUOTE] = ACTIONS(4960),
    [anon_sym_SQUOTE] = ACTIONS(4960),
    [anon_sym_L_DQUOTE] = ACTIONS(4962),
    [anon_sym_u_DQUOTE] = ACTIONS(4962),
    [anon_sym_U_DQUOTE] = ACTIONS(4962),
    [anon_sym_u8_DQUOTE] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(4962),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4964),
    [anon_sym_R_DQUOTE] = ACTIONS(4966),
    [anon_sym_LR_DQUOTE] = ACTIONS(4966),
    [anon_sym_uR_DQUOTE] = ACTIONS(4966),
    [anon_sym_UR_DQUOTE] = ACTIONS(4966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4966),
    [anon_sym_co_await] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2556] = {
    [sym_expression] = STATE(5519),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2557] = {
    [sym_expression] = STATE(3958),
    [sym__string] = STATE(4545),
    [sym_conditional_expression] = STATE(4545),
    [sym_assignment_expression] = STATE(4545),
    [sym_pointer_expression] = STATE(4540),
    [sym_unary_expression] = STATE(4545),
    [sym_binary_expression] = STATE(4545),
    [sym_update_expression] = STATE(4545),
    [sym_cast_expression] = STATE(4545),
    [sym_sizeof_expression] = STATE(4545),
    [sym_alignof_expression] = STATE(4545),
    [sym_offsetof_expression] = STATE(4545),
    [sym_generic_expression] = STATE(4545),
    [sym_subscript_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_gnu_asm_expression] = STATE(4545),
    [sym_field_expression] = STATE(4540),
    [sym_compound_literal_expression] = STATE(4545),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_char_literal] = STATE(4286),
    [sym_concatenated_string] = STATE(4290),
    [sym_string_literal] = STATE(3166),
    [sym_null] = STATE(4545),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9673),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4545),
    [sym_raw_string_literal] = STATE(3169),
    [sym_co_await_expression] = STATE(4545),
    [sym_new_expression] = STATE(4545),
    [sym_delete_expression] = STATE(4545),
    [sym_requires_clause] = STATE(4545),
    [sym_requires_expression] = STATE(4545),
    [sym_lambda_expression] = STATE(4545),
    [sym_lambda_capture_specifier] = STATE(7034),
    [sym_fold_expression] = STATE(4545),
    [sym_parameter_pack_expansion] = STATE(4545),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6879),
    [sym_qualified_identifier] = STATE(4540),
    [sym_qualified_type_identifier] = STATE(9673),
    [sym_user_defined_literal] = STATE(4540),
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_LPAREN2] = ACTIONS(5828),
    [anon_sym_BANG] = ACTIONS(4733),
    [anon_sym_TILDE] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4731),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(4629),
    [anon_sym_COLON_COLON] = ACTIONS(4735),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4739),
    [anon_sym_not] = ACTIONS(4731),
    [anon_sym_compl] = ACTIONS(4731),
    [anon_sym_DASH_DASH] = ACTIONS(5711),
    [anon_sym_PLUS_PLUS] = ACTIONS(5711),
    [anon_sym_sizeof] = ACTIONS(4741),
    [anon_sym___alignof__] = ACTIONS(4743),
    [anon_sym___alignof] = ACTIONS(4743),
    [anon_sym__alignof] = ACTIONS(4743),
    [anon_sym_alignof] = ACTIONS(4743),
    [anon_sym__Alignof] = ACTIONS(4743),
    [anon_sym_offsetof] = ACTIONS(4745),
    [anon_sym__Generic] = ACTIONS(4747),
    [anon_sym_asm] = ACTIONS(4749),
    [anon_sym___asm__] = ACTIONS(4749),
    [sym_number_literal] = ACTIONS(4751),
    [anon_sym_L_SQUOTE] = ACTIONS(4753),
    [anon_sym_u_SQUOTE] = ACTIONS(4753),
    [anon_sym_U_SQUOTE] = ACTIONS(4753),
    [anon_sym_u8_SQUOTE] = ACTIONS(4753),
    [anon_sym_SQUOTE] = ACTIONS(4753),
    [anon_sym_L_DQUOTE] = ACTIONS(4755),
    [anon_sym_u_DQUOTE] = ACTIONS(4755),
    [anon_sym_U_DQUOTE] = ACTIONS(4755),
    [anon_sym_u8_DQUOTE] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [anon_sym_NULL] = ACTIONS(4759),
    [anon_sym_nullptr] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4761),
    [anon_sym_R_DQUOTE] = ACTIONS(4763),
    [anon_sym_LR_DQUOTE] = ACTIONS(4763),
    [anon_sym_uR_DQUOTE] = ACTIONS(4763),
    [anon_sym_UR_DQUOTE] = ACTIONS(4763),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4763),
    [anon_sym_co_await] = ACTIONS(4765),
    [anon_sym_new] = ACTIONS(4767),
    [anon_sym_requires] = ACTIONS(4769),
    [sym_this] = ACTIONS(4757),
  },
  [2558] = {
    [sym_identifier] = ACTIONS(5556),
    [aux_sym_preproc_def_token1] = ACTIONS(5556),
    [aux_sym_preproc_if_token1] = ACTIONS(5556),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5556),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5556),
    [sym_preproc_directive] = ACTIONS(5556),
    [anon_sym_LPAREN2] = ACTIONS(5558),
    [anon_sym_TILDE] = ACTIONS(5558),
    [anon_sym_STAR] = ACTIONS(5558),
    [anon_sym_AMP_AMP] = ACTIONS(5558),
    [anon_sym_AMP] = ACTIONS(5556),
    [anon_sym___extension__] = ACTIONS(5556),
    [anon_sym_typedef] = ACTIONS(5556),
    [anon_sym_in] = ACTIONS(5556),
    [anon_sym_out] = ACTIONS(5556),
    [anon_sym_inout] = ACTIONS(5556),
    [anon_sym_extern] = ACTIONS(5556),
    [anon_sym___attribute__] = ACTIONS(5556),
    [anon_sym_COLON_COLON] = ACTIONS(5558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5558),
    [anon_sym___declspec] = ACTIONS(5556),
    [anon_sym___based] = ACTIONS(5556),
    [anon_sym_RBRACE] = ACTIONS(5558),
    [anon_sym_signed] = ACTIONS(5556),
    [anon_sym_unsigned] = ACTIONS(5556),
    [anon_sym_long] = ACTIONS(5556),
    [anon_sym_short] = ACTIONS(5556),
    [anon_sym_LBRACK] = ACTIONS(5556),
    [anon_sym_static] = ACTIONS(5556),
    [anon_sym_register] = ACTIONS(5556),
    [anon_sym_inline] = ACTIONS(5556),
    [anon_sym___inline] = ACTIONS(5556),
    [anon_sym___inline__] = ACTIONS(5556),
    [anon_sym___forceinline] = ACTIONS(5556),
    [anon_sym_thread_local] = ACTIONS(5556),
    [anon_sym___thread] = ACTIONS(5556),
    [anon_sym_const] = ACTIONS(5556),
    [anon_sym_constexpr] = ACTIONS(5556),
    [anon_sym_volatile] = ACTIONS(5556),
    [anon_sym_restrict] = ACTIONS(5556),
    [anon_sym___restrict__] = ACTIONS(5556),
    [anon_sym__Atomic] = ACTIONS(5556),
    [anon_sym__Noreturn] = ACTIONS(5556),
    [anon_sym_noreturn] = ACTIONS(5556),
    [anon_sym_mutable] = ACTIONS(5556),
    [anon_sym_constinit] = ACTIONS(5556),
    [anon_sym_consteval] = ACTIONS(5556),
    [anon_sym_alignas] = ACTIONS(5556),
    [anon_sym__Alignas] = ACTIONS(5556),
    [sym_primitive_type] = ACTIONS(5556),
    [anon_sym_enum] = ACTIONS(5556),
    [anon_sym_class] = ACTIONS(5556),
    [anon_sym_struct] = ACTIONS(5556),
    [anon_sym_union] = ACTIONS(5556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5556),
    [anon_sym_let] = ACTIONS(5556),
    [anon_sym_This] = ACTIONS(5556),
    [anon_sym_decltype] = ACTIONS(5556),
    [sym_virtual] = ACTIONS(5556),
    [anon_sym_explicit] = ACTIONS(5556),
    [anon_sym_typename] = ACTIONS(5556),
    [anon_sym_template] = ACTIONS(5556),
    [anon_sym_operator] = ACTIONS(5556),
    [anon_sym_friend] = ACTIONS(5556),
    [anon_sym_public] = ACTIONS(5556),
    [anon_sym_private] = ACTIONS(5556),
    [anon_sym_protected] = ACTIONS(5556),
    [anon_sym_using] = ACTIONS(5556),
    [anon_sym_static_assert] = ACTIONS(5556),
    [anon_sym_precise] = ACTIONS(5556),
    [anon_sym_shared] = ACTIONS(5556),
    [anon_sym_groupshared] = ACTIONS(5556),
    [anon_sym_uniform] = ACTIONS(5556),
    [anon_sym_row_major] = ACTIONS(5556),
    [anon_sym_column_major] = ACTIONS(5556),
    [anon_sym_globallycoherent] = ACTIONS(5556),
    [anon_sym_centroid] = ACTIONS(5556),
    [anon_sym_noperspective] = ACTIONS(5556),
    [anon_sym_nointerpolation] = ACTIONS(5556),
    [anon_sym_sample] = ACTIONS(5556),
    [anon_sym_linear] = ACTIONS(5556),
    [anon_sym_snorm] = ACTIONS(5556),
    [anon_sym_unorm] = ACTIONS(5556),
    [anon_sym_point] = ACTIONS(5556),
    [anon_sym_line] = ACTIONS(5556),
    [anon_sym_triangleadj] = ACTIONS(5556),
    [anon_sym_lineadj] = ACTIONS(5556),
    [anon_sym_triangle] = ACTIONS(5556),
    [anon_sym_interface] = ACTIONS(5556),
    [anon_sym_extension] = ACTIONS(5556),
    [anon_sym___init] = ACTIONS(5556),
    [anon_sym___subscript] = ACTIONS(5556),
    [anon_sym_property] = ACTIONS(5556),
    [anon_sym_associatedtype] = ACTIONS(5556),
  },
  [2559] = {
    [sym_expression] = STATE(5352),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4425),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4425),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4425),
    [sym_identifier] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(5787),
    [anon_sym_BANG] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(5783),
    [anon_sym_AMP] = ACTIONS(5783),
    [anon_sym_COLON_COLON] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4972),
    [anon_sym_compl] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_sizeof] = ACTIONS(4978),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4980),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2560] = {
    [sym_expression] = STATE(3732),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(4134),
    [sym_concatenated_string] = STATE(4159),
    [sym_string_literal] = STATE(3152),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(3145),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4587),
    [anon_sym_LPAREN2] = ACTIONS(5819),
    [anon_sym_BANG] = ACTIONS(4591),
    [anon_sym_TILDE] = ACTIONS(4591),
    [anon_sym_DASH] = ACTIONS(4589),
    [anon_sym_PLUS] = ACTIONS(4589),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4593),
    [anon_sym_LBRACK] = ACTIONS(6130),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4589),
    [anon_sym_compl] = ACTIONS(4589),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_sizeof] = ACTIONS(4595),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4597),
    [anon_sym_L_SQUOTE] = ACTIONS(4599),
    [anon_sym_u_SQUOTE] = ACTIONS(4599),
    [anon_sym_U_SQUOTE] = ACTIONS(4599),
    [anon_sym_u8_SQUOTE] = ACTIONS(4599),
    [anon_sym_SQUOTE] = ACTIONS(4599),
    [anon_sym_L_DQUOTE] = ACTIONS(4601),
    [anon_sym_u_DQUOTE] = ACTIONS(4601),
    [anon_sym_U_DQUOTE] = ACTIONS(4601),
    [anon_sym_u8_DQUOTE] = ACTIONS(4601),
    [anon_sym_DQUOTE] = ACTIONS(4601),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4603),
    [anon_sym_R_DQUOTE] = ACTIONS(4605),
    [anon_sym_LR_DQUOTE] = ACTIONS(4605),
    [anon_sym_uR_DQUOTE] = ACTIONS(4605),
    [anon_sym_UR_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4605),
    [anon_sym_co_await] = ACTIONS(4607),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2561] = {
    [sym_identifier] = ACTIONS(5646),
    [aux_sym_preproc_def_token1] = ACTIONS(5646),
    [aux_sym_preproc_if_token1] = ACTIONS(5646),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5646),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5646),
    [sym_preproc_directive] = ACTIONS(5646),
    [anon_sym_LPAREN2] = ACTIONS(5648),
    [anon_sym_TILDE] = ACTIONS(5648),
    [anon_sym_STAR] = ACTIONS(5648),
    [anon_sym_AMP_AMP] = ACTIONS(5648),
    [anon_sym_AMP] = ACTIONS(5646),
    [anon_sym___extension__] = ACTIONS(5646),
    [anon_sym_typedef] = ACTIONS(5646),
    [anon_sym_in] = ACTIONS(5646),
    [anon_sym_out] = ACTIONS(5646),
    [anon_sym_inout] = ACTIONS(5646),
    [anon_sym_extern] = ACTIONS(5646),
    [anon_sym___attribute__] = ACTIONS(5646),
    [anon_sym_COLON_COLON] = ACTIONS(5648),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5648),
    [anon_sym___declspec] = ACTIONS(5646),
    [anon_sym___based] = ACTIONS(5646),
    [anon_sym_RBRACE] = ACTIONS(5648),
    [anon_sym_signed] = ACTIONS(5646),
    [anon_sym_unsigned] = ACTIONS(5646),
    [anon_sym_long] = ACTIONS(5646),
    [anon_sym_short] = ACTIONS(5646),
    [anon_sym_LBRACK] = ACTIONS(5646),
    [anon_sym_static] = ACTIONS(5646),
    [anon_sym_register] = ACTIONS(5646),
    [anon_sym_inline] = ACTIONS(5646),
    [anon_sym___inline] = ACTIONS(5646),
    [anon_sym___inline__] = ACTIONS(5646),
    [anon_sym___forceinline] = ACTIONS(5646),
    [anon_sym_thread_local] = ACTIONS(5646),
    [anon_sym___thread] = ACTIONS(5646),
    [anon_sym_const] = ACTIONS(5646),
    [anon_sym_constexpr] = ACTIONS(5646),
    [anon_sym_volatile] = ACTIONS(5646),
    [anon_sym_restrict] = ACTIONS(5646),
    [anon_sym___restrict__] = ACTIONS(5646),
    [anon_sym__Atomic] = ACTIONS(5646),
    [anon_sym__Noreturn] = ACTIONS(5646),
    [anon_sym_noreturn] = ACTIONS(5646),
    [anon_sym_mutable] = ACTIONS(5646),
    [anon_sym_constinit] = ACTIONS(5646),
    [anon_sym_consteval] = ACTIONS(5646),
    [anon_sym_alignas] = ACTIONS(5646),
    [anon_sym__Alignas] = ACTIONS(5646),
    [sym_primitive_type] = ACTIONS(5646),
    [anon_sym_enum] = ACTIONS(5646),
    [anon_sym_class] = ACTIONS(5646),
    [anon_sym_struct] = ACTIONS(5646),
    [anon_sym_union] = ACTIONS(5646),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5646),
    [anon_sym_let] = ACTIONS(5646),
    [anon_sym_This] = ACTIONS(5646),
    [anon_sym_decltype] = ACTIONS(5646),
    [sym_virtual] = ACTIONS(5646),
    [anon_sym_explicit] = ACTIONS(5646),
    [anon_sym_typename] = ACTIONS(5646),
    [anon_sym_template] = ACTIONS(5646),
    [anon_sym_operator] = ACTIONS(5646),
    [anon_sym_friend] = ACTIONS(5646),
    [anon_sym_public] = ACTIONS(5646),
    [anon_sym_private] = ACTIONS(5646),
    [anon_sym_protected] = ACTIONS(5646),
    [anon_sym_using] = ACTIONS(5646),
    [anon_sym_static_assert] = ACTIONS(5646),
    [anon_sym_precise] = ACTIONS(5646),
    [anon_sym_shared] = ACTIONS(5646),
    [anon_sym_groupshared] = ACTIONS(5646),
    [anon_sym_uniform] = ACTIONS(5646),
    [anon_sym_row_major] = ACTIONS(5646),
    [anon_sym_column_major] = ACTIONS(5646),
    [anon_sym_globallycoherent] = ACTIONS(5646),
    [anon_sym_centroid] = ACTIONS(5646),
    [anon_sym_noperspective] = ACTIONS(5646),
    [anon_sym_nointerpolation] = ACTIONS(5646),
    [anon_sym_sample] = ACTIONS(5646),
    [anon_sym_linear] = ACTIONS(5646),
    [anon_sym_snorm] = ACTIONS(5646),
    [anon_sym_unorm] = ACTIONS(5646),
    [anon_sym_point] = ACTIONS(5646),
    [anon_sym_line] = ACTIONS(5646),
    [anon_sym_triangleadj] = ACTIONS(5646),
    [anon_sym_lineadj] = ACTIONS(5646),
    [anon_sym_triangle] = ACTIONS(5646),
    [anon_sym_interface] = ACTIONS(5646),
    [anon_sym_extension] = ACTIONS(5646),
    [anon_sym___init] = ACTIONS(5646),
    [anon_sym___subscript] = ACTIONS(5646),
    [anon_sym_property] = ACTIONS(5646),
    [anon_sym_associatedtype] = ACTIONS(5646),
  },
  [2562] = {
    [sym_expression] = STATE(3229),
    [sym__string] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3335),
    [sym_unary_expression] = STATE(3316),
    [sym_binary_expression] = STATE(3316),
    [sym_update_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_alignof_expression] = STATE(3316),
    [sym_offsetof_expression] = STATE(3316),
    [sym_generic_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3335),
    [sym_call_expression] = STATE(3335),
    [sym_gnu_asm_expression] = STATE(3316),
    [sym_field_expression] = STATE(3335),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3335),
    [sym_char_literal] = STATE(4134),
    [sym_concatenated_string] = STATE(4159),
    [sym_string_literal] = STATE(3152),
    [sym_null] = STATE(3316),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9776),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(3316),
    [sym_raw_string_literal] = STATE(3145),
    [sym_co_await_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_requires_clause] = STATE(3316),
    [sym_requires_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(7066),
    [sym_fold_expression] = STATE(3316),
    [sym_parameter_pack_expansion] = STATE(3316),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(3335),
    [sym_qualified_type_identifier] = STATE(9776),
    [sym_user_defined_literal] = STATE(3335),
    [sym_identifier] = ACTIONS(4587),
    [anon_sym_LPAREN2] = ACTIONS(5819),
    [anon_sym_BANG] = ACTIONS(4591),
    [anon_sym_TILDE] = ACTIONS(4591),
    [anon_sym_DASH] = ACTIONS(4589),
    [anon_sym_PLUS] = ACTIONS(4589),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(4593),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_not] = ACTIONS(4589),
    [anon_sym_compl] = ACTIONS(4589),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_sizeof] = ACTIONS(4595),
    [anon_sym___alignof__] = ACTIONS(4424),
    [anon_sym___alignof] = ACTIONS(4424),
    [anon_sym__alignof] = ACTIONS(4424),
    [anon_sym_alignof] = ACTIONS(4424),
    [anon_sym__Alignof] = ACTIONS(4424),
    [anon_sym_offsetof] = ACTIONS(4426),
    [anon_sym__Generic] = ACTIONS(4428),
    [anon_sym_asm] = ACTIONS(4430),
    [anon_sym___asm__] = ACTIONS(4430),
    [sym_number_literal] = ACTIONS(4597),
    [anon_sym_L_SQUOTE] = ACTIONS(4599),
    [anon_sym_u_SQUOTE] = ACTIONS(4599),
    [anon_sym_U_SQUOTE] = ACTIONS(4599),
    [anon_sym_u8_SQUOTE] = ACTIONS(4599),
    [anon_sym_SQUOTE] = ACTIONS(4599),
    [anon_sym_L_DQUOTE] = ACTIONS(4601),
    [anon_sym_u_DQUOTE] = ACTIONS(4601),
    [anon_sym_U_DQUOTE] = ACTIONS(4601),
    [anon_sym_u8_DQUOTE] = ACTIONS(4601),
    [anon_sym_DQUOTE] = ACTIONS(4601),
    [sym_true] = ACTIONS(4438),
    [sym_false] = ACTIONS(4438),
    [anon_sym_NULL] = ACTIONS(4440),
    [anon_sym_nullptr] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4603),
    [anon_sym_R_DQUOTE] = ACTIONS(4605),
    [anon_sym_LR_DQUOTE] = ACTIONS(4605),
    [anon_sym_uR_DQUOTE] = ACTIONS(4605),
    [anon_sym_UR_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4605),
    [anon_sym_co_await] = ACTIONS(4607),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4450),
    [sym_this] = ACTIONS(4438),
  },
  [2563] = {
    [sym_identifier] = ACTIONS(5650),
    [aux_sym_preproc_def_token1] = ACTIONS(5650),
    [aux_sym_preproc_if_token1] = ACTIONS(5650),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5650),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5650),
    [sym_preproc_directive] = ACTIONS(5650),
    [anon_sym_LPAREN2] = ACTIONS(5652),
    [anon_sym_TILDE] = ACTIONS(5652),
    [anon_sym_STAR] = ACTIONS(5652),
    [anon_sym_AMP_AMP] = ACTIONS(5652),
    [anon_sym_AMP] = ACTIONS(5650),
    [anon_sym___extension__] = ACTIONS(5650),
    [anon_sym_typedef] = ACTIONS(5650),
    [anon_sym_in] = ACTIONS(5650),
    [anon_sym_out] = ACTIONS(5650),
    [anon_sym_inout] = ACTIONS(5650),
    [anon_sym_extern] = ACTIONS(5650),
    [anon_sym___attribute__] = ACTIONS(5650),
    [anon_sym_COLON_COLON] = ACTIONS(5652),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5652),
    [anon_sym___declspec] = ACTIONS(5650),
    [anon_sym___based] = ACTIONS(5650),
    [anon_sym_RBRACE] = ACTIONS(5652),
    [anon_sym_signed] = ACTIONS(5650),
    [anon_sym_unsigned] = ACTIONS(5650),
    [anon_sym_long] = ACTIONS(5650),
    [anon_sym_short] = ACTIONS(5650),
    [anon_sym_LBRACK] = ACTIONS(5650),
    [anon_sym_static] = ACTIONS(5650),
    [anon_sym_register] = ACTIONS(5650),
    [anon_sym_inline] = ACTIONS(5650),
    [anon_sym___inline] = ACTIONS(5650),
    [anon_sym___inline__] = ACTIONS(5650),
    [anon_sym___forceinline] = ACTIONS(5650),
    [anon_sym_thread_local] = ACTIONS(5650),
    [anon_sym___thread] = ACTIONS(5650),
    [anon_sym_const] = ACTIONS(5650),
    [anon_sym_constexpr] = ACTIONS(5650),
    [anon_sym_volatile] = ACTIONS(5650),
    [anon_sym_restrict] = ACTIONS(5650),
    [anon_sym___restrict__] = ACTIONS(5650),
    [anon_sym__Atomic] = ACTIONS(5650),
    [anon_sym__Noreturn] = ACTIONS(5650),
    [anon_sym_noreturn] = ACTIONS(5650),
    [anon_sym_mutable] = ACTIONS(5650),
    [anon_sym_constinit] = ACTIONS(5650),
    [anon_sym_consteval] = ACTIONS(5650),
    [anon_sym_alignas] = ACTIONS(5650),
    [anon_sym__Alignas] = ACTIONS(5650),
    [sym_primitive_type] = ACTIONS(5650),
    [anon_sym_enum] = ACTIONS(5650),
    [anon_sym_class] = ACTIONS(5650),
    [anon_sym_struct] = ACTIONS(5650),
    [anon_sym_union] = ACTIONS(5650),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5650),
    [anon_sym_let] = ACTIONS(5650),
    [anon_sym_This] = ACTIONS(5650),
    [anon_sym_decltype] = ACTIONS(5650),
    [sym_virtual] = ACTIONS(5650),
    [anon_sym_explicit] = ACTIONS(5650),
    [anon_sym_typename] = ACTIONS(5650),
    [anon_sym_template] = ACTIONS(5650),
    [anon_sym_operator] = ACTIONS(5650),
    [anon_sym_friend] = ACTIONS(5650),
    [anon_sym_public] = ACTIONS(5650),
    [anon_sym_private] = ACTIONS(5650),
    [anon_sym_protected] = ACTIONS(5650),
    [anon_sym_using] = ACTIONS(5650),
    [anon_sym_static_assert] = ACTIONS(5650),
    [anon_sym_precise] = ACTIONS(5650),
    [anon_sym_shared] = ACTIONS(5650),
    [anon_sym_groupshared] = ACTIONS(5650),
    [anon_sym_uniform] = ACTIONS(5650),
    [anon_sym_row_major] = ACTIONS(5650),
    [anon_sym_column_major] = ACTIONS(5650),
    [anon_sym_globallycoherent] = ACTIONS(5650),
    [anon_sym_centroid] = ACTIONS(5650),
    [anon_sym_noperspective] = ACTIONS(5650),
    [anon_sym_nointerpolation] = ACTIONS(5650),
    [anon_sym_sample] = ACTIONS(5650),
    [anon_sym_linear] = ACTIONS(5650),
    [anon_sym_snorm] = ACTIONS(5650),
    [anon_sym_unorm] = ACTIONS(5650),
    [anon_sym_point] = ACTIONS(5650),
    [anon_sym_line] = ACTIONS(5650),
    [anon_sym_triangleadj] = ACTIONS(5650),
    [anon_sym_lineadj] = ACTIONS(5650),
    [anon_sym_triangle] = ACTIONS(5650),
    [anon_sym_interface] = ACTIONS(5650),
    [anon_sym_extension] = ACTIONS(5650),
    [anon_sym___init] = ACTIONS(5650),
    [anon_sym___subscript] = ACTIONS(5650),
    [anon_sym_property] = ACTIONS(5650),
    [anon_sym_associatedtype] = ACTIONS(5650),
  },
  [2564] = {
    [sym_identifier] = ACTIONS(3665),
    [aux_sym_preproc_def_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token2] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3665),
    [sym_preproc_directive] = ACTIONS(3665),
    [anon_sym_LPAREN2] = ACTIONS(3667),
    [anon_sym_TILDE] = ACTIONS(3667),
    [anon_sym_STAR] = ACTIONS(3667),
    [anon_sym_AMP_AMP] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym___extension__] = ACTIONS(3665),
    [anon_sym_typedef] = ACTIONS(3665),
    [anon_sym_in] = ACTIONS(3665),
    [anon_sym_out] = ACTIONS(3665),
    [anon_sym_inout] = ACTIONS(3665),
    [anon_sym_extern] = ACTIONS(3665),
    [anon_sym___attribute__] = ACTIONS(3665),
    [anon_sym_COLON_COLON] = ACTIONS(3667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3667),
    [anon_sym___declspec] = ACTIONS(3665),
    [anon_sym___based] = ACTIONS(3665),
    [anon_sym_signed] = ACTIONS(3665),
    [anon_sym_unsigned] = ACTIONS(3665),
    [anon_sym_long] = ACTIONS(3665),
    [anon_sym_short] = ACTIONS(3665),
    [anon_sym_LBRACK] = ACTIONS(3665),
    [anon_sym_static] = ACTIONS(3665),
    [anon_sym_register] = ACTIONS(3665),
    [anon_sym_inline] = ACTIONS(3665),
    [anon_sym___inline] = ACTIONS(3665),
    [anon_sym___inline__] = ACTIONS(3665),
    [anon_sym___forceinline] = ACTIONS(3665),
    [anon_sym_thread_local] = ACTIONS(3665),
    [anon_sym___thread] = ACTIONS(3665),
    [anon_sym_const] = ACTIONS(3665),
    [anon_sym_constexpr] = ACTIONS(3665),
    [anon_sym_volatile] = ACTIONS(3665),
    [anon_sym_restrict] = ACTIONS(3665),
    [anon_sym___restrict__] = ACTIONS(3665),
    [anon_sym__Atomic] = ACTIONS(3665),
    [anon_sym__Noreturn] = ACTIONS(3665),
    [anon_sym_noreturn] = ACTIONS(3665),
    [anon_sym_mutable] = ACTIONS(3665),
    [anon_sym_constinit] = ACTIONS(3665),
    [anon_sym_consteval] = ACTIONS(3665),
    [anon_sym_alignas] = ACTIONS(3665),
    [anon_sym__Alignas] = ACTIONS(3665),
    [sym_primitive_type] = ACTIONS(3665),
    [anon_sym_enum] = ACTIONS(3665),
    [anon_sym_class] = ACTIONS(3665),
    [anon_sym_struct] = ACTIONS(3665),
    [anon_sym_union] = ACTIONS(3665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3665),
    [anon_sym_let] = ACTIONS(3665),
    [anon_sym_This] = ACTIONS(3665),
    [anon_sym_decltype] = ACTIONS(3665),
    [sym_virtual] = ACTIONS(3665),
    [anon_sym_explicit] = ACTIONS(3665),
    [anon_sym_typename] = ACTIONS(3665),
    [anon_sym_template] = ACTIONS(3665),
    [anon_sym_operator] = ACTIONS(3665),
    [anon_sym_friend] = ACTIONS(3665),
    [anon_sym_public] = ACTIONS(3665),
    [anon_sym_private] = ACTIONS(3665),
    [anon_sym_protected] = ACTIONS(3665),
    [anon_sym_using] = ACTIONS(3665),
    [anon_sym_static_assert] = ACTIONS(3665),
    [anon_sym_precise] = ACTIONS(3665),
    [anon_sym_shared] = ACTIONS(3665),
    [anon_sym_groupshared] = ACTIONS(3665),
    [anon_sym_uniform] = ACTIONS(3665),
    [anon_sym_row_major] = ACTIONS(3665),
    [anon_sym_column_major] = ACTIONS(3665),
    [anon_sym_globallycoherent] = ACTIONS(3665),
    [anon_sym_centroid] = ACTIONS(3665),
    [anon_sym_noperspective] = ACTIONS(3665),
    [anon_sym_nointerpolation] = ACTIONS(3665),
    [anon_sym_sample] = ACTIONS(3665),
    [anon_sym_linear] = ACTIONS(3665),
    [anon_sym_snorm] = ACTIONS(3665),
    [anon_sym_unorm] = ACTIONS(3665),
    [anon_sym_point] = ACTIONS(3665),
    [anon_sym_line] = ACTIONS(3665),
    [anon_sym_triangleadj] = ACTIONS(3665),
    [anon_sym_lineadj] = ACTIONS(3665),
    [anon_sym_triangle] = ACTIONS(3665),
    [anon_sym_interface] = ACTIONS(3665),
    [anon_sym_extension] = ACTIONS(3665),
    [anon_sym___init] = ACTIONS(3665),
    [anon_sym___subscript] = ACTIONS(3665),
    [anon_sym_property] = ACTIONS(3665),
    [anon_sym_associatedtype] = ACTIONS(3665),
  },
  [2565] = {
    [sym_identifier] = ACTIONS(3665),
    [aux_sym_preproc_def_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token2] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3665),
    [sym_preproc_directive] = ACTIONS(3665),
    [anon_sym_LPAREN2] = ACTIONS(3667),
    [anon_sym_TILDE] = ACTIONS(3667),
    [anon_sym_STAR] = ACTIONS(3667),
    [anon_sym_AMP_AMP] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym___extension__] = ACTIONS(3665),
    [anon_sym_typedef] = ACTIONS(3665),
    [anon_sym_in] = ACTIONS(3665),
    [anon_sym_out] = ACTIONS(3665),
    [anon_sym_inout] = ACTIONS(3665),
    [anon_sym_extern] = ACTIONS(3665),
    [anon_sym___attribute__] = ACTIONS(3665),
    [anon_sym_COLON_COLON] = ACTIONS(3667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3667),
    [anon_sym___declspec] = ACTIONS(3665),
    [anon_sym___based] = ACTIONS(3665),
    [anon_sym_signed] = ACTIONS(3665),
    [anon_sym_unsigned] = ACTIONS(3665),
    [anon_sym_long] = ACTIONS(3665),
    [anon_sym_short] = ACTIONS(3665),
    [anon_sym_LBRACK] = ACTIONS(3665),
    [anon_sym_static] = ACTIONS(3665),
    [anon_sym_register] = ACTIONS(3665),
    [anon_sym_inline] = ACTIONS(3665),
    [anon_sym___inline] = ACTIONS(3665),
    [anon_sym___inline__] = ACTIONS(3665),
    [anon_sym___forceinline] = ACTIONS(3665),
    [anon_sym_thread_local] = ACTIONS(3665),
    [anon_sym___thread] = ACTIONS(3665),
    [anon_sym_const] = ACTIONS(3665),
    [anon_sym_constexpr] = ACTIONS(3665),
    [anon_sym_volatile] = ACTIONS(3665),
    [anon_sym_restrict] = ACTIONS(3665),
    [anon_sym___restrict__] = ACTIONS(3665),
    [anon_sym__Atomic] = ACTIONS(3665),
    [anon_sym__Noreturn] = ACTIONS(3665),
    [anon_sym_noreturn] = ACTIONS(3665),
    [anon_sym_mutable] = ACTIONS(3665),
    [anon_sym_constinit] = ACTIONS(3665),
    [anon_sym_consteval] = ACTIONS(3665),
    [anon_sym_alignas] = ACTIONS(3665),
    [anon_sym__Alignas] = ACTIONS(3665),
    [sym_primitive_type] = ACTIONS(3665),
    [anon_sym_enum] = ACTIONS(3665),
    [anon_sym_class] = ACTIONS(3665),
    [anon_sym_struct] = ACTIONS(3665),
    [anon_sym_union] = ACTIONS(3665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3665),
    [anon_sym_let] = ACTIONS(3665),
    [anon_sym_This] = ACTIONS(3665),
    [anon_sym_decltype] = ACTIONS(3665),
    [sym_virtual] = ACTIONS(3665),
    [anon_sym_explicit] = ACTIONS(3665),
    [anon_sym_typename] = ACTIONS(3665),
    [anon_sym_template] = ACTIONS(3665),
    [anon_sym_operator] = ACTIONS(3665),
    [anon_sym_friend] = ACTIONS(3665),
    [anon_sym_public] = ACTIONS(3665),
    [anon_sym_private] = ACTIONS(3665),
    [anon_sym_protected] = ACTIONS(3665),
    [anon_sym_using] = ACTIONS(3665),
    [anon_sym_static_assert] = ACTIONS(3665),
    [anon_sym_precise] = ACTIONS(3665),
    [anon_sym_shared] = ACTIONS(3665),
    [anon_sym_groupshared] = ACTIONS(3665),
    [anon_sym_uniform] = ACTIONS(3665),
    [anon_sym_row_major] = ACTIONS(3665),
    [anon_sym_column_major] = ACTIONS(3665),
    [anon_sym_globallycoherent] = ACTIONS(3665),
    [anon_sym_centroid] = ACTIONS(3665),
    [anon_sym_noperspective] = ACTIONS(3665),
    [anon_sym_nointerpolation] = ACTIONS(3665),
    [anon_sym_sample] = ACTIONS(3665),
    [anon_sym_linear] = ACTIONS(3665),
    [anon_sym_snorm] = ACTIONS(3665),
    [anon_sym_unorm] = ACTIONS(3665),
    [anon_sym_point] = ACTIONS(3665),
    [anon_sym_line] = ACTIONS(3665),
    [anon_sym_triangleadj] = ACTIONS(3665),
    [anon_sym_lineadj] = ACTIONS(3665),
    [anon_sym_triangle] = ACTIONS(3665),
    [anon_sym_interface] = ACTIONS(3665),
    [anon_sym_extension] = ACTIONS(3665),
    [anon_sym___init] = ACTIONS(3665),
    [anon_sym___subscript] = ACTIONS(3665),
    [anon_sym_property] = ACTIONS(3665),
    [anon_sym_associatedtype] = ACTIONS(3665),
  },
  [2566] = {
    [sym_identifier] = ACTIONS(5464),
    [aux_sym_preproc_def_token1] = ACTIONS(5464),
    [aux_sym_preproc_if_token1] = ACTIONS(5464),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5464),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5464),
    [sym_preproc_directive] = ACTIONS(5464),
    [anon_sym_LPAREN2] = ACTIONS(5466),
    [anon_sym_TILDE] = ACTIONS(5466),
    [anon_sym_STAR] = ACTIONS(5466),
    [anon_sym_AMP_AMP] = ACTIONS(5466),
    [anon_sym_AMP] = ACTIONS(5464),
    [anon_sym___extension__] = ACTIONS(5464),
    [anon_sym_typedef] = ACTIONS(5464),
    [anon_sym_in] = ACTIONS(5464),
    [anon_sym_out] = ACTIONS(5464),
    [anon_sym_inout] = ACTIONS(5464),
    [anon_sym_extern] = ACTIONS(5464),
    [anon_sym___attribute__] = ACTIONS(5464),
    [anon_sym_COLON_COLON] = ACTIONS(5466),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5466),
    [anon_sym___declspec] = ACTIONS(5464),
    [anon_sym___based] = ACTIONS(5464),
    [anon_sym_RBRACE] = ACTIONS(5466),
    [anon_sym_signed] = ACTIONS(5464),
    [anon_sym_unsigned] = ACTIONS(5464),
    [anon_sym_long] = ACTIONS(5464),
    [anon_sym_short] = ACTIONS(5464),
    [anon_sym_LBRACK] = ACTIONS(5464),
    [anon_sym_static] = ACTIONS(5464),
    [anon_sym_register] = ACTIONS(5464),
    [anon_sym_inline] = ACTIONS(5464),
    [anon_sym___inline] = ACTIONS(5464),
    [anon_sym___inline__] = ACTIONS(5464),
    [anon_sym___forceinline] = ACTIONS(5464),
    [anon_sym_thread_local] = ACTIONS(5464),
    [anon_sym___thread] = ACTIONS(5464),
    [anon_sym_const] = ACTIONS(5464),
    [anon_sym_constexpr] = ACTIONS(5464),
    [anon_sym_volatile] = ACTIONS(5464),
    [anon_sym_restrict] = ACTIONS(5464),
    [anon_sym___restrict__] = ACTIONS(5464),
    [anon_sym__Atomic] = ACTIONS(5464),
    [anon_sym__Noreturn] = ACTIONS(5464),
    [anon_sym_noreturn] = ACTIONS(5464),
    [anon_sym_mutable] = ACTIONS(5464),
    [anon_sym_constinit] = ACTIONS(5464),
    [anon_sym_consteval] = ACTIONS(5464),
    [anon_sym_alignas] = ACTIONS(5464),
    [anon_sym__Alignas] = ACTIONS(5464),
    [sym_primitive_type] = ACTIONS(5464),
    [anon_sym_enum] = ACTIONS(5464),
    [anon_sym_class] = ACTIONS(5464),
    [anon_sym_struct] = ACTIONS(5464),
    [anon_sym_union] = ACTIONS(5464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5464),
    [anon_sym_let] = ACTIONS(5464),
    [anon_sym_This] = ACTIONS(5464),
    [anon_sym_decltype] = ACTIONS(5464),
    [sym_virtual] = ACTIONS(5464),
    [anon_sym_explicit] = ACTIONS(5464),
    [anon_sym_typename] = ACTIONS(5464),
    [anon_sym_template] = ACTIONS(5464),
    [anon_sym_operator] = ACTIONS(5464),
    [anon_sym_friend] = ACTIONS(5464),
    [anon_sym_public] = ACTIONS(5464),
    [anon_sym_private] = ACTIONS(5464),
    [anon_sym_protected] = ACTIONS(5464),
    [anon_sym_using] = ACTIONS(5464),
    [anon_sym_static_assert] = ACTIONS(5464),
    [anon_sym_precise] = ACTIONS(5464),
    [anon_sym_shared] = ACTIONS(5464),
    [anon_sym_groupshared] = ACTIONS(5464),
    [anon_sym_uniform] = ACTIONS(5464),
    [anon_sym_row_major] = ACTIONS(5464),
    [anon_sym_column_major] = ACTIONS(5464),
    [anon_sym_globallycoherent] = ACTIONS(5464),
    [anon_sym_centroid] = ACTIONS(5464),
    [anon_sym_noperspective] = ACTIONS(5464),
    [anon_sym_nointerpolation] = ACTIONS(5464),
    [anon_sym_sample] = ACTIONS(5464),
    [anon_sym_linear] = ACTIONS(5464),
    [anon_sym_snorm] = ACTIONS(5464),
    [anon_sym_unorm] = ACTIONS(5464),
    [anon_sym_point] = ACTIONS(5464),
    [anon_sym_line] = ACTIONS(5464),
    [anon_sym_triangleadj] = ACTIONS(5464),
    [anon_sym_lineadj] = ACTIONS(5464),
    [anon_sym_triangle] = ACTIONS(5464),
    [anon_sym_interface] = ACTIONS(5464),
    [anon_sym_extension] = ACTIONS(5464),
    [anon_sym___init] = ACTIONS(5464),
    [anon_sym___subscript] = ACTIONS(5464),
    [anon_sym_property] = ACTIONS(5464),
    [anon_sym_associatedtype] = ACTIONS(5464),
  },
  [2567] = {
    [sym_identifier] = ACTIONS(5464),
    [aux_sym_preproc_def_token1] = ACTIONS(5464),
    [aux_sym_preproc_if_token1] = ACTIONS(5464),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5464),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5464),
    [sym_preproc_directive] = ACTIONS(5464),
    [anon_sym_LPAREN2] = ACTIONS(5466),
    [anon_sym_TILDE] = ACTIONS(5466),
    [anon_sym_STAR] = ACTIONS(5466),
    [anon_sym_AMP_AMP] = ACTIONS(5466),
    [anon_sym_AMP] = ACTIONS(5464),
    [anon_sym___extension__] = ACTIONS(5464),
    [anon_sym_typedef] = ACTIONS(5464),
    [anon_sym_in] = ACTIONS(5464),
    [anon_sym_out] = ACTIONS(5464),
    [anon_sym_inout] = ACTIONS(5464),
    [anon_sym_extern] = ACTIONS(5464),
    [anon_sym___attribute__] = ACTIONS(5464),
    [anon_sym_COLON_COLON] = ACTIONS(5466),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5466),
    [anon_sym___declspec] = ACTIONS(5464),
    [anon_sym___based] = ACTIONS(5464),
    [anon_sym_RBRACE] = ACTIONS(5466),
    [anon_sym_signed] = ACTIONS(5464),
    [anon_sym_unsigned] = ACTIONS(5464),
    [anon_sym_long] = ACTIONS(5464),
    [anon_sym_short] = ACTIONS(5464),
    [anon_sym_LBRACK] = ACTIONS(5464),
    [anon_sym_static] = ACTIONS(5464),
    [anon_sym_register] = ACTIONS(5464),
    [anon_sym_inline] = ACTIONS(5464),
    [anon_sym___inline] = ACTIONS(5464),
    [anon_sym___inline__] = ACTIONS(5464),
    [anon_sym___forceinline] = ACTIONS(5464),
    [anon_sym_thread_local] = ACTIONS(5464),
    [anon_sym___thread] = ACTIONS(5464),
    [anon_sym_const] = ACTIONS(5464),
    [anon_sym_constexpr] = ACTIONS(5464),
    [anon_sym_volatile] = ACTIONS(5464),
    [anon_sym_restrict] = ACTIONS(5464),
    [anon_sym___restrict__] = ACTIONS(5464),
    [anon_sym__Atomic] = ACTIONS(5464),
    [anon_sym__Noreturn] = ACTIONS(5464),
    [anon_sym_noreturn] = ACTIONS(5464),
    [anon_sym_mutable] = ACTIONS(5464),
    [anon_sym_constinit] = ACTIONS(5464),
    [anon_sym_consteval] = ACTIONS(5464),
    [anon_sym_alignas] = ACTIONS(5464),
    [anon_sym__Alignas] = ACTIONS(5464),
    [sym_primitive_type] = ACTIONS(5464),
    [anon_sym_enum] = ACTIONS(5464),
    [anon_sym_class] = ACTIONS(5464),
    [anon_sym_struct] = ACTIONS(5464),
    [anon_sym_union] = ACTIONS(5464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5464),
    [anon_sym_let] = ACTIONS(5464),
    [anon_sym_This] = ACTIONS(5464),
    [anon_sym_decltype] = ACTIONS(5464),
    [sym_virtual] = ACTIONS(5464),
    [anon_sym_explicit] = ACTIONS(5464),
    [anon_sym_typename] = ACTIONS(5464),
    [anon_sym_template] = ACTIONS(5464),
    [anon_sym_operator] = ACTIONS(5464),
    [anon_sym_friend] = ACTIONS(5464),
    [anon_sym_public] = ACTIONS(5464),
    [anon_sym_private] = ACTIONS(5464),
    [anon_sym_protected] = ACTIONS(5464),
    [anon_sym_using] = ACTIONS(5464),
    [anon_sym_static_assert] = ACTIONS(5464),
    [anon_sym_precise] = ACTIONS(5464),
    [anon_sym_shared] = ACTIONS(5464),
    [anon_sym_groupshared] = ACTIONS(5464),
    [anon_sym_uniform] = ACTIONS(5464),
    [anon_sym_row_major] = ACTIONS(5464),
    [anon_sym_column_major] = ACTIONS(5464),
    [anon_sym_globallycoherent] = ACTIONS(5464),
    [anon_sym_centroid] = ACTIONS(5464),
    [anon_sym_noperspective] = ACTIONS(5464),
    [anon_sym_nointerpolation] = ACTIONS(5464),
    [anon_sym_sample] = ACTIONS(5464),
    [anon_sym_linear] = ACTIONS(5464),
    [anon_sym_snorm] = ACTIONS(5464),
    [anon_sym_unorm] = ACTIONS(5464),
    [anon_sym_point] = ACTIONS(5464),
    [anon_sym_line] = ACTIONS(5464),
    [anon_sym_triangleadj] = ACTIONS(5464),
    [anon_sym_lineadj] = ACTIONS(5464),
    [anon_sym_triangle] = ACTIONS(5464),
    [anon_sym_interface] = ACTIONS(5464),
    [anon_sym_extension] = ACTIONS(5464),
    [anon_sym___init] = ACTIONS(5464),
    [anon_sym___subscript] = ACTIONS(5464),
    [anon_sym_property] = ACTIONS(5464),
    [anon_sym_associatedtype] = ACTIONS(5464),
  },
  [2568] = {
    [sym_identifier] = ACTIONS(3673),
    [aux_sym_preproc_def_token1] = ACTIONS(3673),
    [aux_sym_preproc_if_token1] = ACTIONS(3673),
    [aux_sym_preproc_if_token2] = ACTIONS(3673),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3673),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3673),
    [sym_preproc_directive] = ACTIONS(3673),
    [anon_sym_LPAREN2] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3673),
    [anon_sym___extension__] = ACTIONS(3673),
    [anon_sym_typedef] = ACTIONS(3673),
    [anon_sym_in] = ACTIONS(3673),
    [anon_sym_out] = ACTIONS(3673),
    [anon_sym_inout] = ACTIONS(3673),
    [anon_sym_extern] = ACTIONS(3673),
    [anon_sym___attribute__] = ACTIONS(3673),
    [anon_sym_COLON_COLON] = ACTIONS(3675),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3675),
    [anon_sym___declspec] = ACTIONS(3673),
    [anon_sym___based] = ACTIONS(3673),
    [anon_sym_signed] = ACTIONS(3673),
    [anon_sym_unsigned] = ACTIONS(3673),
    [anon_sym_long] = ACTIONS(3673),
    [anon_sym_short] = ACTIONS(3673),
    [anon_sym_LBRACK] = ACTIONS(3673),
    [anon_sym_static] = ACTIONS(3673),
    [anon_sym_register] = ACTIONS(3673),
    [anon_sym_inline] = ACTIONS(3673),
    [anon_sym___inline] = ACTIONS(3673),
    [anon_sym___inline__] = ACTIONS(3673),
    [anon_sym___forceinline] = ACTIONS(3673),
    [anon_sym_thread_local] = ACTIONS(3673),
    [anon_sym___thread] = ACTIONS(3673),
    [anon_sym_const] = ACTIONS(3673),
    [anon_sym_constexpr] = ACTIONS(3673),
    [anon_sym_volatile] = ACTIONS(3673),
    [anon_sym_restrict] = ACTIONS(3673),
    [anon_sym___restrict__] = ACTIONS(3673),
    [anon_sym__Atomic] = ACTIONS(3673),
    [anon_sym__Noreturn] = ACTIONS(3673),
    [anon_sym_noreturn] = ACTIONS(3673),
    [anon_sym_mutable] = ACTIONS(3673),
    [anon_sym_constinit] = ACTIONS(3673),
    [anon_sym_consteval] = ACTIONS(3673),
    [anon_sym_alignas] = ACTIONS(3673),
    [anon_sym__Alignas] = ACTIONS(3673),
    [sym_primitive_type] = ACTIONS(3673),
    [anon_sym_enum] = ACTIONS(3673),
    [anon_sym_class] = ACTIONS(3673),
    [anon_sym_struct] = ACTIONS(3673),
    [anon_sym_union] = ACTIONS(3673),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3673),
    [anon_sym_let] = ACTIONS(3673),
    [anon_sym_This] = ACTIONS(3673),
    [anon_sym_decltype] = ACTIONS(3673),
    [sym_virtual] = ACTIONS(3673),
    [anon_sym_explicit] = ACTIONS(3673),
    [anon_sym_typename] = ACTIONS(3673),
    [anon_sym_template] = ACTIONS(3673),
    [anon_sym_operator] = ACTIONS(3673),
    [anon_sym_friend] = ACTIONS(3673),
    [anon_sym_public] = ACTIONS(3673),
    [anon_sym_private] = ACTIONS(3673),
    [anon_sym_protected] = ACTIONS(3673),
    [anon_sym_using] = ACTIONS(3673),
    [anon_sym_static_assert] = ACTIONS(3673),
    [anon_sym_precise] = ACTIONS(3673),
    [anon_sym_shared] = ACTIONS(3673),
    [anon_sym_groupshared] = ACTIONS(3673),
    [anon_sym_uniform] = ACTIONS(3673),
    [anon_sym_row_major] = ACTIONS(3673),
    [anon_sym_column_major] = ACTIONS(3673),
    [anon_sym_globallycoherent] = ACTIONS(3673),
    [anon_sym_centroid] = ACTIONS(3673),
    [anon_sym_noperspective] = ACTIONS(3673),
    [anon_sym_nointerpolation] = ACTIONS(3673),
    [anon_sym_sample] = ACTIONS(3673),
    [anon_sym_linear] = ACTIONS(3673),
    [anon_sym_snorm] = ACTIONS(3673),
    [anon_sym_unorm] = ACTIONS(3673),
    [anon_sym_point] = ACTIONS(3673),
    [anon_sym_line] = ACTIONS(3673),
    [anon_sym_triangleadj] = ACTIONS(3673),
    [anon_sym_lineadj] = ACTIONS(3673),
    [anon_sym_triangle] = ACTIONS(3673),
    [anon_sym_interface] = ACTIONS(3673),
    [anon_sym_extension] = ACTIONS(3673),
    [anon_sym___init] = ACTIONS(3673),
    [anon_sym___subscript] = ACTIONS(3673),
    [anon_sym_property] = ACTIONS(3673),
    [anon_sym_associatedtype] = ACTIONS(3673),
  },
  [2569] = {
    [sym_identifier] = ACTIONS(3587),
    [aux_sym_preproc_def_token1] = ACTIONS(3587),
    [aux_sym_preproc_if_token1] = ACTIONS(3587),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3587),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3587),
    [sym_preproc_directive] = ACTIONS(3587),
    [anon_sym_LPAREN2] = ACTIONS(3589),
    [anon_sym_TILDE] = ACTIONS(3589),
    [anon_sym_STAR] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3587),
    [anon_sym___extension__] = ACTIONS(3587),
    [anon_sym_typedef] = ACTIONS(3587),
    [anon_sym_in] = ACTIONS(3587),
    [anon_sym_out] = ACTIONS(3587),
    [anon_sym_inout] = ACTIONS(3587),
    [anon_sym_extern] = ACTIONS(3587),
    [anon_sym___attribute__] = ACTIONS(3587),
    [anon_sym_COLON_COLON] = ACTIONS(3589),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3589),
    [anon_sym___declspec] = ACTIONS(3587),
    [anon_sym___based] = ACTIONS(3587),
    [anon_sym_RBRACE] = ACTIONS(3589),
    [anon_sym_signed] = ACTIONS(3587),
    [anon_sym_unsigned] = ACTIONS(3587),
    [anon_sym_long] = ACTIONS(3587),
    [anon_sym_short] = ACTIONS(3587),
    [anon_sym_LBRACK] = ACTIONS(3587),
    [anon_sym_static] = ACTIONS(3587),
    [anon_sym_register] = ACTIONS(3587),
    [anon_sym_inline] = ACTIONS(3587),
    [anon_sym___inline] = ACTIONS(3587),
    [anon_sym___inline__] = ACTIONS(3587),
    [anon_sym___forceinline] = ACTIONS(3587),
    [anon_sym_thread_local] = ACTIONS(3587),
    [anon_sym___thread] = ACTIONS(3587),
    [anon_sym_const] = ACTIONS(3587),
    [anon_sym_constexpr] = ACTIONS(3587),
    [anon_sym_volatile] = ACTIONS(3587),
    [anon_sym_restrict] = ACTIONS(3587),
    [anon_sym___restrict__] = ACTIONS(3587),
    [anon_sym__Atomic] = ACTIONS(3587),
    [anon_sym__Noreturn] = ACTIONS(3587),
    [anon_sym_noreturn] = ACTIONS(3587),
    [anon_sym_mutable] = ACTIONS(3587),
    [anon_sym_constinit] = ACTIONS(3587),
    [anon_sym_consteval] = ACTIONS(3587),
    [anon_sym_alignas] = ACTIONS(3587),
    [anon_sym__Alignas] = ACTIONS(3587),
    [sym_primitive_type] = ACTIONS(3587),
    [anon_sym_enum] = ACTIONS(3587),
    [anon_sym_class] = ACTIONS(3587),
    [anon_sym_struct] = ACTIONS(3587),
    [anon_sym_union] = ACTIONS(3587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3587),
    [anon_sym_let] = ACTIONS(3587),
    [anon_sym_This] = ACTIONS(3587),
    [anon_sym_decltype] = ACTIONS(3587),
    [sym_virtual] = ACTIONS(3587),
    [anon_sym_explicit] = ACTIONS(3587),
    [anon_sym_typename] = ACTIONS(3587),
    [anon_sym_template] = ACTIONS(3587),
    [anon_sym_operator] = ACTIONS(3587),
    [anon_sym_friend] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3587),
    [anon_sym_private] = ACTIONS(3587),
    [anon_sym_protected] = ACTIONS(3587),
    [anon_sym_using] = ACTIONS(3587),
    [anon_sym_static_assert] = ACTIONS(3587),
    [anon_sym_precise] = ACTIONS(3587),
    [anon_sym_shared] = ACTIONS(3587),
    [anon_sym_groupshared] = ACTIONS(3587),
    [anon_sym_uniform] = ACTIONS(3587),
    [anon_sym_row_major] = ACTIONS(3587),
    [anon_sym_column_major] = ACTIONS(3587),
    [anon_sym_globallycoherent] = ACTIONS(3587),
    [anon_sym_centroid] = ACTIONS(3587),
    [anon_sym_noperspective] = ACTIONS(3587),
    [anon_sym_nointerpolation] = ACTIONS(3587),
    [anon_sym_sample] = ACTIONS(3587),
    [anon_sym_linear] = ACTIONS(3587),
    [anon_sym_snorm] = ACTIONS(3587),
    [anon_sym_unorm] = ACTIONS(3587),
    [anon_sym_point] = ACTIONS(3587),
    [anon_sym_line] = ACTIONS(3587),
    [anon_sym_triangleadj] = ACTIONS(3587),
    [anon_sym_lineadj] = ACTIONS(3587),
    [anon_sym_triangle] = ACTIONS(3587),
    [anon_sym_interface] = ACTIONS(3587),
    [anon_sym_extension] = ACTIONS(3587),
    [anon_sym___init] = ACTIONS(3587),
    [anon_sym___subscript] = ACTIONS(3587),
    [anon_sym_property] = ACTIONS(3587),
    [anon_sym_associatedtype] = ACTIONS(3587),
  },
  [2570] = {
    [sym_identifier] = ACTIONS(3605),
    [aux_sym_preproc_def_token1] = ACTIONS(3605),
    [aux_sym_preproc_if_token1] = ACTIONS(3605),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3605),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3605),
    [sym_preproc_directive] = ACTIONS(3605),
    [anon_sym_LPAREN2] = ACTIONS(3607),
    [anon_sym_TILDE] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(3607),
    [anon_sym_AMP_AMP] = ACTIONS(3607),
    [anon_sym_AMP] = ACTIONS(3605),
    [anon_sym___extension__] = ACTIONS(3605),
    [anon_sym_typedef] = ACTIONS(3605),
    [anon_sym_in] = ACTIONS(3605),
    [anon_sym_out] = ACTIONS(3605),
    [anon_sym_inout] = ACTIONS(3605),
    [anon_sym_extern] = ACTIONS(3605),
    [anon_sym___attribute__] = ACTIONS(3605),
    [anon_sym_COLON_COLON] = ACTIONS(3607),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3607),
    [anon_sym___declspec] = ACTIONS(3605),
    [anon_sym___based] = ACTIONS(3605),
    [anon_sym_RBRACE] = ACTIONS(3607),
    [anon_sym_signed] = ACTIONS(3605),
    [anon_sym_unsigned] = ACTIONS(3605),
    [anon_sym_long] = ACTIONS(3605),
    [anon_sym_short] = ACTIONS(3605),
    [anon_sym_LBRACK] = ACTIONS(3605),
    [anon_sym_static] = ACTIONS(3605),
    [anon_sym_register] = ACTIONS(3605),
    [anon_sym_inline] = ACTIONS(3605),
    [anon_sym___inline] = ACTIONS(3605),
    [anon_sym___inline__] = ACTIONS(3605),
    [anon_sym___forceinline] = ACTIONS(3605),
    [anon_sym_thread_local] = ACTIONS(3605),
    [anon_sym___thread] = ACTIONS(3605),
    [anon_sym_const] = ACTIONS(3605),
    [anon_sym_constexpr] = ACTIONS(3605),
    [anon_sym_volatile] = ACTIONS(3605),
    [anon_sym_restrict] = ACTIONS(3605),
    [anon_sym___restrict__] = ACTIONS(3605),
    [anon_sym__Atomic] = ACTIONS(3605),
    [anon_sym__Noreturn] = ACTIONS(3605),
    [anon_sym_noreturn] = ACTIONS(3605),
    [anon_sym_mutable] = ACTIONS(3605),
    [anon_sym_constinit] = ACTIONS(3605),
    [anon_sym_consteval] = ACTIONS(3605),
    [anon_sym_alignas] = ACTIONS(3605),
    [anon_sym__Alignas] = ACTIONS(3605),
    [sym_primitive_type] = ACTIONS(3605),
    [anon_sym_enum] = ACTIONS(3605),
    [anon_sym_class] = ACTIONS(3605),
    [anon_sym_struct] = ACTIONS(3605),
    [anon_sym_union] = ACTIONS(3605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3605),
    [anon_sym_let] = ACTIONS(3605),
    [anon_sym_This] = ACTIONS(3605),
    [anon_sym_decltype] = ACTIONS(3605),
    [sym_virtual] = ACTIONS(3605),
    [anon_sym_explicit] = ACTIONS(3605),
    [anon_sym_typename] = ACTIONS(3605),
    [anon_sym_template] = ACTIONS(3605),
    [anon_sym_operator] = ACTIONS(3605),
    [anon_sym_friend] = ACTIONS(3605),
    [anon_sym_public] = ACTIONS(3605),
    [anon_sym_private] = ACTIONS(3605),
    [anon_sym_protected] = ACTIONS(3605),
    [anon_sym_using] = ACTIONS(3605),
    [anon_sym_static_assert] = ACTIONS(3605),
    [anon_sym_precise] = ACTIONS(3605),
    [anon_sym_shared] = ACTIONS(3605),
    [anon_sym_groupshared] = ACTIONS(3605),
    [anon_sym_uniform] = ACTIONS(3605),
    [anon_sym_row_major] = ACTIONS(3605),
    [anon_sym_column_major] = ACTIONS(3605),
    [anon_sym_globallycoherent] = ACTIONS(3605),
    [anon_sym_centroid] = ACTIONS(3605),
    [anon_sym_noperspective] = ACTIONS(3605),
    [anon_sym_nointerpolation] = ACTIONS(3605),
    [anon_sym_sample] = ACTIONS(3605),
    [anon_sym_linear] = ACTIONS(3605),
    [anon_sym_snorm] = ACTIONS(3605),
    [anon_sym_unorm] = ACTIONS(3605),
    [anon_sym_point] = ACTIONS(3605),
    [anon_sym_line] = ACTIONS(3605),
    [anon_sym_triangleadj] = ACTIONS(3605),
    [anon_sym_lineadj] = ACTIONS(3605),
    [anon_sym_triangle] = ACTIONS(3605),
    [anon_sym_interface] = ACTIONS(3605),
    [anon_sym_extension] = ACTIONS(3605),
    [anon_sym___init] = ACTIONS(3605),
    [anon_sym___subscript] = ACTIONS(3605),
    [anon_sym_property] = ACTIONS(3605),
    [anon_sym_associatedtype] = ACTIONS(3605),
  },
  [2571] = {
    [sym_identifier] = ACTIONS(3609),
    [aux_sym_preproc_def_token1] = ACTIONS(3609),
    [aux_sym_preproc_if_token1] = ACTIONS(3609),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3609),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3609),
    [sym_preproc_directive] = ACTIONS(3609),
    [anon_sym_LPAREN2] = ACTIONS(3611),
    [anon_sym_TILDE] = ACTIONS(3611),
    [anon_sym_STAR] = ACTIONS(3611),
    [anon_sym_AMP_AMP] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3609),
    [anon_sym___extension__] = ACTIONS(3609),
    [anon_sym_typedef] = ACTIONS(3609),
    [anon_sym_in] = ACTIONS(3609),
    [anon_sym_out] = ACTIONS(3609),
    [anon_sym_inout] = ACTIONS(3609),
    [anon_sym_extern] = ACTIONS(3609),
    [anon_sym___attribute__] = ACTIONS(3609),
    [anon_sym_COLON_COLON] = ACTIONS(3611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3611),
    [anon_sym___declspec] = ACTIONS(3609),
    [anon_sym___based] = ACTIONS(3609),
    [anon_sym_RBRACE] = ACTIONS(3611),
    [anon_sym_signed] = ACTIONS(3609),
    [anon_sym_unsigned] = ACTIONS(3609),
    [anon_sym_long] = ACTIONS(3609),
    [anon_sym_short] = ACTIONS(3609),
    [anon_sym_LBRACK] = ACTIONS(3609),
    [anon_sym_static] = ACTIONS(3609),
    [anon_sym_register] = ACTIONS(3609),
    [anon_sym_inline] = ACTIONS(3609),
    [anon_sym___inline] = ACTIONS(3609),
    [anon_sym___inline__] = ACTIONS(3609),
    [anon_sym___forceinline] = ACTIONS(3609),
    [anon_sym_thread_local] = ACTIONS(3609),
    [anon_sym___thread] = ACTIONS(3609),
    [anon_sym_const] = ACTIONS(3609),
    [anon_sym_constexpr] = ACTIONS(3609),
    [anon_sym_volatile] = ACTIONS(3609),
    [anon_sym_restrict] = ACTIONS(3609),
    [anon_sym___restrict__] = ACTIONS(3609),
    [anon_sym__Atomic] = ACTIONS(3609),
    [anon_sym__Noreturn] = ACTIONS(3609),
    [anon_sym_noreturn] = ACTIONS(3609),
    [anon_sym_mutable] = ACTIONS(3609),
    [anon_sym_constinit] = ACTIONS(3609),
    [anon_sym_consteval] = ACTIONS(3609),
    [anon_sym_alignas] = ACTIONS(3609),
    [anon_sym__Alignas] = ACTIONS(3609),
    [sym_primitive_type] = ACTIONS(3609),
    [anon_sym_enum] = ACTIONS(3609),
    [anon_sym_class] = ACTIONS(3609),
    [anon_sym_struct] = ACTIONS(3609),
    [anon_sym_union] = ACTIONS(3609),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3609),
    [anon_sym_let] = ACTIONS(3609),
    [anon_sym_This] = ACTIONS(3609),
    [anon_sym_decltype] = ACTIONS(3609),
    [sym_virtual] = ACTIONS(3609),
    [anon_sym_explicit] = ACTIONS(3609),
    [anon_sym_typename] = ACTIONS(3609),
    [anon_sym_template] = ACTIONS(3609),
    [anon_sym_operator] = ACTIONS(3609),
    [anon_sym_friend] = ACTIONS(3609),
    [anon_sym_public] = ACTIONS(3609),
    [anon_sym_private] = ACTIONS(3609),
    [anon_sym_protected] = ACTIONS(3609),
    [anon_sym_using] = ACTIONS(3609),
    [anon_sym_static_assert] = ACTIONS(3609),
    [anon_sym_precise] = ACTIONS(3609),
    [anon_sym_shared] = ACTIONS(3609),
    [anon_sym_groupshared] = ACTIONS(3609),
    [anon_sym_uniform] = ACTIONS(3609),
    [anon_sym_row_major] = ACTIONS(3609),
    [anon_sym_column_major] = ACTIONS(3609),
    [anon_sym_globallycoherent] = ACTIONS(3609),
    [anon_sym_centroid] = ACTIONS(3609),
    [anon_sym_noperspective] = ACTIONS(3609),
    [anon_sym_nointerpolation] = ACTIONS(3609),
    [anon_sym_sample] = ACTIONS(3609),
    [anon_sym_linear] = ACTIONS(3609),
    [anon_sym_snorm] = ACTIONS(3609),
    [anon_sym_unorm] = ACTIONS(3609),
    [anon_sym_point] = ACTIONS(3609),
    [anon_sym_line] = ACTIONS(3609),
    [anon_sym_triangleadj] = ACTIONS(3609),
    [anon_sym_lineadj] = ACTIONS(3609),
    [anon_sym_triangle] = ACTIONS(3609),
    [anon_sym_interface] = ACTIONS(3609),
    [anon_sym_extension] = ACTIONS(3609),
    [anon_sym___init] = ACTIONS(3609),
    [anon_sym___subscript] = ACTIONS(3609),
    [anon_sym_property] = ACTIONS(3609),
    [anon_sym_associatedtype] = ACTIONS(3609),
  },
  [2572] = {
    [sym_identifier] = ACTIONS(3617),
    [aux_sym_preproc_def_token1] = ACTIONS(3617),
    [aux_sym_preproc_if_token1] = ACTIONS(3617),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3617),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3617),
    [sym_preproc_directive] = ACTIONS(3617),
    [anon_sym_LPAREN2] = ACTIONS(3619),
    [anon_sym_TILDE] = ACTIONS(3619),
    [anon_sym_STAR] = ACTIONS(3619),
    [anon_sym_AMP_AMP] = ACTIONS(3619),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym___extension__] = ACTIONS(3617),
    [anon_sym_typedef] = ACTIONS(3617),
    [anon_sym_in] = ACTIONS(3617),
    [anon_sym_out] = ACTIONS(3617),
    [anon_sym_inout] = ACTIONS(3617),
    [anon_sym_extern] = ACTIONS(3617),
    [anon_sym___attribute__] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3619),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3619),
    [anon_sym___declspec] = ACTIONS(3617),
    [anon_sym___based] = ACTIONS(3617),
    [anon_sym_RBRACE] = ACTIONS(3619),
    [anon_sym_signed] = ACTIONS(3617),
    [anon_sym_unsigned] = ACTIONS(3617),
    [anon_sym_long] = ACTIONS(3617),
    [anon_sym_short] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_static] = ACTIONS(3617),
    [anon_sym_register] = ACTIONS(3617),
    [anon_sym_inline] = ACTIONS(3617),
    [anon_sym___inline] = ACTIONS(3617),
    [anon_sym___inline__] = ACTIONS(3617),
    [anon_sym___forceinline] = ACTIONS(3617),
    [anon_sym_thread_local] = ACTIONS(3617),
    [anon_sym___thread] = ACTIONS(3617),
    [anon_sym_const] = ACTIONS(3617),
    [anon_sym_constexpr] = ACTIONS(3617),
    [anon_sym_volatile] = ACTIONS(3617),
    [anon_sym_restrict] = ACTIONS(3617),
    [anon_sym___restrict__] = ACTIONS(3617),
    [anon_sym__Atomic] = ACTIONS(3617),
    [anon_sym__Noreturn] = ACTIONS(3617),
    [anon_sym_noreturn] = ACTIONS(3617),
    [anon_sym_mutable] = ACTIONS(3617),
    [anon_sym_constinit] = ACTIONS(3617),
    [anon_sym_consteval] = ACTIONS(3617),
    [anon_sym_alignas] = ACTIONS(3617),
    [anon_sym__Alignas] = ACTIONS(3617),
    [sym_primitive_type] = ACTIONS(3617),
    [anon_sym_enum] = ACTIONS(3617),
    [anon_sym_class] = ACTIONS(3617),
    [anon_sym_struct] = ACTIONS(3617),
    [anon_sym_union] = ACTIONS(3617),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3617),
    [anon_sym_let] = ACTIONS(3617),
    [anon_sym_This] = ACTIONS(3617),
    [anon_sym_decltype] = ACTIONS(3617),
    [sym_virtual] = ACTIONS(3617),
    [anon_sym_explicit] = ACTIONS(3617),
    [anon_sym_typename] = ACTIONS(3617),
    [anon_sym_template] = ACTIONS(3617),
    [anon_sym_operator] = ACTIONS(3617),
    [anon_sym_friend] = ACTIONS(3617),
    [anon_sym_public] = ACTIONS(3617),
    [anon_sym_private] = ACTIONS(3617),
    [anon_sym_protected] = ACTIONS(3617),
    [anon_sym_using] = ACTIONS(3617),
    [anon_sym_static_assert] = ACTIONS(3617),
    [anon_sym_precise] = ACTIONS(3617),
    [anon_sym_shared] = ACTIONS(3617),
    [anon_sym_groupshared] = ACTIONS(3617),
    [anon_sym_uniform] = ACTIONS(3617),
    [anon_sym_row_major] = ACTIONS(3617),
    [anon_sym_column_major] = ACTIONS(3617),
    [anon_sym_globallycoherent] = ACTIONS(3617),
    [anon_sym_centroid] = ACTIONS(3617),
    [anon_sym_noperspective] = ACTIONS(3617),
    [anon_sym_nointerpolation] = ACTIONS(3617),
    [anon_sym_sample] = ACTIONS(3617),
    [anon_sym_linear] = ACTIONS(3617),
    [anon_sym_snorm] = ACTIONS(3617),
    [anon_sym_unorm] = ACTIONS(3617),
    [anon_sym_point] = ACTIONS(3617),
    [anon_sym_line] = ACTIONS(3617),
    [anon_sym_triangleadj] = ACTIONS(3617),
    [anon_sym_lineadj] = ACTIONS(3617),
    [anon_sym_triangle] = ACTIONS(3617),
    [anon_sym_interface] = ACTIONS(3617),
    [anon_sym_extension] = ACTIONS(3617),
    [anon_sym___init] = ACTIONS(3617),
    [anon_sym___subscript] = ACTIONS(3617),
    [anon_sym_property] = ACTIONS(3617),
    [anon_sym_associatedtype] = ACTIONS(3617),
  },
  [2573] = {
    [sym_expression] = STATE(5595),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2574] = {
    [sym_expression] = STATE(5594),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4473),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4473),
    [sym_call_expression] = STATE(4473),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4473),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4473),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4473),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4473),
    [sym_identifier] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(5008),
    [anon_sym_BANG] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(4988),
    [anon_sym_compl] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(5012),
    [anon_sym_PLUS_PLUS] = ACTIONS(5012),
    [anon_sym_sizeof] = ACTIONS(4994),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(4996),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2575] = {
    [sym_identifier] = ACTIONS(3621),
    [aux_sym_preproc_def_token1] = ACTIONS(3621),
    [aux_sym_preproc_if_token1] = ACTIONS(3621),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3621),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3621),
    [sym_preproc_directive] = ACTIONS(3621),
    [anon_sym_LPAREN2] = ACTIONS(3623),
    [anon_sym_TILDE] = ACTIONS(3623),
    [anon_sym_STAR] = ACTIONS(3623),
    [anon_sym_AMP_AMP] = ACTIONS(3623),
    [anon_sym_AMP] = ACTIONS(3621),
    [anon_sym___extension__] = ACTIONS(3621),
    [anon_sym_typedef] = ACTIONS(3621),
    [anon_sym_in] = ACTIONS(3621),
    [anon_sym_out] = ACTIONS(3621),
    [anon_sym_inout] = ACTIONS(3621),
    [anon_sym_extern] = ACTIONS(3621),
    [anon_sym___attribute__] = ACTIONS(3621),
    [anon_sym_COLON_COLON] = ACTIONS(3623),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3623),
    [anon_sym___declspec] = ACTIONS(3621),
    [anon_sym___based] = ACTIONS(3621),
    [anon_sym_RBRACE] = ACTIONS(3623),
    [anon_sym_signed] = ACTIONS(3621),
    [anon_sym_unsigned] = ACTIONS(3621),
    [anon_sym_long] = ACTIONS(3621),
    [anon_sym_short] = ACTIONS(3621),
    [anon_sym_LBRACK] = ACTIONS(3621),
    [anon_sym_static] = ACTIONS(3621),
    [anon_sym_register] = ACTIONS(3621),
    [anon_sym_inline] = ACTIONS(3621),
    [anon_sym___inline] = ACTIONS(3621),
    [anon_sym___inline__] = ACTIONS(3621),
    [anon_sym___forceinline] = ACTIONS(3621),
    [anon_sym_thread_local] = ACTIONS(3621),
    [anon_sym___thread] = ACTIONS(3621),
    [anon_sym_const] = ACTIONS(3621),
    [anon_sym_constexpr] = ACTIONS(3621),
    [anon_sym_volatile] = ACTIONS(3621),
    [anon_sym_restrict] = ACTIONS(3621),
    [anon_sym___restrict__] = ACTIONS(3621),
    [anon_sym__Atomic] = ACTIONS(3621),
    [anon_sym__Noreturn] = ACTIONS(3621),
    [anon_sym_noreturn] = ACTIONS(3621),
    [anon_sym_mutable] = ACTIONS(3621),
    [anon_sym_constinit] = ACTIONS(3621),
    [anon_sym_consteval] = ACTIONS(3621),
    [anon_sym_alignas] = ACTIONS(3621),
    [anon_sym__Alignas] = ACTIONS(3621),
    [sym_primitive_type] = ACTIONS(3621),
    [anon_sym_enum] = ACTIONS(3621),
    [anon_sym_class] = ACTIONS(3621),
    [anon_sym_struct] = ACTIONS(3621),
    [anon_sym_union] = ACTIONS(3621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3621),
    [anon_sym_let] = ACTIONS(3621),
    [anon_sym_This] = ACTIONS(3621),
    [anon_sym_decltype] = ACTIONS(3621),
    [sym_virtual] = ACTIONS(3621),
    [anon_sym_explicit] = ACTIONS(3621),
    [anon_sym_typename] = ACTIONS(3621),
    [anon_sym_template] = ACTIONS(3621),
    [anon_sym_operator] = ACTIONS(3621),
    [anon_sym_friend] = ACTIONS(3621),
    [anon_sym_public] = ACTIONS(3621),
    [anon_sym_private] = ACTIONS(3621),
    [anon_sym_protected] = ACTIONS(3621),
    [anon_sym_using] = ACTIONS(3621),
    [anon_sym_static_assert] = ACTIONS(3621),
    [anon_sym_precise] = ACTIONS(3621),
    [anon_sym_shared] = ACTIONS(3621),
    [anon_sym_groupshared] = ACTIONS(3621),
    [anon_sym_uniform] = ACTIONS(3621),
    [anon_sym_row_major] = ACTIONS(3621),
    [anon_sym_column_major] = ACTIONS(3621),
    [anon_sym_globallycoherent] = ACTIONS(3621),
    [anon_sym_centroid] = ACTIONS(3621),
    [anon_sym_noperspective] = ACTIONS(3621),
    [anon_sym_nointerpolation] = ACTIONS(3621),
    [anon_sym_sample] = ACTIONS(3621),
    [anon_sym_linear] = ACTIONS(3621),
    [anon_sym_snorm] = ACTIONS(3621),
    [anon_sym_unorm] = ACTIONS(3621),
    [anon_sym_point] = ACTIONS(3621),
    [anon_sym_line] = ACTIONS(3621),
    [anon_sym_triangleadj] = ACTIONS(3621),
    [anon_sym_lineadj] = ACTIONS(3621),
    [anon_sym_triangle] = ACTIONS(3621),
    [anon_sym_interface] = ACTIONS(3621),
    [anon_sym_extension] = ACTIONS(3621),
    [anon_sym___init] = ACTIONS(3621),
    [anon_sym___subscript] = ACTIONS(3621),
    [anon_sym_property] = ACTIONS(3621),
    [anon_sym_associatedtype] = ACTIONS(3621),
  },
  [2576] = {
    [sym_identifier] = ACTIONS(3625),
    [aux_sym_preproc_def_token1] = ACTIONS(3625),
    [aux_sym_preproc_if_token1] = ACTIONS(3625),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3625),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3625),
    [sym_preproc_directive] = ACTIONS(3625),
    [anon_sym_LPAREN2] = ACTIONS(3627),
    [anon_sym_TILDE] = ACTIONS(3627),
    [anon_sym_STAR] = ACTIONS(3627),
    [anon_sym_AMP_AMP] = ACTIONS(3627),
    [anon_sym_AMP] = ACTIONS(3625),
    [anon_sym___extension__] = ACTIONS(3625),
    [anon_sym_typedef] = ACTIONS(3625),
    [anon_sym_in] = ACTIONS(3625),
    [anon_sym_out] = ACTIONS(3625),
    [anon_sym_inout] = ACTIONS(3625),
    [anon_sym_extern] = ACTIONS(3625),
    [anon_sym___attribute__] = ACTIONS(3625),
    [anon_sym_COLON_COLON] = ACTIONS(3627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3627),
    [anon_sym___declspec] = ACTIONS(3625),
    [anon_sym___based] = ACTIONS(3625),
    [anon_sym_RBRACE] = ACTIONS(3627),
    [anon_sym_signed] = ACTIONS(3625),
    [anon_sym_unsigned] = ACTIONS(3625),
    [anon_sym_long] = ACTIONS(3625),
    [anon_sym_short] = ACTIONS(3625),
    [anon_sym_LBRACK] = ACTIONS(3625),
    [anon_sym_static] = ACTIONS(3625),
    [anon_sym_register] = ACTIONS(3625),
    [anon_sym_inline] = ACTIONS(3625),
    [anon_sym___inline] = ACTIONS(3625),
    [anon_sym___inline__] = ACTIONS(3625),
    [anon_sym___forceinline] = ACTIONS(3625),
    [anon_sym_thread_local] = ACTIONS(3625),
    [anon_sym___thread] = ACTIONS(3625),
    [anon_sym_const] = ACTIONS(3625),
    [anon_sym_constexpr] = ACTIONS(3625),
    [anon_sym_volatile] = ACTIONS(3625),
    [anon_sym_restrict] = ACTIONS(3625),
    [anon_sym___restrict__] = ACTIONS(3625),
    [anon_sym__Atomic] = ACTIONS(3625),
    [anon_sym__Noreturn] = ACTIONS(3625),
    [anon_sym_noreturn] = ACTIONS(3625),
    [anon_sym_mutable] = ACTIONS(3625),
    [anon_sym_constinit] = ACTIONS(3625),
    [anon_sym_consteval] = ACTIONS(3625),
    [anon_sym_alignas] = ACTIONS(3625),
    [anon_sym__Alignas] = ACTIONS(3625),
    [sym_primitive_type] = ACTIONS(3625),
    [anon_sym_enum] = ACTIONS(3625),
    [anon_sym_class] = ACTIONS(3625),
    [anon_sym_struct] = ACTIONS(3625),
    [anon_sym_union] = ACTIONS(3625),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3625),
    [anon_sym_let] = ACTIONS(3625),
    [anon_sym_This] = ACTIONS(3625),
    [anon_sym_decltype] = ACTIONS(3625),
    [sym_virtual] = ACTIONS(3625),
    [anon_sym_explicit] = ACTIONS(3625),
    [anon_sym_typename] = ACTIONS(3625),
    [anon_sym_template] = ACTIONS(3625),
    [anon_sym_operator] = ACTIONS(3625),
    [anon_sym_friend] = ACTIONS(3625),
    [anon_sym_public] = ACTIONS(3625),
    [anon_sym_private] = ACTIONS(3625),
    [anon_sym_protected] = ACTIONS(3625),
    [anon_sym_using] = ACTIONS(3625),
    [anon_sym_static_assert] = ACTIONS(3625),
    [anon_sym_precise] = ACTIONS(3625),
    [anon_sym_shared] = ACTIONS(3625),
    [anon_sym_groupshared] = ACTIONS(3625),
    [anon_sym_uniform] = ACTIONS(3625),
    [anon_sym_row_major] = ACTIONS(3625),
    [anon_sym_column_major] = ACTIONS(3625),
    [anon_sym_globallycoherent] = ACTIONS(3625),
    [anon_sym_centroid] = ACTIONS(3625),
    [anon_sym_noperspective] = ACTIONS(3625),
    [anon_sym_nointerpolation] = ACTIONS(3625),
    [anon_sym_sample] = ACTIONS(3625),
    [anon_sym_linear] = ACTIONS(3625),
    [anon_sym_snorm] = ACTIONS(3625),
    [anon_sym_unorm] = ACTIONS(3625),
    [anon_sym_point] = ACTIONS(3625),
    [anon_sym_line] = ACTIONS(3625),
    [anon_sym_triangleadj] = ACTIONS(3625),
    [anon_sym_lineadj] = ACTIONS(3625),
    [anon_sym_triangle] = ACTIONS(3625),
    [anon_sym_interface] = ACTIONS(3625),
    [anon_sym_extension] = ACTIONS(3625),
    [anon_sym___init] = ACTIONS(3625),
    [anon_sym___subscript] = ACTIONS(3625),
    [anon_sym_property] = ACTIONS(3625),
    [anon_sym_associatedtype] = ACTIONS(3625),
  },
  [2577] = {
    [sym_expression] = STATE(5252),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2578] = {
    [sym_expression] = STATE(5247),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2579] = {
    [sym_expression] = STATE(5560),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2580] = {
    [sym_expression] = STATE(5578),
    [sym__string] = STATE(4704),
    [sym_conditional_expression] = STATE(4704),
    [sym_assignment_expression] = STATE(4704),
    [sym_pointer_expression] = STATE(4081),
    [sym_unary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_cast_expression] = STATE(4704),
    [sym_sizeof_expression] = STATE(4704),
    [sym_alignof_expression] = STATE(4704),
    [sym_offsetof_expression] = STATE(4704),
    [sym_generic_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(4081),
    [sym_call_expression] = STATE(4081),
    [sym_gnu_asm_expression] = STATE(4704),
    [sym_field_expression] = STATE(4081),
    [sym_compound_literal_expression] = STATE(4704),
    [sym_parenthesized_expression] = STATE(4081),
    [sym_char_literal] = STATE(4993),
    [sym_concatenated_string] = STATE(4975),
    [sym_string_literal] = STATE(3709),
    [sym_null] = STATE(4704),
    [sym_decltype] = STATE(10765),
    [sym__class_name] = STATE(9700),
    [sym_template_type] = STATE(195),
    [sym_template_function] = STATE(4704),
    [sym_raw_string_literal] = STATE(3697),
    [sym_co_await_expression] = STATE(4704),
    [sym_new_expression] = STATE(4704),
    [sym_delete_expression] = STATE(4704),
    [sym_requires_clause] = STATE(4704),
    [sym_requires_expression] = STATE(4704),
    [sym_lambda_expression] = STATE(4704),
    [sym_lambda_capture_specifier] = STATE(7052),
    [sym_fold_expression] = STATE(4704),
    [sym_parameter_pack_expansion] = STATE(4704),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6786),
    [sym_qualified_identifier] = STATE(4081),
    [sym_qualified_type_identifier] = STATE(9700),
    [sym_user_defined_literal] = STATE(4081),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4043),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(241),
  },
  [2581] = {
    [sym_identifier] = ACTIONS(3222),
    [aux_sym_preproc_def_token1] = ACTIONS(3222),
    [aux_sym_preproc_if_token1] = ACTIONS(3222),
    [aux_sym_preproc_if_token2] = ACTIONS(3222),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3222),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3222),
    [sym_preproc_directive] = ACTIONS(3222),
    [anon_sym_LPAREN2] = ACTIONS(3224),
    [anon_sym_TILDE] = ACTIONS(3224),
    [anon_sym_STAR] = ACTIONS(3224),
    [anon_sym_AMP_AMP] = ACTIONS(3224),
    [anon_sym_AMP] = ACTIONS(3222),
    [anon_sym___extension__] = ACTIONS(3222),
    [anon_sym_typedef] = ACTIONS(3222),
    [anon_sym_in] = ACTIONS(3222),
    [anon_sym_out] = ACTIONS(3222),
    [anon_sym_inout] = ACTIONS(3222),
    [anon_sym_extern] = ACTIONS(3222),
    [anon_sym___attribute__] = ACTIONS(3222),
    [anon_sym_COLON_COLON] = ACTIONS(3224),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3224),
    [anon_sym___declspec] = ACTIONS(3222),
    [anon_sym___based] = ACTIONS(3222),
    [anon_sym_signed] = ACTIONS(3222),
    [anon_sym_unsigned] = ACTIONS(3222),
    [anon_sym_long] = ACTIONS(3222),
    [anon_sym_short] = ACTIONS(3222),
    [anon_sym_LBRACK] = ACTIONS(3222),
    [anon_sym_static] = ACTIONS(3222),
    [anon_sym_register] = ACTIONS(3222),
    [anon_sym_inline] = ACTIONS(3222),
    [anon_sym___inline] = ACTIONS(3222),
    [anon_sym___inline__] = ACTIONS(3222),
    [anon_sym___forceinline] = ACTIONS(3222),
    [anon_sym_thread_local] = ACTIONS(3222),
    [anon_sym___thread] = ACTIONS(3222),
    [anon_sym_const] = ACTIONS(3222),
    [anon_sym_constexpr] = ACTIONS(3222),
    [anon_sym_volatile] = ACTIONS(3222),
    [anon_sym_restrict] = ACTIONS(3222),
    [anon_sym___restrict__] = ACTIONS(3222),
    [anon_sym__Atomic] = ACTIONS(3222),
    [anon_sym__Noreturn] = ACTIONS(3222),
    [anon_sym_noreturn] = ACTIONS(3222),
    [anon_sym_mutable] = ACTIONS(3222),
    [anon_sym_constinit] = ACTIONS(3222),
    [anon_sym_consteval] = ACTIONS(3222),
    [anon_sym_alignas] = ACTIONS(3222),
    [anon_sym__Alignas] = ACTIONS(3222),
    [sym_primitive_type] = ACTIONS(3222),
    [anon_sym_enum] = ACTIONS(3222),
    [anon_sym_class] = ACTIONS(3222),
    [anon_sym_struct] = ACTIONS(3222),
    [anon_sym_union] = ACTIONS(3222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3222),
    [anon_sym_let] = ACTIONS(3222),
    [anon_sym_This] = ACTIONS(3222),
    [anon_sym_decltype] = ACTIONS(3222),
    [sym_virtual] = ACTIONS(3222),
    [anon_sym_explicit] = ACTIONS(3222),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3222),
    [anon_sym_operator] = ACTIONS(3222),
    [anon_sym_friend] = ACTIONS(3222),
    [anon_sym_public] = ACTIONS(3222),
    [anon_sym_private] = ACTIONS(3222),
    [anon_sym_protected] = ACTIONS(3222),
    [anon_sym_using] = ACTIONS(3222),
    [anon_sym_static_assert] = ACTIONS(3222),
    [anon_sym_precise] = ACTIONS(3222),
    [anon_sym_shared] = ACTIONS(3222),
    [anon_sym_groupshared] = ACTIONS(3222),
    [anon_sym_uniform] = ACTIONS(3222),
    [anon_sym_row_major] = ACTIONS(3222),
    [anon_sym_column_major] = ACTIONS(3222),
    [anon_sym_globallycoherent] = ACTIONS(3222),
    [anon_sym_centroid] = ACTIONS(3222),
    [anon_sym_noperspective] = ACTIONS(3222),
    [anon_sym_nointerpolation] = ACTIONS(3222),
    [anon_sym_sample] = ACTIONS(3222),
    [anon_sym_linear] = ACTIONS(3222),
    [anon_sym_snorm] = ACTIONS(3222),
    [anon_sym_unorm] = ACTIONS(3222),
    [anon_sym_point] = ACTIONS(3222),
    [anon_sym_line] = ACTIONS(3222),
    [anon_sym_triangleadj] = ACTIONS(3222),
    [anon_sym_lineadj] = ACTIONS(3222),
    [anon_sym_triangle] = ACTIONS(3222),
    [anon_sym_interface] = ACTIONS(3222),
    [anon_sym_extension] = ACTIONS(3222),
    [anon_sym___init] = ACTIONS(3222),
    [anon_sym___subscript] = ACTIONS(3222),
    [anon_sym_property] = ACTIONS(3222),
    [anon_sym_associatedtype] = ACTIONS(3222),
  },
  [2582] = {
    [sym_identifier] = ACTIONS(6132),
    [anon_sym_COMMA] = ACTIONS(6134),
    [anon_sym_RPAREN] = ACTIONS(6134),
    [anon_sym_LPAREN2] = ACTIONS(6134),
    [anon_sym_TILDE] = ACTIONS(6134),
    [anon_sym_STAR] = ACTIONS(6134),
    [anon_sym_AMP_AMP] = ACTIONS(6134),
    [anon_sym_AMP] = ACTIONS(6132),
    [anon_sym_SEMI] = ACTIONS(6134),
    [anon_sym___extension__] = ACTIONS(6132),
    [anon_sym_in] = ACTIONS(6132),
    [anon_sym_out] = ACTIONS(6132),
    [anon_sym_inout] = ACTIONS(6132),
    [anon_sym_extern] = ACTIONS(6132),
    [anon_sym___attribute__] = ACTIONS(6132),
    [anon_sym_COLON_COLON] = ACTIONS(6134),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6134),
    [anon_sym___declspec] = ACTIONS(6132),
    [anon_sym___based] = ACTIONS(6132),
    [anon_sym_LBRACE] = ACTIONS(6134),
    [anon_sym_signed] = ACTIONS(6132),
    [anon_sym_unsigned] = ACTIONS(6132),
    [anon_sym_long] = ACTIONS(6132),
    [anon_sym_short] = ACTIONS(6132),
    [anon_sym_LBRACK] = ACTIONS(6132),
    [anon_sym_static] = ACTIONS(6132),
    [anon_sym_EQ] = ACTIONS(6134),
    [anon_sym_register] = ACTIONS(6132),
    [anon_sym_inline] = ACTIONS(6132),
    [anon_sym___inline] = ACTIONS(6132),
    [anon_sym___inline__] = ACTIONS(6132),
    [anon_sym___forceinline] = ACTIONS(6132),
    [anon_sym_thread_local] = ACTIONS(6132),
    [anon_sym___thread] = ACTIONS(6132),
    [anon_sym_const] = ACTIONS(6132),
    [anon_sym_constexpr] = ACTIONS(6132),
    [anon_sym_volatile] = ACTIONS(6132),
    [anon_sym_restrict] = ACTIONS(6132),
    [anon_sym___restrict__] = ACTIONS(6132),
    [anon_sym__Atomic] = ACTIONS(6132),
    [anon_sym__Noreturn] = ACTIONS(6132),
    [anon_sym_noreturn] = ACTIONS(6132),
    [anon_sym_mutable] = ACTIONS(6132),
    [anon_sym_constinit] = ACTIONS(6132),
    [anon_sym_consteval] = ACTIONS(6132),
    [anon_sym_alignas] = ACTIONS(6132),
    [anon_sym__Alignas] = ACTIONS(6132),
    [sym_primitive_type] = ACTIONS(6132),
    [anon_sym_enum] = ACTIONS(6132),
    [anon_sym_class] = ACTIONS(6132),
    [anon_sym_struct] = ACTIONS(6132),
    [anon_sym_union] = ACTIONS(6132),
    [anon_sym_asm] = ACTIONS(6132),
    [anon_sym___asm__] = ACTIONS(6132),
    [anon_sym_DASH_GT] = ACTIONS(6134),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6132),
    [anon_sym_let] = ACTIONS(6132),
    [anon_sym_This] = ACTIONS(6132),
    [anon_sym_decltype] = ACTIONS(6132),
    [anon_sym_final] = ACTIONS(6132),
    [anon_sym_override] = ACTIONS(6132),
    [sym_virtual] = ACTIONS(6132),
    [anon_sym_explicit] = ACTIONS(6132),
    [anon_sym_typename] = ACTIONS(6132),
    [anon_sym_template] = ACTIONS(6132),
    [anon_sym_GT2] = ACTIONS(6134),
    [anon_sym_operator] = ACTIONS(6132),
    [anon_sym_try] = ACTIONS(6132),
    [anon_sym_noexcept] = ACTIONS(6132),
    [anon_sym_throw] = ACTIONS(6132),
    [anon_sym_requires] = ACTIONS(6132),
    [anon_sym_precise] = ACTIONS(6132),
    [anon_sym_shared] = ACTIONS(6132),
    [anon_sym_groupshared] = ACTIONS(6132),
    [anon_sym_uniform] = ACTIONS(6132),
    [anon_sym_row_major] = ACTIONS(6132),
    [anon_sym_column_major] = ACTIONS(6132),
    [anon_sym_globallycoherent] = ACTIONS(6132),
    [anon_sym_centroid] = ACTIONS(6132),
    [anon_sym_noperspective] = ACTIONS(6132),
    [anon_sym_nointerpolation] = ACTIONS(6132),
    [anon_sym_sample] = ACTIONS(6132),
    [anon_sym_linear] = ACTIONS(6132),
    [anon_sym_snorm] = ACTIONS(6132),
    [anon_sym_unorm] = ACTIONS(6132),
    [anon_sym_point] = ACTIONS(6132),
    [anon_sym_line] = ACTIONS(6132),
    [anon_sym_triangleadj] = ACTIONS(6132),
    [anon_sym_lineadj] = ACTIONS(6132),
    [anon_sym_triangle] = ACTIONS(6132),
    [anon_sym_interface] = ACTIONS(6132),
    [anon_sym_extension] = ACTIONS(6132),
    [anon_sym_where] = ACTIONS(6132),
  },
  [2583] = {
    [sym_identifier] = ACTIONS(6136),
    [anon_sym_COMMA] = ACTIONS(6138),
    [anon_sym_RPAREN] = ACTIONS(6138),
    [anon_sym_LPAREN2] = ACTIONS(6138),
    [anon_sym_TILDE] = ACTIONS(6138),
    [anon_sym_STAR] = ACTIONS(6138),
    [anon_sym_AMP_AMP] = ACTIONS(6138),
    [anon_sym_AMP] = ACTIONS(6136),
    [anon_sym_SEMI] = ACTIONS(6138),
    [anon_sym___extension__] = ACTIONS(6136),
    [anon_sym_in] = ACTIONS(6136),
    [anon_sym_out] = ACTIONS(6136),
    [anon_sym_inout] = ACTIONS(6136),
    [anon_sym_extern] = ACTIONS(6136),
    [anon_sym___attribute__] = ACTIONS(6136),
    [anon_sym_COLON_COLON] = ACTIONS(6138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6138),
    [anon_sym___declspec] = ACTIONS(6136),
    [anon_sym___based] = ACTIONS(6136),
    [anon_sym_LBRACE] = ACTIONS(6138),
    [anon_sym_signed] = ACTIONS(6136),
    [anon_sym_unsigned] = ACTIONS(6136),
    [anon_sym_long] = ACTIONS(6136),
    [anon_sym_short] = ACTIONS(6136),
    [anon_sym_LBRACK] = ACTIONS(6136),
    [anon_sym_static] = ACTIONS(6136),
    [anon_sym_EQ] = ACTIONS(6138),
    [anon_sym_register] = ACTIONS(6136),
    [anon_sym_inline] = ACTIONS(6136),
    [anon_sym___inline] = ACTIONS(6136),
    [anon_sym___inline__] = ACTIONS(6136),
    [anon_sym___forceinline] = ACTIONS(6136),
    [anon_sym_thread_local] = ACTIONS(6136),
    [anon_sym___thread] = ACTIONS(6136),
    [anon_sym_const] = ACTIONS(6136),
    [anon_sym_constexpr] = ACTIONS(6136),
    [anon_sym_volatile] = ACTIONS(6136),
    [anon_sym_restrict] = ACTIONS(6136),
    [anon_sym___restrict__] = ACTIONS(6136),
    [anon_sym__Atomic] = ACTIONS(6136),
    [anon_sym__Noreturn] = ACTIONS(6136),
    [anon_sym_noreturn] = ACTIONS(6136),
    [anon_sym_mutable] = ACTIONS(6136),
    [anon_sym_constinit] = ACTIONS(6136),
    [anon_sym_consteval] = ACTIONS(6136),
    [anon_sym_alignas] = ACTIONS(6136),
    [anon_sym__Alignas] = ACTIONS(6136),
    [sym_primitive_type] = ACTIONS(6136),
    [anon_sym_enum] = ACTIONS(6136),
    [anon_sym_class] = ACTIONS(6136),
    [anon_sym_struct] = ACTIONS(6136),
    [anon_sym_union] = ACTIONS(6136),
    [anon_sym_asm] = ACTIONS(6136),
    [anon_sym___asm__] = ACTIONS(6136),
    [anon_sym_DASH_GT] = ACTIONS(6138),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6136),
    [anon_sym_let] = ACTIONS(6136),
    [anon_sym_This] = ACTIONS(6136),
    [anon_sym_decltype] = ACTIONS(6136),
    [anon_sym_final] = ACTIONS(6136),
    [anon_sym_override] = ACTIONS(6136),
    [sym_virtual] = ACTIONS(6136),
    [anon_sym_explicit] = ACTIONS(6136),
    [anon_sym_typename] = ACTIONS(6136),
    [anon_sym_template] = ACTIONS(6136),
    [anon_sym_GT2] = ACTIONS(6138),
    [anon_sym_operator] = ACTIONS(6136),
    [anon_sym_try] = ACTIONS(6136),
    [anon_sym_noexcept] = ACTIONS(6136),
    [anon_sym_throw] = ACTIONS(6136),
    [anon_sym_requires] = ACTIONS(6136),
    [anon_sym_precise] = ACTIONS(6136),
    [anon_sym_shared] = ACTIONS(6136),
    [anon_sym_groupshared] = ACTIONS(6136),
    [anon_sym_uniform] = ACTIONS(6136),
    [anon_sym_row_major] = ACTIONS(6136),
    [anon_sym_column_major] = ACTIONS(6136),
    [anon_sym_globallycoherent] = ACTIONS(6136),
    [anon_sym_centroid] = ACTIONS(6136),
    [anon_sym_noperspective] = ACTIONS(6136),
    [anon_sym_nointerpolation] = ACTIONS(6136),
    [anon_sym_sample] = ACTIONS(6136),
    [anon_sym_linear] = ACTIONS(6136),
    [anon_sym_snorm] = ACTIONS(6136),
    [anon_sym_unorm] = ACTIONS(6136),
    [anon_sym_point] = ACTIONS(6136),
    [anon_sym_line] = ACTIONS(6136),
    [anon_sym_triangleadj] = ACTIONS(6136),
    [anon_sym_lineadj] = ACTIONS(6136),
    [anon_sym_triangle] = ACTIONS(6136),
    [anon_sym_interface] = ACTIONS(6136),
    [anon_sym_extension] = ACTIONS(6136),
    [anon_sym_where] = ACTIONS(6136),
  },
  [2584] = {
    [sym__declaration_modifiers] = STATE(2862),
    [sym_attribute_specifier] = STATE(2862),
    [sym_attribute_declaration] = STATE(2862),
    [sym_ms_declspec_modifier] = STATE(2862),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7536),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2862),
    [sym_type_qualifier] = STATE(2862),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_decltype] = STATE(10765),
    [sym_explicit_function_specifier] = STATE(2862),
    [sym_operator_cast] = STATE(8419),
    [sym__constructor_specifiers] = STATE(2862),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(10765),
    [sym_template_function] = STATE(7882),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6643),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_operator_cast_identifier] = STATE(8419),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2862),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2862),
    [sym_identifier] = ACTIONS(6140),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(6142),
    [anon_sym_in] = ACTIONS(6144),
    [anon_sym_out] = ACTIONS(6144),
    [anon_sym_inout] = ACTIONS(6144),
    [anon_sym_extern] = ACTIONS(6146),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(6150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6152),
    [anon_sym___declspec] = ACTIONS(6154),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(6146),
    [anon_sym_register] = ACTIONS(6146),
    [anon_sym_inline] = ACTIONS(6146),
    [anon_sym___inline] = ACTIONS(6146),
    [anon_sym___inline__] = ACTIONS(6146),
    [anon_sym___forceinline] = ACTIONS(6146),
    [anon_sym_thread_local] = ACTIONS(6146),
    [anon_sym___thread] = ACTIONS(6146),
    [anon_sym_const] = ACTIONS(6142),
    [anon_sym_constexpr] = ACTIONS(6142),
    [anon_sym_volatile] = ACTIONS(6142),
    [anon_sym_restrict] = ACTIONS(6142),
    [anon_sym___restrict__] = ACTIONS(6142),
    [anon_sym__Atomic] = ACTIONS(6142),
    [anon_sym__Noreturn] = ACTIONS(6142),
    [anon_sym_noreturn] = ACTIONS(6142),
    [anon_sym_mutable] = ACTIONS(6142),
    [anon_sym_constinit] = ACTIONS(6142),
    [anon_sym_consteval] = ACTIONS(6142),
    [anon_sym_alignas] = ACTIONS(6156),
    [anon_sym__Alignas] = ACTIONS(6156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(6144),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_precise] = ACTIONS(6158),
    [anon_sym_shared] = ACTIONS(6158),
    [anon_sym_groupshared] = ACTIONS(6158),
    [anon_sym_uniform] = ACTIONS(6158),
    [anon_sym_row_major] = ACTIONS(6158),
    [anon_sym_column_major] = ACTIONS(6158),
    [anon_sym_globallycoherent] = ACTIONS(6158),
    [anon_sym_centroid] = ACTIONS(6158),
    [anon_sym_noperspective] = ACTIONS(6158),
    [anon_sym_nointerpolation] = ACTIONS(6158),
    [anon_sym_sample] = ACTIONS(6158),
    [anon_sym_linear] = ACTIONS(6158),
    [anon_sym_snorm] = ACTIONS(6158),
    [anon_sym_unorm] = ACTIONS(6158),
    [anon_sym_point] = ACTIONS(6158),
    [anon_sym_line] = ACTIONS(6158),
    [anon_sym_triangleadj] = ACTIONS(6158),
    [anon_sym_lineadj] = ACTIONS(6158),
    [anon_sym_triangle] = ACTIONS(6158),
  },
  [2585] = {
    [sym__declaration_modifiers] = STATE(2862),
    [sym_attribute_specifier] = STATE(2862),
    [sym_attribute_declaration] = STATE(2862),
    [sym_ms_declspec_modifier] = STATE(2862),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7464),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2862),
    [sym_type_qualifier] = STATE(2862),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_decltype] = STATE(10765),
    [sym_explicit_function_specifier] = STATE(2862),
    [sym_operator_cast] = STATE(8400),
    [sym__constructor_specifiers] = STATE(2862),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(10765),
    [sym_template_function] = STATE(7882),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6643),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_operator_cast_identifier] = STATE(8400),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2862),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2862),
    [sym_identifier] = ACTIONS(6140),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(6142),
    [anon_sym_in] = ACTIONS(6144),
    [anon_sym_out] = ACTIONS(6144),
    [anon_sym_inout] = ACTIONS(6144),
    [anon_sym_extern] = ACTIONS(6146),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(6150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6152),
    [anon_sym___declspec] = ACTIONS(6154),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(6146),
    [anon_sym_register] = ACTIONS(6146),
    [anon_sym_inline] = ACTIONS(6146),
    [anon_sym___inline] = ACTIONS(6146),
    [anon_sym___inline__] = ACTIONS(6146),
    [anon_sym___forceinline] = ACTIONS(6146),
    [anon_sym_thread_local] = ACTIONS(6146),
    [anon_sym___thread] = ACTIONS(6146),
    [anon_sym_const] = ACTIONS(6142),
    [anon_sym_constexpr] = ACTIONS(6142),
    [anon_sym_volatile] = ACTIONS(6142),
    [anon_sym_restrict] = ACTIONS(6142),
    [anon_sym___restrict__] = ACTIONS(6142),
    [anon_sym__Atomic] = ACTIONS(6142),
    [anon_sym__Noreturn] = ACTIONS(6142),
    [anon_sym_noreturn] = ACTIONS(6142),
    [anon_sym_mutable] = ACTIONS(6142),
    [anon_sym_constinit] = ACTIONS(6142),
    [anon_sym_consteval] = ACTIONS(6142),
    [anon_sym_alignas] = ACTIONS(6156),
    [anon_sym__Alignas] = ACTIONS(6156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(6144),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_precise] = ACTIONS(6158),
    [anon_sym_shared] = ACTIONS(6158),
    [anon_sym_groupshared] = ACTIONS(6158),
    [anon_sym_uniform] = ACTIONS(6158),
    [anon_sym_row_major] = ACTIONS(6158),
    [anon_sym_column_major] = ACTIONS(6158),
    [anon_sym_globallycoherent] = ACTIONS(6158),
    [anon_sym_centroid] = ACTIONS(6158),
    [anon_sym_noperspective] = ACTIONS(6158),
    [anon_sym_nointerpolation] = ACTIONS(6158),
    [anon_sym_sample] = ACTIONS(6158),
    [anon_sym_linear] = ACTIONS(6158),
    [anon_sym_snorm] = ACTIONS(6158),
    [anon_sym_unorm] = ACTIONS(6158),
    [anon_sym_point] = ACTIONS(6158),
    [anon_sym_line] = ACTIONS(6158),
    [anon_sym_triangleadj] = ACTIONS(6158),
    [anon_sym_lineadj] = ACTIONS(6158),
    [anon_sym_triangle] = ACTIONS(6158),
  },
  [2586] = {
    [sym__declaration_modifiers] = STATE(2862),
    [sym_attribute_specifier] = STATE(2862),
    [sym_attribute_declaration] = STATE(2862),
    [sym_ms_declspec_modifier] = STATE(2862),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7362),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2862),
    [sym_type_qualifier] = STATE(2862),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_decltype] = STATE(10765),
    [sym_explicit_function_specifier] = STATE(2862),
    [sym_operator_cast] = STATE(8398),
    [sym__constructor_specifiers] = STATE(2862),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(10765),
    [sym_template_function] = STATE(7882),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6643),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_operator_cast_identifier] = STATE(8398),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2862),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2862),
    [sym_identifier] = ACTIONS(6140),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(6142),
    [anon_sym_in] = ACTIONS(6144),
    [anon_sym_out] = ACTIONS(6144),
    [anon_sym_inout] = ACTIONS(6144),
    [anon_sym_extern] = ACTIONS(6146),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(6150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6152),
    [anon_sym___declspec] = ACTIONS(6154),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(6146),
    [anon_sym_register] = ACTIONS(6146),
    [anon_sym_inline] = ACTIONS(6146),
    [anon_sym___inline] = ACTIONS(6146),
    [anon_sym___inline__] = ACTIONS(6146),
    [anon_sym___forceinline] = ACTIONS(6146),
    [anon_sym_thread_local] = ACTIONS(6146),
    [anon_sym___thread] = ACTIONS(6146),
    [anon_sym_const] = ACTIONS(6142),
    [anon_sym_constexpr] = ACTIONS(6142),
    [anon_sym_volatile] = ACTIONS(6142),
    [anon_sym_restrict] = ACTIONS(6142),
    [anon_sym___restrict__] = ACTIONS(6142),
    [anon_sym__Atomic] = ACTIONS(6142),
    [anon_sym__Noreturn] = ACTIONS(6142),
    [anon_sym_noreturn] = ACTIONS(6142),
    [anon_sym_mutable] = ACTIONS(6142),
    [anon_sym_constinit] = ACTIONS(6142),
    [anon_sym_consteval] = ACTIONS(6142),
    [anon_sym_alignas] = ACTIONS(6156),
    [anon_sym__Alignas] = ACTIONS(6156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(6144),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_precise] = ACTIONS(6158),
    [anon_sym_shared] = ACTIONS(6158),
    [anon_sym_groupshared] = ACTIONS(6158),
    [anon_sym_uniform] = ACTIONS(6158),
    [anon_sym_row_major] = ACTIONS(6158),
    [anon_sym_column_major] = ACTIONS(6158),
    [anon_sym_globallycoherent] = ACTIONS(6158),
    [anon_sym_centroid] = ACTIONS(6158),
    [anon_sym_noperspective] = ACTIONS(6158),
    [anon_sym_nointerpolation] = ACTIONS(6158),
    [anon_sym_sample] = ACTIONS(6158),
    [anon_sym_linear] = ACTIONS(6158),
    [anon_sym_snorm] = ACTIONS(6158),
    [anon_sym_unorm] = ACTIONS(6158),
    [anon_sym_point] = ACTIONS(6158),
    [anon_sym_line] = ACTIONS(6158),
    [anon_sym_triangleadj] = ACTIONS(6158),
    [anon_sym_lineadj] = ACTIONS(6158),
    [anon_sym_triangle] = ACTIONS(6158),
  },
  [2587] = {
    [sym__declaration_modifiers] = STATE(2862),
    [sym_attribute_specifier] = STATE(2862),
    [sym_attribute_declaration] = STATE(2862),
    [sym_ms_declspec_modifier] = STATE(2862),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7383),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2862),
    [sym_type_qualifier] = STATE(2862),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_decltype] = STATE(10765),
    [sym_explicit_function_specifier] = STATE(2862),
    [sym_operator_cast] = STATE(8366),
    [sym__constructor_specifiers] = STATE(2862),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(10765),
    [sym_template_function] = STATE(7882),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6643),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_operator_cast_identifier] = STATE(8366),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2862),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2862),
    [sym_identifier] = ACTIONS(6140),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(6142),
    [anon_sym_in] = ACTIONS(6144),
    [anon_sym_out] = ACTIONS(6144),
    [anon_sym_inout] = ACTIONS(6144),
    [anon_sym_extern] = ACTIONS(6146),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(6150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6152),
    [anon_sym___declspec] = ACTIONS(6154),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(6146),
    [anon_sym_register] = ACTIONS(6146),
    [anon_sym_inline] = ACTIONS(6146),
    [anon_sym___inline] = ACTIONS(6146),
    [anon_sym___inline__] = ACTIONS(6146),
    [anon_sym___forceinline] = ACTIONS(6146),
    [anon_sym_thread_local] = ACTIONS(6146),
    [anon_sym___thread] = ACTIONS(6146),
    [anon_sym_const] = ACTIONS(6142),
    [anon_sym_constexpr] = ACTIONS(6142),
    [anon_sym_volatile] = ACTIONS(6142),
    [anon_sym_restrict] = ACTIONS(6142),
    [anon_sym___restrict__] = ACTIONS(6142),
    [anon_sym__Atomic] = ACTIONS(6142),
    [anon_sym__Noreturn] = ACTIONS(6142),
    [anon_sym_noreturn] = ACTIONS(6142),
    [anon_sym_mutable] = ACTIONS(6142),
    [anon_sym_constinit] = ACTIONS(6142),
    [anon_sym_consteval] = ACTIONS(6142),
    [anon_sym_alignas] = ACTIONS(6156),
    [anon_sym__Alignas] = ACTIONS(6156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(6144),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_precise] = ACTIONS(6158),
    [anon_sym_shared] = ACTIONS(6158),
    [anon_sym_groupshared] = ACTIONS(6158),
    [anon_sym_uniform] = ACTIONS(6158),
    [anon_sym_row_major] = ACTIONS(6158),
    [anon_sym_column_major] = ACTIONS(6158),
    [anon_sym_globallycoherent] = ACTIONS(6158),
    [anon_sym_centroid] = ACTIONS(6158),
    [anon_sym_noperspective] = ACTIONS(6158),
    [anon_sym_nointerpolation] = ACTIONS(6158),
    [anon_sym_sample] = ACTIONS(6158),
    [anon_sym_linear] = ACTIONS(6158),
    [anon_sym_snorm] = ACTIONS(6158),
    [anon_sym_unorm] = ACTIONS(6158),
    [anon_sym_point] = ACTIONS(6158),
    [anon_sym_line] = ACTIONS(6158),
    [anon_sym_triangleadj] = ACTIONS(6158),
    [anon_sym_lineadj] = ACTIONS(6158),
    [anon_sym_triangle] = ACTIONS(6158),
  },
  [2588] = {
    [sym__declaration_modifiers] = STATE(2862),
    [sym_attribute_specifier] = STATE(2862),
    [sym_attribute_declaration] = STATE(2862),
    [sym_ms_declspec_modifier] = STATE(2862),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7545),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2862),
    [sym_type_qualifier] = STATE(2862),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_decltype] = STATE(10765),
    [sym_explicit_function_specifier] = STATE(2862),
    [sym_operator_cast] = STATE(8398),
    [sym__constructor_specifiers] = STATE(2862),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(10765),
    [sym_template_function] = STATE(7882),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6643),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_operator_cast_identifier] = STATE(8398),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2862),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2862),
    [sym_identifier] = ACTIONS(6140),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(6142),
    [anon_sym_in] = ACTIONS(6144),
    [anon_sym_out] = ACTIONS(6144),
    [anon_sym_inout] = ACTIONS(6144),
    [anon_sym_extern] = ACTIONS(6146),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(6150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6152),
    [anon_sym___declspec] = ACTIONS(6154),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(6146),
    [anon_sym_register] = ACTIONS(6146),
    [anon_sym_inline] = ACTIONS(6146),
    [anon_sym___inline] = ACTIONS(6146),
    [anon_sym___inline__] = ACTIONS(6146),
    [anon_sym___forceinline] = ACTIONS(6146),
    [anon_sym_thread_local] = ACTIONS(6146),
    [anon_sym___thread] = ACTIONS(6146),
    [anon_sym_const] = ACTIONS(6142),
    [anon_sym_constexpr] = ACTIONS(6142),
    [anon_sym_volatile] = ACTIONS(6142),
    [anon_sym_restrict] = ACTIONS(6142),
    [anon_sym___restrict__] = ACTIONS(6142),
    [anon_sym__Atomic] = ACTIONS(6142),
    [anon_sym__Noreturn] = ACTIONS(6142),
    [anon_sym_noreturn] = ACTIONS(6142),
    [anon_sym_mutable] = ACTIONS(6142),
    [anon_sym_constinit] = ACTIONS(6142),
    [anon_sym_consteval] = ACTIONS(6142),
    [anon_sym_alignas] = ACTIONS(6156),
    [anon_sym__Alignas] = ACTIONS(6156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(6144),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_precise] = ACTIONS(6158),
    [anon_sym_shared] = ACTIONS(6158),
    [anon_sym_groupshared] = ACTIONS(6158),
    [anon_sym_uniform] = ACTIONS(6158),
    [anon_sym_row_major] = ACTIONS(6158),
    [anon_sym_column_major] = ACTIONS(6158),
    [anon_sym_globallycoherent] = ACTIONS(6158),
    [anon_sym_centroid] = ACTIONS(6158),
    [anon_sym_noperspective] = ACTIONS(6158),
    [anon_sym_nointerpolation] = ACTIONS(6158),
    [anon_sym_sample] = ACTIONS(6158),
    [anon_sym_linear] = ACTIONS(6158),
    [anon_sym_snorm] = ACTIONS(6158),
    [anon_sym_unorm] = ACTIONS(6158),
    [anon_sym_point] = ACTIONS(6158),
    [anon_sym_line] = ACTIONS(6158),
    [anon_sym_triangleadj] = ACTIONS(6158),
    [anon_sym_lineadj] = ACTIONS(6158),
    [anon_sym_triangle] = ACTIONS(6158),
  },
  [2589] = {
    [sym__declaration_modifiers] = STATE(2862),
    [sym_attribute_specifier] = STATE(2862),
    [sym_attribute_declaration] = STATE(2862),
    [sym_ms_declspec_modifier] = STATE(2862),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7450),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2862),
    [sym_type_qualifier] = STATE(2862),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_decltype] = STATE(10765),
    [sym_explicit_function_specifier] = STATE(2862),
    [sym_operator_cast] = STATE(8419),
    [sym__constructor_specifiers] = STATE(2862),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(10765),
    [sym_template_function] = STATE(7882),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6643),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_operator_cast_identifier] = STATE(8419),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2862),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2862),
    [sym_identifier] = ACTIONS(6140),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(6142),
    [anon_sym_in] = ACTIONS(6144),
    [anon_sym_out] = ACTIONS(6144),
    [anon_sym_inout] = ACTIONS(6144),
    [anon_sym_extern] = ACTIONS(6146),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(6150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6152),
    [anon_sym___declspec] = ACTIONS(6154),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(6146),
    [anon_sym_register] = ACTIONS(6146),
    [anon_sym_inline] = ACTIONS(6146),
    [anon_sym___inline] = ACTIONS(6146),
    [anon_sym___inline__] = ACTIONS(6146),
    [anon_sym___forceinline] = ACTIONS(6146),
    [anon_sym_thread_local] = ACTIONS(6146),
    [anon_sym___thread] = ACTIONS(6146),
    [anon_sym_const] = ACTIONS(6142),
    [anon_sym_constexpr] = ACTIONS(6142),
    [anon_sym_volatile] = ACTIONS(6142),
    [anon_sym_restrict] = ACTIONS(6142),
    [anon_sym___restrict__] = ACTIONS(6142),
    [anon_sym__Atomic] = ACTIONS(6142),
    [anon_sym__Noreturn] = ACTIONS(6142),
    [anon_sym_noreturn] = ACTIONS(6142),
    [anon_sym_mutable] = ACTIONS(6142),
    [anon_sym_constinit] = ACTIONS(6142),
    [anon_sym_consteval] = ACTIONS(6142),
    [anon_sym_alignas] = ACTIONS(6156),
    [anon_sym__Alignas] = ACTIONS(6156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(6144),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_precise] = ACTIONS(6158),
    [anon_sym_shared] = ACTIONS(6158),
    [anon_sym_groupshared] = ACTIONS(6158),
    [anon_sym_uniform] = ACTIONS(6158),
    [anon_sym_row_major] = ACTIONS(6158),
    [anon_sym_column_major] = ACTIONS(6158),
    [anon_sym_globallycoherent] = ACTIONS(6158),
    [anon_sym_centroid] = ACTIONS(6158),
    [anon_sym_noperspective] = ACTIONS(6158),
    [anon_sym_nointerpolation] = ACTIONS(6158),
    [anon_sym_sample] = ACTIONS(6158),
    [anon_sym_linear] = ACTIONS(6158),
    [anon_sym_snorm] = ACTIONS(6158),
    [anon_sym_unorm] = ACTIONS(6158),
    [anon_sym_point] = ACTIONS(6158),
    [anon_sym_line] = ACTIONS(6158),
    [anon_sym_triangleadj] = ACTIONS(6158),
    [anon_sym_lineadj] = ACTIONS(6158),
    [anon_sym_triangle] = ACTIONS(6158),
  },
  [2590] = {
    [sym__declaration_modifiers] = STATE(2862),
    [sym_attribute_specifier] = STATE(2862),
    [sym_attribute_declaration] = STATE(2862),
    [sym_ms_declspec_modifier] = STATE(2862),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7364),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2862),
    [sym_type_qualifier] = STATE(2862),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_decltype] = STATE(10765),
    [sym_explicit_function_specifier] = STATE(2862),
    [sym_operator_cast] = STATE(8383),
    [sym__constructor_specifiers] = STATE(2862),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(10765),
    [sym_template_function] = STATE(7882),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6643),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_operator_cast_identifier] = STATE(8383),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2862),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2862),
    [sym_identifier] = ACTIONS(6140),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(6142),
    [anon_sym_in] = ACTIONS(6144),
    [anon_sym_out] = ACTIONS(6144),
    [anon_sym_inout] = ACTIONS(6144),
    [anon_sym_extern] = ACTIONS(6146),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(6150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6152),
    [anon_sym___declspec] = ACTIONS(6154),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(6146),
    [anon_sym_register] = ACTIONS(6146),
    [anon_sym_inline] = ACTIONS(6146),
    [anon_sym___inline] = ACTIONS(6146),
    [anon_sym___inline__] = ACTIONS(6146),
    [anon_sym___forceinline] = ACTIONS(6146),
    [anon_sym_thread_local] = ACTIONS(6146),
    [anon_sym___thread] = ACTIONS(6146),
    [anon_sym_const] = ACTIONS(6142),
    [anon_sym_constexpr] = ACTIONS(6142),
    [anon_sym_volatile] = ACTIONS(6142),
    [anon_sym_restrict] = ACTIONS(6142),
    [anon_sym___restrict__] = ACTIONS(6142),
    [anon_sym__Atomic] = ACTIONS(6142),
    [anon_sym__Noreturn] = ACTIONS(6142),
    [anon_sym_noreturn] = ACTIONS(6142),
    [anon_sym_mutable] = ACTIONS(6142),
    [anon_sym_constinit] = ACTIONS(6142),
    [anon_sym_consteval] = ACTIONS(6142),
    [anon_sym_alignas] = ACTIONS(6156),
    [anon_sym__Alignas] = ACTIONS(6156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(6144),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_precise] = ACTIONS(6158),
    [anon_sym_shared] = ACTIONS(6158),
    [anon_sym_groupshared] = ACTIONS(6158),
    [anon_sym_uniform] = ACTIONS(6158),
    [anon_sym_row_major] = ACTIONS(6158),
    [anon_sym_column_major] = ACTIONS(6158),
    [anon_sym_globallycoherent] = ACTIONS(6158),
    [anon_sym_centroid] = ACTIONS(6158),
    [anon_sym_noperspective] = ACTIONS(6158),
    [anon_sym_nointerpolation] = ACTIONS(6158),
    [anon_sym_sample] = ACTIONS(6158),
    [anon_sym_linear] = ACTIONS(6158),
    [anon_sym_snorm] = ACTIONS(6158),
    [anon_sym_unorm] = ACTIONS(6158),
    [anon_sym_point] = ACTIONS(6158),
    [anon_sym_line] = ACTIONS(6158),
    [anon_sym_triangleadj] = ACTIONS(6158),
    [anon_sym_lineadj] = ACTIONS(6158),
    [anon_sym_triangle] = ACTIONS(6158),
  },
  [2591] = {
    [sym__declaration_modifiers] = STATE(2862),
    [sym_attribute_specifier] = STATE(2862),
    [sym_attribute_declaration] = STATE(2862),
    [sym_ms_declspec_modifier] = STATE(2862),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7466),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2862),
    [sym_type_qualifier] = STATE(2862),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_decltype] = STATE(10765),
    [sym_explicit_function_specifier] = STATE(2862),
    [sym_operator_cast] = STATE(8432),
    [sym__constructor_specifiers] = STATE(2862),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(10765),
    [sym_template_function] = STATE(7882),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6643),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_operator_cast_identifier] = STATE(8432),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2862),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2862),
    [sym_identifier] = ACTIONS(6140),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(6142),
    [anon_sym_in] = ACTIONS(6144),
    [anon_sym_out] = ACTIONS(6144),
    [anon_sym_inout] = ACTIONS(6144),
    [anon_sym_extern] = ACTIONS(6146),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(6150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6152),
    [anon_sym___declspec] = ACTIONS(6154),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(6146),
    [anon_sym_register] = ACTIONS(6146),
    [anon_sym_inline] = ACTIONS(6146),
    [anon_sym___inline] = ACTIONS(6146),
    [anon_sym___inline__] = ACTIONS(6146),
    [anon_sym___forceinline] = ACTIONS(6146),
    [anon_sym_thread_local] = ACTIONS(6146),
    [anon_sym___thread] = ACTIONS(6146),
    [anon_sym_const] = ACTIONS(6142),
    [anon_sym_constexpr] = ACTIONS(6142),
    [anon_sym_volatile] = ACTIONS(6142),
    [anon_sym_restrict] = ACTIONS(6142),
    [anon_sym___restrict__] = ACTIONS(6142),
    [anon_sym__Atomic] = ACTIONS(6142),
    [anon_sym__Noreturn] = ACTIONS(6142),
    [anon_sym_noreturn] = ACTIONS(6142),
    [anon_sym_mutable] = ACTIONS(6142),
    [anon_sym_constinit] = ACTIONS(6142),
    [anon_sym_consteval] = ACTIONS(6142),
    [anon_sym_alignas] = ACTIONS(6156),
    [anon_sym__Alignas] = ACTIONS(6156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(6144),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_precise] = ACTIONS(6158),
    [anon_sym_shared] = ACTIONS(6158),
    [anon_sym_groupshared] = ACTIONS(6158),
    [anon_sym_uniform] = ACTIONS(6158),
    [anon_sym_row_major] = ACTIONS(6158),
    [anon_sym_column_major] = ACTIONS(6158),
    [anon_sym_globallycoherent] = ACTIONS(6158),
    [anon_sym_centroid] = ACTIONS(6158),
    [anon_sym_noperspective] = ACTIONS(6158),
    [anon_sym_nointerpolation] = ACTIONS(6158),
    [anon_sym_sample] = ACTIONS(6158),
    [anon_sym_linear] = ACTIONS(6158),
    [anon_sym_snorm] = ACTIONS(6158),
    [anon_sym_unorm] = ACTIONS(6158),
    [anon_sym_point] = ACTIONS(6158),
    [anon_sym_line] = ACTIONS(6158),
    [anon_sym_triangleadj] = ACTIONS(6158),
    [anon_sym_lineadj] = ACTIONS(6158),
    [anon_sym_triangle] = ACTIONS(6158),
  },
  [2592] = {
    [sym__declaration_modifiers] = STATE(2862),
    [sym_attribute_specifier] = STATE(2862),
    [sym_attribute_declaration] = STATE(2862),
    [sym_ms_declspec_modifier] = STATE(2862),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7568),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2862),
    [sym_type_qualifier] = STATE(2862),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_decltype] = STATE(10765),
    [sym_explicit_function_specifier] = STATE(2862),
    [sym_operator_cast] = STATE(8366),
    [sym__constructor_specifiers] = STATE(2862),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(10765),
    [sym_template_function] = STATE(7882),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6643),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_operator_cast_identifier] = STATE(8366),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2862),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2862),
    [sym_identifier] = ACTIONS(6140),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(6142),
    [anon_sym_in] = ACTIONS(6144),
    [anon_sym_out] = ACTIONS(6144),
    [anon_sym_inout] = ACTIONS(6144),
    [anon_sym_extern] = ACTIONS(6146),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(6150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6152),
    [anon_sym___declspec] = ACTIONS(6154),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(6146),
    [anon_sym_register] = ACTIONS(6146),
    [anon_sym_inline] = ACTIONS(6146),
    [anon_sym___inline] = ACTIONS(6146),
    [anon_sym___inline__] = ACTIONS(6146),
    [anon_sym___forceinline] = ACTIONS(6146),
    [anon_sym_thread_local] = ACTIONS(6146),
    [anon_sym___thread] = ACTIONS(6146),
    [anon_sym_const] = ACTIONS(6142),
    [anon_sym_constexpr] = ACTIONS(6142),
    [anon_sym_volatile] = ACTIONS(6142),
    [anon_sym_restrict] = ACTIONS(6142),
    [anon_sym___restrict__] = ACTIONS(6142),
    [anon_sym__Atomic] = ACTIONS(6142),
    [anon_sym__Noreturn] = ACTIONS(6142),
    [anon_sym_noreturn] = ACTIONS(6142),
    [anon_sym_mutable] = ACTIONS(6142),
    [anon_sym_constinit] = ACTIONS(6142),
    [anon_sym_consteval] = ACTIONS(6142),
    [anon_sym_alignas] = ACTIONS(6156),
    [anon_sym__Alignas] = ACTIONS(6156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(6144),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_precise] = ACTIONS(6158),
    [anon_sym_shared] = ACTIONS(6158),
    [anon_sym_groupshared] = ACTIONS(6158),
    [anon_sym_uniform] = ACTIONS(6158),
    [anon_sym_row_major] = ACTIONS(6158),
    [anon_sym_column_major] = ACTIONS(6158),
    [anon_sym_globallycoherent] = ACTIONS(6158),
    [anon_sym_centroid] = ACTIONS(6158),
    [anon_sym_noperspective] = ACTIONS(6158),
    [anon_sym_nointerpolation] = ACTIONS(6158),
    [anon_sym_sample] = ACTIONS(6158),
    [anon_sym_linear] = ACTIONS(6158),
    [anon_sym_snorm] = ACTIONS(6158),
    [anon_sym_unorm] = ACTIONS(6158),
    [anon_sym_point] = ACTIONS(6158),
    [anon_sym_line] = ACTIONS(6158),
    [anon_sym_triangleadj] = ACTIONS(6158),
    [anon_sym_lineadj] = ACTIONS(6158),
    [anon_sym_triangle] = ACTIONS(6158),
  },
  [2593] = {
    [sym__declaration_modifiers] = STATE(2862),
    [sym_attribute_specifier] = STATE(2862),
    [sym_attribute_declaration] = STATE(2862),
    [sym_ms_declspec_modifier] = STATE(2862),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7423),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2862),
    [sym_type_qualifier] = STATE(2862),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_decltype] = STATE(10765),
    [sym_explicit_function_specifier] = STATE(2862),
    [sym_operator_cast] = STATE(8508),
    [sym__constructor_specifiers] = STATE(2862),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(10765),
    [sym_template_function] = STATE(7882),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6643),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_operator_cast_identifier] = STATE(8508),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2862),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2862),
    [sym_identifier] = ACTIONS(6140),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(6142),
    [anon_sym_in] = ACTIONS(6144),
    [anon_sym_out] = ACTIONS(6144),
    [anon_sym_inout] = ACTIONS(6144),
    [anon_sym_extern] = ACTIONS(6146),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(6150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6152),
    [anon_sym___declspec] = ACTIONS(6154),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(6146),
    [anon_sym_register] = ACTIONS(6146),
    [anon_sym_inline] = ACTIONS(6146),
    [anon_sym___inline] = ACTIONS(6146),
    [anon_sym___inline__] = ACTIONS(6146),
    [anon_sym___forceinline] = ACTIONS(6146),
    [anon_sym_thread_local] = ACTIONS(6146),
    [anon_sym___thread] = ACTIONS(6146),
    [anon_sym_const] = ACTIONS(6142),
    [anon_sym_constexpr] = ACTIONS(6142),
    [anon_sym_volatile] = ACTIONS(6142),
    [anon_sym_restrict] = ACTIONS(6142),
    [anon_sym___restrict__] = ACTIONS(6142),
    [anon_sym__Atomic] = ACTIONS(6142),
    [anon_sym__Noreturn] = ACTIONS(6142),
    [anon_sym_noreturn] = ACTIONS(6142),
    [anon_sym_mutable] = ACTIONS(6142),
    [anon_sym_constinit] = ACTIONS(6142),
    [anon_sym_consteval] = ACTIONS(6142),
    [anon_sym_alignas] = ACTIONS(6156),
    [anon_sym__Alignas] = ACTIONS(6156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(6144),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_precise] = ACTIONS(6158),
    [anon_sym_shared] = ACTIONS(6158),
    [anon_sym_groupshared] = ACTIONS(6158),
    [anon_sym_uniform] = ACTIONS(6158),
    [anon_sym_row_major] = ACTIONS(6158),
    [anon_sym_column_major] = ACTIONS(6158),
    [anon_sym_globallycoherent] = ACTIONS(6158),
    [anon_sym_centroid] = ACTIONS(6158),
    [anon_sym_noperspective] = ACTIONS(6158),
    [anon_sym_nointerpolation] = ACTIONS(6158),
    [anon_sym_sample] = ACTIONS(6158),
    [anon_sym_linear] = ACTIONS(6158),
    [anon_sym_snorm] = ACTIONS(6158),
    [anon_sym_unorm] = ACTIONS(6158),
    [anon_sym_point] = ACTIONS(6158),
    [anon_sym_line] = ACTIONS(6158),
    [anon_sym_triangleadj] = ACTIONS(6158),
    [anon_sym_lineadj] = ACTIONS(6158),
    [anon_sym_triangle] = ACTIONS(6158),
  },
  [2594] = {
    [sym__declaration_modifiers] = STATE(2862),
    [sym_attribute_specifier] = STATE(2862),
    [sym_attribute_declaration] = STATE(2862),
    [sym_ms_declspec_modifier] = STATE(2862),
    [sym_ms_based_modifier] = STATE(10814),
    [sym__declarator] = STATE(8279),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_function_declarator] = STATE(7556),
    [sym_array_declarator] = STATE(7882),
    [sym_storage_class_specifier] = STATE(2862),
    [sym_type_qualifier] = STATE(2862),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_decltype] = STATE(10765),
    [sym_explicit_function_specifier] = STATE(2862),
    [sym_operator_cast] = STATE(8400),
    [sym__constructor_specifiers] = STATE(2862),
    [sym_reference_declarator] = STATE(7882),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym_template_type] = STATE(10765),
    [sym_template_function] = STATE(7882),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6643),
    [sym_qualified_identifier] = STATE(7882),
    [sym_qualified_operator_cast_identifier] = STATE(8400),
    [sym_operator_name] = STATE(7882),
    [sym_qualifiers] = STATE(2862),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2862),
    [sym_identifier] = ACTIONS(6140),
    [anon_sym_LPAREN2] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym___extension__] = ACTIONS(6142),
    [anon_sym_in] = ACTIONS(6144),
    [anon_sym_out] = ACTIONS(6144),
    [anon_sym_inout] = ACTIONS(6144),
    [anon_sym_extern] = ACTIONS(6146),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(6150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6152),
    [anon_sym___declspec] = ACTIONS(6154),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(6146),
    [anon_sym_register] = ACTIONS(6146),
    [anon_sym_inline] = ACTIONS(6146),
    [anon_sym___inline] = ACTIONS(6146),
    [anon_sym___inline__] = ACTIONS(6146),
    [anon_sym___forceinline] = ACTIONS(6146),
    [anon_sym_thread_local] = ACTIONS(6146),
    [anon_sym___thread] = ACTIONS(6146),
    [anon_sym_const] = ACTIONS(6142),
    [anon_sym_constexpr] = ACTIONS(6142),
    [anon_sym_volatile] = ACTIONS(6142),
    [anon_sym_restrict] = ACTIONS(6142),
    [anon_sym___restrict__] = ACTIONS(6142),
    [anon_sym__Atomic] = ACTIONS(6142),
    [anon_sym__Noreturn] = ACTIONS(6142),
    [anon_sym_noreturn] = ACTIONS(6142),
    [anon_sym_mutable] = ACTIONS(6142),
    [anon_sym_constinit] = ACTIONS(6142),
    [anon_sym_consteval] = ACTIONS(6142),
    [anon_sym_alignas] = ACTIONS(6156),
    [anon_sym__Alignas] = ACTIONS(6156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(6144),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_precise] = ACTIONS(6158),
    [anon_sym_shared] = ACTIONS(6158),
    [anon_sym_groupshared] = ACTIONS(6158),
    [anon_sym_uniform] = ACTIONS(6158),
    [anon_sym_row_major] = ACTIONS(6158),
    [anon_sym_column_major] = ACTIONS(6158),
    [anon_sym_globallycoherent] = ACTIONS(6158),
    [anon_sym_centroid] = ACTIONS(6158),
    [anon_sym_noperspective] = ACTIONS(6158),
    [anon_sym_nointerpolation] = ACTIONS(6158),
    [anon_sym_sample] = ACTIONS(6158),
    [anon_sym_linear] = ACTIONS(6158),
    [anon_sym_snorm] = ACTIONS(6158),
    [anon_sym_unorm] = ACTIONS(6158),
    [anon_sym_point] = ACTIONS(6158),
    [anon_sym_line] = ACTIONS(6158),
    [anon_sym_triangleadj] = ACTIONS(6158),
    [anon_sym_lineadj] = ACTIONS(6158),
    [anon_sym_triangle] = ACTIONS(6158),
  },
  [2595] = {
    [sym_template_argument_list] = STATE(2609),
    [sym_identifier] = ACTIONS(2169),
    [anon_sym_LPAREN2] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_STAR] = ACTIONS(2176),
    [anon_sym_PIPE_PIPE] = ACTIONS(2176),
    [anon_sym_AMP_AMP] = ACTIONS(2176),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(6160),
    [anon_sym___extension__] = ACTIONS(2169),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_out] = ACTIONS(2169),
    [anon_sym_inout] = ACTIONS(2169),
    [anon_sym_extern] = ACTIONS(2169),
    [anon_sym___attribute__] = ACTIONS(2169),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2176),
    [anon_sym___declspec] = ACTIONS(2169),
    [anon_sym___based] = ACTIONS(2169),
    [anon_sym___cdecl] = ACTIONS(2169),
    [anon_sym___clrcall] = ACTIONS(2169),
    [anon_sym___stdcall] = ACTIONS(2169),
    [anon_sym___fastcall] = ACTIONS(2169),
    [anon_sym___thiscall] = ACTIONS(2169),
    [anon_sym___vectorcall] = ACTIONS(2169),
    [anon_sym_signed] = ACTIONS(2169),
    [anon_sym_unsigned] = ACTIONS(2169),
    [anon_sym_long] = ACTIONS(2169),
    [anon_sym_short] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(2169),
    [anon_sym_static] = ACTIONS(2169),
    [anon_sym_register] = ACTIONS(2169),
    [anon_sym_inline] = ACTIONS(2169),
    [anon_sym___inline] = ACTIONS(2169),
    [anon_sym___inline__] = ACTIONS(2169),
    [anon_sym___forceinline] = ACTIONS(2169),
    [anon_sym_thread_local] = ACTIONS(2169),
    [anon_sym___thread] = ACTIONS(2169),
    [anon_sym_const] = ACTIONS(2169),
    [anon_sym_constexpr] = ACTIONS(2169),
    [anon_sym_volatile] = ACTIONS(2169),
    [anon_sym_restrict] = ACTIONS(2169),
    [anon_sym___restrict__] = ACTIONS(2169),
    [anon_sym__Atomic] = ACTIONS(2169),
    [anon_sym__Noreturn] = ACTIONS(2169),
    [anon_sym_noreturn] = ACTIONS(2169),
    [anon_sym_mutable] = ACTIONS(2169),
    [anon_sym_constinit] = ACTIONS(2169),
    [anon_sym_consteval] = ACTIONS(2169),
    [anon_sym_alignas] = ACTIONS(2169),
    [anon_sym__Alignas] = ACTIONS(2169),
    [sym_primitive_type] = ACTIONS(2169),
    [anon_sym_enum] = ACTIONS(2169),
    [anon_sym_class] = ACTIONS(2169),
    [anon_sym_struct] = ACTIONS(2169),
    [anon_sym_union] = ACTIONS(2169),
    [anon_sym_or] = ACTIONS(2169),
    [anon_sym_and] = ACTIONS(2169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2169),
    [anon_sym_let] = ACTIONS(2169),
    [anon_sym_This] = ACTIONS(2169),
    [anon_sym_decltype] = ACTIONS(2169),
    [sym_virtual] = ACTIONS(2169),
    [anon_sym_explicit] = ACTIONS(2169),
    [anon_sym_typename] = ACTIONS(2169),
    [anon_sym_template] = ACTIONS(2169),
    [anon_sym_operator] = ACTIONS(2169),
    [anon_sym_friend] = ACTIONS(2169),
    [anon_sym_using] = ACTIONS(2169),
    [anon_sym_concept] = ACTIONS(2169),
    [anon_sym_precise] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_groupshared] = ACTIONS(2169),
    [anon_sym_uniform] = ACTIONS(2169),
    [anon_sym_row_major] = ACTIONS(2169),
    [anon_sym_column_major] = ACTIONS(2169),
    [anon_sym_globallycoherent] = ACTIONS(2169),
    [anon_sym_centroid] = ACTIONS(2169),
    [anon_sym_noperspective] = ACTIONS(2169),
    [anon_sym_nointerpolation] = ACTIONS(2169),
    [anon_sym_sample] = ACTIONS(2169),
    [anon_sym_linear] = ACTIONS(2169),
    [anon_sym_snorm] = ACTIONS(2169),
    [anon_sym_unorm] = ACTIONS(2169),
    [anon_sym_point] = ACTIONS(2169),
    [anon_sym_line] = ACTIONS(2169),
    [anon_sym_triangleadj] = ACTIONS(2169),
    [anon_sym_lineadj] = ACTIONS(2169),
    [anon_sym_triangle] = ACTIONS(2169),
    [anon_sym_interface] = ACTIONS(2169),
    [anon_sym_extension] = ACTIONS(2169),
  },
  [2596] = {
    [sym_string_literal] = STATE(2997),
    [sym_template_argument_list] = STATE(2836),
    [sym_raw_string_literal] = STATE(2997),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_RPAREN] = ACTIONS(2119),
    [anon_sym_LPAREN2] = ACTIONS(2119),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2130),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(6162),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym___extension__] = ACTIONS(2123),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6165),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_signed] = ACTIONS(6167),
    [anon_sym_unsigned] = ACTIONS(6167),
    [anon_sym_long] = ACTIONS(6167),
    [anon_sym_short] = ACTIONS(6167),
    [anon_sym_LBRACK] = ACTIONS(2148),
    [anon_sym_EQ] = ACTIONS(2128),
    [anon_sym_const] = ACTIONS(2115),
    [anon_sym_constexpr] = ACTIONS(2123),
    [anon_sym_volatile] = ACTIONS(2123),
    [anon_sym_restrict] = ACTIONS(2123),
    [anon_sym___restrict__] = ACTIONS(2123),
    [anon_sym__Atomic] = ACTIONS(2123),
    [anon_sym__Noreturn] = ACTIONS(2123),
    [anon_sym_noreturn] = ACTIONS(2123),
    [anon_sym_mutable] = ACTIONS(2123),
    [anon_sym_constinit] = ACTIONS(2123),
    [anon_sym_consteval] = ACTIONS(2123),
    [anon_sym_alignas] = ACTIONS(2123),
    [anon_sym__Alignas] = ACTIONS(2123),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2117),
    [anon_sym_SLASH_EQ] = ACTIONS(2117),
    [anon_sym_PERCENT_EQ] = ACTIONS(2117),
    [anon_sym_PLUS_EQ] = ACTIONS(2117),
    [anon_sym_DASH_EQ] = ACTIONS(2117),
    [anon_sym_LT_LT_EQ] = ACTIONS(2117),
    [anon_sym_GT_GT_EQ] = ACTIONS(2117),
    [anon_sym_AMP_EQ] = ACTIONS(2117),
    [anon_sym_CARET_EQ] = ACTIONS(2117),
    [anon_sym_PIPE_EQ] = ACTIONS(2117),
    [anon_sym_and_eq] = ACTIONS(2117),
    [anon_sym_or_eq] = ACTIONS(2117),
    [anon_sym_xor_eq] = ACTIONS(2117),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2117),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2117),
    [anon_sym_not_eq] = ACTIONS(2117),
    [anon_sym_is] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2125),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2128),
    [anon_sym_L_DQUOTE] = ACTIONS(6169),
    [anon_sym_u_DQUOTE] = ACTIONS(6169),
    [anon_sym_U_DQUOTE] = ACTIONS(6169),
    [anon_sym_u8_DQUOTE] = ACTIONS(6169),
    [anon_sym_DQUOTE] = ACTIONS(6169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2123),
    [anon_sym_let] = ACTIONS(2123),
    [anon_sym_This] = ACTIONS(2123),
    [anon_sym_R_DQUOTE] = ACTIONS(6171),
    [anon_sym_LR_DQUOTE] = ACTIONS(6171),
    [anon_sym_uR_DQUOTE] = ACTIONS(6171),
    [anon_sym_UR_DQUOTE] = ACTIONS(6171),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6171),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2117),
  },
  [2597] = {
    [sym_template_argument_list] = STATE(2609),
    [sym_identifier] = ACTIONS(2349),
    [anon_sym_LPAREN2] = ACTIONS(2347),
    [anon_sym_TILDE] = ACTIONS(2347),
    [anon_sym_STAR] = ACTIONS(2347),
    [anon_sym_PIPE_PIPE] = ACTIONS(2347),
    [anon_sym_AMP_AMP] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2349),
    [anon_sym_LT] = ACTIONS(6160),
    [anon_sym___extension__] = ACTIONS(2349),
    [anon_sym_in] = ACTIONS(2349),
    [anon_sym_out] = ACTIONS(2349),
    [anon_sym_inout] = ACTIONS(2349),
    [anon_sym_extern] = ACTIONS(2349),
    [anon_sym___attribute__] = ACTIONS(2349),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2347),
    [anon_sym___declspec] = ACTIONS(2349),
    [anon_sym___based] = ACTIONS(2349),
    [anon_sym___cdecl] = ACTIONS(2349),
    [anon_sym___clrcall] = ACTIONS(2349),
    [anon_sym___stdcall] = ACTIONS(2349),
    [anon_sym___fastcall] = ACTIONS(2349),
    [anon_sym___thiscall] = ACTIONS(2349),
    [anon_sym___vectorcall] = ACTIONS(2349),
    [anon_sym_signed] = ACTIONS(2349),
    [anon_sym_unsigned] = ACTIONS(2349),
    [anon_sym_long] = ACTIONS(2349),
    [anon_sym_short] = ACTIONS(2349),
    [anon_sym_LBRACK] = ACTIONS(2349),
    [anon_sym_static] = ACTIONS(2349),
    [anon_sym_register] = ACTIONS(2349),
    [anon_sym_inline] = ACTIONS(2349),
    [anon_sym___inline] = ACTIONS(2349),
    [anon_sym___inline__] = ACTIONS(2349),
    [anon_sym___forceinline] = ACTIONS(2349),
    [anon_sym_thread_local] = ACTIONS(2349),
    [anon_sym___thread] = ACTIONS(2349),
    [anon_sym_const] = ACTIONS(2349),
    [anon_sym_constexpr] = ACTIONS(2349),
    [anon_sym_volatile] = ACTIONS(2349),
    [anon_sym_restrict] = ACTIONS(2349),
    [anon_sym___restrict__] = ACTIONS(2349),
    [anon_sym__Atomic] = ACTIONS(2349),
    [anon_sym__Noreturn] = ACTIONS(2349),
    [anon_sym_noreturn] = ACTIONS(2349),
    [anon_sym_mutable] = ACTIONS(2349),
    [anon_sym_constinit] = ACTIONS(2349),
    [anon_sym_consteval] = ACTIONS(2349),
    [anon_sym_alignas] = ACTIONS(2349),
    [anon_sym__Alignas] = ACTIONS(2349),
    [sym_primitive_type] = ACTIONS(2349),
    [anon_sym_enum] = ACTIONS(2349),
    [anon_sym_class] = ACTIONS(2349),
    [anon_sym_struct] = ACTIONS(2349),
    [anon_sym_union] = ACTIONS(2349),
    [anon_sym_or] = ACTIONS(2349),
    [anon_sym_and] = ACTIONS(2349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2349),
    [anon_sym_let] = ACTIONS(2349),
    [anon_sym_This] = ACTIONS(2349),
    [anon_sym_decltype] = ACTIONS(2349),
    [sym_virtual] = ACTIONS(2349),
    [anon_sym_explicit] = ACTIONS(2349),
    [anon_sym_typename] = ACTIONS(2349),
    [anon_sym_template] = ACTIONS(2349),
    [anon_sym_operator] = ACTIONS(2349),
    [anon_sym_friend] = ACTIONS(2349),
    [anon_sym_using] = ACTIONS(2349),
    [anon_sym_concept] = ACTIONS(2349),
    [anon_sym_precise] = ACTIONS(2349),
    [anon_sym_shared] = ACTIONS(2349),
    [anon_sym_groupshared] = ACTIONS(2349),
    [anon_sym_uniform] = ACTIONS(2349),
    [anon_sym_row_major] = ACTIONS(2349),
    [anon_sym_column_major] = ACTIONS(2349),
    [anon_sym_globallycoherent] = ACTIONS(2349),
    [anon_sym_centroid] = ACTIONS(2349),
    [anon_sym_noperspective] = ACTIONS(2349),
    [anon_sym_nointerpolation] = ACTIONS(2349),
    [anon_sym_sample] = ACTIONS(2349),
    [anon_sym_linear] = ACTIONS(2349),
    [anon_sym_snorm] = ACTIONS(2349),
    [anon_sym_unorm] = ACTIONS(2349),
    [anon_sym_point] = ACTIONS(2349),
    [anon_sym_line] = ACTIONS(2349),
    [anon_sym_triangleadj] = ACTIONS(2349),
    [anon_sym_lineadj] = ACTIONS(2349),
    [anon_sym_triangle] = ACTIONS(2349),
    [anon_sym_interface] = ACTIONS(2349),
    [anon_sym_extension] = ACTIONS(2349),
  },
  [2598] = {
    [sym_string_literal] = STATE(2997),
    [sym_template_argument_list] = STATE(2921),
    [sym_raw_string_literal] = STATE(2997),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_RPAREN] = ACTIONS(2130),
    [anon_sym_LPAREN2] = ACTIONS(2130),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2130),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(6173),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym___extension__] = ACTIONS(2123),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_signed] = ACTIONS(6167),
    [anon_sym_unsigned] = ACTIONS(6167),
    [anon_sym_long] = ACTIONS(6167),
    [anon_sym_short] = ACTIONS(6167),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_EQ] = ACTIONS(2128),
    [anon_sym_const] = ACTIONS(2115),
    [anon_sym_constexpr] = ACTIONS(2123),
    [anon_sym_volatile] = ACTIONS(2123),
    [anon_sym_restrict] = ACTIONS(2123),
    [anon_sym___restrict__] = ACTIONS(2123),
    [anon_sym__Atomic] = ACTIONS(2123),
    [anon_sym__Noreturn] = ACTIONS(2123),
    [anon_sym_noreturn] = ACTIONS(2123),
    [anon_sym_mutable] = ACTIONS(2123),
    [anon_sym_constinit] = ACTIONS(2123),
    [anon_sym_consteval] = ACTIONS(2123),
    [anon_sym_alignas] = ACTIONS(2123),
    [anon_sym__Alignas] = ACTIONS(2123),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2117),
    [anon_sym_SLASH_EQ] = ACTIONS(2117),
    [anon_sym_PERCENT_EQ] = ACTIONS(2117),
    [anon_sym_PLUS_EQ] = ACTIONS(2117),
    [anon_sym_DASH_EQ] = ACTIONS(2117),
    [anon_sym_LT_LT_EQ] = ACTIONS(2117),
    [anon_sym_GT_GT_EQ] = ACTIONS(2117),
    [anon_sym_AMP_EQ] = ACTIONS(2117),
    [anon_sym_CARET_EQ] = ACTIONS(2117),
    [anon_sym_PIPE_EQ] = ACTIONS(2117),
    [anon_sym_and_eq] = ACTIONS(2117),
    [anon_sym_or_eq] = ACTIONS(2117),
    [anon_sym_xor_eq] = ACTIONS(2117),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2117),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2117),
    [anon_sym_not_eq] = ACTIONS(2117),
    [anon_sym_is] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2125),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2128),
    [anon_sym_L_DQUOTE] = ACTIONS(6169),
    [anon_sym_u_DQUOTE] = ACTIONS(6169),
    [anon_sym_U_DQUOTE] = ACTIONS(6169),
    [anon_sym_u8_DQUOTE] = ACTIONS(6169),
    [anon_sym_DQUOTE] = ACTIONS(6169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2123),
    [anon_sym_let] = ACTIONS(2123),
    [anon_sym_This] = ACTIONS(2123),
    [anon_sym_R_DQUOTE] = ACTIONS(6171),
    [anon_sym_LR_DQUOTE] = ACTIONS(6171),
    [anon_sym_uR_DQUOTE] = ACTIONS(6171),
    [anon_sym_UR_DQUOTE] = ACTIONS(6171),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6171),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2117),
  },
  [2599] = {
    [sym_string_literal] = STATE(4271),
    [sym_template_argument_list] = STATE(3437),
    [sym_raw_string_literal] = STATE(4271),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2130),
    [anon_sym_COMMA] = ACTIONS(2130),
    [anon_sym_LPAREN2] = ACTIONS(2130),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2130),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2128),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(6176),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON] = ACTIONS(2115),
    [anon_sym___extension__] = ACTIONS(2123),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_signed] = ACTIONS(6179),
    [anon_sym_unsigned] = ACTIONS(6179),
    [anon_sym_long] = ACTIONS(6179),
    [anon_sym_short] = ACTIONS(6179),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_EQ] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(2115),
    [anon_sym_constexpr] = ACTIONS(2123),
    [anon_sym_volatile] = ACTIONS(2123),
    [anon_sym_restrict] = ACTIONS(2123),
    [anon_sym___restrict__] = ACTIONS(2123),
    [anon_sym__Atomic] = ACTIONS(2123),
    [anon_sym__Noreturn] = ACTIONS(2123),
    [anon_sym_noreturn] = ACTIONS(2123),
    [anon_sym_mutable] = ACTIONS(2123),
    [anon_sym_constinit] = ACTIONS(2123),
    [anon_sym_consteval] = ACTIONS(2123),
    [anon_sym_alignas] = ACTIONS(2123),
    [anon_sym__Alignas] = ACTIONS(2123),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(6181),
    [anon_sym_SLASH_EQ] = ACTIONS(6181),
    [anon_sym_PERCENT_EQ] = ACTIONS(6181),
    [anon_sym_PLUS_EQ] = ACTIONS(6181),
    [anon_sym_DASH_EQ] = ACTIONS(6181),
    [anon_sym_LT_LT_EQ] = ACTIONS(6181),
    [anon_sym_GT_GT_EQ] = ACTIONS(6183),
    [anon_sym_AMP_EQ] = ACTIONS(6181),
    [anon_sym_CARET_EQ] = ACTIONS(6181),
    [anon_sym_PIPE_EQ] = ACTIONS(6181),
    [anon_sym_and_eq] = ACTIONS(6181),
    [anon_sym_or_eq] = ACTIONS(6181),
    [anon_sym_xor_eq] = ACTIONS(6181),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2117),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2117),
    [anon_sym_not_eq] = ACTIONS(2117),
    [anon_sym_is] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2125),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(6185),
    [anon_sym_u_DQUOTE] = ACTIONS(6185),
    [anon_sym_U_DQUOTE] = ACTIONS(6185),
    [anon_sym_u8_DQUOTE] = ACTIONS(6185),
    [anon_sym_DQUOTE] = ACTIONS(6185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2123),
    [anon_sym_let] = ACTIONS(2123),
    [anon_sym_This] = ACTIONS(2123),
    [anon_sym_GT2] = ACTIONS(2130),
    [anon_sym_R_DQUOTE] = ACTIONS(6187),
    [anon_sym_LR_DQUOTE] = ACTIONS(6187),
    [anon_sym_uR_DQUOTE] = ACTIONS(6187),
    [anon_sym_UR_DQUOTE] = ACTIONS(6187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6187),
  },
  [2600] = {
    [sym_identifier] = ACTIONS(2244),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(2246),
    [anon_sym_PIPE_PIPE] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_AMP] = ACTIONS(2244),
    [anon_sym___extension__] = ACTIONS(2244),
    [anon_sym_in] = ACTIONS(2244),
    [anon_sym_out] = ACTIONS(2244),
    [anon_sym_inout] = ACTIONS(2244),
    [anon_sym_extern] = ACTIONS(2244),
    [anon_sym___attribute__] = ACTIONS(2244),
    [anon_sym_COLON_COLON] = ACTIONS(2246),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2246),
    [anon_sym___declspec] = ACTIONS(2244),
    [anon_sym___based] = ACTIONS(2244),
    [anon_sym___cdecl] = ACTIONS(2244),
    [anon_sym___clrcall] = ACTIONS(2244),
    [anon_sym___stdcall] = ACTIONS(2244),
    [anon_sym___fastcall] = ACTIONS(2244),
    [anon_sym___thiscall] = ACTIONS(2244),
    [anon_sym___vectorcall] = ACTIONS(2244),
    [anon_sym_signed] = ACTIONS(2244),
    [anon_sym_unsigned] = ACTIONS(2244),
    [anon_sym_long] = ACTIONS(2244),
    [anon_sym_short] = ACTIONS(2244),
    [anon_sym_LBRACK] = ACTIONS(2244),
    [anon_sym_static] = ACTIONS(2244),
    [anon_sym_register] = ACTIONS(2244),
    [anon_sym_inline] = ACTIONS(2244),
    [anon_sym___inline] = ACTIONS(2244),
    [anon_sym___inline__] = ACTIONS(2244),
    [anon_sym___forceinline] = ACTIONS(2244),
    [anon_sym_thread_local] = ACTIONS(2244),
    [anon_sym___thread] = ACTIONS(2244),
    [anon_sym_const] = ACTIONS(2244),
    [anon_sym_constexpr] = ACTIONS(2244),
    [anon_sym_volatile] = ACTIONS(2244),
    [anon_sym_restrict] = ACTIONS(2244),
    [anon_sym___restrict__] = ACTIONS(2244),
    [anon_sym__Atomic] = ACTIONS(2244),
    [anon_sym__Noreturn] = ACTIONS(2244),
    [anon_sym_noreturn] = ACTIONS(2244),
    [anon_sym_mutable] = ACTIONS(2244),
    [anon_sym_constinit] = ACTIONS(2244),
    [anon_sym_consteval] = ACTIONS(2244),
    [anon_sym_alignas] = ACTIONS(2244),
    [anon_sym__Alignas] = ACTIONS(2244),
    [sym_primitive_type] = ACTIONS(2244),
    [anon_sym_enum] = ACTIONS(2244),
    [anon_sym_class] = ACTIONS(2244),
    [anon_sym_struct] = ACTIONS(2244),
    [anon_sym_union] = ACTIONS(2244),
    [anon_sym_or] = ACTIONS(2244),
    [anon_sym_and] = ACTIONS(2244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2244),
    [anon_sym_let] = ACTIONS(2244),
    [anon_sym_This] = ACTIONS(2244),
    [anon_sym_decltype] = ACTIONS(2244),
    [sym_virtual] = ACTIONS(2244),
    [anon_sym_explicit] = ACTIONS(2244),
    [anon_sym_typename] = ACTIONS(2244),
    [anon_sym_template] = ACTIONS(2244),
    [anon_sym_operator] = ACTIONS(2244),
    [anon_sym_friend] = ACTIONS(2244),
    [anon_sym_using] = ACTIONS(2244),
    [anon_sym_concept] = ACTIONS(2244),
    [anon_sym_precise] = ACTIONS(2244),
    [anon_sym_shared] = ACTIONS(2244),
    [anon_sym_groupshared] = ACTIONS(2244),
    [anon_sym_uniform] = ACTIONS(2244),
    [anon_sym_row_major] = ACTIONS(2244),
    [anon_sym_column_major] = ACTIONS(2244),
    [anon_sym_globallycoherent] = ACTIONS(2244),
    [anon_sym_centroid] = ACTIONS(2244),
    [anon_sym_noperspective] = ACTIONS(2244),
    [anon_sym_nointerpolation] = ACTIONS(2244),
    [anon_sym_sample] = ACTIONS(2244),
    [anon_sym_linear] = ACTIONS(2244),
    [anon_sym_snorm] = ACTIONS(2244),
    [anon_sym_unorm] = ACTIONS(2244),
    [anon_sym_point] = ACTIONS(2244),
    [anon_sym_line] = ACTIONS(2244),
    [anon_sym_triangleadj] = ACTIONS(2244),
    [anon_sym_lineadj] = ACTIONS(2244),
    [anon_sym_triangle] = ACTIONS(2244),
    [anon_sym_interface] = ACTIONS(2244),
    [anon_sym_extension] = ACTIONS(2244),
  },
  [2601] = {
    [sym_identifier] = ACTIONS(2190),
    [anon_sym_LPAREN2] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [anon_sym_STAR] = ACTIONS(2192),
    [anon_sym_PIPE_PIPE] = ACTIONS(2192),
    [anon_sym_AMP_AMP] = ACTIONS(2192),
    [anon_sym_AMP] = ACTIONS(2190),
    [anon_sym___extension__] = ACTIONS(2190),
    [anon_sym_in] = ACTIONS(2190),
    [anon_sym_out] = ACTIONS(2190),
    [anon_sym_inout] = ACTIONS(2190),
    [anon_sym_extern] = ACTIONS(2190),
    [anon_sym___attribute__] = ACTIONS(2190),
    [anon_sym_COLON_COLON] = ACTIONS(2192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2192),
    [anon_sym___declspec] = ACTIONS(2190),
    [anon_sym___based] = ACTIONS(2190),
    [anon_sym___cdecl] = ACTIONS(2190),
    [anon_sym___clrcall] = ACTIONS(2190),
    [anon_sym___stdcall] = ACTIONS(2190),
    [anon_sym___fastcall] = ACTIONS(2190),
    [anon_sym___thiscall] = ACTIONS(2190),
    [anon_sym___vectorcall] = ACTIONS(2190),
    [anon_sym_signed] = ACTIONS(2190),
    [anon_sym_unsigned] = ACTIONS(2190),
    [anon_sym_long] = ACTIONS(2190),
    [anon_sym_short] = ACTIONS(2190),
    [anon_sym_LBRACK] = ACTIONS(2190),
    [anon_sym_static] = ACTIONS(2190),
    [anon_sym_register] = ACTIONS(2190),
    [anon_sym_inline] = ACTIONS(2190),
    [anon_sym___inline] = ACTIONS(2190),
    [anon_sym___inline__] = ACTIONS(2190),
    [anon_sym___forceinline] = ACTIONS(2190),
    [anon_sym_thread_local] = ACTIONS(2190),
    [anon_sym___thread] = ACTIONS(2190),
    [anon_sym_const] = ACTIONS(2190),
    [anon_sym_constexpr] = ACTIONS(2190),
    [anon_sym_volatile] = ACTIONS(2190),
    [anon_sym_restrict] = ACTIONS(2190),
    [anon_sym___restrict__] = ACTIONS(2190),
    [anon_sym__Atomic] = ACTIONS(2190),
    [anon_sym__Noreturn] = ACTIONS(2190),
    [anon_sym_noreturn] = ACTIONS(2190),
    [anon_sym_mutable] = ACTIONS(2190),
    [anon_sym_constinit] = ACTIONS(2190),
    [anon_sym_consteval] = ACTIONS(2190),
    [anon_sym_alignas] = ACTIONS(2190),
    [anon_sym__Alignas] = ACTIONS(2190),
    [sym_primitive_type] = ACTIONS(2190),
    [anon_sym_enum] = ACTIONS(2190),
    [anon_sym_class] = ACTIONS(2190),
    [anon_sym_struct] = ACTIONS(2190),
    [anon_sym_union] = ACTIONS(2190),
    [anon_sym_or] = ACTIONS(2190),
    [anon_sym_and] = ACTIONS(2190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2190),
    [anon_sym_let] = ACTIONS(2190),
    [anon_sym_This] = ACTIONS(2190),
    [anon_sym_decltype] = ACTIONS(2190),
    [sym_virtual] = ACTIONS(2190),
    [anon_sym_explicit] = ACTIONS(2190),
    [anon_sym_typename] = ACTIONS(2190),
    [anon_sym_template] = ACTIONS(2190),
    [anon_sym_operator] = ACTIONS(2190),
    [anon_sym_friend] = ACTIONS(2190),
    [anon_sym_using] = ACTIONS(2190),
    [anon_sym_concept] = ACTIONS(2190),
    [anon_sym_precise] = ACTIONS(2190),
    [anon_sym_shared] = ACTIONS(2190),
    [anon_sym_groupshared] = ACTIONS(2190),
    [anon_sym_uniform] = ACTIONS(2190),
    [anon_sym_row_major] = ACTIONS(2190),
    [anon_sym_column_major] = ACTIONS(2190),
    [anon_sym_globallycoherent] = ACTIONS(2190),
    [anon_sym_centroid] = ACTIONS(2190),
    [anon_sym_noperspective] = ACTIONS(2190),
    [anon_sym_nointerpolation] = ACTIONS(2190),
    [anon_sym_sample] = ACTIONS(2190),
    [anon_sym_linear] = ACTIONS(2190),
    [anon_sym_snorm] = ACTIONS(2190),
    [anon_sym_unorm] = ACTIONS(2190),
    [anon_sym_point] = ACTIONS(2190),
    [anon_sym_line] = ACTIONS(2190),
    [anon_sym_triangleadj] = ACTIONS(2190),
    [anon_sym_lineadj] = ACTIONS(2190),
    [anon_sym_triangle] = ACTIONS(2190),
    [anon_sym_interface] = ACTIONS(2190),
    [anon_sym_extension] = ACTIONS(2190),
  },
  [2602] = {
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_LPAREN2] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym___extension__] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_out] = ACTIONS(2373),
    [anon_sym_inout] = ACTIONS(2373),
    [anon_sym_extern] = ACTIONS(2373),
    [anon_sym___attribute__] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2371),
    [anon_sym___declspec] = ACTIONS(2373),
    [anon_sym___based] = ACTIONS(2373),
    [anon_sym___cdecl] = ACTIONS(2373),
    [anon_sym___clrcall] = ACTIONS(2373),
    [anon_sym___stdcall] = ACTIONS(2373),
    [anon_sym___fastcall] = ACTIONS(2373),
    [anon_sym___thiscall] = ACTIONS(2373),
    [anon_sym___vectorcall] = ACTIONS(2373),
    [anon_sym_signed] = ACTIONS(2373),
    [anon_sym_unsigned] = ACTIONS(2373),
    [anon_sym_long] = ACTIONS(2373),
    [anon_sym_short] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2373),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_register] = ACTIONS(2373),
    [anon_sym_inline] = ACTIONS(2373),
    [anon_sym___inline] = ACTIONS(2373),
    [anon_sym___inline__] = ACTIONS(2373),
    [anon_sym___forceinline] = ACTIONS(2373),
    [anon_sym_thread_local] = ACTIONS(2373),
    [anon_sym___thread] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym___restrict__] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym__Noreturn] = ACTIONS(2373),
    [anon_sym_noreturn] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_constinit] = ACTIONS(2373),
    [anon_sym_consteval] = ACTIONS(2373),
    [anon_sym_alignas] = ACTIONS(2373),
    [anon_sym__Alignas] = ACTIONS(2373),
    [sym_primitive_type] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_class] = ACTIONS(2373),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_or] = ACTIONS(2373),
    [anon_sym_and] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_This] = ACTIONS(2373),
    [anon_sym_decltype] = ACTIONS(2373),
    [sym_virtual] = ACTIONS(2373),
    [anon_sym_explicit] = ACTIONS(2373),
    [anon_sym_typename] = ACTIONS(2373),
    [anon_sym_template] = ACTIONS(2373),
    [anon_sym_operator] = ACTIONS(2373),
    [anon_sym_friend] = ACTIONS(2373),
    [anon_sym_using] = ACTIONS(2373),
    [anon_sym_concept] = ACTIONS(2373),
    [anon_sym_precise] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_groupshared] = ACTIONS(2373),
    [anon_sym_uniform] = ACTIONS(2373),
    [anon_sym_row_major] = ACTIONS(2373),
    [anon_sym_column_major] = ACTIONS(2373),
    [anon_sym_globallycoherent] = ACTIONS(2373),
    [anon_sym_centroid] = ACTIONS(2373),
    [anon_sym_noperspective] = ACTIONS(2373),
    [anon_sym_nointerpolation] = ACTIONS(2373),
    [anon_sym_sample] = ACTIONS(2373),
    [anon_sym_linear] = ACTIONS(2373),
    [anon_sym_snorm] = ACTIONS(2373),
    [anon_sym_unorm] = ACTIONS(2373),
    [anon_sym_point] = ACTIONS(2373),
    [anon_sym_line] = ACTIONS(2373),
    [anon_sym_triangleadj] = ACTIONS(2373),
    [anon_sym_lineadj] = ACTIONS(2373),
    [anon_sym_triangle] = ACTIONS(2373),
    [anon_sym_interface] = ACTIONS(2373),
    [anon_sym_extension] = ACTIONS(2373),
  },
  [2603] = {
    [sym_identifier] = ACTIONS(2359),
    [anon_sym_LPAREN2] = ACTIONS(2357),
    [anon_sym_TILDE] = ACTIONS(2357),
    [anon_sym_STAR] = ACTIONS(2357),
    [anon_sym_PIPE_PIPE] = ACTIONS(2357),
    [anon_sym_AMP_AMP] = ACTIONS(2357),
    [anon_sym_AMP] = ACTIONS(2359),
    [anon_sym___extension__] = ACTIONS(2359),
    [anon_sym_in] = ACTIONS(2359),
    [anon_sym_out] = ACTIONS(2359),
    [anon_sym_inout] = ACTIONS(2359),
    [anon_sym_extern] = ACTIONS(2359),
    [anon_sym___attribute__] = ACTIONS(2359),
    [anon_sym_COLON_COLON] = ACTIONS(2357),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2357),
    [anon_sym___declspec] = ACTIONS(2359),
    [anon_sym___based] = ACTIONS(2359),
    [anon_sym___cdecl] = ACTIONS(2359),
    [anon_sym___clrcall] = ACTIONS(2359),
    [anon_sym___stdcall] = ACTIONS(2359),
    [anon_sym___fastcall] = ACTIONS(2359),
    [anon_sym___thiscall] = ACTIONS(2359),
    [anon_sym___vectorcall] = ACTIONS(2359),
    [anon_sym_signed] = ACTIONS(2359),
    [anon_sym_unsigned] = ACTIONS(2359),
    [anon_sym_long] = ACTIONS(2359),
    [anon_sym_short] = ACTIONS(2359),
    [anon_sym_LBRACK] = ACTIONS(2359),
    [anon_sym_static] = ACTIONS(2359),
    [anon_sym_register] = ACTIONS(2359),
    [anon_sym_inline] = ACTIONS(2359),
    [anon_sym___inline] = ACTIONS(2359),
    [anon_sym___inline__] = ACTIONS(2359),
    [anon_sym___forceinline] = ACTIONS(2359),
    [anon_sym_thread_local] = ACTIONS(2359),
    [anon_sym___thread] = ACTIONS(2359),
    [anon_sym_const] = ACTIONS(2359),
    [anon_sym_constexpr] = ACTIONS(2359),
    [anon_sym_volatile] = ACTIONS(2359),
    [anon_sym_restrict] = ACTIONS(2359),
    [anon_sym___restrict__] = ACTIONS(2359),
    [anon_sym__Atomic] = ACTIONS(2359),
    [anon_sym__Noreturn] = ACTIONS(2359),
    [anon_sym_noreturn] = ACTIONS(2359),
    [anon_sym_mutable] = ACTIONS(2359),
    [anon_sym_constinit] = ACTIONS(2359),
    [anon_sym_consteval] = ACTIONS(2359),
    [anon_sym_alignas] = ACTIONS(2359),
    [anon_sym__Alignas] = ACTIONS(2359),
    [sym_primitive_type] = ACTIONS(2359),
    [anon_sym_enum] = ACTIONS(2359),
    [anon_sym_class] = ACTIONS(2359),
    [anon_sym_struct] = ACTIONS(2359),
    [anon_sym_union] = ACTIONS(2359),
    [anon_sym_or] = ACTIONS(2359),
    [anon_sym_and] = ACTIONS(2359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2359),
    [anon_sym_let] = ACTIONS(2359),
    [anon_sym_This] = ACTIONS(2359),
    [anon_sym_decltype] = ACTIONS(2359),
    [sym_virtual] = ACTIONS(2359),
    [anon_sym_explicit] = ACTIONS(2359),
    [anon_sym_typename] = ACTIONS(2359),
    [anon_sym_template] = ACTIONS(2359),
    [anon_sym_operator] = ACTIONS(2359),
    [anon_sym_friend] = ACTIONS(2359),
    [anon_sym_using] = ACTIONS(2359),
    [anon_sym_concept] = ACTIONS(2359),
    [anon_sym_precise] = ACTIONS(2359),
    [anon_sym_shared] = ACTIONS(2359),
    [anon_sym_groupshared] = ACTIONS(2359),
    [anon_sym_uniform] = ACTIONS(2359),
    [anon_sym_row_major] = ACTIONS(2359),
    [anon_sym_column_major] = ACTIONS(2359),
    [anon_sym_globallycoherent] = ACTIONS(2359),
    [anon_sym_centroid] = ACTIONS(2359),
    [anon_sym_noperspective] = ACTIONS(2359),
    [anon_sym_nointerpolation] = ACTIONS(2359),
    [anon_sym_sample] = ACTIONS(2359),
    [anon_sym_linear] = ACTIONS(2359),
    [anon_sym_snorm] = ACTIONS(2359),
    [anon_sym_unorm] = ACTIONS(2359),
    [anon_sym_point] = ACTIONS(2359),
    [anon_sym_line] = ACTIONS(2359),
    [anon_sym_triangleadj] = ACTIONS(2359),
    [anon_sym_lineadj] = ACTIONS(2359),
    [anon_sym_triangle] = ACTIONS(2359),
    [anon_sym_interface] = ACTIONS(2359),
    [anon_sym_extension] = ACTIONS(2359),
  },
  [2604] = {
    [sym_identifier] = ACTIONS(2224),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_TILDE] = ACTIONS(2226),
    [anon_sym_STAR] = ACTIONS(2226),
    [anon_sym_PIPE_PIPE] = ACTIONS(2226),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_AMP] = ACTIONS(2224),
    [anon_sym___extension__] = ACTIONS(2224),
    [anon_sym_in] = ACTIONS(2224),
    [anon_sym_out] = ACTIONS(2224),
    [anon_sym_inout] = ACTIONS(2224),
    [anon_sym_extern] = ACTIONS(2224),
    [anon_sym___attribute__] = ACTIONS(2224),
    [anon_sym_COLON_COLON] = ACTIONS(2226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2226),
    [anon_sym___declspec] = ACTIONS(2224),
    [anon_sym___based] = ACTIONS(2224),
    [anon_sym___cdecl] = ACTIONS(2224),
    [anon_sym___clrcall] = ACTIONS(2224),
    [anon_sym___stdcall] = ACTIONS(2224),
    [anon_sym___fastcall] = ACTIONS(2224),
    [anon_sym___thiscall] = ACTIONS(2224),
    [anon_sym___vectorcall] = ACTIONS(2224),
    [anon_sym_signed] = ACTIONS(2224),
    [anon_sym_unsigned] = ACTIONS(2224),
    [anon_sym_long] = ACTIONS(2224),
    [anon_sym_short] = ACTIONS(2224),
    [anon_sym_LBRACK] = ACTIONS(2224),
    [anon_sym_static] = ACTIONS(2224),
    [anon_sym_register] = ACTIONS(2224),
    [anon_sym_inline] = ACTIONS(2224),
    [anon_sym___inline] = ACTIONS(2224),
    [anon_sym___inline__] = ACTIONS(2224),
    [anon_sym___forceinline] = ACTIONS(2224),
    [anon_sym_thread_local] = ACTIONS(2224),
    [anon_sym___thread] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_constexpr] = ACTIONS(2224),
    [anon_sym_volatile] = ACTIONS(2224),
    [anon_sym_restrict] = ACTIONS(2224),
    [anon_sym___restrict__] = ACTIONS(2224),
    [anon_sym__Atomic] = ACTIONS(2224),
    [anon_sym__Noreturn] = ACTIONS(2224),
    [anon_sym_noreturn] = ACTIONS(2224),
    [anon_sym_mutable] = ACTIONS(2224),
    [anon_sym_constinit] = ACTIONS(2224),
    [anon_sym_consteval] = ACTIONS(2224),
    [anon_sym_alignas] = ACTIONS(2224),
    [anon_sym__Alignas] = ACTIONS(2224),
    [sym_primitive_type] = ACTIONS(2224),
    [anon_sym_enum] = ACTIONS(2224),
    [anon_sym_class] = ACTIONS(2224),
    [anon_sym_struct] = ACTIONS(2224),
    [anon_sym_union] = ACTIONS(2224),
    [anon_sym_or] = ACTIONS(2224),
    [anon_sym_and] = ACTIONS(2224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2224),
    [anon_sym_let] = ACTIONS(2224),
    [anon_sym_This] = ACTIONS(2224),
    [anon_sym_decltype] = ACTIONS(2224),
    [sym_virtual] = ACTIONS(2224),
    [anon_sym_explicit] = ACTIONS(2224),
    [anon_sym_typename] = ACTIONS(2224),
    [anon_sym_template] = ACTIONS(2224),
    [anon_sym_operator] = ACTIONS(2224),
    [anon_sym_friend] = ACTIONS(2224),
    [anon_sym_using] = ACTIONS(2224),
    [anon_sym_concept] = ACTIONS(2224),
    [anon_sym_precise] = ACTIONS(2224),
    [anon_sym_shared] = ACTIONS(2224),
    [anon_sym_groupshared] = ACTIONS(2224),
    [anon_sym_uniform] = ACTIONS(2224),
    [anon_sym_row_major] = ACTIONS(2224),
    [anon_sym_column_major] = ACTIONS(2224),
    [anon_sym_globallycoherent] = ACTIONS(2224),
    [anon_sym_centroid] = ACTIONS(2224),
    [anon_sym_noperspective] = ACTIONS(2224),
    [anon_sym_nointerpolation] = ACTIONS(2224),
    [anon_sym_sample] = ACTIONS(2224),
    [anon_sym_linear] = ACTIONS(2224),
    [anon_sym_snorm] = ACTIONS(2224),
    [anon_sym_unorm] = ACTIONS(2224),
    [anon_sym_point] = ACTIONS(2224),
    [anon_sym_line] = ACTIONS(2224),
    [anon_sym_triangleadj] = ACTIONS(2224),
    [anon_sym_lineadj] = ACTIONS(2224),
    [anon_sym_triangle] = ACTIONS(2224),
    [anon_sym_interface] = ACTIONS(2224),
    [anon_sym_extension] = ACTIONS(2224),
  },
  [2605] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2605),
    [sym_identifier] = ACTIONS(2856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2854),
    [anon_sym_COMMA] = ACTIONS(2854),
    [anon_sym_RPAREN] = ACTIONS(2854),
    [anon_sym_LPAREN2] = ACTIONS(2854),
    [anon_sym_TILDE] = ACTIONS(2854),
    [anon_sym_STAR] = ACTIONS(2854),
    [anon_sym_AMP_AMP] = ACTIONS(2854),
    [anon_sym_AMP] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2856),
    [anon_sym_SEMI] = ACTIONS(2854),
    [anon_sym___extension__] = ACTIONS(2856),
    [anon_sym_in] = ACTIONS(2856),
    [anon_sym_out] = ACTIONS(2856),
    [anon_sym_inout] = ACTIONS(2856),
    [anon_sym_extern] = ACTIONS(2856),
    [anon_sym___attribute__] = ACTIONS(2856),
    [anon_sym_COLON_COLON] = ACTIONS(2854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2854),
    [anon_sym___declspec] = ACTIONS(2856),
    [anon_sym___based] = ACTIONS(2856),
    [anon_sym___cdecl] = ACTIONS(2856),
    [anon_sym___clrcall] = ACTIONS(2856),
    [anon_sym___stdcall] = ACTIONS(2856),
    [anon_sym___fastcall] = ACTIONS(2856),
    [anon_sym___thiscall] = ACTIONS(2856),
    [anon_sym___vectorcall] = ACTIONS(2856),
    [anon_sym_LBRACE] = ACTIONS(2854),
    [anon_sym_signed] = ACTIONS(6189),
    [anon_sym_unsigned] = ACTIONS(6189),
    [anon_sym_long] = ACTIONS(6189),
    [anon_sym_short] = ACTIONS(6189),
    [anon_sym_LBRACK] = ACTIONS(2856),
    [anon_sym_static] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(2854),
    [anon_sym_register] = ACTIONS(2856),
    [anon_sym_inline] = ACTIONS(2856),
    [anon_sym___inline] = ACTIONS(2856),
    [anon_sym___inline__] = ACTIONS(2856),
    [anon_sym___forceinline] = ACTIONS(2856),
    [anon_sym_thread_local] = ACTIONS(2856),
    [anon_sym___thread] = ACTIONS(2856),
    [anon_sym_const] = ACTIONS(2856),
    [anon_sym_constexpr] = ACTIONS(2856),
    [anon_sym_volatile] = ACTIONS(2856),
    [anon_sym_restrict] = ACTIONS(2856),
    [anon_sym___restrict__] = ACTIONS(2856),
    [anon_sym__Atomic] = ACTIONS(2856),
    [anon_sym__Noreturn] = ACTIONS(2856),
    [anon_sym_noreturn] = ACTIONS(2856),
    [anon_sym_mutable] = ACTIONS(2856),
    [anon_sym_constinit] = ACTIONS(2856),
    [anon_sym_consteval] = ACTIONS(2856),
    [anon_sym_alignas] = ACTIONS(2856),
    [anon_sym__Alignas] = ACTIONS(2856),
    [sym_primitive_type] = ACTIONS(2856),
    [anon_sym_DOT] = ACTIONS(2856),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2856),
    [anon_sym_let] = ACTIONS(2856),
    [anon_sym_This] = ACTIONS(2856),
    [anon_sym_decltype] = ACTIONS(2856),
    [anon_sym_final] = ACTIONS(2856),
    [anon_sym_override] = ACTIONS(2856),
    [sym_virtual] = ACTIONS(2856),
    [anon_sym_template] = ACTIONS(2856),
    [anon_sym_GT2] = ACTIONS(2854),
    [anon_sym_operator] = ACTIONS(2856),
    [anon_sym_requires] = ACTIONS(2856),
    [anon_sym_precise] = ACTIONS(2856),
    [anon_sym_shared] = ACTIONS(2856),
    [anon_sym_groupshared] = ACTIONS(2856),
    [anon_sym_uniform] = ACTIONS(2856),
    [anon_sym_row_major] = ACTIONS(2856),
    [anon_sym_column_major] = ACTIONS(2856),
    [anon_sym_globallycoherent] = ACTIONS(2856),
    [anon_sym_centroid] = ACTIONS(2856),
    [anon_sym_noperspective] = ACTIONS(2856),
    [anon_sym_nointerpolation] = ACTIONS(2856),
    [anon_sym_sample] = ACTIONS(2856),
    [anon_sym_linear] = ACTIONS(2856),
    [anon_sym_snorm] = ACTIONS(2856),
    [anon_sym_unorm] = ACTIONS(2856),
    [anon_sym_point] = ACTIONS(2856),
    [anon_sym_line] = ACTIONS(2856),
    [anon_sym_triangleadj] = ACTIONS(2856),
    [anon_sym_lineadj] = ACTIONS(2856),
    [anon_sym_triangle] = ACTIONS(2856),
    [anon_sym_where] = ACTIONS(2856),
  },
  [2606] = {
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_TILDE] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2230),
    [anon_sym_PIPE_PIPE] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_AMP] = ACTIONS(2228),
    [anon_sym___extension__] = ACTIONS(2228),
    [anon_sym_in] = ACTIONS(2228),
    [anon_sym_out] = ACTIONS(2228),
    [anon_sym_inout] = ACTIONS(2228),
    [anon_sym_extern] = ACTIONS(2228),
    [anon_sym___attribute__] = ACTIONS(2228),
    [anon_sym_COLON_COLON] = ACTIONS(2230),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2230),
    [anon_sym___declspec] = ACTIONS(2228),
    [anon_sym___based] = ACTIONS(2228),
    [anon_sym___cdecl] = ACTIONS(2228),
    [anon_sym___clrcall] = ACTIONS(2228),
    [anon_sym___stdcall] = ACTIONS(2228),
    [anon_sym___fastcall] = ACTIONS(2228),
    [anon_sym___thiscall] = ACTIONS(2228),
    [anon_sym___vectorcall] = ACTIONS(2228),
    [anon_sym_signed] = ACTIONS(2228),
    [anon_sym_unsigned] = ACTIONS(2228),
    [anon_sym_long] = ACTIONS(2228),
    [anon_sym_short] = ACTIONS(2228),
    [anon_sym_LBRACK] = ACTIONS(2228),
    [anon_sym_static] = ACTIONS(2228),
    [anon_sym_register] = ACTIONS(2228),
    [anon_sym_inline] = ACTIONS(2228),
    [anon_sym___inline] = ACTIONS(2228),
    [anon_sym___inline__] = ACTIONS(2228),
    [anon_sym___forceinline] = ACTIONS(2228),
    [anon_sym_thread_local] = ACTIONS(2228),
    [anon_sym___thread] = ACTIONS(2228),
    [anon_sym_const] = ACTIONS(2228),
    [anon_sym_constexpr] = ACTIONS(2228),
    [anon_sym_volatile] = ACTIONS(2228),
    [anon_sym_restrict] = ACTIONS(2228),
    [anon_sym___restrict__] = ACTIONS(2228),
    [anon_sym__Atomic] = ACTIONS(2228),
    [anon_sym__Noreturn] = ACTIONS(2228),
    [anon_sym_noreturn] = ACTIONS(2228),
    [anon_sym_mutable] = ACTIONS(2228),
    [anon_sym_constinit] = ACTIONS(2228),
    [anon_sym_consteval] = ACTIONS(2228),
    [anon_sym_alignas] = ACTIONS(2228),
    [anon_sym__Alignas] = ACTIONS(2228),
    [sym_primitive_type] = ACTIONS(2228),
    [anon_sym_enum] = ACTIONS(2228),
    [anon_sym_class] = ACTIONS(2228),
    [anon_sym_struct] = ACTIONS(2228),
    [anon_sym_union] = ACTIONS(2228),
    [anon_sym_or] = ACTIONS(2228),
    [anon_sym_and] = ACTIONS(2228),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(2228),
    [anon_sym_This] = ACTIONS(2228),
    [anon_sym_decltype] = ACTIONS(2228),
    [sym_virtual] = ACTIONS(2228),
    [anon_sym_explicit] = ACTIONS(2228),
    [anon_sym_typename] = ACTIONS(2228),
    [anon_sym_template] = ACTIONS(2228),
    [anon_sym_operator] = ACTIONS(2228),
    [anon_sym_friend] = ACTIONS(2228),
    [anon_sym_using] = ACTIONS(2228),
    [anon_sym_concept] = ACTIONS(2228),
    [anon_sym_precise] = ACTIONS(2228),
    [anon_sym_shared] = ACTIONS(2228),
    [anon_sym_groupshared] = ACTIONS(2228),
    [anon_sym_uniform] = ACTIONS(2228),
    [anon_sym_row_major] = ACTIONS(2228),
    [anon_sym_column_major] = ACTIONS(2228),
    [anon_sym_globallycoherent] = ACTIONS(2228),
    [anon_sym_centroid] = ACTIONS(2228),
    [anon_sym_noperspective] = ACTIONS(2228),
    [anon_sym_nointerpolation] = ACTIONS(2228),
    [anon_sym_sample] = ACTIONS(2228),
    [anon_sym_linear] = ACTIONS(2228),
    [anon_sym_snorm] = ACTIONS(2228),
    [anon_sym_unorm] = ACTIONS(2228),
    [anon_sym_point] = ACTIONS(2228),
    [anon_sym_line] = ACTIONS(2228),
    [anon_sym_triangleadj] = ACTIONS(2228),
    [anon_sym_lineadj] = ACTIONS(2228),
    [anon_sym_triangle] = ACTIONS(2228),
    [anon_sym_interface] = ACTIONS(2228),
    [anon_sym_extension] = ACTIONS(2228),
  },
  [2607] = {
    [sym_identifier] = ACTIONS(6192),
    [anon_sym_LPAREN2] = ACTIONS(6194),
    [anon_sym_TILDE] = ACTIONS(6194),
    [anon_sym_STAR] = ACTIONS(6194),
    [anon_sym_PIPE_PIPE] = ACTIONS(6196),
    [anon_sym_AMP_AMP] = ACTIONS(6198),
    [anon_sym_AMP] = ACTIONS(6192),
    [anon_sym___extension__] = ACTIONS(6192),
    [anon_sym_in] = ACTIONS(6192),
    [anon_sym_out] = ACTIONS(6192),
    [anon_sym_inout] = ACTIONS(6192),
    [anon_sym_extern] = ACTIONS(6192),
    [anon_sym___attribute__] = ACTIONS(6192),
    [anon_sym_COLON_COLON] = ACTIONS(6194),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6194),
    [anon_sym___declspec] = ACTIONS(6192),
    [anon_sym___based] = ACTIONS(6192),
    [anon_sym___cdecl] = ACTIONS(6192),
    [anon_sym___clrcall] = ACTIONS(6192),
    [anon_sym___stdcall] = ACTIONS(6192),
    [anon_sym___fastcall] = ACTIONS(6192),
    [anon_sym___thiscall] = ACTIONS(6192),
    [anon_sym___vectorcall] = ACTIONS(6192),
    [anon_sym_signed] = ACTIONS(6192),
    [anon_sym_unsigned] = ACTIONS(6192),
    [anon_sym_long] = ACTIONS(6192),
    [anon_sym_short] = ACTIONS(6192),
    [anon_sym_LBRACK] = ACTIONS(6192),
    [anon_sym_static] = ACTIONS(6192),
    [anon_sym_register] = ACTIONS(6192),
    [anon_sym_inline] = ACTIONS(6192),
    [anon_sym___inline] = ACTIONS(6192),
    [anon_sym___inline__] = ACTIONS(6192),
    [anon_sym___forceinline] = ACTIONS(6192),
    [anon_sym_thread_local] = ACTIONS(6192),
    [anon_sym___thread] = ACTIONS(6192),
    [anon_sym_const] = ACTIONS(6192),
    [anon_sym_constexpr] = ACTIONS(6192),
    [anon_sym_volatile] = ACTIONS(6192),
    [anon_sym_restrict] = ACTIONS(6192),
    [anon_sym___restrict__] = ACTIONS(6192),
    [anon_sym__Atomic] = ACTIONS(6192),
    [anon_sym__Noreturn] = ACTIONS(6192),
    [anon_sym_noreturn] = ACTIONS(6192),
    [anon_sym_mutable] = ACTIONS(6192),
    [anon_sym_constinit] = ACTIONS(6192),
    [anon_sym_consteval] = ACTIONS(6192),
    [anon_sym_alignas] = ACTIONS(6192),
    [anon_sym__Alignas] = ACTIONS(6192),
    [sym_primitive_type] = ACTIONS(6192),
    [anon_sym_enum] = ACTIONS(6192),
    [anon_sym_class] = ACTIONS(6192),
    [anon_sym_struct] = ACTIONS(6192),
    [anon_sym_union] = ACTIONS(6192),
    [anon_sym_or] = ACTIONS(6200),
    [anon_sym_and] = ACTIONS(6202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6192),
    [anon_sym_let] = ACTIONS(6192),
    [anon_sym_This] = ACTIONS(6192),
    [anon_sym_decltype] = ACTIONS(6192),
    [sym_virtual] = ACTIONS(6192),
    [anon_sym_explicit] = ACTIONS(6192),
    [anon_sym_typename] = ACTIONS(6192),
    [anon_sym_template] = ACTIONS(6192),
    [anon_sym_operator] = ACTIONS(6192),
    [anon_sym_friend] = ACTIONS(6192),
    [anon_sym_using] = ACTIONS(6192),
    [anon_sym_concept] = ACTIONS(6192),
    [anon_sym_precise] = ACTIONS(6192),
    [anon_sym_shared] = ACTIONS(6192),
    [anon_sym_groupshared] = ACTIONS(6192),
    [anon_sym_uniform] = ACTIONS(6192),
    [anon_sym_row_major] = ACTIONS(6192),
    [anon_sym_column_major] = ACTIONS(6192),
    [anon_sym_globallycoherent] = ACTIONS(6192),
    [anon_sym_centroid] = ACTIONS(6192),
    [anon_sym_noperspective] = ACTIONS(6192),
    [anon_sym_nointerpolation] = ACTIONS(6192),
    [anon_sym_sample] = ACTIONS(6192),
    [anon_sym_linear] = ACTIONS(6192),
    [anon_sym_snorm] = ACTIONS(6192),
    [anon_sym_unorm] = ACTIONS(6192),
    [anon_sym_point] = ACTIONS(6192),
    [anon_sym_line] = ACTIONS(6192),
    [anon_sym_triangleadj] = ACTIONS(6192),
    [anon_sym_lineadj] = ACTIONS(6192),
    [anon_sym_triangle] = ACTIONS(6192),
    [anon_sym_interface] = ACTIONS(6192),
    [anon_sym_extension] = ACTIONS(6192),
  },
  [2608] = {
    [sym_identifier] = ACTIONS(2232),
    [anon_sym_LPAREN2] = ACTIONS(2234),
    [anon_sym_TILDE] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_PIPE_PIPE] = ACTIONS(2234),
    [anon_sym_AMP_AMP] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2232),
    [anon_sym___extension__] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2232),
    [anon_sym_out] = ACTIONS(2232),
    [anon_sym_inout] = ACTIONS(2232),
    [anon_sym_extern] = ACTIONS(2232),
    [anon_sym___attribute__] = ACTIONS(2232),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2234),
    [anon_sym___declspec] = ACTIONS(2232),
    [anon_sym___based] = ACTIONS(2232),
    [anon_sym___cdecl] = ACTIONS(2232),
    [anon_sym___clrcall] = ACTIONS(2232),
    [anon_sym___stdcall] = ACTIONS(2232),
    [anon_sym___fastcall] = ACTIONS(2232),
    [anon_sym___thiscall] = ACTIONS(2232),
    [anon_sym___vectorcall] = ACTIONS(2232),
    [anon_sym_signed] = ACTIONS(2232),
    [anon_sym_unsigned] = ACTIONS(2232),
    [anon_sym_long] = ACTIONS(2232),
    [anon_sym_short] = ACTIONS(2232),
    [anon_sym_LBRACK] = ACTIONS(2232),
    [anon_sym_static] = ACTIONS(2232),
    [anon_sym_register] = ACTIONS(2232),
    [anon_sym_inline] = ACTIONS(2232),
    [anon_sym___inline] = ACTIONS(2232),
    [anon_sym___inline__] = ACTIONS(2232),
    [anon_sym___forceinline] = ACTIONS(2232),
    [anon_sym_thread_local] = ACTIONS(2232),
    [anon_sym___thread] = ACTIONS(2232),
    [anon_sym_const] = ACTIONS(2232),
    [anon_sym_constexpr] = ACTIONS(2232),
    [anon_sym_volatile] = ACTIONS(2232),
    [anon_sym_restrict] = ACTIONS(2232),
    [anon_sym___restrict__] = ACTIONS(2232),
    [anon_sym__Atomic] = ACTIONS(2232),
    [anon_sym__Noreturn] = ACTIONS(2232),
    [anon_sym_noreturn] = ACTIONS(2232),
    [anon_sym_mutable] = ACTIONS(2232),
    [anon_sym_constinit] = ACTIONS(2232),
    [anon_sym_consteval] = ACTIONS(2232),
    [anon_sym_alignas] = ACTIONS(2232),
    [anon_sym__Alignas] = ACTIONS(2232),
    [sym_primitive_type] = ACTIONS(2232),
    [anon_sym_enum] = ACTIONS(2232),
    [anon_sym_class] = ACTIONS(2232),
    [anon_sym_struct] = ACTIONS(2232),
    [anon_sym_union] = ACTIONS(2232),
    [anon_sym_or] = ACTIONS(2232),
    [anon_sym_and] = ACTIONS(2232),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2232),
    [anon_sym_let] = ACTIONS(2232),
    [anon_sym_This] = ACTIONS(2232),
    [anon_sym_decltype] = ACTIONS(2232),
    [sym_virtual] = ACTIONS(2232),
    [anon_sym_explicit] = ACTIONS(2232),
    [anon_sym_typename] = ACTIONS(2232),
    [anon_sym_template] = ACTIONS(2232),
    [anon_sym_operator] = ACTIONS(2232),
    [anon_sym_friend] = ACTIONS(2232),
    [anon_sym_using] = ACTIONS(2232),
    [anon_sym_concept] = ACTIONS(2232),
    [anon_sym_precise] = ACTIONS(2232),
    [anon_sym_shared] = ACTIONS(2232),
    [anon_sym_groupshared] = ACTIONS(2232),
    [anon_sym_uniform] = ACTIONS(2232),
    [anon_sym_row_major] = ACTIONS(2232),
    [anon_sym_column_major] = ACTIONS(2232),
    [anon_sym_globallycoherent] = ACTIONS(2232),
    [anon_sym_centroid] = ACTIONS(2232),
    [anon_sym_noperspective] = ACTIONS(2232),
    [anon_sym_nointerpolation] = ACTIONS(2232),
    [anon_sym_sample] = ACTIONS(2232),
    [anon_sym_linear] = ACTIONS(2232),
    [anon_sym_snorm] = ACTIONS(2232),
    [anon_sym_unorm] = ACTIONS(2232),
    [anon_sym_point] = ACTIONS(2232),
    [anon_sym_line] = ACTIONS(2232),
    [anon_sym_triangleadj] = ACTIONS(2232),
    [anon_sym_lineadj] = ACTIONS(2232),
    [anon_sym_triangle] = ACTIONS(2232),
    [anon_sym_interface] = ACTIONS(2232),
    [anon_sym_extension] = ACTIONS(2232),
  },
  [2609] = {
    [sym_identifier] = ACTIONS(2210),
    [anon_sym_LPAREN2] = ACTIONS(2217),
    [anon_sym_TILDE] = ACTIONS(2217),
    [anon_sym_STAR] = ACTIONS(2217),
    [anon_sym_PIPE_PIPE] = ACTIONS(2217),
    [anon_sym_AMP_AMP] = ACTIONS(2217),
    [anon_sym_AMP] = ACTIONS(2210),
    [anon_sym___extension__] = ACTIONS(2210),
    [anon_sym_in] = ACTIONS(2210),
    [anon_sym_out] = ACTIONS(2210),
    [anon_sym_inout] = ACTIONS(2210),
    [anon_sym_extern] = ACTIONS(2210),
    [anon_sym___attribute__] = ACTIONS(2210),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2217),
    [anon_sym___declspec] = ACTIONS(2210),
    [anon_sym___based] = ACTIONS(2210),
    [anon_sym___cdecl] = ACTIONS(2210),
    [anon_sym___clrcall] = ACTIONS(2210),
    [anon_sym___stdcall] = ACTIONS(2210),
    [anon_sym___fastcall] = ACTIONS(2210),
    [anon_sym___thiscall] = ACTIONS(2210),
    [anon_sym___vectorcall] = ACTIONS(2210),
    [anon_sym_signed] = ACTIONS(2210),
    [anon_sym_unsigned] = ACTIONS(2210),
    [anon_sym_long] = ACTIONS(2210),
    [anon_sym_short] = ACTIONS(2210),
    [anon_sym_LBRACK] = ACTIONS(2210),
    [anon_sym_static] = ACTIONS(2210),
    [anon_sym_register] = ACTIONS(2210),
    [anon_sym_inline] = ACTIONS(2210),
    [anon_sym___inline] = ACTIONS(2210),
    [anon_sym___inline__] = ACTIONS(2210),
    [anon_sym___forceinline] = ACTIONS(2210),
    [anon_sym_thread_local] = ACTIONS(2210),
    [anon_sym___thread] = ACTIONS(2210),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_constexpr] = ACTIONS(2210),
    [anon_sym_volatile] = ACTIONS(2210),
    [anon_sym_restrict] = ACTIONS(2210),
    [anon_sym___restrict__] = ACTIONS(2210),
    [anon_sym__Atomic] = ACTIONS(2210),
    [anon_sym__Noreturn] = ACTIONS(2210),
    [anon_sym_noreturn] = ACTIONS(2210),
    [anon_sym_mutable] = ACTIONS(2210),
    [anon_sym_constinit] = ACTIONS(2210),
    [anon_sym_consteval] = ACTIONS(2210),
    [anon_sym_alignas] = ACTIONS(2210),
    [anon_sym__Alignas] = ACTIONS(2210),
    [sym_primitive_type] = ACTIONS(2210),
    [anon_sym_enum] = ACTIONS(2210),
    [anon_sym_class] = ACTIONS(2210),
    [anon_sym_struct] = ACTIONS(2210),
    [anon_sym_union] = ACTIONS(2210),
    [anon_sym_or] = ACTIONS(2210),
    [anon_sym_and] = ACTIONS(2210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2210),
    [anon_sym_let] = ACTIONS(2210),
    [anon_sym_This] = ACTIONS(2210),
    [anon_sym_decltype] = ACTIONS(2210),
    [sym_virtual] = ACTIONS(2210),
    [anon_sym_explicit] = ACTIONS(2210),
    [anon_sym_typename] = ACTIONS(2210),
    [anon_sym_template] = ACTIONS(2210),
    [anon_sym_operator] = ACTIONS(2210),
    [anon_sym_friend] = ACTIONS(2210),
    [anon_sym_using] = ACTIONS(2210),
    [anon_sym_concept] = ACTIONS(2210),
    [anon_sym_precise] = ACTIONS(2210),
    [anon_sym_shared] = ACTIONS(2210),
    [anon_sym_groupshared] = ACTIONS(2210),
    [anon_sym_uniform] = ACTIONS(2210),
    [anon_sym_row_major] = ACTIONS(2210),
    [anon_sym_column_major] = ACTIONS(2210),
    [anon_sym_globallycoherent] = ACTIONS(2210),
    [anon_sym_centroid] = ACTIONS(2210),
    [anon_sym_noperspective] = ACTIONS(2210),
    [anon_sym_nointerpolation] = ACTIONS(2210),
    [anon_sym_sample] = ACTIONS(2210),
    [anon_sym_linear] = ACTIONS(2210),
    [anon_sym_snorm] = ACTIONS(2210),
    [anon_sym_unorm] = ACTIONS(2210),
    [anon_sym_point] = ACTIONS(2210),
    [anon_sym_line] = ACTIONS(2210),
    [anon_sym_triangleadj] = ACTIONS(2210),
    [anon_sym_lineadj] = ACTIONS(2210),
    [anon_sym_triangle] = ACTIONS(2210),
    [anon_sym_interface] = ACTIONS(2210),
    [anon_sym_extension] = ACTIONS(2210),
  },
  [2610] = {
    [sym_identifier] = ACTIONS(6204),
    [anon_sym_LPAREN2] = ACTIONS(6206),
    [anon_sym_TILDE] = ACTIONS(6206),
    [anon_sym_STAR] = ACTIONS(6206),
    [anon_sym_PIPE_PIPE] = ACTIONS(6206),
    [anon_sym_AMP_AMP] = ACTIONS(6198),
    [anon_sym_AMP] = ACTIONS(6204),
    [anon_sym___extension__] = ACTIONS(6204),
    [anon_sym_in] = ACTIONS(6204),
    [anon_sym_out] = ACTIONS(6204),
    [anon_sym_inout] = ACTIONS(6204),
    [anon_sym_extern] = ACTIONS(6204),
    [anon_sym___attribute__] = ACTIONS(6204),
    [anon_sym_COLON_COLON] = ACTIONS(6206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6206),
    [anon_sym___declspec] = ACTIONS(6204),
    [anon_sym___based] = ACTIONS(6204),
    [anon_sym___cdecl] = ACTIONS(6204),
    [anon_sym___clrcall] = ACTIONS(6204),
    [anon_sym___stdcall] = ACTIONS(6204),
    [anon_sym___fastcall] = ACTIONS(6204),
    [anon_sym___thiscall] = ACTIONS(6204),
    [anon_sym___vectorcall] = ACTIONS(6204),
    [anon_sym_signed] = ACTIONS(6204),
    [anon_sym_unsigned] = ACTIONS(6204),
    [anon_sym_long] = ACTIONS(6204),
    [anon_sym_short] = ACTIONS(6204),
    [anon_sym_LBRACK] = ACTIONS(6204),
    [anon_sym_static] = ACTIONS(6204),
    [anon_sym_register] = ACTIONS(6204),
    [anon_sym_inline] = ACTIONS(6204),
    [anon_sym___inline] = ACTIONS(6204),
    [anon_sym___inline__] = ACTIONS(6204),
    [anon_sym___forceinline] = ACTIONS(6204),
    [anon_sym_thread_local] = ACTIONS(6204),
    [anon_sym___thread] = ACTIONS(6204),
    [anon_sym_const] = ACTIONS(6204),
    [anon_sym_constexpr] = ACTIONS(6204),
    [anon_sym_volatile] = ACTIONS(6204),
    [anon_sym_restrict] = ACTIONS(6204),
    [anon_sym___restrict__] = ACTIONS(6204),
    [anon_sym__Atomic] = ACTIONS(6204),
    [anon_sym__Noreturn] = ACTIONS(6204),
    [anon_sym_noreturn] = ACTIONS(6204),
    [anon_sym_mutable] = ACTIONS(6204),
    [anon_sym_constinit] = ACTIONS(6204),
    [anon_sym_consteval] = ACTIONS(6204),
    [anon_sym_alignas] = ACTIONS(6204),
    [anon_sym__Alignas] = ACTIONS(6204),
    [sym_primitive_type] = ACTIONS(6204),
    [anon_sym_enum] = ACTIONS(6204),
    [anon_sym_class] = ACTIONS(6204),
    [anon_sym_struct] = ACTIONS(6204),
    [anon_sym_union] = ACTIONS(6204),
    [anon_sym_or] = ACTIONS(6204),
    [anon_sym_and] = ACTIONS(6202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6204),
    [anon_sym_let] = ACTIONS(6204),
    [anon_sym_This] = ACTIONS(6204),
    [anon_sym_decltype] = ACTIONS(6204),
    [sym_virtual] = ACTIONS(6204),
    [anon_sym_explicit] = ACTIONS(6204),
    [anon_sym_typename] = ACTIONS(6204),
    [anon_sym_template] = ACTIONS(6204),
    [anon_sym_operator] = ACTIONS(6204),
    [anon_sym_friend] = ACTIONS(6204),
    [anon_sym_using] = ACTIONS(6204),
    [anon_sym_concept] = ACTIONS(6204),
    [anon_sym_precise] = ACTIONS(6204),
    [anon_sym_shared] = ACTIONS(6204),
    [anon_sym_groupshared] = ACTIONS(6204),
    [anon_sym_uniform] = ACTIONS(6204),
    [anon_sym_row_major] = ACTIONS(6204),
    [anon_sym_column_major] = ACTIONS(6204),
    [anon_sym_globallycoherent] = ACTIONS(6204),
    [anon_sym_centroid] = ACTIONS(6204),
    [anon_sym_noperspective] = ACTIONS(6204),
    [anon_sym_nointerpolation] = ACTIONS(6204),
    [anon_sym_sample] = ACTIONS(6204),
    [anon_sym_linear] = ACTIONS(6204),
    [anon_sym_snorm] = ACTIONS(6204),
    [anon_sym_unorm] = ACTIONS(6204),
    [anon_sym_point] = ACTIONS(6204),
    [anon_sym_line] = ACTIONS(6204),
    [anon_sym_triangleadj] = ACTIONS(6204),
    [anon_sym_lineadj] = ACTIONS(6204),
    [anon_sym_triangle] = ACTIONS(6204),
    [anon_sym_interface] = ACTIONS(6204),
    [anon_sym_extension] = ACTIONS(6204),
  },
  [2611] = {
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_LPAREN2] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym___extension__] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_out] = ACTIONS(2373),
    [anon_sym_inout] = ACTIONS(2373),
    [anon_sym_extern] = ACTIONS(2373),
    [anon_sym___attribute__] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2371),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2371),
    [anon_sym___declspec] = ACTIONS(2373),
    [anon_sym___based] = ACTIONS(2373),
    [anon_sym___cdecl] = ACTIONS(2373),
    [anon_sym___clrcall] = ACTIONS(2373),
    [anon_sym___stdcall] = ACTIONS(2373),
    [anon_sym___fastcall] = ACTIONS(2373),
    [anon_sym___thiscall] = ACTIONS(2373),
    [anon_sym___vectorcall] = ACTIONS(2373),
    [anon_sym_signed] = ACTIONS(2373),
    [anon_sym_unsigned] = ACTIONS(2373),
    [anon_sym_long] = ACTIONS(2373),
    [anon_sym_short] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2373),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_register] = ACTIONS(2373),
    [anon_sym_inline] = ACTIONS(2373),
    [anon_sym___inline] = ACTIONS(2373),
    [anon_sym___inline__] = ACTIONS(2373),
    [anon_sym___forceinline] = ACTIONS(2373),
    [anon_sym_thread_local] = ACTIONS(2373),
    [anon_sym___thread] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym___restrict__] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym__Noreturn] = ACTIONS(2373),
    [anon_sym_noreturn] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_constinit] = ACTIONS(2373),
    [anon_sym_consteval] = ACTIONS(2373),
    [anon_sym_alignas] = ACTIONS(2373),
    [anon_sym__Alignas] = ACTIONS(2373),
    [sym_primitive_type] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_class] = ACTIONS(2373),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_or] = ACTIONS(2373),
    [anon_sym_and] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_This] = ACTIONS(2373),
    [anon_sym_decltype] = ACTIONS(2373),
    [sym_virtual] = ACTIONS(2373),
    [anon_sym_explicit] = ACTIONS(2373),
    [anon_sym_typename] = ACTIONS(2373),
    [anon_sym_template] = ACTIONS(2373),
    [anon_sym_operator] = ACTIONS(2373),
    [anon_sym_friend] = ACTIONS(2373),
    [anon_sym_using] = ACTIONS(2373),
    [anon_sym_concept] = ACTIONS(2373),
    [anon_sym_precise] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_groupshared] = ACTIONS(2373),
    [anon_sym_uniform] = ACTIONS(2373),
    [anon_sym_row_major] = ACTIONS(2373),
    [anon_sym_column_major] = ACTIONS(2373),
    [anon_sym_globallycoherent] = ACTIONS(2373),
    [anon_sym_centroid] = ACTIONS(2373),
    [anon_sym_noperspective] = ACTIONS(2373),
    [anon_sym_nointerpolation] = ACTIONS(2373),
    [anon_sym_sample] = ACTIONS(2373),
    [anon_sym_linear] = ACTIONS(2373),
    [anon_sym_snorm] = ACTIONS(2373),
    [anon_sym_unorm] = ACTIONS(2373),
    [anon_sym_point] = ACTIONS(2373),
    [anon_sym_line] = ACTIONS(2373),
    [anon_sym_triangleadj] = ACTIONS(2373),
    [anon_sym_lineadj] = ACTIONS(2373),
    [anon_sym_triangle] = ACTIONS(2373),
    [anon_sym_interface] = ACTIONS(2373),
    [anon_sym_extension] = ACTIONS(2373),
  },
  [2612] = {
    [sym_identifier] = ACTIONS(3844),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3846),
    [anon_sym_COMMA] = ACTIONS(3846),
    [anon_sym_RPAREN] = ACTIONS(3846),
    [anon_sym_LPAREN2] = ACTIONS(3846),
    [anon_sym_TILDE] = ACTIONS(3846),
    [anon_sym_STAR] = ACTIONS(3846),
    [anon_sym_AMP_AMP] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3844),
    [anon_sym_COLON] = ACTIONS(3844),
    [anon_sym_SEMI] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(3844),
    [anon_sym_in] = ACTIONS(3844),
    [anon_sym_out] = ACTIONS(3844),
    [anon_sym_inout] = ACTIONS(3844),
    [anon_sym_extern] = ACTIONS(3844),
    [anon_sym___attribute__] = ACTIONS(3844),
    [anon_sym_COLON_COLON] = ACTIONS(3846),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3846),
    [anon_sym___declspec] = ACTIONS(3844),
    [anon_sym___based] = ACTIONS(3844),
    [anon_sym___cdecl] = ACTIONS(3844),
    [anon_sym___clrcall] = ACTIONS(3844),
    [anon_sym___stdcall] = ACTIONS(3844),
    [anon_sym___fastcall] = ACTIONS(3844),
    [anon_sym___thiscall] = ACTIONS(3844),
    [anon_sym___vectorcall] = ACTIONS(3844),
    [anon_sym_LBRACE] = ACTIONS(3846),
    [anon_sym_LBRACK] = ACTIONS(3844),
    [anon_sym_static] = ACTIONS(3844),
    [anon_sym_EQ] = ACTIONS(3846),
    [anon_sym_register] = ACTIONS(3844),
    [anon_sym_inline] = ACTIONS(3844),
    [anon_sym___inline] = ACTIONS(3844),
    [anon_sym___inline__] = ACTIONS(3844),
    [anon_sym___forceinline] = ACTIONS(3844),
    [anon_sym_thread_local] = ACTIONS(3844),
    [anon_sym___thread] = ACTIONS(3844),
    [anon_sym_const] = ACTIONS(3844),
    [anon_sym_constexpr] = ACTIONS(3844),
    [anon_sym_volatile] = ACTIONS(3844),
    [anon_sym_restrict] = ACTIONS(3844),
    [anon_sym___restrict__] = ACTIONS(3844),
    [anon_sym__Atomic] = ACTIONS(3844),
    [anon_sym__Noreturn] = ACTIONS(3844),
    [anon_sym_noreturn] = ACTIONS(3844),
    [anon_sym_mutable] = ACTIONS(3844),
    [anon_sym_constinit] = ACTIONS(3844),
    [anon_sym_consteval] = ACTIONS(3844),
    [anon_sym_alignas] = ACTIONS(3844),
    [anon_sym__Alignas] = ACTIONS(3844),
    [anon_sym_asm] = ACTIONS(3844),
    [anon_sym___asm__] = ACTIONS(3844),
    [anon_sym_DOT] = ACTIONS(3844),
    [anon_sym_DASH_GT] = ACTIONS(3846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3844),
    [anon_sym_let] = ACTIONS(3844),
    [anon_sym_This] = ACTIONS(3844),
    [anon_sym_decltype] = ACTIONS(3844),
    [anon_sym_final] = ACTIONS(3844),
    [anon_sym_override] = ACTIONS(3844),
    [sym_virtual] = ACTIONS(3844),
    [anon_sym_explicit] = ACTIONS(3844),
    [anon_sym_template] = ACTIONS(3844),
    [anon_sym_GT2] = ACTIONS(3846),
    [anon_sym_operator] = ACTIONS(3844),
    [anon_sym_noexcept] = ACTIONS(3844),
    [anon_sym_throw] = ACTIONS(3844),
    [anon_sym_requires] = ACTIONS(3844),
    [anon_sym_precise] = ACTIONS(3844),
    [anon_sym_shared] = ACTIONS(3844),
    [anon_sym_groupshared] = ACTIONS(3844),
    [anon_sym_uniform] = ACTIONS(3844),
    [anon_sym_row_major] = ACTIONS(3844),
    [anon_sym_column_major] = ACTIONS(3844),
    [anon_sym_globallycoherent] = ACTIONS(3844),
    [anon_sym_centroid] = ACTIONS(3844),
    [anon_sym_noperspective] = ACTIONS(3844),
    [anon_sym_nointerpolation] = ACTIONS(3844),
    [anon_sym_sample] = ACTIONS(3844),
    [anon_sym_linear] = ACTIONS(3844),
    [anon_sym_snorm] = ACTIONS(3844),
    [anon_sym_unorm] = ACTIONS(3844),
    [anon_sym_point] = ACTIONS(3844),
    [anon_sym_line] = ACTIONS(3844),
    [anon_sym_triangleadj] = ACTIONS(3844),
    [anon_sym_lineadj] = ACTIONS(3844),
    [anon_sym_triangle] = ACTIONS(3844),
    [anon_sym_where] = ACTIONS(3844),
  },
  [2613] = {
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_LPAREN2] = ACTIONS(2254),
    [anon_sym_TILDE] = ACTIONS(2254),
    [anon_sym_STAR] = ACTIONS(2254),
    [anon_sym_PIPE_PIPE] = ACTIONS(2254),
    [anon_sym_AMP_AMP] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym___extension__] = ACTIONS(2252),
    [anon_sym_in] = ACTIONS(2252),
    [anon_sym_out] = ACTIONS(2252),
    [anon_sym_inout] = ACTIONS(2252),
    [anon_sym_extern] = ACTIONS(2252),
    [anon_sym___attribute__] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2254),
    [anon_sym___declspec] = ACTIONS(2252),
    [anon_sym___based] = ACTIONS(2252),
    [anon_sym___cdecl] = ACTIONS(2252),
    [anon_sym___clrcall] = ACTIONS(2252),
    [anon_sym___stdcall] = ACTIONS(2252),
    [anon_sym___fastcall] = ACTIONS(2252),
    [anon_sym___thiscall] = ACTIONS(2252),
    [anon_sym___vectorcall] = ACTIONS(2252),
    [anon_sym_signed] = ACTIONS(2252),
    [anon_sym_unsigned] = ACTIONS(2252),
    [anon_sym_long] = ACTIONS(2252),
    [anon_sym_short] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2252),
    [anon_sym_register] = ACTIONS(2252),
    [anon_sym_inline] = ACTIONS(2252),
    [anon_sym___inline] = ACTIONS(2252),
    [anon_sym___inline__] = ACTIONS(2252),
    [anon_sym___forceinline] = ACTIONS(2252),
    [anon_sym_thread_local] = ACTIONS(2252),
    [anon_sym___thread] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2252),
    [anon_sym_constexpr] = ACTIONS(2252),
    [anon_sym_volatile] = ACTIONS(2252),
    [anon_sym_restrict] = ACTIONS(2252),
    [anon_sym___restrict__] = ACTIONS(2252),
    [anon_sym__Atomic] = ACTIONS(2252),
    [anon_sym__Noreturn] = ACTIONS(2252),
    [anon_sym_noreturn] = ACTIONS(2252),
    [anon_sym_mutable] = ACTIONS(2252),
    [anon_sym_constinit] = ACTIONS(2252),
    [anon_sym_consteval] = ACTIONS(2252),
    [anon_sym_alignas] = ACTIONS(2252),
    [anon_sym__Alignas] = ACTIONS(2252),
    [sym_primitive_type] = ACTIONS(2252),
    [anon_sym_enum] = ACTIONS(2252),
    [anon_sym_class] = ACTIONS(2252),
    [anon_sym_struct] = ACTIONS(2252),
    [anon_sym_union] = ACTIONS(2252),
    [anon_sym_or] = ACTIONS(2252),
    [anon_sym_and] = ACTIONS(2252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_This] = ACTIONS(2252),
    [anon_sym_decltype] = ACTIONS(2252),
    [sym_virtual] = ACTIONS(2252),
    [anon_sym_explicit] = ACTIONS(2252),
    [anon_sym_typename] = ACTIONS(2252),
    [anon_sym_template] = ACTIONS(2252),
    [anon_sym_operator] = ACTIONS(2252),
    [anon_sym_friend] = ACTIONS(2252),
    [anon_sym_using] = ACTIONS(2252),
    [anon_sym_concept] = ACTIONS(2252),
    [anon_sym_precise] = ACTIONS(2252),
    [anon_sym_shared] = ACTIONS(2252),
    [anon_sym_groupshared] = ACTIONS(2252),
    [anon_sym_uniform] = ACTIONS(2252),
    [anon_sym_row_major] = ACTIONS(2252),
    [anon_sym_column_major] = ACTIONS(2252),
    [anon_sym_globallycoherent] = ACTIONS(2252),
    [anon_sym_centroid] = ACTIONS(2252),
    [anon_sym_noperspective] = ACTIONS(2252),
    [anon_sym_nointerpolation] = ACTIONS(2252),
    [anon_sym_sample] = ACTIONS(2252),
    [anon_sym_linear] = ACTIONS(2252),
    [anon_sym_snorm] = ACTIONS(2252),
    [anon_sym_unorm] = ACTIONS(2252),
    [anon_sym_point] = ACTIONS(2252),
    [anon_sym_line] = ACTIONS(2252),
    [anon_sym_triangleadj] = ACTIONS(2252),
    [anon_sym_lineadj] = ACTIONS(2252),
    [anon_sym_triangle] = ACTIONS(2252),
    [anon_sym_interface] = ACTIONS(2252),
    [anon_sym_extension] = ACTIONS(2252),
  },
  [2614] = {
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_LPAREN2] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym___extension__] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_out] = ACTIONS(2373),
    [anon_sym_inout] = ACTIONS(2373),
    [anon_sym_extern] = ACTIONS(2373),
    [anon_sym___attribute__] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2371),
    [anon_sym___declspec] = ACTIONS(2373),
    [anon_sym___based] = ACTIONS(2373),
    [anon_sym___cdecl] = ACTIONS(2373),
    [anon_sym___clrcall] = ACTIONS(2373),
    [anon_sym___stdcall] = ACTIONS(2373),
    [anon_sym___fastcall] = ACTIONS(2373),
    [anon_sym___thiscall] = ACTIONS(2373),
    [anon_sym___vectorcall] = ACTIONS(2373),
    [anon_sym_signed] = ACTIONS(2373),
    [anon_sym_unsigned] = ACTIONS(2373),
    [anon_sym_long] = ACTIONS(2373),
    [anon_sym_short] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2373),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_register] = ACTIONS(2373),
    [anon_sym_inline] = ACTIONS(2373),
    [anon_sym___inline] = ACTIONS(2373),
    [anon_sym___inline__] = ACTIONS(2373),
    [anon_sym___forceinline] = ACTIONS(2373),
    [anon_sym_thread_local] = ACTIONS(2373),
    [anon_sym___thread] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym___restrict__] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym__Noreturn] = ACTIONS(2373),
    [anon_sym_noreturn] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_constinit] = ACTIONS(2373),
    [anon_sym_consteval] = ACTIONS(2373),
    [anon_sym_alignas] = ACTIONS(2373),
    [anon_sym__Alignas] = ACTIONS(2373),
    [sym_primitive_type] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_class] = ACTIONS(2373),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_or] = ACTIONS(2373),
    [anon_sym_and] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_This] = ACTIONS(2373),
    [anon_sym_decltype] = ACTIONS(2373),
    [sym_virtual] = ACTIONS(2373),
    [anon_sym_explicit] = ACTIONS(2373),
    [anon_sym_typename] = ACTIONS(2373),
    [anon_sym_template] = ACTIONS(2373),
    [anon_sym_operator] = ACTIONS(2373),
    [anon_sym_friend] = ACTIONS(2373),
    [anon_sym_using] = ACTIONS(2373),
    [anon_sym_concept] = ACTIONS(2373),
    [anon_sym_precise] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_groupshared] = ACTIONS(2373),
    [anon_sym_uniform] = ACTIONS(2373),
    [anon_sym_row_major] = ACTIONS(2373),
    [anon_sym_column_major] = ACTIONS(2373),
    [anon_sym_globallycoherent] = ACTIONS(2373),
    [anon_sym_centroid] = ACTIONS(2373),
    [anon_sym_noperspective] = ACTIONS(2373),
    [anon_sym_nointerpolation] = ACTIONS(2373),
    [anon_sym_sample] = ACTIONS(2373),
    [anon_sym_linear] = ACTIONS(2373),
    [anon_sym_snorm] = ACTIONS(2373),
    [anon_sym_unorm] = ACTIONS(2373),
    [anon_sym_point] = ACTIONS(2373),
    [anon_sym_line] = ACTIONS(2373),
    [anon_sym_triangleadj] = ACTIONS(2373),
    [anon_sym_lineadj] = ACTIONS(2373),
    [anon_sym_triangle] = ACTIONS(2373),
    [anon_sym_interface] = ACTIONS(2373),
    [anon_sym_extension] = ACTIONS(2373),
  },
  [2615] = {
    [sym_identifier] = ACTIONS(2186),
    [anon_sym_LPAREN2] = ACTIONS(2188),
    [anon_sym_TILDE] = ACTIONS(2188),
    [anon_sym_STAR] = ACTIONS(2188),
    [anon_sym_PIPE_PIPE] = ACTIONS(2188),
    [anon_sym_AMP_AMP] = ACTIONS(2188),
    [anon_sym_AMP] = ACTIONS(2186),
    [anon_sym___extension__] = ACTIONS(2186),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_out] = ACTIONS(2186),
    [anon_sym_inout] = ACTIONS(2186),
    [anon_sym_extern] = ACTIONS(2186),
    [anon_sym___attribute__] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2188),
    [anon_sym___declspec] = ACTIONS(2186),
    [anon_sym___based] = ACTIONS(2186),
    [anon_sym___cdecl] = ACTIONS(2186),
    [anon_sym___clrcall] = ACTIONS(2186),
    [anon_sym___stdcall] = ACTIONS(2186),
    [anon_sym___fastcall] = ACTIONS(2186),
    [anon_sym___thiscall] = ACTIONS(2186),
    [anon_sym___vectorcall] = ACTIONS(2186),
    [anon_sym_signed] = ACTIONS(2186),
    [anon_sym_unsigned] = ACTIONS(2186),
    [anon_sym_long] = ACTIONS(2186),
    [anon_sym_short] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_static] = ACTIONS(2186),
    [anon_sym_register] = ACTIONS(2186),
    [anon_sym_inline] = ACTIONS(2186),
    [anon_sym___inline] = ACTIONS(2186),
    [anon_sym___inline__] = ACTIONS(2186),
    [anon_sym___forceinline] = ACTIONS(2186),
    [anon_sym_thread_local] = ACTIONS(2186),
    [anon_sym___thread] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_constexpr] = ACTIONS(2186),
    [anon_sym_volatile] = ACTIONS(2186),
    [anon_sym_restrict] = ACTIONS(2186),
    [anon_sym___restrict__] = ACTIONS(2186),
    [anon_sym__Atomic] = ACTIONS(2186),
    [anon_sym__Noreturn] = ACTIONS(2186),
    [anon_sym_noreturn] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_constinit] = ACTIONS(2186),
    [anon_sym_consteval] = ACTIONS(2186),
    [anon_sym_alignas] = ACTIONS(2186),
    [anon_sym__Alignas] = ACTIONS(2186),
    [sym_primitive_type] = ACTIONS(2186),
    [anon_sym_enum] = ACTIONS(2186),
    [anon_sym_class] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_union] = ACTIONS(2186),
    [anon_sym_or] = ACTIONS(2186),
    [anon_sym_and] = ACTIONS(2186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_This] = ACTIONS(2186),
    [anon_sym_decltype] = ACTIONS(2186),
    [sym_virtual] = ACTIONS(2186),
    [anon_sym_explicit] = ACTIONS(2186),
    [anon_sym_typename] = ACTIONS(2186),
    [anon_sym_template] = ACTIONS(2186),
    [anon_sym_operator] = ACTIONS(2186),
    [anon_sym_friend] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_concept] = ACTIONS(2186),
    [anon_sym_precise] = ACTIONS(2186),
    [anon_sym_shared] = ACTIONS(2186),
    [anon_sym_groupshared] = ACTIONS(2186),
    [anon_sym_uniform] = ACTIONS(2186),
    [anon_sym_row_major] = ACTIONS(2186),
    [anon_sym_column_major] = ACTIONS(2186),
    [anon_sym_globallycoherent] = ACTIONS(2186),
    [anon_sym_centroid] = ACTIONS(2186),
    [anon_sym_noperspective] = ACTIONS(2186),
    [anon_sym_nointerpolation] = ACTIONS(2186),
    [anon_sym_sample] = ACTIONS(2186),
    [anon_sym_linear] = ACTIONS(2186),
    [anon_sym_snorm] = ACTIONS(2186),
    [anon_sym_unorm] = ACTIONS(2186),
    [anon_sym_point] = ACTIONS(2186),
    [anon_sym_line] = ACTIONS(2186),
    [anon_sym_triangleadj] = ACTIONS(2186),
    [anon_sym_lineadj] = ACTIONS(2186),
    [anon_sym_triangle] = ACTIONS(2186),
    [anon_sym_interface] = ACTIONS(2186),
    [anon_sym_extension] = ACTIONS(2186),
  },
  [2616] = {
    [sym_identifier] = ACTIONS(2363),
    [anon_sym_LPAREN2] = ACTIONS(2361),
    [anon_sym_TILDE] = ACTIONS(2361),
    [anon_sym_STAR] = ACTIONS(2361),
    [anon_sym_PIPE_PIPE] = ACTIONS(2361),
    [anon_sym_AMP_AMP] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(2363),
    [anon_sym___extension__] = ACTIONS(2363),
    [anon_sym_in] = ACTIONS(2363),
    [anon_sym_out] = ACTIONS(2363),
    [anon_sym_inout] = ACTIONS(2363),
    [anon_sym_extern] = ACTIONS(2363),
    [anon_sym___attribute__] = ACTIONS(2363),
    [anon_sym_COLON_COLON] = ACTIONS(2361),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2361),
    [anon_sym___declspec] = ACTIONS(2363),
    [anon_sym___based] = ACTIONS(2363),
    [anon_sym___cdecl] = ACTIONS(2363),
    [anon_sym___clrcall] = ACTIONS(2363),
    [anon_sym___stdcall] = ACTIONS(2363),
    [anon_sym___fastcall] = ACTIONS(2363),
    [anon_sym___thiscall] = ACTIONS(2363),
    [anon_sym___vectorcall] = ACTIONS(2363),
    [anon_sym_signed] = ACTIONS(2363),
    [anon_sym_unsigned] = ACTIONS(2363),
    [anon_sym_long] = ACTIONS(2363),
    [anon_sym_short] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(2363),
    [anon_sym_static] = ACTIONS(2363),
    [anon_sym_register] = ACTIONS(2363),
    [anon_sym_inline] = ACTIONS(2363),
    [anon_sym___inline] = ACTIONS(2363),
    [anon_sym___inline__] = ACTIONS(2363),
    [anon_sym___forceinline] = ACTIONS(2363),
    [anon_sym_thread_local] = ACTIONS(2363),
    [anon_sym___thread] = ACTIONS(2363),
    [anon_sym_const] = ACTIONS(2363),
    [anon_sym_constexpr] = ACTIONS(2363),
    [anon_sym_volatile] = ACTIONS(2363),
    [anon_sym_restrict] = ACTIONS(2363),
    [anon_sym___restrict__] = ACTIONS(2363),
    [anon_sym__Atomic] = ACTIONS(2363),
    [anon_sym__Noreturn] = ACTIONS(2363),
    [anon_sym_noreturn] = ACTIONS(2363),
    [anon_sym_mutable] = ACTIONS(2363),
    [anon_sym_constinit] = ACTIONS(2363),
    [anon_sym_consteval] = ACTIONS(2363),
    [anon_sym_alignas] = ACTIONS(2363),
    [anon_sym__Alignas] = ACTIONS(2363),
    [sym_primitive_type] = ACTIONS(2363),
    [anon_sym_enum] = ACTIONS(2363),
    [anon_sym_class] = ACTIONS(2363),
    [anon_sym_struct] = ACTIONS(2363),
    [anon_sym_union] = ACTIONS(2363),
    [anon_sym_or] = ACTIONS(2363),
    [anon_sym_and] = ACTIONS(2363),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2363),
    [anon_sym_let] = ACTIONS(2363),
    [anon_sym_This] = ACTIONS(2363),
    [anon_sym_decltype] = ACTIONS(2363),
    [sym_virtual] = ACTIONS(2363),
    [anon_sym_explicit] = ACTIONS(2363),
    [anon_sym_typename] = ACTIONS(2363),
    [anon_sym_template] = ACTIONS(2363),
    [anon_sym_operator] = ACTIONS(2363),
    [anon_sym_friend] = ACTIONS(2363),
    [anon_sym_using] = ACTIONS(2363),
    [anon_sym_concept] = ACTIONS(2363),
    [anon_sym_precise] = ACTIONS(2363),
    [anon_sym_shared] = ACTIONS(2363),
    [anon_sym_groupshared] = ACTIONS(2363),
    [anon_sym_uniform] = ACTIONS(2363),
    [anon_sym_row_major] = ACTIONS(2363),
    [anon_sym_column_major] = ACTIONS(2363),
    [anon_sym_globallycoherent] = ACTIONS(2363),
    [anon_sym_centroid] = ACTIONS(2363),
    [anon_sym_noperspective] = ACTIONS(2363),
    [anon_sym_nointerpolation] = ACTIONS(2363),
    [anon_sym_sample] = ACTIONS(2363),
    [anon_sym_linear] = ACTIONS(2363),
    [anon_sym_snorm] = ACTIONS(2363),
    [anon_sym_unorm] = ACTIONS(2363),
    [anon_sym_point] = ACTIONS(2363),
    [anon_sym_line] = ACTIONS(2363),
    [anon_sym_triangleadj] = ACTIONS(2363),
    [anon_sym_lineadj] = ACTIONS(2363),
    [anon_sym_triangle] = ACTIONS(2363),
    [anon_sym_interface] = ACTIONS(2363),
    [anon_sym_extension] = ACTIONS(2363),
  },
  [2617] = {
    [sym_identifier] = ACTIONS(2355),
    [anon_sym_LPAREN2] = ACTIONS(2353),
    [anon_sym_TILDE] = ACTIONS(2353),
    [anon_sym_STAR] = ACTIONS(2353),
    [anon_sym_PIPE_PIPE] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(2353),
    [anon_sym_AMP] = ACTIONS(2355),
    [anon_sym___extension__] = ACTIONS(2355),
    [anon_sym_in] = ACTIONS(2355),
    [anon_sym_out] = ACTIONS(2355),
    [anon_sym_inout] = ACTIONS(2355),
    [anon_sym_extern] = ACTIONS(2355),
    [anon_sym___attribute__] = ACTIONS(2355),
    [anon_sym_COLON_COLON] = ACTIONS(2353),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2353),
    [anon_sym___declspec] = ACTIONS(2355),
    [anon_sym___based] = ACTIONS(2355),
    [anon_sym___cdecl] = ACTIONS(2355),
    [anon_sym___clrcall] = ACTIONS(2355),
    [anon_sym___stdcall] = ACTIONS(2355),
    [anon_sym___fastcall] = ACTIONS(2355),
    [anon_sym___thiscall] = ACTIONS(2355),
    [anon_sym___vectorcall] = ACTIONS(2355),
    [anon_sym_signed] = ACTIONS(2355),
    [anon_sym_unsigned] = ACTIONS(2355),
    [anon_sym_long] = ACTIONS(2355),
    [anon_sym_short] = ACTIONS(2355),
    [anon_sym_LBRACK] = ACTIONS(2355),
    [anon_sym_static] = ACTIONS(2355),
    [anon_sym_register] = ACTIONS(2355),
    [anon_sym_inline] = ACTIONS(2355),
    [anon_sym___inline] = ACTIONS(2355),
    [anon_sym___inline__] = ACTIONS(2355),
    [anon_sym___forceinline] = ACTIONS(2355),
    [anon_sym_thread_local] = ACTIONS(2355),
    [anon_sym___thread] = ACTIONS(2355),
    [anon_sym_const] = ACTIONS(2355),
    [anon_sym_constexpr] = ACTIONS(2355),
    [anon_sym_volatile] = ACTIONS(2355),
    [anon_sym_restrict] = ACTIONS(2355),
    [anon_sym___restrict__] = ACTIONS(2355),
    [anon_sym__Atomic] = ACTIONS(2355),
    [anon_sym__Noreturn] = ACTIONS(2355),
    [anon_sym_noreturn] = ACTIONS(2355),
    [anon_sym_mutable] = ACTIONS(2355),
    [anon_sym_constinit] = ACTIONS(2355),
    [anon_sym_consteval] = ACTIONS(2355),
    [anon_sym_alignas] = ACTIONS(2355),
    [anon_sym__Alignas] = ACTIONS(2355),
    [sym_primitive_type] = ACTIONS(2355),
    [anon_sym_enum] = ACTIONS(2355),
    [anon_sym_class] = ACTIONS(2355),
    [anon_sym_struct] = ACTIONS(2355),
    [anon_sym_union] = ACTIONS(2355),
    [anon_sym_or] = ACTIONS(2355),
    [anon_sym_and] = ACTIONS(2355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2355),
    [anon_sym_let] = ACTIONS(2355),
    [anon_sym_This] = ACTIONS(2355),
    [anon_sym_decltype] = ACTIONS(2355),
    [sym_virtual] = ACTIONS(2355),
    [anon_sym_explicit] = ACTIONS(2355),
    [anon_sym_typename] = ACTIONS(2355),
    [anon_sym_template] = ACTIONS(2355),
    [anon_sym_operator] = ACTIONS(2355),
    [anon_sym_friend] = ACTIONS(2355),
    [anon_sym_using] = ACTIONS(2355),
    [anon_sym_concept] = ACTIONS(2355),
    [anon_sym_precise] = ACTIONS(2355),
    [anon_sym_shared] = ACTIONS(2355),
    [anon_sym_groupshared] = ACTIONS(2355),
    [anon_sym_uniform] = ACTIONS(2355),
    [anon_sym_row_major] = ACTIONS(2355),
    [anon_sym_column_major] = ACTIONS(2355),
    [anon_sym_globallycoherent] = ACTIONS(2355),
    [anon_sym_centroid] = ACTIONS(2355),
    [anon_sym_noperspective] = ACTIONS(2355),
    [anon_sym_nointerpolation] = ACTIONS(2355),
    [anon_sym_sample] = ACTIONS(2355),
    [anon_sym_linear] = ACTIONS(2355),
    [anon_sym_snorm] = ACTIONS(2355),
    [anon_sym_unorm] = ACTIONS(2355),
    [anon_sym_point] = ACTIONS(2355),
    [anon_sym_line] = ACTIONS(2355),
    [anon_sym_triangleadj] = ACTIONS(2355),
    [anon_sym_lineadj] = ACTIONS(2355),
    [anon_sym_triangle] = ACTIONS(2355),
    [anon_sym_interface] = ACTIONS(2355),
    [anon_sym_extension] = ACTIONS(2355),
  },
  [2618] = {
    [sym_identifier] = ACTIONS(2367),
    [anon_sym_LPAREN2] = ACTIONS(2365),
    [anon_sym_TILDE] = ACTIONS(2365),
    [anon_sym_STAR] = ACTIONS(2365),
    [anon_sym_PIPE_PIPE] = ACTIONS(2365),
    [anon_sym_AMP_AMP] = ACTIONS(2365),
    [anon_sym_AMP] = ACTIONS(2367),
    [anon_sym___extension__] = ACTIONS(2367),
    [anon_sym_in] = ACTIONS(2367),
    [anon_sym_out] = ACTIONS(2367),
    [anon_sym_inout] = ACTIONS(2367),
    [anon_sym_extern] = ACTIONS(2367),
    [anon_sym___attribute__] = ACTIONS(2367),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2365),
    [anon_sym___declspec] = ACTIONS(2367),
    [anon_sym___based] = ACTIONS(2367),
    [anon_sym___cdecl] = ACTIONS(2367),
    [anon_sym___clrcall] = ACTIONS(2367),
    [anon_sym___stdcall] = ACTIONS(2367),
    [anon_sym___fastcall] = ACTIONS(2367),
    [anon_sym___thiscall] = ACTIONS(2367),
    [anon_sym___vectorcall] = ACTIONS(2367),
    [anon_sym_signed] = ACTIONS(2367),
    [anon_sym_unsigned] = ACTIONS(2367),
    [anon_sym_long] = ACTIONS(2367),
    [anon_sym_short] = ACTIONS(2367),
    [anon_sym_LBRACK] = ACTIONS(2367),
    [anon_sym_static] = ACTIONS(2367),
    [anon_sym_register] = ACTIONS(2367),
    [anon_sym_inline] = ACTIONS(2367),
    [anon_sym___inline] = ACTIONS(2367),
    [anon_sym___inline__] = ACTIONS(2367),
    [anon_sym___forceinline] = ACTIONS(2367),
    [anon_sym_thread_local] = ACTIONS(2367),
    [anon_sym___thread] = ACTIONS(2367),
    [anon_sym_const] = ACTIONS(2367),
    [anon_sym_constexpr] = ACTIONS(2367),
    [anon_sym_volatile] = ACTIONS(2367),
    [anon_sym_restrict] = ACTIONS(2367),
    [anon_sym___restrict__] = ACTIONS(2367),
    [anon_sym__Atomic] = ACTIONS(2367),
    [anon_sym__Noreturn] = ACTIONS(2367),
    [anon_sym_noreturn] = ACTIONS(2367),
    [anon_sym_mutable] = ACTIONS(2367),
    [anon_sym_constinit] = ACTIONS(2367),
    [anon_sym_consteval] = ACTIONS(2367),
    [anon_sym_alignas] = ACTIONS(2367),
    [anon_sym__Alignas] = ACTIONS(2367),
    [sym_primitive_type] = ACTIONS(2367),
    [anon_sym_enum] = ACTIONS(2367),
    [anon_sym_class] = ACTIONS(2367),
    [anon_sym_struct] = ACTIONS(2367),
    [anon_sym_union] = ACTIONS(2367),
    [anon_sym_or] = ACTIONS(2367),
    [anon_sym_and] = ACTIONS(2367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2367),
    [anon_sym_let] = ACTIONS(2367),
    [anon_sym_This] = ACTIONS(2367),
    [anon_sym_decltype] = ACTIONS(2367),
    [sym_virtual] = ACTIONS(2367),
    [anon_sym_explicit] = ACTIONS(2367),
    [anon_sym_typename] = ACTIONS(2367),
    [anon_sym_template] = ACTIONS(2367),
    [anon_sym_operator] = ACTIONS(2367),
    [anon_sym_friend] = ACTIONS(2367),
    [anon_sym_using] = ACTIONS(2367),
    [anon_sym_concept] = ACTIONS(2367),
    [anon_sym_precise] = ACTIONS(2367),
    [anon_sym_shared] = ACTIONS(2367),
    [anon_sym_groupshared] = ACTIONS(2367),
    [anon_sym_uniform] = ACTIONS(2367),
    [anon_sym_row_major] = ACTIONS(2367),
    [anon_sym_column_major] = ACTIONS(2367),
    [anon_sym_globallycoherent] = ACTIONS(2367),
    [anon_sym_centroid] = ACTIONS(2367),
    [anon_sym_noperspective] = ACTIONS(2367),
    [anon_sym_nointerpolation] = ACTIONS(2367),
    [anon_sym_sample] = ACTIONS(2367),
    [anon_sym_linear] = ACTIONS(2367),
    [anon_sym_snorm] = ACTIONS(2367),
    [anon_sym_unorm] = ACTIONS(2367),
    [anon_sym_point] = ACTIONS(2367),
    [anon_sym_line] = ACTIONS(2367),
    [anon_sym_triangleadj] = ACTIONS(2367),
    [anon_sym_lineadj] = ACTIONS(2367),
    [anon_sym_triangle] = ACTIONS(2367),
    [anon_sym_interface] = ACTIONS(2367),
    [anon_sym_extension] = ACTIONS(2367),
  },
  [2619] = {
    [sym_identifier] = ACTIONS(2194),
    [anon_sym_LPAREN2] = ACTIONS(2196),
    [anon_sym_TILDE] = ACTIONS(2196),
    [anon_sym_STAR] = ACTIONS(2196),
    [anon_sym_PIPE_PIPE] = ACTIONS(2196),
    [anon_sym_AMP_AMP] = ACTIONS(2196),
    [anon_sym_AMP] = ACTIONS(2194),
    [anon_sym___extension__] = ACTIONS(2194),
    [anon_sym_in] = ACTIONS(2194),
    [anon_sym_out] = ACTIONS(2194),
    [anon_sym_inout] = ACTIONS(2194),
    [anon_sym_extern] = ACTIONS(2194),
    [anon_sym___attribute__] = ACTIONS(2194),
    [anon_sym_COLON_COLON] = ACTIONS(2196),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2196),
    [anon_sym___declspec] = ACTIONS(2194),
    [anon_sym___based] = ACTIONS(2194),
    [anon_sym___cdecl] = ACTIONS(2194),
    [anon_sym___clrcall] = ACTIONS(2194),
    [anon_sym___stdcall] = ACTIONS(2194),
    [anon_sym___fastcall] = ACTIONS(2194),
    [anon_sym___thiscall] = ACTIONS(2194),
    [anon_sym___vectorcall] = ACTIONS(2194),
    [anon_sym_signed] = ACTIONS(2194),
    [anon_sym_unsigned] = ACTIONS(2194),
    [anon_sym_long] = ACTIONS(2194),
    [anon_sym_short] = ACTIONS(2194),
    [anon_sym_LBRACK] = ACTIONS(2194),
    [anon_sym_static] = ACTIONS(2194),
    [anon_sym_register] = ACTIONS(2194),
    [anon_sym_inline] = ACTIONS(2194),
    [anon_sym___inline] = ACTIONS(2194),
    [anon_sym___inline__] = ACTIONS(2194),
    [anon_sym___forceinline] = ACTIONS(2194),
    [anon_sym_thread_local] = ACTIONS(2194),
    [anon_sym___thread] = ACTIONS(2194),
    [anon_sym_const] = ACTIONS(2194),
    [anon_sym_constexpr] = ACTIONS(2194),
    [anon_sym_volatile] = ACTIONS(2194),
    [anon_sym_restrict] = ACTIONS(2194),
    [anon_sym___restrict__] = ACTIONS(2194),
    [anon_sym__Atomic] = ACTIONS(2194),
    [anon_sym__Noreturn] = ACTIONS(2194),
    [anon_sym_noreturn] = ACTIONS(2194),
    [anon_sym_mutable] = ACTIONS(2194),
    [anon_sym_constinit] = ACTIONS(2194),
    [anon_sym_consteval] = ACTIONS(2194),
    [anon_sym_alignas] = ACTIONS(2194),
    [anon_sym__Alignas] = ACTIONS(2194),
    [sym_primitive_type] = ACTIONS(2194),
    [anon_sym_enum] = ACTIONS(2194),
    [anon_sym_class] = ACTIONS(2194),
    [anon_sym_struct] = ACTIONS(2194),
    [anon_sym_union] = ACTIONS(2194),
    [anon_sym_or] = ACTIONS(2194),
    [anon_sym_and] = ACTIONS(2194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2194),
    [anon_sym_let] = ACTIONS(2194),
    [anon_sym_This] = ACTIONS(2194),
    [anon_sym_decltype] = ACTIONS(2194),
    [sym_virtual] = ACTIONS(2194),
    [anon_sym_explicit] = ACTIONS(2194),
    [anon_sym_typename] = ACTIONS(2194),
    [anon_sym_template] = ACTIONS(2194),
    [anon_sym_operator] = ACTIONS(2194),
    [anon_sym_friend] = ACTIONS(2194),
    [anon_sym_using] = ACTIONS(2194),
    [anon_sym_concept] = ACTIONS(2194),
    [anon_sym_precise] = ACTIONS(2194),
    [anon_sym_shared] = ACTIONS(2194),
    [anon_sym_groupshared] = ACTIONS(2194),
    [anon_sym_uniform] = ACTIONS(2194),
    [anon_sym_row_major] = ACTIONS(2194),
    [anon_sym_column_major] = ACTIONS(2194),
    [anon_sym_globallycoherent] = ACTIONS(2194),
    [anon_sym_centroid] = ACTIONS(2194),
    [anon_sym_noperspective] = ACTIONS(2194),
    [anon_sym_nointerpolation] = ACTIONS(2194),
    [anon_sym_sample] = ACTIONS(2194),
    [anon_sym_linear] = ACTIONS(2194),
    [anon_sym_snorm] = ACTIONS(2194),
    [anon_sym_unorm] = ACTIONS(2194),
    [anon_sym_point] = ACTIONS(2194),
    [anon_sym_line] = ACTIONS(2194),
    [anon_sym_triangleadj] = ACTIONS(2194),
    [anon_sym_lineadj] = ACTIONS(2194),
    [anon_sym_triangle] = ACTIONS(2194),
    [anon_sym_interface] = ACTIONS(2194),
    [anon_sym_extension] = ACTIONS(2194),
  },
  [2620] = {
    [sym_identifier] = ACTIONS(2240),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_TILDE] = ACTIONS(2242),
    [anon_sym_STAR] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_AMP] = ACTIONS(2240),
    [anon_sym___extension__] = ACTIONS(2240),
    [anon_sym_in] = ACTIONS(2240),
    [anon_sym_out] = ACTIONS(2240),
    [anon_sym_inout] = ACTIONS(2240),
    [anon_sym_extern] = ACTIONS(2240),
    [anon_sym___attribute__] = ACTIONS(2240),
    [anon_sym_COLON_COLON] = ACTIONS(2242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2242),
    [anon_sym___declspec] = ACTIONS(2240),
    [anon_sym___based] = ACTIONS(2240),
    [anon_sym___cdecl] = ACTIONS(2240),
    [anon_sym___clrcall] = ACTIONS(2240),
    [anon_sym___stdcall] = ACTIONS(2240),
    [anon_sym___fastcall] = ACTIONS(2240),
    [anon_sym___thiscall] = ACTIONS(2240),
    [anon_sym___vectorcall] = ACTIONS(2240),
    [anon_sym_signed] = ACTIONS(2240),
    [anon_sym_unsigned] = ACTIONS(2240),
    [anon_sym_long] = ACTIONS(2240),
    [anon_sym_short] = ACTIONS(2240),
    [anon_sym_LBRACK] = ACTIONS(2240),
    [anon_sym_static] = ACTIONS(2240),
    [anon_sym_register] = ACTIONS(2240),
    [anon_sym_inline] = ACTIONS(2240),
    [anon_sym___inline] = ACTIONS(2240),
    [anon_sym___inline__] = ACTIONS(2240),
    [anon_sym___forceinline] = ACTIONS(2240),
    [anon_sym_thread_local] = ACTIONS(2240),
    [anon_sym___thread] = ACTIONS(2240),
    [anon_sym_const] = ACTIONS(2240),
    [anon_sym_constexpr] = ACTIONS(2240),
    [anon_sym_volatile] = ACTIONS(2240),
    [anon_sym_restrict] = ACTIONS(2240),
    [anon_sym___restrict__] = ACTIONS(2240),
    [anon_sym__Atomic] = ACTIONS(2240),
    [anon_sym__Noreturn] = ACTIONS(2240),
    [anon_sym_noreturn] = ACTIONS(2240),
    [anon_sym_mutable] = ACTIONS(2240),
    [anon_sym_constinit] = ACTIONS(2240),
    [anon_sym_consteval] = ACTIONS(2240),
    [anon_sym_alignas] = ACTIONS(2240),
    [anon_sym__Alignas] = ACTIONS(2240),
    [sym_primitive_type] = ACTIONS(2240),
    [anon_sym_enum] = ACTIONS(2240),
    [anon_sym_class] = ACTIONS(2240),
    [anon_sym_struct] = ACTIONS(2240),
    [anon_sym_union] = ACTIONS(2240),
    [anon_sym_or] = ACTIONS(2240),
    [anon_sym_and] = ACTIONS(2240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2240),
    [anon_sym_let] = ACTIONS(2240),
    [anon_sym_This] = ACTIONS(2240),
    [anon_sym_decltype] = ACTIONS(2240),
    [sym_virtual] = ACTIONS(2240),
    [anon_sym_explicit] = ACTIONS(2240),
    [anon_sym_typename] = ACTIONS(2240),
    [anon_sym_template] = ACTIONS(2240),
    [anon_sym_operator] = ACTIONS(2240),
    [anon_sym_friend] = ACTIONS(2240),
    [anon_sym_using] = ACTIONS(2240),
    [anon_sym_concept] = ACTIONS(2240),
    [anon_sym_precise] = ACTIONS(2240),
    [anon_sym_shared] = ACTIONS(2240),
    [anon_sym_groupshared] = ACTIONS(2240),
    [anon_sym_uniform] = ACTIONS(2240),
    [anon_sym_row_major] = ACTIONS(2240),
    [anon_sym_column_major] = ACTIONS(2240),
    [anon_sym_globallycoherent] = ACTIONS(2240),
    [anon_sym_centroid] = ACTIONS(2240),
    [anon_sym_noperspective] = ACTIONS(2240),
    [anon_sym_nointerpolation] = ACTIONS(2240),
    [anon_sym_sample] = ACTIONS(2240),
    [anon_sym_linear] = ACTIONS(2240),
    [anon_sym_snorm] = ACTIONS(2240),
    [anon_sym_unorm] = ACTIONS(2240),
    [anon_sym_point] = ACTIONS(2240),
    [anon_sym_line] = ACTIONS(2240),
    [anon_sym_triangleadj] = ACTIONS(2240),
    [anon_sym_lineadj] = ACTIONS(2240),
    [anon_sym_triangle] = ACTIONS(2240),
    [anon_sym_interface] = ACTIONS(2240),
    [anon_sym_extension] = ACTIONS(2240),
  },
  [2621] = {
    [sym_identifier] = ACTIONS(2236),
    [anon_sym_LPAREN2] = ACTIONS(2238),
    [anon_sym_TILDE] = ACTIONS(2238),
    [anon_sym_STAR] = ACTIONS(2238),
    [anon_sym_PIPE_PIPE] = ACTIONS(2238),
    [anon_sym_AMP_AMP] = ACTIONS(2238),
    [anon_sym_AMP] = ACTIONS(2236),
    [anon_sym___extension__] = ACTIONS(2236),
    [anon_sym_in] = ACTIONS(2236),
    [anon_sym_out] = ACTIONS(2236),
    [anon_sym_inout] = ACTIONS(2236),
    [anon_sym_extern] = ACTIONS(2236),
    [anon_sym___attribute__] = ACTIONS(2236),
    [anon_sym_COLON_COLON] = ACTIONS(2238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2238),
    [anon_sym___declspec] = ACTIONS(2236),
    [anon_sym___based] = ACTIONS(2236),
    [anon_sym___cdecl] = ACTIONS(2236),
    [anon_sym___clrcall] = ACTIONS(2236),
    [anon_sym___stdcall] = ACTIONS(2236),
    [anon_sym___fastcall] = ACTIONS(2236),
    [anon_sym___thiscall] = ACTIONS(2236),
    [anon_sym___vectorcall] = ACTIONS(2236),
    [anon_sym_signed] = ACTIONS(2236),
    [anon_sym_unsigned] = ACTIONS(2236),
    [anon_sym_long] = ACTIONS(2236),
    [anon_sym_short] = ACTIONS(2236),
    [anon_sym_LBRACK] = ACTIONS(2236),
    [anon_sym_static] = ACTIONS(2236),
    [anon_sym_register] = ACTIONS(2236),
    [anon_sym_inline] = ACTIONS(2236),
    [anon_sym___inline] = ACTIONS(2236),
    [anon_sym___inline__] = ACTIONS(2236),
    [anon_sym___forceinline] = ACTIONS(2236),
    [anon_sym_thread_local] = ACTIONS(2236),
    [anon_sym___thread] = ACTIONS(2236),
    [anon_sym_const] = ACTIONS(2236),
    [anon_sym_constexpr] = ACTIONS(2236),
    [anon_sym_volatile] = ACTIONS(2236),
    [anon_sym_restrict] = ACTIONS(2236),
    [anon_sym___restrict__] = ACTIONS(2236),
    [anon_sym__Atomic] = ACTIONS(2236),
    [anon_sym__Noreturn] = ACTIONS(2236),
    [anon_sym_noreturn] = ACTIONS(2236),
    [anon_sym_mutable] = ACTIONS(2236),
    [anon_sym_constinit] = ACTIONS(2236),
    [anon_sym_consteval] = ACTIONS(2236),
    [anon_sym_alignas] = ACTIONS(2236),
    [anon_sym__Alignas] = ACTIONS(2236),
    [sym_primitive_type] = ACTIONS(2236),
    [anon_sym_enum] = ACTIONS(2236),
    [anon_sym_class] = ACTIONS(2236),
    [anon_sym_struct] = ACTIONS(2236),
    [anon_sym_union] = ACTIONS(2236),
    [anon_sym_or] = ACTIONS(2236),
    [anon_sym_and] = ACTIONS(2236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2236),
    [anon_sym_let] = ACTIONS(2236),
    [anon_sym_This] = ACTIONS(2236),
    [anon_sym_decltype] = ACTIONS(2236),
    [sym_virtual] = ACTIONS(2236),
    [anon_sym_explicit] = ACTIONS(2236),
    [anon_sym_typename] = ACTIONS(2236),
    [anon_sym_template] = ACTIONS(2236),
    [anon_sym_operator] = ACTIONS(2236),
    [anon_sym_friend] = ACTIONS(2236),
    [anon_sym_using] = ACTIONS(2236),
    [anon_sym_concept] = ACTIONS(2236),
    [anon_sym_precise] = ACTIONS(2236),
    [anon_sym_shared] = ACTIONS(2236),
    [anon_sym_groupshared] = ACTIONS(2236),
    [anon_sym_uniform] = ACTIONS(2236),
    [anon_sym_row_major] = ACTIONS(2236),
    [anon_sym_column_major] = ACTIONS(2236),
    [anon_sym_globallycoherent] = ACTIONS(2236),
    [anon_sym_centroid] = ACTIONS(2236),
    [anon_sym_noperspective] = ACTIONS(2236),
    [anon_sym_nointerpolation] = ACTIONS(2236),
    [anon_sym_sample] = ACTIONS(2236),
    [anon_sym_linear] = ACTIONS(2236),
    [anon_sym_snorm] = ACTIONS(2236),
    [anon_sym_unorm] = ACTIONS(2236),
    [anon_sym_point] = ACTIONS(2236),
    [anon_sym_line] = ACTIONS(2236),
    [anon_sym_triangleadj] = ACTIONS(2236),
    [anon_sym_lineadj] = ACTIONS(2236),
    [anon_sym_triangle] = ACTIONS(2236),
    [anon_sym_interface] = ACTIONS(2236),
    [anon_sym_extension] = ACTIONS(2236),
  },
  [2622] = {
    [sym_identifier] = ACTIONS(2202),
    [anon_sym_LPAREN2] = ACTIONS(2204),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_STAR] = ACTIONS(2204),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_AMP] = ACTIONS(2202),
    [anon_sym___extension__] = ACTIONS(2202),
    [anon_sym_in] = ACTIONS(2202),
    [anon_sym_out] = ACTIONS(2202),
    [anon_sym_inout] = ACTIONS(2202),
    [anon_sym_extern] = ACTIONS(2202),
    [anon_sym___attribute__] = ACTIONS(2202),
    [anon_sym_COLON_COLON] = ACTIONS(2204),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2204),
    [anon_sym___declspec] = ACTIONS(2202),
    [anon_sym___based] = ACTIONS(2202),
    [anon_sym___cdecl] = ACTIONS(2202),
    [anon_sym___clrcall] = ACTIONS(2202),
    [anon_sym___stdcall] = ACTIONS(2202),
    [anon_sym___fastcall] = ACTIONS(2202),
    [anon_sym___thiscall] = ACTIONS(2202),
    [anon_sym___vectorcall] = ACTIONS(2202),
    [anon_sym_signed] = ACTIONS(2202),
    [anon_sym_unsigned] = ACTIONS(2202),
    [anon_sym_long] = ACTIONS(2202),
    [anon_sym_short] = ACTIONS(2202),
    [anon_sym_LBRACK] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2202),
    [anon_sym_register] = ACTIONS(2202),
    [anon_sym_inline] = ACTIONS(2202),
    [anon_sym___inline] = ACTIONS(2202),
    [anon_sym___inline__] = ACTIONS(2202),
    [anon_sym___forceinline] = ACTIONS(2202),
    [anon_sym_thread_local] = ACTIONS(2202),
    [anon_sym___thread] = ACTIONS(2202),
    [anon_sym_const] = ACTIONS(2202),
    [anon_sym_constexpr] = ACTIONS(2202),
    [anon_sym_volatile] = ACTIONS(2202),
    [anon_sym_restrict] = ACTIONS(2202),
    [anon_sym___restrict__] = ACTIONS(2202),
    [anon_sym__Atomic] = ACTIONS(2202),
    [anon_sym__Noreturn] = ACTIONS(2202),
    [anon_sym_noreturn] = ACTIONS(2202),
    [anon_sym_mutable] = ACTIONS(2202),
    [anon_sym_constinit] = ACTIONS(2202),
    [anon_sym_consteval] = ACTIONS(2202),
    [anon_sym_alignas] = ACTIONS(2202),
    [anon_sym__Alignas] = ACTIONS(2202),
    [sym_primitive_type] = ACTIONS(2202),
    [anon_sym_enum] = ACTIONS(2202),
    [anon_sym_class] = ACTIONS(2202),
    [anon_sym_struct] = ACTIONS(2202),
    [anon_sym_union] = ACTIONS(2202),
    [anon_sym_or] = ACTIONS(2202),
    [anon_sym_and] = ACTIONS(2202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2202),
    [anon_sym_let] = ACTIONS(2202),
    [anon_sym_This] = ACTIONS(2202),
    [anon_sym_decltype] = ACTIONS(2202),
    [sym_virtual] = ACTIONS(2202),
    [anon_sym_explicit] = ACTIONS(2202),
    [anon_sym_typename] = ACTIONS(2202),
    [anon_sym_template] = ACTIONS(2202),
    [anon_sym_operator] = ACTIONS(2202),
    [anon_sym_friend] = ACTIONS(2202),
    [anon_sym_using] = ACTIONS(2202),
    [anon_sym_concept] = ACTIONS(2202),
    [anon_sym_precise] = ACTIONS(2202),
    [anon_sym_shared] = ACTIONS(2202),
    [anon_sym_groupshared] = ACTIONS(2202),
    [anon_sym_uniform] = ACTIONS(2202),
    [anon_sym_row_major] = ACTIONS(2202),
    [anon_sym_column_major] = ACTIONS(2202),
    [anon_sym_globallycoherent] = ACTIONS(2202),
    [anon_sym_centroid] = ACTIONS(2202),
    [anon_sym_noperspective] = ACTIONS(2202),
    [anon_sym_nointerpolation] = ACTIONS(2202),
    [anon_sym_sample] = ACTIONS(2202),
    [anon_sym_linear] = ACTIONS(2202),
    [anon_sym_snorm] = ACTIONS(2202),
    [anon_sym_unorm] = ACTIONS(2202),
    [anon_sym_point] = ACTIONS(2202),
    [anon_sym_line] = ACTIONS(2202),
    [anon_sym_triangleadj] = ACTIONS(2202),
    [anon_sym_lineadj] = ACTIONS(2202),
    [anon_sym_triangle] = ACTIONS(2202),
    [anon_sym_interface] = ACTIONS(2202),
    [anon_sym_extension] = ACTIONS(2202),
  },
  [2623] = {
    [sym_identifier] = ACTIONS(2206),
    [anon_sym_LPAREN2] = ACTIONS(2208),
    [anon_sym_TILDE] = ACTIONS(2208),
    [anon_sym_STAR] = ACTIONS(2208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2208),
    [anon_sym_AMP_AMP] = ACTIONS(2208),
    [anon_sym_AMP] = ACTIONS(2206),
    [anon_sym___extension__] = ACTIONS(2206),
    [anon_sym_in] = ACTIONS(2206),
    [anon_sym_out] = ACTIONS(2206),
    [anon_sym_inout] = ACTIONS(2206),
    [anon_sym_extern] = ACTIONS(2206),
    [anon_sym___attribute__] = ACTIONS(2206),
    [anon_sym_COLON_COLON] = ACTIONS(2208),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2208),
    [anon_sym___declspec] = ACTIONS(2206),
    [anon_sym___based] = ACTIONS(2206),
    [anon_sym___cdecl] = ACTIONS(2206),
    [anon_sym___clrcall] = ACTIONS(2206),
    [anon_sym___stdcall] = ACTIONS(2206),
    [anon_sym___fastcall] = ACTIONS(2206),
    [anon_sym___thiscall] = ACTIONS(2206),
    [anon_sym___vectorcall] = ACTIONS(2206),
    [anon_sym_signed] = ACTIONS(2206),
    [anon_sym_unsigned] = ACTIONS(2206),
    [anon_sym_long] = ACTIONS(2206),
    [anon_sym_short] = ACTIONS(2206),
    [anon_sym_LBRACK] = ACTIONS(2206),
    [anon_sym_static] = ACTIONS(2206),
    [anon_sym_register] = ACTIONS(2206),
    [anon_sym_inline] = ACTIONS(2206),
    [anon_sym___inline] = ACTIONS(2206),
    [anon_sym___inline__] = ACTIONS(2206),
    [anon_sym___forceinline] = ACTIONS(2206),
    [anon_sym_thread_local] = ACTIONS(2206),
    [anon_sym___thread] = ACTIONS(2206),
    [anon_sym_const] = ACTIONS(2206),
    [anon_sym_constexpr] = ACTIONS(2206),
    [anon_sym_volatile] = ACTIONS(2206),
    [anon_sym_restrict] = ACTIONS(2206),
    [anon_sym___restrict__] = ACTIONS(2206),
    [anon_sym__Atomic] = ACTIONS(2206),
    [anon_sym__Noreturn] = ACTIONS(2206),
    [anon_sym_noreturn] = ACTIONS(2206),
    [anon_sym_mutable] = ACTIONS(2206),
    [anon_sym_constinit] = ACTIONS(2206),
    [anon_sym_consteval] = ACTIONS(2206),
    [anon_sym_alignas] = ACTIONS(2206),
    [anon_sym__Alignas] = ACTIONS(2206),
    [sym_primitive_type] = ACTIONS(2206),
    [anon_sym_enum] = ACTIONS(2206),
    [anon_sym_class] = ACTIONS(2206),
    [anon_sym_struct] = ACTIONS(2206),
    [anon_sym_union] = ACTIONS(2206),
    [anon_sym_or] = ACTIONS(2206),
    [anon_sym_and] = ACTIONS(2206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2206),
    [anon_sym_let] = ACTIONS(2206),
    [anon_sym_This] = ACTIONS(2206),
    [anon_sym_decltype] = ACTIONS(2206),
    [sym_virtual] = ACTIONS(2206),
    [anon_sym_explicit] = ACTIONS(2206),
    [anon_sym_typename] = ACTIONS(2206),
    [anon_sym_template] = ACTIONS(2206),
    [anon_sym_operator] = ACTIONS(2206),
    [anon_sym_friend] = ACTIONS(2206),
    [anon_sym_using] = ACTIONS(2206),
    [anon_sym_concept] = ACTIONS(2206),
    [anon_sym_precise] = ACTIONS(2206),
    [anon_sym_shared] = ACTIONS(2206),
    [anon_sym_groupshared] = ACTIONS(2206),
    [anon_sym_uniform] = ACTIONS(2206),
    [anon_sym_row_major] = ACTIONS(2206),
    [anon_sym_column_major] = ACTIONS(2206),
    [anon_sym_globallycoherent] = ACTIONS(2206),
    [anon_sym_centroid] = ACTIONS(2206),
    [anon_sym_noperspective] = ACTIONS(2206),
    [anon_sym_nointerpolation] = ACTIONS(2206),
    [anon_sym_sample] = ACTIONS(2206),
    [anon_sym_linear] = ACTIONS(2206),
    [anon_sym_snorm] = ACTIONS(2206),
    [anon_sym_unorm] = ACTIONS(2206),
    [anon_sym_point] = ACTIONS(2206),
    [anon_sym_line] = ACTIONS(2206),
    [anon_sym_triangleadj] = ACTIONS(2206),
    [anon_sym_lineadj] = ACTIONS(2206),
    [anon_sym_triangle] = ACTIONS(2206),
    [anon_sym_interface] = ACTIONS(2206),
    [anon_sym_extension] = ACTIONS(2206),
  },
  [2624] = {
    [sym_identifier] = ACTIONS(2248),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2248),
    [anon_sym___extension__] = ACTIONS(2248),
    [anon_sym_in] = ACTIONS(2248),
    [anon_sym_out] = ACTIONS(2248),
    [anon_sym_inout] = ACTIONS(2248),
    [anon_sym_extern] = ACTIONS(2248),
    [anon_sym___attribute__] = ACTIONS(2248),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2250),
    [anon_sym___declspec] = ACTIONS(2248),
    [anon_sym___based] = ACTIONS(2248),
    [anon_sym___cdecl] = ACTIONS(2248),
    [anon_sym___clrcall] = ACTIONS(2248),
    [anon_sym___stdcall] = ACTIONS(2248),
    [anon_sym___fastcall] = ACTIONS(2248),
    [anon_sym___thiscall] = ACTIONS(2248),
    [anon_sym___vectorcall] = ACTIONS(2248),
    [anon_sym_signed] = ACTIONS(2248),
    [anon_sym_unsigned] = ACTIONS(2248),
    [anon_sym_long] = ACTIONS(2248),
    [anon_sym_short] = ACTIONS(2248),
    [anon_sym_LBRACK] = ACTIONS(2248),
    [anon_sym_static] = ACTIONS(2248),
    [anon_sym_register] = ACTIONS(2248),
    [anon_sym_inline] = ACTIONS(2248),
    [anon_sym___inline] = ACTIONS(2248),
    [anon_sym___inline__] = ACTIONS(2248),
    [anon_sym___forceinline] = ACTIONS(2248),
    [anon_sym_thread_local] = ACTIONS(2248),
    [anon_sym___thread] = ACTIONS(2248),
    [anon_sym_const] = ACTIONS(2248),
    [anon_sym_constexpr] = ACTIONS(2248),
    [anon_sym_volatile] = ACTIONS(2248),
    [anon_sym_restrict] = ACTIONS(2248),
    [anon_sym___restrict__] = ACTIONS(2248),
    [anon_sym__Atomic] = ACTIONS(2248),
    [anon_sym__Noreturn] = ACTIONS(2248),
    [anon_sym_noreturn] = ACTIONS(2248),
    [anon_sym_mutable] = ACTIONS(2248),
    [anon_sym_constinit] = ACTIONS(2248),
    [anon_sym_consteval] = ACTIONS(2248),
    [anon_sym_alignas] = ACTIONS(2248),
    [anon_sym__Alignas] = ACTIONS(2248),
    [sym_primitive_type] = ACTIONS(2248),
    [anon_sym_enum] = ACTIONS(2248),
    [anon_sym_class] = ACTIONS(2248),
    [anon_sym_struct] = ACTIONS(2248),
    [anon_sym_union] = ACTIONS(2248),
    [anon_sym_or] = ACTIONS(2248),
    [anon_sym_and] = ACTIONS(2248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2248),
    [anon_sym_let] = ACTIONS(2248),
    [anon_sym_This] = ACTIONS(2248),
    [anon_sym_decltype] = ACTIONS(2248),
    [sym_virtual] = ACTIONS(2248),
    [anon_sym_explicit] = ACTIONS(2248),
    [anon_sym_typename] = ACTIONS(2248),
    [anon_sym_template] = ACTIONS(2248),
    [anon_sym_operator] = ACTIONS(2248),
    [anon_sym_friend] = ACTIONS(2248),
    [anon_sym_using] = ACTIONS(2248),
    [anon_sym_concept] = ACTIONS(2248),
    [anon_sym_precise] = ACTIONS(2248),
    [anon_sym_shared] = ACTIONS(2248),
    [anon_sym_groupshared] = ACTIONS(2248),
    [anon_sym_uniform] = ACTIONS(2248),
    [anon_sym_row_major] = ACTIONS(2248),
    [anon_sym_column_major] = ACTIONS(2248),
    [anon_sym_globallycoherent] = ACTIONS(2248),
    [anon_sym_centroid] = ACTIONS(2248),
    [anon_sym_noperspective] = ACTIONS(2248),
    [anon_sym_nointerpolation] = ACTIONS(2248),
    [anon_sym_sample] = ACTIONS(2248),
    [anon_sym_linear] = ACTIONS(2248),
    [anon_sym_snorm] = ACTIONS(2248),
    [anon_sym_unorm] = ACTIONS(2248),
    [anon_sym_point] = ACTIONS(2248),
    [anon_sym_line] = ACTIONS(2248),
    [anon_sym_triangleadj] = ACTIONS(2248),
    [anon_sym_lineadj] = ACTIONS(2248),
    [anon_sym_triangle] = ACTIONS(2248),
    [anon_sym_interface] = ACTIONS(2248),
    [anon_sym_extension] = ACTIONS(2248),
  },
  [2625] = {
    [sym_identifier] = ACTIONS(2256),
    [anon_sym_LPAREN2] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [anon_sym_STAR] = ACTIONS(2258),
    [anon_sym_PIPE_PIPE] = ACTIONS(2258),
    [anon_sym_AMP_AMP] = ACTIONS(2258),
    [anon_sym_AMP] = ACTIONS(2256),
    [anon_sym___extension__] = ACTIONS(2256),
    [anon_sym_in] = ACTIONS(2256),
    [anon_sym_out] = ACTIONS(2256),
    [anon_sym_inout] = ACTIONS(2256),
    [anon_sym_extern] = ACTIONS(2256),
    [anon_sym___attribute__] = ACTIONS(2256),
    [anon_sym_COLON_COLON] = ACTIONS(2258),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2258),
    [anon_sym___declspec] = ACTIONS(2256),
    [anon_sym___based] = ACTIONS(2256),
    [anon_sym___cdecl] = ACTIONS(2256),
    [anon_sym___clrcall] = ACTIONS(2256),
    [anon_sym___stdcall] = ACTIONS(2256),
    [anon_sym___fastcall] = ACTIONS(2256),
    [anon_sym___thiscall] = ACTIONS(2256),
    [anon_sym___vectorcall] = ACTIONS(2256),
    [anon_sym_signed] = ACTIONS(2256),
    [anon_sym_unsigned] = ACTIONS(2256),
    [anon_sym_long] = ACTIONS(2256),
    [anon_sym_short] = ACTIONS(2256),
    [anon_sym_LBRACK] = ACTIONS(2256),
    [anon_sym_static] = ACTIONS(2256),
    [anon_sym_register] = ACTIONS(2256),
    [anon_sym_inline] = ACTIONS(2256),
    [anon_sym___inline] = ACTIONS(2256),
    [anon_sym___inline__] = ACTIONS(2256),
    [anon_sym___forceinline] = ACTIONS(2256),
    [anon_sym_thread_local] = ACTIONS(2256),
    [anon_sym___thread] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_constexpr] = ACTIONS(2256),
    [anon_sym_volatile] = ACTIONS(2256),
    [anon_sym_restrict] = ACTIONS(2256),
    [anon_sym___restrict__] = ACTIONS(2256),
    [anon_sym__Atomic] = ACTIONS(2256),
    [anon_sym__Noreturn] = ACTIONS(2256),
    [anon_sym_noreturn] = ACTIONS(2256),
    [anon_sym_mutable] = ACTIONS(2256),
    [anon_sym_constinit] = ACTIONS(2256),
    [anon_sym_consteval] = ACTIONS(2256),
    [anon_sym_alignas] = ACTIONS(2256),
    [anon_sym__Alignas] = ACTIONS(2256),
    [sym_primitive_type] = ACTIONS(2256),
    [anon_sym_enum] = ACTIONS(2256),
    [anon_sym_class] = ACTIONS(2256),
    [anon_sym_struct] = ACTIONS(2256),
    [anon_sym_union] = ACTIONS(2256),
    [anon_sym_or] = ACTIONS(2256),
    [anon_sym_and] = ACTIONS(2256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_This] = ACTIONS(2256),
    [anon_sym_decltype] = ACTIONS(2256),
    [sym_virtual] = ACTIONS(2256),
    [anon_sym_explicit] = ACTIONS(2256),
    [anon_sym_typename] = ACTIONS(2256),
    [anon_sym_template] = ACTIONS(2256),
    [anon_sym_operator] = ACTIONS(2256),
    [anon_sym_friend] = ACTIONS(2256),
    [anon_sym_using] = ACTIONS(2256),
    [anon_sym_concept] = ACTIONS(2256),
    [anon_sym_precise] = ACTIONS(2256),
    [anon_sym_shared] = ACTIONS(2256),
    [anon_sym_groupshared] = ACTIONS(2256),
    [anon_sym_uniform] = ACTIONS(2256),
    [anon_sym_row_major] = ACTIONS(2256),
    [anon_sym_column_major] = ACTIONS(2256),
    [anon_sym_globallycoherent] = ACTIONS(2256),
    [anon_sym_centroid] = ACTIONS(2256),
    [anon_sym_noperspective] = ACTIONS(2256),
    [anon_sym_nointerpolation] = ACTIONS(2256),
    [anon_sym_sample] = ACTIONS(2256),
    [anon_sym_linear] = ACTIONS(2256),
    [anon_sym_snorm] = ACTIONS(2256),
    [anon_sym_unorm] = ACTIONS(2256),
    [anon_sym_point] = ACTIONS(2256),
    [anon_sym_line] = ACTIONS(2256),
    [anon_sym_triangleadj] = ACTIONS(2256),
    [anon_sym_lineadj] = ACTIONS(2256),
    [anon_sym_triangle] = ACTIONS(2256),
    [anon_sym_interface] = ACTIONS(2256),
    [anon_sym_extension] = ACTIONS(2256),
  },
  [2626] = {
    [sym_identifier] = ACTIONS(2198),
    [anon_sym_LPAREN2] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(2200),
    [anon_sym_PIPE_PIPE] = ACTIONS(2200),
    [anon_sym_AMP_AMP] = ACTIONS(2200),
    [anon_sym_AMP] = ACTIONS(2198),
    [anon_sym___extension__] = ACTIONS(2198),
    [anon_sym_in] = ACTIONS(2198),
    [anon_sym_out] = ACTIONS(2198),
    [anon_sym_inout] = ACTIONS(2198),
    [anon_sym_extern] = ACTIONS(2198),
    [anon_sym___attribute__] = ACTIONS(2198),
    [anon_sym_COLON_COLON] = ACTIONS(2200),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2200),
    [anon_sym___declspec] = ACTIONS(2198),
    [anon_sym___based] = ACTIONS(2198),
    [anon_sym___cdecl] = ACTIONS(2198),
    [anon_sym___clrcall] = ACTIONS(2198),
    [anon_sym___stdcall] = ACTIONS(2198),
    [anon_sym___fastcall] = ACTIONS(2198),
    [anon_sym___thiscall] = ACTIONS(2198),
    [anon_sym___vectorcall] = ACTIONS(2198),
    [anon_sym_signed] = ACTIONS(2198),
    [anon_sym_unsigned] = ACTIONS(2198),
    [anon_sym_long] = ACTIONS(2198),
    [anon_sym_short] = ACTIONS(2198),
    [anon_sym_LBRACK] = ACTIONS(2198),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_register] = ACTIONS(2198),
    [anon_sym_inline] = ACTIONS(2198),
    [anon_sym___inline] = ACTIONS(2198),
    [anon_sym___inline__] = ACTIONS(2198),
    [anon_sym___forceinline] = ACTIONS(2198),
    [anon_sym_thread_local] = ACTIONS(2198),
    [anon_sym___thread] = ACTIONS(2198),
    [anon_sym_const] = ACTIONS(2198),
    [anon_sym_constexpr] = ACTIONS(2198),
    [anon_sym_volatile] = ACTIONS(2198),
    [anon_sym_restrict] = ACTIONS(2198),
    [anon_sym___restrict__] = ACTIONS(2198),
    [anon_sym__Atomic] = ACTIONS(2198),
    [anon_sym__Noreturn] = ACTIONS(2198),
    [anon_sym_noreturn] = ACTIONS(2198),
    [anon_sym_mutable] = ACTIONS(2198),
    [anon_sym_constinit] = ACTIONS(2198),
    [anon_sym_consteval] = ACTIONS(2198),
    [anon_sym_alignas] = ACTIONS(2198),
    [anon_sym__Alignas] = ACTIONS(2198),
    [sym_primitive_type] = ACTIONS(2198),
    [anon_sym_enum] = ACTIONS(2198),
    [anon_sym_class] = ACTIONS(2198),
    [anon_sym_struct] = ACTIONS(2198),
    [anon_sym_union] = ACTIONS(2198),
    [anon_sym_or] = ACTIONS(2198),
    [anon_sym_and] = ACTIONS(2198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2198),
    [anon_sym_let] = ACTIONS(2198),
    [anon_sym_This] = ACTIONS(2198),
    [anon_sym_decltype] = ACTIONS(2198),
    [sym_virtual] = ACTIONS(2198),
    [anon_sym_explicit] = ACTIONS(2198),
    [anon_sym_typename] = ACTIONS(2198),
    [anon_sym_template] = ACTIONS(2198),
    [anon_sym_operator] = ACTIONS(2198),
    [anon_sym_friend] = ACTIONS(2198),
    [anon_sym_using] = ACTIONS(2198),
    [anon_sym_concept] = ACTIONS(2198),
    [anon_sym_precise] = ACTIONS(2198),
    [anon_sym_shared] = ACTIONS(2198),
    [anon_sym_groupshared] = ACTIONS(2198),
    [anon_sym_uniform] = ACTIONS(2198),
    [anon_sym_row_major] = ACTIONS(2198),
    [anon_sym_column_major] = ACTIONS(2198),
    [anon_sym_globallycoherent] = ACTIONS(2198),
    [anon_sym_centroid] = ACTIONS(2198),
    [anon_sym_noperspective] = ACTIONS(2198),
    [anon_sym_nointerpolation] = ACTIONS(2198),
    [anon_sym_sample] = ACTIONS(2198),
    [anon_sym_linear] = ACTIONS(2198),
    [anon_sym_snorm] = ACTIONS(2198),
    [anon_sym_unorm] = ACTIONS(2198),
    [anon_sym_point] = ACTIONS(2198),
    [anon_sym_line] = ACTIONS(2198),
    [anon_sym_triangleadj] = ACTIONS(2198),
    [anon_sym_lineadj] = ACTIONS(2198),
    [anon_sym_triangle] = ACTIONS(2198),
    [anon_sym_interface] = ACTIONS(2198),
    [anon_sym_extension] = ACTIONS(2198),
  },
  [2627] = {
    [sym_string_literal] = STATE(3342),
    [sym_template_argument_list] = STATE(3627),
    [sym_raw_string_literal] = STATE(3342),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_RPAREN] = ACTIONS(2130),
    [anon_sym_LPAREN2] = ACTIONS(2130),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2130),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(6208),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym___extension__] = ACTIONS(2123),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_signed] = ACTIONS(6167),
    [anon_sym_unsigned] = ACTIONS(6167),
    [anon_sym_long] = ACTIONS(6167),
    [anon_sym_short] = ACTIONS(6167),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_EQ] = ACTIONS(2152),
    [anon_sym_const] = ACTIONS(2115),
    [anon_sym_constexpr] = ACTIONS(2123),
    [anon_sym_volatile] = ACTIONS(2123),
    [anon_sym_restrict] = ACTIONS(2123),
    [anon_sym___restrict__] = ACTIONS(2123),
    [anon_sym__Atomic] = ACTIONS(2123),
    [anon_sym__Noreturn] = ACTIONS(2123),
    [anon_sym_noreturn] = ACTIONS(2123),
    [anon_sym_mutable] = ACTIONS(2123),
    [anon_sym_constinit] = ACTIONS(2123),
    [anon_sym_consteval] = ACTIONS(2123),
    [anon_sym_alignas] = ACTIONS(2123),
    [anon_sym__Alignas] = ACTIONS(2123),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2154),
    [anon_sym_SLASH_EQ] = ACTIONS(2154),
    [anon_sym_PERCENT_EQ] = ACTIONS(2154),
    [anon_sym_PLUS_EQ] = ACTIONS(2154),
    [anon_sym_DASH_EQ] = ACTIONS(2154),
    [anon_sym_LT_LT_EQ] = ACTIONS(2154),
    [anon_sym_GT_GT_EQ] = ACTIONS(2154),
    [anon_sym_AMP_EQ] = ACTIONS(2154),
    [anon_sym_CARET_EQ] = ACTIONS(2154),
    [anon_sym_PIPE_EQ] = ACTIONS(2154),
    [anon_sym_and_eq] = ACTIONS(2154),
    [anon_sym_or_eq] = ACTIONS(2154),
    [anon_sym_xor_eq] = ACTIONS(2154),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2117),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2117),
    [anon_sym_not_eq] = ACTIONS(2117),
    [anon_sym_is] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2125),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2123),
    [anon_sym_let] = ACTIONS(2123),
    [anon_sym_This] = ACTIONS(2123),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
  },
  [2628] = {
    [sym_identifier] = ACTIONS(6211),
    [anon_sym_LPAREN2] = ACTIONS(6213),
    [anon_sym_TILDE] = ACTIONS(6213),
    [anon_sym_STAR] = ACTIONS(6213),
    [anon_sym_AMP_AMP] = ACTIONS(6213),
    [anon_sym_AMP] = ACTIONS(6211),
    [anon_sym___extension__] = ACTIONS(6211),
    [anon_sym_in] = ACTIONS(6211),
    [anon_sym_out] = ACTIONS(6211),
    [anon_sym_inout] = ACTIONS(6211),
    [anon_sym_extern] = ACTIONS(6211),
    [anon_sym___attribute__] = ACTIONS(6211),
    [anon_sym_COLON_COLON] = ACTIONS(6213),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6213),
    [anon_sym___declspec] = ACTIONS(6211),
    [anon_sym___based] = ACTIONS(6211),
    [anon_sym___cdecl] = ACTIONS(6211),
    [anon_sym___clrcall] = ACTIONS(6211),
    [anon_sym___stdcall] = ACTIONS(6211),
    [anon_sym___fastcall] = ACTIONS(6211),
    [anon_sym___thiscall] = ACTIONS(6211),
    [anon_sym___vectorcall] = ACTIONS(6211),
    [anon_sym_signed] = ACTIONS(6211),
    [anon_sym_unsigned] = ACTIONS(6211),
    [anon_sym_long] = ACTIONS(6211),
    [anon_sym_short] = ACTIONS(6211),
    [anon_sym_LBRACK] = ACTIONS(6211),
    [anon_sym_static] = ACTIONS(6211),
    [anon_sym_register] = ACTIONS(6211),
    [anon_sym_inline] = ACTIONS(6211),
    [anon_sym___inline] = ACTIONS(6211),
    [anon_sym___inline__] = ACTIONS(6211),
    [anon_sym___forceinline] = ACTIONS(6211),
    [anon_sym_thread_local] = ACTIONS(6211),
    [anon_sym___thread] = ACTIONS(6211),
    [anon_sym_const] = ACTIONS(6211),
    [anon_sym_constexpr] = ACTIONS(6211),
    [anon_sym_volatile] = ACTIONS(6211),
    [anon_sym_restrict] = ACTIONS(6211),
    [anon_sym___restrict__] = ACTIONS(6211),
    [anon_sym__Atomic] = ACTIONS(6211),
    [anon_sym__Noreturn] = ACTIONS(6211),
    [anon_sym_noreturn] = ACTIONS(6211),
    [anon_sym_mutable] = ACTIONS(6211),
    [anon_sym_constinit] = ACTIONS(6211),
    [anon_sym_consteval] = ACTIONS(6211),
    [anon_sym_alignas] = ACTIONS(6211),
    [anon_sym__Alignas] = ACTIONS(6211),
    [sym_primitive_type] = ACTIONS(6211),
    [anon_sym_enum] = ACTIONS(6211),
    [anon_sym_class] = ACTIONS(6211),
    [anon_sym_struct] = ACTIONS(6211),
    [anon_sym_union] = ACTIONS(6211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6211),
    [anon_sym_let] = ACTIONS(6211),
    [anon_sym_This] = ACTIONS(6211),
    [anon_sym_decltype] = ACTIONS(6211),
    [sym_virtual] = ACTIONS(6211),
    [anon_sym_explicit] = ACTIONS(6211),
    [anon_sym_typename] = ACTIONS(6211),
    [anon_sym_template] = ACTIONS(6211),
    [anon_sym_operator] = ACTIONS(6211),
    [anon_sym_friend] = ACTIONS(6211),
    [anon_sym_using] = ACTIONS(6211),
    [anon_sym_concept] = ACTIONS(6211),
    [anon_sym_requires] = ACTIONS(6211),
    [anon_sym_precise] = ACTIONS(6211),
    [anon_sym_shared] = ACTIONS(6211),
    [anon_sym_groupshared] = ACTIONS(6211),
    [anon_sym_uniform] = ACTIONS(6211),
    [anon_sym_row_major] = ACTIONS(6211),
    [anon_sym_column_major] = ACTIONS(6211),
    [anon_sym_globallycoherent] = ACTIONS(6211),
    [anon_sym_centroid] = ACTIONS(6211),
    [anon_sym_noperspective] = ACTIONS(6211),
    [anon_sym_nointerpolation] = ACTIONS(6211),
    [anon_sym_sample] = ACTIONS(6211),
    [anon_sym_linear] = ACTIONS(6211),
    [anon_sym_snorm] = ACTIONS(6211),
    [anon_sym_unorm] = ACTIONS(6211),
    [anon_sym_point] = ACTIONS(6211),
    [anon_sym_line] = ACTIONS(6211),
    [anon_sym_triangleadj] = ACTIONS(6211),
    [anon_sym_lineadj] = ACTIONS(6211),
    [anon_sym_triangle] = ACTIONS(6211),
    [anon_sym_interface] = ACTIONS(6211),
    [anon_sym_extension] = ACTIONS(6211),
  },
  [2629] = {
    [sym_identifier] = ACTIONS(6215),
    [anon_sym_LPAREN2] = ACTIONS(6217),
    [anon_sym_TILDE] = ACTIONS(6217),
    [anon_sym_STAR] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6215),
    [anon_sym___extension__] = ACTIONS(6215),
    [anon_sym_in] = ACTIONS(6215),
    [anon_sym_out] = ACTIONS(6215),
    [anon_sym_inout] = ACTIONS(6215),
    [anon_sym_extern] = ACTIONS(6215),
    [anon_sym___attribute__] = ACTIONS(6215),
    [anon_sym_COLON_COLON] = ACTIONS(6217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6217),
    [anon_sym___declspec] = ACTIONS(6215),
    [anon_sym___based] = ACTIONS(6215),
    [anon_sym___cdecl] = ACTIONS(6215),
    [anon_sym___clrcall] = ACTIONS(6215),
    [anon_sym___stdcall] = ACTIONS(6215),
    [anon_sym___fastcall] = ACTIONS(6215),
    [anon_sym___thiscall] = ACTIONS(6215),
    [anon_sym___vectorcall] = ACTIONS(6215),
    [anon_sym_signed] = ACTIONS(6215),
    [anon_sym_unsigned] = ACTIONS(6215),
    [anon_sym_long] = ACTIONS(6215),
    [anon_sym_short] = ACTIONS(6215),
    [anon_sym_LBRACK] = ACTIONS(6215),
    [anon_sym_static] = ACTIONS(6215),
    [anon_sym_register] = ACTIONS(6215),
    [anon_sym_inline] = ACTIONS(6215),
    [anon_sym___inline] = ACTIONS(6215),
    [anon_sym___inline__] = ACTIONS(6215),
    [anon_sym___forceinline] = ACTIONS(6215),
    [anon_sym_thread_local] = ACTIONS(6215),
    [anon_sym___thread] = ACTIONS(6215),
    [anon_sym_const] = ACTIONS(6215),
    [anon_sym_constexpr] = ACTIONS(6215),
    [anon_sym_volatile] = ACTIONS(6215),
    [anon_sym_restrict] = ACTIONS(6215),
    [anon_sym___restrict__] = ACTIONS(6215),
    [anon_sym__Atomic] = ACTIONS(6215),
    [anon_sym__Noreturn] = ACTIONS(6215),
    [anon_sym_noreturn] = ACTIONS(6215),
    [anon_sym_mutable] = ACTIONS(6215),
    [anon_sym_constinit] = ACTIONS(6215),
    [anon_sym_consteval] = ACTIONS(6215),
    [anon_sym_alignas] = ACTIONS(6215),
    [anon_sym__Alignas] = ACTIONS(6215),
    [sym_primitive_type] = ACTIONS(6215),
    [anon_sym_enum] = ACTIONS(6215),
    [anon_sym_class] = ACTIONS(6215),
    [anon_sym_struct] = ACTIONS(6215),
    [anon_sym_union] = ACTIONS(6215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6215),
    [anon_sym_let] = ACTIONS(6215),
    [anon_sym_This] = ACTIONS(6215),
    [anon_sym_decltype] = ACTIONS(6215),
    [sym_virtual] = ACTIONS(6215),
    [anon_sym_explicit] = ACTIONS(6215),
    [anon_sym_typename] = ACTIONS(6215),
    [anon_sym_template] = ACTIONS(6215),
    [anon_sym_operator] = ACTIONS(6215),
    [anon_sym_friend] = ACTIONS(6215),
    [anon_sym_using] = ACTIONS(6215),
    [anon_sym_concept] = ACTIONS(6215),
    [anon_sym_requires] = ACTIONS(6215),
    [anon_sym_precise] = ACTIONS(6215),
    [anon_sym_shared] = ACTIONS(6215),
    [anon_sym_groupshared] = ACTIONS(6215),
    [anon_sym_uniform] = ACTIONS(6215),
    [anon_sym_row_major] = ACTIONS(6215),
    [anon_sym_column_major] = ACTIONS(6215),
    [anon_sym_globallycoherent] = ACTIONS(6215),
    [anon_sym_centroid] = ACTIONS(6215),
    [anon_sym_noperspective] = ACTIONS(6215),
    [anon_sym_nointerpolation] = ACTIONS(6215),
    [anon_sym_sample] = ACTIONS(6215),
    [anon_sym_linear] = ACTIONS(6215),
    [anon_sym_snorm] = ACTIONS(6215),
    [anon_sym_unorm] = ACTIONS(6215),
    [anon_sym_point] = ACTIONS(6215),
    [anon_sym_line] = ACTIONS(6215),
    [anon_sym_triangleadj] = ACTIONS(6215),
    [anon_sym_lineadj] = ACTIONS(6215),
    [anon_sym_triangle] = ACTIONS(6215),
    [anon_sym_interface] = ACTIONS(6215),
    [anon_sym_extension] = ACTIONS(6215),
  },
  [2630] = {
    [sym_identifier] = ACTIONS(6219),
    [anon_sym_LPAREN2] = ACTIONS(6221),
    [anon_sym_TILDE] = ACTIONS(6221),
    [anon_sym_STAR] = ACTIONS(6221),
    [anon_sym_AMP_AMP] = ACTIONS(6221),
    [anon_sym_AMP] = ACTIONS(6219),
    [anon_sym___extension__] = ACTIONS(6219),
    [anon_sym_in] = ACTIONS(6219),
    [anon_sym_out] = ACTIONS(6219),
    [anon_sym_inout] = ACTIONS(6219),
    [anon_sym_extern] = ACTIONS(6219),
    [anon_sym___attribute__] = ACTIONS(6219),
    [anon_sym_COLON_COLON] = ACTIONS(6221),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6221),
    [anon_sym___declspec] = ACTIONS(6219),
    [anon_sym___based] = ACTIONS(6219),
    [anon_sym___cdecl] = ACTIONS(6219),
    [anon_sym___clrcall] = ACTIONS(6219),
    [anon_sym___stdcall] = ACTIONS(6219),
    [anon_sym___fastcall] = ACTIONS(6219),
    [anon_sym___thiscall] = ACTIONS(6219),
    [anon_sym___vectorcall] = ACTIONS(6219),
    [anon_sym_signed] = ACTIONS(6219),
    [anon_sym_unsigned] = ACTIONS(6219),
    [anon_sym_long] = ACTIONS(6219),
    [anon_sym_short] = ACTIONS(6219),
    [anon_sym_LBRACK] = ACTIONS(6219),
    [anon_sym_static] = ACTIONS(6219),
    [anon_sym_register] = ACTIONS(6219),
    [anon_sym_inline] = ACTIONS(6219),
    [anon_sym___inline] = ACTIONS(6219),
    [anon_sym___inline__] = ACTIONS(6219),
    [anon_sym___forceinline] = ACTIONS(6219),
    [anon_sym_thread_local] = ACTIONS(6219),
    [anon_sym___thread] = ACTIONS(6219),
    [anon_sym_const] = ACTIONS(6219),
    [anon_sym_constexpr] = ACTIONS(6219),
    [anon_sym_volatile] = ACTIONS(6219),
    [anon_sym_restrict] = ACTIONS(6219),
    [anon_sym___restrict__] = ACTIONS(6219),
    [anon_sym__Atomic] = ACTIONS(6219),
    [anon_sym__Noreturn] = ACTIONS(6219),
    [anon_sym_noreturn] = ACTIONS(6219),
    [anon_sym_mutable] = ACTIONS(6219),
    [anon_sym_constinit] = ACTIONS(6219),
    [anon_sym_consteval] = ACTIONS(6219),
    [anon_sym_alignas] = ACTIONS(6219),
    [anon_sym__Alignas] = ACTIONS(6219),
    [sym_primitive_type] = ACTIONS(6219),
    [anon_sym_enum] = ACTIONS(6219),
    [anon_sym_class] = ACTIONS(6219),
    [anon_sym_struct] = ACTIONS(6219),
    [anon_sym_union] = ACTIONS(6219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6219),
    [anon_sym_let] = ACTIONS(6219),
    [anon_sym_This] = ACTIONS(6219),
    [anon_sym_decltype] = ACTIONS(6219),
    [sym_virtual] = ACTIONS(6219),
    [anon_sym_explicit] = ACTIONS(6219),
    [anon_sym_typename] = ACTIONS(6219),
    [anon_sym_template] = ACTIONS(6219),
    [anon_sym_operator] = ACTIONS(6219),
    [anon_sym_friend] = ACTIONS(6219),
    [anon_sym_using] = ACTIONS(6219),
    [anon_sym_concept] = ACTIONS(6219),
    [anon_sym_requires] = ACTIONS(6219),
    [anon_sym_precise] = ACTIONS(6219),
    [anon_sym_shared] = ACTIONS(6219),
    [anon_sym_groupshared] = ACTIONS(6219),
    [anon_sym_uniform] = ACTIONS(6219),
    [anon_sym_row_major] = ACTIONS(6219),
    [anon_sym_column_major] = ACTIONS(6219),
    [anon_sym_globallycoherent] = ACTIONS(6219),
    [anon_sym_centroid] = ACTIONS(6219),
    [anon_sym_noperspective] = ACTIONS(6219),
    [anon_sym_nointerpolation] = ACTIONS(6219),
    [anon_sym_sample] = ACTIONS(6219),
    [anon_sym_linear] = ACTIONS(6219),
    [anon_sym_snorm] = ACTIONS(6219),
    [anon_sym_unorm] = ACTIONS(6219),
    [anon_sym_point] = ACTIONS(6219),
    [anon_sym_line] = ACTIONS(6219),
    [anon_sym_triangleadj] = ACTIONS(6219),
    [anon_sym_lineadj] = ACTIONS(6219),
    [anon_sym_triangle] = ACTIONS(6219),
    [anon_sym_interface] = ACTIONS(6219),
    [anon_sym_extension] = ACTIONS(6219),
  },
  [2631] = {
    [sym_template_argument_list] = STATE(2816),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2639),
    [sym_identifier] = ACTIONS(3483),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3485),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_RPAREN] = ACTIONS(3485),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_TILDE] = ACTIONS(3485),
    [anon_sym_STAR] = ACTIONS(3485),
    [anon_sym_AMP_AMP] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_LT] = ACTIONS(3487),
    [anon_sym_COLON] = ACTIONS(3483),
    [anon_sym_SEMI] = ACTIONS(3485),
    [anon_sym___extension__] = ACTIONS(3483),
    [anon_sym_in] = ACTIONS(3483),
    [anon_sym_out] = ACTIONS(3483),
    [anon_sym_inout] = ACTIONS(3483),
    [anon_sym_extern] = ACTIONS(3483),
    [anon_sym___attribute__] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3485),
    [anon_sym___declspec] = ACTIONS(3483),
    [anon_sym___based] = ACTIONS(3483),
    [anon_sym___cdecl] = ACTIONS(3483),
    [anon_sym___clrcall] = ACTIONS(3483),
    [anon_sym___stdcall] = ACTIONS(3483),
    [anon_sym___fastcall] = ACTIONS(3483),
    [anon_sym___thiscall] = ACTIONS(3483),
    [anon_sym___vectorcall] = ACTIONS(3483),
    [anon_sym_LBRACE] = ACTIONS(3485),
    [anon_sym_signed] = ACTIONS(4863),
    [anon_sym_unsigned] = ACTIONS(4863),
    [anon_sym_long] = ACTIONS(4863),
    [anon_sym_short] = ACTIONS(4863),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_static] = ACTIONS(3483),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_register] = ACTIONS(3483),
    [anon_sym_inline] = ACTIONS(3483),
    [anon_sym___inline] = ACTIONS(3483),
    [anon_sym___inline__] = ACTIONS(3483),
    [anon_sym___forceinline] = ACTIONS(3483),
    [anon_sym_thread_local] = ACTIONS(3483),
    [anon_sym___thread] = ACTIONS(3483),
    [anon_sym_const] = ACTIONS(3483),
    [anon_sym_constexpr] = ACTIONS(3483),
    [anon_sym_volatile] = ACTIONS(3483),
    [anon_sym_restrict] = ACTIONS(3483),
    [anon_sym___restrict__] = ACTIONS(3483),
    [anon_sym__Atomic] = ACTIONS(3483),
    [anon_sym__Noreturn] = ACTIONS(3483),
    [anon_sym_noreturn] = ACTIONS(3483),
    [anon_sym_mutable] = ACTIONS(3483),
    [anon_sym_constinit] = ACTIONS(3483),
    [anon_sym_consteval] = ACTIONS(3483),
    [anon_sym_alignas] = ACTIONS(3483),
    [anon_sym__Alignas] = ACTIONS(3483),
    [anon_sym_DOT] = ACTIONS(3483),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_This] = ACTIONS(3483),
    [anon_sym_decltype] = ACTIONS(3483),
    [sym_virtual] = ACTIONS(3483),
    [anon_sym_template] = ACTIONS(3483),
    [anon_sym_GT2] = ACTIONS(3485),
    [anon_sym_operator] = ACTIONS(3483),
    [anon_sym_precise] = ACTIONS(3483),
    [anon_sym_shared] = ACTIONS(3483),
    [anon_sym_groupshared] = ACTIONS(3483),
    [anon_sym_uniform] = ACTIONS(3483),
    [anon_sym_row_major] = ACTIONS(3483),
    [anon_sym_column_major] = ACTIONS(3483),
    [anon_sym_globallycoherent] = ACTIONS(3483),
    [anon_sym_centroid] = ACTIONS(3483),
    [anon_sym_noperspective] = ACTIONS(3483),
    [anon_sym_nointerpolation] = ACTIONS(3483),
    [anon_sym_sample] = ACTIONS(3483),
    [anon_sym_linear] = ACTIONS(3483),
    [anon_sym_snorm] = ACTIONS(3483),
    [anon_sym_unorm] = ACTIONS(3483),
    [anon_sym_point] = ACTIONS(3483),
    [anon_sym_line] = ACTIONS(3483),
    [anon_sym_triangleadj] = ACTIONS(3483),
    [anon_sym_lineadj] = ACTIONS(3483),
    [anon_sym_triangle] = ACTIONS(3483),
  },
  [2632] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2638),
    [sym_identifier] = ACTIONS(6223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3822),
    [anon_sym_COMMA] = ACTIONS(3822),
    [anon_sym_RPAREN] = ACTIONS(3822),
    [anon_sym_LPAREN2] = ACTIONS(3822),
    [anon_sym_TILDE] = ACTIONS(3822),
    [anon_sym_STAR] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3822),
    [anon_sym_AMP] = ACTIONS(3820),
    [anon_sym_COLON] = ACTIONS(3820),
    [anon_sym_SEMI] = ACTIONS(3822),
    [anon_sym___extension__] = ACTIONS(3820),
    [anon_sym_in] = ACTIONS(3820),
    [anon_sym_out] = ACTIONS(3820),
    [anon_sym_inout] = ACTIONS(3820),
    [anon_sym_extern] = ACTIONS(3820),
    [anon_sym___attribute__] = ACTIONS(3820),
    [anon_sym_COLON_COLON] = ACTIONS(3822),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3822),
    [anon_sym___declspec] = ACTIONS(3820),
    [anon_sym___based] = ACTIONS(3820),
    [anon_sym___cdecl] = ACTIONS(3820),
    [anon_sym___clrcall] = ACTIONS(3820),
    [anon_sym___stdcall] = ACTIONS(3820),
    [anon_sym___fastcall] = ACTIONS(3820),
    [anon_sym___thiscall] = ACTIONS(3820),
    [anon_sym___vectorcall] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3822),
    [anon_sym_signed] = ACTIONS(6226),
    [anon_sym_unsigned] = ACTIONS(6226),
    [anon_sym_long] = ACTIONS(6226),
    [anon_sym_short] = ACTIONS(6226),
    [anon_sym_LBRACK] = ACTIONS(3820),
    [anon_sym_static] = ACTIONS(3820),
    [anon_sym_EQ] = ACTIONS(3822),
    [anon_sym_register] = ACTIONS(3820),
    [anon_sym_inline] = ACTIONS(3820),
    [anon_sym___inline] = ACTIONS(3820),
    [anon_sym___inline__] = ACTIONS(3820),
    [anon_sym___forceinline] = ACTIONS(3820),
    [anon_sym_thread_local] = ACTIONS(3820),
    [anon_sym___thread] = ACTIONS(3820),
    [anon_sym_const] = ACTIONS(3820),
    [anon_sym_constexpr] = ACTIONS(3820),
    [anon_sym_volatile] = ACTIONS(3820),
    [anon_sym_restrict] = ACTIONS(3820),
    [anon_sym___restrict__] = ACTIONS(3820),
    [anon_sym__Atomic] = ACTIONS(3820),
    [anon_sym__Noreturn] = ACTIONS(3820),
    [anon_sym_noreturn] = ACTIONS(3820),
    [anon_sym_mutable] = ACTIONS(3820),
    [anon_sym_constinit] = ACTIONS(3820),
    [anon_sym_consteval] = ACTIONS(3820),
    [anon_sym_alignas] = ACTIONS(3820),
    [anon_sym__Alignas] = ACTIONS(3820),
    [sym_primitive_type] = ACTIONS(6228),
    [anon_sym_DOT] = ACTIONS(3820),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3820),
    [anon_sym_let] = ACTIONS(3820),
    [anon_sym_This] = ACTIONS(3820),
    [anon_sym_decltype] = ACTIONS(3820),
    [sym_virtual] = ACTIONS(3820),
    [anon_sym_template] = ACTIONS(3820),
    [anon_sym_GT2] = ACTIONS(3822),
    [anon_sym_operator] = ACTIONS(3820),
    [anon_sym_precise] = ACTIONS(3820),
    [anon_sym_shared] = ACTIONS(3820),
    [anon_sym_groupshared] = ACTIONS(3820),
    [anon_sym_uniform] = ACTIONS(3820),
    [anon_sym_row_major] = ACTIONS(3820),
    [anon_sym_column_major] = ACTIONS(3820),
    [anon_sym_globallycoherent] = ACTIONS(3820),
    [anon_sym_centroid] = ACTIONS(3820),
    [anon_sym_noperspective] = ACTIONS(3820),
    [anon_sym_nointerpolation] = ACTIONS(3820),
    [anon_sym_sample] = ACTIONS(3820),
    [anon_sym_linear] = ACTIONS(3820),
    [anon_sym_snorm] = ACTIONS(3820),
    [anon_sym_unorm] = ACTIONS(3820),
    [anon_sym_point] = ACTIONS(3820),
    [anon_sym_line] = ACTIONS(3820),
    [anon_sym_triangleadj] = ACTIONS(3820),
    [anon_sym_lineadj] = ACTIONS(3820),
    [anon_sym_triangle] = ACTIONS(3820),
  },
  [2633] = {
    [sym_identifier] = ACTIONS(4573),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4575),
    [anon_sym_COMMA] = ACTIONS(4575),
    [anon_sym_RPAREN] = ACTIONS(4575),
    [anon_sym_LPAREN2] = ACTIONS(4575),
    [anon_sym_TILDE] = ACTIONS(4575),
    [anon_sym_STAR] = ACTIONS(4575),
    [anon_sym_AMP_AMP] = ACTIONS(4575),
    [anon_sym_AMP] = ACTIONS(4573),
    [anon_sym_COLON] = ACTIONS(4573),
    [anon_sym_SEMI] = ACTIONS(4575),
    [anon_sym___extension__] = ACTIONS(4573),
    [anon_sym_in] = ACTIONS(4573),
    [anon_sym_out] = ACTIONS(4573),
    [anon_sym_inout] = ACTIONS(4573),
    [anon_sym_extern] = ACTIONS(4573),
    [anon_sym___attribute__] = ACTIONS(4573),
    [anon_sym_COLON_COLON] = ACTIONS(4575),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4575),
    [anon_sym___declspec] = ACTIONS(4573),
    [anon_sym___based] = ACTIONS(4573),
    [anon_sym___cdecl] = ACTIONS(4573),
    [anon_sym___clrcall] = ACTIONS(4573),
    [anon_sym___stdcall] = ACTIONS(4573),
    [anon_sym___fastcall] = ACTIONS(4573),
    [anon_sym___thiscall] = ACTIONS(4573),
    [anon_sym___vectorcall] = ACTIONS(4573),
    [anon_sym_LBRACE] = ACTIONS(4575),
    [anon_sym_LBRACK] = ACTIONS(4573),
    [anon_sym_static] = ACTIONS(4573),
    [anon_sym_EQ] = ACTIONS(4575),
    [anon_sym_register] = ACTIONS(4573),
    [anon_sym_inline] = ACTIONS(4573),
    [anon_sym___inline] = ACTIONS(4573),
    [anon_sym___inline__] = ACTIONS(4573),
    [anon_sym___forceinline] = ACTIONS(4573),
    [anon_sym_thread_local] = ACTIONS(4573),
    [anon_sym___thread] = ACTIONS(4573),
    [anon_sym_const] = ACTIONS(4573),
    [anon_sym_constexpr] = ACTIONS(4573),
    [anon_sym_volatile] = ACTIONS(4573),
    [anon_sym_restrict] = ACTIONS(4573),
    [anon_sym___restrict__] = ACTIONS(4573),
    [anon_sym__Atomic] = ACTIONS(4573),
    [anon_sym__Noreturn] = ACTIONS(4573),
    [anon_sym_noreturn] = ACTIONS(4573),
    [anon_sym_mutable] = ACTIONS(4573),
    [anon_sym_constinit] = ACTIONS(4573),
    [anon_sym_consteval] = ACTIONS(4573),
    [anon_sym_alignas] = ACTIONS(4573),
    [anon_sym__Alignas] = ACTIONS(4573),
    [anon_sym_DASH_GT] = ACTIONS(4575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4573),
    [anon_sym_final] = ACTIONS(4573),
    [anon_sym_override] = ACTIONS(4573),
    [sym_virtual] = ACTIONS(4573),
    [anon_sym_explicit] = ACTIONS(4573),
    [anon_sym_template] = ACTIONS(4573),
    [anon_sym_GT2] = ACTIONS(4575),
    [anon_sym_operator] = ACTIONS(4573),
    [anon_sym_try] = ACTIONS(4573),
    [anon_sym_public] = ACTIONS(4573),
    [anon_sym_private] = ACTIONS(4573),
    [anon_sym_protected] = ACTIONS(4573),
    [anon_sym_requires] = ACTIONS(4573),
    [anon_sym_precise] = ACTIONS(4573),
    [anon_sym_shared] = ACTIONS(4573),
    [anon_sym_groupshared] = ACTIONS(4573),
    [anon_sym_uniform] = ACTIONS(4573),
    [anon_sym_row_major] = ACTIONS(4573),
    [anon_sym_column_major] = ACTIONS(4573),
    [anon_sym_globallycoherent] = ACTIONS(4573),
    [anon_sym_centroid] = ACTIONS(4573),
    [anon_sym_noperspective] = ACTIONS(4573),
    [anon_sym_nointerpolation] = ACTIONS(4573),
    [anon_sym_sample] = ACTIONS(4573),
    [anon_sym_linear] = ACTIONS(4573),
    [anon_sym_snorm] = ACTIONS(4573),
    [anon_sym_unorm] = ACTIONS(4573),
    [anon_sym_point] = ACTIONS(4573),
    [anon_sym_line] = ACTIONS(4573),
    [anon_sym_triangleadj] = ACTIONS(4573),
    [anon_sym_lineadj] = ACTIONS(4573),
    [anon_sym_triangle] = ACTIONS(4573),
    [anon_sym_where] = ACTIONS(4573),
  },
  [2634] = {
    [sym_attribute_specifier] = STATE(2746),
    [sym_field_declaration_list] = STATE(2714),
    [sym_virtual_specifier] = STATE(8832),
    [sym_base_class_clause] = STATE(9868),
    [sym_identifier] = ACTIONS(2683),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2685),
    [anon_sym_RPAREN] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2685),
    [anon_sym_STAR] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_COLON] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(2685),
    [anon_sym___extension__] = ACTIONS(2683),
    [anon_sym_in] = ACTIONS(2683),
    [anon_sym_out] = ACTIONS(2683),
    [anon_sym_inout] = ACTIONS(2683),
    [anon_sym_extern] = ACTIONS(2683),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(2685),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2685),
    [anon_sym___declspec] = ACTIONS(2683),
    [anon_sym___based] = ACTIONS(2683),
    [anon_sym___cdecl] = ACTIONS(2683),
    [anon_sym___clrcall] = ACTIONS(2683),
    [anon_sym___stdcall] = ACTIONS(2683),
    [anon_sym___fastcall] = ACTIONS(2683),
    [anon_sym___thiscall] = ACTIONS(2683),
    [anon_sym___vectorcall] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(6230),
    [anon_sym_LBRACK] = ACTIONS(2683),
    [anon_sym_static] = ACTIONS(2683),
    [anon_sym_EQ] = ACTIONS(2685),
    [anon_sym_register] = ACTIONS(2683),
    [anon_sym_inline] = ACTIONS(2683),
    [anon_sym___inline] = ACTIONS(2683),
    [anon_sym___inline__] = ACTIONS(2683),
    [anon_sym___forceinline] = ACTIONS(2683),
    [anon_sym_thread_local] = ACTIONS(2683),
    [anon_sym___thread] = ACTIONS(2683),
    [anon_sym_const] = ACTIONS(2683),
    [anon_sym_constexpr] = ACTIONS(2683),
    [anon_sym_volatile] = ACTIONS(2683),
    [anon_sym_restrict] = ACTIONS(2683),
    [anon_sym___restrict__] = ACTIONS(2683),
    [anon_sym__Atomic] = ACTIONS(2683),
    [anon_sym__Noreturn] = ACTIONS(2683),
    [anon_sym_noreturn] = ACTIONS(2683),
    [anon_sym_mutable] = ACTIONS(2683),
    [anon_sym_constinit] = ACTIONS(2683),
    [anon_sym_consteval] = ACTIONS(2683),
    [anon_sym_alignas] = ACTIONS(2683),
    [anon_sym__Alignas] = ACTIONS(2683),
    [anon_sym_DOT] = ACTIONS(2683),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2683),
    [anon_sym_let] = ACTIONS(2683),
    [anon_sym_This] = ACTIONS(2683),
    [anon_sym_decltype] = ACTIONS(2683),
    [anon_sym_final] = ACTIONS(2481),
    [anon_sym_override] = ACTIONS(2481),
    [sym_virtual] = ACTIONS(2683),
    [anon_sym_template] = ACTIONS(2683),
    [anon_sym_GT2] = ACTIONS(2685),
    [anon_sym_operator] = ACTIONS(2683),
    [anon_sym_precise] = ACTIONS(2683),
    [anon_sym_shared] = ACTIONS(2683),
    [anon_sym_groupshared] = ACTIONS(2683),
    [anon_sym_uniform] = ACTIONS(2683),
    [anon_sym_row_major] = ACTIONS(2683),
    [anon_sym_column_major] = ACTIONS(2683),
    [anon_sym_globallycoherent] = ACTIONS(2683),
    [anon_sym_centroid] = ACTIONS(2683),
    [anon_sym_noperspective] = ACTIONS(2683),
    [anon_sym_nointerpolation] = ACTIONS(2683),
    [anon_sym_sample] = ACTIONS(2683),
    [anon_sym_linear] = ACTIONS(2683),
    [anon_sym_snorm] = ACTIONS(2683),
    [anon_sym_unorm] = ACTIONS(2683),
    [anon_sym_point] = ACTIONS(2683),
    [anon_sym_line] = ACTIONS(2683),
    [anon_sym_triangleadj] = ACTIONS(2683),
    [anon_sym_lineadj] = ACTIONS(2683),
    [anon_sym_triangle] = ACTIONS(2683),
  },
  [2635] = {
    [sym_identifier] = ACTIONS(6136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6138),
    [anon_sym_COMMA] = ACTIONS(6138),
    [anon_sym_RPAREN] = ACTIONS(6138),
    [anon_sym_LPAREN2] = ACTIONS(6138),
    [anon_sym_TILDE] = ACTIONS(6138),
    [anon_sym_STAR] = ACTIONS(6138),
    [anon_sym_AMP_AMP] = ACTIONS(6138),
    [anon_sym_AMP] = ACTIONS(6136),
    [anon_sym_COLON] = ACTIONS(6136),
    [anon_sym_SEMI] = ACTIONS(6138),
    [anon_sym___extension__] = ACTIONS(6136),
    [anon_sym_in] = ACTIONS(6136),
    [anon_sym_out] = ACTIONS(6136),
    [anon_sym_inout] = ACTIONS(6136),
    [anon_sym_extern] = ACTIONS(6136),
    [anon_sym___attribute__] = ACTIONS(6136),
    [anon_sym_COLON_COLON] = ACTIONS(6138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6138),
    [anon_sym___declspec] = ACTIONS(6136),
    [anon_sym___based] = ACTIONS(6136),
    [anon_sym___cdecl] = ACTIONS(6136),
    [anon_sym___clrcall] = ACTIONS(6136),
    [anon_sym___stdcall] = ACTIONS(6136),
    [anon_sym___fastcall] = ACTIONS(6136),
    [anon_sym___thiscall] = ACTIONS(6136),
    [anon_sym___vectorcall] = ACTIONS(6136),
    [anon_sym_LBRACE] = ACTIONS(6138),
    [anon_sym_LBRACK] = ACTIONS(6136),
    [anon_sym_static] = ACTIONS(6136),
    [anon_sym_EQ] = ACTIONS(6138),
    [anon_sym_register] = ACTIONS(6136),
    [anon_sym_inline] = ACTIONS(6136),
    [anon_sym___inline] = ACTIONS(6136),
    [anon_sym___inline__] = ACTIONS(6136),
    [anon_sym___forceinline] = ACTIONS(6136),
    [anon_sym_thread_local] = ACTIONS(6136),
    [anon_sym___thread] = ACTIONS(6136),
    [anon_sym_const] = ACTIONS(6136),
    [anon_sym_constexpr] = ACTIONS(6136),
    [anon_sym_volatile] = ACTIONS(6136),
    [anon_sym_restrict] = ACTIONS(6136),
    [anon_sym___restrict__] = ACTIONS(6136),
    [anon_sym__Atomic] = ACTIONS(6136),
    [anon_sym__Noreturn] = ACTIONS(6136),
    [anon_sym_noreturn] = ACTIONS(6136),
    [anon_sym_mutable] = ACTIONS(6136),
    [anon_sym_constinit] = ACTIONS(6136),
    [anon_sym_consteval] = ACTIONS(6136),
    [anon_sym_alignas] = ACTIONS(6136),
    [anon_sym__Alignas] = ACTIONS(6136),
    [anon_sym_asm] = ACTIONS(6136),
    [anon_sym___asm__] = ACTIONS(6136),
    [anon_sym_DASH_GT] = ACTIONS(6138),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(6136),
    [anon_sym_final] = ACTIONS(6136),
    [anon_sym_override] = ACTIONS(6136),
    [sym_virtual] = ACTIONS(6136),
    [anon_sym_explicit] = ACTIONS(6136),
    [anon_sym_template] = ACTIONS(6136),
    [anon_sym_GT2] = ACTIONS(6138),
    [anon_sym_operator] = ACTIONS(6136),
    [anon_sym_noexcept] = ACTIONS(6136),
    [anon_sym_throw] = ACTIONS(6136),
    [anon_sym_requires] = ACTIONS(6136),
    [anon_sym_precise] = ACTIONS(6136),
    [anon_sym_shared] = ACTIONS(6136),
    [anon_sym_groupshared] = ACTIONS(6136),
    [anon_sym_uniform] = ACTIONS(6136),
    [anon_sym_row_major] = ACTIONS(6136),
    [anon_sym_column_major] = ACTIONS(6136),
    [anon_sym_globallycoherent] = ACTIONS(6136),
    [anon_sym_centroid] = ACTIONS(6136),
    [anon_sym_noperspective] = ACTIONS(6136),
    [anon_sym_nointerpolation] = ACTIONS(6136),
    [anon_sym_sample] = ACTIONS(6136),
    [anon_sym_linear] = ACTIONS(6136),
    [anon_sym_snorm] = ACTIONS(6136),
    [anon_sym_unorm] = ACTIONS(6136),
    [anon_sym_point] = ACTIONS(6136),
    [anon_sym_line] = ACTIONS(6136),
    [anon_sym_triangleadj] = ACTIONS(6136),
    [anon_sym_lineadj] = ACTIONS(6136),
    [anon_sym_triangle] = ACTIONS(6136),
    [anon_sym_where] = ACTIONS(6136),
  },
  [2636] = {
    [sym_identifier] = ACTIONS(4545),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4547),
    [anon_sym_COMMA] = ACTIONS(4547),
    [anon_sym_RPAREN] = ACTIONS(4547),
    [anon_sym_LPAREN2] = ACTIONS(4547),
    [anon_sym_TILDE] = ACTIONS(4547),
    [anon_sym_STAR] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4547),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_COLON] = ACTIONS(4545),
    [anon_sym_SEMI] = ACTIONS(4547),
    [anon_sym___extension__] = ACTIONS(4545),
    [anon_sym_in] = ACTIONS(4545),
    [anon_sym_out] = ACTIONS(4545),
    [anon_sym_inout] = ACTIONS(4545),
    [anon_sym_extern] = ACTIONS(4545),
    [anon_sym___attribute__] = ACTIONS(4545),
    [anon_sym_COLON_COLON] = ACTIONS(4547),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4547),
    [anon_sym___declspec] = ACTIONS(4545),
    [anon_sym___based] = ACTIONS(4545),
    [anon_sym___cdecl] = ACTIONS(4545),
    [anon_sym___clrcall] = ACTIONS(4545),
    [anon_sym___stdcall] = ACTIONS(4545),
    [anon_sym___fastcall] = ACTIONS(4545),
    [anon_sym___thiscall] = ACTIONS(4545),
    [anon_sym___vectorcall] = ACTIONS(4545),
    [anon_sym_LBRACE] = ACTIONS(4547),
    [anon_sym_LBRACK] = ACTIONS(4545),
    [anon_sym_static] = ACTIONS(4545),
    [anon_sym_EQ] = ACTIONS(4547),
    [anon_sym_register] = ACTIONS(4545),
    [anon_sym_inline] = ACTIONS(4545),
    [anon_sym___inline] = ACTIONS(4545),
    [anon_sym___inline__] = ACTIONS(4545),
    [anon_sym___forceinline] = ACTIONS(4545),
    [anon_sym_thread_local] = ACTIONS(4545),
    [anon_sym___thread] = ACTIONS(4545),
    [anon_sym_const] = ACTIONS(4545),
    [anon_sym_constexpr] = ACTIONS(4545),
    [anon_sym_volatile] = ACTIONS(4545),
    [anon_sym_restrict] = ACTIONS(4545),
    [anon_sym___restrict__] = ACTIONS(4545),
    [anon_sym__Atomic] = ACTIONS(4545),
    [anon_sym__Noreturn] = ACTIONS(4545),
    [anon_sym_noreturn] = ACTIONS(4545),
    [anon_sym_mutable] = ACTIONS(4545),
    [anon_sym_constinit] = ACTIONS(4545),
    [anon_sym_consteval] = ACTIONS(4545),
    [anon_sym_alignas] = ACTIONS(4545),
    [anon_sym__Alignas] = ACTIONS(4545),
    [anon_sym_DASH_GT] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4545),
    [anon_sym_final] = ACTIONS(4545),
    [anon_sym_override] = ACTIONS(4545),
    [sym_virtual] = ACTIONS(4545),
    [anon_sym_explicit] = ACTIONS(4545),
    [anon_sym_template] = ACTIONS(4545),
    [anon_sym_GT2] = ACTIONS(4547),
    [anon_sym_operator] = ACTIONS(4545),
    [anon_sym_try] = ACTIONS(4545),
    [anon_sym_public] = ACTIONS(4545),
    [anon_sym_private] = ACTIONS(4545),
    [anon_sym_protected] = ACTIONS(4545),
    [anon_sym_requires] = ACTIONS(4545),
    [anon_sym_precise] = ACTIONS(4545),
    [anon_sym_shared] = ACTIONS(4545),
    [anon_sym_groupshared] = ACTIONS(4545),
    [anon_sym_uniform] = ACTIONS(4545),
    [anon_sym_row_major] = ACTIONS(4545),
    [anon_sym_column_major] = ACTIONS(4545),
    [anon_sym_globallycoherent] = ACTIONS(4545),
    [anon_sym_centroid] = ACTIONS(4545),
    [anon_sym_noperspective] = ACTIONS(4545),
    [anon_sym_nointerpolation] = ACTIONS(4545),
    [anon_sym_sample] = ACTIONS(4545),
    [anon_sym_linear] = ACTIONS(4545),
    [anon_sym_snorm] = ACTIONS(4545),
    [anon_sym_unorm] = ACTIONS(4545),
    [anon_sym_point] = ACTIONS(4545),
    [anon_sym_line] = ACTIONS(4545),
    [anon_sym_triangleadj] = ACTIONS(4545),
    [anon_sym_lineadj] = ACTIONS(4545),
    [anon_sym_triangle] = ACTIONS(4545),
    [anon_sym_where] = ACTIONS(4545),
  },
  [2637] = {
    [sym_identifier] = ACTIONS(6232),
    [anon_sym_LPAREN2] = ACTIONS(6234),
    [anon_sym_STAR] = ACTIONS(6234),
    [anon_sym_AMP_AMP] = ACTIONS(6234),
    [anon_sym_AMP] = ACTIONS(6236),
    [anon_sym_LT] = ACTIONS(6234),
    [anon_sym___extension__] = ACTIONS(6232),
    [anon_sym_in] = ACTIONS(6232),
    [anon_sym_out] = ACTIONS(6232),
    [anon_sym_inout] = ACTIONS(6232),
    [anon_sym_extern] = ACTIONS(6232),
    [anon_sym___attribute__] = ACTIONS(6232),
    [anon_sym_COLON_COLON] = ACTIONS(6238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6238),
    [anon_sym___declspec] = ACTIONS(6232),
    [anon_sym___cdecl] = ACTIONS(6232),
    [anon_sym___clrcall] = ACTIONS(6232),
    [anon_sym___stdcall] = ACTIONS(6232),
    [anon_sym___fastcall] = ACTIONS(6232),
    [anon_sym___thiscall] = ACTIONS(6232),
    [anon_sym___vectorcall] = ACTIONS(6232),
    [anon_sym_LBRACE] = ACTIONS(6234),
    [anon_sym_signed] = ACTIONS(6232),
    [anon_sym_unsigned] = ACTIONS(6232),
    [anon_sym_long] = ACTIONS(6232),
    [anon_sym_short] = ACTIONS(6232),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_static] = ACTIONS(6232),
    [anon_sym_EQ] = ACTIONS(6240),
    [anon_sym_register] = ACTIONS(6232),
    [anon_sym_inline] = ACTIONS(6232),
    [anon_sym___inline] = ACTIONS(6232),
    [anon_sym___inline__] = ACTIONS(6232),
    [anon_sym___forceinline] = ACTIONS(6232),
    [anon_sym_thread_local] = ACTIONS(6232),
    [anon_sym___thread] = ACTIONS(6232),
    [anon_sym_const] = ACTIONS(6232),
    [anon_sym_constexpr] = ACTIONS(6232),
    [anon_sym_volatile] = ACTIONS(6232),
    [anon_sym_restrict] = ACTIONS(6232),
    [anon_sym___restrict__] = ACTIONS(6232),
    [anon_sym__Atomic] = ACTIONS(6232),
    [anon_sym__Noreturn] = ACTIONS(6232),
    [anon_sym_noreturn] = ACTIONS(6232),
    [anon_sym_mutable] = ACTIONS(6232),
    [anon_sym_constinit] = ACTIONS(6232),
    [anon_sym_consteval] = ACTIONS(6232),
    [anon_sym_alignas] = ACTIONS(6232),
    [anon_sym__Alignas] = ACTIONS(6232),
    [sym_primitive_type] = ACTIONS(6232),
    [anon_sym_enum] = ACTIONS(6232),
    [anon_sym_class] = ACTIONS(6232),
    [anon_sym_struct] = ACTIONS(6232),
    [anon_sym_union] = ACTIONS(6232),
    [anon_sym_if] = ACTIONS(6232),
    [anon_sym_for] = ACTIONS(6232),
    [anon_sym_DOT] = ACTIONS(6240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6232),
    [anon_sym_let] = ACTIONS(6232),
    [anon_sym_This] = ACTIONS(6232),
    [anon_sym_decltype] = ACTIONS(6232),
    [sym_virtual] = ACTIONS(6232),
    [anon_sym_typename] = ACTIONS(6232),
    [anon_sym_template] = ACTIONS(6232),
    [anon_sym_precise] = ACTIONS(6232),
    [anon_sym_shared] = ACTIONS(6232),
    [anon_sym_groupshared] = ACTIONS(6232),
    [anon_sym_uniform] = ACTIONS(6232),
    [anon_sym_row_major] = ACTIONS(6232),
    [anon_sym_column_major] = ACTIONS(6232),
    [anon_sym_globallycoherent] = ACTIONS(6232),
    [anon_sym_centroid] = ACTIONS(6232),
    [anon_sym_noperspective] = ACTIONS(6232),
    [anon_sym_nointerpolation] = ACTIONS(6232),
    [anon_sym_sample] = ACTIONS(6232),
    [anon_sym_linear] = ACTIONS(6232),
    [anon_sym_snorm] = ACTIONS(6232),
    [anon_sym_unorm] = ACTIONS(6232),
    [anon_sym_point] = ACTIONS(6232),
    [anon_sym_line] = ACTIONS(6232),
    [anon_sym_triangleadj] = ACTIONS(6232),
    [anon_sym_lineadj] = ACTIONS(6232),
    [anon_sym_triangle] = ACTIONS(6232),
    [anon_sym_interface] = ACTIONS(6232),
    [anon_sym_extension] = ACTIONS(6232),
  },
  [2638] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2605),
    [sym_identifier] = ACTIONS(3778),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3781),
    [anon_sym_RPAREN] = ACTIONS(3781),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_TILDE] = ACTIONS(3781),
    [anon_sym_STAR] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_COLON] = ACTIONS(3778),
    [anon_sym_SEMI] = ACTIONS(3781),
    [anon_sym___extension__] = ACTIONS(3778),
    [anon_sym_in] = ACTIONS(3778),
    [anon_sym_out] = ACTIONS(3778),
    [anon_sym_inout] = ACTIONS(3778),
    [anon_sym_extern] = ACTIONS(3778),
    [anon_sym___attribute__] = ACTIONS(3778),
    [anon_sym_COLON_COLON] = ACTIONS(3781),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3781),
    [anon_sym___declspec] = ACTIONS(3778),
    [anon_sym___based] = ACTIONS(3778),
    [anon_sym___cdecl] = ACTIONS(3778),
    [anon_sym___clrcall] = ACTIONS(3778),
    [anon_sym___stdcall] = ACTIONS(3778),
    [anon_sym___fastcall] = ACTIONS(3778),
    [anon_sym___thiscall] = ACTIONS(3778),
    [anon_sym___vectorcall] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_signed] = ACTIONS(6189),
    [anon_sym_unsigned] = ACTIONS(6189),
    [anon_sym_long] = ACTIONS(6189),
    [anon_sym_short] = ACTIONS(6189),
    [anon_sym_LBRACK] = ACTIONS(3778),
    [anon_sym_static] = ACTIONS(3778),
    [anon_sym_EQ] = ACTIONS(3781),
    [anon_sym_register] = ACTIONS(3778),
    [anon_sym_inline] = ACTIONS(3778),
    [anon_sym___inline] = ACTIONS(3778),
    [anon_sym___inline__] = ACTIONS(3778),
    [anon_sym___forceinline] = ACTIONS(3778),
    [anon_sym_thread_local] = ACTIONS(3778),
    [anon_sym___thread] = ACTIONS(3778),
    [anon_sym_const] = ACTIONS(3778),
    [anon_sym_constexpr] = ACTIONS(3778),
    [anon_sym_volatile] = ACTIONS(3778),
    [anon_sym_restrict] = ACTIONS(3778),
    [anon_sym___restrict__] = ACTIONS(3778),
    [anon_sym__Atomic] = ACTIONS(3778),
    [anon_sym__Noreturn] = ACTIONS(3778),
    [anon_sym_noreturn] = ACTIONS(3778),
    [anon_sym_mutable] = ACTIONS(3778),
    [anon_sym_constinit] = ACTIONS(3778),
    [anon_sym_consteval] = ACTIONS(3778),
    [anon_sym_alignas] = ACTIONS(3778),
    [anon_sym__Alignas] = ACTIONS(3778),
    [sym_primitive_type] = ACTIONS(2856),
    [anon_sym_DOT] = ACTIONS(3778),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3778),
    [anon_sym_let] = ACTIONS(3778),
    [anon_sym_This] = ACTIONS(3778),
    [anon_sym_decltype] = ACTIONS(3778),
    [sym_virtual] = ACTIONS(3778),
    [anon_sym_template] = ACTIONS(3778),
    [anon_sym_GT2] = ACTIONS(3781),
    [anon_sym_operator] = ACTIONS(3778),
    [anon_sym_precise] = ACTIONS(3778),
    [anon_sym_shared] = ACTIONS(3778),
    [anon_sym_groupshared] = ACTIONS(3778),
    [anon_sym_uniform] = ACTIONS(3778),
    [anon_sym_row_major] = ACTIONS(3778),
    [anon_sym_column_major] = ACTIONS(3778),
    [anon_sym_globallycoherent] = ACTIONS(3778),
    [anon_sym_centroid] = ACTIONS(3778),
    [anon_sym_noperspective] = ACTIONS(3778),
    [anon_sym_nointerpolation] = ACTIONS(3778),
    [anon_sym_sample] = ACTIONS(3778),
    [anon_sym_linear] = ACTIONS(3778),
    [anon_sym_snorm] = ACTIONS(3778),
    [anon_sym_unorm] = ACTIONS(3778),
    [anon_sym_point] = ACTIONS(3778),
    [anon_sym_line] = ACTIONS(3778),
    [anon_sym_triangleadj] = ACTIONS(3778),
    [anon_sym_lineadj] = ACTIONS(3778),
    [anon_sym_triangle] = ACTIONS(3778),
  },
  [2639] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2658),
    [sym_identifier] = ACTIONS(3757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3759),
    [anon_sym_RPAREN] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_TILDE] = ACTIONS(3759),
    [anon_sym_STAR] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_AMP] = ACTIONS(3757),
    [anon_sym_COLON] = ACTIONS(3757),
    [anon_sym_SEMI] = ACTIONS(3759),
    [anon_sym___extension__] = ACTIONS(3757),
    [anon_sym_in] = ACTIONS(3757),
    [anon_sym_out] = ACTIONS(3757),
    [anon_sym_inout] = ACTIONS(3757),
    [anon_sym_extern] = ACTIONS(3757),
    [anon_sym___attribute__] = ACTIONS(3757),
    [anon_sym_COLON_COLON] = ACTIONS(3759),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3759),
    [anon_sym___declspec] = ACTIONS(3757),
    [anon_sym___based] = ACTIONS(3757),
    [anon_sym___cdecl] = ACTIONS(3757),
    [anon_sym___clrcall] = ACTIONS(3757),
    [anon_sym___stdcall] = ACTIONS(3757),
    [anon_sym___fastcall] = ACTIONS(3757),
    [anon_sym___thiscall] = ACTIONS(3757),
    [anon_sym___vectorcall] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_signed] = ACTIONS(6242),
    [anon_sym_unsigned] = ACTIONS(6242),
    [anon_sym_long] = ACTIONS(6242),
    [anon_sym_short] = ACTIONS(6242),
    [anon_sym_LBRACK] = ACTIONS(3757),
    [anon_sym_static] = ACTIONS(3757),
    [anon_sym_EQ] = ACTIONS(3759),
    [anon_sym_register] = ACTIONS(3757),
    [anon_sym_inline] = ACTIONS(3757),
    [anon_sym___inline] = ACTIONS(3757),
    [anon_sym___inline__] = ACTIONS(3757),
    [anon_sym___forceinline] = ACTIONS(3757),
    [anon_sym_thread_local] = ACTIONS(3757),
    [anon_sym___thread] = ACTIONS(3757),
    [anon_sym_const] = ACTIONS(3757),
    [anon_sym_constexpr] = ACTIONS(3757),
    [anon_sym_volatile] = ACTIONS(3757),
    [anon_sym_restrict] = ACTIONS(3757),
    [anon_sym___restrict__] = ACTIONS(3757),
    [anon_sym__Atomic] = ACTIONS(3757),
    [anon_sym__Noreturn] = ACTIONS(3757),
    [anon_sym_noreturn] = ACTIONS(3757),
    [anon_sym_mutable] = ACTIONS(3757),
    [anon_sym_constinit] = ACTIONS(3757),
    [anon_sym_consteval] = ACTIONS(3757),
    [anon_sym_alignas] = ACTIONS(3757),
    [anon_sym__Alignas] = ACTIONS(3757),
    [anon_sym_DOT] = ACTIONS(3757),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3757),
    [anon_sym_let] = ACTIONS(3757),
    [anon_sym_This] = ACTIONS(3757),
    [anon_sym_decltype] = ACTIONS(3757),
    [sym_virtual] = ACTIONS(3757),
    [anon_sym_template] = ACTIONS(3757),
    [anon_sym_GT2] = ACTIONS(3759),
    [anon_sym_operator] = ACTIONS(3757),
    [anon_sym_precise] = ACTIONS(3757),
    [anon_sym_shared] = ACTIONS(3757),
    [anon_sym_groupshared] = ACTIONS(3757),
    [anon_sym_uniform] = ACTIONS(3757),
    [anon_sym_row_major] = ACTIONS(3757),
    [anon_sym_column_major] = ACTIONS(3757),
    [anon_sym_globallycoherent] = ACTIONS(3757),
    [anon_sym_centroid] = ACTIONS(3757),
    [anon_sym_noperspective] = ACTIONS(3757),
    [anon_sym_nointerpolation] = ACTIONS(3757),
    [anon_sym_sample] = ACTIONS(3757),
    [anon_sym_linear] = ACTIONS(3757),
    [anon_sym_snorm] = ACTIONS(3757),
    [anon_sym_unorm] = ACTIONS(3757),
    [anon_sym_point] = ACTIONS(3757),
    [anon_sym_line] = ACTIONS(3757),
    [anon_sym_triangleadj] = ACTIONS(3757),
    [anon_sym_lineadj] = ACTIONS(3757),
    [anon_sym_triangle] = ACTIONS(3757),
  },
  [2640] = {
    [sym_identifier] = ACTIONS(2198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_COMMA] = ACTIONS(2200),
    [anon_sym_RPAREN] = ACTIONS(2200),
    [aux_sym_preproc_if_token2] = ACTIONS(2200),
    [aux_sym_preproc_else_token1] = ACTIONS(2200),
    [aux_sym_preproc_elif_token1] = ACTIONS(2198),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2200),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2200),
    [anon_sym_LPAREN2] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(2198),
    [anon_sym_SLASH] = ACTIONS(2198),
    [anon_sym_PERCENT] = ACTIONS(2198),
    [anon_sym_PIPE_PIPE] = ACTIONS(2200),
    [anon_sym_AMP_AMP] = ACTIONS(2200),
    [anon_sym_PIPE] = ACTIONS(2198),
    [anon_sym_CARET] = ACTIONS(2198),
    [anon_sym_AMP] = ACTIONS(2198),
    [anon_sym_EQ_EQ] = ACTIONS(2200),
    [anon_sym_BANG_EQ] = ACTIONS(2200),
    [anon_sym_GT] = ACTIONS(2198),
    [anon_sym_GT_EQ] = ACTIONS(2200),
    [anon_sym_LT_EQ] = ACTIONS(2198),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_LT_LT] = ACTIONS(2198),
    [anon_sym_GT_GT] = ACTIONS(2198),
    [anon_sym_COLON] = ACTIONS(2198),
    [anon_sym_SEMI] = ACTIONS(2200),
    [anon_sym___extension__] = ACTIONS(2198),
    [anon_sym___attribute__] = ACTIONS(2198),
    [anon_sym_COLON_COLON] = ACTIONS(2200),
    [anon_sym_LBRACE] = ACTIONS(2200),
    [anon_sym_RBRACE] = ACTIONS(2200),
    [anon_sym_LBRACK] = ACTIONS(2200),
    [anon_sym_RBRACK] = ACTIONS(2200),
    [anon_sym_EQ] = ACTIONS(2198),
    [anon_sym_const] = ACTIONS(2198),
    [anon_sym_constexpr] = ACTIONS(2198),
    [anon_sym_volatile] = ACTIONS(2198),
    [anon_sym_restrict] = ACTIONS(2198),
    [anon_sym___restrict__] = ACTIONS(2198),
    [anon_sym__Atomic] = ACTIONS(2198),
    [anon_sym__Noreturn] = ACTIONS(2198),
    [anon_sym_noreturn] = ACTIONS(2198),
    [anon_sym_mutable] = ACTIONS(2198),
    [anon_sym_constinit] = ACTIONS(2198),
    [anon_sym_consteval] = ACTIONS(2198),
    [anon_sym_alignas] = ACTIONS(2198),
    [anon_sym__Alignas] = ACTIONS(2198),
    [anon_sym_QMARK] = ACTIONS(2200),
    [anon_sym_STAR_EQ] = ACTIONS(2200),
    [anon_sym_SLASH_EQ] = ACTIONS(2200),
    [anon_sym_PERCENT_EQ] = ACTIONS(2200),
    [anon_sym_PLUS_EQ] = ACTIONS(2200),
    [anon_sym_DASH_EQ] = ACTIONS(2200),
    [anon_sym_LT_LT_EQ] = ACTIONS(2200),
    [anon_sym_GT_GT_EQ] = ACTIONS(2200),
    [anon_sym_AMP_EQ] = ACTIONS(2200),
    [anon_sym_CARET_EQ] = ACTIONS(2200),
    [anon_sym_PIPE_EQ] = ACTIONS(2200),
    [anon_sym_and_eq] = ACTIONS(2198),
    [anon_sym_or_eq] = ACTIONS(2198),
    [anon_sym_xor_eq] = ACTIONS(2198),
    [anon_sym_LT_EQ_GT] = ACTIONS(2200),
    [anon_sym_or] = ACTIONS(2198),
    [anon_sym_and] = ACTIONS(2198),
    [anon_sym_bitor] = ACTIONS(2198),
    [anon_sym_xor] = ACTIONS(2198),
    [anon_sym_bitand] = ACTIONS(2198),
    [anon_sym_not_eq] = ACTIONS(2198),
    [anon_sym_is] = ACTIONS(2198),
    [anon_sym_as] = ACTIONS(2198),
    [anon_sym_DASH_DASH] = ACTIONS(2200),
    [anon_sym_PLUS_PLUS] = ACTIONS(2200),
    [anon_sym_DOT] = ACTIONS(2198),
    [anon_sym_DOT_STAR] = ACTIONS(2200),
    [anon_sym_DASH_GT] = ACTIONS(2200),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2198),
    [anon_sym_let] = ACTIONS(2198),
    [anon_sym_This] = ACTIONS(2198),
    [anon_sym_final] = ACTIONS(2198),
    [anon_sym_override] = ACTIONS(2198),
  },
  [2641] = {
    [sym_identifier] = ACTIONS(2256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2258),
    [anon_sym_COMMA] = ACTIONS(2258),
    [anon_sym_RPAREN] = ACTIONS(2258),
    [aux_sym_preproc_if_token2] = ACTIONS(2258),
    [aux_sym_preproc_else_token1] = ACTIONS(2258),
    [aux_sym_preproc_elif_token1] = ACTIONS(2256),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2258),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2258),
    [anon_sym_LPAREN2] = ACTIONS(2258),
    [anon_sym_DASH] = ACTIONS(2256),
    [anon_sym_PLUS] = ACTIONS(2256),
    [anon_sym_STAR] = ACTIONS(2256),
    [anon_sym_SLASH] = ACTIONS(2256),
    [anon_sym_PERCENT] = ACTIONS(2256),
    [anon_sym_PIPE_PIPE] = ACTIONS(2258),
    [anon_sym_AMP_AMP] = ACTIONS(2258),
    [anon_sym_PIPE] = ACTIONS(2256),
    [anon_sym_CARET] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(2256),
    [anon_sym_EQ_EQ] = ACTIONS(2258),
    [anon_sym_BANG_EQ] = ACTIONS(2258),
    [anon_sym_GT] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2258),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_LT] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2256),
    [anon_sym_GT_GT] = ACTIONS(2256),
    [anon_sym_COLON] = ACTIONS(2256),
    [anon_sym_SEMI] = ACTIONS(2258),
    [anon_sym___extension__] = ACTIONS(2256),
    [anon_sym___attribute__] = ACTIONS(2256),
    [anon_sym_COLON_COLON] = ACTIONS(2258),
    [anon_sym_LBRACE] = ACTIONS(2258),
    [anon_sym_RBRACE] = ACTIONS(2258),
    [anon_sym_LBRACK] = ACTIONS(2258),
    [anon_sym_RBRACK] = ACTIONS(2258),
    [anon_sym_EQ] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_constexpr] = ACTIONS(2256),
    [anon_sym_volatile] = ACTIONS(2256),
    [anon_sym_restrict] = ACTIONS(2256),
    [anon_sym___restrict__] = ACTIONS(2256),
    [anon_sym__Atomic] = ACTIONS(2256),
    [anon_sym__Noreturn] = ACTIONS(2256),
    [anon_sym_noreturn] = ACTIONS(2256),
    [anon_sym_mutable] = ACTIONS(2256),
    [anon_sym_constinit] = ACTIONS(2256),
    [anon_sym_consteval] = ACTIONS(2256),
    [anon_sym_alignas] = ACTIONS(2256),
    [anon_sym__Alignas] = ACTIONS(2256),
    [anon_sym_QMARK] = ACTIONS(2258),
    [anon_sym_STAR_EQ] = ACTIONS(2258),
    [anon_sym_SLASH_EQ] = ACTIONS(2258),
    [anon_sym_PERCENT_EQ] = ACTIONS(2258),
    [anon_sym_PLUS_EQ] = ACTIONS(2258),
    [anon_sym_DASH_EQ] = ACTIONS(2258),
    [anon_sym_LT_LT_EQ] = ACTIONS(2258),
    [anon_sym_GT_GT_EQ] = ACTIONS(2258),
    [anon_sym_AMP_EQ] = ACTIONS(2258),
    [anon_sym_CARET_EQ] = ACTIONS(2258),
    [anon_sym_PIPE_EQ] = ACTIONS(2258),
    [anon_sym_and_eq] = ACTIONS(2256),
    [anon_sym_or_eq] = ACTIONS(2256),
    [anon_sym_xor_eq] = ACTIONS(2256),
    [anon_sym_LT_EQ_GT] = ACTIONS(2258),
    [anon_sym_or] = ACTIONS(2256),
    [anon_sym_and] = ACTIONS(2256),
    [anon_sym_bitor] = ACTIONS(2256),
    [anon_sym_xor] = ACTIONS(2256),
    [anon_sym_bitand] = ACTIONS(2256),
    [anon_sym_not_eq] = ACTIONS(2256),
    [anon_sym_is] = ACTIONS(2256),
    [anon_sym_as] = ACTIONS(2256),
    [anon_sym_DASH_DASH] = ACTIONS(2258),
    [anon_sym_PLUS_PLUS] = ACTIONS(2258),
    [anon_sym_DOT] = ACTIONS(2256),
    [anon_sym_DOT_STAR] = ACTIONS(2258),
    [anon_sym_DASH_GT] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_This] = ACTIONS(2256),
    [anon_sym_final] = ACTIONS(2256),
    [anon_sym_override] = ACTIONS(2256),
  },
  [2642] = {
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2254),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_RPAREN] = ACTIONS(2254),
    [aux_sym_preproc_if_token2] = ACTIONS(2254),
    [aux_sym_preproc_else_token1] = ACTIONS(2254),
    [aux_sym_preproc_elif_token1] = ACTIONS(2252),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2254),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2254),
    [anon_sym_LPAREN2] = ACTIONS(2254),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_SLASH] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2252),
    [anon_sym_PIPE_PIPE] = ACTIONS(2254),
    [anon_sym_AMP_AMP] = ACTIONS(2254),
    [anon_sym_PIPE] = ACTIONS(2252),
    [anon_sym_CARET] = ACTIONS(2252),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_EQ_EQ] = ACTIONS(2254),
    [anon_sym_BANG_EQ] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2252),
    [anon_sym_GT_EQ] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2252),
    [anon_sym_LT_LT] = ACTIONS(2252),
    [anon_sym_GT_GT] = ACTIONS(2252),
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym_SEMI] = ACTIONS(2254),
    [anon_sym___extension__] = ACTIONS(2252),
    [anon_sym___attribute__] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_RBRACE] = ACTIONS(2254),
    [anon_sym_LBRACK] = ACTIONS(2254),
    [anon_sym_RBRACK] = ACTIONS(2254),
    [anon_sym_EQ] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2252),
    [anon_sym_constexpr] = ACTIONS(2252),
    [anon_sym_volatile] = ACTIONS(2252),
    [anon_sym_restrict] = ACTIONS(2252),
    [anon_sym___restrict__] = ACTIONS(2252),
    [anon_sym__Atomic] = ACTIONS(2252),
    [anon_sym__Noreturn] = ACTIONS(2252),
    [anon_sym_noreturn] = ACTIONS(2252),
    [anon_sym_mutable] = ACTIONS(2252),
    [anon_sym_constinit] = ACTIONS(2252),
    [anon_sym_consteval] = ACTIONS(2252),
    [anon_sym_alignas] = ACTIONS(2252),
    [anon_sym__Alignas] = ACTIONS(2252),
    [anon_sym_QMARK] = ACTIONS(2254),
    [anon_sym_STAR_EQ] = ACTIONS(2254),
    [anon_sym_SLASH_EQ] = ACTIONS(2254),
    [anon_sym_PERCENT_EQ] = ACTIONS(2254),
    [anon_sym_PLUS_EQ] = ACTIONS(2254),
    [anon_sym_DASH_EQ] = ACTIONS(2254),
    [anon_sym_LT_LT_EQ] = ACTIONS(2254),
    [anon_sym_GT_GT_EQ] = ACTIONS(2254),
    [anon_sym_AMP_EQ] = ACTIONS(2254),
    [anon_sym_CARET_EQ] = ACTIONS(2254),
    [anon_sym_PIPE_EQ] = ACTIONS(2254),
    [anon_sym_and_eq] = ACTIONS(2252),
    [anon_sym_or_eq] = ACTIONS(2252),
    [anon_sym_xor_eq] = ACTIONS(2252),
    [anon_sym_LT_EQ_GT] = ACTIONS(2254),
    [anon_sym_or] = ACTIONS(2252),
    [anon_sym_and] = ACTIONS(2252),
    [anon_sym_bitor] = ACTIONS(2252),
    [anon_sym_xor] = ACTIONS(2252),
    [anon_sym_bitand] = ACTIONS(2252),
    [anon_sym_not_eq] = ACTIONS(2252),
    [anon_sym_is] = ACTIONS(2252),
    [anon_sym_as] = ACTIONS(2252),
    [anon_sym_DASH_DASH] = ACTIONS(2254),
    [anon_sym_PLUS_PLUS] = ACTIONS(2254),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_DOT_STAR] = ACTIONS(2254),
    [anon_sym_DASH_GT] = ACTIONS(2254),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_This] = ACTIONS(2252),
    [anon_sym_final] = ACTIONS(2252),
    [anon_sym_override] = ACTIONS(2252),
  },
  [2643] = {
    [sym_identifier] = ACTIONS(2206),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2208),
    [anon_sym_COMMA] = ACTIONS(2208),
    [anon_sym_RPAREN] = ACTIONS(2208),
    [aux_sym_preproc_if_token2] = ACTIONS(2208),
    [aux_sym_preproc_else_token1] = ACTIONS(2208),
    [aux_sym_preproc_elif_token1] = ACTIONS(2206),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2208),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2208),
    [anon_sym_LPAREN2] = ACTIONS(2208),
    [anon_sym_DASH] = ACTIONS(2206),
    [anon_sym_PLUS] = ACTIONS(2206),
    [anon_sym_STAR] = ACTIONS(2206),
    [anon_sym_SLASH] = ACTIONS(2206),
    [anon_sym_PERCENT] = ACTIONS(2206),
    [anon_sym_PIPE_PIPE] = ACTIONS(2208),
    [anon_sym_AMP_AMP] = ACTIONS(2208),
    [anon_sym_PIPE] = ACTIONS(2206),
    [anon_sym_CARET] = ACTIONS(2206),
    [anon_sym_AMP] = ACTIONS(2206),
    [anon_sym_EQ_EQ] = ACTIONS(2208),
    [anon_sym_BANG_EQ] = ACTIONS(2208),
    [anon_sym_GT] = ACTIONS(2206),
    [anon_sym_GT_EQ] = ACTIONS(2208),
    [anon_sym_LT_EQ] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2206),
    [anon_sym_LT_LT] = ACTIONS(2206),
    [anon_sym_GT_GT] = ACTIONS(2206),
    [anon_sym_COLON] = ACTIONS(2206),
    [anon_sym_SEMI] = ACTIONS(2208),
    [anon_sym___extension__] = ACTIONS(2206),
    [anon_sym___attribute__] = ACTIONS(2206),
    [anon_sym_COLON_COLON] = ACTIONS(2208),
    [anon_sym_LBRACE] = ACTIONS(2208),
    [anon_sym_RBRACE] = ACTIONS(2208),
    [anon_sym_LBRACK] = ACTIONS(2208),
    [anon_sym_RBRACK] = ACTIONS(2208),
    [anon_sym_EQ] = ACTIONS(2206),
    [anon_sym_const] = ACTIONS(2206),
    [anon_sym_constexpr] = ACTIONS(2206),
    [anon_sym_volatile] = ACTIONS(2206),
    [anon_sym_restrict] = ACTIONS(2206),
    [anon_sym___restrict__] = ACTIONS(2206),
    [anon_sym__Atomic] = ACTIONS(2206),
    [anon_sym__Noreturn] = ACTIONS(2206),
    [anon_sym_noreturn] = ACTIONS(2206),
    [anon_sym_mutable] = ACTIONS(2206),
    [anon_sym_constinit] = ACTIONS(2206),
    [anon_sym_consteval] = ACTIONS(2206),
    [anon_sym_alignas] = ACTIONS(2206),
    [anon_sym__Alignas] = ACTIONS(2206),
    [anon_sym_QMARK] = ACTIONS(2208),
    [anon_sym_STAR_EQ] = ACTIONS(2208),
    [anon_sym_SLASH_EQ] = ACTIONS(2208),
    [anon_sym_PERCENT_EQ] = ACTIONS(2208),
    [anon_sym_PLUS_EQ] = ACTIONS(2208),
    [anon_sym_DASH_EQ] = ACTIONS(2208),
    [anon_sym_LT_LT_EQ] = ACTIONS(2208),
    [anon_sym_GT_GT_EQ] = ACTIONS(2208),
    [anon_sym_AMP_EQ] = ACTIONS(2208),
    [anon_sym_CARET_EQ] = ACTIONS(2208),
    [anon_sym_PIPE_EQ] = ACTIONS(2208),
    [anon_sym_and_eq] = ACTIONS(2206),
    [anon_sym_or_eq] = ACTIONS(2206),
    [anon_sym_xor_eq] = ACTIONS(2206),
    [anon_sym_LT_EQ_GT] = ACTIONS(2208),
    [anon_sym_or] = ACTIONS(2206),
    [anon_sym_and] = ACTIONS(2206),
    [anon_sym_bitor] = ACTIONS(2206),
    [anon_sym_xor] = ACTIONS(2206),
    [anon_sym_bitand] = ACTIONS(2206),
    [anon_sym_not_eq] = ACTIONS(2206),
    [anon_sym_is] = ACTIONS(2206),
    [anon_sym_as] = ACTIONS(2206),
    [anon_sym_DASH_DASH] = ACTIONS(2208),
    [anon_sym_PLUS_PLUS] = ACTIONS(2208),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_DOT_STAR] = ACTIONS(2208),
    [anon_sym_DASH_GT] = ACTIONS(2208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2206),
    [anon_sym_let] = ACTIONS(2206),
    [anon_sym_This] = ACTIONS(2206),
    [anon_sym_final] = ACTIONS(2206),
    [anon_sym_override] = ACTIONS(2206),
  },
  [2644] = {
    [sym_identifier] = ACTIONS(2244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(2246),
    [anon_sym_RPAREN] = ACTIONS(2246),
    [aux_sym_preproc_if_token2] = ACTIONS(2246),
    [aux_sym_preproc_else_token1] = ACTIONS(2246),
    [aux_sym_preproc_elif_token1] = ACTIONS(2244),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2246),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2244),
    [anon_sym_PLUS] = ACTIONS(2244),
    [anon_sym_STAR] = ACTIONS(2244),
    [anon_sym_SLASH] = ACTIONS(2244),
    [anon_sym_PERCENT] = ACTIONS(2244),
    [anon_sym_PIPE_PIPE] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2244),
    [anon_sym_CARET] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2244),
    [anon_sym_EQ_EQ] = ACTIONS(2246),
    [anon_sym_BANG_EQ] = ACTIONS(2246),
    [anon_sym_GT] = ACTIONS(2244),
    [anon_sym_GT_EQ] = ACTIONS(2246),
    [anon_sym_LT_EQ] = ACTIONS(2244),
    [anon_sym_LT] = ACTIONS(2244),
    [anon_sym_LT_LT] = ACTIONS(2244),
    [anon_sym_GT_GT] = ACTIONS(2244),
    [anon_sym_COLON] = ACTIONS(2244),
    [anon_sym_SEMI] = ACTIONS(2246),
    [anon_sym___extension__] = ACTIONS(2244),
    [anon_sym___attribute__] = ACTIONS(2244),
    [anon_sym_COLON_COLON] = ACTIONS(2246),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_RBRACE] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_RBRACK] = ACTIONS(2246),
    [anon_sym_EQ] = ACTIONS(2244),
    [anon_sym_const] = ACTIONS(2244),
    [anon_sym_constexpr] = ACTIONS(2244),
    [anon_sym_volatile] = ACTIONS(2244),
    [anon_sym_restrict] = ACTIONS(2244),
    [anon_sym___restrict__] = ACTIONS(2244),
    [anon_sym__Atomic] = ACTIONS(2244),
    [anon_sym__Noreturn] = ACTIONS(2244),
    [anon_sym_noreturn] = ACTIONS(2244),
    [anon_sym_mutable] = ACTIONS(2244),
    [anon_sym_constinit] = ACTIONS(2244),
    [anon_sym_consteval] = ACTIONS(2244),
    [anon_sym_alignas] = ACTIONS(2244),
    [anon_sym__Alignas] = ACTIONS(2244),
    [anon_sym_QMARK] = ACTIONS(2246),
    [anon_sym_STAR_EQ] = ACTIONS(2246),
    [anon_sym_SLASH_EQ] = ACTIONS(2246),
    [anon_sym_PERCENT_EQ] = ACTIONS(2246),
    [anon_sym_PLUS_EQ] = ACTIONS(2246),
    [anon_sym_DASH_EQ] = ACTIONS(2246),
    [anon_sym_LT_LT_EQ] = ACTIONS(2246),
    [anon_sym_GT_GT_EQ] = ACTIONS(2246),
    [anon_sym_AMP_EQ] = ACTIONS(2246),
    [anon_sym_CARET_EQ] = ACTIONS(2246),
    [anon_sym_PIPE_EQ] = ACTIONS(2246),
    [anon_sym_and_eq] = ACTIONS(2244),
    [anon_sym_or_eq] = ACTIONS(2244),
    [anon_sym_xor_eq] = ACTIONS(2244),
    [anon_sym_LT_EQ_GT] = ACTIONS(2246),
    [anon_sym_or] = ACTIONS(2244),
    [anon_sym_and] = ACTIONS(2244),
    [anon_sym_bitor] = ACTIONS(2244),
    [anon_sym_xor] = ACTIONS(2244),
    [anon_sym_bitand] = ACTIONS(2244),
    [anon_sym_not_eq] = ACTIONS(2244),
    [anon_sym_is] = ACTIONS(2244),
    [anon_sym_as] = ACTIONS(2244),
    [anon_sym_DASH_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_PLUS] = ACTIONS(2246),
    [anon_sym_DOT] = ACTIONS(2244),
    [anon_sym_DOT_STAR] = ACTIONS(2246),
    [anon_sym_DASH_GT] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2244),
    [anon_sym_let] = ACTIONS(2244),
    [anon_sym_This] = ACTIONS(2244),
    [anon_sym_final] = ACTIONS(2244),
    [anon_sym_override] = ACTIONS(2244),
  },
  [2645] = {
    [sym_identifier] = ACTIONS(2232),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_COMMA] = ACTIONS(2234),
    [anon_sym_RPAREN] = ACTIONS(2234),
    [aux_sym_preproc_if_token2] = ACTIONS(2234),
    [aux_sym_preproc_else_token1] = ACTIONS(2234),
    [aux_sym_preproc_elif_token1] = ACTIONS(2232),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2234),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2234),
    [anon_sym_LPAREN2] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2232),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_STAR] = ACTIONS(2232),
    [anon_sym_SLASH] = ACTIONS(2232),
    [anon_sym_PERCENT] = ACTIONS(2232),
    [anon_sym_PIPE_PIPE] = ACTIONS(2234),
    [anon_sym_AMP_AMP] = ACTIONS(2234),
    [anon_sym_PIPE] = ACTIONS(2232),
    [anon_sym_CARET] = ACTIONS(2232),
    [anon_sym_AMP] = ACTIONS(2232),
    [anon_sym_EQ_EQ] = ACTIONS(2234),
    [anon_sym_BANG_EQ] = ACTIONS(2234),
    [anon_sym_GT] = ACTIONS(2232),
    [anon_sym_GT_EQ] = ACTIONS(2234),
    [anon_sym_LT_EQ] = ACTIONS(2232),
    [anon_sym_LT] = ACTIONS(2232),
    [anon_sym_LT_LT] = ACTIONS(2232),
    [anon_sym_GT_GT] = ACTIONS(2232),
    [anon_sym_COLON] = ACTIONS(2232),
    [anon_sym_SEMI] = ACTIONS(2234),
    [anon_sym___extension__] = ACTIONS(2232),
    [anon_sym___attribute__] = ACTIONS(2232),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_RBRACE] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_RBRACK] = ACTIONS(2234),
    [anon_sym_EQ] = ACTIONS(2232),
    [anon_sym_const] = ACTIONS(2232),
    [anon_sym_constexpr] = ACTIONS(2232),
    [anon_sym_volatile] = ACTIONS(2232),
    [anon_sym_restrict] = ACTIONS(2232),
    [anon_sym___restrict__] = ACTIONS(2232),
    [anon_sym__Atomic] = ACTIONS(2232),
    [anon_sym__Noreturn] = ACTIONS(2232),
    [anon_sym_noreturn] = ACTIONS(2232),
    [anon_sym_mutable] = ACTIONS(2232),
    [anon_sym_constinit] = ACTIONS(2232),
    [anon_sym_consteval] = ACTIONS(2232),
    [anon_sym_alignas] = ACTIONS(2232),
    [anon_sym__Alignas] = ACTIONS(2232),
    [anon_sym_QMARK] = ACTIONS(2234),
    [anon_sym_STAR_EQ] = ACTIONS(2234),
    [anon_sym_SLASH_EQ] = ACTIONS(2234),
    [anon_sym_PERCENT_EQ] = ACTIONS(2234),
    [anon_sym_PLUS_EQ] = ACTIONS(2234),
    [anon_sym_DASH_EQ] = ACTIONS(2234),
    [anon_sym_LT_LT_EQ] = ACTIONS(2234),
    [anon_sym_GT_GT_EQ] = ACTIONS(2234),
    [anon_sym_AMP_EQ] = ACTIONS(2234),
    [anon_sym_CARET_EQ] = ACTIONS(2234),
    [anon_sym_PIPE_EQ] = ACTIONS(2234),
    [anon_sym_and_eq] = ACTIONS(2232),
    [anon_sym_or_eq] = ACTIONS(2232),
    [anon_sym_xor_eq] = ACTIONS(2232),
    [anon_sym_LT_EQ_GT] = ACTIONS(2234),
    [anon_sym_or] = ACTIONS(2232),
    [anon_sym_and] = ACTIONS(2232),
    [anon_sym_bitor] = ACTIONS(2232),
    [anon_sym_xor] = ACTIONS(2232),
    [anon_sym_bitand] = ACTIONS(2232),
    [anon_sym_not_eq] = ACTIONS(2232),
    [anon_sym_is] = ACTIONS(2232),
    [anon_sym_as] = ACTIONS(2232),
    [anon_sym_DASH_DASH] = ACTIONS(2234),
    [anon_sym_PLUS_PLUS] = ACTIONS(2234),
    [anon_sym_DOT] = ACTIONS(2232),
    [anon_sym_DOT_STAR] = ACTIONS(2234),
    [anon_sym_DASH_GT] = ACTIONS(2234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2232),
    [anon_sym_let] = ACTIONS(2232),
    [anon_sym_This] = ACTIONS(2232),
    [anon_sym_final] = ACTIONS(2232),
    [anon_sym_override] = ACTIONS(2232),
  },
  [2646] = {
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2230),
    [anon_sym_COMMA] = ACTIONS(2230),
    [anon_sym_RPAREN] = ACTIONS(2230),
    [aux_sym_preproc_if_token2] = ACTIONS(2230),
    [aux_sym_preproc_else_token1] = ACTIONS(2230),
    [aux_sym_preproc_elif_token1] = ACTIONS(2228),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2230),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2230),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2228),
    [anon_sym_PLUS] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(2228),
    [anon_sym_SLASH] = ACTIONS(2228),
    [anon_sym_PERCENT] = ACTIONS(2228),
    [anon_sym_PIPE_PIPE] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_PIPE] = ACTIONS(2228),
    [anon_sym_CARET] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2228),
    [anon_sym_EQ_EQ] = ACTIONS(2230),
    [anon_sym_BANG_EQ] = ACTIONS(2230),
    [anon_sym_GT] = ACTIONS(2228),
    [anon_sym_GT_EQ] = ACTIONS(2230),
    [anon_sym_LT_EQ] = ACTIONS(2228),
    [anon_sym_LT] = ACTIONS(2228),
    [anon_sym_LT_LT] = ACTIONS(2228),
    [anon_sym_GT_GT] = ACTIONS(2228),
    [anon_sym_COLON] = ACTIONS(2228),
    [anon_sym_SEMI] = ACTIONS(2230),
    [anon_sym___extension__] = ACTIONS(2228),
    [anon_sym___attribute__] = ACTIONS(2228),
    [anon_sym_COLON_COLON] = ACTIONS(2230),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_RBRACE] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2230),
    [anon_sym_RBRACK] = ACTIONS(2230),
    [anon_sym_EQ] = ACTIONS(2228),
    [anon_sym_const] = ACTIONS(2228),
    [anon_sym_constexpr] = ACTIONS(2228),
    [anon_sym_volatile] = ACTIONS(2228),
    [anon_sym_restrict] = ACTIONS(2228),
    [anon_sym___restrict__] = ACTIONS(2228),
    [anon_sym__Atomic] = ACTIONS(2228),
    [anon_sym__Noreturn] = ACTIONS(2228),
    [anon_sym_noreturn] = ACTIONS(2228),
    [anon_sym_mutable] = ACTIONS(2228),
    [anon_sym_constinit] = ACTIONS(2228),
    [anon_sym_consteval] = ACTIONS(2228),
    [anon_sym_alignas] = ACTIONS(2228),
    [anon_sym__Alignas] = ACTIONS(2228),
    [anon_sym_QMARK] = ACTIONS(2230),
    [anon_sym_STAR_EQ] = ACTIONS(2230),
    [anon_sym_SLASH_EQ] = ACTIONS(2230),
    [anon_sym_PERCENT_EQ] = ACTIONS(2230),
    [anon_sym_PLUS_EQ] = ACTIONS(2230),
    [anon_sym_DASH_EQ] = ACTIONS(2230),
    [anon_sym_LT_LT_EQ] = ACTIONS(2230),
    [anon_sym_GT_GT_EQ] = ACTIONS(2230),
    [anon_sym_AMP_EQ] = ACTIONS(2230),
    [anon_sym_CARET_EQ] = ACTIONS(2230),
    [anon_sym_PIPE_EQ] = ACTIONS(2230),
    [anon_sym_and_eq] = ACTIONS(2228),
    [anon_sym_or_eq] = ACTIONS(2228),
    [anon_sym_xor_eq] = ACTIONS(2228),
    [anon_sym_LT_EQ_GT] = ACTIONS(2230),
    [anon_sym_or] = ACTIONS(2228),
    [anon_sym_and] = ACTIONS(2228),
    [anon_sym_bitor] = ACTIONS(2228),
    [anon_sym_xor] = ACTIONS(2228),
    [anon_sym_bitand] = ACTIONS(2228),
    [anon_sym_not_eq] = ACTIONS(2228),
    [anon_sym_is] = ACTIONS(2228),
    [anon_sym_as] = ACTIONS(2228),
    [anon_sym_DASH_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_PLUS] = ACTIONS(2230),
    [anon_sym_DOT] = ACTIONS(2228),
    [anon_sym_DOT_STAR] = ACTIONS(2230),
    [anon_sym_DASH_GT] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(2228),
    [anon_sym_This] = ACTIONS(2228),
    [anon_sym_final] = ACTIONS(2228),
    [anon_sym_override] = ACTIONS(2228),
  },
  [2647] = {
    [sym_identifier] = ACTIONS(6132),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6134),
    [anon_sym_COMMA] = ACTIONS(6134),
    [anon_sym_RPAREN] = ACTIONS(6134),
    [anon_sym_LPAREN2] = ACTIONS(6134),
    [anon_sym_TILDE] = ACTIONS(6134),
    [anon_sym_STAR] = ACTIONS(6134),
    [anon_sym_AMP_AMP] = ACTIONS(6134),
    [anon_sym_AMP] = ACTIONS(6132),
    [anon_sym_COLON] = ACTIONS(6132),
    [anon_sym_SEMI] = ACTIONS(6134),
    [anon_sym___extension__] = ACTIONS(6132),
    [anon_sym_in] = ACTIONS(6132),
    [anon_sym_out] = ACTIONS(6132),
    [anon_sym_inout] = ACTIONS(6132),
    [anon_sym_extern] = ACTIONS(6132),
    [anon_sym___attribute__] = ACTIONS(6132),
    [anon_sym_COLON_COLON] = ACTIONS(6134),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6134),
    [anon_sym___declspec] = ACTIONS(6132),
    [anon_sym___based] = ACTIONS(6132),
    [anon_sym___cdecl] = ACTIONS(6132),
    [anon_sym___clrcall] = ACTIONS(6132),
    [anon_sym___stdcall] = ACTIONS(6132),
    [anon_sym___fastcall] = ACTIONS(6132),
    [anon_sym___thiscall] = ACTIONS(6132),
    [anon_sym___vectorcall] = ACTIONS(6132),
    [anon_sym_LBRACK] = ACTIONS(6132),
    [anon_sym_static] = ACTIONS(6132),
    [anon_sym_EQ] = ACTIONS(6134),
    [anon_sym_register] = ACTIONS(6132),
    [anon_sym_inline] = ACTIONS(6132),
    [anon_sym___inline] = ACTIONS(6132),
    [anon_sym___inline__] = ACTIONS(6132),
    [anon_sym___forceinline] = ACTIONS(6132),
    [anon_sym_thread_local] = ACTIONS(6132),
    [anon_sym___thread] = ACTIONS(6132),
    [anon_sym_const] = ACTIONS(6132),
    [anon_sym_constexpr] = ACTIONS(6132),
    [anon_sym_volatile] = ACTIONS(6132),
    [anon_sym_restrict] = ACTIONS(6132),
    [anon_sym___restrict__] = ACTIONS(6132),
    [anon_sym__Atomic] = ACTIONS(6132),
    [anon_sym__Noreturn] = ACTIONS(6132),
    [anon_sym_noreturn] = ACTIONS(6132),
    [anon_sym_mutable] = ACTIONS(6132),
    [anon_sym_constinit] = ACTIONS(6132),
    [anon_sym_consteval] = ACTIONS(6132),
    [anon_sym_alignas] = ACTIONS(6132),
    [anon_sym__Alignas] = ACTIONS(6132),
    [anon_sym_asm] = ACTIONS(6132),
    [anon_sym___asm__] = ACTIONS(6132),
    [anon_sym_DASH_GT] = ACTIONS(6134),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(6132),
    [anon_sym_final] = ACTIONS(6132),
    [anon_sym_override] = ACTIONS(6132),
    [sym_virtual] = ACTIONS(6132),
    [anon_sym_explicit] = ACTIONS(6132),
    [anon_sym_template] = ACTIONS(6132),
    [anon_sym_GT2] = ACTIONS(6134),
    [anon_sym_operator] = ACTIONS(6132),
    [anon_sym_noexcept] = ACTIONS(6132),
    [anon_sym_throw] = ACTIONS(6132),
    [anon_sym_requires] = ACTIONS(6132),
    [anon_sym_precise] = ACTIONS(6132),
    [anon_sym_shared] = ACTIONS(6132),
    [anon_sym_groupshared] = ACTIONS(6132),
    [anon_sym_uniform] = ACTIONS(6132),
    [anon_sym_row_major] = ACTIONS(6132),
    [anon_sym_column_major] = ACTIONS(6132),
    [anon_sym_globallycoherent] = ACTIONS(6132),
    [anon_sym_centroid] = ACTIONS(6132),
    [anon_sym_noperspective] = ACTIONS(6132),
    [anon_sym_nointerpolation] = ACTIONS(6132),
    [anon_sym_sample] = ACTIONS(6132),
    [anon_sym_linear] = ACTIONS(6132),
    [anon_sym_snorm] = ACTIONS(6132),
    [anon_sym_unorm] = ACTIONS(6132),
    [anon_sym_point] = ACTIONS(6132),
    [anon_sym_line] = ACTIONS(6132),
    [anon_sym_triangleadj] = ACTIONS(6132),
    [anon_sym_lineadj] = ACTIONS(6132),
    [anon_sym_triangle] = ACTIONS(6132),
    [anon_sym_where] = ACTIONS(6132),
  },
  [2648] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2656),
    [sym_identifier] = ACTIONS(3771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3773),
    [anon_sym_COMMA] = ACTIONS(3773),
    [anon_sym_RPAREN] = ACTIONS(3773),
    [anon_sym_LPAREN2] = ACTIONS(3773),
    [anon_sym_TILDE] = ACTIONS(3773),
    [anon_sym_STAR] = ACTIONS(3773),
    [anon_sym_AMP_AMP] = ACTIONS(3773),
    [anon_sym_AMP] = ACTIONS(3771),
    [anon_sym_COLON] = ACTIONS(3771),
    [anon_sym_SEMI] = ACTIONS(3773),
    [anon_sym___extension__] = ACTIONS(3771),
    [anon_sym_in] = ACTIONS(3771),
    [anon_sym_out] = ACTIONS(3771),
    [anon_sym_inout] = ACTIONS(3771),
    [anon_sym_extern] = ACTIONS(3771),
    [anon_sym___attribute__] = ACTIONS(3771),
    [anon_sym_COLON_COLON] = ACTIONS(3773),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3773),
    [anon_sym___declspec] = ACTIONS(3771),
    [anon_sym___based] = ACTIONS(3771),
    [anon_sym___cdecl] = ACTIONS(3771),
    [anon_sym___clrcall] = ACTIONS(3771),
    [anon_sym___stdcall] = ACTIONS(3771),
    [anon_sym___fastcall] = ACTIONS(3771),
    [anon_sym___thiscall] = ACTIONS(3771),
    [anon_sym___vectorcall] = ACTIONS(3771),
    [anon_sym_LBRACE] = ACTIONS(3773),
    [anon_sym_signed] = ACTIONS(6244),
    [anon_sym_unsigned] = ACTIONS(6244),
    [anon_sym_long] = ACTIONS(6244),
    [anon_sym_short] = ACTIONS(6244),
    [anon_sym_LBRACK] = ACTIONS(3771),
    [anon_sym_static] = ACTIONS(3771),
    [anon_sym_EQ] = ACTIONS(3773),
    [anon_sym_register] = ACTIONS(3771),
    [anon_sym_inline] = ACTIONS(3771),
    [anon_sym___inline] = ACTIONS(3771),
    [anon_sym___inline__] = ACTIONS(3771),
    [anon_sym___forceinline] = ACTIONS(3771),
    [anon_sym_thread_local] = ACTIONS(3771),
    [anon_sym___thread] = ACTIONS(3771),
    [anon_sym_const] = ACTIONS(3771),
    [anon_sym_constexpr] = ACTIONS(3771),
    [anon_sym_volatile] = ACTIONS(3771),
    [anon_sym_restrict] = ACTIONS(3771),
    [anon_sym___restrict__] = ACTIONS(3771),
    [anon_sym__Atomic] = ACTIONS(3771),
    [anon_sym__Noreturn] = ACTIONS(3771),
    [anon_sym_noreturn] = ACTIONS(3771),
    [anon_sym_mutable] = ACTIONS(3771),
    [anon_sym_constinit] = ACTIONS(3771),
    [anon_sym_consteval] = ACTIONS(3771),
    [anon_sym_alignas] = ACTIONS(3771),
    [anon_sym__Alignas] = ACTIONS(3771),
    [anon_sym_DOT] = ACTIONS(3771),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3771),
    [anon_sym_let] = ACTIONS(3771),
    [anon_sym_This] = ACTIONS(3771),
    [anon_sym_decltype] = ACTIONS(3771),
    [sym_virtual] = ACTIONS(3771),
    [anon_sym_template] = ACTIONS(3771),
    [anon_sym_GT2] = ACTIONS(3773),
    [anon_sym_operator] = ACTIONS(3771),
    [anon_sym_precise] = ACTIONS(3771),
    [anon_sym_shared] = ACTIONS(3771),
    [anon_sym_groupshared] = ACTIONS(3771),
    [anon_sym_uniform] = ACTIONS(3771),
    [anon_sym_row_major] = ACTIONS(3771),
    [anon_sym_column_major] = ACTIONS(3771),
    [anon_sym_globallycoherent] = ACTIONS(3771),
    [anon_sym_centroid] = ACTIONS(3771),
    [anon_sym_noperspective] = ACTIONS(3771),
    [anon_sym_nointerpolation] = ACTIONS(3771),
    [anon_sym_sample] = ACTIONS(3771),
    [anon_sym_linear] = ACTIONS(3771),
    [anon_sym_snorm] = ACTIONS(3771),
    [anon_sym_unorm] = ACTIONS(3771),
    [anon_sym_point] = ACTIONS(3771),
    [anon_sym_line] = ACTIONS(3771),
    [anon_sym_triangleadj] = ACTIONS(3771),
    [anon_sym_lineadj] = ACTIONS(3771),
    [anon_sym_triangle] = ACTIONS(3771),
  },
  [2649] = {
    [sym_identifier] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [aux_sym_preproc_if_token2] = ACTIONS(2188),
    [aux_sym_preproc_else_token1] = ACTIONS(2188),
    [aux_sym_preproc_elif_token1] = ACTIONS(2186),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2188),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2188),
    [anon_sym_LPAREN2] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2186),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_STAR] = ACTIONS(2186),
    [anon_sym_SLASH] = ACTIONS(2186),
    [anon_sym_PERCENT] = ACTIONS(2186),
    [anon_sym_PIPE_PIPE] = ACTIONS(2188),
    [anon_sym_AMP_AMP] = ACTIONS(2188),
    [anon_sym_PIPE] = ACTIONS(2186),
    [anon_sym_CARET] = ACTIONS(2186),
    [anon_sym_AMP] = ACTIONS(2186),
    [anon_sym_EQ_EQ] = ACTIONS(2188),
    [anon_sym_BANG_EQ] = ACTIONS(2188),
    [anon_sym_GT] = ACTIONS(2186),
    [anon_sym_GT_EQ] = ACTIONS(2188),
    [anon_sym_LT_EQ] = ACTIONS(2186),
    [anon_sym_LT] = ACTIONS(2186),
    [anon_sym_LT_LT] = ACTIONS(2186),
    [anon_sym_GT_GT] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym___extension__] = ACTIONS(2186),
    [anon_sym___attribute__] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_RBRACE] = ACTIONS(2188),
    [anon_sym_LBRACK] = ACTIONS(2188),
    [anon_sym_RBRACK] = ACTIONS(2188),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_constexpr] = ACTIONS(2186),
    [anon_sym_volatile] = ACTIONS(2186),
    [anon_sym_restrict] = ACTIONS(2186),
    [anon_sym___restrict__] = ACTIONS(2186),
    [anon_sym__Atomic] = ACTIONS(2186),
    [anon_sym__Noreturn] = ACTIONS(2186),
    [anon_sym_noreturn] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_constinit] = ACTIONS(2186),
    [anon_sym_consteval] = ACTIONS(2186),
    [anon_sym_alignas] = ACTIONS(2186),
    [anon_sym__Alignas] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_STAR_EQ] = ACTIONS(2188),
    [anon_sym_SLASH_EQ] = ACTIONS(2188),
    [anon_sym_PERCENT_EQ] = ACTIONS(2188),
    [anon_sym_PLUS_EQ] = ACTIONS(2188),
    [anon_sym_DASH_EQ] = ACTIONS(2188),
    [anon_sym_LT_LT_EQ] = ACTIONS(2188),
    [anon_sym_GT_GT_EQ] = ACTIONS(2188),
    [anon_sym_AMP_EQ] = ACTIONS(2188),
    [anon_sym_CARET_EQ] = ACTIONS(2188),
    [anon_sym_PIPE_EQ] = ACTIONS(2188),
    [anon_sym_and_eq] = ACTIONS(2186),
    [anon_sym_or_eq] = ACTIONS(2186),
    [anon_sym_xor_eq] = ACTIONS(2186),
    [anon_sym_LT_EQ_GT] = ACTIONS(2188),
    [anon_sym_or] = ACTIONS(2186),
    [anon_sym_and] = ACTIONS(2186),
    [anon_sym_bitor] = ACTIONS(2186),
    [anon_sym_xor] = ACTIONS(2186),
    [anon_sym_bitand] = ACTIONS(2186),
    [anon_sym_not_eq] = ACTIONS(2186),
    [anon_sym_is] = ACTIONS(2186),
    [anon_sym_as] = ACTIONS(2186),
    [anon_sym_DASH_DASH] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2188),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOT_STAR] = ACTIONS(2188),
    [anon_sym_DASH_GT] = ACTIONS(2188),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_This] = ACTIONS(2186),
    [anon_sym_final] = ACTIONS(2186),
    [anon_sym_override] = ACTIONS(2186),
  },
  [2650] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2658),
    [sym_identifier] = ACTIONS(3810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3812),
    [anon_sym_COMMA] = ACTIONS(3812),
    [anon_sym_RPAREN] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3812),
    [anon_sym_TILDE] = ACTIONS(3812),
    [anon_sym_STAR] = ACTIONS(3812),
    [anon_sym_AMP_AMP] = ACTIONS(3812),
    [anon_sym_AMP] = ACTIONS(3810),
    [anon_sym_COLON] = ACTIONS(3810),
    [anon_sym_SEMI] = ACTIONS(3812),
    [anon_sym___extension__] = ACTIONS(3810),
    [anon_sym_in] = ACTIONS(3810),
    [anon_sym_out] = ACTIONS(3810),
    [anon_sym_inout] = ACTIONS(3810),
    [anon_sym_extern] = ACTIONS(3810),
    [anon_sym___attribute__] = ACTIONS(3810),
    [anon_sym_COLON_COLON] = ACTIONS(3812),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3812),
    [anon_sym___declspec] = ACTIONS(3810),
    [anon_sym___based] = ACTIONS(3810),
    [anon_sym___cdecl] = ACTIONS(3810),
    [anon_sym___clrcall] = ACTIONS(3810),
    [anon_sym___stdcall] = ACTIONS(3810),
    [anon_sym___fastcall] = ACTIONS(3810),
    [anon_sym___thiscall] = ACTIONS(3810),
    [anon_sym___vectorcall] = ACTIONS(3810),
    [anon_sym_LBRACE] = ACTIONS(3812),
    [anon_sym_signed] = ACTIONS(6242),
    [anon_sym_unsigned] = ACTIONS(6242),
    [anon_sym_long] = ACTIONS(6242),
    [anon_sym_short] = ACTIONS(6242),
    [anon_sym_LBRACK] = ACTIONS(3810),
    [anon_sym_static] = ACTIONS(3810),
    [anon_sym_EQ] = ACTIONS(3812),
    [anon_sym_register] = ACTIONS(3810),
    [anon_sym_inline] = ACTIONS(3810),
    [anon_sym___inline] = ACTIONS(3810),
    [anon_sym___inline__] = ACTIONS(3810),
    [anon_sym___forceinline] = ACTIONS(3810),
    [anon_sym_thread_local] = ACTIONS(3810),
    [anon_sym___thread] = ACTIONS(3810),
    [anon_sym_const] = ACTIONS(3810),
    [anon_sym_constexpr] = ACTIONS(3810),
    [anon_sym_volatile] = ACTIONS(3810),
    [anon_sym_restrict] = ACTIONS(3810),
    [anon_sym___restrict__] = ACTIONS(3810),
    [anon_sym__Atomic] = ACTIONS(3810),
    [anon_sym__Noreturn] = ACTIONS(3810),
    [anon_sym_noreturn] = ACTIONS(3810),
    [anon_sym_mutable] = ACTIONS(3810),
    [anon_sym_constinit] = ACTIONS(3810),
    [anon_sym_consteval] = ACTIONS(3810),
    [anon_sym_alignas] = ACTIONS(3810),
    [anon_sym__Alignas] = ACTIONS(3810),
    [anon_sym_DOT] = ACTIONS(3810),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3810),
    [anon_sym_let] = ACTIONS(3810),
    [anon_sym_This] = ACTIONS(3810),
    [anon_sym_decltype] = ACTIONS(3810),
    [sym_virtual] = ACTIONS(3810),
    [anon_sym_template] = ACTIONS(3810),
    [anon_sym_GT2] = ACTIONS(3812),
    [anon_sym_operator] = ACTIONS(3810),
    [anon_sym_precise] = ACTIONS(3810),
    [anon_sym_shared] = ACTIONS(3810),
    [anon_sym_groupshared] = ACTIONS(3810),
    [anon_sym_uniform] = ACTIONS(3810),
    [anon_sym_row_major] = ACTIONS(3810),
    [anon_sym_column_major] = ACTIONS(3810),
    [anon_sym_globallycoherent] = ACTIONS(3810),
    [anon_sym_centroid] = ACTIONS(3810),
    [anon_sym_noperspective] = ACTIONS(3810),
    [anon_sym_nointerpolation] = ACTIONS(3810),
    [anon_sym_sample] = ACTIONS(3810),
    [anon_sym_linear] = ACTIONS(3810),
    [anon_sym_snorm] = ACTIONS(3810),
    [anon_sym_unorm] = ACTIONS(3810),
    [anon_sym_point] = ACTIONS(3810),
    [anon_sym_line] = ACTIONS(3810),
    [anon_sym_triangleadj] = ACTIONS(3810),
    [anon_sym_lineadj] = ACTIONS(3810),
    [anon_sym_triangle] = ACTIONS(3810),
  },
  [2651] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2650),
    [sym_identifier] = ACTIONS(3764),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3766),
    [anon_sym_COMMA] = ACTIONS(3766),
    [anon_sym_RPAREN] = ACTIONS(3766),
    [anon_sym_LPAREN2] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_AMP_AMP] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3764),
    [anon_sym_COLON] = ACTIONS(3764),
    [anon_sym_SEMI] = ACTIONS(3766),
    [anon_sym___extension__] = ACTIONS(3764),
    [anon_sym_in] = ACTIONS(3764),
    [anon_sym_out] = ACTIONS(3764),
    [anon_sym_inout] = ACTIONS(3764),
    [anon_sym_extern] = ACTIONS(3764),
    [anon_sym___attribute__] = ACTIONS(3764),
    [anon_sym_COLON_COLON] = ACTIONS(3766),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3766),
    [anon_sym___declspec] = ACTIONS(3764),
    [anon_sym___based] = ACTIONS(3764),
    [anon_sym___cdecl] = ACTIONS(3764),
    [anon_sym___clrcall] = ACTIONS(3764),
    [anon_sym___stdcall] = ACTIONS(3764),
    [anon_sym___fastcall] = ACTIONS(3764),
    [anon_sym___thiscall] = ACTIONS(3764),
    [anon_sym___vectorcall] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3766),
    [anon_sym_signed] = ACTIONS(6246),
    [anon_sym_unsigned] = ACTIONS(6246),
    [anon_sym_long] = ACTIONS(6246),
    [anon_sym_short] = ACTIONS(6246),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_static] = ACTIONS(3764),
    [anon_sym_EQ] = ACTIONS(3766),
    [anon_sym_register] = ACTIONS(3764),
    [anon_sym_inline] = ACTIONS(3764),
    [anon_sym___inline] = ACTIONS(3764),
    [anon_sym___inline__] = ACTIONS(3764),
    [anon_sym___forceinline] = ACTIONS(3764),
    [anon_sym_thread_local] = ACTIONS(3764),
    [anon_sym___thread] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(3764),
    [anon_sym_constexpr] = ACTIONS(3764),
    [anon_sym_volatile] = ACTIONS(3764),
    [anon_sym_restrict] = ACTIONS(3764),
    [anon_sym___restrict__] = ACTIONS(3764),
    [anon_sym__Atomic] = ACTIONS(3764),
    [anon_sym__Noreturn] = ACTIONS(3764),
    [anon_sym_noreturn] = ACTIONS(3764),
    [anon_sym_mutable] = ACTIONS(3764),
    [anon_sym_constinit] = ACTIONS(3764),
    [anon_sym_consteval] = ACTIONS(3764),
    [anon_sym_alignas] = ACTIONS(3764),
    [anon_sym__Alignas] = ACTIONS(3764),
    [anon_sym_DOT] = ACTIONS(3764),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3764),
    [anon_sym_let] = ACTIONS(3764),
    [anon_sym_This] = ACTIONS(3764),
    [anon_sym_decltype] = ACTIONS(3764),
    [sym_virtual] = ACTIONS(3764),
    [anon_sym_template] = ACTIONS(3764),
    [anon_sym_GT2] = ACTIONS(3766),
    [anon_sym_operator] = ACTIONS(3764),
    [anon_sym_precise] = ACTIONS(3764),
    [anon_sym_shared] = ACTIONS(3764),
    [anon_sym_groupshared] = ACTIONS(3764),
    [anon_sym_uniform] = ACTIONS(3764),
    [anon_sym_row_major] = ACTIONS(3764),
    [anon_sym_column_major] = ACTIONS(3764),
    [anon_sym_globallycoherent] = ACTIONS(3764),
    [anon_sym_centroid] = ACTIONS(3764),
    [anon_sym_noperspective] = ACTIONS(3764),
    [anon_sym_nointerpolation] = ACTIONS(3764),
    [anon_sym_sample] = ACTIONS(3764),
    [anon_sym_linear] = ACTIONS(3764),
    [anon_sym_snorm] = ACTIONS(3764),
    [anon_sym_unorm] = ACTIONS(3764),
    [anon_sym_point] = ACTIONS(3764),
    [anon_sym_line] = ACTIONS(3764),
    [anon_sym_triangleadj] = ACTIONS(3764),
    [anon_sym_lineadj] = ACTIONS(3764),
    [anon_sym_triangle] = ACTIONS(3764),
  },
  [2652] = {
    [sym_identifier] = ACTIONS(2236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2238),
    [anon_sym_COMMA] = ACTIONS(2238),
    [anon_sym_RPAREN] = ACTIONS(2238),
    [aux_sym_preproc_if_token2] = ACTIONS(2238),
    [aux_sym_preproc_else_token1] = ACTIONS(2238),
    [aux_sym_preproc_elif_token1] = ACTIONS(2236),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2238),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2238),
    [anon_sym_LPAREN2] = ACTIONS(2238),
    [anon_sym_DASH] = ACTIONS(2236),
    [anon_sym_PLUS] = ACTIONS(2236),
    [anon_sym_STAR] = ACTIONS(2236),
    [anon_sym_SLASH] = ACTIONS(2236),
    [anon_sym_PERCENT] = ACTIONS(2236),
    [anon_sym_PIPE_PIPE] = ACTIONS(2238),
    [anon_sym_AMP_AMP] = ACTIONS(2238),
    [anon_sym_PIPE] = ACTIONS(2236),
    [anon_sym_CARET] = ACTIONS(2236),
    [anon_sym_AMP] = ACTIONS(2236),
    [anon_sym_EQ_EQ] = ACTIONS(2238),
    [anon_sym_BANG_EQ] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2236),
    [anon_sym_GT_EQ] = ACTIONS(2238),
    [anon_sym_LT_EQ] = ACTIONS(2236),
    [anon_sym_LT] = ACTIONS(2236),
    [anon_sym_LT_LT] = ACTIONS(2236),
    [anon_sym_GT_GT] = ACTIONS(2236),
    [anon_sym_COLON] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(2238),
    [anon_sym___extension__] = ACTIONS(2236),
    [anon_sym___attribute__] = ACTIONS(2236),
    [anon_sym_COLON_COLON] = ACTIONS(2238),
    [anon_sym_LBRACE] = ACTIONS(2238),
    [anon_sym_RBRACE] = ACTIONS(2238),
    [anon_sym_LBRACK] = ACTIONS(2238),
    [anon_sym_RBRACK] = ACTIONS(2238),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_const] = ACTIONS(2236),
    [anon_sym_constexpr] = ACTIONS(2236),
    [anon_sym_volatile] = ACTIONS(2236),
    [anon_sym_restrict] = ACTIONS(2236),
    [anon_sym___restrict__] = ACTIONS(2236),
    [anon_sym__Atomic] = ACTIONS(2236),
    [anon_sym__Noreturn] = ACTIONS(2236),
    [anon_sym_noreturn] = ACTIONS(2236),
    [anon_sym_mutable] = ACTIONS(2236),
    [anon_sym_constinit] = ACTIONS(2236),
    [anon_sym_consteval] = ACTIONS(2236),
    [anon_sym_alignas] = ACTIONS(2236),
    [anon_sym__Alignas] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2238),
    [anon_sym_SLASH_EQ] = ACTIONS(2238),
    [anon_sym_PERCENT_EQ] = ACTIONS(2238),
    [anon_sym_PLUS_EQ] = ACTIONS(2238),
    [anon_sym_DASH_EQ] = ACTIONS(2238),
    [anon_sym_LT_LT_EQ] = ACTIONS(2238),
    [anon_sym_GT_GT_EQ] = ACTIONS(2238),
    [anon_sym_AMP_EQ] = ACTIONS(2238),
    [anon_sym_CARET_EQ] = ACTIONS(2238),
    [anon_sym_PIPE_EQ] = ACTIONS(2238),
    [anon_sym_and_eq] = ACTIONS(2236),
    [anon_sym_or_eq] = ACTIONS(2236),
    [anon_sym_xor_eq] = ACTIONS(2236),
    [anon_sym_LT_EQ_GT] = ACTIONS(2238),
    [anon_sym_or] = ACTIONS(2236),
    [anon_sym_and] = ACTIONS(2236),
    [anon_sym_bitor] = ACTIONS(2236),
    [anon_sym_xor] = ACTIONS(2236),
    [anon_sym_bitand] = ACTIONS(2236),
    [anon_sym_not_eq] = ACTIONS(2236),
    [anon_sym_is] = ACTIONS(2236),
    [anon_sym_as] = ACTIONS(2236),
    [anon_sym_DASH_DASH] = ACTIONS(2238),
    [anon_sym_PLUS_PLUS] = ACTIONS(2238),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_DOT_STAR] = ACTIONS(2238),
    [anon_sym_DASH_GT] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2236),
    [anon_sym_let] = ACTIONS(2236),
    [anon_sym_This] = ACTIONS(2236),
    [anon_sym_final] = ACTIONS(2236),
    [anon_sym_override] = ACTIONS(2236),
  },
  [2653] = {
    [sym_identifier] = ACTIONS(2202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_RPAREN] = ACTIONS(2204),
    [aux_sym_preproc_if_token2] = ACTIONS(2204),
    [aux_sym_preproc_else_token1] = ACTIONS(2204),
    [aux_sym_preproc_elif_token1] = ACTIONS(2202),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2204),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2204),
    [anon_sym_LPAREN2] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2202),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_STAR] = ACTIONS(2202),
    [anon_sym_SLASH] = ACTIONS(2202),
    [anon_sym_PERCENT] = ACTIONS(2202),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2202),
    [anon_sym_CARET] = ACTIONS(2202),
    [anon_sym_AMP] = ACTIONS(2202),
    [anon_sym_EQ_EQ] = ACTIONS(2204),
    [anon_sym_BANG_EQ] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(2202),
    [anon_sym_GT_EQ] = ACTIONS(2204),
    [anon_sym_LT_EQ] = ACTIONS(2202),
    [anon_sym_LT] = ACTIONS(2202),
    [anon_sym_LT_LT] = ACTIONS(2202),
    [anon_sym_GT_GT] = ACTIONS(2202),
    [anon_sym_COLON] = ACTIONS(2202),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym___extension__] = ACTIONS(2202),
    [anon_sym___attribute__] = ACTIONS(2202),
    [anon_sym_COLON_COLON] = ACTIONS(2204),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(2204),
    [anon_sym_RBRACK] = ACTIONS(2204),
    [anon_sym_EQ] = ACTIONS(2202),
    [anon_sym_const] = ACTIONS(2202),
    [anon_sym_constexpr] = ACTIONS(2202),
    [anon_sym_volatile] = ACTIONS(2202),
    [anon_sym_restrict] = ACTIONS(2202),
    [anon_sym___restrict__] = ACTIONS(2202),
    [anon_sym__Atomic] = ACTIONS(2202),
    [anon_sym__Noreturn] = ACTIONS(2202),
    [anon_sym_noreturn] = ACTIONS(2202),
    [anon_sym_mutable] = ACTIONS(2202),
    [anon_sym_constinit] = ACTIONS(2202),
    [anon_sym_consteval] = ACTIONS(2202),
    [anon_sym_alignas] = ACTIONS(2202),
    [anon_sym__Alignas] = ACTIONS(2202),
    [anon_sym_QMARK] = ACTIONS(2204),
    [anon_sym_STAR_EQ] = ACTIONS(2204),
    [anon_sym_SLASH_EQ] = ACTIONS(2204),
    [anon_sym_PERCENT_EQ] = ACTIONS(2204),
    [anon_sym_PLUS_EQ] = ACTIONS(2204),
    [anon_sym_DASH_EQ] = ACTIONS(2204),
    [anon_sym_LT_LT_EQ] = ACTIONS(2204),
    [anon_sym_GT_GT_EQ] = ACTIONS(2204),
    [anon_sym_AMP_EQ] = ACTIONS(2204),
    [anon_sym_CARET_EQ] = ACTIONS(2204),
    [anon_sym_PIPE_EQ] = ACTIONS(2204),
    [anon_sym_and_eq] = ACTIONS(2202),
    [anon_sym_or_eq] = ACTIONS(2202),
    [anon_sym_xor_eq] = ACTIONS(2202),
    [anon_sym_LT_EQ_GT] = ACTIONS(2204),
    [anon_sym_or] = ACTIONS(2202),
    [anon_sym_and] = ACTIONS(2202),
    [anon_sym_bitor] = ACTIONS(2202),
    [anon_sym_xor] = ACTIONS(2202),
    [anon_sym_bitand] = ACTIONS(2202),
    [anon_sym_not_eq] = ACTIONS(2202),
    [anon_sym_is] = ACTIONS(2202),
    [anon_sym_as] = ACTIONS(2202),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(2202),
    [anon_sym_DOT_STAR] = ACTIONS(2204),
    [anon_sym_DASH_GT] = ACTIONS(2204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2202),
    [anon_sym_let] = ACTIONS(2202),
    [anon_sym_This] = ACTIONS(2202),
    [anon_sym_final] = ACTIONS(2202),
    [anon_sym_override] = ACTIONS(2202),
  },
  [2654] = {
    [sym_identifier] = ACTIONS(2190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2192),
    [anon_sym_COMMA] = ACTIONS(2192),
    [anon_sym_RPAREN] = ACTIONS(2192),
    [aux_sym_preproc_if_token2] = ACTIONS(2192),
    [aux_sym_preproc_else_token1] = ACTIONS(2192),
    [aux_sym_preproc_elif_token1] = ACTIONS(2190),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2192),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2192),
    [anon_sym_LPAREN2] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2190),
    [anon_sym_PLUS] = ACTIONS(2190),
    [anon_sym_STAR] = ACTIONS(2190),
    [anon_sym_SLASH] = ACTIONS(2190),
    [anon_sym_PERCENT] = ACTIONS(2190),
    [anon_sym_PIPE_PIPE] = ACTIONS(2192),
    [anon_sym_AMP_AMP] = ACTIONS(2192),
    [anon_sym_PIPE] = ACTIONS(2190),
    [anon_sym_CARET] = ACTIONS(2190),
    [anon_sym_AMP] = ACTIONS(2190),
    [anon_sym_EQ_EQ] = ACTIONS(2192),
    [anon_sym_BANG_EQ] = ACTIONS(2192),
    [anon_sym_GT] = ACTIONS(2190),
    [anon_sym_GT_EQ] = ACTIONS(2192),
    [anon_sym_LT_EQ] = ACTIONS(2190),
    [anon_sym_LT] = ACTIONS(2190),
    [anon_sym_LT_LT] = ACTIONS(2190),
    [anon_sym_GT_GT] = ACTIONS(2190),
    [anon_sym_COLON] = ACTIONS(2190),
    [anon_sym_SEMI] = ACTIONS(2192),
    [anon_sym___extension__] = ACTIONS(2190),
    [anon_sym___attribute__] = ACTIONS(2190),
    [anon_sym_COLON_COLON] = ACTIONS(2192),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [anon_sym_RBRACE] = ACTIONS(2192),
    [anon_sym_LBRACK] = ACTIONS(2192),
    [anon_sym_RBRACK] = ACTIONS(2192),
    [anon_sym_EQ] = ACTIONS(2190),
    [anon_sym_const] = ACTIONS(2190),
    [anon_sym_constexpr] = ACTIONS(2190),
    [anon_sym_volatile] = ACTIONS(2190),
    [anon_sym_restrict] = ACTIONS(2190),
    [anon_sym___restrict__] = ACTIONS(2190),
    [anon_sym__Atomic] = ACTIONS(2190),
    [anon_sym__Noreturn] = ACTIONS(2190),
    [anon_sym_noreturn] = ACTIONS(2190),
    [anon_sym_mutable] = ACTIONS(2190),
    [anon_sym_constinit] = ACTIONS(2190),
    [anon_sym_consteval] = ACTIONS(2190),
    [anon_sym_alignas] = ACTIONS(2190),
    [anon_sym__Alignas] = ACTIONS(2190),
    [anon_sym_QMARK] = ACTIONS(2192),
    [anon_sym_STAR_EQ] = ACTIONS(2192),
    [anon_sym_SLASH_EQ] = ACTIONS(2192),
    [anon_sym_PERCENT_EQ] = ACTIONS(2192),
    [anon_sym_PLUS_EQ] = ACTIONS(2192),
    [anon_sym_DASH_EQ] = ACTIONS(2192),
    [anon_sym_LT_LT_EQ] = ACTIONS(2192),
    [anon_sym_GT_GT_EQ] = ACTIONS(2192),
    [anon_sym_AMP_EQ] = ACTIONS(2192),
    [anon_sym_CARET_EQ] = ACTIONS(2192),
    [anon_sym_PIPE_EQ] = ACTIONS(2192),
    [anon_sym_and_eq] = ACTIONS(2190),
    [anon_sym_or_eq] = ACTIONS(2190),
    [anon_sym_xor_eq] = ACTIONS(2190),
    [anon_sym_LT_EQ_GT] = ACTIONS(2192),
    [anon_sym_or] = ACTIONS(2190),
    [anon_sym_and] = ACTIONS(2190),
    [anon_sym_bitor] = ACTIONS(2190),
    [anon_sym_xor] = ACTIONS(2190),
    [anon_sym_bitand] = ACTIONS(2190),
    [anon_sym_not_eq] = ACTIONS(2190),
    [anon_sym_is] = ACTIONS(2190),
    [anon_sym_as] = ACTIONS(2190),
    [anon_sym_DASH_DASH] = ACTIONS(2192),
    [anon_sym_PLUS_PLUS] = ACTIONS(2192),
    [anon_sym_DOT] = ACTIONS(2190),
    [anon_sym_DOT_STAR] = ACTIONS(2192),
    [anon_sym_DASH_GT] = ACTIONS(2192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2190),
    [anon_sym_let] = ACTIONS(2190),
    [anon_sym_This] = ACTIONS(2190),
    [anon_sym_final] = ACTIONS(2190),
    [anon_sym_override] = ACTIONS(2190),
  },
  [2655] = {
    [sym_identifier] = ACTIONS(2224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2226),
    [anon_sym_COMMA] = ACTIONS(2226),
    [anon_sym_RPAREN] = ACTIONS(2226),
    [aux_sym_preproc_if_token2] = ACTIONS(2226),
    [aux_sym_preproc_else_token1] = ACTIONS(2226),
    [aux_sym_preproc_elif_token1] = ACTIONS(2224),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2226),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2226),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_PLUS] = ACTIONS(2224),
    [anon_sym_STAR] = ACTIONS(2224),
    [anon_sym_SLASH] = ACTIONS(2224),
    [anon_sym_PERCENT] = ACTIONS(2224),
    [anon_sym_PIPE_PIPE] = ACTIONS(2226),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_PIPE] = ACTIONS(2224),
    [anon_sym_CARET] = ACTIONS(2224),
    [anon_sym_AMP] = ACTIONS(2224),
    [anon_sym_EQ_EQ] = ACTIONS(2226),
    [anon_sym_BANG_EQ] = ACTIONS(2226),
    [anon_sym_GT] = ACTIONS(2224),
    [anon_sym_GT_EQ] = ACTIONS(2226),
    [anon_sym_LT_EQ] = ACTIONS(2224),
    [anon_sym_LT] = ACTIONS(2224),
    [anon_sym_LT_LT] = ACTIONS(2224),
    [anon_sym_GT_GT] = ACTIONS(2224),
    [anon_sym_COLON] = ACTIONS(2224),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym___extension__] = ACTIONS(2224),
    [anon_sym___attribute__] = ACTIONS(2224),
    [anon_sym_COLON_COLON] = ACTIONS(2226),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_RBRACE] = ACTIONS(2226),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_RBRACK] = ACTIONS(2226),
    [anon_sym_EQ] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_constexpr] = ACTIONS(2224),
    [anon_sym_volatile] = ACTIONS(2224),
    [anon_sym_restrict] = ACTIONS(2224),
    [anon_sym___restrict__] = ACTIONS(2224),
    [anon_sym__Atomic] = ACTIONS(2224),
    [anon_sym__Noreturn] = ACTIONS(2224),
    [anon_sym_noreturn] = ACTIONS(2224),
    [anon_sym_mutable] = ACTIONS(2224),
    [anon_sym_constinit] = ACTIONS(2224),
    [anon_sym_consteval] = ACTIONS(2224),
    [anon_sym_alignas] = ACTIONS(2224),
    [anon_sym__Alignas] = ACTIONS(2224),
    [anon_sym_QMARK] = ACTIONS(2226),
    [anon_sym_STAR_EQ] = ACTIONS(2226),
    [anon_sym_SLASH_EQ] = ACTIONS(2226),
    [anon_sym_PERCENT_EQ] = ACTIONS(2226),
    [anon_sym_PLUS_EQ] = ACTIONS(2226),
    [anon_sym_DASH_EQ] = ACTIONS(2226),
    [anon_sym_LT_LT_EQ] = ACTIONS(2226),
    [anon_sym_GT_GT_EQ] = ACTIONS(2226),
    [anon_sym_AMP_EQ] = ACTIONS(2226),
    [anon_sym_CARET_EQ] = ACTIONS(2226),
    [anon_sym_PIPE_EQ] = ACTIONS(2226),
    [anon_sym_and_eq] = ACTIONS(2224),
    [anon_sym_or_eq] = ACTIONS(2224),
    [anon_sym_xor_eq] = ACTIONS(2224),
    [anon_sym_LT_EQ_GT] = ACTIONS(2226),
    [anon_sym_or] = ACTIONS(2224),
    [anon_sym_and] = ACTIONS(2224),
    [anon_sym_bitor] = ACTIONS(2224),
    [anon_sym_xor] = ACTIONS(2224),
    [anon_sym_bitand] = ACTIONS(2224),
    [anon_sym_not_eq] = ACTIONS(2224),
    [anon_sym_is] = ACTIONS(2224),
    [anon_sym_as] = ACTIONS(2224),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_DOT] = ACTIONS(2224),
    [anon_sym_DOT_STAR] = ACTIONS(2226),
    [anon_sym_DASH_GT] = ACTIONS(2226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2224),
    [anon_sym_let] = ACTIONS(2224),
    [anon_sym_This] = ACTIONS(2224),
    [anon_sym_final] = ACTIONS(2224),
    [anon_sym_override] = ACTIONS(2224),
  },
  [2656] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2658),
    [sym_identifier] = ACTIONS(3803),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3805),
    [anon_sym_COMMA] = ACTIONS(3805),
    [anon_sym_RPAREN] = ACTIONS(3805),
    [anon_sym_LPAREN2] = ACTIONS(3805),
    [anon_sym_TILDE] = ACTIONS(3805),
    [anon_sym_STAR] = ACTIONS(3805),
    [anon_sym_AMP_AMP] = ACTIONS(3805),
    [anon_sym_AMP] = ACTIONS(3803),
    [anon_sym_COLON] = ACTIONS(3803),
    [anon_sym_SEMI] = ACTIONS(3805),
    [anon_sym___extension__] = ACTIONS(3803),
    [anon_sym_in] = ACTIONS(3803),
    [anon_sym_out] = ACTIONS(3803),
    [anon_sym_inout] = ACTIONS(3803),
    [anon_sym_extern] = ACTIONS(3803),
    [anon_sym___attribute__] = ACTIONS(3803),
    [anon_sym_COLON_COLON] = ACTIONS(3805),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3805),
    [anon_sym___declspec] = ACTIONS(3803),
    [anon_sym___based] = ACTIONS(3803),
    [anon_sym___cdecl] = ACTIONS(3803),
    [anon_sym___clrcall] = ACTIONS(3803),
    [anon_sym___stdcall] = ACTIONS(3803),
    [anon_sym___fastcall] = ACTIONS(3803),
    [anon_sym___thiscall] = ACTIONS(3803),
    [anon_sym___vectorcall] = ACTIONS(3803),
    [anon_sym_LBRACE] = ACTIONS(3805),
    [anon_sym_signed] = ACTIONS(6242),
    [anon_sym_unsigned] = ACTIONS(6242),
    [anon_sym_long] = ACTIONS(6242),
    [anon_sym_short] = ACTIONS(6242),
    [anon_sym_LBRACK] = ACTIONS(3803),
    [anon_sym_static] = ACTIONS(3803),
    [anon_sym_EQ] = ACTIONS(3805),
    [anon_sym_register] = ACTIONS(3803),
    [anon_sym_inline] = ACTIONS(3803),
    [anon_sym___inline] = ACTIONS(3803),
    [anon_sym___inline__] = ACTIONS(3803),
    [anon_sym___forceinline] = ACTIONS(3803),
    [anon_sym_thread_local] = ACTIONS(3803),
    [anon_sym___thread] = ACTIONS(3803),
    [anon_sym_const] = ACTIONS(3803),
    [anon_sym_constexpr] = ACTIONS(3803),
    [anon_sym_volatile] = ACTIONS(3803),
    [anon_sym_restrict] = ACTIONS(3803),
    [anon_sym___restrict__] = ACTIONS(3803),
    [anon_sym__Atomic] = ACTIONS(3803),
    [anon_sym__Noreturn] = ACTIONS(3803),
    [anon_sym_noreturn] = ACTIONS(3803),
    [anon_sym_mutable] = ACTIONS(3803),
    [anon_sym_constinit] = ACTIONS(3803),
    [anon_sym_consteval] = ACTIONS(3803),
    [anon_sym_alignas] = ACTIONS(3803),
    [anon_sym__Alignas] = ACTIONS(3803),
    [anon_sym_DOT] = ACTIONS(3803),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3803),
    [anon_sym_let] = ACTIONS(3803),
    [anon_sym_This] = ACTIONS(3803),
    [anon_sym_decltype] = ACTIONS(3803),
    [sym_virtual] = ACTIONS(3803),
    [anon_sym_template] = ACTIONS(3803),
    [anon_sym_GT2] = ACTIONS(3805),
    [anon_sym_operator] = ACTIONS(3803),
    [anon_sym_precise] = ACTIONS(3803),
    [anon_sym_shared] = ACTIONS(3803),
    [anon_sym_groupshared] = ACTIONS(3803),
    [anon_sym_uniform] = ACTIONS(3803),
    [anon_sym_row_major] = ACTIONS(3803),
    [anon_sym_column_major] = ACTIONS(3803),
    [anon_sym_globallycoherent] = ACTIONS(3803),
    [anon_sym_centroid] = ACTIONS(3803),
    [anon_sym_noperspective] = ACTIONS(3803),
    [anon_sym_nointerpolation] = ACTIONS(3803),
    [anon_sym_sample] = ACTIONS(3803),
    [anon_sym_linear] = ACTIONS(3803),
    [anon_sym_snorm] = ACTIONS(3803),
    [anon_sym_unorm] = ACTIONS(3803),
    [anon_sym_point] = ACTIONS(3803),
    [anon_sym_line] = ACTIONS(3803),
    [anon_sym_triangleadj] = ACTIONS(3803),
    [anon_sym_lineadj] = ACTIONS(3803),
    [anon_sym_triangle] = ACTIONS(3803),
  },
  [2657] = {
    [sym_identifier] = ACTIONS(2248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_RPAREN] = ACTIONS(2250),
    [aux_sym_preproc_if_token2] = ACTIONS(2250),
    [aux_sym_preproc_else_token1] = ACTIONS(2250),
    [aux_sym_preproc_elif_token1] = ACTIONS(2248),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2250),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2248),
    [anon_sym_PLUS] = ACTIONS(2248),
    [anon_sym_STAR] = ACTIONS(2248),
    [anon_sym_SLASH] = ACTIONS(2248),
    [anon_sym_PERCENT] = ACTIONS(2248),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2248),
    [anon_sym_EQ_EQ] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_GT] = ACTIONS(2248),
    [anon_sym_GT_EQ] = ACTIONS(2250),
    [anon_sym_LT_EQ] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_LT_LT] = ACTIONS(2248),
    [anon_sym_GT_GT] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2248),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym___extension__] = ACTIONS(2248),
    [anon_sym___attribute__] = ACTIONS(2248),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_RBRACK] = ACTIONS(2250),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_const] = ACTIONS(2248),
    [anon_sym_constexpr] = ACTIONS(2248),
    [anon_sym_volatile] = ACTIONS(2248),
    [anon_sym_restrict] = ACTIONS(2248),
    [anon_sym___restrict__] = ACTIONS(2248),
    [anon_sym__Atomic] = ACTIONS(2248),
    [anon_sym__Noreturn] = ACTIONS(2248),
    [anon_sym_noreturn] = ACTIONS(2248),
    [anon_sym_mutable] = ACTIONS(2248),
    [anon_sym_constinit] = ACTIONS(2248),
    [anon_sym_consteval] = ACTIONS(2248),
    [anon_sym_alignas] = ACTIONS(2248),
    [anon_sym__Alignas] = ACTIONS(2248),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_STAR_EQ] = ACTIONS(2250),
    [anon_sym_SLASH_EQ] = ACTIONS(2250),
    [anon_sym_PERCENT_EQ] = ACTIONS(2250),
    [anon_sym_PLUS_EQ] = ACTIONS(2250),
    [anon_sym_DASH_EQ] = ACTIONS(2250),
    [anon_sym_LT_LT_EQ] = ACTIONS(2250),
    [anon_sym_GT_GT_EQ] = ACTIONS(2250),
    [anon_sym_AMP_EQ] = ACTIONS(2250),
    [anon_sym_CARET_EQ] = ACTIONS(2250),
    [anon_sym_PIPE_EQ] = ACTIONS(2250),
    [anon_sym_and_eq] = ACTIONS(2248),
    [anon_sym_or_eq] = ACTIONS(2248),
    [anon_sym_xor_eq] = ACTIONS(2248),
    [anon_sym_LT_EQ_GT] = ACTIONS(2250),
    [anon_sym_or] = ACTIONS(2248),
    [anon_sym_and] = ACTIONS(2248),
    [anon_sym_bitor] = ACTIONS(2248),
    [anon_sym_xor] = ACTIONS(2248),
    [anon_sym_bitand] = ACTIONS(2248),
    [anon_sym_not_eq] = ACTIONS(2248),
    [anon_sym_is] = ACTIONS(2248),
    [anon_sym_as] = ACTIONS(2248),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2248),
    [anon_sym_DOT_STAR] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2248),
    [anon_sym_let] = ACTIONS(2248),
    [anon_sym_This] = ACTIONS(2248),
    [anon_sym_final] = ACTIONS(2248),
    [anon_sym_override] = ACTIONS(2248),
  },
  [2658] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2658),
    [sym_identifier] = ACTIONS(2856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2854),
    [anon_sym_COMMA] = ACTIONS(2854),
    [anon_sym_RPAREN] = ACTIONS(2854),
    [anon_sym_LPAREN2] = ACTIONS(2854),
    [anon_sym_TILDE] = ACTIONS(2854),
    [anon_sym_STAR] = ACTIONS(2854),
    [anon_sym_AMP_AMP] = ACTIONS(2854),
    [anon_sym_AMP] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2856),
    [anon_sym_SEMI] = ACTIONS(2854),
    [anon_sym___extension__] = ACTIONS(2856),
    [anon_sym_in] = ACTIONS(2856),
    [anon_sym_out] = ACTIONS(2856),
    [anon_sym_inout] = ACTIONS(2856),
    [anon_sym_extern] = ACTIONS(2856),
    [anon_sym___attribute__] = ACTIONS(2856),
    [anon_sym_COLON_COLON] = ACTIONS(2854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2854),
    [anon_sym___declspec] = ACTIONS(2856),
    [anon_sym___based] = ACTIONS(2856),
    [anon_sym___cdecl] = ACTIONS(2856),
    [anon_sym___clrcall] = ACTIONS(2856),
    [anon_sym___stdcall] = ACTIONS(2856),
    [anon_sym___fastcall] = ACTIONS(2856),
    [anon_sym___thiscall] = ACTIONS(2856),
    [anon_sym___vectorcall] = ACTIONS(2856),
    [anon_sym_LBRACE] = ACTIONS(2854),
    [anon_sym_signed] = ACTIONS(6248),
    [anon_sym_unsigned] = ACTIONS(6248),
    [anon_sym_long] = ACTIONS(6248),
    [anon_sym_short] = ACTIONS(6248),
    [anon_sym_LBRACK] = ACTIONS(2856),
    [anon_sym_static] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(2854),
    [anon_sym_register] = ACTIONS(2856),
    [anon_sym_inline] = ACTIONS(2856),
    [anon_sym___inline] = ACTIONS(2856),
    [anon_sym___inline__] = ACTIONS(2856),
    [anon_sym___forceinline] = ACTIONS(2856),
    [anon_sym_thread_local] = ACTIONS(2856),
    [anon_sym___thread] = ACTIONS(2856),
    [anon_sym_const] = ACTIONS(2856),
    [anon_sym_constexpr] = ACTIONS(2856),
    [anon_sym_volatile] = ACTIONS(2856),
    [anon_sym_restrict] = ACTIONS(2856),
    [anon_sym___restrict__] = ACTIONS(2856),
    [anon_sym__Atomic] = ACTIONS(2856),
    [anon_sym__Noreturn] = ACTIONS(2856),
    [anon_sym_noreturn] = ACTIONS(2856),
    [anon_sym_mutable] = ACTIONS(2856),
    [anon_sym_constinit] = ACTIONS(2856),
    [anon_sym_consteval] = ACTIONS(2856),
    [anon_sym_alignas] = ACTIONS(2856),
    [anon_sym__Alignas] = ACTIONS(2856),
    [anon_sym_DOT] = ACTIONS(2856),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2856),
    [anon_sym_let] = ACTIONS(2856),
    [anon_sym_This] = ACTIONS(2856),
    [anon_sym_decltype] = ACTIONS(2856),
    [sym_virtual] = ACTIONS(2856),
    [anon_sym_template] = ACTIONS(2856),
    [anon_sym_GT2] = ACTIONS(2854),
    [anon_sym_operator] = ACTIONS(2856),
    [anon_sym_precise] = ACTIONS(2856),
    [anon_sym_shared] = ACTIONS(2856),
    [anon_sym_groupshared] = ACTIONS(2856),
    [anon_sym_uniform] = ACTIONS(2856),
    [anon_sym_row_major] = ACTIONS(2856),
    [anon_sym_column_major] = ACTIONS(2856),
    [anon_sym_globallycoherent] = ACTIONS(2856),
    [anon_sym_centroid] = ACTIONS(2856),
    [anon_sym_noperspective] = ACTIONS(2856),
    [anon_sym_nointerpolation] = ACTIONS(2856),
    [anon_sym_sample] = ACTIONS(2856),
    [anon_sym_linear] = ACTIONS(2856),
    [anon_sym_snorm] = ACTIONS(2856),
    [anon_sym_unorm] = ACTIONS(2856),
    [anon_sym_point] = ACTIONS(2856),
    [anon_sym_line] = ACTIONS(2856),
    [anon_sym_triangleadj] = ACTIONS(2856),
    [anon_sym_lineadj] = ACTIONS(2856),
    [anon_sym_triangle] = ACTIONS(2856),
  },
  [2659] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2661),
    [sym_identifier] = ACTIONS(3392),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3390),
    [anon_sym_COMMA] = ACTIONS(3390),
    [anon_sym_RPAREN] = ACTIONS(3390),
    [anon_sym_LPAREN2] = ACTIONS(3390),
    [anon_sym_TILDE] = ACTIONS(3390),
    [anon_sym_STAR] = ACTIONS(3390),
    [anon_sym_AMP_AMP] = ACTIONS(3390),
    [anon_sym_AMP] = ACTIONS(3392),
    [anon_sym_COLON] = ACTIONS(3392),
    [anon_sym_SEMI] = ACTIONS(3390),
    [anon_sym___extension__] = ACTIONS(3392),
    [anon_sym_in] = ACTIONS(3392),
    [anon_sym_out] = ACTIONS(3392),
    [anon_sym_inout] = ACTIONS(3392),
    [anon_sym_extern] = ACTIONS(3392),
    [anon_sym___attribute__] = ACTIONS(3392),
    [anon_sym_COLON_COLON] = ACTIONS(3390),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3390),
    [anon_sym___declspec] = ACTIONS(3392),
    [anon_sym___based] = ACTIONS(3392),
    [anon_sym___cdecl] = ACTIONS(3392),
    [anon_sym___clrcall] = ACTIONS(3392),
    [anon_sym___stdcall] = ACTIONS(3392),
    [anon_sym___fastcall] = ACTIONS(3392),
    [anon_sym___thiscall] = ACTIONS(3392),
    [anon_sym___vectorcall] = ACTIONS(3392),
    [anon_sym_LBRACE] = ACTIONS(3390),
    [anon_sym_signed] = ACTIONS(6251),
    [anon_sym_unsigned] = ACTIONS(6251),
    [anon_sym_long] = ACTIONS(6251),
    [anon_sym_short] = ACTIONS(6251),
    [anon_sym_LBRACK] = ACTIONS(3392),
    [anon_sym_static] = ACTIONS(3392),
    [anon_sym_EQ] = ACTIONS(3390),
    [anon_sym_register] = ACTIONS(3392),
    [anon_sym_inline] = ACTIONS(3392),
    [anon_sym___inline] = ACTIONS(3392),
    [anon_sym___inline__] = ACTIONS(3392),
    [anon_sym___forceinline] = ACTIONS(3392),
    [anon_sym_thread_local] = ACTIONS(3392),
    [anon_sym___thread] = ACTIONS(3392),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_constexpr] = ACTIONS(3392),
    [anon_sym_volatile] = ACTIONS(3392),
    [anon_sym_restrict] = ACTIONS(3392),
    [anon_sym___restrict__] = ACTIONS(3392),
    [anon_sym__Atomic] = ACTIONS(3392),
    [anon_sym__Noreturn] = ACTIONS(3392),
    [anon_sym_noreturn] = ACTIONS(3392),
    [anon_sym_mutable] = ACTIONS(3392),
    [anon_sym_constinit] = ACTIONS(3392),
    [anon_sym_consteval] = ACTIONS(3392),
    [anon_sym_alignas] = ACTIONS(3392),
    [anon_sym__Alignas] = ACTIONS(3392),
    [anon_sym_DOT] = ACTIONS(3392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3392),
    [anon_sym_let] = ACTIONS(3392),
    [anon_sym_This] = ACTIONS(3392),
    [anon_sym_decltype] = ACTIONS(3392),
    [sym_virtual] = ACTIONS(3392),
    [anon_sym_template] = ACTIONS(3392),
    [anon_sym_GT2] = ACTIONS(3390),
    [anon_sym_operator] = ACTIONS(3392),
    [anon_sym_precise] = ACTIONS(3392),
    [anon_sym_shared] = ACTIONS(3392),
    [anon_sym_groupshared] = ACTIONS(3392),
    [anon_sym_uniform] = ACTIONS(3392),
    [anon_sym_row_major] = ACTIONS(3392),
    [anon_sym_column_major] = ACTIONS(3392),
    [anon_sym_globallycoherent] = ACTIONS(3392),
    [anon_sym_centroid] = ACTIONS(3392),
    [anon_sym_noperspective] = ACTIONS(3392),
    [anon_sym_nointerpolation] = ACTIONS(3392),
    [anon_sym_sample] = ACTIONS(3392),
    [anon_sym_linear] = ACTIONS(3392),
    [anon_sym_snorm] = ACTIONS(3392),
    [anon_sym_unorm] = ACTIONS(3392),
    [anon_sym_point] = ACTIONS(3392),
    [anon_sym_line] = ACTIONS(3392),
    [anon_sym_triangleadj] = ACTIONS(3392),
    [anon_sym_lineadj] = ACTIONS(3392),
    [anon_sym_triangle] = ACTIONS(3392),
  },
  [2660] = {
    [sym_identifier] = ACTIONS(2240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2242),
    [anon_sym_RPAREN] = ACTIONS(2242),
    [aux_sym_preproc_if_token2] = ACTIONS(2242),
    [aux_sym_preproc_else_token1] = ACTIONS(2242),
    [aux_sym_preproc_elif_token1] = ACTIONS(2240),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2242),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2240),
    [anon_sym_PLUS] = ACTIONS(2240),
    [anon_sym_STAR] = ACTIONS(2240),
    [anon_sym_SLASH] = ACTIONS(2240),
    [anon_sym_PERCENT] = ACTIONS(2240),
    [anon_sym_PIPE_PIPE] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_PIPE] = ACTIONS(2240),
    [anon_sym_CARET] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2240),
    [anon_sym_EQ_EQ] = ACTIONS(2242),
    [anon_sym_BANG_EQ] = ACTIONS(2242),
    [anon_sym_GT] = ACTIONS(2240),
    [anon_sym_GT_EQ] = ACTIONS(2242),
    [anon_sym_LT_EQ] = ACTIONS(2240),
    [anon_sym_LT] = ACTIONS(2240),
    [anon_sym_LT_LT] = ACTIONS(2240),
    [anon_sym_GT_GT] = ACTIONS(2240),
    [anon_sym_COLON] = ACTIONS(2240),
    [anon_sym_SEMI] = ACTIONS(2242),
    [anon_sym___extension__] = ACTIONS(2240),
    [anon_sym___attribute__] = ACTIONS(2240),
    [anon_sym_COLON_COLON] = ACTIONS(2242),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_RBRACE] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_RBRACK] = ACTIONS(2242),
    [anon_sym_EQ] = ACTIONS(2240),
    [anon_sym_const] = ACTIONS(2240),
    [anon_sym_constexpr] = ACTIONS(2240),
    [anon_sym_volatile] = ACTIONS(2240),
    [anon_sym_restrict] = ACTIONS(2240),
    [anon_sym___restrict__] = ACTIONS(2240),
    [anon_sym__Atomic] = ACTIONS(2240),
    [anon_sym__Noreturn] = ACTIONS(2240),
    [anon_sym_noreturn] = ACTIONS(2240),
    [anon_sym_mutable] = ACTIONS(2240),
    [anon_sym_constinit] = ACTIONS(2240),
    [anon_sym_consteval] = ACTIONS(2240),
    [anon_sym_alignas] = ACTIONS(2240),
    [anon_sym__Alignas] = ACTIONS(2240),
    [anon_sym_QMARK] = ACTIONS(2242),
    [anon_sym_STAR_EQ] = ACTIONS(2242),
    [anon_sym_SLASH_EQ] = ACTIONS(2242),
    [anon_sym_PERCENT_EQ] = ACTIONS(2242),
    [anon_sym_PLUS_EQ] = ACTIONS(2242),
    [anon_sym_DASH_EQ] = ACTIONS(2242),
    [anon_sym_LT_LT_EQ] = ACTIONS(2242),
    [anon_sym_GT_GT_EQ] = ACTIONS(2242),
    [anon_sym_AMP_EQ] = ACTIONS(2242),
    [anon_sym_CARET_EQ] = ACTIONS(2242),
    [anon_sym_PIPE_EQ] = ACTIONS(2242),
    [anon_sym_and_eq] = ACTIONS(2240),
    [anon_sym_or_eq] = ACTIONS(2240),
    [anon_sym_xor_eq] = ACTIONS(2240),
    [anon_sym_LT_EQ_GT] = ACTIONS(2242),
    [anon_sym_or] = ACTIONS(2240),
    [anon_sym_and] = ACTIONS(2240),
    [anon_sym_bitor] = ACTIONS(2240),
    [anon_sym_xor] = ACTIONS(2240),
    [anon_sym_bitand] = ACTIONS(2240),
    [anon_sym_not_eq] = ACTIONS(2240),
    [anon_sym_is] = ACTIONS(2240),
    [anon_sym_as] = ACTIONS(2240),
    [anon_sym_DASH_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_PLUS] = ACTIONS(2242),
    [anon_sym_DOT] = ACTIONS(2240),
    [anon_sym_DOT_STAR] = ACTIONS(2242),
    [anon_sym_DASH_GT] = ACTIONS(2242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2240),
    [anon_sym_let] = ACTIONS(2240),
    [anon_sym_This] = ACTIONS(2240),
    [anon_sym_final] = ACTIONS(2240),
    [anon_sym_override] = ACTIONS(2240),
  },
  [2661] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2658),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3752),
    [anon_sym_COMMA] = ACTIONS(3752),
    [anon_sym_RPAREN] = ACTIONS(3752),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_TILDE] = ACTIONS(3752),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_AMP_AMP] = ACTIONS(3752),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_COLON] = ACTIONS(3750),
    [anon_sym_SEMI] = ACTIONS(3752),
    [anon_sym___extension__] = ACTIONS(3750),
    [anon_sym_in] = ACTIONS(3750),
    [anon_sym_out] = ACTIONS(3750),
    [anon_sym_inout] = ACTIONS(3750),
    [anon_sym_extern] = ACTIONS(3750),
    [anon_sym___attribute__] = ACTIONS(3750),
    [anon_sym_COLON_COLON] = ACTIONS(3752),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3752),
    [anon_sym___declspec] = ACTIONS(3750),
    [anon_sym___based] = ACTIONS(3750),
    [anon_sym___cdecl] = ACTIONS(3750),
    [anon_sym___clrcall] = ACTIONS(3750),
    [anon_sym___stdcall] = ACTIONS(3750),
    [anon_sym___fastcall] = ACTIONS(3750),
    [anon_sym___thiscall] = ACTIONS(3750),
    [anon_sym___vectorcall] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(3752),
    [anon_sym_signed] = ACTIONS(6242),
    [anon_sym_unsigned] = ACTIONS(6242),
    [anon_sym_long] = ACTIONS(6242),
    [anon_sym_short] = ACTIONS(6242),
    [anon_sym_LBRACK] = ACTIONS(3750),
    [anon_sym_static] = ACTIONS(3750),
    [anon_sym_EQ] = ACTIONS(3752),
    [anon_sym_register] = ACTIONS(3750),
    [anon_sym_inline] = ACTIONS(3750),
    [anon_sym___inline] = ACTIONS(3750),
    [anon_sym___inline__] = ACTIONS(3750),
    [anon_sym___forceinline] = ACTIONS(3750),
    [anon_sym_thread_local] = ACTIONS(3750),
    [anon_sym___thread] = ACTIONS(3750),
    [anon_sym_const] = ACTIONS(3750),
    [anon_sym_constexpr] = ACTIONS(3750),
    [anon_sym_volatile] = ACTIONS(3750),
    [anon_sym_restrict] = ACTIONS(3750),
    [anon_sym___restrict__] = ACTIONS(3750),
    [anon_sym__Atomic] = ACTIONS(3750),
    [anon_sym__Noreturn] = ACTIONS(3750),
    [anon_sym_noreturn] = ACTIONS(3750),
    [anon_sym_mutable] = ACTIONS(3750),
    [anon_sym_constinit] = ACTIONS(3750),
    [anon_sym_consteval] = ACTIONS(3750),
    [anon_sym_alignas] = ACTIONS(3750),
    [anon_sym__Alignas] = ACTIONS(3750),
    [anon_sym_DOT] = ACTIONS(3750),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3750),
    [anon_sym_let] = ACTIONS(3750),
    [anon_sym_This] = ACTIONS(3750),
    [anon_sym_decltype] = ACTIONS(3750),
    [sym_virtual] = ACTIONS(3750),
    [anon_sym_template] = ACTIONS(3750),
    [anon_sym_GT2] = ACTIONS(3752),
    [anon_sym_operator] = ACTIONS(3750),
    [anon_sym_precise] = ACTIONS(3750),
    [anon_sym_shared] = ACTIONS(3750),
    [anon_sym_groupshared] = ACTIONS(3750),
    [anon_sym_uniform] = ACTIONS(3750),
    [anon_sym_row_major] = ACTIONS(3750),
    [anon_sym_column_major] = ACTIONS(3750),
    [anon_sym_globallycoherent] = ACTIONS(3750),
    [anon_sym_centroid] = ACTIONS(3750),
    [anon_sym_noperspective] = ACTIONS(3750),
    [anon_sym_nointerpolation] = ACTIONS(3750),
    [anon_sym_sample] = ACTIONS(3750),
    [anon_sym_linear] = ACTIONS(3750),
    [anon_sym_snorm] = ACTIONS(3750),
    [anon_sym_unorm] = ACTIONS(3750),
    [anon_sym_point] = ACTIONS(3750),
    [anon_sym_line] = ACTIONS(3750),
    [anon_sym_triangleadj] = ACTIONS(3750),
    [anon_sym_lineadj] = ACTIONS(3750),
    [anon_sym_triangle] = ACTIONS(3750),
  },
  [2662] = {
    [sym_identifier] = ACTIONS(2194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2196),
    [anon_sym_COMMA] = ACTIONS(2196),
    [anon_sym_RPAREN] = ACTIONS(2196),
    [aux_sym_preproc_if_token2] = ACTIONS(2196),
    [aux_sym_preproc_else_token1] = ACTIONS(2196),
    [aux_sym_preproc_elif_token1] = ACTIONS(2194),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2196),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2196),
    [anon_sym_LPAREN2] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2194),
    [anon_sym_PLUS] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(2194),
    [anon_sym_SLASH] = ACTIONS(2194),
    [anon_sym_PERCENT] = ACTIONS(2194),
    [anon_sym_PIPE_PIPE] = ACTIONS(2196),
    [anon_sym_AMP_AMP] = ACTIONS(2196),
    [anon_sym_PIPE] = ACTIONS(2194),
    [anon_sym_CARET] = ACTIONS(2194),
    [anon_sym_AMP] = ACTIONS(2194),
    [anon_sym_EQ_EQ] = ACTIONS(2196),
    [anon_sym_BANG_EQ] = ACTIONS(2196),
    [anon_sym_GT] = ACTIONS(2194),
    [anon_sym_GT_EQ] = ACTIONS(2196),
    [anon_sym_LT_EQ] = ACTIONS(2194),
    [anon_sym_LT] = ACTIONS(2194),
    [anon_sym_LT_LT] = ACTIONS(2194),
    [anon_sym_GT_GT] = ACTIONS(2194),
    [anon_sym_COLON] = ACTIONS(2194),
    [anon_sym_SEMI] = ACTIONS(2196),
    [anon_sym___extension__] = ACTIONS(2194),
    [anon_sym___attribute__] = ACTIONS(2194),
    [anon_sym_COLON_COLON] = ACTIONS(2196),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_RBRACE] = ACTIONS(2196),
    [anon_sym_LBRACK] = ACTIONS(2196),
    [anon_sym_RBRACK] = ACTIONS(2196),
    [anon_sym_EQ] = ACTIONS(2194),
    [anon_sym_const] = ACTIONS(2194),
    [anon_sym_constexpr] = ACTIONS(2194),
    [anon_sym_volatile] = ACTIONS(2194),
    [anon_sym_restrict] = ACTIONS(2194),
    [anon_sym___restrict__] = ACTIONS(2194),
    [anon_sym__Atomic] = ACTIONS(2194),
    [anon_sym__Noreturn] = ACTIONS(2194),
    [anon_sym_noreturn] = ACTIONS(2194),
    [anon_sym_mutable] = ACTIONS(2194),
    [anon_sym_constinit] = ACTIONS(2194),
    [anon_sym_consteval] = ACTIONS(2194),
    [anon_sym_alignas] = ACTIONS(2194),
    [anon_sym__Alignas] = ACTIONS(2194),
    [anon_sym_QMARK] = ACTIONS(2196),
    [anon_sym_STAR_EQ] = ACTIONS(2196),
    [anon_sym_SLASH_EQ] = ACTIONS(2196),
    [anon_sym_PERCENT_EQ] = ACTIONS(2196),
    [anon_sym_PLUS_EQ] = ACTIONS(2196),
    [anon_sym_DASH_EQ] = ACTIONS(2196),
    [anon_sym_LT_LT_EQ] = ACTIONS(2196),
    [anon_sym_GT_GT_EQ] = ACTIONS(2196),
    [anon_sym_AMP_EQ] = ACTIONS(2196),
    [anon_sym_CARET_EQ] = ACTIONS(2196),
    [anon_sym_PIPE_EQ] = ACTIONS(2196),
    [anon_sym_and_eq] = ACTIONS(2194),
    [anon_sym_or_eq] = ACTIONS(2194),
    [anon_sym_xor_eq] = ACTIONS(2194),
    [anon_sym_LT_EQ_GT] = ACTIONS(2196),
    [anon_sym_or] = ACTIONS(2194),
    [anon_sym_and] = ACTIONS(2194),
    [anon_sym_bitor] = ACTIONS(2194),
    [anon_sym_xor] = ACTIONS(2194),
    [anon_sym_bitand] = ACTIONS(2194),
    [anon_sym_not_eq] = ACTIONS(2194),
    [anon_sym_is] = ACTIONS(2194),
    [anon_sym_as] = ACTIONS(2194),
    [anon_sym_DASH_DASH] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2196),
    [anon_sym_DOT] = ACTIONS(2194),
    [anon_sym_DOT_STAR] = ACTIONS(2196),
    [anon_sym_DASH_GT] = ACTIONS(2196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2194),
    [anon_sym_let] = ACTIONS(2194),
    [anon_sym_This] = ACTIONS(2194),
    [anon_sym_final] = ACTIONS(2194),
    [anon_sym_override] = ACTIONS(2194),
  },
  [2663] = {
    [sym_identifier] = ACTIONS(6232),
    [anon_sym_LPAREN2] = ACTIONS(6234),
    [anon_sym_STAR] = ACTIONS(6234),
    [anon_sym_AMP_AMP] = ACTIONS(6234),
    [anon_sym_AMP] = ACTIONS(6236),
    [anon_sym_LT] = ACTIONS(6234),
    [anon_sym___extension__] = ACTIONS(6232),
    [anon_sym_in] = ACTIONS(6232),
    [anon_sym_out] = ACTIONS(6232),
    [anon_sym_inout] = ACTIONS(6232),
    [anon_sym_extern] = ACTIONS(6232),
    [anon_sym___attribute__] = ACTIONS(6232),
    [anon_sym_COLON_COLON] = ACTIONS(6238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6238),
    [anon_sym___declspec] = ACTIONS(6232),
    [anon_sym___cdecl] = ACTIONS(6232),
    [anon_sym___clrcall] = ACTIONS(6232),
    [anon_sym___stdcall] = ACTIONS(6232),
    [anon_sym___fastcall] = ACTIONS(6232),
    [anon_sym___thiscall] = ACTIONS(6232),
    [anon_sym___vectorcall] = ACTIONS(6232),
    [anon_sym_LBRACE] = ACTIONS(6234),
    [anon_sym_signed] = ACTIONS(6232),
    [anon_sym_unsigned] = ACTIONS(6232),
    [anon_sym_long] = ACTIONS(6232),
    [anon_sym_short] = ACTIONS(6232),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_static] = ACTIONS(6232),
    [anon_sym_register] = ACTIONS(6232),
    [anon_sym_inline] = ACTIONS(6232),
    [anon_sym___inline] = ACTIONS(6232),
    [anon_sym___inline__] = ACTIONS(6232),
    [anon_sym___forceinline] = ACTIONS(6232),
    [anon_sym_thread_local] = ACTIONS(6232),
    [anon_sym___thread] = ACTIONS(6232),
    [anon_sym_const] = ACTIONS(6232),
    [anon_sym_constexpr] = ACTIONS(6232),
    [anon_sym_volatile] = ACTIONS(6232),
    [anon_sym_restrict] = ACTIONS(6232),
    [anon_sym___restrict__] = ACTIONS(6232),
    [anon_sym__Atomic] = ACTIONS(6232),
    [anon_sym__Noreturn] = ACTIONS(6232),
    [anon_sym_noreturn] = ACTIONS(6232),
    [anon_sym_mutable] = ACTIONS(6232),
    [anon_sym_constinit] = ACTIONS(6232),
    [anon_sym_consteval] = ACTIONS(6232),
    [anon_sym_alignas] = ACTIONS(6232),
    [anon_sym__Alignas] = ACTIONS(6232),
    [sym_primitive_type] = ACTIONS(6232),
    [anon_sym_enum] = ACTIONS(6232),
    [anon_sym_class] = ACTIONS(6232),
    [anon_sym_struct] = ACTIONS(6232),
    [anon_sym_union] = ACTIONS(6232),
    [anon_sym_if] = ACTIONS(6232),
    [anon_sym_for] = ACTIONS(6232),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6232),
    [anon_sym_let] = ACTIONS(6232),
    [anon_sym_This] = ACTIONS(6232),
    [anon_sym_decltype] = ACTIONS(6232),
    [sym_virtual] = ACTIONS(6232),
    [anon_sym_typename] = ACTIONS(6232),
    [anon_sym_template] = ACTIONS(6232),
    [anon_sym_precise] = ACTIONS(6232),
    [anon_sym_shared] = ACTIONS(6232),
    [anon_sym_groupshared] = ACTIONS(6232),
    [anon_sym_uniform] = ACTIONS(6232),
    [anon_sym_row_major] = ACTIONS(6232),
    [anon_sym_column_major] = ACTIONS(6232),
    [anon_sym_globallycoherent] = ACTIONS(6232),
    [anon_sym_centroid] = ACTIONS(6232),
    [anon_sym_noperspective] = ACTIONS(6232),
    [anon_sym_nointerpolation] = ACTIONS(6232),
    [anon_sym_sample] = ACTIONS(6232),
    [anon_sym_linear] = ACTIONS(6232),
    [anon_sym_snorm] = ACTIONS(6232),
    [anon_sym_unorm] = ACTIONS(6232),
    [anon_sym_point] = ACTIONS(6232),
    [anon_sym_line] = ACTIONS(6232),
    [anon_sym_triangleadj] = ACTIONS(6232),
    [anon_sym_lineadj] = ACTIONS(6232),
    [anon_sym_triangle] = ACTIONS(6232),
    [anon_sym_interface] = ACTIONS(6232),
    [anon_sym_extension] = ACTIONS(6232),
  },
  [2664] = {
    [sym_string_literal] = STATE(1452),
    [sym_identifier] = ACTIONS(6253),
    [anon_sym_LPAREN2] = ACTIONS(6255),
    [anon_sym_TILDE] = ACTIONS(6255),
    [anon_sym_STAR] = ACTIONS(6255),
    [anon_sym_AMP_AMP] = ACTIONS(6255),
    [anon_sym_AMP] = ACTIONS(6253),
    [anon_sym___extension__] = ACTIONS(6253),
    [anon_sym_in] = ACTIONS(6253),
    [anon_sym_out] = ACTIONS(6253),
    [anon_sym_inout] = ACTIONS(6253),
    [anon_sym_extern] = ACTIONS(6253),
    [anon_sym___attribute__] = ACTIONS(6253),
    [anon_sym_COLON_COLON] = ACTIONS(6255),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6255),
    [anon_sym___declspec] = ACTIONS(6253),
    [anon_sym___based] = ACTIONS(6253),
    [anon_sym_signed] = ACTIONS(6253),
    [anon_sym_unsigned] = ACTIONS(6253),
    [anon_sym_long] = ACTIONS(6253),
    [anon_sym_short] = ACTIONS(6253),
    [anon_sym_LBRACK] = ACTIONS(6253),
    [anon_sym_static] = ACTIONS(6253),
    [anon_sym_register] = ACTIONS(6253),
    [anon_sym_inline] = ACTIONS(6253),
    [anon_sym___inline] = ACTIONS(6253),
    [anon_sym___inline__] = ACTIONS(6253),
    [anon_sym___forceinline] = ACTIONS(6253),
    [anon_sym_thread_local] = ACTIONS(6253),
    [anon_sym___thread] = ACTIONS(6253),
    [anon_sym_const] = ACTIONS(6253),
    [anon_sym_constexpr] = ACTIONS(6253),
    [anon_sym_volatile] = ACTIONS(6253),
    [anon_sym_restrict] = ACTIONS(6253),
    [anon_sym___restrict__] = ACTIONS(6253),
    [anon_sym__Atomic] = ACTIONS(6253),
    [anon_sym__Noreturn] = ACTIONS(6253),
    [anon_sym_noreturn] = ACTIONS(6253),
    [anon_sym_mutable] = ACTIONS(6253),
    [anon_sym_constinit] = ACTIONS(6253),
    [anon_sym_consteval] = ACTIONS(6253),
    [anon_sym_alignas] = ACTIONS(6253),
    [anon_sym__Alignas] = ACTIONS(6253),
    [sym_primitive_type] = ACTIONS(6253),
    [anon_sym_enum] = ACTIONS(6253),
    [anon_sym_class] = ACTIONS(6253),
    [anon_sym_struct] = ACTIONS(6253),
    [anon_sym_union] = ACTIONS(6253),
    [anon_sym_L_DQUOTE] = ACTIONS(6257),
    [anon_sym_u_DQUOTE] = ACTIONS(6257),
    [anon_sym_U_DQUOTE] = ACTIONS(6257),
    [anon_sym_u8_DQUOTE] = ACTIONS(6257),
    [anon_sym_DQUOTE] = ACTIONS(6257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6253),
    [anon_sym_let] = ACTIONS(6253),
    [anon_sym_This] = ACTIONS(6253),
    [anon_sym_decltype] = ACTIONS(6253),
    [sym_virtual] = ACTIONS(6253),
    [anon_sym_explicit] = ACTIONS(6253),
    [anon_sym_typename] = ACTIONS(6253),
    [anon_sym_template] = ACTIONS(6253),
    [anon_sym_operator] = ACTIONS(6253),
    [anon_sym_precise] = ACTIONS(6253),
    [anon_sym_shared] = ACTIONS(6253),
    [anon_sym_groupshared] = ACTIONS(6253),
    [anon_sym_uniform] = ACTIONS(6253),
    [anon_sym_row_major] = ACTIONS(6253),
    [anon_sym_column_major] = ACTIONS(6253),
    [anon_sym_globallycoherent] = ACTIONS(6253),
    [anon_sym_centroid] = ACTIONS(6253),
    [anon_sym_noperspective] = ACTIONS(6253),
    [anon_sym_nointerpolation] = ACTIONS(6253),
    [anon_sym_sample] = ACTIONS(6253),
    [anon_sym_linear] = ACTIONS(6253),
    [anon_sym_snorm] = ACTIONS(6253),
    [anon_sym_unorm] = ACTIONS(6253),
    [anon_sym_point] = ACTIONS(6253),
    [anon_sym_line] = ACTIONS(6253),
    [anon_sym_triangleadj] = ACTIONS(6253),
    [anon_sym_lineadj] = ACTIONS(6253),
    [anon_sym_triangle] = ACTIONS(6253),
    [anon_sym_interface] = ACTIONS(6253),
    [anon_sym_extension] = ACTIONS(6253),
  },
  [2665] = {
    [sym__declaration_modifiers] = STATE(2665),
    [sym_attribute_specifier] = STATE(2665),
    [sym_attribute_declaration] = STATE(2665),
    [sym_ms_declspec_modifier] = STATE(2665),
    [sym_storage_class_specifier] = STATE(2665),
    [sym_type_qualifier] = STATE(2665),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_qualifiers] = STATE(2665),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [sym_identifier] = ACTIONS(6259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6261),
    [anon_sym_COMMA] = ACTIONS(6261),
    [anon_sym_RPAREN] = ACTIONS(6261),
    [anon_sym_LPAREN2] = ACTIONS(6261),
    [anon_sym_TILDE] = ACTIONS(6261),
    [anon_sym_STAR] = ACTIONS(6261),
    [anon_sym_AMP_AMP] = ACTIONS(6261),
    [anon_sym_AMP] = ACTIONS(6259),
    [anon_sym_COLON] = ACTIONS(6259),
    [anon_sym_SEMI] = ACTIONS(6261),
    [anon_sym___extension__] = ACTIONS(6263),
    [anon_sym_in] = ACTIONS(6266),
    [anon_sym_out] = ACTIONS(6266),
    [anon_sym_inout] = ACTIONS(6266),
    [anon_sym_extern] = ACTIONS(6269),
    [anon_sym___attribute__] = ACTIONS(6272),
    [anon_sym_COLON_COLON] = ACTIONS(6261),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6275),
    [anon_sym___declspec] = ACTIONS(6278),
    [anon_sym___based] = ACTIONS(6259),
    [anon_sym___cdecl] = ACTIONS(6259),
    [anon_sym___clrcall] = ACTIONS(6259),
    [anon_sym___stdcall] = ACTIONS(6259),
    [anon_sym___fastcall] = ACTIONS(6259),
    [anon_sym___thiscall] = ACTIONS(6259),
    [anon_sym___vectorcall] = ACTIONS(6259),
    [anon_sym_LBRACK] = ACTIONS(6259),
    [anon_sym_static] = ACTIONS(6269),
    [anon_sym_EQ] = ACTIONS(6261),
    [anon_sym_register] = ACTIONS(6269),
    [anon_sym_inline] = ACTIONS(6269),
    [anon_sym___inline] = ACTIONS(6269),
    [anon_sym___inline__] = ACTIONS(6269),
    [anon_sym___forceinline] = ACTIONS(6269),
    [anon_sym_thread_local] = ACTIONS(6269),
    [anon_sym___thread] = ACTIONS(6269),
    [anon_sym_const] = ACTIONS(6263),
    [anon_sym_constexpr] = ACTIONS(6263),
    [anon_sym_volatile] = ACTIONS(6263),
    [anon_sym_restrict] = ACTIONS(6263),
    [anon_sym___restrict__] = ACTIONS(6263),
    [anon_sym__Atomic] = ACTIONS(6263),
    [anon_sym__Noreturn] = ACTIONS(6263),
    [anon_sym_noreturn] = ACTIONS(6263),
    [anon_sym_mutable] = ACTIONS(6263),
    [anon_sym_constinit] = ACTIONS(6263),
    [anon_sym_consteval] = ACTIONS(6263),
    [anon_sym_alignas] = ACTIONS(6281),
    [anon_sym__Alignas] = ACTIONS(6281),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(6259),
    [sym_virtual] = ACTIONS(6266),
    [anon_sym_template] = ACTIONS(6259),
    [anon_sym_GT2] = ACTIONS(6261),
    [anon_sym_operator] = ACTIONS(6259),
    [anon_sym_precise] = ACTIONS(6284),
    [anon_sym_shared] = ACTIONS(6284),
    [anon_sym_groupshared] = ACTIONS(6284),
    [anon_sym_uniform] = ACTIONS(6284),
    [anon_sym_row_major] = ACTIONS(6284),
    [anon_sym_column_major] = ACTIONS(6284),
    [anon_sym_globallycoherent] = ACTIONS(6284),
    [anon_sym_centroid] = ACTIONS(6284),
    [anon_sym_noperspective] = ACTIONS(6284),
    [anon_sym_nointerpolation] = ACTIONS(6284),
    [anon_sym_sample] = ACTIONS(6284),
    [anon_sym_linear] = ACTIONS(6284),
    [anon_sym_snorm] = ACTIONS(6284),
    [anon_sym_unorm] = ACTIONS(6284),
    [anon_sym_point] = ACTIONS(6284),
    [anon_sym_line] = ACTIONS(6284),
    [anon_sym_triangleadj] = ACTIONS(6284),
    [anon_sym_lineadj] = ACTIONS(6284),
    [anon_sym_triangle] = ACTIONS(6284),
  },
  [2666] = {
    [sym__declaration_modifiers] = STATE(2665),
    [sym_attribute_specifier] = STATE(2665),
    [sym_attribute_declaration] = STATE(2665),
    [sym_ms_declspec_modifier] = STATE(2665),
    [sym_storage_class_specifier] = STATE(2665),
    [sym_type_qualifier] = STATE(2665),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_qualifiers] = STATE(2665),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [sym_identifier] = ACTIONS(6287),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6289),
    [anon_sym_COMMA] = ACTIONS(6289),
    [anon_sym_RPAREN] = ACTIONS(6289),
    [anon_sym_LPAREN2] = ACTIONS(6289),
    [anon_sym_TILDE] = ACTIONS(6289),
    [anon_sym_STAR] = ACTIONS(6289),
    [anon_sym_AMP_AMP] = ACTIONS(6289),
    [anon_sym_AMP] = ACTIONS(6287),
    [anon_sym_COLON] = ACTIONS(6287),
    [anon_sym_SEMI] = ACTIONS(6289),
    [anon_sym___extension__] = ACTIONS(6142),
    [anon_sym_in] = ACTIONS(6291),
    [anon_sym_out] = ACTIONS(6291),
    [anon_sym_inout] = ACTIONS(6291),
    [anon_sym_extern] = ACTIONS(6146),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(6289),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6152),
    [anon_sym___declspec] = ACTIONS(6154),
    [anon_sym___based] = ACTIONS(6287),
    [anon_sym___cdecl] = ACTIONS(6287),
    [anon_sym___clrcall] = ACTIONS(6287),
    [anon_sym___stdcall] = ACTIONS(6287),
    [anon_sym___fastcall] = ACTIONS(6287),
    [anon_sym___thiscall] = ACTIONS(6287),
    [anon_sym___vectorcall] = ACTIONS(6287),
    [anon_sym_LBRACK] = ACTIONS(6287),
    [anon_sym_static] = ACTIONS(6146),
    [anon_sym_EQ] = ACTIONS(6289),
    [anon_sym_register] = ACTIONS(6146),
    [anon_sym_inline] = ACTIONS(6146),
    [anon_sym___inline] = ACTIONS(6146),
    [anon_sym___inline__] = ACTIONS(6146),
    [anon_sym___forceinline] = ACTIONS(6146),
    [anon_sym_thread_local] = ACTIONS(6146),
    [anon_sym___thread] = ACTIONS(6146),
    [anon_sym_const] = ACTIONS(6142),
    [anon_sym_constexpr] = ACTIONS(6142),
    [anon_sym_volatile] = ACTIONS(6142),
    [anon_sym_restrict] = ACTIONS(6142),
    [anon_sym___restrict__] = ACTIONS(6142),
    [anon_sym__Atomic] = ACTIONS(6142),
    [anon_sym__Noreturn] = ACTIONS(6142),
    [anon_sym_noreturn] = ACTIONS(6142),
    [anon_sym_mutable] = ACTIONS(6142),
    [anon_sym_constinit] = ACTIONS(6142),
    [anon_sym_consteval] = ACTIONS(6142),
    [anon_sym_alignas] = ACTIONS(6156),
    [anon_sym__Alignas] = ACTIONS(6156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(6287),
    [sym_virtual] = ACTIONS(6291),
    [anon_sym_template] = ACTIONS(6287),
    [anon_sym_GT2] = ACTIONS(6289),
    [anon_sym_operator] = ACTIONS(6287),
    [anon_sym_precise] = ACTIONS(6158),
    [anon_sym_shared] = ACTIONS(6158),
    [anon_sym_groupshared] = ACTIONS(6158),
    [anon_sym_uniform] = ACTIONS(6158),
    [anon_sym_row_major] = ACTIONS(6158),
    [anon_sym_column_major] = ACTIONS(6158),
    [anon_sym_globallycoherent] = ACTIONS(6158),
    [anon_sym_centroid] = ACTIONS(6158),
    [anon_sym_noperspective] = ACTIONS(6158),
    [anon_sym_nointerpolation] = ACTIONS(6158),
    [anon_sym_sample] = ACTIONS(6158),
    [anon_sym_linear] = ACTIONS(6158),
    [anon_sym_snorm] = ACTIONS(6158),
    [anon_sym_unorm] = ACTIONS(6158),
    [anon_sym_point] = ACTIONS(6158),
    [anon_sym_line] = ACTIONS(6158),
    [anon_sym_triangleadj] = ACTIONS(6158),
    [anon_sym_lineadj] = ACTIONS(6158),
    [anon_sym_triangle] = ACTIONS(6158),
  },
  [2667] = {
    [sym_string_literal] = STATE(1450),
    [sym_identifier] = ACTIONS(6253),
    [anon_sym_LPAREN2] = ACTIONS(6255),
    [anon_sym_TILDE] = ACTIONS(6255),
    [anon_sym_STAR] = ACTIONS(6255),
    [anon_sym_AMP_AMP] = ACTIONS(6255),
    [anon_sym_AMP] = ACTIONS(6253),
    [anon_sym___extension__] = ACTIONS(6253),
    [anon_sym_in] = ACTIONS(6253),
    [anon_sym_out] = ACTIONS(6253),
    [anon_sym_inout] = ACTIONS(6253),
    [anon_sym_extern] = ACTIONS(6253),
    [anon_sym___attribute__] = ACTIONS(6253),
    [anon_sym_COLON_COLON] = ACTIONS(6255),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6255),
    [anon_sym___declspec] = ACTIONS(6253),
    [anon_sym___based] = ACTIONS(6253),
    [anon_sym_signed] = ACTIONS(6253),
    [anon_sym_unsigned] = ACTIONS(6253),
    [anon_sym_long] = ACTIONS(6253),
    [anon_sym_short] = ACTIONS(6253),
    [anon_sym_LBRACK] = ACTIONS(6253),
    [anon_sym_static] = ACTIONS(6253),
    [anon_sym_register] = ACTIONS(6253),
    [anon_sym_inline] = ACTIONS(6253),
    [anon_sym___inline] = ACTIONS(6253),
    [anon_sym___inline__] = ACTIONS(6253),
    [anon_sym___forceinline] = ACTIONS(6253),
    [anon_sym_thread_local] = ACTIONS(6253),
    [anon_sym___thread] = ACTIONS(6253),
    [anon_sym_const] = ACTIONS(6253),
    [anon_sym_constexpr] = ACTIONS(6253),
    [anon_sym_volatile] = ACTIONS(6253),
    [anon_sym_restrict] = ACTIONS(6253),
    [anon_sym___restrict__] = ACTIONS(6253),
    [anon_sym__Atomic] = ACTIONS(6253),
    [anon_sym__Noreturn] = ACTIONS(6253),
    [anon_sym_noreturn] = ACTIONS(6253),
    [anon_sym_mutable] = ACTIONS(6253),
    [anon_sym_constinit] = ACTIONS(6253),
    [anon_sym_consteval] = ACTIONS(6253),
    [anon_sym_alignas] = ACTIONS(6253),
    [anon_sym__Alignas] = ACTIONS(6253),
    [sym_primitive_type] = ACTIONS(6253),
    [anon_sym_enum] = ACTIONS(6253),
    [anon_sym_class] = ACTIONS(6253),
    [anon_sym_struct] = ACTIONS(6253),
    [anon_sym_union] = ACTIONS(6253),
    [anon_sym_L_DQUOTE] = ACTIONS(6257),
    [anon_sym_u_DQUOTE] = ACTIONS(6257),
    [anon_sym_U_DQUOTE] = ACTIONS(6257),
    [anon_sym_u8_DQUOTE] = ACTIONS(6257),
    [anon_sym_DQUOTE] = ACTIONS(6257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6253),
    [anon_sym_let] = ACTIONS(6253),
    [anon_sym_This] = ACTIONS(6253),
    [anon_sym_decltype] = ACTIONS(6253),
    [sym_virtual] = ACTIONS(6253),
    [anon_sym_explicit] = ACTIONS(6253),
    [anon_sym_typename] = ACTIONS(6253),
    [anon_sym_template] = ACTIONS(6253),
    [anon_sym_operator] = ACTIONS(6253),
    [anon_sym_precise] = ACTIONS(6253),
    [anon_sym_shared] = ACTIONS(6253),
    [anon_sym_groupshared] = ACTIONS(6253),
    [anon_sym_uniform] = ACTIONS(6253),
    [anon_sym_row_major] = ACTIONS(6253),
    [anon_sym_column_major] = ACTIONS(6253),
    [anon_sym_globallycoherent] = ACTIONS(6253),
    [anon_sym_centroid] = ACTIONS(6253),
    [anon_sym_noperspective] = ACTIONS(6253),
    [anon_sym_nointerpolation] = ACTIONS(6253),
    [anon_sym_sample] = ACTIONS(6253),
    [anon_sym_linear] = ACTIONS(6253),
    [anon_sym_snorm] = ACTIONS(6253),
    [anon_sym_unorm] = ACTIONS(6253),
    [anon_sym_point] = ACTIONS(6253),
    [anon_sym_line] = ACTIONS(6253),
    [anon_sym_triangleadj] = ACTIONS(6253),
    [anon_sym_lineadj] = ACTIONS(6253),
    [anon_sym_triangle] = ACTIONS(6253),
    [anon_sym_interface] = ACTIONS(6253),
    [anon_sym_extension] = ACTIONS(6253),
  },
  [2668] = {
    [sym_string_literal] = STATE(1448),
    [sym_identifier] = ACTIONS(6253),
    [anon_sym_LPAREN2] = ACTIONS(6255),
    [anon_sym_TILDE] = ACTIONS(6255),
    [anon_sym_STAR] = ACTIONS(6255),
    [anon_sym_AMP_AMP] = ACTIONS(6255),
    [anon_sym_AMP] = ACTIONS(6253),
    [anon_sym___extension__] = ACTIONS(6253),
    [anon_sym_in] = ACTIONS(6253),
    [anon_sym_out] = ACTIONS(6253),
    [anon_sym_inout] = ACTIONS(6253),
    [anon_sym_extern] = ACTIONS(6253),
    [anon_sym___attribute__] = ACTIONS(6253),
    [anon_sym_COLON_COLON] = ACTIONS(6255),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6255),
    [anon_sym___declspec] = ACTIONS(6253),
    [anon_sym___based] = ACTIONS(6253),
    [anon_sym_signed] = ACTIONS(6253),
    [anon_sym_unsigned] = ACTIONS(6253),
    [anon_sym_long] = ACTIONS(6253),
    [anon_sym_short] = ACTIONS(6253),
    [anon_sym_LBRACK] = ACTIONS(6253),
    [anon_sym_static] = ACTIONS(6253),
    [anon_sym_register] = ACTIONS(6253),
    [anon_sym_inline] = ACTIONS(6253),
    [anon_sym___inline] = ACTIONS(6253),
    [anon_sym___inline__] = ACTIONS(6253),
    [anon_sym___forceinline] = ACTIONS(6253),
    [anon_sym_thread_local] = ACTIONS(6253),
    [anon_sym___thread] = ACTIONS(6253),
    [anon_sym_const] = ACTIONS(6253),
    [anon_sym_constexpr] = ACTIONS(6253),
    [anon_sym_volatile] = ACTIONS(6253),
    [anon_sym_restrict] = ACTIONS(6253),
    [anon_sym___restrict__] = ACTIONS(6253),
    [anon_sym__Atomic] = ACTIONS(6253),
    [anon_sym__Noreturn] = ACTIONS(6253),
    [anon_sym_noreturn] = ACTIONS(6253),
    [anon_sym_mutable] = ACTIONS(6253),
    [anon_sym_constinit] = ACTIONS(6253),
    [anon_sym_consteval] = ACTIONS(6253),
    [anon_sym_alignas] = ACTIONS(6253),
    [anon_sym__Alignas] = ACTIONS(6253),
    [sym_primitive_type] = ACTIONS(6253),
    [anon_sym_enum] = ACTIONS(6253),
    [anon_sym_class] = ACTIONS(6253),
    [anon_sym_struct] = ACTIONS(6253),
    [anon_sym_union] = ACTIONS(6253),
    [anon_sym_L_DQUOTE] = ACTIONS(6257),
    [anon_sym_u_DQUOTE] = ACTIONS(6257),
    [anon_sym_U_DQUOTE] = ACTIONS(6257),
    [anon_sym_u8_DQUOTE] = ACTIONS(6257),
    [anon_sym_DQUOTE] = ACTIONS(6257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6253),
    [anon_sym_let] = ACTIONS(6253),
    [anon_sym_This] = ACTIONS(6253),
    [anon_sym_decltype] = ACTIONS(6253),
    [sym_virtual] = ACTIONS(6253),
    [anon_sym_explicit] = ACTIONS(6253),
    [anon_sym_typename] = ACTIONS(6253),
    [anon_sym_template] = ACTIONS(6253),
    [anon_sym_operator] = ACTIONS(6253),
    [anon_sym_precise] = ACTIONS(6253),
    [anon_sym_shared] = ACTIONS(6253),
    [anon_sym_groupshared] = ACTIONS(6253),
    [anon_sym_uniform] = ACTIONS(6253),
    [anon_sym_row_major] = ACTIONS(6253),
    [anon_sym_column_major] = ACTIONS(6253),
    [anon_sym_globallycoherent] = ACTIONS(6253),
    [anon_sym_centroid] = ACTIONS(6253),
    [anon_sym_noperspective] = ACTIONS(6253),
    [anon_sym_nointerpolation] = ACTIONS(6253),
    [anon_sym_sample] = ACTIONS(6253),
    [anon_sym_linear] = ACTIONS(6253),
    [anon_sym_snorm] = ACTIONS(6253),
    [anon_sym_unorm] = ACTIONS(6253),
    [anon_sym_point] = ACTIONS(6253),
    [anon_sym_line] = ACTIONS(6253),
    [anon_sym_triangleadj] = ACTIONS(6253),
    [anon_sym_lineadj] = ACTIONS(6253),
    [anon_sym_triangle] = ACTIONS(6253),
    [anon_sym_interface] = ACTIONS(6253),
    [anon_sym_extension] = ACTIONS(6253),
  },
  [2669] = {
    [sym_string_literal] = STATE(1451),
    [sym_identifier] = ACTIONS(6253),
    [anon_sym_LPAREN2] = ACTIONS(6255),
    [anon_sym_TILDE] = ACTIONS(6255),
    [anon_sym_STAR] = ACTIONS(6255),
    [anon_sym_AMP_AMP] = ACTIONS(6255),
    [anon_sym_AMP] = ACTIONS(6253),
    [anon_sym___extension__] = ACTIONS(6253),
    [anon_sym_in] = ACTIONS(6253),
    [anon_sym_out] = ACTIONS(6253),
    [anon_sym_inout] = ACTIONS(6253),
    [anon_sym_extern] = ACTIONS(6253),
    [anon_sym___attribute__] = ACTIONS(6253),
    [anon_sym_COLON_COLON] = ACTIONS(6255),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6255),
    [anon_sym___declspec] = ACTIONS(6253),
    [anon_sym___based] = ACTIONS(6253),
    [anon_sym_signed] = ACTIONS(6253),
    [anon_sym_unsigned] = ACTIONS(6253),
    [anon_sym_long] = ACTIONS(6253),
    [anon_sym_short] = ACTIONS(6253),
    [anon_sym_LBRACK] = ACTIONS(6253),
    [anon_sym_static] = ACTIONS(6253),
    [anon_sym_register] = ACTIONS(6253),
    [anon_sym_inline] = ACTIONS(6253),
    [anon_sym___inline] = ACTIONS(6253),
    [anon_sym___inline__] = ACTIONS(6253),
    [anon_sym___forceinline] = ACTIONS(6253),
    [anon_sym_thread_local] = ACTIONS(6253),
    [anon_sym___thread] = ACTIONS(6253),
    [anon_sym_const] = ACTIONS(6253),
    [anon_sym_constexpr] = ACTIONS(6253),
    [anon_sym_volatile] = ACTIONS(6253),
    [anon_sym_restrict] = ACTIONS(6253),
    [anon_sym___restrict__] = ACTIONS(6253),
    [anon_sym__Atomic] = ACTIONS(6253),
    [anon_sym__Noreturn] = ACTIONS(6253),
    [anon_sym_noreturn] = ACTIONS(6253),
    [anon_sym_mutable] = ACTIONS(6253),
    [anon_sym_constinit] = ACTIONS(6253),
    [anon_sym_consteval] = ACTIONS(6253),
    [anon_sym_alignas] = ACTIONS(6253),
    [anon_sym__Alignas] = ACTIONS(6253),
    [sym_primitive_type] = ACTIONS(6253),
    [anon_sym_enum] = ACTIONS(6253),
    [anon_sym_class] = ACTIONS(6253),
    [anon_sym_struct] = ACTIONS(6253),
    [anon_sym_union] = ACTIONS(6253),
    [anon_sym_L_DQUOTE] = ACTIONS(6257),
    [anon_sym_u_DQUOTE] = ACTIONS(6257),
    [anon_sym_U_DQUOTE] = ACTIONS(6257),
    [anon_sym_u8_DQUOTE] = ACTIONS(6257),
    [anon_sym_DQUOTE] = ACTIONS(6257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6253),
    [anon_sym_let] = ACTIONS(6253),
    [anon_sym_This] = ACTIONS(6253),
    [anon_sym_decltype] = ACTIONS(6253),
    [sym_virtual] = ACTIONS(6253),
    [anon_sym_explicit] = ACTIONS(6253),
    [anon_sym_typename] = ACTIONS(6253),
    [anon_sym_template] = ACTIONS(6253),
    [anon_sym_operator] = ACTIONS(6253),
    [anon_sym_precise] = ACTIONS(6253),
    [anon_sym_shared] = ACTIONS(6253),
    [anon_sym_groupshared] = ACTIONS(6253),
    [anon_sym_uniform] = ACTIONS(6253),
    [anon_sym_row_major] = ACTIONS(6253),
    [anon_sym_column_major] = ACTIONS(6253),
    [anon_sym_globallycoherent] = ACTIONS(6253),
    [anon_sym_centroid] = ACTIONS(6253),
    [anon_sym_noperspective] = ACTIONS(6253),
    [anon_sym_nointerpolation] = ACTIONS(6253),
    [anon_sym_sample] = ACTIONS(6253),
    [anon_sym_linear] = ACTIONS(6253),
    [anon_sym_snorm] = ACTIONS(6253),
    [anon_sym_unorm] = ACTIONS(6253),
    [anon_sym_point] = ACTIONS(6253),
    [anon_sym_line] = ACTIONS(6253),
    [anon_sym_triangleadj] = ACTIONS(6253),
    [anon_sym_lineadj] = ACTIONS(6253),
    [anon_sym_triangle] = ACTIONS(6253),
    [anon_sym_interface] = ACTIONS(6253),
    [anon_sym_extension] = ACTIONS(6253),
  },
  [2670] = {
    [sym__declaration_modifiers] = STATE(2665),
    [sym_attribute_specifier] = STATE(2665),
    [sym_attribute_declaration] = STATE(2665),
    [sym_ms_declspec_modifier] = STATE(2665),
    [sym_storage_class_specifier] = STATE(2665),
    [sym_type_qualifier] = STATE(2665),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_qualifiers] = STATE(2665),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [sym_identifier] = ACTIONS(6293),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6295),
    [anon_sym_COMMA] = ACTIONS(6295),
    [anon_sym_RPAREN] = ACTIONS(6295),
    [anon_sym_LPAREN2] = ACTIONS(6295),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_STAR] = ACTIONS(6295),
    [anon_sym_AMP_AMP] = ACTIONS(6295),
    [anon_sym_AMP] = ACTIONS(6293),
    [anon_sym_COLON] = ACTIONS(6293),
    [anon_sym_SEMI] = ACTIONS(6295),
    [anon_sym___extension__] = ACTIONS(6142),
    [anon_sym_in] = ACTIONS(6291),
    [anon_sym_out] = ACTIONS(6291),
    [anon_sym_inout] = ACTIONS(6291),
    [anon_sym_extern] = ACTIONS(6146),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(6295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6152),
    [anon_sym___declspec] = ACTIONS(6154),
    [anon_sym___based] = ACTIONS(6293),
    [anon_sym___cdecl] = ACTIONS(6293),
    [anon_sym___clrcall] = ACTIONS(6293),
    [anon_sym___stdcall] = ACTIONS(6293),
    [anon_sym___fastcall] = ACTIONS(6293),
    [anon_sym___thiscall] = ACTIONS(6293),
    [anon_sym___vectorcall] = ACTIONS(6293),
    [anon_sym_LBRACK] = ACTIONS(6293),
    [anon_sym_static] = ACTIONS(6146),
    [anon_sym_EQ] = ACTIONS(6295),
    [anon_sym_register] = ACTIONS(6146),
    [anon_sym_inline] = ACTIONS(6146),
    [anon_sym___inline] = ACTIONS(6146),
    [anon_sym___inline__] = ACTIONS(6146),
    [anon_sym___forceinline] = ACTIONS(6146),
    [anon_sym_thread_local] = ACTIONS(6146),
    [anon_sym___thread] = ACTIONS(6146),
    [anon_sym_const] = ACTIONS(6142),
    [anon_sym_constexpr] = ACTIONS(6142),
    [anon_sym_volatile] = ACTIONS(6142),
    [anon_sym_restrict] = ACTIONS(6142),
    [anon_sym___restrict__] = ACTIONS(6142),
    [anon_sym__Atomic] = ACTIONS(6142),
    [anon_sym__Noreturn] = ACTIONS(6142),
    [anon_sym_noreturn] = ACTIONS(6142),
    [anon_sym_mutable] = ACTIONS(6142),
    [anon_sym_constinit] = ACTIONS(6142),
    [anon_sym_consteval] = ACTIONS(6142),
    [anon_sym_alignas] = ACTIONS(6156),
    [anon_sym__Alignas] = ACTIONS(6156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(6293),
    [sym_virtual] = ACTIONS(6291),
    [anon_sym_template] = ACTIONS(6293),
    [anon_sym_GT2] = ACTIONS(6295),
    [anon_sym_operator] = ACTIONS(6293),
    [anon_sym_precise] = ACTIONS(6158),
    [anon_sym_shared] = ACTIONS(6158),
    [anon_sym_groupshared] = ACTIONS(6158),
    [anon_sym_uniform] = ACTIONS(6158),
    [anon_sym_row_major] = ACTIONS(6158),
    [anon_sym_column_major] = ACTIONS(6158),
    [anon_sym_globallycoherent] = ACTIONS(6158),
    [anon_sym_centroid] = ACTIONS(6158),
    [anon_sym_noperspective] = ACTIONS(6158),
    [anon_sym_nointerpolation] = ACTIONS(6158),
    [anon_sym_sample] = ACTIONS(6158),
    [anon_sym_linear] = ACTIONS(6158),
    [anon_sym_snorm] = ACTIONS(6158),
    [anon_sym_unorm] = ACTIONS(6158),
    [anon_sym_point] = ACTIONS(6158),
    [anon_sym_line] = ACTIONS(6158),
    [anon_sym_triangleadj] = ACTIONS(6158),
    [anon_sym_lineadj] = ACTIONS(6158),
    [anon_sym_triangle] = ACTIONS(6158),
  },
  [2671] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2661),
    [sym_identifier] = ACTIONS(2742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2740),
    [anon_sym_COMMA] = ACTIONS(2740),
    [anon_sym_RPAREN] = ACTIONS(2740),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_TILDE] = ACTIONS(2740),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_COLON] = ACTIONS(2742),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym___extension__] = ACTIONS(2742),
    [anon_sym_in] = ACTIONS(2742),
    [anon_sym_out] = ACTIONS(2742),
    [anon_sym_inout] = ACTIONS(2742),
    [anon_sym_extern] = ACTIONS(2742),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym_COLON_COLON] = ACTIONS(2740),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2740),
    [anon_sym___declspec] = ACTIONS(2742),
    [anon_sym___based] = ACTIONS(2742),
    [anon_sym___cdecl] = ACTIONS(2742),
    [anon_sym___clrcall] = ACTIONS(2742),
    [anon_sym___stdcall] = ACTIONS(2742),
    [anon_sym___fastcall] = ACTIONS(2742),
    [anon_sym___thiscall] = ACTIONS(2742),
    [anon_sym___vectorcall] = ACTIONS(2742),
    [anon_sym_signed] = ACTIONS(6251),
    [anon_sym_unsigned] = ACTIONS(6251),
    [anon_sym_long] = ACTIONS(6251),
    [anon_sym_short] = ACTIONS(6251),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2742),
    [anon_sym_EQ] = ACTIONS(2740),
    [anon_sym_register] = ACTIONS(2742),
    [anon_sym_inline] = ACTIONS(2742),
    [anon_sym___inline] = ACTIONS(2742),
    [anon_sym___inline__] = ACTIONS(2742),
    [anon_sym___forceinline] = ACTIONS(2742),
    [anon_sym_thread_local] = ACTIONS(2742),
    [anon_sym___thread] = ACTIONS(2742),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_constexpr] = ACTIONS(2742),
    [anon_sym_volatile] = ACTIONS(2742),
    [anon_sym_restrict] = ACTIONS(2742),
    [anon_sym___restrict__] = ACTIONS(2742),
    [anon_sym__Atomic] = ACTIONS(2742),
    [anon_sym__Noreturn] = ACTIONS(2742),
    [anon_sym_noreturn] = ACTIONS(2742),
    [anon_sym_mutable] = ACTIONS(2742),
    [anon_sym_constinit] = ACTIONS(2742),
    [anon_sym_consteval] = ACTIONS(2742),
    [anon_sym_alignas] = ACTIONS(2742),
    [anon_sym__Alignas] = ACTIONS(2742),
    [anon_sym_DOT] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
    [anon_sym_decltype] = ACTIONS(2742),
    [sym_virtual] = ACTIONS(2742),
    [anon_sym_template] = ACTIONS(2742),
    [anon_sym_GT2] = ACTIONS(2740),
    [anon_sym_operator] = ACTIONS(2742),
    [anon_sym_precise] = ACTIONS(2742),
    [anon_sym_shared] = ACTIONS(2742),
    [anon_sym_groupshared] = ACTIONS(2742),
    [anon_sym_uniform] = ACTIONS(2742),
    [anon_sym_row_major] = ACTIONS(2742),
    [anon_sym_column_major] = ACTIONS(2742),
    [anon_sym_globallycoherent] = ACTIONS(2742),
    [anon_sym_centroid] = ACTIONS(2742),
    [anon_sym_noperspective] = ACTIONS(2742),
    [anon_sym_nointerpolation] = ACTIONS(2742),
    [anon_sym_sample] = ACTIONS(2742),
    [anon_sym_linear] = ACTIONS(2742),
    [anon_sym_snorm] = ACTIONS(2742),
    [anon_sym_unorm] = ACTIONS(2742),
    [anon_sym_point] = ACTIONS(2742),
    [anon_sym_line] = ACTIONS(2742),
    [anon_sym_triangleadj] = ACTIONS(2742),
    [anon_sym_lineadj] = ACTIONS(2742),
    [anon_sym_triangle] = ACTIONS(2742),
  },
  [2672] = {
    [sym_identifier] = ACTIONS(2363),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2361),
    [anon_sym_COMMA] = ACTIONS(2361),
    [anon_sym_RPAREN] = ACTIONS(2361),
    [anon_sym_LPAREN2] = ACTIONS(2361),
    [anon_sym_TILDE] = ACTIONS(2361),
    [anon_sym_STAR] = ACTIONS(2361),
    [anon_sym_AMP_AMP] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(2363),
    [anon_sym_COLON] = ACTIONS(2363),
    [anon_sym_SEMI] = ACTIONS(2361),
    [anon_sym___extension__] = ACTIONS(2363),
    [anon_sym_in] = ACTIONS(2363),
    [anon_sym_out] = ACTIONS(2363),
    [anon_sym_inout] = ACTIONS(2363),
    [anon_sym_extern] = ACTIONS(2363),
    [anon_sym___attribute__] = ACTIONS(2363),
    [anon_sym_COLON_COLON] = ACTIONS(2361),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2361),
    [anon_sym___declspec] = ACTIONS(2363),
    [anon_sym___based] = ACTIONS(2363),
    [anon_sym___cdecl] = ACTIONS(2363),
    [anon_sym___clrcall] = ACTIONS(2363),
    [anon_sym___stdcall] = ACTIONS(2363),
    [anon_sym___fastcall] = ACTIONS(2363),
    [anon_sym___thiscall] = ACTIONS(2363),
    [anon_sym___vectorcall] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LBRACK] = ACTIONS(2363),
    [anon_sym_static] = ACTIONS(2363),
    [anon_sym_EQ] = ACTIONS(2361),
    [anon_sym_register] = ACTIONS(2363),
    [anon_sym_inline] = ACTIONS(2363),
    [anon_sym___inline] = ACTIONS(2363),
    [anon_sym___inline__] = ACTIONS(2363),
    [anon_sym___forceinline] = ACTIONS(2363),
    [anon_sym_thread_local] = ACTIONS(2363),
    [anon_sym___thread] = ACTIONS(2363),
    [anon_sym_const] = ACTIONS(2363),
    [anon_sym_constexpr] = ACTIONS(2363),
    [anon_sym_volatile] = ACTIONS(2363),
    [anon_sym_restrict] = ACTIONS(2363),
    [anon_sym___restrict__] = ACTIONS(2363),
    [anon_sym__Atomic] = ACTIONS(2363),
    [anon_sym__Noreturn] = ACTIONS(2363),
    [anon_sym_noreturn] = ACTIONS(2363),
    [anon_sym_mutable] = ACTIONS(2363),
    [anon_sym_constinit] = ACTIONS(2363),
    [anon_sym_consteval] = ACTIONS(2363),
    [anon_sym_alignas] = ACTIONS(2363),
    [anon_sym__Alignas] = ACTIONS(2363),
    [anon_sym_DOT] = ACTIONS(2363),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2363),
    [anon_sym_let] = ACTIONS(2363),
    [anon_sym_This] = ACTIONS(2363),
    [anon_sym_decltype] = ACTIONS(2363),
    [anon_sym_final] = ACTIONS(2363),
    [anon_sym_override] = ACTIONS(2363),
    [sym_virtual] = ACTIONS(2363),
    [anon_sym_template] = ACTIONS(2363),
    [anon_sym_GT2] = ACTIONS(2361),
    [anon_sym_operator] = ACTIONS(2363),
    [anon_sym_precise] = ACTIONS(2363),
    [anon_sym_shared] = ACTIONS(2363),
    [anon_sym_groupshared] = ACTIONS(2363),
    [anon_sym_uniform] = ACTIONS(2363),
    [anon_sym_row_major] = ACTIONS(2363),
    [anon_sym_column_major] = ACTIONS(2363),
    [anon_sym_globallycoherent] = ACTIONS(2363),
    [anon_sym_centroid] = ACTIONS(2363),
    [anon_sym_noperspective] = ACTIONS(2363),
    [anon_sym_nointerpolation] = ACTIONS(2363),
    [anon_sym_sample] = ACTIONS(2363),
    [anon_sym_linear] = ACTIONS(2363),
    [anon_sym_snorm] = ACTIONS(2363),
    [anon_sym_unorm] = ACTIONS(2363),
    [anon_sym_point] = ACTIONS(2363),
    [anon_sym_line] = ACTIONS(2363),
    [anon_sym_triangleadj] = ACTIONS(2363),
    [anon_sym_lineadj] = ACTIONS(2363),
    [anon_sym_triangle] = ACTIONS(2363),
  },
  [2673] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_qualifiers] = STATE(2666),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(6297),
    [anon_sym_LPAREN2] = ACTIONS(6299),
    [anon_sym_TILDE] = ACTIONS(6299),
    [anon_sym_STAR] = ACTIONS(6299),
    [anon_sym_AMP_AMP] = ACTIONS(6299),
    [anon_sym_AMP] = ACTIONS(6297),
    [anon_sym_SEMI] = ACTIONS(6301),
    [anon_sym___extension__] = ACTIONS(6142),
    [anon_sym_in] = ACTIONS(6303),
    [anon_sym_out] = ACTIONS(6303),
    [anon_sym_inout] = ACTIONS(6303),
    [anon_sym_extern] = ACTIONS(6146),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(6299),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6152),
    [anon_sym___declspec] = ACTIONS(6154),
    [anon_sym___based] = ACTIONS(6297),
    [anon_sym___cdecl] = ACTIONS(6297),
    [anon_sym___clrcall] = ACTIONS(6297),
    [anon_sym___stdcall] = ACTIONS(6297),
    [anon_sym___fastcall] = ACTIONS(6297),
    [anon_sym___thiscall] = ACTIONS(6297),
    [anon_sym___vectorcall] = ACTIONS(6297),
    [anon_sym_LBRACK] = ACTIONS(6297),
    [anon_sym_static] = ACTIONS(6146),
    [anon_sym_register] = ACTIONS(6146),
    [anon_sym_inline] = ACTIONS(6146),
    [anon_sym___inline] = ACTIONS(6146),
    [anon_sym___inline__] = ACTIONS(6146),
    [anon_sym___forceinline] = ACTIONS(6146),
    [anon_sym_thread_local] = ACTIONS(6146),
    [anon_sym___thread] = ACTIONS(6146),
    [anon_sym_const] = ACTIONS(6142),
    [anon_sym_constexpr] = ACTIONS(6142),
    [anon_sym_volatile] = ACTIONS(6142),
    [anon_sym_restrict] = ACTIONS(6142),
    [anon_sym___restrict__] = ACTIONS(6142),
    [anon_sym__Atomic] = ACTIONS(6142),
    [anon_sym__Noreturn] = ACTIONS(6142),
    [anon_sym_noreturn] = ACTIONS(6142),
    [anon_sym_mutable] = ACTIONS(6142),
    [anon_sym_constinit] = ACTIONS(6142),
    [anon_sym_consteval] = ACTIONS(6142),
    [anon_sym_alignas] = ACTIONS(6156),
    [anon_sym__Alignas] = ACTIONS(6156),
    [anon_sym_DOT] = ACTIONS(6305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6307),
    [anon_sym_let] = ACTIONS(6307),
    [anon_sym_This] = ACTIONS(6307),
    [anon_sym_decltype] = ACTIONS(6297),
    [sym_virtual] = ACTIONS(6303),
    [anon_sym_template] = ACTIONS(6297),
    [anon_sym_operator] = ACTIONS(6297),
    [anon_sym_precise] = ACTIONS(6158),
    [anon_sym_shared] = ACTIONS(6158),
    [anon_sym_groupshared] = ACTIONS(6158),
    [anon_sym_uniform] = ACTIONS(6158),
    [anon_sym_row_major] = ACTIONS(6158),
    [anon_sym_column_major] = ACTIONS(6158),
    [anon_sym_globallycoherent] = ACTIONS(6158),
    [anon_sym_centroid] = ACTIONS(6158),
    [anon_sym_noperspective] = ACTIONS(6158),
    [anon_sym_nointerpolation] = ACTIONS(6158),
    [anon_sym_sample] = ACTIONS(6158),
    [anon_sym_linear] = ACTIONS(6158),
    [anon_sym_snorm] = ACTIONS(6158),
    [anon_sym_unorm] = ACTIONS(6158),
    [anon_sym_point] = ACTIONS(6158),
    [anon_sym_line] = ACTIONS(6158),
    [anon_sym_triangleadj] = ACTIONS(6158),
    [anon_sym_lineadj] = ACTIONS(6158),
    [anon_sym_triangle] = ACTIONS(6158),
  },
  [2674] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_qualifiers] = STATE(2666),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(6297),
    [anon_sym_LPAREN2] = ACTIONS(6299),
    [anon_sym_TILDE] = ACTIONS(6299),
    [anon_sym_STAR] = ACTIONS(6299),
    [anon_sym_AMP_AMP] = ACTIONS(6299),
    [anon_sym_AMP] = ACTIONS(6297),
    [anon_sym_SEMI] = ACTIONS(6309),
    [anon_sym___extension__] = ACTIONS(6142),
    [anon_sym_in] = ACTIONS(6303),
    [anon_sym_out] = ACTIONS(6303),
    [anon_sym_inout] = ACTIONS(6303),
    [anon_sym_extern] = ACTIONS(6146),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(6299),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6152),
    [anon_sym___declspec] = ACTIONS(6154),
    [anon_sym___based] = ACTIONS(6297),
    [anon_sym___cdecl] = ACTIONS(6297),
    [anon_sym___clrcall] = ACTIONS(6297),
    [anon_sym___stdcall] = ACTIONS(6297),
    [anon_sym___fastcall] = ACTIONS(6297),
    [anon_sym___thiscall] = ACTIONS(6297),
    [anon_sym___vectorcall] = ACTIONS(6297),
    [anon_sym_LBRACK] = ACTIONS(6297),
    [anon_sym_static] = ACTIONS(6146),
    [anon_sym_register] = ACTIONS(6146),
    [anon_sym_inline] = ACTIONS(6146),
    [anon_sym___inline] = ACTIONS(6146),
    [anon_sym___inline__] = ACTIONS(6146),
    [anon_sym___forceinline] = ACTIONS(6146),
    [anon_sym_thread_local] = ACTIONS(6146),
    [anon_sym___thread] = ACTIONS(6146),
    [anon_sym_const] = ACTIONS(6142),
    [anon_sym_constexpr] = ACTIONS(6142),
    [anon_sym_volatile] = ACTIONS(6142),
    [anon_sym_restrict] = ACTIONS(6142),
    [anon_sym___restrict__] = ACTIONS(6142),
    [anon_sym__Atomic] = ACTIONS(6142),
    [anon_sym__Noreturn] = ACTIONS(6142),
    [anon_sym_noreturn] = ACTIONS(6142),
    [anon_sym_mutable] = ACTIONS(6142),
    [anon_sym_constinit] = ACTIONS(6142),
    [anon_sym_consteval] = ACTIONS(6142),
    [anon_sym_alignas] = ACTIONS(6156),
    [anon_sym__Alignas] = ACTIONS(6156),
    [anon_sym_DOT] = ACTIONS(6305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6307),
    [anon_sym_let] = ACTIONS(6307),
    [anon_sym_This] = ACTIONS(6307),
    [anon_sym_decltype] = ACTIONS(6297),
    [sym_virtual] = ACTIONS(6303),
    [anon_sym_template] = ACTIONS(6297),
    [anon_sym_operator] = ACTIONS(6297),
    [anon_sym_precise] = ACTIONS(6158),
    [anon_sym_shared] = ACTIONS(6158),
    [anon_sym_groupshared] = ACTIONS(6158),
    [anon_sym_uniform] = ACTIONS(6158),
    [anon_sym_row_major] = ACTIONS(6158),
    [anon_sym_column_major] = ACTIONS(6158),
    [anon_sym_globallycoherent] = ACTIONS(6158),
    [anon_sym_centroid] = ACTIONS(6158),
    [anon_sym_noperspective] = ACTIONS(6158),
    [anon_sym_nointerpolation] = ACTIONS(6158),
    [anon_sym_sample] = ACTIONS(6158),
    [anon_sym_linear] = ACTIONS(6158),
    [anon_sym_snorm] = ACTIONS(6158),
    [anon_sym_unorm] = ACTIONS(6158),
    [anon_sym_point] = ACTIONS(6158),
    [anon_sym_line] = ACTIONS(6158),
    [anon_sym_triangleadj] = ACTIONS(6158),
    [anon_sym_lineadj] = ACTIONS(6158),
    [anon_sym_triangle] = ACTIONS(6158),
  },
  [2675] = {
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2371),
    [anon_sym_COMMA] = ACTIONS(2371),
    [anon_sym_RPAREN] = ACTIONS(2371),
    [anon_sym_LPAREN2] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym___extension__] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_out] = ACTIONS(2373),
    [anon_sym_inout] = ACTIONS(2373),
    [anon_sym_extern] = ACTIONS(2373),
    [anon_sym___attribute__] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2371),
    [anon_sym___declspec] = ACTIONS(2373),
    [anon_sym___based] = ACTIONS(2373),
    [anon_sym___cdecl] = ACTIONS(2373),
    [anon_sym___clrcall] = ACTIONS(2373),
    [anon_sym___stdcall] = ACTIONS(2373),
    [anon_sym___fastcall] = ACTIONS(2373),
    [anon_sym___thiscall] = ACTIONS(2373),
    [anon_sym___vectorcall] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_LBRACK] = ACTIONS(2373),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_EQ] = ACTIONS(2371),
    [anon_sym_register] = ACTIONS(2373),
    [anon_sym_inline] = ACTIONS(2373),
    [anon_sym___inline] = ACTIONS(2373),
    [anon_sym___inline__] = ACTIONS(2373),
    [anon_sym___forceinline] = ACTIONS(2373),
    [anon_sym_thread_local] = ACTIONS(2373),
    [anon_sym___thread] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym___restrict__] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym__Noreturn] = ACTIONS(2373),
    [anon_sym_noreturn] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_constinit] = ACTIONS(2373),
    [anon_sym_consteval] = ACTIONS(2373),
    [anon_sym_alignas] = ACTIONS(2373),
    [anon_sym__Alignas] = ACTIONS(2373),
    [anon_sym_DOT] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_This] = ACTIONS(2373),
    [anon_sym_decltype] = ACTIONS(2373),
    [anon_sym_final] = ACTIONS(2373),
    [anon_sym_override] = ACTIONS(2373),
    [sym_virtual] = ACTIONS(2373),
    [anon_sym_template] = ACTIONS(2373),
    [anon_sym_GT2] = ACTIONS(2371),
    [anon_sym_operator] = ACTIONS(2373),
    [anon_sym_precise] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_groupshared] = ACTIONS(2373),
    [anon_sym_uniform] = ACTIONS(2373),
    [anon_sym_row_major] = ACTIONS(2373),
    [anon_sym_column_major] = ACTIONS(2373),
    [anon_sym_globallycoherent] = ACTIONS(2373),
    [anon_sym_centroid] = ACTIONS(2373),
    [anon_sym_noperspective] = ACTIONS(2373),
    [anon_sym_nointerpolation] = ACTIONS(2373),
    [anon_sym_sample] = ACTIONS(2373),
    [anon_sym_linear] = ACTIONS(2373),
    [anon_sym_snorm] = ACTIONS(2373),
    [anon_sym_unorm] = ACTIONS(2373),
    [anon_sym_point] = ACTIONS(2373),
    [anon_sym_line] = ACTIONS(2373),
    [anon_sym_triangleadj] = ACTIONS(2373),
    [anon_sym_lineadj] = ACTIONS(2373),
    [anon_sym_triangle] = ACTIONS(2373),
  },
  [2676] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_qualifiers] = STATE(2666),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(6297),
    [anon_sym_LPAREN2] = ACTIONS(6299),
    [anon_sym_TILDE] = ACTIONS(6299),
    [anon_sym_STAR] = ACTIONS(6299),
    [anon_sym_AMP_AMP] = ACTIONS(6299),
    [anon_sym_AMP] = ACTIONS(6297),
    [anon_sym_SEMI] = ACTIONS(6311),
    [anon_sym___extension__] = ACTIONS(6142),
    [anon_sym_in] = ACTIONS(6303),
    [anon_sym_out] = ACTIONS(6303),
    [anon_sym_inout] = ACTIONS(6303),
    [anon_sym_extern] = ACTIONS(6146),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(6299),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6152),
    [anon_sym___declspec] = ACTIONS(6154),
    [anon_sym___based] = ACTIONS(6297),
    [anon_sym___cdecl] = ACTIONS(6297),
    [anon_sym___clrcall] = ACTIONS(6297),
    [anon_sym___stdcall] = ACTIONS(6297),
    [anon_sym___fastcall] = ACTIONS(6297),
    [anon_sym___thiscall] = ACTIONS(6297),
    [anon_sym___vectorcall] = ACTIONS(6297),
    [anon_sym_LBRACK] = ACTIONS(6297),
    [anon_sym_static] = ACTIONS(6146),
    [anon_sym_register] = ACTIONS(6146),
    [anon_sym_inline] = ACTIONS(6146),
    [anon_sym___inline] = ACTIONS(6146),
    [anon_sym___inline__] = ACTIONS(6146),
    [anon_sym___forceinline] = ACTIONS(6146),
    [anon_sym_thread_local] = ACTIONS(6146),
    [anon_sym___thread] = ACTIONS(6146),
    [anon_sym_const] = ACTIONS(6142),
    [anon_sym_constexpr] = ACTIONS(6142),
    [anon_sym_volatile] = ACTIONS(6142),
    [anon_sym_restrict] = ACTIONS(6142),
    [anon_sym___restrict__] = ACTIONS(6142),
    [anon_sym__Atomic] = ACTIONS(6142),
    [anon_sym__Noreturn] = ACTIONS(6142),
    [anon_sym_noreturn] = ACTIONS(6142),
    [anon_sym_mutable] = ACTIONS(6142),
    [anon_sym_constinit] = ACTIONS(6142),
    [anon_sym_consteval] = ACTIONS(6142),
    [anon_sym_alignas] = ACTIONS(6156),
    [anon_sym__Alignas] = ACTIONS(6156),
    [anon_sym_DOT] = ACTIONS(6305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6307),
    [anon_sym_let] = ACTIONS(6307),
    [anon_sym_This] = ACTIONS(6307),
    [anon_sym_decltype] = ACTIONS(6297),
    [sym_virtual] = ACTIONS(6303),
    [anon_sym_template] = ACTIONS(6297),
    [anon_sym_operator] = ACTIONS(6297),
    [anon_sym_precise] = ACTIONS(6158),
    [anon_sym_shared] = ACTIONS(6158),
    [anon_sym_groupshared] = ACTIONS(6158),
    [anon_sym_uniform] = ACTIONS(6158),
    [anon_sym_row_major] = ACTIONS(6158),
    [anon_sym_column_major] = ACTIONS(6158),
    [anon_sym_globallycoherent] = ACTIONS(6158),
    [anon_sym_centroid] = ACTIONS(6158),
    [anon_sym_noperspective] = ACTIONS(6158),
    [anon_sym_nointerpolation] = ACTIONS(6158),
    [anon_sym_sample] = ACTIONS(6158),
    [anon_sym_linear] = ACTIONS(6158),
    [anon_sym_snorm] = ACTIONS(6158),
    [anon_sym_unorm] = ACTIONS(6158),
    [anon_sym_point] = ACTIONS(6158),
    [anon_sym_line] = ACTIONS(6158),
    [anon_sym_triangleadj] = ACTIONS(6158),
    [anon_sym_lineadj] = ACTIONS(6158),
    [anon_sym_triangle] = ACTIONS(6158),
  },
  [2677] = {
    [sym_attribute_specifier] = STATE(2766),
    [sym_enumerator_list] = STATE(2702),
    [sym_identifier] = ACTIONS(3711),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3713),
    [anon_sym_COMMA] = ACTIONS(3713),
    [anon_sym_RPAREN] = ACTIONS(3713),
    [anon_sym_LPAREN2] = ACTIONS(3713),
    [anon_sym_TILDE] = ACTIONS(3713),
    [anon_sym_STAR] = ACTIONS(3713),
    [anon_sym_AMP_AMP] = ACTIONS(3713),
    [anon_sym_AMP] = ACTIONS(3711),
    [anon_sym_COLON] = ACTIONS(3711),
    [anon_sym_SEMI] = ACTIONS(3713),
    [anon_sym___extension__] = ACTIONS(3711),
    [anon_sym_in] = ACTIONS(3711),
    [anon_sym_out] = ACTIONS(3711),
    [anon_sym_inout] = ACTIONS(3711),
    [anon_sym_extern] = ACTIONS(3711),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(3713),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3713),
    [anon_sym___declspec] = ACTIONS(3711),
    [anon_sym___based] = ACTIONS(3711),
    [anon_sym___cdecl] = ACTIONS(3711),
    [anon_sym___clrcall] = ACTIONS(3711),
    [anon_sym___stdcall] = ACTIONS(3711),
    [anon_sym___fastcall] = ACTIONS(3711),
    [anon_sym___thiscall] = ACTIONS(3711),
    [anon_sym___vectorcall] = ACTIONS(3711),
    [anon_sym_LBRACE] = ACTIONS(6313),
    [anon_sym_LBRACK] = ACTIONS(3711),
    [anon_sym_static] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3713),
    [anon_sym_register] = ACTIONS(3711),
    [anon_sym_inline] = ACTIONS(3711),
    [anon_sym___inline] = ACTIONS(3711),
    [anon_sym___inline__] = ACTIONS(3711),
    [anon_sym___forceinline] = ACTIONS(3711),
    [anon_sym_thread_local] = ACTIONS(3711),
    [anon_sym___thread] = ACTIONS(3711),
    [anon_sym_const] = ACTIONS(3711),
    [anon_sym_constexpr] = ACTIONS(3711),
    [anon_sym_volatile] = ACTIONS(3711),
    [anon_sym_restrict] = ACTIONS(3711),
    [anon_sym___restrict__] = ACTIONS(3711),
    [anon_sym__Atomic] = ACTIONS(3711),
    [anon_sym__Noreturn] = ACTIONS(3711),
    [anon_sym_noreturn] = ACTIONS(3711),
    [anon_sym_mutable] = ACTIONS(3711),
    [anon_sym_constinit] = ACTIONS(3711),
    [anon_sym_consteval] = ACTIONS(3711),
    [anon_sym_alignas] = ACTIONS(3711),
    [anon_sym__Alignas] = ACTIONS(3711),
    [anon_sym_DOT] = ACTIONS(3711),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_This] = ACTIONS(3711),
    [anon_sym_decltype] = ACTIONS(3711),
    [sym_virtual] = ACTIONS(3711),
    [anon_sym_template] = ACTIONS(3711),
    [anon_sym_GT2] = ACTIONS(3713),
    [anon_sym_operator] = ACTIONS(3711),
    [anon_sym_precise] = ACTIONS(3711),
    [anon_sym_shared] = ACTIONS(3711),
    [anon_sym_groupshared] = ACTIONS(3711),
    [anon_sym_uniform] = ACTIONS(3711),
    [anon_sym_row_major] = ACTIONS(3711),
    [anon_sym_column_major] = ACTIONS(3711),
    [anon_sym_globallycoherent] = ACTIONS(3711),
    [anon_sym_centroid] = ACTIONS(3711),
    [anon_sym_noperspective] = ACTIONS(3711),
    [anon_sym_nointerpolation] = ACTIONS(3711),
    [anon_sym_sample] = ACTIONS(3711),
    [anon_sym_linear] = ACTIONS(3711),
    [anon_sym_snorm] = ACTIONS(3711),
    [anon_sym_unorm] = ACTIONS(3711),
    [anon_sym_point] = ACTIONS(3711),
    [anon_sym_line] = ACTIONS(3711),
    [anon_sym_triangleadj] = ACTIONS(3711),
    [anon_sym_lineadj] = ACTIONS(3711),
    [anon_sym_triangle] = ACTIONS(3711),
  },
  [2678] = {
    [sym_attribute_specifier] = STATE(2757),
    [sym_enumerator_list] = STATE(2713),
    [sym_identifier] = ACTIONS(3715),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3717),
    [anon_sym_COMMA] = ACTIONS(3717),
    [anon_sym_RPAREN] = ACTIONS(3717),
    [anon_sym_LPAREN2] = ACTIONS(3717),
    [anon_sym_TILDE] = ACTIONS(3717),
    [anon_sym_STAR] = ACTIONS(3717),
    [anon_sym_AMP_AMP] = ACTIONS(3717),
    [anon_sym_AMP] = ACTIONS(3715),
    [anon_sym_COLON] = ACTIONS(3715),
    [anon_sym_SEMI] = ACTIONS(3717),
    [anon_sym___extension__] = ACTIONS(3715),
    [anon_sym_in] = ACTIONS(3715),
    [anon_sym_out] = ACTIONS(3715),
    [anon_sym_inout] = ACTIONS(3715),
    [anon_sym_extern] = ACTIONS(3715),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(3717),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3717),
    [anon_sym___declspec] = ACTIONS(3715),
    [anon_sym___based] = ACTIONS(3715),
    [anon_sym___cdecl] = ACTIONS(3715),
    [anon_sym___clrcall] = ACTIONS(3715),
    [anon_sym___stdcall] = ACTIONS(3715),
    [anon_sym___fastcall] = ACTIONS(3715),
    [anon_sym___thiscall] = ACTIONS(3715),
    [anon_sym___vectorcall] = ACTIONS(3715),
    [anon_sym_LBRACE] = ACTIONS(6313),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_static] = ACTIONS(3715),
    [anon_sym_EQ] = ACTIONS(3717),
    [anon_sym_register] = ACTIONS(3715),
    [anon_sym_inline] = ACTIONS(3715),
    [anon_sym___inline] = ACTIONS(3715),
    [anon_sym___inline__] = ACTIONS(3715),
    [anon_sym___forceinline] = ACTIONS(3715),
    [anon_sym_thread_local] = ACTIONS(3715),
    [anon_sym___thread] = ACTIONS(3715),
    [anon_sym_const] = ACTIONS(3715),
    [anon_sym_constexpr] = ACTIONS(3715),
    [anon_sym_volatile] = ACTIONS(3715),
    [anon_sym_restrict] = ACTIONS(3715),
    [anon_sym___restrict__] = ACTIONS(3715),
    [anon_sym__Atomic] = ACTIONS(3715),
    [anon_sym__Noreturn] = ACTIONS(3715),
    [anon_sym_noreturn] = ACTIONS(3715),
    [anon_sym_mutable] = ACTIONS(3715),
    [anon_sym_constinit] = ACTIONS(3715),
    [anon_sym_consteval] = ACTIONS(3715),
    [anon_sym_alignas] = ACTIONS(3715),
    [anon_sym__Alignas] = ACTIONS(3715),
    [anon_sym_DOT] = ACTIONS(3715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3715),
    [anon_sym_let] = ACTIONS(3715),
    [anon_sym_This] = ACTIONS(3715),
    [anon_sym_decltype] = ACTIONS(3715),
    [sym_virtual] = ACTIONS(3715),
    [anon_sym_template] = ACTIONS(3715),
    [anon_sym_GT2] = ACTIONS(3717),
    [anon_sym_operator] = ACTIONS(3715),
    [anon_sym_precise] = ACTIONS(3715),
    [anon_sym_shared] = ACTIONS(3715),
    [anon_sym_groupshared] = ACTIONS(3715),
    [anon_sym_uniform] = ACTIONS(3715),
    [anon_sym_row_major] = ACTIONS(3715),
    [anon_sym_column_major] = ACTIONS(3715),
    [anon_sym_globallycoherent] = ACTIONS(3715),
    [anon_sym_centroid] = ACTIONS(3715),
    [anon_sym_noperspective] = ACTIONS(3715),
    [anon_sym_nointerpolation] = ACTIONS(3715),
    [anon_sym_sample] = ACTIONS(3715),
    [anon_sym_linear] = ACTIONS(3715),
    [anon_sym_snorm] = ACTIONS(3715),
    [anon_sym_unorm] = ACTIONS(3715),
    [anon_sym_point] = ACTIONS(3715),
    [anon_sym_line] = ACTIONS(3715),
    [anon_sym_triangleadj] = ACTIONS(3715),
    [anon_sym_lineadj] = ACTIONS(3715),
    [anon_sym_triangle] = ACTIONS(3715),
  },
  [2679] = {
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2371),
    [anon_sym_COMMA] = ACTIONS(2371),
    [anon_sym_RPAREN] = ACTIONS(2371),
    [anon_sym_LPAREN2] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym___extension__] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_out] = ACTIONS(2373),
    [anon_sym_inout] = ACTIONS(2373),
    [anon_sym_extern] = ACTIONS(2373),
    [anon_sym___attribute__] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2371),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2371),
    [anon_sym___declspec] = ACTIONS(2373),
    [anon_sym___based] = ACTIONS(2373),
    [anon_sym___cdecl] = ACTIONS(2373),
    [anon_sym___clrcall] = ACTIONS(2373),
    [anon_sym___stdcall] = ACTIONS(2373),
    [anon_sym___fastcall] = ACTIONS(2373),
    [anon_sym___thiscall] = ACTIONS(2373),
    [anon_sym___vectorcall] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_LBRACK] = ACTIONS(2373),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_EQ] = ACTIONS(2371),
    [anon_sym_register] = ACTIONS(2373),
    [anon_sym_inline] = ACTIONS(2373),
    [anon_sym___inline] = ACTIONS(2373),
    [anon_sym___inline__] = ACTIONS(2373),
    [anon_sym___forceinline] = ACTIONS(2373),
    [anon_sym_thread_local] = ACTIONS(2373),
    [anon_sym___thread] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym___restrict__] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym__Noreturn] = ACTIONS(2373),
    [anon_sym_noreturn] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_constinit] = ACTIONS(2373),
    [anon_sym_consteval] = ACTIONS(2373),
    [anon_sym_alignas] = ACTIONS(2373),
    [anon_sym__Alignas] = ACTIONS(2373),
    [anon_sym_DOT] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_This] = ACTIONS(2373),
    [anon_sym_decltype] = ACTIONS(2373),
    [anon_sym_final] = ACTIONS(2373),
    [anon_sym_override] = ACTIONS(2373),
    [sym_virtual] = ACTIONS(2373),
    [anon_sym_template] = ACTIONS(2373),
    [anon_sym_GT2] = ACTIONS(2371),
    [anon_sym_operator] = ACTIONS(2373),
    [anon_sym_precise] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_groupshared] = ACTIONS(2373),
    [anon_sym_uniform] = ACTIONS(2373),
    [anon_sym_row_major] = ACTIONS(2373),
    [anon_sym_column_major] = ACTIONS(2373),
    [anon_sym_globallycoherent] = ACTIONS(2373),
    [anon_sym_centroid] = ACTIONS(2373),
    [anon_sym_noperspective] = ACTIONS(2373),
    [anon_sym_nointerpolation] = ACTIONS(2373),
    [anon_sym_sample] = ACTIONS(2373),
    [anon_sym_linear] = ACTIONS(2373),
    [anon_sym_snorm] = ACTIONS(2373),
    [anon_sym_unorm] = ACTIONS(2373),
    [anon_sym_point] = ACTIONS(2373),
    [anon_sym_line] = ACTIONS(2373),
    [anon_sym_triangleadj] = ACTIONS(2373),
    [anon_sym_lineadj] = ACTIONS(2373),
    [anon_sym_triangle] = ACTIONS(2373),
  },
  [2680] = {
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2371),
    [anon_sym_COMMA] = ACTIONS(2371),
    [anon_sym_RPAREN] = ACTIONS(2371),
    [anon_sym_LPAREN2] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym___extension__] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_out] = ACTIONS(2373),
    [anon_sym_inout] = ACTIONS(2373),
    [anon_sym_extern] = ACTIONS(2373),
    [anon_sym___attribute__] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2371),
    [anon_sym___declspec] = ACTIONS(2373),
    [anon_sym___based] = ACTIONS(2373),
    [anon_sym___cdecl] = ACTIONS(2373),
    [anon_sym___clrcall] = ACTIONS(2373),
    [anon_sym___stdcall] = ACTIONS(2373),
    [anon_sym___fastcall] = ACTIONS(2373),
    [anon_sym___thiscall] = ACTIONS(2373),
    [anon_sym___vectorcall] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_LBRACK] = ACTIONS(2373),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_EQ] = ACTIONS(2371),
    [anon_sym_register] = ACTIONS(2373),
    [anon_sym_inline] = ACTIONS(2373),
    [anon_sym___inline] = ACTIONS(2373),
    [anon_sym___inline__] = ACTIONS(2373),
    [anon_sym___forceinline] = ACTIONS(2373),
    [anon_sym_thread_local] = ACTIONS(2373),
    [anon_sym___thread] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym___restrict__] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym__Noreturn] = ACTIONS(2373),
    [anon_sym_noreturn] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_constinit] = ACTIONS(2373),
    [anon_sym_consteval] = ACTIONS(2373),
    [anon_sym_alignas] = ACTIONS(2373),
    [anon_sym__Alignas] = ACTIONS(2373),
    [anon_sym_DOT] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_This] = ACTIONS(2373),
    [anon_sym_decltype] = ACTIONS(2373),
    [anon_sym_final] = ACTIONS(2373),
    [anon_sym_override] = ACTIONS(2373),
    [sym_virtual] = ACTIONS(2373),
    [anon_sym_template] = ACTIONS(2373),
    [anon_sym_GT2] = ACTIONS(2371),
    [anon_sym_operator] = ACTIONS(2373),
    [anon_sym_precise] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_groupshared] = ACTIONS(2373),
    [anon_sym_uniform] = ACTIONS(2373),
    [anon_sym_row_major] = ACTIONS(2373),
    [anon_sym_column_major] = ACTIONS(2373),
    [anon_sym_globallycoherent] = ACTIONS(2373),
    [anon_sym_centroid] = ACTIONS(2373),
    [anon_sym_noperspective] = ACTIONS(2373),
    [anon_sym_nointerpolation] = ACTIONS(2373),
    [anon_sym_sample] = ACTIONS(2373),
    [anon_sym_linear] = ACTIONS(2373),
    [anon_sym_snorm] = ACTIONS(2373),
    [anon_sym_unorm] = ACTIONS(2373),
    [anon_sym_point] = ACTIONS(2373),
    [anon_sym_line] = ACTIONS(2373),
    [anon_sym_triangleadj] = ACTIONS(2373),
    [anon_sym_lineadj] = ACTIONS(2373),
    [anon_sym_triangle] = ACTIONS(2373),
  },
  [2681] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_qualifiers] = STATE(2666),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(6297),
    [anon_sym_LPAREN2] = ACTIONS(6299),
    [anon_sym_TILDE] = ACTIONS(6299),
    [anon_sym_STAR] = ACTIONS(6299),
    [anon_sym_AMP_AMP] = ACTIONS(6299),
    [anon_sym_AMP] = ACTIONS(6297),
    [anon_sym_SEMI] = ACTIONS(2701),
    [anon_sym___extension__] = ACTIONS(6142),
    [anon_sym_in] = ACTIONS(6303),
    [anon_sym_out] = ACTIONS(6303),
    [anon_sym_inout] = ACTIONS(6303),
    [anon_sym_extern] = ACTIONS(6146),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(6299),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6152),
    [anon_sym___declspec] = ACTIONS(6154),
    [anon_sym___based] = ACTIONS(6297),
    [anon_sym___cdecl] = ACTIONS(6297),
    [anon_sym___clrcall] = ACTIONS(6297),
    [anon_sym___stdcall] = ACTIONS(6297),
    [anon_sym___fastcall] = ACTIONS(6297),
    [anon_sym___thiscall] = ACTIONS(6297),
    [anon_sym___vectorcall] = ACTIONS(6297),
    [anon_sym_LBRACK] = ACTIONS(6297),
    [anon_sym_static] = ACTIONS(6146),
    [anon_sym_register] = ACTIONS(6146),
    [anon_sym_inline] = ACTIONS(6146),
    [anon_sym___inline] = ACTIONS(6146),
    [anon_sym___inline__] = ACTIONS(6146),
    [anon_sym___forceinline] = ACTIONS(6146),
    [anon_sym_thread_local] = ACTIONS(6146),
    [anon_sym___thread] = ACTIONS(6146),
    [anon_sym_const] = ACTIONS(6142),
    [anon_sym_constexpr] = ACTIONS(6142),
    [anon_sym_volatile] = ACTIONS(6142),
    [anon_sym_restrict] = ACTIONS(6142),
    [anon_sym___restrict__] = ACTIONS(6142),
    [anon_sym__Atomic] = ACTIONS(6142),
    [anon_sym__Noreturn] = ACTIONS(6142),
    [anon_sym_noreturn] = ACTIONS(6142),
    [anon_sym_mutable] = ACTIONS(6142),
    [anon_sym_constinit] = ACTIONS(6142),
    [anon_sym_consteval] = ACTIONS(6142),
    [anon_sym_alignas] = ACTIONS(6156),
    [anon_sym__Alignas] = ACTIONS(6156),
    [anon_sym_DOT] = ACTIONS(6305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6307),
    [anon_sym_let] = ACTIONS(6307),
    [anon_sym_This] = ACTIONS(6307),
    [anon_sym_decltype] = ACTIONS(6297),
    [sym_virtual] = ACTIONS(6303),
    [anon_sym_template] = ACTIONS(6297),
    [anon_sym_operator] = ACTIONS(6297),
    [anon_sym_precise] = ACTIONS(6158),
    [anon_sym_shared] = ACTIONS(6158),
    [anon_sym_groupshared] = ACTIONS(6158),
    [anon_sym_uniform] = ACTIONS(6158),
    [anon_sym_row_major] = ACTIONS(6158),
    [anon_sym_column_major] = ACTIONS(6158),
    [anon_sym_globallycoherent] = ACTIONS(6158),
    [anon_sym_centroid] = ACTIONS(6158),
    [anon_sym_noperspective] = ACTIONS(6158),
    [anon_sym_nointerpolation] = ACTIONS(6158),
    [anon_sym_sample] = ACTIONS(6158),
    [anon_sym_linear] = ACTIONS(6158),
    [anon_sym_snorm] = ACTIONS(6158),
    [anon_sym_unorm] = ACTIONS(6158),
    [anon_sym_point] = ACTIONS(6158),
    [anon_sym_line] = ACTIONS(6158),
    [anon_sym_triangleadj] = ACTIONS(6158),
    [anon_sym_lineadj] = ACTIONS(6158),
    [anon_sym_triangle] = ACTIONS(6158),
  },
  [2682] = {
    [sym_identifier] = ACTIONS(2367),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(2365),
    [anon_sym_RPAREN] = ACTIONS(2365),
    [anon_sym_LPAREN2] = ACTIONS(2365),
    [anon_sym_TILDE] = ACTIONS(2365),
    [anon_sym_STAR] = ACTIONS(2365),
    [anon_sym_AMP_AMP] = ACTIONS(2365),
    [anon_sym_AMP] = ACTIONS(2367),
    [anon_sym_COLON] = ACTIONS(2367),
    [anon_sym_SEMI] = ACTIONS(2365),
    [anon_sym___extension__] = ACTIONS(2367),
    [anon_sym_in] = ACTIONS(2367),
    [anon_sym_out] = ACTIONS(2367),
    [anon_sym_inout] = ACTIONS(2367),
    [anon_sym_extern] = ACTIONS(2367),
    [anon_sym___attribute__] = ACTIONS(2367),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2365),
    [anon_sym___declspec] = ACTIONS(2367),
    [anon_sym___based] = ACTIONS(2367),
    [anon_sym___cdecl] = ACTIONS(2367),
    [anon_sym___clrcall] = ACTIONS(2367),
    [anon_sym___stdcall] = ACTIONS(2367),
    [anon_sym___fastcall] = ACTIONS(2367),
    [anon_sym___thiscall] = ACTIONS(2367),
    [anon_sym___vectorcall] = ACTIONS(2367),
    [anon_sym_LBRACE] = ACTIONS(2365),
    [anon_sym_LBRACK] = ACTIONS(2367),
    [anon_sym_static] = ACTIONS(2367),
    [anon_sym_EQ] = ACTIONS(2365),
    [anon_sym_register] = ACTIONS(2367),
    [anon_sym_inline] = ACTIONS(2367),
    [anon_sym___inline] = ACTIONS(2367),
    [anon_sym___inline__] = ACTIONS(2367),
    [anon_sym___forceinline] = ACTIONS(2367),
    [anon_sym_thread_local] = ACTIONS(2367),
    [anon_sym___thread] = ACTIONS(2367),
    [anon_sym_const] = ACTIONS(2367),
    [anon_sym_constexpr] = ACTIONS(2367),
    [anon_sym_volatile] = ACTIONS(2367),
    [anon_sym_restrict] = ACTIONS(2367),
    [anon_sym___restrict__] = ACTIONS(2367),
    [anon_sym__Atomic] = ACTIONS(2367),
    [anon_sym__Noreturn] = ACTIONS(2367),
    [anon_sym_noreturn] = ACTIONS(2367),
    [anon_sym_mutable] = ACTIONS(2367),
    [anon_sym_constinit] = ACTIONS(2367),
    [anon_sym_consteval] = ACTIONS(2367),
    [anon_sym_alignas] = ACTIONS(2367),
    [anon_sym__Alignas] = ACTIONS(2367),
    [anon_sym_DOT] = ACTIONS(2367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2367),
    [anon_sym_let] = ACTIONS(2367),
    [anon_sym_This] = ACTIONS(2367),
    [anon_sym_decltype] = ACTIONS(2367),
    [anon_sym_final] = ACTIONS(2367),
    [anon_sym_override] = ACTIONS(2367),
    [sym_virtual] = ACTIONS(2367),
    [anon_sym_template] = ACTIONS(2367),
    [anon_sym_GT2] = ACTIONS(2365),
    [anon_sym_operator] = ACTIONS(2367),
    [anon_sym_precise] = ACTIONS(2367),
    [anon_sym_shared] = ACTIONS(2367),
    [anon_sym_groupshared] = ACTIONS(2367),
    [anon_sym_uniform] = ACTIONS(2367),
    [anon_sym_row_major] = ACTIONS(2367),
    [anon_sym_column_major] = ACTIONS(2367),
    [anon_sym_globallycoherent] = ACTIONS(2367),
    [anon_sym_centroid] = ACTIONS(2367),
    [anon_sym_noperspective] = ACTIONS(2367),
    [anon_sym_nointerpolation] = ACTIONS(2367),
    [anon_sym_sample] = ACTIONS(2367),
    [anon_sym_linear] = ACTIONS(2367),
    [anon_sym_snorm] = ACTIONS(2367),
    [anon_sym_unorm] = ACTIONS(2367),
    [anon_sym_point] = ACTIONS(2367),
    [anon_sym_line] = ACTIONS(2367),
    [anon_sym_triangleadj] = ACTIONS(2367),
    [anon_sym_lineadj] = ACTIONS(2367),
    [anon_sym_triangle] = ACTIONS(2367),
  },
  [2683] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_qualifiers] = STATE(2666),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(6297),
    [anon_sym_LPAREN2] = ACTIONS(6299),
    [anon_sym_TILDE] = ACTIONS(6299),
    [anon_sym_STAR] = ACTIONS(6299),
    [anon_sym_AMP_AMP] = ACTIONS(6299),
    [anon_sym_AMP] = ACTIONS(6297),
    [anon_sym_SEMI] = ACTIONS(6315),
    [anon_sym___extension__] = ACTIONS(6142),
    [anon_sym_in] = ACTIONS(6303),
    [anon_sym_out] = ACTIONS(6303),
    [anon_sym_inout] = ACTIONS(6303),
    [anon_sym_extern] = ACTIONS(6146),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(6299),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6152),
    [anon_sym___declspec] = ACTIONS(6154),
    [anon_sym___based] = ACTIONS(6297),
    [anon_sym___cdecl] = ACTIONS(6297),
    [anon_sym___clrcall] = ACTIONS(6297),
    [anon_sym___stdcall] = ACTIONS(6297),
    [anon_sym___fastcall] = ACTIONS(6297),
    [anon_sym___thiscall] = ACTIONS(6297),
    [anon_sym___vectorcall] = ACTIONS(6297),
    [anon_sym_LBRACK] = ACTIONS(6297),
    [anon_sym_static] = ACTIONS(6146),
    [anon_sym_register] = ACTIONS(6146),
    [anon_sym_inline] = ACTIONS(6146),
    [anon_sym___inline] = ACTIONS(6146),
    [anon_sym___inline__] = ACTIONS(6146),
    [anon_sym___forceinline] = ACTIONS(6146),
    [anon_sym_thread_local] = ACTIONS(6146),
    [anon_sym___thread] = ACTIONS(6146),
    [anon_sym_const] = ACTIONS(6142),
    [anon_sym_constexpr] = ACTIONS(6142),
    [anon_sym_volatile] = ACTIONS(6142),
    [anon_sym_restrict] = ACTIONS(6142),
    [anon_sym___restrict__] = ACTIONS(6142),
    [anon_sym__Atomic] = ACTIONS(6142),
    [anon_sym__Noreturn] = ACTIONS(6142),
    [anon_sym_noreturn] = ACTIONS(6142),
    [anon_sym_mutable] = ACTIONS(6142),
    [anon_sym_constinit] = ACTIONS(6142),
    [anon_sym_consteval] = ACTIONS(6142),
    [anon_sym_alignas] = ACTIONS(6156),
    [anon_sym__Alignas] = ACTIONS(6156),
    [anon_sym_DOT] = ACTIONS(6305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6307),
    [anon_sym_let] = ACTIONS(6307),
    [anon_sym_This] = ACTIONS(6307),
    [anon_sym_decltype] = ACTIONS(6297),
    [sym_virtual] = ACTIONS(6303),
    [anon_sym_template] = ACTIONS(6297),
    [anon_sym_operator] = ACTIONS(6297),
    [anon_sym_precise] = ACTIONS(6158),
    [anon_sym_shared] = ACTIONS(6158),
    [anon_sym_groupshared] = ACTIONS(6158),
    [anon_sym_uniform] = ACTIONS(6158),
    [anon_sym_row_major] = ACTIONS(6158),
    [anon_sym_column_major] = ACTIONS(6158),
    [anon_sym_globallycoherent] = ACTIONS(6158),
    [anon_sym_centroid] = ACTIONS(6158),
    [anon_sym_noperspective] = ACTIONS(6158),
    [anon_sym_nointerpolation] = ACTIONS(6158),
    [anon_sym_sample] = ACTIONS(6158),
    [anon_sym_linear] = ACTIONS(6158),
    [anon_sym_snorm] = ACTIONS(6158),
    [anon_sym_unorm] = ACTIONS(6158),
    [anon_sym_point] = ACTIONS(6158),
    [anon_sym_line] = ACTIONS(6158),
    [anon_sym_triangleadj] = ACTIONS(6158),
    [anon_sym_lineadj] = ACTIONS(6158),
    [anon_sym_triangle] = ACTIONS(6158),
  },
  [2684] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_qualifiers] = STATE(2666),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(6297),
    [anon_sym_LPAREN2] = ACTIONS(6299),
    [anon_sym_TILDE] = ACTIONS(6299),
    [anon_sym_STAR] = ACTIONS(6299),
    [anon_sym_AMP_AMP] = ACTIONS(6299),
    [anon_sym_AMP] = ACTIONS(6297),
    [anon_sym_SEMI] = ACTIONS(6317),
    [anon_sym___extension__] = ACTIONS(6142),
    [anon_sym_in] = ACTIONS(6303),
    [anon_sym_out] = ACTIONS(6303),
    [anon_sym_inout] = ACTIONS(6303),
    [anon_sym_extern] = ACTIONS(6146),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(6299),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6152),
    [anon_sym___declspec] = ACTIONS(6154),
    [anon_sym___based] = ACTIONS(6297),
    [anon_sym___cdecl] = ACTIONS(6297),
    [anon_sym___clrcall] = ACTIONS(6297),
    [anon_sym___stdcall] = ACTIONS(6297),
    [anon_sym___fastcall] = ACTIONS(6297),
    [anon_sym___thiscall] = ACTIONS(6297),
    [anon_sym___vectorcall] = ACTIONS(6297),
    [anon_sym_LBRACK] = ACTIONS(6297),
    [anon_sym_static] = ACTIONS(6146),
    [anon_sym_register] = ACTIONS(6146),
    [anon_sym_inline] = ACTIONS(6146),
    [anon_sym___inline] = ACTIONS(6146),
    [anon_sym___inline__] = ACTIONS(6146),
    [anon_sym___forceinline] = ACTIONS(6146),
    [anon_sym_thread_local] = ACTIONS(6146),
    [anon_sym___thread] = ACTIONS(6146),
    [anon_sym_const] = ACTIONS(6142),
    [anon_sym_constexpr] = ACTIONS(6142),
    [anon_sym_volatile] = ACTIONS(6142),
    [anon_sym_restrict] = ACTIONS(6142),
    [anon_sym___restrict__] = ACTIONS(6142),
    [anon_sym__Atomic] = ACTIONS(6142),
    [anon_sym__Noreturn] = ACTIONS(6142),
    [anon_sym_noreturn] = ACTIONS(6142),
    [anon_sym_mutable] = ACTIONS(6142),
    [anon_sym_constinit] = ACTIONS(6142),
    [anon_sym_consteval] = ACTIONS(6142),
    [anon_sym_alignas] = ACTIONS(6156),
    [anon_sym__Alignas] = ACTIONS(6156),
    [anon_sym_DOT] = ACTIONS(6305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6307),
    [anon_sym_let] = ACTIONS(6307),
    [anon_sym_This] = ACTIONS(6307),
    [anon_sym_decltype] = ACTIONS(6297),
    [sym_virtual] = ACTIONS(6303),
    [anon_sym_template] = ACTIONS(6297),
    [anon_sym_operator] = ACTIONS(6297),
    [anon_sym_precise] = ACTIONS(6158),
    [anon_sym_shared] = ACTIONS(6158),
    [anon_sym_groupshared] = ACTIONS(6158),
    [anon_sym_uniform] = ACTIONS(6158),
    [anon_sym_row_major] = ACTIONS(6158),
    [anon_sym_column_major] = ACTIONS(6158),
    [anon_sym_globallycoherent] = ACTIONS(6158),
    [anon_sym_centroid] = ACTIONS(6158),
    [anon_sym_noperspective] = ACTIONS(6158),
    [anon_sym_nointerpolation] = ACTIONS(6158),
    [anon_sym_sample] = ACTIONS(6158),
    [anon_sym_linear] = ACTIONS(6158),
    [anon_sym_snorm] = ACTIONS(6158),
    [anon_sym_unorm] = ACTIONS(6158),
    [anon_sym_point] = ACTIONS(6158),
    [anon_sym_line] = ACTIONS(6158),
    [anon_sym_triangleadj] = ACTIONS(6158),
    [anon_sym_lineadj] = ACTIONS(6158),
    [anon_sym_triangle] = ACTIONS(6158),
  },
  [2685] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_qualifiers] = STATE(2666),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(6297),
    [anon_sym_LPAREN2] = ACTIONS(6299),
    [anon_sym_TILDE] = ACTIONS(6299),
    [anon_sym_STAR] = ACTIONS(6299),
    [anon_sym_AMP_AMP] = ACTIONS(6299),
    [anon_sym_AMP] = ACTIONS(6297),
    [anon_sym_SEMI] = ACTIONS(6319),
    [anon_sym___extension__] = ACTIONS(6142),
    [anon_sym_in] = ACTIONS(6303),
    [anon_sym_out] = ACTIONS(6303),
    [anon_sym_inout] = ACTIONS(6303),
    [anon_sym_extern] = ACTIONS(6146),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(6299),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6152),
    [anon_sym___declspec] = ACTIONS(6154),
    [anon_sym___based] = ACTIONS(6297),
    [anon_sym___cdecl] = ACTIONS(6297),
    [anon_sym___clrcall] = ACTIONS(6297),
    [anon_sym___stdcall] = ACTIONS(6297),
    [anon_sym___fastcall] = ACTIONS(6297),
    [anon_sym___thiscall] = ACTIONS(6297),
    [anon_sym___vectorcall] = ACTIONS(6297),
    [anon_sym_LBRACK] = ACTIONS(6297),
    [anon_sym_static] = ACTIONS(6146),
    [anon_sym_register] = ACTIONS(6146),
    [anon_sym_inline] = ACTIONS(6146),
    [anon_sym___inline] = ACTIONS(6146),
    [anon_sym___inline__] = ACTIONS(6146),
    [anon_sym___forceinline] = ACTIONS(6146),
    [anon_sym_thread_local] = ACTIONS(6146),
    [anon_sym___thread] = ACTIONS(6146),
    [anon_sym_const] = ACTIONS(6142),
    [anon_sym_constexpr] = ACTIONS(6142),
    [anon_sym_volatile] = ACTIONS(6142),
    [anon_sym_restrict] = ACTIONS(6142),
    [anon_sym___restrict__] = ACTIONS(6142),
    [anon_sym__Atomic] = ACTIONS(6142),
    [anon_sym__Noreturn] = ACTIONS(6142),
    [anon_sym_noreturn] = ACTIONS(6142),
    [anon_sym_mutable] = ACTIONS(6142),
    [anon_sym_constinit] = ACTIONS(6142),
    [anon_sym_consteval] = ACTIONS(6142),
    [anon_sym_alignas] = ACTIONS(6156),
    [anon_sym__Alignas] = ACTIONS(6156),
    [anon_sym_DOT] = ACTIONS(6305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6307),
    [anon_sym_let] = ACTIONS(6307),
    [anon_sym_This] = ACTIONS(6307),
    [anon_sym_decltype] = ACTIONS(6297),
    [sym_virtual] = ACTIONS(6303),
    [anon_sym_template] = ACTIONS(6297),
    [anon_sym_operator] = ACTIONS(6297),
    [anon_sym_precise] = ACTIONS(6158),
    [anon_sym_shared] = ACTIONS(6158),
    [anon_sym_groupshared] = ACTIONS(6158),
    [anon_sym_uniform] = ACTIONS(6158),
    [anon_sym_row_major] = ACTIONS(6158),
    [anon_sym_column_major] = ACTIONS(6158),
    [anon_sym_globallycoherent] = ACTIONS(6158),
    [anon_sym_centroid] = ACTIONS(6158),
    [anon_sym_noperspective] = ACTIONS(6158),
    [anon_sym_nointerpolation] = ACTIONS(6158),
    [anon_sym_sample] = ACTIONS(6158),
    [anon_sym_linear] = ACTIONS(6158),
    [anon_sym_snorm] = ACTIONS(6158),
    [anon_sym_unorm] = ACTIONS(6158),
    [anon_sym_point] = ACTIONS(6158),
    [anon_sym_line] = ACTIONS(6158),
    [anon_sym_triangleadj] = ACTIONS(6158),
    [anon_sym_lineadj] = ACTIONS(6158),
    [anon_sym_triangle] = ACTIONS(6158),
  },
  [2686] = {
    [sym_identifier] = ACTIONS(2210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2217),
    [anon_sym_COMMA] = ACTIONS(2217),
    [anon_sym_RPAREN] = ACTIONS(2217),
    [anon_sym_LPAREN2] = ACTIONS(2217),
    [anon_sym_TILDE] = ACTIONS(2217),
    [anon_sym_STAR] = ACTIONS(2217),
    [anon_sym_AMP_AMP] = ACTIONS(2217),
    [anon_sym_AMP] = ACTIONS(2210),
    [anon_sym_COLON] = ACTIONS(2210),
    [anon_sym_SEMI] = ACTIONS(2217),
    [anon_sym___extension__] = ACTIONS(2210),
    [anon_sym_in] = ACTIONS(2210),
    [anon_sym_out] = ACTIONS(2210),
    [anon_sym_inout] = ACTIONS(2210),
    [anon_sym_extern] = ACTIONS(2210),
    [anon_sym___attribute__] = ACTIONS(2210),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2217),
    [anon_sym___declspec] = ACTIONS(2210),
    [anon_sym___based] = ACTIONS(2210),
    [anon_sym___cdecl] = ACTIONS(2210),
    [anon_sym___clrcall] = ACTIONS(2210),
    [anon_sym___stdcall] = ACTIONS(2210),
    [anon_sym___fastcall] = ACTIONS(2210),
    [anon_sym___thiscall] = ACTIONS(2210),
    [anon_sym___vectorcall] = ACTIONS(2210),
    [anon_sym_LBRACE] = ACTIONS(2217),
    [anon_sym_LBRACK] = ACTIONS(2210),
    [anon_sym_static] = ACTIONS(2210),
    [anon_sym_EQ] = ACTIONS(2217),
    [anon_sym_register] = ACTIONS(2210),
    [anon_sym_inline] = ACTIONS(2210),
    [anon_sym___inline] = ACTIONS(2210),
    [anon_sym___inline__] = ACTIONS(2210),
    [anon_sym___forceinline] = ACTIONS(2210),
    [anon_sym_thread_local] = ACTIONS(2210),
    [anon_sym___thread] = ACTIONS(2210),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_constexpr] = ACTIONS(2210),
    [anon_sym_volatile] = ACTIONS(2210),
    [anon_sym_restrict] = ACTIONS(2210),
    [anon_sym___restrict__] = ACTIONS(2210),
    [anon_sym__Atomic] = ACTIONS(2210),
    [anon_sym__Noreturn] = ACTIONS(2210),
    [anon_sym_noreturn] = ACTIONS(2210),
    [anon_sym_mutable] = ACTIONS(2210),
    [anon_sym_constinit] = ACTIONS(2210),
    [anon_sym_consteval] = ACTIONS(2210),
    [anon_sym_alignas] = ACTIONS(2210),
    [anon_sym__Alignas] = ACTIONS(2210),
    [anon_sym_DOT] = ACTIONS(2210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2210),
    [anon_sym_let] = ACTIONS(2210),
    [anon_sym_This] = ACTIONS(2210),
    [anon_sym_decltype] = ACTIONS(2210),
    [anon_sym_final] = ACTIONS(2210),
    [anon_sym_override] = ACTIONS(2210),
    [sym_virtual] = ACTIONS(2210),
    [anon_sym_template] = ACTIONS(2210),
    [anon_sym_GT2] = ACTIONS(2217),
    [anon_sym_operator] = ACTIONS(2210),
    [anon_sym_precise] = ACTIONS(2210),
    [anon_sym_shared] = ACTIONS(2210),
    [anon_sym_groupshared] = ACTIONS(2210),
    [anon_sym_uniform] = ACTIONS(2210),
    [anon_sym_row_major] = ACTIONS(2210),
    [anon_sym_column_major] = ACTIONS(2210),
    [anon_sym_globallycoherent] = ACTIONS(2210),
    [anon_sym_centroid] = ACTIONS(2210),
    [anon_sym_noperspective] = ACTIONS(2210),
    [anon_sym_nointerpolation] = ACTIONS(2210),
    [anon_sym_sample] = ACTIONS(2210),
    [anon_sym_linear] = ACTIONS(2210),
    [anon_sym_snorm] = ACTIONS(2210),
    [anon_sym_unorm] = ACTIONS(2210),
    [anon_sym_point] = ACTIONS(2210),
    [anon_sym_line] = ACTIONS(2210),
    [anon_sym_triangleadj] = ACTIONS(2210),
    [anon_sym_lineadj] = ACTIONS(2210),
    [anon_sym_triangle] = ACTIONS(2210),
  },
  [2687] = {
    [sym__declaration_modifiers] = STATE(2670),
    [sym_attribute_specifier] = STATE(2670),
    [sym_attribute_declaration] = STATE(2670),
    [sym_ms_declspec_modifier] = STATE(2670),
    [sym_storage_class_specifier] = STATE(2670),
    [sym_type_qualifier] = STATE(2670),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_qualifiers] = STATE(2670),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(6321),
    [anon_sym_LPAREN2] = ACTIONS(6323),
    [anon_sym_TILDE] = ACTIONS(6323),
    [anon_sym_STAR] = ACTIONS(6323),
    [anon_sym_AMP_AMP] = ACTIONS(6323),
    [anon_sym_AMP] = ACTIONS(6321),
    [anon_sym___extension__] = ACTIONS(6142),
    [anon_sym_in] = ACTIONS(6325),
    [anon_sym_out] = ACTIONS(6325),
    [anon_sym_inout] = ACTIONS(6325),
    [anon_sym_extern] = ACTIONS(6146),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(6323),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6152),
    [anon_sym___declspec] = ACTIONS(6154),
    [anon_sym___based] = ACTIONS(6321),
    [anon_sym___cdecl] = ACTIONS(6321),
    [anon_sym___clrcall] = ACTIONS(6321),
    [anon_sym___stdcall] = ACTIONS(6321),
    [anon_sym___fastcall] = ACTIONS(6321),
    [anon_sym___thiscall] = ACTIONS(6321),
    [anon_sym___vectorcall] = ACTIONS(6321),
    [anon_sym_LBRACK] = ACTIONS(6321),
    [anon_sym_static] = ACTIONS(6146),
    [anon_sym_register] = ACTIONS(6146),
    [anon_sym_inline] = ACTIONS(6146),
    [anon_sym___inline] = ACTIONS(6146),
    [anon_sym___inline__] = ACTIONS(6146),
    [anon_sym___forceinline] = ACTIONS(6146),
    [anon_sym_thread_local] = ACTIONS(6146),
    [anon_sym___thread] = ACTIONS(6146),
    [anon_sym_const] = ACTIONS(6142),
    [anon_sym_constexpr] = ACTIONS(6142),
    [anon_sym_volatile] = ACTIONS(6142),
    [anon_sym_restrict] = ACTIONS(6142),
    [anon_sym___restrict__] = ACTIONS(6142),
    [anon_sym__Atomic] = ACTIONS(6142),
    [anon_sym__Noreturn] = ACTIONS(6142),
    [anon_sym_noreturn] = ACTIONS(6142),
    [anon_sym_mutable] = ACTIONS(6142),
    [anon_sym_constinit] = ACTIONS(6142),
    [anon_sym_consteval] = ACTIONS(6142),
    [anon_sym_alignas] = ACTIONS(6156),
    [anon_sym__Alignas] = ACTIONS(6156),
    [anon_sym_DOT] = ACTIONS(6305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6307),
    [anon_sym_let] = ACTIONS(6307),
    [anon_sym_This] = ACTIONS(6307),
    [anon_sym_decltype] = ACTIONS(6321),
    [sym_virtual] = ACTIONS(6325),
    [anon_sym_template] = ACTIONS(6321),
    [anon_sym_operator] = ACTIONS(6321),
    [anon_sym_precise] = ACTIONS(6158),
    [anon_sym_shared] = ACTIONS(6158),
    [anon_sym_groupshared] = ACTIONS(6158),
    [anon_sym_uniform] = ACTIONS(6158),
    [anon_sym_row_major] = ACTIONS(6158),
    [anon_sym_column_major] = ACTIONS(6158),
    [anon_sym_globallycoherent] = ACTIONS(6158),
    [anon_sym_centroid] = ACTIONS(6158),
    [anon_sym_noperspective] = ACTIONS(6158),
    [anon_sym_nointerpolation] = ACTIONS(6158),
    [anon_sym_sample] = ACTIONS(6158),
    [anon_sym_linear] = ACTIONS(6158),
    [anon_sym_snorm] = ACTIONS(6158),
    [anon_sym_unorm] = ACTIONS(6158),
    [anon_sym_point] = ACTIONS(6158),
    [anon_sym_line] = ACTIONS(6158),
    [anon_sym_triangleadj] = ACTIONS(6158),
    [anon_sym_lineadj] = ACTIONS(6158),
    [anon_sym_triangle] = ACTIONS(6158),
  },
  [2688] = {
    [sym__declaration_modifiers] = STATE(2670),
    [sym_attribute_specifier] = STATE(2670),
    [sym_attribute_declaration] = STATE(2670),
    [sym_ms_declspec_modifier] = STATE(2670),
    [sym_storage_class_specifier] = STATE(2670),
    [sym_type_qualifier] = STATE(2670),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_qualifiers] = STATE(2670),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(6321),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6323),
    [anon_sym_COMMA] = ACTIONS(6323),
    [anon_sym_RPAREN] = ACTIONS(6323),
    [anon_sym_LPAREN2] = ACTIONS(6323),
    [anon_sym_TILDE] = ACTIONS(6323),
    [anon_sym_STAR] = ACTIONS(6323),
    [anon_sym_AMP_AMP] = ACTIONS(6323),
    [anon_sym_AMP] = ACTIONS(6321),
    [anon_sym_COLON] = ACTIONS(6321),
    [anon_sym___extension__] = ACTIONS(6142),
    [anon_sym_in] = ACTIONS(6325),
    [anon_sym_out] = ACTIONS(6325),
    [anon_sym_inout] = ACTIONS(6325),
    [anon_sym_extern] = ACTIONS(6146),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(6323),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6152),
    [anon_sym___declspec] = ACTIONS(6154),
    [anon_sym___based] = ACTIONS(6321),
    [anon_sym_LBRACK] = ACTIONS(6321),
    [anon_sym_static] = ACTIONS(6146),
    [anon_sym_EQ] = ACTIONS(6323),
    [anon_sym_register] = ACTIONS(6146),
    [anon_sym_inline] = ACTIONS(6146),
    [anon_sym___inline] = ACTIONS(6146),
    [anon_sym___inline__] = ACTIONS(6146),
    [anon_sym___forceinline] = ACTIONS(6146),
    [anon_sym_thread_local] = ACTIONS(6146),
    [anon_sym___thread] = ACTIONS(6146),
    [anon_sym_const] = ACTIONS(6142),
    [anon_sym_constexpr] = ACTIONS(6142),
    [anon_sym_volatile] = ACTIONS(6142),
    [anon_sym_restrict] = ACTIONS(6142),
    [anon_sym___restrict__] = ACTIONS(6142),
    [anon_sym__Atomic] = ACTIONS(6142),
    [anon_sym__Noreturn] = ACTIONS(6142),
    [anon_sym_noreturn] = ACTIONS(6142),
    [anon_sym_mutable] = ACTIONS(6142),
    [anon_sym_constinit] = ACTIONS(6142),
    [anon_sym_consteval] = ACTIONS(6142),
    [anon_sym_alignas] = ACTIONS(6156),
    [anon_sym__Alignas] = ACTIONS(6156),
    [anon_sym_DOT] = ACTIONS(6327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6307),
    [anon_sym_let] = ACTIONS(6307),
    [anon_sym_This] = ACTIONS(6307),
    [anon_sym_decltype] = ACTIONS(6321),
    [sym_virtual] = ACTIONS(6325),
    [anon_sym_template] = ACTIONS(6321),
    [anon_sym_GT2] = ACTIONS(6323),
    [anon_sym_operator] = ACTIONS(6321),
    [anon_sym_precise] = ACTIONS(6158),
    [anon_sym_shared] = ACTIONS(6158),
    [anon_sym_groupshared] = ACTIONS(6158),
    [anon_sym_uniform] = ACTIONS(6158),
    [anon_sym_row_major] = ACTIONS(6158),
    [anon_sym_column_major] = ACTIONS(6158),
    [anon_sym_globallycoherent] = ACTIONS(6158),
    [anon_sym_centroid] = ACTIONS(6158),
    [anon_sym_noperspective] = ACTIONS(6158),
    [anon_sym_nointerpolation] = ACTIONS(6158),
    [anon_sym_sample] = ACTIONS(6158),
    [anon_sym_linear] = ACTIONS(6158),
    [anon_sym_snorm] = ACTIONS(6158),
    [anon_sym_unorm] = ACTIONS(6158),
    [anon_sym_point] = ACTIONS(6158),
    [anon_sym_line] = ACTIONS(6158),
    [anon_sym_triangleadj] = ACTIONS(6158),
    [anon_sym_lineadj] = ACTIONS(6158),
    [anon_sym_triangle] = ACTIONS(6158),
  },
  [2689] = {
    [sym_attribute_specifier] = STATE(2746),
    [sym_field_declaration_list] = STATE(2714),
    [sym_virtual_specifier] = STATE(8832),
    [sym_base_class_clause] = STATE(9868),
    [sym_identifier] = ACTIONS(2683),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2685),
    [anon_sym_STAR] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_COLON] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(6329),
    [anon_sym___extension__] = ACTIONS(2683),
    [anon_sym_in] = ACTIONS(2683),
    [anon_sym_out] = ACTIONS(2683),
    [anon_sym_inout] = ACTIONS(2683),
    [anon_sym_extern] = ACTIONS(2683),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(2685),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2685),
    [anon_sym___declspec] = ACTIONS(2683),
    [anon_sym___based] = ACTIONS(2683),
    [anon_sym___cdecl] = ACTIONS(2683),
    [anon_sym___clrcall] = ACTIONS(2683),
    [anon_sym___stdcall] = ACTIONS(2683),
    [anon_sym___fastcall] = ACTIONS(2683),
    [anon_sym___thiscall] = ACTIONS(2683),
    [anon_sym___vectorcall] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(6230),
    [anon_sym_LBRACK] = ACTIONS(2683),
    [anon_sym_static] = ACTIONS(2683),
    [anon_sym_register] = ACTIONS(2683),
    [anon_sym_inline] = ACTIONS(2683),
    [anon_sym___inline] = ACTIONS(2683),
    [anon_sym___inline__] = ACTIONS(2683),
    [anon_sym___forceinline] = ACTIONS(2683),
    [anon_sym_thread_local] = ACTIONS(2683),
    [anon_sym___thread] = ACTIONS(2683),
    [anon_sym_const] = ACTIONS(2683),
    [anon_sym_constexpr] = ACTIONS(2683),
    [anon_sym_volatile] = ACTIONS(2683),
    [anon_sym_restrict] = ACTIONS(2683),
    [anon_sym___restrict__] = ACTIONS(2683),
    [anon_sym__Atomic] = ACTIONS(2683),
    [anon_sym__Noreturn] = ACTIONS(2683),
    [anon_sym_noreturn] = ACTIONS(2683),
    [anon_sym_mutable] = ACTIONS(2683),
    [anon_sym_constinit] = ACTIONS(2683),
    [anon_sym_consteval] = ACTIONS(2683),
    [anon_sym_alignas] = ACTIONS(2683),
    [anon_sym__Alignas] = ACTIONS(2683),
    [anon_sym_DOT] = ACTIONS(2685),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2683),
    [anon_sym_let] = ACTIONS(2683),
    [anon_sym_This] = ACTIONS(2683),
    [anon_sym_decltype] = ACTIONS(2683),
    [anon_sym_final] = ACTIONS(2481),
    [anon_sym_override] = ACTIONS(2481),
    [sym_virtual] = ACTIONS(2683),
    [anon_sym_template] = ACTIONS(2683),
    [anon_sym_operator] = ACTIONS(2683),
    [anon_sym_precise] = ACTIONS(2683),
    [anon_sym_shared] = ACTIONS(2683),
    [anon_sym_groupshared] = ACTIONS(2683),
    [anon_sym_uniform] = ACTIONS(2683),
    [anon_sym_row_major] = ACTIONS(2683),
    [anon_sym_column_major] = ACTIONS(2683),
    [anon_sym_globallycoherent] = ACTIONS(2683),
    [anon_sym_centroid] = ACTIONS(2683),
    [anon_sym_noperspective] = ACTIONS(2683),
    [anon_sym_nointerpolation] = ACTIONS(2683),
    [anon_sym_sample] = ACTIONS(2683),
    [anon_sym_linear] = ACTIONS(2683),
    [anon_sym_snorm] = ACTIONS(2683),
    [anon_sym_unorm] = ACTIONS(2683),
    [anon_sym_point] = ACTIONS(2683),
    [anon_sym_line] = ACTIONS(2683),
    [anon_sym_triangleadj] = ACTIONS(2683),
    [anon_sym_lineadj] = ACTIONS(2683),
    [anon_sym_triangle] = ACTIONS(2683),
  },
  [2690] = {
    [sym_attribute_specifier] = STATE(2746),
    [sym_field_declaration_list] = STATE(2714),
    [sym_virtual_specifier] = STATE(8832),
    [sym_base_class_clause] = STATE(9868),
    [sym_identifier] = ACTIONS(2683),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2685),
    [anon_sym_STAR] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_COLON] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(6331),
    [anon_sym___extension__] = ACTIONS(2683),
    [anon_sym_in] = ACTIONS(2683),
    [anon_sym_out] = ACTIONS(2683),
    [anon_sym_inout] = ACTIONS(2683),
    [anon_sym_extern] = ACTIONS(2683),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(2685),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2685),
    [anon_sym___declspec] = ACTIONS(2683),
    [anon_sym___based] = ACTIONS(2683),
    [anon_sym___cdecl] = ACTIONS(2683),
    [anon_sym___clrcall] = ACTIONS(2683),
    [anon_sym___stdcall] = ACTIONS(2683),
    [anon_sym___fastcall] = ACTIONS(2683),
    [anon_sym___thiscall] = ACTIONS(2683),
    [anon_sym___vectorcall] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(6230),
    [anon_sym_LBRACK] = ACTIONS(2683),
    [anon_sym_static] = ACTIONS(2683),
    [anon_sym_register] = ACTIONS(2683),
    [anon_sym_inline] = ACTIONS(2683),
    [anon_sym___inline] = ACTIONS(2683),
    [anon_sym___inline__] = ACTIONS(2683),
    [anon_sym___forceinline] = ACTIONS(2683),
    [anon_sym_thread_local] = ACTIONS(2683),
    [anon_sym___thread] = ACTIONS(2683),
    [anon_sym_const] = ACTIONS(2683),
    [anon_sym_constexpr] = ACTIONS(2683),
    [anon_sym_volatile] = ACTIONS(2683),
    [anon_sym_restrict] = ACTIONS(2683),
    [anon_sym___restrict__] = ACTIONS(2683),
    [anon_sym__Atomic] = ACTIONS(2683),
    [anon_sym__Noreturn] = ACTIONS(2683),
    [anon_sym_noreturn] = ACTIONS(2683),
    [anon_sym_mutable] = ACTIONS(2683),
    [anon_sym_constinit] = ACTIONS(2683),
    [anon_sym_consteval] = ACTIONS(2683),
    [anon_sym_alignas] = ACTIONS(2683),
    [anon_sym__Alignas] = ACTIONS(2683),
    [anon_sym_DOT] = ACTIONS(2685),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2683),
    [anon_sym_let] = ACTIONS(2683),
    [anon_sym_This] = ACTIONS(2683),
    [anon_sym_decltype] = ACTIONS(2683),
    [anon_sym_final] = ACTIONS(2481),
    [anon_sym_override] = ACTIONS(2481),
    [sym_virtual] = ACTIONS(2683),
    [anon_sym_template] = ACTIONS(2683),
    [anon_sym_operator] = ACTIONS(2683),
    [anon_sym_precise] = ACTIONS(2683),
    [anon_sym_shared] = ACTIONS(2683),
    [anon_sym_groupshared] = ACTIONS(2683),
    [anon_sym_uniform] = ACTIONS(2683),
    [anon_sym_row_major] = ACTIONS(2683),
    [anon_sym_column_major] = ACTIONS(2683),
    [anon_sym_globallycoherent] = ACTIONS(2683),
    [anon_sym_centroid] = ACTIONS(2683),
    [anon_sym_noperspective] = ACTIONS(2683),
    [anon_sym_nointerpolation] = ACTIONS(2683),
    [anon_sym_sample] = ACTIONS(2683),
    [anon_sym_linear] = ACTIONS(2683),
    [anon_sym_snorm] = ACTIONS(2683),
    [anon_sym_unorm] = ACTIONS(2683),
    [anon_sym_point] = ACTIONS(2683),
    [anon_sym_line] = ACTIONS(2683),
    [anon_sym_triangleadj] = ACTIONS(2683),
    [anon_sym_lineadj] = ACTIONS(2683),
    [anon_sym_triangle] = ACTIONS(2683),
  },
  [2691] = {
    [sym_attribute_specifier] = STATE(2746),
    [sym_field_declaration_list] = STATE(2714),
    [sym_virtual_specifier] = STATE(8832),
    [sym_base_class_clause] = STATE(9868),
    [sym_identifier] = ACTIONS(2683),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2685),
    [anon_sym_STAR] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_COLON] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(6333),
    [anon_sym___extension__] = ACTIONS(2683),
    [anon_sym_in] = ACTIONS(2683),
    [anon_sym_out] = ACTIONS(2683),
    [anon_sym_inout] = ACTIONS(2683),
    [anon_sym_extern] = ACTIONS(2683),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(2685),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2685),
    [anon_sym___declspec] = ACTIONS(2683),
    [anon_sym___based] = ACTIONS(2683),
    [anon_sym___cdecl] = ACTIONS(2683),
    [anon_sym___clrcall] = ACTIONS(2683),
    [anon_sym___stdcall] = ACTIONS(2683),
    [anon_sym___fastcall] = ACTIONS(2683),
    [anon_sym___thiscall] = ACTIONS(2683),
    [anon_sym___vectorcall] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(6230),
    [anon_sym_LBRACK] = ACTIONS(2683),
    [anon_sym_static] = ACTIONS(2683),
    [anon_sym_register] = ACTIONS(2683),
    [anon_sym_inline] = ACTIONS(2683),
    [anon_sym___inline] = ACTIONS(2683),
    [anon_sym___inline__] = ACTIONS(2683),
    [anon_sym___forceinline] = ACTIONS(2683),
    [anon_sym_thread_local] = ACTIONS(2683),
    [anon_sym___thread] = ACTIONS(2683),
    [anon_sym_const] = ACTIONS(2683),
    [anon_sym_constexpr] = ACTIONS(2683),
    [anon_sym_volatile] = ACTIONS(2683),
    [anon_sym_restrict] = ACTIONS(2683),
    [anon_sym___restrict__] = ACTIONS(2683),
    [anon_sym__Atomic] = ACTIONS(2683),
    [anon_sym__Noreturn] = ACTIONS(2683),
    [anon_sym_noreturn] = ACTIONS(2683),
    [anon_sym_mutable] = ACTIONS(2683),
    [anon_sym_constinit] = ACTIONS(2683),
    [anon_sym_consteval] = ACTIONS(2683),
    [anon_sym_alignas] = ACTIONS(2683),
    [anon_sym__Alignas] = ACTIONS(2683),
    [anon_sym_DOT] = ACTIONS(2685),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2683),
    [anon_sym_let] = ACTIONS(2683),
    [anon_sym_This] = ACTIONS(2683),
    [anon_sym_decltype] = ACTIONS(2683),
    [anon_sym_final] = ACTIONS(2481),
    [anon_sym_override] = ACTIONS(2481),
    [sym_virtual] = ACTIONS(2683),
    [anon_sym_template] = ACTIONS(2683),
    [anon_sym_operator] = ACTIONS(2683),
    [anon_sym_precise] = ACTIONS(2683),
    [anon_sym_shared] = ACTIONS(2683),
    [anon_sym_groupshared] = ACTIONS(2683),
    [anon_sym_uniform] = ACTIONS(2683),
    [anon_sym_row_major] = ACTIONS(2683),
    [anon_sym_column_major] = ACTIONS(2683),
    [anon_sym_globallycoherent] = ACTIONS(2683),
    [anon_sym_centroid] = ACTIONS(2683),
    [anon_sym_noperspective] = ACTIONS(2683),
    [anon_sym_nointerpolation] = ACTIONS(2683),
    [anon_sym_sample] = ACTIONS(2683),
    [anon_sym_linear] = ACTIONS(2683),
    [anon_sym_snorm] = ACTIONS(2683),
    [anon_sym_unorm] = ACTIONS(2683),
    [anon_sym_point] = ACTIONS(2683),
    [anon_sym_line] = ACTIONS(2683),
    [anon_sym_triangleadj] = ACTIONS(2683),
    [anon_sym_lineadj] = ACTIONS(2683),
    [anon_sym_triangle] = ACTIONS(2683),
  },
  [2692] = {
    [sym_argument_list] = STATE(3305),
    [sym_initializer_list] = STATE(4688),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2661),
    [sym_identifier] = ACTIONS(2742),
    [anon_sym_LPAREN2] = ACTIONS(3656),
    [anon_sym_TILDE] = ACTIONS(2740),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym___extension__] = ACTIONS(2742),
    [anon_sym_in] = ACTIONS(2742),
    [anon_sym_out] = ACTIONS(2742),
    [anon_sym_inout] = ACTIONS(2742),
    [anon_sym_extern] = ACTIONS(2742),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym_COLON_COLON] = ACTIONS(2740),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2740),
    [anon_sym___declspec] = ACTIONS(2742),
    [anon_sym___based] = ACTIONS(2742),
    [anon_sym___cdecl] = ACTIONS(2742),
    [anon_sym___clrcall] = ACTIONS(2742),
    [anon_sym___stdcall] = ACTIONS(2742),
    [anon_sym___fastcall] = ACTIONS(2742),
    [anon_sym___thiscall] = ACTIONS(2742),
    [anon_sym___vectorcall] = ACTIONS(2742),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_signed] = ACTIONS(6251),
    [anon_sym_unsigned] = ACTIONS(6251),
    [anon_sym_long] = ACTIONS(6251),
    [anon_sym_short] = ACTIONS(6251),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2742),
    [anon_sym_register] = ACTIONS(2742),
    [anon_sym_inline] = ACTIONS(2742),
    [anon_sym___inline] = ACTIONS(2742),
    [anon_sym___inline__] = ACTIONS(2742),
    [anon_sym___forceinline] = ACTIONS(2742),
    [anon_sym_thread_local] = ACTIONS(2742),
    [anon_sym___thread] = ACTIONS(2742),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_constexpr] = ACTIONS(2742),
    [anon_sym_volatile] = ACTIONS(2742),
    [anon_sym_restrict] = ACTIONS(2742),
    [anon_sym___restrict__] = ACTIONS(2742),
    [anon_sym__Atomic] = ACTIONS(2742),
    [anon_sym__Noreturn] = ACTIONS(2742),
    [anon_sym_noreturn] = ACTIONS(2742),
    [anon_sym_mutable] = ACTIONS(2742),
    [anon_sym_constinit] = ACTIONS(2742),
    [anon_sym_consteval] = ACTIONS(2742),
    [anon_sym_alignas] = ACTIONS(2742),
    [anon_sym__Alignas] = ACTIONS(2742),
    [anon_sym_DOT] = ACTIONS(2740),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
    [anon_sym_decltype] = ACTIONS(2742),
    [sym_virtual] = ACTIONS(2742),
    [anon_sym_template] = ACTIONS(2742),
    [anon_sym_operator] = ACTIONS(2742),
    [anon_sym_precise] = ACTIONS(2742),
    [anon_sym_shared] = ACTIONS(2742),
    [anon_sym_groupshared] = ACTIONS(2742),
    [anon_sym_uniform] = ACTIONS(2742),
    [anon_sym_row_major] = ACTIONS(2742),
    [anon_sym_column_major] = ACTIONS(2742),
    [anon_sym_globallycoherent] = ACTIONS(2742),
    [anon_sym_centroid] = ACTIONS(2742),
    [anon_sym_noperspective] = ACTIONS(2742),
    [anon_sym_nointerpolation] = ACTIONS(2742),
    [anon_sym_sample] = ACTIONS(2742),
    [anon_sym_linear] = ACTIONS(2742),
    [anon_sym_snorm] = ACTIONS(2742),
    [anon_sym_unorm] = ACTIONS(2742),
    [anon_sym_point] = ACTIONS(2742),
    [anon_sym_line] = ACTIONS(2742),
    [anon_sym_triangleadj] = ACTIONS(2742),
    [anon_sym_lineadj] = ACTIONS(2742),
    [anon_sym_triangle] = ACTIONS(2742),
  },
  [2693] = {
    [sym_attribute_specifier] = STATE(2746),
    [sym_field_declaration_list] = STATE(2714),
    [sym_virtual_specifier] = STATE(8832),
    [sym_base_class_clause] = STATE(9868),
    [sym_identifier] = ACTIONS(2683),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2685),
    [anon_sym_STAR] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_COLON] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(6335),
    [anon_sym___extension__] = ACTIONS(2683),
    [anon_sym_in] = ACTIONS(2683),
    [anon_sym_out] = ACTIONS(2683),
    [anon_sym_inout] = ACTIONS(2683),
    [anon_sym_extern] = ACTIONS(2683),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(2685),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2685),
    [anon_sym___declspec] = ACTIONS(2683),
    [anon_sym___based] = ACTIONS(2683),
    [anon_sym___cdecl] = ACTIONS(2683),
    [anon_sym___clrcall] = ACTIONS(2683),
    [anon_sym___stdcall] = ACTIONS(2683),
    [anon_sym___fastcall] = ACTIONS(2683),
    [anon_sym___thiscall] = ACTIONS(2683),
    [anon_sym___vectorcall] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(6230),
    [anon_sym_LBRACK] = ACTIONS(2683),
    [anon_sym_static] = ACTIONS(2683),
    [anon_sym_register] = ACTIONS(2683),
    [anon_sym_inline] = ACTIONS(2683),
    [anon_sym___inline] = ACTIONS(2683),
    [anon_sym___inline__] = ACTIONS(2683),
    [anon_sym___forceinline] = ACTIONS(2683),
    [anon_sym_thread_local] = ACTIONS(2683),
    [anon_sym___thread] = ACTIONS(2683),
    [anon_sym_const] = ACTIONS(2683),
    [anon_sym_constexpr] = ACTIONS(2683),
    [anon_sym_volatile] = ACTIONS(2683),
    [anon_sym_restrict] = ACTIONS(2683),
    [anon_sym___restrict__] = ACTIONS(2683),
    [anon_sym__Atomic] = ACTIONS(2683),
    [anon_sym__Noreturn] = ACTIONS(2683),
    [anon_sym_noreturn] = ACTIONS(2683),
    [anon_sym_mutable] = ACTIONS(2683),
    [anon_sym_constinit] = ACTIONS(2683),
    [anon_sym_consteval] = ACTIONS(2683),
    [anon_sym_alignas] = ACTIONS(2683),
    [anon_sym__Alignas] = ACTIONS(2683),
    [anon_sym_DOT] = ACTIONS(2685),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2683),
    [anon_sym_let] = ACTIONS(2683),
    [anon_sym_This] = ACTIONS(2683),
    [anon_sym_decltype] = ACTIONS(2683),
    [anon_sym_final] = ACTIONS(2481),
    [anon_sym_override] = ACTIONS(2481),
    [sym_virtual] = ACTIONS(2683),
    [anon_sym_template] = ACTIONS(2683),
    [anon_sym_operator] = ACTIONS(2683),
    [anon_sym_precise] = ACTIONS(2683),
    [anon_sym_shared] = ACTIONS(2683),
    [anon_sym_groupshared] = ACTIONS(2683),
    [anon_sym_uniform] = ACTIONS(2683),
    [anon_sym_row_major] = ACTIONS(2683),
    [anon_sym_column_major] = ACTIONS(2683),
    [anon_sym_globallycoherent] = ACTIONS(2683),
    [anon_sym_centroid] = ACTIONS(2683),
    [anon_sym_noperspective] = ACTIONS(2683),
    [anon_sym_nointerpolation] = ACTIONS(2683),
    [anon_sym_sample] = ACTIONS(2683),
    [anon_sym_linear] = ACTIONS(2683),
    [anon_sym_snorm] = ACTIONS(2683),
    [anon_sym_unorm] = ACTIONS(2683),
    [anon_sym_point] = ACTIONS(2683),
    [anon_sym_line] = ACTIONS(2683),
    [anon_sym_triangleadj] = ACTIONS(2683),
    [anon_sym_lineadj] = ACTIONS(2683),
    [anon_sym_triangle] = ACTIONS(2683),
  },
  [2694] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_qualifiers] = STATE(2666),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(6297),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6299),
    [anon_sym_COMMA] = ACTIONS(6299),
    [anon_sym_RPAREN] = ACTIONS(6299),
    [anon_sym_LPAREN2] = ACTIONS(6299),
    [anon_sym_TILDE] = ACTIONS(6299),
    [anon_sym_STAR] = ACTIONS(6299),
    [anon_sym_AMP_AMP] = ACTIONS(6299),
    [anon_sym_AMP] = ACTIONS(6297),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym___extension__] = ACTIONS(6142),
    [anon_sym_in] = ACTIONS(6303),
    [anon_sym_out] = ACTIONS(6303),
    [anon_sym_inout] = ACTIONS(6303),
    [anon_sym_extern] = ACTIONS(6146),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(6299),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6152),
    [anon_sym___declspec] = ACTIONS(6154),
    [anon_sym___based] = ACTIONS(6297),
    [anon_sym_LBRACK] = ACTIONS(6297),
    [anon_sym_static] = ACTIONS(6146),
    [anon_sym_EQ] = ACTIONS(6299),
    [anon_sym_register] = ACTIONS(6146),
    [anon_sym_inline] = ACTIONS(6146),
    [anon_sym___inline] = ACTIONS(6146),
    [anon_sym___inline__] = ACTIONS(6146),
    [anon_sym___forceinline] = ACTIONS(6146),
    [anon_sym_thread_local] = ACTIONS(6146),
    [anon_sym___thread] = ACTIONS(6146),
    [anon_sym_const] = ACTIONS(6142),
    [anon_sym_constexpr] = ACTIONS(6142),
    [anon_sym_volatile] = ACTIONS(6142),
    [anon_sym_restrict] = ACTIONS(6142),
    [anon_sym___restrict__] = ACTIONS(6142),
    [anon_sym__Atomic] = ACTIONS(6142),
    [anon_sym__Noreturn] = ACTIONS(6142),
    [anon_sym_noreturn] = ACTIONS(6142),
    [anon_sym_mutable] = ACTIONS(6142),
    [anon_sym_constinit] = ACTIONS(6142),
    [anon_sym_consteval] = ACTIONS(6142),
    [anon_sym_alignas] = ACTIONS(6156),
    [anon_sym__Alignas] = ACTIONS(6156),
    [anon_sym_DOT] = ACTIONS(6327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6307),
    [anon_sym_let] = ACTIONS(6307),
    [anon_sym_This] = ACTIONS(6307),
    [anon_sym_decltype] = ACTIONS(6297),
    [sym_virtual] = ACTIONS(6303),
    [anon_sym_template] = ACTIONS(6297),
    [anon_sym_GT2] = ACTIONS(6299),
    [anon_sym_operator] = ACTIONS(6297),
    [anon_sym_precise] = ACTIONS(6158),
    [anon_sym_shared] = ACTIONS(6158),
    [anon_sym_groupshared] = ACTIONS(6158),
    [anon_sym_uniform] = ACTIONS(6158),
    [anon_sym_row_major] = ACTIONS(6158),
    [anon_sym_column_major] = ACTIONS(6158),
    [anon_sym_globallycoherent] = ACTIONS(6158),
    [anon_sym_centroid] = ACTIONS(6158),
    [anon_sym_noperspective] = ACTIONS(6158),
    [anon_sym_nointerpolation] = ACTIONS(6158),
    [anon_sym_sample] = ACTIONS(6158),
    [anon_sym_linear] = ACTIONS(6158),
    [anon_sym_snorm] = ACTIONS(6158),
    [anon_sym_unorm] = ACTIONS(6158),
    [anon_sym_point] = ACTIONS(6158),
    [anon_sym_line] = ACTIONS(6158),
    [anon_sym_triangleadj] = ACTIONS(6158),
    [anon_sym_lineadj] = ACTIONS(6158),
    [anon_sym_triangle] = ACTIONS(6158),
  },
  [2695] = {
    [sym_attribute_specifier] = STATE(2746),
    [sym_field_declaration_list] = STATE(2714),
    [sym_virtual_specifier] = STATE(8832),
    [sym_base_class_clause] = STATE(9868),
    [sym_identifier] = ACTIONS(2683),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2685),
    [anon_sym_STAR] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_COLON] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(6337),
    [anon_sym___extension__] = ACTIONS(2683),
    [anon_sym_in] = ACTIONS(2683),
    [anon_sym_out] = ACTIONS(2683),
    [anon_sym_inout] = ACTIONS(2683),
    [anon_sym_extern] = ACTIONS(2683),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(2685),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2685),
    [anon_sym___declspec] = ACTIONS(2683),
    [anon_sym___based] = ACTIONS(2683),
    [anon_sym___cdecl] = ACTIONS(2683),
    [anon_sym___clrcall] = ACTIONS(2683),
    [anon_sym___stdcall] = ACTIONS(2683),
    [anon_sym___fastcall] = ACTIONS(2683),
    [anon_sym___thiscall] = ACTIONS(2683),
    [anon_sym___vectorcall] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(6230),
    [anon_sym_LBRACK] = ACTIONS(2683),
    [anon_sym_static] = ACTIONS(2683),
    [anon_sym_register] = ACTIONS(2683),
    [anon_sym_inline] = ACTIONS(2683),
    [anon_sym___inline] = ACTIONS(2683),
    [anon_sym___inline__] = ACTIONS(2683),
    [anon_sym___forceinline] = ACTIONS(2683),
    [anon_sym_thread_local] = ACTIONS(2683),
    [anon_sym___thread] = ACTIONS(2683),
    [anon_sym_const] = ACTIONS(2683),
    [anon_sym_constexpr] = ACTIONS(2683),
    [anon_sym_volatile] = ACTIONS(2683),
    [anon_sym_restrict] = ACTIONS(2683),
    [anon_sym___restrict__] = ACTIONS(2683),
    [anon_sym__Atomic] = ACTIONS(2683),
    [anon_sym__Noreturn] = ACTIONS(2683),
    [anon_sym_noreturn] = ACTIONS(2683),
    [anon_sym_mutable] = ACTIONS(2683),
    [anon_sym_constinit] = ACTIONS(2683),
    [anon_sym_consteval] = ACTIONS(2683),
    [anon_sym_alignas] = ACTIONS(2683),
    [anon_sym__Alignas] = ACTIONS(2683),
    [anon_sym_DOT] = ACTIONS(2685),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2683),
    [anon_sym_let] = ACTIONS(2683),
    [anon_sym_This] = ACTIONS(2683),
    [anon_sym_decltype] = ACTIONS(2683),
    [anon_sym_final] = ACTIONS(2481),
    [anon_sym_override] = ACTIONS(2481),
    [sym_virtual] = ACTIONS(2683),
    [anon_sym_template] = ACTIONS(2683),
    [anon_sym_operator] = ACTIONS(2683),
    [anon_sym_precise] = ACTIONS(2683),
    [anon_sym_shared] = ACTIONS(2683),
    [anon_sym_groupshared] = ACTIONS(2683),
    [anon_sym_uniform] = ACTIONS(2683),
    [anon_sym_row_major] = ACTIONS(2683),
    [anon_sym_column_major] = ACTIONS(2683),
    [anon_sym_globallycoherent] = ACTIONS(2683),
    [anon_sym_centroid] = ACTIONS(2683),
    [anon_sym_noperspective] = ACTIONS(2683),
    [anon_sym_nointerpolation] = ACTIONS(2683),
    [anon_sym_sample] = ACTIONS(2683),
    [anon_sym_linear] = ACTIONS(2683),
    [anon_sym_snorm] = ACTIONS(2683),
    [anon_sym_unorm] = ACTIONS(2683),
    [anon_sym_point] = ACTIONS(2683),
    [anon_sym_line] = ACTIONS(2683),
    [anon_sym_triangleadj] = ACTIONS(2683),
    [anon_sym_lineadj] = ACTIONS(2683),
    [anon_sym_triangle] = ACTIONS(2683),
  },
  [2696] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_qualifiers] = STATE(2666),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(6297),
    [anon_sym_LPAREN2] = ACTIONS(6299),
    [anon_sym_TILDE] = ACTIONS(6299),
    [anon_sym_STAR] = ACTIONS(6299),
    [anon_sym_AMP_AMP] = ACTIONS(6299),
    [anon_sym_AMP] = ACTIONS(6297),
    [anon_sym___extension__] = ACTIONS(6142),
    [anon_sym_in] = ACTIONS(6303),
    [anon_sym_out] = ACTIONS(6303),
    [anon_sym_inout] = ACTIONS(6303),
    [anon_sym_extern] = ACTIONS(6146),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(6299),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6152),
    [anon_sym___declspec] = ACTIONS(6154),
    [anon_sym___based] = ACTIONS(6297),
    [anon_sym___cdecl] = ACTIONS(6297),
    [anon_sym___clrcall] = ACTIONS(6297),
    [anon_sym___stdcall] = ACTIONS(6297),
    [anon_sym___fastcall] = ACTIONS(6297),
    [anon_sym___thiscall] = ACTIONS(6297),
    [anon_sym___vectorcall] = ACTIONS(6297),
    [anon_sym_LBRACK] = ACTIONS(6297),
    [anon_sym_static] = ACTIONS(6146),
    [anon_sym_register] = ACTIONS(6146),
    [anon_sym_inline] = ACTIONS(6146),
    [anon_sym___inline] = ACTIONS(6146),
    [anon_sym___inline__] = ACTIONS(6146),
    [anon_sym___forceinline] = ACTIONS(6146),
    [anon_sym_thread_local] = ACTIONS(6146),
    [anon_sym___thread] = ACTIONS(6146),
    [anon_sym_const] = ACTIONS(6142),
    [anon_sym_constexpr] = ACTIONS(6142),
    [anon_sym_volatile] = ACTIONS(6142),
    [anon_sym_restrict] = ACTIONS(6142),
    [anon_sym___restrict__] = ACTIONS(6142),
    [anon_sym__Atomic] = ACTIONS(6142),
    [anon_sym__Noreturn] = ACTIONS(6142),
    [anon_sym_noreturn] = ACTIONS(6142),
    [anon_sym_mutable] = ACTIONS(6142),
    [anon_sym_constinit] = ACTIONS(6142),
    [anon_sym_consteval] = ACTIONS(6142),
    [anon_sym_alignas] = ACTIONS(6156),
    [anon_sym__Alignas] = ACTIONS(6156),
    [anon_sym_DOT] = ACTIONS(6305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6307),
    [anon_sym_let] = ACTIONS(6307),
    [anon_sym_This] = ACTIONS(6307),
    [anon_sym_decltype] = ACTIONS(6297),
    [sym_virtual] = ACTIONS(6303),
    [anon_sym_template] = ACTIONS(6297),
    [anon_sym_operator] = ACTIONS(6297),
    [anon_sym_precise] = ACTIONS(6158),
    [anon_sym_shared] = ACTIONS(6158),
    [anon_sym_groupshared] = ACTIONS(6158),
    [anon_sym_uniform] = ACTIONS(6158),
    [anon_sym_row_major] = ACTIONS(6158),
    [anon_sym_column_major] = ACTIONS(6158),
    [anon_sym_globallycoherent] = ACTIONS(6158),
    [anon_sym_centroid] = ACTIONS(6158),
    [anon_sym_noperspective] = ACTIONS(6158),
    [anon_sym_nointerpolation] = ACTIONS(6158),
    [anon_sym_sample] = ACTIONS(6158),
    [anon_sym_linear] = ACTIONS(6158),
    [anon_sym_snorm] = ACTIONS(6158),
    [anon_sym_unorm] = ACTIONS(6158),
    [anon_sym_point] = ACTIONS(6158),
    [anon_sym_line] = ACTIONS(6158),
    [anon_sym_triangleadj] = ACTIONS(6158),
    [anon_sym_lineadj] = ACTIONS(6158),
    [anon_sym_triangle] = ACTIONS(6158),
  },
  [2697] = {
    [sym_attribute_specifier] = STATE(2746),
    [sym_field_declaration_list] = STATE(2714),
    [sym_virtual_specifier] = STATE(8832),
    [sym_base_class_clause] = STATE(9868),
    [sym_identifier] = ACTIONS(2683),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2685),
    [anon_sym_STAR] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_COLON] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(6339),
    [anon_sym___extension__] = ACTIONS(2683),
    [anon_sym_in] = ACTIONS(2683),
    [anon_sym_out] = ACTIONS(2683),
    [anon_sym_inout] = ACTIONS(2683),
    [anon_sym_extern] = ACTIONS(2683),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(2685),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2685),
    [anon_sym___declspec] = ACTIONS(2683),
    [anon_sym___based] = ACTIONS(2683),
    [anon_sym___cdecl] = ACTIONS(2683),
    [anon_sym___clrcall] = ACTIONS(2683),
    [anon_sym___stdcall] = ACTIONS(2683),
    [anon_sym___fastcall] = ACTIONS(2683),
    [anon_sym___thiscall] = ACTIONS(2683),
    [anon_sym___vectorcall] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(6230),
    [anon_sym_LBRACK] = ACTIONS(2683),
    [anon_sym_static] = ACTIONS(2683),
    [anon_sym_register] = ACTIONS(2683),
    [anon_sym_inline] = ACTIONS(2683),
    [anon_sym___inline] = ACTIONS(2683),
    [anon_sym___inline__] = ACTIONS(2683),
    [anon_sym___forceinline] = ACTIONS(2683),
    [anon_sym_thread_local] = ACTIONS(2683),
    [anon_sym___thread] = ACTIONS(2683),
    [anon_sym_const] = ACTIONS(2683),
    [anon_sym_constexpr] = ACTIONS(2683),
    [anon_sym_volatile] = ACTIONS(2683),
    [anon_sym_restrict] = ACTIONS(2683),
    [anon_sym___restrict__] = ACTIONS(2683),
    [anon_sym__Atomic] = ACTIONS(2683),
    [anon_sym__Noreturn] = ACTIONS(2683),
    [anon_sym_noreturn] = ACTIONS(2683),
    [anon_sym_mutable] = ACTIONS(2683),
    [anon_sym_constinit] = ACTIONS(2683),
    [anon_sym_consteval] = ACTIONS(2683),
    [anon_sym_alignas] = ACTIONS(2683),
    [anon_sym__Alignas] = ACTIONS(2683),
    [anon_sym_DOT] = ACTIONS(2685),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2683),
    [anon_sym_let] = ACTIONS(2683),
    [anon_sym_This] = ACTIONS(2683),
    [anon_sym_decltype] = ACTIONS(2683),
    [anon_sym_final] = ACTIONS(2481),
    [anon_sym_override] = ACTIONS(2481),
    [sym_virtual] = ACTIONS(2683),
    [anon_sym_template] = ACTIONS(2683),
    [anon_sym_operator] = ACTIONS(2683),
    [anon_sym_precise] = ACTIONS(2683),
    [anon_sym_shared] = ACTIONS(2683),
    [anon_sym_groupshared] = ACTIONS(2683),
    [anon_sym_uniform] = ACTIONS(2683),
    [anon_sym_row_major] = ACTIONS(2683),
    [anon_sym_column_major] = ACTIONS(2683),
    [anon_sym_globallycoherent] = ACTIONS(2683),
    [anon_sym_centroid] = ACTIONS(2683),
    [anon_sym_noperspective] = ACTIONS(2683),
    [anon_sym_nointerpolation] = ACTIONS(2683),
    [anon_sym_sample] = ACTIONS(2683),
    [anon_sym_linear] = ACTIONS(2683),
    [anon_sym_snorm] = ACTIONS(2683),
    [anon_sym_unorm] = ACTIONS(2683),
    [anon_sym_point] = ACTIONS(2683),
    [anon_sym_line] = ACTIONS(2683),
    [anon_sym_triangleadj] = ACTIONS(2683),
    [anon_sym_lineadj] = ACTIONS(2683),
    [anon_sym_triangle] = ACTIONS(2683),
  },
  [2698] = {
    [sym_attribute_specifier] = STATE(2746),
    [sym_field_declaration_list] = STATE(2714),
    [sym_virtual_specifier] = STATE(8832),
    [sym_base_class_clause] = STATE(9868),
    [sym_identifier] = ACTIONS(2683),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2685),
    [anon_sym_STAR] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_COLON] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(6341),
    [anon_sym___extension__] = ACTIONS(2683),
    [anon_sym_in] = ACTIONS(2683),
    [anon_sym_out] = ACTIONS(2683),
    [anon_sym_inout] = ACTIONS(2683),
    [anon_sym_extern] = ACTIONS(2683),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(2685),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2685),
    [anon_sym___declspec] = ACTIONS(2683),
    [anon_sym___based] = ACTIONS(2683),
    [anon_sym___cdecl] = ACTIONS(2683),
    [anon_sym___clrcall] = ACTIONS(2683),
    [anon_sym___stdcall] = ACTIONS(2683),
    [anon_sym___fastcall] = ACTIONS(2683),
    [anon_sym___thiscall] = ACTIONS(2683),
    [anon_sym___vectorcall] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(6230),
    [anon_sym_LBRACK] = ACTIONS(2683),
    [anon_sym_static] = ACTIONS(2683),
    [anon_sym_register] = ACTIONS(2683),
    [anon_sym_inline] = ACTIONS(2683),
    [anon_sym___inline] = ACTIONS(2683),
    [anon_sym___inline__] = ACTIONS(2683),
    [anon_sym___forceinline] = ACTIONS(2683),
    [anon_sym_thread_local] = ACTIONS(2683),
    [anon_sym___thread] = ACTIONS(2683),
    [anon_sym_const] = ACTIONS(2683),
    [anon_sym_constexpr] = ACTIONS(2683),
    [anon_sym_volatile] = ACTIONS(2683),
    [anon_sym_restrict] = ACTIONS(2683),
    [anon_sym___restrict__] = ACTIONS(2683),
    [anon_sym__Atomic] = ACTIONS(2683),
    [anon_sym__Noreturn] = ACTIONS(2683),
    [anon_sym_noreturn] = ACTIONS(2683),
    [anon_sym_mutable] = ACTIONS(2683),
    [anon_sym_constinit] = ACTIONS(2683),
    [anon_sym_consteval] = ACTIONS(2683),
    [anon_sym_alignas] = ACTIONS(2683),
    [anon_sym__Alignas] = ACTIONS(2683),
    [anon_sym_DOT] = ACTIONS(2685),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2683),
    [anon_sym_let] = ACTIONS(2683),
    [anon_sym_This] = ACTIONS(2683),
    [anon_sym_decltype] = ACTIONS(2683),
    [anon_sym_final] = ACTIONS(2481),
    [anon_sym_override] = ACTIONS(2481),
    [sym_virtual] = ACTIONS(2683),
    [anon_sym_template] = ACTIONS(2683),
    [anon_sym_operator] = ACTIONS(2683),
    [anon_sym_precise] = ACTIONS(2683),
    [anon_sym_shared] = ACTIONS(2683),
    [anon_sym_groupshared] = ACTIONS(2683),
    [anon_sym_uniform] = ACTIONS(2683),
    [anon_sym_row_major] = ACTIONS(2683),
    [anon_sym_column_major] = ACTIONS(2683),
    [anon_sym_globallycoherent] = ACTIONS(2683),
    [anon_sym_centroid] = ACTIONS(2683),
    [anon_sym_noperspective] = ACTIONS(2683),
    [anon_sym_nointerpolation] = ACTIONS(2683),
    [anon_sym_sample] = ACTIONS(2683),
    [anon_sym_linear] = ACTIONS(2683),
    [anon_sym_snorm] = ACTIONS(2683),
    [anon_sym_unorm] = ACTIONS(2683),
    [anon_sym_point] = ACTIONS(2683),
    [anon_sym_line] = ACTIONS(2683),
    [anon_sym_triangleadj] = ACTIONS(2683),
    [anon_sym_lineadj] = ACTIONS(2683),
    [anon_sym_triangle] = ACTIONS(2683),
  },
  [2699] = {
    [sym_template_argument_list] = STATE(2686),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2639),
    [sym_identifier] = ACTIONS(2115),
    [anon_sym_LPAREN2] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_AMP_AMP] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2115),
    [anon_sym_LT] = ACTIONS(6343),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym___extension__] = ACTIONS(2115),
    [anon_sym_in] = ACTIONS(2115),
    [anon_sym_out] = ACTIONS(2115),
    [anon_sym_inout] = ACTIONS(2115),
    [anon_sym_extern] = ACTIONS(2115),
    [anon_sym___attribute__] = ACTIONS(2115),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2123),
    [anon_sym___declspec] = ACTIONS(2115),
    [anon_sym___based] = ACTIONS(2115),
    [anon_sym___cdecl] = ACTIONS(2115),
    [anon_sym___clrcall] = ACTIONS(2115),
    [anon_sym___stdcall] = ACTIONS(2115),
    [anon_sym___fastcall] = ACTIONS(2115),
    [anon_sym___thiscall] = ACTIONS(2115),
    [anon_sym___vectorcall] = ACTIONS(2115),
    [anon_sym_signed] = ACTIONS(4863),
    [anon_sym_unsigned] = ACTIONS(4863),
    [anon_sym_long] = ACTIONS(4863),
    [anon_sym_short] = ACTIONS(4863),
    [anon_sym_LBRACK] = ACTIONS(2115),
    [anon_sym_static] = ACTIONS(2115),
    [anon_sym_register] = ACTIONS(2115),
    [anon_sym_inline] = ACTIONS(2115),
    [anon_sym___inline] = ACTIONS(2115),
    [anon_sym___inline__] = ACTIONS(2115),
    [anon_sym___forceinline] = ACTIONS(2115),
    [anon_sym_thread_local] = ACTIONS(2115),
    [anon_sym___thread] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(2115),
    [anon_sym_constexpr] = ACTIONS(2115),
    [anon_sym_volatile] = ACTIONS(2115),
    [anon_sym_restrict] = ACTIONS(2115),
    [anon_sym___restrict__] = ACTIONS(2115),
    [anon_sym__Atomic] = ACTIONS(2115),
    [anon_sym__Noreturn] = ACTIONS(2115),
    [anon_sym_noreturn] = ACTIONS(2115),
    [anon_sym_mutable] = ACTIONS(2115),
    [anon_sym_constinit] = ACTIONS(2115),
    [anon_sym_consteval] = ACTIONS(2115),
    [anon_sym_alignas] = ACTIONS(2115),
    [anon_sym__Alignas] = ACTIONS(2115),
    [anon_sym_DOT] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2115),
    [anon_sym_let] = ACTIONS(2115),
    [anon_sym_This] = ACTIONS(2115),
    [anon_sym_decltype] = ACTIONS(2115),
    [sym_virtual] = ACTIONS(2115),
    [anon_sym_template] = ACTIONS(2115),
    [anon_sym_operator] = ACTIONS(2115),
    [anon_sym_precise] = ACTIONS(2115),
    [anon_sym_shared] = ACTIONS(2115),
    [anon_sym_groupshared] = ACTIONS(2115),
    [anon_sym_uniform] = ACTIONS(2115),
    [anon_sym_row_major] = ACTIONS(2115),
    [anon_sym_column_major] = ACTIONS(2115),
    [anon_sym_globallycoherent] = ACTIONS(2115),
    [anon_sym_centroid] = ACTIONS(2115),
    [anon_sym_noperspective] = ACTIONS(2115),
    [anon_sym_nointerpolation] = ACTIONS(2115),
    [anon_sym_sample] = ACTIONS(2115),
    [anon_sym_linear] = ACTIONS(2115),
    [anon_sym_snorm] = ACTIONS(2115),
    [anon_sym_unorm] = ACTIONS(2115),
    [anon_sym_point] = ACTIONS(2115),
    [anon_sym_line] = ACTIONS(2115),
    [anon_sym_triangleadj] = ACTIONS(2115),
    [anon_sym_lineadj] = ACTIONS(2115),
    [anon_sym_triangle] = ACTIONS(2115),
  },
  [2700] = {
    [sym_attribute_specifier] = STATE(2717),
    [sym_identifier] = ACTIONS(3791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3793),
    [anon_sym_COMMA] = ACTIONS(3793),
    [anon_sym_RPAREN] = ACTIONS(3793),
    [anon_sym_LPAREN2] = ACTIONS(3793),
    [anon_sym_TILDE] = ACTIONS(3793),
    [anon_sym_STAR] = ACTIONS(3793),
    [anon_sym_AMP_AMP] = ACTIONS(3793),
    [anon_sym_AMP] = ACTIONS(3791),
    [anon_sym_COLON] = ACTIONS(3791),
    [anon_sym_SEMI] = ACTIONS(3793),
    [anon_sym___extension__] = ACTIONS(3791),
    [anon_sym_in] = ACTIONS(3791),
    [anon_sym_out] = ACTIONS(3791),
    [anon_sym_inout] = ACTIONS(3791),
    [anon_sym_extern] = ACTIONS(3791),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(3793),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3793),
    [anon_sym___declspec] = ACTIONS(3791),
    [anon_sym___based] = ACTIONS(3791),
    [anon_sym___cdecl] = ACTIONS(3791),
    [anon_sym___clrcall] = ACTIONS(3791),
    [anon_sym___stdcall] = ACTIONS(3791),
    [anon_sym___fastcall] = ACTIONS(3791),
    [anon_sym___thiscall] = ACTIONS(3791),
    [anon_sym___vectorcall] = ACTIONS(3791),
    [anon_sym_LBRACK] = ACTIONS(3791),
    [anon_sym_static] = ACTIONS(3791),
    [anon_sym_EQ] = ACTIONS(3793),
    [anon_sym_register] = ACTIONS(3791),
    [anon_sym_inline] = ACTIONS(3791),
    [anon_sym___inline] = ACTIONS(3791),
    [anon_sym___inline__] = ACTIONS(3791),
    [anon_sym___forceinline] = ACTIONS(3791),
    [anon_sym_thread_local] = ACTIONS(3791),
    [anon_sym___thread] = ACTIONS(3791),
    [anon_sym_const] = ACTIONS(3791),
    [anon_sym_constexpr] = ACTIONS(3791),
    [anon_sym_volatile] = ACTIONS(3791),
    [anon_sym_restrict] = ACTIONS(3791),
    [anon_sym___restrict__] = ACTIONS(3791),
    [anon_sym__Atomic] = ACTIONS(3791),
    [anon_sym__Noreturn] = ACTIONS(3791),
    [anon_sym_noreturn] = ACTIONS(3791),
    [anon_sym_mutable] = ACTIONS(3791),
    [anon_sym_constinit] = ACTIONS(3791),
    [anon_sym_consteval] = ACTIONS(3791),
    [anon_sym_alignas] = ACTIONS(3791),
    [anon_sym__Alignas] = ACTIONS(3791),
    [anon_sym_DOT] = ACTIONS(3791),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3791),
    [anon_sym_let] = ACTIONS(3791),
    [anon_sym_This] = ACTIONS(3791),
    [anon_sym_decltype] = ACTIONS(3791),
    [sym_virtual] = ACTIONS(3791),
    [anon_sym_template] = ACTIONS(3791),
    [anon_sym_GT2] = ACTIONS(3793),
    [anon_sym_operator] = ACTIONS(3791),
    [anon_sym_precise] = ACTIONS(3791),
    [anon_sym_shared] = ACTIONS(3791),
    [anon_sym_groupshared] = ACTIONS(3791),
    [anon_sym_uniform] = ACTIONS(3791),
    [anon_sym_row_major] = ACTIONS(3791),
    [anon_sym_column_major] = ACTIONS(3791),
    [anon_sym_globallycoherent] = ACTIONS(3791),
    [anon_sym_centroid] = ACTIONS(3791),
    [anon_sym_noperspective] = ACTIONS(3791),
    [anon_sym_nointerpolation] = ACTIONS(3791),
    [anon_sym_sample] = ACTIONS(3791),
    [anon_sym_linear] = ACTIONS(3791),
    [anon_sym_snorm] = ACTIONS(3791),
    [anon_sym_unorm] = ACTIONS(3791),
    [anon_sym_point] = ACTIONS(3791),
    [anon_sym_line] = ACTIONS(3791),
    [anon_sym_triangleadj] = ACTIONS(3791),
    [anon_sym_lineadj] = ACTIONS(3791),
    [anon_sym_triangle] = ACTIONS(3791),
  },
  [2701] = {
    [sym_attribute_specifier] = STATE(2771),
    [sym_identifier] = ACTIONS(3742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3744),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_RPAREN] = ACTIONS(3744),
    [anon_sym_LPAREN2] = ACTIONS(3744),
    [anon_sym_TILDE] = ACTIONS(3744),
    [anon_sym_STAR] = ACTIONS(3744),
    [anon_sym_AMP_AMP] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(3742),
    [anon_sym_COLON] = ACTIONS(3742),
    [anon_sym_SEMI] = ACTIONS(3744),
    [anon_sym___extension__] = ACTIONS(3742),
    [anon_sym_in] = ACTIONS(3742),
    [anon_sym_out] = ACTIONS(3742),
    [anon_sym_inout] = ACTIONS(3742),
    [anon_sym_extern] = ACTIONS(3742),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(3744),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3744),
    [anon_sym___declspec] = ACTIONS(3742),
    [anon_sym___based] = ACTIONS(3742),
    [anon_sym___cdecl] = ACTIONS(3742),
    [anon_sym___clrcall] = ACTIONS(3742),
    [anon_sym___stdcall] = ACTIONS(3742),
    [anon_sym___fastcall] = ACTIONS(3742),
    [anon_sym___thiscall] = ACTIONS(3742),
    [anon_sym___vectorcall] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(3742),
    [anon_sym_static] = ACTIONS(3742),
    [anon_sym_EQ] = ACTIONS(3744),
    [anon_sym_register] = ACTIONS(3742),
    [anon_sym_inline] = ACTIONS(3742),
    [anon_sym___inline] = ACTIONS(3742),
    [anon_sym___inline__] = ACTIONS(3742),
    [anon_sym___forceinline] = ACTIONS(3742),
    [anon_sym_thread_local] = ACTIONS(3742),
    [anon_sym___thread] = ACTIONS(3742),
    [anon_sym_const] = ACTIONS(3742),
    [anon_sym_constexpr] = ACTIONS(3742),
    [anon_sym_volatile] = ACTIONS(3742),
    [anon_sym_restrict] = ACTIONS(3742),
    [anon_sym___restrict__] = ACTIONS(3742),
    [anon_sym__Atomic] = ACTIONS(3742),
    [anon_sym__Noreturn] = ACTIONS(3742),
    [anon_sym_noreturn] = ACTIONS(3742),
    [anon_sym_mutable] = ACTIONS(3742),
    [anon_sym_constinit] = ACTIONS(3742),
    [anon_sym_consteval] = ACTIONS(3742),
    [anon_sym_alignas] = ACTIONS(3742),
    [anon_sym__Alignas] = ACTIONS(3742),
    [anon_sym_DOT] = ACTIONS(3742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3742),
    [anon_sym_let] = ACTIONS(3742),
    [anon_sym_This] = ACTIONS(3742),
    [anon_sym_decltype] = ACTIONS(3742),
    [sym_virtual] = ACTIONS(3742),
    [anon_sym_template] = ACTIONS(3742),
    [anon_sym_GT2] = ACTIONS(3744),
    [anon_sym_operator] = ACTIONS(3742),
    [anon_sym_precise] = ACTIONS(3742),
    [anon_sym_shared] = ACTIONS(3742),
    [anon_sym_groupshared] = ACTIONS(3742),
    [anon_sym_uniform] = ACTIONS(3742),
    [anon_sym_row_major] = ACTIONS(3742),
    [anon_sym_column_major] = ACTIONS(3742),
    [anon_sym_globallycoherent] = ACTIONS(3742),
    [anon_sym_centroid] = ACTIONS(3742),
    [anon_sym_noperspective] = ACTIONS(3742),
    [anon_sym_nointerpolation] = ACTIONS(3742),
    [anon_sym_sample] = ACTIONS(3742),
    [anon_sym_linear] = ACTIONS(3742),
    [anon_sym_snorm] = ACTIONS(3742),
    [anon_sym_unorm] = ACTIONS(3742),
    [anon_sym_point] = ACTIONS(3742),
    [anon_sym_line] = ACTIONS(3742),
    [anon_sym_triangleadj] = ACTIONS(3742),
    [anon_sym_lineadj] = ACTIONS(3742),
    [anon_sym_triangle] = ACTIONS(3742),
  },
  [2702] = {
    [sym_attribute_specifier] = STATE(2735),
    [sym_identifier] = ACTIONS(3731),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3733),
    [anon_sym_COMMA] = ACTIONS(3733),
    [anon_sym_RPAREN] = ACTIONS(3733),
    [anon_sym_LPAREN2] = ACTIONS(3733),
    [anon_sym_TILDE] = ACTIONS(3733),
    [anon_sym_STAR] = ACTIONS(3733),
    [anon_sym_AMP_AMP] = ACTIONS(3733),
    [anon_sym_AMP] = ACTIONS(3731),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_SEMI] = ACTIONS(3733),
    [anon_sym___extension__] = ACTIONS(3731),
    [anon_sym_in] = ACTIONS(3731),
    [anon_sym_out] = ACTIONS(3731),
    [anon_sym_inout] = ACTIONS(3731),
    [anon_sym_extern] = ACTIONS(3731),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(3733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3733),
    [anon_sym___declspec] = ACTIONS(3731),
    [anon_sym___based] = ACTIONS(3731),
    [anon_sym___cdecl] = ACTIONS(3731),
    [anon_sym___clrcall] = ACTIONS(3731),
    [anon_sym___stdcall] = ACTIONS(3731),
    [anon_sym___fastcall] = ACTIONS(3731),
    [anon_sym___thiscall] = ACTIONS(3731),
    [anon_sym___vectorcall] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3731),
    [anon_sym_static] = ACTIONS(3731),
    [anon_sym_EQ] = ACTIONS(3733),
    [anon_sym_register] = ACTIONS(3731),
    [anon_sym_inline] = ACTIONS(3731),
    [anon_sym___inline] = ACTIONS(3731),
    [anon_sym___inline__] = ACTIONS(3731),
    [anon_sym___forceinline] = ACTIONS(3731),
    [anon_sym_thread_local] = ACTIONS(3731),
    [anon_sym___thread] = ACTIONS(3731),
    [anon_sym_const] = ACTIONS(3731),
    [anon_sym_constexpr] = ACTIONS(3731),
    [anon_sym_volatile] = ACTIONS(3731),
    [anon_sym_restrict] = ACTIONS(3731),
    [anon_sym___restrict__] = ACTIONS(3731),
    [anon_sym__Atomic] = ACTIONS(3731),
    [anon_sym__Noreturn] = ACTIONS(3731),
    [anon_sym_noreturn] = ACTIONS(3731),
    [anon_sym_mutable] = ACTIONS(3731),
    [anon_sym_constinit] = ACTIONS(3731),
    [anon_sym_consteval] = ACTIONS(3731),
    [anon_sym_alignas] = ACTIONS(3731),
    [anon_sym__Alignas] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3731),
    [anon_sym_let] = ACTIONS(3731),
    [anon_sym_This] = ACTIONS(3731),
    [anon_sym_decltype] = ACTIONS(3731),
    [sym_virtual] = ACTIONS(3731),
    [anon_sym_template] = ACTIONS(3731),
    [anon_sym_GT2] = ACTIONS(3733),
    [anon_sym_operator] = ACTIONS(3731),
    [anon_sym_precise] = ACTIONS(3731),
    [anon_sym_shared] = ACTIONS(3731),
    [anon_sym_groupshared] = ACTIONS(3731),
    [anon_sym_uniform] = ACTIONS(3731),
    [anon_sym_row_major] = ACTIONS(3731),
    [anon_sym_column_major] = ACTIONS(3731),
    [anon_sym_globallycoherent] = ACTIONS(3731),
    [anon_sym_centroid] = ACTIONS(3731),
    [anon_sym_noperspective] = ACTIONS(3731),
    [anon_sym_nointerpolation] = ACTIONS(3731),
    [anon_sym_sample] = ACTIONS(3731),
    [anon_sym_linear] = ACTIONS(3731),
    [anon_sym_snorm] = ACTIONS(3731),
    [anon_sym_unorm] = ACTIONS(3731),
    [anon_sym_point] = ACTIONS(3731),
    [anon_sym_line] = ACTIONS(3731),
    [anon_sym_triangleadj] = ACTIONS(3731),
    [anon_sym_lineadj] = ACTIONS(3731),
    [anon_sym_triangle] = ACTIONS(3731),
  },
  [2703] = {
    [sym_attribute_specifier] = STATE(2730),
    [sym_identifier] = ACTIONS(3725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3727),
    [anon_sym_COMMA] = ACTIONS(3727),
    [anon_sym_RPAREN] = ACTIONS(3727),
    [anon_sym_LPAREN2] = ACTIONS(3727),
    [anon_sym_TILDE] = ACTIONS(3727),
    [anon_sym_STAR] = ACTIONS(3727),
    [anon_sym_AMP_AMP] = ACTIONS(3727),
    [anon_sym_AMP] = ACTIONS(3725),
    [anon_sym_COLON] = ACTIONS(3725),
    [anon_sym_SEMI] = ACTIONS(3727),
    [anon_sym___extension__] = ACTIONS(3725),
    [anon_sym_in] = ACTIONS(3725),
    [anon_sym_out] = ACTIONS(3725),
    [anon_sym_inout] = ACTIONS(3725),
    [anon_sym_extern] = ACTIONS(3725),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(3727),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3727),
    [anon_sym___declspec] = ACTIONS(3725),
    [anon_sym___based] = ACTIONS(3725),
    [anon_sym___cdecl] = ACTIONS(3725),
    [anon_sym___clrcall] = ACTIONS(3725),
    [anon_sym___stdcall] = ACTIONS(3725),
    [anon_sym___fastcall] = ACTIONS(3725),
    [anon_sym___thiscall] = ACTIONS(3725),
    [anon_sym___vectorcall] = ACTIONS(3725),
    [anon_sym_LBRACK] = ACTIONS(3725),
    [anon_sym_static] = ACTIONS(3725),
    [anon_sym_EQ] = ACTIONS(3727),
    [anon_sym_register] = ACTIONS(3725),
    [anon_sym_inline] = ACTIONS(3725),
    [anon_sym___inline] = ACTIONS(3725),
    [anon_sym___inline__] = ACTIONS(3725),
    [anon_sym___forceinline] = ACTIONS(3725),
    [anon_sym_thread_local] = ACTIONS(3725),
    [anon_sym___thread] = ACTIONS(3725),
    [anon_sym_const] = ACTIONS(3725),
    [anon_sym_constexpr] = ACTIONS(3725),
    [anon_sym_volatile] = ACTIONS(3725),
    [anon_sym_restrict] = ACTIONS(3725),
    [anon_sym___restrict__] = ACTIONS(3725),
    [anon_sym__Atomic] = ACTIONS(3725),
    [anon_sym__Noreturn] = ACTIONS(3725),
    [anon_sym_noreturn] = ACTIONS(3725),
    [anon_sym_mutable] = ACTIONS(3725),
    [anon_sym_constinit] = ACTIONS(3725),
    [anon_sym_consteval] = ACTIONS(3725),
    [anon_sym_alignas] = ACTIONS(3725),
    [anon_sym__Alignas] = ACTIONS(3725),
    [anon_sym_DOT] = ACTIONS(3725),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3725),
    [anon_sym_let] = ACTIONS(3725),
    [anon_sym_This] = ACTIONS(3725),
    [anon_sym_decltype] = ACTIONS(3725),
    [sym_virtual] = ACTIONS(3725),
    [anon_sym_template] = ACTIONS(3725),
    [anon_sym_GT2] = ACTIONS(3727),
    [anon_sym_operator] = ACTIONS(3725),
    [anon_sym_precise] = ACTIONS(3725),
    [anon_sym_shared] = ACTIONS(3725),
    [anon_sym_groupshared] = ACTIONS(3725),
    [anon_sym_uniform] = ACTIONS(3725),
    [anon_sym_row_major] = ACTIONS(3725),
    [anon_sym_column_major] = ACTIONS(3725),
    [anon_sym_globallycoherent] = ACTIONS(3725),
    [anon_sym_centroid] = ACTIONS(3725),
    [anon_sym_noperspective] = ACTIONS(3725),
    [anon_sym_nointerpolation] = ACTIONS(3725),
    [anon_sym_sample] = ACTIONS(3725),
    [anon_sym_linear] = ACTIONS(3725),
    [anon_sym_snorm] = ACTIONS(3725),
    [anon_sym_unorm] = ACTIONS(3725),
    [anon_sym_point] = ACTIONS(3725),
    [anon_sym_line] = ACTIONS(3725),
    [anon_sym_triangleadj] = ACTIONS(3725),
    [anon_sym_lineadj] = ACTIONS(3725),
    [anon_sym_triangle] = ACTIONS(3725),
  },
  [2704] = {
    [sym_attribute_specifier] = STATE(2748),
    [sym_identifier] = ACTIONS(3746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3748),
    [anon_sym_COMMA] = ACTIONS(3748),
    [anon_sym_RPAREN] = ACTIONS(3748),
    [anon_sym_LPAREN2] = ACTIONS(3748),
    [anon_sym_TILDE] = ACTIONS(3748),
    [anon_sym_STAR] = ACTIONS(3748),
    [anon_sym_AMP_AMP] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_COLON] = ACTIONS(3746),
    [anon_sym_SEMI] = ACTIONS(3748),
    [anon_sym___extension__] = ACTIONS(3746),
    [anon_sym_in] = ACTIONS(3746),
    [anon_sym_out] = ACTIONS(3746),
    [anon_sym_inout] = ACTIONS(3746),
    [anon_sym_extern] = ACTIONS(3746),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(3748),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3748),
    [anon_sym___declspec] = ACTIONS(3746),
    [anon_sym___based] = ACTIONS(3746),
    [anon_sym___cdecl] = ACTIONS(3746),
    [anon_sym___clrcall] = ACTIONS(3746),
    [anon_sym___stdcall] = ACTIONS(3746),
    [anon_sym___fastcall] = ACTIONS(3746),
    [anon_sym___thiscall] = ACTIONS(3746),
    [anon_sym___vectorcall] = ACTIONS(3746),
    [anon_sym_LBRACK] = ACTIONS(3746),
    [anon_sym_static] = ACTIONS(3746),
    [anon_sym_EQ] = ACTIONS(3748),
    [anon_sym_register] = ACTIONS(3746),
    [anon_sym_inline] = ACTIONS(3746),
    [anon_sym___inline] = ACTIONS(3746),
    [anon_sym___inline__] = ACTIONS(3746),
    [anon_sym___forceinline] = ACTIONS(3746),
    [anon_sym_thread_local] = ACTIONS(3746),
    [anon_sym___thread] = ACTIONS(3746),
    [anon_sym_const] = ACTIONS(3746),
    [anon_sym_constexpr] = ACTIONS(3746),
    [anon_sym_volatile] = ACTIONS(3746),
    [anon_sym_restrict] = ACTIONS(3746),
    [anon_sym___restrict__] = ACTIONS(3746),
    [anon_sym__Atomic] = ACTIONS(3746),
    [anon_sym__Noreturn] = ACTIONS(3746),
    [anon_sym_noreturn] = ACTIONS(3746),
    [anon_sym_mutable] = ACTIONS(3746),
    [anon_sym_constinit] = ACTIONS(3746),
    [anon_sym_consteval] = ACTIONS(3746),
    [anon_sym_alignas] = ACTIONS(3746),
    [anon_sym__Alignas] = ACTIONS(3746),
    [anon_sym_DOT] = ACTIONS(3746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3746),
    [anon_sym_let] = ACTIONS(3746),
    [anon_sym_This] = ACTIONS(3746),
    [anon_sym_decltype] = ACTIONS(3746),
    [sym_virtual] = ACTIONS(3746),
    [anon_sym_template] = ACTIONS(3746),
    [anon_sym_GT2] = ACTIONS(3748),
    [anon_sym_operator] = ACTIONS(3746),
    [anon_sym_precise] = ACTIONS(3746),
    [anon_sym_shared] = ACTIONS(3746),
    [anon_sym_groupshared] = ACTIONS(3746),
    [anon_sym_uniform] = ACTIONS(3746),
    [anon_sym_row_major] = ACTIONS(3746),
    [anon_sym_column_major] = ACTIONS(3746),
    [anon_sym_globallycoherent] = ACTIONS(3746),
    [anon_sym_centroid] = ACTIONS(3746),
    [anon_sym_noperspective] = ACTIONS(3746),
    [anon_sym_nointerpolation] = ACTIONS(3746),
    [anon_sym_sample] = ACTIONS(3746),
    [anon_sym_linear] = ACTIONS(3746),
    [anon_sym_snorm] = ACTIONS(3746),
    [anon_sym_unorm] = ACTIONS(3746),
    [anon_sym_point] = ACTIONS(3746),
    [anon_sym_line] = ACTIONS(3746),
    [anon_sym_triangleadj] = ACTIONS(3746),
    [anon_sym_lineadj] = ACTIONS(3746),
    [anon_sym_triangle] = ACTIONS(3746),
  },
  [2705] = {
    [sym_attribute_specifier] = STATE(2770),
    [sym_identifier] = ACTIONS(3830),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3832),
    [anon_sym_RPAREN] = ACTIONS(3832),
    [anon_sym_LPAREN2] = ACTIONS(3832),
    [anon_sym_TILDE] = ACTIONS(3832),
    [anon_sym_STAR] = ACTIONS(3832),
    [anon_sym_AMP_AMP] = ACTIONS(3832),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_COLON] = ACTIONS(3830),
    [anon_sym_SEMI] = ACTIONS(3832),
    [anon_sym___extension__] = ACTIONS(3830),
    [anon_sym_in] = ACTIONS(3830),
    [anon_sym_out] = ACTIONS(3830),
    [anon_sym_inout] = ACTIONS(3830),
    [anon_sym_extern] = ACTIONS(3830),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(3832),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3832),
    [anon_sym___declspec] = ACTIONS(3830),
    [anon_sym___based] = ACTIONS(3830),
    [anon_sym___cdecl] = ACTIONS(3830),
    [anon_sym___clrcall] = ACTIONS(3830),
    [anon_sym___stdcall] = ACTIONS(3830),
    [anon_sym___fastcall] = ACTIONS(3830),
    [anon_sym___thiscall] = ACTIONS(3830),
    [anon_sym___vectorcall] = ACTIONS(3830),
    [anon_sym_LBRACK] = ACTIONS(3830),
    [anon_sym_static] = ACTIONS(3830),
    [anon_sym_EQ] = ACTIONS(3832),
    [anon_sym_register] = ACTIONS(3830),
    [anon_sym_inline] = ACTIONS(3830),
    [anon_sym___inline] = ACTIONS(3830),
    [anon_sym___inline__] = ACTIONS(3830),
    [anon_sym___forceinline] = ACTIONS(3830),
    [anon_sym_thread_local] = ACTIONS(3830),
    [anon_sym___thread] = ACTIONS(3830),
    [anon_sym_const] = ACTIONS(3830),
    [anon_sym_constexpr] = ACTIONS(3830),
    [anon_sym_volatile] = ACTIONS(3830),
    [anon_sym_restrict] = ACTIONS(3830),
    [anon_sym___restrict__] = ACTIONS(3830),
    [anon_sym__Atomic] = ACTIONS(3830),
    [anon_sym__Noreturn] = ACTIONS(3830),
    [anon_sym_noreturn] = ACTIONS(3830),
    [anon_sym_mutable] = ACTIONS(3830),
    [anon_sym_constinit] = ACTIONS(3830),
    [anon_sym_consteval] = ACTIONS(3830),
    [anon_sym_alignas] = ACTIONS(3830),
    [anon_sym__Alignas] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3830),
    [anon_sym_let] = ACTIONS(3830),
    [anon_sym_This] = ACTIONS(3830),
    [anon_sym_decltype] = ACTIONS(3830),
    [sym_virtual] = ACTIONS(3830),
    [anon_sym_template] = ACTIONS(3830),
    [anon_sym_GT2] = ACTIONS(3832),
    [anon_sym_operator] = ACTIONS(3830),
    [anon_sym_precise] = ACTIONS(3830),
    [anon_sym_shared] = ACTIONS(3830),
    [anon_sym_groupshared] = ACTIONS(3830),
    [anon_sym_uniform] = ACTIONS(3830),
    [anon_sym_row_major] = ACTIONS(3830),
    [anon_sym_column_major] = ACTIONS(3830),
    [anon_sym_globallycoherent] = ACTIONS(3830),
    [anon_sym_centroid] = ACTIONS(3830),
    [anon_sym_noperspective] = ACTIONS(3830),
    [anon_sym_nointerpolation] = ACTIONS(3830),
    [anon_sym_sample] = ACTIONS(3830),
    [anon_sym_linear] = ACTIONS(3830),
    [anon_sym_snorm] = ACTIONS(3830),
    [anon_sym_unorm] = ACTIONS(3830),
    [anon_sym_point] = ACTIONS(3830),
    [anon_sym_line] = ACTIONS(3830),
    [anon_sym_triangleadj] = ACTIONS(3830),
    [anon_sym_lineadj] = ACTIONS(3830),
    [anon_sym_triangle] = ACTIONS(3830),
  },
  [2706] = {
    [sym_attribute_specifier] = STATE(2737),
    [sym_identifier] = ACTIONS(3719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3721),
    [anon_sym_RPAREN] = ACTIONS(3721),
    [anon_sym_LPAREN2] = ACTIONS(3721),
    [anon_sym_TILDE] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3719),
    [anon_sym_SEMI] = ACTIONS(3721),
    [anon_sym___extension__] = ACTIONS(3719),
    [anon_sym_in] = ACTIONS(3719),
    [anon_sym_out] = ACTIONS(3719),
    [anon_sym_inout] = ACTIONS(3719),
    [anon_sym_extern] = ACTIONS(3719),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(3721),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3721),
    [anon_sym___declspec] = ACTIONS(3719),
    [anon_sym___based] = ACTIONS(3719),
    [anon_sym___cdecl] = ACTIONS(3719),
    [anon_sym___clrcall] = ACTIONS(3719),
    [anon_sym___stdcall] = ACTIONS(3719),
    [anon_sym___fastcall] = ACTIONS(3719),
    [anon_sym___thiscall] = ACTIONS(3719),
    [anon_sym___vectorcall] = ACTIONS(3719),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_static] = ACTIONS(3719),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_register] = ACTIONS(3719),
    [anon_sym_inline] = ACTIONS(3719),
    [anon_sym___inline] = ACTIONS(3719),
    [anon_sym___inline__] = ACTIONS(3719),
    [anon_sym___forceinline] = ACTIONS(3719),
    [anon_sym_thread_local] = ACTIONS(3719),
    [anon_sym___thread] = ACTIONS(3719),
    [anon_sym_const] = ACTIONS(3719),
    [anon_sym_constexpr] = ACTIONS(3719),
    [anon_sym_volatile] = ACTIONS(3719),
    [anon_sym_restrict] = ACTIONS(3719),
    [anon_sym___restrict__] = ACTIONS(3719),
    [anon_sym__Atomic] = ACTIONS(3719),
    [anon_sym__Noreturn] = ACTIONS(3719),
    [anon_sym_noreturn] = ACTIONS(3719),
    [anon_sym_mutable] = ACTIONS(3719),
    [anon_sym_constinit] = ACTIONS(3719),
    [anon_sym_consteval] = ACTIONS(3719),
    [anon_sym_alignas] = ACTIONS(3719),
    [anon_sym__Alignas] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3719),
    [anon_sym_let] = ACTIONS(3719),
    [anon_sym_This] = ACTIONS(3719),
    [anon_sym_decltype] = ACTIONS(3719),
    [sym_virtual] = ACTIONS(3719),
    [anon_sym_template] = ACTIONS(3719),
    [anon_sym_GT2] = ACTIONS(3721),
    [anon_sym_operator] = ACTIONS(3719),
    [anon_sym_precise] = ACTIONS(3719),
    [anon_sym_shared] = ACTIONS(3719),
    [anon_sym_groupshared] = ACTIONS(3719),
    [anon_sym_uniform] = ACTIONS(3719),
    [anon_sym_row_major] = ACTIONS(3719),
    [anon_sym_column_major] = ACTIONS(3719),
    [anon_sym_globallycoherent] = ACTIONS(3719),
    [anon_sym_centroid] = ACTIONS(3719),
    [anon_sym_noperspective] = ACTIONS(3719),
    [anon_sym_nointerpolation] = ACTIONS(3719),
    [anon_sym_sample] = ACTIONS(3719),
    [anon_sym_linear] = ACTIONS(3719),
    [anon_sym_snorm] = ACTIONS(3719),
    [anon_sym_unorm] = ACTIONS(3719),
    [anon_sym_point] = ACTIONS(3719),
    [anon_sym_line] = ACTIONS(3719),
    [anon_sym_triangleadj] = ACTIONS(3719),
    [anon_sym_lineadj] = ACTIONS(3719),
    [anon_sym_triangle] = ACTIONS(3719),
  },
  [2707] = {
    [sym_template_argument_list] = STATE(2899),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2639),
    [sym_identifier] = ACTIONS(2115),
    [anon_sym_LPAREN2] = ACTIONS(2140),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_AMP_AMP] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2115),
    [anon_sym_LT] = ACTIONS(6343),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym___extension__] = ACTIONS(2115),
    [anon_sym_in] = ACTIONS(2115),
    [anon_sym_out] = ACTIONS(2115),
    [anon_sym_inout] = ACTIONS(2115),
    [anon_sym_extern] = ACTIONS(2115),
    [anon_sym___attribute__] = ACTIONS(2115),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2140),
    [anon_sym___declspec] = ACTIONS(2115),
    [anon_sym___based] = ACTIONS(2115),
    [anon_sym___cdecl] = ACTIONS(2115),
    [anon_sym___clrcall] = ACTIONS(2115),
    [anon_sym___stdcall] = ACTIONS(2115),
    [anon_sym___fastcall] = ACTIONS(2115),
    [anon_sym___thiscall] = ACTIONS(2115),
    [anon_sym___vectorcall] = ACTIONS(2115),
    [anon_sym_signed] = ACTIONS(4863),
    [anon_sym_unsigned] = ACTIONS(4863),
    [anon_sym_long] = ACTIONS(4863),
    [anon_sym_short] = ACTIONS(4863),
    [anon_sym_LBRACK] = ACTIONS(6345),
    [anon_sym_static] = ACTIONS(2115),
    [anon_sym_register] = ACTIONS(2115),
    [anon_sym_inline] = ACTIONS(2115),
    [anon_sym___inline] = ACTIONS(2115),
    [anon_sym___inline__] = ACTIONS(2115),
    [anon_sym___forceinline] = ACTIONS(2115),
    [anon_sym_thread_local] = ACTIONS(2115),
    [anon_sym___thread] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(2115),
    [anon_sym_constexpr] = ACTIONS(2115),
    [anon_sym_volatile] = ACTIONS(2115),
    [anon_sym_restrict] = ACTIONS(2115),
    [anon_sym___restrict__] = ACTIONS(2115),
    [anon_sym__Atomic] = ACTIONS(2115),
    [anon_sym__Noreturn] = ACTIONS(2115),
    [anon_sym_noreturn] = ACTIONS(2115),
    [anon_sym_mutable] = ACTIONS(2115),
    [anon_sym_constinit] = ACTIONS(2115),
    [anon_sym_consteval] = ACTIONS(2115),
    [anon_sym_alignas] = ACTIONS(2115),
    [anon_sym__Alignas] = ACTIONS(2115),
    [anon_sym_DOT] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2115),
    [anon_sym_let] = ACTIONS(2115),
    [anon_sym_This] = ACTIONS(2115),
    [anon_sym_decltype] = ACTIONS(2115),
    [sym_virtual] = ACTIONS(2115),
    [anon_sym_template] = ACTIONS(2115),
    [anon_sym_operator] = ACTIONS(2115),
    [anon_sym_precise] = ACTIONS(2115),
    [anon_sym_shared] = ACTIONS(2115),
    [anon_sym_groupshared] = ACTIONS(2115),
    [anon_sym_uniform] = ACTIONS(2115),
    [anon_sym_row_major] = ACTIONS(2115),
    [anon_sym_column_major] = ACTIONS(2115),
    [anon_sym_globallycoherent] = ACTIONS(2115),
    [anon_sym_centroid] = ACTIONS(2115),
    [anon_sym_noperspective] = ACTIONS(2115),
    [anon_sym_nointerpolation] = ACTIONS(2115),
    [anon_sym_sample] = ACTIONS(2115),
    [anon_sym_linear] = ACTIONS(2115),
    [anon_sym_snorm] = ACTIONS(2115),
    [anon_sym_unorm] = ACTIONS(2115),
    [anon_sym_point] = ACTIONS(2115),
    [anon_sym_line] = ACTIONS(2115),
    [anon_sym_triangleadj] = ACTIONS(2115),
    [anon_sym_lineadj] = ACTIONS(2115),
    [anon_sym_triangle] = ACTIONS(2115),
  },
  [2708] = {
    [sym_attribute_specifier] = STATE(2758),
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3797),
    [anon_sym_COMMA] = ACTIONS(3797),
    [anon_sym_RPAREN] = ACTIONS(3797),
    [anon_sym_LPAREN2] = ACTIONS(3797),
    [anon_sym_TILDE] = ACTIONS(3797),
    [anon_sym_STAR] = ACTIONS(3797),
    [anon_sym_AMP_AMP] = ACTIONS(3797),
    [anon_sym_AMP] = ACTIONS(3795),
    [anon_sym_COLON] = ACTIONS(3795),
    [anon_sym_SEMI] = ACTIONS(3797),
    [anon_sym___extension__] = ACTIONS(3795),
    [anon_sym_in] = ACTIONS(3795),
    [anon_sym_out] = ACTIONS(3795),
    [anon_sym_inout] = ACTIONS(3795),
    [anon_sym_extern] = ACTIONS(3795),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(3797),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3797),
    [anon_sym___declspec] = ACTIONS(3795),
    [anon_sym___based] = ACTIONS(3795),
    [anon_sym___cdecl] = ACTIONS(3795),
    [anon_sym___clrcall] = ACTIONS(3795),
    [anon_sym___stdcall] = ACTIONS(3795),
    [anon_sym___fastcall] = ACTIONS(3795),
    [anon_sym___thiscall] = ACTIONS(3795),
    [anon_sym___vectorcall] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3795),
    [anon_sym_static] = ACTIONS(3795),
    [anon_sym_EQ] = ACTIONS(3797),
    [anon_sym_register] = ACTIONS(3795),
    [anon_sym_inline] = ACTIONS(3795),
    [anon_sym___inline] = ACTIONS(3795),
    [anon_sym___inline__] = ACTIONS(3795),
    [anon_sym___forceinline] = ACTIONS(3795),
    [anon_sym_thread_local] = ACTIONS(3795),
    [anon_sym___thread] = ACTIONS(3795),
    [anon_sym_const] = ACTIONS(3795),
    [anon_sym_constexpr] = ACTIONS(3795),
    [anon_sym_volatile] = ACTIONS(3795),
    [anon_sym_restrict] = ACTIONS(3795),
    [anon_sym___restrict__] = ACTIONS(3795),
    [anon_sym__Atomic] = ACTIONS(3795),
    [anon_sym__Noreturn] = ACTIONS(3795),
    [anon_sym_noreturn] = ACTIONS(3795),
    [anon_sym_mutable] = ACTIONS(3795),
    [anon_sym_constinit] = ACTIONS(3795),
    [anon_sym_consteval] = ACTIONS(3795),
    [anon_sym_alignas] = ACTIONS(3795),
    [anon_sym__Alignas] = ACTIONS(3795),
    [anon_sym_DOT] = ACTIONS(3795),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3795),
    [anon_sym_let] = ACTIONS(3795),
    [anon_sym_This] = ACTIONS(3795),
    [anon_sym_decltype] = ACTIONS(3795),
    [sym_virtual] = ACTIONS(3795),
    [anon_sym_template] = ACTIONS(3795),
    [anon_sym_GT2] = ACTIONS(3797),
    [anon_sym_operator] = ACTIONS(3795),
    [anon_sym_precise] = ACTIONS(3795),
    [anon_sym_shared] = ACTIONS(3795),
    [anon_sym_groupshared] = ACTIONS(3795),
    [anon_sym_uniform] = ACTIONS(3795),
    [anon_sym_row_major] = ACTIONS(3795),
    [anon_sym_column_major] = ACTIONS(3795),
    [anon_sym_globallycoherent] = ACTIONS(3795),
    [anon_sym_centroid] = ACTIONS(3795),
    [anon_sym_noperspective] = ACTIONS(3795),
    [anon_sym_nointerpolation] = ACTIONS(3795),
    [anon_sym_sample] = ACTIONS(3795),
    [anon_sym_linear] = ACTIONS(3795),
    [anon_sym_snorm] = ACTIONS(3795),
    [anon_sym_unorm] = ACTIONS(3795),
    [anon_sym_point] = ACTIONS(3795),
    [anon_sym_line] = ACTIONS(3795),
    [anon_sym_triangleadj] = ACTIONS(3795),
    [anon_sym_lineadj] = ACTIONS(3795),
    [anon_sym_triangle] = ACTIONS(3795),
  },
  [2709] = {
    [sym_template_argument_list] = STATE(2686),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2639),
    [sym_identifier] = ACTIONS(2115),
    [anon_sym_LPAREN2] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_AMP_AMP] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2115),
    [anon_sym_LT] = ACTIONS(6343),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym___extension__] = ACTIONS(2115),
    [anon_sym_in] = ACTIONS(2115),
    [anon_sym_out] = ACTIONS(2115),
    [anon_sym_inout] = ACTIONS(2115),
    [anon_sym_extern] = ACTIONS(2115),
    [anon_sym___attribute__] = ACTIONS(2115),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2123),
    [anon_sym___declspec] = ACTIONS(2115),
    [anon_sym___based] = ACTIONS(2115),
    [anon_sym___cdecl] = ACTIONS(2115),
    [anon_sym___clrcall] = ACTIONS(2115),
    [anon_sym___stdcall] = ACTIONS(2115),
    [anon_sym___fastcall] = ACTIONS(2115),
    [anon_sym___thiscall] = ACTIONS(2115),
    [anon_sym___vectorcall] = ACTIONS(2115),
    [anon_sym_signed] = ACTIONS(4863),
    [anon_sym_unsigned] = ACTIONS(4863),
    [anon_sym_long] = ACTIONS(4863),
    [anon_sym_short] = ACTIONS(4863),
    [anon_sym_LBRACK] = ACTIONS(2115),
    [anon_sym_static] = ACTIONS(2115),
    [anon_sym_register] = ACTIONS(2115),
    [anon_sym_inline] = ACTIONS(2115),
    [anon_sym___inline] = ACTIONS(2115),
    [anon_sym___inline__] = ACTIONS(2115),
    [anon_sym___forceinline] = ACTIONS(2115),
    [anon_sym_thread_local] = ACTIONS(2115),
    [anon_sym___thread] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(2115),
    [anon_sym_constexpr] = ACTIONS(2115),
    [anon_sym_volatile] = ACTIONS(2115),
    [anon_sym_restrict] = ACTIONS(2115),
    [anon_sym___restrict__] = ACTIONS(2115),
    [anon_sym__Atomic] = ACTIONS(2115),
    [anon_sym__Noreturn] = ACTIONS(2115),
    [anon_sym_noreturn] = ACTIONS(2115),
    [anon_sym_mutable] = ACTIONS(2115),
    [anon_sym_constinit] = ACTIONS(2115),
    [anon_sym_consteval] = ACTIONS(2115),
    [anon_sym_alignas] = ACTIONS(2115),
    [anon_sym__Alignas] = ACTIONS(2115),
    [anon_sym_DOT] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2115),
    [anon_sym_let] = ACTIONS(2115),
    [anon_sym_This] = ACTIONS(2115),
    [anon_sym_decltype] = ACTIONS(2115),
    [sym_virtual] = ACTIONS(2115),
    [anon_sym_template] = ACTIONS(2115),
    [anon_sym_operator] = ACTIONS(2115),
    [anon_sym_precise] = ACTIONS(2115),
    [anon_sym_shared] = ACTIONS(2115),
    [anon_sym_groupshared] = ACTIONS(2115),
    [anon_sym_uniform] = ACTIONS(2115),
    [anon_sym_row_major] = ACTIONS(2115),
    [anon_sym_column_major] = ACTIONS(2115),
    [anon_sym_globallycoherent] = ACTIONS(2115),
    [anon_sym_centroid] = ACTIONS(2115),
    [anon_sym_noperspective] = ACTIONS(2115),
    [anon_sym_nointerpolation] = ACTIONS(2115),
    [anon_sym_sample] = ACTIONS(2115),
    [anon_sym_linear] = ACTIONS(2115),
    [anon_sym_snorm] = ACTIONS(2115),
    [anon_sym_unorm] = ACTIONS(2115),
    [anon_sym_point] = ACTIONS(2115),
    [anon_sym_line] = ACTIONS(2115),
    [anon_sym_triangleadj] = ACTIONS(2115),
    [anon_sym_lineadj] = ACTIONS(2115),
    [anon_sym_triangle] = ACTIONS(2115),
  },
  [2710] = {
    [sym_attribute_specifier] = STATE(2726),
    [sym_identifier] = ACTIONS(3735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3737),
    [anon_sym_COMMA] = ACTIONS(3737),
    [anon_sym_RPAREN] = ACTIONS(3737),
    [anon_sym_LPAREN2] = ACTIONS(3737),
    [anon_sym_TILDE] = ACTIONS(3737),
    [anon_sym_STAR] = ACTIONS(3737),
    [anon_sym_AMP_AMP] = ACTIONS(3737),
    [anon_sym_AMP] = ACTIONS(3735),
    [anon_sym_COLON] = ACTIONS(3735),
    [anon_sym_SEMI] = ACTIONS(3737),
    [anon_sym___extension__] = ACTIONS(3735),
    [anon_sym_in] = ACTIONS(3735),
    [anon_sym_out] = ACTIONS(3735),
    [anon_sym_inout] = ACTIONS(3735),
    [anon_sym_extern] = ACTIONS(3735),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(3737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3737),
    [anon_sym___declspec] = ACTIONS(3735),
    [anon_sym___based] = ACTIONS(3735),
    [anon_sym___cdecl] = ACTIONS(3735),
    [anon_sym___clrcall] = ACTIONS(3735),
    [anon_sym___stdcall] = ACTIONS(3735),
    [anon_sym___fastcall] = ACTIONS(3735),
    [anon_sym___thiscall] = ACTIONS(3735),
    [anon_sym___vectorcall] = ACTIONS(3735),
    [anon_sym_LBRACK] = ACTIONS(3735),
    [anon_sym_static] = ACTIONS(3735),
    [anon_sym_EQ] = ACTIONS(3737),
    [anon_sym_register] = ACTIONS(3735),
    [anon_sym_inline] = ACTIONS(3735),
    [anon_sym___inline] = ACTIONS(3735),
    [anon_sym___inline__] = ACTIONS(3735),
    [anon_sym___forceinline] = ACTIONS(3735),
    [anon_sym_thread_local] = ACTIONS(3735),
    [anon_sym___thread] = ACTIONS(3735),
    [anon_sym_const] = ACTIONS(3735),
    [anon_sym_constexpr] = ACTIONS(3735),
    [anon_sym_volatile] = ACTIONS(3735),
    [anon_sym_restrict] = ACTIONS(3735),
    [anon_sym___restrict__] = ACTIONS(3735),
    [anon_sym__Atomic] = ACTIONS(3735),
    [anon_sym__Noreturn] = ACTIONS(3735),
    [anon_sym_noreturn] = ACTIONS(3735),
    [anon_sym_mutable] = ACTIONS(3735),
    [anon_sym_constinit] = ACTIONS(3735),
    [anon_sym_consteval] = ACTIONS(3735),
    [anon_sym_alignas] = ACTIONS(3735),
    [anon_sym__Alignas] = ACTIONS(3735),
    [anon_sym_DOT] = ACTIONS(3735),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3735),
    [anon_sym_let] = ACTIONS(3735),
    [anon_sym_This] = ACTIONS(3735),
    [anon_sym_decltype] = ACTIONS(3735),
    [sym_virtual] = ACTIONS(3735),
    [anon_sym_template] = ACTIONS(3735),
    [anon_sym_GT2] = ACTIONS(3737),
    [anon_sym_operator] = ACTIONS(3735),
    [anon_sym_precise] = ACTIONS(3735),
    [anon_sym_shared] = ACTIONS(3735),
    [anon_sym_groupshared] = ACTIONS(3735),
    [anon_sym_uniform] = ACTIONS(3735),
    [anon_sym_row_major] = ACTIONS(3735),
    [anon_sym_column_major] = ACTIONS(3735),
    [anon_sym_globallycoherent] = ACTIONS(3735),
    [anon_sym_centroid] = ACTIONS(3735),
    [anon_sym_noperspective] = ACTIONS(3735),
    [anon_sym_nointerpolation] = ACTIONS(3735),
    [anon_sym_sample] = ACTIONS(3735),
    [anon_sym_linear] = ACTIONS(3735),
    [anon_sym_snorm] = ACTIONS(3735),
    [anon_sym_unorm] = ACTIONS(3735),
    [anon_sym_point] = ACTIONS(3735),
    [anon_sym_line] = ACTIONS(3735),
    [anon_sym_triangleadj] = ACTIONS(3735),
    [anon_sym_lineadj] = ACTIONS(3735),
    [anon_sym_triangle] = ACTIONS(3735),
  },
  [2711] = {
    [sym_attribute_specifier] = STATE(2720),
    [sym_identifier] = ACTIONS(3840),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3842),
    [anon_sym_COMMA] = ACTIONS(3842),
    [anon_sym_RPAREN] = ACTIONS(3842),
    [anon_sym_LPAREN2] = ACTIONS(3842),
    [anon_sym_TILDE] = ACTIONS(3842),
    [anon_sym_STAR] = ACTIONS(3842),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_AMP] = ACTIONS(3840),
    [anon_sym_COLON] = ACTIONS(3840),
    [anon_sym_SEMI] = ACTIONS(3842),
    [anon_sym___extension__] = ACTIONS(3840),
    [anon_sym_in] = ACTIONS(3840),
    [anon_sym_out] = ACTIONS(3840),
    [anon_sym_inout] = ACTIONS(3840),
    [anon_sym_extern] = ACTIONS(3840),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(3842),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3842),
    [anon_sym___declspec] = ACTIONS(3840),
    [anon_sym___based] = ACTIONS(3840),
    [anon_sym___cdecl] = ACTIONS(3840),
    [anon_sym___clrcall] = ACTIONS(3840),
    [anon_sym___stdcall] = ACTIONS(3840),
    [anon_sym___fastcall] = ACTIONS(3840),
    [anon_sym___thiscall] = ACTIONS(3840),
    [anon_sym___vectorcall] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3840),
    [anon_sym_static] = ACTIONS(3840),
    [anon_sym_EQ] = ACTIONS(3842),
    [anon_sym_register] = ACTIONS(3840),
    [anon_sym_inline] = ACTIONS(3840),
    [anon_sym___inline] = ACTIONS(3840),
    [anon_sym___inline__] = ACTIONS(3840),
    [anon_sym___forceinline] = ACTIONS(3840),
    [anon_sym_thread_local] = ACTIONS(3840),
    [anon_sym___thread] = ACTIONS(3840),
    [anon_sym_const] = ACTIONS(3840),
    [anon_sym_constexpr] = ACTIONS(3840),
    [anon_sym_volatile] = ACTIONS(3840),
    [anon_sym_restrict] = ACTIONS(3840),
    [anon_sym___restrict__] = ACTIONS(3840),
    [anon_sym__Atomic] = ACTIONS(3840),
    [anon_sym__Noreturn] = ACTIONS(3840),
    [anon_sym_noreturn] = ACTIONS(3840),
    [anon_sym_mutable] = ACTIONS(3840),
    [anon_sym_constinit] = ACTIONS(3840),
    [anon_sym_consteval] = ACTIONS(3840),
    [anon_sym_alignas] = ACTIONS(3840),
    [anon_sym__Alignas] = ACTIONS(3840),
    [anon_sym_DOT] = ACTIONS(3840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3840),
    [anon_sym_let] = ACTIONS(3840),
    [anon_sym_This] = ACTIONS(3840),
    [anon_sym_decltype] = ACTIONS(3840),
    [sym_virtual] = ACTIONS(3840),
    [anon_sym_template] = ACTIONS(3840),
    [anon_sym_GT2] = ACTIONS(3842),
    [anon_sym_operator] = ACTIONS(3840),
    [anon_sym_precise] = ACTIONS(3840),
    [anon_sym_shared] = ACTIONS(3840),
    [anon_sym_groupshared] = ACTIONS(3840),
    [anon_sym_uniform] = ACTIONS(3840),
    [anon_sym_row_major] = ACTIONS(3840),
    [anon_sym_column_major] = ACTIONS(3840),
    [anon_sym_globallycoherent] = ACTIONS(3840),
    [anon_sym_centroid] = ACTIONS(3840),
    [anon_sym_noperspective] = ACTIONS(3840),
    [anon_sym_nointerpolation] = ACTIONS(3840),
    [anon_sym_sample] = ACTIONS(3840),
    [anon_sym_linear] = ACTIONS(3840),
    [anon_sym_snorm] = ACTIONS(3840),
    [anon_sym_unorm] = ACTIONS(3840),
    [anon_sym_point] = ACTIONS(3840),
    [anon_sym_line] = ACTIONS(3840),
    [anon_sym_triangleadj] = ACTIONS(3840),
    [anon_sym_lineadj] = ACTIONS(3840),
    [anon_sym_triangle] = ACTIONS(3840),
  },
  [2712] = {
    [sym_identifier] = ACTIONS(3392),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3390),
    [anon_sym_COMMA] = ACTIONS(3390),
    [anon_sym_RPAREN] = ACTIONS(3390),
    [anon_sym_LPAREN2] = ACTIONS(3390),
    [anon_sym_TILDE] = ACTIONS(3390),
    [anon_sym_STAR] = ACTIONS(3390),
    [anon_sym_AMP_AMP] = ACTIONS(3390),
    [anon_sym_AMP] = ACTIONS(3392),
    [anon_sym_COLON] = ACTIONS(3392),
    [anon_sym_SEMI] = ACTIONS(3390),
    [anon_sym___extension__] = ACTIONS(3392),
    [anon_sym_in] = ACTIONS(3392),
    [anon_sym_out] = ACTIONS(3392),
    [anon_sym_inout] = ACTIONS(3392),
    [anon_sym_extern] = ACTIONS(3392),
    [anon_sym___attribute__] = ACTIONS(3392),
    [anon_sym_COLON_COLON] = ACTIONS(3390),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3390),
    [anon_sym___declspec] = ACTIONS(3392),
    [anon_sym___based] = ACTIONS(3392),
    [anon_sym___cdecl] = ACTIONS(3392),
    [anon_sym___clrcall] = ACTIONS(3392),
    [anon_sym___stdcall] = ACTIONS(3392),
    [anon_sym___fastcall] = ACTIONS(3392),
    [anon_sym___thiscall] = ACTIONS(3392),
    [anon_sym___vectorcall] = ACTIONS(3392),
    [anon_sym_LBRACE] = ACTIONS(3390),
    [anon_sym_LBRACK] = ACTIONS(3392),
    [anon_sym_static] = ACTIONS(3392),
    [anon_sym_EQ] = ACTIONS(3390),
    [anon_sym_register] = ACTIONS(3392),
    [anon_sym_inline] = ACTIONS(3392),
    [anon_sym___inline] = ACTIONS(3392),
    [anon_sym___inline__] = ACTIONS(3392),
    [anon_sym___forceinline] = ACTIONS(3392),
    [anon_sym_thread_local] = ACTIONS(3392),
    [anon_sym___thread] = ACTIONS(3392),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_constexpr] = ACTIONS(3392),
    [anon_sym_volatile] = ACTIONS(3392),
    [anon_sym_restrict] = ACTIONS(3392),
    [anon_sym___restrict__] = ACTIONS(3392),
    [anon_sym__Atomic] = ACTIONS(3392),
    [anon_sym__Noreturn] = ACTIONS(3392),
    [anon_sym_noreturn] = ACTIONS(3392),
    [anon_sym_mutable] = ACTIONS(3392),
    [anon_sym_constinit] = ACTIONS(3392),
    [anon_sym_consteval] = ACTIONS(3392),
    [anon_sym_alignas] = ACTIONS(3392),
    [anon_sym__Alignas] = ACTIONS(3392),
    [anon_sym_DOT] = ACTIONS(3392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3392),
    [anon_sym_let] = ACTIONS(3392),
    [anon_sym_This] = ACTIONS(3392),
    [anon_sym_decltype] = ACTIONS(3392),
    [sym_virtual] = ACTIONS(3392),
    [anon_sym_template] = ACTIONS(3392),
    [anon_sym_GT2] = ACTIONS(3390),
    [anon_sym_operator] = ACTIONS(3392),
    [anon_sym_precise] = ACTIONS(3392),
    [anon_sym_shared] = ACTIONS(3392),
    [anon_sym_groupshared] = ACTIONS(3392),
    [anon_sym_uniform] = ACTIONS(3392),
    [anon_sym_row_major] = ACTIONS(3392),
    [anon_sym_column_major] = ACTIONS(3392),
    [anon_sym_globallycoherent] = ACTIONS(3392),
    [anon_sym_centroid] = ACTIONS(3392),
    [anon_sym_noperspective] = ACTIONS(3392),
    [anon_sym_nointerpolation] = ACTIONS(3392),
    [anon_sym_sample] = ACTIONS(3392),
    [anon_sym_linear] = ACTIONS(3392),
    [anon_sym_snorm] = ACTIONS(3392),
    [anon_sym_unorm] = ACTIONS(3392),
    [anon_sym_point] = ACTIONS(3392),
    [anon_sym_line] = ACTIONS(3392),
    [anon_sym_triangleadj] = ACTIONS(3392),
    [anon_sym_lineadj] = ACTIONS(3392),
    [anon_sym_triangle] = ACTIONS(3392),
  },
  [2713] = {
    [sym_attribute_specifier] = STATE(2740),
    [sym_identifier] = ACTIONS(3836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3838),
    [anon_sym_COMMA] = ACTIONS(3838),
    [anon_sym_RPAREN] = ACTIONS(3838),
    [anon_sym_LPAREN2] = ACTIONS(3838),
    [anon_sym_TILDE] = ACTIONS(3838),
    [anon_sym_STAR] = ACTIONS(3838),
    [anon_sym_AMP_AMP] = ACTIONS(3838),
    [anon_sym_AMP] = ACTIONS(3836),
    [anon_sym_COLON] = ACTIONS(3836),
    [anon_sym_SEMI] = ACTIONS(3838),
    [anon_sym___extension__] = ACTIONS(3836),
    [anon_sym_in] = ACTIONS(3836),
    [anon_sym_out] = ACTIONS(3836),
    [anon_sym_inout] = ACTIONS(3836),
    [anon_sym_extern] = ACTIONS(3836),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(3838),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3838),
    [anon_sym___declspec] = ACTIONS(3836),
    [anon_sym___based] = ACTIONS(3836),
    [anon_sym___cdecl] = ACTIONS(3836),
    [anon_sym___clrcall] = ACTIONS(3836),
    [anon_sym___stdcall] = ACTIONS(3836),
    [anon_sym___fastcall] = ACTIONS(3836),
    [anon_sym___thiscall] = ACTIONS(3836),
    [anon_sym___vectorcall] = ACTIONS(3836),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_static] = ACTIONS(3836),
    [anon_sym_EQ] = ACTIONS(3838),
    [anon_sym_register] = ACTIONS(3836),
    [anon_sym_inline] = ACTIONS(3836),
    [anon_sym___inline] = ACTIONS(3836),
    [anon_sym___inline__] = ACTIONS(3836),
    [anon_sym___forceinline] = ACTIONS(3836),
    [anon_sym_thread_local] = ACTIONS(3836),
    [anon_sym___thread] = ACTIONS(3836),
    [anon_sym_const] = ACTIONS(3836),
    [anon_sym_constexpr] = ACTIONS(3836),
    [anon_sym_volatile] = ACTIONS(3836),
    [anon_sym_restrict] = ACTIONS(3836),
    [anon_sym___restrict__] = ACTIONS(3836),
    [anon_sym__Atomic] = ACTIONS(3836),
    [anon_sym__Noreturn] = ACTIONS(3836),
    [anon_sym_noreturn] = ACTIONS(3836),
    [anon_sym_mutable] = ACTIONS(3836),
    [anon_sym_constinit] = ACTIONS(3836),
    [anon_sym_consteval] = ACTIONS(3836),
    [anon_sym_alignas] = ACTIONS(3836),
    [anon_sym__Alignas] = ACTIONS(3836),
    [anon_sym_DOT] = ACTIONS(3836),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3836),
    [anon_sym_let] = ACTIONS(3836),
    [anon_sym_This] = ACTIONS(3836),
    [anon_sym_decltype] = ACTIONS(3836),
    [sym_virtual] = ACTIONS(3836),
    [anon_sym_template] = ACTIONS(3836),
    [anon_sym_GT2] = ACTIONS(3838),
    [anon_sym_operator] = ACTIONS(3836),
    [anon_sym_precise] = ACTIONS(3836),
    [anon_sym_shared] = ACTIONS(3836),
    [anon_sym_groupshared] = ACTIONS(3836),
    [anon_sym_uniform] = ACTIONS(3836),
    [anon_sym_row_major] = ACTIONS(3836),
    [anon_sym_column_major] = ACTIONS(3836),
    [anon_sym_globallycoherent] = ACTIONS(3836),
    [anon_sym_centroid] = ACTIONS(3836),
    [anon_sym_noperspective] = ACTIONS(3836),
    [anon_sym_nointerpolation] = ACTIONS(3836),
    [anon_sym_sample] = ACTIONS(3836),
    [anon_sym_linear] = ACTIONS(3836),
    [anon_sym_snorm] = ACTIONS(3836),
    [anon_sym_unorm] = ACTIONS(3836),
    [anon_sym_point] = ACTIONS(3836),
    [anon_sym_line] = ACTIONS(3836),
    [anon_sym_triangleadj] = ACTIONS(3836),
    [anon_sym_lineadj] = ACTIONS(3836),
    [anon_sym_triangle] = ACTIONS(3836),
  },
  [2714] = {
    [sym_attribute_specifier] = STATE(2736),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3801),
    [anon_sym_COMMA] = ACTIONS(3801),
    [anon_sym_RPAREN] = ACTIONS(3801),
    [anon_sym_LPAREN2] = ACTIONS(3801),
    [anon_sym_TILDE] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(3801),
    [anon_sym_AMP_AMP] = ACTIONS(3801),
    [anon_sym_AMP] = ACTIONS(3799),
    [anon_sym_COLON] = ACTIONS(3799),
    [anon_sym_SEMI] = ACTIONS(3801),
    [anon_sym___extension__] = ACTIONS(3799),
    [anon_sym_in] = ACTIONS(3799),
    [anon_sym_out] = ACTIONS(3799),
    [anon_sym_inout] = ACTIONS(3799),
    [anon_sym_extern] = ACTIONS(3799),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(3801),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3801),
    [anon_sym___declspec] = ACTIONS(3799),
    [anon_sym___based] = ACTIONS(3799),
    [anon_sym___cdecl] = ACTIONS(3799),
    [anon_sym___clrcall] = ACTIONS(3799),
    [anon_sym___stdcall] = ACTIONS(3799),
    [anon_sym___fastcall] = ACTIONS(3799),
    [anon_sym___thiscall] = ACTIONS(3799),
    [anon_sym___vectorcall] = ACTIONS(3799),
    [anon_sym_LBRACK] = ACTIONS(3799),
    [anon_sym_static] = ACTIONS(3799),
    [anon_sym_EQ] = ACTIONS(3801),
    [anon_sym_register] = ACTIONS(3799),
    [anon_sym_inline] = ACTIONS(3799),
    [anon_sym___inline] = ACTIONS(3799),
    [anon_sym___inline__] = ACTIONS(3799),
    [anon_sym___forceinline] = ACTIONS(3799),
    [anon_sym_thread_local] = ACTIONS(3799),
    [anon_sym___thread] = ACTIONS(3799),
    [anon_sym_const] = ACTIONS(3799),
    [anon_sym_constexpr] = ACTIONS(3799),
    [anon_sym_volatile] = ACTIONS(3799),
    [anon_sym_restrict] = ACTIONS(3799),
    [anon_sym___restrict__] = ACTIONS(3799),
    [anon_sym__Atomic] = ACTIONS(3799),
    [anon_sym__Noreturn] = ACTIONS(3799),
    [anon_sym_noreturn] = ACTIONS(3799),
    [anon_sym_mutable] = ACTIONS(3799),
    [anon_sym_constinit] = ACTIONS(3799),
    [anon_sym_consteval] = ACTIONS(3799),
    [anon_sym_alignas] = ACTIONS(3799),
    [anon_sym__Alignas] = ACTIONS(3799),
    [anon_sym_DOT] = ACTIONS(3799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3799),
    [anon_sym_let] = ACTIONS(3799),
    [anon_sym_This] = ACTIONS(3799),
    [anon_sym_decltype] = ACTIONS(3799),
    [sym_virtual] = ACTIONS(3799),
    [anon_sym_template] = ACTIONS(3799),
    [anon_sym_GT2] = ACTIONS(3801),
    [anon_sym_operator] = ACTIONS(3799),
    [anon_sym_precise] = ACTIONS(3799),
    [anon_sym_shared] = ACTIONS(3799),
    [anon_sym_groupshared] = ACTIONS(3799),
    [anon_sym_uniform] = ACTIONS(3799),
    [anon_sym_row_major] = ACTIONS(3799),
    [anon_sym_column_major] = ACTIONS(3799),
    [anon_sym_globallycoherent] = ACTIONS(3799),
    [anon_sym_centroid] = ACTIONS(3799),
    [anon_sym_noperspective] = ACTIONS(3799),
    [anon_sym_nointerpolation] = ACTIONS(3799),
    [anon_sym_sample] = ACTIONS(3799),
    [anon_sym_linear] = ACTIONS(3799),
    [anon_sym_snorm] = ACTIONS(3799),
    [anon_sym_unorm] = ACTIONS(3799),
    [anon_sym_point] = ACTIONS(3799),
    [anon_sym_line] = ACTIONS(3799),
    [anon_sym_triangleadj] = ACTIONS(3799),
    [anon_sym_lineadj] = ACTIONS(3799),
    [anon_sym_triangle] = ACTIONS(3799),
  },
  [2715] = {
    [sym_identifier] = ACTIONS(2742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2740),
    [anon_sym_COMMA] = ACTIONS(2740),
    [anon_sym_RPAREN] = ACTIONS(2740),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_TILDE] = ACTIONS(2740),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_COLON] = ACTIONS(2742),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym___extension__] = ACTIONS(2742),
    [anon_sym_in] = ACTIONS(2742),
    [anon_sym_out] = ACTIONS(2742),
    [anon_sym_inout] = ACTIONS(2742),
    [anon_sym_extern] = ACTIONS(2742),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2740),
    [anon_sym___declspec] = ACTIONS(2742),
    [anon_sym___based] = ACTIONS(2742),
    [anon_sym___cdecl] = ACTIONS(2742),
    [anon_sym___clrcall] = ACTIONS(2742),
    [anon_sym___stdcall] = ACTIONS(2742),
    [anon_sym___fastcall] = ACTIONS(2742),
    [anon_sym___thiscall] = ACTIONS(2742),
    [anon_sym___vectorcall] = ACTIONS(2742),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2742),
    [anon_sym_EQ] = ACTIONS(2740),
    [anon_sym_register] = ACTIONS(2742),
    [anon_sym_inline] = ACTIONS(2742),
    [anon_sym___inline] = ACTIONS(2742),
    [anon_sym___inline__] = ACTIONS(2742),
    [anon_sym___forceinline] = ACTIONS(2742),
    [anon_sym_thread_local] = ACTIONS(2742),
    [anon_sym___thread] = ACTIONS(2742),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_constexpr] = ACTIONS(2742),
    [anon_sym_volatile] = ACTIONS(2742),
    [anon_sym_restrict] = ACTIONS(2742),
    [anon_sym___restrict__] = ACTIONS(2742),
    [anon_sym__Atomic] = ACTIONS(2742),
    [anon_sym__Noreturn] = ACTIONS(2742),
    [anon_sym_noreturn] = ACTIONS(2742),
    [anon_sym_mutable] = ACTIONS(2742),
    [anon_sym_constinit] = ACTIONS(2742),
    [anon_sym_consteval] = ACTIONS(2742),
    [anon_sym_alignas] = ACTIONS(2742),
    [anon_sym__Alignas] = ACTIONS(2742),
    [anon_sym_DOT] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
    [anon_sym_decltype] = ACTIONS(2742),
    [sym_virtual] = ACTIONS(2742),
    [anon_sym_template] = ACTIONS(2742),
    [anon_sym_GT2] = ACTIONS(2740),
    [anon_sym_operator] = ACTIONS(2742),
    [anon_sym_precise] = ACTIONS(2742),
    [anon_sym_shared] = ACTIONS(2742),
    [anon_sym_groupshared] = ACTIONS(2742),
    [anon_sym_uniform] = ACTIONS(2742),
    [anon_sym_row_major] = ACTIONS(2742),
    [anon_sym_column_major] = ACTIONS(2742),
    [anon_sym_globallycoherent] = ACTIONS(2742),
    [anon_sym_centroid] = ACTIONS(2742),
    [anon_sym_noperspective] = ACTIONS(2742),
    [anon_sym_nointerpolation] = ACTIONS(2742),
    [anon_sym_sample] = ACTIONS(2742),
    [anon_sym_linear] = ACTIONS(2742),
    [anon_sym_snorm] = ACTIONS(2742),
    [anon_sym_unorm] = ACTIONS(2742),
    [anon_sym_point] = ACTIONS(2742),
    [anon_sym_line] = ACTIONS(2742),
    [anon_sym_triangleadj] = ACTIONS(2742),
    [anon_sym_lineadj] = ACTIONS(2742),
    [anon_sym_triangle] = ACTIONS(2742),
  },
  [2716] = {
    [sym_identifier] = ACTIONS(3388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3386),
    [anon_sym_COMMA] = ACTIONS(3386),
    [anon_sym_RPAREN] = ACTIONS(3386),
    [anon_sym_LPAREN2] = ACTIONS(3386),
    [anon_sym_TILDE] = ACTIONS(3386),
    [anon_sym_STAR] = ACTIONS(3386),
    [anon_sym_AMP_AMP] = ACTIONS(3386),
    [anon_sym_AMP] = ACTIONS(3388),
    [anon_sym_COLON] = ACTIONS(3388),
    [anon_sym_SEMI] = ACTIONS(3386),
    [anon_sym___extension__] = ACTIONS(3388),
    [anon_sym_in] = ACTIONS(3388),
    [anon_sym_out] = ACTIONS(3388),
    [anon_sym_inout] = ACTIONS(3388),
    [anon_sym_extern] = ACTIONS(3388),
    [anon_sym___attribute__] = ACTIONS(3388),
    [anon_sym_COLON_COLON] = ACTIONS(3386),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3386),
    [anon_sym___declspec] = ACTIONS(3388),
    [anon_sym___based] = ACTIONS(3388),
    [anon_sym___cdecl] = ACTIONS(3388),
    [anon_sym___clrcall] = ACTIONS(3388),
    [anon_sym___stdcall] = ACTIONS(3388),
    [anon_sym___fastcall] = ACTIONS(3388),
    [anon_sym___thiscall] = ACTIONS(3388),
    [anon_sym___vectorcall] = ACTIONS(3388),
    [anon_sym_LBRACK] = ACTIONS(3388),
    [anon_sym_static] = ACTIONS(3388),
    [anon_sym_EQ] = ACTIONS(3386),
    [anon_sym_register] = ACTIONS(3388),
    [anon_sym_inline] = ACTIONS(3388),
    [anon_sym___inline] = ACTIONS(3388),
    [anon_sym___inline__] = ACTIONS(3388),
    [anon_sym___forceinline] = ACTIONS(3388),
    [anon_sym_thread_local] = ACTIONS(3388),
    [anon_sym___thread] = ACTIONS(3388),
    [anon_sym_const] = ACTIONS(3388),
    [anon_sym_constexpr] = ACTIONS(3388),
    [anon_sym_volatile] = ACTIONS(3388),
    [anon_sym_restrict] = ACTIONS(3388),
    [anon_sym___restrict__] = ACTIONS(3388),
    [anon_sym__Atomic] = ACTIONS(3388),
    [anon_sym__Noreturn] = ACTIONS(3388),
    [anon_sym_noreturn] = ACTIONS(3388),
    [anon_sym_mutable] = ACTIONS(3388),
    [anon_sym_constinit] = ACTIONS(3388),
    [anon_sym_consteval] = ACTIONS(3388),
    [anon_sym_alignas] = ACTIONS(3388),
    [anon_sym__Alignas] = ACTIONS(3388),
    [anon_sym_DOT] = ACTIONS(3388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3388),
    [anon_sym_let] = ACTIONS(3388),
    [anon_sym_This] = ACTIONS(3388),
    [anon_sym_decltype] = ACTIONS(3388),
    [sym_virtual] = ACTIONS(3388),
    [anon_sym_template] = ACTIONS(3388),
    [anon_sym_GT2] = ACTIONS(3386),
    [anon_sym_operator] = ACTIONS(3388),
    [anon_sym_precise] = ACTIONS(3388),
    [anon_sym_shared] = ACTIONS(3388),
    [anon_sym_groupshared] = ACTIONS(3388),
    [anon_sym_uniform] = ACTIONS(3388),
    [anon_sym_row_major] = ACTIONS(3388),
    [anon_sym_column_major] = ACTIONS(3388),
    [anon_sym_globallycoherent] = ACTIONS(3388),
    [anon_sym_centroid] = ACTIONS(3388),
    [anon_sym_noperspective] = ACTIONS(3388),
    [anon_sym_nointerpolation] = ACTIONS(3388),
    [anon_sym_sample] = ACTIONS(3388),
    [anon_sym_linear] = ACTIONS(3388),
    [anon_sym_snorm] = ACTIONS(3388),
    [anon_sym_unorm] = ACTIONS(3388),
    [anon_sym_point] = ACTIONS(3388),
    [anon_sym_line] = ACTIONS(3388),
    [anon_sym_triangleadj] = ACTIONS(3388),
    [anon_sym_lineadj] = ACTIONS(3388),
    [anon_sym_triangle] = ACTIONS(3388),
  },
  [2717] = {
    [sym_identifier] = ACTIONS(3082),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3080),
    [anon_sym_COMMA] = ACTIONS(3080),
    [anon_sym_RPAREN] = ACTIONS(3080),
    [anon_sym_LPAREN2] = ACTIONS(3080),
    [anon_sym_TILDE] = ACTIONS(3080),
    [anon_sym_STAR] = ACTIONS(3080),
    [anon_sym_AMP_AMP] = ACTIONS(3080),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym_COLON] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_in] = ACTIONS(3082),
    [anon_sym_out] = ACTIONS(3082),
    [anon_sym_inout] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3080),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3080),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym___cdecl] = ACTIONS(3082),
    [anon_sym___clrcall] = ACTIONS(3082),
    [anon_sym___stdcall] = ACTIONS(3082),
    [anon_sym___fastcall] = ACTIONS(3082),
    [anon_sym___thiscall] = ACTIONS(3082),
    [anon_sym___vectorcall] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_EQ] = ACTIONS(3080),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym__Alignas] = ACTIONS(3082),
    [anon_sym_DOT] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3082),
    [anon_sym_let] = ACTIONS(3082),
    [anon_sym_This] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [sym_virtual] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_GT2] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_precise] = ACTIONS(3082),
    [anon_sym_shared] = ACTIONS(3082),
    [anon_sym_groupshared] = ACTIONS(3082),
    [anon_sym_uniform] = ACTIONS(3082),
    [anon_sym_row_major] = ACTIONS(3082),
    [anon_sym_column_major] = ACTIONS(3082),
    [anon_sym_globallycoherent] = ACTIONS(3082),
    [anon_sym_centroid] = ACTIONS(3082),
    [anon_sym_noperspective] = ACTIONS(3082),
    [anon_sym_nointerpolation] = ACTIONS(3082),
    [anon_sym_sample] = ACTIONS(3082),
    [anon_sym_linear] = ACTIONS(3082),
    [anon_sym_snorm] = ACTIONS(3082),
    [anon_sym_unorm] = ACTIONS(3082),
    [anon_sym_point] = ACTIONS(3082),
    [anon_sym_line] = ACTIONS(3082),
    [anon_sym_triangleadj] = ACTIONS(3082),
    [anon_sym_lineadj] = ACTIONS(3082),
    [anon_sym_triangle] = ACTIONS(3082),
  },
  [2718] = {
    [sym_identifier] = ACTIONS(2742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2740),
    [anon_sym_COMMA] = ACTIONS(2740),
    [anon_sym_RPAREN] = ACTIONS(2740),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_TILDE] = ACTIONS(2740),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_COLON] = ACTIONS(2742),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym___extension__] = ACTIONS(2742),
    [anon_sym_in] = ACTIONS(2742),
    [anon_sym_out] = ACTIONS(2742),
    [anon_sym_inout] = ACTIONS(2742),
    [anon_sym_extern] = ACTIONS(2742),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym_COLON_COLON] = ACTIONS(2740),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2740),
    [anon_sym___declspec] = ACTIONS(2742),
    [anon_sym___based] = ACTIONS(2742),
    [anon_sym___cdecl] = ACTIONS(2742),
    [anon_sym___clrcall] = ACTIONS(2742),
    [anon_sym___stdcall] = ACTIONS(2742),
    [anon_sym___fastcall] = ACTIONS(2742),
    [anon_sym___thiscall] = ACTIONS(2742),
    [anon_sym___vectorcall] = ACTIONS(2742),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2742),
    [anon_sym_EQ] = ACTIONS(2740),
    [anon_sym_register] = ACTIONS(2742),
    [anon_sym_inline] = ACTIONS(2742),
    [anon_sym___inline] = ACTIONS(2742),
    [anon_sym___inline__] = ACTIONS(2742),
    [anon_sym___forceinline] = ACTIONS(2742),
    [anon_sym_thread_local] = ACTIONS(2742),
    [anon_sym___thread] = ACTIONS(2742),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_constexpr] = ACTIONS(2742),
    [anon_sym_volatile] = ACTIONS(2742),
    [anon_sym_restrict] = ACTIONS(2742),
    [anon_sym___restrict__] = ACTIONS(2742),
    [anon_sym__Atomic] = ACTIONS(2742),
    [anon_sym__Noreturn] = ACTIONS(2742),
    [anon_sym_noreturn] = ACTIONS(2742),
    [anon_sym_mutable] = ACTIONS(2742),
    [anon_sym_constinit] = ACTIONS(2742),
    [anon_sym_consteval] = ACTIONS(2742),
    [anon_sym_alignas] = ACTIONS(2742),
    [anon_sym__Alignas] = ACTIONS(2742),
    [anon_sym_DOT] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
    [anon_sym_decltype] = ACTIONS(2742),
    [sym_virtual] = ACTIONS(2742),
    [anon_sym_template] = ACTIONS(2742),
    [anon_sym_GT2] = ACTIONS(2740),
    [anon_sym_operator] = ACTIONS(2742),
    [anon_sym_precise] = ACTIONS(2742),
    [anon_sym_shared] = ACTIONS(2742),
    [anon_sym_groupshared] = ACTIONS(2742),
    [anon_sym_uniform] = ACTIONS(2742),
    [anon_sym_row_major] = ACTIONS(2742),
    [anon_sym_column_major] = ACTIONS(2742),
    [anon_sym_globallycoherent] = ACTIONS(2742),
    [anon_sym_centroid] = ACTIONS(2742),
    [anon_sym_noperspective] = ACTIONS(2742),
    [anon_sym_nointerpolation] = ACTIONS(2742),
    [anon_sym_sample] = ACTIONS(2742),
    [anon_sym_linear] = ACTIONS(2742),
    [anon_sym_snorm] = ACTIONS(2742),
    [anon_sym_unorm] = ACTIONS(2742),
    [anon_sym_point] = ACTIONS(2742),
    [anon_sym_line] = ACTIONS(2742),
    [anon_sym_triangleadj] = ACTIONS(2742),
    [anon_sym_lineadj] = ACTIONS(2742),
    [anon_sym_triangle] = ACTIONS(2742),
  },
  [2719] = {
    [sym_identifier] = ACTIONS(6132),
    [anon_sym_LPAREN2] = ACTIONS(6134),
    [anon_sym_TILDE] = ACTIONS(6134),
    [anon_sym_STAR] = ACTIONS(6134),
    [anon_sym_AMP_AMP] = ACTIONS(6134),
    [anon_sym_AMP] = ACTIONS(6132),
    [anon_sym___extension__] = ACTIONS(6132),
    [anon_sym_typedef] = ACTIONS(6348),
    [anon_sym_in] = ACTIONS(6132),
    [anon_sym_out] = ACTIONS(6132),
    [anon_sym_inout] = ACTIONS(6132),
    [anon_sym_extern] = ACTIONS(6132),
    [anon_sym___attribute__] = ACTIONS(6132),
    [anon_sym_COLON_COLON] = ACTIONS(6134),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6134),
    [anon_sym___declspec] = ACTIONS(6132),
    [anon_sym___based] = ACTIONS(6132),
    [anon_sym_signed] = ACTIONS(6132),
    [anon_sym_unsigned] = ACTIONS(6132),
    [anon_sym_long] = ACTIONS(6132),
    [anon_sym_short] = ACTIONS(6132),
    [anon_sym_LBRACK] = ACTIONS(6132),
    [anon_sym_static] = ACTIONS(6132),
    [anon_sym_register] = ACTIONS(6132),
    [anon_sym_inline] = ACTIONS(6132),
    [anon_sym___inline] = ACTIONS(6132),
    [anon_sym___inline__] = ACTIONS(6132),
    [anon_sym___forceinline] = ACTIONS(6132),
    [anon_sym_thread_local] = ACTIONS(6132),
    [anon_sym___thread] = ACTIONS(6132),
    [anon_sym_const] = ACTIONS(6132),
    [anon_sym_constexpr] = ACTIONS(6132),
    [anon_sym_volatile] = ACTIONS(6132),
    [anon_sym_restrict] = ACTIONS(6132),
    [anon_sym___restrict__] = ACTIONS(6132),
    [anon_sym__Atomic] = ACTIONS(6132),
    [anon_sym__Noreturn] = ACTIONS(6132),
    [anon_sym_noreturn] = ACTIONS(6132),
    [anon_sym_mutable] = ACTIONS(6132),
    [anon_sym_constinit] = ACTIONS(6132),
    [anon_sym_consteval] = ACTIONS(6132),
    [anon_sym_alignas] = ACTIONS(6132),
    [anon_sym__Alignas] = ACTIONS(6132),
    [sym_primitive_type] = ACTIONS(6132),
    [anon_sym_enum] = ACTIONS(6132),
    [anon_sym_class] = ACTIONS(6132),
    [anon_sym_struct] = ACTIONS(6132),
    [anon_sym_union] = ACTIONS(6132),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6132),
    [anon_sym_let] = ACTIONS(6132),
    [anon_sym_This] = ACTIONS(6132),
    [anon_sym_decltype] = ACTIONS(6132),
    [sym_virtual] = ACTIONS(6132),
    [anon_sym_explicit] = ACTIONS(6132),
    [anon_sym_typename] = ACTIONS(6132),
    [anon_sym_template] = ACTIONS(6132),
    [anon_sym_operator] = ACTIONS(6132),
    [anon_sym_precise] = ACTIONS(6132),
    [anon_sym_shared] = ACTIONS(6132),
    [anon_sym_groupshared] = ACTIONS(6132),
    [anon_sym_uniform] = ACTIONS(6132),
    [anon_sym_row_major] = ACTIONS(6132),
    [anon_sym_column_major] = ACTIONS(6132),
    [anon_sym_globallycoherent] = ACTIONS(6132),
    [anon_sym_centroid] = ACTIONS(6132),
    [anon_sym_noperspective] = ACTIONS(6132),
    [anon_sym_nointerpolation] = ACTIONS(6132),
    [anon_sym_sample] = ACTIONS(6132),
    [anon_sym_linear] = ACTIONS(6132),
    [anon_sym_snorm] = ACTIONS(6132),
    [anon_sym_unorm] = ACTIONS(6132),
    [anon_sym_point] = ACTIONS(6132),
    [anon_sym_line] = ACTIONS(6132),
    [anon_sym_triangleadj] = ACTIONS(6132),
    [anon_sym_lineadj] = ACTIONS(6132),
    [anon_sym_triangle] = ACTIONS(6132),
    [anon_sym_interface] = ACTIONS(6132),
    [anon_sym_extension] = ACTIONS(6132),
  },
  [2720] = {
    [sym_identifier] = ACTIONS(2910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2908),
    [anon_sym_COMMA] = ACTIONS(2908),
    [anon_sym_RPAREN] = ACTIONS(2908),
    [anon_sym_LPAREN2] = ACTIONS(2908),
    [anon_sym_TILDE] = ACTIONS(2908),
    [anon_sym_STAR] = ACTIONS(2908),
    [anon_sym_AMP_AMP] = ACTIONS(2908),
    [anon_sym_AMP] = ACTIONS(2910),
    [anon_sym_COLON] = ACTIONS(2910),
    [anon_sym_SEMI] = ACTIONS(2908),
    [anon_sym___extension__] = ACTIONS(2910),
    [anon_sym_in] = ACTIONS(2910),
    [anon_sym_out] = ACTIONS(2910),
    [anon_sym_inout] = ACTIONS(2910),
    [anon_sym_extern] = ACTIONS(2910),
    [anon_sym___attribute__] = ACTIONS(2910),
    [anon_sym_COLON_COLON] = ACTIONS(2908),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2908),
    [anon_sym___declspec] = ACTIONS(2910),
    [anon_sym___based] = ACTIONS(2910),
    [anon_sym___cdecl] = ACTIONS(2910),
    [anon_sym___clrcall] = ACTIONS(2910),
    [anon_sym___stdcall] = ACTIONS(2910),
    [anon_sym___fastcall] = ACTIONS(2910),
    [anon_sym___thiscall] = ACTIONS(2910),
    [anon_sym___vectorcall] = ACTIONS(2910),
    [anon_sym_LBRACK] = ACTIONS(2910),
    [anon_sym_static] = ACTIONS(2910),
    [anon_sym_EQ] = ACTIONS(2908),
    [anon_sym_register] = ACTIONS(2910),
    [anon_sym_inline] = ACTIONS(2910),
    [anon_sym___inline] = ACTIONS(2910),
    [anon_sym___inline__] = ACTIONS(2910),
    [anon_sym___forceinline] = ACTIONS(2910),
    [anon_sym_thread_local] = ACTIONS(2910),
    [anon_sym___thread] = ACTIONS(2910),
    [anon_sym_const] = ACTIONS(2910),
    [anon_sym_constexpr] = ACTIONS(2910),
    [anon_sym_volatile] = ACTIONS(2910),
    [anon_sym_restrict] = ACTIONS(2910),
    [anon_sym___restrict__] = ACTIONS(2910),
    [anon_sym__Atomic] = ACTIONS(2910),
    [anon_sym__Noreturn] = ACTIONS(2910),
    [anon_sym_noreturn] = ACTIONS(2910),
    [anon_sym_mutable] = ACTIONS(2910),
    [anon_sym_constinit] = ACTIONS(2910),
    [anon_sym_consteval] = ACTIONS(2910),
    [anon_sym_alignas] = ACTIONS(2910),
    [anon_sym__Alignas] = ACTIONS(2910),
    [anon_sym_DOT] = ACTIONS(2910),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2910),
    [anon_sym_let] = ACTIONS(2910),
    [anon_sym_This] = ACTIONS(2910),
    [anon_sym_decltype] = ACTIONS(2910),
    [sym_virtual] = ACTIONS(2910),
    [anon_sym_template] = ACTIONS(2910),
    [anon_sym_GT2] = ACTIONS(2908),
    [anon_sym_operator] = ACTIONS(2910),
    [anon_sym_precise] = ACTIONS(2910),
    [anon_sym_shared] = ACTIONS(2910),
    [anon_sym_groupshared] = ACTIONS(2910),
    [anon_sym_uniform] = ACTIONS(2910),
    [anon_sym_row_major] = ACTIONS(2910),
    [anon_sym_column_major] = ACTIONS(2910),
    [anon_sym_globallycoherent] = ACTIONS(2910),
    [anon_sym_centroid] = ACTIONS(2910),
    [anon_sym_noperspective] = ACTIONS(2910),
    [anon_sym_nointerpolation] = ACTIONS(2910),
    [anon_sym_sample] = ACTIONS(2910),
    [anon_sym_linear] = ACTIONS(2910),
    [anon_sym_snorm] = ACTIONS(2910),
    [anon_sym_unorm] = ACTIONS(2910),
    [anon_sym_point] = ACTIONS(2910),
    [anon_sym_line] = ACTIONS(2910),
    [anon_sym_triangleadj] = ACTIONS(2910),
    [anon_sym_lineadj] = ACTIONS(2910),
    [anon_sym_triangle] = ACTIONS(2910),
  },
  [2721] = {
    [sym_identifier] = ACTIONS(3054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3052),
    [anon_sym_COMMA] = ACTIONS(3052),
    [anon_sym_RPAREN] = ACTIONS(3052),
    [anon_sym_LPAREN2] = ACTIONS(3052),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3054),
    [anon_sym_COLON] = ACTIONS(3054),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym___extension__] = ACTIONS(3054),
    [anon_sym_in] = ACTIONS(3054),
    [anon_sym_out] = ACTIONS(3054),
    [anon_sym_inout] = ACTIONS(3054),
    [anon_sym_extern] = ACTIONS(3054),
    [anon_sym___attribute__] = ACTIONS(3054),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3052),
    [anon_sym___declspec] = ACTIONS(3054),
    [anon_sym___based] = ACTIONS(3054),
    [anon_sym___cdecl] = ACTIONS(3054),
    [anon_sym___clrcall] = ACTIONS(3054),
    [anon_sym___stdcall] = ACTIONS(3054),
    [anon_sym___fastcall] = ACTIONS(3054),
    [anon_sym___thiscall] = ACTIONS(3054),
    [anon_sym___vectorcall] = ACTIONS(3054),
    [anon_sym_LBRACK] = ACTIONS(3054),
    [anon_sym_static] = ACTIONS(3054),
    [anon_sym_EQ] = ACTIONS(3052),
    [anon_sym_register] = ACTIONS(3054),
    [anon_sym_inline] = ACTIONS(3054),
    [anon_sym___inline] = ACTIONS(3054),
    [anon_sym___inline__] = ACTIONS(3054),
    [anon_sym___forceinline] = ACTIONS(3054),
    [anon_sym_thread_local] = ACTIONS(3054),
    [anon_sym___thread] = ACTIONS(3054),
    [anon_sym_const] = ACTIONS(3054),
    [anon_sym_constexpr] = ACTIONS(3054),
    [anon_sym_volatile] = ACTIONS(3054),
    [anon_sym_restrict] = ACTIONS(3054),
    [anon_sym___restrict__] = ACTIONS(3054),
    [anon_sym__Atomic] = ACTIONS(3054),
    [anon_sym__Noreturn] = ACTIONS(3054),
    [anon_sym_noreturn] = ACTIONS(3054),
    [anon_sym_mutable] = ACTIONS(3054),
    [anon_sym_constinit] = ACTIONS(3054),
    [anon_sym_consteval] = ACTIONS(3054),
    [anon_sym_alignas] = ACTIONS(3054),
    [anon_sym__Alignas] = ACTIONS(3054),
    [anon_sym_DOT] = ACTIONS(3054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3054),
    [anon_sym_let] = ACTIONS(3054),
    [anon_sym_This] = ACTIONS(3054),
    [anon_sym_decltype] = ACTIONS(3054),
    [sym_virtual] = ACTIONS(3054),
    [anon_sym_template] = ACTIONS(3054),
    [anon_sym_GT2] = ACTIONS(3052),
    [anon_sym_operator] = ACTIONS(3054),
    [anon_sym_precise] = ACTIONS(3054),
    [anon_sym_shared] = ACTIONS(3054),
    [anon_sym_groupshared] = ACTIONS(3054),
    [anon_sym_uniform] = ACTIONS(3054),
    [anon_sym_row_major] = ACTIONS(3054),
    [anon_sym_column_major] = ACTIONS(3054),
    [anon_sym_globallycoherent] = ACTIONS(3054),
    [anon_sym_centroid] = ACTIONS(3054),
    [anon_sym_noperspective] = ACTIONS(3054),
    [anon_sym_nointerpolation] = ACTIONS(3054),
    [anon_sym_sample] = ACTIONS(3054),
    [anon_sym_linear] = ACTIONS(3054),
    [anon_sym_snorm] = ACTIONS(3054),
    [anon_sym_unorm] = ACTIONS(3054),
    [anon_sym_point] = ACTIONS(3054),
    [anon_sym_line] = ACTIONS(3054),
    [anon_sym_triangleadj] = ACTIONS(3054),
    [anon_sym_lineadj] = ACTIONS(3054),
    [anon_sym_triangle] = ACTIONS(3054),
  },
  [2722] = {
    [sym_identifier] = ACTIONS(6253),
    [anon_sym_LPAREN2] = ACTIONS(6255),
    [anon_sym_TILDE] = ACTIONS(6255),
    [anon_sym_STAR] = ACTIONS(6255),
    [anon_sym_AMP_AMP] = ACTIONS(6255),
    [anon_sym_AMP] = ACTIONS(6253),
    [anon_sym___extension__] = ACTIONS(6253),
    [anon_sym_in] = ACTIONS(6253),
    [anon_sym_out] = ACTIONS(6253),
    [anon_sym_inout] = ACTIONS(6253),
    [anon_sym_extern] = ACTIONS(6253),
    [anon_sym___attribute__] = ACTIONS(6253),
    [anon_sym_COLON_COLON] = ACTIONS(6255),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6255),
    [anon_sym___declspec] = ACTIONS(6253),
    [anon_sym___based] = ACTIONS(6253),
    [anon_sym_signed] = ACTIONS(6253),
    [anon_sym_unsigned] = ACTIONS(6253),
    [anon_sym_long] = ACTIONS(6253),
    [anon_sym_short] = ACTIONS(6253),
    [anon_sym_LBRACK] = ACTIONS(6253),
    [anon_sym_static] = ACTIONS(6253),
    [anon_sym_register] = ACTIONS(6253),
    [anon_sym_inline] = ACTIONS(6253),
    [anon_sym___inline] = ACTIONS(6253),
    [anon_sym___inline__] = ACTIONS(6253),
    [anon_sym___forceinline] = ACTIONS(6253),
    [anon_sym_thread_local] = ACTIONS(6253),
    [anon_sym___thread] = ACTIONS(6253),
    [anon_sym_const] = ACTIONS(6253),
    [anon_sym_constexpr] = ACTIONS(6253),
    [anon_sym_volatile] = ACTIONS(6253),
    [anon_sym_restrict] = ACTIONS(6253),
    [anon_sym___restrict__] = ACTIONS(6253),
    [anon_sym__Atomic] = ACTIONS(6253),
    [anon_sym__Noreturn] = ACTIONS(6253),
    [anon_sym_noreturn] = ACTIONS(6253),
    [anon_sym_mutable] = ACTIONS(6253),
    [anon_sym_constinit] = ACTIONS(6253),
    [anon_sym_consteval] = ACTIONS(6253),
    [anon_sym_alignas] = ACTIONS(6253),
    [anon_sym__Alignas] = ACTIONS(6253),
    [sym_primitive_type] = ACTIONS(6253),
    [anon_sym_enum] = ACTIONS(6253),
    [anon_sym_class] = ACTIONS(6253),
    [anon_sym_struct] = ACTIONS(6253),
    [anon_sym_union] = ACTIONS(6253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6253),
    [anon_sym_let] = ACTIONS(6253),
    [anon_sym_This] = ACTIONS(6253),
    [anon_sym_decltype] = ACTIONS(6253),
    [sym_virtual] = ACTIONS(6253),
    [anon_sym_explicit] = ACTIONS(6253),
    [anon_sym_typename] = ACTIONS(6253),
    [anon_sym_template] = ACTIONS(6253),
    [anon_sym_operator] = ACTIONS(6253),
    [anon_sym_namespace] = ACTIONS(6350),
    [anon_sym_precise] = ACTIONS(6253),
    [anon_sym_shared] = ACTIONS(6253),
    [anon_sym_groupshared] = ACTIONS(6253),
    [anon_sym_uniform] = ACTIONS(6253),
    [anon_sym_row_major] = ACTIONS(6253),
    [anon_sym_column_major] = ACTIONS(6253),
    [anon_sym_globallycoherent] = ACTIONS(6253),
    [anon_sym_centroid] = ACTIONS(6253),
    [anon_sym_noperspective] = ACTIONS(6253),
    [anon_sym_nointerpolation] = ACTIONS(6253),
    [anon_sym_sample] = ACTIONS(6253),
    [anon_sym_linear] = ACTIONS(6253),
    [anon_sym_snorm] = ACTIONS(6253),
    [anon_sym_unorm] = ACTIONS(6253),
    [anon_sym_point] = ACTIONS(6253),
    [anon_sym_line] = ACTIONS(6253),
    [anon_sym_triangleadj] = ACTIONS(6253),
    [anon_sym_lineadj] = ACTIONS(6253),
    [anon_sym_triangle] = ACTIONS(6253),
    [anon_sym_interface] = ACTIONS(6253),
    [anon_sym_extension] = ACTIONS(6253),
  },
  [2723] = {
    [sym_identifier] = ACTIONS(2826),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2824),
    [anon_sym_COMMA] = ACTIONS(2824),
    [anon_sym_RPAREN] = ACTIONS(2824),
    [anon_sym_LPAREN2] = ACTIONS(2824),
    [anon_sym_TILDE] = ACTIONS(2824),
    [anon_sym_STAR] = ACTIONS(2824),
    [anon_sym_AMP_AMP] = ACTIONS(2824),
    [anon_sym_AMP] = ACTIONS(2826),
    [anon_sym_COLON] = ACTIONS(2826),
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym___extension__] = ACTIONS(2826),
    [anon_sym_in] = ACTIONS(2826),
    [anon_sym_out] = ACTIONS(2826),
    [anon_sym_inout] = ACTIONS(2826),
    [anon_sym_extern] = ACTIONS(2826),
    [anon_sym___attribute__] = ACTIONS(2826),
    [anon_sym_COLON_COLON] = ACTIONS(2824),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2824),
    [anon_sym___declspec] = ACTIONS(2826),
    [anon_sym___based] = ACTIONS(2826),
    [anon_sym___cdecl] = ACTIONS(2826),
    [anon_sym___clrcall] = ACTIONS(2826),
    [anon_sym___stdcall] = ACTIONS(2826),
    [anon_sym___fastcall] = ACTIONS(2826),
    [anon_sym___thiscall] = ACTIONS(2826),
    [anon_sym___vectorcall] = ACTIONS(2826),
    [anon_sym_LBRACK] = ACTIONS(2826),
    [anon_sym_static] = ACTIONS(2826),
    [anon_sym_EQ] = ACTIONS(2824),
    [anon_sym_register] = ACTIONS(2826),
    [anon_sym_inline] = ACTIONS(2826),
    [anon_sym___inline] = ACTIONS(2826),
    [anon_sym___inline__] = ACTIONS(2826),
    [anon_sym___forceinline] = ACTIONS(2826),
    [anon_sym_thread_local] = ACTIONS(2826),
    [anon_sym___thread] = ACTIONS(2826),
    [anon_sym_const] = ACTIONS(2826),
    [anon_sym_constexpr] = ACTIONS(2826),
    [anon_sym_volatile] = ACTIONS(2826),
    [anon_sym_restrict] = ACTIONS(2826),
    [anon_sym___restrict__] = ACTIONS(2826),
    [anon_sym__Atomic] = ACTIONS(2826),
    [anon_sym__Noreturn] = ACTIONS(2826),
    [anon_sym_noreturn] = ACTIONS(2826),
    [anon_sym_mutable] = ACTIONS(2826),
    [anon_sym_constinit] = ACTIONS(2826),
    [anon_sym_consteval] = ACTIONS(2826),
    [anon_sym_alignas] = ACTIONS(2826),
    [anon_sym__Alignas] = ACTIONS(2826),
    [anon_sym_DOT] = ACTIONS(2826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2826),
    [anon_sym_let] = ACTIONS(2826),
    [anon_sym_This] = ACTIONS(2826),
    [anon_sym_decltype] = ACTIONS(2826),
    [sym_virtual] = ACTIONS(2826),
    [anon_sym_template] = ACTIONS(2826),
    [anon_sym_GT2] = ACTIONS(2824),
    [anon_sym_operator] = ACTIONS(2826),
    [anon_sym_precise] = ACTIONS(2826),
    [anon_sym_shared] = ACTIONS(2826),
    [anon_sym_groupshared] = ACTIONS(2826),
    [anon_sym_uniform] = ACTIONS(2826),
    [anon_sym_row_major] = ACTIONS(2826),
    [anon_sym_column_major] = ACTIONS(2826),
    [anon_sym_globallycoherent] = ACTIONS(2826),
    [anon_sym_centroid] = ACTIONS(2826),
    [anon_sym_noperspective] = ACTIONS(2826),
    [anon_sym_nointerpolation] = ACTIONS(2826),
    [anon_sym_sample] = ACTIONS(2826),
    [anon_sym_linear] = ACTIONS(2826),
    [anon_sym_snorm] = ACTIONS(2826),
    [anon_sym_unorm] = ACTIONS(2826),
    [anon_sym_point] = ACTIONS(2826),
    [anon_sym_line] = ACTIONS(2826),
    [anon_sym_triangleadj] = ACTIONS(2826),
    [anon_sym_lineadj] = ACTIONS(2826),
    [anon_sym_triangle] = ACTIONS(2826),
  },
  [2724] = {
    [sym_identifier] = ACTIONS(6132),
    [anon_sym_LPAREN2] = ACTIONS(6134),
    [anon_sym_TILDE] = ACTIONS(6134),
    [anon_sym_STAR] = ACTIONS(6134),
    [anon_sym_AMP_AMP] = ACTIONS(6134),
    [anon_sym_AMP] = ACTIONS(6132),
    [anon_sym___extension__] = ACTIONS(6132),
    [anon_sym_typedef] = ACTIONS(6352),
    [anon_sym_in] = ACTIONS(6132),
    [anon_sym_out] = ACTIONS(6132),
    [anon_sym_inout] = ACTIONS(6132),
    [anon_sym_extern] = ACTIONS(6132),
    [anon_sym___attribute__] = ACTIONS(6132),
    [anon_sym_COLON_COLON] = ACTIONS(6134),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6134),
    [anon_sym___declspec] = ACTIONS(6132),
    [anon_sym___based] = ACTIONS(6132),
    [anon_sym_signed] = ACTIONS(6132),
    [anon_sym_unsigned] = ACTIONS(6132),
    [anon_sym_long] = ACTIONS(6132),
    [anon_sym_short] = ACTIONS(6132),
    [anon_sym_LBRACK] = ACTIONS(6132),
    [anon_sym_static] = ACTIONS(6132),
    [anon_sym_register] = ACTIONS(6132),
    [anon_sym_inline] = ACTIONS(6132),
    [anon_sym___inline] = ACTIONS(6132),
    [anon_sym___inline__] = ACTIONS(6132),
    [anon_sym___forceinline] = ACTIONS(6132),
    [anon_sym_thread_local] = ACTIONS(6132),
    [anon_sym___thread] = ACTIONS(6132),
    [anon_sym_const] = ACTIONS(6132),
    [anon_sym_constexpr] = ACTIONS(6132),
    [anon_sym_volatile] = ACTIONS(6132),
    [anon_sym_restrict] = ACTIONS(6132),
    [anon_sym___restrict__] = ACTIONS(6132),
    [anon_sym__Atomic] = ACTIONS(6132),
    [anon_sym__Noreturn] = ACTIONS(6132),
    [anon_sym_noreturn] = ACTIONS(6132),
    [anon_sym_mutable] = ACTIONS(6132),
    [anon_sym_constinit] = ACTIONS(6132),
    [anon_sym_consteval] = ACTIONS(6132),
    [anon_sym_alignas] = ACTIONS(6132),
    [anon_sym__Alignas] = ACTIONS(6132),
    [sym_primitive_type] = ACTIONS(6132),
    [anon_sym_enum] = ACTIONS(6132),
    [anon_sym_class] = ACTIONS(6132),
    [anon_sym_struct] = ACTIONS(6132),
    [anon_sym_union] = ACTIONS(6132),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6132),
    [anon_sym_let] = ACTIONS(6132),
    [anon_sym_This] = ACTIONS(6132),
    [anon_sym_decltype] = ACTIONS(6132),
    [sym_virtual] = ACTIONS(6132),
    [anon_sym_explicit] = ACTIONS(6132),
    [anon_sym_typename] = ACTIONS(6132),
    [anon_sym_template] = ACTIONS(6132),
    [anon_sym_operator] = ACTIONS(6132),
    [anon_sym_precise] = ACTIONS(6132),
    [anon_sym_shared] = ACTIONS(6132),
    [anon_sym_groupshared] = ACTIONS(6132),
    [anon_sym_uniform] = ACTIONS(6132),
    [anon_sym_row_major] = ACTIONS(6132),
    [anon_sym_column_major] = ACTIONS(6132),
    [anon_sym_globallycoherent] = ACTIONS(6132),
    [anon_sym_centroid] = ACTIONS(6132),
    [anon_sym_noperspective] = ACTIONS(6132),
    [anon_sym_nointerpolation] = ACTIONS(6132),
    [anon_sym_sample] = ACTIONS(6132),
    [anon_sym_linear] = ACTIONS(6132),
    [anon_sym_snorm] = ACTIONS(6132),
    [anon_sym_unorm] = ACTIONS(6132),
    [anon_sym_point] = ACTIONS(6132),
    [anon_sym_line] = ACTIONS(6132),
    [anon_sym_triangleadj] = ACTIONS(6132),
    [anon_sym_lineadj] = ACTIONS(6132),
    [anon_sym_triangle] = ACTIONS(6132),
    [anon_sym_interface] = ACTIONS(6132),
    [anon_sym_extension] = ACTIONS(6132),
  },
  [2725] = {
    [sym_identifier] = ACTIONS(2964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2962),
    [anon_sym_COMMA] = ACTIONS(2962),
    [anon_sym_RPAREN] = ACTIONS(2962),
    [anon_sym_LPAREN2] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2962),
    [anon_sym_STAR] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_COLON] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym___extension__] = ACTIONS(2964),
    [anon_sym_in] = ACTIONS(2964),
    [anon_sym_out] = ACTIONS(2964),
    [anon_sym_inout] = ACTIONS(2964),
    [anon_sym_extern] = ACTIONS(2964),
    [anon_sym___attribute__] = ACTIONS(2964),
    [anon_sym_COLON_COLON] = ACTIONS(2962),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2962),
    [anon_sym___declspec] = ACTIONS(2964),
    [anon_sym___based] = ACTIONS(2964),
    [anon_sym___cdecl] = ACTIONS(2964),
    [anon_sym___clrcall] = ACTIONS(2964),
    [anon_sym___stdcall] = ACTIONS(2964),
    [anon_sym___fastcall] = ACTIONS(2964),
    [anon_sym___thiscall] = ACTIONS(2964),
    [anon_sym___vectorcall] = ACTIONS(2964),
    [anon_sym_LBRACK] = ACTIONS(2964),
    [anon_sym_static] = ACTIONS(2964),
    [anon_sym_EQ] = ACTIONS(2962),
    [anon_sym_register] = ACTIONS(2964),
    [anon_sym_inline] = ACTIONS(2964),
    [anon_sym___inline] = ACTIONS(2964),
    [anon_sym___inline__] = ACTIONS(2964),
    [anon_sym___forceinline] = ACTIONS(2964),
    [anon_sym_thread_local] = ACTIONS(2964),
    [anon_sym___thread] = ACTIONS(2964),
    [anon_sym_const] = ACTIONS(2964),
    [anon_sym_constexpr] = ACTIONS(2964),
    [anon_sym_volatile] = ACTIONS(2964),
    [anon_sym_restrict] = ACTIONS(2964),
    [anon_sym___restrict__] = ACTIONS(2964),
    [anon_sym__Atomic] = ACTIONS(2964),
    [anon_sym__Noreturn] = ACTIONS(2964),
    [anon_sym_noreturn] = ACTIONS(2964),
    [anon_sym_mutable] = ACTIONS(2964),
    [anon_sym_constinit] = ACTIONS(2964),
    [anon_sym_consteval] = ACTIONS(2964),
    [anon_sym_alignas] = ACTIONS(2964),
    [anon_sym__Alignas] = ACTIONS(2964),
    [anon_sym_DOT] = ACTIONS(2964),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2964),
    [anon_sym_let] = ACTIONS(2964),
    [anon_sym_This] = ACTIONS(2964),
    [anon_sym_decltype] = ACTIONS(2964),
    [sym_virtual] = ACTIONS(2964),
    [anon_sym_template] = ACTIONS(2964),
    [anon_sym_GT2] = ACTIONS(2962),
    [anon_sym_operator] = ACTIONS(2964),
    [anon_sym_precise] = ACTIONS(2964),
    [anon_sym_shared] = ACTIONS(2964),
    [anon_sym_groupshared] = ACTIONS(2964),
    [anon_sym_uniform] = ACTIONS(2964),
    [anon_sym_row_major] = ACTIONS(2964),
    [anon_sym_column_major] = ACTIONS(2964),
    [anon_sym_globallycoherent] = ACTIONS(2964),
    [anon_sym_centroid] = ACTIONS(2964),
    [anon_sym_noperspective] = ACTIONS(2964),
    [anon_sym_nointerpolation] = ACTIONS(2964),
    [anon_sym_sample] = ACTIONS(2964),
    [anon_sym_linear] = ACTIONS(2964),
    [anon_sym_snorm] = ACTIONS(2964),
    [anon_sym_unorm] = ACTIONS(2964),
    [anon_sym_point] = ACTIONS(2964),
    [anon_sym_line] = ACTIONS(2964),
    [anon_sym_triangleadj] = ACTIONS(2964),
    [anon_sym_lineadj] = ACTIONS(2964),
    [anon_sym_triangle] = ACTIONS(2964),
  },
  [2726] = {
    [sym_identifier] = ACTIONS(3102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3100),
    [anon_sym_COMMA] = ACTIONS(3100),
    [anon_sym_RPAREN] = ACTIONS(3100),
    [anon_sym_LPAREN2] = ACTIONS(3100),
    [anon_sym_TILDE] = ACTIONS(3100),
    [anon_sym_STAR] = ACTIONS(3100),
    [anon_sym_AMP_AMP] = ACTIONS(3100),
    [anon_sym_AMP] = ACTIONS(3102),
    [anon_sym_COLON] = ACTIONS(3102),
    [anon_sym_SEMI] = ACTIONS(3100),
    [anon_sym___extension__] = ACTIONS(3102),
    [anon_sym_in] = ACTIONS(3102),
    [anon_sym_out] = ACTIONS(3102),
    [anon_sym_inout] = ACTIONS(3102),
    [anon_sym_extern] = ACTIONS(3102),
    [anon_sym___attribute__] = ACTIONS(3102),
    [anon_sym_COLON_COLON] = ACTIONS(3100),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3100),
    [anon_sym___declspec] = ACTIONS(3102),
    [anon_sym___based] = ACTIONS(3102),
    [anon_sym___cdecl] = ACTIONS(3102),
    [anon_sym___clrcall] = ACTIONS(3102),
    [anon_sym___stdcall] = ACTIONS(3102),
    [anon_sym___fastcall] = ACTIONS(3102),
    [anon_sym___thiscall] = ACTIONS(3102),
    [anon_sym___vectorcall] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_static] = ACTIONS(3102),
    [anon_sym_EQ] = ACTIONS(3100),
    [anon_sym_register] = ACTIONS(3102),
    [anon_sym_inline] = ACTIONS(3102),
    [anon_sym___inline] = ACTIONS(3102),
    [anon_sym___inline__] = ACTIONS(3102),
    [anon_sym___forceinline] = ACTIONS(3102),
    [anon_sym_thread_local] = ACTIONS(3102),
    [anon_sym___thread] = ACTIONS(3102),
    [anon_sym_const] = ACTIONS(3102),
    [anon_sym_constexpr] = ACTIONS(3102),
    [anon_sym_volatile] = ACTIONS(3102),
    [anon_sym_restrict] = ACTIONS(3102),
    [anon_sym___restrict__] = ACTIONS(3102),
    [anon_sym__Atomic] = ACTIONS(3102),
    [anon_sym__Noreturn] = ACTIONS(3102),
    [anon_sym_noreturn] = ACTIONS(3102),
    [anon_sym_mutable] = ACTIONS(3102),
    [anon_sym_constinit] = ACTIONS(3102),
    [anon_sym_consteval] = ACTIONS(3102),
    [anon_sym_alignas] = ACTIONS(3102),
    [anon_sym__Alignas] = ACTIONS(3102),
    [anon_sym_DOT] = ACTIONS(3102),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3102),
    [anon_sym_let] = ACTIONS(3102),
    [anon_sym_This] = ACTIONS(3102),
    [anon_sym_decltype] = ACTIONS(3102),
    [sym_virtual] = ACTIONS(3102),
    [anon_sym_template] = ACTIONS(3102),
    [anon_sym_GT2] = ACTIONS(3100),
    [anon_sym_operator] = ACTIONS(3102),
    [anon_sym_precise] = ACTIONS(3102),
    [anon_sym_shared] = ACTIONS(3102),
    [anon_sym_groupshared] = ACTIONS(3102),
    [anon_sym_uniform] = ACTIONS(3102),
    [anon_sym_row_major] = ACTIONS(3102),
    [anon_sym_column_major] = ACTIONS(3102),
    [anon_sym_globallycoherent] = ACTIONS(3102),
    [anon_sym_centroid] = ACTIONS(3102),
    [anon_sym_noperspective] = ACTIONS(3102),
    [anon_sym_nointerpolation] = ACTIONS(3102),
    [anon_sym_sample] = ACTIONS(3102),
    [anon_sym_linear] = ACTIONS(3102),
    [anon_sym_snorm] = ACTIONS(3102),
    [anon_sym_unorm] = ACTIONS(3102),
    [anon_sym_point] = ACTIONS(3102),
    [anon_sym_line] = ACTIONS(3102),
    [anon_sym_triangleadj] = ACTIONS(3102),
    [anon_sym_lineadj] = ACTIONS(3102),
    [anon_sym_triangle] = ACTIONS(3102),
  },
  [2727] = {
    [sym_identifier] = ACTIONS(2742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2740),
    [anon_sym_COMMA] = ACTIONS(2740),
    [anon_sym_RPAREN] = ACTIONS(2740),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_TILDE] = ACTIONS(2740),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_COLON] = ACTIONS(2742),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym___extension__] = ACTIONS(2742),
    [anon_sym_in] = ACTIONS(2742),
    [anon_sym_out] = ACTIONS(2742),
    [anon_sym_inout] = ACTIONS(2742),
    [anon_sym_extern] = ACTIONS(2742),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym_COLON_COLON] = ACTIONS(2740),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2740),
    [anon_sym___declspec] = ACTIONS(2742),
    [anon_sym___based] = ACTIONS(2742),
    [anon_sym___cdecl] = ACTIONS(2742),
    [anon_sym___clrcall] = ACTIONS(2742),
    [anon_sym___stdcall] = ACTIONS(2742),
    [anon_sym___fastcall] = ACTIONS(2742),
    [anon_sym___thiscall] = ACTIONS(2742),
    [anon_sym___vectorcall] = ACTIONS(2742),
    [anon_sym_LBRACE] = ACTIONS(2365),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2742),
    [anon_sym_EQ] = ACTIONS(2740),
    [anon_sym_register] = ACTIONS(2742),
    [anon_sym_inline] = ACTIONS(2742),
    [anon_sym___inline] = ACTIONS(2742),
    [anon_sym___inline__] = ACTIONS(2742),
    [anon_sym___forceinline] = ACTIONS(2742),
    [anon_sym_thread_local] = ACTIONS(2742),
    [anon_sym___thread] = ACTIONS(2742),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_constexpr] = ACTIONS(2742),
    [anon_sym_volatile] = ACTIONS(2742),
    [anon_sym_restrict] = ACTIONS(2742),
    [anon_sym___restrict__] = ACTIONS(2742),
    [anon_sym__Atomic] = ACTIONS(2742),
    [anon_sym__Noreturn] = ACTIONS(2742),
    [anon_sym_noreturn] = ACTIONS(2742),
    [anon_sym_mutable] = ACTIONS(2742),
    [anon_sym_constinit] = ACTIONS(2742),
    [anon_sym_consteval] = ACTIONS(2742),
    [anon_sym_alignas] = ACTIONS(2742),
    [anon_sym__Alignas] = ACTIONS(2742),
    [anon_sym_DOT] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
    [anon_sym_decltype] = ACTIONS(2742),
    [sym_virtual] = ACTIONS(2742),
    [anon_sym_template] = ACTIONS(2742),
    [anon_sym_operator] = ACTIONS(2742),
    [anon_sym_precise] = ACTIONS(2742),
    [anon_sym_shared] = ACTIONS(2742),
    [anon_sym_groupshared] = ACTIONS(2742),
    [anon_sym_uniform] = ACTIONS(2742),
    [anon_sym_row_major] = ACTIONS(2742),
    [anon_sym_column_major] = ACTIONS(2742),
    [anon_sym_globallycoherent] = ACTIONS(2742),
    [anon_sym_centroid] = ACTIONS(2742),
    [anon_sym_noperspective] = ACTIONS(2742),
    [anon_sym_nointerpolation] = ACTIONS(2742),
    [anon_sym_sample] = ACTIONS(2742),
    [anon_sym_linear] = ACTIONS(2742),
    [anon_sym_snorm] = ACTIONS(2742),
    [anon_sym_unorm] = ACTIONS(2742),
    [anon_sym_point] = ACTIONS(2742),
    [anon_sym_line] = ACTIONS(2742),
    [anon_sym_triangleadj] = ACTIONS(2742),
    [anon_sym_lineadj] = ACTIONS(2742),
    [anon_sym_triangle] = ACTIONS(2742),
  },
  [2728] = {
    [sym_identifier] = ACTIONS(2742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2740),
    [anon_sym_COMMA] = ACTIONS(2740),
    [anon_sym_RPAREN] = ACTIONS(2740),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_TILDE] = ACTIONS(2740),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_COLON] = ACTIONS(2742),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym___extension__] = ACTIONS(2742),
    [anon_sym_in] = ACTIONS(2742),
    [anon_sym_out] = ACTIONS(2742),
    [anon_sym_inout] = ACTIONS(2742),
    [anon_sym_extern] = ACTIONS(2742),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2740),
    [anon_sym___declspec] = ACTIONS(2742),
    [anon_sym___based] = ACTIONS(2742),
    [anon_sym___cdecl] = ACTIONS(2742),
    [anon_sym___clrcall] = ACTIONS(2742),
    [anon_sym___stdcall] = ACTIONS(2742),
    [anon_sym___fastcall] = ACTIONS(2742),
    [anon_sym___thiscall] = ACTIONS(2742),
    [anon_sym___vectorcall] = ACTIONS(2742),
    [anon_sym_LBRACE] = ACTIONS(2365),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2742),
    [anon_sym_EQ] = ACTIONS(2740),
    [anon_sym_register] = ACTIONS(2742),
    [anon_sym_inline] = ACTIONS(2742),
    [anon_sym___inline] = ACTIONS(2742),
    [anon_sym___inline__] = ACTIONS(2742),
    [anon_sym___forceinline] = ACTIONS(2742),
    [anon_sym_thread_local] = ACTIONS(2742),
    [anon_sym___thread] = ACTIONS(2742),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_constexpr] = ACTIONS(2742),
    [anon_sym_volatile] = ACTIONS(2742),
    [anon_sym_restrict] = ACTIONS(2742),
    [anon_sym___restrict__] = ACTIONS(2742),
    [anon_sym__Atomic] = ACTIONS(2742),
    [anon_sym__Noreturn] = ACTIONS(2742),
    [anon_sym_noreturn] = ACTIONS(2742),
    [anon_sym_mutable] = ACTIONS(2742),
    [anon_sym_constinit] = ACTIONS(2742),
    [anon_sym_consteval] = ACTIONS(2742),
    [anon_sym_alignas] = ACTIONS(2742),
    [anon_sym__Alignas] = ACTIONS(2742),
    [anon_sym_DOT] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
    [anon_sym_decltype] = ACTIONS(2742),
    [sym_virtual] = ACTIONS(2742),
    [anon_sym_template] = ACTIONS(2742),
    [anon_sym_operator] = ACTIONS(2742),
    [anon_sym_precise] = ACTIONS(2742),
    [anon_sym_shared] = ACTIONS(2742),
    [anon_sym_groupshared] = ACTIONS(2742),
    [anon_sym_uniform] = ACTIONS(2742),
    [anon_sym_row_major] = ACTIONS(2742),
    [anon_sym_column_major] = ACTIONS(2742),
    [anon_sym_globallycoherent] = ACTIONS(2742),
    [anon_sym_centroid] = ACTIONS(2742),
    [anon_sym_noperspective] = ACTIONS(2742),
    [anon_sym_nointerpolation] = ACTIONS(2742),
    [anon_sym_sample] = ACTIONS(2742),
    [anon_sym_linear] = ACTIONS(2742),
    [anon_sym_snorm] = ACTIONS(2742),
    [anon_sym_unorm] = ACTIONS(2742),
    [anon_sym_point] = ACTIONS(2742),
    [anon_sym_line] = ACTIONS(2742),
    [anon_sym_triangleadj] = ACTIONS(2742),
    [anon_sym_lineadj] = ACTIONS(2742),
    [anon_sym_triangle] = ACTIONS(2742),
  },
  [2729] = {
    [sym_identifier] = ACTIONS(3338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3336),
    [anon_sym_COMMA] = ACTIONS(3336),
    [anon_sym_RPAREN] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3336),
    [anon_sym_TILDE] = ACTIONS(3336),
    [anon_sym_STAR] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_AMP] = ACTIONS(3338),
    [anon_sym_COLON] = ACTIONS(3338),
    [anon_sym_SEMI] = ACTIONS(3336),
    [anon_sym___extension__] = ACTIONS(3338),
    [anon_sym_in] = ACTIONS(3338),
    [anon_sym_out] = ACTIONS(3338),
    [anon_sym_inout] = ACTIONS(3338),
    [anon_sym_extern] = ACTIONS(3338),
    [anon_sym___attribute__] = ACTIONS(3338),
    [anon_sym_COLON_COLON] = ACTIONS(3336),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3336),
    [anon_sym___declspec] = ACTIONS(3338),
    [anon_sym___based] = ACTIONS(3338),
    [anon_sym___cdecl] = ACTIONS(3338),
    [anon_sym___clrcall] = ACTIONS(3338),
    [anon_sym___stdcall] = ACTIONS(3338),
    [anon_sym___fastcall] = ACTIONS(3338),
    [anon_sym___thiscall] = ACTIONS(3338),
    [anon_sym___vectorcall] = ACTIONS(3338),
    [anon_sym_LBRACK] = ACTIONS(3338),
    [anon_sym_static] = ACTIONS(3338),
    [anon_sym_EQ] = ACTIONS(3336),
    [anon_sym_register] = ACTIONS(3338),
    [anon_sym_inline] = ACTIONS(3338),
    [anon_sym___inline] = ACTIONS(3338),
    [anon_sym___inline__] = ACTIONS(3338),
    [anon_sym___forceinline] = ACTIONS(3338),
    [anon_sym_thread_local] = ACTIONS(3338),
    [anon_sym___thread] = ACTIONS(3338),
    [anon_sym_const] = ACTIONS(3338),
    [anon_sym_constexpr] = ACTIONS(3338),
    [anon_sym_volatile] = ACTIONS(3338),
    [anon_sym_restrict] = ACTIONS(3338),
    [anon_sym___restrict__] = ACTIONS(3338),
    [anon_sym__Atomic] = ACTIONS(3338),
    [anon_sym__Noreturn] = ACTIONS(3338),
    [anon_sym_noreturn] = ACTIONS(3338),
    [anon_sym_mutable] = ACTIONS(3338),
    [anon_sym_constinit] = ACTIONS(3338),
    [anon_sym_consteval] = ACTIONS(3338),
    [anon_sym_alignas] = ACTIONS(3338),
    [anon_sym__Alignas] = ACTIONS(3338),
    [anon_sym_DOT] = ACTIONS(3338),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3338),
    [anon_sym_let] = ACTIONS(3338),
    [anon_sym_This] = ACTIONS(3338),
    [anon_sym_decltype] = ACTIONS(3338),
    [sym_virtual] = ACTIONS(3338),
    [anon_sym_template] = ACTIONS(3338),
    [anon_sym_GT2] = ACTIONS(3336),
    [anon_sym_operator] = ACTIONS(3338),
    [anon_sym_precise] = ACTIONS(3338),
    [anon_sym_shared] = ACTIONS(3338),
    [anon_sym_groupshared] = ACTIONS(3338),
    [anon_sym_uniform] = ACTIONS(3338),
    [anon_sym_row_major] = ACTIONS(3338),
    [anon_sym_column_major] = ACTIONS(3338),
    [anon_sym_globallycoherent] = ACTIONS(3338),
    [anon_sym_centroid] = ACTIONS(3338),
    [anon_sym_noperspective] = ACTIONS(3338),
    [anon_sym_nointerpolation] = ACTIONS(3338),
    [anon_sym_sample] = ACTIONS(3338),
    [anon_sym_linear] = ACTIONS(3338),
    [anon_sym_snorm] = ACTIONS(3338),
    [anon_sym_unorm] = ACTIONS(3338),
    [anon_sym_point] = ACTIONS(3338),
    [anon_sym_line] = ACTIONS(3338),
    [anon_sym_triangleadj] = ACTIONS(3338),
    [anon_sym_lineadj] = ACTIONS(3338),
    [anon_sym_triangle] = ACTIONS(3338),
  },
  [2730] = {
    [sym_identifier] = ACTIONS(2948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2946),
    [anon_sym_COMMA] = ACTIONS(2946),
    [anon_sym_RPAREN] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2946),
    [anon_sym_TILDE] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2946),
    [anon_sym_AMP_AMP] = ACTIONS(2946),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_COLON] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2946),
    [anon_sym___extension__] = ACTIONS(2948),
    [anon_sym_in] = ACTIONS(2948),
    [anon_sym_out] = ACTIONS(2948),
    [anon_sym_inout] = ACTIONS(2948),
    [anon_sym_extern] = ACTIONS(2948),
    [anon_sym___attribute__] = ACTIONS(2948),
    [anon_sym_COLON_COLON] = ACTIONS(2946),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2946),
    [anon_sym___declspec] = ACTIONS(2948),
    [anon_sym___based] = ACTIONS(2948),
    [anon_sym___cdecl] = ACTIONS(2948),
    [anon_sym___clrcall] = ACTIONS(2948),
    [anon_sym___stdcall] = ACTIONS(2948),
    [anon_sym___fastcall] = ACTIONS(2948),
    [anon_sym___thiscall] = ACTIONS(2948),
    [anon_sym___vectorcall] = ACTIONS(2948),
    [anon_sym_LBRACK] = ACTIONS(2948),
    [anon_sym_static] = ACTIONS(2948),
    [anon_sym_EQ] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2948),
    [anon_sym_inline] = ACTIONS(2948),
    [anon_sym___inline] = ACTIONS(2948),
    [anon_sym___inline__] = ACTIONS(2948),
    [anon_sym___forceinline] = ACTIONS(2948),
    [anon_sym_thread_local] = ACTIONS(2948),
    [anon_sym___thread] = ACTIONS(2948),
    [anon_sym_const] = ACTIONS(2948),
    [anon_sym_constexpr] = ACTIONS(2948),
    [anon_sym_volatile] = ACTIONS(2948),
    [anon_sym_restrict] = ACTIONS(2948),
    [anon_sym___restrict__] = ACTIONS(2948),
    [anon_sym__Atomic] = ACTIONS(2948),
    [anon_sym__Noreturn] = ACTIONS(2948),
    [anon_sym_noreturn] = ACTIONS(2948),
    [anon_sym_mutable] = ACTIONS(2948),
    [anon_sym_constinit] = ACTIONS(2948),
    [anon_sym_consteval] = ACTIONS(2948),
    [anon_sym_alignas] = ACTIONS(2948),
    [anon_sym__Alignas] = ACTIONS(2948),
    [anon_sym_DOT] = ACTIONS(2948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2948),
    [anon_sym_let] = ACTIONS(2948),
    [anon_sym_This] = ACTIONS(2948),
    [anon_sym_decltype] = ACTIONS(2948),
    [sym_virtual] = ACTIONS(2948),
    [anon_sym_template] = ACTIONS(2948),
    [anon_sym_GT2] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2948),
    [anon_sym_precise] = ACTIONS(2948),
    [anon_sym_shared] = ACTIONS(2948),
    [anon_sym_groupshared] = ACTIONS(2948),
    [anon_sym_uniform] = ACTIONS(2948),
    [anon_sym_row_major] = ACTIONS(2948),
    [anon_sym_column_major] = ACTIONS(2948),
    [anon_sym_globallycoherent] = ACTIONS(2948),
    [anon_sym_centroid] = ACTIONS(2948),
    [anon_sym_noperspective] = ACTIONS(2948),
    [anon_sym_nointerpolation] = ACTIONS(2948),
    [anon_sym_sample] = ACTIONS(2948),
    [anon_sym_linear] = ACTIONS(2948),
    [anon_sym_snorm] = ACTIONS(2948),
    [anon_sym_unorm] = ACTIONS(2948),
    [anon_sym_point] = ACTIONS(2948),
    [anon_sym_line] = ACTIONS(2948),
    [anon_sym_triangleadj] = ACTIONS(2948),
    [anon_sym_lineadj] = ACTIONS(2948),
    [anon_sym_triangle] = ACTIONS(2948),
  },
  [2731] = {
    [sym_identifier] = ACTIONS(6132),
    [anon_sym_LPAREN2] = ACTIONS(6134),
    [anon_sym_TILDE] = ACTIONS(6134),
    [anon_sym_STAR] = ACTIONS(6134),
    [anon_sym_AMP_AMP] = ACTIONS(6134),
    [anon_sym_AMP] = ACTIONS(6132),
    [anon_sym___extension__] = ACTIONS(6132),
    [anon_sym_typedef] = ACTIONS(6354),
    [anon_sym_in] = ACTIONS(6132),
    [anon_sym_out] = ACTIONS(6132),
    [anon_sym_inout] = ACTIONS(6132),
    [anon_sym_extern] = ACTIONS(6132),
    [anon_sym___attribute__] = ACTIONS(6132),
    [anon_sym_COLON_COLON] = ACTIONS(6134),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6134),
    [anon_sym___declspec] = ACTIONS(6132),
    [anon_sym___based] = ACTIONS(6132),
    [anon_sym_signed] = ACTIONS(6132),
    [anon_sym_unsigned] = ACTIONS(6132),
    [anon_sym_long] = ACTIONS(6132),
    [anon_sym_short] = ACTIONS(6132),
    [anon_sym_LBRACK] = ACTIONS(6132),
    [anon_sym_static] = ACTIONS(6132),
    [anon_sym_register] = ACTIONS(6132),
    [anon_sym_inline] = ACTIONS(6132),
    [anon_sym___inline] = ACTIONS(6132),
    [anon_sym___inline__] = ACTIONS(6132),
    [anon_sym___forceinline] = ACTIONS(6132),
    [anon_sym_thread_local] = ACTIONS(6132),
    [anon_sym___thread] = ACTIONS(6132),
    [anon_sym_const] = ACTIONS(6132),
    [anon_sym_constexpr] = ACTIONS(6132),
    [anon_sym_volatile] = ACTIONS(6132),
    [anon_sym_restrict] = ACTIONS(6132),
    [anon_sym___restrict__] = ACTIONS(6132),
    [anon_sym__Atomic] = ACTIONS(6132),
    [anon_sym__Noreturn] = ACTIONS(6132),
    [anon_sym_noreturn] = ACTIONS(6132),
    [anon_sym_mutable] = ACTIONS(6132),
    [anon_sym_constinit] = ACTIONS(6132),
    [anon_sym_consteval] = ACTIONS(6132),
    [anon_sym_alignas] = ACTIONS(6132),
    [anon_sym__Alignas] = ACTIONS(6132),
    [sym_primitive_type] = ACTIONS(6132),
    [anon_sym_enum] = ACTIONS(6132),
    [anon_sym_class] = ACTIONS(6132),
    [anon_sym_struct] = ACTIONS(6132),
    [anon_sym_union] = ACTIONS(6132),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6132),
    [anon_sym_let] = ACTIONS(6132),
    [anon_sym_This] = ACTIONS(6132),
    [anon_sym_decltype] = ACTIONS(6132),
    [sym_virtual] = ACTIONS(6132),
    [anon_sym_explicit] = ACTIONS(6132),
    [anon_sym_typename] = ACTIONS(6132),
    [anon_sym_template] = ACTIONS(6132),
    [anon_sym_operator] = ACTIONS(6132),
    [anon_sym_precise] = ACTIONS(6132),
    [anon_sym_shared] = ACTIONS(6132),
    [anon_sym_groupshared] = ACTIONS(6132),
    [anon_sym_uniform] = ACTIONS(6132),
    [anon_sym_row_major] = ACTIONS(6132),
    [anon_sym_column_major] = ACTIONS(6132),
    [anon_sym_globallycoherent] = ACTIONS(6132),
    [anon_sym_centroid] = ACTIONS(6132),
    [anon_sym_noperspective] = ACTIONS(6132),
    [anon_sym_nointerpolation] = ACTIONS(6132),
    [anon_sym_sample] = ACTIONS(6132),
    [anon_sym_linear] = ACTIONS(6132),
    [anon_sym_snorm] = ACTIONS(6132),
    [anon_sym_unorm] = ACTIONS(6132),
    [anon_sym_point] = ACTIONS(6132),
    [anon_sym_line] = ACTIONS(6132),
    [anon_sym_triangleadj] = ACTIONS(6132),
    [anon_sym_lineadj] = ACTIONS(6132),
    [anon_sym_triangle] = ACTIONS(6132),
    [anon_sym_interface] = ACTIONS(6132),
    [anon_sym_extension] = ACTIONS(6132),
  },
  [2732] = {
    [sym_identifier] = ACTIONS(6132),
    [anon_sym_LPAREN2] = ACTIONS(6134),
    [anon_sym_TILDE] = ACTIONS(6134),
    [anon_sym_STAR] = ACTIONS(6134),
    [anon_sym_AMP_AMP] = ACTIONS(6134),
    [anon_sym_AMP] = ACTIONS(6132),
    [anon_sym___extension__] = ACTIONS(6132),
    [anon_sym_typedef] = ACTIONS(6356),
    [anon_sym_in] = ACTIONS(6132),
    [anon_sym_out] = ACTIONS(6132),
    [anon_sym_inout] = ACTIONS(6132),
    [anon_sym_extern] = ACTIONS(6132),
    [anon_sym___attribute__] = ACTIONS(6132),
    [anon_sym_COLON_COLON] = ACTIONS(6134),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6134),
    [anon_sym___declspec] = ACTIONS(6132),
    [anon_sym___based] = ACTIONS(6132),
    [anon_sym_signed] = ACTIONS(6132),
    [anon_sym_unsigned] = ACTIONS(6132),
    [anon_sym_long] = ACTIONS(6132),
    [anon_sym_short] = ACTIONS(6132),
    [anon_sym_LBRACK] = ACTIONS(6132),
    [anon_sym_static] = ACTIONS(6132),
    [anon_sym_register] = ACTIONS(6132),
    [anon_sym_inline] = ACTIONS(6132),
    [anon_sym___inline] = ACTIONS(6132),
    [anon_sym___inline__] = ACTIONS(6132),
    [anon_sym___forceinline] = ACTIONS(6132),
    [anon_sym_thread_local] = ACTIONS(6132),
    [anon_sym___thread] = ACTIONS(6132),
    [anon_sym_const] = ACTIONS(6132),
    [anon_sym_constexpr] = ACTIONS(6132),
    [anon_sym_volatile] = ACTIONS(6132),
    [anon_sym_restrict] = ACTIONS(6132),
    [anon_sym___restrict__] = ACTIONS(6132),
    [anon_sym__Atomic] = ACTIONS(6132),
    [anon_sym__Noreturn] = ACTIONS(6132),
    [anon_sym_noreturn] = ACTIONS(6132),
    [anon_sym_mutable] = ACTIONS(6132),
    [anon_sym_constinit] = ACTIONS(6132),
    [anon_sym_consteval] = ACTIONS(6132),
    [anon_sym_alignas] = ACTIONS(6132),
    [anon_sym__Alignas] = ACTIONS(6132),
    [sym_primitive_type] = ACTIONS(6132),
    [anon_sym_enum] = ACTIONS(6132),
    [anon_sym_class] = ACTIONS(6132),
    [anon_sym_struct] = ACTIONS(6132),
    [anon_sym_union] = ACTIONS(6132),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6132),
    [anon_sym_let] = ACTIONS(6132),
    [anon_sym_This] = ACTIONS(6132),
    [anon_sym_decltype] = ACTIONS(6132),
    [sym_virtual] = ACTIONS(6132),
    [anon_sym_explicit] = ACTIONS(6132),
    [anon_sym_typename] = ACTIONS(6132),
    [anon_sym_template] = ACTIONS(6132),
    [anon_sym_operator] = ACTIONS(6132),
    [anon_sym_precise] = ACTIONS(6132),
    [anon_sym_shared] = ACTIONS(6132),
    [anon_sym_groupshared] = ACTIONS(6132),
    [anon_sym_uniform] = ACTIONS(6132),
    [anon_sym_row_major] = ACTIONS(6132),
    [anon_sym_column_major] = ACTIONS(6132),
    [anon_sym_globallycoherent] = ACTIONS(6132),
    [anon_sym_centroid] = ACTIONS(6132),
    [anon_sym_noperspective] = ACTIONS(6132),
    [anon_sym_nointerpolation] = ACTIONS(6132),
    [anon_sym_sample] = ACTIONS(6132),
    [anon_sym_linear] = ACTIONS(6132),
    [anon_sym_snorm] = ACTIONS(6132),
    [anon_sym_unorm] = ACTIONS(6132),
    [anon_sym_point] = ACTIONS(6132),
    [anon_sym_line] = ACTIONS(6132),
    [anon_sym_triangleadj] = ACTIONS(6132),
    [anon_sym_lineadj] = ACTIONS(6132),
    [anon_sym_triangle] = ACTIONS(6132),
    [anon_sym_interface] = ACTIONS(6132),
    [anon_sym_extension] = ACTIONS(6132),
  },
  [2733] = {
    [sym_template_argument_list] = STATE(2686),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2639),
    [sym_identifier] = ACTIONS(2115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2123),
    [anon_sym_COMMA] = ACTIONS(2123),
    [anon_sym_RPAREN] = ACTIONS(2123),
    [anon_sym_LPAREN2] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_AMP_AMP] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2115),
    [anon_sym_LT] = ACTIONS(6358),
    [anon_sym_COLON] = ACTIONS(2115),
    [anon_sym___extension__] = ACTIONS(2115),
    [anon_sym_in] = ACTIONS(2115),
    [anon_sym_out] = ACTIONS(2115),
    [anon_sym_inout] = ACTIONS(2115),
    [anon_sym_extern] = ACTIONS(2115),
    [anon_sym___attribute__] = ACTIONS(2115),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2123),
    [anon_sym___declspec] = ACTIONS(2115),
    [anon_sym___based] = ACTIONS(2115),
    [anon_sym_signed] = ACTIONS(4863),
    [anon_sym_unsigned] = ACTIONS(4863),
    [anon_sym_long] = ACTIONS(4863),
    [anon_sym_short] = ACTIONS(4863),
    [anon_sym_LBRACK] = ACTIONS(2115),
    [anon_sym_static] = ACTIONS(2115),
    [anon_sym_EQ] = ACTIONS(2123),
    [anon_sym_register] = ACTIONS(2115),
    [anon_sym_inline] = ACTIONS(2115),
    [anon_sym___inline] = ACTIONS(2115),
    [anon_sym___inline__] = ACTIONS(2115),
    [anon_sym___forceinline] = ACTIONS(2115),
    [anon_sym_thread_local] = ACTIONS(2115),
    [anon_sym___thread] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(2115),
    [anon_sym_constexpr] = ACTIONS(2115),
    [anon_sym_volatile] = ACTIONS(2115),
    [anon_sym_restrict] = ACTIONS(2115),
    [anon_sym___restrict__] = ACTIONS(2115),
    [anon_sym__Atomic] = ACTIONS(2115),
    [anon_sym__Noreturn] = ACTIONS(2115),
    [anon_sym_noreturn] = ACTIONS(2115),
    [anon_sym_mutable] = ACTIONS(2115),
    [anon_sym_constinit] = ACTIONS(2115),
    [anon_sym_consteval] = ACTIONS(2115),
    [anon_sym_alignas] = ACTIONS(2115),
    [anon_sym__Alignas] = ACTIONS(2115),
    [anon_sym_DOT] = ACTIONS(2115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2115),
    [anon_sym_let] = ACTIONS(2115),
    [anon_sym_This] = ACTIONS(2115),
    [anon_sym_decltype] = ACTIONS(2115),
    [sym_virtual] = ACTIONS(2115),
    [anon_sym_template] = ACTIONS(2115),
    [anon_sym_GT2] = ACTIONS(2123),
    [anon_sym_operator] = ACTIONS(2115),
    [anon_sym_precise] = ACTIONS(2115),
    [anon_sym_shared] = ACTIONS(2115),
    [anon_sym_groupshared] = ACTIONS(2115),
    [anon_sym_uniform] = ACTIONS(2115),
    [anon_sym_row_major] = ACTIONS(2115),
    [anon_sym_column_major] = ACTIONS(2115),
    [anon_sym_globallycoherent] = ACTIONS(2115),
    [anon_sym_centroid] = ACTIONS(2115),
    [anon_sym_noperspective] = ACTIONS(2115),
    [anon_sym_nointerpolation] = ACTIONS(2115),
    [anon_sym_sample] = ACTIONS(2115),
    [anon_sym_linear] = ACTIONS(2115),
    [anon_sym_snorm] = ACTIONS(2115),
    [anon_sym_unorm] = ACTIONS(2115),
    [anon_sym_point] = ACTIONS(2115),
    [anon_sym_line] = ACTIONS(2115),
    [anon_sym_triangleadj] = ACTIONS(2115),
    [anon_sym_lineadj] = ACTIONS(2115),
    [anon_sym_triangle] = ACTIONS(2115),
  },
  [2734] = {
    [sym_identifier] = ACTIONS(3338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3336),
    [anon_sym_COMMA] = ACTIONS(3336),
    [anon_sym_RPAREN] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3336),
    [anon_sym_TILDE] = ACTIONS(3336),
    [anon_sym_STAR] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_AMP] = ACTIONS(3338),
    [anon_sym_COLON] = ACTIONS(3338),
    [anon_sym_SEMI] = ACTIONS(3336),
    [anon_sym___extension__] = ACTIONS(3338),
    [anon_sym_in] = ACTIONS(3338),
    [anon_sym_out] = ACTIONS(3338),
    [anon_sym_inout] = ACTIONS(3338),
    [anon_sym_extern] = ACTIONS(3338),
    [anon_sym___attribute__] = ACTIONS(3338),
    [anon_sym_COLON_COLON] = ACTIONS(3336),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3336),
    [anon_sym___declspec] = ACTIONS(3338),
    [anon_sym___based] = ACTIONS(3338),
    [anon_sym___cdecl] = ACTIONS(3338),
    [anon_sym___clrcall] = ACTIONS(3338),
    [anon_sym___stdcall] = ACTIONS(3338),
    [anon_sym___fastcall] = ACTIONS(3338),
    [anon_sym___thiscall] = ACTIONS(3338),
    [anon_sym___vectorcall] = ACTIONS(3338),
    [anon_sym_LBRACK] = ACTIONS(3338),
    [anon_sym_static] = ACTIONS(3338),
    [anon_sym_EQ] = ACTIONS(3336),
    [anon_sym_register] = ACTIONS(3338),
    [anon_sym_inline] = ACTIONS(3338),
    [anon_sym___inline] = ACTIONS(3338),
    [anon_sym___inline__] = ACTIONS(3338),
    [anon_sym___forceinline] = ACTIONS(3338),
    [anon_sym_thread_local] = ACTIONS(3338),
    [anon_sym___thread] = ACTIONS(3338),
    [anon_sym_const] = ACTIONS(3338),
    [anon_sym_constexpr] = ACTIONS(3338),
    [anon_sym_volatile] = ACTIONS(3338),
    [anon_sym_restrict] = ACTIONS(3338),
    [anon_sym___restrict__] = ACTIONS(3338),
    [anon_sym__Atomic] = ACTIONS(3338),
    [anon_sym__Noreturn] = ACTIONS(3338),
    [anon_sym_noreturn] = ACTIONS(3338),
    [anon_sym_mutable] = ACTIONS(3338),
    [anon_sym_constinit] = ACTIONS(3338),
    [anon_sym_consteval] = ACTIONS(3338),
    [anon_sym_alignas] = ACTIONS(3338),
    [anon_sym__Alignas] = ACTIONS(3338),
    [anon_sym_DOT] = ACTIONS(3338),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3338),
    [anon_sym_let] = ACTIONS(3338),
    [anon_sym_This] = ACTIONS(3338),
    [anon_sym_decltype] = ACTIONS(3338),
    [sym_virtual] = ACTIONS(3338),
    [anon_sym_template] = ACTIONS(3338),
    [anon_sym_GT2] = ACTIONS(3336),
    [anon_sym_operator] = ACTIONS(3338),
    [anon_sym_precise] = ACTIONS(3338),
    [anon_sym_shared] = ACTIONS(3338),
    [anon_sym_groupshared] = ACTIONS(3338),
    [anon_sym_uniform] = ACTIONS(3338),
    [anon_sym_row_major] = ACTIONS(3338),
    [anon_sym_column_major] = ACTIONS(3338),
    [anon_sym_globallycoherent] = ACTIONS(3338),
    [anon_sym_centroid] = ACTIONS(3338),
    [anon_sym_noperspective] = ACTIONS(3338),
    [anon_sym_nointerpolation] = ACTIONS(3338),
    [anon_sym_sample] = ACTIONS(3338),
    [anon_sym_linear] = ACTIONS(3338),
    [anon_sym_snorm] = ACTIONS(3338),
    [anon_sym_unorm] = ACTIONS(3338),
    [anon_sym_point] = ACTIONS(3338),
    [anon_sym_line] = ACTIONS(3338),
    [anon_sym_triangleadj] = ACTIONS(3338),
    [anon_sym_lineadj] = ACTIONS(3338),
    [anon_sym_triangle] = ACTIONS(3338),
  },
  [2735] = {
    [sym_identifier] = ACTIONS(3070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3068),
    [anon_sym_COMMA] = ACTIONS(3068),
    [anon_sym_RPAREN] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3068),
    [anon_sym_TILDE] = ACTIONS(3068),
    [anon_sym_STAR] = ACTIONS(3068),
    [anon_sym_AMP_AMP] = ACTIONS(3068),
    [anon_sym_AMP] = ACTIONS(3070),
    [anon_sym_COLON] = ACTIONS(3070),
    [anon_sym_SEMI] = ACTIONS(3068),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_in] = ACTIONS(3070),
    [anon_sym_out] = ACTIONS(3070),
    [anon_sym_inout] = ACTIONS(3070),
    [anon_sym_extern] = ACTIONS(3070),
    [anon_sym___attribute__] = ACTIONS(3070),
    [anon_sym_COLON_COLON] = ACTIONS(3068),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3068),
    [anon_sym___declspec] = ACTIONS(3070),
    [anon_sym___based] = ACTIONS(3070),
    [anon_sym___cdecl] = ACTIONS(3070),
    [anon_sym___clrcall] = ACTIONS(3070),
    [anon_sym___stdcall] = ACTIONS(3070),
    [anon_sym___fastcall] = ACTIONS(3070),
    [anon_sym___thiscall] = ACTIONS(3070),
    [anon_sym___vectorcall] = ACTIONS(3070),
    [anon_sym_LBRACK] = ACTIONS(3070),
    [anon_sym_static] = ACTIONS(3070),
    [anon_sym_EQ] = ACTIONS(3068),
    [anon_sym_register] = ACTIONS(3070),
    [anon_sym_inline] = ACTIONS(3070),
    [anon_sym___inline] = ACTIONS(3070),
    [anon_sym___inline__] = ACTIONS(3070),
    [anon_sym___forceinline] = ACTIONS(3070),
    [anon_sym_thread_local] = ACTIONS(3070),
    [anon_sym___thread] = ACTIONS(3070),
    [anon_sym_const] = ACTIONS(3070),
    [anon_sym_constexpr] = ACTIONS(3070),
    [anon_sym_volatile] = ACTIONS(3070),
    [anon_sym_restrict] = ACTIONS(3070),
    [anon_sym___restrict__] = ACTIONS(3070),
    [anon_sym__Atomic] = ACTIONS(3070),
    [anon_sym__Noreturn] = ACTIONS(3070),
    [anon_sym_noreturn] = ACTIONS(3070),
    [anon_sym_mutable] = ACTIONS(3070),
    [anon_sym_constinit] = ACTIONS(3070),
    [anon_sym_consteval] = ACTIONS(3070),
    [anon_sym_alignas] = ACTIONS(3070),
    [anon_sym__Alignas] = ACTIONS(3070),
    [anon_sym_DOT] = ACTIONS(3070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3070),
    [anon_sym_let] = ACTIONS(3070),
    [anon_sym_This] = ACTIONS(3070),
    [anon_sym_decltype] = ACTIONS(3070),
    [sym_virtual] = ACTIONS(3070),
    [anon_sym_template] = ACTIONS(3070),
    [anon_sym_GT2] = ACTIONS(3068),
    [anon_sym_operator] = ACTIONS(3070),
    [anon_sym_precise] = ACTIONS(3070),
    [anon_sym_shared] = ACTIONS(3070),
    [anon_sym_groupshared] = ACTIONS(3070),
    [anon_sym_uniform] = ACTIONS(3070),
    [anon_sym_row_major] = ACTIONS(3070),
    [anon_sym_column_major] = ACTIONS(3070),
    [anon_sym_globallycoherent] = ACTIONS(3070),
    [anon_sym_centroid] = ACTIONS(3070),
    [anon_sym_noperspective] = ACTIONS(3070),
    [anon_sym_nointerpolation] = ACTIONS(3070),
    [anon_sym_sample] = ACTIONS(3070),
    [anon_sym_linear] = ACTIONS(3070),
    [anon_sym_snorm] = ACTIONS(3070),
    [anon_sym_unorm] = ACTIONS(3070),
    [anon_sym_point] = ACTIONS(3070),
    [anon_sym_line] = ACTIONS(3070),
    [anon_sym_triangleadj] = ACTIONS(3070),
    [anon_sym_lineadj] = ACTIONS(3070),
    [anon_sym_triangle] = ACTIONS(3070),
  },
  [2736] = {
    [sym_identifier] = ACTIONS(3090),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3088),
    [anon_sym_COMMA] = ACTIONS(3088),
    [anon_sym_RPAREN] = ACTIONS(3088),
    [anon_sym_LPAREN2] = ACTIONS(3088),
    [anon_sym_TILDE] = ACTIONS(3088),
    [anon_sym_STAR] = ACTIONS(3088),
    [anon_sym_AMP_AMP] = ACTIONS(3088),
    [anon_sym_AMP] = ACTIONS(3090),
    [anon_sym_COLON] = ACTIONS(3090),
    [anon_sym_SEMI] = ACTIONS(3088),
    [anon_sym___extension__] = ACTIONS(3090),
    [anon_sym_in] = ACTIONS(3090),
    [anon_sym_out] = ACTIONS(3090),
    [anon_sym_inout] = ACTIONS(3090),
    [anon_sym_extern] = ACTIONS(3090),
    [anon_sym___attribute__] = ACTIONS(3090),
    [anon_sym_COLON_COLON] = ACTIONS(3088),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3088),
    [anon_sym___declspec] = ACTIONS(3090),
    [anon_sym___based] = ACTIONS(3090),
    [anon_sym___cdecl] = ACTIONS(3090),
    [anon_sym___clrcall] = ACTIONS(3090),
    [anon_sym___stdcall] = ACTIONS(3090),
    [anon_sym___fastcall] = ACTIONS(3090),
    [anon_sym___thiscall] = ACTIONS(3090),
    [anon_sym___vectorcall] = ACTIONS(3090),
    [anon_sym_LBRACK] = ACTIONS(3090),
    [anon_sym_static] = ACTIONS(3090),
    [anon_sym_EQ] = ACTIONS(3088),
    [anon_sym_register] = ACTIONS(3090),
    [anon_sym_inline] = ACTIONS(3090),
    [anon_sym___inline] = ACTIONS(3090),
    [anon_sym___inline__] = ACTIONS(3090),
    [anon_sym___forceinline] = ACTIONS(3090),
    [anon_sym_thread_local] = ACTIONS(3090),
    [anon_sym___thread] = ACTIONS(3090),
    [anon_sym_const] = ACTIONS(3090),
    [anon_sym_constexpr] = ACTIONS(3090),
    [anon_sym_volatile] = ACTIONS(3090),
    [anon_sym_restrict] = ACTIONS(3090),
    [anon_sym___restrict__] = ACTIONS(3090),
    [anon_sym__Atomic] = ACTIONS(3090),
    [anon_sym__Noreturn] = ACTIONS(3090),
    [anon_sym_noreturn] = ACTIONS(3090),
    [anon_sym_mutable] = ACTIONS(3090),
    [anon_sym_constinit] = ACTIONS(3090),
    [anon_sym_consteval] = ACTIONS(3090),
    [anon_sym_alignas] = ACTIONS(3090),
    [anon_sym__Alignas] = ACTIONS(3090),
    [anon_sym_DOT] = ACTIONS(3090),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3090),
    [anon_sym_let] = ACTIONS(3090),
    [anon_sym_This] = ACTIONS(3090),
    [anon_sym_decltype] = ACTIONS(3090),
    [sym_virtual] = ACTIONS(3090),
    [anon_sym_template] = ACTIONS(3090),
    [anon_sym_GT2] = ACTIONS(3088),
    [anon_sym_operator] = ACTIONS(3090),
    [anon_sym_precise] = ACTIONS(3090),
    [anon_sym_shared] = ACTIONS(3090),
    [anon_sym_groupshared] = ACTIONS(3090),
    [anon_sym_uniform] = ACTIONS(3090),
    [anon_sym_row_major] = ACTIONS(3090),
    [anon_sym_column_major] = ACTIONS(3090),
    [anon_sym_globallycoherent] = ACTIONS(3090),
    [anon_sym_centroid] = ACTIONS(3090),
    [anon_sym_noperspective] = ACTIONS(3090),
    [anon_sym_nointerpolation] = ACTIONS(3090),
    [anon_sym_sample] = ACTIONS(3090),
    [anon_sym_linear] = ACTIONS(3090),
    [anon_sym_snorm] = ACTIONS(3090),
    [anon_sym_unorm] = ACTIONS(3090),
    [anon_sym_point] = ACTIONS(3090),
    [anon_sym_line] = ACTIONS(3090),
    [anon_sym_triangleadj] = ACTIONS(3090),
    [anon_sym_lineadj] = ACTIONS(3090),
    [anon_sym_triangle] = ACTIONS(3090),
  },
  [2737] = {
    [sym_identifier] = ACTIONS(3384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3382),
    [anon_sym_COMMA] = ACTIONS(3382),
    [anon_sym_RPAREN] = ACTIONS(3382),
    [anon_sym_LPAREN2] = ACTIONS(3382),
    [anon_sym_TILDE] = ACTIONS(3382),
    [anon_sym_STAR] = ACTIONS(3382),
    [anon_sym_AMP_AMP] = ACTIONS(3382),
    [anon_sym_AMP] = ACTIONS(3384),
    [anon_sym_COLON] = ACTIONS(3384),
    [anon_sym_SEMI] = ACTIONS(3382),
    [anon_sym___extension__] = ACTIONS(3384),
    [anon_sym_in] = ACTIONS(3384),
    [anon_sym_out] = ACTIONS(3384),
    [anon_sym_inout] = ACTIONS(3384),
    [anon_sym_extern] = ACTIONS(3384),
    [anon_sym___attribute__] = ACTIONS(3384),
    [anon_sym_COLON_COLON] = ACTIONS(3382),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3382),
    [anon_sym___declspec] = ACTIONS(3384),
    [anon_sym___based] = ACTIONS(3384),
    [anon_sym___cdecl] = ACTIONS(3384),
    [anon_sym___clrcall] = ACTIONS(3384),
    [anon_sym___stdcall] = ACTIONS(3384),
    [anon_sym___fastcall] = ACTIONS(3384),
    [anon_sym___thiscall] = ACTIONS(3384),
    [anon_sym___vectorcall] = ACTIONS(3384),
    [anon_sym_LBRACK] = ACTIONS(3384),
    [anon_sym_static] = ACTIONS(3384),
    [anon_sym_EQ] = ACTIONS(3382),
    [anon_sym_register] = ACTIONS(3384),
    [anon_sym_inline] = ACTIONS(3384),
    [anon_sym___inline] = ACTIONS(3384),
    [anon_sym___inline__] = ACTIONS(3384),
    [anon_sym___forceinline] = ACTIONS(3384),
    [anon_sym_thread_local] = ACTIONS(3384),
    [anon_sym___thread] = ACTIONS(3384),
    [anon_sym_const] = ACTIONS(3384),
    [anon_sym_constexpr] = ACTIONS(3384),
    [anon_sym_volatile] = ACTIONS(3384),
    [anon_sym_restrict] = ACTIONS(3384),
    [anon_sym___restrict__] = ACTIONS(3384),
    [anon_sym__Atomic] = ACTIONS(3384),
    [anon_sym__Noreturn] = ACTIONS(3384),
    [anon_sym_noreturn] = ACTIONS(3384),
    [anon_sym_mutable] = ACTIONS(3384),
    [anon_sym_constinit] = ACTIONS(3384),
    [anon_sym_consteval] = ACTIONS(3384),
    [anon_sym_alignas] = ACTIONS(3384),
    [anon_sym__Alignas] = ACTIONS(3384),
    [anon_sym_DOT] = ACTIONS(3384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3384),
    [anon_sym_let] = ACTIONS(3384),
    [anon_sym_This] = ACTIONS(3384),
    [anon_sym_decltype] = ACTIONS(3384),
    [sym_virtual] = ACTIONS(3384),
    [anon_sym_template] = ACTIONS(3384),
    [anon_sym_GT2] = ACTIONS(3382),
    [anon_sym_operator] = ACTIONS(3384),
    [anon_sym_precise] = ACTIONS(3384),
    [anon_sym_shared] = ACTIONS(3384),
    [anon_sym_groupshared] = ACTIONS(3384),
    [anon_sym_uniform] = ACTIONS(3384),
    [anon_sym_row_major] = ACTIONS(3384),
    [anon_sym_column_major] = ACTIONS(3384),
    [anon_sym_globallycoherent] = ACTIONS(3384),
    [anon_sym_centroid] = ACTIONS(3384),
    [anon_sym_noperspective] = ACTIONS(3384),
    [anon_sym_nointerpolation] = ACTIONS(3384),
    [anon_sym_sample] = ACTIONS(3384),
    [anon_sym_linear] = ACTIONS(3384),
    [anon_sym_snorm] = ACTIONS(3384),
    [anon_sym_unorm] = ACTIONS(3384),
    [anon_sym_point] = ACTIONS(3384),
    [anon_sym_line] = ACTIONS(3384),
    [anon_sym_triangleadj] = ACTIONS(3384),
    [anon_sym_lineadj] = ACTIONS(3384),
    [anon_sym_triangle] = ACTIONS(3384),
  },
  [2738] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2738),
    [sym_identifier] = ACTIONS(2856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2854),
    [anon_sym_COMMA] = ACTIONS(2854),
    [anon_sym_RPAREN] = ACTIONS(2854),
    [aux_sym_preproc_if_token2] = ACTIONS(2854),
    [aux_sym_preproc_else_token1] = ACTIONS(2854),
    [aux_sym_preproc_elif_token1] = ACTIONS(2856),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2854),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2854),
    [anon_sym_LPAREN2] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(2856),
    [anon_sym_PLUS] = ACTIONS(2856),
    [anon_sym_STAR] = ACTIONS(2854),
    [anon_sym_SLASH] = ACTIONS(2856),
    [anon_sym_PERCENT] = ACTIONS(2854),
    [anon_sym_PIPE_PIPE] = ACTIONS(2854),
    [anon_sym_AMP_AMP] = ACTIONS(2854),
    [anon_sym_PIPE] = ACTIONS(2856),
    [anon_sym_CARET] = ACTIONS(2854),
    [anon_sym_AMP] = ACTIONS(2856),
    [anon_sym_EQ_EQ] = ACTIONS(2854),
    [anon_sym_BANG_EQ] = ACTIONS(2854),
    [anon_sym_GT] = ACTIONS(2856),
    [anon_sym_GT_EQ] = ACTIONS(2854),
    [anon_sym_LT_EQ] = ACTIONS(2856),
    [anon_sym_LT] = ACTIONS(2856),
    [anon_sym_LT_LT] = ACTIONS(2854),
    [anon_sym_GT_GT] = ACTIONS(2854),
    [anon_sym_COLON] = ACTIONS(2854),
    [anon_sym_SEMI] = ACTIONS(2854),
    [anon_sym___extension__] = ACTIONS(2856),
    [anon_sym___attribute__] = ACTIONS(2856),
    [anon_sym___based] = ACTIONS(2856),
    [anon_sym_LBRACE] = ACTIONS(2854),
    [anon_sym_RBRACE] = ACTIONS(2854),
    [anon_sym_signed] = ACTIONS(6360),
    [anon_sym_unsigned] = ACTIONS(6360),
    [anon_sym_long] = ACTIONS(6360),
    [anon_sym_short] = ACTIONS(6360),
    [anon_sym_LBRACK] = ACTIONS(2854),
    [anon_sym_RBRACK] = ACTIONS(2854),
    [anon_sym_const] = ACTIONS(2856),
    [anon_sym_constexpr] = ACTIONS(2856),
    [anon_sym_volatile] = ACTIONS(2856),
    [anon_sym_restrict] = ACTIONS(2856),
    [anon_sym___restrict__] = ACTIONS(2856),
    [anon_sym__Atomic] = ACTIONS(2856),
    [anon_sym__Noreturn] = ACTIONS(2856),
    [anon_sym_noreturn] = ACTIONS(2856),
    [anon_sym_mutable] = ACTIONS(2856),
    [anon_sym_constinit] = ACTIONS(2856),
    [anon_sym_consteval] = ACTIONS(2856),
    [anon_sym_alignas] = ACTIONS(2856),
    [anon_sym__Alignas] = ACTIONS(2856),
    [sym_primitive_type] = ACTIONS(2856),
    [anon_sym_QMARK] = ACTIONS(2854),
    [anon_sym_LT_EQ_GT] = ACTIONS(2854),
    [anon_sym_or] = ACTIONS(2856),
    [anon_sym_and] = ACTIONS(2856),
    [anon_sym_bitor] = ACTIONS(2856),
    [anon_sym_xor] = ACTIONS(2856),
    [anon_sym_bitand] = ACTIONS(2856),
    [anon_sym_not_eq] = ACTIONS(2856),
    [anon_sym_is] = ACTIONS(2856),
    [anon_sym_as] = ACTIONS(2856),
    [anon_sym_DASH_DASH] = ACTIONS(2854),
    [anon_sym_PLUS_PLUS] = ACTIONS(2854),
    [anon_sym_DOT] = ACTIONS(2856),
    [anon_sym_DOT_STAR] = ACTIONS(2854),
    [anon_sym_DASH_GT] = ACTIONS(2854),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2856),
    [anon_sym_let] = ACTIONS(2856),
    [anon_sym_This] = ACTIONS(2856),
    [anon_sym_final] = ACTIONS(2856),
    [anon_sym_override] = ACTIONS(2856),
    [anon_sym_requires] = ACTIONS(2856),
    [anon_sym_where] = ACTIONS(2856),
  },
  [2739] = {
    [sym_identifier] = ACTIONS(3054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3052),
    [anon_sym_COMMA] = ACTIONS(3052),
    [anon_sym_RPAREN] = ACTIONS(3052),
    [anon_sym_LPAREN2] = ACTIONS(3052),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3054),
    [anon_sym_COLON] = ACTIONS(3054),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym___extension__] = ACTIONS(3054),
    [anon_sym_in] = ACTIONS(3054),
    [anon_sym_out] = ACTIONS(3054),
    [anon_sym_inout] = ACTIONS(3054),
    [anon_sym_extern] = ACTIONS(3054),
    [anon_sym___attribute__] = ACTIONS(3054),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3052),
    [anon_sym___declspec] = ACTIONS(3054),
    [anon_sym___based] = ACTIONS(3054),
    [anon_sym___cdecl] = ACTIONS(3054),
    [anon_sym___clrcall] = ACTIONS(3054),
    [anon_sym___stdcall] = ACTIONS(3054),
    [anon_sym___fastcall] = ACTIONS(3054),
    [anon_sym___thiscall] = ACTIONS(3054),
    [anon_sym___vectorcall] = ACTIONS(3054),
    [anon_sym_LBRACK] = ACTIONS(3054),
    [anon_sym_static] = ACTIONS(3054),
    [anon_sym_EQ] = ACTIONS(3052),
    [anon_sym_register] = ACTIONS(3054),
    [anon_sym_inline] = ACTIONS(3054),
    [anon_sym___inline] = ACTIONS(3054),
    [anon_sym___inline__] = ACTIONS(3054),
    [anon_sym___forceinline] = ACTIONS(3054),
    [anon_sym_thread_local] = ACTIONS(3054),
    [anon_sym___thread] = ACTIONS(3054),
    [anon_sym_const] = ACTIONS(3054),
    [anon_sym_constexpr] = ACTIONS(3054),
    [anon_sym_volatile] = ACTIONS(3054),
    [anon_sym_restrict] = ACTIONS(3054),
    [anon_sym___restrict__] = ACTIONS(3054),
    [anon_sym__Atomic] = ACTIONS(3054),
    [anon_sym__Noreturn] = ACTIONS(3054),
    [anon_sym_noreturn] = ACTIONS(3054),
    [anon_sym_mutable] = ACTIONS(3054),
    [anon_sym_constinit] = ACTIONS(3054),
    [anon_sym_consteval] = ACTIONS(3054),
    [anon_sym_alignas] = ACTIONS(3054),
    [anon_sym__Alignas] = ACTIONS(3054),
    [anon_sym_DOT] = ACTIONS(3054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3054),
    [anon_sym_let] = ACTIONS(3054),
    [anon_sym_This] = ACTIONS(3054),
    [anon_sym_decltype] = ACTIONS(3054),
    [sym_virtual] = ACTIONS(3054),
    [anon_sym_template] = ACTIONS(3054),
    [anon_sym_GT2] = ACTIONS(3052),
    [anon_sym_operator] = ACTIONS(3054),
    [anon_sym_precise] = ACTIONS(3054),
    [anon_sym_shared] = ACTIONS(3054),
    [anon_sym_groupshared] = ACTIONS(3054),
    [anon_sym_uniform] = ACTIONS(3054),
    [anon_sym_row_major] = ACTIONS(3054),
    [anon_sym_column_major] = ACTIONS(3054),
    [anon_sym_globallycoherent] = ACTIONS(3054),
    [anon_sym_centroid] = ACTIONS(3054),
    [anon_sym_noperspective] = ACTIONS(3054),
    [anon_sym_nointerpolation] = ACTIONS(3054),
    [anon_sym_sample] = ACTIONS(3054),
    [anon_sym_linear] = ACTIONS(3054),
    [anon_sym_snorm] = ACTIONS(3054),
    [anon_sym_unorm] = ACTIONS(3054),
    [anon_sym_point] = ACTIONS(3054),
    [anon_sym_line] = ACTIONS(3054),
    [anon_sym_triangleadj] = ACTIONS(3054),
    [anon_sym_lineadj] = ACTIONS(3054),
    [anon_sym_triangle] = ACTIONS(3054),
  },
  [2740] = {
    [sym_identifier] = ACTIONS(2944),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2942),
    [anon_sym_COMMA] = ACTIONS(2942),
    [anon_sym_RPAREN] = ACTIONS(2942),
    [anon_sym_LPAREN2] = ACTIONS(2942),
    [anon_sym_TILDE] = ACTIONS(2942),
    [anon_sym_STAR] = ACTIONS(2942),
    [anon_sym_AMP_AMP] = ACTIONS(2942),
    [anon_sym_AMP] = ACTIONS(2944),
    [anon_sym_COLON] = ACTIONS(2944),
    [anon_sym_SEMI] = ACTIONS(2942),
    [anon_sym___extension__] = ACTIONS(2944),
    [anon_sym_in] = ACTIONS(2944),
    [anon_sym_out] = ACTIONS(2944),
    [anon_sym_inout] = ACTIONS(2944),
    [anon_sym_extern] = ACTIONS(2944),
    [anon_sym___attribute__] = ACTIONS(2944),
    [anon_sym_COLON_COLON] = ACTIONS(2942),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2942),
    [anon_sym___declspec] = ACTIONS(2944),
    [anon_sym___based] = ACTIONS(2944),
    [anon_sym___cdecl] = ACTIONS(2944),
    [anon_sym___clrcall] = ACTIONS(2944),
    [anon_sym___stdcall] = ACTIONS(2944),
    [anon_sym___fastcall] = ACTIONS(2944),
    [anon_sym___thiscall] = ACTIONS(2944),
    [anon_sym___vectorcall] = ACTIONS(2944),
    [anon_sym_LBRACK] = ACTIONS(2944),
    [anon_sym_static] = ACTIONS(2944),
    [anon_sym_EQ] = ACTIONS(2942),
    [anon_sym_register] = ACTIONS(2944),
    [anon_sym_inline] = ACTIONS(2944),
    [anon_sym___inline] = ACTIONS(2944),
    [anon_sym___inline__] = ACTIONS(2944),
    [anon_sym___forceinline] = ACTIONS(2944),
    [anon_sym_thread_local] = ACTIONS(2944),
    [anon_sym___thread] = ACTIONS(2944),
    [anon_sym_const] = ACTIONS(2944),
    [anon_sym_constexpr] = ACTIONS(2944),
    [anon_sym_volatile] = ACTIONS(2944),
    [anon_sym_restrict] = ACTIONS(2944),
    [anon_sym___restrict__] = ACTIONS(2944),
    [anon_sym__Atomic] = ACTIONS(2944),
    [anon_sym__Noreturn] = ACTIONS(2944),
    [anon_sym_noreturn] = ACTIONS(2944),
    [anon_sym_mutable] = ACTIONS(2944),
    [anon_sym_constinit] = ACTIONS(2944),
    [anon_sym_consteval] = ACTIONS(2944),
    [anon_sym_alignas] = ACTIONS(2944),
    [anon_sym__Alignas] = ACTIONS(2944),
    [anon_sym_DOT] = ACTIONS(2944),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2944),
    [anon_sym_let] = ACTIONS(2944),
    [anon_sym_This] = ACTIONS(2944),
    [anon_sym_decltype] = ACTIONS(2944),
    [sym_virtual] = ACTIONS(2944),
    [anon_sym_template] = ACTIONS(2944),
    [anon_sym_GT2] = ACTIONS(2942),
    [anon_sym_operator] = ACTIONS(2944),
    [anon_sym_precise] = ACTIONS(2944),
    [anon_sym_shared] = ACTIONS(2944),
    [anon_sym_groupshared] = ACTIONS(2944),
    [anon_sym_uniform] = ACTIONS(2944),
    [anon_sym_row_major] = ACTIONS(2944),
    [anon_sym_column_major] = ACTIONS(2944),
    [anon_sym_globallycoherent] = ACTIONS(2944),
    [anon_sym_centroid] = ACTIONS(2944),
    [anon_sym_noperspective] = ACTIONS(2944),
    [anon_sym_nointerpolation] = ACTIONS(2944),
    [anon_sym_sample] = ACTIONS(2944),
    [anon_sym_linear] = ACTIONS(2944),
    [anon_sym_snorm] = ACTIONS(2944),
    [anon_sym_unorm] = ACTIONS(2944),
    [anon_sym_point] = ACTIONS(2944),
    [anon_sym_line] = ACTIONS(2944),
    [anon_sym_triangleadj] = ACTIONS(2944),
    [anon_sym_lineadj] = ACTIONS(2944),
    [anon_sym_triangle] = ACTIONS(2944),
  },
  [2741] = {
    [sym_identifier] = ACTIONS(2742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2740),
    [anon_sym_COMMA] = ACTIONS(2740),
    [anon_sym_RPAREN] = ACTIONS(2740),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_TILDE] = ACTIONS(2740),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_COLON] = ACTIONS(2742),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym___extension__] = ACTIONS(2742),
    [anon_sym_in] = ACTIONS(2742),
    [anon_sym_out] = ACTIONS(2742),
    [anon_sym_inout] = ACTIONS(2742),
    [anon_sym_extern] = ACTIONS(2742),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym_COLON_COLON] = ACTIONS(2740),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2740),
    [anon_sym___declspec] = ACTIONS(2742),
    [anon_sym___based] = ACTIONS(2742),
    [anon_sym___cdecl] = ACTIONS(2742),
    [anon_sym___clrcall] = ACTIONS(2742),
    [anon_sym___stdcall] = ACTIONS(2742),
    [anon_sym___fastcall] = ACTIONS(2742),
    [anon_sym___thiscall] = ACTIONS(2742),
    [anon_sym___vectorcall] = ACTIONS(2742),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2742),
    [anon_sym_EQ] = ACTIONS(2740),
    [anon_sym_register] = ACTIONS(2742),
    [anon_sym_inline] = ACTIONS(2742),
    [anon_sym___inline] = ACTIONS(2742),
    [anon_sym___inline__] = ACTIONS(2742),
    [anon_sym___forceinline] = ACTIONS(2742),
    [anon_sym_thread_local] = ACTIONS(2742),
    [anon_sym___thread] = ACTIONS(2742),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_constexpr] = ACTIONS(2742),
    [anon_sym_volatile] = ACTIONS(2742),
    [anon_sym_restrict] = ACTIONS(2742),
    [anon_sym___restrict__] = ACTIONS(2742),
    [anon_sym__Atomic] = ACTIONS(2742),
    [anon_sym__Noreturn] = ACTIONS(2742),
    [anon_sym_noreturn] = ACTIONS(2742),
    [anon_sym_mutable] = ACTIONS(2742),
    [anon_sym_constinit] = ACTIONS(2742),
    [anon_sym_consteval] = ACTIONS(2742),
    [anon_sym_alignas] = ACTIONS(2742),
    [anon_sym__Alignas] = ACTIONS(2742),
    [anon_sym_DOT] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
    [anon_sym_decltype] = ACTIONS(2742),
    [sym_virtual] = ACTIONS(2742),
    [anon_sym_template] = ACTIONS(2742),
    [anon_sym_GT2] = ACTIONS(2740),
    [anon_sym_operator] = ACTIONS(2742),
    [anon_sym_precise] = ACTIONS(2742),
    [anon_sym_shared] = ACTIONS(2742),
    [anon_sym_groupshared] = ACTIONS(2742),
    [anon_sym_uniform] = ACTIONS(2742),
    [anon_sym_row_major] = ACTIONS(2742),
    [anon_sym_column_major] = ACTIONS(2742),
    [anon_sym_globallycoherent] = ACTIONS(2742),
    [anon_sym_centroid] = ACTIONS(2742),
    [anon_sym_noperspective] = ACTIONS(2742),
    [anon_sym_nointerpolation] = ACTIONS(2742),
    [anon_sym_sample] = ACTIONS(2742),
    [anon_sym_linear] = ACTIONS(2742),
    [anon_sym_snorm] = ACTIONS(2742),
    [anon_sym_unorm] = ACTIONS(2742),
    [anon_sym_point] = ACTIONS(2742),
    [anon_sym_line] = ACTIONS(2742),
    [anon_sym_triangleadj] = ACTIONS(2742),
    [anon_sym_lineadj] = ACTIONS(2742),
    [anon_sym_triangle] = ACTIONS(2742),
  },
  [2742] = {
    [sym_template_argument_list] = STATE(2686),
    [sym_identifier] = ACTIONS(2349),
    [anon_sym_LPAREN2] = ACTIONS(2347),
    [anon_sym_TILDE] = ACTIONS(2347),
    [anon_sym_STAR] = ACTIONS(2347),
    [anon_sym_AMP_AMP] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2349),
    [anon_sym_LT] = ACTIONS(6343),
    [anon_sym_COLON] = ACTIONS(2349),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym___extension__] = ACTIONS(2349),
    [anon_sym_in] = ACTIONS(2349),
    [anon_sym_out] = ACTIONS(2349),
    [anon_sym_inout] = ACTIONS(2349),
    [anon_sym_extern] = ACTIONS(2349),
    [anon_sym___attribute__] = ACTIONS(2349),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2347),
    [anon_sym___declspec] = ACTIONS(2349),
    [anon_sym___based] = ACTIONS(2349),
    [anon_sym___cdecl] = ACTIONS(2349),
    [anon_sym___clrcall] = ACTIONS(2349),
    [anon_sym___stdcall] = ACTIONS(2349),
    [anon_sym___fastcall] = ACTIONS(2349),
    [anon_sym___thiscall] = ACTIONS(2349),
    [anon_sym___vectorcall] = ACTIONS(2349),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2349),
    [anon_sym_static] = ACTIONS(2349),
    [anon_sym_register] = ACTIONS(2349),
    [anon_sym_inline] = ACTIONS(2349),
    [anon_sym___inline] = ACTIONS(2349),
    [anon_sym___inline__] = ACTIONS(2349),
    [anon_sym___forceinline] = ACTIONS(2349),
    [anon_sym_thread_local] = ACTIONS(2349),
    [anon_sym___thread] = ACTIONS(2349),
    [anon_sym_const] = ACTIONS(2349),
    [anon_sym_constexpr] = ACTIONS(2349),
    [anon_sym_volatile] = ACTIONS(2349),
    [anon_sym_restrict] = ACTIONS(2349),
    [anon_sym___restrict__] = ACTIONS(2349),
    [anon_sym__Atomic] = ACTIONS(2349),
    [anon_sym__Noreturn] = ACTIONS(2349),
    [anon_sym_noreturn] = ACTIONS(2349),
    [anon_sym_mutable] = ACTIONS(2349),
    [anon_sym_constinit] = ACTIONS(2349),
    [anon_sym_consteval] = ACTIONS(2349),
    [anon_sym_alignas] = ACTIONS(2349),
    [anon_sym__Alignas] = ACTIONS(2349),
    [anon_sym_DOT] = ACTIONS(2347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2349),
    [anon_sym_let] = ACTIONS(2349),
    [anon_sym_This] = ACTIONS(2349),
    [anon_sym_decltype] = ACTIONS(2349),
    [anon_sym_final] = ACTIONS(2349),
    [anon_sym_override] = ACTIONS(2349),
    [sym_virtual] = ACTIONS(2349),
    [anon_sym_template] = ACTIONS(2349),
    [anon_sym_operator] = ACTIONS(2349),
    [anon_sym_precise] = ACTIONS(2349),
    [anon_sym_shared] = ACTIONS(2349),
    [anon_sym_groupshared] = ACTIONS(2349),
    [anon_sym_uniform] = ACTIONS(2349),
    [anon_sym_row_major] = ACTIONS(2349),
    [anon_sym_column_major] = ACTIONS(2349),
    [anon_sym_globallycoherent] = ACTIONS(2349),
    [anon_sym_centroid] = ACTIONS(2349),
    [anon_sym_noperspective] = ACTIONS(2349),
    [anon_sym_nointerpolation] = ACTIONS(2349),
    [anon_sym_sample] = ACTIONS(2349),
    [anon_sym_linear] = ACTIONS(2349),
    [anon_sym_snorm] = ACTIONS(2349),
    [anon_sym_unorm] = ACTIONS(2349),
    [anon_sym_point] = ACTIONS(2349),
    [anon_sym_line] = ACTIONS(2349),
    [anon_sym_triangleadj] = ACTIONS(2349),
    [anon_sym_lineadj] = ACTIONS(2349),
    [anon_sym_triangle] = ACTIONS(2349),
  },
  [2743] = {
    [sym_identifier] = ACTIONS(6253),
    [anon_sym_LPAREN2] = ACTIONS(6255),
    [anon_sym_TILDE] = ACTIONS(6255),
    [anon_sym_STAR] = ACTIONS(6255),
    [anon_sym_AMP_AMP] = ACTIONS(6255),
    [anon_sym_AMP] = ACTIONS(6253),
    [anon_sym___extension__] = ACTIONS(6253),
    [anon_sym_in] = ACTIONS(6253),
    [anon_sym_out] = ACTIONS(6253),
    [anon_sym_inout] = ACTIONS(6253),
    [anon_sym_extern] = ACTIONS(6253),
    [anon_sym___attribute__] = ACTIONS(6253),
    [anon_sym_COLON_COLON] = ACTIONS(6255),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6255),
    [anon_sym___declspec] = ACTIONS(6253),
    [anon_sym___based] = ACTIONS(6253),
    [anon_sym_signed] = ACTIONS(6253),
    [anon_sym_unsigned] = ACTIONS(6253),
    [anon_sym_long] = ACTIONS(6253),
    [anon_sym_short] = ACTIONS(6253),
    [anon_sym_LBRACK] = ACTIONS(6253),
    [anon_sym_static] = ACTIONS(6253),
    [anon_sym_register] = ACTIONS(6253),
    [anon_sym_inline] = ACTIONS(6253),
    [anon_sym___inline] = ACTIONS(6253),
    [anon_sym___inline__] = ACTIONS(6253),
    [anon_sym___forceinline] = ACTIONS(6253),
    [anon_sym_thread_local] = ACTIONS(6253),
    [anon_sym___thread] = ACTIONS(6253),
    [anon_sym_const] = ACTIONS(6253),
    [anon_sym_constexpr] = ACTIONS(6253),
    [anon_sym_volatile] = ACTIONS(6253),
    [anon_sym_restrict] = ACTIONS(6253),
    [anon_sym___restrict__] = ACTIONS(6253),
    [anon_sym__Atomic] = ACTIONS(6253),
    [anon_sym__Noreturn] = ACTIONS(6253),
    [anon_sym_noreturn] = ACTIONS(6253),
    [anon_sym_mutable] = ACTIONS(6253),
    [anon_sym_constinit] = ACTIONS(6253),
    [anon_sym_consteval] = ACTIONS(6253),
    [anon_sym_alignas] = ACTIONS(6253),
    [anon_sym__Alignas] = ACTIONS(6253),
    [sym_primitive_type] = ACTIONS(6253),
    [anon_sym_enum] = ACTIONS(6253),
    [anon_sym_class] = ACTIONS(6253),
    [anon_sym_struct] = ACTIONS(6253),
    [anon_sym_union] = ACTIONS(6253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6253),
    [anon_sym_let] = ACTIONS(6253),
    [anon_sym_This] = ACTIONS(6253),
    [anon_sym_decltype] = ACTIONS(6253),
    [sym_virtual] = ACTIONS(6253),
    [anon_sym_explicit] = ACTIONS(6253),
    [anon_sym_typename] = ACTIONS(6253),
    [anon_sym_template] = ACTIONS(6253),
    [anon_sym_operator] = ACTIONS(6253),
    [anon_sym_namespace] = ACTIONS(6363),
    [anon_sym_precise] = ACTIONS(6253),
    [anon_sym_shared] = ACTIONS(6253),
    [anon_sym_groupshared] = ACTIONS(6253),
    [anon_sym_uniform] = ACTIONS(6253),
    [anon_sym_row_major] = ACTIONS(6253),
    [anon_sym_column_major] = ACTIONS(6253),
    [anon_sym_globallycoherent] = ACTIONS(6253),
    [anon_sym_centroid] = ACTIONS(6253),
    [anon_sym_noperspective] = ACTIONS(6253),
    [anon_sym_nointerpolation] = ACTIONS(6253),
    [anon_sym_sample] = ACTIONS(6253),
    [anon_sym_linear] = ACTIONS(6253),
    [anon_sym_snorm] = ACTIONS(6253),
    [anon_sym_unorm] = ACTIONS(6253),
    [anon_sym_point] = ACTIONS(6253),
    [anon_sym_line] = ACTIONS(6253),
    [anon_sym_triangleadj] = ACTIONS(6253),
    [anon_sym_lineadj] = ACTIONS(6253),
    [anon_sym_triangle] = ACTIONS(6253),
    [anon_sym_interface] = ACTIONS(6253),
    [anon_sym_extension] = ACTIONS(6253),
  },
  [2744] = {
    [sym_identifier] = ACTIONS(6253),
    [anon_sym_LPAREN2] = ACTIONS(6255),
    [anon_sym_TILDE] = ACTIONS(6255),
    [anon_sym_STAR] = ACTIONS(6255),
    [anon_sym_AMP_AMP] = ACTIONS(6255),
    [anon_sym_AMP] = ACTIONS(6253),
    [anon_sym___extension__] = ACTIONS(6253),
    [anon_sym_in] = ACTIONS(6253),
    [anon_sym_out] = ACTIONS(6253),
    [anon_sym_inout] = ACTIONS(6253),
    [anon_sym_extern] = ACTIONS(6253),
    [anon_sym___attribute__] = ACTIONS(6253),
    [anon_sym_COLON_COLON] = ACTIONS(6255),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6255),
    [anon_sym___declspec] = ACTIONS(6253),
    [anon_sym___based] = ACTIONS(6253),
    [anon_sym_signed] = ACTIONS(6253),
    [anon_sym_unsigned] = ACTIONS(6253),
    [anon_sym_long] = ACTIONS(6253),
    [anon_sym_short] = ACTIONS(6253),
    [anon_sym_LBRACK] = ACTIONS(6253),
    [anon_sym_static] = ACTIONS(6253),
    [anon_sym_register] = ACTIONS(6253),
    [anon_sym_inline] = ACTIONS(6253),
    [anon_sym___inline] = ACTIONS(6253),
    [anon_sym___inline__] = ACTIONS(6253),
    [anon_sym___forceinline] = ACTIONS(6253),
    [anon_sym_thread_local] = ACTIONS(6253),
    [anon_sym___thread] = ACTIONS(6253),
    [anon_sym_const] = ACTIONS(6253),
    [anon_sym_constexpr] = ACTIONS(6253),
    [anon_sym_volatile] = ACTIONS(6253),
    [anon_sym_restrict] = ACTIONS(6253),
    [anon_sym___restrict__] = ACTIONS(6253),
    [anon_sym__Atomic] = ACTIONS(6253),
    [anon_sym__Noreturn] = ACTIONS(6253),
    [anon_sym_noreturn] = ACTIONS(6253),
    [anon_sym_mutable] = ACTIONS(6253),
    [anon_sym_constinit] = ACTIONS(6253),
    [anon_sym_consteval] = ACTIONS(6253),
    [anon_sym_alignas] = ACTIONS(6253),
    [anon_sym__Alignas] = ACTIONS(6253),
    [sym_primitive_type] = ACTIONS(6253),
    [anon_sym_enum] = ACTIONS(6253),
    [anon_sym_class] = ACTIONS(6253),
    [anon_sym_struct] = ACTIONS(6253),
    [anon_sym_union] = ACTIONS(6253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6253),
    [anon_sym_let] = ACTIONS(6253),
    [anon_sym_This] = ACTIONS(6253),
    [anon_sym_decltype] = ACTIONS(6253),
    [sym_virtual] = ACTIONS(6253),
    [anon_sym_explicit] = ACTIONS(6253),
    [anon_sym_typename] = ACTIONS(6253),
    [anon_sym_template] = ACTIONS(6253),
    [anon_sym_operator] = ACTIONS(6253),
    [anon_sym_namespace] = ACTIONS(6365),
    [anon_sym_precise] = ACTIONS(6253),
    [anon_sym_shared] = ACTIONS(6253),
    [anon_sym_groupshared] = ACTIONS(6253),
    [anon_sym_uniform] = ACTIONS(6253),
    [anon_sym_row_major] = ACTIONS(6253),
    [anon_sym_column_major] = ACTIONS(6253),
    [anon_sym_globallycoherent] = ACTIONS(6253),
    [anon_sym_centroid] = ACTIONS(6253),
    [anon_sym_noperspective] = ACTIONS(6253),
    [anon_sym_nointerpolation] = ACTIONS(6253),
    [anon_sym_sample] = ACTIONS(6253),
    [anon_sym_linear] = ACTIONS(6253),
    [anon_sym_snorm] = ACTIONS(6253),
    [anon_sym_unorm] = ACTIONS(6253),
    [anon_sym_point] = ACTIONS(6253),
    [anon_sym_line] = ACTIONS(6253),
    [anon_sym_triangleadj] = ACTIONS(6253),
    [anon_sym_lineadj] = ACTIONS(6253),
    [anon_sym_triangle] = ACTIONS(6253),
    [anon_sym_interface] = ACTIONS(6253),
    [anon_sym_extension] = ACTIONS(6253),
  },
  [2745] = {
    [sym_identifier] = ACTIONS(2536),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2534),
    [anon_sym_COMMA] = ACTIONS(2534),
    [anon_sym_RPAREN] = ACTIONS(2534),
    [anon_sym_LPAREN2] = ACTIONS(2534),
    [anon_sym_TILDE] = ACTIONS(2534),
    [anon_sym_STAR] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
    [anon_sym_COLON] = ACTIONS(2536),
    [anon_sym_SEMI] = ACTIONS(2534),
    [anon_sym___extension__] = ACTIONS(2536),
    [anon_sym_in] = ACTIONS(2536),
    [anon_sym_out] = ACTIONS(2536),
    [anon_sym_inout] = ACTIONS(2536),
    [anon_sym_extern] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(2534),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2534),
    [anon_sym___declspec] = ACTIONS(2536),
    [anon_sym___based] = ACTIONS(2536),
    [anon_sym___cdecl] = ACTIONS(2536),
    [anon_sym___clrcall] = ACTIONS(2536),
    [anon_sym___stdcall] = ACTIONS(2536),
    [anon_sym___fastcall] = ACTIONS(2536),
    [anon_sym___thiscall] = ACTIONS(2536),
    [anon_sym___vectorcall] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(2536),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_EQ] = ACTIONS(2534),
    [anon_sym_register] = ACTIONS(2536),
    [anon_sym_inline] = ACTIONS(2536),
    [anon_sym___inline] = ACTIONS(2536),
    [anon_sym___inline__] = ACTIONS(2536),
    [anon_sym___forceinline] = ACTIONS(2536),
    [anon_sym_thread_local] = ACTIONS(2536),
    [anon_sym___thread] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [anon_sym_DOT] = ACTIONS(2536),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2536),
    [anon_sym_let] = ACTIONS(2536),
    [anon_sym_This] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2536),
    [sym_virtual] = ACTIONS(2536),
    [anon_sym_template] = ACTIONS(2536),
    [anon_sym_GT2] = ACTIONS(2534),
    [anon_sym_operator] = ACTIONS(2536),
    [anon_sym_precise] = ACTIONS(2536),
    [anon_sym_shared] = ACTIONS(2536),
    [anon_sym_groupshared] = ACTIONS(2536),
    [anon_sym_uniform] = ACTIONS(2536),
    [anon_sym_row_major] = ACTIONS(2536),
    [anon_sym_column_major] = ACTIONS(2536),
    [anon_sym_globallycoherent] = ACTIONS(2536),
    [anon_sym_centroid] = ACTIONS(2536),
    [anon_sym_noperspective] = ACTIONS(2536),
    [anon_sym_nointerpolation] = ACTIONS(2536),
    [anon_sym_sample] = ACTIONS(2536),
    [anon_sym_linear] = ACTIONS(2536),
    [anon_sym_snorm] = ACTIONS(2536),
    [anon_sym_unorm] = ACTIONS(2536),
    [anon_sym_point] = ACTIONS(2536),
    [anon_sym_line] = ACTIONS(2536),
    [anon_sym_triangleadj] = ACTIONS(2536),
    [anon_sym_lineadj] = ACTIONS(2536),
    [anon_sym_triangle] = ACTIONS(2536),
  },
  [2746] = {
    [sym_identifier] = ACTIONS(3366),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3364),
    [anon_sym_COMMA] = ACTIONS(3364),
    [anon_sym_RPAREN] = ACTIONS(3364),
    [anon_sym_LPAREN2] = ACTIONS(3364),
    [anon_sym_TILDE] = ACTIONS(3364),
    [anon_sym_STAR] = ACTIONS(3364),
    [anon_sym_AMP_AMP] = ACTIONS(3364),
    [anon_sym_AMP] = ACTIONS(3366),
    [anon_sym_COLON] = ACTIONS(3366),
    [anon_sym_SEMI] = ACTIONS(3364),
    [anon_sym___extension__] = ACTIONS(3366),
    [anon_sym_in] = ACTIONS(3366),
    [anon_sym_out] = ACTIONS(3366),
    [anon_sym_inout] = ACTIONS(3366),
    [anon_sym_extern] = ACTIONS(3366),
    [anon_sym___attribute__] = ACTIONS(3366),
    [anon_sym_COLON_COLON] = ACTIONS(3364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3364),
    [anon_sym___declspec] = ACTIONS(3366),
    [anon_sym___based] = ACTIONS(3366),
    [anon_sym___cdecl] = ACTIONS(3366),
    [anon_sym___clrcall] = ACTIONS(3366),
    [anon_sym___stdcall] = ACTIONS(3366),
    [anon_sym___fastcall] = ACTIONS(3366),
    [anon_sym___thiscall] = ACTIONS(3366),
    [anon_sym___vectorcall] = ACTIONS(3366),
    [anon_sym_LBRACK] = ACTIONS(3366),
    [anon_sym_static] = ACTIONS(3366),
    [anon_sym_EQ] = ACTIONS(3364),
    [anon_sym_register] = ACTIONS(3366),
    [anon_sym_inline] = ACTIONS(3366),
    [anon_sym___inline] = ACTIONS(3366),
    [anon_sym___inline__] = ACTIONS(3366),
    [anon_sym___forceinline] = ACTIONS(3366),
    [anon_sym_thread_local] = ACTIONS(3366),
    [anon_sym___thread] = ACTIONS(3366),
    [anon_sym_const] = ACTIONS(3366),
    [anon_sym_constexpr] = ACTIONS(3366),
    [anon_sym_volatile] = ACTIONS(3366),
    [anon_sym_restrict] = ACTIONS(3366),
    [anon_sym___restrict__] = ACTIONS(3366),
    [anon_sym__Atomic] = ACTIONS(3366),
    [anon_sym__Noreturn] = ACTIONS(3366),
    [anon_sym_noreturn] = ACTIONS(3366),
    [anon_sym_mutable] = ACTIONS(3366),
    [anon_sym_constinit] = ACTIONS(3366),
    [anon_sym_consteval] = ACTIONS(3366),
    [anon_sym_alignas] = ACTIONS(3366),
    [anon_sym__Alignas] = ACTIONS(3366),
    [anon_sym_DOT] = ACTIONS(3366),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3366),
    [anon_sym_let] = ACTIONS(3366),
    [anon_sym_This] = ACTIONS(3366),
    [anon_sym_decltype] = ACTIONS(3366),
    [sym_virtual] = ACTIONS(3366),
    [anon_sym_template] = ACTIONS(3366),
    [anon_sym_GT2] = ACTIONS(3364),
    [anon_sym_operator] = ACTIONS(3366),
    [anon_sym_precise] = ACTIONS(3366),
    [anon_sym_shared] = ACTIONS(3366),
    [anon_sym_groupshared] = ACTIONS(3366),
    [anon_sym_uniform] = ACTIONS(3366),
    [anon_sym_row_major] = ACTIONS(3366),
    [anon_sym_column_major] = ACTIONS(3366),
    [anon_sym_globallycoherent] = ACTIONS(3366),
    [anon_sym_centroid] = ACTIONS(3366),
    [anon_sym_noperspective] = ACTIONS(3366),
    [anon_sym_nointerpolation] = ACTIONS(3366),
    [anon_sym_sample] = ACTIONS(3366),
    [anon_sym_linear] = ACTIONS(3366),
    [anon_sym_snorm] = ACTIONS(3366),
    [anon_sym_unorm] = ACTIONS(3366),
    [anon_sym_point] = ACTIONS(3366),
    [anon_sym_line] = ACTIONS(3366),
    [anon_sym_triangleadj] = ACTIONS(3366),
    [anon_sym_lineadj] = ACTIONS(3366),
    [anon_sym_triangle] = ACTIONS(3366),
  },
  [2747] = {
    [sym_identifier] = ACTIONS(6132),
    [anon_sym_LPAREN2] = ACTIONS(6134),
    [anon_sym_TILDE] = ACTIONS(6134),
    [anon_sym_STAR] = ACTIONS(6134),
    [anon_sym_AMP_AMP] = ACTIONS(6134),
    [anon_sym_AMP] = ACTIONS(6132),
    [anon_sym___extension__] = ACTIONS(6132),
    [anon_sym_typedef] = ACTIONS(6367),
    [anon_sym_in] = ACTIONS(6132),
    [anon_sym_out] = ACTIONS(6132),
    [anon_sym_inout] = ACTIONS(6132),
    [anon_sym_extern] = ACTIONS(6132),
    [anon_sym___attribute__] = ACTIONS(6132),
    [anon_sym_COLON_COLON] = ACTIONS(6134),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6134),
    [anon_sym___declspec] = ACTIONS(6132),
    [anon_sym___based] = ACTIONS(6132),
    [anon_sym_signed] = ACTIONS(6132),
    [anon_sym_unsigned] = ACTIONS(6132),
    [anon_sym_long] = ACTIONS(6132),
    [anon_sym_short] = ACTIONS(6132),
    [anon_sym_LBRACK] = ACTIONS(6132),
    [anon_sym_static] = ACTIONS(6132),
    [anon_sym_register] = ACTIONS(6132),
    [anon_sym_inline] = ACTIONS(6132),
    [anon_sym___inline] = ACTIONS(6132),
    [anon_sym___inline__] = ACTIONS(6132),
    [anon_sym___forceinline] = ACTIONS(6132),
    [anon_sym_thread_local] = ACTIONS(6132),
    [anon_sym___thread] = ACTIONS(6132),
    [anon_sym_const] = ACTIONS(6132),
    [anon_sym_constexpr] = ACTIONS(6132),
    [anon_sym_volatile] = ACTIONS(6132),
    [anon_sym_restrict] = ACTIONS(6132),
    [anon_sym___restrict__] = ACTIONS(6132),
    [anon_sym__Atomic] = ACTIONS(6132),
    [anon_sym__Noreturn] = ACTIONS(6132),
    [anon_sym_noreturn] = ACTIONS(6132),
    [anon_sym_mutable] = ACTIONS(6132),
    [anon_sym_constinit] = ACTIONS(6132),
    [anon_sym_consteval] = ACTIONS(6132),
    [anon_sym_alignas] = ACTIONS(6132),
    [anon_sym__Alignas] = ACTIONS(6132),
    [sym_primitive_type] = ACTIONS(6132),
    [anon_sym_enum] = ACTIONS(6132),
    [anon_sym_class] = ACTIONS(6132),
    [anon_sym_struct] = ACTIONS(6132),
    [anon_sym_union] = ACTIONS(6132),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6132),
    [anon_sym_let] = ACTIONS(6132),
    [anon_sym_This] = ACTIONS(6132),
    [anon_sym_decltype] = ACTIONS(6132),
    [sym_virtual] = ACTIONS(6132),
    [anon_sym_explicit] = ACTIONS(6132),
    [anon_sym_typename] = ACTIONS(6132),
    [anon_sym_template] = ACTIONS(6132),
    [anon_sym_operator] = ACTIONS(6132),
    [anon_sym_precise] = ACTIONS(6132),
    [anon_sym_shared] = ACTIONS(6132),
    [anon_sym_groupshared] = ACTIONS(6132),
    [anon_sym_uniform] = ACTIONS(6132),
    [anon_sym_row_major] = ACTIONS(6132),
    [anon_sym_column_major] = ACTIONS(6132),
    [anon_sym_globallycoherent] = ACTIONS(6132),
    [anon_sym_centroid] = ACTIONS(6132),
    [anon_sym_noperspective] = ACTIONS(6132),
    [anon_sym_nointerpolation] = ACTIONS(6132),
    [anon_sym_sample] = ACTIONS(6132),
    [anon_sym_linear] = ACTIONS(6132),
    [anon_sym_snorm] = ACTIONS(6132),
    [anon_sym_unorm] = ACTIONS(6132),
    [anon_sym_point] = ACTIONS(6132),
    [anon_sym_line] = ACTIONS(6132),
    [anon_sym_triangleadj] = ACTIONS(6132),
    [anon_sym_lineadj] = ACTIONS(6132),
    [anon_sym_triangle] = ACTIONS(6132),
    [anon_sym_interface] = ACTIONS(6132),
    [anon_sym_extension] = ACTIONS(6132),
  },
  [2748] = {
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3360),
    [anon_sym_COMMA] = ACTIONS(3360),
    [anon_sym_RPAREN] = ACTIONS(3360),
    [anon_sym_LPAREN2] = ACTIONS(3360),
    [anon_sym_TILDE] = ACTIONS(3360),
    [anon_sym_STAR] = ACTIONS(3360),
    [anon_sym_AMP_AMP] = ACTIONS(3360),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_COLON] = ACTIONS(3362),
    [anon_sym_SEMI] = ACTIONS(3360),
    [anon_sym___extension__] = ACTIONS(3362),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3360),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3360),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym___based] = ACTIONS(3362),
    [anon_sym___cdecl] = ACTIONS(3362),
    [anon_sym___clrcall] = ACTIONS(3362),
    [anon_sym___stdcall] = ACTIONS(3362),
    [anon_sym___fastcall] = ACTIONS(3362),
    [anon_sym___thiscall] = ACTIONS(3362),
    [anon_sym___vectorcall] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(3362),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_EQ] = ACTIONS(3360),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [anon_sym_DOT] = ACTIONS(3362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3362),
    [sym_virtual] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3362),
    [anon_sym_GT2] = ACTIONS(3360),
    [anon_sym_operator] = ACTIONS(3362),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
  },
  [2749] = {
    [sym_identifier] = ACTIONS(3058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3056),
    [anon_sym_COMMA] = ACTIONS(3056),
    [anon_sym_RPAREN] = ACTIONS(3056),
    [anon_sym_LPAREN2] = ACTIONS(3056),
    [anon_sym_TILDE] = ACTIONS(3056),
    [anon_sym_STAR] = ACTIONS(3056),
    [anon_sym_AMP_AMP] = ACTIONS(3056),
    [anon_sym_AMP] = ACTIONS(3058),
    [anon_sym_COLON] = ACTIONS(3058),
    [anon_sym_SEMI] = ACTIONS(3056),
    [anon_sym___extension__] = ACTIONS(3058),
    [anon_sym_in] = ACTIONS(3058),
    [anon_sym_out] = ACTIONS(3058),
    [anon_sym_inout] = ACTIONS(3058),
    [anon_sym_extern] = ACTIONS(3058),
    [anon_sym___attribute__] = ACTIONS(3058),
    [anon_sym_COLON_COLON] = ACTIONS(3056),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3056),
    [anon_sym___declspec] = ACTIONS(3058),
    [anon_sym___based] = ACTIONS(3058),
    [anon_sym___cdecl] = ACTIONS(3058),
    [anon_sym___clrcall] = ACTIONS(3058),
    [anon_sym___stdcall] = ACTIONS(3058),
    [anon_sym___fastcall] = ACTIONS(3058),
    [anon_sym___thiscall] = ACTIONS(3058),
    [anon_sym___vectorcall] = ACTIONS(3058),
    [anon_sym_LBRACK] = ACTIONS(3058),
    [anon_sym_static] = ACTIONS(3058),
    [anon_sym_EQ] = ACTIONS(3056),
    [anon_sym_register] = ACTIONS(3058),
    [anon_sym_inline] = ACTIONS(3058),
    [anon_sym___inline] = ACTIONS(3058),
    [anon_sym___inline__] = ACTIONS(3058),
    [anon_sym___forceinline] = ACTIONS(3058),
    [anon_sym_thread_local] = ACTIONS(3058),
    [anon_sym___thread] = ACTIONS(3058),
    [anon_sym_const] = ACTIONS(3058),
    [anon_sym_constexpr] = ACTIONS(3058),
    [anon_sym_volatile] = ACTIONS(3058),
    [anon_sym_restrict] = ACTIONS(3058),
    [anon_sym___restrict__] = ACTIONS(3058),
    [anon_sym__Atomic] = ACTIONS(3058),
    [anon_sym__Noreturn] = ACTIONS(3058),
    [anon_sym_noreturn] = ACTIONS(3058),
    [anon_sym_mutable] = ACTIONS(3058),
    [anon_sym_constinit] = ACTIONS(3058),
    [anon_sym_consteval] = ACTIONS(3058),
    [anon_sym_alignas] = ACTIONS(3058),
    [anon_sym__Alignas] = ACTIONS(3058),
    [anon_sym_DOT] = ACTIONS(3058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3058),
    [anon_sym_let] = ACTIONS(3058),
    [anon_sym_This] = ACTIONS(3058),
    [anon_sym_decltype] = ACTIONS(3058),
    [sym_virtual] = ACTIONS(3058),
    [anon_sym_template] = ACTIONS(3058),
    [anon_sym_GT2] = ACTIONS(3056),
    [anon_sym_operator] = ACTIONS(3058),
    [anon_sym_precise] = ACTIONS(3058),
    [anon_sym_shared] = ACTIONS(3058),
    [anon_sym_groupshared] = ACTIONS(3058),
    [anon_sym_uniform] = ACTIONS(3058),
    [anon_sym_row_major] = ACTIONS(3058),
    [anon_sym_column_major] = ACTIONS(3058),
    [anon_sym_globallycoherent] = ACTIONS(3058),
    [anon_sym_centroid] = ACTIONS(3058),
    [anon_sym_noperspective] = ACTIONS(3058),
    [anon_sym_nointerpolation] = ACTIONS(3058),
    [anon_sym_sample] = ACTIONS(3058),
    [anon_sym_linear] = ACTIONS(3058),
    [anon_sym_snorm] = ACTIONS(3058),
    [anon_sym_unorm] = ACTIONS(3058),
    [anon_sym_point] = ACTIONS(3058),
    [anon_sym_line] = ACTIONS(3058),
    [anon_sym_triangleadj] = ACTIONS(3058),
    [anon_sym_lineadj] = ACTIONS(3058),
    [anon_sym_triangle] = ACTIONS(3058),
  },
  [2750] = {
    [sym_identifier] = ACTIONS(6132),
    [anon_sym_LPAREN2] = ACTIONS(6134),
    [anon_sym_TILDE] = ACTIONS(6134),
    [anon_sym_STAR] = ACTIONS(6134),
    [anon_sym_AMP_AMP] = ACTIONS(6134),
    [anon_sym_AMP] = ACTIONS(6132),
    [anon_sym___extension__] = ACTIONS(6132),
    [anon_sym_typedef] = ACTIONS(6369),
    [anon_sym_in] = ACTIONS(6132),
    [anon_sym_out] = ACTIONS(6132),
    [anon_sym_inout] = ACTIONS(6132),
    [anon_sym_extern] = ACTIONS(6132),
    [anon_sym___attribute__] = ACTIONS(6132),
    [anon_sym_COLON_COLON] = ACTIONS(6134),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6134),
    [anon_sym___declspec] = ACTIONS(6132),
    [anon_sym___based] = ACTIONS(6132),
    [anon_sym_signed] = ACTIONS(6132),
    [anon_sym_unsigned] = ACTIONS(6132),
    [anon_sym_long] = ACTIONS(6132),
    [anon_sym_short] = ACTIONS(6132),
    [anon_sym_LBRACK] = ACTIONS(6132),
    [anon_sym_static] = ACTIONS(6132),
    [anon_sym_register] = ACTIONS(6132),
    [anon_sym_inline] = ACTIONS(6132),
    [anon_sym___inline] = ACTIONS(6132),
    [anon_sym___inline__] = ACTIONS(6132),
    [anon_sym___forceinline] = ACTIONS(6132),
    [anon_sym_thread_local] = ACTIONS(6132),
    [anon_sym___thread] = ACTIONS(6132),
    [anon_sym_const] = ACTIONS(6132),
    [anon_sym_constexpr] = ACTIONS(6132),
    [anon_sym_volatile] = ACTIONS(6132),
    [anon_sym_restrict] = ACTIONS(6132),
    [anon_sym___restrict__] = ACTIONS(6132),
    [anon_sym__Atomic] = ACTIONS(6132),
    [anon_sym__Noreturn] = ACTIONS(6132),
    [anon_sym_noreturn] = ACTIONS(6132),
    [anon_sym_mutable] = ACTIONS(6132),
    [anon_sym_constinit] = ACTIONS(6132),
    [anon_sym_consteval] = ACTIONS(6132),
    [anon_sym_alignas] = ACTIONS(6132),
    [anon_sym__Alignas] = ACTIONS(6132),
    [sym_primitive_type] = ACTIONS(6132),
    [anon_sym_enum] = ACTIONS(6132),
    [anon_sym_class] = ACTIONS(6132),
    [anon_sym_struct] = ACTIONS(6132),
    [anon_sym_union] = ACTIONS(6132),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6132),
    [anon_sym_let] = ACTIONS(6132),
    [anon_sym_This] = ACTIONS(6132),
    [anon_sym_decltype] = ACTIONS(6132),
    [sym_virtual] = ACTIONS(6132),
    [anon_sym_explicit] = ACTIONS(6132),
    [anon_sym_typename] = ACTIONS(6132),
    [anon_sym_template] = ACTIONS(6132),
    [anon_sym_operator] = ACTIONS(6132),
    [anon_sym_precise] = ACTIONS(6132),
    [anon_sym_shared] = ACTIONS(6132),
    [anon_sym_groupshared] = ACTIONS(6132),
    [anon_sym_uniform] = ACTIONS(6132),
    [anon_sym_row_major] = ACTIONS(6132),
    [anon_sym_column_major] = ACTIONS(6132),
    [anon_sym_globallycoherent] = ACTIONS(6132),
    [anon_sym_centroid] = ACTIONS(6132),
    [anon_sym_noperspective] = ACTIONS(6132),
    [anon_sym_nointerpolation] = ACTIONS(6132),
    [anon_sym_sample] = ACTIONS(6132),
    [anon_sym_linear] = ACTIONS(6132),
    [anon_sym_snorm] = ACTIONS(6132),
    [anon_sym_unorm] = ACTIONS(6132),
    [anon_sym_point] = ACTIONS(6132),
    [anon_sym_line] = ACTIONS(6132),
    [anon_sym_triangleadj] = ACTIONS(6132),
    [anon_sym_lineadj] = ACTIONS(6132),
    [anon_sym_triangle] = ACTIONS(6132),
    [anon_sym_interface] = ACTIONS(6132),
    [anon_sym_extension] = ACTIONS(6132),
  },
  [2751] = {
    [sym_identifier] = ACTIONS(3338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3336),
    [anon_sym_COMMA] = ACTIONS(3336),
    [anon_sym_RPAREN] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3336),
    [anon_sym_TILDE] = ACTIONS(3336),
    [anon_sym_STAR] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_AMP] = ACTIONS(3338),
    [anon_sym_COLON] = ACTIONS(3338),
    [anon_sym_SEMI] = ACTIONS(3336),
    [anon_sym___extension__] = ACTIONS(3338),
    [anon_sym_in] = ACTIONS(3338),
    [anon_sym_out] = ACTIONS(3338),
    [anon_sym_inout] = ACTIONS(3338),
    [anon_sym_extern] = ACTIONS(3338),
    [anon_sym___attribute__] = ACTIONS(3338),
    [anon_sym_COLON_COLON] = ACTIONS(3336),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3336),
    [anon_sym___declspec] = ACTIONS(3338),
    [anon_sym___based] = ACTIONS(3338),
    [anon_sym___cdecl] = ACTIONS(3338),
    [anon_sym___clrcall] = ACTIONS(3338),
    [anon_sym___stdcall] = ACTIONS(3338),
    [anon_sym___fastcall] = ACTIONS(3338),
    [anon_sym___thiscall] = ACTIONS(3338),
    [anon_sym___vectorcall] = ACTIONS(3338),
    [anon_sym_LBRACK] = ACTIONS(3338),
    [anon_sym_static] = ACTIONS(3338),
    [anon_sym_EQ] = ACTIONS(3336),
    [anon_sym_register] = ACTIONS(3338),
    [anon_sym_inline] = ACTIONS(3338),
    [anon_sym___inline] = ACTIONS(3338),
    [anon_sym___inline__] = ACTIONS(3338),
    [anon_sym___forceinline] = ACTIONS(3338),
    [anon_sym_thread_local] = ACTIONS(3338),
    [anon_sym___thread] = ACTIONS(3338),
    [anon_sym_const] = ACTIONS(3338),
    [anon_sym_constexpr] = ACTIONS(3338),
    [anon_sym_volatile] = ACTIONS(3338),
    [anon_sym_restrict] = ACTIONS(3338),
    [anon_sym___restrict__] = ACTIONS(3338),
    [anon_sym__Atomic] = ACTIONS(3338),
    [anon_sym__Noreturn] = ACTIONS(3338),
    [anon_sym_noreturn] = ACTIONS(3338),
    [anon_sym_mutable] = ACTIONS(3338),
    [anon_sym_constinit] = ACTIONS(3338),
    [anon_sym_consteval] = ACTIONS(3338),
    [anon_sym_alignas] = ACTIONS(3338),
    [anon_sym__Alignas] = ACTIONS(3338),
    [anon_sym_DOT] = ACTIONS(3338),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3338),
    [anon_sym_let] = ACTIONS(3338),
    [anon_sym_This] = ACTIONS(3338),
    [anon_sym_decltype] = ACTIONS(3338),
    [sym_virtual] = ACTIONS(3338),
    [anon_sym_template] = ACTIONS(3338),
    [anon_sym_GT2] = ACTIONS(3336),
    [anon_sym_operator] = ACTIONS(3338),
    [anon_sym_precise] = ACTIONS(3338),
    [anon_sym_shared] = ACTIONS(3338),
    [anon_sym_groupshared] = ACTIONS(3338),
    [anon_sym_uniform] = ACTIONS(3338),
    [anon_sym_row_major] = ACTIONS(3338),
    [anon_sym_column_major] = ACTIONS(3338),
    [anon_sym_globallycoherent] = ACTIONS(3338),
    [anon_sym_centroid] = ACTIONS(3338),
    [anon_sym_noperspective] = ACTIONS(3338),
    [anon_sym_nointerpolation] = ACTIONS(3338),
    [anon_sym_sample] = ACTIONS(3338),
    [anon_sym_linear] = ACTIONS(3338),
    [anon_sym_snorm] = ACTIONS(3338),
    [anon_sym_unorm] = ACTIONS(3338),
    [anon_sym_point] = ACTIONS(3338),
    [anon_sym_line] = ACTIONS(3338),
    [anon_sym_triangleadj] = ACTIONS(3338),
    [anon_sym_lineadj] = ACTIONS(3338),
    [anon_sym_triangle] = ACTIONS(3338),
  },
  [2752] = {
    [sym_template_argument_list] = STATE(2686),
    [sym_identifier] = ACTIONS(2169),
    [anon_sym_LPAREN2] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_STAR] = ACTIONS(2176),
    [anon_sym_AMP_AMP] = ACTIONS(2176),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(6343),
    [anon_sym_COLON] = ACTIONS(2169),
    [anon_sym_SEMI] = ACTIONS(2176),
    [anon_sym___extension__] = ACTIONS(2169),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_out] = ACTIONS(2169),
    [anon_sym_inout] = ACTIONS(2169),
    [anon_sym_extern] = ACTIONS(2169),
    [anon_sym___attribute__] = ACTIONS(2169),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2176),
    [anon_sym___declspec] = ACTIONS(2169),
    [anon_sym___based] = ACTIONS(2169),
    [anon_sym___cdecl] = ACTIONS(2169),
    [anon_sym___clrcall] = ACTIONS(2169),
    [anon_sym___stdcall] = ACTIONS(2169),
    [anon_sym___fastcall] = ACTIONS(2169),
    [anon_sym___thiscall] = ACTIONS(2169),
    [anon_sym___vectorcall] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2176),
    [anon_sym_LBRACK] = ACTIONS(2169),
    [anon_sym_static] = ACTIONS(2169),
    [anon_sym_register] = ACTIONS(2169),
    [anon_sym_inline] = ACTIONS(2169),
    [anon_sym___inline] = ACTIONS(2169),
    [anon_sym___inline__] = ACTIONS(2169),
    [anon_sym___forceinline] = ACTIONS(2169),
    [anon_sym_thread_local] = ACTIONS(2169),
    [anon_sym___thread] = ACTIONS(2169),
    [anon_sym_const] = ACTIONS(2169),
    [anon_sym_constexpr] = ACTIONS(2169),
    [anon_sym_volatile] = ACTIONS(2169),
    [anon_sym_restrict] = ACTIONS(2169),
    [anon_sym___restrict__] = ACTIONS(2169),
    [anon_sym__Atomic] = ACTIONS(2169),
    [anon_sym__Noreturn] = ACTIONS(2169),
    [anon_sym_noreturn] = ACTIONS(2169),
    [anon_sym_mutable] = ACTIONS(2169),
    [anon_sym_constinit] = ACTIONS(2169),
    [anon_sym_consteval] = ACTIONS(2169),
    [anon_sym_alignas] = ACTIONS(2169),
    [anon_sym__Alignas] = ACTIONS(2169),
    [anon_sym_DOT] = ACTIONS(2176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2169),
    [anon_sym_let] = ACTIONS(2169),
    [anon_sym_This] = ACTIONS(2169),
    [anon_sym_decltype] = ACTIONS(2169),
    [anon_sym_final] = ACTIONS(2169),
    [anon_sym_override] = ACTIONS(2169),
    [sym_virtual] = ACTIONS(2169),
    [anon_sym_template] = ACTIONS(2169),
    [anon_sym_operator] = ACTIONS(2169),
    [anon_sym_precise] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_groupshared] = ACTIONS(2169),
    [anon_sym_uniform] = ACTIONS(2169),
    [anon_sym_row_major] = ACTIONS(2169),
    [anon_sym_column_major] = ACTIONS(2169),
    [anon_sym_globallycoherent] = ACTIONS(2169),
    [anon_sym_centroid] = ACTIONS(2169),
    [anon_sym_noperspective] = ACTIONS(2169),
    [anon_sym_nointerpolation] = ACTIONS(2169),
    [anon_sym_sample] = ACTIONS(2169),
    [anon_sym_linear] = ACTIONS(2169),
    [anon_sym_snorm] = ACTIONS(2169),
    [anon_sym_unorm] = ACTIONS(2169),
    [anon_sym_point] = ACTIONS(2169),
    [anon_sym_line] = ACTIONS(2169),
    [anon_sym_triangleadj] = ACTIONS(2169),
    [anon_sym_lineadj] = ACTIONS(2169),
    [anon_sym_triangle] = ACTIONS(2169),
  },
  [2753] = {
    [sym_identifier] = ACTIONS(2988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2986),
    [anon_sym_COMMA] = ACTIONS(2986),
    [anon_sym_RPAREN] = ACTIONS(2986),
    [anon_sym_LPAREN2] = ACTIONS(2986),
    [anon_sym_TILDE] = ACTIONS(2986),
    [anon_sym_STAR] = ACTIONS(2986),
    [anon_sym_AMP_AMP] = ACTIONS(2986),
    [anon_sym_AMP] = ACTIONS(2988),
    [anon_sym_COLON] = ACTIONS(2988),
    [anon_sym_SEMI] = ACTIONS(2986),
    [anon_sym___extension__] = ACTIONS(2988),
    [anon_sym_in] = ACTIONS(2988),
    [anon_sym_out] = ACTIONS(2988),
    [anon_sym_inout] = ACTIONS(2988),
    [anon_sym_extern] = ACTIONS(2988),
    [anon_sym___attribute__] = ACTIONS(2988),
    [anon_sym_COLON_COLON] = ACTIONS(2986),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2986),
    [anon_sym___declspec] = ACTIONS(2988),
    [anon_sym___based] = ACTIONS(2988),
    [anon_sym___cdecl] = ACTIONS(2988),
    [anon_sym___clrcall] = ACTIONS(2988),
    [anon_sym___stdcall] = ACTIONS(2988),
    [anon_sym___fastcall] = ACTIONS(2988),
    [anon_sym___thiscall] = ACTIONS(2988),
    [anon_sym___vectorcall] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2988),
    [anon_sym_static] = ACTIONS(2988),
    [anon_sym_EQ] = ACTIONS(2986),
    [anon_sym_register] = ACTIONS(2988),
    [anon_sym_inline] = ACTIONS(2988),
    [anon_sym___inline] = ACTIONS(2988),
    [anon_sym___inline__] = ACTIONS(2988),
    [anon_sym___forceinline] = ACTIONS(2988),
    [anon_sym_thread_local] = ACTIONS(2988),
    [anon_sym___thread] = ACTIONS(2988),
    [anon_sym_const] = ACTIONS(2988),
    [anon_sym_constexpr] = ACTIONS(2988),
    [anon_sym_volatile] = ACTIONS(2988),
    [anon_sym_restrict] = ACTIONS(2988),
    [anon_sym___restrict__] = ACTIONS(2988),
    [anon_sym__Atomic] = ACTIONS(2988),
    [anon_sym__Noreturn] = ACTIONS(2988),
    [anon_sym_noreturn] = ACTIONS(2988),
    [anon_sym_mutable] = ACTIONS(2988),
    [anon_sym_constinit] = ACTIONS(2988),
    [anon_sym_consteval] = ACTIONS(2988),
    [anon_sym_alignas] = ACTIONS(2988),
    [anon_sym__Alignas] = ACTIONS(2988),
    [anon_sym_DOT] = ACTIONS(2988),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2988),
    [anon_sym_let] = ACTIONS(2988),
    [anon_sym_This] = ACTIONS(2988),
    [anon_sym_decltype] = ACTIONS(2988),
    [sym_virtual] = ACTIONS(2988),
    [anon_sym_template] = ACTIONS(2988),
    [anon_sym_GT2] = ACTIONS(2986),
    [anon_sym_operator] = ACTIONS(2988),
    [anon_sym_precise] = ACTIONS(2988),
    [anon_sym_shared] = ACTIONS(2988),
    [anon_sym_groupshared] = ACTIONS(2988),
    [anon_sym_uniform] = ACTIONS(2988),
    [anon_sym_row_major] = ACTIONS(2988),
    [anon_sym_column_major] = ACTIONS(2988),
    [anon_sym_globallycoherent] = ACTIONS(2988),
    [anon_sym_centroid] = ACTIONS(2988),
    [anon_sym_noperspective] = ACTIONS(2988),
    [anon_sym_nointerpolation] = ACTIONS(2988),
    [anon_sym_sample] = ACTIONS(2988),
    [anon_sym_linear] = ACTIONS(2988),
    [anon_sym_snorm] = ACTIONS(2988),
    [anon_sym_unorm] = ACTIONS(2988),
    [anon_sym_point] = ACTIONS(2988),
    [anon_sym_line] = ACTIONS(2988),
    [anon_sym_triangleadj] = ACTIONS(2988),
    [anon_sym_lineadj] = ACTIONS(2988),
    [anon_sym_triangle] = ACTIONS(2988),
  },
  [2754] = {
    [sym_identifier] = ACTIONS(6371),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6373),
    [anon_sym_COMMA] = ACTIONS(6373),
    [anon_sym_RPAREN] = ACTIONS(6373),
    [anon_sym_LPAREN2] = ACTIONS(6373),
    [anon_sym_TILDE] = ACTIONS(6373),
    [anon_sym_STAR] = ACTIONS(6373),
    [anon_sym_AMP_AMP] = ACTIONS(6373),
    [anon_sym_AMP] = ACTIONS(6371),
    [anon_sym_COLON] = ACTIONS(6371),
    [anon_sym_SEMI] = ACTIONS(6373),
    [anon_sym___extension__] = ACTIONS(6371),
    [anon_sym_in] = ACTIONS(6371),
    [anon_sym_out] = ACTIONS(6371),
    [anon_sym_inout] = ACTIONS(6371),
    [anon_sym_extern] = ACTIONS(6371),
    [anon_sym___attribute__] = ACTIONS(6371),
    [anon_sym_COLON_COLON] = ACTIONS(6373),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6373),
    [anon_sym___declspec] = ACTIONS(6371),
    [anon_sym___based] = ACTIONS(6371),
    [anon_sym___cdecl] = ACTIONS(6371),
    [anon_sym___clrcall] = ACTIONS(6371),
    [anon_sym___stdcall] = ACTIONS(6371),
    [anon_sym___fastcall] = ACTIONS(6371),
    [anon_sym___thiscall] = ACTIONS(6371),
    [anon_sym___vectorcall] = ACTIONS(6371),
    [anon_sym_LBRACE] = ACTIONS(6373),
    [anon_sym_LBRACK] = ACTIONS(6371),
    [anon_sym_static] = ACTIONS(6371),
    [anon_sym_EQ] = ACTIONS(6373),
    [anon_sym_register] = ACTIONS(6371),
    [anon_sym_inline] = ACTIONS(6371),
    [anon_sym___inline] = ACTIONS(6371),
    [anon_sym___inline__] = ACTIONS(6371),
    [anon_sym___forceinline] = ACTIONS(6371),
    [anon_sym_thread_local] = ACTIONS(6371),
    [anon_sym___thread] = ACTIONS(6371),
    [anon_sym_const] = ACTIONS(6371),
    [anon_sym_constexpr] = ACTIONS(6371),
    [anon_sym_volatile] = ACTIONS(6371),
    [anon_sym_restrict] = ACTIONS(6371),
    [anon_sym___restrict__] = ACTIONS(6371),
    [anon_sym__Atomic] = ACTIONS(6371),
    [anon_sym__Noreturn] = ACTIONS(6371),
    [anon_sym_noreturn] = ACTIONS(6371),
    [anon_sym_mutable] = ACTIONS(6371),
    [anon_sym_constinit] = ACTIONS(6371),
    [anon_sym_consteval] = ACTIONS(6371),
    [anon_sym_alignas] = ACTIONS(6371),
    [anon_sym__Alignas] = ACTIONS(6371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(6371),
    [anon_sym_final] = ACTIONS(6371),
    [anon_sym_override] = ACTIONS(6371),
    [sym_virtual] = ACTIONS(6371),
    [anon_sym_explicit] = ACTIONS(6371),
    [anon_sym_template] = ACTIONS(6371),
    [anon_sym_GT2] = ACTIONS(6373),
    [anon_sym_operator] = ACTIONS(6371),
    [anon_sym_precise] = ACTIONS(6371),
    [anon_sym_shared] = ACTIONS(6371),
    [anon_sym_groupshared] = ACTIONS(6371),
    [anon_sym_uniform] = ACTIONS(6371),
    [anon_sym_row_major] = ACTIONS(6371),
    [anon_sym_column_major] = ACTIONS(6371),
    [anon_sym_globallycoherent] = ACTIONS(6371),
    [anon_sym_centroid] = ACTIONS(6371),
    [anon_sym_noperspective] = ACTIONS(6371),
    [anon_sym_nointerpolation] = ACTIONS(6371),
    [anon_sym_sample] = ACTIONS(6371),
    [anon_sym_linear] = ACTIONS(6371),
    [anon_sym_snorm] = ACTIONS(6371),
    [anon_sym_unorm] = ACTIONS(6371),
    [anon_sym_point] = ACTIONS(6371),
    [anon_sym_line] = ACTIONS(6371),
    [anon_sym_triangleadj] = ACTIONS(6371),
    [anon_sym_lineadj] = ACTIONS(6371),
    [anon_sym_triangle] = ACTIONS(6371),
  },
  [2755] = {
    [sym_identifier] = ACTIONS(3048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3046),
    [anon_sym_COMMA] = ACTIONS(3046),
    [anon_sym_RPAREN] = ACTIONS(3046),
    [anon_sym_LPAREN2] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [anon_sym_STAR] = ACTIONS(3046),
    [anon_sym_AMP_AMP] = ACTIONS(3046),
    [anon_sym_AMP] = ACTIONS(3048),
    [anon_sym_COLON] = ACTIONS(3048),
    [anon_sym_SEMI] = ACTIONS(3046),
    [anon_sym___extension__] = ACTIONS(3048),
    [anon_sym_in] = ACTIONS(3048),
    [anon_sym_out] = ACTIONS(3048),
    [anon_sym_inout] = ACTIONS(3048),
    [anon_sym_extern] = ACTIONS(3048),
    [anon_sym___attribute__] = ACTIONS(3048),
    [anon_sym_COLON_COLON] = ACTIONS(3046),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3046),
    [anon_sym___declspec] = ACTIONS(3048),
    [anon_sym___based] = ACTIONS(3048),
    [anon_sym___cdecl] = ACTIONS(3048),
    [anon_sym___clrcall] = ACTIONS(3048),
    [anon_sym___stdcall] = ACTIONS(3048),
    [anon_sym___fastcall] = ACTIONS(3048),
    [anon_sym___thiscall] = ACTIONS(3048),
    [anon_sym___vectorcall] = ACTIONS(3048),
    [anon_sym_LBRACK] = ACTIONS(3048),
    [anon_sym_static] = ACTIONS(3048),
    [anon_sym_EQ] = ACTIONS(3046),
    [anon_sym_register] = ACTIONS(3048),
    [anon_sym_inline] = ACTIONS(3048),
    [anon_sym___inline] = ACTIONS(3048),
    [anon_sym___inline__] = ACTIONS(3048),
    [anon_sym___forceinline] = ACTIONS(3048),
    [anon_sym_thread_local] = ACTIONS(3048),
    [anon_sym___thread] = ACTIONS(3048),
    [anon_sym_const] = ACTIONS(3048),
    [anon_sym_constexpr] = ACTIONS(3048),
    [anon_sym_volatile] = ACTIONS(3048),
    [anon_sym_restrict] = ACTIONS(3048),
    [anon_sym___restrict__] = ACTIONS(3048),
    [anon_sym__Atomic] = ACTIONS(3048),
    [anon_sym__Noreturn] = ACTIONS(3048),
    [anon_sym_noreturn] = ACTIONS(3048),
    [anon_sym_mutable] = ACTIONS(3048),
    [anon_sym_constinit] = ACTIONS(3048),
    [anon_sym_consteval] = ACTIONS(3048),
    [anon_sym_alignas] = ACTIONS(3048),
    [anon_sym__Alignas] = ACTIONS(3048),
    [anon_sym_DOT] = ACTIONS(3048),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3048),
    [anon_sym_let] = ACTIONS(3048),
    [anon_sym_This] = ACTIONS(3048),
    [anon_sym_decltype] = ACTIONS(3048),
    [sym_virtual] = ACTIONS(3048),
    [anon_sym_template] = ACTIONS(3048),
    [anon_sym_GT2] = ACTIONS(3046),
    [anon_sym_operator] = ACTIONS(3048),
    [anon_sym_precise] = ACTIONS(3048),
    [anon_sym_shared] = ACTIONS(3048),
    [anon_sym_groupshared] = ACTIONS(3048),
    [anon_sym_uniform] = ACTIONS(3048),
    [anon_sym_row_major] = ACTIONS(3048),
    [anon_sym_column_major] = ACTIONS(3048),
    [anon_sym_globallycoherent] = ACTIONS(3048),
    [anon_sym_centroid] = ACTIONS(3048),
    [anon_sym_noperspective] = ACTIONS(3048),
    [anon_sym_nointerpolation] = ACTIONS(3048),
    [anon_sym_sample] = ACTIONS(3048),
    [anon_sym_linear] = ACTIONS(3048),
    [anon_sym_snorm] = ACTIONS(3048),
    [anon_sym_unorm] = ACTIONS(3048),
    [anon_sym_point] = ACTIONS(3048),
    [anon_sym_line] = ACTIONS(3048),
    [anon_sym_triangleadj] = ACTIONS(3048),
    [anon_sym_lineadj] = ACTIONS(3048),
    [anon_sym_triangle] = ACTIONS(3048),
  },
  [2756] = {
    [sym_identifier] = ACTIONS(3098),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3096),
    [anon_sym_COMMA] = ACTIONS(3096),
    [anon_sym_RPAREN] = ACTIONS(3096),
    [anon_sym_LPAREN2] = ACTIONS(3096),
    [anon_sym_TILDE] = ACTIONS(3096),
    [anon_sym_STAR] = ACTIONS(3096),
    [anon_sym_AMP_AMP] = ACTIONS(3096),
    [anon_sym_AMP] = ACTIONS(3098),
    [anon_sym_COLON] = ACTIONS(3098),
    [anon_sym_SEMI] = ACTIONS(3096),
    [anon_sym___extension__] = ACTIONS(3098),
    [anon_sym_in] = ACTIONS(3098),
    [anon_sym_out] = ACTIONS(3098),
    [anon_sym_inout] = ACTIONS(3098),
    [anon_sym_extern] = ACTIONS(3098),
    [anon_sym___attribute__] = ACTIONS(3098),
    [anon_sym_COLON_COLON] = ACTIONS(3096),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3096),
    [anon_sym___declspec] = ACTIONS(3098),
    [anon_sym___based] = ACTIONS(3098),
    [anon_sym___cdecl] = ACTIONS(3098),
    [anon_sym___clrcall] = ACTIONS(3098),
    [anon_sym___stdcall] = ACTIONS(3098),
    [anon_sym___fastcall] = ACTIONS(3098),
    [anon_sym___thiscall] = ACTIONS(3098),
    [anon_sym___vectorcall] = ACTIONS(3098),
    [anon_sym_LBRACK] = ACTIONS(3098),
    [anon_sym_static] = ACTIONS(3098),
    [anon_sym_EQ] = ACTIONS(3096),
    [anon_sym_register] = ACTIONS(3098),
    [anon_sym_inline] = ACTIONS(3098),
    [anon_sym___inline] = ACTIONS(3098),
    [anon_sym___inline__] = ACTIONS(3098),
    [anon_sym___forceinline] = ACTIONS(3098),
    [anon_sym_thread_local] = ACTIONS(3098),
    [anon_sym___thread] = ACTIONS(3098),
    [anon_sym_const] = ACTIONS(3098),
    [anon_sym_constexpr] = ACTIONS(3098),
    [anon_sym_volatile] = ACTIONS(3098),
    [anon_sym_restrict] = ACTIONS(3098),
    [anon_sym___restrict__] = ACTIONS(3098),
    [anon_sym__Atomic] = ACTIONS(3098),
    [anon_sym__Noreturn] = ACTIONS(3098),
    [anon_sym_noreturn] = ACTIONS(3098),
    [anon_sym_mutable] = ACTIONS(3098),
    [anon_sym_constinit] = ACTIONS(3098),
    [anon_sym_consteval] = ACTIONS(3098),
    [anon_sym_alignas] = ACTIONS(3098),
    [anon_sym__Alignas] = ACTIONS(3098),
    [anon_sym_DOT] = ACTIONS(3098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3098),
    [anon_sym_let] = ACTIONS(3098),
    [anon_sym_This] = ACTIONS(3098),
    [anon_sym_decltype] = ACTIONS(3098),
    [sym_virtual] = ACTIONS(3098),
    [anon_sym_template] = ACTIONS(3098),
    [anon_sym_GT2] = ACTIONS(3096),
    [anon_sym_operator] = ACTIONS(3098),
    [anon_sym_precise] = ACTIONS(3098),
    [anon_sym_shared] = ACTIONS(3098),
    [anon_sym_groupshared] = ACTIONS(3098),
    [anon_sym_uniform] = ACTIONS(3098),
    [anon_sym_row_major] = ACTIONS(3098),
    [anon_sym_column_major] = ACTIONS(3098),
    [anon_sym_globallycoherent] = ACTIONS(3098),
    [anon_sym_centroid] = ACTIONS(3098),
    [anon_sym_noperspective] = ACTIONS(3098),
    [anon_sym_nointerpolation] = ACTIONS(3098),
    [anon_sym_sample] = ACTIONS(3098),
    [anon_sym_linear] = ACTIONS(3098),
    [anon_sym_snorm] = ACTIONS(3098),
    [anon_sym_unorm] = ACTIONS(3098),
    [anon_sym_point] = ACTIONS(3098),
    [anon_sym_line] = ACTIONS(3098),
    [anon_sym_triangleadj] = ACTIONS(3098),
    [anon_sym_lineadj] = ACTIONS(3098),
    [anon_sym_triangle] = ACTIONS(3098),
  },
  [2757] = {
    [sym_identifier] = ACTIONS(3156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3154),
    [anon_sym_COMMA] = ACTIONS(3154),
    [anon_sym_RPAREN] = ACTIONS(3154),
    [anon_sym_LPAREN2] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3154),
    [anon_sym_STAR] = ACTIONS(3154),
    [anon_sym_AMP_AMP] = ACTIONS(3154),
    [anon_sym_AMP] = ACTIONS(3156),
    [anon_sym_COLON] = ACTIONS(3156),
    [anon_sym_SEMI] = ACTIONS(3154),
    [anon_sym___extension__] = ACTIONS(3156),
    [anon_sym_in] = ACTIONS(3156),
    [anon_sym_out] = ACTIONS(3156),
    [anon_sym_inout] = ACTIONS(3156),
    [anon_sym_extern] = ACTIONS(3156),
    [anon_sym___attribute__] = ACTIONS(3156),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3154),
    [anon_sym___declspec] = ACTIONS(3156),
    [anon_sym___based] = ACTIONS(3156),
    [anon_sym___cdecl] = ACTIONS(3156),
    [anon_sym___clrcall] = ACTIONS(3156),
    [anon_sym___stdcall] = ACTIONS(3156),
    [anon_sym___fastcall] = ACTIONS(3156),
    [anon_sym___thiscall] = ACTIONS(3156),
    [anon_sym___vectorcall] = ACTIONS(3156),
    [anon_sym_LBRACK] = ACTIONS(3156),
    [anon_sym_static] = ACTIONS(3156),
    [anon_sym_EQ] = ACTIONS(3154),
    [anon_sym_register] = ACTIONS(3156),
    [anon_sym_inline] = ACTIONS(3156),
    [anon_sym___inline] = ACTIONS(3156),
    [anon_sym___inline__] = ACTIONS(3156),
    [anon_sym___forceinline] = ACTIONS(3156),
    [anon_sym_thread_local] = ACTIONS(3156),
    [anon_sym___thread] = ACTIONS(3156),
    [anon_sym_const] = ACTIONS(3156),
    [anon_sym_constexpr] = ACTIONS(3156),
    [anon_sym_volatile] = ACTIONS(3156),
    [anon_sym_restrict] = ACTIONS(3156),
    [anon_sym___restrict__] = ACTIONS(3156),
    [anon_sym__Atomic] = ACTIONS(3156),
    [anon_sym__Noreturn] = ACTIONS(3156),
    [anon_sym_noreturn] = ACTIONS(3156),
    [anon_sym_mutable] = ACTIONS(3156),
    [anon_sym_constinit] = ACTIONS(3156),
    [anon_sym_consteval] = ACTIONS(3156),
    [anon_sym_alignas] = ACTIONS(3156),
    [anon_sym__Alignas] = ACTIONS(3156),
    [anon_sym_DOT] = ACTIONS(3156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3156),
    [anon_sym_let] = ACTIONS(3156),
    [anon_sym_This] = ACTIONS(3156),
    [anon_sym_decltype] = ACTIONS(3156),
    [sym_virtual] = ACTIONS(3156),
    [anon_sym_template] = ACTIONS(3156),
    [anon_sym_GT2] = ACTIONS(3154),
    [anon_sym_operator] = ACTIONS(3156),
    [anon_sym_precise] = ACTIONS(3156),
    [anon_sym_shared] = ACTIONS(3156),
    [anon_sym_groupshared] = ACTIONS(3156),
    [anon_sym_uniform] = ACTIONS(3156),
    [anon_sym_row_major] = ACTIONS(3156),
    [anon_sym_column_major] = ACTIONS(3156),
    [anon_sym_globallycoherent] = ACTIONS(3156),
    [anon_sym_centroid] = ACTIONS(3156),
    [anon_sym_noperspective] = ACTIONS(3156),
    [anon_sym_nointerpolation] = ACTIONS(3156),
    [anon_sym_sample] = ACTIONS(3156),
    [anon_sym_linear] = ACTIONS(3156),
    [anon_sym_snorm] = ACTIONS(3156),
    [anon_sym_unorm] = ACTIONS(3156),
    [anon_sym_point] = ACTIONS(3156),
    [anon_sym_line] = ACTIONS(3156),
    [anon_sym_triangleadj] = ACTIONS(3156),
    [anon_sym_lineadj] = ACTIONS(3156),
    [anon_sym_triangle] = ACTIONS(3156),
  },
  [2758] = {
    [sym_identifier] = ACTIONS(3172),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3170),
    [anon_sym_COMMA] = ACTIONS(3170),
    [anon_sym_RPAREN] = ACTIONS(3170),
    [anon_sym_LPAREN2] = ACTIONS(3170),
    [anon_sym_TILDE] = ACTIONS(3170),
    [anon_sym_STAR] = ACTIONS(3170),
    [anon_sym_AMP_AMP] = ACTIONS(3170),
    [anon_sym_AMP] = ACTIONS(3172),
    [anon_sym_COLON] = ACTIONS(3172),
    [anon_sym_SEMI] = ACTIONS(3170),
    [anon_sym___extension__] = ACTIONS(3172),
    [anon_sym_in] = ACTIONS(3172),
    [anon_sym_out] = ACTIONS(3172),
    [anon_sym_inout] = ACTIONS(3172),
    [anon_sym_extern] = ACTIONS(3172),
    [anon_sym___attribute__] = ACTIONS(3172),
    [anon_sym_COLON_COLON] = ACTIONS(3170),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3170),
    [anon_sym___declspec] = ACTIONS(3172),
    [anon_sym___based] = ACTIONS(3172),
    [anon_sym___cdecl] = ACTIONS(3172),
    [anon_sym___clrcall] = ACTIONS(3172),
    [anon_sym___stdcall] = ACTIONS(3172),
    [anon_sym___fastcall] = ACTIONS(3172),
    [anon_sym___thiscall] = ACTIONS(3172),
    [anon_sym___vectorcall] = ACTIONS(3172),
    [anon_sym_LBRACK] = ACTIONS(3172),
    [anon_sym_static] = ACTIONS(3172),
    [anon_sym_EQ] = ACTIONS(3170),
    [anon_sym_register] = ACTIONS(3172),
    [anon_sym_inline] = ACTIONS(3172),
    [anon_sym___inline] = ACTIONS(3172),
    [anon_sym___inline__] = ACTIONS(3172),
    [anon_sym___forceinline] = ACTIONS(3172),
    [anon_sym_thread_local] = ACTIONS(3172),
    [anon_sym___thread] = ACTIONS(3172),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_constexpr] = ACTIONS(3172),
    [anon_sym_volatile] = ACTIONS(3172),
    [anon_sym_restrict] = ACTIONS(3172),
    [anon_sym___restrict__] = ACTIONS(3172),
    [anon_sym__Atomic] = ACTIONS(3172),
    [anon_sym__Noreturn] = ACTIONS(3172),
    [anon_sym_noreturn] = ACTIONS(3172),
    [anon_sym_mutable] = ACTIONS(3172),
    [anon_sym_constinit] = ACTIONS(3172),
    [anon_sym_consteval] = ACTIONS(3172),
    [anon_sym_alignas] = ACTIONS(3172),
    [anon_sym__Alignas] = ACTIONS(3172),
    [anon_sym_DOT] = ACTIONS(3172),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3172),
    [anon_sym_let] = ACTIONS(3172),
    [anon_sym_This] = ACTIONS(3172),
    [anon_sym_decltype] = ACTIONS(3172),
    [sym_virtual] = ACTIONS(3172),
    [anon_sym_template] = ACTIONS(3172),
    [anon_sym_GT2] = ACTIONS(3170),
    [anon_sym_operator] = ACTIONS(3172),
    [anon_sym_precise] = ACTIONS(3172),
    [anon_sym_shared] = ACTIONS(3172),
    [anon_sym_groupshared] = ACTIONS(3172),
    [anon_sym_uniform] = ACTIONS(3172),
    [anon_sym_row_major] = ACTIONS(3172),
    [anon_sym_column_major] = ACTIONS(3172),
    [anon_sym_globallycoherent] = ACTIONS(3172),
    [anon_sym_centroid] = ACTIONS(3172),
    [anon_sym_noperspective] = ACTIONS(3172),
    [anon_sym_nointerpolation] = ACTIONS(3172),
    [anon_sym_sample] = ACTIONS(3172),
    [anon_sym_linear] = ACTIONS(3172),
    [anon_sym_snorm] = ACTIONS(3172),
    [anon_sym_unorm] = ACTIONS(3172),
    [anon_sym_point] = ACTIONS(3172),
    [anon_sym_line] = ACTIONS(3172),
    [anon_sym_triangleadj] = ACTIONS(3172),
    [anon_sym_lineadj] = ACTIONS(3172),
    [anon_sym_triangle] = ACTIONS(3172),
  },
  [2759] = {
    [sym_identifier] = ACTIONS(6132),
    [anon_sym_LPAREN2] = ACTIONS(6134),
    [anon_sym_TILDE] = ACTIONS(6134),
    [anon_sym_STAR] = ACTIONS(6134),
    [anon_sym_AMP_AMP] = ACTIONS(6134),
    [anon_sym_AMP] = ACTIONS(6132),
    [anon_sym___extension__] = ACTIONS(6132),
    [anon_sym_typedef] = ACTIONS(6375),
    [anon_sym_in] = ACTIONS(6132),
    [anon_sym_out] = ACTIONS(6132),
    [anon_sym_inout] = ACTIONS(6132),
    [anon_sym_extern] = ACTIONS(6132),
    [anon_sym___attribute__] = ACTIONS(6132),
    [anon_sym_COLON_COLON] = ACTIONS(6134),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6134),
    [anon_sym___declspec] = ACTIONS(6132),
    [anon_sym___based] = ACTIONS(6132),
    [anon_sym_signed] = ACTIONS(6132),
    [anon_sym_unsigned] = ACTIONS(6132),
    [anon_sym_long] = ACTIONS(6132),
    [anon_sym_short] = ACTIONS(6132),
    [anon_sym_LBRACK] = ACTIONS(6132),
    [anon_sym_static] = ACTIONS(6132),
    [anon_sym_register] = ACTIONS(6132),
    [anon_sym_inline] = ACTIONS(6132),
    [anon_sym___inline] = ACTIONS(6132),
    [anon_sym___inline__] = ACTIONS(6132),
    [anon_sym___forceinline] = ACTIONS(6132),
    [anon_sym_thread_local] = ACTIONS(6132),
    [anon_sym___thread] = ACTIONS(6132),
    [anon_sym_const] = ACTIONS(6132),
    [anon_sym_constexpr] = ACTIONS(6132),
    [anon_sym_volatile] = ACTIONS(6132),
    [anon_sym_restrict] = ACTIONS(6132),
    [anon_sym___restrict__] = ACTIONS(6132),
    [anon_sym__Atomic] = ACTIONS(6132),
    [anon_sym__Noreturn] = ACTIONS(6132),
    [anon_sym_noreturn] = ACTIONS(6132),
    [anon_sym_mutable] = ACTIONS(6132),
    [anon_sym_constinit] = ACTIONS(6132),
    [anon_sym_consteval] = ACTIONS(6132),
    [anon_sym_alignas] = ACTIONS(6132),
    [anon_sym__Alignas] = ACTIONS(6132),
    [sym_primitive_type] = ACTIONS(6132),
    [anon_sym_enum] = ACTIONS(6132),
    [anon_sym_class] = ACTIONS(6132),
    [anon_sym_struct] = ACTIONS(6132),
    [anon_sym_union] = ACTIONS(6132),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6132),
    [anon_sym_let] = ACTIONS(6132),
    [anon_sym_This] = ACTIONS(6132),
    [anon_sym_decltype] = ACTIONS(6132),
    [sym_virtual] = ACTIONS(6132),
    [anon_sym_explicit] = ACTIONS(6132),
    [anon_sym_typename] = ACTIONS(6132),
    [anon_sym_template] = ACTIONS(6132),
    [anon_sym_operator] = ACTIONS(6132),
    [anon_sym_precise] = ACTIONS(6132),
    [anon_sym_shared] = ACTIONS(6132),
    [anon_sym_groupshared] = ACTIONS(6132),
    [anon_sym_uniform] = ACTIONS(6132),
    [anon_sym_row_major] = ACTIONS(6132),
    [anon_sym_column_major] = ACTIONS(6132),
    [anon_sym_globallycoherent] = ACTIONS(6132),
    [anon_sym_centroid] = ACTIONS(6132),
    [anon_sym_noperspective] = ACTIONS(6132),
    [anon_sym_nointerpolation] = ACTIONS(6132),
    [anon_sym_sample] = ACTIONS(6132),
    [anon_sym_linear] = ACTIONS(6132),
    [anon_sym_snorm] = ACTIONS(6132),
    [anon_sym_unorm] = ACTIONS(6132),
    [anon_sym_point] = ACTIONS(6132),
    [anon_sym_line] = ACTIONS(6132),
    [anon_sym_triangleadj] = ACTIONS(6132),
    [anon_sym_lineadj] = ACTIONS(6132),
    [anon_sym_triangle] = ACTIONS(6132),
    [anon_sym_interface] = ACTIONS(6132),
    [anon_sym_extension] = ACTIONS(6132),
  },
  [2760] = {
    [sym_identifier] = ACTIONS(6253),
    [anon_sym_LPAREN2] = ACTIONS(6255),
    [anon_sym_TILDE] = ACTIONS(6255),
    [anon_sym_STAR] = ACTIONS(6255),
    [anon_sym_AMP_AMP] = ACTIONS(6255),
    [anon_sym_AMP] = ACTIONS(6253),
    [anon_sym___extension__] = ACTIONS(6253),
    [anon_sym_in] = ACTIONS(6253),
    [anon_sym_out] = ACTIONS(6253),
    [anon_sym_inout] = ACTIONS(6253),
    [anon_sym_extern] = ACTIONS(6253),
    [anon_sym___attribute__] = ACTIONS(6253),
    [anon_sym_COLON_COLON] = ACTIONS(6255),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6255),
    [anon_sym___declspec] = ACTIONS(6253),
    [anon_sym___based] = ACTIONS(6253),
    [anon_sym_signed] = ACTIONS(6253),
    [anon_sym_unsigned] = ACTIONS(6253),
    [anon_sym_long] = ACTIONS(6253),
    [anon_sym_short] = ACTIONS(6253),
    [anon_sym_LBRACK] = ACTIONS(6253),
    [anon_sym_static] = ACTIONS(6253),
    [anon_sym_register] = ACTIONS(6253),
    [anon_sym_inline] = ACTIONS(6253),
    [anon_sym___inline] = ACTIONS(6253),
    [anon_sym___inline__] = ACTIONS(6253),
    [anon_sym___forceinline] = ACTIONS(6253),
    [anon_sym_thread_local] = ACTIONS(6253),
    [anon_sym___thread] = ACTIONS(6253),
    [anon_sym_const] = ACTIONS(6253),
    [anon_sym_constexpr] = ACTIONS(6253),
    [anon_sym_volatile] = ACTIONS(6253),
    [anon_sym_restrict] = ACTIONS(6253),
    [anon_sym___restrict__] = ACTIONS(6253),
    [anon_sym__Atomic] = ACTIONS(6253),
    [anon_sym__Noreturn] = ACTIONS(6253),
    [anon_sym_noreturn] = ACTIONS(6253),
    [anon_sym_mutable] = ACTIONS(6253),
    [anon_sym_constinit] = ACTIONS(6253),
    [anon_sym_consteval] = ACTIONS(6253),
    [anon_sym_alignas] = ACTIONS(6253),
    [anon_sym__Alignas] = ACTIONS(6253),
    [sym_primitive_type] = ACTIONS(6253),
    [anon_sym_enum] = ACTIONS(6253),
    [anon_sym_class] = ACTIONS(6253),
    [anon_sym_struct] = ACTIONS(6253),
    [anon_sym_union] = ACTIONS(6253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6253),
    [anon_sym_let] = ACTIONS(6253),
    [anon_sym_This] = ACTIONS(6253),
    [anon_sym_decltype] = ACTIONS(6253),
    [sym_virtual] = ACTIONS(6253),
    [anon_sym_explicit] = ACTIONS(6253),
    [anon_sym_typename] = ACTIONS(6253),
    [anon_sym_template] = ACTIONS(6253),
    [anon_sym_operator] = ACTIONS(6253),
    [anon_sym_namespace] = ACTIONS(6377),
    [anon_sym_precise] = ACTIONS(6253),
    [anon_sym_shared] = ACTIONS(6253),
    [anon_sym_groupshared] = ACTIONS(6253),
    [anon_sym_uniform] = ACTIONS(6253),
    [anon_sym_row_major] = ACTIONS(6253),
    [anon_sym_column_major] = ACTIONS(6253),
    [anon_sym_globallycoherent] = ACTIONS(6253),
    [anon_sym_centroid] = ACTIONS(6253),
    [anon_sym_noperspective] = ACTIONS(6253),
    [anon_sym_nointerpolation] = ACTIONS(6253),
    [anon_sym_sample] = ACTIONS(6253),
    [anon_sym_linear] = ACTIONS(6253),
    [anon_sym_snorm] = ACTIONS(6253),
    [anon_sym_unorm] = ACTIONS(6253),
    [anon_sym_point] = ACTIONS(6253),
    [anon_sym_line] = ACTIONS(6253),
    [anon_sym_triangleadj] = ACTIONS(6253),
    [anon_sym_lineadj] = ACTIONS(6253),
    [anon_sym_triangle] = ACTIONS(6253),
    [anon_sym_interface] = ACTIONS(6253),
    [anon_sym_extension] = ACTIONS(6253),
  },
  [2761] = {
    [sym_identifier] = ACTIONS(2491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2489),
    [anon_sym_COMMA] = ACTIONS(2489),
    [anon_sym_RPAREN] = ACTIONS(2489),
    [anon_sym_LPAREN2] = ACTIONS(2489),
    [anon_sym_TILDE] = ACTIONS(2489),
    [anon_sym_STAR] = ACTIONS(2489),
    [anon_sym_AMP_AMP] = ACTIONS(2489),
    [anon_sym_AMP] = ACTIONS(2491),
    [anon_sym_COLON] = ACTIONS(2491),
    [anon_sym_SEMI] = ACTIONS(2489),
    [anon_sym___extension__] = ACTIONS(2491),
    [anon_sym_in] = ACTIONS(2491),
    [anon_sym_out] = ACTIONS(2491),
    [anon_sym_inout] = ACTIONS(2491),
    [anon_sym_extern] = ACTIONS(2491),
    [anon_sym___attribute__] = ACTIONS(2491),
    [anon_sym_COLON_COLON] = ACTIONS(2489),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2489),
    [anon_sym___declspec] = ACTIONS(2491),
    [anon_sym___based] = ACTIONS(2491),
    [anon_sym___cdecl] = ACTIONS(2491),
    [anon_sym___clrcall] = ACTIONS(2491),
    [anon_sym___stdcall] = ACTIONS(2491),
    [anon_sym___fastcall] = ACTIONS(2491),
    [anon_sym___thiscall] = ACTIONS(2491),
    [anon_sym___vectorcall] = ACTIONS(2491),
    [anon_sym_LBRACK] = ACTIONS(2491),
    [anon_sym_static] = ACTIONS(2491),
    [anon_sym_EQ] = ACTIONS(2489),
    [anon_sym_register] = ACTIONS(2491),
    [anon_sym_inline] = ACTIONS(2491),
    [anon_sym___inline] = ACTIONS(2491),
    [anon_sym___inline__] = ACTIONS(2491),
    [anon_sym___forceinline] = ACTIONS(2491),
    [anon_sym_thread_local] = ACTIONS(2491),
    [anon_sym___thread] = ACTIONS(2491),
    [anon_sym_const] = ACTIONS(2491),
    [anon_sym_constexpr] = ACTIONS(2491),
    [anon_sym_volatile] = ACTIONS(2491),
    [anon_sym_restrict] = ACTIONS(2491),
    [anon_sym___restrict__] = ACTIONS(2491),
    [anon_sym__Atomic] = ACTIONS(2491),
    [anon_sym__Noreturn] = ACTIONS(2491),
    [anon_sym_noreturn] = ACTIONS(2491),
    [anon_sym_mutable] = ACTIONS(2491),
    [anon_sym_constinit] = ACTIONS(2491),
    [anon_sym_consteval] = ACTIONS(2491),
    [anon_sym_alignas] = ACTIONS(2491),
    [anon_sym__Alignas] = ACTIONS(2491),
    [anon_sym_DOT] = ACTIONS(2491),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2491),
    [anon_sym_let] = ACTIONS(2491),
    [anon_sym_This] = ACTIONS(2491),
    [anon_sym_decltype] = ACTIONS(2491),
    [sym_virtual] = ACTIONS(2491),
    [anon_sym_template] = ACTIONS(2491),
    [anon_sym_GT2] = ACTIONS(2489),
    [anon_sym_operator] = ACTIONS(2491),
    [anon_sym_precise] = ACTIONS(2491),
    [anon_sym_shared] = ACTIONS(2491),
    [anon_sym_groupshared] = ACTIONS(2491),
    [anon_sym_uniform] = ACTIONS(2491),
    [anon_sym_row_major] = ACTIONS(2491),
    [anon_sym_column_major] = ACTIONS(2491),
    [anon_sym_globallycoherent] = ACTIONS(2491),
    [anon_sym_centroid] = ACTIONS(2491),
    [anon_sym_noperspective] = ACTIONS(2491),
    [anon_sym_nointerpolation] = ACTIONS(2491),
    [anon_sym_sample] = ACTIONS(2491),
    [anon_sym_linear] = ACTIONS(2491),
    [anon_sym_snorm] = ACTIONS(2491),
    [anon_sym_unorm] = ACTIONS(2491),
    [anon_sym_point] = ACTIONS(2491),
    [anon_sym_line] = ACTIONS(2491),
    [anon_sym_triangleadj] = ACTIONS(2491),
    [anon_sym_lineadj] = ACTIONS(2491),
    [anon_sym_triangle] = ACTIONS(2491),
  },
  [2762] = {
    [sym_identifier] = ACTIONS(3152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(3150),
    [anon_sym_RPAREN] = ACTIONS(3150),
    [anon_sym_LPAREN2] = ACTIONS(3150),
    [anon_sym_TILDE] = ACTIONS(3150),
    [anon_sym_STAR] = ACTIONS(3150),
    [anon_sym_AMP_AMP] = ACTIONS(3150),
    [anon_sym_AMP] = ACTIONS(3152),
    [anon_sym_COLON] = ACTIONS(3152),
    [anon_sym_SEMI] = ACTIONS(3150),
    [anon_sym___extension__] = ACTIONS(3152),
    [anon_sym_in] = ACTIONS(3152),
    [anon_sym_out] = ACTIONS(3152),
    [anon_sym_inout] = ACTIONS(3152),
    [anon_sym_extern] = ACTIONS(3152),
    [anon_sym___attribute__] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3150),
    [anon_sym___declspec] = ACTIONS(3152),
    [anon_sym___based] = ACTIONS(3152),
    [anon_sym___cdecl] = ACTIONS(3152),
    [anon_sym___clrcall] = ACTIONS(3152),
    [anon_sym___stdcall] = ACTIONS(3152),
    [anon_sym___fastcall] = ACTIONS(3152),
    [anon_sym___thiscall] = ACTIONS(3152),
    [anon_sym___vectorcall] = ACTIONS(3152),
    [anon_sym_LBRACK] = ACTIONS(3152),
    [anon_sym_static] = ACTIONS(3152),
    [anon_sym_EQ] = ACTIONS(3150),
    [anon_sym_register] = ACTIONS(3152),
    [anon_sym_inline] = ACTIONS(3152),
    [anon_sym___inline] = ACTIONS(3152),
    [anon_sym___inline__] = ACTIONS(3152),
    [anon_sym___forceinline] = ACTIONS(3152),
    [anon_sym_thread_local] = ACTIONS(3152),
    [anon_sym___thread] = ACTIONS(3152),
    [anon_sym_const] = ACTIONS(3152),
    [anon_sym_constexpr] = ACTIONS(3152),
    [anon_sym_volatile] = ACTIONS(3152),
    [anon_sym_restrict] = ACTIONS(3152),
    [anon_sym___restrict__] = ACTIONS(3152),
    [anon_sym__Atomic] = ACTIONS(3152),
    [anon_sym__Noreturn] = ACTIONS(3152),
    [anon_sym_noreturn] = ACTIONS(3152),
    [anon_sym_mutable] = ACTIONS(3152),
    [anon_sym_constinit] = ACTIONS(3152),
    [anon_sym_consteval] = ACTIONS(3152),
    [anon_sym_alignas] = ACTIONS(3152),
    [anon_sym__Alignas] = ACTIONS(3152),
    [anon_sym_DOT] = ACTIONS(3152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3152),
    [anon_sym_let] = ACTIONS(3152),
    [anon_sym_This] = ACTIONS(3152),
    [anon_sym_decltype] = ACTIONS(3152),
    [sym_virtual] = ACTIONS(3152),
    [anon_sym_template] = ACTIONS(3152),
    [anon_sym_GT2] = ACTIONS(3150),
    [anon_sym_operator] = ACTIONS(3152),
    [anon_sym_precise] = ACTIONS(3152),
    [anon_sym_shared] = ACTIONS(3152),
    [anon_sym_groupshared] = ACTIONS(3152),
    [anon_sym_uniform] = ACTIONS(3152),
    [anon_sym_row_major] = ACTIONS(3152),
    [anon_sym_column_major] = ACTIONS(3152),
    [anon_sym_globallycoherent] = ACTIONS(3152),
    [anon_sym_centroid] = ACTIONS(3152),
    [anon_sym_noperspective] = ACTIONS(3152),
    [anon_sym_nointerpolation] = ACTIONS(3152),
    [anon_sym_sample] = ACTIONS(3152),
    [anon_sym_linear] = ACTIONS(3152),
    [anon_sym_snorm] = ACTIONS(3152),
    [anon_sym_unorm] = ACTIONS(3152),
    [anon_sym_point] = ACTIONS(3152),
    [anon_sym_line] = ACTIONS(3152),
    [anon_sym_triangleadj] = ACTIONS(3152),
    [anon_sym_lineadj] = ACTIONS(3152),
    [anon_sym_triangle] = ACTIONS(3152),
  },
  [2763] = {
    [sym_identifier] = ACTIONS(3000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2998),
    [anon_sym_COMMA] = ACTIONS(2998),
    [anon_sym_RPAREN] = ACTIONS(2998),
    [anon_sym_LPAREN2] = ACTIONS(2998),
    [anon_sym_TILDE] = ACTIONS(2998),
    [anon_sym_STAR] = ACTIONS(2998),
    [anon_sym_AMP_AMP] = ACTIONS(2998),
    [anon_sym_AMP] = ACTIONS(3000),
    [anon_sym_COLON] = ACTIONS(3000),
    [anon_sym_SEMI] = ACTIONS(2998),
    [anon_sym___extension__] = ACTIONS(3000),
    [anon_sym_in] = ACTIONS(3000),
    [anon_sym_out] = ACTIONS(3000),
    [anon_sym_inout] = ACTIONS(3000),
    [anon_sym_extern] = ACTIONS(3000),
    [anon_sym___attribute__] = ACTIONS(3000),
    [anon_sym_COLON_COLON] = ACTIONS(2998),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2998),
    [anon_sym___declspec] = ACTIONS(3000),
    [anon_sym___based] = ACTIONS(3000),
    [anon_sym___cdecl] = ACTIONS(3000),
    [anon_sym___clrcall] = ACTIONS(3000),
    [anon_sym___stdcall] = ACTIONS(3000),
    [anon_sym___fastcall] = ACTIONS(3000),
    [anon_sym___thiscall] = ACTIONS(3000),
    [anon_sym___vectorcall] = ACTIONS(3000),
    [anon_sym_LBRACK] = ACTIONS(3000),
    [anon_sym_static] = ACTIONS(3000),
    [anon_sym_EQ] = ACTIONS(2998),
    [anon_sym_register] = ACTIONS(3000),
    [anon_sym_inline] = ACTIONS(3000),
    [anon_sym___inline] = ACTIONS(3000),
    [anon_sym___inline__] = ACTIONS(3000),
    [anon_sym___forceinline] = ACTIONS(3000),
    [anon_sym_thread_local] = ACTIONS(3000),
    [anon_sym___thread] = ACTIONS(3000),
    [anon_sym_const] = ACTIONS(3000),
    [anon_sym_constexpr] = ACTIONS(3000),
    [anon_sym_volatile] = ACTIONS(3000),
    [anon_sym_restrict] = ACTIONS(3000),
    [anon_sym___restrict__] = ACTIONS(3000),
    [anon_sym__Atomic] = ACTIONS(3000),
    [anon_sym__Noreturn] = ACTIONS(3000),
    [anon_sym_noreturn] = ACTIONS(3000),
    [anon_sym_mutable] = ACTIONS(3000),
    [anon_sym_constinit] = ACTIONS(3000),
    [anon_sym_consteval] = ACTIONS(3000),
    [anon_sym_alignas] = ACTIONS(3000),
    [anon_sym__Alignas] = ACTIONS(3000),
    [anon_sym_DOT] = ACTIONS(3000),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3000),
    [anon_sym_let] = ACTIONS(3000),
    [anon_sym_This] = ACTIONS(3000),
    [anon_sym_decltype] = ACTIONS(3000),
    [sym_virtual] = ACTIONS(3000),
    [anon_sym_template] = ACTIONS(3000),
    [anon_sym_GT2] = ACTIONS(2998),
    [anon_sym_operator] = ACTIONS(3000),
    [anon_sym_precise] = ACTIONS(3000),
    [anon_sym_shared] = ACTIONS(3000),
    [anon_sym_groupshared] = ACTIONS(3000),
    [anon_sym_uniform] = ACTIONS(3000),
    [anon_sym_row_major] = ACTIONS(3000),
    [anon_sym_column_major] = ACTIONS(3000),
    [anon_sym_globallycoherent] = ACTIONS(3000),
    [anon_sym_centroid] = ACTIONS(3000),
    [anon_sym_noperspective] = ACTIONS(3000),
    [anon_sym_nointerpolation] = ACTIONS(3000),
    [anon_sym_sample] = ACTIONS(3000),
    [anon_sym_linear] = ACTIONS(3000),
    [anon_sym_snorm] = ACTIONS(3000),
    [anon_sym_unorm] = ACTIONS(3000),
    [anon_sym_point] = ACTIONS(3000),
    [anon_sym_line] = ACTIONS(3000),
    [anon_sym_triangleadj] = ACTIONS(3000),
    [anon_sym_lineadj] = ACTIONS(3000),
    [anon_sym_triangle] = ACTIONS(3000),
  },
  [2764] = {
    [sym_identifier] = ACTIONS(2996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2994),
    [anon_sym_COMMA] = ACTIONS(2994),
    [anon_sym_RPAREN] = ACTIONS(2994),
    [anon_sym_LPAREN2] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [anon_sym_STAR] = ACTIONS(2994),
    [anon_sym_AMP_AMP] = ACTIONS(2994),
    [anon_sym_AMP] = ACTIONS(2996),
    [anon_sym_COLON] = ACTIONS(2996),
    [anon_sym_SEMI] = ACTIONS(2994),
    [anon_sym___extension__] = ACTIONS(2996),
    [anon_sym_in] = ACTIONS(2996),
    [anon_sym_out] = ACTIONS(2996),
    [anon_sym_inout] = ACTIONS(2996),
    [anon_sym_extern] = ACTIONS(2996),
    [anon_sym___attribute__] = ACTIONS(2996),
    [anon_sym_COLON_COLON] = ACTIONS(2994),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2994),
    [anon_sym___declspec] = ACTIONS(2996),
    [anon_sym___based] = ACTIONS(2996),
    [anon_sym___cdecl] = ACTIONS(2996),
    [anon_sym___clrcall] = ACTIONS(2996),
    [anon_sym___stdcall] = ACTIONS(2996),
    [anon_sym___fastcall] = ACTIONS(2996),
    [anon_sym___thiscall] = ACTIONS(2996),
    [anon_sym___vectorcall] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(2996),
    [anon_sym_static] = ACTIONS(2996),
    [anon_sym_EQ] = ACTIONS(2994),
    [anon_sym_register] = ACTIONS(2996),
    [anon_sym_inline] = ACTIONS(2996),
    [anon_sym___inline] = ACTIONS(2996),
    [anon_sym___inline__] = ACTIONS(2996),
    [anon_sym___forceinline] = ACTIONS(2996),
    [anon_sym_thread_local] = ACTIONS(2996),
    [anon_sym___thread] = ACTIONS(2996),
    [anon_sym_const] = ACTIONS(2996),
    [anon_sym_constexpr] = ACTIONS(2996),
    [anon_sym_volatile] = ACTIONS(2996),
    [anon_sym_restrict] = ACTIONS(2996),
    [anon_sym___restrict__] = ACTIONS(2996),
    [anon_sym__Atomic] = ACTIONS(2996),
    [anon_sym__Noreturn] = ACTIONS(2996),
    [anon_sym_noreturn] = ACTIONS(2996),
    [anon_sym_mutable] = ACTIONS(2996),
    [anon_sym_constinit] = ACTIONS(2996),
    [anon_sym_consteval] = ACTIONS(2996),
    [anon_sym_alignas] = ACTIONS(2996),
    [anon_sym__Alignas] = ACTIONS(2996),
    [anon_sym_DOT] = ACTIONS(2996),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2996),
    [anon_sym_let] = ACTIONS(2996),
    [anon_sym_This] = ACTIONS(2996),
    [anon_sym_decltype] = ACTIONS(2996),
    [sym_virtual] = ACTIONS(2996),
    [anon_sym_template] = ACTIONS(2996),
    [anon_sym_GT2] = ACTIONS(2994),
    [anon_sym_operator] = ACTIONS(2996),
    [anon_sym_precise] = ACTIONS(2996),
    [anon_sym_shared] = ACTIONS(2996),
    [anon_sym_groupshared] = ACTIONS(2996),
    [anon_sym_uniform] = ACTIONS(2996),
    [anon_sym_row_major] = ACTIONS(2996),
    [anon_sym_column_major] = ACTIONS(2996),
    [anon_sym_globallycoherent] = ACTIONS(2996),
    [anon_sym_centroid] = ACTIONS(2996),
    [anon_sym_noperspective] = ACTIONS(2996),
    [anon_sym_nointerpolation] = ACTIONS(2996),
    [anon_sym_sample] = ACTIONS(2996),
    [anon_sym_linear] = ACTIONS(2996),
    [anon_sym_snorm] = ACTIONS(2996),
    [anon_sym_unorm] = ACTIONS(2996),
    [anon_sym_point] = ACTIONS(2996),
    [anon_sym_line] = ACTIONS(2996),
    [anon_sym_triangleadj] = ACTIONS(2996),
    [anon_sym_lineadj] = ACTIONS(2996),
    [anon_sym_triangle] = ACTIONS(2996),
  },
  [2765] = {
    [sym_identifier] = ACTIONS(3206),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3204),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_RPAREN] = ACTIONS(3204),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_TILDE] = ACTIONS(3204),
    [anon_sym_STAR] = ACTIONS(3204),
    [anon_sym_AMP_AMP] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3206),
    [anon_sym_COLON] = ACTIONS(3206),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym___extension__] = ACTIONS(3206),
    [anon_sym_in] = ACTIONS(3206),
    [anon_sym_out] = ACTIONS(3206),
    [anon_sym_inout] = ACTIONS(3206),
    [anon_sym_extern] = ACTIONS(3206),
    [anon_sym___attribute__] = ACTIONS(3206),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3204),
    [anon_sym___declspec] = ACTIONS(3206),
    [anon_sym___based] = ACTIONS(3206),
    [anon_sym___cdecl] = ACTIONS(3206),
    [anon_sym___clrcall] = ACTIONS(3206),
    [anon_sym___stdcall] = ACTIONS(3206),
    [anon_sym___fastcall] = ACTIONS(3206),
    [anon_sym___thiscall] = ACTIONS(3206),
    [anon_sym___vectorcall] = ACTIONS(3206),
    [anon_sym_LBRACK] = ACTIONS(3206),
    [anon_sym_static] = ACTIONS(3206),
    [anon_sym_EQ] = ACTIONS(3204),
    [anon_sym_register] = ACTIONS(3206),
    [anon_sym_inline] = ACTIONS(3206),
    [anon_sym___inline] = ACTIONS(3206),
    [anon_sym___inline__] = ACTIONS(3206),
    [anon_sym___forceinline] = ACTIONS(3206),
    [anon_sym_thread_local] = ACTIONS(3206),
    [anon_sym___thread] = ACTIONS(3206),
    [anon_sym_const] = ACTIONS(3206),
    [anon_sym_constexpr] = ACTIONS(3206),
    [anon_sym_volatile] = ACTIONS(3206),
    [anon_sym_restrict] = ACTIONS(3206),
    [anon_sym___restrict__] = ACTIONS(3206),
    [anon_sym__Atomic] = ACTIONS(3206),
    [anon_sym__Noreturn] = ACTIONS(3206),
    [anon_sym_noreturn] = ACTIONS(3206),
    [anon_sym_mutable] = ACTIONS(3206),
    [anon_sym_constinit] = ACTIONS(3206),
    [anon_sym_consteval] = ACTIONS(3206),
    [anon_sym_alignas] = ACTIONS(3206),
    [anon_sym__Alignas] = ACTIONS(3206),
    [anon_sym_DOT] = ACTIONS(3206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3206),
    [anon_sym_let] = ACTIONS(3206),
    [anon_sym_This] = ACTIONS(3206),
    [anon_sym_decltype] = ACTIONS(3206),
    [sym_virtual] = ACTIONS(3206),
    [anon_sym_template] = ACTIONS(3206),
    [anon_sym_GT2] = ACTIONS(3204),
    [anon_sym_operator] = ACTIONS(3206),
    [anon_sym_precise] = ACTIONS(3206),
    [anon_sym_shared] = ACTIONS(3206),
    [anon_sym_groupshared] = ACTIONS(3206),
    [anon_sym_uniform] = ACTIONS(3206),
    [anon_sym_row_major] = ACTIONS(3206),
    [anon_sym_column_major] = ACTIONS(3206),
    [anon_sym_globallycoherent] = ACTIONS(3206),
    [anon_sym_centroid] = ACTIONS(3206),
    [anon_sym_noperspective] = ACTIONS(3206),
    [anon_sym_nointerpolation] = ACTIONS(3206),
    [anon_sym_sample] = ACTIONS(3206),
    [anon_sym_linear] = ACTIONS(3206),
    [anon_sym_snorm] = ACTIONS(3206),
    [anon_sym_unorm] = ACTIONS(3206),
    [anon_sym_point] = ACTIONS(3206),
    [anon_sym_line] = ACTIONS(3206),
    [anon_sym_triangleadj] = ACTIONS(3206),
    [anon_sym_lineadj] = ACTIONS(3206),
    [anon_sym_triangle] = ACTIONS(3206),
  },
  [2766] = {
    [sym_identifier] = ACTIONS(3358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3356),
    [anon_sym_COMMA] = ACTIONS(3356),
    [anon_sym_RPAREN] = ACTIONS(3356),
    [anon_sym_LPAREN2] = ACTIONS(3356),
    [anon_sym_TILDE] = ACTIONS(3356),
    [anon_sym_STAR] = ACTIONS(3356),
    [anon_sym_AMP_AMP] = ACTIONS(3356),
    [anon_sym_AMP] = ACTIONS(3358),
    [anon_sym_COLON] = ACTIONS(3358),
    [anon_sym_SEMI] = ACTIONS(3356),
    [anon_sym___extension__] = ACTIONS(3358),
    [anon_sym_in] = ACTIONS(3358),
    [anon_sym_out] = ACTIONS(3358),
    [anon_sym_inout] = ACTIONS(3358),
    [anon_sym_extern] = ACTIONS(3358),
    [anon_sym___attribute__] = ACTIONS(3358),
    [anon_sym_COLON_COLON] = ACTIONS(3356),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3356),
    [anon_sym___declspec] = ACTIONS(3358),
    [anon_sym___based] = ACTIONS(3358),
    [anon_sym___cdecl] = ACTIONS(3358),
    [anon_sym___clrcall] = ACTIONS(3358),
    [anon_sym___stdcall] = ACTIONS(3358),
    [anon_sym___fastcall] = ACTIONS(3358),
    [anon_sym___thiscall] = ACTIONS(3358),
    [anon_sym___vectorcall] = ACTIONS(3358),
    [anon_sym_LBRACK] = ACTIONS(3358),
    [anon_sym_static] = ACTIONS(3358),
    [anon_sym_EQ] = ACTIONS(3356),
    [anon_sym_register] = ACTIONS(3358),
    [anon_sym_inline] = ACTIONS(3358),
    [anon_sym___inline] = ACTIONS(3358),
    [anon_sym___inline__] = ACTIONS(3358),
    [anon_sym___forceinline] = ACTIONS(3358),
    [anon_sym_thread_local] = ACTIONS(3358),
    [anon_sym___thread] = ACTIONS(3358),
    [anon_sym_const] = ACTIONS(3358),
    [anon_sym_constexpr] = ACTIONS(3358),
    [anon_sym_volatile] = ACTIONS(3358),
    [anon_sym_restrict] = ACTIONS(3358),
    [anon_sym___restrict__] = ACTIONS(3358),
    [anon_sym__Atomic] = ACTIONS(3358),
    [anon_sym__Noreturn] = ACTIONS(3358),
    [anon_sym_noreturn] = ACTIONS(3358),
    [anon_sym_mutable] = ACTIONS(3358),
    [anon_sym_constinit] = ACTIONS(3358),
    [anon_sym_consteval] = ACTIONS(3358),
    [anon_sym_alignas] = ACTIONS(3358),
    [anon_sym__Alignas] = ACTIONS(3358),
    [anon_sym_DOT] = ACTIONS(3358),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3358),
    [anon_sym_let] = ACTIONS(3358),
    [anon_sym_This] = ACTIONS(3358),
    [anon_sym_decltype] = ACTIONS(3358),
    [sym_virtual] = ACTIONS(3358),
    [anon_sym_template] = ACTIONS(3358),
    [anon_sym_GT2] = ACTIONS(3356),
    [anon_sym_operator] = ACTIONS(3358),
    [anon_sym_precise] = ACTIONS(3358),
    [anon_sym_shared] = ACTIONS(3358),
    [anon_sym_groupshared] = ACTIONS(3358),
    [anon_sym_uniform] = ACTIONS(3358),
    [anon_sym_row_major] = ACTIONS(3358),
    [anon_sym_column_major] = ACTIONS(3358),
    [anon_sym_globallycoherent] = ACTIONS(3358),
    [anon_sym_centroid] = ACTIONS(3358),
    [anon_sym_noperspective] = ACTIONS(3358),
    [anon_sym_nointerpolation] = ACTIONS(3358),
    [anon_sym_sample] = ACTIONS(3358),
    [anon_sym_linear] = ACTIONS(3358),
    [anon_sym_snorm] = ACTIONS(3358),
    [anon_sym_unorm] = ACTIONS(3358),
    [anon_sym_point] = ACTIONS(3358),
    [anon_sym_line] = ACTIONS(3358),
    [anon_sym_triangleadj] = ACTIONS(3358),
    [anon_sym_lineadj] = ACTIONS(3358),
    [anon_sym_triangle] = ACTIONS(3358),
  },
  [2767] = {
    [sym_identifier] = ACTIONS(3396),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3394),
    [anon_sym_COMMA] = ACTIONS(3394),
    [anon_sym_RPAREN] = ACTIONS(3394),
    [anon_sym_LPAREN2] = ACTIONS(3394),
    [anon_sym_TILDE] = ACTIONS(3394),
    [anon_sym_STAR] = ACTIONS(3394),
    [anon_sym_AMP_AMP] = ACTIONS(3394),
    [anon_sym_AMP] = ACTIONS(3396),
    [anon_sym_COLON] = ACTIONS(3396),
    [anon_sym_SEMI] = ACTIONS(3394),
    [anon_sym___extension__] = ACTIONS(3396),
    [anon_sym_in] = ACTIONS(3396),
    [anon_sym_out] = ACTIONS(3396),
    [anon_sym_inout] = ACTIONS(3396),
    [anon_sym_extern] = ACTIONS(3396),
    [anon_sym___attribute__] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(3394),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3394),
    [anon_sym___declspec] = ACTIONS(3396),
    [anon_sym___based] = ACTIONS(3396),
    [anon_sym___cdecl] = ACTIONS(3396),
    [anon_sym___clrcall] = ACTIONS(3396),
    [anon_sym___stdcall] = ACTIONS(3396),
    [anon_sym___fastcall] = ACTIONS(3396),
    [anon_sym___thiscall] = ACTIONS(3396),
    [anon_sym___vectorcall] = ACTIONS(3396),
    [anon_sym_LBRACK] = ACTIONS(3396),
    [anon_sym_static] = ACTIONS(3396),
    [anon_sym_EQ] = ACTIONS(3394),
    [anon_sym_register] = ACTIONS(3396),
    [anon_sym_inline] = ACTIONS(3396),
    [anon_sym___inline] = ACTIONS(3396),
    [anon_sym___inline__] = ACTIONS(3396),
    [anon_sym___forceinline] = ACTIONS(3396),
    [anon_sym_thread_local] = ACTIONS(3396),
    [anon_sym___thread] = ACTIONS(3396),
    [anon_sym_const] = ACTIONS(3396),
    [anon_sym_constexpr] = ACTIONS(3396),
    [anon_sym_volatile] = ACTIONS(3396),
    [anon_sym_restrict] = ACTIONS(3396),
    [anon_sym___restrict__] = ACTIONS(3396),
    [anon_sym__Atomic] = ACTIONS(3396),
    [anon_sym__Noreturn] = ACTIONS(3396),
    [anon_sym_noreturn] = ACTIONS(3396),
    [anon_sym_mutable] = ACTIONS(3396),
    [anon_sym_constinit] = ACTIONS(3396),
    [anon_sym_consteval] = ACTIONS(3396),
    [anon_sym_alignas] = ACTIONS(3396),
    [anon_sym__Alignas] = ACTIONS(3396),
    [anon_sym_DOT] = ACTIONS(3396),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3396),
    [anon_sym_let] = ACTIONS(3396),
    [anon_sym_This] = ACTIONS(3396),
    [anon_sym_decltype] = ACTIONS(3396),
    [sym_virtual] = ACTIONS(3396),
    [anon_sym_template] = ACTIONS(3396),
    [anon_sym_GT2] = ACTIONS(3394),
    [anon_sym_operator] = ACTIONS(3396),
    [anon_sym_precise] = ACTIONS(3396),
    [anon_sym_shared] = ACTIONS(3396),
    [anon_sym_groupshared] = ACTIONS(3396),
    [anon_sym_uniform] = ACTIONS(3396),
    [anon_sym_row_major] = ACTIONS(3396),
    [anon_sym_column_major] = ACTIONS(3396),
    [anon_sym_globallycoherent] = ACTIONS(3396),
    [anon_sym_centroid] = ACTIONS(3396),
    [anon_sym_noperspective] = ACTIONS(3396),
    [anon_sym_nointerpolation] = ACTIONS(3396),
    [anon_sym_sample] = ACTIONS(3396),
    [anon_sym_linear] = ACTIONS(3396),
    [anon_sym_snorm] = ACTIONS(3396),
    [anon_sym_unorm] = ACTIONS(3396),
    [anon_sym_point] = ACTIONS(3396),
    [anon_sym_line] = ACTIONS(3396),
    [anon_sym_triangleadj] = ACTIONS(3396),
    [anon_sym_lineadj] = ACTIONS(3396),
    [anon_sym_triangle] = ACTIONS(3396),
  },
  [2768] = {
    [sym_identifier] = ACTIONS(3176),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3174),
    [anon_sym_COMMA] = ACTIONS(3174),
    [anon_sym_RPAREN] = ACTIONS(3174),
    [anon_sym_LPAREN2] = ACTIONS(3174),
    [anon_sym_TILDE] = ACTIONS(3174),
    [anon_sym_STAR] = ACTIONS(3174),
    [anon_sym_AMP_AMP] = ACTIONS(3174),
    [anon_sym_AMP] = ACTIONS(3176),
    [anon_sym_COLON] = ACTIONS(3176),
    [anon_sym_SEMI] = ACTIONS(3174),
    [anon_sym___extension__] = ACTIONS(3176),
    [anon_sym_in] = ACTIONS(3176),
    [anon_sym_out] = ACTIONS(3176),
    [anon_sym_inout] = ACTIONS(3176),
    [anon_sym_extern] = ACTIONS(3176),
    [anon_sym___attribute__] = ACTIONS(3176),
    [anon_sym_COLON_COLON] = ACTIONS(3174),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3174),
    [anon_sym___declspec] = ACTIONS(3176),
    [anon_sym___based] = ACTIONS(3176),
    [anon_sym___cdecl] = ACTIONS(3176),
    [anon_sym___clrcall] = ACTIONS(3176),
    [anon_sym___stdcall] = ACTIONS(3176),
    [anon_sym___fastcall] = ACTIONS(3176),
    [anon_sym___thiscall] = ACTIONS(3176),
    [anon_sym___vectorcall] = ACTIONS(3176),
    [anon_sym_LBRACK] = ACTIONS(3176),
    [anon_sym_static] = ACTIONS(3176),
    [anon_sym_EQ] = ACTIONS(3174),
    [anon_sym_register] = ACTIONS(3176),
    [anon_sym_inline] = ACTIONS(3176),
    [anon_sym___inline] = ACTIONS(3176),
    [anon_sym___inline__] = ACTIONS(3176),
    [anon_sym___forceinline] = ACTIONS(3176),
    [anon_sym_thread_local] = ACTIONS(3176),
    [anon_sym___thread] = ACTIONS(3176),
    [anon_sym_const] = ACTIONS(3176),
    [anon_sym_constexpr] = ACTIONS(3176),
    [anon_sym_volatile] = ACTIONS(3176),
    [anon_sym_restrict] = ACTIONS(3176),
    [anon_sym___restrict__] = ACTIONS(3176),
    [anon_sym__Atomic] = ACTIONS(3176),
    [anon_sym__Noreturn] = ACTIONS(3176),
    [anon_sym_noreturn] = ACTIONS(3176),
    [anon_sym_mutable] = ACTIONS(3176),
    [anon_sym_constinit] = ACTIONS(3176),
    [anon_sym_consteval] = ACTIONS(3176),
    [anon_sym_alignas] = ACTIONS(3176),
    [anon_sym__Alignas] = ACTIONS(3176),
    [anon_sym_DOT] = ACTIONS(3176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3176),
    [anon_sym_let] = ACTIONS(3176),
    [anon_sym_This] = ACTIONS(3176),
    [anon_sym_decltype] = ACTIONS(3176),
    [sym_virtual] = ACTIONS(3176),
    [anon_sym_template] = ACTIONS(3176),
    [anon_sym_GT2] = ACTIONS(3174),
    [anon_sym_operator] = ACTIONS(3176),
    [anon_sym_precise] = ACTIONS(3176),
    [anon_sym_shared] = ACTIONS(3176),
    [anon_sym_groupshared] = ACTIONS(3176),
    [anon_sym_uniform] = ACTIONS(3176),
    [anon_sym_row_major] = ACTIONS(3176),
    [anon_sym_column_major] = ACTIONS(3176),
    [anon_sym_globallycoherent] = ACTIONS(3176),
    [anon_sym_centroid] = ACTIONS(3176),
    [anon_sym_noperspective] = ACTIONS(3176),
    [anon_sym_nointerpolation] = ACTIONS(3176),
    [anon_sym_sample] = ACTIONS(3176),
    [anon_sym_linear] = ACTIONS(3176),
    [anon_sym_snorm] = ACTIONS(3176),
    [anon_sym_unorm] = ACTIONS(3176),
    [anon_sym_point] = ACTIONS(3176),
    [anon_sym_line] = ACTIONS(3176),
    [anon_sym_triangleadj] = ACTIONS(3176),
    [anon_sym_lineadj] = ACTIONS(3176),
    [anon_sym_triangle] = ACTIONS(3176),
  },
  [2769] = {
    [sym_argument_list] = STATE(4288),
    [sym_initializer_list] = STATE(4646),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2661),
    [sym_identifier] = ACTIONS(2742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2740),
    [anon_sym_COMMA] = ACTIONS(2740),
    [anon_sym_RPAREN] = ACTIONS(2740),
    [anon_sym_LPAREN2] = ACTIONS(6379),
    [anon_sym_TILDE] = ACTIONS(2740),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_COLON] = ACTIONS(2742),
    [anon_sym___extension__] = ACTIONS(2742),
    [anon_sym_in] = ACTIONS(2742),
    [anon_sym_out] = ACTIONS(2742),
    [anon_sym_inout] = ACTIONS(2742),
    [anon_sym_extern] = ACTIONS(2742),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym_COLON_COLON] = ACTIONS(2740),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2740),
    [anon_sym___declspec] = ACTIONS(2742),
    [anon_sym___based] = ACTIONS(2742),
    [anon_sym_LBRACE] = ACTIONS(4867),
    [anon_sym_signed] = ACTIONS(6251),
    [anon_sym_unsigned] = ACTIONS(6251),
    [anon_sym_long] = ACTIONS(6251),
    [anon_sym_short] = ACTIONS(6251),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2742),
    [anon_sym_EQ] = ACTIONS(2740),
    [anon_sym_register] = ACTIONS(2742),
    [anon_sym_inline] = ACTIONS(2742),
    [anon_sym___inline] = ACTIONS(2742),
    [anon_sym___inline__] = ACTIONS(2742),
    [anon_sym___forceinline] = ACTIONS(2742),
    [anon_sym_thread_local] = ACTIONS(2742),
    [anon_sym___thread] = ACTIONS(2742),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_constexpr] = ACTIONS(2742),
    [anon_sym_volatile] = ACTIONS(2742),
    [anon_sym_restrict] = ACTIONS(2742),
    [anon_sym___restrict__] = ACTIONS(2742),
    [anon_sym__Atomic] = ACTIONS(2742),
    [anon_sym__Noreturn] = ACTIONS(2742),
    [anon_sym_noreturn] = ACTIONS(2742),
    [anon_sym_mutable] = ACTIONS(2742),
    [anon_sym_constinit] = ACTIONS(2742),
    [anon_sym_consteval] = ACTIONS(2742),
    [anon_sym_alignas] = ACTIONS(2742),
    [anon_sym__Alignas] = ACTIONS(2742),
    [anon_sym_DOT] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
    [anon_sym_decltype] = ACTIONS(2742),
    [sym_virtual] = ACTIONS(2742),
    [anon_sym_template] = ACTIONS(2742),
    [anon_sym_operator] = ACTIONS(2742),
    [anon_sym_precise] = ACTIONS(2742),
    [anon_sym_shared] = ACTIONS(2742),
    [anon_sym_groupshared] = ACTIONS(2742),
    [anon_sym_uniform] = ACTIONS(2742),
    [anon_sym_row_major] = ACTIONS(2742),
    [anon_sym_column_major] = ACTIONS(2742),
    [anon_sym_globallycoherent] = ACTIONS(2742),
    [anon_sym_centroid] = ACTIONS(2742),
    [anon_sym_noperspective] = ACTIONS(2742),
    [anon_sym_nointerpolation] = ACTIONS(2742),
    [anon_sym_sample] = ACTIONS(2742),
    [anon_sym_linear] = ACTIONS(2742),
    [anon_sym_snorm] = ACTIONS(2742),
    [anon_sym_unorm] = ACTIONS(2742),
    [anon_sym_point] = ACTIONS(2742),
    [anon_sym_line] = ACTIONS(2742),
    [anon_sym_triangleadj] = ACTIONS(2742),
    [anon_sym_lineadj] = ACTIONS(2742),
    [anon_sym_triangle] = ACTIONS(2742),
  },
  [2770] = {
    [sym_identifier] = ACTIONS(3400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3398),
    [anon_sym_COMMA] = ACTIONS(3398),
    [anon_sym_RPAREN] = ACTIONS(3398),
    [anon_sym_LPAREN2] = ACTIONS(3398),
    [anon_sym_TILDE] = ACTIONS(3398),
    [anon_sym_STAR] = ACTIONS(3398),
    [anon_sym_AMP_AMP] = ACTIONS(3398),
    [anon_sym_AMP] = ACTIONS(3400),
    [anon_sym_COLON] = ACTIONS(3400),
    [anon_sym_SEMI] = ACTIONS(3398),
    [anon_sym___extension__] = ACTIONS(3400),
    [anon_sym_in] = ACTIONS(3400),
    [anon_sym_out] = ACTIONS(3400),
    [anon_sym_inout] = ACTIONS(3400),
    [anon_sym_extern] = ACTIONS(3400),
    [anon_sym___attribute__] = ACTIONS(3400),
    [anon_sym_COLON_COLON] = ACTIONS(3398),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3398),
    [anon_sym___declspec] = ACTIONS(3400),
    [anon_sym___based] = ACTIONS(3400),
    [anon_sym___cdecl] = ACTIONS(3400),
    [anon_sym___clrcall] = ACTIONS(3400),
    [anon_sym___stdcall] = ACTIONS(3400),
    [anon_sym___fastcall] = ACTIONS(3400),
    [anon_sym___thiscall] = ACTIONS(3400),
    [anon_sym___vectorcall] = ACTIONS(3400),
    [anon_sym_LBRACK] = ACTIONS(3400),
    [anon_sym_static] = ACTIONS(3400),
    [anon_sym_EQ] = ACTIONS(3398),
    [anon_sym_register] = ACTIONS(3400),
    [anon_sym_inline] = ACTIONS(3400),
    [anon_sym___inline] = ACTIONS(3400),
    [anon_sym___inline__] = ACTIONS(3400),
    [anon_sym___forceinline] = ACTIONS(3400),
    [anon_sym_thread_local] = ACTIONS(3400),
    [anon_sym___thread] = ACTIONS(3400),
    [anon_sym_const] = ACTIONS(3400),
    [anon_sym_constexpr] = ACTIONS(3400),
    [anon_sym_volatile] = ACTIONS(3400),
    [anon_sym_restrict] = ACTIONS(3400),
    [anon_sym___restrict__] = ACTIONS(3400),
    [anon_sym__Atomic] = ACTIONS(3400),
    [anon_sym__Noreturn] = ACTIONS(3400),
    [anon_sym_noreturn] = ACTIONS(3400),
    [anon_sym_mutable] = ACTIONS(3400),
    [anon_sym_constinit] = ACTIONS(3400),
    [anon_sym_consteval] = ACTIONS(3400),
    [anon_sym_alignas] = ACTIONS(3400),
    [anon_sym__Alignas] = ACTIONS(3400),
    [anon_sym_DOT] = ACTIONS(3400),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3400),
    [anon_sym_let] = ACTIONS(3400),
    [anon_sym_This] = ACTIONS(3400),
    [anon_sym_decltype] = ACTIONS(3400),
    [sym_virtual] = ACTIONS(3400),
    [anon_sym_template] = ACTIONS(3400),
    [anon_sym_GT2] = ACTIONS(3398),
    [anon_sym_operator] = ACTIONS(3400),
    [anon_sym_precise] = ACTIONS(3400),
    [anon_sym_shared] = ACTIONS(3400),
    [anon_sym_groupshared] = ACTIONS(3400),
    [anon_sym_uniform] = ACTIONS(3400),
    [anon_sym_row_major] = ACTIONS(3400),
    [anon_sym_column_major] = ACTIONS(3400),
    [anon_sym_globallycoherent] = ACTIONS(3400),
    [anon_sym_centroid] = ACTIONS(3400),
    [anon_sym_noperspective] = ACTIONS(3400),
    [anon_sym_nointerpolation] = ACTIONS(3400),
    [anon_sym_sample] = ACTIONS(3400),
    [anon_sym_linear] = ACTIONS(3400),
    [anon_sym_snorm] = ACTIONS(3400),
    [anon_sym_unorm] = ACTIONS(3400),
    [anon_sym_point] = ACTIONS(3400),
    [anon_sym_line] = ACTIONS(3400),
    [anon_sym_triangleadj] = ACTIONS(3400),
    [anon_sym_lineadj] = ACTIONS(3400),
    [anon_sym_triangle] = ACTIONS(3400),
  },
  [2771] = {
    [sym_identifier] = ACTIONS(3192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3190),
    [anon_sym_COMMA] = ACTIONS(3190),
    [anon_sym_RPAREN] = ACTIONS(3190),
    [anon_sym_LPAREN2] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_STAR] = ACTIONS(3190),
    [anon_sym_AMP_AMP] = ACTIONS(3190),
    [anon_sym_AMP] = ACTIONS(3192),
    [anon_sym_COLON] = ACTIONS(3192),
    [anon_sym_SEMI] = ACTIONS(3190),
    [anon_sym___extension__] = ACTIONS(3192),
    [anon_sym_in] = ACTIONS(3192),
    [anon_sym_out] = ACTIONS(3192),
    [anon_sym_inout] = ACTIONS(3192),
    [anon_sym_extern] = ACTIONS(3192),
    [anon_sym___attribute__] = ACTIONS(3192),
    [anon_sym_COLON_COLON] = ACTIONS(3190),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3190),
    [anon_sym___declspec] = ACTIONS(3192),
    [anon_sym___based] = ACTIONS(3192),
    [anon_sym___cdecl] = ACTIONS(3192),
    [anon_sym___clrcall] = ACTIONS(3192),
    [anon_sym___stdcall] = ACTIONS(3192),
    [anon_sym___fastcall] = ACTIONS(3192),
    [anon_sym___thiscall] = ACTIONS(3192),
    [anon_sym___vectorcall] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(3192),
    [anon_sym_static] = ACTIONS(3192),
    [anon_sym_EQ] = ACTIONS(3190),
    [anon_sym_register] = ACTIONS(3192),
    [anon_sym_inline] = ACTIONS(3192),
    [anon_sym___inline] = ACTIONS(3192),
    [anon_sym___inline__] = ACTIONS(3192),
    [anon_sym___forceinline] = ACTIONS(3192),
    [anon_sym_thread_local] = ACTIONS(3192),
    [anon_sym___thread] = ACTIONS(3192),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_constexpr] = ACTIONS(3192),
    [anon_sym_volatile] = ACTIONS(3192),
    [anon_sym_restrict] = ACTIONS(3192),
    [anon_sym___restrict__] = ACTIONS(3192),
    [anon_sym__Atomic] = ACTIONS(3192),
    [anon_sym__Noreturn] = ACTIONS(3192),
    [anon_sym_noreturn] = ACTIONS(3192),
    [anon_sym_mutable] = ACTIONS(3192),
    [anon_sym_constinit] = ACTIONS(3192),
    [anon_sym_consteval] = ACTIONS(3192),
    [anon_sym_alignas] = ACTIONS(3192),
    [anon_sym__Alignas] = ACTIONS(3192),
    [anon_sym_DOT] = ACTIONS(3192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3192),
    [anon_sym_let] = ACTIONS(3192),
    [anon_sym_This] = ACTIONS(3192),
    [anon_sym_decltype] = ACTIONS(3192),
    [sym_virtual] = ACTIONS(3192),
    [anon_sym_template] = ACTIONS(3192),
    [anon_sym_GT2] = ACTIONS(3190),
    [anon_sym_operator] = ACTIONS(3192),
    [anon_sym_precise] = ACTIONS(3192),
    [anon_sym_shared] = ACTIONS(3192),
    [anon_sym_groupshared] = ACTIONS(3192),
    [anon_sym_uniform] = ACTIONS(3192),
    [anon_sym_row_major] = ACTIONS(3192),
    [anon_sym_column_major] = ACTIONS(3192),
    [anon_sym_globallycoherent] = ACTIONS(3192),
    [anon_sym_centroid] = ACTIONS(3192),
    [anon_sym_noperspective] = ACTIONS(3192),
    [anon_sym_nointerpolation] = ACTIONS(3192),
    [anon_sym_sample] = ACTIONS(3192),
    [anon_sym_linear] = ACTIONS(3192),
    [anon_sym_snorm] = ACTIONS(3192),
    [anon_sym_unorm] = ACTIONS(3192),
    [anon_sym_point] = ACTIONS(3192),
    [anon_sym_line] = ACTIONS(3192),
    [anon_sym_triangleadj] = ACTIONS(3192),
    [anon_sym_lineadj] = ACTIONS(3192),
    [anon_sym_triangle] = ACTIONS(3192),
  },
  [2772] = {
    [sym_identifier] = ACTIONS(3404),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3402),
    [anon_sym_COMMA] = ACTIONS(3402),
    [anon_sym_RPAREN] = ACTIONS(3402),
    [anon_sym_LPAREN2] = ACTIONS(3402),
    [anon_sym_TILDE] = ACTIONS(3402),
    [anon_sym_STAR] = ACTIONS(3402),
    [anon_sym_AMP_AMP] = ACTIONS(3402),
    [anon_sym_AMP] = ACTIONS(3404),
    [anon_sym_COLON] = ACTIONS(3404),
    [anon_sym_SEMI] = ACTIONS(3402),
    [anon_sym___extension__] = ACTIONS(3404),
    [anon_sym_in] = ACTIONS(3404),
    [anon_sym_out] = ACTIONS(3404),
    [anon_sym_inout] = ACTIONS(3404),
    [anon_sym_extern] = ACTIONS(3404),
    [anon_sym___attribute__] = ACTIONS(3404),
    [anon_sym_COLON_COLON] = ACTIONS(3402),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3402),
    [anon_sym___declspec] = ACTIONS(3404),
    [anon_sym___based] = ACTIONS(3404),
    [anon_sym___cdecl] = ACTIONS(3404),
    [anon_sym___clrcall] = ACTIONS(3404),
    [anon_sym___stdcall] = ACTIONS(3404),
    [anon_sym___fastcall] = ACTIONS(3404),
    [anon_sym___thiscall] = ACTIONS(3404),
    [anon_sym___vectorcall] = ACTIONS(3404),
    [anon_sym_LBRACK] = ACTIONS(3404),
    [anon_sym_static] = ACTIONS(3404),
    [anon_sym_EQ] = ACTIONS(3402),
    [anon_sym_register] = ACTIONS(3404),
    [anon_sym_inline] = ACTIONS(3404),
    [anon_sym___inline] = ACTIONS(3404),
    [anon_sym___inline__] = ACTIONS(3404),
    [anon_sym___forceinline] = ACTIONS(3404),
    [anon_sym_thread_local] = ACTIONS(3404),
    [anon_sym___thread] = ACTIONS(3404),
    [anon_sym_const] = ACTIONS(3404),
    [anon_sym_constexpr] = ACTIONS(3404),
    [anon_sym_volatile] = ACTIONS(3404),
    [anon_sym_restrict] = ACTIONS(3404),
    [anon_sym___restrict__] = ACTIONS(3404),
    [anon_sym__Atomic] = ACTIONS(3404),
    [anon_sym__Noreturn] = ACTIONS(3404),
    [anon_sym_noreturn] = ACTIONS(3404),
    [anon_sym_mutable] = ACTIONS(3404),
    [anon_sym_constinit] = ACTIONS(3404),
    [anon_sym_consteval] = ACTIONS(3404),
    [anon_sym_alignas] = ACTIONS(3404),
    [anon_sym__Alignas] = ACTIONS(3404),
    [anon_sym_DOT] = ACTIONS(3404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3404),
    [anon_sym_let] = ACTIONS(3404),
    [anon_sym_This] = ACTIONS(3404),
    [anon_sym_decltype] = ACTIONS(3404),
    [sym_virtual] = ACTIONS(3404),
    [anon_sym_template] = ACTIONS(3404),
    [anon_sym_GT2] = ACTIONS(3402),
    [anon_sym_operator] = ACTIONS(3404),
    [anon_sym_precise] = ACTIONS(3404),
    [anon_sym_shared] = ACTIONS(3404),
    [anon_sym_groupshared] = ACTIONS(3404),
    [anon_sym_uniform] = ACTIONS(3404),
    [anon_sym_row_major] = ACTIONS(3404),
    [anon_sym_column_major] = ACTIONS(3404),
    [anon_sym_globallycoherent] = ACTIONS(3404),
    [anon_sym_centroid] = ACTIONS(3404),
    [anon_sym_noperspective] = ACTIONS(3404),
    [anon_sym_nointerpolation] = ACTIONS(3404),
    [anon_sym_sample] = ACTIONS(3404),
    [anon_sym_linear] = ACTIONS(3404),
    [anon_sym_snorm] = ACTIONS(3404),
    [anon_sym_unorm] = ACTIONS(3404),
    [anon_sym_point] = ACTIONS(3404),
    [anon_sym_line] = ACTIONS(3404),
    [anon_sym_triangleadj] = ACTIONS(3404),
    [anon_sym_lineadj] = ACTIONS(3404),
    [anon_sym_triangle] = ACTIONS(3404),
  },
  [2773] = {
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3200),
    [anon_sym_COMMA] = ACTIONS(3200),
    [anon_sym_RPAREN] = ACTIONS(3200),
    [anon_sym_LPAREN2] = ACTIONS(3200),
    [anon_sym_TILDE] = ACTIONS(3200),
    [anon_sym_STAR] = ACTIONS(3200),
    [anon_sym_AMP_AMP] = ACTIONS(3200),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_COLON] = ACTIONS(3202),
    [anon_sym_SEMI] = ACTIONS(3200),
    [anon_sym___extension__] = ACTIONS(3202),
    [anon_sym_in] = ACTIONS(3202),
    [anon_sym_out] = ACTIONS(3202),
    [anon_sym_inout] = ACTIONS(3202),
    [anon_sym_extern] = ACTIONS(3202),
    [anon_sym___attribute__] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3200),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3200),
    [anon_sym___declspec] = ACTIONS(3202),
    [anon_sym___based] = ACTIONS(3202),
    [anon_sym___cdecl] = ACTIONS(3202),
    [anon_sym___clrcall] = ACTIONS(3202),
    [anon_sym___stdcall] = ACTIONS(3202),
    [anon_sym___fastcall] = ACTIONS(3202),
    [anon_sym___thiscall] = ACTIONS(3202),
    [anon_sym___vectorcall] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_static] = ACTIONS(3202),
    [anon_sym_EQ] = ACTIONS(3200),
    [anon_sym_register] = ACTIONS(3202),
    [anon_sym_inline] = ACTIONS(3202),
    [anon_sym___inline] = ACTIONS(3202),
    [anon_sym___inline__] = ACTIONS(3202),
    [anon_sym___forceinline] = ACTIONS(3202),
    [anon_sym_thread_local] = ACTIONS(3202),
    [anon_sym___thread] = ACTIONS(3202),
    [anon_sym_const] = ACTIONS(3202),
    [anon_sym_constexpr] = ACTIONS(3202),
    [anon_sym_volatile] = ACTIONS(3202),
    [anon_sym_restrict] = ACTIONS(3202),
    [anon_sym___restrict__] = ACTIONS(3202),
    [anon_sym__Atomic] = ACTIONS(3202),
    [anon_sym__Noreturn] = ACTIONS(3202),
    [anon_sym_noreturn] = ACTIONS(3202),
    [anon_sym_mutable] = ACTIONS(3202),
    [anon_sym_constinit] = ACTIONS(3202),
    [anon_sym_consteval] = ACTIONS(3202),
    [anon_sym_alignas] = ACTIONS(3202),
    [anon_sym__Alignas] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(3202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_This] = ACTIONS(3202),
    [anon_sym_decltype] = ACTIONS(3202),
    [sym_virtual] = ACTIONS(3202),
    [anon_sym_template] = ACTIONS(3202),
    [anon_sym_GT2] = ACTIONS(3200),
    [anon_sym_operator] = ACTIONS(3202),
    [anon_sym_precise] = ACTIONS(3202),
    [anon_sym_shared] = ACTIONS(3202),
    [anon_sym_groupshared] = ACTIONS(3202),
    [anon_sym_uniform] = ACTIONS(3202),
    [anon_sym_row_major] = ACTIONS(3202),
    [anon_sym_column_major] = ACTIONS(3202),
    [anon_sym_globallycoherent] = ACTIONS(3202),
    [anon_sym_centroid] = ACTIONS(3202),
    [anon_sym_noperspective] = ACTIONS(3202),
    [anon_sym_nointerpolation] = ACTIONS(3202),
    [anon_sym_sample] = ACTIONS(3202),
    [anon_sym_linear] = ACTIONS(3202),
    [anon_sym_snorm] = ACTIONS(3202),
    [anon_sym_unorm] = ACTIONS(3202),
    [anon_sym_point] = ACTIONS(3202),
    [anon_sym_line] = ACTIONS(3202),
    [anon_sym_triangleadj] = ACTIONS(3202),
    [anon_sym_lineadj] = ACTIONS(3202),
    [anon_sym_triangle] = ACTIONS(3202),
  },
  [2774] = {
    [sym_attribute_specifier] = STATE(2767),
    [sym_enumerator_list] = STATE(2708),
    [sym__enum_base_clause] = STATE(2678),
    [sym_identifier] = ACTIONS(3348),
    [anon_sym_LPAREN2] = ACTIONS(3350),
    [anon_sym_TILDE] = ACTIONS(3350),
    [anon_sym_STAR] = ACTIONS(3350),
    [anon_sym_AMP_AMP] = ACTIONS(3350),
    [anon_sym_AMP] = ACTIONS(3348),
    [anon_sym_COLON] = ACTIONS(6382),
    [anon_sym_SEMI] = ACTIONS(3350),
    [anon_sym___extension__] = ACTIONS(3348),
    [anon_sym_in] = ACTIONS(3348),
    [anon_sym_out] = ACTIONS(3348),
    [anon_sym_inout] = ACTIONS(3348),
    [anon_sym_extern] = ACTIONS(3348),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(3350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3350),
    [anon_sym___declspec] = ACTIONS(3348),
    [anon_sym___based] = ACTIONS(3348),
    [anon_sym___cdecl] = ACTIONS(3348),
    [anon_sym___clrcall] = ACTIONS(3348),
    [anon_sym___stdcall] = ACTIONS(3348),
    [anon_sym___fastcall] = ACTIONS(3348),
    [anon_sym___thiscall] = ACTIONS(3348),
    [anon_sym___vectorcall] = ACTIONS(3348),
    [anon_sym_LBRACE] = ACTIONS(6313),
    [anon_sym_LBRACK] = ACTIONS(3348),
    [anon_sym_static] = ACTIONS(3348),
    [anon_sym_register] = ACTIONS(3348),
    [anon_sym_inline] = ACTIONS(3348),
    [anon_sym___inline] = ACTIONS(3348),
    [anon_sym___inline__] = ACTIONS(3348),
    [anon_sym___forceinline] = ACTIONS(3348),
    [anon_sym_thread_local] = ACTIONS(3348),
    [anon_sym___thread] = ACTIONS(3348),
    [anon_sym_const] = ACTIONS(3348),
    [anon_sym_constexpr] = ACTIONS(3348),
    [anon_sym_volatile] = ACTIONS(3348),
    [anon_sym_restrict] = ACTIONS(3348),
    [anon_sym___restrict__] = ACTIONS(3348),
    [anon_sym__Atomic] = ACTIONS(3348),
    [anon_sym__Noreturn] = ACTIONS(3348),
    [anon_sym_noreturn] = ACTIONS(3348),
    [anon_sym_mutable] = ACTIONS(3348),
    [anon_sym_constinit] = ACTIONS(3348),
    [anon_sym_consteval] = ACTIONS(3348),
    [anon_sym_alignas] = ACTIONS(3348),
    [anon_sym__Alignas] = ACTIONS(3348),
    [anon_sym_DOT] = ACTIONS(3350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3348),
    [anon_sym_let] = ACTIONS(3348),
    [anon_sym_This] = ACTIONS(3348),
    [anon_sym_decltype] = ACTIONS(3348),
    [sym_virtual] = ACTIONS(3348),
    [anon_sym_template] = ACTIONS(3348),
    [anon_sym_operator] = ACTIONS(3348),
    [anon_sym_precise] = ACTIONS(3348),
    [anon_sym_shared] = ACTIONS(3348),
    [anon_sym_groupshared] = ACTIONS(3348),
    [anon_sym_uniform] = ACTIONS(3348),
    [anon_sym_row_major] = ACTIONS(3348),
    [anon_sym_column_major] = ACTIONS(3348),
    [anon_sym_globallycoherent] = ACTIONS(3348),
    [anon_sym_centroid] = ACTIONS(3348),
    [anon_sym_noperspective] = ACTIONS(3348),
    [anon_sym_nointerpolation] = ACTIONS(3348),
    [anon_sym_sample] = ACTIONS(3348),
    [anon_sym_linear] = ACTIONS(3348),
    [anon_sym_snorm] = ACTIONS(3348),
    [anon_sym_unorm] = ACTIONS(3348),
    [anon_sym_point] = ACTIONS(3348),
    [anon_sym_line] = ACTIONS(3348),
    [anon_sym_triangleadj] = ACTIONS(3348),
    [anon_sym_lineadj] = ACTIONS(3348),
    [anon_sym_triangle] = ACTIONS(3348),
  },
  [2775] = {
    [sym_identifier] = ACTIONS(4545),
    [anon_sym_LPAREN2] = ACTIONS(4547),
    [anon_sym_TILDE] = ACTIONS(4547),
    [anon_sym_STAR] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4547),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym___extension__] = ACTIONS(4545),
    [anon_sym_in] = ACTIONS(4545),
    [anon_sym_out] = ACTIONS(4545),
    [anon_sym_inout] = ACTIONS(4545),
    [anon_sym_extern] = ACTIONS(4545),
    [anon_sym___attribute__] = ACTIONS(4545),
    [anon_sym_COLON_COLON] = ACTIONS(4547),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4547),
    [anon_sym___declspec] = ACTIONS(4545),
    [anon_sym___based] = ACTIONS(4545),
    [anon_sym_signed] = ACTIONS(4545),
    [anon_sym_unsigned] = ACTIONS(4545),
    [anon_sym_long] = ACTIONS(4545),
    [anon_sym_short] = ACTIONS(4545),
    [anon_sym_LBRACK] = ACTIONS(4545),
    [anon_sym_static] = ACTIONS(4545),
    [anon_sym_register] = ACTIONS(4545),
    [anon_sym_inline] = ACTIONS(4545),
    [anon_sym___inline] = ACTIONS(4545),
    [anon_sym___inline__] = ACTIONS(4545),
    [anon_sym___forceinline] = ACTIONS(4545),
    [anon_sym_thread_local] = ACTIONS(4545),
    [anon_sym___thread] = ACTIONS(4545),
    [anon_sym_const] = ACTIONS(4545),
    [anon_sym_constexpr] = ACTIONS(4545),
    [anon_sym_volatile] = ACTIONS(4545),
    [anon_sym_restrict] = ACTIONS(4545),
    [anon_sym___restrict__] = ACTIONS(4545),
    [anon_sym__Atomic] = ACTIONS(4545),
    [anon_sym__Noreturn] = ACTIONS(4545),
    [anon_sym_noreturn] = ACTIONS(4545),
    [anon_sym_mutable] = ACTIONS(4545),
    [anon_sym_constinit] = ACTIONS(4545),
    [anon_sym_consteval] = ACTIONS(4545),
    [anon_sym_alignas] = ACTIONS(4545),
    [anon_sym__Alignas] = ACTIONS(4545),
    [sym_primitive_type] = ACTIONS(4545),
    [anon_sym_enum] = ACTIONS(4545),
    [anon_sym_class] = ACTIONS(4545),
    [anon_sym_struct] = ACTIONS(4545),
    [anon_sym_union] = ACTIONS(4545),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4545),
    [anon_sym_let] = ACTIONS(4545),
    [anon_sym_This] = ACTIONS(4545),
    [anon_sym_decltype] = ACTIONS(4545),
    [sym_virtual] = ACTIONS(4545),
    [anon_sym_explicit] = ACTIONS(4545),
    [anon_sym_typename] = ACTIONS(4545),
    [anon_sym_template] = ACTIONS(4545),
    [anon_sym_operator] = ACTIONS(4545),
    [anon_sym_precise] = ACTIONS(4545),
    [anon_sym_shared] = ACTIONS(4545),
    [anon_sym_groupshared] = ACTIONS(4545),
    [anon_sym_uniform] = ACTIONS(4545),
    [anon_sym_row_major] = ACTIONS(4545),
    [anon_sym_column_major] = ACTIONS(4545),
    [anon_sym_globallycoherent] = ACTIONS(4545),
    [anon_sym_centroid] = ACTIONS(4545),
    [anon_sym_noperspective] = ACTIONS(4545),
    [anon_sym_nointerpolation] = ACTIONS(4545),
    [anon_sym_sample] = ACTIONS(4545),
    [anon_sym_linear] = ACTIONS(4545),
    [anon_sym_snorm] = ACTIONS(4545),
    [anon_sym_unorm] = ACTIONS(4545),
    [anon_sym_point] = ACTIONS(4545),
    [anon_sym_line] = ACTIONS(4545),
    [anon_sym_triangleadj] = ACTIONS(4545),
    [anon_sym_lineadj] = ACTIONS(4545),
    [anon_sym_triangle] = ACTIONS(4545),
    [anon_sym_interface] = ACTIONS(4545),
    [anon_sym_extension] = ACTIONS(4545),
  },
  [2776] = {
    [sym_identifier] = ACTIONS(6384),
    [anon_sym_LPAREN2] = ACTIONS(6387),
    [anon_sym_TILDE] = ACTIONS(6387),
    [anon_sym_STAR] = ACTIONS(6387),
    [anon_sym_AMP_AMP] = ACTIONS(6387),
    [anon_sym_AMP] = ACTIONS(6389),
    [anon_sym___extension__] = ACTIONS(6384),
    [anon_sym_in] = ACTIONS(6384),
    [anon_sym_out] = ACTIONS(6384),
    [anon_sym_inout] = ACTIONS(6384),
    [anon_sym_extern] = ACTIONS(6384),
    [anon_sym___attribute__] = ACTIONS(6384),
    [anon_sym_COLON_COLON] = ACTIONS(6391),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6391),
    [anon_sym___declspec] = ACTIONS(6384),
    [anon_sym___based] = ACTIONS(6389),
    [anon_sym_signed] = ACTIONS(6394),
    [anon_sym_unsigned] = ACTIONS(6394),
    [anon_sym_long] = ACTIONS(6394),
    [anon_sym_short] = ACTIONS(6394),
    [anon_sym_LBRACK] = ACTIONS(6389),
    [anon_sym_static] = ACTIONS(6384),
    [anon_sym_register] = ACTIONS(6384),
    [anon_sym_inline] = ACTIONS(6384),
    [anon_sym___inline] = ACTIONS(6384),
    [anon_sym___inline__] = ACTIONS(6384),
    [anon_sym___forceinline] = ACTIONS(6384),
    [anon_sym_thread_local] = ACTIONS(6384),
    [anon_sym___thread] = ACTIONS(6384),
    [anon_sym_const] = ACTIONS(6384),
    [anon_sym_constexpr] = ACTIONS(6384),
    [anon_sym_volatile] = ACTIONS(6384),
    [anon_sym_restrict] = ACTIONS(6384),
    [anon_sym___restrict__] = ACTIONS(6384),
    [anon_sym__Atomic] = ACTIONS(6384),
    [anon_sym__Noreturn] = ACTIONS(6384),
    [anon_sym_noreturn] = ACTIONS(6384),
    [anon_sym_mutable] = ACTIONS(6384),
    [anon_sym_constinit] = ACTIONS(6384),
    [anon_sym_consteval] = ACTIONS(6384),
    [anon_sym_alignas] = ACTIONS(6384),
    [anon_sym__Alignas] = ACTIONS(6384),
    [sym_primitive_type] = ACTIONS(6394),
    [anon_sym_enum] = ACTIONS(6394),
    [anon_sym_class] = ACTIONS(6394),
    [anon_sym_struct] = ACTIONS(6394),
    [anon_sym_union] = ACTIONS(6394),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6394),
    [anon_sym_let] = ACTIONS(6394),
    [anon_sym_This] = ACTIONS(6394),
    [anon_sym_decltype] = ACTIONS(6384),
    [sym_virtual] = ACTIONS(6384),
    [anon_sym_explicit] = ACTIONS(6389),
    [anon_sym_typename] = ACTIONS(6394),
    [anon_sym_template] = ACTIONS(6384),
    [anon_sym_operator] = ACTIONS(6389),
    [anon_sym_precise] = ACTIONS(6384),
    [anon_sym_shared] = ACTIONS(6384),
    [anon_sym_groupshared] = ACTIONS(6384),
    [anon_sym_uniform] = ACTIONS(6384),
    [anon_sym_row_major] = ACTIONS(6384),
    [anon_sym_column_major] = ACTIONS(6384),
    [anon_sym_globallycoherent] = ACTIONS(6384),
    [anon_sym_centroid] = ACTIONS(6384),
    [anon_sym_noperspective] = ACTIONS(6384),
    [anon_sym_nointerpolation] = ACTIONS(6384),
    [anon_sym_sample] = ACTIONS(6384),
    [anon_sym_linear] = ACTIONS(6384),
    [anon_sym_snorm] = ACTIONS(6384),
    [anon_sym_unorm] = ACTIONS(6384),
    [anon_sym_point] = ACTIONS(6384),
    [anon_sym_line] = ACTIONS(6384),
    [anon_sym_triangleadj] = ACTIONS(6384),
    [anon_sym_lineadj] = ACTIONS(6384),
    [anon_sym_triangle] = ACTIONS(6384),
    [anon_sym_interface] = ACTIONS(6394),
    [anon_sym_extension] = ACTIONS(6394),
  },
  [2777] = {
    [sym__declaration_modifiers] = STATE(2777),
    [sym_attribute_specifier] = STATE(2777),
    [sym_attribute_declaration] = STATE(2777),
    [sym_ms_declspec_modifier] = STATE(2777),
    [sym_storage_class_specifier] = STATE(2777),
    [sym_type_qualifier] = STATE(2777),
    [sym_alignas_qualifier] = STATE(2582),
    [sym_qualifiers] = STATE(2777),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2777),
    [sym_identifier] = ACTIONS(6259),
    [anon_sym___extension__] = ACTIONS(6396),
    [anon_sym_in] = ACTIONS(6399),
    [anon_sym_out] = ACTIONS(6399),
    [anon_sym_inout] = ACTIONS(6399),
    [anon_sym_extern] = ACTIONS(6402),
    [anon_sym___attribute__] = ACTIONS(6405),
    [anon_sym_COLON_COLON] = ACTIONS(6261),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6408),
    [anon_sym___declspec] = ACTIONS(6411),
    [anon_sym_signed] = ACTIONS(6259),
    [anon_sym_unsigned] = ACTIONS(6259),
    [anon_sym_long] = ACTIONS(6259),
    [anon_sym_short] = ACTIONS(6259),
    [anon_sym_static] = ACTIONS(6402),
    [anon_sym_register] = ACTIONS(6402),
    [anon_sym_inline] = ACTIONS(6402),
    [anon_sym___inline] = ACTIONS(6402),
    [anon_sym___inline__] = ACTIONS(6402),
    [anon_sym___forceinline] = ACTIONS(6402),
    [anon_sym_thread_local] = ACTIONS(6402),
    [anon_sym___thread] = ACTIONS(6402),
    [anon_sym_const] = ACTIONS(6396),
    [anon_sym_constexpr] = ACTIONS(6396),
    [anon_sym_volatile] = ACTIONS(6396),
    [anon_sym_restrict] = ACTIONS(6396),
    [anon_sym___restrict__] = ACTIONS(6396),
    [anon_sym__Atomic] = ACTIONS(6396),
    [anon_sym__Noreturn] = ACTIONS(6396),
    [anon_sym_noreturn] = ACTIONS(6396),
    [anon_sym_mutable] = ACTIONS(6396),
    [anon_sym_constinit] = ACTIONS(6396),
    [anon_sym_consteval] = ACTIONS(6396),
    [anon_sym_alignas] = ACTIONS(6414),
    [anon_sym__Alignas] = ACTIONS(6414),
    [sym_primitive_type] = ACTIONS(6259),
    [anon_sym_enum] = ACTIONS(6259),
    [anon_sym_class] = ACTIONS(6259),
    [anon_sym_struct] = ACTIONS(6259),
    [anon_sym_union] = ACTIONS(6259),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6259),
    [anon_sym_let] = ACTIONS(6259),
    [anon_sym_This] = ACTIONS(6259),
    [anon_sym_decltype] = ACTIONS(6259),
    [sym_virtual] = ACTIONS(6399),
    [anon_sym_typename] = ACTIONS(6259),
    [anon_sym_template] = ACTIONS(6259),
    [anon_sym_precise] = ACTIONS(6417),
    [anon_sym_shared] = ACTIONS(6417),
    [anon_sym_groupshared] = ACTIONS(6417),
    [anon_sym_uniform] = ACTIONS(6417),
    [anon_sym_row_major] = ACTIONS(6417),
    [anon_sym_column_major] = ACTIONS(6417),
    [anon_sym_globallycoherent] = ACTIONS(6417),
    [anon_sym_centroid] = ACTIONS(6417),
    [anon_sym_noperspective] = ACTIONS(6417),
    [anon_sym_nointerpolation] = ACTIONS(6417),
    [anon_sym_sample] = ACTIONS(6417),
    [anon_sym_linear] = ACTIONS(6417),
    [anon_sym_snorm] = ACTIONS(6417),
    [anon_sym_unorm] = ACTIONS(6417),
    [anon_sym_point] = ACTIONS(6417),
    [anon_sym_line] = ACTIONS(6417),
    [anon_sym_triangleadj] = ACTIONS(6417),
    [anon_sym_lineadj] = ACTIONS(6417),
    [anon_sym_triangle] = ACTIONS(6417),
    [anon_sym_interface] = ACTIONS(6259),
    [anon_sym_extension] = ACTIONS(6259),
  },
  [2778] = {
    [sym_identifier] = ACTIONS(6420),
    [anon_sym_LPAREN2] = ACTIONS(6422),
    [anon_sym_TILDE] = ACTIONS(6422),
    [anon_sym_STAR] = ACTIONS(6422),
    [anon_sym_AMP_AMP] = ACTIONS(6422),
    [anon_sym_AMP] = ACTIONS(6420),
    [anon_sym___extension__] = ACTIONS(6420),
    [anon_sym_in] = ACTIONS(6420),
    [anon_sym_out] = ACTIONS(6420),
    [anon_sym_inout] = ACTIONS(6420),
    [anon_sym_extern] = ACTIONS(6420),
    [anon_sym___attribute__] = ACTIONS(6420),
    [anon_sym_COLON_COLON] = ACTIONS(6422),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6422),
    [anon_sym___declspec] = ACTIONS(6420),
    [anon_sym___based] = ACTIONS(6420),
    [anon_sym_signed] = ACTIONS(6420),
    [anon_sym_unsigned] = ACTIONS(6420),
    [anon_sym_long] = ACTIONS(6420),
    [anon_sym_short] = ACTIONS(6420),
    [anon_sym_LBRACK] = ACTIONS(6420),
    [anon_sym_static] = ACTIONS(6420),
    [anon_sym_register] = ACTIONS(6420),
    [anon_sym_inline] = ACTIONS(6420),
    [anon_sym___inline] = ACTIONS(6420),
    [anon_sym___inline__] = ACTIONS(6420),
    [anon_sym___forceinline] = ACTIONS(6420),
    [anon_sym_thread_local] = ACTIONS(6420),
    [anon_sym___thread] = ACTIONS(6420),
    [anon_sym_const] = ACTIONS(6420),
    [anon_sym_constexpr] = ACTIONS(6420),
    [anon_sym_volatile] = ACTIONS(6420),
    [anon_sym_restrict] = ACTIONS(6420),
    [anon_sym___restrict__] = ACTIONS(6420),
    [anon_sym__Atomic] = ACTIONS(6420),
    [anon_sym__Noreturn] = ACTIONS(6420),
    [anon_sym_noreturn] = ACTIONS(6420),
    [anon_sym_mutable] = ACTIONS(6420),
    [anon_sym_constinit] = ACTIONS(6420),
    [anon_sym_consteval] = ACTIONS(6420),
    [anon_sym_alignas] = ACTIONS(6420),
    [anon_sym__Alignas] = ACTIONS(6420),
    [sym_primitive_type] = ACTIONS(6420),
    [anon_sym_enum] = ACTIONS(6420),
    [anon_sym_class] = ACTIONS(6420),
    [anon_sym_struct] = ACTIONS(6420),
    [anon_sym_union] = ACTIONS(6420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6420),
    [anon_sym_let] = ACTIONS(6420),
    [anon_sym_This] = ACTIONS(6420),
    [anon_sym_decltype] = ACTIONS(6420),
    [sym_virtual] = ACTIONS(6420),
    [anon_sym_explicit] = ACTIONS(6420),
    [anon_sym_typename] = ACTIONS(6420),
    [anon_sym_template] = ACTIONS(6420),
    [anon_sym_operator] = ACTIONS(6420),
    [anon_sym_precise] = ACTIONS(6420),
    [anon_sym_shared] = ACTIONS(6420),
    [anon_sym_groupshared] = ACTIONS(6420),
    [anon_sym_uniform] = ACTIONS(6420),
    [anon_sym_row_major] = ACTIONS(6420),
    [anon_sym_column_major] = ACTIONS(6420),
    [anon_sym_globallycoherent] = ACTIONS(6420),
    [anon_sym_centroid] = ACTIONS(6420),
    [anon_sym_noperspective] = ACTIONS(6420),
    [anon_sym_nointerpolation] = ACTIONS(6420),
    [anon_sym_sample] = ACTIONS(6420),
    [anon_sym_linear] = ACTIONS(6420),
    [anon_sym_snorm] = ACTIONS(6420),
    [anon_sym_unorm] = ACTIONS(6420),
    [anon_sym_point] = ACTIONS(6420),
    [anon_sym_line] = ACTIONS(6420),
    [anon_sym_triangleadj] = ACTIONS(6420),
    [anon_sym_lineadj] = ACTIONS(6420),
    [anon_sym_triangle] = ACTIONS(6420),
    [anon_sym_interface] = ACTIONS(6420),
    [anon_sym_extension] = ACTIONS(6420),
  },
  [2779] = {
    [sym_attribute_specifier] = STATE(2773),
    [sym_enumerator_list] = STATE(2706),
    [sym__enum_base_clause] = STATE(2677),
    [sym_identifier] = ACTIONS(3060),
    [anon_sym_LPAREN2] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3062),
    [anon_sym_STAR] = ACTIONS(3062),
    [anon_sym_AMP_AMP] = ACTIONS(3062),
    [anon_sym_AMP] = ACTIONS(3060),
    [anon_sym_COLON] = ACTIONS(6382),
    [anon_sym_SEMI] = ACTIONS(3062),
    [anon_sym___extension__] = ACTIONS(3060),
    [anon_sym_in] = ACTIONS(3060),
    [anon_sym_out] = ACTIONS(3060),
    [anon_sym_inout] = ACTIONS(3060),
    [anon_sym_extern] = ACTIONS(3060),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(3062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3062),
    [anon_sym___declspec] = ACTIONS(3060),
    [anon_sym___based] = ACTIONS(3060),
    [anon_sym___cdecl] = ACTIONS(3060),
    [anon_sym___clrcall] = ACTIONS(3060),
    [anon_sym___stdcall] = ACTIONS(3060),
    [anon_sym___fastcall] = ACTIONS(3060),
    [anon_sym___thiscall] = ACTIONS(3060),
    [anon_sym___vectorcall] = ACTIONS(3060),
    [anon_sym_LBRACE] = ACTIONS(6313),
    [anon_sym_LBRACK] = ACTIONS(3060),
    [anon_sym_static] = ACTIONS(3060),
    [anon_sym_register] = ACTIONS(3060),
    [anon_sym_inline] = ACTIONS(3060),
    [anon_sym___inline] = ACTIONS(3060),
    [anon_sym___inline__] = ACTIONS(3060),
    [anon_sym___forceinline] = ACTIONS(3060),
    [anon_sym_thread_local] = ACTIONS(3060),
    [anon_sym___thread] = ACTIONS(3060),
    [anon_sym_const] = ACTIONS(3060),
    [anon_sym_constexpr] = ACTIONS(3060),
    [anon_sym_volatile] = ACTIONS(3060),
    [anon_sym_restrict] = ACTIONS(3060),
    [anon_sym___restrict__] = ACTIONS(3060),
    [anon_sym__Atomic] = ACTIONS(3060),
    [anon_sym__Noreturn] = ACTIONS(3060),
    [anon_sym_noreturn] = ACTIONS(3060),
    [anon_sym_mutable] = ACTIONS(3060),
    [anon_sym_constinit] = ACTIONS(3060),
    [anon_sym_consteval] = ACTIONS(3060),
    [anon_sym_alignas] = ACTIONS(3060),
    [anon_sym__Alignas] = ACTIONS(3060),
    [anon_sym_DOT] = ACTIONS(3062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3060),
    [anon_sym_let] = ACTIONS(3060),
    [anon_sym_This] = ACTIONS(3060),
    [anon_sym_decltype] = ACTIONS(3060),
    [sym_virtual] = ACTIONS(3060),
    [anon_sym_template] = ACTIONS(3060),
    [anon_sym_operator] = ACTIONS(3060),
    [anon_sym_precise] = ACTIONS(3060),
    [anon_sym_shared] = ACTIONS(3060),
    [anon_sym_groupshared] = ACTIONS(3060),
    [anon_sym_uniform] = ACTIONS(3060),
    [anon_sym_row_major] = ACTIONS(3060),
    [anon_sym_column_major] = ACTIONS(3060),
    [anon_sym_globallycoherent] = ACTIONS(3060),
    [anon_sym_centroid] = ACTIONS(3060),
    [anon_sym_noperspective] = ACTIONS(3060),
    [anon_sym_nointerpolation] = ACTIONS(3060),
    [anon_sym_sample] = ACTIONS(3060),
    [anon_sym_linear] = ACTIONS(3060),
    [anon_sym_snorm] = ACTIONS(3060),
    [anon_sym_unorm] = ACTIONS(3060),
    [anon_sym_point] = ACTIONS(3060),
    [anon_sym_line] = ACTIONS(3060),
    [anon_sym_triangleadj] = ACTIONS(3060),
    [anon_sym_lineadj] = ACTIONS(3060),
    [anon_sym_triangle] = ACTIONS(3060),
  },
  [2780] = {
    [sym_identifier] = ACTIONS(6371),
    [anon_sym_LPAREN2] = ACTIONS(6373),
    [anon_sym_TILDE] = ACTIONS(6373),
    [anon_sym_STAR] = ACTIONS(6373),
    [anon_sym_AMP_AMP] = ACTIONS(6373),
    [anon_sym_AMP] = ACTIONS(6371),
    [anon_sym___extension__] = ACTIONS(6371),
    [anon_sym_in] = ACTIONS(6371),
    [anon_sym_out] = ACTIONS(6371),
    [anon_sym_inout] = ACTIONS(6371),
    [anon_sym_extern] = ACTIONS(6371),
    [anon_sym___attribute__] = ACTIONS(6371),
    [anon_sym_COLON_COLON] = ACTIONS(6373),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6373),
    [anon_sym___declspec] = ACTIONS(6371),
    [anon_sym___based] = ACTIONS(6371),
    [anon_sym_signed] = ACTIONS(6371),
    [anon_sym_unsigned] = ACTIONS(6371),
    [anon_sym_long] = ACTIONS(6371),
    [anon_sym_short] = ACTIONS(6371),
    [anon_sym_LBRACK] = ACTIONS(6371),
    [anon_sym_static] = ACTIONS(6371),
    [anon_sym_register] = ACTIONS(6371),
    [anon_sym_inline] = ACTIONS(6371),
    [anon_sym___inline] = ACTIONS(6371),
    [anon_sym___inline__] = ACTIONS(6371),
    [anon_sym___forceinline] = ACTIONS(6371),
    [anon_sym_thread_local] = ACTIONS(6371),
    [anon_sym___thread] = ACTIONS(6371),
    [anon_sym_const] = ACTIONS(6371),
    [anon_sym_constexpr] = ACTIONS(6371),
    [anon_sym_volatile] = ACTIONS(6371),
    [anon_sym_restrict] = ACTIONS(6371),
    [anon_sym___restrict__] = ACTIONS(6371),
    [anon_sym__Atomic] = ACTIONS(6371),
    [anon_sym__Noreturn] = ACTIONS(6371),
    [anon_sym_noreturn] = ACTIONS(6371),
    [anon_sym_mutable] = ACTIONS(6371),
    [anon_sym_constinit] = ACTIONS(6371),
    [anon_sym_consteval] = ACTIONS(6371),
    [anon_sym_alignas] = ACTIONS(6371),
    [anon_sym__Alignas] = ACTIONS(6371),
    [sym_primitive_type] = ACTIONS(6371),
    [anon_sym_enum] = ACTIONS(6371),
    [anon_sym_class] = ACTIONS(6371),
    [anon_sym_struct] = ACTIONS(6371),
    [anon_sym_union] = ACTIONS(6371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6371),
    [anon_sym_let] = ACTIONS(6371),
    [anon_sym_This] = ACTIONS(6371),
    [anon_sym_decltype] = ACTIONS(6371),
    [sym_virtual] = ACTIONS(6371),
    [anon_sym_explicit] = ACTIONS(6371),
    [anon_sym_typename] = ACTIONS(6371),
    [anon_sym_template] = ACTIONS(6371),
    [anon_sym_operator] = ACTIONS(6371),
    [anon_sym_precise] = ACTIONS(6371),
    [anon_sym_shared] = ACTIONS(6371),
    [anon_sym_groupshared] = ACTIONS(6371),
    [anon_sym_uniform] = ACTIONS(6371),
    [anon_sym_row_major] = ACTIONS(6371),
    [anon_sym_column_major] = ACTIONS(6371),
    [anon_sym_globallycoherent] = ACTIONS(6371),
    [anon_sym_centroid] = ACTIONS(6371),
    [anon_sym_noperspective] = ACTIONS(6371),
    [anon_sym_nointerpolation] = ACTIONS(6371),
    [anon_sym_sample] = ACTIONS(6371),
    [anon_sym_linear] = ACTIONS(6371),
    [anon_sym_snorm] = ACTIONS(6371),
    [anon_sym_unorm] = ACTIONS(6371),
    [anon_sym_point] = ACTIONS(6371),
    [anon_sym_line] = ACTIONS(6371),
    [anon_sym_triangleadj] = ACTIONS(6371),
    [anon_sym_lineadj] = ACTIONS(6371),
    [anon_sym_triangle] = ACTIONS(6371),
    [anon_sym_interface] = ACTIONS(6371),
    [anon_sym_extension] = ACTIONS(6371),
  },
  [2781] = {
    [sym_template_argument_list] = STATE(2944),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2639),
    [sym_identifier] = ACTIONS(2115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2123),
    [anon_sym_COMMA] = ACTIONS(2123),
    [anon_sym_RPAREN] = ACTIONS(2140),
    [anon_sym_LPAREN2] = ACTIONS(2140),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_AMP_AMP] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2115),
    [anon_sym_LT] = ACTIONS(6358),
    [anon_sym_COLON] = ACTIONS(2115),
    [anon_sym___extension__] = ACTIONS(2115),
    [anon_sym_in] = ACTIONS(2115),
    [anon_sym_out] = ACTIONS(2115),
    [anon_sym_inout] = ACTIONS(2115),
    [anon_sym_extern] = ACTIONS(2115),
    [anon_sym___attribute__] = ACTIONS(2115),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2140),
    [anon_sym___declspec] = ACTIONS(2115),
    [anon_sym___based] = ACTIONS(2115),
    [anon_sym_signed] = ACTIONS(4863),
    [anon_sym_unsigned] = ACTIONS(4863),
    [anon_sym_long] = ACTIONS(4863),
    [anon_sym_short] = ACTIONS(4863),
    [anon_sym_LBRACK] = ACTIONS(6345),
    [anon_sym_static] = ACTIONS(2115),
    [anon_sym_EQ] = ACTIONS(2123),
    [anon_sym_register] = ACTIONS(2115),
    [anon_sym_inline] = ACTIONS(2115),
    [anon_sym___inline] = ACTIONS(2115),
    [anon_sym___inline__] = ACTIONS(2115),
    [anon_sym___forceinline] = ACTIONS(2115),
    [anon_sym_thread_local] = ACTIONS(2115),
    [anon_sym___thread] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(2115),
    [anon_sym_constexpr] = ACTIONS(2115),
    [anon_sym_volatile] = ACTIONS(2115),
    [anon_sym_restrict] = ACTIONS(2115),
    [anon_sym___restrict__] = ACTIONS(2115),
    [anon_sym__Atomic] = ACTIONS(2115),
    [anon_sym__Noreturn] = ACTIONS(2115),
    [anon_sym_noreturn] = ACTIONS(2115),
    [anon_sym_mutable] = ACTIONS(2115),
    [anon_sym_constinit] = ACTIONS(2115),
    [anon_sym_consteval] = ACTIONS(2115),
    [anon_sym_alignas] = ACTIONS(2115),
    [anon_sym__Alignas] = ACTIONS(2115),
    [anon_sym_DOT] = ACTIONS(2115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2115),
    [anon_sym_let] = ACTIONS(2115),
    [anon_sym_This] = ACTIONS(2115),
    [anon_sym_decltype] = ACTIONS(2115),
    [sym_virtual] = ACTIONS(2115),
    [anon_sym_template] = ACTIONS(2115),
    [anon_sym_operator] = ACTIONS(2115),
    [anon_sym_precise] = ACTIONS(2115),
    [anon_sym_shared] = ACTIONS(2115),
    [anon_sym_groupshared] = ACTIONS(2115),
    [anon_sym_uniform] = ACTIONS(2115),
    [anon_sym_row_major] = ACTIONS(2115),
    [anon_sym_column_major] = ACTIONS(2115),
    [anon_sym_globallycoherent] = ACTIONS(2115),
    [anon_sym_centroid] = ACTIONS(2115),
    [anon_sym_noperspective] = ACTIONS(2115),
    [anon_sym_nointerpolation] = ACTIONS(2115),
    [anon_sym_sample] = ACTIONS(2115),
    [anon_sym_linear] = ACTIONS(2115),
    [anon_sym_snorm] = ACTIONS(2115),
    [anon_sym_unorm] = ACTIONS(2115),
    [anon_sym_point] = ACTIONS(2115),
    [anon_sym_line] = ACTIONS(2115),
    [anon_sym_triangleadj] = ACTIONS(2115),
    [anon_sym_lineadj] = ACTIONS(2115),
    [anon_sym_triangle] = ACTIONS(2115),
  },
  [2782] = {
    [sym_template_argument_list] = STATE(2686),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2639),
    [sym_identifier] = ACTIONS(2115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2123),
    [anon_sym_COMMA] = ACTIONS(6424),
    [anon_sym_LPAREN2] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_AMP_AMP] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2115),
    [anon_sym_LT] = ACTIONS(6358),
    [anon_sym_COLON] = ACTIONS(2115),
    [anon_sym___extension__] = ACTIONS(2115),
    [anon_sym_in] = ACTIONS(2115),
    [anon_sym_out] = ACTIONS(2115),
    [anon_sym_inout] = ACTIONS(2115),
    [anon_sym_extern] = ACTIONS(2115),
    [anon_sym___attribute__] = ACTIONS(2115),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2123),
    [anon_sym___declspec] = ACTIONS(2115),
    [anon_sym___based] = ACTIONS(2115),
    [anon_sym_signed] = ACTIONS(4863),
    [anon_sym_unsigned] = ACTIONS(4863),
    [anon_sym_long] = ACTIONS(4863),
    [anon_sym_short] = ACTIONS(4863),
    [anon_sym_LBRACK] = ACTIONS(2115),
    [anon_sym_static] = ACTIONS(2115),
    [anon_sym_EQ] = ACTIONS(6426),
    [anon_sym_register] = ACTIONS(2115),
    [anon_sym_inline] = ACTIONS(2115),
    [anon_sym___inline] = ACTIONS(2115),
    [anon_sym___inline__] = ACTIONS(2115),
    [anon_sym___forceinline] = ACTIONS(2115),
    [anon_sym_thread_local] = ACTIONS(2115),
    [anon_sym___thread] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(2115),
    [anon_sym_constexpr] = ACTIONS(2115),
    [anon_sym_volatile] = ACTIONS(2115),
    [anon_sym_restrict] = ACTIONS(2115),
    [anon_sym___restrict__] = ACTIONS(2115),
    [anon_sym__Atomic] = ACTIONS(2115),
    [anon_sym__Noreturn] = ACTIONS(2115),
    [anon_sym_noreturn] = ACTIONS(2115),
    [anon_sym_mutable] = ACTIONS(2115),
    [anon_sym_constinit] = ACTIONS(2115),
    [anon_sym_consteval] = ACTIONS(2115),
    [anon_sym_alignas] = ACTIONS(2115),
    [anon_sym__Alignas] = ACTIONS(2115),
    [anon_sym_DOT] = ACTIONS(2115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2115),
    [anon_sym_let] = ACTIONS(2115),
    [anon_sym_This] = ACTIONS(2115),
    [anon_sym_decltype] = ACTIONS(2115),
    [sym_virtual] = ACTIONS(2115),
    [anon_sym_template] = ACTIONS(2115),
    [anon_sym_GT2] = ACTIONS(6424),
    [anon_sym_operator] = ACTIONS(2115),
    [anon_sym_precise] = ACTIONS(2115),
    [anon_sym_shared] = ACTIONS(2115),
    [anon_sym_groupshared] = ACTIONS(2115),
    [anon_sym_uniform] = ACTIONS(2115),
    [anon_sym_row_major] = ACTIONS(2115),
    [anon_sym_column_major] = ACTIONS(2115),
    [anon_sym_globallycoherent] = ACTIONS(2115),
    [anon_sym_centroid] = ACTIONS(2115),
    [anon_sym_noperspective] = ACTIONS(2115),
    [anon_sym_nointerpolation] = ACTIONS(2115),
    [anon_sym_sample] = ACTIONS(2115),
    [anon_sym_linear] = ACTIONS(2115),
    [anon_sym_snorm] = ACTIONS(2115),
    [anon_sym_unorm] = ACTIONS(2115),
    [anon_sym_point] = ACTIONS(2115),
    [anon_sym_line] = ACTIONS(2115),
    [anon_sym_triangleadj] = ACTIONS(2115),
    [anon_sym_lineadj] = ACTIONS(2115),
    [anon_sym_triangle] = ACTIONS(2115),
  },
  [2783] = {
    [sym_identifier] = ACTIONS(4573),
    [anon_sym_LPAREN2] = ACTIONS(4575),
    [anon_sym_TILDE] = ACTIONS(4575),
    [anon_sym_STAR] = ACTIONS(4575),
    [anon_sym_AMP_AMP] = ACTIONS(4575),
    [anon_sym_AMP] = ACTIONS(4573),
    [anon_sym___extension__] = ACTIONS(4573),
    [anon_sym_in] = ACTIONS(4573),
    [anon_sym_out] = ACTIONS(4573),
    [anon_sym_inout] = ACTIONS(4573),
    [anon_sym_extern] = ACTIONS(4573),
    [anon_sym___attribute__] = ACTIONS(4573),
    [anon_sym_COLON_COLON] = ACTIONS(4575),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4575),
    [anon_sym___declspec] = ACTIONS(4573),
    [anon_sym___based] = ACTIONS(4573),
    [anon_sym_signed] = ACTIONS(4573),
    [anon_sym_unsigned] = ACTIONS(4573),
    [anon_sym_long] = ACTIONS(4573),
    [anon_sym_short] = ACTIONS(4573),
    [anon_sym_LBRACK] = ACTIONS(4573),
    [anon_sym_static] = ACTIONS(4573),
    [anon_sym_register] = ACTIONS(4573),
    [anon_sym_inline] = ACTIONS(4573),
    [anon_sym___inline] = ACTIONS(4573),
    [anon_sym___inline__] = ACTIONS(4573),
    [anon_sym___forceinline] = ACTIONS(4573),
    [anon_sym_thread_local] = ACTIONS(4573),
    [anon_sym___thread] = ACTIONS(4573),
    [anon_sym_const] = ACTIONS(4573),
    [anon_sym_constexpr] = ACTIONS(4573),
    [anon_sym_volatile] = ACTIONS(4573),
    [anon_sym_restrict] = ACTIONS(4573),
    [anon_sym___restrict__] = ACTIONS(4573),
    [anon_sym__Atomic] = ACTIONS(4573),
    [anon_sym__Noreturn] = ACTIONS(4573),
    [anon_sym_noreturn] = ACTIONS(4573),
    [anon_sym_mutable] = ACTIONS(4573),
    [anon_sym_constinit] = ACTIONS(4573),
    [anon_sym_consteval] = ACTIONS(4573),
    [anon_sym_alignas] = ACTIONS(4573),
    [anon_sym__Alignas] = ACTIONS(4573),
    [sym_primitive_type] = ACTIONS(4573),
    [anon_sym_enum] = ACTIONS(4573),
    [anon_sym_class] = ACTIONS(4573),
    [anon_sym_struct] = ACTIONS(4573),
    [anon_sym_union] = ACTIONS(4573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4573),
    [anon_sym_let] = ACTIONS(4573),
    [anon_sym_This] = ACTIONS(4573),
    [anon_sym_decltype] = ACTIONS(4573),
    [sym_virtual] = ACTIONS(4573),
    [anon_sym_explicit] = ACTIONS(4573),
    [anon_sym_typename] = ACTIONS(4573),
    [anon_sym_template] = ACTIONS(4573),
    [anon_sym_operator] = ACTIONS(4573),
    [anon_sym_precise] = ACTIONS(4573),
    [anon_sym_shared] = ACTIONS(4573),
    [anon_sym_groupshared] = ACTIONS(4573),
    [anon_sym_uniform] = ACTIONS(4573),
    [anon_sym_row_major] = ACTIONS(4573),
    [anon_sym_column_major] = ACTIONS(4573),
    [anon_sym_globallycoherent] = ACTIONS(4573),
    [anon_sym_centroid] = ACTIONS(4573),
    [anon_sym_noperspective] = ACTIONS(4573),
    [anon_sym_nointerpolation] = ACTIONS(4573),
    [anon_sym_sample] = ACTIONS(4573),
    [anon_sym_linear] = ACTIONS(4573),
    [anon_sym_snorm] = ACTIONS(4573),
    [anon_sym_unorm] = ACTIONS(4573),
    [anon_sym_point] = ACTIONS(4573),
    [anon_sym_line] = ACTIONS(4573),
    [anon_sym_triangleadj] = ACTIONS(4573),
    [anon_sym_lineadj] = ACTIONS(4573),
    [anon_sym_triangle] = ACTIONS(4573),
    [anon_sym_interface] = ACTIONS(4573),
    [anon_sym_extension] = ACTIONS(4573),
  },
  [2784] = {
    [sym_string_literal] = STATE(2792),
    [sym_template_argument_list] = STATE(3167),
    [sym_raw_string_literal] = STATE(2792),
    [sym_identifier] = ACTIONS(2128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_RPAREN] = ACTIONS(2117),
    [aux_sym_preproc_if_token2] = ACTIONS(2117),
    [aux_sym_preproc_else_token1] = ACTIONS(2117),
    [aux_sym_preproc_elif_token1] = ACTIONS(2128),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2117),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(6428),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON] = ACTIONS(2128),
    [anon_sym_SEMI] = ACTIONS(2117),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_RBRACE] = ACTIONS(2117),
    [anon_sym_LBRACK] = ACTIONS(2117),
    [anon_sym_RBRACK] = ACTIONS(2117),
    [anon_sym_EQ] = ACTIONS(2128),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2117),
    [anon_sym_SLASH_EQ] = ACTIONS(2117),
    [anon_sym_PERCENT_EQ] = ACTIONS(2117),
    [anon_sym_PLUS_EQ] = ACTIONS(2117),
    [anon_sym_DASH_EQ] = ACTIONS(2117),
    [anon_sym_LT_LT_EQ] = ACTIONS(2117),
    [anon_sym_GT_GT_EQ] = ACTIONS(2117),
    [anon_sym_AMP_EQ] = ACTIONS(2117),
    [anon_sym_CARET_EQ] = ACTIONS(2117),
    [anon_sym_PIPE_EQ] = ACTIONS(2117),
    [anon_sym_and_eq] = ACTIONS(2128),
    [anon_sym_or_eq] = ACTIONS(2128),
    [anon_sym_xor_eq] = ACTIONS(2128),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2128),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2128),
    [anon_sym_not_eq] = ACTIONS(2128),
    [anon_sym_is] = ACTIONS(2128),
    [anon_sym_as] = ACTIONS(2128),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
  },
  [2785] = {
    [sym_identifier] = ACTIONS(6253),
    [anon_sym_LPAREN2] = ACTIONS(6255),
    [anon_sym_TILDE] = ACTIONS(6255),
    [anon_sym_STAR] = ACTIONS(6255),
    [anon_sym_AMP_AMP] = ACTIONS(6255),
    [anon_sym_AMP] = ACTIONS(6253),
    [anon_sym___extension__] = ACTIONS(6253),
    [anon_sym_in] = ACTIONS(6253),
    [anon_sym_out] = ACTIONS(6253),
    [anon_sym_inout] = ACTIONS(6253),
    [anon_sym_extern] = ACTIONS(6253),
    [anon_sym___attribute__] = ACTIONS(6253),
    [anon_sym_COLON_COLON] = ACTIONS(6255),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6255),
    [anon_sym___declspec] = ACTIONS(6253),
    [anon_sym___based] = ACTIONS(6253),
    [anon_sym_signed] = ACTIONS(6253),
    [anon_sym_unsigned] = ACTIONS(6253),
    [anon_sym_long] = ACTIONS(6253),
    [anon_sym_short] = ACTIONS(6253),
    [anon_sym_LBRACK] = ACTIONS(6253),
    [anon_sym_static] = ACTIONS(6253),
    [anon_sym_register] = ACTIONS(6253),
    [anon_sym_inline] = ACTIONS(6253),
    [anon_sym___inline] = ACTIONS(6253),
    [anon_sym___inline__] = ACTIONS(6253),
    [anon_sym___forceinline] = ACTIONS(6253),
    [anon_sym_thread_local] = ACTIONS(6253),
    [anon_sym___thread] = ACTIONS(6253),
    [anon_sym_const] = ACTIONS(6253),
    [anon_sym_constexpr] = ACTIONS(6253),
    [anon_sym_volatile] = ACTIONS(6253),
    [anon_sym_restrict] = ACTIONS(6253),
    [anon_sym___restrict__] = ACTIONS(6253),
    [anon_sym__Atomic] = ACTIONS(6253),
    [anon_sym__Noreturn] = ACTIONS(6253),
    [anon_sym_noreturn] = ACTIONS(6253),
    [anon_sym_mutable] = ACTIONS(6253),
    [anon_sym_constinit] = ACTIONS(6253),
    [anon_sym_consteval] = ACTIONS(6253),
    [anon_sym_alignas] = ACTIONS(6253),
    [anon_sym__Alignas] = ACTIONS(6253),
    [sym_primitive_type] = ACTIONS(6253),
    [anon_sym_enum] = ACTIONS(6253),
    [anon_sym_class] = ACTIONS(6253),
    [anon_sym_struct] = ACTIONS(6253),
    [anon_sym_union] = ACTIONS(6253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6253),
    [anon_sym_let] = ACTIONS(6253),
    [anon_sym_This] = ACTIONS(6253),
    [anon_sym_decltype] = ACTIONS(6253),
    [sym_virtual] = ACTIONS(6253),
    [anon_sym_explicit] = ACTIONS(6253),
    [anon_sym_typename] = ACTIONS(6253),
    [anon_sym_template] = ACTIONS(6253),
    [anon_sym_operator] = ACTIONS(6253),
    [anon_sym_precise] = ACTIONS(6253),
    [anon_sym_shared] = ACTIONS(6253),
    [anon_sym_groupshared] = ACTIONS(6253),
    [anon_sym_uniform] = ACTIONS(6253),
    [anon_sym_row_major] = ACTIONS(6253),
    [anon_sym_column_major] = ACTIONS(6253),
    [anon_sym_globallycoherent] = ACTIONS(6253),
    [anon_sym_centroid] = ACTIONS(6253),
    [anon_sym_noperspective] = ACTIONS(6253),
    [anon_sym_nointerpolation] = ACTIONS(6253),
    [anon_sym_sample] = ACTIONS(6253),
    [anon_sym_linear] = ACTIONS(6253),
    [anon_sym_snorm] = ACTIONS(6253),
    [anon_sym_unorm] = ACTIONS(6253),
    [anon_sym_point] = ACTIONS(6253),
    [anon_sym_line] = ACTIONS(6253),
    [anon_sym_triangleadj] = ACTIONS(6253),
    [anon_sym_lineadj] = ACTIONS(6253),
    [anon_sym_triangle] = ACTIONS(6253),
    [anon_sym_interface] = ACTIONS(6253),
    [anon_sym_extension] = ACTIONS(6253),
  },
  [2786] = {
    [sym_identifier] = ACTIONS(6431),
    [anon_sym___extension__] = ACTIONS(6431),
    [anon_sym_in] = ACTIONS(6431),
    [anon_sym_out] = ACTIONS(6431),
    [anon_sym_inout] = ACTIONS(6431),
    [anon_sym_extern] = ACTIONS(6431),
    [anon_sym___attribute__] = ACTIONS(6431),
    [anon_sym_COLON_COLON] = ACTIONS(6433),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6433),
    [anon_sym___declspec] = ACTIONS(6431),
    [anon_sym___cdecl] = ACTIONS(6431),
    [anon_sym___clrcall] = ACTIONS(6431),
    [anon_sym___stdcall] = ACTIONS(6431),
    [anon_sym___fastcall] = ACTIONS(6431),
    [anon_sym___thiscall] = ACTIONS(6431),
    [anon_sym___vectorcall] = ACTIONS(6431),
    [anon_sym_LBRACE] = ACTIONS(6433),
    [anon_sym_signed] = ACTIONS(6431),
    [anon_sym_unsigned] = ACTIONS(6431),
    [anon_sym_long] = ACTIONS(6431),
    [anon_sym_short] = ACTIONS(6431),
    [anon_sym_LBRACK] = ACTIONS(6431),
    [anon_sym_static] = ACTIONS(6431),
    [anon_sym_register] = ACTIONS(6431),
    [anon_sym_inline] = ACTIONS(6431),
    [anon_sym___inline] = ACTIONS(6431),
    [anon_sym___inline__] = ACTIONS(6431),
    [anon_sym___forceinline] = ACTIONS(6431),
    [anon_sym_thread_local] = ACTIONS(6431),
    [anon_sym___thread] = ACTIONS(6431),
    [anon_sym_const] = ACTIONS(6431),
    [anon_sym_constexpr] = ACTIONS(6431),
    [anon_sym_volatile] = ACTIONS(6431),
    [anon_sym_restrict] = ACTIONS(6431),
    [anon_sym___restrict__] = ACTIONS(6431),
    [anon_sym__Atomic] = ACTIONS(6431),
    [anon_sym__Noreturn] = ACTIONS(6431),
    [anon_sym_noreturn] = ACTIONS(6431),
    [anon_sym_mutable] = ACTIONS(6431),
    [anon_sym_constinit] = ACTIONS(6431),
    [anon_sym_consteval] = ACTIONS(6431),
    [anon_sym_alignas] = ACTIONS(6431),
    [anon_sym__Alignas] = ACTIONS(6431),
    [sym_primitive_type] = ACTIONS(6431),
    [anon_sym_enum] = ACTIONS(6431),
    [anon_sym_class] = ACTIONS(6431),
    [anon_sym_struct] = ACTIONS(6431),
    [anon_sym_union] = ACTIONS(6431),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6431),
    [anon_sym_let] = ACTIONS(6431),
    [anon_sym_This] = ACTIONS(6431),
    [anon_sym_decltype] = ACTIONS(6431),
    [sym_virtual] = ACTIONS(6431),
    [anon_sym_typename] = ACTIONS(6431),
    [anon_sym_template] = ACTIONS(6431),
    [anon_sym_precise] = ACTIONS(6431),
    [anon_sym_shared] = ACTIONS(6431),
    [anon_sym_groupshared] = ACTIONS(6431),
    [anon_sym_uniform] = ACTIONS(6431),
    [anon_sym_row_major] = ACTIONS(6431),
    [anon_sym_column_major] = ACTIONS(6431),
    [anon_sym_globallycoherent] = ACTIONS(6431),
    [anon_sym_centroid] = ACTIONS(6431),
    [anon_sym_noperspective] = ACTIONS(6431),
    [anon_sym_nointerpolation] = ACTIONS(6431),
    [anon_sym_sample] = ACTIONS(6431),
    [anon_sym_linear] = ACTIONS(6431),
    [anon_sym_snorm] = ACTIONS(6431),
    [anon_sym_unorm] = ACTIONS(6431),
    [anon_sym_point] = ACTIONS(6431),
    [anon_sym_line] = ACTIONS(6431),
    [anon_sym_triangleadj] = ACTIONS(6431),
    [anon_sym_lineadj] = ACTIONS(6431),
    [anon_sym_triangle] = ACTIONS(6431),
    [anon_sym_interface] = ACTIONS(6431),
    [anon_sym_extension] = ACTIONS(6431),
  },
  [2787] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2242),
    [anon_sym_RPAREN] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2240),
    [anon_sym_PLUS] = ACTIONS(2240),
    [anon_sym_STAR] = ACTIONS(2240),
    [anon_sym_SLASH] = ACTIONS(2240),
    [anon_sym_PERCENT] = ACTIONS(2240),
    [anon_sym_PIPE_PIPE] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_PIPE] = ACTIONS(2240),
    [anon_sym_CARET] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2240),
    [anon_sym_EQ_EQ] = ACTIONS(2242),
    [anon_sym_BANG_EQ] = ACTIONS(2242),
    [anon_sym_GT] = ACTIONS(2240),
    [anon_sym_GT_EQ] = ACTIONS(2242),
    [anon_sym_LT_EQ] = ACTIONS(2240),
    [anon_sym_LT] = ACTIONS(2240),
    [anon_sym_LT_LT] = ACTIONS(2240),
    [anon_sym_GT_GT] = ACTIONS(2240),
    [anon_sym_COLON] = ACTIONS(2240),
    [anon_sym___extension__] = ACTIONS(2242),
    [anon_sym___attribute__] = ACTIONS(2242),
    [anon_sym_COLON_COLON] = ACTIONS(2242),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_EQ] = ACTIONS(2240),
    [anon_sym_const] = ACTIONS(2240),
    [anon_sym_constexpr] = ACTIONS(2242),
    [anon_sym_volatile] = ACTIONS(2242),
    [anon_sym_restrict] = ACTIONS(2242),
    [anon_sym___restrict__] = ACTIONS(2242),
    [anon_sym__Atomic] = ACTIONS(2242),
    [anon_sym__Noreturn] = ACTIONS(2242),
    [anon_sym_noreturn] = ACTIONS(2242),
    [anon_sym_mutable] = ACTIONS(2242),
    [anon_sym_constinit] = ACTIONS(2242),
    [anon_sym_consteval] = ACTIONS(2242),
    [anon_sym_alignas] = ACTIONS(2242),
    [anon_sym__Alignas] = ACTIONS(2242),
    [anon_sym_QMARK] = ACTIONS(2242),
    [anon_sym_STAR_EQ] = ACTIONS(2242),
    [anon_sym_SLASH_EQ] = ACTIONS(2242),
    [anon_sym_PERCENT_EQ] = ACTIONS(2242),
    [anon_sym_PLUS_EQ] = ACTIONS(2242),
    [anon_sym_DASH_EQ] = ACTIONS(2242),
    [anon_sym_LT_LT_EQ] = ACTIONS(2242),
    [anon_sym_GT_GT_EQ] = ACTIONS(2242),
    [anon_sym_AMP_EQ] = ACTIONS(2242),
    [anon_sym_CARET_EQ] = ACTIONS(2242),
    [anon_sym_PIPE_EQ] = ACTIONS(2242),
    [anon_sym_and_eq] = ACTIONS(2242),
    [anon_sym_or_eq] = ACTIONS(2242),
    [anon_sym_xor_eq] = ACTIONS(2242),
    [anon_sym_LT_EQ_GT] = ACTIONS(2242),
    [anon_sym_or] = ACTIONS(2240),
    [anon_sym_and] = ACTIONS(2240),
    [anon_sym_bitor] = ACTIONS(2242),
    [anon_sym_xor] = ACTIONS(2240),
    [anon_sym_bitand] = ACTIONS(2242),
    [anon_sym_not_eq] = ACTIONS(2242),
    [anon_sym_is] = ACTIONS(2242),
    [anon_sym_as] = ACTIONS(2242),
    [anon_sym_DASH_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_PLUS] = ACTIONS(2242),
    [anon_sym_DOT] = ACTIONS(2240),
    [anon_sym_DOT_STAR] = ACTIONS(2242),
    [anon_sym_DASH_GT] = ACTIONS(2240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2242),
    [anon_sym_let] = ACTIONS(2242),
    [anon_sym_This] = ACTIONS(2242),
    [anon_sym_final] = ACTIONS(2242),
    [anon_sym_override] = ACTIONS(2242),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2242),
  },
  [2788] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2258),
    [anon_sym_COMMA] = ACTIONS(2258),
    [anon_sym_RPAREN] = ACTIONS(2258),
    [anon_sym_LPAREN2] = ACTIONS(2258),
    [anon_sym_DASH] = ACTIONS(2256),
    [anon_sym_PLUS] = ACTIONS(2256),
    [anon_sym_STAR] = ACTIONS(2256),
    [anon_sym_SLASH] = ACTIONS(2256),
    [anon_sym_PERCENT] = ACTIONS(2256),
    [anon_sym_PIPE_PIPE] = ACTIONS(2258),
    [anon_sym_AMP_AMP] = ACTIONS(2258),
    [anon_sym_PIPE] = ACTIONS(2256),
    [anon_sym_CARET] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(2256),
    [anon_sym_EQ_EQ] = ACTIONS(2258),
    [anon_sym_BANG_EQ] = ACTIONS(2258),
    [anon_sym_GT] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2258),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_LT] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2256),
    [anon_sym_GT_GT] = ACTIONS(2256),
    [anon_sym_COLON] = ACTIONS(2256),
    [anon_sym___extension__] = ACTIONS(2258),
    [anon_sym___attribute__] = ACTIONS(2258),
    [anon_sym_COLON_COLON] = ACTIONS(2258),
    [anon_sym_LBRACE] = ACTIONS(2258),
    [anon_sym_LBRACK] = ACTIONS(2258),
    [anon_sym_EQ] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_constexpr] = ACTIONS(2258),
    [anon_sym_volatile] = ACTIONS(2258),
    [anon_sym_restrict] = ACTIONS(2258),
    [anon_sym___restrict__] = ACTIONS(2258),
    [anon_sym__Atomic] = ACTIONS(2258),
    [anon_sym__Noreturn] = ACTIONS(2258),
    [anon_sym_noreturn] = ACTIONS(2258),
    [anon_sym_mutable] = ACTIONS(2258),
    [anon_sym_constinit] = ACTIONS(2258),
    [anon_sym_consteval] = ACTIONS(2258),
    [anon_sym_alignas] = ACTIONS(2258),
    [anon_sym__Alignas] = ACTIONS(2258),
    [anon_sym_QMARK] = ACTIONS(2258),
    [anon_sym_STAR_EQ] = ACTIONS(2258),
    [anon_sym_SLASH_EQ] = ACTIONS(2258),
    [anon_sym_PERCENT_EQ] = ACTIONS(2258),
    [anon_sym_PLUS_EQ] = ACTIONS(2258),
    [anon_sym_DASH_EQ] = ACTIONS(2258),
    [anon_sym_LT_LT_EQ] = ACTIONS(2258),
    [anon_sym_GT_GT_EQ] = ACTIONS(2258),
    [anon_sym_AMP_EQ] = ACTIONS(2258),
    [anon_sym_CARET_EQ] = ACTIONS(2258),
    [anon_sym_PIPE_EQ] = ACTIONS(2258),
    [anon_sym_and_eq] = ACTIONS(2258),
    [anon_sym_or_eq] = ACTIONS(2258),
    [anon_sym_xor_eq] = ACTIONS(2258),
    [anon_sym_LT_EQ_GT] = ACTIONS(2258),
    [anon_sym_or] = ACTIONS(2256),
    [anon_sym_and] = ACTIONS(2256),
    [anon_sym_bitor] = ACTIONS(2258),
    [anon_sym_xor] = ACTIONS(2256),
    [anon_sym_bitand] = ACTIONS(2258),
    [anon_sym_not_eq] = ACTIONS(2258),
    [anon_sym_is] = ACTIONS(2258),
    [anon_sym_as] = ACTIONS(2258),
    [anon_sym_DASH_DASH] = ACTIONS(2258),
    [anon_sym_PLUS_PLUS] = ACTIONS(2258),
    [anon_sym_DOT] = ACTIONS(2256),
    [anon_sym_DOT_STAR] = ACTIONS(2258),
    [anon_sym_DASH_GT] = ACTIONS(2256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2258),
    [anon_sym_let] = ACTIONS(2258),
    [anon_sym_This] = ACTIONS(2258),
    [anon_sym_final] = ACTIONS(2258),
    [anon_sym_override] = ACTIONS(2258),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2258),
  },
  [2789] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_COMMA] = ACTIONS(2200),
    [anon_sym_RPAREN] = ACTIONS(2200),
    [anon_sym_LPAREN2] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(2198),
    [anon_sym_SLASH] = ACTIONS(2198),
    [anon_sym_PERCENT] = ACTIONS(2198),
    [anon_sym_PIPE_PIPE] = ACTIONS(2200),
    [anon_sym_AMP_AMP] = ACTIONS(2200),
    [anon_sym_PIPE] = ACTIONS(2198),
    [anon_sym_CARET] = ACTIONS(2198),
    [anon_sym_AMP] = ACTIONS(2198),
    [anon_sym_EQ_EQ] = ACTIONS(2200),
    [anon_sym_BANG_EQ] = ACTIONS(2200),
    [anon_sym_GT] = ACTIONS(2198),
    [anon_sym_GT_EQ] = ACTIONS(2200),
    [anon_sym_LT_EQ] = ACTIONS(2198),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_LT_LT] = ACTIONS(2198),
    [anon_sym_GT_GT] = ACTIONS(2198),
    [anon_sym_COLON] = ACTIONS(2198),
    [anon_sym___extension__] = ACTIONS(2200),
    [anon_sym___attribute__] = ACTIONS(2200),
    [anon_sym_COLON_COLON] = ACTIONS(2200),
    [anon_sym_LBRACE] = ACTIONS(2200),
    [anon_sym_LBRACK] = ACTIONS(2200),
    [anon_sym_EQ] = ACTIONS(2198),
    [anon_sym_const] = ACTIONS(2198),
    [anon_sym_constexpr] = ACTIONS(2200),
    [anon_sym_volatile] = ACTIONS(2200),
    [anon_sym_restrict] = ACTIONS(2200),
    [anon_sym___restrict__] = ACTIONS(2200),
    [anon_sym__Atomic] = ACTIONS(2200),
    [anon_sym__Noreturn] = ACTIONS(2200),
    [anon_sym_noreturn] = ACTIONS(2200),
    [anon_sym_mutable] = ACTIONS(2200),
    [anon_sym_constinit] = ACTIONS(2200),
    [anon_sym_consteval] = ACTIONS(2200),
    [anon_sym_alignas] = ACTIONS(2200),
    [anon_sym__Alignas] = ACTIONS(2200),
    [anon_sym_QMARK] = ACTIONS(2200),
    [anon_sym_STAR_EQ] = ACTIONS(2200),
    [anon_sym_SLASH_EQ] = ACTIONS(2200),
    [anon_sym_PERCENT_EQ] = ACTIONS(2200),
    [anon_sym_PLUS_EQ] = ACTIONS(2200),
    [anon_sym_DASH_EQ] = ACTIONS(2200),
    [anon_sym_LT_LT_EQ] = ACTIONS(2200),
    [anon_sym_GT_GT_EQ] = ACTIONS(2200),
    [anon_sym_AMP_EQ] = ACTIONS(2200),
    [anon_sym_CARET_EQ] = ACTIONS(2200),
    [anon_sym_PIPE_EQ] = ACTIONS(2200),
    [anon_sym_and_eq] = ACTIONS(2200),
    [anon_sym_or_eq] = ACTIONS(2200),
    [anon_sym_xor_eq] = ACTIONS(2200),
    [anon_sym_LT_EQ_GT] = ACTIONS(2200),
    [anon_sym_or] = ACTIONS(2198),
    [anon_sym_and] = ACTIONS(2198),
    [anon_sym_bitor] = ACTIONS(2200),
    [anon_sym_xor] = ACTIONS(2198),
    [anon_sym_bitand] = ACTIONS(2200),
    [anon_sym_not_eq] = ACTIONS(2200),
    [anon_sym_is] = ACTIONS(2200),
    [anon_sym_as] = ACTIONS(2200),
    [anon_sym_DASH_DASH] = ACTIONS(2200),
    [anon_sym_PLUS_PLUS] = ACTIONS(2200),
    [anon_sym_DOT] = ACTIONS(2198),
    [anon_sym_DOT_STAR] = ACTIONS(2200),
    [anon_sym_DASH_GT] = ACTIONS(2198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2200),
    [anon_sym_let] = ACTIONS(2200),
    [anon_sym_This] = ACTIONS(2200),
    [anon_sym_final] = ACTIONS(2200),
    [anon_sym_override] = ACTIONS(2200),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2200),
  },
  [2790] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_LPAREN2] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2186),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_STAR] = ACTIONS(2186),
    [anon_sym_SLASH] = ACTIONS(2186),
    [anon_sym_PERCENT] = ACTIONS(2186),
    [anon_sym_PIPE_PIPE] = ACTIONS(2188),
    [anon_sym_AMP_AMP] = ACTIONS(2188),
    [anon_sym_PIPE] = ACTIONS(2186),
    [anon_sym_CARET] = ACTIONS(2186),
    [anon_sym_AMP] = ACTIONS(2186),
    [anon_sym_EQ_EQ] = ACTIONS(2188),
    [anon_sym_BANG_EQ] = ACTIONS(2188),
    [anon_sym_GT] = ACTIONS(2186),
    [anon_sym_GT_EQ] = ACTIONS(2188),
    [anon_sym_LT_EQ] = ACTIONS(2186),
    [anon_sym_LT] = ACTIONS(2186),
    [anon_sym_LT_LT] = ACTIONS(2186),
    [anon_sym_GT_GT] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym___extension__] = ACTIONS(2188),
    [anon_sym___attribute__] = ACTIONS(2188),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_LBRACK] = ACTIONS(2188),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_constexpr] = ACTIONS(2188),
    [anon_sym_volatile] = ACTIONS(2188),
    [anon_sym_restrict] = ACTIONS(2188),
    [anon_sym___restrict__] = ACTIONS(2188),
    [anon_sym__Atomic] = ACTIONS(2188),
    [anon_sym__Noreturn] = ACTIONS(2188),
    [anon_sym_noreturn] = ACTIONS(2188),
    [anon_sym_mutable] = ACTIONS(2188),
    [anon_sym_constinit] = ACTIONS(2188),
    [anon_sym_consteval] = ACTIONS(2188),
    [anon_sym_alignas] = ACTIONS(2188),
    [anon_sym__Alignas] = ACTIONS(2188),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_STAR_EQ] = ACTIONS(2188),
    [anon_sym_SLASH_EQ] = ACTIONS(2188),
    [anon_sym_PERCENT_EQ] = ACTIONS(2188),
    [anon_sym_PLUS_EQ] = ACTIONS(2188),
    [anon_sym_DASH_EQ] = ACTIONS(2188),
    [anon_sym_LT_LT_EQ] = ACTIONS(2188),
    [anon_sym_GT_GT_EQ] = ACTIONS(2188),
    [anon_sym_AMP_EQ] = ACTIONS(2188),
    [anon_sym_CARET_EQ] = ACTIONS(2188),
    [anon_sym_PIPE_EQ] = ACTIONS(2188),
    [anon_sym_and_eq] = ACTIONS(2188),
    [anon_sym_or_eq] = ACTIONS(2188),
    [anon_sym_xor_eq] = ACTIONS(2188),
    [anon_sym_LT_EQ_GT] = ACTIONS(2188),
    [anon_sym_or] = ACTIONS(2186),
    [anon_sym_and] = ACTIONS(2186),
    [anon_sym_bitor] = ACTIONS(2188),
    [anon_sym_xor] = ACTIONS(2186),
    [anon_sym_bitand] = ACTIONS(2188),
    [anon_sym_not_eq] = ACTIONS(2188),
    [anon_sym_is] = ACTIONS(2188),
    [anon_sym_as] = ACTIONS(2188),
    [anon_sym_DASH_DASH] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2188),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOT_STAR] = ACTIONS(2188),
    [anon_sym_DASH_GT] = ACTIONS(2186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2188),
    [anon_sym_let] = ACTIONS(2188),
    [anon_sym_This] = ACTIONS(2188),
    [anon_sym_final] = ACTIONS(2188),
    [anon_sym_override] = ACTIONS(2188),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2188),
  },
  [2791] = {
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_COMMA] = ACTIONS(2371),
    [anon_sym_RPAREN] = ACTIONS(2371),
    [anon_sym_LPAREN2] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_COLON] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym___extension__] = ACTIONS(2373),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_out] = ACTIONS(2373),
    [anon_sym_inout] = ACTIONS(2373),
    [anon_sym_extern] = ACTIONS(2373),
    [anon_sym___attribute__] = ACTIONS(2373),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2371),
    [anon_sym___declspec] = ACTIONS(2373),
    [anon_sym___based] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_LBRACK] = ACTIONS(2373),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_EQ] = ACTIONS(2371),
    [anon_sym_register] = ACTIONS(2373),
    [anon_sym_inline] = ACTIONS(2373),
    [anon_sym___inline] = ACTIONS(2373),
    [anon_sym___inline__] = ACTIONS(2373),
    [anon_sym___forceinline] = ACTIONS(2373),
    [anon_sym_thread_local] = ACTIONS(2373),
    [anon_sym___thread] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym___restrict__] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym__Noreturn] = ACTIONS(2373),
    [anon_sym_noreturn] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_constinit] = ACTIONS(2373),
    [anon_sym_consteval] = ACTIONS(2373),
    [anon_sym_alignas] = ACTIONS(2373),
    [anon_sym__Alignas] = ACTIONS(2373),
    [anon_sym_or] = ACTIONS(2373),
    [anon_sym_and] = ACTIONS(2373),
    [anon_sym_DOT] = ACTIONS(2371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_This] = ACTIONS(2373),
    [anon_sym_final] = ACTIONS(2373),
    [anon_sym_override] = ACTIONS(2373),
    [sym_virtual] = ACTIONS(2373),
    [anon_sym_GT2] = ACTIONS(2371),
    [anon_sym_operator] = ACTIONS(2373),
    [anon_sym_try] = ACTIONS(2373),
    [anon_sym_requires] = ACTIONS(2373),
    [anon_sym_precise] = ACTIONS(2373),
    [anon_sym_shared] = ACTIONS(2373),
    [anon_sym_groupshared] = ACTIONS(2373),
    [anon_sym_uniform] = ACTIONS(2373),
    [anon_sym_row_major] = ACTIONS(2373),
    [anon_sym_column_major] = ACTIONS(2373),
    [anon_sym_globallycoherent] = ACTIONS(2373),
    [anon_sym_centroid] = ACTIONS(2373),
    [anon_sym_noperspective] = ACTIONS(2373),
    [anon_sym_nointerpolation] = ACTIONS(2373),
    [anon_sym_sample] = ACTIONS(2373),
    [anon_sym_linear] = ACTIONS(2373),
    [anon_sym_snorm] = ACTIONS(2373),
    [anon_sym_unorm] = ACTIONS(2373),
    [anon_sym_point] = ACTIONS(2373),
    [anon_sym_line] = ACTIONS(2373),
    [anon_sym_triangleadj] = ACTIONS(2373),
    [anon_sym_lineadj] = ACTIONS(2373),
    [anon_sym_triangle] = ACTIONS(2373),
    [anon_sym_where] = ACTIONS(2373),
  },
  [2792] = {
    [sym_string_literal] = STATE(2804),
    [sym_raw_string_literal] = STATE(2804),
    [aux_sym_concatenated_string_repeat1] = STATE(2804),
    [sym_identifier] = ACTIONS(6435),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6437),
    [anon_sym_COMMA] = ACTIONS(6437),
    [anon_sym_RPAREN] = ACTIONS(6437),
    [aux_sym_preproc_if_token2] = ACTIONS(6437),
    [aux_sym_preproc_else_token1] = ACTIONS(6437),
    [aux_sym_preproc_elif_token1] = ACTIONS(6439),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6437),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6437),
    [anon_sym_LPAREN2] = ACTIONS(6437),
    [anon_sym_DASH] = ACTIONS(6439),
    [anon_sym_PLUS] = ACTIONS(6439),
    [anon_sym_STAR] = ACTIONS(6439),
    [anon_sym_SLASH] = ACTIONS(6439),
    [anon_sym_PERCENT] = ACTIONS(6439),
    [anon_sym_PIPE_PIPE] = ACTIONS(6437),
    [anon_sym_AMP_AMP] = ACTIONS(6437),
    [anon_sym_PIPE] = ACTIONS(6439),
    [anon_sym_CARET] = ACTIONS(6439),
    [anon_sym_AMP] = ACTIONS(6439),
    [anon_sym_EQ_EQ] = ACTIONS(6437),
    [anon_sym_BANG_EQ] = ACTIONS(6437),
    [anon_sym_GT] = ACTIONS(6439),
    [anon_sym_GT_EQ] = ACTIONS(6437),
    [anon_sym_LT_EQ] = ACTIONS(6439),
    [anon_sym_LT] = ACTIONS(6439),
    [anon_sym_LT_LT] = ACTIONS(6439),
    [anon_sym_GT_GT] = ACTIONS(6439),
    [anon_sym_COLON] = ACTIONS(6437),
    [anon_sym_SEMI] = ACTIONS(6437),
    [anon_sym_RBRACE] = ACTIONS(6437),
    [anon_sym_LBRACK] = ACTIONS(6437),
    [anon_sym_RBRACK] = ACTIONS(6437),
    [anon_sym_EQ] = ACTIONS(6439),
    [anon_sym_QMARK] = ACTIONS(6437),
    [anon_sym_STAR_EQ] = ACTIONS(6437),
    [anon_sym_SLASH_EQ] = ACTIONS(6437),
    [anon_sym_PERCENT_EQ] = ACTIONS(6437),
    [anon_sym_PLUS_EQ] = ACTIONS(6437),
    [anon_sym_DASH_EQ] = ACTIONS(6437),
    [anon_sym_LT_LT_EQ] = ACTIONS(6437),
    [anon_sym_GT_GT_EQ] = ACTIONS(6437),
    [anon_sym_AMP_EQ] = ACTIONS(6437),
    [anon_sym_CARET_EQ] = ACTIONS(6437),
    [anon_sym_PIPE_EQ] = ACTIONS(6437),
    [anon_sym_and_eq] = ACTIONS(6439),
    [anon_sym_or_eq] = ACTIONS(6439),
    [anon_sym_xor_eq] = ACTIONS(6439),
    [anon_sym_LT_EQ_GT] = ACTIONS(6437),
    [anon_sym_or] = ACTIONS(6439),
    [anon_sym_and] = ACTIONS(6439),
    [anon_sym_bitor] = ACTIONS(6439),
    [anon_sym_xor] = ACTIONS(6439),
    [anon_sym_bitand] = ACTIONS(6439),
    [anon_sym_not_eq] = ACTIONS(6439),
    [anon_sym_is] = ACTIONS(6439),
    [anon_sym_as] = ACTIONS(6439),
    [anon_sym_DASH_DASH] = ACTIONS(6437),
    [anon_sym_PLUS_PLUS] = ACTIONS(6437),
    [anon_sym_DOT] = ACTIONS(6439),
    [anon_sym_DOT_STAR] = ACTIONS(6437),
    [anon_sym_DASH_GT] = ACTIONS(6437),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [sym_literal_suffix] = ACTIONS(6439),
  },
  [2793] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2226),
    [anon_sym_COMMA] = ACTIONS(2226),
    [anon_sym_RPAREN] = ACTIONS(2226),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_PLUS] = ACTIONS(2224),
    [anon_sym_STAR] = ACTIONS(2224),
    [anon_sym_SLASH] = ACTIONS(2224),
    [anon_sym_PERCENT] = ACTIONS(2224),
    [anon_sym_PIPE_PIPE] = ACTIONS(2226),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_PIPE] = ACTIONS(2224),
    [anon_sym_CARET] = ACTIONS(2224),
    [anon_sym_AMP] = ACTIONS(2224),
    [anon_sym_EQ_EQ] = ACTIONS(2226),
    [anon_sym_BANG_EQ] = ACTIONS(2226),
    [anon_sym_GT] = ACTIONS(2224),
    [anon_sym_GT_EQ] = ACTIONS(2226),
    [anon_sym_LT_EQ] = ACTIONS(2224),
    [anon_sym_LT] = ACTIONS(2224),
    [anon_sym_LT_LT] = ACTIONS(2224),
    [anon_sym_GT_GT] = ACTIONS(2224),
    [anon_sym_COLON] = ACTIONS(2224),
    [anon_sym___extension__] = ACTIONS(2226),
    [anon_sym___attribute__] = ACTIONS(2226),
    [anon_sym_COLON_COLON] = ACTIONS(2226),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_EQ] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_constexpr] = ACTIONS(2226),
    [anon_sym_volatile] = ACTIONS(2226),
    [anon_sym_restrict] = ACTIONS(2226),
    [anon_sym___restrict__] = ACTIONS(2226),
    [anon_sym__Atomic] = ACTIONS(2226),
    [anon_sym__Noreturn] = ACTIONS(2226),
    [anon_sym_noreturn] = ACTIONS(2226),
    [anon_sym_mutable] = ACTIONS(2226),
    [anon_sym_constinit] = ACTIONS(2226),
    [anon_sym_consteval] = ACTIONS(2226),
    [anon_sym_alignas] = ACTIONS(2226),
    [anon_sym__Alignas] = ACTIONS(2226),
    [anon_sym_QMARK] = ACTIONS(2226),
    [anon_sym_STAR_EQ] = ACTIONS(2226),
    [anon_sym_SLASH_EQ] = ACTIONS(2226),
    [anon_sym_PERCENT_EQ] = ACTIONS(2226),
    [anon_sym_PLUS_EQ] = ACTIONS(2226),
    [anon_sym_DASH_EQ] = ACTIONS(2226),
    [anon_sym_LT_LT_EQ] = ACTIONS(2226),
    [anon_sym_GT_GT_EQ] = ACTIONS(2226),
    [anon_sym_AMP_EQ] = ACTIONS(2226),
    [anon_sym_CARET_EQ] = ACTIONS(2226),
    [anon_sym_PIPE_EQ] = ACTIONS(2226),
    [anon_sym_and_eq] = ACTIONS(2226),
    [anon_sym_or_eq] = ACTIONS(2226),
    [anon_sym_xor_eq] = ACTIONS(2226),
    [anon_sym_LT_EQ_GT] = ACTIONS(2226),
    [anon_sym_or] = ACTIONS(2224),
    [anon_sym_and] = ACTIONS(2224),
    [anon_sym_bitor] = ACTIONS(2226),
    [anon_sym_xor] = ACTIONS(2224),
    [anon_sym_bitand] = ACTIONS(2226),
    [anon_sym_not_eq] = ACTIONS(2226),
    [anon_sym_is] = ACTIONS(2226),
    [anon_sym_as] = ACTIONS(2226),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_DOT] = ACTIONS(2224),
    [anon_sym_DOT_STAR] = ACTIONS(2226),
    [anon_sym_DASH_GT] = ACTIONS(2224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2226),
    [anon_sym_let] = ACTIONS(2226),
    [anon_sym_This] = ACTIONS(2226),
    [anon_sym_final] = ACTIONS(2226),
    [anon_sym_override] = ACTIONS(2226),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2226),
  },
  [2794] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2238),
    [anon_sym_COMMA] = ACTIONS(2238),
    [anon_sym_RPAREN] = ACTIONS(2238),
    [anon_sym_LPAREN2] = ACTIONS(2238),
    [anon_sym_DASH] = ACTIONS(2236),
    [anon_sym_PLUS] = ACTIONS(2236),
    [anon_sym_STAR] = ACTIONS(2236),
    [anon_sym_SLASH] = ACTIONS(2236),
    [anon_sym_PERCENT] = ACTIONS(2236),
    [anon_sym_PIPE_PIPE] = ACTIONS(2238),
    [anon_sym_AMP_AMP] = ACTIONS(2238),
    [anon_sym_PIPE] = ACTIONS(2236),
    [anon_sym_CARET] = ACTIONS(2236),
    [anon_sym_AMP] = ACTIONS(2236),
    [anon_sym_EQ_EQ] = ACTIONS(2238),
    [anon_sym_BANG_EQ] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2236),
    [anon_sym_GT_EQ] = ACTIONS(2238),
    [anon_sym_LT_EQ] = ACTIONS(2236),
    [anon_sym_LT] = ACTIONS(2236),
    [anon_sym_LT_LT] = ACTIONS(2236),
    [anon_sym_GT_GT] = ACTIONS(2236),
    [anon_sym_COLON] = ACTIONS(2236),
    [anon_sym___extension__] = ACTIONS(2238),
    [anon_sym___attribute__] = ACTIONS(2238),
    [anon_sym_COLON_COLON] = ACTIONS(2238),
    [anon_sym_LBRACE] = ACTIONS(2238),
    [anon_sym_LBRACK] = ACTIONS(2238),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_const] = ACTIONS(2236),
    [anon_sym_constexpr] = ACTIONS(2238),
    [anon_sym_volatile] = ACTIONS(2238),
    [anon_sym_restrict] = ACTIONS(2238),
    [anon_sym___restrict__] = ACTIONS(2238),
    [anon_sym__Atomic] = ACTIONS(2238),
    [anon_sym__Noreturn] = ACTIONS(2238),
    [anon_sym_noreturn] = ACTIONS(2238),
    [anon_sym_mutable] = ACTIONS(2238),
    [anon_sym_constinit] = ACTIONS(2238),
    [anon_sym_consteval] = ACTIONS(2238),
    [anon_sym_alignas] = ACTIONS(2238),
    [anon_sym__Alignas] = ACTIONS(2238),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2238),
    [anon_sym_SLASH_EQ] = ACTIONS(2238),
    [anon_sym_PERCENT_EQ] = ACTIONS(2238),
    [anon_sym_PLUS_EQ] = ACTIONS(2238),
    [anon_sym_DASH_EQ] = ACTIONS(2238),
    [anon_sym_LT_LT_EQ] = ACTIONS(2238),
    [anon_sym_GT_GT_EQ] = ACTIONS(2238),
    [anon_sym_AMP_EQ] = ACTIONS(2238),
    [anon_sym_CARET_EQ] = ACTIONS(2238),
    [anon_sym_PIPE_EQ] = ACTIONS(2238),
    [anon_sym_and_eq] = ACTIONS(2238),
    [anon_sym_or_eq] = ACTIONS(2238),
    [anon_sym_xor_eq] = ACTIONS(2238),
    [anon_sym_LT_EQ_GT] = ACTIONS(2238),
    [anon_sym_or] = ACTIONS(2236),
    [anon_sym_and] = ACTIONS(2236),
    [anon_sym_bitor] = ACTIONS(2238),
    [anon_sym_xor] = ACTIONS(2236),
    [anon_sym_bitand] = ACTIONS(2238),
    [anon_sym_not_eq] = ACTIONS(2238),
    [anon_sym_is] = ACTIONS(2238),
    [anon_sym_as] = ACTIONS(2238),
    [anon_sym_DASH_DASH] = ACTIONS(2238),
    [anon_sym_PLUS_PLUS] = ACTIONS(2238),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_DOT_STAR] = ACTIONS(2238),
    [anon_sym_DASH_GT] = ACTIONS(2236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2238),
    [anon_sym_let] = ACTIONS(2238),
    [anon_sym_This] = ACTIONS(2238),
    [anon_sym_final] = ACTIONS(2238),
    [anon_sym_override] = ACTIONS(2238),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2238),
  },
  [2795] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2208),
    [anon_sym_COMMA] = ACTIONS(2208),
    [anon_sym_RPAREN] = ACTIONS(2208),
    [anon_sym_LPAREN2] = ACTIONS(2208),
    [anon_sym_DASH] = ACTIONS(2206),
    [anon_sym_PLUS] = ACTIONS(2206),
    [anon_sym_STAR] = ACTIONS(2206),
    [anon_sym_SLASH] = ACTIONS(2206),
    [anon_sym_PERCENT] = ACTIONS(2206),
    [anon_sym_PIPE_PIPE] = ACTIONS(2208),
    [anon_sym_AMP_AMP] = ACTIONS(2208),
    [anon_sym_PIPE] = ACTIONS(2206),
    [anon_sym_CARET] = ACTIONS(2206),
    [anon_sym_AMP] = ACTIONS(2206),
    [anon_sym_EQ_EQ] = ACTIONS(2208),
    [anon_sym_BANG_EQ] = ACTIONS(2208),
    [anon_sym_GT] = ACTIONS(2206),
    [anon_sym_GT_EQ] = ACTIONS(2208),
    [anon_sym_LT_EQ] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2206),
    [anon_sym_LT_LT] = ACTIONS(2206),
    [anon_sym_GT_GT] = ACTIONS(2206),
    [anon_sym_COLON] = ACTIONS(2206),
    [anon_sym___extension__] = ACTIONS(2208),
    [anon_sym___attribute__] = ACTIONS(2208),
    [anon_sym_COLON_COLON] = ACTIONS(2208),
    [anon_sym_LBRACE] = ACTIONS(2208),
    [anon_sym_LBRACK] = ACTIONS(2208),
    [anon_sym_EQ] = ACTIONS(2206),
    [anon_sym_const] = ACTIONS(2206),
    [anon_sym_constexpr] = ACTIONS(2208),
    [anon_sym_volatile] = ACTIONS(2208),
    [anon_sym_restrict] = ACTIONS(2208),
    [anon_sym___restrict__] = ACTIONS(2208),
    [anon_sym__Atomic] = ACTIONS(2208),
    [anon_sym__Noreturn] = ACTIONS(2208),
    [anon_sym_noreturn] = ACTIONS(2208),
    [anon_sym_mutable] = ACTIONS(2208),
    [anon_sym_constinit] = ACTIONS(2208),
    [anon_sym_consteval] = ACTIONS(2208),
    [anon_sym_alignas] = ACTIONS(2208),
    [anon_sym__Alignas] = ACTIONS(2208),
    [anon_sym_QMARK] = ACTIONS(2208),
    [anon_sym_STAR_EQ] = ACTIONS(2208),
    [anon_sym_SLASH_EQ] = ACTIONS(2208),
    [anon_sym_PERCENT_EQ] = ACTIONS(2208),
    [anon_sym_PLUS_EQ] = ACTIONS(2208),
    [anon_sym_DASH_EQ] = ACTIONS(2208),
    [anon_sym_LT_LT_EQ] = ACTIONS(2208),
    [anon_sym_GT_GT_EQ] = ACTIONS(2208),
    [anon_sym_AMP_EQ] = ACTIONS(2208),
    [anon_sym_CARET_EQ] = ACTIONS(2208),
    [anon_sym_PIPE_EQ] = ACTIONS(2208),
    [anon_sym_and_eq] = ACTIONS(2208),
    [anon_sym_or_eq] = ACTIONS(2208),
    [anon_sym_xor_eq] = ACTIONS(2208),
    [anon_sym_LT_EQ_GT] = ACTIONS(2208),
    [anon_sym_or] = ACTIONS(2206),
    [anon_sym_and] = ACTIONS(2206),
    [anon_sym_bitor] = ACTIONS(2208),
    [anon_sym_xor] = ACTIONS(2206),
    [anon_sym_bitand] = ACTIONS(2208),
    [anon_sym_not_eq] = ACTIONS(2208),
    [anon_sym_is] = ACTIONS(2208),
    [anon_sym_as] = ACTIONS(2208),
    [anon_sym_DASH_DASH] = ACTIONS(2208),
    [anon_sym_PLUS_PLUS] = ACTIONS(2208),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_DOT_STAR] = ACTIONS(2208),
    [anon_sym_DASH_GT] = ACTIONS(2206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2208),
    [anon_sym_let] = ACTIONS(2208),
    [anon_sym_This] = ACTIONS(2208),
    [anon_sym_final] = ACTIONS(2208),
    [anon_sym_override] = ACTIONS(2208),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2208),
  },
  [2796] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_RPAREN] = ACTIONS(2204),
    [anon_sym_LPAREN2] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2202),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_STAR] = ACTIONS(2202),
    [anon_sym_SLASH] = ACTIONS(2202),
    [anon_sym_PERCENT] = ACTIONS(2202),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2202),
    [anon_sym_CARET] = ACTIONS(2202),
    [anon_sym_AMP] = ACTIONS(2202),
    [anon_sym_EQ_EQ] = ACTIONS(2204),
    [anon_sym_BANG_EQ] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(2202),
    [anon_sym_GT_EQ] = ACTIONS(2204),
    [anon_sym_LT_EQ] = ACTIONS(2202),
    [anon_sym_LT] = ACTIONS(2202),
    [anon_sym_LT_LT] = ACTIONS(2202),
    [anon_sym_GT_GT] = ACTIONS(2202),
    [anon_sym_COLON] = ACTIONS(2202),
    [anon_sym___extension__] = ACTIONS(2204),
    [anon_sym___attribute__] = ACTIONS(2204),
    [anon_sym_COLON_COLON] = ACTIONS(2204),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(2204),
    [anon_sym_EQ] = ACTIONS(2202),
    [anon_sym_const] = ACTIONS(2202),
    [anon_sym_constexpr] = ACTIONS(2204),
    [anon_sym_volatile] = ACTIONS(2204),
    [anon_sym_restrict] = ACTIONS(2204),
    [anon_sym___restrict__] = ACTIONS(2204),
    [anon_sym__Atomic] = ACTIONS(2204),
    [anon_sym__Noreturn] = ACTIONS(2204),
    [anon_sym_noreturn] = ACTIONS(2204),
    [anon_sym_mutable] = ACTIONS(2204),
    [anon_sym_constinit] = ACTIONS(2204),
    [anon_sym_consteval] = ACTIONS(2204),
    [anon_sym_alignas] = ACTIONS(2204),
    [anon_sym__Alignas] = ACTIONS(2204),
    [anon_sym_QMARK] = ACTIONS(2204),
    [anon_sym_STAR_EQ] = ACTIONS(2204),
    [anon_sym_SLASH_EQ] = ACTIONS(2204),
    [anon_sym_PERCENT_EQ] = ACTIONS(2204),
    [anon_sym_PLUS_EQ] = ACTIONS(2204),
    [anon_sym_DASH_EQ] = ACTIONS(2204),
    [anon_sym_LT_LT_EQ] = ACTIONS(2204),
    [anon_sym_GT_GT_EQ] = ACTIONS(2204),
    [anon_sym_AMP_EQ] = ACTIONS(2204),
    [anon_sym_CARET_EQ] = ACTIONS(2204),
    [anon_sym_PIPE_EQ] = ACTIONS(2204),
    [anon_sym_and_eq] = ACTIONS(2204),
    [anon_sym_or_eq] = ACTIONS(2204),
    [anon_sym_xor_eq] = ACTIONS(2204),
    [anon_sym_LT_EQ_GT] = ACTIONS(2204),
    [anon_sym_or] = ACTIONS(2202),
    [anon_sym_and] = ACTIONS(2202),
    [anon_sym_bitor] = ACTIONS(2204),
    [anon_sym_xor] = ACTIONS(2202),
    [anon_sym_bitand] = ACTIONS(2204),
    [anon_sym_not_eq] = ACTIONS(2204),
    [anon_sym_is] = ACTIONS(2204),
    [anon_sym_as] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(2202),
    [anon_sym_DOT_STAR] = ACTIONS(2204),
    [anon_sym_DASH_GT] = ACTIONS(2202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2204),
    [anon_sym_let] = ACTIONS(2204),
    [anon_sym_This] = ACTIONS(2204),
    [anon_sym_final] = ACTIONS(2204),
    [anon_sym_override] = ACTIONS(2204),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2204),
  },
  [2797] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2196),
    [anon_sym_COMMA] = ACTIONS(2196),
    [anon_sym_RPAREN] = ACTIONS(2196),
    [anon_sym_LPAREN2] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2194),
    [anon_sym_PLUS] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(2194),
    [anon_sym_SLASH] = ACTIONS(2194),
    [anon_sym_PERCENT] = ACTIONS(2194),
    [anon_sym_PIPE_PIPE] = ACTIONS(2196),
    [anon_sym_AMP_AMP] = ACTIONS(2196),
    [anon_sym_PIPE] = ACTIONS(2194),
    [anon_sym_CARET] = ACTIONS(2194),
    [anon_sym_AMP] = ACTIONS(2194),
    [anon_sym_EQ_EQ] = ACTIONS(2196),
    [anon_sym_BANG_EQ] = ACTIONS(2196),
    [anon_sym_GT] = ACTIONS(2194),
    [anon_sym_GT_EQ] = ACTIONS(2196),
    [anon_sym_LT_EQ] = ACTIONS(2194),
    [anon_sym_LT] = ACTIONS(2194),
    [anon_sym_LT_LT] = ACTIONS(2194),
    [anon_sym_GT_GT] = ACTIONS(2194),
    [anon_sym_COLON] = ACTIONS(2194),
    [anon_sym___extension__] = ACTIONS(2196),
    [anon_sym___attribute__] = ACTIONS(2196),
    [anon_sym_COLON_COLON] = ACTIONS(2196),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_LBRACK] = ACTIONS(2196),
    [anon_sym_EQ] = ACTIONS(2194),
    [anon_sym_const] = ACTIONS(2194),
    [anon_sym_constexpr] = ACTIONS(2196),
    [anon_sym_volatile] = ACTIONS(2196),
    [anon_sym_restrict] = ACTIONS(2196),
    [anon_sym___restrict__] = ACTIONS(2196),
    [anon_sym__Atomic] = ACTIONS(2196),
    [anon_sym__Noreturn] = ACTIONS(2196),
    [anon_sym_noreturn] = ACTIONS(2196),
    [anon_sym_mutable] = ACTIONS(2196),
    [anon_sym_constinit] = ACTIONS(2196),
    [anon_sym_consteval] = ACTIONS(2196),
    [anon_sym_alignas] = ACTIONS(2196),
    [anon_sym__Alignas] = ACTIONS(2196),
    [anon_sym_QMARK] = ACTIONS(2196),
    [anon_sym_STAR_EQ] = ACTIONS(2196),
    [anon_sym_SLASH_EQ] = ACTIONS(2196),
    [anon_sym_PERCENT_EQ] = ACTIONS(2196),
    [anon_sym_PLUS_EQ] = ACTIONS(2196),
    [anon_sym_DASH_EQ] = ACTIONS(2196),
    [anon_sym_LT_LT_EQ] = ACTIONS(2196),
    [anon_sym_GT_GT_EQ] = ACTIONS(2196),
    [anon_sym_AMP_EQ] = ACTIONS(2196),
    [anon_sym_CARET_EQ] = ACTIONS(2196),
    [anon_sym_PIPE_EQ] = ACTIONS(2196),
    [anon_sym_and_eq] = ACTIONS(2196),
    [anon_sym_or_eq] = ACTIONS(2196),
    [anon_sym_xor_eq] = ACTIONS(2196),
    [anon_sym_LT_EQ_GT] = ACTIONS(2196),
    [anon_sym_or] = ACTIONS(2194),
    [anon_sym_and] = ACTIONS(2194),
    [anon_sym_bitor] = ACTIONS(2196),
    [anon_sym_xor] = ACTIONS(2194),
    [anon_sym_bitand] = ACTIONS(2196),
    [anon_sym_not_eq] = ACTIONS(2196),
    [anon_sym_is] = ACTIONS(2196),
    [anon_sym_as] = ACTIONS(2196),
    [anon_sym_DASH_DASH] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2196),
    [anon_sym_DOT] = ACTIONS(2194),
    [anon_sym_DOT_STAR] = ACTIONS(2196),
    [anon_sym_DASH_GT] = ACTIONS(2194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2196),
    [anon_sym_let] = ACTIONS(2196),
    [anon_sym_This] = ACTIONS(2196),
    [anon_sym_final] = ACTIONS(2196),
    [anon_sym_override] = ACTIONS(2196),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2196),
  },
  [2798] = {
    [sym_template_argument_list] = STATE(2686),
    [sym_identifier] = ACTIONS(2169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2176),
    [anon_sym_COMMA] = ACTIONS(2176),
    [anon_sym_RPAREN] = ACTIONS(2176),
    [anon_sym_LPAREN2] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_STAR] = ACTIONS(2176),
    [anon_sym_AMP_AMP] = ACTIONS(2176),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(6358),
    [anon_sym_COLON] = ACTIONS(2169),
    [anon_sym___extension__] = ACTIONS(2169),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_out] = ACTIONS(2169),
    [anon_sym_inout] = ACTIONS(2169),
    [anon_sym_extern] = ACTIONS(2169),
    [anon_sym___attribute__] = ACTIONS(2169),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2176),
    [anon_sym___declspec] = ACTIONS(2169),
    [anon_sym___based] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2176),
    [anon_sym_LBRACK] = ACTIONS(2169),
    [anon_sym_static] = ACTIONS(2169),
    [anon_sym_EQ] = ACTIONS(2176),
    [anon_sym_register] = ACTIONS(2169),
    [anon_sym_inline] = ACTIONS(2169),
    [anon_sym___inline] = ACTIONS(2169),
    [anon_sym___inline__] = ACTIONS(2169),
    [anon_sym___forceinline] = ACTIONS(2169),
    [anon_sym_thread_local] = ACTIONS(2169),
    [anon_sym___thread] = ACTIONS(2169),
    [anon_sym_const] = ACTIONS(2169),
    [anon_sym_constexpr] = ACTIONS(2169),
    [anon_sym_volatile] = ACTIONS(2169),
    [anon_sym_restrict] = ACTIONS(2169),
    [anon_sym___restrict__] = ACTIONS(2169),
    [anon_sym__Atomic] = ACTIONS(2169),
    [anon_sym__Noreturn] = ACTIONS(2169),
    [anon_sym_noreturn] = ACTIONS(2169),
    [anon_sym_mutable] = ACTIONS(2169),
    [anon_sym_constinit] = ACTIONS(2169),
    [anon_sym_consteval] = ACTIONS(2169),
    [anon_sym_alignas] = ACTIONS(2169),
    [anon_sym__Alignas] = ACTIONS(2169),
    [anon_sym_DOT] = ACTIONS(2169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2169),
    [anon_sym_let] = ACTIONS(2169),
    [anon_sym_This] = ACTIONS(2169),
    [anon_sym_decltype] = ACTIONS(2169),
    [anon_sym_final] = ACTIONS(2169),
    [anon_sym_override] = ACTIONS(2169),
    [sym_virtual] = ACTIONS(2169),
    [anon_sym_template] = ACTIONS(2169),
    [anon_sym_GT2] = ACTIONS(2176),
    [anon_sym_operator] = ACTIONS(2169),
    [anon_sym_precise] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_groupshared] = ACTIONS(2169),
    [anon_sym_uniform] = ACTIONS(2169),
    [anon_sym_row_major] = ACTIONS(2169),
    [anon_sym_column_major] = ACTIONS(2169),
    [anon_sym_globallycoherent] = ACTIONS(2169),
    [anon_sym_centroid] = ACTIONS(2169),
    [anon_sym_noperspective] = ACTIONS(2169),
    [anon_sym_nointerpolation] = ACTIONS(2169),
    [anon_sym_sample] = ACTIONS(2169),
    [anon_sym_linear] = ACTIONS(2169),
    [anon_sym_snorm] = ACTIONS(2169),
    [anon_sym_unorm] = ACTIONS(2169),
    [anon_sym_point] = ACTIONS(2169),
    [anon_sym_line] = ACTIONS(2169),
    [anon_sym_triangleadj] = ACTIONS(2169),
    [anon_sym_lineadj] = ACTIONS(2169),
    [anon_sym_triangle] = ACTIONS(2169),
  },
  [2799] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_RPAREN] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2248),
    [anon_sym_PLUS] = ACTIONS(2248),
    [anon_sym_STAR] = ACTIONS(2248),
    [anon_sym_SLASH] = ACTIONS(2248),
    [anon_sym_PERCENT] = ACTIONS(2248),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2248),
    [anon_sym_EQ_EQ] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_GT] = ACTIONS(2248),
    [anon_sym_GT_EQ] = ACTIONS(2250),
    [anon_sym_LT_EQ] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_LT_LT] = ACTIONS(2248),
    [anon_sym_GT_GT] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2248),
    [anon_sym___extension__] = ACTIONS(2250),
    [anon_sym___attribute__] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_const] = ACTIONS(2248),
    [anon_sym_constexpr] = ACTIONS(2250),
    [anon_sym_volatile] = ACTIONS(2250),
    [anon_sym_restrict] = ACTIONS(2250),
    [anon_sym___restrict__] = ACTIONS(2250),
    [anon_sym__Atomic] = ACTIONS(2250),
    [anon_sym__Noreturn] = ACTIONS(2250),
    [anon_sym_noreturn] = ACTIONS(2250),
    [anon_sym_mutable] = ACTIONS(2250),
    [anon_sym_constinit] = ACTIONS(2250),
    [anon_sym_consteval] = ACTIONS(2250),
    [anon_sym_alignas] = ACTIONS(2250),
    [anon_sym__Alignas] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_STAR_EQ] = ACTIONS(2250),
    [anon_sym_SLASH_EQ] = ACTIONS(2250),
    [anon_sym_PERCENT_EQ] = ACTIONS(2250),
    [anon_sym_PLUS_EQ] = ACTIONS(2250),
    [anon_sym_DASH_EQ] = ACTIONS(2250),
    [anon_sym_LT_LT_EQ] = ACTIONS(2250),
    [anon_sym_GT_GT_EQ] = ACTIONS(2250),
    [anon_sym_AMP_EQ] = ACTIONS(2250),
    [anon_sym_CARET_EQ] = ACTIONS(2250),
    [anon_sym_PIPE_EQ] = ACTIONS(2250),
    [anon_sym_and_eq] = ACTIONS(2250),
    [anon_sym_or_eq] = ACTIONS(2250),
    [anon_sym_xor_eq] = ACTIONS(2250),
    [anon_sym_LT_EQ_GT] = ACTIONS(2250),
    [anon_sym_or] = ACTIONS(2248),
    [anon_sym_and] = ACTIONS(2248),
    [anon_sym_bitor] = ACTIONS(2250),
    [anon_sym_xor] = ACTIONS(2248),
    [anon_sym_bitand] = ACTIONS(2250),
    [anon_sym_not_eq] = ACTIONS(2250),
    [anon_sym_is] = ACTIONS(2250),
    [anon_sym_as] = ACTIONS(2250),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2248),
    [anon_sym_DOT_STAR] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_This] = ACTIONS(2250),
    [anon_sym_final] = ACTIONS(2250),
    [anon_sym_override] = ACTIONS(2250),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2250),
  },
  [2800] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2192),
    [anon_sym_COMMA] = ACTIONS(2192),
    [anon_sym_RPAREN] = ACTIONS(2192),
    [anon_sym_LPAREN2] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2190),
    [anon_sym_PLUS] = ACTIONS(2190),
    [anon_sym_STAR] = ACTIONS(2190),
    [anon_sym_SLASH] = ACTIONS(2190),
    [anon_sym_PERCENT] = ACTIONS(2190),
    [anon_sym_PIPE_PIPE] = ACTIONS(2192),
    [anon_sym_AMP_AMP] = ACTIONS(2192),
    [anon_sym_PIPE] = ACTIONS(2190),
    [anon_sym_CARET] = ACTIONS(2190),
    [anon_sym_AMP] = ACTIONS(2190),
    [anon_sym_EQ_EQ] = ACTIONS(2192),
    [anon_sym_BANG_EQ] = ACTIONS(2192),
    [anon_sym_GT] = ACTIONS(2190),
    [anon_sym_GT_EQ] = ACTIONS(2192),
    [anon_sym_LT_EQ] = ACTIONS(2190),
    [anon_sym_LT] = ACTIONS(2190),
    [anon_sym_LT_LT] = ACTIONS(2190),
    [anon_sym_GT_GT] = ACTIONS(2190),
    [anon_sym_COLON] = ACTIONS(2190),
    [anon_sym___extension__] = ACTIONS(2192),
    [anon_sym___attribute__] = ACTIONS(2192),
    [anon_sym_COLON_COLON] = ACTIONS(2192),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [anon_sym_LBRACK] = ACTIONS(2192),
    [anon_sym_EQ] = ACTIONS(2190),
    [anon_sym_const] = ACTIONS(2190),
    [anon_sym_constexpr] = ACTIONS(2192),
    [anon_sym_volatile] = ACTIONS(2192),
    [anon_sym_restrict] = ACTIONS(2192),
    [anon_sym___restrict__] = ACTIONS(2192),
    [anon_sym__Atomic] = ACTIONS(2192),
    [anon_sym__Noreturn] = ACTIONS(2192),
    [anon_sym_noreturn] = ACTIONS(2192),
    [anon_sym_mutable] = ACTIONS(2192),
    [anon_sym_constinit] = ACTIONS(2192),
    [anon_sym_consteval] = ACTIONS(2192),
    [anon_sym_alignas] = ACTIONS(2192),
    [anon_sym__Alignas] = ACTIONS(2192),
    [anon_sym_QMARK] = ACTIONS(2192),
    [anon_sym_STAR_EQ] = ACTIONS(2192),
    [anon_sym_SLASH_EQ] = ACTIONS(2192),
    [anon_sym_PERCENT_EQ] = ACTIONS(2192),
    [anon_sym_PLUS_EQ] = ACTIONS(2192),
    [anon_sym_DASH_EQ] = ACTIONS(2192),
    [anon_sym_LT_LT_EQ] = ACTIONS(2192),
    [anon_sym_GT_GT_EQ] = ACTIONS(2192),
    [anon_sym_AMP_EQ] = ACTIONS(2192),
    [anon_sym_CARET_EQ] = ACTIONS(2192),
    [anon_sym_PIPE_EQ] = ACTIONS(2192),
    [anon_sym_and_eq] = ACTIONS(2192),
    [anon_sym_or_eq] = ACTIONS(2192),
    [anon_sym_xor_eq] = ACTIONS(2192),
    [anon_sym_LT_EQ_GT] = ACTIONS(2192),
    [anon_sym_or] = ACTIONS(2190),
    [anon_sym_and] = ACTIONS(2190),
    [anon_sym_bitor] = ACTIONS(2192),
    [anon_sym_xor] = ACTIONS(2190),
    [anon_sym_bitand] = ACTIONS(2192),
    [anon_sym_not_eq] = ACTIONS(2192),
    [anon_sym_is] = ACTIONS(2192),
    [anon_sym_as] = ACTIONS(2192),
    [anon_sym_DASH_DASH] = ACTIONS(2192),
    [anon_sym_PLUS_PLUS] = ACTIONS(2192),
    [anon_sym_DOT] = ACTIONS(2190),
    [anon_sym_DOT_STAR] = ACTIONS(2192),
    [anon_sym_DASH_GT] = ACTIONS(2190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2192),
    [anon_sym_let] = ACTIONS(2192),
    [anon_sym_This] = ACTIONS(2192),
    [anon_sym_final] = ACTIONS(2192),
    [anon_sym_override] = ACTIONS(2192),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2192),
  },
  [2801] = {
    [sym_string_literal] = STATE(2801),
    [sym_raw_string_literal] = STATE(2801),
    [aux_sym_concatenated_string_repeat1] = STATE(2801),
    [sym_identifier] = ACTIONS(6441),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6444),
    [anon_sym_COMMA] = ACTIONS(6444),
    [anon_sym_RPAREN] = ACTIONS(6444),
    [aux_sym_preproc_if_token2] = ACTIONS(6444),
    [aux_sym_preproc_else_token1] = ACTIONS(6444),
    [aux_sym_preproc_elif_token1] = ACTIONS(6446),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6444),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6444),
    [anon_sym_LPAREN2] = ACTIONS(6444),
    [anon_sym_DASH] = ACTIONS(6446),
    [anon_sym_PLUS] = ACTIONS(6446),
    [anon_sym_STAR] = ACTIONS(6446),
    [anon_sym_SLASH] = ACTIONS(6446),
    [anon_sym_PERCENT] = ACTIONS(6446),
    [anon_sym_PIPE_PIPE] = ACTIONS(6444),
    [anon_sym_AMP_AMP] = ACTIONS(6444),
    [anon_sym_PIPE] = ACTIONS(6446),
    [anon_sym_CARET] = ACTIONS(6446),
    [anon_sym_AMP] = ACTIONS(6446),
    [anon_sym_EQ_EQ] = ACTIONS(6444),
    [anon_sym_BANG_EQ] = ACTIONS(6444),
    [anon_sym_GT] = ACTIONS(6446),
    [anon_sym_GT_EQ] = ACTIONS(6444),
    [anon_sym_LT_EQ] = ACTIONS(6446),
    [anon_sym_LT] = ACTIONS(6446),
    [anon_sym_LT_LT] = ACTIONS(6446),
    [anon_sym_GT_GT] = ACTIONS(6446),
    [anon_sym_COLON] = ACTIONS(6444),
    [anon_sym_SEMI] = ACTIONS(6444),
    [anon_sym_RBRACE] = ACTIONS(6444),
    [anon_sym_LBRACK] = ACTIONS(6444),
    [anon_sym_RBRACK] = ACTIONS(6444),
    [anon_sym_EQ] = ACTIONS(6446),
    [anon_sym_QMARK] = ACTIONS(6444),
    [anon_sym_STAR_EQ] = ACTIONS(6444),
    [anon_sym_SLASH_EQ] = ACTIONS(6444),
    [anon_sym_PERCENT_EQ] = ACTIONS(6444),
    [anon_sym_PLUS_EQ] = ACTIONS(6444),
    [anon_sym_DASH_EQ] = ACTIONS(6444),
    [anon_sym_LT_LT_EQ] = ACTIONS(6444),
    [anon_sym_GT_GT_EQ] = ACTIONS(6444),
    [anon_sym_AMP_EQ] = ACTIONS(6444),
    [anon_sym_CARET_EQ] = ACTIONS(6444),
    [anon_sym_PIPE_EQ] = ACTIONS(6444),
    [anon_sym_and_eq] = ACTIONS(6446),
    [anon_sym_or_eq] = ACTIONS(6446),
    [anon_sym_xor_eq] = ACTIONS(6446),
    [anon_sym_LT_EQ_GT] = ACTIONS(6444),
    [anon_sym_or] = ACTIONS(6446),
    [anon_sym_and] = ACTIONS(6446),
    [anon_sym_bitor] = ACTIONS(6446),
    [anon_sym_xor] = ACTIONS(6446),
    [anon_sym_bitand] = ACTIONS(6446),
    [anon_sym_not_eq] = ACTIONS(6446),
    [anon_sym_is] = ACTIONS(6446),
    [anon_sym_as] = ACTIONS(6446),
    [anon_sym_DASH_DASH] = ACTIONS(6444),
    [anon_sym_PLUS_PLUS] = ACTIONS(6444),
    [anon_sym_DOT] = ACTIONS(6446),
    [anon_sym_DOT_STAR] = ACTIONS(6444),
    [anon_sym_DASH_GT] = ACTIONS(6444),
    [anon_sym_L_DQUOTE] = ACTIONS(6448),
    [anon_sym_u_DQUOTE] = ACTIONS(6448),
    [anon_sym_U_DQUOTE] = ACTIONS(6448),
    [anon_sym_u8_DQUOTE] = ACTIONS(6448),
    [anon_sym_DQUOTE] = ACTIONS(6448),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6451),
    [anon_sym_LR_DQUOTE] = ACTIONS(6451),
    [anon_sym_uR_DQUOTE] = ACTIONS(6451),
    [anon_sym_UR_DQUOTE] = ACTIONS(6451),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6451),
    [sym_literal_suffix] = ACTIONS(6446),
  },
  [2802] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2254),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_RPAREN] = ACTIONS(2254),
    [anon_sym_LPAREN2] = ACTIONS(2254),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_SLASH] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2252),
    [anon_sym_PIPE_PIPE] = ACTIONS(2254),
    [anon_sym_AMP_AMP] = ACTIONS(2254),
    [anon_sym_PIPE] = ACTIONS(2252),
    [anon_sym_CARET] = ACTIONS(2252),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_EQ_EQ] = ACTIONS(2254),
    [anon_sym_BANG_EQ] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2252),
    [anon_sym_GT_EQ] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2252),
    [anon_sym_LT_LT] = ACTIONS(2252),
    [anon_sym_GT_GT] = ACTIONS(2252),
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym___extension__] = ACTIONS(2254),
    [anon_sym___attribute__] = ACTIONS(2254),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_LBRACK] = ACTIONS(2254),
    [anon_sym_EQ] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2252),
    [anon_sym_constexpr] = ACTIONS(2254),
    [anon_sym_volatile] = ACTIONS(2254),
    [anon_sym_restrict] = ACTIONS(2254),
    [anon_sym___restrict__] = ACTIONS(2254),
    [anon_sym__Atomic] = ACTIONS(2254),
    [anon_sym__Noreturn] = ACTIONS(2254),
    [anon_sym_noreturn] = ACTIONS(2254),
    [anon_sym_mutable] = ACTIONS(2254),
    [anon_sym_constinit] = ACTIONS(2254),
    [anon_sym_consteval] = ACTIONS(2254),
    [anon_sym_alignas] = ACTIONS(2254),
    [anon_sym__Alignas] = ACTIONS(2254),
    [anon_sym_QMARK] = ACTIONS(2254),
    [anon_sym_STAR_EQ] = ACTIONS(2254),
    [anon_sym_SLASH_EQ] = ACTIONS(2254),
    [anon_sym_PERCENT_EQ] = ACTIONS(2254),
    [anon_sym_PLUS_EQ] = ACTIONS(2254),
    [anon_sym_DASH_EQ] = ACTIONS(2254),
    [anon_sym_LT_LT_EQ] = ACTIONS(2254),
    [anon_sym_GT_GT_EQ] = ACTIONS(2254),
    [anon_sym_AMP_EQ] = ACTIONS(2254),
    [anon_sym_CARET_EQ] = ACTIONS(2254),
    [anon_sym_PIPE_EQ] = ACTIONS(2254),
    [anon_sym_and_eq] = ACTIONS(2254),
    [anon_sym_or_eq] = ACTIONS(2254),
    [anon_sym_xor_eq] = ACTIONS(2254),
    [anon_sym_LT_EQ_GT] = ACTIONS(2254),
    [anon_sym_or] = ACTIONS(2252),
    [anon_sym_and] = ACTIONS(2252),
    [anon_sym_bitor] = ACTIONS(2254),
    [anon_sym_xor] = ACTIONS(2252),
    [anon_sym_bitand] = ACTIONS(2254),
    [anon_sym_not_eq] = ACTIONS(2254),
    [anon_sym_is] = ACTIONS(2254),
    [anon_sym_as] = ACTIONS(2254),
    [anon_sym_DASH_DASH] = ACTIONS(2254),
    [anon_sym_PLUS_PLUS] = ACTIONS(2254),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_DOT_STAR] = ACTIONS(2254),
    [anon_sym_DASH_GT] = ACTIONS(2252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2254),
    [anon_sym_let] = ACTIONS(2254),
    [anon_sym_This] = ACTIONS(2254),
    [anon_sym_final] = ACTIONS(2254),
    [anon_sym_override] = ACTIONS(2254),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2254),
  },
  [2803] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(2246),
    [anon_sym_RPAREN] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2244),
    [anon_sym_PLUS] = ACTIONS(2244),
    [anon_sym_STAR] = ACTIONS(2244),
    [anon_sym_SLASH] = ACTIONS(2244),
    [anon_sym_PERCENT] = ACTIONS(2244),
    [anon_sym_PIPE_PIPE] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2244),
    [anon_sym_CARET] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2244),
    [anon_sym_EQ_EQ] = ACTIONS(2246),
    [anon_sym_BANG_EQ] = ACTIONS(2246),
    [anon_sym_GT] = ACTIONS(2244),
    [anon_sym_GT_EQ] = ACTIONS(2246),
    [anon_sym_LT_EQ] = ACTIONS(2244),
    [anon_sym_LT] = ACTIONS(2244),
    [anon_sym_LT_LT] = ACTIONS(2244),
    [anon_sym_GT_GT] = ACTIONS(2244),
    [anon_sym_COLON] = ACTIONS(2244),
    [anon_sym___extension__] = ACTIONS(2246),
    [anon_sym___attribute__] = ACTIONS(2246),
    [anon_sym_COLON_COLON] = ACTIONS(2246),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_EQ] = ACTIONS(2244),
    [anon_sym_const] = ACTIONS(2244),
    [anon_sym_constexpr] = ACTIONS(2246),
    [anon_sym_volatile] = ACTIONS(2246),
    [anon_sym_restrict] = ACTIONS(2246),
    [anon_sym___restrict__] = ACTIONS(2246),
    [anon_sym__Atomic] = ACTIONS(2246),
    [anon_sym__Noreturn] = ACTIONS(2246),
    [anon_sym_noreturn] = ACTIONS(2246),
    [anon_sym_mutable] = ACTIONS(2246),
    [anon_sym_constinit] = ACTIONS(2246),
    [anon_sym_consteval] = ACTIONS(2246),
    [anon_sym_alignas] = ACTIONS(2246),
    [anon_sym__Alignas] = ACTIONS(2246),
    [anon_sym_QMARK] = ACTIONS(2246),
    [anon_sym_STAR_EQ] = ACTIONS(2246),
    [anon_sym_SLASH_EQ] = ACTIONS(2246),
    [anon_sym_PERCENT_EQ] = ACTIONS(2246),
    [anon_sym_PLUS_EQ] = ACTIONS(2246),
    [anon_sym_DASH_EQ] = ACTIONS(2246),
    [anon_sym_LT_LT_EQ] = ACTIONS(2246),
    [anon_sym_GT_GT_EQ] = ACTIONS(2246),
    [anon_sym_AMP_EQ] = ACTIONS(2246),
    [anon_sym_CARET_EQ] = ACTIONS(2246),
    [anon_sym_PIPE_EQ] = ACTIONS(2246),
    [anon_sym_and_eq] = ACTIONS(2246),
    [anon_sym_or_eq] = ACTIONS(2246),
    [anon_sym_xor_eq] = ACTIONS(2246),
    [anon_sym_LT_EQ_GT] = ACTIONS(2246),
    [anon_sym_or] = ACTIONS(2244),
    [anon_sym_and] = ACTIONS(2244),
    [anon_sym_bitor] = ACTIONS(2246),
    [anon_sym_xor] = ACTIONS(2244),
    [anon_sym_bitand] = ACTIONS(2246),
    [anon_sym_not_eq] = ACTIONS(2246),
    [anon_sym_is] = ACTIONS(2246),
    [anon_sym_as] = ACTIONS(2246),
    [anon_sym_DASH_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_PLUS] = ACTIONS(2246),
    [anon_sym_DOT] = ACTIONS(2244),
    [anon_sym_DOT_STAR] = ACTIONS(2246),
    [anon_sym_DASH_GT] = ACTIONS(2244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2246),
    [anon_sym_let] = ACTIONS(2246),
    [anon_sym_This] = ACTIONS(2246),
    [anon_sym_final] = ACTIONS(2246),
    [anon_sym_override] = ACTIONS(2246),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2246),
  },
  [2804] = {
    [sym_string_literal] = STATE(2801),
    [sym_raw_string_literal] = STATE(2801),
    [aux_sym_concatenated_string_repeat1] = STATE(2801),
    [sym_identifier] = ACTIONS(6454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6456),
    [anon_sym_COMMA] = ACTIONS(6456),
    [anon_sym_RPAREN] = ACTIONS(6456),
    [aux_sym_preproc_if_token2] = ACTIONS(6456),
    [aux_sym_preproc_else_token1] = ACTIONS(6456),
    [aux_sym_preproc_elif_token1] = ACTIONS(6458),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6456),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6456),
    [anon_sym_LPAREN2] = ACTIONS(6456),
    [anon_sym_DASH] = ACTIONS(6458),
    [anon_sym_PLUS] = ACTIONS(6458),
    [anon_sym_STAR] = ACTIONS(6458),
    [anon_sym_SLASH] = ACTIONS(6458),
    [anon_sym_PERCENT] = ACTIONS(6458),
    [anon_sym_PIPE_PIPE] = ACTIONS(6456),
    [anon_sym_AMP_AMP] = ACTIONS(6456),
    [anon_sym_PIPE] = ACTIONS(6458),
    [anon_sym_CARET] = ACTIONS(6458),
    [anon_sym_AMP] = ACTIONS(6458),
    [anon_sym_EQ_EQ] = ACTIONS(6456),
    [anon_sym_BANG_EQ] = ACTIONS(6456),
    [anon_sym_GT] = ACTIONS(6458),
    [anon_sym_GT_EQ] = ACTIONS(6456),
    [anon_sym_LT_EQ] = ACTIONS(6458),
    [anon_sym_LT] = ACTIONS(6458),
    [anon_sym_LT_LT] = ACTIONS(6458),
    [anon_sym_GT_GT] = ACTIONS(6458),
    [anon_sym_COLON] = ACTIONS(6456),
    [anon_sym_SEMI] = ACTIONS(6456),
    [anon_sym_RBRACE] = ACTIONS(6456),
    [anon_sym_LBRACK] = ACTIONS(6456),
    [anon_sym_RBRACK] = ACTIONS(6456),
    [anon_sym_EQ] = ACTIONS(6458),
    [anon_sym_QMARK] = ACTIONS(6456),
    [anon_sym_STAR_EQ] = ACTIONS(6456),
    [anon_sym_SLASH_EQ] = ACTIONS(6456),
    [anon_sym_PERCENT_EQ] = ACTIONS(6456),
    [anon_sym_PLUS_EQ] = ACTIONS(6456),
    [anon_sym_DASH_EQ] = ACTIONS(6456),
    [anon_sym_LT_LT_EQ] = ACTIONS(6456),
    [anon_sym_GT_GT_EQ] = ACTIONS(6456),
    [anon_sym_AMP_EQ] = ACTIONS(6456),
    [anon_sym_CARET_EQ] = ACTIONS(6456),
    [anon_sym_PIPE_EQ] = ACTIONS(6456),
    [anon_sym_and_eq] = ACTIONS(6458),
    [anon_sym_or_eq] = ACTIONS(6458),
    [anon_sym_xor_eq] = ACTIONS(6458),
    [anon_sym_LT_EQ_GT] = ACTIONS(6456),
    [anon_sym_or] = ACTIONS(6458),
    [anon_sym_and] = ACTIONS(6458),
    [anon_sym_bitor] = ACTIONS(6458),
    [anon_sym_xor] = ACTIONS(6458),
    [anon_sym_bitand] = ACTIONS(6458),
    [anon_sym_not_eq] = ACTIONS(6458),
    [anon_sym_is] = ACTIONS(6458),
    [anon_sym_as] = ACTIONS(6458),
    [anon_sym_DASH_DASH] = ACTIONS(6456),
    [anon_sym_PLUS_PLUS] = ACTIONS(6456),
    [anon_sym_DOT] = ACTIONS(6458),
    [anon_sym_DOT_STAR] = ACTIONS(6456),
    [anon_sym_DASH_GT] = ACTIONS(6456),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [sym_literal_suffix] = ACTIONS(6458),
  },
  [2805] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_COMMA] = ACTIONS(2234),
    [anon_sym_RPAREN] = ACTIONS(2234),
    [anon_sym_LPAREN2] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2232),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_STAR] = ACTIONS(2232),
    [anon_sym_SLASH] = ACTIONS(2232),
    [anon_sym_PERCENT] = ACTIONS(2232),
    [anon_sym_PIPE_PIPE] = ACTIONS(2234),
    [anon_sym_AMP_AMP] = ACTIONS(2234),
    [anon_sym_PIPE] = ACTIONS(2232),
    [anon_sym_CARET] = ACTIONS(2232),
    [anon_sym_AMP] = ACTIONS(2232),
    [anon_sym_EQ_EQ] = ACTIONS(2234),
    [anon_sym_BANG_EQ] = ACTIONS(2234),
    [anon_sym_GT] = ACTIONS(2232),
    [anon_sym_GT_EQ] = ACTIONS(2234),
    [anon_sym_LT_EQ] = ACTIONS(2232),
    [anon_sym_LT] = ACTIONS(2232),
    [anon_sym_LT_LT] = ACTIONS(2232),
    [anon_sym_GT_GT] = ACTIONS(2232),
    [anon_sym_COLON] = ACTIONS(2232),
    [anon_sym___extension__] = ACTIONS(2234),
    [anon_sym___attribute__] = ACTIONS(2234),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_EQ] = ACTIONS(2232),
    [anon_sym_const] = ACTIONS(2232),
    [anon_sym_constexpr] = ACTIONS(2234),
    [anon_sym_volatile] = ACTIONS(2234),
    [anon_sym_restrict] = ACTIONS(2234),
    [anon_sym___restrict__] = ACTIONS(2234),
    [anon_sym__Atomic] = ACTIONS(2234),
    [anon_sym__Noreturn] = ACTIONS(2234),
    [anon_sym_noreturn] = ACTIONS(2234),
    [anon_sym_mutable] = ACTIONS(2234),
    [anon_sym_constinit] = ACTIONS(2234),
    [anon_sym_consteval] = ACTIONS(2234),
    [anon_sym_alignas] = ACTIONS(2234),
    [anon_sym__Alignas] = ACTIONS(2234),
    [anon_sym_QMARK] = ACTIONS(2234),
    [anon_sym_STAR_EQ] = ACTIONS(2234),
    [anon_sym_SLASH_EQ] = ACTIONS(2234),
    [anon_sym_PERCENT_EQ] = ACTIONS(2234),
    [anon_sym_PLUS_EQ] = ACTIONS(2234),
    [anon_sym_DASH_EQ] = ACTIONS(2234),
    [anon_sym_LT_LT_EQ] = ACTIONS(2234),
    [anon_sym_GT_GT_EQ] = ACTIONS(2234),
    [anon_sym_AMP_EQ] = ACTIONS(2234),
    [anon_sym_CARET_EQ] = ACTIONS(2234),
    [anon_sym_PIPE_EQ] = ACTIONS(2234),
    [anon_sym_and_eq] = ACTIONS(2234),
    [anon_sym_or_eq] = ACTIONS(2234),
    [anon_sym_xor_eq] = ACTIONS(2234),
    [anon_sym_LT_EQ_GT] = ACTIONS(2234),
    [anon_sym_or] = ACTIONS(2232),
    [anon_sym_and] = ACTIONS(2232),
    [anon_sym_bitor] = ACTIONS(2234),
    [anon_sym_xor] = ACTIONS(2232),
    [anon_sym_bitand] = ACTIONS(2234),
    [anon_sym_not_eq] = ACTIONS(2234),
    [anon_sym_is] = ACTIONS(2234),
    [anon_sym_as] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2234),
    [anon_sym_PLUS_PLUS] = ACTIONS(2234),
    [anon_sym_DOT] = ACTIONS(2232),
    [anon_sym_DOT_STAR] = ACTIONS(2234),
    [anon_sym_DASH_GT] = ACTIONS(2232),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2234),
    [anon_sym_let] = ACTIONS(2234),
    [anon_sym_This] = ACTIONS(2234),
    [anon_sym_final] = ACTIONS(2234),
    [anon_sym_override] = ACTIONS(2234),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2234),
  },
  [2806] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2230),
    [anon_sym_COMMA] = ACTIONS(2230),
    [anon_sym_RPAREN] = ACTIONS(2230),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2228),
    [anon_sym_PLUS] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(2228),
    [anon_sym_SLASH] = ACTIONS(2228),
    [anon_sym_PERCENT] = ACTIONS(2228),
    [anon_sym_PIPE_PIPE] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_PIPE] = ACTIONS(2228),
    [anon_sym_CARET] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2228),
    [anon_sym_EQ_EQ] = ACTIONS(2230),
    [anon_sym_BANG_EQ] = ACTIONS(2230),
    [anon_sym_GT] = ACTIONS(2228),
    [anon_sym_GT_EQ] = ACTIONS(2230),
    [anon_sym_LT_EQ] = ACTIONS(2228),
    [anon_sym_LT] = ACTIONS(2228),
    [anon_sym_LT_LT] = ACTIONS(2228),
    [anon_sym_GT_GT] = ACTIONS(2228),
    [anon_sym_COLON] = ACTIONS(2228),
    [anon_sym___extension__] = ACTIONS(2230),
    [anon_sym___attribute__] = ACTIONS(2230),
    [anon_sym_COLON_COLON] = ACTIONS(2230),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2230),
    [anon_sym_EQ] = ACTIONS(2228),
    [anon_sym_const] = ACTIONS(2228),
    [anon_sym_constexpr] = ACTIONS(2230),
    [anon_sym_volatile] = ACTIONS(2230),
    [anon_sym_restrict] = ACTIONS(2230),
    [anon_sym___restrict__] = ACTIONS(2230),
    [anon_sym__Atomic] = ACTIONS(2230),
    [anon_sym__Noreturn] = ACTIONS(2230),
    [anon_sym_noreturn] = ACTIONS(2230),
    [anon_sym_mutable] = ACTIONS(2230),
    [anon_sym_constinit] = ACTIONS(2230),
    [anon_sym_consteval] = ACTIONS(2230),
    [anon_sym_alignas] = ACTIONS(2230),
    [anon_sym__Alignas] = ACTIONS(2230),
    [anon_sym_QMARK] = ACTIONS(2230),
    [anon_sym_STAR_EQ] = ACTIONS(2230),
    [anon_sym_SLASH_EQ] = ACTIONS(2230),
    [anon_sym_PERCENT_EQ] = ACTIONS(2230),
    [anon_sym_PLUS_EQ] = ACTIONS(2230),
    [anon_sym_DASH_EQ] = ACTIONS(2230),
    [anon_sym_LT_LT_EQ] = ACTIONS(2230),
    [anon_sym_GT_GT_EQ] = ACTIONS(2230),
    [anon_sym_AMP_EQ] = ACTIONS(2230),
    [anon_sym_CARET_EQ] = ACTIONS(2230),
    [anon_sym_PIPE_EQ] = ACTIONS(2230),
    [anon_sym_and_eq] = ACTIONS(2230),
    [anon_sym_or_eq] = ACTIONS(2230),
    [anon_sym_xor_eq] = ACTIONS(2230),
    [anon_sym_LT_EQ_GT] = ACTIONS(2230),
    [anon_sym_or] = ACTIONS(2228),
    [anon_sym_and] = ACTIONS(2228),
    [anon_sym_bitor] = ACTIONS(2230),
    [anon_sym_xor] = ACTIONS(2228),
    [anon_sym_bitand] = ACTIONS(2230),
    [anon_sym_not_eq] = ACTIONS(2230),
    [anon_sym_is] = ACTIONS(2230),
    [anon_sym_as] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_PLUS] = ACTIONS(2230),
    [anon_sym_DOT] = ACTIONS(2228),
    [anon_sym_DOT_STAR] = ACTIONS(2230),
    [anon_sym_DASH_GT] = ACTIONS(2228),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2230),
    [anon_sym_let] = ACTIONS(2230),
    [anon_sym_This] = ACTIONS(2230),
    [anon_sym_final] = ACTIONS(2230),
    [anon_sym_override] = ACTIONS(2230),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2230),
  },
  [2807] = {
    [sym_template_argument_list] = STATE(2686),
    [sym_identifier] = ACTIONS(2349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2347),
    [anon_sym_COMMA] = ACTIONS(2347),
    [anon_sym_RPAREN] = ACTIONS(2347),
    [anon_sym_LPAREN2] = ACTIONS(2347),
    [anon_sym_TILDE] = ACTIONS(2347),
    [anon_sym_STAR] = ACTIONS(2347),
    [anon_sym_AMP_AMP] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2349),
    [anon_sym_LT] = ACTIONS(6358),
    [anon_sym_COLON] = ACTIONS(2349),
    [anon_sym___extension__] = ACTIONS(2349),
    [anon_sym_in] = ACTIONS(2349),
    [anon_sym_out] = ACTIONS(2349),
    [anon_sym_inout] = ACTIONS(2349),
    [anon_sym_extern] = ACTIONS(2349),
    [anon_sym___attribute__] = ACTIONS(2349),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2347),
    [anon_sym___declspec] = ACTIONS(2349),
    [anon_sym___based] = ACTIONS(2349),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2349),
    [anon_sym_static] = ACTIONS(2349),
    [anon_sym_EQ] = ACTIONS(2347),
    [anon_sym_register] = ACTIONS(2349),
    [anon_sym_inline] = ACTIONS(2349),
    [anon_sym___inline] = ACTIONS(2349),
    [anon_sym___inline__] = ACTIONS(2349),
    [anon_sym___forceinline] = ACTIONS(2349),
    [anon_sym_thread_local] = ACTIONS(2349),
    [anon_sym___thread] = ACTIONS(2349),
    [anon_sym_const] = ACTIONS(2349),
    [anon_sym_constexpr] = ACTIONS(2349),
    [anon_sym_volatile] = ACTIONS(2349),
    [anon_sym_restrict] = ACTIONS(2349),
    [anon_sym___restrict__] = ACTIONS(2349),
    [anon_sym__Atomic] = ACTIONS(2349),
    [anon_sym__Noreturn] = ACTIONS(2349),
    [anon_sym_noreturn] = ACTIONS(2349),
    [anon_sym_mutable] = ACTIONS(2349),
    [anon_sym_constinit] = ACTIONS(2349),
    [anon_sym_consteval] = ACTIONS(2349),
    [anon_sym_alignas] = ACTIONS(2349),
    [anon_sym__Alignas] = ACTIONS(2349),
    [anon_sym_DOT] = ACTIONS(2349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2349),
    [anon_sym_let] = ACTIONS(2349),
    [anon_sym_This] = ACTIONS(2349),
    [anon_sym_decltype] = ACTIONS(2349),
    [anon_sym_final] = ACTIONS(2349),
    [anon_sym_override] = ACTIONS(2349),
    [sym_virtual] = ACTIONS(2349),
    [anon_sym_template] = ACTIONS(2349),
    [anon_sym_GT2] = ACTIONS(2347),
    [anon_sym_operator] = ACTIONS(2349),
    [anon_sym_precise] = ACTIONS(2349),
    [anon_sym_shared] = ACTIONS(2349),
    [anon_sym_groupshared] = ACTIONS(2349),
    [anon_sym_uniform] = ACTIONS(2349),
    [anon_sym_row_major] = ACTIONS(2349),
    [anon_sym_column_major] = ACTIONS(2349),
    [anon_sym_globallycoherent] = ACTIONS(2349),
    [anon_sym_centroid] = ACTIONS(2349),
    [anon_sym_noperspective] = ACTIONS(2349),
    [anon_sym_nointerpolation] = ACTIONS(2349),
    [anon_sym_sample] = ACTIONS(2349),
    [anon_sym_linear] = ACTIONS(2349),
    [anon_sym_snorm] = ACTIONS(2349),
    [anon_sym_unorm] = ACTIONS(2349),
    [anon_sym_point] = ACTIONS(2349),
    [anon_sym_line] = ACTIONS(2349),
    [anon_sym_triangleadj] = ACTIONS(2349),
    [anon_sym_lineadj] = ACTIONS(2349),
    [anon_sym_triangle] = ACTIONS(2349),
  },
  [2808] = {
    [sym_identifier] = ACTIONS(6460),
    [anon_sym___extension__] = ACTIONS(6460),
    [anon_sym_in] = ACTIONS(6460),
    [anon_sym_out] = ACTIONS(6460),
    [anon_sym_inout] = ACTIONS(6460),
    [anon_sym_extern] = ACTIONS(6460),
    [anon_sym___attribute__] = ACTIONS(6460),
    [anon_sym_COLON_COLON] = ACTIONS(6462),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6462),
    [anon_sym___declspec] = ACTIONS(6460),
    [anon_sym___cdecl] = ACTIONS(6460),
    [anon_sym___clrcall] = ACTIONS(6460),
    [anon_sym___stdcall] = ACTIONS(6460),
    [anon_sym___fastcall] = ACTIONS(6460),
    [anon_sym___thiscall] = ACTIONS(6460),
    [anon_sym___vectorcall] = ACTIONS(6460),
    [anon_sym_LBRACE] = ACTIONS(6462),
    [anon_sym_signed] = ACTIONS(6460),
    [anon_sym_unsigned] = ACTIONS(6460),
    [anon_sym_long] = ACTIONS(6460),
    [anon_sym_short] = ACTIONS(6460),
    [anon_sym_LBRACK] = ACTIONS(6460),
    [anon_sym_static] = ACTIONS(6460),
    [anon_sym_register] = ACTIONS(6460),
    [anon_sym_inline] = ACTIONS(6460),
    [anon_sym___inline] = ACTIONS(6460),
    [anon_sym___inline__] = ACTIONS(6460),
    [anon_sym___forceinline] = ACTIONS(6460),
    [anon_sym_thread_local] = ACTIONS(6460),
    [anon_sym___thread] = ACTIONS(6460),
    [anon_sym_const] = ACTIONS(6460),
    [anon_sym_constexpr] = ACTIONS(6460),
    [anon_sym_volatile] = ACTIONS(6460),
    [anon_sym_restrict] = ACTIONS(6460),
    [anon_sym___restrict__] = ACTIONS(6460),
    [anon_sym__Atomic] = ACTIONS(6460),
    [anon_sym__Noreturn] = ACTIONS(6460),
    [anon_sym_noreturn] = ACTIONS(6460),
    [anon_sym_mutable] = ACTIONS(6460),
    [anon_sym_constinit] = ACTIONS(6460),
    [anon_sym_consteval] = ACTIONS(6460),
    [anon_sym_alignas] = ACTIONS(6460),
    [anon_sym__Alignas] = ACTIONS(6460),
    [sym_primitive_type] = ACTIONS(6460),
    [anon_sym_enum] = ACTIONS(6460),
    [anon_sym_class] = ACTIONS(6460),
    [anon_sym_struct] = ACTIONS(6460),
    [anon_sym_union] = ACTIONS(6460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6460),
    [anon_sym_let] = ACTIONS(6460),
    [anon_sym_This] = ACTIONS(6460),
    [anon_sym_decltype] = ACTIONS(6460),
    [sym_virtual] = ACTIONS(6460),
    [anon_sym_typename] = ACTIONS(6460),
    [anon_sym_template] = ACTIONS(6460),
    [anon_sym_precise] = ACTIONS(6460),
    [anon_sym_shared] = ACTIONS(6460),
    [anon_sym_groupshared] = ACTIONS(6460),
    [anon_sym_uniform] = ACTIONS(6460),
    [anon_sym_row_major] = ACTIONS(6460),
    [anon_sym_column_major] = ACTIONS(6460),
    [anon_sym_globallycoherent] = ACTIONS(6460),
    [anon_sym_centroid] = ACTIONS(6460),
    [anon_sym_noperspective] = ACTIONS(6460),
    [anon_sym_nointerpolation] = ACTIONS(6460),
    [anon_sym_sample] = ACTIONS(6460),
    [anon_sym_linear] = ACTIONS(6460),
    [anon_sym_snorm] = ACTIONS(6460),
    [anon_sym_unorm] = ACTIONS(6460),
    [anon_sym_point] = ACTIONS(6460),
    [anon_sym_line] = ACTIONS(6460),
    [anon_sym_triangleadj] = ACTIONS(6460),
    [anon_sym_lineadj] = ACTIONS(6460),
    [anon_sym_triangle] = ACTIONS(6460),
    [anon_sym_interface] = ACTIONS(6460),
    [anon_sym_extension] = ACTIONS(6460),
  },
  [2809] = {
    [sym_identifier] = ACTIONS(6420),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6422),
    [anon_sym_COMMA] = ACTIONS(6422),
    [anon_sym_RPAREN] = ACTIONS(6422),
    [anon_sym_LPAREN2] = ACTIONS(6422),
    [anon_sym_TILDE] = ACTIONS(6422),
    [anon_sym_STAR] = ACTIONS(6422),
    [anon_sym_AMP_AMP] = ACTIONS(6422),
    [anon_sym_AMP] = ACTIONS(6420),
    [anon_sym_COLON] = ACTIONS(6420),
    [anon_sym_SEMI] = ACTIONS(6422),
    [anon_sym___extension__] = ACTIONS(6420),
    [anon_sym_in] = ACTIONS(6420),
    [anon_sym_out] = ACTIONS(6420),
    [anon_sym_inout] = ACTIONS(6420),
    [anon_sym_extern] = ACTIONS(6420),
    [anon_sym___attribute__] = ACTIONS(6420),
    [anon_sym_COLON_COLON] = ACTIONS(6422),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6422),
    [anon_sym___declspec] = ACTIONS(6420),
    [anon_sym___based] = ACTIONS(6420),
    [anon_sym___cdecl] = ACTIONS(6420),
    [anon_sym___clrcall] = ACTIONS(6420),
    [anon_sym___stdcall] = ACTIONS(6420),
    [anon_sym___fastcall] = ACTIONS(6420),
    [anon_sym___thiscall] = ACTIONS(6420),
    [anon_sym___vectorcall] = ACTIONS(6420),
    [anon_sym_LBRACK] = ACTIONS(6420),
    [anon_sym_static] = ACTIONS(6420),
    [anon_sym_EQ] = ACTIONS(6422),
    [anon_sym_register] = ACTIONS(6420),
    [anon_sym_inline] = ACTIONS(6420),
    [anon_sym___inline] = ACTIONS(6420),
    [anon_sym___inline__] = ACTIONS(6420),
    [anon_sym___forceinline] = ACTIONS(6420),
    [anon_sym_thread_local] = ACTIONS(6420),
    [anon_sym___thread] = ACTIONS(6420),
    [anon_sym_const] = ACTIONS(6420),
    [anon_sym_constexpr] = ACTIONS(6420),
    [anon_sym_volatile] = ACTIONS(6420),
    [anon_sym_restrict] = ACTIONS(6420),
    [anon_sym___restrict__] = ACTIONS(6420),
    [anon_sym__Atomic] = ACTIONS(6420),
    [anon_sym__Noreturn] = ACTIONS(6420),
    [anon_sym_noreturn] = ACTIONS(6420),
    [anon_sym_mutable] = ACTIONS(6420),
    [anon_sym_constinit] = ACTIONS(6420),
    [anon_sym_consteval] = ACTIONS(6420),
    [anon_sym_alignas] = ACTIONS(6420),
    [anon_sym__Alignas] = ACTIONS(6420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(6420),
    [sym_virtual] = ACTIONS(6420),
    [anon_sym_explicit] = ACTIONS(6420),
    [anon_sym_template] = ACTIONS(6420),
    [anon_sym_GT2] = ACTIONS(6422),
    [anon_sym_operator] = ACTIONS(6420),
    [anon_sym_precise] = ACTIONS(6420),
    [anon_sym_shared] = ACTIONS(6420),
    [anon_sym_groupshared] = ACTIONS(6420),
    [anon_sym_uniform] = ACTIONS(6420),
    [anon_sym_row_major] = ACTIONS(6420),
    [anon_sym_column_major] = ACTIONS(6420),
    [anon_sym_globallycoherent] = ACTIONS(6420),
    [anon_sym_centroid] = ACTIONS(6420),
    [anon_sym_noperspective] = ACTIONS(6420),
    [anon_sym_nointerpolation] = ACTIONS(6420),
    [anon_sym_sample] = ACTIONS(6420),
    [anon_sym_linear] = ACTIONS(6420),
    [anon_sym_snorm] = ACTIONS(6420),
    [anon_sym_unorm] = ACTIONS(6420),
    [anon_sym_point] = ACTIONS(6420),
    [anon_sym_line] = ACTIONS(6420),
    [anon_sym_triangleadj] = ACTIONS(6420),
    [anon_sym_lineadj] = ACTIONS(6420),
    [anon_sym_triangle] = ACTIONS(6420),
  },
  [2810] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2230),
    [anon_sym_COMMA] = ACTIONS(2230),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2228),
    [anon_sym_PLUS] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(2228),
    [anon_sym_SLASH] = ACTIONS(2228),
    [anon_sym_PERCENT] = ACTIONS(2228),
    [anon_sym_PIPE_PIPE] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_PIPE] = ACTIONS(2228),
    [anon_sym_CARET] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2228),
    [anon_sym_EQ_EQ] = ACTIONS(2230),
    [anon_sym_BANG_EQ] = ACTIONS(2230),
    [anon_sym_GT] = ACTIONS(2228),
    [anon_sym_GT_EQ] = ACTIONS(2228),
    [anon_sym_LT_EQ] = ACTIONS(2228),
    [anon_sym_LT] = ACTIONS(2228),
    [anon_sym_LT_LT] = ACTIONS(2228),
    [anon_sym_GT_GT] = ACTIONS(2228),
    [anon_sym_COLON] = ACTIONS(2228),
    [anon_sym___extension__] = ACTIONS(2230),
    [anon_sym___attribute__] = ACTIONS(2230),
    [anon_sym_COLON_COLON] = ACTIONS(2230),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2230),
    [anon_sym_EQ] = ACTIONS(2228),
    [anon_sym_const] = ACTIONS(2228),
    [anon_sym_constexpr] = ACTIONS(2230),
    [anon_sym_volatile] = ACTIONS(2230),
    [anon_sym_restrict] = ACTIONS(2230),
    [anon_sym___restrict__] = ACTIONS(2230),
    [anon_sym__Atomic] = ACTIONS(2230),
    [anon_sym__Noreturn] = ACTIONS(2230),
    [anon_sym_noreturn] = ACTIONS(2230),
    [anon_sym_mutable] = ACTIONS(2230),
    [anon_sym_constinit] = ACTIONS(2230),
    [anon_sym_consteval] = ACTIONS(2230),
    [anon_sym_alignas] = ACTIONS(2230),
    [anon_sym__Alignas] = ACTIONS(2230),
    [anon_sym_QMARK] = ACTIONS(2230),
    [anon_sym_STAR_EQ] = ACTIONS(2230),
    [anon_sym_SLASH_EQ] = ACTIONS(2230),
    [anon_sym_PERCENT_EQ] = ACTIONS(2230),
    [anon_sym_PLUS_EQ] = ACTIONS(2230),
    [anon_sym_DASH_EQ] = ACTIONS(2230),
    [anon_sym_LT_LT_EQ] = ACTIONS(2230),
    [anon_sym_GT_GT_EQ] = ACTIONS(2228),
    [anon_sym_AMP_EQ] = ACTIONS(2230),
    [anon_sym_CARET_EQ] = ACTIONS(2230),
    [anon_sym_PIPE_EQ] = ACTIONS(2230),
    [anon_sym_and_eq] = ACTIONS(2230),
    [anon_sym_or_eq] = ACTIONS(2230),
    [anon_sym_xor_eq] = ACTIONS(2230),
    [anon_sym_LT_EQ_GT] = ACTIONS(2230),
    [anon_sym_or] = ACTIONS(2228),
    [anon_sym_and] = ACTIONS(2228),
    [anon_sym_bitor] = ACTIONS(2230),
    [anon_sym_xor] = ACTIONS(2228),
    [anon_sym_bitand] = ACTIONS(2230),
    [anon_sym_not_eq] = ACTIONS(2230),
    [anon_sym_is] = ACTIONS(2230),
    [anon_sym_as] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_PLUS] = ACTIONS(2230),
    [anon_sym_DOT] = ACTIONS(2228),
    [anon_sym_DOT_STAR] = ACTIONS(2230),
    [anon_sym_DASH_GT] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2230),
    [anon_sym_let] = ACTIONS(2230),
    [anon_sym_This] = ACTIONS(2230),
    [anon_sym_final] = ACTIONS(2230),
    [anon_sym_override] = ACTIONS(2230),
    [anon_sym_GT2] = ACTIONS(2230),
  },
  [2811] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_COMMA] = ACTIONS(2234),
    [anon_sym_LPAREN2] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2232),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_STAR] = ACTIONS(2232),
    [anon_sym_SLASH] = ACTIONS(2232),
    [anon_sym_PERCENT] = ACTIONS(2232),
    [anon_sym_PIPE_PIPE] = ACTIONS(2234),
    [anon_sym_AMP_AMP] = ACTIONS(2234),
    [anon_sym_PIPE] = ACTIONS(2232),
    [anon_sym_CARET] = ACTIONS(2232),
    [anon_sym_AMP] = ACTIONS(2232),
    [anon_sym_EQ_EQ] = ACTIONS(2234),
    [anon_sym_BANG_EQ] = ACTIONS(2234),
    [anon_sym_GT] = ACTIONS(2232),
    [anon_sym_GT_EQ] = ACTIONS(2232),
    [anon_sym_LT_EQ] = ACTIONS(2232),
    [anon_sym_LT] = ACTIONS(2232),
    [anon_sym_LT_LT] = ACTIONS(2232),
    [anon_sym_GT_GT] = ACTIONS(2232),
    [anon_sym_COLON] = ACTIONS(2232),
    [anon_sym___extension__] = ACTIONS(2234),
    [anon_sym___attribute__] = ACTIONS(2234),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_EQ] = ACTIONS(2232),
    [anon_sym_const] = ACTIONS(2232),
    [anon_sym_constexpr] = ACTIONS(2234),
    [anon_sym_volatile] = ACTIONS(2234),
    [anon_sym_restrict] = ACTIONS(2234),
    [anon_sym___restrict__] = ACTIONS(2234),
    [anon_sym__Atomic] = ACTIONS(2234),
    [anon_sym__Noreturn] = ACTIONS(2234),
    [anon_sym_noreturn] = ACTIONS(2234),
    [anon_sym_mutable] = ACTIONS(2234),
    [anon_sym_constinit] = ACTIONS(2234),
    [anon_sym_consteval] = ACTIONS(2234),
    [anon_sym_alignas] = ACTIONS(2234),
    [anon_sym__Alignas] = ACTIONS(2234),
    [anon_sym_QMARK] = ACTIONS(2234),
    [anon_sym_STAR_EQ] = ACTIONS(2234),
    [anon_sym_SLASH_EQ] = ACTIONS(2234),
    [anon_sym_PERCENT_EQ] = ACTIONS(2234),
    [anon_sym_PLUS_EQ] = ACTIONS(2234),
    [anon_sym_DASH_EQ] = ACTIONS(2234),
    [anon_sym_LT_LT_EQ] = ACTIONS(2234),
    [anon_sym_GT_GT_EQ] = ACTIONS(2232),
    [anon_sym_AMP_EQ] = ACTIONS(2234),
    [anon_sym_CARET_EQ] = ACTIONS(2234),
    [anon_sym_PIPE_EQ] = ACTIONS(2234),
    [anon_sym_and_eq] = ACTIONS(2234),
    [anon_sym_or_eq] = ACTIONS(2234),
    [anon_sym_xor_eq] = ACTIONS(2234),
    [anon_sym_LT_EQ_GT] = ACTIONS(2234),
    [anon_sym_or] = ACTIONS(2232),
    [anon_sym_and] = ACTIONS(2232),
    [anon_sym_bitor] = ACTIONS(2234),
    [anon_sym_xor] = ACTIONS(2232),
    [anon_sym_bitand] = ACTIONS(2234),
    [anon_sym_not_eq] = ACTIONS(2234),
    [anon_sym_is] = ACTIONS(2234),
    [anon_sym_as] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2234),
    [anon_sym_PLUS_PLUS] = ACTIONS(2234),
    [anon_sym_DOT] = ACTIONS(2232),
    [anon_sym_DOT_STAR] = ACTIONS(2234),
    [anon_sym_DASH_GT] = ACTIONS(2234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2234),
    [anon_sym_let] = ACTIONS(2234),
    [anon_sym_This] = ACTIONS(2234),
    [anon_sym_final] = ACTIONS(2234),
    [anon_sym_override] = ACTIONS(2234),
    [anon_sym_GT2] = ACTIONS(2234),
  },
  [2812] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2244),
    [anon_sym_PLUS] = ACTIONS(2244),
    [anon_sym_STAR] = ACTIONS(2244),
    [anon_sym_SLASH] = ACTIONS(2244),
    [anon_sym_PERCENT] = ACTIONS(2244),
    [anon_sym_PIPE_PIPE] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2244),
    [anon_sym_CARET] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2244),
    [anon_sym_EQ_EQ] = ACTIONS(2246),
    [anon_sym_BANG_EQ] = ACTIONS(2246),
    [anon_sym_GT] = ACTIONS(2244),
    [anon_sym_GT_EQ] = ACTIONS(2244),
    [anon_sym_LT_EQ] = ACTIONS(2244),
    [anon_sym_LT] = ACTIONS(2244),
    [anon_sym_LT_LT] = ACTIONS(2244),
    [anon_sym_GT_GT] = ACTIONS(2244),
    [anon_sym_COLON] = ACTIONS(2244),
    [anon_sym___extension__] = ACTIONS(2246),
    [anon_sym___attribute__] = ACTIONS(2246),
    [anon_sym_COLON_COLON] = ACTIONS(2246),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_EQ] = ACTIONS(2244),
    [anon_sym_const] = ACTIONS(2244),
    [anon_sym_constexpr] = ACTIONS(2246),
    [anon_sym_volatile] = ACTIONS(2246),
    [anon_sym_restrict] = ACTIONS(2246),
    [anon_sym___restrict__] = ACTIONS(2246),
    [anon_sym__Atomic] = ACTIONS(2246),
    [anon_sym__Noreturn] = ACTIONS(2246),
    [anon_sym_noreturn] = ACTIONS(2246),
    [anon_sym_mutable] = ACTIONS(2246),
    [anon_sym_constinit] = ACTIONS(2246),
    [anon_sym_consteval] = ACTIONS(2246),
    [anon_sym_alignas] = ACTIONS(2246),
    [anon_sym__Alignas] = ACTIONS(2246),
    [anon_sym_QMARK] = ACTIONS(2246),
    [anon_sym_STAR_EQ] = ACTIONS(2246),
    [anon_sym_SLASH_EQ] = ACTIONS(2246),
    [anon_sym_PERCENT_EQ] = ACTIONS(2246),
    [anon_sym_PLUS_EQ] = ACTIONS(2246),
    [anon_sym_DASH_EQ] = ACTIONS(2246),
    [anon_sym_LT_LT_EQ] = ACTIONS(2246),
    [anon_sym_GT_GT_EQ] = ACTIONS(2244),
    [anon_sym_AMP_EQ] = ACTIONS(2246),
    [anon_sym_CARET_EQ] = ACTIONS(2246),
    [anon_sym_PIPE_EQ] = ACTIONS(2246),
    [anon_sym_and_eq] = ACTIONS(2246),
    [anon_sym_or_eq] = ACTIONS(2246),
    [anon_sym_xor_eq] = ACTIONS(2246),
    [anon_sym_LT_EQ_GT] = ACTIONS(2246),
    [anon_sym_or] = ACTIONS(2244),
    [anon_sym_and] = ACTIONS(2244),
    [anon_sym_bitor] = ACTIONS(2246),
    [anon_sym_xor] = ACTIONS(2244),
    [anon_sym_bitand] = ACTIONS(2246),
    [anon_sym_not_eq] = ACTIONS(2246),
    [anon_sym_is] = ACTIONS(2246),
    [anon_sym_as] = ACTIONS(2246),
    [anon_sym_DASH_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_PLUS] = ACTIONS(2246),
    [anon_sym_DOT] = ACTIONS(2244),
    [anon_sym_DOT_STAR] = ACTIONS(2246),
    [anon_sym_DASH_GT] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2246),
    [anon_sym_let] = ACTIONS(2246),
    [anon_sym_This] = ACTIONS(2246),
    [anon_sym_final] = ACTIONS(2246),
    [anon_sym_override] = ACTIONS(2246),
    [anon_sym_GT2] = ACTIONS(2246),
  },
  [2813] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2254),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_LPAREN2] = ACTIONS(2254),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_SLASH] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2252),
    [anon_sym_PIPE_PIPE] = ACTIONS(2254),
    [anon_sym_AMP_AMP] = ACTIONS(2254),
    [anon_sym_PIPE] = ACTIONS(2252),
    [anon_sym_CARET] = ACTIONS(2252),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_EQ_EQ] = ACTIONS(2254),
    [anon_sym_BANG_EQ] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2252),
    [anon_sym_GT_EQ] = ACTIONS(2252),
    [anon_sym_LT_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2252),
    [anon_sym_LT_LT] = ACTIONS(2252),
    [anon_sym_GT_GT] = ACTIONS(2252),
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym___extension__] = ACTIONS(2254),
    [anon_sym___attribute__] = ACTIONS(2254),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_LBRACK] = ACTIONS(2254),
    [anon_sym_EQ] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2252),
    [anon_sym_constexpr] = ACTIONS(2254),
    [anon_sym_volatile] = ACTIONS(2254),
    [anon_sym_restrict] = ACTIONS(2254),
    [anon_sym___restrict__] = ACTIONS(2254),
    [anon_sym__Atomic] = ACTIONS(2254),
    [anon_sym__Noreturn] = ACTIONS(2254),
    [anon_sym_noreturn] = ACTIONS(2254),
    [anon_sym_mutable] = ACTIONS(2254),
    [anon_sym_constinit] = ACTIONS(2254),
    [anon_sym_consteval] = ACTIONS(2254),
    [anon_sym_alignas] = ACTIONS(2254),
    [anon_sym__Alignas] = ACTIONS(2254),
    [anon_sym_QMARK] = ACTIONS(2254),
    [anon_sym_STAR_EQ] = ACTIONS(2254),
    [anon_sym_SLASH_EQ] = ACTIONS(2254),
    [anon_sym_PERCENT_EQ] = ACTIONS(2254),
    [anon_sym_PLUS_EQ] = ACTIONS(2254),
    [anon_sym_DASH_EQ] = ACTIONS(2254),
    [anon_sym_LT_LT_EQ] = ACTIONS(2254),
    [anon_sym_GT_GT_EQ] = ACTIONS(2252),
    [anon_sym_AMP_EQ] = ACTIONS(2254),
    [anon_sym_CARET_EQ] = ACTIONS(2254),
    [anon_sym_PIPE_EQ] = ACTIONS(2254),
    [anon_sym_and_eq] = ACTIONS(2254),
    [anon_sym_or_eq] = ACTIONS(2254),
    [anon_sym_xor_eq] = ACTIONS(2254),
    [anon_sym_LT_EQ_GT] = ACTIONS(2254),
    [anon_sym_or] = ACTIONS(2252),
    [anon_sym_and] = ACTIONS(2252),
    [anon_sym_bitor] = ACTIONS(2254),
    [anon_sym_xor] = ACTIONS(2252),
    [anon_sym_bitand] = ACTIONS(2254),
    [anon_sym_not_eq] = ACTIONS(2254),
    [anon_sym_is] = ACTIONS(2254),
    [anon_sym_as] = ACTIONS(2254),
    [anon_sym_DASH_DASH] = ACTIONS(2254),
    [anon_sym_PLUS_PLUS] = ACTIONS(2254),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_DOT_STAR] = ACTIONS(2254),
    [anon_sym_DASH_GT] = ACTIONS(2254),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2254),
    [anon_sym_let] = ACTIONS(2254),
    [anon_sym_This] = ACTIONS(2254),
    [anon_sym_final] = ACTIONS(2254),
    [anon_sym_override] = ACTIONS(2254),
    [anon_sym_GT2] = ACTIONS(2254),
  },
  [2814] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2192),
    [anon_sym_COMMA] = ACTIONS(2192),
    [anon_sym_LPAREN2] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2190),
    [anon_sym_PLUS] = ACTIONS(2190),
    [anon_sym_STAR] = ACTIONS(2190),
    [anon_sym_SLASH] = ACTIONS(2190),
    [anon_sym_PERCENT] = ACTIONS(2190),
    [anon_sym_PIPE_PIPE] = ACTIONS(2192),
    [anon_sym_AMP_AMP] = ACTIONS(2192),
    [anon_sym_PIPE] = ACTIONS(2190),
    [anon_sym_CARET] = ACTIONS(2190),
    [anon_sym_AMP] = ACTIONS(2190),
    [anon_sym_EQ_EQ] = ACTIONS(2192),
    [anon_sym_BANG_EQ] = ACTIONS(2192),
    [anon_sym_GT] = ACTIONS(2190),
    [anon_sym_GT_EQ] = ACTIONS(2190),
    [anon_sym_LT_EQ] = ACTIONS(2190),
    [anon_sym_LT] = ACTIONS(2190),
    [anon_sym_LT_LT] = ACTIONS(2190),
    [anon_sym_GT_GT] = ACTIONS(2190),
    [anon_sym_COLON] = ACTIONS(2190),
    [anon_sym___extension__] = ACTIONS(2192),
    [anon_sym___attribute__] = ACTIONS(2192),
    [anon_sym_COLON_COLON] = ACTIONS(2192),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [anon_sym_LBRACK] = ACTIONS(2192),
    [anon_sym_EQ] = ACTIONS(2190),
    [anon_sym_const] = ACTIONS(2190),
    [anon_sym_constexpr] = ACTIONS(2192),
    [anon_sym_volatile] = ACTIONS(2192),
    [anon_sym_restrict] = ACTIONS(2192),
    [anon_sym___restrict__] = ACTIONS(2192),
    [anon_sym__Atomic] = ACTIONS(2192),
    [anon_sym__Noreturn] = ACTIONS(2192),
    [anon_sym_noreturn] = ACTIONS(2192),
    [anon_sym_mutable] = ACTIONS(2192),
    [anon_sym_constinit] = ACTIONS(2192),
    [anon_sym_consteval] = ACTIONS(2192),
    [anon_sym_alignas] = ACTIONS(2192),
    [anon_sym__Alignas] = ACTIONS(2192),
    [anon_sym_QMARK] = ACTIONS(2192),
    [anon_sym_STAR_EQ] = ACTIONS(2192),
    [anon_sym_SLASH_EQ] = ACTIONS(2192),
    [anon_sym_PERCENT_EQ] = ACTIONS(2192),
    [anon_sym_PLUS_EQ] = ACTIONS(2192),
    [anon_sym_DASH_EQ] = ACTIONS(2192),
    [anon_sym_LT_LT_EQ] = ACTIONS(2192),
    [anon_sym_GT_GT_EQ] = ACTIONS(2190),
    [anon_sym_AMP_EQ] = ACTIONS(2192),
    [anon_sym_CARET_EQ] = ACTIONS(2192),
    [anon_sym_PIPE_EQ] = ACTIONS(2192),
    [anon_sym_and_eq] = ACTIONS(2192),
    [anon_sym_or_eq] = ACTIONS(2192),
    [anon_sym_xor_eq] = ACTIONS(2192),
    [anon_sym_LT_EQ_GT] = ACTIONS(2192),
    [anon_sym_or] = ACTIONS(2190),
    [anon_sym_and] = ACTIONS(2190),
    [anon_sym_bitor] = ACTIONS(2192),
    [anon_sym_xor] = ACTIONS(2190),
    [anon_sym_bitand] = ACTIONS(2192),
    [anon_sym_not_eq] = ACTIONS(2192),
    [anon_sym_is] = ACTIONS(2192),
    [anon_sym_as] = ACTIONS(2192),
    [anon_sym_DASH_DASH] = ACTIONS(2192),
    [anon_sym_PLUS_PLUS] = ACTIONS(2192),
    [anon_sym_DOT] = ACTIONS(2190),
    [anon_sym_DOT_STAR] = ACTIONS(2192),
    [anon_sym_DASH_GT] = ACTIONS(2192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2192),
    [anon_sym_let] = ACTIONS(2192),
    [anon_sym_This] = ACTIONS(2192),
    [anon_sym_final] = ACTIONS(2192),
    [anon_sym_override] = ACTIONS(2192),
    [anon_sym_GT2] = ACTIONS(2192),
  },
  [2815] = {
    [sym_identifier] = ACTIONS(6253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6255),
    [anon_sym_COMMA] = ACTIONS(6255),
    [anon_sym_RPAREN] = ACTIONS(6255),
    [anon_sym_LPAREN2] = ACTIONS(6255),
    [anon_sym_TILDE] = ACTIONS(6255),
    [anon_sym_STAR] = ACTIONS(6255),
    [anon_sym_AMP_AMP] = ACTIONS(6255),
    [anon_sym_AMP] = ACTIONS(6253),
    [anon_sym_COLON] = ACTIONS(6253),
    [anon_sym_SEMI] = ACTIONS(6255),
    [anon_sym___extension__] = ACTIONS(6253),
    [anon_sym_in] = ACTIONS(6253),
    [anon_sym_out] = ACTIONS(6253),
    [anon_sym_inout] = ACTIONS(6253),
    [anon_sym_extern] = ACTIONS(6253),
    [anon_sym___attribute__] = ACTIONS(6253),
    [anon_sym_COLON_COLON] = ACTIONS(6255),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6255),
    [anon_sym___declspec] = ACTIONS(6253),
    [anon_sym___based] = ACTIONS(6253),
    [anon_sym___cdecl] = ACTIONS(6253),
    [anon_sym___clrcall] = ACTIONS(6253),
    [anon_sym___stdcall] = ACTIONS(6253),
    [anon_sym___fastcall] = ACTIONS(6253),
    [anon_sym___thiscall] = ACTIONS(6253),
    [anon_sym___vectorcall] = ACTIONS(6253),
    [anon_sym_LBRACK] = ACTIONS(6253),
    [anon_sym_static] = ACTIONS(6253),
    [anon_sym_EQ] = ACTIONS(6255),
    [anon_sym_register] = ACTIONS(6253),
    [anon_sym_inline] = ACTIONS(6253),
    [anon_sym___inline] = ACTIONS(6253),
    [anon_sym___inline__] = ACTIONS(6253),
    [anon_sym___forceinline] = ACTIONS(6253),
    [anon_sym_thread_local] = ACTIONS(6253),
    [anon_sym___thread] = ACTIONS(6253),
    [anon_sym_const] = ACTIONS(6253),
    [anon_sym_constexpr] = ACTIONS(6253),
    [anon_sym_volatile] = ACTIONS(6253),
    [anon_sym_restrict] = ACTIONS(6253),
    [anon_sym___restrict__] = ACTIONS(6253),
    [anon_sym__Atomic] = ACTIONS(6253),
    [anon_sym__Noreturn] = ACTIONS(6253),
    [anon_sym_noreturn] = ACTIONS(6253),
    [anon_sym_mutable] = ACTIONS(6253),
    [anon_sym_constinit] = ACTIONS(6253),
    [anon_sym_consteval] = ACTIONS(6253),
    [anon_sym_alignas] = ACTIONS(6253),
    [anon_sym__Alignas] = ACTIONS(6253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(6253),
    [sym_virtual] = ACTIONS(6253),
    [anon_sym_explicit] = ACTIONS(6253),
    [anon_sym_template] = ACTIONS(6253),
    [anon_sym_GT2] = ACTIONS(6255),
    [anon_sym_operator] = ACTIONS(6253),
    [anon_sym_precise] = ACTIONS(6253),
    [anon_sym_shared] = ACTIONS(6253),
    [anon_sym_groupshared] = ACTIONS(6253),
    [anon_sym_uniform] = ACTIONS(6253),
    [anon_sym_row_major] = ACTIONS(6253),
    [anon_sym_column_major] = ACTIONS(6253),
    [anon_sym_globallycoherent] = ACTIONS(6253),
    [anon_sym_centroid] = ACTIONS(6253),
    [anon_sym_noperspective] = ACTIONS(6253),
    [anon_sym_nointerpolation] = ACTIONS(6253),
    [anon_sym_sample] = ACTIONS(6253),
    [anon_sym_linear] = ACTIONS(6253),
    [anon_sym_snorm] = ACTIONS(6253),
    [anon_sym_unorm] = ACTIONS(6253),
    [anon_sym_point] = ACTIONS(6253),
    [anon_sym_line] = ACTIONS(6253),
    [anon_sym_triangleadj] = ACTIONS(6253),
    [anon_sym_lineadj] = ACTIONS(6253),
    [anon_sym_triangle] = ACTIONS(6253),
  },
  [2816] = {
    [sym_identifier] = ACTIONS(2210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2217),
    [anon_sym_COMMA] = ACTIONS(2217),
    [anon_sym_RPAREN] = ACTIONS(2217),
    [anon_sym_LPAREN2] = ACTIONS(2217),
    [anon_sym_DASH] = ACTIONS(2210),
    [anon_sym_PLUS] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(2217),
    [anon_sym_SLASH] = ACTIONS(2210),
    [anon_sym_PERCENT] = ACTIONS(2217),
    [anon_sym_PIPE_PIPE] = ACTIONS(2217),
    [anon_sym_AMP_AMP] = ACTIONS(2217),
    [anon_sym_PIPE] = ACTIONS(2210),
    [anon_sym_CARET] = ACTIONS(2217),
    [anon_sym_AMP] = ACTIONS(2210),
    [anon_sym_EQ_EQ] = ACTIONS(2217),
    [anon_sym_BANG_EQ] = ACTIONS(2217),
    [anon_sym_GT] = ACTIONS(2210),
    [anon_sym_GT_EQ] = ACTIONS(2217),
    [anon_sym_LT_EQ] = ACTIONS(2210),
    [anon_sym_LT] = ACTIONS(2210),
    [anon_sym_LT_LT] = ACTIONS(2217),
    [anon_sym_GT_GT] = ACTIONS(2217),
    [anon_sym_COLON] = ACTIONS(2210),
    [anon_sym_SEMI] = ACTIONS(2217),
    [anon_sym___extension__] = ACTIONS(2210),
    [anon_sym___attribute__] = ACTIONS(2210),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym___based] = ACTIONS(2210),
    [anon_sym_LBRACE] = ACTIONS(2217),
    [anon_sym_RBRACE] = ACTIONS(2217),
    [anon_sym_signed] = ACTIONS(2210),
    [anon_sym_unsigned] = ACTIONS(2210),
    [anon_sym_long] = ACTIONS(2210),
    [anon_sym_short] = ACTIONS(2210),
    [anon_sym_LBRACK] = ACTIONS(2217),
    [anon_sym_RBRACK] = ACTIONS(2217),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_constexpr] = ACTIONS(2210),
    [anon_sym_volatile] = ACTIONS(2210),
    [anon_sym_restrict] = ACTIONS(2210),
    [anon_sym___restrict__] = ACTIONS(2210),
    [anon_sym__Atomic] = ACTIONS(2210),
    [anon_sym__Noreturn] = ACTIONS(2210),
    [anon_sym_noreturn] = ACTIONS(2210),
    [anon_sym_mutable] = ACTIONS(2210),
    [anon_sym_constinit] = ACTIONS(2210),
    [anon_sym_consteval] = ACTIONS(2210),
    [anon_sym_alignas] = ACTIONS(2210),
    [anon_sym__Alignas] = ACTIONS(2210),
    [sym_primitive_type] = ACTIONS(2210),
    [anon_sym_else] = ACTIONS(2210),
    [anon_sym_while] = ACTIONS(2210),
    [anon_sym_QMARK] = ACTIONS(2217),
    [anon_sym_LT_EQ_GT] = ACTIONS(2217),
    [anon_sym_or] = ACTIONS(2210),
    [anon_sym_and] = ACTIONS(2210),
    [anon_sym_bitor] = ACTIONS(2210),
    [anon_sym_xor] = ACTIONS(2210),
    [anon_sym_bitand] = ACTIONS(2210),
    [anon_sym_not_eq] = ACTIONS(2210),
    [anon_sym_is] = ACTIONS(2210),
    [anon_sym_as] = ACTIONS(2210),
    [anon_sym_DASH_DASH] = ACTIONS(2217),
    [anon_sym_PLUS_PLUS] = ACTIONS(2217),
    [anon_sym_DOT] = ACTIONS(2210),
    [anon_sym_DOT_STAR] = ACTIONS(2217),
    [anon_sym_DASH_GT] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2210),
    [anon_sym_let] = ACTIONS(2210),
    [anon_sym_This] = ACTIONS(2210),
    [anon_sym_final] = ACTIONS(2210),
    [anon_sym_override] = ACTIONS(2210),
    [anon_sym_requires] = ACTIONS(2210),
    [anon_sym_where] = ACTIONS(2210),
  },
  [2817] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2196),
    [anon_sym_COMMA] = ACTIONS(2196),
    [anon_sym_LPAREN2] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2194),
    [anon_sym_PLUS] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(2194),
    [anon_sym_SLASH] = ACTIONS(2194),
    [anon_sym_PERCENT] = ACTIONS(2194),
    [anon_sym_PIPE_PIPE] = ACTIONS(2196),
    [anon_sym_AMP_AMP] = ACTIONS(2196),
    [anon_sym_PIPE] = ACTIONS(2194),
    [anon_sym_CARET] = ACTIONS(2194),
    [anon_sym_AMP] = ACTIONS(2194),
    [anon_sym_EQ_EQ] = ACTIONS(2196),
    [anon_sym_BANG_EQ] = ACTIONS(2196),
    [anon_sym_GT] = ACTIONS(2194),
    [anon_sym_GT_EQ] = ACTIONS(2194),
    [anon_sym_LT_EQ] = ACTIONS(2194),
    [anon_sym_LT] = ACTIONS(2194),
    [anon_sym_LT_LT] = ACTIONS(2194),
    [anon_sym_GT_GT] = ACTIONS(2194),
    [anon_sym_COLON] = ACTIONS(2194),
    [anon_sym___extension__] = ACTIONS(2196),
    [anon_sym___attribute__] = ACTIONS(2196),
    [anon_sym_COLON_COLON] = ACTIONS(2196),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_LBRACK] = ACTIONS(2196),
    [anon_sym_EQ] = ACTIONS(2194),
    [anon_sym_const] = ACTIONS(2194),
    [anon_sym_constexpr] = ACTIONS(2196),
    [anon_sym_volatile] = ACTIONS(2196),
    [anon_sym_restrict] = ACTIONS(2196),
    [anon_sym___restrict__] = ACTIONS(2196),
    [anon_sym__Atomic] = ACTIONS(2196),
    [anon_sym__Noreturn] = ACTIONS(2196),
    [anon_sym_noreturn] = ACTIONS(2196),
    [anon_sym_mutable] = ACTIONS(2196),
    [anon_sym_constinit] = ACTIONS(2196),
    [anon_sym_consteval] = ACTIONS(2196),
    [anon_sym_alignas] = ACTIONS(2196),
    [anon_sym__Alignas] = ACTIONS(2196),
    [anon_sym_QMARK] = ACTIONS(2196),
    [anon_sym_STAR_EQ] = ACTIONS(2196),
    [anon_sym_SLASH_EQ] = ACTIONS(2196),
    [anon_sym_PERCENT_EQ] = ACTIONS(2196),
    [anon_sym_PLUS_EQ] = ACTIONS(2196),
    [anon_sym_DASH_EQ] = ACTIONS(2196),
    [anon_sym_LT_LT_EQ] = ACTIONS(2196),
    [anon_sym_GT_GT_EQ] = ACTIONS(2194),
    [anon_sym_AMP_EQ] = ACTIONS(2196),
    [anon_sym_CARET_EQ] = ACTIONS(2196),
    [anon_sym_PIPE_EQ] = ACTIONS(2196),
    [anon_sym_and_eq] = ACTIONS(2196),
    [anon_sym_or_eq] = ACTIONS(2196),
    [anon_sym_xor_eq] = ACTIONS(2196),
    [anon_sym_LT_EQ_GT] = ACTIONS(2196),
    [anon_sym_or] = ACTIONS(2194),
    [anon_sym_and] = ACTIONS(2194),
    [anon_sym_bitor] = ACTIONS(2196),
    [anon_sym_xor] = ACTIONS(2194),
    [anon_sym_bitand] = ACTIONS(2196),
    [anon_sym_not_eq] = ACTIONS(2196),
    [anon_sym_is] = ACTIONS(2196),
    [anon_sym_as] = ACTIONS(2196),
    [anon_sym_DASH_DASH] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2196),
    [anon_sym_DOT] = ACTIONS(2194),
    [anon_sym_DOT_STAR] = ACTIONS(2196),
    [anon_sym_DASH_GT] = ACTIONS(2196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2196),
    [anon_sym_let] = ACTIONS(2196),
    [anon_sym_This] = ACTIONS(2196),
    [anon_sym_final] = ACTIONS(2196),
    [anon_sym_override] = ACTIONS(2196),
    [anon_sym_GT2] = ACTIONS(2196),
  },
  [2818] = {
    [sym_template_argument_list] = STATE(2686),
    [sym_identifier] = ACTIONS(2349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2347),
    [anon_sym_COMMA] = ACTIONS(6424),
    [anon_sym_LPAREN2] = ACTIONS(2347),
    [anon_sym_TILDE] = ACTIONS(2347),
    [anon_sym_STAR] = ACTIONS(2347),
    [anon_sym_AMP_AMP] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2349),
    [anon_sym_LT] = ACTIONS(6358),
    [anon_sym_COLON] = ACTIONS(2349),
    [anon_sym___extension__] = ACTIONS(2349),
    [anon_sym_in] = ACTIONS(2349),
    [anon_sym_out] = ACTIONS(2349),
    [anon_sym_inout] = ACTIONS(2349),
    [anon_sym_extern] = ACTIONS(2349),
    [anon_sym___attribute__] = ACTIONS(2349),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2347),
    [anon_sym___declspec] = ACTIONS(2349),
    [anon_sym___based] = ACTIONS(2349),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2349),
    [anon_sym_static] = ACTIONS(2349),
    [anon_sym_EQ] = ACTIONS(6426),
    [anon_sym_register] = ACTIONS(2349),
    [anon_sym_inline] = ACTIONS(2349),
    [anon_sym___inline] = ACTIONS(2349),
    [anon_sym___inline__] = ACTIONS(2349),
    [anon_sym___forceinline] = ACTIONS(2349),
    [anon_sym_thread_local] = ACTIONS(2349),
    [anon_sym___thread] = ACTIONS(2349),
    [anon_sym_const] = ACTIONS(2349),
    [anon_sym_constexpr] = ACTIONS(2349),
    [anon_sym_volatile] = ACTIONS(2349),
    [anon_sym_restrict] = ACTIONS(2349),
    [anon_sym___restrict__] = ACTIONS(2349),
    [anon_sym__Atomic] = ACTIONS(2349),
    [anon_sym__Noreturn] = ACTIONS(2349),
    [anon_sym_noreturn] = ACTIONS(2349),
    [anon_sym_mutable] = ACTIONS(2349),
    [anon_sym_constinit] = ACTIONS(2349),
    [anon_sym_consteval] = ACTIONS(2349),
    [anon_sym_alignas] = ACTIONS(2349),
    [anon_sym__Alignas] = ACTIONS(2349),
    [anon_sym_DOT] = ACTIONS(2349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2349),
    [anon_sym_let] = ACTIONS(2349),
    [anon_sym_This] = ACTIONS(2349),
    [anon_sym_decltype] = ACTIONS(2349),
    [anon_sym_final] = ACTIONS(2349),
    [anon_sym_override] = ACTIONS(2349),
    [sym_virtual] = ACTIONS(2349),
    [anon_sym_template] = ACTIONS(2349),
    [anon_sym_GT2] = ACTIONS(6424),
    [anon_sym_operator] = ACTIONS(2349),
    [anon_sym_precise] = ACTIONS(2349),
    [anon_sym_shared] = ACTIONS(2349),
    [anon_sym_groupshared] = ACTIONS(2349),
    [anon_sym_uniform] = ACTIONS(2349),
    [anon_sym_row_major] = ACTIONS(2349),
    [anon_sym_column_major] = ACTIONS(2349),
    [anon_sym_globallycoherent] = ACTIONS(2349),
    [anon_sym_centroid] = ACTIONS(2349),
    [anon_sym_noperspective] = ACTIONS(2349),
    [anon_sym_nointerpolation] = ACTIONS(2349),
    [anon_sym_sample] = ACTIONS(2349),
    [anon_sym_linear] = ACTIONS(2349),
    [anon_sym_snorm] = ACTIONS(2349),
    [anon_sym_unorm] = ACTIONS(2349),
    [anon_sym_point] = ACTIONS(2349),
    [anon_sym_line] = ACTIONS(2349),
    [anon_sym_triangleadj] = ACTIONS(2349),
    [anon_sym_lineadj] = ACTIONS(2349),
    [anon_sym_triangle] = ACTIONS(2349),
  },
  [2819] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2240),
    [anon_sym_PLUS] = ACTIONS(2240),
    [anon_sym_STAR] = ACTIONS(2240),
    [anon_sym_SLASH] = ACTIONS(2240),
    [anon_sym_PERCENT] = ACTIONS(2240),
    [anon_sym_PIPE_PIPE] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_PIPE] = ACTIONS(2240),
    [anon_sym_CARET] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2240),
    [anon_sym_EQ_EQ] = ACTIONS(2242),
    [anon_sym_BANG_EQ] = ACTIONS(2242),
    [anon_sym_GT] = ACTIONS(2240),
    [anon_sym_GT_EQ] = ACTIONS(2240),
    [anon_sym_LT_EQ] = ACTIONS(2240),
    [anon_sym_LT] = ACTIONS(2240),
    [anon_sym_LT_LT] = ACTIONS(2240),
    [anon_sym_GT_GT] = ACTIONS(2240),
    [anon_sym_COLON] = ACTIONS(2240),
    [anon_sym___extension__] = ACTIONS(2242),
    [anon_sym___attribute__] = ACTIONS(2242),
    [anon_sym_COLON_COLON] = ACTIONS(2242),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_EQ] = ACTIONS(2240),
    [anon_sym_const] = ACTIONS(2240),
    [anon_sym_constexpr] = ACTIONS(2242),
    [anon_sym_volatile] = ACTIONS(2242),
    [anon_sym_restrict] = ACTIONS(2242),
    [anon_sym___restrict__] = ACTIONS(2242),
    [anon_sym__Atomic] = ACTIONS(2242),
    [anon_sym__Noreturn] = ACTIONS(2242),
    [anon_sym_noreturn] = ACTIONS(2242),
    [anon_sym_mutable] = ACTIONS(2242),
    [anon_sym_constinit] = ACTIONS(2242),
    [anon_sym_consteval] = ACTIONS(2242),
    [anon_sym_alignas] = ACTIONS(2242),
    [anon_sym__Alignas] = ACTIONS(2242),
    [anon_sym_QMARK] = ACTIONS(2242),
    [anon_sym_STAR_EQ] = ACTIONS(2242),
    [anon_sym_SLASH_EQ] = ACTIONS(2242),
    [anon_sym_PERCENT_EQ] = ACTIONS(2242),
    [anon_sym_PLUS_EQ] = ACTIONS(2242),
    [anon_sym_DASH_EQ] = ACTIONS(2242),
    [anon_sym_LT_LT_EQ] = ACTIONS(2242),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2242),
    [anon_sym_CARET_EQ] = ACTIONS(2242),
    [anon_sym_PIPE_EQ] = ACTIONS(2242),
    [anon_sym_and_eq] = ACTIONS(2242),
    [anon_sym_or_eq] = ACTIONS(2242),
    [anon_sym_xor_eq] = ACTIONS(2242),
    [anon_sym_LT_EQ_GT] = ACTIONS(2242),
    [anon_sym_or] = ACTIONS(2240),
    [anon_sym_and] = ACTIONS(2240),
    [anon_sym_bitor] = ACTIONS(2242),
    [anon_sym_xor] = ACTIONS(2240),
    [anon_sym_bitand] = ACTIONS(2242),
    [anon_sym_not_eq] = ACTIONS(2242),
    [anon_sym_is] = ACTIONS(2242),
    [anon_sym_as] = ACTIONS(2242),
    [anon_sym_DASH_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_PLUS] = ACTIONS(2242),
    [anon_sym_DOT] = ACTIONS(2240),
    [anon_sym_DOT_STAR] = ACTIONS(2242),
    [anon_sym_DASH_GT] = ACTIONS(2242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2242),
    [anon_sym_let] = ACTIONS(2242),
    [anon_sym_This] = ACTIONS(2242),
    [anon_sym_final] = ACTIONS(2242),
    [anon_sym_override] = ACTIONS(2242),
    [anon_sym_GT2] = ACTIONS(2242),
  },
  [2820] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_LPAREN2] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2202),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_STAR] = ACTIONS(2202),
    [anon_sym_SLASH] = ACTIONS(2202),
    [anon_sym_PERCENT] = ACTIONS(2202),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2202),
    [anon_sym_CARET] = ACTIONS(2202),
    [anon_sym_AMP] = ACTIONS(2202),
    [anon_sym_EQ_EQ] = ACTIONS(2204),
    [anon_sym_BANG_EQ] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(2202),
    [anon_sym_GT_EQ] = ACTIONS(2202),
    [anon_sym_LT_EQ] = ACTIONS(2202),
    [anon_sym_LT] = ACTIONS(2202),
    [anon_sym_LT_LT] = ACTIONS(2202),
    [anon_sym_GT_GT] = ACTIONS(2202),
    [anon_sym_COLON] = ACTIONS(2202),
    [anon_sym___extension__] = ACTIONS(2204),
    [anon_sym___attribute__] = ACTIONS(2204),
    [anon_sym_COLON_COLON] = ACTIONS(2204),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(2204),
    [anon_sym_EQ] = ACTIONS(2202),
    [anon_sym_const] = ACTIONS(2202),
    [anon_sym_constexpr] = ACTIONS(2204),
    [anon_sym_volatile] = ACTIONS(2204),
    [anon_sym_restrict] = ACTIONS(2204),
    [anon_sym___restrict__] = ACTIONS(2204),
    [anon_sym__Atomic] = ACTIONS(2204),
    [anon_sym__Noreturn] = ACTIONS(2204),
    [anon_sym_noreturn] = ACTIONS(2204),
    [anon_sym_mutable] = ACTIONS(2204),
    [anon_sym_constinit] = ACTIONS(2204),
    [anon_sym_consteval] = ACTIONS(2204),
    [anon_sym_alignas] = ACTIONS(2204),
    [anon_sym__Alignas] = ACTIONS(2204),
    [anon_sym_QMARK] = ACTIONS(2204),
    [anon_sym_STAR_EQ] = ACTIONS(2204),
    [anon_sym_SLASH_EQ] = ACTIONS(2204),
    [anon_sym_PERCENT_EQ] = ACTIONS(2204),
    [anon_sym_PLUS_EQ] = ACTIONS(2204),
    [anon_sym_DASH_EQ] = ACTIONS(2204),
    [anon_sym_LT_LT_EQ] = ACTIONS(2204),
    [anon_sym_GT_GT_EQ] = ACTIONS(2202),
    [anon_sym_AMP_EQ] = ACTIONS(2204),
    [anon_sym_CARET_EQ] = ACTIONS(2204),
    [anon_sym_PIPE_EQ] = ACTIONS(2204),
    [anon_sym_and_eq] = ACTIONS(2204),
    [anon_sym_or_eq] = ACTIONS(2204),
    [anon_sym_xor_eq] = ACTIONS(2204),
    [anon_sym_LT_EQ_GT] = ACTIONS(2204),
    [anon_sym_or] = ACTIONS(2202),
    [anon_sym_and] = ACTIONS(2202),
    [anon_sym_bitor] = ACTIONS(2204),
    [anon_sym_xor] = ACTIONS(2202),
    [anon_sym_bitand] = ACTIONS(2204),
    [anon_sym_not_eq] = ACTIONS(2204),
    [anon_sym_is] = ACTIONS(2204),
    [anon_sym_as] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(2202),
    [anon_sym_DOT_STAR] = ACTIONS(2204),
    [anon_sym_DASH_GT] = ACTIONS(2204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2204),
    [anon_sym_let] = ACTIONS(2204),
    [anon_sym_This] = ACTIONS(2204),
    [anon_sym_final] = ACTIONS(2204),
    [anon_sym_override] = ACTIONS(2204),
    [anon_sym_GT2] = ACTIONS(2204),
  },
  [2821] = {
    [sym_attribute_specifier] = STATE(2773),
    [sym_enumerator_list] = STATE(2706),
    [sym__enum_base_clause] = STATE(2677),
    [sym_identifier] = ACTIONS(3060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3062),
    [anon_sym_COMMA] = ACTIONS(3062),
    [anon_sym_RPAREN] = ACTIONS(3062),
    [anon_sym_LPAREN2] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3062),
    [anon_sym_STAR] = ACTIONS(3062),
    [anon_sym_AMP_AMP] = ACTIONS(3062),
    [anon_sym_AMP] = ACTIONS(3060),
    [anon_sym_COLON] = ACTIONS(6464),
    [anon_sym___extension__] = ACTIONS(3060),
    [anon_sym_in] = ACTIONS(3060),
    [anon_sym_out] = ACTIONS(3060),
    [anon_sym_inout] = ACTIONS(3060),
    [anon_sym_extern] = ACTIONS(3060),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(3062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3062),
    [anon_sym___declspec] = ACTIONS(3060),
    [anon_sym___based] = ACTIONS(3060),
    [anon_sym_LBRACE] = ACTIONS(6313),
    [anon_sym_LBRACK] = ACTIONS(3060),
    [anon_sym_static] = ACTIONS(3060),
    [anon_sym_EQ] = ACTIONS(3062),
    [anon_sym_register] = ACTIONS(3060),
    [anon_sym_inline] = ACTIONS(3060),
    [anon_sym___inline] = ACTIONS(3060),
    [anon_sym___inline__] = ACTIONS(3060),
    [anon_sym___forceinline] = ACTIONS(3060),
    [anon_sym_thread_local] = ACTIONS(3060),
    [anon_sym___thread] = ACTIONS(3060),
    [anon_sym_const] = ACTIONS(3060),
    [anon_sym_constexpr] = ACTIONS(3060),
    [anon_sym_volatile] = ACTIONS(3060),
    [anon_sym_restrict] = ACTIONS(3060),
    [anon_sym___restrict__] = ACTIONS(3060),
    [anon_sym__Atomic] = ACTIONS(3060),
    [anon_sym__Noreturn] = ACTIONS(3060),
    [anon_sym_noreturn] = ACTIONS(3060),
    [anon_sym_mutable] = ACTIONS(3060),
    [anon_sym_constinit] = ACTIONS(3060),
    [anon_sym_consteval] = ACTIONS(3060),
    [anon_sym_alignas] = ACTIONS(3060),
    [anon_sym__Alignas] = ACTIONS(3060),
    [anon_sym_DOT] = ACTIONS(3060),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3060),
    [anon_sym_let] = ACTIONS(3060),
    [anon_sym_This] = ACTIONS(3060),
    [anon_sym_decltype] = ACTIONS(3060),
    [sym_virtual] = ACTIONS(3060),
    [anon_sym_template] = ACTIONS(3060),
    [anon_sym_GT2] = ACTIONS(3062),
    [anon_sym_operator] = ACTIONS(3060),
    [anon_sym_precise] = ACTIONS(3060),
    [anon_sym_shared] = ACTIONS(3060),
    [anon_sym_groupshared] = ACTIONS(3060),
    [anon_sym_uniform] = ACTIONS(3060),
    [anon_sym_row_major] = ACTIONS(3060),
    [anon_sym_column_major] = ACTIONS(3060),
    [anon_sym_globallycoherent] = ACTIONS(3060),
    [anon_sym_centroid] = ACTIONS(3060),
    [anon_sym_noperspective] = ACTIONS(3060),
    [anon_sym_nointerpolation] = ACTIONS(3060),
    [anon_sym_sample] = ACTIONS(3060),
    [anon_sym_linear] = ACTIONS(3060),
    [anon_sym_snorm] = ACTIONS(3060),
    [anon_sym_unorm] = ACTIONS(3060),
    [anon_sym_point] = ACTIONS(3060),
    [anon_sym_line] = ACTIONS(3060),
    [anon_sym_triangleadj] = ACTIONS(3060),
    [anon_sym_lineadj] = ACTIONS(3060),
    [anon_sym_triangle] = ACTIONS(3060),
  },
  [2822] = {
    [sym_attribute_specifier] = STATE(2767),
    [sym_enumerator_list] = STATE(2708),
    [sym__enum_base_clause] = STATE(2678),
    [sym_identifier] = ACTIONS(3348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3350),
    [anon_sym_COMMA] = ACTIONS(3350),
    [anon_sym_RPAREN] = ACTIONS(3350),
    [anon_sym_LPAREN2] = ACTIONS(3350),
    [anon_sym_TILDE] = ACTIONS(3350),
    [anon_sym_STAR] = ACTIONS(3350),
    [anon_sym_AMP_AMP] = ACTIONS(3350),
    [anon_sym_AMP] = ACTIONS(3348),
    [anon_sym_COLON] = ACTIONS(6464),
    [anon_sym___extension__] = ACTIONS(3348),
    [anon_sym_in] = ACTIONS(3348),
    [anon_sym_out] = ACTIONS(3348),
    [anon_sym_inout] = ACTIONS(3348),
    [anon_sym_extern] = ACTIONS(3348),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(3350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3350),
    [anon_sym___declspec] = ACTIONS(3348),
    [anon_sym___based] = ACTIONS(3348),
    [anon_sym_LBRACE] = ACTIONS(6313),
    [anon_sym_LBRACK] = ACTIONS(3348),
    [anon_sym_static] = ACTIONS(3348),
    [anon_sym_EQ] = ACTIONS(3350),
    [anon_sym_register] = ACTIONS(3348),
    [anon_sym_inline] = ACTIONS(3348),
    [anon_sym___inline] = ACTIONS(3348),
    [anon_sym___inline__] = ACTIONS(3348),
    [anon_sym___forceinline] = ACTIONS(3348),
    [anon_sym_thread_local] = ACTIONS(3348),
    [anon_sym___thread] = ACTIONS(3348),
    [anon_sym_const] = ACTIONS(3348),
    [anon_sym_constexpr] = ACTIONS(3348),
    [anon_sym_volatile] = ACTIONS(3348),
    [anon_sym_restrict] = ACTIONS(3348),
    [anon_sym___restrict__] = ACTIONS(3348),
    [anon_sym__Atomic] = ACTIONS(3348),
    [anon_sym__Noreturn] = ACTIONS(3348),
    [anon_sym_noreturn] = ACTIONS(3348),
    [anon_sym_mutable] = ACTIONS(3348),
    [anon_sym_constinit] = ACTIONS(3348),
    [anon_sym_consteval] = ACTIONS(3348),
    [anon_sym_alignas] = ACTIONS(3348),
    [anon_sym__Alignas] = ACTIONS(3348),
    [anon_sym_DOT] = ACTIONS(3348),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3348),
    [anon_sym_let] = ACTIONS(3348),
    [anon_sym_This] = ACTIONS(3348),
    [anon_sym_decltype] = ACTIONS(3348),
    [sym_virtual] = ACTIONS(3348),
    [anon_sym_template] = ACTIONS(3348),
    [anon_sym_GT2] = ACTIONS(3350),
    [anon_sym_operator] = ACTIONS(3348),
    [anon_sym_precise] = ACTIONS(3348),
    [anon_sym_shared] = ACTIONS(3348),
    [anon_sym_groupshared] = ACTIONS(3348),
    [anon_sym_uniform] = ACTIONS(3348),
    [anon_sym_row_major] = ACTIONS(3348),
    [anon_sym_column_major] = ACTIONS(3348),
    [anon_sym_globallycoherent] = ACTIONS(3348),
    [anon_sym_centroid] = ACTIONS(3348),
    [anon_sym_noperspective] = ACTIONS(3348),
    [anon_sym_nointerpolation] = ACTIONS(3348),
    [anon_sym_sample] = ACTIONS(3348),
    [anon_sym_linear] = ACTIONS(3348),
    [anon_sym_snorm] = ACTIONS(3348),
    [anon_sym_unorm] = ACTIONS(3348),
    [anon_sym_point] = ACTIONS(3348),
    [anon_sym_line] = ACTIONS(3348),
    [anon_sym_triangleadj] = ACTIONS(3348),
    [anon_sym_lineadj] = ACTIONS(3348),
    [anon_sym_triangle] = ACTIONS(3348),
  },
  [2823] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2208),
    [anon_sym_COMMA] = ACTIONS(2208),
    [anon_sym_LPAREN2] = ACTIONS(2208),
    [anon_sym_DASH] = ACTIONS(2206),
    [anon_sym_PLUS] = ACTIONS(2206),
    [anon_sym_STAR] = ACTIONS(2206),
    [anon_sym_SLASH] = ACTIONS(2206),
    [anon_sym_PERCENT] = ACTIONS(2206),
    [anon_sym_PIPE_PIPE] = ACTIONS(2208),
    [anon_sym_AMP_AMP] = ACTIONS(2208),
    [anon_sym_PIPE] = ACTIONS(2206),
    [anon_sym_CARET] = ACTIONS(2206),
    [anon_sym_AMP] = ACTIONS(2206),
    [anon_sym_EQ_EQ] = ACTIONS(2208),
    [anon_sym_BANG_EQ] = ACTIONS(2208),
    [anon_sym_GT] = ACTIONS(2206),
    [anon_sym_GT_EQ] = ACTIONS(2206),
    [anon_sym_LT_EQ] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2206),
    [anon_sym_LT_LT] = ACTIONS(2206),
    [anon_sym_GT_GT] = ACTIONS(2206),
    [anon_sym_COLON] = ACTIONS(2206),
    [anon_sym___extension__] = ACTIONS(2208),
    [anon_sym___attribute__] = ACTIONS(2208),
    [anon_sym_COLON_COLON] = ACTIONS(2208),
    [anon_sym_LBRACE] = ACTIONS(2208),
    [anon_sym_LBRACK] = ACTIONS(2208),
    [anon_sym_EQ] = ACTIONS(2206),
    [anon_sym_const] = ACTIONS(2206),
    [anon_sym_constexpr] = ACTIONS(2208),
    [anon_sym_volatile] = ACTIONS(2208),
    [anon_sym_restrict] = ACTIONS(2208),
    [anon_sym___restrict__] = ACTIONS(2208),
    [anon_sym__Atomic] = ACTIONS(2208),
    [anon_sym__Noreturn] = ACTIONS(2208),
    [anon_sym_noreturn] = ACTIONS(2208),
    [anon_sym_mutable] = ACTIONS(2208),
    [anon_sym_constinit] = ACTIONS(2208),
    [anon_sym_consteval] = ACTIONS(2208),
    [anon_sym_alignas] = ACTIONS(2208),
    [anon_sym__Alignas] = ACTIONS(2208),
    [anon_sym_QMARK] = ACTIONS(2208),
    [anon_sym_STAR_EQ] = ACTIONS(2208),
    [anon_sym_SLASH_EQ] = ACTIONS(2208),
    [anon_sym_PERCENT_EQ] = ACTIONS(2208),
    [anon_sym_PLUS_EQ] = ACTIONS(2208),
    [anon_sym_DASH_EQ] = ACTIONS(2208),
    [anon_sym_LT_LT_EQ] = ACTIONS(2208),
    [anon_sym_GT_GT_EQ] = ACTIONS(2206),
    [anon_sym_AMP_EQ] = ACTIONS(2208),
    [anon_sym_CARET_EQ] = ACTIONS(2208),
    [anon_sym_PIPE_EQ] = ACTIONS(2208),
    [anon_sym_and_eq] = ACTIONS(2208),
    [anon_sym_or_eq] = ACTIONS(2208),
    [anon_sym_xor_eq] = ACTIONS(2208),
    [anon_sym_LT_EQ_GT] = ACTIONS(2208),
    [anon_sym_or] = ACTIONS(2206),
    [anon_sym_and] = ACTIONS(2206),
    [anon_sym_bitor] = ACTIONS(2208),
    [anon_sym_xor] = ACTIONS(2206),
    [anon_sym_bitand] = ACTIONS(2208),
    [anon_sym_not_eq] = ACTIONS(2208),
    [anon_sym_is] = ACTIONS(2208),
    [anon_sym_as] = ACTIONS(2208),
    [anon_sym_DASH_DASH] = ACTIONS(2208),
    [anon_sym_PLUS_PLUS] = ACTIONS(2208),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_DOT_STAR] = ACTIONS(2208),
    [anon_sym_DASH_GT] = ACTIONS(2208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2208),
    [anon_sym_let] = ACTIONS(2208),
    [anon_sym_This] = ACTIONS(2208),
    [anon_sym_final] = ACTIONS(2208),
    [anon_sym_override] = ACTIONS(2208),
    [anon_sym_GT2] = ACTIONS(2208),
  },
  [2824] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2248),
    [anon_sym_PLUS] = ACTIONS(2248),
    [anon_sym_STAR] = ACTIONS(2248),
    [anon_sym_SLASH] = ACTIONS(2248),
    [anon_sym_PERCENT] = ACTIONS(2248),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2248),
    [anon_sym_EQ_EQ] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_GT] = ACTIONS(2248),
    [anon_sym_GT_EQ] = ACTIONS(2248),
    [anon_sym_LT_EQ] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_LT_LT] = ACTIONS(2248),
    [anon_sym_GT_GT] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2248),
    [anon_sym___extension__] = ACTIONS(2250),
    [anon_sym___attribute__] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_const] = ACTIONS(2248),
    [anon_sym_constexpr] = ACTIONS(2250),
    [anon_sym_volatile] = ACTIONS(2250),
    [anon_sym_restrict] = ACTIONS(2250),
    [anon_sym___restrict__] = ACTIONS(2250),
    [anon_sym__Atomic] = ACTIONS(2250),
    [anon_sym__Noreturn] = ACTIONS(2250),
    [anon_sym_noreturn] = ACTIONS(2250),
    [anon_sym_mutable] = ACTIONS(2250),
    [anon_sym_constinit] = ACTIONS(2250),
    [anon_sym_consteval] = ACTIONS(2250),
    [anon_sym_alignas] = ACTIONS(2250),
    [anon_sym__Alignas] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_STAR_EQ] = ACTIONS(2250),
    [anon_sym_SLASH_EQ] = ACTIONS(2250),
    [anon_sym_PERCENT_EQ] = ACTIONS(2250),
    [anon_sym_PLUS_EQ] = ACTIONS(2250),
    [anon_sym_DASH_EQ] = ACTIONS(2250),
    [anon_sym_LT_LT_EQ] = ACTIONS(2250),
    [anon_sym_GT_GT_EQ] = ACTIONS(2248),
    [anon_sym_AMP_EQ] = ACTIONS(2250),
    [anon_sym_CARET_EQ] = ACTIONS(2250),
    [anon_sym_PIPE_EQ] = ACTIONS(2250),
    [anon_sym_and_eq] = ACTIONS(2250),
    [anon_sym_or_eq] = ACTIONS(2250),
    [anon_sym_xor_eq] = ACTIONS(2250),
    [anon_sym_LT_EQ_GT] = ACTIONS(2250),
    [anon_sym_or] = ACTIONS(2248),
    [anon_sym_and] = ACTIONS(2248),
    [anon_sym_bitor] = ACTIONS(2250),
    [anon_sym_xor] = ACTIONS(2248),
    [anon_sym_bitand] = ACTIONS(2250),
    [anon_sym_not_eq] = ACTIONS(2250),
    [anon_sym_is] = ACTIONS(2250),
    [anon_sym_as] = ACTIONS(2250),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2248),
    [anon_sym_DOT_STAR] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_This] = ACTIONS(2250),
    [anon_sym_final] = ACTIONS(2250),
    [anon_sym_override] = ACTIONS(2250),
    [anon_sym_GT2] = ACTIONS(2250),
  },
  [2825] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2258),
    [anon_sym_COMMA] = ACTIONS(2258),
    [anon_sym_LPAREN2] = ACTIONS(2258),
    [anon_sym_DASH] = ACTIONS(2256),
    [anon_sym_PLUS] = ACTIONS(2256),
    [anon_sym_STAR] = ACTIONS(2256),
    [anon_sym_SLASH] = ACTIONS(2256),
    [anon_sym_PERCENT] = ACTIONS(2256),
    [anon_sym_PIPE_PIPE] = ACTIONS(2258),
    [anon_sym_AMP_AMP] = ACTIONS(2258),
    [anon_sym_PIPE] = ACTIONS(2256),
    [anon_sym_CARET] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(2256),
    [anon_sym_EQ_EQ] = ACTIONS(2258),
    [anon_sym_BANG_EQ] = ACTIONS(2258),
    [anon_sym_GT] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_LT] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2256),
    [anon_sym_GT_GT] = ACTIONS(2256),
    [anon_sym_COLON] = ACTIONS(2256),
    [anon_sym___extension__] = ACTIONS(2258),
    [anon_sym___attribute__] = ACTIONS(2258),
    [anon_sym_COLON_COLON] = ACTIONS(2258),
    [anon_sym_LBRACE] = ACTIONS(2258),
    [anon_sym_LBRACK] = ACTIONS(2258),
    [anon_sym_EQ] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_constexpr] = ACTIONS(2258),
    [anon_sym_volatile] = ACTIONS(2258),
    [anon_sym_restrict] = ACTIONS(2258),
    [anon_sym___restrict__] = ACTIONS(2258),
    [anon_sym__Atomic] = ACTIONS(2258),
    [anon_sym__Noreturn] = ACTIONS(2258),
    [anon_sym_noreturn] = ACTIONS(2258),
    [anon_sym_mutable] = ACTIONS(2258),
    [anon_sym_constinit] = ACTIONS(2258),
    [anon_sym_consteval] = ACTIONS(2258),
    [anon_sym_alignas] = ACTIONS(2258),
    [anon_sym__Alignas] = ACTIONS(2258),
    [anon_sym_QMARK] = ACTIONS(2258),
    [anon_sym_STAR_EQ] = ACTIONS(2258),
    [anon_sym_SLASH_EQ] = ACTIONS(2258),
    [anon_sym_PERCENT_EQ] = ACTIONS(2258),
    [anon_sym_PLUS_EQ] = ACTIONS(2258),
    [anon_sym_DASH_EQ] = ACTIONS(2258),
    [anon_sym_LT_LT_EQ] = ACTIONS(2258),
    [anon_sym_GT_GT_EQ] = ACTIONS(2256),
    [anon_sym_AMP_EQ] = ACTIONS(2258),
    [anon_sym_CARET_EQ] = ACTIONS(2258),
    [anon_sym_PIPE_EQ] = ACTIONS(2258),
    [anon_sym_and_eq] = ACTIONS(2258),
    [anon_sym_or_eq] = ACTIONS(2258),
    [anon_sym_xor_eq] = ACTIONS(2258),
    [anon_sym_LT_EQ_GT] = ACTIONS(2258),
    [anon_sym_or] = ACTIONS(2256),
    [anon_sym_and] = ACTIONS(2256),
    [anon_sym_bitor] = ACTIONS(2258),
    [anon_sym_xor] = ACTIONS(2256),
    [anon_sym_bitand] = ACTIONS(2258),
    [anon_sym_not_eq] = ACTIONS(2258),
    [anon_sym_is] = ACTIONS(2258),
    [anon_sym_as] = ACTIONS(2258),
    [anon_sym_DASH_DASH] = ACTIONS(2258),
    [anon_sym_PLUS_PLUS] = ACTIONS(2258),
    [anon_sym_DOT] = ACTIONS(2256),
    [anon_sym_DOT_STAR] = ACTIONS(2258),
    [anon_sym_DASH_GT] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2258),
    [anon_sym_let] = ACTIONS(2258),
    [anon_sym_This] = ACTIONS(2258),
    [anon_sym_final] = ACTIONS(2258),
    [anon_sym_override] = ACTIONS(2258),
    [anon_sym_GT2] = ACTIONS(2258),
  },
  [2826] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_COMMA] = ACTIONS(2200),
    [anon_sym_LPAREN2] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(2198),
    [anon_sym_SLASH] = ACTIONS(2198),
    [anon_sym_PERCENT] = ACTIONS(2198),
    [anon_sym_PIPE_PIPE] = ACTIONS(2200),
    [anon_sym_AMP_AMP] = ACTIONS(2200),
    [anon_sym_PIPE] = ACTIONS(2198),
    [anon_sym_CARET] = ACTIONS(2198),
    [anon_sym_AMP] = ACTIONS(2198),
    [anon_sym_EQ_EQ] = ACTIONS(2200),
    [anon_sym_BANG_EQ] = ACTIONS(2200),
    [anon_sym_GT] = ACTIONS(2198),
    [anon_sym_GT_EQ] = ACTIONS(2198),
    [anon_sym_LT_EQ] = ACTIONS(2198),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_LT_LT] = ACTIONS(2198),
    [anon_sym_GT_GT] = ACTIONS(2198),
    [anon_sym_COLON] = ACTIONS(2198),
    [anon_sym___extension__] = ACTIONS(2200),
    [anon_sym___attribute__] = ACTIONS(2200),
    [anon_sym_COLON_COLON] = ACTIONS(2200),
    [anon_sym_LBRACE] = ACTIONS(2200),
    [anon_sym_LBRACK] = ACTIONS(2200),
    [anon_sym_EQ] = ACTIONS(2198),
    [anon_sym_const] = ACTIONS(2198),
    [anon_sym_constexpr] = ACTIONS(2200),
    [anon_sym_volatile] = ACTIONS(2200),
    [anon_sym_restrict] = ACTIONS(2200),
    [anon_sym___restrict__] = ACTIONS(2200),
    [anon_sym__Atomic] = ACTIONS(2200),
    [anon_sym__Noreturn] = ACTIONS(2200),
    [anon_sym_noreturn] = ACTIONS(2200),
    [anon_sym_mutable] = ACTIONS(2200),
    [anon_sym_constinit] = ACTIONS(2200),
    [anon_sym_consteval] = ACTIONS(2200),
    [anon_sym_alignas] = ACTIONS(2200),
    [anon_sym__Alignas] = ACTIONS(2200),
    [anon_sym_QMARK] = ACTIONS(2200),
    [anon_sym_STAR_EQ] = ACTIONS(2200),
    [anon_sym_SLASH_EQ] = ACTIONS(2200),
    [anon_sym_PERCENT_EQ] = ACTIONS(2200),
    [anon_sym_PLUS_EQ] = ACTIONS(2200),
    [anon_sym_DASH_EQ] = ACTIONS(2200),
    [anon_sym_LT_LT_EQ] = ACTIONS(2200),
    [anon_sym_GT_GT_EQ] = ACTIONS(2198),
    [anon_sym_AMP_EQ] = ACTIONS(2200),
    [anon_sym_CARET_EQ] = ACTIONS(2200),
    [anon_sym_PIPE_EQ] = ACTIONS(2200),
    [anon_sym_and_eq] = ACTIONS(2200),
    [anon_sym_or_eq] = ACTIONS(2200),
    [anon_sym_xor_eq] = ACTIONS(2200),
    [anon_sym_LT_EQ_GT] = ACTIONS(2200),
    [anon_sym_or] = ACTIONS(2198),
    [anon_sym_and] = ACTIONS(2198),
    [anon_sym_bitor] = ACTIONS(2200),
    [anon_sym_xor] = ACTIONS(2198),
    [anon_sym_bitand] = ACTIONS(2200),
    [anon_sym_not_eq] = ACTIONS(2200),
    [anon_sym_is] = ACTIONS(2200),
    [anon_sym_as] = ACTIONS(2200),
    [anon_sym_DASH_DASH] = ACTIONS(2200),
    [anon_sym_PLUS_PLUS] = ACTIONS(2200),
    [anon_sym_DOT] = ACTIONS(2198),
    [anon_sym_DOT_STAR] = ACTIONS(2200),
    [anon_sym_DASH_GT] = ACTIONS(2200),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2200),
    [anon_sym_let] = ACTIONS(2200),
    [anon_sym_This] = ACTIONS(2200),
    [anon_sym_final] = ACTIONS(2200),
    [anon_sym_override] = ACTIONS(2200),
    [anon_sym_GT2] = ACTIONS(2200),
  },
  [2827] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2238),
    [anon_sym_COMMA] = ACTIONS(2238),
    [anon_sym_LPAREN2] = ACTIONS(2238),
    [anon_sym_DASH] = ACTIONS(2236),
    [anon_sym_PLUS] = ACTIONS(2236),
    [anon_sym_STAR] = ACTIONS(2236),
    [anon_sym_SLASH] = ACTIONS(2236),
    [anon_sym_PERCENT] = ACTIONS(2236),
    [anon_sym_PIPE_PIPE] = ACTIONS(2238),
    [anon_sym_AMP_AMP] = ACTIONS(2238),
    [anon_sym_PIPE] = ACTIONS(2236),
    [anon_sym_CARET] = ACTIONS(2236),
    [anon_sym_AMP] = ACTIONS(2236),
    [anon_sym_EQ_EQ] = ACTIONS(2238),
    [anon_sym_BANG_EQ] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2236),
    [anon_sym_GT_EQ] = ACTIONS(2236),
    [anon_sym_LT_EQ] = ACTIONS(2236),
    [anon_sym_LT] = ACTIONS(2236),
    [anon_sym_LT_LT] = ACTIONS(2236),
    [anon_sym_GT_GT] = ACTIONS(2236),
    [anon_sym_COLON] = ACTIONS(2236),
    [anon_sym___extension__] = ACTIONS(2238),
    [anon_sym___attribute__] = ACTIONS(2238),
    [anon_sym_COLON_COLON] = ACTIONS(2238),
    [anon_sym_LBRACE] = ACTIONS(2238),
    [anon_sym_LBRACK] = ACTIONS(2238),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_const] = ACTIONS(2236),
    [anon_sym_constexpr] = ACTIONS(2238),
    [anon_sym_volatile] = ACTIONS(2238),
    [anon_sym_restrict] = ACTIONS(2238),
    [anon_sym___restrict__] = ACTIONS(2238),
    [anon_sym__Atomic] = ACTIONS(2238),
    [anon_sym__Noreturn] = ACTIONS(2238),
    [anon_sym_noreturn] = ACTIONS(2238),
    [anon_sym_mutable] = ACTIONS(2238),
    [anon_sym_constinit] = ACTIONS(2238),
    [anon_sym_consteval] = ACTIONS(2238),
    [anon_sym_alignas] = ACTIONS(2238),
    [anon_sym__Alignas] = ACTIONS(2238),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2238),
    [anon_sym_SLASH_EQ] = ACTIONS(2238),
    [anon_sym_PERCENT_EQ] = ACTIONS(2238),
    [anon_sym_PLUS_EQ] = ACTIONS(2238),
    [anon_sym_DASH_EQ] = ACTIONS(2238),
    [anon_sym_LT_LT_EQ] = ACTIONS(2238),
    [anon_sym_GT_GT_EQ] = ACTIONS(2236),
    [anon_sym_AMP_EQ] = ACTIONS(2238),
    [anon_sym_CARET_EQ] = ACTIONS(2238),
    [anon_sym_PIPE_EQ] = ACTIONS(2238),
    [anon_sym_and_eq] = ACTIONS(2238),
    [anon_sym_or_eq] = ACTIONS(2238),
    [anon_sym_xor_eq] = ACTIONS(2238),
    [anon_sym_LT_EQ_GT] = ACTIONS(2238),
    [anon_sym_or] = ACTIONS(2236),
    [anon_sym_and] = ACTIONS(2236),
    [anon_sym_bitor] = ACTIONS(2238),
    [anon_sym_xor] = ACTIONS(2236),
    [anon_sym_bitand] = ACTIONS(2238),
    [anon_sym_not_eq] = ACTIONS(2238),
    [anon_sym_is] = ACTIONS(2238),
    [anon_sym_as] = ACTIONS(2238),
    [anon_sym_DASH_DASH] = ACTIONS(2238),
    [anon_sym_PLUS_PLUS] = ACTIONS(2238),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_DOT_STAR] = ACTIONS(2238),
    [anon_sym_DASH_GT] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2238),
    [anon_sym_let] = ACTIONS(2238),
    [anon_sym_This] = ACTIONS(2238),
    [anon_sym_final] = ACTIONS(2238),
    [anon_sym_override] = ACTIONS(2238),
    [anon_sym_GT2] = ACTIONS(2238),
  },
  [2828] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_LPAREN2] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2186),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_STAR] = ACTIONS(2186),
    [anon_sym_SLASH] = ACTIONS(2186),
    [anon_sym_PERCENT] = ACTIONS(2186),
    [anon_sym_PIPE_PIPE] = ACTIONS(2188),
    [anon_sym_AMP_AMP] = ACTIONS(2188),
    [anon_sym_PIPE] = ACTIONS(2186),
    [anon_sym_CARET] = ACTIONS(2186),
    [anon_sym_AMP] = ACTIONS(2186),
    [anon_sym_EQ_EQ] = ACTIONS(2188),
    [anon_sym_BANG_EQ] = ACTIONS(2188),
    [anon_sym_GT] = ACTIONS(2186),
    [anon_sym_GT_EQ] = ACTIONS(2186),
    [anon_sym_LT_EQ] = ACTIONS(2186),
    [anon_sym_LT] = ACTIONS(2186),
    [anon_sym_LT_LT] = ACTIONS(2186),
    [anon_sym_GT_GT] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym___extension__] = ACTIONS(2188),
    [anon_sym___attribute__] = ACTIONS(2188),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_LBRACK] = ACTIONS(2188),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_constexpr] = ACTIONS(2188),
    [anon_sym_volatile] = ACTIONS(2188),
    [anon_sym_restrict] = ACTIONS(2188),
    [anon_sym___restrict__] = ACTIONS(2188),
    [anon_sym__Atomic] = ACTIONS(2188),
    [anon_sym__Noreturn] = ACTIONS(2188),
    [anon_sym_noreturn] = ACTIONS(2188),
    [anon_sym_mutable] = ACTIONS(2188),
    [anon_sym_constinit] = ACTIONS(2188),
    [anon_sym_consteval] = ACTIONS(2188),
    [anon_sym_alignas] = ACTIONS(2188),
    [anon_sym__Alignas] = ACTIONS(2188),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_STAR_EQ] = ACTIONS(2188),
    [anon_sym_SLASH_EQ] = ACTIONS(2188),
    [anon_sym_PERCENT_EQ] = ACTIONS(2188),
    [anon_sym_PLUS_EQ] = ACTIONS(2188),
    [anon_sym_DASH_EQ] = ACTIONS(2188),
    [anon_sym_LT_LT_EQ] = ACTIONS(2188),
    [anon_sym_GT_GT_EQ] = ACTIONS(2186),
    [anon_sym_AMP_EQ] = ACTIONS(2188),
    [anon_sym_CARET_EQ] = ACTIONS(2188),
    [anon_sym_PIPE_EQ] = ACTIONS(2188),
    [anon_sym_and_eq] = ACTIONS(2188),
    [anon_sym_or_eq] = ACTIONS(2188),
    [anon_sym_xor_eq] = ACTIONS(2188),
    [anon_sym_LT_EQ_GT] = ACTIONS(2188),
    [anon_sym_or] = ACTIONS(2186),
    [anon_sym_and] = ACTIONS(2186),
    [anon_sym_bitor] = ACTIONS(2188),
    [anon_sym_xor] = ACTIONS(2186),
    [anon_sym_bitand] = ACTIONS(2188),
    [anon_sym_not_eq] = ACTIONS(2188),
    [anon_sym_is] = ACTIONS(2188),
    [anon_sym_as] = ACTIONS(2188),
    [anon_sym_DASH_DASH] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2188),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOT_STAR] = ACTIONS(2188),
    [anon_sym_DASH_GT] = ACTIONS(2188),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2188),
    [anon_sym_let] = ACTIONS(2188),
    [anon_sym_This] = ACTIONS(2188),
    [anon_sym_final] = ACTIONS(2188),
    [anon_sym_override] = ACTIONS(2188),
    [anon_sym_GT2] = ACTIONS(2188),
  },
  [2829] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2226),
    [anon_sym_COMMA] = ACTIONS(2226),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_PLUS] = ACTIONS(2224),
    [anon_sym_STAR] = ACTIONS(2224),
    [anon_sym_SLASH] = ACTIONS(2224),
    [anon_sym_PERCENT] = ACTIONS(2224),
    [anon_sym_PIPE_PIPE] = ACTIONS(2226),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_PIPE] = ACTIONS(2224),
    [anon_sym_CARET] = ACTIONS(2224),
    [anon_sym_AMP] = ACTIONS(2224),
    [anon_sym_EQ_EQ] = ACTIONS(2226),
    [anon_sym_BANG_EQ] = ACTIONS(2226),
    [anon_sym_GT] = ACTIONS(2224),
    [anon_sym_GT_EQ] = ACTIONS(2224),
    [anon_sym_LT_EQ] = ACTIONS(2224),
    [anon_sym_LT] = ACTIONS(2224),
    [anon_sym_LT_LT] = ACTIONS(2224),
    [anon_sym_GT_GT] = ACTIONS(2224),
    [anon_sym_COLON] = ACTIONS(2224),
    [anon_sym___extension__] = ACTIONS(2226),
    [anon_sym___attribute__] = ACTIONS(2226),
    [anon_sym_COLON_COLON] = ACTIONS(2226),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_EQ] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_constexpr] = ACTIONS(2226),
    [anon_sym_volatile] = ACTIONS(2226),
    [anon_sym_restrict] = ACTIONS(2226),
    [anon_sym___restrict__] = ACTIONS(2226),
    [anon_sym__Atomic] = ACTIONS(2226),
    [anon_sym__Noreturn] = ACTIONS(2226),
    [anon_sym_noreturn] = ACTIONS(2226),
    [anon_sym_mutable] = ACTIONS(2226),
    [anon_sym_constinit] = ACTIONS(2226),
    [anon_sym_consteval] = ACTIONS(2226),
    [anon_sym_alignas] = ACTIONS(2226),
    [anon_sym__Alignas] = ACTIONS(2226),
    [anon_sym_QMARK] = ACTIONS(2226),
    [anon_sym_STAR_EQ] = ACTIONS(2226),
    [anon_sym_SLASH_EQ] = ACTIONS(2226),
    [anon_sym_PERCENT_EQ] = ACTIONS(2226),
    [anon_sym_PLUS_EQ] = ACTIONS(2226),
    [anon_sym_DASH_EQ] = ACTIONS(2226),
    [anon_sym_LT_LT_EQ] = ACTIONS(2226),
    [anon_sym_GT_GT_EQ] = ACTIONS(2224),
    [anon_sym_AMP_EQ] = ACTIONS(2226),
    [anon_sym_CARET_EQ] = ACTIONS(2226),
    [anon_sym_PIPE_EQ] = ACTIONS(2226),
    [anon_sym_and_eq] = ACTIONS(2226),
    [anon_sym_or_eq] = ACTIONS(2226),
    [anon_sym_xor_eq] = ACTIONS(2226),
    [anon_sym_LT_EQ_GT] = ACTIONS(2226),
    [anon_sym_or] = ACTIONS(2224),
    [anon_sym_and] = ACTIONS(2224),
    [anon_sym_bitor] = ACTIONS(2226),
    [anon_sym_xor] = ACTIONS(2224),
    [anon_sym_bitand] = ACTIONS(2226),
    [anon_sym_not_eq] = ACTIONS(2226),
    [anon_sym_is] = ACTIONS(2226),
    [anon_sym_as] = ACTIONS(2226),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_DOT] = ACTIONS(2224),
    [anon_sym_DOT_STAR] = ACTIONS(2226),
    [anon_sym_DASH_GT] = ACTIONS(2226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2226),
    [anon_sym_let] = ACTIONS(2226),
    [anon_sym_This] = ACTIONS(2226),
    [anon_sym_final] = ACTIONS(2226),
    [anon_sym_override] = ACTIONS(2226),
    [anon_sym_GT2] = ACTIONS(2226),
  },
  [2830] = {
    [sym_identifier] = ACTIONS(2232),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_COMMA] = ACTIONS(2234),
    [anon_sym_RPAREN] = ACTIONS(2234),
    [anon_sym_LPAREN2] = ACTIONS(2234),
    [anon_sym_TILDE] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_AMP_AMP] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2232),
    [anon_sym_COLON] = ACTIONS(2232),
    [anon_sym___extension__] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2232),
    [anon_sym_out] = ACTIONS(2232),
    [anon_sym_inout] = ACTIONS(2232),
    [anon_sym_extern] = ACTIONS(2232),
    [anon_sym___attribute__] = ACTIONS(2232),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2234),
    [anon_sym___declspec] = ACTIONS(2232),
    [anon_sym___based] = ACTIONS(2232),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2232),
    [anon_sym_static] = ACTIONS(2232),
    [anon_sym_EQ] = ACTIONS(2234),
    [anon_sym_register] = ACTIONS(2232),
    [anon_sym_inline] = ACTIONS(2232),
    [anon_sym___inline] = ACTIONS(2232),
    [anon_sym___inline__] = ACTIONS(2232),
    [anon_sym___forceinline] = ACTIONS(2232),
    [anon_sym_thread_local] = ACTIONS(2232),
    [anon_sym___thread] = ACTIONS(2232),
    [anon_sym_const] = ACTIONS(2232),
    [anon_sym_constexpr] = ACTIONS(2232),
    [anon_sym_volatile] = ACTIONS(2232),
    [anon_sym_restrict] = ACTIONS(2232),
    [anon_sym___restrict__] = ACTIONS(2232),
    [anon_sym__Atomic] = ACTIONS(2232),
    [anon_sym__Noreturn] = ACTIONS(2232),
    [anon_sym_noreturn] = ACTIONS(2232),
    [anon_sym_mutable] = ACTIONS(2232),
    [anon_sym_constinit] = ACTIONS(2232),
    [anon_sym_consteval] = ACTIONS(2232),
    [anon_sym_alignas] = ACTIONS(2232),
    [anon_sym__Alignas] = ACTIONS(2232),
    [anon_sym_DOT] = ACTIONS(2232),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2232),
    [anon_sym_let] = ACTIONS(2232),
    [anon_sym_This] = ACTIONS(2232),
    [anon_sym_decltype] = ACTIONS(2232),
    [anon_sym_final] = ACTIONS(2232),
    [anon_sym_override] = ACTIONS(2232),
    [sym_virtual] = ACTIONS(2232),
    [anon_sym_template] = ACTIONS(2232),
    [anon_sym_GT2] = ACTIONS(2234),
    [anon_sym_operator] = ACTIONS(2232),
    [anon_sym_precise] = ACTIONS(2232),
    [anon_sym_shared] = ACTIONS(2232),
    [anon_sym_groupshared] = ACTIONS(2232),
    [anon_sym_uniform] = ACTIONS(2232),
    [anon_sym_row_major] = ACTIONS(2232),
    [anon_sym_column_major] = ACTIONS(2232),
    [anon_sym_globallycoherent] = ACTIONS(2232),
    [anon_sym_centroid] = ACTIONS(2232),
    [anon_sym_noperspective] = ACTIONS(2232),
    [anon_sym_nointerpolation] = ACTIONS(2232),
    [anon_sym_sample] = ACTIONS(2232),
    [anon_sym_linear] = ACTIONS(2232),
    [anon_sym_snorm] = ACTIONS(2232),
    [anon_sym_unorm] = ACTIONS(2232),
    [anon_sym_point] = ACTIONS(2232),
    [anon_sym_line] = ACTIONS(2232),
    [anon_sym_triangleadj] = ACTIONS(2232),
    [anon_sym_lineadj] = ACTIONS(2232),
    [anon_sym_triangle] = ACTIONS(2232),
  },
  [2831] = {
    [sym_identifier] = ACTIONS(2202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_RPAREN] = ACTIONS(2204),
    [anon_sym_LPAREN2] = ACTIONS(2204),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_STAR] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_AMP] = ACTIONS(2202),
    [anon_sym_COLON] = ACTIONS(2202),
    [anon_sym___extension__] = ACTIONS(2202),
    [anon_sym_in] = ACTIONS(2202),
    [anon_sym_out] = ACTIONS(2202),
    [anon_sym_inout] = ACTIONS(2202),
    [anon_sym_extern] = ACTIONS(2202),
    [anon_sym___attribute__] = ACTIONS(2202),
    [anon_sym_COLON_COLON] = ACTIONS(2204),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2204),
    [anon_sym___declspec] = ACTIONS(2202),
    [anon_sym___based] = ACTIONS(2202),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2202),
    [anon_sym_EQ] = ACTIONS(2204),
    [anon_sym_register] = ACTIONS(2202),
    [anon_sym_inline] = ACTIONS(2202),
    [anon_sym___inline] = ACTIONS(2202),
    [anon_sym___inline__] = ACTIONS(2202),
    [anon_sym___forceinline] = ACTIONS(2202),
    [anon_sym_thread_local] = ACTIONS(2202),
    [anon_sym___thread] = ACTIONS(2202),
    [anon_sym_const] = ACTIONS(2202),
    [anon_sym_constexpr] = ACTIONS(2202),
    [anon_sym_volatile] = ACTIONS(2202),
    [anon_sym_restrict] = ACTIONS(2202),
    [anon_sym___restrict__] = ACTIONS(2202),
    [anon_sym__Atomic] = ACTIONS(2202),
    [anon_sym__Noreturn] = ACTIONS(2202),
    [anon_sym_noreturn] = ACTIONS(2202),
    [anon_sym_mutable] = ACTIONS(2202),
    [anon_sym_constinit] = ACTIONS(2202),
    [anon_sym_consteval] = ACTIONS(2202),
    [anon_sym_alignas] = ACTIONS(2202),
    [anon_sym__Alignas] = ACTIONS(2202),
    [anon_sym_DOT] = ACTIONS(2202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2202),
    [anon_sym_let] = ACTIONS(2202),
    [anon_sym_This] = ACTIONS(2202),
    [anon_sym_decltype] = ACTIONS(2202),
    [anon_sym_final] = ACTIONS(2202),
    [anon_sym_override] = ACTIONS(2202),
    [sym_virtual] = ACTIONS(2202),
    [anon_sym_template] = ACTIONS(2202),
    [anon_sym_GT2] = ACTIONS(2204),
    [anon_sym_operator] = ACTIONS(2202),
    [anon_sym_precise] = ACTIONS(2202),
    [anon_sym_shared] = ACTIONS(2202),
    [anon_sym_groupshared] = ACTIONS(2202),
    [anon_sym_uniform] = ACTIONS(2202),
    [anon_sym_row_major] = ACTIONS(2202),
    [anon_sym_column_major] = ACTIONS(2202),
    [anon_sym_globallycoherent] = ACTIONS(2202),
    [anon_sym_centroid] = ACTIONS(2202),
    [anon_sym_noperspective] = ACTIONS(2202),
    [anon_sym_nointerpolation] = ACTIONS(2202),
    [anon_sym_sample] = ACTIONS(2202),
    [anon_sym_linear] = ACTIONS(2202),
    [anon_sym_snorm] = ACTIONS(2202),
    [anon_sym_unorm] = ACTIONS(2202),
    [anon_sym_point] = ACTIONS(2202),
    [anon_sym_line] = ACTIONS(2202),
    [anon_sym_triangleadj] = ACTIONS(2202),
    [anon_sym_lineadj] = ACTIONS(2202),
    [anon_sym_triangle] = ACTIONS(2202),
  },
  [2832] = {
    [sym_identifier] = ACTIONS(2248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_RPAREN] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2248),
    [anon_sym___extension__] = ACTIONS(2248),
    [anon_sym_in] = ACTIONS(2248),
    [anon_sym_out] = ACTIONS(2248),
    [anon_sym_inout] = ACTIONS(2248),
    [anon_sym_extern] = ACTIONS(2248),
    [anon_sym___attribute__] = ACTIONS(2248),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2250),
    [anon_sym___declspec] = ACTIONS(2248),
    [anon_sym___based] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2248),
    [anon_sym_static] = ACTIONS(2248),
    [anon_sym_EQ] = ACTIONS(2250),
    [anon_sym_register] = ACTIONS(2248),
    [anon_sym_inline] = ACTIONS(2248),
    [anon_sym___inline] = ACTIONS(2248),
    [anon_sym___inline__] = ACTIONS(2248),
    [anon_sym___forceinline] = ACTIONS(2248),
    [anon_sym_thread_local] = ACTIONS(2248),
    [anon_sym___thread] = ACTIONS(2248),
    [anon_sym_const] = ACTIONS(2248),
    [anon_sym_constexpr] = ACTIONS(2248),
    [anon_sym_volatile] = ACTIONS(2248),
    [anon_sym_restrict] = ACTIONS(2248),
    [anon_sym___restrict__] = ACTIONS(2248),
    [anon_sym__Atomic] = ACTIONS(2248),
    [anon_sym__Noreturn] = ACTIONS(2248),
    [anon_sym_noreturn] = ACTIONS(2248),
    [anon_sym_mutable] = ACTIONS(2248),
    [anon_sym_constinit] = ACTIONS(2248),
    [anon_sym_consteval] = ACTIONS(2248),
    [anon_sym_alignas] = ACTIONS(2248),
    [anon_sym__Alignas] = ACTIONS(2248),
    [anon_sym_DOT] = ACTIONS(2248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2248),
    [anon_sym_let] = ACTIONS(2248),
    [anon_sym_This] = ACTIONS(2248),
    [anon_sym_decltype] = ACTIONS(2248),
    [anon_sym_final] = ACTIONS(2248),
    [anon_sym_override] = ACTIONS(2248),
    [sym_virtual] = ACTIONS(2248),
    [anon_sym_template] = ACTIONS(2248),
    [anon_sym_GT2] = ACTIONS(2250),
    [anon_sym_operator] = ACTIONS(2248),
    [anon_sym_precise] = ACTIONS(2248),
    [anon_sym_shared] = ACTIONS(2248),
    [anon_sym_groupshared] = ACTIONS(2248),
    [anon_sym_uniform] = ACTIONS(2248),
    [anon_sym_row_major] = ACTIONS(2248),
    [anon_sym_column_major] = ACTIONS(2248),
    [anon_sym_globallycoherent] = ACTIONS(2248),
    [anon_sym_centroid] = ACTIONS(2248),
    [anon_sym_noperspective] = ACTIONS(2248),
    [anon_sym_nointerpolation] = ACTIONS(2248),
    [anon_sym_sample] = ACTIONS(2248),
    [anon_sym_linear] = ACTIONS(2248),
    [anon_sym_snorm] = ACTIONS(2248),
    [anon_sym_unorm] = ACTIONS(2248),
    [anon_sym_point] = ACTIONS(2248),
    [anon_sym_line] = ACTIONS(2248),
    [anon_sym_triangleadj] = ACTIONS(2248),
    [anon_sym_lineadj] = ACTIONS(2248),
    [anon_sym_triangle] = ACTIONS(2248),
  },
  [2833] = {
    [sym_identifier] = ACTIONS(6466),
    [anon_sym_LPAREN2] = ACTIONS(6468),
    [anon_sym_BANG] = ACTIONS(6468),
    [anon_sym_TILDE] = ACTIONS(6468),
    [anon_sym_DASH] = ACTIONS(6466),
    [anon_sym_PLUS] = ACTIONS(6466),
    [anon_sym_STAR] = ACTIONS(6468),
    [anon_sym_AMP] = ACTIONS(6468),
    [anon_sym_SEMI] = ACTIONS(6468),
    [anon_sym_COLON_COLON] = ACTIONS(6468),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6468),
    [anon_sym_LBRACE] = ACTIONS(6468),
    [anon_sym_LBRACK] = ACTIONS(6466),
    [sym_primitive_type] = ACTIONS(6466),
    [anon_sym_if] = ACTIONS(6466),
    [anon_sym_switch] = ACTIONS(6466),
    [anon_sym_case] = ACTIONS(6466),
    [anon_sym_default] = ACTIONS(6466),
    [anon_sym_while] = ACTIONS(6466),
    [anon_sym_do] = ACTIONS(6466),
    [anon_sym_for] = ACTIONS(6466),
    [anon_sym_return] = ACTIONS(6466),
    [anon_sym_break] = ACTIONS(6466),
    [anon_sym_continue] = ACTIONS(6466),
    [anon_sym_goto] = ACTIONS(6466),
    [anon_sym___try] = ACTIONS(6466),
    [anon_sym___leave] = ACTIONS(6466),
    [anon_sym_not] = ACTIONS(6466),
    [anon_sym_compl] = ACTIONS(6466),
    [anon_sym_DASH_DASH] = ACTIONS(6468),
    [anon_sym_PLUS_PLUS] = ACTIONS(6468),
    [anon_sym_sizeof] = ACTIONS(6466),
    [anon_sym___alignof__] = ACTIONS(6466),
    [anon_sym___alignof] = ACTIONS(6466),
    [anon_sym__alignof] = ACTIONS(6466),
    [anon_sym_alignof] = ACTIONS(6466),
    [anon_sym__Alignof] = ACTIONS(6466),
    [anon_sym_offsetof] = ACTIONS(6466),
    [anon_sym__Generic] = ACTIONS(6466),
    [anon_sym_asm] = ACTIONS(6466),
    [anon_sym___asm__] = ACTIONS(6466),
    [sym_number_literal] = ACTIONS(6468),
    [anon_sym_L_SQUOTE] = ACTIONS(6468),
    [anon_sym_u_SQUOTE] = ACTIONS(6468),
    [anon_sym_U_SQUOTE] = ACTIONS(6468),
    [anon_sym_u8_SQUOTE] = ACTIONS(6468),
    [anon_sym_SQUOTE] = ACTIONS(6468),
    [anon_sym_L_DQUOTE] = ACTIONS(6468),
    [anon_sym_u_DQUOTE] = ACTIONS(6468),
    [anon_sym_U_DQUOTE] = ACTIONS(6468),
    [anon_sym_u8_DQUOTE] = ACTIONS(6468),
    [anon_sym_DQUOTE] = ACTIONS(6468),
    [sym_true] = ACTIONS(6466),
    [sym_false] = ACTIONS(6466),
    [anon_sym_NULL] = ACTIONS(6466),
    [anon_sym_nullptr] = ACTIONS(6466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(6466),
    [anon_sym_template] = ACTIONS(6466),
    [anon_sym_try] = ACTIONS(6466),
    [anon_sym_delete] = ACTIONS(6466),
    [anon_sym_throw] = ACTIONS(6466),
    [anon_sym_co_return] = ACTIONS(6466),
    [anon_sym_co_yield] = ACTIONS(6466),
    [anon_sym_R_DQUOTE] = ACTIONS(6468),
    [anon_sym_LR_DQUOTE] = ACTIONS(6468),
    [anon_sym_uR_DQUOTE] = ACTIONS(6468),
    [anon_sym_UR_DQUOTE] = ACTIONS(6468),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6468),
    [anon_sym_co_await] = ACTIONS(6466),
    [anon_sym_new] = ACTIONS(6466),
    [anon_sym_requires] = ACTIONS(6466),
    [sym_this] = ACTIONS(6466),
    [anon_sym_discard] = ACTIONS(6466),
    [anon_sym_cbuffer] = ACTIONS(6466),
  },
  [2834] = {
    [sym_identifier] = ACTIONS(2224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2226),
    [anon_sym_COMMA] = ACTIONS(2226),
    [anon_sym_RPAREN] = ACTIONS(2226),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_TILDE] = ACTIONS(2226),
    [anon_sym_STAR] = ACTIONS(2226),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_AMP] = ACTIONS(2224),
    [anon_sym_COLON] = ACTIONS(2224),
    [anon_sym___extension__] = ACTIONS(2224),
    [anon_sym_in] = ACTIONS(2224),
    [anon_sym_out] = ACTIONS(2224),
    [anon_sym_inout] = ACTIONS(2224),
    [anon_sym_extern] = ACTIONS(2224),
    [anon_sym___attribute__] = ACTIONS(2224),
    [anon_sym_COLON_COLON] = ACTIONS(2226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2226),
    [anon_sym___declspec] = ACTIONS(2224),
    [anon_sym___based] = ACTIONS(2224),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_LBRACK] = ACTIONS(2224),
    [anon_sym_static] = ACTIONS(2224),
    [anon_sym_EQ] = ACTIONS(2226),
    [anon_sym_register] = ACTIONS(2224),
    [anon_sym_inline] = ACTIONS(2224),
    [anon_sym___inline] = ACTIONS(2224),
    [anon_sym___inline__] = ACTIONS(2224),
    [anon_sym___forceinline] = ACTIONS(2224),
    [anon_sym_thread_local] = ACTIONS(2224),
    [anon_sym___thread] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_constexpr] = ACTIONS(2224),
    [anon_sym_volatile] = ACTIONS(2224),
    [anon_sym_restrict] = ACTIONS(2224),
    [anon_sym___restrict__] = ACTIONS(2224),
    [anon_sym__Atomic] = ACTIONS(2224),
    [anon_sym__Noreturn] = ACTIONS(2224),
    [anon_sym_noreturn] = ACTIONS(2224),
    [anon_sym_mutable] = ACTIONS(2224),
    [anon_sym_constinit] = ACTIONS(2224),
    [anon_sym_consteval] = ACTIONS(2224),
    [anon_sym_alignas] = ACTIONS(2224),
    [anon_sym__Alignas] = ACTIONS(2224),
    [anon_sym_DOT] = ACTIONS(2224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2224),
    [anon_sym_let] = ACTIONS(2224),
    [anon_sym_This] = ACTIONS(2224),
    [anon_sym_decltype] = ACTIONS(2224),
    [anon_sym_final] = ACTIONS(2224),
    [anon_sym_override] = ACTIONS(2224),
    [sym_virtual] = ACTIONS(2224),
    [anon_sym_template] = ACTIONS(2224),
    [anon_sym_GT2] = ACTIONS(2226),
    [anon_sym_operator] = ACTIONS(2224),
    [anon_sym_precise] = ACTIONS(2224),
    [anon_sym_shared] = ACTIONS(2224),
    [anon_sym_groupshared] = ACTIONS(2224),
    [anon_sym_uniform] = ACTIONS(2224),
    [anon_sym_row_major] = ACTIONS(2224),
    [anon_sym_column_major] = ACTIONS(2224),
    [anon_sym_globallycoherent] = ACTIONS(2224),
    [anon_sym_centroid] = ACTIONS(2224),
    [anon_sym_noperspective] = ACTIONS(2224),
    [anon_sym_nointerpolation] = ACTIONS(2224),
    [anon_sym_sample] = ACTIONS(2224),
    [anon_sym_linear] = ACTIONS(2224),
    [anon_sym_snorm] = ACTIONS(2224),
    [anon_sym_unorm] = ACTIONS(2224),
    [anon_sym_point] = ACTIONS(2224),
    [anon_sym_line] = ACTIONS(2224),
    [anon_sym_triangleadj] = ACTIONS(2224),
    [anon_sym_lineadj] = ACTIONS(2224),
    [anon_sym_triangle] = ACTIONS(2224),
  },
  [2835] = {
    [sym_identifier] = ACTIONS(6470),
    [anon_sym_LPAREN2] = ACTIONS(6472),
    [anon_sym_BANG] = ACTIONS(6472),
    [anon_sym_TILDE] = ACTIONS(6472),
    [anon_sym_DASH] = ACTIONS(6470),
    [anon_sym_PLUS] = ACTIONS(6470),
    [anon_sym_STAR] = ACTIONS(6472),
    [anon_sym_AMP] = ACTIONS(6472),
    [anon_sym_SEMI] = ACTIONS(6472),
    [anon_sym_COLON_COLON] = ACTIONS(6472),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6472),
    [anon_sym_LBRACE] = ACTIONS(6472),
    [anon_sym_LBRACK] = ACTIONS(6470),
    [sym_primitive_type] = ACTIONS(6470),
    [anon_sym_if] = ACTIONS(6470),
    [anon_sym_switch] = ACTIONS(6470),
    [anon_sym_case] = ACTIONS(6470),
    [anon_sym_default] = ACTIONS(6470),
    [anon_sym_while] = ACTIONS(6470),
    [anon_sym_do] = ACTIONS(6470),
    [anon_sym_for] = ACTIONS(6470),
    [anon_sym_return] = ACTIONS(6470),
    [anon_sym_break] = ACTIONS(6470),
    [anon_sym_continue] = ACTIONS(6470),
    [anon_sym_goto] = ACTIONS(6470),
    [anon_sym___try] = ACTIONS(6470),
    [anon_sym___leave] = ACTIONS(6470),
    [anon_sym_not] = ACTIONS(6470),
    [anon_sym_compl] = ACTIONS(6470),
    [anon_sym_DASH_DASH] = ACTIONS(6472),
    [anon_sym_PLUS_PLUS] = ACTIONS(6472),
    [anon_sym_sizeof] = ACTIONS(6470),
    [anon_sym___alignof__] = ACTIONS(6470),
    [anon_sym___alignof] = ACTIONS(6470),
    [anon_sym__alignof] = ACTIONS(6470),
    [anon_sym_alignof] = ACTIONS(6470),
    [anon_sym__Alignof] = ACTIONS(6470),
    [anon_sym_offsetof] = ACTIONS(6470),
    [anon_sym__Generic] = ACTIONS(6470),
    [anon_sym_asm] = ACTIONS(6470),
    [anon_sym___asm__] = ACTIONS(6470),
    [sym_number_literal] = ACTIONS(6472),
    [anon_sym_L_SQUOTE] = ACTIONS(6472),
    [anon_sym_u_SQUOTE] = ACTIONS(6472),
    [anon_sym_U_SQUOTE] = ACTIONS(6472),
    [anon_sym_u8_SQUOTE] = ACTIONS(6472),
    [anon_sym_SQUOTE] = ACTIONS(6472),
    [anon_sym_L_DQUOTE] = ACTIONS(6472),
    [anon_sym_u_DQUOTE] = ACTIONS(6472),
    [anon_sym_U_DQUOTE] = ACTIONS(6472),
    [anon_sym_u8_DQUOTE] = ACTIONS(6472),
    [anon_sym_DQUOTE] = ACTIONS(6472),
    [sym_true] = ACTIONS(6470),
    [sym_false] = ACTIONS(6470),
    [anon_sym_NULL] = ACTIONS(6470),
    [anon_sym_nullptr] = ACTIONS(6470),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(6470),
    [anon_sym_template] = ACTIONS(6470),
    [anon_sym_try] = ACTIONS(6470),
    [anon_sym_delete] = ACTIONS(6470),
    [anon_sym_throw] = ACTIONS(6470),
    [anon_sym_co_return] = ACTIONS(6470),
    [anon_sym_co_yield] = ACTIONS(6470),
    [anon_sym_R_DQUOTE] = ACTIONS(6472),
    [anon_sym_LR_DQUOTE] = ACTIONS(6472),
    [anon_sym_uR_DQUOTE] = ACTIONS(6472),
    [anon_sym_UR_DQUOTE] = ACTIONS(6472),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6472),
    [anon_sym_co_await] = ACTIONS(6470),
    [anon_sym_new] = ACTIONS(6470),
    [anon_sym_requires] = ACTIONS(6470),
    [sym_this] = ACTIONS(6470),
    [anon_sym_discard] = ACTIONS(6470),
    [anon_sym_cbuffer] = ACTIONS(6470),
  },
  [2836] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2212),
    [anon_sym_COMMA] = ACTIONS(2212),
    [anon_sym_RPAREN] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(2214),
    [anon_sym_DASH] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(2222),
    [anon_sym_STAR] = ACTIONS(2219),
    [anon_sym_SLASH] = ACTIONS(2222),
    [anon_sym_PERCENT] = ACTIONS(2222),
    [anon_sym_PIPE_PIPE] = ACTIONS(2212),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2222),
    [anon_sym_CARET] = ACTIONS(2222),
    [anon_sym_AMP] = ACTIONS(2219),
    [anon_sym_EQ_EQ] = ACTIONS(2212),
    [anon_sym_BANG_EQ] = ACTIONS(2212),
    [anon_sym_GT] = ACTIONS(2222),
    [anon_sym_GT_EQ] = ACTIONS(2212),
    [anon_sym_LT_EQ] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(2222),
    [anon_sym_LT_LT] = ACTIONS(2222),
    [anon_sym_GT_GT] = ACTIONS(2222),
    [anon_sym_SEMI] = ACTIONS(2212),
    [anon_sym___extension__] = ACTIONS(2217),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2212),
    [anon_sym_LBRACE] = ACTIONS(2217),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_EQ] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_constexpr] = ACTIONS(2217),
    [anon_sym_volatile] = ACTIONS(2217),
    [anon_sym_restrict] = ACTIONS(2217),
    [anon_sym___restrict__] = ACTIONS(2217),
    [anon_sym__Atomic] = ACTIONS(2217),
    [anon_sym__Noreturn] = ACTIONS(2217),
    [anon_sym_noreturn] = ACTIONS(2217),
    [anon_sym_mutable] = ACTIONS(2217),
    [anon_sym_constinit] = ACTIONS(2217),
    [anon_sym_consteval] = ACTIONS(2217),
    [anon_sym_alignas] = ACTIONS(2217),
    [anon_sym__Alignas] = ACTIONS(2217),
    [anon_sym_QMARK] = ACTIONS(2212),
    [anon_sym_STAR_EQ] = ACTIONS(2212),
    [anon_sym_SLASH_EQ] = ACTIONS(2212),
    [anon_sym_PERCENT_EQ] = ACTIONS(2212),
    [anon_sym_PLUS_EQ] = ACTIONS(2212),
    [anon_sym_DASH_EQ] = ACTIONS(2212),
    [anon_sym_LT_LT_EQ] = ACTIONS(2212),
    [anon_sym_GT_GT_EQ] = ACTIONS(2212),
    [anon_sym_AMP_EQ] = ACTIONS(2212),
    [anon_sym_CARET_EQ] = ACTIONS(2212),
    [anon_sym_PIPE_EQ] = ACTIONS(2212),
    [anon_sym_and_eq] = ACTIONS(2212),
    [anon_sym_or_eq] = ACTIONS(2212),
    [anon_sym_xor_eq] = ACTIONS(2212),
    [anon_sym_LT_EQ_GT] = ACTIONS(2212),
    [anon_sym_or] = ACTIONS(2222),
    [anon_sym_and] = ACTIONS(2222),
    [anon_sym_bitor] = ACTIONS(2212),
    [anon_sym_xor] = ACTIONS(2222),
    [anon_sym_bitand] = ACTIONS(2212),
    [anon_sym_not_eq] = ACTIONS(2212),
    [anon_sym_is] = ACTIONS(2212),
    [anon_sym_as] = ACTIONS(2212),
    [anon_sym_DASH_DASH] = ACTIONS(2212),
    [anon_sym_PLUS_PLUS] = ACTIONS(2212),
    [anon_sym_DOT] = ACTIONS(2219),
    [anon_sym_DOT_STAR] = ACTIONS(2212),
    [anon_sym_DASH_GT] = ACTIONS(2222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2217),
    [anon_sym_let] = ACTIONS(2217),
    [anon_sym_This] = ACTIONS(2217),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2212),
  },
  [2837] = {
    [sym_identifier] = ACTIONS(2236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2238),
    [anon_sym_COMMA] = ACTIONS(2238),
    [anon_sym_RPAREN] = ACTIONS(2238),
    [anon_sym_LPAREN2] = ACTIONS(2238),
    [anon_sym_TILDE] = ACTIONS(2238),
    [anon_sym_STAR] = ACTIONS(2238),
    [anon_sym_AMP_AMP] = ACTIONS(2238),
    [anon_sym_AMP] = ACTIONS(2236),
    [anon_sym_COLON] = ACTIONS(2236),
    [anon_sym___extension__] = ACTIONS(2236),
    [anon_sym_in] = ACTIONS(2236),
    [anon_sym_out] = ACTIONS(2236),
    [anon_sym_inout] = ACTIONS(2236),
    [anon_sym_extern] = ACTIONS(2236),
    [anon_sym___attribute__] = ACTIONS(2236),
    [anon_sym_COLON_COLON] = ACTIONS(2238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2238),
    [anon_sym___declspec] = ACTIONS(2236),
    [anon_sym___based] = ACTIONS(2236),
    [anon_sym_LBRACE] = ACTIONS(2238),
    [anon_sym_LBRACK] = ACTIONS(2236),
    [anon_sym_static] = ACTIONS(2236),
    [anon_sym_EQ] = ACTIONS(2238),
    [anon_sym_register] = ACTIONS(2236),
    [anon_sym_inline] = ACTIONS(2236),
    [anon_sym___inline] = ACTIONS(2236),
    [anon_sym___inline__] = ACTIONS(2236),
    [anon_sym___forceinline] = ACTIONS(2236),
    [anon_sym_thread_local] = ACTIONS(2236),
    [anon_sym___thread] = ACTIONS(2236),
    [anon_sym_const] = ACTIONS(2236),
    [anon_sym_constexpr] = ACTIONS(2236),
    [anon_sym_volatile] = ACTIONS(2236),
    [anon_sym_restrict] = ACTIONS(2236),
    [anon_sym___restrict__] = ACTIONS(2236),
    [anon_sym__Atomic] = ACTIONS(2236),
    [anon_sym__Noreturn] = ACTIONS(2236),
    [anon_sym_noreturn] = ACTIONS(2236),
    [anon_sym_mutable] = ACTIONS(2236),
    [anon_sym_constinit] = ACTIONS(2236),
    [anon_sym_consteval] = ACTIONS(2236),
    [anon_sym_alignas] = ACTIONS(2236),
    [anon_sym__Alignas] = ACTIONS(2236),
    [anon_sym_DOT] = ACTIONS(2236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2236),
    [anon_sym_let] = ACTIONS(2236),
    [anon_sym_This] = ACTIONS(2236),
    [anon_sym_decltype] = ACTIONS(2236),
    [anon_sym_final] = ACTIONS(2236),
    [anon_sym_override] = ACTIONS(2236),
    [sym_virtual] = ACTIONS(2236),
    [anon_sym_template] = ACTIONS(2236),
    [anon_sym_GT2] = ACTIONS(2238),
    [anon_sym_operator] = ACTIONS(2236),
    [anon_sym_precise] = ACTIONS(2236),
    [anon_sym_shared] = ACTIONS(2236),
    [anon_sym_groupshared] = ACTIONS(2236),
    [anon_sym_uniform] = ACTIONS(2236),
    [anon_sym_row_major] = ACTIONS(2236),
    [anon_sym_column_major] = ACTIONS(2236),
    [anon_sym_globallycoherent] = ACTIONS(2236),
    [anon_sym_centroid] = ACTIONS(2236),
    [anon_sym_noperspective] = ACTIONS(2236),
    [anon_sym_nointerpolation] = ACTIONS(2236),
    [anon_sym_sample] = ACTIONS(2236),
    [anon_sym_linear] = ACTIONS(2236),
    [anon_sym_snorm] = ACTIONS(2236),
    [anon_sym_unorm] = ACTIONS(2236),
    [anon_sym_point] = ACTIONS(2236),
    [anon_sym_line] = ACTIONS(2236),
    [anon_sym_triangleadj] = ACTIONS(2236),
    [anon_sym_lineadj] = ACTIONS(2236),
    [anon_sym_triangle] = ACTIONS(2236),
  },
  [2838] = {
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2230),
    [anon_sym_COMMA] = ACTIONS(2230),
    [anon_sym_RPAREN] = ACTIONS(2230),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_TILDE] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_AMP] = ACTIONS(2228),
    [anon_sym_COLON] = ACTIONS(2228),
    [anon_sym___extension__] = ACTIONS(2228),
    [anon_sym_in] = ACTIONS(2228),
    [anon_sym_out] = ACTIONS(2228),
    [anon_sym_inout] = ACTIONS(2228),
    [anon_sym_extern] = ACTIONS(2228),
    [anon_sym___attribute__] = ACTIONS(2228),
    [anon_sym_COLON_COLON] = ACTIONS(2230),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2230),
    [anon_sym___declspec] = ACTIONS(2228),
    [anon_sym___based] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2228),
    [anon_sym_static] = ACTIONS(2228),
    [anon_sym_EQ] = ACTIONS(2230),
    [anon_sym_register] = ACTIONS(2228),
    [anon_sym_inline] = ACTIONS(2228),
    [anon_sym___inline] = ACTIONS(2228),
    [anon_sym___inline__] = ACTIONS(2228),
    [anon_sym___forceinline] = ACTIONS(2228),
    [anon_sym_thread_local] = ACTIONS(2228),
    [anon_sym___thread] = ACTIONS(2228),
    [anon_sym_const] = ACTIONS(2228),
    [anon_sym_constexpr] = ACTIONS(2228),
    [anon_sym_volatile] = ACTIONS(2228),
    [anon_sym_restrict] = ACTIONS(2228),
    [anon_sym___restrict__] = ACTIONS(2228),
    [anon_sym__Atomic] = ACTIONS(2228),
    [anon_sym__Noreturn] = ACTIONS(2228),
    [anon_sym_noreturn] = ACTIONS(2228),
    [anon_sym_mutable] = ACTIONS(2228),
    [anon_sym_constinit] = ACTIONS(2228),
    [anon_sym_consteval] = ACTIONS(2228),
    [anon_sym_alignas] = ACTIONS(2228),
    [anon_sym__Alignas] = ACTIONS(2228),
    [anon_sym_DOT] = ACTIONS(2228),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(2228),
    [anon_sym_This] = ACTIONS(2228),
    [anon_sym_decltype] = ACTIONS(2228),
    [anon_sym_final] = ACTIONS(2228),
    [anon_sym_override] = ACTIONS(2228),
    [sym_virtual] = ACTIONS(2228),
    [anon_sym_template] = ACTIONS(2228),
    [anon_sym_GT2] = ACTIONS(2230),
    [anon_sym_operator] = ACTIONS(2228),
    [anon_sym_precise] = ACTIONS(2228),
    [anon_sym_shared] = ACTIONS(2228),
    [anon_sym_groupshared] = ACTIONS(2228),
    [anon_sym_uniform] = ACTIONS(2228),
    [anon_sym_row_major] = ACTIONS(2228),
    [anon_sym_column_major] = ACTIONS(2228),
    [anon_sym_globallycoherent] = ACTIONS(2228),
    [anon_sym_centroid] = ACTIONS(2228),
    [anon_sym_noperspective] = ACTIONS(2228),
    [anon_sym_nointerpolation] = ACTIONS(2228),
    [anon_sym_sample] = ACTIONS(2228),
    [anon_sym_linear] = ACTIONS(2228),
    [anon_sym_snorm] = ACTIONS(2228),
    [anon_sym_unorm] = ACTIONS(2228),
    [anon_sym_point] = ACTIONS(2228),
    [anon_sym_line] = ACTIONS(2228),
    [anon_sym_triangleadj] = ACTIONS(2228),
    [anon_sym_lineadj] = ACTIONS(2228),
    [anon_sym_triangle] = ACTIONS(2228),
  },
  [2839] = {
    [sym_identifier] = ACTIONS(2244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(2246),
    [anon_sym_RPAREN] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_AMP] = ACTIONS(2244),
    [anon_sym_COLON] = ACTIONS(2244),
    [anon_sym___extension__] = ACTIONS(2244),
    [anon_sym_in] = ACTIONS(2244),
    [anon_sym_out] = ACTIONS(2244),
    [anon_sym_inout] = ACTIONS(2244),
    [anon_sym_extern] = ACTIONS(2244),
    [anon_sym___attribute__] = ACTIONS(2244),
    [anon_sym_COLON_COLON] = ACTIONS(2246),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2246),
    [anon_sym___declspec] = ACTIONS(2244),
    [anon_sym___based] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2244),
    [anon_sym_static] = ACTIONS(2244),
    [anon_sym_EQ] = ACTIONS(2246),
    [anon_sym_register] = ACTIONS(2244),
    [anon_sym_inline] = ACTIONS(2244),
    [anon_sym___inline] = ACTIONS(2244),
    [anon_sym___inline__] = ACTIONS(2244),
    [anon_sym___forceinline] = ACTIONS(2244),
    [anon_sym_thread_local] = ACTIONS(2244),
    [anon_sym___thread] = ACTIONS(2244),
    [anon_sym_const] = ACTIONS(2244),
    [anon_sym_constexpr] = ACTIONS(2244),
    [anon_sym_volatile] = ACTIONS(2244),
    [anon_sym_restrict] = ACTIONS(2244),
    [anon_sym___restrict__] = ACTIONS(2244),
    [anon_sym__Atomic] = ACTIONS(2244),
    [anon_sym__Noreturn] = ACTIONS(2244),
    [anon_sym_noreturn] = ACTIONS(2244),
    [anon_sym_mutable] = ACTIONS(2244),
    [anon_sym_constinit] = ACTIONS(2244),
    [anon_sym_consteval] = ACTIONS(2244),
    [anon_sym_alignas] = ACTIONS(2244),
    [anon_sym__Alignas] = ACTIONS(2244),
    [anon_sym_DOT] = ACTIONS(2244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2244),
    [anon_sym_let] = ACTIONS(2244),
    [anon_sym_This] = ACTIONS(2244),
    [anon_sym_decltype] = ACTIONS(2244),
    [anon_sym_final] = ACTIONS(2244),
    [anon_sym_override] = ACTIONS(2244),
    [sym_virtual] = ACTIONS(2244),
    [anon_sym_template] = ACTIONS(2244),
    [anon_sym_GT2] = ACTIONS(2246),
    [anon_sym_operator] = ACTIONS(2244),
    [anon_sym_precise] = ACTIONS(2244),
    [anon_sym_shared] = ACTIONS(2244),
    [anon_sym_groupshared] = ACTIONS(2244),
    [anon_sym_uniform] = ACTIONS(2244),
    [anon_sym_row_major] = ACTIONS(2244),
    [anon_sym_column_major] = ACTIONS(2244),
    [anon_sym_globallycoherent] = ACTIONS(2244),
    [anon_sym_centroid] = ACTIONS(2244),
    [anon_sym_noperspective] = ACTIONS(2244),
    [anon_sym_nointerpolation] = ACTIONS(2244),
    [anon_sym_sample] = ACTIONS(2244),
    [anon_sym_linear] = ACTIONS(2244),
    [anon_sym_snorm] = ACTIONS(2244),
    [anon_sym_unorm] = ACTIONS(2244),
    [anon_sym_point] = ACTIONS(2244),
    [anon_sym_line] = ACTIONS(2244),
    [anon_sym_triangleadj] = ACTIONS(2244),
    [anon_sym_lineadj] = ACTIONS(2244),
    [anon_sym_triangle] = ACTIONS(2244),
  },
  [2840] = {
    [sym_identifier] = ACTIONS(2206),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2208),
    [anon_sym_COMMA] = ACTIONS(2208),
    [anon_sym_RPAREN] = ACTIONS(2208),
    [anon_sym_LPAREN2] = ACTIONS(2208),
    [anon_sym_TILDE] = ACTIONS(2208),
    [anon_sym_STAR] = ACTIONS(2208),
    [anon_sym_AMP_AMP] = ACTIONS(2208),
    [anon_sym_AMP] = ACTIONS(2206),
    [anon_sym_COLON] = ACTIONS(2206),
    [anon_sym___extension__] = ACTIONS(2206),
    [anon_sym_in] = ACTIONS(2206),
    [anon_sym_out] = ACTIONS(2206),
    [anon_sym_inout] = ACTIONS(2206),
    [anon_sym_extern] = ACTIONS(2206),
    [anon_sym___attribute__] = ACTIONS(2206),
    [anon_sym_COLON_COLON] = ACTIONS(2208),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2208),
    [anon_sym___declspec] = ACTIONS(2206),
    [anon_sym___based] = ACTIONS(2206),
    [anon_sym_LBRACE] = ACTIONS(2208),
    [anon_sym_LBRACK] = ACTIONS(2206),
    [anon_sym_static] = ACTIONS(2206),
    [anon_sym_EQ] = ACTIONS(2208),
    [anon_sym_register] = ACTIONS(2206),
    [anon_sym_inline] = ACTIONS(2206),
    [anon_sym___inline] = ACTIONS(2206),
    [anon_sym___inline__] = ACTIONS(2206),
    [anon_sym___forceinline] = ACTIONS(2206),
    [anon_sym_thread_local] = ACTIONS(2206),
    [anon_sym___thread] = ACTIONS(2206),
    [anon_sym_const] = ACTIONS(2206),
    [anon_sym_constexpr] = ACTIONS(2206),
    [anon_sym_volatile] = ACTIONS(2206),
    [anon_sym_restrict] = ACTIONS(2206),
    [anon_sym___restrict__] = ACTIONS(2206),
    [anon_sym__Atomic] = ACTIONS(2206),
    [anon_sym__Noreturn] = ACTIONS(2206),
    [anon_sym_noreturn] = ACTIONS(2206),
    [anon_sym_mutable] = ACTIONS(2206),
    [anon_sym_constinit] = ACTIONS(2206),
    [anon_sym_consteval] = ACTIONS(2206),
    [anon_sym_alignas] = ACTIONS(2206),
    [anon_sym__Alignas] = ACTIONS(2206),
    [anon_sym_DOT] = ACTIONS(2206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2206),
    [anon_sym_let] = ACTIONS(2206),
    [anon_sym_This] = ACTIONS(2206),
    [anon_sym_decltype] = ACTIONS(2206),
    [anon_sym_final] = ACTIONS(2206),
    [anon_sym_override] = ACTIONS(2206),
    [sym_virtual] = ACTIONS(2206),
    [anon_sym_template] = ACTIONS(2206),
    [anon_sym_GT2] = ACTIONS(2208),
    [anon_sym_operator] = ACTIONS(2206),
    [anon_sym_precise] = ACTIONS(2206),
    [anon_sym_shared] = ACTIONS(2206),
    [anon_sym_groupshared] = ACTIONS(2206),
    [anon_sym_uniform] = ACTIONS(2206),
    [anon_sym_row_major] = ACTIONS(2206),
    [anon_sym_column_major] = ACTIONS(2206),
    [anon_sym_globallycoherent] = ACTIONS(2206),
    [anon_sym_centroid] = ACTIONS(2206),
    [anon_sym_noperspective] = ACTIONS(2206),
    [anon_sym_nointerpolation] = ACTIONS(2206),
    [anon_sym_sample] = ACTIONS(2206),
    [anon_sym_linear] = ACTIONS(2206),
    [anon_sym_snorm] = ACTIONS(2206),
    [anon_sym_unorm] = ACTIONS(2206),
    [anon_sym_point] = ACTIONS(2206),
    [anon_sym_line] = ACTIONS(2206),
    [anon_sym_triangleadj] = ACTIONS(2206),
    [anon_sym_lineadj] = ACTIONS(2206),
    [anon_sym_triangle] = ACTIONS(2206),
  },
  [2841] = {
    [sym_identifier] = ACTIONS(4545),
    [anon_sym_LPAREN2] = ACTIONS(4547),
    [anon_sym_BANG] = ACTIONS(4547),
    [anon_sym_TILDE] = ACTIONS(4547),
    [anon_sym_DASH] = ACTIONS(4545),
    [anon_sym_PLUS] = ACTIONS(4545),
    [anon_sym_STAR] = ACTIONS(4547),
    [anon_sym_AMP] = ACTIONS(4547),
    [anon_sym_SEMI] = ACTIONS(4547),
    [anon_sym_COLON_COLON] = ACTIONS(4547),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4547),
    [anon_sym_LBRACE] = ACTIONS(4547),
    [anon_sym_LBRACK] = ACTIONS(4545),
    [sym_primitive_type] = ACTIONS(4545),
    [anon_sym_if] = ACTIONS(4545),
    [anon_sym_switch] = ACTIONS(4545),
    [anon_sym_case] = ACTIONS(4545),
    [anon_sym_default] = ACTIONS(4545),
    [anon_sym_while] = ACTIONS(4545),
    [anon_sym_do] = ACTIONS(4545),
    [anon_sym_for] = ACTIONS(4545),
    [anon_sym_return] = ACTIONS(4545),
    [anon_sym_break] = ACTIONS(4545),
    [anon_sym_continue] = ACTIONS(4545),
    [anon_sym_goto] = ACTIONS(4545),
    [anon_sym___try] = ACTIONS(4545),
    [anon_sym___leave] = ACTIONS(4545),
    [anon_sym_not] = ACTIONS(4545),
    [anon_sym_compl] = ACTIONS(4545),
    [anon_sym_DASH_DASH] = ACTIONS(4547),
    [anon_sym_PLUS_PLUS] = ACTIONS(4547),
    [anon_sym_sizeof] = ACTIONS(4545),
    [anon_sym___alignof__] = ACTIONS(4545),
    [anon_sym___alignof] = ACTIONS(4545),
    [anon_sym__alignof] = ACTIONS(4545),
    [anon_sym_alignof] = ACTIONS(4545),
    [anon_sym__Alignof] = ACTIONS(4545),
    [anon_sym_offsetof] = ACTIONS(4545),
    [anon_sym__Generic] = ACTIONS(4545),
    [anon_sym_asm] = ACTIONS(4545),
    [anon_sym___asm__] = ACTIONS(4545),
    [sym_number_literal] = ACTIONS(4547),
    [anon_sym_L_SQUOTE] = ACTIONS(4547),
    [anon_sym_u_SQUOTE] = ACTIONS(4547),
    [anon_sym_U_SQUOTE] = ACTIONS(4547),
    [anon_sym_u8_SQUOTE] = ACTIONS(4547),
    [anon_sym_SQUOTE] = ACTIONS(4547),
    [anon_sym_L_DQUOTE] = ACTIONS(4547),
    [anon_sym_u_DQUOTE] = ACTIONS(4547),
    [anon_sym_U_DQUOTE] = ACTIONS(4547),
    [anon_sym_u8_DQUOTE] = ACTIONS(4547),
    [anon_sym_DQUOTE] = ACTIONS(4547),
    [sym_true] = ACTIONS(4545),
    [sym_false] = ACTIONS(4545),
    [anon_sym_NULL] = ACTIONS(4545),
    [anon_sym_nullptr] = ACTIONS(4545),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4545),
    [anon_sym_template] = ACTIONS(4545),
    [anon_sym_try] = ACTIONS(4545),
    [anon_sym_delete] = ACTIONS(4545),
    [anon_sym_throw] = ACTIONS(4545),
    [anon_sym_co_return] = ACTIONS(4545),
    [anon_sym_co_yield] = ACTIONS(4545),
    [anon_sym_R_DQUOTE] = ACTIONS(4547),
    [anon_sym_LR_DQUOTE] = ACTIONS(4547),
    [anon_sym_uR_DQUOTE] = ACTIONS(4547),
    [anon_sym_UR_DQUOTE] = ACTIONS(4547),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4547),
    [anon_sym_co_await] = ACTIONS(4545),
    [anon_sym_new] = ACTIONS(4545),
    [anon_sym_requires] = ACTIONS(4545),
    [sym_this] = ACTIONS(4545),
    [anon_sym_discard] = ACTIONS(4545),
    [anon_sym_cbuffer] = ACTIONS(4545),
  },
  [2842] = {
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2254),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_RPAREN] = ACTIONS(2254),
    [anon_sym_LPAREN2] = ACTIONS(2254),
    [anon_sym_TILDE] = ACTIONS(2254),
    [anon_sym_STAR] = ACTIONS(2254),
    [anon_sym_AMP_AMP] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym___extension__] = ACTIONS(2252),
    [anon_sym_in] = ACTIONS(2252),
    [anon_sym_out] = ACTIONS(2252),
    [anon_sym_inout] = ACTIONS(2252),
    [anon_sym_extern] = ACTIONS(2252),
    [anon_sym___attribute__] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2254),
    [anon_sym___declspec] = ACTIONS(2252),
    [anon_sym___based] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2252),
    [anon_sym_EQ] = ACTIONS(2254),
    [anon_sym_register] = ACTIONS(2252),
    [anon_sym_inline] = ACTIONS(2252),
    [anon_sym___inline] = ACTIONS(2252),
    [anon_sym___inline__] = ACTIONS(2252),
    [anon_sym___forceinline] = ACTIONS(2252),
    [anon_sym_thread_local] = ACTIONS(2252),
    [anon_sym___thread] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2252),
    [anon_sym_constexpr] = ACTIONS(2252),
    [anon_sym_volatile] = ACTIONS(2252),
    [anon_sym_restrict] = ACTIONS(2252),
    [anon_sym___restrict__] = ACTIONS(2252),
    [anon_sym__Atomic] = ACTIONS(2252),
    [anon_sym__Noreturn] = ACTIONS(2252),
    [anon_sym_noreturn] = ACTIONS(2252),
    [anon_sym_mutable] = ACTIONS(2252),
    [anon_sym_constinit] = ACTIONS(2252),
    [anon_sym_consteval] = ACTIONS(2252),
    [anon_sym_alignas] = ACTIONS(2252),
    [anon_sym__Alignas] = ACTIONS(2252),
    [anon_sym_DOT] = ACTIONS(2252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_This] = ACTIONS(2252),
    [anon_sym_decltype] = ACTIONS(2252),
    [anon_sym_final] = ACTIONS(2252),
    [anon_sym_override] = ACTIONS(2252),
    [sym_virtual] = ACTIONS(2252),
    [anon_sym_template] = ACTIONS(2252),
    [anon_sym_GT2] = ACTIONS(2254),
    [anon_sym_operator] = ACTIONS(2252),
    [anon_sym_precise] = ACTIONS(2252),
    [anon_sym_shared] = ACTIONS(2252),
    [anon_sym_groupshared] = ACTIONS(2252),
    [anon_sym_uniform] = ACTIONS(2252),
    [anon_sym_row_major] = ACTIONS(2252),
    [anon_sym_column_major] = ACTIONS(2252),
    [anon_sym_globallycoherent] = ACTIONS(2252),
    [anon_sym_centroid] = ACTIONS(2252),
    [anon_sym_noperspective] = ACTIONS(2252),
    [anon_sym_nointerpolation] = ACTIONS(2252),
    [anon_sym_sample] = ACTIONS(2252),
    [anon_sym_linear] = ACTIONS(2252),
    [anon_sym_snorm] = ACTIONS(2252),
    [anon_sym_unorm] = ACTIONS(2252),
    [anon_sym_point] = ACTIONS(2252),
    [anon_sym_line] = ACTIONS(2252),
    [anon_sym_triangleadj] = ACTIONS(2252),
    [anon_sym_lineadj] = ACTIONS(2252),
    [anon_sym_triangle] = ACTIONS(2252),
  },
  [2843] = {
    [sym_identifier] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_LPAREN2] = ACTIONS(2188),
    [anon_sym_TILDE] = ACTIONS(2188),
    [anon_sym_STAR] = ACTIONS(2188),
    [anon_sym_AMP_AMP] = ACTIONS(2188),
    [anon_sym_AMP] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym___extension__] = ACTIONS(2186),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_out] = ACTIONS(2186),
    [anon_sym_inout] = ACTIONS(2186),
    [anon_sym_extern] = ACTIONS(2186),
    [anon_sym___attribute__] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2188),
    [anon_sym___declspec] = ACTIONS(2186),
    [anon_sym___based] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_static] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2188),
    [anon_sym_register] = ACTIONS(2186),
    [anon_sym_inline] = ACTIONS(2186),
    [anon_sym___inline] = ACTIONS(2186),
    [anon_sym___inline__] = ACTIONS(2186),
    [anon_sym___forceinline] = ACTIONS(2186),
    [anon_sym_thread_local] = ACTIONS(2186),
    [anon_sym___thread] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_constexpr] = ACTIONS(2186),
    [anon_sym_volatile] = ACTIONS(2186),
    [anon_sym_restrict] = ACTIONS(2186),
    [anon_sym___restrict__] = ACTIONS(2186),
    [anon_sym__Atomic] = ACTIONS(2186),
    [anon_sym__Noreturn] = ACTIONS(2186),
    [anon_sym_noreturn] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_constinit] = ACTIONS(2186),
    [anon_sym_consteval] = ACTIONS(2186),
    [anon_sym_alignas] = ACTIONS(2186),
    [anon_sym__Alignas] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_This] = ACTIONS(2186),
    [anon_sym_decltype] = ACTIONS(2186),
    [anon_sym_final] = ACTIONS(2186),
    [anon_sym_override] = ACTIONS(2186),
    [sym_virtual] = ACTIONS(2186),
    [anon_sym_template] = ACTIONS(2186),
    [anon_sym_GT2] = ACTIONS(2188),
    [anon_sym_operator] = ACTIONS(2186),
    [anon_sym_precise] = ACTIONS(2186),
    [anon_sym_shared] = ACTIONS(2186),
    [anon_sym_groupshared] = ACTIONS(2186),
    [anon_sym_uniform] = ACTIONS(2186),
    [anon_sym_row_major] = ACTIONS(2186),
    [anon_sym_column_major] = ACTIONS(2186),
    [anon_sym_globallycoherent] = ACTIONS(2186),
    [anon_sym_centroid] = ACTIONS(2186),
    [anon_sym_noperspective] = ACTIONS(2186),
    [anon_sym_nointerpolation] = ACTIONS(2186),
    [anon_sym_sample] = ACTIONS(2186),
    [anon_sym_linear] = ACTIONS(2186),
    [anon_sym_snorm] = ACTIONS(2186),
    [anon_sym_unorm] = ACTIONS(2186),
    [anon_sym_point] = ACTIONS(2186),
    [anon_sym_line] = ACTIONS(2186),
    [anon_sym_triangleadj] = ACTIONS(2186),
    [anon_sym_lineadj] = ACTIONS(2186),
    [anon_sym_triangle] = ACTIONS(2186),
  },
  [2844] = {
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2371),
    [anon_sym_COMMA] = ACTIONS(2371),
    [anon_sym_RPAREN] = ACTIONS(2371),
    [anon_sym_LPAREN2] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_SLASH] = ACTIONS(2373),
    [anon_sym_PERCENT] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_CARET] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_EQ_EQ] = ACTIONS(2371),
    [anon_sym_BANG_EQ] = ACTIONS(2371),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_EQ] = ACTIONS(2371),
    [anon_sym_LT_EQ] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_LT_LT] = ACTIONS(2371),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_COLON] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym___extension__] = ACTIONS(2373),
    [anon_sym___attribute__] = ACTIONS(2373),
    [anon_sym___based] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_RBRACE] = ACTIONS(2371),
    [anon_sym_signed] = ACTIONS(2373),
    [anon_sym_unsigned] = ACTIONS(2373),
    [anon_sym_long] = ACTIONS(2373),
    [anon_sym_short] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_RBRACK] = ACTIONS(2371),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym___restrict__] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym__Noreturn] = ACTIONS(2373),
    [anon_sym_noreturn] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_constinit] = ACTIONS(2373),
    [anon_sym_consteval] = ACTIONS(2373),
    [anon_sym_alignas] = ACTIONS(2373),
    [anon_sym__Alignas] = ACTIONS(2373),
    [sym_primitive_type] = ACTIONS(2373),
    [anon_sym_else] = ACTIONS(2373),
    [anon_sym_while] = ACTIONS(2373),
    [anon_sym_QMARK] = ACTIONS(2371),
    [anon_sym_LT_EQ_GT] = ACTIONS(2371),
    [anon_sym_or] = ACTIONS(2373),
    [anon_sym_and] = ACTIONS(2373),
    [anon_sym_bitor] = ACTIONS(2373),
    [anon_sym_xor] = ACTIONS(2373),
    [anon_sym_bitand] = ACTIONS(2373),
    [anon_sym_not_eq] = ACTIONS(2373),
    [anon_sym_is] = ACTIONS(2373),
    [anon_sym_as] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_DOT] = ACTIONS(2373),
    [anon_sym_DOT_STAR] = ACTIONS(2371),
    [anon_sym_DASH_GT] = ACTIONS(2371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_This] = ACTIONS(2373),
    [anon_sym_final] = ACTIONS(2373),
    [anon_sym_override] = ACTIONS(2373),
    [anon_sym_requires] = ACTIONS(2373),
    [anon_sym_where] = ACTIONS(2373),
  },
  [2845] = {
    [sym_identifier] = ACTIONS(2198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_COMMA] = ACTIONS(2200),
    [anon_sym_RPAREN] = ACTIONS(2200),
    [anon_sym_LPAREN2] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(2200),
    [anon_sym_AMP_AMP] = ACTIONS(2200),
    [anon_sym_AMP] = ACTIONS(2198),
    [anon_sym_COLON] = ACTIONS(2198),
    [anon_sym___extension__] = ACTIONS(2198),
    [anon_sym_in] = ACTIONS(2198),
    [anon_sym_out] = ACTIONS(2198),
    [anon_sym_inout] = ACTIONS(2198),
    [anon_sym_extern] = ACTIONS(2198),
    [anon_sym___attribute__] = ACTIONS(2198),
    [anon_sym_COLON_COLON] = ACTIONS(2200),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2200),
    [anon_sym___declspec] = ACTIONS(2198),
    [anon_sym___based] = ACTIONS(2198),
    [anon_sym_LBRACE] = ACTIONS(2200),
    [anon_sym_LBRACK] = ACTIONS(2198),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_EQ] = ACTIONS(2200),
    [anon_sym_register] = ACTIONS(2198),
    [anon_sym_inline] = ACTIONS(2198),
    [anon_sym___inline] = ACTIONS(2198),
    [anon_sym___inline__] = ACTIONS(2198),
    [anon_sym___forceinline] = ACTIONS(2198),
    [anon_sym_thread_local] = ACTIONS(2198),
    [anon_sym___thread] = ACTIONS(2198),
    [anon_sym_const] = ACTIONS(2198),
    [anon_sym_constexpr] = ACTIONS(2198),
    [anon_sym_volatile] = ACTIONS(2198),
    [anon_sym_restrict] = ACTIONS(2198),
    [anon_sym___restrict__] = ACTIONS(2198),
    [anon_sym__Atomic] = ACTIONS(2198),
    [anon_sym__Noreturn] = ACTIONS(2198),
    [anon_sym_noreturn] = ACTIONS(2198),
    [anon_sym_mutable] = ACTIONS(2198),
    [anon_sym_constinit] = ACTIONS(2198),
    [anon_sym_consteval] = ACTIONS(2198),
    [anon_sym_alignas] = ACTIONS(2198),
    [anon_sym__Alignas] = ACTIONS(2198),
    [anon_sym_DOT] = ACTIONS(2198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2198),
    [anon_sym_let] = ACTIONS(2198),
    [anon_sym_This] = ACTIONS(2198),
    [anon_sym_decltype] = ACTIONS(2198),
    [anon_sym_final] = ACTIONS(2198),
    [anon_sym_override] = ACTIONS(2198),
    [sym_virtual] = ACTIONS(2198),
    [anon_sym_template] = ACTIONS(2198),
    [anon_sym_GT2] = ACTIONS(2200),
    [anon_sym_operator] = ACTIONS(2198),
    [anon_sym_precise] = ACTIONS(2198),
    [anon_sym_shared] = ACTIONS(2198),
    [anon_sym_groupshared] = ACTIONS(2198),
    [anon_sym_uniform] = ACTIONS(2198),
    [anon_sym_row_major] = ACTIONS(2198),
    [anon_sym_column_major] = ACTIONS(2198),
    [anon_sym_globallycoherent] = ACTIONS(2198),
    [anon_sym_centroid] = ACTIONS(2198),
    [anon_sym_noperspective] = ACTIONS(2198),
    [anon_sym_nointerpolation] = ACTIONS(2198),
    [anon_sym_sample] = ACTIONS(2198),
    [anon_sym_linear] = ACTIONS(2198),
    [anon_sym_snorm] = ACTIONS(2198),
    [anon_sym_unorm] = ACTIONS(2198),
    [anon_sym_point] = ACTIONS(2198),
    [anon_sym_line] = ACTIONS(2198),
    [anon_sym_triangleadj] = ACTIONS(2198),
    [anon_sym_lineadj] = ACTIONS(2198),
    [anon_sym_triangle] = ACTIONS(2198),
  },
  [2846] = {
    [sym_identifier] = ACTIONS(2190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2192),
    [anon_sym_COMMA] = ACTIONS(2192),
    [anon_sym_RPAREN] = ACTIONS(2192),
    [anon_sym_LPAREN2] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [anon_sym_STAR] = ACTIONS(2192),
    [anon_sym_AMP_AMP] = ACTIONS(2192),
    [anon_sym_AMP] = ACTIONS(2190),
    [anon_sym_COLON] = ACTIONS(2190),
    [anon_sym___extension__] = ACTIONS(2190),
    [anon_sym_in] = ACTIONS(2190),
    [anon_sym_out] = ACTIONS(2190),
    [anon_sym_inout] = ACTIONS(2190),
    [anon_sym_extern] = ACTIONS(2190),
    [anon_sym___attribute__] = ACTIONS(2190),
    [anon_sym_COLON_COLON] = ACTIONS(2192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2192),
    [anon_sym___declspec] = ACTIONS(2190),
    [anon_sym___based] = ACTIONS(2190),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [anon_sym_LBRACK] = ACTIONS(2190),
    [anon_sym_static] = ACTIONS(2190),
    [anon_sym_EQ] = ACTIONS(2192),
    [anon_sym_register] = ACTIONS(2190),
    [anon_sym_inline] = ACTIONS(2190),
    [anon_sym___inline] = ACTIONS(2190),
    [anon_sym___inline__] = ACTIONS(2190),
    [anon_sym___forceinline] = ACTIONS(2190),
    [anon_sym_thread_local] = ACTIONS(2190),
    [anon_sym___thread] = ACTIONS(2190),
    [anon_sym_const] = ACTIONS(2190),
    [anon_sym_constexpr] = ACTIONS(2190),
    [anon_sym_volatile] = ACTIONS(2190),
    [anon_sym_restrict] = ACTIONS(2190),
    [anon_sym___restrict__] = ACTIONS(2190),
    [anon_sym__Atomic] = ACTIONS(2190),
    [anon_sym__Noreturn] = ACTIONS(2190),
    [anon_sym_noreturn] = ACTIONS(2190),
    [anon_sym_mutable] = ACTIONS(2190),
    [anon_sym_constinit] = ACTIONS(2190),
    [anon_sym_consteval] = ACTIONS(2190),
    [anon_sym_alignas] = ACTIONS(2190),
    [anon_sym__Alignas] = ACTIONS(2190),
    [anon_sym_DOT] = ACTIONS(2190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2190),
    [anon_sym_let] = ACTIONS(2190),
    [anon_sym_This] = ACTIONS(2190),
    [anon_sym_decltype] = ACTIONS(2190),
    [anon_sym_final] = ACTIONS(2190),
    [anon_sym_override] = ACTIONS(2190),
    [sym_virtual] = ACTIONS(2190),
    [anon_sym_template] = ACTIONS(2190),
    [anon_sym_GT2] = ACTIONS(2192),
    [anon_sym_operator] = ACTIONS(2190),
    [anon_sym_precise] = ACTIONS(2190),
    [anon_sym_shared] = ACTIONS(2190),
    [anon_sym_groupshared] = ACTIONS(2190),
    [anon_sym_uniform] = ACTIONS(2190),
    [anon_sym_row_major] = ACTIONS(2190),
    [anon_sym_column_major] = ACTIONS(2190),
    [anon_sym_globallycoherent] = ACTIONS(2190),
    [anon_sym_centroid] = ACTIONS(2190),
    [anon_sym_noperspective] = ACTIONS(2190),
    [anon_sym_nointerpolation] = ACTIONS(2190),
    [anon_sym_sample] = ACTIONS(2190),
    [anon_sym_linear] = ACTIONS(2190),
    [anon_sym_snorm] = ACTIONS(2190),
    [anon_sym_unorm] = ACTIONS(2190),
    [anon_sym_point] = ACTIONS(2190),
    [anon_sym_line] = ACTIONS(2190),
    [anon_sym_triangleadj] = ACTIONS(2190),
    [anon_sym_lineadj] = ACTIONS(2190),
    [anon_sym_triangle] = ACTIONS(2190),
  },
  [2847] = {
    [sym_identifier] = ACTIONS(2194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2196),
    [anon_sym_COMMA] = ACTIONS(2196),
    [anon_sym_RPAREN] = ACTIONS(2196),
    [anon_sym_LPAREN2] = ACTIONS(2196),
    [anon_sym_TILDE] = ACTIONS(2196),
    [anon_sym_STAR] = ACTIONS(2196),
    [anon_sym_AMP_AMP] = ACTIONS(2196),
    [anon_sym_AMP] = ACTIONS(2194),
    [anon_sym_COLON] = ACTIONS(2194),
    [anon_sym___extension__] = ACTIONS(2194),
    [anon_sym_in] = ACTIONS(2194),
    [anon_sym_out] = ACTIONS(2194),
    [anon_sym_inout] = ACTIONS(2194),
    [anon_sym_extern] = ACTIONS(2194),
    [anon_sym___attribute__] = ACTIONS(2194),
    [anon_sym_COLON_COLON] = ACTIONS(2196),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2196),
    [anon_sym___declspec] = ACTIONS(2194),
    [anon_sym___based] = ACTIONS(2194),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_LBRACK] = ACTIONS(2194),
    [anon_sym_static] = ACTIONS(2194),
    [anon_sym_EQ] = ACTIONS(2196),
    [anon_sym_register] = ACTIONS(2194),
    [anon_sym_inline] = ACTIONS(2194),
    [anon_sym___inline] = ACTIONS(2194),
    [anon_sym___inline__] = ACTIONS(2194),
    [anon_sym___forceinline] = ACTIONS(2194),
    [anon_sym_thread_local] = ACTIONS(2194),
    [anon_sym___thread] = ACTIONS(2194),
    [anon_sym_const] = ACTIONS(2194),
    [anon_sym_constexpr] = ACTIONS(2194),
    [anon_sym_volatile] = ACTIONS(2194),
    [anon_sym_restrict] = ACTIONS(2194),
    [anon_sym___restrict__] = ACTIONS(2194),
    [anon_sym__Atomic] = ACTIONS(2194),
    [anon_sym__Noreturn] = ACTIONS(2194),
    [anon_sym_noreturn] = ACTIONS(2194),
    [anon_sym_mutable] = ACTIONS(2194),
    [anon_sym_constinit] = ACTIONS(2194),
    [anon_sym_consteval] = ACTIONS(2194),
    [anon_sym_alignas] = ACTIONS(2194),
    [anon_sym__Alignas] = ACTIONS(2194),
    [anon_sym_DOT] = ACTIONS(2194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2194),
    [anon_sym_let] = ACTIONS(2194),
    [anon_sym_This] = ACTIONS(2194),
    [anon_sym_decltype] = ACTIONS(2194),
    [anon_sym_final] = ACTIONS(2194),
    [anon_sym_override] = ACTIONS(2194),
    [sym_virtual] = ACTIONS(2194),
    [anon_sym_template] = ACTIONS(2194),
    [anon_sym_GT2] = ACTIONS(2196),
    [anon_sym_operator] = ACTIONS(2194),
    [anon_sym_precise] = ACTIONS(2194),
    [anon_sym_shared] = ACTIONS(2194),
    [anon_sym_groupshared] = ACTIONS(2194),
    [anon_sym_uniform] = ACTIONS(2194),
    [anon_sym_row_major] = ACTIONS(2194),
    [anon_sym_column_major] = ACTIONS(2194),
    [anon_sym_globallycoherent] = ACTIONS(2194),
    [anon_sym_centroid] = ACTIONS(2194),
    [anon_sym_noperspective] = ACTIONS(2194),
    [anon_sym_nointerpolation] = ACTIONS(2194),
    [anon_sym_sample] = ACTIONS(2194),
    [anon_sym_linear] = ACTIONS(2194),
    [anon_sym_snorm] = ACTIONS(2194),
    [anon_sym_unorm] = ACTIONS(2194),
    [anon_sym_point] = ACTIONS(2194),
    [anon_sym_line] = ACTIONS(2194),
    [anon_sym_triangleadj] = ACTIONS(2194),
    [anon_sym_lineadj] = ACTIONS(2194),
    [anon_sym_triangle] = ACTIONS(2194),
  },
  [2848] = {
    [sym_template_argument_list] = STATE(2899),
    [sym_identifier] = ACTIONS(2169),
    [anon_sym_LPAREN2] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_STAR] = ACTIONS(2176),
    [anon_sym_AMP_AMP] = ACTIONS(2176),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(6343),
    [anon_sym_SEMI] = ACTIONS(2176),
    [anon_sym___extension__] = ACTIONS(2169),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_out] = ACTIONS(2169),
    [anon_sym_inout] = ACTIONS(2169),
    [anon_sym_extern] = ACTIONS(2169),
    [anon_sym___attribute__] = ACTIONS(2169),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2173),
    [anon_sym___declspec] = ACTIONS(2169),
    [anon_sym___based] = ACTIONS(2169),
    [anon_sym___cdecl] = ACTIONS(2169),
    [anon_sym___clrcall] = ACTIONS(2169),
    [anon_sym___stdcall] = ACTIONS(2169),
    [anon_sym___fastcall] = ACTIONS(2169),
    [anon_sym___thiscall] = ACTIONS(2169),
    [anon_sym___vectorcall] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2169),
    [anon_sym_register] = ACTIONS(2169),
    [anon_sym_inline] = ACTIONS(2169),
    [anon_sym___inline] = ACTIONS(2169),
    [anon_sym___inline__] = ACTIONS(2169),
    [anon_sym___forceinline] = ACTIONS(2169),
    [anon_sym_thread_local] = ACTIONS(2169),
    [anon_sym___thread] = ACTIONS(2169),
    [anon_sym_const] = ACTIONS(2169),
    [anon_sym_constexpr] = ACTIONS(2169),
    [anon_sym_volatile] = ACTIONS(2169),
    [anon_sym_restrict] = ACTIONS(2169),
    [anon_sym___restrict__] = ACTIONS(2169),
    [anon_sym__Atomic] = ACTIONS(2169),
    [anon_sym__Noreturn] = ACTIONS(2169),
    [anon_sym_noreturn] = ACTIONS(2169),
    [anon_sym_mutable] = ACTIONS(2169),
    [anon_sym_constinit] = ACTIONS(2169),
    [anon_sym_consteval] = ACTIONS(2169),
    [anon_sym_alignas] = ACTIONS(2169),
    [anon_sym__Alignas] = ACTIONS(2169),
    [anon_sym_DOT] = ACTIONS(2176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2169),
    [anon_sym_let] = ACTIONS(2169),
    [anon_sym_This] = ACTIONS(2169),
    [anon_sym_decltype] = ACTIONS(2169),
    [sym_virtual] = ACTIONS(2169),
    [anon_sym_template] = ACTIONS(2169),
    [anon_sym_operator] = ACTIONS(2169),
    [anon_sym_precise] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_groupshared] = ACTIONS(2169),
    [anon_sym_uniform] = ACTIONS(2169),
    [anon_sym_row_major] = ACTIONS(2169),
    [anon_sym_column_major] = ACTIONS(2169),
    [anon_sym_globallycoherent] = ACTIONS(2169),
    [anon_sym_centroid] = ACTIONS(2169),
    [anon_sym_noperspective] = ACTIONS(2169),
    [anon_sym_nointerpolation] = ACTIONS(2169),
    [anon_sym_sample] = ACTIONS(2169),
    [anon_sym_linear] = ACTIONS(2169),
    [anon_sym_snorm] = ACTIONS(2169),
    [anon_sym_unorm] = ACTIONS(2169),
    [anon_sym_point] = ACTIONS(2169),
    [anon_sym_line] = ACTIONS(2169),
    [anon_sym_triangleadj] = ACTIONS(2169),
    [anon_sym_lineadj] = ACTIONS(2169),
    [anon_sym_triangle] = ACTIONS(2169),
  },
  [2849] = {
    [sym_template_argument_list] = STATE(2836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2171),
    [anon_sym_COMMA] = ACTIONS(2171),
    [anon_sym_RPAREN] = ACTIONS(2173),
    [anon_sym_LPAREN2] = ACTIONS(2173),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2171),
    [anon_sym_AMP_AMP] = ACTIONS(2173),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2171),
    [anon_sym_BANG_EQ] = ACTIONS(2171),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2171),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(5037),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym___extension__] = ACTIONS(2176),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(2176),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_EQ] = ACTIONS(2181),
    [anon_sym_const] = ACTIONS(2169),
    [anon_sym_constexpr] = ACTIONS(2176),
    [anon_sym_volatile] = ACTIONS(2176),
    [anon_sym_restrict] = ACTIONS(2176),
    [anon_sym___restrict__] = ACTIONS(2176),
    [anon_sym__Atomic] = ACTIONS(2176),
    [anon_sym__Noreturn] = ACTIONS(2176),
    [anon_sym_noreturn] = ACTIONS(2176),
    [anon_sym_mutable] = ACTIONS(2176),
    [anon_sym_constinit] = ACTIONS(2176),
    [anon_sym_consteval] = ACTIONS(2176),
    [anon_sym_alignas] = ACTIONS(2176),
    [anon_sym__Alignas] = ACTIONS(2176),
    [anon_sym_QMARK] = ACTIONS(2171),
    [anon_sym_STAR_EQ] = ACTIONS(2171),
    [anon_sym_SLASH_EQ] = ACTIONS(2171),
    [anon_sym_PERCENT_EQ] = ACTIONS(2171),
    [anon_sym_PLUS_EQ] = ACTIONS(2171),
    [anon_sym_DASH_EQ] = ACTIONS(2171),
    [anon_sym_LT_LT_EQ] = ACTIONS(2171),
    [anon_sym_GT_GT_EQ] = ACTIONS(2171),
    [anon_sym_AMP_EQ] = ACTIONS(2171),
    [anon_sym_CARET_EQ] = ACTIONS(2171),
    [anon_sym_PIPE_EQ] = ACTIONS(2171),
    [anon_sym_and_eq] = ACTIONS(2171),
    [anon_sym_or_eq] = ACTIONS(2171),
    [anon_sym_xor_eq] = ACTIONS(2171),
    [anon_sym_LT_EQ_GT] = ACTIONS(2171),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2171),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2171),
    [anon_sym_not_eq] = ACTIONS(2171),
    [anon_sym_is] = ACTIONS(2171),
    [anon_sym_as] = ACTIONS(2171),
    [anon_sym_DASH_DASH] = ACTIONS(2171),
    [anon_sym_PLUS_PLUS] = ACTIONS(2171),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DOT_STAR] = ACTIONS(2171),
    [anon_sym_DASH_GT] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2176),
    [anon_sym_let] = ACTIONS(2176),
    [anon_sym_This] = ACTIONS(2176),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2171),
  },
  [2850] = {
    [sym_identifier] = ACTIONS(2256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2258),
    [anon_sym_COMMA] = ACTIONS(2258),
    [anon_sym_RPAREN] = ACTIONS(2258),
    [anon_sym_LPAREN2] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [anon_sym_STAR] = ACTIONS(2258),
    [anon_sym_AMP_AMP] = ACTIONS(2258),
    [anon_sym_AMP] = ACTIONS(2256),
    [anon_sym_COLON] = ACTIONS(2256),
    [anon_sym___extension__] = ACTIONS(2256),
    [anon_sym_in] = ACTIONS(2256),
    [anon_sym_out] = ACTIONS(2256),
    [anon_sym_inout] = ACTIONS(2256),
    [anon_sym_extern] = ACTIONS(2256),
    [anon_sym___attribute__] = ACTIONS(2256),
    [anon_sym_COLON_COLON] = ACTIONS(2258),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2258),
    [anon_sym___declspec] = ACTIONS(2256),
    [anon_sym___based] = ACTIONS(2256),
    [anon_sym_LBRACE] = ACTIONS(2258),
    [anon_sym_LBRACK] = ACTIONS(2256),
    [anon_sym_static] = ACTIONS(2256),
    [anon_sym_EQ] = ACTIONS(2258),
    [anon_sym_register] = ACTIONS(2256),
    [anon_sym_inline] = ACTIONS(2256),
    [anon_sym___inline] = ACTIONS(2256),
    [anon_sym___inline__] = ACTIONS(2256),
    [anon_sym___forceinline] = ACTIONS(2256),
    [anon_sym_thread_local] = ACTIONS(2256),
    [anon_sym___thread] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_constexpr] = ACTIONS(2256),
    [anon_sym_volatile] = ACTIONS(2256),
    [anon_sym_restrict] = ACTIONS(2256),
    [anon_sym___restrict__] = ACTIONS(2256),
    [anon_sym__Atomic] = ACTIONS(2256),
    [anon_sym__Noreturn] = ACTIONS(2256),
    [anon_sym_noreturn] = ACTIONS(2256),
    [anon_sym_mutable] = ACTIONS(2256),
    [anon_sym_constinit] = ACTIONS(2256),
    [anon_sym_consteval] = ACTIONS(2256),
    [anon_sym_alignas] = ACTIONS(2256),
    [anon_sym__Alignas] = ACTIONS(2256),
    [anon_sym_DOT] = ACTIONS(2256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_This] = ACTIONS(2256),
    [anon_sym_decltype] = ACTIONS(2256),
    [anon_sym_final] = ACTIONS(2256),
    [anon_sym_override] = ACTIONS(2256),
    [sym_virtual] = ACTIONS(2256),
    [anon_sym_template] = ACTIONS(2256),
    [anon_sym_GT2] = ACTIONS(2258),
    [anon_sym_operator] = ACTIONS(2256),
    [anon_sym_precise] = ACTIONS(2256),
    [anon_sym_shared] = ACTIONS(2256),
    [anon_sym_groupshared] = ACTIONS(2256),
    [anon_sym_uniform] = ACTIONS(2256),
    [anon_sym_row_major] = ACTIONS(2256),
    [anon_sym_column_major] = ACTIONS(2256),
    [anon_sym_globallycoherent] = ACTIONS(2256),
    [anon_sym_centroid] = ACTIONS(2256),
    [anon_sym_noperspective] = ACTIONS(2256),
    [anon_sym_nointerpolation] = ACTIONS(2256),
    [anon_sym_sample] = ACTIONS(2256),
    [anon_sym_linear] = ACTIONS(2256),
    [anon_sym_snorm] = ACTIONS(2256),
    [anon_sym_unorm] = ACTIONS(2256),
    [anon_sym_point] = ACTIONS(2256),
    [anon_sym_line] = ACTIONS(2256),
    [anon_sym_triangleadj] = ACTIONS(2256),
    [anon_sym_lineadj] = ACTIONS(2256),
    [anon_sym_triangle] = ACTIONS(2256),
  },
  [2851] = {
    [sym_identifier] = ACTIONS(6232),
    [anon_sym___extension__] = ACTIONS(6232),
    [anon_sym_in] = ACTIONS(6232),
    [anon_sym_out] = ACTIONS(6232),
    [anon_sym_inout] = ACTIONS(6232),
    [anon_sym_extern] = ACTIONS(6232),
    [anon_sym___attribute__] = ACTIONS(6232),
    [anon_sym_COLON_COLON] = ACTIONS(6238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6238),
    [anon_sym___declspec] = ACTIONS(6232),
    [anon_sym___cdecl] = ACTIONS(6232),
    [anon_sym___clrcall] = ACTIONS(6232),
    [anon_sym___stdcall] = ACTIONS(6232),
    [anon_sym___fastcall] = ACTIONS(6232),
    [anon_sym___thiscall] = ACTIONS(6232),
    [anon_sym___vectorcall] = ACTIONS(6232),
    [anon_sym_signed] = ACTIONS(6232),
    [anon_sym_unsigned] = ACTIONS(6232),
    [anon_sym_long] = ACTIONS(6232),
    [anon_sym_short] = ACTIONS(6232),
    [anon_sym_static] = ACTIONS(6232),
    [anon_sym_register] = ACTIONS(6232),
    [anon_sym_inline] = ACTIONS(6232),
    [anon_sym___inline] = ACTIONS(6232),
    [anon_sym___inline__] = ACTIONS(6232),
    [anon_sym___forceinline] = ACTIONS(6232),
    [anon_sym_thread_local] = ACTIONS(6232),
    [anon_sym___thread] = ACTIONS(6232),
    [anon_sym_const] = ACTIONS(6232),
    [anon_sym_constexpr] = ACTIONS(6232),
    [anon_sym_volatile] = ACTIONS(6232),
    [anon_sym_restrict] = ACTIONS(6232),
    [anon_sym___restrict__] = ACTIONS(6232),
    [anon_sym__Atomic] = ACTIONS(6232),
    [anon_sym__Noreturn] = ACTIONS(6232),
    [anon_sym_noreturn] = ACTIONS(6232),
    [anon_sym_mutable] = ACTIONS(6232),
    [anon_sym_constinit] = ACTIONS(6232),
    [anon_sym_consteval] = ACTIONS(6232),
    [anon_sym_alignas] = ACTIONS(6232),
    [anon_sym__Alignas] = ACTIONS(6232),
    [sym_primitive_type] = ACTIONS(6232),
    [anon_sym_enum] = ACTIONS(6232),
    [anon_sym_class] = ACTIONS(6232),
    [anon_sym_struct] = ACTIONS(6232),
    [anon_sym_union] = ACTIONS(6232),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6232),
    [anon_sym_let] = ACTIONS(6232),
    [anon_sym_This] = ACTIONS(6232),
    [anon_sym_decltype] = ACTIONS(6232),
    [sym_virtual] = ACTIONS(6232),
    [anon_sym_typename] = ACTIONS(6232),
    [anon_sym_template] = ACTIONS(6232),
    [anon_sym_precise] = ACTIONS(6232),
    [anon_sym_shared] = ACTIONS(6232),
    [anon_sym_groupshared] = ACTIONS(6232),
    [anon_sym_uniform] = ACTIONS(6232),
    [anon_sym_row_major] = ACTIONS(6232),
    [anon_sym_column_major] = ACTIONS(6232),
    [anon_sym_globallycoherent] = ACTIONS(6232),
    [anon_sym_centroid] = ACTIONS(6232),
    [anon_sym_noperspective] = ACTIONS(6232),
    [anon_sym_nointerpolation] = ACTIONS(6232),
    [anon_sym_sample] = ACTIONS(6232),
    [anon_sym_linear] = ACTIONS(6232),
    [anon_sym_snorm] = ACTIONS(6232),
    [anon_sym_unorm] = ACTIONS(6232),
    [anon_sym_point] = ACTIONS(6232),
    [anon_sym_line] = ACTIONS(6232),
    [anon_sym_triangleadj] = ACTIONS(6232),
    [anon_sym_lineadj] = ACTIONS(6232),
    [anon_sym_triangle] = ACTIONS(6232),
    [anon_sym_interface] = ACTIONS(6232),
    [anon_sym_extension] = ACTIONS(6232),
  },
  [2852] = {
    [sym_identifier] = ACTIONS(4573),
    [anon_sym_LPAREN2] = ACTIONS(4575),
    [anon_sym_BANG] = ACTIONS(4575),
    [anon_sym_TILDE] = ACTIONS(4575),
    [anon_sym_DASH] = ACTIONS(4573),
    [anon_sym_PLUS] = ACTIONS(4573),
    [anon_sym_STAR] = ACTIONS(4575),
    [anon_sym_AMP] = ACTIONS(4575),
    [anon_sym_SEMI] = ACTIONS(4575),
    [anon_sym_COLON_COLON] = ACTIONS(4575),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4575),
    [anon_sym_LBRACE] = ACTIONS(4575),
    [anon_sym_LBRACK] = ACTIONS(4573),
    [sym_primitive_type] = ACTIONS(4573),
    [anon_sym_if] = ACTIONS(4573),
    [anon_sym_switch] = ACTIONS(4573),
    [anon_sym_case] = ACTIONS(4573),
    [anon_sym_default] = ACTIONS(4573),
    [anon_sym_while] = ACTIONS(4573),
    [anon_sym_do] = ACTIONS(4573),
    [anon_sym_for] = ACTIONS(4573),
    [anon_sym_return] = ACTIONS(4573),
    [anon_sym_break] = ACTIONS(4573),
    [anon_sym_continue] = ACTIONS(4573),
    [anon_sym_goto] = ACTIONS(4573),
    [anon_sym___try] = ACTIONS(4573),
    [anon_sym___leave] = ACTIONS(4573),
    [anon_sym_not] = ACTIONS(4573),
    [anon_sym_compl] = ACTIONS(4573),
    [anon_sym_DASH_DASH] = ACTIONS(4575),
    [anon_sym_PLUS_PLUS] = ACTIONS(4575),
    [anon_sym_sizeof] = ACTIONS(4573),
    [anon_sym___alignof__] = ACTIONS(4573),
    [anon_sym___alignof] = ACTIONS(4573),
    [anon_sym__alignof] = ACTIONS(4573),
    [anon_sym_alignof] = ACTIONS(4573),
    [anon_sym__Alignof] = ACTIONS(4573),
    [anon_sym_offsetof] = ACTIONS(4573),
    [anon_sym__Generic] = ACTIONS(4573),
    [anon_sym_asm] = ACTIONS(4573),
    [anon_sym___asm__] = ACTIONS(4573),
    [sym_number_literal] = ACTIONS(4575),
    [anon_sym_L_SQUOTE] = ACTIONS(4575),
    [anon_sym_u_SQUOTE] = ACTIONS(4575),
    [anon_sym_U_SQUOTE] = ACTIONS(4575),
    [anon_sym_u8_SQUOTE] = ACTIONS(4575),
    [anon_sym_SQUOTE] = ACTIONS(4575),
    [anon_sym_L_DQUOTE] = ACTIONS(4575),
    [anon_sym_u_DQUOTE] = ACTIONS(4575),
    [anon_sym_U_DQUOTE] = ACTIONS(4575),
    [anon_sym_u8_DQUOTE] = ACTIONS(4575),
    [anon_sym_DQUOTE] = ACTIONS(4575),
    [sym_true] = ACTIONS(4573),
    [sym_false] = ACTIONS(4573),
    [anon_sym_NULL] = ACTIONS(4573),
    [anon_sym_nullptr] = ACTIONS(4573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4573),
    [anon_sym_template] = ACTIONS(4573),
    [anon_sym_try] = ACTIONS(4573),
    [anon_sym_delete] = ACTIONS(4573),
    [anon_sym_throw] = ACTIONS(4573),
    [anon_sym_co_return] = ACTIONS(4573),
    [anon_sym_co_yield] = ACTIONS(4573),
    [anon_sym_R_DQUOTE] = ACTIONS(4575),
    [anon_sym_LR_DQUOTE] = ACTIONS(4575),
    [anon_sym_uR_DQUOTE] = ACTIONS(4575),
    [anon_sym_UR_DQUOTE] = ACTIONS(4575),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4575),
    [anon_sym_co_await] = ACTIONS(4573),
    [anon_sym_new] = ACTIONS(4573),
    [anon_sym_requires] = ACTIONS(4573),
    [sym_this] = ACTIONS(4573),
    [anon_sym_discard] = ACTIONS(4573),
    [anon_sym_cbuffer] = ACTIONS(4573),
  },
  [2853] = {
    [sym_identifier] = ACTIONS(2240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2242),
    [anon_sym_RPAREN] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_TILDE] = ACTIONS(2242),
    [anon_sym_STAR] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_AMP] = ACTIONS(2240),
    [anon_sym_COLON] = ACTIONS(2240),
    [anon_sym___extension__] = ACTIONS(2240),
    [anon_sym_in] = ACTIONS(2240),
    [anon_sym_out] = ACTIONS(2240),
    [anon_sym_inout] = ACTIONS(2240),
    [anon_sym_extern] = ACTIONS(2240),
    [anon_sym___attribute__] = ACTIONS(2240),
    [anon_sym_COLON_COLON] = ACTIONS(2242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2242),
    [anon_sym___declspec] = ACTIONS(2240),
    [anon_sym___based] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2240),
    [anon_sym_static] = ACTIONS(2240),
    [anon_sym_EQ] = ACTIONS(2242),
    [anon_sym_register] = ACTIONS(2240),
    [anon_sym_inline] = ACTIONS(2240),
    [anon_sym___inline] = ACTIONS(2240),
    [anon_sym___inline__] = ACTIONS(2240),
    [anon_sym___forceinline] = ACTIONS(2240),
    [anon_sym_thread_local] = ACTIONS(2240),
    [anon_sym___thread] = ACTIONS(2240),
    [anon_sym_const] = ACTIONS(2240),
    [anon_sym_constexpr] = ACTIONS(2240),
    [anon_sym_volatile] = ACTIONS(2240),
    [anon_sym_restrict] = ACTIONS(2240),
    [anon_sym___restrict__] = ACTIONS(2240),
    [anon_sym__Atomic] = ACTIONS(2240),
    [anon_sym__Noreturn] = ACTIONS(2240),
    [anon_sym_noreturn] = ACTIONS(2240),
    [anon_sym_mutable] = ACTIONS(2240),
    [anon_sym_constinit] = ACTIONS(2240),
    [anon_sym_consteval] = ACTIONS(2240),
    [anon_sym_alignas] = ACTIONS(2240),
    [anon_sym__Alignas] = ACTIONS(2240),
    [anon_sym_DOT] = ACTIONS(2240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2240),
    [anon_sym_let] = ACTIONS(2240),
    [anon_sym_This] = ACTIONS(2240),
    [anon_sym_decltype] = ACTIONS(2240),
    [anon_sym_final] = ACTIONS(2240),
    [anon_sym_override] = ACTIONS(2240),
    [sym_virtual] = ACTIONS(2240),
    [anon_sym_template] = ACTIONS(2240),
    [anon_sym_GT2] = ACTIONS(2242),
    [anon_sym_operator] = ACTIONS(2240),
    [anon_sym_precise] = ACTIONS(2240),
    [anon_sym_shared] = ACTIONS(2240),
    [anon_sym_groupshared] = ACTIONS(2240),
    [anon_sym_uniform] = ACTIONS(2240),
    [anon_sym_row_major] = ACTIONS(2240),
    [anon_sym_column_major] = ACTIONS(2240),
    [anon_sym_globallycoherent] = ACTIONS(2240),
    [anon_sym_centroid] = ACTIONS(2240),
    [anon_sym_noperspective] = ACTIONS(2240),
    [anon_sym_nointerpolation] = ACTIONS(2240),
    [anon_sym_sample] = ACTIONS(2240),
    [anon_sym_linear] = ACTIONS(2240),
    [anon_sym_snorm] = ACTIONS(2240),
    [anon_sym_unorm] = ACTIONS(2240),
    [anon_sym_point] = ACTIONS(2240),
    [anon_sym_line] = ACTIONS(2240),
    [anon_sym_triangleadj] = ACTIONS(2240),
    [anon_sym_lineadj] = ACTIONS(2240),
    [anon_sym_triangle] = ACTIONS(2240),
  },
  [2854] = {
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2230),
    [anon_sym_COMMA] = ACTIONS(2230),
    [anon_sym_RPAREN] = ACTIONS(2230),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2228),
    [anon_sym_PLUS] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(2230),
    [anon_sym_SLASH] = ACTIONS(2228),
    [anon_sym_PERCENT] = ACTIONS(2230),
    [anon_sym_PIPE_PIPE] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_PIPE] = ACTIONS(2228),
    [anon_sym_CARET] = ACTIONS(2230),
    [anon_sym_AMP] = ACTIONS(2228),
    [anon_sym_EQ_EQ] = ACTIONS(2230),
    [anon_sym_BANG_EQ] = ACTIONS(2230),
    [anon_sym_GT] = ACTIONS(2228),
    [anon_sym_GT_EQ] = ACTIONS(2230),
    [anon_sym_LT_EQ] = ACTIONS(2228),
    [anon_sym_LT] = ACTIONS(2228),
    [anon_sym_LT_LT] = ACTIONS(2230),
    [anon_sym_GT_GT] = ACTIONS(2230),
    [anon_sym_COLON] = ACTIONS(2228),
    [anon_sym_SEMI] = ACTIONS(2230),
    [anon_sym___extension__] = ACTIONS(2228),
    [anon_sym___attribute__] = ACTIONS(2228),
    [anon_sym_COLON_COLON] = ACTIONS(2230),
    [anon_sym___based] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_RBRACE] = ACTIONS(2230),
    [anon_sym_signed] = ACTIONS(2228),
    [anon_sym_unsigned] = ACTIONS(2228),
    [anon_sym_long] = ACTIONS(2228),
    [anon_sym_short] = ACTIONS(2228),
    [anon_sym_LBRACK] = ACTIONS(2230),
    [anon_sym_RBRACK] = ACTIONS(2230),
    [anon_sym_const] = ACTIONS(2228),
    [anon_sym_constexpr] = ACTIONS(2228),
    [anon_sym_volatile] = ACTIONS(2228),
    [anon_sym_restrict] = ACTIONS(2228),
    [anon_sym___restrict__] = ACTIONS(2228),
    [anon_sym__Atomic] = ACTIONS(2228),
    [anon_sym__Noreturn] = ACTIONS(2228),
    [anon_sym_noreturn] = ACTIONS(2228),
    [anon_sym_mutable] = ACTIONS(2228),
    [anon_sym_constinit] = ACTIONS(2228),
    [anon_sym_consteval] = ACTIONS(2228),
    [anon_sym_alignas] = ACTIONS(2228),
    [anon_sym__Alignas] = ACTIONS(2228),
    [sym_primitive_type] = ACTIONS(2228),
    [anon_sym_QMARK] = ACTIONS(2230),
    [anon_sym_LT_EQ_GT] = ACTIONS(2230),
    [anon_sym_or] = ACTIONS(2228),
    [anon_sym_and] = ACTIONS(2228),
    [anon_sym_bitor] = ACTIONS(2228),
    [anon_sym_xor] = ACTIONS(2228),
    [anon_sym_bitand] = ACTIONS(2228),
    [anon_sym_not_eq] = ACTIONS(2228),
    [anon_sym_is] = ACTIONS(2228),
    [anon_sym_as] = ACTIONS(2228),
    [anon_sym_DASH_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_PLUS] = ACTIONS(2230),
    [anon_sym_DOT] = ACTIONS(2228),
    [anon_sym_DOT_STAR] = ACTIONS(2230),
    [anon_sym_DASH_GT] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(2228),
    [anon_sym_This] = ACTIONS(2228),
    [anon_sym_final] = ACTIONS(2228),
    [anon_sym_override] = ACTIONS(2228),
    [anon_sym_requires] = ACTIONS(2228),
    [anon_sym_where] = ACTIONS(2228),
  },
  [2855] = {
    [sym_identifier] = ACTIONS(2367),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(2365),
    [anon_sym_RPAREN] = ACTIONS(2365),
    [anon_sym_LPAREN2] = ACTIONS(2365),
    [anon_sym_DASH] = ACTIONS(2367),
    [anon_sym_PLUS] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2365),
    [anon_sym_SLASH] = ACTIONS(2367),
    [anon_sym_PERCENT] = ACTIONS(2365),
    [anon_sym_PIPE_PIPE] = ACTIONS(2365),
    [anon_sym_AMP_AMP] = ACTIONS(2365),
    [anon_sym_PIPE] = ACTIONS(2367),
    [anon_sym_CARET] = ACTIONS(2365),
    [anon_sym_AMP] = ACTIONS(2367),
    [anon_sym_EQ_EQ] = ACTIONS(2365),
    [anon_sym_BANG_EQ] = ACTIONS(2365),
    [anon_sym_GT] = ACTIONS(2367),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [anon_sym_LT_EQ] = ACTIONS(2367),
    [anon_sym_LT] = ACTIONS(2367),
    [anon_sym_LT_LT] = ACTIONS(2365),
    [anon_sym_GT_GT] = ACTIONS(2365),
    [anon_sym_COLON] = ACTIONS(2367),
    [anon_sym_SEMI] = ACTIONS(2365),
    [anon_sym___extension__] = ACTIONS(2367),
    [anon_sym___attribute__] = ACTIONS(2367),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym___based] = ACTIONS(2367),
    [anon_sym_LBRACE] = ACTIONS(2365),
    [anon_sym_RBRACE] = ACTIONS(2365),
    [anon_sym_signed] = ACTIONS(2367),
    [anon_sym_unsigned] = ACTIONS(2367),
    [anon_sym_long] = ACTIONS(2367),
    [anon_sym_short] = ACTIONS(2367),
    [anon_sym_LBRACK] = ACTIONS(2365),
    [anon_sym_RBRACK] = ACTIONS(2365),
    [anon_sym_const] = ACTIONS(2367),
    [anon_sym_constexpr] = ACTIONS(2367),
    [anon_sym_volatile] = ACTIONS(2367),
    [anon_sym_restrict] = ACTIONS(2367),
    [anon_sym___restrict__] = ACTIONS(2367),
    [anon_sym__Atomic] = ACTIONS(2367),
    [anon_sym__Noreturn] = ACTIONS(2367),
    [anon_sym_noreturn] = ACTIONS(2367),
    [anon_sym_mutable] = ACTIONS(2367),
    [anon_sym_constinit] = ACTIONS(2367),
    [anon_sym_consteval] = ACTIONS(2367),
    [anon_sym_alignas] = ACTIONS(2367),
    [anon_sym__Alignas] = ACTIONS(2367),
    [sym_primitive_type] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2365),
    [anon_sym_LT_EQ_GT] = ACTIONS(2365),
    [anon_sym_or] = ACTIONS(2367),
    [anon_sym_and] = ACTIONS(2367),
    [anon_sym_bitor] = ACTIONS(2367),
    [anon_sym_xor] = ACTIONS(2367),
    [anon_sym_bitand] = ACTIONS(2367),
    [anon_sym_not_eq] = ACTIONS(2367),
    [anon_sym_is] = ACTIONS(2367),
    [anon_sym_as] = ACTIONS(2367),
    [anon_sym_DASH_DASH] = ACTIONS(2365),
    [anon_sym_PLUS_PLUS] = ACTIONS(2365),
    [anon_sym_DOT] = ACTIONS(2367),
    [anon_sym_DOT_STAR] = ACTIONS(2365),
    [anon_sym_DASH_GT] = ACTIONS(2365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2367),
    [anon_sym_let] = ACTIONS(2367),
    [anon_sym_This] = ACTIONS(2367),
    [anon_sym_final] = ACTIONS(2367),
    [anon_sym_override] = ACTIONS(2367),
    [anon_sym_requires] = ACTIONS(2367),
    [anon_sym_where] = ACTIONS(2367),
  },
  [2856] = {
    [sym_identifier] = ACTIONS(2256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2258),
    [anon_sym_COMMA] = ACTIONS(2258),
    [anon_sym_RPAREN] = ACTIONS(2258),
    [anon_sym_LPAREN2] = ACTIONS(2258),
    [anon_sym_DASH] = ACTIONS(2256),
    [anon_sym_PLUS] = ACTIONS(2256),
    [anon_sym_STAR] = ACTIONS(2258),
    [anon_sym_SLASH] = ACTIONS(2256),
    [anon_sym_PERCENT] = ACTIONS(2258),
    [anon_sym_PIPE_PIPE] = ACTIONS(2258),
    [anon_sym_AMP_AMP] = ACTIONS(2258),
    [anon_sym_PIPE] = ACTIONS(2256),
    [anon_sym_CARET] = ACTIONS(2258),
    [anon_sym_AMP] = ACTIONS(2256),
    [anon_sym_EQ_EQ] = ACTIONS(2258),
    [anon_sym_BANG_EQ] = ACTIONS(2258),
    [anon_sym_GT] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2258),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_LT] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_COLON] = ACTIONS(2256),
    [anon_sym_SEMI] = ACTIONS(2258),
    [anon_sym___extension__] = ACTIONS(2256),
    [anon_sym___attribute__] = ACTIONS(2256),
    [anon_sym_COLON_COLON] = ACTIONS(2258),
    [anon_sym___based] = ACTIONS(2256),
    [anon_sym_LBRACE] = ACTIONS(2258),
    [anon_sym_RBRACE] = ACTIONS(2258),
    [anon_sym_signed] = ACTIONS(2256),
    [anon_sym_unsigned] = ACTIONS(2256),
    [anon_sym_long] = ACTIONS(2256),
    [anon_sym_short] = ACTIONS(2256),
    [anon_sym_LBRACK] = ACTIONS(2258),
    [anon_sym_RBRACK] = ACTIONS(2258),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_constexpr] = ACTIONS(2256),
    [anon_sym_volatile] = ACTIONS(2256),
    [anon_sym_restrict] = ACTIONS(2256),
    [anon_sym___restrict__] = ACTIONS(2256),
    [anon_sym__Atomic] = ACTIONS(2256),
    [anon_sym__Noreturn] = ACTIONS(2256),
    [anon_sym_noreturn] = ACTIONS(2256),
    [anon_sym_mutable] = ACTIONS(2256),
    [anon_sym_constinit] = ACTIONS(2256),
    [anon_sym_consteval] = ACTIONS(2256),
    [anon_sym_alignas] = ACTIONS(2256),
    [anon_sym__Alignas] = ACTIONS(2256),
    [sym_primitive_type] = ACTIONS(2256),
    [anon_sym_QMARK] = ACTIONS(2258),
    [anon_sym_LT_EQ_GT] = ACTIONS(2258),
    [anon_sym_or] = ACTIONS(2256),
    [anon_sym_and] = ACTIONS(2256),
    [anon_sym_bitor] = ACTIONS(2256),
    [anon_sym_xor] = ACTIONS(2256),
    [anon_sym_bitand] = ACTIONS(2256),
    [anon_sym_not_eq] = ACTIONS(2256),
    [anon_sym_is] = ACTIONS(2256),
    [anon_sym_as] = ACTIONS(2256),
    [anon_sym_DASH_DASH] = ACTIONS(2258),
    [anon_sym_PLUS_PLUS] = ACTIONS(2258),
    [anon_sym_DOT] = ACTIONS(2256),
    [anon_sym_DOT_STAR] = ACTIONS(2258),
    [anon_sym_DASH_GT] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_This] = ACTIONS(2256),
    [anon_sym_final] = ACTIONS(2256),
    [anon_sym_override] = ACTIONS(2256),
    [anon_sym_requires] = ACTIONS(2256),
    [anon_sym_where] = ACTIONS(2256),
  },
  [2857] = {
    [sym_attribute_specifier] = STATE(3076),
    [sym_field_declaration_list] = STATE(3032),
    [sym_virtual_specifier] = STATE(8652),
    [sym_base_class_clause] = STATE(9836),
    [sym_identifier] = ACTIONS(2683),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2685),
    [anon_sym_RPAREN] = ACTIONS(2685),
    [aux_sym_preproc_if_token2] = ACTIONS(2685),
    [aux_sym_preproc_else_token1] = ACTIONS(2685),
    [aux_sym_preproc_elif_token1] = ACTIONS(2683),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2685),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2683),
    [anon_sym_PLUS] = ACTIONS(2683),
    [anon_sym_STAR] = ACTIONS(2683),
    [anon_sym_SLASH] = ACTIONS(2683),
    [anon_sym_PERCENT] = ACTIONS(2683),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_PIPE] = ACTIONS(2683),
    [anon_sym_CARET] = ACTIONS(2683),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_EQ_EQ] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_GT] = ACTIONS(2683),
    [anon_sym_GT_EQ] = ACTIONS(2685),
    [anon_sym_LT_EQ] = ACTIONS(2683),
    [anon_sym_LT] = ACTIONS(2683),
    [anon_sym_LT_LT] = ACTIONS(2683),
    [anon_sym_GT_GT] = ACTIONS(2683),
    [anon_sym_COLON] = ACTIONS(6474),
    [anon_sym_SEMI] = ACTIONS(2685),
    [anon_sym___attribute__] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(6478),
    [anon_sym_RBRACE] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_RBRACK] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2683),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_STAR_EQ] = ACTIONS(2685),
    [anon_sym_SLASH_EQ] = ACTIONS(2685),
    [anon_sym_PERCENT_EQ] = ACTIONS(2685),
    [anon_sym_PLUS_EQ] = ACTIONS(2685),
    [anon_sym_DASH_EQ] = ACTIONS(2685),
    [anon_sym_LT_LT_EQ] = ACTIONS(2685),
    [anon_sym_GT_GT_EQ] = ACTIONS(2685),
    [anon_sym_AMP_EQ] = ACTIONS(2685),
    [anon_sym_CARET_EQ] = ACTIONS(2685),
    [anon_sym_PIPE_EQ] = ACTIONS(2685),
    [anon_sym_and_eq] = ACTIONS(2683),
    [anon_sym_or_eq] = ACTIONS(2683),
    [anon_sym_xor_eq] = ACTIONS(2683),
    [anon_sym_LT_EQ_GT] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2683),
    [anon_sym_and] = ACTIONS(2683),
    [anon_sym_bitor] = ACTIONS(2683),
    [anon_sym_xor] = ACTIONS(2683),
    [anon_sym_bitand] = ACTIONS(2683),
    [anon_sym_not_eq] = ACTIONS(2683),
    [anon_sym_is] = ACTIONS(2683),
    [anon_sym_as] = ACTIONS(2683),
    [anon_sym_DASH_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_PLUS] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2683),
    [anon_sym_DOT_STAR] = ACTIONS(2685),
    [anon_sym_DASH_GT] = ACTIONS(2685),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2683),
    [anon_sym_let] = ACTIONS(2683),
    [anon_sym_This] = ACTIONS(2683),
    [anon_sym_final] = ACTIONS(2481),
    [anon_sym_override] = ACTIONS(2481),
  },
  [2858] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2605),
    [sym_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(3781),
    [anon_sym_RPAREN] = ACTIONS(3781),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_STAR] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym___extension__] = ACTIONS(3778),
    [anon_sym_in] = ACTIONS(3778),
    [anon_sym_out] = ACTIONS(3778),
    [anon_sym_inout] = ACTIONS(3778),
    [anon_sym_extern] = ACTIONS(3778),
    [anon_sym___attribute__] = ACTIONS(3778),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3781),
    [anon_sym___declspec] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_signed] = ACTIONS(6189),
    [anon_sym_unsigned] = ACTIONS(6189),
    [anon_sym_long] = ACTIONS(6189),
    [anon_sym_short] = ACTIONS(6189),
    [anon_sym_LBRACK] = ACTIONS(3778),
    [anon_sym_static] = ACTIONS(3778),
    [anon_sym_register] = ACTIONS(3778),
    [anon_sym_inline] = ACTIONS(3778),
    [anon_sym___inline] = ACTIONS(3778),
    [anon_sym___inline__] = ACTIONS(3778),
    [anon_sym___forceinline] = ACTIONS(3778),
    [anon_sym_thread_local] = ACTIONS(3778),
    [anon_sym___thread] = ACTIONS(3778),
    [anon_sym_const] = ACTIONS(3778),
    [anon_sym_constexpr] = ACTIONS(3778),
    [anon_sym_volatile] = ACTIONS(3778),
    [anon_sym_restrict] = ACTIONS(3778),
    [anon_sym___restrict__] = ACTIONS(3778),
    [anon_sym__Atomic] = ACTIONS(3778),
    [anon_sym__Noreturn] = ACTIONS(3778),
    [anon_sym_noreturn] = ACTIONS(3778),
    [anon_sym_mutable] = ACTIONS(3778),
    [anon_sym_constinit] = ACTIONS(3778),
    [anon_sym_consteval] = ACTIONS(3778),
    [anon_sym_alignas] = ACTIONS(3778),
    [anon_sym__Alignas] = ACTIONS(3778),
    [sym_primitive_type] = ACTIONS(2856),
    [anon_sym_DOT] = ACTIONS(3781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3778),
    [anon_sym_let] = ACTIONS(3778),
    [anon_sym_This] = ACTIONS(3778),
    [anon_sym_final] = ACTIONS(3778),
    [anon_sym_override] = ACTIONS(3778),
    [sym_virtual] = ACTIONS(3778),
    [anon_sym_GT2] = ACTIONS(3781),
    [anon_sym_requires] = ACTIONS(3778),
    [anon_sym_precise] = ACTIONS(3778),
    [anon_sym_shared] = ACTIONS(3778),
    [anon_sym_groupshared] = ACTIONS(3778),
    [anon_sym_uniform] = ACTIONS(3778),
    [anon_sym_row_major] = ACTIONS(3778),
    [anon_sym_column_major] = ACTIONS(3778),
    [anon_sym_globallycoherent] = ACTIONS(3778),
    [anon_sym_centroid] = ACTIONS(3778),
    [anon_sym_noperspective] = ACTIONS(3778),
    [anon_sym_nointerpolation] = ACTIONS(3778),
    [anon_sym_sample] = ACTIONS(3778),
    [anon_sym_linear] = ACTIONS(3778),
    [anon_sym_snorm] = ACTIONS(3778),
    [anon_sym_unorm] = ACTIONS(3778),
    [anon_sym_point] = ACTIONS(3778),
    [anon_sym_line] = ACTIONS(3778),
    [anon_sym_triangleadj] = ACTIONS(3778),
    [anon_sym_lineadj] = ACTIONS(3778),
    [anon_sym_triangle] = ACTIONS(3778),
    [anon_sym_where] = ACTIONS(3778),
  },
  [2859] = {
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2371),
    [anon_sym_COMMA] = ACTIONS(2371),
    [anon_sym_RPAREN] = ACTIONS(2371),
    [anon_sym_LPAREN2] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_SLASH] = ACTIONS(2373),
    [anon_sym_PERCENT] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_CARET] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_EQ_EQ] = ACTIONS(2371),
    [anon_sym_BANG_EQ] = ACTIONS(2371),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_EQ] = ACTIONS(2371),
    [anon_sym_LT_EQ] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_LT_LT] = ACTIONS(2371),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym___extension__] = ACTIONS(2373),
    [anon_sym___attribute__] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym___based] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_RBRACE] = ACTIONS(2371),
    [anon_sym_signed] = ACTIONS(2373),
    [anon_sym_unsigned] = ACTIONS(2373),
    [anon_sym_long] = ACTIONS(2373),
    [anon_sym_short] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_RBRACK] = ACTIONS(2371),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym___restrict__] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym__Noreturn] = ACTIONS(2373),
    [anon_sym_noreturn] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_constinit] = ACTIONS(2373),
    [anon_sym_consteval] = ACTIONS(2373),
    [anon_sym_alignas] = ACTIONS(2373),
    [anon_sym__Alignas] = ACTIONS(2373),
    [sym_primitive_type] = ACTIONS(2373),
    [anon_sym_QMARK] = ACTIONS(2371),
    [anon_sym_LT_EQ_GT] = ACTIONS(2371),
    [anon_sym_or] = ACTIONS(2373),
    [anon_sym_and] = ACTIONS(2373),
    [anon_sym_bitor] = ACTIONS(2373),
    [anon_sym_xor] = ACTIONS(2373),
    [anon_sym_bitand] = ACTIONS(2373),
    [anon_sym_not_eq] = ACTIONS(2373),
    [anon_sym_is] = ACTIONS(2373),
    [anon_sym_as] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_DOT] = ACTIONS(2373),
    [anon_sym_DOT_STAR] = ACTIONS(2371),
    [anon_sym_DASH_GT] = ACTIONS(2371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_This] = ACTIONS(2373),
    [anon_sym_final] = ACTIONS(2373),
    [anon_sym_override] = ACTIONS(2373),
    [anon_sym_requires] = ACTIONS(2373),
    [anon_sym_where] = ACTIONS(2373),
  },
  [2860] = {
    [sym_identifier] = ACTIONS(2742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2740),
    [anon_sym_COMMA] = ACTIONS(2740),
    [anon_sym_RPAREN] = ACTIONS(2740),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2742),
    [anon_sym_PLUS] = ACTIONS(2742),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_SLASH] = ACTIONS(2742),
    [anon_sym_PERCENT] = ACTIONS(2740),
    [anon_sym_PIPE_PIPE] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_PIPE] = ACTIONS(2742),
    [anon_sym_CARET] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_EQ_EQ] = ACTIONS(2740),
    [anon_sym_BANG_EQ] = ACTIONS(2740),
    [anon_sym_GT] = ACTIONS(2742),
    [anon_sym_GT_EQ] = ACTIONS(2740),
    [anon_sym_LT_EQ] = ACTIONS(2742),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_LT_LT] = ACTIONS(2740),
    [anon_sym_GT_GT] = ACTIONS(2740),
    [anon_sym_COLON] = ACTIONS(2742),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym___extension__] = ACTIONS(2742),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym___based] = ACTIONS(2742),
    [anon_sym_LBRACE] = ACTIONS(2740),
    [anon_sym_RBRACE] = ACTIONS(2740),
    [anon_sym_signed] = ACTIONS(2742),
    [anon_sym_unsigned] = ACTIONS(2742),
    [anon_sym_long] = ACTIONS(2742),
    [anon_sym_short] = ACTIONS(2742),
    [anon_sym_LBRACK] = ACTIONS(2740),
    [anon_sym_RBRACK] = ACTIONS(2740),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_constexpr] = ACTIONS(2742),
    [anon_sym_volatile] = ACTIONS(2742),
    [anon_sym_restrict] = ACTIONS(2742),
    [anon_sym___restrict__] = ACTIONS(2742),
    [anon_sym__Atomic] = ACTIONS(2742),
    [anon_sym__Noreturn] = ACTIONS(2742),
    [anon_sym_noreturn] = ACTIONS(2742),
    [anon_sym_mutable] = ACTIONS(2742),
    [anon_sym_constinit] = ACTIONS(2742),
    [anon_sym_consteval] = ACTIONS(2742),
    [anon_sym_alignas] = ACTIONS(2742),
    [anon_sym__Alignas] = ACTIONS(2742),
    [sym_primitive_type] = ACTIONS(2742),
    [anon_sym_QMARK] = ACTIONS(2740),
    [anon_sym_LT_EQ_GT] = ACTIONS(2740),
    [anon_sym_or] = ACTIONS(2742),
    [anon_sym_and] = ACTIONS(2742),
    [anon_sym_bitor] = ACTIONS(2742),
    [anon_sym_xor] = ACTIONS(2742),
    [anon_sym_bitand] = ACTIONS(2742),
    [anon_sym_not_eq] = ACTIONS(2742),
    [anon_sym_is] = ACTIONS(2742),
    [anon_sym_as] = ACTIONS(2742),
    [anon_sym_DASH_DASH] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2740),
    [anon_sym_DOT] = ACTIONS(2742),
    [anon_sym_DOT_STAR] = ACTIONS(2740),
    [anon_sym_DASH_GT] = ACTIONS(2740),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
    [anon_sym_final] = ACTIONS(2742),
    [anon_sym_override] = ACTIONS(2742),
    [anon_sym_requires] = ACTIONS(2742),
    [anon_sym_where] = ACTIONS(2742),
  },
  [2861] = {
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2371),
    [anon_sym_COMMA] = ACTIONS(2371),
    [anon_sym_RPAREN] = ACTIONS(2371),
    [anon_sym_LPAREN2] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_SLASH] = ACTIONS(2373),
    [anon_sym_PERCENT] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_CARET] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_EQ_EQ] = ACTIONS(2371),
    [anon_sym_BANG_EQ] = ACTIONS(2371),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_EQ] = ACTIONS(2371),
    [anon_sym_LT_EQ] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_LT_LT] = ACTIONS(2371),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym___extension__] = ACTIONS(2373),
    [anon_sym___attribute__] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym___based] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_RBRACE] = ACTIONS(2371),
    [anon_sym_signed] = ACTIONS(2373),
    [anon_sym_unsigned] = ACTIONS(2373),
    [anon_sym_long] = ACTIONS(2373),
    [anon_sym_short] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_RBRACK] = ACTIONS(2371),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym___restrict__] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym__Noreturn] = ACTIONS(2373),
    [anon_sym_noreturn] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_constinit] = ACTIONS(2373),
    [anon_sym_consteval] = ACTIONS(2373),
    [anon_sym_alignas] = ACTIONS(2373),
    [anon_sym__Alignas] = ACTIONS(2373),
    [sym_primitive_type] = ACTIONS(2373),
    [anon_sym_QMARK] = ACTIONS(2371),
    [anon_sym_LT_EQ_GT] = ACTIONS(2371),
    [anon_sym_or] = ACTIONS(2373),
    [anon_sym_and] = ACTIONS(2373),
    [anon_sym_bitor] = ACTIONS(2373),
    [anon_sym_xor] = ACTIONS(2373),
    [anon_sym_bitand] = ACTIONS(2373),
    [anon_sym_not_eq] = ACTIONS(2373),
    [anon_sym_is] = ACTIONS(2373),
    [anon_sym_as] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_DOT] = ACTIONS(2373),
    [anon_sym_DOT_STAR] = ACTIONS(2371),
    [anon_sym_DASH_GT] = ACTIONS(2371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_This] = ACTIONS(2373),
    [anon_sym_final] = ACTIONS(2373),
    [anon_sym_override] = ACTIONS(2373),
    [anon_sym_requires] = ACTIONS(2373),
    [anon_sym_where] = ACTIONS(2373),
  },
  [2862] = {
    [sym__declaration_modifiers] = STATE(2862),
    [sym_attribute_specifier] = STATE(2862),
    [sym_attribute_declaration] = STATE(2862),
    [sym_ms_declspec_modifier] = STATE(2862),
    [sym_storage_class_specifier] = STATE(2862),
    [sym_type_qualifier] = STATE(2862),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_explicit_function_specifier] = STATE(2862),
    [sym__constructor_specifiers] = STATE(2862),
    [sym_qualifiers] = STATE(2862),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2862),
    [sym_identifier] = ACTIONS(6480),
    [anon_sym_LPAREN2] = ACTIONS(6482),
    [anon_sym_TILDE] = ACTIONS(6482),
    [anon_sym_STAR] = ACTIONS(6482),
    [anon_sym_AMP_AMP] = ACTIONS(6482),
    [anon_sym_AMP] = ACTIONS(6480),
    [anon_sym___extension__] = ACTIONS(6484),
    [anon_sym_in] = ACTIONS(6487),
    [anon_sym_out] = ACTIONS(6487),
    [anon_sym_inout] = ACTIONS(6487),
    [anon_sym_extern] = ACTIONS(6490),
    [anon_sym___attribute__] = ACTIONS(6493),
    [anon_sym_COLON_COLON] = ACTIONS(6482),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6496),
    [anon_sym___declspec] = ACTIONS(6499),
    [anon_sym___based] = ACTIONS(6480),
    [anon_sym_LBRACK] = ACTIONS(6480),
    [anon_sym_static] = ACTIONS(6490),
    [anon_sym_register] = ACTIONS(6490),
    [anon_sym_inline] = ACTIONS(6490),
    [anon_sym___inline] = ACTIONS(6490),
    [anon_sym___inline__] = ACTIONS(6490),
    [anon_sym___forceinline] = ACTIONS(6490),
    [anon_sym_thread_local] = ACTIONS(6490),
    [anon_sym___thread] = ACTIONS(6490),
    [anon_sym_const] = ACTIONS(6484),
    [anon_sym_constexpr] = ACTIONS(6484),
    [anon_sym_volatile] = ACTIONS(6484),
    [anon_sym_restrict] = ACTIONS(6484),
    [anon_sym___restrict__] = ACTIONS(6484),
    [anon_sym__Atomic] = ACTIONS(6484),
    [anon_sym__Noreturn] = ACTIONS(6484),
    [anon_sym_noreturn] = ACTIONS(6484),
    [anon_sym_mutable] = ACTIONS(6484),
    [anon_sym_constinit] = ACTIONS(6484),
    [anon_sym_consteval] = ACTIONS(6484),
    [anon_sym_alignas] = ACTIONS(6502),
    [anon_sym__Alignas] = ACTIONS(6502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(6480),
    [sym_virtual] = ACTIONS(6487),
    [anon_sym_explicit] = ACTIONS(6505),
    [anon_sym_template] = ACTIONS(6480),
    [anon_sym_operator] = ACTIONS(6480),
    [anon_sym_precise] = ACTIONS(6508),
    [anon_sym_shared] = ACTIONS(6508),
    [anon_sym_groupshared] = ACTIONS(6508),
    [anon_sym_uniform] = ACTIONS(6508),
    [anon_sym_row_major] = ACTIONS(6508),
    [anon_sym_column_major] = ACTIONS(6508),
    [anon_sym_globallycoherent] = ACTIONS(6508),
    [anon_sym_centroid] = ACTIONS(6508),
    [anon_sym_noperspective] = ACTIONS(6508),
    [anon_sym_nointerpolation] = ACTIONS(6508),
    [anon_sym_sample] = ACTIONS(6508),
    [anon_sym_linear] = ACTIONS(6508),
    [anon_sym_snorm] = ACTIONS(6508),
    [anon_sym_unorm] = ACTIONS(6508),
    [anon_sym_point] = ACTIONS(6508),
    [anon_sym_line] = ACTIONS(6508),
    [anon_sym_triangleadj] = ACTIONS(6508),
    [anon_sym_lineadj] = ACTIONS(6508),
    [anon_sym_triangle] = ACTIONS(6508),
  },
  [2863] = {
    [sym_identifier] = ACTIONS(2198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_COMMA] = ACTIONS(2200),
    [anon_sym_RPAREN] = ACTIONS(2200),
    [anon_sym_LPAREN2] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(2200),
    [anon_sym_SLASH] = ACTIONS(2198),
    [anon_sym_PERCENT] = ACTIONS(2200),
    [anon_sym_PIPE_PIPE] = ACTIONS(2200),
    [anon_sym_AMP_AMP] = ACTIONS(2200),
    [anon_sym_PIPE] = ACTIONS(2198),
    [anon_sym_CARET] = ACTIONS(2200),
    [anon_sym_AMP] = ACTIONS(2198),
    [anon_sym_EQ_EQ] = ACTIONS(2200),
    [anon_sym_BANG_EQ] = ACTIONS(2200),
    [anon_sym_GT] = ACTIONS(2198),
    [anon_sym_GT_EQ] = ACTIONS(2200),
    [anon_sym_LT_EQ] = ACTIONS(2198),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_LT_LT] = ACTIONS(2200),
    [anon_sym_GT_GT] = ACTIONS(2200),
    [anon_sym_COLON] = ACTIONS(2198),
    [anon_sym_SEMI] = ACTIONS(2200),
    [anon_sym___extension__] = ACTIONS(2198),
    [anon_sym___attribute__] = ACTIONS(2198),
    [anon_sym_COLON_COLON] = ACTIONS(2200),
    [anon_sym___based] = ACTIONS(2198),
    [anon_sym_LBRACE] = ACTIONS(2200),
    [anon_sym_RBRACE] = ACTIONS(2200),
    [anon_sym_signed] = ACTIONS(2198),
    [anon_sym_unsigned] = ACTIONS(2198),
    [anon_sym_long] = ACTIONS(2198),
    [anon_sym_short] = ACTIONS(2198),
    [anon_sym_LBRACK] = ACTIONS(2200),
    [anon_sym_RBRACK] = ACTIONS(2200),
    [anon_sym_const] = ACTIONS(2198),
    [anon_sym_constexpr] = ACTIONS(2198),
    [anon_sym_volatile] = ACTIONS(2198),
    [anon_sym_restrict] = ACTIONS(2198),
    [anon_sym___restrict__] = ACTIONS(2198),
    [anon_sym__Atomic] = ACTIONS(2198),
    [anon_sym__Noreturn] = ACTIONS(2198),
    [anon_sym_noreturn] = ACTIONS(2198),
    [anon_sym_mutable] = ACTIONS(2198),
    [anon_sym_constinit] = ACTIONS(2198),
    [anon_sym_consteval] = ACTIONS(2198),
    [anon_sym_alignas] = ACTIONS(2198),
    [anon_sym__Alignas] = ACTIONS(2198),
    [sym_primitive_type] = ACTIONS(2198),
    [anon_sym_QMARK] = ACTIONS(2200),
    [anon_sym_LT_EQ_GT] = ACTIONS(2200),
    [anon_sym_or] = ACTIONS(2198),
    [anon_sym_and] = ACTIONS(2198),
    [anon_sym_bitor] = ACTIONS(2198),
    [anon_sym_xor] = ACTIONS(2198),
    [anon_sym_bitand] = ACTIONS(2198),
    [anon_sym_not_eq] = ACTIONS(2198),
    [anon_sym_is] = ACTIONS(2198),
    [anon_sym_as] = ACTIONS(2198),
    [anon_sym_DASH_DASH] = ACTIONS(2200),
    [anon_sym_PLUS_PLUS] = ACTIONS(2200),
    [anon_sym_DOT] = ACTIONS(2198),
    [anon_sym_DOT_STAR] = ACTIONS(2200),
    [anon_sym_DASH_GT] = ACTIONS(2200),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2198),
    [anon_sym_let] = ACTIONS(2198),
    [anon_sym_This] = ACTIONS(2198),
    [anon_sym_final] = ACTIONS(2198),
    [anon_sym_override] = ACTIONS(2198),
    [anon_sym_requires] = ACTIONS(2198),
    [anon_sym_where] = ACTIONS(2198),
  },
  [2864] = {
    [sym_identifier] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_LPAREN2] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2186),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_STAR] = ACTIONS(2188),
    [anon_sym_SLASH] = ACTIONS(2186),
    [anon_sym_PERCENT] = ACTIONS(2188),
    [anon_sym_PIPE_PIPE] = ACTIONS(2188),
    [anon_sym_AMP_AMP] = ACTIONS(2188),
    [anon_sym_PIPE] = ACTIONS(2186),
    [anon_sym_CARET] = ACTIONS(2188),
    [anon_sym_AMP] = ACTIONS(2186),
    [anon_sym_EQ_EQ] = ACTIONS(2188),
    [anon_sym_BANG_EQ] = ACTIONS(2188),
    [anon_sym_GT] = ACTIONS(2186),
    [anon_sym_GT_EQ] = ACTIONS(2188),
    [anon_sym_LT_EQ] = ACTIONS(2186),
    [anon_sym_LT] = ACTIONS(2186),
    [anon_sym_LT_LT] = ACTIONS(2188),
    [anon_sym_GT_GT] = ACTIONS(2188),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym___extension__] = ACTIONS(2186),
    [anon_sym___attribute__] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym___based] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_RBRACE] = ACTIONS(2188),
    [anon_sym_signed] = ACTIONS(2186),
    [anon_sym_unsigned] = ACTIONS(2186),
    [anon_sym_long] = ACTIONS(2186),
    [anon_sym_short] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2188),
    [anon_sym_RBRACK] = ACTIONS(2188),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_constexpr] = ACTIONS(2186),
    [anon_sym_volatile] = ACTIONS(2186),
    [anon_sym_restrict] = ACTIONS(2186),
    [anon_sym___restrict__] = ACTIONS(2186),
    [anon_sym__Atomic] = ACTIONS(2186),
    [anon_sym__Noreturn] = ACTIONS(2186),
    [anon_sym_noreturn] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_constinit] = ACTIONS(2186),
    [anon_sym_consteval] = ACTIONS(2186),
    [anon_sym_alignas] = ACTIONS(2186),
    [anon_sym__Alignas] = ACTIONS(2186),
    [sym_primitive_type] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_LT_EQ_GT] = ACTIONS(2188),
    [anon_sym_or] = ACTIONS(2186),
    [anon_sym_and] = ACTIONS(2186),
    [anon_sym_bitor] = ACTIONS(2186),
    [anon_sym_xor] = ACTIONS(2186),
    [anon_sym_bitand] = ACTIONS(2186),
    [anon_sym_not_eq] = ACTIONS(2186),
    [anon_sym_is] = ACTIONS(2186),
    [anon_sym_as] = ACTIONS(2186),
    [anon_sym_DASH_DASH] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2188),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOT_STAR] = ACTIONS(2188),
    [anon_sym_DASH_GT] = ACTIONS(2188),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_This] = ACTIONS(2186),
    [anon_sym_final] = ACTIONS(2186),
    [anon_sym_override] = ACTIONS(2186),
    [anon_sym_requires] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
  },
  [2865] = {
    [sym_identifier] = ACTIONS(2190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2192),
    [anon_sym_COMMA] = ACTIONS(2192),
    [anon_sym_RPAREN] = ACTIONS(2192),
    [anon_sym_LPAREN2] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2190),
    [anon_sym_PLUS] = ACTIONS(2190),
    [anon_sym_STAR] = ACTIONS(2192),
    [anon_sym_SLASH] = ACTIONS(2190),
    [anon_sym_PERCENT] = ACTIONS(2192),
    [anon_sym_PIPE_PIPE] = ACTIONS(2192),
    [anon_sym_AMP_AMP] = ACTIONS(2192),
    [anon_sym_PIPE] = ACTIONS(2190),
    [anon_sym_CARET] = ACTIONS(2192),
    [anon_sym_AMP] = ACTIONS(2190),
    [anon_sym_EQ_EQ] = ACTIONS(2192),
    [anon_sym_BANG_EQ] = ACTIONS(2192),
    [anon_sym_GT] = ACTIONS(2190),
    [anon_sym_GT_EQ] = ACTIONS(2192),
    [anon_sym_LT_EQ] = ACTIONS(2190),
    [anon_sym_LT] = ACTIONS(2190),
    [anon_sym_LT_LT] = ACTIONS(2192),
    [anon_sym_GT_GT] = ACTIONS(2192),
    [anon_sym_COLON] = ACTIONS(2190),
    [anon_sym_SEMI] = ACTIONS(2192),
    [anon_sym___extension__] = ACTIONS(2190),
    [anon_sym___attribute__] = ACTIONS(2190),
    [anon_sym_COLON_COLON] = ACTIONS(2192),
    [anon_sym___based] = ACTIONS(2190),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [anon_sym_RBRACE] = ACTIONS(2192),
    [anon_sym_signed] = ACTIONS(2190),
    [anon_sym_unsigned] = ACTIONS(2190),
    [anon_sym_long] = ACTIONS(2190),
    [anon_sym_short] = ACTIONS(2190),
    [anon_sym_LBRACK] = ACTIONS(2192),
    [anon_sym_RBRACK] = ACTIONS(2192),
    [anon_sym_const] = ACTIONS(2190),
    [anon_sym_constexpr] = ACTIONS(2190),
    [anon_sym_volatile] = ACTIONS(2190),
    [anon_sym_restrict] = ACTIONS(2190),
    [anon_sym___restrict__] = ACTIONS(2190),
    [anon_sym__Atomic] = ACTIONS(2190),
    [anon_sym__Noreturn] = ACTIONS(2190),
    [anon_sym_noreturn] = ACTIONS(2190),
    [anon_sym_mutable] = ACTIONS(2190),
    [anon_sym_constinit] = ACTIONS(2190),
    [anon_sym_consteval] = ACTIONS(2190),
    [anon_sym_alignas] = ACTIONS(2190),
    [anon_sym__Alignas] = ACTIONS(2190),
    [sym_primitive_type] = ACTIONS(2190),
    [anon_sym_QMARK] = ACTIONS(2192),
    [anon_sym_LT_EQ_GT] = ACTIONS(2192),
    [anon_sym_or] = ACTIONS(2190),
    [anon_sym_and] = ACTIONS(2190),
    [anon_sym_bitor] = ACTIONS(2190),
    [anon_sym_xor] = ACTIONS(2190),
    [anon_sym_bitand] = ACTIONS(2190),
    [anon_sym_not_eq] = ACTIONS(2190),
    [anon_sym_is] = ACTIONS(2190),
    [anon_sym_as] = ACTIONS(2190),
    [anon_sym_DASH_DASH] = ACTIONS(2192),
    [anon_sym_PLUS_PLUS] = ACTIONS(2192),
    [anon_sym_DOT] = ACTIONS(2190),
    [anon_sym_DOT_STAR] = ACTIONS(2192),
    [anon_sym_DASH_GT] = ACTIONS(2192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2190),
    [anon_sym_let] = ACTIONS(2190),
    [anon_sym_This] = ACTIONS(2190),
    [anon_sym_final] = ACTIONS(2190),
    [anon_sym_override] = ACTIONS(2190),
    [anon_sym_requires] = ACTIONS(2190),
    [anon_sym_where] = ACTIONS(2190),
  },
  [2866] = {
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2254),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_RPAREN] = ACTIONS(2254),
    [anon_sym_LPAREN2] = ACTIONS(2254),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2254),
    [anon_sym_SLASH] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2254),
    [anon_sym_PIPE_PIPE] = ACTIONS(2254),
    [anon_sym_AMP_AMP] = ACTIONS(2254),
    [anon_sym_PIPE] = ACTIONS(2252),
    [anon_sym_CARET] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_EQ_EQ] = ACTIONS(2254),
    [anon_sym_BANG_EQ] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2252),
    [anon_sym_GT_EQ] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2252),
    [anon_sym_LT_LT] = ACTIONS(2254),
    [anon_sym_GT_GT] = ACTIONS(2254),
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym_SEMI] = ACTIONS(2254),
    [anon_sym___extension__] = ACTIONS(2252),
    [anon_sym___attribute__] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym___based] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_RBRACE] = ACTIONS(2254),
    [anon_sym_signed] = ACTIONS(2252),
    [anon_sym_unsigned] = ACTIONS(2252),
    [anon_sym_long] = ACTIONS(2252),
    [anon_sym_short] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2254),
    [anon_sym_RBRACK] = ACTIONS(2254),
    [anon_sym_const] = ACTIONS(2252),
    [anon_sym_constexpr] = ACTIONS(2252),
    [anon_sym_volatile] = ACTIONS(2252),
    [anon_sym_restrict] = ACTIONS(2252),
    [anon_sym___restrict__] = ACTIONS(2252),
    [anon_sym__Atomic] = ACTIONS(2252),
    [anon_sym__Noreturn] = ACTIONS(2252),
    [anon_sym_noreturn] = ACTIONS(2252),
    [anon_sym_mutable] = ACTIONS(2252),
    [anon_sym_constinit] = ACTIONS(2252),
    [anon_sym_consteval] = ACTIONS(2252),
    [anon_sym_alignas] = ACTIONS(2252),
    [anon_sym__Alignas] = ACTIONS(2252),
    [sym_primitive_type] = ACTIONS(2252),
    [anon_sym_QMARK] = ACTIONS(2254),
    [anon_sym_LT_EQ_GT] = ACTIONS(2254),
    [anon_sym_or] = ACTIONS(2252),
    [anon_sym_and] = ACTIONS(2252),
    [anon_sym_bitor] = ACTIONS(2252),
    [anon_sym_xor] = ACTIONS(2252),
    [anon_sym_bitand] = ACTIONS(2252),
    [anon_sym_not_eq] = ACTIONS(2252),
    [anon_sym_is] = ACTIONS(2252),
    [anon_sym_as] = ACTIONS(2252),
    [anon_sym_DASH_DASH] = ACTIONS(2254),
    [anon_sym_PLUS_PLUS] = ACTIONS(2254),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_DOT_STAR] = ACTIONS(2254),
    [anon_sym_DASH_GT] = ACTIONS(2254),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_This] = ACTIONS(2252),
    [anon_sym_final] = ACTIONS(2252),
    [anon_sym_override] = ACTIONS(2252),
    [anon_sym_requires] = ACTIONS(2252),
    [anon_sym_where] = ACTIONS(2252),
  },
  [2867] = {
    [sym_identifier] = ACTIONS(6460),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6462),
    [anon_sym_COMMA] = ACTIONS(6462),
    [anon_sym_RPAREN] = ACTIONS(6462),
    [aux_sym_preproc_if_token2] = ACTIONS(6462),
    [aux_sym_preproc_else_token1] = ACTIONS(6462),
    [aux_sym_preproc_elif_token1] = ACTIONS(6460),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6462),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6462),
    [anon_sym_LPAREN2] = ACTIONS(6462),
    [anon_sym_DASH] = ACTIONS(6460),
    [anon_sym_PLUS] = ACTIONS(6460),
    [anon_sym_STAR] = ACTIONS(6460),
    [anon_sym_SLASH] = ACTIONS(6460),
    [anon_sym_PERCENT] = ACTIONS(6460),
    [anon_sym_PIPE_PIPE] = ACTIONS(6462),
    [anon_sym_AMP_AMP] = ACTIONS(6462),
    [anon_sym_PIPE] = ACTIONS(6460),
    [anon_sym_CARET] = ACTIONS(6460),
    [anon_sym_AMP] = ACTIONS(6460),
    [anon_sym_EQ_EQ] = ACTIONS(6462),
    [anon_sym_BANG_EQ] = ACTIONS(6462),
    [anon_sym_GT] = ACTIONS(6460),
    [anon_sym_GT_EQ] = ACTIONS(6462),
    [anon_sym_LT_EQ] = ACTIONS(6460),
    [anon_sym_LT] = ACTIONS(6460),
    [anon_sym_LT_LT] = ACTIONS(6460),
    [anon_sym_GT_GT] = ACTIONS(6460),
    [anon_sym_COLON] = ACTIONS(6462),
    [anon_sym_SEMI] = ACTIONS(6462),
    [anon_sym_RBRACE] = ACTIONS(6462),
    [anon_sym_LBRACK] = ACTIONS(6462),
    [anon_sym_RBRACK] = ACTIONS(6462),
    [anon_sym_EQ] = ACTIONS(6460),
    [anon_sym_QMARK] = ACTIONS(6462),
    [anon_sym_STAR_EQ] = ACTIONS(6462),
    [anon_sym_SLASH_EQ] = ACTIONS(6462),
    [anon_sym_PERCENT_EQ] = ACTIONS(6462),
    [anon_sym_PLUS_EQ] = ACTIONS(6462),
    [anon_sym_DASH_EQ] = ACTIONS(6462),
    [anon_sym_LT_LT_EQ] = ACTIONS(6462),
    [anon_sym_GT_GT_EQ] = ACTIONS(6462),
    [anon_sym_AMP_EQ] = ACTIONS(6462),
    [anon_sym_CARET_EQ] = ACTIONS(6462),
    [anon_sym_PIPE_EQ] = ACTIONS(6462),
    [anon_sym_and_eq] = ACTIONS(6460),
    [anon_sym_or_eq] = ACTIONS(6460),
    [anon_sym_xor_eq] = ACTIONS(6460),
    [anon_sym_LT_EQ_GT] = ACTIONS(6462),
    [anon_sym_or] = ACTIONS(6460),
    [anon_sym_and] = ACTIONS(6460),
    [anon_sym_bitor] = ACTIONS(6460),
    [anon_sym_xor] = ACTIONS(6460),
    [anon_sym_bitand] = ACTIONS(6460),
    [anon_sym_not_eq] = ACTIONS(6460),
    [anon_sym_is] = ACTIONS(6460),
    [anon_sym_as] = ACTIONS(6460),
    [anon_sym_DASH_DASH] = ACTIONS(6462),
    [anon_sym_PLUS_PLUS] = ACTIONS(6462),
    [anon_sym_DOT] = ACTIONS(6460),
    [anon_sym_DOT_STAR] = ACTIONS(6462),
    [anon_sym_DASH_GT] = ACTIONS(6462),
    [anon_sym_L_DQUOTE] = ACTIONS(6462),
    [anon_sym_u_DQUOTE] = ACTIONS(6462),
    [anon_sym_U_DQUOTE] = ACTIONS(6462),
    [anon_sym_u8_DQUOTE] = ACTIONS(6462),
    [anon_sym_DQUOTE] = ACTIONS(6462),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6462),
    [anon_sym_LR_DQUOTE] = ACTIONS(6462),
    [anon_sym_uR_DQUOTE] = ACTIONS(6462),
    [anon_sym_UR_DQUOTE] = ACTIONS(6462),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6462),
    [sym_literal_suffix] = ACTIONS(6460),
  },
  [2868] = {
    [sym_identifier] = ACTIONS(6511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6513),
    [anon_sym_COMMA] = ACTIONS(6513),
    [anon_sym_RPAREN] = ACTIONS(6513),
    [aux_sym_preproc_if_token2] = ACTIONS(6513),
    [aux_sym_preproc_else_token1] = ACTIONS(6513),
    [aux_sym_preproc_elif_token1] = ACTIONS(6511),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6513),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6513),
    [anon_sym_LPAREN2] = ACTIONS(6513),
    [anon_sym_DASH] = ACTIONS(6511),
    [anon_sym_PLUS] = ACTIONS(6511),
    [anon_sym_STAR] = ACTIONS(6511),
    [anon_sym_SLASH] = ACTIONS(6511),
    [anon_sym_PERCENT] = ACTIONS(6511),
    [anon_sym_PIPE_PIPE] = ACTIONS(6513),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_PIPE] = ACTIONS(6511),
    [anon_sym_CARET] = ACTIONS(6511),
    [anon_sym_AMP] = ACTIONS(6511),
    [anon_sym_EQ_EQ] = ACTIONS(6513),
    [anon_sym_BANG_EQ] = ACTIONS(6513),
    [anon_sym_GT] = ACTIONS(6511),
    [anon_sym_GT_EQ] = ACTIONS(6513),
    [anon_sym_LT_EQ] = ACTIONS(6511),
    [anon_sym_LT] = ACTIONS(6511),
    [anon_sym_LT_LT] = ACTIONS(6511),
    [anon_sym_GT_GT] = ACTIONS(6511),
    [anon_sym_COLON] = ACTIONS(6513),
    [anon_sym_SEMI] = ACTIONS(6513),
    [anon_sym_RBRACE] = ACTIONS(6513),
    [anon_sym_LBRACK] = ACTIONS(6513),
    [anon_sym_RBRACK] = ACTIONS(6513),
    [anon_sym_EQ] = ACTIONS(6511),
    [anon_sym_QMARK] = ACTIONS(6513),
    [anon_sym_STAR_EQ] = ACTIONS(6513),
    [anon_sym_SLASH_EQ] = ACTIONS(6513),
    [anon_sym_PERCENT_EQ] = ACTIONS(6513),
    [anon_sym_PLUS_EQ] = ACTIONS(6513),
    [anon_sym_DASH_EQ] = ACTIONS(6513),
    [anon_sym_LT_LT_EQ] = ACTIONS(6513),
    [anon_sym_GT_GT_EQ] = ACTIONS(6513),
    [anon_sym_AMP_EQ] = ACTIONS(6513),
    [anon_sym_CARET_EQ] = ACTIONS(6513),
    [anon_sym_PIPE_EQ] = ACTIONS(6513),
    [anon_sym_and_eq] = ACTIONS(6511),
    [anon_sym_or_eq] = ACTIONS(6511),
    [anon_sym_xor_eq] = ACTIONS(6511),
    [anon_sym_LT_EQ_GT] = ACTIONS(6513),
    [anon_sym_or] = ACTIONS(6511),
    [anon_sym_and] = ACTIONS(6511),
    [anon_sym_bitor] = ACTIONS(6511),
    [anon_sym_xor] = ACTIONS(6511),
    [anon_sym_bitand] = ACTIONS(6511),
    [anon_sym_not_eq] = ACTIONS(6511),
    [anon_sym_is] = ACTIONS(6511),
    [anon_sym_as] = ACTIONS(6511),
    [anon_sym_DASH_DASH] = ACTIONS(6513),
    [anon_sym_PLUS_PLUS] = ACTIONS(6513),
    [anon_sym_DOT] = ACTIONS(6511),
    [anon_sym_DOT_STAR] = ACTIONS(6513),
    [anon_sym_DASH_GT] = ACTIONS(6513),
    [anon_sym_L_DQUOTE] = ACTIONS(6513),
    [anon_sym_u_DQUOTE] = ACTIONS(6513),
    [anon_sym_U_DQUOTE] = ACTIONS(6513),
    [anon_sym_u8_DQUOTE] = ACTIONS(6513),
    [anon_sym_DQUOTE] = ACTIONS(6513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6513),
    [anon_sym_LR_DQUOTE] = ACTIONS(6513),
    [anon_sym_uR_DQUOTE] = ACTIONS(6513),
    [anon_sym_UR_DQUOTE] = ACTIONS(6513),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6513),
    [sym_literal_suffix] = ACTIONS(6511),
  },
  [2869] = {
    [sym_template_argument_list] = STATE(2910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2173),
    [anon_sym_COMMA] = ACTIONS(2173),
    [anon_sym_LPAREN2] = ACTIONS(2173),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2171),
    [anon_sym_AMP_AMP] = ACTIONS(2173),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2171),
    [anon_sym_BANG_EQ] = ACTIONS(2171),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2181),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(6515),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(2169),
    [anon_sym___extension__] = ACTIONS(2176),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2176),
    [anon_sym_LBRACK] = ACTIONS(2173),
    [anon_sym_EQ] = ACTIONS(2178),
    [anon_sym_const] = ACTIONS(2169),
    [anon_sym_constexpr] = ACTIONS(2176),
    [anon_sym_volatile] = ACTIONS(2176),
    [anon_sym_restrict] = ACTIONS(2176),
    [anon_sym___restrict__] = ACTIONS(2176),
    [anon_sym__Atomic] = ACTIONS(2176),
    [anon_sym__Noreturn] = ACTIONS(2176),
    [anon_sym_noreturn] = ACTIONS(2176),
    [anon_sym_mutable] = ACTIONS(2176),
    [anon_sym_constinit] = ACTIONS(2176),
    [anon_sym_consteval] = ACTIONS(2176),
    [anon_sym_alignas] = ACTIONS(2176),
    [anon_sym__Alignas] = ACTIONS(2176),
    [anon_sym_QMARK] = ACTIONS(2171),
    [anon_sym_STAR_EQ] = ACTIONS(2171),
    [anon_sym_SLASH_EQ] = ACTIONS(2171),
    [anon_sym_PERCENT_EQ] = ACTIONS(2171),
    [anon_sym_PLUS_EQ] = ACTIONS(2171),
    [anon_sym_DASH_EQ] = ACTIONS(2171),
    [anon_sym_LT_LT_EQ] = ACTIONS(2171),
    [anon_sym_GT_GT_EQ] = ACTIONS(2181),
    [anon_sym_AMP_EQ] = ACTIONS(2171),
    [anon_sym_CARET_EQ] = ACTIONS(2171),
    [anon_sym_PIPE_EQ] = ACTIONS(2171),
    [anon_sym_and_eq] = ACTIONS(2171),
    [anon_sym_or_eq] = ACTIONS(2171),
    [anon_sym_xor_eq] = ACTIONS(2171),
    [anon_sym_LT_EQ_GT] = ACTIONS(2171),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2171),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2171),
    [anon_sym_not_eq] = ACTIONS(2171),
    [anon_sym_is] = ACTIONS(2171),
    [anon_sym_as] = ACTIONS(2171),
    [anon_sym_DASH_DASH] = ACTIONS(2171),
    [anon_sym_PLUS_PLUS] = ACTIONS(2171),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DOT_STAR] = ACTIONS(2171),
    [anon_sym_DASH_GT] = ACTIONS(2171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2176),
    [anon_sym_let] = ACTIONS(2176),
    [anon_sym_This] = ACTIONS(2176),
    [anon_sym_GT2] = ACTIONS(2173),
  },
  [2870] = {
    [sym_template_argument_list] = STATE(2921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2171),
    [anon_sym_COMMA] = ACTIONS(2171),
    [anon_sym_RPAREN] = ACTIONS(2173),
    [anon_sym_LPAREN2] = ACTIONS(2173),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2171),
    [anon_sym_AMP_AMP] = ACTIONS(2173),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2171),
    [anon_sym_BANG_EQ] = ACTIONS(2171),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2171),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(6518),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym___extension__] = ACTIONS(2176),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2176),
    [anon_sym_LBRACK] = ACTIONS(2173),
    [anon_sym_EQ] = ACTIONS(2181),
    [anon_sym_const] = ACTIONS(2169),
    [anon_sym_constexpr] = ACTIONS(2176),
    [anon_sym_volatile] = ACTIONS(2176),
    [anon_sym_restrict] = ACTIONS(2176),
    [anon_sym___restrict__] = ACTIONS(2176),
    [anon_sym__Atomic] = ACTIONS(2176),
    [anon_sym__Noreturn] = ACTIONS(2176),
    [anon_sym_noreturn] = ACTIONS(2176),
    [anon_sym_mutable] = ACTIONS(2176),
    [anon_sym_constinit] = ACTIONS(2176),
    [anon_sym_consteval] = ACTIONS(2176),
    [anon_sym_alignas] = ACTIONS(2176),
    [anon_sym__Alignas] = ACTIONS(2176),
    [anon_sym_QMARK] = ACTIONS(2171),
    [anon_sym_STAR_EQ] = ACTIONS(2171),
    [anon_sym_SLASH_EQ] = ACTIONS(2171),
    [anon_sym_PERCENT_EQ] = ACTIONS(2171),
    [anon_sym_PLUS_EQ] = ACTIONS(2171),
    [anon_sym_DASH_EQ] = ACTIONS(2171),
    [anon_sym_LT_LT_EQ] = ACTIONS(2171),
    [anon_sym_GT_GT_EQ] = ACTIONS(2171),
    [anon_sym_AMP_EQ] = ACTIONS(2171),
    [anon_sym_CARET_EQ] = ACTIONS(2171),
    [anon_sym_PIPE_EQ] = ACTIONS(2171),
    [anon_sym_and_eq] = ACTIONS(2171),
    [anon_sym_or_eq] = ACTIONS(2171),
    [anon_sym_xor_eq] = ACTIONS(2171),
    [anon_sym_LT_EQ_GT] = ACTIONS(2171),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2171),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2171),
    [anon_sym_not_eq] = ACTIONS(2171),
    [anon_sym_is] = ACTIONS(2171),
    [anon_sym_as] = ACTIONS(2171),
    [anon_sym_DASH_DASH] = ACTIONS(2171),
    [anon_sym_PLUS_PLUS] = ACTIONS(2171),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DOT_STAR] = ACTIONS(2171),
    [anon_sym_DASH_GT] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2176),
    [anon_sym_let] = ACTIONS(2176),
    [anon_sym_This] = ACTIONS(2176),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2171),
  },
  [2871] = {
    [sym_identifier] = ACTIONS(2244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(2246),
    [anon_sym_RPAREN] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2244),
    [anon_sym_PLUS] = ACTIONS(2244),
    [anon_sym_STAR] = ACTIONS(2246),
    [anon_sym_SLASH] = ACTIONS(2244),
    [anon_sym_PERCENT] = ACTIONS(2246),
    [anon_sym_PIPE_PIPE] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2244),
    [anon_sym_CARET] = ACTIONS(2246),
    [anon_sym_AMP] = ACTIONS(2244),
    [anon_sym_EQ_EQ] = ACTIONS(2246),
    [anon_sym_BANG_EQ] = ACTIONS(2246),
    [anon_sym_GT] = ACTIONS(2244),
    [anon_sym_GT_EQ] = ACTIONS(2246),
    [anon_sym_LT_EQ] = ACTIONS(2244),
    [anon_sym_LT] = ACTIONS(2244),
    [anon_sym_LT_LT] = ACTIONS(2246),
    [anon_sym_GT_GT] = ACTIONS(2246),
    [anon_sym_COLON] = ACTIONS(2244),
    [anon_sym_SEMI] = ACTIONS(2246),
    [anon_sym___extension__] = ACTIONS(2244),
    [anon_sym___attribute__] = ACTIONS(2244),
    [anon_sym_COLON_COLON] = ACTIONS(2246),
    [anon_sym___based] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_RBRACE] = ACTIONS(2246),
    [anon_sym_signed] = ACTIONS(2244),
    [anon_sym_unsigned] = ACTIONS(2244),
    [anon_sym_long] = ACTIONS(2244),
    [anon_sym_short] = ACTIONS(2244),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_RBRACK] = ACTIONS(2246),
    [anon_sym_const] = ACTIONS(2244),
    [anon_sym_constexpr] = ACTIONS(2244),
    [anon_sym_volatile] = ACTIONS(2244),
    [anon_sym_restrict] = ACTIONS(2244),
    [anon_sym___restrict__] = ACTIONS(2244),
    [anon_sym__Atomic] = ACTIONS(2244),
    [anon_sym__Noreturn] = ACTIONS(2244),
    [anon_sym_noreturn] = ACTIONS(2244),
    [anon_sym_mutable] = ACTIONS(2244),
    [anon_sym_constinit] = ACTIONS(2244),
    [anon_sym_consteval] = ACTIONS(2244),
    [anon_sym_alignas] = ACTIONS(2244),
    [anon_sym__Alignas] = ACTIONS(2244),
    [sym_primitive_type] = ACTIONS(2244),
    [anon_sym_QMARK] = ACTIONS(2246),
    [anon_sym_LT_EQ_GT] = ACTIONS(2246),
    [anon_sym_or] = ACTIONS(2244),
    [anon_sym_and] = ACTIONS(2244),
    [anon_sym_bitor] = ACTIONS(2244),
    [anon_sym_xor] = ACTIONS(2244),
    [anon_sym_bitand] = ACTIONS(2244),
    [anon_sym_not_eq] = ACTIONS(2244),
    [anon_sym_is] = ACTIONS(2244),
    [anon_sym_as] = ACTIONS(2244),
    [anon_sym_DASH_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_PLUS] = ACTIONS(2246),
    [anon_sym_DOT] = ACTIONS(2244),
    [anon_sym_DOT_STAR] = ACTIONS(2246),
    [anon_sym_DASH_GT] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2244),
    [anon_sym_let] = ACTIONS(2244),
    [anon_sym_This] = ACTIONS(2244),
    [anon_sym_final] = ACTIONS(2244),
    [anon_sym_override] = ACTIONS(2244),
    [anon_sym_requires] = ACTIONS(2244),
    [anon_sym_where] = ACTIONS(2244),
  },
  [2872] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2872),
    [sym_identifier] = ACTIONS(2856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2854),
    [anon_sym_COMMA] = ACTIONS(2854),
    [anon_sym_RPAREN] = ACTIONS(2854),
    [aux_sym_preproc_if_token2] = ACTIONS(2854),
    [aux_sym_preproc_else_token1] = ACTIONS(2854),
    [aux_sym_preproc_elif_token1] = ACTIONS(2856),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2854),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2854),
    [anon_sym_LPAREN2] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(2856),
    [anon_sym_PLUS] = ACTIONS(2856),
    [anon_sym_STAR] = ACTIONS(2856),
    [anon_sym_SLASH] = ACTIONS(2856),
    [anon_sym_PERCENT] = ACTIONS(2856),
    [anon_sym_PIPE_PIPE] = ACTIONS(2854),
    [anon_sym_AMP_AMP] = ACTIONS(2854),
    [anon_sym_PIPE] = ACTIONS(2856),
    [anon_sym_CARET] = ACTIONS(2856),
    [anon_sym_AMP] = ACTIONS(2856),
    [anon_sym_EQ_EQ] = ACTIONS(2854),
    [anon_sym_BANG_EQ] = ACTIONS(2854),
    [anon_sym_GT] = ACTIONS(2856),
    [anon_sym_GT_EQ] = ACTIONS(2854),
    [anon_sym_LT_EQ] = ACTIONS(2856),
    [anon_sym_LT] = ACTIONS(2856),
    [anon_sym_LT_LT] = ACTIONS(2856),
    [anon_sym_GT_GT] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2854),
    [anon_sym_SEMI] = ACTIONS(2854),
    [anon_sym___attribute__] = ACTIONS(2856),
    [anon_sym_LBRACE] = ACTIONS(2854),
    [anon_sym_RBRACE] = ACTIONS(2854),
    [anon_sym_signed] = ACTIONS(6521),
    [anon_sym_unsigned] = ACTIONS(6521),
    [anon_sym_long] = ACTIONS(6521),
    [anon_sym_short] = ACTIONS(6521),
    [anon_sym_LBRACK] = ACTIONS(2854),
    [anon_sym_RBRACK] = ACTIONS(2854),
    [anon_sym_EQ] = ACTIONS(2856),
    [sym_primitive_type] = ACTIONS(2856),
    [anon_sym_QMARK] = ACTIONS(2854),
    [anon_sym_STAR_EQ] = ACTIONS(2854),
    [anon_sym_SLASH_EQ] = ACTIONS(2854),
    [anon_sym_PERCENT_EQ] = ACTIONS(2854),
    [anon_sym_PLUS_EQ] = ACTIONS(2854),
    [anon_sym_DASH_EQ] = ACTIONS(2854),
    [anon_sym_LT_LT_EQ] = ACTIONS(2854),
    [anon_sym_GT_GT_EQ] = ACTIONS(2854),
    [anon_sym_AMP_EQ] = ACTIONS(2854),
    [anon_sym_CARET_EQ] = ACTIONS(2854),
    [anon_sym_PIPE_EQ] = ACTIONS(2854),
    [anon_sym_and_eq] = ACTIONS(2856),
    [anon_sym_or_eq] = ACTIONS(2856),
    [anon_sym_xor_eq] = ACTIONS(2856),
    [anon_sym_LT_EQ_GT] = ACTIONS(2854),
    [anon_sym_or] = ACTIONS(2856),
    [anon_sym_and] = ACTIONS(2856),
    [anon_sym_bitor] = ACTIONS(2856),
    [anon_sym_xor] = ACTIONS(2856),
    [anon_sym_bitand] = ACTIONS(2856),
    [anon_sym_not_eq] = ACTIONS(2856),
    [anon_sym_is] = ACTIONS(2856),
    [anon_sym_as] = ACTIONS(2856),
    [anon_sym_DASH_DASH] = ACTIONS(2854),
    [anon_sym_PLUS_PLUS] = ACTIONS(2854),
    [anon_sym_DOT] = ACTIONS(2856),
    [anon_sym_DOT_STAR] = ACTIONS(2854),
    [anon_sym_DASH_GT] = ACTIONS(2854),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2856),
    [anon_sym_let] = ACTIONS(2856),
    [anon_sym_This] = ACTIONS(2856),
  },
  [2873] = {
    [sym_identifier] = ACTIONS(2363),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2361),
    [anon_sym_COMMA] = ACTIONS(2361),
    [anon_sym_RPAREN] = ACTIONS(2361),
    [anon_sym_LPAREN2] = ACTIONS(2361),
    [anon_sym_DASH] = ACTIONS(2363),
    [anon_sym_PLUS] = ACTIONS(2363),
    [anon_sym_STAR] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(2363),
    [anon_sym_PERCENT] = ACTIONS(2361),
    [anon_sym_PIPE_PIPE] = ACTIONS(2361),
    [anon_sym_AMP_AMP] = ACTIONS(2361),
    [anon_sym_PIPE] = ACTIONS(2363),
    [anon_sym_CARET] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(2363),
    [anon_sym_EQ_EQ] = ACTIONS(2361),
    [anon_sym_BANG_EQ] = ACTIONS(2361),
    [anon_sym_GT] = ACTIONS(2363),
    [anon_sym_GT_EQ] = ACTIONS(2361),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2363),
    [anon_sym_LT_LT] = ACTIONS(2361),
    [anon_sym_GT_GT] = ACTIONS(2361),
    [anon_sym_COLON] = ACTIONS(2363),
    [anon_sym_SEMI] = ACTIONS(2361),
    [anon_sym___extension__] = ACTIONS(2363),
    [anon_sym___attribute__] = ACTIONS(2363),
    [anon_sym_COLON_COLON] = ACTIONS(2361),
    [anon_sym___based] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_RBRACE] = ACTIONS(2361),
    [anon_sym_signed] = ACTIONS(2363),
    [anon_sym_unsigned] = ACTIONS(2363),
    [anon_sym_long] = ACTIONS(2363),
    [anon_sym_short] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_RBRACK] = ACTIONS(2361),
    [anon_sym_const] = ACTIONS(2363),
    [anon_sym_constexpr] = ACTIONS(2363),
    [anon_sym_volatile] = ACTIONS(2363),
    [anon_sym_restrict] = ACTIONS(2363),
    [anon_sym___restrict__] = ACTIONS(2363),
    [anon_sym__Atomic] = ACTIONS(2363),
    [anon_sym__Noreturn] = ACTIONS(2363),
    [anon_sym_noreturn] = ACTIONS(2363),
    [anon_sym_mutable] = ACTIONS(2363),
    [anon_sym_constinit] = ACTIONS(2363),
    [anon_sym_consteval] = ACTIONS(2363),
    [anon_sym_alignas] = ACTIONS(2363),
    [anon_sym__Alignas] = ACTIONS(2363),
    [sym_primitive_type] = ACTIONS(2363),
    [anon_sym_QMARK] = ACTIONS(2361),
    [anon_sym_LT_EQ_GT] = ACTIONS(2361),
    [anon_sym_or] = ACTIONS(2363),
    [anon_sym_and] = ACTIONS(2363),
    [anon_sym_bitor] = ACTIONS(2363),
    [anon_sym_xor] = ACTIONS(2363),
    [anon_sym_bitand] = ACTIONS(2363),
    [anon_sym_not_eq] = ACTIONS(2363),
    [anon_sym_is] = ACTIONS(2363),
    [anon_sym_as] = ACTIONS(2363),
    [anon_sym_DASH_DASH] = ACTIONS(2361),
    [anon_sym_PLUS_PLUS] = ACTIONS(2361),
    [anon_sym_DOT] = ACTIONS(2363),
    [anon_sym_DOT_STAR] = ACTIONS(2361),
    [anon_sym_DASH_GT] = ACTIONS(2361),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2363),
    [anon_sym_let] = ACTIONS(2363),
    [anon_sym_This] = ACTIONS(2363),
    [anon_sym_final] = ACTIONS(2363),
    [anon_sym_override] = ACTIONS(2363),
    [anon_sym_requires] = ACTIONS(2363),
    [anon_sym_where] = ACTIONS(2363),
  },
  [2874] = {
    [sym_identifier] = ACTIONS(2232),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_COMMA] = ACTIONS(2234),
    [anon_sym_RPAREN] = ACTIONS(2234),
    [anon_sym_LPAREN2] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2232),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2232),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_PIPE_PIPE] = ACTIONS(2234),
    [anon_sym_AMP_AMP] = ACTIONS(2234),
    [anon_sym_PIPE] = ACTIONS(2232),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2232),
    [anon_sym_EQ_EQ] = ACTIONS(2234),
    [anon_sym_BANG_EQ] = ACTIONS(2234),
    [anon_sym_GT] = ACTIONS(2232),
    [anon_sym_GT_EQ] = ACTIONS(2234),
    [anon_sym_LT_EQ] = ACTIONS(2232),
    [anon_sym_LT] = ACTIONS(2232),
    [anon_sym_LT_LT] = ACTIONS(2234),
    [anon_sym_GT_GT] = ACTIONS(2234),
    [anon_sym_COLON] = ACTIONS(2232),
    [anon_sym_SEMI] = ACTIONS(2234),
    [anon_sym___extension__] = ACTIONS(2232),
    [anon_sym___attribute__] = ACTIONS(2232),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym___based] = ACTIONS(2232),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_RBRACE] = ACTIONS(2234),
    [anon_sym_signed] = ACTIONS(2232),
    [anon_sym_unsigned] = ACTIONS(2232),
    [anon_sym_long] = ACTIONS(2232),
    [anon_sym_short] = ACTIONS(2232),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_RBRACK] = ACTIONS(2234),
    [anon_sym_const] = ACTIONS(2232),
    [anon_sym_constexpr] = ACTIONS(2232),
    [anon_sym_volatile] = ACTIONS(2232),
    [anon_sym_restrict] = ACTIONS(2232),
    [anon_sym___restrict__] = ACTIONS(2232),
    [anon_sym__Atomic] = ACTIONS(2232),
    [anon_sym__Noreturn] = ACTIONS(2232),
    [anon_sym_noreturn] = ACTIONS(2232),
    [anon_sym_mutable] = ACTIONS(2232),
    [anon_sym_constinit] = ACTIONS(2232),
    [anon_sym_consteval] = ACTIONS(2232),
    [anon_sym_alignas] = ACTIONS(2232),
    [anon_sym__Alignas] = ACTIONS(2232),
    [sym_primitive_type] = ACTIONS(2232),
    [anon_sym_QMARK] = ACTIONS(2234),
    [anon_sym_LT_EQ_GT] = ACTIONS(2234),
    [anon_sym_or] = ACTIONS(2232),
    [anon_sym_and] = ACTIONS(2232),
    [anon_sym_bitor] = ACTIONS(2232),
    [anon_sym_xor] = ACTIONS(2232),
    [anon_sym_bitand] = ACTIONS(2232),
    [anon_sym_not_eq] = ACTIONS(2232),
    [anon_sym_is] = ACTIONS(2232),
    [anon_sym_as] = ACTIONS(2232),
    [anon_sym_DASH_DASH] = ACTIONS(2234),
    [anon_sym_PLUS_PLUS] = ACTIONS(2234),
    [anon_sym_DOT] = ACTIONS(2232),
    [anon_sym_DOT_STAR] = ACTIONS(2234),
    [anon_sym_DASH_GT] = ACTIONS(2234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2232),
    [anon_sym_let] = ACTIONS(2232),
    [anon_sym_This] = ACTIONS(2232),
    [anon_sym_final] = ACTIONS(2232),
    [anon_sym_override] = ACTIONS(2232),
    [anon_sym_requires] = ACTIONS(2232),
    [anon_sym_where] = ACTIONS(2232),
  },
  [2875] = {
    [sym_identifier] = ACTIONS(2202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_RPAREN] = ACTIONS(2204),
    [anon_sym_LPAREN2] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2202),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_STAR] = ACTIONS(2204),
    [anon_sym_SLASH] = ACTIONS(2202),
    [anon_sym_PERCENT] = ACTIONS(2204),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2202),
    [anon_sym_CARET] = ACTIONS(2204),
    [anon_sym_AMP] = ACTIONS(2202),
    [anon_sym_EQ_EQ] = ACTIONS(2204),
    [anon_sym_BANG_EQ] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(2202),
    [anon_sym_GT_EQ] = ACTIONS(2204),
    [anon_sym_LT_EQ] = ACTIONS(2202),
    [anon_sym_LT] = ACTIONS(2202),
    [anon_sym_LT_LT] = ACTIONS(2204),
    [anon_sym_GT_GT] = ACTIONS(2204),
    [anon_sym_COLON] = ACTIONS(2202),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym___extension__] = ACTIONS(2202),
    [anon_sym___attribute__] = ACTIONS(2202),
    [anon_sym_COLON_COLON] = ACTIONS(2204),
    [anon_sym___based] = ACTIONS(2202),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_signed] = ACTIONS(2202),
    [anon_sym_unsigned] = ACTIONS(2202),
    [anon_sym_long] = ACTIONS(2202),
    [anon_sym_short] = ACTIONS(2202),
    [anon_sym_LBRACK] = ACTIONS(2204),
    [anon_sym_RBRACK] = ACTIONS(2204),
    [anon_sym_const] = ACTIONS(2202),
    [anon_sym_constexpr] = ACTIONS(2202),
    [anon_sym_volatile] = ACTIONS(2202),
    [anon_sym_restrict] = ACTIONS(2202),
    [anon_sym___restrict__] = ACTIONS(2202),
    [anon_sym__Atomic] = ACTIONS(2202),
    [anon_sym__Noreturn] = ACTIONS(2202),
    [anon_sym_noreturn] = ACTIONS(2202),
    [anon_sym_mutable] = ACTIONS(2202),
    [anon_sym_constinit] = ACTIONS(2202),
    [anon_sym_consteval] = ACTIONS(2202),
    [anon_sym_alignas] = ACTIONS(2202),
    [anon_sym__Alignas] = ACTIONS(2202),
    [sym_primitive_type] = ACTIONS(2202),
    [anon_sym_QMARK] = ACTIONS(2204),
    [anon_sym_LT_EQ_GT] = ACTIONS(2204),
    [anon_sym_or] = ACTIONS(2202),
    [anon_sym_and] = ACTIONS(2202),
    [anon_sym_bitor] = ACTIONS(2202),
    [anon_sym_xor] = ACTIONS(2202),
    [anon_sym_bitand] = ACTIONS(2202),
    [anon_sym_not_eq] = ACTIONS(2202),
    [anon_sym_is] = ACTIONS(2202),
    [anon_sym_as] = ACTIONS(2202),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(2202),
    [anon_sym_DOT_STAR] = ACTIONS(2204),
    [anon_sym_DASH_GT] = ACTIONS(2204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2202),
    [anon_sym_let] = ACTIONS(2202),
    [anon_sym_This] = ACTIONS(2202),
    [anon_sym_final] = ACTIONS(2202),
    [anon_sym_override] = ACTIONS(2202),
    [anon_sym_requires] = ACTIONS(2202),
    [anon_sym_where] = ACTIONS(2202),
  },
  [2876] = {
    [sym_identifier] = ACTIONS(2194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2196),
    [anon_sym_COMMA] = ACTIONS(2196),
    [anon_sym_RPAREN] = ACTIONS(2196),
    [anon_sym_LPAREN2] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2194),
    [anon_sym_PLUS] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(2196),
    [anon_sym_SLASH] = ACTIONS(2194),
    [anon_sym_PERCENT] = ACTIONS(2196),
    [anon_sym_PIPE_PIPE] = ACTIONS(2196),
    [anon_sym_AMP_AMP] = ACTIONS(2196),
    [anon_sym_PIPE] = ACTIONS(2194),
    [anon_sym_CARET] = ACTIONS(2196),
    [anon_sym_AMP] = ACTIONS(2194),
    [anon_sym_EQ_EQ] = ACTIONS(2196),
    [anon_sym_BANG_EQ] = ACTIONS(2196),
    [anon_sym_GT] = ACTIONS(2194),
    [anon_sym_GT_EQ] = ACTIONS(2196),
    [anon_sym_LT_EQ] = ACTIONS(2194),
    [anon_sym_LT] = ACTIONS(2194),
    [anon_sym_LT_LT] = ACTIONS(2196),
    [anon_sym_GT_GT] = ACTIONS(2196),
    [anon_sym_COLON] = ACTIONS(2194),
    [anon_sym_SEMI] = ACTIONS(2196),
    [anon_sym___extension__] = ACTIONS(2194),
    [anon_sym___attribute__] = ACTIONS(2194),
    [anon_sym_COLON_COLON] = ACTIONS(2196),
    [anon_sym___based] = ACTIONS(2194),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_RBRACE] = ACTIONS(2196),
    [anon_sym_signed] = ACTIONS(2194),
    [anon_sym_unsigned] = ACTIONS(2194),
    [anon_sym_long] = ACTIONS(2194),
    [anon_sym_short] = ACTIONS(2194),
    [anon_sym_LBRACK] = ACTIONS(2196),
    [anon_sym_RBRACK] = ACTIONS(2196),
    [anon_sym_const] = ACTIONS(2194),
    [anon_sym_constexpr] = ACTIONS(2194),
    [anon_sym_volatile] = ACTIONS(2194),
    [anon_sym_restrict] = ACTIONS(2194),
    [anon_sym___restrict__] = ACTIONS(2194),
    [anon_sym__Atomic] = ACTIONS(2194),
    [anon_sym__Noreturn] = ACTIONS(2194),
    [anon_sym_noreturn] = ACTIONS(2194),
    [anon_sym_mutable] = ACTIONS(2194),
    [anon_sym_constinit] = ACTIONS(2194),
    [anon_sym_consteval] = ACTIONS(2194),
    [anon_sym_alignas] = ACTIONS(2194),
    [anon_sym__Alignas] = ACTIONS(2194),
    [sym_primitive_type] = ACTIONS(2194),
    [anon_sym_QMARK] = ACTIONS(2196),
    [anon_sym_LT_EQ_GT] = ACTIONS(2196),
    [anon_sym_or] = ACTIONS(2194),
    [anon_sym_and] = ACTIONS(2194),
    [anon_sym_bitor] = ACTIONS(2194),
    [anon_sym_xor] = ACTIONS(2194),
    [anon_sym_bitand] = ACTIONS(2194),
    [anon_sym_not_eq] = ACTIONS(2194),
    [anon_sym_is] = ACTIONS(2194),
    [anon_sym_as] = ACTIONS(2194),
    [anon_sym_DASH_DASH] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2196),
    [anon_sym_DOT] = ACTIONS(2194),
    [anon_sym_DOT_STAR] = ACTIONS(2196),
    [anon_sym_DASH_GT] = ACTIONS(2196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2194),
    [anon_sym_let] = ACTIONS(2194),
    [anon_sym_This] = ACTIONS(2194),
    [anon_sym_final] = ACTIONS(2194),
    [anon_sym_override] = ACTIONS(2194),
    [anon_sym_requires] = ACTIONS(2194),
    [anon_sym_where] = ACTIONS(2194),
  },
  [2877] = {
    [sym_identifier] = ACTIONS(2206),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2208),
    [anon_sym_COMMA] = ACTIONS(2208),
    [anon_sym_RPAREN] = ACTIONS(2208),
    [anon_sym_LPAREN2] = ACTIONS(2208),
    [anon_sym_DASH] = ACTIONS(2206),
    [anon_sym_PLUS] = ACTIONS(2206),
    [anon_sym_STAR] = ACTIONS(2208),
    [anon_sym_SLASH] = ACTIONS(2206),
    [anon_sym_PERCENT] = ACTIONS(2208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2208),
    [anon_sym_AMP_AMP] = ACTIONS(2208),
    [anon_sym_PIPE] = ACTIONS(2206),
    [anon_sym_CARET] = ACTIONS(2208),
    [anon_sym_AMP] = ACTIONS(2206),
    [anon_sym_EQ_EQ] = ACTIONS(2208),
    [anon_sym_BANG_EQ] = ACTIONS(2208),
    [anon_sym_GT] = ACTIONS(2206),
    [anon_sym_GT_EQ] = ACTIONS(2208),
    [anon_sym_LT_EQ] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2206),
    [anon_sym_LT_LT] = ACTIONS(2208),
    [anon_sym_GT_GT] = ACTIONS(2208),
    [anon_sym_COLON] = ACTIONS(2206),
    [anon_sym_SEMI] = ACTIONS(2208),
    [anon_sym___extension__] = ACTIONS(2206),
    [anon_sym___attribute__] = ACTIONS(2206),
    [anon_sym_COLON_COLON] = ACTIONS(2208),
    [anon_sym___based] = ACTIONS(2206),
    [anon_sym_LBRACE] = ACTIONS(2208),
    [anon_sym_RBRACE] = ACTIONS(2208),
    [anon_sym_signed] = ACTIONS(2206),
    [anon_sym_unsigned] = ACTIONS(2206),
    [anon_sym_long] = ACTIONS(2206),
    [anon_sym_short] = ACTIONS(2206),
    [anon_sym_LBRACK] = ACTIONS(2208),
    [anon_sym_RBRACK] = ACTIONS(2208),
    [anon_sym_const] = ACTIONS(2206),
    [anon_sym_constexpr] = ACTIONS(2206),
    [anon_sym_volatile] = ACTIONS(2206),
    [anon_sym_restrict] = ACTIONS(2206),
    [anon_sym___restrict__] = ACTIONS(2206),
    [anon_sym__Atomic] = ACTIONS(2206),
    [anon_sym__Noreturn] = ACTIONS(2206),
    [anon_sym_noreturn] = ACTIONS(2206),
    [anon_sym_mutable] = ACTIONS(2206),
    [anon_sym_constinit] = ACTIONS(2206),
    [anon_sym_consteval] = ACTIONS(2206),
    [anon_sym_alignas] = ACTIONS(2206),
    [anon_sym__Alignas] = ACTIONS(2206),
    [sym_primitive_type] = ACTIONS(2206),
    [anon_sym_QMARK] = ACTIONS(2208),
    [anon_sym_LT_EQ_GT] = ACTIONS(2208),
    [anon_sym_or] = ACTIONS(2206),
    [anon_sym_and] = ACTIONS(2206),
    [anon_sym_bitor] = ACTIONS(2206),
    [anon_sym_xor] = ACTIONS(2206),
    [anon_sym_bitand] = ACTIONS(2206),
    [anon_sym_not_eq] = ACTIONS(2206),
    [anon_sym_is] = ACTIONS(2206),
    [anon_sym_as] = ACTIONS(2206),
    [anon_sym_DASH_DASH] = ACTIONS(2208),
    [anon_sym_PLUS_PLUS] = ACTIONS(2208),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_DOT_STAR] = ACTIONS(2208),
    [anon_sym_DASH_GT] = ACTIONS(2208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2206),
    [anon_sym_let] = ACTIONS(2206),
    [anon_sym_This] = ACTIONS(2206),
    [anon_sym_final] = ACTIONS(2206),
    [anon_sym_override] = ACTIONS(2206),
    [anon_sym_requires] = ACTIONS(2206),
    [anon_sym_where] = ACTIONS(2206),
  },
  [2878] = {
    [sym_identifier] = ACTIONS(2240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2242),
    [anon_sym_RPAREN] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2240),
    [anon_sym_PLUS] = ACTIONS(2240),
    [anon_sym_STAR] = ACTIONS(2242),
    [anon_sym_SLASH] = ACTIONS(2240),
    [anon_sym_PERCENT] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_PIPE] = ACTIONS(2240),
    [anon_sym_CARET] = ACTIONS(2242),
    [anon_sym_AMP] = ACTIONS(2240),
    [anon_sym_EQ_EQ] = ACTIONS(2242),
    [anon_sym_BANG_EQ] = ACTIONS(2242),
    [anon_sym_GT] = ACTIONS(2240),
    [anon_sym_GT_EQ] = ACTIONS(2242),
    [anon_sym_LT_EQ] = ACTIONS(2240),
    [anon_sym_LT] = ACTIONS(2240),
    [anon_sym_LT_LT] = ACTIONS(2242),
    [anon_sym_GT_GT] = ACTIONS(2242),
    [anon_sym_COLON] = ACTIONS(2240),
    [anon_sym_SEMI] = ACTIONS(2242),
    [anon_sym___extension__] = ACTIONS(2240),
    [anon_sym___attribute__] = ACTIONS(2240),
    [anon_sym_COLON_COLON] = ACTIONS(2242),
    [anon_sym___based] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_RBRACE] = ACTIONS(2242),
    [anon_sym_signed] = ACTIONS(2240),
    [anon_sym_unsigned] = ACTIONS(2240),
    [anon_sym_long] = ACTIONS(2240),
    [anon_sym_short] = ACTIONS(2240),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_RBRACK] = ACTIONS(2242),
    [anon_sym_const] = ACTIONS(2240),
    [anon_sym_constexpr] = ACTIONS(2240),
    [anon_sym_volatile] = ACTIONS(2240),
    [anon_sym_restrict] = ACTIONS(2240),
    [anon_sym___restrict__] = ACTIONS(2240),
    [anon_sym__Atomic] = ACTIONS(2240),
    [anon_sym__Noreturn] = ACTIONS(2240),
    [anon_sym_noreturn] = ACTIONS(2240),
    [anon_sym_mutable] = ACTIONS(2240),
    [anon_sym_constinit] = ACTIONS(2240),
    [anon_sym_consteval] = ACTIONS(2240),
    [anon_sym_alignas] = ACTIONS(2240),
    [anon_sym__Alignas] = ACTIONS(2240),
    [sym_primitive_type] = ACTIONS(2240),
    [anon_sym_QMARK] = ACTIONS(2242),
    [anon_sym_LT_EQ_GT] = ACTIONS(2242),
    [anon_sym_or] = ACTIONS(2240),
    [anon_sym_and] = ACTIONS(2240),
    [anon_sym_bitor] = ACTIONS(2240),
    [anon_sym_xor] = ACTIONS(2240),
    [anon_sym_bitand] = ACTIONS(2240),
    [anon_sym_not_eq] = ACTIONS(2240),
    [anon_sym_is] = ACTIONS(2240),
    [anon_sym_as] = ACTIONS(2240),
    [anon_sym_DASH_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_PLUS] = ACTIONS(2242),
    [anon_sym_DOT] = ACTIONS(2240),
    [anon_sym_DOT_STAR] = ACTIONS(2242),
    [anon_sym_DASH_GT] = ACTIONS(2242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2240),
    [anon_sym_let] = ACTIONS(2240),
    [anon_sym_This] = ACTIONS(2240),
    [anon_sym_final] = ACTIONS(2240),
    [anon_sym_override] = ACTIONS(2240),
    [anon_sym_requires] = ACTIONS(2240),
    [anon_sym_where] = ACTIONS(2240),
  },
  [2879] = {
    [sym_identifier] = ACTIONS(2236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2238),
    [anon_sym_COMMA] = ACTIONS(2238),
    [anon_sym_RPAREN] = ACTIONS(2238),
    [anon_sym_LPAREN2] = ACTIONS(2238),
    [anon_sym_DASH] = ACTIONS(2236),
    [anon_sym_PLUS] = ACTIONS(2236),
    [anon_sym_STAR] = ACTIONS(2238),
    [anon_sym_SLASH] = ACTIONS(2236),
    [anon_sym_PERCENT] = ACTIONS(2238),
    [anon_sym_PIPE_PIPE] = ACTIONS(2238),
    [anon_sym_AMP_AMP] = ACTIONS(2238),
    [anon_sym_PIPE] = ACTIONS(2236),
    [anon_sym_CARET] = ACTIONS(2238),
    [anon_sym_AMP] = ACTIONS(2236),
    [anon_sym_EQ_EQ] = ACTIONS(2238),
    [anon_sym_BANG_EQ] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2236),
    [anon_sym_GT_EQ] = ACTIONS(2238),
    [anon_sym_LT_EQ] = ACTIONS(2236),
    [anon_sym_LT] = ACTIONS(2236),
    [anon_sym_LT_LT] = ACTIONS(2238),
    [anon_sym_GT_GT] = ACTIONS(2238),
    [anon_sym_COLON] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(2238),
    [anon_sym___extension__] = ACTIONS(2236),
    [anon_sym___attribute__] = ACTIONS(2236),
    [anon_sym_COLON_COLON] = ACTIONS(2238),
    [anon_sym___based] = ACTIONS(2236),
    [anon_sym_LBRACE] = ACTIONS(2238),
    [anon_sym_RBRACE] = ACTIONS(2238),
    [anon_sym_signed] = ACTIONS(2236),
    [anon_sym_unsigned] = ACTIONS(2236),
    [anon_sym_long] = ACTIONS(2236),
    [anon_sym_short] = ACTIONS(2236),
    [anon_sym_LBRACK] = ACTIONS(2238),
    [anon_sym_RBRACK] = ACTIONS(2238),
    [anon_sym_const] = ACTIONS(2236),
    [anon_sym_constexpr] = ACTIONS(2236),
    [anon_sym_volatile] = ACTIONS(2236),
    [anon_sym_restrict] = ACTIONS(2236),
    [anon_sym___restrict__] = ACTIONS(2236),
    [anon_sym__Atomic] = ACTIONS(2236),
    [anon_sym__Noreturn] = ACTIONS(2236),
    [anon_sym_noreturn] = ACTIONS(2236),
    [anon_sym_mutable] = ACTIONS(2236),
    [anon_sym_constinit] = ACTIONS(2236),
    [anon_sym_consteval] = ACTIONS(2236),
    [anon_sym_alignas] = ACTIONS(2236),
    [anon_sym__Alignas] = ACTIONS(2236),
    [sym_primitive_type] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_LT_EQ_GT] = ACTIONS(2238),
    [anon_sym_or] = ACTIONS(2236),
    [anon_sym_and] = ACTIONS(2236),
    [anon_sym_bitor] = ACTIONS(2236),
    [anon_sym_xor] = ACTIONS(2236),
    [anon_sym_bitand] = ACTIONS(2236),
    [anon_sym_not_eq] = ACTIONS(2236),
    [anon_sym_is] = ACTIONS(2236),
    [anon_sym_as] = ACTIONS(2236),
    [anon_sym_DASH_DASH] = ACTIONS(2238),
    [anon_sym_PLUS_PLUS] = ACTIONS(2238),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_DOT_STAR] = ACTIONS(2238),
    [anon_sym_DASH_GT] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2236),
    [anon_sym_let] = ACTIONS(2236),
    [anon_sym_This] = ACTIONS(2236),
    [anon_sym_final] = ACTIONS(2236),
    [anon_sym_override] = ACTIONS(2236),
    [anon_sym_requires] = ACTIONS(2236),
    [anon_sym_where] = ACTIONS(2236),
  },
  [2880] = {
    [sym_identifier] = ACTIONS(2224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2226),
    [anon_sym_COMMA] = ACTIONS(2226),
    [anon_sym_RPAREN] = ACTIONS(2226),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_PLUS] = ACTIONS(2224),
    [anon_sym_STAR] = ACTIONS(2226),
    [anon_sym_SLASH] = ACTIONS(2224),
    [anon_sym_PERCENT] = ACTIONS(2226),
    [anon_sym_PIPE_PIPE] = ACTIONS(2226),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_PIPE] = ACTIONS(2224),
    [anon_sym_CARET] = ACTIONS(2226),
    [anon_sym_AMP] = ACTIONS(2224),
    [anon_sym_EQ_EQ] = ACTIONS(2226),
    [anon_sym_BANG_EQ] = ACTIONS(2226),
    [anon_sym_GT] = ACTIONS(2224),
    [anon_sym_GT_EQ] = ACTIONS(2226),
    [anon_sym_LT_EQ] = ACTIONS(2224),
    [anon_sym_LT] = ACTIONS(2224),
    [anon_sym_LT_LT] = ACTIONS(2226),
    [anon_sym_GT_GT] = ACTIONS(2226),
    [anon_sym_COLON] = ACTIONS(2224),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym___extension__] = ACTIONS(2224),
    [anon_sym___attribute__] = ACTIONS(2224),
    [anon_sym_COLON_COLON] = ACTIONS(2226),
    [anon_sym___based] = ACTIONS(2224),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_RBRACE] = ACTIONS(2226),
    [anon_sym_signed] = ACTIONS(2224),
    [anon_sym_unsigned] = ACTIONS(2224),
    [anon_sym_long] = ACTIONS(2224),
    [anon_sym_short] = ACTIONS(2224),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_RBRACK] = ACTIONS(2226),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_constexpr] = ACTIONS(2224),
    [anon_sym_volatile] = ACTIONS(2224),
    [anon_sym_restrict] = ACTIONS(2224),
    [anon_sym___restrict__] = ACTIONS(2224),
    [anon_sym__Atomic] = ACTIONS(2224),
    [anon_sym__Noreturn] = ACTIONS(2224),
    [anon_sym_noreturn] = ACTIONS(2224),
    [anon_sym_mutable] = ACTIONS(2224),
    [anon_sym_constinit] = ACTIONS(2224),
    [anon_sym_consteval] = ACTIONS(2224),
    [anon_sym_alignas] = ACTIONS(2224),
    [anon_sym__Alignas] = ACTIONS(2224),
    [sym_primitive_type] = ACTIONS(2224),
    [anon_sym_QMARK] = ACTIONS(2226),
    [anon_sym_LT_EQ_GT] = ACTIONS(2226),
    [anon_sym_or] = ACTIONS(2224),
    [anon_sym_and] = ACTIONS(2224),
    [anon_sym_bitor] = ACTIONS(2224),
    [anon_sym_xor] = ACTIONS(2224),
    [anon_sym_bitand] = ACTIONS(2224),
    [anon_sym_not_eq] = ACTIONS(2224),
    [anon_sym_is] = ACTIONS(2224),
    [anon_sym_as] = ACTIONS(2224),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_DOT] = ACTIONS(2224),
    [anon_sym_DOT_STAR] = ACTIONS(2226),
    [anon_sym_DASH_GT] = ACTIONS(2226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2224),
    [anon_sym_let] = ACTIONS(2224),
    [anon_sym_This] = ACTIONS(2224),
    [anon_sym_final] = ACTIONS(2224),
    [anon_sym_override] = ACTIONS(2224),
    [anon_sym_requires] = ACTIONS(2224),
    [anon_sym_where] = ACTIONS(2224),
  },
  [2881] = {
    [sym_identifier] = ACTIONS(6524),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6526),
    [anon_sym_COMMA] = ACTIONS(6526),
    [anon_sym_RPAREN] = ACTIONS(6526),
    [aux_sym_preproc_if_token2] = ACTIONS(6526),
    [aux_sym_preproc_else_token1] = ACTIONS(6526),
    [aux_sym_preproc_elif_token1] = ACTIONS(6524),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6526),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6526),
    [anon_sym_LPAREN2] = ACTIONS(6526),
    [anon_sym_DASH] = ACTIONS(6524),
    [anon_sym_PLUS] = ACTIONS(6524),
    [anon_sym_STAR] = ACTIONS(6524),
    [anon_sym_SLASH] = ACTIONS(6524),
    [anon_sym_PERCENT] = ACTIONS(6524),
    [anon_sym_PIPE_PIPE] = ACTIONS(6526),
    [anon_sym_AMP_AMP] = ACTIONS(6526),
    [anon_sym_PIPE] = ACTIONS(6524),
    [anon_sym_CARET] = ACTIONS(6524),
    [anon_sym_AMP] = ACTIONS(6524),
    [anon_sym_EQ_EQ] = ACTIONS(6526),
    [anon_sym_BANG_EQ] = ACTIONS(6526),
    [anon_sym_GT] = ACTIONS(6524),
    [anon_sym_GT_EQ] = ACTIONS(6526),
    [anon_sym_LT_EQ] = ACTIONS(6524),
    [anon_sym_LT] = ACTIONS(6524),
    [anon_sym_LT_LT] = ACTIONS(6524),
    [anon_sym_GT_GT] = ACTIONS(6524),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_SEMI] = ACTIONS(6526),
    [anon_sym_RBRACE] = ACTIONS(6526),
    [anon_sym_LBRACK] = ACTIONS(6526),
    [anon_sym_RBRACK] = ACTIONS(6526),
    [anon_sym_EQ] = ACTIONS(6524),
    [anon_sym_QMARK] = ACTIONS(6526),
    [anon_sym_STAR_EQ] = ACTIONS(6526),
    [anon_sym_SLASH_EQ] = ACTIONS(6526),
    [anon_sym_PERCENT_EQ] = ACTIONS(6526),
    [anon_sym_PLUS_EQ] = ACTIONS(6526),
    [anon_sym_DASH_EQ] = ACTIONS(6526),
    [anon_sym_LT_LT_EQ] = ACTIONS(6526),
    [anon_sym_GT_GT_EQ] = ACTIONS(6526),
    [anon_sym_AMP_EQ] = ACTIONS(6526),
    [anon_sym_CARET_EQ] = ACTIONS(6526),
    [anon_sym_PIPE_EQ] = ACTIONS(6526),
    [anon_sym_and_eq] = ACTIONS(6524),
    [anon_sym_or_eq] = ACTIONS(6524),
    [anon_sym_xor_eq] = ACTIONS(6524),
    [anon_sym_LT_EQ_GT] = ACTIONS(6526),
    [anon_sym_or] = ACTIONS(6524),
    [anon_sym_and] = ACTIONS(6524),
    [anon_sym_bitor] = ACTIONS(6524),
    [anon_sym_xor] = ACTIONS(6524),
    [anon_sym_bitand] = ACTIONS(6524),
    [anon_sym_not_eq] = ACTIONS(6524),
    [anon_sym_is] = ACTIONS(6524),
    [anon_sym_as] = ACTIONS(6524),
    [anon_sym_DASH_DASH] = ACTIONS(6526),
    [anon_sym_PLUS_PLUS] = ACTIONS(6526),
    [anon_sym_DOT] = ACTIONS(6524),
    [anon_sym_DOT_STAR] = ACTIONS(6526),
    [anon_sym_DASH_GT] = ACTIONS(6526),
    [anon_sym_L_DQUOTE] = ACTIONS(6526),
    [anon_sym_u_DQUOTE] = ACTIONS(6526),
    [anon_sym_U_DQUOTE] = ACTIONS(6526),
    [anon_sym_u8_DQUOTE] = ACTIONS(6526),
    [anon_sym_DQUOTE] = ACTIONS(6526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6526),
    [anon_sym_LR_DQUOTE] = ACTIONS(6526),
    [anon_sym_uR_DQUOTE] = ACTIONS(6526),
    [anon_sym_UR_DQUOTE] = ACTIONS(6526),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6526),
    [sym_literal_suffix] = ACTIONS(6524),
  },
  [2882] = {
    [sym_template_argument_list] = STATE(2944),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2639),
    [sym_identifier] = ACTIONS(2115),
    [anon_sym_LPAREN2] = ACTIONS(2140),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_AMP_AMP] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2115),
    [anon_sym_LT] = ACTIONS(6343),
    [anon_sym_SEMI] = ACTIONS(6165),
    [anon_sym___extension__] = ACTIONS(2115),
    [anon_sym_in] = ACTIONS(2115),
    [anon_sym_out] = ACTIONS(2115),
    [anon_sym_inout] = ACTIONS(2115),
    [anon_sym_extern] = ACTIONS(2115),
    [anon_sym___attribute__] = ACTIONS(2115),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2140),
    [anon_sym___declspec] = ACTIONS(2115),
    [anon_sym___based] = ACTIONS(2115),
    [anon_sym_signed] = ACTIONS(4863),
    [anon_sym_unsigned] = ACTIONS(4863),
    [anon_sym_long] = ACTIONS(4863),
    [anon_sym_short] = ACTIONS(4863),
    [anon_sym_LBRACK] = ACTIONS(6345),
    [anon_sym_static] = ACTIONS(2115),
    [anon_sym_register] = ACTIONS(2115),
    [anon_sym_inline] = ACTIONS(2115),
    [anon_sym___inline] = ACTIONS(2115),
    [anon_sym___inline__] = ACTIONS(2115),
    [anon_sym___forceinline] = ACTIONS(2115),
    [anon_sym_thread_local] = ACTIONS(2115),
    [anon_sym___thread] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(2115),
    [anon_sym_constexpr] = ACTIONS(2115),
    [anon_sym_volatile] = ACTIONS(2115),
    [anon_sym_restrict] = ACTIONS(2115),
    [anon_sym___restrict__] = ACTIONS(2115),
    [anon_sym__Atomic] = ACTIONS(2115),
    [anon_sym__Noreturn] = ACTIONS(2115),
    [anon_sym_noreturn] = ACTIONS(2115),
    [anon_sym_mutable] = ACTIONS(2115),
    [anon_sym_constinit] = ACTIONS(2115),
    [anon_sym_consteval] = ACTIONS(2115),
    [anon_sym_alignas] = ACTIONS(2115),
    [anon_sym__Alignas] = ACTIONS(2115),
    [anon_sym_DOT] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2115),
    [anon_sym_let] = ACTIONS(2115),
    [anon_sym_This] = ACTIONS(2115),
    [anon_sym_decltype] = ACTIONS(2115),
    [sym_virtual] = ACTIONS(2115),
    [anon_sym_template] = ACTIONS(2115),
    [anon_sym_operator] = ACTIONS(2115),
    [anon_sym_precise] = ACTIONS(2115),
    [anon_sym_shared] = ACTIONS(2115),
    [anon_sym_groupshared] = ACTIONS(2115),
    [anon_sym_uniform] = ACTIONS(2115),
    [anon_sym_row_major] = ACTIONS(2115),
    [anon_sym_column_major] = ACTIONS(2115),
    [anon_sym_globallycoherent] = ACTIONS(2115),
    [anon_sym_centroid] = ACTIONS(2115),
    [anon_sym_noperspective] = ACTIONS(2115),
    [anon_sym_nointerpolation] = ACTIONS(2115),
    [anon_sym_sample] = ACTIONS(2115),
    [anon_sym_linear] = ACTIONS(2115),
    [anon_sym_snorm] = ACTIONS(2115),
    [anon_sym_unorm] = ACTIONS(2115),
    [anon_sym_point] = ACTIONS(2115),
    [anon_sym_line] = ACTIONS(2115),
    [anon_sym_triangleadj] = ACTIONS(2115),
    [anon_sym_lineadj] = ACTIONS(2115),
    [anon_sym_triangle] = ACTIONS(2115),
  },
  [2883] = {
    [sym_identifier] = ACTIONS(2826),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2824),
    [anon_sym_COMMA] = ACTIONS(2824),
    [anon_sym_RPAREN] = ACTIONS(2824),
    [anon_sym_LPAREN2] = ACTIONS(2824),
    [anon_sym_DASH] = ACTIONS(2826),
    [anon_sym_PLUS] = ACTIONS(2826),
    [anon_sym_STAR] = ACTIONS(2824),
    [anon_sym_SLASH] = ACTIONS(2826),
    [anon_sym_PERCENT] = ACTIONS(2824),
    [anon_sym_PIPE_PIPE] = ACTIONS(2824),
    [anon_sym_AMP_AMP] = ACTIONS(2824),
    [anon_sym_PIPE] = ACTIONS(2826),
    [anon_sym_CARET] = ACTIONS(2824),
    [anon_sym_AMP] = ACTIONS(2826),
    [anon_sym_EQ_EQ] = ACTIONS(2824),
    [anon_sym_BANG_EQ] = ACTIONS(2824),
    [anon_sym_GT] = ACTIONS(2826),
    [anon_sym_GT_EQ] = ACTIONS(2824),
    [anon_sym_LT_EQ] = ACTIONS(2826),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_LT_LT] = ACTIONS(2824),
    [anon_sym_GT_GT] = ACTIONS(2824),
    [anon_sym_COLON] = ACTIONS(2826),
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym___extension__] = ACTIONS(2826),
    [anon_sym___attribute__] = ACTIONS(2826),
    [anon_sym_COLON_COLON] = ACTIONS(2824),
    [anon_sym___based] = ACTIONS(2826),
    [anon_sym_LBRACE] = ACTIONS(2824),
    [anon_sym_RBRACE] = ACTIONS(2824),
    [anon_sym_signed] = ACTIONS(2826),
    [anon_sym_unsigned] = ACTIONS(2826),
    [anon_sym_long] = ACTIONS(2826),
    [anon_sym_short] = ACTIONS(2826),
    [anon_sym_LBRACK] = ACTIONS(2824),
    [anon_sym_RBRACK] = ACTIONS(2824),
    [anon_sym_const] = ACTIONS(2826),
    [anon_sym_constexpr] = ACTIONS(2826),
    [anon_sym_volatile] = ACTIONS(2826),
    [anon_sym_restrict] = ACTIONS(2826),
    [anon_sym___restrict__] = ACTIONS(2826),
    [anon_sym__Atomic] = ACTIONS(2826),
    [anon_sym__Noreturn] = ACTIONS(2826),
    [anon_sym_noreturn] = ACTIONS(2826),
    [anon_sym_mutable] = ACTIONS(2826),
    [anon_sym_constinit] = ACTIONS(2826),
    [anon_sym_consteval] = ACTIONS(2826),
    [anon_sym_alignas] = ACTIONS(2826),
    [anon_sym__Alignas] = ACTIONS(2826),
    [sym_primitive_type] = ACTIONS(2826),
    [anon_sym_QMARK] = ACTIONS(2824),
    [anon_sym_LT_EQ_GT] = ACTIONS(2824),
    [anon_sym_or] = ACTIONS(2826),
    [anon_sym_and] = ACTIONS(2826),
    [anon_sym_bitor] = ACTIONS(2826),
    [anon_sym_xor] = ACTIONS(2826),
    [anon_sym_bitand] = ACTIONS(2826),
    [anon_sym_not_eq] = ACTIONS(2826),
    [anon_sym_is] = ACTIONS(2826),
    [anon_sym_as] = ACTIONS(2826),
    [anon_sym_DASH_DASH] = ACTIONS(2824),
    [anon_sym_PLUS_PLUS] = ACTIONS(2824),
    [anon_sym_DOT] = ACTIONS(2826),
    [anon_sym_DOT_STAR] = ACTIONS(2824),
    [anon_sym_DASH_GT] = ACTIONS(2824),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2826),
    [anon_sym_let] = ACTIONS(2826),
    [anon_sym_This] = ACTIONS(2826),
    [anon_sym_final] = ACTIONS(2826),
    [anon_sym_override] = ACTIONS(2826),
    [anon_sym_requires] = ACTIONS(2826),
    [anon_sym_where] = ACTIONS(2826),
  },
  [2884] = {
    [sym_identifier] = ACTIONS(6431),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6433),
    [anon_sym_COMMA] = ACTIONS(6433),
    [anon_sym_RPAREN] = ACTIONS(6433),
    [aux_sym_preproc_if_token2] = ACTIONS(6433),
    [aux_sym_preproc_else_token1] = ACTIONS(6433),
    [aux_sym_preproc_elif_token1] = ACTIONS(6431),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6433),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6433),
    [anon_sym_LPAREN2] = ACTIONS(6433),
    [anon_sym_DASH] = ACTIONS(6431),
    [anon_sym_PLUS] = ACTIONS(6431),
    [anon_sym_STAR] = ACTIONS(6431),
    [anon_sym_SLASH] = ACTIONS(6431),
    [anon_sym_PERCENT] = ACTIONS(6431),
    [anon_sym_PIPE_PIPE] = ACTIONS(6433),
    [anon_sym_AMP_AMP] = ACTIONS(6433),
    [anon_sym_PIPE] = ACTIONS(6431),
    [anon_sym_CARET] = ACTIONS(6431),
    [anon_sym_AMP] = ACTIONS(6431),
    [anon_sym_EQ_EQ] = ACTIONS(6433),
    [anon_sym_BANG_EQ] = ACTIONS(6433),
    [anon_sym_GT] = ACTIONS(6431),
    [anon_sym_GT_EQ] = ACTIONS(6433),
    [anon_sym_LT_EQ] = ACTIONS(6431),
    [anon_sym_LT] = ACTIONS(6431),
    [anon_sym_LT_LT] = ACTIONS(6431),
    [anon_sym_GT_GT] = ACTIONS(6431),
    [anon_sym_COLON] = ACTIONS(6433),
    [anon_sym_SEMI] = ACTIONS(6433),
    [anon_sym_RBRACE] = ACTIONS(6433),
    [anon_sym_LBRACK] = ACTIONS(6433),
    [anon_sym_RBRACK] = ACTIONS(6433),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_QMARK] = ACTIONS(6433),
    [anon_sym_STAR_EQ] = ACTIONS(6433),
    [anon_sym_SLASH_EQ] = ACTIONS(6433),
    [anon_sym_PERCENT_EQ] = ACTIONS(6433),
    [anon_sym_PLUS_EQ] = ACTIONS(6433),
    [anon_sym_DASH_EQ] = ACTIONS(6433),
    [anon_sym_LT_LT_EQ] = ACTIONS(6433),
    [anon_sym_GT_GT_EQ] = ACTIONS(6433),
    [anon_sym_AMP_EQ] = ACTIONS(6433),
    [anon_sym_CARET_EQ] = ACTIONS(6433),
    [anon_sym_PIPE_EQ] = ACTIONS(6433),
    [anon_sym_and_eq] = ACTIONS(6431),
    [anon_sym_or_eq] = ACTIONS(6431),
    [anon_sym_xor_eq] = ACTIONS(6431),
    [anon_sym_LT_EQ_GT] = ACTIONS(6433),
    [anon_sym_or] = ACTIONS(6431),
    [anon_sym_and] = ACTIONS(6431),
    [anon_sym_bitor] = ACTIONS(6431),
    [anon_sym_xor] = ACTIONS(6431),
    [anon_sym_bitand] = ACTIONS(6431),
    [anon_sym_not_eq] = ACTIONS(6431),
    [anon_sym_is] = ACTIONS(6431),
    [anon_sym_as] = ACTIONS(6431),
    [anon_sym_DASH_DASH] = ACTIONS(6433),
    [anon_sym_PLUS_PLUS] = ACTIONS(6433),
    [anon_sym_DOT] = ACTIONS(6431),
    [anon_sym_DOT_STAR] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6433),
    [anon_sym_L_DQUOTE] = ACTIONS(6433),
    [anon_sym_u_DQUOTE] = ACTIONS(6433),
    [anon_sym_U_DQUOTE] = ACTIONS(6433),
    [anon_sym_u8_DQUOTE] = ACTIONS(6433),
    [anon_sym_DQUOTE] = ACTIONS(6433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6433),
    [anon_sym_LR_DQUOTE] = ACTIONS(6433),
    [anon_sym_uR_DQUOTE] = ACTIONS(6433),
    [anon_sym_UR_DQUOTE] = ACTIONS(6433),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6433),
    [sym_literal_suffix] = ACTIONS(6431),
  },
  [2885] = {
    [sym_identifier] = ACTIONS(2248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_RPAREN] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2248),
    [anon_sym_PLUS] = ACTIONS(2248),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_SLASH] = ACTIONS(2248),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2248),
    [anon_sym_EQ_EQ] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_GT] = ACTIONS(2248),
    [anon_sym_GT_EQ] = ACTIONS(2250),
    [anon_sym_LT_EQ] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_LT_LT] = ACTIONS(2250),
    [anon_sym_GT_GT] = ACTIONS(2250),
    [anon_sym_COLON] = ACTIONS(2248),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym___extension__] = ACTIONS(2248),
    [anon_sym___attribute__] = ACTIONS(2248),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym___based] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_signed] = ACTIONS(2248),
    [anon_sym_unsigned] = ACTIONS(2248),
    [anon_sym_long] = ACTIONS(2248),
    [anon_sym_short] = ACTIONS(2248),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_RBRACK] = ACTIONS(2250),
    [anon_sym_const] = ACTIONS(2248),
    [anon_sym_constexpr] = ACTIONS(2248),
    [anon_sym_volatile] = ACTIONS(2248),
    [anon_sym_restrict] = ACTIONS(2248),
    [anon_sym___restrict__] = ACTIONS(2248),
    [anon_sym__Atomic] = ACTIONS(2248),
    [anon_sym__Noreturn] = ACTIONS(2248),
    [anon_sym_noreturn] = ACTIONS(2248),
    [anon_sym_mutable] = ACTIONS(2248),
    [anon_sym_constinit] = ACTIONS(2248),
    [anon_sym_consteval] = ACTIONS(2248),
    [anon_sym_alignas] = ACTIONS(2248),
    [anon_sym__Alignas] = ACTIONS(2248),
    [sym_primitive_type] = ACTIONS(2248),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_LT_EQ_GT] = ACTIONS(2250),
    [anon_sym_or] = ACTIONS(2248),
    [anon_sym_and] = ACTIONS(2248),
    [anon_sym_bitor] = ACTIONS(2248),
    [anon_sym_xor] = ACTIONS(2248),
    [anon_sym_bitand] = ACTIONS(2248),
    [anon_sym_not_eq] = ACTIONS(2248),
    [anon_sym_is] = ACTIONS(2248),
    [anon_sym_as] = ACTIONS(2248),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2248),
    [anon_sym_DOT_STAR] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2248),
    [anon_sym_let] = ACTIONS(2248),
    [anon_sym_This] = ACTIONS(2248),
    [anon_sym_final] = ACTIONS(2248),
    [anon_sym_override] = ACTIONS(2248),
    [anon_sym_requires] = ACTIONS(2248),
    [anon_sym_where] = ACTIONS(2248),
  },
  [2886] = {
    [sym_identifier] = ACTIONS(3054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3052),
    [anon_sym_COMMA] = ACTIONS(3052),
    [anon_sym_RPAREN] = ACTIONS(3052),
    [anon_sym_LPAREN2] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3054),
    [anon_sym_PLUS] = ACTIONS(3054),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_SLASH] = ACTIONS(3054),
    [anon_sym_PERCENT] = ACTIONS(3052),
    [anon_sym_PIPE_PIPE] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_PIPE] = ACTIONS(3054),
    [anon_sym_CARET] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3054),
    [anon_sym_EQ_EQ] = ACTIONS(3052),
    [anon_sym_BANG_EQ] = ACTIONS(3052),
    [anon_sym_GT] = ACTIONS(3054),
    [anon_sym_GT_EQ] = ACTIONS(3052),
    [anon_sym_LT_EQ] = ACTIONS(3054),
    [anon_sym_LT] = ACTIONS(3054),
    [anon_sym_LT_LT] = ACTIONS(3052),
    [anon_sym_GT_GT] = ACTIONS(3052),
    [anon_sym_COLON] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym___extension__] = ACTIONS(3054),
    [anon_sym___attribute__] = ACTIONS(3054),
    [anon_sym___based] = ACTIONS(3054),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_RBRACE] = ACTIONS(3052),
    [anon_sym_signed] = ACTIONS(3054),
    [anon_sym_unsigned] = ACTIONS(3054),
    [anon_sym_long] = ACTIONS(3054),
    [anon_sym_short] = ACTIONS(3054),
    [anon_sym_LBRACK] = ACTIONS(3052),
    [anon_sym_RBRACK] = ACTIONS(3052),
    [anon_sym_const] = ACTIONS(3054),
    [anon_sym_constexpr] = ACTIONS(3054),
    [anon_sym_volatile] = ACTIONS(3054),
    [anon_sym_restrict] = ACTIONS(3054),
    [anon_sym___restrict__] = ACTIONS(3054),
    [anon_sym__Atomic] = ACTIONS(3054),
    [anon_sym__Noreturn] = ACTIONS(3054),
    [anon_sym_noreturn] = ACTIONS(3054),
    [anon_sym_mutable] = ACTIONS(3054),
    [anon_sym_constinit] = ACTIONS(3054),
    [anon_sym_consteval] = ACTIONS(3054),
    [anon_sym_alignas] = ACTIONS(3054),
    [anon_sym__Alignas] = ACTIONS(3054),
    [sym_primitive_type] = ACTIONS(3054),
    [anon_sym_QMARK] = ACTIONS(3052),
    [anon_sym_LT_EQ_GT] = ACTIONS(3052),
    [anon_sym_or] = ACTIONS(3054),
    [anon_sym_and] = ACTIONS(3054),
    [anon_sym_bitor] = ACTIONS(3054),
    [anon_sym_xor] = ACTIONS(3054),
    [anon_sym_bitand] = ACTIONS(3054),
    [anon_sym_not_eq] = ACTIONS(3054),
    [anon_sym_is] = ACTIONS(3054),
    [anon_sym_as] = ACTIONS(3054),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_DOT] = ACTIONS(3054),
    [anon_sym_DOT_STAR] = ACTIONS(3052),
    [anon_sym_DASH_GT] = ACTIONS(3052),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3054),
    [anon_sym_let] = ACTIONS(3054),
    [anon_sym_This] = ACTIONS(3054),
    [anon_sym_final] = ACTIONS(3054),
    [anon_sym_override] = ACTIONS(3054),
    [anon_sym_requires] = ACTIONS(3054),
    [anon_sym_where] = ACTIONS(3054),
  },
  [2887] = {
    [sym_identifier] = ACTIONS(3400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3398),
    [anon_sym_COMMA] = ACTIONS(3398),
    [anon_sym_RPAREN] = ACTIONS(3398),
    [anon_sym_LPAREN2] = ACTIONS(3398),
    [anon_sym_DASH] = ACTIONS(3400),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_STAR] = ACTIONS(3398),
    [anon_sym_SLASH] = ACTIONS(3400),
    [anon_sym_PERCENT] = ACTIONS(3398),
    [anon_sym_PIPE_PIPE] = ACTIONS(3398),
    [anon_sym_AMP_AMP] = ACTIONS(3398),
    [anon_sym_PIPE] = ACTIONS(3400),
    [anon_sym_CARET] = ACTIONS(3398),
    [anon_sym_AMP] = ACTIONS(3400),
    [anon_sym_EQ_EQ] = ACTIONS(3398),
    [anon_sym_BANG_EQ] = ACTIONS(3398),
    [anon_sym_GT] = ACTIONS(3400),
    [anon_sym_GT_EQ] = ACTIONS(3398),
    [anon_sym_LT_EQ] = ACTIONS(3400),
    [anon_sym_LT] = ACTIONS(3400),
    [anon_sym_LT_LT] = ACTIONS(3398),
    [anon_sym_GT_GT] = ACTIONS(3398),
    [anon_sym_COLON] = ACTIONS(3398),
    [anon_sym_SEMI] = ACTIONS(3398),
    [anon_sym___extension__] = ACTIONS(3400),
    [anon_sym___attribute__] = ACTIONS(3400),
    [anon_sym___based] = ACTIONS(3400),
    [anon_sym_LBRACE] = ACTIONS(3398),
    [anon_sym_RBRACE] = ACTIONS(3398),
    [anon_sym_signed] = ACTIONS(3400),
    [anon_sym_unsigned] = ACTIONS(3400),
    [anon_sym_long] = ACTIONS(3400),
    [anon_sym_short] = ACTIONS(3400),
    [anon_sym_LBRACK] = ACTIONS(3398),
    [anon_sym_RBRACK] = ACTIONS(3398),
    [anon_sym_const] = ACTIONS(3400),
    [anon_sym_constexpr] = ACTIONS(3400),
    [anon_sym_volatile] = ACTIONS(3400),
    [anon_sym_restrict] = ACTIONS(3400),
    [anon_sym___restrict__] = ACTIONS(3400),
    [anon_sym__Atomic] = ACTIONS(3400),
    [anon_sym__Noreturn] = ACTIONS(3400),
    [anon_sym_noreturn] = ACTIONS(3400),
    [anon_sym_mutable] = ACTIONS(3400),
    [anon_sym_constinit] = ACTIONS(3400),
    [anon_sym_consteval] = ACTIONS(3400),
    [anon_sym_alignas] = ACTIONS(3400),
    [anon_sym__Alignas] = ACTIONS(3400),
    [sym_primitive_type] = ACTIONS(3400),
    [anon_sym_QMARK] = ACTIONS(3398),
    [anon_sym_LT_EQ_GT] = ACTIONS(3398),
    [anon_sym_or] = ACTIONS(3400),
    [anon_sym_and] = ACTIONS(3400),
    [anon_sym_bitor] = ACTIONS(3400),
    [anon_sym_xor] = ACTIONS(3400),
    [anon_sym_bitand] = ACTIONS(3400),
    [anon_sym_not_eq] = ACTIONS(3400),
    [anon_sym_is] = ACTIONS(3400),
    [anon_sym_as] = ACTIONS(3400),
    [anon_sym_DASH_DASH] = ACTIONS(3398),
    [anon_sym_PLUS_PLUS] = ACTIONS(3398),
    [anon_sym_DOT] = ACTIONS(3400),
    [anon_sym_DOT_STAR] = ACTIONS(3398),
    [anon_sym_DASH_GT] = ACTIONS(3398),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3400),
    [anon_sym_let] = ACTIONS(3400),
    [anon_sym_This] = ACTIONS(3400),
    [anon_sym_final] = ACTIONS(3400),
    [anon_sym_override] = ACTIONS(3400),
    [anon_sym_requires] = ACTIONS(3400),
    [anon_sym_where] = ACTIONS(3400),
  },
  [2888] = {
    [sym_identifier] = ACTIONS(2742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2740),
    [anon_sym_COMMA] = ACTIONS(2740),
    [anon_sym_RPAREN] = ACTIONS(2740),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2742),
    [anon_sym_PLUS] = ACTIONS(2742),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_SLASH] = ACTIONS(2742),
    [anon_sym_PERCENT] = ACTIONS(2740),
    [anon_sym_PIPE_PIPE] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_PIPE] = ACTIONS(2742),
    [anon_sym_CARET] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_EQ_EQ] = ACTIONS(2740),
    [anon_sym_BANG_EQ] = ACTIONS(2740),
    [anon_sym_GT] = ACTIONS(2742),
    [anon_sym_GT_EQ] = ACTIONS(2740),
    [anon_sym_LT_EQ] = ACTIONS(2742),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_LT_LT] = ACTIONS(2740),
    [anon_sym_GT_GT] = ACTIONS(2740),
    [anon_sym_COLON] = ACTIONS(2740),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym___extension__] = ACTIONS(2742),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym___based] = ACTIONS(2742),
    [anon_sym_LBRACE] = ACTIONS(2740),
    [anon_sym_RBRACE] = ACTIONS(2740),
    [anon_sym_signed] = ACTIONS(2742),
    [anon_sym_unsigned] = ACTIONS(2742),
    [anon_sym_long] = ACTIONS(2742),
    [anon_sym_short] = ACTIONS(2742),
    [anon_sym_LBRACK] = ACTIONS(2740),
    [anon_sym_RBRACK] = ACTIONS(2740),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_constexpr] = ACTIONS(2742),
    [anon_sym_volatile] = ACTIONS(2742),
    [anon_sym_restrict] = ACTIONS(2742),
    [anon_sym___restrict__] = ACTIONS(2742),
    [anon_sym__Atomic] = ACTIONS(2742),
    [anon_sym__Noreturn] = ACTIONS(2742),
    [anon_sym_noreturn] = ACTIONS(2742),
    [anon_sym_mutable] = ACTIONS(2742),
    [anon_sym_constinit] = ACTIONS(2742),
    [anon_sym_consteval] = ACTIONS(2742),
    [anon_sym_alignas] = ACTIONS(2742),
    [anon_sym__Alignas] = ACTIONS(2742),
    [sym_primitive_type] = ACTIONS(2742),
    [anon_sym_QMARK] = ACTIONS(2740),
    [anon_sym_LT_EQ_GT] = ACTIONS(2740),
    [anon_sym_or] = ACTIONS(2742),
    [anon_sym_and] = ACTIONS(2742),
    [anon_sym_bitor] = ACTIONS(2742),
    [anon_sym_xor] = ACTIONS(2742),
    [anon_sym_bitand] = ACTIONS(2742),
    [anon_sym_not_eq] = ACTIONS(2742),
    [anon_sym_is] = ACTIONS(2742),
    [anon_sym_as] = ACTIONS(2742),
    [anon_sym_DASH_DASH] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2740),
    [anon_sym_DOT] = ACTIONS(2742),
    [anon_sym_DOT_STAR] = ACTIONS(2740),
    [anon_sym_DASH_GT] = ACTIONS(2740),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
    [anon_sym_final] = ACTIONS(2742),
    [anon_sym_override] = ACTIONS(2742),
    [anon_sym_requires] = ACTIONS(2742),
    [anon_sym_where] = ACTIONS(2742),
  },
  [2889] = {
    [sym_identifier] = ACTIONS(3082),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3080),
    [anon_sym_COMMA] = ACTIONS(3080),
    [anon_sym_RPAREN] = ACTIONS(3080),
    [anon_sym_LPAREN2] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_STAR] = ACTIONS(3080),
    [anon_sym_SLASH] = ACTIONS(3082),
    [anon_sym_PERCENT] = ACTIONS(3080),
    [anon_sym_PIPE_PIPE] = ACTIONS(3080),
    [anon_sym_AMP_AMP] = ACTIONS(3080),
    [anon_sym_PIPE] = ACTIONS(3082),
    [anon_sym_CARET] = ACTIONS(3080),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym_EQ_EQ] = ACTIONS(3080),
    [anon_sym_BANG_EQ] = ACTIONS(3080),
    [anon_sym_GT] = ACTIONS(3082),
    [anon_sym_GT_EQ] = ACTIONS(3080),
    [anon_sym_LT_EQ] = ACTIONS(3082),
    [anon_sym_LT] = ACTIONS(3082),
    [anon_sym_LT_LT] = ACTIONS(3080),
    [anon_sym_GT_GT] = ACTIONS(3080),
    [anon_sym_COLON] = ACTIONS(3080),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3080),
    [anon_sym_RBRACE] = ACTIONS(3080),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3080),
    [anon_sym_RBRACK] = ACTIONS(3080),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym__Alignas] = ACTIONS(3082),
    [sym_primitive_type] = ACTIONS(3082),
    [anon_sym_QMARK] = ACTIONS(3080),
    [anon_sym_LT_EQ_GT] = ACTIONS(3080),
    [anon_sym_or] = ACTIONS(3082),
    [anon_sym_and] = ACTIONS(3082),
    [anon_sym_bitor] = ACTIONS(3082),
    [anon_sym_xor] = ACTIONS(3082),
    [anon_sym_bitand] = ACTIONS(3082),
    [anon_sym_not_eq] = ACTIONS(3082),
    [anon_sym_is] = ACTIONS(3082),
    [anon_sym_as] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3080),
    [anon_sym_PLUS_PLUS] = ACTIONS(3080),
    [anon_sym_DOT] = ACTIONS(3082),
    [anon_sym_DOT_STAR] = ACTIONS(3080),
    [anon_sym_DASH_GT] = ACTIONS(3080),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3082),
    [anon_sym_let] = ACTIONS(3082),
    [anon_sym_This] = ACTIONS(3082),
    [anon_sym_final] = ACTIONS(3082),
    [anon_sym_override] = ACTIONS(3082),
    [anon_sym_requires] = ACTIONS(3082),
    [anon_sym_where] = ACTIONS(3082),
  },
  [2890] = {
    [sym_identifier] = ACTIONS(3054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3052),
    [anon_sym_COMMA] = ACTIONS(3052),
    [anon_sym_RPAREN] = ACTIONS(3052),
    [anon_sym_LPAREN2] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3054),
    [anon_sym_PLUS] = ACTIONS(3054),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_SLASH] = ACTIONS(3054),
    [anon_sym_PERCENT] = ACTIONS(3052),
    [anon_sym_PIPE_PIPE] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_PIPE] = ACTIONS(3054),
    [anon_sym_CARET] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3054),
    [anon_sym_EQ_EQ] = ACTIONS(3052),
    [anon_sym_BANG_EQ] = ACTIONS(3052),
    [anon_sym_GT] = ACTIONS(3054),
    [anon_sym_GT_EQ] = ACTIONS(3052),
    [anon_sym_LT_EQ] = ACTIONS(3054),
    [anon_sym_LT] = ACTIONS(3054),
    [anon_sym_LT_LT] = ACTIONS(3052),
    [anon_sym_GT_GT] = ACTIONS(3052),
    [anon_sym_COLON] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym___extension__] = ACTIONS(3054),
    [anon_sym___attribute__] = ACTIONS(3054),
    [anon_sym___based] = ACTIONS(3054),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_RBRACE] = ACTIONS(3052),
    [anon_sym_signed] = ACTIONS(3054),
    [anon_sym_unsigned] = ACTIONS(3054),
    [anon_sym_long] = ACTIONS(3054),
    [anon_sym_short] = ACTIONS(3054),
    [anon_sym_LBRACK] = ACTIONS(3052),
    [anon_sym_RBRACK] = ACTIONS(3052),
    [anon_sym_const] = ACTIONS(3054),
    [anon_sym_constexpr] = ACTIONS(3054),
    [anon_sym_volatile] = ACTIONS(3054),
    [anon_sym_restrict] = ACTIONS(3054),
    [anon_sym___restrict__] = ACTIONS(3054),
    [anon_sym__Atomic] = ACTIONS(3054),
    [anon_sym__Noreturn] = ACTIONS(3054),
    [anon_sym_noreturn] = ACTIONS(3054),
    [anon_sym_mutable] = ACTIONS(3054),
    [anon_sym_constinit] = ACTIONS(3054),
    [anon_sym_consteval] = ACTIONS(3054),
    [anon_sym_alignas] = ACTIONS(3054),
    [anon_sym__Alignas] = ACTIONS(3054),
    [sym_primitive_type] = ACTIONS(3054),
    [anon_sym_QMARK] = ACTIONS(3052),
    [anon_sym_LT_EQ_GT] = ACTIONS(3052),
    [anon_sym_or] = ACTIONS(3054),
    [anon_sym_and] = ACTIONS(3054),
    [anon_sym_bitor] = ACTIONS(3054),
    [anon_sym_xor] = ACTIONS(3054),
    [anon_sym_bitand] = ACTIONS(3054),
    [anon_sym_not_eq] = ACTIONS(3054),
    [anon_sym_is] = ACTIONS(3054),
    [anon_sym_as] = ACTIONS(3054),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_DOT] = ACTIONS(3054),
    [anon_sym_DOT_STAR] = ACTIONS(3052),
    [anon_sym_DASH_GT] = ACTIONS(3052),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3054),
    [anon_sym_let] = ACTIONS(3054),
    [anon_sym_This] = ACTIONS(3054),
    [anon_sym_final] = ACTIONS(3054),
    [anon_sym_override] = ACTIONS(3054),
    [anon_sym_requires] = ACTIONS(3054),
    [anon_sym_where] = ACTIONS(3054),
  },
  [2891] = {
    [sym_identifier] = ACTIONS(2910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2908),
    [anon_sym_COMMA] = ACTIONS(2908),
    [anon_sym_RPAREN] = ACTIONS(2908),
    [anon_sym_LPAREN2] = ACTIONS(2908),
    [anon_sym_DASH] = ACTIONS(2910),
    [anon_sym_PLUS] = ACTIONS(2910),
    [anon_sym_STAR] = ACTIONS(2908),
    [anon_sym_SLASH] = ACTIONS(2910),
    [anon_sym_PERCENT] = ACTIONS(2908),
    [anon_sym_PIPE_PIPE] = ACTIONS(2908),
    [anon_sym_AMP_AMP] = ACTIONS(2908),
    [anon_sym_PIPE] = ACTIONS(2910),
    [anon_sym_CARET] = ACTIONS(2908),
    [anon_sym_AMP] = ACTIONS(2910),
    [anon_sym_EQ_EQ] = ACTIONS(2908),
    [anon_sym_BANG_EQ] = ACTIONS(2908),
    [anon_sym_GT] = ACTIONS(2910),
    [anon_sym_GT_EQ] = ACTIONS(2908),
    [anon_sym_LT_EQ] = ACTIONS(2910),
    [anon_sym_LT] = ACTIONS(2910),
    [anon_sym_LT_LT] = ACTIONS(2908),
    [anon_sym_GT_GT] = ACTIONS(2908),
    [anon_sym_COLON] = ACTIONS(2908),
    [anon_sym_SEMI] = ACTIONS(2908),
    [anon_sym___extension__] = ACTIONS(2910),
    [anon_sym___attribute__] = ACTIONS(2910),
    [anon_sym___based] = ACTIONS(2910),
    [anon_sym_LBRACE] = ACTIONS(2908),
    [anon_sym_RBRACE] = ACTIONS(2908),
    [anon_sym_signed] = ACTIONS(2910),
    [anon_sym_unsigned] = ACTIONS(2910),
    [anon_sym_long] = ACTIONS(2910),
    [anon_sym_short] = ACTIONS(2910),
    [anon_sym_LBRACK] = ACTIONS(2908),
    [anon_sym_RBRACK] = ACTIONS(2908),
    [anon_sym_const] = ACTIONS(2910),
    [anon_sym_constexpr] = ACTIONS(2910),
    [anon_sym_volatile] = ACTIONS(2910),
    [anon_sym_restrict] = ACTIONS(2910),
    [anon_sym___restrict__] = ACTIONS(2910),
    [anon_sym__Atomic] = ACTIONS(2910),
    [anon_sym__Noreturn] = ACTIONS(2910),
    [anon_sym_noreturn] = ACTIONS(2910),
    [anon_sym_mutable] = ACTIONS(2910),
    [anon_sym_constinit] = ACTIONS(2910),
    [anon_sym_consteval] = ACTIONS(2910),
    [anon_sym_alignas] = ACTIONS(2910),
    [anon_sym__Alignas] = ACTIONS(2910),
    [sym_primitive_type] = ACTIONS(2910),
    [anon_sym_QMARK] = ACTIONS(2908),
    [anon_sym_LT_EQ_GT] = ACTIONS(2908),
    [anon_sym_or] = ACTIONS(2910),
    [anon_sym_and] = ACTIONS(2910),
    [anon_sym_bitor] = ACTIONS(2910),
    [anon_sym_xor] = ACTIONS(2910),
    [anon_sym_bitand] = ACTIONS(2910),
    [anon_sym_not_eq] = ACTIONS(2910),
    [anon_sym_is] = ACTIONS(2910),
    [anon_sym_as] = ACTIONS(2910),
    [anon_sym_DASH_DASH] = ACTIONS(2908),
    [anon_sym_PLUS_PLUS] = ACTIONS(2908),
    [anon_sym_DOT] = ACTIONS(2910),
    [anon_sym_DOT_STAR] = ACTIONS(2908),
    [anon_sym_DASH_GT] = ACTIONS(2908),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2910),
    [anon_sym_let] = ACTIONS(2910),
    [anon_sym_This] = ACTIONS(2910),
    [anon_sym_final] = ACTIONS(2910),
    [anon_sym_override] = ACTIONS(2910),
    [anon_sym_requires] = ACTIONS(2910),
    [anon_sym_where] = ACTIONS(2910),
  },
  [2892] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2903),
    [sym_identifier] = ACTIONS(6528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3822),
    [anon_sym_COMMA] = ACTIONS(3822),
    [anon_sym_RPAREN] = ACTIONS(3822),
    [anon_sym_LPAREN2] = ACTIONS(3822),
    [anon_sym_DASH] = ACTIONS(3820),
    [anon_sym_PLUS] = ACTIONS(3820),
    [anon_sym_STAR] = ACTIONS(3822),
    [anon_sym_SLASH] = ACTIONS(3820),
    [anon_sym_PERCENT] = ACTIONS(3822),
    [anon_sym_PIPE_PIPE] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3822),
    [anon_sym_PIPE] = ACTIONS(3820),
    [anon_sym_CARET] = ACTIONS(3822),
    [anon_sym_AMP] = ACTIONS(3820),
    [anon_sym_EQ_EQ] = ACTIONS(3822),
    [anon_sym_BANG_EQ] = ACTIONS(3822),
    [anon_sym_GT] = ACTIONS(3820),
    [anon_sym_GT_EQ] = ACTIONS(3822),
    [anon_sym_LT_EQ] = ACTIONS(3820),
    [anon_sym_LT] = ACTIONS(3820),
    [anon_sym_LT_LT] = ACTIONS(3822),
    [anon_sym_GT_GT] = ACTIONS(3822),
    [anon_sym_COLON] = ACTIONS(3822),
    [anon_sym_SEMI] = ACTIONS(3822),
    [anon_sym___extension__] = ACTIONS(3820),
    [anon_sym___attribute__] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3822),
    [anon_sym_RBRACE] = ACTIONS(3822),
    [anon_sym_signed] = ACTIONS(6530),
    [anon_sym_unsigned] = ACTIONS(6530),
    [anon_sym_long] = ACTIONS(6530),
    [anon_sym_short] = ACTIONS(6530),
    [anon_sym_LBRACK] = ACTIONS(3822),
    [anon_sym_RBRACK] = ACTIONS(3822),
    [anon_sym_const] = ACTIONS(3820),
    [anon_sym_constexpr] = ACTIONS(3820),
    [anon_sym_volatile] = ACTIONS(3820),
    [anon_sym_restrict] = ACTIONS(3820),
    [anon_sym___restrict__] = ACTIONS(3820),
    [anon_sym__Atomic] = ACTIONS(3820),
    [anon_sym__Noreturn] = ACTIONS(3820),
    [anon_sym_noreturn] = ACTIONS(3820),
    [anon_sym_mutable] = ACTIONS(3820),
    [anon_sym_constinit] = ACTIONS(3820),
    [anon_sym_consteval] = ACTIONS(3820),
    [anon_sym_alignas] = ACTIONS(3820),
    [anon_sym__Alignas] = ACTIONS(3820),
    [sym_primitive_type] = ACTIONS(6532),
    [anon_sym_QMARK] = ACTIONS(3822),
    [anon_sym_LT_EQ_GT] = ACTIONS(3822),
    [anon_sym_or] = ACTIONS(3820),
    [anon_sym_and] = ACTIONS(3820),
    [anon_sym_bitor] = ACTIONS(3820),
    [anon_sym_xor] = ACTIONS(3820),
    [anon_sym_bitand] = ACTIONS(3820),
    [anon_sym_not_eq] = ACTIONS(3820),
    [anon_sym_is] = ACTIONS(3820),
    [anon_sym_as] = ACTIONS(3820),
    [anon_sym_DASH_DASH] = ACTIONS(3822),
    [anon_sym_PLUS_PLUS] = ACTIONS(3822),
    [anon_sym_DOT] = ACTIONS(3820),
    [anon_sym_DOT_STAR] = ACTIONS(3822),
    [anon_sym_DASH_GT] = ACTIONS(3822),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3820),
    [anon_sym_let] = ACTIONS(3820),
    [anon_sym_This] = ACTIONS(3820),
    [anon_sym_final] = ACTIONS(3820),
    [anon_sym_override] = ACTIONS(3820),
    [anon_sym_requires] = ACTIONS(3820),
    [anon_sym_where] = ACTIONS(3820),
  },
  [2893] = {
    [sym_identifier] = ACTIONS(3070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3068),
    [anon_sym_COMMA] = ACTIONS(3068),
    [anon_sym_RPAREN] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3068),
    [anon_sym_DASH] = ACTIONS(3070),
    [anon_sym_PLUS] = ACTIONS(3070),
    [anon_sym_STAR] = ACTIONS(3068),
    [anon_sym_SLASH] = ACTIONS(3070),
    [anon_sym_PERCENT] = ACTIONS(3068),
    [anon_sym_PIPE_PIPE] = ACTIONS(3068),
    [anon_sym_AMP_AMP] = ACTIONS(3068),
    [anon_sym_PIPE] = ACTIONS(3070),
    [anon_sym_CARET] = ACTIONS(3068),
    [anon_sym_AMP] = ACTIONS(3070),
    [anon_sym_EQ_EQ] = ACTIONS(3068),
    [anon_sym_BANG_EQ] = ACTIONS(3068),
    [anon_sym_GT] = ACTIONS(3070),
    [anon_sym_GT_EQ] = ACTIONS(3068),
    [anon_sym_LT_EQ] = ACTIONS(3070),
    [anon_sym_LT] = ACTIONS(3070),
    [anon_sym_LT_LT] = ACTIONS(3068),
    [anon_sym_GT_GT] = ACTIONS(3068),
    [anon_sym_COLON] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3068),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym___attribute__] = ACTIONS(3070),
    [anon_sym___based] = ACTIONS(3070),
    [anon_sym_LBRACE] = ACTIONS(3068),
    [anon_sym_RBRACE] = ACTIONS(3068),
    [anon_sym_signed] = ACTIONS(3070),
    [anon_sym_unsigned] = ACTIONS(3070),
    [anon_sym_long] = ACTIONS(3070),
    [anon_sym_short] = ACTIONS(3070),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_RBRACK] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3070),
    [anon_sym_constexpr] = ACTIONS(3070),
    [anon_sym_volatile] = ACTIONS(3070),
    [anon_sym_restrict] = ACTIONS(3070),
    [anon_sym___restrict__] = ACTIONS(3070),
    [anon_sym__Atomic] = ACTIONS(3070),
    [anon_sym__Noreturn] = ACTIONS(3070),
    [anon_sym_noreturn] = ACTIONS(3070),
    [anon_sym_mutable] = ACTIONS(3070),
    [anon_sym_constinit] = ACTIONS(3070),
    [anon_sym_consteval] = ACTIONS(3070),
    [anon_sym_alignas] = ACTIONS(3070),
    [anon_sym__Alignas] = ACTIONS(3070),
    [sym_primitive_type] = ACTIONS(3070),
    [anon_sym_QMARK] = ACTIONS(3068),
    [anon_sym_LT_EQ_GT] = ACTIONS(3068),
    [anon_sym_or] = ACTIONS(3070),
    [anon_sym_and] = ACTIONS(3070),
    [anon_sym_bitor] = ACTIONS(3070),
    [anon_sym_xor] = ACTIONS(3070),
    [anon_sym_bitand] = ACTIONS(3070),
    [anon_sym_not_eq] = ACTIONS(3070),
    [anon_sym_is] = ACTIONS(3070),
    [anon_sym_as] = ACTIONS(3070),
    [anon_sym_DASH_DASH] = ACTIONS(3068),
    [anon_sym_PLUS_PLUS] = ACTIONS(3068),
    [anon_sym_DOT] = ACTIONS(3070),
    [anon_sym_DOT_STAR] = ACTIONS(3068),
    [anon_sym_DASH_GT] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3070),
    [anon_sym_let] = ACTIONS(3070),
    [anon_sym_This] = ACTIONS(3070),
    [anon_sym_final] = ACTIONS(3070),
    [anon_sym_override] = ACTIONS(3070),
    [anon_sym_requires] = ACTIONS(3070),
    [anon_sym_where] = ACTIONS(3070),
  },
  [2894] = {
    [sym_identifier] = ACTIONS(2536),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2534),
    [anon_sym_COMMA] = ACTIONS(2534),
    [anon_sym_RPAREN] = ACTIONS(2534),
    [anon_sym_LPAREN2] = ACTIONS(2534),
    [anon_sym_DASH] = ACTIONS(2536),
    [anon_sym_PLUS] = ACTIONS(2536),
    [anon_sym_STAR] = ACTIONS(2534),
    [anon_sym_SLASH] = ACTIONS(2536),
    [anon_sym_PERCENT] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_CARET] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
    [anon_sym_EQ_EQ] = ACTIONS(2534),
    [anon_sym_BANG_EQ] = ACTIONS(2534),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_EQ] = ACTIONS(2534),
    [anon_sym_LT_EQ] = ACTIONS(2536),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_LT_LT] = ACTIONS(2534),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_COLON] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2534),
    [anon_sym___extension__] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym___based] = ACTIONS(2536),
    [anon_sym_LBRACE] = ACTIONS(2534),
    [anon_sym_RBRACE] = ACTIONS(2534),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(2534),
    [anon_sym_RBRACK] = ACTIONS(2534),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2536),
    [anon_sym_QMARK] = ACTIONS(2534),
    [anon_sym_LT_EQ_GT] = ACTIONS(2534),
    [anon_sym_or] = ACTIONS(2536),
    [anon_sym_and] = ACTIONS(2536),
    [anon_sym_bitor] = ACTIONS(2536),
    [anon_sym_xor] = ACTIONS(2536),
    [anon_sym_bitand] = ACTIONS(2536),
    [anon_sym_not_eq] = ACTIONS(2536),
    [anon_sym_is] = ACTIONS(2536),
    [anon_sym_as] = ACTIONS(2536),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DOT] = ACTIONS(2536),
    [anon_sym_DOT_STAR] = ACTIONS(2534),
    [anon_sym_DASH_GT] = ACTIONS(2534),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2536),
    [anon_sym_let] = ACTIONS(2536),
    [anon_sym_This] = ACTIONS(2536),
    [anon_sym_final] = ACTIONS(2536),
    [anon_sym_override] = ACTIONS(2536),
    [anon_sym_requires] = ACTIONS(2536),
    [anon_sym_where] = ACTIONS(2536),
  },
  [2895] = {
    [sym_identifier] = ACTIONS(3848),
    [anon_sym_LPAREN2] = ACTIONS(3850),
    [anon_sym_TILDE] = ACTIONS(3850),
    [anon_sym_STAR] = ACTIONS(3850),
    [anon_sym_AMP_AMP] = ACTIONS(3850),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_SEMI] = ACTIONS(3850),
    [anon_sym___extension__] = ACTIONS(3848),
    [anon_sym_in] = ACTIONS(3848),
    [anon_sym_out] = ACTIONS(3848),
    [anon_sym_inout] = ACTIONS(3848),
    [anon_sym_extern] = ACTIONS(3848),
    [anon_sym___attribute__] = ACTIONS(3848),
    [anon_sym_COLON_COLON] = ACTIONS(3850),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3850),
    [anon_sym___declspec] = ACTIONS(3848),
    [anon_sym___based] = ACTIONS(3848),
    [anon_sym___cdecl] = ACTIONS(3848),
    [anon_sym___clrcall] = ACTIONS(3848),
    [anon_sym___stdcall] = ACTIONS(3848),
    [anon_sym___fastcall] = ACTIONS(3848),
    [anon_sym___thiscall] = ACTIONS(3848),
    [anon_sym___vectorcall] = ACTIONS(3848),
    [anon_sym_LBRACK] = ACTIONS(3848),
    [anon_sym_static] = ACTIONS(3848),
    [anon_sym_register] = ACTIONS(3848),
    [anon_sym_inline] = ACTIONS(3848),
    [anon_sym___inline] = ACTIONS(3848),
    [anon_sym___inline__] = ACTIONS(3848),
    [anon_sym___forceinline] = ACTIONS(3848),
    [anon_sym_thread_local] = ACTIONS(3848),
    [anon_sym___thread] = ACTIONS(3848),
    [anon_sym_const] = ACTIONS(3848),
    [anon_sym_constexpr] = ACTIONS(3848),
    [anon_sym_volatile] = ACTIONS(3848),
    [anon_sym_restrict] = ACTIONS(3848),
    [anon_sym___restrict__] = ACTIONS(3848),
    [anon_sym__Atomic] = ACTIONS(3848),
    [anon_sym__Noreturn] = ACTIONS(3848),
    [anon_sym_noreturn] = ACTIONS(3848),
    [anon_sym_mutable] = ACTIONS(3848),
    [anon_sym_constinit] = ACTIONS(3848),
    [anon_sym_consteval] = ACTIONS(3848),
    [anon_sym_alignas] = ACTIONS(3848),
    [anon_sym__Alignas] = ACTIONS(3848),
    [anon_sym_DOT] = ACTIONS(6305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6307),
    [anon_sym_let] = ACTIONS(6307),
    [anon_sym_This] = ACTIONS(6307),
    [anon_sym_decltype] = ACTIONS(3848),
    [sym_virtual] = ACTIONS(3848),
    [anon_sym_template] = ACTIONS(3848),
    [anon_sym_operator] = ACTIONS(3848),
    [anon_sym_precise] = ACTIONS(3848),
    [anon_sym_shared] = ACTIONS(3848),
    [anon_sym_groupshared] = ACTIONS(3848),
    [anon_sym_uniform] = ACTIONS(3848),
    [anon_sym_row_major] = ACTIONS(3848),
    [anon_sym_column_major] = ACTIONS(3848),
    [anon_sym_globallycoherent] = ACTIONS(3848),
    [anon_sym_centroid] = ACTIONS(3848),
    [anon_sym_noperspective] = ACTIONS(3848),
    [anon_sym_nointerpolation] = ACTIONS(3848),
    [anon_sym_sample] = ACTIONS(3848),
    [anon_sym_linear] = ACTIONS(3848),
    [anon_sym_snorm] = ACTIONS(3848),
    [anon_sym_unorm] = ACTIONS(3848),
    [anon_sym_point] = ACTIONS(3848),
    [anon_sym_line] = ACTIONS(3848),
    [anon_sym_triangleadj] = ACTIONS(3848),
    [anon_sym_lineadj] = ACTIONS(3848),
    [anon_sym_triangle] = ACTIONS(3848),
  },
  [2896] = {
    [sym_identifier] = ACTIONS(3358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3356),
    [anon_sym_COMMA] = ACTIONS(3356),
    [anon_sym_RPAREN] = ACTIONS(3356),
    [anon_sym_LPAREN2] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3358),
    [anon_sym_PLUS] = ACTIONS(3358),
    [anon_sym_STAR] = ACTIONS(3356),
    [anon_sym_SLASH] = ACTIONS(3358),
    [anon_sym_PERCENT] = ACTIONS(3356),
    [anon_sym_PIPE_PIPE] = ACTIONS(3356),
    [anon_sym_AMP_AMP] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(3358),
    [anon_sym_CARET] = ACTIONS(3356),
    [anon_sym_AMP] = ACTIONS(3358),
    [anon_sym_EQ_EQ] = ACTIONS(3356),
    [anon_sym_BANG_EQ] = ACTIONS(3356),
    [anon_sym_GT] = ACTIONS(3358),
    [anon_sym_GT_EQ] = ACTIONS(3356),
    [anon_sym_LT_EQ] = ACTIONS(3358),
    [anon_sym_LT] = ACTIONS(3358),
    [anon_sym_LT_LT] = ACTIONS(3356),
    [anon_sym_GT_GT] = ACTIONS(3356),
    [anon_sym_COLON] = ACTIONS(3356),
    [anon_sym_SEMI] = ACTIONS(3356),
    [anon_sym___extension__] = ACTIONS(3358),
    [anon_sym___attribute__] = ACTIONS(3358),
    [anon_sym___based] = ACTIONS(3358),
    [anon_sym_LBRACE] = ACTIONS(3356),
    [anon_sym_RBRACE] = ACTIONS(3356),
    [anon_sym_signed] = ACTIONS(3358),
    [anon_sym_unsigned] = ACTIONS(3358),
    [anon_sym_long] = ACTIONS(3358),
    [anon_sym_short] = ACTIONS(3358),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_RBRACK] = ACTIONS(3356),
    [anon_sym_const] = ACTIONS(3358),
    [anon_sym_constexpr] = ACTIONS(3358),
    [anon_sym_volatile] = ACTIONS(3358),
    [anon_sym_restrict] = ACTIONS(3358),
    [anon_sym___restrict__] = ACTIONS(3358),
    [anon_sym__Atomic] = ACTIONS(3358),
    [anon_sym__Noreturn] = ACTIONS(3358),
    [anon_sym_noreturn] = ACTIONS(3358),
    [anon_sym_mutable] = ACTIONS(3358),
    [anon_sym_constinit] = ACTIONS(3358),
    [anon_sym_consteval] = ACTIONS(3358),
    [anon_sym_alignas] = ACTIONS(3358),
    [anon_sym__Alignas] = ACTIONS(3358),
    [sym_primitive_type] = ACTIONS(3358),
    [anon_sym_QMARK] = ACTIONS(3356),
    [anon_sym_LT_EQ_GT] = ACTIONS(3356),
    [anon_sym_or] = ACTIONS(3358),
    [anon_sym_and] = ACTIONS(3358),
    [anon_sym_bitor] = ACTIONS(3358),
    [anon_sym_xor] = ACTIONS(3358),
    [anon_sym_bitand] = ACTIONS(3358),
    [anon_sym_not_eq] = ACTIONS(3358),
    [anon_sym_is] = ACTIONS(3358),
    [anon_sym_as] = ACTIONS(3358),
    [anon_sym_DASH_DASH] = ACTIONS(3356),
    [anon_sym_PLUS_PLUS] = ACTIONS(3356),
    [anon_sym_DOT] = ACTIONS(3358),
    [anon_sym_DOT_STAR] = ACTIONS(3356),
    [anon_sym_DASH_GT] = ACTIONS(3356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3358),
    [anon_sym_let] = ACTIONS(3358),
    [anon_sym_This] = ACTIONS(3358),
    [anon_sym_final] = ACTIONS(3358),
    [anon_sym_override] = ACTIONS(3358),
    [anon_sym_requires] = ACTIONS(3358),
    [anon_sym_where] = ACTIONS(3358),
  },
  [2897] = {
    [sym_identifier] = ACTIONS(2944),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2942),
    [anon_sym_COMMA] = ACTIONS(2942),
    [anon_sym_RPAREN] = ACTIONS(2942),
    [anon_sym_LPAREN2] = ACTIONS(2942),
    [anon_sym_DASH] = ACTIONS(2944),
    [anon_sym_PLUS] = ACTIONS(2944),
    [anon_sym_STAR] = ACTIONS(2942),
    [anon_sym_SLASH] = ACTIONS(2944),
    [anon_sym_PERCENT] = ACTIONS(2942),
    [anon_sym_PIPE_PIPE] = ACTIONS(2942),
    [anon_sym_AMP_AMP] = ACTIONS(2942),
    [anon_sym_PIPE] = ACTIONS(2944),
    [anon_sym_CARET] = ACTIONS(2942),
    [anon_sym_AMP] = ACTIONS(2944),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_GT_EQ] = ACTIONS(2942),
    [anon_sym_LT_EQ] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_LT_LT] = ACTIONS(2942),
    [anon_sym_GT_GT] = ACTIONS(2942),
    [anon_sym_COLON] = ACTIONS(2942),
    [anon_sym_SEMI] = ACTIONS(2942),
    [anon_sym___extension__] = ACTIONS(2944),
    [anon_sym___attribute__] = ACTIONS(2944),
    [anon_sym___based] = ACTIONS(2944),
    [anon_sym_LBRACE] = ACTIONS(2942),
    [anon_sym_RBRACE] = ACTIONS(2942),
    [anon_sym_signed] = ACTIONS(2944),
    [anon_sym_unsigned] = ACTIONS(2944),
    [anon_sym_long] = ACTIONS(2944),
    [anon_sym_short] = ACTIONS(2944),
    [anon_sym_LBRACK] = ACTIONS(2942),
    [anon_sym_RBRACK] = ACTIONS(2942),
    [anon_sym_const] = ACTIONS(2944),
    [anon_sym_constexpr] = ACTIONS(2944),
    [anon_sym_volatile] = ACTIONS(2944),
    [anon_sym_restrict] = ACTIONS(2944),
    [anon_sym___restrict__] = ACTIONS(2944),
    [anon_sym__Atomic] = ACTIONS(2944),
    [anon_sym__Noreturn] = ACTIONS(2944),
    [anon_sym_noreturn] = ACTIONS(2944),
    [anon_sym_mutable] = ACTIONS(2944),
    [anon_sym_constinit] = ACTIONS(2944),
    [anon_sym_consteval] = ACTIONS(2944),
    [anon_sym_alignas] = ACTIONS(2944),
    [anon_sym__Alignas] = ACTIONS(2944),
    [sym_primitive_type] = ACTIONS(2944),
    [anon_sym_QMARK] = ACTIONS(2942),
    [anon_sym_LT_EQ_GT] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2944),
    [anon_sym_and] = ACTIONS(2944),
    [anon_sym_bitor] = ACTIONS(2944),
    [anon_sym_xor] = ACTIONS(2944),
    [anon_sym_bitand] = ACTIONS(2944),
    [anon_sym_not_eq] = ACTIONS(2944),
    [anon_sym_is] = ACTIONS(2944),
    [anon_sym_as] = ACTIONS(2944),
    [anon_sym_DASH_DASH] = ACTIONS(2942),
    [anon_sym_PLUS_PLUS] = ACTIONS(2942),
    [anon_sym_DOT] = ACTIONS(2944),
    [anon_sym_DOT_STAR] = ACTIONS(2942),
    [anon_sym_DASH_GT] = ACTIONS(2942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2944),
    [anon_sym_let] = ACTIONS(2944),
    [anon_sym_This] = ACTIONS(2944),
    [anon_sym_final] = ACTIONS(2944),
    [anon_sym_override] = ACTIONS(2944),
    [anon_sym_requires] = ACTIONS(2944),
    [anon_sym_where] = ACTIONS(2944),
  },
  [2898] = {
    [sym_string_literal] = STATE(3342),
    [sym_template_argument_list] = STATE(4579),
    [sym_raw_string_literal] = STATE(3342),
    [sym_identifier] = ACTIONS(2128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [aux_sym_preproc_if_token2] = ACTIONS(2117),
    [aux_sym_preproc_else_token1] = ACTIONS(2117),
    [aux_sym_preproc_elif_token1] = ACTIONS(2128),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2117),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(6534),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2117),
    [anon_sym_EQ] = ACTIONS(6537),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(6539),
    [anon_sym_SLASH_EQ] = ACTIONS(6539),
    [anon_sym_PERCENT_EQ] = ACTIONS(6539),
    [anon_sym_PLUS_EQ] = ACTIONS(6539),
    [anon_sym_DASH_EQ] = ACTIONS(6539),
    [anon_sym_LT_LT_EQ] = ACTIONS(6539),
    [anon_sym_GT_GT_EQ] = ACTIONS(6539),
    [anon_sym_AMP_EQ] = ACTIONS(6539),
    [anon_sym_CARET_EQ] = ACTIONS(6539),
    [anon_sym_PIPE_EQ] = ACTIONS(6539),
    [anon_sym_and_eq] = ACTIONS(6537),
    [anon_sym_or_eq] = ACTIONS(6537),
    [anon_sym_xor_eq] = ACTIONS(6537),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2128),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2128),
    [anon_sym_not_eq] = ACTIONS(2128),
    [anon_sym_is] = ACTIONS(2128),
    [anon_sym_as] = ACTIONS(2128),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
  },
  [2899] = {
    [sym_identifier] = ACTIONS(2210),
    [anon_sym_LPAREN2] = ACTIONS(2214),
    [anon_sym_TILDE] = ACTIONS(2217),
    [anon_sym_STAR] = ACTIONS(2217),
    [anon_sym_AMP_AMP] = ACTIONS(2217),
    [anon_sym_AMP] = ACTIONS(2210),
    [anon_sym_SEMI] = ACTIONS(2217),
    [anon_sym___extension__] = ACTIONS(2210),
    [anon_sym_in] = ACTIONS(2210),
    [anon_sym_out] = ACTIONS(2210),
    [anon_sym_inout] = ACTIONS(2210),
    [anon_sym_extern] = ACTIONS(2210),
    [anon_sym___attribute__] = ACTIONS(2210),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2214),
    [anon_sym___declspec] = ACTIONS(2210),
    [anon_sym___based] = ACTIONS(2210),
    [anon_sym___cdecl] = ACTIONS(2210),
    [anon_sym___clrcall] = ACTIONS(2210),
    [anon_sym___stdcall] = ACTIONS(2210),
    [anon_sym___fastcall] = ACTIONS(2210),
    [anon_sym___thiscall] = ACTIONS(2210),
    [anon_sym___vectorcall] = ACTIONS(2210),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_static] = ACTIONS(2210),
    [anon_sym_register] = ACTIONS(2210),
    [anon_sym_inline] = ACTIONS(2210),
    [anon_sym___inline] = ACTIONS(2210),
    [anon_sym___inline__] = ACTIONS(2210),
    [anon_sym___forceinline] = ACTIONS(2210),
    [anon_sym_thread_local] = ACTIONS(2210),
    [anon_sym___thread] = ACTIONS(2210),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_constexpr] = ACTIONS(2210),
    [anon_sym_volatile] = ACTIONS(2210),
    [anon_sym_restrict] = ACTIONS(2210),
    [anon_sym___restrict__] = ACTIONS(2210),
    [anon_sym__Atomic] = ACTIONS(2210),
    [anon_sym__Noreturn] = ACTIONS(2210),
    [anon_sym_noreturn] = ACTIONS(2210),
    [anon_sym_mutable] = ACTIONS(2210),
    [anon_sym_constinit] = ACTIONS(2210),
    [anon_sym_consteval] = ACTIONS(2210),
    [anon_sym_alignas] = ACTIONS(2210),
    [anon_sym__Alignas] = ACTIONS(2210),
    [anon_sym_DOT] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2210),
    [anon_sym_let] = ACTIONS(2210),
    [anon_sym_This] = ACTIONS(2210),
    [anon_sym_decltype] = ACTIONS(2210),
    [sym_virtual] = ACTIONS(2210),
    [anon_sym_template] = ACTIONS(2210),
    [anon_sym_operator] = ACTIONS(2210),
    [anon_sym_precise] = ACTIONS(2210),
    [anon_sym_shared] = ACTIONS(2210),
    [anon_sym_groupshared] = ACTIONS(2210),
    [anon_sym_uniform] = ACTIONS(2210),
    [anon_sym_row_major] = ACTIONS(2210),
    [anon_sym_column_major] = ACTIONS(2210),
    [anon_sym_globallycoherent] = ACTIONS(2210),
    [anon_sym_centroid] = ACTIONS(2210),
    [anon_sym_noperspective] = ACTIONS(2210),
    [anon_sym_nointerpolation] = ACTIONS(2210),
    [anon_sym_sample] = ACTIONS(2210),
    [anon_sym_linear] = ACTIONS(2210),
    [anon_sym_snorm] = ACTIONS(2210),
    [anon_sym_unorm] = ACTIONS(2210),
    [anon_sym_point] = ACTIONS(2210),
    [anon_sym_line] = ACTIONS(2210),
    [anon_sym_triangleadj] = ACTIONS(2210),
    [anon_sym_lineadj] = ACTIONS(2210),
    [anon_sym_triangle] = ACTIONS(2210),
  },
  [2900] = {
    [sym_identifier] = ACTIONS(2742),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_TILDE] = ACTIONS(2740),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_SEMI] = ACTIONS(2365),
    [anon_sym___extension__] = ACTIONS(2742),
    [anon_sym_in] = ACTIONS(2742),
    [anon_sym_out] = ACTIONS(2742),
    [anon_sym_inout] = ACTIONS(2742),
    [anon_sym_extern] = ACTIONS(2742),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym_COLON_COLON] = ACTIONS(2740),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2740),
    [anon_sym___declspec] = ACTIONS(2742),
    [anon_sym___based] = ACTIONS(2742),
    [anon_sym___cdecl] = ACTIONS(2742),
    [anon_sym___clrcall] = ACTIONS(2742),
    [anon_sym___stdcall] = ACTIONS(2742),
    [anon_sym___fastcall] = ACTIONS(2742),
    [anon_sym___thiscall] = ACTIONS(2742),
    [anon_sym___vectorcall] = ACTIONS(2742),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2742),
    [anon_sym_register] = ACTIONS(2742),
    [anon_sym_inline] = ACTIONS(2742),
    [anon_sym___inline] = ACTIONS(2742),
    [anon_sym___inline__] = ACTIONS(2742),
    [anon_sym___forceinline] = ACTIONS(2742),
    [anon_sym_thread_local] = ACTIONS(2742),
    [anon_sym___thread] = ACTIONS(2742),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_constexpr] = ACTIONS(2742),
    [anon_sym_volatile] = ACTIONS(2742),
    [anon_sym_restrict] = ACTIONS(2742),
    [anon_sym___restrict__] = ACTIONS(2742),
    [anon_sym__Atomic] = ACTIONS(2742),
    [anon_sym__Noreturn] = ACTIONS(2742),
    [anon_sym_noreturn] = ACTIONS(2742),
    [anon_sym_mutable] = ACTIONS(2742),
    [anon_sym_constinit] = ACTIONS(2742),
    [anon_sym_consteval] = ACTIONS(2742),
    [anon_sym_alignas] = ACTIONS(2742),
    [anon_sym__Alignas] = ACTIONS(2742),
    [anon_sym_DOT] = ACTIONS(2740),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
    [anon_sym_decltype] = ACTIONS(2742),
    [sym_virtual] = ACTIONS(2742),
    [anon_sym_template] = ACTIONS(2742),
    [anon_sym_operator] = ACTIONS(2742),
    [anon_sym_precise] = ACTIONS(2742),
    [anon_sym_shared] = ACTIONS(2742),
    [anon_sym_groupshared] = ACTIONS(2742),
    [anon_sym_uniform] = ACTIONS(2742),
    [anon_sym_row_major] = ACTIONS(2742),
    [anon_sym_column_major] = ACTIONS(2742),
    [anon_sym_globallycoherent] = ACTIONS(2742),
    [anon_sym_centroid] = ACTIONS(2742),
    [anon_sym_noperspective] = ACTIONS(2742),
    [anon_sym_nointerpolation] = ACTIONS(2742),
    [anon_sym_sample] = ACTIONS(2742),
    [anon_sym_linear] = ACTIONS(2742),
    [anon_sym_snorm] = ACTIONS(2742),
    [anon_sym_unorm] = ACTIONS(2742),
    [anon_sym_point] = ACTIONS(2742),
    [anon_sym_line] = ACTIONS(2742),
    [anon_sym_triangleadj] = ACTIONS(2742),
    [anon_sym_lineadj] = ACTIONS(2742),
    [anon_sym_triangle] = ACTIONS(2742),
  },
  [2901] = {
    [sym_identifier] = ACTIONS(3890),
    [anon_sym_LPAREN2] = ACTIONS(3892),
    [anon_sym_TILDE] = ACTIONS(3892),
    [anon_sym_STAR] = ACTIONS(3892),
    [anon_sym_AMP_AMP] = ACTIONS(3892),
    [anon_sym_AMP] = ACTIONS(3890),
    [anon_sym_SEMI] = ACTIONS(3892),
    [anon_sym___extension__] = ACTIONS(3890),
    [anon_sym_in] = ACTIONS(3890),
    [anon_sym_out] = ACTIONS(3890),
    [anon_sym_inout] = ACTIONS(3890),
    [anon_sym_extern] = ACTIONS(3890),
    [anon_sym___attribute__] = ACTIONS(3890),
    [anon_sym_COLON_COLON] = ACTIONS(3892),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3892),
    [anon_sym___declspec] = ACTIONS(3890),
    [anon_sym___based] = ACTIONS(3890),
    [anon_sym___cdecl] = ACTIONS(3890),
    [anon_sym___clrcall] = ACTIONS(3890),
    [anon_sym___stdcall] = ACTIONS(3890),
    [anon_sym___fastcall] = ACTIONS(3890),
    [anon_sym___thiscall] = ACTIONS(3890),
    [anon_sym___vectorcall] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3890),
    [anon_sym_static] = ACTIONS(3890),
    [anon_sym_register] = ACTIONS(3890),
    [anon_sym_inline] = ACTIONS(3890),
    [anon_sym___inline] = ACTIONS(3890),
    [anon_sym___inline__] = ACTIONS(3890),
    [anon_sym___forceinline] = ACTIONS(3890),
    [anon_sym_thread_local] = ACTIONS(3890),
    [anon_sym___thread] = ACTIONS(3890),
    [anon_sym_const] = ACTIONS(3890),
    [anon_sym_constexpr] = ACTIONS(3890),
    [anon_sym_volatile] = ACTIONS(3890),
    [anon_sym_restrict] = ACTIONS(3890),
    [anon_sym___restrict__] = ACTIONS(3890),
    [anon_sym__Atomic] = ACTIONS(3890),
    [anon_sym__Noreturn] = ACTIONS(3890),
    [anon_sym_noreturn] = ACTIONS(3890),
    [anon_sym_mutable] = ACTIONS(3890),
    [anon_sym_constinit] = ACTIONS(3890),
    [anon_sym_consteval] = ACTIONS(3890),
    [anon_sym_alignas] = ACTIONS(3890),
    [anon_sym__Alignas] = ACTIONS(3890),
    [anon_sym_DOT] = ACTIONS(6305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6307),
    [anon_sym_let] = ACTIONS(6307),
    [anon_sym_This] = ACTIONS(6307),
    [anon_sym_decltype] = ACTIONS(3890),
    [sym_virtual] = ACTIONS(3890),
    [anon_sym_template] = ACTIONS(3890),
    [anon_sym_operator] = ACTIONS(3890),
    [anon_sym_precise] = ACTIONS(3890),
    [anon_sym_shared] = ACTIONS(3890),
    [anon_sym_groupshared] = ACTIONS(3890),
    [anon_sym_uniform] = ACTIONS(3890),
    [anon_sym_row_major] = ACTIONS(3890),
    [anon_sym_column_major] = ACTIONS(3890),
    [anon_sym_globallycoherent] = ACTIONS(3890),
    [anon_sym_centroid] = ACTIONS(3890),
    [anon_sym_noperspective] = ACTIONS(3890),
    [anon_sym_nointerpolation] = ACTIONS(3890),
    [anon_sym_sample] = ACTIONS(3890),
    [anon_sym_linear] = ACTIONS(3890),
    [anon_sym_snorm] = ACTIONS(3890),
    [anon_sym_unorm] = ACTIONS(3890),
    [anon_sym_point] = ACTIONS(3890),
    [anon_sym_line] = ACTIONS(3890),
    [anon_sym_triangleadj] = ACTIONS(3890),
    [anon_sym_lineadj] = ACTIONS(3890),
    [anon_sym_triangle] = ACTIONS(3890),
  },
  [2902] = {
    [sym_identifier] = ACTIONS(3384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3382),
    [anon_sym_COMMA] = ACTIONS(3382),
    [anon_sym_RPAREN] = ACTIONS(3382),
    [anon_sym_LPAREN2] = ACTIONS(3382),
    [anon_sym_DASH] = ACTIONS(3384),
    [anon_sym_PLUS] = ACTIONS(3384),
    [anon_sym_STAR] = ACTIONS(3382),
    [anon_sym_SLASH] = ACTIONS(3384),
    [anon_sym_PERCENT] = ACTIONS(3382),
    [anon_sym_PIPE_PIPE] = ACTIONS(3382),
    [anon_sym_AMP_AMP] = ACTIONS(3382),
    [anon_sym_PIPE] = ACTIONS(3384),
    [anon_sym_CARET] = ACTIONS(3382),
    [anon_sym_AMP] = ACTIONS(3384),
    [anon_sym_EQ_EQ] = ACTIONS(3382),
    [anon_sym_BANG_EQ] = ACTIONS(3382),
    [anon_sym_GT] = ACTIONS(3384),
    [anon_sym_GT_EQ] = ACTIONS(3382),
    [anon_sym_LT_EQ] = ACTIONS(3384),
    [anon_sym_LT] = ACTIONS(3384),
    [anon_sym_LT_LT] = ACTIONS(3382),
    [anon_sym_GT_GT] = ACTIONS(3382),
    [anon_sym_COLON] = ACTIONS(3382),
    [anon_sym_SEMI] = ACTIONS(3382),
    [anon_sym___extension__] = ACTIONS(3384),
    [anon_sym___attribute__] = ACTIONS(3384),
    [anon_sym___based] = ACTIONS(3384),
    [anon_sym_LBRACE] = ACTIONS(3382),
    [anon_sym_RBRACE] = ACTIONS(3382),
    [anon_sym_signed] = ACTIONS(3384),
    [anon_sym_unsigned] = ACTIONS(3384),
    [anon_sym_long] = ACTIONS(3384),
    [anon_sym_short] = ACTIONS(3384),
    [anon_sym_LBRACK] = ACTIONS(3382),
    [anon_sym_RBRACK] = ACTIONS(3382),
    [anon_sym_const] = ACTIONS(3384),
    [anon_sym_constexpr] = ACTIONS(3384),
    [anon_sym_volatile] = ACTIONS(3384),
    [anon_sym_restrict] = ACTIONS(3384),
    [anon_sym___restrict__] = ACTIONS(3384),
    [anon_sym__Atomic] = ACTIONS(3384),
    [anon_sym__Noreturn] = ACTIONS(3384),
    [anon_sym_noreturn] = ACTIONS(3384),
    [anon_sym_mutable] = ACTIONS(3384),
    [anon_sym_constinit] = ACTIONS(3384),
    [anon_sym_consteval] = ACTIONS(3384),
    [anon_sym_alignas] = ACTIONS(3384),
    [anon_sym__Alignas] = ACTIONS(3384),
    [sym_primitive_type] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3382),
    [anon_sym_LT_EQ_GT] = ACTIONS(3382),
    [anon_sym_or] = ACTIONS(3384),
    [anon_sym_and] = ACTIONS(3384),
    [anon_sym_bitor] = ACTIONS(3384),
    [anon_sym_xor] = ACTIONS(3384),
    [anon_sym_bitand] = ACTIONS(3384),
    [anon_sym_not_eq] = ACTIONS(3384),
    [anon_sym_is] = ACTIONS(3384),
    [anon_sym_as] = ACTIONS(3384),
    [anon_sym_DASH_DASH] = ACTIONS(3382),
    [anon_sym_PLUS_PLUS] = ACTIONS(3382),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_DOT_STAR] = ACTIONS(3382),
    [anon_sym_DASH_GT] = ACTIONS(3382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3384),
    [anon_sym_let] = ACTIONS(3384),
    [anon_sym_This] = ACTIONS(3384),
    [anon_sym_final] = ACTIONS(3384),
    [anon_sym_override] = ACTIONS(3384),
    [anon_sym_requires] = ACTIONS(3384),
    [anon_sym_where] = ACTIONS(3384),
  },
  [2903] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2738),
    [sym_identifier] = ACTIONS(2856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3781),
    [anon_sym_RPAREN] = ACTIONS(3781),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_DASH] = ACTIONS(3778),
    [anon_sym_PLUS] = ACTIONS(3778),
    [anon_sym_STAR] = ACTIONS(3781),
    [anon_sym_SLASH] = ACTIONS(3778),
    [anon_sym_PERCENT] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_PIPE] = ACTIONS(3778),
    [anon_sym_CARET] = ACTIONS(3781),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_GT] = ACTIONS(3778),
    [anon_sym_GT_EQ] = ACTIONS(3781),
    [anon_sym_LT_EQ] = ACTIONS(3778),
    [anon_sym_LT] = ACTIONS(3778),
    [anon_sym_LT_LT] = ACTIONS(3781),
    [anon_sym_GT_GT] = ACTIONS(3781),
    [anon_sym_COLON] = ACTIONS(3781),
    [anon_sym_SEMI] = ACTIONS(3781),
    [anon_sym___extension__] = ACTIONS(3778),
    [anon_sym___attribute__] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_RBRACE] = ACTIONS(3781),
    [anon_sym_signed] = ACTIONS(6360),
    [anon_sym_unsigned] = ACTIONS(6360),
    [anon_sym_long] = ACTIONS(6360),
    [anon_sym_short] = ACTIONS(6360),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_RBRACK] = ACTIONS(3781),
    [anon_sym_const] = ACTIONS(3778),
    [anon_sym_constexpr] = ACTIONS(3778),
    [anon_sym_volatile] = ACTIONS(3778),
    [anon_sym_restrict] = ACTIONS(3778),
    [anon_sym___restrict__] = ACTIONS(3778),
    [anon_sym__Atomic] = ACTIONS(3778),
    [anon_sym__Noreturn] = ACTIONS(3778),
    [anon_sym_noreturn] = ACTIONS(3778),
    [anon_sym_mutable] = ACTIONS(3778),
    [anon_sym_constinit] = ACTIONS(3778),
    [anon_sym_consteval] = ACTIONS(3778),
    [anon_sym_alignas] = ACTIONS(3778),
    [anon_sym__Alignas] = ACTIONS(3778),
    [sym_primitive_type] = ACTIONS(2856),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_LT_EQ_GT] = ACTIONS(3781),
    [anon_sym_or] = ACTIONS(3778),
    [anon_sym_and] = ACTIONS(3778),
    [anon_sym_bitor] = ACTIONS(3778),
    [anon_sym_xor] = ACTIONS(3778),
    [anon_sym_bitand] = ACTIONS(3778),
    [anon_sym_not_eq] = ACTIONS(3778),
    [anon_sym_is] = ACTIONS(3778),
    [anon_sym_as] = ACTIONS(3778),
    [anon_sym_DASH_DASH] = ACTIONS(3781),
    [anon_sym_PLUS_PLUS] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(3778),
    [anon_sym_DOT_STAR] = ACTIONS(3781),
    [anon_sym_DASH_GT] = ACTIONS(3781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3778),
    [anon_sym_let] = ACTIONS(3778),
    [anon_sym_This] = ACTIONS(3778),
    [anon_sym_final] = ACTIONS(3778),
    [anon_sym_override] = ACTIONS(3778),
    [anon_sym_requires] = ACTIONS(3778),
    [anon_sym_where] = ACTIONS(3778),
  },
  [2904] = {
    [sym_identifier] = ACTIONS(2742),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_TILDE] = ACTIONS(2740),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_SEMI] = ACTIONS(2365),
    [anon_sym___extension__] = ACTIONS(2742),
    [anon_sym_in] = ACTIONS(2742),
    [anon_sym_out] = ACTIONS(2742),
    [anon_sym_inout] = ACTIONS(2742),
    [anon_sym_extern] = ACTIONS(2742),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2740),
    [anon_sym___declspec] = ACTIONS(2742),
    [anon_sym___based] = ACTIONS(2742),
    [anon_sym___cdecl] = ACTIONS(2742),
    [anon_sym___clrcall] = ACTIONS(2742),
    [anon_sym___stdcall] = ACTIONS(2742),
    [anon_sym___fastcall] = ACTIONS(2742),
    [anon_sym___thiscall] = ACTIONS(2742),
    [anon_sym___vectorcall] = ACTIONS(2742),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2742),
    [anon_sym_register] = ACTIONS(2742),
    [anon_sym_inline] = ACTIONS(2742),
    [anon_sym___inline] = ACTIONS(2742),
    [anon_sym___inline__] = ACTIONS(2742),
    [anon_sym___forceinline] = ACTIONS(2742),
    [anon_sym_thread_local] = ACTIONS(2742),
    [anon_sym___thread] = ACTIONS(2742),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_constexpr] = ACTIONS(2742),
    [anon_sym_volatile] = ACTIONS(2742),
    [anon_sym_restrict] = ACTIONS(2742),
    [anon_sym___restrict__] = ACTIONS(2742),
    [anon_sym__Atomic] = ACTIONS(2742),
    [anon_sym__Noreturn] = ACTIONS(2742),
    [anon_sym_noreturn] = ACTIONS(2742),
    [anon_sym_mutable] = ACTIONS(2742),
    [anon_sym_constinit] = ACTIONS(2742),
    [anon_sym_consteval] = ACTIONS(2742),
    [anon_sym_alignas] = ACTIONS(2742),
    [anon_sym__Alignas] = ACTIONS(2742),
    [anon_sym_DOT] = ACTIONS(2740),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
    [anon_sym_decltype] = ACTIONS(2742),
    [sym_virtual] = ACTIONS(2742),
    [anon_sym_template] = ACTIONS(2742),
    [anon_sym_operator] = ACTIONS(2742),
    [anon_sym_precise] = ACTIONS(2742),
    [anon_sym_shared] = ACTIONS(2742),
    [anon_sym_groupshared] = ACTIONS(2742),
    [anon_sym_uniform] = ACTIONS(2742),
    [anon_sym_row_major] = ACTIONS(2742),
    [anon_sym_column_major] = ACTIONS(2742),
    [anon_sym_globallycoherent] = ACTIONS(2742),
    [anon_sym_centroid] = ACTIONS(2742),
    [anon_sym_noperspective] = ACTIONS(2742),
    [anon_sym_nointerpolation] = ACTIONS(2742),
    [anon_sym_sample] = ACTIONS(2742),
    [anon_sym_linear] = ACTIONS(2742),
    [anon_sym_snorm] = ACTIONS(2742),
    [anon_sym_unorm] = ACTIONS(2742),
    [anon_sym_point] = ACTIONS(2742),
    [anon_sym_line] = ACTIONS(2742),
    [anon_sym_triangleadj] = ACTIONS(2742),
    [anon_sym_lineadj] = ACTIONS(2742),
    [anon_sym_triangle] = ACTIONS(2742),
  },
  [2905] = {
    [sym_template_argument_list] = STATE(2944),
    [sym_identifier] = ACTIONS(2169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2176),
    [anon_sym_COMMA] = ACTIONS(2176),
    [anon_sym_RPAREN] = ACTIONS(2173),
    [anon_sym_LPAREN2] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_STAR] = ACTIONS(2176),
    [anon_sym_AMP_AMP] = ACTIONS(2176),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(6358),
    [anon_sym_COLON] = ACTIONS(2169),
    [anon_sym___extension__] = ACTIONS(2169),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_out] = ACTIONS(2169),
    [anon_sym_inout] = ACTIONS(2169),
    [anon_sym_extern] = ACTIONS(2169),
    [anon_sym___attribute__] = ACTIONS(2169),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2173),
    [anon_sym___declspec] = ACTIONS(2169),
    [anon_sym___based] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2169),
    [anon_sym_EQ] = ACTIONS(2176),
    [anon_sym_register] = ACTIONS(2169),
    [anon_sym_inline] = ACTIONS(2169),
    [anon_sym___inline] = ACTIONS(2169),
    [anon_sym___inline__] = ACTIONS(2169),
    [anon_sym___forceinline] = ACTIONS(2169),
    [anon_sym_thread_local] = ACTIONS(2169),
    [anon_sym___thread] = ACTIONS(2169),
    [anon_sym_const] = ACTIONS(2169),
    [anon_sym_constexpr] = ACTIONS(2169),
    [anon_sym_volatile] = ACTIONS(2169),
    [anon_sym_restrict] = ACTIONS(2169),
    [anon_sym___restrict__] = ACTIONS(2169),
    [anon_sym__Atomic] = ACTIONS(2169),
    [anon_sym__Noreturn] = ACTIONS(2169),
    [anon_sym_noreturn] = ACTIONS(2169),
    [anon_sym_mutable] = ACTIONS(2169),
    [anon_sym_constinit] = ACTIONS(2169),
    [anon_sym_consteval] = ACTIONS(2169),
    [anon_sym_alignas] = ACTIONS(2169),
    [anon_sym__Alignas] = ACTIONS(2169),
    [anon_sym_DOT] = ACTIONS(2169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2169),
    [anon_sym_let] = ACTIONS(2169),
    [anon_sym_This] = ACTIONS(2169),
    [anon_sym_decltype] = ACTIONS(2169),
    [sym_virtual] = ACTIONS(2169),
    [anon_sym_template] = ACTIONS(2169),
    [anon_sym_operator] = ACTIONS(2169),
    [anon_sym_precise] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_groupshared] = ACTIONS(2169),
    [anon_sym_uniform] = ACTIONS(2169),
    [anon_sym_row_major] = ACTIONS(2169),
    [anon_sym_column_major] = ACTIONS(2169),
    [anon_sym_globallycoherent] = ACTIONS(2169),
    [anon_sym_centroid] = ACTIONS(2169),
    [anon_sym_noperspective] = ACTIONS(2169),
    [anon_sym_nointerpolation] = ACTIONS(2169),
    [anon_sym_sample] = ACTIONS(2169),
    [anon_sym_linear] = ACTIONS(2169),
    [anon_sym_snorm] = ACTIONS(2169),
    [anon_sym_unorm] = ACTIONS(2169),
    [anon_sym_point] = ACTIONS(2169),
    [anon_sym_line] = ACTIONS(2169),
    [anon_sym_triangleadj] = ACTIONS(2169),
    [anon_sym_lineadj] = ACTIONS(2169),
    [anon_sym_triangle] = ACTIONS(2169),
  },
  [2906] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2738),
    [sym_identifier] = ACTIONS(3778),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3781),
    [aux_sym_preproc_if_token2] = ACTIONS(3781),
    [aux_sym_preproc_else_token1] = ACTIONS(3781),
    [aux_sym_preproc_elif_token1] = ACTIONS(3778),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3781),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3781),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_DASH] = ACTIONS(3778),
    [anon_sym_PLUS] = ACTIONS(3778),
    [anon_sym_STAR] = ACTIONS(3781),
    [anon_sym_SLASH] = ACTIONS(3778),
    [anon_sym_PERCENT] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_PIPE] = ACTIONS(3778),
    [anon_sym_CARET] = ACTIONS(3781),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_GT] = ACTIONS(3778),
    [anon_sym_GT_EQ] = ACTIONS(3781),
    [anon_sym_LT_EQ] = ACTIONS(3778),
    [anon_sym_LT] = ACTIONS(3778),
    [anon_sym_LT_LT] = ACTIONS(3781),
    [anon_sym_GT_GT] = ACTIONS(3781),
    [anon_sym___extension__] = ACTIONS(3778),
    [anon_sym___attribute__] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_signed] = ACTIONS(6360),
    [anon_sym_unsigned] = ACTIONS(6360),
    [anon_sym_long] = ACTIONS(6360),
    [anon_sym_short] = ACTIONS(6360),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_const] = ACTIONS(3778),
    [anon_sym_constexpr] = ACTIONS(3778),
    [anon_sym_volatile] = ACTIONS(3778),
    [anon_sym_restrict] = ACTIONS(3778),
    [anon_sym___restrict__] = ACTIONS(3778),
    [anon_sym__Atomic] = ACTIONS(3778),
    [anon_sym__Noreturn] = ACTIONS(3778),
    [anon_sym_noreturn] = ACTIONS(3778),
    [anon_sym_mutable] = ACTIONS(3778),
    [anon_sym_constinit] = ACTIONS(3778),
    [anon_sym_consteval] = ACTIONS(3778),
    [anon_sym_alignas] = ACTIONS(3778),
    [anon_sym__Alignas] = ACTIONS(3778),
    [sym_primitive_type] = ACTIONS(2856),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_LT_EQ_GT] = ACTIONS(3781),
    [anon_sym_or] = ACTIONS(3778),
    [anon_sym_and] = ACTIONS(3778),
    [anon_sym_bitor] = ACTIONS(3778),
    [anon_sym_xor] = ACTIONS(3778),
    [anon_sym_bitand] = ACTIONS(3778),
    [anon_sym_not_eq] = ACTIONS(3778),
    [anon_sym_is] = ACTIONS(3778),
    [anon_sym_as] = ACTIONS(3778),
    [anon_sym_DASH_DASH] = ACTIONS(3781),
    [anon_sym_PLUS_PLUS] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(3778),
    [anon_sym_DOT_STAR] = ACTIONS(3781),
    [anon_sym_DASH_GT] = ACTIONS(3781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3778),
    [anon_sym_let] = ACTIONS(3778),
    [anon_sym_This] = ACTIONS(3778),
    [anon_sym_final] = ACTIONS(3778),
    [anon_sym_override] = ACTIONS(3778),
    [anon_sym_requires] = ACTIONS(3778),
    [anon_sym_where] = ACTIONS(3778),
  },
  [2907] = {
    [sym_identifier] = ACTIONS(3338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3336),
    [anon_sym_COMMA] = ACTIONS(3336),
    [anon_sym_RPAREN] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3338),
    [anon_sym_PLUS] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3336),
    [anon_sym_SLASH] = ACTIONS(3338),
    [anon_sym_PERCENT] = ACTIONS(3336),
    [anon_sym_PIPE_PIPE] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_PIPE] = ACTIONS(3338),
    [anon_sym_CARET] = ACTIONS(3336),
    [anon_sym_AMP] = ACTIONS(3338),
    [anon_sym_EQ_EQ] = ACTIONS(3336),
    [anon_sym_BANG_EQ] = ACTIONS(3336),
    [anon_sym_GT] = ACTIONS(3338),
    [anon_sym_GT_EQ] = ACTIONS(3336),
    [anon_sym_LT_EQ] = ACTIONS(3338),
    [anon_sym_LT] = ACTIONS(3338),
    [anon_sym_LT_LT] = ACTIONS(3336),
    [anon_sym_GT_GT] = ACTIONS(3336),
    [anon_sym_COLON] = ACTIONS(3336),
    [anon_sym_SEMI] = ACTIONS(3336),
    [anon_sym___extension__] = ACTIONS(3338),
    [anon_sym___attribute__] = ACTIONS(3338),
    [anon_sym___based] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_RBRACE] = ACTIONS(3336),
    [anon_sym_signed] = ACTIONS(3338),
    [anon_sym_unsigned] = ACTIONS(3338),
    [anon_sym_long] = ACTIONS(3338),
    [anon_sym_short] = ACTIONS(3338),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_RBRACK] = ACTIONS(3336),
    [anon_sym_const] = ACTIONS(3338),
    [anon_sym_constexpr] = ACTIONS(3338),
    [anon_sym_volatile] = ACTIONS(3338),
    [anon_sym_restrict] = ACTIONS(3338),
    [anon_sym___restrict__] = ACTIONS(3338),
    [anon_sym__Atomic] = ACTIONS(3338),
    [anon_sym__Noreturn] = ACTIONS(3338),
    [anon_sym_noreturn] = ACTIONS(3338),
    [anon_sym_mutable] = ACTIONS(3338),
    [anon_sym_constinit] = ACTIONS(3338),
    [anon_sym_consteval] = ACTIONS(3338),
    [anon_sym_alignas] = ACTIONS(3338),
    [anon_sym__Alignas] = ACTIONS(3338),
    [sym_primitive_type] = ACTIONS(3338),
    [anon_sym_QMARK] = ACTIONS(3336),
    [anon_sym_LT_EQ_GT] = ACTIONS(3336),
    [anon_sym_or] = ACTIONS(3338),
    [anon_sym_and] = ACTIONS(3338),
    [anon_sym_bitor] = ACTIONS(3338),
    [anon_sym_xor] = ACTIONS(3338),
    [anon_sym_bitand] = ACTIONS(3338),
    [anon_sym_not_eq] = ACTIONS(3338),
    [anon_sym_is] = ACTIONS(3338),
    [anon_sym_as] = ACTIONS(3338),
    [anon_sym_DASH_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_PLUS] = ACTIONS(3336),
    [anon_sym_DOT] = ACTIONS(3338),
    [anon_sym_DOT_STAR] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(3336),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3338),
    [anon_sym_let] = ACTIONS(3338),
    [anon_sym_This] = ACTIONS(3338),
    [anon_sym_final] = ACTIONS(3338),
    [anon_sym_override] = ACTIONS(3338),
    [anon_sym_requires] = ACTIONS(3338),
    [anon_sym_where] = ACTIONS(3338),
  },
  [2908] = {
    [sym_identifier] = ACTIONS(3338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3336),
    [anon_sym_COMMA] = ACTIONS(3336),
    [anon_sym_RPAREN] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3338),
    [anon_sym_PLUS] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3336),
    [anon_sym_SLASH] = ACTIONS(3338),
    [anon_sym_PERCENT] = ACTIONS(3336),
    [anon_sym_PIPE_PIPE] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_PIPE] = ACTIONS(3338),
    [anon_sym_CARET] = ACTIONS(3336),
    [anon_sym_AMP] = ACTIONS(3338),
    [anon_sym_EQ_EQ] = ACTIONS(3336),
    [anon_sym_BANG_EQ] = ACTIONS(3336),
    [anon_sym_GT] = ACTIONS(3338),
    [anon_sym_GT_EQ] = ACTIONS(3336),
    [anon_sym_LT_EQ] = ACTIONS(3338),
    [anon_sym_LT] = ACTIONS(3338),
    [anon_sym_LT_LT] = ACTIONS(3336),
    [anon_sym_GT_GT] = ACTIONS(3336),
    [anon_sym_COLON] = ACTIONS(3336),
    [anon_sym_SEMI] = ACTIONS(3336),
    [anon_sym___extension__] = ACTIONS(3338),
    [anon_sym___attribute__] = ACTIONS(3338),
    [anon_sym___based] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_RBRACE] = ACTIONS(3336),
    [anon_sym_signed] = ACTIONS(3338),
    [anon_sym_unsigned] = ACTIONS(3338),
    [anon_sym_long] = ACTIONS(3338),
    [anon_sym_short] = ACTIONS(3338),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_RBRACK] = ACTIONS(3336),
    [anon_sym_const] = ACTIONS(3338),
    [anon_sym_constexpr] = ACTIONS(3338),
    [anon_sym_volatile] = ACTIONS(3338),
    [anon_sym_restrict] = ACTIONS(3338),
    [anon_sym___restrict__] = ACTIONS(3338),
    [anon_sym__Atomic] = ACTIONS(3338),
    [anon_sym__Noreturn] = ACTIONS(3338),
    [anon_sym_noreturn] = ACTIONS(3338),
    [anon_sym_mutable] = ACTIONS(3338),
    [anon_sym_constinit] = ACTIONS(3338),
    [anon_sym_consteval] = ACTIONS(3338),
    [anon_sym_alignas] = ACTIONS(3338),
    [anon_sym__Alignas] = ACTIONS(3338),
    [sym_primitive_type] = ACTIONS(3338),
    [anon_sym_QMARK] = ACTIONS(3336),
    [anon_sym_LT_EQ_GT] = ACTIONS(3336),
    [anon_sym_or] = ACTIONS(3338),
    [anon_sym_and] = ACTIONS(3338),
    [anon_sym_bitor] = ACTIONS(3338),
    [anon_sym_xor] = ACTIONS(3338),
    [anon_sym_bitand] = ACTIONS(3338),
    [anon_sym_not_eq] = ACTIONS(3338),
    [anon_sym_is] = ACTIONS(3338),
    [anon_sym_as] = ACTIONS(3338),
    [anon_sym_DASH_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_PLUS] = ACTIONS(3336),
    [anon_sym_DOT] = ACTIONS(3338),
    [anon_sym_DOT_STAR] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(3336),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3338),
    [anon_sym_let] = ACTIONS(3338),
    [anon_sym_This] = ACTIONS(3338),
    [anon_sym_final] = ACTIONS(3338),
    [anon_sym_override] = ACTIONS(3338),
    [anon_sym_requires] = ACTIONS(3338),
    [anon_sym_where] = ACTIONS(3338),
  },
  [2909] = {
    [sym_identifier] = ACTIONS(3388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3386),
    [anon_sym_COMMA] = ACTIONS(3386),
    [anon_sym_RPAREN] = ACTIONS(3386),
    [anon_sym_LPAREN2] = ACTIONS(3386),
    [anon_sym_DASH] = ACTIONS(3388),
    [anon_sym_PLUS] = ACTIONS(3388),
    [anon_sym_STAR] = ACTIONS(3386),
    [anon_sym_SLASH] = ACTIONS(3388),
    [anon_sym_PERCENT] = ACTIONS(3386),
    [anon_sym_PIPE_PIPE] = ACTIONS(3386),
    [anon_sym_AMP_AMP] = ACTIONS(3386),
    [anon_sym_PIPE] = ACTIONS(3388),
    [anon_sym_CARET] = ACTIONS(3386),
    [anon_sym_AMP] = ACTIONS(3388),
    [anon_sym_EQ_EQ] = ACTIONS(3386),
    [anon_sym_BANG_EQ] = ACTIONS(3386),
    [anon_sym_GT] = ACTIONS(3388),
    [anon_sym_GT_EQ] = ACTIONS(3386),
    [anon_sym_LT_EQ] = ACTIONS(3388),
    [anon_sym_LT] = ACTIONS(3388),
    [anon_sym_LT_LT] = ACTIONS(3386),
    [anon_sym_GT_GT] = ACTIONS(3386),
    [anon_sym_COLON] = ACTIONS(3386),
    [anon_sym_SEMI] = ACTIONS(3386),
    [anon_sym___extension__] = ACTIONS(3388),
    [anon_sym___attribute__] = ACTIONS(3388),
    [anon_sym___based] = ACTIONS(3388),
    [anon_sym_LBRACE] = ACTIONS(3386),
    [anon_sym_RBRACE] = ACTIONS(3386),
    [anon_sym_signed] = ACTIONS(3388),
    [anon_sym_unsigned] = ACTIONS(3388),
    [anon_sym_long] = ACTIONS(3388),
    [anon_sym_short] = ACTIONS(3388),
    [anon_sym_LBRACK] = ACTIONS(3386),
    [anon_sym_RBRACK] = ACTIONS(3386),
    [anon_sym_const] = ACTIONS(3388),
    [anon_sym_constexpr] = ACTIONS(3388),
    [anon_sym_volatile] = ACTIONS(3388),
    [anon_sym_restrict] = ACTIONS(3388),
    [anon_sym___restrict__] = ACTIONS(3388),
    [anon_sym__Atomic] = ACTIONS(3388),
    [anon_sym__Noreturn] = ACTIONS(3388),
    [anon_sym_noreturn] = ACTIONS(3388),
    [anon_sym_mutable] = ACTIONS(3388),
    [anon_sym_constinit] = ACTIONS(3388),
    [anon_sym_consteval] = ACTIONS(3388),
    [anon_sym_alignas] = ACTIONS(3388),
    [anon_sym__Alignas] = ACTIONS(3388),
    [sym_primitive_type] = ACTIONS(3388),
    [anon_sym_QMARK] = ACTIONS(3386),
    [anon_sym_LT_EQ_GT] = ACTIONS(3386),
    [anon_sym_or] = ACTIONS(3388),
    [anon_sym_and] = ACTIONS(3388),
    [anon_sym_bitor] = ACTIONS(3388),
    [anon_sym_xor] = ACTIONS(3388),
    [anon_sym_bitand] = ACTIONS(3388),
    [anon_sym_not_eq] = ACTIONS(3388),
    [anon_sym_is] = ACTIONS(3388),
    [anon_sym_as] = ACTIONS(3388),
    [anon_sym_DASH_DASH] = ACTIONS(3386),
    [anon_sym_PLUS_PLUS] = ACTIONS(3386),
    [anon_sym_DOT] = ACTIONS(3388),
    [anon_sym_DOT_STAR] = ACTIONS(3386),
    [anon_sym_DASH_GT] = ACTIONS(3386),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3388),
    [anon_sym_let] = ACTIONS(3388),
    [anon_sym_This] = ACTIONS(3388),
    [anon_sym_final] = ACTIONS(3388),
    [anon_sym_override] = ACTIONS(3388),
    [anon_sym_requires] = ACTIONS(3388),
    [anon_sym_where] = ACTIONS(3388),
  },
  [2910] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2214),
    [anon_sym_COMMA] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(2214),
    [anon_sym_DASH] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(2222),
    [anon_sym_STAR] = ACTIONS(2219),
    [anon_sym_SLASH] = ACTIONS(2222),
    [anon_sym_PERCENT] = ACTIONS(2222),
    [anon_sym_PIPE_PIPE] = ACTIONS(2212),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2222),
    [anon_sym_CARET] = ACTIONS(2222),
    [anon_sym_AMP] = ACTIONS(2219),
    [anon_sym_EQ_EQ] = ACTIONS(2212),
    [anon_sym_BANG_EQ] = ACTIONS(2212),
    [anon_sym_GT] = ACTIONS(2222),
    [anon_sym_GT_EQ] = ACTIONS(2222),
    [anon_sym_LT_EQ] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(2222),
    [anon_sym_LT_LT] = ACTIONS(2222),
    [anon_sym_GT_GT] = ACTIONS(2222),
    [anon_sym_COLON] = ACTIONS(2210),
    [anon_sym___extension__] = ACTIONS(2217),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2217),
    [anon_sym_LBRACK] = ACTIONS(2214),
    [anon_sym_EQ] = ACTIONS(2219),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_constexpr] = ACTIONS(2217),
    [anon_sym_volatile] = ACTIONS(2217),
    [anon_sym_restrict] = ACTIONS(2217),
    [anon_sym___restrict__] = ACTIONS(2217),
    [anon_sym__Atomic] = ACTIONS(2217),
    [anon_sym__Noreturn] = ACTIONS(2217),
    [anon_sym_noreturn] = ACTIONS(2217),
    [anon_sym_mutable] = ACTIONS(2217),
    [anon_sym_constinit] = ACTIONS(2217),
    [anon_sym_consteval] = ACTIONS(2217),
    [anon_sym_alignas] = ACTIONS(2217),
    [anon_sym__Alignas] = ACTIONS(2217),
    [anon_sym_QMARK] = ACTIONS(2212),
    [anon_sym_STAR_EQ] = ACTIONS(2212),
    [anon_sym_SLASH_EQ] = ACTIONS(2212),
    [anon_sym_PERCENT_EQ] = ACTIONS(2212),
    [anon_sym_PLUS_EQ] = ACTIONS(2212),
    [anon_sym_DASH_EQ] = ACTIONS(2212),
    [anon_sym_LT_LT_EQ] = ACTIONS(2212),
    [anon_sym_GT_GT_EQ] = ACTIONS(2222),
    [anon_sym_AMP_EQ] = ACTIONS(2212),
    [anon_sym_CARET_EQ] = ACTIONS(2212),
    [anon_sym_PIPE_EQ] = ACTIONS(2212),
    [anon_sym_and_eq] = ACTIONS(2212),
    [anon_sym_or_eq] = ACTIONS(2212),
    [anon_sym_xor_eq] = ACTIONS(2212),
    [anon_sym_LT_EQ_GT] = ACTIONS(2212),
    [anon_sym_or] = ACTIONS(2222),
    [anon_sym_and] = ACTIONS(2222),
    [anon_sym_bitor] = ACTIONS(2212),
    [anon_sym_xor] = ACTIONS(2222),
    [anon_sym_bitand] = ACTIONS(2212),
    [anon_sym_not_eq] = ACTIONS(2212),
    [anon_sym_is] = ACTIONS(2212),
    [anon_sym_as] = ACTIONS(2212),
    [anon_sym_DASH_DASH] = ACTIONS(2212),
    [anon_sym_PLUS_PLUS] = ACTIONS(2212),
    [anon_sym_DOT] = ACTIONS(2219),
    [anon_sym_DOT_STAR] = ACTIONS(2212),
    [anon_sym_DASH_GT] = ACTIONS(2212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2217),
    [anon_sym_let] = ACTIONS(2217),
    [anon_sym_This] = ACTIONS(2217),
    [anon_sym_GT2] = ACTIONS(2214),
  },
  [2911] = {
    [sym_identifier] = ACTIONS(2996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2994),
    [anon_sym_COMMA] = ACTIONS(2994),
    [anon_sym_RPAREN] = ACTIONS(2994),
    [anon_sym_LPAREN2] = ACTIONS(2994),
    [anon_sym_DASH] = ACTIONS(2996),
    [anon_sym_PLUS] = ACTIONS(2996),
    [anon_sym_STAR] = ACTIONS(2994),
    [anon_sym_SLASH] = ACTIONS(2996),
    [anon_sym_PERCENT] = ACTIONS(2994),
    [anon_sym_PIPE_PIPE] = ACTIONS(2994),
    [anon_sym_AMP_AMP] = ACTIONS(2994),
    [anon_sym_PIPE] = ACTIONS(2996),
    [anon_sym_CARET] = ACTIONS(2994),
    [anon_sym_AMP] = ACTIONS(2996),
    [anon_sym_EQ_EQ] = ACTIONS(2994),
    [anon_sym_BANG_EQ] = ACTIONS(2994),
    [anon_sym_GT] = ACTIONS(2996),
    [anon_sym_GT_EQ] = ACTIONS(2994),
    [anon_sym_LT_EQ] = ACTIONS(2996),
    [anon_sym_LT] = ACTIONS(2996),
    [anon_sym_LT_LT] = ACTIONS(2994),
    [anon_sym_GT_GT] = ACTIONS(2994),
    [anon_sym_COLON] = ACTIONS(2994),
    [anon_sym_SEMI] = ACTIONS(2994),
    [anon_sym___extension__] = ACTIONS(2996),
    [anon_sym___attribute__] = ACTIONS(2996),
    [anon_sym___based] = ACTIONS(2996),
    [anon_sym_LBRACE] = ACTIONS(2994),
    [anon_sym_RBRACE] = ACTIONS(2994),
    [anon_sym_signed] = ACTIONS(2996),
    [anon_sym_unsigned] = ACTIONS(2996),
    [anon_sym_long] = ACTIONS(2996),
    [anon_sym_short] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(2994),
    [anon_sym_RBRACK] = ACTIONS(2994),
    [anon_sym_const] = ACTIONS(2996),
    [anon_sym_constexpr] = ACTIONS(2996),
    [anon_sym_volatile] = ACTIONS(2996),
    [anon_sym_restrict] = ACTIONS(2996),
    [anon_sym___restrict__] = ACTIONS(2996),
    [anon_sym__Atomic] = ACTIONS(2996),
    [anon_sym__Noreturn] = ACTIONS(2996),
    [anon_sym_noreturn] = ACTIONS(2996),
    [anon_sym_mutable] = ACTIONS(2996),
    [anon_sym_constinit] = ACTIONS(2996),
    [anon_sym_consteval] = ACTIONS(2996),
    [anon_sym_alignas] = ACTIONS(2996),
    [anon_sym__Alignas] = ACTIONS(2996),
    [sym_primitive_type] = ACTIONS(2996),
    [anon_sym_QMARK] = ACTIONS(2994),
    [anon_sym_LT_EQ_GT] = ACTIONS(2994),
    [anon_sym_or] = ACTIONS(2996),
    [anon_sym_and] = ACTIONS(2996),
    [anon_sym_bitor] = ACTIONS(2996),
    [anon_sym_xor] = ACTIONS(2996),
    [anon_sym_bitand] = ACTIONS(2996),
    [anon_sym_not_eq] = ACTIONS(2996),
    [anon_sym_is] = ACTIONS(2996),
    [anon_sym_as] = ACTIONS(2996),
    [anon_sym_DASH_DASH] = ACTIONS(2994),
    [anon_sym_PLUS_PLUS] = ACTIONS(2994),
    [anon_sym_DOT] = ACTIONS(2996),
    [anon_sym_DOT_STAR] = ACTIONS(2994),
    [anon_sym_DASH_GT] = ACTIONS(2994),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2996),
    [anon_sym_let] = ACTIONS(2996),
    [anon_sym_This] = ACTIONS(2996),
    [anon_sym_final] = ACTIONS(2996),
    [anon_sym_override] = ACTIONS(2996),
    [anon_sym_requires] = ACTIONS(2996),
    [anon_sym_where] = ACTIONS(2996),
  },
  [2912] = {
    [sym_identifier] = ACTIONS(3090),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3088),
    [anon_sym_COMMA] = ACTIONS(3088),
    [anon_sym_RPAREN] = ACTIONS(3088),
    [anon_sym_LPAREN2] = ACTIONS(3088),
    [anon_sym_DASH] = ACTIONS(3090),
    [anon_sym_PLUS] = ACTIONS(3090),
    [anon_sym_STAR] = ACTIONS(3088),
    [anon_sym_SLASH] = ACTIONS(3090),
    [anon_sym_PERCENT] = ACTIONS(3088),
    [anon_sym_PIPE_PIPE] = ACTIONS(3088),
    [anon_sym_AMP_AMP] = ACTIONS(3088),
    [anon_sym_PIPE] = ACTIONS(3090),
    [anon_sym_CARET] = ACTIONS(3088),
    [anon_sym_AMP] = ACTIONS(3090),
    [anon_sym_EQ_EQ] = ACTIONS(3088),
    [anon_sym_BANG_EQ] = ACTIONS(3088),
    [anon_sym_GT] = ACTIONS(3090),
    [anon_sym_GT_EQ] = ACTIONS(3088),
    [anon_sym_LT_EQ] = ACTIONS(3090),
    [anon_sym_LT] = ACTIONS(3090),
    [anon_sym_LT_LT] = ACTIONS(3088),
    [anon_sym_GT_GT] = ACTIONS(3088),
    [anon_sym_COLON] = ACTIONS(3088),
    [anon_sym_SEMI] = ACTIONS(3088),
    [anon_sym___extension__] = ACTIONS(3090),
    [anon_sym___attribute__] = ACTIONS(3090),
    [anon_sym___based] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3088),
    [anon_sym_RBRACE] = ACTIONS(3088),
    [anon_sym_signed] = ACTIONS(3090),
    [anon_sym_unsigned] = ACTIONS(3090),
    [anon_sym_long] = ACTIONS(3090),
    [anon_sym_short] = ACTIONS(3090),
    [anon_sym_LBRACK] = ACTIONS(3088),
    [anon_sym_RBRACK] = ACTIONS(3088),
    [anon_sym_const] = ACTIONS(3090),
    [anon_sym_constexpr] = ACTIONS(3090),
    [anon_sym_volatile] = ACTIONS(3090),
    [anon_sym_restrict] = ACTIONS(3090),
    [anon_sym___restrict__] = ACTIONS(3090),
    [anon_sym__Atomic] = ACTIONS(3090),
    [anon_sym__Noreturn] = ACTIONS(3090),
    [anon_sym_noreturn] = ACTIONS(3090),
    [anon_sym_mutable] = ACTIONS(3090),
    [anon_sym_constinit] = ACTIONS(3090),
    [anon_sym_consteval] = ACTIONS(3090),
    [anon_sym_alignas] = ACTIONS(3090),
    [anon_sym__Alignas] = ACTIONS(3090),
    [sym_primitive_type] = ACTIONS(3090),
    [anon_sym_QMARK] = ACTIONS(3088),
    [anon_sym_LT_EQ_GT] = ACTIONS(3088),
    [anon_sym_or] = ACTIONS(3090),
    [anon_sym_and] = ACTIONS(3090),
    [anon_sym_bitor] = ACTIONS(3090),
    [anon_sym_xor] = ACTIONS(3090),
    [anon_sym_bitand] = ACTIONS(3090),
    [anon_sym_not_eq] = ACTIONS(3090),
    [anon_sym_is] = ACTIONS(3090),
    [anon_sym_as] = ACTIONS(3090),
    [anon_sym_DASH_DASH] = ACTIONS(3088),
    [anon_sym_PLUS_PLUS] = ACTIONS(3088),
    [anon_sym_DOT] = ACTIONS(3090),
    [anon_sym_DOT_STAR] = ACTIONS(3088),
    [anon_sym_DASH_GT] = ACTIONS(3088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3090),
    [anon_sym_let] = ACTIONS(3090),
    [anon_sym_This] = ACTIONS(3090),
    [anon_sym_final] = ACTIONS(3090),
    [anon_sym_override] = ACTIONS(3090),
    [anon_sym_requires] = ACTIONS(3090),
    [anon_sym_where] = ACTIONS(3090),
  },
  [2913] = {
    [sym_identifier] = ACTIONS(2742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2740),
    [anon_sym_COMMA] = ACTIONS(2740),
    [anon_sym_RPAREN] = ACTIONS(2740),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2742),
    [anon_sym_PLUS] = ACTIONS(2742),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_SLASH] = ACTIONS(2742),
    [anon_sym_PERCENT] = ACTIONS(2740),
    [anon_sym_PIPE_PIPE] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_PIPE] = ACTIONS(2742),
    [anon_sym_CARET] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_EQ_EQ] = ACTIONS(2740),
    [anon_sym_BANG_EQ] = ACTIONS(2740),
    [anon_sym_GT] = ACTIONS(2742),
    [anon_sym_GT_EQ] = ACTIONS(2740),
    [anon_sym_LT_EQ] = ACTIONS(2742),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_LT_LT] = ACTIONS(2740),
    [anon_sym_GT_GT] = ACTIONS(2740),
    [anon_sym_COLON] = ACTIONS(2740),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym___extension__] = ACTIONS(2742),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym___based] = ACTIONS(2742),
    [anon_sym_LBRACE] = ACTIONS(2740),
    [anon_sym_RBRACE] = ACTIONS(2740),
    [anon_sym_signed] = ACTIONS(2742),
    [anon_sym_unsigned] = ACTIONS(2742),
    [anon_sym_long] = ACTIONS(2742),
    [anon_sym_short] = ACTIONS(2742),
    [anon_sym_LBRACK] = ACTIONS(2740),
    [anon_sym_RBRACK] = ACTIONS(2740),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_constexpr] = ACTIONS(2742),
    [anon_sym_volatile] = ACTIONS(2742),
    [anon_sym_restrict] = ACTIONS(2742),
    [anon_sym___restrict__] = ACTIONS(2742),
    [anon_sym__Atomic] = ACTIONS(2742),
    [anon_sym__Noreturn] = ACTIONS(2742),
    [anon_sym_noreturn] = ACTIONS(2742),
    [anon_sym_mutable] = ACTIONS(2742),
    [anon_sym_constinit] = ACTIONS(2742),
    [anon_sym_consteval] = ACTIONS(2742),
    [anon_sym_alignas] = ACTIONS(2742),
    [anon_sym__Alignas] = ACTIONS(2742),
    [sym_primitive_type] = ACTIONS(2742),
    [anon_sym_QMARK] = ACTIONS(2740),
    [anon_sym_LT_EQ_GT] = ACTIONS(2740),
    [anon_sym_or] = ACTIONS(2742),
    [anon_sym_and] = ACTIONS(2742),
    [anon_sym_bitor] = ACTIONS(2742),
    [anon_sym_xor] = ACTIONS(2742),
    [anon_sym_bitand] = ACTIONS(2742),
    [anon_sym_not_eq] = ACTIONS(2742),
    [anon_sym_is] = ACTIONS(2742),
    [anon_sym_as] = ACTIONS(2742),
    [anon_sym_DASH_DASH] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2740),
    [anon_sym_DOT] = ACTIONS(2742),
    [anon_sym_DOT_STAR] = ACTIONS(2740),
    [anon_sym_DASH_GT] = ACTIONS(2740),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
    [anon_sym_final] = ACTIONS(2742),
    [anon_sym_override] = ACTIONS(2742),
    [anon_sym_requires] = ACTIONS(2742),
    [anon_sym_where] = ACTIONS(2742),
  },
  [2914] = {
    [sym_identifier] = ACTIONS(3396),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3394),
    [anon_sym_COMMA] = ACTIONS(3394),
    [anon_sym_RPAREN] = ACTIONS(3394),
    [anon_sym_LPAREN2] = ACTIONS(3394),
    [anon_sym_DASH] = ACTIONS(3396),
    [anon_sym_PLUS] = ACTIONS(3396),
    [anon_sym_STAR] = ACTIONS(3394),
    [anon_sym_SLASH] = ACTIONS(3396),
    [anon_sym_PERCENT] = ACTIONS(3394),
    [anon_sym_PIPE_PIPE] = ACTIONS(3394),
    [anon_sym_AMP_AMP] = ACTIONS(3394),
    [anon_sym_PIPE] = ACTIONS(3396),
    [anon_sym_CARET] = ACTIONS(3394),
    [anon_sym_AMP] = ACTIONS(3396),
    [anon_sym_EQ_EQ] = ACTIONS(3394),
    [anon_sym_BANG_EQ] = ACTIONS(3394),
    [anon_sym_GT] = ACTIONS(3396),
    [anon_sym_GT_EQ] = ACTIONS(3394),
    [anon_sym_LT_EQ] = ACTIONS(3396),
    [anon_sym_LT] = ACTIONS(3396),
    [anon_sym_LT_LT] = ACTIONS(3394),
    [anon_sym_GT_GT] = ACTIONS(3394),
    [anon_sym_COLON] = ACTIONS(3394),
    [anon_sym_SEMI] = ACTIONS(3394),
    [anon_sym___extension__] = ACTIONS(3396),
    [anon_sym___attribute__] = ACTIONS(3396),
    [anon_sym___based] = ACTIONS(3396),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_RBRACE] = ACTIONS(3394),
    [anon_sym_signed] = ACTIONS(3396),
    [anon_sym_unsigned] = ACTIONS(3396),
    [anon_sym_long] = ACTIONS(3396),
    [anon_sym_short] = ACTIONS(3396),
    [anon_sym_LBRACK] = ACTIONS(3394),
    [anon_sym_RBRACK] = ACTIONS(3394),
    [anon_sym_const] = ACTIONS(3396),
    [anon_sym_constexpr] = ACTIONS(3396),
    [anon_sym_volatile] = ACTIONS(3396),
    [anon_sym_restrict] = ACTIONS(3396),
    [anon_sym___restrict__] = ACTIONS(3396),
    [anon_sym__Atomic] = ACTIONS(3396),
    [anon_sym__Noreturn] = ACTIONS(3396),
    [anon_sym_noreturn] = ACTIONS(3396),
    [anon_sym_mutable] = ACTIONS(3396),
    [anon_sym_constinit] = ACTIONS(3396),
    [anon_sym_consteval] = ACTIONS(3396),
    [anon_sym_alignas] = ACTIONS(3396),
    [anon_sym__Alignas] = ACTIONS(3396),
    [sym_primitive_type] = ACTIONS(3396),
    [anon_sym_QMARK] = ACTIONS(3394),
    [anon_sym_LT_EQ_GT] = ACTIONS(3394),
    [anon_sym_or] = ACTIONS(3396),
    [anon_sym_and] = ACTIONS(3396),
    [anon_sym_bitor] = ACTIONS(3396),
    [anon_sym_xor] = ACTIONS(3396),
    [anon_sym_bitand] = ACTIONS(3396),
    [anon_sym_not_eq] = ACTIONS(3396),
    [anon_sym_is] = ACTIONS(3396),
    [anon_sym_as] = ACTIONS(3396),
    [anon_sym_DASH_DASH] = ACTIONS(3394),
    [anon_sym_PLUS_PLUS] = ACTIONS(3394),
    [anon_sym_DOT] = ACTIONS(3396),
    [anon_sym_DOT_STAR] = ACTIONS(3394),
    [anon_sym_DASH_GT] = ACTIONS(3394),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3396),
    [anon_sym_let] = ACTIONS(3396),
    [anon_sym_This] = ACTIONS(3396),
    [anon_sym_final] = ACTIONS(3396),
    [anon_sym_override] = ACTIONS(3396),
    [anon_sym_requires] = ACTIONS(3396),
    [anon_sym_where] = ACTIONS(3396),
  },
  [2915] = {
    [sym_identifier] = ACTIONS(2948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2946),
    [anon_sym_COMMA] = ACTIONS(2946),
    [anon_sym_RPAREN] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2948),
    [anon_sym_PLUS] = ACTIONS(2948),
    [anon_sym_STAR] = ACTIONS(2946),
    [anon_sym_SLASH] = ACTIONS(2948),
    [anon_sym_PERCENT] = ACTIONS(2946),
    [anon_sym_PIPE_PIPE] = ACTIONS(2946),
    [anon_sym_AMP_AMP] = ACTIONS(2946),
    [anon_sym_PIPE] = ACTIONS(2948),
    [anon_sym_CARET] = ACTIONS(2946),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_EQ_EQ] = ACTIONS(2946),
    [anon_sym_BANG_EQ] = ACTIONS(2946),
    [anon_sym_GT] = ACTIONS(2948),
    [anon_sym_GT_EQ] = ACTIONS(2946),
    [anon_sym_LT_EQ] = ACTIONS(2948),
    [anon_sym_LT] = ACTIONS(2948),
    [anon_sym_LT_LT] = ACTIONS(2946),
    [anon_sym_GT_GT] = ACTIONS(2946),
    [anon_sym_COLON] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2946),
    [anon_sym___extension__] = ACTIONS(2948),
    [anon_sym___attribute__] = ACTIONS(2948),
    [anon_sym___based] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2946),
    [anon_sym_RBRACE] = ACTIONS(2946),
    [anon_sym_signed] = ACTIONS(2948),
    [anon_sym_unsigned] = ACTIONS(2948),
    [anon_sym_long] = ACTIONS(2948),
    [anon_sym_short] = ACTIONS(2948),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_RBRACK] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2948),
    [anon_sym_constexpr] = ACTIONS(2948),
    [anon_sym_volatile] = ACTIONS(2948),
    [anon_sym_restrict] = ACTIONS(2948),
    [anon_sym___restrict__] = ACTIONS(2948),
    [anon_sym__Atomic] = ACTIONS(2948),
    [anon_sym__Noreturn] = ACTIONS(2948),
    [anon_sym_noreturn] = ACTIONS(2948),
    [anon_sym_mutable] = ACTIONS(2948),
    [anon_sym_constinit] = ACTIONS(2948),
    [anon_sym_consteval] = ACTIONS(2948),
    [anon_sym_alignas] = ACTIONS(2948),
    [anon_sym__Alignas] = ACTIONS(2948),
    [sym_primitive_type] = ACTIONS(2948),
    [anon_sym_QMARK] = ACTIONS(2946),
    [anon_sym_LT_EQ_GT] = ACTIONS(2946),
    [anon_sym_or] = ACTIONS(2948),
    [anon_sym_and] = ACTIONS(2948),
    [anon_sym_bitor] = ACTIONS(2948),
    [anon_sym_xor] = ACTIONS(2948),
    [anon_sym_bitand] = ACTIONS(2948),
    [anon_sym_not_eq] = ACTIONS(2948),
    [anon_sym_is] = ACTIONS(2948),
    [anon_sym_as] = ACTIONS(2948),
    [anon_sym_DASH_DASH] = ACTIONS(2946),
    [anon_sym_PLUS_PLUS] = ACTIONS(2946),
    [anon_sym_DOT] = ACTIONS(2948),
    [anon_sym_DOT_STAR] = ACTIONS(2946),
    [anon_sym_DASH_GT] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2948),
    [anon_sym_let] = ACTIONS(2948),
    [anon_sym_This] = ACTIONS(2948),
    [anon_sym_final] = ACTIONS(2948),
    [anon_sym_override] = ACTIONS(2948),
    [anon_sym_requires] = ACTIONS(2948),
    [anon_sym_where] = ACTIONS(2948),
  },
  [2916] = {
    [sym_identifier] = ACTIONS(3404),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3402),
    [anon_sym_COMMA] = ACTIONS(3402),
    [anon_sym_RPAREN] = ACTIONS(3402),
    [anon_sym_LPAREN2] = ACTIONS(3402),
    [anon_sym_DASH] = ACTIONS(3404),
    [anon_sym_PLUS] = ACTIONS(3404),
    [anon_sym_STAR] = ACTIONS(3402),
    [anon_sym_SLASH] = ACTIONS(3404),
    [anon_sym_PERCENT] = ACTIONS(3402),
    [anon_sym_PIPE_PIPE] = ACTIONS(3402),
    [anon_sym_AMP_AMP] = ACTIONS(3402),
    [anon_sym_PIPE] = ACTIONS(3404),
    [anon_sym_CARET] = ACTIONS(3402),
    [anon_sym_AMP] = ACTIONS(3404),
    [anon_sym_EQ_EQ] = ACTIONS(3402),
    [anon_sym_BANG_EQ] = ACTIONS(3402),
    [anon_sym_GT] = ACTIONS(3404),
    [anon_sym_GT_EQ] = ACTIONS(3402),
    [anon_sym_LT_EQ] = ACTIONS(3404),
    [anon_sym_LT] = ACTIONS(3404),
    [anon_sym_LT_LT] = ACTIONS(3402),
    [anon_sym_GT_GT] = ACTIONS(3402),
    [anon_sym_COLON] = ACTIONS(3402),
    [anon_sym_SEMI] = ACTIONS(3402),
    [anon_sym___extension__] = ACTIONS(3404),
    [anon_sym___attribute__] = ACTIONS(3404),
    [anon_sym___based] = ACTIONS(3404),
    [anon_sym_LBRACE] = ACTIONS(3402),
    [anon_sym_RBRACE] = ACTIONS(3402),
    [anon_sym_signed] = ACTIONS(3404),
    [anon_sym_unsigned] = ACTIONS(3404),
    [anon_sym_long] = ACTIONS(3404),
    [anon_sym_short] = ACTIONS(3404),
    [anon_sym_LBRACK] = ACTIONS(3402),
    [anon_sym_RBRACK] = ACTIONS(3402),
    [anon_sym_const] = ACTIONS(3404),
    [anon_sym_constexpr] = ACTIONS(3404),
    [anon_sym_volatile] = ACTIONS(3404),
    [anon_sym_restrict] = ACTIONS(3404),
    [anon_sym___restrict__] = ACTIONS(3404),
    [anon_sym__Atomic] = ACTIONS(3404),
    [anon_sym__Noreturn] = ACTIONS(3404),
    [anon_sym_noreturn] = ACTIONS(3404),
    [anon_sym_mutable] = ACTIONS(3404),
    [anon_sym_constinit] = ACTIONS(3404),
    [anon_sym_consteval] = ACTIONS(3404),
    [anon_sym_alignas] = ACTIONS(3404),
    [anon_sym__Alignas] = ACTIONS(3404),
    [sym_primitive_type] = ACTIONS(3404),
    [anon_sym_QMARK] = ACTIONS(3402),
    [anon_sym_LT_EQ_GT] = ACTIONS(3402),
    [anon_sym_or] = ACTIONS(3404),
    [anon_sym_and] = ACTIONS(3404),
    [anon_sym_bitor] = ACTIONS(3404),
    [anon_sym_xor] = ACTIONS(3404),
    [anon_sym_bitand] = ACTIONS(3404),
    [anon_sym_not_eq] = ACTIONS(3404),
    [anon_sym_is] = ACTIONS(3404),
    [anon_sym_as] = ACTIONS(3404),
    [anon_sym_DASH_DASH] = ACTIONS(3402),
    [anon_sym_PLUS_PLUS] = ACTIONS(3402),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_DOT_STAR] = ACTIONS(3402),
    [anon_sym_DASH_GT] = ACTIONS(3402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3404),
    [anon_sym_let] = ACTIONS(3404),
    [anon_sym_This] = ACTIONS(3404),
    [anon_sym_final] = ACTIONS(3404),
    [anon_sym_override] = ACTIONS(3404),
    [anon_sym_requires] = ACTIONS(3404),
    [anon_sym_where] = ACTIONS(3404),
  },
  [2917] = {
    [sym_identifier] = ACTIONS(2988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2986),
    [anon_sym_COMMA] = ACTIONS(2986),
    [anon_sym_RPAREN] = ACTIONS(2986),
    [anon_sym_LPAREN2] = ACTIONS(2986),
    [anon_sym_DASH] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_STAR] = ACTIONS(2986),
    [anon_sym_SLASH] = ACTIONS(2988),
    [anon_sym_PERCENT] = ACTIONS(2986),
    [anon_sym_PIPE_PIPE] = ACTIONS(2986),
    [anon_sym_AMP_AMP] = ACTIONS(2986),
    [anon_sym_PIPE] = ACTIONS(2988),
    [anon_sym_CARET] = ACTIONS(2986),
    [anon_sym_AMP] = ACTIONS(2988),
    [anon_sym_EQ_EQ] = ACTIONS(2986),
    [anon_sym_BANG_EQ] = ACTIONS(2986),
    [anon_sym_GT] = ACTIONS(2988),
    [anon_sym_GT_EQ] = ACTIONS(2986),
    [anon_sym_LT_EQ] = ACTIONS(2988),
    [anon_sym_LT] = ACTIONS(2988),
    [anon_sym_LT_LT] = ACTIONS(2986),
    [anon_sym_GT_GT] = ACTIONS(2986),
    [anon_sym_COLON] = ACTIONS(2986),
    [anon_sym_SEMI] = ACTIONS(2986),
    [anon_sym___extension__] = ACTIONS(2988),
    [anon_sym___attribute__] = ACTIONS(2988),
    [anon_sym___based] = ACTIONS(2988),
    [anon_sym_LBRACE] = ACTIONS(2986),
    [anon_sym_RBRACE] = ACTIONS(2986),
    [anon_sym_signed] = ACTIONS(2988),
    [anon_sym_unsigned] = ACTIONS(2988),
    [anon_sym_long] = ACTIONS(2988),
    [anon_sym_short] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2986),
    [anon_sym_RBRACK] = ACTIONS(2986),
    [anon_sym_const] = ACTIONS(2988),
    [anon_sym_constexpr] = ACTIONS(2988),
    [anon_sym_volatile] = ACTIONS(2988),
    [anon_sym_restrict] = ACTIONS(2988),
    [anon_sym___restrict__] = ACTIONS(2988),
    [anon_sym__Atomic] = ACTIONS(2988),
    [anon_sym__Noreturn] = ACTIONS(2988),
    [anon_sym_noreturn] = ACTIONS(2988),
    [anon_sym_mutable] = ACTIONS(2988),
    [anon_sym_constinit] = ACTIONS(2988),
    [anon_sym_consteval] = ACTIONS(2988),
    [anon_sym_alignas] = ACTIONS(2988),
    [anon_sym__Alignas] = ACTIONS(2988),
    [sym_primitive_type] = ACTIONS(2988),
    [anon_sym_QMARK] = ACTIONS(2986),
    [anon_sym_LT_EQ_GT] = ACTIONS(2986),
    [anon_sym_or] = ACTIONS(2988),
    [anon_sym_and] = ACTIONS(2988),
    [anon_sym_bitor] = ACTIONS(2988),
    [anon_sym_xor] = ACTIONS(2988),
    [anon_sym_bitand] = ACTIONS(2988),
    [anon_sym_not_eq] = ACTIONS(2988),
    [anon_sym_is] = ACTIONS(2988),
    [anon_sym_as] = ACTIONS(2988),
    [anon_sym_DASH_DASH] = ACTIONS(2986),
    [anon_sym_PLUS_PLUS] = ACTIONS(2986),
    [anon_sym_DOT] = ACTIONS(2988),
    [anon_sym_DOT_STAR] = ACTIONS(2986),
    [anon_sym_DASH_GT] = ACTIONS(2986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2988),
    [anon_sym_let] = ACTIONS(2988),
    [anon_sym_This] = ACTIONS(2988),
    [anon_sym_final] = ACTIONS(2988),
    [anon_sym_override] = ACTIONS(2988),
    [anon_sym_requires] = ACTIONS(2988),
    [anon_sym_where] = ACTIONS(2988),
  },
  [2918] = {
    [sym_identifier] = ACTIONS(3392),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3390),
    [anon_sym_COMMA] = ACTIONS(3390),
    [anon_sym_RPAREN] = ACTIONS(3390),
    [anon_sym_LPAREN2] = ACTIONS(3390),
    [anon_sym_DASH] = ACTIONS(3392),
    [anon_sym_PLUS] = ACTIONS(3392),
    [anon_sym_STAR] = ACTIONS(3390),
    [anon_sym_SLASH] = ACTIONS(3392),
    [anon_sym_PERCENT] = ACTIONS(3390),
    [anon_sym_PIPE_PIPE] = ACTIONS(3390),
    [anon_sym_AMP_AMP] = ACTIONS(3390),
    [anon_sym_PIPE] = ACTIONS(3392),
    [anon_sym_CARET] = ACTIONS(3390),
    [anon_sym_AMP] = ACTIONS(3392),
    [anon_sym_EQ_EQ] = ACTIONS(3390),
    [anon_sym_BANG_EQ] = ACTIONS(3390),
    [anon_sym_GT] = ACTIONS(3392),
    [anon_sym_GT_EQ] = ACTIONS(3390),
    [anon_sym_LT_EQ] = ACTIONS(3392),
    [anon_sym_LT] = ACTIONS(3392),
    [anon_sym_LT_LT] = ACTIONS(3390),
    [anon_sym_GT_GT] = ACTIONS(3390),
    [anon_sym_COLON] = ACTIONS(3390),
    [anon_sym_SEMI] = ACTIONS(3390),
    [anon_sym___extension__] = ACTIONS(3392),
    [anon_sym___attribute__] = ACTIONS(3392),
    [anon_sym___based] = ACTIONS(3392),
    [anon_sym_LBRACE] = ACTIONS(3390),
    [anon_sym_RBRACE] = ACTIONS(3390),
    [anon_sym_signed] = ACTIONS(3392),
    [anon_sym_unsigned] = ACTIONS(3392),
    [anon_sym_long] = ACTIONS(3392),
    [anon_sym_short] = ACTIONS(3392),
    [anon_sym_LBRACK] = ACTIONS(3390),
    [anon_sym_RBRACK] = ACTIONS(3390),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_constexpr] = ACTIONS(3392),
    [anon_sym_volatile] = ACTIONS(3392),
    [anon_sym_restrict] = ACTIONS(3392),
    [anon_sym___restrict__] = ACTIONS(3392),
    [anon_sym__Atomic] = ACTIONS(3392),
    [anon_sym__Noreturn] = ACTIONS(3392),
    [anon_sym_noreturn] = ACTIONS(3392),
    [anon_sym_mutable] = ACTIONS(3392),
    [anon_sym_constinit] = ACTIONS(3392),
    [anon_sym_consteval] = ACTIONS(3392),
    [anon_sym_alignas] = ACTIONS(3392),
    [anon_sym__Alignas] = ACTIONS(3392),
    [sym_primitive_type] = ACTIONS(3392),
    [anon_sym_QMARK] = ACTIONS(3390),
    [anon_sym_LT_EQ_GT] = ACTIONS(3390),
    [anon_sym_or] = ACTIONS(3392),
    [anon_sym_and] = ACTIONS(3392),
    [anon_sym_bitor] = ACTIONS(3392),
    [anon_sym_xor] = ACTIONS(3392),
    [anon_sym_bitand] = ACTIONS(3392),
    [anon_sym_not_eq] = ACTIONS(3392),
    [anon_sym_is] = ACTIONS(3392),
    [anon_sym_as] = ACTIONS(3392),
    [anon_sym_DASH_DASH] = ACTIONS(3390),
    [anon_sym_PLUS_PLUS] = ACTIONS(3390),
    [anon_sym_DOT] = ACTIONS(3392),
    [anon_sym_DOT_STAR] = ACTIONS(3390),
    [anon_sym_DASH_GT] = ACTIONS(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3392),
    [anon_sym_let] = ACTIONS(3392),
    [anon_sym_This] = ACTIONS(3392),
    [anon_sym_final] = ACTIONS(3392),
    [anon_sym_override] = ACTIONS(3392),
    [anon_sym_requires] = ACTIONS(3392),
    [anon_sym_where] = ACTIONS(3392),
  },
  [2919] = {
    [sym_identifier] = ACTIONS(3176),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3174),
    [anon_sym_COMMA] = ACTIONS(3174),
    [anon_sym_RPAREN] = ACTIONS(3174),
    [anon_sym_LPAREN2] = ACTIONS(3174),
    [anon_sym_DASH] = ACTIONS(3176),
    [anon_sym_PLUS] = ACTIONS(3176),
    [anon_sym_STAR] = ACTIONS(3174),
    [anon_sym_SLASH] = ACTIONS(3176),
    [anon_sym_PERCENT] = ACTIONS(3174),
    [anon_sym_PIPE_PIPE] = ACTIONS(3174),
    [anon_sym_AMP_AMP] = ACTIONS(3174),
    [anon_sym_PIPE] = ACTIONS(3176),
    [anon_sym_CARET] = ACTIONS(3174),
    [anon_sym_AMP] = ACTIONS(3176),
    [anon_sym_EQ_EQ] = ACTIONS(3174),
    [anon_sym_BANG_EQ] = ACTIONS(3174),
    [anon_sym_GT] = ACTIONS(3176),
    [anon_sym_GT_EQ] = ACTIONS(3174),
    [anon_sym_LT_EQ] = ACTIONS(3176),
    [anon_sym_LT] = ACTIONS(3176),
    [anon_sym_LT_LT] = ACTIONS(3174),
    [anon_sym_GT_GT] = ACTIONS(3174),
    [anon_sym_COLON] = ACTIONS(3174),
    [anon_sym_SEMI] = ACTIONS(3174),
    [anon_sym___extension__] = ACTIONS(3176),
    [anon_sym___attribute__] = ACTIONS(3176),
    [anon_sym___based] = ACTIONS(3176),
    [anon_sym_LBRACE] = ACTIONS(3174),
    [anon_sym_RBRACE] = ACTIONS(3174),
    [anon_sym_signed] = ACTIONS(3176),
    [anon_sym_unsigned] = ACTIONS(3176),
    [anon_sym_long] = ACTIONS(3176),
    [anon_sym_short] = ACTIONS(3176),
    [anon_sym_LBRACK] = ACTIONS(3174),
    [anon_sym_RBRACK] = ACTIONS(3174),
    [anon_sym_const] = ACTIONS(3176),
    [anon_sym_constexpr] = ACTIONS(3176),
    [anon_sym_volatile] = ACTIONS(3176),
    [anon_sym_restrict] = ACTIONS(3176),
    [anon_sym___restrict__] = ACTIONS(3176),
    [anon_sym__Atomic] = ACTIONS(3176),
    [anon_sym__Noreturn] = ACTIONS(3176),
    [anon_sym_noreturn] = ACTIONS(3176),
    [anon_sym_mutable] = ACTIONS(3176),
    [anon_sym_constinit] = ACTIONS(3176),
    [anon_sym_consteval] = ACTIONS(3176),
    [anon_sym_alignas] = ACTIONS(3176),
    [anon_sym__Alignas] = ACTIONS(3176),
    [sym_primitive_type] = ACTIONS(3176),
    [anon_sym_QMARK] = ACTIONS(3174),
    [anon_sym_LT_EQ_GT] = ACTIONS(3174),
    [anon_sym_or] = ACTIONS(3176),
    [anon_sym_and] = ACTIONS(3176),
    [anon_sym_bitor] = ACTIONS(3176),
    [anon_sym_xor] = ACTIONS(3176),
    [anon_sym_bitand] = ACTIONS(3176),
    [anon_sym_not_eq] = ACTIONS(3176),
    [anon_sym_is] = ACTIONS(3176),
    [anon_sym_as] = ACTIONS(3176),
    [anon_sym_DASH_DASH] = ACTIONS(3174),
    [anon_sym_PLUS_PLUS] = ACTIONS(3174),
    [anon_sym_DOT] = ACTIONS(3176),
    [anon_sym_DOT_STAR] = ACTIONS(3174),
    [anon_sym_DASH_GT] = ACTIONS(3174),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3176),
    [anon_sym_let] = ACTIONS(3176),
    [anon_sym_This] = ACTIONS(3176),
    [anon_sym_final] = ACTIONS(3176),
    [anon_sym_override] = ACTIONS(3176),
    [anon_sym_requires] = ACTIONS(3176),
    [anon_sym_where] = ACTIONS(3176),
  },
  [2920] = {
    [sym_identifier] = ACTIONS(3192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3190),
    [anon_sym_COMMA] = ACTIONS(3190),
    [anon_sym_RPAREN] = ACTIONS(3190),
    [anon_sym_LPAREN2] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3192),
    [anon_sym_PLUS] = ACTIONS(3192),
    [anon_sym_STAR] = ACTIONS(3190),
    [anon_sym_SLASH] = ACTIONS(3192),
    [anon_sym_PERCENT] = ACTIONS(3190),
    [anon_sym_PIPE_PIPE] = ACTIONS(3190),
    [anon_sym_AMP_AMP] = ACTIONS(3190),
    [anon_sym_PIPE] = ACTIONS(3192),
    [anon_sym_CARET] = ACTIONS(3190),
    [anon_sym_AMP] = ACTIONS(3192),
    [anon_sym_EQ_EQ] = ACTIONS(3190),
    [anon_sym_BANG_EQ] = ACTIONS(3190),
    [anon_sym_GT] = ACTIONS(3192),
    [anon_sym_GT_EQ] = ACTIONS(3190),
    [anon_sym_LT_EQ] = ACTIONS(3192),
    [anon_sym_LT] = ACTIONS(3192),
    [anon_sym_LT_LT] = ACTIONS(3190),
    [anon_sym_GT_GT] = ACTIONS(3190),
    [anon_sym_COLON] = ACTIONS(3190),
    [anon_sym_SEMI] = ACTIONS(3190),
    [anon_sym___extension__] = ACTIONS(3192),
    [anon_sym___attribute__] = ACTIONS(3192),
    [anon_sym___based] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(3190),
    [anon_sym_RBRACE] = ACTIONS(3190),
    [anon_sym_signed] = ACTIONS(3192),
    [anon_sym_unsigned] = ACTIONS(3192),
    [anon_sym_long] = ACTIONS(3192),
    [anon_sym_short] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(3190),
    [anon_sym_RBRACK] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_constexpr] = ACTIONS(3192),
    [anon_sym_volatile] = ACTIONS(3192),
    [anon_sym_restrict] = ACTIONS(3192),
    [anon_sym___restrict__] = ACTIONS(3192),
    [anon_sym__Atomic] = ACTIONS(3192),
    [anon_sym__Noreturn] = ACTIONS(3192),
    [anon_sym_noreturn] = ACTIONS(3192),
    [anon_sym_mutable] = ACTIONS(3192),
    [anon_sym_constinit] = ACTIONS(3192),
    [anon_sym_consteval] = ACTIONS(3192),
    [anon_sym_alignas] = ACTIONS(3192),
    [anon_sym__Alignas] = ACTIONS(3192),
    [sym_primitive_type] = ACTIONS(3192),
    [anon_sym_QMARK] = ACTIONS(3190),
    [anon_sym_LT_EQ_GT] = ACTIONS(3190),
    [anon_sym_or] = ACTIONS(3192),
    [anon_sym_and] = ACTIONS(3192),
    [anon_sym_bitor] = ACTIONS(3192),
    [anon_sym_xor] = ACTIONS(3192),
    [anon_sym_bitand] = ACTIONS(3192),
    [anon_sym_not_eq] = ACTIONS(3192),
    [anon_sym_is] = ACTIONS(3192),
    [anon_sym_as] = ACTIONS(3192),
    [anon_sym_DASH_DASH] = ACTIONS(3190),
    [anon_sym_PLUS_PLUS] = ACTIONS(3190),
    [anon_sym_DOT] = ACTIONS(3192),
    [anon_sym_DOT_STAR] = ACTIONS(3190),
    [anon_sym_DASH_GT] = ACTIONS(3190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3192),
    [anon_sym_let] = ACTIONS(3192),
    [anon_sym_This] = ACTIONS(3192),
    [anon_sym_final] = ACTIONS(3192),
    [anon_sym_override] = ACTIONS(3192),
    [anon_sym_requires] = ACTIONS(3192),
    [anon_sym_where] = ACTIONS(3192),
  },
  [2921] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2212),
    [anon_sym_COMMA] = ACTIONS(2212),
    [anon_sym_RPAREN] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(2214),
    [anon_sym_DASH] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(2222),
    [anon_sym_STAR] = ACTIONS(2219),
    [anon_sym_SLASH] = ACTIONS(2222),
    [anon_sym_PERCENT] = ACTIONS(2222),
    [anon_sym_PIPE_PIPE] = ACTIONS(2212),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2222),
    [anon_sym_CARET] = ACTIONS(2222),
    [anon_sym_AMP] = ACTIONS(2219),
    [anon_sym_EQ_EQ] = ACTIONS(2212),
    [anon_sym_BANG_EQ] = ACTIONS(2212),
    [anon_sym_GT] = ACTIONS(2222),
    [anon_sym_GT_EQ] = ACTIONS(2212),
    [anon_sym_LT_EQ] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(2222),
    [anon_sym_LT_LT] = ACTIONS(2222),
    [anon_sym_GT_GT] = ACTIONS(2222),
    [anon_sym___extension__] = ACTIONS(2217),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2217),
    [anon_sym_LBRACK] = ACTIONS(2214),
    [anon_sym_EQ] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_constexpr] = ACTIONS(2217),
    [anon_sym_volatile] = ACTIONS(2217),
    [anon_sym_restrict] = ACTIONS(2217),
    [anon_sym___restrict__] = ACTIONS(2217),
    [anon_sym__Atomic] = ACTIONS(2217),
    [anon_sym__Noreturn] = ACTIONS(2217),
    [anon_sym_noreturn] = ACTIONS(2217),
    [anon_sym_mutable] = ACTIONS(2217),
    [anon_sym_constinit] = ACTIONS(2217),
    [anon_sym_consteval] = ACTIONS(2217),
    [anon_sym_alignas] = ACTIONS(2217),
    [anon_sym__Alignas] = ACTIONS(2217),
    [anon_sym_QMARK] = ACTIONS(2212),
    [anon_sym_STAR_EQ] = ACTIONS(2212),
    [anon_sym_SLASH_EQ] = ACTIONS(2212),
    [anon_sym_PERCENT_EQ] = ACTIONS(2212),
    [anon_sym_PLUS_EQ] = ACTIONS(2212),
    [anon_sym_DASH_EQ] = ACTIONS(2212),
    [anon_sym_LT_LT_EQ] = ACTIONS(2212),
    [anon_sym_GT_GT_EQ] = ACTIONS(2212),
    [anon_sym_AMP_EQ] = ACTIONS(2212),
    [anon_sym_CARET_EQ] = ACTIONS(2212),
    [anon_sym_PIPE_EQ] = ACTIONS(2212),
    [anon_sym_and_eq] = ACTIONS(2212),
    [anon_sym_or_eq] = ACTIONS(2212),
    [anon_sym_xor_eq] = ACTIONS(2212),
    [anon_sym_LT_EQ_GT] = ACTIONS(2212),
    [anon_sym_or] = ACTIONS(2222),
    [anon_sym_and] = ACTIONS(2222),
    [anon_sym_bitor] = ACTIONS(2212),
    [anon_sym_xor] = ACTIONS(2222),
    [anon_sym_bitand] = ACTIONS(2212),
    [anon_sym_not_eq] = ACTIONS(2212),
    [anon_sym_is] = ACTIONS(2212),
    [anon_sym_as] = ACTIONS(2212),
    [anon_sym_DASH_DASH] = ACTIONS(2212),
    [anon_sym_PLUS_PLUS] = ACTIONS(2212),
    [anon_sym_DOT] = ACTIONS(2219),
    [anon_sym_DOT_STAR] = ACTIONS(2212),
    [anon_sym_DASH_GT] = ACTIONS(2222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2217),
    [anon_sym_let] = ACTIONS(2217),
    [anon_sym_This] = ACTIONS(2217),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2212),
  },
  [2922] = {
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3200),
    [anon_sym_COMMA] = ACTIONS(3200),
    [anon_sym_RPAREN] = ACTIONS(3200),
    [anon_sym_LPAREN2] = ACTIONS(3200),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_STAR] = ACTIONS(3200),
    [anon_sym_SLASH] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3200),
    [anon_sym_PIPE_PIPE] = ACTIONS(3200),
    [anon_sym_AMP_AMP] = ACTIONS(3200),
    [anon_sym_PIPE] = ACTIONS(3202),
    [anon_sym_CARET] = ACTIONS(3200),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_EQ_EQ] = ACTIONS(3200),
    [anon_sym_BANG_EQ] = ACTIONS(3200),
    [anon_sym_GT] = ACTIONS(3202),
    [anon_sym_GT_EQ] = ACTIONS(3200),
    [anon_sym_LT_EQ] = ACTIONS(3202),
    [anon_sym_LT] = ACTIONS(3202),
    [anon_sym_LT_LT] = ACTIONS(3200),
    [anon_sym_GT_GT] = ACTIONS(3200),
    [anon_sym_COLON] = ACTIONS(3200),
    [anon_sym_SEMI] = ACTIONS(3200),
    [anon_sym___extension__] = ACTIONS(3202),
    [anon_sym___attribute__] = ACTIONS(3202),
    [anon_sym___based] = ACTIONS(3202),
    [anon_sym_LBRACE] = ACTIONS(3200),
    [anon_sym_RBRACE] = ACTIONS(3200),
    [anon_sym_signed] = ACTIONS(3202),
    [anon_sym_unsigned] = ACTIONS(3202),
    [anon_sym_long] = ACTIONS(3202),
    [anon_sym_short] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3200),
    [anon_sym_RBRACK] = ACTIONS(3200),
    [anon_sym_const] = ACTIONS(3202),
    [anon_sym_constexpr] = ACTIONS(3202),
    [anon_sym_volatile] = ACTIONS(3202),
    [anon_sym_restrict] = ACTIONS(3202),
    [anon_sym___restrict__] = ACTIONS(3202),
    [anon_sym__Atomic] = ACTIONS(3202),
    [anon_sym__Noreturn] = ACTIONS(3202),
    [anon_sym_noreturn] = ACTIONS(3202),
    [anon_sym_mutable] = ACTIONS(3202),
    [anon_sym_constinit] = ACTIONS(3202),
    [anon_sym_consteval] = ACTIONS(3202),
    [anon_sym_alignas] = ACTIONS(3202),
    [anon_sym__Alignas] = ACTIONS(3202),
    [sym_primitive_type] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3200),
    [anon_sym_LT_EQ_GT] = ACTIONS(3200),
    [anon_sym_or] = ACTIONS(3202),
    [anon_sym_and] = ACTIONS(3202),
    [anon_sym_bitor] = ACTIONS(3202),
    [anon_sym_xor] = ACTIONS(3202),
    [anon_sym_bitand] = ACTIONS(3202),
    [anon_sym_not_eq] = ACTIONS(3202),
    [anon_sym_is] = ACTIONS(3202),
    [anon_sym_as] = ACTIONS(3202),
    [anon_sym_DASH_DASH] = ACTIONS(3200),
    [anon_sym_PLUS_PLUS] = ACTIONS(3200),
    [anon_sym_DOT] = ACTIONS(3202),
    [anon_sym_DOT_STAR] = ACTIONS(3200),
    [anon_sym_DASH_GT] = ACTIONS(3200),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_This] = ACTIONS(3202),
    [anon_sym_final] = ACTIONS(3202),
    [anon_sym_override] = ACTIONS(3202),
    [anon_sym_requires] = ACTIONS(3202),
    [anon_sym_where] = ACTIONS(3202),
  },
  [2923] = {
    [sym_identifier] = ACTIONS(3048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3046),
    [anon_sym_COMMA] = ACTIONS(3046),
    [anon_sym_RPAREN] = ACTIONS(3046),
    [anon_sym_LPAREN2] = ACTIONS(3046),
    [anon_sym_DASH] = ACTIONS(3048),
    [anon_sym_PLUS] = ACTIONS(3048),
    [anon_sym_STAR] = ACTIONS(3046),
    [anon_sym_SLASH] = ACTIONS(3048),
    [anon_sym_PERCENT] = ACTIONS(3046),
    [anon_sym_PIPE_PIPE] = ACTIONS(3046),
    [anon_sym_AMP_AMP] = ACTIONS(3046),
    [anon_sym_PIPE] = ACTIONS(3048),
    [anon_sym_CARET] = ACTIONS(3046),
    [anon_sym_AMP] = ACTIONS(3048),
    [anon_sym_EQ_EQ] = ACTIONS(3046),
    [anon_sym_BANG_EQ] = ACTIONS(3046),
    [anon_sym_GT] = ACTIONS(3048),
    [anon_sym_GT_EQ] = ACTIONS(3046),
    [anon_sym_LT_EQ] = ACTIONS(3048),
    [anon_sym_LT] = ACTIONS(3048),
    [anon_sym_LT_LT] = ACTIONS(3046),
    [anon_sym_GT_GT] = ACTIONS(3046),
    [anon_sym_COLON] = ACTIONS(3046),
    [anon_sym_SEMI] = ACTIONS(3046),
    [anon_sym___extension__] = ACTIONS(3048),
    [anon_sym___attribute__] = ACTIONS(3048),
    [anon_sym___based] = ACTIONS(3048),
    [anon_sym_LBRACE] = ACTIONS(3046),
    [anon_sym_RBRACE] = ACTIONS(3046),
    [anon_sym_signed] = ACTIONS(3048),
    [anon_sym_unsigned] = ACTIONS(3048),
    [anon_sym_long] = ACTIONS(3048),
    [anon_sym_short] = ACTIONS(3048),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_RBRACK] = ACTIONS(3046),
    [anon_sym_const] = ACTIONS(3048),
    [anon_sym_constexpr] = ACTIONS(3048),
    [anon_sym_volatile] = ACTIONS(3048),
    [anon_sym_restrict] = ACTIONS(3048),
    [anon_sym___restrict__] = ACTIONS(3048),
    [anon_sym__Atomic] = ACTIONS(3048),
    [anon_sym__Noreturn] = ACTIONS(3048),
    [anon_sym_noreturn] = ACTIONS(3048),
    [anon_sym_mutable] = ACTIONS(3048),
    [anon_sym_constinit] = ACTIONS(3048),
    [anon_sym_consteval] = ACTIONS(3048),
    [anon_sym_alignas] = ACTIONS(3048),
    [anon_sym__Alignas] = ACTIONS(3048),
    [sym_primitive_type] = ACTIONS(3048),
    [anon_sym_QMARK] = ACTIONS(3046),
    [anon_sym_LT_EQ_GT] = ACTIONS(3046),
    [anon_sym_or] = ACTIONS(3048),
    [anon_sym_and] = ACTIONS(3048),
    [anon_sym_bitor] = ACTIONS(3048),
    [anon_sym_xor] = ACTIONS(3048),
    [anon_sym_bitand] = ACTIONS(3048),
    [anon_sym_not_eq] = ACTIONS(3048),
    [anon_sym_is] = ACTIONS(3048),
    [anon_sym_as] = ACTIONS(3048),
    [anon_sym_DASH_DASH] = ACTIONS(3046),
    [anon_sym_PLUS_PLUS] = ACTIONS(3046),
    [anon_sym_DOT] = ACTIONS(3048),
    [anon_sym_DOT_STAR] = ACTIONS(3046),
    [anon_sym_DASH_GT] = ACTIONS(3046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3048),
    [anon_sym_let] = ACTIONS(3048),
    [anon_sym_This] = ACTIONS(3048),
    [anon_sym_final] = ACTIONS(3048),
    [anon_sym_override] = ACTIONS(3048),
    [anon_sym_requires] = ACTIONS(3048),
    [anon_sym_where] = ACTIONS(3048),
  },
  [2924] = {
    [sym_identifier] = ACTIONS(3206),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3204),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_RPAREN] = ACTIONS(3204),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_DASH] = ACTIONS(3206),
    [anon_sym_PLUS] = ACTIONS(3206),
    [anon_sym_STAR] = ACTIONS(3204),
    [anon_sym_SLASH] = ACTIONS(3206),
    [anon_sym_PERCENT] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(3204),
    [anon_sym_AMP_AMP] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(3206),
    [anon_sym_CARET] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3206),
    [anon_sym_EQ_EQ] = ACTIONS(3204),
    [anon_sym_BANG_EQ] = ACTIONS(3204),
    [anon_sym_GT] = ACTIONS(3206),
    [anon_sym_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_EQ] = ACTIONS(3206),
    [anon_sym_LT] = ACTIONS(3206),
    [anon_sym_LT_LT] = ACTIONS(3204),
    [anon_sym_GT_GT] = ACTIONS(3204),
    [anon_sym_COLON] = ACTIONS(3204),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym___extension__] = ACTIONS(3206),
    [anon_sym___attribute__] = ACTIONS(3206),
    [anon_sym___based] = ACTIONS(3206),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_RBRACE] = ACTIONS(3204),
    [anon_sym_signed] = ACTIONS(3206),
    [anon_sym_unsigned] = ACTIONS(3206),
    [anon_sym_long] = ACTIONS(3206),
    [anon_sym_short] = ACTIONS(3206),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_RBRACK] = ACTIONS(3204),
    [anon_sym_const] = ACTIONS(3206),
    [anon_sym_constexpr] = ACTIONS(3206),
    [anon_sym_volatile] = ACTIONS(3206),
    [anon_sym_restrict] = ACTIONS(3206),
    [anon_sym___restrict__] = ACTIONS(3206),
    [anon_sym__Atomic] = ACTIONS(3206),
    [anon_sym__Noreturn] = ACTIONS(3206),
    [anon_sym_noreturn] = ACTIONS(3206),
    [anon_sym_mutable] = ACTIONS(3206),
    [anon_sym_constinit] = ACTIONS(3206),
    [anon_sym_consteval] = ACTIONS(3206),
    [anon_sym_alignas] = ACTIONS(3206),
    [anon_sym__Alignas] = ACTIONS(3206),
    [sym_primitive_type] = ACTIONS(3206),
    [anon_sym_QMARK] = ACTIONS(3204),
    [anon_sym_LT_EQ_GT] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3206),
    [anon_sym_and] = ACTIONS(3206),
    [anon_sym_bitor] = ACTIONS(3206),
    [anon_sym_xor] = ACTIONS(3206),
    [anon_sym_bitand] = ACTIONS(3206),
    [anon_sym_not_eq] = ACTIONS(3206),
    [anon_sym_is] = ACTIONS(3206),
    [anon_sym_as] = ACTIONS(3206),
    [anon_sym_DASH_DASH] = ACTIONS(3204),
    [anon_sym_PLUS_PLUS] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(3206),
    [anon_sym_DOT_STAR] = ACTIONS(3204),
    [anon_sym_DASH_GT] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3206),
    [anon_sym_let] = ACTIONS(3206),
    [anon_sym_This] = ACTIONS(3206),
    [anon_sym_final] = ACTIONS(3206),
    [anon_sym_override] = ACTIONS(3206),
    [anon_sym_requires] = ACTIONS(3206),
    [anon_sym_where] = ACTIONS(3206),
  },
  [2925] = {
    [sym_identifier] = ACTIONS(3098),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3096),
    [anon_sym_COMMA] = ACTIONS(3096),
    [anon_sym_RPAREN] = ACTIONS(3096),
    [anon_sym_LPAREN2] = ACTIONS(3096),
    [anon_sym_DASH] = ACTIONS(3098),
    [anon_sym_PLUS] = ACTIONS(3098),
    [anon_sym_STAR] = ACTIONS(3096),
    [anon_sym_SLASH] = ACTIONS(3098),
    [anon_sym_PERCENT] = ACTIONS(3096),
    [anon_sym_PIPE_PIPE] = ACTIONS(3096),
    [anon_sym_AMP_AMP] = ACTIONS(3096),
    [anon_sym_PIPE] = ACTIONS(3098),
    [anon_sym_CARET] = ACTIONS(3096),
    [anon_sym_AMP] = ACTIONS(3098),
    [anon_sym_EQ_EQ] = ACTIONS(3096),
    [anon_sym_BANG_EQ] = ACTIONS(3096),
    [anon_sym_GT] = ACTIONS(3098),
    [anon_sym_GT_EQ] = ACTIONS(3096),
    [anon_sym_LT_EQ] = ACTIONS(3098),
    [anon_sym_LT] = ACTIONS(3098),
    [anon_sym_LT_LT] = ACTIONS(3096),
    [anon_sym_GT_GT] = ACTIONS(3096),
    [anon_sym_COLON] = ACTIONS(3096),
    [anon_sym_SEMI] = ACTIONS(3096),
    [anon_sym___extension__] = ACTIONS(3098),
    [anon_sym___attribute__] = ACTIONS(3098),
    [anon_sym___based] = ACTIONS(3098),
    [anon_sym_LBRACE] = ACTIONS(3096),
    [anon_sym_RBRACE] = ACTIONS(3096),
    [anon_sym_signed] = ACTIONS(3098),
    [anon_sym_unsigned] = ACTIONS(3098),
    [anon_sym_long] = ACTIONS(3098),
    [anon_sym_short] = ACTIONS(3098),
    [anon_sym_LBRACK] = ACTIONS(3096),
    [anon_sym_RBRACK] = ACTIONS(3096),
    [anon_sym_const] = ACTIONS(3098),
    [anon_sym_constexpr] = ACTIONS(3098),
    [anon_sym_volatile] = ACTIONS(3098),
    [anon_sym_restrict] = ACTIONS(3098),
    [anon_sym___restrict__] = ACTIONS(3098),
    [anon_sym__Atomic] = ACTIONS(3098),
    [anon_sym__Noreturn] = ACTIONS(3098),
    [anon_sym_noreturn] = ACTIONS(3098),
    [anon_sym_mutable] = ACTIONS(3098),
    [anon_sym_constinit] = ACTIONS(3098),
    [anon_sym_consteval] = ACTIONS(3098),
    [anon_sym_alignas] = ACTIONS(3098),
    [anon_sym__Alignas] = ACTIONS(3098),
    [sym_primitive_type] = ACTIONS(3098),
    [anon_sym_QMARK] = ACTIONS(3096),
    [anon_sym_LT_EQ_GT] = ACTIONS(3096),
    [anon_sym_or] = ACTIONS(3098),
    [anon_sym_and] = ACTIONS(3098),
    [anon_sym_bitor] = ACTIONS(3098),
    [anon_sym_xor] = ACTIONS(3098),
    [anon_sym_bitand] = ACTIONS(3098),
    [anon_sym_not_eq] = ACTIONS(3098),
    [anon_sym_is] = ACTIONS(3098),
    [anon_sym_as] = ACTIONS(3098),
    [anon_sym_DASH_DASH] = ACTIONS(3096),
    [anon_sym_PLUS_PLUS] = ACTIONS(3096),
    [anon_sym_DOT] = ACTIONS(3098),
    [anon_sym_DOT_STAR] = ACTIONS(3096),
    [anon_sym_DASH_GT] = ACTIONS(3096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3098),
    [anon_sym_let] = ACTIONS(3098),
    [anon_sym_This] = ACTIONS(3098),
    [anon_sym_final] = ACTIONS(3098),
    [anon_sym_override] = ACTIONS(3098),
    [anon_sym_requires] = ACTIONS(3098),
    [anon_sym_where] = ACTIONS(3098),
  },
  [2926] = {
    [sym_identifier] = ACTIONS(3058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3056),
    [anon_sym_COMMA] = ACTIONS(3056),
    [anon_sym_RPAREN] = ACTIONS(3056),
    [anon_sym_LPAREN2] = ACTIONS(3056),
    [anon_sym_DASH] = ACTIONS(3058),
    [anon_sym_PLUS] = ACTIONS(3058),
    [anon_sym_STAR] = ACTIONS(3056),
    [anon_sym_SLASH] = ACTIONS(3058),
    [anon_sym_PERCENT] = ACTIONS(3056),
    [anon_sym_PIPE_PIPE] = ACTIONS(3056),
    [anon_sym_AMP_AMP] = ACTIONS(3056),
    [anon_sym_PIPE] = ACTIONS(3058),
    [anon_sym_CARET] = ACTIONS(3056),
    [anon_sym_AMP] = ACTIONS(3058),
    [anon_sym_EQ_EQ] = ACTIONS(3056),
    [anon_sym_BANG_EQ] = ACTIONS(3056),
    [anon_sym_GT] = ACTIONS(3058),
    [anon_sym_GT_EQ] = ACTIONS(3056),
    [anon_sym_LT_EQ] = ACTIONS(3058),
    [anon_sym_LT] = ACTIONS(3058),
    [anon_sym_LT_LT] = ACTIONS(3056),
    [anon_sym_GT_GT] = ACTIONS(3056),
    [anon_sym_COLON] = ACTIONS(3056),
    [anon_sym_SEMI] = ACTIONS(3056),
    [anon_sym___extension__] = ACTIONS(3058),
    [anon_sym___attribute__] = ACTIONS(3058),
    [anon_sym___based] = ACTIONS(3058),
    [anon_sym_LBRACE] = ACTIONS(3056),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_signed] = ACTIONS(3058),
    [anon_sym_unsigned] = ACTIONS(3058),
    [anon_sym_long] = ACTIONS(3058),
    [anon_sym_short] = ACTIONS(3058),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [anon_sym_RBRACK] = ACTIONS(3056),
    [anon_sym_const] = ACTIONS(3058),
    [anon_sym_constexpr] = ACTIONS(3058),
    [anon_sym_volatile] = ACTIONS(3058),
    [anon_sym_restrict] = ACTIONS(3058),
    [anon_sym___restrict__] = ACTIONS(3058),
    [anon_sym__Atomic] = ACTIONS(3058),
    [anon_sym__Noreturn] = ACTIONS(3058),
    [anon_sym_noreturn] = ACTIONS(3058),
    [anon_sym_mutable] = ACTIONS(3058),
    [anon_sym_constinit] = ACTIONS(3058),
    [anon_sym_consteval] = ACTIONS(3058),
    [anon_sym_alignas] = ACTIONS(3058),
    [anon_sym__Alignas] = ACTIONS(3058),
    [sym_primitive_type] = ACTIONS(3058),
    [anon_sym_QMARK] = ACTIONS(3056),
    [anon_sym_LT_EQ_GT] = ACTIONS(3056),
    [anon_sym_or] = ACTIONS(3058),
    [anon_sym_and] = ACTIONS(3058),
    [anon_sym_bitor] = ACTIONS(3058),
    [anon_sym_xor] = ACTIONS(3058),
    [anon_sym_bitand] = ACTIONS(3058),
    [anon_sym_not_eq] = ACTIONS(3058),
    [anon_sym_is] = ACTIONS(3058),
    [anon_sym_as] = ACTIONS(3058),
    [anon_sym_DASH_DASH] = ACTIONS(3056),
    [anon_sym_PLUS_PLUS] = ACTIONS(3056),
    [anon_sym_DOT] = ACTIONS(3058),
    [anon_sym_DOT_STAR] = ACTIONS(3056),
    [anon_sym_DASH_GT] = ACTIONS(3056),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3058),
    [anon_sym_let] = ACTIONS(3058),
    [anon_sym_This] = ACTIONS(3058),
    [anon_sym_final] = ACTIONS(3058),
    [anon_sym_override] = ACTIONS(3058),
    [anon_sym_requires] = ACTIONS(3058),
    [anon_sym_where] = ACTIONS(3058),
  },
  [2927] = {
    [sym_identifier] = ACTIONS(3172),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3170),
    [anon_sym_COMMA] = ACTIONS(3170),
    [anon_sym_RPAREN] = ACTIONS(3170),
    [anon_sym_LPAREN2] = ACTIONS(3170),
    [anon_sym_DASH] = ACTIONS(3172),
    [anon_sym_PLUS] = ACTIONS(3172),
    [anon_sym_STAR] = ACTIONS(3170),
    [anon_sym_SLASH] = ACTIONS(3172),
    [anon_sym_PERCENT] = ACTIONS(3170),
    [anon_sym_PIPE_PIPE] = ACTIONS(3170),
    [anon_sym_AMP_AMP] = ACTIONS(3170),
    [anon_sym_PIPE] = ACTIONS(3172),
    [anon_sym_CARET] = ACTIONS(3170),
    [anon_sym_AMP] = ACTIONS(3172),
    [anon_sym_EQ_EQ] = ACTIONS(3170),
    [anon_sym_BANG_EQ] = ACTIONS(3170),
    [anon_sym_GT] = ACTIONS(3172),
    [anon_sym_GT_EQ] = ACTIONS(3170),
    [anon_sym_LT_EQ] = ACTIONS(3172),
    [anon_sym_LT] = ACTIONS(3172),
    [anon_sym_LT_LT] = ACTIONS(3170),
    [anon_sym_GT_GT] = ACTIONS(3170),
    [anon_sym_COLON] = ACTIONS(3170),
    [anon_sym_SEMI] = ACTIONS(3170),
    [anon_sym___extension__] = ACTIONS(3172),
    [anon_sym___attribute__] = ACTIONS(3172),
    [anon_sym___based] = ACTIONS(3172),
    [anon_sym_LBRACE] = ACTIONS(3170),
    [anon_sym_RBRACE] = ACTIONS(3170),
    [anon_sym_signed] = ACTIONS(3172),
    [anon_sym_unsigned] = ACTIONS(3172),
    [anon_sym_long] = ACTIONS(3172),
    [anon_sym_short] = ACTIONS(3172),
    [anon_sym_LBRACK] = ACTIONS(3170),
    [anon_sym_RBRACK] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_constexpr] = ACTIONS(3172),
    [anon_sym_volatile] = ACTIONS(3172),
    [anon_sym_restrict] = ACTIONS(3172),
    [anon_sym___restrict__] = ACTIONS(3172),
    [anon_sym__Atomic] = ACTIONS(3172),
    [anon_sym__Noreturn] = ACTIONS(3172),
    [anon_sym_noreturn] = ACTIONS(3172),
    [anon_sym_mutable] = ACTIONS(3172),
    [anon_sym_constinit] = ACTIONS(3172),
    [anon_sym_consteval] = ACTIONS(3172),
    [anon_sym_alignas] = ACTIONS(3172),
    [anon_sym__Alignas] = ACTIONS(3172),
    [sym_primitive_type] = ACTIONS(3172),
    [anon_sym_QMARK] = ACTIONS(3170),
    [anon_sym_LT_EQ_GT] = ACTIONS(3170),
    [anon_sym_or] = ACTIONS(3172),
    [anon_sym_and] = ACTIONS(3172),
    [anon_sym_bitor] = ACTIONS(3172),
    [anon_sym_xor] = ACTIONS(3172),
    [anon_sym_bitand] = ACTIONS(3172),
    [anon_sym_not_eq] = ACTIONS(3172),
    [anon_sym_is] = ACTIONS(3172),
    [anon_sym_as] = ACTIONS(3172),
    [anon_sym_DASH_DASH] = ACTIONS(3170),
    [anon_sym_PLUS_PLUS] = ACTIONS(3170),
    [anon_sym_DOT] = ACTIONS(3172),
    [anon_sym_DOT_STAR] = ACTIONS(3170),
    [anon_sym_DASH_GT] = ACTIONS(3170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3172),
    [anon_sym_let] = ACTIONS(3172),
    [anon_sym_This] = ACTIONS(3172),
    [anon_sym_final] = ACTIONS(3172),
    [anon_sym_override] = ACTIONS(3172),
    [anon_sym_requires] = ACTIONS(3172),
    [anon_sym_where] = ACTIONS(3172),
  },
  [2928] = {
    [sym_identifier] = ACTIONS(3152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(3150),
    [anon_sym_RPAREN] = ACTIONS(3150),
    [anon_sym_LPAREN2] = ACTIONS(3150),
    [anon_sym_DASH] = ACTIONS(3152),
    [anon_sym_PLUS] = ACTIONS(3152),
    [anon_sym_STAR] = ACTIONS(3150),
    [anon_sym_SLASH] = ACTIONS(3152),
    [anon_sym_PERCENT] = ACTIONS(3150),
    [anon_sym_PIPE_PIPE] = ACTIONS(3150),
    [anon_sym_AMP_AMP] = ACTIONS(3150),
    [anon_sym_PIPE] = ACTIONS(3152),
    [anon_sym_CARET] = ACTIONS(3150),
    [anon_sym_AMP] = ACTIONS(3152),
    [anon_sym_EQ_EQ] = ACTIONS(3150),
    [anon_sym_BANG_EQ] = ACTIONS(3150),
    [anon_sym_GT] = ACTIONS(3152),
    [anon_sym_GT_EQ] = ACTIONS(3150),
    [anon_sym_LT_EQ] = ACTIONS(3152),
    [anon_sym_LT] = ACTIONS(3152),
    [anon_sym_LT_LT] = ACTIONS(3150),
    [anon_sym_GT_GT] = ACTIONS(3150),
    [anon_sym_COLON] = ACTIONS(3150),
    [anon_sym_SEMI] = ACTIONS(3150),
    [anon_sym___extension__] = ACTIONS(3152),
    [anon_sym___attribute__] = ACTIONS(3152),
    [anon_sym___based] = ACTIONS(3152),
    [anon_sym_LBRACE] = ACTIONS(3150),
    [anon_sym_RBRACE] = ACTIONS(3150),
    [anon_sym_signed] = ACTIONS(3152),
    [anon_sym_unsigned] = ACTIONS(3152),
    [anon_sym_long] = ACTIONS(3152),
    [anon_sym_short] = ACTIONS(3152),
    [anon_sym_LBRACK] = ACTIONS(3150),
    [anon_sym_RBRACK] = ACTIONS(3150),
    [anon_sym_const] = ACTIONS(3152),
    [anon_sym_constexpr] = ACTIONS(3152),
    [anon_sym_volatile] = ACTIONS(3152),
    [anon_sym_restrict] = ACTIONS(3152),
    [anon_sym___restrict__] = ACTIONS(3152),
    [anon_sym__Atomic] = ACTIONS(3152),
    [anon_sym__Noreturn] = ACTIONS(3152),
    [anon_sym_noreturn] = ACTIONS(3152),
    [anon_sym_mutable] = ACTIONS(3152),
    [anon_sym_constinit] = ACTIONS(3152),
    [anon_sym_consteval] = ACTIONS(3152),
    [anon_sym_alignas] = ACTIONS(3152),
    [anon_sym__Alignas] = ACTIONS(3152),
    [sym_primitive_type] = ACTIONS(3152),
    [anon_sym_QMARK] = ACTIONS(3150),
    [anon_sym_LT_EQ_GT] = ACTIONS(3150),
    [anon_sym_or] = ACTIONS(3152),
    [anon_sym_and] = ACTIONS(3152),
    [anon_sym_bitor] = ACTIONS(3152),
    [anon_sym_xor] = ACTIONS(3152),
    [anon_sym_bitand] = ACTIONS(3152),
    [anon_sym_not_eq] = ACTIONS(3152),
    [anon_sym_is] = ACTIONS(3152),
    [anon_sym_as] = ACTIONS(3152),
    [anon_sym_DASH_DASH] = ACTIONS(3150),
    [anon_sym_PLUS_PLUS] = ACTIONS(3150),
    [anon_sym_DOT] = ACTIONS(3152),
    [anon_sym_DOT_STAR] = ACTIONS(3150),
    [anon_sym_DASH_GT] = ACTIONS(3150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3152),
    [anon_sym_let] = ACTIONS(3152),
    [anon_sym_This] = ACTIONS(3152),
    [anon_sym_final] = ACTIONS(3152),
    [anon_sym_override] = ACTIONS(3152),
    [anon_sym_requires] = ACTIONS(3152),
    [anon_sym_where] = ACTIONS(3152),
  },
  [2929] = {
    [sym_identifier] = ACTIONS(2491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2489),
    [anon_sym_COMMA] = ACTIONS(2489),
    [anon_sym_RPAREN] = ACTIONS(2489),
    [anon_sym_LPAREN2] = ACTIONS(2489),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(2489),
    [anon_sym_SLASH] = ACTIONS(2491),
    [anon_sym_PERCENT] = ACTIONS(2489),
    [anon_sym_PIPE_PIPE] = ACTIONS(2489),
    [anon_sym_AMP_AMP] = ACTIONS(2489),
    [anon_sym_PIPE] = ACTIONS(2491),
    [anon_sym_CARET] = ACTIONS(2489),
    [anon_sym_AMP] = ACTIONS(2491),
    [anon_sym_EQ_EQ] = ACTIONS(2489),
    [anon_sym_BANG_EQ] = ACTIONS(2489),
    [anon_sym_GT] = ACTIONS(2491),
    [anon_sym_GT_EQ] = ACTIONS(2489),
    [anon_sym_LT_EQ] = ACTIONS(2491),
    [anon_sym_LT] = ACTIONS(2491),
    [anon_sym_LT_LT] = ACTIONS(2489),
    [anon_sym_GT_GT] = ACTIONS(2489),
    [anon_sym_COLON] = ACTIONS(2489),
    [anon_sym_SEMI] = ACTIONS(2489),
    [anon_sym___extension__] = ACTIONS(2491),
    [anon_sym___attribute__] = ACTIONS(2491),
    [anon_sym___based] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(2489),
    [anon_sym_RBRACE] = ACTIONS(2489),
    [anon_sym_signed] = ACTIONS(2491),
    [anon_sym_unsigned] = ACTIONS(2491),
    [anon_sym_long] = ACTIONS(2491),
    [anon_sym_short] = ACTIONS(2491),
    [anon_sym_LBRACK] = ACTIONS(2489),
    [anon_sym_RBRACK] = ACTIONS(2489),
    [anon_sym_const] = ACTIONS(2491),
    [anon_sym_constexpr] = ACTIONS(2491),
    [anon_sym_volatile] = ACTIONS(2491),
    [anon_sym_restrict] = ACTIONS(2491),
    [anon_sym___restrict__] = ACTIONS(2491),
    [anon_sym__Atomic] = ACTIONS(2491),
    [anon_sym__Noreturn] = ACTIONS(2491),
    [anon_sym_noreturn] = ACTIONS(2491),
    [anon_sym_mutable] = ACTIONS(2491),
    [anon_sym_constinit] = ACTIONS(2491),
    [anon_sym_consteval] = ACTIONS(2491),
    [anon_sym_alignas] = ACTIONS(2491),
    [anon_sym__Alignas] = ACTIONS(2491),
    [sym_primitive_type] = ACTIONS(2491),
    [anon_sym_QMARK] = ACTIONS(2489),
    [anon_sym_LT_EQ_GT] = ACTIONS(2489),
    [anon_sym_or] = ACTIONS(2491),
    [anon_sym_and] = ACTIONS(2491),
    [anon_sym_bitor] = ACTIONS(2491),
    [anon_sym_xor] = ACTIONS(2491),
    [anon_sym_bitand] = ACTIONS(2491),
    [anon_sym_not_eq] = ACTIONS(2491),
    [anon_sym_is] = ACTIONS(2491),
    [anon_sym_as] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(2489),
    [anon_sym_PLUS_PLUS] = ACTIONS(2489),
    [anon_sym_DOT] = ACTIONS(2491),
    [anon_sym_DOT_STAR] = ACTIONS(2489),
    [anon_sym_DASH_GT] = ACTIONS(2489),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2491),
    [anon_sym_let] = ACTIONS(2491),
    [anon_sym_This] = ACTIONS(2491),
    [anon_sym_final] = ACTIONS(2491),
    [anon_sym_override] = ACTIONS(2491),
    [anon_sym_requires] = ACTIONS(2491),
    [anon_sym_where] = ACTIONS(2491),
  },
  [2930] = {
    [sym_identifier] = ACTIONS(3338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3336),
    [anon_sym_COMMA] = ACTIONS(3336),
    [anon_sym_RPAREN] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3338),
    [anon_sym_PLUS] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3336),
    [anon_sym_SLASH] = ACTIONS(3338),
    [anon_sym_PERCENT] = ACTIONS(3336),
    [anon_sym_PIPE_PIPE] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_PIPE] = ACTIONS(3338),
    [anon_sym_CARET] = ACTIONS(3336),
    [anon_sym_AMP] = ACTIONS(3338),
    [anon_sym_EQ_EQ] = ACTIONS(3336),
    [anon_sym_BANG_EQ] = ACTIONS(3336),
    [anon_sym_GT] = ACTIONS(3338),
    [anon_sym_GT_EQ] = ACTIONS(3336),
    [anon_sym_LT_EQ] = ACTIONS(3338),
    [anon_sym_LT] = ACTIONS(3338),
    [anon_sym_LT_LT] = ACTIONS(3336),
    [anon_sym_GT_GT] = ACTIONS(3336),
    [anon_sym_COLON] = ACTIONS(3336),
    [anon_sym_SEMI] = ACTIONS(3336),
    [anon_sym___extension__] = ACTIONS(3338),
    [anon_sym___attribute__] = ACTIONS(3338),
    [anon_sym___based] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_RBRACE] = ACTIONS(3336),
    [anon_sym_signed] = ACTIONS(3338),
    [anon_sym_unsigned] = ACTIONS(3338),
    [anon_sym_long] = ACTIONS(3338),
    [anon_sym_short] = ACTIONS(3338),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_RBRACK] = ACTIONS(3336),
    [anon_sym_const] = ACTIONS(3338),
    [anon_sym_constexpr] = ACTIONS(3338),
    [anon_sym_volatile] = ACTIONS(3338),
    [anon_sym_restrict] = ACTIONS(3338),
    [anon_sym___restrict__] = ACTIONS(3338),
    [anon_sym__Atomic] = ACTIONS(3338),
    [anon_sym__Noreturn] = ACTIONS(3338),
    [anon_sym_noreturn] = ACTIONS(3338),
    [anon_sym_mutable] = ACTIONS(3338),
    [anon_sym_constinit] = ACTIONS(3338),
    [anon_sym_consteval] = ACTIONS(3338),
    [anon_sym_alignas] = ACTIONS(3338),
    [anon_sym__Alignas] = ACTIONS(3338),
    [sym_primitive_type] = ACTIONS(3338),
    [anon_sym_QMARK] = ACTIONS(3336),
    [anon_sym_LT_EQ_GT] = ACTIONS(3336),
    [anon_sym_or] = ACTIONS(3338),
    [anon_sym_and] = ACTIONS(3338),
    [anon_sym_bitor] = ACTIONS(3338),
    [anon_sym_xor] = ACTIONS(3338),
    [anon_sym_bitand] = ACTIONS(3338),
    [anon_sym_not_eq] = ACTIONS(3338),
    [anon_sym_is] = ACTIONS(3338),
    [anon_sym_as] = ACTIONS(3338),
    [anon_sym_DASH_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_PLUS] = ACTIONS(3336),
    [anon_sym_DOT] = ACTIONS(3338),
    [anon_sym_DOT_STAR] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(3336),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3338),
    [anon_sym_let] = ACTIONS(3338),
    [anon_sym_This] = ACTIONS(3338),
    [anon_sym_final] = ACTIONS(3338),
    [anon_sym_override] = ACTIONS(3338),
    [anon_sym_requires] = ACTIONS(3338),
    [anon_sym_where] = ACTIONS(3338),
  },
  [2931] = {
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3360),
    [anon_sym_COMMA] = ACTIONS(3360),
    [anon_sym_RPAREN] = ACTIONS(3360),
    [anon_sym_LPAREN2] = ACTIONS(3360),
    [anon_sym_DASH] = ACTIONS(3362),
    [anon_sym_PLUS] = ACTIONS(3362),
    [anon_sym_STAR] = ACTIONS(3360),
    [anon_sym_SLASH] = ACTIONS(3362),
    [anon_sym_PERCENT] = ACTIONS(3360),
    [anon_sym_PIPE_PIPE] = ACTIONS(3360),
    [anon_sym_AMP_AMP] = ACTIONS(3360),
    [anon_sym_PIPE] = ACTIONS(3362),
    [anon_sym_CARET] = ACTIONS(3360),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_EQ_EQ] = ACTIONS(3360),
    [anon_sym_BANG_EQ] = ACTIONS(3360),
    [anon_sym_GT] = ACTIONS(3362),
    [anon_sym_GT_EQ] = ACTIONS(3360),
    [anon_sym_LT_EQ] = ACTIONS(3362),
    [anon_sym_LT] = ACTIONS(3362),
    [anon_sym_LT_LT] = ACTIONS(3360),
    [anon_sym_GT_GT] = ACTIONS(3360),
    [anon_sym_COLON] = ACTIONS(3360),
    [anon_sym_SEMI] = ACTIONS(3360),
    [anon_sym___extension__] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___based] = ACTIONS(3362),
    [anon_sym_LBRACE] = ACTIONS(3360),
    [anon_sym_RBRACE] = ACTIONS(3360),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(3360),
    [anon_sym_RBRACK] = ACTIONS(3360),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3362),
    [anon_sym_QMARK] = ACTIONS(3360),
    [anon_sym_LT_EQ_GT] = ACTIONS(3360),
    [anon_sym_or] = ACTIONS(3362),
    [anon_sym_and] = ACTIONS(3362),
    [anon_sym_bitor] = ACTIONS(3362),
    [anon_sym_xor] = ACTIONS(3362),
    [anon_sym_bitand] = ACTIONS(3362),
    [anon_sym_not_eq] = ACTIONS(3362),
    [anon_sym_is] = ACTIONS(3362),
    [anon_sym_as] = ACTIONS(3362),
    [anon_sym_DASH_DASH] = ACTIONS(3360),
    [anon_sym_PLUS_PLUS] = ACTIONS(3360),
    [anon_sym_DOT] = ACTIONS(3362),
    [anon_sym_DOT_STAR] = ACTIONS(3360),
    [anon_sym_DASH_GT] = ACTIONS(3360),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_final] = ACTIONS(3362),
    [anon_sym_override] = ACTIONS(3362),
    [anon_sym_requires] = ACTIONS(3362),
    [anon_sym_where] = ACTIONS(3362),
  },
  [2932] = {
    [sym_identifier] = ACTIONS(3366),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3364),
    [anon_sym_COMMA] = ACTIONS(3364),
    [anon_sym_RPAREN] = ACTIONS(3364),
    [anon_sym_LPAREN2] = ACTIONS(3364),
    [anon_sym_DASH] = ACTIONS(3366),
    [anon_sym_PLUS] = ACTIONS(3366),
    [anon_sym_STAR] = ACTIONS(3364),
    [anon_sym_SLASH] = ACTIONS(3366),
    [anon_sym_PERCENT] = ACTIONS(3364),
    [anon_sym_PIPE_PIPE] = ACTIONS(3364),
    [anon_sym_AMP_AMP] = ACTIONS(3364),
    [anon_sym_PIPE] = ACTIONS(3366),
    [anon_sym_CARET] = ACTIONS(3364),
    [anon_sym_AMP] = ACTIONS(3366),
    [anon_sym_EQ_EQ] = ACTIONS(3364),
    [anon_sym_BANG_EQ] = ACTIONS(3364),
    [anon_sym_GT] = ACTIONS(3366),
    [anon_sym_GT_EQ] = ACTIONS(3364),
    [anon_sym_LT_EQ] = ACTIONS(3366),
    [anon_sym_LT] = ACTIONS(3366),
    [anon_sym_LT_LT] = ACTIONS(3364),
    [anon_sym_GT_GT] = ACTIONS(3364),
    [anon_sym_COLON] = ACTIONS(3364),
    [anon_sym_SEMI] = ACTIONS(3364),
    [anon_sym___extension__] = ACTIONS(3366),
    [anon_sym___attribute__] = ACTIONS(3366),
    [anon_sym___based] = ACTIONS(3366),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_RBRACE] = ACTIONS(3364),
    [anon_sym_signed] = ACTIONS(3366),
    [anon_sym_unsigned] = ACTIONS(3366),
    [anon_sym_long] = ACTIONS(3366),
    [anon_sym_short] = ACTIONS(3366),
    [anon_sym_LBRACK] = ACTIONS(3364),
    [anon_sym_RBRACK] = ACTIONS(3364),
    [anon_sym_const] = ACTIONS(3366),
    [anon_sym_constexpr] = ACTIONS(3366),
    [anon_sym_volatile] = ACTIONS(3366),
    [anon_sym_restrict] = ACTIONS(3366),
    [anon_sym___restrict__] = ACTIONS(3366),
    [anon_sym__Atomic] = ACTIONS(3366),
    [anon_sym__Noreturn] = ACTIONS(3366),
    [anon_sym_noreturn] = ACTIONS(3366),
    [anon_sym_mutable] = ACTIONS(3366),
    [anon_sym_constinit] = ACTIONS(3366),
    [anon_sym_consteval] = ACTIONS(3366),
    [anon_sym_alignas] = ACTIONS(3366),
    [anon_sym__Alignas] = ACTIONS(3366),
    [sym_primitive_type] = ACTIONS(3366),
    [anon_sym_QMARK] = ACTIONS(3364),
    [anon_sym_LT_EQ_GT] = ACTIONS(3364),
    [anon_sym_or] = ACTIONS(3366),
    [anon_sym_and] = ACTIONS(3366),
    [anon_sym_bitor] = ACTIONS(3366),
    [anon_sym_xor] = ACTIONS(3366),
    [anon_sym_bitand] = ACTIONS(3366),
    [anon_sym_not_eq] = ACTIONS(3366),
    [anon_sym_is] = ACTIONS(3366),
    [anon_sym_as] = ACTIONS(3366),
    [anon_sym_DASH_DASH] = ACTIONS(3364),
    [anon_sym_PLUS_PLUS] = ACTIONS(3364),
    [anon_sym_DOT] = ACTIONS(3366),
    [anon_sym_DOT_STAR] = ACTIONS(3364),
    [anon_sym_DASH_GT] = ACTIONS(3364),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3366),
    [anon_sym_let] = ACTIONS(3366),
    [anon_sym_This] = ACTIONS(3366),
    [anon_sym_final] = ACTIONS(3366),
    [anon_sym_override] = ACTIONS(3366),
    [anon_sym_requires] = ACTIONS(3366),
    [anon_sym_where] = ACTIONS(3366),
  },
  [2933] = {
    [sym_identifier] = ACTIONS(3156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3154),
    [anon_sym_COMMA] = ACTIONS(3154),
    [anon_sym_RPAREN] = ACTIONS(3154),
    [anon_sym_LPAREN2] = ACTIONS(3154),
    [anon_sym_DASH] = ACTIONS(3156),
    [anon_sym_PLUS] = ACTIONS(3156),
    [anon_sym_STAR] = ACTIONS(3154),
    [anon_sym_SLASH] = ACTIONS(3156),
    [anon_sym_PERCENT] = ACTIONS(3154),
    [anon_sym_PIPE_PIPE] = ACTIONS(3154),
    [anon_sym_AMP_AMP] = ACTIONS(3154),
    [anon_sym_PIPE] = ACTIONS(3156),
    [anon_sym_CARET] = ACTIONS(3154),
    [anon_sym_AMP] = ACTIONS(3156),
    [anon_sym_EQ_EQ] = ACTIONS(3154),
    [anon_sym_BANG_EQ] = ACTIONS(3154),
    [anon_sym_GT] = ACTIONS(3156),
    [anon_sym_GT_EQ] = ACTIONS(3154),
    [anon_sym_LT_EQ] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3156),
    [anon_sym_LT_LT] = ACTIONS(3154),
    [anon_sym_GT_GT] = ACTIONS(3154),
    [anon_sym_COLON] = ACTIONS(3154),
    [anon_sym_SEMI] = ACTIONS(3154),
    [anon_sym___extension__] = ACTIONS(3156),
    [anon_sym___attribute__] = ACTIONS(3156),
    [anon_sym___based] = ACTIONS(3156),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_RBRACE] = ACTIONS(3154),
    [anon_sym_signed] = ACTIONS(3156),
    [anon_sym_unsigned] = ACTIONS(3156),
    [anon_sym_long] = ACTIONS(3156),
    [anon_sym_short] = ACTIONS(3156),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_RBRACK] = ACTIONS(3154),
    [anon_sym_const] = ACTIONS(3156),
    [anon_sym_constexpr] = ACTIONS(3156),
    [anon_sym_volatile] = ACTIONS(3156),
    [anon_sym_restrict] = ACTIONS(3156),
    [anon_sym___restrict__] = ACTIONS(3156),
    [anon_sym__Atomic] = ACTIONS(3156),
    [anon_sym__Noreturn] = ACTIONS(3156),
    [anon_sym_noreturn] = ACTIONS(3156),
    [anon_sym_mutable] = ACTIONS(3156),
    [anon_sym_constinit] = ACTIONS(3156),
    [anon_sym_consteval] = ACTIONS(3156),
    [anon_sym_alignas] = ACTIONS(3156),
    [anon_sym__Alignas] = ACTIONS(3156),
    [sym_primitive_type] = ACTIONS(3156),
    [anon_sym_QMARK] = ACTIONS(3154),
    [anon_sym_LT_EQ_GT] = ACTIONS(3154),
    [anon_sym_or] = ACTIONS(3156),
    [anon_sym_and] = ACTIONS(3156),
    [anon_sym_bitor] = ACTIONS(3156),
    [anon_sym_xor] = ACTIONS(3156),
    [anon_sym_bitand] = ACTIONS(3156),
    [anon_sym_not_eq] = ACTIONS(3156),
    [anon_sym_is] = ACTIONS(3156),
    [anon_sym_as] = ACTIONS(3156),
    [anon_sym_DASH_DASH] = ACTIONS(3154),
    [anon_sym_PLUS_PLUS] = ACTIONS(3154),
    [anon_sym_DOT] = ACTIONS(3156),
    [anon_sym_DOT_STAR] = ACTIONS(3154),
    [anon_sym_DASH_GT] = ACTIONS(3154),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3156),
    [anon_sym_let] = ACTIONS(3156),
    [anon_sym_This] = ACTIONS(3156),
    [anon_sym_final] = ACTIONS(3156),
    [anon_sym_override] = ACTIONS(3156),
    [anon_sym_requires] = ACTIONS(3156),
    [anon_sym_where] = ACTIONS(3156),
  },
  [2934] = {
    [sym_identifier] = ACTIONS(2964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2962),
    [anon_sym_COMMA] = ACTIONS(2962),
    [anon_sym_RPAREN] = ACTIONS(2962),
    [anon_sym_LPAREN2] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2964),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_STAR] = ACTIONS(2962),
    [anon_sym_SLASH] = ACTIONS(2964),
    [anon_sym_PERCENT] = ACTIONS(2962),
    [anon_sym_PIPE_PIPE] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_PIPE] = ACTIONS(2964),
    [anon_sym_CARET] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_EQ_EQ] = ACTIONS(2962),
    [anon_sym_BANG_EQ] = ACTIONS(2962),
    [anon_sym_GT] = ACTIONS(2964),
    [anon_sym_GT_EQ] = ACTIONS(2962),
    [anon_sym_LT_EQ] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_LT_LT] = ACTIONS(2962),
    [anon_sym_GT_GT] = ACTIONS(2962),
    [anon_sym_COLON] = ACTIONS(2962),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym___extension__] = ACTIONS(2964),
    [anon_sym___attribute__] = ACTIONS(2964),
    [anon_sym___based] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_RBRACE] = ACTIONS(2962),
    [anon_sym_signed] = ACTIONS(2964),
    [anon_sym_unsigned] = ACTIONS(2964),
    [anon_sym_long] = ACTIONS(2964),
    [anon_sym_short] = ACTIONS(2964),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [anon_sym_RBRACK] = ACTIONS(2962),
    [anon_sym_const] = ACTIONS(2964),
    [anon_sym_constexpr] = ACTIONS(2964),
    [anon_sym_volatile] = ACTIONS(2964),
    [anon_sym_restrict] = ACTIONS(2964),
    [anon_sym___restrict__] = ACTIONS(2964),
    [anon_sym__Atomic] = ACTIONS(2964),
    [anon_sym__Noreturn] = ACTIONS(2964),
    [anon_sym_noreturn] = ACTIONS(2964),
    [anon_sym_mutable] = ACTIONS(2964),
    [anon_sym_constinit] = ACTIONS(2964),
    [anon_sym_consteval] = ACTIONS(2964),
    [anon_sym_alignas] = ACTIONS(2964),
    [anon_sym__Alignas] = ACTIONS(2964),
    [sym_primitive_type] = ACTIONS(2964),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_LT_EQ_GT] = ACTIONS(2962),
    [anon_sym_or] = ACTIONS(2964),
    [anon_sym_and] = ACTIONS(2964),
    [anon_sym_bitor] = ACTIONS(2964),
    [anon_sym_xor] = ACTIONS(2964),
    [anon_sym_bitand] = ACTIONS(2964),
    [anon_sym_not_eq] = ACTIONS(2964),
    [anon_sym_is] = ACTIONS(2964),
    [anon_sym_as] = ACTIONS(2964),
    [anon_sym_DASH_DASH] = ACTIONS(2962),
    [anon_sym_PLUS_PLUS] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2964),
    [anon_sym_DOT_STAR] = ACTIONS(2962),
    [anon_sym_DASH_GT] = ACTIONS(2962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2964),
    [anon_sym_let] = ACTIONS(2964),
    [anon_sym_This] = ACTIONS(2964),
    [anon_sym_final] = ACTIONS(2964),
    [anon_sym_override] = ACTIONS(2964),
    [anon_sym_requires] = ACTIONS(2964),
    [anon_sym_where] = ACTIONS(2964),
  },
  [2935] = {
    [sym_identifier] = ACTIONS(3102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3100),
    [anon_sym_COMMA] = ACTIONS(3100),
    [anon_sym_RPAREN] = ACTIONS(3100),
    [anon_sym_LPAREN2] = ACTIONS(3100),
    [anon_sym_DASH] = ACTIONS(3102),
    [anon_sym_PLUS] = ACTIONS(3102),
    [anon_sym_STAR] = ACTIONS(3100),
    [anon_sym_SLASH] = ACTIONS(3102),
    [anon_sym_PERCENT] = ACTIONS(3100),
    [anon_sym_PIPE_PIPE] = ACTIONS(3100),
    [anon_sym_AMP_AMP] = ACTIONS(3100),
    [anon_sym_PIPE] = ACTIONS(3102),
    [anon_sym_CARET] = ACTIONS(3100),
    [anon_sym_AMP] = ACTIONS(3102),
    [anon_sym_EQ_EQ] = ACTIONS(3100),
    [anon_sym_BANG_EQ] = ACTIONS(3100),
    [anon_sym_GT] = ACTIONS(3102),
    [anon_sym_GT_EQ] = ACTIONS(3100),
    [anon_sym_LT_EQ] = ACTIONS(3102),
    [anon_sym_LT] = ACTIONS(3102),
    [anon_sym_LT_LT] = ACTIONS(3100),
    [anon_sym_GT_GT] = ACTIONS(3100),
    [anon_sym_COLON] = ACTIONS(3100),
    [anon_sym_SEMI] = ACTIONS(3100),
    [anon_sym___extension__] = ACTIONS(3102),
    [anon_sym___attribute__] = ACTIONS(3102),
    [anon_sym___based] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(3100),
    [anon_sym_RBRACE] = ACTIONS(3100),
    [anon_sym_signed] = ACTIONS(3102),
    [anon_sym_unsigned] = ACTIONS(3102),
    [anon_sym_long] = ACTIONS(3102),
    [anon_sym_short] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3100),
    [anon_sym_RBRACK] = ACTIONS(3100),
    [anon_sym_const] = ACTIONS(3102),
    [anon_sym_constexpr] = ACTIONS(3102),
    [anon_sym_volatile] = ACTIONS(3102),
    [anon_sym_restrict] = ACTIONS(3102),
    [anon_sym___restrict__] = ACTIONS(3102),
    [anon_sym__Atomic] = ACTIONS(3102),
    [anon_sym__Noreturn] = ACTIONS(3102),
    [anon_sym_noreturn] = ACTIONS(3102),
    [anon_sym_mutable] = ACTIONS(3102),
    [anon_sym_constinit] = ACTIONS(3102),
    [anon_sym_consteval] = ACTIONS(3102),
    [anon_sym_alignas] = ACTIONS(3102),
    [anon_sym__Alignas] = ACTIONS(3102),
    [sym_primitive_type] = ACTIONS(3102),
    [anon_sym_QMARK] = ACTIONS(3100),
    [anon_sym_LT_EQ_GT] = ACTIONS(3100),
    [anon_sym_or] = ACTIONS(3102),
    [anon_sym_and] = ACTIONS(3102),
    [anon_sym_bitor] = ACTIONS(3102),
    [anon_sym_xor] = ACTIONS(3102),
    [anon_sym_bitand] = ACTIONS(3102),
    [anon_sym_not_eq] = ACTIONS(3102),
    [anon_sym_is] = ACTIONS(3102),
    [anon_sym_as] = ACTIONS(3102),
    [anon_sym_DASH_DASH] = ACTIONS(3100),
    [anon_sym_PLUS_PLUS] = ACTIONS(3100),
    [anon_sym_DOT] = ACTIONS(3102),
    [anon_sym_DOT_STAR] = ACTIONS(3100),
    [anon_sym_DASH_GT] = ACTIONS(3100),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3102),
    [anon_sym_let] = ACTIONS(3102),
    [anon_sym_This] = ACTIONS(3102),
    [anon_sym_final] = ACTIONS(3102),
    [anon_sym_override] = ACTIONS(3102),
    [anon_sym_requires] = ACTIONS(3102),
    [anon_sym_where] = ACTIONS(3102),
  },
  [2936] = {
    [sym_identifier] = ACTIONS(3000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2998),
    [anon_sym_COMMA] = ACTIONS(2998),
    [anon_sym_RPAREN] = ACTIONS(2998),
    [anon_sym_LPAREN2] = ACTIONS(2998),
    [anon_sym_DASH] = ACTIONS(3000),
    [anon_sym_PLUS] = ACTIONS(3000),
    [anon_sym_STAR] = ACTIONS(2998),
    [anon_sym_SLASH] = ACTIONS(3000),
    [anon_sym_PERCENT] = ACTIONS(2998),
    [anon_sym_PIPE_PIPE] = ACTIONS(2998),
    [anon_sym_AMP_AMP] = ACTIONS(2998),
    [anon_sym_PIPE] = ACTIONS(3000),
    [anon_sym_CARET] = ACTIONS(2998),
    [anon_sym_AMP] = ACTIONS(3000),
    [anon_sym_EQ_EQ] = ACTIONS(2998),
    [anon_sym_BANG_EQ] = ACTIONS(2998),
    [anon_sym_GT] = ACTIONS(3000),
    [anon_sym_GT_EQ] = ACTIONS(2998),
    [anon_sym_LT_EQ] = ACTIONS(3000),
    [anon_sym_LT] = ACTIONS(3000),
    [anon_sym_LT_LT] = ACTIONS(2998),
    [anon_sym_GT_GT] = ACTIONS(2998),
    [anon_sym_COLON] = ACTIONS(2998),
    [anon_sym_SEMI] = ACTIONS(2998),
    [anon_sym___extension__] = ACTIONS(3000),
    [anon_sym___attribute__] = ACTIONS(3000),
    [anon_sym___based] = ACTIONS(3000),
    [anon_sym_LBRACE] = ACTIONS(2998),
    [anon_sym_RBRACE] = ACTIONS(2998),
    [anon_sym_signed] = ACTIONS(3000),
    [anon_sym_unsigned] = ACTIONS(3000),
    [anon_sym_long] = ACTIONS(3000),
    [anon_sym_short] = ACTIONS(3000),
    [anon_sym_LBRACK] = ACTIONS(2998),
    [anon_sym_RBRACK] = ACTIONS(2998),
    [anon_sym_const] = ACTIONS(3000),
    [anon_sym_constexpr] = ACTIONS(3000),
    [anon_sym_volatile] = ACTIONS(3000),
    [anon_sym_restrict] = ACTIONS(3000),
    [anon_sym___restrict__] = ACTIONS(3000),
    [anon_sym__Atomic] = ACTIONS(3000),
    [anon_sym__Noreturn] = ACTIONS(3000),
    [anon_sym_noreturn] = ACTIONS(3000),
    [anon_sym_mutable] = ACTIONS(3000),
    [anon_sym_constinit] = ACTIONS(3000),
    [anon_sym_consteval] = ACTIONS(3000),
    [anon_sym_alignas] = ACTIONS(3000),
    [anon_sym__Alignas] = ACTIONS(3000),
    [sym_primitive_type] = ACTIONS(3000),
    [anon_sym_QMARK] = ACTIONS(2998),
    [anon_sym_LT_EQ_GT] = ACTIONS(2998),
    [anon_sym_or] = ACTIONS(3000),
    [anon_sym_and] = ACTIONS(3000),
    [anon_sym_bitor] = ACTIONS(3000),
    [anon_sym_xor] = ACTIONS(3000),
    [anon_sym_bitand] = ACTIONS(3000),
    [anon_sym_not_eq] = ACTIONS(3000),
    [anon_sym_is] = ACTIONS(3000),
    [anon_sym_as] = ACTIONS(3000),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_DOT] = ACTIONS(3000),
    [anon_sym_DOT_STAR] = ACTIONS(2998),
    [anon_sym_DASH_GT] = ACTIONS(2998),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3000),
    [anon_sym_let] = ACTIONS(3000),
    [anon_sym_This] = ACTIONS(3000),
    [anon_sym_final] = ACTIONS(3000),
    [anon_sym_override] = ACTIONS(3000),
    [anon_sym_requires] = ACTIONS(3000),
    [anon_sym_where] = ACTIONS(3000),
  },
  [2937] = {
    [sym_template_argument_list] = STATE(2955),
    [sym_identifier] = ACTIONS(2169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2176),
    [anon_sym_COMMA] = ACTIONS(2176),
    [anon_sym_RPAREN] = ACTIONS(2176),
    [aux_sym_preproc_if_token2] = ACTIONS(2176),
    [aux_sym_preproc_else_token1] = ACTIONS(2176),
    [aux_sym_preproc_elif_token1] = ACTIONS(2169),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2176),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2176),
    [anon_sym_LPAREN2] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2169),
    [anon_sym_PLUS] = ACTIONS(2169),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_SLASH] = ACTIONS(2169),
    [anon_sym_PERCENT] = ACTIONS(2169),
    [anon_sym_PIPE_PIPE] = ACTIONS(2176),
    [anon_sym_AMP_AMP] = ACTIONS(2176),
    [anon_sym_PIPE] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_EQ_EQ] = ACTIONS(2176),
    [anon_sym_BANG_EQ] = ACTIONS(2176),
    [anon_sym_GT] = ACTIONS(2169),
    [anon_sym_GT_EQ] = ACTIONS(2176),
    [anon_sym_LT_EQ] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(6541),
    [anon_sym_LT_LT] = ACTIONS(2169),
    [anon_sym_GT_GT] = ACTIONS(2169),
    [anon_sym_COLON] = ACTIONS(2169),
    [anon_sym_SEMI] = ACTIONS(2176),
    [anon_sym___attribute__] = ACTIONS(2169),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2176),
    [anon_sym_RBRACE] = ACTIONS(2176),
    [anon_sym_LBRACK] = ACTIONS(2176),
    [anon_sym_RBRACK] = ACTIONS(2176),
    [anon_sym_EQ] = ACTIONS(2169),
    [anon_sym_QMARK] = ACTIONS(2176),
    [anon_sym_STAR_EQ] = ACTIONS(2176),
    [anon_sym_SLASH_EQ] = ACTIONS(2176),
    [anon_sym_PERCENT_EQ] = ACTIONS(2176),
    [anon_sym_PLUS_EQ] = ACTIONS(2176),
    [anon_sym_DASH_EQ] = ACTIONS(2176),
    [anon_sym_LT_LT_EQ] = ACTIONS(2176),
    [anon_sym_GT_GT_EQ] = ACTIONS(2176),
    [anon_sym_AMP_EQ] = ACTIONS(2176),
    [anon_sym_CARET_EQ] = ACTIONS(2176),
    [anon_sym_PIPE_EQ] = ACTIONS(2176),
    [anon_sym_and_eq] = ACTIONS(2169),
    [anon_sym_or_eq] = ACTIONS(2169),
    [anon_sym_xor_eq] = ACTIONS(2169),
    [anon_sym_LT_EQ_GT] = ACTIONS(2176),
    [anon_sym_or] = ACTIONS(2169),
    [anon_sym_and] = ACTIONS(2169),
    [anon_sym_bitor] = ACTIONS(2169),
    [anon_sym_xor] = ACTIONS(2169),
    [anon_sym_bitand] = ACTIONS(2169),
    [anon_sym_not_eq] = ACTIONS(2169),
    [anon_sym_is] = ACTIONS(2169),
    [anon_sym_as] = ACTIONS(2169),
    [anon_sym_DASH_DASH] = ACTIONS(2176),
    [anon_sym_PLUS_PLUS] = ACTIONS(2176),
    [anon_sym_DOT] = ACTIONS(2169),
    [anon_sym_DOT_STAR] = ACTIONS(2176),
    [anon_sym_DASH_GT] = ACTIONS(2176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2169),
    [anon_sym_let] = ACTIONS(2169),
    [anon_sym_This] = ACTIONS(2169),
    [anon_sym_final] = ACTIONS(2169),
    [anon_sym_override] = ACTIONS(2169),
  },
  [2938] = {
    [sym_identifier] = ACTIONS(3890),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3892),
    [anon_sym_COMMA] = ACTIONS(3892),
    [anon_sym_RPAREN] = ACTIONS(3892),
    [anon_sym_LPAREN2] = ACTIONS(3892),
    [anon_sym_TILDE] = ACTIONS(3892),
    [anon_sym_STAR] = ACTIONS(3892),
    [anon_sym_AMP_AMP] = ACTIONS(3892),
    [anon_sym_AMP] = ACTIONS(3890),
    [anon_sym_COLON] = ACTIONS(3890),
    [anon_sym___extension__] = ACTIONS(3890),
    [anon_sym_in] = ACTIONS(3890),
    [anon_sym_out] = ACTIONS(3890),
    [anon_sym_inout] = ACTIONS(3890),
    [anon_sym_extern] = ACTIONS(3890),
    [anon_sym___attribute__] = ACTIONS(3890),
    [anon_sym_COLON_COLON] = ACTIONS(3892),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3892),
    [anon_sym___declspec] = ACTIONS(3890),
    [anon_sym___based] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3890),
    [anon_sym_static] = ACTIONS(3890),
    [anon_sym_EQ] = ACTIONS(3892),
    [anon_sym_register] = ACTIONS(3890),
    [anon_sym_inline] = ACTIONS(3890),
    [anon_sym___inline] = ACTIONS(3890),
    [anon_sym___inline__] = ACTIONS(3890),
    [anon_sym___forceinline] = ACTIONS(3890),
    [anon_sym_thread_local] = ACTIONS(3890),
    [anon_sym___thread] = ACTIONS(3890),
    [anon_sym_const] = ACTIONS(3890),
    [anon_sym_constexpr] = ACTIONS(3890),
    [anon_sym_volatile] = ACTIONS(3890),
    [anon_sym_restrict] = ACTIONS(3890),
    [anon_sym___restrict__] = ACTIONS(3890),
    [anon_sym__Atomic] = ACTIONS(3890),
    [anon_sym__Noreturn] = ACTIONS(3890),
    [anon_sym_noreturn] = ACTIONS(3890),
    [anon_sym_mutable] = ACTIONS(3890),
    [anon_sym_constinit] = ACTIONS(3890),
    [anon_sym_consteval] = ACTIONS(3890),
    [anon_sym_alignas] = ACTIONS(3890),
    [anon_sym__Alignas] = ACTIONS(3890),
    [anon_sym_DOT] = ACTIONS(6327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6307),
    [anon_sym_let] = ACTIONS(6307),
    [anon_sym_This] = ACTIONS(6307),
    [anon_sym_decltype] = ACTIONS(3890),
    [sym_virtual] = ACTIONS(3890),
    [anon_sym_template] = ACTIONS(3890),
    [anon_sym_GT2] = ACTIONS(3892),
    [anon_sym_operator] = ACTIONS(3890),
    [anon_sym_precise] = ACTIONS(3890),
    [anon_sym_shared] = ACTIONS(3890),
    [anon_sym_groupshared] = ACTIONS(3890),
    [anon_sym_uniform] = ACTIONS(3890),
    [anon_sym_row_major] = ACTIONS(3890),
    [anon_sym_column_major] = ACTIONS(3890),
    [anon_sym_globallycoherent] = ACTIONS(3890),
    [anon_sym_centroid] = ACTIONS(3890),
    [anon_sym_noperspective] = ACTIONS(3890),
    [anon_sym_nointerpolation] = ACTIONS(3890),
    [anon_sym_sample] = ACTIONS(3890),
    [anon_sym_linear] = ACTIONS(3890),
    [anon_sym_snorm] = ACTIONS(3890),
    [anon_sym_unorm] = ACTIONS(3890),
    [anon_sym_point] = ACTIONS(3890),
    [anon_sym_line] = ACTIONS(3890),
    [anon_sym_triangleadj] = ACTIONS(3890),
    [anon_sym_lineadj] = ACTIONS(3890),
    [anon_sym_triangle] = ACTIONS(3890),
  },
  [2939] = {
    [sym_identifier] = ACTIONS(3844),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3846),
    [anon_sym_COMMA] = ACTIONS(3846),
    [anon_sym_RPAREN] = ACTIONS(3846),
    [aux_sym_preproc_if_token2] = ACTIONS(3846),
    [aux_sym_preproc_else_token1] = ACTIONS(3846),
    [aux_sym_preproc_elif_token1] = ACTIONS(3844),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3846),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3846),
    [anon_sym_LPAREN2] = ACTIONS(3846),
    [anon_sym_DASH] = ACTIONS(3844),
    [anon_sym_PLUS] = ACTIONS(3844),
    [anon_sym_STAR] = ACTIONS(3846),
    [anon_sym_SLASH] = ACTIONS(3844),
    [anon_sym_PERCENT] = ACTIONS(3846),
    [anon_sym_PIPE_PIPE] = ACTIONS(3846),
    [anon_sym_AMP_AMP] = ACTIONS(3846),
    [anon_sym_PIPE] = ACTIONS(3844),
    [anon_sym_CARET] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3844),
    [anon_sym_EQ_EQ] = ACTIONS(3846),
    [anon_sym_BANG_EQ] = ACTIONS(3846),
    [anon_sym_GT] = ACTIONS(3844),
    [anon_sym_GT_EQ] = ACTIONS(3846),
    [anon_sym_LT_EQ] = ACTIONS(3844),
    [anon_sym_LT] = ACTIONS(3844),
    [anon_sym_LT_LT] = ACTIONS(3846),
    [anon_sym_GT_GT] = ACTIONS(3846),
    [anon_sym_COLON] = ACTIONS(3846),
    [anon_sym_SEMI] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(3844),
    [anon_sym___attribute__] = ACTIONS(3844),
    [anon_sym_LBRACE] = ACTIONS(3846),
    [anon_sym_RBRACE] = ACTIONS(3846),
    [anon_sym_LBRACK] = ACTIONS(3846),
    [anon_sym_RBRACK] = ACTIONS(3846),
    [anon_sym_const] = ACTIONS(3844),
    [anon_sym_constexpr] = ACTIONS(3844),
    [anon_sym_volatile] = ACTIONS(3844),
    [anon_sym_restrict] = ACTIONS(3844),
    [anon_sym___restrict__] = ACTIONS(3844),
    [anon_sym__Atomic] = ACTIONS(3844),
    [anon_sym__Noreturn] = ACTIONS(3844),
    [anon_sym_noreturn] = ACTIONS(3844),
    [anon_sym_mutable] = ACTIONS(3844),
    [anon_sym_constinit] = ACTIONS(3844),
    [anon_sym_consteval] = ACTIONS(3844),
    [anon_sym_alignas] = ACTIONS(3844),
    [anon_sym__Alignas] = ACTIONS(3844),
    [anon_sym_QMARK] = ACTIONS(3846),
    [anon_sym_LT_EQ_GT] = ACTIONS(3846),
    [anon_sym_or] = ACTIONS(3844),
    [anon_sym_and] = ACTIONS(3844),
    [anon_sym_bitor] = ACTIONS(3844),
    [anon_sym_xor] = ACTIONS(3844),
    [anon_sym_bitand] = ACTIONS(3844),
    [anon_sym_not_eq] = ACTIONS(3844),
    [anon_sym_is] = ACTIONS(3844),
    [anon_sym_as] = ACTIONS(3844),
    [anon_sym_DASH_DASH] = ACTIONS(3846),
    [anon_sym_PLUS_PLUS] = ACTIONS(3846),
    [anon_sym_DOT] = ACTIONS(3844),
    [anon_sym_DOT_STAR] = ACTIONS(3846),
    [anon_sym_DASH_GT] = ACTIONS(3846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3844),
    [anon_sym_let] = ACTIONS(3844),
    [anon_sym_This] = ACTIONS(3844),
    [anon_sym_final] = ACTIONS(3844),
    [anon_sym_override] = ACTIONS(3844),
    [anon_sym_requires] = ACTIONS(3844),
    [anon_sym_where] = ACTIONS(3844),
  },
  [2940] = {
    [sym_type_qualifier] = STATE(2940),
    [sym_alignas_qualifier] = STATE(2994),
    [aux_sym_array_declarator_repeat1] = STATE(2940),
    [sym_identifier] = ACTIONS(6544),
    [anon_sym_LPAREN2] = ACTIONS(6546),
    [anon_sym_BANG] = ACTIONS(6546),
    [anon_sym_TILDE] = ACTIONS(6546),
    [anon_sym_DASH] = ACTIONS(6544),
    [anon_sym_PLUS] = ACTIONS(6544),
    [anon_sym_STAR] = ACTIONS(6546),
    [anon_sym_AMP] = ACTIONS(6546),
    [anon_sym___extension__] = ACTIONS(6548),
    [anon_sym_COLON_COLON] = ACTIONS(6546),
    [anon_sym_LBRACK] = ACTIONS(6546),
    [anon_sym_static] = ACTIONS(6551),
    [anon_sym_RBRACK] = ACTIONS(6546),
    [anon_sym_const] = ACTIONS(6548),
    [anon_sym_constexpr] = ACTIONS(6548),
    [anon_sym_volatile] = ACTIONS(6548),
    [anon_sym_restrict] = ACTIONS(6548),
    [anon_sym___restrict__] = ACTIONS(6548),
    [anon_sym__Atomic] = ACTIONS(6548),
    [anon_sym__Noreturn] = ACTIONS(6548),
    [anon_sym_noreturn] = ACTIONS(6548),
    [anon_sym_mutable] = ACTIONS(6548),
    [anon_sym_constinit] = ACTIONS(6548),
    [anon_sym_consteval] = ACTIONS(6548),
    [anon_sym_alignas] = ACTIONS(6554),
    [anon_sym__Alignas] = ACTIONS(6554),
    [sym_primitive_type] = ACTIONS(6544),
    [anon_sym_not] = ACTIONS(6544),
    [anon_sym_compl] = ACTIONS(6544),
    [anon_sym_DASH_DASH] = ACTIONS(6546),
    [anon_sym_PLUS_PLUS] = ACTIONS(6546),
    [anon_sym_sizeof] = ACTIONS(6544),
    [anon_sym___alignof__] = ACTIONS(6544),
    [anon_sym___alignof] = ACTIONS(6544),
    [anon_sym__alignof] = ACTIONS(6544),
    [anon_sym_alignof] = ACTIONS(6544),
    [anon_sym__Alignof] = ACTIONS(6544),
    [anon_sym_offsetof] = ACTIONS(6544),
    [anon_sym__Generic] = ACTIONS(6544),
    [anon_sym_asm] = ACTIONS(6544),
    [anon_sym___asm__] = ACTIONS(6544),
    [sym_number_literal] = ACTIONS(6546),
    [anon_sym_L_SQUOTE] = ACTIONS(6546),
    [anon_sym_u_SQUOTE] = ACTIONS(6546),
    [anon_sym_U_SQUOTE] = ACTIONS(6546),
    [anon_sym_u8_SQUOTE] = ACTIONS(6546),
    [anon_sym_SQUOTE] = ACTIONS(6546),
    [anon_sym_L_DQUOTE] = ACTIONS(6546),
    [anon_sym_u_DQUOTE] = ACTIONS(6546),
    [anon_sym_U_DQUOTE] = ACTIONS(6546),
    [anon_sym_u8_DQUOTE] = ACTIONS(6546),
    [anon_sym_DQUOTE] = ACTIONS(6546),
    [sym_true] = ACTIONS(6544),
    [sym_false] = ACTIONS(6544),
    [anon_sym_NULL] = ACTIONS(6544),
    [anon_sym_nullptr] = ACTIONS(6544),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(6544),
    [anon_sym_template] = ACTIONS(6544),
    [anon_sym_delete] = ACTIONS(6544),
    [anon_sym_R_DQUOTE] = ACTIONS(6546),
    [anon_sym_LR_DQUOTE] = ACTIONS(6546),
    [anon_sym_uR_DQUOTE] = ACTIONS(6546),
    [anon_sym_UR_DQUOTE] = ACTIONS(6546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6546),
    [anon_sym_co_await] = ACTIONS(6544),
    [anon_sym_new] = ACTIONS(6544),
    [anon_sym_requires] = ACTIONS(6544),
    [sym_this] = ACTIONS(6544),
  },
  [2941] = {
    [sym_identifier] = ACTIONS(3848),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3850),
    [anon_sym_COMMA] = ACTIONS(3850),
    [anon_sym_RPAREN] = ACTIONS(3850),
    [anon_sym_LPAREN2] = ACTIONS(3850),
    [anon_sym_TILDE] = ACTIONS(3850),
    [anon_sym_STAR] = ACTIONS(3850),
    [anon_sym_AMP_AMP] = ACTIONS(3850),
    [anon_sym_AMP] = ACTIONS(3848),
    [anon_sym_COLON] = ACTIONS(3848),
    [anon_sym___extension__] = ACTIONS(3848),
    [anon_sym_in] = ACTIONS(3848),
    [anon_sym_out] = ACTIONS(3848),
    [anon_sym_inout] = ACTIONS(3848),
    [anon_sym_extern] = ACTIONS(3848),
    [anon_sym___attribute__] = ACTIONS(3848),
    [anon_sym_COLON_COLON] = ACTIONS(3850),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3850),
    [anon_sym___declspec] = ACTIONS(3848),
    [anon_sym___based] = ACTIONS(3848),
    [anon_sym_LBRACK] = ACTIONS(3848),
    [anon_sym_static] = ACTIONS(3848),
    [anon_sym_EQ] = ACTIONS(3850),
    [anon_sym_register] = ACTIONS(3848),
    [anon_sym_inline] = ACTIONS(3848),
    [anon_sym___inline] = ACTIONS(3848),
    [anon_sym___inline__] = ACTIONS(3848),
    [anon_sym___forceinline] = ACTIONS(3848),
    [anon_sym_thread_local] = ACTIONS(3848),
    [anon_sym___thread] = ACTIONS(3848),
    [anon_sym_const] = ACTIONS(3848),
    [anon_sym_constexpr] = ACTIONS(3848),
    [anon_sym_volatile] = ACTIONS(3848),
    [anon_sym_restrict] = ACTIONS(3848),
    [anon_sym___restrict__] = ACTIONS(3848),
    [anon_sym__Atomic] = ACTIONS(3848),
    [anon_sym__Noreturn] = ACTIONS(3848),
    [anon_sym_noreturn] = ACTIONS(3848),
    [anon_sym_mutable] = ACTIONS(3848),
    [anon_sym_constinit] = ACTIONS(3848),
    [anon_sym_consteval] = ACTIONS(3848),
    [anon_sym_alignas] = ACTIONS(3848),
    [anon_sym__Alignas] = ACTIONS(3848),
    [anon_sym_DOT] = ACTIONS(6327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6307),
    [anon_sym_let] = ACTIONS(6307),
    [anon_sym_This] = ACTIONS(6307),
    [anon_sym_decltype] = ACTIONS(3848),
    [sym_virtual] = ACTIONS(3848),
    [anon_sym_template] = ACTIONS(3848),
    [anon_sym_GT2] = ACTIONS(3850),
    [anon_sym_operator] = ACTIONS(3848),
    [anon_sym_precise] = ACTIONS(3848),
    [anon_sym_shared] = ACTIONS(3848),
    [anon_sym_groupshared] = ACTIONS(3848),
    [anon_sym_uniform] = ACTIONS(3848),
    [anon_sym_row_major] = ACTIONS(3848),
    [anon_sym_column_major] = ACTIONS(3848),
    [anon_sym_globallycoherent] = ACTIONS(3848),
    [anon_sym_centroid] = ACTIONS(3848),
    [anon_sym_noperspective] = ACTIONS(3848),
    [anon_sym_nointerpolation] = ACTIONS(3848),
    [anon_sym_sample] = ACTIONS(3848),
    [anon_sym_linear] = ACTIONS(3848),
    [anon_sym_snorm] = ACTIONS(3848),
    [anon_sym_unorm] = ACTIONS(3848),
    [anon_sym_point] = ACTIONS(3848),
    [anon_sym_line] = ACTIONS(3848),
    [anon_sym_triangleadj] = ACTIONS(3848),
    [anon_sym_lineadj] = ACTIONS(3848),
    [anon_sym_triangle] = ACTIONS(3848),
  },
  [2942] = {
    [sym_template_argument_list] = STATE(2957),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2171),
    [anon_sym_RPAREN] = ACTIONS(2173),
    [anon_sym_LPAREN2] = ACTIONS(2173),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2171),
    [anon_sym_AMP_AMP] = ACTIONS(2173),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2171),
    [anon_sym_BANG_EQ] = ACTIONS(2171),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2171),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(6557),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym___extension__] = ACTIONS(2176),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2176),
    [anon_sym_LBRACK] = ACTIONS(2173),
    [anon_sym_EQ] = ACTIONS(2181),
    [anon_sym_const] = ACTIONS(2169),
    [anon_sym_constexpr] = ACTIONS(2176),
    [anon_sym_volatile] = ACTIONS(2176),
    [anon_sym_restrict] = ACTIONS(2176),
    [anon_sym___restrict__] = ACTIONS(2176),
    [anon_sym__Atomic] = ACTIONS(2176),
    [anon_sym__Noreturn] = ACTIONS(2176),
    [anon_sym_noreturn] = ACTIONS(2176),
    [anon_sym_mutable] = ACTIONS(2176),
    [anon_sym_constinit] = ACTIONS(2176),
    [anon_sym_consteval] = ACTIONS(2176),
    [anon_sym_alignas] = ACTIONS(2176),
    [anon_sym__Alignas] = ACTIONS(2176),
    [anon_sym_QMARK] = ACTIONS(2171),
    [anon_sym_STAR_EQ] = ACTIONS(2171),
    [anon_sym_SLASH_EQ] = ACTIONS(2171),
    [anon_sym_PERCENT_EQ] = ACTIONS(2171),
    [anon_sym_PLUS_EQ] = ACTIONS(2171),
    [anon_sym_DASH_EQ] = ACTIONS(2171),
    [anon_sym_LT_LT_EQ] = ACTIONS(2171),
    [anon_sym_GT_GT_EQ] = ACTIONS(2171),
    [anon_sym_AMP_EQ] = ACTIONS(2171),
    [anon_sym_CARET_EQ] = ACTIONS(2171),
    [anon_sym_PIPE_EQ] = ACTIONS(2171),
    [anon_sym_and_eq] = ACTIONS(2171),
    [anon_sym_or_eq] = ACTIONS(2171),
    [anon_sym_xor_eq] = ACTIONS(2171),
    [anon_sym_LT_EQ_GT] = ACTIONS(2171),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2171),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2171),
    [anon_sym_not_eq] = ACTIONS(2171),
    [anon_sym_is] = ACTIONS(2171),
    [anon_sym_as] = ACTIONS(2171),
    [anon_sym_DASH_DASH] = ACTIONS(2171),
    [anon_sym_PLUS_PLUS] = ACTIONS(2171),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DOT_STAR] = ACTIONS(2171),
    [anon_sym_DASH_GT] = ACTIONS(2171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2176),
    [anon_sym_let] = ACTIONS(2176),
    [anon_sym_This] = ACTIONS(2176),
  },
  [2943] = {
    [sym_template_argument_list] = STATE(2955),
    [sym_identifier] = ACTIONS(2349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2347),
    [anon_sym_COMMA] = ACTIONS(2347),
    [anon_sym_RPAREN] = ACTIONS(2347),
    [aux_sym_preproc_if_token2] = ACTIONS(2347),
    [aux_sym_preproc_else_token1] = ACTIONS(2347),
    [aux_sym_preproc_elif_token1] = ACTIONS(2349),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2347),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2347),
    [anon_sym_LPAREN2] = ACTIONS(2347),
    [anon_sym_DASH] = ACTIONS(2349),
    [anon_sym_PLUS] = ACTIONS(2349),
    [anon_sym_STAR] = ACTIONS(2349),
    [anon_sym_SLASH] = ACTIONS(2349),
    [anon_sym_PERCENT] = ACTIONS(2349),
    [anon_sym_PIPE_PIPE] = ACTIONS(2347),
    [anon_sym_AMP_AMP] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(2349),
    [anon_sym_CARET] = ACTIONS(2349),
    [anon_sym_AMP] = ACTIONS(2349),
    [anon_sym_EQ_EQ] = ACTIONS(2347),
    [anon_sym_BANG_EQ] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2349),
    [anon_sym_GT_EQ] = ACTIONS(2347),
    [anon_sym_LT_EQ] = ACTIONS(2349),
    [anon_sym_LT] = ACTIONS(6560),
    [anon_sym_LT_LT] = ACTIONS(2349),
    [anon_sym_GT_GT] = ACTIONS(2349),
    [anon_sym_COLON] = ACTIONS(2349),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym___attribute__] = ACTIONS(2349),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_RBRACE] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_RBRACK] = ACTIONS(2347),
    [anon_sym_EQ] = ACTIONS(2349),
    [anon_sym_QMARK] = ACTIONS(2347),
    [anon_sym_STAR_EQ] = ACTIONS(2347),
    [anon_sym_SLASH_EQ] = ACTIONS(2347),
    [anon_sym_PERCENT_EQ] = ACTIONS(2347),
    [anon_sym_PLUS_EQ] = ACTIONS(2347),
    [anon_sym_DASH_EQ] = ACTIONS(2347),
    [anon_sym_LT_LT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT_EQ] = ACTIONS(2347),
    [anon_sym_AMP_EQ] = ACTIONS(2347),
    [anon_sym_CARET_EQ] = ACTIONS(2347),
    [anon_sym_PIPE_EQ] = ACTIONS(2347),
    [anon_sym_and_eq] = ACTIONS(2349),
    [anon_sym_or_eq] = ACTIONS(2349),
    [anon_sym_xor_eq] = ACTIONS(2349),
    [anon_sym_LT_EQ_GT] = ACTIONS(2347),
    [anon_sym_or] = ACTIONS(2349),
    [anon_sym_and] = ACTIONS(2349),
    [anon_sym_bitor] = ACTIONS(2349),
    [anon_sym_xor] = ACTIONS(2349),
    [anon_sym_bitand] = ACTIONS(2349),
    [anon_sym_not_eq] = ACTIONS(2349),
    [anon_sym_is] = ACTIONS(2349),
    [anon_sym_as] = ACTIONS(2349),
    [anon_sym_DASH_DASH] = ACTIONS(2347),
    [anon_sym_PLUS_PLUS] = ACTIONS(2347),
    [anon_sym_DOT] = ACTIONS(2349),
    [anon_sym_DOT_STAR] = ACTIONS(2347),
    [anon_sym_DASH_GT] = ACTIONS(2347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2349),
    [anon_sym_let] = ACTIONS(2349),
    [anon_sym_This] = ACTIONS(2349),
    [anon_sym_final] = ACTIONS(2349),
    [anon_sym_override] = ACTIONS(2349),
  },
  [2944] = {
    [sym_identifier] = ACTIONS(2210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2217),
    [anon_sym_COMMA] = ACTIONS(2217),
    [anon_sym_RPAREN] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(2214),
    [anon_sym_TILDE] = ACTIONS(2217),
    [anon_sym_STAR] = ACTIONS(2217),
    [anon_sym_AMP_AMP] = ACTIONS(2217),
    [anon_sym_AMP] = ACTIONS(2210),
    [anon_sym_COLON] = ACTIONS(2210),
    [anon_sym_SEMI] = ACTIONS(2212),
    [anon_sym___extension__] = ACTIONS(2210),
    [anon_sym_in] = ACTIONS(2210),
    [anon_sym_out] = ACTIONS(2210),
    [anon_sym_inout] = ACTIONS(2210),
    [anon_sym_extern] = ACTIONS(2210),
    [anon_sym___attribute__] = ACTIONS(2210),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2214),
    [anon_sym___declspec] = ACTIONS(2210),
    [anon_sym___based] = ACTIONS(2210),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_static] = ACTIONS(2210),
    [anon_sym_EQ] = ACTIONS(2217),
    [anon_sym_register] = ACTIONS(2210),
    [anon_sym_inline] = ACTIONS(2210),
    [anon_sym___inline] = ACTIONS(2210),
    [anon_sym___inline__] = ACTIONS(2210),
    [anon_sym___forceinline] = ACTIONS(2210),
    [anon_sym_thread_local] = ACTIONS(2210),
    [anon_sym___thread] = ACTIONS(2210),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_constexpr] = ACTIONS(2210),
    [anon_sym_volatile] = ACTIONS(2210),
    [anon_sym_restrict] = ACTIONS(2210),
    [anon_sym___restrict__] = ACTIONS(2210),
    [anon_sym__Atomic] = ACTIONS(2210),
    [anon_sym__Noreturn] = ACTIONS(2210),
    [anon_sym_noreturn] = ACTIONS(2210),
    [anon_sym_mutable] = ACTIONS(2210),
    [anon_sym_constinit] = ACTIONS(2210),
    [anon_sym_consteval] = ACTIONS(2210),
    [anon_sym_alignas] = ACTIONS(2210),
    [anon_sym__Alignas] = ACTIONS(2210),
    [anon_sym_DOT] = ACTIONS(2210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2210),
    [anon_sym_let] = ACTIONS(2210),
    [anon_sym_This] = ACTIONS(2210),
    [anon_sym_decltype] = ACTIONS(2210),
    [sym_virtual] = ACTIONS(2210),
    [anon_sym_template] = ACTIONS(2210),
    [anon_sym_operator] = ACTIONS(2210),
    [anon_sym_precise] = ACTIONS(2210),
    [anon_sym_shared] = ACTIONS(2210),
    [anon_sym_groupshared] = ACTIONS(2210),
    [anon_sym_uniform] = ACTIONS(2210),
    [anon_sym_row_major] = ACTIONS(2210),
    [anon_sym_column_major] = ACTIONS(2210),
    [anon_sym_globallycoherent] = ACTIONS(2210),
    [anon_sym_centroid] = ACTIONS(2210),
    [anon_sym_noperspective] = ACTIONS(2210),
    [anon_sym_nointerpolation] = ACTIONS(2210),
    [anon_sym_sample] = ACTIONS(2210),
    [anon_sym_linear] = ACTIONS(2210),
    [anon_sym_snorm] = ACTIONS(2210),
    [anon_sym_unorm] = ACTIONS(2210),
    [anon_sym_point] = ACTIONS(2210),
    [anon_sym_line] = ACTIONS(2210),
    [anon_sym_triangleadj] = ACTIONS(2210),
    [anon_sym_lineadj] = ACTIONS(2210),
    [anon_sym_triangle] = ACTIONS(2210),
  },
  [2945] = {
    [sym__declaration_modifiers] = STATE(2670),
    [sym_attribute_specifier] = STATE(2670),
    [sym_attribute_declaration] = STATE(2670),
    [sym_ms_declspec_modifier] = STATE(2670),
    [sym_storage_class_specifier] = STATE(2670),
    [sym_type_qualifier] = STATE(2670),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_qualifiers] = STATE(2670),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(6321),
    [anon_sym_LPAREN2] = ACTIONS(6323),
    [anon_sym_STAR] = ACTIONS(6323),
    [anon_sym_AMP_AMP] = ACTIONS(6323),
    [anon_sym_AMP] = ACTIONS(6321),
    [anon_sym_SEMI] = ACTIONS(6323),
    [anon_sym___extension__] = ACTIONS(6142),
    [anon_sym_in] = ACTIONS(6325),
    [anon_sym_out] = ACTIONS(6325),
    [anon_sym_inout] = ACTIONS(6325),
    [anon_sym_extern] = ACTIONS(6146),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6152),
    [anon_sym___declspec] = ACTIONS(6154),
    [anon_sym___based] = ACTIONS(6321),
    [anon_sym_static] = ACTIONS(6146),
    [anon_sym_register] = ACTIONS(6146),
    [anon_sym_inline] = ACTIONS(6146),
    [anon_sym___inline] = ACTIONS(6146),
    [anon_sym___inline__] = ACTIONS(6146),
    [anon_sym___forceinline] = ACTIONS(6146),
    [anon_sym_thread_local] = ACTIONS(6146),
    [anon_sym___thread] = ACTIONS(6146),
    [anon_sym_const] = ACTIONS(6142),
    [anon_sym_constexpr] = ACTIONS(6142),
    [anon_sym_volatile] = ACTIONS(6142),
    [anon_sym_restrict] = ACTIONS(6142),
    [anon_sym___restrict__] = ACTIONS(6142),
    [anon_sym__Atomic] = ACTIONS(6142),
    [anon_sym__Noreturn] = ACTIONS(6142),
    [anon_sym_noreturn] = ACTIONS(6142),
    [anon_sym_mutable] = ACTIONS(6142),
    [anon_sym_constinit] = ACTIONS(6142),
    [anon_sym_consteval] = ACTIONS(6142),
    [anon_sym_alignas] = ACTIONS(6156),
    [anon_sym__Alignas] = ACTIONS(6156),
    [anon_sym_DOT] = ACTIONS(6562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6307),
    [anon_sym_let] = ACTIONS(6307),
    [anon_sym_This] = ACTIONS(6307),
    [sym_virtual] = ACTIONS(6325),
    [anon_sym_operator] = ACTIONS(6321),
    [anon_sym_precise] = ACTIONS(6158),
    [anon_sym_shared] = ACTIONS(6158),
    [anon_sym_groupshared] = ACTIONS(6158),
    [anon_sym_uniform] = ACTIONS(6158),
    [anon_sym_row_major] = ACTIONS(6158),
    [anon_sym_column_major] = ACTIONS(6158),
    [anon_sym_globallycoherent] = ACTIONS(6158),
    [anon_sym_centroid] = ACTIONS(6158),
    [anon_sym_noperspective] = ACTIONS(6158),
    [anon_sym_nointerpolation] = ACTIONS(6158),
    [anon_sym_sample] = ACTIONS(6158),
    [anon_sym_linear] = ACTIONS(6158),
    [anon_sym_snorm] = ACTIONS(6158),
    [anon_sym_unorm] = ACTIONS(6158),
    [anon_sym_point] = ACTIONS(6158),
    [anon_sym_line] = ACTIONS(6158),
    [anon_sym_triangleadj] = ACTIONS(6158),
    [anon_sym_lineadj] = ACTIONS(6158),
    [anon_sym_triangle] = ACTIONS(6158),
  },
  [2946] = {
    [sym_argument_list] = STATE(3289),
    [sym_initializer_list] = STATE(3289),
    [sym_new_declarator] = STATE(3110),
    [sym_identifier] = ACTIONS(6564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6566),
    [anon_sym_COMMA] = ACTIONS(6566),
    [anon_sym_RPAREN] = ACTIONS(6566),
    [aux_sym_preproc_if_token2] = ACTIONS(6566),
    [aux_sym_preproc_else_token1] = ACTIONS(6566),
    [aux_sym_preproc_elif_token1] = ACTIONS(6564),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6566),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6568),
    [anon_sym_DASH] = ACTIONS(6564),
    [anon_sym_PLUS] = ACTIONS(6564),
    [anon_sym_STAR] = ACTIONS(6564),
    [anon_sym_SLASH] = ACTIONS(6564),
    [anon_sym_PERCENT] = ACTIONS(6564),
    [anon_sym_PIPE_PIPE] = ACTIONS(6566),
    [anon_sym_AMP_AMP] = ACTIONS(6566),
    [anon_sym_PIPE] = ACTIONS(6564),
    [anon_sym_CARET] = ACTIONS(6564),
    [anon_sym_AMP] = ACTIONS(6564),
    [anon_sym_EQ_EQ] = ACTIONS(6566),
    [anon_sym_BANG_EQ] = ACTIONS(6566),
    [anon_sym_GT] = ACTIONS(6564),
    [anon_sym_GT_EQ] = ACTIONS(6566),
    [anon_sym_LT_EQ] = ACTIONS(6564),
    [anon_sym_LT] = ACTIONS(6564),
    [anon_sym_LT_LT] = ACTIONS(6564),
    [anon_sym_GT_GT] = ACTIONS(6564),
    [anon_sym_COLON] = ACTIONS(6566),
    [anon_sym_SEMI] = ACTIONS(6566),
    [anon_sym___attribute__] = ACTIONS(6564),
    [anon_sym_LBRACE] = ACTIONS(4418),
    [anon_sym_RBRACE] = ACTIONS(6566),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_RBRACK] = ACTIONS(6566),
    [anon_sym_EQ] = ACTIONS(6564),
    [anon_sym_QMARK] = ACTIONS(6566),
    [anon_sym_STAR_EQ] = ACTIONS(6566),
    [anon_sym_SLASH_EQ] = ACTIONS(6566),
    [anon_sym_PERCENT_EQ] = ACTIONS(6566),
    [anon_sym_PLUS_EQ] = ACTIONS(6566),
    [anon_sym_DASH_EQ] = ACTIONS(6566),
    [anon_sym_LT_LT_EQ] = ACTIONS(6566),
    [anon_sym_GT_GT_EQ] = ACTIONS(6566),
    [anon_sym_AMP_EQ] = ACTIONS(6566),
    [anon_sym_CARET_EQ] = ACTIONS(6566),
    [anon_sym_PIPE_EQ] = ACTIONS(6566),
    [anon_sym_and_eq] = ACTIONS(6564),
    [anon_sym_or_eq] = ACTIONS(6564),
    [anon_sym_xor_eq] = ACTIONS(6564),
    [anon_sym_LT_EQ_GT] = ACTIONS(6566),
    [anon_sym_or] = ACTIONS(6564),
    [anon_sym_and] = ACTIONS(6564),
    [anon_sym_bitor] = ACTIONS(6564),
    [anon_sym_xor] = ACTIONS(6564),
    [anon_sym_bitand] = ACTIONS(6564),
    [anon_sym_not_eq] = ACTIONS(6564),
    [anon_sym_is] = ACTIONS(6564),
    [anon_sym_as] = ACTIONS(6564),
    [anon_sym_DASH_DASH] = ACTIONS(6566),
    [anon_sym_PLUS_PLUS] = ACTIONS(6566),
    [anon_sym_DOT] = ACTIONS(6564),
    [anon_sym_DOT_STAR] = ACTIONS(6566),
    [anon_sym_DASH_GT] = ACTIONS(6566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6572),
    [anon_sym_let] = ACTIONS(6572),
    [anon_sym_This] = ACTIONS(6572),
  },
  [2947] = {
    [sym_identifier] = ACTIONS(2367),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(2365),
    [anon_sym_RPAREN] = ACTIONS(2365),
    [aux_sym_preproc_if_token2] = ACTIONS(2365),
    [aux_sym_preproc_else_token1] = ACTIONS(2365),
    [aux_sym_preproc_elif_token1] = ACTIONS(2367),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2365),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2365),
    [anon_sym_LPAREN2] = ACTIONS(2365),
    [anon_sym_DASH] = ACTIONS(2367),
    [anon_sym_PLUS] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2367),
    [anon_sym_SLASH] = ACTIONS(2367),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_PIPE_PIPE] = ACTIONS(2365),
    [anon_sym_AMP_AMP] = ACTIONS(2365),
    [anon_sym_PIPE] = ACTIONS(2367),
    [anon_sym_CARET] = ACTIONS(2367),
    [anon_sym_AMP] = ACTIONS(2367),
    [anon_sym_EQ_EQ] = ACTIONS(2365),
    [anon_sym_BANG_EQ] = ACTIONS(2365),
    [anon_sym_GT] = ACTIONS(2367),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [anon_sym_LT_EQ] = ACTIONS(2367),
    [anon_sym_LT] = ACTIONS(2367),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_GT_GT] = ACTIONS(2367),
    [anon_sym_COLON] = ACTIONS(2367),
    [anon_sym_SEMI] = ACTIONS(2365),
    [anon_sym___attribute__] = ACTIONS(2367),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACE] = ACTIONS(2365),
    [anon_sym_RBRACE] = ACTIONS(2365),
    [anon_sym_LBRACK] = ACTIONS(2365),
    [anon_sym_RBRACK] = ACTIONS(2365),
    [anon_sym_EQ] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2365),
    [anon_sym_STAR_EQ] = ACTIONS(2365),
    [anon_sym_SLASH_EQ] = ACTIONS(2365),
    [anon_sym_PERCENT_EQ] = ACTIONS(2365),
    [anon_sym_PLUS_EQ] = ACTIONS(2365),
    [anon_sym_DASH_EQ] = ACTIONS(2365),
    [anon_sym_LT_LT_EQ] = ACTIONS(2365),
    [anon_sym_GT_GT_EQ] = ACTIONS(2365),
    [anon_sym_AMP_EQ] = ACTIONS(2365),
    [anon_sym_CARET_EQ] = ACTIONS(2365),
    [anon_sym_PIPE_EQ] = ACTIONS(2365),
    [anon_sym_and_eq] = ACTIONS(2367),
    [anon_sym_or_eq] = ACTIONS(2367),
    [anon_sym_xor_eq] = ACTIONS(2367),
    [anon_sym_LT_EQ_GT] = ACTIONS(2365),
    [anon_sym_or] = ACTIONS(2367),
    [anon_sym_and] = ACTIONS(2367),
    [anon_sym_bitor] = ACTIONS(2367),
    [anon_sym_xor] = ACTIONS(2367),
    [anon_sym_bitand] = ACTIONS(2367),
    [anon_sym_not_eq] = ACTIONS(2367),
    [anon_sym_is] = ACTIONS(2367),
    [anon_sym_as] = ACTIONS(2367),
    [anon_sym_DASH_DASH] = ACTIONS(2365),
    [anon_sym_PLUS_PLUS] = ACTIONS(2365),
    [anon_sym_DOT] = ACTIONS(2367),
    [anon_sym_DOT_STAR] = ACTIONS(2365),
    [anon_sym_DASH_GT] = ACTIONS(2365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2367),
    [anon_sym_let] = ACTIONS(2367),
    [anon_sym_This] = ACTIONS(2367),
    [anon_sym_final] = ACTIONS(2367),
    [anon_sym_override] = ACTIONS(2367),
  },
  [2948] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2740),
    [anon_sym_COMMA] = ACTIONS(2740),
    [anon_sym_RPAREN] = ACTIONS(2740),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2742),
    [anon_sym_PLUS] = ACTIONS(2742),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_SLASH] = ACTIONS(2742),
    [anon_sym_PERCENT] = ACTIONS(2740),
    [anon_sym_PIPE_PIPE] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_PIPE] = ACTIONS(2742),
    [anon_sym_CARET] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_EQ_EQ] = ACTIONS(2740),
    [anon_sym_BANG_EQ] = ACTIONS(2740),
    [anon_sym_GT] = ACTIONS(2742),
    [anon_sym_GT_EQ] = ACTIONS(2740),
    [anon_sym_LT_EQ] = ACTIONS(2742),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_LT_LT] = ACTIONS(2740),
    [anon_sym_GT_GT] = ACTIONS(2740),
    [anon_sym_COLON] = ACTIONS(2740),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym___extension__] = ACTIONS(2740),
    [anon_sym___attribute__] = ACTIONS(2740),
    [anon_sym_LBRACE] = ACTIONS(2740),
    [anon_sym_RBRACE] = ACTIONS(2740),
    [anon_sym_signed] = ACTIONS(6574),
    [anon_sym_unsigned] = ACTIONS(6574),
    [anon_sym_long] = ACTIONS(6574),
    [anon_sym_short] = ACTIONS(6574),
    [anon_sym_LBRACK] = ACTIONS(2740),
    [anon_sym_RBRACK] = ACTIONS(2740),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_constexpr] = ACTIONS(2740),
    [anon_sym_volatile] = ACTIONS(2740),
    [anon_sym_restrict] = ACTIONS(2740),
    [anon_sym___restrict__] = ACTIONS(2740),
    [anon_sym__Atomic] = ACTIONS(2740),
    [anon_sym__Noreturn] = ACTIONS(2740),
    [anon_sym_noreturn] = ACTIONS(2740),
    [anon_sym_mutable] = ACTIONS(2740),
    [anon_sym_constinit] = ACTIONS(2740),
    [anon_sym_consteval] = ACTIONS(2740),
    [anon_sym_alignas] = ACTIONS(2740),
    [anon_sym__Alignas] = ACTIONS(2740),
    [anon_sym_QMARK] = ACTIONS(2740),
    [anon_sym_LT_EQ_GT] = ACTIONS(2740),
    [anon_sym_or] = ACTIONS(2740),
    [anon_sym_and] = ACTIONS(2740),
    [anon_sym_bitor] = ACTIONS(2740),
    [anon_sym_xor] = ACTIONS(2740),
    [anon_sym_bitand] = ACTIONS(2740),
    [anon_sym_not_eq] = ACTIONS(2740),
    [anon_sym_is] = ACTIONS(2740),
    [anon_sym_as] = ACTIONS(2740),
    [anon_sym_DASH_DASH] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2740),
    [anon_sym_DOT] = ACTIONS(2742),
    [anon_sym_DOT_STAR] = ACTIONS(2740),
    [anon_sym_DASH_GT] = ACTIONS(2740),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2740),
    [anon_sym_let] = ACTIONS(2740),
    [anon_sym_This] = ACTIONS(2740),
    [anon_sym_final] = ACTIONS(2740),
    [anon_sym_override] = ACTIONS(2740),
    [anon_sym_requires] = ACTIONS(2740),
    [anon_sym_where] = ACTIONS(2740),
  },
  [2949] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3759),
    [anon_sym_RPAREN] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3757),
    [anon_sym_PLUS] = ACTIONS(3757),
    [anon_sym_STAR] = ACTIONS(3759),
    [anon_sym_SLASH] = ACTIONS(3757),
    [anon_sym_PERCENT] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_PIPE] = ACTIONS(3757),
    [anon_sym_CARET] = ACTIONS(3759),
    [anon_sym_AMP] = ACTIONS(3757),
    [anon_sym_EQ_EQ] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_GT] = ACTIONS(3757),
    [anon_sym_GT_EQ] = ACTIONS(3759),
    [anon_sym_LT_EQ] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_LT_LT] = ACTIONS(3759),
    [anon_sym_GT_GT] = ACTIONS(3759),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_SEMI] = ACTIONS(3759),
    [anon_sym___extension__] = ACTIONS(3759),
    [anon_sym___attribute__] = ACTIONS(3759),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_RBRACE] = ACTIONS(3759),
    [anon_sym_signed] = ACTIONS(6576),
    [anon_sym_unsigned] = ACTIONS(6576),
    [anon_sym_long] = ACTIONS(6576),
    [anon_sym_short] = ACTIONS(6576),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_RBRACK] = ACTIONS(3759),
    [anon_sym_const] = ACTIONS(3757),
    [anon_sym_constexpr] = ACTIONS(3759),
    [anon_sym_volatile] = ACTIONS(3759),
    [anon_sym_restrict] = ACTIONS(3759),
    [anon_sym___restrict__] = ACTIONS(3759),
    [anon_sym__Atomic] = ACTIONS(3759),
    [anon_sym__Noreturn] = ACTIONS(3759),
    [anon_sym_noreturn] = ACTIONS(3759),
    [anon_sym_mutable] = ACTIONS(3759),
    [anon_sym_constinit] = ACTIONS(3759),
    [anon_sym_consteval] = ACTIONS(3759),
    [anon_sym_alignas] = ACTIONS(3759),
    [anon_sym__Alignas] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_LT_EQ_GT] = ACTIONS(3759),
    [anon_sym_or] = ACTIONS(3759),
    [anon_sym_and] = ACTIONS(3759),
    [anon_sym_bitor] = ACTIONS(3759),
    [anon_sym_xor] = ACTIONS(3759),
    [anon_sym_bitand] = ACTIONS(3759),
    [anon_sym_not_eq] = ACTIONS(3759),
    [anon_sym_is] = ACTIONS(3759),
    [anon_sym_as] = ACTIONS(3759),
    [anon_sym_DASH_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_PLUS] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(3757),
    [anon_sym_DOT_STAR] = ACTIONS(3759),
    [anon_sym_DASH_GT] = ACTIONS(3759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_This] = ACTIONS(3759),
    [anon_sym_final] = ACTIONS(3759),
    [anon_sym_override] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3759),
    [anon_sym_where] = ACTIONS(3759),
  },
  [2950] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_qualifiers] = STATE(2666),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(6297),
    [anon_sym_LPAREN2] = ACTIONS(6299),
    [anon_sym_STAR] = ACTIONS(6299),
    [anon_sym_AMP_AMP] = ACTIONS(6299),
    [anon_sym_AMP] = ACTIONS(6297),
    [anon_sym_SEMI] = ACTIONS(6299),
    [anon_sym___extension__] = ACTIONS(6142),
    [anon_sym_in] = ACTIONS(6303),
    [anon_sym_out] = ACTIONS(6303),
    [anon_sym_inout] = ACTIONS(6303),
    [anon_sym_extern] = ACTIONS(6146),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6152),
    [anon_sym___declspec] = ACTIONS(6154),
    [anon_sym___based] = ACTIONS(6297),
    [anon_sym_static] = ACTIONS(6146),
    [anon_sym_register] = ACTIONS(6146),
    [anon_sym_inline] = ACTIONS(6146),
    [anon_sym___inline] = ACTIONS(6146),
    [anon_sym___inline__] = ACTIONS(6146),
    [anon_sym___forceinline] = ACTIONS(6146),
    [anon_sym_thread_local] = ACTIONS(6146),
    [anon_sym___thread] = ACTIONS(6146),
    [anon_sym_const] = ACTIONS(6142),
    [anon_sym_constexpr] = ACTIONS(6142),
    [anon_sym_volatile] = ACTIONS(6142),
    [anon_sym_restrict] = ACTIONS(6142),
    [anon_sym___restrict__] = ACTIONS(6142),
    [anon_sym__Atomic] = ACTIONS(6142),
    [anon_sym__Noreturn] = ACTIONS(6142),
    [anon_sym_noreturn] = ACTIONS(6142),
    [anon_sym_mutable] = ACTIONS(6142),
    [anon_sym_constinit] = ACTIONS(6142),
    [anon_sym_consteval] = ACTIONS(6142),
    [anon_sym_alignas] = ACTIONS(6156),
    [anon_sym__Alignas] = ACTIONS(6156),
    [anon_sym_DOT] = ACTIONS(6562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6307),
    [anon_sym_let] = ACTIONS(6307),
    [anon_sym_This] = ACTIONS(6307),
    [sym_virtual] = ACTIONS(6303),
    [anon_sym_operator] = ACTIONS(6297),
    [anon_sym_precise] = ACTIONS(6158),
    [anon_sym_shared] = ACTIONS(6158),
    [anon_sym_groupshared] = ACTIONS(6158),
    [anon_sym_uniform] = ACTIONS(6158),
    [anon_sym_row_major] = ACTIONS(6158),
    [anon_sym_column_major] = ACTIONS(6158),
    [anon_sym_globallycoherent] = ACTIONS(6158),
    [anon_sym_centroid] = ACTIONS(6158),
    [anon_sym_noperspective] = ACTIONS(6158),
    [anon_sym_nointerpolation] = ACTIONS(6158),
    [anon_sym_sample] = ACTIONS(6158),
    [anon_sym_linear] = ACTIONS(6158),
    [anon_sym_snorm] = ACTIONS(6158),
    [anon_sym_unorm] = ACTIONS(6158),
    [anon_sym_point] = ACTIONS(6158),
    [anon_sym_line] = ACTIONS(6158),
    [anon_sym_triangleadj] = ACTIONS(6158),
    [anon_sym_lineadj] = ACTIONS(6158),
    [anon_sym_triangle] = ACTIONS(6158),
  },
  [2951] = {
    [sym_argument_list] = STATE(3247),
    [sym_initializer_list] = STATE(3247),
    [sym_new_declarator] = STATE(3120),
    [sym_identifier] = ACTIONS(6578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6580),
    [anon_sym_COMMA] = ACTIONS(6580),
    [anon_sym_RPAREN] = ACTIONS(6580),
    [aux_sym_preproc_if_token2] = ACTIONS(6580),
    [aux_sym_preproc_else_token1] = ACTIONS(6580),
    [aux_sym_preproc_elif_token1] = ACTIONS(6578),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6580),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6580),
    [anon_sym_LPAREN2] = ACTIONS(6568),
    [anon_sym_DASH] = ACTIONS(6578),
    [anon_sym_PLUS] = ACTIONS(6578),
    [anon_sym_STAR] = ACTIONS(6578),
    [anon_sym_SLASH] = ACTIONS(6578),
    [anon_sym_PERCENT] = ACTIONS(6578),
    [anon_sym_PIPE_PIPE] = ACTIONS(6580),
    [anon_sym_AMP_AMP] = ACTIONS(6580),
    [anon_sym_PIPE] = ACTIONS(6578),
    [anon_sym_CARET] = ACTIONS(6578),
    [anon_sym_AMP] = ACTIONS(6578),
    [anon_sym_EQ_EQ] = ACTIONS(6580),
    [anon_sym_BANG_EQ] = ACTIONS(6580),
    [anon_sym_GT] = ACTIONS(6578),
    [anon_sym_GT_EQ] = ACTIONS(6580),
    [anon_sym_LT_EQ] = ACTIONS(6578),
    [anon_sym_LT] = ACTIONS(6578),
    [anon_sym_LT_LT] = ACTIONS(6578),
    [anon_sym_GT_GT] = ACTIONS(6578),
    [anon_sym_COLON] = ACTIONS(6580),
    [anon_sym_SEMI] = ACTIONS(6580),
    [anon_sym___attribute__] = ACTIONS(6578),
    [anon_sym_LBRACE] = ACTIONS(4418),
    [anon_sym_RBRACE] = ACTIONS(6580),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_RBRACK] = ACTIONS(6580),
    [anon_sym_EQ] = ACTIONS(6578),
    [anon_sym_QMARK] = ACTIONS(6580),
    [anon_sym_STAR_EQ] = ACTIONS(6580),
    [anon_sym_SLASH_EQ] = ACTIONS(6580),
    [anon_sym_PERCENT_EQ] = ACTIONS(6580),
    [anon_sym_PLUS_EQ] = ACTIONS(6580),
    [anon_sym_DASH_EQ] = ACTIONS(6580),
    [anon_sym_LT_LT_EQ] = ACTIONS(6580),
    [anon_sym_GT_GT_EQ] = ACTIONS(6580),
    [anon_sym_AMP_EQ] = ACTIONS(6580),
    [anon_sym_CARET_EQ] = ACTIONS(6580),
    [anon_sym_PIPE_EQ] = ACTIONS(6580),
    [anon_sym_and_eq] = ACTIONS(6578),
    [anon_sym_or_eq] = ACTIONS(6578),
    [anon_sym_xor_eq] = ACTIONS(6578),
    [anon_sym_LT_EQ_GT] = ACTIONS(6580),
    [anon_sym_or] = ACTIONS(6578),
    [anon_sym_and] = ACTIONS(6578),
    [anon_sym_bitor] = ACTIONS(6578),
    [anon_sym_xor] = ACTIONS(6578),
    [anon_sym_bitand] = ACTIONS(6578),
    [anon_sym_not_eq] = ACTIONS(6578),
    [anon_sym_is] = ACTIONS(6578),
    [anon_sym_as] = ACTIONS(6578),
    [anon_sym_DASH_DASH] = ACTIONS(6580),
    [anon_sym_PLUS_PLUS] = ACTIONS(6580),
    [anon_sym_DOT] = ACTIONS(6578),
    [anon_sym_DOT_STAR] = ACTIONS(6580),
    [anon_sym_DASH_GT] = ACTIONS(6580),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6572),
    [anon_sym_let] = ACTIONS(6572),
    [anon_sym_This] = ACTIONS(6572),
  },
  [2952] = {
    [sym_argument_list] = STATE(3284),
    [sym_initializer_list] = STATE(3284),
    [sym_new_declarator] = STATE(3114),
    [sym_identifier] = ACTIONS(6582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6584),
    [anon_sym_COMMA] = ACTIONS(6584),
    [anon_sym_RPAREN] = ACTIONS(6584),
    [aux_sym_preproc_if_token2] = ACTIONS(6584),
    [aux_sym_preproc_else_token1] = ACTIONS(6584),
    [aux_sym_preproc_elif_token1] = ACTIONS(6582),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6584),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6584),
    [anon_sym_LPAREN2] = ACTIONS(6568),
    [anon_sym_DASH] = ACTIONS(6582),
    [anon_sym_PLUS] = ACTIONS(6582),
    [anon_sym_STAR] = ACTIONS(6582),
    [anon_sym_SLASH] = ACTIONS(6582),
    [anon_sym_PERCENT] = ACTIONS(6582),
    [anon_sym_PIPE_PIPE] = ACTIONS(6584),
    [anon_sym_AMP_AMP] = ACTIONS(6584),
    [anon_sym_PIPE] = ACTIONS(6582),
    [anon_sym_CARET] = ACTIONS(6582),
    [anon_sym_AMP] = ACTIONS(6582),
    [anon_sym_EQ_EQ] = ACTIONS(6584),
    [anon_sym_BANG_EQ] = ACTIONS(6584),
    [anon_sym_GT] = ACTIONS(6582),
    [anon_sym_GT_EQ] = ACTIONS(6584),
    [anon_sym_LT_EQ] = ACTIONS(6582),
    [anon_sym_LT] = ACTIONS(6582),
    [anon_sym_LT_LT] = ACTIONS(6582),
    [anon_sym_GT_GT] = ACTIONS(6582),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_SEMI] = ACTIONS(6584),
    [anon_sym___attribute__] = ACTIONS(6582),
    [anon_sym_LBRACE] = ACTIONS(4418),
    [anon_sym_RBRACE] = ACTIONS(6584),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_RBRACK] = ACTIONS(6584),
    [anon_sym_EQ] = ACTIONS(6582),
    [anon_sym_QMARK] = ACTIONS(6584),
    [anon_sym_STAR_EQ] = ACTIONS(6584),
    [anon_sym_SLASH_EQ] = ACTIONS(6584),
    [anon_sym_PERCENT_EQ] = ACTIONS(6584),
    [anon_sym_PLUS_EQ] = ACTIONS(6584),
    [anon_sym_DASH_EQ] = ACTIONS(6584),
    [anon_sym_LT_LT_EQ] = ACTIONS(6584),
    [anon_sym_GT_GT_EQ] = ACTIONS(6584),
    [anon_sym_AMP_EQ] = ACTIONS(6584),
    [anon_sym_CARET_EQ] = ACTIONS(6584),
    [anon_sym_PIPE_EQ] = ACTIONS(6584),
    [anon_sym_and_eq] = ACTIONS(6582),
    [anon_sym_or_eq] = ACTIONS(6582),
    [anon_sym_xor_eq] = ACTIONS(6582),
    [anon_sym_LT_EQ_GT] = ACTIONS(6584),
    [anon_sym_or] = ACTIONS(6582),
    [anon_sym_and] = ACTIONS(6582),
    [anon_sym_bitor] = ACTIONS(6582),
    [anon_sym_xor] = ACTIONS(6582),
    [anon_sym_bitand] = ACTIONS(6582),
    [anon_sym_not_eq] = ACTIONS(6582),
    [anon_sym_is] = ACTIONS(6582),
    [anon_sym_as] = ACTIONS(6582),
    [anon_sym_DASH_DASH] = ACTIONS(6584),
    [anon_sym_PLUS_PLUS] = ACTIONS(6584),
    [anon_sym_DOT] = ACTIONS(6582),
    [anon_sym_DOT_STAR] = ACTIONS(6584),
    [anon_sym_DASH_GT] = ACTIONS(6584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6572),
    [anon_sym_let] = ACTIONS(6572),
    [anon_sym_This] = ACTIONS(6572),
  },
  [2953] = {
    [sym_identifier] = ACTIONS(2363),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2361),
    [anon_sym_COMMA] = ACTIONS(2361),
    [anon_sym_RPAREN] = ACTIONS(2361),
    [aux_sym_preproc_if_token2] = ACTIONS(2361),
    [aux_sym_preproc_else_token1] = ACTIONS(2361),
    [aux_sym_preproc_elif_token1] = ACTIONS(2363),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2361),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2361),
    [anon_sym_LPAREN2] = ACTIONS(2361),
    [anon_sym_DASH] = ACTIONS(2363),
    [anon_sym_PLUS] = ACTIONS(2363),
    [anon_sym_STAR] = ACTIONS(2363),
    [anon_sym_SLASH] = ACTIONS(2363),
    [anon_sym_PERCENT] = ACTIONS(2363),
    [anon_sym_PIPE_PIPE] = ACTIONS(2361),
    [anon_sym_AMP_AMP] = ACTIONS(2361),
    [anon_sym_PIPE] = ACTIONS(2363),
    [anon_sym_CARET] = ACTIONS(2363),
    [anon_sym_AMP] = ACTIONS(2363),
    [anon_sym_EQ_EQ] = ACTIONS(2361),
    [anon_sym_BANG_EQ] = ACTIONS(2361),
    [anon_sym_GT] = ACTIONS(2363),
    [anon_sym_GT_EQ] = ACTIONS(2361),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2363),
    [anon_sym_LT_LT] = ACTIONS(2363),
    [anon_sym_GT_GT] = ACTIONS(2363),
    [anon_sym_COLON] = ACTIONS(2363),
    [anon_sym_SEMI] = ACTIONS(2361),
    [anon_sym___attribute__] = ACTIONS(2363),
    [anon_sym_COLON_COLON] = ACTIONS(2361),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_RBRACE] = ACTIONS(2361),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_RBRACK] = ACTIONS(2361),
    [anon_sym_EQ] = ACTIONS(2363),
    [anon_sym_QMARK] = ACTIONS(2361),
    [anon_sym_STAR_EQ] = ACTIONS(2361),
    [anon_sym_SLASH_EQ] = ACTIONS(2361),
    [anon_sym_PERCENT_EQ] = ACTIONS(2361),
    [anon_sym_PLUS_EQ] = ACTIONS(2361),
    [anon_sym_DASH_EQ] = ACTIONS(2361),
    [anon_sym_LT_LT_EQ] = ACTIONS(2361),
    [anon_sym_GT_GT_EQ] = ACTIONS(2361),
    [anon_sym_AMP_EQ] = ACTIONS(2361),
    [anon_sym_CARET_EQ] = ACTIONS(2361),
    [anon_sym_PIPE_EQ] = ACTIONS(2361),
    [anon_sym_and_eq] = ACTIONS(2363),
    [anon_sym_or_eq] = ACTIONS(2363),
    [anon_sym_xor_eq] = ACTIONS(2363),
    [anon_sym_LT_EQ_GT] = ACTIONS(2361),
    [anon_sym_or] = ACTIONS(2363),
    [anon_sym_and] = ACTIONS(2363),
    [anon_sym_bitor] = ACTIONS(2363),
    [anon_sym_xor] = ACTIONS(2363),
    [anon_sym_bitand] = ACTIONS(2363),
    [anon_sym_not_eq] = ACTIONS(2363),
    [anon_sym_is] = ACTIONS(2363),
    [anon_sym_as] = ACTIONS(2363),
    [anon_sym_DASH_DASH] = ACTIONS(2361),
    [anon_sym_PLUS_PLUS] = ACTIONS(2361),
    [anon_sym_DOT] = ACTIONS(2363),
    [anon_sym_DOT_STAR] = ACTIONS(2361),
    [anon_sym_DASH_GT] = ACTIONS(2361),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2363),
    [anon_sym_let] = ACTIONS(2363),
    [anon_sym_This] = ACTIONS(2363),
    [anon_sym_final] = ACTIONS(2363),
    [anon_sym_override] = ACTIONS(2363),
  },
  [2954] = {
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2371),
    [anon_sym_COMMA] = ACTIONS(2371),
    [anon_sym_RPAREN] = ACTIONS(2371),
    [aux_sym_preproc_if_token2] = ACTIONS(2371),
    [aux_sym_preproc_else_token1] = ACTIONS(2371),
    [aux_sym_preproc_elif_token1] = ACTIONS(2373),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2371),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2371),
    [anon_sym_LPAREN2] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_SLASH] = ACTIONS(2373),
    [anon_sym_PERCENT] = ACTIONS(2373),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_CARET] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_EQ_EQ] = ACTIONS(2371),
    [anon_sym_BANG_EQ] = ACTIONS(2371),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_EQ] = ACTIONS(2371),
    [anon_sym_LT_EQ] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym___attribute__] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_RBRACE] = ACTIONS(2371),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_RBRACK] = ACTIONS(2371),
    [anon_sym_EQ] = ACTIONS(2373),
    [anon_sym_QMARK] = ACTIONS(2371),
    [anon_sym_STAR_EQ] = ACTIONS(2371),
    [anon_sym_SLASH_EQ] = ACTIONS(2371),
    [anon_sym_PERCENT_EQ] = ACTIONS(2371),
    [anon_sym_PLUS_EQ] = ACTIONS(2371),
    [anon_sym_DASH_EQ] = ACTIONS(2371),
    [anon_sym_LT_LT_EQ] = ACTIONS(2371),
    [anon_sym_GT_GT_EQ] = ACTIONS(2371),
    [anon_sym_AMP_EQ] = ACTIONS(2371),
    [anon_sym_CARET_EQ] = ACTIONS(2371),
    [anon_sym_PIPE_EQ] = ACTIONS(2371),
    [anon_sym_and_eq] = ACTIONS(2373),
    [anon_sym_or_eq] = ACTIONS(2373),
    [anon_sym_xor_eq] = ACTIONS(2373),
    [anon_sym_LT_EQ_GT] = ACTIONS(2371),
    [anon_sym_or] = ACTIONS(2373),
    [anon_sym_and] = ACTIONS(2373),
    [anon_sym_bitor] = ACTIONS(2373),
    [anon_sym_xor] = ACTIONS(2373),
    [anon_sym_bitand] = ACTIONS(2373),
    [anon_sym_not_eq] = ACTIONS(2373),
    [anon_sym_is] = ACTIONS(2373),
    [anon_sym_as] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_DOT] = ACTIONS(2373),
    [anon_sym_DOT_STAR] = ACTIONS(2371),
    [anon_sym_DASH_GT] = ACTIONS(2371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_This] = ACTIONS(2373),
    [anon_sym_final] = ACTIONS(2373),
    [anon_sym_override] = ACTIONS(2373),
  },
  [2955] = {
    [sym_identifier] = ACTIONS(2210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2217),
    [anon_sym_COMMA] = ACTIONS(2217),
    [anon_sym_RPAREN] = ACTIONS(2217),
    [aux_sym_preproc_if_token2] = ACTIONS(2217),
    [aux_sym_preproc_else_token1] = ACTIONS(2217),
    [aux_sym_preproc_elif_token1] = ACTIONS(2210),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2217),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2217),
    [anon_sym_LPAREN2] = ACTIONS(2217),
    [anon_sym_DASH] = ACTIONS(2210),
    [anon_sym_PLUS] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(2210),
    [anon_sym_SLASH] = ACTIONS(2210),
    [anon_sym_PERCENT] = ACTIONS(2210),
    [anon_sym_PIPE_PIPE] = ACTIONS(2217),
    [anon_sym_AMP_AMP] = ACTIONS(2217),
    [anon_sym_PIPE] = ACTIONS(2210),
    [anon_sym_CARET] = ACTIONS(2210),
    [anon_sym_AMP] = ACTIONS(2210),
    [anon_sym_EQ_EQ] = ACTIONS(2217),
    [anon_sym_BANG_EQ] = ACTIONS(2217),
    [anon_sym_GT] = ACTIONS(2210),
    [anon_sym_GT_EQ] = ACTIONS(2217),
    [anon_sym_LT_EQ] = ACTIONS(2210),
    [anon_sym_LT] = ACTIONS(2210),
    [anon_sym_LT_LT] = ACTIONS(2210),
    [anon_sym_GT_GT] = ACTIONS(2210),
    [anon_sym_COLON] = ACTIONS(2210),
    [anon_sym_SEMI] = ACTIONS(2217),
    [anon_sym___attribute__] = ACTIONS(2210),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2217),
    [anon_sym_RBRACE] = ACTIONS(2217),
    [anon_sym_LBRACK] = ACTIONS(2217),
    [anon_sym_RBRACK] = ACTIONS(2217),
    [anon_sym_EQ] = ACTIONS(2210),
    [anon_sym_QMARK] = ACTIONS(2217),
    [anon_sym_STAR_EQ] = ACTIONS(2217),
    [anon_sym_SLASH_EQ] = ACTIONS(2217),
    [anon_sym_PERCENT_EQ] = ACTIONS(2217),
    [anon_sym_PLUS_EQ] = ACTIONS(2217),
    [anon_sym_DASH_EQ] = ACTIONS(2217),
    [anon_sym_LT_LT_EQ] = ACTIONS(2217),
    [anon_sym_GT_GT_EQ] = ACTIONS(2217),
    [anon_sym_AMP_EQ] = ACTIONS(2217),
    [anon_sym_CARET_EQ] = ACTIONS(2217),
    [anon_sym_PIPE_EQ] = ACTIONS(2217),
    [anon_sym_and_eq] = ACTIONS(2210),
    [anon_sym_or_eq] = ACTIONS(2210),
    [anon_sym_xor_eq] = ACTIONS(2210),
    [anon_sym_LT_EQ_GT] = ACTIONS(2217),
    [anon_sym_or] = ACTIONS(2210),
    [anon_sym_and] = ACTIONS(2210),
    [anon_sym_bitor] = ACTIONS(2210),
    [anon_sym_xor] = ACTIONS(2210),
    [anon_sym_bitand] = ACTIONS(2210),
    [anon_sym_not_eq] = ACTIONS(2210),
    [anon_sym_is] = ACTIONS(2210),
    [anon_sym_as] = ACTIONS(2210),
    [anon_sym_DASH_DASH] = ACTIONS(2217),
    [anon_sym_PLUS_PLUS] = ACTIONS(2217),
    [anon_sym_DOT] = ACTIONS(2210),
    [anon_sym_DOT_STAR] = ACTIONS(2217),
    [anon_sym_DASH_GT] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2210),
    [anon_sym_let] = ACTIONS(2210),
    [anon_sym_This] = ACTIONS(2210),
    [anon_sym_final] = ACTIONS(2210),
    [anon_sym_override] = ACTIONS(2210),
  },
  [2956] = {
    [sym_argument_list] = STATE(3326),
    [sym_initializer_list] = STATE(3326),
    [sym_new_declarator] = STATE(3136),
    [sym_identifier] = ACTIONS(6586),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6588),
    [anon_sym_COMMA] = ACTIONS(6588),
    [anon_sym_RPAREN] = ACTIONS(6588),
    [aux_sym_preproc_if_token2] = ACTIONS(6588),
    [aux_sym_preproc_else_token1] = ACTIONS(6588),
    [aux_sym_preproc_elif_token1] = ACTIONS(6586),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6588),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6588),
    [anon_sym_LPAREN2] = ACTIONS(6568),
    [anon_sym_DASH] = ACTIONS(6586),
    [anon_sym_PLUS] = ACTIONS(6586),
    [anon_sym_STAR] = ACTIONS(6586),
    [anon_sym_SLASH] = ACTIONS(6586),
    [anon_sym_PERCENT] = ACTIONS(6586),
    [anon_sym_PIPE_PIPE] = ACTIONS(6588),
    [anon_sym_AMP_AMP] = ACTIONS(6588),
    [anon_sym_PIPE] = ACTIONS(6586),
    [anon_sym_CARET] = ACTIONS(6586),
    [anon_sym_AMP] = ACTIONS(6586),
    [anon_sym_EQ_EQ] = ACTIONS(6588),
    [anon_sym_BANG_EQ] = ACTIONS(6588),
    [anon_sym_GT] = ACTIONS(6586),
    [anon_sym_GT_EQ] = ACTIONS(6588),
    [anon_sym_LT_EQ] = ACTIONS(6586),
    [anon_sym_LT] = ACTIONS(6586),
    [anon_sym_LT_LT] = ACTIONS(6586),
    [anon_sym_GT_GT] = ACTIONS(6586),
    [anon_sym_COLON] = ACTIONS(6588),
    [anon_sym_SEMI] = ACTIONS(6588),
    [anon_sym___attribute__] = ACTIONS(6586),
    [anon_sym_LBRACE] = ACTIONS(4418),
    [anon_sym_RBRACE] = ACTIONS(6588),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_RBRACK] = ACTIONS(6588),
    [anon_sym_EQ] = ACTIONS(6586),
    [anon_sym_QMARK] = ACTIONS(6588),
    [anon_sym_STAR_EQ] = ACTIONS(6588),
    [anon_sym_SLASH_EQ] = ACTIONS(6588),
    [anon_sym_PERCENT_EQ] = ACTIONS(6588),
    [anon_sym_PLUS_EQ] = ACTIONS(6588),
    [anon_sym_DASH_EQ] = ACTIONS(6588),
    [anon_sym_LT_LT_EQ] = ACTIONS(6588),
    [anon_sym_GT_GT_EQ] = ACTIONS(6588),
    [anon_sym_AMP_EQ] = ACTIONS(6588),
    [anon_sym_CARET_EQ] = ACTIONS(6588),
    [anon_sym_PIPE_EQ] = ACTIONS(6588),
    [anon_sym_and_eq] = ACTIONS(6586),
    [anon_sym_or_eq] = ACTIONS(6586),
    [anon_sym_xor_eq] = ACTIONS(6586),
    [anon_sym_LT_EQ_GT] = ACTIONS(6588),
    [anon_sym_or] = ACTIONS(6586),
    [anon_sym_and] = ACTIONS(6586),
    [anon_sym_bitor] = ACTIONS(6586),
    [anon_sym_xor] = ACTIONS(6586),
    [anon_sym_bitand] = ACTIONS(6586),
    [anon_sym_not_eq] = ACTIONS(6586),
    [anon_sym_is] = ACTIONS(6586),
    [anon_sym_as] = ACTIONS(6586),
    [anon_sym_DASH_DASH] = ACTIONS(6588),
    [anon_sym_PLUS_PLUS] = ACTIONS(6588),
    [anon_sym_DOT] = ACTIONS(6586),
    [anon_sym_DOT_STAR] = ACTIONS(6588),
    [anon_sym_DASH_GT] = ACTIONS(6588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6572),
    [anon_sym_let] = ACTIONS(6572),
    [anon_sym_This] = ACTIONS(6572),
  },
  [2957] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2212),
    [anon_sym_RPAREN] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(2214),
    [anon_sym_DASH] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(2222),
    [anon_sym_STAR] = ACTIONS(2219),
    [anon_sym_SLASH] = ACTIONS(2222),
    [anon_sym_PERCENT] = ACTIONS(2222),
    [anon_sym_PIPE_PIPE] = ACTIONS(2212),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2222),
    [anon_sym_CARET] = ACTIONS(2222),
    [anon_sym_AMP] = ACTIONS(2219),
    [anon_sym_EQ_EQ] = ACTIONS(2212),
    [anon_sym_BANG_EQ] = ACTIONS(2212),
    [anon_sym_GT] = ACTIONS(2222),
    [anon_sym_GT_EQ] = ACTIONS(2212),
    [anon_sym_LT_EQ] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(2222),
    [anon_sym_LT_LT] = ACTIONS(2222),
    [anon_sym_GT_GT] = ACTIONS(2222),
    [anon_sym___extension__] = ACTIONS(2217),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2217),
    [anon_sym_LBRACK] = ACTIONS(2214),
    [anon_sym_EQ] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_constexpr] = ACTIONS(2217),
    [anon_sym_volatile] = ACTIONS(2217),
    [anon_sym_restrict] = ACTIONS(2217),
    [anon_sym___restrict__] = ACTIONS(2217),
    [anon_sym__Atomic] = ACTIONS(2217),
    [anon_sym__Noreturn] = ACTIONS(2217),
    [anon_sym_noreturn] = ACTIONS(2217),
    [anon_sym_mutable] = ACTIONS(2217),
    [anon_sym_constinit] = ACTIONS(2217),
    [anon_sym_consteval] = ACTIONS(2217),
    [anon_sym_alignas] = ACTIONS(2217),
    [anon_sym__Alignas] = ACTIONS(2217),
    [anon_sym_QMARK] = ACTIONS(2212),
    [anon_sym_STAR_EQ] = ACTIONS(2212),
    [anon_sym_SLASH_EQ] = ACTIONS(2212),
    [anon_sym_PERCENT_EQ] = ACTIONS(2212),
    [anon_sym_PLUS_EQ] = ACTIONS(2212),
    [anon_sym_DASH_EQ] = ACTIONS(2212),
    [anon_sym_LT_LT_EQ] = ACTIONS(2212),
    [anon_sym_GT_GT_EQ] = ACTIONS(2212),
    [anon_sym_AMP_EQ] = ACTIONS(2212),
    [anon_sym_CARET_EQ] = ACTIONS(2212),
    [anon_sym_PIPE_EQ] = ACTIONS(2212),
    [anon_sym_and_eq] = ACTIONS(2212),
    [anon_sym_or_eq] = ACTIONS(2212),
    [anon_sym_xor_eq] = ACTIONS(2212),
    [anon_sym_LT_EQ_GT] = ACTIONS(2212),
    [anon_sym_or] = ACTIONS(2222),
    [anon_sym_and] = ACTIONS(2222),
    [anon_sym_bitor] = ACTIONS(2212),
    [anon_sym_xor] = ACTIONS(2222),
    [anon_sym_bitand] = ACTIONS(2212),
    [anon_sym_not_eq] = ACTIONS(2212),
    [anon_sym_is] = ACTIONS(2212),
    [anon_sym_as] = ACTIONS(2212),
    [anon_sym_DASH_DASH] = ACTIONS(2212),
    [anon_sym_PLUS_PLUS] = ACTIONS(2212),
    [anon_sym_DOT] = ACTIONS(2219),
    [anon_sym_DOT_STAR] = ACTIONS(2212),
    [anon_sym_DASH_GT] = ACTIONS(2212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2217),
    [anon_sym_let] = ACTIONS(2217),
    [anon_sym_This] = ACTIONS(2217),
  },
  [2958] = {
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2371),
    [anon_sym_COMMA] = ACTIONS(2371),
    [anon_sym_RPAREN] = ACTIONS(2371),
    [aux_sym_preproc_if_token2] = ACTIONS(2371),
    [aux_sym_preproc_else_token1] = ACTIONS(2371),
    [aux_sym_preproc_elif_token1] = ACTIONS(2373),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2371),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2371),
    [anon_sym_LPAREN2] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_SLASH] = ACTIONS(2373),
    [anon_sym_PERCENT] = ACTIONS(2373),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_CARET] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_EQ_EQ] = ACTIONS(2371),
    [anon_sym_BANG_EQ] = ACTIONS(2371),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_EQ] = ACTIONS(2371),
    [anon_sym_LT_EQ] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym___attribute__] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_RBRACE] = ACTIONS(2371),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_RBRACK] = ACTIONS(2371),
    [anon_sym_EQ] = ACTIONS(2373),
    [anon_sym_QMARK] = ACTIONS(2371),
    [anon_sym_STAR_EQ] = ACTIONS(2371),
    [anon_sym_SLASH_EQ] = ACTIONS(2371),
    [anon_sym_PERCENT_EQ] = ACTIONS(2371),
    [anon_sym_PLUS_EQ] = ACTIONS(2371),
    [anon_sym_DASH_EQ] = ACTIONS(2371),
    [anon_sym_LT_LT_EQ] = ACTIONS(2371),
    [anon_sym_GT_GT_EQ] = ACTIONS(2371),
    [anon_sym_AMP_EQ] = ACTIONS(2371),
    [anon_sym_CARET_EQ] = ACTIONS(2371),
    [anon_sym_PIPE_EQ] = ACTIONS(2371),
    [anon_sym_and_eq] = ACTIONS(2373),
    [anon_sym_or_eq] = ACTIONS(2373),
    [anon_sym_xor_eq] = ACTIONS(2373),
    [anon_sym_LT_EQ_GT] = ACTIONS(2371),
    [anon_sym_or] = ACTIONS(2373),
    [anon_sym_and] = ACTIONS(2373),
    [anon_sym_bitor] = ACTIONS(2373),
    [anon_sym_xor] = ACTIONS(2373),
    [anon_sym_bitand] = ACTIONS(2373),
    [anon_sym_not_eq] = ACTIONS(2373),
    [anon_sym_is] = ACTIONS(2373),
    [anon_sym_as] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_DOT] = ACTIONS(2373),
    [anon_sym_DOT_STAR] = ACTIONS(2371),
    [anon_sym_DASH_GT] = ACTIONS(2371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_This] = ACTIONS(2373),
    [anon_sym_final] = ACTIONS(2373),
    [anon_sym_override] = ACTIONS(2373),
  },
  [2959] = {
    [sym_template_argument_list] = STATE(3322),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2639),
    [sym_identifier] = ACTIONS(2115),
    [anon_sym_LPAREN2] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_AMP_AMP] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2115),
    [anon_sym_LT] = ACTIONS(6343),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym___extension__] = ACTIONS(2115),
    [anon_sym_in] = ACTIONS(2115),
    [anon_sym_out] = ACTIONS(2115),
    [anon_sym_inout] = ACTIONS(2115),
    [anon_sym_extern] = ACTIONS(2115),
    [anon_sym___attribute__] = ACTIONS(2115),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2140),
    [anon_sym___declspec] = ACTIONS(2115),
    [anon_sym___based] = ACTIONS(2115),
    [anon_sym_signed] = ACTIONS(4863),
    [anon_sym_unsigned] = ACTIONS(4863),
    [anon_sym_long] = ACTIONS(4863),
    [anon_sym_short] = ACTIONS(4863),
    [anon_sym_LBRACK] = ACTIONS(6590),
    [anon_sym_static] = ACTIONS(2115),
    [anon_sym_register] = ACTIONS(2115),
    [anon_sym_inline] = ACTIONS(2115),
    [anon_sym___inline] = ACTIONS(2115),
    [anon_sym___inline__] = ACTIONS(2115),
    [anon_sym___forceinline] = ACTIONS(2115),
    [anon_sym_thread_local] = ACTIONS(2115),
    [anon_sym___thread] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(2115),
    [anon_sym_constexpr] = ACTIONS(2115),
    [anon_sym_volatile] = ACTIONS(2115),
    [anon_sym_restrict] = ACTIONS(2115),
    [anon_sym___restrict__] = ACTIONS(2115),
    [anon_sym__Atomic] = ACTIONS(2115),
    [anon_sym__Noreturn] = ACTIONS(2115),
    [anon_sym_noreturn] = ACTIONS(2115),
    [anon_sym_mutable] = ACTIONS(2115),
    [anon_sym_constinit] = ACTIONS(2115),
    [anon_sym_consteval] = ACTIONS(2115),
    [anon_sym_alignas] = ACTIONS(2115),
    [anon_sym__Alignas] = ACTIONS(2115),
    [anon_sym_DOT] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2115),
    [anon_sym_let] = ACTIONS(2115),
    [anon_sym_This] = ACTIONS(2115),
    [sym_virtual] = ACTIONS(2115),
    [anon_sym_operator] = ACTIONS(2115),
    [anon_sym_precise] = ACTIONS(2115),
    [anon_sym_shared] = ACTIONS(2115),
    [anon_sym_groupshared] = ACTIONS(2115),
    [anon_sym_uniform] = ACTIONS(2115),
    [anon_sym_row_major] = ACTIONS(2115),
    [anon_sym_column_major] = ACTIONS(2115),
    [anon_sym_globallycoherent] = ACTIONS(2115),
    [anon_sym_centroid] = ACTIONS(2115),
    [anon_sym_noperspective] = ACTIONS(2115),
    [anon_sym_nointerpolation] = ACTIONS(2115),
    [anon_sym_sample] = ACTIONS(2115),
    [anon_sym_linear] = ACTIONS(2115),
    [anon_sym_snorm] = ACTIONS(2115),
    [anon_sym_unorm] = ACTIONS(2115),
    [anon_sym_point] = ACTIONS(2115),
    [anon_sym_line] = ACTIONS(2115),
    [anon_sym_triangleadj] = ACTIONS(2115),
    [anon_sym_lineadj] = ACTIONS(2115),
    [anon_sym_triangle] = ACTIONS(2115),
  },
  [2960] = {
    [sym_string_literal] = STATE(2792),
    [sym_raw_string_literal] = STATE(2792),
    [sym_identifier] = ACTIONS(2128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [aux_sym_preproc_if_token2] = ACTIONS(2117),
    [aux_sym_preproc_else_token1] = ACTIONS(2117),
    [aux_sym_preproc_elif_token1] = ACTIONS(2128),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2117),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(2128),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2117),
    [anon_sym_EQ] = ACTIONS(2128),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2117),
    [anon_sym_SLASH_EQ] = ACTIONS(2117),
    [anon_sym_PERCENT_EQ] = ACTIONS(2117),
    [anon_sym_PLUS_EQ] = ACTIONS(2117),
    [anon_sym_DASH_EQ] = ACTIONS(2117),
    [anon_sym_LT_LT_EQ] = ACTIONS(2117),
    [anon_sym_GT_GT_EQ] = ACTIONS(2117),
    [anon_sym_AMP_EQ] = ACTIONS(2117),
    [anon_sym_CARET_EQ] = ACTIONS(2117),
    [anon_sym_PIPE_EQ] = ACTIONS(2117),
    [anon_sym_and_eq] = ACTIONS(2128),
    [anon_sym_or_eq] = ACTIONS(2128),
    [anon_sym_xor_eq] = ACTIONS(2128),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2128),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2128),
    [anon_sym_not_eq] = ACTIONS(2128),
    [anon_sym_is] = ACTIONS(2128),
    [anon_sym_as] = ACTIONS(2128),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [sym_literal_suffix] = ACTIONS(6592),
  },
  [2961] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3805),
    [anon_sym_COMMA] = ACTIONS(3805),
    [anon_sym_RPAREN] = ACTIONS(3805),
    [anon_sym_LPAREN2] = ACTIONS(3805),
    [anon_sym_DASH] = ACTIONS(3803),
    [anon_sym_PLUS] = ACTIONS(3803),
    [anon_sym_STAR] = ACTIONS(3805),
    [anon_sym_SLASH] = ACTIONS(3803),
    [anon_sym_PERCENT] = ACTIONS(3805),
    [anon_sym_PIPE_PIPE] = ACTIONS(3805),
    [anon_sym_AMP_AMP] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3803),
    [anon_sym_CARET] = ACTIONS(3805),
    [anon_sym_AMP] = ACTIONS(3803),
    [anon_sym_EQ_EQ] = ACTIONS(3805),
    [anon_sym_BANG_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3803),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_LT_EQ] = ACTIONS(3803),
    [anon_sym_LT] = ACTIONS(3803),
    [anon_sym_LT_LT] = ACTIONS(3805),
    [anon_sym_GT_GT] = ACTIONS(3805),
    [anon_sym_COLON] = ACTIONS(3805),
    [anon_sym_SEMI] = ACTIONS(3805),
    [anon_sym___extension__] = ACTIONS(3805),
    [anon_sym___attribute__] = ACTIONS(3805),
    [anon_sym_LBRACE] = ACTIONS(3805),
    [anon_sym_RBRACE] = ACTIONS(3805),
    [anon_sym_signed] = ACTIONS(6576),
    [anon_sym_unsigned] = ACTIONS(6576),
    [anon_sym_long] = ACTIONS(6576),
    [anon_sym_short] = ACTIONS(6576),
    [anon_sym_LBRACK] = ACTIONS(3805),
    [anon_sym_RBRACK] = ACTIONS(3805),
    [anon_sym_const] = ACTIONS(3803),
    [anon_sym_constexpr] = ACTIONS(3805),
    [anon_sym_volatile] = ACTIONS(3805),
    [anon_sym_restrict] = ACTIONS(3805),
    [anon_sym___restrict__] = ACTIONS(3805),
    [anon_sym__Atomic] = ACTIONS(3805),
    [anon_sym__Noreturn] = ACTIONS(3805),
    [anon_sym_noreturn] = ACTIONS(3805),
    [anon_sym_mutable] = ACTIONS(3805),
    [anon_sym_constinit] = ACTIONS(3805),
    [anon_sym_consteval] = ACTIONS(3805),
    [anon_sym_alignas] = ACTIONS(3805),
    [anon_sym__Alignas] = ACTIONS(3805),
    [anon_sym_QMARK] = ACTIONS(3805),
    [anon_sym_LT_EQ_GT] = ACTIONS(3805),
    [anon_sym_or] = ACTIONS(3805),
    [anon_sym_and] = ACTIONS(3805),
    [anon_sym_bitor] = ACTIONS(3805),
    [anon_sym_xor] = ACTIONS(3805),
    [anon_sym_bitand] = ACTIONS(3805),
    [anon_sym_not_eq] = ACTIONS(3805),
    [anon_sym_is] = ACTIONS(3805),
    [anon_sym_as] = ACTIONS(3805),
    [anon_sym_DASH_DASH] = ACTIONS(3805),
    [anon_sym_PLUS_PLUS] = ACTIONS(3805),
    [anon_sym_DOT] = ACTIONS(3803),
    [anon_sym_DOT_STAR] = ACTIONS(3805),
    [anon_sym_DASH_GT] = ACTIONS(3805),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3805),
    [anon_sym_let] = ACTIONS(3805),
    [anon_sym_This] = ACTIONS(3805),
    [anon_sym_final] = ACTIONS(3805),
    [anon_sym_override] = ACTIONS(3805),
    [anon_sym_requires] = ACTIONS(3805),
    [anon_sym_where] = ACTIONS(3805),
  },
  [2962] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3752),
    [anon_sym_COMMA] = ACTIONS(3752),
    [anon_sym_RPAREN] = ACTIONS(3752),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_DASH] = ACTIONS(3750),
    [anon_sym_PLUS] = ACTIONS(3750),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_SLASH] = ACTIONS(3750),
    [anon_sym_PERCENT] = ACTIONS(3752),
    [anon_sym_PIPE_PIPE] = ACTIONS(3752),
    [anon_sym_AMP_AMP] = ACTIONS(3752),
    [anon_sym_PIPE] = ACTIONS(3750),
    [anon_sym_CARET] = ACTIONS(3752),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_EQ_EQ] = ACTIONS(3752),
    [anon_sym_BANG_EQ] = ACTIONS(3752),
    [anon_sym_GT] = ACTIONS(3750),
    [anon_sym_GT_EQ] = ACTIONS(3752),
    [anon_sym_LT_EQ] = ACTIONS(3750),
    [anon_sym_LT] = ACTIONS(3750),
    [anon_sym_LT_LT] = ACTIONS(3752),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_COLON] = ACTIONS(3752),
    [anon_sym_SEMI] = ACTIONS(3752),
    [anon_sym___extension__] = ACTIONS(3752),
    [anon_sym___attribute__] = ACTIONS(3752),
    [anon_sym_LBRACE] = ACTIONS(3752),
    [anon_sym_RBRACE] = ACTIONS(3752),
    [anon_sym_signed] = ACTIONS(6576),
    [anon_sym_unsigned] = ACTIONS(6576),
    [anon_sym_long] = ACTIONS(6576),
    [anon_sym_short] = ACTIONS(6576),
    [anon_sym_LBRACK] = ACTIONS(3752),
    [anon_sym_RBRACK] = ACTIONS(3752),
    [anon_sym_const] = ACTIONS(3750),
    [anon_sym_constexpr] = ACTIONS(3752),
    [anon_sym_volatile] = ACTIONS(3752),
    [anon_sym_restrict] = ACTIONS(3752),
    [anon_sym___restrict__] = ACTIONS(3752),
    [anon_sym__Atomic] = ACTIONS(3752),
    [anon_sym__Noreturn] = ACTIONS(3752),
    [anon_sym_noreturn] = ACTIONS(3752),
    [anon_sym_mutable] = ACTIONS(3752),
    [anon_sym_constinit] = ACTIONS(3752),
    [anon_sym_consteval] = ACTIONS(3752),
    [anon_sym_alignas] = ACTIONS(3752),
    [anon_sym__Alignas] = ACTIONS(3752),
    [anon_sym_QMARK] = ACTIONS(3752),
    [anon_sym_LT_EQ_GT] = ACTIONS(3752),
    [anon_sym_or] = ACTIONS(3752),
    [anon_sym_and] = ACTIONS(3752),
    [anon_sym_bitor] = ACTIONS(3752),
    [anon_sym_xor] = ACTIONS(3752),
    [anon_sym_bitand] = ACTIONS(3752),
    [anon_sym_not_eq] = ACTIONS(3752),
    [anon_sym_is] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3752),
    [anon_sym_DASH_DASH] = ACTIONS(3752),
    [anon_sym_PLUS_PLUS] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3750),
    [anon_sym_DOT_STAR] = ACTIONS(3752),
    [anon_sym_DASH_GT] = ACTIONS(3752),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3752),
    [anon_sym_let] = ACTIONS(3752),
    [anon_sym_This] = ACTIONS(3752),
    [anon_sym_final] = ACTIONS(3752),
    [anon_sym_override] = ACTIONS(3752),
    [anon_sym_requires] = ACTIONS(3752),
    [anon_sym_where] = ACTIONS(3752),
  },
  [2963] = {
    [sym_string_literal] = STATE(2792),
    [sym_raw_string_literal] = STATE(2792),
    [sym_identifier] = ACTIONS(6594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6596),
    [anon_sym_COMMA] = ACTIONS(6596),
    [aux_sym_preproc_if_token2] = ACTIONS(6596),
    [aux_sym_preproc_else_token1] = ACTIONS(6596),
    [aux_sym_preproc_elif_token1] = ACTIONS(6594),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6596),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6596),
    [anon_sym_LPAREN2] = ACTIONS(6596),
    [anon_sym_DASH] = ACTIONS(6594),
    [anon_sym_PLUS] = ACTIONS(6594),
    [anon_sym_STAR] = ACTIONS(6594),
    [anon_sym_SLASH] = ACTIONS(6594),
    [anon_sym_PERCENT] = ACTIONS(6594),
    [anon_sym_PIPE_PIPE] = ACTIONS(6596),
    [anon_sym_AMP_AMP] = ACTIONS(6596),
    [anon_sym_PIPE] = ACTIONS(6594),
    [anon_sym_CARET] = ACTIONS(6594),
    [anon_sym_AMP] = ACTIONS(6594),
    [anon_sym_EQ_EQ] = ACTIONS(6596),
    [anon_sym_BANG_EQ] = ACTIONS(6596),
    [anon_sym_GT] = ACTIONS(6594),
    [anon_sym_GT_EQ] = ACTIONS(6596),
    [anon_sym_LT_EQ] = ACTIONS(6594),
    [anon_sym_LT] = ACTIONS(6594),
    [anon_sym_LT_LT] = ACTIONS(6594),
    [anon_sym_GT_GT] = ACTIONS(6594),
    [anon_sym_LBRACK] = ACTIONS(6596),
    [anon_sym_EQ] = ACTIONS(6594),
    [anon_sym_QMARK] = ACTIONS(6596),
    [anon_sym_STAR_EQ] = ACTIONS(6596),
    [anon_sym_SLASH_EQ] = ACTIONS(6596),
    [anon_sym_PERCENT_EQ] = ACTIONS(6596),
    [anon_sym_PLUS_EQ] = ACTIONS(6596),
    [anon_sym_DASH_EQ] = ACTIONS(6596),
    [anon_sym_LT_LT_EQ] = ACTIONS(6596),
    [anon_sym_GT_GT_EQ] = ACTIONS(6596),
    [anon_sym_AMP_EQ] = ACTIONS(6596),
    [anon_sym_CARET_EQ] = ACTIONS(6596),
    [anon_sym_PIPE_EQ] = ACTIONS(6596),
    [anon_sym_and_eq] = ACTIONS(6594),
    [anon_sym_or_eq] = ACTIONS(6594),
    [anon_sym_xor_eq] = ACTIONS(6594),
    [anon_sym_LT_EQ_GT] = ACTIONS(6596),
    [anon_sym_or] = ACTIONS(6594),
    [anon_sym_and] = ACTIONS(6594),
    [anon_sym_bitor] = ACTIONS(6594),
    [anon_sym_xor] = ACTIONS(6594),
    [anon_sym_bitand] = ACTIONS(6594),
    [anon_sym_not_eq] = ACTIONS(6594),
    [anon_sym_is] = ACTIONS(6594),
    [anon_sym_as] = ACTIONS(6594),
    [anon_sym_DASH_DASH] = ACTIONS(6596),
    [anon_sym_PLUS_PLUS] = ACTIONS(6596),
    [anon_sym_DOT] = ACTIONS(6594),
    [anon_sym_DOT_STAR] = ACTIONS(6596),
    [anon_sym_DASH_GT] = ACTIONS(6596),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [sym_literal_suffix] = ACTIONS(6592),
  },
  [2964] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3390),
    [anon_sym_COMMA] = ACTIONS(3390),
    [anon_sym_RPAREN] = ACTIONS(3390),
    [anon_sym_LPAREN2] = ACTIONS(3390),
    [anon_sym_DASH] = ACTIONS(3392),
    [anon_sym_PLUS] = ACTIONS(3392),
    [anon_sym_STAR] = ACTIONS(3390),
    [anon_sym_SLASH] = ACTIONS(3392),
    [anon_sym_PERCENT] = ACTIONS(3390),
    [anon_sym_PIPE_PIPE] = ACTIONS(3390),
    [anon_sym_AMP_AMP] = ACTIONS(3390),
    [anon_sym_PIPE] = ACTIONS(3392),
    [anon_sym_CARET] = ACTIONS(3390),
    [anon_sym_AMP] = ACTIONS(3392),
    [anon_sym_EQ_EQ] = ACTIONS(3390),
    [anon_sym_BANG_EQ] = ACTIONS(3390),
    [anon_sym_GT] = ACTIONS(3392),
    [anon_sym_GT_EQ] = ACTIONS(3390),
    [anon_sym_LT_EQ] = ACTIONS(3392),
    [anon_sym_LT] = ACTIONS(3392),
    [anon_sym_LT_LT] = ACTIONS(3390),
    [anon_sym_GT_GT] = ACTIONS(3390),
    [anon_sym_COLON] = ACTIONS(3390),
    [anon_sym_SEMI] = ACTIONS(3390),
    [anon_sym___extension__] = ACTIONS(3390),
    [anon_sym___attribute__] = ACTIONS(3390),
    [anon_sym_LBRACE] = ACTIONS(3390),
    [anon_sym_RBRACE] = ACTIONS(3390),
    [anon_sym_signed] = ACTIONS(6574),
    [anon_sym_unsigned] = ACTIONS(6574),
    [anon_sym_long] = ACTIONS(6574),
    [anon_sym_short] = ACTIONS(6574),
    [anon_sym_LBRACK] = ACTIONS(3390),
    [anon_sym_RBRACK] = ACTIONS(3390),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_constexpr] = ACTIONS(3390),
    [anon_sym_volatile] = ACTIONS(3390),
    [anon_sym_restrict] = ACTIONS(3390),
    [anon_sym___restrict__] = ACTIONS(3390),
    [anon_sym__Atomic] = ACTIONS(3390),
    [anon_sym__Noreturn] = ACTIONS(3390),
    [anon_sym_noreturn] = ACTIONS(3390),
    [anon_sym_mutable] = ACTIONS(3390),
    [anon_sym_constinit] = ACTIONS(3390),
    [anon_sym_consteval] = ACTIONS(3390),
    [anon_sym_alignas] = ACTIONS(3390),
    [anon_sym__Alignas] = ACTIONS(3390),
    [anon_sym_QMARK] = ACTIONS(3390),
    [anon_sym_LT_EQ_GT] = ACTIONS(3390),
    [anon_sym_or] = ACTIONS(3390),
    [anon_sym_and] = ACTIONS(3390),
    [anon_sym_bitor] = ACTIONS(3390),
    [anon_sym_xor] = ACTIONS(3390),
    [anon_sym_bitand] = ACTIONS(3390),
    [anon_sym_not_eq] = ACTIONS(3390),
    [anon_sym_is] = ACTIONS(3390),
    [anon_sym_as] = ACTIONS(3390),
    [anon_sym_DASH_DASH] = ACTIONS(3390),
    [anon_sym_PLUS_PLUS] = ACTIONS(3390),
    [anon_sym_DOT] = ACTIONS(3392),
    [anon_sym_DOT_STAR] = ACTIONS(3390),
    [anon_sym_DASH_GT] = ACTIONS(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3390),
    [anon_sym_let] = ACTIONS(3390),
    [anon_sym_This] = ACTIONS(3390),
    [anon_sym_final] = ACTIONS(3390),
    [anon_sym_override] = ACTIONS(3390),
    [anon_sym_requires] = ACTIONS(3390),
    [anon_sym_where] = ACTIONS(3390),
  },
  [2965] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2967),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3766),
    [anon_sym_COMMA] = ACTIONS(3766),
    [anon_sym_RPAREN] = ACTIONS(3766),
    [anon_sym_LPAREN2] = ACTIONS(3766),
    [anon_sym_DASH] = ACTIONS(3764),
    [anon_sym_PLUS] = ACTIONS(3764),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3764),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3766),
    [anon_sym_AMP_AMP] = ACTIONS(3766),
    [anon_sym_PIPE] = ACTIONS(3764),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3764),
    [anon_sym_EQ_EQ] = ACTIONS(3766),
    [anon_sym_BANG_EQ] = ACTIONS(3766),
    [anon_sym_GT] = ACTIONS(3764),
    [anon_sym_GT_EQ] = ACTIONS(3766),
    [anon_sym_LT_EQ] = ACTIONS(3764),
    [anon_sym_LT] = ACTIONS(3764),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_COLON] = ACTIONS(3766),
    [anon_sym_SEMI] = ACTIONS(3766),
    [anon_sym___extension__] = ACTIONS(3766),
    [anon_sym___attribute__] = ACTIONS(3766),
    [anon_sym_LBRACE] = ACTIONS(3766),
    [anon_sym_RBRACE] = ACTIONS(3766),
    [anon_sym_signed] = ACTIONS(6598),
    [anon_sym_unsigned] = ACTIONS(6598),
    [anon_sym_long] = ACTIONS(6598),
    [anon_sym_short] = ACTIONS(6598),
    [anon_sym_LBRACK] = ACTIONS(3766),
    [anon_sym_RBRACK] = ACTIONS(3766),
    [anon_sym_const] = ACTIONS(3764),
    [anon_sym_constexpr] = ACTIONS(3766),
    [anon_sym_volatile] = ACTIONS(3766),
    [anon_sym_restrict] = ACTIONS(3766),
    [anon_sym___restrict__] = ACTIONS(3766),
    [anon_sym__Atomic] = ACTIONS(3766),
    [anon_sym__Noreturn] = ACTIONS(3766),
    [anon_sym_noreturn] = ACTIONS(3766),
    [anon_sym_mutable] = ACTIONS(3766),
    [anon_sym_constinit] = ACTIONS(3766),
    [anon_sym_consteval] = ACTIONS(3766),
    [anon_sym_alignas] = ACTIONS(3766),
    [anon_sym__Alignas] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3766),
    [anon_sym_LT_EQ_GT] = ACTIONS(3766),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3766),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3766),
    [anon_sym_not_eq] = ACTIONS(3766),
    [anon_sym_is] = ACTIONS(3766),
    [anon_sym_as] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3766),
    [anon_sym_PLUS_PLUS] = ACTIONS(3766),
    [anon_sym_DOT] = ACTIONS(3764),
    [anon_sym_DOT_STAR] = ACTIONS(3766),
    [anon_sym_DASH_GT] = ACTIONS(3766),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3766),
    [anon_sym_let] = ACTIONS(3766),
    [anon_sym_This] = ACTIONS(3766),
    [anon_sym_final] = ACTIONS(3766),
    [anon_sym_override] = ACTIONS(3766),
    [anon_sym_requires] = ACTIONS(3766),
    [anon_sym_where] = ACTIONS(3766),
  },
  [2966] = {
    [sym_attribute_specifier] = STATE(2746),
    [sym_field_declaration_list] = STATE(2714),
    [sym_virtual_specifier] = STATE(8832),
    [sym_base_class_clause] = STATE(9868),
    [sym_identifier] = ACTIONS(2683),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_STAR] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_COLON] = ACTIONS(6474),
    [anon_sym_SEMI] = ACTIONS(2685),
    [anon_sym___extension__] = ACTIONS(2683),
    [anon_sym_in] = ACTIONS(2683),
    [anon_sym_out] = ACTIONS(2683),
    [anon_sym_inout] = ACTIONS(2683),
    [anon_sym_extern] = ACTIONS(2683),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2685),
    [anon_sym___declspec] = ACTIONS(2683),
    [anon_sym___based] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(6230),
    [anon_sym_LBRACK] = ACTIONS(2683),
    [anon_sym_static] = ACTIONS(2683),
    [anon_sym_register] = ACTIONS(2683),
    [anon_sym_inline] = ACTIONS(2683),
    [anon_sym___inline] = ACTIONS(2683),
    [anon_sym___inline__] = ACTIONS(2683),
    [anon_sym___forceinline] = ACTIONS(2683),
    [anon_sym_thread_local] = ACTIONS(2683),
    [anon_sym___thread] = ACTIONS(2683),
    [anon_sym_const] = ACTIONS(2683),
    [anon_sym_constexpr] = ACTIONS(2683),
    [anon_sym_volatile] = ACTIONS(2683),
    [anon_sym_restrict] = ACTIONS(2683),
    [anon_sym___restrict__] = ACTIONS(2683),
    [anon_sym__Atomic] = ACTIONS(2683),
    [anon_sym__Noreturn] = ACTIONS(2683),
    [anon_sym_noreturn] = ACTIONS(2683),
    [anon_sym_mutable] = ACTIONS(2683),
    [anon_sym_constinit] = ACTIONS(2683),
    [anon_sym_consteval] = ACTIONS(2683),
    [anon_sym_alignas] = ACTIONS(2683),
    [anon_sym__Alignas] = ACTIONS(2683),
    [anon_sym_DOT] = ACTIONS(2685),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2683),
    [anon_sym_let] = ACTIONS(2683),
    [anon_sym_This] = ACTIONS(2683),
    [anon_sym_final] = ACTIONS(2481),
    [anon_sym_override] = ACTIONS(2481),
    [sym_virtual] = ACTIONS(2683),
    [anon_sym_operator] = ACTIONS(2683),
    [anon_sym_precise] = ACTIONS(2683),
    [anon_sym_shared] = ACTIONS(2683),
    [anon_sym_groupshared] = ACTIONS(2683),
    [anon_sym_uniform] = ACTIONS(2683),
    [anon_sym_row_major] = ACTIONS(2683),
    [anon_sym_column_major] = ACTIONS(2683),
    [anon_sym_globallycoherent] = ACTIONS(2683),
    [anon_sym_centroid] = ACTIONS(2683),
    [anon_sym_noperspective] = ACTIONS(2683),
    [anon_sym_nointerpolation] = ACTIONS(2683),
    [anon_sym_sample] = ACTIONS(2683),
    [anon_sym_linear] = ACTIONS(2683),
    [anon_sym_snorm] = ACTIONS(2683),
    [anon_sym_unorm] = ACTIONS(2683),
    [anon_sym_point] = ACTIONS(2683),
    [anon_sym_line] = ACTIONS(2683),
    [anon_sym_triangleadj] = ACTIONS(2683),
    [anon_sym_lineadj] = ACTIONS(2683),
    [anon_sym_triangle] = ACTIONS(2683),
  },
  [2967] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3812),
    [anon_sym_COMMA] = ACTIONS(3812),
    [anon_sym_RPAREN] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3812),
    [anon_sym_DASH] = ACTIONS(3810),
    [anon_sym_PLUS] = ACTIONS(3810),
    [anon_sym_STAR] = ACTIONS(3812),
    [anon_sym_SLASH] = ACTIONS(3810),
    [anon_sym_PERCENT] = ACTIONS(3812),
    [anon_sym_PIPE_PIPE] = ACTIONS(3812),
    [anon_sym_AMP_AMP] = ACTIONS(3812),
    [anon_sym_PIPE] = ACTIONS(3810),
    [anon_sym_CARET] = ACTIONS(3812),
    [anon_sym_AMP] = ACTIONS(3810),
    [anon_sym_EQ_EQ] = ACTIONS(3812),
    [anon_sym_BANG_EQ] = ACTIONS(3812),
    [anon_sym_GT] = ACTIONS(3810),
    [anon_sym_GT_EQ] = ACTIONS(3812),
    [anon_sym_LT_EQ] = ACTIONS(3810),
    [anon_sym_LT] = ACTIONS(3810),
    [anon_sym_LT_LT] = ACTIONS(3812),
    [anon_sym_GT_GT] = ACTIONS(3812),
    [anon_sym_COLON] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3812),
    [anon_sym___extension__] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym_LBRACE] = ACTIONS(3812),
    [anon_sym_RBRACE] = ACTIONS(3812),
    [anon_sym_signed] = ACTIONS(6576),
    [anon_sym_unsigned] = ACTIONS(6576),
    [anon_sym_long] = ACTIONS(6576),
    [anon_sym_short] = ACTIONS(6576),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_RBRACK] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3810),
    [anon_sym_constexpr] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_restrict] = ACTIONS(3812),
    [anon_sym___restrict__] = ACTIONS(3812),
    [anon_sym__Atomic] = ACTIONS(3812),
    [anon_sym__Noreturn] = ACTIONS(3812),
    [anon_sym_noreturn] = ACTIONS(3812),
    [anon_sym_mutable] = ACTIONS(3812),
    [anon_sym_constinit] = ACTIONS(3812),
    [anon_sym_consteval] = ACTIONS(3812),
    [anon_sym_alignas] = ACTIONS(3812),
    [anon_sym__Alignas] = ACTIONS(3812),
    [anon_sym_QMARK] = ACTIONS(3812),
    [anon_sym_LT_EQ_GT] = ACTIONS(3812),
    [anon_sym_or] = ACTIONS(3812),
    [anon_sym_and] = ACTIONS(3812),
    [anon_sym_bitor] = ACTIONS(3812),
    [anon_sym_xor] = ACTIONS(3812),
    [anon_sym_bitand] = ACTIONS(3812),
    [anon_sym_not_eq] = ACTIONS(3812),
    [anon_sym_is] = ACTIONS(3812),
    [anon_sym_as] = ACTIONS(3812),
    [anon_sym_DASH_DASH] = ACTIONS(3812),
    [anon_sym_PLUS_PLUS] = ACTIONS(3812),
    [anon_sym_DOT] = ACTIONS(3810),
    [anon_sym_DOT_STAR] = ACTIONS(3812),
    [anon_sym_DASH_GT] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
    [anon_sym_final] = ACTIONS(3812),
    [anon_sym_override] = ACTIONS(3812),
    [anon_sym_requires] = ACTIONS(3812),
    [anon_sym_where] = ACTIONS(3812),
  },
  [2968] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3773),
    [anon_sym_COMMA] = ACTIONS(3773),
    [anon_sym_RPAREN] = ACTIONS(3773),
    [anon_sym_LPAREN2] = ACTIONS(3773),
    [anon_sym_DASH] = ACTIONS(3771),
    [anon_sym_PLUS] = ACTIONS(3771),
    [anon_sym_STAR] = ACTIONS(3773),
    [anon_sym_SLASH] = ACTIONS(3771),
    [anon_sym_PERCENT] = ACTIONS(3773),
    [anon_sym_PIPE_PIPE] = ACTIONS(3773),
    [anon_sym_AMP_AMP] = ACTIONS(3773),
    [anon_sym_PIPE] = ACTIONS(3771),
    [anon_sym_CARET] = ACTIONS(3773),
    [anon_sym_AMP] = ACTIONS(3771),
    [anon_sym_EQ_EQ] = ACTIONS(3773),
    [anon_sym_BANG_EQ] = ACTIONS(3773),
    [anon_sym_GT] = ACTIONS(3771),
    [anon_sym_GT_EQ] = ACTIONS(3773),
    [anon_sym_LT_EQ] = ACTIONS(3771),
    [anon_sym_LT] = ACTIONS(3771),
    [anon_sym_LT_LT] = ACTIONS(3773),
    [anon_sym_GT_GT] = ACTIONS(3773),
    [anon_sym_COLON] = ACTIONS(3773),
    [anon_sym_SEMI] = ACTIONS(3773),
    [anon_sym___extension__] = ACTIONS(3773),
    [anon_sym___attribute__] = ACTIONS(3773),
    [anon_sym_LBRACE] = ACTIONS(3773),
    [anon_sym_RBRACE] = ACTIONS(3773),
    [anon_sym_signed] = ACTIONS(6600),
    [anon_sym_unsigned] = ACTIONS(6600),
    [anon_sym_long] = ACTIONS(6600),
    [anon_sym_short] = ACTIONS(6600),
    [anon_sym_LBRACK] = ACTIONS(3773),
    [anon_sym_RBRACK] = ACTIONS(3773),
    [anon_sym_const] = ACTIONS(3771),
    [anon_sym_constexpr] = ACTIONS(3773),
    [anon_sym_volatile] = ACTIONS(3773),
    [anon_sym_restrict] = ACTIONS(3773),
    [anon_sym___restrict__] = ACTIONS(3773),
    [anon_sym__Atomic] = ACTIONS(3773),
    [anon_sym__Noreturn] = ACTIONS(3773),
    [anon_sym_noreturn] = ACTIONS(3773),
    [anon_sym_mutable] = ACTIONS(3773),
    [anon_sym_constinit] = ACTIONS(3773),
    [anon_sym_consteval] = ACTIONS(3773),
    [anon_sym_alignas] = ACTIONS(3773),
    [anon_sym__Alignas] = ACTIONS(3773),
    [anon_sym_QMARK] = ACTIONS(3773),
    [anon_sym_LT_EQ_GT] = ACTIONS(3773),
    [anon_sym_or] = ACTIONS(3773),
    [anon_sym_and] = ACTIONS(3773),
    [anon_sym_bitor] = ACTIONS(3773),
    [anon_sym_xor] = ACTIONS(3773),
    [anon_sym_bitand] = ACTIONS(3773),
    [anon_sym_not_eq] = ACTIONS(3773),
    [anon_sym_is] = ACTIONS(3773),
    [anon_sym_as] = ACTIONS(3773),
    [anon_sym_DASH_DASH] = ACTIONS(3773),
    [anon_sym_PLUS_PLUS] = ACTIONS(3773),
    [anon_sym_DOT] = ACTIONS(3771),
    [anon_sym_DOT_STAR] = ACTIONS(3773),
    [anon_sym_DASH_GT] = ACTIONS(3773),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3773),
    [anon_sym_let] = ACTIONS(3773),
    [anon_sym_This] = ACTIONS(3773),
    [anon_sym_final] = ACTIONS(3773),
    [anon_sym_override] = ACTIONS(3773),
    [anon_sym_requires] = ACTIONS(3773),
    [anon_sym_where] = ACTIONS(3773),
  },
  [2969] = {
    [sym_string_literal] = STATE(2997),
    [sym_template_argument_list] = STATE(3679),
    [sym_raw_string_literal] = STATE(2997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_RPAREN] = ACTIONS(6602),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(6162),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6165),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(6605),
    [anon_sym_EQ] = ACTIONS(2128),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2117),
    [anon_sym_SLASH_EQ] = ACTIONS(2117),
    [anon_sym_PERCENT_EQ] = ACTIONS(2117),
    [anon_sym_PLUS_EQ] = ACTIONS(2117),
    [anon_sym_DASH_EQ] = ACTIONS(2117),
    [anon_sym_LT_LT_EQ] = ACTIONS(2117),
    [anon_sym_GT_GT_EQ] = ACTIONS(2117),
    [anon_sym_AMP_EQ] = ACTIONS(2117),
    [anon_sym_CARET_EQ] = ACTIONS(2117),
    [anon_sym_PIPE_EQ] = ACTIONS(2117),
    [anon_sym_and_eq] = ACTIONS(2117),
    [anon_sym_or_eq] = ACTIONS(2117),
    [anon_sym_xor_eq] = ACTIONS(2117),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2117),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2117),
    [anon_sym_not_eq] = ACTIONS(2117),
    [anon_sym_is] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2128),
    [anon_sym_L_DQUOTE] = ACTIONS(6169),
    [anon_sym_u_DQUOTE] = ACTIONS(6169),
    [anon_sym_U_DQUOTE] = ACTIONS(6169),
    [anon_sym_u8_DQUOTE] = ACTIONS(6169),
    [anon_sym_DQUOTE] = ACTIONS(6169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6171),
    [anon_sym_LR_DQUOTE] = ACTIONS(6171),
    [anon_sym_uR_DQUOTE] = ACTIONS(6171),
    [anon_sym_UR_DQUOTE] = ACTIONS(6171),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6171),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2117),
  },
  [2970] = {
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2371),
    [anon_sym_COMMA] = ACTIONS(2371),
    [anon_sym_RPAREN] = ACTIONS(2371),
    [aux_sym_preproc_if_token2] = ACTIONS(2371),
    [aux_sym_preproc_else_token1] = ACTIONS(2371),
    [aux_sym_preproc_elif_token1] = ACTIONS(2373),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2371),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2371),
    [anon_sym_LPAREN2] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_SLASH] = ACTIONS(2373),
    [anon_sym_PERCENT] = ACTIONS(2373),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_CARET] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_EQ_EQ] = ACTIONS(2371),
    [anon_sym_BANG_EQ] = ACTIONS(2371),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_EQ] = ACTIONS(2371),
    [anon_sym_LT_EQ] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_COLON] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym___attribute__] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_RBRACE] = ACTIONS(2371),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_RBRACK] = ACTIONS(2371),
    [anon_sym_EQ] = ACTIONS(2373),
    [anon_sym_QMARK] = ACTIONS(2371),
    [anon_sym_STAR_EQ] = ACTIONS(2371),
    [anon_sym_SLASH_EQ] = ACTIONS(2371),
    [anon_sym_PERCENT_EQ] = ACTIONS(2371),
    [anon_sym_PLUS_EQ] = ACTIONS(2371),
    [anon_sym_DASH_EQ] = ACTIONS(2371),
    [anon_sym_LT_LT_EQ] = ACTIONS(2371),
    [anon_sym_GT_GT_EQ] = ACTIONS(2371),
    [anon_sym_AMP_EQ] = ACTIONS(2371),
    [anon_sym_CARET_EQ] = ACTIONS(2371),
    [anon_sym_PIPE_EQ] = ACTIONS(2371),
    [anon_sym_and_eq] = ACTIONS(2373),
    [anon_sym_or_eq] = ACTIONS(2373),
    [anon_sym_xor_eq] = ACTIONS(2373),
    [anon_sym_LT_EQ_GT] = ACTIONS(2371),
    [anon_sym_or] = ACTIONS(2373),
    [anon_sym_and] = ACTIONS(2373),
    [anon_sym_bitor] = ACTIONS(2373),
    [anon_sym_xor] = ACTIONS(2373),
    [anon_sym_bitand] = ACTIONS(2373),
    [anon_sym_not_eq] = ACTIONS(2373),
    [anon_sym_is] = ACTIONS(2373),
    [anon_sym_as] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_DOT] = ACTIONS(2373),
    [anon_sym_DOT_STAR] = ACTIONS(2371),
    [anon_sym_DASH_GT] = ACTIONS(2371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_This] = ACTIONS(2373),
    [anon_sym_final] = ACTIONS(2373),
    [anon_sym_override] = ACTIONS(2373),
  },
  [2971] = {
    [sym_string_literal] = STATE(2792),
    [sym_raw_string_literal] = STATE(2792),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6596),
    [anon_sym_COMMA] = ACTIONS(6596),
    [anon_sym_RPAREN] = ACTIONS(6596),
    [anon_sym_LPAREN2] = ACTIONS(6596),
    [anon_sym_DASH] = ACTIONS(6594),
    [anon_sym_PLUS] = ACTIONS(6594),
    [anon_sym_STAR] = ACTIONS(6594),
    [anon_sym_SLASH] = ACTIONS(6594),
    [anon_sym_PERCENT] = ACTIONS(6594),
    [anon_sym_PIPE_PIPE] = ACTIONS(6596),
    [anon_sym_AMP_AMP] = ACTIONS(6596),
    [anon_sym_PIPE] = ACTIONS(6594),
    [anon_sym_CARET] = ACTIONS(6594),
    [anon_sym_AMP] = ACTIONS(6594),
    [anon_sym_EQ_EQ] = ACTIONS(6596),
    [anon_sym_BANG_EQ] = ACTIONS(6596),
    [anon_sym_GT] = ACTIONS(6594),
    [anon_sym_GT_EQ] = ACTIONS(6596),
    [anon_sym_LT_EQ] = ACTIONS(6594),
    [anon_sym_LT] = ACTIONS(6594),
    [anon_sym_LT_LT] = ACTIONS(6594),
    [anon_sym_GT_GT] = ACTIONS(6594),
    [anon_sym_COLON] = ACTIONS(6596),
    [anon_sym_SEMI] = ACTIONS(6596),
    [anon_sym_RBRACE] = ACTIONS(6596),
    [anon_sym_LBRACK] = ACTIONS(6596),
    [anon_sym_RBRACK] = ACTIONS(6596),
    [anon_sym_EQ] = ACTIONS(6594),
    [anon_sym_QMARK] = ACTIONS(6596),
    [anon_sym_STAR_EQ] = ACTIONS(6596),
    [anon_sym_SLASH_EQ] = ACTIONS(6596),
    [anon_sym_PERCENT_EQ] = ACTIONS(6596),
    [anon_sym_PLUS_EQ] = ACTIONS(6596),
    [anon_sym_DASH_EQ] = ACTIONS(6596),
    [anon_sym_LT_LT_EQ] = ACTIONS(6596),
    [anon_sym_GT_GT_EQ] = ACTIONS(6596),
    [anon_sym_AMP_EQ] = ACTIONS(6596),
    [anon_sym_CARET_EQ] = ACTIONS(6596),
    [anon_sym_PIPE_EQ] = ACTIONS(6596),
    [anon_sym_and_eq] = ACTIONS(6594),
    [anon_sym_or_eq] = ACTIONS(6594),
    [anon_sym_xor_eq] = ACTIONS(6594),
    [anon_sym_LT_EQ_GT] = ACTIONS(6596),
    [anon_sym_or] = ACTIONS(6594),
    [anon_sym_and] = ACTIONS(6594),
    [anon_sym_bitor] = ACTIONS(6594),
    [anon_sym_xor] = ACTIONS(6594),
    [anon_sym_bitand] = ACTIONS(6594),
    [anon_sym_not_eq] = ACTIONS(6594),
    [anon_sym_is] = ACTIONS(6594),
    [anon_sym_as] = ACTIONS(6594),
    [anon_sym_DASH_DASH] = ACTIONS(6596),
    [anon_sym_PLUS_PLUS] = ACTIONS(6596),
    [anon_sym_DOT] = ACTIONS(6594),
    [anon_sym_DOT_STAR] = ACTIONS(6596),
    [anon_sym_DASH_GT] = ACTIONS(6596),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [sym_literal_suffix] = ACTIONS(6592),
  },
  [2972] = {
    [sym_string_literal] = STATE(2792),
    [sym_template_argument_list] = STATE(3505),
    [sym_raw_string_literal] = STATE(2792),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(6602),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(6608),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_SEMI] = ACTIONS(2117),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6165),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_RBRACE] = ACTIONS(2117),
    [anon_sym_LBRACK] = ACTIONS(6605),
    [anon_sym_EQ] = ACTIONS(2128),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2117),
    [anon_sym_SLASH_EQ] = ACTIONS(2117),
    [anon_sym_PERCENT_EQ] = ACTIONS(2117),
    [anon_sym_PLUS_EQ] = ACTIONS(2117),
    [anon_sym_DASH_EQ] = ACTIONS(2117),
    [anon_sym_LT_LT_EQ] = ACTIONS(2117),
    [anon_sym_GT_GT_EQ] = ACTIONS(2117),
    [anon_sym_AMP_EQ] = ACTIONS(2117),
    [anon_sym_CARET_EQ] = ACTIONS(2117),
    [anon_sym_PIPE_EQ] = ACTIONS(2117),
    [anon_sym_and_eq] = ACTIONS(2117),
    [anon_sym_or_eq] = ACTIONS(2117),
    [anon_sym_xor_eq] = ACTIONS(2117),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2117),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2117),
    [anon_sym_not_eq] = ACTIONS(2117),
    [anon_sym_is] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
  },
  [2973] = {
    [sym_string_literal] = STATE(2997),
    [sym_template_argument_list] = STATE(3706),
    [sym_raw_string_literal] = STATE(2997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_RPAREN] = ACTIONS(6611),
    [anon_sym_LPAREN2] = ACTIONS(6611),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(6173),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6611),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(6613),
    [anon_sym_EQ] = ACTIONS(2128),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2117),
    [anon_sym_SLASH_EQ] = ACTIONS(2117),
    [anon_sym_PERCENT_EQ] = ACTIONS(2117),
    [anon_sym_PLUS_EQ] = ACTIONS(2117),
    [anon_sym_DASH_EQ] = ACTIONS(2117),
    [anon_sym_LT_LT_EQ] = ACTIONS(2117),
    [anon_sym_GT_GT_EQ] = ACTIONS(2117),
    [anon_sym_AMP_EQ] = ACTIONS(2117),
    [anon_sym_CARET_EQ] = ACTIONS(2117),
    [anon_sym_PIPE_EQ] = ACTIONS(2117),
    [anon_sym_and_eq] = ACTIONS(2117),
    [anon_sym_or_eq] = ACTIONS(2117),
    [anon_sym_xor_eq] = ACTIONS(2117),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2117),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2117),
    [anon_sym_not_eq] = ACTIONS(2117),
    [anon_sym_is] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2128),
    [anon_sym_L_DQUOTE] = ACTIONS(6169),
    [anon_sym_u_DQUOTE] = ACTIONS(6169),
    [anon_sym_U_DQUOTE] = ACTIONS(6169),
    [anon_sym_u8_DQUOTE] = ACTIONS(6169),
    [anon_sym_DQUOTE] = ACTIONS(6169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6171),
    [anon_sym_LR_DQUOTE] = ACTIONS(6171),
    [anon_sym_uR_DQUOTE] = ACTIONS(6171),
    [anon_sym_UR_DQUOTE] = ACTIONS(6171),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6171),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2117),
  },
  [2974] = {
    [sym_attribute_specifier] = STATE(3103),
    [sym_enumerator_list] = STATE(3015),
    [sym_identifier] = ACTIONS(3711),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3713),
    [anon_sym_COMMA] = ACTIONS(3713),
    [anon_sym_RPAREN] = ACTIONS(3713),
    [aux_sym_preproc_if_token2] = ACTIONS(3713),
    [aux_sym_preproc_else_token1] = ACTIONS(3713),
    [aux_sym_preproc_elif_token1] = ACTIONS(3711),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3713),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3713),
    [anon_sym_LPAREN2] = ACTIONS(3713),
    [anon_sym_DASH] = ACTIONS(3711),
    [anon_sym_PLUS] = ACTIONS(3711),
    [anon_sym_STAR] = ACTIONS(3711),
    [anon_sym_SLASH] = ACTIONS(3711),
    [anon_sym_PERCENT] = ACTIONS(3711),
    [anon_sym_PIPE_PIPE] = ACTIONS(3713),
    [anon_sym_AMP_AMP] = ACTIONS(3713),
    [anon_sym_PIPE] = ACTIONS(3711),
    [anon_sym_CARET] = ACTIONS(3711),
    [anon_sym_AMP] = ACTIONS(3711),
    [anon_sym_EQ_EQ] = ACTIONS(3713),
    [anon_sym_BANG_EQ] = ACTIONS(3713),
    [anon_sym_GT] = ACTIONS(3711),
    [anon_sym_GT_EQ] = ACTIONS(3713),
    [anon_sym_LT_EQ] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3711),
    [anon_sym_LT_LT] = ACTIONS(3711),
    [anon_sym_GT_GT] = ACTIONS(3711),
    [anon_sym_COLON] = ACTIONS(3713),
    [anon_sym_SEMI] = ACTIONS(3713),
    [anon_sym___attribute__] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(6615),
    [anon_sym_RBRACE] = ACTIONS(3713),
    [anon_sym_LBRACK] = ACTIONS(3713),
    [anon_sym_RBRACK] = ACTIONS(3713),
    [anon_sym_EQ] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3713),
    [anon_sym_STAR_EQ] = ACTIONS(3713),
    [anon_sym_SLASH_EQ] = ACTIONS(3713),
    [anon_sym_PERCENT_EQ] = ACTIONS(3713),
    [anon_sym_PLUS_EQ] = ACTIONS(3713),
    [anon_sym_DASH_EQ] = ACTIONS(3713),
    [anon_sym_LT_LT_EQ] = ACTIONS(3713),
    [anon_sym_GT_GT_EQ] = ACTIONS(3713),
    [anon_sym_AMP_EQ] = ACTIONS(3713),
    [anon_sym_CARET_EQ] = ACTIONS(3713),
    [anon_sym_PIPE_EQ] = ACTIONS(3713),
    [anon_sym_and_eq] = ACTIONS(3711),
    [anon_sym_or_eq] = ACTIONS(3711),
    [anon_sym_xor_eq] = ACTIONS(3711),
    [anon_sym_LT_EQ_GT] = ACTIONS(3713),
    [anon_sym_or] = ACTIONS(3711),
    [anon_sym_and] = ACTIONS(3711),
    [anon_sym_bitor] = ACTIONS(3711),
    [anon_sym_xor] = ACTIONS(3711),
    [anon_sym_bitand] = ACTIONS(3711),
    [anon_sym_not_eq] = ACTIONS(3711),
    [anon_sym_is] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3711),
    [anon_sym_DASH_DASH] = ACTIONS(3713),
    [anon_sym_PLUS_PLUS] = ACTIONS(3713),
    [anon_sym_DOT] = ACTIONS(3711),
    [anon_sym_DOT_STAR] = ACTIONS(3713),
    [anon_sym_DASH_GT] = ACTIONS(3713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_This] = ACTIONS(3711),
  },
  [2975] = {
    [sym_template_argument_list] = STATE(2816),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3044),
    [sym_identifier] = ACTIONS(3483),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3485),
    [anon_sym_COMMA] = ACTIONS(3485),
    [aux_sym_preproc_if_token2] = ACTIONS(3485),
    [aux_sym_preproc_else_token1] = ACTIONS(3485),
    [aux_sym_preproc_elif_token1] = ACTIONS(3483),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3485),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3485),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_STAR] = ACTIONS(3483),
    [anon_sym_SLASH] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3485),
    [anon_sym_AMP_AMP] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(3483),
    [anon_sym_CARET] = ACTIONS(3483),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_EQ_EQ] = ACTIONS(3485),
    [anon_sym_BANG_EQ] = ACTIONS(3485),
    [anon_sym_GT] = ACTIONS(3483),
    [anon_sym_GT_EQ] = ACTIONS(3485),
    [anon_sym_LT_EQ] = ACTIONS(3483),
    [anon_sym_LT] = ACTIONS(3483),
    [anon_sym_LT_LT] = ACTIONS(3483),
    [anon_sym_GT_GT] = ACTIONS(3483),
    [anon_sym___attribute__] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(3485),
    [anon_sym_signed] = ACTIONS(6617),
    [anon_sym_unsigned] = ACTIONS(6617),
    [anon_sym_long] = ACTIONS(6617),
    [anon_sym_short] = ACTIONS(6617),
    [anon_sym_LBRACK] = ACTIONS(3485),
    [anon_sym_EQ] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3485),
    [anon_sym_STAR_EQ] = ACTIONS(3485),
    [anon_sym_SLASH_EQ] = ACTIONS(3485),
    [anon_sym_PERCENT_EQ] = ACTIONS(3485),
    [anon_sym_PLUS_EQ] = ACTIONS(3485),
    [anon_sym_DASH_EQ] = ACTIONS(3485),
    [anon_sym_LT_LT_EQ] = ACTIONS(3485),
    [anon_sym_GT_GT_EQ] = ACTIONS(3485),
    [anon_sym_AMP_EQ] = ACTIONS(3485),
    [anon_sym_CARET_EQ] = ACTIONS(3485),
    [anon_sym_PIPE_EQ] = ACTIONS(3485),
    [anon_sym_and_eq] = ACTIONS(3483),
    [anon_sym_or_eq] = ACTIONS(3483),
    [anon_sym_xor_eq] = ACTIONS(3483),
    [anon_sym_LT_EQ_GT] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [anon_sym_and] = ACTIONS(3483),
    [anon_sym_bitor] = ACTIONS(3483),
    [anon_sym_xor] = ACTIONS(3483),
    [anon_sym_bitand] = ACTIONS(3483),
    [anon_sym_not_eq] = ACTIONS(3483),
    [anon_sym_is] = ACTIONS(3483),
    [anon_sym_as] = ACTIONS(3483),
    [anon_sym_DASH_DASH] = ACTIONS(3485),
    [anon_sym_PLUS_PLUS] = ACTIONS(3485),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_DOT_STAR] = ACTIONS(3485),
    [anon_sym_DASH_GT] = ACTIONS(3485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_This] = ACTIONS(3483),
  },
  [2976] = {
    [sym_string_literal] = STATE(2792),
    [sym_template_argument_list] = STATE(3167),
    [sym_raw_string_literal] = STATE(2792),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(6611),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(6428),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_SEMI] = ACTIONS(2117),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6611),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_RBRACE] = ACTIONS(2117),
    [anon_sym_LBRACK] = ACTIONS(6613),
    [anon_sym_EQ] = ACTIONS(2128),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2117),
    [anon_sym_SLASH_EQ] = ACTIONS(2117),
    [anon_sym_PERCENT_EQ] = ACTIONS(2117),
    [anon_sym_PLUS_EQ] = ACTIONS(2117),
    [anon_sym_DASH_EQ] = ACTIONS(2117),
    [anon_sym_LT_LT_EQ] = ACTIONS(2117),
    [anon_sym_GT_GT_EQ] = ACTIONS(2117),
    [anon_sym_AMP_EQ] = ACTIONS(2117),
    [anon_sym_CARET_EQ] = ACTIONS(2117),
    [anon_sym_PIPE_EQ] = ACTIONS(2117),
    [anon_sym_and_eq] = ACTIONS(2117),
    [anon_sym_or_eq] = ACTIONS(2117),
    [anon_sym_xor_eq] = ACTIONS(2117),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2117),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2117),
    [anon_sym_not_eq] = ACTIONS(2117),
    [anon_sym_is] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
  },
  [2977] = {
    [sym_identifier] = ACTIONS(6132),
    [anon_sym___extension__] = ACTIONS(6132),
    [anon_sym_typedef] = ACTIONS(6619),
    [anon_sym_in] = ACTIONS(6132),
    [anon_sym_out] = ACTIONS(6132),
    [anon_sym_inout] = ACTIONS(6132),
    [anon_sym_extern] = ACTIONS(6132),
    [anon_sym___attribute__] = ACTIONS(6132),
    [anon_sym_COLON_COLON] = ACTIONS(6134),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6134),
    [anon_sym___declspec] = ACTIONS(6132),
    [anon_sym_signed] = ACTIONS(6132),
    [anon_sym_unsigned] = ACTIONS(6132),
    [anon_sym_long] = ACTIONS(6132),
    [anon_sym_short] = ACTIONS(6132),
    [anon_sym_static] = ACTIONS(6132),
    [anon_sym_register] = ACTIONS(6132),
    [anon_sym_inline] = ACTIONS(6132),
    [anon_sym___inline] = ACTIONS(6132),
    [anon_sym___inline__] = ACTIONS(6132),
    [anon_sym___forceinline] = ACTIONS(6132),
    [anon_sym_thread_local] = ACTIONS(6132),
    [anon_sym___thread] = ACTIONS(6132),
    [anon_sym_const] = ACTIONS(6132),
    [anon_sym_constexpr] = ACTIONS(6132),
    [anon_sym_volatile] = ACTIONS(6132),
    [anon_sym_restrict] = ACTIONS(6132),
    [anon_sym___restrict__] = ACTIONS(6132),
    [anon_sym__Atomic] = ACTIONS(6132),
    [anon_sym__Noreturn] = ACTIONS(6132),
    [anon_sym_noreturn] = ACTIONS(6132),
    [anon_sym_mutable] = ACTIONS(6132),
    [anon_sym_constinit] = ACTIONS(6132),
    [anon_sym_consteval] = ACTIONS(6132),
    [anon_sym_alignas] = ACTIONS(6132),
    [anon_sym__Alignas] = ACTIONS(6132),
    [sym_primitive_type] = ACTIONS(6132),
    [anon_sym_enum] = ACTIONS(6132),
    [anon_sym_class] = ACTIONS(6132),
    [anon_sym_struct] = ACTIONS(6132),
    [anon_sym_union] = ACTIONS(6132),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6132),
    [anon_sym_let] = ACTIONS(6132),
    [anon_sym_This] = ACTIONS(6132),
    [anon_sym_decltype] = ACTIONS(6132),
    [sym_virtual] = ACTIONS(6132),
    [anon_sym_typename] = ACTIONS(6132),
    [anon_sym_template] = ACTIONS(6132),
    [anon_sym_precise] = ACTIONS(6132),
    [anon_sym_shared] = ACTIONS(6132),
    [anon_sym_groupshared] = ACTIONS(6132),
    [anon_sym_uniform] = ACTIONS(6132),
    [anon_sym_row_major] = ACTIONS(6132),
    [anon_sym_column_major] = ACTIONS(6132),
    [anon_sym_globallycoherent] = ACTIONS(6132),
    [anon_sym_centroid] = ACTIONS(6132),
    [anon_sym_noperspective] = ACTIONS(6132),
    [anon_sym_nointerpolation] = ACTIONS(6132),
    [anon_sym_sample] = ACTIONS(6132),
    [anon_sym_linear] = ACTIONS(6132),
    [anon_sym_snorm] = ACTIONS(6132),
    [anon_sym_unorm] = ACTIONS(6132),
    [anon_sym_point] = ACTIONS(6132),
    [anon_sym_line] = ACTIONS(6132),
    [anon_sym_triangleadj] = ACTIONS(6132),
    [anon_sym_lineadj] = ACTIONS(6132),
    [anon_sym_triangle] = ACTIONS(6132),
    [anon_sym_interface] = ACTIONS(6132),
    [anon_sym_extension] = ACTIONS(6132),
  },
  [2978] = {
    [sym_string_literal] = STATE(3342),
    [sym_template_argument_list] = STATE(4579),
    [sym_raw_string_literal] = STATE(3342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(6208),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON] = ACTIONS(2136),
    [anon_sym_SEMI] = ACTIONS(2117),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_RBRACE] = ACTIONS(2117),
    [anon_sym_LBRACK] = ACTIONS(2117),
    [anon_sym_EQ] = ACTIONS(2152),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2154),
    [anon_sym_SLASH_EQ] = ACTIONS(2154),
    [anon_sym_PERCENT_EQ] = ACTIONS(2154),
    [anon_sym_PLUS_EQ] = ACTIONS(2154),
    [anon_sym_DASH_EQ] = ACTIONS(2154),
    [anon_sym_LT_LT_EQ] = ACTIONS(2154),
    [anon_sym_GT_GT_EQ] = ACTIONS(2154),
    [anon_sym_AMP_EQ] = ACTIONS(2154),
    [anon_sym_CARET_EQ] = ACTIONS(2154),
    [anon_sym_PIPE_EQ] = ACTIONS(2154),
    [anon_sym_and_eq] = ACTIONS(2154),
    [anon_sym_or_eq] = ACTIONS(2154),
    [anon_sym_xor_eq] = ACTIONS(2154),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2117),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2117),
    [anon_sym_not_eq] = ACTIONS(2117),
    [anon_sym_is] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
  },
  [2979] = {
    [sym_attribute_specifier] = STATE(2932),
    [sym_field_declaration_list] = STATE(3129),
    [sym_virtual_specifier] = STATE(8728),
    [sym_base_class_clause] = STATE(9690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2685),
    [anon_sym_RPAREN] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2683),
    [anon_sym_PLUS] = ACTIONS(2683),
    [anon_sym_STAR] = ACTIONS(2685),
    [anon_sym_SLASH] = ACTIONS(2683),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_PIPE] = ACTIONS(2683),
    [anon_sym_CARET] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_EQ_EQ] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_GT] = ACTIONS(2683),
    [anon_sym_GT_EQ] = ACTIONS(2685),
    [anon_sym_LT_EQ] = ACTIONS(2683),
    [anon_sym_LT] = ACTIONS(2683),
    [anon_sym_LT_LT] = ACTIONS(2685),
    [anon_sym_GT_GT] = ACTIONS(2685),
    [anon_sym_COLON] = ACTIONS(6474),
    [anon_sym_SEMI] = ACTIONS(2685),
    [anon_sym___extension__] = ACTIONS(2685),
    [anon_sym___attribute__] = ACTIONS(6621),
    [anon_sym_LBRACE] = ACTIONS(6623),
    [anon_sym_RBRACE] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_RBRACK] = ACTIONS(2685),
    [anon_sym_const] = ACTIONS(2683),
    [anon_sym_constexpr] = ACTIONS(2685),
    [anon_sym_volatile] = ACTIONS(2685),
    [anon_sym_restrict] = ACTIONS(2685),
    [anon_sym___restrict__] = ACTIONS(2685),
    [anon_sym__Atomic] = ACTIONS(2685),
    [anon_sym__Noreturn] = ACTIONS(2685),
    [anon_sym_noreturn] = ACTIONS(2685),
    [anon_sym_mutable] = ACTIONS(2685),
    [anon_sym_constinit] = ACTIONS(2685),
    [anon_sym_consteval] = ACTIONS(2685),
    [anon_sym_alignas] = ACTIONS(2685),
    [anon_sym__Alignas] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_LT_EQ_GT] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [anon_sym_and] = ACTIONS(2685),
    [anon_sym_bitor] = ACTIONS(2685),
    [anon_sym_xor] = ACTIONS(2685),
    [anon_sym_bitand] = ACTIONS(2685),
    [anon_sym_not_eq] = ACTIONS(2685),
    [anon_sym_is] = ACTIONS(2685),
    [anon_sym_as] = ACTIONS(2685),
    [anon_sym_DASH_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_PLUS] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2683),
    [anon_sym_DOT_STAR] = ACTIONS(2685),
    [anon_sym_DASH_GT] = ACTIONS(2685),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_This] = ACTIONS(2685),
    [anon_sym_final] = ACTIONS(6625),
    [anon_sym_override] = ACTIONS(6625),
    [anon_sym_requires] = ACTIONS(2685),
    [anon_sym_where] = ACTIONS(2685),
  },
  [2980] = {
    [sym_string_literal] = STATE(3342),
    [sym_template_argument_list] = STATE(4579),
    [sym_raw_string_literal] = STATE(3342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(6611),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(6208),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_SEMI] = ACTIONS(2117),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6611),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_RBRACE] = ACTIONS(2117),
    [anon_sym_LBRACK] = ACTIONS(6613),
    [anon_sym_EQ] = ACTIONS(2152),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2154),
    [anon_sym_SLASH_EQ] = ACTIONS(2154),
    [anon_sym_PERCENT_EQ] = ACTIONS(2154),
    [anon_sym_PLUS_EQ] = ACTIONS(2154),
    [anon_sym_DASH_EQ] = ACTIONS(2154),
    [anon_sym_LT_LT_EQ] = ACTIONS(2154),
    [anon_sym_GT_GT_EQ] = ACTIONS(2154),
    [anon_sym_AMP_EQ] = ACTIONS(2154),
    [anon_sym_CARET_EQ] = ACTIONS(2154),
    [anon_sym_PIPE_EQ] = ACTIONS(2154),
    [anon_sym_and_eq] = ACTIONS(2154),
    [anon_sym_or_eq] = ACTIONS(2154),
    [anon_sym_xor_eq] = ACTIONS(2154),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2117),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2117),
    [anon_sym_not_eq] = ACTIONS(2117),
    [anon_sym_is] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
  },
  [2981] = {
    [sym_string_literal] = STATE(3342),
    [sym_template_argument_list] = STATE(4579),
    [sym_raw_string_literal] = STATE(3342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_RPAREN] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(6208),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_SEMI] = ACTIONS(2117),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_RBRACE] = ACTIONS(2117),
    [anon_sym_LBRACK] = ACTIONS(2117),
    [anon_sym_EQ] = ACTIONS(2152),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2154),
    [anon_sym_SLASH_EQ] = ACTIONS(2154),
    [anon_sym_PERCENT_EQ] = ACTIONS(2154),
    [anon_sym_PLUS_EQ] = ACTIONS(2154),
    [anon_sym_DASH_EQ] = ACTIONS(2154),
    [anon_sym_LT_LT_EQ] = ACTIONS(2154),
    [anon_sym_GT_GT_EQ] = ACTIONS(2154),
    [anon_sym_AMP_EQ] = ACTIONS(2154),
    [anon_sym_CARET_EQ] = ACTIONS(2154),
    [anon_sym_PIPE_EQ] = ACTIONS(2154),
    [anon_sym_and_eq] = ACTIONS(2154),
    [anon_sym_or_eq] = ACTIONS(2154),
    [anon_sym_xor_eq] = ACTIONS(2154),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2117),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2117),
    [anon_sym_not_eq] = ACTIONS(2117),
    [anon_sym_is] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
  },
  [2982] = {
    [sym_string_literal] = STATE(3342),
    [sym_template_argument_list] = STATE(4579),
    [sym_raw_string_literal] = STATE(3342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(6208),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON] = ACTIONS(6627),
    [anon_sym_SEMI] = ACTIONS(2117),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_RBRACE] = ACTIONS(2117),
    [anon_sym_LBRACK] = ACTIONS(2117),
    [anon_sym_EQ] = ACTIONS(2152),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2154),
    [anon_sym_SLASH_EQ] = ACTIONS(2154),
    [anon_sym_PERCENT_EQ] = ACTIONS(2154),
    [anon_sym_PLUS_EQ] = ACTIONS(2154),
    [anon_sym_DASH_EQ] = ACTIONS(2154),
    [anon_sym_LT_LT_EQ] = ACTIONS(2154),
    [anon_sym_GT_GT_EQ] = ACTIONS(2154),
    [anon_sym_AMP_EQ] = ACTIONS(2154),
    [anon_sym_CARET_EQ] = ACTIONS(2154),
    [anon_sym_PIPE_EQ] = ACTIONS(2154),
    [anon_sym_and_eq] = ACTIONS(2154),
    [anon_sym_or_eq] = ACTIONS(2154),
    [anon_sym_xor_eq] = ACTIONS(2154),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2117),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2117),
    [anon_sym_not_eq] = ACTIONS(2117),
    [anon_sym_is] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
  },
  [2983] = {
    [sym_attribute_specifier] = STATE(3081),
    [sym_enumerator_list] = STATE(3004),
    [sym_identifier] = ACTIONS(3715),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3717),
    [anon_sym_COMMA] = ACTIONS(3717),
    [anon_sym_RPAREN] = ACTIONS(3717),
    [aux_sym_preproc_if_token2] = ACTIONS(3717),
    [aux_sym_preproc_else_token1] = ACTIONS(3717),
    [aux_sym_preproc_elif_token1] = ACTIONS(3715),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3717),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3717),
    [anon_sym_LPAREN2] = ACTIONS(3717),
    [anon_sym_DASH] = ACTIONS(3715),
    [anon_sym_PLUS] = ACTIONS(3715),
    [anon_sym_STAR] = ACTIONS(3715),
    [anon_sym_SLASH] = ACTIONS(3715),
    [anon_sym_PERCENT] = ACTIONS(3715),
    [anon_sym_PIPE_PIPE] = ACTIONS(3717),
    [anon_sym_AMP_AMP] = ACTIONS(3717),
    [anon_sym_PIPE] = ACTIONS(3715),
    [anon_sym_CARET] = ACTIONS(3715),
    [anon_sym_AMP] = ACTIONS(3715),
    [anon_sym_EQ_EQ] = ACTIONS(3717),
    [anon_sym_BANG_EQ] = ACTIONS(3717),
    [anon_sym_GT] = ACTIONS(3715),
    [anon_sym_GT_EQ] = ACTIONS(3717),
    [anon_sym_LT_EQ] = ACTIONS(3715),
    [anon_sym_LT] = ACTIONS(3715),
    [anon_sym_LT_LT] = ACTIONS(3715),
    [anon_sym_GT_GT] = ACTIONS(3715),
    [anon_sym_COLON] = ACTIONS(3717),
    [anon_sym_SEMI] = ACTIONS(3717),
    [anon_sym___attribute__] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(6615),
    [anon_sym_RBRACE] = ACTIONS(3717),
    [anon_sym_LBRACK] = ACTIONS(3717),
    [anon_sym_RBRACK] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(3715),
    [anon_sym_QMARK] = ACTIONS(3717),
    [anon_sym_STAR_EQ] = ACTIONS(3717),
    [anon_sym_SLASH_EQ] = ACTIONS(3717),
    [anon_sym_PERCENT_EQ] = ACTIONS(3717),
    [anon_sym_PLUS_EQ] = ACTIONS(3717),
    [anon_sym_DASH_EQ] = ACTIONS(3717),
    [anon_sym_LT_LT_EQ] = ACTIONS(3717),
    [anon_sym_GT_GT_EQ] = ACTIONS(3717),
    [anon_sym_AMP_EQ] = ACTIONS(3717),
    [anon_sym_CARET_EQ] = ACTIONS(3717),
    [anon_sym_PIPE_EQ] = ACTIONS(3717),
    [anon_sym_and_eq] = ACTIONS(3715),
    [anon_sym_or_eq] = ACTIONS(3715),
    [anon_sym_xor_eq] = ACTIONS(3715),
    [anon_sym_LT_EQ_GT] = ACTIONS(3717),
    [anon_sym_or] = ACTIONS(3715),
    [anon_sym_and] = ACTIONS(3715),
    [anon_sym_bitor] = ACTIONS(3715),
    [anon_sym_xor] = ACTIONS(3715),
    [anon_sym_bitand] = ACTIONS(3715),
    [anon_sym_not_eq] = ACTIONS(3715),
    [anon_sym_is] = ACTIONS(3715),
    [anon_sym_as] = ACTIONS(3715),
    [anon_sym_DASH_DASH] = ACTIONS(3717),
    [anon_sym_PLUS_PLUS] = ACTIONS(3717),
    [anon_sym_DOT] = ACTIONS(3715),
    [anon_sym_DOT_STAR] = ACTIONS(3717),
    [anon_sym_DASH_GT] = ACTIONS(3717),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3715),
    [anon_sym_let] = ACTIONS(3715),
    [anon_sym_This] = ACTIONS(3715),
  },
  [2984] = {
    [sym_identifier] = ACTIONS(6132),
    [anon_sym___extension__] = ACTIONS(6132),
    [anon_sym_typedef] = ACTIONS(6629),
    [anon_sym_in] = ACTIONS(6132),
    [anon_sym_out] = ACTIONS(6132),
    [anon_sym_inout] = ACTIONS(6132),
    [anon_sym_extern] = ACTIONS(6132),
    [anon_sym___attribute__] = ACTIONS(6132),
    [anon_sym_COLON_COLON] = ACTIONS(6134),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6134),
    [anon_sym___declspec] = ACTIONS(6132),
    [anon_sym_signed] = ACTIONS(6132),
    [anon_sym_unsigned] = ACTIONS(6132),
    [anon_sym_long] = ACTIONS(6132),
    [anon_sym_short] = ACTIONS(6132),
    [anon_sym_static] = ACTIONS(6132),
    [anon_sym_register] = ACTIONS(6132),
    [anon_sym_inline] = ACTIONS(6132),
    [anon_sym___inline] = ACTIONS(6132),
    [anon_sym___inline__] = ACTIONS(6132),
    [anon_sym___forceinline] = ACTIONS(6132),
    [anon_sym_thread_local] = ACTIONS(6132),
    [anon_sym___thread] = ACTIONS(6132),
    [anon_sym_const] = ACTIONS(6132),
    [anon_sym_constexpr] = ACTIONS(6132),
    [anon_sym_volatile] = ACTIONS(6132),
    [anon_sym_restrict] = ACTIONS(6132),
    [anon_sym___restrict__] = ACTIONS(6132),
    [anon_sym__Atomic] = ACTIONS(6132),
    [anon_sym__Noreturn] = ACTIONS(6132),
    [anon_sym_noreturn] = ACTIONS(6132),
    [anon_sym_mutable] = ACTIONS(6132),
    [anon_sym_constinit] = ACTIONS(6132),
    [anon_sym_consteval] = ACTIONS(6132),
    [anon_sym_alignas] = ACTIONS(6132),
    [anon_sym__Alignas] = ACTIONS(6132),
    [sym_primitive_type] = ACTIONS(6132),
    [anon_sym_enum] = ACTIONS(6132),
    [anon_sym_class] = ACTIONS(6132),
    [anon_sym_struct] = ACTIONS(6132),
    [anon_sym_union] = ACTIONS(6132),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6132),
    [anon_sym_let] = ACTIONS(6132),
    [anon_sym_This] = ACTIONS(6132),
    [anon_sym_decltype] = ACTIONS(6132),
    [sym_virtual] = ACTIONS(6132),
    [anon_sym_typename] = ACTIONS(6132),
    [anon_sym_template] = ACTIONS(6132),
    [anon_sym_precise] = ACTIONS(6132),
    [anon_sym_shared] = ACTIONS(6132),
    [anon_sym_groupshared] = ACTIONS(6132),
    [anon_sym_uniform] = ACTIONS(6132),
    [anon_sym_row_major] = ACTIONS(6132),
    [anon_sym_column_major] = ACTIONS(6132),
    [anon_sym_globallycoherent] = ACTIONS(6132),
    [anon_sym_centroid] = ACTIONS(6132),
    [anon_sym_noperspective] = ACTIONS(6132),
    [anon_sym_nointerpolation] = ACTIONS(6132),
    [anon_sym_sample] = ACTIONS(6132),
    [anon_sym_linear] = ACTIONS(6132),
    [anon_sym_snorm] = ACTIONS(6132),
    [anon_sym_unorm] = ACTIONS(6132),
    [anon_sym_point] = ACTIONS(6132),
    [anon_sym_line] = ACTIONS(6132),
    [anon_sym_triangleadj] = ACTIONS(6132),
    [anon_sym_lineadj] = ACTIONS(6132),
    [anon_sym_triangle] = ACTIONS(6132),
    [anon_sym_interface] = ACTIONS(6132),
    [anon_sym_extension] = ACTIONS(6132),
  },
  [2985] = {
    [sym_string_literal] = STATE(2792),
    [sym_raw_string_literal] = STATE(2792),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_RPAREN] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(2128),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON] = ACTIONS(2117),
    [anon_sym_SEMI] = ACTIONS(2117),
    [anon_sym_RBRACE] = ACTIONS(2117),
    [anon_sym_LBRACK] = ACTIONS(2117),
    [anon_sym_RBRACK] = ACTIONS(2117),
    [anon_sym_EQ] = ACTIONS(2128),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2117),
    [anon_sym_SLASH_EQ] = ACTIONS(2117),
    [anon_sym_PERCENT_EQ] = ACTIONS(2117),
    [anon_sym_PLUS_EQ] = ACTIONS(2117),
    [anon_sym_DASH_EQ] = ACTIONS(2117),
    [anon_sym_LT_LT_EQ] = ACTIONS(2117),
    [anon_sym_GT_GT_EQ] = ACTIONS(2117),
    [anon_sym_AMP_EQ] = ACTIONS(2117),
    [anon_sym_CARET_EQ] = ACTIONS(2117),
    [anon_sym_PIPE_EQ] = ACTIONS(2117),
    [anon_sym_and_eq] = ACTIONS(2128),
    [anon_sym_or_eq] = ACTIONS(2128),
    [anon_sym_xor_eq] = ACTIONS(2128),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2128),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2128),
    [anon_sym_not_eq] = ACTIONS(2128),
    [anon_sym_is] = ACTIONS(2128),
    [anon_sym_as] = ACTIONS(2128),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(4436),
    [anon_sym_u_DQUOTE] = ACTIONS(4436),
    [anon_sym_U_DQUOTE] = ACTIONS(4436),
    [anon_sym_u8_DQUOTE] = ACTIONS(4436),
    [anon_sym_DQUOTE] = ACTIONS(4436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4444),
    [anon_sym_LR_DQUOTE] = ACTIONS(4444),
    [anon_sym_uR_DQUOTE] = ACTIONS(4444),
    [anon_sym_UR_DQUOTE] = ACTIONS(4444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4444),
    [sym_literal_suffix] = ACTIONS(6592),
  },
  [2986] = {
    [sym_attribute_specifier] = STATE(3075),
    [sym_identifier] = ACTIONS(3746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3748),
    [anon_sym_COMMA] = ACTIONS(3748),
    [anon_sym_RPAREN] = ACTIONS(3748),
    [aux_sym_preproc_if_token2] = ACTIONS(3748),
    [aux_sym_preproc_else_token1] = ACTIONS(3748),
    [aux_sym_preproc_elif_token1] = ACTIONS(3746),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3748),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3748),
    [anon_sym_LPAREN2] = ACTIONS(3748),
    [anon_sym_DASH] = ACTIONS(3746),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_STAR] = ACTIONS(3746),
    [anon_sym_SLASH] = ACTIONS(3746),
    [anon_sym_PERCENT] = ACTIONS(3746),
    [anon_sym_PIPE_PIPE] = ACTIONS(3748),
    [anon_sym_AMP_AMP] = ACTIONS(3748),
    [anon_sym_PIPE] = ACTIONS(3746),
    [anon_sym_CARET] = ACTIONS(3746),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_EQ_EQ] = ACTIONS(3748),
    [anon_sym_BANG_EQ] = ACTIONS(3748),
    [anon_sym_GT] = ACTIONS(3746),
    [anon_sym_GT_EQ] = ACTIONS(3748),
    [anon_sym_LT_EQ] = ACTIONS(3746),
    [anon_sym_LT] = ACTIONS(3746),
    [anon_sym_LT_LT] = ACTIONS(3746),
    [anon_sym_GT_GT] = ACTIONS(3746),
    [anon_sym_COLON] = ACTIONS(3748),
    [anon_sym_SEMI] = ACTIONS(3748),
    [anon_sym___attribute__] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(3748),
    [anon_sym_RBRACE] = ACTIONS(3748),
    [anon_sym_LBRACK] = ACTIONS(3748),
    [anon_sym_RBRACK] = ACTIONS(3748),
    [anon_sym_EQ] = ACTIONS(3746),
    [anon_sym_QMARK] = ACTIONS(3748),
    [anon_sym_STAR_EQ] = ACTIONS(3748),
    [anon_sym_SLASH_EQ] = ACTIONS(3748),
    [anon_sym_PERCENT_EQ] = ACTIONS(3748),
    [anon_sym_PLUS_EQ] = ACTIONS(3748),
    [anon_sym_DASH_EQ] = ACTIONS(3748),
    [anon_sym_LT_LT_EQ] = ACTIONS(3748),
    [anon_sym_GT_GT_EQ] = ACTIONS(3748),
    [anon_sym_AMP_EQ] = ACTIONS(3748),
    [anon_sym_CARET_EQ] = ACTIONS(3748),
    [anon_sym_PIPE_EQ] = ACTIONS(3748),
    [anon_sym_and_eq] = ACTIONS(3746),
    [anon_sym_or_eq] = ACTIONS(3746),
    [anon_sym_xor_eq] = ACTIONS(3746),
    [anon_sym_LT_EQ_GT] = ACTIONS(3748),
    [anon_sym_or] = ACTIONS(3746),
    [anon_sym_and] = ACTIONS(3746),
    [anon_sym_bitor] = ACTIONS(3746),
    [anon_sym_xor] = ACTIONS(3746),
    [anon_sym_bitand] = ACTIONS(3746),
    [anon_sym_not_eq] = ACTIONS(3746),
    [anon_sym_is] = ACTIONS(3746),
    [anon_sym_as] = ACTIONS(3746),
    [anon_sym_DASH_DASH] = ACTIONS(3748),
    [anon_sym_PLUS_PLUS] = ACTIONS(3748),
    [anon_sym_DOT] = ACTIONS(3746),
    [anon_sym_DOT_STAR] = ACTIONS(3748),
    [anon_sym_DASH_GT] = ACTIONS(3748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3746),
    [anon_sym_let] = ACTIONS(3746),
    [anon_sym_This] = ACTIONS(3746),
  },
  [2987] = {
    [sym_identifier] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(2982),
    [anon_sym_in] = ACTIONS(2982),
    [anon_sym_out] = ACTIONS(2982),
    [anon_sym_inout] = ACTIONS(2982),
    [anon_sym_extern] = ACTIONS(2982),
    [anon_sym___attribute__] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2984),
    [anon_sym___declspec] = ACTIONS(2982),
    [anon_sym_signed] = ACTIONS(2982),
    [anon_sym_unsigned] = ACTIONS(2982),
    [anon_sym_long] = ACTIONS(2982),
    [anon_sym_short] = ACTIONS(2982),
    [anon_sym_static] = ACTIONS(2982),
    [anon_sym_register] = ACTIONS(2982),
    [anon_sym_inline] = ACTIONS(2982),
    [anon_sym___inline] = ACTIONS(2982),
    [anon_sym___inline__] = ACTIONS(2982),
    [anon_sym___forceinline] = ACTIONS(2982),
    [anon_sym_thread_local] = ACTIONS(2982),
    [anon_sym___thread] = ACTIONS(2982),
    [anon_sym_const] = ACTIONS(2982),
    [anon_sym_constexpr] = ACTIONS(2982),
    [anon_sym_volatile] = ACTIONS(2982),
    [anon_sym_restrict] = ACTIONS(2982),
    [anon_sym___restrict__] = ACTIONS(2982),
    [anon_sym__Atomic] = ACTIONS(2982),
    [anon_sym__Noreturn] = ACTIONS(2982),
    [anon_sym_noreturn] = ACTIONS(2982),
    [anon_sym_mutable] = ACTIONS(2982),
    [anon_sym_constinit] = ACTIONS(2982),
    [anon_sym_consteval] = ACTIONS(2982),
    [anon_sym_alignas] = ACTIONS(2982),
    [anon_sym__Alignas] = ACTIONS(2982),
    [sym_primitive_type] = ACTIONS(2982),
    [anon_sym_enum] = ACTIONS(2982),
    [anon_sym_class] = ACTIONS(2982),
    [anon_sym_struct] = ACTIONS(2982),
    [anon_sym_union] = ACTIONS(2982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2982),
    [anon_sym_let] = ACTIONS(2982),
    [anon_sym_This] = ACTIONS(2982),
    [anon_sym_decltype] = ACTIONS(2982),
    [sym_virtual] = ACTIONS(2982),
    [anon_sym_typename] = ACTIONS(2982),
    [anon_sym_template] = ACTIONS(2982),
    [anon_sym_precise] = ACTIONS(2982),
    [anon_sym_shared] = ACTIONS(2982),
    [anon_sym_groupshared] = ACTIONS(2982),
    [anon_sym_uniform] = ACTIONS(2982),
    [anon_sym_row_major] = ACTIONS(2982),
    [anon_sym_column_major] = ACTIONS(2982),
    [anon_sym_globallycoherent] = ACTIONS(2982),
    [anon_sym_centroid] = ACTIONS(2982),
    [anon_sym_noperspective] = ACTIONS(2982),
    [anon_sym_nointerpolation] = ACTIONS(2982),
    [anon_sym_sample] = ACTIONS(2982),
    [anon_sym_linear] = ACTIONS(2982),
    [anon_sym_snorm] = ACTIONS(2982),
    [anon_sym_unorm] = ACTIONS(2982),
    [anon_sym_point] = ACTIONS(2982),
    [anon_sym_line] = ACTIONS(2982),
    [anon_sym_triangleadj] = ACTIONS(2982),
    [anon_sym_lineadj] = ACTIONS(2982),
    [anon_sym_triangle] = ACTIONS(2982),
    [anon_sym_interface] = ACTIONS(2982),
    [anon_sym_extension] = ACTIONS(2982),
  },
  [2988] = {
    [sym_template_argument_list] = STATE(2944),
    [sym_identifier] = ACTIONS(2169),
    [anon_sym_LPAREN2] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_STAR] = ACTIONS(2176),
    [anon_sym_AMP_AMP] = ACTIONS(2176),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(6343),
    [anon_sym_SEMI] = ACTIONS(2171),
    [anon_sym___extension__] = ACTIONS(2169),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_out] = ACTIONS(2169),
    [anon_sym_inout] = ACTIONS(2169),
    [anon_sym_extern] = ACTIONS(2169),
    [anon_sym___attribute__] = ACTIONS(2169),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2173),
    [anon_sym___declspec] = ACTIONS(2169),
    [anon_sym___based] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2169),
    [anon_sym_register] = ACTIONS(2169),
    [anon_sym_inline] = ACTIONS(2169),
    [anon_sym___inline] = ACTIONS(2169),
    [anon_sym___inline__] = ACTIONS(2169),
    [anon_sym___forceinline] = ACTIONS(2169),
    [anon_sym_thread_local] = ACTIONS(2169),
    [anon_sym___thread] = ACTIONS(2169),
    [anon_sym_const] = ACTIONS(2169),
    [anon_sym_constexpr] = ACTIONS(2169),
    [anon_sym_volatile] = ACTIONS(2169),
    [anon_sym_restrict] = ACTIONS(2169),
    [anon_sym___restrict__] = ACTIONS(2169),
    [anon_sym__Atomic] = ACTIONS(2169),
    [anon_sym__Noreturn] = ACTIONS(2169),
    [anon_sym_noreturn] = ACTIONS(2169),
    [anon_sym_mutable] = ACTIONS(2169),
    [anon_sym_constinit] = ACTIONS(2169),
    [anon_sym_consteval] = ACTIONS(2169),
    [anon_sym_alignas] = ACTIONS(2169),
    [anon_sym__Alignas] = ACTIONS(2169),
    [anon_sym_DOT] = ACTIONS(2176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2169),
    [anon_sym_let] = ACTIONS(2169),
    [anon_sym_This] = ACTIONS(2169),
    [anon_sym_decltype] = ACTIONS(2169),
    [sym_virtual] = ACTIONS(2169),
    [anon_sym_template] = ACTIONS(2169),
    [anon_sym_operator] = ACTIONS(2169),
    [anon_sym_precise] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_groupshared] = ACTIONS(2169),
    [anon_sym_uniform] = ACTIONS(2169),
    [anon_sym_row_major] = ACTIONS(2169),
    [anon_sym_column_major] = ACTIONS(2169),
    [anon_sym_globallycoherent] = ACTIONS(2169),
    [anon_sym_centroid] = ACTIONS(2169),
    [anon_sym_noperspective] = ACTIONS(2169),
    [anon_sym_nointerpolation] = ACTIONS(2169),
    [anon_sym_sample] = ACTIONS(2169),
    [anon_sym_linear] = ACTIONS(2169),
    [anon_sym_snorm] = ACTIONS(2169),
    [anon_sym_unorm] = ACTIONS(2169),
    [anon_sym_point] = ACTIONS(2169),
    [anon_sym_line] = ACTIONS(2169),
    [anon_sym_triangleadj] = ACTIONS(2169),
    [anon_sym_lineadj] = ACTIONS(2169),
    [anon_sym_triangle] = ACTIONS(2169),
  },
  [2989] = {
    [sym_template_argument_list] = STATE(2955),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3044),
    [sym_identifier] = ACTIONS(2115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2123),
    [anon_sym_COMMA] = ACTIONS(2123),
    [aux_sym_preproc_if_token2] = ACTIONS(2123),
    [aux_sym_preproc_else_token1] = ACTIONS(2123),
    [aux_sym_preproc_elif_token1] = ACTIONS(2115),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2123),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2123),
    [anon_sym_LPAREN2] = ACTIONS(2123),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2115),
    [anon_sym_SLASH] = ACTIONS(2115),
    [anon_sym_PERCENT] = ACTIONS(2115),
    [anon_sym_PIPE_PIPE] = ACTIONS(2123),
    [anon_sym_AMP_AMP] = ACTIONS(2123),
    [anon_sym_PIPE] = ACTIONS(2115),
    [anon_sym_CARET] = ACTIONS(2115),
    [anon_sym_AMP] = ACTIONS(2115),
    [anon_sym_EQ_EQ] = ACTIONS(2123),
    [anon_sym_BANG_EQ] = ACTIONS(2123),
    [anon_sym_GT] = ACTIONS(2115),
    [anon_sym_GT_EQ] = ACTIONS(2123),
    [anon_sym_LT_EQ] = ACTIONS(2115),
    [anon_sym_LT] = ACTIONS(6560),
    [anon_sym_LT_LT] = ACTIONS(2115),
    [anon_sym_GT_GT] = ACTIONS(2115),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_signed] = ACTIONS(6617),
    [anon_sym_unsigned] = ACTIONS(6617),
    [anon_sym_long] = ACTIONS(6617),
    [anon_sym_short] = ACTIONS(6617),
    [anon_sym_LBRACK] = ACTIONS(2123),
    [anon_sym_EQ] = ACTIONS(2115),
    [anon_sym_QMARK] = ACTIONS(2123),
    [anon_sym_STAR_EQ] = ACTIONS(2123),
    [anon_sym_SLASH_EQ] = ACTIONS(2123),
    [anon_sym_PERCENT_EQ] = ACTIONS(2123),
    [anon_sym_PLUS_EQ] = ACTIONS(2123),
    [anon_sym_DASH_EQ] = ACTIONS(2123),
    [anon_sym_LT_LT_EQ] = ACTIONS(2123),
    [anon_sym_GT_GT_EQ] = ACTIONS(2123),
    [anon_sym_AMP_EQ] = ACTIONS(2123),
    [anon_sym_CARET_EQ] = ACTIONS(2123),
    [anon_sym_PIPE_EQ] = ACTIONS(2123),
    [anon_sym_and_eq] = ACTIONS(2115),
    [anon_sym_or_eq] = ACTIONS(2115),
    [anon_sym_xor_eq] = ACTIONS(2115),
    [anon_sym_LT_EQ_GT] = ACTIONS(2123),
    [anon_sym_or] = ACTIONS(2115),
    [anon_sym_and] = ACTIONS(2115),
    [anon_sym_bitor] = ACTIONS(2115),
    [anon_sym_xor] = ACTIONS(2115),
    [anon_sym_bitand] = ACTIONS(2115),
    [anon_sym_not_eq] = ACTIONS(2115),
    [anon_sym_is] = ACTIONS(2115),
    [anon_sym_as] = ACTIONS(2115),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DOT] = ACTIONS(2115),
    [anon_sym_DOT_STAR] = ACTIONS(2123),
    [anon_sym_DASH_GT] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2115),
    [anon_sym_let] = ACTIONS(2115),
    [anon_sym_This] = ACTIONS(2115),
  },
  [2990] = {
    [sym_template_argument_list] = STATE(2816),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3485),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_RPAREN] = ACTIONS(3485),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_STAR] = ACTIONS(3483),
    [anon_sym_SLASH] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3485),
    [anon_sym_AMP_AMP] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(3483),
    [anon_sym_CARET] = ACTIONS(3483),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_EQ_EQ] = ACTIONS(3485),
    [anon_sym_BANG_EQ] = ACTIONS(3485),
    [anon_sym_GT] = ACTIONS(3483),
    [anon_sym_GT_EQ] = ACTIONS(3485),
    [anon_sym_LT_EQ] = ACTIONS(3483),
    [anon_sym_LT] = ACTIONS(3483),
    [anon_sym_LT_LT] = ACTIONS(3483),
    [anon_sym_GT_GT] = ACTIONS(3483),
    [anon_sym_COLON] = ACTIONS(3483),
    [anon_sym_SEMI] = ACTIONS(3485),
    [anon_sym___attribute__] = ACTIONS(3485),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(3485),
    [anon_sym_RBRACE] = ACTIONS(3485),
    [anon_sym_signed] = ACTIONS(6631),
    [anon_sym_unsigned] = ACTIONS(6631),
    [anon_sym_long] = ACTIONS(6631),
    [anon_sym_short] = ACTIONS(6631),
    [anon_sym_LBRACK] = ACTIONS(3485),
    [anon_sym_RBRACK] = ACTIONS(3485),
    [anon_sym_EQ] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3485),
    [anon_sym_STAR_EQ] = ACTIONS(3485),
    [anon_sym_SLASH_EQ] = ACTIONS(3485),
    [anon_sym_PERCENT_EQ] = ACTIONS(3485),
    [anon_sym_PLUS_EQ] = ACTIONS(3485),
    [anon_sym_DASH_EQ] = ACTIONS(3485),
    [anon_sym_LT_LT_EQ] = ACTIONS(3485),
    [anon_sym_GT_GT_EQ] = ACTIONS(3485),
    [anon_sym_AMP_EQ] = ACTIONS(3485),
    [anon_sym_CARET_EQ] = ACTIONS(3485),
    [anon_sym_PIPE_EQ] = ACTIONS(3485),
    [anon_sym_and_eq] = ACTIONS(3485),
    [anon_sym_or_eq] = ACTIONS(3485),
    [anon_sym_xor_eq] = ACTIONS(3485),
    [anon_sym_LT_EQ_GT] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [anon_sym_and] = ACTIONS(3483),
    [anon_sym_bitor] = ACTIONS(3485),
    [anon_sym_xor] = ACTIONS(3483),
    [anon_sym_bitand] = ACTIONS(3485),
    [anon_sym_not_eq] = ACTIONS(3485),
    [anon_sym_is] = ACTIONS(3485),
    [anon_sym_as] = ACTIONS(3485),
    [anon_sym_DASH_DASH] = ACTIONS(3485),
    [anon_sym_PLUS_PLUS] = ACTIONS(3485),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_DOT_STAR] = ACTIONS(3485),
    [anon_sym_DASH_GT] = ACTIONS(3485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3485),
    [anon_sym_let] = ACTIONS(3485),
    [anon_sym_This] = ACTIONS(3485),
  },
  [2991] = {
    [sym_string_literal] = STATE(2997),
    [sym_template_argument_list] = STATE(3706),
    [sym_raw_string_literal] = STATE(2997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_RPAREN] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(6173),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2117),
    [anon_sym_EQ] = ACTIONS(2128),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2117),
    [anon_sym_SLASH_EQ] = ACTIONS(2117),
    [anon_sym_PERCENT_EQ] = ACTIONS(2117),
    [anon_sym_PLUS_EQ] = ACTIONS(2117),
    [anon_sym_DASH_EQ] = ACTIONS(2117),
    [anon_sym_LT_LT_EQ] = ACTIONS(2117),
    [anon_sym_GT_GT_EQ] = ACTIONS(2117),
    [anon_sym_AMP_EQ] = ACTIONS(2117),
    [anon_sym_CARET_EQ] = ACTIONS(2117),
    [anon_sym_PIPE_EQ] = ACTIONS(2117),
    [anon_sym_and_eq] = ACTIONS(2117),
    [anon_sym_or_eq] = ACTIONS(2117),
    [anon_sym_xor_eq] = ACTIONS(2117),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2117),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2117),
    [anon_sym_not_eq] = ACTIONS(2117),
    [anon_sym_is] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2128),
    [anon_sym_L_DQUOTE] = ACTIONS(6169),
    [anon_sym_u_DQUOTE] = ACTIONS(6169),
    [anon_sym_U_DQUOTE] = ACTIONS(6169),
    [anon_sym_u8_DQUOTE] = ACTIONS(6169),
    [anon_sym_DQUOTE] = ACTIONS(6169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6171),
    [anon_sym_LR_DQUOTE] = ACTIONS(6171),
    [anon_sym_uR_DQUOTE] = ACTIONS(6171),
    [anon_sym_UR_DQUOTE] = ACTIONS(6171),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6171),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2117),
  },
  [2992] = {
    [sym_template_argument_list] = STATE(2955),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2123),
    [anon_sym_COMMA] = ACTIONS(2123),
    [anon_sym_RPAREN] = ACTIONS(2123),
    [anon_sym_LPAREN2] = ACTIONS(2123),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2115),
    [anon_sym_SLASH] = ACTIONS(2115),
    [anon_sym_PERCENT] = ACTIONS(2115),
    [anon_sym_PIPE_PIPE] = ACTIONS(2123),
    [anon_sym_AMP_AMP] = ACTIONS(2123),
    [anon_sym_PIPE] = ACTIONS(2115),
    [anon_sym_CARET] = ACTIONS(2115),
    [anon_sym_AMP] = ACTIONS(2115),
    [anon_sym_EQ_EQ] = ACTIONS(2123),
    [anon_sym_BANG_EQ] = ACTIONS(2123),
    [anon_sym_GT] = ACTIONS(2115),
    [anon_sym_GT_EQ] = ACTIONS(2123),
    [anon_sym_LT_EQ] = ACTIONS(2115),
    [anon_sym_LT] = ACTIONS(6560),
    [anon_sym_LT_LT] = ACTIONS(2115),
    [anon_sym_GT_GT] = ACTIONS(2115),
    [anon_sym_COLON] = ACTIONS(2115),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym___attribute__] = ACTIONS(2123),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_signed] = ACTIONS(6631),
    [anon_sym_unsigned] = ACTIONS(6631),
    [anon_sym_long] = ACTIONS(6631),
    [anon_sym_short] = ACTIONS(6631),
    [anon_sym_LBRACK] = ACTIONS(2123),
    [anon_sym_RBRACK] = ACTIONS(2123),
    [anon_sym_EQ] = ACTIONS(2115),
    [anon_sym_QMARK] = ACTIONS(2123),
    [anon_sym_STAR_EQ] = ACTIONS(2123),
    [anon_sym_SLASH_EQ] = ACTIONS(2123),
    [anon_sym_PERCENT_EQ] = ACTIONS(2123),
    [anon_sym_PLUS_EQ] = ACTIONS(2123),
    [anon_sym_DASH_EQ] = ACTIONS(2123),
    [anon_sym_LT_LT_EQ] = ACTIONS(2123),
    [anon_sym_GT_GT_EQ] = ACTIONS(2123),
    [anon_sym_AMP_EQ] = ACTIONS(2123),
    [anon_sym_CARET_EQ] = ACTIONS(2123),
    [anon_sym_PIPE_EQ] = ACTIONS(2123),
    [anon_sym_and_eq] = ACTIONS(2123),
    [anon_sym_or_eq] = ACTIONS(2123),
    [anon_sym_xor_eq] = ACTIONS(2123),
    [anon_sym_LT_EQ_GT] = ACTIONS(2123),
    [anon_sym_or] = ACTIONS(2115),
    [anon_sym_and] = ACTIONS(2115),
    [anon_sym_bitor] = ACTIONS(2123),
    [anon_sym_xor] = ACTIONS(2115),
    [anon_sym_bitand] = ACTIONS(2123),
    [anon_sym_not_eq] = ACTIONS(2123),
    [anon_sym_is] = ACTIONS(2123),
    [anon_sym_as] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DOT] = ACTIONS(2115),
    [anon_sym_DOT_STAR] = ACTIONS(2123),
    [anon_sym_DASH_GT] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2123),
    [anon_sym_let] = ACTIONS(2123),
    [anon_sym_This] = ACTIONS(2123),
  },
  [2993] = {
    [sym_string_literal] = STATE(3165),
    [sym_template_argument_list] = STATE(4558),
    [sym_raw_string_literal] = STATE(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_RPAREN] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(6633),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2117),
    [anon_sym_EQ] = ACTIONS(2128),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2117),
    [anon_sym_SLASH_EQ] = ACTIONS(2117),
    [anon_sym_PERCENT_EQ] = ACTIONS(2117),
    [anon_sym_PLUS_EQ] = ACTIONS(2117),
    [anon_sym_DASH_EQ] = ACTIONS(2117),
    [anon_sym_LT_LT_EQ] = ACTIONS(2117),
    [anon_sym_GT_GT_EQ] = ACTIONS(2117),
    [anon_sym_AMP_EQ] = ACTIONS(2117),
    [anon_sym_CARET_EQ] = ACTIONS(2117),
    [anon_sym_PIPE_EQ] = ACTIONS(2117),
    [anon_sym_and_eq] = ACTIONS(6636),
    [anon_sym_or_eq] = ACTIONS(6636),
    [anon_sym_xor_eq] = ACTIONS(6636),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2117),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2117),
    [anon_sym_not_eq] = ACTIONS(2117),
    [anon_sym_is] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2128),
    [anon_sym_L_DQUOTE] = ACTIONS(4918),
    [anon_sym_u_DQUOTE] = ACTIONS(4918),
    [anon_sym_U_DQUOTE] = ACTIONS(4918),
    [anon_sym_u8_DQUOTE] = ACTIONS(4918),
    [anon_sym_DQUOTE] = ACTIONS(4918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4920),
    [anon_sym_LR_DQUOTE] = ACTIONS(4920),
    [anon_sym_uR_DQUOTE] = ACTIONS(4920),
    [anon_sym_UR_DQUOTE] = ACTIONS(4920),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4920),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2117),
  },
  [2994] = {
    [sym_identifier] = ACTIONS(6132),
    [anon_sym_LPAREN2] = ACTIONS(6134),
    [anon_sym_BANG] = ACTIONS(6134),
    [anon_sym_TILDE] = ACTIONS(6134),
    [anon_sym_DASH] = ACTIONS(6132),
    [anon_sym_PLUS] = ACTIONS(6132),
    [anon_sym_STAR] = ACTIONS(6134),
    [anon_sym_AMP] = ACTIONS(6134),
    [anon_sym___extension__] = ACTIONS(6132),
    [anon_sym_COLON_COLON] = ACTIONS(6134),
    [anon_sym_LBRACK] = ACTIONS(6134),
    [anon_sym_static] = ACTIONS(6132),
    [anon_sym_RBRACK] = ACTIONS(6134),
    [anon_sym_const] = ACTIONS(6132),
    [anon_sym_constexpr] = ACTIONS(6132),
    [anon_sym_volatile] = ACTIONS(6132),
    [anon_sym_restrict] = ACTIONS(6132),
    [anon_sym___restrict__] = ACTIONS(6132),
    [anon_sym__Atomic] = ACTIONS(6132),
    [anon_sym__Noreturn] = ACTIONS(6132),
    [anon_sym_noreturn] = ACTIONS(6132),
    [anon_sym_mutable] = ACTIONS(6132),
    [anon_sym_constinit] = ACTIONS(6132),
    [anon_sym_consteval] = ACTIONS(6132),
    [anon_sym_alignas] = ACTIONS(6132),
    [anon_sym__Alignas] = ACTIONS(6132),
    [sym_primitive_type] = ACTIONS(6132),
    [anon_sym_not] = ACTIONS(6132),
    [anon_sym_compl] = ACTIONS(6132),
    [anon_sym_DASH_DASH] = ACTIONS(6134),
    [anon_sym_PLUS_PLUS] = ACTIONS(6134),
    [anon_sym_sizeof] = ACTIONS(6132),
    [anon_sym___alignof__] = ACTIONS(6132),
    [anon_sym___alignof] = ACTIONS(6132),
    [anon_sym__alignof] = ACTIONS(6132),
    [anon_sym_alignof] = ACTIONS(6132),
    [anon_sym__Alignof] = ACTIONS(6132),
    [anon_sym_offsetof] = ACTIONS(6132),
    [anon_sym__Generic] = ACTIONS(6132),
    [anon_sym_asm] = ACTIONS(6132),
    [anon_sym___asm__] = ACTIONS(6132),
    [sym_number_literal] = ACTIONS(6134),
    [anon_sym_L_SQUOTE] = ACTIONS(6134),
    [anon_sym_u_SQUOTE] = ACTIONS(6134),
    [anon_sym_U_SQUOTE] = ACTIONS(6134),
    [anon_sym_u8_SQUOTE] = ACTIONS(6134),
    [anon_sym_SQUOTE] = ACTIONS(6134),
    [anon_sym_L_DQUOTE] = ACTIONS(6134),
    [anon_sym_u_DQUOTE] = ACTIONS(6134),
    [anon_sym_U_DQUOTE] = ACTIONS(6134),
    [anon_sym_u8_DQUOTE] = ACTIONS(6134),
    [anon_sym_DQUOTE] = ACTIONS(6134),
    [sym_true] = ACTIONS(6132),
    [sym_false] = ACTIONS(6132),
    [anon_sym_NULL] = ACTIONS(6132),
    [anon_sym_nullptr] = ACTIONS(6132),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(6132),
    [anon_sym_template] = ACTIONS(6132),
    [anon_sym_delete] = ACTIONS(6132),
    [anon_sym_R_DQUOTE] = ACTIONS(6134),
    [anon_sym_LR_DQUOTE] = ACTIONS(6134),
    [anon_sym_uR_DQUOTE] = ACTIONS(6134),
    [anon_sym_UR_DQUOTE] = ACTIONS(6134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6134),
    [anon_sym_co_await] = ACTIONS(6132),
    [anon_sym_new] = ACTIONS(6132),
    [anon_sym_requires] = ACTIONS(6132),
    [sym_this] = ACTIONS(6132),
  },
  [2995] = {
    [sym_string_literal] = STATE(3342),
    [sym_template_argument_list] = STATE(4579),
    [sym_raw_string_literal] = STATE(3342),
    [aux_sym_structured_binding_declarator_repeat1] = STATE(8986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(6638),
    [anon_sym_LPAREN2] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(6208),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2117),
    [anon_sym_RBRACK] = ACTIONS(6640),
    [anon_sym_EQ] = ACTIONS(6643),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(6645),
    [anon_sym_SLASH_EQ] = ACTIONS(6645),
    [anon_sym_PERCENT_EQ] = ACTIONS(6645),
    [anon_sym_PLUS_EQ] = ACTIONS(6645),
    [anon_sym_DASH_EQ] = ACTIONS(6645),
    [anon_sym_LT_LT_EQ] = ACTIONS(6645),
    [anon_sym_GT_GT_EQ] = ACTIONS(6645),
    [anon_sym_AMP_EQ] = ACTIONS(6645),
    [anon_sym_CARET_EQ] = ACTIONS(6645),
    [anon_sym_PIPE_EQ] = ACTIONS(6645),
    [anon_sym_and_eq] = ACTIONS(6645),
    [anon_sym_or_eq] = ACTIONS(6645),
    [anon_sym_xor_eq] = ACTIONS(6645),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2117),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2117),
    [anon_sym_not_eq] = ACTIONS(2117),
    [anon_sym_is] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
  },
  [2996] = {
    [sym_string_literal] = STATE(3814),
    [sym_template_argument_list] = STATE(4579),
    [sym_raw_string_literal] = STATE(3814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(6208),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_SEMI] = ACTIONS(2117),
    [anon_sym___attribute__] = ACTIONS(2117),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2117),
    [anon_sym_EQ] = ACTIONS(6647),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(6649),
    [anon_sym_SLASH_EQ] = ACTIONS(6649),
    [anon_sym_PERCENT_EQ] = ACTIONS(6649),
    [anon_sym_PLUS_EQ] = ACTIONS(6649),
    [anon_sym_DASH_EQ] = ACTIONS(6649),
    [anon_sym_LT_LT_EQ] = ACTIONS(6649),
    [anon_sym_GT_GT_EQ] = ACTIONS(6649),
    [anon_sym_AMP_EQ] = ACTIONS(6649),
    [anon_sym_CARET_EQ] = ACTIONS(6649),
    [anon_sym_PIPE_EQ] = ACTIONS(6649),
    [anon_sym_and_eq] = ACTIONS(6649),
    [anon_sym_or_eq] = ACTIONS(6649),
    [anon_sym_xor_eq] = ACTIONS(6649),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2117),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2117),
    [anon_sym_not_eq] = ACTIONS(2117),
    [anon_sym_is] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(6651),
    [anon_sym_u_DQUOTE] = ACTIONS(6651),
    [anon_sym_U_DQUOTE] = ACTIONS(6651),
    [anon_sym_u8_DQUOTE] = ACTIONS(6651),
    [anon_sym_DQUOTE] = ACTIONS(6651),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6653),
    [anon_sym_LR_DQUOTE] = ACTIONS(6653),
    [anon_sym_uR_DQUOTE] = ACTIONS(6653),
    [anon_sym_UR_DQUOTE] = ACTIONS(6653),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6653),
  },
  [2997] = {
    [sym_string_literal] = STATE(3009),
    [sym_raw_string_literal] = STATE(3009),
    [aux_sym_concatenated_string_repeat1] = STATE(3009),
    [sym_identifier] = ACTIONS(6655),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6437),
    [anon_sym_COMMA] = ACTIONS(6437),
    [anon_sym_RPAREN] = ACTIONS(6437),
    [anon_sym_LPAREN2] = ACTIONS(6437),
    [anon_sym_DASH] = ACTIONS(6439),
    [anon_sym_PLUS] = ACTIONS(6439),
    [anon_sym_STAR] = ACTIONS(6439),
    [anon_sym_SLASH] = ACTIONS(6439),
    [anon_sym_PERCENT] = ACTIONS(6439),
    [anon_sym_PIPE_PIPE] = ACTIONS(6437),
    [anon_sym_AMP_AMP] = ACTIONS(6437),
    [anon_sym_PIPE] = ACTIONS(6439),
    [anon_sym_CARET] = ACTIONS(6439),
    [anon_sym_AMP] = ACTIONS(6439),
    [anon_sym_EQ_EQ] = ACTIONS(6437),
    [anon_sym_BANG_EQ] = ACTIONS(6437),
    [anon_sym_GT] = ACTIONS(6439),
    [anon_sym_GT_EQ] = ACTIONS(6437),
    [anon_sym_LT_EQ] = ACTIONS(6439),
    [anon_sym_LT] = ACTIONS(6439),
    [anon_sym_LT_LT] = ACTIONS(6439),
    [anon_sym_GT_GT] = ACTIONS(6439),
    [anon_sym_LBRACK] = ACTIONS(6437),
    [anon_sym_EQ] = ACTIONS(6439),
    [anon_sym_QMARK] = ACTIONS(6437),
    [anon_sym_STAR_EQ] = ACTIONS(6437),
    [anon_sym_SLASH_EQ] = ACTIONS(6437),
    [anon_sym_PERCENT_EQ] = ACTIONS(6437),
    [anon_sym_PLUS_EQ] = ACTIONS(6437),
    [anon_sym_DASH_EQ] = ACTIONS(6437),
    [anon_sym_LT_LT_EQ] = ACTIONS(6437),
    [anon_sym_GT_GT_EQ] = ACTIONS(6437),
    [anon_sym_AMP_EQ] = ACTIONS(6437),
    [anon_sym_CARET_EQ] = ACTIONS(6437),
    [anon_sym_PIPE_EQ] = ACTIONS(6437),
    [anon_sym_and_eq] = ACTIONS(6439),
    [anon_sym_or_eq] = ACTIONS(6439),
    [anon_sym_xor_eq] = ACTIONS(6439),
    [anon_sym_LT_EQ_GT] = ACTIONS(6437),
    [anon_sym_or] = ACTIONS(6439),
    [anon_sym_and] = ACTIONS(6439),
    [anon_sym_bitor] = ACTIONS(6439),
    [anon_sym_xor] = ACTIONS(6439),
    [anon_sym_bitand] = ACTIONS(6439),
    [anon_sym_not_eq] = ACTIONS(6439),
    [anon_sym_is] = ACTIONS(6439),
    [anon_sym_as] = ACTIONS(6439),
    [anon_sym_DASH_DASH] = ACTIONS(6437),
    [anon_sym_PLUS_PLUS] = ACTIONS(6437),
    [anon_sym_DOT] = ACTIONS(6439),
    [anon_sym_DOT_STAR] = ACTIONS(6437),
    [anon_sym_DASH_GT] = ACTIONS(6439),
    [anon_sym_L_DQUOTE] = ACTIONS(6169),
    [anon_sym_u_DQUOTE] = ACTIONS(6169),
    [anon_sym_U_DQUOTE] = ACTIONS(6169),
    [anon_sym_u8_DQUOTE] = ACTIONS(6169),
    [anon_sym_DQUOTE] = ACTIONS(6169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6171),
    [anon_sym_LR_DQUOTE] = ACTIONS(6171),
    [anon_sym_uR_DQUOTE] = ACTIONS(6171),
    [anon_sym_UR_DQUOTE] = ACTIONS(6171),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6171),
    [anon_sym_DASH_GT_STAR] = ACTIONS(6437),
    [sym_literal_suffix] = ACTIONS(6439),
  },
  [2998] = {
    [sym_string_literal] = STATE(3342),
    [sym_template_argument_list] = STATE(4579),
    [sym_raw_string_literal] = STATE(3342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(6208),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON] = ACTIONS(4922),
    [anon_sym_SEMI] = ACTIONS(2117),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2117),
    [anon_sym_EQ] = ACTIONS(2152),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2154),
    [anon_sym_SLASH_EQ] = ACTIONS(2154),
    [anon_sym_PERCENT_EQ] = ACTIONS(2154),
    [anon_sym_PLUS_EQ] = ACTIONS(2154),
    [anon_sym_DASH_EQ] = ACTIONS(2154),
    [anon_sym_LT_LT_EQ] = ACTIONS(2154),
    [anon_sym_GT_GT_EQ] = ACTIONS(2154),
    [anon_sym_AMP_EQ] = ACTIONS(2154),
    [anon_sym_CARET_EQ] = ACTIONS(2154),
    [anon_sym_PIPE_EQ] = ACTIONS(2154),
    [anon_sym_and_eq] = ACTIONS(2154),
    [anon_sym_or_eq] = ACTIONS(2154),
    [anon_sym_xor_eq] = ACTIONS(2154),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2117),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2117),
    [anon_sym_not_eq] = ACTIONS(2117),
    [anon_sym_is] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
  },
  [2999] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2872),
    [sym_identifier] = ACTIONS(2856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3781),
    [anon_sym_RPAREN] = ACTIONS(3781),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_DASH] = ACTIONS(3778),
    [anon_sym_PLUS] = ACTIONS(3778),
    [anon_sym_STAR] = ACTIONS(3778),
    [anon_sym_SLASH] = ACTIONS(3778),
    [anon_sym_PERCENT] = ACTIONS(3778),
    [anon_sym_PIPE_PIPE] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_PIPE] = ACTIONS(3778),
    [anon_sym_CARET] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_GT] = ACTIONS(3778),
    [anon_sym_GT_EQ] = ACTIONS(3781),
    [anon_sym_LT_EQ] = ACTIONS(3778),
    [anon_sym_LT] = ACTIONS(3778),
    [anon_sym_LT_LT] = ACTIONS(3778),
    [anon_sym_GT_GT] = ACTIONS(3778),
    [anon_sym_COLON] = ACTIONS(3781),
    [anon_sym_SEMI] = ACTIONS(3781),
    [anon_sym___attribute__] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_RBRACE] = ACTIONS(3781),
    [anon_sym_signed] = ACTIONS(6521),
    [anon_sym_unsigned] = ACTIONS(6521),
    [anon_sym_long] = ACTIONS(6521),
    [anon_sym_short] = ACTIONS(6521),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_RBRACK] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3778),
    [sym_primitive_type] = ACTIONS(2856),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_STAR_EQ] = ACTIONS(3781),
    [anon_sym_SLASH_EQ] = ACTIONS(3781),
    [anon_sym_PERCENT_EQ] = ACTIONS(3781),
    [anon_sym_PLUS_EQ] = ACTIONS(3781),
    [anon_sym_DASH_EQ] = ACTIONS(3781),
    [anon_sym_LT_LT_EQ] = ACTIONS(3781),
    [anon_sym_GT_GT_EQ] = ACTIONS(3781),
    [anon_sym_AMP_EQ] = ACTIONS(3781),
    [anon_sym_CARET_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_and_eq] = ACTIONS(3778),
    [anon_sym_or_eq] = ACTIONS(3778),
    [anon_sym_xor_eq] = ACTIONS(3778),
    [anon_sym_LT_EQ_GT] = ACTIONS(3781),
    [anon_sym_or] = ACTIONS(3778),
    [anon_sym_and] = ACTIONS(3778),
    [anon_sym_bitor] = ACTIONS(3778),
    [anon_sym_xor] = ACTIONS(3778),
    [anon_sym_bitand] = ACTIONS(3778),
    [anon_sym_not_eq] = ACTIONS(3778),
    [anon_sym_is] = ACTIONS(3778),
    [anon_sym_as] = ACTIONS(3778),
    [anon_sym_DASH_DASH] = ACTIONS(3781),
    [anon_sym_PLUS_PLUS] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(3778),
    [anon_sym_DOT_STAR] = ACTIONS(3781),
    [anon_sym_DASH_GT] = ACTIONS(3781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3778),
    [anon_sym_let] = ACTIONS(3778),
    [anon_sym_This] = ACTIONS(3778),
  },
  [3000] = {
    [sym_identifier] = ACTIONS(2742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2740),
    [anon_sym_COMMA] = ACTIONS(2740),
    [anon_sym_RPAREN] = ACTIONS(2740),
    [aux_sym_preproc_if_token2] = ACTIONS(2740),
    [aux_sym_preproc_else_token1] = ACTIONS(2740),
    [aux_sym_preproc_elif_token1] = ACTIONS(2742),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2740),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2740),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2742),
    [anon_sym_PLUS] = ACTIONS(2742),
    [anon_sym_STAR] = ACTIONS(2742),
    [anon_sym_SLASH] = ACTIONS(2742),
    [anon_sym_PERCENT] = ACTIONS(2742),
    [anon_sym_PIPE_PIPE] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_PIPE] = ACTIONS(2742),
    [anon_sym_CARET] = ACTIONS(2742),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_EQ_EQ] = ACTIONS(2740),
    [anon_sym_BANG_EQ] = ACTIONS(2740),
    [anon_sym_GT] = ACTIONS(2742),
    [anon_sym_GT_EQ] = ACTIONS(2740),
    [anon_sym_LT_EQ] = ACTIONS(2742),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_LT_LT] = ACTIONS(2742),
    [anon_sym_GT_GT] = ACTIONS(2742),
    [anon_sym_COLON] = ACTIONS(2742),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACE] = ACTIONS(2740),
    [anon_sym_RBRACE] = ACTIONS(2740),
    [anon_sym_LBRACK] = ACTIONS(2740),
    [anon_sym_RBRACK] = ACTIONS(2740),
    [anon_sym_EQ] = ACTIONS(2742),
    [anon_sym_QMARK] = ACTIONS(2740),
    [anon_sym_STAR_EQ] = ACTIONS(2740),
    [anon_sym_SLASH_EQ] = ACTIONS(2740),
    [anon_sym_PERCENT_EQ] = ACTIONS(2740),
    [anon_sym_PLUS_EQ] = ACTIONS(2740),
    [anon_sym_DASH_EQ] = ACTIONS(2740),
    [anon_sym_LT_LT_EQ] = ACTIONS(2740),
    [anon_sym_GT_GT_EQ] = ACTIONS(2740),
    [anon_sym_AMP_EQ] = ACTIONS(2740),
    [anon_sym_CARET_EQ] = ACTIONS(2740),
    [anon_sym_PIPE_EQ] = ACTIONS(2740),
    [anon_sym_and_eq] = ACTIONS(2742),
    [anon_sym_or_eq] = ACTIONS(2742),
    [anon_sym_xor_eq] = ACTIONS(2742),
    [anon_sym_LT_EQ_GT] = ACTIONS(2740),
    [anon_sym_or] = ACTIONS(2742),
    [anon_sym_and] = ACTIONS(2742),
    [anon_sym_bitor] = ACTIONS(2742),
    [anon_sym_xor] = ACTIONS(2742),
    [anon_sym_bitand] = ACTIONS(2742),
    [anon_sym_not_eq] = ACTIONS(2742),
    [anon_sym_is] = ACTIONS(2742),
    [anon_sym_as] = ACTIONS(2742),
    [anon_sym_DASH_DASH] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2740),
    [anon_sym_DOT] = ACTIONS(2742),
    [anon_sym_DOT_STAR] = ACTIONS(2740),
    [anon_sym_DASH_GT] = ACTIONS(2740),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
  },
  [3001] = {
    [sym_attribute_specifier] = STATE(3061),
    [sym_identifier] = ACTIONS(3840),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3842),
    [anon_sym_COMMA] = ACTIONS(3842),
    [anon_sym_RPAREN] = ACTIONS(3842),
    [aux_sym_preproc_if_token2] = ACTIONS(3842),
    [aux_sym_preproc_else_token1] = ACTIONS(3842),
    [aux_sym_preproc_elif_token1] = ACTIONS(3840),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3842),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3842),
    [anon_sym_LPAREN2] = ACTIONS(3842),
    [anon_sym_DASH] = ACTIONS(3840),
    [anon_sym_PLUS] = ACTIONS(3840),
    [anon_sym_STAR] = ACTIONS(3840),
    [anon_sym_SLASH] = ACTIONS(3840),
    [anon_sym_PERCENT] = ACTIONS(3840),
    [anon_sym_PIPE_PIPE] = ACTIONS(3842),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE] = ACTIONS(3840),
    [anon_sym_CARET] = ACTIONS(3840),
    [anon_sym_AMP] = ACTIONS(3840),
    [anon_sym_EQ_EQ] = ACTIONS(3842),
    [anon_sym_BANG_EQ] = ACTIONS(3842),
    [anon_sym_GT] = ACTIONS(3840),
    [anon_sym_GT_EQ] = ACTIONS(3842),
    [anon_sym_LT_EQ] = ACTIONS(3840),
    [anon_sym_LT] = ACTIONS(3840),
    [anon_sym_LT_LT] = ACTIONS(3840),
    [anon_sym_GT_GT] = ACTIONS(3840),
    [anon_sym_COLON] = ACTIONS(3842),
    [anon_sym_SEMI] = ACTIONS(3842),
    [anon_sym___attribute__] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(3842),
    [anon_sym_RBRACE] = ACTIONS(3842),
    [anon_sym_LBRACK] = ACTIONS(3842),
    [anon_sym_RBRACK] = ACTIONS(3842),
    [anon_sym_EQ] = ACTIONS(3840),
    [anon_sym_QMARK] = ACTIONS(3842),
    [anon_sym_STAR_EQ] = ACTIONS(3842),
    [anon_sym_SLASH_EQ] = ACTIONS(3842),
    [anon_sym_PERCENT_EQ] = ACTIONS(3842),
    [anon_sym_PLUS_EQ] = ACTIONS(3842),
    [anon_sym_DASH_EQ] = ACTIONS(3842),
    [anon_sym_LT_LT_EQ] = ACTIONS(3842),
    [anon_sym_GT_GT_EQ] = ACTIONS(3842),
    [anon_sym_AMP_EQ] = ACTIONS(3842),
    [anon_sym_CARET_EQ] = ACTIONS(3842),
    [anon_sym_PIPE_EQ] = ACTIONS(3842),
    [anon_sym_and_eq] = ACTIONS(3840),
    [anon_sym_or_eq] = ACTIONS(3840),
    [anon_sym_xor_eq] = ACTIONS(3840),
    [anon_sym_LT_EQ_GT] = ACTIONS(3842),
    [anon_sym_or] = ACTIONS(3840),
    [anon_sym_and] = ACTIONS(3840),
    [anon_sym_bitor] = ACTIONS(3840),
    [anon_sym_xor] = ACTIONS(3840),
    [anon_sym_bitand] = ACTIONS(3840),
    [anon_sym_not_eq] = ACTIONS(3840),
    [anon_sym_is] = ACTIONS(3840),
    [anon_sym_as] = ACTIONS(3840),
    [anon_sym_DASH_DASH] = ACTIONS(3842),
    [anon_sym_PLUS_PLUS] = ACTIONS(3842),
    [anon_sym_DOT] = ACTIONS(3840),
    [anon_sym_DOT_STAR] = ACTIONS(3842),
    [anon_sym_DASH_GT] = ACTIONS(3842),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3840),
    [anon_sym_let] = ACTIONS(3840),
    [anon_sym_This] = ACTIONS(3840),
  },
  [3002] = {
    [sym_identifier] = ACTIONS(3222),
    [anon_sym___extension__] = ACTIONS(3222),
    [anon_sym_in] = ACTIONS(3222),
    [anon_sym_out] = ACTIONS(3222),
    [anon_sym_inout] = ACTIONS(3222),
    [anon_sym_extern] = ACTIONS(3222),
    [anon_sym___attribute__] = ACTIONS(3222),
    [anon_sym_COLON_COLON] = ACTIONS(3224),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3224),
    [anon_sym___declspec] = ACTIONS(3222),
    [anon_sym_signed] = ACTIONS(3222),
    [anon_sym_unsigned] = ACTIONS(3222),
    [anon_sym_long] = ACTIONS(3222),
    [anon_sym_short] = ACTIONS(3222),
    [anon_sym_static] = ACTIONS(3222),
    [anon_sym_register] = ACTIONS(3222),
    [anon_sym_inline] = ACTIONS(3222),
    [anon_sym___inline] = ACTIONS(3222),
    [anon_sym___inline__] = ACTIONS(3222),
    [anon_sym___forceinline] = ACTIONS(3222),
    [anon_sym_thread_local] = ACTIONS(3222),
    [anon_sym___thread] = ACTIONS(3222),
    [anon_sym_const] = ACTIONS(3222),
    [anon_sym_constexpr] = ACTIONS(3222),
    [anon_sym_volatile] = ACTIONS(3222),
    [anon_sym_restrict] = ACTIONS(3222),
    [anon_sym___restrict__] = ACTIONS(3222),
    [anon_sym__Atomic] = ACTIONS(3222),
    [anon_sym__Noreturn] = ACTIONS(3222),
    [anon_sym_noreturn] = ACTIONS(3222),
    [anon_sym_mutable] = ACTIONS(3222),
    [anon_sym_constinit] = ACTIONS(3222),
    [anon_sym_consteval] = ACTIONS(3222),
    [anon_sym_alignas] = ACTIONS(3222),
    [anon_sym__Alignas] = ACTIONS(3222),
    [sym_primitive_type] = ACTIONS(3222),
    [anon_sym_enum] = ACTIONS(3222),
    [anon_sym_class] = ACTIONS(3222),
    [anon_sym_struct] = ACTIONS(3222),
    [anon_sym_union] = ACTIONS(3222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3222),
    [anon_sym_let] = ACTIONS(3222),
    [anon_sym_This] = ACTIONS(3222),
    [anon_sym_decltype] = ACTIONS(3222),
    [sym_virtual] = ACTIONS(3222),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3222),
    [anon_sym_precise] = ACTIONS(3222),
    [anon_sym_shared] = ACTIONS(3222),
    [anon_sym_groupshared] = ACTIONS(3222),
    [anon_sym_uniform] = ACTIONS(3222),
    [anon_sym_row_major] = ACTIONS(3222),
    [anon_sym_column_major] = ACTIONS(3222),
    [anon_sym_globallycoherent] = ACTIONS(3222),
    [anon_sym_centroid] = ACTIONS(3222),
    [anon_sym_noperspective] = ACTIONS(3222),
    [anon_sym_nointerpolation] = ACTIONS(3222),
    [anon_sym_sample] = ACTIONS(3222),
    [anon_sym_linear] = ACTIONS(3222),
    [anon_sym_snorm] = ACTIONS(3222),
    [anon_sym_unorm] = ACTIONS(3222),
    [anon_sym_point] = ACTIONS(3222),
    [anon_sym_line] = ACTIONS(3222),
    [anon_sym_triangleadj] = ACTIONS(3222),
    [anon_sym_lineadj] = ACTIONS(3222),
    [anon_sym_triangle] = ACTIONS(3222),
    [anon_sym_interface] = ACTIONS(3222),
    [anon_sym_extension] = ACTIONS(3222),
  },
  [3003] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2999),
    [sym_identifier] = ACTIONS(6657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3822),
    [anon_sym_COMMA] = ACTIONS(3822),
    [anon_sym_RPAREN] = ACTIONS(3822),
    [anon_sym_LPAREN2] = ACTIONS(3822),
    [anon_sym_DASH] = ACTIONS(3820),
    [anon_sym_PLUS] = ACTIONS(3820),
    [anon_sym_STAR] = ACTIONS(3820),
    [anon_sym_SLASH] = ACTIONS(3820),
    [anon_sym_PERCENT] = ACTIONS(3820),
    [anon_sym_PIPE_PIPE] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3822),
    [anon_sym_PIPE] = ACTIONS(3820),
    [anon_sym_CARET] = ACTIONS(3820),
    [anon_sym_AMP] = ACTIONS(3820),
    [anon_sym_EQ_EQ] = ACTIONS(3822),
    [anon_sym_BANG_EQ] = ACTIONS(3822),
    [anon_sym_GT] = ACTIONS(3820),
    [anon_sym_GT_EQ] = ACTIONS(3822),
    [anon_sym_LT_EQ] = ACTIONS(3820),
    [anon_sym_LT] = ACTIONS(3820),
    [anon_sym_LT_LT] = ACTIONS(3820),
    [anon_sym_GT_GT] = ACTIONS(3820),
    [anon_sym_COLON] = ACTIONS(3822),
    [anon_sym_SEMI] = ACTIONS(3822),
    [anon_sym___attribute__] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3822),
    [anon_sym_RBRACE] = ACTIONS(3822),
    [anon_sym_signed] = ACTIONS(6659),
    [anon_sym_unsigned] = ACTIONS(6659),
    [anon_sym_long] = ACTIONS(6659),
    [anon_sym_short] = ACTIONS(6659),
    [anon_sym_LBRACK] = ACTIONS(3822),
    [anon_sym_RBRACK] = ACTIONS(3822),
    [anon_sym_EQ] = ACTIONS(3820),
    [sym_primitive_type] = ACTIONS(6661),
    [anon_sym_QMARK] = ACTIONS(3822),
    [anon_sym_STAR_EQ] = ACTIONS(3822),
    [anon_sym_SLASH_EQ] = ACTIONS(3822),
    [anon_sym_PERCENT_EQ] = ACTIONS(3822),
    [anon_sym_PLUS_EQ] = ACTIONS(3822),
    [anon_sym_DASH_EQ] = ACTIONS(3822),
    [anon_sym_LT_LT_EQ] = ACTIONS(3822),
    [anon_sym_GT_GT_EQ] = ACTIONS(3822),
    [anon_sym_AMP_EQ] = ACTIONS(3822),
    [anon_sym_CARET_EQ] = ACTIONS(3822),
    [anon_sym_PIPE_EQ] = ACTIONS(3822),
    [anon_sym_and_eq] = ACTIONS(3820),
    [anon_sym_or_eq] = ACTIONS(3820),
    [anon_sym_xor_eq] = ACTIONS(3820),
    [anon_sym_LT_EQ_GT] = ACTIONS(3822),
    [anon_sym_or] = ACTIONS(3820),
    [anon_sym_and] = ACTIONS(3820),
    [anon_sym_bitor] = ACTIONS(3820),
    [anon_sym_xor] = ACTIONS(3820),
    [anon_sym_bitand] = ACTIONS(3820),
    [anon_sym_not_eq] = ACTIONS(3820),
    [anon_sym_is] = ACTIONS(3820),
    [anon_sym_as] = ACTIONS(3820),
    [anon_sym_DASH_DASH] = ACTIONS(3822),
    [anon_sym_PLUS_PLUS] = ACTIONS(3822),
    [anon_sym_DOT] = ACTIONS(3820),
    [anon_sym_DOT_STAR] = ACTIONS(3822),
    [anon_sym_DASH_GT] = ACTIONS(3822),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3820),
    [anon_sym_let] = ACTIONS(3820),
    [anon_sym_This] = ACTIONS(3820),
  },
  [3004] = {
    [sym_attribute_specifier] = STATE(3063),
    [sym_identifier] = ACTIONS(3836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3838),
    [anon_sym_COMMA] = ACTIONS(3838),
    [anon_sym_RPAREN] = ACTIONS(3838),
    [aux_sym_preproc_if_token2] = ACTIONS(3838),
    [aux_sym_preproc_else_token1] = ACTIONS(3838),
    [aux_sym_preproc_elif_token1] = ACTIONS(3836),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3838),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3838),
    [anon_sym_LPAREN2] = ACTIONS(3838),
    [anon_sym_DASH] = ACTIONS(3836),
    [anon_sym_PLUS] = ACTIONS(3836),
    [anon_sym_STAR] = ACTIONS(3836),
    [anon_sym_SLASH] = ACTIONS(3836),
    [anon_sym_PERCENT] = ACTIONS(3836),
    [anon_sym_PIPE_PIPE] = ACTIONS(3838),
    [anon_sym_AMP_AMP] = ACTIONS(3838),
    [anon_sym_PIPE] = ACTIONS(3836),
    [anon_sym_CARET] = ACTIONS(3836),
    [anon_sym_AMP] = ACTIONS(3836),
    [anon_sym_EQ_EQ] = ACTIONS(3838),
    [anon_sym_BANG_EQ] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3836),
    [anon_sym_GT_EQ] = ACTIONS(3838),
    [anon_sym_LT_EQ] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3836),
    [anon_sym_LT_LT] = ACTIONS(3836),
    [anon_sym_GT_GT] = ACTIONS(3836),
    [anon_sym_COLON] = ACTIONS(3838),
    [anon_sym_SEMI] = ACTIONS(3838),
    [anon_sym___attribute__] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(3838),
    [anon_sym_RBRACE] = ACTIONS(3838),
    [anon_sym_LBRACK] = ACTIONS(3838),
    [anon_sym_RBRACK] = ACTIONS(3838),
    [anon_sym_EQ] = ACTIONS(3836),
    [anon_sym_QMARK] = ACTIONS(3838),
    [anon_sym_STAR_EQ] = ACTIONS(3838),
    [anon_sym_SLASH_EQ] = ACTIONS(3838),
    [anon_sym_PERCENT_EQ] = ACTIONS(3838),
    [anon_sym_PLUS_EQ] = ACTIONS(3838),
    [anon_sym_DASH_EQ] = ACTIONS(3838),
    [anon_sym_LT_LT_EQ] = ACTIONS(3838),
    [anon_sym_GT_GT_EQ] = ACTIONS(3838),
    [anon_sym_AMP_EQ] = ACTIONS(3838),
    [anon_sym_CARET_EQ] = ACTIONS(3838),
    [anon_sym_PIPE_EQ] = ACTIONS(3838),
    [anon_sym_and_eq] = ACTIONS(3836),
    [anon_sym_or_eq] = ACTIONS(3836),
    [anon_sym_xor_eq] = ACTIONS(3836),
    [anon_sym_LT_EQ_GT] = ACTIONS(3838),
    [anon_sym_or] = ACTIONS(3836),
    [anon_sym_and] = ACTIONS(3836),
    [anon_sym_bitor] = ACTIONS(3836),
    [anon_sym_xor] = ACTIONS(3836),
    [anon_sym_bitand] = ACTIONS(3836),
    [anon_sym_not_eq] = ACTIONS(3836),
    [anon_sym_is] = ACTIONS(3836),
    [anon_sym_as] = ACTIONS(3836),
    [anon_sym_DASH_DASH] = ACTIONS(3838),
    [anon_sym_PLUS_PLUS] = ACTIONS(3838),
    [anon_sym_DOT] = ACTIONS(3836),
    [anon_sym_DOT_STAR] = ACTIONS(3838),
    [anon_sym_DASH_GT] = ACTIONS(3838),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3836),
    [anon_sym_let] = ACTIONS(3836),
    [anon_sym_This] = ACTIONS(3836),
  },
  [3005] = {
    [sym_string_literal] = STATE(3342),
    [sym_template_argument_list] = STATE(4579),
    [sym_raw_string_literal] = STATE(3342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(6208),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON] = ACTIONS(2163),
    [anon_sym_SEMI] = ACTIONS(2117),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2117),
    [anon_sym_EQ] = ACTIONS(2152),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2154),
    [anon_sym_SLASH_EQ] = ACTIONS(2154),
    [anon_sym_PERCENT_EQ] = ACTIONS(2154),
    [anon_sym_PLUS_EQ] = ACTIONS(2154),
    [anon_sym_DASH_EQ] = ACTIONS(2154),
    [anon_sym_LT_LT_EQ] = ACTIONS(2154),
    [anon_sym_GT_GT_EQ] = ACTIONS(2154),
    [anon_sym_AMP_EQ] = ACTIONS(2154),
    [anon_sym_CARET_EQ] = ACTIONS(2154),
    [anon_sym_PIPE_EQ] = ACTIONS(2154),
    [anon_sym_and_eq] = ACTIONS(2154),
    [anon_sym_or_eq] = ACTIONS(2154),
    [anon_sym_xor_eq] = ACTIONS(2154),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2117),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2117),
    [anon_sym_not_eq] = ACTIONS(2117),
    [anon_sym_is] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
  },
  [3006] = {
    [sym_string_literal] = STATE(3006),
    [sym_raw_string_literal] = STATE(3006),
    [aux_sym_concatenated_string_repeat1] = STATE(3006),
    [sym_identifier] = ACTIONS(6663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6444),
    [anon_sym_COMMA] = ACTIONS(6444),
    [anon_sym_LPAREN2] = ACTIONS(6444),
    [anon_sym_DASH] = ACTIONS(6446),
    [anon_sym_PLUS] = ACTIONS(6446),
    [anon_sym_STAR] = ACTIONS(6446),
    [anon_sym_SLASH] = ACTIONS(6446),
    [anon_sym_PERCENT] = ACTIONS(6446),
    [anon_sym_PIPE_PIPE] = ACTIONS(6444),
    [anon_sym_AMP_AMP] = ACTIONS(6444),
    [anon_sym_PIPE] = ACTIONS(6446),
    [anon_sym_CARET] = ACTIONS(6446),
    [anon_sym_AMP] = ACTIONS(6446),
    [anon_sym_EQ_EQ] = ACTIONS(6444),
    [anon_sym_BANG_EQ] = ACTIONS(6444),
    [anon_sym_GT] = ACTIONS(6446),
    [anon_sym_GT_EQ] = ACTIONS(6444),
    [anon_sym_LT_EQ] = ACTIONS(6446),
    [anon_sym_LT] = ACTIONS(6446),
    [anon_sym_LT_LT] = ACTIONS(6446),
    [anon_sym_GT_GT] = ACTIONS(6446),
    [anon_sym_SEMI] = ACTIONS(6444),
    [anon_sym___attribute__] = ACTIONS(6446),
    [anon_sym_LBRACK] = ACTIONS(6444),
    [anon_sym_EQ] = ACTIONS(6446),
    [anon_sym_QMARK] = ACTIONS(6444),
    [anon_sym_STAR_EQ] = ACTIONS(6444),
    [anon_sym_SLASH_EQ] = ACTIONS(6444),
    [anon_sym_PERCENT_EQ] = ACTIONS(6444),
    [anon_sym_PLUS_EQ] = ACTIONS(6444),
    [anon_sym_DASH_EQ] = ACTIONS(6444),
    [anon_sym_LT_LT_EQ] = ACTIONS(6444),
    [anon_sym_GT_GT_EQ] = ACTIONS(6444),
    [anon_sym_AMP_EQ] = ACTIONS(6444),
    [anon_sym_CARET_EQ] = ACTIONS(6444),
    [anon_sym_PIPE_EQ] = ACTIONS(6444),
    [anon_sym_and_eq] = ACTIONS(6446),
    [anon_sym_or_eq] = ACTIONS(6446),
    [anon_sym_xor_eq] = ACTIONS(6446),
    [anon_sym_LT_EQ_GT] = ACTIONS(6444),
    [anon_sym_or] = ACTIONS(6446),
    [anon_sym_and] = ACTIONS(6446),
    [anon_sym_bitor] = ACTIONS(6446),
    [anon_sym_xor] = ACTIONS(6446),
    [anon_sym_bitand] = ACTIONS(6446),
    [anon_sym_not_eq] = ACTIONS(6446),
    [anon_sym_is] = ACTIONS(6446),
    [anon_sym_as] = ACTIONS(6446),
    [anon_sym_DASH_DASH] = ACTIONS(6444),
    [anon_sym_PLUS_PLUS] = ACTIONS(6444),
    [anon_sym_DOT] = ACTIONS(6446),
    [anon_sym_DOT_STAR] = ACTIONS(6444),
    [anon_sym_DASH_GT] = ACTIONS(6444),
    [anon_sym_L_DQUOTE] = ACTIONS(6666),
    [anon_sym_u_DQUOTE] = ACTIONS(6666),
    [anon_sym_U_DQUOTE] = ACTIONS(6666),
    [anon_sym_u8_DQUOTE] = ACTIONS(6666),
    [anon_sym_DQUOTE] = ACTIONS(6666),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6669),
    [anon_sym_LR_DQUOTE] = ACTIONS(6669),
    [anon_sym_uR_DQUOTE] = ACTIONS(6669),
    [anon_sym_UR_DQUOTE] = ACTIONS(6669),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6669),
    [sym_literal_suffix] = ACTIONS(6446),
  },
  [3007] = {
    [sym_identifier] = ACTIONS(3857),
    [anon_sym___extension__] = ACTIONS(3857),
    [anon_sym_in] = ACTIONS(3857),
    [anon_sym_out] = ACTIONS(3857),
    [anon_sym_inout] = ACTIONS(3857),
    [anon_sym_extern] = ACTIONS(3857),
    [anon_sym___attribute__] = ACTIONS(3857),
    [anon_sym_COLON_COLON] = ACTIONS(3862),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3862),
    [anon_sym___declspec] = ACTIONS(3857),
    [anon_sym_signed] = ACTIONS(3857),
    [anon_sym_unsigned] = ACTIONS(3857),
    [anon_sym_long] = ACTIONS(3857),
    [anon_sym_short] = ACTIONS(3857),
    [anon_sym_static] = ACTIONS(3857),
    [anon_sym_register] = ACTIONS(3857),
    [anon_sym_inline] = ACTIONS(3857),
    [anon_sym___inline] = ACTIONS(3857),
    [anon_sym___inline__] = ACTIONS(3857),
    [anon_sym___forceinline] = ACTIONS(3857),
    [anon_sym_thread_local] = ACTIONS(3857),
    [anon_sym___thread] = ACTIONS(3857),
    [anon_sym_const] = ACTIONS(3857),
    [anon_sym_constexpr] = ACTIONS(3857),
    [anon_sym_volatile] = ACTIONS(3857),
    [anon_sym_restrict] = ACTIONS(3857),
    [anon_sym___restrict__] = ACTIONS(3857),
    [anon_sym__Atomic] = ACTIONS(3857),
    [anon_sym__Noreturn] = ACTIONS(3857),
    [anon_sym_noreturn] = ACTIONS(3857),
    [anon_sym_mutable] = ACTIONS(3857),
    [anon_sym_constinit] = ACTIONS(3857),
    [anon_sym_consteval] = ACTIONS(3857),
    [anon_sym_alignas] = ACTIONS(3857),
    [anon_sym__Alignas] = ACTIONS(3857),
    [sym_primitive_type] = ACTIONS(3857),
    [anon_sym_enum] = ACTIONS(3857),
    [anon_sym_class] = ACTIONS(3857),
    [anon_sym_struct] = ACTIONS(3857),
    [anon_sym_union] = ACTIONS(3857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3857),
    [anon_sym_let] = ACTIONS(3857),
    [anon_sym_This] = ACTIONS(3857),
    [anon_sym_decltype] = ACTIONS(3857),
    [sym_virtual] = ACTIONS(3857),
    [anon_sym_typename] = ACTIONS(3857),
    [anon_sym_template] = ACTIONS(3857),
    [anon_sym_precise] = ACTIONS(3857),
    [anon_sym_shared] = ACTIONS(3857),
    [anon_sym_groupshared] = ACTIONS(3857),
    [anon_sym_uniform] = ACTIONS(3857),
    [anon_sym_row_major] = ACTIONS(3857),
    [anon_sym_column_major] = ACTIONS(3857),
    [anon_sym_globallycoherent] = ACTIONS(3857),
    [anon_sym_centroid] = ACTIONS(3857),
    [anon_sym_noperspective] = ACTIONS(3857),
    [anon_sym_nointerpolation] = ACTIONS(3857),
    [anon_sym_sample] = ACTIONS(3857),
    [anon_sym_linear] = ACTIONS(3857),
    [anon_sym_snorm] = ACTIONS(3857),
    [anon_sym_unorm] = ACTIONS(3857),
    [anon_sym_point] = ACTIONS(3857),
    [anon_sym_line] = ACTIONS(3857),
    [anon_sym_triangleadj] = ACTIONS(3857),
    [anon_sym_lineadj] = ACTIONS(3857),
    [anon_sym_triangle] = ACTIONS(3857),
    [anon_sym_interface] = ACTIONS(3857),
    [anon_sym_extension] = ACTIONS(3857),
  },
  [3008] = {
    [sym_string_literal] = STATE(3342),
    [sym_template_argument_list] = STATE(4579),
    [sym_raw_string_literal] = STATE(3342),
    [aux_sym_structured_binding_declarator_repeat1] = STATE(8986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(6672),
    [anon_sym_LPAREN2] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(6208),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2117),
    [anon_sym_RBRACK] = ACTIONS(6640),
    [anon_sym_EQ] = ACTIONS(6643),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(6645),
    [anon_sym_SLASH_EQ] = ACTIONS(6645),
    [anon_sym_PERCENT_EQ] = ACTIONS(6645),
    [anon_sym_PLUS_EQ] = ACTIONS(6645),
    [anon_sym_DASH_EQ] = ACTIONS(6645),
    [anon_sym_LT_LT_EQ] = ACTIONS(6645),
    [anon_sym_GT_GT_EQ] = ACTIONS(6645),
    [anon_sym_AMP_EQ] = ACTIONS(6645),
    [anon_sym_CARET_EQ] = ACTIONS(6645),
    [anon_sym_PIPE_EQ] = ACTIONS(6645),
    [anon_sym_and_eq] = ACTIONS(6645),
    [anon_sym_or_eq] = ACTIONS(6645),
    [anon_sym_xor_eq] = ACTIONS(6645),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2117),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2117),
    [anon_sym_not_eq] = ACTIONS(2117),
    [anon_sym_is] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
  },
  [3009] = {
    [sym_string_literal] = STATE(3031),
    [sym_raw_string_literal] = STATE(3031),
    [aux_sym_concatenated_string_repeat1] = STATE(3031),
    [sym_identifier] = ACTIONS(6675),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6456),
    [anon_sym_COMMA] = ACTIONS(6456),
    [anon_sym_RPAREN] = ACTIONS(6456),
    [anon_sym_LPAREN2] = ACTIONS(6456),
    [anon_sym_DASH] = ACTIONS(6458),
    [anon_sym_PLUS] = ACTIONS(6458),
    [anon_sym_STAR] = ACTIONS(6458),
    [anon_sym_SLASH] = ACTIONS(6458),
    [anon_sym_PERCENT] = ACTIONS(6458),
    [anon_sym_PIPE_PIPE] = ACTIONS(6456),
    [anon_sym_AMP_AMP] = ACTIONS(6456),
    [anon_sym_PIPE] = ACTIONS(6458),
    [anon_sym_CARET] = ACTIONS(6458),
    [anon_sym_AMP] = ACTIONS(6458),
    [anon_sym_EQ_EQ] = ACTIONS(6456),
    [anon_sym_BANG_EQ] = ACTIONS(6456),
    [anon_sym_GT] = ACTIONS(6458),
    [anon_sym_GT_EQ] = ACTIONS(6456),
    [anon_sym_LT_EQ] = ACTIONS(6458),
    [anon_sym_LT] = ACTIONS(6458),
    [anon_sym_LT_LT] = ACTIONS(6458),
    [anon_sym_GT_GT] = ACTIONS(6458),
    [anon_sym_LBRACK] = ACTIONS(6456),
    [anon_sym_EQ] = ACTIONS(6458),
    [anon_sym_QMARK] = ACTIONS(6456),
    [anon_sym_STAR_EQ] = ACTIONS(6456),
    [anon_sym_SLASH_EQ] = ACTIONS(6456),
    [anon_sym_PERCENT_EQ] = ACTIONS(6456),
    [anon_sym_PLUS_EQ] = ACTIONS(6456),
    [anon_sym_DASH_EQ] = ACTIONS(6456),
    [anon_sym_LT_LT_EQ] = ACTIONS(6456),
    [anon_sym_GT_GT_EQ] = ACTIONS(6456),
    [anon_sym_AMP_EQ] = ACTIONS(6456),
    [anon_sym_CARET_EQ] = ACTIONS(6456),
    [anon_sym_PIPE_EQ] = ACTIONS(6456),
    [anon_sym_and_eq] = ACTIONS(6458),
    [anon_sym_or_eq] = ACTIONS(6458),
    [anon_sym_xor_eq] = ACTIONS(6458),
    [anon_sym_LT_EQ_GT] = ACTIONS(6456),
    [anon_sym_or] = ACTIONS(6458),
    [anon_sym_and] = ACTIONS(6458),
    [anon_sym_bitor] = ACTIONS(6458),
    [anon_sym_xor] = ACTIONS(6458),
    [anon_sym_bitand] = ACTIONS(6458),
    [anon_sym_not_eq] = ACTIONS(6458),
    [anon_sym_is] = ACTIONS(6458),
    [anon_sym_as] = ACTIONS(6458),
    [anon_sym_DASH_DASH] = ACTIONS(6456),
    [anon_sym_PLUS_PLUS] = ACTIONS(6456),
    [anon_sym_DOT] = ACTIONS(6458),
    [anon_sym_DOT_STAR] = ACTIONS(6456),
    [anon_sym_DASH_GT] = ACTIONS(6458),
    [anon_sym_L_DQUOTE] = ACTIONS(6169),
    [anon_sym_u_DQUOTE] = ACTIONS(6169),
    [anon_sym_U_DQUOTE] = ACTIONS(6169),
    [anon_sym_u8_DQUOTE] = ACTIONS(6169),
    [anon_sym_DQUOTE] = ACTIONS(6169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6171),
    [anon_sym_LR_DQUOTE] = ACTIONS(6171),
    [anon_sym_uR_DQUOTE] = ACTIONS(6171),
    [anon_sym_UR_DQUOTE] = ACTIONS(6171),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6171),
    [anon_sym_DASH_GT_STAR] = ACTIONS(6456),
    [sym_literal_suffix] = ACTIONS(6458),
  },
  [3010] = {
    [sym_identifier] = ACTIONS(2826),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2824),
    [anon_sym_COMMA] = ACTIONS(2824),
    [anon_sym_RPAREN] = ACTIONS(2824),
    [aux_sym_preproc_if_token2] = ACTIONS(2824),
    [aux_sym_preproc_else_token1] = ACTIONS(2824),
    [aux_sym_preproc_elif_token1] = ACTIONS(2826),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2824),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2824),
    [anon_sym_LPAREN2] = ACTIONS(2824),
    [anon_sym_DASH] = ACTIONS(2826),
    [anon_sym_PLUS] = ACTIONS(2826),
    [anon_sym_STAR] = ACTIONS(2826),
    [anon_sym_SLASH] = ACTIONS(2826),
    [anon_sym_PERCENT] = ACTIONS(2826),
    [anon_sym_PIPE_PIPE] = ACTIONS(2824),
    [anon_sym_AMP_AMP] = ACTIONS(2824),
    [anon_sym_PIPE] = ACTIONS(2826),
    [anon_sym_CARET] = ACTIONS(2826),
    [anon_sym_AMP] = ACTIONS(2826),
    [anon_sym_EQ_EQ] = ACTIONS(2824),
    [anon_sym_BANG_EQ] = ACTIONS(2824),
    [anon_sym_GT] = ACTIONS(2826),
    [anon_sym_GT_EQ] = ACTIONS(2824),
    [anon_sym_LT_EQ] = ACTIONS(2826),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_LT_LT] = ACTIONS(2826),
    [anon_sym_GT_GT] = ACTIONS(2826),
    [anon_sym_COLON] = ACTIONS(2826),
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym___attribute__] = ACTIONS(2826),
    [anon_sym_COLON_COLON] = ACTIONS(2824),
    [anon_sym_LBRACE] = ACTIONS(2824),
    [anon_sym_RBRACE] = ACTIONS(2824),
    [anon_sym_LBRACK] = ACTIONS(2824),
    [anon_sym_RBRACK] = ACTIONS(2824),
    [anon_sym_EQ] = ACTIONS(2826),
    [anon_sym_QMARK] = ACTIONS(2824),
    [anon_sym_STAR_EQ] = ACTIONS(2824),
    [anon_sym_SLASH_EQ] = ACTIONS(2824),
    [anon_sym_PERCENT_EQ] = ACTIONS(2824),
    [anon_sym_PLUS_EQ] = ACTIONS(2824),
    [anon_sym_DASH_EQ] = ACTIONS(2824),
    [anon_sym_LT_LT_EQ] = ACTIONS(2824),
    [anon_sym_GT_GT_EQ] = ACTIONS(2824),
    [anon_sym_AMP_EQ] = ACTIONS(2824),
    [anon_sym_CARET_EQ] = ACTIONS(2824),
    [anon_sym_PIPE_EQ] = ACTIONS(2824),
    [anon_sym_and_eq] = ACTIONS(2826),
    [anon_sym_or_eq] = ACTIONS(2826),
    [anon_sym_xor_eq] = ACTIONS(2826),
    [anon_sym_LT_EQ_GT] = ACTIONS(2824),
    [anon_sym_or] = ACTIONS(2826),
    [anon_sym_and] = ACTIONS(2826),
    [anon_sym_bitor] = ACTIONS(2826),
    [anon_sym_xor] = ACTIONS(2826),
    [anon_sym_bitand] = ACTIONS(2826),
    [anon_sym_not_eq] = ACTIONS(2826),
    [anon_sym_is] = ACTIONS(2826),
    [anon_sym_as] = ACTIONS(2826),
    [anon_sym_DASH_DASH] = ACTIONS(2824),
    [anon_sym_PLUS_PLUS] = ACTIONS(2824),
    [anon_sym_DOT] = ACTIONS(2826),
    [anon_sym_DOT_STAR] = ACTIONS(2824),
    [anon_sym_DASH_GT] = ACTIONS(2824),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2826),
    [anon_sym_let] = ACTIONS(2826),
    [anon_sym_This] = ACTIONS(2826),
  },
  [3011] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3021),
    [sym_identifier] = ACTIONS(6677),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3822),
    [anon_sym_COMMA] = ACTIONS(3822),
    [aux_sym_preproc_if_token2] = ACTIONS(3822),
    [aux_sym_preproc_else_token1] = ACTIONS(3822),
    [aux_sym_preproc_elif_token1] = ACTIONS(3820),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3822),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3822),
    [anon_sym_LPAREN2] = ACTIONS(3822),
    [anon_sym_DASH] = ACTIONS(3820),
    [anon_sym_PLUS] = ACTIONS(3820),
    [anon_sym_STAR] = ACTIONS(3820),
    [anon_sym_SLASH] = ACTIONS(3820),
    [anon_sym_PERCENT] = ACTIONS(3820),
    [anon_sym_PIPE_PIPE] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3822),
    [anon_sym_PIPE] = ACTIONS(3820),
    [anon_sym_CARET] = ACTIONS(3820),
    [anon_sym_AMP] = ACTIONS(3820),
    [anon_sym_EQ_EQ] = ACTIONS(3822),
    [anon_sym_BANG_EQ] = ACTIONS(3822),
    [anon_sym_GT] = ACTIONS(3820),
    [anon_sym_GT_EQ] = ACTIONS(3822),
    [anon_sym_LT_EQ] = ACTIONS(3820),
    [anon_sym_LT] = ACTIONS(3820),
    [anon_sym_LT_LT] = ACTIONS(3820),
    [anon_sym_GT_GT] = ACTIONS(3820),
    [anon_sym___attribute__] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3822),
    [anon_sym_signed] = ACTIONS(6680),
    [anon_sym_unsigned] = ACTIONS(6680),
    [anon_sym_long] = ACTIONS(6680),
    [anon_sym_short] = ACTIONS(6680),
    [anon_sym_LBRACK] = ACTIONS(3822),
    [anon_sym_EQ] = ACTIONS(3820),
    [sym_primitive_type] = ACTIONS(6682),
    [anon_sym_QMARK] = ACTIONS(3822),
    [anon_sym_STAR_EQ] = ACTIONS(3822),
    [anon_sym_SLASH_EQ] = ACTIONS(3822),
    [anon_sym_PERCENT_EQ] = ACTIONS(3822),
    [anon_sym_PLUS_EQ] = ACTIONS(3822),
    [anon_sym_DASH_EQ] = ACTIONS(3822),
    [anon_sym_LT_LT_EQ] = ACTIONS(3822),
    [anon_sym_GT_GT_EQ] = ACTIONS(3822),
    [anon_sym_AMP_EQ] = ACTIONS(3822),
    [anon_sym_CARET_EQ] = ACTIONS(3822),
    [anon_sym_PIPE_EQ] = ACTIONS(3822),
    [anon_sym_and_eq] = ACTIONS(3820),
    [anon_sym_or_eq] = ACTIONS(3820),
    [anon_sym_xor_eq] = ACTIONS(3820),
    [anon_sym_LT_EQ_GT] = ACTIONS(3822),
    [anon_sym_or] = ACTIONS(3820),
    [anon_sym_and] = ACTIONS(3820),
    [anon_sym_bitor] = ACTIONS(3820),
    [anon_sym_xor] = ACTIONS(3820),
    [anon_sym_bitand] = ACTIONS(3820),
    [anon_sym_not_eq] = ACTIONS(3820),
    [anon_sym_is] = ACTIONS(3820),
    [anon_sym_as] = ACTIONS(3820),
    [anon_sym_DASH_DASH] = ACTIONS(3822),
    [anon_sym_PLUS_PLUS] = ACTIONS(3822),
    [anon_sym_DOT] = ACTIONS(3820),
    [anon_sym_DOT_STAR] = ACTIONS(3822),
    [anon_sym_DASH_GT] = ACTIONS(3822),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3820),
    [anon_sym_let] = ACTIONS(3820),
    [anon_sym_This] = ACTIONS(3820),
  },
  [3012] = {
    [sym_string_literal] = STATE(3342),
    [sym_template_argument_list] = STATE(4579),
    [sym_raw_string_literal] = STATE(3342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(6208),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON] = ACTIONS(6684),
    [anon_sym_SEMI] = ACTIONS(2117),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2117),
    [anon_sym_EQ] = ACTIONS(2152),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2154),
    [anon_sym_SLASH_EQ] = ACTIONS(2154),
    [anon_sym_PERCENT_EQ] = ACTIONS(2154),
    [anon_sym_PLUS_EQ] = ACTIONS(2154),
    [anon_sym_DASH_EQ] = ACTIONS(2154),
    [anon_sym_LT_LT_EQ] = ACTIONS(2154),
    [anon_sym_GT_GT_EQ] = ACTIONS(2154),
    [anon_sym_AMP_EQ] = ACTIONS(2154),
    [anon_sym_CARET_EQ] = ACTIONS(2154),
    [anon_sym_PIPE_EQ] = ACTIONS(2154),
    [anon_sym_and_eq] = ACTIONS(2154),
    [anon_sym_or_eq] = ACTIONS(2154),
    [anon_sym_xor_eq] = ACTIONS(2154),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2117),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2117),
    [anon_sym_not_eq] = ACTIONS(2117),
    [anon_sym_is] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
  },
  [3013] = {
    [sym_attribute_specifier] = STATE(3068),
    [sym_identifier] = ACTIONS(3735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3737),
    [anon_sym_COMMA] = ACTIONS(3737),
    [anon_sym_RPAREN] = ACTIONS(3737),
    [aux_sym_preproc_if_token2] = ACTIONS(3737),
    [aux_sym_preproc_else_token1] = ACTIONS(3737),
    [aux_sym_preproc_elif_token1] = ACTIONS(3735),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3737),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3737),
    [anon_sym_LPAREN2] = ACTIONS(3737),
    [anon_sym_DASH] = ACTIONS(3735),
    [anon_sym_PLUS] = ACTIONS(3735),
    [anon_sym_STAR] = ACTIONS(3735),
    [anon_sym_SLASH] = ACTIONS(3735),
    [anon_sym_PERCENT] = ACTIONS(3735),
    [anon_sym_PIPE_PIPE] = ACTIONS(3737),
    [anon_sym_AMP_AMP] = ACTIONS(3737),
    [anon_sym_PIPE] = ACTIONS(3735),
    [anon_sym_CARET] = ACTIONS(3735),
    [anon_sym_AMP] = ACTIONS(3735),
    [anon_sym_EQ_EQ] = ACTIONS(3737),
    [anon_sym_BANG_EQ] = ACTIONS(3737),
    [anon_sym_GT] = ACTIONS(3735),
    [anon_sym_GT_EQ] = ACTIONS(3737),
    [anon_sym_LT_EQ] = ACTIONS(3735),
    [anon_sym_LT] = ACTIONS(3735),
    [anon_sym_LT_LT] = ACTIONS(3735),
    [anon_sym_GT_GT] = ACTIONS(3735),
    [anon_sym_COLON] = ACTIONS(3737),
    [anon_sym_SEMI] = ACTIONS(3737),
    [anon_sym___attribute__] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(3737),
    [anon_sym_RBRACE] = ACTIONS(3737),
    [anon_sym_LBRACK] = ACTIONS(3737),
    [anon_sym_RBRACK] = ACTIONS(3737),
    [anon_sym_EQ] = ACTIONS(3735),
    [anon_sym_QMARK] = ACTIONS(3737),
    [anon_sym_STAR_EQ] = ACTIONS(3737),
    [anon_sym_SLASH_EQ] = ACTIONS(3737),
    [anon_sym_PERCENT_EQ] = ACTIONS(3737),
    [anon_sym_PLUS_EQ] = ACTIONS(3737),
    [anon_sym_DASH_EQ] = ACTIONS(3737),
    [anon_sym_LT_LT_EQ] = ACTIONS(3737),
    [anon_sym_GT_GT_EQ] = ACTIONS(3737),
    [anon_sym_AMP_EQ] = ACTIONS(3737),
    [anon_sym_CARET_EQ] = ACTIONS(3737),
    [anon_sym_PIPE_EQ] = ACTIONS(3737),
    [anon_sym_and_eq] = ACTIONS(3735),
    [anon_sym_or_eq] = ACTIONS(3735),
    [anon_sym_xor_eq] = ACTIONS(3735),
    [anon_sym_LT_EQ_GT] = ACTIONS(3737),
    [anon_sym_or] = ACTIONS(3735),
    [anon_sym_and] = ACTIONS(3735),
    [anon_sym_bitor] = ACTIONS(3735),
    [anon_sym_xor] = ACTIONS(3735),
    [anon_sym_bitand] = ACTIONS(3735),
    [anon_sym_not_eq] = ACTIONS(3735),
    [anon_sym_is] = ACTIONS(3735),
    [anon_sym_as] = ACTIONS(3735),
    [anon_sym_DASH_DASH] = ACTIONS(3737),
    [anon_sym_PLUS_PLUS] = ACTIONS(3737),
    [anon_sym_DOT] = ACTIONS(3735),
    [anon_sym_DOT_STAR] = ACTIONS(3737),
    [anon_sym_DASH_GT] = ACTIONS(3737),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3735),
    [anon_sym_let] = ACTIONS(3735),
    [anon_sym_This] = ACTIONS(3735),
  },
  [3014] = {
    [sym_attribute_specifier] = STATE(3073),
    [sym_identifier] = ACTIONS(3725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3727),
    [anon_sym_COMMA] = ACTIONS(3727),
    [anon_sym_RPAREN] = ACTIONS(3727),
    [aux_sym_preproc_if_token2] = ACTIONS(3727),
    [aux_sym_preproc_else_token1] = ACTIONS(3727),
    [aux_sym_preproc_elif_token1] = ACTIONS(3725),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3727),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3727),
    [anon_sym_LPAREN2] = ACTIONS(3727),
    [anon_sym_DASH] = ACTIONS(3725),
    [anon_sym_PLUS] = ACTIONS(3725),
    [anon_sym_STAR] = ACTIONS(3725),
    [anon_sym_SLASH] = ACTIONS(3725),
    [anon_sym_PERCENT] = ACTIONS(3725),
    [anon_sym_PIPE_PIPE] = ACTIONS(3727),
    [anon_sym_AMP_AMP] = ACTIONS(3727),
    [anon_sym_PIPE] = ACTIONS(3725),
    [anon_sym_CARET] = ACTIONS(3725),
    [anon_sym_AMP] = ACTIONS(3725),
    [anon_sym_EQ_EQ] = ACTIONS(3727),
    [anon_sym_BANG_EQ] = ACTIONS(3727),
    [anon_sym_GT] = ACTIONS(3725),
    [anon_sym_GT_EQ] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(3725),
    [anon_sym_LT] = ACTIONS(3725),
    [anon_sym_LT_LT] = ACTIONS(3725),
    [anon_sym_GT_GT] = ACTIONS(3725),
    [anon_sym_COLON] = ACTIONS(3727),
    [anon_sym_SEMI] = ACTIONS(3727),
    [anon_sym___attribute__] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(3727),
    [anon_sym_RBRACE] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(3727),
    [anon_sym_RBRACK] = ACTIONS(3727),
    [anon_sym_EQ] = ACTIONS(3725),
    [anon_sym_QMARK] = ACTIONS(3727),
    [anon_sym_STAR_EQ] = ACTIONS(3727),
    [anon_sym_SLASH_EQ] = ACTIONS(3727),
    [anon_sym_PERCENT_EQ] = ACTIONS(3727),
    [anon_sym_PLUS_EQ] = ACTIONS(3727),
    [anon_sym_DASH_EQ] = ACTIONS(3727),
    [anon_sym_LT_LT_EQ] = ACTIONS(3727),
    [anon_sym_GT_GT_EQ] = ACTIONS(3727),
    [anon_sym_AMP_EQ] = ACTIONS(3727),
    [anon_sym_CARET_EQ] = ACTIONS(3727),
    [anon_sym_PIPE_EQ] = ACTIONS(3727),
    [anon_sym_and_eq] = ACTIONS(3725),
    [anon_sym_or_eq] = ACTIONS(3725),
    [anon_sym_xor_eq] = ACTIONS(3725),
    [anon_sym_LT_EQ_GT] = ACTIONS(3727),
    [anon_sym_or] = ACTIONS(3725),
    [anon_sym_and] = ACTIONS(3725),
    [anon_sym_bitor] = ACTIONS(3725),
    [anon_sym_xor] = ACTIONS(3725),
    [anon_sym_bitand] = ACTIONS(3725),
    [anon_sym_not_eq] = ACTIONS(3725),
    [anon_sym_is] = ACTIONS(3725),
    [anon_sym_as] = ACTIONS(3725),
    [anon_sym_DASH_DASH] = ACTIONS(3727),
    [anon_sym_PLUS_PLUS] = ACTIONS(3727),
    [anon_sym_DOT] = ACTIONS(3725),
    [anon_sym_DOT_STAR] = ACTIONS(3727),
    [anon_sym_DASH_GT] = ACTIONS(3727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3725),
    [anon_sym_let] = ACTIONS(3725),
    [anon_sym_This] = ACTIONS(3725),
  },
  [3015] = {
    [sym_attribute_specifier] = STATE(3074),
    [sym_identifier] = ACTIONS(3731),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3733),
    [anon_sym_COMMA] = ACTIONS(3733),
    [anon_sym_RPAREN] = ACTIONS(3733),
    [aux_sym_preproc_if_token2] = ACTIONS(3733),
    [aux_sym_preproc_else_token1] = ACTIONS(3733),
    [aux_sym_preproc_elif_token1] = ACTIONS(3731),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3733),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3733),
    [anon_sym_LPAREN2] = ACTIONS(3733),
    [anon_sym_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3731),
    [anon_sym_STAR] = ACTIONS(3731),
    [anon_sym_SLASH] = ACTIONS(3731),
    [anon_sym_PERCENT] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3733),
    [anon_sym_AMP_AMP] = ACTIONS(3733),
    [anon_sym_PIPE] = ACTIONS(3731),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_AMP] = ACTIONS(3731),
    [anon_sym_EQ_EQ] = ACTIONS(3733),
    [anon_sym_BANG_EQ] = ACTIONS(3733),
    [anon_sym_GT] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3733),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_LT] = ACTIONS(3731),
    [anon_sym_LT_LT] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3731),
    [anon_sym_COLON] = ACTIONS(3733),
    [anon_sym_SEMI] = ACTIONS(3733),
    [anon_sym___attribute__] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(3733),
    [anon_sym_RBRACE] = ACTIONS(3733),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_RBRACK] = ACTIONS(3733),
    [anon_sym_EQ] = ACTIONS(3731),
    [anon_sym_QMARK] = ACTIONS(3733),
    [anon_sym_STAR_EQ] = ACTIONS(3733),
    [anon_sym_SLASH_EQ] = ACTIONS(3733),
    [anon_sym_PERCENT_EQ] = ACTIONS(3733),
    [anon_sym_PLUS_EQ] = ACTIONS(3733),
    [anon_sym_DASH_EQ] = ACTIONS(3733),
    [anon_sym_LT_LT_EQ] = ACTIONS(3733),
    [anon_sym_GT_GT_EQ] = ACTIONS(3733),
    [anon_sym_AMP_EQ] = ACTIONS(3733),
    [anon_sym_CARET_EQ] = ACTIONS(3733),
    [anon_sym_PIPE_EQ] = ACTIONS(3733),
    [anon_sym_and_eq] = ACTIONS(3731),
    [anon_sym_or_eq] = ACTIONS(3731),
    [anon_sym_xor_eq] = ACTIONS(3731),
    [anon_sym_LT_EQ_GT] = ACTIONS(3733),
    [anon_sym_or] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3731),
    [anon_sym_bitor] = ACTIONS(3731),
    [anon_sym_xor] = ACTIONS(3731),
    [anon_sym_bitand] = ACTIONS(3731),
    [anon_sym_not_eq] = ACTIONS(3731),
    [anon_sym_is] = ACTIONS(3731),
    [anon_sym_as] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3733),
    [anon_sym_PLUS_PLUS] = ACTIONS(3733),
    [anon_sym_DOT] = ACTIONS(3731),
    [anon_sym_DOT_STAR] = ACTIONS(3733),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3731),
    [anon_sym_let] = ACTIONS(3731),
    [anon_sym_This] = ACTIONS(3731),
  },
  [3016] = {
    [sym_attribute_specifier] = STATE(3070),
    [sym_identifier] = ACTIONS(3742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3744),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_RPAREN] = ACTIONS(3744),
    [aux_sym_preproc_if_token2] = ACTIONS(3744),
    [aux_sym_preproc_else_token1] = ACTIONS(3744),
    [aux_sym_preproc_elif_token1] = ACTIONS(3742),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3744),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3744),
    [anon_sym_LPAREN2] = ACTIONS(3744),
    [anon_sym_DASH] = ACTIONS(3742),
    [anon_sym_PLUS] = ACTIONS(3742),
    [anon_sym_STAR] = ACTIONS(3742),
    [anon_sym_SLASH] = ACTIONS(3742),
    [anon_sym_PERCENT] = ACTIONS(3742),
    [anon_sym_PIPE_PIPE] = ACTIONS(3744),
    [anon_sym_AMP_AMP] = ACTIONS(3744),
    [anon_sym_PIPE] = ACTIONS(3742),
    [anon_sym_CARET] = ACTIONS(3742),
    [anon_sym_AMP] = ACTIONS(3742),
    [anon_sym_EQ_EQ] = ACTIONS(3744),
    [anon_sym_BANG_EQ] = ACTIONS(3744),
    [anon_sym_GT] = ACTIONS(3742),
    [anon_sym_GT_EQ] = ACTIONS(3744),
    [anon_sym_LT_EQ] = ACTIONS(3742),
    [anon_sym_LT] = ACTIONS(3742),
    [anon_sym_LT_LT] = ACTIONS(3742),
    [anon_sym_GT_GT] = ACTIONS(3742),
    [anon_sym_COLON] = ACTIONS(3744),
    [anon_sym_SEMI] = ACTIONS(3744),
    [anon_sym___attribute__] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(3744),
    [anon_sym_RBRACE] = ACTIONS(3744),
    [anon_sym_LBRACK] = ACTIONS(3744),
    [anon_sym_RBRACK] = ACTIONS(3744),
    [anon_sym_EQ] = ACTIONS(3742),
    [anon_sym_QMARK] = ACTIONS(3744),
    [anon_sym_STAR_EQ] = ACTIONS(3744),
    [anon_sym_SLASH_EQ] = ACTIONS(3744),
    [anon_sym_PERCENT_EQ] = ACTIONS(3744),
    [anon_sym_PLUS_EQ] = ACTIONS(3744),
    [anon_sym_DASH_EQ] = ACTIONS(3744),
    [anon_sym_LT_LT_EQ] = ACTIONS(3744),
    [anon_sym_GT_GT_EQ] = ACTIONS(3744),
    [anon_sym_AMP_EQ] = ACTIONS(3744),
    [anon_sym_CARET_EQ] = ACTIONS(3744),
    [anon_sym_PIPE_EQ] = ACTIONS(3744),
    [anon_sym_and_eq] = ACTIONS(3742),
    [anon_sym_or_eq] = ACTIONS(3742),
    [anon_sym_xor_eq] = ACTIONS(3742),
    [anon_sym_LT_EQ_GT] = ACTIONS(3744),
    [anon_sym_or] = ACTIONS(3742),
    [anon_sym_and] = ACTIONS(3742),
    [anon_sym_bitor] = ACTIONS(3742),
    [anon_sym_xor] = ACTIONS(3742),
    [anon_sym_bitand] = ACTIONS(3742),
    [anon_sym_not_eq] = ACTIONS(3742),
    [anon_sym_is] = ACTIONS(3742),
    [anon_sym_as] = ACTIONS(3742),
    [anon_sym_DASH_DASH] = ACTIONS(3744),
    [anon_sym_PLUS_PLUS] = ACTIONS(3744),
    [anon_sym_DOT] = ACTIONS(3742),
    [anon_sym_DOT_STAR] = ACTIONS(3744),
    [anon_sym_DASH_GT] = ACTIONS(3744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3742),
    [anon_sym_let] = ACTIONS(3742),
    [anon_sym_This] = ACTIONS(3742),
  },
  [3017] = {
    [sym_identifier] = ACTIONS(6686),
    [anon_sym___extension__] = ACTIONS(6686),
    [anon_sym_in] = ACTIONS(6686),
    [anon_sym_out] = ACTIONS(6686),
    [anon_sym_inout] = ACTIONS(6686),
    [anon_sym_extern] = ACTIONS(6686),
    [anon_sym___attribute__] = ACTIONS(6686),
    [anon_sym_COLON_COLON] = ACTIONS(6688),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6688),
    [anon_sym___declspec] = ACTIONS(6686),
    [anon_sym_signed] = ACTIONS(6686),
    [anon_sym_unsigned] = ACTIONS(6686),
    [anon_sym_long] = ACTIONS(6686),
    [anon_sym_short] = ACTIONS(6686),
    [anon_sym_static] = ACTIONS(6686),
    [anon_sym_register] = ACTIONS(6686),
    [anon_sym_inline] = ACTIONS(6686),
    [anon_sym___inline] = ACTIONS(6686),
    [anon_sym___inline__] = ACTIONS(6686),
    [anon_sym___forceinline] = ACTIONS(6686),
    [anon_sym_thread_local] = ACTIONS(6686),
    [anon_sym___thread] = ACTIONS(6686),
    [anon_sym_const] = ACTIONS(6686),
    [anon_sym_constexpr] = ACTIONS(6686),
    [anon_sym_volatile] = ACTIONS(6686),
    [anon_sym_restrict] = ACTIONS(6686),
    [anon_sym___restrict__] = ACTIONS(6686),
    [anon_sym__Atomic] = ACTIONS(6686),
    [anon_sym__Noreturn] = ACTIONS(6686),
    [anon_sym_noreturn] = ACTIONS(6686),
    [anon_sym_mutable] = ACTIONS(6686),
    [anon_sym_constinit] = ACTIONS(6686),
    [anon_sym_consteval] = ACTIONS(6686),
    [anon_sym_alignas] = ACTIONS(6686),
    [anon_sym__Alignas] = ACTIONS(6686),
    [sym_primitive_type] = ACTIONS(6686),
    [anon_sym_enum] = ACTIONS(6686),
    [anon_sym_class] = ACTIONS(6686),
    [anon_sym_struct] = ACTIONS(6686),
    [anon_sym_union] = ACTIONS(6686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6686),
    [anon_sym_let] = ACTIONS(6686),
    [anon_sym_This] = ACTIONS(6686),
    [anon_sym_decltype] = ACTIONS(6686),
    [sym_virtual] = ACTIONS(6686),
    [anon_sym_typename] = ACTIONS(6686),
    [anon_sym_template] = ACTIONS(6686),
    [anon_sym_precise] = ACTIONS(6686),
    [anon_sym_shared] = ACTIONS(6686),
    [anon_sym_groupshared] = ACTIONS(6686),
    [anon_sym_uniform] = ACTIONS(6686),
    [anon_sym_row_major] = ACTIONS(6686),
    [anon_sym_column_major] = ACTIONS(6686),
    [anon_sym_globallycoherent] = ACTIONS(6686),
    [anon_sym_centroid] = ACTIONS(6686),
    [anon_sym_noperspective] = ACTIONS(6686),
    [anon_sym_nointerpolation] = ACTIONS(6686),
    [anon_sym_sample] = ACTIONS(6686),
    [anon_sym_linear] = ACTIONS(6686),
    [anon_sym_snorm] = ACTIONS(6686),
    [anon_sym_unorm] = ACTIONS(6686),
    [anon_sym_point] = ACTIONS(6686),
    [anon_sym_line] = ACTIONS(6686),
    [anon_sym_triangleadj] = ACTIONS(6686),
    [anon_sym_lineadj] = ACTIONS(6686),
    [anon_sym_triangle] = ACTIONS(6686),
    [anon_sym_interface] = ACTIONS(6686),
    [anon_sym_extension] = ACTIONS(6686),
  },
  [3018] = {
    [sym_attribute_specifier] = STATE(3082),
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3797),
    [anon_sym_COMMA] = ACTIONS(3797),
    [anon_sym_RPAREN] = ACTIONS(3797),
    [aux_sym_preproc_if_token2] = ACTIONS(3797),
    [aux_sym_preproc_else_token1] = ACTIONS(3797),
    [aux_sym_preproc_elif_token1] = ACTIONS(3795),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3797),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3797),
    [anon_sym_LPAREN2] = ACTIONS(3797),
    [anon_sym_DASH] = ACTIONS(3795),
    [anon_sym_PLUS] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(3795),
    [anon_sym_SLASH] = ACTIONS(3795),
    [anon_sym_PERCENT] = ACTIONS(3795),
    [anon_sym_PIPE_PIPE] = ACTIONS(3797),
    [anon_sym_AMP_AMP] = ACTIONS(3797),
    [anon_sym_PIPE] = ACTIONS(3795),
    [anon_sym_CARET] = ACTIONS(3795),
    [anon_sym_AMP] = ACTIONS(3795),
    [anon_sym_EQ_EQ] = ACTIONS(3797),
    [anon_sym_BANG_EQ] = ACTIONS(3797),
    [anon_sym_GT] = ACTIONS(3795),
    [anon_sym_GT_EQ] = ACTIONS(3797),
    [anon_sym_LT_EQ] = ACTIONS(3795),
    [anon_sym_LT] = ACTIONS(3795),
    [anon_sym_LT_LT] = ACTIONS(3795),
    [anon_sym_GT_GT] = ACTIONS(3795),
    [anon_sym_COLON] = ACTIONS(3797),
    [anon_sym_SEMI] = ACTIONS(3797),
    [anon_sym___attribute__] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(3797),
    [anon_sym_RBRACE] = ACTIONS(3797),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_RBRACK] = ACTIONS(3797),
    [anon_sym_EQ] = ACTIONS(3795),
    [anon_sym_QMARK] = ACTIONS(3797),
    [anon_sym_STAR_EQ] = ACTIONS(3797),
    [anon_sym_SLASH_EQ] = ACTIONS(3797),
    [anon_sym_PERCENT_EQ] = ACTIONS(3797),
    [anon_sym_PLUS_EQ] = ACTIONS(3797),
    [anon_sym_DASH_EQ] = ACTIONS(3797),
    [anon_sym_LT_LT_EQ] = ACTIONS(3797),
    [anon_sym_GT_GT_EQ] = ACTIONS(3797),
    [anon_sym_AMP_EQ] = ACTIONS(3797),
    [anon_sym_CARET_EQ] = ACTIONS(3797),
    [anon_sym_PIPE_EQ] = ACTIONS(3797),
    [anon_sym_and_eq] = ACTIONS(3795),
    [anon_sym_or_eq] = ACTIONS(3795),
    [anon_sym_xor_eq] = ACTIONS(3795),
    [anon_sym_LT_EQ_GT] = ACTIONS(3797),
    [anon_sym_or] = ACTIONS(3795),
    [anon_sym_and] = ACTIONS(3795),
    [anon_sym_bitor] = ACTIONS(3795),
    [anon_sym_xor] = ACTIONS(3795),
    [anon_sym_bitand] = ACTIONS(3795),
    [anon_sym_not_eq] = ACTIONS(3795),
    [anon_sym_is] = ACTIONS(3795),
    [anon_sym_as] = ACTIONS(3795),
    [anon_sym_DASH_DASH] = ACTIONS(3797),
    [anon_sym_PLUS_PLUS] = ACTIONS(3797),
    [anon_sym_DOT] = ACTIONS(3795),
    [anon_sym_DOT_STAR] = ACTIONS(3797),
    [anon_sym_DASH_GT] = ACTIONS(3797),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3795),
    [anon_sym_let] = ACTIONS(3795),
    [anon_sym_This] = ACTIONS(3795),
  },
  [3019] = {
    [sym_string_literal] = STATE(3006),
    [sym_raw_string_literal] = STATE(3006),
    [aux_sym_concatenated_string_repeat1] = STATE(3006),
    [sym_identifier] = ACTIONS(6690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6456),
    [anon_sym_COMMA] = ACTIONS(6456),
    [anon_sym_LPAREN2] = ACTIONS(6456),
    [anon_sym_DASH] = ACTIONS(6458),
    [anon_sym_PLUS] = ACTIONS(6458),
    [anon_sym_STAR] = ACTIONS(6458),
    [anon_sym_SLASH] = ACTIONS(6458),
    [anon_sym_PERCENT] = ACTIONS(6458),
    [anon_sym_PIPE_PIPE] = ACTIONS(6456),
    [anon_sym_AMP_AMP] = ACTIONS(6456),
    [anon_sym_PIPE] = ACTIONS(6458),
    [anon_sym_CARET] = ACTIONS(6458),
    [anon_sym_AMP] = ACTIONS(6458),
    [anon_sym_EQ_EQ] = ACTIONS(6456),
    [anon_sym_BANG_EQ] = ACTIONS(6456),
    [anon_sym_GT] = ACTIONS(6458),
    [anon_sym_GT_EQ] = ACTIONS(6456),
    [anon_sym_LT_EQ] = ACTIONS(6458),
    [anon_sym_LT] = ACTIONS(6458),
    [anon_sym_LT_LT] = ACTIONS(6458),
    [anon_sym_GT_GT] = ACTIONS(6458),
    [anon_sym_SEMI] = ACTIONS(6456),
    [anon_sym___attribute__] = ACTIONS(6458),
    [anon_sym_LBRACK] = ACTIONS(6456),
    [anon_sym_EQ] = ACTIONS(6458),
    [anon_sym_QMARK] = ACTIONS(6456),
    [anon_sym_STAR_EQ] = ACTIONS(6456),
    [anon_sym_SLASH_EQ] = ACTIONS(6456),
    [anon_sym_PERCENT_EQ] = ACTIONS(6456),
    [anon_sym_PLUS_EQ] = ACTIONS(6456),
    [anon_sym_DASH_EQ] = ACTIONS(6456),
    [anon_sym_LT_LT_EQ] = ACTIONS(6456),
    [anon_sym_GT_GT_EQ] = ACTIONS(6456),
    [anon_sym_AMP_EQ] = ACTIONS(6456),
    [anon_sym_CARET_EQ] = ACTIONS(6456),
    [anon_sym_PIPE_EQ] = ACTIONS(6456),
    [anon_sym_and_eq] = ACTIONS(6458),
    [anon_sym_or_eq] = ACTIONS(6458),
    [anon_sym_xor_eq] = ACTIONS(6458),
    [anon_sym_LT_EQ_GT] = ACTIONS(6456),
    [anon_sym_or] = ACTIONS(6458),
    [anon_sym_and] = ACTIONS(6458),
    [anon_sym_bitor] = ACTIONS(6458),
    [anon_sym_xor] = ACTIONS(6458),
    [anon_sym_bitand] = ACTIONS(6458),
    [anon_sym_not_eq] = ACTIONS(6458),
    [anon_sym_is] = ACTIONS(6458),
    [anon_sym_as] = ACTIONS(6458),
    [anon_sym_DASH_DASH] = ACTIONS(6456),
    [anon_sym_PLUS_PLUS] = ACTIONS(6456),
    [anon_sym_DOT] = ACTIONS(6458),
    [anon_sym_DOT_STAR] = ACTIONS(6456),
    [anon_sym_DASH_GT] = ACTIONS(6456),
    [anon_sym_L_DQUOTE] = ACTIONS(6692),
    [anon_sym_u_DQUOTE] = ACTIONS(6692),
    [anon_sym_U_DQUOTE] = ACTIONS(6692),
    [anon_sym_u8_DQUOTE] = ACTIONS(6692),
    [anon_sym_DQUOTE] = ACTIONS(6692),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6694),
    [anon_sym_LR_DQUOTE] = ACTIONS(6694),
    [anon_sym_uR_DQUOTE] = ACTIONS(6694),
    [anon_sym_UR_DQUOTE] = ACTIONS(6694),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6694),
    [sym_literal_suffix] = ACTIONS(6458),
  },
  [3020] = {
    [sym_identifier] = ACTIONS(6136),
    [anon_sym_LPAREN2] = ACTIONS(6138),
    [anon_sym_BANG] = ACTIONS(6138),
    [anon_sym_TILDE] = ACTIONS(6138),
    [anon_sym_DASH] = ACTIONS(6136),
    [anon_sym_PLUS] = ACTIONS(6136),
    [anon_sym_STAR] = ACTIONS(6138),
    [anon_sym_AMP] = ACTIONS(6138),
    [anon_sym___extension__] = ACTIONS(6136),
    [anon_sym_COLON_COLON] = ACTIONS(6138),
    [anon_sym_LBRACK] = ACTIONS(6138),
    [anon_sym_static] = ACTIONS(6136),
    [anon_sym_RBRACK] = ACTIONS(6138),
    [anon_sym_const] = ACTIONS(6136),
    [anon_sym_constexpr] = ACTIONS(6136),
    [anon_sym_volatile] = ACTIONS(6136),
    [anon_sym_restrict] = ACTIONS(6136),
    [anon_sym___restrict__] = ACTIONS(6136),
    [anon_sym__Atomic] = ACTIONS(6136),
    [anon_sym__Noreturn] = ACTIONS(6136),
    [anon_sym_noreturn] = ACTIONS(6136),
    [anon_sym_mutable] = ACTIONS(6136),
    [anon_sym_constinit] = ACTIONS(6136),
    [anon_sym_consteval] = ACTIONS(6136),
    [anon_sym_alignas] = ACTIONS(6136),
    [anon_sym__Alignas] = ACTIONS(6136),
    [sym_primitive_type] = ACTIONS(6136),
    [anon_sym_not] = ACTIONS(6136),
    [anon_sym_compl] = ACTIONS(6136),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_sizeof] = ACTIONS(6136),
    [anon_sym___alignof__] = ACTIONS(6136),
    [anon_sym___alignof] = ACTIONS(6136),
    [anon_sym__alignof] = ACTIONS(6136),
    [anon_sym_alignof] = ACTIONS(6136),
    [anon_sym__Alignof] = ACTIONS(6136),
    [anon_sym_offsetof] = ACTIONS(6136),
    [anon_sym__Generic] = ACTIONS(6136),
    [anon_sym_asm] = ACTIONS(6136),
    [anon_sym___asm__] = ACTIONS(6136),
    [sym_number_literal] = ACTIONS(6138),
    [anon_sym_L_SQUOTE] = ACTIONS(6138),
    [anon_sym_u_SQUOTE] = ACTIONS(6138),
    [anon_sym_U_SQUOTE] = ACTIONS(6138),
    [anon_sym_u8_SQUOTE] = ACTIONS(6138),
    [anon_sym_SQUOTE] = ACTIONS(6138),
    [anon_sym_L_DQUOTE] = ACTIONS(6138),
    [anon_sym_u_DQUOTE] = ACTIONS(6138),
    [anon_sym_U_DQUOTE] = ACTIONS(6138),
    [anon_sym_u8_DQUOTE] = ACTIONS(6138),
    [anon_sym_DQUOTE] = ACTIONS(6138),
    [sym_true] = ACTIONS(6136),
    [sym_false] = ACTIONS(6136),
    [anon_sym_NULL] = ACTIONS(6136),
    [anon_sym_nullptr] = ACTIONS(6136),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(6136),
    [anon_sym_template] = ACTIONS(6136),
    [anon_sym_delete] = ACTIONS(6136),
    [anon_sym_R_DQUOTE] = ACTIONS(6138),
    [anon_sym_LR_DQUOTE] = ACTIONS(6138),
    [anon_sym_uR_DQUOTE] = ACTIONS(6138),
    [anon_sym_UR_DQUOTE] = ACTIONS(6138),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6138),
    [anon_sym_co_await] = ACTIONS(6136),
    [anon_sym_new] = ACTIONS(6136),
    [anon_sym_requires] = ACTIONS(6136),
    [sym_this] = ACTIONS(6136),
  },
  [3021] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2872),
    [sym_identifier] = ACTIONS(3778),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3781),
    [aux_sym_preproc_if_token2] = ACTIONS(3781),
    [aux_sym_preproc_else_token1] = ACTIONS(3781),
    [aux_sym_preproc_elif_token1] = ACTIONS(3778),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3781),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3781),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_DASH] = ACTIONS(3778),
    [anon_sym_PLUS] = ACTIONS(3778),
    [anon_sym_STAR] = ACTIONS(3778),
    [anon_sym_SLASH] = ACTIONS(3778),
    [anon_sym_PERCENT] = ACTIONS(3778),
    [anon_sym_PIPE_PIPE] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_PIPE] = ACTIONS(3778),
    [anon_sym_CARET] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_GT] = ACTIONS(3778),
    [anon_sym_GT_EQ] = ACTIONS(3781),
    [anon_sym_LT_EQ] = ACTIONS(3778),
    [anon_sym_LT] = ACTIONS(3778),
    [anon_sym_LT_LT] = ACTIONS(3778),
    [anon_sym_GT_GT] = ACTIONS(3778),
    [anon_sym___attribute__] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_signed] = ACTIONS(6521),
    [anon_sym_unsigned] = ACTIONS(6521),
    [anon_sym_long] = ACTIONS(6521),
    [anon_sym_short] = ACTIONS(6521),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3778),
    [sym_primitive_type] = ACTIONS(2856),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_STAR_EQ] = ACTIONS(3781),
    [anon_sym_SLASH_EQ] = ACTIONS(3781),
    [anon_sym_PERCENT_EQ] = ACTIONS(3781),
    [anon_sym_PLUS_EQ] = ACTIONS(3781),
    [anon_sym_DASH_EQ] = ACTIONS(3781),
    [anon_sym_LT_LT_EQ] = ACTIONS(3781),
    [anon_sym_GT_GT_EQ] = ACTIONS(3781),
    [anon_sym_AMP_EQ] = ACTIONS(3781),
    [anon_sym_CARET_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_and_eq] = ACTIONS(3778),
    [anon_sym_or_eq] = ACTIONS(3778),
    [anon_sym_xor_eq] = ACTIONS(3778),
    [anon_sym_LT_EQ_GT] = ACTIONS(3781),
    [anon_sym_or] = ACTIONS(3778),
    [anon_sym_and] = ACTIONS(3778),
    [anon_sym_bitor] = ACTIONS(3778),
    [anon_sym_xor] = ACTIONS(3778),
    [anon_sym_bitand] = ACTIONS(3778),
    [anon_sym_not_eq] = ACTIONS(3778),
    [anon_sym_is] = ACTIONS(3778),
    [anon_sym_as] = ACTIONS(3778),
    [anon_sym_DASH_DASH] = ACTIONS(3781),
    [anon_sym_PLUS_PLUS] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(3778),
    [anon_sym_DOT_STAR] = ACTIONS(3781),
    [anon_sym_DASH_GT] = ACTIONS(3781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3778),
    [anon_sym_let] = ACTIONS(3778),
    [anon_sym_This] = ACTIONS(3778),
  },
  [3022] = {
    [sym_string_literal] = STATE(3342),
    [sym_template_argument_list] = STATE(4579),
    [sym_raw_string_literal] = STATE(3342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(6208),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON] = ACTIONS(4873),
    [anon_sym_SEMI] = ACTIONS(2117),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2117),
    [anon_sym_EQ] = ACTIONS(2152),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2154),
    [anon_sym_SLASH_EQ] = ACTIONS(2154),
    [anon_sym_PERCENT_EQ] = ACTIONS(2154),
    [anon_sym_PLUS_EQ] = ACTIONS(2154),
    [anon_sym_DASH_EQ] = ACTIONS(2154),
    [anon_sym_LT_LT_EQ] = ACTIONS(2154),
    [anon_sym_GT_GT_EQ] = ACTIONS(2154),
    [anon_sym_AMP_EQ] = ACTIONS(2154),
    [anon_sym_CARET_EQ] = ACTIONS(2154),
    [anon_sym_PIPE_EQ] = ACTIONS(2154),
    [anon_sym_and_eq] = ACTIONS(2154),
    [anon_sym_or_eq] = ACTIONS(2154),
    [anon_sym_xor_eq] = ACTIONS(2154),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2117),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2117),
    [anon_sym_not_eq] = ACTIONS(2117),
    [anon_sym_is] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
  },
  [3023] = {
    [sym_string_literal] = STATE(3033),
    [sym_template_argument_list] = STATE(3167),
    [sym_raw_string_literal] = STATE(3033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(6428),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_SEMI] = ACTIONS(2117),
    [anon_sym___attribute__] = ACTIONS(2117),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2117),
    [anon_sym_EQ] = ACTIONS(2128),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2117),
    [anon_sym_SLASH_EQ] = ACTIONS(2117),
    [anon_sym_PERCENT_EQ] = ACTIONS(2117),
    [anon_sym_PLUS_EQ] = ACTIONS(2117),
    [anon_sym_DASH_EQ] = ACTIONS(2117),
    [anon_sym_LT_LT_EQ] = ACTIONS(2117),
    [anon_sym_GT_GT_EQ] = ACTIONS(2117),
    [anon_sym_AMP_EQ] = ACTIONS(2117),
    [anon_sym_CARET_EQ] = ACTIONS(2117),
    [anon_sym_PIPE_EQ] = ACTIONS(2117),
    [anon_sym_and_eq] = ACTIONS(2117),
    [anon_sym_or_eq] = ACTIONS(2117),
    [anon_sym_xor_eq] = ACTIONS(2117),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2117),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2117),
    [anon_sym_not_eq] = ACTIONS(2117),
    [anon_sym_is] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(6692),
    [anon_sym_u_DQUOTE] = ACTIONS(6692),
    [anon_sym_U_DQUOTE] = ACTIONS(6692),
    [anon_sym_u8_DQUOTE] = ACTIONS(6692),
    [anon_sym_DQUOTE] = ACTIONS(6692),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6694),
    [anon_sym_LR_DQUOTE] = ACTIONS(6694),
    [anon_sym_uR_DQUOTE] = ACTIONS(6694),
    [anon_sym_UR_DQUOTE] = ACTIONS(6694),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6694),
  },
  [3024] = {
    [sym_identifier] = ACTIONS(3374),
    [anon_sym___extension__] = ACTIONS(3374),
    [anon_sym_in] = ACTIONS(3374),
    [anon_sym_out] = ACTIONS(3374),
    [anon_sym_inout] = ACTIONS(3374),
    [anon_sym_extern] = ACTIONS(3374),
    [anon_sym___attribute__] = ACTIONS(3374),
    [anon_sym_COLON_COLON] = ACTIONS(3376),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3376),
    [anon_sym___declspec] = ACTIONS(3374),
    [anon_sym_signed] = ACTIONS(3374),
    [anon_sym_unsigned] = ACTIONS(3374),
    [anon_sym_long] = ACTIONS(3374),
    [anon_sym_short] = ACTIONS(3374),
    [anon_sym_static] = ACTIONS(3374),
    [anon_sym_register] = ACTIONS(3374),
    [anon_sym_inline] = ACTIONS(3374),
    [anon_sym___inline] = ACTIONS(3374),
    [anon_sym___inline__] = ACTIONS(3374),
    [anon_sym___forceinline] = ACTIONS(3374),
    [anon_sym_thread_local] = ACTIONS(3374),
    [anon_sym___thread] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3374),
    [anon_sym_constexpr] = ACTIONS(3374),
    [anon_sym_volatile] = ACTIONS(3374),
    [anon_sym_restrict] = ACTIONS(3374),
    [anon_sym___restrict__] = ACTIONS(3374),
    [anon_sym__Atomic] = ACTIONS(3374),
    [anon_sym__Noreturn] = ACTIONS(3374),
    [anon_sym_noreturn] = ACTIONS(3374),
    [anon_sym_mutable] = ACTIONS(3374),
    [anon_sym_constinit] = ACTIONS(3374),
    [anon_sym_consteval] = ACTIONS(3374),
    [anon_sym_alignas] = ACTIONS(3374),
    [anon_sym__Alignas] = ACTIONS(3374),
    [sym_primitive_type] = ACTIONS(3374),
    [anon_sym_enum] = ACTIONS(3374),
    [anon_sym_class] = ACTIONS(3374),
    [anon_sym_struct] = ACTIONS(3374),
    [anon_sym_union] = ACTIONS(3374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3374),
    [anon_sym_let] = ACTIONS(3374),
    [anon_sym_This] = ACTIONS(3374),
    [anon_sym_decltype] = ACTIONS(3374),
    [sym_virtual] = ACTIONS(3374),
    [anon_sym_typename] = ACTIONS(3374),
    [anon_sym_template] = ACTIONS(3374),
    [anon_sym_precise] = ACTIONS(3374),
    [anon_sym_shared] = ACTIONS(3374),
    [anon_sym_groupshared] = ACTIONS(3374),
    [anon_sym_uniform] = ACTIONS(3374),
    [anon_sym_row_major] = ACTIONS(3374),
    [anon_sym_column_major] = ACTIONS(3374),
    [anon_sym_globallycoherent] = ACTIONS(3374),
    [anon_sym_centroid] = ACTIONS(3374),
    [anon_sym_noperspective] = ACTIONS(3374),
    [anon_sym_nointerpolation] = ACTIONS(3374),
    [anon_sym_sample] = ACTIONS(3374),
    [anon_sym_linear] = ACTIONS(3374),
    [anon_sym_snorm] = ACTIONS(3374),
    [anon_sym_unorm] = ACTIONS(3374),
    [anon_sym_point] = ACTIONS(3374),
    [anon_sym_line] = ACTIONS(3374),
    [anon_sym_triangleadj] = ACTIONS(3374),
    [anon_sym_lineadj] = ACTIONS(3374),
    [anon_sym_triangle] = ACTIONS(3374),
    [anon_sym_interface] = ACTIONS(3374),
    [anon_sym_extension] = ACTIONS(3374),
  },
  [3025] = {
    [sym_attribute_specifier] = STATE(3099),
    [sym_identifier] = ACTIONS(3791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3793),
    [anon_sym_COMMA] = ACTIONS(3793),
    [anon_sym_RPAREN] = ACTIONS(3793),
    [aux_sym_preproc_if_token2] = ACTIONS(3793),
    [aux_sym_preproc_else_token1] = ACTIONS(3793),
    [aux_sym_preproc_elif_token1] = ACTIONS(3791),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3793),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3793),
    [anon_sym_LPAREN2] = ACTIONS(3793),
    [anon_sym_DASH] = ACTIONS(3791),
    [anon_sym_PLUS] = ACTIONS(3791),
    [anon_sym_STAR] = ACTIONS(3791),
    [anon_sym_SLASH] = ACTIONS(3791),
    [anon_sym_PERCENT] = ACTIONS(3791),
    [anon_sym_PIPE_PIPE] = ACTIONS(3793),
    [anon_sym_AMP_AMP] = ACTIONS(3793),
    [anon_sym_PIPE] = ACTIONS(3791),
    [anon_sym_CARET] = ACTIONS(3791),
    [anon_sym_AMP] = ACTIONS(3791),
    [anon_sym_EQ_EQ] = ACTIONS(3793),
    [anon_sym_BANG_EQ] = ACTIONS(3793),
    [anon_sym_GT] = ACTIONS(3791),
    [anon_sym_GT_EQ] = ACTIONS(3793),
    [anon_sym_LT_EQ] = ACTIONS(3791),
    [anon_sym_LT] = ACTIONS(3791),
    [anon_sym_LT_LT] = ACTIONS(3791),
    [anon_sym_GT_GT] = ACTIONS(3791),
    [anon_sym_COLON] = ACTIONS(3793),
    [anon_sym_SEMI] = ACTIONS(3793),
    [anon_sym___attribute__] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(3793),
    [anon_sym_RBRACE] = ACTIONS(3793),
    [anon_sym_LBRACK] = ACTIONS(3793),
    [anon_sym_RBRACK] = ACTIONS(3793),
    [anon_sym_EQ] = ACTIONS(3791),
    [anon_sym_QMARK] = ACTIONS(3793),
    [anon_sym_STAR_EQ] = ACTIONS(3793),
    [anon_sym_SLASH_EQ] = ACTIONS(3793),
    [anon_sym_PERCENT_EQ] = ACTIONS(3793),
    [anon_sym_PLUS_EQ] = ACTIONS(3793),
    [anon_sym_DASH_EQ] = ACTIONS(3793),
    [anon_sym_LT_LT_EQ] = ACTIONS(3793),
    [anon_sym_GT_GT_EQ] = ACTIONS(3793),
    [anon_sym_AMP_EQ] = ACTIONS(3793),
    [anon_sym_CARET_EQ] = ACTIONS(3793),
    [anon_sym_PIPE_EQ] = ACTIONS(3793),
    [anon_sym_and_eq] = ACTIONS(3791),
    [anon_sym_or_eq] = ACTIONS(3791),
    [anon_sym_xor_eq] = ACTIONS(3791),
    [anon_sym_LT_EQ_GT] = ACTIONS(3793),
    [anon_sym_or] = ACTIONS(3791),
    [anon_sym_and] = ACTIONS(3791),
    [anon_sym_bitor] = ACTIONS(3791),
    [anon_sym_xor] = ACTIONS(3791),
    [anon_sym_bitand] = ACTIONS(3791),
    [anon_sym_not_eq] = ACTIONS(3791),
    [anon_sym_is] = ACTIONS(3791),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_DASH_DASH] = ACTIONS(3793),
    [anon_sym_PLUS_PLUS] = ACTIONS(3793),
    [anon_sym_DOT] = ACTIONS(3791),
    [anon_sym_DOT_STAR] = ACTIONS(3793),
    [anon_sym_DASH_GT] = ACTIONS(3793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3791),
    [anon_sym_let] = ACTIONS(3791),
    [anon_sym_This] = ACTIONS(3791),
  },
  [3026] = {
    [sym_attribute_specifier] = STATE(3095),
    [sym_identifier] = ACTIONS(3830),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3832),
    [anon_sym_RPAREN] = ACTIONS(3832),
    [aux_sym_preproc_if_token2] = ACTIONS(3832),
    [aux_sym_preproc_else_token1] = ACTIONS(3832),
    [aux_sym_preproc_elif_token1] = ACTIONS(3830),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3832),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3832),
    [anon_sym_LPAREN2] = ACTIONS(3832),
    [anon_sym_DASH] = ACTIONS(3830),
    [anon_sym_PLUS] = ACTIONS(3830),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_PERCENT] = ACTIONS(3830),
    [anon_sym_PIPE_PIPE] = ACTIONS(3832),
    [anon_sym_AMP_AMP] = ACTIONS(3832),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_CARET] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_EQ_EQ] = ACTIONS(3832),
    [anon_sym_BANG_EQ] = ACTIONS(3832),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_GT_EQ] = ACTIONS(3832),
    [anon_sym_LT_EQ] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_COLON] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3832),
    [anon_sym___attribute__] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(3832),
    [anon_sym_RBRACE] = ACTIONS(3832),
    [anon_sym_LBRACK] = ACTIONS(3832),
    [anon_sym_RBRACK] = ACTIONS(3832),
    [anon_sym_EQ] = ACTIONS(3830),
    [anon_sym_QMARK] = ACTIONS(3832),
    [anon_sym_STAR_EQ] = ACTIONS(3832),
    [anon_sym_SLASH_EQ] = ACTIONS(3832),
    [anon_sym_PERCENT_EQ] = ACTIONS(3832),
    [anon_sym_PLUS_EQ] = ACTIONS(3832),
    [anon_sym_DASH_EQ] = ACTIONS(3832),
    [anon_sym_LT_LT_EQ] = ACTIONS(3832),
    [anon_sym_GT_GT_EQ] = ACTIONS(3832),
    [anon_sym_AMP_EQ] = ACTIONS(3832),
    [anon_sym_CARET_EQ] = ACTIONS(3832),
    [anon_sym_PIPE_EQ] = ACTIONS(3832),
    [anon_sym_and_eq] = ACTIONS(3830),
    [anon_sym_or_eq] = ACTIONS(3830),
    [anon_sym_xor_eq] = ACTIONS(3830),
    [anon_sym_LT_EQ_GT] = ACTIONS(3832),
    [anon_sym_or] = ACTIONS(3830),
    [anon_sym_and] = ACTIONS(3830),
    [anon_sym_bitor] = ACTIONS(3830),
    [anon_sym_xor] = ACTIONS(3830),
    [anon_sym_bitand] = ACTIONS(3830),
    [anon_sym_not_eq] = ACTIONS(3830),
    [anon_sym_is] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3830),
    [anon_sym_DASH_DASH] = ACTIONS(3832),
    [anon_sym_PLUS_PLUS] = ACTIONS(3832),
    [anon_sym_DOT] = ACTIONS(3830),
    [anon_sym_DOT_STAR] = ACTIONS(3832),
    [anon_sym_DASH_GT] = ACTIONS(3832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3830),
    [anon_sym_let] = ACTIONS(3830),
    [anon_sym_This] = ACTIONS(3830),
  },
  [3027] = {
    [sym_identifier] = ACTIONS(3368),
    [anon_sym___extension__] = ACTIONS(3368),
    [anon_sym_in] = ACTIONS(3368),
    [anon_sym_out] = ACTIONS(3368),
    [anon_sym_inout] = ACTIONS(3368),
    [anon_sym_extern] = ACTIONS(3368),
    [anon_sym___attribute__] = ACTIONS(3368),
    [anon_sym_COLON_COLON] = ACTIONS(3370),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3370),
    [anon_sym___declspec] = ACTIONS(3368),
    [anon_sym_signed] = ACTIONS(3368),
    [anon_sym_unsigned] = ACTIONS(3368),
    [anon_sym_long] = ACTIONS(3368),
    [anon_sym_short] = ACTIONS(3368),
    [anon_sym_static] = ACTIONS(3368),
    [anon_sym_register] = ACTIONS(3368),
    [anon_sym_inline] = ACTIONS(3368),
    [anon_sym___inline] = ACTIONS(3368),
    [anon_sym___inline__] = ACTIONS(3368),
    [anon_sym___forceinline] = ACTIONS(3368),
    [anon_sym_thread_local] = ACTIONS(3368),
    [anon_sym___thread] = ACTIONS(3368),
    [anon_sym_const] = ACTIONS(3368),
    [anon_sym_constexpr] = ACTIONS(3368),
    [anon_sym_volatile] = ACTIONS(3368),
    [anon_sym_restrict] = ACTIONS(3368),
    [anon_sym___restrict__] = ACTIONS(3368),
    [anon_sym__Atomic] = ACTIONS(3368),
    [anon_sym__Noreturn] = ACTIONS(3368),
    [anon_sym_noreturn] = ACTIONS(3368),
    [anon_sym_mutable] = ACTIONS(3368),
    [anon_sym_constinit] = ACTIONS(3368),
    [anon_sym_consteval] = ACTIONS(3368),
    [anon_sym_alignas] = ACTIONS(3368),
    [anon_sym__Alignas] = ACTIONS(3368),
    [sym_primitive_type] = ACTIONS(3368),
    [anon_sym_enum] = ACTIONS(3368),
    [anon_sym_class] = ACTIONS(3368),
    [anon_sym_struct] = ACTIONS(3368),
    [anon_sym_union] = ACTIONS(3368),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3368),
    [anon_sym_let] = ACTIONS(3368),
    [anon_sym_This] = ACTIONS(3368),
    [anon_sym_decltype] = ACTIONS(3368),
    [sym_virtual] = ACTIONS(3368),
    [anon_sym_typename] = ACTIONS(3368),
    [anon_sym_template] = ACTIONS(3368),
    [anon_sym_precise] = ACTIONS(3368),
    [anon_sym_shared] = ACTIONS(3368),
    [anon_sym_groupshared] = ACTIONS(3368),
    [anon_sym_uniform] = ACTIONS(3368),
    [anon_sym_row_major] = ACTIONS(3368),
    [anon_sym_column_major] = ACTIONS(3368),
    [anon_sym_globallycoherent] = ACTIONS(3368),
    [anon_sym_centroid] = ACTIONS(3368),
    [anon_sym_noperspective] = ACTIONS(3368),
    [anon_sym_nointerpolation] = ACTIONS(3368),
    [anon_sym_sample] = ACTIONS(3368),
    [anon_sym_linear] = ACTIONS(3368),
    [anon_sym_snorm] = ACTIONS(3368),
    [anon_sym_unorm] = ACTIONS(3368),
    [anon_sym_point] = ACTIONS(3368),
    [anon_sym_line] = ACTIONS(3368),
    [anon_sym_triangleadj] = ACTIONS(3368),
    [anon_sym_lineadj] = ACTIONS(3368),
    [anon_sym_triangle] = ACTIONS(3368),
    [anon_sym_interface] = ACTIONS(3368),
    [anon_sym_extension] = ACTIONS(3368),
  },
  [3028] = {
    [sym_string_literal] = STATE(3342),
    [sym_template_argument_list] = STATE(4579),
    [sym_raw_string_literal] = STATE(3342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(6208),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON] = ACTIONS(4875),
    [anon_sym_SEMI] = ACTIONS(2117),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2117),
    [anon_sym_EQ] = ACTIONS(2152),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2154),
    [anon_sym_SLASH_EQ] = ACTIONS(2154),
    [anon_sym_PERCENT_EQ] = ACTIONS(2154),
    [anon_sym_PLUS_EQ] = ACTIONS(2154),
    [anon_sym_DASH_EQ] = ACTIONS(2154),
    [anon_sym_LT_LT_EQ] = ACTIONS(2154),
    [anon_sym_GT_GT_EQ] = ACTIONS(2154),
    [anon_sym_AMP_EQ] = ACTIONS(2154),
    [anon_sym_CARET_EQ] = ACTIONS(2154),
    [anon_sym_PIPE_EQ] = ACTIONS(2154),
    [anon_sym_and_eq] = ACTIONS(2154),
    [anon_sym_or_eq] = ACTIONS(2154),
    [anon_sym_xor_eq] = ACTIONS(2154),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2117),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2117),
    [anon_sym_not_eq] = ACTIONS(2117),
    [anon_sym_is] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
  },
  [3029] = {
    [sym_identifier] = ACTIONS(3406),
    [anon_sym___extension__] = ACTIONS(3406),
    [anon_sym_in] = ACTIONS(3406),
    [anon_sym_out] = ACTIONS(3406),
    [anon_sym_inout] = ACTIONS(3406),
    [anon_sym_extern] = ACTIONS(3406),
    [anon_sym___attribute__] = ACTIONS(3406),
    [anon_sym_COLON_COLON] = ACTIONS(3408),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3408),
    [anon_sym___declspec] = ACTIONS(3406),
    [anon_sym_signed] = ACTIONS(3406),
    [anon_sym_unsigned] = ACTIONS(3406),
    [anon_sym_long] = ACTIONS(3406),
    [anon_sym_short] = ACTIONS(3406),
    [anon_sym_static] = ACTIONS(3406),
    [anon_sym_register] = ACTIONS(3406),
    [anon_sym_inline] = ACTIONS(3406),
    [anon_sym___inline] = ACTIONS(3406),
    [anon_sym___inline__] = ACTIONS(3406),
    [anon_sym___forceinline] = ACTIONS(3406),
    [anon_sym_thread_local] = ACTIONS(3406),
    [anon_sym___thread] = ACTIONS(3406),
    [anon_sym_const] = ACTIONS(3406),
    [anon_sym_constexpr] = ACTIONS(3406),
    [anon_sym_volatile] = ACTIONS(3406),
    [anon_sym_restrict] = ACTIONS(3406),
    [anon_sym___restrict__] = ACTIONS(3406),
    [anon_sym__Atomic] = ACTIONS(3406),
    [anon_sym__Noreturn] = ACTIONS(3406),
    [anon_sym_noreturn] = ACTIONS(3406),
    [anon_sym_mutable] = ACTIONS(3406),
    [anon_sym_constinit] = ACTIONS(3406),
    [anon_sym_consteval] = ACTIONS(3406),
    [anon_sym_alignas] = ACTIONS(3406),
    [anon_sym__Alignas] = ACTIONS(3406),
    [sym_primitive_type] = ACTIONS(3406),
    [anon_sym_enum] = ACTIONS(3406),
    [anon_sym_class] = ACTIONS(3406),
    [anon_sym_struct] = ACTIONS(3406),
    [anon_sym_union] = ACTIONS(3406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3406),
    [anon_sym_let] = ACTIONS(3406),
    [anon_sym_This] = ACTIONS(3406),
    [anon_sym_decltype] = ACTIONS(3406),
    [sym_virtual] = ACTIONS(3406),
    [anon_sym_typename] = ACTIONS(3406),
    [anon_sym_template] = ACTIONS(3406),
    [anon_sym_precise] = ACTIONS(3406),
    [anon_sym_shared] = ACTIONS(3406),
    [anon_sym_groupshared] = ACTIONS(3406),
    [anon_sym_uniform] = ACTIONS(3406),
    [anon_sym_row_major] = ACTIONS(3406),
    [anon_sym_column_major] = ACTIONS(3406),
    [anon_sym_globallycoherent] = ACTIONS(3406),
    [anon_sym_centroid] = ACTIONS(3406),
    [anon_sym_noperspective] = ACTIONS(3406),
    [anon_sym_nointerpolation] = ACTIONS(3406),
    [anon_sym_sample] = ACTIONS(3406),
    [anon_sym_linear] = ACTIONS(3406),
    [anon_sym_snorm] = ACTIONS(3406),
    [anon_sym_unorm] = ACTIONS(3406),
    [anon_sym_point] = ACTIONS(3406),
    [anon_sym_line] = ACTIONS(3406),
    [anon_sym_triangleadj] = ACTIONS(3406),
    [anon_sym_lineadj] = ACTIONS(3406),
    [anon_sym_triangle] = ACTIONS(3406),
    [anon_sym_interface] = ACTIONS(3406),
    [anon_sym_extension] = ACTIONS(3406),
  },
  [3030] = {
    [sym_identifier] = ACTIONS(3669),
    [anon_sym___extension__] = ACTIONS(3669),
    [anon_sym_in] = ACTIONS(3669),
    [anon_sym_out] = ACTIONS(3669),
    [anon_sym_inout] = ACTIONS(3669),
    [anon_sym_extern] = ACTIONS(3669),
    [anon_sym___attribute__] = ACTIONS(3669),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3671),
    [anon_sym___declspec] = ACTIONS(3669),
    [anon_sym_signed] = ACTIONS(3669),
    [anon_sym_unsigned] = ACTIONS(3669),
    [anon_sym_long] = ACTIONS(3669),
    [anon_sym_short] = ACTIONS(3669),
    [anon_sym_static] = ACTIONS(3669),
    [anon_sym_register] = ACTIONS(3669),
    [anon_sym_inline] = ACTIONS(3669),
    [anon_sym___inline] = ACTIONS(3669),
    [anon_sym___inline__] = ACTIONS(3669),
    [anon_sym___forceinline] = ACTIONS(3669),
    [anon_sym_thread_local] = ACTIONS(3669),
    [anon_sym___thread] = ACTIONS(3669),
    [anon_sym_const] = ACTIONS(3669),
    [anon_sym_constexpr] = ACTIONS(3669),
    [anon_sym_volatile] = ACTIONS(3669),
    [anon_sym_restrict] = ACTIONS(3669),
    [anon_sym___restrict__] = ACTIONS(3669),
    [anon_sym__Atomic] = ACTIONS(3669),
    [anon_sym__Noreturn] = ACTIONS(3669),
    [anon_sym_noreturn] = ACTIONS(3669),
    [anon_sym_mutable] = ACTIONS(3669),
    [anon_sym_constinit] = ACTIONS(3669),
    [anon_sym_consteval] = ACTIONS(3669),
    [anon_sym_alignas] = ACTIONS(3669),
    [anon_sym__Alignas] = ACTIONS(3669),
    [sym_primitive_type] = ACTIONS(3669),
    [anon_sym_enum] = ACTIONS(3669),
    [anon_sym_class] = ACTIONS(3669),
    [anon_sym_struct] = ACTIONS(3669),
    [anon_sym_union] = ACTIONS(3669),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3669),
    [anon_sym_let] = ACTIONS(3669),
    [anon_sym_This] = ACTIONS(3669),
    [anon_sym_decltype] = ACTIONS(3669),
    [sym_virtual] = ACTIONS(3669),
    [anon_sym_typename] = ACTIONS(3669),
    [anon_sym_template] = ACTIONS(3669),
    [anon_sym_precise] = ACTIONS(3669),
    [anon_sym_shared] = ACTIONS(3669),
    [anon_sym_groupshared] = ACTIONS(3669),
    [anon_sym_uniform] = ACTIONS(3669),
    [anon_sym_row_major] = ACTIONS(3669),
    [anon_sym_column_major] = ACTIONS(3669),
    [anon_sym_globallycoherent] = ACTIONS(3669),
    [anon_sym_centroid] = ACTIONS(3669),
    [anon_sym_noperspective] = ACTIONS(3669),
    [anon_sym_nointerpolation] = ACTIONS(3669),
    [anon_sym_sample] = ACTIONS(3669),
    [anon_sym_linear] = ACTIONS(3669),
    [anon_sym_snorm] = ACTIONS(3669),
    [anon_sym_unorm] = ACTIONS(3669),
    [anon_sym_point] = ACTIONS(3669),
    [anon_sym_line] = ACTIONS(3669),
    [anon_sym_triangleadj] = ACTIONS(3669),
    [anon_sym_lineadj] = ACTIONS(3669),
    [anon_sym_triangle] = ACTIONS(3669),
    [anon_sym_interface] = ACTIONS(3669),
    [anon_sym_extension] = ACTIONS(3669),
  },
  [3031] = {
    [sym_string_literal] = STATE(3031),
    [sym_raw_string_literal] = STATE(3031),
    [aux_sym_concatenated_string_repeat1] = STATE(3031),
    [sym_identifier] = ACTIONS(6696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6444),
    [anon_sym_COMMA] = ACTIONS(6444),
    [anon_sym_RPAREN] = ACTIONS(6444),
    [anon_sym_LPAREN2] = ACTIONS(6444),
    [anon_sym_DASH] = ACTIONS(6446),
    [anon_sym_PLUS] = ACTIONS(6446),
    [anon_sym_STAR] = ACTIONS(6446),
    [anon_sym_SLASH] = ACTIONS(6446),
    [anon_sym_PERCENT] = ACTIONS(6446),
    [anon_sym_PIPE_PIPE] = ACTIONS(6444),
    [anon_sym_AMP_AMP] = ACTIONS(6444),
    [anon_sym_PIPE] = ACTIONS(6446),
    [anon_sym_CARET] = ACTIONS(6446),
    [anon_sym_AMP] = ACTIONS(6446),
    [anon_sym_EQ_EQ] = ACTIONS(6444),
    [anon_sym_BANG_EQ] = ACTIONS(6444),
    [anon_sym_GT] = ACTIONS(6446),
    [anon_sym_GT_EQ] = ACTIONS(6444),
    [anon_sym_LT_EQ] = ACTIONS(6446),
    [anon_sym_LT] = ACTIONS(6446),
    [anon_sym_LT_LT] = ACTIONS(6446),
    [anon_sym_GT_GT] = ACTIONS(6446),
    [anon_sym_LBRACK] = ACTIONS(6444),
    [anon_sym_EQ] = ACTIONS(6446),
    [anon_sym_QMARK] = ACTIONS(6444),
    [anon_sym_STAR_EQ] = ACTIONS(6444),
    [anon_sym_SLASH_EQ] = ACTIONS(6444),
    [anon_sym_PERCENT_EQ] = ACTIONS(6444),
    [anon_sym_PLUS_EQ] = ACTIONS(6444),
    [anon_sym_DASH_EQ] = ACTIONS(6444),
    [anon_sym_LT_LT_EQ] = ACTIONS(6444),
    [anon_sym_GT_GT_EQ] = ACTIONS(6444),
    [anon_sym_AMP_EQ] = ACTIONS(6444),
    [anon_sym_CARET_EQ] = ACTIONS(6444),
    [anon_sym_PIPE_EQ] = ACTIONS(6444),
    [anon_sym_and_eq] = ACTIONS(6446),
    [anon_sym_or_eq] = ACTIONS(6446),
    [anon_sym_xor_eq] = ACTIONS(6446),
    [anon_sym_LT_EQ_GT] = ACTIONS(6444),
    [anon_sym_or] = ACTIONS(6446),
    [anon_sym_and] = ACTIONS(6446),
    [anon_sym_bitor] = ACTIONS(6446),
    [anon_sym_xor] = ACTIONS(6446),
    [anon_sym_bitand] = ACTIONS(6446),
    [anon_sym_not_eq] = ACTIONS(6446),
    [anon_sym_is] = ACTIONS(6446),
    [anon_sym_as] = ACTIONS(6446),
    [anon_sym_DASH_DASH] = ACTIONS(6444),
    [anon_sym_PLUS_PLUS] = ACTIONS(6444),
    [anon_sym_DOT] = ACTIONS(6446),
    [anon_sym_DOT_STAR] = ACTIONS(6444),
    [anon_sym_DASH_GT] = ACTIONS(6446),
    [anon_sym_L_DQUOTE] = ACTIONS(6699),
    [anon_sym_u_DQUOTE] = ACTIONS(6699),
    [anon_sym_U_DQUOTE] = ACTIONS(6699),
    [anon_sym_u8_DQUOTE] = ACTIONS(6699),
    [anon_sym_DQUOTE] = ACTIONS(6699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6702),
    [anon_sym_LR_DQUOTE] = ACTIONS(6702),
    [anon_sym_uR_DQUOTE] = ACTIONS(6702),
    [anon_sym_UR_DQUOTE] = ACTIONS(6702),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6702),
    [anon_sym_DASH_GT_STAR] = ACTIONS(6444),
    [sym_literal_suffix] = ACTIONS(6446),
  },
  [3032] = {
    [sym_attribute_specifier] = STATE(3102),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3801),
    [anon_sym_COMMA] = ACTIONS(3801),
    [anon_sym_RPAREN] = ACTIONS(3801),
    [aux_sym_preproc_if_token2] = ACTIONS(3801),
    [aux_sym_preproc_else_token1] = ACTIONS(3801),
    [aux_sym_preproc_elif_token1] = ACTIONS(3799),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3801),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3801),
    [anon_sym_LPAREN2] = ACTIONS(3801),
    [anon_sym_DASH] = ACTIONS(3799),
    [anon_sym_PLUS] = ACTIONS(3799),
    [anon_sym_STAR] = ACTIONS(3799),
    [anon_sym_SLASH] = ACTIONS(3799),
    [anon_sym_PERCENT] = ACTIONS(3799),
    [anon_sym_PIPE_PIPE] = ACTIONS(3801),
    [anon_sym_AMP_AMP] = ACTIONS(3801),
    [anon_sym_PIPE] = ACTIONS(3799),
    [anon_sym_CARET] = ACTIONS(3799),
    [anon_sym_AMP] = ACTIONS(3799),
    [anon_sym_EQ_EQ] = ACTIONS(3801),
    [anon_sym_BANG_EQ] = ACTIONS(3801),
    [anon_sym_GT] = ACTIONS(3799),
    [anon_sym_GT_EQ] = ACTIONS(3801),
    [anon_sym_LT_EQ] = ACTIONS(3799),
    [anon_sym_LT] = ACTIONS(3799),
    [anon_sym_LT_LT] = ACTIONS(3799),
    [anon_sym_GT_GT] = ACTIONS(3799),
    [anon_sym_COLON] = ACTIONS(3801),
    [anon_sym_SEMI] = ACTIONS(3801),
    [anon_sym___attribute__] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(3801),
    [anon_sym_RBRACE] = ACTIONS(3801),
    [anon_sym_LBRACK] = ACTIONS(3801),
    [anon_sym_RBRACK] = ACTIONS(3801),
    [anon_sym_EQ] = ACTIONS(3799),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_STAR_EQ] = ACTIONS(3801),
    [anon_sym_SLASH_EQ] = ACTIONS(3801),
    [anon_sym_PERCENT_EQ] = ACTIONS(3801),
    [anon_sym_PLUS_EQ] = ACTIONS(3801),
    [anon_sym_DASH_EQ] = ACTIONS(3801),
    [anon_sym_LT_LT_EQ] = ACTIONS(3801),
    [anon_sym_GT_GT_EQ] = ACTIONS(3801),
    [anon_sym_AMP_EQ] = ACTIONS(3801),
    [anon_sym_CARET_EQ] = ACTIONS(3801),
    [anon_sym_PIPE_EQ] = ACTIONS(3801),
    [anon_sym_and_eq] = ACTIONS(3799),
    [anon_sym_or_eq] = ACTIONS(3799),
    [anon_sym_xor_eq] = ACTIONS(3799),
    [anon_sym_LT_EQ_GT] = ACTIONS(3801),
    [anon_sym_or] = ACTIONS(3799),
    [anon_sym_and] = ACTIONS(3799),
    [anon_sym_bitor] = ACTIONS(3799),
    [anon_sym_xor] = ACTIONS(3799),
    [anon_sym_bitand] = ACTIONS(3799),
    [anon_sym_not_eq] = ACTIONS(3799),
    [anon_sym_is] = ACTIONS(3799),
    [anon_sym_as] = ACTIONS(3799),
    [anon_sym_DASH_DASH] = ACTIONS(3801),
    [anon_sym_PLUS_PLUS] = ACTIONS(3801),
    [anon_sym_DOT] = ACTIONS(3799),
    [anon_sym_DOT_STAR] = ACTIONS(3801),
    [anon_sym_DASH_GT] = ACTIONS(3801),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3799),
    [anon_sym_let] = ACTIONS(3799),
    [anon_sym_This] = ACTIONS(3799),
  },
  [3033] = {
    [sym_string_literal] = STATE(3019),
    [sym_raw_string_literal] = STATE(3019),
    [aux_sym_concatenated_string_repeat1] = STATE(3019),
    [sym_identifier] = ACTIONS(6705),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6437),
    [anon_sym_COMMA] = ACTIONS(6437),
    [anon_sym_LPAREN2] = ACTIONS(6437),
    [anon_sym_DASH] = ACTIONS(6439),
    [anon_sym_PLUS] = ACTIONS(6439),
    [anon_sym_STAR] = ACTIONS(6439),
    [anon_sym_SLASH] = ACTIONS(6439),
    [anon_sym_PERCENT] = ACTIONS(6439),
    [anon_sym_PIPE_PIPE] = ACTIONS(6437),
    [anon_sym_AMP_AMP] = ACTIONS(6437),
    [anon_sym_PIPE] = ACTIONS(6439),
    [anon_sym_CARET] = ACTIONS(6439),
    [anon_sym_AMP] = ACTIONS(6439),
    [anon_sym_EQ_EQ] = ACTIONS(6437),
    [anon_sym_BANG_EQ] = ACTIONS(6437),
    [anon_sym_GT] = ACTIONS(6439),
    [anon_sym_GT_EQ] = ACTIONS(6437),
    [anon_sym_LT_EQ] = ACTIONS(6439),
    [anon_sym_LT] = ACTIONS(6439),
    [anon_sym_LT_LT] = ACTIONS(6439),
    [anon_sym_GT_GT] = ACTIONS(6439),
    [anon_sym_SEMI] = ACTIONS(6437),
    [anon_sym___attribute__] = ACTIONS(6439),
    [anon_sym_LBRACK] = ACTIONS(6437),
    [anon_sym_EQ] = ACTIONS(6439),
    [anon_sym_QMARK] = ACTIONS(6437),
    [anon_sym_STAR_EQ] = ACTIONS(6437),
    [anon_sym_SLASH_EQ] = ACTIONS(6437),
    [anon_sym_PERCENT_EQ] = ACTIONS(6437),
    [anon_sym_PLUS_EQ] = ACTIONS(6437),
    [anon_sym_DASH_EQ] = ACTIONS(6437),
    [anon_sym_LT_LT_EQ] = ACTIONS(6437),
    [anon_sym_GT_GT_EQ] = ACTIONS(6437),
    [anon_sym_AMP_EQ] = ACTIONS(6437),
    [anon_sym_CARET_EQ] = ACTIONS(6437),
    [anon_sym_PIPE_EQ] = ACTIONS(6437),
    [anon_sym_and_eq] = ACTIONS(6439),
    [anon_sym_or_eq] = ACTIONS(6439),
    [anon_sym_xor_eq] = ACTIONS(6439),
    [anon_sym_LT_EQ_GT] = ACTIONS(6437),
    [anon_sym_or] = ACTIONS(6439),
    [anon_sym_and] = ACTIONS(6439),
    [anon_sym_bitor] = ACTIONS(6439),
    [anon_sym_xor] = ACTIONS(6439),
    [anon_sym_bitand] = ACTIONS(6439),
    [anon_sym_not_eq] = ACTIONS(6439),
    [anon_sym_is] = ACTIONS(6439),
    [anon_sym_as] = ACTIONS(6439),
    [anon_sym_DASH_DASH] = ACTIONS(6437),
    [anon_sym_PLUS_PLUS] = ACTIONS(6437),
    [anon_sym_DOT] = ACTIONS(6439),
    [anon_sym_DOT_STAR] = ACTIONS(6437),
    [anon_sym_DASH_GT] = ACTIONS(6437),
    [anon_sym_L_DQUOTE] = ACTIONS(6692),
    [anon_sym_u_DQUOTE] = ACTIONS(6692),
    [anon_sym_U_DQUOTE] = ACTIONS(6692),
    [anon_sym_u8_DQUOTE] = ACTIONS(6692),
    [anon_sym_DQUOTE] = ACTIONS(6692),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6694),
    [anon_sym_LR_DQUOTE] = ACTIONS(6694),
    [anon_sym_uR_DQUOTE] = ACTIONS(6694),
    [anon_sym_UR_DQUOTE] = ACTIONS(6694),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6694),
    [sym_literal_suffix] = ACTIONS(6439),
  },
  [3034] = {
    [sym_attribute_specifier] = STATE(3101),
    [sym_identifier] = ACTIONS(3719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3721),
    [anon_sym_RPAREN] = ACTIONS(3721),
    [aux_sym_preproc_if_token2] = ACTIONS(3721),
    [aux_sym_preproc_else_token1] = ACTIONS(3721),
    [aux_sym_preproc_elif_token1] = ACTIONS(3719),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3721),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3721),
    [anon_sym_LPAREN2] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3719),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_AMP] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3721),
    [anon_sym_BANG_EQ] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3721),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_LT] = ACTIONS(3719),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_SEMI] = ACTIONS(3721),
    [anon_sym___attribute__] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(3721),
    [anon_sym_RBRACE] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3721),
    [anon_sym_RBRACK] = ACTIONS(3721),
    [anon_sym_EQ] = ACTIONS(3719),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_STAR_EQ] = ACTIONS(3721),
    [anon_sym_SLASH_EQ] = ACTIONS(3721),
    [anon_sym_PERCENT_EQ] = ACTIONS(3721),
    [anon_sym_PLUS_EQ] = ACTIONS(3721),
    [anon_sym_DASH_EQ] = ACTIONS(3721),
    [anon_sym_LT_LT_EQ] = ACTIONS(3721),
    [anon_sym_GT_GT_EQ] = ACTIONS(3721),
    [anon_sym_AMP_EQ] = ACTIONS(3721),
    [anon_sym_CARET_EQ] = ACTIONS(3721),
    [anon_sym_PIPE_EQ] = ACTIONS(3721),
    [anon_sym_and_eq] = ACTIONS(3719),
    [anon_sym_or_eq] = ACTIONS(3719),
    [anon_sym_xor_eq] = ACTIONS(3719),
    [anon_sym_LT_EQ_GT] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3719),
    [anon_sym_bitor] = ACTIONS(3719),
    [anon_sym_xor] = ACTIONS(3719),
    [anon_sym_bitand] = ACTIONS(3719),
    [anon_sym_not_eq] = ACTIONS(3719),
    [anon_sym_is] = ACTIONS(3719),
    [anon_sym_as] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3721),
    [anon_sym_DOT] = ACTIONS(3719),
    [anon_sym_DOT_STAR] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3721),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3719),
    [anon_sym_let] = ACTIONS(3719),
    [anon_sym_This] = ACTIONS(3719),
  },
  [3035] = {
    [sym_identifier] = ACTIONS(2996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2994),
    [anon_sym_COMMA] = ACTIONS(2994),
    [anon_sym_RPAREN] = ACTIONS(2994),
    [aux_sym_preproc_if_token2] = ACTIONS(2994),
    [aux_sym_preproc_else_token1] = ACTIONS(2994),
    [aux_sym_preproc_elif_token1] = ACTIONS(2996),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2994),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2994),
    [anon_sym_LPAREN2] = ACTIONS(2994),
    [anon_sym_DASH] = ACTIONS(2996),
    [anon_sym_PLUS] = ACTIONS(2996),
    [anon_sym_STAR] = ACTIONS(2996),
    [anon_sym_SLASH] = ACTIONS(2996),
    [anon_sym_PERCENT] = ACTIONS(2996),
    [anon_sym_PIPE_PIPE] = ACTIONS(2994),
    [anon_sym_AMP_AMP] = ACTIONS(2994),
    [anon_sym_PIPE] = ACTIONS(2996),
    [anon_sym_CARET] = ACTIONS(2996),
    [anon_sym_AMP] = ACTIONS(2996),
    [anon_sym_EQ_EQ] = ACTIONS(2994),
    [anon_sym_BANG_EQ] = ACTIONS(2994),
    [anon_sym_GT] = ACTIONS(2996),
    [anon_sym_GT_EQ] = ACTIONS(2994),
    [anon_sym_LT_EQ] = ACTIONS(2996),
    [anon_sym_LT] = ACTIONS(2996),
    [anon_sym_LT_LT] = ACTIONS(2996),
    [anon_sym_GT_GT] = ACTIONS(2996),
    [anon_sym_COLON] = ACTIONS(2994),
    [anon_sym_SEMI] = ACTIONS(2994),
    [anon_sym___attribute__] = ACTIONS(2996),
    [anon_sym_LBRACE] = ACTIONS(2994),
    [anon_sym_RBRACE] = ACTIONS(2994),
    [anon_sym_LBRACK] = ACTIONS(2994),
    [anon_sym_RBRACK] = ACTIONS(2994),
    [anon_sym_EQ] = ACTIONS(2996),
    [anon_sym_QMARK] = ACTIONS(2994),
    [anon_sym_STAR_EQ] = ACTIONS(2994),
    [anon_sym_SLASH_EQ] = ACTIONS(2994),
    [anon_sym_PERCENT_EQ] = ACTIONS(2994),
    [anon_sym_PLUS_EQ] = ACTIONS(2994),
    [anon_sym_DASH_EQ] = ACTIONS(2994),
    [anon_sym_LT_LT_EQ] = ACTIONS(2994),
    [anon_sym_GT_GT_EQ] = ACTIONS(2994),
    [anon_sym_AMP_EQ] = ACTIONS(2994),
    [anon_sym_CARET_EQ] = ACTIONS(2994),
    [anon_sym_PIPE_EQ] = ACTIONS(2994),
    [anon_sym_and_eq] = ACTIONS(2996),
    [anon_sym_or_eq] = ACTIONS(2996),
    [anon_sym_xor_eq] = ACTIONS(2996),
    [anon_sym_LT_EQ_GT] = ACTIONS(2994),
    [anon_sym_or] = ACTIONS(2996),
    [anon_sym_and] = ACTIONS(2996),
    [anon_sym_bitor] = ACTIONS(2996),
    [anon_sym_xor] = ACTIONS(2996),
    [anon_sym_bitand] = ACTIONS(2996),
    [anon_sym_not_eq] = ACTIONS(2996),
    [anon_sym_is] = ACTIONS(2996),
    [anon_sym_as] = ACTIONS(2996),
    [anon_sym_DASH_DASH] = ACTIONS(2994),
    [anon_sym_PLUS_PLUS] = ACTIONS(2994),
    [anon_sym_DOT] = ACTIONS(2996),
    [anon_sym_DOT_STAR] = ACTIONS(2994),
    [anon_sym_DASH_GT] = ACTIONS(2994),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2996),
    [anon_sym_let] = ACTIONS(2996),
    [anon_sym_This] = ACTIONS(2996),
  },
  [3036] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6462),
    [anon_sym_COMMA] = ACTIONS(6462),
    [anon_sym_RPAREN] = ACTIONS(6462),
    [anon_sym_LPAREN2] = ACTIONS(6462),
    [anon_sym_DASH] = ACTIONS(6460),
    [anon_sym_PLUS] = ACTIONS(6460),
    [anon_sym_STAR] = ACTIONS(6460),
    [anon_sym_SLASH] = ACTIONS(6460),
    [anon_sym_PERCENT] = ACTIONS(6460),
    [anon_sym_PIPE_PIPE] = ACTIONS(6462),
    [anon_sym_AMP_AMP] = ACTIONS(6462),
    [anon_sym_PIPE] = ACTIONS(6460),
    [anon_sym_CARET] = ACTIONS(6460),
    [anon_sym_AMP] = ACTIONS(6460),
    [anon_sym_EQ_EQ] = ACTIONS(6462),
    [anon_sym_BANG_EQ] = ACTIONS(6462),
    [anon_sym_GT] = ACTIONS(6460),
    [anon_sym_GT_EQ] = ACTIONS(6462),
    [anon_sym_LT_EQ] = ACTIONS(6460),
    [anon_sym_LT] = ACTIONS(6460),
    [anon_sym_LT_LT] = ACTIONS(6460),
    [anon_sym_GT_GT] = ACTIONS(6460),
    [anon_sym_COLON] = ACTIONS(6462),
    [anon_sym_SEMI] = ACTIONS(6462),
    [anon_sym_RBRACE] = ACTIONS(6462),
    [anon_sym_LBRACK] = ACTIONS(6462),
    [anon_sym_RBRACK] = ACTIONS(6462),
    [anon_sym_EQ] = ACTIONS(6460),
    [anon_sym_QMARK] = ACTIONS(6462),
    [anon_sym_STAR_EQ] = ACTIONS(6462),
    [anon_sym_SLASH_EQ] = ACTIONS(6462),
    [anon_sym_PERCENT_EQ] = ACTIONS(6462),
    [anon_sym_PLUS_EQ] = ACTIONS(6462),
    [anon_sym_DASH_EQ] = ACTIONS(6462),
    [anon_sym_LT_LT_EQ] = ACTIONS(6462),
    [anon_sym_GT_GT_EQ] = ACTIONS(6462),
    [anon_sym_AMP_EQ] = ACTIONS(6462),
    [anon_sym_CARET_EQ] = ACTIONS(6462),
    [anon_sym_PIPE_EQ] = ACTIONS(6462),
    [anon_sym_and_eq] = ACTIONS(6460),
    [anon_sym_or_eq] = ACTIONS(6460),
    [anon_sym_xor_eq] = ACTIONS(6460),
    [anon_sym_LT_EQ_GT] = ACTIONS(6462),
    [anon_sym_or] = ACTIONS(6460),
    [anon_sym_and] = ACTIONS(6460),
    [anon_sym_bitor] = ACTIONS(6460),
    [anon_sym_xor] = ACTIONS(6460),
    [anon_sym_bitand] = ACTIONS(6460),
    [anon_sym_not_eq] = ACTIONS(6460),
    [anon_sym_is] = ACTIONS(6460),
    [anon_sym_as] = ACTIONS(6460),
    [anon_sym_DASH_DASH] = ACTIONS(6462),
    [anon_sym_PLUS_PLUS] = ACTIONS(6462),
    [anon_sym_DOT] = ACTIONS(6460),
    [anon_sym_DOT_STAR] = ACTIONS(6462),
    [anon_sym_DASH_GT] = ACTIONS(6462),
    [anon_sym_L_DQUOTE] = ACTIONS(6462),
    [anon_sym_u_DQUOTE] = ACTIONS(6462),
    [anon_sym_U_DQUOTE] = ACTIONS(6462),
    [anon_sym_u8_DQUOTE] = ACTIONS(6462),
    [anon_sym_DQUOTE] = ACTIONS(6462),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6462),
    [anon_sym_LR_DQUOTE] = ACTIONS(6462),
    [anon_sym_uR_DQUOTE] = ACTIONS(6462),
    [anon_sym_UR_DQUOTE] = ACTIONS(6462),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6462),
    [sym_literal_suffix] = ACTIONS(6460),
  },
  [3037] = {
    [sym_string_literal] = STATE(3037),
    [sym_raw_string_literal] = STATE(3037),
    [aux_sym_concatenated_string_repeat1] = STATE(3037),
    [sym_identifier] = ACTIONS(6707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6444),
    [anon_sym_COMMA] = ACTIONS(6444),
    [anon_sym_LPAREN2] = ACTIONS(6444),
    [anon_sym_DASH] = ACTIONS(6446),
    [anon_sym_PLUS] = ACTIONS(6446),
    [anon_sym_STAR] = ACTIONS(6446),
    [anon_sym_SLASH] = ACTIONS(6446),
    [anon_sym_PERCENT] = ACTIONS(6446),
    [anon_sym_PIPE_PIPE] = ACTIONS(6444),
    [anon_sym_AMP_AMP] = ACTIONS(6444),
    [anon_sym_PIPE] = ACTIONS(6446),
    [anon_sym_CARET] = ACTIONS(6446),
    [anon_sym_AMP] = ACTIONS(6446),
    [anon_sym_EQ_EQ] = ACTIONS(6444),
    [anon_sym_BANG_EQ] = ACTIONS(6444),
    [anon_sym_GT] = ACTIONS(6446),
    [anon_sym_GT_EQ] = ACTIONS(6446),
    [anon_sym_LT_EQ] = ACTIONS(6446),
    [anon_sym_LT] = ACTIONS(6446),
    [anon_sym_LT_LT] = ACTIONS(6446),
    [anon_sym_GT_GT] = ACTIONS(6446),
    [anon_sym_LBRACK] = ACTIONS(6444),
    [anon_sym_EQ] = ACTIONS(6446),
    [anon_sym_QMARK] = ACTIONS(6444),
    [anon_sym_STAR_EQ] = ACTIONS(6444),
    [anon_sym_SLASH_EQ] = ACTIONS(6444),
    [anon_sym_PERCENT_EQ] = ACTIONS(6444),
    [anon_sym_PLUS_EQ] = ACTIONS(6444),
    [anon_sym_DASH_EQ] = ACTIONS(6444),
    [anon_sym_LT_LT_EQ] = ACTIONS(6444),
    [anon_sym_GT_GT_EQ] = ACTIONS(6446),
    [anon_sym_AMP_EQ] = ACTIONS(6444),
    [anon_sym_CARET_EQ] = ACTIONS(6444),
    [anon_sym_PIPE_EQ] = ACTIONS(6444),
    [anon_sym_and_eq] = ACTIONS(6446),
    [anon_sym_or_eq] = ACTIONS(6446),
    [anon_sym_xor_eq] = ACTIONS(6446),
    [anon_sym_LT_EQ_GT] = ACTIONS(6444),
    [anon_sym_or] = ACTIONS(6446),
    [anon_sym_and] = ACTIONS(6446),
    [anon_sym_bitor] = ACTIONS(6446),
    [anon_sym_xor] = ACTIONS(6446),
    [anon_sym_bitand] = ACTIONS(6446),
    [anon_sym_not_eq] = ACTIONS(6446),
    [anon_sym_is] = ACTIONS(6446),
    [anon_sym_as] = ACTIONS(6446),
    [anon_sym_DASH_DASH] = ACTIONS(6444),
    [anon_sym_PLUS_PLUS] = ACTIONS(6444),
    [anon_sym_DOT] = ACTIONS(6446),
    [anon_sym_DOT_STAR] = ACTIONS(6444),
    [anon_sym_DASH_GT] = ACTIONS(6444),
    [anon_sym_L_DQUOTE] = ACTIONS(6710),
    [anon_sym_u_DQUOTE] = ACTIONS(6710),
    [anon_sym_U_DQUOTE] = ACTIONS(6710),
    [anon_sym_u8_DQUOTE] = ACTIONS(6710),
    [anon_sym_DQUOTE] = ACTIONS(6710),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(6444),
    [anon_sym_R_DQUOTE] = ACTIONS(6713),
    [anon_sym_LR_DQUOTE] = ACTIONS(6713),
    [anon_sym_uR_DQUOTE] = ACTIONS(6713),
    [anon_sym_UR_DQUOTE] = ACTIONS(6713),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6713),
    [sym_literal_suffix] = ACTIONS(6446),
  },
  [3038] = {
    [sym_identifier] = ACTIONS(2988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2986),
    [anon_sym_COMMA] = ACTIONS(2986),
    [anon_sym_RPAREN] = ACTIONS(2986),
    [aux_sym_preproc_if_token2] = ACTIONS(2986),
    [aux_sym_preproc_else_token1] = ACTIONS(2986),
    [aux_sym_preproc_elif_token1] = ACTIONS(2988),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2986),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2986),
    [anon_sym_LPAREN2] = ACTIONS(2986),
    [anon_sym_DASH] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_STAR] = ACTIONS(2988),
    [anon_sym_SLASH] = ACTIONS(2988),
    [anon_sym_PERCENT] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE] = ACTIONS(2986),
    [anon_sym_AMP_AMP] = ACTIONS(2986),
    [anon_sym_PIPE] = ACTIONS(2988),
    [anon_sym_CARET] = ACTIONS(2988),
    [anon_sym_AMP] = ACTIONS(2988),
    [anon_sym_EQ_EQ] = ACTIONS(2986),
    [anon_sym_BANG_EQ] = ACTIONS(2986),
    [anon_sym_GT] = ACTIONS(2988),
    [anon_sym_GT_EQ] = ACTIONS(2986),
    [anon_sym_LT_EQ] = ACTIONS(2988),
    [anon_sym_LT] = ACTIONS(2988),
    [anon_sym_LT_LT] = ACTIONS(2988),
    [anon_sym_GT_GT] = ACTIONS(2988),
    [anon_sym_COLON] = ACTIONS(2986),
    [anon_sym_SEMI] = ACTIONS(2986),
    [anon_sym___attribute__] = ACTIONS(2988),
    [anon_sym_LBRACE] = ACTIONS(2986),
    [anon_sym_RBRACE] = ACTIONS(2986),
    [anon_sym_LBRACK] = ACTIONS(2986),
    [anon_sym_RBRACK] = ACTIONS(2986),
    [anon_sym_EQ] = ACTIONS(2988),
    [anon_sym_QMARK] = ACTIONS(2986),
    [anon_sym_STAR_EQ] = ACTIONS(2986),
    [anon_sym_SLASH_EQ] = ACTIONS(2986),
    [anon_sym_PERCENT_EQ] = ACTIONS(2986),
    [anon_sym_PLUS_EQ] = ACTIONS(2986),
    [anon_sym_DASH_EQ] = ACTIONS(2986),
    [anon_sym_LT_LT_EQ] = ACTIONS(2986),
    [anon_sym_GT_GT_EQ] = ACTIONS(2986),
    [anon_sym_AMP_EQ] = ACTIONS(2986),
    [anon_sym_CARET_EQ] = ACTIONS(2986),
    [anon_sym_PIPE_EQ] = ACTIONS(2986),
    [anon_sym_and_eq] = ACTIONS(2988),
    [anon_sym_or_eq] = ACTIONS(2988),
    [anon_sym_xor_eq] = ACTIONS(2988),
    [anon_sym_LT_EQ_GT] = ACTIONS(2986),
    [anon_sym_or] = ACTIONS(2988),
    [anon_sym_and] = ACTIONS(2988),
    [anon_sym_bitor] = ACTIONS(2988),
    [anon_sym_xor] = ACTIONS(2988),
    [anon_sym_bitand] = ACTIONS(2988),
    [anon_sym_not_eq] = ACTIONS(2988),
    [anon_sym_is] = ACTIONS(2988),
    [anon_sym_as] = ACTIONS(2988),
    [anon_sym_DASH_DASH] = ACTIONS(2986),
    [anon_sym_PLUS_PLUS] = ACTIONS(2986),
    [anon_sym_DOT] = ACTIONS(2988),
    [anon_sym_DOT_STAR] = ACTIONS(2986),
    [anon_sym_DASH_GT] = ACTIONS(2986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2988),
    [anon_sym_let] = ACTIONS(2988),
    [anon_sym_This] = ACTIONS(2988),
  },
  [3039] = {
    [sym_identifier] = ACTIONS(3048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3046),
    [anon_sym_COMMA] = ACTIONS(3046),
    [anon_sym_RPAREN] = ACTIONS(3046),
    [aux_sym_preproc_if_token2] = ACTIONS(3046),
    [aux_sym_preproc_else_token1] = ACTIONS(3046),
    [aux_sym_preproc_elif_token1] = ACTIONS(3048),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3046),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3046),
    [anon_sym_LPAREN2] = ACTIONS(3046),
    [anon_sym_DASH] = ACTIONS(3048),
    [anon_sym_PLUS] = ACTIONS(3048),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_SLASH] = ACTIONS(3048),
    [anon_sym_PERCENT] = ACTIONS(3048),
    [anon_sym_PIPE_PIPE] = ACTIONS(3046),
    [anon_sym_AMP_AMP] = ACTIONS(3046),
    [anon_sym_PIPE] = ACTIONS(3048),
    [anon_sym_CARET] = ACTIONS(3048),
    [anon_sym_AMP] = ACTIONS(3048),
    [anon_sym_EQ_EQ] = ACTIONS(3046),
    [anon_sym_BANG_EQ] = ACTIONS(3046),
    [anon_sym_GT] = ACTIONS(3048),
    [anon_sym_GT_EQ] = ACTIONS(3046),
    [anon_sym_LT_EQ] = ACTIONS(3048),
    [anon_sym_LT] = ACTIONS(3048),
    [anon_sym_LT_LT] = ACTIONS(3048),
    [anon_sym_GT_GT] = ACTIONS(3048),
    [anon_sym_COLON] = ACTIONS(3046),
    [anon_sym_SEMI] = ACTIONS(3046),
    [anon_sym___attribute__] = ACTIONS(3048),
    [anon_sym_LBRACE] = ACTIONS(3046),
    [anon_sym_RBRACE] = ACTIONS(3046),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_RBRACK] = ACTIONS(3046),
    [anon_sym_EQ] = ACTIONS(3048),
    [anon_sym_QMARK] = ACTIONS(3046),
    [anon_sym_STAR_EQ] = ACTIONS(3046),
    [anon_sym_SLASH_EQ] = ACTIONS(3046),
    [anon_sym_PERCENT_EQ] = ACTIONS(3046),
    [anon_sym_PLUS_EQ] = ACTIONS(3046),
    [anon_sym_DASH_EQ] = ACTIONS(3046),
    [anon_sym_LT_LT_EQ] = ACTIONS(3046),
    [anon_sym_GT_GT_EQ] = ACTIONS(3046),
    [anon_sym_AMP_EQ] = ACTIONS(3046),
    [anon_sym_CARET_EQ] = ACTIONS(3046),
    [anon_sym_PIPE_EQ] = ACTIONS(3046),
    [anon_sym_and_eq] = ACTIONS(3048),
    [anon_sym_or_eq] = ACTIONS(3048),
    [anon_sym_xor_eq] = ACTIONS(3048),
    [anon_sym_LT_EQ_GT] = ACTIONS(3046),
    [anon_sym_or] = ACTIONS(3048),
    [anon_sym_and] = ACTIONS(3048),
    [anon_sym_bitor] = ACTIONS(3048),
    [anon_sym_xor] = ACTIONS(3048),
    [anon_sym_bitand] = ACTIONS(3048),
    [anon_sym_not_eq] = ACTIONS(3048),
    [anon_sym_is] = ACTIONS(3048),
    [anon_sym_as] = ACTIONS(3048),
    [anon_sym_DASH_DASH] = ACTIONS(3046),
    [anon_sym_PLUS_PLUS] = ACTIONS(3046),
    [anon_sym_DOT] = ACTIONS(3048),
    [anon_sym_DOT_STAR] = ACTIONS(3046),
    [anon_sym_DASH_GT] = ACTIONS(3046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3048),
    [anon_sym_let] = ACTIONS(3048),
    [anon_sym_This] = ACTIONS(3048),
  },
  [3040] = {
    [sym_identifier] = ACTIONS(2491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2489),
    [anon_sym_COMMA] = ACTIONS(2489),
    [anon_sym_RPAREN] = ACTIONS(2489),
    [aux_sym_preproc_if_token2] = ACTIONS(2489),
    [aux_sym_preproc_else_token1] = ACTIONS(2489),
    [aux_sym_preproc_elif_token1] = ACTIONS(2491),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2489),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2489),
    [anon_sym_LPAREN2] = ACTIONS(2489),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(2491),
    [anon_sym_SLASH] = ACTIONS(2491),
    [anon_sym_PERCENT] = ACTIONS(2491),
    [anon_sym_PIPE_PIPE] = ACTIONS(2489),
    [anon_sym_AMP_AMP] = ACTIONS(2489),
    [anon_sym_PIPE] = ACTIONS(2491),
    [anon_sym_CARET] = ACTIONS(2491),
    [anon_sym_AMP] = ACTIONS(2491),
    [anon_sym_EQ_EQ] = ACTIONS(2489),
    [anon_sym_BANG_EQ] = ACTIONS(2489),
    [anon_sym_GT] = ACTIONS(2491),
    [anon_sym_GT_EQ] = ACTIONS(2489),
    [anon_sym_LT_EQ] = ACTIONS(2491),
    [anon_sym_LT] = ACTIONS(2491),
    [anon_sym_LT_LT] = ACTIONS(2491),
    [anon_sym_GT_GT] = ACTIONS(2491),
    [anon_sym_COLON] = ACTIONS(2489),
    [anon_sym_SEMI] = ACTIONS(2489),
    [anon_sym___attribute__] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(2489),
    [anon_sym_RBRACE] = ACTIONS(2489),
    [anon_sym_LBRACK] = ACTIONS(2489),
    [anon_sym_RBRACK] = ACTIONS(2489),
    [anon_sym_EQ] = ACTIONS(2491),
    [anon_sym_QMARK] = ACTIONS(2489),
    [anon_sym_STAR_EQ] = ACTIONS(2489),
    [anon_sym_SLASH_EQ] = ACTIONS(2489),
    [anon_sym_PERCENT_EQ] = ACTIONS(2489),
    [anon_sym_PLUS_EQ] = ACTIONS(2489),
    [anon_sym_DASH_EQ] = ACTIONS(2489),
    [anon_sym_LT_LT_EQ] = ACTIONS(2489),
    [anon_sym_GT_GT_EQ] = ACTIONS(2489),
    [anon_sym_AMP_EQ] = ACTIONS(2489),
    [anon_sym_CARET_EQ] = ACTIONS(2489),
    [anon_sym_PIPE_EQ] = ACTIONS(2489),
    [anon_sym_and_eq] = ACTIONS(2491),
    [anon_sym_or_eq] = ACTIONS(2491),
    [anon_sym_xor_eq] = ACTIONS(2491),
    [anon_sym_LT_EQ_GT] = ACTIONS(2489),
    [anon_sym_or] = ACTIONS(2491),
    [anon_sym_and] = ACTIONS(2491),
    [anon_sym_bitor] = ACTIONS(2491),
    [anon_sym_xor] = ACTIONS(2491),
    [anon_sym_bitand] = ACTIONS(2491),
    [anon_sym_not_eq] = ACTIONS(2491),
    [anon_sym_is] = ACTIONS(2491),
    [anon_sym_as] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(2489),
    [anon_sym_PLUS_PLUS] = ACTIONS(2489),
    [anon_sym_DOT] = ACTIONS(2491),
    [anon_sym_DOT_STAR] = ACTIONS(2489),
    [anon_sym_DASH_GT] = ACTIONS(2489),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2491),
    [anon_sym_let] = ACTIONS(2491),
    [anon_sym_This] = ACTIONS(2491),
  },
  [3041] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6433),
    [anon_sym_COMMA] = ACTIONS(6433),
    [anon_sym_RPAREN] = ACTIONS(6433),
    [anon_sym_LPAREN2] = ACTIONS(6433),
    [anon_sym_DASH] = ACTIONS(6431),
    [anon_sym_PLUS] = ACTIONS(6431),
    [anon_sym_STAR] = ACTIONS(6431),
    [anon_sym_SLASH] = ACTIONS(6431),
    [anon_sym_PERCENT] = ACTIONS(6431),
    [anon_sym_PIPE_PIPE] = ACTIONS(6433),
    [anon_sym_AMP_AMP] = ACTIONS(6433),
    [anon_sym_PIPE] = ACTIONS(6431),
    [anon_sym_CARET] = ACTIONS(6431),
    [anon_sym_AMP] = ACTIONS(6431),
    [anon_sym_EQ_EQ] = ACTIONS(6433),
    [anon_sym_BANG_EQ] = ACTIONS(6433),
    [anon_sym_GT] = ACTIONS(6431),
    [anon_sym_GT_EQ] = ACTIONS(6433),
    [anon_sym_LT_EQ] = ACTIONS(6431),
    [anon_sym_LT] = ACTIONS(6431),
    [anon_sym_LT_LT] = ACTIONS(6431),
    [anon_sym_GT_GT] = ACTIONS(6431),
    [anon_sym_COLON] = ACTIONS(6433),
    [anon_sym_SEMI] = ACTIONS(6433),
    [anon_sym_RBRACE] = ACTIONS(6433),
    [anon_sym_LBRACK] = ACTIONS(6433),
    [anon_sym_RBRACK] = ACTIONS(6433),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_QMARK] = ACTIONS(6433),
    [anon_sym_STAR_EQ] = ACTIONS(6433),
    [anon_sym_SLASH_EQ] = ACTIONS(6433),
    [anon_sym_PERCENT_EQ] = ACTIONS(6433),
    [anon_sym_PLUS_EQ] = ACTIONS(6433),
    [anon_sym_DASH_EQ] = ACTIONS(6433),
    [anon_sym_LT_LT_EQ] = ACTIONS(6433),
    [anon_sym_GT_GT_EQ] = ACTIONS(6433),
    [anon_sym_AMP_EQ] = ACTIONS(6433),
    [anon_sym_CARET_EQ] = ACTIONS(6433),
    [anon_sym_PIPE_EQ] = ACTIONS(6433),
    [anon_sym_and_eq] = ACTIONS(6431),
    [anon_sym_or_eq] = ACTIONS(6431),
    [anon_sym_xor_eq] = ACTIONS(6431),
    [anon_sym_LT_EQ_GT] = ACTIONS(6433),
    [anon_sym_or] = ACTIONS(6431),
    [anon_sym_and] = ACTIONS(6431),
    [anon_sym_bitor] = ACTIONS(6431),
    [anon_sym_xor] = ACTIONS(6431),
    [anon_sym_bitand] = ACTIONS(6431),
    [anon_sym_not_eq] = ACTIONS(6431),
    [anon_sym_is] = ACTIONS(6431),
    [anon_sym_as] = ACTIONS(6431),
    [anon_sym_DASH_DASH] = ACTIONS(6433),
    [anon_sym_PLUS_PLUS] = ACTIONS(6433),
    [anon_sym_DOT] = ACTIONS(6431),
    [anon_sym_DOT_STAR] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6433),
    [anon_sym_L_DQUOTE] = ACTIONS(6433),
    [anon_sym_u_DQUOTE] = ACTIONS(6433),
    [anon_sym_U_DQUOTE] = ACTIONS(6433),
    [anon_sym_u8_DQUOTE] = ACTIONS(6433),
    [anon_sym_DQUOTE] = ACTIONS(6433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6433),
    [anon_sym_LR_DQUOTE] = ACTIONS(6433),
    [anon_sym_uR_DQUOTE] = ACTIONS(6433),
    [anon_sym_UR_DQUOTE] = ACTIONS(6433),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6433),
    [sym_literal_suffix] = ACTIONS(6431),
  },
  [3042] = {
    [sym_identifier] = ACTIONS(3098),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3096),
    [anon_sym_COMMA] = ACTIONS(3096),
    [anon_sym_RPAREN] = ACTIONS(3096),
    [aux_sym_preproc_if_token2] = ACTIONS(3096),
    [aux_sym_preproc_else_token1] = ACTIONS(3096),
    [aux_sym_preproc_elif_token1] = ACTIONS(3098),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3096),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3096),
    [anon_sym_LPAREN2] = ACTIONS(3096),
    [anon_sym_DASH] = ACTIONS(3098),
    [anon_sym_PLUS] = ACTIONS(3098),
    [anon_sym_STAR] = ACTIONS(3098),
    [anon_sym_SLASH] = ACTIONS(3098),
    [anon_sym_PERCENT] = ACTIONS(3098),
    [anon_sym_PIPE_PIPE] = ACTIONS(3096),
    [anon_sym_AMP_AMP] = ACTIONS(3096),
    [anon_sym_PIPE] = ACTIONS(3098),
    [anon_sym_CARET] = ACTIONS(3098),
    [anon_sym_AMP] = ACTIONS(3098),
    [anon_sym_EQ_EQ] = ACTIONS(3096),
    [anon_sym_BANG_EQ] = ACTIONS(3096),
    [anon_sym_GT] = ACTIONS(3098),
    [anon_sym_GT_EQ] = ACTIONS(3096),
    [anon_sym_LT_EQ] = ACTIONS(3098),
    [anon_sym_LT] = ACTIONS(3098),
    [anon_sym_LT_LT] = ACTIONS(3098),
    [anon_sym_GT_GT] = ACTIONS(3098),
    [anon_sym_COLON] = ACTIONS(3096),
    [anon_sym_SEMI] = ACTIONS(3096),
    [anon_sym___attribute__] = ACTIONS(3098),
    [anon_sym_LBRACE] = ACTIONS(3096),
    [anon_sym_RBRACE] = ACTIONS(3096),
    [anon_sym_LBRACK] = ACTIONS(3096),
    [anon_sym_RBRACK] = ACTIONS(3096),
    [anon_sym_EQ] = ACTIONS(3098),
    [anon_sym_QMARK] = ACTIONS(3096),
    [anon_sym_STAR_EQ] = ACTIONS(3096),
    [anon_sym_SLASH_EQ] = ACTIONS(3096),
    [anon_sym_PERCENT_EQ] = ACTIONS(3096),
    [anon_sym_PLUS_EQ] = ACTIONS(3096),
    [anon_sym_DASH_EQ] = ACTIONS(3096),
    [anon_sym_LT_LT_EQ] = ACTIONS(3096),
    [anon_sym_GT_GT_EQ] = ACTIONS(3096),
    [anon_sym_AMP_EQ] = ACTIONS(3096),
    [anon_sym_CARET_EQ] = ACTIONS(3096),
    [anon_sym_PIPE_EQ] = ACTIONS(3096),
    [anon_sym_and_eq] = ACTIONS(3098),
    [anon_sym_or_eq] = ACTIONS(3098),
    [anon_sym_xor_eq] = ACTIONS(3098),
    [anon_sym_LT_EQ_GT] = ACTIONS(3096),
    [anon_sym_or] = ACTIONS(3098),
    [anon_sym_and] = ACTIONS(3098),
    [anon_sym_bitor] = ACTIONS(3098),
    [anon_sym_xor] = ACTIONS(3098),
    [anon_sym_bitand] = ACTIONS(3098),
    [anon_sym_not_eq] = ACTIONS(3098),
    [anon_sym_is] = ACTIONS(3098),
    [anon_sym_as] = ACTIONS(3098),
    [anon_sym_DASH_DASH] = ACTIONS(3096),
    [anon_sym_PLUS_PLUS] = ACTIONS(3096),
    [anon_sym_DOT] = ACTIONS(3098),
    [anon_sym_DOT_STAR] = ACTIONS(3096),
    [anon_sym_DASH_GT] = ACTIONS(3096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3098),
    [anon_sym_let] = ACTIONS(3098),
    [anon_sym_This] = ACTIONS(3098),
  },
  [3043] = {
    [sym_identifier] = ACTIONS(3152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3150),
    [anon_sym_COMMA] = ACTIONS(3150),
    [anon_sym_RPAREN] = ACTIONS(3150),
    [aux_sym_preproc_if_token2] = ACTIONS(3150),
    [aux_sym_preproc_else_token1] = ACTIONS(3150),
    [aux_sym_preproc_elif_token1] = ACTIONS(3152),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3150),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3150),
    [anon_sym_LPAREN2] = ACTIONS(3150),
    [anon_sym_DASH] = ACTIONS(3152),
    [anon_sym_PLUS] = ACTIONS(3152),
    [anon_sym_STAR] = ACTIONS(3152),
    [anon_sym_SLASH] = ACTIONS(3152),
    [anon_sym_PERCENT] = ACTIONS(3152),
    [anon_sym_PIPE_PIPE] = ACTIONS(3150),
    [anon_sym_AMP_AMP] = ACTIONS(3150),
    [anon_sym_PIPE] = ACTIONS(3152),
    [anon_sym_CARET] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3152),
    [anon_sym_EQ_EQ] = ACTIONS(3150),
    [anon_sym_BANG_EQ] = ACTIONS(3150),
    [anon_sym_GT] = ACTIONS(3152),
    [anon_sym_GT_EQ] = ACTIONS(3150),
    [anon_sym_LT_EQ] = ACTIONS(3152),
    [anon_sym_LT] = ACTIONS(3152),
    [anon_sym_LT_LT] = ACTIONS(3152),
    [anon_sym_GT_GT] = ACTIONS(3152),
    [anon_sym_COLON] = ACTIONS(3150),
    [anon_sym_SEMI] = ACTIONS(3150),
    [anon_sym___attribute__] = ACTIONS(3152),
    [anon_sym_LBRACE] = ACTIONS(3150),
    [anon_sym_RBRACE] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(3150),
    [anon_sym_RBRACK] = ACTIONS(3150),
    [anon_sym_EQ] = ACTIONS(3152),
    [anon_sym_QMARK] = ACTIONS(3150),
    [anon_sym_STAR_EQ] = ACTIONS(3150),
    [anon_sym_SLASH_EQ] = ACTIONS(3150),
    [anon_sym_PERCENT_EQ] = ACTIONS(3150),
    [anon_sym_PLUS_EQ] = ACTIONS(3150),
    [anon_sym_DASH_EQ] = ACTIONS(3150),
    [anon_sym_LT_LT_EQ] = ACTIONS(3150),
    [anon_sym_GT_GT_EQ] = ACTIONS(3150),
    [anon_sym_AMP_EQ] = ACTIONS(3150),
    [anon_sym_CARET_EQ] = ACTIONS(3150),
    [anon_sym_PIPE_EQ] = ACTIONS(3150),
    [anon_sym_and_eq] = ACTIONS(3152),
    [anon_sym_or_eq] = ACTIONS(3152),
    [anon_sym_xor_eq] = ACTIONS(3152),
    [anon_sym_LT_EQ_GT] = ACTIONS(3150),
    [anon_sym_or] = ACTIONS(3152),
    [anon_sym_and] = ACTIONS(3152),
    [anon_sym_bitor] = ACTIONS(3152),
    [anon_sym_xor] = ACTIONS(3152),
    [anon_sym_bitand] = ACTIONS(3152),
    [anon_sym_not_eq] = ACTIONS(3152),
    [anon_sym_is] = ACTIONS(3152),
    [anon_sym_as] = ACTIONS(3152),
    [anon_sym_DASH_DASH] = ACTIONS(3150),
    [anon_sym_PLUS_PLUS] = ACTIONS(3150),
    [anon_sym_DOT] = ACTIONS(3152),
    [anon_sym_DOT_STAR] = ACTIONS(3150),
    [anon_sym_DASH_GT] = ACTIONS(3150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3152),
    [anon_sym_let] = ACTIONS(3152),
    [anon_sym_This] = ACTIONS(3152),
  },
  [3044] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3088),
    [sym_identifier] = ACTIONS(3757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3759),
    [aux_sym_preproc_if_token2] = ACTIONS(3759),
    [aux_sym_preproc_else_token1] = ACTIONS(3759),
    [aux_sym_preproc_elif_token1] = ACTIONS(3757),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3759),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3757),
    [anon_sym_PLUS] = ACTIONS(3757),
    [anon_sym_STAR] = ACTIONS(3757),
    [anon_sym_SLASH] = ACTIONS(3757),
    [anon_sym_PERCENT] = ACTIONS(3757),
    [anon_sym_PIPE_PIPE] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_PIPE] = ACTIONS(3757),
    [anon_sym_CARET] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3757),
    [anon_sym_EQ_EQ] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_GT] = ACTIONS(3757),
    [anon_sym_GT_EQ] = ACTIONS(3759),
    [anon_sym_LT_EQ] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_LT_LT] = ACTIONS(3757),
    [anon_sym_GT_GT] = ACTIONS(3757),
    [anon_sym___attribute__] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_signed] = ACTIONS(6716),
    [anon_sym_unsigned] = ACTIONS(6716),
    [anon_sym_long] = ACTIONS(6716),
    [anon_sym_short] = ACTIONS(6716),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_STAR_EQ] = ACTIONS(3759),
    [anon_sym_SLASH_EQ] = ACTIONS(3759),
    [anon_sym_PERCENT_EQ] = ACTIONS(3759),
    [anon_sym_PLUS_EQ] = ACTIONS(3759),
    [anon_sym_DASH_EQ] = ACTIONS(3759),
    [anon_sym_LT_LT_EQ] = ACTIONS(3759),
    [anon_sym_GT_GT_EQ] = ACTIONS(3759),
    [anon_sym_AMP_EQ] = ACTIONS(3759),
    [anon_sym_CARET_EQ] = ACTIONS(3759),
    [anon_sym_PIPE_EQ] = ACTIONS(3759),
    [anon_sym_and_eq] = ACTIONS(3757),
    [anon_sym_or_eq] = ACTIONS(3757),
    [anon_sym_xor_eq] = ACTIONS(3757),
    [anon_sym_LT_EQ_GT] = ACTIONS(3759),
    [anon_sym_or] = ACTIONS(3757),
    [anon_sym_and] = ACTIONS(3757),
    [anon_sym_bitor] = ACTIONS(3757),
    [anon_sym_xor] = ACTIONS(3757),
    [anon_sym_bitand] = ACTIONS(3757),
    [anon_sym_not_eq] = ACTIONS(3757),
    [anon_sym_is] = ACTIONS(3757),
    [anon_sym_as] = ACTIONS(3757),
    [anon_sym_DASH_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_PLUS] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(3757),
    [anon_sym_DOT_STAR] = ACTIONS(3759),
    [anon_sym_DASH_GT] = ACTIONS(3759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3757),
    [anon_sym_let] = ACTIONS(3757),
    [anon_sym_This] = ACTIONS(3757),
  },
  [3045] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3050),
    [sym_identifier] = ACTIONS(3764),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3766),
    [anon_sym_COMMA] = ACTIONS(3766),
    [aux_sym_preproc_if_token2] = ACTIONS(3766),
    [aux_sym_preproc_else_token1] = ACTIONS(3766),
    [aux_sym_preproc_elif_token1] = ACTIONS(3764),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3766),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3766),
    [anon_sym_LPAREN2] = ACTIONS(3766),
    [anon_sym_DASH] = ACTIONS(3764),
    [anon_sym_PLUS] = ACTIONS(3764),
    [anon_sym_STAR] = ACTIONS(3764),
    [anon_sym_SLASH] = ACTIONS(3764),
    [anon_sym_PERCENT] = ACTIONS(3764),
    [anon_sym_PIPE_PIPE] = ACTIONS(3766),
    [anon_sym_AMP_AMP] = ACTIONS(3766),
    [anon_sym_PIPE] = ACTIONS(3764),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_AMP] = ACTIONS(3764),
    [anon_sym_EQ_EQ] = ACTIONS(3766),
    [anon_sym_BANG_EQ] = ACTIONS(3766),
    [anon_sym_GT] = ACTIONS(3764),
    [anon_sym_GT_EQ] = ACTIONS(3766),
    [anon_sym_LT_EQ] = ACTIONS(3764),
    [anon_sym_LT] = ACTIONS(3764),
    [anon_sym_LT_LT] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3764),
    [anon_sym___attribute__] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3766),
    [anon_sym_signed] = ACTIONS(6718),
    [anon_sym_unsigned] = ACTIONS(6718),
    [anon_sym_long] = ACTIONS(6718),
    [anon_sym_short] = ACTIONS(6718),
    [anon_sym_LBRACK] = ACTIONS(3766),
    [anon_sym_EQ] = ACTIONS(3764),
    [anon_sym_QMARK] = ACTIONS(3766),
    [anon_sym_STAR_EQ] = ACTIONS(3766),
    [anon_sym_SLASH_EQ] = ACTIONS(3766),
    [anon_sym_PERCENT_EQ] = ACTIONS(3766),
    [anon_sym_PLUS_EQ] = ACTIONS(3766),
    [anon_sym_DASH_EQ] = ACTIONS(3766),
    [anon_sym_LT_LT_EQ] = ACTIONS(3766),
    [anon_sym_GT_GT_EQ] = ACTIONS(3766),
    [anon_sym_AMP_EQ] = ACTIONS(3766),
    [anon_sym_CARET_EQ] = ACTIONS(3766),
    [anon_sym_PIPE_EQ] = ACTIONS(3766),
    [anon_sym_and_eq] = ACTIONS(3764),
    [anon_sym_or_eq] = ACTIONS(3764),
    [anon_sym_xor_eq] = ACTIONS(3764),
    [anon_sym_LT_EQ_GT] = ACTIONS(3766),
    [anon_sym_or] = ACTIONS(3764),
    [anon_sym_and] = ACTIONS(3764),
    [anon_sym_bitor] = ACTIONS(3764),
    [anon_sym_xor] = ACTIONS(3764),
    [anon_sym_bitand] = ACTIONS(3764),
    [anon_sym_not_eq] = ACTIONS(3764),
    [anon_sym_is] = ACTIONS(3764),
    [anon_sym_as] = ACTIONS(3764),
    [anon_sym_DASH_DASH] = ACTIONS(3766),
    [anon_sym_PLUS_PLUS] = ACTIONS(3766),
    [anon_sym_DOT] = ACTIONS(3764),
    [anon_sym_DOT_STAR] = ACTIONS(3766),
    [anon_sym_DASH_GT] = ACTIONS(3766),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3764),
    [anon_sym_let] = ACTIONS(3764),
    [anon_sym_This] = ACTIONS(3764),
  },
  [3046] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3056),
    [sym_identifier] = ACTIONS(3771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3773),
    [anon_sym_COMMA] = ACTIONS(3773),
    [aux_sym_preproc_if_token2] = ACTIONS(3773),
    [aux_sym_preproc_else_token1] = ACTIONS(3773),
    [aux_sym_preproc_elif_token1] = ACTIONS(3771),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3773),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3773),
    [anon_sym_LPAREN2] = ACTIONS(3773),
    [anon_sym_DASH] = ACTIONS(3771),
    [anon_sym_PLUS] = ACTIONS(3771),
    [anon_sym_STAR] = ACTIONS(3771),
    [anon_sym_SLASH] = ACTIONS(3771),
    [anon_sym_PERCENT] = ACTIONS(3771),
    [anon_sym_PIPE_PIPE] = ACTIONS(3773),
    [anon_sym_AMP_AMP] = ACTIONS(3773),
    [anon_sym_PIPE] = ACTIONS(3771),
    [anon_sym_CARET] = ACTIONS(3771),
    [anon_sym_AMP] = ACTIONS(3771),
    [anon_sym_EQ_EQ] = ACTIONS(3773),
    [anon_sym_BANG_EQ] = ACTIONS(3773),
    [anon_sym_GT] = ACTIONS(3771),
    [anon_sym_GT_EQ] = ACTIONS(3773),
    [anon_sym_LT_EQ] = ACTIONS(3771),
    [anon_sym_LT] = ACTIONS(3771),
    [anon_sym_LT_LT] = ACTIONS(3771),
    [anon_sym_GT_GT] = ACTIONS(3771),
    [anon_sym___attribute__] = ACTIONS(3771),
    [anon_sym_LBRACE] = ACTIONS(3773),
    [anon_sym_signed] = ACTIONS(6720),
    [anon_sym_unsigned] = ACTIONS(6720),
    [anon_sym_long] = ACTIONS(6720),
    [anon_sym_short] = ACTIONS(6720),
    [anon_sym_LBRACK] = ACTIONS(3773),
    [anon_sym_EQ] = ACTIONS(3771),
    [anon_sym_QMARK] = ACTIONS(3773),
    [anon_sym_STAR_EQ] = ACTIONS(3773),
    [anon_sym_SLASH_EQ] = ACTIONS(3773),
    [anon_sym_PERCENT_EQ] = ACTIONS(3773),
    [anon_sym_PLUS_EQ] = ACTIONS(3773),
    [anon_sym_DASH_EQ] = ACTIONS(3773),
    [anon_sym_LT_LT_EQ] = ACTIONS(3773),
    [anon_sym_GT_GT_EQ] = ACTIONS(3773),
    [anon_sym_AMP_EQ] = ACTIONS(3773),
    [anon_sym_CARET_EQ] = ACTIONS(3773),
    [anon_sym_PIPE_EQ] = ACTIONS(3773),
    [anon_sym_and_eq] = ACTIONS(3771),
    [anon_sym_or_eq] = ACTIONS(3771),
    [anon_sym_xor_eq] = ACTIONS(3771),
    [anon_sym_LT_EQ_GT] = ACTIONS(3773),
    [anon_sym_or] = ACTIONS(3771),
    [anon_sym_and] = ACTIONS(3771),
    [anon_sym_bitor] = ACTIONS(3771),
    [anon_sym_xor] = ACTIONS(3771),
    [anon_sym_bitand] = ACTIONS(3771),
    [anon_sym_not_eq] = ACTIONS(3771),
    [anon_sym_is] = ACTIONS(3771),
    [anon_sym_as] = ACTIONS(3771),
    [anon_sym_DASH_DASH] = ACTIONS(3773),
    [anon_sym_PLUS_PLUS] = ACTIONS(3773),
    [anon_sym_DOT] = ACTIONS(3771),
    [anon_sym_DOT_STAR] = ACTIONS(3773),
    [anon_sym_DASH_GT] = ACTIONS(3773),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3771),
    [anon_sym_let] = ACTIONS(3771),
    [anon_sym_This] = ACTIONS(3771),
  },
  [3047] = {
    [sym_string_literal] = STATE(4271),
    [sym_template_argument_list] = STATE(5349),
    [sym_raw_string_literal] = STATE(4271),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2128),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(6176),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2117),
    [anon_sym_EQ] = ACTIONS(6183),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(6181),
    [anon_sym_SLASH_EQ] = ACTIONS(6181),
    [anon_sym_PERCENT_EQ] = ACTIONS(6181),
    [anon_sym_PLUS_EQ] = ACTIONS(6181),
    [anon_sym_DASH_EQ] = ACTIONS(6181),
    [anon_sym_LT_LT_EQ] = ACTIONS(6181),
    [anon_sym_GT_GT_EQ] = ACTIONS(6183),
    [anon_sym_AMP_EQ] = ACTIONS(6181),
    [anon_sym_CARET_EQ] = ACTIONS(6181),
    [anon_sym_PIPE_EQ] = ACTIONS(6181),
    [anon_sym_and_eq] = ACTIONS(6181),
    [anon_sym_or_eq] = ACTIONS(6181),
    [anon_sym_xor_eq] = ACTIONS(6181),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2117),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2117),
    [anon_sym_not_eq] = ACTIONS(2117),
    [anon_sym_is] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(6185),
    [anon_sym_u_DQUOTE] = ACTIONS(6185),
    [anon_sym_U_DQUOTE] = ACTIONS(6185),
    [anon_sym_u8_DQUOTE] = ACTIONS(6185),
    [anon_sym_DQUOTE] = ACTIONS(6185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(2117),
    [anon_sym_R_DQUOTE] = ACTIONS(6187),
    [anon_sym_LR_DQUOTE] = ACTIONS(6187),
    [anon_sym_uR_DQUOTE] = ACTIONS(6187),
    [anon_sym_UR_DQUOTE] = ACTIONS(6187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6187),
  },
  [3048] = {
    [sym_identifier] = ACTIONS(3000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2998),
    [anon_sym_COMMA] = ACTIONS(2998),
    [anon_sym_RPAREN] = ACTIONS(2998),
    [aux_sym_preproc_if_token2] = ACTIONS(2998),
    [aux_sym_preproc_else_token1] = ACTIONS(2998),
    [aux_sym_preproc_elif_token1] = ACTIONS(3000),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2998),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2998),
    [anon_sym_LPAREN2] = ACTIONS(2998),
    [anon_sym_DASH] = ACTIONS(3000),
    [anon_sym_PLUS] = ACTIONS(3000),
    [anon_sym_STAR] = ACTIONS(3000),
    [anon_sym_SLASH] = ACTIONS(3000),
    [anon_sym_PERCENT] = ACTIONS(3000),
    [anon_sym_PIPE_PIPE] = ACTIONS(2998),
    [anon_sym_AMP_AMP] = ACTIONS(2998),
    [anon_sym_PIPE] = ACTIONS(3000),
    [anon_sym_CARET] = ACTIONS(3000),
    [anon_sym_AMP] = ACTIONS(3000),
    [anon_sym_EQ_EQ] = ACTIONS(2998),
    [anon_sym_BANG_EQ] = ACTIONS(2998),
    [anon_sym_GT] = ACTIONS(3000),
    [anon_sym_GT_EQ] = ACTIONS(2998),
    [anon_sym_LT_EQ] = ACTIONS(3000),
    [anon_sym_LT] = ACTIONS(3000),
    [anon_sym_LT_LT] = ACTIONS(3000),
    [anon_sym_GT_GT] = ACTIONS(3000),
    [anon_sym_COLON] = ACTIONS(2998),
    [anon_sym_SEMI] = ACTIONS(2998),
    [anon_sym___attribute__] = ACTIONS(3000),
    [anon_sym_LBRACE] = ACTIONS(2998),
    [anon_sym_RBRACE] = ACTIONS(2998),
    [anon_sym_LBRACK] = ACTIONS(2998),
    [anon_sym_RBRACK] = ACTIONS(2998),
    [anon_sym_EQ] = ACTIONS(3000),
    [anon_sym_QMARK] = ACTIONS(2998),
    [anon_sym_STAR_EQ] = ACTIONS(2998),
    [anon_sym_SLASH_EQ] = ACTIONS(2998),
    [anon_sym_PERCENT_EQ] = ACTIONS(2998),
    [anon_sym_PLUS_EQ] = ACTIONS(2998),
    [anon_sym_DASH_EQ] = ACTIONS(2998),
    [anon_sym_LT_LT_EQ] = ACTIONS(2998),
    [anon_sym_GT_GT_EQ] = ACTIONS(2998),
    [anon_sym_AMP_EQ] = ACTIONS(2998),
    [anon_sym_CARET_EQ] = ACTIONS(2998),
    [anon_sym_PIPE_EQ] = ACTIONS(2998),
    [anon_sym_and_eq] = ACTIONS(3000),
    [anon_sym_or_eq] = ACTIONS(3000),
    [anon_sym_xor_eq] = ACTIONS(3000),
    [anon_sym_LT_EQ_GT] = ACTIONS(2998),
    [anon_sym_or] = ACTIONS(3000),
    [anon_sym_and] = ACTIONS(3000),
    [anon_sym_bitor] = ACTIONS(3000),
    [anon_sym_xor] = ACTIONS(3000),
    [anon_sym_bitand] = ACTIONS(3000),
    [anon_sym_not_eq] = ACTIONS(3000),
    [anon_sym_is] = ACTIONS(3000),
    [anon_sym_as] = ACTIONS(3000),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_DOT] = ACTIONS(3000),
    [anon_sym_DOT_STAR] = ACTIONS(2998),
    [anon_sym_DASH_GT] = ACTIONS(2998),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3000),
    [anon_sym_let] = ACTIONS(3000),
    [anon_sym_This] = ACTIONS(3000),
  },
  [3049] = {
    [sym__declaration_modifiers] = STATE(2670),
    [sym_attribute_specifier] = STATE(2670),
    [sym_attribute_declaration] = STATE(2670),
    [sym_ms_declspec_modifier] = STATE(2670),
    [sym_storage_class_specifier] = STATE(2670),
    [sym_type_qualifier] = STATE(2670),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_qualifiers] = STATE(2670),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2670),
    [anon_sym_LPAREN2] = ACTIONS(6323),
    [anon_sym_STAR] = ACTIONS(6323),
    [anon_sym_AMP_AMP] = ACTIONS(6323),
    [anon_sym_AMP] = ACTIONS(6321),
    [anon_sym___extension__] = ACTIONS(6722),
    [anon_sym_in] = ACTIONS(6325),
    [anon_sym_out] = ACTIONS(6724),
    [anon_sym_inout] = ACTIONS(6724),
    [anon_sym_extern] = ACTIONS(6726),
    [anon_sym___attribute__] = ACTIONS(6728),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6152),
    [anon_sym___declspec] = ACTIONS(6730),
    [anon_sym_LBRACK] = ACTIONS(6321),
    [anon_sym_static] = ACTIONS(6726),
    [anon_sym_register] = ACTIONS(6726),
    [anon_sym_inline] = ACTIONS(6726),
    [anon_sym___inline] = ACTIONS(6146),
    [anon_sym___inline__] = ACTIONS(6726),
    [anon_sym___forceinline] = ACTIONS(6726),
    [anon_sym_thread_local] = ACTIONS(6726),
    [anon_sym___thread] = ACTIONS(6726),
    [anon_sym_const] = ACTIONS(6142),
    [anon_sym_constexpr] = ACTIONS(6722),
    [anon_sym_volatile] = ACTIONS(6722),
    [anon_sym_restrict] = ACTIONS(6722),
    [anon_sym___restrict__] = ACTIONS(6722),
    [anon_sym__Atomic] = ACTIONS(6722),
    [anon_sym__Noreturn] = ACTIONS(6722),
    [anon_sym_noreturn] = ACTIONS(6722),
    [anon_sym_mutable] = ACTIONS(6722),
    [anon_sym_constinit] = ACTIONS(6722),
    [anon_sym_consteval] = ACTIONS(6722),
    [anon_sym_alignas] = ACTIONS(6732),
    [anon_sym__Alignas] = ACTIONS(6732),
    [anon_sym_DOT] = ACTIONS(6734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6736),
    [anon_sym_let] = ACTIONS(6736),
    [anon_sym_This] = ACTIONS(6736),
    [sym_virtual] = ACTIONS(6724),
    [anon_sym_precise] = ACTIONS(6738),
    [anon_sym_shared] = ACTIONS(6738),
    [anon_sym_groupshared] = ACTIONS(6738),
    [anon_sym_uniform] = ACTIONS(6738),
    [anon_sym_row_major] = ACTIONS(6738),
    [anon_sym_column_major] = ACTIONS(6738),
    [anon_sym_globallycoherent] = ACTIONS(6738),
    [anon_sym_centroid] = ACTIONS(6738),
    [anon_sym_noperspective] = ACTIONS(6738),
    [anon_sym_nointerpolation] = ACTIONS(6738),
    [anon_sym_sample] = ACTIONS(6738),
    [anon_sym_linear] = ACTIONS(6738),
    [anon_sym_snorm] = ACTIONS(6738),
    [anon_sym_unorm] = ACTIONS(6738),
    [anon_sym_point] = ACTIONS(6738),
    [anon_sym_line] = ACTIONS(6158),
    [anon_sym_triangleadj] = ACTIONS(6738),
    [anon_sym_lineadj] = ACTIONS(6738),
    [anon_sym_triangle] = ACTIONS(6158),
  },
  [3050] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3088),
    [sym_identifier] = ACTIONS(3810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3812),
    [anon_sym_COMMA] = ACTIONS(3812),
    [aux_sym_preproc_if_token2] = ACTIONS(3812),
    [aux_sym_preproc_else_token1] = ACTIONS(3812),
    [aux_sym_preproc_elif_token1] = ACTIONS(3810),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3812),
    [anon_sym_DASH] = ACTIONS(3810),
    [anon_sym_PLUS] = ACTIONS(3810),
    [anon_sym_STAR] = ACTIONS(3810),
    [anon_sym_SLASH] = ACTIONS(3810),
    [anon_sym_PERCENT] = ACTIONS(3810),
    [anon_sym_PIPE_PIPE] = ACTIONS(3812),
    [anon_sym_AMP_AMP] = ACTIONS(3812),
    [anon_sym_PIPE] = ACTIONS(3810),
    [anon_sym_CARET] = ACTIONS(3810),
    [anon_sym_AMP] = ACTIONS(3810),
    [anon_sym_EQ_EQ] = ACTIONS(3812),
    [anon_sym_BANG_EQ] = ACTIONS(3812),
    [anon_sym_GT] = ACTIONS(3810),
    [anon_sym_GT_EQ] = ACTIONS(3812),
    [anon_sym_LT_EQ] = ACTIONS(3810),
    [anon_sym_LT] = ACTIONS(3810),
    [anon_sym_LT_LT] = ACTIONS(3810),
    [anon_sym_GT_GT] = ACTIONS(3810),
    [anon_sym___attribute__] = ACTIONS(3810),
    [anon_sym_LBRACE] = ACTIONS(3812),
    [anon_sym_signed] = ACTIONS(6716),
    [anon_sym_unsigned] = ACTIONS(6716),
    [anon_sym_long] = ACTIONS(6716),
    [anon_sym_short] = ACTIONS(6716),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_EQ] = ACTIONS(3810),
    [anon_sym_QMARK] = ACTIONS(3812),
    [anon_sym_STAR_EQ] = ACTIONS(3812),
    [anon_sym_SLASH_EQ] = ACTIONS(3812),
    [anon_sym_PERCENT_EQ] = ACTIONS(3812),
    [anon_sym_PLUS_EQ] = ACTIONS(3812),
    [anon_sym_DASH_EQ] = ACTIONS(3812),
    [anon_sym_LT_LT_EQ] = ACTIONS(3812),
    [anon_sym_GT_GT_EQ] = ACTIONS(3812),
    [anon_sym_AMP_EQ] = ACTIONS(3812),
    [anon_sym_CARET_EQ] = ACTIONS(3812),
    [anon_sym_PIPE_EQ] = ACTIONS(3812),
    [anon_sym_and_eq] = ACTIONS(3810),
    [anon_sym_or_eq] = ACTIONS(3810),
    [anon_sym_xor_eq] = ACTIONS(3810),
    [anon_sym_LT_EQ_GT] = ACTIONS(3812),
    [anon_sym_or] = ACTIONS(3810),
    [anon_sym_and] = ACTIONS(3810),
    [anon_sym_bitor] = ACTIONS(3810),
    [anon_sym_xor] = ACTIONS(3810),
    [anon_sym_bitand] = ACTIONS(3810),
    [anon_sym_not_eq] = ACTIONS(3810),
    [anon_sym_is] = ACTIONS(3810),
    [anon_sym_as] = ACTIONS(3810),
    [anon_sym_DASH_DASH] = ACTIONS(3812),
    [anon_sym_PLUS_PLUS] = ACTIONS(3812),
    [anon_sym_DOT] = ACTIONS(3810),
    [anon_sym_DOT_STAR] = ACTIONS(3812),
    [anon_sym_DASH_GT] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3810),
    [anon_sym_let] = ACTIONS(3810),
    [anon_sym_This] = ACTIONS(3810),
  },
  [3051] = {
    [sym_identifier] = ACTIONS(2536),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2534),
    [anon_sym_COMMA] = ACTIONS(2534),
    [anon_sym_RPAREN] = ACTIONS(2534),
    [aux_sym_preproc_if_token2] = ACTIONS(2534),
    [aux_sym_preproc_else_token1] = ACTIONS(2534),
    [aux_sym_preproc_elif_token1] = ACTIONS(2536),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2534),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2534),
    [anon_sym_LPAREN2] = ACTIONS(2534),
    [anon_sym_DASH] = ACTIONS(2536),
    [anon_sym_PLUS] = ACTIONS(2536),
    [anon_sym_STAR] = ACTIONS(2536),
    [anon_sym_SLASH] = ACTIONS(2536),
    [anon_sym_PERCENT] = ACTIONS(2536),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_CARET] = ACTIONS(2536),
    [anon_sym_AMP] = ACTIONS(2536),
    [anon_sym_EQ_EQ] = ACTIONS(2534),
    [anon_sym_BANG_EQ] = ACTIONS(2534),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_EQ] = ACTIONS(2534),
    [anon_sym_LT_EQ] = ACTIONS(2536),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2536),
    [anon_sym_COLON] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2534),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym_LBRACE] = ACTIONS(2534),
    [anon_sym_RBRACE] = ACTIONS(2534),
    [anon_sym_LBRACK] = ACTIONS(2534),
    [anon_sym_RBRACK] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2536),
    [anon_sym_QMARK] = ACTIONS(2534),
    [anon_sym_STAR_EQ] = ACTIONS(2534),
    [anon_sym_SLASH_EQ] = ACTIONS(2534),
    [anon_sym_PERCENT_EQ] = ACTIONS(2534),
    [anon_sym_PLUS_EQ] = ACTIONS(2534),
    [anon_sym_DASH_EQ] = ACTIONS(2534),
    [anon_sym_LT_LT_EQ] = ACTIONS(2534),
    [anon_sym_GT_GT_EQ] = ACTIONS(2534),
    [anon_sym_AMP_EQ] = ACTIONS(2534),
    [anon_sym_CARET_EQ] = ACTIONS(2534),
    [anon_sym_PIPE_EQ] = ACTIONS(2534),
    [anon_sym_and_eq] = ACTIONS(2536),
    [anon_sym_or_eq] = ACTIONS(2536),
    [anon_sym_xor_eq] = ACTIONS(2536),
    [anon_sym_LT_EQ_GT] = ACTIONS(2534),
    [anon_sym_or] = ACTIONS(2536),
    [anon_sym_and] = ACTIONS(2536),
    [anon_sym_bitor] = ACTIONS(2536),
    [anon_sym_xor] = ACTIONS(2536),
    [anon_sym_bitand] = ACTIONS(2536),
    [anon_sym_not_eq] = ACTIONS(2536),
    [anon_sym_is] = ACTIONS(2536),
    [anon_sym_as] = ACTIONS(2536),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DOT] = ACTIONS(2536),
    [anon_sym_DOT_STAR] = ACTIONS(2534),
    [anon_sym_DASH_GT] = ACTIONS(2534),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2536),
    [anon_sym_let] = ACTIONS(2536),
    [anon_sym_This] = ACTIONS(2536),
  },
  [3052] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6526),
    [anon_sym_COMMA] = ACTIONS(6526),
    [anon_sym_RPAREN] = ACTIONS(6526),
    [anon_sym_LPAREN2] = ACTIONS(6526),
    [anon_sym_DASH] = ACTIONS(6524),
    [anon_sym_PLUS] = ACTIONS(6524),
    [anon_sym_STAR] = ACTIONS(6524),
    [anon_sym_SLASH] = ACTIONS(6524),
    [anon_sym_PERCENT] = ACTIONS(6524),
    [anon_sym_PIPE_PIPE] = ACTIONS(6526),
    [anon_sym_AMP_AMP] = ACTIONS(6526),
    [anon_sym_PIPE] = ACTIONS(6524),
    [anon_sym_CARET] = ACTIONS(6524),
    [anon_sym_AMP] = ACTIONS(6524),
    [anon_sym_EQ_EQ] = ACTIONS(6526),
    [anon_sym_BANG_EQ] = ACTIONS(6526),
    [anon_sym_GT] = ACTIONS(6524),
    [anon_sym_GT_EQ] = ACTIONS(6526),
    [anon_sym_LT_EQ] = ACTIONS(6524),
    [anon_sym_LT] = ACTIONS(6524),
    [anon_sym_LT_LT] = ACTIONS(6524),
    [anon_sym_GT_GT] = ACTIONS(6524),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_SEMI] = ACTIONS(6526),
    [anon_sym_RBRACE] = ACTIONS(6526),
    [anon_sym_LBRACK] = ACTIONS(6526),
    [anon_sym_RBRACK] = ACTIONS(6526),
    [anon_sym_EQ] = ACTIONS(6524),
    [anon_sym_QMARK] = ACTIONS(6526),
    [anon_sym_STAR_EQ] = ACTIONS(6526),
    [anon_sym_SLASH_EQ] = ACTIONS(6526),
    [anon_sym_PERCENT_EQ] = ACTIONS(6526),
    [anon_sym_PLUS_EQ] = ACTIONS(6526),
    [anon_sym_DASH_EQ] = ACTIONS(6526),
    [anon_sym_LT_LT_EQ] = ACTIONS(6526),
    [anon_sym_GT_GT_EQ] = ACTIONS(6526),
    [anon_sym_AMP_EQ] = ACTIONS(6526),
    [anon_sym_CARET_EQ] = ACTIONS(6526),
    [anon_sym_PIPE_EQ] = ACTIONS(6526),
    [anon_sym_and_eq] = ACTIONS(6524),
    [anon_sym_or_eq] = ACTIONS(6524),
    [anon_sym_xor_eq] = ACTIONS(6524),
    [anon_sym_LT_EQ_GT] = ACTIONS(6526),
    [anon_sym_or] = ACTIONS(6524),
    [anon_sym_and] = ACTIONS(6524),
    [anon_sym_bitor] = ACTIONS(6524),
    [anon_sym_xor] = ACTIONS(6524),
    [anon_sym_bitand] = ACTIONS(6524),
    [anon_sym_not_eq] = ACTIONS(6524),
    [anon_sym_is] = ACTIONS(6524),
    [anon_sym_as] = ACTIONS(6524),
    [anon_sym_DASH_DASH] = ACTIONS(6526),
    [anon_sym_PLUS_PLUS] = ACTIONS(6526),
    [anon_sym_DOT] = ACTIONS(6524),
    [anon_sym_DOT_STAR] = ACTIONS(6526),
    [anon_sym_DASH_GT] = ACTIONS(6526),
    [anon_sym_L_DQUOTE] = ACTIONS(6526),
    [anon_sym_u_DQUOTE] = ACTIONS(6526),
    [anon_sym_U_DQUOTE] = ACTIONS(6526),
    [anon_sym_u8_DQUOTE] = ACTIONS(6526),
    [anon_sym_DQUOTE] = ACTIONS(6526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6526),
    [anon_sym_LR_DQUOTE] = ACTIONS(6526),
    [anon_sym_uR_DQUOTE] = ACTIONS(6526),
    [anon_sym_UR_DQUOTE] = ACTIONS(6526),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6526),
    [sym_literal_suffix] = ACTIONS(6524),
  },
  [3053] = {
    [sym_string_literal] = STATE(3062),
    [sym_raw_string_literal] = STATE(3062),
    [aux_sym_concatenated_string_repeat1] = STATE(3062),
    [sym_identifier] = ACTIONS(6740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6437),
    [anon_sym_COMMA] = ACTIONS(6437),
    [anon_sym_LPAREN2] = ACTIONS(6437),
    [anon_sym_DASH] = ACTIONS(6439),
    [anon_sym_PLUS] = ACTIONS(6439),
    [anon_sym_STAR] = ACTIONS(6439),
    [anon_sym_SLASH] = ACTIONS(6439),
    [anon_sym_PERCENT] = ACTIONS(6439),
    [anon_sym_PIPE_PIPE] = ACTIONS(6437),
    [anon_sym_AMP_AMP] = ACTIONS(6437),
    [anon_sym_PIPE] = ACTIONS(6439),
    [anon_sym_CARET] = ACTIONS(6439),
    [anon_sym_AMP] = ACTIONS(6439),
    [anon_sym_EQ_EQ] = ACTIONS(6437),
    [anon_sym_BANG_EQ] = ACTIONS(6437),
    [anon_sym_GT] = ACTIONS(6439),
    [anon_sym_GT_EQ] = ACTIONS(6439),
    [anon_sym_LT_EQ] = ACTIONS(6439),
    [anon_sym_LT] = ACTIONS(6439),
    [anon_sym_LT_LT] = ACTIONS(6439),
    [anon_sym_GT_GT] = ACTIONS(6439),
    [anon_sym_LBRACK] = ACTIONS(6437),
    [anon_sym_EQ] = ACTIONS(6439),
    [anon_sym_QMARK] = ACTIONS(6437),
    [anon_sym_STAR_EQ] = ACTIONS(6437),
    [anon_sym_SLASH_EQ] = ACTIONS(6437),
    [anon_sym_PERCENT_EQ] = ACTIONS(6437),
    [anon_sym_PLUS_EQ] = ACTIONS(6437),
    [anon_sym_DASH_EQ] = ACTIONS(6437),
    [anon_sym_LT_LT_EQ] = ACTIONS(6437),
    [anon_sym_GT_GT_EQ] = ACTIONS(6439),
    [anon_sym_AMP_EQ] = ACTIONS(6437),
    [anon_sym_CARET_EQ] = ACTIONS(6437),
    [anon_sym_PIPE_EQ] = ACTIONS(6437),
    [anon_sym_and_eq] = ACTIONS(6439),
    [anon_sym_or_eq] = ACTIONS(6439),
    [anon_sym_xor_eq] = ACTIONS(6439),
    [anon_sym_LT_EQ_GT] = ACTIONS(6437),
    [anon_sym_or] = ACTIONS(6439),
    [anon_sym_and] = ACTIONS(6439),
    [anon_sym_bitor] = ACTIONS(6439),
    [anon_sym_xor] = ACTIONS(6439),
    [anon_sym_bitand] = ACTIONS(6439),
    [anon_sym_not_eq] = ACTIONS(6439),
    [anon_sym_is] = ACTIONS(6439),
    [anon_sym_as] = ACTIONS(6439),
    [anon_sym_DASH_DASH] = ACTIONS(6437),
    [anon_sym_PLUS_PLUS] = ACTIONS(6437),
    [anon_sym_DOT] = ACTIONS(6439),
    [anon_sym_DOT_STAR] = ACTIONS(6437),
    [anon_sym_DASH_GT] = ACTIONS(6437),
    [anon_sym_L_DQUOTE] = ACTIONS(6742),
    [anon_sym_u_DQUOTE] = ACTIONS(6742),
    [anon_sym_U_DQUOTE] = ACTIONS(6742),
    [anon_sym_u8_DQUOTE] = ACTIONS(6742),
    [anon_sym_DQUOTE] = ACTIONS(6742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(6437),
    [anon_sym_R_DQUOTE] = ACTIONS(6744),
    [anon_sym_LR_DQUOTE] = ACTIONS(6744),
    [anon_sym_uR_DQUOTE] = ACTIONS(6744),
    [anon_sym_UR_DQUOTE] = ACTIONS(6744),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6744),
    [sym_literal_suffix] = ACTIONS(6439),
  },
  [3054] = {
    [sym_identifier] = ACTIONS(3058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3056),
    [anon_sym_COMMA] = ACTIONS(3056),
    [anon_sym_RPAREN] = ACTIONS(3056),
    [aux_sym_preproc_if_token2] = ACTIONS(3056),
    [aux_sym_preproc_else_token1] = ACTIONS(3056),
    [aux_sym_preproc_elif_token1] = ACTIONS(3058),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3056),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3056),
    [anon_sym_LPAREN2] = ACTIONS(3056),
    [anon_sym_DASH] = ACTIONS(3058),
    [anon_sym_PLUS] = ACTIONS(3058),
    [anon_sym_STAR] = ACTIONS(3058),
    [anon_sym_SLASH] = ACTIONS(3058),
    [anon_sym_PERCENT] = ACTIONS(3058),
    [anon_sym_PIPE_PIPE] = ACTIONS(3056),
    [anon_sym_AMP_AMP] = ACTIONS(3056),
    [anon_sym_PIPE] = ACTIONS(3058),
    [anon_sym_CARET] = ACTIONS(3058),
    [anon_sym_AMP] = ACTIONS(3058),
    [anon_sym_EQ_EQ] = ACTIONS(3056),
    [anon_sym_BANG_EQ] = ACTIONS(3056),
    [anon_sym_GT] = ACTIONS(3058),
    [anon_sym_GT_EQ] = ACTIONS(3056),
    [anon_sym_LT_EQ] = ACTIONS(3058),
    [anon_sym_LT] = ACTIONS(3058),
    [anon_sym_LT_LT] = ACTIONS(3058),
    [anon_sym_GT_GT] = ACTIONS(3058),
    [anon_sym_COLON] = ACTIONS(3056),
    [anon_sym_SEMI] = ACTIONS(3056),
    [anon_sym___attribute__] = ACTIONS(3058),
    [anon_sym_LBRACE] = ACTIONS(3056),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [anon_sym_RBRACK] = ACTIONS(3056),
    [anon_sym_EQ] = ACTIONS(3058),
    [anon_sym_QMARK] = ACTIONS(3056),
    [anon_sym_STAR_EQ] = ACTIONS(3056),
    [anon_sym_SLASH_EQ] = ACTIONS(3056),
    [anon_sym_PERCENT_EQ] = ACTIONS(3056),
    [anon_sym_PLUS_EQ] = ACTIONS(3056),
    [anon_sym_DASH_EQ] = ACTIONS(3056),
    [anon_sym_LT_LT_EQ] = ACTIONS(3056),
    [anon_sym_GT_GT_EQ] = ACTIONS(3056),
    [anon_sym_AMP_EQ] = ACTIONS(3056),
    [anon_sym_CARET_EQ] = ACTIONS(3056),
    [anon_sym_PIPE_EQ] = ACTIONS(3056),
    [anon_sym_and_eq] = ACTIONS(3058),
    [anon_sym_or_eq] = ACTIONS(3058),
    [anon_sym_xor_eq] = ACTIONS(3058),
    [anon_sym_LT_EQ_GT] = ACTIONS(3056),
    [anon_sym_or] = ACTIONS(3058),
    [anon_sym_and] = ACTIONS(3058),
    [anon_sym_bitor] = ACTIONS(3058),
    [anon_sym_xor] = ACTIONS(3058),
    [anon_sym_bitand] = ACTIONS(3058),
    [anon_sym_not_eq] = ACTIONS(3058),
    [anon_sym_is] = ACTIONS(3058),
    [anon_sym_as] = ACTIONS(3058),
    [anon_sym_DASH_DASH] = ACTIONS(3056),
    [anon_sym_PLUS_PLUS] = ACTIONS(3056),
    [anon_sym_DOT] = ACTIONS(3058),
    [anon_sym_DOT_STAR] = ACTIONS(3056),
    [anon_sym_DASH_GT] = ACTIONS(3056),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3058),
    [anon_sym_let] = ACTIONS(3058),
    [anon_sym_This] = ACTIONS(3058),
  },
  [3055] = {
    [sym_identifier] = ACTIONS(3388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3386),
    [anon_sym_COMMA] = ACTIONS(3386),
    [anon_sym_RPAREN] = ACTIONS(3386),
    [aux_sym_preproc_if_token2] = ACTIONS(3386),
    [aux_sym_preproc_else_token1] = ACTIONS(3386),
    [aux_sym_preproc_elif_token1] = ACTIONS(3388),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3386),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3386),
    [anon_sym_LPAREN2] = ACTIONS(3386),
    [anon_sym_DASH] = ACTIONS(3388),
    [anon_sym_PLUS] = ACTIONS(3388),
    [anon_sym_STAR] = ACTIONS(3388),
    [anon_sym_SLASH] = ACTIONS(3388),
    [anon_sym_PERCENT] = ACTIONS(3388),
    [anon_sym_PIPE_PIPE] = ACTIONS(3386),
    [anon_sym_AMP_AMP] = ACTIONS(3386),
    [anon_sym_PIPE] = ACTIONS(3388),
    [anon_sym_CARET] = ACTIONS(3388),
    [anon_sym_AMP] = ACTIONS(3388),
    [anon_sym_EQ_EQ] = ACTIONS(3386),
    [anon_sym_BANG_EQ] = ACTIONS(3386),
    [anon_sym_GT] = ACTIONS(3388),
    [anon_sym_GT_EQ] = ACTIONS(3386),
    [anon_sym_LT_EQ] = ACTIONS(3388),
    [anon_sym_LT] = ACTIONS(3388),
    [anon_sym_LT_LT] = ACTIONS(3388),
    [anon_sym_GT_GT] = ACTIONS(3388),
    [anon_sym_COLON] = ACTIONS(3386),
    [anon_sym_SEMI] = ACTIONS(3386),
    [anon_sym___attribute__] = ACTIONS(3388),
    [anon_sym_LBRACE] = ACTIONS(3386),
    [anon_sym_RBRACE] = ACTIONS(3386),
    [anon_sym_LBRACK] = ACTIONS(3386),
    [anon_sym_RBRACK] = ACTIONS(3386),
    [anon_sym_EQ] = ACTIONS(3388),
    [anon_sym_QMARK] = ACTIONS(3386),
    [anon_sym_STAR_EQ] = ACTIONS(3386),
    [anon_sym_SLASH_EQ] = ACTIONS(3386),
    [anon_sym_PERCENT_EQ] = ACTIONS(3386),
    [anon_sym_PLUS_EQ] = ACTIONS(3386),
    [anon_sym_DASH_EQ] = ACTIONS(3386),
    [anon_sym_LT_LT_EQ] = ACTIONS(3386),
    [anon_sym_GT_GT_EQ] = ACTIONS(3386),
    [anon_sym_AMP_EQ] = ACTIONS(3386),
    [anon_sym_CARET_EQ] = ACTIONS(3386),
    [anon_sym_PIPE_EQ] = ACTIONS(3386),
    [anon_sym_and_eq] = ACTIONS(3388),
    [anon_sym_or_eq] = ACTIONS(3388),
    [anon_sym_xor_eq] = ACTIONS(3388),
    [anon_sym_LT_EQ_GT] = ACTIONS(3386),
    [anon_sym_or] = ACTIONS(3388),
    [anon_sym_and] = ACTIONS(3388),
    [anon_sym_bitor] = ACTIONS(3388),
    [anon_sym_xor] = ACTIONS(3388),
    [anon_sym_bitand] = ACTIONS(3388),
    [anon_sym_not_eq] = ACTIONS(3388),
    [anon_sym_is] = ACTIONS(3388),
    [anon_sym_as] = ACTIONS(3388),
    [anon_sym_DASH_DASH] = ACTIONS(3386),
    [anon_sym_PLUS_PLUS] = ACTIONS(3386),
    [anon_sym_DOT] = ACTIONS(3388),
    [anon_sym_DOT_STAR] = ACTIONS(3386),
    [anon_sym_DASH_GT] = ACTIONS(3386),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3388),
    [anon_sym_let] = ACTIONS(3388),
    [anon_sym_This] = ACTIONS(3388),
  },
  [3056] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3088),
    [sym_identifier] = ACTIONS(3803),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3805),
    [anon_sym_COMMA] = ACTIONS(3805),
    [aux_sym_preproc_if_token2] = ACTIONS(3805),
    [aux_sym_preproc_else_token1] = ACTIONS(3805),
    [aux_sym_preproc_elif_token1] = ACTIONS(3803),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3805),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3805),
    [anon_sym_LPAREN2] = ACTIONS(3805),
    [anon_sym_DASH] = ACTIONS(3803),
    [anon_sym_PLUS] = ACTIONS(3803),
    [anon_sym_STAR] = ACTIONS(3803),
    [anon_sym_SLASH] = ACTIONS(3803),
    [anon_sym_PERCENT] = ACTIONS(3803),
    [anon_sym_PIPE_PIPE] = ACTIONS(3805),
    [anon_sym_AMP_AMP] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3803),
    [anon_sym_CARET] = ACTIONS(3803),
    [anon_sym_AMP] = ACTIONS(3803),
    [anon_sym_EQ_EQ] = ACTIONS(3805),
    [anon_sym_BANG_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3803),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_LT_EQ] = ACTIONS(3803),
    [anon_sym_LT] = ACTIONS(3803),
    [anon_sym_LT_LT] = ACTIONS(3803),
    [anon_sym_GT_GT] = ACTIONS(3803),
    [anon_sym___attribute__] = ACTIONS(3803),
    [anon_sym_LBRACE] = ACTIONS(3805),
    [anon_sym_signed] = ACTIONS(6716),
    [anon_sym_unsigned] = ACTIONS(6716),
    [anon_sym_long] = ACTIONS(6716),
    [anon_sym_short] = ACTIONS(6716),
    [anon_sym_LBRACK] = ACTIONS(3805),
    [anon_sym_EQ] = ACTIONS(3803),
    [anon_sym_QMARK] = ACTIONS(3805),
    [anon_sym_STAR_EQ] = ACTIONS(3805),
    [anon_sym_SLASH_EQ] = ACTIONS(3805),
    [anon_sym_PERCENT_EQ] = ACTIONS(3805),
    [anon_sym_PLUS_EQ] = ACTIONS(3805),
    [anon_sym_DASH_EQ] = ACTIONS(3805),
    [anon_sym_LT_LT_EQ] = ACTIONS(3805),
    [anon_sym_GT_GT_EQ] = ACTIONS(3805),
    [anon_sym_AMP_EQ] = ACTIONS(3805),
    [anon_sym_CARET_EQ] = ACTIONS(3805),
    [anon_sym_PIPE_EQ] = ACTIONS(3805),
    [anon_sym_and_eq] = ACTIONS(3803),
    [anon_sym_or_eq] = ACTIONS(3803),
    [anon_sym_xor_eq] = ACTIONS(3803),
    [anon_sym_LT_EQ_GT] = ACTIONS(3805),
    [anon_sym_or] = ACTIONS(3803),
    [anon_sym_and] = ACTIONS(3803),
    [anon_sym_bitor] = ACTIONS(3803),
    [anon_sym_xor] = ACTIONS(3803),
    [anon_sym_bitand] = ACTIONS(3803),
    [anon_sym_not_eq] = ACTIONS(3803),
    [anon_sym_is] = ACTIONS(3803),
    [anon_sym_as] = ACTIONS(3803),
    [anon_sym_DASH_DASH] = ACTIONS(3805),
    [anon_sym_PLUS_PLUS] = ACTIONS(3805),
    [anon_sym_DOT] = ACTIONS(3803),
    [anon_sym_DOT_STAR] = ACTIONS(3805),
    [anon_sym_DASH_GT] = ACTIONS(3805),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3803),
    [anon_sym_let] = ACTIONS(3803),
    [anon_sym_This] = ACTIONS(3803),
  },
  [3057] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3088),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3752),
    [anon_sym_COMMA] = ACTIONS(3752),
    [aux_sym_preproc_if_token2] = ACTIONS(3752),
    [aux_sym_preproc_else_token1] = ACTIONS(3752),
    [aux_sym_preproc_elif_token1] = ACTIONS(3750),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3752),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3752),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_DASH] = ACTIONS(3750),
    [anon_sym_PLUS] = ACTIONS(3750),
    [anon_sym_STAR] = ACTIONS(3750),
    [anon_sym_SLASH] = ACTIONS(3750),
    [anon_sym_PERCENT] = ACTIONS(3750),
    [anon_sym_PIPE_PIPE] = ACTIONS(3752),
    [anon_sym_AMP_AMP] = ACTIONS(3752),
    [anon_sym_PIPE] = ACTIONS(3750),
    [anon_sym_CARET] = ACTIONS(3750),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_EQ_EQ] = ACTIONS(3752),
    [anon_sym_BANG_EQ] = ACTIONS(3752),
    [anon_sym_GT] = ACTIONS(3750),
    [anon_sym_GT_EQ] = ACTIONS(3752),
    [anon_sym_LT_EQ] = ACTIONS(3750),
    [anon_sym_LT] = ACTIONS(3750),
    [anon_sym_LT_LT] = ACTIONS(3750),
    [anon_sym_GT_GT] = ACTIONS(3750),
    [anon_sym___attribute__] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(3752),
    [anon_sym_signed] = ACTIONS(6716),
    [anon_sym_unsigned] = ACTIONS(6716),
    [anon_sym_long] = ACTIONS(6716),
    [anon_sym_short] = ACTIONS(6716),
    [anon_sym_LBRACK] = ACTIONS(3752),
    [anon_sym_EQ] = ACTIONS(3750),
    [anon_sym_QMARK] = ACTIONS(3752),
    [anon_sym_STAR_EQ] = ACTIONS(3752),
    [anon_sym_SLASH_EQ] = ACTIONS(3752),
    [anon_sym_PERCENT_EQ] = ACTIONS(3752),
    [anon_sym_PLUS_EQ] = ACTIONS(3752),
    [anon_sym_DASH_EQ] = ACTIONS(3752),
    [anon_sym_LT_LT_EQ] = ACTIONS(3752),
    [anon_sym_GT_GT_EQ] = ACTIONS(3752),
    [anon_sym_AMP_EQ] = ACTIONS(3752),
    [anon_sym_CARET_EQ] = ACTIONS(3752),
    [anon_sym_PIPE_EQ] = ACTIONS(3752),
    [anon_sym_and_eq] = ACTIONS(3750),
    [anon_sym_or_eq] = ACTIONS(3750),
    [anon_sym_xor_eq] = ACTIONS(3750),
    [anon_sym_LT_EQ_GT] = ACTIONS(3752),
    [anon_sym_or] = ACTIONS(3750),
    [anon_sym_and] = ACTIONS(3750),
    [anon_sym_bitor] = ACTIONS(3750),
    [anon_sym_xor] = ACTIONS(3750),
    [anon_sym_bitand] = ACTIONS(3750),
    [anon_sym_not_eq] = ACTIONS(3750),
    [anon_sym_is] = ACTIONS(3750),
    [anon_sym_as] = ACTIONS(3750),
    [anon_sym_DASH_DASH] = ACTIONS(3752),
    [anon_sym_PLUS_PLUS] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3750),
    [anon_sym_DOT_STAR] = ACTIONS(3752),
    [anon_sym_DASH_GT] = ACTIONS(3752),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3750),
    [anon_sym_let] = ACTIONS(3750),
    [anon_sym_This] = ACTIONS(3750),
  },
  [3058] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3057),
    [sym_identifier] = ACTIONS(3392),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3390),
    [anon_sym_COMMA] = ACTIONS(3390),
    [aux_sym_preproc_if_token2] = ACTIONS(3390),
    [aux_sym_preproc_else_token1] = ACTIONS(3390),
    [aux_sym_preproc_elif_token1] = ACTIONS(3392),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3390),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3390),
    [anon_sym_LPAREN2] = ACTIONS(3390),
    [anon_sym_DASH] = ACTIONS(3392),
    [anon_sym_PLUS] = ACTIONS(3392),
    [anon_sym_STAR] = ACTIONS(3392),
    [anon_sym_SLASH] = ACTIONS(3392),
    [anon_sym_PERCENT] = ACTIONS(3392),
    [anon_sym_PIPE_PIPE] = ACTIONS(3390),
    [anon_sym_AMP_AMP] = ACTIONS(3390),
    [anon_sym_PIPE] = ACTIONS(3392),
    [anon_sym_CARET] = ACTIONS(3392),
    [anon_sym_AMP] = ACTIONS(3392),
    [anon_sym_EQ_EQ] = ACTIONS(3390),
    [anon_sym_BANG_EQ] = ACTIONS(3390),
    [anon_sym_GT] = ACTIONS(3392),
    [anon_sym_GT_EQ] = ACTIONS(3390),
    [anon_sym_LT_EQ] = ACTIONS(3392),
    [anon_sym_LT] = ACTIONS(3392),
    [anon_sym_LT_LT] = ACTIONS(3392),
    [anon_sym_GT_GT] = ACTIONS(3392),
    [anon_sym___attribute__] = ACTIONS(3392),
    [anon_sym_LBRACE] = ACTIONS(3390),
    [anon_sym_signed] = ACTIONS(6746),
    [anon_sym_unsigned] = ACTIONS(6746),
    [anon_sym_long] = ACTIONS(6746),
    [anon_sym_short] = ACTIONS(6746),
    [anon_sym_LBRACK] = ACTIONS(3390),
    [anon_sym_EQ] = ACTIONS(3392),
    [anon_sym_QMARK] = ACTIONS(3390),
    [anon_sym_STAR_EQ] = ACTIONS(3390),
    [anon_sym_SLASH_EQ] = ACTIONS(3390),
    [anon_sym_PERCENT_EQ] = ACTIONS(3390),
    [anon_sym_PLUS_EQ] = ACTIONS(3390),
    [anon_sym_DASH_EQ] = ACTIONS(3390),
    [anon_sym_LT_LT_EQ] = ACTIONS(3390),
    [anon_sym_GT_GT_EQ] = ACTIONS(3390),
    [anon_sym_AMP_EQ] = ACTIONS(3390),
    [anon_sym_CARET_EQ] = ACTIONS(3390),
    [anon_sym_PIPE_EQ] = ACTIONS(3390),
    [anon_sym_and_eq] = ACTIONS(3392),
    [anon_sym_or_eq] = ACTIONS(3392),
    [anon_sym_xor_eq] = ACTIONS(3392),
    [anon_sym_LT_EQ_GT] = ACTIONS(3390),
    [anon_sym_or] = ACTIONS(3392),
    [anon_sym_and] = ACTIONS(3392),
    [anon_sym_bitor] = ACTIONS(3392),
    [anon_sym_xor] = ACTIONS(3392),
    [anon_sym_bitand] = ACTIONS(3392),
    [anon_sym_not_eq] = ACTIONS(3392),
    [anon_sym_is] = ACTIONS(3392),
    [anon_sym_as] = ACTIONS(3392),
    [anon_sym_DASH_DASH] = ACTIONS(3390),
    [anon_sym_PLUS_PLUS] = ACTIONS(3390),
    [anon_sym_DOT] = ACTIONS(3392),
    [anon_sym_DOT_STAR] = ACTIONS(3390),
    [anon_sym_DASH_GT] = ACTIONS(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3392),
    [anon_sym_let] = ACTIONS(3392),
    [anon_sym_This] = ACTIONS(3392),
  },
  [3059] = {
    [sym_identifier] = ACTIONS(3844),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3846),
    [anon_sym_COMMA] = ACTIONS(3846),
    [anon_sym_RPAREN] = ACTIONS(3846),
    [aux_sym_preproc_if_token2] = ACTIONS(3846),
    [aux_sym_preproc_else_token1] = ACTIONS(3846),
    [aux_sym_preproc_elif_token1] = ACTIONS(3844),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3846),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3846),
    [anon_sym_LPAREN2] = ACTIONS(3846),
    [anon_sym_DASH] = ACTIONS(3844),
    [anon_sym_PLUS] = ACTIONS(3844),
    [anon_sym_STAR] = ACTIONS(3844),
    [anon_sym_SLASH] = ACTIONS(3844),
    [anon_sym_PERCENT] = ACTIONS(3844),
    [anon_sym_PIPE_PIPE] = ACTIONS(3846),
    [anon_sym_AMP_AMP] = ACTIONS(3846),
    [anon_sym_PIPE] = ACTIONS(3844),
    [anon_sym_CARET] = ACTIONS(3844),
    [anon_sym_AMP] = ACTIONS(3844),
    [anon_sym_EQ_EQ] = ACTIONS(3846),
    [anon_sym_BANG_EQ] = ACTIONS(3846),
    [anon_sym_GT] = ACTIONS(3844),
    [anon_sym_GT_EQ] = ACTIONS(3846),
    [anon_sym_LT_EQ] = ACTIONS(3844),
    [anon_sym_LT] = ACTIONS(3844),
    [anon_sym_LT_LT] = ACTIONS(3844),
    [anon_sym_GT_GT] = ACTIONS(3844),
    [anon_sym_COLON] = ACTIONS(3846),
    [anon_sym_SEMI] = ACTIONS(3846),
    [anon_sym___attribute__] = ACTIONS(3844),
    [anon_sym_LBRACE] = ACTIONS(3846),
    [anon_sym_RBRACE] = ACTIONS(3846),
    [anon_sym_LBRACK] = ACTIONS(3846),
    [anon_sym_RBRACK] = ACTIONS(3846),
    [anon_sym_EQ] = ACTIONS(3844),
    [anon_sym_QMARK] = ACTIONS(3846),
    [anon_sym_STAR_EQ] = ACTIONS(3846),
    [anon_sym_SLASH_EQ] = ACTIONS(3846),
    [anon_sym_PERCENT_EQ] = ACTIONS(3846),
    [anon_sym_PLUS_EQ] = ACTIONS(3846),
    [anon_sym_DASH_EQ] = ACTIONS(3846),
    [anon_sym_LT_LT_EQ] = ACTIONS(3846),
    [anon_sym_GT_GT_EQ] = ACTIONS(3846),
    [anon_sym_AMP_EQ] = ACTIONS(3846),
    [anon_sym_CARET_EQ] = ACTIONS(3846),
    [anon_sym_PIPE_EQ] = ACTIONS(3846),
    [anon_sym_and_eq] = ACTIONS(3844),
    [anon_sym_or_eq] = ACTIONS(3844),
    [anon_sym_xor_eq] = ACTIONS(3844),
    [anon_sym_LT_EQ_GT] = ACTIONS(3846),
    [anon_sym_or] = ACTIONS(3844),
    [anon_sym_and] = ACTIONS(3844),
    [anon_sym_bitor] = ACTIONS(3844),
    [anon_sym_xor] = ACTIONS(3844),
    [anon_sym_bitand] = ACTIONS(3844),
    [anon_sym_not_eq] = ACTIONS(3844),
    [anon_sym_is] = ACTIONS(3844),
    [anon_sym_as] = ACTIONS(3844),
    [anon_sym_DASH_DASH] = ACTIONS(3846),
    [anon_sym_PLUS_PLUS] = ACTIONS(3846),
    [anon_sym_DOT] = ACTIONS(3844),
    [anon_sym_DOT_STAR] = ACTIONS(3846),
    [anon_sym_DASH_GT] = ACTIONS(3846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3844),
    [anon_sym_let] = ACTIONS(3844),
    [anon_sym_This] = ACTIONS(3844),
  },
  [3060] = {
    [sym_identifier] = ACTIONS(2742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2740),
    [anon_sym_COMMA] = ACTIONS(2740),
    [anon_sym_RPAREN] = ACTIONS(2740),
    [aux_sym_preproc_if_token2] = ACTIONS(2740),
    [aux_sym_preproc_else_token1] = ACTIONS(2740),
    [aux_sym_preproc_elif_token1] = ACTIONS(2742),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2740),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2740),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2742),
    [anon_sym_PLUS] = ACTIONS(2742),
    [anon_sym_STAR] = ACTIONS(2742),
    [anon_sym_SLASH] = ACTIONS(2742),
    [anon_sym_PERCENT] = ACTIONS(2742),
    [anon_sym_PIPE_PIPE] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_PIPE] = ACTIONS(2742),
    [anon_sym_CARET] = ACTIONS(2742),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_EQ_EQ] = ACTIONS(2740),
    [anon_sym_BANG_EQ] = ACTIONS(2740),
    [anon_sym_GT] = ACTIONS(2742),
    [anon_sym_GT_EQ] = ACTIONS(2740),
    [anon_sym_LT_EQ] = ACTIONS(2742),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_LT_LT] = ACTIONS(2742),
    [anon_sym_GT_GT] = ACTIONS(2742),
    [anon_sym_COLON] = ACTIONS(2740),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym_LBRACE] = ACTIONS(2740),
    [anon_sym_RBRACE] = ACTIONS(2740),
    [anon_sym_LBRACK] = ACTIONS(2740),
    [anon_sym_RBRACK] = ACTIONS(2740),
    [anon_sym_EQ] = ACTIONS(2742),
    [anon_sym_QMARK] = ACTIONS(2740),
    [anon_sym_STAR_EQ] = ACTIONS(2740),
    [anon_sym_SLASH_EQ] = ACTIONS(2740),
    [anon_sym_PERCENT_EQ] = ACTIONS(2740),
    [anon_sym_PLUS_EQ] = ACTIONS(2740),
    [anon_sym_DASH_EQ] = ACTIONS(2740),
    [anon_sym_LT_LT_EQ] = ACTIONS(2740),
    [anon_sym_GT_GT_EQ] = ACTIONS(2740),
    [anon_sym_AMP_EQ] = ACTIONS(2740),
    [anon_sym_CARET_EQ] = ACTIONS(2740),
    [anon_sym_PIPE_EQ] = ACTIONS(2740),
    [anon_sym_and_eq] = ACTIONS(2742),
    [anon_sym_or_eq] = ACTIONS(2742),
    [anon_sym_xor_eq] = ACTIONS(2742),
    [anon_sym_LT_EQ_GT] = ACTIONS(2740),
    [anon_sym_or] = ACTIONS(2742),
    [anon_sym_and] = ACTIONS(2742),
    [anon_sym_bitor] = ACTIONS(2742),
    [anon_sym_xor] = ACTIONS(2742),
    [anon_sym_bitand] = ACTIONS(2742),
    [anon_sym_not_eq] = ACTIONS(2742),
    [anon_sym_is] = ACTIONS(2742),
    [anon_sym_as] = ACTIONS(2742),
    [anon_sym_DASH_DASH] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2740),
    [anon_sym_DOT] = ACTIONS(2742),
    [anon_sym_DOT_STAR] = ACTIONS(2740),
    [anon_sym_DASH_GT] = ACTIONS(2740),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
  },
  [3061] = {
    [sym_identifier] = ACTIONS(2910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2908),
    [anon_sym_COMMA] = ACTIONS(2908),
    [anon_sym_RPAREN] = ACTIONS(2908),
    [aux_sym_preproc_if_token2] = ACTIONS(2908),
    [aux_sym_preproc_else_token1] = ACTIONS(2908),
    [aux_sym_preproc_elif_token1] = ACTIONS(2910),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2908),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2908),
    [anon_sym_LPAREN2] = ACTIONS(2908),
    [anon_sym_DASH] = ACTIONS(2910),
    [anon_sym_PLUS] = ACTIONS(2910),
    [anon_sym_STAR] = ACTIONS(2910),
    [anon_sym_SLASH] = ACTIONS(2910),
    [anon_sym_PERCENT] = ACTIONS(2910),
    [anon_sym_PIPE_PIPE] = ACTIONS(2908),
    [anon_sym_AMP_AMP] = ACTIONS(2908),
    [anon_sym_PIPE] = ACTIONS(2910),
    [anon_sym_CARET] = ACTIONS(2910),
    [anon_sym_AMP] = ACTIONS(2910),
    [anon_sym_EQ_EQ] = ACTIONS(2908),
    [anon_sym_BANG_EQ] = ACTIONS(2908),
    [anon_sym_GT] = ACTIONS(2910),
    [anon_sym_GT_EQ] = ACTIONS(2908),
    [anon_sym_LT_EQ] = ACTIONS(2910),
    [anon_sym_LT] = ACTIONS(2910),
    [anon_sym_LT_LT] = ACTIONS(2910),
    [anon_sym_GT_GT] = ACTIONS(2910),
    [anon_sym_COLON] = ACTIONS(2908),
    [anon_sym_SEMI] = ACTIONS(2908),
    [anon_sym___attribute__] = ACTIONS(2910),
    [anon_sym_LBRACE] = ACTIONS(2908),
    [anon_sym_RBRACE] = ACTIONS(2908),
    [anon_sym_LBRACK] = ACTIONS(2908),
    [anon_sym_RBRACK] = ACTIONS(2908),
    [anon_sym_EQ] = ACTIONS(2910),
    [anon_sym_QMARK] = ACTIONS(2908),
    [anon_sym_STAR_EQ] = ACTIONS(2908),
    [anon_sym_SLASH_EQ] = ACTIONS(2908),
    [anon_sym_PERCENT_EQ] = ACTIONS(2908),
    [anon_sym_PLUS_EQ] = ACTIONS(2908),
    [anon_sym_DASH_EQ] = ACTIONS(2908),
    [anon_sym_LT_LT_EQ] = ACTIONS(2908),
    [anon_sym_GT_GT_EQ] = ACTIONS(2908),
    [anon_sym_AMP_EQ] = ACTIONS(2908),
    [anon_sym_CARET_EQ] = ACTIONS(2908),
    [anon_sym_PIPE_EQ] = ACTIONS(2908),
    [anon_sym_and_eq] = ACTIONS(2910),
    [anon_sym_or_eq] = ACTIONS(2910),
    [anon_sym_xor_eq] = ACTIONS(2910),
    [anon_sym_LT_EQ_GT] = ACTIONS(2908),
    [anon_sym_or] = ACTIONS(2910),
    [anon_sym_and] = ACTIONS(2910),
    [anon_sym_bitor] = ACTIONS(2910),
    [anon_sym_xor] = ACTIONS(2910),
    [anon_sym_bitand] = ACTIONS(2910),
    [anon_sym_not_eq] = ACTIONS(2910),
    [anon_sym_is] = ACTIONS(2910),
    [anon_sym_as] = ACTIONS(2910),
    [anon_sym_DASH_DASH] = ACTIONS(2908),
    [anon_sym_PLUS_PLUS] = ACTIONS(2908),
    [anon_sym_DOT] = ACTIONS(2910),
    [anon_sym_DOT_STAR] = ACTIONS(2908),
    [anon_sym_DASH_GT] = ACTIONS(2908),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2910),
    [anon_sym_let] = ACTIONS(2910),
    [anon_sym_This] = ACTIONS(2910),
  },
  [3062] = {
    [sym_string_literal] = STATE(3037),
    [sym_raw_string_literal] = STATE(3037),
    [aux_sym_concatenated_string_repeat1] = STATE(3037),
    [sym_identifier] = ACTIONS(6748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6456),
    [anon_sym_COMMA] = ACTIONS(6456),
    [anon_sym_LPAREN2] = ACTIONS(6456),
    [anon_sym_DASH] = ACTIONS(6458),
    [anon_sym_PLUS] = ACTIONS(6458),
    [anon_sym_STAR] = ACTIONS(6458),
    [anon_sym_SLASH] = ACTIONS(6458),
    [anon_sym_PERCENT] = ACTIONS(6458),
    [anon_sym_PIPE_PIPE] = ACTIONS(6456),
    [anon_sym_AMP_AMP] = ACTIONS(6456),
    [anon_sym_PIPE] = ACTIONS(6458),
    [anon_sym_CARET] = ACTIONS(6458),
    [anon_sym_AMP] = ACTIONS(6458),
    [anon_sym_EQ_EQ] = ACTIONS(6456),
    [anon_sym_BANG_EQ] = ACTIONS(6456),
    [anon_sym_GT] = ACTIONS(6458),
    [anon_sym_GT_EQ] = ACTIONS(6458),
    [anon_sym_LT_EQ] = ACTIONS(6458),
    [anon_sym_LT] = ACTIONS(6458),
    [anon_sym_LT_LT] = ACTIONS(6458),
    [anon_sym_GT_GT] = ACTIONS(6458),
    [anon_sym_LBRACK] = ACTIONS(6456),
    [anon_sym_EQ] = ACTIONS(6458),
    [anon_sym_QMARK] = ACTIONS(6456),
    [anon_sym_STAR_EQ] = ACTIONS(6456),
    [anon_sym_SLASH_EQ] = ACTIONS(6456),
    [anon_sym_PERCENT_EQ] = ACTIONS(6456),
    [anon_sym_PLUS_EQ] = ACTIONS(6456),
    [anon_sym_DASH_EQ] = ACTIONS(6456),
    [anon_sym_LT_LT_EQ] = ACTIONS(6456),
    [anon_sym_GT_GT_EQ] = ACTIONS(6458),
    [anon_sym_AMP_EQ] = ACTIONS(6456),
    [anon_sym_CARET_EQ] = ACTIONS(6456),
    [anon_sym_PIPE_EQ] = ACTIONS(6456),
    [anon_sym_and_eq] = ACTIONS(6458),
    [anon_sym_or_eq] = ACTIONS(6458),
    [anon_sym_xor_eq] = ACTIONS(6458),
    [anon_sym_LT_EQ_GT] = ACTIONS(6456),
    [anon_sym_or] = ACTIONS(6458),
    [anon_sym_and] = ACTIONS(6458),
    [anon_sym_bitor] = ACTIONS(6458),
    [anon_sym_xor] = ACTIONS(6458),
    [anon_sym_bitand] = ACTIONS(6458),
    [anon_sym_not_eq] = ACTIONS(6458),
    [anon_sym_is] = ACTIONS(6458),
    [anon_sym_as] = ACTIONS(6458),
    [anon_sym_DASH_DASH] = ACTIONS(6456),
    [anon_sym_PLUS_PLUS] = ACTIONS(6456),
    [anon_sym_DOT] = ACTIONS(6458),
    [anon_sym_DOT_STAR] = ACTIONS(6456),
    [anon_sym_DASH_GT] = ACTIONS(6456),
    [anon_sym_L_DQUOTE] = ACTIONS(6742),
    [anon_sym_u_DQUOTE] = ACTIONS(6742),
    [anon_sym_U_DQUOTE] = ACTIONS(6742),
    [anon_sym_u8_DQUOTE] = ACTIONS(6742),
    [anon_sym_DQUOTE] = ACTIONS(6742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(6456),
    [anon_sym_R_DQUOTE] = ACTIONS(6744),
    [anon_sym_LR_DQUOTE] = ACTIONS(6744),
    [anon_sym_uR_DQUOTE] = ACTIONS(6744),
    [anon_sym_UR_DQUOTE] = ACTIONS(6744),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6744),
    [sym_literal_suffix] = ACTIONS(6458),
  },
  [3063] = {
    [sym_identifier] = ACTIONS(2944),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2942),
    [anon_sym_COMMA] = ACTIONS(2942),
    [anon_sym_RPAREN] = ACTIONS(2942),
    [aux_sym_preproc_if_token2] = ACTIONS(2942),
    [aux_sym_preproc_else_token1] = ACTIONS(2942),
    [aux_sym_preproc_elif_token1] = ACTIONS(2944),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2942),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2942),
    [anon_sym_LPAREN2] = ACTIONS(2942),
    [anon_sym_DASH] = ACTIONS(2944),
    [anon_sym_PLUS] = ACTIONS(2944),
    [anon_sym_STAR] = ACTIONS(2944),
    [anon_sym_SLASH] = ACTIONS(2944),
    [anon_sym_PERCENT] = ACTIONS(2944),
    [anon_sym_PIPE_PIPE] = ACTIONS(2942),
    [anon_sym_AMP_AMP] = ACTIONS(2942),
    [anon_sym_PIPE] = ACTIONS(2944),
    [anon_sym_CARET] = ACTIONS(2944),
    [anon_sym_AMP] = ACTIONS(2944),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_GT_EQ] = ACTIONS(2942),
    [anon_sym_LT_EQ] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_LT_LT] = ACTIONS(2944),
    [anon_sym_GT_GT] = ACTIONS(2944),
    [anon_sym_COLON] = ACTIONS(2942),
    [anon_sym_SEMI] = ACTIONS(2942),
    [anon_sym___attribute__] = ACTIONS(2944),
    [anon_sym_LBRACE] = ACTIONS(2942),
    [anon_sym_RBRACE] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(2942),
    [anon_sym_RBRACK] = ACTIONS(2942),
    [anon_sym_EQ] = ACTIONS(2944),
    [anon_sym_QMARK] = ACTIONS(2942),
    [anon_sym_STAR_EQ] = ACTIONS(2942),
    [anon_sym_SLASH_EQ] = ACTIONS(2942),
    [anon_sym_PERCENT_EQ] = ACTIONS(2942),
    [anon_sym_PLUS_EQ] = ACTIONS(2942),
    [anon_sym_DASH_EQ] = ACTIONS(2942),
    [anon_sym_LT_LT_EQ] = ACTIONS(2942),
    [anon_sym_GT_GT_EQ] = ACTIONS(2942),
    [anon_sym_AMP_EQ] = ACTIONS(2942),
    [anon_sym_CARET_EQ] = ACTIONS(2942),
    [anon_sym_PIPE_EQ] = ACTIONS(2942),
    [anon_sym_and_eq] = ACTIONS(2944),
    [anon_sym_or_eq] = ACTIONS(2944),
    [anon_sym_xor_eq] = ACTIONS(2944),
    [anon_sym_LT_EQ_GT] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2944),
    [anon_sym_and] = ACTIONS(2944),
    [anon_sym_bitor] = ACTIONS(2944),
    [anon_sym_xor] = ACTIONS(2944),
    [anon_sym_bitand] = ACTIONS(2944),
    [anon_sym_not_eq] = ACTIONS(2944),
    [anon_sym_is] = ACTIONS(2944),
    [anon_sym_as] = ACTIONS(2944),
    [anon_sym_DASH_DASH] = ACTIONS(2942),
    [anon_sym_PLUS_PLUS] = ACTIONS(2942),
    [anon_sym_DOT] = ACTIONS(2944),
    [anon_sym_DOT_STAR] = ACTIONS(2942),
    [anon_sym_DASH_GT] = ACTIONS(2942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2944),
    [anon_sym_let] = ACTIONS(2944),
    [anon_sym_This] = ACTIONS(2944),
  },
  [3064] = {
    [sym_attribute_specifier] = STATE(2933),
    [sym_enumerator_list] = STATE(3123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3717),
    [anon_sym_COMMA] = ACTIONS(3717),
    [anon_sym_RPAREN] = ACTIONS(3717),
    [anon_sym_LPAREN2] = ACTIONS(3717),
    [anon_sym_DASH] = ACTIONS(3715),
    [anon_sym_PLUS] = ACTIONS(3715),
    [anon_sym_STAR] = ACTIONS(3717),
    [anon_sym_SLASH] = ACTIONS(3715),
    [anon_sym_PERCENT] = ACTIONS(3717),
    [anon_sym_PIPE_PIPE] = ACTIONS(3717),
    [anon_sym_AMP_AMP] = ACTIONS(3717),
    [anon_sym_PIPE] = ACTIONS(3715),
    [anon_sym_CARET] = ACTIONS(3717),
    [anon_sym_AMP] = ACTIONS(3715),
    [anon_sym_EQ_EQ] = ACTIONS(3717),
    [anon_sym_BANG_EQ] = ACTIONS(3717),
    [anon_sym_GT] = ACTIONS(3715),
    [anon_sym_GT_EQ] = ACTIONS(3717),
    [anon_sym_LT_EQ] = ACTIONS(3715),
    [anon_sym_LT] = ACTIONS(3715),
    [anon_sym_LT_LT] = ACTIONS(3717),
    [anon_sym_GT_GT] = ACTIONS(3717),
    [anon_sym_COLON] = ACTIONS(3717),
    [anon_sym_SEMI] = ACTIONS(3717),
    [anon_sym___extension__] = ACTIONS(3717),
    [anon_sym___attribute__] = ACTIONS(6621),
    [anon_sym_LBRACE] = ACTIONS(6750),
    [anon_sym_RBRACE] = ACTIONS(3717),
    [anon_sym_LBRACK] = ACTIONS(3717),
    [anon_sym_RBRACK] = ACTIONS(3717),
    [anon_sym_const] = ACTIONS(3715),
    [anon_sym_constexpr] = ACTIONS(3717),
    [anon_sym_volatile] = ACTIONS(3717),
    [anon_sym_restrict] = ACTIONS(3717),
    [anon_sym___restrict__] = ACTIONS(3717),
    [anon_sym__Atomic] = ACTIONS(3717),
    [anon_sym__Noreturn] = ACTIONS(3717),
    [anon_sym_noreturn] = ACTIONS(3717),
    [anon_sym_mutable] = ACTIONS(3717),
    [anon_sym_constinit] = ACTIONS(3717),
    [anon_sym_consteval] = ACTIONS(3717),
    [anon_sym_alignas] = ACTIONS(3717),
    [anon_sym__Alignas] = ACTIONS(3717),
    [anon_sym_QMARK] = ACTIONS(3717),
    [anon_sym_LT_EQ_GT] = ACTIONS(3717),
    [anon_sym_or] = ACTIONS(3717),
    [anon_sym_and] = ACTIONS(3717),
    [anon_sym_bitor] = ACTIONS(3717),
    [anon_sym_xor] = ACTIONS(3717),
    [anon_sym_bitand] = ACTIONS(3717),
    [anon_sym_not_eq] = ACTIONS(3717),
    [anon_sym_is] = ACTIONS(3717),
    [anon_sym_as] = ACTIONS(3717),
    [anon_sym_DASH_DASH] = ACTIONS(3717),
    [anon_sym_PLUS_PLUS] = ACTIONS(3717),
    [anon_sym_DOT] = ACTIONS(3715),
    [anon_sym_DOT_STAR] = ACTIONS(3717),
    [anon_sym_DASH_GT] = ACTIONS(3717),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3717),
    [anon_sym_let] = ACTIONS(3717),
    [anon_sym_This] = ACTIONS(3717),
    [anon_sym_final] = ACTIONS(3717),
    [anon_sym_override] = ACTIONS(3717),
    [anon_sym_requires] = ACTIONS(3717),
    [anon_sym_where] = ACTIONS(3717),
  },
  [3065] = {
    [sym_identifier] = ACTIONS(2964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2962),
    [anon_sym_COMMA] = ACTIONS(2962),
    [anon_sym_RPAREN] = ACTIONS(2962),
    [aux_sym_preproc_if_token2] = ACTIONS(2962),
    [aux_sym_preproc_else_token1] = ACTIONS(2962),
    [aux_sym_preproc_elif_token1] = ACTIONS(2964),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2962),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2962),
    [anon_sym_LPAREN2] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2964),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_STAR] = ACTIONS(2964),
    [anon_sym_SLASH] = ACTIONS(2964),
    [anon_sym_PERCENT] = ACTIONS(2964),
    [anon_sym_PIPE_PIPE] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_PIPE] = ACTIONS(2964),
    [anon_sym_CARET] = ACTIONS(2964),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_EQ_EQ] = ACTIONS(2962),
    [anon_sym_BANG_EQ] = ACTIONS(2962),
    [anon_sym_GT] = ACTIONS(2964),
    [anon_sym_GT_EQ] = ACTIONS(2962),
    [anon_sym_LT_EQ] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_LT_LT] = ACTIONS(2964),
    [anon_sym_GT_GT] = ACTIONS(2964),
    [anon_sym_COLON] = ACTIONS(2962),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym___attribute__] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_RBRACE] = ACTIONS(2962),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [anon_sym_RBRACK] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(2964),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_STAR_EQ] = ACTIONS(2962),
    [anon_sym_SLASH_EQ] = ACTIONS(2962),
    [anon_sym_PERCENT_EQ] = ACTIONS(2962),
    [anon_sym_PLUS_EQ] = ACTIONS(2962),
    [anon_sym_DASH_EQ] = ACTIONS(2962),
    [anon_sym_LT_LT_EQ] = ACTIONS(2962),
    [anon_sym_GT_GT_EQ] = ACTIONS(2962),
    [anon_sym_AMP_EQ] = ACTIONS(2962),
    [anon_sym_CARET_EQ] = ACTIONS(2962),
    [anon_sym_PIPE_EQ] = ACTIONS(2962),
    [anon_sym_and_eq] = ACTIONS(2964),
    [anon_sym_or_eq] = ACTIONS(2964),
    [anon_sym_xor_eq] = ACTIONS(2964),
    [anon_sym_LT_EQ_GT] = ACTIONS(2962),
    [anon_sym_or] = ACTIONS(2964),
    [anon_sym_and] = ACTIONS(2964),
    [anon_sym_bitor] = ACTIONS(2964),
    [anon_sym_xor] = ACTIONS(2964),
    [anon_sym_bitand] = ACTIONS(2964),
    [anon_sym_not_eq] = ACTIONS(2964),
    [anon_sym_is] = ACTIONS(2964),
    [anon_sym_as] = ACTIONS(2964),
    [anon_sym_DASH_DASH] = ACTIONS(2962),
    [anon_sym_PLUS_PLUS] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2964),
    [anon_sym_DOT_STAR] = ACTIONS(2962),
    [anon_sym_DASH_GT] = ACTIONS(2962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2964),
    [anon_sym_let] = ACTIONS(2964),
    [anon_sym_This] = ACTIONS(2964),
  },
  [3066] = {
    [sym_string_literal] = STATE(3342),
    [sym_template_argument_list] = STATE(4579),
    [sym_raw_string_literal] = STATE(3342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(6208),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON] = ACTIONS(2128),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2117),
    [anon_sym_EQ] = ACTIONS(6752),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(6754),
    [anon_sym_SLASH_EQ] = ACTIONS(6754),
    [anon_sym_PERCENT_EQ] = ACTIONS(6754),
    [anon_sym_PLUS_EQ] = ACTIONS(6754),
    [anon_sym_DASH_EQ] = ACTIONS(6754),
    [anon_sym_LT_LT_EQ] = ACTIONS(6754),
    [anon_sym_GT_GT_EQ] = ACTIONS(6754),
    [anon_sym_AMP_EQ] = ACTIONS(6754),
    [anon_sym_CARET_EQ] = ACTIONS(6754),
    [anon_sym_PIPE_EQ] = ACTIONS(6754),
    [anon_sym_and_eq] = ACTIONS(6754),
    [anon_sym_or_eq] = ACTIONS(6754),
    [anon_sym_xor_eq] = ACTIONS(6754),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2117),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2117),
    [anon_sym_not_eq] = ACTIONS(2117),
    [anon_sym_is] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
  },
  [3067] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2647),
    [sym_qualifiers] = STATE(2666),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [anon_sym_LPAREN2] = ACTIONS(6299),
    [anon_sym_STAR] = ACTIONS(6299),
    [anon_sym_AMP_AMP] = ACTIONS(6299),
    [anon_sym_AMP] = ACTIONS(6297),
    [anon_sym___extension__] = ACTIONS(6722),
    [anon_sym_in] = ACTIONS(6303),
    [anon_sym_out] = ACTIONS(6756),
    [anon_sym_inout] = ACTIONS(6756),
    [anon_sym_extern] = ACTIONS(6726),
    [anon_sym___attribute__] = ACTIONS(6728),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6152),
    [anon_sym___declspec] = ACTIONS(6730),
    [anon_sym_LBRACK] = ACTIONS(6297),
    [anon_sym_static] = ACTIONS(6726),
    [anon_sym_register] = ACTIONS(6726),
    [anon_sym_inline] = ACTIONS(6726),
    [anon_sym___inline] = ACTIONS(6146),
    [anon_sym___inline__] = ACTIONS(6726),
    [anon_sym___forceinline] = ACTIONS(6726),
    [anon_sym_thread_local] = ACTIONS(6726),
    [anon_sym___thread] = ACTIONS(6726),
    [anon_sym_const] = ACTIONS(6142),
    [anon_sym_constexpr] = ACTIONS(6722),
    [anon_sym_volatile] = ACTIONS(6722),
    [anon_sym_restrict] = ACTIONS(6722),
    [anon_sym___restrict__] = ACTIONS(6722),
    [anon_sym__Atomic] = ACTIONS(6722),
    [anon_sym__Noreturn] = ACTIONS(6722),
    [anon_sym_noreturn] = ACTIONS(6722),
    [anon_sym_mutable] = ACTIONS(6722),
    [anon_sym_constinit] = ACTIONS(6722),
    [anon_sym_consteval] = ACTIONS(6722),
    [anon_sym_alignas] = ACTIONS(6732),
    [anon_sym__Alignas] = ACTIONS(6732),
    [anon_sym_DOT] = ACTIONS(6734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6736),
    [anon_sym_let] = ACTIONS(6736),
    [anon_sym_This] = ACTIONS(6736),
    [sym_virtual] = ACTIONS(6756),
    [anon_sym_precise] = ACTIONS(6738),
    [anon_sym_shared] = ACTIONS(6738),
    [anon_sym_groupshared] = ACTIONS(6738),
    [anon_sym_uniform] = ACTIONS(6738),
    [anon_sym_row_major] = ACTIONS(6738),
    [anon_sym_column_major] = ACTIONS(6738),
    [anon_sym_globallycoherent] = ACTIONS(6738),
    [anon_sym_centroid] = ACTIONS(6738),
    [anon_sym_noperspective] = ACTIONS(6738),
    [anon_sym_nointerpolation] = ACTIONS(6738),
    [anon_sym_sample] = ACTIONS(6738),
    [anon_sym_linear] = ACTIONS(6738),
    [anon_sym_snorm] = ACTIONS(6738),
    [anon_sym_unorm] = ACTIONS(6738),
    [anon_sym_point] = ACTIONS(6738),
    [anon_sym_line] = ACTIONS(6158),
    [anon_sym_triangleadj] = ACTIONS(6738),
    [anon_sym_lineadj] = ACTIONS(6738),
    [anon_sym_triangle] = ACTIONS(6158),
  },
  [3068] = {
    [sym_identifier] = ACTIONS(3102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3100),
    [anon_sym_COMMA] = ACTIONS(3100),
    [anon_sym_RPAREN] = ACTIONS(3100),
    [aux_sym_preproc_if_token2] = ACTIONS(3100),
    [aux_sym_preproc_else_token1] = ACTIONS(3100),
    [aux_sym_preproc_elif_token1] = ACTIONS(3102),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3100),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3100),
    [anon_sym_LPAREN2] = ACTIONS(3100),
    [anon_sym_DASH] = ACTIONS(3102),
    [anon_sym_PLUS] = ACTIONS(3102),
    [anon_sym_STAR] = ACTIONS(3102),
    [anon_sym_SLASH] = ACTIONS(3102),
    [anon_sym_PERCENT] = ACTIONS(3102),
    [anon_sym_PIPE_PIPE] = ACTIONS(3100),
    [anon_sym_AMP_AMP] = ACTIONS(3100),
    [anon_sym_PIPE] = ACTIONS(3102),
    [anon_sym_CARET] = ACTIONS(3102),
    [anon_sym_AMP] = ACTIONS(3102),
    [anon_sym_EQ_EQ] = ACTIONS(3100),
    [anon_sym_BANG_EQ] = ACTIONS(3100),
    [anon_sym_GT] = ACTIONS(3102),
    [anon_sym_GT_EQ] = ACTIONS(3100),
    [anon_sym_LT_EQ] = ACTIONS(3102),
    [anon_sym_LT] = ACTIONS(3102),
    [anon_sym_LT_LT] = ACTIONS(3102),
    [anon_sym_GT_GT] = ACTIONS(3102),
    [anon_sym_COLON] = ACTIONS(3100),
    [anon_sym_SEMI] = ACTIONS(3100),
    [anon_sym___attribute__] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(3100),
    [anon_sym_RBRACE] = ACTIONS(3100),
    [anon_sym_LBRACK] = ACTIONS(3100),
    [anon_sym_RBRACK] = ACTIONS(3100),
    [anon_sym_EQ] = ACTIONS(3102),
    [anon_sym_QMARK] = ACTIONS(3100),
    [anon_sym_STAR_EQ] = ACTIONS(3100),
    [anon_sym_SLASH_EQ] = ACTIONS(3100),
    [anon_sym_PERCENT_EQ] = ACTIONS(3100),
    [anon_sym_PLUS_EQ] = ACTIONS(3100),
    [anon_sym_DASH_EQ] = ACTIONS(3100),
    [anon_sym_LT_LT_EQ] = ACTIONS(3100),
    [anon_sym_GT_GT_EQ] = ACTIONS(3100),
    [anon_sym_AMP_EQ] = ACTIONS(3100),
    [anon_sym_CARET_EQ] = ACTIONS(3100),
    [anon_sym_PIPE_EQ] = ACTIONS(3100),
    [anon_sym_and_eq] = ACTIONS(3102),
    [anon_sym_or_eq] = ACTIONS(3102),
    [anon_sym_xor_eq] = ACTIONS(3102),
    [anon_sym_LT_EQ_GT] = ACTIONS(3100),
    [anon_sym_or] = ACTIONS(3102),
    [anon_sym_and] = ACTIONS(3102),
    [anon_sym_bitor] = ACTIONS(3102),
    [anon_sym_xor] = ACTIONS(3102),
    [anon_sym_bitand] = ACTIONS(3102),
    [anon_sym_not_eq] = ACTIONS(3102),
    [anon_sym_is] = ACTIONS(3102),
    [anon_sym_as] = ACTIONS(3102),
    [anon_sym_DASH_DASH] = ACTIONS(3100),
    [anon_sym_PLUS_PLUS] = ACTIONS(3100),
    [anon_sym_DOT] = ACTIONS(3102),
    [anon_sym_DOT_STAR] = ACTIONS(3100),
    [anon_sym_DASH_GT] = ACTIONS(3100),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3102),
    [anon_sym_let] = ACTIONS(3102),
    [anon_sym_This] = ACTIONS(3102),
  },
  [3069] = {
    [sym_identifier] = ACTIONS(3176),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3174),
    [anon_sym_COMMA] = ACTIONS(3174),
    [anon_sym_RPAREN] = ACTIONS(3174),
    [aux_sym_preproc_if_token2] = ACTIONS(3174),
    [aux_sym_preproc_else_token1] = ACTIONS(3174),
    [aux_sym_preproc_elif_token1] = ACTIONS(3176),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3174),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3174),
    [anon_sym_LPAREN2] = ACTIONS(3174),
    [anon_sym_DASH] = ACTIONS(3176),
    [anon_sym_PLUS] = ACTIONS(3176),
    [anon_sym_STAR] = ACTIONS(3176),
    [anon_sym_SLASH] = ACTIONS(3176),
    [anon_sym_PERCENT] = ACTIONS(3176),
    [anon_sym_PIPE_PIPE] = ACTIONS(3174),
    [anon_sym_AMP_AMP] = ACTIONS(3174),
    [anon_sym_PIPE] = ACTIONS(3176),
    [anon_sym_CARET] = ACTIONS(3176),
    [anon_sym_AMP] = ACTIONS(3176),
    [anon_sym_EQ_EQ] = ACTIONS(3174),
    [anon_sym_BANG_EQ] = ACTIONS(3174),
    [anon_sym_GT] = ACTIONS(3176),
    [anon_sym_GT_EQ] = ACTIONS(3174),
    [anon_sym_LT_EQ] = ACTIONS(3176),
    [anon_sym_LT] = ACTIONS(3176),
    [anon_sym_LT_LT] = ACTIONS(3176),
    [anon_sym_GT_GT] = ACTIONS(3176),
    [anon_sym_COLON] = ACTIONS(3174),
    [anon_sym_SEMI] = ACTIONS(3174),
    [anon_sym___attribute__] = ACTIONS(3176),
    [anon_sym_LBRACE] = ACTIONS(3174),
    [anon_sym_RBRACE] = ACTIONS(3174),
    [anon_sym_LBRACK] = ACTIONS(3174),
    [anon_sym_RBRACK] = ACTIONS(3174),
    [anon_sym_EQ] = ACTIONS(3176),
    [anon_sym_QMARK] = ACTIONS(3174),
    [anon_sym_STAR_EQ] = ACTIONS(3174),
    [anon_sym_SLASH_EQ] = ACTIONS(3174),
    [anon_sym_PERCENT_EQ] = ACTIONS(3174),
    [anon_sym_PLUS_EQ] = ACTIONS(3174),
    [anon_sym_DASH_EQ] = ACTIONS(3174),
    [anon_sym_LT_LT_EQ] = ACTIONS(3174),
    [anon_sym_GT_GT_EQ] = ACTIONS(3174),
    [anon_sym_AMP_EQ] = ACTIONS(3174),
    [anon_sym_CARET_EQ] = ACTIONS(3174),
    [anon_sym_PIPE_EQ] = ACTIONS(3174),
    [anon_sym_and_eq] = ACTIONS(3176),
    [anon_sym_or_eq] = ACTIONS(3176),
    [anon_sym_xor_eq] = ACTIONS(3176),
    [anon_sym_LT_EQ_GT] = ACTIONS(3174),
    [anon_sym_or] = ACTIONS(3176),
    [anon_sym_and] = ACTIONS(3176),
    [anon_sym_bitor] = ACTIONS(3176),
    [anon_sym_xor] = ACTIONS(3176),
    [anon_sym_bitand] = ACTIONS(3176),
    [anon_sym_not_eq] = ACTIONS(3176),
    [anon_sym_is] = ACTIONS(3176),
    [anon_sym_as] = ACTIONS(3176),
    [anon_sym_DASH_DASH] = ACTIONS(3174),
    [anon_sym_PLUS_PLUS] = ACTIONS(3174),
    [anon_sym_DOT] = ACTIONS(3176),
    [anon_sym_DOT_STAR] = ACTIONS(3174),
    [anon_sym_DASH_GT] = ACTIONS(3174),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3176),
    [anon_sym_let] = ACTIONS(3176),
    [anon_sym_This] = ACTIONS(3176),
  },
  [3070] = {
    [sym_identifier] = ACTIONS(3192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3190),
    [anon_sym_COMMA] = ACTIONS(3190),
    [anon_sym_RPAREN] = ACTIONS(3190),
    [aux_sym_preproc_if_token2] = ACTIONS(3190),
    [aux_sym_preproc_else_token1] = ACTIONS(3190),
    [aux_sym_preproc_elif_token1] = ACTIONS(3192),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3190),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3190),
    [anon_sym_LPAREN2] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3192),
    [anon_sym_PLUS] = ACTIONS(3192),
    [anon_sym_STAR] = ACTIONS(3192),
    [anon_sym_SLASH] = ACTIONS(3192),
    [anon_sym_PERCENT] = ACTIONS(3192),
    [anon_sym_PIPE_PIPE] = ACTIONS(3190),
    [anon_sym_AMP_AMP] = ACTIONS(3190),
    [anon_sym_PIPE] = ACTIONS(3192),
    [anon_sym_CARET] = ACTIONS(3192),
    [anon_sym_AMP] = ACTIONS(3192),
    [anon_sym_EQ_EQ] = ACTIONS(3190),
    [anon_sym_BANG_EQ] = ACTIONS(3190),
    [anon_sym_GT] = ACTIONS(3192),
    [anon_sym_GT_EQ] = ACTIONS(3190),
    [anon_sym_LT_EQ] = ACTIONS(3192),
    [anon_sym_LT] = ACTIONS(3192),
    [anon_sym_LT_LT] = ACTIONS(3192),
    [anon_sym_GT_GT] = ACTIONS(3192),
    [anon_sym_COLON] = ACTIONS(3190),
    [anon_sym_SEMI] = ACTIONS(3190),
    [anon_sym___attribute__] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(3190),
    [anon_sym_RBRACE] = ACTIONS(3190),
    [anon_sym_LBRACK] = ACTIONS(3190),
    [anon_sym_RBRACK] = ACTIONS(3190),
    [anon_sym_EQ] = ACTIONS(3192),
    [anon_sym_QMARK] = ACTIONS(3190),
    [anon_sym_STAR_EQ] = ACTIONS(3190),
    [anon_sym_SLASH_EQ] = ACTIONS(3190),
    [anon_sym_PERCENT_EQ] = ACTIONS(3190),
    [anon_sym_PLUS_EQ] = ACTIONS(3190),
    [anon_sym_DASH_EQ] = ACTIONS(3190),
    [anon_sym_LT_LT_EQ] = ACTIONS(3190),
    [anon_sym_GT_GT_EQ] = ACTIONS(3190),
    [anon_sym_AMP_EQ] = ACTIONS(3190),
    [anon_sym_CARET_EQ] = ACTIONS(3190),
    [anon_sym_PIPE_EQ] = ACTIONS(3190),
    [anon_sym_and_eq] = ACTIONS(3192),
    [anon_sym_or_eq] = ACTIONS(3192),
    [anon_sym_xor_eq] = ACTIONS(3192),
    [anon_sym_LT_EQ_GT] = ACTIONS(3190),
    [anon_sym_or] = ACTIONS(3192),
    [anon_sym_and] = ACTIONS(3192),
    [anon_sym_bitor] = ACTIONS(3192),
    [anon_sym_xor] = ACTIONS(3192),
    [anon_sym_bitand] = ACTIONS(3192),
    [anon_sym_not_eq] = ACTIONS(3192),
    [anon_sym_is] = ACTIONS(3192),
    [anon_sym_as] = ACTIONS(3192),
    [anon_sym_DASH_DASH] = ACTIONS(3190),
    [anon_sym_PLUS_PLUS] = ACTIONS(3190),
    [anon_sym_DOT] = ACTIONS(3192),
    [anon_sym_DOT_STAR] = ACTIONS(3190),
    [anon_sym_DASH_GT] = ACTIONS(3190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3192),
    [anon_sym_let] = ACTIONS(3192),
    [anon_sym_This] = ACTIONS(3192),
  },
  [3071] = {
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3200),
    [anon_sym_COMMA] = ACTIONS(3200),
    [anon_sym_RPAREN] = ACTIONS(3200),
    [aux_sym_preproc_if_token2] = ACTIONS(3200),
    [aux_sym_preproc_else_token1] = ACTIONS(3200),
    [aux_sym_preproc_elif_token1] = ACTIONS(3202),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3200),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3200),
    [anon_sym_LPAREN2] = ACTIONS(3200),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_STAR] = ACTIONS(3202),
    [anon_sym_SLASH] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3200),
    [anon_sym_AMP_AMP] = ACTIONS(3200),
    [anon_sym_PIPE] = ACTIONS(3202),
    [anon_sym_CARET] = ACTIONS(3202),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_EQ_EQ] = ACTIONS(3200),
    [anon_sym_BANG_EQ] = ACTIONS(3200),
    [anon_sym_GT] = ACTIONS(3202),
    [anon_sym_GT_EQ] = ACTIONS(3200),
    [anon_sym_LT_EQ] = ACTIONS(3202),
    [anon_sym_LT] = ACTIONS(3202),
    [anon_sym_LT_LT] = ACTIONS(3202),
    [anon_sym_GT_GT] = ACTIONS(3202),
    [anon_sym_COLON] = ACTIONS(3200),
    [anon_sym_SEMI] = ACTIONS(3200),
    [anon_sym___attribute__] = ACTIONS(3202),
    [anon_sym_LBRACE] = ACTIONS(3200),
    [anon_sym_RBRACE] = ACTIONS(3200),
    [anon_sym_LBRACK] = ACTIONS(3200),
    [anon_sym_RBRACK] = ACTIONS(3200),
    [anon_sym_EQ] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3200),
    [anon_sym_STAR_EQ] = ACTIONS(3200),
    [anon_sym_SLASH_EQ] = ACTIONS(3200),
    [anon_sym_PERCENT_EQ] = ACTIONS(3200),
    [anon_sym_PLUS_EQ] = ACTIONS(3200),
    [anon_sym_DASH_EQ] = ACTIONS(3200),
    [anon_sym_LT_LT_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_AMP_EQ] = ACTIONS(3200),
    [anon_sym_CARET_EQ] = ACTIONS(3200),
    [anon_sym_PIPE_EQ] = ACTIONS(3200),
    [anon_sym_and_eq] = ACTIONS(3202),
    [anon_sym_or_eq] = ACTIONS(3202),
    [anon_sym_xor_eq] = ACTIONS(3202),
    [anon_sym_LT_EQ_GT] = ACTIONS(3200),
    [anon_sym_or] = ACTIONS(3202),
    [anon_sym_and] = ACTIONS(3202),
    [anon_sym_bitor] = ACTIONS(3202),
    [anon_sym_xor] = ACTIONS(3202),
    [anon_sym_bitand] = ACTIONS(3202),
    [anon_sym_not_eq] = ACTIONS(3202),
    [anon_sym_is] = ACTIONS(3202),
    [anon_sym_as] = ACTIONS(3202),
    [anon_sym_DASH_DASH] = ACTIONS(3200),
    [anon_sym_PLUS_PLUS] = ACTIONS(3200),
    [anon_sym_DOT] = ACTIONS(3202),
    [anon_sym_DOT_STAR] = ACTIONS(3200),
    [anon_sym_DASH_GT] = ACTIONS(3200),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_This] = ACTIONS(3202),
  },
  [3072] = {
    [sym_identifier] = ACTIONS(3338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3336),
    [anon_sym_COMMA] = ACTIONS(3336),
    [anon_sym_RPAREN] = ACTIONS(3336),
    [aux_sym_preproc_if_token2] = ACTIONS(3336),
    [aux_sym_preproc_else_token1] = ACTIONS(3336),
    [aux_sym_preproc_elif_token1] = ACTIONS(3338),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3336),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3338),
    [anon_sym_PLUS] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_SLASH] = ACTIONS(3338),
    [anon_sym_PERCENT] = ACTIONS(3338),
    [anon_sym_PIPE_PIPE] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_PIPE] = ACTIONS(3338),
    [anon_sym_CARET] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3338),
    [anon_sym_EQ_EQ] = ACTIONS(3336),
    [anon_sym_BANG_EQ] = ACTIONS(3336),
    [anon_sym_GT] = ACTIONS(3338),
    [anon_sym_GT_EQ] = ACTIONS(3336),
    [anon_sym_LT_EQ] = ACTIONS(3338),
    [anon_sym_LT] = ACTIONS(3338),
    [anon_sym_LT_LT] = ACTIONS(3338),
    [anon_sym_GT_GT] = ACTIONS(3338),
    [anon_sym_COLON] = ACTIONS(3336),
    [anon_sym_SEMI] = ACTIONS(3336),
    [anon_sym___attribute__] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_RBRACE] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_RBRACK] = ACTIONS(3336),
    [anon_sym_EQ] = ACTIONS(3338),
    [anon_sym_QMARK] = ACTIONS(3336),
    [anon_sym_STAR_EQ] = ACTIONS(3336),
    [anon_sym_SLASH_EQ] = ACTIONS(3336),
    [anon_sym_PERCENT_EQ] = ACTIONS(3336),
    [anon_sym_PLUS_EQ] = ACTIONS(3336),
    [anon_sym_DASH_EQ] = ACTIONS(3336),
    [anon_sym_LT_LT_EQ] = ACTIONS(3336),
    [anon_sym_GT_GT_EQ] = ACTIONS(3336),
    [anon_sym_AMP_EQ] = ACTIONS(3336),
    [anon_sym_CARET_EQ] = ACTIONS(3336),
    [anon_sym_PIPE_EQ] = ACTIONS(3336),
    [anon_sym_and_eq] = ACTIONS(3338),
    [anon_sym_or_eq] = ACTIONS(3338),
    [anon_sym_xor_eq] = ACTIONS(3338),
    [anon_sym_LT_EQ_GT] = ACTIONS(3336),
    [anon_sym_or] = ACTIONS(3338),
    [anon_sym_and] = ACTIONS(3338),
    [anon_sym_bitor] = ACTIONS(3338),
    [anon_sym_xor] = ACTIONS(3338),
    [anon_sym_bitand] = ACTIONS(3338),
    [anon_sym_not_eq] = ACTIONS(3338),
    [anon_sym_is] = ACTIONS(3338),
    [anon_sym_as] = ACTIONS(3338),
    [anon_sym_DASH_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_PLUS] = ACTIONS(3336),
    [anon_sym_DOT] = ACTIONS(3338),
    [anon_sym_DOT_STAR] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(3336),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3338),
    [anon_sym_let] = ACTIONS(3338),
    [anon_sym_This] = ACTIONS(3338),
  },
  [3073] = {
    [sym_identifier] = ACTIONS(2948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2946),
    [anon_sym_COMMA] = ACTIONS(2946),
    [anon_sym_RPAREN] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2948),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2948),
    [anon_sym_PLUS] = ACTIONS(2948),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_SLASH] = ACTIONS(2948),
    [anon_sym_PERCENT] = ACTIONS(2948),
    [anon_sym_PIPE_PIPE] = ACTIONS(2946),
    [anon_sym_AMP_AMP] = ACTIONS(2946),
    [anon_sym_PIPE] = ACTIONS(2948),
    [anon_sym_CARET] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_EQ_EQ] = ACTIONS(2946),
    [anon_sym_BANG_EQ] = ACTIONS(2946),
    [anon_sym_GT] = ACTIONS(2948),
    [anon_sym_GT_EQ] = ACTIONS(2946),
    [anon_sym_LT_EQ] = ACTIONS(2948),
    [anon_sym_LT] = ACTIONS(2948),
    [anon_sym_LT_LT] = ACTIONS(2948),
    [anon_sym_GT_GT] = ACTIONS(2948),
    [anon_sym_COLON] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2946),
    [anon_sym_RBRACE] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_RBRACK] = ACTIONS(2946),
    [anon_sym_EQ] = ACTIONS(2948),
    [anon_sym_QMARK] = ACTIONS(2946),
    [anon_sym_STAR_EQ] = ACTIONS(2946),
    [anon_sym_SLASH_EQ] = ACTIONS(2946),
    [anon_sym_PERCENT_EQ] = ACTIONS(2946),
    [anon_sym_PLUS_EQ] = ACTIONS(2946),
    [anon_sym_DASH_EQ] = ACTIONS(2946),
    [anon_sym_LT_LT_EQ] = ACTIONS(2946),
    [anon_sym_GT_GT_EQ] = ACTIONS(2946),
    [anon_sym_AMP_EQ] = ACTIONS(2946),
    [anon_sym_CARET_EQ] = ACTIONS(2946),
    [anon_sym_PIPE_EQ] = ACTIONS(2946),
    [anon_sym_and_eq] = ACTIONS(2948),
    [anon_sym_or_eq] = ACTIONS(2948),
    [anon_sym_xor_eq] = ACTIONS(2948),
    [anon_sym_LT_EQ_GT] = ACTIONS(2946),
    [anon_sym_or] = ACTIONS(2948),
    [anon_sym_and] = ACTIONS(2948),
    [anon_sym_bitor] = ACTIONS(2948),
    [anon_sym_xor] = ACTIONS(2948),
    [anon_sym_bitand] = ACTIONS(2948),
    [anon_sym_not_eq] = ACTIONS(2948),
    [anon_sym_is] = ACTIONS(2948),
    [anon_sym_as] = ACTIONS(2948),
    [anon_sym_DASH_DASH] = ACTIONS(2946),
    [anon_sym_PLUS_PLUS] = ACTIONS(2946),
    [anon_sym_DOT] = ACTIONS(2948),
    [anon_sym_DOT_STAR] = ACTIONS(2946),
    [anon_sym_DASH_GT] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2948),
    [anon_sym_let] = ACTIONS(2948),
    [anon_sym_This] = ACTIONS(2948),
  },
  [3074] = {
    [sym_identifier] = ACTIONS(3070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3068),
    [anon_sym_COMMA] = ACTIONS(3068),
    [anon_sym_RPAREN] = ACTIONS(3068),
    [aux_sym_preproc_if_token2] = ACTIONS(3068),
    [aux_sym_preproc_else_token1] = ACTIONS(3068),
    [aux_sym_preproc_elif_token1] = ACTIONS(3070),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3068),
    [anon_sym_DASH] = ACTIONS(3070),
    [anon_sym_PLUS] = ACTIONS(3070),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_SLASH] = ACTIONS(3070),
    [anon_sym_PERCENT] = ACTIONS(3070),
    [anon_sym_PIPE_PIPE] = ACTIONS(3068),
    [anon_sym_AMP_AMP] = ACTIONS(3068),
    [anon_sym_PIPE] = ACTIONS(3070),
    [anon_sym_CARET] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3070),
    [anon_sym_EQ_EQ] = ACTIONS(3068),
    [anon_sym_BANG_EQ] = ACTIONS(3068),
    [anon_sym_GT] = ACTIONS(3070),
    [anon_sym_GT_EQ] = ACTIONS(3068),
    [anon_sym_LT_EQ] = ACTIONS(3070),
    [anon_sym_LT] = ACTIONS(3070),
    [anon_sym_LT_LT] = ACTIONS(3070),
    [anon_sym_GT_GT] = ACTIONS(3070),
    [anon_sym_COLON] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3068),
    [anon_sym___attribute__] = ACTIONS(3070),
    [anon_sym_LBRACE] = ACTIONS(3068),
    [anon_sym_RBRACE] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_RBRACK] = ACTIONS(3068),
    [anon_sym_EQ] = ACTIONS(3070),
    [anon_sym_QMARK] = ACTIONS(3068),
    [anon_sym_STAR_EQ] = ACTIONS(3068),
    [anon_sym_SLASH_EQ] = ACTIONS(3068),
    [anon_sym_PERCENT_EQ] = ACTIONS(3068),
    [anon_sym_PLUS_EQ] = ACTIONS(3068),
    [anon_sym_DASH_EQ] = ACTIONS(3068),
    [anon_sym_LT_LT_EQ] = ACTIONS(3068),
    [anon_sym_GT_GT_EQ] = ACTIONS(3068),
    [anon_sym_AMP_EQ] = ACTIONS(3068),
    [anon_sym_CARET_EQ] = ACTIONS(3068),
    [anon_sym_PIPE_EQ] = ACTIONS(3068),
    [anon_sym_and_eq] = ACTIONS(3070),
    [anon_sym_or_eq] = ACTIONS(3070),
    [anon_sym_xor_eq] = ACTIONS(3070),
    [anon_sym_LT_EQ_GT] = ACTIONS(3068),
    [anon_sym_or] = ACTIONS(3070),
    [anon_sym_and] = ACTIONS(3070),
    [anon_sym_bitor] = ACTIONS(3070),
    [anon_sym_xor] = ACTIONS(3070),
    [anon_sym_bitand] = ACTIONS(3070),
    [anon_sym_not_eq] = ACTIONS(3070),
    [anon_sym_is] = ACTIONS(3070),
    [anon_sym_as] = ACTIONS(3070),
    [anon_sym_DASH_DASH] = ACTIONS(3068),
    [anon_sym_PLUS_PLUS] = ACTIONS(3068),
    [anon_sym_DOT] = ACTIONS(3070),
    [anon_sym_DOT_STAR] = ACTIONS(3068),
    [anon_sym_DASH_GT] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3070),
    [anon_sym_let] = ACTIONS(3070),
    [anon_sym_This] = ACTIONS(3070),
  },
  [3075] = {
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3360),
    [anon_sym_COMMA] = ACTIONS(3360),
    [anon_sym_RPAREN] = ACTIONS(3360),
    [aux_sym_preproc_if_token2] = ACTIONS(3360),
    [aux_sym_preproc_else_token1] = ACTIONS(3360),
    [aux_sym_preproc_elif_token1] = ACTIONS(3362),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3360),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3360),
    [anon_sym_LPAREN2] = ACTIONS(3360),
    [anon_sym_DASH] = ACTIONS(3362),
    [anon_sym_PLUS] = ACTIONS(3362),
    [anon_sym_STAR] = ACTIONS(3362),
    [anon_sym_SLASH] = ACTIONS(3362),
    [anon_sym_PERCENT] = ACTIONS(3362),
    [anon_sym_PIPE_PIPE] = ACTIONS(3360),
    [anon_sym_AMP_AMP] = ACTIONS(3360),
    [anon_sym_PIPE] = ACTIONS(3362),
    [anon_sym_CARET] = ACTIONS(3362),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_EQ_EQ] = ACTIONS(3360),
    [anon_sym_BANG_EQ] = ACTIONS(3360),
    [anon_sym_GT] = ACTIONS(3362),
    [anon_sym_GT_EQ] = ACTIONS(3360),
    [anon_sym_LT_EQ] = ACTIONS(3362),
    [anon_sym_LT] = ACTIONS(3362),
    [anon_sym_LT_LT] = ACTIONS(3362),
    [anon_sym_GT_GT] = ACTIONS(3362),
    [anon_sym_COLON] = ACTIONS(3360),
    [anon_sym_SEMI] = ACTIONS(3360),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym_LBRACE] = ACTIONS(3360),
    [anon_sym_RBRACE] = ACTIONS(3360),
    [anon_sym_LBRACK] = ACTIONS(3360),
    [anon_sym_RBRACK] = ACTIONS(3360),
    [anon_sym_EQ] = ACTIONS(3362),
    [anon_sym_QMARK] = ACTIONS(3360),
    [anon_sym_STAR_EQ] = ACTIONS(3360),
    [anon_sym_SLASH_EQ] = ACTIONS(3360),
    [anon_sym_PERCENT_EQ] = ACTIONS(3360),
    [anon_sym_PLUS_EQ] = ACTIONS(3360),
    [anon_sym_DASH_EQ] = ACTIONS(3360),
    [anon_sym_LT_LT_EQ] = ACTIONS(3360),
    [anon_sym_GT_GT_EQ] = ACTIONS(3360),
    [anon_sym_AMP_EQ] = ACTIONS(3360),
    [anon_sym_CARET_EQ] = ACTIONS(3360),
    [anon_sym_PIPE_EQ] = ACTIONS(3360),
    [anon_sym_and_eq] = ACTIONS(3362),
    [anon_sym_or_eq] = ACTIONS(3362),
    [anon_sym_xor_eq] = ACTIONS(3362),
    [anon_sym_LT_EQ_GT] = ACTIONS(3360),
    [anon_sym_or] = ACTIONS(3362),
    [anon_sym_and] = ACTIONS(3362),
    [anon_sym_bitor] = ACTIONS(3362),
    [anon_sym_xor] = ACTIONS(3362),
    [anon_sym_bitand] = ACTIONS(3362),
    [anon_sym_not_eq] = ACTIONS(3362),
    [anon_sym_is] = ACTIONS(3362),
    [anon_sym_as] = ACTIONS(3362),
    [anon_sym_DASH_DASH] = ACTIONS(3360),
    [anon_sym_PLUS_PLUS] = ACTIONS(3360),
    [anon_sym_DOT] = ACTIONS(3362),
    [anon_sym_DOT_STAR] = ACTIONS(3360),
    [anon_sym_DASH_GT] = ACTIONS(3360),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
  },
  [3076] = {
    [sym_identifier] = ACTIONS(3366),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3364),
    [anon_sym_COMMA] = ACTIONS(3364),
    [anon_sym_RPAREN] = ACTIONS(3364),
    [aux_sym_preproc_if_token2] = ACTIONS(3364),
    [aux_sym_preproc_else_token1] = ACTIONS(3364),
    [aux_sym_preproc_elif_token1] = ACTIONS(3366),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3364),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3364),
    [anon_sym_LPAREN2] = ACTIONS(3364),
    [anon_sym_DASH] = ACTIONS(3366),
    [anon_sym_PLUS] = ACTIONS(3366),
    [anon_sym_STAR] = ACTIONS(3366),
    [anon_sym_SLASH] = ACTIONS(3366),
    [anon_sym_PERCENT] = ACTIONS(3366),
    [anon_sym_PIPE_PIPE] = ACTIONS(3364),
    [anon_sym_AMP_AMP] = ACTIONS(3364),
    [anon_sym_PIPE] = ACTIONS(3366),
    [anon_sym_CARET] = ACTIONS(3366),
    [anon_sym_AMP] = ACTIONS(3366),
    [anon_sym_EQ_EQ] = ACTIONS(3364),
    [anon_sym_BANG_EQ] = ACTIONS(3364),
    [anon_sym_GT] = ACTIONS(3366),
    [anon_sym_GT_EQ] = ACTIONS(3364),
    [anon_sym_LT_EQ] = ACTIONS(3366),
    [anon_sym_LT] = ACTIONS(3366),
    [anon_sym_LT_LT] = ACTIONS(3366),
    [anon_sym_GT_GT] = ACTIONS(3366),
    [anon_sym_COLON] = ACTIONS(3364),
    [anon_sym_SEMI] = ACTIONS(3364),
    [anon_sym___attribute__] = ACTIONS(3366),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_RBRACE] = ACTIONS(3364),
    [anon_sym_LBRACK] = ACTIONS(3364),
    [anon_sym_RBRACK] = ACTIONS(3364),
    [anon_sym_EQ] = ACTIONS(3366),
    [anon_sym_QMARK] = ACTIONS(3364),
    [anon_sym_STAR_EQ] = ACTIONS(3364),
    [anon_sym_SLASH_EQ] = ACTIONS(3364),
    [anon_sym_PERCENT_EQ] = ACTIONS(3364),
    [anon_sym_PLUS_EQ] = ACTIONS(3364),
    [anon_sym_DASH_EQ] = ACTIONS(3364),
    [anon_sym_LT_LT_EQ] = ACTIONS(3364),
    [anon_sym_GT_GT_EQ] = ACTIONS(3364),
    [anon_sym_AMP_EQ] = ACTIONS(3364),
    [anon_sym_CARET_EQ] = ACTIONS(3364),
    [anon_sym_PIPE_EQ] = ACTIONS(3364),
    [anon_sym_and_eq] = ACTIONS(3366),
    [anon_sym_or_eq] = ACTIONS(3366),
    [anon_sym_xor_eq] = ACTIONS(3366),
    [anon_sym_LT_EQ_GT] = ACTIONS(3364),
    [anon_sym_or] = ACTIONS(3366),
    [anon_sym_and] = ACTIONS(3366),
    [anon_sym_bitor] = ACTIONS(3366),
    [anon_sym_xor] = ACTIONS(3366),
    [anon_sym_bitand] = ACTIONS(3366),
    [anon_sym_not_eq] = ACTIONS(3366),
    [anon_sym_is] = ACTIONS(3366),
    [anon_sym_as] = ACTIONS(3366),
    [anon_sym_DASH_DASH] = ACTIONS(3364),
    [anon_sym_PLUS_PLUS] = ACTIONS(3364),
    [anon_sym_DOT] = ACTIONS(3366),
    [anon_sym_DOT_STAR] = ACTIONS(3364),
    [anon_sym_DASH_GT] = ACTIONS(3364),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3366),
    [anon_sym_let] = ACTIONS(3366),
    [anon_sym_This] = ACTIONS(3366),
  },
  [3077] = {
    [sym_string_literal] = STATE(3342),
    [sym_template_argument_list] = STATE(4579),
    [sym_raw_string_literal] = STATE(3342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(6208),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2117),
    [anon_sym_RBRACK] = ACTIONS(2117),
    [anon_sym_EQ] = ACTIONS(6643),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(6645),
    [anon_sym_SLASH_EQ] = ACTIONS(6645),
    [anon_sym_PERCENT_EQ] = ACTIONS(6645),
    [anon_sym_PLUS_EQ] = ACTIONS(6645),
    [anon_sym_DASH_EQ] = ACTIONS(6645),
    [anon_sym_LT_LT_EQ] = ACTIONS(6645),
    [anon_sym_GT_GT_EQ] = ACTIONS(6645),
    [anon_sym_AMP_EQ] = ACTIONS(6645),
    [anon_sym_CARET_EQ] = ACTIONS(6645),
    [anon_sym_PIPE_EQ] = ACTIONS(6645),
    [anon_sym_and_eq] = ACTIONS(6645),
    [anon_sym_or_eq] = ACTIONS(6645),
    [anon_sym_xor_eq] = ACTIONS(6645),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2117),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2117),
    [anon_sym_not_eq] = ACTIONS(2117),
    [anon_sym_is] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2158),
    [anon_sym_LR_DQUOTE] = ACTIONS(2158),
    [anon_sym_uR_DQUOTE] = ACTIONS(2158),
    [anon_sym_UR_DQUOTE] = ACTIONS(2158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2158),
  },
  [3078] = {
    [sym_identifier] = ACTIONS(3338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3336),
    [anon_sym_COMMA] = ACTIONS(3336),
    [anon_sym_RPAREN] = ACTIONS(3336),
    [aux_sym_preproc_if_token2] = ACTIONS(3336),
    [aux_sym_preproc_else_token1] = ACTIONS(3336),
    [aux_sym_preproc_elif_token1] = ACTIONS(3338),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3336),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3338),
    [anon_sym_PLUS] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_SLASH] = ACTIONS(3338),
    [anon_sym_PERCENT] = ACTIONS(3338),
    [anon_sym_PIPE_PIPE] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_PIPE] = ACTIONS(3338),
    [anon_sym_CARET] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3338),
    [anon_sym_EQ_EQ] = ACTIONS(3336),
    [anon_sym_BANG_EQ] = ACTIONS(3336),
    [anon_sym_GT] = ACTIONS(3338),
    [anon_sym_GT_EQ] = ACTIONS(3336),
    [anon_sym_LT_EQ] = ACTIONS(3338),
    [anon_sym_LT] = ACTIONS(3338),
    [anon_sym_LT_LT] = ACTIONS(3338),
    [anon_sym_GT_GT] = ACTIONS(3338),
    [anon_sym_COLON] = ACTIONS(3336),
    [anon_sym_SEMI] = ACTIONS(3336),
    [anon_sym___attribute__] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_RBRACE] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_RBRACK] = ACTIONS(3336),
    [anon_sym_EQ] = ACTIONS(3338),
    [anon_sym_QMARK] = ACTIONS(3336),
    [anon_sym_STAR_EQ] = ACTIONS(3336),
    [anon_sym_SLASH_EQ] = ACTIONS(3336),
    [anon_sym_PERCENT_EQ] = ACTIONS(3336),
    [anon_sym_PLUS_EQ] = ACTIONS(3336),
    [anon_sym_DASH_EQ] = ACTIONS(3336),
    [anon_sym_LT_LT_EQ] = ACTIONS(3336),
    [anon_sym_GT_GT_EQ] = ACTIONS(3336),
    [anon_sym_AMP_EQ] = ACTIONS(3336),
    [anon_sym_CARET_EQ] = ACTIONS(3336),
    [anon_sym_PIPE_EQ] = ACTIONS(3336),
    [anon_sym_and_eq] = ACTIONS(3338),
    [anon_sym_or_eq] = ACTIONS(3338),
    [anon_sym_xor_eq] = ACTIONS(3338),
    [anon_sym_LT_EQ_GT] = ACTIONS(3336),
    [anon_sym_or] = ACTIONS(3338),
    [anon_sym_and] = ACTIONS(3338),
    [anon_sym_bitor] = ACTIONS(3338),
    [anon_sym_xor] = ACTIONS(3338),
    [anon_sym_bitand] = ACTIONS(3338),
    [anon_sym_not_eq] = ACTIONS(3338),
    [anon_sym_is] = ACTIONS(3338),
    [anon_sym_as] = ACTIONS(3338),
    [anon_sym_DASH_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_PLUS] = ACTIONS(3336),
    [anon_sym_DOT] = ACTIONS(3338),
    [anon_sym_DOT_STAR] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(3336),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3338),
    [anon_sym_let] = ACTIONS(3338),
    [anon_sym_This] = ACTIONS(3338),
  },
  [3079] = {
    [sym_identifier] = ACTIONS(3338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3336),
    [anon_sym_COMMA] = ACTIONS(3336),
    [anon_sym_RPAREN] = ACTIONS(3336),
    [aux_sym_preproc_if_token2] = ACTIONS(3336),
    [aux_sym_preproc_else_token1] = ACTIONS(3336),
    [aux_sym_preproc_elif_token1] = ACTIONS(3338),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3336),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3338),
    [anon_sym_PLUS] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_SLASH] = ACTIONS(3338),
    [anon_sym_PERCENT] = ACTIONS(3338),
    [anon_sym_PIPE_PIPE] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_PIPE] = ACTIONS(3338),
    [anon_sym_CARET] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3338),
    [anon_sym_EQ_EQ] = ACTIONS(3336),
    [anon_sym_BANG_EQ] = ACTIONS(3336),
    [anon_sym_GT] = ACTIONS(3338),
    [anon_sym_GT_EQ] = ACTIONS(3336),
    [anon_sym_LT_EQ] = ACTIONS(3338),
    [anon_sym_LT] = ACTIONS(3338),
    [anon_sym_LT_LT] = ACTIONS(3338),
    [anon_sym_GT_GT] = ACTIONS(3338),
    [anon_sym_COLON] = ACTIONS(3336),
    [anon_sym_SEMI] = ACTIONS(3336),
    [anon_sym___attribute__] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_RBRACE] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_RBRACK] = ACTIONS(3336),
    [anon_sym_EQ] = ACTIONS(3338),
    [anon_sym_QMARK] = ACTIONS(3336),
    [anon_sym_STAR_EQ] = ACTIONS(3336),
    [anon_sym_SLASH_EQ] = ACTIONS(3336),
    [anon_sym_PERCENT_EQ] = ACTIONS(3336),
    [anon_sym_PLUS_EQ] = ACTIONS(3336),
    [anon_sym_DASH_EQ] = ACTIONS(3336),
    [anon_sym_LT_LT_EQ] = ACTIONS(3336),
    [anon_sym_GT_GT_EQ] = ACTIONS(3336),
    [anon_sym_AMP_EQ] = ACTIONS(3336),
    [anon_sym_CARET_EQ] = ACTIONS(3336),
    [anon_sym_PIPE_EQ] = ACTIONS(3336),
    [anon_sym_and_eq] = ACTIONS(3338),
    [anon_sym_or_eq] = ACTIONS(3338),
    [anon_sym_xor_eq] = ACTIONS(3338),
    [anon_sym_LT_EQ_GT] = ACTIONS(3336),
    [anon_sym_or] = ACTIONS(3338),
    [anon_sym_and] = ACTIONS(3338),
    [anon_sym_bitor] = ACTIONS(3338),
    [anon_sym_xor] = ACTIONS(3338),
    [anon_sym_bitand] = ACTIONS(3338),
    [anon_sym_not_eq] = ACTIONS(3338),
    [anon_sym_is] = ACTIONS(3338),
    [anon_sym_as] = ACTIONS(3338),
    [anon_sym_DASH_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_PLUS] = ACTIONS(3336),
    [anon_sym_DOT] = ACTIONS(3338),
    [anon_sym_DOT_STAR] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(3336),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3338),
    [anon_sym_let] = ACTIONS(3338),
    [anon_sym_This] = ACTIONS(3338),
  },
  [3080] = {
    [sym_string_literal] = STATE(3053),
    [sym_template_argument_list] = STATE(4135),
    [sym_raw_string_literal] = STATE(3053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2128),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(6758),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2117),
    [anon_sym_EQ] = ACTIONS(2128),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2117),
    [anon_sym_SLASH_EQ] = ACTIONS(2117),
    [anon_sym_PERCENT_EQ] = ACTIONS(2117),
    [anon_sym_PLUS_EQ] = ACTIONS(2117),
    [anon_sym_DASH_EQ] = ACTIONS(2117),
    [anon_sym_LT_LT_EQ] = ACTIONS(2117),
    [anon_sym_GT_GT_EQ] = ACTIONS(2128),
    [anon_sym_AMP_EQ] = ACTIONS(2117),
    [anon_sym_CARET_EQ] = ACTIONS(2117),
    [anon_sym_PIPE_EQ] = ACTIONS(2117),
    [anon_sym_and_eq] = ACTIONS(2117),
    [anon_sym_or_eq] = ACTIONS(2117),
    [anon_sym_xor_eq] = ACTIONS(2117),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2117),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2117),
    [anon_sym_not_eq] = ACTIONS(2117),
    [anon_sym_is] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(6742),
    [anon_sym_u_DQUOTE] = ACTIONS(6742),
    [anon_sym_U_DQUOTE] = ACTIONS(6742),
    [anon_sym_u8_DQUOTE] = ACTIONS(6742),
    [anon_sym_DQUOTE] = ACTIONS(6742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(2117),
    [anon_sym_R_DQUOTE] = ACTIONS(6744),
    [anon_sym_LR_DQUOTE] = ACTIONS(6744),
    [anon_sym_uR_DQUOTE] = ACTIONS(6744),
    [anon_sym_UR_DQUOTE] = ACTIONS(6744),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6744),
  },
  [3081] = {
    [sym_identifier] = ACTIONS(3156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3154),
    [anon_sym_COMMA] = ACTIONS(3154),
    [anon_sym_RPAREN] = ACTIONS(3154),
    [aux_sym_preproc_if_token2] = ACTIONS(3154),
    [aux_sym_preproc_else_token1] = ACTIONS(3154),
    [aux_sym_preproc_elif_token1] = ACTIONS(3156),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3154),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3154),
    [anon_sym_LPAREN2] = ACTIONS(3154),
    [anon_sym_DASH] = ACTIONS(3156),
    [anon_sym_PLUS] = ACTIONS(3156),
    [anon_sym_STAR] = ACTIONS(3156),
    [anon_sym_SLASH] = ACTIONS(3156),
    [anon_sym_PERCENT] = ACTIONS(3156),
    [anon_sym_PIPE_PIPE] = ACTIONS(3154),
    [anon_sym_AMP_AMP] = ACTIONS(3154),
    [anon_sym_PIPE] = ACTIONS(3156),
    [anon_sym_CARET] = ACTIONS(3156),
    [anon_sym_AMP] = ACTIONS(3156),
    [anon_sym_EQ_EQ] = ACTIONS(3154),
    [anon_sym_BANG_EQ] = ACTIONS(3154),
    [anon_sym_GT] = ACTIONS(3156),
    [anon_sym_GT_EQ] = ACTIONS(3154),
    [anon_sym_LT_EQ] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3156),
    [anon_sym_LT_LT] = ACTIONS(3156),
    [anon_sym_GT_GT] = ACTIONS(3156),
    [anon_sym_COLON] = ACTIONS(3154),
    [anon_sym_SEMI] = ACTIONS(3154),
    [anon_sym___attribute__] = ACTIONS(3156),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_RBRACE] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_RBRACK] = ACTIONS(3154),
    [anon_sym_EQ] = ACTIONS(3156),
    [anon_sym_QMARK] = ACTIONS(3154),
    [anon_sym_STAR_EQ] = ACTIONS(3154),
    [anon_sym_SLASH_EQ] = ACTIONS(3154),
    [anon_sym_PERCENT_EQ] = ACTIONS(3154),
    [anon_sym_PLUS_EQ] = ACTIONS(3154),
    [anon_sym_DASH_EQ] = ACTIONS(3154),
    [anon_sym_LT_LT_EQ] = ACTIONS(3154),
    [anon_sym_GT_GT_EQ] = ACTIONS(3154),
    [anon_sym_AMP_EQ] = ACTIONS(3154),
    [anon_sym_CARET_EQ] = ACTIONS(3154),
    [anon_sym_PIPE_EQ] = ACTIONS(3154),
    [anon_sym_and_eq] = ACTIONS(3156),
    [anon_sym_or_eq] = ACTIONS(3156),
    [anon_sym_xor_eq] = ACTIONS(3156),
    [anon_sym_LT_EQ_GT] = ACTIONS(3154),
    [anon_sym_or] = ACTIONS(3156),
    [anon_sym_and] = ACTIONS(3156),
    [anon_sym_bitor] = ACTIONS(3156),
    [anon_sym_xor] = ACTIONS(3156),
    [anon_sym_bitand] = ACTIONS(3156),
    [anon_sym_not_eq] = ACTIONS(3156),
    [anon_sym_is] = ACTIONS(3156),
    [anon_sym_as] = ACTIONS(3156),
    [anon_sym_DASH_DASH] = ACTIONS(3154),
    [anon_sym_PLUS_PLUS] = ACTIONS(3154),
    [anon_sym_DOT] = ACTIONS(3156),
    [anon_sym_DOT_STAR] = ACTIONS(3154),
    [anon_sym_DASH_GT] = ACTIONS(3154),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3156),
    [anon_sym_let] = ACTIONS(3156),
    [anon_sym_This] = ACTIONS(3156),
  },
  [3082] = {
    [sym_identifier] = ACTIONS(3172),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3170),
    [anon_sym_COMMA] = ACTIONS(3170),
    [anon_sym_RPAREN] = ACTIONS(3170),
    [aux_sym_preproc_if_token2] = ACTIONS(3170),
    [aux_sym_preproc_else_token1] = ACTIONS(3170),
    [aux_sym_preproc_elif_token1] = ACTIONS(3172),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3170),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3170),
    [anon_sym_LPAREN2] = ACTIONS(3170),
    [anon_sym_DASH] = ACTIONS(3172),
    [anon_sym_PLUS] = ACTIONS(3172),
    [anon_sym_STAR] = ACTIONS(3172),
    [anon_sym_SLASH] = ACTIONS(3172),
    [anon_sym_PERCENT] = ACTIONS(3172),
    [anon_sym_PIPE_PIPE] = ACTIONS(3170),
    [anon_sym_AMP_AMP] = ACTIONS(3170),
    [anon_sym_PIPE] = ACTIONS(3172),
    [anon_sym_CARET] = ACTIONS(3172),
    [anon_sym_AMP] = ACTIONS(3172),
    [anon_sym_EQ_EQ] = ACTIONS(3170),
    [anon_sym_BANG_EQ] = ACTIONS(3170),
    [anon_sym_GT] = ACTIONS(3172),
    [anon_sym_GT_EQ] = ACTIONS(3170),
    [anon_sym_LT_EQ] = ACTIONS(3172),
    [anon_sym_LT] = ACTIONS(3172),
    [anon_sym_LT_LT] = ACTIONS(3172),
    [anon_sym_GT_GT] = ACTIONS(3172),
    [anon_sym_COLON] = ACTIONS(3170),
    [anon_sym_SEMI] = ACTIONS(3170),
    [anon_sym___attribute__] = ACTIONS(3172),
    [anon_sym_LBRACE] = ACTIONS(3170),
    [anon_sym_RBRACE] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3170),
    [anon_sym_RBRACK] = ACTIONS(3170),
    [anon_sym_EQ] = ACTIONS(3172),
    [anon_sym_QMARK] = ACTIONS(3170),
    [anon_sym_STAR_EQ] = ACTIONS(3170),
    [anon_sym_SLASH_EQ] = ACTIONS(3170),
    [anon_sym_PERCENT_EQ] = ACTIONS(3170),
    [anon_sym_PLUS_EQ] = ACTIONS(3170),
    [anon_sym_DASH_EQ] = ACTIONS(3170),
    [anon_sym_LT_LT_EQ] = ACTIONS(3170),
    [anon_sym_GT_GT_EQ] = ACTIONS(3170),
    [anon_sym_AMP_EQ] = ACTIONS(3170),
    [anon_sym_CARET_EQ] = ACTIONS(3170),
    [anon_sym_PIPE_EQ] = ACTIONS(3170),
    [anon_sym_and_eq] = ACTIONS(3172),
    [anon_sym_or_eq] = ACTIONS(3172),
    [anon_sym_xor_eq] = ACTIONS(3172),
    [anon_sym_LT_EQ_GT] = ACTIONS(3170),
    [anon_sym_or] = ACTIONS(3172),
    [anon_sym_and] = ACTIONS(3172),
    [anon_sym_bitor] = ACTIONS(3172),
    [anon_sym_xor] = ACTIONS(3172),
    [anon_sym_bitand] = ACTIONS(3172),
    [anon_sym_not_eq] = ACTIONS(3172),
    [anon_sym_is] = ACTIONS(3172),
    [anon_sym_as] = ACTIONS(3172),
    [anon_sym_DASH_DASH] = ACTIONS(3170),
    [anon_sym_PLUS_PLUS] = ACTIONS(3170),
    [anon_sym_DOT] = ACTIONS(3172),
    [anon_sym_DOT_STAR] = ACTIONS(3170),
    [anon_sym_DASH_GT] = ACTIONS(3170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3172),
    [anon_sym_let] = ACTIONS(3172),
    [anon_sym_This] = ACTIONS(3172),
  },
  [3083] = {
    [sym_ms_based_modifier] = STATE(10435),
    [sym_ms_unaligned_ptr_modifier] = STATE(4963),
    [sym_ms_pointer_modifier] = STATE(3084),
    [sym__declarator] = STATE(7274),
    [sym__abstract_declarator] = STATE(7587),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_abstract_parenthesized_declarator] = STATE(7128),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_abstract_pointer_declarator] = STATE(7128),
    [sym_function_declarator] = STATE(7882),
    [sym_abstract_function_declarator] = STATE(7128),
    [sym_array_declarator] = STATE(7882),
    [sym_abstract_array_declarator] = STATE(7128),
    [sym_type_qualifier] = STATE(3469),
    [sym_alignas_qualifier] = STATE(5665),
    [sym_parameter_list] = STATE(3498),
    [sym_decltype] = STATE(10765),
    [sym_reference_declarator] = STATE(7882),
    [sym_abstract_reference_declarator] = STATE(7128),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym__function_declarator_seq] = STATE(7135),
    [sym_template_type] = STATE(10765),
    [sym_template_function] = STATE(7882),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6926),
    [sym_qualified_identifier] = STATE(7882),
    [sym_operator_name] = STATE(7882),
    [aux_sym__type_definition_type_repeat1] = STATE(3469),
    [aux_sym_pointer_declarator_repeat1] = STATE(3084),
    [sym_identifier] = ACTIONS(6761),
    [anon_sym_COMMA] = ACTIONS(6763),
    [anon_sym_RPAREN] = ACTIONS(6763),
    [anon_sym_LPAREN2] = ACTIONS(4883),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(6765),
    [anon_sym_AMP_AMP] = ACTIONS(6767),
    [anon_sym_AMP] = ACTIONS(6769),
    [anon_sym_COLON] = ACTIONS(6771),
    [anon_sym___extension__] = ACTIONS(4901),
    [anon_sym_COLON_COLON] = ACTIONS(6773),
    [anon_sym___based] = ACTIONS(49),
    [sym_ms_restrict_modifier] = ACTIONS(4903),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(4903),
    [sym_ms_signed_ptr_modifier] = ACTIONS(4903),
    [anon_sym__unaligned] = ACTIONS(4905),
    [anon_sym___unaligned] = ACTIONS(4905),
    [anon_sym_LBRACK] = ACTIONS(6775),
    [anon_sym_EQ] = ACTIONS(6763),
    [anon_sym_const] = ACTIONS(4901),
    [anon_sym_constexpr] = ACTIONS(4901),
    [anon_sym_volatile] = ACTIONS(4901),
    [anon_sym_restrict] = ACTIONS(4901),
    [anon_sym___restrict__] = ACTIONS(4901),
    [anon_sym__Atomic] = ACTIONS(4901),
    [anon_sym__Noreturn] = ACTIONS(4901),
    [anon_sym_noreturn] = ACTIONS(4901),
    [anon_sym_mutable] = ACTIONS(4901),
    [anon_sym_constinit] = ACTIONS(4901),
    [anon_sym_consteval] = ACTIONS(4901),
    [anon_sym_alignas] = ACTIONS(4907),
    [anon_sym__Alignas] = ACTIONS(4907),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(6763),
    [anon_sym_operator] = ACTIONS(2808),
  },
  [3084] = {
    [sym_ms_based_modifier] = STATE(10435),
    [sym_ms_unaligned_ptr_modifier] = STATE(4963),
    [sym_ms_pointer_modifier] = STATE(4823),
    [sym__declarator] = STATE(7264),
    [sym__abstract_declarator] = STATE(7546),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_abstract_parenthesized_declarator] = STATE(7128),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_abstract_pointer_declarator] = STATE(7128),
    [sym_function_declarator] = STATE(7882),
    [sym_abstract_function_declarator] = STATE(7128),
    [sym_array_declarator] = STATE(7882),
    [sym_abstract_array_declarator] = STATE(7128),
    [sym_type_qualifier] = STATE(3462),
    [sym_alignas_qualifier] = STATE(5665),
    [sym_parameter_list] = STATE(3498),
    [sym_decltype] = STATE(10765),
    [sym_reference_declarator] = STATE(7882),
    [sym_abstract_reference_declarator] = STATE(7128),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym__function_declarator_seq] = STATE(7135),
    [sym_template_type] = STATE(10765),
    [sym_template_function] = STATE(7882),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6926),
    [sym_qualified_identifier] = STATE(7882),
    [sym_operator_name] = STATE(7882),
    [aux_sym__type_definition_type_repeat1] = STATE(3462),
    [aux_sym_pointer_declarator_repeat1] = STATE(4823),
    [sym_identifier] = ACTIONS(6761),
    [anon_sym_COMMA] = ACTIONS(6777),
    [anon_sym_RPAREN] = ACTIONS(6777),
    [anon_sym_LPAREN2] = ACTIONS(4883),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(6765),
    [anon_sym_AMP_AMP] = ACTIONS(6767),
    [anon_sym_AMP] = ACTIONS(6769),
    [anon_sym_COLON] = ACTIONS(6779),
    [anon_sym___extension__] = ACTIONS(4901),
    [anon_sym_COLON_COLON] = ACTIONS(6773),
    [anon_sym___based] = ACTIONS(49),
    [sym_ms_restrict_modifier] = ACTIONS(4903),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(4903),
    [sym_ms_signed_ptr_modifier] = ACTIONS(4903),
    [anon_sym__unaligned] = ACTIONS(4905),
    [anon_sym___unaligned] = ACTIONS(4905),
    [anon_sym_LBRACK] = ACTIONS(6775),
    [anon_sym_EQ] = ACTIONS(6777),
    [anon_sym_const] = ACTIONS(4901),
    [anon_sym_constexpr] = ACTIONS(4901),
    [anon_sym_volatile] = ACTIONS(4901),
    [anon_sym_restrict] = ACTIONS(4901),
    [anon_sym___restrict__] = ACTIONS(4901),
    [anon_sym__Atomic] = ACTIONS(4901),
    [anon_sym__Noreturn] = ACTIONS(4901),
    [anon_sym_noreturn] = ACTIONS(4901),
    [anon_sym_mutable] = ACTIONS(4901),
    [anon_sym_constinit] = ACTIONS(4901),
    [anon_sym_consteval] = ACTIONS(4901),
    [anon_sym_alignas] = ACTIONS(4907),
    [anon_sym__Alignas] = ACTIONS(4907),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(6777),
    [anon_sym_operator] = ACTIONS(2808),
  },
  [3085] = {
    [sym_attribute_declaration] = STATE(3119),
    [sym_parameter_list] = STATE(3131),
    [aux_sym_attributed_declarator_repeat1] = STATE(3119),
    [sym_identifier] = ACTIONS(6781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6783),
    [anon_sym_COMMA] = ACTIONS(6783),
    [anon_sym_RPAREN] = ACTIONS(6783),
    [aux_sym_preproc_if_token2] = ACTIONS(6783),
    [aux_sym_preproc_else_token1] = ACTIONS(6783),
    [aux_sym_preproc_elif_token1] = ACTIONS(6781),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6783),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6783),
    [anon_sym_LPAREN2] = ACTIONS(6785),
    [anon_sym_DASH] = ACTIONS(6781),
    [anon_sym_PLUS] = ACTIONS(6781),
    [anon_sym_STAR] = ACTIONS(6781),
    [anon_sym_SLASH] = ACTIONS(6781),
    [anon_sym_PERCENT] = ACTIONS(6781),
    [anon_sym_PIPE_PIPE] = ACTIONS(6783),
    [anon_sym_AMP_AMP] = ACTIONS(6783),
    [anon_sym_PIPE] = ACTIONS(6781),
    [anon_sym_CARET] = ACTIONS(6781),
    [anon_sym_AMP] = ACTIONS(6781),
    [anon_sym_EQ_EQ] = ACTIONS(6783),
    [anon_sym_BANG_EQ] = ACTIONS(6783),
    [anon_sym_GT] = ACTIONS(6781),
    [anon_sym_GT_EQ] = ACTIONS(6783),
    [anon_sym_LT_EQ] = ACTIONS(6781),
    [anon_sym_LT] = ACTIONS(6781),
    [anon_sym_LT_LT] = ACTIONS(6781),
    [anon_sym_GT_GT] = ACTIONS(6781),
    [anon_sym_COLON] = ACTIONS(6783),
    [anon_sym_SEMI] = ACTIONS(6783),
    [anon_sym___attribute__] = ACTIONS(6781),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6787),
    [anon_sym_RBRACE] = ACTIONS(6783),
    [anon_sym_LBRACK] = ACTIONS(6789),
    [anon_sym_RBRACK] = ACTIONS(6783),
    [anon_sym_EQ] = ACTIONS(6781),
    [anon_sym_QMARK] = ACTIONS(6783),
    [anon_sym_STAR_EQ] = ACTIONS(6783),
    [anon_sym_SLASH_EQ] = ACTIONS(6783),
    [anon_sym_PERCENT_EQ] = ACTIONS(6783),
    [anon_sym_PLUS_EQ] = ACTIONS(6783),
    [anon_sym_DASH_EQ] = ACTIONS(6783),
    [anon_sym_LT_LT_EQ] = ACTIONS(6783),
    [anon_sym_GT_GT_EQ] = ACTIONS(6783),
    [anon_sym_AMP_EQ] = ACTIONS(6783),
    [anon_sym_CARET_EQ] = ACTIONS(6783),
    [anon_sym_PIPE_EQ] = ACTIONS(6783),
    [anon_sym_and_eq] = ACTIONS(6781),
    [anon_sym_or_eq] = ACTIONS(6781),
    [anon_sym_xor_eq] = ACTIONS(6781),
    [anon_sym_LT_EQ_GT] = ACTIONS(6783),
    [anon_sym_or] = ACTIONS(6781),
    [anon_sym_and] = ACTIONS(6781),
    [anon_sym_bitor] = ACTIONS(6781),
    [anon_sym_xor] = ACTIONS(6781),
    [anon_sym_bitand] = ACTIONS(6781),
    [anon_sym_not_eq] = ACTIONS(6781),
    [anon_sym_is] = ACTIONS(6781),
    [anon_sym_as] = ACTIONS(6781),
    [anon_sym_DASH_DASH] = ACTIONS(6783),
    [anon_sym_PLUS_PLUS] = ACTIONS(6783),
    [anon_sym_DOT] = ACTIONS(6781),
    [anon_sym_DOT_STAR] = ACTIONS(6783),
    [anon_sym_DASH_GT] = ACTIONS(6783),
    [sym_comment] = ACTIONS(3),
  },
  [3086] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6513),
    [anon_sym_COMMA] = ACTIONS(6513),
    [anon_sym_RPAREN] = ACTIONS(6513),
    [anon_sym_LPAREN2] = ACTIONS(6513),
    [anon_sym_DASH] = ACTIONS(6511),
    [anon_sym_PLUS] = ACTIONS(6511),
    [anon_sym_STAR] = ACTIONS(6511),
    [anon_sym_SLASH] = ACTIONS(6511),
    [anon_sym_PERCENT] = ACTIONS(6511),
    [anon_sym_PIPE_PIPE] = ACTIONS(6513),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_PIPE] = ACTIONS(6511),
    [anon_sym_CARET] = ACTIONS(6511),
    [anon_sym_AMP] = ACTIONS(6511),
    [anon_sym_EQ_EQ] = ACTIONS(6513),
    [anon_sym_BANG_EQ] = ACTIONS(6513),
    [anon_sym_GT] = ACTIONS(6511),
    [anon_sym_GT_EQ] = ACTIONS(6513),
    [anon_sym_LT_EQ] = ACTIONS(6511),
    [anon_sym_LT] = ACTIONS(6511),
    [anon_sym_LT_LT] = ACTIONS(6511),
    [anon_sym_GT_GT] = ACTIONS(6511),
    [anon_sym_COLON] = ACTIONS(6513),
    [anon_sym_SEMI] = ACTIONS(6513),
    [anon_sym_RBRACE] = ACTIONS(6513),
    [anon_sym_LBRACK] = ACTIONS(6513),
    [anon_sym_RBRACK] = ACTIONS(6513),
    [anon_sym_EQ] = ACTIONS(6511),
    [anon_sym_QMARK] = ACTIONS(6513),
    [anon_sym_STAR_EQ] = ACTIONS(6513),
    [anon_sym_SLASH_EQ] = ACTIONS(6513),
    [anon_sym_PERCENT_EQ] = ACTIONS(6513),
    [anon_sym_PLUS_EQ] = ACTIONS(6513),
    [anon_sym_DASH_EQ] = ACTIONS(6513),
    [anon_sym_LT_LT_EQ] = ACTIONS(6513),
    [anon_sym_GT_GT_EQ] = ACTIONS(6513),
    [anon_sym_AMP_EQ] = ACTIONS(6513),
    [anon_sym_CARET_EQ] = ACTIONS(6513),
    [anon_sym_PIPE_EQ] = ACTIONS(6513),
    [anon_sym_and_eq] = ACTIONS(6511),
    [anon_sym_or_eq] = ACTIONS(6511),
    [anon_sym_xor_eq] = ACTIONS(6511),
    [anon_sym_LT_EQ_GT] = ACTIONS(6513),
    [anon_sym_or] = ACTIONS(6511),
    [anon_sym_and] = ACTIONS(6511),
    [anon_sym_bitor] = ACTIONS(6511),
    [anon_sym_xor] = ACTIONS(6511),
    [anon_sym_bitand] = ACTIONS(6511),
    [anon_sym_not_eq] = ACTIONS(6511),
    [anon_sym_is] = ACTIONS(6511),
    [anon_sym_as] = ACTIONS(6511),
    [anon_sym_DASH_DASH] = ACTIONS(6513),
    [anon_sym_PLUS_PLUS] = ACTIONS(6513),
    [anon_sym_DOT] = ACTIONS(6511),
    [anon_sym_DOT_STAR] = ACTIONS(6513),
    [anon_sym_DASH_GT] = ACTIONS(6513),
    [anon_sym_L_DQUOTE] = ACTIONS(6513),
    [anon_sym_u_DQUOTE] = ACTIONS(6513),
    [anon_sym_U_DQUOTE] = ACTIONS(6513),
    [anon_sym_u8_DQUOTE] = ACTIONS(6513),
    [anon_sym_DQUOTE] = ACTIONS(6513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6513),
    [anon_sym_LR_DQUOTE] = ACTIONS(6513),
    [anon_sym_uR_DQUOTE] = ACTIONS(6513),
    [anon_sym_UR_DQUOTE] = ACTIONS(6513),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6513),
    [sym_literal_suffix] = ACTIONS(6511),
  },
  [3087] = {
    [sym_identifier] = ACTIONS(3206),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3204),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_RPAREN] = ACTIONS(3204),
    [aux_sym_preproc_if_token2] = ACTIONS(3204),
    [aux_sym_preproc_else_token1] = ACTIONS(3204),
    [aux_sym_preproc_elif_token1] = ACTIONS(3206),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3204),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3204),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_DASH] = ACTIONS(3206),
    [anon_sym_PLUS] = ACTIONS(3206),
    [anon_sym_STAR] = ACTIONS(3206),
    [anon_sym_SLASH] = ACTIONS(3206),
    [anon_sym_PERCENT] = ACTIONS(3206),
    [anon_sym_PIPE_PIPE] = ACTIONS(3204),
    [anon_sym_AMP_AMP] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(3206),
    [anon_sym_CARET] = ACTIONS(3206),
    [anon_sym_AMP] = ACTIONS(3206),
    [anon_sym_EQ_EQ] = ACTIONS(3204),
    [anon_sym_BANG_EQ] = ACTIONS(3204),
    [anon_sym_GT] = ACTIONS(3206),
    [anon_sym_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_EQ] = ACTIONS(3206),
    [anon_sym_LT] = ACTIONS(3206),
    [anon_sym_LT_LT] = ACTIONS(3206),
    [anon_sym_GT_GT] = ACTIONS(3206),
    [anon_sym_COLON] = ACTIONS(3204),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym___attribute__] = ACTIONS(3206),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_RBRACE] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_RBRACK] = ACTIONS(3204),
    [anon_sym_EQ] = ACTIONS(3206),
    [anon_sym_QMARK] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_and_eq] = ACTIONS(3206),
    [anon_sym_or_eq] = ACTIONS(3206),
    [anon_sym_xor_eq] = ACTIONS(3206),
    [anon_sym_LT_EQ_GT] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3206),
    [anon_sym_and] = ACTIONS(3206),
    [anon_sym_bitor] = ACTIONS(3206),
    [anon_sym_xor] = ACTIONS(3206),
    [anon_sym_bitand] = ACTIONS(3206),
    [anon_sym_not_eq] = ACTIONS(3206),
    [anon_sym_is] = ACTIONS(3206),
    [anon_sym_as] = ACTIONS(3206),
    [anon_sym_DASH_DASH] = ACTIONS(3204),
    [anon_sym_PLUS_PLUS] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(3206),
    [anon_sym_DOT_STAR] = ACTIONS(3204),
    [anon_sym_DASH_GT] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3206),
    [anon_sym_let] = ACTIONS(3206),
    [anon_sym_This] = ACTIONS(3206),
  },
  [3088] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3088),
    [sym_identifier] = ACTIONS(2856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2854),
    [anon_sym_COMMA] = ACTIONS(2854),
    [aux_sym_preproc_if_token2] = ACTIONS(2854),
    [aux_sym_preproc_else_token1] = ACTIONS(2854),
    [aux_sym_preproc_elif_token1] = ACTIONS(2856),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2854),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2854),
    [anon_sym_LPAREN2] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(2856),
    [anon_sym_PLUS] = ACTIONS(2856),
    [anon_sym_STAR] = ACTIONS(2856),
    [anon_sym_SLASH] = ACTIONS(2856),
    [anon_sym_PERCENT] = ACTIONS(2856),
    [anon_sym_PIPE_PIPE] = ACTIONS(2854),
    [anon_sym_AMP_AMP] = ACTIONS(2854),
    [anon_sym_PIPE] = ACTIONS(2856),
    [anon_sym_CARET] = ACTIONS(2856),
    [anon_sym_AMP] = ACTIONS(2856),
    [anon_sym_EQ_EQ] = ACTIONS(2854),
    [anon_sym_BANG_EQ] = ACTIONS(2854),
    [anon_sym_GT] = ACTIONS(2856),
    [anon_sym_GT_EQ] = ACTIONS(2854),
    [anon_sym_LT_EQ] = ACTIONS(2856),
    [anon_sym_LT] = ACTIONS(2856),
    [anon_sym_LT_LT] = ACTIONS(2856),
    [anon_sym_GT_GT] = ACTIONS(2856),
    [anon_sym___attribute__] = ACTIONS(2856),
    [anon_sym_LBRACE] = ACTIONS(2854),
    [anon_sym_signed] = ACTIONS(6791),
    [anon_sym_unsigned] = ACTIONS(6791),
    [anon_sym_long] = ACTIONS(6791),
    [anon_sym_short] = ACTIONS(6791),
    [anon_sym_LBRACK] = ACTIONS(2854),
    [anon_sym_EQ] = ACTIONS(2856),
    [anon_sym_QMARK] = ACTIONS(2854),
    [anon_sym_STAR_EQ] = ACTIONS(2854),
    [anon_sym_SLASH_EQ] = ACTIONS(2854),
    [anon_sym_PERCENT_EQ] = ACTIONS(2854),
    [anon_sym_PLUS_EQ] = ACTIONS(2854),
    [anon_sym_DASH_EQ] = ACTIONS(2854),
    [anon_sym_LT_LT_EQ] = ACTIONS(2854),
    [anon_sym_GT_GT_EQ] = ACTIONS(2854),
    [anon_sym_AMP_EQ] = ACTIONS(2854),
    [anon_sym_CARET_EQ] = ACTIONS(2854),
    [anon_sym_PIPE_EQ] = ACTIONS(2854),
    [anon_sym_and_eq] = ACTIONS(2856),
    [anon_sym_or_eq] = ACTIONS(2856),
    [anon_sym_xor_eq] = ACTIONS(2856),
    [anon_sym_LT_EQ_GT] = ACTIONS(2854),
    [anon_sym_or] = ACTIONS(2856),
    [anon_sym_and] = ACTIONS(2856),
    [anon_sym_bitor] = ACTIONS(2856),
    [anon_sym_xor] = ACTIONS(2856),
    [anon_sym_bitand] = ACTIONS(2856),
    [anon_sym_not_eq] = ACTIONS(2856),
    [anon_sym_is] = ACTIONS(2856),
    [anon_sym_as] = ACTIONS(2856),
    [anon_sym_DASH_DASH] = ACTIONS(2854),
    [anon_sym_PLUS_PLUS] = ACTIONS(2854),
    [anon_sym_DOT] = ACTIONS(2856),
    [anon_sym_DOT_STAR] = ACTIONS(2854),
    [anon_sym_DASH_GT] = ACTIONS(2854),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2856),
    [anon_sym_let] = ACTIONS(2856),
    [anon_sym_This] = ACTIONS(2856),
  },
  [3089] = {
    [sym_attribute_declaration] = STATE(3119),
    [sym_parameter_list] = STATE(3131),
    [aux_sym_attributed_declarator_repeat1] = STATE(3119),
    [sym_identifier] = ACTIONS(6794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6796),
    [anon_sym_COMMA] = ACTIONS(6796),
    [anon_sym_RPAREN] = ACTIONS(6796),
    [aux_sym_preproc_if_token2] = ACTIONS(6796),
    [aux_sym_preproc_else_token1] = ACTIONS(6796),
    [aux_sym_preproc_elif_token1] = ACTIONS(6794),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6796),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6796),
    [anon_sym_LPAREN2] = ACTIONS(6785),
    [anon_sym_DASH] = ACTIONS(6794),
    [anon_sym_PLUS] = ACTIONS(6794),
    [anon_sym_STAR] = ACTIONS(6794),
    [anon_sym_SLASH] = ACTIONS(6794),
    [anon_sym_PERCENT] = ACTIONS(6794),
    [anon_sym_PIPE_PIPE] = ACTIONS(6796),
    [anon_sym_AMP_AMP] = ACTIONS(6796),
    [anon_sym_PIPE] = ACTIONS(6794),
    [anon_sym_CARET] = ACTIONS(6794),
    [anon_sym_AMP] = ACTIONS(6794),
    [anon_sym_EQ_EQ] = ACTIONS(6796),
    [anon_sym_BANG_EQ] = ACTIONS(6796),
    [anon_sym_GT] = ACTIONS(6794),
    [anon_sym_GT_EQ] = ACTIONS(6796),
    [anon_sym_LT_EQ] = ACTIONS(6794),
    [anon_sym_LT] = ACTIONS(6794),
    [anon_sym_LT_LT] = ACTIONS(6794),
    [anon_sym_GT_GT] = ACTIONS(6794),
    [anon_sym_COLON] = ACTIONS(6796),
    [anon_sym_SEMI] = ACTIONS(6796),
    [anon_sym___attribute__] = ACTIONS(6794),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6787),
    [anon_sym_RBRACE] = ACTIONS(6796),
    [anon_sym_LBRACK] = ACTIONS(6789),
    [anon_sym_RBRACK] = ACTIONS(6796),
    [anon_sym_EQ] = ACTIONS(6794),
    [anon_sym_QMARK] = ACTIONS(6796),
    [anon_sym_STAR_EQ] = ACTIONS(6796),
    [anon_sym_SLASH_EQ] = ACTIONS(6796),
    [anon_sym_PERCENT_EQ] = ACTIONS(6796),
    [anon_sym_PLUS_EQ] = ACTIONS(6796),
    [anon_sym_DASH_EQ] = ACTIONS(6796),
    [anon_sym_LT_LT_EQ] = ACTIONS(6796),
    [anon_sym_GT_GT_EQ] = ACTIONS(6796),
    [anon_sym_AMP_EQ] = ACTIONS(6796),
    [anon_sym_CARET_EQ] = ACTIONS(6796),
    [anon_sym_PIPE_EQ] = ACTIONS(6796),
    [anon_sym_and_eq] = ACTIONS(6794),
    [anon_sym_or_eq] = ACTIONS(6794),
    [anon_sym_xor_eq] = ACTIONS(6794),
    [anon_sym_LT_EQ_GT] = ACTIONS(6796),
    [anon_sym_or] = ACTIONS(6794),
    [anon_sym_and] = ACTIONS(6794),
    [anon_sym_bitor] = ACTIONS(6794),
    [anon_sym_xor] = ACTIONS(6794),
    [anon_sym_bitand] = ACTIONS(6794),
    [anon_sym_not_eq] = ACTIONS(6794),
    [anon_sym_is] = ACTIONS(6794),
    [anon_sym_as] = ACTIONS(6794),
    [anon_sym_DASH_DASH] = ACTIONS(6796),
    [anon_sym_PLUS_PLUS] = ACTIONS(6796),
    [anon_sym_DOT] = ACTIONS(6794),
    [anon_sym_DOT_STAR] = ACTIONS(6796),
    [anon_sym_DASH_GT] = ACTIONS(6796),
    [sym_comment] = ACTIONS(3),
  },
  [3090] = {
    [sym_attribute_specifier] = STATE(2896),
    [sym_enumerator_list] = STATE(3151),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3713),
    [anon_sym_COMMA] = ACTIONS(3713),
    [anon_sym_RPAREN] = ACTIONS(3713),
    [anon_sym_LPAREN2] = ACTIONS(3713),
    [anon_sym_DASH] = ACTIONS(3711),
    [anon_sym_PLUS] = ACTIONS(3711),
    [anon_sym_STAR] = ACTIONS(3713),
    [anon_sym_SLASH] = ACTIONS(3711),
    [anon_sym_PERCENT] = ACTIONS(3713),
    [anon_sym_PIPE_PIPE] = ACTIONS(3713),
    [anon_sym_AMP_AMP] = ACTIONS(3713),
    [anon_sym_PIPE] = ACTIONS(3711),
    [anon_sym_CARET] = ACTIONS(3713),
    [anon_sym_AMP] = ACTIONS(3711),
    [anon_sym_EQ_EQ] = ACTIONS(3713),
    [anon_sym_BANG_EQ] = ACTIONS(3713),
    [anon_sym_GT] = ACTIONS(3711),
    [anon_sym_GT_EQ] = ACTIONS(3713),
    [anon_sym_LT_EQ] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3711),
    [anon_sym_LT_LT] = ACTIONS(3713),
    [anon_sym_GT_GT] = ACTIONS(3713),
    [anon_sym_COLON] = ACTIONS(3713),
    [anon_sym_SEMI] = ACTIONS(3713),
    [anon_sym___extension__] = ACTIONS(3713),
    [anon_sym___attribute__] = ACTIONS(6621),
    [anon_sym_LBRACE] = ACTIONS(6750),
    [anon_sym_RBRACE] = ACTIONS(3713),
    [anon_sym_LBRACK] = ACTIONS(3713),
    [anon_sym_RBRACK] = ACTIONS(3713),
    [anon_sym_const] = ACTIONS(3711),
    [anon_sym_constexpr] = ACTIONS(3713),
    [anon_sym_volatile] = ACTIONS(3713),
    [anon_sym_restrict] = ACTIONS(3713),
    [anon_sym___restrict__] = ACTIONS(3713),
    [anon_sym__Atomic] = ACTIONS(3713),
    [anon_sym__Noreturn] = ACTIONS(3713),
    [anon_sym_noreturn] = ACTIONS(3713),
    [anon_sym_mutable] = ACTIONS(3713),
    [anon_sym_constinit] = ACTIONS(3713),
    [anon_sym_consteval] = ACTIONS(3713),
    [anon_sym_alignas] = ACTIONS(3713),
    [anon_sym__Alignas] = ACTIONS(3713),
    [anon_sym_QMARK] = ACTIONS(3713),
    [anon_sym_LT_EQ_GT] = ACTIONS(3713),
    [anon_sym_or] = ACTIONS(3713),
    [anon_sym_and] = ACTIONS(3713),
    [anon_sym_bitor] = ACTIONS(3713),
    [anon_sym_xor] = ACTIONS(3713),
    [anon_sym_bitand] = ACTIONS(3713),
    [anon_sym_not_eq] = ACTIONS(3713),
    [anon_sym_is] = ACTIONS(3713),
    [anon_sym_as] = ACTIONS(3713),
    [anon_sym_DASH_DASH] = ACTIONS(3713),
    [anon_sym_PLUS_PLUS] = ACTIONS(3713),
    [anon_sym_DOT] = ACTIONS(3711),
    [anon_sym_DOT_STAR] = ACTIONS(3713),
    [anon_sym_DASH_GT] = ACTIONS(3713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3713),
    [anon_sym_let] = ACTIONS(3713),
    [anon_sym_This] = ACTIONS(3713),
    [anon_sym_final] = ACTIONS(3713),
    [anon_sym_override] = ACTIONS(3713),
    [anon_sym_requires] = ACTIONS(3713),
    [anon_sym_where] = ACTIONS(3713),
  },
  [3091] = {
    [sym_identifier] = ACTIONS(2742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2740),
    [anon_sym_COMMA] = ACTIONS(2740),
    [anon_sym_RPAREN] = ACTIONS(2740),
    [aux_sym_preproc_if_token2] = ACTIONS(2740),
    [aux_sym_preproc_else_token1] = ACTIONS(2740),
    [aux_sym_preproc_elif_token1] = ACTIONS(2742),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2740),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2740),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2742),
    [anon_sym_PLUS] = ACTIONS(2742),
    [anon_sym_STAR] = ACTIONS(2742),
    [anon_sym_SLASH] = ACTIONS(2742),
    [anon_sym_PERCENT] = ACTIONS(2742),
    [anon_sym_PIPE_PIPE] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_PIPE] = ACTIONS(2742),
    [anon_sym_CARET] = ACTIONS(2742),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_EQ_EQ] = ACTIONS(2740),
    [anon_sym_BANG_EQ] = ACTIONS(2740),
    [anon_sym_GT] = ACTIONS(2742),
    [anon_sym_GT_EQ] = ACTIONS(2740),
    [anon_sym_LT_EQ] = ACTIONS(2742),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_LT_LT] = ACTIONS(2742),
    [anon_sym_GT_GT] = ACTIONS(2742),
    [anon_sym_COLON] = ACTIONS(2740),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym_LBRACE] = ACTIONS(2740),
    [anon_sym_RBRACE] = ACTIONS(2740),
    [anon_sym_LBRACK] = ACTIONS(2740),
    [anon_sym_RBRACK] = ACTIONS(2740),
    [anon_sym_EQ] = ACTIONS(2742),
    [anon_sym_QMARK] = ACTIONS(2740),
    [anon_sym_STAR_EQ] = ACTIONS(2740),
    [anon_sym_SLASH_EQ] = ACTIONS(2740),
    [anon_sym_PERCENT_EQ] = ACTIONS(2740),
    [anon_sym_PLUS_EQ] = ACTIONS(2740),
    [anon_sym_DASH_EQ] = ACTIONS(2740),
    [anon_sym_LT_LT_EQ] = ACTIONS(2740),
    [anon_sym_GT_GT_EQ] = ACTIONS(2740),
    [anon_sym_AMP_EQ] = ACTIONS(2740),
    [anon_sym_CARET_EQ] = ACTIONS(2740),
    [anon_sym_PIPE_EQ] = ACTIONS(2740),
    [anon_sym_and_eq] = ACTIONS(2742),
    [anon_sym_or_eq] = ACTIONS(2742),
    [anon_sym_xor_eq] = ACTIONS(2742),
    [anon_sym_LT_EQ_GT] = ACTIONS(2740),
    [anon_sym_or] = ACTIONS(2742),
    [anon_sym_and] = ACTIONS(2742),
    [anon_sym_bitor] = ACTIONS(2742),
    [anon_sym_xor] = ACTIONS(2742),
    [anon_sym_bitand] = ACTIONS(2742),
    [anon_sym_not_eq] = ACTIONS(2742),
    [anon_sym_is] = ACTIONS(2742),
    [anon_sym_as] = ACTIONS(2742),
    [anon_sym_DASH_DASH] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2740),
    [anon_sym_DOT] = ACTIONS(2742),
    [anon_sym_DOT_STAR] = ACTIONS(2740),
    [anon_sym_DASH_GT] = ACTIONS(2740),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
  },
  [3092] = {
    [sym_attribute_declaration] = STATE(3119),
    [sym_parameter_list] = STATE(3131),
    [aux_sym_attributed_declarator_repeat1] = STATE(3119),
    [sym_identifier] = ACTIONS(6798),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6800),
    [anon_sym_COMMA] = ACTIONS(6800),
    [anon_sym_RPAREN] = ACTIONS(6800),
    [aux_sym_preproc_if_token2] = ACTIONS(6800),
    [aux_sym_preproc_else_token1] = ACTIONS(6800),
    [aux_sym_preproc_elif_token1] = ACTIONS(6798),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6800),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6800),
    [anon_sym_LPAREN2] = ACTIONS(6785),
    [anon_sym_DASH] = ACTIONS(6798),
    [anon_sym_PLUS] = ACTIONS(6798),
    [anon_sym_STAR] = ACTIONS(6798),
    [anon_sym_SLASH] = ACTIONS(6798),
    [anon_sym_PERCENT] = ACTIONS(6798),
    [anon_sym_PIPE_PIPE] = ACTIONS(6800),
    [anon_sym_AMP_AMP] = ACTIONS(6800),
    [anon_sym_PIPE] = ACTIONS(6798),
    [anon_sym_CARET] = ACTIONS(6798),
    [anon_sym_AMP] = ACTIONS(6798),
    [anon_sym_EQ_EQ] = ACTIONS(6800),
    [anon_sym_BANG_EQ] = ACTIONS(6800),
    [anon_sym_GT] = ACTIONS(6798),
    [anon_sym_GT_EQ] = ACTIONS(6800),
    [anon_sym_LT_EQ] = ACTIONS(6798),
    [anon_sym_LT] = ACTIONS(6798),
    [anon_sym_LT_LT] = ACTIONS(6798),
    [anon_sym_GT_GT] = ACTIONS(6798),
    [anon_sym_COLON] = ACTIONS(6800),
    [anon_sym_SEMI] = ACTIONS(6800),
    [anon_sym___attribute__] = ACTIONS(6798),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6787),
    [anon_sym_RBRACE] = ACTIONS(6800),
    [anon_sym_LBRACK] = ACTIONS(6789),
    [anon_sym_RBRACK] = ACTIONS(6800),
    [anon_sym_EQ] = ACTIONS(6798),
    [anon_sym_QMARK] = ACTIONS(6800),
    [anon_sym_STAR_EQ] = ACTIONS(6800),
    [anon_sym_SLASH_EQ] = ACTIONS(6800),
    [anon_sym_PERCENT_EQ] = ACTIONS(6800),
    [anon_sym_PLUS_EQ] = ACTIONS(6800),
    [anon_sym_DASH_EQ] = ACTIONS(6800),
    [anon_sym_LT_LT_EQ] = ACTIONS(6800),
    [anon_sym_GT_GT_EQ] = ACTIONS(6800),
    [anon_sym_AMP_EQ] = ACTIONS(6800),
    [anon_sym_CARET_EQ] = ACTIONS(6800),
    [anon_sym_PIPE_EQ] = ACTIONS(6800),
    [anon_sym_and_eq] = ACTIONS(6798),
    [anon_sym_or_eq] = ACTIONS(6798),
    [anon_sym_xor_eq] = ACTIONS(6798),
    [anon_sym_LT_EQ_GT] = ACTIONS(6800),
    [anon_sym_or] = ACTIONS(6798),
    [anon_sym_and] = ACTIONS(6798),
    [anon_sym_bitor] = ACTIONS(6798),
    [anon_sym_xor] = ACTIONS(6798),
    [anon_sym_bitand] = ACTIONS(6798),
    [anon_sym_not_eq] = ACTIONS(6798),
    [anon_sym_is] = ACTIONS(6798),
    [anon_sym_as] = ACTIONS(6798),
    [anon_sym_DASH_DASH] = ACTIONS(6800),
    [anon_sym_PLUS_PLUS] = ACTIONS(6800),
    [anon_sym_DOT] = ACTIONS(6798),
    [anon_sym_DOT_STAR] = ACTIONS(6800),
    [anon_sym_DASH_GT] = ACTIONS(6800),
    [sym_comment] = ACTIONS(3),
  },
  [3093] = {
    [sym_identifier] = ACTIONS(3404),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3402),
    [anon_sym_COMMA] = ACTIONS(3402),
    [anon_sym_RPAREN] = ACTIONS(3402),
    [aux_sym_preproc_if_token2] = ACTIONS(3402),
    [aux_sym_preproc_else_token1] = ACTIONS(3402),
    [aux_sym_preproc_elif_token1] = ACTIONS(3404),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3402),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3402),
    [anon_sym_LPAREN2] = ACTIONS(3402),
    [anon_sym_DASH] = ACTIONS(3404),
    [anon_sym_PLUS] = ACTIONS(3404),
    [anon_sym_STAR] = ACTIONS(3404),
    [anon_sym_SLASH] = ACTIONS(3404),
    [anon_sym_PERCENT] = ACTIONS(3404),
    [anon_sym_PIPE_PIPE] = ACTIONS(3402),
    [anon_sym_AMP_AMP] = ACTIONS(3402),
    [anon_sym_PIPE] = ACTIONS(3404),
    [anon_sym_CARET] = ACTIONS(3404),
    [anon_sym_AMP] = ACTIONS(3404),
    [anon_sym_EQ_EQ] = ACTIONS(3402),
    [anon_sym_BANG_EQ] = ACTIONS(3402),
    [anon_sym_GT] = ACTIONS(3404),
    [anon_sym_GT_EQ] = ACTIONS(3402),
    [anon_sym_LT_EQ] = ACTIONS(3404),
    [anon_sym_LT] = ACTIONS(3404),
    [anon_sym_LT_LT] = ACTIONS(3404),
    [anon_sym_GT_GT] = ACTIONS(3404),
    [anon_sym_COLON] = ACTIONS(3402),
    [anon_sym_SEMI] = ACTIONS(3402),
    [anon_sym___attribute__] = ACTIONS(3404),
    [anon_sym_LBRACE] = ACTIONS(3402),
    [anon_sym_RBRACE] = ACTIONS(3402),
    [anon_sym_LBRACK] = ACTIONS(3402),
    [anon_sym_RBRACK] = ACTIONS(3402),
    [anon_sym_EQ] = ACTIONS(3404),
    [anon_sym_QMARK] = ACTIONS(3402),
    [anon_sym_STAR_EQ] = ACTIONS(3402),
    [anon_sym_SLASH_EQ] = ACTIONS(3402),
    [anon_sym_PERCENT_EQ] = ACTIONS(3402),
    [anon_sym_PLUS_EQ] = ACTIONS(3402),
    [anon_sym_DASH_EQ] = ACTIONS(3402),
    [anon_sym_LT_LT_EQ] = ACTIONS(3402),
    [anon_sym_GT_GT_EQ] = ACTIONS(3402),
    [anon_sym_AMP_EQ] = ACTIONS(3402),
    [anon_sym_CARET_EQ] = ACTIONS(3402),
    [anon_sym_PIPE_EQ] = ACTIONS(3402),
    [anon_sym_and_eq] = ACTIONS(3404),
    [anon_sym_or_eq] = ACTIONS(3404),
    [anon_sym_xor_eq] = ACTIONS(3404),
    [anon_sym_LT_EQ_GT] = ACTIONS(3402),
    [anon_sym_or] = ACTIONS(3404),
    [anon_sym_and] = ACTIONS(3404),
    [anon_sym_bitor] = ACTIONS(3404),
    [anon_sym_xor] = ACTIONS(3404),
    [anon_sym_bitand] = ACTIONS(3404),
    [anon_sym_not_eq] = ACTIONS(3404),
    [anon_sym_is] = ACTIONS(3404),
    [anon_sym_as] = ACTIONS(3404),
    [anon_sym_DASH_DASH] = ACTIONS(3402),
    [anon_sym_PLUS_PLUS] = ACTIONS(3402),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_DOT_STAR] = ACTIONS(3402),
    [anon_sym_DASH_GT] = ACTIONS(3402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3404),
    [anon_sym_let] = ACTIONS(3404),
    [anon_sym_This] = ACTIONS(3404),
  },
  [3094] = {
    [sym_attribute_declaration] = STATE(3119),
    [sym_parameter_list] = STATE(3131),
    [aux_sym_attributed_declarator_repeat1] = STATE(3119),
    [sym_identifier] = ACTIONS(6802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6804),
    [anon_sym_COMMA] = ACTIONS(6804),
    [anon_sym_RPAREN] = ACTIONS(6804),
    [aux_sym_preproc_if_token2] = ACTIONS(6804),
    [aux_sym_preproc_else_token1] = ACTIONS(6804),
    [aux_sym_preproc_elif_token1] = ACTIONS(6802),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6804),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6804),
    [anon_sym_LPAREN2] = ACTIONS(6785),
    [anon_sym_DASH] = ACTIONS(6802),
    [anon_sym_PLUS] = ACTIONS(6802),
    [anon_sym_STAR] = ACTIONS(6802),
    [anon_sym_SLASH] = ACTIONS(6802),
    [anon_sym_PERCENT] = ACTIONS(6802),
    [anon_sym_PIPE_PIPE] = ACTIONS(6804),
    [anon_sym_AMP_AMP] = ACTIONS(6804),
    [anon_sym_PIPE] = ACTIONS(6802),
    [anon_sym_CARET] = ACTIONS(6802),
    [anon_sym_AMP] = ACTIONS(6802),
    [anon_sym_EQ_EQ] = ACTIONS(6804),
    [anon_sym_BANG_EQ] = ACTIONS(6804),
    [anon_sym_GT] = ACTIONS(6802),
    [anon_sym_GT_EQ] = ACTIONS(6804),
    [anon_sym_LT_EQ] = ACTIONS(6802),
    [anon_sym_LT] = ACTIONS(6802),
    [anon_sym_LT_LT] = ACTIONS(6802),
    [anon_sym_GT_GT] = ACTIONS(6802),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_SEMI] = ACTIONS(6804),
    [anon_sym___attribute__] = ACTIONS(6802),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6787),
    [anon_sym_RBRACE] = ACTIONS(6804),
    [anon_sym_LBRACK] = ACTIONS(6789),
    [anon_sym_RBRACK] = ACTIONS(6804),
    [anon_sym_EQ] = ACTIONS(6802),
    [anon_sym_QMARK] = ACTIONS(6804),
    [anon_sym_STAR_EQ] = ACTIONS(6804),
    [anon_sym_SLASH_EQ] = ACTIONS(6804),
    [anon_sym_PERCENT_EQ] = ACTIONS(6804),
    [anon_sym_PLUS_EQ] = ACTIONS(6804),
    [anon_sym_DASH_EQ] = ACTIONS(6804),
    [anon_sym_LT_LT_EQ] = ACTIONS(6804),
    [anon_sym_GT_GT_EQ] = ACTIONS(6804),
    [anon_sym_AMP_EQ] = ACTIONS(6804),
    [anon_sym_CARET_EQ] = ACTIONS(6804),
    [anon_sym_PIPE_EQ] = ACTIONS(6804),
    [anon_sym_and_eq] = ACTIONS(6802),
    [anon_sym_or_eq] = ACTIONS(6802),
    [anon_sym_xor_eq] = ACTIONS(6802),
    [anon_sym_LT_EQ_GT] = ACTIONS(6804),
    [anon_sym_or] = ACTIONS(6802),
    [anon_sym_and] = ACTIONS(6802),
    [anon_sym_bitor] = ACTIONS(6802),
    [anon_sym_xor] = ACTIONS(6802),
    [anon_sym_bitand] = ACTIONS(6802),
    [anon_sym_not_eq] = ACTIONS(6802),
    [anon_sym_is] = ACTIONS(6802),
    [anon_sym_as] = ACTIONS(6802),
    [anon_sym_DASH_DASH] = ACTIONS(6804),
    [anon_sym_PLUS_PLUS] = ACTIONS(6804),
    [anon_sym_DOT] = ACTIONS(6802),
    [anon_sym_DOT_STAR] = ACTIONS(6804),
    [anon_sym_DASH_GT] = ACTIONS(6804),
    [sym_comment] = ACTIONS(3),
  },
  [3095] = {
    [sym_identifier] = ACTIONS(3400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3398),
    [anon_sym_COMMA] = ACTIONS(3398),
    [anon_sym_RPAREN] = ACTIONS(3398),
    [aux_sym_preproc_if_token2] = ACTIONS(3398),
    [aux_sym_preproc_else_token1] = ACTIONS(3398),
    [aux_sym_preproc_elif_token1] = ACTIONS(3400),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3398),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3398),
    [anon_sym_LPAREN2] = ACTIONS(3398),
    [anon_sym_DASH] = ACTIONS(3400),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_STAR] = ACTIONS(3400),
    [anon_sym_SLASH] = ACTIONS(3400),
    [anon_sym_PERCENT] = ACTIONS(3400),
    [anon_sym_PIPE_PIPE] = ACTIONS(3398),
    [anon_sym_AMP_AMP] = ACTIONS(3398),
    [anon_sym_PIPE] = ACTIONS(3400),
    [anon_sym_CARET] = ACTIONS(3400),
    [anon_sym_AMP] = ACTIONS(3400),
    [anon_sym_EQ_EQ] = ACTIONS(3398),
    [anon_sym_BANG_EQ] = ACTIONS(3398),
    [anon_sym_GT] = ACTIONS(3400),
    [anon_sym_GT_EQ] = ACTIONS(3398),
    [anon_sym_LT_EQ] = ACTIONS(3400),
    [anon_sym_LT] = ACTIONS(3400),
    [anon_sym_LT_LT] = ACTIONS(3400),
    [anon_sym_GT_GT] = ACTIONS(3400),
    [anon_sym_COLON] = ACTIONS(3398),
    [anon_sym_SEMI] = ACTIONS(3398),
    [anon_sym___attribute__] = ACTIONS(3400),
    [anon_sym_LBRACE] = ACTIONS(3398),
    [anon_sym_RBRACE] = ACTIONS(3398),
    [anon_sym_LBRACK] = ACTIONS(3398),
    [anon_sym_RBRACK] = ACTIONS(3398),
    [anon_sym_EQ] = ACTIONS(3400),
    [anon_sym_QMARK] = ACTIONS(3398),
    [anon_sym_STAR_EQ] = ACTIONS(3398),
    [anon_sym_SLASH_EQ] = ACTIONS(3398),
    [anon_sym_PERCENT_EQ] = ACTIONS(3398),
    [anon_sym_PLUS_EQ] = ACTIONS(3398),
    [anon_sym_DASH_EQ] = ACTIONS(3398),
    [anon_sym_LT_LT_EQ] = ACTIONS(3398),
    [anon_sym_GT_GT_EQ] = ACTIONS(3398),
    [anon_sym_AMP_EQ] = ACTIONS(3398),
    [anon_sym_CARET_EQ] = ACTIONS(3398),
    [anon_sym_PIPE_EQ] = ACTIONS(3398),
    [anon_sym_and_eq] = ACTIONS(3400),
    [anon_sym_or_eq] = ACTIONS(3400),
    [anon_sym_xor_eq] = ACTIONS(3400),
    [anon_sym_LT_EQ_GT] = ACTIONS(3398),
    [anon_sym_or] = ACTIONS(3400),
    [anon_sym_and] = ACTIONS(3400),
    [anon_sym_bitor] = ACTIONS(3400),
    [anon_sym_xor] = ACTIONS(3400),
    [anon_sym_bitand] = ACTIONS(3400),
    [anon_sym_not_eq] = ACTIONS(3400),
    [anon_sym_is] = ACTIONS(3400),
    [anon_sym_as] = ACTIONS(3400),
    [anon_sym_DASH_DASH] = ACTIONS(3398),
    [anon_sym_PLUS_PLUS] = ACTIONS(3398),
    [anon_sym_DOT] = ACTIONS(3400),
    [anon_sym_DOT_STAR] = ACTIONS(3398),
    [anon_sym_DASH_GT] = ACTIONS(3398),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3400),
    [anon_sym_let] = ACTIONS(3400),
    [anon_sym_This] = ACTIONS(3400),
  },
  [3096] = {
    [sym_identifier] = ACTIONS(3054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3052),
    [anon_sym_COMMA] = ACTIONS(3052),
    [anon_sym_RPAREN] = ACTIONS(3052),
    [aux_sym_preproc_if_token2] = ACTIONS(3052),
    [aux_sym_preproc_else_token1] = ACTIONS(3052),
    [aux_sym_preproc_elif_token1] = ACTIONS(3054),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3052),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3052),
    [anon_sym_LPAREN2] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3054),
    [anon_sym_PLUS] = ACTIONS(3054),
    [anon_sym_STAR] = ACTIONS(3054),
    [anon_sym_SLASH] = ACTIONS(3054),
    [anon_sym_PERCENT] = ACTIONS(3054),
    [anon_sym_PIPE_PIPE] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_PIPE] = ACTIONS(3054),
    [anon_sym_CARET] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3054),
    [anon_sym_EQ_EQ] = ACTIONS(3052),
    [anon_sym_BANG_EQ] = ACTIONS(3052),
    [anon_sym_GT] = ACTIONS(3054),
    [anon_sym_GT_EQ] = ACTIONS(3052),
    [anon_sym_LT_EQ] = ACTIONS(3054),
    [anon_sym_LT] = ACTIONS(3054),
    [anon_sym_LT_LT] = ACTIONS(3054),
    [anon_sym_GT_GT] = ACTIONS(3054),
    [anon_sym_COLON] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym___attribute__] = ACTIONS(3054),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_RBRACE] = ACTIONS(3052),
    [anon_sym_LBRACK] = ACTIONS(3052),
    [anon_sym_RBRACK] = ACTIONS(3052),
    [anon_sym_EQ] = ACTIONS(3054),
    [anon_sym_QMARK] = ACTIONS(3052),
    [anon_sym_STAR_EQ] = ACTIONS(3052),
    [anon_sym_SLASH_EQ] = ACTIONS(3052),
    [anon_sym_PERCENT_EQ] = ACTIONS(3052),
    [anon_sym_PLUS_EQ] = ACTIONS(3052),
    [anon_sym_DASH_EQ] = ACTIONS(3052),
    [anon_sym_LT_LT_EQ] = ACTIONS(3052),
    [anon_sym_GT_GT_EQ] = ACTIONS(3052),
    [anon_sym_AMP_EQ] = ACTIONS(3052),
    [anon_sym_CARET_EQ] = ACTIONS(3052),
    [anon_sym_PIPE_EQ] = ACTIONS(3052),
    [anon_sym_and_eq] = ACTIONS(3054),
    [anon_sym_or_eq] = ACTIONS(3054),
    [anon_sym_xor_eq] = ACTIONS(3054),
    [anon_sym_LT_EQ_GT] = ACTIONS(3052),
    [anon_sym_or] = ACTIONS(3054),
    [anon_sym_and] = ACTIONS(3054),
    [anon_sym_bitor] = ACTIONS(3054),
    [anon_sym_xor] = ACTIONS(3054),
    [anon_sym_bitand] = ACTIONS(3054),
    [anon_sym_not_eq] = ACTIONS(3054),
    [anon_sym_is] = ACTIONS(3054),
    [anon_sym_as] = ACTIONS(3054),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_DOT] = ACTIONS(3054),
    [anon_sym_DOT_STAR] = ACTIONS(3052),
    [anon_sym_DASH_GT] = ACTIONS(3052),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3054),
    [anon_sym_let] = ACTIONS(3054),
    [anon_sym_This] = ACTIONS(3054),
  },
  [3097] = {
    [sym_attribute_declaration] = STATE(3119),
    [sym_parameter_list] = STATE(3131),
    [aux_sym_attributed_declarator_repeat1] = STATE(3119),
    [sym_identifier] = ACTIONS(6806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6808),
    [anon_sym_COMMA] = ACTIONS(6808),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [aux_sym_preproc_if_token2] = ACTIONS(6808),
    [aux_sym_preproc_else_token1] = ACTIONS(6808),
    [aux_sym_preproc_elif_token1] = ACTIONS(6806),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6808),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6808),
    [anon_sym_LPAREN2] = ACTIONS(6785),
    [anon_sym_DASH] = ACTIONS(6806),
    [anon_sym_PLUS] = ACTIONS(6806),
    [anon_sym_STAR] = ACTIONS(6806),
    [anon_sym_SLASH] = ACTIONS(6806),
    [anon_sym_PERCENT] = ACTIONS(6806),
    [anon_sym_PIPE_PIPE] = ACTIONS(6808),
    [anon_sym_AMP_AMP] = ACTIONS(6808),
    [anon_sym_PIPE] = ACTIONS(6806),
    [anon_sym_CARET] = ACTIONS(6806),
    [anon_sym_AMP] = ACTIONS(6806),
    [anon_sym_EQ_EQ] = ACTIONS(6808),
    [anon_sym_BANG_EQ] = ACTIONS(6808),
    [anon_sym_GT] = ACTIONS(6806),
    [anon_sym_GT_EQ] = ACTIONS(6808),
    [anon_sym_LT_EQ] = ACTIONS(6806),
    [anon_sym_LT] = ACTIONS(6806),
    [anon_sym_LT_LT] = ACTIONS(6806),
    [anon_sym_GT_GT] = ACTIONS(6806),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym___attribute__] = ACTIONS(6806),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6787),
    [anon_sym_RBRACE] = ACTIONS(6808),
    [anon_sym_LBRACK] = ACTIONS(6789),
    [anon_sym_RBRACK] = ACTIONS(6808),
    [anon_sym_EQ] = ACTIONS(6806),
    [anon_sym_QMARK] = ACTIONS(6808),
    [anon_sym_STAR_EQ] = ACTIONS(6808),
    [anon_sym_SLASH_EQ] = ACTIONS(6808),
    [anon_sym_PERCENT_EQ] = ACTIONS(6808),
    [anon_sym_PLUS_EQ] = ACTIONS(6808),
    [anon_sym_DASH_EQ] = ACTIONS(6808),
    [anon_sym_LT_LT_EQ] = ACTIONS(6808),
    [anon_sym_GT_GT_EQ] = ACTIONS(6808),
    [anon_sym_AMP_EQ] = ACTIONS(6808),
    [anon_sym_CARET_EQ] = ACTIONS(6808),
    [anon_sym_PIPE_EQ] = ACTIONS(6808),
    [anon_sym_and_eq] = ACTIONS(6806),
    [anon_sym_or_eq] = ACTIONS(6806),
    [anon_sym_xor_eq] = ACTIONS(6806),
    [anon_sym_LT_EQ_GT] = ACTIONS(6808),
    [anon_sym_or] = ACTIONS(6806),
    [anon_sym_and] = ACTIONS(6806),
    [anon_sym_bitor] = ACTIONS(6806),
    [anon_sym_xor] = ACTIONS(6806),
    [anon_sym_bitand] = ACTIONS(6806),
    [anon_sym_not_eq] = ACTIONS(6806),
    [anon_sym_is] = ACTIONS(6806),
    [anon_sym_as] = ACTIONS(6806),
    [anon_sym_DASH_DASH] = ACTIONS(6808),
    [anon_sym_PLUS_PLUS] = ACTIONS(6808),
    [anon_sym_DOT] = ACTIONS(6806),
    [anon_sym_DOT_STAR] = ACTIONS(6808),
    [anon_sym_DASH_GT] = ACTIONS(6808),
    [sym_comment] = ACTIONS(3),
  },
  [3098] = {
    [sym_identifier] = ACTIONS(3396),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3394),
    [anon_sym_COMMA] = ACTIONS(3394),
    [anon_sym_RPAREN] = ACTIONS(3394),
    [aux_sym_preproc_if_token2] = ACTIONS(3394),
    [aux_sym_preproc_else_token1] = ACTIONS(3394),
    [aux_sym_preproc_elif_token1] = ACTIONS(3396),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3394),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3394),
    [anon_sym_LPAREN2] = ACTIONS(3394),
    [anon_sym_DASH] = ACTIONS(3396),
    [anon_sym_PLUS] = ACTIONS(3396),
    [anon_sym_STAR] = ACTIONS(3396),
    [anon_sym_SLASH] = ACTIONS(3396),
    [anon_sym_PERCENT] = ACTIONS(3396),
    [anon_sym_PIPE_PIPE] = ACTIONS(3394),
    [anon_sym_AMP_AMP] = ACTIONS(3394),
    [anon_sym_PIPE] = ACTIONS(3396),
    [anon_sym_CARET] = ACTIONS(3396),
    [anon_sym_AMP] = ACTIONS(3396),
    [anon_sym_EQ_EQ] = ACTIONS(3394),
    [anon_sym_BANG_EQ] = ACTIONS(3394),
    [anon_sym_GT] = ACTIONS(3396),
    [anon_sym_GT_EQ] = ACTIONS(3394),
    [anon_sym_LT_EQ] = ACTIONS(3396),
    [anon_sym_LT] = ACTIONS(3396),
    [anon_sym_LT_LT] = ACTIONS(3396),
    [anon_sym_GT_GT] = ACTIONS(3396),
    [anon_sym_COLON] = ACTIONS(3394),
    [anon_sym_SEMI] = ACTIONS(3394),
    [anon_sym___attribute__] = ACTIONS(3396),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_RBRACE] = ACTIONS(3394),
    [anon_sym_LBRACK] = ACTIONS(3394),
    [anon_sym_RBRACK] = ACTIONS(3394),
    [anon_sym_EQ] = ACTIONS(3396),
    [anon_sym_QMARK] = ACTIONS(3394),
    [anon_sym_STAR_EQ] = ACTIONS(3394),
    [anon_sym_SLASH_EQ] = ACTIONS(3394),
    [anon_sym_PERCENT_EQ] = ACTIONS(3394),
    [anon_sym_PLUS_EQ] = ACTIONS(3394),
    [anon_sym_DASH_EQ] = ACTIONS(3394),
    [anon_sym_LT_LT_EQ] = ACTIONS(3394),
    [anon_sym_GT_GT_EQ] = ACTIONS(3394),
    [anon_sym_AMP_EQ] = ACTIONS(3394),
    [anon_sym_CARET_EQ] = ACTIONS(3394),
    [anon_sym_PIPE_EQ] = ACTIONS(3394),
    [anon_sym_and_eq] = ACTIONS(3396),
    [anon_sym_or_eq] = ACTIONS(3396),
    [anon_sym_xor_eq] = ACTIONS(3396),
    [anon_sym_LT_EQ_GT] = ACTIONS(3394),
    [anon_sym_or] = ACTIONS(3396),
    [anon_sym_and] = ACTIONS(3396),
    [anon_sym_bitor] = ACTIONS(3396),
    [anon_sym_xor] = ACTIONS(3396),
    [anon_sym_bitand] = ACTIONS(3396),
    [anon_sym_not_eq] = ACTIONS(3396),
    [anon_sym_is] = ACTIONS(3396),
    [anon_sym_as] = ACTIONS(3396),
    [anon_sym_DASH_DASH] = ACTIONS(3394),
    [anon_sym_PLUS_PLUS] = ACTIONS(3394),
    [anon_sym_DOT] = ACTIONS(3396),
    [anon_sym_DOT_STAR] = ACTIONS(3394),
    [anon_sym_DASH_GT] = ACTIONS(3394),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3396),
    [anon_sym_let] = ACTIONS(3396),
    [anon_sym_This] = ACTIONS(3396),
  },
  [3099] = {
    [sym_identifier] = ACTIONS(3082),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3080),
    [anon_sym_COMMA] = ACTIONS(3080),
    [anon_sym_RPAREN] = ACTIONS(3080),
    [aux_sym_preproc_if_token2] = ACTIONS(3080),
    [aux_sym_preproc_else_token1] = ACTIONS(3080),
    [aux_sym_preproc_elif_token1] = ACTIONS(3082),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3080),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3080),
    [anon_sym_LPAREN2] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_STAR] = ACTIONS(3082),
    [anon_sym_SLASH] = ACTIONS(3082),
    [anon_sym_PERCENT] = ACTIONS(3082),
    [anon_sym_PIPE_PIPE] = ACTIONS(3080),
    [anon_sym_AMP_AMP] = ACTIONS(3080),
    [anon_sym_PIPE] = ACTIONS(3082),
    [anon_sym_CARET] = ACTIONS(3082),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym_EQ_EQ] = ACTIONS(3080),
    [anon_sym_BANG_EQ] = ACTIONS(3080),
    [anon_sym_GT] = ACTIONS(3082),
    [anon_sym_GT_EQ] = ACTIONS(3080),
    [anon_sym_LT_EQ] = ACTIONS(3082),
    [anon_sym_LT] = ACTIONS(3082),
    [anon_sym_LT_LT] = ACTIONS(3082),
    [anon_sym_GT_GT] = ACTIONS(3082),
    [anon_sym_COLON] = ACTIONS(3080),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3080),
    [anon_sym_RBRACE] = ACTIONS(3080),
    [anon_sym_LBRACK] = ACTIONS(3080),
    [anon_sym_RBRACK] = ACTIONS(3080),
    [anon_sym_EQ] = ACTIONS(3082),
    [anon_sym_QMARK] = ACTIONS(3080),
    [anon_sym_STAR_EQ] = ACTIONS(3080),
    [anon_sym_SLASH_EQ] = ACTIONS(3080),
    [anon_sym_PERCENT_EQ] = ACTIONS(3080),
    [anon_sym_PLUS_EQ] = ACTIONS(3080),
    [anon_sym_DASH_EQ] = ACTIONS(3080),
    [anon_sym_LT_LT_EQ] = ACTIONS(3080),
    [anon_sym_GT_GT_EQ] = ACTIONS(3080),
    [anon_sym_AMP_EQ] = ACTIONS(3080),
    [anon_sym_CARET_EQ] = ACTIONS(3080),
    [anon_sym_PIPE_EQ] = ACTIONS(3080),
    [anon_sym_and_eq] = ACTIONS(3082),
    [anon_sym_or_eq] = ACTIONS(3082),
    [anon_sym_xor_eq] = ACTIONS(3082),
    [anon_sym_LT_EQ_GT] = ACTIONS(3080),
    [anon_sym_or] = ACTIONS(3082),
    [anon_sym_and] = ACTIONS(3082),
    [anon_sym_bitor] = ACTIONS(3082),
    [anon_sym_xor] = ACTIONS(3082),
    [anon_sym_bitand] = ACTIONS(3082),
    [anon_sym_not_eq] = ACTIONS(3082),
    [anon_sym_is] = ACTIONS(3082),
    [anon_sym_as] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3080),
    [anon_sym_PLUS_PLUS] = ACTIONS(3080),
    [anon_sym_DOT] = ACTIONS(3082),
    [anon_sym_DOT_STAR] = ACTIONS(3080),
    [anon_sym_DASH_GT] = ACTIONS(3080),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3082),
    [anon_sym_let] = ACTIONS(3082),
    [anon_sym_This] = ACTIONS(3082),
  },
  [3100] = {
    [sym_identifier] = ACTIONS(3392),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3390),
    [anon_sym_COMMA] = ACTIONS(3390),
    [anon_sym_RPAREN] = ACTIONS(3390),
    [aux_sym_preproc_if_token2] = ACTIONS(3390),
    [aux_sym_preproc_else_token1] = ACTIONS(3390),
    [aux_sym_preproc_elif_token1] = ACTIONS(3392),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3390),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3390),
    [anon_sym_LPAREN2] = ACTIONS(3390),
    [anon_sym_DASH] = ACTIONS(3392),
    [anon_sym_PLUS] = ACTIONS(3392),
    [anon_sym_STAR] = ACTIONS(3392),
    [anon_sym_SLASH] = ACTIONS(3392),
    [anon_sym_PERCENT] = ACTIONS(3392),
    [anon_sym_PIPE_PIPE] = ACTIONS(3390),
    [anon_sym_AMP_AMP] = ACTIONS(3390),
    [anon_sym_PIPE] = ACTIONS(3392),
    [anon_sym_CARET] = ACTIONS(3392),
    [anon_sym_AMP] = ACTIONS(3392),
    [anon_sym_EQ_EQ] = ACTIONS(3390),
    [anon_sym_BANG_EQ] = ACTIONS(3390),
    [anon_sym_GT] = ACTIONS(3392),
    [anon_sym_GT_EQ] = ACTIONS(3390),
    [anon_sym_LT_EQ] = ACTIONS(3392),
    [anon_sym_LT] = ACTIONS(3392),
    [anon_sym_LT_LT] = ACTIONS(3392),
    [anon_sym_GT_GT] = ACTIONS(3392),
    [anon_sym_COLON] = ACTIONS(3390),
    [anon_sym_SEMI] = ACTIONS(3390),
    [anon_sym___attribute__] = ACTIONS(3392),
    [anon_sym_LBRACE] = ACTIONS(3390),
    [anon_sym_RBRACE] = ACTIONS(3390),
    [anon_sym_LBRACK] = ACTIONS(3390),
    [anon_sym_RBRACK] = ACTIONS(3390),
    [anon_sym_EQ] = ACTIONS(3392),
    [anon_sym_QMARK] = ACTIONS(3390),
    [anon_sym_STAR_EQ] = ACTIONS(3390),
    [anon_sym_SLASH_EQ] = ACTIONS(3390),
    [anon_sym_PERCENT_EQ] = ACTIONS(3390),
    [anon_sym_PLUS_EQ] = ACTIONS(3390),
    [anon_sym_DASH_EQ] = ACTIONS(3390),
    [anon_sym_LT_LT_EQ] = ACTIONS(3390),
    [anon_sym_GT_GT_EQ] = ACTIONS(3390),
    [anon_sym_AMP_EQ] = ACTIONS(3390),
    [anon_sym_CARET_EQ] = ACTIONS(3390),
    [anon_sym_PIPE_EQ] = ACTIONS(3390),
    [anon_sym_and_eq] = ACTIONS(3392),
    [anon_sym_or_eq] = ACTIONS(3392),
    [anon_sym_xor_eq] = ACTIONS(3392),
    [anon_sym_LT_EQ_GT] = ACTIONS(3390),
    [anon_sym_or] = ACTIONS(3392),
    [anon_sym_and] = ACTIONS(3392),
    [anon_sym_bitor] = ACTIONS(3392),
    [anon_sym_xor] = ACTIONS(3392),
    [anon_sym_bitand] = ACTIONS(3392),
    [anon_sym_not_eq] = ACTIONS(3392),
    [anon_sym_is] = ACTIONS(3392),
    [anon_sym_as] = ACTIONS(3392),
    [anon_sym_DASH_DASH] = ACTIONS(3390),
    [anon_sym_PLUS_PLUS] = ACTIONS(3390),
    [anon_sym_DOT] = ACTIONS(3392),
    [anon_sym_DOT_STAR] = ACTIONS(3390),
    [anon_sym_DASH_GT] = ACTIONS(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3392),
    [anon_sym_let] = ACTIONS(3392),
    [anon_sym_This] = ACTIONS(3392),
  },
  [3101] = {
    [sym_identifier] = ACTIONS(3384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3382),
    [anon_sym_COMMA] = ACTIONS(3382),
    [anon_sym_RPAREN] = ACTIONS(3382),
    [aux_sym_preproc_if_token2] = ACTIONS(3382),
    [aux_sym_preproc_else_token1] = ACTIONS(3382),
    [aux_sym_preproc_elif_token1] = ACTIONS(3384),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3382),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3382),
    [anon_sym_LPAREN2] = ACTIONS(3382),
    [anon_sym_DASH] = ACTIONS(3384),
    [anon_sym_PLUS] = ACTIONS(3384),
    [anon_sym_STAR] = ACTIONS(3384),
    [anon_sym_SLASH] = ACTIONS(3384),
    [anon_sym_PERCENT] = ACTIONS(3384),
    [anon_sym_PIPE_PIPE] = ACTIONS(3382),
    [anon_sym_AMP_AMP] = ACTIONS(3382),
    [anon_sym_PIPE] = ACTIONS(3384),
    [anon_sym_CARET] = ACTIONS(3384),
    [anon_sym_AMP] = ACTIONS(3384),
    [anon_sym_EQ_EQ] = ACTIONS(3382),
    [anon_sym_BANG_EQ] = ACTIONS(3382),
    [anon_sym_GT] = ACTIONS(3384),
    [anon_sym_GT_EQ] = ACTIONS(3382),
    [anon_sym_LT_EQ] = ACTIONS(3384),
    [anon_sym_LT] = ACTIONS(3384),
    [anon_sym_LT_LT] = ACTIONS(3384),
    [anon_sym_GT_GT] = ACTIONS(3384),
    [anon_sym_COLON] = ACTIONS(3382),
    [anon_sym_SEMI] = ACTIONS(3382),
    [anon_sym___attribute__] = ACTIONS(3384),
    [anon_sym_LBRACE] = ACTIONS(3382),
    [anon_sym_RBRACE] = ACTIONS(3382),
    [anon_sym_LBRACK] = ACTIONS(3382),
    [anon_sym_RBRACK] = ACTIONS(3382),
    [anon_sym_EQ] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3382),
    [anon_sym_STAR_EQ] = ACTIONS(3382),
    [anon_sym_SLASH_EQ] = ACTIONS(3382),
    [anon_sym_PERCENT_EQ] = ACTIONS(3382),
    [anon_sym_PLUS_EQ] = ACTIONS(3382),
    [anon_sym_DASH_EQ] = ACTIONS(3382),
    [anon_sym_LT_LT_EQ] = ACTIONS(3382),
    [anon_sym_GT_GT_EQ] = ACTIONS(3382),
    [anon_sym_AMP_EQ] = ACTIONS(3382),
    [anon_sym_CARET_EQ] = ACTIONS(3382),
    [anon_sym_PIPE_EQ] = ACTIONS(3382),
    [anon_sym_and_eq] = ACTIONS(3384),
    [anon_sym_or_eq] = ACTIONS(3384),
    [anon_sym_xor_eq] = ACTIONS(3384),
    [anon_sym_LT_EQ_GT] = ACTIONS(3382),
    [anon_sym_or] = ACTIONS(3384),
    [anon_sym_and] = ACTIONS(3384),
    [anon_sym_bitor] = ACTIONS(3384),
    [anon_sym_xor] = ACTIONS(3384),
    [anon_sym_bitand] = ACTIONS(3384),
    [anon_sym_not_eq] = ACTIONS(3384),
    [anon_sym_is] = ACTIONS(3384),
    [anon_sym_as] = ACTIONS(3384),
    [anon_sym_DASH_DASH] = ACTIONS(3382),
    [anon_sym_PLUS_PLUS] = ACTIONS(3382),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_DOT_STAR] = ACTIONS(3382),
    [anon_sym_DASH_GT] = ACTIONS(3382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3384),
    [anon_sym_let] = ACTIONS(3384),
    [anon_sym_This] = ACTIONS(3384),
  },
  [3102] = {
    [sym_identifier] = ACTIONS(3090),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3088),
    [anon_sym_COMMA] = ACTIONS(3088),
    [anon_sym_RPAREN] = ACTIONS(3088),
    [aux_sym_preproc_if_token2] = ACTIONS(3088),
    [aux_sym_preproc_else_token1] = ACTIONS(3088),
    [aux_sym_preproc_elif_token1] = ACTIONS(3090),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3088),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3088),
    [anon_sym_LPAREN2] = ACTIONS(3088),
    [anon_sym_DASH] = ACTIONS(3090),
    [anon_sym_PLUS] = ACTIONS(3090),
    [anon_sym_STAR] = ACTIONS(3090),
    [anon_sym_SLASH] = ACTIONS(3090),
    [anon_sym_PERCENT] = ACTIONS(3090),
    [anon_sym_PIPE_PIPE] = ACTIONS(3088),
    [anon_sym_AMP_AMP] = ACTIONS(3088),
    [anon_sym_PIPE] = ACTIONS(3090),
    [anon_sym_CARET] = ACTIONS(3090),
    [anon_sym_AMP] = ACTIONS(3090),
    [anon_sym_EQ_EQ] = ACTIONS(3088),
    [anon_sym_BANG_EQ] = ACTIONS(3088),
    [anon_sym_GT] = ACTIONS(3090),
    [anon_sym_GT_EQ] = ACTIONS(3088),
    [anon_sym_LT_EQ] = ACTIONS(3090),
    [anon_sym_LT] = ACTIONS(3090),
    [anon_sym_LT_LT] = ACTIONS(3090),
    [anon_sym_GT_GT] = ACTIONS(3090),
    [anon_sym_COLON] = ACTIONS(3088),
    [anon_sym_SEMI] = ACTIONS(3088),
    [anon_sym___attribute__] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3088),
    [anon_sym_RBRACE] = ACTIONS(3088),
    [anon_sym_LBRACK] = ACTIONS(3088),
    [anon_sym_RBRACK] = ACTIONS(3088),
    [anon_sym_EQ] = ACTIONS(3090),
    [anon_sym_QMARK] = ACTIONS(3088),
    [anon_sym_STAR_EQ] = ACTIONS(3088),
    [anon_sym_SLASH_EQ] = ACTIONS(3088),
    [anon_sym_PERCENT_EQ] = ACTIONS(3088),
    [anon_sym_PLUS_EQ] = ACTIONS(3088),
    [anon_sym_DASH_EQ] = ACTIONS(3088),
    [anon_sym_LT_LT_EQ] = ACTIONS(3088),
    [anon_sym_GT_GT_EQ] = ACTIONS(3088),
    [anon_sym_AMP_EQ] = ACTIONS(3088),
    [anon_sym_CARET_EQ] = ACTIONS(3088),
    [anon_sym_PIPE_EQ] = ACTIONS(3088),
    [anon_sym_and_eq] = ACTIONS(3090),
    [anon_sym_or_eq] = ACTIONS(3090),
    [anon_sym_xor_eq] = ACTIONS(3090),
    [anon_sym_LT_EQ_GT] = ACTIONS(3088),
    [anon_sym_or] = ACTIONS(3090),
    [anon_sym_and] = ACTIONS(3090),
    [anon_sym_bitor] = ACTIONS(3090),
    [anon_sym_xor] = ACTIONS(3090),
    [anon_sym_bitand] = ACTIONS(3090),
    [anon_sym_not_eq] = ACTIONS(3090),
    [anon_sym_is] = ACTIONS(3090),
    [anon_sym_as] = ACTIONS(3090),
    [anon_sym_DASH_DASH] = ACTIONS(3088),
    [anon_sym_PLUS_PLUS] = ACTIONS(3088),
    [anon_sym_DOT] = ACTIONS(3090),
    [anon_sym_DOT_STAR] = ACTIONS(3088),
    [anon_sym_DASH_GT] = ACTIONS(3088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3090),
    [anon_sym_let] = ACTIONS(3090),
    [anon_sym_This] = ACTIONS(3090),
  },
  [3103] = {
    [sym_identifier] = ACTIONS(3358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3356),
    [anon_sym_COMMA] = ACTIONS(3356),
    [anon_sym_RPAREN] = ACTIONS(3356),
    [aux_sym_preproc_if_token2] = ACTIONS(3356),
    [aux_sym_preproc_else_token1] = ACTIONS(3356),
    [aux_sym_preproc_elif_token1] = ACTIONS(3358),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3356),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3356),
    [anon_sym_LPAREN2] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3358),
    [anon_sym_PLUS] = ACTIONS(3358),
    [anon_sym_STAR] = ACTIONS(3358),
    [anon_sym_SLASH] = ACTIONS(3358),
    [anon_sym_PERCENT] = ACTIONS(3358),
    [anon_sym_PIPE_PIPE] = ACTIONS(3356),
    [anon_sym_AMP_AMP] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(3358),
    [anon_sym_CARET] = ACTIONS(3358),
    [anon_sym_AMP] = ACTIONS(3358),
    [anon_sym_EQ_EQ] = ACTIONS(3356),
    [anon_sym_BANG_EQ] = ACTIONS(3356),
    [anon_sym_GT] = ACTIONS(3358),
    [anon_sym_GT_EQ] = ACTIONS(3356),
    [anon_sym_LT_EQ] = ACTIONS(3358),
    [anon_sym_LT] = ACTIONS(3358),
    [anon_sym_LT_LT] = ACTIONS(3358),
    [anon_sym_GT_GT] = ACTIONS(3358),
    [anon_sym_COLON] = ACTIONS(3356),
    [anon_sym_SEMI] = ACTIONS(3356),
    [anon_sym___attribute__] = ACTIONS(3358),
    [anon_sym_LBRACE] = ACTIONS(3356),
    [anon_sym_RBRACE] = ACTIONS(3356),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_RBRACK] = ACTIONS(3356),
    [anon_sym_EQ] = ACTIONS(3358),
    [anon_sym_QMARK] = ACTIONS(3356),
    [anon_sym_STAR_EQ] = ACTIONS(3356),
    [anon_sym_SLASH_EQ] = ACTIONS(3356),
    [anon_sym_PERCENT_EQ] = ACTIONS(3356),
    [anon_sym_PLUS_EQ] = ACTIONS(3356),
    [anon_sym_DASH_EQ] = ACTIONS(3356),
    [anon_sym_LT_LT_EQ] = ACTIONS(3356),
    [anon_sym_GT_GT_EQ] = ACTIONS(3356),
    [anon_sym_AMP_EQ] = ACTIONS(3356),
    [anon_sym_CARET_EQ] = ACTIONS(3356),
    [anon_sym_PIPE_EQ] = ACTIONS(3356),
    [anon_sym_and_eq] = ACTIONS(3358),
    [anon_sym_or_eq] = ACTIONS(3358),
    [anon_sym_xor_eq] = ACTIONS(3358),
    [anon_sym_LT_EQ_GT] = ACTIONS(3356),
    [anon_sym_or] = ACTIONS(3358),
    [anon_sym_and] = ACTIONS(3358),
    [anon_sym_bitor] = ACTIONS(3358),
    [anon_sym_xor] = ACTIONS(3358),
    [anon_sym_bitand] = ACTIONS(3358),
    [anon_sym_not_eq] = ACTIONS(3358),
    [anon_sym_is] = ACTIONS(3358),
    [anon_sym_as] = ACTIONS(3358),
    [anon_sym_DASH_DASH] = ACTIONS(3356),
    [anon_sym_PLUS_PLUS] = ACTIONS(3356),
    [anon_sym_DOT] = ACTIONS(3358),
    [anon_sym_DOT_STAR] = ACTIONS(3356),
    [anon_sym_DASH_GT] = ACTIONS(3356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3358),
    [anon_sym_let] = ACTIONS(3358),
    [anon_sym_This] = ACTIONS(3358),
  },
  [3104] = {
    [sym_identifier] = ACTIONS(3054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3052),
    [anon_sym_COMMA] = ACTIONS(3052),
    [anon_sym_RPAREN] = ACTIONS(3052),
    [aux_sym_preproc_if_token2] = ACTIONS(3052),
    [aux_sym_preproc_else_token1] = ACTIONS(3052),
    [aux_sym_preproc_elif_token1] = ACTIONS(3054),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3052),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3052),
    [anon_sym_LPAREN2] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3054),
    [anon_sym_PLUS] = ACTIONS(3054),
    [anon_sym_STAR] = ACTIONS(3054),
    [anon_sym_SLASH] = ACTIONS(3054),
    [anon_sym_PERCENT] = ACTIONS(3054),
    [anon_sym_PIPE_PIPE] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_PIPE] = ACTIONS(3054),
    [anon_sym_CARET] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3054),
    [anon_sym_EQ_EQ] = ACTIONS(3052),
    [anon_sym_BANG_EQ] = ACTIONS(3052),
    [anon_sym_GT] = ACTIONS(3054),
    [anon_sym_GT_EQ] = ACTIONS(3052),
    [anon_sym_LT_EQ] = ACTIONS(3054),
    [anon_sym_LT] = ACTIONS(3054),
    [anon_sym_LT_LT] = ACTIONS(3054),
    [anon_sym_GT_GT] = ACTIONS(3054),
    [anon_sym_COLON] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym___attribute__] = ACTIONS(3054),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_RBRACE] = ACTIONS(3052),
    [anon_sym_LBRACK] = ACTIONS(3052),
    [anon_sym_RBRACK] = ACTIONS(3052),
    [anon_sym_EQ] = ACTIONS(3054),
    [anon_sym_QMARK] = ACTIONS(3052),
    [anon_sym_STAR_EQ] = ACTIONS(3052),
    [anon_sym_SLASH_EQ] = ACTIONS(3052),
    [anon_sym_PERCENT_EQ] = ACTIONS(3052),
    [anon_sym_PLUS_EQ] = ACTIONS(3052),
    [anon_sym_DASH_EQ] = ACTIONS(3052),
    [anon_sym_LT_LT_EQ] = ACTIONS(3052),
    [anon_sym_GT_GT_EQ] = ACTIONS(3052),
    [anon_sym_AMP_EQ] = ACTIONS(3052),
    [anon_sym_CARET_EQ] = ACTIONS(3052),
    [anon_sym_PIPE_EQ] = ACTIONS(3052),
    [anon_sym_and_eq] = ACTIONS(3054),
    [anon_sym_or_eq] = ACTIONS(3054),
    [anon_sym_xor_eq] = ACTIONS(3054),
    [anon_sym_LT_EQ_GT] = ACTIONS(3052),
    [anon_sym_or] = ACTIONS(3054),
    [anon_sym_and] = ACTIONS(3054),
    [anon_sym_bitor] = ACTIONS(3054),
    [anon_sym_xor] = ACTIONS(3054),
    [anon_sym_bitand] = ACTIONS(3054),
    [anon_sym_not_eq] = ACTIONS(3054),
    [anon_sym_is] = ACTIONS(3054),
    [anon_sym_as] = ACTIONS(3054),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_DOT] = ACTIONS(3054),
    [anon_sym_DOT_STAR] = ACTIONS(3052),
    [anon_sym_DASH_GT] = ACTIONS(3052),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3054),
    [anon_sym_let] = ACTIONS(3054),
    [anon_sym_This] = ACTIONS(3054),
  },
  [3105] = {
    [sym_attribute_specifier] = STATE(2891),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3842),
    [anon_sym_COMMA] = ACTIONS(3842),
    [anon_sym_RPAREN] = ACTIONS(3842),
    [anon_sym_LPAREN2] = ACTIONS(3842),
    [anon_sym_DASH] = ACTIONS(3840),
    [anon_sym_PLUS] = ACTIONS(3840),
    [anon_sym_STAR] = ACTIONS(3842),
    [anon_sym_SLASH] = ACTIONS(3840),
    [anon_sym_PERCENT] = ACTIONS(3842),
    [anon_sym_PIPE_PIPE] = ACTIONS(3842),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_PIPE] = ACTIONS(3840),
    [anon_sym_CARET] = ACTIONS(3842),
    [anon_sym_AMP] = ACTIONS(3840),
    [anon_sym_EQ_EQ] = ACTIONS(3842),
    [anon_sym_BANG_EQ] = ACTIONS(3842),
    [anon_sym_GT] = ACTIONS(3840),
    [anon_sym_GT_EQ] = ACTIONS(3842),
    [anon_sym_LT_EQ] = ACTIONS(3840),
    [anon_sym_LT] = ACTIONS(3840),
    [anon_sym_LT_LT] = ACTIONS(3842),
    [anon_sym_GT_GT] = ACTIONS(3842),
    [anon_sym_COLON] = ACTIONS(3842),
    [anon_sym_SEMI] = ACTIONS(3842),
    [anon_sym___extension__] = ACTIONS(3842),
    [anon_sym___attribute__] = ACTIONS(6621),
    [anon_sym_LBRACE] = ACTIONS(3842),
    [anon_sym_RBRACE] = ACTIONS(3842),
    [anon_sym_LBRACK] = ACTIONS(3842),
    [anon_sym_RBRACK] = ACTIONS(3842),
    [anon_sym_const] = ACTIONS(3840),
    [anon_sym_constexpr] = ACTIONS(3842),
    [anon_sym_volatile] = ACTIONS(3842),
    [anon_sym_restrict] = ACTIONS(3842),
    [anon_sym___restrict__] = ACTIONS(3842),
    [anon_sym__Atomic] = ACTIONS(3842),
    [anon_sym__Noreturn] = ACTIONS(3842),
    [anon_sym_noreturn] = ACTIONS(3842),
    [anon_sym_mutable] = ACTIONS(3842),
    [anon_sym_constinit] = ACTIONS(3842),
    [anon_sym_consteval] = ACTIONS(3842),
    [anon_sym_alignas] = ACTIONS(3842),
    [anon_sym__Alignas] = ACTIONS(3842),
    [anon_sym_QMARK] = ACTIONS(3842),
    [anon_sym_LT_EQ_GT] = ACTIONS(3842),
    [anon_sym_or] = ACTIONS(3842),
    [anon_sym_and] = ACTIONS(3842),
    [anon_sym_bitor] = ACTIONS(3842),
    [anon_sym_xor] = ACTIONS(3842),
    [anon_sym_bitand] = ACTIONS(3842),
    [anon_sym_not_eq] = ACTIONS(3842),
    [anon_sym_is] = ACTIONS(3842),
    [anon_sym_as] = ACTIONS(3842),
    [anon_sym_DASH_DASH] = ACTIONS(3842),
    [anon_sym_PLUS_PLUS] = ACTIONS(3842),
    [anon_sym_DOT] = ACTIONS(3840),
    [anon_sym_DOT_STAR] = ACTIONS(3842),
    [anon_sym_DASH_GT] = ACTIONS(3842),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3842),
    [anon_sym_let] = ACTIONS(3842),
    [anon_sym_This] = ACTIONS(3842),
    [anon_sym_final] = ACTIONS(3842),
    [anon_sym_override] = ACTIONS(3842),
    [anon_sym_requires] = ACTIONS(3842),
    [anon_sym_where] = ACTIONS(3842),
  },
  [3106] = {
    [sym_attribute_specifier] = STATE(2931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3748),
    [anon_sym_COMMA] = ACTIONS(3748),
    [anon_sym_RPAREN] = ACTIONS(3748),
    [anon_sym_LPAREN2] = ACTIONS(3748),
    [anon_sym_DASH] = ACTIONS(3746),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_STAR] = ACTIONS(3748),
    [anon_sym_SLASH] = ACTIONS(3746),
    [anon_sym_PERCENT] = ACTIONS(3748),
    [anon_sym_PIPE_PIPE] = ACTIONS(3748),
    [anon_sym_AMP_AMP] = ACTIONS(3748),
    [anon_sym_PIPE] = ACTIONS(3746),
    [anon_sym_CARET] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_EQ_EQ] = ACTIONS(3748),
    [anon_sym_BANG_EQ] = ACTIONS(3748),
    [anon_sym_GT] = ACTIONS(3746),
    [anon_sym_GT_EQ] = ACTIONS(3748),
    [anon_sym_LT_EQ] = ACTIONS(3746),
    [anon_sym_LT] = ACTIONS(3746),
    [anon_sym_LT_LT] = ACTIONS(3748),
    [anon_sym_GT_GT] = ACTIONS(3748),
    [anon_sym_COLON] = ACTIONS(3748),
    [anon_sym_SEMI] = ACTIONS(3748),
    [anon_sym___extension__] = ACTIONS(3748),
    [anon_sym___attribute__] = ACTIONS(6621),
    [anon_sym_LBRACE] = ACTIONS(3748),
    [anon_sym_RBRACE] = ACTIONS(3748),
    [anon_sym_LBRACK] = ACTIONS(3748),
    [anon_sym_RBRACK] = ACTIONS(3748),
    [anon_sym_const] = ACTIONS(3746),
    [anon_sym_constexpr] = ACTIONS(3748),
    [anon_sym_volatile] = ACTIONS(3748),
    [anon_sym_restrict] = ACTIONS(3748),
    [anon_sym___restrict__] = ACTIONS(3748),
    [anon_sym__Atomic] = ACTIONS(3748),
    [anon_sym__Noreturn] = ACTIONS(3748),
    [anon_sym_noreturn] = ACTIONS(3748),
    [anon_sym_mutable] = ACTIONS(3748),
    [anon_sym_constinit] = ACTIONS(3748),
    [anon_sym_consteval] = ACTIONS(3748),
    [anon_sym_alignas] = ACTIONS(3748),
    [anon_sym__Alignas] = ACTIONS(3748),
    [anon_sym_QMARK] = ACTIONS(3748),
    [anon_sym_LT_EQ_GT] = ACTIONS(3748),
    [anon_sym_or] = ACTIONS(3748),
    [anon_sym_and] = ACTIONS(3748),
    [anon_sym_bitor] = ACTIONS(3748),
    [anon_sym_xor] = ACTIONS(3748),
    [anon_sym_bitand] = ACTIONS(3748),
    [anon_sym_not_eq] = ACTIONS(3748),
    [anon_sym_is] = ACTIONS(3748),
    [anon_sym_as] = ACTIONS(3748),
    [anon_sym_DASH_DASH] = ACTIONS(3748),
    [anon_sym_PLUS_PLUS] = ACTIONS(3748),
    [anon_sym_DOT] = ACTIONS(3746),
    [anon_sym_DOT_STAR] = ACTIONS(3748),
    [anon_sym_DASH_GT] = ACTIONS(3748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3748),
    [anon_sym_let] = ACTIONS(3748),
    [anon_sym_This] = ACTIONS(3748),
    [anon_sym_final] = ACTIONS(3748),
    [anon_sym_override] = ACTIONS(3748),
    [anon_sym_requires] = ACTIONS(3748),
    [anon_sym_where] = ACTIONS(3748),
  },
  [3107] = {
    [sym_identifier] = ACTIONS(6810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6812),
    [anon_sym_COMMA] = ACTIONS(6812),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [aux_sym_preproc_if_token2] = ACTIONS(6812),
    [aux_sym_preproc_else_token1] = ACTIONS(6812),
    [aux_sym_preproc_elif_token1] = ACTIONS(6810),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6812),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6812),
    [anon_sym_LPAREN2] = ACTIONS(6812),
    [anon_sym_DASH] = ACTIONS(6810),
    [anon_sym_PLUS] = ACTIONS(6810),
    [anon_sym_STAR] = ACTIONS(6810),
    [anon_sym_SLASH] = ACTIONS(6810),
    [anon_sym_PERCENT] = ACTIONS(6810),
    [anon_sym_PIPE_PIPE] = ACTIONS(6812),
    [anon_sym_AMP_AMP] = ACTIONS(6812),
    [anon_sym_PIPE] = ACTIONS(6810),
    [anon_sym_CARET] = ACTIONS(6810),
    [anon_sym_AMP] = ACTIONS(6810),
    [anon_sym_EQ_EQ] = ACTIONS(6812),
    [anon_sym_BANG_EQ] = ACTIONS(6812),
    [anon_sym_GT] = ACTIONS(6810),
    [anon_sym_GT_EQ] = ACTIONS(6812),
    [anon_sym_LT_EQ] = ACTIONS(6810),
    [anon_sym_LT] = ACTIONS(6810),
    [anon_sym_LT_LT] = ACTIONS(6810),
    [anon_sym_GT_GT] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(6812),
    [anon_sym_SEMI] = ACTIONS(6812),
    [anon_sym___attribute__] = ACTIONS(6810),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6812),
    [anon_sym_LBRACE] = ACTIONS(6812),
    [anon_sym_RBRACE] = ACTIONS(6812),
    [anon_sym_LBRACK] = ACTIONS(6810),
    [anon_sym_RBRACK] = ACTIONS(6812),
    [anon_sym_EQ] = ACTIONS(6810),
    [anon_sym_QMARK] = ACTIONS(6812),
    [anon_sym_STAR_EQ] = ACTIONS(6812),
    [anon_sym_SLASH_EQ] = ACTIONS(6812),
    [anon_sym_PERCENT_EQ] = ACTIONS(6812),
    [anon_sym_PLUS_EQ] = ACTIONS(6812),
    [anon_sym_DASH_EQ] = ACTIONS(6812),
    [anon_sym_LT_LT_EQ] = ACTIONS(6812),
    [anon_sym_GT_GT_EQ] = ACTIONS(6812),
    [anon_sym_AMP_EQ] = ACTIONS(6812),
    [anon_sym_CARET_EQ] = ACTIONS(6812),
    [anon_sym_PIPE_EQ] = ACTIONS(6812),
    [anon_sym_and_eq] = ACTIONS(6810),
    [anon_sym_or_eq] = ACTIONS(6810),
    [anon_sym_xor_eq] = ACTIONS(6810),
    [anon_sym_LT_EQ_GT] = ACTIONS(6812),
    [anon_sym_or] = ACTIONS(6810),
    [anon_sym_and] = ACTIONS(6810),
    [anon_sym_bitor] = ACTIONS(6810),
    [anon_sym_xor] = ACTIONS(6810),
    [anon_sym_bitand] = ACTIONS(6810),
    [anon_sym_not_eq] = ACTIONS(6810),
    [anon_sym_is] = ACTIONS(6810),
    [anon_sym_as] = ACTIONS(6810),
    [anon_sym_DASH_DASH] = ACTIONS(6812),
    [anon_sym_PLUS_PLUS] = ACTIONS(6812),
    [anon_sym_DOT] = ACTIONS(6810),
    [anon_sym_DOT_STAR] = ACTIONS(6812),
    [anon_sym_DASH_GT] = ACTIONS(6812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6810),
  },
  [3108] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3773),
    [anon_sym_COMMA] = ACTIONS(3773),
    [anon_sym_RPAREN] = ACTIONS(3773),
    [anon_sym_LPAREN2] = ACTIONS(3773),
    [anon_sym_DASH] = ACTIONS(3771),
    [anon_sym_PLUS] = ACTIONS(3771),
    [anon_sym_STAR] = ACTIONS(3771),
    [anon_sym_SLASH] = ACTIONS(3771),
    [anon_sym_PERCENT] = ACTIONS(3771),
    [anon_sym_PIPE_PIPE] = ACTIONS(3773),
    [anon_sym_AMP_AMP] = ACTIONS(3773),
    [anon_sym_PIPE] = ACTIONS(3771),
    [anon_sym_CARET] = ACTIONS(3771),
    [anon_sym_AMP] = ACTIONS(3771),
    [anon_sym_EQ_EQ] = ACTIONS(3773),
    [anon_sym_BANG_EQ] = ACTIONS(3773),
    [anon_sym_GT] = ACTIONS(3771),
    [anon_sym_GT_EQ] = ACTIONS(3773),
    [anon_sym_LT_EQ] = ACTIONS(3771),
    [anon_sym_LT] = ACTIONS(3771),
    [anon_sym_LT_LT] = ACTIONS(3771),
    [anon_sym_GT_GT] = ACTIONS(3771),
    [anon_sym_COLON] = ACTIONS(3773),
    [anon_sym_SEMI] = ACTIONS(3773),
    [anon_sym___attribute__] = ACTIONS(3773),
    [anon_sym_LBRACE] = ACTIONS(3773),
    [anon_sym_RBRACE] = ACTIONS(3773),
    [anon_sym_signed] = ACTIONS(6814),
    [anon_sym_unsigned] = ACTIONS(6814),
    [anon_sym_long] = ACTIONS(6814),
    [anon_sym_short] = ACTIONS(6814),
    [anon_sym_LBRACK] = ACTIONS(3773),
    [anon_sym_RBRACK] = ACTIONS(3773),
    [anon_sym_EQ] = ACTIONS(3771),
    [anon_sym_QMARK] = ACTIONS(3773),
    [anon_sym_STAR_EQ] = ACTIONS(3773),
    [anon_sym_SLASH_EQ] = ACTIONS(3773),
    [anon_sym_PERCENT_EQ] = ACTIONS(3773),
    [anon_sym_PLUS_EQ] = ACTIONS(3773),
    [anon_sym_DASH_EQ] = ACTIONS(3773),
    [anon_sym_LT_LT_EQ] = ACTIONS(3773),
    [anon_sym_GT_GT_EQ] = ACTIONS(3773),
    [anon_sym_AMP_EQ] = ACTIONS(3773),
    [anon_sym_CARET_EQ] = ACTIONS(3773),
    [anon_sym_PIPE_EQ] = ACTIONS(3773),
    [anon_sym_and_eq] = ACTIONS(3773),
    [anon_sym_or_eq] = ACTIONS(3773),
    [anon_sym_xor_eq] = ACTIONS(3773),
    [anon_sym_LT_EQ_GT] = ACTIONS(3773),
    [anon_sym_or] = ACTIONS(3771),
    [anon_sym_and] = ACTIONS(3771),
    [anon_sym_bitor] = ACTIONS(3773),
    [anon_sym_xor] = ACTIONS(3771),
    [anon_sym_bitand] = ACTIONS(3773),
    [anon_sym_not_eq] = ACTIONS(3773),
    [anon_sym_is] = ACTIONS(3773),
    [anon_sym_as] = ACTIONS(3773),
    [anon_sym_DASH_DASH] = ACTIONS(3773),
    [anon_sym_PLUS_PLUS] = ACTIONS(3773),
    [anon_sym_DOT] = ACTIONS(3771),
    [anon_sym_DOT_STAR] = ACTIONS(3773),
    [anon_sym_DASH_GT] = ACTIONS(3773),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3773),
    [anon_sym_let] = ACTIONS(3773),
    [anon_sym_This] = ACTIONS(3773),
  },
  [3109] = {
    [sym_identifier] = ACTIONS(6816),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6818),
    [anon_sym_COMMA] = ACTIONS(6818),
    [anon_sym_RPAREN] = ACTIONS(6818),
    [aux_sym_preproc_if_token2] = ACTIONS(6818),
    [aux_sym_preproc_else_token1] = ACTIONS(6818),
    [aux_sym_preproc_elif_token1] = ACTIONS(6816),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6818),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6818),
    [anon_sym_LPAREN2] = ACTIONS(6818),
    [anon_sym_DASH] = ACTIONS(6816),
    [anon_sym_PLUS] = ACTIONS(6816),
    [anon_sym_STAR] = ACTIONS(6816),
    [anon_sym_SLASH] = ACTIONS(6816),
    [anon_sym_PERCENT] = ACTIONS(6816),
    [anon_sym_PIPE_PIPE] = ACTIONS(6818),
    [anon_sym_AMP_AMP] = ACTIONS(6818),
    [anon_sym_PIPE] = ACTIONS(6816),
    [anon_sym_CARET] = ACTIONS(6816),
    [anon_sym_AMP] = ACTIONS(6816),
    [anon_sym_EQ_EQ] = ACTIONS(6818),
    [anon_sym_BANG_EQ] = ACTIONS(6818),
    [anon_sym_GT] = ACTIONS(6816),
    [anon_sym_GT_EQ] = ACTIONS(6818),
    [anon_sym_LT_EQ] = ACTIONS(6816),
    [anon_sym_LT] = ACTIONS(6816),
    [anon_sym_LT_LT] = ACTIONS(6816),
    [anon_sym_GT_GT] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6818),
    [anon_sym_SEMI] = ACTIONS(6818),
    [anon_sym___attribute__] = ACTIONS(6816),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6818),
    [anon_sym_LBRACE] = ACTIONS(6818),
    [anon_sym_RBRACE] = ACTIONS(6818),
    [anon_sym_LBRACK] = ACTIONS(6816),
    [anon_sym_RBRACK] = ACTIONS(6818),
    [anon_sym_EQ] = ACTIONS(6816),
    [anon_sym_QMARK] = ACTIONS(6818),
    [anon_sym_STAR_EQ] = ACTIONS(6818),
    [anon_sym_SLASH_EQ] = ACTIONS(6818),
    [anon_sym_PERCENT_EQ] = ACTIONS(6818),
    [anon_sym_PLUS_EQ] = ACTIONS(6818),
    [anon_sym_DASH_EQ] = ACTIONS(6818),
    [anon_sym_LT_LT_EQ] = ACTIONS(6818),
    [anon_sym_GT_GT_EQ] = ACTIONS(6818),
    [anon_sym_AMP_EQ] = ACTIONS(6818),
    [anon_sym_CARET_EQ] = ACTIONS(6818),
    [anon_sym_PIPE_EQ] = ACTIONS(6818),
    [anon_sym_and_eq] = ACTIONS(6816),
    [anon_sym_or_eq] = ACTIONS(6816),
    [anon_sym_xor_eq] = ACTIONS(6816),
    [anon_sym_LT_EQ_GT] = ACTIONS(6818),
    [anon_sym_or] = ACTIONS(6816),
    [anon_sym_and] = ACTIONS(6816),
    [anon_sym_bitor] = ACTIONS(6816),
    [anon_sym_xor] = ACTIONS(6816),
    [anon_sym_bitand] = ACTIONS(6816),
    [anon_sym_not_eq] = ACTIONS(6816),
    [anon_sym_is] = ACTIONS(6816),
    [anon_sym_as] = ACTIONS(6816),
    [anon_sym_DASH_DASH] = ACTIONS(6818),
    [anon_sym_PLUS_PLUS] = ACTIONS(6818),
    [anon_sym_DOT] = ACTIONS(6816),
    [anon_sym_DOT_STAR] = ACTIONS(6818),
    [anon_sym_DASH_GT] = ACTIONS(6818),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6816),
  },
  [3110] = {
    [sym_argument_list] = STATE(3287),
    [sym_initializer_list] = STATE(3287),
    [sym_identifier] = ACTIONS(6820),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6822),
    [anon_sym_COMMA] = ACTIONS(6822),
    [anon_sym_RPAREN] = ACTIONS(6822),
    [aux_sym_preproc_if_token2] = ACTIONS(6822),
    [aux_sym_preproc_else_token1] = ACTIONS(6822),
    [aux_sym_preproc_elif_token1] = ACTIONS(6820),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6822),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6822),
    [anon_sym_LPAREN2] = ACTIONS(6568),
    [anon_sym_DASH] = ACTIONS(6820),
    [anon_sym_PLUS] = ACTIONS(6820),
    [anon_sym_STAR] = ACTIONS(6820),
    [anon_sym_SLASH] = ACTIONS(6820),
    [anon_sym_PERCENT] = ACTIONS(6820),
    [anon_sym_PIPE_PIPE] = ACTIONS(6822),
    [anon_sym_AMP_AMP] = ACTIONS(6822),
    [anon_sym_PIPE] = ACTIONS(6820),
    [anon_sym_CARET] = ACTIONS(6820),
    [anon_sym_AMP] = ACTIONS(6820),
    [anon_sym_EQ_EQ] = ACTIONS(6822),
    [anon_sym_BANG_EQ] = ACTIONS(6822),
    [anon_sym_GT] = ACTIONS(6820),
    [anon_sym_GT_EQ] = ACTIONS(6822),
    [anon_sym_LT_EQ] = ACTIONS(6820),
    [anon_sym_LT] = ACTIONS(6820),
    [anon_sym_LT_LT] = ACTIONS(6820),
    [anon_sym_GT_GT] = ACTIONS(6820),
    [anon_sym_COLON] = ACTIONS(6822),
    [anon_sym_SEMI] = ACTIONS(6822),
    [anon_sym___attribute__] = ACTIONS(6820),
    [anon_sym_LBRACE] = ACTIONS(4418),
    [anon_sym_RBRACE] = ACTIONS(6822),
    [anon_sym_LBRACK] = ACTIONS(6822),
    [anon_sym_RBRACK] = ACTIONS(6822),
    [anon_sym_EQ] = ACTIONS(6820),
    [anon_sym_QMARK] = ACTIONS(6822),
    [anon_sym_STAR_EQ] = ACTIONS(6822),
    [anon_sym_SLASH_EQ] = ACTIONS(6822),
    [anon_sym_PERCENT_EQ] = ACTIONS(6822),
    [anon_sym_PLUS_EQ] = ACTIONS(6822),
    [anon_sym_DASH_EQ] = ACTIONS(6822),
    [anon_sym_LT_LT_EQ] = ACTIONS(6822),
    [anon_sym_GT_GT_EQ] = ACTIONS(6822),
    [anon_sym_AMP_EQ] = ACTIONS(6822),
    [anon_sym_CARET_EQ] = ACTIONS(6822),
    [anon_sym_PIPE_EQ] = ACTIONS(6822),
    [anon_sym_and_eq] = ACTIONS(6820),
    [anon_sym_or_eq] = ACTIONS(6820),
    [anon_sym_xor_eq] = ACTIONS(6820),
    [anon_sym_LT_EQ_GT] = ACTIONS(6822),
    [anon_sym_or] = ACTIONS(6820),
    [anon_sym_and] = ACTIONS(6820),
    [anon_sym_bitor] = ACTIONS(6820),
    [anon_sym_xor] = ACTIONS(6820),
    [anon_sym_bitand] = ACTIONS(6820),
    [anon_sym_not_eq] = ACTIONS(6820),
    [anon_sym_is] = ACTIONS(6820),
    [anon_sym_as] = ACTIONS(6820),
    [anon_sym_DASH_DASH] = ACTIONS(6822),
    [anon_sym_PLUS_PLUS] = ACTIONS(6822),
    [anon_sym_DOT] = ACTIONS(6820),
    [anon_sym_DOT_STAR] = ACTIONS(6822),
    [anon_sym_DASH_GT] = ACTIONS(6822),
    [sym_comment] = ACTIONS(3),
  },
  [3111] = {
    [sym_identifier] = ACTIONS(6824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6826),
    [anon_sym_COMMA] = ACTIONS(6826),
    [anon_sym_RPAREN] = ACTIONS(6826),
    [aux_sym_preproc_if_token2] = ACTIONS(6826),
    [aux_sym_preproc_else_token1] = ACTIONS(6826),
    [aux_sym_preproc_elif_token1] = ACTIONS(6824),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6826),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6826),
    [anon_sym_LPAREN2] = ACTIONS(6826),
    [anon_sym_DASH] = ACTIONS(6824),
    [anon_sym_PLUS] = ACTIONS(6824),
    [anon_sym_STAR] = ACTIONS(6824),
    [anon_sym_SLASH] = ACTIONS(6824),
    [anon_sym_PERCENT] = ACTIONS(6824),
    [anon_sym_PIPE_PIPE] = ACTIONS(6826),
    [anon_sym_AMP_AMP] = ACTIONS(6826),
    [anon_sym_PIPE] = ACTIONS(6824),
    [anon_sym_CARET] = ACTIONS(6824),
    [anon_sym_AMP] = ACTIONS(6824),
    [anon_sym_EQ_EQ] = ACTIONS(6826),
    [anon_sym_BANG_EQ] = ACTIONS(6826),
    [anon_sym_GT] = ACTIONS(6824),
    [anon_sym_GT_EQ] = ACTIONS(6826),
    [anon_sym_LT_EQ] = ACTIONS(6824),
    [anon_sym_LT] = ACTIONS(6824),
    [anon_sym_LT_LT] = ACTIONS(6824),
    [anon_sym_GT_GT] = ACTIONS(6824),
    [anon_sym_COLON] = ACTIONS(6826),
    [anon_sym_SEMI] = ACTIONS(6826),
    [anon_sym___attribute__] = ACTIONS(6824),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6826),
    [anon_sym_LBRACE] = ACTIONS(6826),
    [anon_sym_RBRACE] = ACTIONS(6826),
    [anon_sym_LBRACK] = ACTIONS(6824),
    [anon_sym_RBRACK] = ACTIONS(6826),
    [anon_sym_EQ] = ACTIONS(6824),
    [anon_sym_QMARK] = ACTIONS(6826),
    [anon_sym_STAR_EQ] = ACTIONS(6826),
    [anon_sym_SLASH_EQ] = ACTIONS(6826),
    [anon_sym_PERCENT_EQ] = ACTIONS(6826),
    [anon_sym_PLUS_EQ] = ACTIONS(6826),
    [anon_sym_DASH_EQ] = ACTIONS(6826),
    [anon_sym_LT_LT_EQ] = ACTIONS(6826),
    [anon_sym_GT_GT_EQ] = ACTIONS(6826),
    [anon_sym_AMP_EQ] = ACTIONS(6826),
    [anon_sym_CARET_EQ] = ACTIONS(6826),
    [anon_sym_PIPE_EQ] = ACTIONS(6826),
    [anon_sym_and_eq] = ACTIONS(6824),
    [anon_sym_or_eq] = ACTIONS(6824),
    [anon_sym_xor_eq] = ACTIONS(6824),
    [anon_sym_LT_EQ_GT] = ACTIONS(6826),
    [anon_sym_or] = ACTIONS(6824),
    [anon_sym_and] = ACTIONS(6824),
    [anon_sym_bitor] = ACTIONS(6824),
    [anon_sym_xor] = ACTIONS(6824),
    [anon_sym_bitand] = ACTIONS(6824),
    [anon_sym_not_eq] = ACTIONS(6824),
    [anon_sym_is] = ACTIONS(6824),
    [anon_sym_as] = ACTIONS(6824),
    [anon_sym_DASH_DASH] = ACTIONS(6826),
    [anon_sym_PLUS_PLUS] = ACTIONS(6826),
    [anon_sym_DOT] = ACTIONS(6824),
    [anon_sym_DOT_STAR] = ACTIONS(6826),
    [anon_sym_DASH_GT] = ACTIONS(6826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6824),
  },
  [3112] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3766),
    [anon_sym_COMMA] = ACTIONS(3766),
    [anon_sym_RPAREN] = ACTIONS(3766),
    [anon_sym_LPAREN2] = ACTIONS(3766),
    [anon_sym_DASH] = ACTIONS(3764),
    [anon_sym_PLUS] = ACTIONS(3764),
    [anon_sym_STAR] = ACTIONS(3764),
    [anon_sym_SLASH] = ACTIONS(3764),
    [anon_sym_PERCENT] = ACTIONS(3764),
    [anon_sym_PIPE_PIPE] = ACTIONS(3766),
    [anon_sym_AMP_AMP] = ACTIONS(3766),
    [anon_sym_PIPE] = ACTIONS(3764),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_AMP] = ACTIONS(3764),
    [anon_sym_EQ_EQ] = ACTIONS(3766),
    [anon_sym_BANG_EQ] = ACTIONS(3766),
    [anon_sym_GT] = ACTIONS(3764),
    [anon_sym_GT_EQ] = ACTIONS(3766),
    [anon_sym_LT_EQ] = ACTIONS(3764),
    [anon_sym_LT] = ACTIONS(3764),
    [anon_sym_LT_LT] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3764),
    [anon_sym_COLON] = ACTIONS(3766),
    [anon_sym_SEMI] = ACTIONS(3766),
    [anon_sym___attribute__] = ACTIONS(3766),
    [anon_sym_LBRACE] = ACTIONS(3766),
    [anon_sym_RBRACE] = ACTIONS(3766),
    [anon_sym_signed] = ACTIONS(6828),
    [anon_sym_unsigned] = ACTIONS(6828),
    [anon_sym_long] = ACTIONS(6828),
    [anon_sym_short] = ACTIONS(6828),
    [anon_sym_LBRACK] = ACTIONS(3766),
    [anon_sym_RBRACK] = ACTIONS(3766),
    [anon_sym_EQ] = ACTIONS(3764),
    [anon_sym_QMARK] = ACTIONS(3766),
    [anon_sym_STAR_EQ] = ACTIONS(3766),
    [anon_sym_SLASH_EQ] = ACTIONS(3766),
    [anon_sym_PERCENT_EQ] = ACTIONS(3766),
    [anon_sym_PLUS_EQ] = ACTIONS(3766),
    [anon_sym_DASH_EQ] = ACTIONS(3766),
    [anon_sym_LT_LT_EQ] = ACTIONS(3766),
    [anon_sym_GT_GT_EQ] = ACTIONS(3766),
    [anon_sym_AMP_EQ] = ACTIONS(3766),
    [anon_sym_CARET_EQ] = ACTIONS(3766),
    [anon_sym_PIPE_EQ] = ACTIONS(3766),
    [anon_sym_and_eq] = ACTIONS(3766),
    [anon_sym_or_eq] = ACTIONS(3766),
    [anon_sym_xor_eq] = ACTIONS(3766),
    [anon_sym_LT_EQ_GT] = ACTIONS(3766),
    [anon_sym_or] = ACTIONS(3764),
    [anon_sym_and] = ACTIONS(3764),
    [anon_sym_bitor] = ACTIONS(3766),
    [anon_sym_xor] = ACTIONS(3764),
    [anon_sym_bitand] = ACTIONS(3766),
    [anon_sym_not_eq] = ACTIONS(3766),
    [anon_sym_is] = ACTIONS(3766),
    [anon_sym_as] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3766),
    [anon_sym_PLUS_PLUS] = ACTIONS(3766),
    [anon_sym_DOT] = ACTIONS(3764),
    [anon_sym_DOT_STAR] = ACTIONS(3766),
    [anon_sym_DASH_GT] = ACTIONS(3766),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3766),
    [anon_sym_let] = ACTIONS(3766),
    [anon_sym_This] = ACTIONS(3766),
  },
  [3113] = {
    [sym_identifier] = ACTIONS(6830),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6832),
    [anon_sym_COMMA] = ACTIONS(6832),
    [anon_sym_RPAREN] = ACTIONS(6832),
    [aux_sym_preproc_if_token2] = ACTIONS(6832),
    [aux_sym_preproc_else_token1] = ACTIONS(6832),
    [aux_sym_preproc_elif_token1] = ACTIONS(6830),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6832),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6832),
    [anon_sym_LPAREN2] = ACTIONS(6832),
    [anon_sym_DASH] = ACTIONS(6830),
    [anon_sym_PLUS] = ACTIONS(6830),
    [anon_sym_STAR] = ACTIONS(6830),
    [anon_sym_SLASH] = ACTIONS(6830),
    [anon_sym_PERCENT] = ACTIONS(6830),
    [anon_sym_PIPE_PIPE] = ACTIONS(6832),
    [anon_sym_AMP_AMP] = ACTIONS(6832),
    [anon_sym_PIPE] = ACTIONS(6830),
    [anon_sym_CARET] = ACTIONS(6830),
    [anon_sym_AMP] = ACTIONS(6830),
    [anon_sym_EQ_EQ] = ACTIONS(6832),
    [anon_sym_BANG_EQ] = ACTIONS(6832),
    [anon_sym_GT] = ACTIONS(6830),
    [anon_sym_GT_EQ] = ACTIONS(6832),
    [anon_sym_LT_EQ] = ACTIONS(6830),
    [anon_sym_LT] = ACTIONS(6830),
    [anon_sym_LT_LT] = ACTIONS(6830),
    [anon_sym_GT_GT] = ACTIONS(6830),
    [anon_sym_COLON] = ACTIONS(6832),
    [anon_sym_SEMI] = ACTIONS(6832),
    [anon_sym___attribute__] = ACTIONS(6830),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6832),
    [anon_sym_LBRACE] = ACTIONS(6832),
    [anon_sym_RBRACE] = ACTIONS(6832),
    [anon_sym_LBRACK] = ACTIONS(6830),
    [anon_sym_RBRACK] = ACTIONS(6832),
    [anon_sym_EQ] = ACTIONS(6830),
    [anon_sym_QMARK] = ACTIONS(6832),
    [anon_sym_STAR_EQ] = ACTIONS(6832),
    [anon_sym_SLASH_EQ] = ACTIONS(6832),
    [anon_sym_PERCENT_EQ] = ACTIONS(6832),
    [anon_sym_PLUS_EQ] = ACTIONS(6832),
    [anon_sym_DASH_EQ] = ACTIONS(6832),
    [anon_sym_LT_LT_EQ] = ACTIONS(6832),
    [anon_sym_GT_GT_EQ] = ACTIONS(6832),
    [anon_sym_AMP_EQ] = ACTIONS(6832),
    [anon_sym_CARET_EQ] = ACTIONS(6832),
    [anon_sym_PIPE_EQ] = ACTIONS(6832),
    [anon_sym_and_eq] = ACTIONS(6830),
    [anon_sym_or_eq] = ACTIONS(6830),
    [anon_sym_xor_eq] = ACTIONS(6830),
    [anon_sym_LT_EQ_GT] = ACTIONS(6832),
    [anon_sym_or] = ACTIONS(6830),
    [anon_sym_and] = ACTIONS(6830),
    [anon_sym_bitor] = ACTIONS(6830),
    [anon_sym_xor] = ACTIONS(6830),
    [anon_sym_bitand] = ACTIONS(6830),
    [anon_sym_not_eq] = ACTIONS(6830),
    [anon_sym_is] = ACTIONS(6830),
    [anon_sym_as] = ACTIONS(6830),
    [anon_sym_DASH_DASH] = ACTIONS(6832),
    [anon_sym_PLUS_PLUS] = ACTIONS(6832),
    [anon_sym_DOT] = ACTIONS(6830),
    [anon_sym_DOT_STAR] = ACTIONS(6832),
    [anon_sym_DASH_GT] = ACTIONS(6832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6830),
  },
  [3114] = {
    [sym_argument_list] = STATE(3282),
    [sym_initializer_list] = STATE(3282),
    [sym_identifier] = ACTIONS(6834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6836),
    [anon_sym_COMMA] = ACTIONS(6836),
    [anon_sym_RPAREN] = ACTIONS(6836),
    [aux_sym_preproc_if_token2] = ACTIONS(6836),
    [aux_sym_preproc_else_token1] = ACTIONS(6836),
    [aux_sym_preproc_elif_token1] = ACTIONS(6834),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6836),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6836),
    [anon_sym_LPAREN2] = ACTIONS(6568),
    [anon_sym_DASH] = ACTIONS(6834),
    [anon_sym_PLUS] = ACTIONS(6834),
    [anon_sym_STAR] = ACTIONS(6834),
    [anon_sym_SLASH] = ACTIONS(6834),
    [anon_sym_PERCENT] = ACTIONS(6834),
    [anon_sym_PIPE_PIPE] = ACTIONS(6836),
    [anon_sym_AMP_AMP] = ACTIONS(6836),
    [anon_sym_PIPE] = ACTIONS(6834),
    [anon_sym_CARET] = ACTIONS(6834),
    [anon_sym_AMP] = ACTIONS(6834),
    [anon_sym_EQ_EQ] = ACTIONS(6836),
    [anon_sym_BANG_EQ] = ACTIONS(6836),
    [anon_sym_GT] = ACTIONS(6834),
    [anon_sym_GT_EQ] = ACTIONS(6836),
    [anon_sym_LT_EQ] = ACTIONS(6834),
    [anon_sym_LT] = ACTIONS(6834),
    [anon_sym_LT_LT] = ACTIONS(6834),
    [anon_sym_GT_GT] = ACTIONS(6834),
    [anon_sym_COLON] = ACTIONS(6836),
    [anon_sym_SEMI] = ACTIONS(6836),
    [anon_sym___attribute__] = ACTIONS(6834),
    [anon_sym_LBRACE] = ACTIONS(4418),
    [anon_sym_RBRACE] = ACTIONS(6836),
    [anon_sym_LBRACK] = ACTIONS(6836),
    [anon_sym_RBRACK] = ACTIONS(6836),
    [anon_sym_EQ] = ACTIONS(6834),
    [anon_sym_QMARK] = ACTIONS(6836),
    [anon_sym_STAR_EQ] = ACTIONS(6836),
    [anon_sym_SLASH_EQ] = ACTIONS(6836),
    [anon_sym_PERCENT_EQ] = ACTIONS(6836),
    [anon_sym_PLUS_EQ] = ACTIONS(6836),
    [anon_sym_DASH_EQ] = ACTIONS(6836),
    [anon_sym_LT_LT_EQ] = ACTIONS(6836),
    [anon_sym_GT_GT_EQ] = ACTIONS(6836),
    [anon_sym_AMP_EQ] = ACTIONS(6836),
    [anon_sym_CARET_EQ] = ACTIONS(6836),
    [anon_sym_PIPE_EQ] = ACTIONS(6836),
    [anon_sym_and_eq] = ACTIONS(6834),
    [anon_sym_or_eq] = ACTIONS(6834),
    [anon_sym_xor_eq] = ACTIONS(6834),
    [anon_sym_LT_EQ_GT] = ACTIONS(6836),
    [anon_sym_or] = ACTIONS(6834),
    [anon_sym_and] = ACTIONS(6834),
    [anon_sym_bitor] = ACTIONS(6834),
    [anon_sym_xor] = ACTIONS(6834),
    [anon_sym_bitand] = ACTIONS(6834),
    [anon_sym_not_eq] = ACTIONS(6834),
    [anon_sym_is] = ACTIONS(6834),
    [anon_sym_as] = ACTIONS(6834),
    [anon_sym_DASH_DASH] = ACTIONS(6836),
    [anon_sym_PLUS_PLUS] = ACTIONS(6836),
    [anon_sym_DOT] = ACTIONS(6834),
    [anon_sym_DOT_STAR] = ACTIONS(6836),
    [anon_sym_DASH_GT] = ACTIONS(6836),
    [sym_comment] = ACTIONS(3),
  },
  [3115] = {
    [sym_identifier] = ACTIONS(6838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6840),
    [anon_sym_COMMA] = ACTIONS(6840),
    [anon_sym_RPAREN] = ACTIONS(6840),
    [aux_sym_preproc_if_token2] = ACTIONS(6840),
    [aux_sym_preproc_else_token1] = ACTIONS(6840),
    [aux_sym_preproc_elif_token1] = ACTIONS(6838),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6840),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6840),
    [anon_sym_LPAREN2] = ACTIONS(6840),
    [anon_sym_DASH] = ACTIONS(6838),
    [anon_sym_PLUS] = ACTIONS(6838),
    [anon_sym_STAR] = ACTIONS(6838),
    [anon_sym_SLASH] = ACTIONS(6838),
    [anon_sym_PERCENT] = ACTIONS(6838),
    [anon_sym_PIPE_PIPE] = ACTIONS(6840),
    [anon_sym_AMP_AMP] = ACTIONS(6840),
    [anon_sym_PIPE] = ACTIONS(6838),
    [anon_sym_CARET] = ACTIONS(6838),
    [anon_sym_AMP] = ACTIONS(6838),
    [anon_sym_EQ_EQ] = ACTIONS(6840),
    [anon_sym_BANG_EQ] = ACTIONS(6840),
    [anon_sym_GT] = ACTIONS(6838),
    [anon_sym_GT_EQ] = ACTIONS(6840),
    [anon_sym_LT_EQ] = ACTIONS(6838),
    [anon_sym_LT] = ACTIONS(6838),
    [anon_sym_LT_LT] = ACTIONS(6838),
    [anon_sym_GT_GT] = ACTIONS(6838),
    [anon_sym_COLON] = ACTIONS(6840),
    [anon_sym_SEMI] = ACTIONS(6840),
    [anon_sym___attribute__] = ACTIONS(6838),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6840),
    [anon_sym_LBRACE] = ACTIONS(6840),
    [anon_sym_RBRACE] = ACTIONS(6840),
    [anon_sym_LBRACK] = ACTIONS(6838),
    [anon_sym_RBRACK] = ACTIONS(6840),
    [anon_sym_EQ] = ACTIONS(6838),
    [anon_sym_QMARK] = ACTIONS(6840),
    [anon_sym_STAR_EQ] = ACTIONS(6840),
    [anon_sym_SLASH_EQ] = ACTIONS(6840),
    [anon_sym_PERCENT_EQ] = ACTIONS(6840),
    [anon_sym_PLUS_EQ] = ACTIONS(6840),
    [anon_sym_DASH_EQ] = ACTIONS(6840),
    [anon_sym_LT_LT_EQ] = ACTIONS(6840),
    [anon_sym_GT_GT_EQ] = ACTIONS(6840),
    [anon_sym_AMP_EQ] = ACTIONS(6840),
    [anon_sym_CARET_EQ] = ACTIONS(6840),
    [anon_sym_PIPE_EQ] = ACTIONS(6840),
    [anon_sym_and_eq] = ACTIONS(6838),
    [anon_sym_or_eq] = ACTIONS(6838),
    [anon_sym_xor_eq] = ACTIONS(6838),
    [anon_sym_LT_EQ_GT] = ACTIONS(6840),
    [anon_sym_or] = ACTIONS(6838),
    [anon_sym_and] = ACTIONS(6838),
    [anon_sym_bitor] = ACTIONS(6838),
    [anon_sym_xor] = ACTIONS(6838),
    [anon_sym_bitand] = ACTIONS(6838),
    [anon_sym_not_eq] = ACTIONS(6838),
    [anon_sym_is] = ACTIONS(6838),
    [anon_sym_as] = ACTIONS(6838),
    [anon_sym_DASH_DASH] = ACTIONS(6840),
    [anon_sym_PLUS_PLUS] = ACTIONS(6840),
    [anon_sym_DOT] = ACTIONS(6838),
    [anon_sym_DOT_STAR] = ACTIONS(6840),
    [anon_sym_DASH_GT] = ACTIONS(6840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6838),
  },
  [3116] = {
    [sym_identifier] = ACTIONS(6842),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6844),
    [anon_sym_COMMA] = ACTIONS(6844),
    [anon_sym_RPAREN] = ACTIONS(6844),
    [aux_sym_preproc_if_token2] = ACTIONS(6844),
    [aux_sym_preproc_else_token1] = ACTIONS(6844),
    [aux_sym_preproc_elif_token1] = ACTIONS(6842),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6844),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6844),
    [anon_sym_LPAREN2] = ACTIONS(6844),
    [anon_sym_DASH] = ACTIONS(6842),
    [anon_sym_PLUS] = ACTIONS(6842),
    [anon_sym_STAR] = ACTIONS(6842),
    [anon_sym_SLASH] = ACTIONS(6842),
    [anon_sym_PERCENT] = ACTIONS(6842),
    [anon_sym_PIPE_PIPE] = ACTIONS(6844),
    [anon_sym_AMP_AMP] = ACTIONS(6844),
    [anon_sym_PIPE] = ACTIONS(6842),
    [anon_sym_CARET] = ACTIONS(6842),
    [anon_sym_AMP] = ACTIONS(6842),
    [anon_sym_EQ_EQ] = ACTIONS(6844),
    [anon_sym_BANG_EQ] = ACTIONS(6844),
    [anon_sym_GT] = ACTIONS(6842),
    [anon_sym_GT_EQ] = ACTIONS(6844),
    [anon_sym_LT_EQ] = ACTIONS(6842),
    [anon_sym_LT] = ACTIONS(6842),
    [anon_sym_LT_LT] = ACTIONS(6842),
    [anon_sym_GT_GT] = ACTIONS(6842),
    [anon_sym_COLON] = ACTIONS(6844),
    [anon_sym_SEMI] = ACTIONS(6844),
    [anon_sym___attribute__] = ACTIONS(6842),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6844),
    [anon_sym_LBRACE] = ACTIONS(6844),
    [anon_sym_RBRACE] = ACTIONS(6844),
    [anon_sym_LBRACK] = ACTIONS(6842),
    [anon_sym_RBRACK] = ACTIONS(6844),
    [anon_sym_EQ] = ACTIONS(6842),
    [anon_sym_QMARK] = ACTIONS(6844),
    [anon_sym_STAR_EQ] = ACTIONS(6844),
    [anon_sym_SLASH_EQ] = ACTIONS(6844),
    [anon_sym_PERCENT_EQ] = ACTIONS(6844),
    [anon_sym_PLUS_EQ] = ACTIONS(6844),
    [anon_sym_DASH_EQ] = ACTIONS(6844),
    [anon_sym_LT_LT_EQ] = ACTIONS(6844),
    [anon_sym_GT_GT_EQ] = ACTIONS(6844),
    [anon_sym_AMP_EQ] = ACTIONS(6844),
    [anon_sym_CARET_EQ] = ACTIONS(6844),
    [anon_sym_PIPE_EQ] = ACTIONS(6844),
    [anon_sym_and_eq] = ACTIONS(6842),
    [anon_sym_or_eq] = ACTIONS(6842),
    [anon_sym_xor_eq] = ACTIONS(6842),
    [anon_sym_LT_EQ_GT] = ACTIONS(6844),
    [anon_sym_or] = ACTIONS(6842),
    [anon_sym_and] = ACTIONS(6842),
    [anon_sym_bitor] = ACTIONS(6842),
    [anon_sym_xor] = ACTIONS(6842),
    [anon_sym_bitand] = ACTIONS(6842),
    [anon_sym_not_eq] = ACTIONS(6842),
    [anon_sym_is] = ACTIONS(6842),
    [anon_sym_as] = ACTIONS(6842),
    [anon_sym_DASH_DASH] = ACTIONS(6844),
    [anon_sym_PLUS_PLUS] = ACTIONS(6844),
    [anon_sym_DOT] = ACTIONS(6842),
    [anon_sym_DOT_STAR] = ACTIONS(6844),
    [anon_sym_DASH_GT] = ACTIONS(6844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6842),
  },
  [3117] = {
    [sym_attribute_declaration] = STATE(3117),
    [aux_sym_attributed_declarator_repeat1] = STATE(3117),
    [sym_identifier] = ACTIONS(6846),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6848),
    [anon_sym_COMMA] = ACTIONS(6848),
    [anon_sym_RPAREN] = ACTIONS(6848),
    [aux_sym_preproc_if_token2] = ACTIONS(6848),
    [aux_sym_preproc_else_token1] = ACTIONS(6848),
    [aux_sym_preproc_elif_token1] = ACTIONS(6846),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6848),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6848),
    [anon_sym_LPAREN2] = ACTIONS(6848),
    [anon_sym_DASH] = ACTIONS(6846),
    [anon_sym_PLUS] = ACTIONS(6846),
    [anon_sym_STAR] = ACTIONS(6846),
    [anon_sym_SLASH] = ACTIONS(6846),
    [anon_sym_PERCENT] = ACTIONS(6846),
    [anon_sym_PIPE_PIPE] = ACTIONS(6848),
    [anon_sym_AMP_AMP] = ACTIONS(6848),
    [anon_sym_PIPE] = ACTIONS(6846),
    [anon_sym_CARET] = ACTIONS(6846),
    [anon_sym_AMP] = ACTIONS(6846),
    [anon_sym_EQ_EQ] = ACTIONS(6848),
    [anon_sym_BANG_EQ] = ACTIONS(6848),
    [anon_sym_GT] = ACTIONS(6846),
    [anon_sym_GT_EQ] = ACTIONS(6848),
    [anon_sym_LT_EQ] = ACTIONS(6846),
    [anon_sym_LT] = ACTIONS(6846),
    [anon_sym_LT_LT] = ACTIONS(6846),
    [anon_sym_GT_GT] = ACTIONS(6846),
    [anon_sym_COLON] = ACTIONS(6848),
    [anon_sym_SEMI] = ACTIONS(6848),
    [anon_sym___attribute__] = ACTIONS(6846),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6850),
    [anon_sym_RBRACE] = ACTIONS(6848),
    [anon_sym_LBRACK] = ACTIONS(6846),
    [anon_sym_RBRACK] = ACTIONS(6848),
    [anon_sym_EQ] = ACTIONS(6846),
    [anon_sym_QMARK] = ACTIONS(6848),
    [anon_sym_STAR_EQ] = ACTIONS(6848),
    [anon_sym_SLASH_EQ] = ACTIONS(6848),
    [anon_sym_PERCENT_EQ] = ACTIONS(6848),
    [anon_sym_PLUS_EQ] = ACTIONS(6848),
    [anon_sym_DASH_EQ] = ACTIONS(6848),
    [anon_sym_LT_LT_EQ] = ACTIONS(6848),
    [anon_sym_GT_GT_EQ] = ACTIONS(6848),
    [anon_sym_AMP_EQ] = ACTIONS(6848),
    [anon_sym_CARET_EQ] = ACTIONS(6848),
    [anon_sym_PIPE_EQ] = ACTIONS(6848),
    [anon_sym_and_eq] = ACTIONS(6846),
    [anon_sym_or_eq] = ACTIONS(6846),
    [anon_sym_xor_eq] = ACTIONS(6846),
    [anon_sym_LT_EQ_GT] = ACTIONS(6848),
    [anon_sym_or] = ACTIONS(6846),
    [anon_sym_and] = ACTIONS(6846),
    [anon_sym_bitor] = ACTIONS(6846),
    [anon_sym_xor] = ACTIONS(6846),
    [anon_sym_bitand] = ACTIONS(6846),
    [anon_sym_not_eq] = ACTIONS(6846),
    [anon_sym_is] = ACTIONS(6846),
    [anon_sym_as] = ACTIONS(6846),
    [anon_sym_DASH_DASH] = ACTIONS(6848),
    [anon_sym_PLUS_PLUS] = ACTIONS(6848),
    [anon_sym_DOT] = ACTIONS(6846),
    [anon_sym_DOT_STAR] = ACTIONS(6848),
    [anon_sym_DASH_GT] = ACTIONS(6848),
    [sym_comment] = ACTIONS(3),
  },
  [3118] = {
    [sym_string_literal] = STATE(2997),
    [sym_raw_string_literal] = STATE(2997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6596),
    [anon_sym_COMMA] = ACTIONS(6596),
    [anon_sym_RPAREN] = ACTIONS(6596),
    [anon_sym_LPAREN2] = ACTIONS(6596),
    [anon_sym_DASH] = ACTIONS(6594),
    [anon_sym_PLUS] = ACTIONS(6594),
    [anon_sym_STAR] = ACTIONS(6594),
    [anon_sym_SLASH] = ACTIONS(6594),
    [anon_sym_PERCENT] = ACTIONS(6594),
    [anon_sym_PIPE_PIPE] = ACTIONS(6596),
    [anon_sym_AMP_AMP] = ACTIONS(6596),
    [anon_sym_PIPE] = ACTIONS(6594),
    [anon_sym_CARET] = ACTIONS(6594),
    [anon_sym_AMP] = ACTIONS(6594),
    [anon_sym_EQ_EQ] = ACTIONS(6596),
    [anon_sym_BANG_EQ] = ACTIONS(6596),
    [anon_sym_GT] = ACTIONS(6594),
    [anon_sym_GT_EQ] = ACTIONS(6596),
    [anon_sym_LT_EQ] = ACTIONS(6594),
    [anon_sym_LT] = ACTIONS(6594),
    [anon_sym_LT_LT] = ACTIONS(6594),
    [anon_sym_GT_GT] = ACTIONS(6594),
    [anon_sym_LBRACK] = ACTIONS(6596),
    [anon_sym_EQ] = ACTIONS(6594),
    [anon_sym_QMARK] = ACTIONS(6596),
    [anon_sym_STAR_EQ] = ACTIONS(6596),
    [anon_sym_SLASH_EQ] = ACTIONS(6596),
    [anon_sym_PERCENT_EQ] = ACTIONS(6596),
    [anon_sym_PLUS_EQ] = ACTIONS(6596),
    [anon_sym_DASH_EQ] = ACTIONS(6596),
    [anon_sym_LT_LT_EQ] = ACTIONS(6596),
    [anon_sym_GT_GT_EQ] = ACTIONS(6596),
    [anon_sym_AMP_EQ] = ACTIONS(6596),
    [anon_sym_CARET_EQ] = ACTIONS(6596),
    [anon_sym_PIPE_EQ] = ACTIONS(6596),
    [anon_sym_and_eq] = ACTIONS(6594),
    [anon_sym_or_eq] = ACTIONS(6594),
    [anon_sym_xor_eq] = ACTIONS(6594),
    [anon_sym_LT_EQ_GT] = ACTIONS(6596),
    [anon_sym_or] = ACTIONS(6594),
    [anon_sym_and] = ACTIONS(6594),
    [anon_sym_bitor] = ACTIONS(6594),
    [anon_sym_xor] = ACTIONS(6594),
    [anon_sym_bitand] = ACTIONS(6594),
    [anon_sym_not_eq] = ACTIONS(6594),
    [anon_sym_is] = ACTIONS(6594),
    [anon_sym_as] = ACTIONS(6594),
    [anon_sym_DASH_DASH] = ACTIONS(6596),
    [anon_sym_PLUS_PLUS] = ACTIONS(6596),
    [anon_sym_DOT] = ACTIONS(6594),
    [anon_sym_DOT_STAR] = ACTIONS(6596),
    [anon_sym_DASH_GT] = ACTIONS(6594),
    [anon_sym_L_DQUOTE] = ACTIONS(6169),
    [anon_sym_u_DQUOTE] = ACTIONS(6169),
    [anon_sym_U_DQUOTE] = ACTIONS(6169),
    [anon_sym_u8_DQUOTE] = ACTIONS(6169),
    [anon_sym_DQUOTE] = ACTIONS(6169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6171),
    [anon_sym_LR_DQUOTE] = ACTIONS(6171),
    [anon_sym_uR_DQUOTE] = ACTIONS(6171),
    [anon_sym_UR_DQUOTE] = ACTIONS(6171),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6171),
    [anon_sym_DASH_GT_STAR] = ACTIONS(6596),
    [sym_literal_suffix] = ACTIONS(6853),
  },
  [3119] = {
    [sym_attribute_declaration] = STATE(3117),
    [aux_sym_attributed_declarator_repeat1] = STATE(3117),
    [sym_identifier] = ACTIONS(6855),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6857),
    [anon_sym_COMMA] = ACTIONS(6857),
    [anon_sym_RPAREN] = ACTIONS(6857),
    [aux_sym_preproc_if_token2] = ACTIONS(6857),
    [aux_sym_preproc_else_token1] = ACTIONS(6857),
    [aux_sym_preproc_elif_token1] = ACTIONS(6855),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6857),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6857),
    [anon_sym_LPAREN2] = ACTIONS(6857),
    [anon_sym_DASH] = ACTIONS(6855),
    [anon_sym_PLUS] = ACTIONS(6855),
    [anon_sym_STAR] = ACTIONS(6855),
    [anon_sym_SLASH] = ACTIONS(6855),
    [anon_sym_PERCENT] = ACTIONS(6855),
    [anon_sym_PIPE_PIPE] = ACTIONS(6857),
    [anon_sym_AMP_AMP] = ACTIONS(6857),
    [anon_sym_PIPE] = ACTIONS(6855),
    [anon_sym_CARET] = ACTIONS(6855),
    [anon_sym_AMP] = ACTIONS(6855),
    [anon_sym_EQ_EQ] = ACTIONS(6857),
    [anon_sym_BANG_EQ] = ACTIONS(6857),
    [anon_sym_GT] = ACTIONS(6855),
    [anon_sym_GT_EQ] = ACTIONS(6857),
    [anon_sym_LT_EQ] = ACTIONS(6855),
    [anon_sym_LT] = ACTIONS(6855),
    [anon_sym_LT_LT] = ACTIONS(6855),
    [anon_sym_GT_GT] = ACTIONS(6855),
    [anon_sym_COLON] = ACTIONS(6857),
    [anon_sym_SEMI] = ACTIONS(6857),
    [anon_sym___attribute__] = ACTIONS(6855),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6787),
    [anon_sym_RBRACE] = ACTIONS(6857),
    [anon_sym_LBRACK] = ACTIONS(6855),
    [anon_sym_RBRACK] = ACTIONS(6857),
    [anon_sym_EQ] = ACTIONS(6855),
    [anon_sym_QMARK] = ACTIONS(6857),
    [anon_sym_STAR_EQ] = ACTIONS(6857),
    [anon_sym_SLASH_EQ] = ACTIONS(6857),
    [anon_sym_PERCENT_EQ] = ACTIONS(6857),
    [anon_sym_PLUS_EQ] = ACTIONS(6857),
    [anon_sym_DASH_EQ] = ACTIONS(6857),
    [anon_sym_LT_LT_EQ] = ACTIONS(6857),
    [anon_sym_GT_GT_EQ] = ACTIONS(6857),
    [anon_sym_AMP_EQ] = ACTIONS(6857),
    [anon_sym_CARET_EQ] = ACTIONS(6857),
    [anon_sym_PIPE_EQ] = ACTIONS(6857),
    [anon_sym_and_eq] = ACTIONS(6855),
    [anon_sym_or_eq] = ACTIONS(6855),
    [anon_sym_xor_eq] = ACTIONS(6855),
    [anon_sym_LT_EQ_GT] = ACTIONS(6857),
    [anon_sym_or] = ACTIONS(6855),
    [anon_sym_and] = ACTIONS(6855),
    [anon_sym_bitor] = ACTIONS(6855),
    [anon_sym_xor] = ACTIONS(6855),
    [anon_sym_bitand] = ACTIONS(6855),
    [anon_sym_not_eq] = ACTIONS(6855),
    [anon_sym_is] = ACTIONS(6855),
    [anon_sym_as] = ACTIONS(6855),
    [anon_sym_DASH_DASH] = ACTIONS(6857),
    [anon_sym_PLUS_PLUS] = ACTIONS(6857),
    [anon_sym_DOT] = ACTIONS(6855),
    [anon_sym_DOT_STAR] = ACTIONS(6857),
    [anon_sym_DASH_GT] = ACTIONS(6857),
    [sym_comment] = ACTIONS(3),
  },
  [3120] = {
    [sym_argument_list] = STATE(3331),
    [sym_initializer_list] = STATE(3331),
    [sym_identifier] = ACTIONS(6859),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6861),
    [anon_sym_COMMA] = ACTIONS(6861),
    [anon_sym_RPAREN] = ACTIONS(6861),
    [aux_sym_preproc_if_token2] = ACTIONS(6861),
    [aux_sym_preproc_else_token1] = ACTIONS(6861),
    [aux_sym_preproc_elif_token1] = ACTIONS(6859),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6861),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6861),
    [anon_sym_LPAREN2] = ACTIONS(6568),
    [anon_sym_DASH] = ACTIONS(6859),
    [anon_sym_PLUS] = ACTIONS(6859),
    [anon_sym_STAR] = ACTIONS(6859),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [anon_sym_PIPE_PIPE] = ACTIONS(6861),
    [anon_sym_AMP_AMP] = ACTIONS(6861),
    [anon_sym_PIPE] = ACTIONS(6859),
    [anon_sym_CARET] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(6859),
    [anon_sym_EQ_EQ] = ACTIONS(6861),
    [anon_sym_BANG_EQ] = ACTIONS(6861),
    [anon_sym_GT] = ACTIONS(6859),
    [anon_sym_GT_EQ] = ACTIONS(6861),
    [anon_sym_LT_EQ] = ACTIONS(6859),
    [anon_sym_LT] = ACTIONS(6859),
    [anon_sym_LT_LT] = ACTIONS(6859),
    [anon_sym_GT_GT] = ACTIONS(6859),
    [anon_sym_COLON] = ACTIONS(6861),
    [anon_sym_SEMI] = ACTIONS(6861),
    [anon_sym___attribute__] = ACTIONS(6859),
    [anon_sym_LBRACE] = ACTIONS(4418),
    [anon_sym_RBRACE] = ACTIONS(6861),
    [anon_sym_LBRACK] = ACTIONS(6861),
    [anon_sym_RBRACK] = ACTIONS(6861),
    [anon_sym_EQ] = ACTIONS(6859),
    [anon_sym_QMARK] = ACTIONS(6861),
    [anon_sym_STAR_EQ] = ACTIONS(6861),
    [anon_sym_SLASH_EQ] = ACTIONS(6861),
    [anon_sym_PERCENT_EQ] = ACTIONS(6861),
    [anon_sym_PLUS_EQ] = ACTIONS(6861),
    [anon_sym_DASH_EQ] = ACTIONS(6861),
    [anon_sym_LT_LT_EQ] = ACTIONS(6861),
    [anon_sym_GT_GT_EQ] = ACTIONS(6861),
    [anon_sym_AMP_EQ] = ACTIONS(6861),
    [anon_sym_CARET_EQ] = ACTIONS(6861),
    [anon_sym_PIPE_EQ] = ACTIONS(6861),
    [anon_sym_and_eq] = ACTIONS(6859),
    [anon_sym_or_eq] = ACTIONS(6859),
    [anon_sym_xor_eq] = ACTIONS(6859),
    [anon_sym_LT_EQ_GT] = ACTIONS(6861),
    [anon_sym_or] = ACTIONS(6859),
    [anon_sym_and] = ACTIONS(6859),
    [anon_sym_bitor] = ACTIONS(6859),
    [anon_sym_xor] = ACTIONS(6859),
    [anon_sym_bitand] = ACTIONS(6859),
    [anon_sym_not_eq] = ACTIONS(6859),
    [anon_sym_is] = ACTIONS(6859),
    [anon_sym_as] = ACTIONS(6859),
    [anon_sym_DASH_DASH] = ACTIONS(6861),
    [anon_sym_PLUS_PLUS] = ACTIONS(6861),
    [anon_sym_DOT] = ACTIONS(6859),
    [anon_sym_DOT_STAR] = ACTIONS(6861),
    [anon_sym_DASH_GT] = ACTIONS(6861),
    [sym_comment] = ACTIONS(3),
  },
  [3121] = {
    [sym_template_argument_list] = STATE(3167),
    [sym_identifier] = ACTIONS(2181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2171),
    [anon_sym_COMMA] = ACTIONS(2171),
    [anon_sym_RPAREN] = ACTIONS(2171),
    [aux_sym_preproc_if_token2] = ACTIONS(2171),
    [aux_sym_preproc_else_token1] = ACTIONS(2171),
    [aux_sym_preproc_elif_token1] = ACTIONS(2181),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2171),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2171),
    [anon_sym_LPAREN2] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2171),
    [anon_sym_AMP_AMP] = ACTIONS(2171),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2171),
    [anon_sym_BANG_EQ] = ACTIONS(2171),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2171),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(6557),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(2181),
    [anon_sym_SEMI] = ACTIONS(2171),
    [anon_sym___attribute__] = ACTIONS(2181),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2176),
    [anon_sym_RBRACE] = ACTIONS(2171),
    [anon_sym_LBRACK] = ACTIONS(2171),
    [anon_sym_RBRACK] = ACTIONS(2171),
    [anon_sym_EQ] = ACTIONS(2181),
    [anon_sym_QMARK] = ACTIONS(2171),
    [anon_sym_STAR_EQ] = ACTIONS(2171),
    [anon_sym_SLASH_EQ] = ACTIONS(2171),
    [anon_sym_PERCENT_EQ] = ACTIONS(2171),
    [anon_sym_PLUS_EQ] = ACTIONS(2171),
    [anon_sym_DASH_EQ] = ACTIONS(2171),
    [anon_sym_LT_LT_EQ] = ACTIONS(2171),
    [anon_sym_GT_GT_EQ] = ACTIONS(2171),
    [anon_sym_AMP_EQ] = ACTIONS(2171),
    [anon_sym_CARET_EQ] = ACTIONS(2171),
    [anon_sym_PIPE_EQ] = ACTIONS(2171),
    [anon_sym_and_eq] = ACTIONS(2181),
    [anon_sym_or_eq] = ACTIONS(2181),
    [anon_sym_xor_eq] = ACTIONS(2181),
    [anon_sym_LT_EQ_GT] = ACTIONS(2171),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2181),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2181),
    [anon_sym_not_eq] = ACTIONS(2181),
    [anon_sym_is] = ACTIONS(2181),
    [anon_sym_as] = ACTIONS(2181),
    [anon_sym_DASH_DASH] = ACTIONS(2171),
    [anon_sym_PLUS_PLUS] = ACTIONS(2171),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2171),
    [anon_sym_DASH_GT] = ACTIONS(2171),
    [sym_comment] = ACTIONS(3),
  },
  [3122] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3057),
    [sym_identifier] = ACTIONS(2742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2740),
    [anon_sym_COMMA] = ACTIONS(2740),
    [aux_sym_preproc_if_token2] = ACTIONS(2740),
    [aux_sym_preproc_else_token1] = ACTIONS(2740),
    [aux_sym_preproc_elif_token1] = ACTIONS(2742),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2740),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2740),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2742),
    [anon_sym_PLUS] = ACTIONS(2742),
    [anon_sym_STAR] = ACTIONS(2742),
    [anon_sym_SLASH] = ACTIONS(2742),
    [anon_sym_PERCENT] = ACTIONS(2742),
    [anon_sym_PIPE_PIPE] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_PIPE] = ACTIONS(2742),
    [anon_sym_CARET] = ACTIONS(2742),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_EQ_EQ] = ACTIONS(2740),
    [anon_sym_BANG_EQ] = ACTIONS(2740),
    [anon_sym_GT] = ACTIONS(2742),
    [anon_sym_GT_EQ] = ACTIONS(2740),
    [anon_sym_LT_EQ] = ACTIONS(2742),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_LT_LT] = ACTIONS(2742),
    [anon_sym_GT_GT] = ACTIONS(2742),
    [anon_sym_LBRACE] = ACTIONS(2740),
    [anon_sym_signed] = ACTIONS(6746),
    [anon_sym_unsigned] = ACTIONS(6746),
    [anon_sym_long] = ACTIONS(6746),
    [anon_sym_short] = ACTIONS(6746),
    [anon_sym_LBRACK] = ACTIONS(2740),
    [anon_sym_EQ] = ACTIONS(2742),
    [anon_sym_QMARK] = ACTIONS(2740),
    [anon_sym_STAR_EQ] = ACTIONS(2740),
    [anon_sym_SLASH_EQ] = ACTIONS(2740),
    [anon_sym_PERCENT_EQ] = ACTIONS(2740),
    [anon_sym_PLUS_EQ] = ACTIONS(2740),
    [anon_sym_DASH_EQ] = ACTIONS(2740),
    [anon_sym_LT_LT_EQ] = ACTIONS(2740),
    [anon_sym_GT_GT_EQ] = ACTIONS(2740),
    [anon_sym_AMP_EQ] = ACTIONS(2740),
    [anon_sym_CARET_EQ] = ACTIONS(2740),
    [anon_sym_PIPE_EQ] = ACTIONS(2740),
    [anon_sym_and_eq] = ACTIONS(2742),
    [anon_sym_or_eq] = ACTIONS(2742),
    [anon_sym_xor_eq] = ACTIONS(2742),
    [anon_sym_LT_EQ_GT] = ACTIONS(2740),
    [anon_sym_or] = ACTIONS(2742),
    [anon_sym_and] = ACTIONS(2742),
    [anon_sym_bitor] = ACTIONS(2742),
    [anon_sym_xor] = ACTIONS(2742),
    [anon_sym_bitand] = ACTIONS(2742),
    [anon_sym_not_eq] = ACTIONS(2742),
    [anon_sym_is] = ACTIONS(2742),
    [anon_sym_as] = ACTIONS(2742),
    [anon_sym_DASH_DASH] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2740),
    [anon_sym_DOT] = ACTIONS(2742),
    [anon_sym_DOT_STAR] = ACTIONS(2740),
    [anon_sym_DASH_GT] = ACTIONS(2740),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
  },
  [3123] = {
    [sym_attribute_specifier] = STATE(2897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3838),
    [anon_sym_COMMA] = ACTIONS(3838),
    [anon_sym_RPAREN] = ACTIONS(3838),
    [anon_sym_LPAREN2] = ACTIONS(3838),
    [anon_sym_DASH] = ACTIONS(3836),
    [anon_sym_PLUS] = ACTIONS(3836),
    [anon_sym_STAR] = ACTIONS(3838),
    [anon_sym_SLASH] = ACTIONS(3836),
    [anon_sym_PERCENT] = ACTIONS(3838),
    [anon_sym_PIPE_PIPE] = ACTIONS(3838),
    [anon_sym_AMP_AMP] = ACTIONS(3838),
    [anon_sym_PIPE] = ACTIONS(3836),
    [anon_sym_CARET] = ACTIONS(3838),
    [anon_sym_AMP] = ACTIONS(3836),
    [anon_sym_EQ_EQ] = ACTIONS(3838),
    [anon_sym_BANG_EQ] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3836),
    [anon_sym_GT_EQ] = ACTIONS(3838),
    [anon_sym_LT_EQ] = ACTIONS(3836),
    [anon_sym_LT] = ACTIONS(3836),
    [anon_sym_LT_LT] = ACTIONS(3838),
    [anon_sym_GT_GT] = ACTIONS(3838),
    [anon_sym_COLON] = ACTIONS(3838),
    [anon_sym_SEMI] = ACTIONS(3838),
    [anon_sym___extension__] = ACTIONS(3838),
    [anon_sym___attribute__] = ACTIONS(6621),
    [anon_sym_LBRACE] = ACTIONS(3838),
    [anon_sym_RBRACE] = ACTIONS(3838),
    [anon_sym_LBRACK] = ACTIONS(3838),
    [anon_sym_RBRACK] = ACTIONS(3838),
    [anon_sym_const] = ACTIONS(3836),
    [anon_sym_constexpr] = ACTIONS(3838),
    [anon_sym_volatile] = ACTIONS(3838),
    [anon_sym_restrict] = ACTIONS(3838),
    [anon_sym___restrict__] = ACTIONS(3838),
    [anon_sym__Atomic] = ACTIONS(3838),
    [anon_sym__Noreturn] = ACTIONS(3838),
    [anon_sym_noreturn] = ACTIONS(3838),
    [anon_sym_mutable] = ACTIONS(3838),
    [anon_sym_constinit] = ACTIONS(3838),
    [anon_sym_consteval] = ACTIONS(3838),
    [anon_sym_alignas] = ACTIONS(3838),
    [anon_sym__Alignas] = ACTIONS(3838),
    [anon_sym_QMARK] = ACTIONS(3838),
    [anon_sym_LT_EQ_GT] = ACTIONS(3838),
    [anon_sym_or] = ACTIONS(3838),
    [anon_sym_and] = ACTIONS(3838),
    [anon_sym_bitor] = ACTIONS(3838),
    [anon_sym_xor] = ACTIONS(3838),
    [anon_sym_bitand] = ACTIONS(3838),
    [anon_sym_not_eq] = ACTIONS(3838),
    [anon_sym_is] = ACTIONS(3838),
    [anon_sym_as] = ACTIONS(3838),
    [anon_sym_DASH_DASH] = ACTIONS(3838),
    [anon_sym_PLUS_PLUS] = ACTIONS(3838),
    [anon_sym_DOT] = ACTIONS(3836),
    [anon_sym_DOT_STAR] = ACTIONS(3838),
    [anon_sym_DASH_GT] = ACTIONS(3838),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3838),
    [anon_sym_let] = ACTIONS(3838),
    [anon_sym_This] = ACTIONS(3838),
    [anon_sym_final] = ACTIONS(3838),
    [anon_sym_override] = ACTIONS(3838),
    [anon_sym_requires] = ACTIONS(3838),
    [anon_sym_where] = ACTIONS(3838),
  },
  [3124] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3126),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3390),
    [anon_sym_COMMA] = ACTIONS(3390),
    [anon_sym_RPAREN] = ACTIONS(3390),
    [anon_sym_LPAREN2] = ACTIONS(3390),
    [anon_sym_DASH] = ACTIONS(3392),
    [anon_sym_PLUS] = ACTIONS(3392),
    [anon_sym_STAR] = ACTIONS(3392),
    [anon_sym_SLASH] = ACTIONS(3392),
    [anon_sym_PERCENT] = ACTIONS(3392),
    [anon_sym_PIPE_PIPE] = ACTIONS(3390),
    [anon_sym_AMP_AMP] = ACTIONS(3390),
    [anon_sym_PIPE] = ACTIONS(3392),
    [anon_sym_CARET] = ACTIONS(3392),
    [anon_sym_AMP] = ACTIONS(3392),
    [anon_sym_EQ_EQ] = ACTIONS(3390),
    [anon_sym_BANG_EQ] = ACTIONS(3390),
    [anon_sym_GT] = ACTIONS(3392),
    [anon_sym_GT_EQ] = ACTIONS(3390),
    [anon_sym_LT_EQ] = ACTIONS(3392),
    [anon_sym_LT] = ACTIONS(3392),
    [anon_sym_LT_LT] = ACTIONS(3392),
    [anon_sym_GT_GT] = ACTIONS(3392),
    [anon_sym_COLON] = ACTIONS(3390),
    [anon_sym_SEMI] = ACTIONS(3390),
    [anon_sym___attribute__] = ACTIONS(3390),
    [anon_sym_LBRACE] = ACTIONS(3390),
    [anon_sym_RBRACE] = ACTIONS(3390),
    [anon_sym_signed] = ACTIONS(6863),
    [anon_sym_unsigned] = ACTIONS(6863),
    [anon_sym_long] = ACTIONS(6863),
    [anon_sym_short] = ACTIONS(6863),
    [anon_sym_LBRACK] = ACTIONS(3390),
    [anon_sym_RBRACK] = ACTIONS(3390),
    [anon_sym_EQ] = ACTIONS(3392),
    [anon_sym_QMARK] = ACTIONS(3390),
    [anon_sym_STAR_EQ] = ACTIONS(3390),
    [anon_sym_SLASH_EQ] = ACTIONS(3390),
    [anon_sym_PERCENT_EQ] = ACTIONS(3390),
    [anon_sym_PLUS_EQ] = ACTIONS(3390),
    [anon_sym_DASH_EQ] = ACTIONS(3390),
    [anon_sym_LT_LT_EQ] = ACTIONS(3390),
    [anon_sym_GT_GT_EQ] = ACTIONS(3390),
    [anon_sym_AMP_EQ] = ACTIONS(3390),
    [anon_sym_CARET_EQ] = ACTIONS(3390),
    [anon_sym_PIPE_EQ] = ACTIONS(3390),
    [anon_sym_and_eq] = ACTIONS(3390),
    [anon_sym_or_eq] = ACTIONS(3390),
    [anon_sym_xor_eq] = ACTIONS(3390),
    [anon_sym_LT_EQ_GT] = ACTIONS(3390),
    [anon_sym_or] = ACTIONS(3392),
    [anon_sym_and] = ACTIONS(3392),
    [anon_sym_bitor] = ACTIONS(3390),
    [anon_sym_xor] = ACTIONS(3392),
    [anon_sym_bitand] = ACTIONS(3390),
    [anon_sym_not_eq] = ACTIONS(3390),
    [anon_sym_is] = ACTIONS(3390),
    [anon_sym_as] = ACTIONS(3390),
    [anon_sym_DASH_DASH] = ACTIONS(3390),
    [anon_sym_PLUS_PLUS] = ACTIONS(3390),
    [anon_sym_DOT] = ACTIONS(3392),
    [anon_sym_DOT_STAR] = ACTIONS(3390),
    [anon_sym_DASH_GT] = ACTIONS(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3390),
    [anon_sym_let] = ACTIONS(3390),
    [anon_sym_This] = ACTIONS(3390),
  },
  [3125] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3759),
    [anon_sym_RPAREN] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3757),
    [anon_sym_PLUS] = ACTIONS(3757),
    [anon_sym_STAR] = ACTIONS(3757),
    [anon_sym_SLASH] = ACTIONS(3757),
    [anon_sym_PERCENT] = ACTIONS(3757),
    [anon_sym_PIPE_PIPE] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_PIPE] = ACTIONS(3757),
    [anon_sym_CARET] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3757),
    [anon_sym_EQ_EQ] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_GT] = ACTIONS(3757),
    [anon_sym_GT_EQ] = ACTIONS(3759),
    [anon_sym_LT_EQ] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_LT_LT] = ACTIONS(3757),
    [anon_sym_GT_GT] = ACTIONS(3757),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_SEMI] = ACTIONS(3759),
    [anon_sym___attribute__] = ACTIONS(3759),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_RBRACE] = ACTIONS(3759),
    [anon_sym_signed] = ACTIONS(6865),
    [anon_sym_unsigned] = ACTIONS(6865),
    [anon_sym_long] = ACTIONS(6865),
    [anon_sym_short] = ACTIONS(6865),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_RBRACK] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_STAR_EQ] = ACTIONS(3759),
    [anon_sym_SLASH_EQ] = ACTIONS(3759),
    [anon_sym_PERCENT_EQ] = ACTIONS(3759),
    [anon_sym_PLUS_EQ] = ACTIONS(3759),
    [anon_sym_DASH_EQ] = ACTIONS(3759),
    [anon_sym_LT_LT_EQ] = ACTIONS(3759),
    [anon_sym_GT_GT_EQ] = ACTIONS(3759),
    [anon_sym_AMP_EQ] = ACTIONS(3759),
    [anon_sym_CARET_EQ] = ACTIONS(3759),
    [anon_sym_PIPE_EQ] = ACTIONS(3759),
    [anon_sym_and_eq] = ACTIONS(3759),
    [anon_sym_or_eq] = ACTIONS(3759),
    [anon_sym_xor_eq] = ACTIONS(3759),
    [anon_sym_LT_EQ_GT] = ACTIONS(3759),
    [anon_sym_or] = ACTIONS(3757),
    [anon_sym_and] = ACTIONS(3757),
    [anon_sym_bitor] = ACTIONS(3759),
    [anon_sym_xor] = ACTIONS(3757),
    [anon_sym_bitand] = ACTIONS(3759),
    [anon_sym_not_eq] = ACTIONS(3759),
    [anon_sym_is] = ACTIONS(3759),
    [anon_sym_as] = ACTIONS(3759),
    [anon_sym_DASH_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_PLUS] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(3757),
    [anon_sym_DOT_STAR] = ACTIONS(3759),
    [anon_sym_DASH_GT] = ACTIONS(3759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_This] = ACTIONS(3759),
  },
  [3126] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3752),
    [anon_sym_COMMA] = ACTIONS(3752),
    [anon_sym_RPAREN] = ACTIONS(3752),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_DASH] = ACTIONS(3750),
    [anon_sym_PLUS] = ACTIONS(3750),
    [anon_sym_STAR] = ACTIONS(3750),
    [anon_sym_SLASH] = ACTIONS(3750),
    [anon_sym_PERCENT] = ACTIONS(3750),
    [anon_sym_PIPE_PIPE] = ACTIONS(3752),
    [anon_sym_AMP_AMP] = ACTIONS(3752),
    [anon_sym_PIPE] = ACTIONS(3750),
    [anon_sym_CARET] = ACTIONS(3750),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_EQ_EQ] = ACTIONS(3752),
    [anon_sym_BANG_EQ] = ACTIONS(3752),
    [anon_sym_GT] = ACTIONS(3750),
    [anon_sym_GT_EQ] = ACTIONS(3752),
    [anon_sym_LT_EQ] = ACTIONS(3750),
    [anon_sym_LT] = ACTIONS(3750),
    [anon_sym_LT_LT] = ACTIONS(3750),
    [anon_sym_GT_GT] = ACTIONS(3750),
    [anon_sym_COLON] = ACTIONS(3752),
    [anon_sym_SEMI] = ACTIONS(3752),
    [anon_sym___attribute__] = ACTIONS(3752),
    [anon_sym_LBRACE] = ACTIONS(3752),
    [anon_sym_RBRACE] = ACTIONS(3752),
    [anon_sym_signed] = ACTIONS(6865),
    [anon_sym_unsigned] = ACTIONS(6865),
    [anon_sym_long] = ACTIONS(6865),
    [anon_sym_short] = ACTIONS(6865),
    [anon_sym_LBRACK] = ACTIONS(3752),
    [anon_sym_RBRACK] = ACTIONS(3752),
    [anon_sym_EQ] = ACTIONS(3750),
    [anon_sym_QMARK] = ACTIONS(3752),
    [anon_sym_STAR_EQ] = ACTIONS(3752),
    [anon_sym_SLASH_EQ] = ACTIONS(3752),
    [anon_sym_PERCENT_EQ] = ACTIONS(3752),
    [anon_sym_PLUS_EQ] = ACTIONS(3752),
    [anon_sym_DASH_EQ] = ACTIONS(3752),
    [anon_sym_LT_LT_EQ] = ACTIONS(3752),
    [anon_sym_GT_GT_EQ] = ACTIONS(3752),
    [anon_sym_AMP_EQ] = ACTIONS(3752),
    [anon_sym_CARET_EQ] = ACTIONS(3752),
    [anon_sym_PIPE_EQ] = ACTIONS(3752),
    [anon_sym_and_eq] = ACTIONS(3752),
    [anon_sym_or_eq] = ACTIONS(3752),
    [anon_sym_xor_eq] = ACTIONS(3752),
    [anon_sym_LT_EQ_GT] = ACTIONS(3752),
    [anon_sym_or] = ACTIONS(3750),
    [anon_sym_and] = ACTIONS(3750),
    [anon_sym_bitor] = ACTIONS(3752),
    [anon_sym_xor] = ACTIONS(3750),
    [anon_sym_bitand] = ACTIONS(3752),
    [anon_sym_not_eq] = ACTIONS(3752),
    [anon_sym_is] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3752),
    [anon_sym_DASH_DASH] = ACTIONS(3752),
    [anon_sym_PLUS_PLUS] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3750),
    [anon_sym_DOT_STAR] = ACTIONS(3752),
    [anon_sym_DASH_GT] = ACTIONS(3752),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3752),
    [anon_sym_let] = ACTIONS(3752),
    [anon_sym_This] = ACTIONS(3752),
  },
  [3127] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3126),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2740),
    [anon_sym_COMMA] = ACTIONS(2740),
    [anon_sym_RPAREN] = ACTIONS(2740),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2742),
    [anon_sym_PLUS] = ACTIONS(2742),
    [anon_sym_STAR] = ACTIONS(2742),
    [anon_sym_SLASH] = ACTIONS(2742),
    [anon_sym_PERCENT] = ACTIONS(2742),
    [anon_sym_PIPE_PIPE] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_PIPE] = ACTIONS(2742),
    [anon_sym_CARET] = ACTIONS(2742),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_EQ_EQ] = ACTIONS(2740),
    [anon_sym_BANG_EQ] = ACTIONS(2740),
    [anon_sym_GT] = ACTIONS(2742),
    [anon_sym_GT_EQ] = ACTIONS(2740),
    [anon_sym_LT_EQ] = ACTIONS(2742),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_LT_LT] = ACTIONS(2742),
    [anon_sym_GT_GT] = ACTIONS(2742),
    [anon_sym_COLON] = ACTIONS(2740),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym___attribute__] = ACTIONS(2740),
    [anon_sym_LBRACE] = ACTIONS(2740),
    [anon_sym_RBRACE] = ACTIONS(2740),
    [anon_sym_signed] = ACTIONS(6863),
    [anon_sym_unsigned] = ACTIONS(6863),
    [anon_sym_long] = ACTIONS(6863),
    [anon_sym_short] = ACTIONS(6863),
    [anon_sym_LBRACK] = ACTIONS(2740),
    [anon_sym_RBRACK] = ACTIONS(2740),
    [anon_sym_EQ] = ACTIONS(2742),
    [anon_sym_QMARK] = ACTIONS(2740),
    [anon_sym_STAR_EQ] = ACTIONS(2740),
    [anon_sym_SLASH_EQ] = ACTIONS(2740),
    [anon_sym_PERCENT_EQ] = ACTIONS(2740),
    [anon_sym_PLUS_EQ] = ACTIONS(2740),
    [anon_sym_DASH_EQ] = ACTIONS(2740),
    [anon_sym_LT_LT_EQ] = ACTIONS(2740),
    [anon_sym_GT_GT_EQ] = ACTIONS(2740),
    [anon_sym_AMP_EQ] = ACTIONS(2740),
    [anon_sym_CARET_EQ] = ACTIONS(2740),
    [anon_sym_PIPE_EQ] = ACTIONS(2740),
    [anon_sym_and_eq] = ACTIONS(2740),
    [anon_sym_or_eq] = ACTIONS(2740),
    [anon_sym_xor_eq] = ACTIONS(2740),
    [anon_sym_LT_EQ_GT] = ACTIONS(2740),
    [anon_sym_or] = ACTIONS(2742),
    [anon_sym_and] = ACTIONS(2742),
    [anon_sym_bitor] = ACTIONS(2740),
    [anon_sym_xor] = ACTIONS(2742),
    [anon_sym_bitand] = ACTIONS(2740),
    [anon_sym_not_eq] = ACTIONS(2740),
    [anon_sym_is] = ACTIONS(2740),
    [anon_sym_as] = ACTIONS(2740),
    [anon_sym_DASH_DASH] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2740),
    [anon_sym_DOT] = ACTIONS(2742),
    [anon_sym_DOT_STAR] = ACTIONS(2740),
    [anon_sym_DASH_GT] = ACTIONS(2740),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2740),
    [anon_sym_let] = ACTIONS(2740),
    [anon_sym_This] = ACTIONS(2740),
  },
  [3128] = {
    [sym_attribute_specifier] = STATE(2889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3793),
    [anon_sym_COMMA] = ACTIONS(3793),
    [anon_sym_RPAREN] = ACTIONS(3793),
    [anon_sym_LPAREN2] = ACTIONS(3793),
    [anon_sym_DASH] = ACTIONS(3791),
    [anon_sym_PLUS] = ACTIONS(3791),
    [anon_sym_STAR] = ACTIONS(3793),
    [anon_sym_SLASH] = ACTIONS(3791),
    [anon_sym_PERCENT] = ACTIONS(3793),
    [anon_sym_PIPE_PIPE] = ACTIONS(3793),
    [anon_sym_AMP_AMP] = ACTIONS(3793),
    [anon_sym_PIPE] = ACTIONS(3791),
    [anon_sym_CARET] = ACTIONS(3793),
    [anon_sym_AMP] = ACTIONS(3791),
    [anon_sym_EQ_EQ] = ACTIONS(3793),
    [anon_sym_BANG_EQ] = ACTIONS(3793),
    [anon_sym_GT] = ACTIONS(3791),
    [anon_sym_GT_EQ] = ACTIONS(3793),
    [anon_sym_LT_EQ] = ACTIONS(3791),
    [anon_sym_LT] = ACTIONS(3791),
    [anon_sym_LT_LT] = ACTIONS(3793),
    [anon_sym_GT_GT] = ACTIONS(3793),
    [anon_sym_COLON] = ACTIONS(3793),
    [anon_sym_SEMI] = ACTIONS(3793),
    [anon_sym___extension__] = ACTIONS(3793),
    [anon_sym___attribute__] = ACTIONS(6621),
    [anon_sym_LBRACE] = ACTIONS(3793),
    [anon_sym_RBRACE] = ACTIONS(3793),
    [anon_sym_LBRACK] = ACTIONS(3793),
    [anon_sym_RBRACK] = ACTIONS(3793),
    [anon_sym_const] = ACTIONS(3791),
    [anon_sym_constexpr] = ACTIONS(3793),
    [anon_sym_volatile] = ACTIONS(3793),
    [anon_sym_restrict] = ACTIONS(3793),
    [anon_sym___restrict__] = ACTIONS(3793),
    [anon_sym__Atomic] = ACTIONS(3793),
    [anon_sym__Noreturn] = ACTIONS(3793),
    [anon_sym_noreturn] = ACTIONS(3793),
    [anon_sym_mutable] = ACTIONS(3793),
    [anon_sym_constinit] = ACTIONS(3793),
    [anon_sym_consteval] = ACTIONS(3793),
    [anon_sym_alignas] = ACTIONS(3793),
    [anon_sym__Alignas] = ACTIONS(3793),
    [anon_sym_QMARK] = ACTIONS(3793),
    [anon_sym_LT_EQ_GT] = ACTIONS(3793),
    [anon_sym_or] = ACTIONS(3793),
    [anon_sym_and] = ACTIONS(3793),
    [anon_sym_bitor] = ACTIONS(3793),
    [anon_sym_xor] = ACTIONS(3793),
    [anon_sym_bitand] = ACTIONS(3793),
    [anon_sym_not_eq] = ACTIONS(3793),
    [anon_sym_is] = ACTIONS(3793),
    [anon_sym_as] = ACTIONS(3793),
    [anon_sym_DASH_DASH] = ACTIONS(3793),
    [anon_sym_PLUS_PLUS] = ACTIONS(3793),
    [anon_sym_DOT] = ACTIONS(3791),
    [anon_sym_DOT_STAR] = ACTIONS(3793),
    [anon_sym_DASH_GT] = ACTIONS(3793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3793),
    [anon_sym_let] = ACTIONS(3793),
    [anon_sym_This] = ACTIONS(3793),
    [anon_sym_final] = ACTIONS(3793),
    [anon_sym_override] = ACTIONS(3793),
    [anon_sym_requires] = ACTIONS(3793),
    [anon_sym_where] = ACTIONS(3793),
  },
  [3129] = {
    [sym_attribute_specifier] = STATE(2912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3801),
    [anon_sym_COMMA] = ACTIONS(3801),
    [anon_sym_RPAREN] = ACTIONS(3801),
    [anon_sym_LPAREN2] = ACTIONS(3801),
    [anon_sym_DASH] = ACTIONS(3799),
    [anon_sym_PLUS] = ACTIONS(3799),
    [anon_sym_STAR] = ACTIONS(3801),
    [anon_sym_SLASH] = ACTIONS(3799),
    [anon_sym_PERCENT] = ACTIONS(3801),
    [anon_sym_PIPE_PIPE] = ACTIONS(3801),
    [anon_sym_AMP_AMP] = ACTIONS(3801),
    [anon_sym_PIPE] = ACTIONS(3799),
    [anon_sym_CARET] = ACTIONS(3801),
    [anon_sym_AMP] = ACTIONS(3799),
    [anon_sym_EQ_EQ] = ACTIONS(3801),
    [anon_sym_BANG_EQ] = ACTIONS(3801),
    [anon_sym_GT] = ACTIONS(3799),
    [anon_sym_GT_EQ] = ACTIONS(3801),
    [anon_sym_LT_EQ] = ACTIONS(3799),
    [anon_sym_LT] = ACTIONS(3799),
    [anon_sym_LT_LT] = ACTIONS(3801),
    [anon_sym_GT_GT] = ACTIONS(3801),
    [anon_sym_COLON] = ACTIONS(3801),
    [anon_sym_SEMI] = ACTIONS(3801),
    [anon_sym___extension__] = ACTIONS(3801),
    [anon_sym___attribute__] = ACTIONS(6621),
    [anon_sym_LBRACE] = ACTIONS(3801),
    [anon_sym_RBRACE] = ACTIONS(3801),
    [anon_sym_LBRACK] = ACTIONS(3801),
    [anon_sym_RBRACK] = ACTIONS(3801),
    [anon_sym_const] = ACTIONS(3799),
    [anon_sym_constexpr] = ACTIONS(3801),
    [anon_sym_volatile] = ACTIONS(3801),
    [anon_sym_restrict] = ACTIONS(3801),
    [anon_sym___restrict__] = ACTIONS(3801),
    [anon_sym__Atomic] = ACTIONS(3801),
    [anon_sym__Noreturn] = ACTIONS(3801),
    [anon_sym_noreturn] = ACTIONS(3801),
    [anon_sym_mutable] = ACTIONS(3801),
    [anon_sym_constinit] = ACTIONS(3801),
    [anon_sym_consteval] = ACTIONS(3801),
    [anon_sym_alignas] = ACTIONS(3801),
    [anon_sym__Alignas] = ACTIONS(3801),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_LT_EQ_GT] = ACTIONS(3801),
    [anon_sym_or] = ACTIONS(3801),
    [anon_sym_and] = ACTIONS(3801),
    [anon_sym_bitor] = ACTIONS(3801),
    [anon_sym_xor] = ACTIONS(3801),
    [anon_sym_bitand] = ACTIONS(3801),
    [anon_sym_not_eq] = ACTIONS(3801),
    [anon_sym_is] = ACTIONS(3801),
    [anon_sym_as] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(3801),
    [anon_sym_PLUS_PLUS] = ACTIONS(3801),
    [anon_sym_DOT] = ACTIONS(3799),
    [anon_sym_DOT_STAR] = ACTIONS(3801),
    [anon_sym_DASH_GT] = ACTIONS(3801),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3801),
    [anon_sym_let] = ACTIONS(3801),
    [anon_sym_This] = ACTIONS(3801),
    [anon_sym_final] = ACTIONS(3801),
    [anon_sym_override] = ACTIONS(3801),
    [anon_sym_requires] = ACTIONS(3801),
    [anon_sym_where] = ACTIONS(3801),
  },
  [3130] = {
    [sym_identifier] = ACTIONS(6867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6869),
    [anon_sym_COMMA] = ACTIONS(6869),
    [anon_sym_RPAREN] = ACTIONS(6869),
    [aux_sym_preproc_if_token2] = ACTIONS(6869),
    [aux_sym_preproc_else_token1] = ACTIONS(6869),
    [aux_sym_preproc_elif_token1] = ACTIONS(6867),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6869),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6869),
    [anon_sym_LPAREN2] = ACTIONS(6869),
    [anon_sym_DASH] = ACTIONS(6867),
    [anon_sym_PLUS] = ACTIONS(6867),
    [anon_sym_STAR] = ACTIONS(6867),
    [anon_sym_SLASH] = ACTIONS(6867),
    [anon_sym_PERCENT] = ACTIONS(6867),
    [anon_sym_PIPE_PIPE] = ACTIONS(6869),
    [anon_sym_AMP_AMP] = ACTIONS(6869),
    [anon_sym_PIPE] = ACTIONS(6867),
    [anon_sym_CARET] = ACTIONS(6867),
    [anon_sym_AMP] = ACTIONS(6867),
    [anon_sym_EQ_EQ] = ACTIONS(6869),
    [anon_sym_BANG_EQ] = ACTIONS(6869),
    [anon_sym_GT] = ACTIONS(6867),
    [anon_sym_GT_EQ] = ACTIONS(6869),
    [anon_sym_LT_EQ] = ACTIONS(6867),
    [anon_sym_LT] = ACTIONS(6867),
    [anon_sym_LT_LT] = ACTIONS(6867),
    [anon_sym_GT_GT] = ACTIONS(6867),
    [anon_sym_COLON] = ACTIONS(6869),
    [anon_sym_SEMI] = ACTIONS(6869),
    [anon_sym___attribute__] = ACTIONS(6867),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6869),
    [anon_sym_LBRACE] = ACTIONS(6869),
    [anon_sym_RBRACE] = ACTIONS(6869),
    [anon_sym_LBRACK] = ACTIONS(6867),
    [anon_sym_RBRACK] = ACTIONS(6869),
    [anon_sym_EQ] = ACTIONS(6867),
    [anon_sym_QMARK] = ACTIONS(6869),
    [anon_sym_STAR_EQ] = ACTIONS(6869),
    [anon_sym_SLASH_EQ] = ACTIONS(6869),
    [anon_sym_PERCENT_EQ] = ACTIONS(6869),
    [anon_sym_PLUS_EQ] = ACTIONS(6869),
    [anon_sym_DASH_EQ] = ACTIONS(6869),
    [anon_sym_LT_LT_EQ] = ACTIONS(6869),
    [anon_sym_GT_GT_EQ] = ACTIONS(6869),
    [anon_sym_AMP_EQ] = ACTIONS(6869),
    [anon_sym_CARET_EQ] = ACTIONS(6869),
    [anon_sym_PIPE_EQ] = ACTIONS(6869),
    [anon_sym_and_eq] = ACTIONS(6867),
    [anon_sym_or_eq] = ACTIONS(6867),
    [anon_sym_xor_eq] = ACTIONS(6867),
    [anon_sym_LT_EQ_GT] = ACTIONS(6869),
    [anon_sym_or] = ACTIONS(6867),
    [anon_sym_and] = ACTIONS(6867),
    [anon_sym_bitor] = ACTIONS(6867),
    [anon_sym_xor] = ACTIONS(6867),
    [anon_sym_bitand] = ACTIONS(6867),
    [anon_sym_not_eq] = ACTIONS(6867),
    [anon_sym_is] = ACTIONS(6867),
    [anon_sym_as] = ACTIONS(6867),
    [anon_sym_DASH_DASH] = ACTIONS(6869),
    [anon_sym_PLUS_PLUS] = ACTIONS(6869),
    [anon_sym_DOT] = ACTIONS(6867),
    [anon_sym_DOT_STAR] = ACTIONS(6869),
    [anon_sym_DASH_GT] = ACTIONS(6869),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6867),
  },
  [3131] = {
    [sym_identifier] = ACTIONS(6871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6873),
    [anon_sym_COMMA] = ACTIONS(6873),
    [anon_sym_RPAREN] = ACTIONS(6873),
    [aux_sym_preproc_if_token2] = ACTIONS(6873),
    [aux_sym_preproc_else_token1] = ACTIONS(6873),
    [aux_sym_preproc_elif_token1] = ACTIONS(6871),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6873),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6873),
    [anon_sym_LPAREN2] = ACTIONS(6873),
    [anon_sym_DASH] = ACTIONS(6871),
    [anon_sym_PLUS] = ACTIONS(6871),
    [anon_sym_STAR] = ACTIONS(6871),
    [anon_sym_SLASH] = ACTIONS(6871),
    [anon_sym_PERCENT] = ACTIONS(6871),
    [anon_sym_PIPE_PIPE] = ACTIONS(6873),
    [anon_sym_AMP_AMP] = ACTIONS(6873),
    [anon_sym_PIPE] = ACTIONS(6871),
    [anon_sym_CARET] = ACTIONS(6871),
    [anon_sym_AMP] = ACTIONS(6871),
    [anon_sym_EQ_EQ] = ACTIONS(6873),
    [anon_sym_BANG_EQ] = ACTIONS(6873),
    [anon_sym_GT] = ACTIONS(6871),
    [anon_sym_GT_EQ] = ACTIONS(6873),
    [anon_sym_LT_EQ] = ACTIONS(6871),
    [anon_sym_LT] = ACTIONS(6871),
    [anon_sym_LT_LT] = ACTIONS(6871),
    [anon_sym_GT_GT] = ACTIONS(6871),
    [anon_sym_COLON] = ACTIONS(6873),
    [anon_sym_SEMI] = ACTIONS(6873),
    [anon_sym___attribute__] = ACTIONS(6871),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6873),
    [anon_sym_LBRACE] = ACTIONS(6873),
    [anon_sym_RBRACE] = ACTIONS(6873),
    [anon_sym_LBRACK] = ACTIONS(6871),
    [anon_sym_RBRACK] = ACTIONS(6873),
    [anon_sym_EQ] = ACTIONS(6871),
    [anon_sym_QMARK] = ACTIONS(6873),
    [anon_sym_STAR_EQ] = ACTIONS(6873),
    [anon_sym_SLASH_EQ] = ACTIONS(6873),
    [anon_sym_PERCENT_EQ] = ACTIONS(6873),
    [anon_sym_PLUS_EQ] = ACTIONS(6873),
    [anon_sym_DASH_EQ] = ACTIONS(6873),
    [anon_sym_LT_LT_EQ] = ACTIONS(6873),
    [anon_sym_GT_GT_EQ] = ACTIONS(6873),
    [anon_sym_AMP_EQ] = ACTIONS(6873),
    [anon_sym_CARET_EQ] = ACTIONS(6873),
    [anon_sym_PIPE_EQ] = ACTIONS(6873),
    [anon_sym_and_eq] = ACTIONS(6871),
    [anon_sym_or_eq] = ACTIONS(6871),
    [anon_sym_xor_eq] = ACTIONS(6871),
    [anon_sym_LT_EQ_GT] = ACTIONS(6873),
    [anon_sym_or] = ACTIONS(6871),
    [anon_sym_and] = ACTIONS(6871),
    [anon_sym_bitor] = ACTIONS(6871),
    [anon_sym_xor] = ACTIONS(6871),
    [anon_sym_bitand] = ACTIONS(6871),
    [anon_sym_not_eq] = ACTIONS(6871),
    [anon_sym_is] = ACTIONS(6871),
    [anon_sym_as] = ACTIONS(6871),
    [anon_sym_DASH_DASH] = ACTIONS(6873),
    [anon_sym_PLUS_PLUS] = ACTIONS(6873),
    [anon_sym_DOT] = ACTIONS(6871),
    [anon_sym_DOT_STAR] = ACTIONS(6873),
    [anon_sym_DASH_GT] = ACTIONS(6873),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6871),
  },
  [3132] = {
    [sym_identifier] = ACTIONS(6875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6877),
    [anon_sym_COMMA] = ACTIONS(6877),
    [anon_sym_RPAREN] = ACTIONS(6877),
    [aux_sym_preproc_if_token2] = ACTIONS(6877),
    [aux_sym_preproc_else_token1] = ACTIONS(6877),
    [aux_sym_preproc_elif_token1] = ACTIONS(6875),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6877),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6877),
    [anon_sym_LPAREN2] = ACTIONS(6877),
    [anon_sym_DASH] = ACTIONS(6875),
    [anon_sym_PLUS] = ACTIONS(6875),
    [anon_sym_STAR] = ACTIONS(6875),
    [anon_sym_SLASH] = ACTIONS(6875),
    [anon_sym_PERCENT] = ACTIONS(6875),
    [anon_sym_PIPE_PIPE] = ACTIONS(6877),
    [anon_sym_AMP_AMP] = ACTIONS(6877),
    [anon_sym_PIPE] = ACTIONS(6875),
    [anon_sym_CARET] = ACTIONS(6875),
    [anon_sym_AMP] = ACTIONS(6875),
    [anon_sym_EQ_EQ] = ACTIONS(6877),
    [anon_sym_BANG_EQ] = ACTIONS(6877),
    [anon_sym_GT] = ACTIONS(6875),
    [anon_sym_GT_EQ] = ACTIONS(6877),
    [anon_sym_LT_EQ] = ACTIONS(6875),
    [anon_sym_LT] = ACTIONS(6875),
    [anon_sym_LT_LT] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6875),
    [anon_sym_COLON] = ACTIONS(6877),
    [anon_sym_SEMI] = ACTIONS(6877),
    [anon_sym___attribute__] = ACTIONS(6875),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6877),
    [anon_sym_LBRACE] = ACTIONS(6877),
    [anon_sym_RBRACE] = ACTIONS(6877),
    [anon_sym_LBRACK] = ACTIONS(6875),
    [anon_sym_RBRACK] = ACTIONS(6877),
    [anon_sym_EQ] = ACTIONS(6875),
    [anon_sym_QMARK] = ACTIONS(6877),
    [anon_sym_STAR_EQ] = ACTIONS(6877),
    [anon_sym_SLASH_EQ] = ACTIONS(6877),
    [anon_sym_PERCENT_EQ] = ACTIONS(6877),
    [anon_sym_PLUS_EQ] = ACTIONS(6877),
    [anon_sym_DASH_EQ] = ACTIONS(6877),
    [anon_sym_LT_LT_EQ] = ACTIONS(6877),
    [anon_sym_GT_GT_EQ] = ACTIONS(6877),
    [anon_sym_AMP_EQ] = ACTIONS(6877),
    [anon_sym_CARET_EQ] = ACTIONS(6877),
    [anon_sym_PIPE_EQ] = ACTIONS(6877),
    [anon_sym_and_eq] = ACTIONS(6875),
    [anon_sym_or_eq] = ACTIONS(6875),
    [anon_sym_xor_eq] = ACTIONS(6875),
    [anon_sym_LT_EQ_GT] = ACTIONS(6877),
    [anon_sym_or] = ACTIONS(6875),
    [anon_sym_and] = ACTIONS(6875),
    [anon_sym_bitor] = ACTIONS(6875),
    [anon_sym_xor] = ACTIONS(6875),
    [anon_sym_bitand] = ACTIONS(6875),
    [anon_sym_not_eq] = ACTIONS(6875),
    [anon_sym_is] = ACTIONS(6875),
    [anon_sym_as] = ACTIONS(6875),
    [anon_sym_DASH_DASH] = ACTIONS(6877),
    [anon_sym_PLUS_PLUS] = ACTIONS(6877),
    [anon_sym_DOT] = ACTIONS(6875),
    [anon_sym_DOT_STAR] = ACTIONS(6877),
    [anon_sym_DASH_GT] = ACTIONS(6877),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6875),
  },
  [3133] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2858),
    [sym_identifier] = ACTIONS(6879),
    [anon_sym_LPAREN2] = ACTIONS(3822),
    [anon_sym_STAR] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3822),
    [anon_sym_AMP] = ACTIONS(3820),
    [anon_sym___extension__] = ACTIONS(3820),
    [anon_sym_in] = ACTIONS(3820),
    [anon_sym_out] = ACTIONS(3820),
    [anon_sym_inout] = ACTIONS(3820),
    [anon_sym_extern] = ACTIONS(3820),
    [anon_sym___attribute__] = ACTIONS(3820),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3822),
    [anon_sym___declspec] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3822),
    [anon_sym_signed] = ACTIONS(6881),
    [anon_sym_unsigned] = ACTIONS(6881),
    [anon_sym_long] = ACTIONS(6881),
    [anon_sym_short] = ACTIONS(6881),
    [anon_sym_LBRACK] = ACTIONS(3820),
    [anon_sym_static] = ACTIONS(3820),
    [anon_sym_register] = ACTIONS(3820),
    [anon_sym_inline] = ACTIONS(3820),
    [anon_sym___inline] = ACTIONS(3820),
    [anon_sym___inline__] = ACTIONS(3820),
    [anon_sym___forceinline] = ACTIONS(3820),
    [anon_sym_thread_local] = ACTIONS(3820),
    [anon_sym___thread] = ACTIONS(3820),
    [anon_sym_const] = ACTIONS(3820),
    [anon_sym_constexpr] = ACTIONS(3820),
    [anon_sym_volatile] = ACTIONS(3820),
    [anon_sym_restrict] = ACTIONS(3820),
    [anon_sym___restrict__] = ACTIONS(3820),
    [anon_sym__Atomic] = ACTIONS(3820),
    [anon_sym__Noreturn] = ACTIONS(3820),
    [anon_sym_noreturn] = ACTIONS(3820),
    [anon_sym_mutable] = ACTIONS(3820),
    [anon_sym_constinit] = ACTIONS(3820),
    [anon_sym_consteval] = ACTIONS(3820),
    [anon_sym_alignas] = ACTIONS(3820),
    [anon_sym__Alignas] = ACTIONS(3820),
    [sym_primitive_type] = ACTIONS(6228),
    [anon_sym_DOT] = ACTIONS(3822),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3820),
    [anon_sym_let] = ACTIONS(3820),
    [anon_sym_This] = ACTIONS(3820),
    [sym_virtual] = ACTIONS(3820),
    [anon_sym_precise] = ACTIONS(3820),
    [anon_sym_shared] = ACTIONS(3820),
    [anon_sym_groupshared] = ACTIONS(3820),
    [anon_sym_uniform] = ACTIONS(3820),
    [anon_sym_row_major] = ACTIONS(3820),
    [anon_sym_column_major] = ACTIONS(3820),
    [anon_sym_globallycoherent] = ACTIONS(3820),
    [anon_sym_centroid] = ACTIONS(3820),
    [anon_sym_noperspective] = ACTIONS(3820),
    [anon_sym_nointerpolation] = ACTIONS(3820),
    [anon_sym_sample] = ACTIONS(3820),
    [anon_sym_linear] = ACTIONS(3820),
    [anon_sym_snorm] = ACTIONS(3820),
    [anon_sym_unorm] = ACTIONS(3820),
    [anon_sym_point] = ACTIONS(3820),
    [anon_sym_line] = ACTIONS(3820),
    [anon_sym_triangleadj] = ACTIONS(3820),
    [anon_sym_lineadj] = ACTIONS(3820),
    [anon_sym_triangle] = ACTIONS(3820),
  },
  [3134] = {
    [sym_attribute_specifier] = STATE(2887),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3832),
    [anon_sym_RPAREN] = ACTIONS(3832),
    [anon_sym_LPAREN2] = ACTIONS(3832),
    [anon_sym_DASH] = ACTIONS(3830),
    [anon_sym_PLUS] = ACTIONS(3830),
    [anon_sym_STAR] = ACTIONS(3832),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_PERCENT] = ACTIONS(3832),
    [anon_sym_PIPE_PIPE] = ACTIONS(3832),
    [anon_sym_AMP_AMP] = ACTIONS(3832),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_CARET] = ACTIONS(3832),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_EQ_EQ] = ACTIONS(3832),
    [anon_sym_BANG_EQ] = ACTIONS(3832),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_GT_EQ] = ACTIONS(3832),
    [anon_sym_LT_EQ] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3832),
    [anon_sym_GT_GT] = ACTIONS(3832),
    [anon_sym_COLON] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3832),
    [anon_sym___extension__] = ACTIONS(3832),
    [anon_sym___attribute__] = ACTIONS(6621),
    [anon_sym_LBRACE] = ACTIONS(3832),
    [anon_sym_RBRACE] = ACTIONS(3832),
    [anon_sym_LBRACK] = ACTIONS(3832),
    [anon_sym_RBRACK] = ACTIONS(3832),
    [anon_sym_const] = ACTIONS(3830),
    [anon_sym_constexpr] = ACTIONS(3832),
    [anon_sym_volatile] = ACTIONS(3832),
    [anon_sym_restrict] = ACTIONS(3832),
    [anon_sym___restrict__] = ACTIONS(3832),
    [anon_sym__Atomic] = ACTIONS(3832),
    [anon_sym__Noreturn] = ACTIONS(3832),
    [anon_sym_noreturn] = ACTIONS(3832),
    [anon_sym_mutable] = ACTIONS(3832),
    [anon_sym_constinit] = ACTIONS(3832),
    [anon_sym_consteval] = ACTIONS(3832),
    [anon_sym_alignas] = ACTIONS(3832),
    [anon_sym__Alignas] = ACTIONS(3832),
    [anon_sym_QMARK] = ACTIONS(3832),
    [anon_sym_LT_EQ_GT] = ACTIONS(3832),
    [anon_sym_or] = ACTIONS(3832),
    [anon_sym_and] = ACTIONS(3832),
    [anon_sym_bitor] = ACTIONS(3832),
    [anon_sym_xor] = ACTIONS(3832),
    [anon_sym_bitand] = ACTIONS(3832),
    [anon_sym_not_eq] = ACTIONS(3832),
    [anon_sym_is] = ACTIONS(3832),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_DASH_DASH] = ACTIONS(3832),
    [anon_sym_PLUS_PLUS] = ACTIONS(3832),
    [anon_sym_DOT] = ACTIONS(3830),
    [anon_sym_DOT_STAR] = ACTIONS(3832),
    [anon_sym_DASH_GT] = ACTIONS(3832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3832),
    [anon_sym_let] = ACTIONS(3832),
    [anon_sym_This] = ACTIONS(3832),
    [anon_sym_final] = ACTIONS(3832),
    [anon_sym_override] = ACTIONS(3832),
    [anon_sym_requires] = ACTIONS(3832),
    [anon_sym_where] = ACTIONS(3832),
  },
  [3135] = {
    [sym_attribute_specifier] = STATE(2935),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3737),
    [anon_sym_COMMA] = ACTIONS(3737),
    [anon_sym_RPAREN] = ACTIONS(3737),
    [anon_sym_LPAREN2] = ACTIONS(3737),
    [anon_sym_DASH] = ACTIONS(3735),
    [anon_sym_PLUS] = ACTIONS(3735),
    [anon_sym_STAR] = ACTIONS(3737),
    [anon_sym_SLASH] = ACTIONS(3735),
    [anon_sym_PERCENT] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(3737),
    [anon_sym_AMP_AMP] = ACTIONS(3737),
    [anon_sym_PIPE] = ACTIONS(3735),
    [anon_sym_CARET] = ACTIONS(3737),
    [anon_sym_AMP] = ACTIONS(3735),
    [anon_sym_EQ_EQ] = ACTIONS(3737),
    [anon_sym_BANG_EQ] = ACTIONS(3737),
    [anon_sym_GT] = ACTIONS(3735),
    [anon_sym_GT_EQ] = ACTIONS(3737),
    [anon_sym_LT_EQ] = ACTIONS(3735),
    [anon_sym_LT] = ACTIONS(3735),
    [anon_sym_LT_LT] = ACTIONS(3737),
    [anon_sym_GT_GT] = ACTIONS(3737),
    [anon_sym_COLON] = ACTIONS(3737),
    [anon_sym_SEMI] = ACTIONS(3737),
    [anon_sym___extension__] = ACTIONS(3737),
    [anon_sym___attribute__] = ACTIONS(6621),
    [anon_sym_LBRACE] = ACTIONS(3737),
    [anon_sym_RBRACE] = ACTIONS(3737),
    [anon_sym_LBRACK] = ACTIONS(3737),
    [anon_sym_RBRACK] = ACTIONS(3737),
    [anon_sym_const] = ACTIONS(3735),
    [anon_sym_constexpr] = ACTIONS(3737),
    [anon_sym_volatile] = ACTIONS(3737),
    [anon_sym_restrict] = ACTIONS(3737),
    [anon_sym___restrict__] = ACTIONS(3737),
    [anon_sym__Atomic] = ACTIONS(3737),
    [anon_sym__Noreturn] = ACTIONS(3737),
    [anon_sym_noreturn] = ACTIONS(3737),
    [anon_sym_mutable] = ACTIONS(3737),
    [anon_sym_constinit] = ACTIONS(3737),
    [anon_sym_consteval] = ACTIONS(3737),
    [anon_sym_alignas] = ACTIONS(3737),
    [anon_sym__Alignas] = ACTIONS(3737),
    [anon_sym_QMARK] = ACTIONS(3737),
    [anon_sym_LT_EQ_GT] = ACTIONS(3737),
    [anon_sym_or] = ACTIONS(3737),
    [anon_sym_and] = ACTIONS(3737),
    [anon_sym_bitor] = ACTIONS(3737),
    [anon_sym_xor] = ACTIONS(3737),
    [anon_sym_bitand] = ACTIONS(3737),
    [anon_sym_not_eq] = ACTIONS(3737),
    [anon_sym_is] = ACTIONS(3737),
    [anon_sym_as] = ACTIONS(3737),
    [anon_sym_DASH_DASH] = ACTIONS(3737),
    [anon_sym_PLUS_PLUS] = ACTIONS(3737),
    [anon_sym_DOT] = ACTIONS(3735),
    [anon_sym_DOT_STAR] = ACTIONS(3737),
    [anon_sym_DASH_GT] = ACTIONS(3737),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3737),
    [anon_sym_let] = ACTIONS(3737),
    [anon_sym_This] = ACTIONS(3737),
    [anon_sym_final] = ACTIONS(3737),
    [anon_sym_override] = ACTIONS(3737),
    [anon_sym_requires] = ACTIONS(3737),
    [anon_sym_where] = ACTIONS(3737),
  },
  [3136] = {
    [sym_argument_list] = STATE(3318),
    [sym_initializer_list] = STATE(3318),
    [sym_identifier] = ACTIONS(6883),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6885),
    [anon_sym_COMMA] = ACTIONS(6885),
    [anon_sym_RPAREN] = ACTIONS(6885),
    [aux_sym_preproc_if_token2] = ACTIONS(6885),
    [aux_sym_preproc_else_token1] = ACTIONS(6885),
    [aux_sym_preproc_elif_token1] = ACTIONS(6883),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6885),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6885),
    [anon_sym_LPAREN2] = ACTIONS(6568),
    [anon_sym_DASH] = ACTIONS(6883),
    [anon_sym_PLUS] = ACTIONS(6883),
    [anon_sym_STAR] = ACTIONS(6883),
    [anon_sym_SLASH] = ACTIONS(6883),
    [anon_sym_PERCENT] = ACTIONS(6883),
    [anon_sym_PIPE_PIPE] = ACTIONS(6885),
    [anon_sym_AMP_AMP] = ACTIONS(6885),
    [anon_sym_PIPE] = ACTIONS(6883),
    [anon_sym_CARET] = ACTIONS(6883),
    [anon_sym_AMP] = ACTIONS(6883),
    [anon_sym_EQ_EQ] = ACTIONS(6885),
    [anon_sym_BANG_EQ] = ACTIONS(6885),
    [anon_sym_GT] = ACTIONS(6883),
    [anon_sym_GT_EQ] = ACTIONS(6885),
    [anon_sym_LT_EQ] = ACTIONS(6883),
    [anon_sym_LT] = ACTIONS(6883),
    [anon_sym_LT_LT] = ACTIONS(6883),
    [anon_sym_GT_GT] = ACTIONS(6883),
    [anon_sym_COLON] = ACTIONS(6885),
    [anon_sym_SEMI] = ACTIONS(6885),
    [anon_sym___attribute__] = ACTIONS(6883),
    [anon_sym_LBRACE] = ACTIONS(4418),
    [anon_sym_RBRACE] = ACTIONS(6885),
    [anon_sym_LBRACK] = ACTIONS(6885),
    [anon_sym_RBRACK] = ACTIONS(6885),
    [anon_sym_EQ] = ACTIONS(6883),
    [anon_sym_QMARK] = ACTIONS(6885),
    [anon_sym_STAR_EQ] = ACTIONS(6885),
    [anon_sym_SLASH_EQ] = ACTIONS(6885),
    [anon_sym_PERCENT_EQ] = ACTIONS(6885),
    [anon_sym_PLUS_EQ] = ACTIONS(6885),
    [anon_sym_DASH_EQ] = ACTIONS(6885),
    [anon_sym_LT_LT_EQ] = ACTIONS(6885),
    [anon_sym_GT_GT_EQ] = ACTIONS(6885),
    [anon_sym_AMP_EQ] = ACTIONS(6885),
    [anon_sym_CARET_EQ] = ACTIONS(6885),
    [anon_sym_PIPE_EQ] = ACTIONS(6885),
    [anon_sym_and_eq] = ACTIONS(6883),
    [anon_sym_or_eq] = ACTIONS(6883),
    [anon_sym_xor_eq] = ACTIONS(6883),
    [anon_sym_LT_EQ_GT] = ACTIONS(6885),
    [anon_sym_or] = ACTIONS(6883),
    [anon_sym_and] = ACTIONS(6883),
    [anon_sym_bitor] = ACTIONS(6883),
    [anon_sym_xor] = ACTIONS(6883),
    [anon_sym_bitand] = ACTIONS(6883),
    [anon_sym_not_eq] = ACTIONS(6883),
    [anon_sym_is] = ACTIONS(6883),
    [anon_sym_as] = ACTIONS(6883),
    [anon_sym_DASH_DASH] = ACTIONS(6885),
    [anon_sym_PLUS_PLUS] = ACTIONS(6885),
    [anon_sym_DOT] = ACTIONS(6883),
    [anon_sym_DOT_STAR] = ACTIONS(6885),
    [anon_sym_DASH_GT] = ACTIONS(6885),
    [sym_comment] = ACTIONS(3),
  },
  [3137] = {
    [sym_attribute_specifier] = STATE(2920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3744),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_RPAREN] = ACTIONS(3744),
    [anon_sym_LPAREN2] = ACTIONS(3744),
    [anon_sym_DASH] = ACTIONS(3742),
    [anon_sym_PLUS] = ACTIONS(3742),
    [anon_sym_STAR] = ACTIONS(3744),
    [anon_sym_SLASH] = ACTIONS(3742),
    [anon_sym_PERCENT] = ACTIONS(3744),
    [anon_sym_PIPE_PIPE] = ACTIONS(3744),
    [anon_sym_AMP_AMP] = ACTIONS(3744),
    [anon_sym_PIPE] = ACTIONS(3742),
    [anon_sym_CARET] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(3742),
    [anon_sym_EQ_EQ] = ACTIONS(3744),
    [anon_sym_BANG_EQ] = ACTIONS(3744),
    [anon_sym_GT] = ACTIONS(3742),
    [anon_sym_GT_EQ] = ACTIONS(3744),
    [anon_sym_LT_EQ] = ACTIONS(3742),
    [anon_sym_LT] = ACTIONS(3742),
    [anon_sym_LT_LT] = ACTIONS(3744),
    [anon_sym_GT_GT] = ACTIONS(3744),
    [anon_sym_COLON] = ACTIONS(3744),
    [anon_sym_SEMI] = ACTIONS(3744),
    [anon_sym___extension__] = ACTIONS(3744),
    [anon_sym___attribute__] = ACTIONS(6621),
    [anon_sym_LBRACE] = ACTIONS(3744),
    [anon_sym_RBRACE] = ACTIONS(3744),
    [anon_sym_LBRACK] = ACTIONS(3744),
    [anon_sym_RBRACK] = ACTIONS(3744),
    [anon_sym_const] = ACTIONS(3742),
    [anon_sym_constexpr] = ACTIONS(3744),
    [anon_sym_volatile] = ACTIONS(3744),
    [anon_sym_restrict] = ACTIONS(3744),
    [anon_sym___restrict__] = ACTIONS(3744),
    [anon_sym__Atomic] = ACTIONS(3744),
    [anon_sym__Noreturn] = ACTIONS(3744),
    [anon_sym_noreturn] = ACTIONS(3744),
    [anon_sym_mutable] = ACTIONS(3744),
    [anon_sym_constinit] = ACTIONS(3744),
    [anon_sym_consteval] = ACTIONS(3744),
    [anon_sym_alignas] = ACTIONS(3744),
    [anon_sym__Alignas] = ACTIONS(3744),
    [anon_sym_QMARK] = ACTIONS(3744),
    [anon_sym_LT_EQ_GT] = ACTIONS(3744),
    [anon_sym_or] = ACTIONS(3744),
    [anon_sym_and] = ACTIONS(3744),
    [anon_sym_bitor] = ACTIONS(3744),
    [anon_sym_xor] = ACTIONS(3744),
    [anon_sym_bitand] = ACTIONS(3744),
    [anon_sym_not_eq] = ACTIONS(3744),
    [anon_sym_is] = ACTIONS(3744),
    [anon_sym_as] = ACTIONS(3744),
    [anon_sym_DASH_DASH] = ACTIONS(3744),
    [anon_sym_PLUS_PLUS] = ACTIONS(3744),
    [anon_sym_DOT] = ACTIONS(3742),
    [anon_sym_DOT_STAR] = ACTIONS(3744),
    [anon_sym_DASH_GT] = ACTIONS(3744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3744),
    [anon_sym_let] = ACTIONS(3744),
    [anon_sym_This] = ACTIONS(3744),
    [anon_sym_final] = ACTIONS(3744),
    [anon_sym_override] = ACTIONS(3744),
    [anon_sym_requires] = ACTIONS(3744),
    [anon_sym_where] = ACTIONS(3744),
  },
  [3138] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3812),
    [anon_sym_COMMA] = ACTIONS(3812),
    [anon_sym_RPAREN] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3812),
    [anon_sym_DASH] = ACTIONS(3810),
    [anon_sym_PLUS] = ACTIONS(3810),
    [anon_sym_STAR] = ACTIONS(3810),
    [anon_sym_SLASH] = ACTIONS(3810),
    [anon_sym_PERCENT] = ACTIONS(3810),
    [anon_sym_PIPE_PIPE] = ACTIONS(3812),
    [anon_sym_AMP_AMP] = ACTIONS(3812),
    [anon_sym_PIPE] = ACTIONS(3810),
    [anon_sym_CARET] = ACTIONS(3810),
    [anon_sym_AMP] = ACTIONS(3810),
    [anon_sym_EQ_EQ] = ACTIONS(3812),
    [anon_sym_BANG_EQ] = ACTIONS(3812),
    [anon_sym_GT] = ACTIONS(3810),
    [anon_sym_GT_EQ] = ACTIONS(3812),
    [anon_sym_LT_EQ] = ACTIONS(3810),
    [anon_sym_LT] = ACTIONS(3810),
    [anon_sym_LT_LT] = ACTIONS(3810),
    [anon_sym_GT_GT] = ACTIONS(3810),
    [anon_sym_COLON] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym_LBRACE] = ACTIONS(3812),
    [anon_sym_RBRACE] = ACTIONS(3812),
    [anon_sym_signed] = ACTIONS(6865),
    [anon_sym_unsigned] = ACTIONS(6865),
    [anon_sym_long] = ACTIONS(6865),
    [anon_sym_short] = ACTIONS(6865),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_RBRACK] = ACTIONS(3812),
    [anon_sym_EQ] = ACTIONS(3810),
    [anon_sym_QMARK] = ACTIONS(3812),
    [anon_sym_STAR_EQ] = ACTIONS(3812),
    [anon_sym_SLASH_EQ] = ACTIONS(3812),
    [anon_sym_PERCENT_EQ] = ACTIONS(3812),
    [anon_sym_PLUS_EQ] = ACTIONS(3812),
    [anon_sym_DASH_EQ] = ACTIONS(3812),
    [anon_sym_LT_LT_EQ] = ACTIONS(3812),
    [anon_sym_GT_GT_EQ] = ACTIONS(3812),
    [anon_sym_AMP_EQ] = ACTIONS(3812),
    [anon_sym_CARET_EQ] = ACTIONS(3812),
    [anon_sym_PIPE_EQ] = ACTIONS(3812),
    [anon_sym_and_eq] = ACTIONS(3812),
    [anon_sym_or_eq] = ACTIONS(3812),
    [anon_sym_xor_eq] = ACTIONS(3812),
    [anon_sym_LT_EQ_GT] = ACTIONS(3812),
    [anon_sym_or] = ACTIONS(3810),
    [anon_sym_and] = ACTIONS(3810),
    [anon_sym_bitor] = ACTIONS(3812),
    [anon_sym_xor] = ACTIONS(3810),
    [anon_sym_bitand] = ACTIONS(3812),
    [anon_sym_not_eq] = ACTIONS(3812),
    [anon_sym_is] = ACTIONS(3812),
    [anon_sym_as] = ACTIONS(3812),
    [anon_sym_DASH_DASH] = ACTIONS(3812),
    [anon_sym_PLUS_PLUS] = ACTIONS(3812),
    [anon_sym_DOT] = ACTIONS(3810),
    [anon_sym_DOT_STAR] = ACTIONS(3812),
    [anon_sym_DASH_GT] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
  },
  [3139] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3805),
    [anon_sym_COMMA] = ACTIONS(3805),
    [anon_sym_RPAREN] = ACTIONS(3805),
    [anon_sym_LPAREN2] = ACTIONS(3805),
    [anon_sym_DASH] = ACTIONS(3803),
    [anon_sym_PLUS] = ACTIONS(3803),
    [anon_sym_STAR] = ACTIONS(3803),
    [anon_sym_SLASH] = ACTIONS(3803),
    [anon_sym_PERCENT] = ACTIONS(3803),
    [anon_sym_PIPE_PIPE] = ACTIONS(3805),
    [anon_sym_AMP_AMP] = ACTIONS(3805),
    [anon_sym_PIPE] = ACTIONS(3803),
    [anon_sym_CARET] = ACTIONS(3803),
    [anon_sym_AMP] = ACTIONS(3803),
    [anon_sym_EQ_EQ] = ACTIONS(3805),
    [anon_sym_BANG_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3803),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_LT_EQ] = ACTIONS(3803),
    [anon_sym_LT] = ACTIONS(3803),
    [anon_sym_LT_LT] = ACTIONS(3803),
    [anon_sym_GT_GT] = ACTIONS(3803),
    [anon_sym_COLON] = ACTIONS(3805),
    [anon_sym_SEMI] = ACTIONS(3805),
    [anon_sym___attribute__] = ACTIONS(3805),
    [anon_sym_LBRACE] = ACTIONS(3805),
    [anon_sym_RBRACE] = ACTIONS(3805),
    [anon_sym_signed] = ACTIONS(6865),
    [anon_sym_unsigned] = ACTIONS(6865),
    [anon_sym_long] = ACTIONS(6865),
    [anon_sym_short] = ACTIONS(6865),
    [anon_sym_LBRACK] = ACTIONS(3805),
    [anon_sym_RBRACK] = ACTIONS(3805),
    [anon_sym_EQ] = ACTIONS(3803),
    [anon_sym_QMARK] = ACTIONS(3805),
    [anon_sym_STAR_EQ] = ACTIONS(3805),
    [anon_sym_SLASH_EQ] = ACTIONS(3805),
    [anon_sym_PERCENT_EQ] = ACTIONS(3805),
    [anon_sym_PLUS_EQ] = ACTIONS(3805),
    [anon_sym_DASH_EQ] = ACTIONS(3805),
    [anon_sym_LT_LT_EQ] = ACTIONS(3805),
    [anon_sym_GT_GT_EQ] = ACTIONS(3805),
    [anon_sym_AMP_EQ] = ACTIONS(3805),
    [anon_sym_CARET_EQ] = ACTIONS(3805),
    [anon_sym_PIPE_EQ] = ACTIONS(3805),
    [anon_sym_and_eq] = ACTIONS(3805),
    [anon_sym_or_eq] = ACTIONS(3805),
    [anon_sym_xor_eq] = ACTIONS(3805),
    [anon_sym_LT_EQ_GT] = ACTIONS(3805),
    [anon_sym_or] = ACTIONS(3803),
    [anon_sym_and] = ACTIONS(3803),
    [anon_sym_bitor] = ACTIONS(3805),
    [anon_sym_xor] = ACTIONS(3803),
    [anon_sym_bitand] = ACTIONS(3805),
    [anon_sym_not_eq] = ACTIONS(3805),
    [anon_sym_is] = ACTIONS(3805),
    [anon_sym_as] = ACTIONS(3805),
    [anon_sym_DASH_DASH] = ACTIONS(3805),
    [anon_sym_PLUS_PLUS] = ACTIONS(3805),
    [anon_sym_DOT] = ACTIONS(3803),
    [anon_sym_DOT_STAR] = ACTIONS(3805),
    [anon_sym_DASH_GT] = ACTIONS(3805),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3805),
    [anon_sym_let] = ACTIONS(3805),
    [anon_sym_This] = ACTIONS(3805),
  },
  [3140] = {
    [sym_identifier] = ACTIONS(6887),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6889),
    [anon_sym_COMMA] = ACTIONS(6889),
    [anon_sym_RPAREN] = ACTIONS(6889),
    [aux_sym_preproc_if_token2] = ACTIONS(6889),
    [aux_sym_preproc_else_token1] = ACTIONS(6889),
    [aux_sym_preproc_elif_token1] = ACTIONS(6887),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6889),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6889),
    [anon_sym_LPAREN2] = ACTIONS(6889),
    [anon_sym_DASH] = ACTIONS(6887),
    [anon_sym_PLUS] = ACTIONS(6887),
    [anon_sym_STAR] = ACTIONS(6887),
    [anon_sym_SLASH] = ACTIONS(6887),
    [anon_sym_PERCENT] = ACTIONS(6887),
    [anon_sym_PIPE_PIPE] = ACTIONS(6889),
    [anon_sym_AMP_AMP] = ACTIONS(6889),
    [anon_sym_PIPE] = ACTIONS(6887),
    [anon_sym_CARET] = ACTIONS(6887),
    [anon_sym_AMP] = ACTIONS(6887),
    [anon_sym_EQ_EQ] = ACTIONS(6889),
    [anon_sym_BANG_EQ] = ACTIONS(6889),
    [anon_sym_GT] = ACTIONS(6887),
    [anon_sym_GT_EQ] = ACTIONS(6889),
    [anon_sym_LT_EQ] = ACTIONS(6887),
    [anon_sym_LT] = ACTIONS(6887),
    [anon_sym_LT_LT] = ACTIONS(6887),
    [anon_sym_GT_GT] = ACTIONS(6887),
    [anon_sym_COLON] = ACTIONS(6889),
    [anon_sym_SEMI] = ACTIONS(6889),
    [anon_sym___attribute__] = ACTIONS(6887),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6889),
    [anon_sym_LBRACE] = ACTIONS(6889),
    [anon_sym_RBRACE] = ACTIONS(6889),
    [anon_sym_LBRACK] = ACTIONS(6887),
    [anon_sym_RBRACK] = ACTIONS(6889),
    [anon_sym_EQ] = ACTIONS(6887),
    [anon_sym_QMARK] = ACTIONS(6889),
    [anon_sym_STAR_EQ] = ACTIONS(6889),
    [anon_sym_SLASH_EQ] = ACTIONS(6889),
    [anon_sym_PERCENT_EQ] = ACTIONS(6889),
    [anon_sym_PLUS_EQ] = ACTIONS(6889),
    [anon_sym_DASH_EQ] = ACTIONS(6889),
    [anon_sym_LT_LT_EQ] = ACTIONS(6889),
    [anon_sym_GT_GT_EQ] = ACTIONS(6889),
    [anon_sym_AMP_EQ] = ACTIONS(6889),
    [anon_sym_CARET_EQ] = ACTIONS(6889),
    [anon_sym_PIPE_EQ] = ACTIONS(6889),
    [anon_sym_and_eq] = ACTIONS(6887),
    [anon_sym_or_eq] = ACTIONS(6887),
    [anon_sym_xor_eq] = ACTIONS(6887),
    [anon_sym_LT_EQ_GT] = ACTIONS(6889),
    [anon_sym_or] = ACTIONS(6887),
    [anon_sym_and] = ACTIONS(6887),
    [anon_sym_bitor] = ACTIONS(6887),
    [anon_sym_xor] = ACTIONS(6887),
    [anon_sym_bitand] = ACTIONS(6887),
    [anon_sym_not_eq] = ACTIONS(6887),
    [anon_sym_is] = ACTIONS(6887),
    [anon_sym_as] = ACTIONS(6887),
    [anon_sym_DASH_DASH] = ACTIONS(6889),
    [anon_sym_PLUS_PLUS] = ACTIONS(6889),
    [anon_sym_DOT] = ACTIONS(6887),
    [anon_sym_DOT_STAR] = ACTIONS(6889),
    [anon_sym_DASH_GT] = ACTIONS(6889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6887),
  },
  [3141] = {
    [sym_attribute_specifier] = STATE(2927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3797),
    [anon_sym_COMMA] = ACTIONS(3797),
    [anon_sym_RPAREN] = ACTIONS(3797),
    [anon_sym_LPAREN2] = ACTIONS(3797),
    [anon_sym_DASH] = ACTIONS(3795),
    [anon_sym_PLUS] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(3797),
    [anon_sym_SLASH] = ACTIONS(3795),
    [anon_sym_PERCENT] = ACTIONS(3797),
    [anon_sym_PIPE_PIPE] = ACTIONS(3797),
    [anon_sym_AMP_AMP] = ACTIONS(3797),
    [anon_sym_PIPE] = ACTIONS(3795),
    [anon_sym_CARET] = ACTIONS(3797),
    [anon_sym_AMP] = ACTIONS(3795),
    [anon_sym_EQ_EQ] = ACTIONS(3797),
    [anon_sym_BANG_EQ] = ACTIONS(3797),
    [anon_sym_GT] = ACTIONS(3795),
    [anon_sym_GT_EQ] = ACTIONS(3797),
    [anon_sym_LT_EQ] = ACTIONS(3795),
    [anon_sym_LT] = ACTIONS(3795),
    [anon_sym_LT_LT] = ACTIONS(3797),
    [anon_sym_GT_GT] = ACTIONS(3797),
    [anon_sym_COLON] = ACTIONS(3797),
    [anon_sym_SEMI] = ACTIONS(3797),
    [anon_sym___extension__] = ACTIONS(3797),
    [anon_sym___attribute__] = ACTIONS(6621),
    [anon_sym_LBRACE] = ACTIONS(3797),
    [anon_sym_RBRACE] = ACTIONS(3797),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_RBRACK] = ACTIONS(3797),
    [anon_sym_const] = ACTIONS(3795),
    [anon_sym_constexpr] = ACTIONS(3797),
    [anon_sym_volatile] = ACTIONS(3797),
    [anon_sym_restrict] = ACTIONS(3797),
    [anon_sym___restrict__] = ACTIONS(3797),
    [anon_sym__Atomic] = ACTIONS(3797),
    [anon_sym__Noreturn] = ACTIONS(3797),
    [anon_sym_noreturn] = ACTIONS(3797),
    [anon_sym_mutable] = ACTIONS(3797),
    [anon_sym_constinit] = ACTIONS(3797),
    [anon_sym_consteval] = ACTIONS(3797),
    [anon_sym_alignas] = ACTIONS(3797),
    [anon_sym__Alignas] = ACTIONS(3797),
    [anon_sym_QMARK] = ACTIONS(3797),
    [anon_sym_LT_EQ_GT] = ACTIONS(3797),
    [anon_sym_or] = ACTIONS(3797),
    [anon_sym_and] = ACTIONS(3797),
    [anon_sym_bitor] = ACTIONS(3797),
    [anon_sym_xor] = ACTIONS(3797),
    [anon_sym_bitand] = ACTIONS(3797),
    [anon_sym_not_eq] = ACTIONS(3797),
    [anon_sym_is] = ACTIONS(3797),
    [anon_sym_as] = ACTIONS(3797),
    [anon_sym_DASH_DASH] = ACTIONS(3797),
    [anon_sym_PLUS_PLUS] = ACTIONS(3797),
    [anon_sym_DOT] = ACTIONS(3795),
    [anon_sym_DOT_STAR] = ACTIONS(3797),
    [anon_sym_DASH_GT] = ACTIONS(3797),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3797),
    [anon_sym_let] = ACTIONS(3797),
    [anon_sym_This] = ACTIONS(3797),
    [anon_sym_final] = ACTIONS(3797),
    [anon_sym_override] = ACTIONS(3797),
    [anon_sym_requires] = ACTIONS(3797),
    [anon_sym_where] = ACTIONS(3797),
  },
  [3142] = {
    [sym_attribute_specifier] = STATE(2773),
    [sym_enumerator_list] = STATE(2706),
    [sym__enum_base_clause] = STATE(2677),
    [sym_identifier] = ACTIONS(3060),
    [anon_sym_LPAREN2] = ACTIONS(3062),
    [anon_sym_STAR] = ACTIONS(3062),
    [anon_sym_AMP_AMP] = ACTIONS(3062),
    [anon_sym_AMP] = ACTIONS(3060),
    [anon_sym_COLON] = ACTIONS(6891),
    [anon_sym_SEMI] = ACTIONS(3062),
    [anon_sym___extension__] = ACTIONS(3060),
    [anon_sym_in] = ACTIONS(3060),
    [anon_sym_out] = ACTIONS(3060),
    [anon_sym_inout] = ACTIONS(3060),
    [anon_sym_extern] = ACTIONS(3060),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3062),
    [anon_sym___declspec] = ACTIONS(3060),
    [anon_sym___based] = ACTIONS(3060),
    [anon_sym_LBRACE] = ACTIONS(6313),
    [anon_sym_static] = ACTIONS(3060),
    [anon_sym_register] = ACTIONS(3060),
    [anon_sym_inline] = ACTIONS(3060),
    [anon_sym___inline] = ACTIONS(3060),
    [anon_sym___inline__] = ACTIONS(3060),
    [anon_sym___forceinline] = ACTIONS(3060),
    [anon_sym_thread_local] = ACTIONS(3060),
    [anon_sym___thread] = ACTIONS(3060),
    [anon_sym_const] = ACTIONS(3060),
    [anon_sym_constexpr] = ACTIONS(3060),
    [anon_sym_volatile] = ACTIONS(3060),
    [anon_sym_restrict] = ACTIONS(3060),
    [anon_sym___restrict__] = ACTIONS(3060),
    [anon_sym__Atomic] = ACTIONS(3060),
    [anon_sym__Noreturn] = ACTIONS(3060),
    [anon_sym_noreturn] = ACTIONS(3060),
    [anon_sym_mutable] = ACTIONS(3060),
    [anon_sym_constinit] = ACTIONS(3060),
    [anon_sym_consteval] = ACTIONS(3060),
    [anon_sym_alignas] = ACTIONS(3060),
    [anon_sym__Alignas] = ACTIONS(3060),
    [anon_sym_DOT] = ACTIONS(3062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3060),
    [anon_sym_let] = ACTIONS(3060),
    [anon_sym_This] = ACTIONS(3060),
    [sym_virtual] = ACTIONS(3060),
    [anon_sym_operator] = ACTIONS(3060),
    [anon_sym_precise] = ACTIONS(3060),
    [anon_sym_shared] = ACTIONS(3060),
    [anon_sym_groupshared] = ACTIONS(3060),
    [anon_sym_uniform] = ACTIONS(3060),
    [anon_sym_row_major] = ACTIONS(3060),
    [anon_sym_column_major] = ACTIONS(3060),
    [anon_sym_globallycoherent] = ACTIONS(3060),
    [anon_sym_centroid] = ACTIONS(3060),
    [anon_sym_noperspective] = ACTIONS(3060),
    [anon_sym_nointerpolation] = ACTIONS(3060),
    [anon_sym_sample] = ACTIONS(3060),
    [anon_sym_linear] = ACTIONS(3060),
    [anon_sym_snorm] = ACTIONS(3060),
    [anon_sym_unorm] = ACTIONS(3060),
    [anon_sym_point] = ACTIONS(3060),
    [anon_sym_line] = ACTIONS(3060),
    [anon_sym_triangleadj] = ACTIONS(3060),
    [anon_sym_lineadj] = ACTIONS(3060),
    [anon_sym_triangle] = ACTIONS(3060),
  },
  [3143] = {
    [sym_string_literal] = STATE(2997),
    [sym_raw_string_literal] = STATE(2997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_RPAREN] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(2128),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2117),
    [anon_sym_EQ] = ACTIONS(2128),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2117),
    [anon_sym_SLASH_EQ] = ACTIONS(2117),
    [anon_sym_PERCENT_EQ] = ACTIONS(2117),
    [anon_sym_PLUS_EQ] = ACTIONS(2117),
    [anon_sym_DASH_EQ] = ACTIONS(2117),
    [anon_sym_LT_LT_EQ] = ACTIONS(2117),
    [anon_sym_GT_GT_EQ] = ACTIONS(2117),
    [anon_sym_AMP_EQ] = ACTIONS(2117),
    [anon_sym_CARET_EQ] = ACTIONS(2117),
    [anon_sym_PIPE_EQ] = ACTIONS(2117),
    [anon_sym_and_eq] = ACTIONS(2128),
    [anon_sym_or_eq] = ACTIONS(2128),
    [anon_sym_xor_eq] = ACTIONS(2128),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2128),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2128),
    [anon_sym_not_eq] = ACTIONS(2128),
    [anon_sym_is] = ACTIONS(2128),
    [anon_sym_as] = ACTIONS(2128),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2128),
    [anon_sym_L_DQUOTE] = ACTIONS(6169),
    [anon_sym_u_DQUOTE] = ACTIONS(6169),
    [anon_sym_U_DQUOTE] = ACTIONS(6169),
    [anon_sym_u8_DQUOTE] = ACTIONS(6169),
    [anon_sym_DQUOTE] = ACTIONS(6169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6171),
    [anon_sym_LR_DQUOTE] = ACTIONS(6171),
    [anon_sym_uR_DQUOTE] = ACTIONS(6171),
    [anon_sym_UR_DQUOTE] = ACTIONS(6171),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6171),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2117),
    [sym_literal_suffix] = ACTIONS(6853),
  },
  [3144] = {
    [sym_attribute_specifier] = STATE(2767),
    [sym_enumerator_list] = STATE(2708),
    [sym__enum_base_clause] = STATE(2678),
    [sym_identifier] = ACTIONS(3348),
    [anon_sym_LPAREN2] = ACTIONS(3350),
    [anon_sym_STAR] = ACTIONS(3350),
    [anon_sym_AMP_AMP] = ACTIONS(3350),
    [anon_sym_AMP] = ACTIONS(3348),
    [anon_sym_COLON] = ACTIONS(6891),
    [anon_sym_SEMI] = ACTIONS(3350),
    [anon_sym___extension__] = ACTIONS(3348),
    [anon_sym_in] = ACTIONS(3348),
    [anon_sym_out] = ACTIONS(3348),
    [anon_sym_inout] = ACTIONS(3348),
    [anon_sym_extern] = ACTIONS(3348),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3350),
    [anon_sym___declspec] = ACTIONS(3348),
    [anon_sym___based] = ACTIONS(3348),
    [anon_sym_LBRACE] = ACTIONS(6313),
    [anon_sym_static] = ACTIONS(3348),
    [anon_sym_register] = ACTIONS(3348),
    [anon_sym_inline] = ACTIONS(3348),
    [anon_sym___inline] = ACTIONS(3348),
    [anon_sym___inline__] = ACTIONS(3348),
    [anon_sym___forceinline] = ACTIONS(3348),
    [anon_sym_thread_local] = ACTIONS(3348),
    [anon_sym___thread] = ACTIONS(3348),
    [anon_sym_const] = ACTIONS(3348),
    [anon_sym_constexpr] = ACTIONS(3348),
    [anon_sym_volatile] = ACTIONS(3348),
    [anon_sym_restrict] = ACTIONS(3348),
    [anon_sym___restrict__] = ACTIONS(3348),
    [anon_sym__Atomic] = ACTIONS(3348),
    [anon_sym__Noreturn] = ACTIONS(3348),
    [anon_sym_noreturn] = ACTIONS(3348),
    [anon_sym_mutable] = ACTIONS(3348),
    [anon_sym_constinit] = ACTIONS(3348),
    [anon_sym_consteval] = ACTIONS(3348),
    [anon_sym_alignas] = ACTIONS(3348),
    [anon_sym__Alignas] = ACTIONS(3348),
    [anon_sym_DOT] = ACTIONS(3350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3348),
    [anon_sym_let] = ACTIONS(3348),
    [anon_sym_This] = ACTIONS(3348),
    [sym_virtual] = ACTIONS(3348),
    [anon_sym_operator] = ACTIONS(3348),
    [anon_sym_precise] = ACTIONS(3348),
    [anon_sym_shared] = ACTIONS(3348),
    [anon_sym_groupshared] = ACTIONS(3348),
    [anon_sym_uniform] = ACTIONS(3348),
    [anon_sym_row_major] = ACTIONS(3348),
    [anon_sym_column_major] = ACTIONS(3348),
    [anon_sym_globallycoherent] = ACTIONS(3348),
    [anon_sym_centroid] = ACTIONS(3348),
    [anon_sym_noperspective] = ACTIONS(3348),
    [anon_sym_nointerpolation] = ACTIONS(3348),
    [anon_sym_sample] = ACTIONS(3348),
    [anon_sym_linear] = ACTIONS(3348),
    [anon_sym_snorm] = ACTIONS(3348),
    [anon_sym_unorm] = ACTIONS(3348),
    [anon_sym_point] = ACTIONS(3348),
    [anon_sym_line] = ACTIONS(3348),
    [anon_sym_triangleadj] = ACTIONS(3348),
    [anon_sym_lineadj] = ACTIONS(3348),
    [anon_sym_triangle] = ACTIONS(3348),
  },
  [3145] = {
    [sym_string_literal] = STATE(3033),
    [sym_raw_string_literal] = STATE(3033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2117),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(2128),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_SEMI] = ACTIONS(2117),
    [anon_sym___attribute__] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2117),
    [anon_sym_EQ] = ACTIONS(2128),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2117),
    [anon_sym_SLASH_EQ] = ACTIONS(2117),
    [anon_sym_PERCENT_EQ] = ACTIONS(2117),
    [anon_sym_PLUS_EQ] = ACTIONS(2117),
    [anon_sym_DASH_EQ] = ACTIONS(2117),
    [anon_sym_LT_LT_EQ] = ACTIONS(2117),
    [anon_sym_GT_GT_EQ] = ACTIONS(2117),
    [anon_sym_AMP_EQ] = ACTIONS(2117),
    [anon_sym_CARET_EQ] = ACTIONS(2117),
    [anon_sym_PIPE_EQ] = ACTIONS(2117),
    [anon_sym_and_eq] = ACTIONS(2128),
    [anon_sym_or_eq] = ACTIONS(2128),
    [anon_sym_xor_eq] = ACTIONS(2128),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2128),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2128),
    [anon_sym_not_eq] = ACTIONS(2128),
    [anon_sym_is] = ACTIONS(2128),
    [anon_sym_as] = ACTIONS(2128),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(6692),
    [anon_sym_u_DQUOTE] = ACTIONS(6692),
    [anon_sym_U_DQUOTE] = ACTIONS(6692),
    [anon_sym_u8_DQUOTE] = ACTIONS(6692),
    [anon_sym_DQUOTE] = ACTIONS(6692),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6694),
    [anon_sym_LR_DQUOTE] = ACTIONS(6694),
    [anon_sym_uR_DQUOTE] = ACTIONS(6694),
    [anon_sym_UR_DQUOTE] = ACTIONS(6694),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6694),
    [sym_literal_suffix] = ACTIONS(6592),
  },
  [3146] = {
    [sym_attribute_specifier] = STATE(3071),
    [sym_enumerator_list] = STATE(3034),
    [sym__enum_base_clause] = STATE(2974),
    [sym_identifier] = ACTIONS(3060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3062),
    [anon_sym_COMMA] = ACTIONS(3062),
    [aux_sym_preproc_if_token2] = ACTIONS(3062),
    [aux_sym_preproc_else_token1] = ACTIONS(3062),
    [aux_sym_preproc_elif_token1] = ACTIONS(3060),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3062),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3062),
    [anon_sym_LPAREN2] = ACTIONS(3062),
    [anon_sym_DASH] = ACTIONS(3060),
    [anon_sym_PLUS] = ACTIONS(3060),
    [anon_sym_STAR] = ACTIONS(3060),
    [anon_sym_SLASH] = ACTIONS(3060),
    [anon_sym_PERCENT] = ACTIONS(3060),
    [anon_sym_PIPE_PIPE] = ACTIONS(3062),
    [anon_sym_AMP_AMP] = ACTIONS(3062),
    [anon_sym_PIPE] = ACTIONS(3060),
    [anon_sym_CARET] = ACTIONS(3060),
    [anon_sym_AMP] = ACTIONS(3060),
    [anon_sym_EQ_EQ] = ACTIONS(3062),
    [anon_sym_BANG_EQ] = ACTIONS(3062),
    [anon_sym_GT] = ACTIONS(3060),
    [anon_sym_GT_EQ] = ACTIONS(3062),
    [anon_sym_LT_EQ] = ACTIONS(3060),
    [anon_sym_LT] = ACTIONS(3060),
    [anon_sym_LT_LT] = ACTIONS(3060),
    [anon_sym_GT_GT] = ACTIONS(3060),
    [anon_sym_COLON] = ACTIONS(6893),
    [anon_sym___attribute__] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(6615),
    [anon_sym_LBRACK] = ACTIONS(3062),
    [anon_sym_EQ] = ACTIONS(3060),
    [anon_sym_QMARK] = ACTIONS(3062),
    [anon_sym_STAR_EQ] = ACTIONS(3062),
    [anon_sym_SLASH_EQ] = ACTIONS(3062),
    [anon_sym_PERCENT_EQ] = ACTIONS(3062),
    [anon_sym_PLUS_EQ] = ACTIONS(3062),
    [anon_sym_DASH_EQ] = ACTIONS(3062),
    [anon_sym_LT_LT_EQ] = ACTIONS(3062),
    [anon_sym_GT_GT_EQ] = ACTIONS(3062),
    [anon_sym_AMP_EQ] = ACTIONS(3062),
    [anon_sym_CARET_EQ] = ACTIONS(3062),
    [anon_sym_PIPE_EQ] = ACTIONS(3062),
    [anon_sym_and_eq] = ACTIONS(3060),
    [anon_sym_or_eq] = ACTIONS(3060),
    [anon_sym_xor_eq] = ACTIONS(3060),
    [anon_sym_LT_EQ_GT] = ACTIONS(3062),
    [anon_sym_or] = ACTIONS(3060),
    [anon_sym_and] = ACTIONS(3060),
    [anon_sym_bitor] = ACTIONS(3060),
    [anon_sym_xor] = ACTIONS(3060),
    [anon_sym_bitand] = ACTIONS(3060),
    [anon_sym_not_eq] = ACTIONS(3060),
    [anon_sym_is] = ACTIONS(3060),
    [anon_sym_as] = ACTIONS(3060),
    [anon_sym_DASH_DASH] = ACTIONS(3062),
    [anon_sym_PLUS_PLUS] = ACTIONS(3062),
    [anon_sym_DOT] = ACTIONS(3060),
    [anon_sym_DOT_STAR] = ACTIONS(3062),
    [anon_sym_DASH_GT] = ACTIONS(3062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3060),
    [anon_sym_let] = ACTIONS(3060),
    [anon_sym_This] = ACTIONS(3060),
  },
  [3147] = {
    [sym_attribute_specifier] = STATE(2915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3727),
    [anon_sym_COMMA] = ACTIONS(3727),
    [anon_sym_RPAREN] = ACTIONS(3727),
    [anon_sym_LPAREN2] = ACTIONS(3727),
    [anon_sym_DASH] = ACTIONS(3725),
    [anon_sym_PLUS] = ACTIONS(3725),
    [anon_sym_STAR] = ACTIONS(3727),
    [anon_sym_SLASH] = ACTIONS(3725),
    [anon_sym_PERCENT] = ACTIONS(3727),
    [anon_sym_PIPE_PIPE] = ACTIONS(3727),
    [anon_sym_AMP_AMP] = ACTIONS(3727),
    [anon_sym_PIPE] = ACTIONS(3725),
    [anon_sym_CARET] = ACTIONS(3727),
    [anon_sym_AMP] = ACTIONS(3725),
    [anon_sym_EQ_EQ] = ACTIONS(3727),
    [anon_sym_BANG_EQ] = ACTIONS(3727),
    [anon_sym_GT] = ACTIONS(3725),
    [anon_sym_GT_EQ] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(3725),
    [anon_sym_LT] = ACTIONS(3725),
    [anon_sym_LT_LT] = ACTIONS(3727),
    [anon_sym_GT_GT] = ACTIONS(3727),
    [anon_sym_COLON] = ACTIONS(3727),
    [anon_sym_SEMI] = ACTIONS(3727),
    [anon_sym___extension__] = ACTIONS(3727),
    [anon_sym___attribute__] = ACTIONS(6621),
    [anon_sym_LBRACE] = ACTIONS(3727),
    [anon_sym_RBRACE] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(3727),
    [anon_sym_RBRACK] = ACTIONS(3727),
    [anon_sym_const] = ACTIONS(3725),
    [anon_sym_constexpr] = ACTIONS(3727),
    [anon_sym_volatile] = ACTIONS(3727),
    [anon_sym_restrict] = ACTIONS(3727),
    [anon_sym___restrict__] = ACTIONS(3727),
    [anon_sym__Atomic] = ACTIONS(3727),
    [anon_sym__Noreturn] = ACTIONS(3727),
    [anon_sym_noreturn] = ACTIONS(3727),
    [anon_sym_mutable] = ACTIONS(3727),
    [anon_sym_constinit] = ACTIONS(3727),
    [anon_sym_consteval] = ACTIONS(3727),
    [anon_sym_alignas] = ACTIONS(3727),
    [anon_sym__Alignas] = ACTIONS(3727),
    [anon_sym_QMARK] = ACTIONS(3727),
    [anon_sym_LT_EQ_GT] = ACTIONS(3727),
    [anon_sym_or] = ACTIONS(3727),
    [anon_sym_and] = ACTIONS(3727),
    [anon_sym_bitor] = ACTIONS(3727),
    [anon_sym_xor] = ACTIONS(3727),
    [anon_sym_bitand] = ACTIONS(3727),
    [anon_sym_not_eq] = ACTIONS(3727),
    [anon_sym_is] = ACTIONS(3727),
    [anon_sym_as] = ACTIONS(3727),
    [anon_sym_DASH_DASH] = ACTIONS(3727),
    [anon_sym_PLUS_PLUS] = ACTIONS(3727),
    [anon_sym_DOT] = ACTIONS(3725),
    [anon_sym_DOT_STAR] = ACTIONS(3727),
    [anon_sym_DASH_GT] = ACTIONS(3727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3727),
    [anon_sym_let] = ACTIONS(3727),
    [anon_sym_This] = ACTIONS(3727),
    [anon_sym_final] = ACTIONS(3727),
    [anon_sym_override] = ACTIONS(3727),
    [anon_sym_requires] = ACTIONS(3727),
    [anon_sym_where] = ACTIONS(3727),
  },
  [3148] = {
    [sym_attribute_specifier] = STATE(3098),
    [sym_enumerator_list] = STATE(3018),
    [sym__enum_base_clause] = STATE(2983),
    [sym_identifier] = ACTIONS(3348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3350),
    [anon_sym_COMMA] = ACTIONS(3350),
    [aux_sym_preproc_if_token2] = ACTIONS(3350),
    [aux_sym_preproc_else_token1] = ACTIONS(3350),
    [aux_sym_preproc_elif_token1] = ACTIONS(3348),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3350),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3350),
    [anon_sym_LPAREN2] = ACTIONS(3350),
    [anon_sym_DASH] = ACTIONS(3348),
    [anon_sym_PLUS] = ACTIONS(3348),
    [anon_sym_STAR] = ACTIONS(3348),
    [anon_sym_SLASH] = ACTIONS(3348),
    [anon_sym_PERCENT] = ACTIONS(3348),
    [anon_sym_PIPE_PIPE] = ACTIONS(3350),
    [anon_sym_AMP_AMP] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3348),
    [anon_sym_CARET] = ACTIONS(3348),
    [anon_sym_AMP] = ACTIONS(3348),
    [anon_sym_EQ_EQ] = ACTIONS(3350),
    [anon_sym_BANG_EQ] = ACTIONS(3350),
    [anon_sym_GT] = ACTIONS(3348),
    [anon_sym_GT_EQ] = ACTIONS(3350),
    [anon_sym_LT_EQ] = ACTIONS(3348),
    [anon_sym_LT] = ACTIONS(3348),
    [anon_sym_LT_LT] = ACTIONS(3348),
    [anon_sym_GT_GT] = ACTIONS(3348),
    [anon_sym_COLON] = ACTIONS(6893),
    [anon_sym___attribute__] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(6615),
    [anon_sym_LBRACK] = ACTIONS(3350),
    [anon_sym_EQ] = ACTIONS(3348),
    [anon_sym_QMARK] = ACTIONS(3350),
    [anon_sym_STAR_EQ] = ACTIONS(3350),
    [anon_sym_SLASH_EQ] = ACTIONS(3350),
    [anon_sym_PERCENT_EQ] = ACTIONS(3350),
    [anon_sym_PLUS_EQ] = ACTIONS(3350),
    [anon_sym_DASH_EQ] = ACTIONS(3350),
    [anon_sym_LT_LT_EQ] = ACTIONS(3350),
    [anon_sym_GT_GT_EQ] = ACTIONS(3350),
    [anon_sym_AMP_EQ] = ACTIONS(3350),
    [anon_sym_CARET_EQ] = ACTIONS(3350),
    [anon_sym_PIPE_EQ] = ACTIONS(3350),
    [anon_sym_and_eq] = ACTIONS(3348),
    [anon_sym_or_eq] = ACTIONS(3348),
    [anon_sym_xor_eq] = ACTIONS(3348),
    [anon_sym_LT_EQ_GT] = ACTIONS(3350),
    [anon_sym_or] = ACTIONS(3348),
    [anon_sym_and] = ACTIONS(3348),
    [anon_sym_bitor] = ACTIONS(3348),
    [anon_sym_xor] = ACTIONS(3348),
    [anon_sym_bitand] = ACTIONS(3348),
    [anon_sym_not_eq] = ACTIONS(3348),
    [anon_sym_is] = ACTIONS(3348),
    [anon_sym_as] = ACTIONS(3348),
    [anon_sym_DASH_DASH] = ACTIONS(3350),
    [anon_sym_PLUS_PLUS] = ACTIONS(3350),
    [anon_sym_DOT] = ACTIONS(3348),
    [anon_sym_DOT_STAR] = ACTIONS(3350),
    [anon_sym_DASH_GT] = ACTIONS(3350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3348),
    [anon_sym_let] = ACTIONS(3348),
    [anon_sym_This] = ACTIONS(3348),
  },
  [3149] = {
    [sym_attribute_specifier] = STATE(2902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3721),
    [anon_sym_RPAREN] = ACTIONS(3721),
    [anon_sym_LPAREN2] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3719),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_PIPE_PIPE] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3721),
    [anon_sym_BANG_EQ] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3721),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_LT] = ACTIONS(3719),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_SEMI] = ACTIONS(3721),
    [anon_sym___extension__] = ACTIONS(3721),
    [anon_sym___attribute__] = ACTIONS(6621),
    [anon_sym_LBRACE] = ACTIONS(3721),
    [anon_sym_RBRACE] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3721),
    [anon_sym_RBRACK] = ACTIONS(3721),
    [anon_sym_const] = ACTIONS(3719),
    [anon_sym_constexpr] = ACTIONS(3721),
    [anon_sym_volatile] = ACTIONS(3721),
    [anon_sym_restrict] = ACTIONS(3721),
    [anon_sym___restrict__] = ACTIONS(3721),
    [anon_sym__Atomic] = ACTIONS(3721),
    [anon_sym__Noreturn] = ACTIONS(3721),
    [anon_sym_noreturn] = ACTIONS(3721),
    [anon_sym_mutable] = ACTIONS(3721),
    [anon_sym_constinit] = ACTIONS(3721),
    [anon_sym_consteval] = ACTIONS(3721),
    [anon_sym_alignas] = ACTIONS(3721),
    [anon_sym__Alignas] = ACTIONS(3721),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_LT_EQ_GT] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_bitor] = ACTIONS(3721),
    [anon_sym_xor] = ACTIONS(3721),
    [anon_sym_bitand] = ACTIONS(3721),
    [anon_sym_not_eq] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_DASH_DASH] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3721),
    [anon_sym_DOT] = ACTIONS(3719),
    [anon_sym_DOT_STAR] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3721),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3721),
    [anon_sym_let] = ACTIONS(3721),
    [anon_sym_This] = ACTIONS(3721),
    [anon_sym_final] = ACTIONS(3721),
    [anon_sym_override] = ACTIONS(3721),
    [anon_sym_requires] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(3721),
  },
  [3150] = {
    [sym_identifier] = ACTIONS(6895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6897),
    [anon_sym_COMMA] = ACTIONS(6897),
    [anon_sym_RPAREN] = ACTIONS(6897),
    [aux_sym_preproc_if_token2] = ACTIONS(6897),
    [aux_sym_preproc_else_token1] = ACTIONS(6897),
    [aux_sym_preproc_elif_token1] = ACTIONS(6895),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6897),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6897),
    [anon_sym_LPAREN2] = ACTIONS(6897),
    [anon_sym_DASH] = ACTIONS(6895),
    [anon_sym_PLUS] = ACTIONS(6895),
    [anon_sym_STAR] = ACTIONS(6895),
    [anon_sym_SLASH] = ACTIONS(6895),
    [anon_sym_PERCENT] = ACTIONS(6895),
    [anon_sym_PIPE_PIPE] = ACTIONS(6897),
    [anon_sym_AMP_AMP] = ACTIONS(6897),
    [anon_sym_PIPE] = ACTIONS(6895),
    [anon_sym_CARET] = ACTIONS(6895),
    [anon_sym_AMP] = ACTIONS(6895),
    [anon_sym_EQ_EQ] = ACTIONS(6897),
    [anon_sym_BANG_EQ] = ACTIONS(6897),
    [anon_sym_GT] = ACTIONS(6895),
    [anon_sym_GT_EQ] = ACTIONS(6897),
    [anon_sym_LT_EQ] = ACTIONS(6895),
    [anon_sym_LT] = ACTIONS(6895),
    [anon_sym_LT_LT] = ACTIONS(6895),
    [anon_sym_GT_GT] = ACTIONS(6895),
    [anon_sym_COLON] = ACTIONS(6897),
    [anon_sym_SEMI] = ACTIONS(6897),
    [anon_sym___attribute__] = ACTIONS(6895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6897),
    [anon_sym_LBRACE] = ACTIONS(6897),
    [anon_sym_RBRACE] = ACTIONS(6897),
    [anon_sym_LBRACK] = ACTIONS(6895),
    [anon_sym_RBRACK] = ACTIONS(6897),
    [anon_sym_EQ] = ACTIONS(6895),
    [anon_sym_QMARK] = ACTIONS(6897),
    [anon_sym_STAR_EQ] = ACTIONS(6897),
    [anon_sym_SLASH_EQ] = ACTIONS(6897),
    [anon_sym_PERCENT_EQ] = ACTIONS(6897),
    [anon_sym_PLUS_EQ] = ACTIONS(6897),
    [anon_sym_DASH_EQ] = ACTIONS(6897),
    [anon_sym_LT_LT_EQ] = ACTIONS(6897),
    [anon_sym_GT_GT_EQ] = ACTIONS(6897),
    [anon_sym_AMP_EQ] = ACTIONS(6897),
    [anon_sym_CARET_EQ] = ACTIONS(6897),
    [anon_sym_PIPE_EQ] = ACTIONS(6897),
    [anon_sym_and_eq] = ACTIONS(6895),
    [anon_sym_or_eq] = ACTIONS(6895),
    [anon_sym_xor_eq] = ACTIONS(6895),
    [anon_sym_LT_EQ_GT] = ACTIONS(6897),
    [anon_sym_or] = ACTIONS(6895),
    [anon_sym_and] = ACTIONS(6895),
    [anon_sym_bitor] = ACTIONS(6895),
    [anon_sym_xor] = ACTIONS(6895),
    [anon_sym_bitand] = ACTIONS(6895),
    [anon_sym_not_eq] = ACTIONS(6895),
    [anon_sym_is] = ACTIONS(6895),
    [anon_sym_as] = ACTIONS(6895),
    [anon_sym_DASH_DASH] = ACTIONS(6897),
    [anon_sym_PLUS_PLUS] = ACTIONS(6897),
    [anon_sym_DOT] = ACTIONS(6895),
    [anon_sym_DOT_STAR] = ACTIONS(6897),
    [anon_sym_DASH_GT] = ACTIONS(6897),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6895),
  },
  [3151] = {
    [sym_attribute_specifier] = STATE(2893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3733),
    [anon_sym_COMMA] = ACTIONS(3733),
    [anon_sym_RPAREN] = ACTIONS(3733),
    [anon_sym_LPAREN2] = ACTIONS(3733),
    [anon_sym_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3731),
    [anon_sym_STAR] = ACTIONS(3733),
    [anon_sym_SLASH] = ACTIONS(3731),
    [anon_sym_PERCENT] = ACTIONS(3733),
    [anon_sym_PIPE_PIPE] = ACTIONS(3733),
    [anon_sym_AMP_AMP] = ACTIONS(3733),
    [anon_sym_PIPE] = ACTIONS(3731),
    [anon_sym_CARET] = ACTIONS(3733),
    [anon_sym_AMP] = ACTIONS(3731),
    [anon_sym_EQ_EQ] = ACTIONS(3733),
    [anon_sym_BANG_EQ] = ACTIONS(3733),
    [anon_sym_GT] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3733),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_LT] = ACTIONS(3731),
    [anon_sym_LT_LT] = ACTIONS(3733),
    [anon_sym_GT_GT] = ACTIONS(3733),
    [anon_sym_COLON] = ACTIONS(3733),
    [anon_sym_SEMI] = ACTIONS(3733),
    [anon_sym___extension__] = ACTIONS(3733),
    [anon_sym___attribute__] = ACTIONS(6621),
    [anon_sym_LBRACE] = ACTIONS(3733),
    [anon_sym_RBRACE] = ACTIONS(3733),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_RBRACK] = ACTIONS(3733),
    [anon_sym_const] = ACTIONS(3731),
    [anon_sym_constexpr] = ACTIONS(3733),
    [anon_sym_volatile] = ACTIONS(3733),
    [anon_sym_restrict] = ACTIONS(3733),
    [anon_sym___restrict__] = ACTIONS(3733),
    [anon_sym__Atomic] = ACTIONS(3733),
    [anon_sym__Noreturn] = ACTIONS(3733),
    [anon_sym_noreturn] = ACTIONS(3733),
    [anon_sym_mutable] = ACTIONS(3733),
    [anon_sym_constinit] = ACTIONS(3733),
    [anon_sym_consteval] = ACTIONS(3733),
    [anon_sym_alignas] = ACTIONS(3733),
    [anon_sym__Alignas] = ACTIONS(3733),
    [anon_sym_QMARK] = ACTIONS(3733),
    [anon_sym_LT_EQ_GT] = ACTIONS(3733),
    [anon_sym_or] = ACTIONS(3733),
    [anon_sym_and] = ACTIONS(3733),
    [anon_sym_bitor] = ACTIONS(3733),
    [anon_sym_xor] = ACTIONS(3733),
    [anon_sym_bitand] = ACTIONS(3733),
    [anon_sym_not_eq] = ACTIONS(3733),
    [anon_sym_is] = ACTIONS(3733),
    [anon_sym_as] = ACTIONS(3733),
    [anon_sym_DASH_DASH] = ACTIONS(3733),
    [anon_sym_PLUS_PLUS] = ACTIONS(3733),
    [anon_sym_DOT] = ACTIONS(3731),
    [anon_sym_DOT_STAR] = ACTIONS(3733),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3733),
    [anon_sym_let] = ACTIONS(3733),
    [anon_sym_This] = ACTIONS(3733),
    [anon_sym_final] = ACTIONS(3733),
    [anon_sym_override] = ACTIONS(3733),
    [anon_sym_requires] = ACTIONS(3733),
    [anon_sym_where] = ACTIONS(3733),
  },
  [3152] = {
    [sym_string_literal] = STATE(3033),
    [sym_raw_string_literal] = STATE(3033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6596),
    [anon_sym_COMMA] = ACTIONS(6596),
    [anon_sym_LPAREN2] = ACTIONS(6596),
    [anon_sym_DASH] = ACTIONS(6594),
    [anon_sym_PLUS] = ACTIONS(6594),
    [anon_sym_STAR] = ACTIONS(6594),
    [anon_sym_SLASH] = ACTIONS(6594),
    [anon_sym_PERCENT] = ACTIONS(6594),
    [anon_sym_PIPE_PIPE] = ACTIONS(6596),
    [anon_sym_AMP_AMP] = ACTIONS(6596),
    [anon_sym_PIPE] = ACTIONS(6594),
    [anon_sym_CARET] = ACTIONS(6594),
    [anon_sym_AMP] = ACTIONS(6594),
    [anon_sym_EQ_EQ] = ACTIONS(6596),
    [anon_sym_BANG_EQ] = ACTIONS(6596),
    [anon_sym_GT] = ACTIONS(6594),
    [anon_sym_GT_EQ] = ACTIONS(6596),
    [anon_sym_LT_EQ] = ACTIONS(6594),
    [anon_sym_LT] = ACTIONS(6594),
    [anon_sym_LT_LT] = ACTIONS(6594),
    [anon_sym_GT_GT] = ACTIONS(6594),
    [anon_sym_SEMI] = ACTIONS(6596),
    [anon_sym___attribute__] = ACTIONS(6594),
    [anon_sym_LBRACK] = ACTIONS(6596),
    [anon_sym_EQ] = ACTIONS(6594),
    [anon_sym_QMARK] = ACTIONS(6596),
    [anon_sym_STAR_EQ] = ACTIONS(6596),
    [anon_sym_SLASH_EQ] = ACTIONS(6596),
    [anon_sym_PERCENT_EQ] = ACTIONS(6596),
    [anon_sym_PLUS_EQ] = ACTIONS(6596),
    [anon_sym_DASH_EQ] = ACTIONS(6596),
    [anon_sym_LT_LT_EQ] = ACTIONS(6596),
    [anon_sym_GT_GT_EQ] = ACTIONS(6596),
    [anon_sym_AMP_EQ] = ACTIONS(6596),
    [anon_sym_CARET_EQ] = ACTIONS(6596),
    [anon_sym_PIPE_EQ] = ACTIONS(6596),
    [anon_sym_and_eq] = ACTIONS(6594),
    [anon_sym_or_eq] = ACTIONS(6594),
    [anon_sym_xor_eq] = ACTIONS(6594),
    [anon_sym_LT_EQ_GT] = ACTIONS(6596),
    [anon_sym_or] = ACTIONS(6594),
    [anon_sym_and] = ACTIONS(6594),
    [anon_sym_bitor] = ACTIONS(6594),
    [anon_sym_xor] = ACTIONS(6594),
    [anon_sym_bitand] = ACTIONS(6594),
    [anon_sym_not_eq] = ACTIONS(6594),
    [anon_sym_is] = ACTIONS(6594),
    [anon_sym_as] = ACTIONS(6594),
    [anon_sym_DASH_DASH] = ACTIONS(6596),
    [anon_sym_PLUS_PLUS] = ACTIONS(6596),
    [anon_sym_DOT] = ACTIONS(6594),
    [anon_sym_DOT_STAR] = ACTIONS(6596),
    [anon_sym_DASH_GT] = ACTIONS(6596),
    [anon_sym_L_DQUOTE] = ACTIONS(6692),
    [anon_sym_u_DQUOTE] = ACTIONS(6692),
    [anon_sym_U_DQUOTE] = ACTIONS(6692),
    [anon_sym_u8_DQUOTE] = ACTIONS(6692),
    [anon_sym_DQUOTE] = ACTIONS(6692),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6694),
    [anon_sym_LR_DQUOTE] = ACTIONS(6694),
    [anon_sym_uR_DQUOTE] = ACTIONS(6694),
    [anon_sym_UR_DQUOTE] = ACTIONS(6694),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6694),
    [sym_literal_suffix] = ACTIONS(6592),
  },
  [3153] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3193),
    [sym_identifier] = ACTIONS(6899),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3822),
    [anon_sym_COMMA] = ACTIONS(3822),
    [anon_sym_RPAREN] = ACTIONS(3822),
    [anon_sym_LPAREN2] = ACTIONS(3822),
    [anon_sym_DASH] = ACTIONS(3820),
    [anon_sym_PLUS] = ACTIONS(3820),
    [anon_sym_STAR] = ACTIONS(3820),
    [anon_sym_SLASH] = ACTIONS(3820),
    [anon_sym_PERCENT] = ACTIONS(3820),
    [anon_sym_PIPE_PIPE] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3822),
    [anon_sym_PIPE] = ACTIONS(3820),
    [anon_sym_CARET] = ACTIONS(3820),
    [anon_sym_AMP] = ACTIONS(3820),
    [anon_sym_EQ_EQ] = ACTIONS(3822),
    [anon_sym_BANG_EQ] = ACTIONS(3822),
    [anon_sym_GT] = ACTIONS(3820),
    [anon_sym_GT_EQ] = ACTIONS(3822),
    [anon_sym_LT_EQ] = ACTIONS(3820),
    [anon_sym_LT] = ACTIONS(3820),
    [anon_sym_LT_LT] = ACTIONS(3820),
    [anon_sym_GT_GT] = ACTIONS(3820),
    [anon_sym___attribute__] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3822),
    [anon_sym_signed] = ACTIONS(6901),
    [anon_sym_unsigned] = ACTIONS(6901),
    [anon_sym_long] = ACTIONS(6901),
    [anon_sym_short] = ACTIONS(6901),
    [anon_sym_LBRACK] = ACTIONS(3822),
    [anon_sym_EQ] = ACTIONS(3820),
    [sym_primitive_type] = ACTIONS(6903),
    [anon_sym_QMARK] = ACTIONS(3822),
    [anon_sym_STAR_EQ] = ACTIONS(3822),
    [anon_sym_SLASH_EQ] = ACTIONS(3822),
    [anon_sym_PERCENT_EQ] = ACTIONS(3822),
    [anon_sym_PLUS_EQ] = ACTIONS(3822),
    [anon_sym_DASH_EQ] = ACTIONS(3822),
    [anon_sym_LT_LT_EQ] = ACTIONS(3822),
    [anon_sym_GT_GT_EQ] = ACTIONS(3822),
    [anon_sym_AMP_EQ] = ACTIONS(3822),
    [anon_sym_CARET_EQ] = ACTIONS(3822),
    [anon_sym_PIPE_EQ] = ACTIONS(3822),
    [anon_sym_and_eq] = ACTIONS(3820),
    [anon_sym_or_eq] = ACTIONS(3820),
    [anon_sym_xor_eq] = ACTIONS(3820),
    [anon_sym_LT_EQ_GT] = ACTIONS(3822),
    [anon_sym_or] = ACTIONS(3820),
    [anon_sym_and] = ACTIONS(3820),
    [anon_sym_bitor] = ACTIONS(3820),
    [anon_sym_xor] = ACTIONS(3820),
    [anon_sym_bitand] = ACTIONS(3820),
    [anon_sym_not_eq] = ACTIONS(3820),
    [anon_sym_is] = ACTIONS(3820),
    [anon_sym_as] = ACTIONS(3820),
    [anon_sym_DASH_DASH] = ACTIONS(3822),
    [anon_sym_PLUS_PLUS] = ACTIONS(3822),
    [anon_sym_DOT] = ACTIONS(3820),
    [anon_sym_DOT_STAR] = ACTIONS(3822),
    [anon_sym_DASH_GT] = ACTIONS(3820),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3820),
    [anon_sym_let] = ACTIONS(3820),
    [anon_sym_This] = ACTIONS(3820),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3822),
  },
  [3154] = {
    [sym_template_argument_list] = STATE(3322),
    [sym_identifier] = ACTIONS(2169),
    [anon_sym_LPAREN2] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(2176),
    [anon_sym_AMP_AMP] = ACTIONS(2176),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(6343),
    [anon_sym_SEMI] = ACTIONS(2176),
    [anon_sym___extension__] = ACTIONS(2169),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_out] = ACTIONS(2169),
    [anon_sym_inout] = ACTIONS(2169),
    [anon_sym_extern] = ACTIONS(2169),
    [anon_sym___attribute__] = ACTIONS(2169),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2173),
    [anon_sym___declspec] = ACTIONS(2169),
    [anon_sym___based] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(2181),
    [anon_sym_static] = ACTIONS(2169),
    [anon_sym_register] = ACTIONS(2169),
    [anon_sym_inline] = ACTIONS(2169),
    [anon_sym___inline] = ACTIONS(2169),
    [anon_sym___inline__] = ACTIONS(2169),
    [anon_sym___forceinline] = ACTIONS(2169),
    [anon_sym_thread_local] = ACTIONS(2169),
    [anon_sym___thread] = ACTIONS(2169),
    [anon_sym_const] = ACTIONS(2169),
    [anon_sym_constexpr] = ACTIONS(2169),
    [anon_sym_volatile] = ACTIONS(2169),
    [anon_sym_restrict] = ACTIONS(2169),
    [anon_sym___restrict__] = ACTIONS(2169),
    [anon_sym__Atomic] = ACTIONS(2169),
    [anon_sym__Noreturn] = ACTIONS(2169),
    [anon_sym_noreturn] = ACTIONS(2169),
    [anon_sym_mutable] = ACTIONS(2169),
    [anon_sym_constinit] = ACTIONS(2169),
    [anon_sym_consteval] = ACTIONS(2169),
    [anon_sym_alignas] = ACTIONS(2169),
    [anon_sym__Alignas] = ACTIONS(2169),
    [anon_sym_DOT] = ACTIONS(2176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2169),
    [anon_sym_let] = ACTIONS(2169),
    [anon_sym_This] = ACTIONS(2169),
    [sym_virtual] = ACTIONS(2169),
    [anon_sym_operator] = ACTIONS(2169),
    [anon_sym_precise] = ACTIONS(2169),
    [anon_sym_shared] = ACTIONS(2169),
    [anon_sym_groupshared] = ACTIONS(2169),
    [anon_sym_uniform] = ACTIONS(2169),
    [anon_sym_row_major] = ACTIONS(2169),
    [anon_sym_column_major] = ACTIONS(2169),
    [anon_sym_globallycoherent] = ACTIONS(2169),
    [anon_sym_centroid] = ACTIONS(2169),
    [anon_sym_noperspective] = ACTIONS(2169),
    [anon_sym_nointerpolation] = ACTIONS(2169),
    [anon_sym_sample] = ACTIONS(2169),
    [anon_sym_linear] = ACTIONS(2169),
    [anon_sym_snorm] = ACTIONS(2169),
    [anon_sym_unorm] = ACTIONS(2169),
    [anon_sym_point] = ACTIONS(2169),
    [anon_sym_line] = ACTIONS(2169),
    [anon_sym_triangleadj] = ACTIONS(2169),
    [anon_sym_lineadj] = ACTIONS(2169),
    [anon_sym_triangle] = ACTIONS(2169),
  },
  [3155] = {
    [sym_identifier] = ACTIONS(2256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2258),
    [anon_sym_COMMA] = ACTIONS(2258),
    [anon_sym_LPAREN2] = ACTIONS(2258),
    [anon_sym_DASH] = ACTIONS(2256),
    [anon_sym_PLUS] = ACTIONS(2256),
    [anon_sym_STAR] = ACTIONS(2258),
    [anon_sym_SLASH] = ACTIONS(2256),
    [anon_sym_PERCENT] = ACTIONS(2258),
    [anon_sym_PIPE_PIPE] = ACTIONS(2258),
    [anon_sym_AMP_AMP] = ACTIONS(2258),
    [anon_sym_PIPE] = ACTIONS(2256),
    [anon_sym_CARET] = ACTIONS(2258),
    [anon_sym_AMP] = ACTIONS(2256),
    [anon_sym_EQ_EQ] = ACTIONS(2258),
    [anon_sym_BANG_EQ] = ACTIONS(2258),
    [anon_sym_GT] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_LT] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2256),
    [anon_sym_COLON] = ACTIONS(2256),
    [anon_sym___extension__] = ACTIONS(2256),
    [anon_sym___attribute__] = ACTIONS(2256),
    [anon_sym_COLON_COLON] = ACTIONS(2258),
    [anon_sym_LBRACE] = ACTIONS(2258),
    [anon_sym_LBRACK] = ACTIONS(2258),
    [anon_sym_EQ] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_constexpr] = ACTIONS(2256),
    [anon_sym_volatile] = ACTIONS(2256),
    [anon_sym_restrict] = ACTIONS(2256),
    [anon_sym___restrict__] = ACTIONS(2256),
    [anon_sym__Atomic] = ACTIONS(2256),
    [anon_sym__Noreturn] = ACTIONS(2256),
    [anon_sym_noreturn] = ACTIONS(2256),
    [anon_sym_mutable] = ACTIONS(2256),
    [anon_sym_constinit] = ACTIONS(2256),
    [anon_sym_consteval] = ACTIONS(2256),
    [anon_sym_alignas] = ACTIONS(2256),
    [anon_sym__Alignas] = ACTIONS(2256),
    [anon_sym_QMARK] = ACTIONS(2258),
    [anon_sym_LT_EQ_GT] = ACTIONS(2258),
    [anon_sym_or] = ACTIONS(2256),
    [anon_sym_and] = ACTIONS(2256),
    [anon_sym_bitor] = ACTIONS(2256),
    [anon_sym_xor] = ACTIONS(2256),
    [anon_sym_bitand] = ACTIONS(2256),
    [anon_sym_not_eq] = ACTIONS(2256),
    [anon_sym_is] = ACTIONS(2256),
    [anon_sym_as] = ACTIONS(2256),
    [anon_sym_DASH_DASH] = ACTIONS(2258),
    [anon_sym_PLUS_PLUS] = ACTIONS(2258),
    [anon_sym_DOT] = ACTIONS(2256),
    [anon_sym_DOT_STAR] = ACTIONS(2258),
    [anon_sym_DASH_GT] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_This] = ACTIONS(2256),
    [anon_sym_final] = ACTIONS(2256),
    [anon_sym_override] = ACTIONS(2256),
    [anon_sym_GT2] = ACTIONS(2258),
    [anon_sym_requires] = ACTIONS(2256),
    [anon_sym_where] = ACTIONS(2256),
  },
  [3156] = {
    [sym_identifier] = ACTIONS(6511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6513),
    [anon_sym_COMMA] = ACTIONS(6513),
    [anon_sym_RPAREN] = ACTIONS(6513),
    [anon_sym_LPAREN2] = ACTIONS(6513),
    [anon_sym_DASH] = ACTIONS(6511),
    [anon_sym_PLUS] = ACTIONS(6511),
    [anon_sym_STAR] = ACTIONS(6511),
    [anon_sym_SLASH] = ACTIONS(6511),
    [anon_sym_PERCENT] = ACTIONS(6511),
    [anon_sym_PIPE_PIPE] = ACTIONS(6513),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_PIPE] = ACTIONS(6511),
    [anon_sym_CARET] = ACTIONS(6511),
    [anon_sym_AMP] = ACTIONS(6511),
    [anon_sym_EQ_EQ] = ACTIONS(6513),
    [anon_sym_BANG_EQ] = ACTIONS(6513),
    [anon_sym_GT] = ACTIONS(6511),
    [anon_sym_GT_EQ] = ACTIONS(6513),
    [anon_sym_LT_EQ] = ACTIONS(6511),
    [anon_sym_LT] = ACTIONS(6511),
    [anon_sym_LT_LT] = ACTIONS(6511),
    [anon_sym_GT_GT] = ACTIONS(6511),
    [anon_sym_LBRACK] = ACTIONS(6513),
    [anon_sym_EQ] = ACTIONS(6511),
    [anon_sym_QMARK] = ACTIONS(6513),
    [anon_sym_STAR_EQ] = ACTIONS(6513),
    [anon_sym_SLASH_EQ] = ACTIONS(6513),
    [anon_sym_PERCENT_EQ] = ACTIONS(6513),
    [anon_sym_PLUS_EQ] = ACTIONS(6513),
    [anon_sym_DASH_EQ] = ACTIONS(6513),
    [anon_sym_LT_LT_EQ] = ACTIONS(6513),
    [anon_sym_GT_GT_EQ] = ACTIONS(6513),
    [anon_sym_AMP_EQ] = ACTIONS(6513),
    [anon_sym_CARET_EQ] = ACTIONS(6513),
    [anon_sym_PIPE_EQ] = ACTIONS(6513),
    [anon_sym_and_eq] = ACTIONS(6511),
    [anon_sym_or_eq] = ACTIONS(6511),
    [anon_sym_xor_eq] = ACTIONS(6511),
    [anon_sym_LT_EQ_GT] = ACTIONS(6513),
    [anon_sym_or] = ACTIONS(6511),
    [anon_sym_and] = ACTIONS(6511),
    [anon_sym_bitor] = ACTIONS(6511),
    [anon_sym_xor] = ACTIONS(6511),
    [anon_sym_bitand] = ACTIONS(6511),
    [anon_sym_not_eq] = ACTIONS(6511),
    [anon_sym_is] = ACTIONS(6511),
    [anon_sym_as] = ACTIONS(6511),
    [anon_sym_DASH_DASH] = ACTIONS(6513),
    [anon_sym_PLUS_PLUS] = ACTIONS(6513),
    [anon_sym_DOT] = ACTIONS(6511),
    [anon_sym_DOT_STAR] = ACTIONS(6513),
    [anon_sym_DASH_GT] = ACTIONS(6511),
    [anon_sym_L_DQUOTE] = ACTIONS(6513),
    [anon_sym_u_DQUOTE] = ACTIONS(6513),
    [anon_sym_U_DQUOTE] = ACTIONS(6513),
    [anon_sym_u8_DQUOTE] = ACTIONS(6513),
    [anon_sym_DQUOTE] = ACTIONS(6513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6513),
    [anon_sym_LR_DQUOTE] = ACTIONS(6513),
    [anon_sym_uR_DQUOTE] = ACTIONS(6513),
    [anon_sym_UR_DQUOTE] = ACTIONS(6513),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6513),
    [anon_sym_DASH_GT_STAR] = ACTIONS(6513),
    [sym_literal_suffix] = ACTIONS(6511),
  },
  [3157] = {
    [sym_ms_based_modifier] = STATE(10435),
    [sym_ms_unaligned_ptr_modifier] = STATE(4963),
    [sym_ms_pointer_modifier] = STATE(4823),
    [sym__declarator] = STATE(7264),
    [sym__abstract_declarator] = STATE(8305),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_abstract_parenthesized_declarator] = STATE(7128),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_abstract_pointer_declarator] = STATE(7128),
    [sym_function_declarator] = STATE(7882),
    [sym_abstract_function_declarator] = STATE(7128),
    [sym_array_declarator] = STATE(7882),
    [sym_abstract_array_declarator] = STATE(7128),
    [sym_type_qualifier] = STATE(3571),
    [sym_alignas_qualifier] = STATE(5665),
    [sym_parameter_list] = STATE(4541),
    [sym_decltype] = STATE(10765),
    [sym_reference_declarator] = STATE(7882),
    [sym_abstract_reference_declarator] = STATE(7128),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym__function_declarator_seq] = STATE(7135),
    [sym_template_type] = STATE(10765),
    [sym_template_function] = STATE(7882),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6926),
    [sym_qualified_identifier] = STATE(7882),
    [sym_operator_name] = STATE(7882),
    [aux_sym__type_definition_type_repeat1] = STATE(3571),
    [aux_sym_pointer_declarator_repeat1] = STATE(4823),
    [sym_identifier] = ACTIONS(6761),
    [anon_sym_COMMA] = ACTIONS(6777),
    [anon_sym_RPAREN] = ACTIONS(6777),
    [anon_sym_LPAREN2] = ACTIONS(4883),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(6905),
    [anon_sym_AMP_AMP] = ACTIONS(6907),
    [anon_sym_AMP] = ACTIONS(6909),
    [anon_sym_COLON] = ACTIONS(6779),
    [anon_sym___extension__] = ACTIONS(4901),
    [anon_sym_COLON_COLON] = ACTIONS(6773),
    [anon_sym___based] = ACTIONS(49),
    [sym_ms_restrict_modifier] = ACTIONS(4903),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(4903),
    [sym_ms_signed_ptr_modifier] = ACTIONS(4903),
    [anon_sym__unaligned] = ACTIONS(4905),
    [anon_sym___unaligned] = ACTIONS(4905),
    [anon_sym_LBRACK] = ACTIONS(6775),
    [anon_sym_const] = ACTIONS(4901),
    [anon_sym_constexpr] = ACTIONS(4901),
    [anon_sym_volatile] = ACTIONS(4901),
    [anon_sym_restrict] = ACTIONS(4901),
    [anon_sym___restrict__] = ACTIONS(4901),
    [anon_sym__Atomic] = ACTIONS(4901),
    [anon_sym__Noreturn] = ACTIONS(4901),
    [anon_sym_noreturn] = ACTIONS(4901),
    [anon_sym_mutable] = ACTIONS(4901),
    [anon_sym_constinit] = ACTIONS(4901),
    [anon_sym_consteval] = ACTIONS(4901),
    [anon_sym_alignas] = ACTIONS(4907),
    [anon_sym__Alignas] = ACTIONS(4907),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(2808),
  },
  [3158] = {
    [sym_identifier] = ACTIONS(6460),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6462),
    [anon_sym_COMMA] = ACTIONS(6462),
    [anon_sym_LPAREN2] = ACTIONS(6462),
    [anon_sym_DASH] = ACTIONS(6460),
    [anon_sym_PLUS] = ACTIONS(6460),
    [anon_sym_STAR] = ACTIONS(6460),
    [anon_sym_SLASH] = ACTIONS(6460),
    [anon_sym_PERCENT] = ACTIONS(6460),
    [anon_sym_PIPE_PIPE] = ACTIONS(6462),
    [anon_sym_AMP_AMP] = ACTIONS(6462),
    [anon_sym_PIPE] = ACTIONS(6460),
    [anon_sym_CARET] = ACTIONS(6460),
    [anon_sym_AMP] = ACTIONS(6460),
    [anon_sym_EQ_EQ] = ACTIONS(6462),
    [anon_sym_BANG_EQ] = ACTIONS(6462),
    [anon_sym_GT] = ACTIONS(6460),
    [anon_sym_GT_EQ] = ACTIONS(6462),
    [anon_sym_LT_EQ] = ACTIONS(6460),
    [anon_sym_LT] = ACTIONS(6460),
    [anon_sym_LT_LT] = ACTIONS(6460),
    [anon_sym_GT_GT] = ACTIONS(6460),
    [anon_sym_SEMI] = ACTIONS(6462),
    [anon_sym___attribute__] = ACTIONS(6460),
    [anon_sym_LBRACK] = ACTIONS(6462),
    [anon_sym_EQ] = ACTIONS(6460),
    [anon_sym_QMARK] = ACTIONS(6462),
    [anon_sym_STAR_EQ] = ACTIONS(6462),
    [anon_sym_SLASH_EQ] = ACTIONS(6462),
    [anon_sym_PERCENT_EQ] = ACTIONS(6462),
    [anon_sym_PLUS_EQ] = ACTIONS(6462),
    [anon_sym_DASH_EQ] = ACTIONS(6462),
    [anon_sym_LT_LT_EQ] = ACTIONS(6462),
    [anon_sym_GT_GT_EQ] = ACTIONS(6462),
    [anon_sym_AMP_EQ] = ACTIONS(6462),
    [anon_sym_CARET_EQ] = ACTIONS(6462),
    [anon_sym_PIPE_EQ] = ACTIONS(6462),
    [anon_sym_and_eq] = ACTIONS(6460),
    [anon_sym_or_eq] = ACTIONS(6460),
    [anon_sym_xor_eq] = ACTIONS(6460),
    [anon_sym_LT_EQ_GT] = ACTIONS(6462),
    [anon_sym_or] = ACTIONS(6460),
    [anon_sym_and] = ACTIONS(6460),
    [anon_sym_bitor] = ACTIONS(6460),
    [anon_sym_xor] = ACTIONS(6460),
    [anon_sym_bitand] = ACTIONS(6460),
    [anon_sym_not_eq] = ACTIONS(6460),
    [anon_sym_is] = ACTIONS(6460),
    [anon_sym_as] = ACTIONS(6460),
    [anon_sym_DASH_DASH] = ACTIONS(6462),
    [anon_sym_PLUS_PLUS] = ACTIONS(6462),
    [anon_sym_DOT] = ACTIONS(6460),
    [anon_sym_DOT_STAR] = ACTIONS(6462),
    [anon_sym_DASH_GT] = ACTIONS(6462),
    [anon_sym_L_DQUOTE] = ACTIONS(6462),
    [anon_sym_u_DQUOTE] = ACTIONS(6462),
    [anon_sym_U_DQUOTE] = ACTIONS(6462),
    [anon_sym_u8_DQUOTE] = ACTIONS(6462),
    [anon_sym_DQUOTE] = ACTIONS(6462),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6462),
    [anon_sym_LR_DQUOTE] = ACTIONS(6462),
    [anon_sym_uR_DQUOTE] = ACTIONS(6462),
    [anon_sym_UR_DQUOTE] = ACTIONS(6462),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6462),
    [sym_literal_suffix] = ACTIONS(6460),
  },
  [3159] = {
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2230),
    [anon_sym_COMMA] = ACTIONS(2230),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2228),
    [anon_sym_PLUS] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(2230),
    [anon_sym_SLASH] = ACTIONS(2228),
    [anon_sym_PERCENT] = ACTIONS(2230),
    [anon_sym_PIPE_PIPE] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_PIPE] = ACTIONS(2228),
    [anon_sym_CARET] = ACTIONS(2230),
    [anon_sym_AMP] = ACTIONS(2228),
    [anon_sym_EQ_EQ] = ACTIONS(2230),
    [anon_sym_BANG_EQ] = ACTIONS(2230),
    [anon_sym_GT] = ACTIONS(2228),
    [anon_sym_GT_EQ] = ACTIONS(2228),
    [anon_sym_LT_EQ] = ACTIONS(2228),
    [anon_sym_LT] = ACTIONS(2228),
    [anon_sym_LT_LT] = ACTIONS(2230),
    [anon_sym_GT_GT] = ACTIONS(2228),
    [anon_sym_COLON] = ACTIONS(2228),
    [anon_sym___extension__] = ACTIONS(2228),
    [anon_sym___attribute__] = ACTIONS(2228),
    [anon_sym_COLON_COLON] = ACTIONS(2230),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2230),
    [anon_sym_EQ] = ACTIONS(2228),
    [anon_sym_const] = ACTIONS(2228),
    [anon_sym_constexpr] = ACTIONS(2228),
    [anon_sym_volatile] = ACTIONS(2228),
    [anon_sym_restrict] = ACTIONS(2228),
    [anon_sym___restrict__] = ACTIONS(2228),
    [anon_sym__Atomic] = ACTIONS(2228),
    [anon_sym__Noreturn] = ACTIONS(2228),
    [anon_sym_noreturn] = ACTIONS(2228),
    [anon_sym_mutable] = ACTIONS(2228),
    [anon_sym_constinit] = ACTIONS(2228),
    [anon_sym_consteval] = ACTIONS(2228),
    [anon_sym_alignas] = ACTIONS(2228),
    [anon_sym__Alignas] = ACTIONS(2228),
    [anon_sym_QMARK] = ACTIONS(2230),
    [anon_sym_LT_EQ_GT] = ACTIONS(2230),
    [anon_sym_or] = ACTIONS(2228),
    [anon_sym_and] = ACTIONS(2228),
    [anon_sym_bitor] = ACTIONS(2228),
    [anon_sym_xor] = ACTIONS(2228),
    [anon_sym_bitand] = ACTIONS(2228),
    [anon_sym_not_eq] = ACTIONS(2228),
    [anon_sym_is] = ACTIONS(2228),
    [anon_sym_as] = ACTIONS(2228),
    [anon_sym_DASH_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_PLUS] = ACTIONS(2230),
    [anon_sym_DOT] = ACTIONS(2228),
    [anon_sym_DOT_STAR] = ACTIONS(2230),
    [anon_sym_DASH_GT] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(2228),
    [anon_sym_This] = ACTIONS(2228),
    [anon_sym_final] = ACTIONS(2228),
    [anon_sym_override] = ACTIONS(2228),
    [anon_sym_GT2] = ACTIONS(2230),
    [anon_sym_requires] = ACTIONS(2228),
    [anon_sym_where] = ACTIONS(2228),
  },
  [3160] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3160),
    [sym_identifier] = ACTIONS(2856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2854),
    [anon_sym_COMMA] = ACTIONS(2854),
    [anon_sym_RPAREN] = ACTIONS(2854),
    [anon_sym_LPAREN2] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(2856),
    [anon_sym_PLUS] = ACTIONS(2856),
    [anon_sym_STAR] = ACTIONS(2856),
    [anon_sym_SLASH] = ACTIONS(2856),
    [anon_sym_PERCENT] = ACTIONS(2856),
    [anon_sym_PIPE_PIPE] = ACTIONS(2854),
    [anon_sym_AMP_AMP] = ACTIONS(2854),
    [anon_sym_PIPE] = ACTIONS(2856),
    [anon_sym_CARET] = ACTIONS(2856),
    [anon_sym_AMP] = ACTIONS(2856),
    [anon_sym_EQ_EQ] = ACTIONS(2854),
    [anon_sym_BANG_EQ] = ACTIONS(2854),
    [anon_sym_GT] = ACTIONS(2856),
    [anon_sym_GT_EQ] = ACTIONS(2854),
    [anon_sym_LT_EQ] = ACTIONS(2856),
    [anon_sym_LT] = ACTIONS(2856),
    [anon_sym_LT_LT] = ACTIONS(2856),
    [anon_sym_GT_GT] = ACTIONS(2856),
    [anon_sym___attribute__] = ACTIONS(2856),
    [anon_sym_LBRACE] = ACTIONS(2854),
    [anon_sym_signed] = ACTIONS(6911),
    [anon_sym_unsigned] = ACTIONS(6911),
    [anon_sym_long] = ACTIONS(6911),
    [anon_sym_short] = ACTIONS(6911),
    [anon_sym_LBRACK] = ACTIONS(2854),
    [anon_sym_EQ] = ACTIONS(2856),
    [sym_primitive_type] = ACTIONS(2856),
    [anon_sym_QMARK] = ACTIONS(2854),
    [anon_sym_STAR_EQ] = ACTIONS(2854),
    [anon_sym_SLASH_EQ] = ACTIONS(2854),
    [anon_sym_PERCENT_EQ] = ACTIONS(2854),
    [anon_sym_PLUS_EQ] = ACTIONS(2854),
    [anon_sym_DASH_EQ] = ACTIONS(2854),
    [anon_sym_LT_LT_EQ] = ACTIONS(2854),
    [anon_sym_GT_GT_EQ] = ACTIONS(2854),
    [anon_sym_AMP_EQ] = ACTIONS(2854),
    [anon_sym_CARET_EQ] = ACTIONS(2854),
    [anon_sym_PIPE_EQ] = ACTIONS(2854),
    [anon_sym_and_eq] = ACTIONS(2856),
    [anon_sym_or_eq] = ACTIONS(2856),
    [anon_sym_xor_eq] = ACTIONS(2856),
    [anon_sym_LT_EQ_GT] = ACTIONS(2854),
    [anon_sym_or] = ACTIONS(2856),
    [anon_sym_and] = ACTIONS(2856),
    [anon_sym_bitor] = ACTIONS(2856),
    [anon_sym_xor] = ACTIONS(2856),
    [anon_sym_bitand] = ACTIONS(2856),
    [anon_sym_not_eq] = ACTIONS(2856),
    [anon_sym_is] = ACTIONS(2856),
    [anon_sym_as] = ACTIONS(2856),
    [anon_sym_DASH_DASH] = ACTIONS(2854),
    [anon_sym_PLUS_PLUS] = ACTIONS(2854),
    [anon_sym_DOT] = ACTIONS(2856),
    [anon_sym_DOT_STAR] = ACTIONS(2854),
    [anon_sym_DASH_GT] = ACTIONS(2856),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2856),
    [anon_sym_let] = ACTIONS(2856),
    [anon_sym_This] = ACTIONS(2856),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2854),
  },
  [3161] = {
    [sym_identifier] = ACTIONS(2248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2248),
    [anon_sym_PLUS] = ACTIONS(2248),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_SLASH] = ACTIONS(2248),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2248),
    [anon_sym_EQ_EQ] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_GT] = ACTIONS(2248),
    [anon_sym_GT_EQ] = ACTIONS(2248),
    [anon_sym_LT_EQ] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_LT_LT] = ACTIONS(2250),
    [anon_sym_GT_GT] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2248),
    [anon_sym___extension__] = ACTIONS(2248),
    [anon_sym___attribute__] = ACTIONS(2248),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_const] = ACTIONS(2248),
    [anon_sym_constexpr] = ACTIONS(2248),
    [anon_sym_volatile] = ACTIONS(2248),
    [anon_sym_restrict] = ACTIONS(2248),
    [anon_sym___restrict__] = ACTIONS(2248),
    [anon_sym__Atomic] = ACTIONS(2248),
    [anon_sym__Noreturn] = ACTIONS(2248),
    [anon_sym_noreturn] = ACTIONS(2248),
    [anon_sym_mutable] = ACTIONS(2248),
    [anon_sym_constinit] = ACTIONS(2248),
    [anon_sym_consteval] = ACTIONS(2248),
    [anon_sym_alignas] = ACTIONS(2248),
    [anon_sym__Alignas] = ACTIONS(2248),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_LT_EQ_GT] = ACTIONS(2250),
    [anon_sym_or] = ACTIONS(2248),
    [anon_sym_and] = ACTIONS(2248),
    [anon_sym_bitor] = ACTIONS(2248),
    [anon_sym_xor] = ACTIONS(2248),
    [anon_sym_bitand] = ACTIONS(2248),
    [anon_sym_not_eq] = ACTIONS(2248),
    [anon_sym_is] = ACTIONS(2248),
    [anon_sym_as] = ACTIONS(2248),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2248),
    [anon_sym_DOT_STAR] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2248),
    [anon_sym_let] = ACTIONS(2248),
    [anon_sym_This] = ACTIONS(2248),
    [anon_sym_final] = ACTIONS(2248),
    [anon_sym_override] = ACTIONS(2248),
    [anon_sym_GT2] = ACTIONS(2250),
    [anon_sym_requires] = ACTIONS(2248),
    [anon_sym_where] = ACTIONS(2248),
  },
  [3162] = {
    [sym_identifier] = ACTIONS(2232),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_COMMA] = ACTIONS(2234),
    [anon_sym_LPAREN2] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2232),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2232),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_PIPE_PIPE] = ACTIONS(2234),
    [anon_sym_AMP_AMP] = ACTIONS(2234),
    [anon_sym_PIPE] = ACTIONS(2232),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2232),
    [anon_sym_EQ_EQ] = ACTIONS(2234),
    [anon_sym_BANG_EQ] = ACTIONS(2234),
    [anon_sym_GT] = ACTIONS(2232),
    [anon_sym_GT_EQ] = ACTIONS(2232),
    [anon_sym_LT_EQ] = ACTIONS(2232),
    [anon_sym_LT] = ACTIONS(2232),
    [anon_sym_LT_LT] = ACTIONS(2234),
    [anon_sym_GT_GT] = ACTIONS(2232),
    [anon_sym_COLON] = ACTIONS(2232),
    [anon_sym___extension__] = ACTIONS(2232),
    [anon_sym___attribute__] = ACTIONS(2232),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_EQ] = ACTIONS(2232),
    [anon_sym_const] = ACTIONS(2232),
    [anon_sym_constexpr] = ACTIONS(2232),
    [anon_sym_volatile] = ACTIONS(2232),
    [anon_sym_restrict] = ACTIONS(2232),
    [anon_sym___restrict__] = ACTIONS(2232),
    [anon_sym__Atomic] = ACTIONS(2232),
    [anon_sym__Noreturn] = ACTIONS(2232),
    [anon_sym_noreturn] = ACTIONS(2232),
    [anon_sym_mutable] = ACTIONS(2232),
    [anon_sym_constinit] = ACTIONS(2232),
    [anon_sym_consteval] = ACTIONS(2232),
    [anon_sym_alignas] = ACTIONS(2232),
    [anon_sym__Alignas] = ACTIONS(2232),
    [anon_sym_QMARK] = ACTIONS(2234),
    [anon_sym_LT_EQ_GT] = ACTIONS(2234),
    [anon_sym_or] = ACTIONS(2232),
    [anon_sym_and] = ACTIONS(2232),
    [anon_sym_bitor] = ACTIONS(2232),
    [anon_sym_xor] = ACTIONS(2232),
    [anon_sym_bitand] = ACTIONS(2232),
    [anon_sym_not_eq] = ACTIONS(2232),
    [anon_sym_is] = ACTIONS(2232),
    [anon_sym_as] = ACTIONS(2232),
    [anon_sym_DASH_DASH] = ACTIONS(2234),
    [anon_sym_PLUS_PLUS] = ACTIONS(2234),
    [anon_sym_DOT] = ACTIONS(2232),
    [anon_sym_DOT_STAR] = ACTIONS(2234),
    [anon_sym_DASH_GT] = ACTIONS(2234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2232),
    [anon_sym_let] = ACTIONS(2232),
    [anon_sym_This] = ACTIONS(2232),
    [anon_sym_final] = ACTIONS(2232),
    [anon_sym_override] = ACTIONS(2232),
    [anon_sym_GT2] = ACTIONS(2234),
    [anon_sym_requires] = ACTIONS(2232),
    [anon_sym_where] = ACTIONS(2232),
  },
  [3163] = {
    [sym_ms_based_modifier] = STATE(10435),
    [sym_ms_unaligned_ptr_modifier] = STATE(4963),
    [sym_ms_pointer_modifier] = STATE(3183),
    [sym__declarator] = STATE(7274),
    [sym__abstract_declarator] = STATE(8266),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_abstract_parenthesized_declarator] = STATE(7128),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_abstract_pointer_declarator] = STATE(7128),
    [sym_function_declarator] = STATE(7882),
    [sym_abstract_function_declarator] = STATE(7128),
    [sym_array_declarator] = STATE(7882),
    [sym_abstract_array_declarator] = STATE(7128),
    [sym_type_qualifier] = STATE(3542),
    [sym_alignas_qualifier] = STATE(5665),
    [sym_parameter_list] = STATE(4478),
    [sym_decltype] = STATE(10765),
    [sym_reference_declarator] = STATE(7882),
    [sym_abstract_reference_declarator] = STATE(7128),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym__function_declarator_seq] = STATE(7135),
    [sym_template_type] = STATE(10765),
    [sym_template_function] = STATE(7882),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6926),
    [sym_qualified_identifier] = STATE(7882),
    [sym_operator_name] = STATE(7882),
    [aux_sym__type_definition_type_repeat1] = STATE(3542),
    [aux_sym_pointer_declarator_repeat1] = STATE(3183),
    [sym_identifier] = ACTIONS(6761),
    [anon_sym_COMMA] = ACTIONS(6763),
    [anon_sym_LPAREN2] = ACTIONS(4883),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(6914),
    [anon_sym_AMP_AMP] = ACTIONS(6916),
    [anon_sym_AMP] = ACTIONS(6918),
    [anon_sym_COLON] = ACTIONS(6771),
    [anon_sym___extension__] = ACTIONS(4901),
    [anon_sym_COLON_COLON] = ACTIONS(6773),
    [anon_sym___based] = ACTIONS(49),
    [sym_ms_restrict_modifier] = ACTIONS(4903),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(4903),
    [sym_ms_signed_ptr_modifier] = ACTIONS(4903),
    [anon_sym__unaligned] = ACTIONS(4905),
    [anon_sym___unaligned] = ACTIONS(4905),
    [anon_sym_LBRACK] = ACTIONS(6775),
    [anon_sym_const] = ACTIONS(4901),
    [anon_sym_constexpr] = ACTIONS(4901),
    [anon_sym_volatile] = ACTIONS(4901),
    [anon_sym_restrict] = ACTIONS(4901),
    [anon_sym___restrict__] = ACTIONS(4901),
    [anon_sym__Atomic] = ACTIONS(4901),
    [anon_sym__Noreturn] = ACTIONS(4901),
    [anon_sym_noreturn] = ACTIONS(4901),
    [anon_sym_mutable] = ACTIONS(4901),
    [anon_sym_constinit] = ACTIONS(4901),
    [anon_sym_consteval] = ACTIONS(4901),
    [anon_sym_alignas] = ACTIONS(4907),
    [anon_sym__Alignas] = ACTIONS(4907),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(6763),
    [anon_sym_operator] = ACTIONS(2808),
  },
  [3164] = {
    [sym_identifier] = ACTIONS(6431),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6433),
    [anon_sym_COMMA] = ACTIONS(6433),
    [anon_sym_LPAREN2] = ACTIONS(6433),
    [anon_sym_DASH] = ACTIONS(6431),
    [anon_sym_PLUS] = ACTIONS(6431),
    [anon_sym_STAR] = ACTIONS(6431),
    [anon_sym_SLASH] = ACTIONS(6431),
    [anon_sym_PERCENT] = ACTIONS(6431),
    [anon_sym_PIPE_PIPE] = ACTIONS(6433),
    [anon_sym_AMP_AMP] = ACTIONS(6433),
    [anon_sym_PIPE] = ACTIONS(6431),
    [anon_sym_CARET] = ACTIONS(6431),
    [anon_sym_AMP] = ACTIONS(6431),
    [anon_sym_EQ_EQ] = ACTIONS(6433),
    [anon_sym_BANG_EQ] = ACTIONS(6433),
    [anon_sym_GT] = ACTIONS(6431),
    [anon_sym_GT_EQ] = ACTIONS(6433),
    [anon_sym_LT_EQ] = ACTIONS(6431),
    [anon_sym_LT] = ACTIONS(6431),
    [anon_sym_LT_LT] = ACTIONS(6431),
    [anon_sym_GT_GT] = ACTIONS(6431),
    [anon_sym_SEMI] = ACTIONS(6433),
    [anon_sym___attribute__] = ACTIONS(6431),
    [anon_sym_LBRACK] = ACTIONS(6433),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_QMARK] = ACTIONS(6433),
    [anon_sym_STAR_EQ] = ACTIONS(6433),
    [anon_sym_SLASH_EQ] = ACTIONS(6433),
    [anon_sym_PERCENT_EQ] = ACTIONS(6433),
    [anon_sym_PLUS_EQ] = ACTIONS(6433),
    [anon_sym_DASH_EQ] = ACTIONS(6433),
    [anon_sym_LT_LT_EQ] = ACTIONS(6433),
    [anon_sym_GT_GT_EQ] = ACTIONS(6433),
    [anon_sym_AMP_EQ] = ACTIONS(6433),
    [anon_sym_CARET_EQ] = ACTIONS(6433),
    [anon_sym_PIPE_EQ] = ACTIONS(6433),
    [anon_sym_and_eq] = ACTIONS(6431),
    [anon_sym_or_eq] = ACTIONS(6431),
    [anon_sym_xor_eq] = ACTIONS(6431),
    [anon_sym_LT_EQ_GT] = ACTIONS(6433),
    [anon_sym_or] = ACTIONS(6431),
    [anon_sym_and] = ACTIONS(6431),
    [anon_sym_bitor] = ACTIONS(6431),
    [anon_sym_xor] = ACTIONS(6431),
    [anon_sym_bitand] = ACTIONS(6431),
    [anon_sym_not_eq] = ACTIONS(6431),
    [anon_sym_is] = ACTIONS(6431),
    [anon_sym_as] = ACTIONS(6431),
    [anon_sym_DASH_DASH] = ACTIONS(6433),
    [anon_sym_PLUS_PLUS] = ACTIONS(6433),
    [anon_sym_DOT] = ACTIONS(6431),
    [anon_sym_DOT_STAR] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6433),
    [anon_sym_L_DQUOTE] = ACTIONS(6433),
    [anon_sym_u_DQUOTE] = ACTIONS(6433),
    [anon_sym_U_DQUOTE] = ACTIONS(6433),
    [anon_sym_u8_DQUOTE] = ACTIONS(6433),
    [anon_sym_DQUOTE] = ACTIONS(6433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6433),
    [anon_sym_LR_DQUOTE] = ACTIONS(6433),
    [anon_sym_uR_DQUOTE] = ACTIONS(6433),
    [anon_sym_UR_DQUOTE] = ACTIONS(6433),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6433),
    [sym_literal_suffix] = ACTIONS(6431),
  },
  [3165] = {
    [sym_string_literal] = STATE(3182),
    [sym_raw_string_literal] = STATE(3182),
    [aux_sym_concatenated_string_repeat1] = STATE(3182),
    [sym_identifier] = ACTIONS(6920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6437),
    [anon_sym_COMMA] = ACTIONS(6437),
    [anon_sym_RPAREN] = ACTIONS(6437),
    [anon_sym_LPAREN2] = ACTIONS(6437),
    [anon_sym_DASH] = ACTIONS(6439),
    [anon_sym_PLUS] = ACTIONS(6439),
    [anon_sym_STAR] = ACTIONS(6439),
    [anon_sym_SLASH] = ACTIONS(6439),
    [anon_sym_PERCENT] = ACTIONS(6439),
    [anon_sym_PIPE_PIPE] = ACTIONS(6437),
    [anon_sym_AMP_AMP] = ACTIONS(6437),
    [anon_sym_PIPE] = ACTIONS(6439),
    [anon_sym_CARET] = ACTIONS(6439),
    [anon_sym_AMP] = ACTIONS(6439),
    [anon_sym_EQ_EQ] = ACTIONS(6437),
    [anon_sym_BANG_EQ] = ACTIONS(6437),
    [anon_sym_GT] = ACTIONS(6439),
    [anon_sym_GT_EQ] = ACTIONS(6437),
    [anon_sym_LT_EQ] = ACTIONS(6439),
    [anon_sym_LT] = ACTIONS(6439),
    [anon_sym_LT_LT] = ACTIONS(6439),
    [anon_sym_GT_GT] = ACTIONS(6439),
    [anon_sym_LBRACK] = ACTIONS(6437),
    [anon_sym_EQ] = ACTIONS(6439),
    [anon_sym_QMARK] = ACTIONS(6437),
    [anon_sym_STAR_EQ] = ACTIONS(6437),
    [anon_sym_SLASH_EQ] = ACTIONS(6437),
    [anon_sym_PERCENT_EQ] = ACTIONS(6437),
    [anon_sym_PLUS_EQ] = ACTIONS(6437),
    [anon_sym_DASH_EQ] = ACTIONS(6437),
    [anon_sym_LT_LT_EQ] = ACTIONS(6437),
    [anon_sym_GT_GT_EQ] = ACTIONS(6437),
    [anon_sym_AMP_EQ] = ACTIONS(6437),
    [anon_sym_CARET_EQ] = ACTIONS(6437),
    [anon_sym_PIPE_EQ] = ACTIONS(6437),
    [anon_sym_LT_EQ_GT] = ACTIONS(6437),
    [anon_sym_or] = ACTIONS(6439),
    [anon_sym_and] = ACTIONS(6439),
    [anon_sym_bitor] = ACTIONS(6439),
    [anon_sym_xor] = ACTIONS(6439),
    [anon_sym_bitand] = ACTIONS(6439),
    [anon_sym_not_eq] = ACTIONS(6439),
    [anon_sym_is] = ACTIONS(6439),
    [anon_sym_as] = ACTIONS(6439),
    [anon_sym_DASH_DASH] = ACTIONS(6437),
    [anon_sym_PLUS_PLUS] = ACTIONS(6437),
    [anon_sym_DOT] = ACTIONS(6439),
    [anon_sym_DOT_STAR] = ACTIONS(6437),
    [anon_sym_DASH_GT] = ACTIONS(6439),
    [anon_sym_L_DQUOTE] = ACTIONS(4918),
    [anon_sym_u_DQUOTE] = ACTIONS(4918),
    [anon_sym_U_DQUOTE] = ACTIONS(4918),
    [anon_sym_u8_DQUOTE] = ACTIONS(4918),
    [anon_sym_DQUOTE] = ACTIONS(4918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4920),
    [anon_sym_LR_DQUOTE] = ACTIONS(4920),
    [anon_sym_uR_DQUOTE] = ACTIONS(4920),
    [anon_sym_UR_DQUOTE] = ACTIONS(4920),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4920),
    [anon_sym_DASH_GT_STAR] = ACTIONS(6437),
    [sym_literal_suffix] = ACTIONS(6439),
  },
  [3166] = {
    [sym_string_literal] = STATE(3053),
    [sym_raw_string_literal] = STATE(3053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6596),
    [anon_sym_COMMA] = ACTIONS(6596),
    [anon_sym_LPAREN2] = ACTIONS(6596),
    [anon_sym_DASH] = ACTIONS(6594),
    [anon_sym_PLUS] = ACTIONS(6594),
    [anon_sym_STAR] = ACTIONS(6594),
    [anon_sym_SLASH] = ACTIONS(6594),
    [anon_sym_PERCENT] = ACTIONS(6594),
    [anon_sym_PIPE_PIPE] = ACTIONS(6596),
    [anon_sym_AMP_AMP] = ACTIONS(6596),
    [anon_sym_PIPE] = ACTIONS(6594),
    [anon_sym_CARET] = ACTIONS(6594),
    [anon_sym_AMP] = ACTIONS(6594),
    [anon_sym_EQ_EQ] = ACTIONS(6596),
    [anon_sym_BANG_EQ] = ACTIONS(6596),
    [anon_sym_GT] = ACTIONS(6594),
    [anon_sym_GT_EQ] = ACTIONS(6594),
    [anon_sym_LT_EQ] = ACTIONS(6594),
    [anon_sym_LT] = ACTIONS(6594),
    [anon_sym_LT_LT] = ACTIONS(6594),
    [anon_sym_GT_GT] = ACTIONS(6594),
    [anon_sym_LBRACK] = ACTIONS(6596),
    [anon_sym_EQ] = ACTIONS(6594),
    [anon_sym_QMARK] = ACTIONS(6596),
    [anon_sym_STAR_EQ] = ACTIONS(6596),
    [anon_sym_SLASH_EQ] = ACTIONS(6596),
    [anon_sym_PERCENT_EQ] = ACTIONS(6596),
    [anon_sym_PLUS_EQ] = ACTIONS(6596),
    [anon_sym_DASH_EQ] = ACTIONS(6596),
    [anon_sym_LT_LT_EQ] = ACTIONS(6596),
    [anon_sym_GT_GT_EQ] = ACTIONS(6594),
    [anon_sym_AMP_EQ] = ACTIONS(6596),
    [anon_sym_CARET_EQ] = ACTIONS(6596),
    [anon_sym_PIPE_EQ] = ACTIONS(6596),
    [anon_sym_and_eq] = ACTIONS(6594),
    [anon_sym_or_eq] = ACTIONS(6594),
    [anon_sym_xor_eq] = ACTIONS(6594),
    [anon_sym_LT_EQ_GT] = ACTIONS(6596),
    [anon_sym_or] = ACTIONS(6594),
    [anon_sym_and] = ACTIONS(6594),
    [anon_sym_bitor] = ACTIONS(6594),
    [anon_sym_xor] = ACTIONS(6594),
    [anon_sym_bitand] = ACTIONS(6594),
    [anon_sym_not_eq] = ACTIONS(6594),
    [anon_sym_is] = ACTIONS(6594),
    [anon_sym_as] = ACTIONS(6594),
    [anon_sym_DASH_DASH] = ACTIONS(6596),
    [anon_sym_PLUS_PLUS] = ACTIONS(6596),
    [anon_sym_DOT] = ACTIONS(6594),
    [anon_sym_DOT_STAR] = ACTIONS(6596),
    [anon_sym_DASH_GT] = ACTIONS(6596),
    [anon_sym_L_DQUOTE] = ACTIONS(6742),
    [anon_sym_u_DQUOTE] = ACTIONS(6742),
    [anon_sym_U_DQUOTE] = ACTIONS(6742),
    [anon_sym_u8_DQUOTE] = ACTIONS(6742),
    [anon_sym_DQUOTE] = ACTIONS(6742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(6596),
    [anon_sym_R_DQUOTE] = ACTIONS(6744),
    [anon_sym_LR_DQUOTE] = ACTIONS(6744),
    [anon_sym_uR_DQUOTE] = ACTIONS(6744),
    [anon_sym_UR_DQUOTE] = ACTIONS(6744),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6744),
    [sym_literal_suffix] = ACTIONS(6922),
  },
  [3167] = {
    [sym_identifier] = ACTIONS(2222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2212),
    [anon_sym_COMMA] = ACTIONS(2212),
    [anon_sym_RPAREN] = ACTIONS(2212),
    [aux_sym_preproc_if_token2] = ACTIONS(2212),
    [aux_sym_preproc_else_token1] = ACTIONS(2212),
    [aux_sym_preproc_elif_token1] = ACTIONS(2222),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2212),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2212),
    [anon_sym_LPAREN2] = ACTIONS(2212),
    [anon_sym_DASH] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(2222),
    [anon_sym_STAR] = ACTIONS(2222),
    [anon_sym_SLASH] = ACTIONS(2222),
    [anon_sym_PERCENT] = ACTIONS(2222),
    [anon_sym_PIPE_PIPE] = ACTIONS(2212),
    [anon_sym_AMP_AMP] = ACTIONS(2212),
    [anon_sym_PIPE] = ACTIONS(2222),
    [anon_sym_CARET] = ACTIONS(2222),
    [anon_sym_AMP] = ACTIONS(2222),
    [anon_sym_EQ_EQ] = ACTIONS(2212),
    [anon_sym_BANG_EQ] = ACTIONS(2212),
    [anon_sym_GT] = ACTIONS(2222),
    [anon_sym_GT_EQ] = ACTIONS(2212),
    [anon_sym_LT_EQ] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(2222),
    [anon_sym_LT_LT] = ACTIONS(2222),
    [anon_sym_GT_GT] = ACTIONS(2222),
    [anon_sym_COLON] = ACTIONS(2222),
    [anon_sym_SEMI] = ACTIONS(2212),
    [anon_sym___attribute__] = ACTIONS(2222),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2217),
    [anon_sym_RBRACE] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2212),
    [anon_sym_RBRACK] = ACTIONS(2212),
    [anon_sym_EQ] = ACTIONS(2222),
    [anon_sym_QMARK] = ACTIONS(2212),
    [anon_sym_STAR_EQ] = ACTIONS(2212),
    [anon_sym_SLASH_EQ] = ACTIONS(2212),
    [anon_sym_PERCENT_EQ] = ACTIONS(2212),
    [anon_sym_PLUS_EQ] = ACTIONS(2212),
    [anon_sym_DASH_EQ] = ACTIONS(2212),
    [anon_sym_LT_LT_EQ] = ACTIONS(2212),
    [anon_sym_GT_GT_EQ] = ACTIONS(2212),
    [anon_sym_AMP_EQ] = ACTIONS(2212),
    [anon_sym_CARET_EQ] = ACTIONS(2212),
    [anon_sym_PIPE_EQ] = ACTIONS(2212),
    [anon_sym_and_eq] = ACTIONS(2222),
    [anon_sym_or_eq] = ACTIONS(2222),
    [anon_sym_xor_eq] = ACTIONS(2222),
    [anon_sym_LT_EQ_GT] = ACTIONS(2212),
    [anon_sym_or] = ACTIONS(2222),
    [anon_sym_and] = ACTIONS(2222),
    [anon_sym_bitor] = ACTIONS(2222),
    [anon_sym_xor] = ACTIONS(2222),
    [anon_sym_bitand] = ACTIONS(2222),
    [anon_sym_not_eq] = ACTIONS(2222),
    [anon_sym_is] = ACTIONS(2222),
    [anon_sym_as] = ACTIONS(2222),
    [anon_sym_DASH_DASH] = ACTIONS(2212),
    [anon_sym_PLUS_PLUS] = ACTIONS(2212),
    [anon_sym_DOT] = ACTIONS(2222),
    [anon_sym_DOT_STAR] = ACTIONS(2212),
    [anon_sym_DASH_GT] = ACTIONS(2212),
    [sym_comment] = ACTIONS(3),
  },
  [3168] = {
    [sym_identifier] = ACTIONS(6460),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6462),
    [anon_sym_COMMA] = ACTIONS(6462),
    [anon_sym_RPAREN] = ACTIONS(6462),
    [anon_sym_LPAREN2] = ACTIONS(6462),
    [anon_sym_DASH] = ACTIONS(6460),
    [anon_sym_PLUS] = ACTIONS(6460),
    [anon_sym_STAR] = ACTIONS(6460),
    [anon_sym_SLASH] = ACTIONS(6460),
    [anon_sym_PERCENT] = ACTIONS(6460),
    [anon_sym_PIPE_PIPE] = ACTIONS(6462),
    [anon_sym_AMP_AMP] = ACTIONS(6462),
    [anon_sym_PIPE] = ACTIONS(6460),
    [anon_sym_CARET] = ACTIONS(6460),
    [anon_sym_AMP] = ACTIONS(6460),
    [anon_sym_EQ_EQ] = ACTIONS(6462),
    [anon_sym_BANG_EQ] = ACTIONS(6462),
    [anon_sym_GT] = ACTIONS(6460),
    [anon_sym_GT_EQ] = ACTIONS(6462),
    [anon_sym_LT_EQ] = ACTIONS(6460),
    [anon_sym_LT] = ACTIONS(6460),
    [anon_sym_LT_LT] = ACTIONS(6460),
    [anon_sym_GT_GT] = ACTIONS(6460),
    [anon_sym_LBRACK] = ACTIONS(6462),
    [anon_sym_EQ] = ACTIONS(6460),
    [anon_sym_QMARK] = ACTIONS(6462),
    [anon_sym_STAR_EQ] = ACTIONS(6462),
    [anon_sym_SLASH_EQ] = ACTIONS(6462),
    [anon_sym_PERCENT_EQ] = ACTIONS(6462),
    [anon_sym_PLUS_EQ] = ACTIONS(6462),
    [anon_sym_DASH_EQ] = ACTIONS(6462),
    [anon_sym_LT_LT_EQ] = ACTIONS(6462),
    [anon_sym_GT_GT_EQ] = ACTIONS(6462),
    [anon_sym_AMP_EQ] = ACTIONS(6462),
    [anon_sym_CARET_EQ] = ACTIONS(6462),
    [anon_sym_PIPE_EQ] = ACTIONS(6462),
    [anon_sym_and_eq] = ACTIONS(6460),
    [anon_sym_or_eq] = ACTIONS(6460),
    [anon_sym_xor_eq] = ACTIONS(6460),
    [anon_sym_LT_EQ_GT] = ACTIONS(6462),
    [anon_sym_or] = ACTIONS(6460),
    [anon_sym_and] = ACTIONS(6460),
    [anon_sym_bitor] = ACTIONS(6460),
    [anon_sym_xor] = ACTIONS(6460),
    [anon_sym_bitand] = ACTIONS(6460),
    [anon_sym_not_eq] = ACTIONS(6460),
    [anon_sym_is] = ACTIONS(6460),
    [anon_sym_as] = ACTIONS(6460),
    [anon_sym_DASH_DASH] = ACTIONS(6462),
    [anon_sym_PLUS_PLUS] = ACTIONS(6462),
    [anon_sym_DOT] = ACTIONS(6460),
    [anon_sym_DOT_STAR] = ACTIONS(6462),
    [anon_sym_DASH_GT] = ACTIONS(6460),
    [anon_sym_L_DQUOTE] = ACTIONS(6462),
    [anon_sym_u_DQUOTE] = ACTIONS(6462),
    [anon_sym_U_DQUOTE] = ACTIONS(6462),
    [anon_sym_u8_DQUOTE] = ACTIONS(6462),
    [anon_sym_DQUOTE] = ACTIONS(6462),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6462),
    [anon_sym_LR_DQUOTE] = ACTIONS(6462),
    [anon_sym_uR_DQUOTE] = ACTIONS(6462),
    [anon_sym_UR_DQUOTE] = ACTIONS(6462),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6462),
    [anon_sym_DASH_GT_STAR] = ACTIONS(6462),
    [sym_literal_suffix] = ACTIONS(6460),
  },
  [3169] = {
    [sym_string_literal] = STATE(3053),
    [sym_raw_string_literal] = STATE(3053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_LPAREN2] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_PERCENT] = ACTIONS(2128),
    [anon_sym_PIPE_PIPE] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_CARET] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_EQ_EQ] = ACTIONS(2117),
    [anon_sym_BANG_EQ] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2128),
    [anon_sym_GT_EQ] = ACTIONS(2128),
    [anon_sym_LT_EQ] = ACTIONS(2128),
    [anon_sym_LT] = ACTIONS(2128),
    [anon_sym_LT_LT] = ACTIONS(2128),
    [anon_sym_GT_GT] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2117),
    [anon_sym_EQ] = ACTIONS(2128),
    [anon_sym_QMARK] = ACTIONS(2117),
    [anon_sym_STAR_EQ] = ACTIONS(2117),
    [anon_sym_SLASH_EQ] = ACTIONS(2117),
    [anon_sym_PERCENT_EQ] = ACTIONS(2117),
    [anon_sym_PLUS_EQ] = ACTIONS(2117),
    [anon_sym_DASH_EQ] = ACTIONS(2117),
    [anon_sym_LT_LT_EQ] = ACTIONS(2117),
    [anon_sym_GT_GT_EQ] = ACTIONS(2128),
    [anon_sym_AMP_EQ] = ACTIONS(2117),
    [anon_sym_CARET_EQ] = ACTIONS(2117),
    [anon_sym_PIPE_EQ] = ACTIONS(2117),
    [anon_sym_and_eq] = ACTIONS(2128),
    [anon_sym_or_eq] = ACTIONS(2128),
    [anon_sym_xor_eq] = ACTIONS(2128),
    [anon_sym_LT_EQ_GT] = ACTIONS(2117),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_bitor] = ACTIONS(2128),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_bitand] = ACTIONS(2128),
    [anon_sym_not_eq] = ACTIONS(2128),
    [anon_sym_is] = ACTIONS(2128),
    [anon_sym_as] = ACTIONS(2128),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DOT] = ACTIONS(2128),
    [anon_sym_DOT_STAR] = ACTIONS(2117),
    [anon_sym_DASH_GT] = ACTIONS(2117),
    [anon_sym_L_DQUOTE] = ACTIONS(6742),
    [anon_sym_u_DQUOTE] = ACTIONS(6742),
    [anon_sym_U_DQUOTE] = ACTIONS(6742),
    [anon_sym_u8_DQUOTE] = ACTIONS(6742),
    [anon_sym_DQUOTE] = ACTIONS(6742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(2117),
    [anon_sym_R_DQUOTE] = ACTIONS(6744),
    [anon_sym_LR_DQUOTE] = ACTIONS(6744),
    [anon_sym_uR_DQUOTE] = ACTIONS(6744),
    [anon_sym_UR_DQUOTE] = ACTIONS(6744),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6744),
    [sym_literal_suffix] = ACTIONS(6922),
  },
  [3170] = {
    [sym_identifier] = ACTIONS(2244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2244),
    [anon_sym_PLUS] = ACTIONS(2244),
    [anon_sym_STAR] = ACTIONS(2246),
    [anon_sym_SLASH] = ACTIONS(2244),
    [anon_sym_PERCENT] = ACTIONS(2246),
    [anon_sym_PIPE_PIPE] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2244),
    [anon_sym_CARET] = ACTIONS(2246),
    [anon_sym_AMP] = ACTIONS(2244),
    [anon_sym_EQ_EQ] = ACTIONS(2246),
    [anon_sym_BANG_EQ] = ACTIONS(2246),
    [anon_sym_GT] = ACTIONS(2244),
    [anon_sym_GT_EQ] = ACTIONS(2244),
    [anon_sym_LT_EQ] = ACTIONS(2244),
    [anon_sym_LT] = ACTIONS(2244),
    [anon_sym_LT_LT] = ACTIONS(2246),
    [anon_sym_GT_GT] = ACTIONS(2244),
    [anon_sym_COLON] = ACTIONS(2244),
    [anon_sym___extension__] = ACTIONS(2244),
    [anon_sym___attribute__] = ACTIONS(2244),
    [anon_sym_COLON_COLON] = ACTIONS(2246),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_EQ] = ACTIONS(2244),
    [anon_sym_const] = ACTIONS(2244),
    [anon_sym_constexpr] = ACTIONS(2244),
    [anon_sym_volatile] = ACTIONS(2244),
    [anon_sym_restrict] = ACTIONS(2244),
    [anon_sym___restrict__] = ACTIONS(2244),
    [anon_sym__Atomic] = ACTIONS(2244),
    [anon_sym__Noreturn] = ACTIONS(2244),
    [anon_sym_noreturn] = ACTIONS(2244),
    [anon_sym_mutable] = ACTIONS(2244),
    [anon_sym_constinit] = ACTIONS(2244),
    [anon_sym_consteval] = ACTIONS(2244),
    [anon_sym_alignas] = ACTIONS(2244),
    [anon_sym__Alignas] = ACTIONS(2244),
    [anon_sym_QMARK] = ACTIONS(2246),
    [anon_sym_LT_EQ_GT] = ACTIONS(2246),
    [anon_sym_or] = ACTIONS(2244),
    [anon_sym_and] = ACTIONS(2244),
    [anon_sym_bitor] = ACTIONS(2244),
    [anon_sym_xor] = ACTIONS(2244),
    [anon_sym_bitand] = ACTIONS(2244),
    [anon_sym_not_eq] = ACTIONS(2244),
    [anon_sym_is] = ACTIONS(2244),
    [anon_sym_as] = ACTIONS(2244),
    [anon_sym_DASH_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_PLUS] = ACTIONS(2246),
    [anon_sym_DOT] = ACTIONS(2244),
    [anon_sym_DOT_STAR] = ACTIONS(2246),
    [anon_sym_DASH_GT] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2244),
    [anon_sym_let] = ACTIONS(2244),
    [anon_sym_This] = ACTIONS(2244),
    [anon_sym_final] = ACTIONS(2244),
    [anon_sym_override] = ACTIONS(2244),
    [anon_sym_GT2] = ACTIONS(2246),
    [anon_sym_requires] = ACTIONS(2244),
    [anon_sym_where] = ACTIONS(2244),
  },
  [3171] = {
    [sym_identifier] = ACTIONS(2742),
    [anon_sym_LPAREN2] = ACTIONS(2740),
    [anon_sym_TILDE] = ACTIONS(2740),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym___extension__] = ACTIONS(2742),
    [anon_sym_in] = ACTIONS(2742),
    [anon_sym_out] = ACTIONS(2742),
    [anon_sym_inout] = ACTIONS(2742),
    [anon_sym_extern] = ACTIONS(2742),
    [anon_sym___attribute__] = ACTIONS(2742),
    [anon_sym_COLON_COLON] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2740),
    [anon_sym___declspec] = ACTIONS(2742),
    [anon_sym___based] = ACTIONS(2742),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2742),
    [anon_sym_register] = ACTIONS(2742),
    [anon_sym_inline] = ACTIONS(2742),
    [anon_sym___inline] = ACTIONS(2742),
    [anon_sym___inline__] = ACTIONS(2742),
    [anon_sym___forceinline] = ACTIONS(2742),
    [anon_sym_thread_local] = ACTIONS(2742),
    [anon_sym___thread] = ACTIONS(2742),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_constexpr] = ACTIONS(2742),
    [anon_sym_volatile] = ACTIONS(2742),
    [anon_sym_restrict] = ACTIONS(2742),
    [anon_sym___restrict__] = ACTIONS(2742),
    [anon_sym__Atomic] = ACTIONS(2742),
    [anon_sym__Noreturn] = ACTIONS(2742),
    [anon_sym_noreturn] = ACTIONS(2742),
    [anon_sym_mutable] = ACTIONS(2742),
    [anon_sym_constinit] = ACTIONS(2742),
    [anon_sym_consteval] = ACTIONS(2742),
    [anon_sym_alignas] = ACTIONS(2742),
    [anon_sym__Alignas] = ACTIONS(2742),
    [anon_sym_DOT] = ACTIONS(2740),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_This] = ACTIONS(2742),
    [anon_sym_decltype] = ACTIONS(2742),
    [sym_virtual] = ACTIONS(2742),
    [anon_sym_template] = ACTIONS(2742),
    [anon_sym_operator] = ACTIONS(2742),
    [anon_sym_precise] = ACTIONS(2742),
    [anon_sym_shared] = ACTIONS(2742),
    [anon_sym_groupshared] = ACTIONS(2742),
    [anon_sym_uniform] = ACTIONS(2742),
    [anon_sym_row_major] = ACTIONS(2742),
    [anon_sym_column_major] = ACTIONS(2742),
    [anon_sym_globallycoherent] = ACTIONS(2742),
    [anon_sym_centroid] = ACTIONS(2742),
    [anon_sym_noperspective] = ACTIONS(2742),
    [anon_sym_nointerpolation] = ACTIONS(2742),
    [anon_sym_sample] = ACTIONS(2742),
    [anon_sym_linear] = ACTIONS(2742),
    [anon_sym_snorm] = ACTIONS(2742),
    [anon_sym_unorm] = ACTIONS(2742),
    [anon_sym_point] = ACTIONS(2742),
    [anon_sym_line] = ACTIONS(2742),
    [anon_sym_triangleadj] = ACTIONS(2742),
    [anon_sym_lineadj] = ACTIONS(2742),
    [anon_sym_triangle] = ACTIONS(2742),
  },
  [3172] = {
    [sym_identifier] = ACTIONS(6431),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6433),
    [anon_sym_COMMA] = ACTIONS(6433),
    [anon_sym_RPAREN] = ACTIONS(6433),
    [anon_sym_LPAREN2] = ACTIONS(6433),
    [anon_sym_DASH] = ACTIONS(6431),
    [anon_sym_PLUS] = ACTIONS(6431),
    [anon_sym_STAR] = ACTIONS(6431),
    [anon_sym_SLASH] = ACTIONS(6431),
    [anon_sym_PERCENT] = ACTIONS(6431),
    [anon_sym_PIPE_PIPE] = ACTIONS(6433),
    [anon_sym_AMP_AMP] = ACTIONS(6433),
    [anon_sym_PIPE] = ACTIONS(6431),
    [anon_sym_CARET] = ACTIONS(6431),
    [anon_sym_AMP] = ACTIONS(6431),
    [anon_sym_EQ_EQ] = ACTIONS(6433),
    [anon_sym_BANG_EQ] = ACTIONS(6433),
    [anon_sym_GT] = ACTIONS(6431),
    [anon_sym_GT_EQ] = ACTIONS(6433),
    [anon_sym_LT_EQ] = ACTIONS(6431),
    [anon_sym_LT] = ACTIONS(6431),
    [anon_sym_LT_LT] = ACTIONS(6431),
    [anon_sym_GT_GT] = ACTIONS(6431),
    [anon_sym_LBRACK] = ACTIONS(6433),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_QMARK] = ACTIONS(6433),
    [anon_sym_STAR_EQ] = ACTIONS(6433),
    [anon_sym_SLASH_EQ] = ACTIONS(6433),
    [anon_sym_PERCENT_EQ] = ACTIONS(6433),
    [anon_sym_PLUS_EQ] = ACTIONS(6433),
    [anon_sym_DASH_EQ] = ACTIONS(6433),
    [anon_sym_LT_LT_EQ] = ACTIONS(6433),
    [anon_sym_GT_GT_EQ] = ACTIONS(6433),
    [anon_sym_AMP_EQ] = ACTIONS(6433),
    [anon_sym_CARET_EQ] = ACTIONS(6433),
    [anon_sym_PIPE_EQ] = ACTIONS(6433),
    [anon_sym_and_eq] = ACTIONS(6431),
    [anon_sym_or_eq] = ACTIONS(6431),
    [anon_sym_xor_eq] = ACTIONS(6431),
    [anon_sym_LT_EQ_GT] = ACTIONS(6433),
    [anon_sym_or] = ACTIONS(6431),
    [anon_sym_and] = ACTIONS(6431),
    [anon_sym_bitor] = ACTIONS(6431),
    [anon_sym_xor] = ACTIONS(6431),
    [anon_sym_bitand] = ACTIONS(6431),
    [anon_sym_not_eq] = ACTIONS(6431),
    [anon_sym_is] = ACTIONS(6431),
    [anon_sym_as] = ACTIONS(6431),
    [anon_sym_DASH_DASH] = ACTIONS(6433),
    [anon_sym_PLUS_PLUS] = ACTIONS(6433),
    [anon_sym_DOT] = ACTIONS(6431),
    [anon_sym_DOT_STAR] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6431),
    [anon_sym_L_DQUOTE] = ACTIONS(6433),
    [anon_sym_u_DQUOTE] = ACTIONS(6433),
    [anon_sym_U_DQUOTE] = ACTIONS(6433),
    [anon_sym_u8_DQUOTE] = ACTIONS(6433),
    [anon_sym_DQUOTE] = ACTIONS(6433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6433),
    [anon_sym_LR_DQUOTE] = ACTIONS(6433),
    [anon_sym_uR_DQUOTE] = ACTIONS(6433),
    [anon_sym_UR_DQUOTE] = ACTIONS(6433),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6433),
    [anon_sym_DASH_GT_STAR] = ACTIONS(6433),
    [sym_literal_suffix] = ACTIONS(6431),
  },
  [3173] = {
    [sym_new_declarator] = STATE(3200),
    [sym_identifier] = ACTIONS(6924),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6926),
    [anon_sym_COMMA] = ACTIONS(6926),
    [anon_sym_RPAREN] = ACTIONS(6926),
    [aux_sym_preproc_if_token2] = ACTIONS(6926),
    [aux_sym_preproc_else_token1] = ACTIONS(6926),
    [aux_sym_preproc_elif_token1] = ACTIONS(6924),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6926),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6926),
    [anon_sym_LPAREN2] = ACTIONS(6926),
    [anon_sym_DASH] = ACTIONS(6924),
    [anon_sym_PLUS] = ACTIONS(6924),
    [anon_sym_STAR] = ACTIONS(6924),
    [anon_sym_SLASH] = ACTIONS(6924),
    [anon_sym_PERCENT] = ACTIONS(6924),
    [anon_sym_PIPE_PIPE] = ACTIONS(6926),
    [anon_sym_AMP_AMP] = ACTIONS(6926),
    [anon_sym_PIPE] = ACTIONS(6924),
    [anon_sym_CARET] = ACTIONS(6924),
    [anon_sym_AMP] = ACTIONS(6924),
    [anon_sym_EQ_EQ] = ACTIONS(6926),
    [anon_sym_BANG_EQ] = ACTIONS(6926),
    [anon_sym_GT] = ACTIONS(6924),
    [anon_sym_GT_EQ] = ACTIONS(6926),
    [anon_sym_LT_EQ] = ACTIONS(6924),
    [anon_sym_LT] = ACTIONS(6924),
    [anon_sym_LT_LT] = ACTIONS(6924),
    [anon_sym_GT_GT] = ACTIONS(6924),
    [anon_sym_COLON] = ACTIONS(6926),
    [anon_sym_SEMI] = ACTIONS(6926),
    [anon_sym___attribute__] = ACTIONS(6924),
    [anon_sym_LBRACE] = ACTIONS(6926),
    [anon_sym_RBRACE] = ACTIONS(6926),
    [anon_sym_LBRACK] = ACTIONS(6570),
    [anon_sym_RBRACK] = ACTIONS(6926),
    [anon_sym_EQ] = ACTIONS(6924),
    [anon_sym_QMARK] = ACTIONS(6926),
    [anon_sym_STAR_EQ] = ACTIONS(6926),
    [anon_sym_SLASH_EQ] = ACTIONS(6926),
    [anon_sym_PERCENT_EQ] = ACTIONS(6926),
    [anon_sym_PLUS_EQ] = ACTIONS(6926),
    [anon_sym_DASH_EQ] = ACTIONS(6926),
    [anon_sym_LT_LT_EQ] = ACTIONS(6926),
    [anon_sym_GT_GT_EQ] = ACTIONS(6926),
    [anon_sym_AMP_EQ] = ACTIONS(6926),
    [anon_sym_CARET_EQ] = ACTIONS(6926),
    [anon_sym_PIPE_EQ] = ACTIONS(6926),
    [anon_sym_and_eq] = ACTIONS(6924),
    [anon_sym_or_eq] = ACTIONS(6924),
    [anon_sym_xor_eq] = ACTIONS(6924),
    [anon_sym_LT_EQ_GT] = ACTIONS(6926),
    [anon_sym_or] = ACTIONS(6924),
    [anon_sym_and] = ACTIONS(6924),
    [anon_sym_bitor] = ACTIONS(6924),
    [anon_sym_xor] = ACTIONS(6924),
    [anon_sym_bitand] = ACTIONS(6924),
    [anon_sym_not_eq] = ACTIONS(6924),
    [anon_sym_is] = ACTIONS(6924),
    [anon_sym_as] = ACTIONS(6924),
    [anon_sym_DASH_DASH] = ACTIONS(6926),
    [anon_sym_PLUS_PLUS] = ACTIONS(6926),
    [anon_sym_DOT] = ACTIONS(6924),
    [anon_sym_DOT_STAR] = ACTIONS(6926),
    [anon_sym_DASH_GT] = ACTIONS(6926),
    [sym_comment] = ACTIONS(3),
  },
  [3174] = {
    [sym_identifier] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_LPAREN2] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2186),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_STAR] = ACTIONS(2188),
    [anon_sym_SLASH] = ACTIONS(2186),
    [anon_sym_PERCENT] = ACTIONS(2188),
    [anon_sym_PIPE_PIPE] = ACTIONS(2188),
    [anon_sym_AMP_AMP] = ACTIONS(2188),
    [anon_sym_PIPE] = ACTIONS(2186),
    [anon_sym_CARET] = ACTIONS(2188),
    [anon_sym_AMP] = ACTIONS(2186),
    [anon_sym_EQ_EQ] = ACTIONS(2188),
    [anon_sym_BANG_EQ] = ACTIONS(2188),
    [anon_sym_GT] = ACTIONS(2186),
    [anon_sym_GT_EQ] = ACTIONS(2186),
    [anon_sym_LT_EQ] = ACTIONS(2186),
    [anon_sym_LT] = ACTIONS(2186),
    [anon_sym_LT_LT] = ACTIONS(2188),
    [anon_sym_GT_GT] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym___extension__] = ACTIONS(2186),
    [anon_sym___attribute__] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_LBRACK] = ACTIONS(2188),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_constexpr] = ACTIONS(2186),
    [anon_sym_volatile] = ACTIONS(2186),
    [anon_sym_restrict] = ACTIONS(2186),
    [anon_sym___restrict__] = ACTIONS(2186),
    [anon_sym__Atomic] = ACTIONS(2186),
    [anon_sym__Noreturn] = ACTIONS(2186),
    [anon_sym_noreturn] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_constinit] = ACTIONS(2186),
    [anon_sym_consteval] = ACTIONS(2186),
    [anon_sym_alignas] = ACTIONS(2186),
    [anon_sym__Alignas] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_LT_EQ_GT] = ACTIONS(2188),
    [anon_sym_or] = ACTIONS(2186),
    [anon_sym_and] = ACTIONS(2186),
    [anon_sym_bitor] = ACTIONS(2186),
    [anon_sym_xor] = ACTIONS(2186),
    [anon_sym_bitand] = ACTIONS(2186),
    [anon_sym_not_eq] = ACTIONS(2186),
    [anon_sym_is] = ACTIONS(2186),
    [anon_sym_as] = ACTIONS(2186),
    [anon_sym_DASH_DASH] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2188),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOT_STAR] = ACTIONS(2188),
    [anon_sym_DASH_GT] = ACTIONS(2188),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_This] = ACTIONS(2186),
    [anon_sym_final] = ACTIONS(2186),
    [anon_sym_override] = ACTIONS(2186),
    [anon_sym_GT2] = ACTIONS(2188),
    [anon_sym_requires] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
  },
  [3175] = {
    [sym_identifier] = ACTIONS(6524),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6526),
    [anon_sym_COMMA] = ACTIONS(6526),
    [anon_sym_RPAREN] = ACTIONS(6526),
    [anon_sym_LPAREN2] = ACTIONS(6526),
    [anon_sym_DASH] = ACTIONS(6524),
    [anon_sym_PLUS] = ACTIONS(6524),
    [anon_sym_STAR] = ACTIONS(6524),
    [anon_sym_SLASH] = ACTIONS(6524),
    [anon_sym_PERCENT] = ACTIONS(6524),
    [anon_sym_PIPE_PIPE] = ACTIONS(6526),
    [anon_sym_AMP_AMP] = ACTIONS(6526),
    [anon_sym_PIPE] = ACTIONS(6524),
    [anon_sym_CARET] = ACTIONS(6524),
    [anon_sym_AMP] = ACTIONS(6524),
    [anon_sym_EQ_EQ] = ACTIONS(6526),
    [anon_sym_BANG_EQ] = ACTIONS(6526),
    [anon_sym_GT] = ACTIONS(6524),
    [anon_sym_GT_EQ] = ACTIONS(6526),
    [anon_sym_LT_EQ] = ACTIONS(6524),
    [anon_sym_LT] = ACTIONS(6524),
    [anon_sym_LT_LT] = ACTIONS(6524),
    [anon_sym_GT_GT] = ACTIONS(6524),
    [anon_sym_LBRACK] = ACTIONS(6526),
    [anon_sym_EQ] = ACTIONS(6524),
    [anon_sym_QMARK] = ACTIONS(6526),
    [anon_sym_STAR_EQ] = ACTIONS(6526),
    [anon_sym_SLASH_EQ] = ACTIONS(6526),
    [anon_sym_PERCENT_EQ] = ACTIONS(6526),
    [anon_sym_PLUS_EQ] = ACTIONS(6526),
    [anon_sym_DASH_EQ] = ACTIONS(6526),
    [anon_sym_LT_LT_EQ] = ACTIONS(6526),
    [anon_sym_GT_GT_EQ] = ACTIONS(6526),
    [anon_sym_AMP_EQ] = ACTIONS(6526),
    [anon_sym_CARET_EQ] = ACTIONS(6526),
    [anon_sym_PIPE_EQ] = ACTIONS(6526),
    [anon_sym_and_eq] = ACTIONS(6524),
    [anon_sym_or_eq] = ACTIONS(6524),
    [anon_sym_xor_eq] = ACTIONS(6524),
    [anon_sym_LT_EQ_GT] = ACTIONS(6526),
    [anon_sym_or] = ACTIONS(6524),
    [anon_sym_and] = ACTIONS(6524),
    [anon_sym_bitor] = ACTIONS(6524),
    [anon_sym_xor] = ACTIONS(6524),
    [anon_sym_bitand] = ACTIONS(6524),
    [anon_sym_not_eq] = ACTIONS(6524),
    [anon_sym_is] = ACTIONS(6524),
    [anon_sym_as] = ACTIONS(6524),
    [anon_sym_DASH_DASH] = ACTIONS(6526),
    [anon_sym_PLUS_PLUS] = ACTIONS(6526),
    [anon_sym_DOT] = ACTIONS(6524),
    [anon_sym_DOT_STAR] = ACTIONS(6526),
    [anon_sym_DASH_GT] = ACTIONS(6524),
    [anon_sym_L_DQUOTE] = ACTIONS(6526),
    [anon_sym_u_DQUOTE] = ACTIONS(6526),
    [anon_sym_U_DQUOTE] = ACTIONS(6526),
    [anon_sym_u8_DQUOTE] = ACTIONS(6526),
    [anon_sym_DQUOTE] = ACTIONS(6526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6526),
    [anon_sym_LR_DQUOTE] = ACTIONS(6526),
    [anon_sym_uR_DQUOTE] = ACTIONS(6526),
    [anon_sym_UR_DQUOTE] = ACTIONS(6526),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6526),
    [anon_sym_DASH_GT_STAR] = ACTIONS(6526),
    [sym_literal_suffix] = ACTIONS(6524),
  },
  [3176] = {
    [sym_identifier] = ACTIONS(2198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_COMMA] = ACTIONS(2200),
    [anon_sym_LPAREN2] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(2200),
    [anon_sym_SLASH] = ACTIONS(2198),
    [anon_sym_PERCENT] = ACTIONS(2200),
    [anon_sym_PIPE_PIPE] = ACTIONS(2200),
    [anon_sym_AMP_AMP] = ACTIONS(2200),
    [anon_sym_PIPE] = ACTIONS(2198),
    [anon_sym_CARET] = ACTIONS(2200),
    [anon_sym_AMP] = ACTIONS(2198),
    [anon_sym_EQ_EQ] = ACTIONS(2200),
    [anon_sym_BANG_EQ] = ACTIONS(2200),
    [anon_sym_GT] = ACTIONS(2198),
    [anon_sym_GT_EQ] = ACTIONS(2198),
    [anon_sym_LT_EQ] = ACTIONS(2198),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_LT_LT] = ACTIONS(2200),
    [anon_sym_GT_GT] = ACTIONS(2198),
    [anon_sym_COLON] = ACTIONS(2198),
    [anon_sym___extension__] = ACTIONS(2198),
    [anon_sym___attribute__] = ACTIONS(2198),
    [anon_sym_COLON_COLON] = ACTIONS(2200),
    [anon_sym_LBRACE] = ACTIONS(2200),
    [anon_sym_LBRACK] = ACTIONS(2200),
    [anon_sym_EQ] = ACTIONS(2198),
    [anon_sym_const] = ACTIONS(2198),
    [anon_sym_constexpr] = ACTIONS(2198),
    [anon_sym_volatile] = ACTIONS(2198),
    [anon_sym_restrict] = ACTIONS(2198),
    [anon_sym___restrict__] = ACTIONS(2198),
    [anon_sym__Atomic] = ACTIONS(2198),
    [anon_sym__Noreturn] = ACTIONS(2198),
    [anon_sym_noreturn] = ACTIONS(2198),
    [anon_sym_mutable] = ACTIONS(2198),
    [anon_sym_constinit] = ACTIONS(2198),
    [anon_sym_consteval] = ACTIONS(2198),
    [anon_sym_alignas] = ACTIONS(2198),
    [anon_sym__Alignas] = ACTIONS(2198),
    [anon_sym_QMARK] = ACTIONS(2200),
    [anon_sym_LT_EQ_GT] = ACTIONS(2200),
    [anon_sym_or] = ACTIONS(2198),
    [anon_sym_and] = ACTIONS(2198),
    [anon_sym_bitor] = ACTIONS(2198),
    [anon_sym_xor] = ACTIONS(2198),
    [anon_sym_bitand] = ACTIONS(2198),
    [anon_sym_not_eq] = ACTIONS(2198),
    [anon_sym_is] = ACTIONS(2198),
    [anon_sym_as] = ACTIONS(2198),
    [anon_sym_DASH_DASH] = ACTIONS(2200),
    [anon_sym_PLUS_PLUS] = ACTIONS(2200),
    [anon_sym_DOT] = ACTIONS(2198),
    [anon_sym_DOT_STAR] = ACTIONS(2200),
    [anon_sym_DASH_GT] = ACTIONS(2200),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2198),
    [anon_sym_let] = ACTIONS(2198),
    [anon_sym_This] = ACTIONS(2198),
    [anon_sym_final] = ACTIONS(2198),
    [anon_sym_override] = ACTIONS(2198),
    [anon_sym_GT2] = ACTIONS(2200),
    [anon_sym_requires] = ACTIONS(2198),
    [anon_sym_where] = ACTIONS(2198),
  },
  [3177] = {
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2254),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_LPAREN2] = ACTIONS(2254),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2254),
    [anon_sym_SLASH] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2254),
    [anon_sym_PIPE_PIPE] = ACTIONS(2254),
    [anon_sym_AMP_AMP] = ACTIONS(2254),
    [anon_sym_PIPE] = ACTIONS(2252),
    [anon_sym_CARET] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_EQ_EQ] = ACTIONS(2254),
    [anon_sym_BANG_EQ] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2252),
    [anon_sym_GT_EQ] = ACTIONS(2252),
    [anon_sym_LT_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2252),
    [anon_sym_LT_LT] = ACTIONS(2254),
    [anon_sym_GT_GT] = ACTIONS(2252),
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym___extension__] = ACTIONS(2252),
    [anon_sym___attribute__] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_LBRACK] = ACTIONS(2254),
    [anon_sym_EQ] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2252),
    [anon_sym_constexpr] = ACTIONS(2252),
    [anon_sym_volatile] = ACTIONS(2252),
    [anon_sym_restrict] = ACTIONS(2252),
    [anon_sym___restrict__] = ACTIONS(2252),
    [anon_sym__Atomic] = ACTIONS(2252),
    [anon_sym__Noreturn] = ACTIONS(2252),
    [anon_sym_noreturn] = ACTIONS(2252),
    [anon_sym_mutable] = ACTIONS(2252),
    [anon_sym_constinit] = ACTIONS(2252),
    [anon_sym_consteval] = ACTIONS(2252),
    [anon_sym_alignas] = ACTIONS(2252),
    [anon_sym__Alignas] = ACTIONS(2252),
    [anon_sym_QMARK] = ACTIONS(2254),
    [anon_sym_LT_EQ_GT] = ACTIONS(2254),
    [anon_sym_or] = ACTIONS(2252),
    [anon_sym_and] = ACTIONS(2252),
    [anon_sym_bitor] = ACTIONS(2252),
    [anon_sym_xor] = ACTIONS(2252),
    [anon_sym_bitand] = ACTIONS(2252),
    [anon_sym_not_eq] = ACTIONS(2252),
    [anon_sym_is] = ACTIONS(2252),
    [anon_sym_as] = ACTIONS(2252),
    [anon_sym_DASH_DASH] = ACTIONS(2254),
    [anon_sym_PLUS_PLUS] = ACTIONS(2254),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_DOT_STAR] = ACTIONS(2254),
    [anon_sym_DASH_GT] = ACTIONS(2254),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_This] = ACTIONS(2252),
    [anon_sym_final] = ACTIONS(2252),
    [anon_sym_override] = ACTIONS(2252),
    [anon_sym_GT2] = ACTIONS(2254),
    [anon_sym_requires] = ACTIONS(2252),
    [anon_sym_where] = ACTIONS(2252),
  },
  [3178] = {
    [sym_identifier] = ACTIONS(2224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2226),
    [anon_sym_COMMA] = ACTIONS(2226),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_PLUS] = ACTIONS(2224),
    [anon_sym_STAR] = ACTIONS(2226),
    [anon_sym_SLASH] = ACTIONS(2224),
    [anon_sym_PERCENT] = ACTIONS(2226),
    [anon_sym_PIPE_PIPE] = ACTIONS(2226),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_PIPE] = ACTIONS(2224),
    [anon_sym_CARET] = ACTIONS(2226),
    [anon_sym_AMP] = ACTIONS(2224),
    [anon_sym_EQ_EQ] = ACTIONS(2226),
    [anon_sym_BANG_EQ] = ACTIONS(2226),
    [anon_sym_GT] = ACTIONS(2224),
    [anon_sym_GT_EQ] = ACTIONS(2224),
    [anon_sym_LT_EQ] = ACTIONS(2224),
    [anon_sym_LT] = ACTIONS(2224),
    [anon_sym_LT_LT] = ACTIONS(2226),
    [anon_sym_GT_GT] = ACTIONS(2224),
    [anon_sym_COLON] = ACTIONS(2224),
    [anon_sym___extension__] = ACTIONS(2224),
    [anon_sym___attribute__] = ACTIONS(2224),
    [anon_sym_COLON_COLON] = ACTIONS(2226),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_EQ] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_constexpr] = ACTIONS(2224),
    [anon_sym_volatile] = ACTIONS(2224),
    [anon_sym_restrict] = ACTIONS(2224),
    [anon_sym___restrict__] = ACTIONS(2224),
    [anon_sym__Atomic] = ACTIONS(2224),
    [anon_sym__Noreturn] = ACTIONS(2224),
    [anon_sym_noreturn] = ACTIONS(2224),
    [anon_sym_mutable] = ACTIONS(2224),
    [anon_sym_constinit] = ACTIONS(2224),
    [anon_sym_consteval] = ACTIONS(2224),
    [anon_sym_alignas] = ACTIONS(2224),
    [anon_sym__Alignas] = ACTIONS(2224),
    [anon_sym_QMARK] = ACTIONS(2226),
    [anon_sym_LT_EQ_GT] = ACTIONS(2226),
    [anon_sym_or] = ACTIONS(2224),
    [anon_sym_and] = ACTIONS(2224),
    [anon_sym_bitor] = ACTIONS(2224),
    [anon_sym_xor] = ACTIONS(2224),
    [anon_sym_bitand] = ACTIONS(2224),
    [anon_sym_not_eq] = ACTIONS(2224),
    [anon_sym_is] = ACTIONS(2224),
    [anon_sym_as] = ACTIONS(2224),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_DOT] = ACTIONS(2224),
    [anon_sym_DOT_STAR] = ACTIONS(2226),
    [anon_sym_DASH_GT] = ACTIONS(2226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2224),
    [anon_sym_let] = ACTIONS(2224),
    [anon_sym_This] = ACTIONS(2224),
    [anon_sym_final] = ACTIONS(2224),
    [anon_sym_override] = ACTIONS(2224),
    [anon_sym_GT2] = ACTIONS(2226),
    [anon_sym_requires] = ACTIONS(2224),
    [anon_sym_where] = ACTIONS(2224),
  },
  [3179] = {
    [sym_template_argument_list] = STATE(3186),
    [sym_identifier] = ACTIONS(6928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6930),
    [anon_sym_COMMA] = ACTIONS(6930),
    [anon_sym_RPAREN] = ACTIONS(6930),
    [aux_sym_preproc_if_token2] = ACTIONS(6930),
    [aux_sym_preproc_else_token1] = ACTIONS(6930),
    [aux_sym_preproc_elif_token1] = ACTIONS(6928),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6930),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6930),
    [anon_sym_LPAREN2] = ACTIONS(6930),
    [anon_sym_DASH] = ACTIONS(6928),
    [anon_sym_PLUS] = ACTIONS(6928),
    [anon_sym_STAR] = ACTIONS(6928),
    [anon_sym_SLASH] = ACTIONS(6928),
    [anon_sym_PERCENT] = ACTIONS(6928),
    [anon_sym_PIPE_PIPE] = ACTIONS(6930),
    [anon_sym_AMP_AMP] = ACTIONS(6930),
    [anon_sym_PIPE] = ACTIONS(6928),
    [anon_sym_CARET] = ACTIONS(6928),
    [anon_sym_AMP] = ACTIONS(6928),
    [anon_sym_EQ_EQ] = ACTIONS(6930),
    [anon_sym_BANG_EQ] = ACTIONS(6930),
    [anon_sym_GT] = ACTIONS(6928),
    [anon_sym_GT_EQ] = ACTIONS(6930),
    [anon_sym_LT_EQ] = ACTIONS(6928),
    [anon_sym_LT] = ACTIONS(6932),
    [anon_sym_LT_LT] = ACTIONS(6928),
    [anon_sym_GT_GT] = ACTIONS(6928),
    [anon_sym_COLON] = ACTIONS(6928),
    [anon_sym_SEMI] = ACTIONS(6930),
    [anon_sym___attribute__] = ACTIONS(6928),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_RBRACE] = ACTIONS(6930),
    [anon_sym_LBRACK] = ACTIONS(6930),
    [anon_sym_RBRACK] = ACTIONS(6930),
    [anon_sym_EQ] = ACTIONS(6928),
    [anon_sym_QMARK] = ACTIONS(6930),
    [anon_sym_STAR_EQ] = ACTIONS(6930),
    [anon_sym_SLASH_EQ] = ACTIONS(6930),
    [anon_sym_PERCENT_EQ] = ACTIONS(6930),
    [anon_sym_PLUS_EQ] = ACTIONS(6930),
    [anon_sym_DASH_EQ] = ACTIONS(6930),
    [anon_sym_LT_LT_EQ] = ACTIONS(6930),
    [anon_sym_GT_GT_EQ] = ACTIONS(6930),
    [anon_sym_AMP_EQ] = ACTIONS(6930),
    [anon_sym_CARET_EQ] = ACTIONS(6930),
    [anon_sym_PIPE_EQ] = ACTIONS(6930),
    [anon_sym_and_eq] = ACTIONS(6928),
    [anon_sym_or_eq] = ACTIONS(6928),
    [anon_sym_xor_eq] = ACTIONS(6928),
    [anon_sym_LT_EQ_GT] = ACTIONS(6930),
    [anon_sym_or] = ACTIONS(6928),
    [anon_sym_and] = ACTIONS(6928),
    [anon_sym_bitor] = ACTIONS(6928),
    [anon_sym_xor] = ACTIONS(6928),
    [anon_sym_bitand] = ACTIONS(6928),
    [anon_sym_not_eq] = ACTIONS(6928),
    [anon_sym_is] = ACTIONS(6928),
    [anon_sym_as] = ACTIONS(6928),
    [anon_sym_DASH_DASH] = ACTIONS(6930),
    [anon_sym_PLUS_PLUS] = ACTIONS(6930),
    [anon_sym_DOT] = ACTIONS(6928),
    [anon_sym_DOT_STAR] = ACTIONS(6930),
    [anon_sym_DASH_GT] = ACTIONS(6930),
    [sym_comment] = ACTIONS(3),
  },
  [3180] = {
    [sym_template_argument_list] = STATE(2816),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3485),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_RPAREN] = ACTIONS(3485),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_STAR] = ACTIONS(3483),
    [anon_sym_SLASH] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3485),
    [anon_sym_AMP_AMP] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(3483),
    [anon_sym_CARET] = ACTIONS(3483),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_EQ_EQ] = ACTIONS(3485),
    [anon_sym_BANG_EQ] = ACTIONS(3485),
    [anon_sym_GT] = ACTIONS(3483),
    [anon_sym_GT_EQ] = ACTIONS(3485),
    [anon_sym_LT_EQ] = ACTIONS(3483),
    [anon_sym_LT] = ACTIONS(3483),
    [anon_sym_LT_LT] = ACTIONS(3483),
    [anon_sym_GT_GT] = ACTIONS(3483),
    [anon_sym___attribute__] = ACTIONS(3485),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(3485),
    [anon_sym_signed] = ACTIONS(6935),
    [anon_sym_unsigned] = ACTIONS(6935),
    [anon_sym_long] = ACTIONS(6935),
    [anon_sym_short] = ACTIONS(6935),
    [anon_sym_LBRACK] = ACTIONS(3485),
    [anon_sym_EQ] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3485),
    [anon_sym_STAR_EQ] = ACTIONS(3485),
    [anon_sym_SLASH_EQ] = ACTIONS(3485),
    [anon_sym_PERCENT_EQ] = ACTIONS(3485),
    [anon_sym_PLUS_EQ] = ACTIONS(3485),
    [anon_sym_DASH_EQ] = ACTIONS(3485),
    [anon_sym_LT_LT_EQ] = ACTIONS(3485),
    [anon_sym_GT_GT_EQ] = ACTIONS(3485),
    [anon_sym_AMP_EQ] = ACTIONS(3485),
    [anon_sym_CARET_EQ] = ACTIONS(3485),
    [anon_sym_PIPE_EQ] = ACTIONS(3485),
    [anon_sym_and_eq] = ACTIONS(3485),
    [anon_sym_or_eq] = ACTIONS(3485),
    [anon_sym_xor_eq] = ACTIONS(3485),
    [anon_sym_LT_EQ_GT] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [anon_sym_and] = ACTIONS(3483),
    [anon_sym_bitor] = ACTIONS(3485),
    [anon_sym_xor] = ACTIONS(3483),
    [anon_sym_bitand] = ACTIONS(3485),
    [anon_sym_not_eq] = ACTIONS(3485),
    [anon_sym_is] = ACTIONS(3485),
    [anon_sym_as] = ACTIONS(3485),
    [anon_sym_DASH_DASH] = ACTIONS(3485),
    [anon_sym_PLUS_PLUS] = ACTIONS(3485),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_DOT_STAR] = ACTIONS(3485),
    [anon_sym_DASH_GT] = ACTIONS(3483),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3485),
    [anon_sym_let] = ACTIONS(3485),
    [anon_sym_This] = ACTIONS(3485),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3485),
  },
  [3181] = {
    [sym_identifier] = ACTIONS(6511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6513),
    [anon_sym_COMMA] = ACTIONS(6513),
    [anon_sym_LPAREN2] = ACTIONS(6513),
    [anon_sym_DASH] = ACTIONS(6511),
    [anon_sym_PLUS] = ACTIONS(6511),
    [anon_sym_STAR] = ACTIONS(6511),
    [anon_sym_SLASH] = ACTIONS(6511),
    [anon_sym_PERCENT] = ACTIONS(6511),
    [anon_sym_PIPE_PIPE] = ACTIONS(6513),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_PIPE] = ACTIONS(6511),
    [anon_sym_CARET] = ACTIONS(6511),
    [anon_sym_AMP] = ACTIONS(6511),
    [anon_sym_EQ_EQ] = ACTIONS(6513),
    [anon_sym_BANG_EQ] = ACTIONS(6513),
    [anon_sym_GT] = ACTIONS(6511),
    [anon_sym_GT_EQ] = ACTIONS(6513),
    [anon_sym_LT_EQ] = ACTIONS(6511),
    [anon_sym_LT] = ACTIONS(6511),
    [anon_sym_LT_LT] = ACTIONS(6511),
    [anon_sym_GT_GT] = ACTIONS(6511),
    [anon_sym_SEMI] = ACTIONS(6513),
    [anon_sym___attribute__] = ACTIONS(6511),
    [anon_sym_LBRACK] = ACTIONS(6513),
    [anon_sym_EQ] = ACTIONS(6511),
    [anon_sym_QMARK] = ACTIONS(6513),
    [anon_sym_STAR_EQ] = ACTIONS(6513),
    [anon_sym_SLASH_EQ] = ACTIONS(6513),
    [anon_sym_PERCENT_EQ] = ACTIONS(6513),
    [anon_sym_PLUS_EQ] = ACTIONS(6513),
    [anon_sym_DASH_EQ] = ACTIONS(6513),
    [anon_sym_LT_LT_EQ] = ACTIONS(6513),
    [anon_sym_GT_GT_EQ] = ACTIONS(6513),
    [anon_sym_AMP_EQ] = ACTIONS(6513),
    [anon_sym_CARET_EQ] = ACTIONS(6513),
    [anon_sym_PIPE_EQ] = ACTIONS(6513),
    [anon_sym_and_eq] = ACTIONS(6511),
    [anon_sym_or_eq] = ACTIONS(6511),
    [anon_sym_xor_eq] = ACTIONS(6511),
    [anon_sym_LT_EQ_GT] = ACTIONS(6513),
    [anon_sym_or] = ACTIONS(6511),
    [anon_sym_and] = ACTIONS(6511),
    [anon_sym_bitor] = ACTIONS(6511),
    [anon_sym_xor] = ACTIONS(6511),
    [anon_sym_bitand] = ACTIONS(6511),
    [anon_sym_not_eq] = ACTIONS(6511),
    [anon_sym_is] = ACTIONS(6511),
    [anon_sym_as] = ACTIONS(6511),
    [anon_sym_DASH_DASH] = ACTIONS(6513),
    [anon_sym_PLUS_PLUS] = ACTIONS(6513),
    [anon_sym_DOT] = ACTIONS(6511),
    [anon_sym_DOT_STAR] = ACTIONS(6513),
    [anon_sym_DASH_GT] = ACTIONS(6513),
    [anon_sym_L_DQUOTE] = ACTIONS(6513),
    [anon_sym_u_DQUOTE] = ACTIONS(6513),
    [anon_sym_U_DQUOTE] = ACTIONS(6513),
    [anon_sym_u8_DQUOTE] = ACTIONS(6513),
    [anon_sym_DQUOTE] = ACTIONS(6513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6513),
    [anon_sym_LR_DQUOTE] = ACTIONS(6513),
    [anon_sym_uR_DQUOTE] = ACTIONS(6513),
    [anon_sym_UR_DQUOTE] = ACTIONS(6513),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6513),
    [sym_literal_suffix] = ACTIONS(6511),
  },
  [3182] = {
    [sym_string_literal] = STATE(3188),
    [sym_raw_string_literal] = STATE(3188),
    [aux_sym_concatenated_string_repeat1] = STATE(3188),
    [sym_identifier] = ACTIONS(6937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6456),
    [anon_sym_COMMA] = ACTIONS(6456),
    [anon_sym_RPAREN] = ACTIONS(6456),
    [anon_sym_LPAREN2] = ACTIONS(6456),
    [anon_sym_DASH] = ACTIONS(6458),
    [anon_sym_PLUS] = ACTIONS(6458),
    [anon_sym_STAR] = ACTIONS(6458),
    [anon_sym_SLASH] = ACTIONS(6458),
    [anon_sym_PERCENT] = ACTIONS(6458),
    [anon_sym_PIPE_PIPE] = ACTIONS(6456),
    [anon_sym_AMP_AMP] = ACTIONS(6456),
    [anon_sym_PIPE] = ACTIONS(6458),
    [anon_sym_CARET] = ACTIONS(6458),
    [anon_sym_AMP] = ACTIONS(6458),
    [anon_sym_EQ_EQ] = ACTIONS(6456),
    [anon_sym_BANG_EQ] = ACTIONS(6456),
    [anon_sym_GT] = ACTIONS(6458),
    [anon_sym_GT_EQ] = ACTIONS(6456),
    [anon_sym_LT_EQ] = ACTIONS(6458),
    [anon_sym_LT] = ACTIONS(6458),
    [anon_sym_LT_LT] = ACTIONS(6458),
    [anon_sym_GT_GT] = ACTIONS(6458),
    [anon_sym_LBRACK] = ACTIONS(6456),
    [anon_sym_EQ] = ACTIONS(6458),
    [anon_sym_QMARK] = ACTIONS(6456),
    [anon_sym_STAR_EQ] = ACTIONS(6456),
    [anon_sym_SLASH_EQ] = ACTIONS(6456),
    [anon_sym_PERCENT_EQ] = ACTIONS(6456),
    [anon_sym_PLUS_EQ] = ACTIONS(6456),
    [anon_sym_DASH_EQ] = ACTIONS(6456),
    [anon_sym_LT_LT_EQ] = ACTIONS(6456),
    [anon_sym_GT_GT_EQ] = ACTIONS(6456),
    [anon_sym_AMP_EQ] = ACTIONS(6456),
    [anon_sym_CARET_EQ] = ACTIONS(6456),
    [anon_sym_PIPE_EQ] = ACTIONS(6456),
    [anon_sym_LT_EQ_GT] = ACTIONS(6456),
    [anon_sym_or] = ACTIONS(6458),
    [anon_sym_and] = ACTIONS(6458),
    [anon_sym_bitor] = ACTIONS(6458),
    [anon_sym_xor] = ACTIONS(6458),
    [anon_sym_bitand] = ACTIONS(6458),
    [anon_sym_not_eq] = ACTIONS(6458),
    [anon_sym_is] = ACTIONS(6458),
    [anon_sym_as] = ACTIONS(6458),
    [anon_sym_DASH_DASH] = ACTIONS(6456),
    [anon_sym_PLUS_PLUS] = ACTIONS(6456),
    [anon_sym_DOT] = ACTIONS(6458),
    [anon_sym_DOT_STAR] = ACTIONS(6456),
    [anon_sym_DASH_GT] = ACTIONS(6458),
    [anon_sym_L_DQUOTE] = ACTIONS(4918),
    [anon_sym_u_DQUOTE] = ACTIONS(4918),
    [anon_sym_U_DQUOTE] = ACTIONS(4918),
    [anon_sym_u8_DQUOTE] = ACTIONS(4918),
    [anon_sym_DQUOTE] = ACTIONS(4918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4920),
    [anon_sym_LR_DQUOTE] = ACTIONS(4920),
    [anon_sym_uR_DQUOTE] = ACTIONS(4920),
    [anon_sym_UR_DQUOTE] = ACTIONS(4920),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4920),
    [anon_sym_DASH_GT_STAR] = ACTIONS(6456),
    [sym_literal_suffix] = ACTIONS(6458),
  },
  [3183] = {
    [sym_ms_based_modifier] = STATE(10435),
    [sym_ms_unaligned_ptr_modifier] = STATE(4963),
    [sym_ms_pointer_modifier] = STATE(4823),
    [sym__declarator] = STATE(7264),
    [sym__abstract_declarator] = STATE(8261),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_abstract_parenthesized_declarator] = STATE(7128),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_abstract_pointer_declarator] = STATE(7128),
    [sym_function_declarator] = STATE(7882),
    [sym_abstract_function_declarator] = STATE(7128),
    [sym_array_declarator] = STATE(7882),
    [sym_abstract_array_declarator] = STATE(7128),
    [sym_type_qualifier] = STATE(3546),
    [sym_alignas_qualifier] = STATE(5665),
    [sym_parameter_list] = STATE(4478),
    [sym_decltype] = STATE(10765),
    [sym_reference_declarator] = STATE(7882),
    [sym_abstract_reference_declarator] = STATE(7128),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym__function_declarator_seq] = STATE(7135),
    [sym_template_type] = STATE(10765),
    [sym_template_function] = STATE(7882),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6926),
    [sym_qualified_identifier] = STATE(7882),
    [sym_operator_name] = STATE(7882),
    [aux_sym__type_definition_type_repeat1] = STATE(3546),
    [aux_sym_pointer_declarator_repeat1] = STATE(4823),
    [sym_identifier] = ACTIONS(6761),
    [anon_sym_COMMA] = ACTIONS(6777),
    [anon_sym_LPAREN2] = ACTIONS(4883),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(6914),
    [anon_sym_AMP_AMP] = ACTIONS(6916),
    [anon_sym_AMP] = ACTIONS(6918),
    [anon_sym_COLON] = ACTIONS(6779),
    [anon_sym___extension__] = ACTIONS(4901),
    [anon_sym_COLON_COLON] = ACTIONS(6773),
    [anon_sym___based] = ACTIONS(49),
    [sym_ms_restrict_modifier] = ACTIONS(4903),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(4903),
    [sym_ms_signed_ptr_modifier] = ACTIONS(4903),
    [anon_sym__unaligned] = ACTIONS(4905),
    [anon_sym___unaligned] = ACTIONS(4905),
    [anon_sym_LBRACK] = ACTIONS(6775),
    [anon_sym_const] = ACTIONS(4901),
    [anon_sym_constexpr] = ACTIONS(4901),
    [anon_sym_volatile] = ACTIONS(4901),
    [anon_sym_restrict] = ACTIONS(4901),
    [anon_sym___restrict__] = ACTIONS(4901),
    [anon_sym__Atomic] = ACTIONS(4901),
    [anon_sym__Noreturn] = ACTIONS(4901),
    [anon_sym_noreturn] = ACTIONS(4901),
    [anon_sym_mutable] = ACTIONS(4901),
    [anon_sym_constinit] = ACTIONS(4901),
    [anon_sym_consteval] = ACTIONS(4901),
    [anon_sym_alignas] = ACTIONS(4907),
    [anon_sym__Alignas] = ACTIONS(4907),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_GT2] = ACTIONS(6777),
    [anon_sym_operator] = ACTIONS(2808),
  },
  [3184] = {
    [sym_identifier] = ACTIONS(6524),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6526),
    [anon_sym_COMMA] = ACTIONS(6526),
    [anon_sym_LPAREN2] = ACTIONS(6526),
    [anon_sym_DASH] = ACTIONS(6524),
    [anon_sym_PLUS] = ACTIONS(6524),
    [anon_sym_STAR] = ACTIONS(6524),
    [anon_sym_SLASH] = ACTIONS(6524),
    [anon_sym_PERCENT] = ACTIONS(6524),
    [anon_sym_PIPE_PIPE] = ACTIONS(6526),
    [anon_sym_AMP_AMP] = ACTIONS(6526),
    [anon_sym_PIPE] = ACTIONS(6524),
    [anon_sym_CARET] = ACTIONS(6524),
    [anon_sym_AMP] = ACTIONS(6524),
    [anon_sym_EQ_EQ] = ACTIONS(6526),
    [anon_sym_BANG_EQ] = ACTIONS(6526),
    [anon_sym_GT] = ACTIONS(6524),
    [anon_sym_GT_EQ] = ACTIONS(6526),
    [anon_sym_LT_EQ] = ACTIONS(6524),
    [anon_sym_LT] = ACTIONS(6524),
    [anon_sym_LT_LT] = ACTIONS(6524),
    [anon_sym_GT_GT] = ACTIONS(6524),
    [anon_sym_SEMI] = ACTIONS(6526),
    [anon_sym___attribute__] = ACTIONS(6524),
    [anon_sym_LBRACK] = ACTIONS(6526),
    [anon_sym_EQ] = ACTIONS(6524),
    [anon_sym_QMARK] = ACTIONS(6526),
    [anon_sym_STAR_EQ] = ACTIONS(6526),
    [anon_sym_SLASH_EQ] = ACTIONS(6526),
    [anon_sym_PERCENT_EQ] = ACTIONS(6526),
    [anon_sym_PLUS_EQ] = ACTIONS(6526),
    [anon_sym_DASH_EQ] = ACTIONS(6526),
    [anon_sym_LT_LT_EQ] = ACTIONS(6526),
    [anon_sym_GT_GT_EQ] = ACTIONS(6526),
    [anon_sym_AMP_EQ] = ACTIONS(6526),
    [anon_sym_CARET_EQ] = ACTIONS(6526),
    [anon_sym_PIPE_EQ] = ACTIONS(6526),
    [anon_sym_and_eq] = ACTIONS(6524),
    [anon_sym_or_eq] = ACTIONS(6524),
    [anon_sym_xor_eq] = ACTIONS(6524),
    [anon_sym_LT_EQ_GT] = ACTIONS(6526),
    [anon_sym_or] = ACTIONS(6524),
    [anon_sym_and] = ACTIONS(6524),
    [anon_sym_bitor] = ACTIONS(6524),
    [anon_sym_xor] = ACTIONS(6524),
    [anon_sym_bitand] = ACTIONS(6524),
    [anon_sym_not_eq] = ACTIONS(6524),
    [anon_sym_is] = ACTIONS(6524),
    [anon_sym_as] = ACTIONS(6524),
    [anon_sym_DASH_DASH] = ACTIONS(6526),
    [anon_sym_PLUS_PLUS] = ACTIONS(6526),
    [anon_sym_DOT] = ACTIONS(6524),
    [anon_sym_DOT_STAR] = ACTIONS(6526),
    [anon_sym_DASH_GT] = ACTIONS(6526),
    [anon_sym_L_DQUOTE] = ACTIONS(6526),
    [anon_sym_u_DQUOTE] = ACTIONS(6526),
    [anon_sym_U_DQUOTE] = ACTIONS(6526),
    [anon_sym_u8_DQUOTE] = ACTIONS(6526),
    [anon_sym_DQUOTE] = ACTIONS(6526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6526),
    [anon_sym_LR_DQUOTE] = ACTIONS(6526),
    [anon_sym_uR_DQUOTE] = ACTIONS(6526),
    [anon_sym_UR_DQUOTE] = ACTIONS(6526),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6526),
    [sym_literal_suffix] = ACTIONS(6524),
  },
  [3185] = {
    [sym_ms_based_modifier] = STATE(10435),
    [sym_ms_unaligned_ptr_modifier] = STATE(4963),
    [sym_ms_pointer_modifier] = STATE(3157),
    [sym__declarator] = STATE(7274),
    [sym__abstract_declarator] = STATE(8249),
    [sym_parenthesized_declarator] = STATE(7882),
    [sym_abstract_parenthesized_declarator] = STATE(7128),
    [sym_attributed_declarator] = STATE(7882),
    [sym_pointer_declarator] = STATE(7882),
    [sym_abstract_pointer_declarator] = STATE(7128),
    [sym_function_declarator] = STATE(7882),
    [sym_abstract_function_declarator] = STATE(7128),
    [sym_array_declarator] = STATE(7882),
    [sym_abstract_array_declarator] = STATE(7128),
    [sym_type_qualifier] = STATE(3587),
    [sym_alignas_qualifier] = STATE(5665),
    [sym_parameter_list] = STATE(4541),
    [sym_decltype] = STATE(10765),
    [sym_reference_declarator] = STATE(7882),
    [sym_abstract_reference_declarator] = STATE(7128),
    [sym_structured_binding_declarator] = STATE(7882),
    [sym__function_declarator_seq] = STATE(7135),
    [sym_template_type] = STATE(10765),
    [sym_template_function] = STATE(7882),
    [sym_destructor_name] = STATE(7882),
    [sym_dependent_type_identifier] = STATE(10765),
    [sym__scope_resolution] = STATE(6926),
    [sym_qualified_identifier] = STATE(7882),
    [sym_operator_name] = STATE(7882),
    [aux_sym__type_definition_type_repeat1] = STATE(3587),
    [aux_sym_pointer_declarator_repeat1] = STATE(3157),
    [sym_identifier] = ACTIONS(6761),
    [anon_sym_COMMA] = ACTIONS(6763),
    [anon_sym_RPAREN] = ACTIONS(6763),
    [anon_sym_LPAREN2] = ACTIONS(4883),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(6905),
    [anon_sym_AMP_AMP] = ACTIONS(6907),
    [anon_sym_AMP] = ACTIONS(6909),
    [anon_sym_COLON] = ACTIONS(6771),
    [anon_sym___extension__] = ACTIONS(4901),
    [anon_sym_COLON_COLON] = ACTIONS(6773),
    [anon_sym___based] = ACTIONS(49),
    [sym_ms_restrict_modifier] = ACTIONS(4903),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(4903),
    [sym_ms_signed_ptr_modifier] = ACTIONS(4903),
    [anon_sym__unaligned] = ACTIONS(4905),
    [anon_sym___unaligned] = ACTIONS(4905),
    [anon_sym_LBRACK] = ACTIONS(6775),
    [anon_sym_const] = ACTIONS(4901),
    [anon_sym_constexpr] = ACTIONS(4901),
    [anon_sym_volatile] = ACTIONS(4901),
    [anon_sym_restrict] = ACTIONS(4901),
    [anon_sym___restrict__] = ACTIONS(4901),
    [anon_sym__Atomic] = ACTIONS(4901),
    [anon_sym__Noreturn] = ACTIONS(4901),
    [anon_sym_noreturn] = ACTIONS(4901),
    [anon_sym_mutable] = ACTIONS(4901),
    [anon_sym_constinit] = ACTIONS(4901),
    [anon_sym_consteval] = ACTIONS(4901),
    [anon_sym_alignas] = ACTIONS(4907),
    [anon_sym__Alignas] = ACTIONS(4907),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(123),
    [anon_sym_template] = ACTIONS(1578),
    [anon_sym_operator] = ACTIONS(2808),
  },
  [3186] = {
    [sym_identifier] = ACTIONS(6939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6941),
    [anon_sym_COMMA] = ACTIONS(6941),
    [anon_sym_RPAREN] = ACTIONS(6941),
    [aux_sym_preproc_if_token2] = ACTIONS(6941),
    [aux_sym_preproc_else_token1] = ACTIONS(6941),
    [aux_sym_preproc_elif_token1] = ACTIONS(6939),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6941),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6941),
    [anon_sym_LPAREN2] = ACTIONS(6941),
    [anon_sym_DASH] = ACTIONS(6939),
    [anon_sym_PLUS] = ACTIONS(6939),
    [anon_sym_STAR] = ACTIONS(6939),
    [anon_sym_SLASH] = ACTIONS(6939),
    [anon_sym_PERCENT] = ACTIONS(6939),
    [anon_sym_PIPE_PIPE] = ACTIONS(6941),
    [anon_sym_AMP_AMP] = ACTIONS(6941),
    [anon_sym_PIPE] = ACTIONS(6939),
    [anon_sym_CARET] = ACTIONS(6939),
    [anon_sym_AMP] = ACTIONS(6939),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_BANG_EQ] = ACTIONS(6941),
    [anon_sym_GT] = ACTIONS(6939),
    [anon_sym_GT_EQ] = ACTIONS(6941),
    [anon_sym_LT_EQ] = ACTIONS(6939),
    [anon_sym_LT] = ACTIONS(6939),
    [anon_sym_LT_LT] = ACTIONS(6939),
    [anon_sym_GT_GT] = ACTIONS(6939),
    [anon_sym_COLON] = ACTIONS(6939),
    [anon_sym_SEMI] = ACTIONS(6941),
    [anon_sym___attribute__] = ACTIONS(6939),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(6941),
    [anon_sym_RBRACE] = ACTIONS(6941),
    [anon_sym_LBRACK] = ACTIONS(6941),
    [anon_sym_RBRACK] = ACTIONS(6941),
    [anon_sym_EQ] = ACTIONS(6939),
    [anon_sym_QMARK] = ACTIONS(6941),
    [anon_sym_STAR_EQ] = ACTIONS(6941),
    [anon_sym_SLASH_EQ] = ACTIONS(6941),
    [anon_sym_PERCENT_EQ] = ACTIONS(6941),
    [anon_sym_PLUS_EQ] = ACTIONS(6941),
    [anon_sym_DASH_EQ] = ACTIONS(6941),
    [anon_sym_LT_LT_EQ] = ACTIONS(6941),
    [anon_sym_GT_GT_EQ] = ACTIONS(6941),
    [anon_sym_AMP_EQ] = ACTIONS(6941),
    [anon_sym_CARET_EQ] = ACTIONS(6941),
    [anon_sym_PIPE_EQ] = ACTIONS(6941),
    [anon_sym_and_eq] = ACTIONS(6939),
    [anon_sym_or_eq] = ACTIONS(6939),
    [anon_sym_xor_eq] = ACTIONS(6939),
    [anon_sym_LT_EQ_GT] = ACTIONS(6941),
    [anon_sym_or] = ACTIONS(6939),
    [anon_sym_and] = ACTIONS(6939),
    [anon_sym_bitor] = ACTIONS(6939),
    [anon_sym_xor] = ACTIONS(6939),
    [anon_sym_bitand] = ACTIONS(6939),
    [anon_sym_not_eq] = ACTIONS(6939),
    [anon_sym_is] = ACTIONS(6939),
    [anon_sym_as] = ACTIONS(6939),
    [anon_sym_DASH_DASH] = ACTIONS(6941),
    [anon_sym_PLUS_PLUS] = ACTIONS(6941),
    [anon_sym_DOT] = ACTIONS(6939),
    [anon_sym_DOT_STAR] = ACTIONS(6941),
    [anon_sym_DASH_GT] = ACTIONS(6941),
    [sym_comment] = ACTIONS(3),
  },
  [3187] = {
    [sym_identifier] = ACTIONS(2236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2238),
    [anon_sym_COMMA] = ACTIONS(2238),
    [anon_sym_LPAREN2] = ACTIONS(2238),
    [anon_sym_DASH] = ACTIONS(2236),
    [anon_sym_PLUS] = ACTIONS(2236),
    [anon_sym_STAR] = ACTIONS(2238),
    [anon_sym_SLASH] = ACTIONS(2236),
    [anon_sym_PERCENT] = ACTIONS(2238),
    [anon_sym_PIPE_PIPE] = ACTIONS(2238),
    [anon_sym_AMP_AMP] = ACTIONS(2238),
    [anon_sym_PIPE] = ACTIONS(2236),
    [anon_sym_CARET] = ACTIONS(2238),
    [anon_sym_AMP] = ACTIONS(2236),
    [anon_sym_EQ_EQ] = ACTIONS(2238),
    [anon_sym_BANG_EQ] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2236),
    [anon_sym_GT_EQ] = ACTIONS(2236),
    [anon_sym_LT_EQ] = ACTIONS(2236),
    [anon_sym_LT] = ACTIONS(2236),
    [anon_sym_LT_LT] = ACTIONS(2238),
    [anon_sym_GT_GT] = ACTIONS(2236),
    [anon_sym_COLON] = ACTIONS(2236),
    [anon_sym___extension__] = ACTIONS(2236),
    [anon_sym___attribute__] = ACTIONS(2236),
    [anon_sym_COLON_COLON] = ACTIONS(2238),
    [anon_sym_LBRACE] = ACTIONS(2238),
    [anon_sym_LBRACK] = ACTIONS(2238),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_const] = ACTIONS(2236),
    [anon_sym_constexpr] = ACTIONS(2236),
    [anon_sym_volatile] = ACTIONS(2236),
    [anon_sym_restrict] = ACTIONS(2236),
    [anon_sym___restrict__] = ACTIONS(2236),
    [anon_sym__Atomic] = ACTIONS(2236),
    [anon_sym__Noreturn] = ACTIONS(2236),
    [anon_sym_noreturn] = ACTIONS(2236),
    [anon_sym_mutable] = ACTIONS(2236),
    [anon_sym_constinit] = ACTIONS(2236),
    [anon_sym_consteval] = ACTIONS(2236),
    [anon_sym_alignas] = ACTIONS(2236),
    [anon_sym__Alignas] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_LT_EQ_GT] = ACTIONS(2238),
    [anon_sym_or] = ACTIONS(2236),
    [anon_sym_and] = ACTIONS(2236),
    [anon_sym_bitor] = ACTIONS(2236),
    [anon_sym_xor] = ACTIONS(2236),
    [anon_sym_bitand] = ACTIONS(2236),
    [anon_sym_not_eq] = ACTIONS(2236),
    [anon_sym_is] = ACTIONS(2236),
    [anon_sym_as] = ACTIONS(2236),
    [anon_sym_DASH_DASH] = ACTIONS(2238),
    [anon_sym_PLUS_PLUS] = ACTIONS(2238),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_DOT_STAR] = ACTIONS(2238),
    [anon_sym_DASH_GT] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2236),
    [anon_sym_let] = ACTIONS(2236),
    [anon_sym_This] = ACTIONS(2236),
    [anon_sym_final] = ACTIONS(2236),
    [anon_sym_override] = ACTIONS(2236),
    [anon_sym_GT2] = ACTIONS(2238),
    [anon_sym_requires] = ACTIONS(2236),
    [anon_sym_where] = ACTIONS(2236),
  },
  [3188] = {
    [sym_string_literal] = STATE(3188),
    [sym_raw_string_literal] = STATE(3188),
    [aux_sym_concatenated_string_repeat1] = STATE(3188),
    [sym_identifier] = ACTIONS(6943),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6444),
    [anon_sym_COMMA] = ACTIONS(6444),
    [anon_sym_RPAREN] = ACTIONS(6444),
    [anon_sym_LPAREN2] = ACTIONS(6444),
    [anon_sym_DASH] = ACTIONS(6446),
    [anon_sym_PLUS] = ACTIONS(6446),
    [anon_sym_STAR] = ACTIONS(6446),
    [anon_sym_SLASH] = ACTIONS(6446),
    [anon_sym_PERCENT] = ACTIONS(6446),
    [anon_sym_PIPE_PIPE] = ACTIONS(6444),
    [anon_sym_AMP_AMP] = ACTIONS(6444),
    [anon_sym_PIPE] = ACTIONS(6446),
    [anon_sym_CARET] = ACTIONS(6446),
    [anon_sym_AMP] = ACTIONS(6446),
    [anon_sym_EQ_EQ] = ACTIONS(6444),
    [anon_sym_BANG_EQ] = ACTIONS(6444),
    [anon_sym_GT] = ACTIONS(6446),
    [anon_sym_GT_EQ] = ACTIONS(6444),
    [anon_sym_LT_EQ] = ACTIONS(6446),
    [anon_sym_LT] = ACTIONS(6446),
    [anon_sym_LT_LT] = ACTIONS(6446),
    [anon_sym_GT_GT] = ACTIONS(6446),
    [anon_sym_LBRACK] = ACTIONS(6444),
    [anon_sym_EQ] = ACTIONS(6446),
    [anon_sym_QMARK] = ACTIONS(6444),
    [anon_sym_STAR_EQ] = ACTIONS(6444),
    [anon_sym_SLASH_EQ] = ACTIONS(6444),
    [anon_sym_PERCENT_EQ] = ACTIONS(6444),
    [anon_sym_PLUS_EQ] = ACTIONS(6444),
    [anon_sym_DASH_EQ] = ACTIONS(6444),
    [anon_sym_LT_LT_EQ] = ACTIONS(6444),
    [anon_sym_GT_GT_EQ] = ACTIONS(6444),
    [anon_sym_AMP_EQ] = ACTIONS(6444),
    [anon_sym_CARET_EQ] = ACTIONS(6444),
    [anon_sym_PIPE_EQ] = ACTIONS(6444),
    [anon_sym_LT_EQ_GT] = ACTIONS(6444),
    [anon_sym_or] = ACTIONS(6446),
    [anon_sym_and] = ACTIONS(6446),
    [anon_sym_bitor] = ACTIONS(6446),
    [anon_sym_xor] = ACTIONS(6446),
    [anon_sym_bitand] = ACTIONS(6446),
    [anon_sym_not_eq] = ACTIONS(6446),
    [anon_sym_is] = ACTIONS(6446),
    [anon_sym_as] = ACTIONS(6446),
    [anon_sym_DASH_DASH] = ACTIONS(6444),
    [anon_sym_PLUS_PLUS] = ACTIONS(6444),
    [anon_sym_DOT] = ACTIONS(6446),
    [anon_sym_DOT_STAR] = ACTIONS(6444),
    [anon_sym_DASH_GT] = ACTIONS(6446),
    [anon_sym_L_DQUOTE] = ACTIONS(6946),
    [anon_sym_u_DQUOTE] = ACTIONS(6946),
    [anon_sym_U_DQUOTE] = ACTIONS(6946),
    [anon_sym_u8_DQUOTE] = ACTIONS(6946),
    [anon_sym_DQUOTE] = ACTIONS(6946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6949),
    [anon_sym_LR_DQUOTE] = ACTIONS(6949),
    [anon_sym_uR_DQUOTE] = ACTIONS(6949),
    [anon_sym_UR_DQUOTE] = ACTIONS(6949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6949),
    [anon_sym_DASH_GT_STAR] = ACTIONS(6444),
    [sym_literal_suffix] = ACTIONS(6446),
  },
  [3189] = {
    [sym_identifier] = ACTIONS(2206),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2208),
    [anon_sym_COMMA] = ACTIONS(2208),
    [anon_sym_LPAREN2] = ACTIONS(2208),
    [anon_sym_DASH] = ACTIONS(2206),
    [anon_sym_PLUS] = ACTIONS(2206),
    [anon_sym_STAR] = ACTIONS(2208),
    [anon_sym_SLASH] = ACTIONS(2206),
    [anon_sym_PERCENT] = ACTIONS(2208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2208),
    [anon_sym_AMP_AMP] = ACTIONS(2208),
    [anon_sym_PIPE] = ACTIONS(2206),
    [anon_sym_CARET] = ACTIONS(2208),
    [anon_sym_AMP] = ACTIONS(2206),
    [anon_sym_EQ_EQ] = ACTIONS(2208),
    [anon_sym_BANG_EQ] = ACTIONS(2208),
    [anon_sym_GT] = ACTIONS(2206),
    [anon_sym_GT_EQ] = ACTIONS(2206),
    [anon_sym_LT_EQ] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2206),
    [anon_sym_LT_LT] = ACTIONS(2208),
    [anon_sym_GT_GT] = ACTIONS(2206),
    [anon_sym_COLON] = ACTIONS(2206),
    [anon_sym___extension__] = ACTIONS(2206),
    [anon_sym___attribute__] = ACTIONS(2206),
    [anon_sym_COLON_COLON] = ACTIONS(2208),
    [anon_sym_LBRACE] = ACTIONS(2208),
    [anon_sym_LBRACK] = ACTIONS(2208),
    [anon_sym_EQ] = ACTIONS(2206),
    [anon_sym_const] = ACTIONS(2206),
    [anon_sym_constexpr] = ACTIONS(2206),
    [anon_sym_volatile] = ACTIONS(2206),
    [anon_sym_restrict] = ACTIONS(2206),
    [anon_sym___restrict__] = ACTIONS(2206),
    [anon_sym__Atomic] = ACTIONS(2206),
    [anon_sym__Noreturn] = ACTIONS(2206),
    [anon_sym_noreturn] = ACTIONS(2206),
    [anon_sym_mutable] = ACTIONS(2206),
    [anon_sym_constinit] = ACTIONS(2206),
    [anon_sym_consteval] = ACTIONS(2206),
    [anon_sym_alignas] = ACTIONS(2206),
    [anon_sym__Alignas] = ACTIONS(2206),
    [anon_sym_QMARK] = ACTIONS(2208),
    [anon_sym_LT_EQ_GT] = ACTIONS(2208),
    [anon_sym_or] = ACTIONS(2206),
    [anon_sym_and] = ACTIONS(2206),
    [anon_sym_bitor] = ACTIONS(2206),
    [anon_sym_xor] = ACTIONS(2206),
    [anon_sym_bitand] = ACTIONS(2206),
    [anon_sym_not_eq] = ACTIONS(2206),
    [anon_sym_is] = ACTIONS(2206),
    [anon_sym_as] = ACTIONS(2206),
    [anon_sym_DASH_DASH] = ACTIONS(2208),
    [anon_sym_PLUS_PLUS] = ACTIONS(2208),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_DOT_STAR] = ACTIONS(2208),
    [anon_sym_DASH_GT] = ACTIONS(2208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2206),
    [anon_sym_let] = ACTIONS(2206),
    [anon_sym_This] = ACTIONS(2206),
    [anon_sym_final] = ACTIONS(2206),
    [anon_sym_override] = ACTIONS(2206),
    [anon_sym_GT2] = ACTIONS(2208),
    [anon_sym_requires] = ACTIONS(2206),
    [anon_sym_where] = ACTIONS(2206),
  },
  [3190] = {
    [sym_identifier] = ACTIONS(2190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2192),
    [anon_sym_COMMA] = ACTIONS(2192),
    [anon_sym_LPAREN2] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2190),
    [anon_sym_PLUS] = ACTIONS(2190),
    [anon_sym_STAR] = ACTIONS(2192),
    [anon_sym_SLASH] = ACTIONS(2190),
    [anon_sym_PERCENT] = ACTIONS(2192),
    [anon_sym_PIPE_PIPE] = ACTIONS(2192),
    [anon_sym_AMP_AMP] = ACTIONS(2192),
    [anon_sym_PIPE] = ACTIONS(2190),
    [anon_sym_CARET] = ACTIONS(2192),
    [anon_sym_AMP] = ACTIONS(2190),
    [anon_sym_EQ_EQ] = ACTIONS(2192),
    [anon_sym_BANG_EQ] = ACTIONS(2192),
    [anon_sym_GT] = ACTIONS(2190),
    [anon_sym_GT_EQ] = ACTIONS(2190),
    [anon_sym_LT_EQ] = ACTIONS(2190),
    [anon_sym_LT] = ACTIONS(2190),
    [anon_sym_LT_LT] = ACTIONS(2192),
    [anon_sym_GT_GT] = ACTIONS(2190),
    [anon_sym_COLON] = ACTIONS(2190),
    [anon_sym___extension__] = ACTIONS(2190),
    [anon_sym___attribute__] = ACTIONS(2190),
    [anon_sym_COLON_COLON] = ACTIONS(2192),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [anon_sym_LBRACK] = ACTIONS(2192),
    [anon_sym_EQ] = ACTIONS(2190),
    [anon_sym_const] = ACTIONS(2190),
    [anon_sym_constexpr] = ACTIONS(2190),
    [anon_sym_volatile] = ACTIONS(2190),
    [anon_sym_restrict] = ACTIONS(2190),
    [anon_sym___restrict__] = ACTIONS(2190),
    [anon_sym__Atomic] = ACTIONS(2190),
    [anon_sym__Noreturn] = ACTIONS(2190),
    [anon_sym_noreturn] = ACTIONS(2190),
    [anon_sym_mutable] = ACTIONS(2190),
    [anon_sym_constinit] = ACTIONS(2190),
    [anon_sym_consteval] = ACTIONS(2190),
    [anon_sym_alignas] = ACTIONS(2190),
    [anon_sym__Alignas] = ACTIONS(2190),
    [anon_sym_QMARK] = ACTIONS(2192),
    [anon_sym_LT_EQ_GT] = ACTIONS(2192),
    [anon_sym_or] = ACTIONS(2190),
    [anon_sym_and] = ACTIONS(2190),
    [anon_sym_bitor] = ACTIONS(2190),
    [anon_sym_xor] = ACTIONS(2190),
    [anon_sym_bitand] = ACTIONS(2190),
    [anon_sym_not_eq] = ACTIONS(2190),
    [anon_sym_is] = ACTIONS(2190),
    [anon_sym_as] = ACTIONS(2190),
    [anon_sym_DASH_DASH] = ACTIONS(2192),
    [anon_sym_PLUS_PLUS] = ACTIONS(2192),
    [anon_sym_DOT] = ACTIONS(2190),
    [anon_sym_DOT_STAR] = ACTIONS(2192),
    [anon_sym_DASH_GT] = ACTIONS(2192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2190),
    [anon_sym_let] = ACTIONS(2190),
    [anon_sym_This] = ACTIONS(2190),
    [anon_sym_final] = ACTIONS(2190),
    [anon_sym_override] = ACTIONS(2190),
    [anon_sym_GT2] = ACTIONS(2192),
    [anon_sym_requires] = ACTIONS(2190),
    [anon_sym_where] = ACTIONS(2190),
  },
  [3191] = {
    [sym_identifier] = ACTIONS(2194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2196),
    [anon_sym_COMMA] = ACTIONS(2196),
    [anon_sym_LPAREN2] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2194),
    [anon_sym_PLUS] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(2196),
    [anon_sym_SLASH] = ACTIONS(2194),
    [anon_sym_PERCENT] = ACTIONS(2196),
    [anon_sym_PIPE_PIPE] = ACTIONS(2196),
    [anon_sym_AMP_AMP] = ACTIONS(2196),
    [anon_sym_PIPE] = ACTIONS(2194),
    [anon_sym_CARET] = ACTIONS(2196),
    [anon_sym_AMP] = ACTIONS(2194),
    [anon_sym_EQ_EQ] = ACTIONS(2196),
    [anon_sym_BANG_EQ] = ACTIONS(2196),
    [anon_sym_GT] = ACTIONS(2194),
    [anon_sym_GT_EQ] = ACTIONS(2194),
    [anon_sym_LT_EQ] = ACTIONS(2194),
    [anon_sym_LT] = ACTIONS(2194),
    [anon_sym_LT_LT] = ACTIONS(2196),
    [anon_sym_GT_GT] = ACTIONS(2194),
    [anon_sym_COLON] = ACTIONS(2194),
    [anon_sym___extension__] = ACTIONS(2194),
    [anon_sym___attribute__] = ACTIONS(2194),
    [anon_sym_COLON_COLON] = ACTIONS(2196),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_LBRACK] = ACTIONS(2196),
    [anon_sym_EQ] = ACTIONS(2194),
    [anon_sym_const] = ACTIONS(2194),
    [anon_sym_constexpr] = ACTIONS(2194),
    [anon_sym_volatile] = ACTIONS(2194),
    [anon_sym_restrict] = ACTIONS(2194),
    [anon_sym___restrict__] = ACTIONS(2194),
    [anon_sym__Atomic] = ACTIONS(2194),
    [anon_sym__Noreturn] = ACTIONS(2194),
    [anon_sym_noreturn] = ACTIONS(2194),
    [anon_sym_mutable] = ACTIONS(2194),
    [anon_sym_constinit] = ACTIONS(2194),
    [anon_sym_consteval] = ACTIONS(2194),
    [anon_sym_alignas] = ACTIONS(2194),
    [anon_sym__Alignas] = ACTIONS(2194),
    [anon_sym_QMARK] = ACTIONS(2196),
    [anon_sym_LT_EQ_GT] = ACTIONS(2196),
    [anon_sym_or] = ACTIONS(2194),
    [anon_sym_and] = ACTIONS(2194),
    [anon_sym_bitor] = ACTIONS(2194),
    [anon_sym_xor] = ACTIONS(2194),
    [anon_sym_bitand] = ACTIONS(2194),
    [anon_sym_not_eq] = ACTIONS(2194),
    [anon_sym_is] = ACTIONS(2194),
    [anon_sym_as] = ACTIONS(2194),
    [anon_sym_DASH_DASH] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2196),
    [anon_sym_DOT] = ACTIONS(2194),
    [anon_sym_DOT_STAR] = ACTIONS(2196),
    [anon_sym_DASH_GT] = ACTIONS(2196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2194),
    [anon_sym_let] = ACTIONS(2194),
    [anon_sym_This] = ACTIONS(2194),
    [anon_sym_final] = ACTIONS(2194),
    [anon_sym_override] = ACTIONS(2194),
    [anon_sym_GT2] = ACTIONS(2196),
    [anon_sym_requires] = ACTIONS(2194),
    [anon_sym_where] = ACTIONS(2194),
  },
  [3192] = {
    [sym_identifier] = ACTIONS(2202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_LPAREN2] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2202),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_STAR] = ACTIONS(2204),
    [anon_sym_SLASH] = ACTIONS(2202),
    [anon_sym_PERCENT] = ACTIONS(2204),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2202),
    [anon_sym_CARET] = ACTIONS(2204),
    [anon_sym_AMP] = ACTIONS(2202),
    [anon_sym_EQ_EQ] = ACTIONS(2204),
    [anon_sym_BANG_EQ] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(2202),
    [anon_sym_GT_EQ] = ACTIONS(2202),
    [anon_sym_LT_EQ] = ACTIONS(2202),
    [anon_sym_LT] = ACTIONS(2202),
    [anon_sym_LT_LT] = ACTIONS(2204),
    [anon_sym_GT_GT] = ACTIONS(2202),
    [anon_sym_COLON] = ACTIONS(2202),
    [anon_sym___extension__] = ACTIONS(2202),
    [anon_sym___attribute__] = ACTIONS(2202),
    [anon_sym_COLON_COLON] = ACTIONS(2204),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(2204),
    [anon_sym_EQ] = ACTIONS(2202),
    [anon_sym_const] = ACTIONS(2202),
    [anon_sym_constexpr] = ACTIONS(2202),
    [anon_sym_volatile] = ACTIONS(2202),
    [anon_sym_restrict] = ACTIONS(2202),
    [anon_sym___restrict__] = ACTIONS(2202),
    [anon_sym__Atomic] = ACTIONS(2202),
    [anon_sym__Noreturn] = ACTIONS(2202),
    [anon_sym_noreturn] = ACTIONS(2202),
    [anon_sym_mutable] = ACTIONS(2202),
    [anon_sym_constinit] = ACTIONS(2202),
    [anon_sym_consteval] = ACTIONS(2202),
    [anon_sym_alignas] = ACTIONS(2202),
    [anon_sym__Alignas] = ACTIONS(2202),
    [anon_sym_QMARK] = ACTIONS(2204),
    [anon_sym_LT_EQ_GT] = ACTIONS(2204),
    [anon_sym_or] = ACTIONS(2202),
    [anon_sym_and] = ACTIONS(2202),
    [anon_sym_bitor] = ACTIONS(2202),
    [anon_sym_xor] = ACTIONS(2202),
    [anon_sym_bitand] = ACTIONS(2202),
    [anon_sym_not_eq] = ACTIONS(2202),
    [anon_sym_is] = ACTIONS(2202),
    [anon_sym_as] = ACTIONS(2202),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(2202),
    [anon_sym_DOT_STAR] = ACTIONS(2204),
    [anon_sym_DASH_GT] = ACTIONS(2204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2202),
    [anon_sym_let] = ACTIONS(2202),
    [anon_sym_This] = ACTIONS(2202),
    [anon_sym_final] = ACTIONS(2202),
    [anon_sym_override] = ACTIONS(2202),
    [anon_sym_GT2] = ACTIONS(2204),
    [anon_sym_requires] = ACTIONS(2202),
    [anon_sym_where] = ACTIONS(2202),
  },
  [3193] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3160),
    [sym_identifier] = ACTIONS(2856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3781),
    [anon_sym_RPAREN] = ACTIONS(3781),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_DASH] = ACTIONS(3778),
    [anon_sym_PLUS] = ACTIONS(3778),
    [anon_sym_STAR] = ACTIONS(3778),
    [anon_sym_SLASH] = ACTIONS(3778),
    [anon_sym_PERCENT] = ACTIONS(3778),
    [anon_sym_PIPE_PIPE] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_PIPE] = ACTIONS(3778),
    [anon_sym_CARET] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_GT] = ACTIONS(3778),
    [anon_sym_GT_EQ] = ACTIONS(3781),
    [anon_sym_LT_EQ] = ACTIONS(3778),
    [anon_sym_LT] = ACTIONS(3778),
    [anon_sym_LT_LT] = ACTIONS(3778),
    [anon_sym_GT_GT] = ACTIONS(3778),
    [anon_sym___attribute__] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_signed] = ACTIONS(6911),
    [anon_sym_unsigned] = ACTIONS(6911),
    [anon_sym_long] = ACTIONS(6911),
    [anon_sym_short] = ACTIONS(6911),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3778),
    [sym_primitive_type] = ACTIONS(2856),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_STAR_EQ] = ACTIONS(3781),
    [anon_sym_SLASH_EQ] = ACTIONS(3781),
    [anon_sym_PERCENT_EQ] = ACTIONS(3781),
    [anon_sym_PLUS_EQ] = ACTIONS(3781),
    [anon_sym_DASH_EQ] = ACTIONS(3781),
    [anon_sym_LT_LT_EQ] = ACTIONS(3781),
    [anon_sym_GT_GT_EQ] = ACTIONS(3781),
    [anon_sym_AMP_EQ] = ACTIONS(3781),
    [anon_sym_CARET_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_and_eq] = ACTIONS(3778),
    [anon_sym_or_eq] = ACTIONS(3778),
    [anon_sym_xor_eq] = ACTIONS(3778),
    [anon_sym_LT_EQ_GT] = ACTIONS(3781),
    [anon_sym_or] = ACTIONS(3778),
    [anon_sym_and] = ACTIONS(3778),
    [anon_sym_bitor] = ACTIONS(3778),
    [anon_sym_xor] = ACTIONS(3778),
    [anon_sym_bitand] = ACTIONS(3778),
    [anon_sym_not_eq] = ACTIONS(3778),
    [anon_sym_is] = ACTIONS(3778),
    [anon_sym_as] = ACTIONS(3778),
    [anon_sym_DASH_DASH] = ACTIONS(3781),
    [anon_sym_PLUS_PLUS] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(3778),
    [anon_sym_DOT_STAR] = ACTIONS(3781),
    [anon_sym_DASH_GT] = ACTIONS(3778),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3778),
    [anon_sym_let] = ACTIONS(3778),
    [anon_sym_This] = ACTIONS(3778),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3781),
  },
  [3194] = {
    [sym_template_argument_list] = STATE(3186),
    [sym_identifier] = ACTIONS(6952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6954),
    [anon_sym_COMMA] = ACTIONS(6954),
    [anon_sym_RPAREN] = ACTIONS(6954),
    [aux_sym_preproc_if_token2] = ACTIONS(6954),
    [aux_sym_preproc_else_token1] = ACTIONS(6954),
    [aux_sym_preproc_elif_token1] = ACTIONS(6952),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6954),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6954),
    [anon_sym_LPAREN2] = ACTIONS(6954),
    [anon_sym_DASH] = ACTIONS(6952),
    [anon_sym_PLUS] = ACTIONS(6952),
    [anon_sym_STAR] = ACTIONS(6952),
    [anon_sym_SLASH] = ACTIONS(6952),
    [anon_sym_PERCENT] = ACTIONS(6952),
    [anon_sym_PIPE_PIPE] = ACTIONS(6954),
    [anon_sym_AMP_AMP] = ACTIONS(6954),
    [anon_sym_PIPE] = ACTIONS(6952),
    [anon_sym_CARET] = ACTIONS(6952),
    [anon_sym_AMP] = ACTIONS(6952),
    [anon_sym_EQ_EQ] = ACTIONS(6954),
    [anon_sym_BANG_EQ] = ACTIONS(6954),
    [anon_sym_GT] = ACTIONS(6952),
    [anon_sym_GT_EQ] = ACTIONS(6954),
    [anon_sym_LT_EQ] = ACTIONS(6952),
    [anon_sym_LT] = ACTIONS(6956),
    [anon_sym_LT_LT] = ACTIONS(6952),
    [anon_sym_GT_GT] = ACTIONS(6952),
    [anon_sym_COLON] = ACTIONS(6952),
    [anon_sym_SEMI] = ACTIONS(6954),
    [anon_sym___attribute__] = ACTIONS(6952),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_RBRACE] = ACTIONS(6954),
    [anon_sym_LBRACK] = ACTIONS(6954),
    [anon_sym_RBRACK] = ACTIONS(6954),
    [anon_sym_EQ] = ACTIONS(6952),
    [anon_sym_QMARK] = ACTIONS(6954),
    [anon_sym_STAR_EQ] = ACTIONS(6954),
    [anon_sym_SLASH_EQ] = ACTIONS(6954),
    [anon_sym_PERCENT_EQ] = ACTIONS(6954),
    [anon_sym_PLUS_EQ] = ACTIONS(6954),
    [anon_sym_DASH_EQ] = ACTIONS(6954),
    [anon_sym_LT_LT_EQ] = ACTIONS(6954),
    [anon_sym_GT_GT_EQ] = ACTIONS(6954),
    [anon_sym_AMP_EQ] = ACTIONS(6954),
    [anon_sym_CARET_EQ] = ACTIONS(6954),
    [anon_sym_PIPE_EQ] = ACTIONS(6954),
    [anon_sym_and_eq] = ACTIONS(6952),
    [anon_sym_or_eq] = ACTIONS(6952),
    [anon_sym_xor_eq] = ACTIONS(6952),
    [anon_sym_LT_EQ_GT] = ACTIONS(6954),
    [anon_sym_or] = ACTIONS(6952),
    [anon_sym_and] = ACTIONS(6952),
    [anon_sym_bitor] = ACTIONS(6952),
    [anon_sym_xor] = ACTIONS(6952),
    [anon_sym_bitand] = ACTIONS(6952),
    [anon_sym_not_eq] = ACTIONS(6952),
    [anon_sym_is] = ACTIONS(6952),
    [anon_sym_as] = ACTIONS(6952),
    [anon_sym_DASH_DASH] = ACTIONS(6954),
    [anon_sym_PLUS_PLUS] = ACTIONS(6954),
    [anon_sym_DOT] = ACTIONS(6952),
    [anon_sym_DOT_STAR] = ACTIONS(6954),
    [anon_sym_DASH_GT] = ACTIONS(6954),
    [sym_comment] = ACTIONS(3),
  },
  [3195] = {
    [sym_attribute_specifier] = STATE(3535),
    [sym_field_declaration_list] = STATE(3471),
    [sym_virtual_specifier] = STATE(8756),
    [sym_base_class_clause] = STATE(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2685),
    [anon_sym_RPAREN] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2683),
    [anon_sym_PLUS] = ACTIONS(2683),
    [anon_sym_STAR] = ACTIONS(2683),
    [anon_sym_SLASH] = ACTIONS(2683),
    [anon_sym_PERCENT] = ACTIONS(2683),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_PIPE] = ACTIONS(2683),
    [anon_sym_CARET] = ACTIONS(2683),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_EQ_EQ] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_GT] = ACTIONS(2683),
    [anon_sym_GT_EQ] = ACTIONS(2685),
    [anon_sym_LT_EQ] = ACTIONS(2683),
    [anon_sym_LT] = ACTIONS(2683),
    [anon_sym_LT_LT] = ACTIONS(2683),
    [anon_sym_GT_GT] = ACTIONS(2683),
    [anon_sym_COLON] = ACTIONS(6474),
    [anon_sym___attribute__] = ACTIONS(6959),
    [anon_sym_LBRACE] = ACTIONS(6961),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2683),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_STAR_EQ] = ACTIONS(2685),
    [anon_sym_SLASH_EQ] = ACTIONS(2685),
    [anon_sym_PERCENT_EQ] = ACTIONS(2685),
    [anon_sym_PLUS_EQ] = ACTIONS(2685),
    [anon_sym_DASH_EQ] = ACTIONS(2685),
    [anon_sym_LT_LT_EQ] = ACTIONS(2685),
    [anon_sym_GT_GT_EQ] = ACTIONS(2685),
    [anon_sym_AMP_EQ] = ACTIONS(2685),
    [anon_sym_CARET_EQ] = ACTIONS(2685),
    [anon_sym_PIPE_EQ] = ACTIONS(2685),
    [anon_sym_and_eq] = ACTIONS(2685),
    [anon_sym_or_eq] = ACTIONS(2685),
    [anon_sym_xor_eq] = ACTIONS(2685),
    [anon_sym_LT_EQ_GT] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2683),
    [anon_sym_and] = ACTIONS(2683),
    [anon_sym_bitor] = ACTIONS(2685),
    [anon_sym_xor] = ACTIONS(2683),
    [anon_sym_bitand] = ACTIONS(2685),
    [anon_sym_not_eq] = ACTIONS(2685),
    [anon_sym_is] = ACTIONS(2685),
    [anon_sym_as] = ACTIONS(2685),
    [anon_sym_DASH_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_PLUS] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2683),
    [anon_sym_DOT_STAR] = ACTIONS(2685),
    [anon_sym_DASH_GT] = ACTIONS(2683),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_This] = ACTIONS(2685),
    [anon_sym_final] = ACTIONS(6625),
    [anon_sym_override] = ACTIONS(6625),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2685),
  },
  [3196] = {
    [sym_identifier] = ACTIONS(2240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2240),
    [anon_sym_PLUS] = ACTIONS(2240),
    [anon_sym_STAR] = ACTIONS(2242),
    [anon_sym_SLASH] = ACTIONS(2240),
    [anon_sym_PERCENT] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_PIPE] = ACTIONS(2240),
    [anon_sym_CARET] = ACTIONS(2242),
    [anon_sym_AMP] = ACTIONS(2240),
    [anon_sym_EQ_EQ] = ACTIONS(2242),
    [anon_sym_BANG_EQ] = ACTIONS(2242),
    [anon_sym_GT] = ACTIONS(2240),
    [anon_sym_GT_EQ] = ACTIONS(2240),
    [anon_sym_LT_EQ] = ACTIONS(2240),
    [anon_sym_LT] = ACTIONS(2240),
    [anon_sym_LT_LT] = ACTIONS(2242),
    [anon_sym_GT_GT] = ACTIONS(2240),
    [anon_sym_COLON] = ACTIONS(2240),
    [anon_sym___extension__] = ACTIONS(2240),
    [anon_sym___attribute__] = ACTIONS(2240),
    [anon_sym_COLON_COLON] = ACTIONS(2242),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_EQ] = ACTIONS(2240),
    [anon_sym_const] = ACTIONS(2240),
    [anon_sym_constexpr] = ACTIONS(2240),
    [anon_sym_volatile] = ACTIONS(2240),
    [anon_sym_restrict] = ACTIONS(2240),
    [anon_sym___restrict__] = ACTIONS(2240),
    [anon_sym__Atomic] = ACTIONS(2240),
    [anon_sym__Noreturn] = ACTIONS(2240),
    [anon_sym_noreturn] = ACTIONS(2240),
    [anon_sym_mutable] = ACTIONS(2240),
    [anon_sym_constinit] = ACTIONS(2240),
    [anon_sym_consteval] = ACTIONS(2240),
    [anon_sym_alignas] = ACTIONS(2240),
    [anon_sym__Alignas] = ACTIONS(2240),
    [anon_sym_QMARK] = ACTIONS(2242),
    [anon_sym_LT_EQ_GT] = ACTIONS(2242),
    [anon_sym_or] = ACTIONS(2240),
    [anon_sym_and] = ACTIONS(2240),
    [anon_sym_bitor] = ACTIONS(2240),
    [anon_sym_xor] = ACTIONS(2240),
    [anon_sym_bitand] = ACTIONS(2240),
    [anon_sym_not_eq] = ACTIONS(2240),
    [anon_sym_is] = ACTIONS(2240),
    [anon_sym_as] = ACTIONS(2240),
    [anon_sym_DASH_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_PLUS] = ACTIONS(2242),
    [anon_sym_DOT] = ACTIONS(2240),
    [anon_sym_DOT_STAR] = ACTIONS(2242),
    [anon_sym_DASH_GT] = ACTIONS(2242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2240),
    [anon_sym_let] = ACTIONS(2240),
    [anon_sym_This] = ACTIONS(2240),
    [anon_sym_final] = ACTIONS(2240),
    [anon_sym_override] = ACTIONS(2240),
    [anon_sym_GT2] = ACTIONS(2242),
    [anon_sym_requires] = ACTIONS(2240),
    [anon_sym_where] = ACTIONS(2240),
  },
  [3197] = {
    [sym_attribute_specifier] = STATE(3071),
    [sym_enumerator_list] = STATE(3034),
    [sym__enum_base_clause] = STATE(2974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3062),
    [anon_sym_COMMA] = ACTIONS(3062),
    [anon_sym_RPAREN] = ACTIONS(3062),
    [anon_sym_LPAREN2] = ACTIONS(3062),
    [anon_sym_DASH] = ACTIONS(3060),
    [anon_sym_PLUS] = ACTIONS(3060),
    [anon_sym_STAR] = ACTIONS(3060),
    [anon_sym_SLASH] = ACTIONS(3060),
    [anon_sym_PERCENT] = ACTIONS(3060),
    [anon_sym_PIPE_PIPE] = ACTIONS(3062),
    [anon_sym_AMP_AMP] = ACTIONS(3062),
    [anon_sym_PIPE] = ACTIONS(3060),
    [anon_sym_CARET] = ACTIONS(3060),
    [anon_sym_AMP] = ACTIONS(3060),
    [anon_sym_EQ_EQ] = ACTIONS(3062),
    [anon_sym_BANG_EQ] = ACTIONS(3062),
    [anon_sym_GT] = ACTIONS(3060),
    [anon_sym_GT_EQ] = ACTIONS(3062),
    [anon_sym_LT_EQ] = ACTIONS(3060),
    [anon_sym_LT] = ACTIONS(3060),
    [anon_sym_LT_LT] = ACTIONS(3060),
    [anon_sym_GT_GT] = ACTIONS(3060),
    [anon_sym_COLON] = ACTIONS(6963),
    [anon_sym_SEMI] = ACTIONS(3062),
    [anon_sym___attribute__] = ACTIONS(6965),
    [anon_sym_LBRACE] = ACTIONS(6615),
    [anon_sym_RBRACE] = ACTIONS(3062),
    [anon_sym_LBRACK] = ACTIONS(3062),
    [anon_sym_RBRACK] = ACTIONS(3062),
    [anon_sym_EQ] = ACTIONS(3060),
    [anon_sym_QMARK] = ACTIONS(3062),
    [anon_sym_STAR_EQ] = ACTIONS(3062),
    [anon_sym_SLASH_EQ] = ACTIONS(3062),
    [anon_sym_PERCENT_EQ] = ACTIONS(3062),
    [anon_sym_PLUS_EQ] = ACTIONS(3062),
    [anon_sym_DASH_EQ] = ACTIONS(3062),
    [anon_sym_LT_LT_EQ] = ACTIONS(3062),
    [anon_sym_GT_GT_EQ] = ACTIONS(3062),
    [anon_sym_AMP_EQ] = ACTIONS(3062),
    [anon_sym_CARET_EQ] = ACTIONS(3062),
    [anon_sym_PIPE_EQ] = ACTIONS(3062),
    [anon_sym_and_eq] = ACTIONS(3062),
    [anon_sym_or_eq] = ACTIONS(3062),
    [anon_sym_xor_eq] = ACTIONS(3062),
    [anon_sym_LT_EQ_GT] = ACTIONS(3062),
    [anon_sym_or] = ACTIONS(3060),
    [anon_sym_and] = ACTIONS(3060),
    [anon_sym_bitor] = ACTIONS(3062),
    [anon_sym_xor] = ACTIONS(3060),
    [anon_sym_bitand] = ACTIONS(3062),
    [anon_sym_not_eq] = ACTIONS(3062),
    [anon_sym_is] = ACTIONS(3062),
    [anon_sym_as] = ACTIONS(3062),
    [anon_sym_DASH_DASH] = ACTIONS(3062),
    [anon_sym_PLUS_PLUS] = ACTIONS(3062),
    [anon_sym_DOT] = ACTIONS(3060),
    [anon_sym_DOT_STAR] = ACTIONS(3062),
    [anon_sym_DASH_GT] = ACTIONS(3062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3062),
    [anon_sym_let] = ACTIONS(3062),
    [anon_sym_This] = ACTIONS(3062),
  },
  [3198] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6462),
    [anon_sym_COMMA] = ACTIONS(6462),
    [anon_sym_RPAREN] = ACTIONS(6462),
    [anon_sym_LPAREN2] = ACTIONS(6462),
    [anon_sym_DASH] = ACTIONS(6460),
    [anon_sym_PLUS] = ACTIONS(6460),
    [anon_sym_STAR] = ACTIONS(6460),
    [anon_sym_SLASH] = ACTIONS(6460),
    [anon_sym_PERCENT] = ACTIONS(6460),
    [anon_sym_PIPE_PIPE] = ACTIONS(6462),
    [anon_sym_AMP_AMP] = ACTIONS(6462),
    [anon_sym_PIPE] = ACTIONS(6460),
    [anon_sym_CARET] = ACTIONS(6460),
    [anon_sym_AMP] = ACTIONS(6460),
    [anon_sym_EQ_EQ] = ACTIONS(6462),
    [anon_sym_BANG_EQ] = ACTIONS(6462),
    [anon_sym_GT] = ACTIONS(6460),
    [anon_sym_GT_EQ] = ACTIONS(6462),
    [anon_sym_LT_EQ] = ACTIONS(6460),
    [anon_sym_LT] = ACTIONS(6460),
    [anon_sym_LT_LT] = ACTIONS(6460),
    [anon_sym_GT_GT] = ACTIONS(6460),
    [anon_sym_LBRACK] = ACTIONS(6462),
    [anon_sym_EQ] = ACTIONS(6460),
    [anon_sym_QMARK] = ACTIONS(6462),
    [anon_sym_STAR_EQ] = ACTIONS(6462),
    [anon_sym_SLASH_EQ] = ACTIONS(6462),
    [anon_sym_PERCENT_EQ] = ACTIONS(6462),
    [anon_sym_PLUS_EQ] = ACTIONS(6462),
    [anon_sym_DASH_EQ] = ACTIONS(6462),
    [anon_sym_LT_LT_EQ] = ACTIONS(6462),
    [anon_sym_GT_GT_EQ] = ACTIONS(6462),
    [anon_sym_AMP_EQ] = ACTIONS(6462),
    [anon_sym_CARET_EQ] = ACTIONS(6462),
    [anon_sym_PIPE_EQ] = ACTIONS(6462),
    [anon_sym_and_eq] = ACTIONS(6460),
    [anon_sym_or_eq] = ACTIONS(6460),
    [anon_sym_xor_eq] = ACTIONS(6460),
    [anon_sym_LT_EQ_GT] = ACTIONS(6462),
    [anon_sym_or] = ACTIONS(6460),
    [anon_sym_and] = ACTIONS(6460),
    [anon_sym_bitor] = ACTIONS(6460),
    [anon_sym_xor] = ACTIONS(6460),
    [anon_sym_bitand] = ACTIONS(6460),
    [anon_sym_not_eq] = ACTIONS(6460),
    [anon_sym_is] = ACTIONS(6460),
    [anon_sym_as] = ACTIONS(6460),
    [anon_sym_DASH_DASH] = ACTIONS(6462),
    [anon_sym_PLUS_PLUS] = ACTIONS(6462),
    [anon_sym_DOT] = ACTIONS(6460),
    [anon_sym_DOT_STAR] = ACTIONS(6462),
    [anon_sym_DASH_GT] = ACTIONS(6460),
    [anon_sym_L_DQUOTE] = ACTIONS(6462),
    [anon_sym_u_DQUOTE] = ACTIONS(6462),
    [anon_sym_U_DQUOTE] = ACTIONS(6462),
    [anon_sym_u8_DQUOTE] = ACTIONS(6462),
    [anon_sym_DQUOTE] = ACTIONS(6462),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6462),
    [anon_sym_LR_DQUOTE] = ACTIONS(6462),
    [anon_sym_uR_DQUOTE] = ACTIONS(6462),
    [anon_sym_UR_DQUOTE] = ACTIONS(6462),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6462),
    [anon_sym_DASH_GT_STAR] = ACTIONS(6462),
    [sym_literal_suffix] = ACTIONS(6460),
  },
  [3199] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3214),
    [sym_identifier] = ACTIONS(2856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3781),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_DASH] = ACTIONS(3778),
    [anon_sym_PLUS] = ACTIONS(3778),
    [anon_sym_STAR] = ACTIONS(3778),
    [anon_sym_SLASH] = ACTIONS(3778),
    [anon_sym_PERCENT] = ACTIONS(3778),
    [anon_sym_PIPE_PIPE] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_PIPE] = ACTIONS(3778),
    [anon_sym_CARET] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_GT] = ACTIONS(3778),
    [anon_sym_GT_EQ] = ACTIONS(3778),
    [anon_sym_LT_EQ] = ACTIONS(3778),
    [anon_sym_LT] = ACTIONS(3778),
    [anon_sym_LT_LT] = ACTIONS(3778),
    [anon_sym_GT_GT] = ACTIONS(3778),
    [anon_sym___attribute__] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_signed] = ACTIONS(6967),
    [anon_sym_unsigned] = ACTIONS(6967),
    [anon_sym_long] = ACTIONS(6967),
    [anon_sym_short] = ACTIONS(6967),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3778),
    [sym_primitive_type] = ACTIONS(2856),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_STAR_EQ] = ACTIONS(3781),
    [anon_sym_SLASH_EQ] = ACTIONS(3781),
    [anon_sym_PERCENT_EQ] = ACTIONS(3781),
    [anon_sym_PLUS_EQ] = ACTIONS(3781),
    [anon_sym_DASH_EQ] = ACTIONS(3781),
    [anon_sym_LT_LT_EQ] = ACTIONS(3781),
    [anon_sym_GT_GT_EQ] = ACTIONS(3778),
    [anon_sym_AMP_EQ] = ACTIONS(3781),
    [anon_sym_CARET_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_and_eq] = ACTIONS(3778),
    [anon_sym_or_eq] = ACTIONS(3778),
    [anon_sym_xor_eq] = ACTIONS(3778),
    [anon_sym_LT_EQ_GT] = ACTIONS(3781),
    [anon_sym_or] = ACTIONS(3778),
    [anon_sym_and] = ACTIONS(3778),
    [anon_sym_bitor] = ACTIONS(3778),
    [anon_sym_xor] = ACTIONS(3778),
    [anon_sym_bitand] = ACTIONS(3778),
    [anon_sym_not_eq] = ACTIONS(3778),
    [anon_sym_is] = ACTIONS(3778),
    [anon_sym_as] = ACTIONS(3778),
    [anon_sym_DASH_DASH] = ACTIONS(3781),
    [anon_sym_PLUS_PLUS] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(3778),
    [anon_sym_DOT_STAR] = ACTIONS(3781),
    [anon_sym_DASH_GT] = ACTIONS(3781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3778),
    [anon_sym_let] = ACTIONS(3778),
    [anon_sym_This] = ACTIONS(3778),
    [anon_sym_GT2] = ACTIONS(3781),
  },
  [3200] = {
    [sym_identifier] = ACTIONS(6970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6972),
    [anon_sym_COMMA] = ACTIONS(6972),
    [anon_sym_RPAREN] = ACTIONS(6972),
    [aux_sym_preproc_if_token2] = ACTIONS(6972),
    [aux_sym_preproc_else_token1] = ACTIONS(6972),
    [aux_sym_preproc_elif_token1] = ACTIONS(6970),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6972),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6972),
    [anon_sym_LPAREN2] = ACTIONS(6972),
    [anon_sym_DASH] = ACTIONS(6970),
    [anon_sym_PLUS] = ACTIONS(6970),
    [anon_sym_STAR] = ACTIONS(6970),
    [anon_sym_SLASH] = ACTIONS(6970),
    [anon_sym_PERCENT] = ACTIONS(6970),
    [anon_sym_PIPE_PIPE] = ACTIONS(6972),
    [anon_sym_AMP_AMP] = ACTIONS(6972),
    [anon_sym_PIPE] = ACTIONS(6970),
    [anon_sym_CARET] = ACTIONS(6970),
    [anon_sym_AMP] = ACTIONS(6970),
    [anon_sym_EQ_EQ] = ACTIONS(6972),
    [anon_sym_BANG_EQ] = ACTIONS(6972),
    [anon_sym_GT] = ACTIONS(6970),
    [anon_sym_GT_EQ] = ACTIONS(6972),
    [anon_sym_LT_EQ] = ACTIONS(6970),
    [anon_sym_LT] = ACTIONS(6970),
    [anon_sym_LT_LT] = ACTIONS(6970),
    [anon_sym_GT_GT] = ACTIONS(6970),
    [anon_sym_COLON] = ACTIONS(6972),
    [anon_sym_SEMI] = ACTIONS(6972),
    [anon_sym___attribute__] = ACTIONS(6970),
    [anon_sym_LBRACE] = ACTIONS(6972),
    [anon_sym_RBRACE] = ACTIONS(6972),
    [anon_sym_LBRACK] = ACTIONS(6972),
    [anon_sym_RBRACK] = ACTIONS(6972),
    [anon_sym_EQ] = ACTIONS(6970),
    [anon_sym_QMARK] = ACTIONS(6972),
    [anon_sym_STAR_EQ] = ACTIONS(6972),
    [anon_sym_SLASH_EQ] = ACTIONS(6972),
    [anon_sym_PERCENT_EQ] = ACTIONS(6972),
    [anon_sym_PLUS_EQ] = ACTIONS(6972),
    [anon_sym_DASH_EQ] = ACTIONS(6972),
    [anon_sym_LT_LT_EQ] = ACTIONS(6972),
    [anon_sym_GT_GT_EQ] = ACTIONS(6972),
    [anon_sym_AMP_EQ] = ACTIONS(6972),
    [anon_sym_CARET_EQ] = ACTIONS(6972),
    [anon_sym_PIPE_EQ] = ACTIONS(6972),
    [anon_sym_and_eq] = ACTIONS(6970),
    [anon_sym_or_eq] = ACTIONS(6970),
    [anon_sym_xor_eq] = ACTIONS(6970),
    [anon_sym_LT_EQ_GT] = ACTIONS(6972),
    [anon_sym_or] = ACTIONS(6970),
    [anon_sym_and] = ACTIONS(6970),
    [anon_sym_bitor] = ACTIONS(6970),
    [anon_sym_xor] = ACTIONS(6970),
    [anon_sym_bitand] = ACTIONS(6970),
    [anon_sym_not_eq] = ACTIONS(6970),
    [anon_sym_is] = ACTIONS(6970),
    [anon_sym_as] = ACTIONS(6970),
    [anon_sym_DASH_DASH] = ACTIONS(6972),
    [anon_sym_PLUS_PLUS] = ACTIONS(6972),
    [anon_sym_DOT] = ACTIONS(6970),
    [anon_sym_DOT_STAR] = ACTIONS(6972),
    [anon_sym_DASH_GT] = ACTIONS(6972),
    [sym_comment] = ACTIONS(3),
  },
  [3201] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6462),
    [anon_sym_COMMA] = ACTIONS(6462),
    [anon_sym_LPAREN2] = ACTIONS(6462),
    [anon_sym_DASH] = ACTIONS(6460),
    [anon_sym_PLUS] = ACTIONS(6460),
    [anon_sym_STAR] = ACTIONS(6460),
    [anon_sym_SLASH] = ACTIONS(6460),
    [anon_sym_PERCENT] = ACTIONS(6460),
    [anon_sym_PIPE_PIPE] = ACTIONS(6462),
    [anon_sym_AMP_AMP] = ACTIONS(6462),
    [anon_sym_PIPE] = ACTIONS(6460),
    [anon_sym_CARET] = ACTIONS(6460),
    [anon_sym_AMP] = ACTIONS(6460),
    [anon_sym_EQ_EQ] = ACTIONS(6462),
    [anon_sym_BANG_EQ] = ACTIONS(6462),
    [anon_sym_GT] = ACTIONS(6460),
    [anon_sym_GT_EQ] = ACTIONS(6462),
    [anon_sym_LT_EQ] = ACTIONS(6460),
    [anon_sym_LT] = ACTIONS(6460),
    [anon_sym_LT_LT] = ACTIONS(6460),
    [anon_sym_GT_GT] = ACTIONS(6460),
    [anon_sym_SEMI] = ACTIONS(6462),
    [anon_sym___attribute__] = ACTIONS(6460),
    [anon_sym_LBRACK] = ACTIONS(6462),
    [anon_sym_EQ] = ACTIONS(6460),
    [anon_sym_QMARK] = ACTIONS(6462),
    [anon_sym_STAR_EQ] = ACTIONS(6462),
    [anon_sym_SLASH_EQ] = ACTIONS(6462),
    [anon_sym_PERCENT_EQ] = ACTIONS(6462),
    [anon_sym_PLUS_EQ] = ACTIONS(6462),
    [anon_sym_DASH_EQ] = ACTIONS(6462),
    [anon_sym_LT_LT_EQ] = ACTIONS(6462),
    [anon_sym_GT_GT_EQ] = ACTIONS(6462),
    [anon_sym_AMP_EQ] = ACTIONS(6462),
    [anon_sym_CARET_EQ] = ACTIONS(6462),
    [anon_sym_PIPE_EQ] = ACTIONS(6462),
    [anon_sym_and_eq] = ACTIONS(6460),
    [anon_sym_or_eq] = ACTIONS(6460),
    [anon_sym_xor_eq] = ACTIONS(6460),
    [anon_sym_LT_EQ_GT] = ACTIONS(6462),
    [anon_sym_or] = ACTIONS(6460),
    [anon_sym_and] = ACTIONS(6460),
    [anon_sym_bitor] = ACTIONS(6460),
    [anon_sym_xor] = ACTIONS(6460),
    [anon_sym_bitand] = ACTIONS(6460),
    [anon_sym_not_eq] = ACTIONS(6460),
    [anon_sym_is] = ACTIONS(6460),
    [anon_sym_as] = ACTIONS(6460),
    [anon_sym_DASH_DASH] = ACTIONS(6462),
    [anon_sym_PLUS_PLUS] = ACTIONS(6462),
    [anon_sym_DOT] = ACTIONS(6460),
    [anon_sym_DOT_STAR] = ACTIONS(6462),
    [anon_sym_DASH_GT] = ACTIONS(6462),
    [anon_sym_L_DQUOTE] = ACTIONS(6462),
    [anon_sym_u_DQUOTE] = ACTIONS(6462),
    [anon_sym_U_DQUOTE] = ACTIONS(6462),
    [anon_sym_u8_DQUOTE] = ACTIONS(6462),
    [anon_sym_DQUOTE] = ACTIONS(6462),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6462),
    [anon_sym_LR_DQUOTE] = ACTIONS(6462),
    [anon_sym_uR_DQUOTE] = ACTIONS(6462),
    [anon_sym_UR_DQUOTE] = ACTIONS(6462),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6462),
    [sym_literal_suffix] = ACTIONS(6460),
  },
  [3202] = {
    [sym_identifier] = ACTIONS(6974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6976),
    [anon_sym_COMMA] = ACTIONS(6976),
    [anon_sym_RPAREN] = ACTIONS(6976),
    [aux_sym_preproc_if_token2] = ACTIONS(6976),
    [aux_sym_preproc_else_token1] = ACTIONS(6976),
    [aux_sym_preproc_elif_token1] = ACTIONS(6974),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6976),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6976),
    [anon_sym_LPAREN2] = ACTIONS(6976),
    [anon_sym_DASH] = ACTIONS(6974),
    [anon_sym_PLUS] = ACTIONS(6974),
    [anon_sym_STAR] = ACTIONS(6974),
    [anon_sym_SLASH] = ACTIONS(6974),
    [anon_sym_PERCENT] = ACTIONS(6974),
    [anon_sym_PIPE_PIPE] = ACTIONS(6976),
    [anon_sym_AMP_AMP] = ACTIONS(6976),
    [anon_sym_PIPE] = ACTIONS(6974),
    [anon_sym_CARET] = ACTIONS(6974),
    [anon_sym_AMP] = ACTIONS(6974),
    [anon_sym_EQ_EQ] = ACTIONS(6976),
    [anon_sym_BANG_EQ] = ACTIONS(6976),
    [anon_sym_GT] = ACTIONS(6974),
    [anon_sym_GT_EQ] = ACTIONS(6976),
    [anon_sym_LT_EQ] = ACTIONS(6974),
    [anon_sym_LT] = ACTIONS(6974),
    [anon_sym_LT_LT] = ACTIONS(6974),
    [anon_sym_GT_GT] = ACTIONS(6974),
    [anon_sym_COLON] = ACTIONS(6976),
    [anon_sym_SEMI] = ACTIONS(6976),
    [anon_sym___attribute__] = ACTIONS(6974),
    [anon_sym_LBRACE] = ACTIONS(6976),
    [anon_sym_RBRACE] = ACTIONS(6976),
    [anon_sym_LBRACK] = ACTIONS(6976),
    [anon_sym_RBRACK] = ACTIONS(6976),
    [anon_sym_EQ] = ACTIONS(6974),
    [anon_sym_QMARK] = ACTIONS(6976),
    [anon_sym_STAR_EQ] = ACTIONS(6976),
    [anon_sym_SLASH_EQ] = ACTIONS(6976),
    [anon_sym_PERCENT_EQ] = ACTIONS(6976),
    [anon_sym_PLUS_EQ] = ACTIONS(6976),
    [anon_sym_DASH_EQ] = ACTIONS(6976),
    [anon_sym_LT_LT_EQ] = ACTIONS(6976),
    [anon_sym_GT_GT_EQ] = ACTIONS(6976),
    [anon_sym_AMP_EQ] = ACTIONS(6976),
    [anon_sym_CARET_EQ] = ACTIONS(6976),
    [anon_sym_PIPE_EQ] = ACTIONS(6976),
    [anon_sym_and_eq] = ACTIONS(6974),
    [anon_sym_or_eq] = ACTIONS(6974),
    [anon_sym_xor_eq] = ACTIONS(6974),
    [anon_sym_LT_EQ_GT] = ACTIONS(6976),
    [anon_sym_or] = ACTIONS(6974),
    [anon_sym_and] = ACTIONS(6974),
    [anon_sym_bitor] = ACTIONS(6974),
    [anon_sym_xor] = ACTIONS(6974),
    [anon_sym_bitand] = ACTIONS(6974),
    [anon_sym_not_eq] = ACTIONS(6974),
    [anon_sym_is] = ACTIONS(6974),
    [anon_sym_as] = ACTIONS(6974),
    [anon_sym_DASH_DASH] = ACTIONS(6976),
    [anon_sym_PLUS_PLUS] = ACTIONS(6976),
    [anon_sym_DOT] = ACTIONS(6974),
    [anon_sym_DOT_STAR] = ACTIONS(6976),
    [anon_sym_DASH_GT] = ACTIONS(6976),
    [sym_comment] = ACTIONS(3),
  },
  [3203] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3199),
    [sym_identifier] = ACTIONS(6978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3822),
    [anon_sym_COMMA] = ACTIONS(3822),
    [anon_sym_LPAREN2] = ACTIONS(3822),
    [anon_sym_DASH] = ACTIONS(3820),
    [anon_sym_PLUS] = ACTIONS(3820),
    [anon_sym_STAR] = ACTIONS(3820),
    [anon_sym_SLASH] = ACTIONS(3820),
    [anon_sym_PERCENT] = ACTIONS(3820),
    [anon_sym_PIPE_PIPE] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3822),
    [anon_sym_PIPE] = ACTIONS(3820),
    [anon_sym_CARET] = ACTIONS(3820),
    [anon_sym_AMP] = ACTIONS(3820),
    [anon_sym_EQ_EQ] = ACTIONS(3822),
    [anon_sym_BANG_EQ] = ACTIONS(3822),
    [anon_sym_GT] = ACTIONS(3820),
    [anon_sym_GT_EQ] = ACTIONS(3820),
    [anon_sym_LT_EQ] = ACTIONS(3820),
    [anon_sym_LT] = ACTIONS(3820),
    [anon_sym_LT_LT] = ACTIONS(3820),
    [anon_sym_GT_GT] = ACTIONS(3820),
    [anon_sym___attribute__] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3822),
    [anon_sym_signed] = ACTIONS(6980),
    [anon_sym_unsigned] = ACTIONS(6980),
    [anon_sym_long] = ACTIONS(6980),
    [anon_sym_short] = ACTIONS(6980),
    [anon_sym_LBRACK] = ACTIONS(3822),
    [anon_sym_EQ] = ACTIONS(3820),
    [sym_primitive_type] = ACTIONS(6982),
    [anon_sym_QMARK] = ACTIONS(3822),
    [anon_sym_STAR_EQ] = ACTIONS(3822),
    [anon_sym_SLASH_EQ] = ACTIONS(3822),
    [anon_sym_PERCENT_EQ] = ACTIONS(3822),
    [anon_sym_PLUS_EQ] = ACTIONS(3822),
    [anon_sym_DASH_EQ] = ACTIONS(3822),
    [anon_sym_LT_LT_EQ] = ACTIONS(3822),
    [anon_sym_GT_GT_EQ] = ACTIONS(3820),
    [anon_sym_AMP_EQ] = ACTIONS(3822),
    [anon_sym_CARET_EQ] = ACTIONS(3822),
    [anon_sym_PIPE_EQ] = ACTIONS(3822),
    [anon_sym_and_eq] = ACTIONS(3820),
    [anon_sym_or_eq] = ACTIONS(3820),
    [anon_sym_xor_eq] = ACTIONS(3820),
    [anon_sym_LT_EQ_GT] = ACTIONS(3822),
    [anon_sym_or] = ACTIONS(3820),
    [anon_sym_and] = ACTIONS(3820),
    [anon_sym_bitor] = ACTIONS(3820),
    [anon_sym_xor] = ACTIONS(3820),
    [anon_sym_bitand] = ACTIONS(3820),
    [anon_sym_not_eq] = ACTIONS(3820),
    [anon_sym_is] = ACTIONS(3820),
    [anon_sym_as] = ACTIONS(3820),
    [anon_sym_DASH_DASH] = ACTIONS(3822),
    [anon_sym_PLUS_PLUS] = ACTIONS(3822),
    [anon_sym_DOT] = ACTIONS(3820),
    [anon_sym_DOT_STAR] = ACTIONS(3822),
    [anon_sym_DASH_GT] = ACTIONS(3822),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3820),
    [anon_sym_let] = ACTIONS(3820),
    [anon_sym_This] = ACTIONS(3820),
    [anon_sym_GT2] = ACTIONS(3822),
  },
  [3204] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6513),
    [anon_sym_COMMA] = ACTIONS(6513),
    [anon_sym_RPAREN] = ACTIONS(6513),
    [anon_sym_LPAREN2] = ACTIONS(6513),
    [anon_sym_DASH] = ACTIONS(6511),
    [anon_sym_PLUS] = ACTIONS(6511),
    [anon_sym_STAR] = ACTIONS(6511),
    [anon_sym_SLASH] = ACTIONS(6511),
    [anon_sym_PERCENT] = ACTIONS(6511),
    [anon_sym_PIPE_PIPE] = ACTIONS(6513),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_PIPE] = ACTIONS(6511),
    [anon_sym_CARET] = ACTIONS(6511),
    [anon_sym_AMP] = ACTIONS(6511),
    [anon_sym_EQ_EQ] = ACTIONS(6513),
    [anon_sym_BANG_EQ] = ACTIONS(6513),
    [anon_sym_GT] = ACTIONS(6511),
    [anon_sym_GT_EQ] = ACTIONS(6513),
    [anon_sym_LT_EQ] = ACTIONS(6511),
    [anon_sym_LT] = ACTIONS(6511),
    [anon_sym_LT_LT] = ACTIONS(6511),
    [anon_sym_GT_GT] = ACTIONS(6511),
    [anon_sym_LBRACK] = ACTIONS(6513),
    [anon_sym_EQ] = ACTIONS(6511),
    [anon_sym_QMARK] = ACTIONS(6513),
    [anon_sym_STAR_EQ] = ACTIONS(6513),
    [anon_sym_SLASH_EQ] = ACTIONS(6513),
    [anon_sym_PERCENT_EQ] = ACTIONS(6513),
    [anon_sym_PLUS_EQ] = ACTIONS(6513),
    [anon_sym_DASH_EQ] = ACTIONS(6513),
    [anon_sym_LT_LT_EQ] = ACTIONS(6513),
    [anon_sym_GT_GT_EQ] = ACTIONS(6513),
    [anon_sym_AMP_EQ] = ACTIONS(6513),
    [anon_sym_CARET_EQ] = ACTIONS(6513),
    [anon_sym_PIPE_EQ] = ACTIONS(6513),
    [anon_sym_and_eq] = ACTIONS(6511),
    [anon_sym_or_eq] = ACTIONS(6511),
    [anon_sym_xor_eq] = ACTIONS(6511),
    [anon_sym_LT_EQ_GT] = ACTIONS(6513),
    [anon_sym_or] = ACTIONS(6511),
    [anon_sym_and] = ACTIONS(6511),
    [anon_sym_bitor] = ACTIONS(6511),
    [anon_sym_xor] = ACTIONS(6511),
    [anon_sym_bitand] = ACTIONS(6511),
    [anon_sym_not_eq] = ACTIONS(6511),
    [anon_sym_is] = ACTIONS(6511),
    [anon_sym_as] = ACTIONS(6511),
    [anon_sym_DASH_DASH] = ACTIONS(6513),
    [anon_sym_PLUS_PLUS] = ACTIONS(6513),
    [anon_sym_DOT] = ACTIONS(6511),
    [anon_sym_DOT_STAR] = ACTIONS(6513),
    [anon_sym_DASH_GT] = ACTIONS(6511),
    [anon_sym_L_DQUOTE] = ACTIONS(6513),
    [anon_sym_u_DQUOTE] = ACTIONS(6513),
    [anon_sym_U_DQUOTE] = ACTIONS(6513),
    [anon_sym_u8_DQUOTE] = ACTIONS(6513),
    [anon_sym_DQUOTE] = ACTIONS(6513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6513),
    [anon_sym_LR_DQUOTE] = ACTIONS(6513),
    [anon_sym_uR_DQUOTE] = ACTIONS(6513),
    [anon_sym_UR_DQUOTE] = ACTIONS(6513),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6513),
    [anon_sym_DASH_GT_STAR] = ACTIONS(6513),
    [sym_literal_suffix] = ACTIONS(6511),
  },
  [3205] = {
    [sym_argument_list] = STATE(3288),
    [sym_subscript_argument_list] = STATE(3292),
    [sym_identifier] = ACTIONS(6984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6986),
    [anon_sym_COMMA] = ACTIONS(6986),
    [anon_sym_RPAREN] = ACTIONS(6986),
    [aux_sym_preproc_if_token2] = ACTIONS(6986),
    [aux_sym_preproc_else_token1] = ACTIONS(6986),
    [aux_sym_preproc_elif_token1] = ACTIONS(6984),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6986),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6986),
    [anon_sym_LPAREN2] = ACTIONS(6568),
    [anon_sym_DASH] = ACTIONS(6984),
    [anon_sym_PLUS] = ACTIONS(6984),
    [anon_sym_STAR] = ACTIONS(6984),
    [anon_sym_SLASH] = ACTIONS(6984),
    [anon_sym_PERCENT] = ACTIONS(6984),
    [anon_sym_PIPE_PIPE] = ACTIONS(6986),
    [anon_sym_AMP_AMP] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(6984),
    [anon_sym_CARET] = ACTIONS(6984),
    [anon_sym_AMP] = ACTIONS(6984),
    [anon_sym_EQ_EQ] = ACTIONS(6986),
    [anon_sym_BANG_EQ] = ACTIONS(6986),
    [anon_sym_GT] = ACTIONS(6984),
    [anon_sym_GT_EQ] = ACTIONS(6986),
    [anon_sym_LT_EQ] = ACTIONS(6984),
    [anon_sym_LT] = ACTIONS(6984),
    [anon_sym_LT_LT] = ACTIONS(6984),
    [anon_sym_GT_GT] = ACTIONS(6984),
    [anon_sym_SEMI] = ACTIONS(6986),
    [anon_sym___attribute__] = ACTIONS(6984),
    [anon_sym_RBRACE] = ACTIONS(6986),
    [anon_sym_LBRACK] = ACTIONS(6988),
    [anon_sym_RBRACK] = ACTIONS(6986),
    [anon_sym_EQ] = ACTIONS(6984),
    [anon_sym_QMARK] = ACTIONS(6986),
    [anon_sym_STAR_EQ] = ACTIONS(6986),
    [anon_sym_SLASH_EQ] = ACTIONS(6986),
    [anon_sym_PERCENT_EQ] = ACTIONS(6986),
    [anon_sym_PLUS_EQ] = ACTIONS(6986),
    [anon_sym_DASH_EQ] = ACTIONS(6986),
    [anon_sym_LT_LT_EQ] = ACTIONS(6986),
    [anon_sym_GT_GT_EQ] = ACTIONS(6986),
    [anon_sym_AMP_EQ] = ACTIONS(6986),
    [anon_sym_CARET_EQ] = ACTIONS(6986),
    [anon_sym_PIPE_EQ] = ACTIONS(6986),
    [anon_sym_and_eq] = ACTIONS(6984),
    [anon_sym_or_eq] = ACTIONS(6984),
    [anon_sym_xor_eq] = ACTIONS(6984),
    [anon_sym_LT_EQ_GT] = ACTIONS(6986),
    [anon_sym_or] = ACTIONS(6984),
    [anon_sym_and] = ACTIONS(6984),
    [anon_sym_bitor] = ACTIONS(6984),
    [anon_sym_xor] = ACTIONS(6984),
    [anon_sym_bitand] = ACTIONS(6984),
    [anon_sym_not_eq] = ACTIONS(6984),
    [anon_sym_is] = ACTIONS(6984),
    [anon_sym_as] = ACTIONS(6984),
    [anon_sym_DASH_DASH] = ACTIONS(6990),
    [anon_sym_PLUS_PLUS] = ACTIONS(6990),
    [anon_sym_DOT] = ACTIONS(6992),
    [anon_sym_DOT_STAR] = ACTIONS(6994),
    [anon_sym_DASH_GT] = ACTIONS(6994),
    [sym_comment] = ACTIONS(3),
  },
  [3206] = {
    [sym_identifier] = ACTIONS(6511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6513),
    [anon_sym_COMMA] = ACTIONS(6513),
    [anon_sym_LPAREN2] = ACTIONS(6513),
    [anon_sym_DASH] = ACTIONS(6511),
    [anon_sym_PLUS] = ACTIONS(6511),
    [anon_sym_STAR] = ACTIONS(6511),
    [anon_sym_SLASH] = ACTIONS(6511),
    [anon_sym_PERCENT] = ACTIONS(6511),
    [anon_sym_PIPE_PIPE] = ACTIONS(6513),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_PIPE] = ACTIONS(6511),
    [anon_sym_CARET] = ACTIONS(6511),
    [anon_sym_AMP] = ACTIONS(6511),
    [anon_sym_EQ_EQ] = ACTIONS(6513),
    [anon_sym_BANG_EQ] = ACTIONS(6513),
    [anon_sym_GT] = ACTIONS(6511),
    [anon_sym_GT_EQ] = ACTIONS(6511),
    [anon_sym_LT_EQ] = ACTIONS(6511),
    [anon_sym_LT] = ACTIONS(6511),
    [anon_sym_LT_LT] = ACTIONS(6511),
    [anon_sym_GT_GT] = ACTIONS(6511),
    [anon_sym_LBRACK] = ACTIONS(6513),
    [anon_sym_EQ] = ACTIONS(6511),
    [anon_sym_QMARK] = ACTIONS(6513),
    [anon_sym_STAR_EQ] = ACTIONS(6513),
    [anon_sym_SLASH_EQ] = ACTIONS(6513),
    [anon_sym_PERCENT_EQ] = ACTIONS(6513),
    [anon_sym_PLUS_EQ] = ACTIONS(6513),
    [anon_sym_DASH_EQ] = ACTIONS(6513),
    [anon_sym_LT_LT_EQ] = ACTIONS(6513),
    [anon_sym_GT_GT_EQ] = ACTIONS(6511),
    [anon_sym_AMP_EQ] = ACTIONS(6513),
    [anon_sym_CARET_EQ] = ACTIONS(6513),
    [anon_sym_PIPE_EQ] = ACTIONS(6513),
    [anon_sym_and_eq] = ACTIONS(6511),
    [anon_sym_or_eq] = ACTIONS(6511),
    [anon_sym_xor_eq] = ACTIONS(6511),
    [anon_sym_LT_EQ_GT] = ACTIONS(6513),
    [anon_sym_or] = ACTIONS(6511),
    [anon_sym_and] = ACTIONS(6511),
    [anon_sym_bitor] = ACTIONS(6511),
    [anon_sym_xor] = ACTIONS(6511),
    [anon_sym_bitand] = ACTIONS(6511),
    [anon_sym_not_eq] = ACTIONS(6511),
    [anon_sym_is] = ACTIONS(6511),
    [anon_sym_as] = ACTIONS(6511),
    [anon_sym_DASH_DASH] = ACTIONS(6513),
    [anon_sym_PLUS_PLUS] = ACTIONS(6513),
    [anon_sym_DOT] = ACTIONS(6511),
    [anon_sym_DOT_STAR] = ACTIONS(6513),
    [anon_sym_DASH_GT] = ACTIONS(6513),
    [anon_sym_L_DQUOTE] = ACTIONS(6513),
    [anon_sym_u_DQUOTE] = ACTIONS(6513),
    [anon_sym_U_DQUOTE] = ACTIONS(6513),
    [anon_sym_u8_DQUOTE] = ACTIONS(6513),
    [anon_sym_DQUOTE] = ACTIONS(6513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(6513),
    [anon_sym_R_DQUOTE] = ACTIONS(6513),
    [anon_sym_LR_DQUOTE] = ACTIONS(6513),
    [anon_sym_uR_DQUOTE] = ACTIONS(6513),
    [anon_sym_UR_DQUOTE] = ACTIONS(6513),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6513),
    [sym_literal_suffix] = ACTIONS(6511),
  },
  [3207] = {
    [sym_template_argument_list] = STATE(3167),
    [sym_identifier] = ACTIONS(6996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6998),
    [anon_sym_COMMA] = ACTIONS(6998),
    [anon_sym_RPAREN] = ACTIONS(6998),
    [aux_sym_preproc_if_token2] = ACTIONS(6998),
    [aux_sym_preproc_else_token1] = ACTIONS(6998),
    [aux_sym_preproc_elif_token1] = ACTIONS(6996),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6998),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6998),
    [anon_sym_LPAREN2] = ACTIONS(6998),
    [anon_sym_DASH] = ACTIONS(6996),
    [anon_sym_PLUS] = ACTIONS(6996),
    [anon_sym_STAR] = ACTIONS(6996),
    [anon_sym_SLASH] = ACTIONS(6996),
    [anon_sym_PERCENT] = ACTIONS(6996),
    [anon_sym_PIPE_PIPE] = ACTIONS(6998),
    [anon_sym_AMP_AMP] = ACTIONS(6998),
    [anon_sym_PIPE] = ACTIONS(6996),
    [anon_sym_CARET] = ACTIONS(6996),
    [anon_sym_AMP] = ACTIONS(6996),
    [anon_sym_EQ_EQ] = ACTIONS(6998),
    [anon_sym_BANG_EQ] = ACTIONS(6998),
    [anon_sym_GT] = ACTIONS(6996),
    [anon_sym_GT_EQ] = ACTIONS(6998),
    [anon_sym_LT_EQ] = ACTIONS(6996),
    [anon_sym_LT] = ACTIONS(7000),
    [anon_sym_LT_LT] = ACTIONS(6996),
    [anon_sym_GT_GT] = ACTIONS(6996),
    [anon_sym_COLON] = ACTIONS(6998),
    [anon_sym_SEMI] = ACTIONS(6998),
    [anon_sym___attribute__] = ACTIONS(6996),
    [anon_sym_RBRACE] = ACTIONS(6998),
    [anon_sym_LBRACK] = ACTIONS(6998),
    [anon_sym_RBRACK] = ACTIONS(6998),
    [anon_sym_EQ] = ACTIONS(6996),
    [anon_sym_QMARK] = ACTIONS(6998),
    [anon_sym_STAR_EQ] = ACTIONS(6998),
    [anon_sym_SLASH_EQ] = ACTIONS(6998),
    [anon_sym_PERCENT_EQ] = ACTIONS(6998),
    [anon_sym_PLUS_EQ] = ACTIONS(6998),
    [anon_sym_DASH_EQ] = ACTIONS(6998),
    [anon_sym_LT_LT_EQ] = ACTIONS(6998),
    [anon_sym_GT_GT_EQ] = ACTIONS(6998),
    [anon_sym_AMP_EQ] = ACTIONS(6998),
    [anon_sym_CARET_EQ] = ACTIONS(6998),
    [anon_sym_PIPE_EQ] = ACTIONS(6998),
    [anon_sym_and_eq] = ACTIONS(6996),
    [anon_sym_or_eq] = ACTIONS(6996),
    [anon_sym_xor_eq] = ACTIONS(6996),
    [anon_sym_LT_EQ_GT] = ACTIONS(6998),
    [anon_sym_or] = ACTIONS(6996),
    [anon_sym_and] = ACTIONS(6996),
    [anon_sym_bitor] = ACTIONS(6996),
    [anon_sym_xor] = ACTIONS(6996),
    [anon_sym_bitand] = ACTIONS(6996),
    [anon_sym_not_eq] = ACTIONS(6996),
    [anon_sym_is] = ACTIONS(6996),
    [anon_sym_as] = ACTIONS(6996),
    [anon_sym_DASH_DASH] = ACTIONS(6998),
    [anon_sym_PLUS_PLUS] = ACTIONS(6998),
    [anon_sym_DOT] = ACTIONS(6996),
    [anon_sym_DOT_STAR] = ACTIONS(6998),
    [anon_sym_DASH_GT] = ACTIONS(6998),
    [sym_comment] = ACTIONS(3),
  },
  [3208] = {
    [sym_identifier] = ACTIONS(6524),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6526),
    [anon_sym_COMMA] = ACTIONS(6526),
    [anon_sym_LPAREN2] = ACTIONS(6526),
    [anon_sym_DASH] = ACTIONS(6524),
    [anon_sym_PLUS] = ACTIONS(6524),
    [anon_sym_STAR] = ACTIONS(6524),
    [anon_sym_SLASH] = ACTIONS(6524),
    [anon_sym_PERCENT] = ACTIONS(6524),
    [anon_sym_PIPE_PIPE] = ACTIONS(6526),
    [anon_sym_AMP_AMP] = ACTIONS(6526),
    [anon_sym_PIPE] = ACTIONS(6524),
    [anon_sym_CARET] = ACTIONS(6524),
    [anon_sym_AMP] = ACTIONS(6524),
    [anon_sym_EQ_EQ] = ACTIONS(6526),
    [anon_sym_BANG_EQ] = ACTIONS(6526),
    [anon_sym_GT] = ACTIONS(6524),
    [anon_sym_GT_EQ] = ACTIONS(6524),
    [anon_sym_LT_EQ] = ACTIONS(6524),
    [anon_sym_LT] = ACTIONS(6524),
    [anon_sym_LT_LT] = ACTIONS(6524),
    [anon_sym_GT_GT] = ACTIONS(6524),
    [anon_sym_LBRACK] = ACTIONS(6526),
    [anon_sym_EQ] = ACTIONS(6524),
    [anon_sym_QMARK] = ACTIONS(6526),
    [anon_sym_STAR_EQ] = ACTIONS(6526),
    [anon_sym_SLASH_EQ] = ACTIONS(6526),
    [anon_sym_PERCENT_EQ] = ACTIONS(6526),
    [anon_sym_PLUS_EQ] = ACTIONS(6526),
    [anon_sym_DASH_EQ] = ACTIONS(6526),
    [anon_sym_LT_LT_EQ] = ACTIONS(6526),
    [anon_sym_GT_GT_EQ] = ACTIONS(6524),
    [anon_sym_AMP_EQ] = ACTIONS(6526),
    [anon_sym_CARET_EQ] = ACTIONS(6526),
    [anon_sym_PIPE_EQ] = ACTIONS(6526),
    [anon_sym_and_eq] = ACTIONS(6524),
    [anon_sym_or_eq] = ACTIONS(6524),
    [anon_sym_xor_eq] = ACTIONS(6524),
    [anon_sym_LT_EQ_GT] = ACTIONS(6526),
    [anon_sym_or] = ACTIONS(6524),
    [anon_sym_and] = ACTIONS(6524),
    [anon_sym_bitor] = ACTIONS(6524),
    [anon_sym_xor] = ACTIONS(6524),
    [anon_sym_bitand] = ACTIONS(6524),
    [anon_sym_not_eq] = ACTIONS(6524),
    [anon_sym_is] = ACTIONS(6524),
    [anon_sym_as] = ACTIONS(6524),
    [anon_sym_DASH_DASH] = ACTIONS(6526),
    [anon_sym_PLUS_PLUS] = ACTIONS(6526),
    [anon_sym_DOT] = ACTIONS(6524),
    [anon_sym_DOT_STAR] = ACTIONS(6526),
    [anon_sym_DASH_GT] = ACTIONS(6526),
    [anon_sym_L_DQUOTE] = ACTIONS(6526),
    [anon_sym_u_DQUOTE] = ACTIONS(6526),
    [anon_sym_U_DQUOTE] = ACTIONS(6526),
    [anon_sym_u8_DQUOTE] = ACTIONS(6526),
    [anon_sym_DQUOTE] = ACTIONS(6526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(6526),
    [anon_sym_R_DQUOTE] = ACTIONS(6526),
    [anon_sym_LR_DQUOTE] = ACTIONS(6526),
    [anon_sym_uR_DQUOTE] = ACTIONS(6526),
    [anon_sym_UR_DQUOTE] = ACTIONS(6526),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6526),
    [sym_literal_suffix] = ACTIONS(6524),
  },
  [3209] = {
    [sym_identifier] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7005),
    [anon_sym_COMMA] = ACTIONS(7005),
    [anon_sym_RPAREN] = ACTIONS(7005),
    [aux_sym_preproc_if_token2] = ACTIONS(7005),
    [aux_sym_preproc_else_token1] = ACTIONS(7005),
    [aux_sym_preproc_elif_token1] = ACTIONS(7003),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7005),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7005),
    [anon_sym_LPAREN2] = ACTIONS(7005),
    [anon_sym_DASH] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_STAR] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7005),
    [anon_sym_AMP_AMP] = ACTIONS(7005),
    [anon_sym_PIPE] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7005),
    [anon_sym_BANG_EQ] = ACTIONS(7005),
    [anon_sym_GT] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7005),
    [anon_sym_LT_EQ] = ACTIONS(7003),
    [anon_sym_LT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_COLON] = ACTIONS(7005),
    [anon_sym_SEMI] = ACTIONS(7005),
    [anon_sym___attribute__] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7005),
    [anon_sym_RBRACE] = ACTIONS(7005),
    [anon_sym_LBRACK] = ACTIONS(7005),
    [anon_sym_RBRACK] = ACTIONS(7005),
    [anon_sym_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7005),
    [anon_sym_STAR_EQ] = ACTIONS(7005),
    [anon_sym_SLASH_EQ] = ACTIONS(7005),
    [anon_sym_PERCENT_EQ] = ACTIONS(7005),
    [anon_sym_PLUS_EQ] = ACTIONS(7005),
    [anon_sym_DASH_EQ] = ACTIONS(7005),
    [anon_sym_LT_LT_EQ] = ACTIONS(7005),
    [anon_sym_GT_GT_EQ] = ACTIONS(7005),
    [anon_sym_AMP_EQ] = ACTIONS(7005),
    [anon_sym_CARET_EQ] = ACTIONS(7005),
    [anon_sym_PIPE_EQ] = ACTIONS(7005),
    [anon_sym_and_eq] = ACTIONS(7003),
    [anon_sym_or_eq] = ACTIONS(7003),
    [anon_sym_xor_eq] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7005),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_bitor] = ACTIONS(7003),
    [anon_sym_xor] = ACTIONS(7003),
    [anon_sym_bitand] = ACTIONS(7003),
    [anon_sym_not_eq] = ACTIONS(7003),
    [anon_sym_is] = ACTIONS(7003),
    [anon_sym_as] = ACTIONS(7003),
    [anon_sym_DASH_DASH] = ACTIONS(7005),
    [anon_sym_PLUS_PLUS] = ACTIONS(7005),
    [anon_sym_DOT] = ACTIONS(7003),
    [anon_sym_DOT_STAR] = ACTIONS(7005),
    [anon_sym_DASH_GT] = ACTIONS(7005),
    [sym_comment] = ACTIONS(3),
  },
  [3210] = {
    [sym_identifier] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7005),
    [anon_sym_COMMA] = ACTIONS(7005),
    [anon_sym_RPAREN] = ACTIONS(7005),
    [aux_sym_preproc_if_token2] = ACTIONS(7005),
    [aux_sym_preproc_else_token1] = ACTIONS(7005),
    [aux_sym_preproc_elif_token1] = ACTIONS(7003),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7005),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7005),
    [anon_sym_LPAREN2] = ACTIONS(7005),
    [anon_sym_DASH] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_STAR] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7005),
    [anon_sym_AMP_AMP] = ACTIONS(7005),
    [anon_sym_PIPE] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7005),
    [anon_sym_BANG_EQ] = ACTIONS(7005),
    [anon_sym_GT] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7005),
    [anon_sym_LT_EQ] = ACTIONS(7003),
    [anon_sym_LT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_COLON] = ACTIONS(7005),
    [anon_sym_SEMI] = ACTIONS(7005),
    [anon_sym___attribute__] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7005),
    [anon_sym_RBRACE] = ACTIONS(7005),
    [anon_sym_LBRACK] = ACTIONS(7005),
    [anon_sym_RBRACK] = ACTIONS(7005),
    [anon_sym_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7005),
    [anon_sym_STAR_EQ] = ACTIONS(7005),
    [anon_sym_SLASH_EQ] = ACTIONS(7005),
    [anon_sym_PERCENT_EQ] = ACTIONS(7005),
    [anon_sym_PLUS_EQ] = ACTIONS(7005),
    [anon_sym_DASH_EQ] = ACTIONS(7005),
    [anon_sym_LT_LT_EQ] = ACTIONS(7005),
    [anon_sym_GT_GT_EQ] = ACTIONS(7005),
    [anon_sym_AMP_EQ] = ACTIONS(7005),
    [anon_sym_CARET_EQ] = ACTIONS(7005),
    [anon_sym_PIPE_EQ] = ACTIONS(7005),
    [anon_sym_and_eq] = ACTIONS(7003),
    [anon_sym_or_eq] = ACTIONS(7003),
    [anon_sym_xor_eq] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7005),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_bitor] = ACTIONS(7003),
    [anon_sym_xor] = ACTIONS(7003),
    [anon_sym_bitand] = ACTIONS(7003),
    [anon_sym_not_eq] = ACTIONS(7003),
    [anon_sym_is] = ACTIONS(7003),
    [anon_sym_as] = ACTIONS(7003),
    [anon_sym_DASH_DASH] = ACTIONS(7005),
    [anon_sym_PLUS_PLUS] = ACTIONS(7005),
    [anon_sym_DOT] = ACTIONS(7003),
    [anon_sym_DOT_STAR] = ACTIONS(7005),
    [anon_sym_DASH_GT] = ACTIONS(7005),
    [sym_comment] = ACTIONS(3),
  },
  [3211] = {
    [sym_identifier] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7005),
    [anon_sym_COMMA] = ACTIONS(7005),
    [anon_sym_RPAREN] = ACTIONS(7005),
    [aux_sym_preproc_if_token2] = ACTIONS(7005),
    [aux_sym_preproc_else_token1] = ACTIONS(7005),
    [aux_sym_preproc_elif_token1] = ACTIONS(7003),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7005),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7005),
    [anon_sym_LPAREN2] = ACTIONS(7005),
    [anon_sym_DASH] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_STAR] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7005),
    [anon_sym_AMP_AMP] = ACTIONS(7005),
    [anon_sym_PIPE] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7005),
    [anon_sym_BANG_EQ] = ACTIONS(7005),
    [anon_sym_GT] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7005),
    [anon_sym_LT_EQ] = ACTIONS(7003),
    [anon_sym_LT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_COLON] = ACTIONS(7005),
    [anon_sym_SEMI] = ACTIONS(7005),
    [anon_sym___attribute__] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7005),
    [anon_sym_RBRACE] = ACTIONS(7005),
    [anon_sym_LBRACK] = ACTIONS(7005),
    [anon_sym_RBRACK] = ACTIONS(7005),
    [anon_sym_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7005),
    [anon_sym_STAR_EQ] = ACTIONS(7005),
    [anon_sym_SLASH_EQ] = ACTIONS(7005),
    [anon_sym_PERCENT_EQ] = ACTIONS(7005),
    [anon_sym_PLUS_EQ] = ACTIONS(7005),
    [anon_sym_DASH_EQ] = ACTIONS(7005),
    [anon_sym_LT_LT_EQ] = ACTIONS(7005),
    [anon_sym_GT_GT_EQ] = ACTIONS(7005),
    [anon_sym_AMP_EQ] = ACTIONS(7005),
    [anon_sym_CARET_EQ] = ACTIONS(7005),
    [anon_sym_PIPE_EQ] = ACTIONS(7005),
    [anon_sym_and_eq] = ACTIONS(7003),
    [anon_sym_or_eq] = ACTIONS(7003),
    [anon_sym_xor_eq] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7005),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_bitor] = ACTIONS(7003),
    [anon_sym_xor] = ACTIONS(7003),
    [anon_sym_bitand] = ACTIONS(7003),
    [anon_sym_not_eq] = ACTIONS(7003),
    [anon_sym_is] = ACTIONS(7003),
    [anon_sym_as] = ACTIONS(7003),
    [anon_sym_DASH_DASH] = ACTIONS(7005),
    [anon_sym_PLUS_PLUS] = ACTIONS(7005),
    [anon_sym_DOT] = ACTIONS(7003),
    [anon_sym_DOT_STAR] = ACTIONS(7005),
    [anon_sym_DASH_GT] = ACTIONS(7005),
    [sym_comment] = ACTIONS(3),
  },
  [3212] = {
    [sym_argument_list] = STATE(3288),
    [sym_subscript_argument_list] = STATE(3292),
    [sym_identifier] = ACTIONS(7007),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7009),
    [anon_sym_COMMA] = ACTIONS(7009),
    [anon_sym_RPAREN] = ACTIONS(7009),
    [aux_sym_preproc_if_token2] = ACTIONS(7009),
    [aux_sym_preproc_else_token1] = ACTIONS(7009),
    [aux_sym_preproc_elif_token1] = ACTIONS(7007),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7009),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7009),
    [anon_sym_LPAREN2] = ACTIONS(6568),
    [anon_sym_DASH] = ACTIONS(7007),
    [anon_sym_PLUS] = ACTIONS(7007),
    [anon_sym_STAR] = ACTIONS(7007),
    [anon_sym_SLASH] = ACTIONS(7007),
    [anon_sym_PERCENT] = ACTIONS(7007),
    [anon_sym_PIPE_PIPE] = ACTIONS(7009),
    [anon_sym_AMP_AMP] = ACTIONS(7009),
    [anon_sym_PIPE] = ACTIONS(7007),
    [anon_sym_CARET] = ACTIONS(7007),
    [anon_sym_AMP] = ACTIONS(7007),
    [anon_sym_EQ_EQ] = ACTIONS(7009),
    [anon_sym_BANG_EQ] = ACTIONS(7009),
    [anon_sym_GT] = ACTIONS(7007),
    [anon_sym_GT_EQ] = ACTIONS(7009),
    [anon_sym_LT_EQ] = ACTIONS(7007),
    [anon_sym_LT] = ACTIONS(7007),
    [anon_sym_LT_LT] = ACTIONS(7007),
    [anon_sym_GT_GT] = ACTIONS(7007),
    [anon_sym_SEMI] = ACTIONS(7009),
    [anon_sym___attribute__] = ACTIONS(7007),
    [anon_sym_RBRACE] = ACTIONS(7009),
    [anon_sym_LBRACK] = ACTIONS(6988),
    [anon_sym_RBRACK] = ACTIONS(7009),
    [anon_sym_EQ] = ACTIONS(7007),
    [anon_sym_QMARK] = ACTIONS(7009),
    [anon_sym_STAR_EQ] = ACTIONS(7009),
    [anon_sym_SLASH_EQ] = ACTIONS(7009),
    [anon_sym_PERCENT_EQ] = ACTIONS(7009),
    [anon_sym_PLUS_EQ] = ACTIONS(7009),
    [anon_sym_DASH_EQ] = ACTIONS(7009),
    [anon_sym_LT_LT_EQ] = ACTIONS(7009),
    [anon_sym_GT_GT_EQ] = ACTIONS(7009),
    [anon_sym_AMP_EQ] = ACTIONS(7009),
    [anon_sym_CARET_EQ] = ACTIONS(7009),
    [anon_sym_PIPE_EQ] = ACTIONS(7009),
    [anon_sym_and_eq] = ACTIONS(7007),
    [anon_sym_or_eq] = ACTIONS(7007),
    [anon_sym_xor_eq] = ACTIONS(7007),
    [anon_sym_LT_EQ_GT] = ACTIONS(7009),
    [anon_sym_or] = ACTIONS(7007),
    [anon_sym_and] = ACTIONS(7007),
    [anon_sym_bitor] = ACTIONS(7007),
    [anon_sym_xor] = ACTIONS(7007),
    [anon_sym_bitand] = ACTIONS(7007),
    [anon_sym_not_eq] = ACTIONS(7007),
    [anon_sym_is] = ACTIONS(7007),
    [anon_sym_as] = ACTIONS(7007),
    [anon_sym_DASH_DASH] = ACTIONS(6990),
    [anon_sym_PLUS_PLUS] = ACTIONS(6990),
    [anon_sym_DOT] = ACTIONS(6992),
    [anon_sym_DOT_STAR] = ACTIONS(6994),
    [anon_sym_DASH_GT] = ACTIONS(6994),
    [sym_comment] = ACTIONS(3),
  },
  [3213] = {
    [sym_argument_list] = STATE(3288),
    [sym_subscript_argument_list] = STATE(3292),
    [sym_identifier] = ACTIONS(7011),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7013),
    [anon_sym_COMMA] = ACTIONS(7013),
    [anon_sym_RPAREN] = ACTIONS(7013),
    [aux_sym_preproc_if_token2] = ACTIONS(7013),
    [aux_sym_preproc_else_token1] = ACTIONS(7013),
    [aux_sym_preproc_elif_token1] = ACTIONS(7011),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7013),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7013),
    [anon_sym_LPAREN2] = ACTIONS(6568),
    [anon_sym_DASH] = ACTIONS(7011),
    [anon_sym_PLUS] = ACTIONS(7011),
    [anon_sym_STAR] = ACTIONS(7011),
    [anon_sym_SLASH] = ACTIONS(7011),
    [anon_sym_PERCENT] = ACTIONS(7011),
    [anon_sym_PIPE_PIPE] = ACTIONS(7013),
    [anon_sym_AMP_AMP] = ACTIONS(7013),
    [anon_sym_PIPE] = ACTIONS(7011),
    [anon_sym_CARET] = ACTIONS(7011),
    [anon_sym_AMP] = ACTIONS(7011),
    [anon_sym_EQ_EQ] = ACTIONS(7013),
    [anon_sym_BANG_EQ] = ACTIONS(7013),
    [anon_sym_GT] = ACTIONS(7011),
    [anon_sym_GT_EQ] = ACTIONS(7013),
    [anon_sym_LT_EQ] = ACTIONS(7011),
    [anon_sym_LT] = ACTIONS(7011),
    [anon_sym_LT_LT] = ACTIONS(7011),
    [anon_sym_GT_GT] = ACTIONS(7011),
    [anon_sym_SEMI] = ACTIONS(7013),
    [anon_sym___attribute__] = ACTIONS(7011),
    [anon_sym_RBRACE] = ACTIONS(7013),
    [anon_sym_LBRACK] = ACTIONS(6988),
    [anon_sym_RBRACK] = ACTIONS(7013),
    [anon_sym_EQ] = ACTIONS(7011),
    [anon_sym_QMARK] = ACTIONS(7013),
    [anon_sym_STAR_EQ] = ACTIONS(7013),
    [anon_sym_SLASH_EQ] = ACTIONS(7013),
    [anon_sym_PERCENT_EQ] = ACTIONS(7013),
    [anon_sym_PLUS_EQ] = ACTIONS(7013),
    [anon_sym_DASH_EQ] = ACTIONS(7013),
    [anon_sym_LT_LT_EQ] = ACTIONS(7013),
    [anon_sym_GT_GT_EQ] = ACTIONS(7013),
    [anon_sym_AMP_EQ] = ACTIONS(7013),
    [anon_sym_CARET_EQ] = ACTIONS(7013),
    [anon_sym_PIPE_EQ] = ACTIONS(7013),
    [anon_sym_and_eq] = ACTIONS(7011),
    [anon_sym_or_eq] = ACTIONS(7011),
    [anon_sym_xor_eq] = ACTIONS(7011),
    [anon_sym_LT_EQ_GT] = ACTIONS(7013),
    [anon_sym_or] = ACTIONS(7011),
    [anon_sym_and] = ACTIONS(7011),
    [anon_sym_bitor] = ACTIONS(7011),
    [anon_sym_xor] = ACTIONS(7011),
    [anon_sym_bitand] = ACTIONS(7011),
    [anon_sym_not_eq] = ACTIONS(7011),
    [anon_sym_is] = ACTIONS(7011),
    [anon_sym_as] = ACTIONS(7011),
    [anon_sym_DASH_DASH] = ACTIONS(7013),
    [anon_sym_PLUS_PLUS] = ACTIONS(7013),
    [anon_sym_DOT] = ACTIONS(6992),
    [anon_sym_DOT_STAR] = ACTIONS(6994),
    [anon_sym_DASH_GT] = ACTIONS(6994),
    [sym_comment] = ACTIONS(3),
  },
  [3214] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3214),
    [sym_identifier] = ACTIONS(2856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2854),
    [anon_sym_COMMA] = ACTIONS(2854),
    [anon_sym_LPAREN2] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(2856),
    [anon_sym_PLUS] = ACTIONS(2856),
    [anon_sym_STAR] = ACTIONS(2856),
    [anon_sym_SLASH] = ACTIONS(2856),
    [anon_sym_PERCENT] = ACTIONS(2856),
    [anon_sym_PIPE_PIPE] = ACTIONS(2854),
    [anon_sym_AMP_AMP] = ACTIONS(2854),
    [anon_sym_PIPE] = ACTIONS(2856),
    [anon_sym_CARET] = ACTIONS(2856),
    [anon_sym_AMP] = ACTIONS(2856),
    [anon_sym_EQ_EQ] = ACTIONS(2854),
    [anon_sym_BANG_EQ] = ACTIONS(2854),
    [anon_sym_GT] = ACTIONS(2856),
    [anon_sym_GT_EQ] = ACTIONS(2856),
    [anon_sym_LT_EQ] = ACTIONS(2856),
    [anon_sym_LT] = ACTIONS(2856),
    [anon_sym_LT_LT] = ACTIONS(2856),
    [anon_sym_GT_GT] = ACTIONS(2856),
    [anon_sym___attribute__] = ACTIONS(2856),
    [anon_sym_LBRACE] = ACTIONS(2854),
    [anon_sym_signed] = ACTIONS(6967),
    [anon_sym_unsigned] = ACTIONS(6967),
    [anon_sym_long] = ACTIONS(6967),
    [anon_sym_short] = ACTIONS(6967),
    [anon_sym_LBRACK] = ACTIONS(2854),
    [anon_sym_EQ] = ACTIONS(2856),
    [sym_primitive_type] = ACTIONS(2856),
    [anon_sym_QMARK] = ACTIONS(2854),
    [anon_sym_STAR_EQ] = ACTIONS(2854),
    [anon_sym_SLASH_EQ] = ACTIONS(2854),
    [anon_sym_PERCENT_EQ] = ACTIONS(2854),
    [anon_sym_PLUS_EQ] = ACTIONS(2854),
    [anon_sym_DASH_EQ] = ACTIONS(2854),
    [anon_sym_LT_LT_EQ] = ACTIONS(2854),
    [anon_sym_GT_GT_EQ] = ACTIONS(2856),
    [anon_sym_AMP_EQ] = ACTIONS(2854),
    [anon_sym_CARET_EQ] = ACTIONS(2854),
    [anon_sym_PIPE_EQ] = ACTIONS(2854),
    [anon_sym_and_eq] = ACTIONS(2856),
    [anon_sym_or_eq] = ACTIONS(2856),
    [anon_sym_xor_eq] = ACTIONS(2856),
    [anon_sym_LT_EQ_GT] = ACTIONS(2854),
    [anon_sym_or] = ACTIONS(2856),
    [anon_sym_and] = ACTIONS(2856),
    [anon_sym_bitor] = ACTIONS(2856),
    [anon_sym_xor] = ACTIONS(2856),
    [anon_sym_bitand] = ACTIONS(2856),
    [anon_sym_not_eq] = ACTIONS(2856),
    [anon_sym_is] = ACTIONS(2856),
    [anon_sym_as] = ACTIONS(2856),
    [anon_sym_DASH_DASH] = ACTIONS(2854),
    [anon_sym_PLUS_PLUS] = ACTIONS(2854),
    [anon_sym_DOT] = ACTIONS(2856),
    [anon_sym_DOT_STAR] = ACTIONS(2854),
    [anon_sym_DASH_GT] = ACTIONS(2854),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2856),
    [anon_sym_let] = ACTIONS(2856),
    [anon_sym_This] = ACTIONS(2856),
    [anon_sym_GT2] = ACTIONS(2854),
  },
  [3215] = {
    [sym_argument_list] = STATE(3288),
    [sym_subscript_argument_list] = STATE(3292),
    [sym_identifier] = ACTIONS(7015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7017),
    [anon_sym_COMMA] = ACTIONS(7017),
    [anon_sym_RPAREN] = ACTIONS(7017),
    [aux_sym_preproc_if_token2] = ACTIONS(7017),
    [aux_sym_preproc_else_token1] = ACTIONS(7017),
    [aux_sym_preproc_elif_token1] = ACTIONS(7015),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7017),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7017),
    [anon_sym_LPAREN2] = ACTIONS(6568),
    [anon_sym_DASH] = ACTIONS(7015),
    [anon_sym_PLUS] = ACTIONS(7015),
    [anon_sym_STAR] = ACTIONS(7015),
    [anon_sym_SLASH] = ACTIONS(7015),
    [anon_sym_PERCENT] = ACTIONS(7015),
    [anon_sym_PIPE_PIPE] = ACTIONS(7017),
    [anon_sym_AMP_AMP] = ACTIONS(7017),
    [anon_sym_PIPE] = ACTIONS(7015),
    [anon_sym_CARET] = ACTIONS(7015),
    [anon_sym_AMP] = ACTIONS(7015),
    [anon_sym_EQ_EQ] = ACTIONS(7017),
    [anon_sym_BANG_EQ] = ACTIONS(7017),
    [anon_sym_GT] = ACTIONS(7015),
    [anon_sym_GT_EQ] = ACTIONS(7017),
    [anon_sym_LT_EQ] = ACTIONS(7015),
    [anon_sym_LT] = ACTIONS(7015),
    [anon_sym_LT_LT] = ACTIONS(7015),
    [anon_sym_GT_GT] = ACTIONS(7015),
    [anon_sym_SEMI] = ACTIONS(7017),
    [anon_sym___attribute__] = ACTIONS(7015),
    [anon_sym_RBRACE] = ACTIONS(7017),
    [anon_sym_LBRACK] = ACTIONS(6988),
    [anon_sym_RBRACK] = ACTIONS(7017),
    [anon_sym_EQ] = ACTIONS(7015),
    [anon_sym_QMARK] = ACTIONS(7017),
    [anon_sym_STAR_EQ] = ACTIONS(7017),
    [anon_sym_SLASH_EQ] = ACTIONS(7017),
    [anon_sym_PERCENT_EQ] = ACTIONS(7017),
    [anon_sym_PLUS_EQ] = ACTIONS(7017),
    [anon_sym_DASH_EQ] = ACTIONS(7017),
    [anon_sym_LT_LT_EQ] = ACTIONS(7017),
    [anon_sym_GT_GT_EQ] = ACTIONS(7017),
    [anon_sym_AMP_EQ] = ACTIONS(7017),
    [anon_sym_CARET_EQ] = ACTIONS(7017),
    [anon_sym_PIPE_EQ] = ACTIONS(7017),
    [anon_sym_and_eq] = ACTIONS(7015),
    [anon_sym_or_eq] = ACTIONS(7015),
    [anon_sym_xor_eq] = ACTIONS(7015),
    [anon_sym_LT_EQ_GT] = ACTIONS(7017),
    [anon_sym_or] = ACTIONS(7015),
    [anon_sym_and] = ACTIONS(7015),
    [anon_sym_bitor] = ACTIONS(7015),
    [anon_sym_xor] = ACTIONS(7015),
    [anon_sym_bitand] = ACTIONS(7015),
    [anon_sym_not_eq] = ACTIONS(7015),
    [anon_sym_is] = ACTIONS(7015),
    [anon_sym_as] = ACTIONS(7015),
    [anon_sym_DASH_DASH] = ACTIONS(6990),
    [anon_sym_PLUS_PLUS] = ACTIONS(6990),
    [anon_sym_DOT] = ACTIONS(6992),
    [anon_sym_DOT_STAR] = ACTIONS(6994),
    [anon_sym_DASH_GT] = ACTIONS(6994),
    [sym_comment] = ACTIONS(3),
  },
  [3216] = {
    [sym_identifier] = ACTIONS(7019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7021),
    [anon_sym_COMMA] = ACTIONS(7021),
    [anon_sym_RPAREN] = ACTIONS(7021),
    [aux_sym_preproc_if_token2] = ACTIONS(7021),
    [aux_sym_preproc_else_token1] = ACTIONS(7021),
    [aux_sym_preproc_elif_token1] = ACTIONS(7019),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7021),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7021),
    [anon_sym_LPAREN2] = ACTIONS(7021),
    [anon_sym_DASH] = ACTIONS(7019),
    [anon_sym_PLUS] = ACTIONS(7019),
    [anon_sym_STAR] = ACTIONS(7019),
    [anon_sym_SLASH] = ACTIONS(7019),
    [anon_sym_PERCENT] = ACTIONS(7019),
    [anon_sym_PIPE_PIPE] = ACTIONS(7021),
    [anon_sym_AMP_AMP] = ACTIONS(7021),
    [anon_sym_PIPE] = ACTIONS(7019),
    [anon_sym_CARET] = ACTIONS(7019),
    [anon_sym_AMP] = ACTIONS(7019),
    [anon_sym_EQ_EQ] = ACTIONS(7021),
    [anon_sym_BANG_EQ] = ACTIONS(7021),
    [anon_sym_GT] = ACTIONS(7019),
    [anon_sym_GT_EQ] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(7019),
    [anon_sym_LT] = ACTIONS(7019),
    [anon_sym_LT_LT] = ACTIONS(7019),
    [anon_sym_GT_GT] = ACTIONS(7019),
    [anon_sym_COLON] = ACTIONS(7021),
    [anon_sym_SEMI] = ACTIONS(7021),
    [anon_sym___attribute__] = ACTIONS(7019),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7021),
    [anon_sym_RBRACE] = ACTIONS(7021),
    [anon_sym_LBRACK] = ACTIONS(7019),
    [anon_sym_RBRACK] = ACTIONS(7021),
    [anon_sym_EQ] = ACTIONS(7019),
    [anon_sym_QMARK] = ACTIONS(7021),
    [anon_sym_STAR_EQ] = ACTIONS(7021),
    [anon_sym_SLASH_EQ] = ACTIONS(7021),
    [anon_sym_PERCENT_EQ] = ACTIONS(7021),
    [anon_sym_PLUS_EQ] = ACTIONS(7021),
    [anon_sym_DASH_EQ] = ACTIONS(7021),
    [anon_sym_LT_LT_EQ] = ACTIONS(7021),
    [anon_sym_GT_GT_EQ] = ACTIONS(7021),
    [anon_sym_AMP_EQ] = ACTIONS(7021),
    [anon_sym_CARET_EQ] = ACTIONS(7021),
    [anon_sym_PIPE_EQ] = ACTIONS(7021),
    [anon_sym_and_eq] = ACTIONS(7019),
    [anon_sym_or_eq] = ACTIONS(7019),
    [anon_sym_xor_eq] = ACTIONS(7019),
    [anon_sym_LT_EQ_GT] = ACTIONS(7021),
    [anon_sym_or] = ACTIONS(7019),
    [anon_sym_and] = ACTIONS(7019),
    [anon_sym_bitor] = ACTIONS(7019),
    [anon_sym_xor] = ACTIONS(7019),
    [anon_sym_bitand] = ACTIONS(7019),
    [anon_sym_not_eq] = ACTIONS(7019),
    [anon_sym_is] = ACTIONS(7019),
    [anon_sym_as] = ACTIONS(7019),
    [anon_sym_DASH_DASH] = ACTIONS(7021),
    [anon_sym_PLUS_PLUS] = ACTIONS(7021),
    [anon_sym_DOT] = ACTIONS(7019),
    [anon_sym_DOT_STAR] = ACTIONS(7021),
    [anon_sym_DASH_GT] = ACTIONS(7021),
    [sym_comment] = ACTIONS(3),
  },
  [3217] = {
    [sym_identifier] = ACTIONS(7023),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7025),
    [anon_sym_COMMA] = ACTIONS(7025),
    [anon_sym_RPAREN] = ACTIONS(7025),
    [aux_sym_preproc_if_token2] = ACTIONS(7025),
    [aux_sym_preproc_else_token1] = ACTIONS(7025),
    [aux_sym_preproc_elif_token1] = ACTIONS(7023),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7025),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7025),
    [anon_sym_LPAREN2] = ACTIONS(7025),
    [anon_sym_DASH] = ACTIONS(7023),
    [anon_sym_PLUS] = ACTIONS(7023),
    [anon_sym_STAR] = ACTIONS(7023),
    [anon_sym_SLASH] = ACTIONS(7023),
    [anon_sym_PERCENT] = ACTIONS(7023),
    [anon_sym_PIPE_PIPE] = ACTIONS(7025),
    [anon_sym_AMP_AMP] = ACTIONS(7025),
    [anon_sym_PIPE] = ACTIONS(7023),
    [anon_sym_CARET] = ACTIONS(7023),
    [anon_sym_AMP] = ACTIONS(7023),
    [anon_sym_EQ_EQ] = ACTIONS(7025),
    [anon_sym_BANG_EQ] = ACTIONS(7025),
    [anon_sym_GT] = ACTIONS(7023),
    [anon_sym_GT_EQ] = ACTIONS(7025),
    [anon_sym_LT_EQ] = ACTIONS(7023),
    [anon_sym_LT] = ACTIONS(7023),
    [anon_sym_LT_LT] = ACTIONS(7023),
    [anon_sym_GT_GT] = ACTIONS(7023),
    [anon_sym_COLON] = ACTIONS(7025),
    [anon_sym_SEMI] = ACTIONS(7025),
    [anon_sym___attribute__] = ACTIONS(7023),
    [anon_sym_RBRACE] = ACTIONS(7025),
    [anon_sym_LBRACK] = ACTIONS(7023),
    [anon_sym_RBRACK] = ACTIONS(7025),
    [anon_sym_EQ] = ACTIONS(7023),
    [anon_sym_QMARK] = ACTIONS(7025),
    [anon_sym_STAR_EQ] = ACTIONS(7025),
    [anon_sym_SLASH_EQ] = ACTIONS(7025),
    [anon_sym_PERCENT_EQ] = ACTIONS(7025),
    [anon_sym_PLUS_EQ] = ACTIONS(7025),
    [anon_sym_DASH_EQ] = ACTIONS(7025),
    [anon_sym_LT_LT_EQ] = ACTIONS(7025),
    [anon_sym_GT_GT_EQ] = ACTIONS(7025),
    [anon_sym_AMP_EQ] = ACTIONS(7025),
    [anon_sym_CARET_EQ] = ACTIONS(7025),
    [anon_sym_PIPE_EQ] = ACTIONS(7025),
    [anon_sym_and_eq] = ACTIONS(7023),
    [anon_sym_or_eq] = ACTIONS(7023),
    [anon_sym_xor_eq] = ACTIONS(7023),
    [anon_sym_LT_EQ_GT] = ACTIONS(7025),
    [anon_sym_or] = ACTIONS(7023),
    [anon_sym_and] = ACTIONS(7023),
    [anon_sym_bitor] = ACTIONS(7023),
    [anon_sym_xor] = ACTIONS(7023),
    [anon_sym_bitand] = ACTIONS(7023),
    [anon_sym_not_eq] = ACTIONS(7023),
    [anon_sym_is] = ACTIONS(7023),
    [anon_sym_as] = ACTIONS(7023),
    [anon_sym_DASH_DASH] = ACTIONS(7025),
    [anon_sym_PLUS_PLUS] = ACTIONS(7025),
    [anon_sym_DOT] = ACTIONS(7023),
    [anon_sym_DOT_STAR] = ACTIONS(7025),
    [anon_sym_DASH_GT] = ACTIONS(7025),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(7027),
  },
  [3218] = {
    [sym_identifier] = ACTIONS(7029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7031),
    [anon_sym_COMMA] = ACTIONS(7031),
    [anon_sym_RPAREN] = ACTIONS(7031),
    [aux_sym_preproc_if_token2] = ACTIONS(7031),
    [aux_sym_preproc_else_token1] = ACTIONS(7031),
    [aux_sym_preproc_elif_token1] = ACTIONS(7029),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7031),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7031),
    [anon_sym_LPAREN2] = ACTIONS(7031),
    [anon_sym_DASH] = ACTIONS(7029),
    [anon_sym_PLUS] = ACTIONS(7029),
    [anon_sym_STAR] = ACTIONS(7029),
    [anon_sym_SLASH] = ACTIONS(7029),
    [anon_sym_PERCENT] = ACTIONS(7029),
    [anon_sym_PIPE_PIPE] = ACTIONS(7031),
    [anon_sym_AMP_AMP] = ACTIONS(7031),
    [anon_sym_PIPE] = ACTIONS(7029),
    [anon_sym_CARET] = ACTIONS(7029),
    [anon_sym_AMP] = ACTIONS(7029),
    [anon_sym_EQ_EQ] = ACTIONS(7031),
    [anon_sym_BANG_EQ] = ACTIONS(7031),
    [anon_sym_GT] = ACTIONS(7029),
    [anon_sym_GT_EQ] = ACTIONS(7031),
    [anon_sym_LT_EQ] = ACTIONS(7029),
    [anon_sym_LT] = ACTIONS(7029),
    [anon_sym_LT_LT] = ACTIONS(7029),
    [anon_sym_GT_GT] = ACTIONS(7029),
    [anon_sym_COLON] = ACTIONS(7031),
    [anon_sym_SEMI] = ACTIONS(7031),
    [anon_sym___attribute__] = ACTIONS(7029),
    [anon_sym_LBRACE] = ACTIONS(7031),
    [anon_sym_RBRACE] = ACTIONS(7031),
    [anon_sym_LBRACK] = ACTIONS(7031),
    [anon_sym_RBRACK] = ACTIONS(7031),
    [anon_sym_EQ] = ACTIONS(7029),
    [anon_sym_QMARK] = ACTIONS(7031),
    [anon_sym_STAR_EQ] = ACTIONS(7031),
    [anon_sym_SLASH_EQ] = ACTIONS(7031),
    [anon_sym_PERCENT_EQ] = ACTIONS(7031),
    [anon_sym_PLUS_EQ] = ACTIONS(7031),
    [anon_sym_DASH_EQ] = ACTIONS(7031),
    [anon_sym_LT_LT_EQ] = ACTIONS(7031),
    [anon_sym_GT_GT_EQ] = ACTIONS(7031),
    [anon_sym_AMP_EQ] = ACTIONS(7031),
    [anon_sym_CARET_EQ] = ACTIONS(7031),
    [anon_sym_PIPE_EQ] = ACTIONS(7031),
    [anon_sym_and_eq] = ACTIONS(7029),
    [anon_sym_or_eq] = ACTIONS(7029),
    [anon_sym_xor_eq] = ACTIONS(7029),
    [anon_sym_LT_EQ_GT] = ACTIONS(7031),
    [anon_sym_or] = ACTIONS(7029),
    [anon_sym_and] = ACTIONS(7029),
    [anon_sym_bitor] = ACTIONS(7029),
    [anon_sym_xor] = ACTIONS(7029),
    [anon_sym_bitand] = ACTIONS(7029),
    [anon_sym_not_eq] = ACTIONS(7029),
    [anon_sym_is] = ACTIONS(7029),
    [anon_sym_as] = ACTIONS(7029),
    [anon_sym_DASH_DASH] = ACTIONS(7031),
    [anon_sym_PLUS_PLUS] = ACTIONS(7031),
    [anon_sym_DOT] = ACTIONS(7029),
    [anon_sym_DOT_STAR] = ACTIONS(7031),
    [anon_sym_DASH_GT] = ACTIONS(7031),
    [sym_comment] = ACTIONS(3),
  },
  [3219] = {
    [sym_identifier] = ACTIONS(7033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7035),
    [anon_sym_COMMA] = ACTIONS(7035),
    [anon_sym_RPAREN] = ACTIONS(7035),
    [aux_sym_preproc_if_token2] = ACTIONS(7035),
    [aux_sym_preproc_else_token1] = ACTIONS(7035),
    [aux_sym_preproc_elif_token1] = ACTIONS(7033),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7035),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7035),
    [anon_sym_LPAREN2] = ACTIONS(7035),
    [anon_sym_DASH] = ACTIONS(7033),
    [anon_sym_PLUS] = ACTIONS(7033),
    [anon_sym_STAR] = ACTIONS(7033),
    [anon_sym_SLASH] = ACTIONS(7033),
    [anon_sym_PERCENT] = ACTIONS(7033),
    [anon_sym_PIPE_PIPE] = ACTIONS(7035),
    [anon_sym_AMP_AMP] = ACTIONS(7035),
    [anon_sym_PIPE] = ACTIONS(7033),
    [anon_sym_CARET] = ACTIONS(7033),
    [anon_sym_AMP] = ACTIONS(7033),
    [anon_sym_EQ_EQ] = ACTIONS(7035),
    [anon_sym_BANG_EQ] = ACTIONS(7035),
    [anon_sym_GT] = ACTIONS(7033),
    [anon_sym_GT_EQ] = ACTIONS(7035),
    [anon_sym_LT_EQ] = ACTIONS(7033),
    [anon_sym_LT] = ACTIONS(7033),
    [anon_sym_LT_LT] = ACTIONS(7033),
    [anon_sym_GT_GT] = ACTIONS(7033),
    [anon_sym_COLON] = ACTIONS(7035),
    [anon_sym_SEMI] = ACTIONS(7035),
    [anon_sym___attribute__] = ACTIONS(7033),
    [anon_sym_LBRACE] = ACTIONS(7035),
    [anon_sym_RBRACE] = ACTIONS(7035),
    [anon_sym_LBRACK] = ACTIONS(7035),
    [anon_sym_RBRACK] = ACTIONS(7035),
    [anon_sym_EQ] = ACTIONS(7033),
    [anon_sym_QMARK] = ACTIONS(7035),
    [anon_sym_STAR_EQ] = ACTIONS(7035),
    [anon_sym_SLASH_EQ] = ACTIONS(7035),
    [anon_sym_PERCENT_EQ] = ACTIONS(7035),
    [anon_sym_PLUS_EQ] = ACTIONS(7035),
    [anon_sym_DASH_EQ] = ACTIONS(7035),
    [anon_sym_LT_LT_EQ] = ACTIONS(7035),
    [anon_sym_GT_GT_EQ] = ACTIONS(7035),
    [anon_sym_AMP_EQ] = ACTIONS(7035),
    [anon_sym_CARET_EQ] = ACTIONS(7035),
    [anon_sym_PIPE_EQ] = ACTIONS(7035),
    [anon_sym_and_eq] = ACTIONS(7033),
    [anon_sym_or_eq] = ACTIONS(7033),
    [anon_sym_xor_eq] = ACTIONS(7033),
    [anon_sym_LT_EQ_GT] = ACTIONS(7035),
    [anon_sym_or] = ACTIONS(7033),
    [anon_sym_and] = ACTIONS(7033),
    [anon_sym_bitor] = ACTIONS(7033),
    [anon_sym_xor] = ACTIONS(7033),
    [anon_sym_bitand] = ACTIONS(7033),
    [anon_sym_not_eq] = ACTIONS(7033),
    [anon_sym_is] = ACTIONS(7033),
    [anon_sym_as] = ACTIONS(7033),
    [anon_sym_DASH_DASH] = ACTIONS(7035),
    [anon_sym_PLUS_PLUS] = ACTIONS(7035),
    [anon_sym_DOT] = ACTIONS(7033),
    [anon_sym_DOT_STAR] = ACTIONS(7035),
    [anon_sym_DASH_GT] = ACTIONS(7035),
    [sym_comment] = ACTIONS(3),
  },
  [3220] = {
    [sym_attribute_specifier] = STATE(3098),
    [sym_enumerator_list] = STATE(3018),
    [sym__enum_base_clause] = STATE(2983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3350),
    [anon_sym_COMMA] = ACTIONS(3350),
    [anon_sym_RPAREN] = ACTIONS(3350),
    [anon_sym_LPAREN2] = ACTIONS(3350),
    [anon_sym_DASH] = ACTIONS(3348),
    [anon_sym_PLUS] = ACTIONS(3348),
    [anon_sym_STAR] = ACTIONS(3348),
    [anon_sym_SLASH] = ACTIONS(3348),
    [anon_sym_PERCENT] = ACTIONS(3348),
    [anon_sym_PIPE_PIPE] = ACTIONS(3350),
    [anon_sym_AMP_AMP] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3348),
    [anon_sym_CARET] = ACTIONS(3348),
    [anon_sym_AMP] = ACTIONS(3348),
    [anon_sym_EQ_EQ] = ACTIONS(3350),
    [anon_sym_BANG_EQ] = ACTIONS(3350),
    [anon_sym_GT] = ACTIONS(3348),
    [anon_sym_GT_EQ] = ACTIONS(3350),
    [anon_sym_LT_EQ] = ACTIONS(3348),
    [anon_sym_LT] = ACTIONS(3348),
    [anon_sym_LT_LT] = ACTIONS(3348),
    [anon_sym_GT_GT] = ACTIONS(3348),
    [anon_sym_COLON] = ACTIONS(6963),
    [anon_sym_SEMI] = ACTIONS(3350),
    [anon_sym___attribute__] = ACTIONS(6965),
    [anon_sym_LBRACE] = ACTIONS(6615),
    [anon_sym_RBRACE] = ACTIONS(3350),
    [anon_sym_LBRACK] = ACTIONS(3350),
    [anon_sym_RBRACK] = ACTIONS(3350),
    [anon_sym_EQ] = ACTIONS(3348),
    [anon_sym_QMARK] = ACTIONS(3350),
    [anon_sym_STAR_EQ] = ACTIONS(3350),
    [anon_sym_SLASH_EQ] = ACTIONS(3350),
    [anon_sym_PERCENT_EQ] = ACTIONS(3350),
    [anon_sym_PLUS_EQ] = ACTIONS(3350),
    [anon_sym_DASH_EQ] = ACTIONS(3350),
    [anon_sym_LT_LT_EQ] = ACTIONS(3350),
    [anon_sym_GT_GT_EQ] = ACTIONS(3350),
    [anon_sym_AMP_EQ] = ACTIONS(3350),
    [anon_sym_CARET_EQ] = ACTIONS(3350),
    [anon_sym_PIPE_EQ] = ACTIONS(3350),
    [anon_sym_and_eq] = ACTIONS(3350),
    [anon_sym_or_eq] = ACTIONS(3350),
    [anon_sym_xor_eq] = ACTIONS(3350),
    [anon_sym_LT_EQ_GT] = ACTIONS(3350),
    [anon_sym_or] = ACTIONS(3348),
    [anon_sym_and] = ACTIONS(3348),
    [anon_sym_bitor] = ACTIONS(3350),
    [anon_sym_xor] = ACTIONS(3348),
    [anon_sym_bitand] = ACTIONS(3350),
    [anon_sym_not_eq] = ACTIONS(3350),
    [anon_sym_is] = ACTIONS(3350),
    [anon_sym_as] = ACTIONS(3350),
    [anon_sym_DASH_DASH] = ACTIONS(3350),
    [anon_sym_PLUS_PLUS] = ACTIONS(3350),
    [anon_sym_DOT] = ACTIONS(3348),
    [anon_sym_DOT_STAR] = ACTIONS(3350),
    [anon_sym_DASH_GT] = ACTIONS(3350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3350),
    [anon_sym_let] = ACTIONS(3350),
    [anon_sym_This] = ACTIONS(3350),
  },
  [3221] = {
    [sym_identifier] = ACTIONS(6431),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6433),
    [anon_sym_COMMA] = ACTIONS(6433),
    [anon_sym_LPAREN2] = ACTIONS(6433),
    [anon_sym_DASH] = ACTIONS(6431),
    [anon_sym_PLUS] = ACTIONS(6431),
    [anon_sym_STAR] = ACTIONS(6431),
    [anon_sym_SLASH] = ACTIONS(6431),
    [anon_sym_PERCENT] = ACTIONS(6431),
    [anon_sym_PIPE_PIPE] = ACTIONS(6433),
    [anon_sym_AMP_AMP] = ACTIONS(6433),
    [anon_sym_PIPE] = ACTIONS(6431),
    [anon_sym_CARET] = ACTIONS(6431),
    [anon_sym_AMP] = ACTIONS(6431),
    [anon_sym_EQ_EQ] = ACTIONS(6433),
    [anon_sym_BANG_EQ] = ACTIONS(6433),
    [anon_sym_GT] = ACTIONS(6431),
    [anon_sym_GT_EQ] = ACTIONS(6431),
    [anon_sym_LT_EQ] = ACTIONS(6431),
    [anon_sym_LT] = ACTIONS(6431),
    [anon_sym_LT_LT] = ACTIONS(6431),
    [anon_sym_GT_GT] = ACTIONS(6431),
    [anon_sym_LBRACK] = ACTIONS(6433),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_QMARK] = ACTIONS(6433),
    [anon_sym_STAR_EQ] = ACTIONS(6433),
    [anon_sym_SLASH_EQ] = ACTIONS(6433),
    [anon_sym_PERCENT_EQ] = ACTIONS(6433),
    [anon_sym_PLUS_EQ] = ACTIONS(6433),
    [anon_sym_DASH_EQ] = ACTIONS(6433),
    [anon_sym_LT_LT_EQ] = ACTIONS(6433),
    [anon_sym_GT_GT_EQ] = ACTIONS(6431),
    [anon_sym_AMP_EQ] = ACTIONS(6433),
    [anon_sym_CARET_EQ] = ACTIONS(6433),
    [anon_sym_PIPE_EQ] = ACTIONS(6433),
    [anon_sym_and_eq] = ACTIONS(6431),
    [anon_sym_or_eq] = ACTIONS(6431),
    [anon_sym_xor_eq] = ACTIONS(6431),
    [anon_sym_LT_EQ_GT] = ACTIONS(6433),
    [anon_sym_or] = ACTIONS(6431),
    [anon_sym_and] = ACTIONS(6431),
    [anon_sym_bitor] = ACTIONS(6431),
    [anon_sym_xor] = ACTIONS(6431),
    [anon_sym_bitand] = ACTIONS(6431),
    [anon_sym_not_eq] = ACTIONS(6431),
    [anon_sym_is] = ACTIONS(6431),
    [anon_sym_as] = ACTIONS(6431),
    [anon_sym_DASH_DASH] = ACTIONS(6433),
    [anon_sym_PLUS_PLUS] = ACTIONS(6433),
    [anon_sym_DOT] = ACTIONS(6431),
    [anon_sym_DOT_STAR] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6433),
    [anon_sym_L_DQUOTE] = ACTIONS(6433),
    [anon_sym_u_DQUOTE] = ACTIONS(6433),
    [anon_sym_U_DQUOTE] = ACTIONS(6433),
    [anon_sym_u8_DQUOTE] = ACTIONS(6433),
    [anon_sym_DQUOTE] = ACTIONS(6433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(6433),
    [anon_sym_R_DQUOTE] = ACTIONS(6433),
    [anon_sym_LR_DQUOTE] = ACTIONS(6433),
    [anon_sym_uR_DQUOTE] = ACTIONS(6433),
    [anon_sym_UR_DQUOTE] = ACTIONS(6433),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6433),
    [sym_literal_suffix] = ACTIONS(6431),
  },
  [3222] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6513),
    [anon_sym_COMMA] = ACTIONS(6513),
    [anon_sym_LPAREN2] = ACTIONS(6513),
    [anon_sym_DASH] = ACTIONS(6511),
    [anon_sym_PLUS] = ACTIONS(6511),
    [anon_sym_STAR] = ACTIONS(6511),
    [anon_sym_SLASH] = ACTIONS(6511),
    [anon_sym_PERCENT] = ACTIONS(6511),
    [anon_sym_PIPE_PIPE] = ACTIONS(6513),
    [anon_sym_AMP_AMP] = ACTIONS(6513),
    [anon_sym_PIPE] = ACTIONS(6511),
    [anon_sym_CARET] = ACTIONS(6511),
    [anon_sym_AMP] = ACTIONS(6511),
    [anon_sym_EQ_EQ] = ACTIONS(6513),
    [anon_sym_BANG_EQ] = ACTIONS(6513),
    [anon_sym_GT] = ACTIONS(6511),
    [anon_sym_GT_EQ] = ACTIONS(6513),
    [anon_sym_LT_EQ] = ACTIONS(6511),
    [anon_sym_LT] = ACTIONS(6511),
    [anon_sym_LT_LT] = ACTIONS(6511),
    [anon_sym_GT_GT] = ACTIONS(6511),
    [anon_sym_SEMI] = ACTIONS(6513),
    [anon_sym___attribute__] = ACTIONS(6511),
    [anon_sym_LBRACK] = ACTIONS(6513),
    [anon_sym_EQ] = ACTIONS(6511),
    [anon_sym_QMARK] = ACTIONS(6513),
    [anon_sym_STAR_EQ] = ACTIONS(6513),
    [anon_sym_SLASH_EQ] = ACTIONS(6513),
    [anon_sym_PERCENT_EQ] = ACTIONS(6513),
    [anon_sym_PLUS_EQ] = ACTIONS(6513),
    [anon_sym_DASH_EQ] = ACTIONS(6513),
    [anon_sym_LT_LT_EQ] = ACTIONS(6513),
    [anon_sym_GT_GT_EQ] = ACTIONS(6513),
    [anon_sym_AMP_EQ] = ACTIONS(6513),
    [anon_sym_CARET_EQ] = ACTIONS(6513),
    [anon_sym_PIPE_EQ] = ACTIONS(6513),
    [anon_sym_and_eq] = ACTIONS(6511),
    [anon_sym_or_eq] = ACTIONS(6511),
    [anon_sym_xor_eq] = ACTIONS(6511),
    [anon_sym_LT_EQ_GT] = ACTIONS(6513),
    [anon_sym_or] = ACTIONS(6511),
    [anon_sym_and] = ACTIONS(6511),
    [anon_sym_bitor] = ACTIONS(6511),
    [anon_sym_xor] = ACTIONS(6511),
    [anon_sym_bitand] = ACTIONS(6511),
    [anon_sym_not_eq] = ACTIONS(6511),
    [anon_sym_is] = ACTIONS(6511),
    [anon_sym_as] = ACTIONS(6511),
    [anon_sym_DASH_DASH] = ACTIONS(6513),
    [anon_sym_PLUS_PLUS] = ACTIONS(6513),
    [anon_sym_DOT] = ACTIONS(6511),
    [anon_sym_DOT_STAR] = ACTIONS(6513),
    [anon_sym_DASH_GT] = ACTIONS(6513),
    [anon_sym_L_DQUOTE] = ACTIONS(6513),
    [anon_sym_u_DQUOTE] = ACTIONS(6513),
    [anon_sym_U_DQUOTE] = ACTIONS(6513),
    [anon_sym_u8_DQUOTE] = ACTIONS(6513),
    [anon_sym_DQUOTE] = ACTIONS(6513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6513),
    [anon_sym_LR_DQUOTE] = ACTIONS(6513),
    [anon_sym_uR_DQUOTE] = ACTIONS(6513),
    [anon_sym_UR_DQUOTE] = ACTIONS(6513),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6513),
    [sym_literal_suffix] = ACTIONS(6511),
  },
  [3223] = {
    [sym_identifier] = ACTIONS(4545),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4547),
    [anon_sym_COMMA] = ACTIONS(4547),
    [anon_sym_RPAREN] = ACTIONS(4547),
    [aux_sym_preproc_if_token2] = ACTIONS(4547),
    [aux_sym_preproc_else_token1] = ACTIONS(4547),
    [aux_sym_preproc_elif_token1] = ACTIONS(4545),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4547),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4547),
    [anon_sym_LPAREN2] = ACTIONS(4547),
    [anon_sym_DASH] = ACTIONS(4545),
    [anon_sym_PLUS] = ACTIONS(4545),
    [anon_sym_STAR] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(4545),
    [anon_sym_PERCENT] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4547),
    [anon_sym_PIPE] = ACTIONS(4545),
    [anon_sym_CARET] = ACTIONS(4545),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_EQ_EQ] = ACTIONS(4547),
    [anon_sym_BANG_EQ] = ACTIONS(4547),
    [anon_sym_GT] = ACTIONS(4545),
    [anon_sym_GT_EQ] = ACTIONS(4547),
    [anon_sym_LT_EQ] = ACTIONS(4545),
    [anon_sym_LT] = ACTIONS(4545),
    [anon_sym_LT_LT] = ACTIONS(4545),
    [anon_sym_GT_GT] = ACTIONS(4545),
    [anon_sym_COLON] = ACTIONS(4547),
    [anon_sym_SEMI] = ACTIONS(4547),
    [anon_sym___attribute__] = ACTIONS(4545),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4547),
    [anon_sym_RBRACE] = ACTIONS(4547),
    [anon_sym_LBRACK] = ACTIONS(4545),
    [anon_sym_RBRACK] = ACTIONS(4547),
    [anon_sym_EQ] = ACTIONS(4545),
    [anon_sym_QMARK] = ACTIONS(4547),
    [anon_sym_STAR_EQ] = ACTIONS(4547),
    [anon_sym_SLASH_EQ] = ACTIONS(4547),
    [anon_sym_PERCENT_EQ] = ACTIONS(4547),
    [anon_sym_PLUS_EQ] = ACTIONS(4547),
    [anon_sym_DASH_EQ] = ACTIONS(4547),
    [anon_sym_LT_LT_EQ] = ACTIONS(4547),
    [anon_sym_GT_GT_EQ] = ACTIONS(4547),
    [anon_sym_AMP_EQ] = ACTIONS(4547),
    [anon_sym_CARET_EQ] = ACTIONS(4547),
    [anon_sym_PIPE_EQ] = ACTIONS(4547),
    [anon_sym_and_eq] = ACTIONS(4545),
    [anon_sym_or_eq] = ACTIONS(4545),
    [anon_sym_xor_eq] = ACTIONS(4545),
    [anon_sym_LT_EQ_GT] = ACTIONS(4547),
    [anon_sym_or] = ACTIONS(4545),
    [anon_sym_and] = ACTIONS(4545),
    [anon_sym_bitor] = ACTIONS(4545),
    [anon_sym_xor] = ACTIONS(4545),
    [anon_sym_bitand] = ACTIONS(4545),
    [anon_sym_not_eq] = ACTIONS(4545),
    [anon_sym_is] = ACTIONS(4545),
    [anon_sym_as] = ACTIONS(4545),
    [anon_sym_DASH_DASH] = ACTIONS(4547),
    [anon_sym_PLUS_PLUS] = ACTIONS(4547),
    [anon_sym_DOT] = ACTIONS(4545),
    [anon_sym_DOT_STAR] = ACTIONS(4547),
    [anon_sym_DASH_GT] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
  },
  [3224] = {
    [sym_argument_list] = STATE(3288),
    [sym_subscript_argument_list] = STATE(3292),
    [sym_identifier] = ACTIONS(7037),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7039),
    [anon_sym_COMMA] = ACTIONS(7039),
    [anon_sym_RPAREN] = ACTIONS(7039),
    [aux_sym_preproc_if_token2] = ACTIONS(7039),
    [aux_sym_preproc_else_token1] = ACTIONS(7039),
    [aux_sym_preproc_elif_token1] = ACTIONS(7037),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7039),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7039),
    [anon_sym_LPAREN2] = ACTIONS(6568),
    [anon_sym_DASH] = ACTIONS(7037),
    [anon_sym_PLUS] = ACTIONS(7037),
    [anon_sym_STAR] = ACTIONS(7037),
    [anon_sym_SLASH] = ACTIONS(7037),
    [anon_sym_PERCENT] = ACTIONS(7037),
    [anon_sym_PIPE_PIPE] = ACTIONS(7039),
    [anon_sym_AMP_AMP] = ACTIONS(7039),
    [anon_sym_PIPE] = ACTIONS(7037),
    [anon_sym_CARET] = ACTIONS(7037),
    [anon_sym_AMP] = ACTIONS(7037),
    [anon_sym_EQ_EQ] = ACTIONS(7039),
    [anon_sym_BANG_EQ] = ACTIONS(7039),
    [anon_sym_GT] = ACTIONS(7037),
    [anon_sym_GT_EQ] = ACTIONS(7039),
    [anon_sym_LT_EQ] = ACTIONS(7037),
    [anon_sym_LT] = ACTIONS(7037),
    [anon_sym_LT_LT] = ACTIONS(7037),
    [anon_sym_GT_GT] = ACTIONS(7037),
    [anon_sym_SEMI] = ACTIONS(7039),
    [anon_sym___attribute__] = ACTIONS(7037),
    [anon_sym_RBRACE] = ACTIONS(7039),
    [anon_sym_LBRACK] = ACTIONS(6988),
    [anon_sym_RBRACK] = ACTIONS(7039),
    [anon_sym_EQ] = ACTIONS(7037),
    [anon_sym_QMARK] = ACTIONS(7039),
    [anon_sym_STAR_EQ] = ACTIONS(7039),
    [anon_sym_SLASH_EQ] = ACTIONS(7039),
    [anon_sym_PERCENT_EQ] = ACTIONS(7039),
    [anon_sym_PLUS_EQ] = ACTIONS(7039),
    [anon_sym_DASH_EQ] = ACTIONS(7039),
    [anon_sym_LT_LT_EQ] = ACTIONS(7039),
    [anon_sym_GT_GT_EQ] = ACTIONS(7039),
    [anon_sym_AMP_EQ] = ACTIONS(7039),
    [anon_sym_CARET_EQ] = ACTIONS(7039),
    [anon_sym_PIPE_EQ] = ACTIONS(7039),
    [anon_sym_and_eq] = ACTIONS(7037),
    [anon_sym_or_eq] = ACTIONS(7037),
    [anon_sym_xor_eq] = ACTIONS(7037),
    [anon_sym_LT_EQ_GT] = ACTIONS(7039),
    [anon_sym_or] = ACTIONS(7037),
    [anon_sym_and] = ACTIONS(7037),
    [anon_sym_bitor] = ACTIONS(7037),
    [anon_sym_xor] = ACTIONS(7037),
    [anon_sym_bitand] = ACTIONS(7037),
    [anon_sym_not_eq] = ACTIONS(7037),
    [anon_sym_is] = ACTIONS(7037),
    [anon_sym_as] = ACTIONS(7037),
    [anon_sym_DASH_DASH] = ACTIONS(6990),
    [anon_sym_PLUS_PLUS] = ACTIONS(6990),
    [anon_sym_DOT] = ACTIONS(6992),
    [anon_sym_DOT_STAR] = ACTIONS(6994),
    [anon_sym_DASH_GT] = ACTIONS(6994),
    [sym_comment] = ACTIONS(3),
  },
  [3225] = {
    [sym_argument_list] = STATE(3288),
    [sym_subscript_argument_list] = STATE(3292),
    [sym_identifier] = ACTIONS(7041),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7043),
    [anon_sym_COMMA] = ACTIONS(7043),
    [anon_sym_RPAREN] = ACTIONS(7043),
    [aux_sym_preproc_if_token2] = ACTIONS(7043),
    [aux_sym_preproc_else_token1] = ACTIONS(7043),
    [aux_sym_preproc_elif_token1] = ACTIONS(7041),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7043),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7043),
    [anon_sym_LPAREN2] = ACTIONS(6568),
    [anon_sym_DASH] = ACTIONS(7041),
    [anon_sym_PLUS] = ACTIONS(7041),
    [anon_sym_STAR] = ACTIONS(7041),
    [anon_sym_SLASH] = ACTIONS(7041),
    [anon_sym_PERCENT] = ACTIONS(7041),
    [anon_sym_PIPE_PIPE] = ACTIONS(7043),
    [anon_sym_AMP_AMP] = ACTIONS(7043),
    [anon_sym_PIPE] = ACTIONS(7041),
    [anon_sym_CARET] = ACTIONS(7041),
    [anon_sym_AMP] = ACTIONS(7041),
    [anon_sym_EQ_EQ] = ACTIONS(7043),
    [anon_sym_BANG_EQ] = ACTIONS(7043),
    [anon_sym_GT] = ACTIONS(7041),
    [anon_sym_GT_EQ] = ACTIONS(7043),
    [anon_sym_LT_EQ] = ACTIONS(7041),
    [anon_sym_LT] = ACTIONS(7041),
    [anon_sym_LT_LT] = ACTIONS(7041),
    [anon_sym_GT_GT] = ACTIONS(7041),
    [anon_sym_SEMI] = ACTIONS(7043),
    [anon_sym___attribute__] = ACTIONS(7041),
    [anon_sym_RBRACE] = ACTIONS(7043),
    [anon_sym_LBRACK] = ACTIONS(6988),
    [anon_sym_RBRACK] = ACTIONS(7043),
    [anon_sym_EQ] = ACTIONS(7041),
    [anon_sym_QMARK] = ACTIONS(7043),
    [anon_sym_STAR_EQ] = ACTIONS(7043),
    [anon_sym_SLASH_EQ] = ACTIONS(7043),
    [anon_sym_PERCENT_EQ] = ACTIONS(7043),
    [anon_sym_PLUS_EQ] = ACTIONS(7043),
    [anon_sym_DASH_EQ] = ACTIONS(7043),
    [anon_sym_LT_LT_EQ] = ACTIONS(7043),
    [anon_sym_GT_GT_EQ] = ACTIONS(7043),
    [anon_sym_AMP_EQ] = ACTIONS(7043),
    [anon_sym_CARET_EQ] = ACTIONS(7043),
    [anon_sym_PIPE_EQ] = ACTIONS(7043),
    [anon_sym_and_eq] = ACTIONS(7041),
    [anon_sym_or_eq] = ACTIONS(7041),
    [anon_sym_xor_eq] = ACTIONS(7041),
    [anon_sym_LT_EQ_GT] = ACTIONS(7043),
    [anon_sym_or] = ACTIONS(7041),
    [anon_sym_and] = ACTIONS(7041),
    [anon_sym_bitor] = ACTIONS(7041),
    [anon_sym_xor] = ACTIONS(7041),
    [anon_sym_bitand] = ACTIONS(7041),
    [anon_sym_not_eq] = ACTIONS(7041),
    [anon_sym_is] = ACTIONS(7041),
    [anon_sym_as] = ACTIONS(7041),
    [anon_sym_DASH_DASH] = ACTIONS(6990),
    [anon_sym_PLUS_PLUS] = ACTIONS(6990),
    [anon_sym_DOT] = ACTIONS(6992),
    [anon_sym_DOT_STAR] = ACTIONS(6994),
    [anon_sym_DASH_GT] = ACTIONS(6994),
    [sym_comment] = ACTIONS(3),
  },
  [3226] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6433),
    [anon_sym_COMMA] = ACTIONS(6433),
    [anon_sym_RPAREN] = ACTIONS(6433),
    [anon_sym_LPAREN2] = ACTIONS(6433),
    [anon_sym_DASH] = ACTIONS(6431),
    [anon_sym_PLUS] = ACTIONS(6431),
    [anon_sym_STAR] = ACTIONS(6431),
    [anon_sym_SLASH] = ACTIONS(6431),
    [anon_sym_PERCENT] = ACTIONS(6431),
    [anon_sym_PIPE_PIPE] = ACTIONS(6433),
    [anon_sym_AMP_AMP] = ACTIONS(6433),
    [anon_sym_PIPE] = ACTIONS(6431),
    [anon_sym_CARET] = ACTIONS(6431),
    [anon_sym_AMP] = ACTIONS(6431),
    [anon_sym_EQ_EQ] = ACTIONS(6433),
    [anon_sym_BANG_EQ] = ACTIONS(6433),
    [anon_sym_GT] = ACTIONS(6431),
    [anon_sym_GT_EQ] = ACTIONS(6433),
    [anon_sym_LT_EQ] = ACTIONS(6431),
    [anon_sym_LT] = ACTIONS(6431),
    [anon_sym_LT_LT] = ACTIONS(6431),
    [anon_sym_GT_GT] = ACTIONS(6431),
    [anon_sym_LBRACK] = ACTIONS(6433),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_QMARK] = ACTIONS(6433),
    [anon_sym_STAR_EQ] = ACTIONS(6433),
    [anon_sym_SLASH_EQ] = ACTIONS(6433),
    [anon_sym_PERCENT_EQ] = ACTIONS(6433),
    [anon_sym_PLUS_EQ] = ACTIONS(6433),
    [anon_sym_DASH_EQ] = ACTIONS(6433),
    [anon_sym_LT_LT_EQ] = ACTIONS(6433),
    [anon_sym_GT_GT_EQ] = ACTIONS(6433),
    [anon_sym_AMP_EQ] = ACTIONS(6433),
    [anon_sym_CARET_EQ] = ACTIONS(6433),
    [anon_sym_PIPE_EQ] = ACTIONS(6433),
    [anon_sym_and_eq] = ACTIONS(6431),
    [anon_sym_or_eq] = ACTIONS(6431),
    [anon_sym_xor_eq] = ACTIONS(6431),
    [anon_sym_LT_EQ_GT] = ACTIONS(6433),
    [anon_sym_or] = ACTIONS(6431),
    [anon_sym_and] = ACTIONS(6431),
    [anon_sym_bitor] = ACTIONS(6431),
    [anon_sym_xor] = ACTIONS(6431),
    [anon_sym_bitand] = ACTIONS(6431),
    [anon_sym_not_eq] = ACTIONS(6431),
    [anon_sym_is] = ACTIONS(6431),
    [anon_sym_as] = ACTIONS(6431),
    [anon_sym_DASH_DASH] = ACTIONS(6433),
    [anon_sym_PLUS_PLUS] = ACTIONS(6433),
    [anon_sym_DOT] = ACTIONS(6431),
    [anon_sym_DOT_STAR] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6431),
    [anon_sym_L_DQUOTE] = ACTIONS(6433),
    [anon_sym_u_DQUOTE] = ACTIONS(6433),
    [anon_sym_U_DQUOTE] = ACTIONS(6433),
    [anon_sym_u8_DQUOTE] = ACTIONS(6433),
    [anon_sym_DQUOTE] = ACTIONS(6433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6433),
    [anon_sym_LR_DQUOTE] = ACTIONS(6433),
    [anon_sym_uR_DQUOTE] = ACTIONS(6433),
    [anon_sym_UR_DQUOTE] = ACTIONS(6433),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6433),
    [anon_sym_DASH_GT_STAR] = ACTIONS(6433),
    [sym_literal_suffix] = ACTIONS(6431),
  },
  [3227] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6433),
    [anon_sym_COMMA] = ACTIONS(6433),
    [anon_sym_LPAREN2] = ACTIONS(6433),
    [anon_sym_DASH] = ACTIONS(6431),
    [anon_sym_PLUS] = ACTIONS(6431),
    [anon_sym_STAR] = ACTIONS(6431),
    [anon_sym_SLASH] = ACTIONS(6431),
    [anon_sym_PERCENT] = ACTIONS(6431),
    [anon_sym_PIPE_PIPE] = ACTIONS(6433),
    [anon_sym_AMP_AMP] = ACTIONS(6433),
    [anon_sym_PIPE] = ACTIONS(6431),
    [anon_sym_CARET] = ACTIONS(6431),
    [anon_sym_AMP] = ACTIONS(6431),
    [anon_sym_EQ_EQ] = ACTIONS(6433),
    [anon_sym_BANG_EQ] = ACTIONS(6433),
    [anon_sym_GT] = ACTIONS(6431),
    [anon_sym_GT_EQ] = ACTIONS(6433),
    [anon_sym_LT_EQ] = ACTIONS(6431),
    [anon_sym_LT] = ACTIONS(6431),
    [anon_sym_LT_LT] = ACTIONS(6431),
    [anon_sym_GT_GT] = ACTIONS(6431),
    [anon_sym_SEMI] = ACTIONS(6433),
    [anon_sym___attribute__] = ACTIONS(6431),
    [anon_sym_LBRACK] = ACTIONS(6433),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_QMARK] = ACTIONS(6433),
    [anon_sym_STAR_EQ] = ACTIONS(6433),
    [anon_sym_SLASH_EQ] = ACTIONS(6433),
    [anon_sym_PERCENT_EQ] = ACTIONS(6433),
    [anon_sym_PLUS_EQ] = ACTIONS(6433),
    [anon_sym_DASH_EQ] = ACTIONS(6433),
    [anon_sym_LT_LT_EQ] = ACTIONS(6433),
    [anon_sym_GT_GT_EQ] = ACTIONS(6433),
    [anon_sym_AMP_EQ] = ACTIONS(6433),
    [anon_sym_CARET_EQ] = ACTIONS(6433),
    [anon_sym_PIPE_EQ] = ACTIONS(6433),
    [anon_sym_and_eq] = ACTIONS(6431),
    [anon_sym_or_eq] = ACTIONS(6431),
    [anon_sym_xor_eq] = ACTIONS(6431),
    [anon_sym_LT_EQ_GT] = ACTIONS(6433),
    [anon_sym_or] = ACTIONS(6431),
    [anon_sym_and] = ACTIONS(6431),
    [anon_sym_bitor] = ACTIONS(6431),
    [anon_sym_xor] = ACTIONS(6431),
    [anon_sym_bitand] = ACTIONS(6431),
    [anon_sym_not_eq] = ACTIONS(6431),
    [anon_sym_is] = ACTIONS(6431),
    [anon_sym_as] = ACTIONS(6431),
    [anon_sym_DASH_DASH] = ACTIONS(6433),
    [anon_sym_PLUS_PLUS] = ACTIONS(6433),
    [anon_sym_DOT] = ACTIONS(6431),
    [anon_sym_DOT_STAR] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6433),
    [anon_sym_L_DQUOTE] = ACTIONS(6433),
    [anon_sym_u_DQUOTE] = ACTIONS(6433),
    [anon_sym_U_DQUOTE] = ACTIONS(6433),
    [anon_sym_u8_DQUOTE] = ACTIONS(6433),
    [anon_sym_DQUOTE] = ACTIONS(6433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6433),
    [anon_sym_LR_DQUOTE] = ACTIONS(6433),
    [anon_sym_uR_DQUOTE] = ACTIONS(6433),
    [anon_sym_UR_DQUOTE] = ACTIONS(6433),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6433),
    [sym_literal_suffix] = ACTIONS(6431),
  },
  [3228] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6526),
    [anon_sym_COMMA] = ACTIONS(6526),
    [anon_sym_LPAREN2] = ACTIONS(6526),
    [anon_sym_DASH] = ACTIONS(6524),
    [anon_sym_PLUS] = ACTIONS(6524),
    [anon_sym_STAR] = ACTIONS(6524),
    [anon_sym_SLASH] = ACTIONS(6524),
    [anon_sym_PERCENT] = ACTIONS(6524),
    [anon_sym_PIPE_PIPE] = ACTIONS(6526),
    [anon_sym_AMP_AMP] = ACTIONS(6526),
    [anon_sym_PIPE] = ACTIONS(6524),
    [anon_sym_CARET] = ACTIONS(6524),
    [anon_sym_AMP] = ACTIONS(6524),
    [anon_sym_EQ_EQ] = ACTIONS(6526),
    [anon_sym_BANG_EQ] = ACTIONS(6526),
    [anon_sym_GT] = ACTIONS(6524),
    [anon_sym_GT_EQ] = ACTIONS(6526),
    [anon_sym_LT_EQ] = ACTIONS(6524),
    [anon_sym_LT] = ACTIONS(6524),
    [anon_sym_LT_LT] = ACTIONS(6524),
    [anon_sym_GT_GT] = ACTIONS(6524),
    [anon_sym_SEMI] = ACTIONS(6526),
    [anon_sym___attribute__] = ACTIONS(6524),
    [anon_sym_LBRACK] = ACTIONS(6526),
    [anon_sym_EQ] = ACTIONS(6524),
    [anon_sym_QMARK] = ACTIONS(6526),
    [anon_sym_STAR_EQ] = ACTIONS(6526),
    [anon_sym_SLASH_EQ] = ACTIONS(6526),
    [anon_sym_PERCENT_EQ] = ACTIONS(6526),
    [anon_sym_PLUS_EQ] = ACTIONS(6526),
    [anon_sym_DASH_EQ] = ACTIONS(6526),
    [anon_sym_LT_LT_EQ] = ACTIONS(6526),
    [anon_sym_GT_GT_EQ] = ACTIONS(6526),
    [anon_sym_AMP_EQ] = ACTIONS(6526),
    [anon_sym_CARET_EQ] = ACTIONS(6526),
    [anon_sym_PIPE_EQ] = ACTIONS(6526),
    [anon_sym_and_eq] = ACTIONS(6524),
    [anon_sym_or_eq] = ACTIONS(6524),
    [anon_sym_xor_eq] = ACTIONS(6524),
    [anon_sym_LT_EQ_GT] = ACTIONS(6526),
    [anon_sym_or] = ACTIONS(6524),
    [anon_sym_and] = ACTIONS(6524),
    [anon_sym_bitor] = ACTIONS(6524),
    [anon_sym_xor] = ACTIONS(6524),
    [anon_sym_bitand] = ACTIONS(6524),
    [anon_sym_not_eq] = ACTIONS(6524),
    [anon_sym_is] = ACTIONS(6524),
    [anon_sym_as] = ACTIONS(6524),
    [anon_sym_DASH_DASH] = ACTIONS(6526),
    [anon_sym_PLUS_PLUS] = ACTIONS(6526),
    [anon_sym_DOT] = ACTIONS(6524),
    [anon_sym_DOT_STAR] = ACTIONS(6526),
    [anon_sym_DASH_GT] = ACTIONS(6526),
    [anon_sym_L_DQUOTE] = ACTIONS(6526),
    [anon_sym_u_DQUOTE] = ACTIONS(6526),
    [anon_sym_U_DQUOTE] = ACTIONS(6526),
    [anon_sym_u8_DQUOTE] = ACTIONS(6526),
    [anon_sym_DQUOTE] = ACTIONS(6526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6526),
    [anon_sym_LR_DQUOTE] = ACTIONS(6526),
    [anon_sym_uR_DQUOTE] = ACTIONS(6526),
    [anon_sym_UR_DQUOTE] = ACTIONS(6526),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6526),
    [sym_literal_suffix] = ACTIONS(6524),
  },
  [3229] = {
    [sym_argument_list] = STATE(3288),
    [sym_subscript_argument_list] = STATE(3292),
    [sym_identifier] = ACTIONS(7045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7047),
    [anon_sym_COMMA] = ACTIONS(7047),
    [anon_sym_RPAREN] = ACTIONS(7047),
    [aux_sym_preproc_if_token2] = ACTIONS(7047),
    [aux_sym_preproc_else_token1] = ACTIONS(7047),
    [aux_sym_preproc_elif_token1] = ACTIONS(7045),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7047),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7047),
    [anon_sym_LPAREN2] = ACTIONS(6568),
    [anon_sym_DASH] = ACTIONS(7045),
    [anon_sym_PLUS] = ACTIONS(7045),
    [anon_sym_STAR] = ACTIONS(7045),
    [anon_sym_SLASH] = ACTIONS(7045),
    [anon_sym_PERCENT] = ACTIONS(7045),
    [anon_sym_PIPE_PIPE] = ACTIONS(7047),
    [anon_sym_AMP_AMP] = ACTIONS(7047),
    [anon_sym_PIPE] = ACTIONS(7045),
    [anon_sym_CARET] = ACTIONS(7045),
    [anon_sym_AMP] = ACTIONS(7045),
    [anon_sym_EQ_EQ] = ACTIONS(7047),
    [anon_sym_BANG_EQ] = ACTIONS(7047),
    [anon_sym_GT] = ACTIONS(7045),
    [anon_sym_GT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ] = ACTIONS(7045),
    [anon_sym_LT] = ACTIONS(7045),
    [anon_sym_LT_LT] = ACTIONS(7045),
    [anon_sym_GT_GT] = ACTIONS(7045),
    [anon_sym_SEMI] = ACTIONS(7047),
    [anon_sym___attribute__] = ACTIONS(7045),
    [anon_sym_RBRACE] = ACTIONS(7047),
    [anon_sym_LBRACK] = ACTIONS(6988),
    [anon_sym_RBRACK] = ACTIONS(7047),
    [anon_sym_EQ] = ACTIONS(7045),
    [anon_sym_QMARK] = ACTIONS(7047),
    [anon_sym_STAR_EQ] = ACTIONS(7047),
    [anon_sym_SLASH_EQ] = ACTIONS(7047),
    [anon_sym_PERCENT_EQ] = ACTIONS(7047),
    [anon_sym_PLUS_EQ] = ACTIONS(7047),
    [anon_sym_DASH_EQ] = ACTIONS(7047),
    [anon_sym_LT_LT_EQ] = ACTIONS(7047),
    [anon_sym_GT_GT_EQ] = ACTIONS(7047),
    [anon_sym_AMP_EQ] = ACTIONS(7047),
    [anon_sym_CARET_EQ] = ACTIONS(7047),
    [anon_sym_PIPE_EQ] = ACTIONS(7047),
    [anon_sym_and_eq] = ACTIONS(7045),
    [anon_sym_or_eq] = ACTIONS(7045),
    [anon_sym_xor_eq] = ACTIONS(7045),
    [anon_sym_LT_EQ_GT] = ACTIONS(7047),
    [anon_sym_or] = ACTIONS(7045),
    [anon_sym_and] = ACTIONS(7045),
    [anon_sym_bitor] = ACTIONS(7045),
    [anon_sym_xor] = ACTIONS(7045),
    [anon_sym_bitand] = ACTIONS(7045),
    [anon_sym_not_eq] = ACTIONS(7045),
    [anon_sym_is] = ACTIONS(7045),
    [anon_sym_as] = ACTIONS(7045),
    [anon_sym_DASH_DASH] = ACTIONS(7047),
    [anon_sym_PLUS_PLUS] = ACTIONS(7047),
    [anon_sym_DOT] = ACTIONS(6992),
    [anon_sym_DOT_STAR] = ACTIONS(6994),
    [anon_sym_DASH_GT] = ACTIONS(6994),
    [sym_comment] = ACTIONS(3),
  },
  [3230] = {
    [sym_identifier] = ACTIONS(7049),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7051),
    [anon_sym_COMMA] = ACTIONS(7051),
    [anon_sym_RPAREN] = ACTIONS(7051),
    [aux_sym_preproc_if_token2] = ACTIONS(7051),
    [aux_sym_preproc_else_token1] = ACTIONS(7051),
    [aux_sym_preproc_elif_token1] = ACTIONS(7049),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7051),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7051),
    [anon_sym_LPAREN2] = ACTIONS(7051),
    [anon_sym_DASH] = ACTIONS(7049),
    [anon_sym_PLUS] = ACTIONS(7049),
    [anon_sym_STAR] = ACTIONS(7049),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_PIPE_PIPE] = ACTIONS(7051),
    [anon_sym_AMP_AMP] = ACTIONS(7051),
    [anon_sym_PIPE] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7049),
    [anon_sym_AMP] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7051),
    [anon_sym_BANG_EQ] = ACTIONS(7051),
    [anon_sym_GT] = ACTIONS(7049),
    [anon_sym_GT_EQ] = ACTIONS(7051),
    [anon_sym_LT_EQ] = ACTIONS(7049),
    [anon_sym_LT] = ACTIONS(7049),
    [anon_sym_LT_LT] = ACTIONS(7049),
    [anon_sym_GT_GT] = ACTIONS(7049),
    [anon_sym_COLON] = ACTIONS(7051),
    [anon_sym_SEMI] = ACTIONS(7051),
    [anon_sym___attribute__] = ACTIONS(7049),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7051),
    [anon_sym_RBRACE] = ACTIONS(7051),
    [anon_sym_LBRACK] = ACTIONS(7049),
    [anon_sym_RBRACK] = ACTIONS(7051),
    [anon_sym_EQ] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_STAR_EQ] = ACTIONS(7051),
    [anon_sym_SLASH_EQ] = ACTIONS(7051),
    [anon_sym_PERCENT_EQ] = ACTIONS(7051),
    [anon_sym_PLUS_EQ] = ACTIONS(7051),
    [anon_sym_DASH_EQ] = ACTIONS(7051),
    [anon_sym_LT_LT_EQ] = ACTIONS(7051),
    [anon_sym_GT_GT_EQ] = ACTIONS(7051),
    [anon_sym_AMP_EQ] = ACTIONS(7051),
    [anon_sym_CARET_EQ] = ACTIONS(7051),
    [anon_sym_PIPE_EQ] = ACTIONS(7051),
    [anon_sym_and_eq] = ACTIONS(7049),
    [anon_sym_or_eq] = ACTIONS(7049),
    [anon_sym_xor_eq] = ACTIONS(7049),
    [anon_sym_LT_EQ_GT] = ACTIONS(7051),
    [anon_sym_or] = ACTIONS(7049),
    [anon_sym_and] = ACTIONS(7049),
    [anon_sym_bitor] = ACTIONS(7049),
    [anon_sym_xor] = ACTIONS(7049),
    [anon_sym_bitand] = ACTIONS(7049),
    [anon_sym_not_eq] = ACTIONS(7049),
    [anon_sym_is] = ACTIONS(7049),
    [anon_sym_as] = ACTIONS(7049),
    [anon_sym_DASH_DASH] = ACTIONS(7051),
    [anon_sym_PLUS_PLUS] = ACTIONS(7051),
    [anon_sym_DOT] = ACTIONS(7049),
    [anon_sym_DOT_STAR] = ACTIONS(7051),
    [anon_sym_DASH_GT] = ACTIONS(7051),
    [sym_comment] = ACTIONS(3),
  },
  [3231] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6526),
    [anon_sym_COMMA] = ACTIONS(6526),
    [anon_sym_RPAREN] = ACTIONS(6526),
    [anon_sym_LPAREN2] = ACTIONS(6526),
    [anon_sym_DASH] = ACTIONS(6524),
    [anon_sym_PLUS] = ACTIONS(6524),
    [anon_sym_STAR] = ACTIONS(6524),
    [anon_sym_SLASH] = ACTIONS(6524),
    [anon_sym_PERCENT] = ACTIONS(6524),
    [anon_sym_PIPE_PIPE] = ACTIONS(6526),
    [anon_sym_AMP_AMP] = ACTIONS(6526),
    [anon_sym_PIPE] = ACTIONS(6524),
    [anon_sym_CARET] = ACTIONS(6524),
    [anon_sym_AMP] = ACTIONS(6524),
    [anon_sym_EQ_EQ] = ACTIONS(6526),
    [anon_sym_BANG_EQ] = ACTIONS(6526),
    [anon_sym_GT] = ACTIONS(6524),
    [anon_sym_GT_EQ] = ACTIONS(6526),
    [anon_sym_LT_EQ] = ACTIONS(6524),
    [anon_sym_LT] = ACTIONS(6524),
    [anon_sym_LT_LT] = ACTIONS(6524),
    [anon_sym_GT_GT] = ACTIONS(6524),
    [anon_sym_LBRACK] = ACTIONS(6526),
    [anon_sym_EQ] = ACTIONS(6524),
    [anon_sym_QMARK] = ACTIONS(6526),
    [anon_sym_STAR_EQ] = ACTIONS(6526),
    [anon_sym_SLASH_EQ] = ACTIONS(6526),
    [anon_sym_PERCENT_EQ] = ACTIONS(6526),
    [anon_sym_PLUS_EQ] = ACTIONS(6526),
    [anon_sym_DASH_EQ] = ACTIONS(6526),
    [anon_sym_LT_LT_EQ] = ACTIONS(6526),
    [anon_sym_GT_GT_EQ] = ACTIONS(6526),
    [anon_sym_AMP_EQ] = ACTIONS(6526),
    [anon_sym_CARET_EQ] = ACTIONS(6526),
    [anon_sym_PIPE_EQ] = ACTIONS(6526),
    [anon_sym_and_eq] = ACTIONS(6524),
    [anon_sym_or_eq] = ACTIONS(6524),
    [anon_sym_xor_eq] = ACTIONS(6524),
    [anon_sym_LT_EQ_GT] = ACTIONS(6526),
    [anon_sym_or] = ACTIONS(6524),
    [anon_sym_and] = ACTIONS(6524),
    [anon_sym_bitor] = ACTIONS(6524),
    [anon_sym_xor] = ACTIONS(6524),
    [anon_sym_bitand] = ACTIONS(6524),
    [anon_sym_not_eq] = ACTIONS(6524),
    [anon_sym_is] = ACTIONS(6524),
    [anon_sym_as] = ACTIONS(6524),
    [anon_sym_DASH_DASH] = ACTIONS(6526),
    [anon_sym_PLUS_PLUS] = ACTIONS(6526),
    [anon_sym_DOT] = ACTIONS(6524),
    [anon_sym_DOT_STAR] = ACTIONS(6526),
    [anon_sym_DASH_GT] = ACTIONS(6524),
    [anon_sym_L_DQUOTE] = ACTIONS(6526),
    [anon_sym_u_DQUOTE] = ACTIONS(6526),
    [anon_sym_U_DQUOTE] = ACTIONS(6526),
    [anon_sym_u8_DQUOTE] = ACTIONS(6526),
    [anon_sym_DQUOTE] = ACTIONS(6526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6526),
    [anon_sym_LR_DQUOTE] = ACTIONS(6526),
    [anon_sym_uR_DQUOTE] = ACTIONS(6526),
    [anon_sym_UR_DQUOTE] = ACTIONS(6526),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6526),
    [anon_sym_DASH_GT_STAR] = ACTIONS(6526),
    [sym_literal_suffix] = ACTIONS(6524),
  },
  [3232] = {
    [sym_identifier] = ACTIONS(6460),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6462),
    [anon_sym_COMMA] = ACTIONS(6462),
    [anon_sym_LPAREN2] = ACTIONS(6462),
    [anon_sym_DASH] = ACTIONS(6460),
    [anon_sym_PLUS] = ACTIONS(6460),
    [anon_sym_STAR] = ACTIONS(6460),
    [anon_sym_SLASH] = ACTIONS(6460),
    [anon_sym_PERCENT] = ACTIONS(6460),
    [anon_sym_PIPE_PIPE] = ACTIONS(6462),
    [anon_sym_AMP_AMP] = ACTIONS(6462),
    [anon_sym_PIPE] = ACTIONS(6460),
    [anon_sym_CARET] = ACTIONS(6460),
    [anon_sym_AMP] = ACTIONS(6460),
    [anon_sym_EQ_EQ] = ACTIONS(6462),
    [anon_sym_BANG_EQ] = ACTIONS(6462),
    [anon_sym_GT] = ACTIONS(6460),
    [anon_sym_GT_EQ] = ACTIONS(6460),
    [anon_sym_LT_EQ] = ACTIONS(6460),
    [anon_sym_LT] = ACTIONS(6460),
    [anon_sym_LT_LT] = ACTIONS(6460),
    [anon_sym_GT_GT] = ACTIONS(6460),
    [anon_sym_LBRACK] = ACTIONS(6462),
    [anon_sym_EQ] = ACTIONS(6460),
    [anon_sym_QMARK] = ACTIONS(6462),
    [anon_sym_STAR_EQ] = ACTIONS(6462),
    [anon_sym_SLASH_EQ] = ACTIONS(6462),
    [anon_sym_PERCENT_EQ] = ACTIONS(6462),
    [anon_sym_PLUS_EQ] = ACTIONS(6462),
    [anon_sym_DASH_EQ] = ACTIONS(6462),
    [anon_sym_LT_LT_EQ] = ACTIONS(6462),
    [anon_sym_GT_GT_EQ] = ACTIONS(6460),
    [anon_sym_AMP_EQ] = ACTIONS(6462),
    [anon_sym_CARET_EQ] = ACTIONS(6462),
    [anon_sym_PIPE_EQ] = ACTIONS(6462),
    [anon_sym_and_eq] = ACTIONS(6460),
    [anon_sym_or_eq] = ACTIONS(6460),
    [anon_sym_xor_eq] = ACTIONS(6460),
    [anon_sym_LT_EQ_GT] = ACTIONS(6462),
    [anon_sym_or] = ACTIONS(6460),
    [anon_sym_and] = ACTIONS(6460),
    [anon_sym_bitor] = ACTIONS(6460),
    [anon_sym_xor] = ACTIONS(6460),
    [anon_sym_bitand] = ACTIONS(6460),
    [anon_sym_not_eq] = ACTIONS(6460),
    [anon_sym_is] = ACTIONS(6460),
    [anon_sym_as] = ACTIONS(6460),
    [anon_sym_DASH_DASH] = ACTIONS(6462),
    [anon_sym_PLUS_PLUS] = ACTIONS(6462),
    [anon_sym_DOT] = ACTIONS(6460),
    [anon_sym_DOT_STAR] = ACTIONS(6462),
    [anon_sym_DASH_GT] = ACTIONS(6462),
    [anon_sym_L_DQUOTE] = ACTIONS(6462),
    [anon_sym_u_DQUOTE] = ACTIONS(6462),
    [anon_sym_U_DQUOTE] = ACTIONS(6462),
    [anon_sym_u8_DQUOTE] = ACTIONS(6462),
    [anon_sym_DQUOTE] = ACTIONS(6462),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(6462),
    [anon_sym_R_DQUOTE] = ACTIONS(6462),
    [anon_sym_LR_DQUOTE] = ACTIONS(6462),
    [anon_sym_uR_DQUOTE] = ACTIONS(6462),
    [anon_sym_UR_DQUOTE] = ACTIONS(6462),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6462),
    [sym_literal_suffix] = ACTIONS(6460),
  },
  [3233] = {
    [sym_template_argument_list] = STATE(2816),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3485),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_STAR] = ACTIONS(3483),
    [anon_sym_SLASH] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3485),
    [anon_sym_AMP_AMP] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(3483),
    [anon_sym_CARET] = ACTIONS(3483),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_EQ_EQ] = ACTIONS(3485),
    [anon_sym_BANG_EQ] = ACTIONS(3485),
    [anon_sym_GT] = ACTIONS(3483),
    [anon_sym_GT_EQ] = ACTIONS(3483),
    [anon_sym_LT_EQ] = ACTIONS(3483),
    [anon_sym_LT] = ACTIONS(3483),
    [anon_sym_LT_LT] = ACTIONS(3483),
    [anon_sym_GT_GT] = ACTIONS(3483),
    [anon_sym___attribute__] = ACTIONS(3485),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(3485),
    [anon_sym_signed] = ACTIONS(7053),
    [anon_sym_unsigned] = ACTIONS(7053),
    [anon_sym_long] = ACTIONS(7053),
    [anon_sym_short] = ACTIONS(7053),
    [anon_sym_LBRACK] = ACTIONS(3485),
    [anon_sym_EQ] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3485),
    [anon_sym_STAR_EQ] = ACTIONS(3485),
    [anon_sym_SLASH_EQ] = ACTIONS(3485),
    [anon_sym_PERCENT_EQ] = ACTIONS(3485),
    [anon_sym_PLUS_EQ] = ACTIONS(3485),
    [anon_sym_DASH_EQ] = ACTIONS(3485),
    [anon_sym_LT_LT_EQ] = ACTIONS(3485),
    [anon_sym_GT_GT_EQ] = ACTIONS(3483),
    [anon_sym_AMP_EQ] = ACTIONS(3485),
    [anon_sym_CARET_EQ] = ACTIONS(3485),
    [anon_sym_PIPE_EQ] = ACTIONS(3485),
    [anon_sym_and_eq] = ACTIONS(3485),
    [anon_sym_or_eq] = ACTIONS(3485),
    [anon_sym_xor_eq] = ACTIONS(3485),
    [anon_sym_LT_EQ_GT] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [anon_sym_and] = ACTIONS(3483),
    [anon_sym_bitor] = ACTIONS(3485),
    [anon_sym_xor] = ACTIONS(3483),
    [anon_sym_bitand] = ACTIONS(3485),
    [anon_sym_not_eq] = ACTIONS(3485),
    [anon_sym_is] = ACTIONS(3485),
    [anon_sym_as] = ACTIONS(3485),
    [anon_sym_DASH_DASH] = ACTIONS(3485),
    [anon_sym_PLUS_PLUS] = ACTIONS(3485),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_DOT_STAR] = ACTIONS(3485),
    [anon_sym_DASH_GT] = ACTIONS(3485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3485),
    [anon_sym_let] = ACTIONS(3485),
    [anon_sym_This] = ACTIONS(3485),
    [anon_sym_GT2] = ACTIONS(3485),
  },
  [3234] = {
    [sym_identifier] = ACTIONS(7055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [anon_sym_COMMA] = ACTIONS(7057),
    [anon_sym_RPAREN] = ACTIONS(7057),
    [aux_sym_preproc_if_token2] = ACTIONS(7057),
    [aux_sym_preproc_else_token1] = ACTIONS(7057),
    [aux_sym_preproc_elif_token1] = ACTIONS(7055),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7057),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7057),
    [anon_sym_LPAREN2] = ACTIONS(7057),
    [anon_sym_DASH] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7055),
    [anon_sym_STAR] = ACTIONS(7055),
    [anon_sym_SLASH] = ACTIONS(7055),
    [anon_sym_PERCENT] = ACTIONS(7055),
    [anon_sym_PIPE_PIPE] = ACTIONS(7057),
    [anon_sym_AMP_AMP] = ACTIONS(7057),
    [anon_sym_PIPE] = ACTIONS(7055),
    [anon_sym_CARET] = ACTIONS(7055),
    [anon_sym_AMP] = ACTIONS(7055),
    [anon_sym_EQ_EQ] = ACTIONS(7057),
    [anon_sym_BANG_EQ] = ACTIONS(7057),
    [anon_sym_GT] = ACTIONS(7055),
    [anon_sym_GT_EQ] = ACTIONS(7057),
    [anon_sym_LT_EQ] = ACTIONS(7055),
    [anon_sym_LT] = ACTIONS(7055),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_COLON] = ACTIONS(7057),
    [anon_sym_SEMI] = ACTIONS(7057),
    [anon_sym___attribute__] = ACTIONS(7055),
    [anon_sym_LBRACE] = ACTIONS(7057),
    [anon_sym_RBRACE] = ACTIONS(7057),
    [anon_sym_LBRACK] = ACTIONS(7057),
    [anon_sym_RBRACK] = ACTIONS(7057),
    [anon_sym_EQ] = ACTIONS(7055),
    [anon_sym_QMARK] = ACTIONS(7057),
    [anon_sym_STAR_EQ] = ACTIONS(7057),
    [anon_sym_SLASH_EQ] = ACTIONS(7057),
    [anon_sym_PERCENT_EQ] = ACTIONS(7057),
    [anon_sym_PLUS_EQ] = ACTIONS(7057),
    [anon_sym_DASH_EQ] = ACTIONS(7057),
    [anon_sym_LT_LT_EQ] = ACTIONS(7057),
    [anon_sym_GT_GT_EQ] = ACTIONS(7057),
    [anon_sym_AMP_EQ] = ACTIONS(7057),
    [anon_sym_CARET_EQ] = ACTIONS(7057),
    [anon_sym_PIPE_EQ] = ACTIONS(7057),
    [anon_sym_and_eq] = ACTIONS(7055),
    [anon_sym_or_eq] = ACTIONS(7055),
    [anon_sym_xor_eq] = ACTIONS(7055),
    [anon_sym_LT_EQ_GT] = ACTIONS(7057),
    [anon_sym_or] = ACTIONS(7055),
    [anon_sym_and] = ACTIONS(7055),
    [anon_sym_bitor] = ACTIONS(7055),
    [anon_sym_xor] = ACTIONS(7055),
    [anon_sym_bitand] = ACTIONS(7055),
    [anon_sym_not_eq] = ACTIONS(7055),
    [anon_sym_is] = ACTIONS(7055),
    [anon_sym_as] = ACTIONS(7055),
    [anon_sym_DASH_DASH] = ACTIONS(7057),
    [anon_sym_PLUS_PLUS] = ACTIONS(7057),
    [anon_sym_DOT] = ACTIONS(7055),
    [anon_sym_DOT_STAR] = ACTIONS(7057),
    [anon_sym_DASH_GT] = ACTIONS(7057),
    [sym_comment] = ACTIONS(3),
  },
  [3235] = {
    [sym_identifier] = ACTIONS(7059),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7061),
    [anon_sym_COMMA] = ACTIONS(7061),
    [anon_sym_RPAREN] = ACTIONS(7061),
    [aux_sym_preproc_if_token2] = ACTIONS(7061),
    [aux_sym_preproc_else_token1] = ACTIONS(7061),
    [aux_sym_preproc_elif_token1] = ACTIONS(7059),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7061),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7061),
    [anon_sym_LPAREN2] = ACTIONS(7061),
    [anon_sym_DASH] = ACTIONS(7059),
    [anon_sym_PLUS] = ACTIONS(7059),
    [anon_sym_STAR] = ACTIONS(7059),
    [anon_sym_SLASH] = ACTIONS(7059),
    [anon_sym_PERCENT] = ACTIONS(7059),
    [anon_sym_PIPE_PIPE] = ACTIONS(7061),
    [anon_sym_AMP_AMP] = ACTIONS(7061),
    [anon_sym_PIPE] = ACTIONS(7059),
    [anon_sym_CARET] = ACTIONS(7059),
    [anon_sym_AMP] = ACTIONS(7059),
    [anon_sym_EQ_EQ] = ACTIONS(7061),
    [anon_sym_BANG_EQ] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7059),
    [anon_sym_GT_EQ] = ACTIONS(7061),
    [anon_sym_LT_EQ] = ACTIONS(7059),
    [anon_sym_LT] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7059),
    [anon_sym_GT_GT] = ACTIONS(7059),
    [anon_sym_COLON] = ACTIONS(7061),
    [anon_sym_SEMI] = ACTIONS(7061),
    [anon_sym___attribute__] = ACTIONS(7059),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7061),
    [anon_sym_RBRACE] = ACTIONS(7061),
    [anon_sym_LBRACK] = ACTIONS(7059),
    [anon_sym_RBRACK] = ACTIONS(7061),
    [anon_sym_EQ] = ACTIONS(7059),
    [anon_sym_QMARK] = ACTIONS(7061),
    [anon_sym_STAR_EQ] = ACTIONS(7061),
    [anon_sym_SLASH_EQ] = ACTIONS(7061),
    [anon_sym_PERCENT_EQ] = ACTIONS(7061),
    [anon_sym_PLUS_EQ] = ACTIONS(7061),
    [anon_sym_DASH_EQ] = ACTIONS(7061),
    [anon_sym_LT_LT_EQ] = ACTIONS(7061),
    [anon_sym_GT_GT_EQ] = ACTIONS(7061),
    [anon_sym_AMP_EQ] = ACTIONS(7061),
    [anon_sym_CARET_EQ] = ACTIONS(7061),
    [anon_sym_PIPE_EQ] = ACTIONS(7061),
    [anon_sym_and_eq] = ACTIONS(7059),
    [anon_sym_or_eq] = ACTIONS(7059),
    [anon_sym_xor_eq] = ACTIONS(7059),
    [anon_sym_LT_EQ_GT] = ACTIONS(7061),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_bitor] = ACTIONS(7059),
    [anon_sym_xor] = ACTIONS(7059),
    [anon_sym_bitand] = ACTIONS(7059),
    [anon_sym_not_eq] = ACTIONS(7059),
    [anon_sym_is] = ACTIONS(7059),
    [anon_sym_as] = ACTIONS(7059),
    [anon_sym_DASH_DASH] = ACTIONS(7061),
    [anon_sym_PLUS_PLUS] = ACTIONS(7061),
    [anon_sym_DOT] = ACTIONS(7059),
    [anon_sym_DOT_STAR] = ACTIONS(7061),
    [anon_sym_DASH_GT] = ACTIONS(7061),
    [sym_comment] = ACTIONS(3),
  },
  [3236] = {
    [sym_template_argument_list] = STATE(3372),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2123),
    [anon_sym_COMMA] = ACTIONS(2123),
    [anon_sym_RPAREN] = ACTIONS(2123),
    [anon_sym_LPAREN2] = ACTIONS(2123),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2115),
    [anon_sym_SLASH] = ACTIONS(2115),
    [anon_sym_PERCENT] = ACTIONS(2115),
    [anon_sym_PIPE_PIPE] = ACTIONS(2123),
    [anon_sym_AMP_AMP] = ACTIONS(2123),
    [anon_sym_PIPE] = ACTIONS(2115),
    [anon_sym_CARET] = ACTIONS(2115),
    [anon_sym_AMP] = ACTIONS(2115),
    [anon_sym_EQ_EQ] = ACTIONS(2123),
    [anon_sym_BANG_EQ] = ACTIONS(2123),
    [anon_sym_GT] = ACTIONS(2115),
    [anon_sym_GT_EQ] = ACTIONS(2123),
    [anon_sym_LT_EQ] = ACTIONS(2115),
    [anon_sym_LT] = ACTIONS(7063),
    [anon_sym_LT_LT] = ACTIONS(2115),
    [anon_sym_GT_GT] = ACTIONS(2115),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_signed] = ACTIONS(6935),
    [anon_sym_unsigned] = ACTIONS(6935),
    [anon_sym_long] = ACTIONS(6935),
    [anon_sym_short] = ACTIONS(6935),
    [anon_sym_LBRACK] = ACTIONS(2123),
    [anon_sym_EQ] = ACTIONS(2115),
    [anon_sym_QMARK] = ACTIONS(2123),
    [anon_sym_STAR_EQ] = ACTIONS(2123),
    [anon_sym_SLASH_EQ] = ACTIONS(2123),
    [anon_sym_PERCENT_EQ] = ACTIONS(2123),
    [anon_sym_PLUS_EQ] = ACTIONS(2123),
    [anon_sym_DASH_EQ] = ACTIONS(2123),
    [anon_sym_LT_LT_EQ] = ACTIONS(2123),
    [anon_sym_GT_GT_EQ] = ACTIONS(2123),
    [anon_sym_AMP_EQ] = ACTIONS(2123),
    [anon_sym_CARET_EQ] = ACTIONS(2123),
    [anon_sym_PIPE_EQ] = ACTIONS(2123),
    [anon_sym_and_eq] = ACTIONS(2123),
    [anon_sym_or_eq] = ACTIONS(2123),
    [anon_sym_xor_eq] = ACTIONS(2123),
    [anon_sym_LT_EQ_GT] = ACTIONS(2123),
    [anon_sym_or] = ACTIONS(2115),
    [anon_sym_and] = ACTIONS(2115),
    [anon_sym_bitor] = ACTIONS(2123),
    [anon_sym_xor] = ACTIONS(2115),
    [anon_sym_bitand] = ACTIONS(2123),
    [anon_sym_not_eq] = ACTIONS(2123),
    [anon_sym_is] = ACTIONS(2123),
    [anon_sym_as] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DOT] = ACTIONS(2115),
    [anon_sym_DOT_STAR] = ACTIONS(2123),
    [anon_sym_DASH_GT] = ACTIONS(2115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2123),
    [anon_sym_let] = ACTIONS(2123),
    [anon_sym_This] = ACTIONS(2123),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2123),
  },
  [3237] = {
    [sym_identifier] = ACTIONS(4573),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4575),
    [anon_sym_COMMA] = ACTIONS(4575),
    [anon_sym_RPAREN] = ACTIONS(4575),
    [aux_sym_preproc_if_token2] = ACTIONS(4575),
    [aux_sym_preproc_else_token1] = ACTIONS(4575),
    [aux_sym_preproc_elif_token1] = ACTIONS(4573),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4575),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4575),
    [anon_sym_LPAREN2] = ACTIONS(4575),
    [anon_sym_DASH] = ACTIONS(4573),
    [anon_sym_PLUS] = ACTIONS(4573),
    [anon_sym_STAR] = ACTIONS(4573),
    [anon_sym_SLASH] = ACTIONS(4573),
    [anon_sym_PERCENT] = ACTIONS(4573),
    [anon_sym_PIPE_PIPE] = ACTIONS(4575),
    [anon_sym_AMP_AMP] = ACTIONS(4575),
    [anon_sym_PIPE] = ACTIONS(4573),
    [anon_sym_CARET] = ACTIONS(4573),
    [anon_sym_AMP] = ACTIONS(4573),
    [anon_sym_EQ_EQ] = ACTIONS(4575),
    [anon_sym_BANG_EQ] = ACTIONS(4575),
    [anon_sym_GT] = ACTIONS(4573),
    [anon_sym_GT_EQ] = ACTIONS(4575),
    [anon_sym_LT_EQ] = ACTIONS(4573),
    [anon_sym_LT] = ACTIONS(4573),
    [anon_sym_LT_LT] = ACTIONS(4573),
    [anon_sym_GT_GT] = ACTIONS(4573),
    [anon_sym_COLON] = ACTIONS(4575),
    [anon_sym_SEMI] = ACTIONS(4575),
    [anon_sym___attribute__] = ACTIONS(4573),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4575),
    [anon_sym_RBRACE] = ACTIONS(4575),
    [anon_sym_LBRACK] = ACTIONS(4573),
    [anon_sym_RBRACK] = ACTIONS(4575),
    [anon_sym_EQ] = ACTIONS(4573),
    [anon_sym_QMARK] = ACTIONS(4575),
    [anon_sym_STAR_EQ] = ACTIONS(4575),
    [anon_sym_SLASH_EQ] = ACTIONS(4575),
    [anon_sym_PERCENT_EQ] = ACTIONS(4575),
    [anon_sym_PLUS_EQ] = ACTIONS(4575),
    [anon_sym_DASH_EQ] = ACTIONS(4575),
    [anon_sym_LT_LT_EQ] = ACTIONS(4575),
    [anon_sym_GT_GT_EQ] = ACTIONS(4575),
    [anon_sym_AMP_EQ] = ACTIONS(4575),
    [anon_sym_CARET_EQ] = ACTIONS(4575),
    [anon_sym_PIPE_EQ] = ACTIONS(4575),
    [anon_sym_and_eq] = ACTIONS(4573),
    [anon_sym_or_eq] = ACTIONS(4573),
    [anon_sym_xor_eq] = ACTIONS(4573),
    [anon_sym_LT_EQ_GT] = ACTIONS(4575),
    [anon_sym_or] = ACTIONS(4573),
    [anon_sym_and] = ACTIONS(4573),
    [anon_sym_bitor] = ACTIONS(4573),
    [anon_sym_xor] = ACTIONS(4573),
    [anon_sym_bitand] = ACTIONS(4573),
    [anon_sym_not_eq] = ACTIONS(4573),
    [anon_sym_is] = ACTIONS(4573),
    [anon_sym_as] = ACTIONS(4573),
    [anon_sym_DASH_DASH] = ACTIONS(4575),
    [anon_sym_PLUS_PLUS] = ACTIONS(4575),
    [anon_sym_DOT] = ACTIONS(4573),
    [anon_sym_DOT_STAR] = ACTIONS(4575),
    [anon_sym_DASH_GT] = ACTIONS(4575),
    [sym_comment] = ACTIONS(3),
  },
  [3238] = {
    [sym_attribute_specifier] = STATE(3609),
    [sym_field_declaration_list] = STATE(3495),
    [sym_virtual_specifier] = STATE(8873),
    [sym_base_class_clause] = STATE(9913),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2683),
    [anon_sym_PLUS] = ACTIONS(2683),
    [anon_sym_STAR] = ACTIONS(2683),
    [anon_sym_SLASH] = ACTIONS(2683),
    [anon_sym_PERCENT] = ACTIONS(2683),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_PIPE] = ACTIONS(2683),
    [anon_sym_CARET] = ACTIONS(2683),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_EQ_EQ] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_GT] = ACTIONS(2683),
    [anon_sym_GT_EQ] = ACTIONS(2683),
    [anon_sym_LT_EQ] = ACTIONS(2683),
    [anon_sym_LT] = ACTIONS(2683),
    [anon_sym_LT_LT] = ACTIONS(2683),
    [anon_sym_GT_GT] = ACTIONS(2683),
    [anon_sym_COLON] = ACTIONS(6474),
    [anon_sym___attribute__] = ACTIONS(7065),
    [anon_sym_LBRACE] = ACTIONS(7067),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2683),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_STAR_EQ] = ACTIONS(2685),
    [anon_sym_SLASH_EQ] = ACTIONS(2685),
    [anon_sym_PERCENT_EQ] = ACTIONS(2685),
    [anon_sym_PLUS_EQ] = ACTIONS(2685),
    [anon_sym_DASH_EQ] = ACTIONS(2685),
    [anon_sym_LT_LT_EQ] = ACTIONS(2685),
    [anon_sym_GT_GT_EQ] = ACTIONS(2683),
    [anon_sym_AMP_EQ] = ACTIONS(2685),
    [anon_sym_CARET_EQ] = ACTIONS(2685),
    [anon_sym_PIPE_EQ] = ACTIONS(2685),
    [anon_sym_and_eq] = ACTIONS(2685),
    [anon_sym_or_eq] = ACTIONS(2685),
    [anon_sym_xor_eq] = ACTIONS(2685),
    [anon_sym_LT_EQ_GT] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2683),
    [anon_sym_and] = ACTIONS(2683),
    [anon_sym_bitor] = ACTIONS(2685),
    [anon_sym_xor] = ACTIONS(2683),
    [anon_sym_bitand] = ACTIONS(2685),
    [anon_sym_not_eq] = ACTIONS(2685),
    [anon_sym_is] = ACTIONS(2685),
    [anon_sym_as] = ACTIONS(2685),
    [anon_sym_DASH_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_PLUS] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2683),
    [anon_sym_DOT_STAR] = ACTIONS(2685),
    [anon_sym_DASH_GT] = ACTIONS(2685),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_This] = ACTIONS(2685),
    [anon_sym_final] = ACTIONS(6625),
    [anon_sym_override] = ACTIONS(6625),
    [anon_sym_GT2] = ACTIONS(2685),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7069), 1,
      anon_sym_LT,
    STATE(3372), 1,
      sym_template_argument_list,
    ACTIONS(2169), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2176), 41,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [77] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(4883), 1,
      anon_sym_LPAREN2,
    ACTIONS(4885), 1,
      anon_sym_STAR,
    ACTIONS(4887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4889), 1,
      anon_sym_AMP,
    ACTIONS(6140), 1,
      sym_identifier,
    ACTIONS(6763), 1,
      anon_sym_RPAREN,
    ACTIONS(6775), 1,
      anon_sym_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_COLON_COLON,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6961), 1,
      sym__scope_resolution,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7899), 1,
      sym__declarator,
    STATE(8201), 1,
      sym__abstract_declarator,
    STATE(10814), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3285), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3701), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7074), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7076), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [275] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6853), 1,
      sym_literal_suffix,
    STATE(3165), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(4918), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4920), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2128), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2117), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7078), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7080), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [425] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3160), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7082), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3810), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3812), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7084), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7086), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [571] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3160), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7082), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3803), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3805), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7088), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7090), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [717] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3160), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7082), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3750), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3752), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [792] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7092), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7094), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7096), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7098), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7102), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [1005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7104), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7106), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [1076] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7108), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7110), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [1147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5418), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3834), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [1218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7112), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7114), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [1289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5896), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5898), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [1360] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5858), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5860), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [1431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5961), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5963), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [1502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7116), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7118), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [1573] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3160), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7082), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3757), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3759), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [1648] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5858), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5860), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [1719] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3248), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7120), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3392), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3390), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [1794] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5858), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5860), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [1865] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7124), 1,
      anon_sym_and,
    ACTIONS(6204), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6206), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [1940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6044), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6046), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6431), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6433), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [2082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2171), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2171), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6511), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6513), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [2295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2171), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5953), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5955), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2171), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2171), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2171), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5933), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5935), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5941), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5943), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2792] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7126), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7128), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7130), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7132), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7134), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7136), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5010), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5006), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3076] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5886), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5888), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7138), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7140), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3218] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7124), 1,
      anon_sym_and,
    ACTIONS(7142), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7144), 1,
      anon_sym_or,
    ACTIONS(6192), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6194), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7146), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7148), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3368] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(4883), 1,
      anon_sym_LPAREN2,
    ACTIONS(4885), 1,
      anon_sym_STAR,
    ACTIONS(4887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4889), 1,
      anon_sym_AMP,
    ACTIONS(6140), 1,
      sym_identifier,
    ACTIONS(6775), 1,
      anon_sym_LBRACK,
    ACTIONS(6777), 1,
      anon_sym_RPAREN,
    ACTIONS(7072), 1,
      anon_sym_COLON_COLON,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6961), 1,
      sym__scope_resolution,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7902), 1,
      sym__declarator,
    STATE(8214), 1,
      sym__abstract_declarator,
    STATE(10814), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3761), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4823), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [3495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5892), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5894), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7150), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7152), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7154), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7156), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7160), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3779] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3244), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7162), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3764), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3766), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [3854] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3246), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7164), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3771), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3773), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [3929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7166), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7168), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7172), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7174), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7176), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4142] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2359), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2357), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6526), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [4284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5937), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5939), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7178), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7180), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6056), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6058), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7182), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7184), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4568] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7186), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7188), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4639] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6853), 1,
      sym_literal_suffix,
    STATE(3165), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(4918), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4920), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6594), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6596), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [4718] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7190), 1,
      anon_sym_LT,
    STATE(3369), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3392), 1,
      sym_template_argument_list,
    ACTIONS(7053), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2115), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2123), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [4799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7192), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7194), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7154), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7156), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7196), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7198), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5925), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5927), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7200), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7202), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6062), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7204), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7206), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5296] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6313), 1,
      anon_sym_LBRACE,
    ACTIONS(6728), 1,
      anon_sym___attribute__,
    ACTIONS(7208), 1,
      anon_sym_COLON,
    STATE(2678), 1,
      sym__enum_base_clause,
    STATE(2708), 1,
      sym_enumerator_list,
    STATE(2767), 1,
      sym_attribute_specifier,
    ACTIONS(3348), 7,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym_line,
      anon_sym_triangle,
    ACTIONS(3350), 50,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_out,
      anon_sym_inout,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      sym_virtual,
      anon_sym_precise,
      anon_sym_shared,
      anon_sym_groupshared,
      anon_sym_uniform,
      anon_sym_row_major,
      anon_sym_column_major,
      anon_sym_globallycoherent,
      anon_sym_centroid,
      anon_sym_noperspective,
      anon_sym_nointerpolation,
      anon_sym_sample,
      anon_sym_linear,
      anon_sym_snorm,
      anon_sym_unorm,
      anon_sym_point,
      anon_sym_triangleadj,
      anon_sym_lineadj,
  [5379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7210), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7212), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7214), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7216), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7218), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7220), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7222), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7224), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2128), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2117), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5734] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7228), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7230), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7232), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7234), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7236), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2355), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2353), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6018] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7238), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7240), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6089] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 1,
      anon_sym_LBRACK,
    ACTIONS(2214), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2217), 5,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_DOT,
    ACTIONS(2210), 55,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_in,
      anon_sym_out,
      anon_sym_inout,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      sym_virtual,
      anon_sym_operator,
      anon_sym_precise,
      anon_sym_shared,
      anon_sym_groupshared,
      anon_sym_uniform,
      anon_sym_row_major,
      anon_sym_column_major,
      anon_sym_globallycoherent,
      anon_sym_centroid,
      anon_sym_noperspective,
      anon_sym_nointerpolation,
      anon_sym_sample,
      anon_sym_linear,
      anon_sym_snorm,
      anon_sym_unorm,
      anon_sym_point,
      anon_sym_line,
      anon_sym_triangleadj,
      anon_sym_lineadj,
      anon_sym_triangle,
  [6164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6460), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6462), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [6235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7023), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7025), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7242), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7244), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7246), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7248), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7250), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7252), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7254), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7256), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7258), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7260), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6661] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6313), 1,
      anon_sym_LBRACE,
    ACTIONS(6728), 1,
      anon_sym___attribute__,
    ACTIONS(7208), 1,
      anon_sym_COLON,
    STATE(2677), 1,
      sym__enum_base_clause,
    STATE(2706), 1,
      sym_enumerator_list,
    STATE(2773), 1,
      sym_attribute_specifier,
    ACTIONS(3060), 7,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym_line,
      anon_sym_triangle,
    ACTIONS(3062), 50,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_out,
      anon_sym_inout,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      sym_virtual,
      anon_sym_precise,
      anon_sym_shared,
      anon_sym_groupshared,
      anon_sym_uniform,
      anon_sym_row_major,
      anon_sym_column_major,
      anon_sym_globallycoherent,
      anon_sym_centroid,
      anon_sym_noperspective,
      anon_sym_nointerpolation,
      anon_sym_sample,
      anon_sym_linear,
      anon_sym_snorm,
      anon_sym_unorm,
      anon_sym_point,
      anon_sym_triangleadj,
      anon_sym_lineadj,
  [6744] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7262), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7264), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6613), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6611), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6886] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7266), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7268), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6957] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7063), 1,
      anon_sym_LT,
    STATE(3372), 1,
      sym_template_argument_list,
    ACTIONS(2349), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2347), 41,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [7034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2128), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2117), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7105] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3368), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7270), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3771), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3773), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [7179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6431), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6433), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [7249] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7272), 1,
      sym_identifier,
    STATE(3357), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2156), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2158), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6458), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6456), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7266), 36,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_interface,
      anon_sym_extension,
  [7397] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    STATE(2816), 1,
      sym_template_argument_list,
    STATE(3406), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7274), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3483), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3485), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [7475] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(7276), 1,
      anon_sym___attribute__,
    ACTIONS(7278), 1,
      anon_sym_LBRACE,
    STATE(3615), 1,
      sym_field_declaration_list,
    STATE(3932), 1,
      sym_attribute_specifier,
    STATE(8885), 1,
      sym_virtual_specifier,
    STATE(9932), 1,
      sym_base_class_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2683), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2685), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [7561] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7280), 1,
      sym_identifier,
    STATE(3338), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2156), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2158), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6439), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6437), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7639] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7282), 1,
      sym_identifier,
    ACTIONS(7286), 1,
      sym_primitive_type,
    STATE(3354), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7284), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3822), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
    ACTIONS(3820), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [7717] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7190), 1,
      anon_sym_LT,
    STATE(3392), 1,
      sym_template_argument_list,
    ACTIONS(2349), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2347), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [7793] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2367), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2365), 41,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [7865] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3346), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7288), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2854), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
    ACTIONS(2856), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_primitive_type,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [7939] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3248), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7120), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2742), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2740), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [8013] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7291), 1,
      anon_sym_LT,
    STATE(3392), 1,
      sym_template_argument_list,
    ACTIONS(2169), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2176), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [8089] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6959), 1,
      anon_sym___attribute__,
    ACTIONS(7294), 1,
      anon_sym_COLON,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    STATE(3402), 1,
      sym__enum_base_clause,
    STATE(3454), 1,
      sym_enumerator_list,
    STATE(3527), 1,
      sym_attribute_specifier,
    ACTIONS(3060), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3062), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [8171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7260), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7258), 36,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_interface,
      anon_sym_extension,
  [8241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6526), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [8311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2361), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
    ACTIONS(2363), 34,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [8381] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3214), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7298), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3750), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3752), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [8455] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3346), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2856), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(7288), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3781), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
    ACTIONS(3778), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [8531] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2371), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
    ACTIONS(2373), 34,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [8603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7302), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7300), 56,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_in,
      anon_sym_out,
      anon_sym_inout,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_precise,
      anon_sym_shared,
      anon_sym_groupshared,
      anon_sym_uniform,
      anon_sym_row_major,
      anon_sym_column_major,
      anon_sym_globallycoherent,
      anon_sym_centroid,
      anon_sym_noperspective,
      anon_sym_nointerpolation,
      anon_sym_sample,
      anon_sym_linear,
      anon_sym_snorm,
      anon_sym_unorm,
      anon_sym_point,
      anon_sym_line,
      anon_sym_triangleadj,
      anon_sym_lineadj,
      anon_sym_triangle,
  [8673] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7304), 1,
      sym_identifier,
    STATE(3357), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(7307), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(7310), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6446), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6444), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8751] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6959), 1,
      anon_sym___attribute__,
    ACTIONS(7294), 1,
      anon_sym_COLON,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    STATE(3405), 1,
      sym__enum_base_clause,
    STATE(3436), 1,
      sym_enumerator_list,
    STATE(3559), 1,
      sym_attribute_specifier,
    ACTIONS(3348), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3350), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [8833] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3367), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7313), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3764), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3766), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [8907] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2373), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2371), 41,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [8979] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6511), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6513), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [9049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6460), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6462), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [9119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7172), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7170), 36,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_interface,
      anon_sym_extension,
  [9189] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2373), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2371), 41,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [9261] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2371), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
    ACTIONS(2373), 34,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [9333] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3353), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7315), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3392), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3390), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [9407] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3214), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7298), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3810), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3812), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [9481] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3214), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7298), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3803), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3805), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [9555] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3214), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7298), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3757), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3759), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [9629] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7176), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7174), 36,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_interface,
      anon_sym_extension,
  [9699] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7319), 1,
      anon_sym_LPAREN2,
    ACTIONS(7321), 5,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7317), 56,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_in,
      anon_sym_out,
      anon_sym_inout,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_precise,
      anon_sym_shared,
      anon_sym_groupshared,
      anon_sym_uniform,
      anon_sym_row_major,
      anon_sym_column_major,
      anon_sym_globallycoherent,
      anon_sym_centroid,
      anon_sym_noperspective,
      anon_sym_nointerpolation,
      anon_sym_sample,
      anon_sym_linear,
      anon_sym_snorm,
      anon_sym_unorm,
      anon_sym_point,
      anon_sym_line,
      anon_sym_triangleadj,
      anon_sym_lineadj,
      anon_sym_triangle,
  [9771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2210), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2217), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [9841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2363), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2361), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [9911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6460), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(6462), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [9980] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___attribute__,
    ACTIONS(7323), 1,
      anon_sym_COLON,
    ACTIONS(7325), 1,
      anon_sym_LBRACE,
    STATE(3425), 1,
      sym__enum_base_clause,
    STATE(3502), 1,
      sym_enumerator_list,
    STATE(3634), 1,
      sym_attribute_specifier,
    ACTIONS(3348), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3350), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [10061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2373), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2371), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [10130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(6526), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [10199] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6562), 1,
      anon_sym_DOT,
    ACTIONS(6307), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3850), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3848), 52,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_in,
      anon_sym_out,
      anon_sym_inout,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_virtual,
      anon_sym_operator,
      anon_sym_precise,
      anon_sym_shared,
      anon_sym_groupshared,
      anon_sym_uniform,
      anon_sym_row_major,
      anon_sym_column_major,
      anon_sym_globallycoherent,
      anon_sym_centroid,
      anon_sym_noperspective,
      anon_sym_nointerpolation,
      anon_sym_sample,
      anon_sym_linear,
      anon_sym_snorm,
      anon_sym_unorm,
      anon_sym_point,
      anon_sym_line,
      anon_sym_triangleadj,
      anon_sym_lineadj,
      anon_sym_triangle,
  [10272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6511), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(6513), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [10341] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7327), 1,
      anon_sym_DOT,
    ACTIONS(6572), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3848), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
    ACTIONS(3850), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [10414] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2373), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2371), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [10485] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2373), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2371), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [10556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2371), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
    ACTIONS(2373), 33,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [10625] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7329), 1,
      anon_sym_DOT,
    ACTIONS(7331), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3890), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(3892), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [10698] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3353), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7315), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2742), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2740), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [10771] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7327), 1,
      anon_sym_DOT,
    ACTIONS(6572), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3890), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
    ACTIONS(3892), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [10844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6431), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(6433), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [10913] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6562), 1,
      anon_sym_DOT,
    ACTIONS(6307), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3892), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3890), 52,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_in,
      anon_sym_out,
      anon_sym_inout,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_virtual,
      anon_sym_operator,
      anon_sym_precise,
      anon_sym_shared,
      anon_sym_groupshared,
      anon_sym_uniform,
      anon_sym_row_major,
      anon_sym_column_major,
      anon_sym_globallycoherent,
      anon_sym_centroid,
      anon_sym_noperspective,
      anon_sym_nointerpolation,
      anon_sym_sample,
      anon_sym_linear,
      anon_sym_snorm,
      anon_sym_unorm,
      anon_sym_point,
      anon_sym_line,
      anon_sym_triangleadj,
      anon_sym_lineadj,
      anon_sym_triangle,
  [10986] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7333), 1,
      anon_sym_LT,
    STATE(3406), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3472), 1,
      sym_template_argument_list,
    ACTIONS(7274), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2115), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2123), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [11065] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___attribute__,
    ACTIONS(7323), 1,
      anon_sym_COLON,
    ACTIONS(7325), 1,
      anon_sym_LBRACE,
    STATE(3468), 1,
      sym__enum_base_clause,
    STATE(3492), 1,
      sym_enumerator_list,
    STATE(3601), 1,
      sym_attribute_specifier,
    ACTIONS(3060), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3062), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [11146] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7329), 1,
      anon_sym_DOT,
    ACTIONS(7331), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3848), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(3850), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2210), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2217), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [11288] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2367), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2365), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [11359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2363), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2361), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [11428] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7333), 1,
      anon_sym_LT,
    STATE(3472), 1,
      sym_template_argument_list,
    ACTIONS(2349), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2347), 41,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [11502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2373), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2371), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [11570] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3401), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7335), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3771), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3773), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [11642] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4583), 1,
      anon_sym_LBRACE,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7339), 1,
      anon_sym_LBRACK,
    STATE(3620), 1,
      sym_new_declarator,
    STATE(4313), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7341), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(6586), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6588), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [11722] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3346), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7343), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3810), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3812), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [11794] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3399), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7345), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3764), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3766), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [11866] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3346), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7343), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3803), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3805), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [11938] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6959), 1,
      anon_sym___attribute__,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    STATE(3442), 1,
      sym_enumerator_list,
    STATE(3557), 1,
      sym_attribute_specifier,
    ACTIONS(3711), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3713), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [12014] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3408), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7347), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3392), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3390), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [12086] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4583), 1,
      anon_sym_LBRACE,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7339), 1,
      anon_sym_LBRACK,
    STATE(3635), 1,
      sym_new_declarator,
    STATE(4346), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7341), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(6564), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6566), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [12166] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6959), 1,
      anon_sym___attribute__,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    STATE(3461), 1,
      sym_enumerator_list,
    STATE(3531), 1,
      sym_attribute_specifier,
    ACTIONS(3715), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3717), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [12242] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3346), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7343), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3757), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3759), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [12314] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7349), 1,
      anon_sym_LT,
    STATE(3472), 1,
      sym_template_argument_list,
    ACTIONS(2169), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2176), 41,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [12388] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3346), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7343), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3750), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3752), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [12460] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4583), 1,
      anon_sym_LBRACE,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7339), 1,
      anon_sym_LBRACK,
    STATE(3623), 1,
      sym_new_declarator,
    STATE(4369), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7341), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(6578), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6580), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [12540] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4583), 1,
      anon_sym_LBRACE,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7339), 1,
      anon_sym_LBRACK,
    STATE(3688), 1,
      sym_new_declarator,
    STATE(4347), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7341), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(6582), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6584), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [12620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2196), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [12687] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6959), 1,
      anon_sym___attribute__,
    STATE(3551), 1,
      sym_attribute_specifier,
    ACTIONS(3791), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3793), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [12758] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6959), 1,
      anon_sym___attribute__,
    STATE(3532), 1,
      sym_attribute_specifier,
    ACTIONS(3746), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3748), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [12829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2258), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [12896] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4737), 1,
      anon_sym_LBRACE,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(7354), 1,
      anon_sym_LBRACK,
    STATE(3712), 1,
      sym_new_declarator,
    STATE(4509), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7356), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(6564), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6566), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [12975] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7366), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7368), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7380), 1,
      anon_sym_GT_EQ,
    ACTIONS(7384), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7386), 1,
      anon_sym_or,
    ACTIONS(7388), 1,
      anon_sym_and,
    ACTIONS(7390), 1,
      anon_sym_not_eq,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7362), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7370), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7372), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7374), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7376), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7382), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7392), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7364), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7378), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7358), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(7360), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [13088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6431), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6433), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [13155] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4737), 1,
      anon_sym_LBRACE,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(7354), 1,
      anon_sym_LBRACK,
    STATE(3720), 1,
      sym_new_declarator,
    STATE(4491), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7356), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(6578), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6580), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [13234] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7384), 1,
      anon_sym_LT_EQ_GT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7362), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7382), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7392), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7364), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7007), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(7009), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [13325] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7380), 1,
      anon_sym_GT_EQ,
    ACTIONS(7384), 1,
      anon_sym_LT_EQ_GT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7362), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7382), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7392), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7364), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7378), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 15,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(7009), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [13420] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4737), 1,
      anon_sym_LBRACE,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(7354), 1,
      anon_sym_LBRACK,
    STATE(3723), 1,
      sym_new_declarator,
    STATE(4481), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7356), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(6582), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6584), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [13499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2228), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2230), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [13566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2234), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [13633] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3408), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7347), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2742), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2740), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [13704] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___attribute__,
    ACTIONS(7325), 1,
      anon_sym_LBRACE,
    STATE(3496), 1,
      sym_enumerator_list,
    STATE(3648), 1,
      sym_attribute_specifier,
    ACTIONS(3715), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3717), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [13779] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7380), 1,
      anon_sym_GT_EQ,
    ACTIONS(7384), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7390), 1,
      anon_sym_not_eq,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7362), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7374), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7376), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7382), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7392), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7364), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7378), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 12,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      sym_identifier,
    ACTIONS(7009), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [13880] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7380), 1,
      anon_sym_GT_EQ,
    ACTIONS(7384), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7390), 1,
      anon_sym_not_eq,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7362), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7372), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7374), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7376), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7382), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7392), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7364), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7378), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 10,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      sym_identifier,
    ACTIONS(7009), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [13983] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7380), 1,
      anon_sym_GT_EQ,
    ACTIONS(7384), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7390), 1,
      anon_sym_not_eq,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7362), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7370), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7372), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7374), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7376), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7382), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7392), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7364), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7378), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 8,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
    ACTIONS(7009), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [14088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2248), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2250), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [14155] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7368), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7380), 1,
      anon_sym_GT_EQ,
    ACTIONS(7384), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7388), 1,
      anon_sym_and,
    ACTIONS(7390), 1,
      anon_sym_not_eq,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7362), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7370), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7372), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7374), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7376), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7382), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7392), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7364), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7378), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 7,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      sym_identifier,
    ACTIONS(7009), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [14264] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6511), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6513), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [14331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6460), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6462), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [14398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2198), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2200), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [14465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2186), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2188), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [14532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6526), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [14599] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6959), 1,
      anon_sym___attribute__,
    STATE(3530), 1,
      sym_attribute_specifier,
    ACTIONS(3795), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3797), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [14670] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2219), 2,
      anon_sym_AMP,
      anon_sym_DOT,
    ACTIONS(2210), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_const,
    ACTIONS(2214), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_GT2,
    ACTIONS(2222), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(2217), 18,
      anon_sym___extension__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2212), 20,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [14745] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 1,
      anon_sym___attribute__,
    ACTIONS(7394), 1,
      anon_sym_COLON,
    ACTIONS(7396), 1,
      anon_sym_LBRACE,
    STATE(3555), 1,
      sym__enum_base_clause,
    STATE(3614), 1,
      sym_enumerator_list,
    STATE(3906), 1,
      sym_attribute_specifier,
    ACTIONS(3060), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3062), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [14824] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6959), 1,
      anon_sym___attribute__,
    STATE(3560), 1,
      sym_attribute_specifier,
    ACTIONS(3830), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3832), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [14895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2246), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [14962] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7366), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7368), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7380), 1,
      anon_sym_GT_EQ,
    ACTIONS(7384), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7386), 1,
      anon_sym_or,
    ACTIONS(7388), 1,
      anon_sym_and,
    ACTIONS(7390), 1,
      anon_sym_not_eq,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7362), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7370), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7372), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7374), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7376), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7382), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7392), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7364), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7378), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7398), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(7400), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [15075] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6959), 1,
      anon_sym___attribute__,
    STATE(3533), 1,
      sym_attribute_specifier,
    ACTIONS(3731), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3733), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [15146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2252), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2254), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [15213] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7366), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7368), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7380), 1,
      anon_sym_GT_EQ,
    ACTIONS(7384), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7386), 1,
      anon_sym_or,
    ACTIONS(7388), 1,
      anon_sym_and,
    ACTIONS(7390), 1,
      anon_sym_not_eq,
    ACTIONS(7402), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7404), 1,
      anon_sym_QMARK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7362), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7370), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7372), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7374), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7376), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7382), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7392), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7364), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7378), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7178), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(7180), 15,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [15330] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7364), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7009), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(7007), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
  [15413] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7366), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7368), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7380), 1,
      anon_sym_GT_EQ,
    ACTIONS(7384), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7386), 1,
      anon_sym_or,
    ACTIONS(7388), 1,
      anon_sym_and,
    ACTIONS(7390), 1,
      anon_sym_not_eq,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7362), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7370), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7372), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7374), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7376), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7382), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7392), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7364), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7378), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7406), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(7408), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [15526] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7362), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7364), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7007), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
    ACTIONS(7009), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [15611] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6959), 1,
      anon_sym___attribute__,
    STATE(3536), 1,
      sym_attribute_specifier,
    ACTIONS(3725), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3727), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [15682] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7362), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7382), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7364), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7007), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
    ACTIONS(7009), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [15769] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6959), 1,
      anon_sym___attribute__,
    STATE(3538), 1,
      sym_attribute_specifier,
    ACTIONS(3735), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3737), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [15840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2190), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2192), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [15907] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7366), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7368), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7380), 1,
      anon_sym_GT_EQ,
    ACTIONS(7384), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7386), 1,
      anon_sym_or,
    ACTIONS(7388), 1,
      anon_sym_and,
    ACTIONS(7390), 1,
      anon_sym_not_eq,
    ACTIONS(7402), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7404), 1,
      anon_sym_QMARK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7362), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7370), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7372), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7374), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7376), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7382), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7392), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7364), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7378), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7410), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(7412), 15,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [16024] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2224), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2226), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [16091] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6959), 1,
      anon_sym___attribute__,
    STATE(3558), 1,
      sym_attribute_specifier,
    ACTIONS(3719), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3721), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [16162] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4737), 1,
      anon_sym_LBRACE,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(7354), 1,
      anon_sym_LBRACK,
    STATE(3739), 1,
      sym_new_declarator,
    STATE(4463), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7356), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(6586), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6588), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [16241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2236), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2238), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [16308] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2367), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2365), 41,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [16377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2240), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2242), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [16444] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7366), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7368), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7380), 1,
      anon_sym_GT_EQ,
    ACTIONS(7384), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7386), 1,
      anon_sym_or,
    ACTIONS(7388), 1,
      anon_sym_and,
    ACTIONS(7390), 1,
      anon_sym_not_eq,
    ACTIONS(7402), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7404), 1,
      anon_sym_QMARK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7362), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7370), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7372), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7374), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7376), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7382), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7392), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7364), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7378), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7414), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(7416), 15,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [16561] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6959), 1,
      anon_sym___attribute__,
    STATE(3523), 1,
      sym_attribute_specifier,
    ACTIONS(3742), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3744), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [16632] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6959), 1,
      anon_sym___attribute__,
    STATE(3594), 1,
      sym_attribute_specifier,
    ACTIONS(3836), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3838), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [16703] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(4883), 1,
      anon_sym_LPAREN2,
    ACTIONS(6761), 1,
      sym_identifier,
    ACTIONS(6765), 1,
      anon_sym_STAR,
    ACTIONS(6767), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6769), 1,
      anon_sym_AMP,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6775), 1,
      anon_sym_LBRACK,
    ACTIONS(7420), 1,
      anon_sym_COLON,
    STATE(3498), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7317), 1,
      sym__declarator,
    STATE(7489), 1,
      sym__abstract_declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(7418), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [16820] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 1,
      anon_sym___attribute__,
    ACTIONS(7394), 1,
      anon_sym_COLON,
    ACTIONS(7396), 1,
      anon_sym_LBRACE,
    STATE(3512), 1,
      sym__enum_base_clause,
    STATE(3646), 1,
      sym_enumerator_list,
    STATE(4170), 1,
      sym_attribute_specifier,
    ACTIONS(3348), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3350), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [16899] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7380), 1,
      anon_sym_GT_EQ,
    ACTIONS(7384), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7390), 1,
      anon_sym_not_eq,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7362), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7376), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7382), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7392), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7364), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7378), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 14,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      sym_identifier,
    ACTIONS(7009), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [16998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2202), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2204), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [17065] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7366), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7368), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7380), 1,
      anon_sym_GT_EQ,
    ACTIONS(7384), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7386), 1,
      anon_sym_or,
    ACTIONS(7388), 1,
      anon_sym_and,
    ACTIONS(7390), 1,
      anon_sym_not_eq,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7362), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7370), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7372), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7374), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7376), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7382), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7392), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7364), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7378), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7422), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(7424), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [17178] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6959), 1,
      anon_sym___attribute__,
    STATE(3596), 1,
      sym_attribute_specifier,
    ACTIONS(3840), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3842), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [17249] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___attribute__,
    ACTIONS(7325), 1,
      anon_sym_LBRACE,
    STATE(3504), 1,
      sym_enumerator_list,
    STATE(3637), 1,
      sym_attribute_specifier,
    ACTIONS(3711), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3713), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [17324] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(4883), 1,
      anon_sym_LPAREN2,
    ACTIONS(6761), 1,
      sym_identifier,
    ACTIONS(6765), 1,
      anon_sym_STAR,
    ACTIONS(6767), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6769), 1,
      anon_sym_AMP,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6775), 1,
      anon_sym_LBRACK,
    ACTIONS(6779), 1,
      anon_sym_COLON,
    STATE(3498), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7264), 1,
      sym__declarator,
    STATE(7546), 1,
      sym__abstract_declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(6777), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [17441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2206), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2208), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [17508] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6959), 1,
      anon_sym___attribute__,
    STATE(3552), 1,
      sym_attribute_specifier,
    ACTIONS(3799), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3801), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [17579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2210), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2217), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [17646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3392), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3390), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [17712] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3176), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3174), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [17778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7186), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7188), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [17844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2824), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [17910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7426), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(7428), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [17976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2171), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [18042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3204), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [18108] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___attribute__,
    STATE(3608), 1,
      sym_attribute_specifier,
    ACTIONS(3746), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3748), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [18178] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      sym_literal_suffix,
    ACTIONS(2128), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2117), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [18246] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7430), 1,
      anon_sym_LT,
    STATE(3604), 1,
      sym_template_argument_list,
    ACTIONS(2176), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2169), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [18318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2491), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2489), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [18384] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6734), 1,
      anon_sym_DOT,
    ACTIONS(6736), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3890), 7,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym_line,
      anon_sym_triangle,
    ACTIONS(3892), 47,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_out,
      anon_sym_inout,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_virtual,
      anon_sym_precise,
      anon_sym_shared,
      anon_sym_groupshared,
      anon_sym_uniform,
      anon_sym_row_major,
      anon_sym_column_major,
      anon_sym_globallycoherent,
      anon_sym_centroid,
      anon_sym_noperspective,
      anon_sym_nointerpolation,
      anon_sym_sample,
      anon_sym_linear,
      anon_sym_snorm,
      anon_sym_unorm,
      anon_sym_point,
      anon_sym_triangleadj,
      anon_sym_lineadj,
  [18454] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___attribute__,
    STATE(3639), 1,
      sym_attribute_specifier,
    ACTIONS(3742), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3744), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [18524] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      sym_literal_suffix,
    ACTIONS(6594), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6596), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [18592] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___attribute__,
    STATE(3683), 1,
      sym_attribute_specifier,
    ACTIONS(3840), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3842), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [18662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2536), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2534), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [18728] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7444), 1,
      anon_sym_LBRACK,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(7452), 1,
      anon_sym_DASH_GT,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7461), 1,
      anon_sym_requires,
    ACTIONS(7464), 1,
      anon_sym_where,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(5381), 1,
      sym__function_attributes_start,
    STATE(5813), 1,
      sym_ref_qualifier,
    STATE(6571), 1,
      sym__function_attributes_end,
    STATE(6825), 1,
      sym_trailing_return_type,
    STATE(7202), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7454), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4858), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5151), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7179), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6127), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7432), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [18848] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2742), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2740), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [18916] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___attribute__,
    STATE(3632), 1,
      sym_attribute_specifier,
    ACTIONS(3830), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3832), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [18986] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___attribute__,
    STATE(3636), 1,
      sym_attribute_specifier,
    ACTIONS(3719), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3721), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [19056] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6734), 1,
      anon_sym_DOT,
    ACTIONS(6736), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3848), 7,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym_line,
      anon_sym_triangle,
    ACTIONS(3850), 47,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_out,
      anon_sym_inout,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_virtual,
      anon_sym_precise,
      anon_sym_shared,
      anon_sym_groupshared,
      anon_sym_uniform,
      anon_sym_row_major,
      anon_sym_column_major,
      anon_sym_globallycoherent,
      anon_sym_centroid,
      anon_sym_noperspective,
      anon_sym_nointerpolation,
      anon_sym_sample,
      anon_sym_linear,
      anon_sym_snorm,
      anon_sym_unorm,
      anon_sym_point,
      anon_sym_triangleadj,
      anon_sym_lineadj,
  [19126] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3404), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3402), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [19192] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___attribute__,
    STATE(3598), 1,
      sym_attribute_specifier,
    ACTIONS(3799), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3801), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [19262] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___attribute__,
    STATE(3685), 1,
      sym_attribute_specifier,
    ACTIONS(3836), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3838), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [19332] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___attribute__,
    STATE(3643), 1,
      sym_attribute_specifier,
    ACTIONS(3791), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3793), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [19402] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7444), 1,
      anon_sym_LBRACK,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(7452), 1,
      anon_sym_DASH_GT,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(7471), 1,
      anon_sym_where,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(5405), 1,
      sym__function_attributes_start,
    STATE(5803), 1,
      sym_ref_qualifier,
    STATE(6539), 1,
      sym__function_attributes_end,
    STATE(6858), 1,
      sym_trailing_return_type,
    STATE(7202), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4858), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5151), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7499), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6138), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7432), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [19522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2171), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [19588] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2171), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [19654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2171), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [19720] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___attribute__,
    STATE(3647), 1,
      sym_attribute_specifier,
    ACTIONS(3795), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3797), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [19790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2171), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [19856] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___attribute__,
    STATE(3597), 1,
      sym_attribute_specifier,
    ACTIONS(3731), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3733), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [19926] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2217), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(2222), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2212), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [19994] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___attribute__,
    STATE(3682), 1,
      sym_attribute_specifier,
    ACTIONS(3725), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3727), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [20064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2171), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [20130] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7430), 1,
      anon_sym_LT,
    STATE(3604), 1,
      sym_template_argument_list,
    ACTIONS(2347), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2349), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [20202] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___attribute__,
    STATE(3642), 1,
      sym_attribute_specifier,
    ACTIONS(3735), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3737), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [20272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3054), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3052), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [20337] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7358), 1,
      anon_sym_EQ,
    ACTIONS(7477), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7479), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7481), 1,
      anon_sym_PIPE,
    ACTIONS(7485), 1,
      anon_sym_AMP,
    ACTIONS(7491), 1,
      anon_sym_GT_EQ,
    ACTIONS(7497), 1,
      anon_sym_or,
    ACTIONS(7499), 1,
      anon_sym_and,
    ACTIONS(7501), 1,
      anon_sym_bitor,
    ACTIONS(7503), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7473), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7483), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7493), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7487), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7489), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7495), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7360), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [20448] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 1,
      anon_sym___attribute__,
    ACTIONS(7396), 1,
      anon_sym_LBRACE,
    STATE(3655), 1,
      sym_enumerator_list,
    STATE(3766), 1,
      sym_attribute_specifier,
    ACTIONS(3715), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3717), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [20521] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4867), 1,
      anon_sym_LBRACE,
    ACTIONS(7505), 1,
      anon_sym_LPAREN2,
    ACTIONS(7507), 1,
      anon_sym_LBRACK,
    STATE(4373), 1,
      sym_new_declarator,
    STATE(4637), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7509), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(6578), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6580), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [20598] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7444), 1,
      anon_sym_LBRACK,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7511), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7514), 1,
      anon_sym_DASH_GT,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7518), 1,
      anon_sym_where,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(5513), 1,
      sym__function_attributes_start,
    STATE(5958), 1,
      sym_ref_qualifier,
    STATE(6535), 1,
      sym__function_attributes_end,
    STATE(6800), 1,
      sym_trailing_return_type,
    STATE(7161), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4858), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5151), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7574), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6196), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7432), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [20717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3388), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3386), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [20782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2740), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [20847] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7398), 1,
      anon_sym_EQ,
    ACTIONS(7477), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7479), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7481), 1,
      anon_sym_PIPE,
    ACTIONS(7485), 1,
      anon_sym_AMP,
    ACTIONS(7491), 1,
      anon_sym_GT_EQ,
    ACTIONS(7497), 1,
      anon_sym_or,
    ACTIONS(7499), 1,
      anon_sym_and,
    ACTIONS(7501), 1,
      anon_sym_bitor,
    ACTIONS(7503), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7473), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7483), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7493), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7487), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7489), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7495), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7400), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [20958] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7402), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7414), 1,
      anon_sym_EQ,
    ACTIONS(7477), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7479), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7481), 1,
      anon_sym_PIPE,
    ACTIONS(7485), 1,
      anon_sym_AMP,
    ACTIONS(7491), 1,
      anon_sym_GT_EQ,
    ACTIONS(7497), 1,
      anon_sym_or,
    ACTIONS(7499), 1,
      anon_sym_and,
    ACTIONS(7501), 1,
      anon_sym_bitor,
    ACTIONS(7503), 1,
      anon_sym_bitand,
    ACTIONS(7520), 1,
      anon_sym_QMARK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7473), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7483), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7493), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7487), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7489), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7495), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7416), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [21073] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7522), 1,
      anon_sym_LPAREN2,
    ACTIONS(7524), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7526), 1,
      anon_sym_LBRACK,
    STATE(3855), 1,
      sym_parameter_list,
    STATE(3621), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6802), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6804), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [21148] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7473), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7007), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [21231] = 52,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7530), 1,
      anon_sym_COMMA,
    ACTIONS(7532), 1,
      anon_sym_RPAREN,
    ACTIONS(7534), 1,
      anon_sym_DASH,
    ACTIONS(7536), 1,
      anon_sym_PLUS,
    ACTIONS(7538), 1,
      anon_sym_STAR,
    ACTIONS(7540), 1,
      anon_sym_SLASH,
    ACTIONS(7542), 1,
      anon_sym_PERCENT,
    ACTIONS(7544), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7546), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7548), 1,
      anon_sym_PIPE,
    ACTIONS(7550), 1,
      anon_sym_CARET,
    ACTIONS(7552), 1,
      anon_sym_AMP,
    ACTIONS(7554), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7556), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7558), 1,
      anon_sym_GT,
    ACTIONS(7560), 1,
      anon_sym_GT_EQ,
    ACTIONS(7562), 1,
      anon_sym_LT_EQ,
    ACTIONS(7564), 1,
      anon_sym_LT,
    ACTIONS(7566), 1,
      anon_sym_LT_LT,
    ACTIONS(7568), 1,
      anon_sym_GT_GT,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7572), 1,
      anon_sym_EQ,
    ACTIONS(7574), 1,
      anon_sym_QMARK,
    ACTIONS(7576), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7578), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7580), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7582), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7584), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7586), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7588), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7590), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7592), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7594), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7600), 1,
      anon_sym_or,
    ACTIONS(7602), 1,
      anon_sym_and,
    ACTIONS(7604), 1,
      anon_sym_bitor,
    ACTIONS(7606), 1,
      anon_sym_xor,
    ACTIONS(7608), 1,
      anon_sym_bitand,
    ACTIONS(7610), 1,
      anon_sym_not_eq,
    ACTIONS(7616), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7618), 1,
      anon_sym_DASH_GT_STAR,
    STATE(2393), 1,
      sym__binary_fold_operator,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    STATE(10128), 1,
      sym__fold_operator,
    ACTIONS(7612), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7596), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(7598), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [21394] = 52,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7530), 1,
      anon_sym_COMMA,
    ACTIONS(7534), 1,
      anon_sym_DASH,
    ACTIONS(7536), 1,
      anon_sym_PLUS,
    ACTIONS(7538), 1,
      anon_sym_STAR,
    ACTIONS(7540), 1,
      anon_sym_SLASH,
    ACTIONS(7542), 1,
      anon_sym_PERCENT,
    ACTIONS(7544), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7546), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7548), 1,
      anon_sym_PIPE,
    ACTIONS(7550), 1,
      anon_sym_CARET,
    ACTIONS(7552), 1,
      anon_sym_AMP,
    ACTIONS(7554), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7556), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7558), 1,
      anon_sym_GT,
    ACTIONS(7560), 1,
      anon_sym_GT_EQ,
    ACTIONS(7562), 1,
      anon_sym_LT_EQ,
    ACTIONS(7564), 1,
      anon_sym_LT,
    ACTIONS(7566), 1,
      anon_sym_LT_LT,
    ACTIONS(7568), 1,
      anon_sym_GT_GT,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7572), 1,
      anon_sym_EQ,
    ACTIONS(7574), 1,
      anon_sym_QMARK,
    ACTIONS(7576), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7578), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7580), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7582), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7584), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7586), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7588), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7590), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7592), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7594), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7600), 1,
      anon_sym_or,
    ACTIONS(7602), 1,
      anon_sym_and,
    ACTIONS(7604), 1,
      anon_sym_bitor,
    ACTIONS(7606), 1,
      anon_sym_xor,
    ACTIONS(7608), 1,
      anon_sym_bitand,
    ACTIONS(7610), 1,
      anon_sym_not_eq,
    ACTIONS(7616), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7618), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7620), 1,
      anon_sym_RPAREN,
    STATE(2393), 1,
      sym__binary_fold_operator,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    STATE(10128), 1,
      sym__fold_operator,
    ACTIONS(7612), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7596), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(7598), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [21557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3190), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [21622] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4867), 1,
      anon_sym_LBRACE,
    ACTIONS(7505), 1,
      anon_sym_LPAREN2,
    ACTIONS(7507), 1,
      anon_sym_LBRACK,
    STATE(4396), 1,
      sym_new_declarator,
    STATE(4681), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7509), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(6564), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6566), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [21699] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2176), 1,
      anon_sym_LBRACE,
    ACTIONS(5028), 1,
      anon_sym_LT,
    STATE(3505), 1,
      sym_template_argument_list,
    ACTIONS(2181), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2171), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [21772] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7622), 1,
      anon_sym_DOT,
    ACTIONS(7341), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3848), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(3850), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [21841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3202), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3200), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [21906] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3338), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3336), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [21971] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7522), 1,
      anon_sym_LPAREN2,
    ACTIONS(7524), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7526), 1,
      anon_sym_LBRACK,
    STATE(3855), 1,
      sym_parameter_list,
    STATE(3621), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6798), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6800), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [22046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3172), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3170), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [22111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3156), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3154), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [22176] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3362), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3360), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [22241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3070), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3068), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [22306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2824), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [22371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3366), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3364), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [22436] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2948), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2946), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [22501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3176), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3174), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [22566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3102), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3100), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [22631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2964), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2962), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [22696] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3338), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3336), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [22761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3338), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3336), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [22826] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(4883), 1,
      anon_sym_LPAREN2,
    ACTIONS(6761), 1,
      sym_identifier,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6775), 1,
      anon_sym_LBRACK,
    ACTIONS(6779), 1,
      anon_sym_COLON,
    ACTIONS(6914), 1,
      anon_sym_STAR,
    ACTIONS(6916), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6918), 1,
      anon_sym_AMP,
    STATE(4478), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7264), 1,
      sym__declarator,
    STATE(8261), 1,
      sym__abstract_declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6777), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [22941] = 52,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7530), 1,
      anon_sym_COMMA,
    ACTIONS(7534), 1,
      anon_sym_DASH,
    ACTIONS(7536), 1,
      anon_sym_PLUS,
    ACTIONS(7538), 1,
      anon_sym_STAR,
    ACTIONS(7540), 1,
      anon_sym_SLASH,
    ACTIONS(7542), 1,
      anon_sym_PERCENT,
    ACTIONS(7544), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7546), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7548), 1,
      anon_sym_PIPE,
    ACTIONS(7550), 1,
      anon_sym_CARET,
    ACTIONS(7552), 1,
      anon_sym_AMP,
    ACTIONS(7554), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7556), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7558), 1,
      anon_sym_GT,
    ACTIONS(7560), 1,
      anon_sym_GT_EQ,
    ACTIONS(7562), 1,
      anon_sym_LT_EQ,
    ACTIONS(7564), 1,
      anon_sym_LT,
    ACTIONS(7566), 1,
      anon_sym_LT_LT,
    ACTIONS(7568), 1,
      anon_sym_GT_GT,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7572), 1,
      anon_sym_EQ,
    ACTIONS(7574), 1,
      anon_sym_QMARK,
    ACTIONS(7576), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7578), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7580), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7582), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7584), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7586), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7588), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7590), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7592), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7594), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7600), 1,
      anon_sym_or,
    ACTIONS(7602), 1,
      anon_sym_and,
    ACTIONS(7604), 1,
      anon_sym_bitor,
    ACTIONS(7606), 1,
      anon_sym_xor,
    ACTIONS(7608), 1,
      anon_sym_bitand,
    ACTIONS(7610), 1,
      anon_sym_not_eq,
    ACTIONS(7616), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7618), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7624), 1,
      anon_sym_RPAREN,
    STATE(2393), 1,
      sym__binary_fold_operator,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    STATE(10128), 1,
      sym__fold_operator,
    ACTIONS(7612), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7596), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(7598), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [23104] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4867), 1,
      anon_sym_LBRACE,
    ACTIONS(7505), 1,
      anon_sym_LPAREN2,
    ACTIONS(7507), 1,
      anon_sym_LBRACK,
    STATE(4353), 1,
      sym_new_declarator,
    STATE(4628), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7509), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(6582), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6584), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [23181] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2536), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2534), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [23246] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(4883), 1,
      anon_sym_LPAREN2,
    ACTIONS(6761), 1,
      sym_identifier,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6775), 1,
      anon_sym_LBRACK,
    ACTIONS(6914), 1,
      anon_sym_STAR,
    ACTIONS(6916), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6918), 1,
      anon_sym_AMP,
    ACTIONS(7420), 1,
      anon_sym_COLON,
    STATE(4478), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7317), 1,
      sym__declarator,
    STATE(8258), 1,
      sym__abstract_declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7418), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [23361] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7522), 1,
      anon_sym_LPAREN2,
    ACTIONS(7524), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7526), 1,
      anon_sym_LBRACK,
    STATE(3855), 1,
      sym_parameter_list,
    STATE(3621), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6781), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6783), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [23436] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2176), 1,
      anon_sym_LBRACE,
    ACTIONS(5037), 1,
      anon_sym_LT,
    STATE(3679), 1,
      sym_template_argument_list,
    ACTIONS(2181), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2171), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [23509] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7444), 1,
      anon_sym_LBRACK,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7511), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7514), 1,
      anon_sym_DASH_GT,
    ACTIONS(7629), 1,
      anon_sym_requires,
    ACTIONS(7632), 1,
      anon_sym_where,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(5572), 1,
      sym__function_attributes_start,
    STATE(5927), 1,
      sym_ref_qualifier,
    STATE(6526), 1,
      sym__function_attributes_end,
    STATE(6883), 1,
      sym_trailing_return_type,
    STATE(7161), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7626), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4858), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5151), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7154), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6180), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7432), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [23628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3054), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3052), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [23693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3082), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3080), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [23758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3090), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3088), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [23823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3056), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [23888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7426), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7428), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [23953] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 1,
      anon_sym___attribute__,
    ACTIONS(7396), 1,
      anon_sym_LBRACE,
    STATE(3653), 1,
      sym_enumerator_list,
    STATE(4157), 1,
      sym_attribute_specifier,
    ACTIONS(3711), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3713), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [24026] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7473), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7493), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7495), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7007), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [24113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3358), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3356), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [24178] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3384), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3382), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [24243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3396), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3394), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [24308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3400), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3398), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [24373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2998), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [24438] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2742), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2740), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [24505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3404), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3402), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [24570] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7491), 1,
      anon_sym_GT_EQ,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7473), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7493), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7489), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7495), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7007), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [24661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2996), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2994), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [24726] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7402), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7410), 1,
      anon_sym_EQ,
    ACTIONS(7477), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7479), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7481), 1,
      anon_sym_PIPE,
    ACTIONS(7485), 1,
      anon_sym_AMP,
    ACTIONS(7491), 1,
      anon_sym_GT_EQ,
    ACTIONS(7497), 1,
      anon_sym_or,
    ACTIONS(7499), 1,
      anon_sym_and,
    ACTIONS(7501), 1,
      anon_sym_bitor,
    ACTIONS(7503), 1,
      anon_sym_bitand,
    ACTIONS(7520), 1,
      anon_sym_QMARK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7473), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7483), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7493), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7487), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7489), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7495), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7412), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [24841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3844), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3846), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [24906] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7491), 1,
      anon_sym_GT_EQ,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7473), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7493), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7487), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7489), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7495), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7007), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
  [24999] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7178), 1,
      anon_sym_EQ,
    ACTIONS(7402), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7477), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7479), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7481), 1,
      anon_sym_PIPE,
    ACTIONS(7485), 1,
      anon_sym_AMP,
    ACTIONS(7491), 1,
      anon_sym_GT_EQ,
    ACTIONS(7497), 1,
      anon_sym_or,
    ACTIONS(7499), 1,
      anon_sym_and,
    ACTIONS(7501), 1,
      anon_sym_bitor,
    ACTIONS(7503), 1,
      anon_sym_bitand,
    ACTIONS(7520), 1,
      anon_sym_QMARK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7473), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7483), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7493), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7487), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7489), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7495), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7180), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [25114] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4867), 1,
      anon_sym_LBRACE,
    ACTIONS(7505), 1,
      anon_sym_LPAREN2,
    ACTIONS(7507), 1,
      anon_sym_LBRACK,
    STATE(4332), 1,
      sym_new_declarator,
    STATE(4618), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7509), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(6586), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6588), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [25191] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(4883), 1,
      anon_sym_LPAREN2,
    ACTIONS(6761), 1,
      sym_identifier,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6775), 1,
      anon_sym_LBRACK,
    ACTIONS(6905), 1,
      anon_sym_STAR,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(7420), 1,
      anon_sym_COLON,
    STATE(4541), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7317), 1,
      sym__declarator,
    STATE(8344), 1,
      sym__abstract_declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7418), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [25306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3392), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3390), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [25371] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      sym_literal_suffix,
    ACTIONS(6594), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
    ACTIONS(6596), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [25438] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7622), 1,
      anon_sym_DOT,
    ACTIONS(7341), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3890), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(3892), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [25507] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7485), 1,
      anon_sym_AMP,
    ACTIONS(7491), 1,
      anon_sym_GT_EQ,
    ACTIONS(7503), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7473), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7493), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7487), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7489), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7495), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7007), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [25604] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7485), 1,
      anon_sym_AMP,
    ACTIONS(7491), 1,
      anon_sym_GT_EQ,
    ACTIONS(7503), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7473), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7483), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7493), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7487), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7489), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7495), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7007), 4,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7009), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [25703] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      sym_literal_suffix,
    ACTIONS(2128), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
    ACTIONS(2117), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [25770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3152), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3150), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [25835] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7481), 1,
      anon_sym_PIPE,
    ACTIONS(7485), 1,
      anon_sym_AMP,
    ACTIONS(7491), 1,
      anon_sym_GT_EQ,
    ACTIONS(7501), 1,
      anon_sym_bitor,
    ACTIONS(7503), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7473), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7483), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7493), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7007), 3,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7487), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7489), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7495), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [25938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3098), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3096), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [26003] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6537), 4,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(6539), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2117), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2128), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
  [26072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3048), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3046), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [26137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2988), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2986), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [26202] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7522), 1,
      anon_sym_LPAREN2,
    ACTIONS(7524), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7526), 1,
      anon_sym_LBRACK,
    STATE(3855), 1,
      sym_parameter_list,
    STATE(3621), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6806), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6808), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [26277] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7522), 1,
      anon_sym_LPAREN2,
    ACTIONS(7524), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7526), 1,
      anon_sym_LBRACK,
    STATE(3855), 1,
      sym_parameter_list,
    STATE(3621), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6794), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6796), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [26352] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7406), 1,
      anon_sym_EQ,
    ACTIONS(7477), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7479), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7481), 1,
      anon_sym_PIPE,
    ACTIONS(7485), 1,
      anon_sym_AMP,
    ACTIONS(7491), 1,
      anon_sym_GT_EQ,
    ACTIONS(7497), 1,
      anon_sym_or,
    ACTIONS(7499), 1,
      anon_sym_and,
    ACTIONS(7501), 1,
      anon_sym_bitor,
    ACTIONS(7503), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7473), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7483), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7493), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7487), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7489), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7495), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7408), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [26463] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(4883), 1,
      anon_sym_LPAREN2,
    ACTIONS(6761), 1,
      sym_identifier,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6775), 1,
      anon_sym_LBRACK,
    ACTIONS(6779), 1,
      anon_sym_COLON,
    ACTIONS(6905), 1,
      anon_sym_STAR,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    STATE(4541), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7264), 1,
      sym__declarator,
    STATE(8305), 1,
      sym__abstract_declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6777), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [26578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2740), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [26643] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7422), 1,
      anon_sym_EQ,
    ACTIONS(7477), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7479), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7481), 1,
      anon_sym_PIPE,
    ACTIONS(7485), 1,
      anon_sym_AMP,
    ACTIONS(7491), 1,
      anon_sym_GT_EQ,
    ACTIONS(7497), 1,
      anon_sym_or,
    ACTIONS(7499), 1,
      anon_sym_and,
    ACTIONS(7501), 1,
      anon_sym_bitor,
    ACTIONS(7503), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7473), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7483), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7493), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7487), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7489), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7495), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7424), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [26754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3204), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [26819] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7479), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7481), 1,
      anon_sym_PIPE,
    ACTIONS(7485), 1,
      anon_sym_AMP,
    ACTIONS(7491), 1,
      anon_sym_GT_EQ,
    ACTIONS(7499), 1,
      anon_sym_and,
    ACTIONS(7501), 1,
      anon_sym_bitor,
    ACTIONS(7503), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7007), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(7473), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7483), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7493), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7487), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7489), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7495), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [26926] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7473), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7493), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7007), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [27011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2491), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2489), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [27076] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2942), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [27141] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7007), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [27222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2908), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [27287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3070), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3068), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [27351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3090), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3088), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [27415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2740), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [27479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3388), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3386), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [27543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3202), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3200), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [27607] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7635), 1,
      anon_sym_DOT,
    ACTIONS(7356), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3848), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(3850), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [27675] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2176), 1,
      anon_sym_LBRACE,
    ACTIONS(6518), 1,
      anon_sym_LT,
    STATE(3706), 1,
      sym_template_argument_list,
    ACTIONS(2181), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2171), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [27747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2210), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(2217), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [27811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3338), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3336), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [27875] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 1,
      anon_sym___attribute__,
    STATE(3923), 1,
      sym_attribute_specifier,
    ACTIONS(3746), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3748), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [27943] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 1,
      anon_sym___attribute__,
    STATE(3905), 1,
      sym_attribute_specifier,
    ACTIONS(3742), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3744), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [28011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3362), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3360), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [28075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3366), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3364), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [28139] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      sym_literal_suffix,
    STATE(3342), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(2156), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2158), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2128), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2117), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [28211] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      sym_literal_suffix,
    STATE(3342), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(2156), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2158), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6594), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6596), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [28283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3158), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(3160), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [28347] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 1,
      anon_sym___attribute__,
    STATE(4171), 1,
      sym_attribute_specifier,
    ACTIONS(3830), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3832), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [28415] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 1,
      anon_sym___attribute__,
    STATE(4160), 1,
      sym_attribute_specifier,
    ACTIONS(3719), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3721), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [28483] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 1,
      anon_sym___attribute__,
    STATE(4123), 1,
      sym_attribute_specifier,
    ACTIONS(3799), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3801), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [28551] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7637), 1,
      anon_sym_LPAREN2,
    ACTIONS(7639), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7641), 1,
      anon_sym_LBRACK,
    STATE(4367), 1,
      sym_parameter_list,
    STATE(3730), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6806), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6808), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [28625] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 1,
      anon_sym___attribute__,
    STATE(4116), 1,
      sym_attribute_specifier,
    ACTIONS(3791), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3793), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [28693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3338), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3336), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [28757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2371), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2373), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [28821] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4583), 1,
      anon_sym_LBRACE,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    STATE(4389), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6883), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6885), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [28891] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7524), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3687), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6855), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6857), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [28959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3338), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3336), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [29023] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4583), 1,
      anon_sym_LBRACE,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    STATE(4307), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6859), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6861), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [29093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3056), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [29157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2998), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [29221] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7637), 1,
      anon_sym_LPAREN2,
    ACTIONS(7639), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7641), 1,
      anon_sym_LBRACK,
    STATE(4367), 1,
      sym_parameter_list,
    STATE(3730), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6794), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6796), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [29295] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2210), 1,
      anon_sym_const,
    ACTIONS(2219), 2,
      anon_sym_AMP,
      anon_sym_DOT,
    ACTIONS(2214), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
    ACTIONS(2222), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(2217), 18,
      anon_sym___extension__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2212), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [29367] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2365), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2367), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [29433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2996), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2994), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [29497] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7635), 1,
      anon_sym_DOT,
    ACTIONS(7356), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3890), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(3892), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [29565] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7637), 1,
      anon_sym_LPAREN2,
    ACTIONS(7639), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7641), 1,
      anon_sym_LBRACK,
    STATE(4367), 1,
      sym_parameter_list,
    STATE(3730), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6802), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6804), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [29639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3400), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3398), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [29703] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7637), 1,
      anon_sym_LPAREN2,
    ACTIONS(7639), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7641), 1,
      anon_sym_LBRACK,
    STATE(4367), 1,
      sym_parameter_list,
    STATE(3730), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6781), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6783), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [29777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3396), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3394), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [29841] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4583), 1,
      anon_sym_LBRACE,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    STATE(4299), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6820), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6822), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [29911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3384), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3382), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [29975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3358), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3356), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [30039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7643), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(7645), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [30103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3190), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [30167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3054), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3052), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [30231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7647), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(7649), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [30295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3102), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3100), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [30359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3082), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3080), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [30423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3844), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3846), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [30487] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3054), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3052), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [30551] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 1,
      anon_sym___attribute__,
    STATE(4005), 1,
      sym_attribute_specifier,
    ACTIONS(3795), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3797), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [30619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3172), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3170), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [30683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3156), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3154), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [30747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7651), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(7653), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [30811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2361), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2363), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [30875] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 1,
      anon_sym___attribute__,
    STATE(3897), 1,
      sym_attribute_specifier,
    ACTIONS(3840), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3842), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [30943] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7637), 1,
      anon_sym_LPAREN2,
    ACTIONS(7639), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7641), 1,
      anon_sym_LBRACK,
    STATE(4367), 1,
      sym_parameter_list,
    STATE(3730), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6798), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6800), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [31017] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 1,
      anon_sym___attribute__,
    STATE(3997), 1,
      sym_attribute_specifier,
    ACTIONS(3731), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3733), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [31085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7655), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(7657), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [31149] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 1,
      anon_sym___attribute__,
    STATE(3908), 1,
      sym_attribute_specifier,
    ACTIONS(3836), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3838), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [31217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2228), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(2230), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [31281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(2234), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [31345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(2246), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [31409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2252), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(2254), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [31473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2190), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(2192), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [31537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(2196), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [31601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2240), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(2242), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [31665] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2371), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2373), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [31731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3178), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(3180), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [31795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2202), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(2204), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [31859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2206), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(2208), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [31923] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 1,
      anon_sym___attribute__,
    STATE(3987), 1,
      sym_attribute_specifier,
    ACTIONS(3725), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3727), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [31991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2740), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [32055] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 1,
      anon_sym___attribute__,
    STATE(3978), 1,
      sym_attribute_specifier,
    ACTIONS(3735), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3737), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [32123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2236), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(2238), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [32187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2224), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(2226), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [32251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2186), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(2188), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [32315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2198), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(2200), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [32379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(2258), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [32443] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2371), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2373), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [32509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2988), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2986), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [32573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2248), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(2250), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [32637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3152), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3150), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [32701] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2217), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(2222), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2212), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [32767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7659), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(7661), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [32831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3098), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3096), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [32895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2948), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2946), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [32959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2908), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [33023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3048), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3046), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [33087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2942), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [33151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2964), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2962), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [33215] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3687), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6846), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6848), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [33283] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4583), 1,
      anon_sym_LBRACE,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    STATE(4266), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6834), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6836), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [33353] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7666), 1,
      anon_sym_LT,
    STATE(3505), 1,
      sym_template_argument_list,
    ACTIONS(6996), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6998), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [33420] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7612), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7015), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7017), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [33497] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7671), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7023), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7025), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [33562] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7675), 1,
      anon_sym_RPAREN,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(9243), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [33675] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7681), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7023), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7025), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [33740] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7402), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7410), 1,
      anon_sym_EQ,
    ACTIONS(7687), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7689), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7691), 1,
      anon_sym_PIPE,
    ACTIONS(7695), 1,
      anon_sym_AMP,
    ACTIONS(7701), 1,
      anon_sym_GT_EQ,
    ACTIONS(7705), 1,
      anon_sym_QMARK,
    ACTIONS(7709), 1,
      anon_sym_or,
    ACTIONS(7711), 1,
      anon_sym_and,
    ACTIONS(7713), 1,
      anon_sym_bitor,
    ACTIONS(7715), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7683), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7693), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7685), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7697), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7699), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7707), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7412), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [33853] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7612), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7037), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7039), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [33930] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7612), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7041), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7043), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [34007] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      sym_literal_suffix,
    STATE(3342), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(2156), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2158), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2128), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
    ACTIONS(2117), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [34078] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7011), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7013), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
  [34153] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_EQ,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7721), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7725), 1,
      anon_sym_PIPE,
    ACTIONS(7729), 1,
      anon_sym_AMP,
    ACTIONS(7735), 1,
      anon_sym_GT_EQ,
    ACTIONS(7739), 1,
      anon_sym_or,
    ACTIONS(7741), 1,
      anon_sym_and,
    ACTIONS(7743), 1,
      anon_sym_bitor,
    ACTIONS(7745), 1,
      anon_sym_bitand,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7612), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7727), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7598), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7719), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7400), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [34262] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7045), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7047), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
  [34337] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(4883), 1,
      anon_sym_LPAREN2,
    ACTIONS(4885), 1,
      anon_sym_STAR,
    ACTIONS(4887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4889), 1,
      anon_sym_AMP,
    ACTIONS(6140), 1,
      sym_identifier,
    ACTIONS(6775), 1,
      anon_sym_LBRACK,
    ACTIONS(6777), 1,
      anon_sym_RPAREN,
    ACTIONS(7072), 1,
      anon_sym_COLON_COLON,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6961), 1,
      sym__scope_resolution,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7902), 1,
      sym__declarator,
    STATE(8214), 1,
      sym__abstract_declarator,
    STATE(10814), 1,
      sym_ms_based_modifier,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [34448] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7422), 1,
      anon_sym_EQ,
    ACTIONS(7687), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7689), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7691), 1,
      anon_sym_PIPE,
    ACTIONS(7695), 1,
      anon_sym_AMP,
    ACTIONS(7701), 1,
      anon_sym_GT_EQ,
    ACTIONS(7709), 1,
      anon_sym_or,
    ACTIONS(7711), 1,
      anon_sym_and,
    ACTIONS(7713), 1,
      anon_sym_bitor,
    ACTIONS(7715), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7683), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7693), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7685), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7697), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7699), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7707), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7424), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [34557] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7358), 1,
      anon_sym_EQ,
    ACTIONS(7687), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7689), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7691), 1,
      anon_sym_PIPE,
    ACTIONS(7695), 1,
      anon_sym_AMP,
    ACTIONS(7701), 1,
      anon_sym_GT_EQ,
    ACTIONS(7709), 1,
      anon_sym_or,
    ACTIONS(7711), 1,
      anon_sym_and,
    ACTIONS(7713), 1,
      anon_sym_bitor,
    ACTIONS(7715), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7683), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7693), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7685), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7697), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7699), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7707), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7360), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [34666] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7358), 1,
      anon_sym_EQ,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7721), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7725), 1,
      anon_sym_PIPE,
    ACTIONS(7729), 1,
      anon_sym_AMP,
    ACTIONS(7735), 1,
      anon_sym_GT_EQ,
    ACTIONS(7739), 1,
      anon_sym_or,
    ACTIONS(7741), 1,
      anon_sym_and,
    ACTIONS(7743), 1,
      anon_sym_bitor,
    ACTIONS(7745), 1,
      anon_sym_bitand,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7612), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7727), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7598), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7719), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7360), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [34775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2824), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [34838] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2217), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(2222), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2212), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [34903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3204), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [34966] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7339), 1,
      anon_sym_LBRACK,
    STATE(3833), 1,
      sym_new_declarator,
    ACTIONS(6924), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6926), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [35033] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      sym_literal_suffix,
    STATE(3342), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(2156), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2158), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6594), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
    ACTIONS(6596), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [35104] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7410), 1,
      anon_sym_EQ,
    ACTIONS(7528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7574), 1,
      anon_sym_QMARK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7721), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7725), 1,
      anon_sym_PIPE,
    ACTIONS(7729), 1,
      anon_sym_AMP,
    ACTIONS(7735), 1,
      anon_sym_GT_EQ,
    ACTIONS(7739), 1,
      anon_sym_or,
    ACTIONS(7741), 1,
      anon_sym_and,
    ACTIONS(7743), 1,
      anon_sym_bitor,
    ACTIONS(7745), 1,
      anon_sym_bitand,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7612), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7727), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7598), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7719), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7412), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [35217] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7406), 1,
      anon_sym_EQ,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7721), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7725), 1,
      anon_sym_PIPE,
    ACTIONS(7729), 1,
      anon_sym_AMP,
    ACTIONS(7735), 1,
      anon_sym_GT_EQ,
    ACTIONS(7739), 1,
      anon_sym_or,
    ACTIONS(7741), 1,
      anon_sym_and,
    ACTIONS(7743), 1,
      anon_sym_bitor,
    ACTIONS(7745), 1,
      anon_sym_bitand,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7612), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7727), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7598), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7719), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7408), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [35326] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4737), 1,
      anon_sym_LBRACE,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    STATE(4482), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6820), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6822), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [35395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2491), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2489), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [35458] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7402), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7414), 1,
      anon_sym_EQ,
    ACTIONS(7687), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7689), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7691), 1,
      anon_sym_PIPE,
    ACTIONS(7695), 1,
      anon_sym_AMP,
    ACTIONS(7701), 1,
      anon_sym_GT_EQ,
    ACTIONS(7705), 1,
      anon_sym_QMARK,
    ACTIONS(7709), 1,
      anon_sym_or,
    ACTIONS(7711), 1,
      anon_sym_and,
    ACTIONS(7713), 1,
      anon_sym_bitor,
    ACTIONS(7715), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7683), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7693), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7685), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7697), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7699), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7707), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7416), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [35571] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3392), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3390), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [35634] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3404), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3402), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [35697] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7444), 1,
      anon_sym_LBRACK,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7511), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(7749), 1,
      anon_sym_requires,
    ACTIONS(7752), 1,
      anon_sym_where,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(5849), 1,
      sym__function_attributes_start,
    STATE(6031), 1,
      sym_ref_qualifier,
    STATE(6792), 1,
      sym__function_attributes_end,
    STATE(6984), 1,
      sym_trailing_return_type,
    STATE(7161), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7626), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4858), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5151), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7392), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6419), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7432), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [35814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2536), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2534), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [35877] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7178), 1,
      anon_sym_EQ,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7574), 1,
      anon_sym_QMARK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7721), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7725), 1,
      anon_sym_PIPE,
    ACTIONS(7729), 1,
      anon_sym_AMP,
    ACTIONS(7735), 1,
      anon_sym_GT_EQ,
    ACTIONS(7739), 1,
      anon_sym_or,
    ACTIONS(7741), 1,
      anon_sym_and,
    ACTIONS(7743), 1,
      anon_sym_bitor,
    ACTIONS(7745), 1,
      anon_sym_bitand,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7612), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7727), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7598), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7719), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7180), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [35990] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4737), 1,
      anon_sym_LBRACE,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    STATE(4464), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6859), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6861), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [36059] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7683), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7685), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7707), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7007), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [36144] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7701), 1,
      anon_sym_GT_EQ,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7683), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7685), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7699), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7707), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7007), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [36233] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4737), 1,
      anon_sym_LBRACE,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    STATE(4455), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6834), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6836), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [36302] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7701), 1,
      anon_sym_GT_EQ,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7683), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7685), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7697), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7699), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7707), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7007), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
  [36393] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7695), 1,
      anon_sym_AMP,
    ACTIONS(7701), 1,
      anon_sym_GT_EQ,
    ACTIONS(7715), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7683), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7685), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7697), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7699), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7707), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7007), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [36488] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7612), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7719), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7007), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [36567] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7695), 1,
      anon_sym_AMP,
    ACTIONS(7701), 1,
      anon_sym_GT_EQ,
    ACTIONS(7715), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7683), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7693), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7685), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7697), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7699), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7707), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7007), 4,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7009), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [36664] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7691), 1,
      anon_sym_PIPE,
    ACTIONS(7695), 1,
      anon_sym_AMP,
    ACTIONS(7701), 1,
      anon_sym_GT_EQ,
    ACTIONS(7713), 1,
      anon_sym_bitor,
    ACTIONS(7715), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7683), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7693), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7007), 3,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7685), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7697), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7699), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7707), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [36765] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7689), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7691), 1,
      anon_sym_PIPE,
    ACTIONS(7695), 1,
      anon_sym_AMP,
    ACTIONS(7701), 1,
      anon_sym_GT_EQ,
    ACTIONS(7711), 1,
      anon_sym_and,
    ACTIONS(7713), 1,
      anon_sym_bitor,
    ACTIONS(7715), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7007), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(7683), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7693), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7685), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7697), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7699), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7707), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [36870] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7639), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3765), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6855), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6857), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [36937] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7755), 1,
      anon_sym_LT,
    STATE(3679), 1,
      sym_template_argument_list,
    ACTIONS(6996), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6998), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [37004] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7398), 1,
      anon_sym_EQ,
    ACTIONS(7687), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7689), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7691), 1,
      anon_sym_PIPE,
    ACTIONS(7695), 1,
      anon_sym_AMP,
    ACTIONS(7701), 1,
      anon_sym_GT_EQ,
    ACTIONS(7709), 1,
      anon_sym_or,
    ACTIONS(7711), 1,
      anon_sym_and,
    ACTIONS(7713), 1,
      anon_sym_bitor,
    ACTIONS(7715), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7683), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7693), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7685), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7697), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7699), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7707), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7400), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [37113] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7685), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7007), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [37192] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7612), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7007), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [37269] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7683), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7685), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7007), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [37350] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7683), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7685), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7007), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [37433] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7422), 1,
      anon_sym_EQ,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7721), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7725), 1,
      anon_sym_PIPE,
    ACTIONS(7729), 1,
      anon_sym_AMP,
    ACTIONS(7735), 1,
      anon_sym_GT_EQ,
    ACTIONS(7739), 1,
      anon_sym_or,
    ACTIONS(7741), 1,
      anon_sym_and,
    ACTIONS(7743), 1,
      anon_sym_bitor,
    ACTIONS(7745), 1,
      anon_sym_bitand,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7612), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7727), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7598), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7719), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7424), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [37542] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7725), 1,
      anon_sym_PIPE,
    ACTIONS(7729), 1,
      anon_sym_AMP,
    ACTIONS(7735), 1,
      anon_sym_GT_EQ,
    ACTIONS(7741), 1,
      anon_sym_and,
    ACTIONS(7743), 1,
      anon_sym_bitor,
    ACTIONS(7745), 1,
      anon_sym_bitand,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7007), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(7612), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7727), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7598), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7719), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [37647] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4737), 1,
      anon_sym_LBRACE,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    STATE(4448), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6883), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6885), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [37716] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    ACTIONS(7760), 1,
      anon_sym_LBRACE,
    STATE(4692), 1,
      sym_field_declaration_list,
    STATE(4813), 1,
      sym_attribute_specifier,
    STATE(8735), 1,
      sym_virtual_specifier,
    STATE(9705), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2683), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2685), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [37795] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7725), 1,
      anon_sym_PIPE,
    ACTIONS(7729), 1,
      anon_sym_AMP,
    ACTIONS(7735), 1,
      anon_sym_GT_EQ,
    ACTIONS(7743), 1,
      anon_sym_bitor,
    ACTIONS(7745), 1,
      anon_sym_bitand,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7612), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7727), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7007), 3,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7598), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7719), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [37896] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7729), 1,
      anon_sym_AMP,
    ACTIONS(7735), 1,
      anon_sym_GT_EQ,
    ACTIONS(7745), 1,
      anon_sym_bitand,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7612), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7727), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7598), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7719), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 4,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7009), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_DASH_GT_STAR,
  [37993] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7729), 1,
      anon_sym_AMP,
    ACTIONS(7735), 1,
      anon_sym_GT_EQ,
    ACTIONS(7745), 1,
      anon_sym_bitand,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7612), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7598), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7719), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_DASH_GT_STAR,
  [38088] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    STATE(2816), 1,
      sym_template_argument_list,
    STATE(4370), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7762), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3483), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3485), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [38159] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7735), 1,
      anon_sym_GT_EQ,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7612), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7598), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7719), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_DASH_GT_STAR,
  [38250] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7735), 1,
      anon_sym_GT_EQ,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7612), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7598), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7719), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [38339] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7612), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7598), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7719), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7007), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [38424] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7444), 1,
      anon_sym_LBRACK,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7511), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(7764), 1,
      anon_sym_requires,
    ACTIONS(7766), 1,
      anon_sym_where,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(5798), 1,
      sym__function_attributes_start,
    STATE(6032), 1,
      sym_ref_qualifier,
    STATE(6777), 1,
      sym__function_attributes_end,
    STATE(7002), 1,
      sym_trailing_return_type,
    STATE(7161), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4858), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5151), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7759), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6376), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7432), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [38541] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7612), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6984), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6986), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [38618] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7612), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7719), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7007), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [38699] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7178), 1,
      anon_sym_EQ,
    ACTIONS(7402), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7687), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7689), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7691), 1,
      anon_sym_PIPE,
    ACTIONS(7695), 1,
      anon_sym_AMP,
    ACTIONS(7701), 1,
      anon_sym_GT_EQ,
    ACTIONS(7705), 1,
      anon_sym_QMARK,
    ACTIONS(7709), 1,
      anon_sym_or,
    ACTIONS(7711), 1,
      anon_sym_and,
    ACTIONS(7713), 1,
      anon_sym_bitor,
    ACTIONS(7715), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7683), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7693), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7685), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7697), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7699), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7707), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7180), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [38812] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3176), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3174), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [38875] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7768), 1,
      anon_sym_LT,
    STATE(4112), 1,
      sym_template_argument_list,
    ACTIONS(6928), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6930), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [38944] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7612), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7719), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7007), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [39027] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7414), 1,
      anon_sym_EQ,
    ACTIONS(7528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7574), 1,
      anon_sym_QMARK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7721), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7725), 1,
      anon_sym_PIPE,
    ACTIONS(7729), 1,
      anon_sym_AMP,
    ACTIONS(7735), 1,
      anon_sym_GT_EQ,
    ACTIONS(7739), 1,
      anon_sym_or,
    ACTIONS(7741), 1,
      anon_sym_and,
    ACTIONS(7743), 1,
      anon_sym_bitor,
    ACTIONS(7745), 1,
      anon_sym_bitand,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7612), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7727), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7598), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7719), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7416), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [39140] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7771), 1,
      anon_sym_LT,
    STATE(4112), 1,
      sym_template_argument_list,
    ACTIONS(6952), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6954), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [39209] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2176), 1,
      anon_sym_LBRACE,
    ACTIONS(6515), 1,
      anon_sym_LT,
    STATE(4135), 1,
      sym_template_argument_list,
    ACTIONS(2181), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2171), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [39280] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7406), 1,
      anon_sym_EQ,
    ACTIONS(7687), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7689), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7691), 1,
      anon_sym_PIPE,
    ACTIONS(7695), 1,
      anon_sym_AMP,
    ACTIONS(7701), 1,
      anon_sym_GT_EQ,
    ACTIONS(7709), 1,
      anon_sym_or,
    ACTIONS(7711), 1,
      anon_sym_and,
    ACTIONS(7713), 1,
      anon_sym_bitor,
    ACTIONS(7715), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7683), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7693), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7685), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7697), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7699), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7707), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7408), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [39389] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2742), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2740), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [39454] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7666), 1,
      anon_sym_LT,
    STATE(1369), 1,
      sym_template_argument_list,
    ACTIONS(6996), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6998), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [39521] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(4883), 1,
      anon_sym_LPAREN2,
    ACTIONS(4885), 1,
      anon_sym_STAR,
    ACTIONS(4887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4889), 1,
      anon_sym_AMP,
    ACTIONS(6140), 1,
      sym_identifier,
    ACTIONS(6775), 1,
      anon_sym_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7418), 1,
      anon_sym_RPAREN,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6961), 1,
      sym__scope_resolution,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7758), 1,
      sym__declarator,
    STATE(8177), 1,
      sym__abstract_declarator,
    STATE(10814), 1,
      sym_ms_based_modifier,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [39632] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7755), 1,
      anon_sym_LT,
    STATE(2836), 1,
      sym_template_argument_list,
    ACTIONS(6996), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6998), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [39699] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7444), 1,
      anon_sym_LBRACK,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7511), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7629), 1,
      anon_sym_requires,
    ACTIONS(7774), 1,
      anon_sym___attribute__,
    ACTIONS(7777), 1,
      anon_sym_DASH_GT,
    ACTIONS(7779), 1,
      anon_sym_where,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(5822), 1,
      sym__function_attributes_start,
    STATE(6055), 1,
      sym_ref_qualifier,
    STATE(6613), 1,
      sym__function_attributes_end,
    STATE(6942), 1,
      sym_trailing_return_type,
    STATE(7161), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7626), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4858), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5151), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7339), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6359), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7432), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [39816] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7444), 1,
      anon_sym_LBRACK,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7511), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7774), 1,
      anon_sym___attribute__,
    ACTIONS(7777), 1,
      anon_sym_DASH_GT,
    ACTIONS(7782), 1,
      anon_sym_where,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(5864), 1,
      sym__function_attributes_start,
    STATE(6049), 1,
      sym_ref_qualifier,
    STATE(6727), 1,
      sym__function_attributes_end,
    STATE(6966), 1,
      sym_trailing_return_type,
    STATE(7161), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4858), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5151), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7613), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6380), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7432), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [39933] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7784), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3765), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6846), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6848), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [40000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3156), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3154), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [40062] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2397), 1,
      anon_sym_STAR,
    ACTIONS(2399), 1,
      anon_sym_AMP,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6140), 1,
      sym_identifier,
    ACTIONS(7072), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6961), 1,
      sym__scope_resolution,
    STATE(7758), 1,
      sym__declarator,
    STATE(10814), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4823), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4838), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [40170] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4826), 1,
      sym_type_specifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7197), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4351), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [40280] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(8274), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [40390] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9494), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [40500] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9421), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [40610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5933), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(5935), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [40672] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4982), 1,
      sym_type_specifier,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7605), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4241), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [40782] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9518), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [40892] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10367), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [41002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2998), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [41064] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7833), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    ACTIONS(7849), 1,
      anon_sym_interface,
    ACTIONS(7851), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(6114), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6116), 1,
      sym_type_specifier,
    STATE(6793), 1,
      sym__type_definition_type,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4320), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [41174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2996), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2994), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [41236] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9481), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [41346] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10699), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [41456] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9255), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [41566] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4960), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(8187), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4248), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [41676] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7011), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7013), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [41750] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7861), 1,
      sym_identifier,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(7869), 1,
      anon_sym_enum,
    ACTIONS(7871), 1,
      anon_sym_class,
    ACTIONS(7873), 1,
      anon_sym_struct,
    ACTIONS(7875), 1,
      anon_sym_union,
    ACTIONS(7877), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      anon_sym_interface,
    ACTIONS(7881), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5512), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5679), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(8323), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4350), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7865), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [41860] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7883), 1,
      anon_sym_DOT,
    ACTIONS(7509), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3890), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3892), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [41926] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7037), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7039), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [42002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7196), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7198), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [42064] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7861), 1,
      sym_identifier,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(7869), 1,
      anon_sym_enum,
    ACTIONS(7871), 1,
      anon_sym_class,
    ACTIONS(7873), 1,
      anon_sym_struct,
    ACTIONS(7875), 1,
      anon_sym_union,
    ACTIONS(7877), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      anon_sym_interface,
    ACTIONS(7881), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5512), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5679), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(8333), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4350), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7865), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [42174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7186), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7188), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [42236] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7041), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7043), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [42312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5925), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(5927), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [42374] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7398), 1,
      anon_sym_EQ,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(7889), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7893), 1,
      anon_sym_PIPE,
    ACTIONS(7897), 1,
      anon_sym_AMP,
    ACTIONS(7903), 1,
      anon_sym_GT_EQ,
    ACTIONS(7909), 1,
      anon_sym_or,
    ACTIONS(7911), 1,
      anon_sym_and,
    ACTIONS(7913), 1,
      anon_sym_bitor,
    ACTIONS(7915), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7885), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7895), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7905), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7887), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7899), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7901), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7907), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7400), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [42482] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7045), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7047), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [42556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4573), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4575), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [42618] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(8951), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [42728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6867), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6869), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [42790] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7406), 1,
      anon_sym_EQ,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(7889), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7893), 1,
      anon_sym_PIPE,
    ACTIONS(7897), 1,
      anon_sym_AMP,
    ACTIONS(7903), 1,
      anon_sym_GT_EQ,
    ACTIONS(7909), 1,
      anon_sym_or,
    ACTIONS(7911), 1,
      anon_sym_and,
    ACTIONS(7913), 1,
      anon_sym_bitor,
    ACTIONS(7915), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7885), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7895), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7905), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7887), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7899), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7901), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7907), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7408), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [42898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3152), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3150), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [42960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3098), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3096), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [43022] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7178), 1,
      anon_sym_EQ,
    ACTIONS(7402), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(7889), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7893), 1,
      anon_sym_PIPE,
    ACTIONS(7897), 1,
      anon_sym_AMP,
    ACTIONS(7903), 1,
      anon_sym_GT_EQ,
    ACTIONS(7909), 1,
      anon_sym_or,
    ACTIONS(7911), 1,
      anon_sym_and,
    ACTIONS(7913), 1,
      anon_sym_bitor,
    ACTIONS(7915), 1,
      anon_sym_bitand,
    ACTIONS(7917), 1,
      anon_sym_QMARK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7885), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7895), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7905), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7887), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7899), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7901), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7907), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7180), 15,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [43134] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5316), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7142), 1,
      sym_type_descriptor,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4393), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [43244] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4960), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7167), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4248), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [43354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3048), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3046), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [43416] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7887), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7007), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [43494] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7007), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [43570] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(7891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7893), 1,
      anon_sym_PIPE,
    ACTIONS(7897), 1,
      anon_sym_AMP,
    ACTIONS(7903), 1,
      anon_sym_GT_EQ,
    ACTIONS(7911), 1,
      anon_sym_and,
    ACTIONS(7913), 1,
      anon_sym_bitor,
    ACTIONS(7915), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7007), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7885), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7895), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7905), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7887), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7899), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7901), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7907), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [43674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6895), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6897), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [43736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6810), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6812), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [43798] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6761), 1,
      sym_identifier,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7264), 1,
      sym__declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4823), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4841), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [43906] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2988), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2986), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [43968] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6044), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6046), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [44030] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7925), 1,
      sym_identifier,
    ACTIONS(7930), 1,
      sym_primitive_type,
    STATE(2906), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7928), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3820), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3822), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [44100] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(7893), 1,
      anon_sym_PIPE,
    ACTIONS(7897), 1,
      anon_sym_AMP,
    ACTIONS(7903), 1,
      anon_sym_GT_EQ,
    ACTIONS(7913), 1,
      anon_sym_bitor,
    ACTIONS(7915), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7885), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7895), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7905), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7007), 3,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7887), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7899), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7901), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7907), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [44200] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7932), 1,
      sym_identifier,
    STATE(3859), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(6651), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6653), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6439), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6437), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [44270] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7902), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4823), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4842), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [44378] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4960), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7148), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4248), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [44488] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6761), 1,
      sym_identifier,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7944), 1,
      anon_sym_STAR,
    ACTIONS(7946), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7948), 1,
      anon_sym_AMP,
    ACTIONS(7950), 1,
      anon_sym_COLON_COLON,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6954), 1,
      sym__scope_resolution,
    STATE(8109), 1,
      sym__declarator,
    STATE(10201), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4085), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4834), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [44596] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(7897), 1,
      anon_sym_AMP,
    ACTIONS(7903), 1,
      anon_sym_GT_EQ,
    ACTIONS(7915), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7885), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7895), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7905), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7887), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7899), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7901), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7907), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7007), 4,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7009), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [44692] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9576), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [44802] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7952), 1,
      anon_sym_LT,
    STATE(4354), 1,
      sym_template_argument_list,
    ACTIONS(6928), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6930), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [44870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2740), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [44932] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(8955), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [45042] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4960), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7631), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4248), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [45152] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7861), 1,
      sym_identifier,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(7869), 1,
      anon_sym_enum,
    ACTIONS(7871), 1,
      anon_sym_class,
    ACTIONS(7873), 1,
      anon_sym_struct,
    ACTIONS(7875), 1,
      anon_sym_union,
    ACTIONS(7877), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      anon_sym_interface,
    ACTIONS(7881), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5512), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5679), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(8348), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4350), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7865), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [45262] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7861), 1,
      sym_identifier,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(7869), 1,
      anon_sym_enum,
    ACTIONS(7871), 1,
      anon_sym_class,
    ACTIONS(7873), 1,
      anon_sym_struct,
    ACTIONS(7875), 1,
      anon_sym_union,
    ACTIONS(7877), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      anon_sym_interface,
    ACTIONS(7881), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5512), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5679), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7148), 1,
      sym_type_descriptor,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4350), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7865), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [45372] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7861), 1,
      sym_identifier,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(7869), 1,
      anon_sym_enum,
    ACTIONS(7871), 1,
      anon_sym_class,
    ACTIONS(7873), 1,
      anon_sym_struct,
    ACTIONS(7875), 1,
      anon_sym_union,
    ACTIONS(7877), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      anon_sym_interface,
    ACTIONS(7881), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5086), 1,
      sym_type_specifier,
    STATE(5512), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7142), 1,
      sym_type_descriptor,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4400), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7865), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [45482] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7758), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4819), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4823), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [45590] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7616), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7618), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7955), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7957), 1,
      anon_sym_COMMA,
    ACTIONS(7959), 1,
      anon_sym_RPAREN,
    ACTIONS(7961), 1,
      anon_sym_DASH,
    ACTIONS(7963), 1,
      anon_sym_PLUS,
    ACTIONS(7965), 1,
      anon_sym_STAR,
    ACTIONS(7967), 1,
      anon_sym_SLASH,
    ACTIONS(7969), 1,
      anon_sym_PERCENT,
    ACTIONS(7971), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7973), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_CARET,
    ACTIONS(7979), 1,
      anon_sym_AMP,
    ACTIONS(7981), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7983), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7985), 1,
      anon_sym_GT,
    ACTIONS(7987), 1,
      anon_sym_GT_EQ,
    ACTIONS(7989), 1,
      anon_sym_LT_EQ,
    ACTIONS(7991), 1,
      anon_sym_LT,
    ACTIONS(7993), 1,
      anon_sym_LT_LT,
    ACTIONS(7995), 1,
      anon_sym_GT_GT,
    ACTIONS(7997), 1,
      anon_sym_EQ,
    ACTIONS(7999), 1,
      anon_sym_QMARK,
    ACTIONS(8001), 1,
      anon_sym_STAR_EQ,
    ACTIONS(8003), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(8005), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(8007), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(8009), 1,
      anon_sym_DASH_EQ,
    ACTIONS(8011), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(8013), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(8015), 1,
      anon_sym_AMP_EQ,
    ACTIONS(8017), 1,
      anon_sym_CARET_EQ,
    ACTIONS(8019), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(8023), 1,
      anon_sym_or,
    ACTIONS(8025), 1,
      anon_sym_and,
    ACTIONS(8027), 1,
      anon_sym_bitor,
    ACTIONS(8029), 1,
      anon_sym_xor,
    ACTIONS(8031), 1,
      anon_sym_bitand,
    ACTIONS(8033), 1,
      anon_sym_not_eq,
    STATE(2393), 1,
      sym__binary_fold_operator,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    STATE(10128), 1,
      sym__fold_operator,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8021), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [45748] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7861), 1,
      sym_identifier,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(7869), 1,
      anon_sym_enum,
    ACTIONS(7871), 1,
      anon_sym_class,
    ACTIONS(7873), 1,
      anon_sym_struct,
    ACTIONS(7875), 1,
      anon_sym_union,
    ACTIONS(7877), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      anon_sym_interface,
    ACTIONS(7881), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5512), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5679), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7167), 1,
      sym_type_descriptor,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4350), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7865), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [45858] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8037), 1,
      anon_sym_LT,
    STATE(3706), 1,
      sym_template_argument_list,
    ACTIONS(6996), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6998), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [45924] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4826), 1,
      sym_type_specifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7308), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4351), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [46034] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10341), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [46144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6970), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6972), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [46206] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4982), 1,
      sym_type_specifier,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7704), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4241), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [46316] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(7897), 1,
      anon_sym_AMP,
    ACTIONS(7903), 1,
      anon_sym_GT_EQ,
    ACTIONS(7915), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7885), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7905), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7887), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7899), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7901), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7907), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7007), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [46410] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(7903), 1,
      anon_sym_GT_EQ,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7885), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7905), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7887), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7899), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7901), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7907), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7007), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
  [46500] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4826), 1,
      sym_type_specifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7301), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4351), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [46610] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(7903), 1,
      anon_sym_GT_EQ,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7885), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7905), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7887), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7901), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7907), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7007), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [46698] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7899), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3815), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4844), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [46806] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7885), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7905), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7887), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7907), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7007), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [46890] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5892), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(5894), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [46952] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7885), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7887), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7007), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [47032] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7885), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7905), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7887), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7007), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [47114] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4982), 1,
      sym_type_specifier,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7706), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4241), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [47224] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4826), 1,
      sym_type_specifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7175), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4351), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [47334] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10244), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [47444] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4960), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7639), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4248), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [47554] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10754), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [47664] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10147), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [47774] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4788), 1,
      sym_type_specifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7157), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4265), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [47884] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10146), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [47994] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6984), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6986), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [48070] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7358), 1,
      anon_sym_EQ,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(7889), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7893), 1,
      anon_sym_PIPE,
    ACTIONS(7897), 1,
      anon_sym_AMP,
    ACTIONS(7903), 1,
      anon_sym_GT_EQ,
    ACTIONS(7909), 1,
      anon_sym_or,
    ACTIONS(7911), 1,
      anon_sym_and,
    ACTIONS(7913), 1,
      anon_sym_bitor,
    ACTIONS(7915), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7885), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7895), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7905), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7887), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7899), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7901), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7907), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7360), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [48178] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7402), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7410), 1,
      anon_sym_EQ,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(7889), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7893), 1,
      anon_sym_PIPE,
    ACTIONS(7897), 1,
      anon_sym_AMP,
    ACTIONS(7903), 1,
      anon_sym_GT_EQ,
    ACTIONS(7909), 1,
      anon_sym_or,
    ACTIONS(7911), 1,
      anon_sym_and,
    ACTIONS(7913), 1,
      anon_sym_bitor,
    ACTIONS(7915), 1,
      anon_sym_bitand,
    ACTIONS(7917), 1,
      anon_sym_QMARK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7885), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7895), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7905), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7887), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7899), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7901), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7907), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7412), 15,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [48290] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6871), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6873), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [48352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6613), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6611), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [48414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5937), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(5939), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [48476] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(8313), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [48586] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8040), 1,
      sym_identifier,
    STATE(4092), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(6651), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6653), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6458), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6456), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [48656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2740), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [48718] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7833), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    ACTIONS(7849), 1,
      anon_sym_interface,
    ACTIONS(7851), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(6114), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6116), 1,
      sym_type_specifier,
    STATE(6782), 1,
      sym__type_definition_type,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4320), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [48828] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9599), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [48938] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    STATE(2816), 1,
      sym_template_argument_list,
    STATE(2949), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6167), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3483), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(3485), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [49008] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3388), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3386), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [49070] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4826), 1,
      sym_type_specifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7171), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4351), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [49180] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7861), 1,
      sym_identifier,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(7869), 1,
      anon_sym_enum,
    ACTIONS(7871), 1,
      anon_sym_class,
    ACTIONS(7873), 1,
      anon_sym_struct,
    ACTIONS(7875), 1,
      anon_sym_union,
    ACTIONS(7877), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      anon_sym_interface,
    ACTIONS(7881), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5086), 1,
      sym_type_specifier,
    STATE(5512), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7148), 1,
      sym_type_descriptor,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4400), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7865), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [49290] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5261), 1,
      sym_type_specifier,
    STATE(7142), 1,
      sym_type_descriptor,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4342), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [49400] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9077), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [49510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6838), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6840), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [49572] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7422), 1,
      anon_sym_EQ,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(7889), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7893), 1,
      anon_sym_PIPE,
    ACTIONS(7897), 1,
      anon_sym_AMP,
    ACTIONS(7903), 1,
      anon_sym_GT_EQ,
    ACTIONS(7909), 1,
      anon_sym_or,
    ACTIONS(7911), 1,
      anon_sym_and,
    ACTIONS(7913), 1,
      anon_sym_bitor,
    ACTIONS(7915), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7885), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7895), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7905), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7887), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7899), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7901), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7907), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7424), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [49680] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4960), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7620), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4248), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [49790] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7902), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3827), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4842), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [49898] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10425), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [50008] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(7148), 1,
      sym_type_descriptor,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [50118] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4826), 1,
      sym_type_specifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7207), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4351), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [50228] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4788), 1,
      sym_type_specifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7012), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4265), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [50338] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7402), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7414), 1,
      anon_sym_EQ,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(7889), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7893), 1,
      anon_sym_PIPE,
    ACTIONS(7897), 1,
      anon_sym_AMP,
    ACTIONS(7903), 1,
      anon_sym_GT_EQ,
    ACTIONS(7909), 1,
      anon_sym_or,
    ACTIONS(7911), 1,
      anon_sym_and,
    ACTIONS(7913), 1,
      anon_sym_bitor,
    ACTIONS(7915), 1,
      anon_sym_bitand,
    ACTIONS(7917), 1,
      anon_sym_QMARK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7885), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7895), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7905), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7887), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7899), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7901), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7907), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7416), 15,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [50450] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(7148), 1,
      sym_type_descriptor,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [50560] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(7167), 1,
      sym_type_descriptor,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [50670] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5093), 1,
      sym_type_specifier,
    STATE(7819), 1,
      sym_type_descriptor,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4392), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [50780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3844), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3846), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [50842] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5093), 1,
      sym_type_specifier,
    STATE(7823), 1,
      sym_type_descriptor,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4392), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [50952] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5093), 1,
      sym_type_specifier,
    STATE(7148), 1,
      sym_type_descriptor,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4392), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [51062] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5785), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10639), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4296), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [51172] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10634), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [51282] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7861), 1,
      sym_identifier,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(7869), 1,
      anon_sym_enum,
    ACTIONS(7871), 1,
      anon_sym_class,
    ACTIONS(7873), 1,
      anon_sym_struct,
    ACTIONS(7875), 1,
      anon_sym_union,
    ACTIONS(7877), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      anon_sym_interface,
    ACTIONS(7881), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5086), 1,
      sym_type_specifier,
    STATE(5512), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7748), 1,
      sym_type_descriptor,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4400), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7865), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [51392] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(8969), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [51502] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7861), 1,
      sym_identifier,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(7869), 1,
      anon_sym_enum,
    ACTIONS(7871), 1,
      anon_sym_class,
    ACTIONS(7873), 1,
      anon_sym_struct,
    ACTIONS(7875), 1,
      anon_sym_union,
    ACTIONS(7877), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      anon_sym_interface,
    ACTIONS(7881), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5086), 1,
      sym_type_specifier,
    STATE(5512), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7167), 1,
      sym_type_descriptor,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4400), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7865), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [51612] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7833), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    ACTIONS(7849), 1,
      anon_sym_interface,
    ACTIONS(7851), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(6114), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6116), 1,
      sym_type_specifier,
    STATE(6761), 1,
      sym__type_definition_type,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4320), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [51722] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5093), 1,
      sym_type_specifier,
    STATE(7167), 1,
      sym_type_descriptor,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4392), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [51832] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8042), 1,
      sym_identifier,
    ACTIONS(8044), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8048), 1,
      sym_primitive_type,
    ACTIONS(8050), 1,
      anon_sym_enum,
    ACTIONS(8052), 1,
      anon_sym_class,
    ACTIONS(8054), 1,
      anon_sym_struct,
    ACTIONS(8056), 1,
      anon_sym_union,
    ACTIONS(8058), 1,
      anon_sym_typename,
    ACTIONS(8060), 1,
      anon_sym_interface,
    ACTIONS(8062), 1,
      anon_sym_extension,
    STATE(405), 1,
      sym_qualified_type_identifier,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5463), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5761), 1,
      sym_type_specifier,
    STATE(8039), 1,
      sym__scope_resolution,
    STATE(8487), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4275), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(121), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8046), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(361), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [51942] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4960), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7968), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4248), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [52052] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5093), 1,
      sym_type_specifier,
    STATE(7142), 1,
      sym_type_descriptor,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4392), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [52162] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7833), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    ACTIONS(7849), 1,
      anon_sym_interface,
    ACTIONS(7851), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(6114), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6116), 1,
      sym_type_specifier,
    STATE(6770), 1,
      sym__type_definition_type,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4320), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [52272] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7666), 1,
      anon_sym_LT,
    STATE(1398), 1,
      sym_template_argument_list,
    ACTIONS(6996), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6998), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [52338] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(8064), 1,
      sym_identifier,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8070), 1,
      anon_sym_enum,
    ACTIONS(8072), 1,
      anon_sym_class,
    ACTIONS(8074), 1,
      anon_sym_struct,
    ACTIONS(8076), 1,
      anon_sym_union,
    ACTIONS(8078), 1,
      anon_sym_typename,
    ACTIONS(8080), 1,
      anon_sym_interface,
    ACTIONS(8082), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5859), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6009), 1,
      sym_type_specifier,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(10462), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4331), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8068), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [52448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2908), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [52510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7061), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [52572] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4763), 1,
      sym_type_specifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7142), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4341), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [52682] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(10772), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [52792] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4960), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(8189), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4248), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [52902] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10449), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [53012] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7755), 1,
      anon_sym_LT,
    STATE(1393), 1,
      sym_template_argument_list,
    ACTIONS(6996), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6998), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [53078] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7833), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    ACTIONS(7849), 1,
      anon_sym_interface,
    ACTIONS(7851), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(6114), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6116), 1,
      sym_type_specifier,
    STATE(6762), 1,
      sym__type_definition_type,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4320), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [53188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3190), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [53250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3202), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3200), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [53312] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4763), 1,
      sym_type_specifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7583), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4341), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [53422] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2942), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [53484] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5176), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7951), 1,
      sym_type_descriptor,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4343), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [53594] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5176), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7923), 1,
      sym_type_descriptor,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4343), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [53704] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5176), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7148), 1,
      sym_type_descriptor,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4343), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [53814] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5176), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7167), 1,
      sym_type_descriptor,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4343), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [53924] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5785), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10506), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4296), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [54034] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9412), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [54144] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9486), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [54254] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7402), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7477), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7479), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7481), 1,
      anon_sym_PIPE,
    ACTIONS(7485), 1,
      anon_sym_AMP,
    ACTIONS(7491), 1,
      anon_sym_GT_EQ,
    ACTIONS(7497), 1,
      anon_sym_or,
    ACTIONS(7499), 1,
      anon_sym_and,
    ACTIONS(7501), 1,
      anon_sym_bitor,
    ACTIONS(7503), 1,
      anon_sym_bitand,
    ACTIONS(7520), 1,
      anon_sym_QMARK,
    ACTIONS(7620), 1,
      anon_sym_RPAREN,
    ACTIONS(8084), 1,
      anon_sym_COMMA,
    ACTIONS(8086), 1,
      anon_sym_EQ,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7473), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7483), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7493), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7487), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7489), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7495), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7596), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [54370] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6140), 1,
      sym_identifier,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(8088), 1,
      anon_sym_STAR,
    ACTIONS(8090), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8092), 1,
      anon_sym_AMP,
    ACTIONS(8094), 1,
      anon_sym_COLON_COLON,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6902), 1,
      sym__scope_resolution,
    STATE(8151), 1,
      sym__declarator,
    STATE(10164), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4091), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4833), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [54478] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4763), 1,
      sym_type_specifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7760), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4341), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [54588] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7616), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7618), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7955), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7957), 1,
      anon_sym_COMMA,
    ACTIONS(7961), 1,
      anon_sym_DASH,
    ACTIONS(7963), 1,
      anon_sym_PLUS,
    ACTIONS(7965), 1,
      anon_sym_STAR,
    ACTIONS(7967), 1,
      anon_sym_SLASH,
    ACTIONS(7969), 1,
      anon_sym_PERCENT,
    ACTIONS(7971), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7973), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_CARET,
    ACTIONS(7979), 1,
      anon_sym_AMP,
    ACTIONS(7981), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7983), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7985), 1,
      anon_sym_GT,
    ACTIONS(7987), 1,
      anon_sym_GT_EQ,
    ACTIONS(7989), 1,
      anon_sym_LT_EQ,
    ACTIONS(7991), 1,
      anon_sym_LT,
    ACTIONS(7993), 1,
      anon_sym_LT_LT,
    ACTIONS(7995), 1,
      anon_sym_GT_GT,
    ACTIONS(7997), 1,
      anon_sym_EQ,
    ACTIONS(7999), 1,
      anon_sym_QMARK,
    ACTIONS(8001), 1,
      anon_sym_STAR_EQ,
    ACTIONS(8003), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(8005), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(8007), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(8009), 1,
      anon_sym_DASH_EQ,
    ACTIONS(8011), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(8013), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(8015), 1,
      anon_sym_AMP_EQ,
    ACTIONS(8017), 1,
      anon_sym_CARET_EQ,
    ACTIONS(8019), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(8023), 1,
      anon_sym_or,
    ACTIONS(8025), 1,
      anon_sym_and,
    ACTIONS(8027), 1,
      anon_sym_bitor,
    ACTIONS(8029), 1,
      anon_sym_xor,
    ACTIONS(8031), 1,
      anon_sym_bitand,
    ACTIONS(8033), 1,
      anon_sym_not_eq,
    ACTIONS(8096), 1,
      anon_sym_RPAREN,
    STATE(2393), 1,
      sym__binary_fold_operator,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    STATE(10128), 1,
      sym__fold_operator,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8021), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [54746] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9008), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [54856] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4763), 1,
      sym_type_specifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7167), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4341), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [54966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3338), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3336), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [55028] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3362), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3360), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [55090] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7861), 1,
      sym_identifier,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(7869), 1,
      anon_sym_enum,
    ACTIONS(7871), 1,
      anon_sym_class,
    ACTIONS(7873), 1,
      anon_sym_struct,
    ACTIONS(7875), 1,
      anon_sym_union,
    ACTIONS(7877), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      anon_sym_interface,
    ACTIONS(7881), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5086), 1,
      sym_type_specifier,
    STATE(5512), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7863), 1,
      sym_type_descriptor,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4400), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7865), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [55200] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5785), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10613), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4296), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [55310] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10229), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [55420] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9336), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [55530] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2397), 1,
      anon_sym_STAR,
    ACTIONS(2399), 1,
      anon_sym_AMP,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6140), 1,
      sym_identifier,
    ACTIONS(7072), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6961), 1,
      sym__scope_resolution,
    STATE(7902), 1,
      sym__declarator,
    STATE(10814), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3767), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4821), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [55638] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5858), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(5860), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [55700] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(7167), 1,
      sym_type_descriptor,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [55810] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10608), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [55920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3366), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3364), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [55982] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4960), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7995), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4248), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [56092] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(8974), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [56202] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7833), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    ACTIONS(7849), 1,
      anon_sym_interface,
    ACTIONS(7851), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(6114), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6116), 1,
      sym_type_specifier,
    STATE(6801), 1,
      sym__type_definition_type,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4320), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [56312] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9125), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [56422] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4763), 1,
      sym_type_specifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7148), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4341), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [56532] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8042), 1,
      sym_identifier,
    ACTIONS(8044), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8048), 1,
      sym_primitive_type,
    ACTIONS(8050), 1,
      anon_sym_enum,
    ACTIONS(8052), 1,
      anon_sym_class,
    ACTIONS(8054), 1,
      anon_sym_struct,
    ACTIONS(8056), 1,
      anon_sym_union,
    ACTIONS(8058), 1,
      anon_sym_typename,
    ACTIONS(8060), 1,
      anon_sym_interface,
    ACTIONS(8062), 1,
      anon_sym_extension,
    STATE(405), 1,
      sym_qualified_type_identifier,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5215), 1,
      sym_type_specifier,
    STATE(5463), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(7207), 1,
      sym_type_descriptor,
    STATE(8039), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4274), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(121), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8046), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(361), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [56642] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4763), 1,
      sym_type_specifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7104), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4341), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [56752] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5084), 1,
      sym_type_specifier,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7805), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4399), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [56862] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(10810), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [56972] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8104), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(8102), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(8100), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(8098), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [57038] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5084), 1,
      sym_type_specifier,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7175), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4399), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [57148] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4763), 1,
      sym_type_specifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7765), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4341), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [57258] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5084), 1,
      sym_type_specifier,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7171), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4399), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [57368] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9398), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [57478] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9467), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [57588] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4960), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7533), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4248), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [57698] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7833), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    ACTIONS(7849), 1,
      anon_sym_interface,
    ACTIONS(7851), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(6114), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6116), 1,
      sym_type_specifier,
    STATE(6812), 1,
      sym__type_definition_type,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4320), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [57808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3056), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [57870] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2152), 1,
      anon_sym_EQ,
    ACTIONS(6165), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6602), 1,
      anon_sym_LPAREN2,
    ACTIONS(6605), 1,
      anon_sym_LBRACK,
    ACTIONS(2154), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(2128), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2117), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [57942] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10637), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [58052] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4788), 1,
      sym_type_specifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7548), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4265), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [58162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3338), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3336), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [58224] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7616), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7618), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7955), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7957), 1,
      anon_sym_COMMA,
    ACTIONS(7961), 1,
      anon_sym_DASH,
    ACTIONS(7963), 1,
      anon_sym_PLUS,
    ACTIONS(7965), 1,
      anon_sym_STAR,
    ACTIONS(7967), 1,
      anon_sym_SLASH,
    ACTIONS(7969), 1,
      anon_sym_PERCENT,
    ACTIONS(7971), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7973), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_CARET,
    ACTIONS(7979), 1,
      anon_sym_AMP,
    ACTIONS(7981), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7983), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7985), 1,
      anon_sym_GT,
    ACTIONS(7987), 1,
      anon_sym_GT_EQ,
    ACTIONS(7989), 1,
      anon_sym_LT_EQ,
    ACTIONS(7991), 1,
      anon_sym_LT,
    ACTIONS(7993), 1,
      anon_sym_LT_LT,
    ACTIONS(7995), 1,
      anon_sym_GT_GT,
    ACTIONS(7997), 1,
      anon_sym_EQ,
    ACTIONS(7999), 1,
      anon_sym_QMARK,
    ACTIONS(8001), 1,
      anon_sym_STAR_EQ,
    ACTIONS(8003), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(8005), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(8007), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(8009), 1,
      anon_sym_DASH_EQ,
    ACTIONS(8011), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(8013), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(8015), 1,
      anon_sym_AMP_EQ,
    ACTIONS(8017), 1,
      anon_sym_CARET_EQ,
    ACTIONS(8019), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(8023), 1,
      anon_sym_or,
    ACTIONS(8025), 1,
      anon_sym_and,
    ACTIONS(8027), 1,
      anon_sym_bitor,
    ACTIONS(8029), 1,
      anon_sym_xor,
    ACTIONS(8031), 1,
      anon_sym_bitand,
    ACTIONS(8033), 1,
      anon_sym_not_eq,
    ACTIONS(8106), 1,
      anon_sym_RPAREN,
    STATE(2393), 1,
      sym__binary_fold_operator,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    STATE(10128), 1,
      sym__fold_operator,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8021), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [58382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6830), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6832), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [58444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6842), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6844), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [58506] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8108), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8114), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8118), 1,
      anon_sym_PIPE,
    ACTIONS(8122), 1,
      anon_sym_AMP,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8132), 1,
      anon_sym_QMARK,
    ACTIONS(8136), 1,
      anon_sym_or,
    ACTIONS(8138), 1,
      anon_sym_and,
    ACTIONS(8140), 1,
      anon_sym_bitor,
    ACTIONS(8142), 1,
      anon_sym_bitand,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(7414), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(8110), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8128), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8144), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8112), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8134), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8126), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7416), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [58616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6826), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [58678] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7833), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    ACTIONS(7849), 1,
      anon_sym_interface,
    ACTIONS(7851), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(6114), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6116), 1,
      sym_type_specifier,
    STATE(6871), 1,
      sym__type_definition_type,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4320), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [58788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6816), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6818), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [58850] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8144), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7015), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7017), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [58926] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7833), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    ACTIONS(7849), 1,
      anon_sym_interface,
    ACTIONS(7851), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(6114), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6116), 1,
      sym_type_specifier,
    STATE(6875), 1,
      sym__type_definition_type,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4320), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [59036] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4960), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(8069), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4248), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [59146] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4960), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(8314), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4248), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [59256] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9301), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [59366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3338), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3336), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [59428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7049), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7051), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [59490] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7833), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    ACTIONS(7849), 1,
      anon_sym_interface,
    ACTIONS(7851), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(6114), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6116), 1,
      sym_type_specifier,
    STATE(6795), 1,
      sym__type_definition_type,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4320), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [59600] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5785), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10577), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4296), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [59710] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5479), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(8175), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4374), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [59820] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7833), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    ACTIONS(7849), 1,
      anon_sym_interface,
    ACTIONS(7851), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(6114), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6116), 1,
      sym_type_specifier,
    STATE(6877), 1,
      sym__type_definition_type,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4320), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [59930] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10442), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [60040] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7833), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    ACTIONS(7849), 1,
      anon_sym_interface,
    ACTIONS(7851), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(6114), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6116), 1,
      sym_type_specifier,
    STATE(6816), 1,
      sym__type_definition_type,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4320), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [60150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2171), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [60212] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2397), 1,
      anon_sym_STAR,
    ACTIONS(2399), 1,
      anon_sym_AMP,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6140), 1,
      sym_identifier,
    ACTIONS(7072), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6961), 1,
      sym__scope_resolution,
    STATE(7899), 1,
      sym__declarator,
    STATE(10814), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3985), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4837), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [60320] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2964), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2962), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [60382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3102), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3100), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [60444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2171), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [60506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2171), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [60568] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2171), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [60630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2171), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [60692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2171), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [60754] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7833), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    ACTIONS(7849), 1,
      anon_sym_interface,
    ACTIONS(7851), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(6114), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6116), 1,
      sym_type_specifier,
    STATE(6763), 1,
      sym__type_definition_type,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4320), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [60864] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2397), 1,
      anon_sym_STAR,
    ACTIONS(2399), 1,
      anon_sym_AMP,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6140), 1,
      sym_identifier,
    ACTIONS(7072), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6961), 1,
      sym__scope_resolution,
    STATE(7902), 1,
      sym__declarator,
    STATE(10814), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4821), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4823), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [60972] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4763), 1,
      sym_type_specifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7462), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4341), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [61082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2948), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2946), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [61144] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10629), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [61254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2359), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(2357), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [61316] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7833), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    ACTIONS(7849), 1,
      anon_sym_interface,
    ACTIONS(7851), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(6114), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6116), 1,
      sym_type_specifier,
    STATE(6742), 1,
      sym__type_definition_type,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4320), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [61426] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4763), 1,
      sym_type_specifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7120), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4341), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [61536] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4788), 1,
      sym_type_specifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7667), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4265), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [61646] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5176), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7142), 1,
      sym_type_descriptor,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4343), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [61756] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7444), 1,
      anon_sym_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7461), 1,
      anon_sym_requires,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8156), 1,
      anon_sym_DASH_GT,
    ACTIONS(8158), 1,
      anon_sym_where,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5965), 1,
      sym__function_attributes_start,
    STATE(6082), 1,
      sym_ref_qualifier,
    STATE(6976), 1,
      sym__function_attributes_end,
    STATE(7202), 1,
      sym_where_clause,
    STATE(7211), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7454), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8154), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4992), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5493), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7608), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6456), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7432), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(8150), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [61872] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5850), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(8409), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4360), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [61982] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7354), 1,
      anon_sym_LBRACK,
    STATE(4340), 1,
      sym_new_declarator,
    ACTIONS(6924), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6926), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [62048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3070), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3068), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [62110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4545), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4547), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [62172] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(8161), 1,
      sym_identifier,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8165), 1,
      anon_sym_enum,
    ACTIONS(8167), 1,
      anon_sym_class,
    ACTIONS(8169), 1,
      anon_sym_struct,
    ACTIONS(8171), 1,
      anon_sym_union,
    ACTIONS(8173), 1,
      anon_sym_typename,
    ACTIONS(8175), 1,
      anon_sym_interface,
    ACTIONS(8177), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4851), 1,
      sym_type_specifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7171), 1,
      sym_type_descriptor,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4252), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [62282] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9285), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [62392] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7616), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7618), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7955), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7957), 1,
      anon_sym_COMMA,
    ACTIONS(7961), 1,
      anon_sym_DASH,
    ACTIONS(7963), 1,
      anon_sym_PLUS,
    ACTIONS(7965), 1,
      anon_sym_STAR,
    ACTIONS(7967), 1,
      anon_sym_SLASH,
    ACTIONS(7969), 1,
      anon_sym_PERCENT,
    ACTIONS(7971), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7973), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_CARET,
    ACTIONS(7979), 1,
      anon_sym_AMP,
    ACTIONS(7981), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7983), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7985), 1,
      anon_sym_GT,
    ACTIONS(7987), 1,
      anon_sym_GT_EQ,
    ACTIONS(7989), 1,
      anon_sym_LT_EQ,
    ACTIONS(7991), 1,
      anon_sym_LT,
    ACTIONS(7993), 1,
      anon_sym_LT_LT,
    ACTIONS(7995), 1,
      anon_sym_GT_GT,
    ACTIONS(7997), 1,
      anon_sym_EQ,
    ACTIONS(7999), 1,
      anon_sym_QMARK,
    ACTIONS(8001), 1,
      anon_sym_STAR_EQ,
    ACTIONS(8003), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(8005), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(8007), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(8009), 1,
      anon_sym_DASH_EQ,
    ACTIONS(8011), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(8013), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(8015), 1,
      anon_sym_AMP_EQ,
    ACTIONS(8017), 1,
      anon_sym_CARET_EQ,
    ACTIONS(8019), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(8023), 1,
      anon_sym_or,
    ACTIONS(8025), 1,
      anon_sym_and,
    ACTIONS(8027), 1,
      anon_sym_bitor,
    ACTIONS(8029), 1,
      anon_sym_xor,
    ACTIONS(8031), 1,
      anon_sym_bitand,
    ACTIONS(8033), 1,
      anon_sym_not_eq,
    ACTIONS(8179), 1,
      anon_sym_RPAREN,
    STATE(2393), 1,
      sym__binary_fold_operator,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    STATE(10128), 1,
      sym__fold_operator,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8021), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [62550] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(8161), 1,
      sym_identifier,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8165), 1,
      anon_sym_enum,
    ACTIONS(8167), 1,
      anon_sym_class,
    ACTIONS(8169), 1,
      anon_sym_struct,
    ACTIONS(8171), 1,
      anon_sym_union,
    ACTIONS(8173), 1,
      anon_sym_typename,
    ACTIONS(8175), 1,
      anon_sym_interface,
    ACTIONS(8177), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4851), 1,
      sym_type_specifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7175), 1,
      sym_type_descriptor,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4252), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [62660] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7833), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    ACTIONS(7849), 1,
      anon_sym_interface,
    ACTIONS(7851), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(6114), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6116), 1,
      sym_type_specifier,
    STATE(6754), 1,
      sym__type_definition_type,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4320), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [62770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5886), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(5888), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [62832] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3172), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3170), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [62894] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10570), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [63004] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(8161), 1,
      sym_identifier,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8165), 1,
      anon_sym_enum,
    ACTIONS(8167), 1,
      anon_sym_class,
    ACTIONS(8169), 1,
      anon_sym_struct,
    ACTIONS(8171), 1,
      anon_sym_union,
    ACTIONS(8173), 1,
      anon_sym_typename,
    ACTIONS(8175), 1,
      anon_sym_interface,
    ACTIONS(8177), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4851), 1,
      sym_type_specifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7367), 1,
      sym_type_descriptor,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4252), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [63114] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7833), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    ACTIONS(7849), 1,
      anon_sym_interface,
    ACTIONS(7851), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(6114), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6116), 1,
      sym_type_specifier,
    STATE(6756), 1,
      sym__type_definition_type,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4320), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [63224] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4763), 1,
      sym_type_specifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7351), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4341), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [63334] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5785), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10535), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4296), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [63444] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8070), 1,
      anon_sym_enum,
    ACTIONS(8072), 1,
      anon_sym_class,
    ACTIONS(8074), 1,
      anon_sym_struct,
    ACTIONS(8076), 1,
      anon_sym_union,
    ACTIONS(8078), 1,
      anon_sym_typename,
    ACTIONS(8080), 1,
      anon_sym_interface,
    ACTIONS(8082), 1,
      anon_sym_extension,
    ACTIONS(8181), 1,
      sym_identifier,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5859), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6009), 1,
      sym_type_specifier,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(10529), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4331), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8068), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [63554] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3993), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(8183), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(3989), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(3987), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [63620] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5316), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7148), 1,
      sym_type_descriptor,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4393), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [63730] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7833), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    ACTIONS(7849), 1,
      anon_sym_interface,
    ACTIONS(7851), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(6114), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6116), 1,
      sym_type_specifier,
    STATE(6760), 1,
      sym__type_definition_type,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4320), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [63840] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7833), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    ACTIONS(7849), 1,
      anon_sym_interface,
    ACTIONS(7851), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(6114), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6116), 1,
      sym_type_specifier,
    STATE(6820), 1,
      sym__type_definition_type,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4320), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [63950] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6165), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6605), 1,
      anon_sym_LBRACK,
    ACTIONS(6602), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    ACTIONS(2128), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2117), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [64018] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3985), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(8185), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(3971), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(3969), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [64084] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9349), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [64194] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7861), 1,
      sym_identifier,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(7869), 1,
      anon_sym_enum,
    ACTIONS(7871), 1,
      anon_sym_class,
    ACTIONS(7873), 1,
      anon_sym_struct,
    ACTIONS(7875), 1,
      anon_sym_union,
    ACTIONS(7877), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      anon_sym_interface,
    ACTIONS(7881), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5086), 1,
      sym_type_specifier,
    STATE(5512), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7896), 1,
      sym_type_descriptor,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4400), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7865), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [64304] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9205), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [64414] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5850), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(8427), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4360), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [64524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5858), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(5860), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [64586] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5316), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7167), 1,
      sym_type_descriptor,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4393), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [64696] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7861), 1,
      sym_identifier,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(7869), 1,
      anon_sym_enum,
    ACTIONS(7871), 1,
      anon_sym_class,
    ACTIONS(7873), 1,
      anon_sym_struct,
    ACTIONS(7875), 1,
      anon_sym_union,
    ACTIONS(7877), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      anon_sym_interface,
    ACTIONS(7881), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5512), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5679), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(8336), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4350), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7865), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [64806] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10526), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [64916] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5084), 1,
      sym_type_specifier,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7678), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4399), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [65026] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4788), 1,
      sym_type_specifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7183), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4265), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [65136] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9326), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [65246] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8037), 1,
      anon_sym_LT,
    STATE(2921), 1,
      sym_template_argument_list,
    ACTIONS(6996), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6998), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [65312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5941), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(5943), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [65374] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6165), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6605), 1,
      anon_sym_LBRACK,
    ACTIONS(6602), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    ACTIONS(2128), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2117), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [65442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5896), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(5898), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [65504] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4763), 1,
      sym_type_specifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7567), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4341), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [65614] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6990), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7015), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7017), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [65690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5858), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(5860), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [65752] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10585), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [65862] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9036), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [65972] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8042), 1,
      sym_identifier,
    ACTIONS(8044), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8048), 1,
      sym_primitive_type,
    ACTIONS(8050), 1,
      anon_sym_enum,
    ACTIONS(8052), 1,
      anon_sym_class,
    ACTIONS(8054), 1,
      anon_sym_struct,
    ACTIONS(8056), 1,
      anon_sym_union,
    ACTIONS(8058), 1,
      anon_sym_typename,
    ACTIONS(8060), 1,
      anon_sym_interface,
    ACTIONS(8062), 1,
      anon_sym_extension,
    STATE(405), 1,
      sym_qualified_type_identifier,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5215), 1,
      sym_type_specifier,
    STATE(5463), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(7171), 1,
      sym_type_descriptor,
    STATE(8039), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4274), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(121), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8046), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(361), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [66082] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8042), 1,
      sym_identifier,
    ACTIONS(8044), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8048), 1,
      sym_primitive_type,
    ACTIONS(8050), 1,
      anon_sym_enum,
    ACTIONS(8052), 1,
      anon_sym_class,
    ACTIONS(8054), 1,
      anon_sym_struct,
    ACTIONS(8056), 1,
      anon_sym_union,
    ACTIONS(8058), 1,
      anon_sym_typename,
    ACTIONS(8060), 1,
      anon_sym_interface,
    ACTIONS(8062), 1,
      anon_sym_extension,
    STATE(405), 1,
      sym_qualified_type_identifier,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5215), 1,
      sym_type_specifier,
    STATE(5463), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(7175), 1,
      sym_type_descriptor,
    STATE(8039), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4274), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(121), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8046), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(361), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [66192] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8042), 1,
      sym_identifier,
    ACTIONS(8044), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8048), 1,
      sym_primitive_type,
    ACTIONS(8050), 1,
      anon_sym_enum,
    ACTIONS(8052), 1,
      anon_sym_class,
    ACTIONS(8054), 1,
      anon_sym_struct,
    ACTIONS(8056), 1,
      anon_sym_union,
    ACTIONS(8058), 1,
      anon_sym_typename,
    ACTIONS(8060), 1,
      anon_sym_interface,
    ACTIONS(8062), 1,
      anon_sym_extension,
    STATE(405), 1,
      sym_qualified_type_identifier,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5215), 1,
      sym_type_specifier,
    STATE(5463), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(7990), 1,
      sym_type_descriptor,
    STATE(8039), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4274), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(121), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8046), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(361), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [66302] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8042), 1,
      sym_identifier,
    ACTIONS(8044), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8048), 1,
      sym_primitive_type,
    ACTIONS(8050), 1,
      anon_sym_enum,
    ACTIONS(8052), 1,
      anon_sym_class,
    ACTIONS(8054), 1,
      anon_sym_struct,
    ACTIONS(8056), 1,
      anon_sym_union,
    ACTIONS(8058), 1,
      anon_sym_typename,
    ACTIONS(8060), 1,
      anon_sym_interface,
    ACTIONS(8062), 1,
      anon_sym_extension,
    STATE(405), 1,
      sym_qualified_type_identifier,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5215), 1,
      sym_type_specifier,
    STATE(5463), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(7926), 1,
      sym_type_descriptor,
    STATE(8039), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4274), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(121), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8046), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(361), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [66412] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5850), 1,
      sym_type_specifier,
    STATE(7148), 1,
      sym_type_descriptor,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4360), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [66522] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5850), 1,
      sym_type_specifier,
    STATE(7167), 1,
      sym_type_descriptor,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4360), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [66632] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(8161), 1,
      sym_identifier,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8165), 1,
      anon_sym_enum,
    ACTIONS(8167), 1,
      anon_sym_class,
    ACTIONS(8169), 1,
      anon_sym_struct,
    ACTIONS(8171), 1,
      anon_sym_union,
    ACTIONS(8173), 1,
      anon_sym_typename,
    ACTIONS(8175), 1,
      anon_sym_interface,
    ACTIONS(8177), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4851), 1,
      sym_type_specifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7352), 1,
      sym_type_descriptor,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4252), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [66742] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9189), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [66852] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9017), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [66962] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7861), 1,
      sym_identifier,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(7869), 1,
      anon_sym_enum,
    ACTIONS(7871), 1,
      anon_sym_class,
    ACTIONS(7873), 1,
      anon_sym_struct,
    ACTIONS(7875), 1,
      anon_sym_union,
    ACTIONS(7877), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      anon_sym_interface,
    ACTIONS(7881), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5512), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5679), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(8147), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4350), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7865), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [67072] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9571), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [67182] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7011), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7013), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
  [67256] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10254), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [67366] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9624), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [67476] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9012), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [67586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7428), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7426), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
  [67648] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7616), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7618), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7955), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7957), 1,
      anon_sym_COMMA,
    ACTIONS(7961), 1,
      anon_sym_DASH,
    ACTIONS(7963), 1,
      anon_sym_PLUS,
    ACTIONS(7965), 1,
      anon_sym_STAR,
    ACTIONS(7967), 1,
      anon_sym_SLASH,
    ACTIONS(7969), 1,
      anon_sym_PERCENT,
    ACTIONS(7971), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7973), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_CARET,
    ACTIONS(7979), 1,
      anon_sym_AMP,
    ACTIONS(7981), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7983), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7985), 1,
      anon_sym_GT,
    ACTIONS(7987), 1,
      anon_sym_GT_EQ,
    ACTIONS(7989), 1,
      anon_sym_LT_EQ,
    ACTIONS(7991), 1,
      anon_sym_LT,
    ACTIONS(7993), 1,
      anon_sym_LT_LT,
    ACTIONS(7995), 1,
      anon_sym_GT_GT,
    ACTIONS(7997), 1,
      anon_sym_EQ,
    ACTIONS(7999), 1,
      anon_sym_QMARK,
    ACTIONS(8001), 1,
      anon_sym_STAR_EQ,
    ACTIONS(8003), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(8005), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(8007), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(8009), 1,
      anon_sym_DASH_EQ,
    ACTIONS(8011), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(8013), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(8015), 1,
      anon_sym_AMP_EQ,
    ACTIONS(8017), 1,
      anon_sym_CARET_EQ,
    ACTIONS(8019), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(8023), 1,
      anon_sym_or,
    ACTIONS(8025), 1,
      anon_sym_and,
    ACTIONS(8027), 1,
      anon_sym_bitor,
    ACTIONS(8029), 1,
      anon_sym_xor,
    ACTIONS(8031), 1,
      anon_sym_bitand,
    ACTIONS(8033), 1,
      anon_sym_not_eq,
    ACTIONS(8187), 1,
      anon_sym_RPAREN,
    STATE(2393), 1,
      sym__binary_fold_operator,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    STATE(10128), 1,
      sym__fold_operator,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8021), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [67806] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8070), 1,
      anon_sym_enum,
    ACTIONS(8072), 1,
      anon_sym_class,
    ACTIONS(8074), 1,
      anon_sym_struct,
    ACTIONS(8076), 1,
      anon_sym_union,
    ACTIONS(8078), 1,
      anon_sym_typename,
    ACTIONS(8080), 1,
      anon_sym_interface,
    ACTIONS(8082), 1,
      anon_sym_extension,
    ACTIONS(8189), 1,
      sym_identifier,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5859), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6009), 1,
      sym_type_specifier,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(10269), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4331), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8068), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [67916] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8191), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7023), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7025), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [67980] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8114), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8118), 1,
      anon_sym_PIPE,
    ACTIONS(8122), 1,
      anon_sym_AMP,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8136), 1,
      anon_sym_or,
    ACTIONS(8138), 1,
      anon_sym_and,
    ACTIONS(8140), 1,
      anon_sym_bitor,
    ACTIONS(8142), 1,
      anon_sym_bitand,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(7422), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(8110), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8128), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8144), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8112), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8134), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8126), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7424), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [68086] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4763), 1,
      sym_type_specifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7648), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4341), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [68196] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(10811), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [68306] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5785), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10283), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4296), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [68416] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9539), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [68526] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(8591), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [68636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7023), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7025), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68698] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8042), 1,
      sym_identifier,
    ACTIONS(8044), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8048), 1,
      sym_primitive_type,
    ACTIONS(8050), 1,
      anon_sym_enum,
    ACTIONS(8052), 1,
      anon_sym_class,
    ACTIONS(8054), 1,
      anon_sym_struct,
    ACTIONS(8056), 1,
      anon_sym_union,
    ACTIONS(8058), 1,
      anon_sym_typename,
    ACTIONS(8060), 1,
      anon_sym_interface,
    ACTIONS(8062), 1,
      anon_sym_extension,
    STATE(405), 1,
      sym_qualified_type_identifier,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5463), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5761), 1,
      sym_type_specifier,
    STATE(7175), 1,
      sym_type_descriptor,
    STATE(8039), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4275), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(121), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8046), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(361), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [68808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6887), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6889), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [68870] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6853), 1,
      sym_literal_suffix,
    ACTIONS(2117), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
    ACTIONS(2128), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [68934] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6165), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6602), 1,
      anon_sym_LPAREN2,
    ACTIONS(6605), 1,
      anon_sym_LBRACK,
    ACTIONS(2128), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2117), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [69002] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8144), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7037), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7039), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [69078] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8144), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7041), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7043), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [69154] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(8161), 1,
      sym_identifier,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8165), 1,
      anon_sym_enum,
    ACTIONS(8167), 1,
      anon_sym_class,
    ACTIONS(8169), 1,
      anon_sym_struct,
    ACTIONS(8171), 1,
      anon_sym_union,
    ACTIONS(8173), 1,
      anon_sym_typename,
    ACTIONS(8175), 1,
      anon_sym_interface,
    ACTIONS(8177), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5185), 1,
      sym_type_specifier,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7171), 1,
      sym_type_descriptor,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4344), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [69264] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4982), 1,
      sym_type_specifier,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7529), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4241), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [69374] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7861), 1,
      sym_identifier,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(7869), 1,
      anon_sym_enum,
    ACTIONS(7871), 1,
      anon_sym_class,
    ACTIONS(7873), 1,
      anon_sym_struct,
    ACTIONS(7875), 1,
      anon_sym_union,
    ACTIONS(7877), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      anon_sym_interface,
    ACTIONS(7881), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5086), 1,
      sym_type_specifier,
    STATE(5512), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7712), 1,
      sym_type_descriptor,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4400), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7865), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [69484] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4788), 1,
      sym_type_specifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7207), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4265), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [69594] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6165), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6602), 1,
      anon_sym_LPAREN2,
    ACTIONS(6605), 1,
      anon_sym_LBRACK,
    ACTIONS(2128), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2117), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [69662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7023), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7025), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [69724] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9267), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [69834] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8114), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8118), 1,
      anon_sym_PIPE,
    ACTIONS(8122), 1,
      anon_sym_AMP,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8136), 1,
      anon_sym_or,
    ACTIONS(8138), 1,
      anon_sym_and,
    ACTIONS(8140), 1,
      anon_sym_bitor,
    ACTIONS(8142), 1,
      anon_sym_bitand,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(7398), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(8110), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8128), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8144), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8112), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8134), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8126), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7400), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [69940] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7045), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7047), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
  [70014] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10115), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [70124] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(8161), 1,
      sym_identifier,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8165), 1,
      anon_sym_enum,
    ACTIONS(8167), 1,
      anon_sym_class,
    ACTIONS(8169), 1,
      anon_sym_struct,
    ACTIONS(8171), 1,
      anon_sym_union,
    ACTIONS(8173), 1,
      anon_sym_typename,
    ACTIONS(8175), 1,
      anon_sym_interface,
    ACTIONS(8177), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5185), 1,
      sym_type_specifier,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7175), 1,
      sym_type_descriptor,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4344), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [70234] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2152), 1,
      anon_sym_EQ,
    ACTIONS(2154), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(2128), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2117), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [70300] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5785), 1,
      sym_type_specifier,
    STATE(7167), 1,
      sym_type_descriptor,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4296), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [70410] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7444), 1,
      anon_sym_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8156), 1,
      anon_sym_DASH_GT,
    ACTIONS(8193), 1,
      anon_sym_where,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5923), 1,
      sym__function_attributes_start,
    STATE(6087), 1,
      sym_ref_qualifier,
    STATE(7007), 1,
      sym__function_attributes_end,
    STATE(7141), 1,
      sym_trailing_return_type,
    STATE(7202), 1,
      sym_where_clause,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8154), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4992), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5493), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8054), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6457), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7432), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(8150), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [70526] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5316), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(8074), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4393), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [70636] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6761), 1,
      sym_identifier,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7944), 1,
      anon_sym_STAR,
    ACTIONS(7946), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7948), 1,
      anon_sym_AMP,
    ACTIONS(7950), 1,
      anon_sym_COLON_COLON,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6954), 1,
      sym__scope_resolution,
    STATE(8080), 1,
      sym__declarator,
    STATE(10201), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4820), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4823), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [70744] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10749), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [70854] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9578), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [70964] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5084), 1,
      sym_type_specifier,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7810), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4399), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [71074] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6853), 1,
      sym_literal_suffix,
    ACTIONS(6596), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
    ACTIONS(6594), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [71138] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5785), 1,
      sym_type_specifier,
    STATE(7148), 1,
      sym_type_descriptor,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4296), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [71248] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6140), 1,
      sym_identifier,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(8088), 1,
      anon_sym_STAR,
    ACTIONS(8090), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8092), 1,
      anon_sym_AMP,
    ACTIONS(8094), 1,
      anon_sym_COLON_COLON,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6902), 1,
      sym__scope_resolution,
    STATE(8171), 1,
      sym__declarator,
    STATE(10164), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4823), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4846), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [71356] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8195), 1,
      sym_identifier,
    STATE(4092), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(8198), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(8201), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6446), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6444), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [71426] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8108), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8114), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8118), 1,
      anon_sym_PIPE,
    ACTIONS(8122), 1,
      anon_sym_AMP,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8132), 1,
      anon_sym_QMARK,
    ACTIONS(8136), 1,
      anon_sym_or,
    ACTIONS(8138), 1,
      anon_sym_and,
    ACTIONS(8140), 1,
      anon_sym_bitor,
    ACTIONS(8142), 1,
      anon_sym_bitand,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(7410), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(8110), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8128), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8144), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8112), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8134), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8126), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7412), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [71536] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5785), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(8457), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4296), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [71646] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5785), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(8462), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4296), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [71756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2355), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(2353), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [71818] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9381), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [71928] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9157), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [72038] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9257), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [72148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5961), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(5963), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [72210] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(10891), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [72320] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5316), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(8034), 1,
      sym_type_descriptor,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4393), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [72430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7428), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7426), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
  [72492] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9210), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [72602] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4960), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(8125), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4248), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [72712] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(8161), 1,
      sym_identifier,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8165), 1,
      anon_sym_enum,
    ACTIONS(8167), 1,
      anon_sym_class,
    ACTIONS(8169), 1,
      anon_sym_struct,
    ACTIONS(8171), 1,
      anon_sym_union,
    ACTIONS(8173), 1,
      anon_sym_typename,
    ACTIONS(8175), 1,
      anon_sym_interface,
    ACTIONS(8177), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5185), 1,
      sym_type_specifier,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7989), 1,
      sym_type_descriptor,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4344), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [72822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5953), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(5955), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [72884] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9195), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [72994] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9151), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [73104] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5261), 1,
      sym_type_specifier,
    STATE(7167), 1,
      sym_type_descriptor,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4342), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [73214] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9143), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [73324] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2217), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6939), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6941), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [73388] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5261), 1,
      sym_type_specifier,
    STATE(7148), 1,
      sym_type_descriptor,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4342), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [73498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3054), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3052), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [73560] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5261), 1,
      sym_type_specifier,
    STATE(7956), 1,
      sym_type_descriptor,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4342), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [73670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3082), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3080), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [73732] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5261), 1,
      sym_type_specifier,
    STATE(7939), 1,
      sym_type_descriptor,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4342), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [73842] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6613), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6611), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [73904] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8204), 1,
      anon_sym_LT,
    STATE(4370), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4549), 1,
      sym_template_argument_list,
    ACTIONS(7762), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2115), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2123), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [73976] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(8161), 1,
      sym_identifier,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8165), 1,
      anon_sym_enum,
    ACTIONS(8167), 1,
      anon_sym_class,
    ACTIONS(8169), 1,
      anon_sym_struct,
    ACTIONS(8171), 1,
      anon_sym_union,
    ACTIONS(8173), 1,
      anon_sym_typename,
    ACTIONS(8175), 1,
      anon_sym_interface,
    ACTIONS(8177), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5185), 1,
      sym_type_specifier,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(8029), 1,
      sym_type_descriptor,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4344), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [74086] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8114), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8118), 1,
      anon_sym_PIPE,
    ACTIONS(8122), 1,
      anon_sym_AMP,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8136), 1,
      anon_sym_or,
    ACTIONS(8138), 1,
      anon_sym_and,
    ACTIONS(8140), 1,
      anon_sym_bitor,
    ACTIONS(8142), 1,
      anon_sym_bitand,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(7406), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(8110), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8128), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8144), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8112), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8134), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8126), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7408), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [74192] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(7207), 1,
      sym_type_descriptor,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [74302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3090), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3088), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [74364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3054), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3052), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [74426] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10272), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [74536] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8070), 1,
      anon_sym_enum,
    ACTIONS(8072), 1,
      anon_sym_class,
    ACTIONS(8074), 1,
      anon_sym_struct,
    ACTIONS(8076), 1,
      anon_sym_union,
    ACTIONS(8078), 1,
      anon_sym_typename,
    ACTIONS(8080), 1,
      anon_sym_interface,
    ACTIONS(8082), 1,
      anon_sym_extension,
    ACTIONS(8206), 1,
      sym_identifier,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5341), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5859), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(7167), 1,
      sym_type_descriptor,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4345), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8068), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [74646] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9201), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [74756] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(10065), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [74866] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4982), 1,
      sym_type_specifier,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(8065), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4241), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [74976] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8042), 1,
      sym_identifier,
    ACTIONS(8044), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8048), 1,
      sym_primitive_type,
    ACTIONS(8050), 1,
      anon_sym_enum,
    ACTIONS(8052), 1,
      anon_sym_class,
    ACTIONS(8054), 1,
      anon_sym_struct,
    ACTIONS(8056), 1,
      anon_sym_union,
    ACTIONS(8058), 1,
      anon_sym_typename,
    ACTIONS(8060), 1,
      anon_sym_interface,
    ACTIONS(8062), 1,
      anon_sym_extension,
    STATE(405), 1,
      sym_qualified_type_identifier,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5463), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5761), 1,
      sym_type_specifier,
    STATE(8039), 1,
      sym__scope_resolution,
    STATE(8501), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4275), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(121), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8046), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(361), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [75086] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8070), 1,
      anon_sym_enum,
    ACTIONS(8072), 1,
      anon_sym_class,
    ACTIONS(8074), 1,
      anon_sym_struct,
    ACTIONS(8076), 1,
      anon_sym_union,
    ACTIONS(8078), 1,
      anon_sym_typename,
    ACTIONS(8080), 1,
      anon_sym_interface,
    ACTIONS(8082), 1,
      anon_sym_extension,
    ACTIONS(8206), 1,
      sym_identifier,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5859), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6009), 1,
      sym_type_specifier,
    STATE(7167), 1,
      sym_type_descriptor,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4331), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8068), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [75196] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4763), 1,
      sym_type_specifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7637), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4341), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [75306] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(8161), 1,
      sym_identifier,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8165), 1,
      anon_sym_enum,
    ACTIONS(8167), 1,
      anon_sym_class,
    ACTIONS(8169), 1,
      anon_sym_struct,
    ACTIONS(8171), 1,
      anon_sym_union,
    ACTIONS(8173), 1,
      anon_sym_typename,
    ACTIONS(8175), 1,
      anon_sym_interface,
    ACTIONS(8177), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4851), 1,
      sym_type_specifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7207), 1,
      sym_type_descriptor,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4252), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [75416] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      sym_literal_suffix,
    ACTIONS(2117), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2128), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
  [75480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2217), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(2222), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2212), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [75544] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5084), 1,
      sym_type_specifier,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7885), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4399), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [75654] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8214), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(8212), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(8210), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(8208), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [75720] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7616), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7618), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7955), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7957), 1,
      anon_sym_COMMA,
    ACTIONS(7961), 1,
      anon_sym_DASH,
    ACTIONS(7963), 1,
      anon_sym_PLUS,
    ACTIONS(7965), 1,
      anon_sym_STAR,
    ACTIONS(7967), 1,
      anon_sym_SLASH,
    ACTIONS(7969), 1,
      anon_sym_PERCENT,
    ACTIONS(7971), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7973), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_CARET,
    ACTIONS(7979), 1,
      anon_sym_AMP,
    ACTIONS(7981), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7983), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7985), 1,
      anon_sym_GT,
    ACTIONS(7987), 1,
      anon_sym_GT_EQ,
    ACTIONS(7989), 1,
      anon_sym_LT_EQ,
    ACTIONS(7991), 1,
      anon_sym_LT,
    ACTIONS(7993), 1,
      anon_sym_LT_LT,
    ACTIONS(7995), 1,
      anon_sym_GT_GT,
    ACTIONS(7997), 1,
      anon_sym_EQ,
    ACTIONS(7999), 1,
      anon_sym_QMARK,
    ACTIONS(8001), 1,
      anon_sym_STAR_EQ,
    ACTIONS(8003), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(8005), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(8007), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(8009), 1,
      anon_sym_DASH_EQ,
    ACTIONS(8011), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(8013), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(8015), 1,
      anon_sym_AMP_EQ,
    ACTIONS(8017), 1,
      anon_sym_CARET_EQ,
    ACTIONS(8019), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(8023), 1,
      anon_sym_or,
    ACTIONS(8025), 1,
      anon_sym_and,
    ACTIONS(8027), 1,
      anon_sym_bitor,
    ACTIONS(8029), 1,
      anon_sym_xor,
    ACTIONS(8031), 1,
      anon_sym_bitand,
    ACTIONS(8033), 1,
      anon_sym_not_eq,
    ACTIONS(8216), 1,
      anon_sym_RPAREN,
    STATE(2393), 1,
      sym__binary_fold_operator,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    STATE(10128), 1,
      sym__fold_operator,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8021), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [75878] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8070), 1,
      anon_sym_enum,
    ACTIONS(8072), 1,
      anon_sym_class,
    ACTIONS(8074), 1,
      anon_sym_struct,
    ACTIONS(8076), 1,
      anon_sym_union,
    ACTIONS(8078), 1,
      anon_sym_typename,
    ACTIONS(8080), 1,
      anon_sym_interface,
    ACTIONS(8082), 1,
      anon_sym_extension,
    ACTIONS(8206), 1,
      sym_identifier,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5341), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5859), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(7148), 1,
      sym_type_descriptor,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4345), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8068), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [75988] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4960), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(8280), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4248), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [76098] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4982), 1,
      sym_type_specifier,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7171), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4241), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [76208] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9047), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [76318] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8042), 1,
      sym_identifier,
    ACTIONS(8044), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8048), 1,
      sym_primitive_type,
    ACTIONS(8050), 1,
      anon_sym_enum,
    ACTIONS(8052), 1,
      anon_sym_class,
    ACTIONS(8054), 1,
      anon_sym_struct,
    ACTIONS(8056), 1,
      anon_sym_union,
    ACTIONS(8058), 1,
      anon_sym_typename,
    ACTIONS(8060), 1,
      anon_sym_interface,
    ACTIONS(8062), 1,
      anon_sym_extension,
    STATE(405), 1,
      sym_qualified_type_identifier,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5463), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5761), 1,
      sym_type_specifier,
    STATE(7171), 1,
      sym_type_descriptor,
    STATE(8039), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4275), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(121), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8046), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(361), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [76428] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4826), 1,
      sym_type_specifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7260), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4351), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [76538] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(8979), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [76648] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4788), 1,
      sym_type_specifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7239), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4265), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [76758] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4788), 1,
      sym_type_specifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7193), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4265), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [76868] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8218), 1,
      anon_sym_LT,
    STATE(2816), 1,
      sym_template_argument_list,
    STATE(2949), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6167), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2115), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(2123), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [76940] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8108), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8114), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8118), 1,
      anon_sym_PIPE,
    ACTIONS(8122), 1,
      anon_sym_AMP,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8132), 1,
      anon_sym_QMARK,
    ACTIONS(8136), 1,
      anon_sym_or,
    ACTIONS(8138), 1,
      anon_sym_and,
    ACTIONS(8140), 1,
      anon_sym_bitor,
    ACTIONS(8142), 1,
      anon_sym_bitand,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(7178), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(8110), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8128), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8144), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8112), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8134), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8126), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7180), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [77050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6875), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6877), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77112] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9448), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [77222] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6140), 1,
      sym_identifier,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(8088), 1,
      anon_sym_STAR,
    ACTIONS(8090), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8092), 1,
      anon_sym_AMP,
    ACTIONS(8094), 1,
      anon_sym_COLON_COLON,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6902), 1,
      sym__scope_resolution,
    STATE(8181), 1,
      sym__declarator,
    STATE(10164), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4823), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4848), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [77330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7196), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7198), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77392] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9092), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [77502] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5785), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(10805), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4296), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [77612] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4982), 1,
      sym_type_specifier,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(8161), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4241), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [77722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3358), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3356), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [77784] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10169), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [77894] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      sym_literal_suffix,
    ACTIONS(6596), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6594), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
  [77958] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3384), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3382), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [78020] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8070), 1,
      anon_sym_enum,
    ACTIONS(8072), 1,
      anon_sym_class,
    ACTIONS(8074), 1,
      anon_sym_struct,
    ACTIONS(8076), 1,
      anon_sym_union,
    ACTIONS(8078), 1,
      anon_sym_typename,
    ACTIONS(8080), 1,
      anon_sym_interface,
    ACTIONS(8082), 1,
      anon_sym_extension,
    ACTIONS(8206), 1,
      sym_identifier,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5341), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5859), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8088), 1,
      sym_type_descriptor,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4345), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8068), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [78130] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4788), 1,
      sym_type_specifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7175), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4265), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [78240] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4788), 1,
      sym_type_specifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7171), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4265), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [78350] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4788), 1,
      sym_type_specifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7324), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4265), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [78460] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7616), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7618), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7955), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7957), 1,
      anon_sym_COMMA,
    ACTIONS(7961), 1,
      anon_sym_DASH,
    ACTIONS(7963), 1,
      anon_sym_PLUS,
    ACTIONS(7965), 1,
      anon_sym_STAR,
    ACTIONS(7967), 1,
      anon_sym_SLASH,
    ACTIONS(7969), 1,
      anon_sym_PERCENT,
    ACTIONS(7971), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7973), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_CARET,
    ACTIONS(7979), 1,
      anon_sym_AMP,
    ACTIONS(7981), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7983), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7985), 1,
      anon_sym_GT,
    ACTIONS(7987), 1,
      anon_sym_GT_EQ,
    ACTIONS(7989), 1,
      anon_sym_LT_EQ,
    ACTIONS(7991), 1,
      anon_sym_LT,
    ACTIONS(7993), 1,
      anon_sym_LT_LT,
    ACTIONS(7995), 1,
      anon_sym_GT_GT,
    ACTIONS(7997), 1,
      anon_sym_EQ,
    ACTIONS(7999), 1,
      anon_sym_QMARK,
    ACTIONS(8001), 1,
      anon_sym_STAR_EQ,
    ACTIONS(8003), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(8005), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(8007), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(8009), 1,
      anon_sym_DASH_EQ,
    ACTIONS(8011), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(8013), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(8015), 1,
      anon_sym_AMP_EQ,
    ACTIONS(8017), 1,
      anon_sym_CARET_EQ,
    ACTIONS(8019), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(8023), 1,
      anon_sym_or,
    ACTIONS(8025), 1,
      anon_sym_and,
    ACTIONS(8027), 1,
      anon_sym_bitor,
    ACTIONS(8029), 1,
      anon_sym_xor,
    ACTIONS(8031), 1,
      anon_sym_bitand,
    ACTIONS(8033), 1,
      anon_sym_not_eq,
    ACTIONS(8220), 1,
      anon_sym_RPAREN,
    STATE(2393), 1,
      sym__binary_fold_operator,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    STATE(10128), 1,
      sym__fold_operator,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8021), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [78618] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6062), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [78680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6056), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6058), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [78742] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8228), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(8226), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(8224), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(8222), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [78808] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9072), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [78918] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3396), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3394), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [78980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3400), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3398), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [79042] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8070), 1,
      anon_sym_enum,
    ACTIONS(8072), 1,
      anon_sym_class,
    ACTIONS(8074), 1,
      anon_sym_struct,
    ACTIONS(8076), 1,
      anon_sym_union,
    ACTIONS(8078), 1,
      anon_sym_typename,
    ACTIONS(8080), 1,
      anon_sym_interface,
    ACTIONS(8082), 1,
      anon_sym_extension,
    ACTIONS(8206), 1,
      sym_identifier,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5341), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5859), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(8124), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4345), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8068), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [79152] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4960), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(8149), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4248), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [79262] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9039), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [79372] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9307), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [79482] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10600), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [79592] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8144), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8112), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7007), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [79670] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8144), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7007), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [79746] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8118), 1,
      anon_sym_PIPE,
    ACTIONS(8122), 1,
      anon_sym_AMP,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8138), 1,
      anon_sym_and,
    ACTIONS(8140), 1,
      anon_sym_bitor,
    ACTIONS(8142), 1,
      anon_sym_bitand,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8110), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8128), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8144), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7007), 3,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
    ACTIONS(8112), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8134), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8126), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [79848] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8118), 1,
      anon_sym_PIPE,
    ACTIONS(8122), 1,
      anon_sym_AMP,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8140), 1,
      anon_sym_bitor,
    ACTIONS(8142), 1,
      anon_sym_bitand,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8110), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8128), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8144), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8112), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8134), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7007), 4,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(8126), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [79946] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8122), 1,
      anon_sym_AMP,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8142), 1,
      anon_sym_bitand,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8110), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8128), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8144), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8112), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8134), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8126), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 5,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7009), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_GT2,
  [80040] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8122), 1,
      anon_sym_AMP,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8142), 1,
      anon_sym_bitand,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8110), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8128), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8144), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8112), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8134), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8126), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_GT2,
  [80132] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8110), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8128), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8144), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8112), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8134), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8126), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_GT2,
  [80220] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8110), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8128), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8144), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8112), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8134), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8126), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [80306] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8110), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8128), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8144), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8112), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8134), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7007), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [80390] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8110), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8144), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8112), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7007), 14,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [80470] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4982), 1,
      sym_type_specifier,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7175), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4241), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [80580] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8110), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8128), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8144), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8112), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7007), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7009), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [80662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7019), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7021), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80724] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4987), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7142), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4334), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [80834] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8070), 1,
      anon_sym_enum,
    ACTIONS(8072), 1,
      anon_sym_class,
    ACTIONS(8074), 1,
      anon_sym_struct,
    ACTIONS(8076), 1,
      anon_sym_union,
    ACTIONS(8078), 1,
      anon_sym_typename,
    ACTIONS(8080), 1,
      anon_sym_interface,
    ACTIONS(8082), 1,
      anon_sym_extension,
    ACTIONS(8206), 1,
      sym_identifier,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5859), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6009), 1,
      sym_type_specifier,
    STATE(7148), 1,
      sym_type_descriptor,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4331), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8068), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [80944] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6761), 1,
      sym_identifier,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7274), 1,
      sym__declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3809), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4832), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [81052] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7883), 1,
      anon_sym_DOT,
    ACTIONS(7509), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3848), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3850), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81118] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7861), 1,
      sym_identifier,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(7869), 1,
      anon_sym_enum,
    ACTIONS(7871), 1,
      anon_sym_class,
    ACTIONS(7873), 1,
      anon_sym_struct,
    ACTIONS(7875), 1,
      anon_sym_union,
    ACTIONS(7877), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      anon_sym_interface,
    ACTIONS(7881), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5086), 1,
      sym_type_specifier,
    STATE(5512), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7594), 1,
      sym_type_descriptor,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4400), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7865), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [81228] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6140), 1,
      sym_identifier,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(8088), 1,
      anon_sym_STAR,
    ACTIONS(8090), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8092), 1,
      anon_sym_AMP,
    ACTIONS(8094), 1,
      anon_sym_COLON_COLON,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6902), 1,
      sym__scope_resolution,
    STATE(8171), 1,
      sym__declarator,
    STATE(10164), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4152), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4846), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [81336] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8114), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8118), 1,
      anon_sym_PIPE,
    ACTIONS(8122), 1,
      anon_sym_AMP,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8136), 1,
      anon_sym_or,
    ACTIONS(8138), 1,
      anon_sym_and,
    ACTIONS(8140), 1,
      anon_sym_bitor,
    ACTIONS(8142), 1,
      anon_sym_bitand,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(7358), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(8110), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8128), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8144), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8112), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8134), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8126), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7360), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [81442] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8070), 1,
      anon_sym_enum,
    ACTIONS(8072), 1,
      anon_sym_class,
    ACTIONS(8074), 1,
      anon_sym_struct,
    ACTIONS(8076), 1,
      anon_sym_union,
    ACTIONS(8078), 1,
      anon_sym_typename,
    ACTIONS(8080), 1,
      anon_sym_interface,
    ACTIONS(8082), 1,
      anon_sym_extension,
    ACTIONS(8206), 1,
      sym_identifier,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5859), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6009), 1,
      sym_type_specifier,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(8528), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4331), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8068), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [81552] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5479), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7167), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4374), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [81662] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9663), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [81772] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(10823), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [81882] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8144), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6984), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6986), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [81958] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8236), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(8234), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(8232), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(8230), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [82024] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4763), 1,
      sym_type_specifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7898), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4341), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [82134] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(8983), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [82244] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4763), 1,
      sym_type_specifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7604), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4341), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [82354] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9083), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [82464] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10582), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [82574] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5479), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7148), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4374), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [82684] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4987), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7662), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4334), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [82794] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8238), 1,
      anon_sym_LT,
    STATE(4354), 1,
      sym_template_argument_list,
    ACTIONS(6952), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6954), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [82862] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6761), 1,
      sym_identifier,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7264), 1,
      sym__declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4215), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4841), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [82970] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4960), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(8321), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4248), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [83080] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4987), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7658), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4334), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [83190] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7616), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7618), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7955), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7957), 1,
      anon_sym_COMMA,
    ACTIONS(7961), 1,
      anon_sym_DASH,
    ACTIONS(7963), 1,
      anon_sym_PLUS,
    ACTIONS(7965), 1,
      anon_sym_STAR,
    ACTIONS(7967), 1,
      anon_sym_SLASH,
    ACTIONS(7969), 1,
      anon_sym_PERCENT,
    ACTIONS(7971), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7973), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_CARET,
    ACTIONS(7979), 1,
      anon_sym_AMP,
    ACTIONS(7981), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7983), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7985), 1,
      anon_sym_GT,
    ACTIONS(7987), 1,
      anon_sym_GT_EQ,
    ACTIONS(7989), 1,
      anon_sym_LT_EQ,
    ACTIONS(7991), 1,
      anon_sym_LT,
    ACTIONS(7993), 1,
      anon_sym_LT_LT,
    ACTIONS(7995), 1,
      anon_sym_GT_GT,
    ACTIONS(7997), 1,
      anon_sym_EQ,
    ACTIONS(7999), 1,
      anon_sym_QMARK,
    ACTIONS(8001), 1,
      anon_sym_STAR_EQ,
    ACTIONS(8003), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(8005), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(8007), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(8009), 1,
      anon_sym_DASH_EQ,
    ACTIONS(8011), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(8013), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(8015), 1,
      anon_sym_AMP_EQ,
    ACTIONS(8017), 1,
      anon_sym_CARET_EQ,
    ACTIONS(8019), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(8023), 1,
      anon_sym_or,
    ACTIONS(8025), 1,
      anon_sym_and,
    ACTIONS(8027), 1,
      anon_sym_bitor,
    ACTIONS(8029), 1,
      anon_sym_xor,
    ACTIONS(8031), 1,
      anon_sym_bitand,
    ACTIONS(8033), 1,
      anon_sym_not_eq,
    ACTIONS(8241), 1,
      anon_sym_RPAREN,
    STATE(2393), 1,
      sym__binary_fold_operator,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    STATE(10128), 1,
      sym__fold_operator,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8021), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [83348] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6761), 1,
      sym_identifier,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7317), 1,
      sym__declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4823), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4835), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [83456] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8070), 1,
      anon_sym_enum,
    ACTIONS(8072), 1,
      anon_sym_class,
    ACTIONS(8074), 1,
      anon_sym_struct,
    ACTIONS(8076), 1,
      anon_sym_union,
    ACTIONS(8078), 1,
      anon_sym_typename,
    ACTIONS(8080), 1,
      anon_sym_interface,
    ACTIONS(8082), 1,
      anon_sym_extension,
    ACTIONS(8206), 1,
      sym_identifier,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5341), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5859), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(7142), 1,
      sym_type_descriptor,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4345), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8068), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [83566] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7861), 1,
      sym_identifier,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(7869), 1,
      anon_sym_enum,
    ACTIONS(7871), 1,
      anon_sym_class,
    ACTIONS(7873), 1,
      anon_sym_struct,
    ACTIONS(7875), 1,
      anon_sym_union,
    ACTIONS(7877), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      anon_sym_interface,
    ACTIONS(7881), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5512), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5679), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(8188), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4350), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7865), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [83676] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9182), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [83786] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4987), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7148), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4334), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [83896] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4987), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7167), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4334), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [84006] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7861), 1,
      sym_identifier,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(7869), 1,
      anon_sym_enum,
    ACTIONS(7871), 1,
      anon_sym_class,
    ACTIONS(7873), 1,
      anon_sym_struct,
    ACTIONS(7875), 1,
      anon_sym_union,
    ACTIONS(7877), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      anon_sym_interface,
    ACTIONS(7881), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5086), 1,
      sym_type_specifier,
    STATE(5512), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7640), 1,
      sym_type_descriptor,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4400), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7865), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [84116] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10540), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [84226] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(8602), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [84336] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5888), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(9566), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [84446] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4763), 1,
      sym_type_specifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7108), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4341), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [84556] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8243), 1,
      anon_sym_LT,
    STATE(111), 1,
      sym_template_argument_list,
    ACTIONS(6996), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6998), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [84622] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(10847), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [84732] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6761), 1,
      sym_identifier,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7944), 1,
      anon_sym_STAR,
    ACTIONS(7946), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7948), 1,
      anon_sym_AMP,
    ACTIONS(7950), 1,
      anon_sym_COLON_COLON,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6954), 1,
      sym__scope_resolution,
    STATE(8138), 1,
      sym__declarator,
    STATE(10201), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4823), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4830), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [84840] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10542), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [84950] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7616), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7618), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7955), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7957), 1,
      anon_sym_COMMA,
    ACTIONS(7961), 1,
      anon_sym_DASH,
    ACTIONS(7963), 1,
      anon_sym_PLUS,
    ACTIONS(7965), 1,
      anon_sym_STAR,
    ACTIONS(7967), 1,
      anon_sym_SLASH,
    ACTIONS(7969), 1,
      anon_sym_PERCENT,
    ACTIONS(7971), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7973), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_CARET,
    ACTIONS(7979), 1,
      anon_sym_AMP,
    ACTIONS(7981), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7983), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7985), 1,
      anon_sym_GT,
    ACTIONS(7987), 1,
      anon_sym_GT_EQ,
    ACTIONS(7989), 1,
      anon_sym_LT_EQ,
    ACTIONS(7991), 1,
      anon_sym_LT,
    ACTIONS(7993), 1,
      anon_sym_LT_LT,
    ACTIONS(7995), 1,
      anon_sym_GT_GT,
    ACTIONS(7997), 1,
      anon_sym_EQ,
    ACTIONS(7999), 1,
      anon_sym_QMARK,
    ACTIONS(8001), 1,
      anon_sym_STAR_EQ,
    ACTIONS(8003), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(8005), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(8007), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(8009), 1,
      anon_sym_DASH_EQ,
    ACTIONS(8011), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(8013), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(8015), 1,
      anon_sym_AMP_EQ,
    ACTIONS(8017), 1,
      anon_sym_CARET_EQ,
    ACTIONS(8019), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(8023), 1,
      anon_sym_or,
    ACTIONS(8025), 1,
      anon_sym_and,
    ACTIONS(8027), 1,
      anon_sym_bitor,
    ACTIONS(8029), 1,
      anon_sym_xor,
    ACTIONS(8031), 1,
      anon_sym_bitand,
    ACTIONS(8033), 1,
      anon_sym_not_eq,
    ACTIONS(8246), 1,
      anon_sym_RPAREN,
    STATE(2393), 1,
      sym__binary_fold_operator,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    STATE(10128), 1,
      sym__fold_operator,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8021), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [85108] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4982), 1,
      sym_type_specifier,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7599), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4241), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [85218] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4763), 1,
      sym_type_specifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(7065), 1,
      sym_type_descriptor,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4341), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [85328] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5755), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(9986), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [85438] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5479), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(8159), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4374), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [85548] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6761), 1,
      sym_identifier,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7944), 1,
      anon_sym_STAR,
    ACTIONS(7946), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7948), 1,
      anon_sym_AMP,
    ACTIONS(7950), 1,
      anon_sym_COLON_COLON,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6954), 1,
      sym__scope_resolution,
    STATE(8080), 1,
      sym__declarator,
    STATE(10201), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4228), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4820), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [85656] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4982), 1,
      sym_type_specifier,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(7836), 1,
      sym_type_descriptor,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(4241), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [85766] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8070), 1,
      anon_sym_enum,
    ACTIONS(8072), 1,
      anon_sym_class,
    ACTIONS(8074), 1,
      anon_sym_struct,
    ACTIONS(8076), 1,
      anon_sym_union,
    ACTIONS(8078), 1,
      anon_sym_typename,
    ACTIONS(8080), 1,
      anon_sym_interface,
    ACTIONS(8082), 1,
      anon_sym_extension,
    ACTIONS(8206), 1,
      sym_identifier,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5859), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6009), 1,
      sym_type_specifier,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(8561), 1,
      sym_type_descriptor,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4331), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8068), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [85876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6887), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6889), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [85937] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4239), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8248), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2856), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2854), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [86002] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7444), 1,
      anon_sym_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8251), 1,
      anon_sym_DASH_GT,
    ACTIONS(8253), 1,
      anon_sym_requires,
    ACTIONS(8256), 1,
      anon_sym_where,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(6028), 1,
      sym__function_attributes_start,
    STATE(6122), 1,
      sym_ref_qualifier,
    STATE(7038), 1,
      sym__function_attributes_end,
    STATE(7202), 1,
      sym_where_clause,
    STATE(7315), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7454), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8154), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4992), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5493), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7743), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6471), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7432), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(8150), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [86117] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4956), 1,
      sym_type_specifier,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(5970), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [86224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7174), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7176), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [86285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6511), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6513), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [86346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7108), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7110), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [86407] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8259), 1,
      anon_sym_LT,
    STATE(2910), 1,
      sym_template_argument_list,
    ACTIONS(6996), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6998), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [86472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6895), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6897), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [86533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6867), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6869), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [86594] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4977), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    STATE(5970), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [86701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7055), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7057), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [86762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7238), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7240), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [86823] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6636), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(2128), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2117), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [86886] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(8161), 1,
      sym_identifier,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8165), 1,
      anon_sym_enum,
    ACTIONS(8167), 1,
      anon_sym_class,
    ACTIONS(8169), 1,
      anon_sym_struct,
    ACTIONS(8171), 1,
      anon_sym_union,
    ACTIONS(8173), 1,
      anon_sym_typename,
    ACTIONS(8175), 1,
      anon_sym_interface,
    ACTIONS(8177), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4855), 1,
      sym_type_specifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(5970), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [86993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6974), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6976), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [87054] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6647), 1,
      anon_sym_EQ,
    ACTIONS(6649), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(2128), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2117), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [87119] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8204), 1,
      anon_sym_LT,
    STATE(4549), 1,
      sym_template_argument_list,
    ACTIONS(2347), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2349), 25,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [87186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7049), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7051), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [87247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7196), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7198), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [87308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7003), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7005), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [87369] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2359), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2357), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [87430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7003), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7005), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [87491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7003), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7005), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [87552] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8262), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7023), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7025), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [87615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3036), 26,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3034), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [87676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3036), 26,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3034), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [87737] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4795), 1,
      sym_type_specifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(5970), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [87844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7138), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7140), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [87905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7266), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7268), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [87966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6613), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6611), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [88027] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7222), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7224), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [88088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6062), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [88149] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8264), 1,
      sym_identifier,
    STATE(4398), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(6185), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6187), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6437), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(6439), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
  [88218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3346), 26,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3344), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [88279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6816), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6818), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88340] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8042), 1,
      sym_identifier,
    ACTIONS(8044), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8048), 1,
      sym_primitive_type,
    ACTIONS(8050), 1,
      anon_sym_enum,
    ACTIONS(8052), 1,
      anon_sym_class,
    ACTIONS(8054), 1,
      anon_sym_struct,
    ACTIONS(8056), 1,
      anon_sym_union,
    ACTIONS(8058), 1,
      anon_sym_typename,
    ACTIONS(8060), 1,
      anon_sym_interface,
    ACTIONS(8062), 1,
      anon_sym_extension,
    STATE(405), 1,
      sym_qualified_type_identifier,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5133), 1,
      sym_type_specifier,
    STATE(5463), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8039), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(5970), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(121), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8046), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(361), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [88447] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8042), 1,
      sym_identifier,
    ACTIONS(8044), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8048), 1,
      sym_primitive_type,
    ACTIONS(8050), 1,
      anon_sym_enum,
    ACTIONS(8052), 1,
      anon_sym_class,
    ACTIONS(8054), 1,
      anon_sym_struct,
    ACTIONS(8056), 1,
      anon_sym_union,
    ACTIONS(8058), 1,
      anon_sym_typename,
    ACTIONS(8060), 1,
      anon_sym_interface,
    ACTIONS(8062), 1,
      anon_sym_extension,
    STATE(405), 1,
      sym_qualified_type_identifier,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5463), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5765), 1,
      sym_type_specifier,
    STATE(8039), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(5970), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(121), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8046), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(361), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [88554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6826), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6842), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6844), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6830), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6832), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5896), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5898), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [88798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3346), 26,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3344), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [88859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3036), 26,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3034), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [88920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3346), 26,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3344), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [88981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7023), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7025), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [89042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6460), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6462), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [89103] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8266), 1,
      anon_sym_LT,
    STATE(4549), 1,
      sym_template_argument_list,
    ACTIONS(2169), 25,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2176), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [89170] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6922), 1,
      sym_literal_suffix,
    ACTIONS(2117), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(2128), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
  [89233] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7258), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7260), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [89294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7154), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7156), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [89355] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8269), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8271), 1,
      anon_sym_and,
    ACTIONS(6204), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6206), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [89420] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6922), 1,
      sym_literal_suffix,
    ACTIONS(6596), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(6594), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
  [89483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7242), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7244), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [89544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2128), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2117), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [89605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5941), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5943), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [89666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5886), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5888), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [89727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7218), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7220), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [89788] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5843), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(5970), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [89895] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5655), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(5970), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [90002] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8259), 1,
      anon_sym_LT,
    STATE(4135), 1,
      sym_template_argument_list,
    ACTIONS(6996), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6998), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7150), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7152), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [90128] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5892), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5894), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [90189] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8269), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8271), 1,
      anon_sym_and,
    ACTIONS(8273), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8275), 1,
      anon_sym_or,
    ACTIONS(6192), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6194), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [90258] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8279), 1,
      anon_sym___attribute__,
    ACTIONS(8285), 1,
      anon_sym_DASH_GT,
    ACTIONS(8289), 1,
      anon_sym_noexcept,
    ACTIONS(8291), 1,
      anon_sym_throw,
    ACTIONS(8293), 1,
      anon_sym_requires,
    ACTIONS(8295), 1,
      anon_sym_where,
    STATE(6030), 1,
      sym__function_attributes_start,
    STATE(6084), 1,
      sym_alignas_qualifier,
    STATE(6115), 1,
      sym_ref_qualifier,
    STATE(7046), 1,
      sym__function_attributes_end,
    STATE(7202), 1,
      sym_where_clause,
    STATE(7320), 1,
      sym_trailing_return_type,
    STATE(8412), 1,
      sym_gnu_asm_expression,
    ACTIONS(7444), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(8281), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8283), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5319), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5917), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8154), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6467), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7432), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(8277), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [90371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6875), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6877), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7214), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7216), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [90493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6810), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6812), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5010), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5006), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [90615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7262), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7264), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [90676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7130), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7132), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [90737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7154), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7156), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [90798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7166), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7168), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [90859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5933), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5935), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [90920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7228), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [90981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7246), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7248), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [91042] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5941), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    STATE(5970), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [91149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6838), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6840), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7033), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7035), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [91271] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5858), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5860), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [91332] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5858), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5860), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [91393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5858), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5860), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [91454] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7833), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    ACTIONS(7849), 1,
      anon_sym_interface,
    ACTIONS(7851), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(6114), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6124), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(5970), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [91561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3184), 26,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3182), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [91622] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7444), 1,
      anon_sym_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8251), 1,
      anon_sym_DASH_GT,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8299), 1,
      anon_sym_where,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(6014), 1,
      sym__function_attributes_start,
    STATE(6148), 1,
      sym_ref_qualifier,
    STATE(7045), 1,
      sym__function_attributes_end,
    STATE(7202), 1,
      sym_where_clause,
    STATE(7259), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8154), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4992), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5493), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8210), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6474), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7432), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(8150), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [91737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6056), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6058), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [91798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2128), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2117), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [91859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7250), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7252), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [91920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7019), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7021), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3184), 26,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3182), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [92042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7192), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7194), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [92103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5418), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3834), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [92164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7200), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7202), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [92225] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8070), 1,
      anon_sym_enum,
    ACTIONS(8072), 1,
      anon_sym_class,
    ACTIONS(8074), 1,
      anon_sym_struct,
    ACTIONS(8076), 1,
      anon_sym_union,
    ACTIONS(8078), 1,
      anon_sym_typename,
    ACTIONS(8080), 1,
      anon_sym_interface,
    ACTIONS(8082), 1,
      anon_sym_extension,
    ACTIONS(8206), 1,
      sym_identifier,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5859), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5906), 1,
      sym_type_specifier,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    STATE(5970), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8068), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [92332] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4867), 1,
      anon_sym_LBRACE,
    ACTIONS(7505), 1,
      anon_sym_LPAREN2,
    STATE(4606), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6883), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6885), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [92399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2171), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [92460] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4983), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    STATE(5970), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [92567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2171), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [92628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2171), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [92689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2171), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [92750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7178), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7180), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [92811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2171), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [92872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6970), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6972), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [92933] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4780), 1,
      sym_type_specifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    STATE(5970), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [93040] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5209), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(5970), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [93147] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5184), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    STATE(5970), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [93254] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(8161), 1,
      sym_identifier,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8165), 1,
      anon_sym_enum,
    ACTIONS(8167), 1,
      anon_sym_class,
    ACTIONS(8169), 1,
      anon_sym_struct,
    ACTIONS(8171), 1,
      anon_sym_union,
    ACTIONS(8173), 1,
      anon_sym_typename,
    ACTIONS(8175), 1,
      anon_sym_interface,
    ACTIONS(8177), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5180), 1,
      sym_type_specifier,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(5970), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [93361] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8070), 1,
      anon_sym_enum,
    ACTIONS(8072), 1,
      anon_sym_class,
    ACTIONS(8074), 1,
      anon_sym_struct,
    ACTIONS(8076), 1,
      anon_sym_union,
    ACTIONS(8078), 1,
      anon_sym_typename,
    ACTIONS(8080), 1,
      anon_sym_interface,
    ACTIONS(8082), 1,
      anon_sym_extension,
    ACTIONS(8206), 1,
      sym_identifier,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5430), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5859), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    STATE(5970), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8068), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [93468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7160), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7146), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7148), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5953), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5955), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5961), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5963), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93712] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7861), 1,
      sym_identifier,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(7869), 1,
      anon_sym_enum,
    ACTIONS(7871), 1,
      anon_sym_class,
    ACTIONS(7873), 1,
      anon_sym_struct,
    ACTIONS(7875), 1,
      anon_sym_union,
    ACTIONS(7877), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      anon_sym_interface,
    ACTIONS(7881), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5512), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5664), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    STATE(5970), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7865), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [93819] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4845), 1,
      sym_type_specifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(5970), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [93926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7029), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7031), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93987] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4867), 1,
      anon_sym_LBRACE,
    ACTIONS(7505), 1,
      anon_sym_LPAREN2,
    STATE(4608), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6834), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6836), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [94054] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2217), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6939), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6941), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [94117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2171), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [94178] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8279), 1,
      anon_sym___attribute__,
    ACTIONS(8285), 1,
      anon_sym_DASH_GT,
    ACTIONS(8289), 1,
      anon_sym_noexcept,
    ACTIONS(8291), 1,
      anon_sym_throw,
    ACTIONS(8304), 1,
      anon_sym_requires,
    ACTIONS(8307), 1,
      anon_sym_where,
    STATE(6023), 1,
      sym__function_attributes_start,
    STATE(6084), 1,
      sym_alignas_qualifier,
    STATE(6119), 1,
      sym_ref_qualifier,
    STATE(7072), 1,
      sym__function_attributes_end,
    STATE(7202), 1,
      sym_where_clause,
    STATE(7263), 1,
      sym_trailing_return_type,
    STATE(8412), 1,
      sym_gnu_asm_expression,
    ACTIONS(7444), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(8281), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8283), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8301), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5319), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5917), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7771), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6473), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7432), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(8277), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [94291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7078), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7080), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [94352] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8310), 1,
      sym_identifier,
    STATE(4358), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(8313), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(8316), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6444), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(6446), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
  [94421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4545), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4547), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [94482] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5831), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    STATE(5970), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [94589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3040), 26,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3038), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [94650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3040), 26,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3038), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [94711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7112), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7114), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [94772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7210), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7212), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [94833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7204), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7206), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [94894] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4239), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8319), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3750), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3752), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [94959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6871), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6873), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [95020] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7182), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7184), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7088), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7090), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95142] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4239), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8319), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3757), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3759), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [95207] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4391), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8321), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3764), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3766), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [95272] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4385), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3771), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3773), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [95337] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4867), 1,
      anon_sym_LBRACE,
    ACTIONS(7505), 1,
      anon_sym_LPAREN2,
    STATE(4619), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6859), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6861), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95404] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5497), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    STATE(5970), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [95511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7126), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7128), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6431), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6433), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [95633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2355), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2353), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7186), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7188), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7116), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7118), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7134), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7136), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7428), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(7426), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
  [95938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7096), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7098), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7074), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7076), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96060] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4366), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8325), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3392), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3390), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [96125] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4239), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8319), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3803), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3805), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [96190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7084), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7086), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7092), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7094), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7234), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7236), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7230), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7232), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5925), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5927), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96495] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4239), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8319), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3810), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3812), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [96560] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(5036), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    STATE(5970), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [96667] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5469), 1,
      sym_type_specifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    STATE(5970), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [96774] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7172), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7102), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96896] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4867), 1,
      anon_sym_LBRACE,
    ACTIONS(7505), 1,
      anon_sym_LPAREN2,
    STATE(4629), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6820), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6822), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7061), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [97024] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8327), 1,
      sym_identifier,
    STATE(4358), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(6185), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6187), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6456), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(6458), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
  [97093] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5078), 1,
      sym_type_specifier,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    STATE(5970), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [97200] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7861), 1,
      sym_identifier,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(7869), 1,
      anon_sym_enum,
    ACTIONS(7871), 1,
      anon_sym_class,
    ACTIONS(7873), 1,
      anon_sym_struct,
    ACTIONS(7875), 1,
      anon_sym_union,
    ACTIONS(7877), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      anon_sym_interface,
    ACTIONS(7881), 1,
      anon_sym_extension,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(5110), 1,
      sym_type_specifier,
    STATE(5512), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    STATE(5970), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7865), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(63), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [97307] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8329), 1,
      anon_sym_LT,
    STATE(134), 1,
      sym_template_argument_list,
    ACTIONS(6996), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6998), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [97372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5937), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5939), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7104), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7106), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6044), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6046), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6526), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [97616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4573), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4575), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [97677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7254), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7256), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97738] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2371), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2373), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [97800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2246), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [97860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7074), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7076), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [97920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8334), 25,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(8332), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [97980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7055), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7057), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [98040] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      sym_literal_suffix,
    STATE(3814), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(6651), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6653), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2128), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
    ACTIONS(2117), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [98108] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6183), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(6181), 12,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(2128), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2117), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [98172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7023), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7025), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [98232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7238), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7240), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [98292] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      sym_literal_suffix,
    STATE(3814), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(6651), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6653), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6594), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
    ACTIONS(6596), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [98360] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7007), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(7009), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [98434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7210), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7212), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [98494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7204), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7206), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [98554] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7007), 1,
      anon_sym_EQ,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8342), 1,
      anon_sym_PIPE,
    ACTIONS(8344), 1,
      anon_sym_CARET,
    ACTIONS(8346), 1,
      anon_sym_AMP,
    ACTIONS(8352), 1,
      anon_sym_GT_EQ,
    ACTIONS(8356), 1,
      anon_sym_bitor,
    ACTIONS(8358), 1,
      anon_sym_xor,
    ACTIONS(8360), 1,
      anon_sym_bitand,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8336), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8340), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8354), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8021), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8338), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8348), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8350), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_DASH_GT_STAR,
  [98656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7003), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7005), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [98716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7003), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7005), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [98776] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8344), 1,
      anon_sym_CARET,
    ACTIONS(8346), 1,
      anon_sym_AMP,
    ACTIONS(8352), 1,
      anon_sym_GT_EQ,
    ACTIONS(8358), 1,
      anon_sym_xor,
    ACTIONS(8360), 1,
      anon_sym_bitand,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7007), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8336), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8354), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8021), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8338), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8348), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8350), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_DASH_GT_STAR,
  [98872] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6752), 1,
      anon_sym_EQ,
    ACTIONS(6754), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(2128), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2117), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [98936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7200), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7202), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [98996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7003), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7005), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [99056] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8366), 1,
      anon_sym_or,
    ACTIONS(8368), 1,
      anon_sym_and,
    ACTIONS(6192), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6194), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [99124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2359), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2357), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [99184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7112), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7114), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [99244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6613), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6611), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [99304] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8346), 1,
      anon_sym_AMP,
    ACTIONS(8352), 1,
      anon_sym_GT_EQ,
    ACTIONS(8360), 1,
      anon_sym_bitand,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8336), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8354), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7007), 3,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
    ACTIONS(8021), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8338), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8348), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8350), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_DASH_GT_STAR,
  [99396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7266), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7268), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [99456] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8352), 1,
      anon_sym_GT_EQ,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8336), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8354), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8021), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8338), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8348), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8350), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(7009), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_DASH_GT_STAR,
  [99544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7228), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [99604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7196), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7198), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [99664] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8352), 1,
      anon_sym_GT_EQ,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8336), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8354), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8021), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8338), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8350), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(7009), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [99750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7084), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7086), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [99810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7134), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7136), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [99870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2355), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2353), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [99930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7174), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7176), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [99990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7029), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7031), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [100050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7033), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7035), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [100110] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7358), 1,
      anon_sym_EQ,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8342), 1,
      anon_sym_PIPE,
    ACTIONS(8344), 1,
      anon_sym_CARET,
    ACTIONS(8346), 1,
      anon_sym_AMP,
    ACTIONS(8352), 1,
      anon_sym_GT_EQ,
    ACTIONS(8356), 1,
      anon_sym_bitor,
    ACTIONS(8358), 1,
      anon_sym_xor,
    ACTIONS(8360), 1,
      anon_sym_bitand,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8336), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8340), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8354), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8370), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8021), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8338), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8348), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8350), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7360), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [100214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7092), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7094), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [100274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7234), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7236), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [100334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6974), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6976), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [100394] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7230), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7232), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [100454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5937), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5939), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [100514] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7507), 1,
      anon_sym_LBRACK,
    STATE(4566), 1,
      sym_new_declarator,
    ACTIONS(6924), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6926), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [100578] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8336), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8354), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8021), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8338), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7007), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(7009), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [100660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7166), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7168), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [100720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7154), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7156), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [100780] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7444), 1,
      anon_sym_LBRACK,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8253), 1,
      anon_sym_requires,
    ACTIONS(8372), 1,
      anon_sym_DASH_GT,
    ACTIONS(8374), 1,
      anon_sym_where,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(6058), 1,
      sym__function_attributes_start,
    STATE(6167), 1,
      sym_ref_qualifier,
    STATE(7202), 1,
      sym_where_clause,
    STATE(7231), 1,
      sym__function_attributes_end,
    STATE(7382), 1,
      sym_trailing_return_type,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7454), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4858), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5151), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7952), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6477), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7432), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [100894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7138), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7140), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [100954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2228), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2230), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [101014] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2152), 1,
      anon_sym_EQ,
    ACTIONS(2165), 1,
      anon_sym_SEMI,
    ACTIONS(6165), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6602), 1,
      anon_sym_LPAREN2,
    ACTIONS(6605), 1,
      anon_sym_LBRACK,
    ACTIONS(2154), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(2117), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2128), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
  [101086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7102), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [101146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7078), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7080), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [101206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7172), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [101266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7218), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7220), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [101326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7154), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7156), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [101386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7246), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7248), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [101446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7262), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7264), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [101506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6056), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6058), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [101566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6062), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [101626] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    ACTIONS(8377), 1,
      anon_sym_COLON,
    ACTIONS(8379), 1,
      anon_sym_LBRACE,
    STATE(4668), 1,
      sym__enum_base_clause,
    STATE(4698), 1,
      sym_enumerator_list,
    STATE(4807), 1,
      sym_attribute_specifier,
    ACTIONS(3348), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3350), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [101698] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    ACTIONS(8377), 1,
      anon_sym_COLON,
    ACTIONS(8379), 1,
      anon_sym_LBRACE,
    STATE(4666), 1,
      sym__enum_base_clause,
    STATE(4685), 1,
      sym_enumerator_list,
    STATE(4799), 1,
      sym_attribute_specifier,
    ACTIONS(3060), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3062), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [101770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2234), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [101830] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7258), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7260), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [101890] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7000), 1,
      anon_sym_LT,
    STATE(2957), 1,
      sym_template_argument_list,
    ACTIONS(6996), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6998), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [101954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2246), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [102014] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6643), 1,
      anon_sym_EQ,
    ACTIONS(6645), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(2128), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2117), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [102078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2248), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2250), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [102138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2258), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [102198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2198), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2200), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [102258] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2252), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2254), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [102318] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7444), 1,
      anon_sym_LBRACK,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8381), 1,
      anon_sym_DASH_GT,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8385), 1,
      anon_sym_where,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(6039), 1,
      sym__function_attributes_start,
    STATE(6188), 1,
      sym_ref_qualifier,
    STATE(7163), 1,
      sym__function_attributes_end,
    STATE(7202), 1,
      sym_where_clause,
    STATE(7401), 1,
      sym_trailing_return_type,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4858), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5151), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8319), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6476), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7432), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [102432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5941), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5943), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102492] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7414), 1,
      anon_sym_EQ,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7955), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7999), 1,
      anon_sym_QMARK,
    ACTIONS(8342), 1,
      anon_sym_PIPE,
    ACTIONS(8344), 1,
      anon_sym_CARET,
    ACTIONS(8346), 1,
      anon_sym_AMP,
    ACTIONS(8352), 1,
      anon_sym_GT_EQ,
    ACTIONS(8356), 1,
      anon_sym_bitor,
    ACTIONS(8358), 1,
      anon_sym_xor,
    ACTIONS(8360), 1,
      anon_sym_bitand,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8336), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8340), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8354), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8370), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8021), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8338), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8348), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8350), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7416), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [102600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7146), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7148), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7150), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7152), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7108), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7110), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2171), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102840] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7444), 1,
      anon_sym_LBRACK,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8381), 1,
      anon_sym_DASH_GT,
    ACTIONS(8387), 1,
      anon_sym_requires,
    ACTIONS(8390), 1,
      anon_sym_where,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(6046), 1,
      sym__function_attributes_start,
    STATE(6184), 1,
      sym_ref_qualifier,
    STATE(7134), 1,
      sym__function_attributes_end,
    STATE(7202), 1,
      sym_where_clause,
    STATE(7414), 1,
      sym_trailing_return_type,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7454), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4858), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5151), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8023), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6485), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7432), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [102954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7104), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7106), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7182), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7184), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103074] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7192), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7194), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103134] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7011), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(7013), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
  [103206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5896), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5898), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7088), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7090), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7126), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7128), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7186), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7188), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5925), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5927), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6044), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6046), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2186), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2188), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [103626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2228), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2230), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [103686] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2234), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [103746] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8338), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7007), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(7009), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [103822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2224), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2226), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [103882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2252), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2254), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [103942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2190), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2192), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [104002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2196), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [104062] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8368), 1,
      anon_sym_and,
    ACTIONS(6204), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6206), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [104126] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5961), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5963), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [104186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2240), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2242), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [104246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2236), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2238), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [104306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5953), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5955), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [104366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7160), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [104426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7178), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7180), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [104486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2202), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2204), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [104546] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2206), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2208), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [104606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5418), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3834), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [104666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5886), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5888), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [104726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2236), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2238), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [104786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2224), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2226), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [104846] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2186), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2188), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [104906] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5858), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5860), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [104966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5858), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5860), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [105026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7214), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7216), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [105086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5858), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5860), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [105146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2171), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [105206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2171), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [105266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2171), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [105326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2171), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [105386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2198), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2200), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [105446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2171), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [105506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5933), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5935), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [105566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7130), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7132), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [105626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2258), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [105686] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5010), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5006), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [105746] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7037), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(7039), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [105820] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7041), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(7043), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [105894] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_EQ,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8342), 1,
      anon_sym_PIPE,
    ACTIONS(8344), 1,
      anon_sym_CARET,
    ACTIONS(8346), 1,
      anon_sym_AMP,
    ACTIONS(8352), 1,
      anon_sym_GT_EQ,
    ACTIONS(8356), 1,
      anon_sym_bitor,
    ACTIONS(8358), 1,
      anon_sym_xor,
    ACTIONS(8360), 1,
      anon_sym_bitand,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8336), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8340), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8354), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8370), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8021), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8338), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8348), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8350), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7400), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [105998] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6984), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6986), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [106072] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7045), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(7047), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
  [106144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5892), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5894), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [106204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7242), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7244), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [106264] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2248), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2250), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [106324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2128), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2117), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [106384] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7444), 1,
      anon_sym_LBRACK,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8372), 1,
      anon_sym_DASH_GT,
    ACTIONS(8393), 1,
      anon_sym_where,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(6051), 1,
      sym__function_attributes_start,
    STATE(6163), 1,
      sym_ref_qualifier,
    STATE(7202), 1,
      sym_where_clause,
    STATE(7241), 1,
      sym__function_attributes_end,
    STATE(7432), 1,
      sym_trailing_return_type,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4858), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5151), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8248), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6481), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7432), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [106498] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4366), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8325), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2742), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2740), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [106562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2206), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2208), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [106622] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2371), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2373), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [106684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2128), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2117), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [106744] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2202), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2204), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [106804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7222), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7224), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [106864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2361), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2363), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [106924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2210), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2217), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [106984] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7406), 1,
      anon_sym_EQ,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8342), 1,
      anon_sym_PIPE,
    ACTIONS(8344), 1,
      anon_sym_CARET,
    ACTIONS(8346), 1,
      anon_sym_AMP,
    ACTIONS(8352), 1,
      anon_sym_GT_EQ,
    ACTIONS(8356), 1,
      anon_sym_bitor,
    ACTIONS(8358), 1,
      anon_sym_xor,
    ACTIONS(8360), 1,
      anon_sym_bitand,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8336), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8340), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8354), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8370), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8021), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8338), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8348), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8350), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7408), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [107088] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7178), 1,
      anon_sym_EQ,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7955), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7999), 1,
      anon_sym_QMARK,
    ACTIONS(8342), 1,
      anon_sym_PIPE,
    ACTIONS(8344), 1,
      anon_sym_CARET,
    ACTIONS(8346), 1,
      anon_sym_AMP,
    ACTIONS(8352), 1,
      anon_sym_GT_EQ,
    ACTIONS(8356), 1,
      anon_sym_bitor,
    ACTIONS(8358), 1,
      anon_sym_xor,
    ACTIONS(8360), 1,
      anon_sym_bitand,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8336), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8340), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8354), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8370), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8021), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8338), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8348), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8350), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7180), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [107196] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2365), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2367), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [107258] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7422), 1,
      anon_sym_EQ,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8342), 1,
      anon_sym_PIPE,
    ACTIONS(8344), 1,
      anon_sym_CARET,
    ACTIONS(8346), 1,
      anon_sym_AMP,
    ACTIONS(8352), 1,
      anon_sym_GT_EQ,
    ACTIONS(8356), 1,
      anon_sym_bitor,
    ACTIONS(8358), 1,
      anon_sym_xor,
    ACTIONS(8360), 1,
      anon_sym_bitand,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8336), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8340), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8354), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8370), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8021), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8338), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8348), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8350), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7424), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [107362] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7007), 1,
      anon_sym_EQ,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8342), 1,
      anon_sym_PIPE,
    ACTIONS(8344), 1,
      anon_sym_CARET,
    ACTIONS(8346), 1,
      anon_sym_AMP,
    ACTIONS(8352), 1,
      anon_sym_GT_EQ,
    ACTIONS(8356), 1,
      anon_sym_bitor,
    ACTIONS(8358), 1,
      anon_sym_xor,
    ACTIONS(8360), 1,
      anon_sym_bitand,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8336), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8354), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8021), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8338), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8348), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8350), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH_GT_STAR,
  [107462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2240), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2242), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7116), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7118), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [107582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7096), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7098), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [107642] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2217), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(2222), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2212), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [107704] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7410), 1,
      anon_sym_EQ,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7955), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7999), 1,
      anon_sym_QMARK,
    ACTIONS(8342), 1,
      anon_sym_PIPE,
    ACTIONS(8344), 1,
      anon_sym_CARET,
    ACTIONS(8346), 1,
      anon_sym_AMP,
    ACTIONS(8352), 1,
      anon_sym_GT_EQ,
    ACTIONS(8356), 1,
      anon_sym_bitor,
    ACTIONS(8358), 1,
      anon_sym_xor,
    ACTIONS(8360), 1,
      anon_sym_bitand,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8336), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8340), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8354), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8370), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8021), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8338), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8348), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8350), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7412), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [107812] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8336), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8354), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8338), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7007), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(7009), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [107892] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7570), 1,
      anon_sym_LBRACK,
    ACTIONS(7669), 1,
      anon_sym_DOT_STAR,
    STATE(4309), 1,
      sym_argument_list,
    STATE(4310), 1,
      sym_subscript_argument_list,
    ACTIONS(7614), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8336), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8338), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7007), 9,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(7009), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [107970] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2196), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7254), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7256), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [108090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2190), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2192), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7250), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7252), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [108210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6970), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6972), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [108269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6511), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6513), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [108328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6526), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [108387] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7444), 1,
      anon_sym_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8395), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8398), 1,
      anon_sym_DASH_GT,
    ACTIONS(8400), 1,
      anon_sym_requires,
    ACTIONS(8403), 1,
      anon_sym_where,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(6091), 1,
      sym__function_attributes_start,
    STATE(6249), 1,
      sym_ref_qualifier,
    STATE(7161), 1,
      sym_where_clause,
    STATE(7190), 1,
      sym__function_attributes_end,
    STATE(7451), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7626), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8154), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4992), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5493), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7967), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(7432), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(6494), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8150), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [108500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2373), 25,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2371), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108559] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(8289), 1,
      anon_sym_noexcept,
    ACTIONS(8291), 1,
      anon_sym_throw,
    ACTIONS(8406), 1,
      anon_sym_DASH_GT,
    ACTIONS(8408), 1,
      anon_sym_requires,
    ACTIONS(8410), 1,
      anon_sym_where,
    STATE(2647), 1,
      sym_alignas_qualifier,
    STATE(6104), 1,
      sym__function_attributes_start,
    STATE(6220), 1,
      sym_ref_qualifier,
    STATE(7202), 1,
      sym_where_clause,
    STATE(7292), 1,
      sym__function_attributes_end,
    STATE(7535), 1,
      sym_trailing_return_type,
    STATE(8408), 1,
      sym_gnu_asm_expression,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7432), 2,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
    ACTIONS(7444), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(8283), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5642), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6059), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8365), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6497), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6142), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [108670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6431), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6433), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [108729] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6853), 1,
      sym_literal_suffix,
    ACTIONS(2128), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2117), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [108790] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7444), 1,
      anon_sym_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8387), 1,
      anon_sym_requires,
    ACTIONS(8412), 1,
      anon_sym_DASH_GT,
    ACTIONS(8414), 1,
      anon_sym_where,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(6079), 1,
      sym__function_attributes_start,
    STATE(6257), 1,
      sym_ref_qualifier,
    STATE(7202), 1,
      sym_where_clause,
    STATE(7246), 1,
      sym__function_attributes_end,
    STATE(7512), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7454), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8154), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4992), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5493), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8103), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(7432), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(6499), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8150), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [108903] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6853), 1,
      sym_literal_suffix,
    ACTIONS(6594), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6596), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [108964] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7444), 1,
      anon_sym_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8412), 1,
      anon_sym_DASH_GT,
    ACTIONS(8417), 1,
      anon_sym_where,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(6096), 1,
      sym__function_attributes_start,
    STATE(6248), 1,
      sym_ref_qualifier,
    STATE(7202), 1,
      sym_where_clause,
    STATE(7287), 1,
      sym__function_attributes_end,
    STATE(7491), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8154), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4992), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5493), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8519), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(7432), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(6517), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8150), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [109077] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(8289), 1,
      anon_sym_noexcept,
    ACTIONS(8291), 1,
      anon_sym_throw,
    ACTIONS(8406), 1,
      anon_sym_DASH_GT,
    ACTIONS(8419), 1,
      anon_sym_requires,
    ACTIONS(8422), 1,
      anon_sym_where,
    STATE(2647), 1,
      sym_alignas_qualifier,
    STATE(6070), 1,
      sym__function_attributes_start,
    STATE(6283), 1,
      sym_ref_qualifier,
    STATE(7202), 1,
      sym_where_clause,
    STATE(7248), 1,
      sym__function_attributes_end,
    STATE(7488), 1,
      sym_trailing_return_type,
    STATE(8408), 1,
      sym_gnu_asm_expression,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7432), 2,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
    ACTIONS(7444), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(8283), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8301), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5642), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6059), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8118), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6509), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6142), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [109188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6460), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6462), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [109247] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2217), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(2222), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2212), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109308] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8427), 1,
      anon_sym_STAR,
    ACTIONS(8429), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8431), 1,
      anon_sym_AMP,
    ACTIONS(8433), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    STATE(3549), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(5745), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7040), 1,
      sym__abstract_declarator,
    STATE(7138), 1,
      sym__function_declarator_seq,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8435), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8437), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4583), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4996), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(6763), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [109403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7426), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(7428), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [109462] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8218), 1,
      anon_sym_LT,
    STATE(2816), 1,
      sym_template_argument_list,
    ACTIONS(2349), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(2347), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [109527] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8427), 1,
      anon_sym_STAR,
    ACTIONS(8429), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8431), 1,
      anon_sym_AMP,
    ACTIONS(8433), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    STATE(3549), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(5745), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7030), 1,
      sym__abstract_declarator,
    STATE(7138), 1,
      sym__function_declarator_seq,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8435), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8437), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4999), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5287), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(6777), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [109622] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8441), 1,
      anon_sym_LBRACK,
    STATE(4593), 1,
      sym_new_declarator,
    ACTIONS(6924), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6926), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109685] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8443), 1,
      anon_sym_LT,
    STATE(2816), 1,
      sym_template_argument_list,
    ACTIONS(2169), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(2176), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [109750] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2152), 1,
      anon_sym_EQ,
    ACTIONS(2165), 1,
      anon_sym_SEMI,
    ACTIONS(2154), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(2128), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2117), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109815] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8446), 1,
      anon_sym_STAR,
    ACTIONS(8448), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8450), 1,
      anon_sym_AMP,
    ACTIONS(8454), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    STATE(3489), 1,
      sym_parameter_list,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7081), 1,
      sym__abstract_declarator,
    STATE(7135), 1,
      sym__function_declarator_seq,
    ACTIONS(8456), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8458), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4590), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5004), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(6763), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [109910] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7444), 1,
      anon_sym_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8395), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8398), 1,
      anon_sym_DASH_GT,
    ACTIONS(8466), 1,
      anon_sym_requires,
    ACTIONS(8468), 1,
      anon_sym_where,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(6067), 1,
      sym__function_attributes_start,
    STATE(6334), 1,
      sym_ref_qualifier,
    STATE(7161), 1,
      sym_where_clause,
    STATE(7219), 1,
      sym__function_attributes_end,
    STATE(7457), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8154), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4992), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5493), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8354), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(7432), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(6511), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8150), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [110023] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6922), 1,
      sym_literal_suffix,
    STATE(4271), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(6185), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6187), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2117), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(2128), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
  [110090] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8446), 1,
      anon_sym_STAR,
    ACTIONS(8448), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8450), 1,
      anon_sym_AMP,
    ACTIONS(8454), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    STATE(3489), 1,
      sym_parameter_list,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7074), 1,
      sym__abstract_declarator,
    STATE(7135), 1,
      sym__function_declarator_seq,
    ACTIONS(8456), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8458), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4772), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5002), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(6777), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [110185] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6922), 1,
      sym_literal_suffix,
    STATE(4271), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(6185), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6187), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6594), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
    ACTIONS(6596), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [110252] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7045), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
    ACTIONS(7047), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [110322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6970), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6972), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7112), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7114), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [110438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6460), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6462), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [110496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7210), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7212), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [110554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7204), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7206), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [110612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7182), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7184), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110670] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7011), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
    ACTIONS(7013), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [110740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6431), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6433), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [110798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7116), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7118), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [110856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7096), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7098), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [110914] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7092), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7094), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [110972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7234), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7236), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [111030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7258), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7260), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [111088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7230), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7232), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [111146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5937), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5939), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [111204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7138), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7140), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [111262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7108), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7110), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [111320] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2165), 1,
      anon_sym_SEMI,
    ACTIONS(6592), 1,
      sym_literal_suffix,
    STATE(3342), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(2156), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2158), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2128), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
    ACTIONS(2117), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [111388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7104), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7106), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [111446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7102), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [111504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7078), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7080), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [111562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7172), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [111620] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6984), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
    ACTIONS(6986), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [111692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7234), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7236), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [111750] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4617), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8472), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2854), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(2856), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      sym_primitive_type,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [111812] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7246), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7248), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [111870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7262), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7264), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [111928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6056), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6058), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [111986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6062), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [112044] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 1,
      anon_sym_LBRACE,
    ACTIONS(8441), 1,
      anon_sym_LBRACK,
    ACTIONS(8475), 1,
      anon_sym_LPAREN2,
    STATE(4737), 1,
      sym_new_declarator,
    STATE(4727), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(8477), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(6578), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6580), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [112114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3846), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(3844), 37,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [112172] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 1,
      anon_sym_LBRACE,
    ACTIONS(8441), 1,
      anon_sym_LBRACK,
    ACTIONS(8475), 1,
      anon_sym_LPAREN2,
    STATE(4738), 1,
      sym_new_declarator,
    STATE(4697), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(8477), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(6582), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6584), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [112242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7222), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7224), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [112300] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5896), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5898), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [112358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5941), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5943), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [112416] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7146), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7148), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [112474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7150), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7152), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [112532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7214), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7216), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [112590] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8479), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6204), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6206), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [112650] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 1,
      anon_sym_LBRACE,
    ACTIONS(8441), 1,
      anon_sym_LBRACK,
    ACTIONS(8475), 1,
      anon_sym_LPAREN2,
    STATE(4740), 1,
      sym_new_declarator,
    STATE(4689), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(8477), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(6586), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6588), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [112720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5886), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5888), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [112778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7228), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [112836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7182), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7184), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [112894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7174), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7176), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [112952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7088), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7090), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2128), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2117), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113068] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 1,
      anon_sym_LBRACE,
    ACTIONS(8441), 1,
      anon_sym_LBRACK,
    ACTIONS(8475), 1,
      anon_sym_LPAREN2,
    STATE(4754), 1,
      sym_new_declarator,
    STATE(4708), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(8477), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(6564), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6566), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2359), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2357), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7126), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7128), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5925), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5927), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5418), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3834), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113370] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(8481), 1,
      anon_sym___attribute__,
    ACTIONS(8483), 1,
      anon_sym_LBRACE,
    STATE(4920), 1,
      sym_field_declaration_list,
    STATE(5079), 1,
      sym_attribute_specifier,
    STATE(8852), 1,
      sym_virtual_specifier,
    STATE(9885), 1,
      sym_base_class_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2683), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2685), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [113444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6511), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6513), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [113502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7242), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7244), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6044), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6046), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113618] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8489), 1,
      sym_primitive_type,
    STATE(4651), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8487), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3822), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(3820), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [113684] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8479), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8491), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(6192), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6194), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5892), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5894), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113804] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4617), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2856), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(8472), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3781), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(3778), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [113868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2355), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2353), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6460), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6462), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [113984] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7037), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
    ACTIONS(7039), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [114056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6526), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [114114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6526), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [114172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6511), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6513), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [114230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5010), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5006), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [114288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7130), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7132), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [114346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7254), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7256), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [114404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5858), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5860), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [114462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7192), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7194), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [114520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7200), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7202), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [114578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7078), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7080), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [114636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5858), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5860), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [114694] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    ACTIONS(8379), 1,
      anon_sym_LBRACE,
    STATE(4707), 1,
      sym_enumerator_list,
    STATE(4802), 1,
      sym_attribute_specifier,
    ACTIONS(3711), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3713), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [114760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5858), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5860), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [114818] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    ACTIONS(8379), 1,
      anon_sym_LBRACE,
    STATE(4686), 1,
      sym_enumerator_list,
    STATE(4785), 1,
      sym_attribute_specifier,
    ACTIONS(3715), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3717), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [114884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7266), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7268), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [114942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6431), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6433), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [115000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5418), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3834), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [115058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5961), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5963), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [115116] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    STATE(2816), 1,
      sym_template_argument_list,
    STATE(4755), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8493), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3483), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3485), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [115182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5933), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5935), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [115240] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8433), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8495), 1,
      anon_sym_STAR,
    ACTIONS(8497), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8499), 1,
      anon_sym_AMP,
    STATE(3763), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(5745), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7215), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8435), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8437), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4678), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5064), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(6763), 12,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [115334] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7041), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
    ACTIONS(7043), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [115406] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7007), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
    ACTIONS(7009), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [115478] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8433), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8495), 1,
      anon_sym_STAR,
    ACTIONS(8497), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8499), 1,
      anon_sym_AMP,
    STATE(3763), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(5745), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7223), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8435), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8437), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5069), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5287), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(6777), 12,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [115572] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym___attribute__,
    ACTIONS(6750), 1,
      anon_sym_LBRACE,
    ACTIONS(8501), 1,
      anon_sym_COLON,
    STATE(2922), 1,
      sym_attribute_specifier,
    STATE(3090), 1,
      sym__enum_base_clause,
    STATE(3149), 1,
      sym_enumerator_list,
    ACTIONS(3060), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(3062), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [115642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5953), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5955), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [115700] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7160), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [115758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7178), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7180), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [115816] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym___attribute__,
    ACTIONS(6750), 1,
      anon_sym_LBRACE,
    ACTIONS(8501), 1,
      anon_sym_COLON,
    STATE(2914), 1,
      sym_attribute_specifier,
    STATE(3064), 1,
      sym__enum_base_clause,
    STATE(3141), 1,
      sym_enumerator_list,
    ACTIONS(3348), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(3350), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [115886] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7250), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7252), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [115944] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    STATE(4803), 1,
      sym_attribute_specifier,
    ACTIONS(3719), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3721), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116005] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    STATE(4769), 1,
      sym_attribute_specifier,
    ACTIONS(3836), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3838), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7262), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7264), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7242), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7244), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7246), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7248), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7112), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7114), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116294] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    STATE(4798), 1,
      sym_attribute_specifier,
    ACTIONS(3791), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3793), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116355] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    STATE(4800), 1,
      sym_attribute_specifier,
    ACTIONS(3799), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3801), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116416] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6511), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6513), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [116473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7210), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7212), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7230), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7232), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7150), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7152), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7146), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7148), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116701] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    STATE(4786), 1,
      sym_attribute_specifier,
    ACTIONS(3795), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3797), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7192), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7194), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7204), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7206), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6526), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [116933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6431), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6433), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [116990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7102), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2128), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2117), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117104] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7138), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7140), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7200), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7202), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117218] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    STATE(4783), 1,
      sym_attribute_specifier,
    ACTIONS(3731), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3733), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7160), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117336] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8433), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8503), 1,
      anon_sym_STAR,
    ACTIONS(8505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8507), 1,
      anon_sym_AMP,
    STATE(3717), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(5745), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7247), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8435), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8437), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4729), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5135), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6763), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [117429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7222), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7224), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7250), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7252), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117543] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    STATE(4782), 1,
      sym_attribute_specifier,
    ACTIONS(3725), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3727), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117604] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    STATE(4806), 1,
      sym_attribute_specifier,
    ACTIONS(3746), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3748), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7126), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7128), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117722] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    STATE(4779), 1,
      sym_attribute_specifier,
    ACTIONS(3735), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3737), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7254), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7256), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7108), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7110), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7214), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7216), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7228), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7104), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7106), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118068] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    STATE(4781), 1,
      sym_attribute_specifier,
    ACTIONS(3742), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3744), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7116), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7118), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118186] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8509), 1,
      anon_sym_LT,
    STATE(4755), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4775), 1,
      sym_template_argument_list,
    ACTIONS(8493), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2115), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2123), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [118253] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4847), 1,
      sym_alignas_qualifier,
    ACTIONS(8518), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8515), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8513), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(8511), 19,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [118318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7178), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7180), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7092), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7094), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7088), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7090), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5010), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5006), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118546] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8433), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8503), 1,
      anon_sym_STAR,
    ACTIONS(8505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8507), 1,
      anon_sym_AMP,
    STATE(3717), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(5745), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7271), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8435), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8437), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5150), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5287), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6777), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [118639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6460), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6462), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [118696] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    STATE(4766), 1,
      sym_attribute_specifier,
    ACTIONS(3840), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3842), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7130), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7132), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7096), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7098), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118871] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    STATE(4810), 1,
      sym_attribute_specifier,
    ACTIONS(3830), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3832), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118932] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8521), 1,
      anon_sym_LT,
    STATE(4775), 1,
      sym_template_argument_list,
    ACTIONS(2169), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(2176), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [118994] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4617), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8524), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3810), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3812), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [119054] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 1,
      anon_sym_LBRACE,
    ACTIONS(8475), 1,
      anon_sym_LPAREN2,
    STATE(4687), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6859), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6861), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119116] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 1,
      anon_sym_LBRACE,
    ACTIONS(8475), 1,
      anon_sym_LPAREN2,
    STATE(4705), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6834), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6836), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119178] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3176), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3174), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119234] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 1,
      anon_sym_LBRACE,
    ACTIONS(8475), 1,
      anon_sym_LPAREN2,
    STATE(4695), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6883), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6885), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119296] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4617), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8524), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3803), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3805), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [119356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2824), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119412] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4746), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8526), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3392), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3390), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [119472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2491), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2489), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119528] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3204), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119584] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4617), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8524), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3750), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3752), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [119644] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8509), 1,
      anon_sym_LT,
    STATE(4775), 1,
      sym_template_argument_list,
    ACTIONS(2349), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(2347), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [119706] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 1,
      anon_sym_LBRACE,
    ACTIONS(8441), 1,
      anon_sym_LBRACK,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    STATE(4913), 1,
      sym_new_declarator,
    STATE(4708), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(8530), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(6564), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6566), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119774] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4736), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8532), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3764), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3766), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [119834] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 1,
      anon_sym_LBRACE,
    ACTIONS(8441), 1,
      anon_sym_LBRACK,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    STATE(4921), 1,
      sym_new_declarator,
    STATE(4689), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(8530), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(6586), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6588), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3392), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3390), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119958] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2742), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2740), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120016] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 1,
      anon_sym_LBRACE,
    ACTIONS(8441), 1,
      anon_sym_LBRACK,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    STATE(4953), 1,
      sym_new_declarator,
    STATE(4697), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(8530), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(6582), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6584), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120084] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 1,
      anon_sym_LBRACE,
    ACTIONS(8475), 1,
      anon_sym_LPAREN2,
    STATE(4696), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6820), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6822), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120146] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4617), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8524), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3757), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3759), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [120206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2536), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2534), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3404), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3402), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120318] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4741), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8534), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3771), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3773), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [120378] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 1,
      anon_sym_LBRACE,
    ACTIONS(8441), 1,
      anon_sym_LBRACK,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    STATE(4901), 1,
      sym_new_declarator,
    STATE(4727), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(8530), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(6578), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6580), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3054), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3052), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2740), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120556] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8536), 1,
      anon_sym_DOT,
    ACTIONS(8530), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3890), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(3892), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120615] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8446), 1,
      anon_sym_STAR,
    ACTIONS(8448), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8450), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(8540), 1,
      anon_sym_DOT,
    STATE(3489), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7079), 1,
      sym__abstract_declarator,
    STATE(7135), 1,
      sym__function_declarator_seq,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5001), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8542), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8538), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [120700] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8544), 1,
      anon_sym_DOT,
    ACTIONS(8477), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3890), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
    ACTIONS(3892), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3338), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3336), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2908), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2988), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2986), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3048), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3046), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120979] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2942), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [121034] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8544), 1,
      anon_sym_DOT,
    ACTIONS(8477), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3848), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
    ACTIONS(3850), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [121093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2740), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [121148] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(8553), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4772), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(8550), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8548), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8546), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [121211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3098), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3096), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [121266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3388), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3386), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [121321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2210), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(2217), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [121376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2363), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(2361), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [121431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2964), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2962), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [121486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3152), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3150), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [121541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3102), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3100), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [121596] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8446), 1,
      anon_sym_STAR,
    ACTIONS(8448), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8450), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(8540), 1,
      anon_sym_DOT,
    STATE(3489), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7077), 1,
      sym__abstract_declarator,
    STATE(7135), 1,
      sym__function_declarator_seq,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5006), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8542), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8556), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [121681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3190), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [121736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2948), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2946), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [121791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3070), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3068), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [121846] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8536), 1,
      anon_sym_DOT,
    ACTIONS(8530), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3848), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(3850), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [121905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3156), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3154), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [121960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3172), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3170), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [122015] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4746), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8526), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2742), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2740), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [122074] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8427), 1,
      anon_sym_STAR,
    ACTIONS(8429), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8431), 1,
      anon_sym_AMP,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8558), 1,
      anon_sym_DOT,
    STATE(3549), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7075), 1,
      sym__abstract_declarator,
    STATE(7138), 1,
      sym__function_declarator_seq,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4985), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8560), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8538), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [122159] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8433), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8562), 1,
      anon_sym_STAR,
    ACTIONS(8564), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8566), 1,
      anon_sym_AMP,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(5745), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7478), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8435), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8437), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4791), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5549), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6763), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [122250] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8481), 1,
      anon_sym___attribute__,
    ACTIONS(8568), 1,
      anon_sym_COLON,
    ACTIONS(8570), 1,
      anon_sym_LBRACE,
    STATE(4892), 1,
      sym__enum_base_clause,
    STATE(4907), 1,
      sym_enumerator_list,
    STATE(5107), 1,
      sym_attribute_specifier,
    ACTIONS(3348), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3350), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [122317] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8433), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8562), 1,
      anon_sym_STAR,
    ACTIONS(8564), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8566), 1,
      anon_sym_AMP,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(5745), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7477), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8435), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8437), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5287), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5561), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6777), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [122408] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2373), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(2371), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [122465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3338), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3336), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [122520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3056), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [122575] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8427), 1,
      anon_sym_STAR,
    ACTIONS(8429), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8431), 1,
      anon_sym_AMP,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8558), 1,
      anon_sym_DOT,
    STATE(3549), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7010), 1,
      sym__abstract_declarator,
    STATE(7138), 1,
      sym__function_declarator_seq,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4954), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8560), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8556), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [122660] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2373), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(2371), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [122717] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8454), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(8572), 1,
      anon_sym_STAR,
    ACTIONS(8574), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8576), 1,
      anon_sym_AMP,
    STATE(3498), 1,
      sym_parameter_list,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7587), 1,
      sym__abstract_declarator,
    ACTIONS(8456), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8458), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4811), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5555), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6763), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [122808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3082), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3080), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [122863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3202), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3200), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [122918] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3090), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3088), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [122973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3054), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3052), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [123028] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3358), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3356), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [123083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3384), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3382), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [123138] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(4903), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8578), 1,
      anon_sym_STAR,
    ACTIONS(8580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8582), 1,
      anon_sym_AMP,
    STATE(3994), 1,
      sym_parameter_list,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7553), 1,
      sym__abstract_declarator,
    ACTIONS(8586), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8588), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4823), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5505), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6777), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [123229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3338), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3336), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [123284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3362), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3360), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [123339] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3396), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3394), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [123394] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2996), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2994), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [123449] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8481), 1,
      anon_sym___attribute__,
    ACTIONS(8568), 1,
      anon_sym_COLON,
    ACTIONS(8570), 1,
      anon_sym_LBRACE,
    STATE(4888), 1,
      sym__enum_base_clause,
    STATE(4924), 1,
      sym_enumerator_list,
    STATE(5068), 1,
      sym_attribute_specifier,
    ACTIONS(3060), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3062), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [123516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3400), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3398), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [123571] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8454), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(8572), 1,
      anon_sym_STAR,
    ACTIONS(8574), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8576), 1,
      anon_sym_AMP,
    STATE(3498), 1,
      sym_parameter_list,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7546), 1,
      sym__abstract_declarator,
    ACTIONS(8456), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8458), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4772), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5473), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6777), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [123662] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2367), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(2365), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [123719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3366), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3364), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [123774] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(4903), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8578), 1,
      anon_sym_STAR,
    ACTIONS(8580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8582), 1,
      anon_sym_AMP,
    STATE(3994), 1,
      sym_parameter_list,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7538), 1,
      sym__abstract_declarator,
    ACTIONS(8586), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8588), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4804), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5474), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6763), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [123865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2998), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [123920] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 1,
      anon_sym_LBRACE,
    ACTIONS(8441), 1,
      anon_sym_LBRACK,
    ACTIONS(8475), 1,
      anon_sym_LPAREN2,
    STATE(4740), 1,
      sym_new_declarator,
    STATE(4689), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(8530), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(6586), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6588), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [123986] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 1,
      anon_sym_LBRACE,
    ACTIONS(8441), 1,
      anon_sym_LBRACK,
    ACTIONS(8475), 1,
      anon_sym_LPAREN2,
    STATE(4738), 1,
      sym_new_declarator,
    STATE(4697), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(8530), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(6582), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6584), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [124052] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(4903), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8592), 1,
      anon_sym_STAR,
    ACTIONS(8594), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8596), 1,
      anon_sym_AMP,
    STATE(4240), 1,
      sym_parameter_list,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7684), 1,
      sym__abstract_declarator,
    ACTIONS(8586), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8588), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4829), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5753), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6763), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [124142] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7790), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [124234] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6761), 1,
      sym_identifier,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7944), 1,
      anon_sym_STAR,
    ACTIONS(7946), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7948), 1,
      anon_sym_AMP,
    ACTIONS(7950), 1,
      anon_sym_COLON_COLON,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6954), 1,
      sym__scope_resolution,
    STATE(8138), 1,
      sym__declarator,
    STATE(10201), 1,
      sym_ms_based_modifier,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [124326] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2397), 1,
      anon_sym_STAR,
    ACTIONS(2399), 1,
      anon_sym_AMP,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6140), 1,
      sym_identifier,
    ACTIONS(7072), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6961), 1,
      sym__scope_resolution,
    STATE(7758), 1,
      sym__declarator,
    STATE(10814), 1,
      sym_ms_based_modifier,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [124418] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8598), 1,
      anon_sym_STAR,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_AMP,
    STATE(4356), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(6118), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7689), 1,
      sym__abstract_declarator,
    ACTIONS(8606), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8608), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4825), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5672), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6763), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(8604), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(6771), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8462), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [124506] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(8613), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4823), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(8610), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8548), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8546), 26,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [124568] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8616), 1,
      anon_sym_LT,
    STATE(2816), 1,
      sym_template_argument_list,
    ACTIONS(2176), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2169), 33,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [124628] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8598), 1,
      anon_sym_STAR,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_AMP,
    STATE(4356), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(6118), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7697), 1,
      sym__abstract_declarator,
    ACTIONS(8606), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8608), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5687), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6017), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(6777), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(8604), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(6779), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8462), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [124716] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8495), 1,
      anon_sym_STAR,
    ACTIONS(8497), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8499), 1,
      anon_sym_AMP,
    ACTIONS(8558), 1,
      anon_sym_DOT,
    STATE(3763), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7195), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5062), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8560), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8538), 12,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [124800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6138), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(6136), 33,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [124854] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 1,
      anon_sym_LBRACE,
    ACTIONS(8441), 1,
      anon_sym_LBRACK,
    ACTIONS(8475), 1,
      anon_sym_LPAREN2,
    STATE(4754), 1,
      sym_new_declarator,
    STATE(4708), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(8530), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(6564), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6566), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [124920] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(4903), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8592), 1,
      anon_sym_STAR,
    ACTIONS(8594), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8596), 1,
      anon_sym_AMP,
    STATE(4240), 1,
      sym_parameter_list,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7676), 1,
      sym__abstract_declarator,
    ACTIONS(8586), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8588), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4823), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5699), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6777), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [125010] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6761), 1,
      sym_identifier,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7944), 1,
      anon_sym_STAR,
    ACTIONS(7946), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7948), 1,
      anon_sym_AMP,
    ACTIONS(7950), 1,
      anon_sym_COLON_COLON,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6954), 1,
      sym__scope_resolution,
    STATE(8057), 1,
      sym__declarator,
    STATE(10201), 1,
      sym_ms_based_modifier,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [125102] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2373), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2371), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [125156] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6761), 1,
      sym_identifier,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7264), 1,
      sym__declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [125248] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6140), 1,
      sym_identifier,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(8088), 1,
      anon_sym_STAR,
    ACTIONS(8090), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8092), 1,
      anon_sym_AMP,
    ACTIONS(8094), 1,
      anon_sym_COLON_COLON,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6902), 1,
      sym__scope_resolution,
    STATE(8171), 1,
      sym__declarator,
    STATE(10164), 1,
      sym_ms_based_modifier,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [125340] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6761), 1,
      sym_identifier,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7944), 1,
      anon_sym_STAR,
    ACTIONS(7946), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7948), 1,
      anon_sym_AMP,
    ACTIONS(7950), 1,
      anon_sym_COLON_COLON,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6954), 1,
      sym__scope_resolution,
    STATE(8080), 1,
      sym__declarator,
    STATE(10201), 1,
      sym_ms_based_modifier,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [125432] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6761), 1,
      sym_identifier,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7255), 1,
      sym__declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [125524] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8616), 1,
      anon_sym_LT,
    STATE(2816), 1,
      sym_template_argument_list,
    ACTIONS(2347), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2349), 33,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [125584] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2397), 1,
      anon_sym_STAR,
    ACTIONS(2399), 1,
      anon_sym_AMP,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6140), 1,
      sym_identifier,
    ACTIONS(7072), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6961), 1,
      sym__scope_resolution,
    STATE(7902), 1,
      sym__declarator,
    STATE(10814), 1,
      sym_ms_based_modifier,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [125676] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2397), 1,
      anon_sym_STAR,
    ACTIONS(2399), 1,
      anon_sym_AMP,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6140), 1,
      sym_identifier,
    ACTIONS(7072), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6961), 1,
      sym__scope_resolution,
    STATE(7790), 1,
      sym__declarator,
    STATE(10814), 1,
      sym_ms_based_modifier,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [125768] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8433), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8618), 1,
      anon_sym_STAR,
    ACTIONS(8620), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8622), 1,
      anon_sym_AMP,
    STATE(3764), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(5745), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7672), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8435), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8437), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4840), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5632), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6763), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [125858] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8433), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8618), 1,
      anon_sym_STAR,
    ACTIONS(8620), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8622), 1,
      anon_sym_AMP,
    STATE(3764), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(5745), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7623), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8435), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8437), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5287), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5625), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6777), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [125948] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6761), 1,
      sym_identifier,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7317), 1,
      sym__declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [126040] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7758), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [126132] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 1,
      anon_sym_LBRACE,
    ACTIONS(8441), 1,
      anon_sym_LBRACK,
    ACTIONS(8475), 1,
      anon_sym_LPAREN2,
    STATE(4737), 1,
      sym_new_declarator,
    STATE(4727), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(8530), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(6578), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6580), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126198] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7902), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [126290] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8495), 1,
      anon_sym_STAR,
    ACTIONS(8497), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8499), 1,
      anon_sym_AMP,
    ACTIONS(8558), 1,
      anon_sym_DOT,
    STATE(3763), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7232), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5066), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8560), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8556), 12,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [126374] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6140), 1,
      sym_identifier,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(8088), 1,
      anon_sym_STAR,
    ACTIONS(8090), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8092), 1,
      anon_sym_AMP,
    ACTIONS(8094), 1,
      anon_sym_COLON_COLON,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6902), 1,
      sym__scope_resolution,
    STATE(8181), 1,
      sym__declarator,
    STATE(10164), 1,
      sym_ms_based_modifier,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [126466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6134), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(6132), 33,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [126520] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6140), 1,
      sym_identifier,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(8088), 1,
      anon_sym_STAR,
    ACTIONS(8090), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8092), 1,
      anon_sym_AMP,
    ACTIONS(8094), 1,
      anon_sym_COLON_COLON,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(6902), 1,
      sym__scope_resolution,
    STATE(8185), 1,
      sym__declarator,
    STATE(10164), 1,
      sym_ms_based_modifier,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [126612] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8433), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8624), 1,
      anon_sym_STAR,
    ACTIONS(8626), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8628), 1,
      anon_sym_AMP,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4569), 1,
      sym_parameter_list,
    STATE(5745), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7909), 1,
      sym__abstract_declarator,
    ACTIONS(8154), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8435), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8437), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4878), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5821), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6763), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8150), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [126701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7266), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7268), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126754] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8503), 1,
      anon_sym_STAR,
    ACTIONS(8505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8507), 1,
      anon_sym_AMP,
    ACTIONS(8630), 1,
      anon_sym_DOT,
    STATE(3717), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7272), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5136), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8560), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8538), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [126837] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8636), 1,
      anon_sym_SLASH,
    ACTIONS(8638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8644), 1,
      anon_sym_CARET,
    ACTIONS(8652), 1,
      anon_sym_GT_EQ,
    ACTIONS(8656), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8658), 1,
      anon_sym_or,
    ACTIONS(8660), 1,
      anon_sym_and,
    ACTIONS(8662), 1,
      anon_sym_xor,
    ACTIONS(8664), 1,
      anon_sym_not_eq,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7398), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8632), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8646), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8666), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8650), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7400), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [126940] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2351), 1,
      anon_sym_LT,
    STATE(212), 1,
      sym_template_argument_list,
    STATE(5121), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2115), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8668), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2123), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [127003] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8636), 1,
      anon_sym_SLASH,
    ACTIONS(8644), 1,
      anon_sym_CARET,
    ACTIONS(8652), 1,
      anon_sym_GT_EQ,
    ACTIONS(8656), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8662), 1,
      anon_sym_xor,
    ACTIONS(8664), 1,
      anon_sym_not_eq,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8632), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8646), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8666), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8650), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 4,
      aux_sym_preproc_elif_token1,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
    ACTIONS(7009), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
  [127098] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8503), 1,
      anon_sym_STAR,
    ACTIONS(8505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8507), 1,
      anon_sym_AMP,
    ACTIONS(8630), 1,
      anon_sym_DOT,
    STATE(3717), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7257), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5134), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8560), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8556), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [127181] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(4883), 1,
      anon_sym_LPAREN2,
    ACTIONS(6761), 1,
      sym_identifier,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6775), 1,
      anon_sym_LBRACK,
    ACTIONS(6905), 1,
      anon_sym_STAR,
    ACTIONS(8670), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8674), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_AMP,
    ACTIONS(8678), 1,
      anon_sym_COLON,
    ACTIONS(8680), 1,
      anon_sym_EQ,
    STATE(4541), 1,
      sym_parameter_list,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7592), 1,
      sym__declarator,
    STATE(8146), 1,
      sym__abstract_declarator,
    STATE(8410), 1,
      sym_abstract_reference_declarator,
    STATE(9175), 1,
      sym_variadic_declarator,
    STATE(9217), 1,
      sym_variadic_reference_declarator,
    STATE(9223), 1,
      sym_semantics,
    STATE(10435), 1,
      sym_ms_based_modifier,
    ACTIONS(8672), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [127288] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    STATE(2816), 1,
      sym_template_argument_list,
    STATE(5032), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3483), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6179), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3485), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [127351] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    STATE(4847), 1,
      sym_alignas_qualifier,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8684), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    STATE(5195), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5441), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6642), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8682), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [127418] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8454), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(8686), 1,
      anon_sym_STAR,
    ACTIONS(8688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8690), 1,
      anon_sym_AMP,
    STATE(4485), 1,
      sym_parameter_list,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7873), 1,
      sym__abstract_declarator,
    ACTIONS(8456), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8458), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4772), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5766), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6777), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [127507] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8454), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(8686), 1,
      anon_sym_STAR,
    ACTIONS(8688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8690), 1,
      anon_sym_AMP,
    STATE(4485), 1,
      sym_parameter_list,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7877), 1,
      sym__abstract_declarator,
    ACTIONS(8456), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8458), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4859), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5775), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6763), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [127596] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8636), 1,
      anon_sym_SLASH,
    ACTIONS(8638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8644), 1,
      anon_sym_CARET,
    ACTIONS(8652), 1,
      anon_sym_GT_EQ,
    ACTIONS(8656), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8658), 1,
      anon_sym_or,
    ACTIONS(8660), 1,
      anon_sym_and,
    ACTIONS(8662), 1,
      anon_sym_xor,
    ACTIONS(8664), 1,
      anon_sym_not_eq,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7406), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8632), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8646), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8666), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8650), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7408), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [127699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7172), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [127752] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8454), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(8692), 1,
      anon_sym_STAR,
    ACTIONS(8694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8696), 1,
      anon_sym_AMP,
    STATE(4454), 1,
      sym_parameter_list,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7768), 1,
      sym__abstract_declarator,
    ACTIONS(8456), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8458), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4772), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5764), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6777), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [127841] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8454), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(8692), 1,
      anon_sym_STAR,
    ACTIONS(8694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8696), 1,
      anon_sym_AMP,
    STATE(4454), 1,
      sym_parameter_list,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7779), 1,
      sym__abstract_declarator,
    ACTIONS(8456), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8458), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4863), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5773), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6763), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [127930] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym_LBRACE,
    ACTIONS(8698), 1,
      anon_sym_LPAREN2,
    ACTIONS(8700), 1,
      anon_sym_LBRACK,
    STATE(5263), 1,
      sym_new_declarator,
    STATE(5712), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(8702), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(6564), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6566), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [127995] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8636), 1,
      anon_sym_SLASH,
    ACTIONS(8638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8644), 1,
      anon_sym_CARET,
    ACTIONS(8652), 1,
      anon_sym_GT_EQ,
    ACTIONS(8656), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8658), 1,
      anon_sym_or,
    ACTIONS(8660), 1,
      anon_sym_and,
    ACTIONS(8662), 1,
      anon_sym_xor,
    ACTIONS(8664), 1,
      anon_sym_not_eq,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8710), 1,
      anon_sym_QMARK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8632), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8646), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8666), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8704), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8650), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8708), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [128102] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8433), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8712), 1,
      anon_sym_STAR,
    ACTIONS(8714), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8716), 1,
      anon_sym_AMP,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(5745), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7737), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8435), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8437), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4868), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5844), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6763), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [128191] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8433), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8712), 1,
      anon_sym_STAR,
    ACTIONS(8714), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8716), 1,
      anon_sym_AMP,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(5745), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7726), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8435), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8437), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5287), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5841), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6777), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [128280] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(4883), 1,
      anon_sym_LPAREN2,
    ACTIONS(6761), 1,
      sym_identifier,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6775), 1,
      anon_sym_LBRACK,
    ACTIONS(6914), 1,
      anon_sym_STAR,
    ACTIONS(8670), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8674), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_AMP,
    ACTIONS(8678), 1,
      anon_sym_COLON,
    ACTIONS(8718), 1,
      anon_sym_EQ,
    STATE(4478), 1,
      sym_parameter_list,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7596), 1,
      sym__declarator,
    STATE(8227), 1,
      sym__abstract_declarator,
    STATE(8498), 1,
      sym_abstract_reference_declarator,
    STATE(9175), 1,
      sym_variadic_declarator,
    STATE(9217), 1,
      sym_variadic_reference_declarator,
    STATE(9223), 1,
      sym_semantics,
    STATE(10435), 1,
      sym_ms_based_modifier,
    ACTIONS(8672), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [128387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7258), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7260), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [128440] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    STATE(2816), 1,
      sym_template_argument_list,
    STATE(5121), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3483), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8668), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3485), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [128503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7174), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7176), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [128556] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym_LBRACE,
    ACTIONS(8698), 1,
      anon_sym_LPAREN2,
    ACTIONS(8700), 1,
      anon_sym_LBRACK,
    STATE(5240), 1,
      sym_new_declarator,
    STATE(5624), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(8702), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(6586), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6588), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [128621] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8636), 1,
      anon_sym_SLASH,
    ACTIONS(8638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8644), 1,
      anon_sym_CARET,
    ACTIONS(8652), 1,
      anon_sym_GT_EQ,
    ACTIONS(8656), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8658), 1,
      anon_sym_or,
    ACTIONS(8660), 1,
      anon_sym_and,
    ACTIONS(8662), 1,
      anon_sym_xor,
    ACTIONS(8664), 1,
      anon_sym_not_eq,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8710), 1,
      anon_sym_QMARK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7414), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8632), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8646), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8666), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8650), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7416), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [128728] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8636), 1,
      anon_sym_SLASH,
    ACTIONS(8638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8644), 1,
      anon_sym_CARET,
    ACTIONS(8652), 1,
      anon_sym_GT_EQ,
    ACTIONS(8656), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8658), 1,
      anon_sym_or,
    ACTIONS(8660), 1,
      anon_sym_and,
    ACTIONS(8662), 1,
      anon_sym_xor,
    ACTIONS(8664), 1,
      anon_sym_not_eq,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7422), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8632), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8646), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8666), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8650), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7424), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [128831] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8636), 1,
      anon_sym_SLASH,
    ACTIONS(8638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8644), 1,
      anon_sym_CARET,
    ACTIONS(8652), 1,
      anon_sym_GT_EQ,
    ACTIONS(8656), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8658), 1,
      anon_sym_or,
    ACTIONS(8660), 1,
      anon_sym_and,
    ACTIONS(8662), 1,
      anon_sym_xor,
    ACTIONS(8664), 1,
      anon_sym_not_eq,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8710), 1,
      anon_sym_QMARK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7178), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8632), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8646), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8666), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8650), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7180), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [128938] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8636), 1,
      anon_sym_SLASH,
    ACTIONS(8638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8644), 1,
      anon_sym_CARET,
    ACTIONS(8652), 1,
      anon_sym_GT_EQ,
    ACTIONS(8656), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8658), 1,
      anon_sym_or,
    ACTIONS(8660), 1,
      anon_sym_and,
    ACTIONS(8662), 1,
      anon_sym_xor,
    ACTIONS(8664), 1,
      anon_sym_not_eq,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8710), 1,
      anon_sym_QMARK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7410), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8632), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8646), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8666), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8650), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7412), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [129045] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8433), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8624), 1,
      anon_sym_STAR,
    ACTIONS(8626), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8628), 1,
      anon_sym_AMP,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4569), 1,
      sym_parameter_list,
    STATE(5745), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7916), 1,
      sym__abstract_declarator,
    ACTIONS(8154), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8435), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8437), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5287), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5796), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6777), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8150), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [129134] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym_LBRACE,
    ACTIONS(8698), 1,
      anon_sym_LPAREN2,
    ACTIONS(8700), 1,
      anon_sym_LBRACK,
    STATE(5295), 1,
      sym_new_declarator,
    STATE(5651), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(8702), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(6578), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6580), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [129199] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8636), 1,
      anon_sym_SLASH,
    ACTIONS(8644), 1,
      anon_sym_CARET,
    ACTIONS(8652), 1,
      anon_sym_GT_EQ,
    ACTIONS(8656), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8662), 1,
      anon_sym_xor,
    ACTIONS(8664), 1,
      anon_sym_not_eq,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8632), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8646), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8666), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8650), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      sym_identifier,
    ACTIONS(7009), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
  [129292] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8636), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_GT_EQ,
    ACTIONS(8656), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8664), 1,
      anon_sym_not_eq,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8632), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8646), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8666), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8650), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 7,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      sym_identifier,
    ACTIONS(7009), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
  [129381] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8636), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_GT_EQ,
    ACTIONS(8656), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8664), 1,
      anon_sym_not_eq,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8632), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8666), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8650), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 9,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      sym_identifier,
    ACTIONS(7009), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
  [129468] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8636), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_GT_EQ,
    ACTIONS(8656), 1,
      anon_sym_LT_EQ_GT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8632), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8666), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8650), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 10,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(7009), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
  [129551] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8636), 1,
      anon_sym_SLASH,
    ACTIONS(8656), 1,
      anon_sym_LT_EQ_GT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8632), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8666), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7007), 13,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(7009), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
  [129630] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8636), 1,
      anon_sym_SLASH,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8632), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7007), 15,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
    ACTIONS(7009), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [129703] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8636), 1,
      anon_sym_SLASH,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8632), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7009), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
    ACTIONS(7007), 15,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
  [129778] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym_LBRACE,
    ACTIONS(8698), 1,
      anon_sym_LPAREN2,
    ACTIONS(8700), 1,
      anon_sym_LBRACK,
    STATE(5286), 1,
      sym_new_declarator,
    STATE(5636), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(8702), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(6582), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6584), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [129843] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8481), 1,
      anon_sym___attribute__,
    ACTIONS(8570), 1,
      anon_sym_LBRACE,
    STATE(4900), 1,
      sym_enumerator_list,
    STATE(5117), 1,
      sym_attribute_specifier,
    ACTIONS(3711), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3713), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [129904] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8636), 1,
      anon_sym_SLASH,
    ACTIONS(8638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8644), 1,
      anon_sym_CARET,
    ACTIONS(8652), 1,
      anon_sym_GT_EQ,
    ACTIONS(8656), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8658), 1,
      anon_sym_or,
    ACTIONS(8660), 1,
      anon_sym_and,
    ACTIONS(8662), 1,
      anon_sym_xor,
    ACTIONS(8664), 1,
      anon_sym_not_eq,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7358), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8632), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8646), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8666), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8650), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7360), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [130007] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8636), 1,
      anon_sym_SLASH,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7009), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
    ACTIONS(7007), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
  [130078] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8636), 1,
      anon_sym_SLASH,
    ACTIONS(8640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8644), 1,
      anon_sym_CARET,
    ACTIONS(8652), 1,
      anon_sym_GT_EQ,
    ACTIONS(8656), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8660), 1,
      anon_sym_and,
    ACTIONS(8662), 1,
      anon_sym_xor,
    ACTIONS(8664), 1,
      anon_sym_not_eq,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8632), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8646), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8666), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7007), 3,
      aux_sym_preproc_elif_token1,
      anon_sym_or,
      sym_identifier,
    ACTIONS(8650), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
  [130177] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8481), 1,
      anon_sym___attribute__,
    ACTIONS(8570), 1,
      anon_sym_LBRACE,
    STATE(4894), 1,
      sym_enumerator_list,
    STATE(5013), 1,
      sym_attribute_specifier,
    ACTIONS(3715), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3717), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [130238] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8724), 1,
      anon_sym_STAR,
    ACTIONS(8726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8728), 1,
      anon_sym_AMP,
    ACTIONS(8736), 1,
      sym_primitive_type,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8350), 1,
      sym__type_declarator,
    STATE(10519), 1,
      sym_ms_based_modifier,
    ACTIONS(8730), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4922), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5911), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8454), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [130326] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8481), 1,
      anon_sym___attribute__,
    STATE(5038), 1,
      sym_attribute_specifier,
    ACTIONS(3836), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3838), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [130382] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8481), 1,
      anon_sym___attribute__,
    STATE(5018), 1,
      sym_attribute_specifier,
    ACTIONS(3725), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3727), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [130438] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8738), 1,
      sym_identifier,
    ACTIONS(8740), 1,
      anon_sym_LPAREN2,
    ACTIONS(8742), 1,
      anon_sym_STAR,
    ACTIONS(8744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8746), 1,
      anon_sym_AMP,
    ACTIONS(8750), 1,
      sym_primitive_type,
    STATE(3633), 1,
      sym__type_declarator,
    STATE(4278), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(10635), 1,
      sym_ms_based_modifier,
    ACTIONS(8730), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4909), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5938), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8454), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8748), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4276), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [130526] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8752), 1,
      anon_sym_STAR,
    ACTIONS(8754), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8756), 1,
      anon_sym_AMP,
    STATE(3085), 1,
      sym__type_declarator,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(10183), 1,
      sym_ms_based_modifier,
    ACTIONS(8730), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4935), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5892), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8454), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [130614] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7641), 1,
      sym__type_declarator,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8730), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4772), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5940), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8454), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [130702] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7680), 1,
      sym__type_declarator,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8730), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4898), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5953), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8454), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [130790] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8481), 1,
      anon_sym___attribute__,
    STATE(5016), 1,
      sym_attribute_specifier,
    ACTIONS(3731), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3733), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [130846] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 1,
      anon_sym_LBRACE,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    STATE(4687), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6859), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6861), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [130904] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      sym_literal_suffix,
    ACTIONS(6594), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6596), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [130958] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8764), 1,
      sym_identifier,
    ACTIONS(8768), 1,
      sym_primitive_type,
    STATE(4914), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3822), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3820), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [131018] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7641), 1,
      sym__type_declarator,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8730), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4926), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5940), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8454), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [131106] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      sym_literal_suffix,
    ACTIONS(2128), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2117), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [131160] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8738), 1,
      sym_identifier,
    ACTIONS(8740), 1,
      anon_sym_LPAREN2,
    ACTIONS(8742), 1,
      anon_sym_STAR,
    ACTIONS(8744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8746), 1,
      anon_sym_AMP,
    ACTIONS(8750), 1,
      sym_primitive_type,
    STATE(3626), 1,
      sym__type_declarator,
    STATE(4278), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(10635), 1,
      sym_ms_based_modifier,
    ACTIONS(8730), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4918), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6007), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8454), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8748), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4276), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [131248] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8481), 1,
      anon_sym___attribute__,
    STATE(5049), 1,
      sym_attribute_specifier,
    ACTIONS(3795), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3797), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [131304] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4908), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8770), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2854), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_GT2,
    ACTIONS(2856), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [131360] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8738), 1,
      sym_identifier,
    ACTIONS(8740), 1,
      anon_sym_LPAREN2,
    ACTIONS(8742), 1,
      anon_sym_STAR,
    ACTIONS(8744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8746), 1,
      anon_sym_AMP,
    ACTIONS(8750), 1,
      sym_primitive_type,
    STATE(3626), 1,
      sym__type_declarator,
    STATE(4278), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(10635), 1,
      sym_ms_based_modifier,
    ACTIONS(8730), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4772), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6007), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8454), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8748), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4276), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [131448] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8773), 1,
      sym_identifier,
    ACTIONS(8775), 1,
      anon_sym_LPAREN2,
    ACTIONS(8777), 1,
      anon_sym_STAR,
    ACTIONS(8779), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8781), 1,
      anon_sym_AMP,
    ACTIONS(8785), 1,
      sym_primitive_type,
    STATE(3585), 1,
      sym__type_declarator,
    STATE(3956), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(10354), 1,
      sym_ms_based_modifier,
    ACTIONS(8730), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4772), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5903), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8454), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8783), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3959), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [131536] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8773), 1,
      sym_identifier,
    ACTIONS(8775), 1,
      anon_sym_LPAREN2,
    ACTIONS(8777), 1,
      anon_sym_STAR,
    ACTIONS(8779), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8781), 1,
      anon_sym_AMP,
    ACTIONS(8785), 1,
      sym_primitive_type,
    STATE(3585), 1,
      sym__type_declarator,
    STATE(3956), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(10354), 1,
      sym_ms_based_modifier,
    ACTIONS(8730), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4950), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5903), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8454), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8783), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3959), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [131624] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4912), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8787), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2854), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2856), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [131680] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 1,
      anon_sym_LBRACE,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    STATE(4696), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6820), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6822), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [131738] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4912), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2856), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(8787), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3781), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3778), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [131796] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8773), 1,
      sym_identifier,
    ACTIONS(8775), 1,
      anon_sym_LPAREN2,
    ACTIONS(8777), 1,
      anon_sym_STAR,
    ACTIONS(8779), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8781), 1,
      anon_sym_AMP,
    ACTIONS(8785), 1,
      sym_primitive_type,
    STATE(3547), 1,
      sym__type_declarator,
    STATE(3956), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(10354), 1,
      sym_ms_based_modifier,
    ACTIONS(8730), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4910), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5879), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8454), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8783), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3959), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [131884] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8790), 1,
      anon_sym_LT,
    STATE(5032), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5082), 1,
      sym_template_argument_list,
    ACTIONS(2115), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6179), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2123), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [131946] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4908), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2856), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(8770), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3781), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_GT2,
    ACTIONS(3778), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [132004] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8738), 1,
      sym_identifier,
    ACTIONS(8740), 1,
      anon_sym_LPAREN2,
    ACTIONS(8742), 1,
      anon_sym_STAR,
    ACTIONS(8744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8746), 1,
      anon_sym_AMP,
    ACTIONS(8750), 1,
      sym_primitive_type,
    STATE(3652), 1,
      sym__type_declarator,
    STATE(4278), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(10635), 1,
      sym_ms_based_modifier,
    ACTIONS(8730), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4772), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5986), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8454), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8748), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4276), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [132092] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8481), 1,
      anon_sym___attribute__,
    STATE(5099), 1,
      sym_attribute_specifier,
    ACTIONS(3791), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3793), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [132148] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8481), 1,
      anon_sym___attribute__,
    STATE(5025), 1,
      sym_attribute_specifier,
    ACTIONS(3799), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3801), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [132204] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 1,
      anon_sym_LBRACE,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    STATE(4695), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6883), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6885), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [132262] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8724), 1,
      anon_sym_STAR,
    ACTIONS(8726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8728), 1,
      anon_sym_AMP,
    ACTIONS(8736), 1,
      sym_primitive_type,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8250), 1,
      sym__type_declarator,
    STATE(10519), 1,
      sym_ms_based_modifier,
    ACTIONS(8730), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4772), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5900), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8454), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [132350] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8792), 1,
      sym_identifier,
    ACTIONS(8796), 1,
      sym_primitive_type,
    STATE(4917), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8794), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3822), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_GT2,
    ACTIONS(3820), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [132410] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8481), 1,
      anon_sym___attribute__,
    STATE(5115), 1,
      sym_attribute_specifier,
    ACTIONS(3719), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3721), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [132466] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8798), 1,
      sym_identifier,
    ACTIONS(8800), 1,
      anon_sym_LPAREN2,
    ACTIONS(8802), 1,
      anon_sym_STAR,
    ACTIONS(8804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8806), 1,
      anon_sym_AMP,
    ACTIONS(8810), 1,
      sym_primitive_type,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7436), 1,
      sym__type_declarator,
    STATE(7833), 1,
      sym_pointer_type_declarator,
    STATE(10326), 1,
      sym_ms_based_modifier,
    ACTIONS(8730), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4772), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5962), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8454), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8808), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7859), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [132554] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7634), 1,
      sym__type_declarator,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8730), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4772), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5931), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8454), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [132642] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8798), 1,
      sym_identifier,
    ACTIONS(8800), 1,
      anon_sym_LPAREN2,
    ACTIONS(8810), 1,
      sym_primitive_type,
    ACTIONS(8812), 1,
      anon_sym_STAR,
    ACTIONS(8814), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8816), 1,
      anon_sym_AMP,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7833), 1,
      sym_pointer_type_declarator,
    STATE(8150), 1,
      sym__type_declarator,
    STATE(10312), 1,
      sym_ms_based_modifier,
    ACTIONS(8730), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4940), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5913), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8454), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8808), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7859), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [132730] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8752), 1,
      anon_sym_STAR,
    ACTIONS(8754), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8756), 1,
      anon_sym_AMP,
    STATE(3092), 1,
      sym__type_declarator,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(10183), 1,
      sym_ms_based_modifier,
    ACTIONS(8730), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4772), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5894), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8454), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [132818] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8798), 1,
      sym_identifier,
    ACTIONS(8800), 1,
      anon_sym_LPAREN2,
    ACTIONS(8802), 1,
      anon_sym_STAR,
    ACTIONS(8804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8806), 1,
      anon_sym_AMP,
    ACTIONS(8810), 1,
      sym_primitive_type,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7377), 1,
      sym__type_declarator,
    STATE(7833), 1,
      sym_pointer_type_declarator,
    STATE(10326), 1,
      sym_ms_based_modifier,
    ACTIONS(8730), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4943), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5967), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8454), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8808), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7859), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [132906] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8724), 1,
      anon_sym_STAR,
    ACTIONS(8726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8728), 1,
      anon_sym_AMP,
    ACTIONS(8736), 1,
      sym_primitive_type,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8350), 1,
      sym__type_declarator,
    STATE(10519), 1,
      sym_ms_based_modifier,
    ACTIONS(8730), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4772), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5911), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8454), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [132994] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8481), 1,
      anon_sym___attribute__,
    STATE(5098), 1,
      sym_attribute_specifier,
    ACTIONS(3830), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3832), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [133050] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8724), 1,
      anon_sym_STAR,
    ACTIONS(8726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8728), 1,
      anon_sym_AMP,
    ACTIONS(8736), 1,
      sym_primitive_type,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8256), 1,
      sym__type_declarator,
    STATE(10519), 1,
      sym_ms_based_modifier,
    ACTIONS(8730), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4930), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5987), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8454), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [133138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8820), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8818), 32,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [133190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7426), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(7428), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [133242] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8752), 1,
      anon_sym_STAR,
    ACTIONS(8754), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8756), 1,
      anon_sym_AMP,
    STATE(3089), 1,
      sym__type_declarator,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(10183), 1,
      sym_ms_based_modifier,
    ACTIONS(8730), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4772), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5887), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8454), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [133330] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8752), 1,
      anon_sym_STAR,
    ACTIONS(8754), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8756), 1,
      anon_sym_AMP,
    STATE(3089), 1,
      sym__type_declarator,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(10183), 1,
      sym_ms_based_modifier,
    ACTIONS(8730), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4928), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5887), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8454), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [133418] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(6763), 1,
      anon_sym_COMMA,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8822), 1,
      anon_sym_STAR,
    ACTIONS(8824), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8826), 1,
      anon_sym_AMP,
    STATE(4577), 1,
      sym_parameter_list,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8003), 1,
      sym__abstract_declarator,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4951), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5981), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(6771), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [133504] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(4903), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8828), 1,
      anon_sym_STAR,
    ACTIONS(8830), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8832), 1,
      anon_sym_AMP,
    STATE(4574), 1,
      sym_parameter_list,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8027), 1,
      sym__abstract_declarator,
    ACTIONS(8586), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8588), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4823), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5990), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6777), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [133592] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8798), 1,
      sym_identifier,
    ACTIONS(8800), 1,
      anon_sym_LPAREN2,
    ACTIONS(8810), 1,
      sym_primitive_type,
    ACTIONS(8812), 1,
      anon_sym_STAR,
    ACTIONS(8814), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8816), 1,
      anon_sym_AMP,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7833), 1,
      sym_pointer_type_declarator,
    STATE(8190), 1,
      sym__type_declarator,
    STATE(10312), 1,
      sym_ms_based_modifier,
    ACTIONS(8730), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4772), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5901), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8454), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8808), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7859), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [133680] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8798), 1,
      sym_identifier,
    ACTIONS(8800), 1,
      anon_sym_LPAREN2,
    ACTIONS(8810), 1,
      sym_primitive_type,
    ACTIONS(8812), 1,
      anon_sym_STAR,
    ACTIONS(8814), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8816), 1,
      anon_sym_AMP,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7833), 1,
      sym_pointer_type_declarator,
    STATE(8170), 1,
      sym__type_declarator,
    STATE(10312), 1,
      sym_ms_based_modifier,
    ACTIONS(8730), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4772), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5905), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8454), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8808), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7859), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [133768] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(4883), 1,
      anon_sym_LPAREN2,
    ACTIONS(6761), 1,
      sym_identifier,
    ACTIONS(6765), 1,
      anon_sym_STAR,
    ACTIONS(6767), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6769), 1,
      anon_sym_AMP,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6775), 1,
      anon_sym_LBRACK,
    ACTIONS(8670), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8836), 1,
      anon_sym_COLON,
    STATE(3498), 1,
      sym_parameter_list,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7286), 1,
      sym__declarator,
    STATE(7469), 1,
      sym__abstract_declarator,
    STATE(9190), 1,
      sym_variadic_declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8834), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [133866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8840), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8838), 32,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [133918] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8798), 1,
      sym_identifier,
    ACTIONS(8800), 1,
      anon_sym_LPAREN2,
    ACTIONS(8802), 1,
      anon_sym_STAR,
    ACTIONS(8804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8806), 1,
      anon_sym_AMP,
    ACTIONS(8810), 1,
      sym_primitive_type,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7454), 1,
      sym__type_declarator,
    STATE(7833), 1,
      sym_pointer_type_declarator,
    STATE(10326), 1,
      sym_ms_based_modifier,
    ACTIONS(8730), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4772), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5915), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8454), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8808), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7859), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [134006] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8798), 1,
      sym_identifier,
    ACTIONS(8800), 1,
      anon_sym_LPAREN2,
    ACTIONS(8802), 1,
      anon_sym_STAR,
    ACTIONS(8804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8806), 1,
      anon_sym_AMP,
    ACTIONS(8810), 1,
      sym_primitive_type,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7454), 1,
      sym__type_declarator,
    STATE(7833), 1,
      sym_pointer_type_declarator,
    STATE(10326), 1,
      sym_ms_based_modifier,
    ACTIONS(8730), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4925), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5915), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8454), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8808), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7859), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [134094] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(4903), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8828), 1,
      anon_sym_STAR,
    ACTIONS(8830), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8832), 1,
      anon_sym_AMP,
    STATE(4574), 1,
      sym_parameter_list,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7996), 1,
      sym__abstract_declarator,
    ACTIONS(8586), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8588), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4938), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6001), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6763), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [134182] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8481), 1,
      anon_sym___attribute__,
    STATE(5040), 1,
      sym_attribute_specifier,
    ACTIONS(3840), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3842), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [134238] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8481), 1,
      anon_sym___attribute__,
    STATE(5076), 1,
      sym_attribute_specifier,
    ACTIONS(3746), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3748), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [134294] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8481), 1,
      anon_sym___attribute__,
    STATE(5020), 1,
      sym_attribute_specifier,
    ACTIONS(3735), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3737), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [134350] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8481), 1,
      anon_sym___attribute__,
    STATE(5051), 1,
      sym_attribute_specifier,
    ACTIONS(3742), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3744), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [134406] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8773), 1,
      sym_identifier,
    ACTIONS(8775), 1,
      anon_sym_LPAREN2,
    ACTIONS(8777), 1,
      anon_sym_STAR,
    ACTIONS(8779), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8781), 1,
      anon_sym_AMP,
    ACTIONS(8785), 1,
      sym_primitive_type,
    STATE(3529), 1,
      sym__type_declarator,
    STATE(3956), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(10354), 1,
      sym_ms_based_modifier,
    ACTIONS(8730), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4772), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5932), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8454), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8783), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3959), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [134494] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(6777), 1,
      anon_sym_COMMA,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8822), 1,
      anon_sym_STAR,
    ACTIONS(8824), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8826), 1,
      anon_sym_AMP,
    STATE(4577), 1,
      sym_parameter_list,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8015), 1,
      sym__abstract_declarator,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4823), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5964), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(6779), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [134580] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8798), 1,
      sym_identifier,
    ACTIONS(8800), 1,
      anon_sym_LPAREN2,
    ACTIONS(8810), 1,
      sym_primitive_type,
    ACTIONS(8812), 1,
      anon_sym_STAR,
    ACTIONS(8814), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8816), 1,
      anon_sym_AMP,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7833), 1,
      sym_pointer_type_declarator,
    STATE(8170), 1,
      sym__type_declarator,
    STATE(10312), 1,
      sym_ms_based_modifier,
    ACTIONS(8730), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4939), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5905), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8454), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8808), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7859), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [134668] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 1,
      anon_sym_LBRACE,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    STATE(4705), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6834), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6836), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [134726] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8427), 1,
      anon_sym_STAR,
    ACTIONS(8429), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8431), 1,
      anon_sym_AMP,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    STATE(3549), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7032), 1,
      sym__abstract_declarator,
    STATE(7138), 1,
      sym__function_declarator_seq,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8842), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [134803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5896), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5898), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [134854] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8558), 1,
      anon_sym_DOT,
    ACTIONS(8562), 1,
      anon_sym_STAR,
    ACTIONS(8564), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8566), 1,
      anon_sym_AMP,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7474), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5554), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8560), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8556), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [134935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8840), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8838), 31,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [134986] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8844), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8846), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6192), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6194), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [135041] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(8854), 1,
      anon_sym_SLASH,
    ACTIONS(8860), 1,
      anon_sym_PIPE,
    ACTIONS(8864), 1,
      anon_sym_AMP,
    ACTIONS(8870), 1,
      anon_sym_GT_EQ,
    ACTIONS(8874), 1,
      anon_sym_SEMI,
    ACTIONS(8876), 1,
      anon_sym_QMARK,
    ACTIONS(8880), 1,
      anon_sym_bitor,
    ACTIONS(8882), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(8568), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10361), 1,
      sym_attribute_specifier,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8850), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8852), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8856), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8858), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8862), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8872), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8866), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8868), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8878), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [135146] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(8540), 1,
      anon_sym_DOT,
    ACTIONS(8572), 1,
      anon_sym_STAR,
    ACTIONS(8574), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8576), 1,
      anon_sym_AMP,
    STATE(3498), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7528), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5593), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8542), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8538), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [135227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3392), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3390), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [135278] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2742), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2740), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [135331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8820), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8818), 31,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [135382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7426), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7428), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [135433] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8884), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8886), 1,
      anon_sym_and,
    ACTIONS(6204), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6206), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [135488] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5925), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5927), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [135539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5858), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5860), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [135590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5858), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5860), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [135641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5858), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5860), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [135692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6044), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6046), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [135743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5937), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5939), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [135794] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(4903), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8888), 1,
      anon_sym_STAR,
    ACTIONS(8890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8892), 1,
      anon_sym_AMP,
    STATE(4083), 1,
      sym_parameter_list,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8037), 1,
      sym__abstract_declarator,
    ACTIONS(8586), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8588), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5000), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6018), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6763), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [135881] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8884), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8886), 1,
      anon_sym_and,
    ACTIONS(8894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8896), 1,
      anon_sym_or,
    ACTIONS(6192), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6194), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [135940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3404), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3402), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [135991] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      sym_literal_suffix,
    ACTIONS(6594), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
    ACTIONS(6596), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [136044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6056), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6058), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [136095] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(8540), 1,
      anon_sym_DOT,
    ACTIONS(8572), 1,
      anon_sym_STAR,
    ACTIONS(8574), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8576), 1,
      anon_sym_AMP,
    STATE(3498), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7552), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5498), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8542), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8556), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [136176] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6062), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [136227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3204), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [136278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5961), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5963), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [136329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5933), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5935), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [136380] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8558), 1,
      anon_sym_DOT,
    ACTIONS(8562), 1,
      anon_sym_STAR,
    ACTIONS(8564), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8566), 1,
      anon_sym_AMP,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7487), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5548), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8560), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8538), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [136461] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8578), 1,
      anon_sym_STAR,
    ACTIONS(8580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8582), 1,
      anon_sym_AMP,
    ACTIONS(8898), 1,
      anon_sym_DOT,
    STATE(3994), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7550), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5500), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8542), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8556), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [136542] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(8854), 1,
      anon_sym_SLASH,
    ACTIONS(8860), 1,
      anon_sym_PIPE,
    ACTIONS(8864), 1,
      anon_sym_AMP,
    ACTIONS(8870), 1,
      anon_sym_GT_EQ,
    ACTIONS(8876), 1,
      anon_sym_QMARK,
    ACTIONS(8880), 1,
      anon_sym_bitor,
    ACTIONS(8882), 1,
      anon_sym_bitand,
    ACTIONS(8900), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(8575), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10478), 1,
      sym_attribute_specifier,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8850), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8852), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8856), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8858), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8862), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8872), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8866), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8868), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8878), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [136647] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8427), 1,
      anon_sym_STAR,
    ACTIONS(8429), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8431), 1,
      anon_sym_AMP,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    STATE(3549), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7008), 1,
      sym__abstract_declarator,
    STATE(7138), 1,
      sym__function_declarator_seq,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8902), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [136724] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8846), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6204), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6206), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [136777] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8578), 1,
      anon_sym_STAR,
    ACTIONS(8580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8582), 1,
      anon_sym_AMP,
    ACTIONS(8898), 1,
      anon_sym_DOT,
    STATE(3994), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7524), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5488), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8542), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8538), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [136858] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(8854), 1,
      anon_sym_SLASH,
    ACTIONS(8860), 1,
      anon_sym_PIPE,
    ACTIONS(8864), 1,
      anon_sym_AMP,
    ACTIONS(8870), 1,
      anon_sym_GT_EQ,
    ACTIONS(8876), 1,
      anon_sym_QMARK,
    ACTIONS(8880), 1,
      anon_sym_bitor,
    ACTIONS(8882), 1,
      anon_sym_bitand,
    ACTIONS(8904), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(8548), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10198), 1,
      sym_attribute_specifier,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8850), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8852), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8856), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8858), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8862), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8872), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8866), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8868), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8878), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [136963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3176), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3174), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [137014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2491), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2489), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [137065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2359), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2357), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [137116] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    STATE(2582), 1,
      sym_alignas_qualifier,
    ACTIONS(8154), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8684), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    STATE(5477), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5675), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6982), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(8150), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8682), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [137181] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      sym_literal_suffix,
    ACTIONS(2128), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
    ACTIONS(2117), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [137234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5941), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5943), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [137285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5892), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5894), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [137336] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8427), 1,
      anon_sym_STAR,
    ACTIONS(8429), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8431), 1,
      anon_sym_AMP,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    STATE(3549), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7030), 1,
      sym__abstract_declarator,
    STATE(7138), 1,
      sym__function_declarator_seq,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(6777), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [137413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2536), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2534), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [137464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2355), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2353), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [137515] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8427), 1,
      anon_sym_STAR,
    ACTIONS(8429), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8431), 1,
      anon_sym_AMP,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    STATE(3549), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7042), 1,
      sym__abstract_declarator,
    STATE(7138), 1,
      sym__function_declarator_seq,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(7418), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [137592] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(4903), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8888), 1,
      anon_sym_STAR,
    ACTIONS(8890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8892), 1,
      anon_sym_AMP,
    STATE(4083), 1,
      sym_parameter_list,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8063), 1,
      sym__abstract_declarator,
    ACTIONS(8586), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8588), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4823), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6013), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6777), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [137679] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8446), 1,
      anon_sym_STAR,
    ACTIONS(8448), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8450), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    STATE(3489), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7078), 1,
      sym__abstract_declarator,
    STATE(7135), 1,
      sym__function_declarator_seq,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8902), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [137756] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8446), 1,
      anon_sym_STAR,
    ACTIONS(8448), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8450), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    STATE(3489), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7071), 1,
      sym__abstract_declarator,
    STATE(7135), 1,
      sym__function_declarator_seq,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(7418), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [137833] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8790), 1,
      anon_sym_LT,
    STATE(5082), 1,
      sym_template_argument_list,
    ACTIONS(2349), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(2347), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [137890] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8446), 1,
      anon_sym_STAR,
    ACTIONS(8448), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8450), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    STATE(3489), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7074), 1,
      sym__abstract_declarator,
    STATE(7135), 1,
      sym__function_declarator_seq,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(6777), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [137967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5953), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5955), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [138018] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8446), 1,
      anon_sym_STAR,
    ACTIONS(8448), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8450), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    STATE(3489), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7073), 1,
      sym__abstract_declarator,
    STATE(7135), 1,
      sym__function_declarator_seq,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8842), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [138095] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2824), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [138146] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8790), 1,
      anon_sym_LT,
    STATE(5082), 1,
      sym_template_argument_list,
    ACTIONS(2169), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(2176), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [138203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5886), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5888), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [138254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2242), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2240), 29,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [138304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3388), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3386), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [138354] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5070), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3392), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(8906), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3390), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [138408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3156), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3154), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [138458] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(8908), 1,
      sym_identifier,
    ACTIONS(8910), 1,
      anon_sym_LPAREN2,
    ACTIONS(8912), 1,
      anon_sym_STAR,
    ACTIONS(8914), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8916), 1,
      anon_sym_AMP,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(8153), 1,
      sym__field_declarator,
    STATE(8493), 1,
      sym_operator_name,
    STATE(10393), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4823), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6042), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(7713), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [138542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2188), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2186), 29,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [138592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3070), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3068), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [138642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2196), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2194), 29,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [138692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2948), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2946), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [138742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2192), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2190), 29,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [138792] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3102), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3100), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [138842] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2254), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2252), 29,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [138892] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2964), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2962), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [138942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2246), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2244), 29,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [138992] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(8920), 1,
      anon_sym_RPAREN,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8946), 1,
      anon_sym_SEMI,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9124), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [139094] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3090), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3088), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [139144] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5060), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3771), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(8956), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3773), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [139198] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2371), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2373), 29,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [139250] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5089), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3764), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(8958), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3766), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [139304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2200), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2198), 29,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [139354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2232), 29,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [139404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2228), 29,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [139454] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5119), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3757), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(8960), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3759), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [139508] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7412), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [139604] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(4903), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8214), 1,
      sym__abstract_declarator,
    ACTIONS(8586), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8588), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4823), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6057), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6777), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [139690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2258), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2256), 29,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [139740] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8592), 1,
      anon_sym_STAR,
    ACTIONS(8594), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8596), 1,
      anon_sym_AMP,
    ACTIONS(8962), 1,
      anon_sym_DOT,
    STATE(4240), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7691), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5670), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8530), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8556), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [139820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2248), 29,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [139870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2942), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [139920] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7007), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [139992] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2908), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [140042] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7007), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [140112] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7007), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [140186] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5112), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3392), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8964), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3390), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [140240] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7007), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [140318] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7007), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
  [140398] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7400), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [140490] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7007), 1,
      anon_sym_PIPE,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
  [140574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2224), 29,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [140624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3172), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3170), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [140674] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    STATE(212), 1,
      sym_template_argument_list,
    STATE(5121), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2115), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8668), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2123), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [140734] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3190), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [140784] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5112), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2742), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8964), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2740), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [140838] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7007), 1,
      anon_sym_PIPE,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
  [140924] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4908), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3803), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8966), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3805), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [140978] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4908), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3810), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8966), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3812), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [141032] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8968), 1,
      anon_sym_DOT,
    ACTIONS(8702), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3848), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(3850), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [141086] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7416), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [141182] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(6771), 1,
      sym_identifier,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8970), 1,
      anon_sym_STAR,
    ACTIONS(8972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8974), 1,
      anon_sym_AMP,
    STATE(4302), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(6118), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8196), 1,
      sym__abstract_declarator,
    ACTIONS(8606), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8608), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5088), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6036), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6763), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(8604), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8462), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [141266] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
  [141354] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5119), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3803), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(8960), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3805), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [141408] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
  [141498] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8495), 1,
      anon_sym_STAR,
    ACTIONS(8497), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8499), 1,
      anon_sym_AMP,
    STATE(3763), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7234), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8902), 12,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [141574] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(8976), 1,
      anon_sym___attribute__,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    STATE(5603), 1,
      sym_field_declaration_list,
    STATE(5819), 1,
      sym_attribute_specifier,
    STATE(8727), 1,
      sym_virtual_specifier,
    STATE(9693), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2685), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2683), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [141640] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8495), 1,
      anon_sym_STAR,
    ACTIONS(8497), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8499), 1,
      anon_sym_AMP,
    STATE(3763), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7223), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(6777), 12,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [141716] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7007), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [141784] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8495), 1,
      anon_sym_STAR,
    ACTIONS(8497), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8499), 1,
      anon_sym_AMP,
    STATE(3763), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7221), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8842), 12,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [141860] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(4883), 1,
      anon_sym_LPAREN2,
    ACTIONS(6761), 1,
      sym_identifier,
    ACTIONS(6765), 1,
      anon_sym_STAR,
    ACTIONS(6767), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6769), 1,
      anon_sym_AMP,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6775), 1,
      anon_sym_LBRACK,
    ACTIONS(8836), 1,
      anon_sym_COLON,
    STATE(3498), 1,
      sym_parameter_list,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7286), 1,
      sym__declarator,
    STATE(7469), 1,
      sym__abstract_declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8834), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [141952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3202), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3200), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [142002] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8495), 1,
      anon_sym_STAR,
    ACTIONS(8497), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8499), 1,
      anon_sym_AMP,
    STATE(3763), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7203), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(7418), 12,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [142078] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5119), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3750), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(8960), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3752), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [142132] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3338), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3336), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [142182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2740), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [142232] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7424), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [142324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3054), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3052), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [142374] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2740), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [142424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3362), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3360), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [142474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2204), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2202), 29,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [142524] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8558), 1,
      anon_sym_DOT,
    ACTIONS(8618), 1,
      anon_sym_STAR,
    ACTIONS(8620), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8622), 1,
      anon_sym_AMP,
    STATE(3764), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7657), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5627), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8560), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8556), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [142604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3366), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3364), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [142654] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8968), 1,
      anon_sym_DOT,
    ACTIONS(8702), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3890), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(3892), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [142708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3338), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3336), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [142758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2217), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2210), 29,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [142808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3338), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3336), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [142858] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8558), 1,
      anon_sym_DOT,
    ACTIONS(8618), 1,
      anon_sym_STAR,
    ACTIONS(8620), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8622), 1,
      anon_sym_AMP,
    STATE(3764), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7677), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5637), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8560), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8538), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [142938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2988), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2986), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [142988] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8598), 1,
      anon_sym_STAR,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_AMP,
    ACTIONS(8982), 1,
      anon_sym_DOT,
    STATE(4356), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7687), 1,
      sym__abstract_declarator,
    ACTIONS(8608), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5667), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8538), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(8984), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8980), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8462), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [143068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3048), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3046), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [143118] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8970), 1,
      anon_sym_STAR,
    ACTIONS(8972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8974), 1,
      anon_sym_AMP,
    STATE(4302), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(6118), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8199), 1,
      sym__abstract_declarator,
    ACTIONS(8606), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8608), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6017), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6061), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6777), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(8604), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8462), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [143202] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5119), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3810), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(8960), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3812), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [143256] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2361), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2363), 29,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [143306] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(8908), 1,
      sym_identifier,
    ACTIONS(8910), 1,
      anon_sym_LPAREN2,
    ACTIONS(8912), 1,
      anon_sym_STAR,
    ACTIONS(8914), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8916), 1,
      anon_sym_AMP,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(8153), 1,
      sym__field_declarator,
    STATE(8493), 1,
      sym_operator_name,
    STATE(10393), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5092), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6042), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(7713), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [143390] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(8908), 1,
      sym_identifier,
    ACTIONS(8910), 1,
      anon_sym_LPAREN2,
    ACTIONS(8912), 1,
      anon_sym_STAR,
    ACTIONS(8914), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8916), 1,
      anon_sym_AMP,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(8218), 1,
      sym__field_declarator,
    STATE(8493), 1,
      sym_operator_name,
    STATE(10393), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4823), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6050), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(7713), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [143474] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8592), 1,
      anon_sym_STAR,
    ACTIONS(8594), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8596), 1,
      anon_sym_AMP,
    ACTIONS(8962), 1,
      anon_sym_DOT,
    STATE(4240), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7647), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5703), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8530), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8538), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [143554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3844), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3846), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [143604] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7180), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [143700] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3098), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3096), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [143750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3152), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3150), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [143800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3400), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3398), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [143850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3082), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3080), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [143900] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(8910), 1,
      anon_sym_LPAREN2,
    ACTIONS(8986), 1,
      sym_identifier,
    ACTIONS(8988), 1,
      anon_sym_STAR,
    ACTIONS(8990), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8992), 1,
      anon_sym_AMP,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7453), 1,
      sym__field_declarator,
    STATE(7707), 1,
      sym_operator_name,
    STATE(10471), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5116), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6041), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(7713), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [143984] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(8910), 1,
      anon_sym_LPAREN2,
    ACTIONS(8986), 1,
      sym_identifier,
    ACTIONS(8988), 1,
      anon_sym_STAR,
    ACTIONS(8990), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8992), 1,
      anon_sym_AMP,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7453), 1,
      sym__field_declarator,
    STATE(7707), 1,
      sym_operator_name,
    STATE(10471), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4823), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6041), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(7713), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [144068] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2365), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2367), 29,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [144120] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(8994), 1,
      anon_sym_COMMA,
    ACTIONS(8996), 1,
      anon_sym_SEMI,
    ACTIONS(8998), 1,
      anon_sym_RBRACE,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(8984), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [144222] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5054), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3771), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9000), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3773), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [144276] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7360), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [144368] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5055), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3764), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9002), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3766), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [144422] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3396), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3394), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [144472] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2371), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2373), 29,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [144524] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(8908), 1,
      sym_identifier,
    ACTIONS(8910), 1,
      anon_sym_LPAREN2,
    ACTIONS(8912), 1,
      anon_sym_STAR,
    ACTIONS(8914), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8916), 1,
      anon_sym_AMP,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(8223), 1,
      sym__field_declarator,
    STATE(8493), 1,
      sym_operator_name,
    STATE(10393), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5014), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6054), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(7713), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [144608] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8598), 1,
      anon_sym_STAR,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_AMP,
    ACTIONS(8982), 1,
      anon_sym_DOT,
    STATE(4356), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7695), 1,
      sym__abstract_declarator,
    ACTIONS(8608), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5685), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8556), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(8984), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9004), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8462), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [144688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2996), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2994), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [144738] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4908), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3750), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8966), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3752), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [144792] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2208), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2206), 29,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [144842] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7408), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [144934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3384), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3382), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [144984] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(8910), 1,
      anon_sym_LPAREN2,
    ACTIONS(8986), 1,
      sym_identifier,
    ACTIONS(8988), 1,
      anon_sym_STAR,
    ACTIONS(8990), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8992), 1,
      anon_sym_AMP,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7431), 1,
      sym__field_declarator,
    STATE(7707), 1,
      sym_operator_name,
    STATE(10471), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4823), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6040), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(7713), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [145068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3358), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3356), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [145118] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(8910), 1,
      anon_sym_LPAREN2,
    ACTIONS(8986), 1,
      sym_identifier,
    ACTIONS(8988), 1,
      anon_sym_STAR,
    ACTIONS(8990), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8992), 1,
      anon_sym_AMP,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7400), 1,
      sym__field_declarator,
    STATE(7707), 1,
      sym_operator_name,
    STATE(10471), 1,
      sym_ms_based_modifier,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5101), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6038), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(7713), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [145202] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5119), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2856), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(9006), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2854), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [145256] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(4903), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8201), 1,
      sym__abstract_declarator,
    ACTIONS(8586), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8588), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5034), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6052), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6763), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [145342] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4908), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3757), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8966), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3759), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [145396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3054), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3052), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [145446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2998), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [145496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3056), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [145546] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2236), 29,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [145596] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(9011), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9544), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [145695] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8854), 1,
      anon_sym_SLASH,
    ACTIONS(8860), 1,
      anon_sym_PIPE,
    ACTIONS(8864), 1,
      anon_sym_AMP,
    ACTIONS(8870), 1,
      anon_sym_GT_EQ,
    ACTIONS(8880), 1,
      anon_sym_bitor,
    ACTIONS(8882), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8850), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8852), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8862), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8872), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8866), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8868), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8878), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
  [145782] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(9013), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9629), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [145881] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9053), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9635), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [145980] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8854), 1,
      anon_sym_SLASH,
    ACTIONS(8860), 1,
      anon_sym_PIPE,
    ACTIONS(8864), 1,
      anon_sym_AMP,
    ACTIONS(8870), 1,
      anon_sym_GT_EQ,
    ACTIONS(8876), 1,
      anon_sym_QMARK,
    ACTIONS(8880), 1,
      anon_sym_bitor,
    ACTIONS(8882), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8850), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8852), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8856), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8858), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8862), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8872), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8866), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8868), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8878), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9055), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [146075] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9057), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9531), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [146174] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9059), 1,
      anon_sym_COMMA,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9085), 1,
      anon_sym_RBRACK,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(8989), 1,
      aux_sym_lambda_capture_specifier_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [146273] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8624), 1,
      anon_sym_STAR,
    ACTIONS(8626), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8628), 1,
      anon_sym_AMP,
    ACTIONS(9095), 1,
      anon_sym_DOT,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4569), 1,
      sym_parameter_list,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7914), 1,
      sym__abstract_declarator,
    ACTIONS(8154), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5811), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9097), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8556), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8150), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [146352] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8503), 1,
      anon_sym_STAR,
    ACTIONS(8505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8507), 1,
      anon_sym_AMP,
    STATE(3717), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7273), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8842), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [146427] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8503), 1,
      anon_sym_STAR,
    ACTIONS(8505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8507), 1,
      anon_sym_AMP,
    STATE(3717), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7271), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6777), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [146502] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8503), 1,
      anon_sym_STAR,
    ACTIONS(8505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8507), 1,
      anon_sym_AMP,
    STATE(3717), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7251), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8902), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [146577] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8454), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(9099), 1,
      anon_sym_STAR,
    ACTIONS(9101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9103), 1,
      anon_sym_AMP,
    STATE(4478), 1,
      sym_parameter_list,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8261), 1,
      sym__abstract_declarator,
    ACTIONS(8456), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8458), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4772), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6111), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6777), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_GT2,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [146662] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9105), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9430), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [146761] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8454), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(9099), 1,
      anon_sym_STAR,
    ACTIONS(9101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9103), 1,
      anon_sym_AMP,
    STATE(4478), 1,
      sym_parameter_list,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8266), 1,
      sym__abstract_declarator,
    ACTIONS(8456), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8458), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5137), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6093), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6763), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_GT2,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [146846] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9059), 1,
      anon_sym_COMMA,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    ACTIONS(9107), 1,
      anon_sym_RBRACK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(8989), 1,
      aux_sym_lambda_capture_specifier_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [146945] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(9109), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9030), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [147044] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(9111), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9220), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [147143] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9059), 1,
      anon_sym_COMMA,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    ACTIONS(9113), 1,
      anon_sym_RBRACK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(8989), 1,
      aux_sym_lambda_capture_specifier_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [147242] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(8998), 1,
      anon_sym_RBRACE,
    ACTIONS(9115), 1,
      anon_sym_COMMA,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(8984), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [147341] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8084), 1,
      anon_sym_COMMA,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9117), 1,
      anon_sym_RPAREN,
    ACTIONS(9119), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [147440] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9121), 1,
      anon_sym_COMMA,
    ACTIONS(9123), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9557), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [147539] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8946), 1,
      anon_sym_SEMI,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9124), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [147638] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9125), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9118), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [147737] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9127), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9063), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [147836] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8503), 1,
      anon_sym_STAR,
    ACTIONS(8505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8507), 1,
      anon_sym_AMP,
    STATE(3717), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7294), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7418), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [147911] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    STATE(4847), 1,
      sym_alignas_qualifier,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8684), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8682), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [147970] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8854), 1,
      anon_sym_SLASH,
    ACTIONS(8860), 1,
      anon_sym_PIPE,
    ACTIONS(8864), 1,
      anon_sym_AMP,
    ACTIONS(8870), 1,
      anon_sym_GT_EQ,
    ACTIONS(8880), 1,
      anon_sym_bitor,
    ACTIONS(8882), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8850), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8852), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8856), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8858), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8862), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8872), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8866), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8868), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8878), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7408), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [148061] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(9129), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9031), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [148160] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    ACTIONS(9133), 1,
      anon_sym_RBRACE,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(8945), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [148259] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9135), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9023), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [148358] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9121), 1,
      anon_sym_COMMA,
    ACTIONS(9137), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9135), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [148457] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9139), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(8991), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [148556] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9141), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9029), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [148655] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(9059), 1,
      anon_sym_COMMA,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    ACTIONS(9143), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9145), 1,
      anon_sym_RBRACK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(8989), 1,
      aux_sym_lambda_capture_specifier_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [148754] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8854), 1,
      anon_sym_SLASH,
    ACTIONS(8860), 1,
      anon_sym_PIPE,
    ACTIONS(8864), 1,
      anon_sym_AMP,
    ACTIONS(8870), 1,
      anon_sym_GT_EQ,
    ACTIONS(8876), 1,
      anon_sym_QMARK,
    ACTIONS(8880), 1,
      anon_sym_bitor,
    ACTIONS(8882), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8850), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8852), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8856), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8858), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8862), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8872), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7180), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
    ACTIONS(8866), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8868), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8878), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [148849] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    ACTIONS(9147), 1,
      anon_sym_COMMA,
    ACTIONS(9149), 1,
      anon_sym_RBRACK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9613), 1,
      aux_sym_subscript_argument_list_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [148948] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8854), 1,
      anon_sym_SLASH,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8852), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7007), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [149015] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8854), 1,
      anon_sym_SLASH,
    ACTIONS(8860), 1,
      anon_sym_PIPE,
    ACTIONS(8864), 1,
      anon_sym_AMP,
    ACTIONS(8870), 1,
      anon_sym_GT_EQ,
    ACTIONS(8880), 1,
      anon_sym_bitor,
    ACTIONS(8882), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8850), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8852), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8858), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8862), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8872), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8866), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8868), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8878), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
  [149104] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9151), 1,
      anon_sym_COMMA,
    ACTIONS(9153), 1,
      anon_sym_RBRACE,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9610), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [149203] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    STATE(2816), 1,
      sym_template_argument_list,
    STATE(2949), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3483), 3,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_const,
    ACTIONS(6167), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3485), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [149262] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7007), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_SLASH,
    ACTIONS(8864), 1,
      anon_sym_AMP,
    ACTIONS(8870), 1,
      anon_sym_GT_EQ,
    ACTIONS(8882), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8850), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8852), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8862), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8872), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8866), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8868), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8878), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
  [149347] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7007), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_SLASH,
    ACTIONS(8864), 1,
      anon_sym_AMP,
    ACTIONS(8870), 1,
      anon_sym_GT_EQ,
    ACTIONS(8882), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8850), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8852), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8872), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8866), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8868), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8878), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
  [149430] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8854), 1,
      anon_sym_SLASH,
    ACTIONS(8870), 1,
      anon_sym_GT_EQ,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7007), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8850), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8852), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8872), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8866), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8868), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8878), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
  [149509] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8854), 1,
      anon_sym_SLASH,
    ACTIONS(8870), 1,
      anon_sym_GT_EQ,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7007), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8850), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8852), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8872), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8868), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8878), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [149586] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8854), 1,
      anon_sym_SLASH,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8850), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8852), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8872), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8878), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7007), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [149659] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(9155), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9541), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [149758] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8854), 1,
      anon_sym_SLASH,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8850), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8852), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7007), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [149827] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9157), 1,
      anon_sym_COMMA,
    ACTIONS(9159), 1,
      anon_sym_RBRACE,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9400), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [149926] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    ACTIONS(9147), 1,
      anon_sym_COMMA,
    ACTIONS(9161), 1,
      anon_sym_RBRACK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9109), 1,
      aux_sym_subscript_argument_list_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [150025] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8854), 1,
      anon_sym_SLASH,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8850), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8852), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8872), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7007), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [150096] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(8686), 1,
      anon_sym_STAR,
    ACTIONS(8688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8690), 1,
      anon_sym_AMP,
    ACTIONS(9163), 1,
      anon_sym_DOT,
    STATE(4485), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7878), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5776), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8542), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8538), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [150175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2371), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2373), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [150224] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(9165), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9193), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [150323] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8854), 1,
      anon_sym_SLASH,
    ACTIONS(8860), 1,
      anon_sym_PIPE,
    ACTIONS(8864), 1,
      anon_sym_AMP,
    ACTIONS(8870), 1,
      anon_sym_GT_EQ,
    ACTIONS(8880), 1,
      anon_sym_bitor,
    ACTIONS(8882), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8850), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8852), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8856), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8858), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8862), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8872), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8866), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8868), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8878), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7360), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [150414] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8630), 1,
      anon_sym_DOT,
    ACTIONS(8712), 1,
      anon_sym_STAR,
    ACTIONS(8714), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8716), 1,
      anon_sym_AMP,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7732), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5842), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8560), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8556), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [150493] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(9167), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9506), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [150592] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9169), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9323), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [150691] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9171), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9329), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [150790] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(8686), 1,
      anon_sym_STAR,
    ACTIONS(8688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8690), 1,
      anon_sym_AMP,
    ACTIONS(9163), 1,
      anon_sym_DOT,
    STATE(4485), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7874), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5772), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8542), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8556), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [150869] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8630), 1,
      anon_sym_DOT,
    ACTIONS(8712), 1,
      anon_sym_STAR,
    ACTIONS(8714), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8716), 1,
      anon_sym_AMP,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7738), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5845), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8560), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8538), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [150948] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9173), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9547), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [151047] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9175), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9548), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [151146] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8854), 1,
      anon_sym_SLASH,
    ACTIONS(8860), 1,
      anon_sym_PIPE,
    ACTIONS(8864), 1,
      anon_sym_AMP,
    ACTIONS(8870), 1,
      anon_sym_GT_EQ,
    ACTIONS(8876), 1,
      anon_sym_QMARK,
    ACTIONS(8880), 1,
      anon_sym_bitor,
    ACTIONS(8882), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8850), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8852), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8856), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8858), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8862), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8872), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7412), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
    ACTIONS(8866), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8868), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8878), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [151241] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8854), 1,
      anon_sym_SLASH,
    ACTIONS(8860), 1,
      anon_sym_PIPE,
    ACTIONS(8864), 1,
      anon_sym_AMP,
    ACTIONS(8870), 1,
      anon_sym_GT_EQ,
    ACTIONS(8880), 1,
      anon_sym_bitor,
    ACTIONS(8882), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8850), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8852), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8856), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8858), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8862), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8872), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8866), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8868), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8878), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7424), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [151332] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8854), 1,
      anon_sym_SLASH,
    ACTIONS(8860), 1,
      anon_sym_PIPE,
    ACTIONS(8864), 1,
      anon_sym_AMP,
    ACTIONS(8870), 1,
      anon_sym_GT_EQ,
    ACTIONS(8876), 1,
      anon_sym_QMARK,
    ACTIONS(8880), 1,
      anon_sym_bitor,
    ACTIONS(8882), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8850), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8852), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8856), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8858), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8862), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8872), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7416), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
    ACTIONS(8866), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8868), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8878), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [151427] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9177), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9580), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [151526] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9121), 1,
      anon_sym_COMMA,
    ACTIONS(9179), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9590), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [151625] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9181), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9291), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [151724] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5070), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2742), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(8906), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2740), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [151777] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    STATE(4847), 1,
      sym_alignas_qualifier,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9185), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(9183), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [151836] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8084), 1,
      anon_sym_COMMA,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9187), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [151933] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9189), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9527), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152032] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9121), 1,
      anon_sym_COMMA,
    ACTIONS(9191), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9568), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [152131] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9193), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9572), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152230] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9195), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9145), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152329] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8454), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(9197), 1,
      anon_sym_STAR,
    ACTIONS(9199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9201), 1,
      anon_sym_AMP,
    STATE(4541), 1,
      sym_parameter_list,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8249), 1,
      sym__abstract_declarator,
    ACTIONS(8456), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8458), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5204), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6103), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6763), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [152414] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    STATE(212), 1,
      sym_template_argument_list,
    ACTIONS(2169), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2176), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [152469] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9203), 1,
      anon_sym_COMMA,
    ACTIONS(9205), 1,
      anon_sym_RBRACE,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9533), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [152568] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8454), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(9197), 1,
      anon_sym_STAR,
    ACTIONS(9199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9201), 1,
      anon_sym_AMP,
    STATE(4541), 1,
      sym_parameter_list,
    STATE(4933), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8305), 1,
      sym__abstract_declarator,
    ACTIONS(8456), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8458), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4772), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6085), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6777), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [152653] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9207), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9525), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152752] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9211), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9209), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [152849] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9213), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9112), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [152948] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    STATE(5662), 1,
      sym_field_declaration_list,
    STATE(5810), 1,
      sym_attribute_specifier,
    STATE(8928), 1,
      sym_virtual_specifier,
    STATE(10038), 1,
      sym_base_class_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2683), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2685), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [153013] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(8692), 1,
      anon_sym_STAR,
    ACTIONS(8694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8696), 1,
      anon_sym_AMP,
    ACTIONS(8962), 1,
      anon_sym_DOT,
    STATE(4454), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7775), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5767), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8530), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8556), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [153092] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8854), 1,
      anon_sym_SLASH,
    ACTIONS(8860), 1,
      anon_sym_PIPE,
    ACTIONS(8864), 1,
      anon_sym_AMP,
    ACTIONS(8870), 1,
      anon_sym_GT_EQ,
    ACTIONS(8876), 1,
      anon_sym_QMARK,
    ACTIONS(8880), 1,
      anon_sym_bitor,
    ACTIONS(8882), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8850), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8852), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8856), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8858), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8862), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8872), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8866), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8868), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8878), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9217), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [153187] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8854), 1,
      anon_sym_SLASH,
    ACTIONS(8860), 1,
      anon_sym_PIPE,
    ACTIONS(8864), 1,
      anon_sym_AMP,
    ACTIONS(8870), 1,
      anon_sym_GT_EQ,
    ACTIONS(8880), 1,
      anon_sym_bitor,
    ACTIONS(8882), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8850), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8852), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8856), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8858), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8862), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8872), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8866), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8868), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8878), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7400), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [153278] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(9219), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9500), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [153377] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(9221), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9607), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [153476] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8433), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(9223), 1,
      anon_sym_STAR,
    ACTIONS(9225), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9227), 1,
      anon_sym_AMP,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4588), 1,
      sym_parameter_list,
    STATE(5745), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(8300), 1,
      sym__abstract_declarator,
    ACTIONS(8154), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8435), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8437), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5227), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6105), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6763), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8150), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [153561] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8624), 1,
      anon_sym_STAR,
    ACTIONS(8626), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8628), 1,
      anon_sym_AMP,
    ACTIONS(9095), 1,
      anon_sym_DOT,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4569), 1,
      sym_parameter_list,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7903), 1,
      sym__abstract_declarator,
    ACTIONS(8154), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5783), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9097), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8538), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8150), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [153640] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9229), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9477), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [153739] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9231), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9476), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [153838] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    STATE(212), 1,
      sym_template_argument_list,
    ACTIONS(2349), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2347), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [153893] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    STATE(2816), 1,
      sym_template_argument_list,
    STATE(5728), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3483), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9233), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3485), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [153952] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9235), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9136), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [154051] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9237), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9462), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154150] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9239), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9420), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154249] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9121), 1,
      anon_sym_COMMA,
    ACTIONS(9241), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9458), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [154348] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9121), 1,
      anon_sym_COMMA,
    ACTIONS(9243), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9332), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [154447] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9245), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9441), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154546] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9247), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9457), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154645] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8433), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(9223), 1,
      anon_sym_STAR,
    ACTIONS(9225), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9227), 1,
      anon_sym_AMP,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4588), 1,
      sym_parameter_list,
    STATE(5745), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(8286), 1,
      sym__abstract_declarator,
    ACTIONS(8154), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8435), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8437), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5287), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6065), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6777), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8150), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [154730] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    STATE(2816), 1,
      sym_template_argument_list,
    STATE(5710), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9249), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3485), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(3483), 25,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [154789] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(9251), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9344), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [154888] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9059), 1,
      anon_sym_COMMA,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    ACTIONS(9253), 1,
      anon_sym_RBRACK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9079), 1,
      aux_sym_lambda_capture_specifier_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [154987] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(9059), 1,
      anon_sym_COMMA,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    ACTIONS(9143), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9255), 1,
      anon_sym_RBRACK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(8989), 1,
      aux_sym_lambda_capture_specifier_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [155086] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9257), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(8978), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155185] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9259), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9339), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155284] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9261), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(8975), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155383] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9263), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(8965), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155482] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9265), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(8959), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155581] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9187), 1,
      anon_sym_SEMI,
    ACTIONS(9267), 1,
      anon_sym_COMMA,
    ACTIONS(9270), 1,
      anon_sym_RBRACE,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [155680] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(8996), 1,
      anon_sym_SEMI,
    ACTIONS(9272), 1,
      anon_sym_COMMA,
    ACTIONS(9275), 1,
      anon_sym_RBRACE,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [155779] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(9277), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9314), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [155878] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym_LBRACE,
    ACTIONS(8698), 1,
      anon_sym_LPAREN2,
    STATE(5653), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6883), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6885), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [155933] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9279), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9297), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [156032] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9281), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9296), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [156131] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9283), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(8947), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156230] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9285), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9279), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156329] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9287), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9272), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156428] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9289), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9504), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156527] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9291), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9526), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [156626] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9293), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9005), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156725] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9295), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9206), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156824] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9297), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(8990), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156923] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9299), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9065), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157022] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9301), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9218), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [157121] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9303), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9068), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157220] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9305), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9187), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [157319] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9307), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9102), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157418] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9309), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9132), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157517] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9311), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9186), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [157616] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9313), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9181), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157715] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9315), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9142), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157814] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9317), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9179), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157913] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(8692), 1,
      anon_sym_STAR,
    ACTIONS(8694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8696), 1,
      anon_sym_AMP,
    ACTIONS(8962), 1,
      anon_sym_DOT,
    STATE(4454), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7784), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5759), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8530), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8538), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [157992] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9319), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9103), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158091] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym_LBRACE,
    ACTIONS(8698), 1,
      anon_sym_LPAREN2,
    STATE(5638), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6820), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6822), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [158146] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9321), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9163), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158245] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9323), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9177), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158344] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(9325), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(8960), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [158443] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9327), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9087), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [158542] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9329), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9086), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [158641] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9331), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9080), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158740] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9333), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9069), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158839] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9335), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9194), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158938] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9337), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9000), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159037] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9339), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(8956), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159136] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9341), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9225), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159235] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9343), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(8971), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159334] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9345), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(8962), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159433] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9347), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9246), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159532] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9349), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9254), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159631] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9351), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9228), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159730] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9353), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(8941), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159829] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9355), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9385), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159928] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9357), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9311), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160027] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9359), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9392), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160126] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9361), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9322), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160225] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    ACTIONS(9147), 1,
      anon_sym_COMMA,
    ACTIONS(9363), 1,
      anon_sym_RBRACK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9032), 1,
      aux_sym_subscript_argument_list_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [160324] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym_LBRACE,
    ACTIONS(8698), 1,
      anon_sym_LPAREN2,
    STATE(5630), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6834), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6836), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [160379] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9365), 1,
      sym_ms_restrict_modifier,
    STATE(5745), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(9368), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9371), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5287), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(8546), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8548), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [160438] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9374), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9362), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160537] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9376), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9390), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160636] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9378), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9394), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160735] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9380), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9419), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160834] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9382), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9444), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160933] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9384), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9478), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161032] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9386), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9508), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161131] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym_LBRACE,
    ACTIONS(8698), 1,
      anon_sym_LPAREN2,
    STATE(5626), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6859), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6861), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [161186] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9388), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9429), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161285] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9390), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9567), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161384] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9392), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9636), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161483] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9394), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9456), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161582] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(9396), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9130), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [161681] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9398), 1,
      anon_sym_COMMA,
    ACTIONS(9400), 1,
      anon_sym_RBRACE,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    STATE(9114), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [161780] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9402), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9066), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161879] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9404), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9401), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161978] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9406), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9129), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162077] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9408), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9058), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162176] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9410), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9082), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162275] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9412), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9165), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162374] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9414), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9268), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162473] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9416), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9328), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162572] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9418), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9434), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162671] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9420), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9537), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162770] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9422), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9565), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162869] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    ACTIONS(9424), 1,
      anon_sym_GT2,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    STATE(9623), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162968] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7045), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(7047), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
  [163028] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9426), 1,
      anon_sym_COMMA,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9438), 1,
      anon_sym_PIPE,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9452), 1,
      anon_sym_COLON,
    ACTIONS(9454), 1,
      anon_sym_QMARK,
    ACTIONS(9458), 1,
      anon_sym_bitor,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9434), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9436), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9440), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [163124] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8828), 1,
      anon_sym_STAR,
    ACTIONS(8830), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8832), 1,
      anon_sym_AMP,
    ACTIONS(9163), 1,
      anon_sym_DOT,
    STATE(4574), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7979), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5946), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8542), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8538), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [163202] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      sym_literal_suffix,
    ACTIONS(6594), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
    ACTIONS(6596), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [163252] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9426), 1,
      anon_sym_COMMA,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9438), 1,
      anon_sym_PIPE,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9454), 1,
      anon_sym_QMARK,
    ACTIONS(9458), 1,
      anon_sym_bitor,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    ACTIONS(9462), 1,
      anon_sym_COLON,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9434), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9436), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9440), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [163348] = 9,
    ACTIONS(3), 1,
      sym_comment,
    STATE(6084), 1,
      sym_alignas_qualifier,
    ACTIONS(8281), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5983), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6027), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6642), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(8682), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(8277), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8684), 12,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [163408] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8084), 1,
      anon_sym_COMMA,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9464), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [163504] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7007), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [163576] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7007), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(7009), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [163644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7426), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7428), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [163692] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7007), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [163766] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(7007), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [163842] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(7007), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_GT2,
  [163920] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7007), 1,
      anon_sym_PIPE,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_GT2,
  [164002] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7007), 1,
      anon_sym_PIPE,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_GT2,
  [164086] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7360), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164176] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT2,
  [164262] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_GT2,
  [164350] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7007), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(7009), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [164412] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7007), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(7009), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [164478] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(9466), 1,
      anon_sym_COLON,
    ACTIONS(9468), 1,
      anon_sym_LBRACE,
    STATE(5476), 1,
      sym__enum_base_clause,
    STATE(5750), 1,
      sym_enumerator_list,
    STATE(5793), 1,
      sym_attribute_specifier,
    ACTIONS(3348), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3350), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [164538] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9426), 1,
      anon_sym_COMMA,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9438), 1,
      anon_sym_PIPE,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9454), 1,
      anon_sym_QMARK,
    ACTIONS(9458), 1,
      anon_sym_bitor,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    ACTIONS(9470), 1,
      anon_sym_COLON,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9434), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9436), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9440), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [164634] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9426), 1,
      anon_sym_COMMA,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9438), 1,
      anon_sym_PIPE,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9454), 1,
      anon_sym_QMARK,
    ACTIONS(9458), 1,
      anon_sym_bitor,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    ACTIONS(9472), 1,
      anon_sym_COLON,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9434), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9436), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9440), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [164730] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8976), 1,
      anon_sym___attribute__,
    ACTIONS(9474), 1,
      anon_sym_LBRACE,
    STATE(5610), 1,
      sym_enumerator_list,
    STATE(5778), 1,
      sym_attribute_specifier,
    ACTIONS(3717), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3715), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [164786] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8084), 1,
      anon_sym_COMMA,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9476), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [164882] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8084), 1,
      anon_sym_COMMA,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9478), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [164978] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(6777), 1,
      anon_sym_COMMA,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(9480), 1,
      anon_sym_STAR,
    ACTIONS(9482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9484), 1,
      anon_sym_AMP,
    STATE(4571), 1,
      sym_parameter_list,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8517), 1,
      sym__abstract_declarator,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4823), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6147), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [165060] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8538), 1,
      anon_sym_COMMA,
    ACTIONS(8822), 1,
      anon_sym_STAR,
    ACTIONS(8824), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8826), 1,
      anon_sym_AMP,
    ACTIONS(9486), 1,
      anon_sym_DOT,
    STATE(4577), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7994), 1,
      sym__abstract_declarator,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6000), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8984), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8980), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [165138] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(7180), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165232] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(6763), 1,
      anon_sym_COMMA,
    ACTIONS(6771), 1,
      sym_identifier,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(9480), 1,
      anon_sym_STAR,
    ACTIONS(9482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9484), 1,
      anon_sym_AMP,
    STATE(4571), 1,
      sym_parameter_list,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8418), 1,
      sym__abstract_declarator,
    ACTIONS(4905), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5340), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6139), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4903), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [165314] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9488), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [165408] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8976), 1,
      anon_sym___attribute__,
    ACTIONS(9474), 1,
      anon_sym_LBRACE,
    STATE(5607), 1,
      sym_enumerator_list,
    STATE(5839), 1,
      sym_attribute_specifier,
    ACTIONS(3713), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3711), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [165464] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9490), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165558] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7037), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(7039), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [165620] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(7412), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165714] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2217), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(2222), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2212), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [165764] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7408), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165854] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9492), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [165948] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7045), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7047), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [166008] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9494), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166102] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7041), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7043), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [166164] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9426), 1,
      anon_sym_COMMA,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9438), 1,
      anon_sym_PIPE,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9454), 1,
      anon_sym_QMARK,
    ACTIONS(9458), 1,
      anon_sym_bitor,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    ACTIONS(9496), 1,
      anon_sym_COLON,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9434), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9436), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9440), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [166260] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7037), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7039), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [166322] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7011), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7013), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [166382] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8084), 1,
      anon_sym_COMMA,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(8996), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [166478] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7424), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166568] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9438), 1,
      anon_sym_PIPE,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9458), 1,
      anon_sym_bitor,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9434), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9436), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9440), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7400), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [166658] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8084), 1,
      anon_sym_COMMA,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9498), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [166754] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9438), 1,
      anon_sym_PIPE,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9454), 1,
      anon_sym_QMARK,
    ACTIONS(9458), 1,
      anon_sym_bitor,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7416), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9434), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9436), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9440), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [166848] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9438), 1,
      anon_sym_PIPE,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9458), 1,
      anon_sym_bitor,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9434), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9436), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9440), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7424), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [166938] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9438), 1,
      anon_sym_PIPE,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9454), 1,
      anon_sym_QMARK,
    ACTIONS(9458), 1,
      anon_sym_bitor,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7412), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9434), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9436), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9440), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [167032] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9438), 1,
      anon_sym_PIPE,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9458), 1,
      anon_sym_bitor,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9434), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9436), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9440), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7360), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [167122] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7007), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [167192] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9500), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [167286] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7408), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [167376] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7007), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [167444] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7007), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [167516] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8084), 1,
      anon_sym_COMMA,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9502), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [167612] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9426), 1,
      anon_sym_COMMA,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9438), 1,
      anon_sym_PIPE,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9454), 1,
      anon_sym_QMARK,
    ACTIONS(9458), 1,
      anon_sym_bitor,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    ACTIONS(9504), 1,
      anon_sym_COLON,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9434), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9436), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9440), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [167708] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7007), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [167784] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(9466), 1,
      anon_sym_COLON,
    ACTIONS(9468), 1,
      anon_sym_LBRACE,
    STATE(5509), 1,
      sym__enum_base_clause,
    STATE(5688), 1,
      sym_enumerator_list,
    STATE(5862), 1,
      sym_attribute_specifier,
    ACTIONS(3060), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3062), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [167844] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8700), 1,
      anon_sym_LBRACK,
    STATE(5563), 1,
      sym_new_declarator,
    ACTIONS(6924), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6926), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [167896] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9506), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167990] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9474), 1,
      anon_sym_LBRACE,
    ACTIONS(9508), 1,
      anon_sym_COLON,
    ACTIONS(9510), 1,
      anon_sym___attribute__,
    STATE(5337), 1,
      sym__enum_base_clause,
    STATE(5605), 1,
      sym_enumerator_list,
    STATE(5865), 1,
      sym_attribute_specifier,
    ACTIONS(3348), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(3350), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [168050] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9474), 1,
      anon_sym_LBRACE,
    ACTIONS(9508), 1,
      anon_sym_COLON,
    ACTIONS(9510), 1,
      anon_sym___attribute__,
    STATE(5345), 1,
      sym__enum_base_clause,
    STATE(5601), 1,
      sym_enumerator_list,
    STATE(5768), 1,
      sym_attribute_specifier,
    ACTIONS(3060), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(3062), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [168110] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(4883), 1,
      anon_sym_LPAREN2,
    ACTIONS(6761), 1,
      sym_identifier,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6775), 1,
      anon_sym_LBRACK,
    ACTIONS(6905), 1,
      anon_sym_STAR,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(8836), 1,
      anon_sym_COLON,
    STATE(4541), 1,
      sym_parameter_list,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7286), 1,
      sym__declarator,
    STATE(8337), 1,
      sym__abstract_declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    ACTIONS(8834), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [168200] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7007), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
  [168278] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DASH_GT,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9519), 1,
      anon_sym_requires,
    ACTIONS(9522), 1,
      anon_sym_where,
    STATE(5809), 1,
      sym_ref_qualifier,
    STATE(6573), 1,
      sym__function_attributes_end,
    STATE(6823), 1,
      sym_trailing_return_type,
    STATE(7092), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7182), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6126), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [168368] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7007), 1,
      anon_sym_PIPE,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
  [168450] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9525), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [168544] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(7416), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168638] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7007), 1,
      anon_sym_PIPE,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9440), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
  [168722] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9527), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168816] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9438), 1,
      anon_sym_PIPE,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9458), 1,
      anon_sym_bitor,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9440), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
  [168902] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6165), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6602), 1,
      anon_sym_LPAREN2,
    ACTIONS(6605), 1,
      anon_sym_LBRACK,
    ACTIONS(2128), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(2117), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [168956] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9438), 1,
      anon_sym_PIPE,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9458), 1,
      anon_sym_bitor,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9436), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9440), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
  [169044] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7007), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [169110] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9209), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [169204] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6984), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(6986), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [169266] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      sym_literal_suffix,
    ACTIONS(2128), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
    ACTIONS(2117), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [169316] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7424), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [169406] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9438), 1,
      anon_sym_PIPE,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9454), 1,
      anon_sym_QMARK,
    ACTIONS(9458), 1,
      anon_sym_bitor,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7180), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9434), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9436), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9440), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [169500] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9438), 1,
      anon_sym_PIPE,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9458), 1,
      anon_sym_bitor,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9434), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9436), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9440), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7408), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [169590] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9426), 1,
      anon_sym_COMMA,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9438), 1,
      anon_sym_PIPE,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9454), 1,
      anon_sym_QMARK,
    ACTIONS(9458), 1,
      anon_sym_bitor,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    ACTIONS(9529), 1,
      anon_sym_COLON,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9434), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9436), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9440), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [169686] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8084), 1,
      anon_sym_COMMA,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9531), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [169782] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9426), 1,
      anon_sym_COMMA,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9438), 1,
      anon_sym_PIPE,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9454), 1,
      anon_sym_QMARK,
    ACTIONS(9458), 1,
      anon_sym_bitor,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    ACTIONS(9533), 1,
      anon_sym_COLON,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9434), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9436), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9440), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [169878] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8084), 1,
      anon_sym_COMMA,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9535), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [169974] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9426), 1,
      anon_sym_COMMA,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9438), 1,
      anon_sym_PIPE,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9454), 1,
      anon_sym_QMARK,
    ACTIONS(9458), 1,
      anon_sym_bitor,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    ACTIONS(9537), 1,
      anon_sym_COLON,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9434), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9436), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9440), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [170070] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6984), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6986), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [170132] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7180), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [170226] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9426), 1,
      anon_sym_COMMA,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9438), 1,
      anon_sym_PIPE,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9454), 1,
      anon_sym_QMARK,
    ACTIONS(9458), 1,
      anon_sym_bitor,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    ACTIONS(9539), 1,
      anon_sym_COLON,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9434), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9436), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9440), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [170322] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DASH_GT,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(7471), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(5774), 1,
      sym_ref_qualifier,
    STATE(6546), 1,
      sym__function_attributes_end,
    STATE(6850), 1,
      sym_trailing_return_type,
    STATE(7092), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7500), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6150), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [170412] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9541), 1,
      anon_sym_COMMA,
    ACTIONS(9543), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [170508] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7007), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [170570] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7007), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [170636] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
  [170724] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
  [170810] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7007), 1,
      anon_sym_PIPE,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
  [170894] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7400), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [170984] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8084), 1,
      anon_sym_COMMA,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9545), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [171080] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8084), 1,
      anon_sym_COMMA,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9547), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [171176] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(7007), 1,
      anon_sym_PIPE,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
  [171258] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8084), 1,
      anon_sym_COMMA,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9549), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [171354] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7007), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
  [171432] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7007), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7009), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [171508] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7041), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(7043), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [171570] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7007), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [171642] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7007), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [171710] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8084), 1,
      anon_sym_COMMA,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9551), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [171806] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9426), 1,
      anon_sym_COMMA,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9438), 1,
      anon_sym_PIPE,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9454), 1,
      anon_sym_QMARK,
    ACTIONS(9458), 1,
      anon_sym_bitor,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    ACTIONS(9553), 1,
      anon_sym_COLON,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9434), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9436), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9440), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [171902] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7011), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(7013), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
  [171962] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7007), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7009), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [172032] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9187), 1,
      anon_sym_COLON,
    ACTIONS(9426), 1,
      anon_sym_COMMA,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9438), 1,
      anon_sym_PIPE,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9454), 1,
      anon_sym_QMARK,
    ACTIONS(9458), 1,
      anon_sym_bitor,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9434), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9436), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9440), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [172128] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9555), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [172222] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9555), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [172316] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7360), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [172406] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8556), 1,
      anon_sym_COMMA,
    ACTIONS(8822), 1,
      anon_sym_STAR,
    ACTIONS(8824), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8826), 1,
      anon_sym_AMP,
    ACTIONS(9486), 1,
      anon_sym_DOT,
    STATE(4577), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8011), 1,
      sym__abstract_declarator,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8984), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9004), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [172484] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7412), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [172578] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7400), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172668] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8616), 1,
      anon_sym_LT,
    STATE(2816), 1,
      sym_template_argument_list,
    STATE(2949), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2115), 3,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_const,
    ACTIONS(6167), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2123), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [172726] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8084), 1,
      anon_sym_COMMA,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9557), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [172822] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9555), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172916] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    ACTIONS(8130), 1,
      anon_sym_LBRACK,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9029), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_AMP,
    ACTIONS(9039), 1,
      anon_sym_LT_LT,
    ACTIONS(9041), 1,
      anon_sym_GT_GT,
    ACTIONS(9043), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_bitor,
    ACTIONS(9049), 1,
      anon_sym_bitand,
    STATE(4452), 1,
      sym_subscript_argument_list,
    STATE(4453), 1,
      sym_argument_list,
    ACTIONS(8148), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9019), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9021), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9025), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9027), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9031), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9051), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9555), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(9035), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9045), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9037), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [173010] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8084), 1,
      anon_sym_COMMA,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9119), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [173106] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9559), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [173200] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7416), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [173294] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8084), 1,
      anon_sym_COMMA,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9561), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [173390] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9567), 1,
      anon_sym___attribute__,
    STATE(5441), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(9565), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9563), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [173442] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9570), 1,
      anon_sym_COMMA,
    ACTIONS(9572), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [173538] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9574), 1,
      anon_sym_COMMA,
    ACTIONS(9576), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [173634] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8084), 1,
      anon_sym_COMMA,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9578), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [173730] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9580), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [173824] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(4883), 1,
      anon_sym_LPAREN2,
    ACTIONS(6761), 1,
      sym_identifier,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6775), 1,
      anon_sym_LBRACK,
    ACTIONS(6914), 1,
      anon_sym_STAR,
    ACTIONS(6916), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6918), 1,
      anon_sym_AMP,
    ACTIONS(8836), 1,
      anon_sym_COLON,
    STATE(4478), 1,
      sym_parameter_list,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7286), 1,
      sym__declarator,
    STATE(8264), 1,
      sym__abstract_declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    ACTIONS(8834), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [173914] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8084), 1,
      anon_sym_COMMA,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9582), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [174010] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(245), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2299), 1,
      anon_sym_enum,
    ACTIONS(2301), 1,
      anon_sym_class,
    ACTIONS(2303), 1,
      anon_sym_struct,
    ACTIONS(2305), 1,
      anon_sym_union,
    ACTIONS(2329), 1,
      anon_sym_typename,
    ACTIONS(2341), 1,
      anon_sym_interface,
    ACTIONS(2343), 1,
      anon_sym_extension,
    ACTIONS(2409), 1,
      sym_primitive_type,
    ACTIONS(5024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9584), 1,
      sym_identifier,
    ACTIONS(9586), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9590), 1,
      anon_sym_EQ,
    STATE(2632), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2718), 1,
      sym_qualified_type_identifier,
    STATE(2938), 1,
      sym_type_specifier,
    STATE(8090), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    ACTIONS(9588), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(2715), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(243), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(195), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2741), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [174102] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9592), 1,
      anon_sym_COMMA,
    ACTIONS(9594), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [174198] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(4903), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(9596), 1,
      anon_sym_STAR,
    ACTIONS(9598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9600), 1,
      anon_sym_AMP,
    STATE(4576), 1,
      sym_parameter_list,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8422), 1,
      sym__abstract_declarator,
    ACTIONS(6763), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8586), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8588), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5458), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6136), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [174282] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9602), 1,
      anon_sym_COMMA,
    ACTIONS(9604), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [174378] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9609), 1,
      anon_sym_const,
    STATE(2582), 1,
      sym_alignas_qualifier,
    ACTIONS(8511), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    ACTIONS(9612), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5452), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9606), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8513), 21,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [174436] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9270), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [174530] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9275), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [174624] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9506), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [174718] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8084), 1,
      anon_sym_COMMA,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9615), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [174814] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9617), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [174908] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(4903), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(9596), 1,
      anon_sym_STAR,
    ACTIONS(9598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9600), 1,
      anon_sym_AMP,
    STATE(4576), 1,
      sym_parameter_list,
    STATE(4963), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8438), 1,
      sym__abstract_declarator,
    ACTIONS(6777), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8586), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8588), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4823), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6134), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [174992] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8084), 1,
      anon_sym_COMMA,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9619), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [175088] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8084), 1,
      anon_sym_COMMA,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9621), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [175184] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8708), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [175278] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8084), 1,
      anon_sym_COMMA,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9623), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [175374] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9625), 1,
      sym_identifier,
    ACTIONS(9627), 1,
      sym_primitive_type,
    STATE(2858), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6881), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3822), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_GT2,
    ACTIONS(3820), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [175430] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9629), 1,
      anon_sym_COMMA,
    ACTIONS(9631), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [175526] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8084), 1,
      anon_sym_COMMA,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9633), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [175622] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8084), 1,
      anon_sym_COMMA,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9635), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [175718] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9637), 1,
      anon_sym_COMMA,
    ACTIONS(9639), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [175814] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9426), 1,
      anon_sym_COMMA,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9438), 1,
      anon_sym_PIPE,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9454), 1,
      anon_sym_QMARK,
    ACTIONS(9458), 1,
      anon_sym_bitor,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    ACTIONS(9641), 1,
      anon_sym_COLON,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9434), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9436), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9440), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [175910] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8828), 1,
      anon_sym_STAR,
    ACTIONS(8830), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8832), 1,
      anon_sym_AMP,
    ACTIONS(9163), 1,
      anon_sym_DOT,
    STATE(4574), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8024), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5999), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8542), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8556), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [175988] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9426), 1,
      anon_sym_COMMA,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9438), 1,
      anon_sym_PIPE,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9454), 1,
      anon_sym_QMARK,
    ACTIONS(9458), 1,
      anon_sym_bitor,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    ACTIONS(9643), 1,
      anon_sym_COLON,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9434), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9436), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9440), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [176084] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    ACTIONS(9645), 1,
      anon_sym_RBRACK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [176177] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9647), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [176270] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(8572), 1,
      anon_sym_STAR,
    ACTIONS(8574), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8576), 1,
      anon_sym_AMP,
    STATE(3498), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7489), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7418), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [176343] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8578), 1,
      anon_sym_STAR,
    ACTIONS(8580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8582), 1,
      anon_sym_AMP,
    STATE(3994), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7553), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6068), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6777), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [176416] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9649), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [176509] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(9468), 1,
      anon_sym_LBRACE,
    STATE(5686), 1,
      sym_enumerator_list,
    STATE(5838), 1,
      sym_attribute_specifier,
    ACTIONS(3715), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3717), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [176564] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    STATE(2582), 1,
      sym_alignas_qualifier,
    ACTIONS(8154), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9185), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    STATE(5452), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8150), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(9183), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [176621] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5929), 1,
      anon_sym_RBRACK,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [176714] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8888), 1,
      anon_sym_STAR,
    ACTIONS(8890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8892), 1,
      anon_sym_AMP,
    ACTIONS(8898), 1,
      anon_sym_DOT,
    STATE(4083), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8133), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6029), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8542), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8538), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [176791] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9651), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [176884] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      sym_primitive_type,
    STATE(4912), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8787), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3781), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(3778), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [176937] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 1,
      anon_sym_RBRACK,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [177030] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6066), 1,
      anon_sym_RBRACK,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [177123] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9653), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [177216] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9655), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [177309] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9657), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [177402] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9659), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [177495] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8578), 1,
      anon_sym_STAR,
    ACTIONS(8580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8582), 1,
      anon_sym_AMP,
    STATE(3994), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7547), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6068), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8902), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [177568] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9661), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [177661] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9663), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [177754] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9665), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [177847] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9667), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [177940] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    STATE(2582), 1,
      sym_alignas_qualifier,
    ACTIONS(8154), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8684), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    STATE(5452), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8150), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8682), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [177997] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6050), 1,
      anon_sym_RBRACK,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [178090] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    ACTIONS(9669), 1,
      anon_sym_RBRACK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [178183] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9438), 1,
      anon_sym_PIPE,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9454), 1,
      anon_sym_QMARK,
    ACTIONS(9458), 1,
      anon_sym_bitor,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    ACTIONS(9671), 1,
      anon_sym_COLON,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9434), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9436), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9440), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [178276] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8888), 1,
      anon_sym_STAR,
    ACTIONS(8890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8892), 1,
      anon_sym_AMP,
    ACTIONS(8898), 1,
      anon_sym_DOT,
    STATE(4083), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8136), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6026), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8542), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8556), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [178353] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(8572), 1,
      anon_sym_STAR,
    ACTIONS(8574), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8576), 1,
      anon_sym_AMP,
    STATE(3498), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7484), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8842), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [178426] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5842), 1,
      anon_sym_RBRACK,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [178519] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8578), 1,
      anon_sym_STAR,
    ACTIONS(8580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8582), 1,
      anon_sym_AMP,
    STATE(3994), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7555), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6068), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8842), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [178592] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5957), 1,
      anon_sym_RBRACK,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [178685] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9673), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [178778] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9675), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [178871] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    ACTIONS(9677), 1,
      anon_sym_RBRACK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [178964] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8578), 1,
      anon_sym_STAR,
    ACTIONS(8580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8582), 1,
      anon_sym_AMP,
    STATE(3994), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7564), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6068), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7418), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [179037] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5947), 1,
      anon_sym_RBRACK,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [179130] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9679), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [179223] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5993), 1,
      anon_sym_RBRACK,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [179316] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(9468), 1,
      anon_sym_LBRACE,
    STATE(5749), 1,
      sym_enumerator_list,
    STATE(5762), 1,
      sym_attribute_specifier,
    ACTIONS(3711), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3713), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [179371] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5995), 1,
      anon_sym_RBRACK,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [179464] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9681), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [179557] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9683), 1,
      sym_identifier,
    ACTIONS(9688), 1,
      sym_primitive_type,
    STATE(5481), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9686), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3822), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(3820), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [179612] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7514), 1,
      anon_sym_DASH_GT,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7518), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9690), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5885), 1,
      sym_ref_qualifier,
    STATE(6570), 1,
      sym__function_attributes_end,
    STATE(6779), 1,
      sym_trailing_return_type,
    STATE(7220), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7473), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6189), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [179701] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6013), 1,
      anon_sym_RBRACK,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [179794] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5871), 1,
      anon_sym_RBRACK,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [179887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7021), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(7019), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [179934] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9693), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [180027] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5900), 1,
      anon_sym_RBRACK,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [180120] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9211), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [180213] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5969), 1,
      anon_sym_RBRACK,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [180306] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6922), 1,
      sym_literal_suffix,
    ACTIONS(6594), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
    ACTIONS(6596), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [180355] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8790), 1,
      anon_sym_LT,
    STATE(5082), 1,
      sym_template_argument_list,
    ACTIONS(2347), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2349), 27,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [180408] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9695), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [180501] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9697), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [180594] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9699), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [180687] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9701), 1,
      anon_sym_COMMA,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [180780] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8790), 1,
      anon_sym_LT,
    STATE(5082), 1,
      sym_template_argument_list,
    STATE(5710), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9249), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2123), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2115), 24,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [180837] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9703), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [180930] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8790), 1,
      anon_sym_LT,
    STATE(5082), 1,
      sym_template_argument_list,
    ACTIONS(2176), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2169), 27,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [180983] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    ACTIONS(9705), 1,
      anon_sym_RBRACK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [181076] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9707), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [181169] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9709), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [181262] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9711), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [181355] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9713), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [181448] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9715), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [181541] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9717), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [181634] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7061), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(7059), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [181681] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9438), 1,
      anon_sym_PIPE,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9454), 1,
      anon_sym_QMARK,
    ACTIONS(9458), 1,
      anon_sym_bitor,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    ACTIONS(9719), 1,
      anon_sym_COLON,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9434), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9436), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9440), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [181774] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    ACTIONS(9143), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9721), 1,
      anon_sym_RBRACK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [181867] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6052), 1,
      anon_sym_RBRACK,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [181960] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9723), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [182053] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_RBRACK,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [182146] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9725), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [182239] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6922), 1,
      sym_literal_suffix,
    ACTIONS(2117), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(2128), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
  [182288] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9727), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [182381] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9729), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [182474] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9731), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [182567] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8562), 1,
      anon_sym_STAR,
    ACTIONS(8564), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8566), 1,
      anon_sym_AMP,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7470), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8902), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [182640] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8562), 1,
      anon_sym_STAR,
    ACTIONS(8564), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8566), 1,
      anon_sym_AMP,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7477), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6777), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [182713] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9733), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [182806] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9735), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [182899] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9737), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [182992] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9438), 1,
      anon_sym_PIPE,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9454), 1,
      anon_sym_QMARK,
    ACTIONS(9458), 1,
      anon_sym_bitor,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    ACTIONS(9739), 1,
      anon_sym_COLON,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9434), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9436), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9440), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [183085] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8562), 1,
      anon_sym_STAR,
    ACTIONS(8564), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8566), 1,
      anon_sym_AMP,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7481), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8842), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [183158] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(8572), 1,
      anon_sym_STAR,
    ACTIONS(8574), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8576), 1,
      anon_sym_AMP,
    STATE(3498), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7546), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6777), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [183231] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9741), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [183324] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9438), 1,
      anon_sym_PIPE,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9454), 1,
      anon_sym_QMARK,
    ACTIONS(9458), 1,
      anon_sym_bitor,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    ACTIONS(9743), 1,
      anon_sym_COLON,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9434), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9436), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9440), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [183417] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9745), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [183510] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9747), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [183603] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9749), 1,
      anon_sym_COMMA,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [183696] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8562), 1,
      anon_sym_STAR,
    ACTIONS(8564), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8566), 1,
      anon_sym_AMP,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7483), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7418), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [183769] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5967), 1,
      anon_sym_RBRACK,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [183862] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6970), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6972), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [183909] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9751), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [184002] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    ACTIONS(9753), 1,
      anon_sym_RBRACK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [184095] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9755), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [184188] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9757), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [184281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7428), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(7426), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
  [184328] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9759), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [184421] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9761), 1,
      anon_sym_RBRACE,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [184514] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5965), 1,
      anon_sym_RBRACK,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [184607] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7514), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9690), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9766), 1,
      anon_sym_requires,
    ACTIONS(9769), 1,
      anon_sym_where,
    STATE(5884), 1,
      sym_ref_qualifier,
    STATE(6534), 1,
      sym__function_attributes_end,
    STATE(6888), 1,
      sym_trailing_return_type,
    STATE(7220), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9763), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7144), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6185), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [184696] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9772), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [184789] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9774), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [184882] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5920), 1,
      anon_sym_RBRACK,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [184975] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    ACTIONS(9776), 1,
      anon_sym_RBRACK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [185068] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9432), 1,
      anon_sym_SLASH,
    ACTIONS(9438), 1,
      anon_sym_PIPE,
    ACTIONS(9442), 1,
      anon_sym_AMP,
    ACTIONS(9448), 1,
      anon_sym_GT_EQ,
    ACTIONS(9454), 1,
      anon_sym_QMARK,
    ACTIONS(9458), 1,
      anon_sym_bitor,
    ACTIONS(9460), 1,
      anon_sym_bitand,
    ACTIONS(9778), 1,
      anon_sym_COLON,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(7859), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9428), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9430), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9434), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9436), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9440), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9450), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9444), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9446), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9456), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [185161] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9780), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [185254] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9782), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [185347] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9784), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [185440] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9786), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [185533] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9788), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [185626] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    ACTIONS(9790), 1,
      anon_sym_RBRACK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [185719] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9792), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [185812] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9794), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [185905] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9796), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [185998] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9798), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [186091] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6048), 1,
      anon_sym_RBRACK,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [186184] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9800), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [186277] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9802), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [186370] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9804), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [186463] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2492), 1,
      sym__fold_operator,
    ACTIONS(9808), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(9806), 25,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [186512] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(8572), 1,
      anon_sym_STAR,
    ACTIONS(8574), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8576), 1,
      anon_sym_AMP,
    STATE(3498), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7530), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8902), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [186585] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    ACTIONS(9810), 1,
      anon_sym_RBRACK,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [186678] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9812), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [186771] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8976), 1,
      anon_sym___attribute__,
    STATE(5854), 1,
      sym_attribute_specifier,
    ACTIONS(3744), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3742), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [186822] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9814), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [186915] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9816), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [187008] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8976), 1,
      anon_sym___attribute__,
    STATE(5802), 1,
      sym_attribute_specifier,
    ACTIONS(3748), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3746), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [187059] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8976), 1,
      anon_sym___attribute__,
    STATE(5858), 1,
      sym_attribute_specifier,
    ACTIONS(3832), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3830), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [187110] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8976), 1,
      anon_sym___attribute__,
    STATE(5847), 1,
      sym_attribute_specifier,
    ACTIONS(3721), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3719), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [187161] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5959), 1,
      anon_sym_RBRACK,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9065), 1,
      anon_sym_SLASH,
    ACTIONS(9071), 1,
      anon_sym_PIPE,
    ACTIONS(9075), 1,
      anon_sym_AMP,
    ACTIONS(9081), 1,
      anon_sym_GT_EQ,
    ACTIONS(9087), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_bitor,
    ACTIONS(9093), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9061), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9063), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9067), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9069), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9073), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9083), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9079), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9089), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [187254] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8976), 1,
      anon_sym___attribute__,
    STATE(5816), 1,
      sym_attribute_specifier,
    ACTIONS(3801), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3799), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [187305] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8976), 1,
      anon_sym___attribute__,
    STATE(5800), 1,
      sym_attribute_specifier,
    ACTIONS(3793), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3791), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [187356] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8976), 1,
      anon_sym___attribute__,
    STATE(5779), 1,
      sym_attribute_specifier,
    ACTIONS(3797), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3795), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [187407] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9818), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [187500] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8976), 1,
      anon_sym___attribute__,
    STATE(5769), 1,
      sym_attribute_specifier,
    ACTIONS(3733), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3731), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [187551] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8976), 1,
      anon_sym___attribute__,
    STATE(5770), 1,
      sym_attribute_specifier,
    ACTIONS(3727), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3725), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [187602] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8976), 1,
      anon_sym___attribute__,
    STATE(5771), 1,
      sym_attribute_specifier,
    ACTIONS(3737), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3735), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [187653] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8976), 1,
      anon_sym___attribute__,
    STATE(5792), 1,
      sym_attribute_specifier,
    ACTIONS(3838), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3836), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [187704] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8976), 1,
      anon_sym___attribute__,
    STATE(5833), 1,
      sym_attribute_specifier,
    ACTIONS(3842), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3840), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [187755] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9820), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [187848] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9822), 1,
      anon_sym_SEMI,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [187941] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9824), 1,
      anon_sym_RPAREN,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [188034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7051), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(7049), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [188081] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9826), 1,
      anon_sym_COMMA,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [188174] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9828), 1,
      anon_sym_COMMA,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [188267] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9830), 1,
      anon_sym_COMMA,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [188360] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    ACTIONS(9832), 1,
      anon_sym_COMMA,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [188453] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    ACTIONS(9834), 1,
      sym_identifier,
    ACTIONS(9836), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9840), 1,
      sym_primitive_type,
    ACTIONS(9842), 1,
      anon_sym_enum,
    ACTIONS(9844), 1,
      anon_sym_class,
    ACTIONS(9846), 1,
      anon_sym_struct,
    ACTIONS(9848), 1,
      anon_sym_union,
    ACTIONS(9852), 1,
      anon_sym_decltype,
    ACTIONS(9854), 1,
      anon_sym_typename,
    ACTIONS(9856), 1,
      anon_sym_interface,
    ACTIONS(9858), 1,
      anon_sym_extension,
    STATE(3203), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3415), 1,
      sym_type_specifier,
    STATE(3668), 1,
      sym_qualified_type_identifier,
    STATE(6005), 1,
      sym_argument_list,
    STATE(8075), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3562), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9850), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9838), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3599), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [188541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7130), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7132), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [188587] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5622), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9860), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2854), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2856), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [188637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7078), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7080), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [188683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7246), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7248), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [188729] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8618), 1,
      anon_sym_STAR,
    ACTIONS(8620), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8622), 1,
      anon_sym_AMP,
    STATE(3764), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7622), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7418), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [188801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7262), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7264), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [188847] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8618), 1,
      anon_sym_STAR,
    ACTIONS(8620), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8622), 1,
      anon_sym_AMP,
    STATE(3764), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7646), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8842), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [188919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7104), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7106), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [188965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7108), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7110), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [189011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7138), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7140), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [189057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6138), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6136), 26,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [189103] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8618), 1,
      anon_sym_STAR,
    ACTIONS(8620), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8622), 1,
      anon_sym_AMP,
    STATE(3764), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7623), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6777), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [189175] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5665), 1,
      sym_alignas_qualifier,
    ACTIONS(9866), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8513), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8511), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9863), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [189229] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9869), 1,
      anon_sym_LT,
    STATE(5082), 1,
      sym_template_argument_list,
    ACTIONS(2176), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2169), 27,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [189281] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9871), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6204), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6206), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [189329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7146), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7148), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [189375] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8618), 1,
      anon_sym_STAR,
    ACTIONS(8620), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8622), 1,
      anon_sym_AMP,
    STATE(3764), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7668), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8902), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [189447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7150), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7152), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [189493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7214), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7216), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [189539] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(4883), 1,
      anon_sym_LPAREN2,
    ACTIONS(4885), 1,
      anon_sym_STAR,
    ACTIONS(4887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4889), 1,
      anon_sym_AMP,
    ACTIONS(6140), 1,
      sym_identifier,
    ACTIONS(6775), 1,
      anon_sym_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8834), 1,
      anon_sym_RPAREN,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(6961), 1,
      sym__scope_resolution,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7857), 1,
      sym__declarator,
    STATE(8219), 1,
      sym__abstract_declarator,
    STATE(10814), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [189625] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7679), 1,
      sym_primitive_type,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    ACTIONS(9873), 1,
      sym_identifier,
    ACTIONS(9875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9877), 1,
      anon_sym_enum,
    ACTIONS(9879), 1,
      anon_sym_class,
    ACTIONS(9881), 1,
      anon_sym_struct,
    ACTIONS(9883), 1,
      anon_sym_union,
    ACTIONS(9885), 1,
      anon_sym_typename,
    ACTIONS(9887), 1,
      anon_sym_interface,
    ACTIONS(9889), 1,
      anon_sym_extension,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(4828), 1,
      sym_type_specifier,
    STATE(5979), 1,
      sym_argument_list,
    STATE(8113), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [189713] = 9,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2647), 1,
      sym_alignas_qualifier,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6037), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6099), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6982), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(8682), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(6142), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8684), 12,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [189771] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    ACTIONS(9891), 1,
      sym_identifier,
    STATE(6412), 1,
      sym_ms_call_modifier,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7111), 1,
      sym__declarator,
    STATE(8563), 1,
      sym_type_hinted_declarator,
    STATE(9099), 1,
      sym_init_declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [189855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3204), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3206), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [189901] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7679), 1,
      sym_primitive_type,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    ACTIONS(9873), 1,
      sym_identifier,
    ACTIONS(9875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9877), 1,
      anon_sym_enum,
    ACTIONS(9879), 1,
      anon_sym_class,
    ACTIONS(9881), 1,
      anon_sym_struct,
    ACTIONS(9883), 1,
      anon_sym_union,
    ACTIONS(9885), 1,
      anon_sym_typename,
    ACTIONS(9887), 1,
      anon_sym_interface,
    ACTIONS(9889), 1,
      anon_sym_extension,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(4843), 1,
      sym_type_specifier,
    STATE(5963), 1,
      sym_argument_list,
    STATE(8113), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [189989] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    ACTIONS(9893), 1,
      sym_identifier,
    ACTIONS(9895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9899), 1,
      sym_primitive_type,
    ACTIONS(9901), 1,
      anon_sym_enum,
    ACTIONS(9903), 1,
      anon_sym_class,
    ACTIONS(9905), 1,
      anon_sym_struct,
    ACTIONS(9907), 1,
      anon_sym_union,
    ACTIONS(9911), 1,
      anon_sym_decltype,
    ACTIONS(9913), 1,
      anon_sym_typename,
    ACTIONS(9915), 1,
      anon_sym_interface,
    ACTIONS(9917), 1,
      anon_sym_extension,
    STATE(3343), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3524), 1,
      sym_type_specifier,
    STATE(3821), 1,
      sym_qualified_type_identifier,
    STATE(5969), 1,
      sym_argument_list,
    STATE(8115), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3759), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9909), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9897), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3860), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [190077] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2740), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2742), 26,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [190125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7228), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [190171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7258), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7260), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [190217] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    ACTIONS(9893), 1,
      sym_identifier,
    ACTIONS(9895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9899), 1,
      sym_primitive_type,
    ACTIONS(9901), 1,
      anon_sym_enum,
    ACTIONS(9903), 1,
      anon_sym_class,
    ACTIONS(9905), 1,
      anon_sym_struct,
    ACTIONS(9907), 1,
      anon_sym_union,
    ACTIONS(9911), 1,
      anon_sym_decltype,
    ACTIONS(9913), 1,
      anon_sym_typename,
    ACTIONS(9915), 1,
      anon_sym_interface,
    ACTIONS(9917), 1,
      anon_sym_extension,
    STATE(3343), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3513), 1,
      sym_type_specifier,
    STATE(3821), 1,
      sym_qualified_type_identifier,
    STATE(5907), 1,
      sym_argument_list,
    STATE(8115), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3759), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9909), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9897), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3860), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [190305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7088), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7090), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [190351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7234), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7236), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [190397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7230), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7232), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [190443] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    STATE(5824), 1,
      sym_attribute_specifier,
    ACTIONS(3791), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3793), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [190493] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8962), 1,
      anon_sym_DOT,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8144), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6043), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8530), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8556), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [190569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7096), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7098), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [190615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7116), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7118), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [190661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7182), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7184), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [190707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7250), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7252), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [190753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7204), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7206), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [190799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7210), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7212), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [190845] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    STATE(5805), 1,
      sym_attribute_specifier,
    ACTIONS(3799), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3801), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [190895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7126), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7128), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [190941] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8970), 1,
      anon_sym_STAR,
    ACTIONS(8972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8974), 1,
      anon_sym_AMP,
    ACTIONS(8982), 1,
      anon_sym_DOT,
    ACTIONS(9004), 1,
      sym_identifier,
    STATE(4302), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8198), 1,
      sym__abstract_declarator,
    ACTIONS(8608), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6047), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8556), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(8984), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8462), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [191017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6134), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6132), 26,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [191063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7112), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7114), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [191109] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8598), 1,
      anon_sym_STAR,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_AMP,
    STATE(4356), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7694), 1,
      sym__abstract_declarator,
    ACTIONS(8608), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8902), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(9919), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8462), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [191181] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7254), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7256), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [191227] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(285), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3803), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9921), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3805), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [191277] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8592), 1,
      anon_sym_STAR,
    ACTIONS(8594), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8596), 1,
      anon_sym_AMP,
    STATE(4240), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7679), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6068), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8842), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [191349] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2165), 1,
      anon_sym_SEMI,
    ACTIONS(6592), 1,
      sym_literal_suffix,
    ACTIONS(2128), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
    ACTIONS(2117), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [191399] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8598), 1,
      anon_sym_STAR,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_AMP,
    STATE(4356), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7697), 1,
      sym__abstract_declarator,
    ACTIONS(8608), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6777), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(6779), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8462), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [191471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7200), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7202), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [191517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7192), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7194), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [191563] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9923), 1,
      anon_sym___attribute__,
    STATE(5675), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(9565), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9563), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [191613] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7679), 1,
      sym_primitive_type,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    ACTIONS(9873), 1,
      sym_identifier,
    ACTIONS(9875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9877), 1,
      anon_sym_enum,
    ACTIONS(9879), 1,
      anon_sym_class,
    ACTIONS(9881), 1,
      anon_sym_struct,
    ACTIONS(9883), 1,
      anon_sym_union,
    ACTIONS(9885), 1,
      anon_sym_typename,
    ACTIONS(9887), 1,
      anon_sym_interface,
    ACTIONS(9889), 1,
      anon_sym_extension,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(4748), 1,
      sym_type_specifier,
    STATE(5959), 1,
      sym_argument_list,
    STATE(8113), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [191701] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    STATE(212), 1,
      sym_template_argument_list,
    STATE(5728), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2115), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9233), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2123), 27,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [191757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2824), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2826), 26,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [191803] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8970), 1,
      anon_sym_STAR,
    ACTIONS(8972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8974), 1,
      anon_sym_AMP,
    ACTIONS(8980), 1,
      sym_identifier,
    ACTIONS(8982), 1,
      anon_sym_DOT,
    STATE(4302), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8193), 1,
      sym__abstract_declarator,
    ACTIONS(8608), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6048), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8538), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(8984), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8462), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [191879] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    ACTIONS(9891), 1,
      sym_identifier,
    STATE(6452), 1,
      sym_ms_call_modifier,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7090), 1,
      sym__declarator,
    STATE(8562), 1,
      sym_type_hinted_declarator,
    STATE(9637), 1,
      sym_init_declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [191963] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    STATE(5804), 1,
      sym_attribute_specifier,
    ACTIONS(3840), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3842), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [192013] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    ACTIONS(9891), 1,
      sym_identifier,
    STATE(6357), 1,
      sym_ms_call_modifier,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7137), 1,
      sym__declarator,
    STATE(8532), 1,
      sym_type_hinted_declarator,
    STATE(9152), 1,
      sym_init_declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [192097] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT,
    ACTIONS(8706), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_SLASH,
    ACTIONS(8932), 1,
      anon_sym_PIPE,
    ACTIONS(8936), 1,
      anon_sym_AMP,
    ACTIONS(8942), 1,
      anon_sym_GT_EQ,
    ACTIONS(8948), 1,
      anon_sym_QMARK,
    ACTIONS(8952), 1,
      anon_sym_bitor,
    ACTIONS(8954), 1,
      anon_sym_bitand,
    STATE(3288), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym_subscript_argument_list,
    ACTIONS(6994), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8470), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8922), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8924), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8928), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8930), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8934), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8944), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8938), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8940), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8950), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [192187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7266), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7268), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [192233] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8598), 1,
      anon_sym_STAR,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_AMP,
    STATE(4356), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7698), 1,
      sym__abstract_declarator,
    ACTIONS(8608), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8842), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(9926), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8462), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [192305] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    STATE(5807), 1,
      sym_attribute_specifier,
    ACTIONS(3836), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3838), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [192355] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8598), 1,
      anon_sym_STAR,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_AMP,
    STATE(4356), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7700), 1,
      sym__abstract_declarator,
    ACTIONS(8608), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7418), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(7420), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8462), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [192427] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    STATE(5760), 1,
      sym_attribute_specifier,
    ACTIONS(3719), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3721), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [192477] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9869), 1,
      anon_sym_LT,
    STATE(5082), 1,
      sym_template_argument_list,
    ACTIONS(2347), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2349), 27,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [192529] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    STATE(5846), 1,
      sym_attribute_specifier,
    ACTIONS(3742), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3744), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [192579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2534), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2536), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [192625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7172), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [192671] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    STATE(428), 1,
      sym_attribute_specifier,
    STATE(6083), 1,
      sym_field_declaration_list,
    STATE(8776), 1,
      sym_virtual_specifier,
    STATE(9777), 1,
      sym_base_class_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2683), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2685), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [192733] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3390), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3392), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [192779] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    ACTIONS(9891), 1,
      sym_identifier,
    STATE(6386), 1,
      sym_ms_call_modifier,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7150), 1,
      sym__declarator,
    STATE(8585), 1,
      sym_type_hinted_declarator,
    STATE(9331), 1,
      sym_init_declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [192863] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    STATE(5814), 1,
      sym_attribute_specifier,
    ACTIONS(3746), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3748), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [192913] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5714), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9928), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3766), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(3764), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [192963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7092), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7094), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [193009] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8592), 1,
      anon_sym_STAR,
    ACTIONS(8594), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8596), 1,
      anon_sym_AMP,
    STATE(4240), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7666), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6068), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7418), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [193081] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5715), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9930), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3773), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(3771), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [193131] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(9468), 1,
      anon_sym_LBRACE,
    ACTIONS(9932), 1,
      anon_sym_COLON,
    STATE(5509), 1,
      sym__enum_base_clause,
    STATE(5688), 1,
      sym_enumerator_list,
    STATE(5862), 1,
      sym_attribute_specifier,
    ACTIONS(3060), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3062), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [193189] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5622), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9934), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3752), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(3750), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [193239] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8592), 1,
      anon_sym_STAR,
    ACTIONS(8594), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8596), 1,
      anon_sym_AMP,
    STATE(4240), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7692), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6068), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8902), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [193311] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(9468), 1,
      anon_sym_LBRACE,
    ACTIONS(9932), 1,
      anon_sym_COLON,
    STATE(5476), 1,
      sym__enum_base_clause,
    STATE(5750), 1,
      sym_enumerator_list,
    STATE(5793), 1,
      sym_attribute_specifier,
    ACTIONS(3348), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3350), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [193369] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2165), 1,
      anon_sym_SEMI,
    ACTIONS(6165), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6602), 1,
      anon_sym_LPAREN2,
    ACTIONS(6605), 1,
      anon_sym_LBRACK,
    ACTIONS(2128), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(2117), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [193423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3402), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3404), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [193469] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    ACTIONS(9891), 1,
      sym_identifier,
    STATE(6364), 1,
      sym_ms_call_modifier,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7204), 1,
      sym__declarator,
    STATE(8559), 1,
      sym_type_hinted_declarator,
    STATE(9238), 1,
      sym_init_declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [193553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7222), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7224), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [193599] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    ACTIONS(9936), 1,
      sym_identifier,
    ACTIONS(9938), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9942), 1,
      sym_primitive_type,
    ACTIONS(9944), 1,
      anon_sym_enum,
    ACTIONS(9946), 1,
      anon_sym_class,
    ACTIONS(9948), 1,
      anon_sym_struct,
    ACTIONS(9950), 1,
      anon_sym_union,
    ACTIONS(9954), 1,
      anon_sym_decltype,
    ACTIONS(9956), 1,
      anon_sym_typename,
    ACTIONS(9958), 1,
      anon_sym_interface,
    ACTIONS(9960), 1,
      anon_sym_extension,
    STATE(4648), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4865), 1,
      sym_type_specifier,
    STATE(5075), 1,
      sym_qualified_type_identifier,
    STATE(5914), 1,
      sym_argument_list,
    STATE(8098), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(4962), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9952), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9940), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5072), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [193687] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5622), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9934), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3759), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(3757), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [193737] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5722), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3392), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9962), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3390), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [193787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7160), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [193833] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    ACTIONS(9936), 1,
      sym_identifier,
    ACTIONS(9938), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9942), 1,
      sym_primitive_type,
    ACTIONS(9944), 1,
      anon_sym_enum,
    ACTIONS(9946), 1,
      anon_sym_class,
    ACTIONS(9948), 1,
      anon_sym_struct,
    ACTIONS(9950), 1,
      anon_sym_union,
    ACTIONS(9954), 1,
      anon_sym_decltype,
    ACTIONS(9956), 1,
      anon_sym_typename,
    ACTIONS(9958), 1,
      anon_sym_interface,
    ACTIONS(9960), 1,
      anon_sym_extension,
    STATE(4648), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4879), 1,
      sym_type_specifier,
    STATE(5075), 1,
      sym_qualified_type_identifier,
    STATE(5954), 1,
      sym_argument_list,
    STATE(8098), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(4962), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9952), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9940), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5072), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [193921] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5622), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9934), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3812), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(3810), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [193971] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5622), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9934), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3805), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(3803), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [194021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5418), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3834), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [194067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2128), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2117), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [194113] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5702), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9964), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3390), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(3392), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [194163] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    ACTIONS(9966), 1,
      sym_identifier,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9972), 1,
      sym_primitive_type,
    ACTIONS(9974), 1,
      anon_sym_enum,
    ACTIONS(9976), 1,
      anon_sym_class,
    ACTIONS(9978), 1,
      anon_sym_struct,
    ACTIONS(9980), 1,
      anon_sym_union,
    ACTIONS(9984), 1,
      anon_sym_decltype,
    ACTIONS(9986), 1,
      anon_sym_typename,
    ACTIONS(9988), 1,
      anon_sym_interface,
    ACTIONS(9990), 1,
      anon_sym_extension,
    STATE(2951), 1,
      sym_type_specifier,
    STATE(3011), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3091), 1,
      sym_qualified_type_identifier,
    STATE(5871), 1,
      sym_argument_list,
    STATE(8070), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3000), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9982), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9970), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3060), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [194251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7178), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7180), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [194297] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    ACTIONS(9966), 1,
      sym_identifier,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9972), 1,
      sym_primitive_type,
    ACTIONS(9974), 1,
      anon_sym_enum,
    ACTIONS(9976), 1,
      anon_sym_class,
    ACTIONS(9978), 1,
      anon_sym_struct,
    ACTIONS(9980), 1,
      anon_sym_union,
    ACTIONS(9984), 1,
      anon_sym_decltype,
    ACTIONS(9986), 1,
      anon_sym_typename,
    ACTIONS(9988), 1,
      anon_sym_interface,
    ACTIONS(9990), 1,
      anon_sym_extension,
    STATE(2946), 1,
      sym_type_specifier,
    STATE(3011), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3091), 1,
      sym_qualified_type_identifier,
    STATE(5868), 1,
      sym_argument_list,
    STATE(8070), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3000), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9982), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9970), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3060), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [194385] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(285), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3750), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9921), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3752), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [194435] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    ACTIONS(9891), 1,
      sym_identifier,
    STATE(6431), 1,
      sym_ms_call_modifier,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7166), 1,
      sym__declarator,
    STATE(8555), 1,
      sym_type_hinted_declarator,
    STATE(9615), 1,
      sym_init_declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [194519] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    STATE(5820), 1,
      sym_attribute_specifier,
    ACTIONS(3735), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3737), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [194569] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    STATE(5797), 1,
      sym_attribute_specifier,
    ACTIONS(3830), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3832), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [194619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7174), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7176), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [194665] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    ACTIONS(9992), 1,
      sym_identifier,
    ACTIONS(9994), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9998), 1,
      sym_primitive_type,
    ACTIONS(10000), 1,
      anon_sym_enum,
    ACTIONS(10002), 1,
      anon_sym_class,
    ACTIONS(10004), 1,
      anon_sym_struct,
    ACTIONS(10006), 1,
      anon_sym_union,
    ACTIONS(10010), 1,
      anon_sym_decltype,
    ACTIONS(10012), 1,
      anon_sym_typename,
    ACTIONS(10014), 1,
      anon_sym_interface,
    ACTIONS(10016), 1,
      anon_sym_extension,
    STATE(3812), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4622), 1,
      sym_type_specifier,
    STATE(4761), 1,
      sym_qualified_type_identifier,
    STATE(5933), 1,
      sym_argument_list,
    STATE(8035), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(4752), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10008), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9996), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4771), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [194753] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(285), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3757), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9921), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3759), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [194803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7102), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [194849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5010), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5006), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [194895] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    STATE(5834), 1,
      sym_attribute_specifier,
    ACTIONS(3725), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3727), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [194945] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(285), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3810), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9921), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3812), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [194995] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5732), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3764), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(10018), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3766), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [195045] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5669), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3771), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(10020), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3773), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [195095] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    ACTIONS(9992), 1,
      sym_identifier,
    ACTIONS(9994), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9998), 1,
      sym_primitive_type,
    ACTIONS(10000), 1,
      anon_sym_enum,
    ACTIONS(10002), 1,
      anon_sym_class,
    ACTIONS(10004), 1,
      anon_sym_struct,
    ACTIONS(10006), 1,
      anon_sym_union,
    ACTIONS(10010), 1,
      anon_sym_decltype,
    ACTIONS(10012), 1,
      anon_sym_typename,
    ACTIONS(10014), 1,
      anon_sym_interface,
    ACTIONS(10016), 1,
      anon_sym_extension,
    STATE(3812), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4639), 1,
      sym_type_specifier,
    STATE(4761), 1,
      sym_qualified_type_identifier,
    STATE(5934), 1,
      sym_argument_list,
    STATE(8035), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(4752), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10008), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9996), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4771), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [195183] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9869), 1,
      anon_sym_LT,
    STATE(5082), 1,
      sym_template_argument_list,
    ACTIONS(2349), 3,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_const,
    ACTIONS(2347), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [195235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2489), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2491), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [195281] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    ACTIONS(9891), 1,
      sym_identifier,
    STATE(6402), 1,
      sym_ms_call_modifier,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7116), 1,
      sym__declarator,
    STATE(8586), 1,
      sym_type_hinted_declarator,
    STATE(9172), 1,
      sym_init_declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [195365] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    ACTIONS(10022), 1,
      sym_identifier,
    ACTIONS(10024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10028), 1,
      sym_primitive_type,
    ACTIONS(10030), 1,
      anon_sym_enum,
    ACTIONS(10032), 1,
      anon_sym_class,
    ACTIONS(10034), 1,
      anon_sym_struct,
    ACTIONS(10036), 1,
      anon_sym_union,
    ACTIONS(10040), 1,
      anon_sym_decltype,
    ACTIONS(10042), 1,
      anon_sym_typename,
    ACTIONS(10044), 1,
      anon_sym_interface,
    ACTIONS(10046), 1,
      anon_sym_extension,
    STATE(3153), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3409), 1,
      sym_type_specifier,
    STATE(3588), 1,
      sym_qualified_type_identifier,
    STATE(5918), 1,
      sym_argument_list,
    STATE(8107), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3490), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10038), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10026), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3516), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [195453] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9976), 1,
      anon_sym_class,
    ACTIONS(9978), 1,
      anon_sym_struct,
    ACTIONS(9980), 1,
      anon_sym_union,
    ACTIONS(9984), 1,
      anon_sym_decltype,
    ACTIONS(9988), 1,
      anon_sym_interface,
    ACTIONS(9990), 1,
      anon_sym_extension,
    ACTIONS(10048), 1,
      sym_identifier,
    ACTIONS(10052), 1,
      sym_primitive_type,
    ACTIONS(10054), 1,
      anon_sym_enum,
    ACTIONS(10056), 1,
      anon_sym_typename,
    STATE(2951), 1,
      sym_type_specifier,
    STATE(3003), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3091), 1,
      sym_qualified_type_identifier,
    STATE(5886), 1,
      sym_argument_list,
    STATE(8070), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3000), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9982), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10050), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3060), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [195541] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9869), 1,
      anon_sym_LT,
    STATE(5032), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5082), 1,
      sym_template_argument_list,
    ACTIONS(2115), 3,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_const,
    ACTIONS(6179), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2123), 27,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [195597] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9869), 1,
      anon_sym_LT,
    STATE(5082), 1,
      sym_template_argument_list,
    ACTIONS(2169), 3,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_const,
    ACTIONS(2176), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [195649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7242), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7244), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [195695] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8838), 4,
      anon_sym_AMP,
      sym_ms_restrict_modifier,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8840), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [195741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8818), 4,
      anon_sym_AMP,
      sym_ms_restrict_modifier,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8820), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [195787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3174), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3176), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [195833] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7679), 1,
      sym_primitive_type,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    ACTIONS(9873), 1,
      sym_identifier,
    ACTIONS(9875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9877), 1,
      anon_sym_enum,
    ACTIONS(9879), 1,
      anon_sym_class,
    ACTIONS(9881), 1,
      anon_sym_struct,
    ACTIONS(9883), 1,
      anon_sym_union,
    ACTIONS(9885), 1,
      anon_sym_typename,
    ACTIONS(9887), 1,
      anon_sym_interface,
    ACTIONS(9889), 1,
      anon_sym_extension,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(4759), 1,
      sym_type_specifier,
    STATE(5951), 1,
      sym_argument_list,
    STATE(8113), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [195921] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(10058), 1,
      anon_sym___attribute__,
    STATE(2932), 1,
      sym_attribute_specifier,
    STATE(6175), 1,
      sym_field_declaration_list,
    STATE(8703), 1,
      sym_virtual_specifier,
    STATE(9667), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2685), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(2683), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [195983] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    STATE(5835), 1,
      sym_attribute_specifier,
    ACTIONS(3731), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3733), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [196033] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    STATE(5840), 1,
      sym_attribute_specifier,
    ACTIONS(3795), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3797), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [196083] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9871), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10060), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(6192), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6194), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [196133] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9976), 1,
      anon_sym_class,
    ACTIONS(9978), 1,
      anon_sym_struct,
    ACTIONS(9980), 1,
      anon_sym_union,
    ACTIONS(9984), 1,
      anon_sym_decltype,
    ACTIONS(9988), 1,
      anon_sym_interface,
    ACTIONS(9990), 1,
      anon_sym_extension,
    ACTIONS(10048), 1,
      sym_identifier,
    ACTIONS(10052), 1,
      sym_primitive_type,
    ACTIONS(10054), 1,
      anon_sym_enum,
    ACTIONS(10056), 1,
      anon_sym_typename,
    STATE(2946), 1,
      sym_type_specifier,
    STATE(3003), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3091), 1,
      sym_qualified_type_identifier,
    STATE(5904), 1,
      sym_argument_list,
    STATE(8070), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3000), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9982), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10050), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3060), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [196221] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8592), 1,
      anon_sym_STAR,
    ACTIONS(8594), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8596), 1,
      anon_sym_AMP,
    STATE(4240), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7676), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6068), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6777), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [196293] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    ACTIONS(9834), 1,
      sym_identifier,
    ACTIONS(9836), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9840), 1,
      sym_primitive_type,
    ACTIONS(9842), 1,
      anon_sym_enum,
    ACTIONS(9844), 1,
      anon_sym_class,
    ACTIONS(9846), 1,
      anon_sym_struct,
    ACTIONS(9848), 1,
      anon_sym_union,
    ACTIONS(9852), 1,
      anon_sym_decltype,
    ACTIONS(9854), 1,
      anon_sym_typename,
    ACTIONS(9856), 1,
      anon_sym_interface,
    ACTIONS(9858), 1,
      anon_sym_extension,
    STATE(3203), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3418), 1,
      sym_type_specifier,
    STATE(3668), 1,
      sym_qualified_type_identifier,
    STATE(5996), 1,
      sym_argument_list,
    STATE(8075), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3562), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9850), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9838), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3599), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [196381] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8962), 1,
      anon_sym_DOT,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8182), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6034), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8530), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8538), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [196457] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    ACTIONS(10022), 1,
      sym_identifier,
    ACTIONS(10024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10028), 1,
      sym_primitive_type,
    ACTIONS(10030), 1,
      anon_sym_enum,
    ACTIONS(10032), 1,
      anon_sym_class,
    ACTIONS(10034), 1,
      anon_sym_struct,
    ACTIONS(10036), 1,
      anon_sym_union,
    ACTIONS(10040), 1,
      anon_sym_decltype,
    ACTIONS(10042), 1,
      anon_sym_typename,
    ACTIONS(10044), 1,
      anon_sym_interface,
    ACTIONS(10046), 1,
      anon_sym_extension,
    STATE(3153), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3404), 1,
      sym_type_specifier,
    STATE(3588), 1,
      sym_qualified_type_identifier,
    STATE(5869), 1,
      sym_argument_list,
    STATE(8107), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3490), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10038), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10026), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3516), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [196545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3388), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3386), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [196590] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8558), 1,
      anon_sym_DOT,
    ACTIONS(3890), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8560), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3892), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [196639] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(8692), 1,
      anon_sym_STAR,
    ACTIONS(8694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8696), 1,
      anon_sym_AMP,
    STATE(4454), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7776), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8902), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [196710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3384), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3382), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [196755] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(9095), 1,
      anon_sym_DOT,
    ACTIONS(9223), 1,
      anon_sym_STAR,
    ACTIONS(9225), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9227), 1,
      anon_sym_AMP,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4588), 1,
      sym_parameter_list,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(8302), 1,
      sym__abstract_declarator,
    ACTIONS(8154), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6108), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8538), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9097), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8150), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [196830] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3358), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3356), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [196875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3392), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3390), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [196920] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(8692), 1,
      anon_sym_STAR,
    ACTIONS(8694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8696), 1,
      anon_sym_AMP,
    STATE(4454), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7763), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7418), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [196991] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(9095), 1,
      anon_sym_DOT,
    ACTIONS(9223), 1,
      anon_sym_STAR,
    ACTIONS(9225), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9227), 1,
      anon_sym_AMP,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4588), 1,
      sym_parameter_list,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(8289), 1,
      sym__abstract_declarator,
    ACTIONS(8154), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6090), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8556), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9097), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8150), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [197066] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(8686), 1,
      anon_sym_STAR,
    ACTIONS(8688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8690), 1,
      anon_sym_AMP,
    STATE(4485), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7869), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7418), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [197137] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(8692), 1,
      anon_sym_STAR,
    ACTIONS(8694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8696), 1,
      anon_sym_AMP,
    STATE(4454), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7711), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8842), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [197208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3202), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [197253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3068), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3070), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [197298] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2946), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2948), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [197343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3100), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3102), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [197388] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(8686), 1,
      anon_sym_STAR,
    ACTIONS(8688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8690), 1,
      anon_sym_AMP,
    STATE(4485), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7872), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8842), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [197459] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(8692), 1,
      anon_sym_STAR,
    ACTIONS(8694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8696), 1,
      anon_sym_AMP,
    STATE(4454), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7768), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6777), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [197530] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DASH_GT,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(7471), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    STATE(6549), 1,
      sym__function_attributes_end,
    STATE(6839), 1,
      sym_trailing_return_type,
    STATE(7196), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7501), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6144), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10062), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [197611] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(8686), 1,
      anon_sym_STAR,
    ACTIONS(8688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8690), 1,
      anon_sym_AMP,
    STATE(4485), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7873), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6777), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [197682] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(8686), 1,
      anon_sym_STAR,
    ACTIONS(8688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8690), 1,
      anon_sym_AMP,
    STATE(4485), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7875), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8902), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [197753] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(4883), 1,
      anon_sym_LPAREN2,
    ACTIONS(4885), 1,
      anon_sym_STAR,
    ACTIONS(4887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4889), 1,
      anon_sym_AMP,
    ACTIONS(6140), 1,
      sym_identifier,
    ACTIONS(6775), 1,
      anon_sym_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_COLON_COLON,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(6961), 1,
      sym__scope_resolution,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8167), 1,
      sym__declarator,
    STATE(8544), 1,
      sym__abstract_declarator,
    STATE(10814), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [197836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3154), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3156), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [197881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3170), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3172), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [197926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3338), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3336), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [197971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2962), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2964), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [198016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3336), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3338), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [198061] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8624), 1,
      anon_sym_STAR,
    ACTIONS(8626), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8628), 1,
      anon_sym_AMP,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4569), 1,
      sym_parameter_list,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7912), 1,
      sym__abstract_declarator,
    ACTIONS(8154), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5452), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8902), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8150), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [198132] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3058), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [198177] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(8962), 1,
      anon_sym_DOT,
    ACTIONS(9197), 1,
      anon_sym_STAR,
    ACTIONS(9199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9201), 1,
      anon_sym_AMP,
    STATE(4541), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8247), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6069), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8530), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8538), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [198252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2998), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3000), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [198297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3338), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3336), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [198342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2994), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2996), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [198387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3052), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3054), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [198432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3150), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3152), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [198477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3098), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [198522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2942), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2944), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [198567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3396), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3394), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [198612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3046), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3048), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [198657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2986), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2988), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [198702] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8624), 1,
      anon_sym_STAR,
    ACTIONS(8626), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8628), 1,
      anon_sym_AMP,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4569), 1,
      sym_parameter_list,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7910), 1,
      sym__abstract_declarator,
    ACTIONS(8154), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5452), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7418), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8150), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [198773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3400), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3398), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [198818] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(7764), 1,
      anon_sym_requires,
    ACTIONS(7766), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9690), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6062), 1,
      sym_ref_qualifier,
    STATE(6749), 1,
      sym__function_attributes_end,
    STATE(6998), 1,
      sym_trailing_return_type,
    STATE(7220), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7850), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6366), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [198905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3404), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3402), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [198950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3080), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3082), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [198995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2740), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [199040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3360), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3362), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [199085] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DASH_GT,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(7471), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(6546), 1,
      sym__function_attributes_end,
    STATE(6850), 1,
      sym_trailing_return_type,
    STATE(7092), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7500), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6150), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [199166] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2908), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [199211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3090), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3088), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [199256] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3176), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3174), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [199301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2942), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [199346] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8558), 1,
      anon_sym_DOT,
    ACTIONS(3848), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8560), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3850), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [199395] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DASH_GT,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10069), 1,
      anon_sym_requires,
    ACTIONS(10072), 1,
      anon_sym_where,
    STATE(6574), 1,
      sym__function_attributes_end,
    STATE(6822), 1,
      sym_trailing_return_type,
    STATE(7196), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10066), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7184), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6125), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10062), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [199476] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3366), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3364), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [199521] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8624), 1,
      anon_sym_STAR,
    ACTIONS(8626), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8628), 1,
      anon_sym_AMP,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4569), 1,
      sym_parameter_list,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7919), 1,
      sym__abstract_declarator,
    ACTIONS(8154), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5452), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8842), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8150), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [199592] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9869), 1,
      anon_sym_LT,
    STATE(5082), 1,
      sym_template_argument_list,
    STATE(5710), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9249), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2123), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2115), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [199647] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DASH_GT,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9519), 1,
      anon_sym_requires,
    ACTIONS(9522), 1,
      anon_sym_where,
    STATE(6573), 1,
      sym__function_attributes_end,
    STATE(6823), 1,
      sym_trailing_return_type,
    STATE(7092), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7182), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6126), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [199728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3362), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3360), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [199773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3204), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [199818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3088), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3090), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [199863] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2165), 1,
      anon_sym_SEMI,
    ACTIONS(2128), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(2117), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [199910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2964), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2962), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [199955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3364), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3366), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [200000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3102), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3100), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [200045] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8624), 1,
      anon_sym_STAR,
    ACTIONS(8626), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8628), 1,
      anon_sym_AMP,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4569), 1,
      sym_parameter_list,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7916), 1,
      sym__abstract_declarator,
    ACTIONS(8154), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5452), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6777), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8150), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [200116] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7777), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9690), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9766), 1,
      anon_sym_requires,
    ACTIONS(10075), 1,
      anon_sym___attribute__,
    ACTIONS(10078), 1,
      anon_sym_where,
    STATE(6033), 1,
      sym_ref_qualifier,
    STATE(6597), 1,
      sym__function_attributes_end,
    STATE(6940), 1,
      sym_trailing_return_type,
    STATE(7220), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9763), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7291), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6395), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [200203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3052), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3054), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [200248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3082), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3080), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [200293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2740), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2742), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [200338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2740), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2742), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [200383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3054), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3052), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [200428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3338), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3336), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [200473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3846), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3844), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [200518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3386), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3388), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [200563] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(9099), 1,
      anon_sym_STAR,
    ACTIONS(9101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9103), 1,
      anon_sym_AMP,
    ACTIONS(9163), 1,
      anon_sym_DOT,
    STATE(4478), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8310), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6106), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8542), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8556), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_GT2,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [200638] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3336), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3338), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [200683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2908), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2910), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [200728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2948), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2946), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [200773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3070), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3068), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [200818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3152), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3150), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [200863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2536), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2534), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [200908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3156), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3154), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [200953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3356), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3358), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [200998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3172), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3170), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [201043] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8712), 1,
      anon_sym_STAR,
    ACTIONS(8714), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8716), 1,
      anon_sym_AMP,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7720), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7418), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [201114] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8712), 1,
      anon_sym_STAR,
    ACTIONS(8714), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8716), 1,
      anon_sym_AMP,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7725), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8842), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [201185] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(8962), 1,
      anon_sym_DOT,
    ACTIONS(9197), 1,
      anon_sym_STAR,
    ACTIONS(9199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9201), 1,
      anon_sym_AMP,
    STATE(4541), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8351), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6101), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8530), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8556), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [201260] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8712), 1,
      anon_sym_STAR,
    ACTIONS(8714), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8716), 1,
      anon_sym_AMP,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7726), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6777), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [201331] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8712), 1,
      anon_sym_STAR,
    ACTIONS(8714), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8716), 1,
      anon_sym_AMP,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7734), 1,
      sym__abstract_declarator,
    ACTIONS(7448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8902), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(7438), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [201402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3190), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [201447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3382), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3384), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [201492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3054), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3052), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [201537] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9690), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10081), 1,
      anon_sym_requires,
    ACTIONS(10084), 1,
      anon_sym_where,
    STATE(6035), 1,
      sym_ref_qualifier,
    STATE(6799), 1,
      sym__function_attributes_end,
    STATE(6977), 1,
      sym_trailing_return_type,
    STATE(7220), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9763), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7391), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6422), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [201624] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(9099), 1,
      anon_sym_STAR,
    ACTIONS(9101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9103), 1,
      anon_sym_AMP,
    ACTIONS(9163), 1,
      anon_sym_DOT,
    STATE(4478), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8327), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6089), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8538), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_GT2,
    ACTIONS(8542), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [201699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2988), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2986), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [201744] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3056), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [201789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3336), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3338), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [201834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3190), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3192), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [201879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2491), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2489), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [201924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3098), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3096), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [201969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2740), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [202014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3398), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3400), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [202059] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9683), 1,
      sym_identifier,
    ACTIONS(9688), 1,
      sym_primitive_type,
    STATE(2906), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7928), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3822), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3820), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [202112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2998), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [202157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3048), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3046), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [202202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3202), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3200), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [202247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2996), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2994), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [202292] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7777), 1,
      anon_sym_DASH_GT,
    ACTIONS(7782), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9690), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10075), 1,
      anon_sym___attribute__,
    STATE(6044), 1,
      sym_ref_qualifier,
    STATE(6680), 1,
      sym__function_attributes_end,
    STATE(6913), 1,
      sym_trailing_return_type,
    STATE(7220), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7602), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6417), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [202379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3394), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3396), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [202424] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6390), 1,
      sym_ms_call_modifier,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7803), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [202502] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9992), 1,
      sym_identifier,
    ACTIONS(9994), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9998), 1,
      sym_primitive_type,
    ACTIONS(10000), 1,
      anon_sym_enum,
    ACTIONS(10002), 1,
      anon_sym_class,
    ACTIONS(10004), 1,
      anon_sym_struct,
    ACTIONS(10006), 1,
      anon_sym_union,
    ACTIONS(10010), 1,
      anon_sym_decltype,
    ACTIONS(10012), 1,
      anon_sym_typename,
    ACTIONS(10014), 1,
      anon_sym_interface,
    ACTIONS(10016), 1,
      anon_sym_extension,
    STATE(3812), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4761), 1,
      sym_qualified_type_identifier,
    STATE(4764), 1,
      sym_type_specifier,
    STATE(8035), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(4752), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10008), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9996), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4771), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [202584] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9966), 1,
      sym_identifier,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9972), 1,
      sym_primitive_type,
    ACTIONS(9974), 1,
      anon_sym_enum,
    ACTIONS(9976), 1,
      anon_sym_class,
    ACTIONS(9978), 1,
      anon_sym_struct,
    ACTIONS(9980), 1,
      anon_sym_union,
    ACTIONS(9984), 1,
      anon_sym_decltype,
    ACTIONS(9986), 1,
      anon_sym_typename,
    ACTIONS(9988), 1,
      anon_sym_interface,
    ACTIONS(9990), 1,
      anon_sym_extension,
    STATE(2952), 1,
      sym_type_specifier,
    STATE(3011), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3091), 1,
      sym_qualified_type_identifier,
    STATE(8070), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3000), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9982), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9970), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3060), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [202666] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(10022), 1,
      sym_identifier,
    ACTIONS(10024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10028), 1,
      sym_primitive_type,
    ACTIONS(10030), 1,
      anon_sym_enum,
    ACTIONS(10032), 1,
      anon_sym_class,
    ACTIONS(10034), 1,
      anon_sym_struct,
    ACTIONS(10036), 1,
      anon_sym_union,
    ACTIONS(10040), 1,
      anon_sym_decltype,
    ACTIONS(10042), 1,
      anon_sym_typename,
    ACTIONS(10044), 1,
      anon_sym_interface,
    ACTIONS(10046), 1,
      anon_sym_extension,
    STATE(3153), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3410), 1,
      sym_type_specifier,
    STATE(3588), 1,
      sym_qualified_type_identifier,
    STATE(8107), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3490), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10038), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10026), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3516), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [202748] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5998), 1,
      sym_type_specifier,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [202830] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9966), 1,
      sym_identifier,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9972), 1,
      sym_primitive_type,
    ACTIONS(9974), 1,
      anon_sym_enum,
    ACTIONS(9976), 1,
      anon_sym_class,
    ACTIONS(9978), 1,
      anon_sym_struct,
    ACTIONS(9980), 1,
      anon_sym_union,
    ACTIONS(9984), 1,
      anon_sym_decltype,
    ACTIONS(9986), 1,
      anon_sym_typename,
    ACTIONS(9988), 1,
      anon_sym_interface,
    ACTIONS(9990), 1,
      anon_sym_extension,
    STATE(2956), 1,
      sym_type_specifier,
    STATE(3011), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3091), 1,
      sym_qualified_type_identifier,
    STATE(8070), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3000), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9982), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9970), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3060), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [202912] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9966), 1,
      sym_identifier,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9972), 1,
      sym_primitive_type,
    ACTIONS(9974), 1,
      anon_sym_enum,
    ACTIONS(9976), 1,
      anon_sym_class,
    ACTIONS(9978), 1,
      anon_sym_struct,
    ACTIONS(9980), 1,
      anon_sym_union,
    ACTIONS(9984), 1,
      anon_sym_decltype,
    ACTIONS(9986), 1,
      anon_sym_typename,
    ACTIONS(9988), 1,
      anon_sym_interface,
    ACTIONS(9990), 1,
      anon_sym_extension,
    STATE(3011), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3091), 1,
      sym_qualified_type_identifier,
    STATE(3380), 1,
      sym_type_specifier,
    STATE(8070), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3000), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9982), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9970), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3060), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [202994] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8042), 1,
      sym_identifier,
    ACTIONS(8044), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8048), 1,
      sym_primitive_type,
    ACTIONS(8050), 1,
      anon_sym_enum,
    ACTIONS(8052), 1,
      anon_sym_class,
    ACTIONS(8054), 1,
      anon_sym_struct,
    ACTIONS(8056), 1,
      anon_sym_union,
    ACTIONS(8058), 1,
      anon_sym_typename,
    ACTIONS(8060), 1,
      anon_sym_interface,
    ACTIONS(8062), 1,
      anon_sym_extension,
    STATE(405), 1,
      sym_qualified_type_identifier,
    STATE(5463), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6333), 1,
      sym_type_specifier,
    STATE(8039), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(121), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8046), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(361), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [203076] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6454), 1,
      sym_ms_call_modifier,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7798), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [203154] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8042), 1,
      sym_identifier,
    ACTIONS(8044), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8048), 1,
      sym_primitive_type,
    ACTIONS(8050), 1,
      anon_sym_enum,
    ACTIONS(8052), 1,
      anon_sym_class,
    ACTIONS(8054), 1,
      anon_sym_struct,
    ACTIONS(8056), 1,
      anon_sym_union,
    ACTIONS(8058), 1,
      anon_sym_typename,
    ACTIONS(8060), 1,
      anon_sym_interface,
    ACTIONS(8062), 1,
      anon_sym_extension,
    STATE(405), 1,
      sym_qualified_type_identifier,
    STATE(5463), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6280), 1,
      sym_type_specifier,
    STATE(8039), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(121), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8046), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(361), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [203236] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(8161), 1,
      sym_identifier,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8165), 1,
      anon_sym_enum,
    ACTIONS(8167), 1,
      anon_sym_class,
    ACTIONS(8169), 1,
      anon_sym_struct,
    ACTIONS(8171), 1,
      anon_sym_union,
    ACTIONS(8173), 1,
      anon_sym_typename,
    ACTIONS(8175), 1,
      anon_sym_interface,
    ACTIONS(8177), 1,
      anon_sym_extension,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(6056), 1,
      sym_type_specifier,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [203318] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(10022), 1,
      sym_identifier,
    ACTIONS(10024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10028), 1,
      sym_primitive_type,
    ACTIONS(10030), 1,
      anon_sym_enum,
    ACTIONS(10032), 1,
      anon_sym_class,
    ACTIONS(10034), 1,
      anon_sym_struct,
    ACTIONS(10036), 1,
      anon_sym_union,
    ACTIONS(10040), 1,
      anon_sym_decltype,
    ACTIONS(10042), 1,
      anon_sym_typename,
    ACTIONS(10044), 1,
      anon_sym_interface,
    ACTIONS(10046), 1,
      anon_sym_extension,
    STATE(3153), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3526), 1,
      sym_type_specifier,
    STATE(3588), 1,
      sym_qualified_type_identifier,
    STATE(8107), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3490), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10038), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10026), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3516), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [203400] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8048), 1,
      sym_primitive_type,
    ACTIONS(10087), 1,
      sym_identifier,
    ACTIONS(10089), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10091), 1,
      anon_sym_enum,
    ACTIONS(10093), 1,
      anon_sym_class,
    ACTIONS(10095), 1,
      anon_sym_struct,
    ACTIONS(10097), 1,
      anon_sym_union,
    ACTIONS(10099), 1,
      anon_sym_typename,
    ACTIONS(10101), 1,
      anon_sym_interface,
    ACTIONS(10103), 1,
      anon_sym_extension,
    STATE(405), 1,
      sym_qualified_type_identifier,
    STATE(5463), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8067), 1,
      sym__scope_resolution,
    STATE(8442), 1,
      sym_type_specifier,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(121), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8046), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(361), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [203482] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8773), 1,
      sym_identifier,
    ACTIONS(8775), 1,
      anon_sym_LPAREN2,
    ACTIONS(8777), 1,
      anon_sym_STAR,
    ACTIONS(8779), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8781), 1,
      anon_sym_AMP,
    ACTIONS(8785), 1,
      sym_primitive_type,
    STATE(3585), 1,
      sym__type_declarator,
    STATE(3956), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(10354), 1,
      sym_ms_based_modifier,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8783), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3959), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [203554] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(8161), 1,
      sym_identifier,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8165), 1,
      anon_sym_enum,
    ACTIONS(8167), 1,
      anon_sym_class,
    ACTIONS(8169), 1,
      anon_sym_struct,
    ACTIONS(8171), 1,
      anon_sym_union,
    ACTIONS(8173), 1,
      anon_sym_typename,
    ACTIONS(8175), 1,
      anon_sym_interface,
    ACTIONS(8177), 1,
      anon_sym_extension,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(6053), 1,
      sym_type_specifier,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [203636] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(203), 1,
      anon_sym_enum,
    ACTIONS(205), 1,
      anon_sym_class,
    ACTIONS(207), 1,
      anon_sym_struct,
    ACTIONS(209), 1,
      anon_sym_union,
    ACTIONS(245), 1,
      anon_sym_decltype,
    ACTIONS(247), 1,
      anon_sym_typename,
    ACTIONS(271), 1,
      anon_sym_interface,
    ACTIONS(273), 1,
      anon_sym_extension,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2409), 1,
      sym_primitive_type,
    ACTIONS(3967), 1,
      sym_identifier,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    STATE(2632), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2718), 1,
      sym_qualified_type_identifier,
    STATE(2901), 1,
      sym_type_specifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(2715), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(243), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(195), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2741), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [203718] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym_LBRACE,
    ACTIONS(10105), 1,
      anon_sym_LPAREN2,
    STATE(4462), 1,
      sym_argument_list,
    STATE(5070), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5743), 1,
      sym_initializer_list,
    ACTIONS(2742), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(8906), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2740), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [203774] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7861), 1,
      sym_identifier,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(7869), 1,
      anon_sym_enum,
    ACTIONS(7871), 1,
      anon_sym_class,
    ACTIONS(7873), 1,
      anon_sym_struct,
    ACTIONS(7875), 1,
      anon_sym_union,
    ACTIONS(7877), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      anon_sym_interface,
    ACTIONS(7881), 1,
      anon_sym_extension,
    STATE(5512), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(6159), 1,
      sym_type_specifier,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7865), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [203856] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7514), 1,
      anon_sym_DASH_GT,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10108), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10114), 1,
      anon_sym_requires,
    ACTIONS(10117), 1,
      anon_sym_where,
    STATE(6545), 1,
      sym__function_attributes_end,
    STATE(6880), 1,
      sym_trailing_return_type,
    STATE(7152), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10111), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7091), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6164), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10062), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [203936] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7514), 1,
      anon_sym_DASH_GT,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7518), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10108), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6563), 1,
      sym__function_attributes_end,
    STATE(6864), 1,
      sym_trailing_return_type,
    STATE(7152), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7560), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6176), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10062), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [204016] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9976), 1,
      anon_sym_class,
    ACTIONS(9978), 1,
      anon_sym_struct,
    ACTIONS(9980), 1,
      anon_sym_union,
    ACTIONS(9984), 1,
      anon_sym_decltype,
    ACTIONS(9988), 1,
      anon_sym_interface,
    ACTIONS(9990), 1,
      anon_sym_extension,
    ACTIONS(10048), 1,
      sym_identifier,
    ACTIONS(10052), 1,
      sym_primitive_type,
    ACTIONS(10054), 1,
      anon_sym_enum,
    ACTIONS(10056), 1,
      anon_sym_typename,
    STATE(2956), 1,
      sym_type_specifier,
    STATE(3003), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3091), 1,
      sym_qualified_type_identifier,
    STATE(8070), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3000), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9982), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10050), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3060), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [204098] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8752), 1,
      anon_sym_STAR,
    ACTIONS(8754), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8756), 1,
      anon_sym_AMP,
    STATE(3092), 1,
      sym__type_declarator,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(10183), 1,
      sym_ms_based_modifier,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [204170] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(9163), 1,
      anon_sym_DOT,
    ACTIONS(9596), 1,
      anon_sym_STAR,
    ACTIONS(9598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9600), 1,
      anon_sym_AMP,
    STATE(4576), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8405), 1,
      sym__abstract_declarator,
    ACTIONS(8538), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6113), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8542), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [204244] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(6288), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [204326] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7813), 1,
      sym_identifier,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7819), 1,
      anon_sym_enum,
    ACTIONS(7821), 1,
      anon_sym_class,
    ACTIONS(7823), 1,
      anon_sym_struct,
    ACTIONS(7825), 1,
      anon_sym_union,
    ACTIONS(7827), 1,
      anon_sym_typename,
    ACTIONS(7829), 1,
      anon_sym_interface,
    ACTIONS(7831), 1,
      anon_sym_extension,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(6290), 1,
      sym_type_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [204408] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5758), 1,
      sym_type_specifier,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [204490] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8752), 1,
      anon_sym_STAR,
    ACTIONS(8754), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8756), 1,
      anon_sym_AMP,
    STATE(3089), 1,
      sym__type_declarator,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(10183), 1,
      sym_ms_based_modifier,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [204562] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3709), 1,
      anon_sym_LBRACE,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(10120), 1,
      anon_sym_COLON,
    STATE(438), 1,
      sym_attribute_specifier,
    STATE(6015), 1,
      sym__enum_base_clause,
    STATE(6071), 1,
      sym_enumerator_list,
    ACTIONS(3348), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3350), 27,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [204618] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8752), 1,
      anon_sym_STAR,
    ACTIONS(8754), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8756), 1,
      anon_sym_AMP,
    STATE(3097), 1,
      sym__type_declarator,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(10183), 1,
      sym_ms_based_modifier,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [204690] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3709), 1,
      anon_sym_LBRACE,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(10120), 1,
      anon_sym_COLON,
    STATE(388), 1,
      sym_attribute_specifier,
    STATE(6020), 1,
      sym__enum_base_clause,
    STATE(6092), 1,
      sym_enumerator_list,
    ACTIONS(3060), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3062), 27,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [204746] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(245), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2409), 1,
      sym_primitive_type,
    ACTIONS(2411), 1,
      anon_sym_enum,
    ACTIONS(2413), 1,
      anon_sym_class,
    ACTIONS(2415), 1,
      anon_sym_struct,
    ACTIONS(2417), 1,
      anon_sym_union,
    ACTIONS(2419), 1,
      anon_sym_typename,
    ACTIONS(2431), 1,
      anon_sym_interface,
    ACTIONS(2433), 1,
      anon_sym_extension,
    ACTIONS(3967), 1,
      sym_identifier,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    STATE(2632), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2718), 1,
      sym_qualified_type_identifier,
    STATE(3378), 1,
      sym_type_specifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(2715), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(243), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(195), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2741), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [204828] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6447), 1,
      sym_ms_call_modifier,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7749), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [204906] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(245), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2409), 1,
      sym_primitive_type,
    ACTIONS(2411), 1,
      anon_sym_enum,
    ACTIONS(2413), 1,
      anon_sym_class,
    ACTIONS(2415), 1,
      anon_sym_struct,
    ACTIONS(2417), 1,
      anon_sym_union,
    ACTIONS(2419), 1,
      anon_sym_typename,
    ACTIONS(2431), 1,
      anon_sym_interface,
    ACTIONS(2433), 1,
      anon_sym_extension,
    ACTIONS(3967), 1,
      sym_identifier,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    STATE(2632), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2718), 1,
      sym_qualified_type_identifier,
    STATE(3388), 1,
      sym_type_specifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(2715), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(243), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(195), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2741), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [204988] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6446), 1,
      sym_ms_call_modifier,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7742), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [205066] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8724), 1,
      anon_sym_STAR,
    ACTIONS(8726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8728), 1,
      anon_sym_AMP,
    ACTIONS(8736), 1,
      sym_primitive_type,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(8237), 1,
      sym__type_declarator,
    STATE(10519), 1,
      sym_ms_based_modifier,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [205138] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8798), 1,
      sym_identifier,
    ACTIONS(8800), 1,
      anon_sym_LPAREN2,
    ACTIONS(8810), 1,
      sym_primitive_type,
    ACTIONS(8812), 1,
      anon_sym_STAR,
    ACTIONS(8814), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8816), 1,
      anon_sym_AMP,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7833), 1,
      sym_pointer_type_declarator,
    STATE(8209), 1,
      sym__type_declarator,
    STATE(10312), 1,
      sym_ms_based_modifier,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8808), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7859), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [205210] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8048), 1,
      sym_primitive_type,
    ACTIONS(10087), 1,
      sym_identifier,
    ACTIONS(10089), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10091), 1,
      anon_sym_enum,
    ACTIONS(10093), 1,
      anon_sym_class,
    ACTIONS(10095), 1,
      anon_sym_struct,
    ACTIONS(10097), 1,
      anon_sym_union,
    ACTIONS(10099), 1,
      anon_sym_typename,
    ACTIONS(10101), 1,
      anon_sym_interface,
    ACTIONS(10103), 1,
      anon_sym_extension,
    STATE(405), 1,
      sym_qualified_type_identifier,
    STATE(5463), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8067), 1,
      sym__scope_resolution,
    STATE(8434), 1,
      sym_type_specifier,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(121), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8046), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(361), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [205292] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8773), 1,
      sym_identifier,
    ACTIONS(8775), 1,
      anon_sym_LPAREN2,
    ACTIONS(8777), 1,
      anon_sym_STAR,
    ACTIONS(8779), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8781), 1,
      anon_sym_AMP,
    ACTIONS(8785), 1,
      sym_primitive_type,
    STATE(3529), 1,
      sym__type_declarator,
    STATE(3956), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(10354), 1,
      sym_ms_based_modifier,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8783), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3959), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [205364] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9976), 1,
      anon_sym_class,
    ACTIONS(9978), 1,
      anon_sym_struct,
    ACTIONS(9980), 1,
      anon_sym_union,
    ACTIONS(9984), 1,
      anon_sym_decltype,
    ACTIONS(9988), 1,
      anon_sym_interface,
    ACTIONS(9990), 1,
      anon_sym_extension,
    ACTIONS(10048), 1,
      sym_identifier,
    ACTIONS(10052), 1,
      sym_primitive_type,
    ACTIONS(10054), 1,
      anon_sym_enum,
    ACTIONS(10056), 1,
      anon_sym_typename,
    STATE(2952), 1,
      sym_type_specifier,
    STATE(3003), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3091), 1,
      sym_qualified_type_identifier,
    STATE(8070), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3000), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9982), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10050), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3060), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [205446] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8798), 1,
      sym_identifier,
    ACTIONS(8800), 1,
      anon_sym_LPAREN2,
    ACTIONS(8810), 1,
      sym_primitive_type,
    ACTIONS(8812), 1,
      anon_sym_STAR,
    ACTIONS(8814), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8816), 1,
      anon_sym_AMP,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7833), 1,
      sym_pointer_type_declarator,
    STATE(8190), 1,
      sym__type_declarator,
    STATE(10312), 1,
      sym_ms_based_modifier,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8808), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7859), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [205518] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8556), 1,
      anon_sym_COMMA,
    ACTIONS(9004), 1,
      sym_identifier,
    ACTIONS(9480), 1,
      anon_sym_STAR,
    ACTIONS(9482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9484), 1,
      anon_sym_AMP,
    ACTIONS(9486), 1,
      anon_sym_DOT,
    STATE(4571), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8483), 1,
      sym__abstract_declarator,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6130), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8984), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [205592] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9893), 1,
      sym_identifier,
    ACTIONS(9895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9899), 1,
      sym_primitive_type,
    ACTIONS(9901), 1,
      anon_sym_enum,
    ACTIONS(9903), 1,
      anon_sym_class,
    ACTIONS(9905), 1,
      anon_sym_struct,
    ACTIONS(9907), 1,
      anon_sym_union,
    ACTIONS(9911), 1,
      anon_sym_decltype,
    ACTIONS(9913), 1,
      anon_sym_typename,
    ACTIONS(9915), 1,
      anon_sym_interface,
    ACTIONS(9917), 1,
      anon_sym_extension,
    STATE(3343), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3570), 1,
      sym_type_specifier,
    STATE(3821), 1,
      sym_qualified_type_identifier,
    STATE(8115), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3759), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9909), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9897), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3860), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [205674] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6394), 1,
      sym_ms_call_modifier,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7791), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [205752] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7833), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    ACTIONS(7849), 1,
      anon_sym_interface,
    ACTIONS(7851), 1,
      anon_sym_extension,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(6114), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6399), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [205834] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6351), 1,
      sym_ms_call_modifier,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7847), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [205912] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8724), 1,
      anon_sym_STAR,
    ACTIONS(8726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8728), 1,
      anon_sym_AMP,
    ACTIONS(8736), 1,
      sym_primitive_type,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(8250), 1,
      sym__type_declarator,
    STATE(10519), 1,
      sym_ms_based_modifier,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [205984] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7679), 1,
      sym_primitive_type,
    ACTIONS(9873), 1,
      sym_identifier,
    ACTIONS(9875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9877), 1,
      anon_sym_enum,
    ACTIONS(9879), 1,
      anon_sym_class,
    ACTIONS(9881), 1,
      anon_sym_struct,
    ACTIONS(9883), 1,
      anon_sym_union,
    ACTIONS(9885), 1,
      anon_sym_typename,
    ACTIONS(9887), 1,
      anon_sym_interface,
    ACTIONS(9889), 1,
      anon_sym_extension,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(4784), 1,
      sym_type_specifier,
    STATE(8113), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [206066] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8798), 1,
      sym_identifier,
    ACTIONS(8800), 1,
      anon_sym_LPAREN2,
    ACTIONS(8810), 1,
      sym_primitive_type,
    ACTIONS(8812), 1,
      anon_sym_STAR,
    ACTIONS(8814), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8816), 1,
      anon_sym_AMP,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7833), 1,
      sym_pointer_type_declarator,
    STATE(8170), 1,
      sym__type_declarator,
    STATE(10312), 1,
      sym_ms_based_modifier,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8808), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7859), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [206138] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9936), 1,
      sym_identifier,
    ACTIONS(9938), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9942), 1,
      sym_primitive_type,
    ACTIONS(9944), 1,
      anon_sym_enum,
    ACTIONS(9946), 1,
      anon_sym_class,
    ACTIONS(9948), 1,
      anon_sym_struct,
    ACTIONS(9950), 1,
      anon_sym_union,
    ACTIONS(9954), 1,
      anon_sym_decltype,
    ACTIONS(9956), 1,
      anon_sym_typename,
    ACTIONS(9958), 1,
      anon_sym_interface,
    ACTIONS(9960), 1,
      anon_sym_extension,
    STATE(4648), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4887), 1,
      sym_type_specifier,
    STATE(5075), 1,
      sym_qualified_type_identifier,
    STATE(8098), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(4962), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9952), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9940), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5072), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [206220] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8798), 1,
      sym_identifier,
    ACTIONS(8800), 1,
      anon_sym_LPAREN2,
    ACTIONS(8802), 1,
      anon_sym_STAR,
    ACTIONS(8804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8806), 1,
      anon_sym_AMP,
    ACTIONS(8810), 1,
      sym_primitive_type,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7436), 1,
      sym__type_declarator,
    STATE(7833), 1,
      sym_pointer_type_declarator,
    STATE(10326), 1,
      sym_ms_based_modifier,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8808), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7859), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [206292] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7861), 1,
      sym_identifier,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(7869), 1,
      anon_sym_enum,
    ACTIONS(7871), 1,
      anon_sym_class,
    ACTIONS(7873), 1,
      anon_sym_struct,
    ACTIONS(7875), 1,
      anon_sym_union,
    ACTIONS(7877), 1,
      anon_sym_typename,
    ACTIONS(7879), 1,
      anon_sym_interface,
    ACTIONS(7881), 1,
      anon_sym_extension,
    STATE(5512), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(6177), 1,
      sym_type_specifier,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7865), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [206374] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(6084), 1,
      sym_alignas_qualifier,
    ACTIONS(8281), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5921), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8682), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(8277), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8684), 12,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [206426] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(10022), 1,
      sym_identifier,
    ACTIONS(10024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10028), 1,
      sym_primitive_type,
    ACTIONS(10030), 1,
      anon_sym_enum,
    ACTIONS(10032), 1,
      anon_sym_class,
    ACTIONS(10034), 1,
      anon_sym_struct,
    ACTIONS(10036), 1,
      anon_sym_union,
    ACTIONS(10040), 1,
      anon_sym_decltype,
    ACTIONS(10042), 1,
      anon_sym_typename,
    ACTIONS(10044), 1,
      anon_sym_interface,
    ACTIONS(10046), 1,
      anon_sym_extension,
    STATE(3153), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3398), 1,
      sym_type_specifier,
    STATE(3588), 1,
      sym_qualified_type_identifier,
    STATE(8107), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3490), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10038), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10026), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3516), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [206508] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(10022), 1,
      sym_identifier,
    ACTIONS(10024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10028), 1,
      sym_primitive_type,
    ACTIONS(10030), 1,
      anon_sym_enum,
    ACTIONS(10032), 1,
      anon_sym_class,
    ACTIONS(10034), 1,
      anon_sym_struct,
    ACTIONS(10036), 1,
      anon_sym_union,
    ACTIONS(10040), 1,
      anon_sym_decltype,
    ACTIONS(10042), 1,
      anon_sym_typename,
    ACTIONS(10044), 1,
      anon_sym_interface,
    ACTIONS(10046), 1,
      anon_sym_extension,
    STATE(3153), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3574), 1,
      sym_type_specifier,
    STATE(3588), 1,
      sym_qualified_type_identifier,
    STATE(8107), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3490), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10038), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10026), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3516), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [206590] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5702), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9964), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2740), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2742), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [206638] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(6084), 1,
      sym_alignas_qualifier,
    ACTIONS(10125), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5921), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8513), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(8511), 12,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(10122), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [206690] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9936), 1,
      sym_identifier,
    ACTIONS(9938), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9942), 1,
      sym_primitive_type,
    ACTIONS(9944), 1,
      anon_sym_enum,
    ACTIONS(9946), 1,
      anon_sym_class,
    ACTIONS(9948), 1,
      anon_sym_struct,
    ACTIONS(9950), 1,
      anon_sym_union,
    ACTIONS(9954), 1,
      anon_sym_decltype,
    ACTIONS(9956), 1,
      anon_sym_typename,
    ACTIONS(9958), 1,
      anon_sym_interface,
    ACTIONS(9960), 1,
      anon_sym_extension,
    STATE(4648), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5056), 1,
      sym_type_specifier,
    STATE(5075), 1,
      sym_qualified_type_identifier,
    STATE(8098), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(4962), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9952), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9940), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5072), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [206772] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8156), 1,
      anon_sym_DASH_GT,
    ACTIONS(8193), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(6086), 1,
      sym_ref_qualifier,
    STATE(6999), 1,
      sym__function_attributes_end,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7173), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8036), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6460), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [206858] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8070), 1,
      anon_sym_enum,
    ACTIONS(8072), 1,
      anon_sym_class,
    ACTIONS(8074), 1,
      anon_sym_struct,
    ACTIONS(8076), 1,
      anon_sym_union,
    ACTIONS(8078), 1,
      anon_sym_typename,
    ACTIONS(8080), 1,
      anon_sym_interface,
    ACTIONS(8082), 1,
      anon_sym_extension,
    ACTIONS(8206), 1,
      sym_identifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5859), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6445), 1,
      sym_type_specifier,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8068), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [206940] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6355), 1,
      sym_ms_call_modifier,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7893), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [207018] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7833), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    ACTIONS(7849), 1,
      anon_sym_interface,
    ACTIONS(7851), 1,
      anon_sym_extension,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(6114), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6453), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [207100] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7514), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9690), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9766), 1,
      anon_sym_requires,
    ACTIONS(9769), 1,
      anon_sym_where,
    STATE(6534), 1,
      sym__function_attributes_end,
    STATE(6888), 1,
      sym_trailing_return_type,
    STATE(7220), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9763), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7144), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6185), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [207180] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9992), 1,
      sym_identifier,
    ACTIONS(9994), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9998), 1,
      sym_primitive_type,
    ACTIONS(10000), 1,
      anon_sym_enum,
    ACTIONS(10002), 1,
      anon_sym_class,
    ACTIONS(10004), 1,
      anon_sym_struct,
    ACTIONS(10006), 1,
      anon_sym_union,
    ACTIONS(10010), 1,
      anon_sym_decltype,
    ACTIONS(10012), 1,
      anon_sym_typename,
    ACTIONS(10014), 1,
      anon_sym_interface,
    ACTIONS(10016), 1,
      anon_sym_extension,
    STATE(3812), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4761), 1,
      sym_qualified_type_identifier,
    STATE(4770), 1,
      sym_type_specifier,
    STATE(8035), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(4752), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10008), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9996), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4771), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [207262] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6356), 1,
      sym_ms_call_modifier,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7890), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [207340] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6393), 1,
      sym_ms_call_modifier,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7789), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [207418] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7607), 1,
      sym__type_declarator,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [207490] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8773), 1,
      sym_identifier,
    ACTIONS(8775), 1,
      anon_sym_LPAREN2,
    ACTIONS(8777), 1,
      anon_sym_STAR,
    ACTIONS(8779), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8781), 1,
      anon_sym_AMP,
    ACTIONS(8785), 1,
      sym_primitive_type,
    STATE(3584), 1,
      sym__type_declarator,
    STATE(3956), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(10354), 1,
      sym_ms_based_modifier,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8783), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3959), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [207562] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9992), 1,
      sym_identifier,
    ACTIONS(9994), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9998), 1,
      sym_primitive_type,
    ACTIONS(10000), 1,
      anon_sym_enum,
    ACTIONS(10002), 1,
      anon_sym_class,
    ACTIONS(10004), 1,
      anon_sym_struct,
    ACTIONS(10006), 1,
      anon_sym_union,
    ACTIONS(10010), 1,
      anon_sym_decltype,
    ACTIONS(10012), 1,
      anon_sym_typename,
    ACTIONS(10014), 1,
      anon_sym_interface,
    ACTIONS(10016), 1,
      anon_sym_extension,
    STATE(3812), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4632), 1,
      sym_type_specifier,
    STATE(4761), 1,
      sym_qualified_type_identifier,
    STATE(8035), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(4752), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10008), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9996), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4771), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [207644] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9992), 1,
      sym_identifier,
    ACTIONS(9994), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9998), 1,
      sym_primitive_type,
    ACTIONS(10000), 1,
      anon_sym_enum,
    ACTIONS(10002), 1,
      anon_sym_class,
    ACTIONS(10004), 1,
      anon_sym_struct,
    ACTIONS(10006), 1,
      anon_sym_union,
    ACTIONS(10010), 1,
      anon_sym_decltype,
    ACTIONS(10012), 1,
      anon_sym_typename,
    ACTIONS(10014), 1,
      anon_sym_interface,
    ACTIONS(10016), 1,
      anon_sym_extension,
    STATE(3812), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4624), 1,
      sym_type_specifier,
    STATE(4761), 1,
      sym_qualified_type_identifier,
    STATE(8035), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(4752), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10008), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9996), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4771), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [207726] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6365), 1,
      sym_ms_call_modifier,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7865), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [207804] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      anon_sym_enum,
    ACTIONS(71), 1,
      anon_sym_class,
    ACTIONS(73), 1,
      anon_sym_struct,
    ACTIONS(75), 1,
      anon_sym_union,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(127), 1,
      anon_sym_typename,
    ACTIONS(161), 1,
      anon_sym_interface,
    ACTIONS(163), 1,
      anon_sym_extension,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(10128), 1,
      sym_identifier,
    ACTIONS(10130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10132), 1,
      sym_primitive_type,
    STATE(405), 1,
      sym_qualified_type_identifier,
    STATE(886), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(997), 1,
      sym_type_specifier,
    STATE(8132), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(121), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(55), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(361), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [207886] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7679), 1,
      sym_primitive_type,
    ACTIONS(9873), 1,
      sym_identifier,
    ACTIONS(9875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9877), 1,
      anon_sym_enum,
    ACTIONS(9879), 1,
      anon_sym_class,
    ACTIONS(9881), 1,
      anon_sym_struct,
    ACTIONS(9883), 1,
      anon_sym_union,
    ACTIONS(9885), 1,
      anon_sym_typename,
    ACTIONS(9887), 1,
      anon_sym_interface,
    ACTIONS(9889), 1,
      anon_sym_extension,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(4762), 1,
      sym_type_specifier,
    STATE(8113), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [207968] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8738), 1,
      sym_identifier,
    ACTIONS(8740), 1,
      anon_sym_LPAREN2,
    ACTIONS(8742), 1,
      anon_sym_STAR,
    ACTIONS(8744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8746), 1,
      anon_sym_AMP,
    ACTIONS(8750), 1,
      sym_primitive_type,
    STATE(3626), 1,
      sym__type_declarator,
    STATE(4278), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(10635), 1,
      sym_ms_based_modifier,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8748), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4276), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [208040] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9966), 1,
      sym_identifier,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9972), 1,
      sym_primitive_type,
    ACTIONS(9974), 1,
      anon_sym_enum,
    ACTIONS(9976), 1,
      anon_sym_class,
    ACTIONS(9978), 1,
      anon_sym_struct,
    ACTIONS(9980), 1,
      anon_sym_union,
    ACTIONS(9984), 1,
      anon_sym_decltype,
    ACTIONS(9986), 1,
      anon_sym_typename,
    ACTIONS(9988), 1,
      anon_sym_interface,
    ACTIONS(9990), 1,
      anon_sym_extension,
    STATE(3011), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3091), 1,
      sym_qualified_type_identifier,
    STATE(3386), 1,
      sym_type_specifier,
    STATE(8070), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3000), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9982), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9970), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3060), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [208122] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7634), 1,
      sym__type_declarator,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [208194] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(9163), 1,
      anon_sym_DOT,
    ACTIONS(9596), 1,
      anon_sym_STAR,
    ACTIONS(9598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9600), 1,
      anon_sym_AMP,
    STATE(4576), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8449), 1,
      sym__abstract_declarator,
    ACTIONS(8556), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6123), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8542), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [208268] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4637), 1,
      anon_sym_enum,
    ACTIONS(4639), 1,
      anon_sym_class,
    ACTIONS(4641), 1,
      anon_sym_struct,
    ACTIONS(4643), 1,
      anon_sym_union,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(4673), 1,
      anon_sym_typename,
    ACTIONS(4687), 1,
      anon_sym_interface,
    ACTIONS(4689), 1,
      anon_sym_extension,
    ACTIONS(7817), 1,
      sym_primitive_type,
    ACTIONS(7853), 1,
      sym_identifier,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5943), 1,
      sym_type_specifier,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [208350] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8540), 1,
      anon_sym_DOT,
    ACTIONS(3890), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(8542), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3892), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [208398] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(245), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2299), 1,
      anon_sym_enum,
    ACTIONS(2301), 1,
      anon_sym_class,
    ACTIONS(2303), 1,
      anon_sym_struct,
    ACTIONS(2305), 1,
      anon_sym_union,
    ACTIONS(2329), 1,
      anon_sym_typename,
    ACTIONS(2341), 1,
      anon_sym_interface,
    ACTIONS(2343), 1,
      anon_sym_extension,
    ACTIONS(2409), 1,
      sym_primitive_type,
    ACTIONS(5014), 1,
      sym_identifier,
    ACTIONS(5024), 1,
      anon_sym_COLON_COLON,
    STATE(2632), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2718), 1,
      sym_qualified_type_identifier,
    STATE(2938), 1,
      sym_type_specifier,
    STATE(8090), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(2715), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(243), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(195), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2741), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [208480] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(245), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2299), 1,
      anon_sym_enum,
    ACTIONS(2301), 1,
      anon_sym_class,
    ACTIONS(2303), 1,
      anon_sym_struct,
    ACTIONS(2305), 1,
      anon_sym_union,
    ACTIONS(2329), 1,
      anon_sym_typename,
    ACTIONS(2341), 1,
      anon_sym_interface,
    ACTIONS(2343), 1,
      anon_sym_extension,
    ACTIONS(2409), 1,
      sym_primitive_type,
    ACTIONS(5014), 1,
      sym_identifier,
    ACTIONS(5024), 1,
      anon_sym_COLON_COLON,
    STATE(2632), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2718), 1,
      sym_qualified_type_identifier,
    STATE(2941), 1,
      sym_type_specifier,
    STATE(8090), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(2715), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(243), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(195), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2741), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [208562] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8828), 1,
      anon_sym_STAR,
    ACTIONS(8830), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8832), 1,
      anon_sym_AMP,
    STATE(4574), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8019), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6068), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8902), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [208632] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7789), 1,
      sym_identifier,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7795), 1,
      sym_primitive_type,
    ACTIONS(7797), 1,
      anon_sym_enum,
    ACTIONS(7799), 1,
      anon_sym_class,
    ACTIONS(7801), 1,
      anon_sym_struct,
    ACTIONS(7803), 1,
      anon_sym_union,
    ACTIONS(7807), 1,
      anon_sym_typename,
    ACTIONS(7809), 1,
      anon_sym_interface,
    ACTIONS(7811), 1,
      anon_sym_extension,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5801), 1,
      sym_qualified_type_identifier,
    STATE(5808), 1,
      sym_type_specifier,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7805), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5857), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [208714] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6362), 1,
      sym_ms_call_modifier,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7879), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [208792] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8976), 1,
      anon_sym___attribute__,
    ACTIONS(9474), 1,
      anon_sym_LBRACE,
    ACTIONS(10134), 1,
      anon_sym_COLON,
    STATE(5337), 1,
      sym__enum_base_clause,
    STATE(5605), 1,
      sym_enumerator_list,
    STATE(5865), 1,
      sym_attribute_specifier,
    ACTIONS(3350), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(3348), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [208848] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(245), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2409), 1,
      sym_primitive_type,
    ACTIONS(2413), 1,
      anon_sym_class,
    ACTIONS(2415), 1,
      anon_sym_struct,
    ACTIONS(2417), 1,
      anon_sym_union,
    ACTIONS(2431), 1,
      anon_sym_interface,
    ACTIONS(2433), 1,
      anon_sym_extension,
    ACTIONS(3967), 1,
      sym_identifier,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3979), 1,
      anon_sym_enum,
    ACTIONS(3981), 1,
      anon_sym_typename,
    STATE(2718), 1,
      sym_qualified_type_identifier,
    STATE(3133), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3493), 1,
      sym_type_specifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(2715), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(243), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3977), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2741), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [208930] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7679), 1,
      sym_primitive_type,
    ACTIONS(9873), 1,
      sym_identifier,
    ACTIONS(9875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9877), 1,
      anon_sym_enum,
    ACTIONS(9879), 1,
      anon_sym_class,
    ACTIONS(9881), 1,
      anon_sym_struct,
    ACTIONS(9883), 1,
      anon_sym_union,
    ACTIONS(9885), 1,
      anon_sym_typename,
    ACTIONS(9887), 1,
      anon_sym_interface,
    ACTIONS(9889), 1,
      anon_sym_extension,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(4750), 1,
      sym_type_specifier,
    STATE(8113), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [209012] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(6145), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [209094] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7641), 1,
      sym__type_declarator,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [209166] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9936), 1,
      sym_identifier,
    ACTIONS(9938), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9942), 1,
      sym_primitive_type,
    ACTIONS(9944), 1,
      anon_sym_enum,
    ACTIONS(9946), 1,
      anon_sym_class,
    ACTIONS(9948), 1,
      anon_sym_struct,
    ACTIONS(9950), 1,
      anon_sym_union,
    ACTIONS(9954), 1,
      anon_sym_decltype,
    ACTIONS(9956), 1,
      anon_sym_typename,
    ACTIONS(9958), 1,
      anon_sym_interface,
    ACTIONS(9960), 1,
      anon_sym_extension,
    STATE(4648), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4873), 1,
      sym_type_specifier,
    STATE(5075), 1,
      sym_qualified_type_identifier,
    STATE(8098), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(4962), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9952), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9940), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5072), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [209248] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9834), 1,
      sym_identifier,
    ACTIONS(9836), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9840), 1,
      sym_primitive_type,
    ACTIONS(9842), 1,
      anon_sym_enum,
    ACTIONS(9844), 1,
      anon_sym_class,
    ACTIONS(9846), 1,
      anon_sym_struct,
    ACTIONS(9848), 1,
      anon_sym_union,
    ACTIONS(9852), 1,
      anon_sym_decltype,
    ACTIONS(9854), 1,
      anon_sym_typename,
    ACTIONS(9856), 1,
      anon_sym_interface,
    ACTIONS(9858), 1,
      anon_sym_extension,
    STATE(3203), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3602), 1,
      sym_type_specifier,
    STATE(3668), 1,
      sym_qualified_type_identifier,
    STATE(8075), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3562), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9850), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9838), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3599), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [209330] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6413), 1,
      sym_ms_call_modifier,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7746), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [209408] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8048), 1,
      sym_primitive_type,
    ACTIONS(10087), 1,
      sym_identifier,
    ACTIONS(10089), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10091), 1,
      anon_sym_enum,
    ACTIONS(10093), 1,
      anon_sym_class,
    ACTIONS(10095), 1,
      anon_sym_struct,
    ACTIONS(10097), 1,
      anon_sym_union,
    ACTIONS(10099), 1,
      anon_sym_typename,
    ACTIONS(10101), 1,
      anon_sym_interface,
    ACTIONS(10103), 1,
      anon_sym_extension,
    STATE(405), 1,
      sym_qualified_type_identifier,
    STATE(5463), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8067), 1,
      sym__scope_resolution,
    STATE(8417), 1,
      sym_type_specifier,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(121), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8046), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(361), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [209490] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7514), 1,
      anon_sym_DASH_GT,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7518), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9690), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6570), 1,
      sym__function_attributes_end,
    STATE(6779), 1,
      sym_trailing_return_type,
    STATE(7220), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7473), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6189), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [209570] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7679), 1,
      sym_primitive_type,
    ACTIONS(9873), 1,
      sym_identifier,
    ACTIONS(9875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9877), 1,
      anon_sym_enum,
    ACTIONS(9879), 1,
      anon_sym_class,
    ACTIONS(9881), 1,
      anon_sym_struct,
    ACTIONS(9883), 1,
      anon_sym_union,
    ACTIONS(9885), 1,
      anon_sym_typename,
    ACTIONS(9887), 1,
      anon_sym_interface,
    ACTIONS(9889), 1,
      anon_sym_extension,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(4753), 1,
      sym_type_specifier,
    STATE(8113), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [209652] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(203), 1,
      anon_sym_enum,
    ACTIONS(205), 1,
      anon_sym_class,
    ACTIONS(207), 1,
      anon_sym_struct,
    ACTIONS(209), 1,
      anon_sym_union,
    ACTIONS(245), 1,
      anon_sym_decltype,
    ACTIONS(247), 1,
      anon_sym_typename,
    ACTIONS(271), 1,
      anon_sym_interface,
    ACTIONS(273), 1,
      anon_sym_extension,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2409), 1,
      sym_primitive_type,
    ACTIONS(3967), 1,
      sym_identifier,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    STATE(2632), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2718), 1,
      sym_qualified_type_identifier,
    STATE(2895), 1,
      sym_type_specifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(2715), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(243), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(195), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2741), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [209734] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym___attribute__,
    ACTIONS(6750), 1,
      anon_sym_LBRACE,
    ACTIONS(10136), 1,
      anon_sym_COLON,
    STATE(2922), 1,
      sym_attribute_specifier,
    STATE(3090), 1,
      sym__enum_base_clause,
    STATE(3149), 1,
      sym_enumerator_list,
    ACTIONS(3060), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(3062), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [209790] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8798), 1,
      sym_identifier,
    ACTIONS(8800), 1,
      anon_sym_LPAREN2,
    ACTIONS(8802), 1,
      anon_sym_STAR,
    ACTIONS(8804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8806), 1,
      anon_sym_AMP,
    ACTIONS(8810), 1,
      sym_primitive_type,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7396), 1,
      sym__type_declarator,
    STATE(7833), 1,
      sym_pointer_type_declarator,
    STATE(10326), 1,
      sym_ms_based_modifier,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8808), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7859), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [209862] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7679), 1,
      sym_primitive_type,
    ACTIONS(9873), 1,
      sym_identifier,
    ACTIONS(9875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9877), 1,
      anon_sym_enum,
    ACTIONS(9879), 1,
      anon_sym_class,
    ACTIONS(9881), 1,
      anon_sym_struct,
    ACTIONS(9883), 1,
      anon_sym_union,
    ACTIONS(9885), 1,
      anon_sym_typename,
    ACTIONS(9887), 1,
      anon_sym_interface,
    ACTIONS(9889), 1,
      anon_sym_extension,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(4816), 1,
      sym_type_specifier,
    STATE(8113), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [209944] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(7418), 1,
      anon_sym_COMMA,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8822), 1,
      anon_sym_STAR,
    ACTIONS(8824), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8826), 1,
      anon_sym_AMP,
    STATE(4577), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8026), 1,
      sym__abstract_declarator,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7420), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [210014] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8156), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9519), 1,
      anon_sym_requires,
    ACTIONS(10138), 1,
      anon_sym_where,
    STATE(6074), 1,
      sym_ref_qualifier,
    STATE(7006), 1,
      sym__function_attributes_end,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7149), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7609), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6459), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [210100] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6371), 1,
      sym_ms_call_modifier,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7832), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [210178] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8798), 1,
      sym_identifier,
    ACTIONS(8800), 1,
      anon_sym_LPAREN2,
    ACTIONS(8802), 1,
      anon_sym_STAR,
    ACTIONS(8804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8806), 1,
      anon_sym_AMP,
    ACTIONS(8810), 1,
      sym_primitive_type,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(7454), 1,
      sym__type_declarator,
    STATE(7833), 1,
      sym_pointer_type_declarator,
    STATE(10326), 1,
      sym_ms_based_modifier,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8808), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7859), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [210250] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6361), 1,
      sym_ms_call_modifier,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7827), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [210328] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9893), 1,
      sym_identifier,
    ACTIONS(9895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9899), 1,
      sym_primitive_type,
    ACTIONS(9901), 1,
      anon_sym_enum,
    ACTIONS(9903), 1,
      anon_sym_class,
    ACTIONS(9905), 1,
      anon_sym_struct,
    ACTIONS(9907), 1,
      anon_sym_union,
    ACTIONS(9911), 1,
      anon_sym_decltype,
    ACTIONS(9913), 1,
      anon_sym_typename,
    ACTIONS(9915), 1,
      anon_sym_interface,
    ACTIONS(9917), 1,
      anon_sym_extension,
    STATE(3343), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3544), 1,
      sym_type_specifier,
    STATE(3821), 1,
      sym_qualified_type_identifier,
    STATE(8115), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3759), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9909), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9897), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3860), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [210410] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8513), 1,
      anon_sym_COLON_COLON,
    STATE(2582), 1,
      sym_alignas_qualifier,
    ACTIONS(10141), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5970), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9609), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8511), 18,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_interface,
      anon_sym_extension,
  [210462] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    STATE(5819), 1,
      sym_attribute_specifier,
    STATE(6151), 1,
      sym_field_declaration_list,
    STATE(8691), 1,
      sym_virtual_specifier,
    STATE(9681), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2685), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2683), 21,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_requires,
      anon_sym_where,
  [210522] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8822), 1,
      anon_sym_STAR,
    ACTIONS(8824), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8826), 1,
      anon_sym_AMP,
    ACTIONS(8842), 1,
      anon_sym_COMMA,
    STATE(4577), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8016), 1,
      sym__abstract_declarator,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9926), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [210592] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6397), 1,
      sym_ms_call_modifier,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7780), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [210670] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9976), 1,
      anon_sym_class,
    ACTIONS(9978), 1,
      anon_sym_struct,
    ACTIONS(9980), 1,
      anon_sym_union,
    ACTIONS(9984), 1,
      anon_sym_decltype,
    ACTIONS(9988), 1,
      anon_sym_interface,
    ACTIONS(9990), 1,
      anon_sym_extension,
    ACTIONS(10048), 1,
      sym_identifier,
    ACTIONS(10052), 1,
      sym_primitive_type,
    ACTIONS(10054), 1,
      anon_sym_enum,
    ACTIONS(10056), 1,
      anon_sym_typename,
    STATE(3003), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3091), 1,
      sym_qualified_type_identifier,
    STATE(3384), 1,
      sym_type_specifier,
    STATE(8070), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3000), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9982), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10050), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3060), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [210752] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6396), 1,
      sym_ms_call_modifier,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7777), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [210830] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      anon_sym_enum,
    ACTIONS(71), 1,
      anon_sym_class,
    ACTIONS(73), 1,
      anon_sym_struct,
    ACTIONS(75), 1,
      anon_sym_union,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(127), 1,
      anon_sym_typename,
    ACTIONS(161), 1,
      anon_sym_interface,
    ACTIONS(163), 1,
      anon_sym_extension,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(10128), 1,
      sym_identifier,
    ACTIONS(10130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10132), 1,
      sym_primitive_type,
    STATE(405), 1,
      sym_qualified_type_identifier,
    STATE(886), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(999), 1,
      sym_type_specifier,
    STATE(8132), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(121), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(55), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(361), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [210912] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9893), 1,
      sym_identifier,
    ACTIONS(9895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9899), 1,
      sym_primitive_type,
    ACTIONS(9901), 1,
      anon_sym_enum,
    ACTIONS(9903), 1,
      anon_sym_class,
    ACTIONS(9905), 1,
      anon_sym_struct,
    ACTIONS(9907), 1,
      anon_sym_union,
    ACTIONS(9911), 1,
      anon_sym_decltype,
    ACTIONS(9913), 1,
      anon_sym_typename,
    ACTIONS(9915), 1,
      anon_sym_interface,
    ACTIONS(9917), 1,
      anon_sym_extension,
    STATE(3343), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3785), 1,
      sym_type_specifier,
    STATE(3821), 1,
      sym_qualified_type_identifier,
    STATE(8115), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3759), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9909), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9897), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3860), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [210994] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9893), 1,
      sym_identifier,
    ACTIONS(9895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9899), 1,
      sym_primitive_type,
    ACTIONS(9901), 1,
      anon_sym_enum,
    ACTIONS(9903), 1,
      anon_sym_class,
    ACTIONS(9905), 1,
      anon_sym_struct,
    ACTIONS(9907), 1,
      anon_sym_union,
    ACTIONS(9911), 1,
      anon_sym_decltype,
    ACTIONS(9913), 1,
      anon_sym_typename,
    ACTIONS(9915), 1,
      anon_sym_interface,
    ACTIONS(9917), 1,
      anon_sym_extension,
    STATE(3343), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3821), 1,
      sym_qualified_type_identifier,
    STATE(4193), 1,
      sym_type_specifier,
    STATE(8115), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3759), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9909), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9897), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3860), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [211076] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(7679), 1,
      sym_primitive_type,
    ACTIONS(9873), 1,
      sym_identifier,
    ACTIONS(9875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9877), 1,
      anon_sym_enum,
    ACTIONS(9879), 1,
      anon_sym_class,
    ACTIONS(9881), 1,
      anon_sym_struct,
    ACTIONS(9883), 1,
      anon_sym_union,
    ACTIONS(9885), 1,
      anon_sym_typename,
    ACTIONS(9887), 1,
      anon_sym_interface,
    ACTIONS(9889), 1,
      anon_sym_extension,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(4817), 1,
      sym_type_specifier,
    STATE(8113), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [211158] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2772), 1,
      anon_sym_enum,
    ACTIONS(2774), 1,
      anon_sym_class,
    ACTIONS(2776), 1,
      anon_sym_struct,
    ACTIONS(2778), 1,
      anon_sym_union,
    ACTIONS(2804), 1,
      anon_sym_decltype,
    ACTIONS(2806), 1,
      anon_sym_typename,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_extension,
    ACTIONS(7673), 1,
      sym_identifier,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7679), 1,
      sym_primitive_type,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2913), 1,
      sym_qualified_type_identifier,
    STATE(6143), 1,
      sym_type_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(2860), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2802), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2888), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [211240] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(6777), 1,
      anon_sym_COMMA,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8822), 1,
      anon_sym_STAR,
    ACTIONS(8824), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8826), 1,
      anon_sym_AMP,
    STATE(4577), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8015), 1,
      sym__abstract_declarator,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6779), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [211310] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1045), 1,
      anon_sym_enum,
    ACTIONS(1047), 1,
      anon_sym_class,
    ACTIONS(1049), 1,
      anon_sym_struct,
    ACTIONS(1051), 1,
      anon_sym_union,
    ACTIONS(1055), 1,
      anon_sym_decltype,
    ACTIONS(1057), 1,
      anon_sym_typename,
    ACTIONS(1059), 1,
      anon_sym_interface,
    ACTIONS(1061), 1,
      anon_sym_extension,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(10144), 1,
      sym_identifier,
    ACTIONS(10146), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10148), 1,
      sym_primitive_type,
    STATE(644), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(744), 1,
      sym_type_specifier,
    STATE(805), 1,
      sym_qualified_type_identifier,
    STATE(8117), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(760), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1053), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(1041), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(766), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [211392] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(6084), 1,
      sym_alignas_qualifier,
    ACTIONS(8281), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5921), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9183), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(8277), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(9185), 12,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [211444] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8048), 1,
      sym_primitive_type,
    ACTIONS(10087), 1,
      sym_identifier,
    ACTIONS(10089), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10091), 1,
      anon_sym_enum,
    ACTIONS(10093), 1,
      anon_sym_class,
    ACTIONS(10095), 1,
      anon_sym_struct,
    ACTIONS(10097), 1,
      anon_sym_union,
    ACTIONS(10099), 1,
      anon_sym_typename,
    ACTIONS(10101), 1,
      anon_sym_interface,
    ACTIONS(10103), 1,
      anon_sym_extension,
    STATE(405), 1,
      sym_qualified_type_identifier,
    STATE(5463), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8067), 1,
      sym__scope_resolution,
    STATE(8403), 1,
      sym_type_specifier,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(268), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(121), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8046), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(361), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [211526] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4671), 1,
      anon_sym_decltype,
    ACTIONS(7867), 1,
      sym_primitive_type,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8070), 1,
      anon_sym_enum,
    ACTIONS(8072), 1,
      anon_sym_class,
    ACTIONS(8074), 1,
      anon_sym_struct,
    ACTIONS(8076), 1,
      anon_sym_union,
    ACTIONS(8078), 1,
      anon_sym_typename,
    ACTIONS(8080), 1,
      anon_sym_interface,
    ACTIONS(8082), 1,
      anon_sym_extension,
    ACTIONS(8206), 1,
      sym_identifier,
    STATE(5825), 1,
      sym_qualified_type_identifier,
    STATE(5859), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6407), 1,
      sym_type_specifier,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(5647), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4667), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8068), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5826), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [211608] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8738), 1,
      sym_identifier,
    ACTIONS(8740), 1,
      anon_sym_LPAREN2,
    ACTIONS(8742), 1,
      anon_sym_STAR,
    ACTIONS(8744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8746), 1,
      anon_sym_AMP,
    ACTIONS(8750), 1,
      sym_primitive_type,
    STATE(3616), 1,
      sym__type_declarator,
    STATE(4278), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(10635), 1,
      sym_ms_based_modifier,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8748), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4276), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [211680] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8724), 1,
      anon_sym_STAR,
    ACTIONS(8726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8728), 1,
      anon_sym_AMP,
    ACTIONS(8736), 1,
      sym_primitive_type,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(8350), 1,
      sym__type_declarator,
    STATE(10519), 1,
      sym_ms_based_modifier,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [211752] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6353), 1,
      sym_ms_call_modifier,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7788), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [211830] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6389), 1,
      sym_ms_call_modifier,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7752), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [211908] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8828), 1,
      anon_sym_STAR,
    ACTIONS(8830), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8832), 1,
      anon_sym_AMP,
    STATE(4574), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8033), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6068), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7418), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [211978] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(6094), 1,
      sym_alignas_qualifier,
    ACTIONS(10153), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8511), 7,
      anon_sym_AMP,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8513), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(10150), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [212030] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8976), 1,
      anon_sym___attribute__,
    ACTIONS(9474), 1,
      anon_sym_LBRACE,
    ACTIONS(10134), 1,
      anon_sym_COLON,
    STATE(5345), 1,
      sym__enum_base_clause,
    STATE(5601), 1,
      sym_enumerator_list,
    STATE(5768), 1,
      sym_attribute_specifier,
    ACTIONS(3062), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(3060), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [212086] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9834), 1,
      sym_identifier,
    ACTIONS(9836), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9840), 1,
      sym_primitive_type,
    ACTIONS(9842), 1,
      anon_sym_enum,
    ACTIONS(9844), 1,
      anon_sym_class,
    ACTIONS(9846), 1,
      anon_sym_struct,
    ACTIONS(9848), 1,
      anon_sym_union,
    ACTIONS(9852), 1,
      anon_sym_decltype,
    ACTIONS(9854), 1,
      anon_sym_typename,
    ACTIONS(9856), 1,
      anon_sym_interface,
    ACTIONS(9858), 1,
      anon_sym_extension,
    STATE(3203), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3630), 1,
      sym_type_specifier,
    STATE(3668), 1,
      sym_qualified_type_identifier,
    STATE(8075), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3562), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9850), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9838), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3599), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [212168] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6428), 1,
      sym_ms_call_modifier,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7860), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [212246] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6387), 1,
      sym_ms_call_modifier,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7714), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [212324] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9834), 1,
      sym_identifier,
    ACTIONS(9836), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9840), 1,
      sym_primitive_type,
    ACTIONS(9842), 1,
      anon_sym_enum,
    ACTIONS(9844), 1,
      anon_sym_class,
    ACTIONS(9846), 1,
      anon_sym_struct,
    ACTIONS(9848), 1,
      anon_sym_union,
    ACTIONS(9852), 1,
      anon_sym_decltype,
    ACTIONS(9854), 1,
      anon_sym_typename,
    ACTIONS(9856), 1,
      anon_sym_interface,
    ACTIONS(9858), 1,
      anon_sym_extension,
    STATE(3203), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3455), 1,
      sym_type_specifier,
    STATE(3668), 1,
      sym_qualified_type_identifier,
    STATE(8075), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3562), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9850), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9838), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3599), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [212406] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5722), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2742), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9962), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2740), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [212454] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8540), 1,
      anon_sym_DOT,
    ACTIONS(3848), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(8542), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3850), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [212502] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8828), 1,
      anon_sym_STAR,
    ACTIONS(8830), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8832), 1,
      anon_sym_AMP,
    STATE(4574), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8031), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6068), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8842), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [212572] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8822), 1,
      anon_sym_STAR,
    ACTIONS(8824), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8826), 1,
      anon_sym_AMP,
    ACTIONS(8902), 1,
      anon_sym_COMMA,
    STATE(4577), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8010), 1,
      sym__abstract_declarator,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9919), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [212642] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8828), 1,
      anon_sym_STAR,
    ACTIONS(8830), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8832), 1,
      anon_sym_AMP,
    STATE(4574), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8027), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6068), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6777), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [212712] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9976), 1,
      anon_sym_class,
    ACTIONS(9978), 1,
      anon_sym_struct,
    ACTIONS(9980), 1,
      anon_sym_union,
    ACTIONS(9984), 1,
      anon_sym_decltype,
    ACTIONS(9988), 1,
      anon_sym_interface,
    ACTIONS(9990), 1,
      anon_sym_extension,
    ACTIONS(10048), 1,
      sym_identifier,
    ACTIONS(10052), 1,
      sym_primitive_type,
    ACTIONS(10054), 1,
      anon_sym_enum,
    ACTIONS(10056), 1,
      anon_sym_typename,
    STATE(3003), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3091), 1,
      sym_qualified_type_identifier,
    STATE(3391), 1,
      sym_type_specifier,
    STATE(8070), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3000), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9982), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10050), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3060), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [212794] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2397), 1,
      anon_sym_STAR,
    ACTIONS(2399), 1,
      anon_sym_AMP,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6140), 1,
      sym_identifier,
    ACTIONS(7072), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    STATE(6400), 1,
      sym_ms_call_modifier,
    STATE(6961), 1,
      sym__scope_resolution,
    STATE(8164), 1,
      sym__declarator,
    STATE(10814), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [212872] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym___attribute__,
    ACTIONS(6750), 1,
      anon_sym_LBRACE,
    ACTIONS(10136), 1,
      anon_sym_COLON,
    STATE(2914), 1,
      sym_attribute_specifier,
    STATE(3064), 1,
      sym__enum_base_clause,
    STATE(3141), 1,
      sym_enumerator_list,
    ACTIONS(3348), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(3350), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [212928] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9834), 1,
      sym_identifier,
    ACTIONS(9836), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9840), 1,
      sym_primitive_type,
    ACTIONS(9842), 1,
      anon_sym_enum,
    ACTIONS(9844), 1,
      anon_sym_class,
    ACTIONS(9846), 1,
      anon_sym_struct,
    ACTIONS(9848), 1,
      anon_sym_union,
    ACTIONS(9852), 1,
      anon_sym_decltype,
    ACTIONS(9854), 1,
      anon_sym_typename,
    ACTIONS(9856), 1,
      anon_sym_interface,
    ACTIONS(9858), 1,
      anon_sym_extension,
    STATE(3203), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3421), 1,
      sym_type_specifier,
    STATE(3668), 1,
      sym_qualified_type_identifier,
    STATE(8075), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(3562), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9850), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9838), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3599), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [213010] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1045), 1,
      anon_sym_enum,
    ACTIONS(1047), 1,
      anon_sym_class,
    ACTIONS(1049), 1,
      anon_sym_struct,
    ACTIONS(1051), 1,
      anon_sym_union,
    ACTIONS(1055), 1,
      anon_sym_decltype,
    ACTIONS(1057), 1,
      anon_sym_typename,
    ACTIONS(1059), 1,
      anon_sym_interface,
    ACTIONS(1061), 1,
      anon_sym_extension,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(10144), 1,
      sym_identifier,
    ACTIONS(10146), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10148), 1,
      sym_primitive_type,
    STATE(644), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(717), 1,
      sym_type_specifier,
    STATE(805), 1,
      sym_qualified_type_identifier,
    STATE(8117), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(760), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1053), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(1041), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(766), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [213092] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8738), 1,
      sym_identifier,
    ACTIONS(8740), 1,
      anon_sym_LPAREN2,
    ACTIONS(8742), 1,
      anon_sym_STAR,
    ACTIONS(8744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8746), 1,
      anon_sym_AMP,
    ACTIONS(8750), 1,
      sym_primitive_type,
    STATE(3652), 1,
      sym__type_declarator,
    STATE(4278), 1,
      sym_pointer_type_declarator,
    STATE(4847), 1,
      sym_alignas_qualifier,
    STATE(10635), 1,
      sym_ms_based_modifier,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8748), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4276), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [213164] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9936), 1,
      sym_identifier,
    ACTIONS(9938), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9942), 1,
      sym_primitive_type,
    ACTIONS(9944), 1,
      anon_sym_enum,
    ACTIONS(9946), 1,
      anon_sym_class,
    ACTIONS(9948), 1,
      anon_sym_struct,
    ACTIONS(9950), 1,
      anon_sym_union,
    ACTIONS(9954), 1,
      anon_sym_decltype,
    ACTIONS(9956), 1,
      anon_sym_typename,
    ACTIONS(9958), 1,
      anon_sym_interface,
    ACTIONS(9960), 1,
      anon_sym_extension,
    STATE(4648), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5075), 1,
      sym_qualified_type_identifier,
    STATE(5080), 1,
      sym_type_specifier,
    STATE(8098), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(4962), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9952), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9940), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5072), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [213246] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8538), 1,
      anon_sym_COMMA,
    ACTIONS(8980), 1,
      sym_identifier,
    ACTIONS(9480), 1,
      anon_sym_STAR,
    ACTIONS(9482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9484), 1,
      anon_sym_AMP,
    ACTIONS(9486), 1,
      anon_sym_DOT,
    STATE(4571), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8397), 1,
      sym__abstract_declarator,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8984), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [213320] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(245), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2409), 1,
      sym_primitive_type,
    ACTIONS(2413), 1,
      anon_sym_class,
    ACTIONS(2415), 1,
      anon_sym_struct,
    ACTIONS(2417), 1,
      anon_sym_union,
    ACTIONS(2431), 1,
      anon_sym_interface,
    ACTIONS(2433), 1,
      anon_sym_extension,
    ACTIONS(3967), 1,
      sym_identifier,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3979), 1,
      anon_sym_enum,
    ACTIONS(3981), 1,
      anon_sym_typename,
    STATE(2718), 1,
      sym_qualified_type_identifier,
    STATE(3133), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3484), 1,
      sym_type_specifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_dependent_type_identifier,
    STATE(2715), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(243), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3977), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2741), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [213402] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6384), 1,
      sym_ms_call_modifier,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7723), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [213480] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    ACTIONS(9474), 1,
      anon_sym_LBRACE,
    ACTIONS(10156), 1,
      anon_sym_COLON,
    STATE(5768), 1,
      sym_attribute_specifier,
    STATE(6098), 1,
      sym__enum_base_clause,
    STATE(6195), 1,
      sym_enumerator_list,
    ACTIONS(3062), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3060), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [213535] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8888), 1,
      anon_sym_STAR,
    ACTIONS(8890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8892), 1,
      anon_sym_AMP,
    STATE(4083), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8097), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6068), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7418), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [213604] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8251), 1,
      anon_sym_DASH_GT,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8299), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(6117), 1,
      sym_ref_qualifier,
    STATE(7048), 1,
      sym__function_attributes_end,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7347), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8225), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6472), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [213689] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3709), 1,
      anon_sym_LBRACE,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    STATE(373), 1,
      sym_attribute_specifier,
    STATE(6078), 1,
      sym_enumerator_list,
    ACTIONS(3715), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3717), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [213740] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    STATE(2816), 1,
      sym_template_argument_list,
    STATE(6128), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3485), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(3483), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [213791] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(6118), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(10161), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(6017), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(10158), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8548), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(8546), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [213842] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8888), 1,
      anon_sym_STAR,
    ACTIONS(8890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8892), 1,
      anon_sym_AMP,
    STATE(4083), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8063), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6068), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6777), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [213911] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    ACTIONS(9474), 1,
      anon_sym_LBRACE,
    ACTIONS(10156), 1,
      anon_sym_COLON,
    STATE(5865), 1,
      sym_attribute_specifier,
    STATE(6100), 1,
      sym__enum_base_clause,
    STATE(6157), 1,
      sym_enumerator_list,
    ACTIONS(3350), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3348), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [213966] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3709), 1,
      anon_sym_LBRACE,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    STATE(426), 1,
      sym_attribute_specifier,
    STATE(6072), 1,
      sym_enumerator_list,
    ACTIONS(3711), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3713), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [214017] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6750), 1,
      anon_sym_LBRACE,
    ACTIONS(10058), 1,
      anon_sym___attribute__,
    ACTIONS(10164), 1,
      anon_sym_COLON,
    STATE(2922), 1,
      sym_attribute_specifier,
    STATE(6088), 1,
      sym__enum_base_clause,
    STATE(6197), 1,
      sym_enumerator_list,
    ACTIONS(3062), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(3060), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [214072] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6750), 1,
      anon_sym_LBRACE,
    ACTIONS(10058), 1,
      anon_sym___attribute__,
    ACTIONS(10164), 1,
      anon_sym_COLON,
    STATE(2914), 1,
      sym_attribute_specifier,
    STATE(6076), 1,
      sym__enum_base_clause,
    STATE(6173), 1,
      sym_enumerator_list,
    ACTIONS(3350), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(3348), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [214127] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8279), 1,
      anon_sym___attribute__,
    ACTIONS(8285), 1,
      anon_sym_DASH_GT,
    ACTIONS(8289), 1,
      anon_sym_noexcept,
    ACTIONS(8291), 1,
      anon_sym_throw,
    ACTIONS(10169), 1,
      anon_sym_requires,
    ACTIONS(10172), 1,
      anon_sym_where,
    STATE(6133), 1,
      sym_ref_qualifier,
    STATE(7059), 1,
      sym__function_attributes_end,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7319), 1,
      sym_trailing_return_type,
    STATE(8412), 1,
      sym_gnu_asm_expression,
    ACTIONS(8283), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9514), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(10166), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7031), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7770), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6466), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
  [214212] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9474), 1,
      anon_sym_LBRACE,
    ACTIONS(9510), 1,
      anon_sym___attribute__,
    ACTIONS(10175), 1,
      anon_sym_COLON,
    STATE(5345), 1,
      sym__enum_base_clause,
    STATE(5601), 1,
      sym_enumerator_list,
    STATE(5768), 1,
      sym_attribute_specifier,
    ACTIONS(3060), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(3062), 27,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [214267] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9474), 1,
      anon_sym_LBRACE,
    ACTIONS(9510), 1,
      anon_sym___attribute__,
    ACTIONS(10175), 1,
      anon_sym_COLON,
    STATE(5337), 1,
      sym__enum_base_clause,
    STATE(5605), 1,
      sym_enumerator_list,
    STATE(5865), 1,
      sym_attribute_specifier,
    ACTIONS(3348), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(3350), 27,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [214322] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8888), 1,
      anon_sym_STAR,
    ACTIONS(8890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8892), 1,
      anon_sym_AMP,
    STATE(4083), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8139), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6068), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8842), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [214391] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10177), 1,
      anon_sym___attribute__,
    STATE(6027), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(9563), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(9565), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [214438] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8251), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(10180), 1,
      anon_sym_requires,
    ACTIONS(10183), 1,
      anon_sym_where,
    STATE(6135), 1,
      sym_ref_qualifier,
    STATE(7016), 1,
      sym__function_attributes_end,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7253), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7781), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6470), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [214523] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8888), 1,
      anon_sym_STAR,
    ACTIONS(8890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8892), 1,
      anon_sym_AMP,
    STATE(4083), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8135), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6068), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8902), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [214592] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8279), 1,
      anon_sym___attribute__,
    ACTIONS(8285), 1,
      anon_sym_DASH_GT,
    ACTIONS(8289), 1,
      anon_sym_noexcept,
    ACTIONS(8291), 1,
      anon_sym_throw,
    ACTIONS(8293), 1,
      anon_sym_requires,
    ACTIONS(8295), 1,
      anon_sym_where,
    STATE(6112), 1,
      sym_ref_qualifier,
    STATE(7058), 1,
      sym__function_attributes_end,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7243), 1,
      sym_trailing_return_type,
    STATE(8412), 1,
      sym_gnu_asm_expression,
    ACTIONS(8283), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9514), 2,
      anon_sym_LBRACK,
      sym_identifier,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7031), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8204), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6465), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
  [214677] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9690), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10081), 1,
      anon_sym_requires,
    ACTIONS(10084), 1,
      anon_sym_where,
    STATE(6799), 1,
      sym__function_attributes_end,
    STATE(6977), 1,
      sym_trailing_return_type,
    STATE(7220), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9763), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7391), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6422), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [214755] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(7764), 1,
      anon_sym_requires,
    ACTIONS(7766), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9690), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6749), 1,
      sym__function_attributes_end,
    STATE(6998), 1,
      sym_trailing_return_type,
    STATE(7220), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7850), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6366), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [214833] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7777), 1,
      anon_sym_DASH_GT,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10108), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10114), 1,
      anon_sym_requires,
    ACTIONS(10186), 1,
      anon_sym___attribute__,
    ACTIONS(10189), 1,
      anon_sym_where,
    STATE(6606), 1,
      sym__function_attributes_end,
    STATE(6935), 1,
      sym_trailing_return_type,
    STATE(7152), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10111), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7288), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6439), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10062), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [214911] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8176), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6068), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8902), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [214979] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10108), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10192), 1,
      anon_sym_requires,
    ACTIONS(10195), 1,
      anon_sym_where,
    STATE(6803), 1,
      sym__function_attributes_end,
    STATE(6972), 1,
      sym_trailing_return_type,
    STATE(7152), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10111), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7390), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6425), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10062), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [215057] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8970), 1,
      anon_sym_STAR,
    ACTIONS(8972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8974), 1,
      anon_sym_AMP,
    STATE(4302), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8199), 1,
      sym__abstract_declarator,
    ACTIONS(8608), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6777), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8462), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [215125] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2647), 1,
      sym_alignas_qualifier,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6045), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9183), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(6142), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(9185), 12,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [215175] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(8910), 1,
      anon_sym_LPAREN2,
    ACTIONS(8986), 1,
      sym_identifier,
    ACTIONS(8988), 1,
      anon_sym_STAR,
    ACTIONS(8990), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8992), 1,
      anon_sym_AMP,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7453), 1,
      sym__field_declarator,
    STATE(7707), 1,
      sym_operator_name,
    STATE(10471), 1,
      sym_ms_based_modifier,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7713), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [215243] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8381), 1,
      anon_sym_DASH_GT,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8385), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(6200), 1,
      sym_ref_qualifier,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7162), 1,
      sym__function_attributes_end,
    STATE(7402), 1,
      sym_trailing_return_type,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8317), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6483), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [215327] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(8910), 1,
      anon_sym_LPAREN2,
    ACTIONS(8986), 1,
      sym_identifier,
    ACTIONS(8988), 1,
      anon_sym_STAR,
    ACTIONS(8990), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8992), 1,
      anon_sym_AMP,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7455), 1,
      sym__field_declarator,
    STATE(7707), 1,
      sym_operator_name,
    STATE(10471), 1,
      sym_ms_based_modifier,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7713), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [215395] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(8910), 1,
      anon_sym_LPAREN2,
    ACTIONS(8986), 1,
      sym_identifier,
    ACTIONS(8988), 1,
      anon_sym_STAR,
    ACTIONS(8990), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8992), 1,
      anon_sym_AMP,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7431), 1,
      sym__field_declarator,
    STATE(7707), 1,
      sym_operator_name,
    STATE(10471), 1,
      sym_ms_based_modifier,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7713), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [215463] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(8908), 1,
      sym_identifier,
    ACTIONS(8910), 1,
      anon_sym_LPAREN2,
    ACTIONS(8912), 1,
      anon_sym_STAR,
    ACTIONS(8914), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8916), 1,
      anon_sym_AMP,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(8218), 1,
      sym__field_declarator,
    STATE(8493), 1,
      sym_operator_name,
    STATE(10393), 1,
      sym_ms_based_modifier,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7713), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [215531] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8172), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6068), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8842), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [215599] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7777), 1,
      anon_sym_DASH_GT,
    ACTIONS(7782), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10108), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10186), 1,
      anon_sym___attribute__,
    STATE(6666), 1,
      sym__function_attributes_end,
    STATE(6903), 1,
      sym_trailing_return_type,
    STATE(7152), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7649), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6435), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10062), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [215677] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2647), 1,
      sym_alignas_qualifier,
    ACTIONS(10201), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6045), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8513), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(8511), 12,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(10198), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [215727] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8381), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(10204), 1,
      anon_sym_requires,
    ACTIONS(10207), 1,
      anon_sym_where,
    STATE(6183), 1,
      sym_ref_qualifier,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7132), 1,
      sym__function_attributes_end,
    STATE(7415), 1,
      sym_trailing_return_type,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8014), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6490), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [215811] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8970), 1,
      anon_sym_STAR,
    ACTIONS(8972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8974), 1,
      anon_sym_AMP,
    ACTIONS(9926), 1,
      sym_identifier,
    STATE(4302), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8200), 1,
      sym__abstract_declarator,
    ACTIONS(8608), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8842), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8462), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [215879] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8970), 1,
      anon_sym_STAR,
    ACTIONS(8972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8974), 1,
      anon_sym_AMP,
    ACTIONS(9919), 1,
      sym_identifier,
    STATE(4302), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8197), 1,
      sym__abstract_declarator,
    ACTIONS(8608), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8902), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8462), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [215947] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7777), 1,
      anon_sym_DASH_GT,
    ACTIONS(7782), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9690), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10075), 1,
      anon_sym___attribute__,
    STATE(6680), 1,
      sym__function_attributes_end,
    STATE(6913), 1,
      sym_trailing_return_type,
    STATE(7220), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7602), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6417), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [216025] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(8908), 1,
      sym_identifier,
    ACTIONS(8910), 1,
      anon_sym_LPAREN2,
    ACTIONS(8912), 1,
      anon_sym_STAR,
    ACTIONS(8914), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8916), 1,
      anon_sym_AMP,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(8160), 1,
      sym__field_declarator,
    STATE(8493), 1,
      sym_operator_name,
    STATE(10393), 1,
      sym_ms_based_modifier,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7713), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [216093] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8372), 1,
      anon_sym_DASH_GT,
    ACTIONS(8393), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(6158), 1,
      sym_ref_qualifier,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7177), 1,
      sym__function_attributes_end,
    STATE(7430), 1,
      sym_trailing_return_type,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8270), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6487), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [216177] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8214), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6068), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6777), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [216245] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8630), 1,
      anon_sym_DOT,
    ACTIONS(3890), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8560), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3892), 27,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [216291] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(8908), 1,
      sym_identifier,
    ACTIONS(8910), 1,
      anon_sym_LPAREN2,
    ACTIONS(8912), 1,
      anon_sym_STAR,
    ACTIONS(8914), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8916), 1,
      anon_sym_AMP,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(8153), 1,
      sym__field_declarator,
    STATE(8493), 1,
      sym_operator_name,
    STATE(10393), 1,
      sym_ms_based_modifier,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7713), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [216359] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7777), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9690), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9766), 1,
      anon_sym_requires,
    ACTIONS(10075), 1,
      anon_sym___attribute__,
    ACTIONS(10078), 1,
      anon_sym_where,
    STATE(6597), 1,
      sym__function_attributes_end,
    STATE(6940), 1,
      sym_trailing_return_type,
    STATE(7220), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9763), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7291), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6395), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [216437] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8630), 1,
      anon_sym_DOT,
    ACTIONS(3848), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8560), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3850), 27,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [216483] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8177), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6068), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7418), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [216551] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8372), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(10180), 1,
      anon_sym_requires,
    ACTIONS(10210), 1,
      anon_sym_where,
    STATE(6172), 1,
      sym_ref_qualifier,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7230), 1,
      sym__function_attributes_end,
    STATE(7381), 1,
      sym_trailing_return_type,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7953), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6482), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [216635] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2647), 1,
      sym_alignas_qualifier,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6045), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8682), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(6142), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8684), 12,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [216685] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(5024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(9586), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9590), 1,
      anon_sym_EQ,
    ACTIONS(10213), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2753), 1,
      sym__class_declaration,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(6641), 1,
      sym_ms_declspec_modifier,
    STATE(8090), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9588), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(2634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6644), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6370), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [216775] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(7420), 1,
      sym_identifier,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8970), 1,
      anon_sym_STAR,
    ACTIONS(8972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8974), 1,
      anon_sym_AMP,
    STATE(4302), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8202), 1,
      sym__abstract_declarator,
    ACTIONS(8608), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7418), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8462), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [216843] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(7764), 1,
      anon_sym_requires,
    ACTIONS(7766), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10108), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6738), 1,
      sym__function_attributes_end,
    STATE(6994), 1,
      sym_trailing_return_type,
    STATE(7152), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7868), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6354), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10062), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [216921] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    STATE(295), 1,
      sym_attribute_specifier,
    ACTIONS(3840), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3842), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [216966] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9869), 1,
      anon_sym_LT,
    ACTIONS(10215), 1,
      anon_sym_COLON,
    STATE(5082), 1,
      sym_template_argument_list,
    STATE(5710), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9249), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2123), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2115), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [217019] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(9223), 1,
      anon_sym_STAR,
    ACTIONS(9225), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9227), 1,
      anon_sym_AMP,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4588), 1,
      sym_parameter_list,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(8260), 1,
      sym__abstract_declarator,
    ACTIONS(8154), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5452), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7418), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8150), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [217086] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    STATE(355), 1,
      sym_attribute_specifier,
    ACTIONS(3791), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3793), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [217131] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8398), 1,
      anon_sym_DASH_GT,
    ACTIONS(8466), 1,
      anon_sym_requires,
    ACTIONS(8468), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(10217), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6295), 1,
      sym_ref_qualifier,
    STATE(7220), 1,
      sym_where_clause,
    STATE(7225), 1,
      sym__function_attributes_end,
    STATE(7350), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8285), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(6505), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [217214] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8511), 1,
      anon_sym_AMP,
    ACTIONS(9863), 1,
      anon_sym_const,
    STATE(5665), 1,
      sym_alignas_qualifier,
    ACTIONS(10223), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6068), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(10220), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8513), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [217265] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(9197), 1,
      anon_sym_STAR,
    ACTIONS(9199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9201), 1,
      anon_sym_AMP,
    STATE(4541), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8349), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8902), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [217332] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(8289), 1,
      anon_sym_noexcept,
    ACTIONS(8291), 1,
      anon_sym_throw,
    ACTIONS(8406), 1,
      anon_sym_DASH_GT,
    ACTIONS(10226), 1,
      anon_sym_requires,
    ACTIONS(10229), 1,
      anon_sym_where,
    STATE(6344), 1,
      sym_ref_qualifier,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7258), 1,
      sym__function_attributes_end,
    STATE(7557), 1,
      sym_trailing_return_type,
    STATE(8408), 1,
      sym_gnu_asm_expression,
    ACTIONS(8283), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9512), 2,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
    ACTIONS(9514), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(10166), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7342), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8111), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6498), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [217415] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    STATE(378), 1,
      sym_attribute_specifier,
    ACTIONS(3795), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3797), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [217460] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    STATE(349), 1,
      sym_attribute_specifier,
    ACTIONS(3731), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3733), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [217505] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    STATE(298), 1,
      sym_attribute_specifier,
    ACTIONS(3725), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3727), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [217550] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8156), 1,
      anon_sym_DASH_GT,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10069), 1,
      anon_sym_requires,
    ACTIONS(10232), 1,
      anon_sym_where,
    STATE(6983), 1,
      sym__function_attributes_end,
    STATE(7112), 1,
      sym_trailing_return_type,
    STATE(7196), 1,
      sym_where_clause,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10066), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7610), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6461), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10062), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [217627] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9869), 1,
      anon_sym_LT,
    ACTIONS(10235), 1,
      anon_sym_COLON,
    STATE(5082), 1,
      sym_template_argument_list,
    STATE(5710), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9249), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2123), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2115), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [217680] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6750), 1,
      anon_sym_LBRACE,
    ACTIONS(10058), 1,
      anon_sym___attribute__,
    STATE(2933), 1,
      sym_attribute_specifier,
    STATE(6166), 1,
      sym_enumerator_list,
    ACTIONS(3717), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(3715), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [217729] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    STATE(369), 1,
      sym_attribute_specifier,
    ACTIONS(3735), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3737), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [217774] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    STATE(297), 1,
      sym_attribute_specifier,
    ACTIONS(3836), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3838), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [217819] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8412), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(10204), 1,
      anon_sym_requires,
    ACTIONS(10237), 1,
      anon_sym_where,
    STATE(6268), 1,
      sym_ref_qualifier,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7267), 1,
      sym__function_attributes_end,
    STATE(7514), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8043), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(6514), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [217902] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9869), 1,
      anon_sym_LT,
    ACTIONS(10240), 1,
      anon_sym_COLON,
    STATE(5082), 1,
      sym_template_argument_list,
    STATE(5710), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9249), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2123), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2115), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [217955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6138), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(6136), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [217996] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8156), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9519), 1,
      anon_sym_requires,
    ACTIONS(10138), 1,
      anon_sym_where,
    STATE(7006), 1,
      sym__function_attributes_end,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7149), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7609), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6459), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [218073] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    STATE(357), 1,
      sym_attribute_specifier,
    ACTIONS(3799), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3801), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [218118] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6134), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(6132), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [218159] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(9197), 1,
      anon_sym_STAR,
    ACTIONS(9199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9201), 1,
      anon_sym_AMP,
    STATE(4541), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8344), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7418), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [218226] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8156), 1,
      anon_sym_DASH_GT,
    ACTIONS(8193), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    STATE(6989), 1,
      sym__function_attributes_end,
    STATE(7110), 1,
      sym_trailing_return_type,
    STATE(7196), 1,
      sym_where_clause,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8044), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6462), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10062), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [218303] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8156), 1,
      anon_sym_DASH_GT,
    ACTIONS(8193), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(6999), 1,
      sym__function_attributes_end,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7173), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8036), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6460), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [218380] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6750), 1,
      anon_sym_LBRACE,
    ACTIONS(10058), 1,
      anon_sym___attribute__,
    STATE(2896), 1,
      sym_attribute_specifier,
    STATE(6170), 1,
      sym_enumerator_list,
    ACTIONS(3713), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(3711), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [218429] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(9099), 1,
      anon_sym_STAR,
    ACTIONS(9101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9103), 1,
      anon_sym_AMP,
    STATE(4478), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8316), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8902), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_GT2,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [218496] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(9223), 1,
      anon_sym_STAR,
    ACTIONS(9225), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9227), 1,
      anon_sym_AMP,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4588), 1,
      sym_parameter_list,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(8277), 1,
      sym__abstract_declarator,
    ACTIONS(8154), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5452), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8842), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8150), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [218563] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8398), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(10217), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10242), 1,
      anon_sym_requires,
    ACTIONS(10245), 1,
      anon_sym_where,
    STATE(6314), 1,
      sym_ref_qualifier,
    STATE(7124), 1,
      sym__function_attributes_end,
    STATE(7220), 1,
      sym_where_clause,
    STATE(7448), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9763), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7976), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(6512), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [218646] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    STATE(434), 1,
      sym_attribute_specifier,
    ACTIONS(3719), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3721), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [218691] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(9099), 1,
      anon_sym_STAR,
    ACTIONS(9101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9103), 1,
      anon_sym_AMP,
    STATE(4478), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8261), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6777), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_GT2,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [218758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6134), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6132), 21,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [218799] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    STATE(439), 1,
      sym_attribute_specifier,
    ACTIONS(3830), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3832), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [218844] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8412), 1,
      anon_sym_DASH_GT,
    ACTIONS(8417), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(6223), 1,
      sym_ref_qualifier,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7265), 1,
      sym__function_attributes_end,
    STATE(7495), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8499), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(6504), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [218927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6138), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6136), 21,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [218968] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    ACTIONS(9474), 1,
      anon_sym_LBRACE,
    STATE(5839), 1,
      sym_attribute_specifier,
    STATE(6160), 1,
      sym_enumerator_list,
    ACTIONS(3713), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3711), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [219017] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10248), 1,
      anon_sym___attribute__,
    STATE(6099), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(9563), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(9565), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [219062] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    ACTIONS(9474), 1,
      anon_sym_LBRACE,
    STATE(5778), 1,
      sym_attribute_specifier,
    STATE(6154), 1,
      sym_enumerator_list,
    ACTIONS(3717), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3715), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [219111] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(9197), 1,
      anon_sym_STAR,
    ACTIONS(9199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9201), 1,
      anon_sym_AMP,
    STATE(4541), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8265), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8842), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [219178] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    STATE(385), 1,
      sym_attribute_specifier,
    ACTIONS(3742), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3744), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [219223] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(9197), 1,
      anon_sym_STAR,
    ACTIONS(9199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9201), 1,
      anon_sym_AMP,
    STATE(4541), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8305), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6777), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [219290] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 1,
      anon_sym_AMP,
    ACTIONS(8289), 1,
      anon_sym_noexcept,
    ACTIONS(8291), 1,
      anon_sym_throw,
    ACTIONS(8406), 1,
      anon_sym_DASH_GT,
    ACTIONS(8408), 1,
      anon_sym_requires,
    ACTIONS(8410), 1,
      anon_sym_where,
    STATE(6224), 1,
      sym_ref_qualifier,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7309), 1,
      sym__function_attributes_end,
    STATE(7494), 1,
      sym_trailing_return_type,
    STATE(8408), 1,
      sym_gnu_asm_expression,
    ACTIONS(8283), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9512), 2,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
    ACTIONS(9514), 2,
      anon_sym_LBRACK,
      sym_identifier,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7342), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8500), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6513), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [219373] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(9223), 1,
      anon_sym_STAR,
    ACTIONS(9225), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9227), 1,
      anon_sym_AMP,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4588), 1,
      sym_parameter_list,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(8286), 1,
      sym__abstract_declarator,
    ACTIONS(8154), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5452), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6777), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8150), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [219440] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(9099), 1,
      anon_sym_STAR,
    ACTIONS(9101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9103), 1,
      anon_sym_AMP,
    STATE(4478), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8307), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8842), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_GT2,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [219507] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    STATE(427), 1,
      sym_attribute_specifier,
    ACTIONS(3746), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3748), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [219552] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(9223), 1,
      anon_sym_STAR,
    ACTIONS(9225), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9227), 1,
      anon_sym_AMP,
    STATE(2582), 1,
      sym_alignas_qualifier,
    STATE(4588), 1,
      sym_parameter_list,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(8291), 1,
      sym__abstract_declarator,
    ACTIONS(8154), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5452), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8902), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8150), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [219619] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8616), 1,
      anon_sym_LT,
    STATE(2816), 1,
      sym_template_argument_list,
    STATE(6128), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2123), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(10251), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2115), 21,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [219670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3846), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3844), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [219711] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8462), 1,
      anon_sym_const,
    ACTIONS(9099), 1,
      anon_sym_STAR,
    ACTIONS(9101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9103), 1,
      anon_sym_AMP,
    STATE(4478), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8258), 1,
      sym__abstract_declarator,
    ACTIONS(8464), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5991), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7418), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_GT2,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8452), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [219778] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8279), 1,
      anon_sym___attribute__,
    ACTIONS(8285), 1,
      anon_sym_DASH_GT,
    ACTIONS(8289), 1,
      anon_sym_noexcept,
    ACTIONS(8291), 1,
      anon_sym_throw,
    ACTIONS(8293), 1,
      anon_sym_requires,
    ACTIONS(8295), 1,
      anon_sym_where,
    STATE(7063), 1,
      sym__function_attributes_end,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7348), 1,
      sym_trailing_return_type,
    STATE(8412), 1,
      sym_gnu_asm_expression,
    ACTIONS(8283), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(10064), 2,
      anon_sym_LBRACK,
      sym_identifier,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7031), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8215), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6464), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10062), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
  [219854] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(9596), 1,
      anon_sym_STAR,
    ACTIONS(9598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9600), 1,
      anon_sym_AMP,
    STATE(4576), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8446), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8902), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6068), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [219920] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10253), 1,
      sym_identifier,
    ACTIONS(10259), 1,
      sym_primitive_type,
    STATE(6146), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(10256), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3822), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(3820), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [219968] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8279), 1,
      anon_sym___attribute__,
    ACTIONS(8285), 1,
      anon_sym_DASH_GT,
    ACTIONS(8289), 1,
      anon_sym_noexcept,
    ACTIONS(8291), 1,
      anon_sym_throw,
    ACTIONS(8293), 1,
      anon_sym_requires,
    ACTIONS(8295), 1,
      anon_sym_where,
    STATE(7058), 1,
      sym__function_attributes_end,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7243), 1,
      sym_trailing_return_type,
    STATE(8412), 1,
      sym_gnu_asm_expression,
    ACTIONS(8283), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9514), 2,
      anon_sym_LBRACK,
      sym_identifier,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7031), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8204), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6465), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
  [220044] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10266), 1,
      anon_sym_DOT,
    STATE(4847), 1,
      sym_alignas_qualifier,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6458), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(10264), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(10268), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10262), 8,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [220096] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8251), 1,
      anon_sym_DASH_GT,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8299), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    STATE(7068), 1,
      sym__function_attributes_end,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7302), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8221), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6463), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10062), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [220172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8820), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(8818), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [220212] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8279), 1,
      anon_sym___attribute__,
    ACTIONS(8285), 1,
      anon_sym_DASH_GT,
    ACTIONS(8289), 1,
      anon_sym_noexcept,
    ACTIONS(8291), 1,
      anon_sym_throw,
    ACTIONS(10169), 1,
      anon_sym_requires,
    ACTIONS(10172), 1,
      anon_sym_where,
    STATE(7059), 1,
      sym__function_attributes_end,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7319), 1,
      sym_trailing_return_type,
    STATE(8412), 1,
      sym_gnu_asm_expression,
    ACTIONS(8283), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9514), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(10166), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7031), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7770), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6466), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
  [220288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8840), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(8838), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [220328] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2738), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(10270), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3752), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(3750), 22,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [220372] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8251), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(10180), 1,
      anon_sym_requires,
    ACTIONS(10183), 1,
      anon_sym_where,
    STATE(7016), 1,
      sym__function_attributes_end,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7253), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7781), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6470), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [220448] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(9596), 1,
      anon_sym_STAR,
    ACTIONS(9598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9600), 1,
      anon_sym_AMP,
    STATE(4576), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8391), 1,
      sym__abstract_declarator,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8842), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6068), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [220514] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10266), 1,
      anon_sym_DOT,
    STATE(4847), 1,
      sym_alignas_qualifier,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6455), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(10268), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10275), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(10273), 8,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [220566] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DASH_GT,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    ACTIONS(10284), 1,
      anon_sym_requires,
    ACTIONS(10287), 1,
      anon_sym_where,
    STATE(6575), 1,
      sym__function_attributes_end,
    STATE(6817), 1,
      sym_trailing_return_type,
    STATE(7088), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10281), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7186), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [220636] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DASH_GT,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10069), 1,
      anon_sym_requires,
    ACTIONS(10072), 1,
      anon_sym_where,
    STATE(6574), 1,
      sym__function_attributes_end,
    STATE(6822), 1,
      sym_trailing_return_type,
    STATE(7196), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10066), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7184), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [220706] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9519), 1,
      anon_sym_requires,
    ACTIONS(9522), 1,
      anon_sym_where,
    STATE(6573), 1,
      sym__function_attributes_end,
    STATE(6823), 1,
      sym_trailing_return_type,
    STATE(7092), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7182), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [220776] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2738), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(10290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3759), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(3757), 22,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [220820] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2738), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(10293), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3812), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(3810), 22,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [220864] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8842), 1,
      anon_sym_COMMA,
    ACTIONS(9480), 1,
      anon_sym_STAR,
    ACTIONS(9482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9484), 1,
      anon_sym_AMP,
    ACTIONS(9926), 1,
      sym_identifier,
    STATE(4571), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8411), 1,
      sym__abstract_declarator,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [220930] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8902), 1,
      anon_sym_COMMA,
    ACTIONS(9480), 1,
      anon_sym_STAR,
    ACTIONS(9482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9484), 1,
      anon_sym_AMP,
    ACTIONS(9919), 1,
      sym_identifier,
    STATE(4571), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8495), 1,
      sym__abstract_declarator,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [220996] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2738), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(10296), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3805), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(3803), 22,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [221040] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8279), 1,
      anon_sym___attribute__,
    ACTIONS(8285), 1,
      anon_sym_DASH_GT,
    ACTIONS(8289), 1,
      anon_sym_noexcept,
    ACTIONS(8291), 1,
      anon_sym_throw,
    ACTIONS(10302), 1,
      anon_sym_requires,
    ACTIONS(10305), 1,
      anon_sym_where,
    STATE(7035), 1,
      sym__function_attributes_end,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7313), 1,
      sym_trailing_return_type,
    STATE(8412), 1,
      sym_gnu_asm_expression,
    ACTIONS(8283), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10064), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(10299), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7031), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7767), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6468), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10062), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
  [221116] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(9596), 1,
      anon_sym_STAR,
    ACTIONS(9598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9600), 1,
      anon_sym_AMP,
    STATE(4576), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8453), 1,
      sym__abstract_declarator,
    ACTIONS(7418), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6068), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [221182] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8251), 1,
      anon_sym_DASH_GT,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10308), 1,
      anon_sym_requires,
    ACTIONS(10311), 1,
      anon_sym_where,
    STATE(7053), 1,
      sym__function_attributes_end,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7275), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10066), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7773), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6469), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10062), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [221258] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_const,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(9596), 1,
      anon_sym_STAR,
    ACTIONS(9598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9600), 1,
      anon_sym_AMP,
    STATE(4576), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8438), 1,
      sym__abstract_declarator,
    ACTIONS(6777), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8590), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6068), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8584), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [221324] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3656), 1,
      anon_sym_LPAREN2,
    ACTIONS(4930), 1,
      anon_sym_LBRACE,
    STATE(2962), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3305), 1,
      sym_argument_list,
    STATE(4688), 1,
      sym_initializer_list,
    ACTIONS(2742), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6574), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2740), 21,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [221376] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DASH_GT,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(7471), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(6546), 1,
      sym__function_attributes_end,
    STATE(6850), 1,
      sym_trailing_return_type,
    STATE(7092), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7500), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [221446] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(6777), 1,
      anon_sym_COMMA,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(9480), 1,
      anon_sym_STAR,
    ACTIONS(9482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9484), 1,
      anon_sym_AMP,
    STATE(4571), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8517), 1,
      sym__abstract_declarator,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [221512] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(6121), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3390), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(3392), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [221554] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(6129), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(10314), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3766), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(3764), 22,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [221598] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4583), 1,
      anon_sym_LBRACE,
    ACTIONS(6379), 1,
      anon_sym_LPAREN2,
    STATE(2962), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4288), 1,
      sym_argument_list,
    STATE(4291), 1,
      sym_initializer_list,
    ACTIONS(2742), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6574), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2740), 21,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [221650] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_DOT,
    ACTIONS(3848), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(8530), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3850), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [221694] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DASH_GT,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(7471), 1,
      anon_sym_where,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    STATE(6552), 1,
      sym__function_attributes_end,
    STATE(6836), 1,
      sym_trailing_return_type,
    STATE(7088), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7507), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [221764] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_DOT,
    ACTIONS(3890), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(8530), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3892), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [221808] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2738), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(10317), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3781), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(3778), 22,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [221852] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(7418), 1,
      anon_sym_COMMA,
    ACTIONS(7420), 1,
      sym_identifier,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(9480), 1,
      anon_sym_STAR,
    ACTIONS(9482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9484), 1,
      anon_sym_AMP,
    STATE(4571), 1,
      sym_parameter_list,
    STATE(5665), 1,
      sym_alignas_qualifier,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8362), 1,
      sym__abstract_declarator,
    ACTIONS(4907), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(4901), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [221918] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8251), 1,
      anon_sym_DASH_GT,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8299), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(7048), 1,
      sym__function_attributes_end,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7347), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8225), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6472), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [221994] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(6132), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(10321), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3773), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(3771), 22,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [222038] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DASH_GT,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(7471), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    STATE(6549), 1,
      sym__function_attributes_end,
    STATE(6839), 1,
      sym_trailing_return_type,
    STATE(7196), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7501), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [222108] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    STATE(5816), 1,
      sym_attribute_specifier,
    ACTIONS(3801), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3799), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [222151] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    STATE(5802), 1,
      sym_attribute_specifier,
    ACTIONS(3748), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3746), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [222194] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    STATE(5833), 1,
      sym_attribute_specifier,
    ACTIONS(3842), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3840), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [222237] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    STATE(5792), 1,
      sym_attribute_specifier,
    ACTIONS(3838), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3836), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [222280] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    STATE(5771), 1,
      sym_attribute_specifier,
    ACTIONS(3737), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3735), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [222323] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2365), 1,
      anon_sym_LBRACE,
    ACTIONS(2369), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2742), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(2740), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [222366] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    STATE(5779), 1,
      sym_attribute_specifier,
    ACTIONS(3797), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3795), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [222409] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8372), 1,
      anon_sym_DASH_GT,
    ACTIONS(8393), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    STATE(7164), 1,
      sym__function_attributes_end,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7426), 1,
      sym_trailing_return_type,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8293), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6493), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10062), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [222484] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8982), 1,
      anon_sym_DOT,
    ACTIONS(8984), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3850), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(3848), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [222527] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    STATE(5769), 1,
      sym_attribute_specifier,
    ACTIONS(3733), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3731), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [222570] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    ACTIONS(9891), 1,
      sym_identifier,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7681), 1,
      sym__declarator,
    STATE(8585), 1,
      sym_type_hinted_declarator,
    STATE(9331), 1,
      sym_init_declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [222643] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    ACTIONS(9891), 1,
      sym_identifier,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7675), 1,
      sym__declarator,
    STATE(8563), 1,
      sym_type_hinted_declarator,
    STATE(9099), 1,
      sym_init_declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [222716] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8372), 1,
      anon_sym_DASH_GT,
    ACTIONS(8393), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7177), 1,
      sym__function_attributes_end,
    STATE(7430), 1,
      sym_trailing_return_type,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8270), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6487), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [222791] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7514), 1,
      anon_sym_DASH_GT,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    ACTIONS(10324), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10330), 1,
      anon_sym_requires,
    ACTIONS(10333), 1,
      anon_sym_where,
    STATE(6548), 1,
      sym__function_attributes_end,
    STATE(6847), 1,
      sym_trailing_return_type,
    STATE(7240), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10327), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7169), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [222860] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10058), 1,
      anon_sym___attribute__,
    STATE(2891), 1,
      sym_attribute_specifier,
    ACTIONS(3842), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(3840), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [222903] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10058), 1,
      anon_sym___attribute__,
    STATE(2897), 1,
      sym_attribute_specifier,
    ACTIONS(3838), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(3836), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [222946] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8372), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(10180), 1,
      anon_sym_requires,
    ACTIONS(10210), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7230), 1,
      sym__function_attributes_end,
    STATE(7381), 1,
      sym_trailing_return_type,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7953), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6482), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [223021] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10058), 1,
      anon_sym___attribute__,
    STATE(2935), 1,
      sym_attribute_specifier,
    ACTIONS(3737), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(3735), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [223064] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10058), 1,
      anon_sym___attribute__,
    STATE(2915), 1,
      sym_attribute_specifier,
    ACTIONS(3727), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(3725), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [223107] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10058), 1,
      anon_sym___attribute__,
    STATE(2893), 1,
      sym_attribute_specifier,
    ACTIONS(3733), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(3731), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [223150] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    STATE(5800), 1,
      sym_attribute_specifier,
    ACTIONS(3793), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3791), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [223193] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8372), 1,
      anon_sym_DASH_GT,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10308), 1,
      anon_sym_requires,
    ACTIONS(10336), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7229), 1,
      sym__function_attributes_end,
    STATE(7380), 1,
      sym_trailing_return_type,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10066), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7961), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6491), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10062), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [223268] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10058), 1,
      anon_sym___attribute__,
    STATE(2927), 1,
      sym_attribute_specifier,
    ACTIONS(3797), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(3795), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [223311] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10058), 1,
      anon_sym___attribute__,
    STATE(2889), 1,
      sym_attribute_specifier,
    ACTIONS(3793), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(3791), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [223354] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10058), 1,
      anon_sym___attribute__,
    STATE(2912), 1,
      sym_attribute_specifier,
    ACTIONS(3801), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(3799), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [223397] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7514), 1,
      anon_sym_DASH_GT,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7518), 1,
      anon_sym_where,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    ACTIONS(10324), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6566), 1,
      sym__function_attributes_end,
    STATE(6887), 1,
      sym_trailing_return_type,
    STATE(7240), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7486), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [223466] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8982), 1,
      anon_sym_DOT,
    ACTIONS(8984), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3892), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(3890), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [223509] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    ACTIONS(9891), 1,
      sym_identifier,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7688), 1,
      sym__declarator,
    STATE(8564), 1,
      sym_type_hinted_declarator,
    STATE(9402), 1,
      sym_init_declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [223582] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    ACTIONS(9891), 1,
      sym_identifier,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7626), 1,
      sym__declarator,
    STATE(8586), 1,
      sym_type_hinted_declarator,
    STATE(9172), 1,
      sym_init_declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [223655] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7514), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9690), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9766), 1,
      anon_sym_requires,
    ACTIONS(9769), 1,
      anon_sym_where,
    STATE(6534), 1,
      sym__function_attributes_end,
    STATE(6888), 1,
      sym_trailing_return_type,
    STATE(7220), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9763), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7144), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [223724] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    ACTIONS(9891), 1,
      sym_identifier,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7665), 1,
      sym__declarator,
    STATE(8562), 1,
      sym_type_hinted_declarator,
    STATE(9637), 1,
      sym_init_declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [223797] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    STATE(5858), 1,
      sym_attribute_specifier,
    ACTIONS(3832), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3830), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [223840] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8381), 1,
      anon_sym_DASH_GT,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10339), 1,
      anon_sym_requires,
    ACTIONS(10342), 1,
      anon_sym_where,
    STATE(7131), 1,
      sym__function_attributes_end,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7416), 1,
      sym_trailing_return_type,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10066), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7999), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6475), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10062), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [223915] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8381), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(10204), 1,
      anon_sym_requires,
    ACTIONS(10207), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7132), 1,
      sym__function_attributes_end,
    STATE(7415), 1,
      sym_trailing_return_type,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8014), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6490), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [223990] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7514), 1,
      anon_sym_DASH_GT,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10108), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10114), 1,
      anon_sym_requires,
    ACTIONS(10117), 1,
      anon_sym_where,
    STATE(6545), 1,
      sym__function_attributes_end,
    STATE(6880), 1,
      sym_trailing_return_type,
    STATE(7152), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10111), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7091), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [224059] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    ACTIONS(9891), 1,
      sym_identifier,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7699), 1,
      sym__declarator,
    STATE(8600), 1,
      sym_type_hinted_declarator,
    STATE(9269), 1,
      sym_init_declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [224132] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    STATE(5770), 1,
      sym_attribute_specifier,
    ACTIONS(3727), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3725), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [224175] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8381), 1,
      anon_sym_DASH_GT,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8385), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7162), 1,
      sym__function_attributes_end,
    STATE(7402), 1,
      sym_trailing_return_type,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8317), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6483), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9512), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [224250] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7514), 1,
      anon_sym_DASH_GT,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7518), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10108), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6563), 1,
      sym__function_attributes_end,
    STATE(6864), 1,
      sym_trailing_return_type,
    STATE(7152), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7560), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [224319] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    ACTIONS(9891), 1,
      sym_identifier,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7645), 1,
      sym__declarator,
    STATE(8600), 1,
      sym_type_hinted_declarator,
    STATE(9269), 1,
      sym_init_declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [224392] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    ACTIONS(9891), 1,
      sym_identifier,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7751), 1,
      sym__declarator,
    STATE(8757), 1,
      sym_type_hinted_declarator,
    STATE(9756), 1,
      sym_init_declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [224465] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    ACTIONS(9891), 1,
      sym_identifier,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7363), 1,
      sym__declarator,
    STATE(8600), 1,
      sym_type_hinted_declarator,
    STATE(9269), 1,
      sym_init_declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [224538] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10058), 1,
      anon_sym___attribute__,
    STATE(2920), 1,
      sym_attribute_specifier,
    ACTIONS(3744), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(3742), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [224581] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10058), 1,
      anon_sym___attribute__,
    STATE(2931), 1,
      sym_attribute_specifier,
    ACTIONS(3748), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(3746), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [224624] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    STATE(5847), 1,
      sym_attribute_specifier,
    ACTIONS(3721), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3719), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [224667] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7514), 1,
      anon_sym_DASH_GT,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7518), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9690), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6570), 1,
      sym__function_attributes_end,
    STATE(6779), 1,
      sym_trailing_return_type,
    STATE(7220), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7473), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [224736] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10058), 1,
      anon_sym___attribute__,
    STATE(2902), 1,
      sym_attribute_specifier,
    ACTIONS(3721), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(3719), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [224779] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10058), 1,
      anon_sym___attribute__,
    STATE(2887), 1,
      sym_attribute_specifier,
    ACTIONS(3832), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(3830), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [224822] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym___attribute__,
    STATE(5854), 1,
      sym_attribute_specifier,
    ACTIONS(3744), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3742), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [224865] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8381), 1,
      anon_sym_DASH_GT,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8385), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    STATE(7160), 1,
      sym__function_attributes_end,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7403), 1,
      sym_trailing_return_type,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8311), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6484), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10062), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [224940] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    ACTIONS(10347), 1,
      anon_sym_COLON_COLON,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(2762), 1,
      sym__class_declaration,
    STATE(6600), 1,
      sym_ms_declspec_modifier,
    STATE(8086), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2966), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6598), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6429), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [225020] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    ACTIONS(10349), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(5696), 1,
      sym_field_declaration_list,
    STATE(5851), 1,
      sym__class_declaration,
    STATE(5861), 1,
      sym__class_declaration_item,
    STATE(6609), 1,
      sym_ms_declspec_modifier,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(8921), 1,
      sym_virtual_specifier,
    STATE(10007), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5208), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6608), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6434), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [225100] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10351), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5794), 1,
      sym__class_declaration_item,
    STATE(5795), 1,
      sym__class_declaration,
    STATE(6152), 1,
      sym_field_declaration_list,
    STATE(6692), 1,
      sym_ms_declspec_modifier,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(8693), 1,
      sym_virtual_specifier,
    STATE(9696), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5971), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6690), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6391), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [225180] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10351), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5791), 1,
      sym__class_declaration,
    STATE(5794), 1,
      sym__class_declaration_item,
    STATE(6152), 1,
      sym_field_declaration_list,
    STATE(6692), 1,
      sym_ms_declspec_modifier,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(8693), 1,
      sym_virtual_specifier,
    STATE(9696), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5971), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6690), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6391), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [225260] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10351), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5790), 1,
      sym__class_declaration,
    STATE(5794), 1,
      sym__class_declaration_item,
    STATE(6152), 1,
      sym_field_declaration_list,
    STATE(6692), 1,
      sym_ms_declspec_modifier,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(8693), 1,
      sym_virtual_specifier,
    STATE(9696), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5971), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6690), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6391), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [225340] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6478), 1,
      anon_sym_LBRACE,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10353), 1,
      sym_identifier,
    STATE(2947), 1,
      sym_template_type,
    STATE(2986), 1,
      sym_field_declaration_list,
    STATE(3039), 1,
      sym__class_declaration_item,
    STATE(3048), 1,
      sym__class_declaration,
    STATE(6670), 1,
      sym_ms_declspec_modifier,
    STATE(8070), 1,
      sym__scope_resolution,
    STATE(8631), 1,
      sym_virtual_specifier,
    STATE(9941), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2857), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6669), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6416), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [225420] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6478), 1,
      anon_sym_LBRACE,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10353), 1,
      sym_identifier,
    STATE(2947), 1,
      sym_template_type,
    STATE(2986), 1,
      sym_field_declaration_list,
    STATE(3035), 1,
      sym__class_declaration,
    STATE(3039), 1,
      sym__class_declaration_item,
    STATE(6670), 1,
      sym_ms_declspec_modifier,
    STATE(8070), 1,
      sym__scope_resolution,
    STATE(8631), 1,
      sym_virtual_specifier,
    STATE(9941), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2857), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6669), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6416), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [225500] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6478), 1,
      anon_sym_LBRACE,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10353), 1,
      sym_identifier,
    STATE(2947), 1,
      sym_template_type,
    STATE(2986), 1,
      sym_field_declaration_list,
    STATE(3039), 1,
      sym__class_declaration_item,
    STATE(3043), 1,
      sym__class_declaration,
    STATE(6670), 1,
      sym_ms_declspec_modifier,
    STATE(8070), 1,
      sym__scope_resolution,
    STATE(8631), 1,
      sym_virtual_specifier,
    STATE(9941), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2857), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6669), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6416), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [225580] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10351), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5788), 1,
      sym__class_declaration,
    STATE(5794), 1,
      sym__class_declaration_item,
    STATE(6152), 1,
      sym_field_declaration_list,
    STATE(6692), 1,
      sym_ms_declspec_modifier,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(8693), 1,
      sym_virtual_specifier,
    STATE(9696), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5971), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6690), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6391), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [225660] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6478), 1,
      anon_sym_LBRACE,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10353), 1,
      sym_identifier,
    STATE(2947), 1,
      sym_template_type,
    STATE(2986), 1,
      sym_field_declaration_list,
    STATE(3039), 1,
      sym__class_declaration_item,
    STATE(3042), 1,
      sym__class_declaration,
    STATE(6670), 1,
      sym_ms_declspec_modifier,
    STATE(8070), 1,
      sym__scope_resolution,
    STATE(8631), 1,
      sym_virtual_specifier,
    STATE(9941), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2857), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6669), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6416), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [225740] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(5024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10355), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2753), 1,
      sym__class_declaration,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(6641), 1,
      sym_ms_declspec_modifier,
    STATE(8090), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6644), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6370), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [225820] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(5024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10355), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(2756), 1,
      sym__class_declaration,
    STATE(6641), 1,
      sym_ms_declspec_modifier,
    STATE(8090), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6644), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6370), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [225900] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10351), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5786), 1,
      sym__class_declaration,
    STATE(5794), 1,
      sym__class_declaration_item,
    STATE(6152), 1,
      sym_field_declaration_list,
    STATE(6692), 1,
      sym_ms_declspec_modifier,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(8693), 1,
      sym_virtual_specifier,
    STATE(9696), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5971), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6690), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6391), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [225980] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(5024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10355), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(2762), 1,
      sym__class_declaration,
    STATE(6641), 1,
      sym_ms_declspec_modifier,
    STATE(8090), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6644), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6370), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [226060] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(5024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10355), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(2764), 1,
      sym__class_declaration,
    STATE(6641), 1,
      sym_ms_declspec_modifier,
    STATE(8090), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6644), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6370), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [226140] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6478), 1,
      anon_sym_LBRACE,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10353), 1,
      sym_identifier,
    STATE(2947), 1,
      sym_template_type,
    STATE(2986), 1,
      sym_field_declaration_list,
    STATE(3038), 1,
      sym__class_declaration,
    STATE(3039), 1,
      sym__class_declaration_item,
    STATE(6670), 1,
      sym_ms_declspec_modifier,
    STATE(8070), 1,
      sym__scope_resolution,
    STATE(8631), 1,
      sym_virtual_specifier,
    STATE(9941), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2857), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6669), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6416), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [226220] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(5024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10355), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(2763), 1,
      sym__class_declaration,
    STATE(6641), 1,
      sym_ms_declspec_modifier,
    STATE(8090), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6644), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6370), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [226300] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(6121), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2740), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(10357), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2742), 21,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [226342] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(2762), 1,
      sym__class_declaration,
    STATE(6623), 1,
      sym_ms_declspec_modifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2693), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6624), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6449), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [226422] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8289), 1,
      anon_sym_noexcept,
    ACTIONS(8291), 1,
      anon_sym_throw,
    ACTIONS(8406), 1,
      anon_sym_DASH_GT,
    ACTIONS(8408), 1,
      anon_sym_requires,
    ACTIONS(8410), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7309), 1,
      sym__function_attributes_end,
    STATE(7494), 1,
      sym_trailing_return_type,
    STATE(8408), 1,
      sym_gnu_asm_expression,
    ACTIONS(8283), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9512), 2,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
    ACTIONS(9514), 2,
      anon_sym_LBRACK,
      sym_identifier,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7342), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8500), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6513), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [226496] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(2756), 1,
      sym__class_declaration,
    STATE(6623), 1,
      sym_ms_declspec_modifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2693), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6624), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6449), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [226576] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2753), 1,
      sym__class_declaration,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(6623), 1,
      sym_ms_declspec_modifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2693), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6624), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6449), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [226656] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8412), 1,
      anon_sym_DASH_GT,
    ACTIONS(8417), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7254), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8479), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(6518), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [226730] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8289), 1,
      anon_sym_noexcept,
    ACTIONS(8291), 1,
      anon_sym_throw,
    ACTIONS(8406), 1,
      anon_sym_DASH_GT,
    ACTIONS(8408), 1,
      anon_sym_requires,
    ACTIONS(8410), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7331), 1,
      sym__function_attributes_end,
    STATE(7542), 1,
      sym_trailing_return_type,
    STATE(8408), 1,
      sym_gnu_asm_expression,
    ACTIONS(8283), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(10062), 2,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
    ACTIONS(10064), 2,
      anon_sym_LBRACK,
      sym_identifier,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7342), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8481), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6506), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [226804] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10360), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2923), 1,
      sym__class_declaration_item,
    STATE(2936), 1,
      sym__class_declaration,
    STATE(3106), 1,
      sym_field_declaration_list,
    STATE(6693), 1,
      sym_ms_declspec_modifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(8739), 1,
      sym_virtual_specifier,
    STATE(9695), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2979), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6695), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6382), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [226884] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10360), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2911), 1,
      sym__class_declaration,
    STATE(2923), 1,
      sym__class_declaration_item,
    STATE(3106), 1,
      sym_field_declaration_list,
    STATE(6693), 1,
      sym_ms_declspec_modifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(8739), 1,
      sym_virtual_specifier,
    STATE(9695), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2979), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6695), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6382), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [226964] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2753), 1,
      sym__class_declaration,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(6623), 1,
      sym_ms_declspec_modifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2695), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6624), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6449), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [227044] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(2763), 1,
      sym__class_declaration,
    STATE(6623), 1,
      sym_ms_declspec_modifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6624), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6449), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [227124] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(2764), 1,
      sym__class_declaration,
    STATE(6623), 1,
      sym_ms_declspec_modifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6624), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6449), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [227204] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(2756), 1,
      sym__class_declaration,
    STATE(6623), 1,
      sym_ms_declspec_modifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2695), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6624), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6449), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [227284] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(2762), 1,
      sym__class_declaration,
    STATE(6623), 1,
      sym_ms_declspec_modifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2695), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6624), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6449), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [227364] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(8483), 1,
      anon_sym_LBRACE,
    ACTIONS(9938), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10362), 1,
      sym_identifier,
    STATE(4812), 1,
      sym_template_type,
    STATE(4947), 1,
      sym_field_declaration_list,
    STATE(5087), 1,
      sym__class_declaration_item,
    STATE(5096), 1,
      sym__class_declaration,
    STATE(6632), 1,
      sym_ms_declspec_modifier,
    STATE(8098), 1,
      sym__scope_resolution,
    STATE(8842), 1,
      sym_virtual_specifier,
    STATE(9876), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4644), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6731), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6381), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [227444] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6961), 1,
      anon_sym_LBRACE,
    ACTIONS(10024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10364), 1,
      sym_identifier,
    STATE(3345), 1,
      sym_template_type,
    STATE(3413), 1,
      sym_field_declaration_list,
    STATE(3561), 1,
      sym__class_declaration,
    STATE(3582), 1,
      sym__class_declaration_item,
    STATE(6716), 1,
      sym_ms_declspec_modifier,
    STATE(8107), 1,
      sym__scope_resolution,
    STATE(8854), 1,
      sym_virtual_specifier,
    STATE(9891), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3195), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6724), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6360), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [227524] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6961), 1,
      anon_sym_LBRACE,
    ACTIONS(10024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10364), 1,
      sym_identifier,
    STATE(3345), 1,
      sym_template_type,
    STATE(3413), 1,
      sym_field_declaration_list,
    STATE(3565), 1,
      sym__class_declaration,
    STATE(3582), 1,
      sym__class_declaration_item,
    STATE(6716), 1,
      sym_ms_declspec_modifier,
    STATE(8107), 1,
      sym__scope_resolution,
    STATE(8854), 1,
      sym_virtual_specifier,
    STATE(9891), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3195), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6724), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6360), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [227604] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10360), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2923), 1,
      sym__class_declaration_item,
    STATE(2928), 1,
      sym__class_declaration,
    STATE(3106), 1,
      sym_field_declaration_list,
    STATE(6693), 1,
      sym_ms_declspec_modifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(8739), 1,
      sym_virtual_specifier,
    STATE(9695), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2979), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6695), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6382), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [227684] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10366), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5794), 1,
      sym__class_declaration_item,
    STATE(5795), 1,
      sym__class_declaration,
    STATE(6635), 1,
      sym_ms_declspec_modifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6654), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6403), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [227764] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(2762), 1,
      sym__class_declaration,
    STATE(6623), 1,
      sym_ms_declspec_modifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6624), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6449), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [227844] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(2756), 1,
      sym__class_declaration,
    STATE(6623), 1,
      sym_ms_declspec_modifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6624), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6449), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [227924] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2753), 1,
      sym__class_declaration,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(6623), 1,
      sym_ms_declspec_modifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6624), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6449), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [228004] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10366), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5791), 1,
      sym__class_declaration,
    STATE(5794), 1,
      sym__class_declaration_item,
    STATE(6635), 1,
      sym_ms_declspec_modifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6654), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6403), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [228084] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(8483), 1,
      anon_sym_LBRACE,
    ACTIONS(9938), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10362), 1,
      sym_identifier,
    STATE(4812), 1,
      sym_template_type,
    STATE(4947), 1,
      sym_field_declaration_list,
    STATE(5087), 1,
      sym__class_declaration_item,
    STATE(5097), 1,
      sym__class_declaration,
    STATE(6632), 1,
      sym_ms_declspec_modifier,
    STATE(8098), 1,
      sym__scope_resolution,
    STATE(8842), 1,
      sym_virtual_specifier,
    STATE(9876), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4644), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6731), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6381), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [228164] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10366), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5790), 1,
      sym__class_declaration,
    STATE(5794), 1,
      sym__class_declaration_item,
    STATE(6635), 1,
      sym_ms_declspec_modifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6654), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6403), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [228244] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10366), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5788), 1,
      sym__class_declaration,
    STATE(5794), 1,
      sym__class_declaration_item,
    STATE(6635), 1,
      sym_ms_declspec_modifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6654), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6403), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [228324] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10366), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5786), 1,
      sym__class_declaration,
    STATE(5794), 1,
      sym__class_declaration_item,
    STATE(6635), 1,
      sym_ms_declspec_modifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6654), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6403), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [228404] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10360), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2923), 1,
      sym__class_declaration_item,
    STATE(2925), 1,
      sym__class_declaration,
    STATE(3106), 1,
      sym_field_declaration_list,
    STATE(6693), 1,
      sym_ms_declspec_modifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(8739), 1,
      sym_virtual_specifier,
    STATE(9695), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2979), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6695), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6382), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [228484] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10360), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2917), 1,
      sym__class_declaration,
    STATE(2923), 1,
      sym__class_declaration_item,
    STATE(3106), 1,
      sym_field_declaration_list,
    STATE(6693), 1,
      sym_ms_declspec_modifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(8739), 1,
      sym_virtual_specifier,
    STATE(9695), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2979), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6695), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6382), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [228564] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6961), 1,
      anon_sym_LBRACE,
    ACTIONS(10024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10364), 1,
      sym_identifier,
    STATE(3345), 1,
      sym_template_type,
    STATE(3413), 1,
      sym_field_declaration_list,
    STATE(3578), 1,
      sym__class_declaration,
    STATE(3582), 1,
      sym__class_declaration_item,
    STATE(6716), 1,
      sym_ms_declspec_modifier,
    STATE(8107), 1,
      sym__scope_resolution,
    STATE(8854), 1,
      sym_virtual_specifier,
    STATE(9891), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3195), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6724), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6360), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [228644] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8412), 1,
      anon_sym_DASH_GT,
    ACTIONS(8417), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7265), 1,
      sym__function_attributes_end,
    STATE(7495), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8499), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(6504), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [228718] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8398), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(10217), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10242), 1,
      anon_sym_requires,
    ACTIONS(10245), 1,
      anon_sym_where,
    STATE(7124), 1,
      sym__function_attributes_end,
    STATE(7220), 1,
      sym_where_clause,
    STATE(7448), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9763), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7976), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(6512), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [228792] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2753), 1,
      sym__class_declaration,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(6623), 1,
      sym_ms_declspec_modifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2698), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6624), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6449), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [228872] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(8483), 1,
      anon_sym_LBRACE,
    ACTIONS(9938), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10362), 1,
      sym_identifier,
    STATE(4812), 1,
      sym_template_type,
    STATE(4947), 1,
      sym_field_declaration_list,
    STATE(5087), 1,
      sym__class_declaration_item,
    STATE(5111), 1,
      sym__class_declaration,
    STATE(6632), 1,
      sym_ms_declspec_modifier,
    STATE(8098), 1,
      sym__scope_resolution,
    STATE(8842), 1,
      sym_virtual_specifier,
    STATE(9876), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4644), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6731), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6381), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [228952] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    ACTIONS(10347), 1,
      anon_sym_COLON_COLON,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(2763), 1,
      sym__class_declaration,
    STATE(6600), 1,
      sym_ms_declspec_modifier,
    STATE(8086), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2966), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6598), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6429), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [229032] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(8483), 1,
      anon_sym_LBRACE,
    ACTIONS(9938), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10362), 1,
      sym_identifier,
    STATE(4812), 1,
      sym_template_type,
    STATE(4947), 1,
      sym_field_declaration_list,
    STATE(5087), 1,
      sym__class_declaration_item,
    STATE(5123), 1,
      sym__class_declaration,
    STATE(6632), 1,
      sym_ms_declspec_modifier,
    STATE(8098), 1,
      sym__scope_resolution,
    STATE(8842), 1,
      sym_virtual_specifier,
    STATE(9876), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4644), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6731), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6381), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [229112] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6961), 1,
      anon_sym_LBRACE,
    ACTIONS(10024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10364), 1,
      sym_identifier,
    STATE(3345), 1,
      sym_template_type,
    STATE(3413), 1,
      sym_field_declaration_list,
    STATE(3580), 1,
      sym__class_declaration,
    STATE(3582), 1,
      sym__class_declaration_item,
    STATE(6716), 1,
      sym_ms_declspec_modifier,
    STATE(8107), 1,
      sym__scope_resolution,
    STATE(8854), 1,
      sym_virtual_specifier,
    STATE(9891), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3195), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6724), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6360), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [229192] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7278), 1,
      anon_sym_LBRACE,
    ACTIONS(9895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10368), 1,
      sym_identifier,
    STATE(3457), 1,
      sym_template_type,
    STATE(3606), 1,
      sym_field_declaration_list,
    STATE(3803), 1,
      sym__class_declaration_item,
    STATE(3810), 1,
      sym__class_declaration,
    STATE(6684), 1,
      sym_ms_declspec_modifier,
    STATE(8115), 1,
      sym__scope_resolution,
    STATE(8872), 1,
      sym_virtual_specifier,
    STATE(9918), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3341), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6682), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6373), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [229272] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7278), 1,
      anon_sym_LBRACE,
    ACTIONS(9895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10368), 1,
      sym_identifier,
    STATE(3457), 1,
      sym_template_type,
    STATE(3606), 1,
      sym_field_declaration_list,
    STATE(3799), 1,
      sym__class_declaration,
    STATE(3803), 1,
      sym__class_declaration_item,
    STATE(6684), 1,
      sym_ms_declspec_modifier,
    STATE(8115), 1,
      sym__scope_resolution,
    STATE(8872), 1,
      sym_virtual_specifier,
    STATE(9918), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3341), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6682), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6373), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [229352] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8412), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(10204), 1,
      anon_sym_requires,
    ACTIONS(10237), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7267), 1,
      sym__function_attributes_end,
    STATE(7514), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8043), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(6514), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [229426] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10370), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5794), 1,
      sym__class_declaration_item,
    STATE(5795), 1,
      sym__class_declaration,
    STATE(6630), 1,
      sym_ms_declspec_modifier,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6629), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6451), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [229506] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7278), 1,
      anon_sym_LBRACE,
    ACTIONS(9895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10368), 1,
      sym_identifier,
    STATE(3457), 1,
      sym_template_type,
    STATE(3606), 1,
      sym_field_declaration_list,
    STATE(3798), 1,
      sym__class_declaration,
    STATE(3803), 1,
      sym__class_declaration_item,
    STATE(6684), 1,
      sym_ms_declspec_modifier,
    STATE(8115), 1,
      sym__scope_resolution,
    STATE(8872), 1,
      sym_virtual_specifier,
    STATE(9918), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3341), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6682), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6373), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [229586] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6961), 1,
      anon_sym_LBRACE,
    ACTIONS(10024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10364), 1,
      sym_identifier,
    STATE(3345), 1,
      sym_template_type,
    STATE(3413), 1,
      sym_field_declaration_list,
    STATE(3582), 1,
      sym__class_declaration_item,
    STATE(3583), 1,
      sym__class_declaration,
    STATE(6716), 1,
      sym_ms_declspec_modifier,
    STATE(8107), 1,
      sym__scope_resolution,
    STATE(8854), 1,
      sym_virtual_specifier,
    STATE(9891), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3195), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6724), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6360), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [229666] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10370), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5791), 1,
      sym__class_declaration,
    STATE(5794), 1,
      sym__class_declaration_item,
    STATE(6630), 1,
      sym_ms_declspec_modifier,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6629), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6451), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [229746] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10370), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5790), 1,
      sym__class_declaration,
    STATE(5794), 1,
      sym__class_declaration_item,
    STATE(6630), 1,
      sym_ms_declspec_modifier,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6629), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6451), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [229826] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7278), 1,
      anon_sym_LBRACE,
    ACTIONS(9895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10368), 1,
      sym_identifier,
    STATE(3457), 1,
      sym_template_type,
    STATE(3606), 1,
      sym_field_declaration_list,
    STATE(3778), 1,
      sym__class_declaration,
    STATE(3803), 1,
      sym__class_declaration_item,
    STATE(6684), 1,
      sym_ms_declspec_modifier,
    STATE(8115), 1,
      sym__scope_resolution,
    STATE(8872), 1,
      sym_virtual_specifier,
    STATE(9918), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3341), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6682), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6373), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [229906] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7278), 1,
      anon_sym_LBRACE,
    ACTIONS(9895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10368), 1,
      sym_identifier,
    STATE(3457), 1,
      sym_template_type,
    STATE(3606), 1,
      sym_field_declaration_list,
    STATE(3776), 1,
      sym__class_declaration,
    STATE(3803), 1,
      sym__class_declaration_item,
    STATE(6684), 1,
      sym_ms_declspec_modifier,
    STATE(8115), 1,
      sym__scope_resolution,
    STATE(8872), 1,
      sym_virtual_specifier,
    STATE(9918), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3341), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6682), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6373), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [229986] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2753), 1,
      sym__class_declaration,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(6623), 1,
      sym_ms_declspec_modifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2690), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6624), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6449), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [230066] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    ACTIONS(10347), 1,
      anon_sym_COLON_COLON,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(2756), 1,
      sym__class_declaration,
    STATE(6600), 1,
      sym_ms_declspec_modifier,
    STATE(8086), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2966), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6598), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6429), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [230146] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(2756), 1,
      sym__class_declaration,
    STATE(6623), 1,
      sym_ms_declspec_modifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2690), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6624), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6449), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [230226] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8412), 1,
      anon_sym_DASH_GT,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10339), 1,
      anon_sym_requires,
    ACTIONS(10372), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7268), 1,
      sym__function_attributes_end,
    STATE(7516), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10066), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8051), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(6496), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [230300] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(2762), 1,
      sym__class_declaration,
    STATE(6623), 1,
      sym_ms_declspec_modifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2690), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6624), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6449), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [230380] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10370), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5788), 1,
      sym__class_declaration,
    STATE(5794), 1,
      sym__class_declaration_item,
    STATE(6630), 1,
      sym_ms_declspec_modifier,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6629), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6451), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [230460] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10375), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5794), 1,
      sym__class_declaration_item,
    STATE(5795), 1,
      sym__class_declaration,
    STATE(6706), 1,
      sym_ms_declspec_modifier,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6599), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6441), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [230540] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10375), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5791), 1,
      sym__class_declaration,
    STATE(5794), 1,
      sym__class_declaration_item,
    STATE(6706), 1,
      sym_ms_declspec_modifier,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6599), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6441), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [230620] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10375), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5790), 1,
      sym__class_declaration,
    STATE(5794), 1,
      sym__class_declaration_item,
    STATE(6706), 1,
      sym_ms_declspec_modifier,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6599), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6441), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [230700] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10375), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5788), 1,
      sym__class_declaration,
    STATE(5794), 1,
      sym__class_declaration_item,
    STATE(6706), 1,
      sym_ms_declspec_modifier,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6599), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6441), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [230780] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10375), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5786), 1,
      sym__class_declaration,
    STATE(5794), 1,
      sym__class_declaration_item,
    STATE(6706), 1,
      sym_ms_declspec_modifier,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6599), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6441), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [230860] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    ACTIONS(10347), 1,
      anon_sym_COLON_COLON,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2753), 1,
      sym__class_declaration,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(6600), 1,
      sym_ms_declspec_modifier,
    STATE(8086), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2966), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6598), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6429), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [230940] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    ACTIONS(10349), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(5696), 1,
      sym_field_declaration_list,
    STATE(5856), 1,
      sym__class_declaration,
    STATE(5861), 1,
      sym__class_declaration_item,
    STATE(6609), 1,
      sym_ms_declspec_modifier,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(8921), 1,
      sym_virtual_specifier,
    STATE(10007), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5208), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6608), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6434), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [231020] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    ACTIONS(10349), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(5696), 1,
      sym_field_declaration_list,
    STATE(5836), 1,
      sym__class_declaration,
    STATE(5861), 1,
      sym__class_declaration_item,
    STATE(6609), 1,
      sym_ms_declspec_modifier,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(8921), 1,
      sym_virtual_specifier,
    STATE(10007), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5208), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6608), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6434), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [231100] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    ACTIONS(10377), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(5696), 1,
      sym_field_declaration_list,
    STATE(5851), 1,
      sym__class_declaration,
    STATE(5861), 1,
      sym__class_declaration_item,
    STATE(6622), 1,
      sym_ms_declspec_modifier,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(8921), 1,
      sym_virtual_specifier,
    STATE(10007), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5208), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6619), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6437), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [231180] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9095), 1,
      anon_sym_DOT,
    ACTIONS(3890), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9097), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3892), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [231222] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10370), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5786), 1,
      sym__class_declaration,
    STATE(5794), 1,
      sym__class_declaration_item,
    STATE(6630), 1,
      sym_ms_declspec_modifier,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6629), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6451), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [231302] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    ACTIONS(10349), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(5696), 1,
      sym_field_declaration_list,
    STATE(5861), 1,
      sym__class_declaration_item,
    STATE(5863), 1,
      sym__class_declaration,
    STATE(6609), 1,
      sym_ms_declspec_modifier,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(8921), 1,
      sym_virtual_specifier,
    STATE(10007), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5208), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6608), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6434), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [231382] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8289), 1,
      anon_sym_noexcept,
    ACTIONS(8291), 1,
      anon_sym_throw,
    ACTIONS(8406), 1,
      anon_sym_DASH_GT,
    ACTIONS(10226), 1,
      anon_sym_requires,
    ACTIONS(10229), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7258), 1,
      sym__function_attributes_end,
    STATE(7557), 1,
      sym_trailing_return_type,
    STATE(8408), 1,
      sym_gnu_asm_expression,
    ACTIONS(8283), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9512), 2,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
    ACTIONS(9514), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(10166), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7342), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8111), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6498), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [231456] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    ACTIONS(10349), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(5696), 1,
      sym_field_declaration_list,
    STATE(5860), 1,
      sym__class_declaration,
    STATE(5861), 1,
      sym__class_declaration_item,
    STATE(6609), 1,
      sym_ms_declspec_modifier,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(8921), 1,
      sym_virtual_specifier,
    STATE(10007), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5208), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6608), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6434), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [231536] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    ACTIONS(10377), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(5696), 1,
      sym_field_declaration_list,
    STATE(5856), 1,
      sym__class_declaration,
    STATE(5861), 1,
      sym__class_declaration_item,
    STATE(6622), 1,
      sym_ms_declspec_modifier,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(8921), 1,
      sym_virtual_specifier,
    STATE(10007), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5208), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6619), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6437), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [231616] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10349), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(313), 1,
      sym__class_declaration,
    STATE(339), 1,
      sym__class_declaration_item,
    STATE(6107), 1,
      sym_field_declaration_list,
    STATE(6711), 1,
      sym_ms_declspec_modifier,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(8786), 1,
      sym_virtual_specifier,
    STATE(9784), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5693), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6715), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6379), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [231696] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10349), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(339), 1,
      sym__class_declaration_item,
    STATE(368), 1,
      sym__class_declaration,
    STATE(6107), 1,
      sym_field_declaration_list,
    STATE(6711), 1,
      sym_ms_declspec_modifier,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(8786), 1,
      sym_virtual_specifier,
    STATE(9784), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5693), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6715), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6379), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [231776] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9163), 1,
      anon_sym_DOT,
    ACTIONS(3890), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(8542), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3892), 24,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [231818] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(2762), 1,
      sym__class_declaration,
    STATE(6623), 1,
      sym_ms_declspec_modifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2689), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6624), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6449), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [231898] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9163), 1,
      anon_sym_DOT,
    ACTIONS(3848), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(8542), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3850), 24,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [231940] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(2756), 1,
      sym__class_declaration,
    STATE(6623), 1,
      sym_ms_declspec_modifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2689), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6624), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6449), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [232020] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10349), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(339), 1,
      sym__class_declaration_item,
    STATE(372), 1,
      sym__class_declaration,
    STATE(6107), 1,
      sym_field_declaration_list,
    STATE(6711), 1,
      sym_ms_declspec_modifier,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(8786), 1,
      sym_virtual_specifier,
    STATE(9784), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5693), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6715), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6379), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [232100] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10349), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(318), 1,
      sym__class_declaration,
    STATE(339), 1,
      sym__class_declaration_item,
    STATE(6107), 1,
      sym_field_declaration_list,
    STATE(6711), 1,
      sym_ms_declspec_modifier,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(8786), 1,
      sym_virtual_specifier,
    STATE(9784), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5693), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6715), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6379), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [232180] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10349), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(319), 1,
      sym__class_declaration,
    STATE(339), 1,
      sym__class_declaration_item,
    STATE(6107), 1,
      sym_field_declaration_list,
    STATE(6711), 1,
      sym_ms_declspec_modifier,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(8786), 1,
      sym_virtual_specifier,
    STATE(9784), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5693), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6715), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6379), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [232260] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8398), 1,
      anon_sym_DASH_GT,
    ACTIONS(8466), 1,
      anon_sym_requires,
    ACTIONS(8468), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10379), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7115), 1,
      sym__function_attributes_end,
    STATE(7152), 1,
      sym_where_clause,
    STATE(7459), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8245), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(6519), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [232334] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    ACTIONS(10377), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(5696), 1,
      sym_field_declaration_list,
    STATE(5836), 1,
      sym__class_declaration,
    STATE(5861), 1,
      sym__class_declaration_item,
    STATE(6622), 1,
      sym_ms_declspec_modifier,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(8921), 1,
      sym_virtual_specifier,
    STATE(10007), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5208), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6619), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6437), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [232414] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2753), 1,
      sym__class_declaration,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(6623), 1,
      sym_ms_declspec_modifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2689), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6624), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6449), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [232494] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    ACTIONS(10377), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(5696), 1,
      sym_field_declaration_list,
    STATE(5861), 1,
      sym__class_declaration_item,
    STATE(5863), 1,
      sym__class_declaration,
    STATE(6622), 1,
      sym_ms_declspec_modifier,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(8921), 1,
      sym_virtual_specifier,
    STATE(10007), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5208), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6619), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6437), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [232574] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    ACTIONS(10377), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(5696), 1,
      sym_field_declaration_list,
    STATE(5860), 1,
      sym__class_declaration,
    STATE(5861), 1,
      sym__class_declaration_item,
    STATE(6622), 1,
      sym_ms_declspec_modifier,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(8921), 1,
      sym_virtual_specifier,
    STATE(10007), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5208), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6619), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6437), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [232654] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    ACTIONS(10347), 1,
      anon_sym_COLON_COLON,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(2764), 1,
      sym__class_declaration,
    STATE(6600), 1,
      sym_ms_declspec_modifier,
    STATE(8086), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2966), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6598), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6429), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [232734] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(8483), 1,
      anon_sym_LBRACE,
    ACTIONS(9938), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10362), 1,
      sym_identifier,
    STATE(4812), 1,
      sym_template_type,
    STATE(4947), 1,
      sym_field_declaration_list,
    STATE(5085), 1,
      sym__class_declaration,
    STATE(5087), 1,
      sym__class_declaration_item,
    STATE(6632), 1,
      sym_ms_declspec_modifier,
    STATE(8098), 1,
      sym__scope_resolution,
    STATE(8842), 1,
      sym_virtual_specifier,
    STATE(9876), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4644), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6731), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6381), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [232814] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7067), 1,
      anon_sym_LBRACE,
    ACTIONS(9836), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10382), 1,
      sym_identifier,
    STATE(3393), 1,
      sym_template_type,
    STATE(3480), 1,
      sym_field_declaration_list,
    STATE(3676), 1,
      sym__class_declaration,
    STATE(3684), 1,
      sym__class_declaration_item,
    STATE(6603), 1,
      sym_ms_declspec_modifier,
    STATE(8075), 1,
      sym__scope_resolution,
    STATE(8915), 1,
      sym_virtual_specifier,
    STATE(9997), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3238), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6604), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6430), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [232894] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(2756), 1,
      sym__class_declaration,
    STATE(6623), 1,
      sym_ms_declspec_modifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2698), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6624), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6449), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [232974] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(2762), 1,
      sym__class_declaration,
    STATE(6623), 1,
      sym_ms_declspec_modifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2698), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6624), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6449), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [233054] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7067), 1,
      anon_sym_LBRACE,
    ACTIONS(9836), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10382), 1,
      sym_identifier,
    STATE(3393), 1,
      sym_template_type,
    STATE(3480), 1,
      sym_field_declaration_list,
    STATE(3681), 1,
      sym__class_declaration,
    STATE(3684), 1,
      sym__class_declaration_item,
    STATE(6603), 1,
      sym_ms_declspec_modifier,
    STATE(8075), 1,
      sym__scope_resolution,
    STATE(8915), 1,
      sym_virtual_specifier,
    STATE(9997), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3238), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6604), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6430), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [233134] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7067), 1,
      anon_sym_LBRACE,
    ACTIONS(9836), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10382), 1,
      sym_identifier,
    STATE(3393), 1,
      sym_template_type,
    STATE(3480), 1,
      sym_field_declaration_list,
    STATE(3678), 1,
      sym__class_declaration,
    STATE(3684), 1,
      sym__class_declaration_item,
    STATE(6603), 1,
      sym_ms_declspec_modifier,
    STATE(8075), 1,
      sym__scope_resolution,
    STATE(8915), 1,
      sym_virtual_specifier,
    STATE(9997), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3238), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6604), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6430), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [233214] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7067), 1,
      anon_sym_LBRACE,
    ACTIONS(9836), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10382), 1,
      sym_identifier,
    STATE(3393), 1,
      sym_template_type,
    STATE(3480), 1,
      sym_field_declaration_list,
    STATE(3629), 1,
      sym__class_declaration,
    STATE(3684), 1,
      sym__class_declaration_item,
    STATE(6603), 1,
      sym_ms_declspec_modifier,
    STATE(8075), 1,
      sym__scope_resolution,
    STATE(8915), 1,
      sym_virtual_specifier,
    STATE(9997), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3238), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6604), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6430), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [233294] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7067), 1,
      anon_sym_LBRACE,
    ACTIONS(9836), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10382), 1,
      sym_identifier,
    STATE(3393), 1,
      sym_template_type,
    STATE(3480), 1,
      sym_field_declaration_list,
    STATE(3625), 1,
      sym__class_declaration,
    STATE(3684), 1,
      sym__class_declaration_item,
    STATE(6603), 1,
      sym_ms_declspec_modifier,
    STATE(8075), 1,
      sym__scope_resolution,
    STATE(8915), 1,
      sym_virtual_specifier,
    STATE(9997), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3238), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6604), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6430), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [233374] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10360), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2917), 1,
      sym__class_declaration,
    STATE(2923), 1,
      sym__class_declaration_item,
    STATE(6194), 1,
      sym_field_declaration_list,
    STATE(6705), 1,
      sym_ms_declspec_modifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(8705), 1,
      sym_virtual_specifier,
    STATE(9666), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5748), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6655), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6432), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [233454] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(10377), 1,
      sym_identifier,
    ACTIONS(10384), 1,
      anon_sym_COLON_COLON,
    STATE(195), 1,
      sym_template_type,
    STATE(313), 1,
      sym__class_declaration,
    STATE(339), 1,
      sym__class_declaration_item,
    STATE(6107), 1,
      sym_field_declaration_list,
    STATE(6685), 1,
      sym_ms_declspec_modifier,
    STATE(8061), 1,
      sym__scope_resolution,
    STATE(8786), 1,
      sym_virtual_specifier,
    STATE(9784), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5693), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6681), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6377), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [233534] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(10377), 1,
      sym_identifier,
    ACTIONS(10384), 1,
      anon_sym_COLON_COLON,
    STATE(195), 1,
      sym_template_type,
    STATE(339), 1,
      sym__class_declaration_item,
    STATE(368), 1,
      sym__class_declaration,
    STATE(6107), 1,
      sym_field_declaration_list,
    STATE(6685), 1,
      sym_ms_declspec_modifier,
    STATE(8061), 1,
      sym__scope_resolution,
    STATE(8786), 1,
      sym_virtual_specifier,
    STATE(9784), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5693), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6681), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6377), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [233614] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10360), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2923), 1,
      sym__class_declaration_item,
    STATE(2925), 1,
      sym__class_declaration,
    STATE(6194), 1,
      sym_field_declaration_list,
    STATE(6705), 1,
      sym_ms_declspec_modifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(8705), 1,
      sym_virtual_specifier,
    STATE(9666), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5748), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6655), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6432), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [233694] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10360), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2923), 1,
      sym__class_declaration_item,
    STATE(2928), 1,
      sym__class_declaration,
    STATE(6194), 1,
      sym_field_declaration_list,
    STATE(6705), 1,
      sym_ms_declspec_modifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(8705), 1,
      sym_virtual_specifier,
    STATE(9666), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5748), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6655), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6432), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [233774] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8398), 1,
      anon_sym_DASH_GT,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10379), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10386), 1,
      anon_sym_requires,
    ACTIONS(10389), 1,
      anon_sym_where,
    STATE(7152), 1,
      sym_where_clause,
    STATE(7198), 1,
      sym__function_attributes_end,
    STATE(7447), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10111), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7986), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(6508), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [233848] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10360), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2911), 1,
      sym__class_declaration,
    STATE(2923), 1,
      sym__class_declaration_item,
    STATE(6194), 1,
      sym_field_declaration_list,
    STATE(6705), 1,
      sym_ms_declspec_modifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(8705), 1,
      sym_virtual_specifier,
    STATE(9666), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5748), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6655), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6432), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [233928] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10360), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2923), 1,
      sym__class_declaration_item,
    STATE(2936), 1,
      sym__class_declaration,
    STATE(6194), 1,
      sym_field_declaration_list,
    STATE(6705), 1,
      sym_ms_declspec_modifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(8705), 1,
      sym_virtual_specifier,
    STATE(9666), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5748), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6655), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6432), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [234008] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(10130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10377), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(319), 1,
      sym__class_declaration,
    STATE(339), 1,
      sym__class_declaration_item,
    STATE(855), 1,
      sym_field_declaration_list,
    STATE(6625), 1,
      sym_ms_declspec_modifier,
    STATE(8132), 1,
      sym__scope_resolution,
    STATE(8882), 1,
      sym_virtual_specifier,
    STATE(9741), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(286), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6663), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6401), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [234088] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(10130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10377), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(318), 1,
      sym__class_declaration,
    STATE(339), 1,
      sym__class_declaration_item,
    STATE(855), 1,
      sym_field_declaration_list,
    STATE(6625), 1,
      sym_ms_declspec_modifier,
    STATE(8132), 1,
      sym__scope_resolution,
    STATE(8882), 1,
      sym_virtual_specifier,
    STATE(9741), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(286), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6663), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6401), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [234168] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(10146), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10392), 1,
      sym_identifier,
    STATE(309), 1,
      sym_template_type,
    STATE(626), 1,
      sym_field_declaration_list,
    STATE(741), 1,
      sym__class_declaration,
    STATE(751), 1,
      sym__class_declaration_item,
    STATE(6596), 1,
      sym_ms_declspec_modifier,
    STATE(8117), 1,
      sym__scope_resolution,
    STATE(8779), 1,
      sym_virtual_specifier,
    STATE(9782), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(245), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6717), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6408), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [234248] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(10146), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10392), 1,
      sym_identifier,
    STATE(309), 1,
      sym_template_type,
    STATE(626), 1,
      sym_field_declaration_list,
    STATE(751), 1,
      sym__class_declaration_item,
    STATE(769), 1,
      sym__class_declaration,
    STATE(6596), 1,
      sym_ms_declspec_modifier,
    STATE(8117), 1,
      sym__scope_resolution,
    STATE(8779), 1,
      sym_virtual_specifier,
    STATE(9782), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(245), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6717), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6408), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [234328] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(10377), 1,
      sym_identifier,
    ACTIONS(10384), 1,
      anon_sym_COLON_COLON,
    STATE(195), 1,
      sym_template_type,
    STATE(339), 1,
      sym__class_declaration_item,
    STATE(372), 1,
      sym__class_declaration,
    STATE(6107), 1,
      sym_field_declaration_list,
    STATE(6685), 1,
      sym_ms_declspec_modifier,
    STATE(8061), 1,
      sym__scope_resolution,
    STATE(8786), 1,
      sym_virtual_specifier,
    STATE(9784), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5693), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6681), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6377), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [234408] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(10377), 1,
      sym_identifier,
    ACTIONS(10384), 1,
      anon_sym_COLON_COLON,
    STATE(195), 1,
      sym_template_type,
    STATE(318), 1,
      sym__class_declaration,
    STATE(339), 1,
      sym__class_declaration_item,
    STATE(6107), 1,
      sym_field_declaration_list,
    STATE(6685), 1,
      sym_ms_declspec_modifier,
    STATE(8061), 1,
      sym__scope_resolution,
    STATE(8786), 1,
      sym_virtual_specifier,
    STATE(9784), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5693), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6681), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6377), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [234488] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(10377), 1,
      sym_identifier,
    ACTIONS(10384), 1,
      anon_sym_COLON_COLON,
    STATE(195), 1,
      sym_template_type,
    STATE(319), 1,
      sym__class_declaration,
    STATE(339), 1,
      sym__class_declaration_item,
    STATE(6107), 1,
      sym_field_declaration_list,
    STATE(6685), 1,
      sym_ms_declspec_modifier,
    STATE(8061), 1,
      sym__scope_resolution,
    STATE(8786), 1,
      sym_virtual_specifier,
    STATE(9784), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5693), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6681), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6377), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [234568] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(2762), 1,
      sym__class_declaration,
    STATE(6623), 1,
      sym_ms_declspec_modifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2691), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6624), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6449), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [234648] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(2762), 1,
      sym__class_declaration,
    STATE(6623), 1,
      sym_ms_declspec_modifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2697), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6624), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6449), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [234728] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(2756), 1,
      sym__class_declaration,
    STATE(6623), 1,
      sym_ms_declspec_modifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2691), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6624), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6449), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [234808] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2753), 1,
      sym__class_declaration,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(6623), 1,
      sym_ms_declspec_modifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2691), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6624), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6449), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [234888] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7760), 1,
      anon_sym_LBRACE,
    ACTIONS(9994), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10394), 1,
      sym_identifier,
    STATE(4552), 1,
      sym_template_type,
    STATE(4713), 1,
      sym_field_declaration_list,
    STATE(4767), 1,
      sym__class_declaration,
    STATE(4768), 1,
      sym__class_declaration_item,
    STATE(6722), 1,
      sym_ms_declspec_modifier,
    STATE(8035), 1,
      sym__scope_resolution,
    STATE(8765), 1,
      sym_virtual_specifier,
    STATE(9751), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3740), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6720), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6367), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [234968] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(10130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10377), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(339), 1,
      sym__class_declaration_item,
    STATE(372), 1,
      sym__class_declaration,
    STATE(855), 1,
      sym_field_declaration_list,
    STATE(6625), 1,
      sym_ms_declspec_modifier,
    STATE(8132), 1,
      sym__scope_resolution,
    STATE(8882), 1,
      sym_virtual_specifier,
    STATE(9741), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(286), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6663), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6401), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [235048] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(10130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10377), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(339), 1,
      sym__class_declaration_item,
    STATE(368), 1,
      sym__class_declaration,
    STATE(855), 1,
      sym_field_declaration_list,
    STATE(6625), 1,
      sym_ms_declspec_modifier,
    STATE(8132), 1,
      sym__scope_resolution,
    STATE(8882), 1,
      sym_virtual_specifier,
    STATE(9741), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(286), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6663), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6401), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [235128] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7760), 1,
      anon_sym_LBRACE,
    ACTIONS(9994), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10394), 1,
      sym_identifier,
    STATE(4552), 1,
      sym_template_type,
    STATE(4713), 1,
      sym_field_declaration_list,
    STATE(4768), 1,
      sym__class_declaration_item,
    STATE(4773), 1,
      sym__class_declaration,
    STATE(6722), 1,
      sym_ms_declspec_modifier,
    STATE(8035), 1,
      sym__scope_resolution,
    STATE(8765), 1,
      sym_virtual_specifier,
    STATE(9751), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3740), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6720), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6367), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [235208] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7760), 1,
      anon_sym_LBRACE,
    ACTIONS(9994), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10394), 1,
      sym_identifier,
    STATE(4552), 1,
      sym_template_type,
    STATE(4713), 1,
      sym_field_declaration_list,
    STATE(4768), 1,
      sym__class_declaration_item,
    STATE(4778), 1,
      sym__class_declaration,
    STATE(6722), 1,
      sym_ms_declspec_modifier,
    STATE(8035), 1,
      sym__scope_resolution,
    STATE(8765), 1,
      sym_virtual_specifier,
    STATE(9751), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3740), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6720), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6367), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [235288] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9095), 1,
      anon_sym_DOT,
    ACTIONS(3848), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9097), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3850), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [235330] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7457), 1,
      anon_sym_noexcept,
    ACTIONS(7459), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8398), 1,
      anon_sym_DASH_GT,
    ACTIONS(8466), 1,
      anon_sym_requires,
    ACTIONS(8468), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(10217), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7220), 1,
      sym_where_clause,
    STATE(7225), 1,
      sym__function_attributes_end,
    STATE(7350), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8285), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(6505), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [235404] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2365), 1,
      anon_sym_LBRACE,
    ACTIONS(2742), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(2740), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [235444] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(10146), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10392), 1,
      sym_identifier,
    STATE(309), 1,
      sym_template_type,
    STATE(626), 1,
      sym_field_declaration_list,
    STATE(751), 1,
      sym__class_declaration_item,
    STATE(752), 1,
      sym__class_declaration,
    STATE(6596), 1,
      sym_ms_declspec_modifier,
    STATE(8117), 1,
      sym__scope_resolution,
    STATE(8779), 1,
      sym_virtual_specifier,
    STATE(9782), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(245), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6717), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6408), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [235524] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(10130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10377), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(313), 1,
      sym__class_declaration,
    STATE(339), 1,
      sym__class_declaration_item,
    STATE(855), 1,
      sym_field_declaration_list,
    STATE(6625), 1,
      sym_ms_declspec_modifier,
    STATE(8132), 1,
      sym__scope_resolution,
    STATE(8882), 1,
      sym_virtual_specifier,
    STATE(9741), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(286), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6663), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6401), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [235604] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7760), 1,
      anon_sym_LBRACE,
    ACTIONS(9994), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10394), 1,
      sym_identifier,
    STATE(4552), 1,
      sym_template_type,
    STATE(4713), 1,
      sym_field_declaration_list,
    STATE(4768), 1,
      sym__class_declaration_item,
    STATE(4808), 1,
      sym__class_declaration,
    STATE(6722), 1,
      sym_ms_declspec_modifier,
    STATE(8035), 1,
      sym__scope_resolution,
    STATE(8765), 1,
      sym_virtual_specifier,
    STATE(9751), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3740), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6720), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6367), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [235684] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7760), 1,
      anon_sym_LBRACE,
    ACTIONS(9994), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10394), 1,
      sym_identifier,
    STATE(4552), 1,
      sym_template_type,
    STATE(4713), 1,
      sym_field_declaration_list,
    STATE(4768), 1,
      sym__class_declaration_item,
    STATE(4815), 1,
      sym__class_declaration,
    STATE(6722), 1,
      sym_ms_declspec_modifier,
    STATE(8035), 1,
      sym__scope_resolution,
    STATE(8765), 1,
      sym_virtual_specifier,
    STATE(9751), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3740), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6720), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6367), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [235764] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(9875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10396), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2923), 1,
      sym__class_declaration_item,
    STATE(2936), 1,
      sym__class_declaration,
    STATE(3106), 1,
      sym_field_declaration_list,
    STATE(6671), 1,
      sym_ms_declspec_modifier,
    STATE(8113), 1,
      sym__scope_resolution,
    STATE(8739), 1,
      sym_virtual_specifier,
    STATE(9695), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2979), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6656), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6372), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [235844] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(2756), 1,
      sym__class_declaration,
    STATE(6623), 1,
      sym_ms_declspec_modifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2697), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6624), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6449), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [235924] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(9875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10396), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2911), 1,
      sym__class_declaration,
    STATE(2923), 1,
      sym__class_declaration_item,
    STATE(3106), 1,
      sym_field_declaration_list,
    STATE(6671), 1,
      sym_ms_declspec_modifier,
    STATE(8113), 1,
      sym__scope_resolution,
    STATE(8739), 1,
      sym_virtual_specifier,
    STATE(9695), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2979), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6656), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6372), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [236004] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2753), 1,
      sym__class_declaration,
    STATE(2755), 1,
      sym__class_declaration_item,
    STATE(6623), 1,
      sym_ms_declspec_modifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2697), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6624), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6449), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [236084] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8289), 1,
      anon_sym_noexcept,
    ACTIONS(8291), 1,
      anon_sym_throw,
    ACTIONS(8406), 1,
      anon_sym_DASH_GT,
    ACTIONS(10398), 1,
      anon_sym_requires,
    ACTIONS(10401), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7244), 1,
      sym__function_attributes_end,
    STATE(7571), 1,
      sym_trailing_return_type,
    STATE(8408), 1,
      sym_gnu_asm_expression,
    ACTIONS(8283), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10062), 2,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
    ACTIONS(10064), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(10299), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7342), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8128), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6500), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [236158] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(9875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10396), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2923), 1,
      sym__class_declaration_item,
    STATE(2928), 1,
      sym__class_declaration,
    STATE(3106), 1,
      sym_field_declaration_list,
    STATE(6671), 1,
      sym_ms_declspec_modifier,
    STATE(8113), 1,
      sym__scope_resolution,
    STATE(8739), 1,
      sym_virtual_specifier,
    STATE(9695), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2979), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6656), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6372), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [236238] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(9875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10396), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2923), 1,
      sym__class_declaration_item,
    STATE(2925), 1,
      sym__class_declaration,
    STATE(3106), 1,
      sym_field_declaration_list,
    STATE(6671), 1,
      sym_ms_declspec_modifier,
    STATE(8113), 1,
      sym__scope_resolution,
    STATE(8739), 1,
      sym_virtual_specifier,
    STATE(9695), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2979), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6656), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6372), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [236318] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(9875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10396), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2917), 1,
      sym__class_declaration,
    STATE(2923), 1,
      sym__class_declaration_item,
    STATE(3106), 1,
      sym_field_declaration_list,
    STATE(6671), 1,
      sym_ms_declspec_modifier,
    STATE(8113), 1,
      sym__scope_resolution,
    STATE(8739), 1,
      sym_virtual_specifier,
    STATE(9695), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2979), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6656), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6372), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [236398] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(10146), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10392), 1,
      sym_identifier,
    STATE(309), 1,
      sym_template_type,
    STATE(626), 1,
      sym_field_declaration_list,
    STATE(750), 1,
      sym__class_declaration,
    STATE(751), 1,
      sym__class_declaration_item,
    STATE(6596), 1,
      sym_ms_declspec_modifier,
    STATE(8117), 1,
      sym__scope_resolution,
    STATE(8779), 1,
      sym_virtual_specifier,
    STATE(9782), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(245), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6717), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6408), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [236478] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(10146), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10392), 1,
      sym_identifier,
    STATE(309), 1,
      sym_template_type,
    STATE(626), 1,
      sym_field_declaration_list,
    STATE(749), 1,
      sym__class_declaration,
    STATE(751), 1,
      sym__class_declaration_item,
    STATE(6596), 1,
      sym_ms_declspec_modifier,
    STATE(8117), 1,
      sym__scope_resolution,
    STATE(8779), 1,
      sym_virtual_specifier,
    STATE(9782), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(245), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6717), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6408), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [236558] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6761), 1,
      sym_identifier,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7944), 1,
      anon_sym_STAR,
    ACTIONS(7946), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7948), 1,
      anon_sym_AMP,
    ACTIONS(7950), 1,
      anon_sym_COLON_COLON,
    STATE(6954), 1,
      sym__scope_resolution,
    STATE(7935), 1,
      sym__declarator,
    STATE(10201), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [236625] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7871), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [236692] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10404), 1,
      sym_identifier,
    ACTIONS(3386), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3388), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [236731] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7747), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [236798] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(7764), 1,
      anon_sym_requires,
    ACTIONS(7766), 1,
      anon_sym_where,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    ACTIONS(10324), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6753), 1,
      sym__function_attributes_end,
    STATE(6981), 1,
      sym_trailing_return_type,
    STATE(7240), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7918), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [236865] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7880), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [236932] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7867), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [236999] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7895), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [237066] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2397), 1,
      anon_sym_STAR,
    ACTIONS(2399), 1,
      anon_sym_AMP,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6140), 1,
      sym_identifier,
    ACTIONS(7072), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    STATE(6961), 1,
      sym__scope_resolution,
    STATE(7857), 1,
      sym__declarator,
    STATE(10814), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [237133] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7777), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9690), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9766), 1,
      anon_sym_requires,
    ACTIONS(10075), 1,
      anon_sym___attribute__,
    ACTIONS(10078), 1,
      anon_sym_where,
    STATE(6597), 1,
      sym__function_attributes_end,
    STATE(6940), 1,
      sym_trailing_return_type,
    STATE(7220), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9763), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7291), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [237200] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6961), 1,
      anon_sym_LBRACE,
    ACTIONS(10024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10364), 1,
      sym_identifier,
    STATE(3345), 1,
      sym_template_type,
    STATE(3413), 1,
      sym_field_declaration_list,
    STATE(3541), 1,
      sym__class_declaration_item,
    STATE(6712), 1,
      sym_ms_declspec_modifier,
    STATE(8107), 1,
      sym__scope_resolution,
    STATE(8854), 1,
      sym_virtual_specifier,
    STATE(9891), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3195), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6710), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7194), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [237277] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7756), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [237344] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7750), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [237411] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10406), 1,
      sym_identifier,
    ACTIONS(3386), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3388), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [237450] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7785), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [237517] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7851), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [237584] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(7764), 1,
      anon_sym_requires,
    ACTIONS(7766), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10108), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6738), 1,
      sym__function_attributes_end,
    STATE(6994), 1,
      sym_trailing_return_type,
    STATE(7152), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7868), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [237651] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7760), 1,
      anon_sym_LBRACE,
    ACTIONS(9994), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10394), 1,
      sym_identifier,
    STATE(4552), 1,
      sym_template_type,
    STATE(4713), 1,
      sym_field_declaration_list,
    STATE(4793), 1,
      sym__class_declaration_item,
    STATE(6707), 1,
      sym_ms_declspec_modifier,
    STATE(8035), 1,
      sym__scope_resolution,
    STATE(8765), 1,
      sym_virtual_specifier,
    STATE(9751), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3740), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6708), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7194), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [237728] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10408), 1,
      sym_identifier,
    ACTIONS(3386), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3388), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [237767] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10410), 1,
      sym_identifier,
    ACTIONS(3386), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3388), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [237806] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(5024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10355), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2734), 1,
      sym__class_declaration_item,
    STATE(6652), 1,
      sym_ms_declspec_modifier,
    STATE(8090), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6649), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7194), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [237883] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7837), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [237950] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(9875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10396), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2907), 1,
      sym__class_declaration_item,
    STATE(3106), 1,
      sym_field_declaration_list,
    STATE(6637), 1,
      sym_ms_declspec_modifier,
    STATE(8113), 1,
      sym__scope_resolution,
    STATE(8739), 1,
      sym_virtual_specifier,
    STATE(9695), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2979), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6698), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7194), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [238027] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7278), 1,
      anon_sym_LBRACE,
    ACTIONS(9895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10368), 1,
      sym_identifier,
    STATE(3457), 1,
      sym_template_type,
    STATE(3606), 1,
      sym_field_declaration_list,
    STATE(3967), 1,
      sym__class_declaration_item,
    STATE(6651), 1,
      sym_ms_declspec_modifier,
    STATE(8115), 1,
      sym__scope_resolution,
    STATE(8872), 1,
      sym_virtual_specifier,
    STATE(9918), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3341), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6668), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7194), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [238104] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10412), 1,
      sym_identifier,
    ACTIONS(3386), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3388), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [238143] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10414), 1,
      sym_identifier,
    ACTIONS(3386), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3388), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [238182] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(7764), 1,
      anon_sym_requires,
    ACTIONS(7766), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9690), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6749), 1,
      sym__function_attributes_end,
    STATE(6998), 1,
      sym_trailing_return_type,
    STATE(7220), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7850), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [238249] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(10377), 1,
      sym_identifier,
    ACTIONS(10384), 1,
      anon_sym_COLON_COLON,
    STATE(195), 1,
      sym_template_type,
    STATE(436), 1,
      sym__class_declaration_item,
    STATE(6107), 1,
      sym_field_declaration_list,
    STATE(6677), 1,
      sym_ms_declspec_modifier,
    STATE(8061), 1,
      sym__scope_resolution,
    STATE(8786), 1,
      sym_virtual_specifier,
    STATE(9784), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5693), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7194), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [238326] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2397), 1,
      anon_sym_STAR,
    ACTIONS(2399), 1,
      anon_sym_AMP,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6140), 1,
      sym_identifier,
    ACTIONS(7072), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    STATE(6961), 1,
      sym__scope_resolution,
    STATE(8220), 1,
      sym__declarator,
    STATE(10814), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [238393] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10349), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(436), 1,
      sym__class_declaration_item,
    STATE(6107), 1,
      sym_field_declaration_list,
    STATE(6721), 1,
      sym_ms_declspec_modifier,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(8786), 1,
      sym_virtual_specifier,
    STATE(9784), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5693), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6718), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7194), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [238470] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7777), 1,
      anon_sym_DASH_GT,
    ACTIONS(7782), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9690), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10075), 1,
      anon_sym___attribute__,
    STATE(6680), 1,
      sym__function_attributes_end,
    STATE(6913), 1,
      sym_trailing_return_type,
    STATE(7220), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7602), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [238537] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(8483), 1,
      anon_sym_LBRACE,
    ACTIONS(9938), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10362), 1,
      sym_identifier,
    STATE(4812), 1,
      sym_template_type,
    STATE(4947), 1,
      sym_field_declaration_list,
    STATE(5083), 1,
      sym__class_declaration_item,
    STATE(6713), 1,
      sym_ms_declspec_modifier,
    STATE(8098), 1,
      sym__scope_resolution,
    STATE(8842), 1,
      sym_virtual_specifier,
    STATE(9876), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4644), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7194), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [238614] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10360), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2907), 1,
      sym__class_declaration_item,
    STATE(3106), 1,
      sym_field_declaration_list,
    STATE(6732), 1,
      sym_ms_declspec_modifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(8739), 1,
      sym_virtual_specifier,
    STATE(9695), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2979), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6729), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7194), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [238691] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10416), 1,
      sym_identifier,
    ACTIONS(3386), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3388), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [238730] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7845), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [238797] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6140), 1,
      sym_identifier,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(8088), 1,
      anon_sym_STAR,
    ACTIONS(8090), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8092), 1,
      anon_sym_AMP,
    ACTIONS(8094), 1,
      anon_sym_COLON_COLON,
    STATE(6902), 1,
      sym__scope_resolution,
    STATE(8158), 1,
      sym__declarator,
    STATE(10164), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [238864] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7828), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [238931] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7730), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [238998] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2397), 1,
      anon_sym_STAR,
    ACTIONS(2399), 1,
      anon_sym_AMP,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6140), 1,
      sym_identifier,
    ACTIONS(7072), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    STATE(6961), 1,
      sym__scope_resolution,
    STATE(8145), 1,
      sym__declarator,
    STATE(10814), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [239065] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7744), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [239132] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7846), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [239199] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10351), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5853), 1,
      sym__class_declaration_item,
    STATE(6152), 1,
      sym_field_declaration_list,
    STATE(6675), 1,
      sym_ms_declspec_modifier,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(8693), 1,
      sym_virtual_specifier,
    STATE(9696), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5971), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6686), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7194), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [239276] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10418), 1,
      sym_identifier,
    ACTIONS(3386), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3388), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [239315] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7841), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [239382] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7883), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [239449] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7777), 1,
      anon_sym_DASH_GT,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10108), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10114), 1,
      anon_sym_requires,
    ACTIONS(10186), 1,
      anon_sym___attribute__,
    ACTIONS(10189), 1,
      anon_sym_where,
    STATE(6606), 1,
      sym__function_attributes_end,
    STATE(6935), 1,
      sym_trailing_return_type,
    STATE(7152), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10111), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7288), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [239516] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7855), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [239583] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7766), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [239650] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10420), 1,
      sym_identifier,
    ACTIONS(3386), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3388), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [239689] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10266), 1,
      anon_sym_DOT,
    ACTIONS(3850), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(10268), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3848), 22,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [239730] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2397), 1,
      anon_sym_STAR,
    ACTIONS(2399), 1,
      anon_sym_AMP,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6140), 1,
      sym_identifier,
    ACTIONS(7072), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    STATE(6961), 1,
      sym__scope_resolution,
    STATE(8167), 1,
      sym__declarator,
    STATE(10814), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [239797] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(10130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10377), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(436), 1,
      sym__class_declaration_item,
    STATE(855), 1,
      sym_field_declaration_list,
    STATE(6709), 1,
      sym_ms_declspec_modifier,
    STATE(8132), 1,
      sym__scope_resolution,
    STATE(8882), 1,
      sym_virtual_specifier,
    STATE(9741), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(286), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6714), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7194), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [239874] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7772), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [239941] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10366), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5853), 1,
      sym__class_declaration_item,
    STATE(6688), 1,
      sym_ms_declspec_modifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6687), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7194), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [240018] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2397), 1,
      anon_sym_STAR,
    ACTIONS(2399), 1,
      anon_sym_AMP,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6140), 1,
      sym_identifier,
    ACTIONS(7072), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    STATE(6961), 1,
      sym__scope_resolution,
    STATE(8211), 1,
      sym__declarator,
    STATE(10814), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [240085] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10422), 1,
      sym_identifier,
    ACTIONS(3386), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3388), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [240124] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10424), 1,
      sym_identifier,
    ACTIONS(3386), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3388), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [240163] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9486), 1,
      anon_sym_DOT,
    ACTIONS(8984), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3850), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
    ACTIONS(3848), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [240204] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(10146), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10392), 1,
      sym_identifier,
    STATE(309), 1,
      sym_template_type,
    STATE(626), 1,
      sym_field_declaration_list,
    STATE(675), 1,
      sym__class_declaration_item,
    STATE(6702), 1,
      sym_ms_declspec_modifier,
    STATE(8117), 1,
      sym__scope_resolution,
    STATE(8779), 1,
      sym_virtual_specifier,
    STATE(9782), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(245), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6703), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7194), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [240281] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10426), 1,
      sym_identifier,
    ACTIONS(3386), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3388), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [240320] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10428), 1,
      sym_identifier,
    ACTIONS(3386), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3388), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [240359] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6761), 1,
      sym_identifier,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7944), 1,
      anon_sym_STAR,
    ACTIONS(7946), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7948), 1,
      anon_sym_AMP,
    ACTIONS(7950), 1,
      anon_sym_COLON_COLON,
    STATE(6954), 1,
      sym__scope_resolution,
    STATE(8110), 1,
      sym__declarator,
    STATE(10201), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [240426] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7811), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [240493] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7718), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [240560] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10430), 1,
      sym_identifier,
    ACTIONS(3386), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3388), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [240599] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10432), 1,
      sym_identifier,
    ACTIONS(3386), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3388), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [240638] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6478), 1,
      anon_sym_LBRACE,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10353), 1,
      sym_identifier,
    STATE(2947), 1,
      sym_template_type,
    STATE(2986), 1,
      sym_field_declaration_list,
    STATE(3079), 1,
      sym__class_declaration_item,
    STATE(6664), 1,
      sym_ms_declspec_modifier,
    STATE(8070), 1,
      sym__scope_resolution,
    STATE(8631), 1,
      sym_virtual_specifier,
    STATE(9941), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2857), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6665), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7194), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [240715] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7777), 1,
      anon_sym_DASH_GT,
    ACTIONS(7782), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10108), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10186), 1,
      anon_sym___attribute__,
    STATE(6666), 1,
      sym__function_attributes_end,
    STATE(6903), 1,
      sym_trailing_return_type,
    STATE(7152), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7649), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [240782] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2397), 1,
      anon_sym_STAR,
    ACTIONS(2399), 1,
      anon_sym_AMP,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6140), 1,
      sym_identifier,
    ACTIONS(7072), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    STATE(6961), 1,
      sym__scope_resolution,
    STATE(8208), 1,
      sym__declarator,
    STATE(10814), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [240849] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9690), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10081), 1,
      anon_sym_requires,
    ACTIONS(10084), 1,
      anon_sym_where,
    STATE(6799), 1,
      sym__function_attributes_end,
    STATE(6977), 1,
      sym_trailing_return_type,
    STATE(7220), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9763), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7391), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [240916] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6140), 1,
      sym_identifier,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(8088), 1,
      anon_sym_STAR,
    ACTIONS(8090), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8092), 1,
      anon_sym_AMP,
    ACTIONS(8094), 1,
      anon_sym_COLON_COLON,
    STATE(6902), 1,
      sym__scope_resolution,
    STATE(8166), 1,
      sym__declarator,
    STATE(10164), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [240983] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(3386), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3388), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [241022] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10108), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10192), 1,
      anon_sym_requires,
    ACTIONS(10195), 1,
      anon_sym_where,
    STATE(6803), 1,
      sym__function_attributes_end,
    STATE(6972), 1,
      sym_trailing_return_type,
    STATE(7152), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10111), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7390), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [241089] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10436), 1,
      sym_identifier,
    ACTIONS(3386), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3388), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [241128] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6761), 1,
      sym_identifier,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7286), 1,
      sym__declarator,
    STATE(10435), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [241195] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    ACTIONS(10324), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10438), 1,
      anon_sym_requires,
    ACTIONS(10441), 1,
      anon_sym_where,
    STATE(6807), 1,
      sym__function_attributes_end,
    STATE(6992), 1,
      sym_trailing_return_type,
    STATE(7240), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10327), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7389), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [241262] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7857), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [241329] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10444), 1,
      sym_identifier,
    ACTIONS(3386), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3388), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [241368] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7733), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [241435] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    ACTIONS(10347), 1,
      anon_sym_COLON_COLON,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2734), 1,
      sym__class_declaration_item,
    STATE(6639), 1,
      sym_ms_declspec_modifier,
    STATE(8086), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2966), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6638), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7194), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [241512] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7067), 1,
      anon_sym_LBRACE,
    ACTIONS(9836), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10382), 1,
      sym_identifier,
    STATE(3393), 1,
      sym_template_type,
    STATE(3480), 1,
      sym_field_declaration_list,
    STATE(3622), 1,
      sym__class_declaration_item,
    STATE(6610), 1,
      sym_ms_declspec_modifier,
    STATE(8075), 1,
      sym__scope_resolution,
    STATE(8915), 1,
      sym_virtual_specifier,
    STATE(9997), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3238), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6607), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7194), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [241589] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7739), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [241656] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10360), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2907), 1,
      sym__class_declaration_item,
    STATE(6194), 1,
      sym_field_declaration_list,
    STATE(6667), 1,
      sym_ms_declspec_modifier,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(8705), 1,
      sym_virtual_specifier,
    STATE(9666), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5748), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6661), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7194), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [241733] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10446), 1,
      sym_identifier,
    ACTIONS(3386), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3388), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [241772] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    ACTIONS(10349), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(5696), 1,
      sym_field_declaration_list,
    STATE(5780), 1,
      sym__class_declaration_item,
    STATE(6601), 1,
      sym_ms_declspec_modifier,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(8921), 1,
      sym_virtual_specifier,
    STATE(10007), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5208), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6602), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7194), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [241849] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7777), 1,
      anon_sym_DASH_GT,
    ACTIONS(7782), 1,
      anon_sym_where,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    ACTIONS(10324), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10448), 1,
      anon_sym___attribute__,
    STATE(6640), 1,
      sym__function_attributes_end,
    STATE(6906), 1,
      sym_trailing_return_type,
    STATE(7240), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7591), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [241916] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10451), 1,
      sym_identifier,
    ACTIONS(3386), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3388), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [241955] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    ACTIONS(10377), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(5696), 1,
      sym_field_declaration_list,
    STATE(5780), 1,
      sym__class_declaration_item,
    STATE(6616), 1,
      sym_ms_declspec_modifier,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(8921), 1,
      sym_virtual_specifier,
    STATE(10007), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5208), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6615), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7194), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [242032] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10453), 1,
      sym_identifier,
    ACTIONS(3386), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3388), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [242071] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7777), 1,
      anon_sym_DASH_GT,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    ACTIONS(10324), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10330), 1,
      anon_sym_requires,
    ACTIONS(10448), 1,
      anon_sym___attribute__,
    ACTIONS(10455), 1,
      anon_sym_where,
    STATE(6605), 1,
      sym__function_attributes_end,
    STATE(6951), 1,
      sym_trailing_return_type,
    STATE(7240), 1,
      sym_where_clause,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10327), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7285), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [242138] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10458), 1,
      sym_identifier,
    ACTIONS(3386), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3388), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [242177] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10375), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5853), 1,
      sym__class_declaration_item,
    STATE(6620), 1,
      sym_ms_declspec_modifier,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6618), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7194), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [242254] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10460), 1,
      sym_identifier,
    ACTIONS(3386), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3388), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [242293] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10462), 1,
      sym_identifier,
    ACTIONS(3386), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3388), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [242332] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10464), 1,
      sym_identifier,
    ACTIONS(3386), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3388), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [242371] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9486), 1,
      anon_sym_DOT,
    ACTIONS(8984), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3892), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
    ACTIONS(3890), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [242412] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7793), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [242479] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7795), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [242546] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10466), 1,
      sym_identifier,
    ACTIONS(3386), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3388), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [242585] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2734), 1,
      sym__class_declaration_item,
    STATE(6659), 1,
      sym_ms_declspec_modifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6657), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7194), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [242662] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10468), 1,
      sym_identifier,
    ACTIONS(3386), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3388), 19,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [242701] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6154), 1,
      anon_sym___declspec,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10370), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5853), 1,
      sym__class_declaration_item,
    STATE(6627), 1,
      sym_ms_declspec_modifier,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6156), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6628), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7194), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [242778] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7774), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [242845] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10266), 1,
      anon_sym_DOT,
    ACTIONS(3892), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(10268), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3890), 22,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [242886] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2393), 1,
      anon_sym_LPAREN2,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7787), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_STAR,
    ACTIONS(7938), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(7907), 1,
      sym__declarator,
    STATE(10273), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7882), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [242953] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4847), 1,
      sym_alignas_qualifier,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(10472), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(10470), 8,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [242997] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8156), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9519), 1,
      anon_sym_requires,
    ACTIONS(10138), 1,
      anon_sym_where,
    STATE(7006), 1,
      sym__function_attributes_end,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7149), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7609), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [243063] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8156), 1,
      anon_sym_DASH_GT,
    ACTIONS(8193), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(6999), 1,
      sym__function_attributes_end,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7173), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8036), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [243129] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4847), 1,
      sym_alignas_qualifier,
    ACTIONS(8734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4724), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(10476), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(10474), 8,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(7446), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [243173] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8156), 1,
      anon_sym_DASH_GT,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10069), 1,
      anon_sym_requires,
    ACTIONS(10232), 1,
      anon_sym_where,
    STATE(6983), 1,
      sym__function_attributes_end,
    STATE(7112), 1,
      sym_trailing_return_type,
    STATE(7196), 1,
      sym_where_clause,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10066), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7610), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [243239] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8156), 1,
      anon_sym_DASH_GT,
    ACTIONS(8193), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    STATE(6989), 1,
      sym__function_attributes_end,
    STATE(7110), 1,
      sym_trailing_return_type,
    STATE(7196), 1,
      sym_where_clause,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8044), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [243305] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8156), 1,
      anon_sym_DASH_GT,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    ACTIONS(10284), 1,
      anon_sym_requires,
    ACTIONS(10478), 1,
      anon_sym_where,
    STATE(6993), 1,
      sym__function_attributes_end,
    STATE(7088), 1,
      sym_where_clause,
    STATE(7121), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10281), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7611), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [243371] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8156), 1,
      anon_sym_DASH_GT,
    ACTIONS(8193), 1,
      anon_sym_where,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    STATE(6979), 1,
      sym__function_attributes_end,
    STATE(7088), 1,
      sym_where_clause,
    STATE(7176), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8053), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [243437] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8251), 1,
      anon_sym_DASH_GT,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8299), 1,
      anon_sym_where,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    STATE(7085), 1,
      sym__function_attributes_end,
    STATE(7088), 1,
      sym_where_clause,
    STATE(7279), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8203), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [243502] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8279), 1,
      anon_sym___attribute__,
    ACTIONS(8285), 1,
      anon_sym_DASH_GT,
    ACTIONS(8293), 1,
      anon_sym_requires,
    ACTIONS(8295), 1,
      anon_sym_where,
    STATE(7047), 1,
      sym__function_attributes_end,
    STATE(7088), 1,
      sym_where_clause,
    STATE(7326), 1,
      sym_trailing_return_type,
    STATE(8412), 1,
      sym_gnu_asm_expression,
    ACTIONS(8283), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(10279), 2,
      anon_sym_LBRACK,
      sym_identifier,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7031), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8206), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
  [243567] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8279), 1,
      anon_sym___attribute__,
    ACTIONS(8285), 1,
      anon_sym_DASH_GT,
    ACTIONS(8293), 1,
      anon_sym_requires,
    ACTIONS(8295), 1,
      anon_sym_where,
    STATE(7063), 1,
      sym__function_attributes_end,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7348), 1,
      sym_trailing_return_type,
    STATE(8412), 1,
      sym_gnu_asm_expression,
    ACTIONS(8283), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(10064), 2,
      anon_sym_LBRACK,
      sym_identifier,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7031), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8215), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
  [243632] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8279), 1,
      anon_sym___attribute__,
    ACTIONS(8285), 1,
      anon_sym_DASH_GT,
    ACTIONS(10302), 1,
      anon_sym_requires,
    ACTIONS(10305), 1,
      anon_sym_where,
    STATE(7035), 1,
      sym__function_attributes_end,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7313), 1,
      sym_trailing_return_type,
    STATE(8412), 1,
      sym_gnu_asm_expression,
    ACTIONS(8283), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10064), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(10299), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7031), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7767), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
  [243697] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8279), 1,
      anon_sym___attribute__,
    ACTIONS(8285), 1,
      anon_sym_DASH_GT,
    ACTIONS(8293), 1,
      anon_sym_requires,
    ACTIONS(8295), 1,
      anon_sym_where,
    STATE(7058), 1,
      sym__function_attributes_end,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7243), 1,
      sym_trailing_return_type,
    STATE(8412), 1,
      sym_gnu_asm_expression,
    ACTIONS(8283), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9514), 2,
      anon_sym_LBRACK,
      sym_identifier,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7031), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8204), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
  [243762] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8279), 1,
      anon_sym___attribute__,
    ACTIONS(8285), 1,
      anon_sym_DASH_GT,
    ACTIONS(10484), 1,
      anon_sym_requires,
    ACTIONS(10487), 1,
      anon_sym_where,
    STATE(7056), 1,
      sym__function_attributes_end,
    STATE(7088), 1,
      sym_where_clause,
    STATE(7269), 1,
      sym_trailing_return_type,
    STATE(8412), 1,
      sym_gnu_asm_expression,
    ACTIONS(8283), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10279), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(10481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7031), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7764), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
  [243827] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8251), 1,
      anon_sym_DASH_GT,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    ACTIONS(10490), 1,
      anon_sym_requires,
    ACTIONS(10493), 1,
      anon_sym_where,
    STATE(7054), 1,
      sym__function_attributes_end,
    STATE(7088), 1,
      sym_where_clause,
    STATE(7277), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10281), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7908), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [243892] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8251), 1,
      anon_sym_DASH_GT,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10308), 1,
      anon_sym_requires,
    ACTIONS(10311), 1,
      anon_sym_where,
    STATE(7053), 1,
      sym__function_attributes_end,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7275), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10066), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7773), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [243957] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8251), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(10180), 1,
      anon_sym_requires,
    ACTIONS(10183), 1,
      anon_sym_where,
    STATE(7016), 1,
      sym__function_attributes_end,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7253), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7781), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [244022] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8251), 1,
      anon_sym_DASH_GT,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8299), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    STATE(7068), 1,
      sym__function_attributes_end,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7302), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8221), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [244087] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8279), 1,
      anon_sym___attribute__,
    ACTIONS(8285), 1,
      anon_sym_DASH_GT,
    ACTIONS(10169), 1,
      anon_sym_requires,
    ACTIONS(10172), 1,
      anon_sym_where,
    STATE(7059), 1,
      sym__function_attributes_end,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7319), 1,
      sym_trailing_return_type,
    STATE(8412), 1,
      sym_gnu_asm_expression,
    ACTIONS(8283), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9514), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(10166), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7031), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7770), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
  [244152] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8251), 1,
      anon_sym_DASH_GT,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8299), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(7048), 1,
      sym__function_attributes_end,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7347), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8225), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [244217] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8381), 1,
      anon_sym_DASH_GT,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    ACTIONS(10496), 1,
      anon_sym_requires,
    ACTIONS(10499), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    STATE(7095), 1,
      sym__function_attributes_end,
    STATE(7417), 1,
      sym_trailing_return_type,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10281), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [244281] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8381), 1,
      anon_sym_DASH_GT,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8385), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7162), 1,
      sym__function_attributes_end,
    STATE(7402), 1,
      sym_trailing_return_type,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8317), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [244345] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8372), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(10180), 1,
      anon_sym_requires,
    ACTIONS(10210), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7230), 1,
      sym__function_attributes_end,
    STATE(7381), 1,
      sym_trailing_return_type,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7953), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [244409] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8446), 1,
      anon_sym_STAR,
    ACTIONS(8448), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8450), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    STATE(3489), 1,
      sym_parameter_list,
    STATE(7080), 1,
      sym__abstract_declarator,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8834), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [244459] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10502), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6848), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(6846), 14,
      anon_sym_COLON,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_template,
      anon_sym_try,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_requires,
      anon_sym_where,
  [244497] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8427), 1,
      anon_sym_STAR,
    ACTIONS(8429), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8431), 1,
      anon_sym_AMP,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    STATE(3549), 1,
      sym_parameter_list,
    STATE(7036), 1,
      sym__abstract_declarator,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8834), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [244547] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8372), 1,
      anon_sym_DASH_GT,
    ACTIONS(8393), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7177), 1,
      sym__function_attributes_end,
    STATE(7430), 1,
      sym_trailing_return_type,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8270), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [244611] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8372), 1,
      anon_sym_DASH_GT,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10308), 1,
      anon_sym_requires,
    ACTIONS(10336), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7229), 1,
      sym__function_attributes_end,
    STATE(7380), 1,
      sym_trailing_return_type,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10066), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7961), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [244675] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8381), 1,
      anon_sym_DASH_GT,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8385), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    STATE(7160), 1,
      sym__function_attributes_end,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7403), 1,
      sym_trailing_return_type,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8311), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [244739] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8381), 1,
      anon_sym_DASH_GT,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8385), 1,
      anon_sym_where,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    STATE(7088), 1,
      sym_where_clause,
    STATE(7143), 1,
      sym__function_attributes_end,
    STATE(7408), 1,
      sym_trailing_return_type,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8304), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [244803] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8381), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(10204), 1,
      anon_sym_requires,
    ACTIONS(10207), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7132), 1,
      sym__function_attributes_end,
    STATE(7415), 1,
      sym_trailing_return_type,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8014), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [244867] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(6963), 1,
      sym_ms_call_modifier,
    STATE(8358), 1,
      sym__type_declarator,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(10505), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [244925] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8372), 1,
      anon_sym_DASH_GT,
    ACTIONS(8393), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    STATE(7164), 1,
      sym__function_attributes_end,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7426), 1,
      sym_trailing_return_type,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8293), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [244989] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(6919), 1,
      sym_ms_call_modifier,
    STATE(8236), 1,
      sym__type_declarator,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(10505), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [245047] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(6917), 1,
      sym_ms_call_modifier,
    STATE(8345), 1,
      sym__type_declarator,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(10505), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [245105] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8381), 1,
      anon_sym_DASH_GT,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10339), 1,
      anon_sym_requires,
    ACTIONS(10342), 1,
      anon_sym_where,
    STATE(7131), 1,
      sym__function_attributes_end,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7416), 1,
      sym_trailing_return_type,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10066), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7999), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [245169] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8372), 1,
      anon_sym_DASH_GT,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    ACTIONS(10490), 1,
      anon_sym_requires,
    ACTIONS(10507), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    STATE(7228), 1,
      sym__function_attributes_end,
    STATE(7379), 1,
      sym_trailing_return_type,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10281), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7963), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [245233] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(6970), 1,
      sym_ms_call_modifier,
    STATE(8283), 1,
      sym__type_declarator,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(10505), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [245291] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8372), 1,
      anon_sym_DASH_GT,
    ACTIONS(8393), 1,
      anon_sym_where,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    STATE(7088), 1,
      sym_where_clause,
    STATE(7093), 1,
      sym__function_attributes_end,
    STATE(7425), 1,
      sym_trailing_return_type,
    STATE(8363), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6567), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6691), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8299), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [245355] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8398), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(10217), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10242), 1,
      anon_sym_requires,
    ACTIONS(10245), 1,
      anon_sym_where,
    STATE(7124), 1,
      sym__function_attributes_end,
    STATE(7220), 1,
      sym_where_clause,
    STATE(7448), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9763), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7976), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
  [245418] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10353), 1,
      sym_identifier,
    ACTIONS(10510), 1,
      anon_sym_LPAREN2,
    ACTIONS(10512), 1,
      anon_sym_LBRACE,
    ACTIONS(10516), 1,
      anon_sym_requires,
    STATE(2947), 1,
      sym_template_type,
    STATE(3286), 1,
      sym_requirement_seq,
    STATE(7066), 1,
      sym_lambda_capture_specifier,
    STATE(8070), 1,
      sym__scope_resolution,
    STATE(9838), 1,
      sym_requires_parameter_list,
    ACTIONS(10514), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3283), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [245479] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8412), 1,
      anon_sym_DASH_GT,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    ACTIONS(10496), 1,
      anon_sym_requires,
    ACTIONS(10518), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    STATE(7283), 1,
      sym__function_attributes_end,
    STATE(7517), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10281), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8056), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [245542] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8406), 1,
      anon_sym_DASH_GT,
    ACTIONS(8408), 1,
      anon_sym_requires,
    ACTIONS(8410), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7309), 1,
      sym__function_attributes_end,
    STATE(7494), 1,
      sym_trailing_return_type,
    STATE(8408), 1,
      sym_gnu_asm_expression,
    ACTIONS(8283), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9512), 2,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
    ACTIONS(9514), 2,
      anon_sym_LBRACK,
      sym_identifier,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7342), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8500), 2,
      sym__function_postfix,
      sym_requires_clause,
  [245605] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8406), 1,
      anon_sym_DASH_GT,
    ACTIONS(10398), 1,
      anon_sym_requires,
    ACTIONS(10401), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7244), 1,
      sym__function_attributes_end,
    STATE(7571), 1,
      sym_trailing_return_type,
    STATE(8408), 1,
      sym_gnu_asm_expression,
    ACTIONS(8283), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10062), 2,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
    ACTIONS(10064), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(10299), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7342), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8128), 2,
      sym__function_postfix,
      sym_requires_clause,
  [245668] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8412), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(10204), 1,
      anon_sym_requires,
    ACTIONS(10237), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7267), 1,
      sym__function_attributes_end,
    STATE(7514), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8043), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [245731] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8406), 1,
      anon_sym_DASH_GT,
    ACTIONS(10521), 1,
      anon_sym_requires,
    ACTIONS(10524), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    STATE(7325), 1,
      sym__function_attributes_end,
    STATE(7543), 1,
      sym_trailing_return_type,
    STATE(8408), 1,
      sym_gnu_asm_expression,
    ACTIONS(8283), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10277), 2,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
    ACTIONS(10279), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(10481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7342), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8062), 2,
      sym__function_postfix,
      sym_requires_clause,
  [245794] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(9938), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10362), 1,
      sym_identifier,
    ACTIONS(10527), 1,
      anon_sym_LPAREN2,
    ACTIONS(10529), 1,
      anon_sym_LBRACE,
    ACTIONS(10533), 1,
      anon_sym_requires,
    STATE(4812), 1,
      sym_template_type,
    STATE(4995), 1,
      sym_requirement_seq,
    STATE(7044), 1,
      sym_lambda_capture_specifier,
    STATE(8098), 1,
      sym__scope_resolution,
    STATE(9872), 1,
      sym_requires_parameter_list,
    ACTIONS(10531), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5751), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [245855] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(10024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10364), 1,
      sym_identifier,
    ACTIONS(10535), 1,
      anon_sym_LPAREN2,
    ACTIONS(10537), 1,
      anon_sym_LBRACE,
    ACTIONS(10541), 1,
      anon_sym_requires,
    STATE(3345), 1,
      sym_template_type,
    STATE(4300), 1,
      sym_requirement_seq,
    STATE(7029), 1,
      sym_lambda_capture_specifier,
    STATE(8107), 1,
      sym__scope_resolution,
    STATE(9994), 1,
      sym_requires_parameter_list,
    ACTIONS(10539), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4301), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [245916] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(9875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10396), 1,
      sym_identifier,
    ACTIONS(10543), 1,
      anon_sym_LPAREN2,
    ACTIONS(10545), 1,
      anon_sym_LBRACE,
    ACTIONS(10549), 1,
      anon_sym_requires,
    STATE(2855), 1,
      sym_template_type,
    STATE(3841), 1,
      sym_requirement_seq,
    STATE(7052), 1,
      sym_lambda_capture_specifier,
    STATE(8113), 1,
      sym__scope_resolution,
    STATE(9657), 1,
      sym_requires_parameter_list,
    ACTIONS(10547), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4958), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [245977] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8412), 1,
      anon_sym_DASH_GT,
    ACTIONS(8417), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7254), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8479), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [246040] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8398), 1,
      anon_sym_DASH_GT,
    ACTIONS(8466), 1,
      anon_sym_requires,
    ACTIONS(8468), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10379), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7115), 1,
      sym__function_attributes_end,
    STATE(7152), 1,
      sym_where_clause,
    STATE(7459), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8245), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
  [246103] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8406), 1,
      anon_sym_DASH_GT,
    ACTIONS(8408), 1,
      anon_sym_requires,
    ACTIONS(8410), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    STATE(7295), 1,
      sym__function_attributes_end,
    STATE(7563), 1,
      sym_trailing_return_type,
    STATE(8408), 1,
      sym_gnu_asm_expression,
    ACTIONS(8283), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(10277), 2,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
    ACTIONS(10279), 2,
      anon_sym_LBRACK,
      sym_identifier,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7342), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8394), 2,
      sym__function_postfix,
      sym_requires_clause,
  [246166] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(9836), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10382), 1,
      sym_identifier,
    ACTIONS(10551), 1,
      anon_sym_LPAREN2,
    ACTIONS(10553), 1,
      anon_sym_LBRACE,
    ACTIONS(10557), 1,
      anon_sym_requires,
    STATE(3393), 1,
      sym_template_type,
    STATE(4537), 1,
      sym_requirement_seq,
    STATE(7034), 1,
      sym_lambda_capture_specifier,
    STATE(8075), 1,
      sym__scope_resolution,
    STATE(9654), 1,
      sym_requires_parameter_list,
    ACTIONS(10555), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4428), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [246227] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8398), 1,
      anon_sym_DASH_GT,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    ACTIONS(10559), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10562), 1,
      anon_sym_requires,
    ACTIONS(10565), 1,
      anon_sym_where,
    STATE(7174), 1,
      sym__function_attributes_end,
    STATE(7240), 1,
      sym_where_clause,
    STATE(7446), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10327), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7997), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
  [246290] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8406), 1,
      anon_sym_DASH_GT,
    ACTIONS(10226), 1,
      anon_sym_requires,
    ACTIONS(10229), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7258), 1,
      sym__function_attributes_end,
    STATE(7557), 1,
      sym_trailing_return_type,
    STATE(8408), 1,
      sym_gnu_asm_expression,
    ACTIONS(8283), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9512), 2,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
    ACTIONS(9514), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(10166), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7342), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8111), 2,
      sym__function_postfix,
      sym_requires_clause,
  [246353] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(9994), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10394), 1,
      sym_identifier,
    ACTIONS(10543), 1,
      anon_sym_LPAREN2,
    ACTIONS(10545), 1,
      anon_sym_LBRACE,
    ACTIONS(10549), 1,
      anon_sym_requires,
    STATE(3841), 1,
      sym_requirement_seq,
    STATE(4552), 1,
      sym_template_type,
    STATE(7052), 1,
      sym_lambda_capture_specifier,
    STATE(8035), 1,
      sym__scope_resolution,
    STATE(9657), 1,
      sym_requires_parameter_list,
    ACTIONS(10568), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4973), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [246414] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8398), 1,
      anon_sym_DASH_GT,
    ACTIONS(8466), 1,
      anon_sym_requires,
    ACTIONS(8468), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(10217), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7220), 1,
      sym_where_clause,
    STATE(7225), 1,
      sym__function_attributes_end,
    STATE(7350), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8285), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
  [246477] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8398), 1,
      anon_sym_DASH_GT,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10379), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10386), 1,
      anon_sym_requires,
    ACTIONS(10389), 1,
      anon_sym_where,
    STATE(7152), 1,
      sym_where_clause,
    STATE(7198), 1,
      sym__function_attributes_end,
    STATE(7447), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10111), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7986), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
  [246540] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8406), 1,
      anon_sym_DASH_GT,
    ACTIONS(8408), 1,
      anon_sym_requires,
    ACTIONS(8410), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7331), 1,
      sym__function_attributes_end,
    STATE(7542), 1,
      sym_trailing_return_type,
    STATE(8408), 1,
      sym_gnu_asm_expression,
    ACTIONS(8283), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(10062), 2,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
    ACTIONS(10064), 2,
      anon_sym_LBRACK,
      sym_identifier,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7342), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8481), 2,
      sym__function_postfix,
      sym_requires_clause,
  [246603] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8412), 1,
      anon_sym_DASH_GT,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10339), 1,
      anon_sym_requires,
    ACTIONS(10372), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7268), 1,
      sym__function_attributes_end,
    STATE(7516), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10066), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8051), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [246666] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8495), 1,
      anon_sym_STAR,
    ACTIONS(8497), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8499), 1,
      anon_sym_AMP,
    STATE(3763), 1,
      sym_parameter_list,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7236), 1,
      sym__abstract_declarator,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8834), 12,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [246715] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(9895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10368), 1,
      sym_identifier,
    ACTIONS(10570), 1,
      anon_sym_LPAREN2,
    ACTIONS(10572), 1,
      anon_sym_LBRACE,
    ACTIONS(10576), 1,
      anon_sym_requires,
    STATE(3457), 1,
      sym_template_type,
    STATE(4650), 1,
      sym_requirement_seq,
    STATE(7062), 1,
      sym_lambda_capture_specifier,
    STATE(8115), 1,
      sym__scope_resolution,
    STATE(9911), 1,
      sym_requires_parameter_list,
    ACTIONS(10574), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4649), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [246776] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8412), 1,
      anon_sym_DASH_GT,
    ACTIONS(8417), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7265), 1,
      sym__function_attributes_end,
    STATE(7495), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8499), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [246839] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8412), 1,
      anon_sym_DASH_GT,
    ACTIONS(8417), 1,
      anon_sym_where,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    STATE(7088), 1,
      sym_where_clause,
    STATE(7252), 1,
      sym__function_attributes_end,
    STATE(7508), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8367), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [246902] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8398), 1,
      anon_sym_DASH_GT,
    ACTIONS(8466), 1,
      anon_sym_requires,
    ACTIONS(8468), 1,
      anon_sym_where,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    ACTIONS(10559), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7237), 1,
      sym__function_attributes_end,
    STATE(7240), 1,
      sym_where_clause,
    STATE(7460), 1,
      sym_trailing_return_type,
    STATE(8435), 1,
      sym_gnu_asm_expression,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7450), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6787), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8320), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
  [246965] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8503), 1,
      anon_sym_STAR,
    ACTIONS(8505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8507), 1,
      anon_sym_AMP,
    STATE(3717), 1,
      sym_parameter_list,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7306), 1,
      sym__abstract_declarator,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8834), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [247013] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(8908), 1,
      sym_identifier,
    ACTIONS(8910), 1,
      anon_sym_LPAREN2,
    ACTIONS(8912), 1,
      anon_sym_STAR,
    ACTIONS(8914), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8916), 1,
      anon_sym_AMP,
    STATE(7084), 1,
      sym_ms_call_modifier,
    STATE(8180), 1,
      sym__field_declarator,
    STATE(8493), 1,
      sym_operator_name,
    STATE(10393), 1,
      sym_ms_based_modifier,
    ACTIONS(2764), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(7713), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [247067] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10580), 1,
      anon_sym_COLON,
    ACTIONS(10582), 1,
      anon_sym_SEMI,
    ACTIONS(10584), 1,
      anon_sym_LBRACE,
    ACTIONS(10586), 1,
      anon_sym_LBRACK,
    ACTIONS(10588), 1,
      anon_sym_EQ,
    ACTIONS(10590), 1,
      anon_sym_try,
    STATE(1981), 1,
      sym_compound_statement,
    STATE(1982), 1,
      sym_default_method_clause,
    STATE(1983), 1,
      sym_delete_method_clause,
    STATE(1986), 1,
      sym_pure_virtual_clause,
    STATE(1987), 1,
      sym_try_statement,
    STATE(3764), 1,
      sym_parameter_list,
    STATE(7787), 1,
      sym__function_declarator_seq,
    STATE(8527), 1,
      sym_bitfield_clause,
    STATE(8549), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8554), 1,
      sym_initializer_list,
    STATE(10445), 1,
      sym_attribute_specifier,
    STATE(7618), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [247138] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10580), 1,
      anon_sym_COLON,
    ACTIONS(10586), 1,
      anon_sym_LBRACK,
    ACTIONS(10592), 1,
      anon_sym_SEMI,
    ACTIONS(10594), 1,
      anon_sym_LBRACE,
    ACTIONS(10596), 1,
      anon_sym_EQ,
    ACTIONS(10598), 1,
      anon_sym_try,
    STATE(1627), 1,
      sym_compound_statement,
    STATE(1629), 1,
      sym_default_method_clause,
    STATE(1631), 1,
      sym_delete_method_clause,
    STATE(1635), 1,
      sym_pure_virtual_clause,
    STATE(1651), 1,
      sym_try_statement,
    STATE(3764), 1,
      sym_parameter_list,
    STATE(7787), 1,
      sym__function_declarator_seq,
    STATE(8529), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8539), 1,
      sym_initializer_list,
    STATE(8542), 1,
      sym_bitfield_clause,
    STATE(10160), 1,
      sym_attribute_specifier,
    STATE(7618), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [247209] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10580), 1,
      anon_sym_COLON,
    ACTIONS(10586), 1,
      anon_sym_LBRACK,
    ACTIONS(10600), 1,
      anon_sym_SEMI,
    ACTIONS(10602), 1,
      anon_sym_LBRACE,
    ACTIONS(10604), 1,
      anon_sym_EQ,
    ACTIONS(10606), 1,
      anon_sym_try,
    STATE(2055), 1,
      sym_pure_virtual_clause,
    STATE(2412), 1,
      sym_try_statement,
    STATE(2439), 1,
      sym_delete_method_clause,
    STATE(2504), 1,
      sym_default_method_clause,
    STATE(2535), 1,
      sym_compound_statement,
    STATE(3764), 1,
      sym_parameter_list,
    STATE(7787), 1,
      sym__function_declarator_seq,
    STATE(8552), 1,
      sym_initializer_list,
    STATE(8569), 1,
      sym_bitfield_clause,
    STATE(8584), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10573), 1,
      sym_attribute_specifier,
    STATE(7618), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [247280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10610), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(10608), 12,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [247311] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7514), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9766), 1,
      anon_sym_requires,
    ACTIONS(9769), 1,
      anon_sym_where,
    STATE(6888), 1,
      sym_trailing_return_type,
    STATE(7220), 1,
      sym_where_clause,
    ACTIONS(9763), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7144), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [247357] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10370), 1,
      sym_identifier,
    ACTIONS(10612), 1,
      anon_sym_LPAREN2,
    ACTIONS(10616), 1,
      anon_sym_requires,
    STATE(5102), 1,
      sym_template_type,
    STATE(7050), 1,
      sym_lambda_capture_specifier,
    STATE(8120), 1,
      sym__scope_resolution,
    ACTIONS(10614), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6956), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [247409] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10375), 1,
      sym_identifier,
    ACTIONS(10612), 1,
      anon_sym_LPAREN2,
    ACTIONS(10616), 1,
      anon_sym_requires,
    STATE(5102), 1,
      sym_template_type,
    STATE(7050), 1,
      sym_lambda_capture_specifier,
    STATE(8066), 1,
      sym__scope_resolution,
    ACTIONS(10618), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7404), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [247461] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10375), 1,
      sym_identifier,
    ACTIONS(10612), 1,
      anon_sym_LPAREN2,
    ACTIONS(10616), 1,
      anon_sym_requires,
    STATE(5102), 1,
      sym_template_type,
    STATE(7050), 1,
      sym_lambda_capture_specifier,
    STATE(8066), 1,
      sym__scope_resolution,
    ACTIONS(10620), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6862), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [247513] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(10622), 1,
      sym_identifier,
    ACTIONS(10624), 1,
      anon_sym_LPAREN2,
    ACTIONS(10626), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10630), 1,
      anon_sym_requires,
    STATE(2618), 1,
      sym_template_type,
    STATE(7026), 1,
      sym_lambda_capture_specifier,
    STATE(8119), 1,
      sym__scope_resolution,
    ACTIONS(10628), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2610), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [247565] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(9836), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10382), 1,
      sym_identifier,
    ACTIONS(10557), 1,
      anon_sym_requires,
    ACTIONS(10632), 1,
      anon_sym_LPAREN2,
    STATE(3393), 1,
      sym_template_type,
    STATE(7034), 1,
      sym_lambda_capture_specifier,
    STATE(8075), 1,
      sym__scope_resolution,
    ACTIONS(10634), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4504), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [247617] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10353), 1,
      sym_identifier,
    ACTIONS(10516), 1,
      anon_sym_requires,
    ACTIONS(10636), 1,
      anon_sym_LPAREN2,
    STATE(2947), 1,
      sym_template_type,
    STATE(7066), 1,
      sym_lambda_capture_specifier,
    STATE(8070), 1,
      sym__scope_resolution,
    ACTIONS(10638), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3256), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [247669] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(9836), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10382), 1,
      sym_identifier,
    ACTIONS(10557), 1,
      anon_sym_requires,
    ACTIONS(10632), 1,
      anon_sym_LPAREN2,
    STATE(3393), 1,
      sym_template_type,
    STATE(7034), 1,
      sym_lambda_capture_specifier,
    STATE(8075), 1,
      sym__scope_resolution,
    ACTIONS(10640), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4490), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [247721] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7514), 1,
      anon_sym_DASH_GT,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10114), 1,
      anon_sym_requires,
    ACTIONS(10117), 1,
      anon_sym_where,
    STATE(6880), 1,
      sym_trailing_return_type,
    STATE(7152), 1,
      sym_where_clause,
    ACTIONS(10111), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7091), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [247767] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7514), 1,
      anon_sym_DASH_GT,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7518), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(6779), 1,
      sym_trailing_return_type,
    STATE(7220), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7473), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [247813] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8562), 1,
      anon_sym_STAR,
    ACTIONS(8564), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8566), 1,
      anon_sym_AMP,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7471), 1,
      sym__abstract_declarator,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8834), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [247859] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10349), 1,
      sym_identifier,
    ACTIONS(10642), 1,
      anon_sym_LPAREN2,
    ACTIONS(10646), 1,
      anon_sym_requires,
    STATE(195), 1,
      sym_template_type,
    STATE(7076), 1,
      sym_lambda_capture_specifier,
    STATE(8089), 1,
      sym__scope_resolution,
    ACTIONS(10644), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7021), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [247911] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10360), 1,
      sym_identifier,
    ACTIONS(10549), 1,
      anon_sym_requires,
    ACTIONS(10648), 1,
      anon_sym_LPAREN2,
    STATE(2855), 1,
      sym_template_type,
    STATE(7052), 1,
      sym_lambda_capture_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    ACTIONS(10650), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7069), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [247963] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7452), 1,
      anon_sym_DASH_GT,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(7471), 1,
      anon_sym_where,
    STATE(6850), 1,
      sym_trailing_return_type,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7500), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [248007] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(10622), 1,
      sym_identifier,
    ACTIONS(10624), 1,
      anon_sym_LPAREN2,
    ACTIONS(10626), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10630), 1,
      anon_sym_requires,
    STATE(2618), 1,
      sym_template_type,
    STATE(7026), 1,
      sym_lambda_capture_specifier,
    STATE(8119), 1,
      sym__scope_resolution,
    ACTIONS(10652), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(1830), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [248059] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(8752), 1,
      anon_sym_STAR,
    ACTIONS(10654), 1,
      sym_identifier,
    ACTIONS(10656), 1,
      anon_sym_TILDE,
    ACTIONS(10658), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10660), 1,
      anon_sym_template,
    ACTIONS(10662), 1,
      anon_sym_operator,
    STATE(322), 1,
      sym_template_type,
    STATE(325), 1,
      sym_dependent_type_identifier,
    STATE(326), 1,
      sym_qualified_type_identifier,
    STATE(3478), 1,
      sym_operator_name,
    STATE(3499), 1,
      sym_qualified_identifier,
    STATE(3500), 1,
      sym_dependent_identifier,
    STATE(3501), 1,
      sym_destructor_name,
    STATE(3503), 1,
      sym_template_function,
    STATE(3507), 1,
      sym_pointer_type_declarator,
    STATE(6541), 1,
      sym__scope_resolution,
    STATE(8667), 1,
      sym_qualified_operator_cast_identifier,
    STATE(8671), 1,
      sym_operator_cast,
    STATE(10183), 1,
      sym_ms_based_modifier,
    STATE(10765), 1,
      sym_decltype,
  [248129] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(10351), 1,
      sym_identifier,
    ACTIONS(10549), 1,
      anon_sym_requires,
    ACTIONS(10648), 1,
      anon_sym_LPAREN2,
    ACTIONS(10664), 1,
      anon_sym_COLON_COLON,
    STATE(5102), 1,
      sym_template_type,
    STATE(7052), 1,
      sym_lambda_capture_specifier,
    STATE(8046), 1,
      sym__scope_resolution,
    ACTIONS(10666), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4032), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [248181] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(10351), 1,
      sym_identifier,
    ACTIONS(10549), 1,
      anon_sym_requires,
    ACTIONS(10648), 1,
      anon_sym_LPAREN2,
    ACTIONS(10664), 1,
      anon_sym_COLON_COLON,
    STATE(5102), 1,
      sym_template_type,
    STATE(7052), 1,
      sym_lambda_capture_specifier,
    STATE(8046), 1,
      sym__scope_resolution,
    ACTIONS(10668), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7628), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [248233] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8572), 1,
      anon_sym_STAR,
    ACTIONS(8574), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8576), 1,
      anon_sym_AMP,
    STATE(3498), 1,
      sym_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7469), 1,
      sym__abstract_declarator,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8834), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [248279] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7514), 1,
      anon_sym_DASH_GT,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    ACTIONS(10330), 1,
      anon_sym_requires,
    ACTIONS(10333), 1,
      anon_sym_where,
    STATE(6847), 1,
      sym_trailing_return_type,
    STATE(7240), 1,
      sym_where_clause,
    ACTIONS(10327), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7169), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [248325] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7452), 1,
      anon_sym_DASH_GT,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(7471), 1,
      anon_sym_where,
    STATE(6839), 1,
      sym_trailing_return_type,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7501), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [248369] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10366), 1,
      sym_identifier,
    ACTIONS(10533), 1,
      anon_sym_requires,
    ACTIONS(10670), 1,
      anon_sym_LPAREN2,
    STATE(5102), 1,
      sym_template_type,
    STATE(7044), 1,
      sym_lambda_capture_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    ACTIONS(10672), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7493), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [248421] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7514), 1,
      anon_sym_DASH_GT,
    ACTIONS(10676), 1,
      anon_sym_LBRACK,
    ACTIONS(10681), 1,
      anon_sym_requires,
    ACTIONS(10684), 1,
      anon_sym_where,
    STATE(6859), 1,
      sym_trailing_return_type,
    STATE(7187), 1,
      sym_where_clause,
    ACTIONS(10678), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7181), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [248467] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7452), 1,
      anon_sym_DASH_GT,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(7471), 1,
      anon_sym_where,
    STATE(6836), 1,
      sym_trailing_return_type,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7507), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [248511] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(8044), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10349), 1,
      sym_identifier,
    ACTIONS(10624), 1,
      anon_sym_LPAREN2,
    ACTIONS(10630), 1,
      anon_sym_requires,
    STATE(195), 1,
      sym_template_type,
    STATE(7013), 1,
      sym_lambda_capture_specifier,
    STATE(8039), 1,
      sym__scope_resolution,
    ACTIONS(10687), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7525), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [248563] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10691), 1,
      anon_sym_LPAREN2,
    STATE(6894), 1,
      sym_preproc_argument_list,
    ACTIONS(10693), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10689), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [248597] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7452), 1,
      anon_sym_DASH_GT,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(7471), 1,
      anon_sym_where,
    STATE(6835), 1,
      sym_trailing_return_type,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7526), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [248641] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(8044), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10349), 1,
      sym_identifier,
    ACTIONS(10624), 1,
      anon_sym_LPAREN2,
    ACTIONS(10630), 1,
      anon_sym_requires,
    STATE(195), 1,
      sym_template_type,
    STATE(7013), 1,
      sym_lambda_capture_specifier,
    STATE(8039), 1,
      sym__scope_resolution,
    ACTIONS(10652), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(1830), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [248693] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(131), 1,
      anon_sym_operator,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2405), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(10695), 1,
      sym_identifier,
    ACTIONS(10697), 1,
      anon_sym_template,
    STATE(2675), 1,
      sym_dependent_type_identifier,
    STATE(2679), 1,
      sym_qualified_type_identifier,
    STATE(2680), 1,
      sym_template_type,
    STATE(3478), 1,
      sym_operator_name,
    STATE(3499), 1,
      sym_qualified_identifier,
    STATE(3500), 1,
      sym_dependent_identifier,
    STATE(3501), 1,
      sym_destructor_name,
    STATE(3503), 1,
      sym_template_function,
    STATE(3507), 1,
      sym_pointer_type_declarator,
    STATE(6554), 1,
      sym__scope_resolution,
    STATE(8667), 1,
      sym_qualified_operator_cast_identifier,
    STATE(8671), 1,
      sym_operator_cast,
    STATE(10239), 1,
      sym_ms_based_modifier,
    STATE(10765), 1,
      sym_decltype,
  [248763] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8578), 1,
      anon_sym_STAR,
    ACTIONS(8580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8582), 1,
      anon_sym_AMP,
    STATE(3994), 1,
      sym_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7541), 1,
      sym__abstract_declarator,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8834), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [248809] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(10024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10364), 1,
      sym_identifier,
    ACTIONS(10541), 1,
      anon_sym_requires,
    ACTIONS(10699), 1,
      anon_sym_LPAREN2,
    STATE(3345), 1,
      sym_template_type,
    STATE(7029), 1,
      sym_lambda_capture_specifier,
    STATE(8107), 1,
      sym__scope_resolution,
    ACTIONS(10701), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4289), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [248861] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(10024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10364), 1,
      sym_identifier,
    ACTIONS(10541), 1,
      anon_sym_requires,
    ACTIONS(10699), 1,
      anon_sym_LPAREN2,
    STATE(3345), 1,
      sym_template_type,
    STATE(7029), 1,
      sym_lambda_capture_specifier,
    STATE(8107), 1,
      sym__scope_resolution,
    ACTIONS(10703), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4279), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [248913] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(8752), 1,
      anon_sym_STAR,
    ACTIONS(10656), 1,
      anon_sym_TILDE,
    ACTIONS(10662), 1,
      anon_sym_operator,
    ACTIONS(10705), 1,
      sym_identifier,
    ACTIONS(10707), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10709), 1,
      anon_sym_template,
    STATE(196), 1,
      sym_template_type,
    STATE(197), 1,
      sym_dependent_type_identifier,
    STATE(201), 1,
      sym_qualified_type_identifier,
    STATE(3478), 1,
      sym_operator_name,
    STATE(3499), 1,
      sym_qualified_identifier,
    STATE(3500), 1,
      sym_dependent_identifier,
    STATE(3501), 1,
      sym_destructor_name,
    STATE(3503), 1,
      sym_template_function,
    STATE(3507), 1,
      sym_pointer_type_declarator,
    STATE(6558), 1,
      sym__scope_resolution,
    STATE(8667), 1,
      sym_qualified_operator_cast_identifier,
    STATE(8671), 1,
      sym_operator_cast,
    STATE(10183), 1,
      sym_ms_based_modifier,
    STATE(10765), 1,
      sym_decltype,
  [248983] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10377), 1,
      sym_identifier,
    ACTIONS(10642), 1,
      anon_sym_LPAREN2,
    ACTIONS(10646), 1,
      anon_sym_requires,
    STATE(195), 1,
      sym_template_type,
    STATE(7076), 1,
      sym_lambda_capture_specifier,
    STATE(8102), 1,
      sym__scope_resolution,
    ACTIONS(10711), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6810), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [249035] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10366), 1,
      sym_identifier,
    ACTIONS(10533), 1,
      anon_sym_requires,
    ACTIONS(10670), 1,
      anon_sym_LPAREN2,
    STATE(5102), 1,
      sym_template_type,
    STATE(7044), 1,
      sym_lambda_capture_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    ACTIONS(10713), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4955), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [249087] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10366), 1,
      sym_identifier,
    ACTIONS(10533), 1,
      anon_sym_requires,
    ACTIONS(10670), 1,
      anon_sym_LPAREN2,
    STATE(5102), 1,
      sym_template_type,
    STATE(7044), 1,
      sym_lambda_capture_specifier,
    STATE(8071), 1,
      sym__scope_resolution,
    ACTIONS(10715), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7506), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [249139] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10377), 1,
      sym_identifier,
    ACTIONS(10642), 1,
      anon_sym_LPAREN2,
    ACTIONS(10646), 1,
      anon_sym_requires,
    STATE(195), 1,
      sym_template_type,
    STATE(7076), 1,
      sym_lambda_capture_specifier,
    STATE(8102), 1,
      sym__scope_resolution,
    ACTIONS(10717), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6737), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [249191] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7514), 1,
      anon_sym_DASH_GT,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7518), 1,
      anon_sym_where,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    STATE(6887), 1,
      sym_trailing_return_type,
    STATE(7240), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7486), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [249237] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(8044), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10349), 1,
      sym_identifier,
    ACTIONS(10624), 1,
      anon_sym_LPAREN2,
    ACTIONS(10630), 1,
      anon_sym_requires,
    STATE(195), 1,
      sym_template_type,
    STATE(7013), 1,
      sym_lambda_capture_specifier,
    STATE(8039), 1,
      sym__scope_resolution,
    ACTIONS(10719), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7497), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [249289] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10377), 1,
      sym_identifier,
    ACTIONS(10642), 1,
      anon_sym_LPAREN2,
    ACTIONS(10646), 1,
      anon_sym_requires,
    STATE(195), 1,
      sym_template_type,
    STATE(7076), 1,
      sym_lambda_capture_specifier,
    STATE(8102), 1,
      sym__scope_resolution,
    ACTIONS(10721), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6733), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [249341] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7514), 1,
      anon_sym_DASH_GT,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7518), 1,
      anon_sym_where,
    ACTIONS(10676), 1,
      anon_sym_LBRACK,
    STATE(6784), 1,
      sym_trailing_return_type,
    STATE(7187), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7579), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [249387] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10725), 1,
      anon_sym_LBRACK,
    STATE(5441), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6642), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10723), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [249425] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10349), 1,
      sym_identifier,
    ACTIONS(10642), 1,
      anon_sym_LPAREN2,
    ACTIONS(10646), 1,
      anon_sym_requires,
    STATE(195), 1,
      sym_template_type,
    STATE(7076), 1,
      sym_lambda_capture_specifier,
    STATE(8089), 1,
      sym__scope_resolution,
    ACTIONS(10727), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7023), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [249477] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10349), 1,
      sym_identifier,
    ACTIONS(10642), 1,
      anon_sym_LPAREN2,
    ACTIONS(10646), 1,
      anon_sym_requires,
    STATE(195), 1,
      sym_template_type,
    STATE(7076), 1,
      sym_lambda_capture_specifier,
    STATE(8089), 1,
      sym__scope_resolution,
    ACTIONS(10721), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6733), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [249529] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7514), 1,
      anon_sym_DASH_GT,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7518), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    STATE(6864), 1,
      sym_trailing_return_type,
    STATE(7152), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7560), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [249575] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7452), 1,
      anon_sym_DASH_GT,
    ACTIONS(9519), 1,
      anon_sym_requires,
    ACTIONS(9522), 1,
      anon_sym_where,
    STATE(6823), 1,
      sym_trailing_return_type,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7182), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [249619] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(8752), 1,
      anon_sym_STAR,
    ACTIONS(10656), 1,
      anon_sym_TILDE,
    ACTIONS(10662), 1,
      anon_sym_operator,
    ACTIONS(10729), 1,
      sym_identifier,
    ACTIONS(10731), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10733), 1,
      anon_sym_template,
    STATE(2675), 1,
      sym_dependent_type_identifier,
    STATE(2679), 1,
      sym_qualified_type_identifier,
    STATE(2680), 1,
      sym_template_type,
    STATE(3478), 1,
      sym_operator_name,
    STATE(3499), 1,
      sym_qualified_identifier,
    STATE(3500), 1,
      sym_dependent_identifier,
    STATE(3501), 1,
      sym_destructor_name,
    STATE(3503), 1,
      sym_template_function,
    STATE(3507), 1,
      sym_pointer_type_declarator,
    STATE(6572), 1,
      sym__scope_resolution,
    STATE(8667), 1,
      sym_qualified_operator_cast_identifier,
    STATE(8671), 1,
      sym_operator_cast,
    STATE(10183), 1,
      sym_ms_based_modifier,
    STATE(10765), 1,
      sym_decltype,
  [249689] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7452), 1,
      anon_sym_DASH_GT,
    ACTIONS(10069), 1,
      anon_sym_requires,
    ACTIONS(10072), 1,
      anon_sym_where,
    STATE(6822), 1,
      sym_trailing_return_type,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(10066), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7184), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [249733] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7452), 1,
      anon_sym_DASH_GT,
    ACTIONS(10284), 1,
      anon_sym_requires,
    ACTIONS(10287), 1,
      anon_sym_where,
    STATE(6817), 1,
      sym_trailing_return_type,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(10281), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7186), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [249777] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7452), 1,
      anon_sym_DASH_GT,
    ACTIONS(10738), 1,
      anon_sym_requires,
    ACTIONS(10741), 1,
      anon_sym_where,
    STATE(6841), 1,
      sym_trailing_return_type,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(10735), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7188), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [249821] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(9938), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10362), 1,
      sym_identifier,
    ACTIONS(10533), 1,
      anon_sym_requires,
    ACTIONS(10670), 1,
      anon_sym_LPAREN2,
    STATE(4812), 1,
      sym_template_type,
    STATE(7044), 1,
      sym_lambda_capture_specifier,
    STATE(8098), 1,
      sym__scope_resolution,
    ACTIONS(10713), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4955), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [249873] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10746), 1,
      anon_sym_LBRACK,
    STATE(5441), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6672), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10744), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [249911] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(131), 1,
      anon_sym_operator,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(3997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(10748), 1,
      sym_identifier,
    ACTIONS(10750), 1,
      anon_sym_template,
    STATE(2675), 1,
      sym_dependent_type_identifier,
    STATE(2679), 1,
      sym_qualified_type_identifier,
    STATE(2680), 1,
      sym_template_type,
    STATE(3478), 1,
      sym_operator_name,
    STATE(3499), 1,
      sym_qualified_identifier,
    STATE(3500), 1,
      sym_dependent_identifier,
    STATE(3501), 1,
      sym_destructor_name,
    STATE(3503), 1,
      sym_template_function,
    STATE(3507), 1,
      sym_pointer_type_declarator,
    STATE(6578), 1,
      sym__scope_resolution,
    STATE(8667), 1,
      sym_qualified_operator_cast_identifier,
    STATE(8671), 1,
      sym_operator_cast,
    STATE(10239), 1,
      sym_ms_based_modifier,
    STATE(10765), 1,
      sym_decltype,
  [249981] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10370), 1,
      sym_identifier,
    ACTIONS(10612), 1,
      anon_sym_LPAREN2,
    ACTIONS(10616), 1,
      anon_sym_requires,
    STATE(5102), 1,
      sym_template_type,
    STATE(7050), 1,
      sym_lambda_capture_specifier,
    STATE(8120), 1,
      sym__scope_resolution,
    ACTIONS(10752), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6896), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [250033] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10370), 1,
      sym_identifier,
    ACTIONS(10612), 1,
      anon_sym_LPAREN2,
    ACTIONS(10616), 1,
      anon_sym_requires,
    STATE(5102), 1,
      sym_template_type,
    STATE(7050), 1,
      sym_lambda_capture_specifier,
    STATE(8120), 1,
      sym__scope_resolution,
    ACTIONS(10620), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6862), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [250085] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(10351), 1,
      sym_identifier,
    ACTIONS(10549), 1,
      anon_sym_requires,
    ACTIONS(10648), 1,
      anon_sym_LPAREN2,
    ACTIONS(10664), 1,
      anon_sym_COLON_COLON,
    STATE(5102), 1,
      sym_template_type,
    STATE(7052), 1,
      sym_lambda_capture_specifier,
    STATE(8046), 1,
      sym__scope_resolution,
    ACTIONS(10754), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7685), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [250137] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(9994), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10394), 1,
      sym_identifier,
    ACTIONS(10549), 1,
      anon_sym_requires,
    ACTIONS(10648), 1,
      anon_sym_LPAREN2,
    STATE(4552), 1,
      sym_template_type,
    STATE(7052), 1,
      sym_lambda_capture_specifier,
    STATE(8035), 1,
      sym__scope_resolution,
    ACTIONS(10666), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4032), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [250189] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(9994), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10394), 1,
      sym_identifier,
    ACTIONS(10549), 1,
      anon_sym_requires,
    ACTIONS(10648), 1,
      anon_sym_LPAREN2,
    STATE(4552), 1,
      sym_template_type,
    STATE(7052), 1,
      sym_lambda_capture_specifier,
    STATE(8035), 1,
      sym__scope_resolution,
    ACTIONS(10756), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4965), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [250241] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(9875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10396), 1,
      sym_identifier,
    ACTIONS(10549), 1,
      anon_sym_requires,
    ACTIONS(10648), 1,
      anon_sym_LPAREN2,
    STATE(2855), 1,
      sym_template_type,
    STATE(7052), 1,
      sym_lambda_capture_specifier,
    STATE(8113), 1,
      sym__scope_resolution,
    ACTIONS(10666), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4032), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [250293] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10375), 1,
      sym_identifier,
    ACTIONS(10612), 1,
      anon_sym_LPAREN2,
    ACTIONS(10616), 1,
      anon_sym_requires,
    STATE(5102), 1,
      sym_template_type,
    STATE(7050), 1,
      sym_lambda_capture_specifier,
    STATE(8066), 1,
      sym__scope_resolution,
    ACTIONS(10758), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7439), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [250345] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(10622), 1,
      sym_identifier,
    ACTIONS(10624), 1,
      anon_sym_LPAREN2,
    ACTIONS(10626), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10630), 1,
      anon_sym_requires,
    STATE(2618), 1,
      sym_template_type,
    STATE(7026), 1,
      sym_lambda_capture_specifier,
    STATE(8119), 1,
      sym__scope_resolution,
    ACTIONS(10760), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2607), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [250397] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10360), 1,
      sym_identifier,
    ACTIONS(10549), 1,
      anon_sym_requires,
    ACTIONS(10648), 1,
      anon_sym_LPAREN2,
    STATE(2855), 1,
      sym_template_type,
    STATE(7052), 1,
      sym_lambda_capture_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    ACTIONS(10666), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4032), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [250449] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(9895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10368), 1,
      sym_identifier,
    ACTIONS(10576), 1,
      anon_sym_requires,
    ACTIONS(10762), 1,
      anon_sym_LPAREN2,
    STATE(3457), 1,
      sym_template_type,
    STATE(7062), 1,
      sym_lambda_capture_specifier,
    STATE(8115), 1,
      sym__scope_resolution,
    ACTIONS(10764), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4626), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [250501] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(9895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10368), 1,
      sym_identifier,
    ACTIONS(10576), 1,
      anon_sym_requires,
    ACTIONS(10762), 1,
      anon_sym_LPAREN2,
    STATE(3457), 1,
      sym_template_type,
    STATE(7062), 1,
      sym_lambda_capture_specifier,
    STATE(8115), 1,
      sym__scope_resolution,
    ACTIONS(10766), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4631), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [250553] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(9875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10396), 1,
      sym_identifier,
    ACTIONS(10549), 1,
      anon_sym_requires,
    ACTIONS(10648), 1,
      anon_sym_LPAREN2,
    STATE(2855), 1,
      sym_template_type,
    STATE(7052), 1,
      sym_lambda_capture_specifier,
    STATE(8113), 1,
      sym__scope_resolution,
    ACTIONS(10768), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4986), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [250605] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10353), 1,
      sym_identifier,
    ACTIONS(10516), 1,
      anon_sym_requires,
    ACTIONS(10636), 1,
      anon_sym_LPAREN2,
    STATE(2947), 1,
      sym_template_type,
    STATE(7066), 1,
      sym_lambda_capture_specifier,
    STATE(8070), 1,
      sym__scope_resolution,
    ACTIONS(10770), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3264), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [250657] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(9938), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10362), 1,
      sym_identifier,
    ACTIONS(10533), 1,
      anon_sym_requires,
    ACTIONS(10670), 1,
      anon_sym_LPAREN2,
    STATE(4812), 1,
      sym_template_type,
    STATE(7044), 1,
      sym_lambda_capture_specifier,
    STATE(8098), 1,
      sym__scope_resolution,
    ACTIONS(10772), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5635), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [250709] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10360), 1,
      sym_identifier,
    ACTIONS(10549), 1,
      anon_sym_requires,
    ACTIONS(10648), 1,
      anon_sym_LPAREN2,
    STATE(2855), 1,
      sym_template_type,
    STATE(7052), 1,
      sym_lambda_capture_specifier,
    STATE(8126), 1,
      sym__scope_resolution,
    ACTIONS(10774), 2,
      sym_true,
      sym_false,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7028), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [250761] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10776), 1,
      sym_identifier,
    ACTIONS(10778), 1,
      anon_sym_RPAREN,
    ACTIONS(10780), 1,
      anon_sym_LPAREN2,
    ACTIONS(10782), 1,
      anon_sym_defined,
    ACTIONS(10788), 1,
      sym_number_literal,
    ACTIONS(10784), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10786), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10790), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6719), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [250804] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6478), 1,
      anon_sym_LBRACE,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10353), 1,
      sym_identifier,
    STATE(2947), 1,
      sym_template_type,
    STATE(2986), 1,
      sym_field_declaration_list,
    STATE(3065), 1,
      sym__class_declaration_item,
    STATE(8070), 1,
      sym__scope_resolution,
    STATE(8631), 1,
      sym_virtual_specifier,
    STATE(9941), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2857), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [250863] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10146), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10392), 1,
      sym_identifier,
    STATE(309), 1,
      sym_template_type,
    STATE(626), 1,
      sym_field_declaration_list,
    STATE(685), 1,
      sym__class_declaration_item,
    STATE(8117), 1,
      sym__scope_resolution,
    STATE(8779), 1,
      sym_virtual_specifier,
    STATE(9782), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(245), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6703), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [250922] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7777), 1,
      anon_sym_DASH_GT,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10114), 1,
      anon_sym_requires,
    ACTIONS(10189), 1,
      anon_sym_where,
    STATE(6935), 1,
      sym_trailing_return_type,
    STATE(7152), 1,
      sym_where_clause,
    ACTIONS(10111), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7288), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [250967] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    ACTIONS(10347), 1,
      anon_sym_COLON_COLON,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2729), 1,
      sym__class_declaration_item,
    STATE(8086), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2966), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [251026] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10375), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5832), 1,
      sym__class_declaration_item,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [251085] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    ACTIONS(10347), 1,
      anon_sym_COLON_COLON,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2751), 1,
      sym__class_declaration_item,
    STATE(8086), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2966), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6638), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [251144] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    ACTIONS(10349), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(5696), 1,
      sym_field_declaration_list,
    STATE(5827), 1,
      sym__class_declaration_item,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(8921), 1,
      sym_virtual_specifier,
    STATE(10007), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5208), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6633), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [251203] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    ACTIONS(10349), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(5696), 1,
      sym_field_declaration_list,
    STATE(5848), 1,
      sym__class_declaration_item,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(8921), 1,
      sym_virtual_specifier,
    STATE(10007), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5208), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [251262] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7067), 1,
      anon_sym_LBRACE,
    ACTIONS(9836), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10382), 1,
      sym_identifier,
    STATE(3393), 1,
      sym_template_type,
    STATE(3480), 1,
      sym_field_declaration_list,
    STATE(3605), 1,
      sym__class_declaration_item,
    STATE(8075), 1,
      sym__scope_resolution,
    STATE(8915), 1,
      sym_virtual_specifier,
    STATE(9997), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3238), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6607), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [251321] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7067), 1,
      anon_sym_LBRACE,
    ACTIONS(9836), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10382), 1,
      sym_identifier,
    STATE(3393), 1,
      sym_template_type,
    STATE(3480), 1,
      sym_field_declaration_list,
    STATE(3618), 1,
      sym__class_declaration_item,
    STATE(8075), 1,
      sym__scope_resolution,
    STATE(8915), 1,
      sym_virtual_specifier,
    STATE(9997), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3238), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [251380] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7777), 1,
      anon_sym_DASH_GT,
    ACTIONS(10676), 1,
      anon_sym_LBRACK,
    ACTIONS(10681), 1,
      anon_sym_requires,
    ACTIONS(10792), 1,
      anon_sym_where,
    STATE(6911), 1,
      sym_trailing_return_type,
    STATE(7187), 1,
      sym_where_clause,
    ACTIONS(10678), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7281), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [251425] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7777), 1,
      anon_sym_DASH_GT,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    ACTIONS(10330), 1,
      anon_sym_requires,
    ACTIONS(10455), 1,
      anon_sym_where,
    STATE(6951), 1,
      sym_trailing_return_type,
    STATE(7240), 1,
      sym_where_clause,
    ACTIONS(10327), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7285), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [251470] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7067), 1,
      anon_sym_LBRACE,
    ACTIONS(9836), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10382), 1,
      sym_identifier,
    STATE(3393), 1,
      sym_template_type,
    STATE(3480), 1,
      sym_field_declaration_list,
    STATE(3640), 1,
      sym__class_declaration_item,
    STATE(8075), 1,
      sym__scope_resolution,
    STATE(8915), 1,
      sym_virtual_specifier,
    STATE(9997), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3238), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [251529] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    ACTIONS(10349), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(5696), 1,
      sym_field_declaration_list,
    STATE(5787), 1,
      sym__class_declaration_item,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(8921), 1,
      sym_virtual_specifier,
    STATE(10007), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5208), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [251588] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    ACTIONS(10349), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(5696), 1,
      sym_field_declaration_list,
    STATE(5828), 1,
      sym__class_declaration_item,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(8921), 1,
      sym_virtual_specifier,
    STATE(10007), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5208), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6602), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [251647] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7067), 1,
      anon_sym_LBRACE,
    ACTIONS(9836), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10382), 1,
      sym_identifier,
    STATE(3393), 1,
      sym_template_type,
    STATE(3480), 1,
      sym_field_declaration_list,
    STATE(3645), 1,
      sym__class_declaration_item,
    STATE(8075), 1,
      sym__scope_resolution,
    STATE(8915), 1,
      sym_virtual_specifier,
    STATE(9997), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3238), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [251706] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7067), 1,
      anon_sym_LBRACE,
    ACTIONS(9836), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10382), 1,
      sym_identifier,
    STATE(3393), 1,
      sym_template_type,
    STATE(3480), 1,
      sym_field_declaration_list,
    STATE(3686), 1,
      sym__class_declaration_item,
    STATE(8075), 1,
      sym__scope_resolution,
    STATE(8915), 1,
      sym_virtual_specifier,
    STATE(9997), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3238), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [251765] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8618), 1,
      anon_sym_STAR,
    ACTIONS(8620), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8622), 1,
      anon_sym_AMP,
    STATE(3764), 1,
      sym_parameter_list,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7670), 1,
      sym__abstract_declarator,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8834), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [251810] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7777), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9766), 1,
      anon_sym_requires,
    ACTIONS(10078), 1,
      anon_sym_where,
    STATE(6940), 1,
      sym_trailing_return_type,
    STATE(7220), 1,
      sym_where_clause,
    ACTIONS(9763), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7291), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [251855] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10377), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(303), 1,
      sym__class_declaration_item,
    STATE(855), 1,
      sym_field_declaration_list,
    STATE(8132), 1,
      sym__scope_resolution,
    STATE(8882), 1,
      sym_virtual_specifier,
    STATE(9741), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(286), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [251914] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    ACTIONS(10377), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(5696), 1,
      sym_field_declaration_list,
    STATE(5848), 1,
      sym__class_declaration_item,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(8921), 1,
      sym_virtual_specifier,
    STATE(10007), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5208), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [251973] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    ACTIONS(10377), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(5696), 1,
      sym_field_declaration_list,
    STATE(5827), 1,
      sym__class_declaration_item,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(8921), 1,
      sym_virtual_specifier,
    STATE(10007), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5208), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6723), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10795), 10,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(10797), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [252061] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10375), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5823), 1,
      sym__class_declaration_item,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252120] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    ACTIONS(10377), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(5696), 1,
      sym_field_declaration_list,
    STATE(5787), 1,
      sym__class_declaration_item,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(8921), 1,
      sym_virtual_specifier,
    STATE(10007), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5208), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252179] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10375), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5789), 1,
      sym__class_declaration_item,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6621), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252238] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10375), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5781), 1,
      sym__class_declaration_item,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252297] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    ACTIONS(10377), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(5696), 1,
      sym_field_declaration_list,
    STATE(5828), 1,
      sym__class_declaration_item,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(8921), 1,
      sym_virtual_specifier,
    STATE(10007), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5208), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6615), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252356] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2751), 1,
      sym__class_declaration_item,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6657), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252415] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2729), 1,
      sym__class_declaration_item,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252474] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10377), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(418), 1,
      sym__class_declaration_item,
    STATE(855), 1,
      sym_field_declaration_list,
    STATE(8132), 1,
      sym__scope_resolution,
    STATE(8882), 1,
      sym_virtual_specifier,
    STATE(9741), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(286), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6714), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252533] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10370), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5781), 1,
      sym__class_declaration_item,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252592] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10370), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5789), 1,
      sym__class_declaration_item,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6626), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252651] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10370), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5823), 1,
      sym__class_declaration_item,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252710] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10370), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5832), 1,
      sym__class_declaration_item,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252769] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10370), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5782), 1,
      sym__class_declaration_item,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6628), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10799), 10,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(10801), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [252857] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8483), 1,
      anon_sym_LBRACE,
    ACTIONS(9938), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10362), 1,
      sym_identifier,
    STATE(4812), 1,
      sym_template_type,
    STATE(4947), 1,
      sym_field_declaration_list,
    STATE(5071), 1,
      sym__class_declaration_item,
    STATE(8098), 1,
      sym__scope_resolution,
    STATE(8842), 1,
      sym_virtual_specifier,
    STATE(9876), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4644), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252916] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    ACTIONS(10349), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(5696), 1,
      sym_field_declaration_list,
    STATE(5818), 1,
      sym__class_declaration_item,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(8921), 1,
      sym_virtual_specifier,
    STATE(10007), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5208), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252975] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10360), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2934), 1,
      sym__class_declaration_item,
    STATE(3106), 1,
      sym_field_declaration_list,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(8739), 1,
      sym_virtual_specifier,
    STATE(9695), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2979), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [253034] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10366), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5782), 1,
      sym__class_declaration_item,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6687), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [253093] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(9875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10396), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2934), 1,
      sym__class_declaration_item,
    STATE(3106), 1,
      sym_field_declaration_list,
    STATE(8113), 1,
      sym__scope_resolution,
    STATE(8739), 1,
      sym_virtual_specifier,
    STATE(9695), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2979), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [253152] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(9875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10396), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2890), 1,
      sym__class_declaration_item,
    STATE(3106), 1,
      sym_field_declaration_list,
    STATE(8113), 1,
      sym__scope_resolution,
    STATE(8739), 1,
      sym_virtual_specifier,
    STATE(9695), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2979), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6636), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [253211] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    ACTIONS(10347), 1,
      anon_sym_COLON_COLON,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2739), 1,
      sym__class_declaration_item,
    STATE(8086), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2966), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [253270] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    ACTIONS(10347), 1,
      anon_sym_COLON_COLON,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2721), 1,
      sym__class_declaration_item,
    STATE(8086), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2966), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6647), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [253329] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7777), 1,
      anon_sym_DASH_GT,
    ACTIONS(7782), 1,
      anon_sym_where,
    ACTIONS(10676), 1,
      anon_sym_LBRACK,
    STATE(6915), 1,
      sym_trailing_return_type,
    STATE(7187), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7593), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [253374] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(5024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10355), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2751), 1,
      sym__class_declaration_item,
    STATE(8090), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6649), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [253433] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6730), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10746), 8,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(10744), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [253466] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(131), 1,
      anon_sym_operator,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(6150), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(10803), 1,
      sym_identifier,
    ACTIONS(10805), 1,
      anon_sym_template,
    STATE(3478), 1,
      sym_operator_name,
    STATE(3499), 1,
      sym_qualified_identifier,
    STATE(3500), 1,
      sym_dependent_identifier,
    STATE(3501), 1,
      sym_destructor_name,
    STATE(3503), 1,
      sym_template_function,
    STATE(3507), 1,
      sym_pointer_type_declarator,
    STATE(6643), 1,
      sym__scope_resolution,
    STATE(8667), 1,
      sym_qualified_operator_cast_identifier,
    STATE(8671), 1,
      sym_operator_cast,
    STATE(10239), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [253529] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(5024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10355), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2729), 1,
      sym__class_declaration_item,
    STATE(8090), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [253588] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10776), 1,
      sym_identifier,
    ACTIONS(10780), 1,
      anon_sym_LPAREN2,
    ACTIONS(10782), 1,
      anon_sym_defined,
    ACTIONS(10807), 1,
      anon_sym_RPAREN,
    ACTIONS(10809), 1,
      sym_number_literal,
    ACTIONS(10784), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10786), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10790), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6650), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [253631] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10146), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10392), 1,
      sym_identifier,
    STATE(309), 1,
      sym_template_type,
    STATE(626), 1,
      sym_field_declaration_list,
    STATE(736), 1,
      sym__class_declaration_item,
    STATE(8117), 1,
      sym__scope_resolution,
    STATE(8779), 1,
      sym_virtual_specifier,
    STATE(9782), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(245), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [253690] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    ACTIONS(10347), 1,
      anon_sym_COLON_COLON,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2725), 1,
      sym__class_declaration_item,
    STATE(8086), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2966), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [253749] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7278), 1,
      anon_sym_LBRACE,
    ACTIONS(9895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10368), 1,
      sym_identifier,
    STATE(3457), 1,
      sym_template_type,
    STATE(3606), 1,
      sym_field_declaration_list,
    STATE(3977), 1,
      sym__class_declaration_item,
    STATE(8115), 1,
      sym__scope_resolution,
    STATE(8872), 1,
      sym_virtual_specifier,
    STATE(9918), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3341), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [253808] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(5024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10355), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2739), 1,
      sym__class_declaration_item,
    STATE(8090), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [253867] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10811), 1,
      anon_sym_COMMA,
    ACTIONS(10813), 1,
      anon_sym_RPAREN,
    ACTIONS(10819), 1,
      anon_sym_SLASH,
    ACTIONS(10821), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10823), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10825), 1,
      anon_sym_PIPE,
    ACTIONS(10827), 1,
      anon_sym_CARET,
    ACTIONS(10829), 1,
      anon_sym_AMP,
    STATE(9149), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(10815), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10817), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10831), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10833), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10835), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10837), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [253922] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7278), 1,
      anon_sym_LBRACE,
    ACTIONS(9895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10368), 1,
      sym_identifier,
    STATE(3457), 1,
      sym_template_type,
    STATE(3606), 1,
      sym_field_declaration_list,
    STATE(4114), 1,
      sym__class_declaration_item,
    STATE(8115), 1,
      sym__scope_resolution,
    STATE(8872), 1,
      sym_virtual_specifier,
    STATE(9918), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3341), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6648), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [253981] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(5024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10355), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2721), 1,
      sym__class_declaration_item,
    STATE(8090), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6653), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [254040] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(5024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10355), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2725), 1,
      sym__class_declaration_item,
    STATE(8090), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [254099] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10366), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5832), 1,
      sym__class_declaration_item,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [254158] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10360), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2908), 1,
      sym__class_declaration_item,
    STATE(6194), 1,
      sym_field_declaration_list,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(8705), 1,
      sym_virtual_specifier,
    STATE(9666), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5748), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [254217] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(9875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10396), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2908), 1,
      sym__class_declaration_item,
    STATE(3106), 1,
      sym_field_declaration_list,
    STATE(8113), 1,
      sym__scope_resolution,
    STATE(8739), 1,
      sym_virtual_specifier,
    STATE(9695), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2979), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [254276] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2739), 1,
      sym__class_declaration_item,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [254335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10839), 10,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(10841), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [254364] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2721), 1,
      sym__class_declaration_item,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6679), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [254423] = 5,
    ACTIONS(10689), 1,
      anon_sym_LF,
    ACTIONS(10843), 1,
      anon_sym_LPAREN2,
    ACTIONS(10845), 1,
      sym_comment,
    STATE(6950), 1,
      sym_preproc_argument_list,
    ACTIONS(10693), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [254456] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10360), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2886), 1,
      sym__class_declaration_item,
    STATE(6194), 1,
      sym_field_declaration_list,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(8705), 1,
      sym_virtual_specifier,
    STATE(9666), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5748), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [254515] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10351), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5781), 1,
      sym__class_declaration_item,
    STATE(6152), 1,
      sym_field_declaration_list,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(8693), 1,
      sym_virtual_specifier,
    STATE(9696), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5971), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [254574] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10377), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(432), 1,
      sym__class_declaration_item,
    STATE(855), 1,
      sym_field_declaration_list,
    STATE(8132), 1,
      sym__scope_resolution,
    STATE(8882), 1,
      sym_virtual_specifier,
    STATE(9741), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(286), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [254633] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6478), 1,
      anon_sym_LBRACE,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10353), 1,
      sym_identifier,
    STATE(2947), 1,
      sym_template_type,
    STATE(2986), 1,
      sym_field_declaration_list,
    STATE(3096), 1,
      sym__class_declaration_item,
    STATE(8070), 1,
      sym__scope_resolution,
    STATE(8631), 1,
      sym_virtual_specifier,
    STATE(9941), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2857), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6595), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [254692] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6478), 1,
      anon_sym_LBRACE,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10353), 1,
      sym_identifier,
    STATE(2947), 1,
      sym_template_type,
    STATE(2986), 1,
      sym_field_declaration_list,
    STATE(3104), 1,
      sym__class_declaration_item,
    STATE(8070), 1,
      sym__scope_resolution,
    STATE(8631), 1,
      sym_virtual_specifier,
    STATE(9941), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2857), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [254751] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7777), 1,
      anon_sym_DASH_GT,
    ACTIONS(7782), 1,
      anon_sym_where,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    STATE(6906), 1,
      sym_trailing_return_type,
    STATE(7240), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7591), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [254796] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10360), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2890), 1,
      sym__class_declaration_item,
    STATE(6194), 1,
      sym_field_declaration_list,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(8705), 1,
      sym_virtual_specifier,
    STATE(9666), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5748), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6678), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [254855] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7278), 1,
      anon_sym_LBRACE,
    ACTIONS(9895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10368), 1,
      sym_identifier,
    STATE(3457), 1,
      sym_template_type,
    STATE(3606), 1,
      sym_field_declaration_list,
    STATE(4124), 1,
      sym__class_declaration_item,
    STATE(8115), 1,
      sym__scope_resolution,
    STATE(8872), 1,
      sym_virtual_specifier,
    STATE(9918), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3341), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [254914] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6478), 1,
      anon_sym_LBRACE,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10353), 1,
      sym_identifier,
    STATE(2947), 1,
      sym_template_type,
    STATE(2986), 1,
      sym_field_declaration_list,
    STATE(3078), 1,
      sym__class_declaration_item,
    STATE(8070), 1,
      sym__scope_resolution,
    STATE(8631), 1,
      sym_virtual_specifier,
    STATE(9941), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2857), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [254973] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6478), 1,
      anon_sym_LBRACE,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10353), 1,
      sym_identifier,
    STATE(2947), 1,
      sym_template_type,
    STATE(2986), 1,
      sym_field_declaration_list,
    STATE(3072), 1,
      sym__class_declaration_item,
    STATE(8070), 1,
      sym__scope_resolution,
    STATE(8631), 1,
      sym_virtual_specifier,
    STATE(9941), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2857), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6665), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [255032] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(9875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10396), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2930), 1,
      sym__class_declaration_item,
    STATE(3106), 1,
      sym_field_declaration_list,
    STATE(8113), 1,
      sym__scope_resolution,
    STATE(8739), 1,
      sym_virtual_specifier,
    STATE(9695), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2979), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6698), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [255091] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6730), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10847), 8,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(10849), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [255124] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10377), 1,
      sym_identifier,
    ACTIONS(10384), 1,
      anon_sym_COLON_COLON,
    STATE(195), 1,
      sym_template_type,
    STATE(358), 1,
      sym__class_declaration_item,
    STATE(6107), 1,
      sym_field_declaration_list,
    STATE(8061), 1,
      sym__scope_resolution,
    STATE(8786), 1,
      sym_virtual_specifier,
    STATE(9784), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5693), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [255183] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10811), 1,
      anon_sym_COMMA,
    ACTIONS(10819), 1,
      anon_sym_SLASH,
    ACTIONS(10821), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10823), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10825), 1,
      anon_sym_PIPE,
    ACTIONS(10827), 1,
      anon_sym_CARET,
    ACTIONS(10829), 1,
      anon_sym_AMP,
    ACTIONS(10851), 1,
      anon_sym_RPAREN,
    STATE(9131), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(10815), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10817), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10831), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10833), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10835), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10837), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [255238] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10351), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5789), 1,
      sym__class_declaration_item,
    STATE(6152), 1,
      sym_field_declaration_list,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(8693), 1,
      sym_virtual_specifier,
    STATE(9696), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5971), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6662), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [255297] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10857), 1,
      anon_sym_LPAREN2,
    ACTIONS(10853), 10,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(10855), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [255328] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10377), 1,
      sym_identifier,
    ACTIONS(10384), 1,
      anon_sym_COLON_COLON,
    STATE(195), 1,
      sym_template_type,
    STATE(341), 1,
      sym__class_declaration_item,
    STATE(6107), 1,
      sym_field_declaration_list,
    STATE(8061), 1,
      sym__scope_resolution,
    STATE(8786), 1,
      sym_virtual_specifier,
    STATE(9784), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5693), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6683), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [255387] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10360), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2934), 1,
      sym__class_declaration_item,
    STATE(6194), 1,
      sym_field_declaration_list,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(8705), 1,
      sym_virtual_specifier,
    STATE(9666), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5748), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [255446] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2704), 1,
      sym_field_declaration_list,
    STATE(2725), 1,
      sym__class_declaration_item,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_virtual_specifier,
    STATE(9818), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2634), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [255505] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7777), 1,
      anon_sym_DASH_GT,
    ACTIONS(7782), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    STATE(6903), 1,
      sym_trailing_return_type,
    STATE(7152), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7649), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [255550] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10377), 1,
      sym_identifier,
    ACTIONS(10384), 1,
      anon_sym_COLON_COLON,
    STATE(195), 1,
      sym_template_type,
    STATE(432), 1,
      sym__class_declaration_item,
    STATE(6107), 1,
      sym_field_declaration_list,
    STATE(8061), 1,
      sym__scope_resolution,
    STATE(8786), 1,
      sym_virtual_specifier,
    STATE(9784), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5693), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [255609] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7278), 1,
      anon_sym_LBRACE,
    ACTIONS(9895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10368), 1,
      sym_identifier,
    STATE(3457), 1,
      sym_template_type,
    STATE(3606), 1,
      sym_field_declaration_list,
    STATE(3954), 1,
      sym__class_declaration_item,
    STATE(8115), 1,
      sym__scope_resolution,
    STATE(8872), 1,
      sym_virtual_specifier,
    STATE(9918), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3341), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [255668] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10377), 1,
      sym_identifier,
    ACTIONS(10384), 1,
      anon_sym_COLON_COLON,
    STATE(195), 1,
      sym_template_type,
    STATE(303), 1,
      sym__class_declaration_item,
    STATE(6107), 1,
      sym_field_declaration_list,
    STATE(8061), 1,
      sym__scope_resolution,
    STATE(8786), 1,
      sym_virtual_specifier,
    STATE(9784), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5693), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [255727] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7278), 1,
      anon_sym_LBRACE,
    ACTIONS(9895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10368), 1,
      sym_identifier,
    STATE(3457), 1,
      sym_template_type,
    STATE(3606), 1,
      sym_field_declaration_list,
    STATE(3922), 1,
      sym__class_declaration_item,
    STATE(8115), 1,
      sym__scope_resolution,
    STATE(8872), 1,
      sym_virtual_specifier,
    STATE(9918), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3341), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6668), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [255786] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10377), 1,
      sym_identifier,
    ACTIONS(10384), 1,
      anon_sym_COLON_COLON,
    STATE(195), 1,
      sym_template_type,
    STATE(418), 1,
      sym__class_declaration_item,
    STATE(6107), 1,
      sym_field_declaration_list,
    STATE(8061), 1,
      sym__scope_resolution,
    STATE(8786), 1,
      sym_virtual_specifier,
    STATE(9784), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5693), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6673), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [255845] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10351), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5823), 1,
      sym__class_declaration_item,
    STATE(6152), 1,
      sym_field_declaration_list,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(8693), 1,
      sym_virtual_specifier,
    STATE(9696), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5971), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [255904] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10366), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5823), 1,
      sym__class_declaration_item,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [255963] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10366), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5789), 1,
      sym__class_declaration_item,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6700), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [256022] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8598), 1,
      anon_sym_STAR,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_AMP,
    STATE(4356), 1,
      sym_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7693), 1,
      sym__abstract_declarator,
    ACTIONS(8834), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(8836), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [256069] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10351), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5832), 1,
      sym__class_declaration_item,
    STATE(6152), 1,
      sym_field_declaration_list,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(8693), 1,
      sym_virtual_specifier,
    STATE(9696), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5971), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [256128] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6730), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10725), 8,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(10723), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [256161] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10351), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5782), 1,
      sym__class_declaration_item,
    STATE(6152), 1,
      sym_field_declaration_list,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(8693), 1,
      sym_virtual_specifier,
    STATE(9696), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5971), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6686), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [256220] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10360), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2930), 1,
      sym__class_declaration_item,
    STATE(3106), 1,
      sym_field_declaration_list,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(8739), 1,
      sym_virtual_specifier,
    STATE(9695), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2979), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6729), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [256279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10859), 10,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(10861), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [256308] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10360), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2908), 1,
      sym__class_declaration_item,
    STATE(3106), 1,
      sym_field_declaration_list,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(8739), 1,
      sym_virtual_specifier,
    STATE(9695), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2979), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [256367] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7760), 1,
      anon_sym_LBRACE,
    ACTIONS(9994), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10394), 1,
      sym_identifier,
    STATE(4552), 1,
      sym_template_type,
    STATE(4713), 1,
      sym_field_declaration_list,
    STATE(4777), 1,
      sym__class_declaration_item,
    STATE(8035), 1,
      sym__scope_resolution,
    STATE(8765), 1,
      sym_virtual_specifier,
    STATE(9751), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3740), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [256426] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10776), 1,
      sym_identifier,
    ACTIONS(10780), 1,
      anon_sym_LPAREN2,
    ACTIONS(10782), 1,
      anon_sym_defined,
    ACTIONS(10863), 1,
      anon_sym_RPAREN,
    ACTIONS(10865), 1,
      sym_number_literal,
    ACTIONS(10784), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10786), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10790), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6674), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [256469] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(9875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10396), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2886), 1,
      sym__class_declaration_item,
    STATE(3106), 1,
      sym_field_declaration_list,
    STATE(8113), 1,
      sym__scope_resolution,
    STATE(8739), 1,
      sym_virtual_specifier,
    STATE(9695), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2979), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [256528] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10867), 10,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(10869), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [256557] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10366), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5781), 1,
      sym__class_declaration_item,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [256616] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8592), 1,
      anon_sym_STAR,
    ACTIONS(8594), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8596), 1,
      anon_sym_AMP,
    STATE(4240), 1,
      sym_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7683), 1,
      sym__abstract_declarator,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8834), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [256661] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10146), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10392), 1,
      sym_identifier,
    STATE(309), 1,
      sym_template_type,
    STATE(626), 1,
      sym_field_declaration_list,
    STATE(716), 1,
      sym__class_declaration_item,
    STATE(8117), 1,
      sym__scope_resolution,
    STATE(8779), 1,
      sym_virtual_specifier,
    STATE(9782), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(245), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6646), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [256720] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10146), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10392), 1,
      sym_identifier,
    STATE(309), 1,
      sym_template_type,
    STATE(626), 1,
      sym_field_declaration_list,
    STATE(798), 1,
      sym__class_declaration_item,
    STATE(8117), 1,
      sym__scope_resolution,
    STATE(8779), 1,
      sym_virtual_specifier,
    STATE(9782), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(245), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [256779] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8483), 1,
      anon_sym_LBRACE,
    ACTIONS(9938), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10362), 1,
      sym_identifier,
    STATE(4812), 1,
      sym_template_type,
    STATE(4947), 1,
      sym_field_declaration_list,
    STATE(5022), 1,
      sym__class_declaration_item,
    STATE(8098), 1,
      sym__scope_resolution,
    STATE(8842), 1,
      sym_virtual_specifier,
    STATE(9876), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4644), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [256838] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10360), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2930), 1,
      sym__class_declaration_item,
    STATE(6194), 1,
      sym_field_declaration_list,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(8705), 1,
      sym_virtual_specifier,
    STATE(9666), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5748), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6661), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [256897] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    ACTIONS(10375), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5599), 1,
      sym_field_declaration_list,
    STATE(5782), 1,
      sym__class_declaration_item,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(8712), 1,
      sym_virtual_specifier,
    STATE(9660), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5063), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6618), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [256956] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7760), 1,
      anon_sym_LBRACE,
    ACTIONS(9994), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10394), 1,
      sym_identifier,
    STATE(4552), 1,
      sym_template_type,
    STATE(4713), 1,
      sym_field_declaration_list,
    STATE(4760), 1,
      sym__class_declaration_item,
    STATE(8035), 1,
      sym__scope_resolution,
    STATE(8765), 1,
      sym_virtual_specifier,
    STATE(9751), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3740), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6696), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [257015] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7760), 1,
      anon_sym_LBRACE,
    ACTIONS(9994), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10394), 1,
      sym_identifier,
    STATE(4552), 1,
      sym_template_type,
    STATE(4713), 1,
      sym_field_declaration_list,
    STATE(4801), 1,
      sym__class_declaration_item,
    STATE(8035), 1,
      sym__scope_resolution,
    STATE(8765), 1,
      sym_virtual_specifier,
    STATE(9751), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3740), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [257074] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10377), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(341), 1,
      sym__class_declaration_item,
    STATE(855), 1,
      sym_field_declaration_list,
    STATE(8132), 1,
      sym__scope_resolution,
    STATE(8882), 1,
      sym_virtual_specifier,
    STATE(9741), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(286), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6614), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [257133] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6961), 1,
      anon_sym_LBRACE,
    ACTIONS(10024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10364), 1,
      sym_identifier,
    STATE(3345), 1,
      sym_template_type,
    STATE(3413), 1,
      sym_field_declaration_list,
    STATE(3510), 1,
      sym__class_declaration_item,
    STATE(8107), 1,
      sym__scope_resolution,
    STATE(8854), 1,
      sym_virtual_specifier,
    STATE(9891), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3195), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [257192] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10349), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(418), 1,
      sym__class_declaration_item,
    STATE(6107), 1,
      sym_field_declaration_list,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(8786), 1,
      sym_virtual_specifier,
    STATE(9784), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5693), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6718), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [257251] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6961), 1,
      anon_sym_LBRACE,
    ACTIONS(10024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10364), 1,
      sym_identifier,
    STATE(3345), 1,
      sym_template_type,
    STATE(3413), 1,
      sym_field_declaration_list,
    STATE(3550), 1,
      sym__class_declaration_item,
    STATE(8107), 1,
      sym__scope_resolution,
    STATE(8854), 1,
      sym_virtual_specifier,
    STATE(9891), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3195), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6726), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [257310] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8483), 1,
      anon_sym_LBRACE,
    ACTIONS(9938), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10362), 1,
      sym_identifier,
    STATE(4812), 1,
      sym_template_type,
    STATE(4947), 1,
      sym_field_declaration_list,
    STATE(5074), 1,
      sym__class_declaration_item,
    STATE(8098), 1,
      sym__scope_resolution,
    STATE(8842), 1,
      sym_virtual_specifier,
    STATE(9876), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4644), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6704), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [257369] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10377), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(358), 1,
      sym__class_declaration_item,
    STATE(855), 1,
      sym_field_declaration_list,
    STATE(8132), 1,
      sym__scope_resolution,
    STATE(8882), 1,
      sym_virtual_specifier,
    STATE(9741), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(286), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [257428] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10349), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(432), 1,
      sym__class_declaration_item,
    STATE(6107), 1,
      sym_field_declaration_list,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(8786), 1,
      sym_virtual_specifier,
    STATE(9784), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5693), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [257487] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6961), 1,
      anon_sym_LBRACE,
    ACTIONS(10024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10364), 1,
      sym_identifier,
    STATE(3345), 1,
      sym_template_type,
    STATE(3413), 1,
      sym_field_declaration_list,
    STATE(3528), 1,
      sym__class_declaration_item,
    STATE(8107), 1,
      sym__scope_resolution,
    STATE(8854), 1,
      sym_virtual_specifier,
    STATE(9891), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3195), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6710), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [257546] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10146), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10392), 1,
      sym_identifier,
    STATE(309), 1,
      sym_template_type,
    STATE(626), 1,
      sym_field_declaration_list,
    STATE(678), 1,
      sym__class_declaration_item,
    STATE(8117), 1,
      sym__scope_resolution,
    STATE(8779), 1,
      sym_virtual_specifier,
    STATE(9782), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(245), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [257605] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10349), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(358), 1,
      sym__class_declaration_item,
    STATE(6107), 1,
      sym_field_declaration_list,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(8786), 1,
      sym_virtual_specifier,
    STATE(9784), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5693), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [257664] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10811), 1,
      anon_sym_COMMA,
    ACTIONS(10819), 1,
      anon_sym_SLASH,
    ACTIONS(10821), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10823), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10825), 1,
      anon_sym_PIPE,
    ACTIONS(10827), 1,
      anon_sym_CARET,
    ACTIONS(10829), 1,
      anon_sym_AMP,
    ACTIONS(10871), 1,
      anon_sym_RPAREN,
    STATE(8998), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(10815), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10817), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10831), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10833), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10835), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10837), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [257719] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7760), 1,
      anon_sym_LBRACE,
    ACTIONS(9994), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10394), 1,
      sym_identifier,
    STATE(4552), 1,
      sym_template_type,
    STATE(4713), 1,
      sym_field_declaration_list,
    STATE(4765), 1,
      sym__class_declaration_item,
    STATE(8035), 1,
      sym__scope_resolution,
    STATE(8765), 1,
      sym_virtual_specifier,
    STATE(9751), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3740), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [257778] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10349), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(341), 1,
      sym__class_declaration_item,
    STATE(6107), 1,
      sym_field_declaration_list,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(8786), 1,
      sym_virtual_specifier,
    STATE(9784), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5693), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6725), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [257837] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7760), 1,
      anon_sym_LBRACE,
    ACTIONS(9994), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10394), 1,
      sym_identifier,
    STATE(4552), 1,
      sym_template_type,
    STATE(4713), 1,
      sym_field_declaration_list,
    STATE(4805), 1,
      sym__class_declaration_item,
    STATE(8035), 1,
      sym__scope_resolution,
    STATE(8765), 1,
      sym_virtual_specifier,
    STATE(9751), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3740), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6708), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [257896] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    ACTIONS(10377), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(5696), 1,
      sym_field_declaration_list,
    STATE(5818), 1,
      sym__class_declaration_item,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(8921), 1,
      sym_virtual_specifier,
    STATE(10007), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5208), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [257955] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6961), 1,
      anon_sym_LBRACE,
    ACTIONS(10024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10364), 1,
      sym_identifier,
    STATE(3345), 1,
      sym_template_type,
    STATE(3413), 1,
      sym_field_declaration_list,
    STATE(3540), 1,
      sym__class_declaration_item,
    STATE(8107), 1,
      sym__scope_resolution,
    STATE(8854), 1,
      sym_virtual_specifier,
    STATE(9891), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3195), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [258014] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10349), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(303), 1,
      sym__class_declaration_item,
    STATE(6107), 1,
      sym_field_declaration_list,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(8786), 1,
      sym_virtual_specifier,
    STATE(9784), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5693), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [258073] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6961), 1,
      anon_sym_LBRACE,
    ACTIONS(10024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10364), 1,
      sym_identifier,
    STATE(3345), 1,
      sym_template_type,
    STATE(3413), 1,
      sym_field_declaration_list,
    STATE(3539), 1,
      sym__class_declaration_item,
    STATE(8107), 1,
      sym__scope_resolution,
    STATE(8854), 1,
      sym_virtual_specifier,
    STATE(9891), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3195), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [258132] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7777), 1,
      anon_sym_DASH_GT,
    ACTIONS(7782), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(6913), 1,
      sym_trailing_return_type,
    STATE(7220), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7602), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [258177] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8483), 1,
      anon_sym_LBRACE,
    ACTIONS(9938), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10362), 1,
      sym_identifier,
    STATE(4812), 1,
      sym_template_type,
    STATE(4947), 1,
      sym_field_declaration_list,
    STATE(5122), 1,
      sym__class_declaration_item,
    STATE(8098), 1,
      sym__scope_resolution,
    STATE(8842), 1,
      sym_virtual_specifier,
    STATE(9876), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4644), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [258236] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10360), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2886), 1,
      sym__class_declaration_item,
    STATE(3106), 1,
      sym_field_declaration_list,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(8739), 1,
      sym_virtual_specifier,
    STATE(9695), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2979), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [258295] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10873), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6730), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6846), 8,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6848), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [258328] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8483), 1,
      anon_sym_LBRACE,
    ACTIONS(9938), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10362), 1,
      sym_identifier,
    STATE(4812), 1,
      sym_template_type,
    STATE(4947), 1,
      sym_field_declaration_list,
    STATE(5081), 1,
      sym__class_declaration_item,
    STATE(8098), 1,
      sym__scope_resolution,
    STATE(8842), 1,
      sym_virtual_specifier,
    STATE(9876), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4644), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [258387] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10360), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(2890), 1,
      sym__class_declaration_item,
    STATE(3106), 1,
      sym_field_declaration_list,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(8739), 1,
      sym_virtual_specifier,
    STATE(9695), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2979), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(6634), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [258446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5896), 1,
      anon_sym_LBRACK,
    ACTIONS(5898), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [258474] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(8777), 1,
      anon_sym_STAR,
    ACTIONS(10876), 1,
      sym_identifier,
    ACTIONS(10878), 1,
      anon_sym_TILDE,
    ACTIONS(10880), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10882), 1,
      anon_sym_template,
    ACTIONS(10884), 1,
      anon_sym_operator,
    STATE(2844), 1,
      sym_qualified_type_identifier,
    STATE(2859), 1,
      sym_dependent_type_identifier,
    STATE(2861), 1,
      sym_template_type,
    STATE(3975), 1,
      sym_operator_name,
    STATE(3979), 1,
      sym_qualified_identifier,
    STATE(3980), 1,
      sym_dependent_identifier,
    STATE(3981), 1,
      sym_destructor_name,
    STATE(3982), 1,
      sym_template_function,
    STATE(3983), 1,
      sym_pointer_type_declarator,
    STATE(6734), 1,
      sym__scope_resolution,
    STATE(10354), 1,
      sym_ms_based_modifier,
    STATE(10765), 1,
      sym_decltype,
  [258538] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8692), 1,
      anon_sym_STAR,
    ACTIONS(8694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8696), 1,
      anon_sym_AMP,
    STATE(4454), 1,
      sym_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7778), 1,
      sym__abstract_declarator,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8834), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [258582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5953), 1,
      anon_sym_LBRACK,
    ACTIONS(5955), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [258610] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6192), 1,
      anon_sym_LBRACK,
    ACTIONS(10886), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10888), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6194), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [258642] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(7764), 1,
      anon_sym_requires,
    ACTIONS(7766), 1,
      anon_sym_where,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    STATE(6981), 1,
      sym_trailing_return_type,
    STATE(7240), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7918), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [258686] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10776), 1,
      sym_identifier,
    ACTIONS(10780), 1,
      anon_sym_LPAREN2,
    ACTIONS(10782), 1,
      anon_sym_defined,
    ACTIONS(10890), 1,
      sym_number_literal,
    ACTIONS(10784), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10786), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10790), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6889), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [258726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2359), 1,
      anon_sym_LBRACK,
    ACTIONS(2357), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [258754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5961), 1,
      anon_sym_LBRACK,
    ACTIONS(5963), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [258782] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(7977), 1,
      sym__type_declarator,
    STATE(8603), 1,
      sym__type_definition_declarators,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [258832] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10776), 1,
      sym_identifier,
    ACTIONS(10780), 1,
      anon_sym_LPAREN2,
    ACTIONS(10782), 1,
      anon_sym_defined,
    ACTIONS(10892), 1,
      sym_number_literal,
    ACTIONS(10784), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10786), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10790), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6890), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [258872] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10776), 1,
      sym_identifier,
    ACTIONS(10780), 1,
      anon_sym_LPAREN2,
    ACTIONS(10782), 1,
      anon_sym_defined,
    ACTIONS(10894), 1,
      sym_number_literal,
    ACTIONS(10784), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10786), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10790), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6893), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [258912] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10896), 1,
      sym_identifier,
    ACTIONS(10898), 1,
      anon_sym_LPAREN2,
    ACTIONS(10900), 1,
      anon_sym_defined,
    ACTIONS(10906), 1,
      sym_number_literal,
    ACTIONS(10902), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10904), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10908), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6949), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [258952] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10776), 1,
      sym_identifier,
    ACTIONS(10780), 1,
      anon_sym_LPAREN2,
    ACTIONS(10782), 1,
      anon_sym_defined,
    ACTIONS(10910), 1,
      sym_number_literal,
    ACTIONS(10784), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10786), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10790), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6892), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [258992] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10896), 1,
      sym_identifier,
    ACTIONS(10898), 1,
      anon_sym_LPAREN2,
    ACTIONS(10900), 1,
      anon_sym_defined,
    ACTIONS(10912), 1,
      sym_number_literal,
    ACTIONS(10902), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10904), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10908), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6931), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [259032] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10776), 1,
      sym_identifier,
    ACTIONS(10780), 1,
      anon_sym_LPAREN2,
    ACTIONS(10782), 1,
      anon_sym_defined,
    ACTIONS(10914), 1,
      sym_number_literal,
    ACTIONS(10784), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10786), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10790), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6891), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [259072] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(7764), 1,
      anon_sym_requires,
    ACTIONS(7766), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    STATE(6994), 1,
      sym_trailing_return_type,
    STATE(7152), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7868), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [259116] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10776), 1,
      sym_identifier,
    ACTIONS(10780), 1,
      anon_sym_LPAREN2,
    ACTIONS(10782), 1,
      anon_sym_defined,
    ACTIONS(10916), 1,
      sym_number_literal,
    ACTIONS(10784), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10786), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10790), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6794), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [259156] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10776), 1,
      sym_identifier,
    ACTIONS(10780), 1,
      anon_sym_LPAREN2,
    ACTIONS(10782), 1,
      anon_sym_defined,
    ACTIONS(10918), 1,
      sym_number_literal,
    ACTIONS(10784), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10786), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10790), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6878), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [259196] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10776), 1,
      sym_identifier,
    ACTIONS(10780), 1,
      anon_sym_LPAREN2,
    ACTIONS(10782), 1,
      anon_sym_defined,
    ACTIONS(10920), 1,
      sym_number_literal,
    ACTIONS(10784), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10786), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10790), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6876), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [259236] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(7764), 1,
      anon_sym_requires,
    ACTIONS(7766), 1,
      anon_sym_where,
    ACTIONS(10676), 1,
      anon_sym_LBRACK,
    STATE(6978), 1,
      sym_trailing_return_type,
    STATE(7187), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7921), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [259280] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(7977), 1,
      sym__type_declarator,
    STATE(8850), 1,
      sym__type_definition_declarators,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [259330] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10776), 1,
      sym_identifier,
    ACTIONS(10780), 1,
      anon_sym_LPAREN2,
    ACTIONS(10782), 1,
      anon_sym_defined,
    ACTIONS(10922), 1,
      sym_number_literal,
    ACTIONS(10784), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10786), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10790), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6865), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [259370] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(7977), 1,
      sym__type_declarator,
    STATE(8857), 1,
      sym__type_definition_declarators,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [259420] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10776), 1,
      sym_identifier,
    ACTIONS(10780), 1,
      anon_sym_LPAREN2,
    ACTIONS(10782), 1,
      anon_sym_defined,
    ACTIONS(10924), 1,
      sym_number_literal,
    ACTIONS(10784), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10786), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10790), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6863), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [259460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10928), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10926), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [259488] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10932), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10930), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [259516] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(7977), 1,
      sym__type_declarator,
    STATE(8880), 1,
      sym__type_definition_declarators,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [259566] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(7977), 1,
      sym__type_declarator,
    STATE(8892), 1,
      sym__type_definition_declarators,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [259616] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(7977), 1,
      sym__type_declarator,
    STATE(8886), 1,
      sym__type_definition_declarators,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [259666] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(7977), 1,
      sym__type_declarator,
    STATE(8792), 1,
      sym__type_definition_declarators,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [259716] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym___attribute__,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(8910), 1,
      anon_sym_LPAREN2,
    ACTIONS(8986), 1,
      sym_identifier,
    ACTIONS(8988), 1,
      anon_sym_STAR,
    ACTIONS(8990), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8992), 1,
      anon_sym_AMP,
    ACTIONS(10934), 1,
      anon_sym_SEMI,
    STATE(6524), 1,
      sym__field_declarator,
    STATE(7707), 1,
      sym_operator_name,
    STATE(10470), 1,
      sym_attribute_specifier,
    STATE(10471), 1,
      sym_ms_based_modifier,
    STATE(7713), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [259768] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(8777), 1,
      anon_sym_STAR,
    ACTIONS(10936), 1,
      sym_identifier,
    ACTIONS(10938), 1,
      anon_sym_TILDE,
    ACTIONS(10940), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10942), 1,
      anon_sym_template,
    ACTIONS(10944), 1,
      anon_sym_operator,
    STATE(196), 1,
      sym_template_type,
    STATE(197), 1,
      sym_dependent_type_identifier,
    STATE(201), 1,
      sym_qualified_type_identifier,
    STATE(4333), 1,
      sym_pointer_type_declarator,
    STATE(4335), 1,
      sym_template_function,
    STATE(4336), 1,
      sym_destructor_name,
    STATE(4337), 1,
      sym_dependent_identifier,
    STATE(4339), 1,
      sym_qualified_identifier,
    STATE(4355), 1,
      sym_operator_name,
    STATE(6765), 1,
      sym__scope_resolution,
    STATE(10354), 1,
      sym_ms_based_modifier,
    STATE(10765), 1,
      sym_decltype,
  [259832] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10776), 1,
      sym_identifier,
    ACTIONS(10780), 1,
      anon_sym_LPAREN2,
    ACTIONS(10782), 1,
      anon_sym_defined,
    ACTIONS(10946), 1,
      sym_number_literal,
    ACTIONS(10784), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10786), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10790), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6874), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [259872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6044), 1,
      anon_sym_LBRACK,
    ACTIONS(6046), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [259900] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10896), 1,
      sym_identifier,
    ACTIONS(10898), 1,
      anon_sym_LPAREN2,
    ACTIONS(10900), 1,
      anon_sym_defined,
    ACTIONS(10948), 1,
      sym_number_literal,
    ACTIONS(10902), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10904), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10908), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6922), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [259940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5937), 1,
      anon_sym_LBRACK,
    ACTIONS(5939), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [259968] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(7977), 1,
      sym__type_declarator,
    STATE(8823), 1,
      sym__type_definition_declarators,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [260018] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5925), 1,
      anon_sym_LBRACK,
    ACTIONS(5927), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [260046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7426), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7428), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [260074] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8624), 1,
      anon_sym_STAR,
    ACTIONS(8626), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8628), 1,
      anon_sym_AMP,
    STATE(4569), 1,
      sym_parameter_list,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7911), 1,
      sym__abstract_declarator,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8834), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [260118] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10776), 1,
      sym_identifier,
    ACTIONS(10780), 1,
      anon_sym_LPAREN2,
    ACTIONS(10782), 1,
      anon_sym_defined,
    ACTIONS(10950), 1,
      sym_number_literal,
    ACTIONS(10784), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10786), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10790), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6907), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [260158] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10896), 1,
      sym_identifier,
    ACTIONS(10898), 1,
      anon_sym_LPAREN2,
    ACTIONS(10900), 1,
      anon_sym_defined,
    ACTIONS(10952), 1,
      sym_number_literal,
    ACTIONS(10902), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10904), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10908), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6944), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [260198] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10896), 1,
      sym_identifier,
    ACTIONS(10898), 1,
      anon_sym_LPAREN2,
    ACTIONS(10900), 1,
      anon_sym_defined,
    ACTIONS(10954), 1,
      sym_number_literal,
    ACTIONS(10902), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10904), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10908), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6964), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [260238] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(7764), 1,
      anon_sym_requires,
    ACTIONS(7766), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(6998), 1,
      sym_trailing_return_type,
    STATE(7220), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7850), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [260282] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(8777), 1,
      anon_sym_STAR,
    ACTIONS(10878), 1,
      anon_sym_TILDE,
    ACTIONS(10884), 1,
      anon_sym_operator,
    ACTIONS(10956), 1,
      sym_identifier,
    ACTIONS(10958), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10960), 1,
      anon_sym_template,
    STATE(196), 1,
      sym_template_type,
    STATE(197), 1,
      sym_dependent_type_identifier,
    STATE(201), 1,
      sym_qualified_type_identifier,
    STATE(3975), 1,
      sym_operator_name,
    STATE(3979), 1,
      sym_qualified_identifier,
    STATE(3980), 1,
      sym_dependent_identifier,
    STATE(3981), 1,
      sym_destructor_name,
    STATE(3982), 1,
      sym_template_function,
    STATE(3983), 1,
      sym_pointer_type_declarator,
    STATE(6778), 1,
      sym__scope_resolution,
    STATE(10354), 1,
      sym_ms_based_modifier,
    STATE(10765), 1,
      sym_decltype,
  [260346] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7518), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    STATE(7152), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7560), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [260386] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10896), 1,
      sym_identifier,
    ACTIONS(10898), 1,
      anon_sym_LPAREN2,
    ACTIONS(10900), 1,
      anon_sym_defined,
    ACTIONS(10962), 1,
      sym_number_literal,
    ACTIONS(10902), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10904), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10908), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6921), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [260426] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10776), 1,
      sym_identifier,
    ACTIONS(10780), 1,
      anon_sym_LPAREN2,
    ACTIONS(10782), 1,
      anon_sym_defined,
    ACTIONS(10964), 1,
      sym_number_literal,
    ACTIONS(10784), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10786), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10790), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6758), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [260466] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(7977), 1,
      sym__type_declarator,
    STATE(8616), 1,
      sym__type_definition_declarators,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [260516] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(10746), 1,
      anon_sym_LBRACK,
    STATE(5675), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7001), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10744), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [260552] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7518), 1,
      anon_sym_where,
    ACTIONS(10968), 1,
      anon_sym_LBRACK,
    STATE(7172), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7479), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10966), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [260592] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10896), 1,
      sym_identifier,
    ACTIONS(10898), 1,
      anon_sym_LPAREN2,
    ACTIONS(10900), 1,
      anon_sym_defined,
    ACTIONS(10970), 1,
      sym_number_literal,
    ACTIONS(10902), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10904), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10908), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6953), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [260632] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(8752), 1,
      anon_sym_STAR,
    ACTIONS(10972), 1,
      sym_identifier,
    ACTIONS(10974), 1,
      anon_sym_TILDE,
    ACTIONS(10976), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10978), 1,
      anon_sym_template,
    ACTIONS(10980), 1,
      anon_sym_operator,
    STATE(196), 1,
      sym_template_type,
    STATE(197), 1,
      sym_dependent_type_identifier,
    STATE(201), 1,
      sym_qualified_type_identifier,
    STATE(3267), 1,
      sym_operator_name,
    STATE(3268), 1,
      sym_qualified_identifier,
    STATE(3270), 1,
      sym_dependent_identifier,
    STATE(3272), 1,
      sym_destructor_name,
    STATE(3273), 1,
      sym_template_function,
    STATE(3274), 1,
      sym_pointer_type_declarator,
    STATE(6786), 1,
      sym__scope_resolution,
    STATE(10183), 1,
      sym_ms_based_modifier,
    STATE(10765), 1,
      sym_decltype,
  [260696] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(10725), 1,
      anon_sym_LBRACK,
    STATE(5675), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6982), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10723), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [260732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2355), 1,
      anon_sym_LBRACK,
    ACTIONS(2353), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [260760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10984), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10982), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [260788] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10896), 1,
      sym_identifier,
    ACTIONS(10898), 1,
      anon_sym_LPAREN2,
    ACTIONS(10900), 1,
      anon_sym_defined,
    ACTIONS(10986), 1,
      sym_number_literal,
    ACTIONS(10902), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10904), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10908), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6930), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [260828] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10896), 1,
      sym_identifier,
    ACTIONS(10898), 1,
      anon_sym_LPAREN2,
    ACTIONS(10900), 1,
      anon_sym_defined,
    ACTIONS(10988), 1,
      sym_number_literal,
    ACTIONS(10902), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10904), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10908), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6904), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [260868] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(10081), 1,
      anon_sym_requires,
    ACTIONS(10084), 1,
      anon_sym_where,
    STATE(6977), 1,
      sym_trailing_return_type,
    STATE(7220), 1,
      sym_where_clause,
    ACTIONS(9763), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7391), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [260912] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(7977), 1,
      sym__type_declarator,
    STATE(8623), 1,
      sym__type_definition_declarators,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [260962] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10819), 1,
      anon_sym_SLASH,
    ACTIONS(10827), 1,
      anon_sym_CARET,
    ACTIONS(10829), 1,
      anon_sym_AMP,
    ACTIONS(10992), 1,
      anon_sym_PIPE,
    ACTIONS(10815), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10817), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10831), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10833), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10835), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10837), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10990), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [261008] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(7977), 1,
      sym__type_declarator,
    STATE(8911), 1,
      sym__type_definition_declarators,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [261058] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(8777), 1,
      anon_sym_STAR,
    ACTIONS(10938), 1,
      anon_sym_TILDE,
    ACTIONS(10944), 1,
      anon_sym_operator,
    ACTIONS(10994), 1,
      sym_identifier,
    ACTIONS(10996), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10998), 1,
      anon_sym_template,
    STATE(2844), 1,
      sym_qualified_type_identifier,
    STATE(2859), 1,
      sym_dependent_type_identifier,
    STATE(2861), 1,
      sym_template_type,
    STATE(4333), 1,
      sym_pointer_type_declarator,
    STATE(4335), 1,
      sym_template_function,
    STATE(4336), 1,
      sym_destructor_name,
    STATE(4337), 1,
      sym_dependent_identifier,
    STATE(4339), 1,
      sym_qualified_identifier,
    STATE(4355), 1,
      sym_operator_name,
    STATE(6796), 1,
      sym__scope_resolution,
    STATE(10354), 1,
      sym_ms_based_modifier,
    STATE(10765), 1,
      sym_decltype,
  [261122] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10896), 1,
      sym_identifier,
    ACTIONS(10898), 1,
      anon_sym_LPAREN2,
    ACTIONS(10900), 1,
      anon_sym_defined,
    ACTIONS(11000), 1,
      sym_number_literal,
    ACTIONS(10902), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10904), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10908), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6960), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [261162] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10896), 1,
      sym_identifier,
    ACTIONS(10898), 1,
      anon_sym_LPAREN2,
    ACTIONS(10900), 1,
      anon_sym_defined,
    ACTIONS(11002), 1,
      sym_number_literal,
    ACTIONS(10902), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10904), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10908), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6908), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [261202] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10192), 1,
      anon_sym_requires,
    ACTIONS(10195), 1,
      anon_sym_where,
    STATE(6972), 1,
      sym_trailing_return_type,
    STATE(7152), 1,
      sym_where_clause,
    ACTIONS(10111), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7390), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [261246] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7518), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(7220), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7473), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [261286] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(7977), 1,
      sym__type_declarator,
    STATE(8774), 1,
      sym__type_definition_declarators,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [261336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5858), 1,
      anon_sym_LBRACK,
    ACTIONS(5860), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [261364] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    ACTIONS(10438), 1,
      anon_sym_requires,
    ACTIONS(10441), 1,
      anon_sym_where,
    STATE(6992), 1,
      sym_trailing_return_type,
    STATE(7240), 1,
      sym_where_clause,
    ACTIONS(10327), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7389), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [261408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5858), 1,
      anon_sym_LBRACK,
    ACTIONS(5860), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [261436] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10896), 1,
      sym_identifier,
    ACTIONS(10898), 1,
      anon_sym_LPAREN2,
    ACTIONS(10900), 1,
      anon_sym_defined,
    ACTIONS(11004), 1,
      sym_number_literal,
    ACTIONS(10902), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10904), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10908), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6928), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [261476] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5858), 1,
      anon_sym_LBRACK,
    ACTIONS(5860), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [261504] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7747), 1,
      anon_sym_DASH_GT,
    ACTIONS(10676), 1,
      anon_sym_LBRACK,
    ACTIONS(11006), 1,
      anon_sym_requires,
    ACTIONS(11009), 1,
      anon_sym_where,
    STATE(6997), 1,
      sym_trailing_return_type,
    STATE(7187), 1,
      sym_where_clause,
    ACTIONS(10678), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7387), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [261548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5886), 1,
      anon_sym_LBRACK,
    ACTIONS(5888), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [261576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11014), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(11012), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [261604] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6204), 1,
      anon_sym_LBRACK,
    ACTIONS(10888), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6206), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [261634] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym___attribute__,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(8910), 1,
      anon_sym_LPAREN2,
    ACTIONS(8986), 1,
      sym_identifier,
    ACTIONS(8988), 1,
      anon_sym_STAR,
    ACTIONS(8990), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8992), 1,
      anon_sym_AMP,
    ACTIONS(11016), 1,
      anon_sym_SEMI,
    STATE(6522), 1,
      sym__field_declarator,
    STATE(7707), 1,
      sym_operator_name,
    STATE(10402), 1,
      sym_attribute_specifier,
    STATE(10471), 1,
      sym_ms_based_modifier,
    STATE(7713), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [261686] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(7977), 1,
      sym__type_declarator,
    STATE(8701), 1,
      sym__type_definition_declarators,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [261736] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10896), 1,
      sym_identifier,
    ACTIONS(10898), 1,
      anon_sym_LPAREN2,
    ACTIONS(10900), 1,
      anon_sym_defined,
    ACTIONS(11018), 1,
      sym_number_literal,
    ACTIONS(10902), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10904), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10908), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6962), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [261776] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10896), 1,
      sym_identifier,
    ACTIONS(10898), 1,
      anon_sym_LPAREN2,
    ACTIONS(10900), 1,
      anon_sym_defined,
    ACTIONS(11020), 1,
      sym_number_literal,
    ACTIONS(10902), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10904), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10908), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6957), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [261816] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(8712), 1,
      anon_sym_STAR,
    ACTIONS(8714), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8716), 1,
      anon_sym_AMP,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(7736), 1,
      sym__abstract_declarator,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8834), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [261860] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(7977), 1,
      sym__type_declarator,
    STATE(8734), 1,
      sym__type_definition_declarators,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [261910] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10738), 1,
      anon_sym_requires,
    ACTIONS(10741), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(10735), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7188), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [261948] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10896), 1,
      sym_identifier,
    ACTIONS(10898), 1,
      anon_sym_LPAREN2,
    ACTIONS(10900), 1,
      anon_sym_defined,
    ACTIONS(11022), 1,
      sym_number_literal,
    ACTIONS(10902), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10904), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10908), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6958), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [261988] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10896), 1,
      sym_identifier,
    ACTIONS(10898), 1,
      anon_sym_LPAREN2,
    ACTIONS(10900), 1,
      anon_sym_defined,
    ACTIONS(11024), 1,
      sym_number_literal,
    ACTIONS(10902), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10904), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10908), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6918), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [262028] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(7977), 1,
      sym__type_declarator,
    STATE(8794), 1,
      sym__type_definition_declarators,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [262078] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(8752), 1,
      anon_sym_STAR,
    ACTIONS(10974), 1,
      anon_sym_TILDE,
    ACTIONS(10980), 1,
      anon_sym_operator,
    ACTIONS(11026), 1,
      sym_identifier,
    ACTIONS(11028), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11030), 1,
      anon_sym_template,
    STATE(2844), 1,
      sym_qualified_type_identifier,
    STATE(2859), 1,
      sym_dependent_type_identifier,
    STATE(2861), 1,
      sym_template_type,
    STATE(3267), 1,
      sym_operator_name,
    STATE(3268), 1,
      sym_qualified_identifier,
    STATE(3270), 1,
      sym_dependent_identifier,
    STATE(3272), 1,
      sym_destructor_name,
    STATE(3273), 1,
      sym_template_function,
    STATE(3274), 1,
      sym_pointer_type_declarator,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(10183), 1,
      sym_ms_based_modifier,
    STATE(10765), 1,
      sym_decltype,
  [262142] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10284), 1,
      anon_sym_requires,
    ACTIONS(10287), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(10281), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7186), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [262180] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10069), 1,
      anon_sym_requires,
    ACTIONS(10072), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(10066), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7184), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [262218] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10776), 1,
      sym_identifier,
    ACTIONS(10780), 1,
      anon_sym_LPAREN2,
    ACTIONS(10782), 1,
      anon_sym_defined,
    ACTIONS(11032), 1,
      sym_number_literal,
    ACTIONS(10784), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10786), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10790), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6925), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [262258] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9519), 1,
      anon_sym_requires,
    ACTIONS(9522), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7182), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [262296] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10896), 1,
      sym_identifier,
    ACTIONS(10898), 1,
      anon_sym_LPAREN2,
    ACTIONS(10900), 1,
      anon_sym_defined,
    ACTIONS(11034), 1,
      sym_number_literal,
    ACTIONS(10902), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10904), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10908), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6945), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [262336] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10896), 1,
      sym_identifier,
    ACTIONS(10898), 1,
      anon_sym_LPAREN2,
    ACTIONS(10900), 1,
      anon_sym_defined,
    ACTIONS(11036), 1,
      sym_number_literal,
    ACTIONS(10902), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10904), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10908), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6897), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [262376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5937), 8,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(5939), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [262404] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(4891), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(11038), 1,
      sym_identifier,
    ACTIONS(11040), 1,
      anon_sym_template,
    STATE(2675), 1,
      sym_dependent_type_identifier,
    STATE(2679), 1,
      sym_qualified_type_identifier,
    STATE(2680), 1,
      sym_template_type,
    STATE(3478), 1,
      sym_operator_name,
    STATE(3499), 1,
      sym_qualified_identifier,
    STATE(3500), 1,
      sym_dependent_identifier,
    STATE(3501), 1,
      sym_destructor_name,
    STATE(3503), 1,
      sym_template_function,
    STATE(3507), 1,
      sym_pointer_type_declarator,
    STATE(6829), 1,
      sym__scope_resolution,
    STATE(10239), 1,
      sym_ms_based_modifier,
    STATE(10765), 1,
      sym_decltype,
  [262468] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(5035), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(11042), 1,
      sym_identifier,
    ACTIONS(11044), 1,
      anon_sym_template,
    STATE(2675), 1,
      sym_dependent_type_identifier,
    STATE(2679), 1,
      sym_qualified_type_identifier,
    STATE(2680), 1,
      sym_template_type,
    STATE(3478), 1,
      sym_operator_name,
    STATE(3499), 1,
      sym_qualified_identifier,
    STATE(3500), 1,
      sym_dependent_identifier,
    STATE(3501), 1,
      sym_destructor_name,
    STATE(3503), 1,
      sym_template_function,
    STATE(3507), 1,
      sym_pointer_type_declarator,
    STATE(6830), 1,
      sym__scope_resolution,
    STATE(10239), 1,
      sym_ms_based_modifier,
    STATE(10765), 1,
      sym_decltype,
  [262532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11048), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(11046), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [262560] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10896), 1,
      sym_identifier,
    ACTIONS(10898), 1,
      anon_sym_LPAREN2,
    ACTIONS(10900), 1,
      anon_sym_defined,
    ACTIONS(11050), 1,
      sym_number_literal,
    ACTIONS(10902), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10904), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10908), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6939), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [262600] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10896), 1,
      sym_identifier,
    ACTIONS(10898), 1,
      anon_sym_LPAREN2,
    ACTIONS(10900), 1,
      anon_sym_defined,
    ACTIONS(11052), 1,
      sym_number_literal,
    ACTIONS(10902), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10904), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10908), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6929), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [262640] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10896), 1,
      sym_identifier,
    ACTIONS(10898), 1,
      anon_sym_LPAREN2,
    ACTIONS(10900), 1,
      anon_sym_defined,
    ACTIONS(11054), 1,
      sym_number_literal,
    ACTIONS(10902), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10904), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10908), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6923), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [262680] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(7471), 1,
      anon_sym_where,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7527), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10966), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [262718] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(7471), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7526), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [262756] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(8752), 1,
      anon_sym_STAR,
    ACTIONS(10974), 1,
      anon_sym_TILDE,
    ACTIONS(10980), 1,
      anon_sym_operator,
    ACTIONS(11056), 1,
      sym_identifier,
    ACTIONS(11058), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11060), 1,
      anon_sym_template,
    STATE(2675), 1,
      sym_dependent_type_identifier,
    STATE(2679), 1,
      sym_qualified_type_identifier,
    STATE(2680), 1,
      sym_template_type,
    STATE(3267), 1,
      sym_operator_name,
    STATE(3268), 1,
      sym_qualified_identifier,
    STATE(3270), 1,
      sym_dependent_identifier,
    STATE(3272), 1,
      sym_destructor_name,
    STATE(3273), 1,
      sym_template_function,
    STATE(3274), 1,
      sym_pointer_type_declarator,
    STATE(6837), 1,
      sym__scope_resolution,
    STATE(10183), 1,
      sym_ms_based_modifier,
    STATE(10765), 1,
      sym_decltype,
  [262820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2355), 8,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(2353), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [262848] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(7471), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7507), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [262886] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10896), 1,
      sym_identifier,
    ACTIONS(10898), 1,
      anon_sym_LPAREN2,
    ACTIONS(10900), 1,
      anon_sym_defined,
    ACTIONS(11062), 1,
      sym_number_literal,
    ACTIONS(10902), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10904), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10908), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6920), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [262926] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11067), 1,
      anon_sym_requires,
    ACTIONS(11070), 1,
      anon_sym_where,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(11064), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7191), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10966), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [262964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5892), 8,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(5894), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [262992] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8686), 1,
      anon_sym_STAR,
    ACTIONS(8688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8690), 1,
      anon_sym_AMP,
    STATE(4485), 1,
      sym_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7876), 1,
      sym__abstract_declarator,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8834), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [263036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6058), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [263064] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10896), 1,
      sym_identifier,
    ACTIONS(10898), 1,
      anon_sym_LPAREN2,
    ACTIONS(10900), 1,
      anon_sym_defined,
    ACTIONS(11073), 1,
      sym_number_literal,
    ACTIONS(10902), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10904), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10908), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6912), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [263104] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5933), 8,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(5935), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [263132] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10676), 1,
      anon_sym_LBRACK,
    ACTIONS(10681), 1,
      anon_sym_requires,
    ACTIONS(10684), 1,
      anon_sym_where,
    STATE(7187), 1,
      sym_where_clause,
    ACTIONS(10678), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7181), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [263172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6056), 8,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6058), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [263200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 8,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6062), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [263228] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(7471), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7501), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [263266] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(8752), 1,
      anon_sym_STAR,
    ACTIONS(10656), 1,
      anon_sym_TILDE,
    ACTIONS(11075), 1,
      sym_identifier,
    ACTIONS(11077), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11079), 1,
      anon_sym_template,
    ACTIONS(11081), 1,
      anon_sym_operator,
    STATE(196), 1,
      sym_template_type,
    STATE(197), 1,
      sym_dependent_type_identifier,
    STATE(201), 1,
      sym_qualified_type_identifier,
    STATE(3478), 1,
      sym_operator_name,
    STATE(3499), 1,
      sym_qualified_identifier,
    STATE(3500), 1,
      sym_dependent_identifier,
    STATE(3501), 1,
      sym_destructor_name,
    STATE(3503), 1,
      sym_template_function,
    STATE(3507), 1,
      sym_pointer_type_declarator,
    STATE(6851), 1,
      sym__scope_resolution,
    STATE(10183), 1,
      sym_ms_based_modifier,
    STATE(10765), 1,
      sym_decltype,
  [263330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5858), 8,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(5860), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [263358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5858), 8,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(5860), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [263386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5858), 8,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(5860), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [263414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5933), 1,
      anon_sym_LBRACK,
    ACTIONS(5935), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [263442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11085), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(11083), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [263470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11089), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(11087), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [263498] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(7471), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7500), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [263536] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10968), 1,
      anon_sym_LBRACK,
    ACTIONS(11094), 1,
      anon_sym_requires,
    ACTIONS(11097), 1,
      anon_sym_where,
    STATE(7172), 1,
      sym_where_clause,
    ACTIONS(11091), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7125), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10966), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [263576] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(8742), 1,
      anon_sym_STAR,
    ACTIONS(11100), 1,
      sym_identifier,
    ACTIONS(11102), 1,
      anon_sym_TILDE,
    ACTIONS(11104), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11106), 1,
      anon_sym_template,
    ACTIONS(11108), 1,
      anon_sym_operator,
    STATE(4484), 1,
      sym_template_function,
    STATE(4522), 1,
      sym_operator_name,
    STATE(4523), 1,
      sym_qualified_identifier,
    STATE(4524), 1,
      sym_dependent_identifier,
    STATE(4525), 1,
      sym_destructor_name,
    STATE(4527), 1,
      sym_pointer_type_declarator,
    STATE(5027), 1,
      sym_template_type,
    STATE(5108), 1,
      sym_dependent_type_identifier,
    STATE(5177), 1,
      sym_qualified_type_identifier,
    STATE(6860), 1,
      sym__scope_resolution,
    STATE(10635), 1,
      sym_ms_based_modifier,
    STATE(10765), 1,
      sym_decltype,
  [263640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2359), 8,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(2357), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [263668] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5896), 8,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(5898), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [263696] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10819), 1,
      anon_sym_SLASH,
    ACTIONS(10817), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10992), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10990), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [263728] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7518), 1,
      anon_sym_where,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    STATE(7240), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7486), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [263768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10992), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10990), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [263796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5953), 8,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(5955), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [263824] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(8777), 1,
      anon_sym_STAR,
    ACTIONS(10938), 1,
      anon_sym_TILDE,
    ACTIONS(10944), 1,
      anon_sym_operator,
    ACTIONS(11110), 1,
      sym_identifier,
    ACTIONS(11112), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11114), 1,
      anon_sym_template,
    STATE(2675), 1,
      sym_dependent_type_identifier,
    STATE(2679), 1,
      sym_qualified_type_identifier,
    STATE(2680), 1,
      sym_template_type,
    STATE(4333), 1,
      sym_pointer_type_declarator,
    STATE(4335), 1,
      sym_template_function,
    STATE(4336), 1,
      sym_destructor_name,
    STATE(4337), 1,
      sym_dependent_identifier,
    STATE(4339), 1,
      sym_qualified_identifier,
    STATE(4355), 1,
      sym_operator_name,
    STATE(6867), 1,
      sym__scope_resolution,
    STATE(10354), 1,
      sym_ms_based_modifier,
    STATE(10765), 1,
      sym_decltype,
  [263888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5941), 8,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(5943), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [263916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_LBRACK,
    ACTIONS(6062), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [263944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5886), 8,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(5888), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [263972] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(7977), 1,
      sym__type_declarator,
    STATE(8645), 1,
      sym__type_definition_declarators,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [264022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5941), 1,
      anon_sym_LBRACK,
    ACTIONS(5943), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [264050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5961), 8,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(5963), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [264078] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10819), 1,
      anon_sym_SLASH,
    ACTIONS(10821), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10823), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10825), 1,
      anon_sym_PIPE,
    ACTIONS(10827), 1,
      anon_sym_CARET,
    ACTIONS(10829), 1,
      anon_sym_AMP,
    ACTIONS(10815), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10817), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10831), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10833), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10835), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10837), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(11116), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [264128] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(7977), 1,
      sym__type_declarator,
    STATE(8664), 1,
      sym__type_definition_declarators,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [264178] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10819), 1,
      anon_sym_SLASH,
    ACTIONS(10823), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10825), 1,
      anon_sym_PIPE,
    ACTIONS(10827), 1,
      anon_sym_CARET,
    ACTIONS(10829), 1,
      anon_sym_AMP,
    ACTIONS(10815), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10817), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10831), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10833), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10835), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10837), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10990), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
  [264226] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(7977), 1,
      sym__type_declarator,
    STATE(8722), 1,
      sym__type_definition_declarators,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [264276] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10819), 1,
      anon_sym_SLASH,
    ACTIONS(10825), 1,
      anon_sym_PIPE,
    ACTIONS(10827), 1,
      anon_sym_CARET,
    ACTIONS(10829), 1,
      anon_sym_AMP,
    ACTIONS(10815), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10817), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10831), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10833), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10835), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10837), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10990), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [264322] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(8742), 1,
      anon_sym_STAR,
    ACTIONS(11102), 1,
      anon_sym_TILDE,
    ACTIONS(11108), 1,
      anon_sym_operator,
    ACTIONS(11118), 1,
      sym_identifier,
    ACTIONS(11120), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11122), 1,
      anon_sym_template,
    STATE(196), 1,
      sym_template_type,
    STATE(197), 1,
      sym_dependent_type_identifier,
    STATE(201), 1,
      sym_qualified_type_identifier,
    STATE(4484), 1,
      sym_template_function,
    STATE(4522), 1,
      sym_operator_name,
    STATE(4523), 1,
      sym_qualified_identifier,
    STATE(4524), 1,
      sym_dependent_identifier,
    STATE(4525), 1,
      sym_destructor_name,
    STATE(4527), 1,
      sym_pointer_type_declarator,
    STATE(6879), 1,
      sym__scope_resolution,
    STATE(10635), 1,
      sym_ms_based_modifier,
    STATE(10765), 1,
      sym_decltype,
  [264386] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    ACTIONS(10330), 1,
      anon_sym_requires,
    ACTIONS(10333), 1,
      anon_sym_where,
    STATE(7240), 1,
      sym_where_clause,
    ACTIONS(10327), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7169), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [264426] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym___attribute__,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(8910), 1,
      anon_sym_LPAREN2,
    ACTIONS(8986), 1,
      sym_identifier,
    ACTIONS(8988), 1,
      anon_sym_STAR,
    ACTIONS(8990), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8992), 1,
      anon_sym_AMP,
    ACTIONS(11124), 1,
      anon_sym_SEMI,
    STATE(6523), 1,
      sym__field_declarator,
    STATE(7707), 1,
      sym_operator_name,
    STATE(10088), 1,
      sym_attribute_specifier,
    STATE(10471), 1,
      sym_ms_based_modifier,
    STATE(7713), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [264478] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10896), 1,
      sym_identifier,
    ACTIONS(10898), 1,
      anon_sym_LPAREN2,
    ACTIONS(10900), 1,
      anon_sym_defined,
    ACTIONS(11126), 1,
      sym_number_literal,
    ACTIONS(10902), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10904), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10908), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6916), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [264518] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9766), 1,
      anon_sym_requires,
    ACTIONS(9769), 1,
      anon_sym_where,
    STATE(7220), 1,
      sym_where_clause,
    ACTIONS(9763), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7144), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [264558] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5925), 8,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(5927), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [264586] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10896), 1,
      sym_identifier,
    ACTIONS(10898), 1,
      anon_sym_LPAREN2,
    ACTIONS(10900), 1,
      anon_sym_defined,
    ACTIONS(11128), 1,
      sym_number_literal,
    ACTIONS(10902), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10904), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10908), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6900), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [264626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6044), 8,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6046), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [264654] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7518), 1,
      anon_sym_where,
    ACTIONS(10676), 1,
      anon_sym_LBRACK,
    STATE(7187), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7579), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [264694] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10114), 1,
      anon_sym_requires,
    ACTIONS(10117), 1,
      anon_sym_where,
    STATE(7152), 1,
      sym_where_clause,
    ACTIONS(10111), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7091), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [264734] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10819), 1,
      anon_sym_SLASH,
    ACTIONS(10815), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10817), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10992), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10990), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [264768] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10819), 1,
      anon_sym_SLASH,
    ACTIONS(10815), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10817), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10837), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10992), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10990), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [264804] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10819), 1,
      anon_sym_SLASH,
    ACTIONS(10829), 1,
      anon_sym_AMP,
    ACTIONS(10992), 1,
      anon_sym_PIPE,
    ACTIONS(10815), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10817), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10831), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10833), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10835), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10837), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10990), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [264848] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10819), 1,
      anon_sym_SLASH,
    ACTIONS(10815), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10817), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10831), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10833), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10835), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10837), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10992), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(10990), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [264890] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10819), 1,
      anon_sym_SLASH,
    ACTIONS(10815), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10817), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10833), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10835), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10837), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10992), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(10990), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [264930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11132), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(11130), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [264958] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5892), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [264986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11134), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6206), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [265013] = 8,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(10990), 1,
      anon_sym_LF,
    ACTIONS(11136), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11140), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(11138), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(11142), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10992), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
  [265050] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8752), 1,
      anon_sym_STAR,
    ACTIONS(8754), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8756), 1,
      anon_sym_AMP,
    STATE(3094), 1,
      sym__type_declarator,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(10183), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [265097] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10377), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(563), 1,
      sym_field_declaration_list,
    STATE(7039), 1,
      sym_attribute_declaration,
    STATE(8132), 1,
      sym__scope_resolution,
    STATE(8830), 1,
      sym_virtual_specifier,
    STATE(9857), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(238), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [265152] = 12,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(11146), 1,
      anon_sym_LF,
    ACTIONS(11148), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(11150), 1,
      anon_sym_AMP_AMP,
    ACTIONS(11152), 1,
      anon_sym_PIPE,
    ACTIONS(11154), 1,
      anon_sym_CARET,
    ACTIONS(11156), 1,
      anon_sym_AMP,
    ACTIONS(11136), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11140), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(11138), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(11142), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [265197] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(11158), 1,
      sym_identifier,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11162), 1,
      anon_sym_template,
    STATE(3478), 1,
      sym_operator_name,
    STATE(3499), 1,
      sym_qualified_identifier,
    STATE(3500), 1,
      sym_dependent_identifier,
    STATE(3501), 1,
      sym_destructor_name,
    STATE(3503), 1,
      sym_template_function,
    STATE(3507), 1,
      sym_pointer_type_declarator,
    STATE(6901), 1,
      sym__scope_resolution,
    STATE(10239), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [265254] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(8094), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8724), 1,
      anon_sym_STAR,
    ACTIONS(10803), 1,
      sym_identifier,
    ACTIONS(10805), 1,
      anon_sym_template,
    STATE(3478), 1,
      sym_operator_name,
    STATE(3499), 1,
      sym_qualified_identifier,
    STATE(3500), 1,
      sym_dependent_identifier,
    STATE(3501), 1,
      sym_destructor_name,
    STATE(3503), 1,
      sym_template_function,
    STATE(3507), 1,
      sym_pointer_type_declarator,
    STATE(6902), 1,
      sym__scope_resolution,
    STATE(10519), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [265311] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7782), 1,
      anon_sym_where,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    STATE(7240), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7591), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [265350] = 12,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(11148), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(11150), 1,
      anon_sym_AMP_AMP,
    ACTIONS(11152), 1,
      anon_sym_PIPE,
    ACTIONS(11154), 1,
      anon_sym_CARET,
    ACTIONS(11156), 1,
      anon_sym_AMP,
    ACTIONS(11164), 1,
      anon_sym_LF,
    ACTIONS(11136), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11140), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(11138), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(11142), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [265395] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2479), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11166), 1,
      sym_identifier,
    ACTIONS(11168), 1,
      anon_sym_COLON_COLON,
    STATE(249), 1,
      sym_template_type,
    STATE(375), 1,
      sym_field_declaration_list,
    STATE(7051), 1,
      sym_attribute_declaration,
    STATE(8050), 1,
      sym__scope_resolution,
    STATE(8764), 1,
      sym_virtual_specifier,
    STATE(9768), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(232), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [265450] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7782), 1,
      anon_sym_where,
    ACTIONS(10676), 1,
      anon_sym_LBRACK,
    STATE(7187), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7593), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [265489] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10819), 1,
      anon_sym_SLASH,
    ACTIONS(10821), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10823), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10825), 1,
      anon_sym_PIPE,
    ACTIONS(10827), 1,
      anon_sym_CARET,
    ACTIONS(10829), 1,
      anon_sym_AMP,
    ACTIONS(11170), 1,
      anon_sym_RPAREN,
    ACTIONS(10815), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10817), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10831), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10833), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10835), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10837), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [265538] = 12,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(11148), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(11150), 1,
      anon_sym_AMP_AMP,
    ACTIONS(11152), 1,
      anon_sym_PIPE,
    ACTIONS(11154), 1,
      anon_sym_CARET,
    ACTIONS(11156), 1,
      anon_sym_AMP,
    ACTIONS(11172), 1,
      anon_sym_LF,
    ACTIONS(11136), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11140), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(11138), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(11142), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [265583] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(10982), 1,
      anon_sym_LF,
    ACTIONS(10984), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [265610] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8828), 1,
      anon_sym_STAR,
    ACTIONS(8830), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8832), 1,
      anon_sym_AMP,
    STATE(4574), 1,
      sym_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8017), 1,
      sym__abstract_declarator,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8834), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [265653] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10968), 1,
      anon_sym_LBRACK,
    ACTIONS(11094), 1,
      anon_sym_requires,
    ACTIONS(11174), 1,
      anon_sym_where,
    STATE(7172), 1,
      sym_where_clause,
    ACTIONS(11091), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7278), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10966), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [265692] = 4,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(10990), 1,
      anon_sym_LF,
    ACTIONS(11138), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10992), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [265721] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7782), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    STATE(7152), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7649), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [265760] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8798), 1,
      sym_identifier,
    ACTIONS(8800), 1,
      anon_sym_LPAREN2,
    ACTIONS(8802), 1,
      anon_sym_STAR,
    ACTIONS(8804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8806), 1,
      anon_sym_AMP,
    ACTIONS(8810), 1,
      sym_primitive_type,
    STATE(7833), 1,
      sym_pointer_type_declarator,
    STATE(7936), 1,
      sym__type_declarator,
    STATE(10326), 1,
      sym_ms_based_modifier,
    ACTIONS(8808), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7859), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [265807] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7782), 1,
      anon_sym_where,
    ACTIONS(10968), 1,
      anon_sym_LBRACK,
    STATE(7172), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7595), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10966), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [265846] = 12,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(11148), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(11150), 1,
      anon_sym_AMP_AMP,
    ACTIONS(11152), 1,
      anon_sym_PIPE,
    ACTIONS(11154), 1,
      anon_sym_CARET,
    ACTIONS(11156), 1,
      anon_sym_AMP,
    ACTIONS(11177), 1,
      anon_sym_LF,
    ACTIONS(11136), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11140), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(11138), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(11142), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [265891] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(8252), 1,
      sym__type_declarator,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [265938] = 6,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(10990), 1,
      anon_sym_LF,
    ACTIONS(11136), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(11138), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10992), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [265971] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(8255), 1,
      sym__type_declarator,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [266018] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(10990), 1,
      anon_sym_LF,
    ACTIONS(10992), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [266045] = 12,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(11148), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(11150), 1,
      anon_sym_AMP_AMP,
    ACTIONS(11152), 1,
      anon_sym_PIPE,
    ACTIONS(11154), 1,
      anon_sym_CARET,
    ACTIONS(11156), 1,
      anon_sym_AMP,
    ACTIONS(11179), 1,
      anon_sym_LF,
    ACTIONS(11136), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11140), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(11138), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(11142), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [266090] = 12,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(10990), 1,
      anon_sym_LF,
    ACTIONS(10992), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(11150), 1,
      anon_sym_AMP_AMP,
    ACTIONS(11152), 1,
      anon_sym_PIPE,
    ACTIONS(11154), 1,
      anon_sym_CARET,
    ACTIONS(11156), 1,
      anon_sym_AMP,
    ACTIONS(11136), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11140), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(11138), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(11142), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [266135] = 11,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(10990), 1,
      anon_sym_LF,
    ACTIONS(11152), 1,
      anon_sym_PIPE,
    ACTIONS(11154), 1,
      anon_sym_CARET,
    ACTIONS(11156), 1,
      anon_sym_AMP,
    ACTIONS(10992), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(11136), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11140), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(11138), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(11142), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [266178] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8724), 1,
      anon_sym_STAR,
    ACTIONS(8726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8728), 1,
      anon_sym_AMP,
    ACTIONS(8736), 1,
      sym_primitive_type,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(8284), 1,
      sym__type_declarator,
    STATE(10519), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [266225] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10819), 1,
      anon_sym_SLASH,
    ACTIONS(10821), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10823), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10825), 1,
      anon_sym_PIPE,
    ACTIONS(10827), 1,
      anon_sym_CARET,
    ACTIONS(10829), 1,
      anon_sym_AMP,
    ACTIONS(11181), 1,
      anon_sym_RPAREN,
    ACTIONS(10815), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10817), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10831), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10833), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10835), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10837), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [266274] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8802), 1,
      anon_sym_STAR,
    ACTIONS(11183), 1,
      sym_identifier,
    ACTIONS(11185), 1,
      anon_sym_template,
    STATE(6926), 1,
      sym__scope_resolution,
    STATE(7844), 1,
      sym_operator_name,
    STATE(7864), 1,
      sym_qualified_identifier,
    STATE(7881), 1,
      sym_dependent_identifier,
    STATE(7887), 1,
      sym_destructor_name,
    STATE(7891), 1,
      sym_template_function,
    STATE(7892), 1,
      sym_pointer_type_declarator,
    STATE(10326), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [266331] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(7625), 1,
      sym__type_declarator,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [266378] = 12,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(11148), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(11150), 1,
      anon_sym_AMP_AMP,
    ACTIONS(11152), 1,
      anon_sym_PIPE,
    ACTIONS(11154), 1,
      anon_sym_CARET,
    ACTIONS(11156), 1,
      anon_sym_AMP,
    ACTIONS(11187), 1,
      anon_sym_LF,
    ACTIONS(11136), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11140), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(11138), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(11142), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [266423] = 10,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(10990), 1,
      anon_sym_LF,
    ACTIONS(11154), 1,
      anon_sym_CARET,
    ACTIONS(11156), 1,
      anon_sym_AMP,
    ACTIONS(11136), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11140), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10992), 3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
    ACTIONS(11138), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(11142), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [266464] = 12,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(11148), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(11150), 1,
      anon_sym_AMP_AMP,
    ACTIONS(11152), 1,
      anon_sym_PIPE,
    ACTIONS(11154), 1,
      anon_sym_CARET,
    ACTIONS(11156), 1,
      anon_sym_AMP,
    ACTIONS(11189), 1,
      anon_sym_LF,
    ACTIONS(11136), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11140), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(11138), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(11142), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [266509] = 12,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(11148), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(11150), 1,
      anon_sym_AMP_AMP,
    ACTIONS(11152), 1,
      anon_sym_PIPE,
    ACTIONS(11154), 1,
      anon_sym_CARET,
    ACTIONS(11156), 1,
      anon_sym_AMP,
    ACTIONS(11191), 1,
      anon_sym_LF,
    ACTIONS(11136), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11140), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(11138), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(11142), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [266554] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2828), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11193), 1,
      sym_identifier,
    ACTIONS(11195), 1,
      anon_sym_COLON_COLON,
    STATE(456), 1,
      sym_template_type,
    STATE(728), 1,
      sym_field_declaration_list,
    STATE(7017), 1,
      sym_attribute_declaration,
    STATE(8092), 1,
      sym__scope_resolution,
    STATE(8649), 1,
      sym_virtual_specifier,
    STATE(9869), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(275), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [266609] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10146), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10392), 1,
      sym_identifier,
    STATE(309), 1,
      sym_template_type,
    STATE(804), 1,
      sym_field_declaration_list,
    STATE(7060), 1,
      sym_attribute_declaration,
    STATE(8117), 1,
      sym__scope_resolution,
    STATE(8607), 1,
      sym_virtual_specifier,
    STATE(10061), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(267), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [266664] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(11046), 1,
      anon_sym_LF,
    ACTIONS(11048), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [266691] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    ACTIONS(10330), 1,
      anon_sym_requires,
    ACTIONS(10455), 1,
      anon_sym_where,
    STATE(7240), 1,
      sym_where_clause,
    ACTIONS(10327), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7285), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [266730] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8773), 1,
      sym_identifier,
    ACTIONS(8775), 1,
      anon_sym_LPAREN2,
    ACTIONS(8777), 1,
      anon_sym_STAR,
    ACTIONS(8779), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8781), 1,
      anon_sym_AMP,
    ACTIONS(8785), 1,
      sym_primitive_type,
    STATE(3519), 1,
      sym__type_declarator,
    STATE(3956), 1,
      sym_pointer_type_declarator,
    STATE(10354), 1,
      sym_ms_based_modifier,
    ACTIONS(8783), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3959), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [266777] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(11012), 1,
      anon_sym_LF,
    ACTIONS(11014), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [266804] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11197), 1,
      sym_identifier,
    ACTIONS(11199), 1,
      anon_sym_COLON_COLON,
    STATE(195), 1,
      sym_template_type,
    STATE(804), 1,
      sym_field_declaration_list,
    STATE(7083), 1,
      sym_attribute_declaration,
    STATE(8064), 1,
      sym__scope_resolution,
    STATE(8780), 1,
      sym_virtual_specifier,
    STATE(9783), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(8096), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [266859] = 9,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(10990), 1,
      anon_sym_LF,
    ACTIONS(11156), 1,
      anon_sym_AMP,
    ACTIONS(11136), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11140), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(11138), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10992), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(11142), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [266898] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10114), 1,
      anon_sym_requires,
    ACTIONS(10189), 1,
      anon_sym_where,
    STATE(7152), 1,
      sym_where_clause,
    ACTIONS(10111), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7288), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [266937] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8798), 1,
      sym_identifier,
    ACTIONS(8800), 1,
      anon_sym_LPAREN2,
    ACTIONS(8810), 1,
      sym_primitive_type,
    ACTIONS(8812), 1,
      anon_sym_STAR,
    ACTIONS(8814), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8816), 1,
      anon_sym_AMP,
    STATE(7833), 1,
      sym_pointer_type_declarator,
    STATE(8169), 1,
      sym__type_declarator,
    STATE(10312), 1,
      sym_ms_based_modifier,
    ACTIONS(8808), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7859), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [266984] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9766), 1,
      anon_sym_requires,
    ACTIONS(10078), 1,
      anon_sym_where,
    STATE(7220), 1,
      sym_where_clause,
    ACTIONS(9763), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7291), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [267023] = 3,
    ACTIONS(7428), 1,
      anon_sym_LF,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(7426), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [267050] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(10926), 1,
      anon_sym_LF,
    ACTIONS(10928), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [267077] = 7,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(10990), 1,
      anon_sym_LF,
    ACTIONS(11136), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(11138), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(11142), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10992), 7,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [267112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4573), 8,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(4575), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [267139] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8798), 1,
      sym_identifier,
    ACTIONS(8800), 1,
      anon_sym_LPAREN2,
    ACTIONS(8802), 1,
      anon_sym_STAR,
    ACTIONS(8804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8806), 1,
      anon_sym_AMP,
    ACTIONS(8810), 1,
      sym_primitive_type,
    STATE(7372), 1,
      sym__type_declarator,
    STATE(7833), 1,
      sym_pointer_type_declarator,
    STATE(10326), 1,
      sym_ms_based_modifier,
    ACTIONS(8808), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(7859), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [267186] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8822), 1,
      anon_sym_STAR,
    ACTIONS(8824), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8826), 1,
      anon_sym_AMP,
    ACTIONS(8834), 1,
      anon_sym_COMMA,
    STATE(4577), 1,
      sym_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8007), 1,
      sym__abstract_declarator,
    ACTIONS(8836), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [267231] = 12,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(11148), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(11150), 1,
      anon_sym_AMP_AMP,
    ACTIONS(11152), 1,
      anon_sym_PIPE,
    ACTIONS(11154), 1,
      anon_sym_CARET,
    ACTIONS(11156), 1,
      anon_sym_AMP,
    ACTIONS(11201), 1,
      anon_sym_LF,
    ACTIONS(11136), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11140), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(11138), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(11142), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [267276] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(11130), 1,
      anon_sym_LF,
    ACTIONS(11132), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [267303] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10676), 1,
      anon_sym_LBRACK,
    ACTIONS(10681), 1,
      anon_sym_requires,
    ACTIONS(10792), 1,
      anon_sym_where,
    STATE(7187), 1,
      sym_where_clause,
    ACTIONS(10678), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7281), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [267342] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7942), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(11203), 1,
      sym_identifier,
    ACTIONS(11205), 1,
      anon_sym_template,
    STATE(3478), 1,
      sym_operator_name,
    STATE(3499), 1,
      sym_qualified_identifier,
    STATE(3500), 1,
      sym_dependent_identifier,
    STATE(3501), 1,
      sym_destructor_name,
    STATE(3503), 1,
      sym_template_function,
    STATE(3507), 1,
      sym_pointer_type_declarator,
    STATE(6952), 1,
      sym__scope_resolution,
    STATE(10239), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [267399] = 12,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(11148), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(11150), 1,
      anon_sym_AMP_AMP,
    ACTIONS(11152), 1,
      anon_sym_PIPE,
    ACTIONS(11154), 1,
      anon_sym_CARET,
    ACTIONS(11156), 1,
      anon_sym_AMP,
    ACTIONS(11207), 1,
      anon_sym_LF,
    ACTIONS(11136), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11140), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(11138), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(11142), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [267444] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7950), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8812), 1,
      anon_sym_STAR,
    ACTIONS(11183), 1,
      sym_identifier,
    ACTIONS(11185), 1,
      anon_sym_template,
    STATE(6954), 1,
      sym__scope_resolution,
    STATE(7844), 1,
      sym_operator_name,
    STATE(7864), 1,
      sym_qualified_identifier,
    STATE(7881), 1,
      sym_dependent_identifier,
    STATE(7887), 1,
      sym_destructor_name,
    STATE(7891), 1,
      sym_template_function,
    STATE(7892), 1,
      sym_pointer_type_declarator,
    STATE(10312), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [267501] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(11083), 1,
      anon_sym_LF,
    ACTIONS(11085), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [267528] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11134), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(11209), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(6194), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [267557] = 12,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(11148), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(11150), 1,
      anon_sym_AMP_AMP,
    ACTIONS(11152), 1,
      anon_sym_PIPE,
    ACTIONS(11154), 1,
      anon_sym_CARET,
    ACTIONS(11156), 1,
      anon_sym_AMP,
    ACTIONS(11211), 1,
      anon_sym_LF,
    ACTIONS(11136), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11140), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(11138), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(11142), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [267602] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(10990), 1,
      anon_sym_LF,
    ACTIONS(11136), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11138), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10992), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [267633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4545), 8,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(4547), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [267660] = 12,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(11148), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(11150), 1,
      anon_sym_AMP_AMP,
    ACTIONS(11152), 1,
      anon_sym_PIPE,
    ACTIONS(11154), 1,
      anon_sym_CARET,
    ACTIONS(11156), 1,
      anon_sym_AMP,
    ACTIONS(11213), 1,
      anon_sym_LF,
    ACTIONS(11136), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11140), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(11138), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(11142), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [267705] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(2395), 1,
      anon_sym_TILDE,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(7072), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(10803), 1,
      sym_identifier,
    ACTIONS(10805), 1,
      anon_sym_template,
    STATE(3478), 1,
      sym_operator_name,
    STATE(3499), 1,
      sym_qualified_identifier,
    STATE(3500), 1,
      sym_dependent_identifier,
    STATE(3501), 1,
      sym_destructor_name,
    STATE(3503), 1,
      sym_template_function,
    STATE(3507), 1,
      sym_pointer_type_declarator,
    STATE(6961), 1,
      sym__scope_resolution,
    STATE(10239), 1,
      sym_ms_based_modifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [267762] = 12,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(11148), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(11150), 1,
      anon_sym_AMP_AMP,
    ACTIONS(11152), 1,
      anon_sym_PIPE,
    ACTIONS(11154), 1,
      anon_sym_CARET,
    ACTIONS(11156), 1,
      anon_sym_AMP,
    ACTIONS(11215), 1,
      anon_sym_LF,
    ACTIONS(11136), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11140), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(11138), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(11142), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [267807] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(8355), 1,
      sym__type_declarator,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [267854] = 12,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(11148), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(11150), 1,
      anon_sym_AMP_AMP,
    ACTIONS(11152), 1,
      anon_sym_PIPE,
    ACTIONS(11154), 1,
      anon_sym_CARET,
    ACTIONS(11156), 1,
      anon_sym_AMP,
    ACTIONS(11217), 1,
      anon_sym_LF,
    ACTIONS(11136), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11140), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(11138), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(11142), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [267899] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(10930), 1,
      anon_sym_LF,
    ACTIONS(10932), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [267926] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7516), 1,
      anon_sym_requires,
    ACTIONS(7782), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(7220), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7602), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [267965] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(8121), 1,
      sym__type_declarator,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [268012] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8738), 1,
      sym_identifier,
    ACTIONS(8740), 1,
      anon_sym_LPAREN2,
    ACTIONS(8742), 1,
      anon_sym_STAR,
    ACTIONS(8744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8746), 1,
      anon_sym_AMP,
    ACTIONS(8750), 1,
      sym_primitive_type,
    STATE(3631), 1,
      sym__type_declarator,
    STATE(4278), 1,
      sym_pointer_type_declarator,
    STATE(10635), 1,
      sym_ms_based_modifier,
    ACTIONS(8748), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4276), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [268059] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(11087), 1,
      anon_sym_LF,
    ACTIONS(11089), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [268086] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(8720), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_LPAREN2,
    ACTIONS(8736), 1,
      sym_primitive_type,
    ACTIONS(8758), 1,
      anon_sym_STAR,
    ACTIONS(8760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8762), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_pointer_type_declarator,
    STATE(8326), 1,
      sym__type_declarator,
    STATE(10239), 1,
      sym_ms_based_modifier,
    ACTIONS(8732), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3111), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [268133] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(4577), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11219), 1,
      sym_identifier,
    ACTIONS(11221), 1,
      anon_sym_COLON_COLON,
    STATE(1247), 1,
      sym_template_type,
    STATE(1279), 1,
      sym_field_declaration_list,
    STATE(7014), 1,
      sym_attribute_declaration,
    STATE(8082), 1,
      sym__scope_resolution,
    STATE(8724), 1,
      sym_virtual_specifier,
    STATE(9687), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1199), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [268188] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    ACTIONS(10438), 1,
      anon_sym_requires,
    ACTIONS(10441), 1,
      anon_sym_where,
    STATE(7240), 1,
      sym_where_clause,
    ACTIONS(10327), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7389), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [268226] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11227), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6973), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(11223), 4,
      sym_identifier,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11225), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [268256] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11232), 1,
      anon_sym_LBRACK,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6988), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(11230), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [268286] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11197), 1,
      sym_identifier,
    ACTIONS(11234), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11236), 1,
      sym_virtual,
    STATE(195), 1,
      sym_template_type,
    STATE(7786), 1,
      sym_access_specifier,
    STATE(8127), 1,
      sym__scope_resolution,
    STATE(7003), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8538), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(11238), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [268334] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8156), 1,
      anon_sym_DASH_GT,
    ACTIONS(9519), 1,
      anon_sym_requires,
    ACTIONS(10138), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7149), 1,
      sym_trailing_return_type,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7609), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [268374] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10192), 1,
      anon_sym_requires,
    ACTIONS(10195), 1,
      anon_sym_where,
    STATE(7152), 1,
      sym_where_clause,
    ACTIONS(10111), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7390), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [268412] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7764), 1,
      anon_sym_requires,
    ACTIONS(7766), 1,
      anon_sym_where,
    ACTIONS(10968), 1,
      anon_sym_LBRACK,
    STATE(7172), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7917), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10966), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [268450] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(8156), 1,
      anon_sym_DASH_GT,
    ACTIONS(8193), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    STATE(7156), 1,
      sym_trailing_return_type,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8060), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [268490] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6973), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(11232), 4,
      sym_identifier,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11230), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [268520] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7764), 1,
      anon_sym_requires,
    ACTIONS(7766), 1,
      anon_sym_where,
    ACTIONS(10676), 1,
      anon_sym_LBRACK,
    STATE(7187), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7921), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [268558] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10746), 7,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(10744), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [268588] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8156), 1,
      anon_sym_DASH_GT,
    ACTIONS(10284), 1,
      anon_sym_requires,
    ACTIONS(10478), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    STATE(7121), 1,
      sym_trailing_return_type,
    ACTIONS(10281), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7611), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [268628] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(10081), 1,
      anon_sym_requires,
    ACTIONS(10084), 1,
      anon_sym_where,
    STATE(7220), 1,
      sym_where_clause,
    ACTIONS(9763), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7391), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [268666] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11244), 1,
      anon_sym_AMP,
    STATE(6996), 1,
      aux_sym_interface_requirements_repeat1,
    ACTIONS(11240), 6,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11242), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [268696] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8888), 1,
      anon_sym_STAR,
    ACTIONS(8890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8892), 1,
      anon_sym_AMP,
    STATE(4083), 1,
      sym_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8130), 1,
      sym__abstract_declarator,
    ACTIONS(8834), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [268738] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11240), 1,
      anon_sym_LBRACK,
    ACTIONS(11246), 1,
      anon_sym_AMP,
    STATE(7004), 1,
      aux_sym_interface_requirements_repeat1,
    ACTIONS(11242), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [268768] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11223), 1,
      anon_sym_LBRACK,
    ACTIONS(11248), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6988), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(11225), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [268798] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(8156), 1,
      anon_sym_DASH_GT,
    ACTIONS(8193), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    STATE(7176), 1,
      sym_trailing_return_type,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8053), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [268838] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11197), 1,
      sym_identifier,
    ACTIONS(11234), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11251), 1,
      sym_virtual,
    STATE(195), 1,
      sym_template_type,
    STATE(7856), 1,
      sym_access_specifier,
    STATE(8127), 1,
      sym__scope_resolution,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8758), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(11238), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [268886] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11197), 1,
      sym_identifier,
    ACTIONS(11234), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11253), 1,
      sym_virtual,
    STATE(195), 1,
      sym_template_type,
    STATE(7839), 1,
      sym_access_specifier,
    STATE(8127), 1,
      sym__scope_resolution,
    STATE(6990), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8833), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(11238), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [268934] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10676), 1,
      anon_sym_LBRACK,
    ACTIONS(11006), 1,
      anon_sym_requires,
    ACTIONS(11009), 1,
      anon_sym_where,
    STATE(7187), 1,
      sym_where_clause,
    ACTIONS(10678), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7387), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [268972] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8156), 1,
      anon_sym_DASH_GT,
    ACTIONS(10738), 1,
      anon_sym_requires,
    ACTIONS(11255), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    STATE(7155), 1,
      sym_trailing_return_type,
    ACTIONS(10735), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7616), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [269012] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7764), 1,
      anon_sym_requires,
    ACTIONS(7766), 1,
      anon_sym_where,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    STATE(7240), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7918), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [269050] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10725), 7,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(10723), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [269080] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11244), 1,
      anon_sym_AMP,
    STATE(7005), 1,
      aux_sym_interface_requirements_repeat1,
    ACTIONS(11258), 6,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11260), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [269110] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10968), 1,
      anon_sym_LBRACK,
    ACTIONS(11262), 1,
      anon_sym_requires,
    ACTIONS(11265), 1,
      anon_sym_where,
    STATE(7172), 1,
      sym_where_clause,
    ACTIONS(11091), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7386), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10966), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [269148] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7764), 1,
      anon_sym_requires,
    ACTIONS(7766), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    STATE(7152), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7868), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [269186] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(8156), 1,
      anon_sym_DASH_GT,
    ACTIONS(8193), 1,
      anon_sym_where,
    STATE(7110), 1,
      sym_trailing_return_type,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8044), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [269226] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11270), 1,
      anon_sym_AMP,
    ACTIONS(11273), 1,
      anon_sym_LBRACK,
    STATE(7000), 1,
      aux_sym_interface_requirements_repeat1,
    ACTIONS(11268), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [269256] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10847), 7,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(10849), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [269286] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7764), 1,
      anon_sym_requires,
    ACTIONS(7766), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(7220), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7850), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [269324] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11197), 1,
      sym_identifier,
    ACTIONS(11234), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11275), 1,
      sym_virtual,
    STATE(195), 1,
      sym_template_type,
    STATE(7719), 1,
      sym_access_specifier,
    STATE(8127), 1,
      sym__scope_resolution,
    STATE(6479), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8541), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(11238), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [269372] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11246), 1,
      anon_sym_AMP,
    ACTIONS(11258), 1,
      anon_sym_LBRACK,
    STATE(7000), 1,
      aux_sym_interface_requirements_repeat1,
    ACTIONS(11260), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [269402] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11277), 1,
      anon_sym_AMP,
    STATE(7005), 1,
      aux_sym_interface_requirements_repeat1,
    ACTIONS(11273), 6,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11268), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [269432] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8156), 1,
      anon_sym_DASH_GT,
    ACTIONS(10069), 1,
      anon_sym_requires,
    ACTIONS(10232), 1,
      anon_sym_where,
    STATE(7112), 1,
      sym_trailing_return_type,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(10066), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7610), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [269472] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(8156), 1,
      anon_sym_DASH_GT,
    ACTIONS(8193), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7173), 1,
      sym_trailing_return_type,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8036), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [269512] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3549), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11280), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [269543] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(11284), 1,
      anon_sym_LBRACE,
    STATE(3307), 1,
      sym_compound_statement,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7333), 1,
      sym_requires_clause,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(8871), 1,
      sym_abstract_function_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [269592] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3549), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11286), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [269623] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8970), 1,
      anon_sym_STAR,
    ACTIONS(8972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8974), 1,
      anon_sym_AMP,
    STATE(4302), 1,
      sym_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8140), 1,
      sym__abstract_declarator,
    ACTIONS(8834), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [269664] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11288), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(11294), 1,
      anon_sym_LBRACK,
    ACTIONS(11296), 1,
      anon_sym_EQ,
    STATE(7210), 1,
      sym_interface_requirements,
    STATE(7226), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11290), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [269699] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(11298), 1,
      anon_sym_LT,
    STATE(1847), 1,
      sym_compound_statement,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(7024), 1,
      sym_template_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(8925), 1,
      sym_abstract_function_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [269748] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(4577), 1,
      anon_sym_LBRACE,
    ACTIONS(11219), 1,
      sym_identifier,
    ACTIONS(11221), 1,
      anon_sym_COLON_COLON,
    STATE(1247), 1,
      sym_template_type,
    STATE(1329), 1,
      sym_field_declaration_list,
    STATE(8082), 1,
      sym__scope_resolution,
    STATE(8741), 1,
      sym_virtual_specifier,
    STATE(9714), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1198), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [269797] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11300), 1,
      sym_identifier,
    STATE(7332), 1,
      sym_string_literal,
    STATE(7624), 1,
      sym_raw_string_literal,
    ACTIONS(11302), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(8672), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [269832] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8251), 1,
      anon_sym_DASH_GT,
    ACTIONS(10308), 1,
      anon_sym_requires,
    ACTIONS(10311), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7275), 1,
      sym_trailing_return_type,
    ACTIONS(10066), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7773), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [269871] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2828), 1,
      anon_sym_LBRACE,
    ACTIONS(11193), 1,
      sym_identifier,
    ACTIONS(11195), 1,
      anon_sym_COLON_COLON,
    STATE(456), 1,
      sym_template_type,
    STATE(755), 1,
      sym_field_declaration_list,
    STATE(8092), 1,
      sym__scope_resolution,
    STATE(8669), 1,
      sym_virtual_specifier,
    STATE(9799), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(274), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [269920] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(8910), 1,
      anon_sym_LPAREN2,
    ACTIONS(8986), 1,
      sym_identifier,
    ACTIONS(8988), 1,
      anon_sym_STAR,
    ACTIONS(8990), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8992), 1,
      anon_sym_AMP,
    STATE(7395), 1,
      sym__field_declarator,
    STATE(7707), 1,
      sym_operator_name,
    STATE(10471), 1,
      sym_ms_based_modifier,
    STATE(7713), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [269963] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(11304), 1,
      anon_sym_LBRACE,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(4390), 1,
      sym_compound_statement,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7341), 1,
      sym_requires_clause,
    STATE(8633), 1,
      sym_abstract_function_declarator,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [270012] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11306), 1,
      sym_identifier,
    ACTIONS(6437), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(7049), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(11308), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(11310), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [270043] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6192), 1,
      anon_sym_LBRACK,
    ACTIONS(11312), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(11314), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6194), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [270072] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11316), 1,
      sym_identifier,
    ACTIONS(6444), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(7022), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(11319), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(11322), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [270103] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6204), 1,
      anon_sym_LBRACK,
    ACTIONS(11314), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6206), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [270130] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    STATE(1843), 1,
      sym_compound_statement,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7256), 1,
      sym_requires_clause,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(8929), 1,
      sym_abstract_function_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [270179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11273), 1,
      anon_sym_LBRACK,
    ACTIONS(11268), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [270204] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(11298), 1,
      anon_sym_LT,
    ACTIONS(11325), 1,
      anon_sym_LBRACE,
    STATE(1847), 1,
      sym_compound_statement,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(7037), 1,
      sym_template_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(8789), 1,
      sym_abstract_function_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [270253] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(11327), 1,
      anon_sym_LBRACE,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(4494), 1,
      sym_compound_statement,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7270), 1,
      sym_requires_clause,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(8733), 1,
      sym_abstract_function_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [270302] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6204), 1,
      anon_sym_AMP,
    ACTIONS(11329), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6206), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [270329] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(11298), 1,
      anon_sym_LT,
    ACTIONS(11304), 1,
      anon_sym_LBRACE,
    STATE(4311), 1,
      sym_compound_statement,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(7019), 1,
      sym_template_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(8860), 1,
      sym_abstract_function_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [270378] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3549), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11331), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [270409] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8279), 1,
      anon_sym___attribute__,
    STATE(6027), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6642), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10723), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(10725), 6,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [270442] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3549), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11333), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [270473] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8279), 1,
      anon_sym___attribute__,
    STATE(6027), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6672), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10744), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(10746), 6,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [270506] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(11298), 1,
      anon_sym_LT,
    ACTIONS(11327), 1,
      anon_sym_LBRACE,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(4528), 1,
      sym_compound_statement,
    STATE(7027), 1,
      sym_template_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(8720), 1,
      sym_abstract_function_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [270555] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8285), 1,
      anon_sym_DASH_GT,
    ACTIONS(10279), 1,
      sym_identifier,
    ACTIONS(10484), 1,
      anon_sym_requires,
    ACTIONS(10487), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    STATE(7269), 1,
      sym_trailing_return_type,
    ACTIONS(10481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7764), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [270596] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3549), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11335), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [270627] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(11325), 1,
      anon_sym_LBRACE,
    STATE(1843), 1,
      sym_compound_statement,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7321), 1,
      sym_requires_clause,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(8810), 1,
      sym_abstract_function_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [270676] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8251), 1,
      anon_sym_DASH_GT,
    ACTIONS(10180), 1,
      anon_sym_requires,
    ACTIONS(10183), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7253), 1,
      sym_trailing_return_type,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7781), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [270715] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(10130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10377), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(601), 1,
      sym_field_declaration_list,
    STATE(8132), 1,
      sym__scope_resolution,
    STATE(8889), 1,
      sym_virtual_specifier,
    STATE(9952), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(240), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [270764] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3549), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11337), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [270795] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(11339), 1,
      anon_sym_LBRACE,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(4966), 1,
      sym_compound_statement,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7249), 1,
      sym_requires_clause,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(8711), 1,
      sym_abstract_function_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [270844] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3549), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11341), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [270875] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(11343), 1,
      anon_sym_LBRACE,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(6884), 1,
      sym_compound_statement,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7312), 1,
      sym_requires_clause,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(8891), 1,
      sym_abstract_function_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [270924] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(11298), 1,
      anon_sym_LT,
    ACTIONS(11339), 1,
      anon_sym_LBRACE,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(4981), 1,
      sym_compound_statement,
    STATE(7041), 1,
      sym_template_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(8827), 1,
      sym_abstract_function_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [270973] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8251), 1,
      anon_sym_DASH_GT,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8299), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7347), 1,
      sym_trailing_return_type,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8225), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [271012] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8285), 1,
      anon_sym_DASH_GT,
    ACTIONS(8293), 1,
      anon_sym_requires,
    ACTIONS(8295), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      sym_identifier,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7243), 1,
      sym_trailing_return_type,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8204), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [271053] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8285), 1,
      anon_sym_DASH_GT,
    ACTIONS(8293), 1,
      anon_sym_requires,
    ACTIONS(8295), 1,
      anon_sym_where,
    ACTIONS(10676), 1,
      sym_identifier,
    STATE(7133), 1,
      sym_where_clause,
    STATE(7322), 1,
      sym_trailing_return_type,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8183), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [271094] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8251), 1,
      anon_sym_DASH_GT,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8299), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7302), 1,
      sym_trailing_return_type,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8221), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [271133] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11345), 1,
      sym_identifier,
    ACTIONS(6456), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(7022), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(11308), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(11310), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [271164] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(11298), 1,
      anon_sym_LT,
    ACTIONS(11343), 1,
      anon_sym_LBRACE,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(6846), 1,
      sym_compound_statement,
    STATE(7043), 1,
      sym_template_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(8879), 1,
      sym_abstract_function_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [271213] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2479), 1,
      anon_sym_LBRACE,
    ACTIONS(11166), 1,
      sym_identifier,
    ACTIONS(11168), 1,
      anon_sym_COLON_COLON,
    STATE(249), 1,
      sym_template_type,
    STATE(396), 1,
      sym_field_declaration_list,
    STATE(8050), 1,
      sym__scope_resolution,
    STATE(8695), 1,
      sym_virtual_specifier,
    STATE(9676), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(231), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [271262] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(11298), 1,
      anon_sym_LT,
    ACTIONS(11347), 1,
      anon_sym_LBRACE,
    STATE(3772), 1,
      sym_compound_statement,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(7064), 1,
      sym_template_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8676), 1,
      sym_abstract_function_declarator,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [271311] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8251), 1,
      anon_sym_DASH_GT,
    ACTIONS(10490), 1,
      anon_sym_requires,
    ACTIONS(10493), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    STATE(7277), 1,
      sym_trailing_return_type,
    ACTIONS(10281), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7908), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [271350] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8251), 1,
      anon_sym_DASH_GT,
    ACTIONS(11349), 1,
      anon_sym_requires,
    ACTIONS(11352), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    STATE(7284), 1,
      sym_trailing_return_type,
    ACTIONS(10735), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7842), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [271389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11273), 6,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11268), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [271414] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8285), 1,
      anon_sym_DASH_GT,
    ACTIONS(10676), 1,
      sym_identifier,
    ACTIONS(11358), 1,
      anon_sym_requires,
    ACTIONS(11361), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    STATE(7250), 1,
      sym_trailing_return_type,
    ACTIONS(11355), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7762), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [271455] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(11364), 1,
      anon_sym_LBRACE,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(4642), 1,
      sym_compound_statement,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7266), 1,
      sym_requires_clause,
    STATE(8662), 1,
      sym_abstract_function_declarator,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [271504] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8285), 1,
      anon_sym_DASH_GT,
    ACTIONS(8293), 1,
      anon_sym_requires,
    ACTIONS(8295), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      sym_identifier,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7348), 1,
      sym_trailing_return_type,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8215), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [271545] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8285), 1,
      anon_sym_DASH_GT,
    ACTIONS(10064), 1,
      sym_identifier,
    ACTIONS(10302), 1,
      anon_sym_requires,
    ACTIONS(10305), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7313), 1,
      sym_trailing_return_type,
    ACTIONS(10299), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7767), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [271586] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    ACTIONS(10146), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10392), 1,
      sym_identifier,
    STATE(309), 1,
      sym_template_type,
    STATE(726), 1,
      sym_field_declaration_list,
    STATE(8117), 1,
      sym__scope_resolution,
    STATE(8913), 1,
      sym_virtual_specifier,
    STATE(10016), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(271), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [271635] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(8910), 1,
      anon_sym_LPAREN2,
    ACTIONS(8986), 1,
      sym_identifier,
    ACTIONS(8988), 1,
      anon_sym_STAR,
    ACTIONS(8990), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8992), 1,
      anon_sym_AMP,
    STATE(7293), 1,
      sym__field_declarator,
    STATE(7707), 1,
      sym_operator_name,
    STATE(10471), 1,
      sym_ms_based_modifier,
    STATE(7713), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [271678] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(11298), 1,
      anon_sym_LT,
    ACTIONS(11364), 1,
      anon_sym_LBRACE,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(4674), 1,
      sym_compound_statement,
    STATE(7057), 1,
      sym_template_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8642), 1,
      sym_abstract_function_declarator,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [271727] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8285), 1,
      anon_sym_DASH_GT,
    ACTIONS(8293), 1,
      anon_sym_requires,
    ACTIONS(8295), 1,
      anon_sym_where,
    ACTIONS(10279), 1,
      sym_identifier,
    STATE(7088), 1,
      sym_where_clause,
    STATE(7326), 1,
      sym_trailing_return_type,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8206), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [271768] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(11347), 1,
      anon_sym_LBRACE,
    STATE(3791), 1,
      sym_compound_statement,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7296), 1,
      sym_requires_clause,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(8744), 1,
      sym_abstract_function_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [271817] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11366), 1,
      anon_sym_COMMA,
    ACTIONS(11368), 1,
      anon_sym_COLON,
    ACTIONS(11370), 1,
      anon_sym_EQ,
    STATE(7109), 1,
      aux_sym_where_clause_repeat1,
    STATE(7117), 1,
      sym_interface_requirements,
    ACTIONS(11290), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [271850] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(11284), 1,
      anon_sym_LBRACE,
    ACTIONS(11298), 1,
      anon_sym_LT,
    STATE(3275), 1,
      sym_compound_statement,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(7009), 1,
      sym_template_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(8819), 1,
      sym_abstract_function_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [271899] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(8908), 1,
      sym_identifier,
    ACTIONS(8910), 1,
      anon_sym_LPAREN2,
    ACTIONS(8912), 1,
      anon_sym_STAR,
    ACTIONS(8914), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8916), 1,
      anon_sym_AMP,
    STATE(8222), 1,
      sym__field_declarator,
    STATE(8493), 1,
      sym_operator_name,
    STATE(10393), 1,
      sym_ms_based_modifier,
    STATE(7713), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [271942] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8251), 1,
      anon_sym_DASH_GT,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8299), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    STATE(7279), 1,
      sym_trailing_return_type,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8203), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [271981] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6192), 1,
      anon_sym_AMP,
    ACTIONS(11329), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(11372), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(6194), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [272010] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8219), 1,
      sym__abstract_declarator,
    ACTIONS(8834), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [272051] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(3489), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11341), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [272082] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8285), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      sym_identifier,
    ACTIONS(10169), 1,
      anon_sym_requires,
    ACTIONS(10172), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7319), 1,
      sym_trailing_return_type,
    ACTIONS(10166), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7770), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [272123] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(3489), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11333), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [272154] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(3489), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11331), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [272185] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3549), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11376), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [272216] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(11298), 1,
      anon_sym_LT,
    ACTIONS(11378), 1,
      anon_sym_LBRACE,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(6855), 1,
      sym_compound_statement,
    STATE(7082), 1,
      sym_template_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(8848), 1,
      sym_abstract_function_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [272265] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(3489), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11286), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [272296] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(3489), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11280), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [272327] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(3489), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11376), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [272358] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(3489), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11335), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [272389] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(3489), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11337), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [272420] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(11378), 1,
      anon_sym_LBRACE,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(6771), 1,
      sym_compound_statement,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(7282), 1,
      sym_requires_clause,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(8855), 1,
      sym_abstract_function_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [272469] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2477), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(11197), 1,
      sym_identifier,
    ACTIONS(11199), 1,
      anon_sym_COLON_COLON,
    STATE(195), 1,
      sym_template_type,
    STATE(726), 1,
      sym_field_declaration_list,
    STATE(8064), 1,
      sym__scope_resolution,
    STATE(8612), 1,
      sym_virtual_specifier,
    STATE(10026), 1,
      sym_base_class_clause,
    ACTIONS(2481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(8100), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [272518] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(8908), 1,
      sym_identifier,
    ACTIONS(8910), 1,
      anon_sym_LPAREN2,
    ACTIONS(8912), 1,
      anon_sym_STAR,
    ACTIONS(8914), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8916), 1,
      anon_sym_AMP,
    STATE(8184), 1,
      sym__field_declarator,
    STATE(8493), 1,
      sym_operator_name,
    STATE(10393), 1,
      sym_ms_based_modifier,
    STATE(7713), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [272561] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8251), 1,
      anon_sym_DASH_GT,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8299), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    STATE(7311), 1,
      sym_trailing_return_type,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8148), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [272600] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(5024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11380), 1,
      sym_identifier,
    ACTIONS(11382), 1,
      sym_primitive_type,
    STATE(2632), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8090), 1,
      sym__scope_resolution,
    STATE(2712), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(195), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [272640] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11384), 1,
      sym_identifier,
    ACTIONS(11386), 1,
      sym_primitive_type,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(5763), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [272680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10676), 6,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(10674), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [272704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11390), 1,
      anon_sym_LBRACK,
    ACTIONS(11388), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [272728] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11392), 1,
      anon_sym_COLON,
    ACTIONS(11394), 1,
      anon_sym_SEMI,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11398), 1,
      anon_sym_EQ,
    ACTIONS(11400), 1,
      anon_sym_try,
    STATE(1000), 1,
      sym_try_statement,
    STATE(1066), 1,
      sym_compound_statement,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    STATE(9433), 1,
      aux_sym_declaration_repeat1,
    STATE(7572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [272778] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    ACTIONS(10333), 1,
      anon_sym_where,
    STATE(7240), 1,
      sym_where_clause,
    ACTIONS(10277), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [272806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10064), 6,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(10062), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [272830] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8372), 1,
      anon_sym_DASH_GT,
    ACTIONS(8393), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    STATE(7422), 1,
      sym_trailing_return_type,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8303), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [272868] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11402), 1,
      sym_identifier,
    ACTIONS(11404), 1,
      sym_primitive_type,
    STATE(3003), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8070), 1,
      sym__scope_resolution,
    STATE(3100), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(10050), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [272908] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8381), 1,
      anon_sym_DASH_GT,
    ACTIONS(11406), 1,
      anon_sym_requires,
    ACTIONS(11409), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    STATE(7418), 1,
      sym_trailing_return_type,
    ACTIONS(10735), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7983), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [272946] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11412), 1,
      sym_identifier,
    ACTIONS(11414), 1,
      sym_primitive_type,
    STATE(3343), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8115), 1,
      sym__scope_resolution,
    STATE(3715), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9897), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [272986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11418), 1,
      anon_sym_LBRACK,
    ACTIONS(11416), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [273010] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11420), 1,
      sym_identifier,
    ACTIONS(11422), 1,
      sym_primitive_type,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(2918), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [273050] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11424), 1,
      sym_identifier,
    ACTIONS(11426), 1,
      sym_primitive_type,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(5694), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [273090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11430), 1,
      anon_sym_LBRACK,
    ACTIONS(11428), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [273114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11434), 1,
      anon_sym_LBRACK,
    ACTIONS(11432), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [273138] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(10130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11436), 1,
      sym_identifier,
    ACTIONS(11438), 1,
      sym_primitive_type,
    STATE(886), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8132), 1,
      sym__scope_resolution,
    STATE(437), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(55), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [273178] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11366), 1,
      anon_sym_COMMA,
    STATE(7106), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11440), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [273204] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11366), 1,
      anon_sym_COMMA,
    STATE(7103), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [273230] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11366), 1,
      anon_sym_COMMA,
    STATE(7106), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [273256] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11446), 1,
      anon_sym_COMMA,
    STATE(7106), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11444), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [273282] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11366), 1,
      anon_sym_COMMA,
    STATE(7106), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [273308] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11366), 1,
      anon_sym_COMMA,
    STATE(7105), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [273334] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11366), 1,
      anon_sym_COMMA,
    STATE(7106), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [273360] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(8193), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8053), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [273394] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(655), 1,
      anon_sym_LBRACE,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11398), 1,
      anon_sym_EQ,
    ACTIONS(11453), 1,
      anon_sym_COLON,
    ACTIONS(11455), 1,
      anon_sym_SEMI,
    ACTIONS(11457), 1,
      anon_sym_try,
    STATE(833), 1,
      sym_try_statement,
    STATE(864), 1,
      sym_compound_statement,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    STATE(9513), 1,
      aux_sym_declaration_repeat1,
    STATE(7572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [273444] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10284), 1,
      anon_sym_requires,
    ACTIONS(10478), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(10281), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7611), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [273478] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(10024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11459), 1,
      sym_identifier,
    ACTIONS(11461), 1,
      sym_primitive_type,
    STATE(3153), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8107), 1,
      sym__scope_resolution,
    STATE(3473), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(10026), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [273518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11418), 6,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11416), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [273542] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8398), 1,
      anon_sym_DASH_GT,
    ACTIONS(8466), 1,
      anon_sym_requires,
    ACTIONS(8468), 1,
      anon_sym_where,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    STATE(7240), 1,
      sym_where_clause,
    STATE(7460), 1,
      sym_trailing_return_type,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8320), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [273582] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1219), 1,
      anon_sym_LBRACE,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11398), 1,
      anon_sym_EQ,
    ACTIONS(11463), 1,
      anon_sym_COLON,
    ACTIONS(11465), 1,
      anon_sym_SEMI,
    ACTIONS(11467), 1,
      anon_sym_try,
    STATE(976), 1,
      sym_try_statement,
    STATE(978), 1,
      sym_compound_statement,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    STATE(9348), 1,
      aux_sym_declaration_repeat1,
    STATE(7572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [273632] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11366), 1,
      anon_sym_COMMA,
    ACTIONS(11469), 1,
      anon_sym_EQ,
    STATE(7107), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [273660] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(10938), 1,
      anon_sym_TILDE,
    ACTIONS(11471), 1,
      sym_identifier,
    ACTIONS(11473), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11476), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11478), 1,
      anon_sym_template,
    STATE(7581), 1,
      sym__scope_resolution,
    STATE(9841), 1,
      sym_operator_name,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(4386), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [273702] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11380), 1,
      sym_identifier,
    ACTIONS(11382), 1,
      sym_primitive_type,
    STATE(3133), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(2712), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(3977), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [273742] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11480), 1,
      anon_sym_COLON,
    ACTIONS(11483), 1,
      anon_sym_EQ,
    STATE(7310), 1,
      sym_interface_requirements,
    ACTIONS(11444), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [273770] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10738), 1,
      anon_sym_requires,
    ACTIONS(11255), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(10735), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7616), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [273804] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11380), 1,
      sym_identifier,
    ACTIONS(11382), 1,
      sym_primitive_type,
    STATE(2632), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(2712), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(195), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [273844] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8044), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11486), 1,
      sym_identifier,
    ACTIONS(11488), 1,
      sym_primitive_type,
    STATE(5463), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8039), 1,
      sym__scope_resolution,
    STATE(437), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8046), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [273884] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8398), 1,
      anon_sym_DASH_GT,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10386), 1,
      anon_sym_requires,
    ACTIONS(10389), 1,
      anon_sym_where,
    STATE(7152), 1,
      sym_where_clause,
    STATE(7447), 1,
      sym_trailing_return_type,
    ACTIONS(10111), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7986), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [273924] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11492), 1,
      anon_sym_LBRACK,
    ACTIONS(11494), 1,
      anon_sym_where,
    STATE(7170), 1,
      sym_where_clause,
    ACTIONS(11490), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [273952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11499), 1,
      anon_sym_LBRACK,
    ACTIONS(11497), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [273976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11501), 6,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11503), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [274000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11505), 6,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11507), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [274024] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11509), 1,
      sym_identifier,
    ACTIONS(11511), 1,
      sym_primitive_type,
    STATE(5859), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(5694), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8068), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [274064] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11424), 1,
      sym_identifier,
    ACTIONS(11426), 1,
      sym_primitive_type,
    STATE(4903), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(5694), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(4633), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [274104] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8381), 1,
      anon_sym_DASH_GT,
    ACTIONS(10496), 1,
      anon_sym_requires,
    ACTIONS(10499), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    STATE(7417), 1,
      sym_trailing_return_type,
    ACTIONS(10281), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [274142] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8381), 1,
      anon_sym_DASH_GT,
    ACTIONS(10339), 1,
      anon_sym_requires,
    ACTIONS(10342), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7416), 1,
      sym_trailing_return_type,
    ACTIONS(10066), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7999), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [274180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10968), 6,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(10966), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [274204] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8381), 1,
      anon_sym_DASH_GT,
    ACTIONS(10204), 1,
      anon_sym_requires,
    ACTIONS(10207), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7415), 1,
      sym_trailing_return_type,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8014), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [274242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11513), 6,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11515), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [274266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11499), 6,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11497), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [274290] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10590), 1,
      anon_sym_try,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11398), 1,
      anon_sym_EQ,
    ACTIONS(11517), 1,
      anon_sym_COLON,
    ACTIONS(11519), 1,
      anon_sym_SEMI,
    ACTIONS(11521), 1,
      anon_sym_LBRACE,
    STATE(2564), 1,
      sym_try_statement,
    STATE(2565), 1,
      sym_compound_statement,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    STATE(9123), 1,
      aux_sym_declaration_repeat1,
    STATE(7572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11513), 1,
      anon_sym_LBRACK,
    ACTIONS(11515), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [274364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11505), 1,
      anon_sym_LBRACK,
    ACTIONS(11507), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [274388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11390), 6,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11388), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [274412] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(8193), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8036), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [274446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11523), 6,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11525), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [274470] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8381), 1,
      anon_sym_DASH_GT,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8385), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    STATE(7410), 1,
      sym_trailing_return_type,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8353), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [274508] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10117), 1,
      anon_sym_where,
    STATE(7152), 1,
      sym_where_clause,
    ACTIONS(10062), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [274536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11529), 1,
      anon_sym_LBRACK,
    ACTIONS(11527), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [274560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11430), 6,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11428), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [274584] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11384), 1,
      sym_identifier,
    ACTIONS(11386), 1,
      sym_primitive_type,
    STATE(4923), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(5763), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [274624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11531), 6,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11533), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [274648] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10069), 1,
      anon_sym_requires,
    ACTIONS(10232), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(10066), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7610), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [274682] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(309), 1,
      anon_sym_LBRACE,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11398), 1,
      anon_sym_EQ,
    ACTIONS(11535), 1,
      anon_sym_COLON,
    ACTIONS(11537), 1,
      anon_sym_SEMI,
    ACTIONS(11539), 1,
      anon_sym_try,
    STATE(538), 1,
      sym_try_statement,
    STATE(539), 1,
      sym_compound_statement,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    STATE(9236), 1,
      aux_sym_declaration_repeat1,
    STATE(7572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11501), 1,
      anon_sym_LBRACK,
    ACTIONS(11503), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [274756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    ACTIONS(10277), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [274780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11492), 6,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11490), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [274804] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9769), 1,
      anon_sym_where,
    STATE(7220), 1,
      sym_where_clause,
    ACTIONS(9512), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [274832] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11067), 1,
      anon_sym_requires,
    ACTIONS(11541), 1,
      anon_sym_where,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(11064), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7617), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10966), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [274866] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(8193), 1,
      anon_sym_where,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8077), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10966), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [274900] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11544), 1,
      anon_sym_COLON,
    ACTIONS(11547), 1,
      anon_sym_LBRACK,
    ACTIONS(11549), 1,
      anon_sym_EQ,
    STATE(7299), 1,
      sym_interface_requirements,
    ACTIONS(11444), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [274930] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11509), 1,
      sym_identifier,
    ACTIONS(11511), 1,
      sym_primitive_type,
    STATE(5512), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(5694), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(7865), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [274970] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9938), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11552), 1,
      sym_identifier,
    ACTIONS(11554), 1,
      sym_primitive_type,
    STATE(4648), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8098), 1,
      sym__scope_resolution,
    STATE(4961), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9940), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [275010] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8381), 1,
      anon_sym_DASH_GT,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8385), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    STATE(7408), 1,
      sym_trailing_return_type,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8304), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [275048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(9512), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [275072] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8381), 1,
      anon_sym_DASH_GT,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8385), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7403), 1,
      sym_trailing_return_type,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8311), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [275110] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8381), 1,
      anon_sym_DASH_GT,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8385), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7402), 1,
      sym_trailing_return_type,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8317), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [275148] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8372), 1,
      anon_sym_DASH_GT,
    ACTIONS(8393), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    STATE(7425), 1,
      sym_trailing_return_type,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8299), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [275186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11529), 6,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11527), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [275210] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10606), 1,
      anon_sym_try,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11398), 1,
      anon_sym_EQ,
    ACTIONS(11556), 1,
      anon_sym_COLON,
    ACTIONS(11558), 1,
      anon_sym_SEMI,
    ACTIONS(11560), 1,
      anon_sym_LBRACE,
    STATE(2238), 1,
      sym_try_statement,
    STATE(2239), 1,
      sym_compound_statement,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    STATE(9561), 1,
      aux_sym_declaration_repeat1,
    STATE(7572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [275260] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11562), 6,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11564), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [275284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11566), 6,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11568), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [275308] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10676), 1,
      anon_sym_LBRACK,
    ACTIONS(10684), 1,
      anon_sym_where,
    STATE(7187), 1,
      sym_where_clause,
    ACTIONS(10674), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [275336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11566), 1,
      anon_sym_LBRACK,
    ACTIONS(11568), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [275360] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11562), 1,
      anon_sym_LBRACK,
    ACTIONS(11564), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [275384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11492), 1,
      anon_sym_LBRACK,
    ACTIONS(11490), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [275408] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(8193), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8044), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [275442] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8398), 1,
      anon_sym_DASH_GT,
    ACTIONS(10676), 1,
      anon_sym_LBRACK,
    ACTIONS(11570), 1,
      anon_sym_requires,
    ACTIONS(11573), 1,
      anon_sym_where,
    STATE(7187), 1,
      sym_where_clause,
    STATE(7445), 1,
      sym_trailing_return_type,
    ACTIONS(10678), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7998), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [275482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11531), 1,
      anon_sym_LBRACK,
    ACTIONS(11533), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [275506] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7469), 1,
      anon_sym_requires,
    ACTIONS(8193), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8060), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [275540] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8372), 1,
      anon_sym_DASH_GT,
    ACTIONS(8393), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7426), 1,
      sym_trailing_return_type,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8293), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [275578] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(9099), 1,
      anon_sym_STAR,
    ACTIONS(9101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9103), 1,
      anon_sym_AMP,
    STATE(4478), 1,
      sym_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8264), 1,
      sym__abstract_declarator,
    ACTIONS(8834), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_GT2,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [275618] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9522), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(9512), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [275644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11576), 6,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11578), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [275668] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10968), 1,
      anon_sym_LBRACK,
    ACTIONS(11097), 1,
      anon_sym_where,
    STATE(7172), 1,
      sym_where_clause,
    ACTIONS(10966), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [275696] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10072), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(10062), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [275722] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(11294), 1,
      anon_sym_LBRACK,
    ACTIONS(11580), 1,
      anon_sym_COMMA,
    ACTIONS(11582), 1,
      anon_sym_EQ,
    STATE(7280), 1,
      sym_interface_requirements,
    STATE(7359), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11290), 10,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [275756] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10287), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(10277), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [275782] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(10089), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11486), 1,
      sym_identifier,
    ACTIONS(11488), 1,
      sym_primitive_type,
    STATE(5463), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8067), 1,
      sym__scope_resolution,
    STATE(437), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8046), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [275822] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10741), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(10674), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [275848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10968), 1,
      anon_sym_LBRACK,
    ACTIONS(10966), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [275872] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11070), 1,
      anon_sym_where,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(10966), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [275898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11584), 6,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11586), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [275922] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8398), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(10242), 1,
      anon_sym_requires,
    ACTIONS(10245), 1,
      anon_sym_where,
    STATE(7220), 1,
      sym_where_clause,
    STATE(7448), 1,
      sym_trailing_return_type,
    ACTIONS(9763), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7976), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [275962] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11588), 1,
      anon_sym_where,
    STATE(7168), 1,
      sym_where_clause,
    ACTIONS(11490), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [275988] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11288), 1,
      anon_sym_COMMA,
    ACTIONS(11591), 1,
      anon_sym_LBRACK,
    STATE(7212), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11440), 13,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [276016] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11288), 1,
      anon_sym_COMMA,
    ACTIONS(11593), 1,
      anon_sym_LBRACK,
    STATE(7192), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 13,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [276044] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11597), 1,
      anon_sym___attribute__,
    ACTIONS(11602), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(11600), 3,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    STATE(7194), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
    ACTIONS(11595), 7,
      anon_sym_COLON,
      anon_sym___declspec,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
  [276074] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3763), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11376), 12,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [276104] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10279), 6,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(10277), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [276128] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(11294), 1,
      anon_sym_LBRACK,
    ACTIONS(11605), 1,
      anon_sym_COMMA,
    ACTIONS(11607), 1,
      anon_sym_EQ,
    STATE(7316), 1,
      aux_sym_where_clause_repeat1,
    STATE(7318), 1,
      sym_interface_requirements,
    ACTIONS(11290), 10,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [276162] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8398), 1,
      anon_sym_DASH_GT,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    ACTIONS(10562), 1,
      anon_sym_requires,
    ACTIONS(10565), 1,
      anon_sym_where,
    STATE(7240), 1,
      sym_where_clause,
    STATE(7446), 1,
      sym_trailing_return_type,
    ACTIONS(10327), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7997), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [276202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11609), 6,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11611), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [276226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11576), 1,
      anon_sym_LBRACK,
    ACTIONS(11578), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [276250] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8425), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    ACTIONS(9223), 1,
      anon_sym_STAR,
    ACTIONS(9225), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9227), 1,
      anon_sym_AMP,
    STATE(4588), 1,
      sym_parameter_list,
    STATE(7138), 1,
      sym__function_declarator_seq,
    STATE(8296), 1,
      sym__abstract_declarator,
    ACTIONS(8834), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
    STATE(7139), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [276290] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9514), 6,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9512), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [276314] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3763), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11341), 12,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [276344] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10598), 1,
      anon_sym_try,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11398), 1,
      anon_sym_EQ,
    ACTIONS(11613), 1,
      anon_sym_COLON,
    ACTIONS(11615), 1,
      anon_sym_SEMI,
    ACTIONS(11617), 1,
      anon_sym_LBRACE,
    STATE(1561), 1,
      sym_compound_statement,
    STATE(1562), 1,
      sym_try_statement,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    STATE(9216), 1,
      aux_sym_declaration_repeat1,
    STATE(7572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [276394] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11619), 6,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11621), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [276418] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(9197), 1,
      anon_sym_STAR,
    ACTIONS(9199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9201), 1,
      anon_sym_AMP,
    STATE(4541), 1,
      sym_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8337), 1,
      sym__abstract_declarator,
    ACTIONS(8834), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [276458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11523), 1,
      anon_sym_LBRACK,
    ACTIONS(11525), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [276482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11623), 6,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11625), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [276506] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11288), 1,
      anon_sym_COMMA,
    ACTIONS(11593), 1,
      anon_sym_LBRACK,
    STATE(7212), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 13,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [276534] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11288), 1,
      anon_sym_COMMA,
    ACTIONS(11627), 1,
      anon_sym_LBRACK,
    ACTIONS(11629), 1,
      anon_sym_EQ,
    STATE(7213), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 12,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [276564] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9519), 1,
      anon_sym_requires,
    ACTIONS(10138), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7609), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [276598] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11547), 1,
      anon_sym_LBRACK,
    ACTIONS(11631), 1,
      anon_sym_COMMA,
    STATE(7212), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11444), 13,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [276626] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11288), 1,
      anon_sym_COMMA,
    ACTIONS(11634), 1,
      anon_sym_LBRACK,
    STATE(7212), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 13,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [276654] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11422), 1,
      sym_primitive_type,
    ACTIONS(11636), 1,
      sym_identifier,
    STATE(2892), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8113), 1,
      sym__scope_resolution,
    STATE(2918), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2766), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [276694] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3763), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11337), 12,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [276724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11584), 1,
      anon_sym_LBRACK,
    ACTIONS(11586), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [276748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11619), 1,
      anon_sym_LBRACK,
    ACTIONS(11621), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [276772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11623), 1,
      anon_sym_LBRACK,
    ACTIONS(11625), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [276796] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8398), 1,
      anon_sym_DASH_GT,
    ACTIONS(8466), 1,
      anon_sym_requires,
    ACTIONS(8468), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(7220), 1,
      sym_where_clause,
    STATE(7350), 1,
      sym_trailing_return_type,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8285), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [276836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10062), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [276860] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3763), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11333), 12,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [276890] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11638), 1,
      sym_identifier,
    ACTIONS(11640), 1,
      sym_primitive_type,
    STATE(3011), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8070), 1,
      sym__scope_resolution,
    STATE(3100), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9970), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [276930] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3763), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11331), 12,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [276960] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11642), 1,
      sym_identifier,
    ACTIONS(11644), 1,
      sym_primitive_type,
    STATE(6114), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(2918), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [277000] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8398), 1,
      anon_sym_DASH_GT,
    ACTIONS(8466), 1,
      anon_sym_requires,
    ACTIONS(8468), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    STATE(7152), 1,
      sym_where_clause,
    STATE(7459), 1,
      sym_trailing_return_type,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8245), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [277040] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11288), 1,
      anon_sym_COMMA,
    ACTIONS(11627), 1,
      anon_sym_LBRACK,
    STATE(7212), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 13,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [277068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11609), 1,
      anon_sym_LBRACK,
    ACTIONS(11611), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [277092] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8372), 1,
      anon_sym_DASH_GT,
    ACTIONS(11349), 1,
      anon_sym_requires,
    ACTIONS(11646), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    STATE(7378), 1,
      sym_trailing_return_type,
    ACTIONS(10735), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7972), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [277130] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8372), 1,
      anon_sym_DASH_GT,
    ACTIONS(10490), 1,
      anon_sym_requires,
    ACTIONS(10507), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    STATE(7379), 1,
      sym_trailing_return_type,
    ACTIONS(10281), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7963), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [277168] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8372), 1,
      anon_sym_DASH_GT,
    ACTIONS(10308), 1,
      anon_sym_requires,
    ACTIONS(10336), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7380), 1,
      sym_trailing_return_type,
    ACTIONS(10066), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7961), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [277206] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8372), 1,
      anon_sym_DASH_GT,
    ACTIONS(10180), 1,
      anon_sym_requires,
    ACTIONS(10210), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7381), 1,
      sym_trailing_return_type,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7953), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [277244] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3763), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11286), 12,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [277274] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(10146), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11649), 1,
      sym_identifier,
    ACTIONS(11651), 1,
      sym_primitive_type,
    STATE(644), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8117), 1,
      sym__scope_resolution,
    STATE(718), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1041), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [277314] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3763), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11280), 12,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [277344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11434), 6,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11432), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [277368] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3763), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11335), 12,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [277398] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8398), 1,
      anon_sym_DASH_GT,
    ACTIONS(8466), 1,
      anon_sym_requires,
    ACTIONS(8468), 1,
      anon_sym_where,
    ACTIONS(10676), 1,
      anon_sym_LBRACK,
    STATE(7187), 1,
      sym_where_clause,
    STATE(7461), 1,
      sym_trailing_return_type,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8231), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [277438] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9836), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11653), 1,
      sym_identifier,
    ACTIONS(11655), 1,
      sym_primitive_type,
    STATE(3203), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8075), 1,
      sym__scope_resolution,
    STATE(3572), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9838), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [277478] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11288), 1,
      anon_sym_COMMA,
    ACTIONS(11634), 1,
      anon_sym_LBRACK,
    STATE(7209), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 13,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [277506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10676), 1,
      anon_sym_LBRACK,
    ACTIONS(10674), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [277530] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8372), 1,
      anon_sym_DASH_GT,
    ACTIONS(8393), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7430), 1,
      sym_trailing_return_type,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8270), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [277568] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(9994), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11657), 1,
      sym_identifier,
    ACTIONS(11659), 1,
      sym_primitive_type,
    STATE(3812), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8035), 1,
      sym__scope_resolution,
    STATE(4751), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9996), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [277608] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8293), 1,
      anon_sym_requires,
    ACTIONS(8295), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      sym_identifier,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8215), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [277643] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8406), 1,
      anon_sym_DASH_GT,
    ACTIONS(10279), 1,
      sym_identifier,
    ACTIONS(10521), 1,
      anon_sym_requires,
    ACTIONS(10524), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    STATE(7543), 1,
      sym_trailing_return_type,
    ACTIONS(10481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8062), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [277682] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11300), 1,
      sym_identifier,
    STATE(7332), 1,
      sym_string_literal,
    STATE(7624), 1,
      sym_raw_string_literal,
    STATE(9241), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [277713] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8412), 1,
      anon_sym_DASH_GT,
    ACTIONS(10204), 1,
      anon_sym_requires,
    ACTIONS(10237), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7514), 1,
      sym_trailing_return_type,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8043), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [277750] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3717), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11337), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [277779] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8406), 1,
      anon_sym_DASH_GT,
    ACTIONS(9514), 1,
      sym_identifier,
    ACTIONS(10226), 1,
      anon_sym_requires,
    ACTIONS(10229), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7557), 1,
      sym_trailing_return_type,
    ACTIONS(10166), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8111), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [277818] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(11339), 1,
      anon_sym_LBRACE,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(4976), 1,
      sym_compound_statement,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8655), 1,
      sym_abstract_function_declarator,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [277861] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10968), 1,
      sym_identifier,
    ACTIONS(11664), 1,
      anon_sym_requires,
    ACTIONS(11667), 1,
      anon_sym_where,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(11661), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7761), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10966), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [277896] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3717), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11280), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [277925] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8412), 1,
      anon_sym_DASH_GT,
    ACTIONS(8417), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    STATE(7511), 1,
      sym_trailing_return_type,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8468), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [277962] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10308), 1,
      anon_sym_requires,
    ACTIONS(10311), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(10066), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7773), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [277995] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8412), 1,
      anon_sym_DASH_GT,
    ACTIONS(8417), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    STATE(7508), 1,
      sym_trailing_return_type,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8367), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [278032] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    STATE(7572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11670), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [278065] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    STATE(1920), 1,
      sym_compound_statement,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(8931), 1,
      sym_abstract_function_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [278108] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3717), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11286), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [278137] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8406), 1,
      anon_sym_DASH_GT,
    ACTIONS(10064), 1,
      sym_identifier,
    ACTIONS(10398), 1,
      anon_sym_requires,
    ACTIONS(10401), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7571), 1,
      sym_trailing_return_type,
    ACTIONS(10299), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8128), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [278176] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8299), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8225), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [278209] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11544), 1,
      anon_sym_COLON,
    ACTIONS(11547), 1,
      anon_sym_LBRACK,
    ACTIONS(11672), 1,
      anon_sym_EQ,
    STATE(7398), 1,
      sym_interface_requirements,
    ACTIONS(11444), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [278238] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11300), 1,
      sym_identifier,
    STATE(7332), 1,
      sym_string_literal,
    STATE(7624), 1,
      sym_raw_string_literal,
    STATE(9340), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [278269] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11300), 1,
      sym_identifier,
    STATE(7332), 1,
      sym_string_literal,
    STATE(7624), 1,
      sym_raw_string_literal,
    STATE(9024), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [278300] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9514), 1,
      sym_identifier,
    ACTIONS(10169), 1,
      anon_sym_requires,
    ACTIONS(10172), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(10166), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7770), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [278335] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    STATE(7572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11675), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [278368] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8412), 1,
      anon_sym_DASH_GT,
    ACTIONS(8417), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7505), 1,
      sym_trailing_return_type,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8479), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [278405] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(11364), 1,
      anon_sym_LBRACE,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(4620), 1,
      sym_compound_statement,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(8684), 1,
      sym_abstract_function_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [278448] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8412), 1,
      anon_sym_DASH_GT,
    ACTIONS(10339), 1,
      anon_sym_requires,
    ACTIONS(10372), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7516), 1,
      sym_trailing_return_type,
    ACTIONS(10066), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8051), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [278485] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8412), 1,
      anon_sym_DASH_GT,
    ACTIONS(10496), 1,
      anon_sym_requires,
    ACTIONS(10518), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    STATE(7517), 1,
      sym_trailing_return_type,
    ACTIONS(10281), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8056), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [278522] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10676), 1,
      sym_identifier,
    ACTIONS(11358), 1,
      anon_sym_requires,
    ACTIONS(11361), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(11355), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7762), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [278557] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(11327), 1,
      anon_sym_LBRACE,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(4465), 1,
      sym_compound_statement,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(8750), 1,
      sym_abstract_function_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [278600] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3717), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11331), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [278629] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3717), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11376), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [278658] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3717), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11333), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [278687] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    STATE(7572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11677), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [278720] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10490), 1,
      anon_sym_requires,
    ACTIONS(10493), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(10281), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7908), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [278753] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11300), 1,
      sym_identifier,
    STATE(7332), 1,
      sym_string_literal,
    STATE(7624), 1,
      sym_raw_string_literal,
    STATE(9466), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [278784] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11349), 1,
      anon_sym_requires,
    ACTIONS(11352), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(10735), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7842), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [278817] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11492), 1,
      anon_sym_LBRACK,
    ACTIONS(11679), 1,
      anon_sym_where,
    STATE(7170), 1,
      sym_where_clause,
    ACTIONS(11490), 12,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [278844] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8299), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8148), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [278877] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11580), 1,
      anon_sym_COMMA,
    ACTIONS(11627), 1,
      anon_sym_LBRACK,
    ACTIONS(11682), 1,
      anon_sym_EQ,
    STATE(7353), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [278906] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10968), 1,
      anon_sym_LBRACK,
    ACTIONS(11174), 1,
      anon_sym_where,
    STATE(7172), 1,
      sym_where_clause,
    ACTIONS(10966), 12,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [278933] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(11378), 1,
      anon_sym_LBRACE,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(6844), 1,
      sym_compound_statement,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(8862), 1,
      sym_abstract_function_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [278976] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8412), 1,
      anon_sym_DASH_GT,
    ACTIONS(11406), 1,
      anon_sym_requires,
    ACTIONS(11684), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    STATE(7518), 1,
      sym_trailing_return_type,
    ACTIONS(10735), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8058), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [279013] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11687), 1,
      anon_sym_requires,
    ACTIONS(11690), 1,
      anon_sym_where,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(11064), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7825), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10966), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [279046] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10676), 1,
      anon_sym_LBRACK,
    ACTIONS(10792), 1,
      anon_sym_where,
    STATE(7187), 1,
      sym_where_clause,
    ACTIONS(10674), 12,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [279073] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    STATE(7572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11693), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [279106] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8412), 1,
      anon_sym_DASH_GT,
    ACTIONS(8417), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7495), 1,
      sym_trailing_return_type,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8499), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [279143] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    ACTIONS(10455), 1,
      anon_sym_where,
    STATE(7240), 1,
      sym_where_clause,
    ACTIONS(10277), 12,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [279170] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11300), 1,
      sym_identifier,
    STATE(7332), 1,
      sym_string_literal,
    STATE(7624), 1,
      sym_raw_string_literal,
    STATE(9335), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [279201] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(9596), 1,
      anon_sym_STAR,
    ACTIONS(9598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9600), 1,
      anon_sym_AMP,
    STATE(4576), 1,
      sym_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8429), 1,
      sym__abstract_declarator,
    ACTIONS(8834), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [279240] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10189), 1,
      anon_sym_where,
    STATE(7152), 1,
      sym_where_clause,
    ACTIONS(10062), 12,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [279267] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8406), 1,
      anon_sym_DASH_GT,
    ACTIONS(8408), 1,
      anon_sym_requires,
    ACTIONS(8410), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      sym_identifier,
    STATE(7092), 1,
      sym_where_clause,
    STATE(7494), 1,
      sym_trailing_return_type,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8500), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [279306] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 1,
      anon_sym_LBRACE,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10580), 1,
      anon_sym_COLON,
    ACTIONS(10586), 1,
      anon_sym_LBRACK,
    ACTIONS(11697), 1,
      anon_sym_EQ,
    STATE(3764), 1,
      sym_parameter_list,
    STATE(7787), 1,
      sym__function_declarator_seq,
    STATE(9284), 1,
      sym_initializer_list,
    STATE(9359), 1,
      sym_bitfield_clause,
    STATE(7618), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11695), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [279349] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3717), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11341), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [279378] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8406), 1,
      anon_sym_DASH_GT,
    ACTIONS(8408), 1,
      anon_sym_requires,
    ACTIONS(8410), 1,
      anon_sym_where,
    ACTIONS(10676), 1,
      sym_identifier,
    STATE(7133), 1,
      sym_where_clause,
    STATE(7468), 1,
      sym_trailing_return_type,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8375), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [279417] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(11347), 1,
      anon_sym_LBRACE,
    STATE(4167), 1,
      sym_compound_statement,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8657), 1,
      sym_abstract_function_declarator,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [279460] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11593), 1,
      anon_sym_LBRACK,
    ACTIONS(11605), 1,
      anon_sym_COMMA,
    STATE(7303), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 12,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [279487] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11591), 1,
      anon_sym_LBRACK,
    ACTIONS(11605), 1,
      anon_sym_COMMA,
    STATE(7303), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11440), 12,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [279514] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11701), 1,
      anon_sym_LBRACK,
    ACTIONS(11703), 1,
      anon_sym_EQ,
    ACTIONS(11699), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [279539] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11300), 1,
      sym_identifier,
    STATE(7332), 1,
      sym_string_literal,
    STATE(7624), 1,
      sym_raw_string_literal,
    STATE(9264), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [279570] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11593), 1,
      anon_sym_LBRACK,
    ACTIONS(11605), 1,
      anon_sym_COMMA,
    STATE(7298), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 12,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [279597] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8299), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8203), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [279630] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11547), 1,
      anon_sym_LBRACK,
    ACTIONS(11706), 1,
      anon_sym_COMMA,
    STATE(7303), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11444), 12,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [279657] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11605), 1,
      anon_sym_COMMA,
    ACTIONS(11634), 1,
      anon_sym_LBRACK,
    STATE(7303), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 12,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [279684] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11300), 1,
      sym_identifier,
    STATE(7332), 1,
      sym_string_literal,
    STATE(7624), 1,
      sym_raw_string_literal,
    STATE(9160), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [279715] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3717), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11335), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [279744] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11300), 1,
      sym_identifier,
    STATE(7332), 1,
      sym_string_literal,
    STATE(7624), 1,
      sym_raw_string_literal,
    STATE(9570), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [279775] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11605), 1,
      anon_sym_COMMA,
    ACTIONS(11634), 1,
      anon_sym_LBRACK,
    STATE(7297), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 12,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [279802] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8406), 1,
      anon_sym_DASH_GT,
    ACTIONS(8408), 1,
      anon_sym_requires,
    ACTIONS(8410), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      sym_identifier,
    STATE(7196), 1,
      sym_where_clause,
    STATE(7542), 1,
      sym_trailing_return_type,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8481), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [279841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11709), 1,
      anon_sym_EQ,
    ACTIONS(11699), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [279864] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8299), 1,
      anon_sym_where,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8195), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10966), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [279897] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(11343), 1,
      anon_sym_LBRACE,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(6848), 1,
      sym_compound_statement,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(8896), 1,
      sym_abstract_function_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [279940] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10279), 1,
      sym_identifier,
    ACTIONS(10484), 1,
      anon_sym_requires,
    ACTIONS(10487), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(10481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7764), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [279975] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11712), 1,
      sym_identifier,
    ACTIONS(11714), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11716), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11718), 1,
      aux_sym_preproc_elif_token1,
    STATE(7799), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(7840), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8234), 1,
      sym_enumerator,
    ACTIONS(11720), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(10770), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
    STATE(10771), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [280014] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10180), 1,
      anon_sym_requires,
    ACTIONS(10183), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7781), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [280047] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11605), 1,
      anon_sym_COMMA,
    ACTIONS(11627), 1,
      anon_sym_LBRACK,
    STATE(7303), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 12,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [280074] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    STATE(7572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11722), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [280107] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11605), 1,
      anon_sym_COMMA,
    ACTIONS(11627), 1,
      anon_sym_LBRACK,
    ACTIONS(11724), 1,
      anon_sym_EQ,
    STATE(7304), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 11,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [280136] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10064), 1,
      sym_identifier,
    ACTIONS(10302), 1,
      anon_sym_requires,
    ACTIONS(10305), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(10299), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7767), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [280171] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8293), 1,
      anon_sym_requires,
    ACTIONS(8295), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      sym_identifier,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8204), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [280206] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(11325), 1,
      anon_sym_LBRACE,
    STATE(1920), 1,
      sym_compound_statement,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(8818), 1,
      sym_abstract_function_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [280249] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8293), 1,
      anon_sym_requires,
    ACTIONS(8295), 1,
      anon_sym_where,
    ACTIONS(10968), 1,
      sym_identifier,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8179), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10966), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [280284] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11712), 1,
      sym_identifier,
    ACTIONS(11716), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11718), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11726), 1,
      aux_sym_preproc_if_token2,
    STATE(7913), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(7920), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8234), 1,
      sym_enumerator,
    ACTIONS(11720), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(10665), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
    STATE(10716), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [280323] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11544), 1,
      anon_sym_COLON,
    ACTIONS(11547), 1,
      anon_sym_LBRACK,
    ACTIONS(11728), 1,
      anon_sym_EQ,
    STATE(7393), 1,
      sym_interface_requirements,
    ACTIONS(11444), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [280352] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8406), 1,
      anon_sym_DASH_GT,
    ACTIONS(10676), 1,
      sym_identifier,
    ACTIONS(11730), 1,
      anon_sym_requires,
    ACTIONS(11733), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    STATE(7558), 1,
      sym_trailing_return_type,
    ACTIONS(11355), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8099), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [280391] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8293), 1,
      anon_sym_requires,
    ACTIONS(8295), 1,
      anon_sym_where,
    ACTIONS(10676), 1,
      sym_identifier,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8183), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [280426] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11300), 1,
      sym_identifier,
    STATE(7332), 1,
      sym_string_literal,
    STATE(7624), 1,
      sym_raw_string_literal,
    STATE(9411), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [280457] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11300), 1,
      sym_identifier,
    STATE(7332), 1,
      sym_string_literal,
    STATE(7624), 1,
      sym_raw_string_literal,
    STATE(9070), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [280488] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11300), 1,
      sym_identifier,
    STATE(7332), 1,
      sym_string_literal,
    STATE(7624), 1,
      sym_raw_string_literal,
    STATE(9512), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [280519] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11300), 1,
      sym_identifier,
    STATE(7332), 1,
      sym_string_literal,
    STATE(7624), 1,
      sym_raw_string_literal,
    STATE(9372), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [280550] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8406), 1,
      anon_sym_DASH_GT,
    ACTIONS(8408), 1,
      anon_sym_requires,
    ACTIONS(8410), 1,
      anon_sym_where,
    ACTIONS(10279), 1,
      sym_identifier,
    STATE(7088), 1,
      sym_where_clause,
    STATE(7563), 1,
      sym_trailing_return_type,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8394), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [280589] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(7020), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(6596), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(11308), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(11310), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [280616] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(11284), 1,
      anon_sym_LBRACE,
    STATE(3299), 1,
      sym_compound_statement,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(8927), 1,
      sym_abstract_function_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [280659] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(10974), 1,
      anon_sym_TILDE,
    ACTIONS(11736), 1,
      sym_identifier,
    ACTIONS(11738), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11740), 1,
      anon_sym_template,
    STATE(7559), 1,
      sym__scope_resolution,
    STATE(9802), 1,
      sym_operator_name,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(3245), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [280698] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11300), 1,
      sym_identifier,
    STATE(7332), 1,
      sym_string_literal,
    STATE(7624), 1,
      sym_raw_string_literal,
    STATE(9062), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [280729] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11712), 1,
      sym_identifier,
    ACTIONS(11716), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11718), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11742), 1,
      aux_sym_preproc_if_token2,
    STATE(7801), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(7831), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8234), 1,
      sym_enumerator,
    ACTIONS(11720), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(10071), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
    STATE(10075), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [280768] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11712), 1,
      sym_identifier,
    ACTIONS(11716), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11718), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11744), 1,
      aux_sym_preproc_if_token2,
    STATE(7905), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(7906), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8234), 1,
      sym_enumerator,
    ACTIONS(11720), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(10311), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
    STATE(10314), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [280807] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(11102), 1,
      anon_sym_TILDE,
    ACTIONS(11746), 1,
      sym_identifier,
    ACTIONS(11748), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11750), 1,
      anon_sym_template,
    STATE(7562), 1,
      sym__scope_resolution,
    STATE(9650), 1,
      sym_operator_name,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(4438), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [280846] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(10078), 1,
      anon_sym_where,
    STATE(7220), 1,
      sym_where_clause,
    ACTIONS(9512), 12,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [280873] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11300), 1,
      sym_identifier,
    STATE(7332), 1,
      sym_string_literal,
    STATE(7624), 1,
      sym_raw_string_literal,
    STATE(9528), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [280904] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(11304), 1,
      anon_sym_LBRACE,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(4323), 1,
      sym_compound_statement,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8629), 1,
      sym_abstract_function_declarator,
    STATE(8679), 1,
      sym__abstract_declarator,
    STATE(7128), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [280947] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6099), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6982), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10723), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_DASH_GT,
    ACTIONS(10725), 6,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [280978] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(10974), 1,
      anon_sym_TILDE,
    ACTIONS(11736), 1,
      sym_identifier,
    ACTIONS(11752), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11754), 1,
      anon_sym_template,
    STATE(7537), 1,
      sym__scope_resolution,
    STATE(9833), 1,
      sym_operator_name,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(3245), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [281017] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6148), 1,
      anon_sym___attribute__,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6099), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7001), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10744), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_DASH_GT,
    ACTIONS(10746), 6,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [281048] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(10938), 1,
      anon_sym_TILDE,
    ACTIONS(11471), 1,
      sym_identifier,
    ACTIONS(11476), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11478), 1,
      anon_sym_template,
    STATE(7581), 1,
      sym__scope_resolution,
    STATE(9841), 1,
      sym_operator_name,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(4386), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [281087] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11300), 1,
      sym_identifier,
    STATE(7332), 1,
      sym_string_literal,
    STATE(7624), 1,
      sym_raw_string_literal,
    STATE(9619), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [281118] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8299), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8221), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [281151] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8293), 1,
      anon_sym_requires,
    ACTIONS(8295), 1,
      anon_sym_where,
    ACTIONS(10279), 1,
      sym_identifier,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8206), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [281186] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(9480), 1,
      anon_sym_STAR,
    ACTIONS(9482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9484), 1,
      anon_sym_AMP,
    STATE(4571), 1,
      sym_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8466), 1,
      sym__abstract_declarator,
    ACTIONS(8834), 2,
      anon_sym_COMMA,
      sym_identifier,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [281225] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8466), 1,
      anon_sym_requires,
    ACTIONS(8468), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    STATE(7152), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8245), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [281259] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11368), 1,
      anon_sym_COLON,
    ACTIONS(11756), 1,
      anon_sym_COMMA,
    ACTIONS(11758), 1,
      anon_sym_EQ,
    STATE(7612), 1,
      sym_interface_requirements,
    STATE(7663), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11290), 9,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [281289] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11580), 1,
      anon_sym_COMMA,
    ACTIONS(11634), 1,
      anon_sym_LBRACK,
    STATE(7366), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [281315] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11580), 1,
      anon_sym_COMMA,
    ACTIONS(11634), 1,
      anon_sym_LBRACK,
    STATE(7354), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [281341] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11547), 1,
      anon_sym_LBRACK,
    ACTIONS(11760), 1,
      anon_sym_COMMA,
    STATE(7354), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11444), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [281367] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9468), 1,
      anon_sym_LBRACE,
    ACTIONS(10377), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(5690), 1,
      sym_enumerator_list,
    STATE(8102), 1,
      sym__scope_resolution,
    ACTIONS(11763), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(5374), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [281407] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7325), 1,
      anon_sym_LBRACE,
    ACTIONS(9836), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10382), 1,
      sym_identifier,
    STATE(3393), 1,
      sym_template_type,
    STATE(3485), 1,
      sym_enumerator_list,
    STATE(8075), 1,
      sym__scope_resolution,
    ACTIONS(11765), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3390), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [281447] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7396), 1,
      anon_sym_LBRACE,
    ACTIONS(9895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10368), 1,
      sym_identifier,
    STATE(3457), 1,
      sym_template_type,
    STATE(3607), 1,
      sym_enumerator_list,
    STATE(8115), 1,
      sym__scope_resolution,
    ACTIONS(11767), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3438), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [281487] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(3709), 1,
      anon_sym_LBRACE,
    ACTIONS(10377), 1,
      sym_identifier,
    ACTIONS(10384), 1,
      anon_sym_COLON_COLON,
    STATE(195), 1,
      sym_template_type,
    STATE(6102), 1,
      sym_enumerator_list,
    STATE(8061), 1,
      sym__scope_resolution,
    ACTIONS(11769), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(7652), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [281527] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11580), 1,
      anon_sym_COMMA,
    ACTIONS(11627), 1,
      anon_sym_LBRACK,
    STATE(7354), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [281553] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9474), 1,
      anon_sym_LBRACE,
    ACTIONS(10375), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5596), 1,
      sym_enumerator_list,
    STATE(8066), 1,
      sym__scope_resolution,
    ACTIONS(11771), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(5992), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [281593] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(11197), 1,
      sym_identifier,
    ACTIONS(11234), 1,
      anon_sym_COLON_COLON,
    STATE(195), 1,
      sym_template_type,
    STATE(7958), 1,
      sym_access_specifier,
    STATE(8127), 1,
      sym__scope_resolution,
    STATE(8526), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(11238), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [281631] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(6590), 1,
      anon_sym_LBRACK,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    ACTIONS(11775), 1,
      anon_sym_SEMI,
    ACTIONS(11777), 1,
      anon_sym_EQ,
    ACTIONS(11779), 1,
      anon_sym_try,
    STATE(1078), 1,
      sym_compound_statement,
    STATE(9760), 1,
      sym_field_initializer_list,
    ACTIONS(6165), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1036), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [281669] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 1,
      anon_sym_LBRACE,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11781), 1,
      anon_sym_COLON,
    ACTIONS(11783), 1,
      anon_sym_SEMI,
    ACTIONS(11785), 1,
      anon_sym_EQ,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    STATE(9581), 1,
      aux_sym_declaration_repeat1,
    STATE(10536), 1,
      sym_initializer_list,
    STATE(7572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281713] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6590), 1,
      anon_sym_LBRACK,
    ACTIONS(11560), 1,
      anon_sym_LBRACE,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    ACTIONS(11787), 1,
      anon_sym_SEMI,
    ACTIONS(11789), 1,
      anon_sym_EQ,
    ACTIONS(11791), 1,
      anon_sym_try,
    STATE(2576), 1,
      sym_compound_statement,
    STATE(9662), 1,
      sym_field_initializer_list,
    ACTIONS(6165), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2575), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [281751] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8379), 1,
      anon_sym_LBRACE,
    ACTIONS(9994), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10394), 1,
      sym_identifier,
    STATE(4552), 1,
      sym_template_type,
    STATE(4721), 1,
      sym_enumerator_list,
    STATE(8035), 1,
      sym__scope_resolution,
    ACTIONS(11793), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4468), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [281791] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11580), 1,
      anon_sym_COMMA,
    ACTIONS(11593), 1,
      anon_sym_LBRACK,
    STATE(7354), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [281817] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11580), 1,
      anon_sym_COMMA,
    ACTIONS(11593), 1,
      anon_sym_LBRACK,
    STATE(7369), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [281843] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8570), 1,
      anon_sym_LBRACE,
    ACTIONS(9938), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10362), 1,
      sym_identifier,
    STATE(4812), 1,
      sym_template_type,
    STATE(4949), 1,
      sym_enumerator_list,
    STATE(8098), 1,
      sym__scope_resolution,
    ACTIONS(11795), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4809), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [281883] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11580), 1,
      anon_sym_COMMA,
    ACTIONS(11591), 1,
      anon_sym_LBRACK,
    STATE(7354), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11440), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [281909] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(6615), 1,
      anon_sym_LBRACE,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10353), 1,
      sym_identifier,
    STATE(2947), 1,
      sym_template_type,
    STATE(3016), 1,
      sym_enumerator_list,
    STATE(8070), 1,
      sym__scope_resolution,
    ACTIONS(11797), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3146), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [281949] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9474), 1,
      anon_sym_LBRACE,
    ACTIONS(10351), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(6199), 1,
      sym_enumerator_list,
    STATE(8104), 1,
      sym__scope_resolution,
    ACTIONS(11799), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(6012), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [281989] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11801), 1,
      anon_sym_LBRACK,
    STATE(7754), 1,
      sym_parameter_list,
    STATE(7580), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6804), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [282019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6460), 1,
      sym_identifier,
    ACTIONS(6462), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [282041] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(3066), 1,
      anon_sym_LBRACE,
    ACTIONS(10146), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10392), 1,
      sym_identifier,
    STATE(309), 1,
      sym_template_type,
    STATE(625), 1,
      sym_enumerator_list,
    STATE(8117), 1,
      sym__scope_resolution,
    ACTIONS(11803), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(344), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [282081] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(6313), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    ACTIONS(10347), 1,
      anon_sym_COLON_COLON,
    STATE(2682), 1,
      sym_template_type,
    STATE(2701), 1,
      sym_enumerator_list,
    STATE(8086), 1,
      sym__scope_resolution,
    ACTIONS(11805), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3330), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [282121] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11300), 1,
      sym_identifier,
    STATE(10236), 1,
      sym_concatenated_string,
    STATE(7472), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [282149] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11801), 1,
      anon_sym_LBRACK,
    STATE(7754), 1,
      sym_parameter_list,
    STATE(7580), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6783), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [282179] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11687), 1,
      anon_sym_requires,
    ACTIONS(11807), 1,
      anon_sym_where,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(11064), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7988), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10966), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [282211] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11349), 1,
      anon_sym_requires,
    ACTIONS(11646), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(10735), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7972), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [282243] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10490), 1,
      anon_sym_requires,
    ACTIONS(10507), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(10281), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7963), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [282275] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10308), 1,
      anon_sym_requires,
    ACTIONS(10336), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(10066), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7961), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [282307] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10180), 1,
      anon_sym_requires,
    ACTIONS(10210), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7953), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [282339] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(655), 1,
      anon_sym_LBRACE,
    ACTIONS(6590), 1,
      anon_sym_LBRACK,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    ACTIONS(11810), 1,
      anon_sym_SEMI,
    ACTIONS(11812), 1,
      anon_sym_EQ,
    ACTIONS(11814), 1,
      anon_sym_try,
    STATE(984), 1,
      sym_compound_statement,
    STATE(9930), 1,
      sym_field_initializer_list,
    ACTIONS(6165), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(971), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [282377] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(11197), 1,
      sym_identifier,
    ACTIONS(11234), 1,
      anon_sym_COLON_COLON,
    STATE(195), 1,
      sym_template_type,
    STATE(7985), 1,
      sym_access_specifier,
    STATE(8127), 1,
      sym__scope_resolution,
    STATE(8541), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(11238), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [282415] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2351), 1,
      anon_sym_LT,
    STATE(7603), 1,
      sym_template_argument_list,
    ACTIONS(6590), 2,
      anon_sym_COLON,
      anon_sym_LBRACK,
    ACTIONS(6165), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [282443] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11492), 1,
      anon_sym_LBRACK,
    ACTIONS(11816), 1,
      anon_sym_where,
    STATE(7170), 1,
      sym_where_clause,
    ACTIONS(11490), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [282469] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10968), 1,
      anon_sym_LBRACK,
    ACTIONS(11265), 1,
      anon_sym_where,
    STATE(7172), 1,
      sym_where_clause,
    ACTIONS(10966), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [282495] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(6750), 1,
      anon_sym_LBRACE,
    ACTIONS(9875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10396), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(3137), 1,
      sym_enumerator_list,
    STATE(8113), 1,
      sym__scope_resolution,
    ACTIONS(11819), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4679), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [282535] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10676), 1,
      anon_sym_LBRACK,
    ACTIONS(11009), 1,
      anon_sym_where,
    STATE(7187), 1,
      sym_where_clause,
    ACTIONS(10674), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [282561] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    ACTIONS(10441), 1,
      anon_sym_where,
    STATE(7240), 1,
      sym_where_clause,
    ACTIONS(10277), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [282587] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10195), 1,
      anon_sym_where,
    STATE(7152), 1,
      sym_where_clause,
    ACTIONS(10062), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [282613] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(10084), 1,
      anon_sym_where,
    STATE(7220), 1,
      sym_where_clause,
    ACTIONS(9512), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [282639] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11701), 1,
      anon_sym_LBRACK,
    ACTIONS(11821), 1,
      anon_sym_EQ,
    ACTIONS(11699), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [282663] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9474), 1,
      anon_sym_LBRACE,
    ACTIONS(10370), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5596), 1,
      sym_enumerator_list,
    STATE(8120), 1,
      sym__scope_resolution,
    ACTIONS(11823), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(5378), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [282703] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10586), 1,
      anon_sym_LBRACK,
    STATE(3764), 1,
      sym_parameter_list,
    STATE(7787), 1,
      sym__function_declarator_seq,
    STATE(7618), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11825), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [282735] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11801), 1,
      anon_sym_LBRACK,
    STATE(7754), 1,
      sym_parameter_list,
    STATE(7580), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6808), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [282765] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11300), 1,
      sym_identifier,
    STATE(10182), 1,
      sym_concatenated_string,
    STATE(7554), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [282793] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11701), 1,
      anon_sym_LBRACK,
    ACTIONS(11827), 1,
      anon_sym_EQ,
    ACTIONS(11699), 12,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [282817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 1,
      sym_identifier,
    ACTIONS(6526), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [282839] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10586), 1,
      anon_sym_LBRACK,
    STATE(3764), 1,
      sym_parameter_list,
    STATE(7787), 1,
      sym__function_declarator_seq,
    STATE(7618), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11830), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [282871] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8385), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8317), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [282903] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8385), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8311), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [282935] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8385), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8304), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [282967] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11832), 1,
      anon_sym_AMP_AMP,
    ACTIONS(11834), 1,
      anon_sym_and,
    ACTIONS(6204), 6,
      anon_sym_or,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6206), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [282993] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7023), 1,
      anon_sym_LBRACK,
    ACTIONS(11836), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7025), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [283017] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11300), 1,
      sym_identifier,
    STATE(10433), 1,
      sym_concatenated_string,
    STATE(7520), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [283045] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6590), 1,
      anon_sym_LBRACK,
    ACTIONS(11560), 1,
      anon_sym_LBRACE,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    ACTIONS(11789), 1,
      anon_sym_EQ,
    ACTIONS(11791), 1,
      anon_sym_try,
    ACTIONS(11838), 1,
      anon_sym_SEMI,
    STATE(2241), 1,
      sym_compound_statement,
    STATE(9871), 1,
      sym_field_initializer_list,
    ACTIONS(6165), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2246), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [283083] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8385), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8353), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [283115] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11300), 1,
      sym_identifier,
    STATE(10154), 1,
      sym_concatenated_string,
    STATE(7502), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [283143] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8385), 1,
      anon_sym_where,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8269), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10966), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [283175] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(6313), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    ACTIONS(10347), 1,
      anon_sym_COLON_COLON,
    STATE(2682), 1,
      sym_template_type,
    STATE(2701), 1,
      sym_enumerator_list,
    STATE(8086), 1,
      sym__scope_resolution,
    ACTIONS(11840), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3142), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [283215] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(11197), 1,
      sym_identifier,
    ACTIONS(11234), 1,
      anon_sym_COLON_COLON,
    STATE(195), 1,
      sym_template_type,
    STATE(8005), 1,
      sym_access_specifier,
    STATE(8127), 1,
      sym__scope_resolution,
    STATE(8758), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(11238), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [283253] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(655), 1,
      anon_sym_LBRACE,
    ACTIONS(6590), 1,
      anon_sym_LBRACK,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    ACTIONS(11812), 1,
      anon_sym_EQ,
    ACTIONS(11814), 1,
      anon_sym_try,
    ACTIONS(11842), 1,
      anon_sym_SEMI,
    STATE(942), 1,
      sym_compound_statement,
    STATE(9904), 1,
      sym_field_initializer_list,
    ACTIONS(6165), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(924), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [283291] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10204), 1,
      anon_sym_requires,
    ACTIONS(10207), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8014), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [283323] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10339), 1,
      anon_sym_requires,
    ACTIONS(10342), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(10066), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7999), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [283355] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10496), 1,
      anon_sym_requires,
    ACTIONS(10499), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(10281), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [283387] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11406), 1,
      anon_sym_requires,
    ACTIONS(11409), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(10735), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7983), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [283419] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11844), 1,
      anon_sym_requires,
    ACTIONS(11847), 1,
      anon_sym_where,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(11064), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7975), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10966), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [283451] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2351), 1,
      anon_sym_LT,
    STATE(7603), 1,
      sym_template_argument_list,
    ACTIONS(2181), 2,
      anon_sym_COLON,
      anon_sym_LBRACK,
    ACTIONS(2171), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [283479] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(6750), 1,
      anon_sym_LBRACE,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10360), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(6193), 1,
      sym_enumerator_list,
    STATE(8126), 1,
      sym__scope_resolution,
    ACTIONS(11850), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(6021), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [283519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6511), 1,
      sym_identifier,
    ACTIONS(6513), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [283541] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8393), 1,
      anon_sym_where,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8335), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10966), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [283573] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6590), 1,
      anon_sym_LBRACK,
    ACTIONS(11521), 1,
      anon_sym_LBRACE,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    ACTIONS(11852), 1,
      anon_sym_SEMI,
    ACTIONS(11854), 1,
      anon_sym_EQ,
    ACTIONS(11856), 1,
      anon_sym_try,
    STATE(2352), 1,
      sym_compound_statement,
    STATE(9828), 1,
      sym_field_initializer_list,
    ACTIONS(6165), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2259), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [283611] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11300), 1,
      sym_identifier,
    STATE(10110), 1,
      sym_concatenated_string,
    STATE(7570), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [283639] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8393), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8303), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [283671] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8393), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8299), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [283703] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6590), 1,
      anon_sym_LBRACK,
    ACTIONS(11521), 1,
      anon_sym_LBRACE,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    ACTIONS(11854), 1,
      anon_sym_EQ,
    ACTIONS(11856), 1,
      anon_sym_try,
    ACTIONS(11858), 1,
      anon_sym_SEMI,
    STATE(2351), 1,
      sym_compound_statement,
    STATE(9795), 1,
      sym_field_initializer_list,
    ACTIONS(6165), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2361), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [283741] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11300), 1,
      sym_identifier,
    STATE(10082), 1,
      sym_concatenated_string,
    STATE(7480), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [283769] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(5024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6313), 1,
      anon_sym_LBRACE,
    ACTIONS(10355), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2701), 1,
      sym_enumerator_list,
    STATE(8090), 1,
      sym__scope_resolution,
    ACTIONS(11860), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2821), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [283809] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8393), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8293), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [283841] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10586), 1,
      anon_sym_LBRACK,
    STATE(3764), 1,
      sym_parameter_list,
    STATE(7787), 1,
      sym__function_declarator_seq,
    STATE(7618), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11862), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [283873] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8297), 1,
      anon_sym_requires,
    ACTIONS(8393), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8270), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [283905] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2169), 1,
      anon_sym_COLON,
    ACTIONS(2351), 1,
      anon_sym_LT,
    STATE(212), 1,
      sym_template_argument_list,
    ACTIONS(2176), 10,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [283933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6431), 1,
      sym_identifier,
    ACTIONS(6433), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [283955] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(6615), 1,
      anon_sym_LBRACE,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10353), 1,
      sym_identifier,
    STATE(2947), 1,
      sym_template_type,
    STATE(3016), 1,
      sym_enumerator_list,
    STATE(8070), 1,
      sym__scope_resolution,
    ACTIONS(11864), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3197), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [283995] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11801), 1,
      anon_sym_LBRACK,
    STATE(7754), 1,
      sym_parameter_list,
    STATE(7580), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6800), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [284025] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6313), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2701), 1,
      sym_enumerator_list,
    STATE(8094), 1,
      sym__scope_resolution,
    ACTIONS(11866), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2779), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [284065] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(6750), 1,
      anon_sym_LBRACE,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10360), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(3137), 1,
      sym_enumerator_list,
    STATE(8126), 1,
      sym__scope_resolution,
    ACTIONS(11868), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(5961), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [284105] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11832), 1,
      anon_sym_AMP_AMP,
    ACTIONS(11834), 1,
      anon_sym_and,
    ACTIONS(11870), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(11872), 1,
      anon_sym_or,
    ACTIONS(6192), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6194), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [284135] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9474), 1,
      anon_sym_LBRACE,
    ACTIONS(10366), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5596), 1,
      sym_enumerator_list,
    STATE(8071), 1,
      sym__scope_resolution,
    ACTIONS(11874), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(6024), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [284175] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(11197), 1,
      sym_identifier,
    ACTIONS(11234), 1,
      anon_sym_COLON_COLON,
    STATE(195), 1,
      sym_template_type,
    STATE(8000), 1,
      sym_access_specifier,
    STATE(8127), 1,
      sym__scope_resolution,
    STATE(8681), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(11238), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [284213] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9468), 1,
      anon_sym_LBRACE,
    ACTIONS(10349), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(5690), 1,
      sym_enumerator_list,
    STATE(8089), 1,
      sym__scope_resolution,
    ACTIONS(11876), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(5701), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [284253] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(3709), 1,
      anon_sym_LBRACE,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10349), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(6102), 1,
      sym_enumerator_list,
    STATE(8089), 1,
      sym__scope_resolution,
    ACTIONS(11878), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(5895), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [284293] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11300), 1,
      sym_identifier,
    STATE(10374), 1,
      sym_concatenated_string,
    STATE(7586), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [284321] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10968), 1,
      anon_sym_LBRACK,
    ACTIONS(11880), 1,
      anon_sym_requires,
    ACTIONS(11883), 1,
      anon_sym_where,
    STATE(7172), 1,
      sym_where_clause,
    ACTIONS(11091), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8025), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10966), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [284355] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10676), 1,
      anon_sym_LBRACK,
    ACTIONS(11570), 1,
      anon_sym_requires,
    ACTIONS(11573), 1,
      anon_sym_where,
    STATE(7187), 1,
      sym_where_clause,
    ACTIONS(10678), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7998), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [284389] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    ACTIONS(10562), 1,
      anon_sym_requires,
    ACTIONS(10565), 1,
      anon_sym_where,
    STATE(7240), 1,
      sym_where_clause,
    ACTIONS(10327), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7997), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [284423] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10386), 1,
      anon_sym_requires,
    ACTIONS(10389), 1,
      anon_sym_where,
    STATE(7152), 1,
      sym_where_clause,
    ACTIONS(10111), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7986), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [284457] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(6590), 1,
      anon_sym_LBRACK,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    ACTIONS(11777), 1,
      anon_sym_EQ,
    ACTIONS(11779), 1,
      anon_sym_try,
    ACTIONS(11886), 1,
      anon_sym_SEMI,
    STATE(1013), 1,
      sym_compound_statement,
    STATE(9726), 1,
      sym_field_initializer_list,
    ACTIONS(6165), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1016), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [284495] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1219), 1,
      anon_sym_LBRACE,
    ACTIONS(6590), 1,
      anon_sym_LBRACK,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    ACTIONS(11888), 1,
      anon_sym_SEMI,
    ACTIONS(11890), 1,
      anon_sym_EQ,
    ACTIONS(11892), 1,
      anon_sym_try,
    STATE(870), 1,
      sym_compound_statement,
    STATE(9811), 1,
      sym_field_initializer_list,
    ACTIONS(6165), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(869), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [284533] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(10242), 1,
      anon_sym_requires,
    ACTIONS(10245), 1,
      anon_sym_where,
    STATE(7220), 1,
      sym_where_clause,
    ACTIONS(9763), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7976), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [284567] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(3709), 1,
      anon_sym_LBRACE,
    ACTIONS(10130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10377), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(852), 1,
      sym_enumerator_list,
    STATE(8132), 1,
      sym__scope_resolution,
    ACTIONS(11894), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(572), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [284607] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10586), 1,
      anon_sym_LBRACK,
    STATE(3764), 1,
      sym_parameter_list,
    STATE(7787), 1,
      sym__function_declarator_seq,
    STATE(7618), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11896), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [284639] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11801), 1,
      anon_sym_LBRACK,
    STATE(7754), 1,
      sym_parameter_list,
    STATE(7580), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6796), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [284669] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10586), 1,
      anon_sym_LBRACK,
    STATE(3764), 1,
      sym_parameter_list,
    STATE(7787), 1,
      sym__function_declarator_seq,
    STATE(7618), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11898), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [284701] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1219), 1,
      anon_sym_LBRACE,
    ACTIONS(6590), 1,
      anon_sym_LBRACK,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    ACTIONS(11890), 1,
      anon_sym_EQ,
    ACTIONS(11892), 1,
      anon_sym_try,
    ACTIONS(11900), 1,
      anon_sym_SEMI,
    STATE(897), 1,
      sym_compound_statement,
    STATE(9905), 1,
      sym_field_initializer_list,
    ACTIONS(6165), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(895), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [284739] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8466), 1,
      anon_sym_requires,
    ACTIONS(8468), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(7220), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8285), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [284773] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(309), 1,
      anon_sym_LBRACE,
    ACTIONS(6590), 1,
      anon_sym_LBRACK,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    ACTIONS(11902), 1,
      anon_sym_SEMI,
    ACTIONS(11904), 1,
      anon_sym_EQ,
    ACTIONS(11906), 1,
      anon_sym_try,
    STATE(484), 1,
      sym_compound_statement,
    STATE(9814), 1,
      sym_field_initializer_list,
    ACTIONS(6165), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(482), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [284811] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8466), 1,
      anon_sym_requires,
    ACTIONS(8468), 1,
      anon_sym_where,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    STATE(7240), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8320), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [284845] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8466), 1,
      anon_sym_requires,
    ACTIONS(8468), 1,
      anon_sym_where,
    ACTIONS(10676), 1,
      anon_sym_LBRACK,
    STATE(7187), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8231), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [284879] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8466), 1,
      anon_sym_requires,
    ACTIONS(8468), 1,
      anon_sym_where,
    ACTIONS(10968), 1,
      anon_sym_LBRACK,
    STATE(7172), 1,
      sym_where_clause,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6974), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8318), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10966), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [284913] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11368), 1,
      anon_sym_COLON,
    ACTIONS(11908), 1,
      anon_sym_COMMA,
    ACTIONS(11910), 1,
      anon_sym_EQ,
    STATE(7598), 1,
      sym_interface_requirements,
    STATE(7818), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11290), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [284943] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    ACTIONS(10024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10364), 1,
      sym_identifier,
    STATE(3345), 1,
      sym_template_type,
    STATE(3460), 1,
      sym_enumerator_list,
    STATE(8107), 1,
      sym__scope_resolution,
    ACTIONS(11912), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3349), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [284983] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(309), 1,
      anon_sym_LBRACE,
    ACTIONS(6590), 1,
      anon_sym_LBRACK,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    ACTIONS(11904), 1,
      anon_sym_EQ,
    ACTIONS(11906), 1,
      anon_sym_try,
    ACTIONS(11914), 1,
      anon_sym_SEMI,
    STATE(508), 1,
      sym_compound_statement,
    STATE(9920), 1,
      sym_field_initializer_list,
    ACTIONS(6165), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(507), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [285021] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2351), 1,
      anon_sym_LT,
    STATE(212), 1,
      sym_template_argument_list,
    STATE(5728), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9233), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2123), 6,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [285051] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6590), 1,
      anon_sym_LBRACK,
    ACTIONS(11617), 1,
      anon_sym_LBRACE,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    ACTIONS(11916), 1,
      anon_sym_SEMI,
    ACTIONS(11918), 1,
      anon_sym_EQ,
    ACTIONS(11920), 1,
      anon_sym_try,
    STATE(1567), 1,
      sym_compound_statement,
    STATE(9753), 1,
      sym_field_initializer_list,
    ACTIONS(6165), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1568), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [285089] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6590), 1,
      anon_sym_LBRACK,
    ACTIONS(11617), 1,
      anon_sym_LBRACE,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    ACTIONS(11918), 1,
      anon_sym_EQ,
    ACTIONS(11920), 1,
      anon_sym_try,
    ACTIONS(11922), 1,
      anon_sym_SEMI,
    STATE(1539), 1,
      sym_compound_statement,
    STATE(9653), 1,
      sym_field_initializer_list,
    ACTIONS(6165), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1541), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [285127] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8408), 1,
      anon_sym_requires,
    ACTIONS(8410), 1,
      anon_sym_where,
    ACTIONS(10968), 1,
      sym_identifier,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8460), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10966), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [285160] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(3498), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11335), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [285187] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11280), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [285214] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11335), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [285241] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11924), 1,
      anon_sym_RPAREN,
    STATE(7020), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(11308), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(11310), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [285266] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7518), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    STATE(7152), 1,
      sym_where_clause,
    ACTIONS(10062), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [285291] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11286), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [285318] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(11928), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11932), 1,
      anon_sym_RBRACE,
    ACTIONS(11930), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(9686), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(10774), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7485), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [285351] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2351), 1,
      anon_sym_LT,
    ACTIONS(6590), 1,
      anon_sym_LBRACK,
    ACTIONS(11934), 1,
      anon_sym_COLON,
    STATE(7603), 1,
      sym_template_argument_list,
    STATE(8675), 1,
      sym_type_hint,
    ACTIONS(6165), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [285382] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11331), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [285409] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11337), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [285436] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7518), 1,
      anon_sym_where,
    ACTIONS(11492), 1,
      anon_sym_LBRACK,
    STATE(7170), 1,
      sym_where_clause,
    ACTIONS(11490), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [285461] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11937), 1,
      anon_sym_RPAREN,
    STATE(7020), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(11308), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(11310), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [285486] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11333), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [285513] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(11939), 1,
      sym_identifier,
    ACTIONS(11941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11943), 1,
      anon_sym_template,
    STATE(3209), 1,
      sym_qualified_field_identifier,
    STATE(3210), 1,
      sym_dependent_field_identifier,
    STATE(3211), 1,
      sym_template_method,
    STATE(7482), 1,
      sym__scope_resolution,
    STATE(9711), 1,
      sym_operator_name,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [285552] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11341), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [285579] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(3498), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11333), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [285606] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(11928), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11945), 1,
      anon_sym_RBRACE,
    ACTIONS(11930), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(9717), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(10757), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7731), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [285639] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7518), 1,
      anon_sym_where,
    ACTIONS(10676), 1,
      anon_sym_LBRACK,
    STATE(7187), 1,
      sym_where_clause,
    ACTIONS(10674), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [285664] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11376), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [285691] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9514), 1,
      sym_identifier,
    ACTIONS(10226), 1,
      anon_sym_requires,
    ACTIONS(10229), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(10166), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8111), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [285724] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(3498), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11341), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [285751] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(11928), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11947), 1,
      anon_sym_RBRACE,
    ACTIONS(11930), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(9652), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(10483), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7731), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [285784] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8417), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8499), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [285815] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8544), 1,
      sym__abstract_declarator,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [285850] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11949), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(11951), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6194), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [285873] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8408), 1,
      anon_sym_requires,
    ACTIONS(8410), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      sym_identifier,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8481), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [285906] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8417), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8479), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [285937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7196), 1,
      anon_sym_LBRACK,
    ACTIONS(7198), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [285958] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6192), 1,
      anon_sym_LBRACK,
    ACTIONS(11953), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(11955), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6194), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [285983] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(11928), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11957), 1,
      anon_sym_RBRACE,
    ACTIONS(11930), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(9707), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(10485), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7490), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [286016] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7471), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(9512), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [286039] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7471), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(10062), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [286062] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7471), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(10277), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [286085] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11959), 1,
      anon_sym_RPAREN,
    STATE(7020), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(11308), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(11310), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [286110] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(11928), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11961), 1,
      anon_sym_RBRACE,
    ACTIONS(11930), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10053), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(10073), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7731), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [286143] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(11928), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11963), 1,
      anon_sym_RBRACE,
    ACTIONS(11930), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(9791), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(10829), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7731), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [286176] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8417), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8367), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [286207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11951), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6206), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [286228] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7471), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(10674), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [286251] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8417), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8468), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [286282] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(11928), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11965), 1,
      anon_sym_RBRACE,
    ACTIONS(11930), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(9680), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(10800), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7731), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [286315] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(11941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11967), 1,
      sym_identifier,
    STATE(7482), 1,
      sym__scope_resolution,
    STATE(9711), 1,
      sym_operator_name,
    STATE(9845), 1,
      sym_field_initializer,
    STATE(8706), 2,
      sym_template_method,
      sym_qualified_field_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [286352] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8383), 1,
      anon_sym_requires,
    ACTIONS(8417), 1,
      anon_sym_where,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(7467), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8451), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10966), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [286383] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10204), 1,
      anon_sym_requires,
    ACTIONS(10237), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(9516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8043), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [286414] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(11928), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11969), 1,
      anon_sym_RBRACE,
    ACTIONS(11930), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(9852), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(10862), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7504), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [286447] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10339), 1,
      anon_sym_requires,
    ACTIONS(10372), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(10066), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8051), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [286478] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(309), 1,
      anon_sym_LBRACE,
    ACTIONS(6590), 1,
      anon_sym_LBRACK,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    ACTIONS(11904), 1,
      anon_sym_EQ,
    ACTIONS(11906), 1,
      anon_sym_try,
    STATE(484), 1,
      sym_compound_statement,
    STATE(9814), 1,
      sym_field_initializer_list,
    ACTIONS(6165), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(482), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [286513] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10496), 1,
      anon_sym_requires,
    ACTIONS(10518), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(10281), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8056), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [286544] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11406), 1,
      anon_sym_requires,
    ACTIONS(11684), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(10735), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8058), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [286575] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11844), 1,
      anon_sym_requires,
    ACTIONS(11971), 1,
      anon_sym_where,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(11064), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8059), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10966), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [286606] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(11928), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11974), 1,
      anon_sym_RBRACE,
    ACTIONS(11930), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(9909), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(10494), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7731), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [286639] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11976), 1,
      anon_sym_RPAREN,
    STATE(7020), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(11308), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(11310), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [286664] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(655), 1,
      anon_sym_LBRACE,
    ACTIONS(6590), 1,
      anon_sym_LBRACK,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    ACTIONS(11812), 1,
      anon_sym_EQ,
    ACTIONS(11814), 1,
      anon_sym_try,
    STATE(942), 1,
      sym_compound_statement,
    STATE(9904), 1,
      sym_field_initializer_list,
    ACTIONS(6165), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(924), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [286699] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(11928), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11978), 1,
      anon_sym_RBRACE,
    ACTIONS(11930), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(9812), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(10667), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7531), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [286732] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(11928), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11980), 1,
      anon_sym_RBRACE,
    ACTIONS(11930), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(9926), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(10496), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7519), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [286765] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(3994), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11376), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [286792] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6204), 1,
      anon_sym_LBRACK,
    ACTIONS(11955), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6206), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACK_LBRACK,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [286815] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7471), 1,
      anon_sym_where,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(10966), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [286838] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7471), 1,
      anon_sym_where,
    STATE(7168), 1,
      sym_where_clause,
    ACTIONS(11490), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [286861] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(3498), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11376), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [286888] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(11294), 1,
      anon_sym_LBRACK,
    ACTIONS(11982), 1,
      anon_sym_COMMA,
    ACTIONS(11984), 1,
      anon_sym_EQ,
    STATE(7614), 1,
      sym_interface_requirements,
    STATE(7615), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11290), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_GT2,
      anon_sym_try,
  [286919] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(3498), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11280), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [286946] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(11928), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11986), 1,
      anon_sym_RBRACE,
    ACTIONS(11930), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(9831), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(10641), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7731), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [286979] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(11928), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11988), 1,
      anon_sym_RBRACE,
    ACTIONS(11930), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(9860), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(10385), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7566), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [287012] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11368), 1,
      anon_sym_COLON,
    ACTIONS(11990), 1,
      anon_sym_COMMA,
    ACTIONS(11992), 1,
      anon_sym_EQ,
    STATE(7588), 1,
      aux_sym_where_clause_repeat1,
    STATE(7642), 1,
      sym_interface_requirements,
    ACTIONS(11290), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_GT2,
      anon_sym_try,
  [287041] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(11928), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11994), 1,
      anon_sym_RBRACE,
    ACTIONS(11930), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(9754), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(10279), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7503), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [287074] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8408), 1,
      anon_sym_requires,
    ACTIONS(8410), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      sym_identifier,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8500), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9512), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [287107] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1219), 1,
      anon_sym_LBRACE,
    ACTIONS(6590), 1,
      anon_sym_LBRACK,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    ACTIONS(11890), 1,
      anon_sym_EQ,
    ACTIONS(11892), 1,
      anon_sym_try,
    STATE(870), 1,
      sym_compound_statement,
    STATE(9811), 1,
      sym_field_initializer_list,
    ACTIONS(6165), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(869), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [287142] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(11752), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11754), 1,
      anon_sym_template,
    ACTIONS(11996), 1,
      sym_identifier,
    STATE(3209), 1,
      sym_qualified_field_identifier,
    STATE(3210), 1,
      sym_dependent_field_identifier,
    STATE(3211), 1,
      sym_template_method,
    STATE(7537), 1,
      sym__scope_resolution,
    STATE(9833), 1,
      sym_operator_name,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [287181] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(3994), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11337), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [287208] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(11928), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11998), 1,
      anon_sym_RBRACE,
    ACTIONS(11930), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10031), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(10093), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7549), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [287241] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(6590), 1,
      anon_sym_LBRACK,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    ACTIONS(11777), 1,
      anon_sym_EQ,
    ACTIONS(11779), 1,
      anon_sym_try,
    STATE(1013), 1,
      sym_compound_statement,
    STATE(9726), 1,
      sym_field_initializer_list,
    ACTIONS(6165), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1016), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [287276] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(3994), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11335), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [287303] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8408), 1,
      anon_sym_requires,
    ACTIONS(8410), 1,
      anon_sym_where,
    ACTIONS(10279), 1,
      sym_identifier,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8394), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [287336] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10676), 1,
      sym_identifier,
    ACTIONS(11730), 1,
      anon_sym_requires,
    ACTIONS(11733), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(11355), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8099), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [287369] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(11928), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(12000), 1,
      anon_sym_RBRACE,
    ACTIONS(11930), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10045), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(10511), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7731), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [287402] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(6590), 1,
      anon_sym_LBRACK,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    ACTIONS(11777), 1,
      anon_sym_EQ,
    ACTIONS(11779), 1,
      anon_sym_try,
    STATE(1078), 1,
      sym_compound_statement,
    STATE(9760), 1,
      sym_field_initializer_list,
    ACTIONS(6165), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1036), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [287437] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(3498), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11331), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [287464] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(3994), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11280), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [287491] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(11294), 1,
      anon_sym_LBRACK,
    ACTIONS(12002), 1,
      anon_sym_COMMA,
    ACTIONS(12004), 1,
      anon_sym_EQ,
    STATE(7835), 1,
      sym_interface_requirements,
    STATE(7928), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11290), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [287522] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(11928), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(12006), 1,
      anon_sym_RBRACE,
    ACTIONS(11930), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(9953), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(10446), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7731), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [287555] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(3994), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11286), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [287582] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(11928), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(12008), 1,
      anon_sym_RBRACE,
    ACTIONS(11930), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10035), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(10514), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7544), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [287615] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(3498), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11286), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [287642] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(3994), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11331), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [287669] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12010), 1,
      anon_sym_RPAREN,
    STATE(7020), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(11308), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(11310), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [287694] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(3994), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11333), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [287721] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(309), 1,
      anon_sym_LBRACE,
    ACTIONS(6590), 1,
      anon_sym_LBRACK,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    ACTIONS(11904), 1,
      anon_sym_EQ,
    ACTIONS(11906), 1,
      anon_sym_try,
    STATE(508), 1,
      sym_compound_statement,
    STATE(9920), 1,
      sym_field_initializer_list,
    ACTIONS(6165), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(507), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [287756] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10064), 1,
      sym_identifier,
    ACTIONS(10398), 1,
      anon_sym_requires,
    ACTIONS(10401), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(10299), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8128), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10062), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [287789] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10968), 1,
      sym_identifier,
    ACTIONS(12012), 1,
      anon_sym_requires,
    ACTIONS(12015), 1,
      anon_sym_where,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(11661), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8085), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10966), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [287822] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(11738), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11740), 1,
      anon_sym_template,
    ACTIONS(11996), 1,
      sym_identifier,
    STATE(3209), 1,
      sym_qualified_field_identifier,
    STATE(3210), 1,
      sym_dependent_field_identifier,
    STATE(3211), 1,
      sym_template_method,
    STATE(7559), 1,
      sym__scope_resolution,
    STATE(9802), 1,
      sym_operator_name,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [287861] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7518), 1,
      anon_sym_where,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    STATE(7240), 1,
      sym_where_clause,
    ACTIONS(10277), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [287886] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(11941), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11967), 1,
      sym_identifier,
    STATE(7482), 1,
      sym__scope_resolution,
    STATE(9602), 1,
      sym_field_initializer,
    STATE(9711), 1,
      sym_operator_name,
    STATE(8706), 2,
      sym_template_method,
      sym_qualified_field_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [287923] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(11748), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11750), 1,
      anon_sym_template,
    ACTIONS(12018), 1,
      sym_identifier,
    STATE(4422), 1,
      sym_qualified_field_identifier,
    STATE(4423), 1,
      sym_dependent_field_identifier,
    STATE(4427), 1,
      sym_template_method,
    STATE(7562), 1,
      sym__scope_resolution,
    STATE(9650), 1,
      sym_operator_name,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [287962] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8408), 1,
      anon_sym_requires,
    ACTIONS(8410), 1,
      anon_sym_where,
    ACTIONS(10676), 1,
      sym_identifier,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(8287), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8375), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10674), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [287995] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(3994), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11341), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [288022] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2351), 1,
      anon_sym_LT,
    ACTIONS(6996), 1,
      anon_sym_LBRACK,
    STATE(7603), 1,
      sym_template_argument_list,
    ACTIONS(6998), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [288047] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(11928), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(12020), 1,
      anon_sym_RBRACE,
    ACTIONS(11930), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10011), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(10399), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7731), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [288080] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11368), 1,
      anon_sym_COLON,
    ACTIONS(12022), 1,
      anon_sym_EQ,
    STATE(7858), 1,
      sym_interface_requirements,
    ACTIONS(11444), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [288105] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(655), 1,
      anon_sym_LBRACE,
    ACTIONS(6590), 1,
      anon_sym_LBRACK,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    ACTIONS(11812), 1,
      anon_sym_EQ,
    ACTIONS(11814), 1,
      anon_sym_try,
    STATE(984), 1,
      sym_compound_statement,
    STATE(9930), 1,
      sym_field_initializer_list,
    ACTIONS(6165), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(971), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [288140] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1219), 1,
      anon_sym_LBRACE,
    ACTIONS(6590), 1,
      anon_sym_LBRACK,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    ACTIONS(11890), 1,
      anon_sym_EQ,
    ACTIONS(11892), 1,
      anon_sym_try,
    STATE(897), 1,
      sym_compound_statement,
    STATE(9905), 1,
      sym_field_initializer_list,
    ACTIONS(6165), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(895), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [288175] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12025), 1,
      anon_sym_RPAREN,
    STATE(7020), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(11308), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(11310), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [288200] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10279), 1,
      sym_identifier,
    ACTIONS(10521), 1,
      anon_sym_requires,
    ACTIONS(10524), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(10481), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6980), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8062), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10277), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [288233] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12029), 1,
      anon_sym_LBRACK,
    STATE(6730), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(12027), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [288258] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(5018), 1,
      anon_sym_STAR,
    ACTIONS(5020), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5022), 1,
      anon_sym_AMP,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8581), 1,
      sym__abstract_declarator,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [288293] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7518), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(7220), 1,
      sym_where_clause,
    ACTIONS(9512), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [288318] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN2,
    ACTIONS(8460), 1,
      anon_sym_LBRACK,
    ACTIONS(8888), 1,
      anon_sym_STAR,
    ACTIONS(8890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8892), 1,
      anon_sym_AMP,
    STATE(4083), 1,
      sym_parameter_list,
    STATE(7135), 1,
      sym__function_declarator_seq,
    STATE(8213), 1,
      sym__abstract_declarator,
    STATE(7128), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [288353] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(11928), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(12031), 1,
      anon_sym_RBRACE,
    ACTIONS(11930), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(9968), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(10543), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7731), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [288386] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(11928), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(12033), 1,
      anon_sym_RBRACE,
    ACTIONS(11930), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(9883), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(10589), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7582), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [288419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7023), 1,
      anon_sym_LBRACK,
    ACTIONS(7025), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [288440] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7518), 1,
      anon_sym_where,
    ACTIONS(10968), 1,
      anon_sym_LBRACK,
    STATE(7172), 1,
      sym_where_clause,
    ACTIONS(10966), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [288465] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6855), 1,
      anon_sym_LBRACK,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6730), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6857), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [288490] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(11476), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11478), 1,
      anon_sym_template,
    ACTIONS(12035), 1,
      sym_identifier,
    STATE(4258), 1,
      sym_qualified_field_identifier,
    STATE(4260), 1,
      sym_dependent_field_identifier,
    STATE(4261), 1,
      sym_template_method,
    STATE(7581), 1,
      sym__scope_resolution,
    STATE(9841), 1,
      sym_operator_name,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [288529] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(11928), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(12037), 1,
      anon_sym_RBRACE,
    ACTIONS(11930), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(9892), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(10586), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7731), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [288562] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11368), 1,
      anon_sym_COLON,
    ACTIONS(12039), 1,
      anon_sym_EQ,
    STATE(7915), 1,
      sym_interface_requirements,
    ACTIONS(11444), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [288587] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(11928), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(12041), 1,
      anon_sym_RBRACE,
    ACTIONS(11930), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(9925), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(10547), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7576), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [288620] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(11928), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(12043), 1,
      anon_sym_RBRACE,
    ACTIONS(11930), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(9688), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(10742), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(7509), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [288653] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12045), 1,
      anon_sym_RPAREN,
    STATE(7020), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(11308), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(11310), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [288678] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(3498), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11337), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [288705] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11990), 1,
      anon_sym_COMMA,
    STATE(7636), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [288727] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(6615), 1,
      anon_sym_LBRACE,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10353), 1,
      sym_identifier,
    STATE(2947), 1,
      sym_template_type,
    STATE(3026), 1,
      sym_enumerator_list,
    STATE(8070), 1,
      sym__scope_resolution,
    STATE(3220), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [288763] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9468), 1,
      anon_sym_LBRACE,
    ACTIONS(10377), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(5725), 1,
      sym_enumerator_list,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(5334), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [288799] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7782), 1,
      anon_sym_where,
    ACTIONS(10676), 1,
      anon_sym_LBRACK,
    STATE(7187), 1,
      sym_where_clause,
    ACTIONS(10674), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [288823] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(12049), 1,
      anon_sym_COLON,
    ACTIONS(12051), 1,
      anon_sym_EQ,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    STATE(9426), 1,
      sym_semantics,
    ACTIONS(12047), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(7572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [288859] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7782), 1,
      anon_sym_where,
    ACTIONS(10968), 1,
      anon_sym_LBRACK,
    STATE(7172), 1,
      sym_where_clause,
    ACTIONS(10966), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [288883] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11368), 1,
      anon_sym_COLON,
    ACTIONS(12053), 1,
      anon_sym_COMMA,
    ACTIONS(12055), 1,
      anon_sym_EQ,
    STATE(7978), 1,
      sym_interface_requirements,
    STATE(8108), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11290), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(11294), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [288913] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7782), 1,
      anon_sym_where,
    ACTIONS(11492), 1,
      anon_sym_LBRACK,
    STATE(7170), 1,
      sym_where_clause,
    ACTIONS(11490), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [288937] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(12049), 1,
      anon_sym_COLON,
    ACTIONS(12057), 1,
      anon_sym_EQ,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    STATE(9426), 1,
      sym_semantics,
    ACTIONS(12047), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(7572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [288973] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(6313), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    ACTIONS(10347), 1,
      anon_sym_COLON_COLON,
    STATE(2682), 1,
      sym_template_type,
    STATE(2705), 1,
      sym_enumerator_list,
    STATE(8086), 1,
      sym__scope_resolution,
    STATE(3311), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [289009] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11908), 1,
      anon_sym_COMMA,
    ACTIONS(12059), 1,
      anon_sym_EQ,
    STATE(7820), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [289033] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11593), 1,
      anon_sym_LBRACK,
    ACTIONS(11982), 1,
      anon_sym_COMMA,
    STATE(7701), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [289057] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9474), 1,
      anon_sym_LBRACE,
    ACTIONS(10370), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5600), 1,
      sym_enumerator_list,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(5377), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [289093] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11593), 1,
      anon_sym_LBRACK,
    ACTIONS(11982), 1,
      anon_sym_COMMA,
    STATE(7710), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [289117] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7782), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    STATE(7152), 1,
      sym_where_clause,
    ACTIONS(10062), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [289141] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2217), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2222), 2,
      anon_sym_COLON,
      anon_sym_LBRACK,
    ACTIONS(2212), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [289163] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11368), 1,
      anon_sym_COLON,
    ACTIONS(12061), 1,
      anon_sym_COMMA,
    ACTIONS(12063), 1,
      anon_sym_EQ,
    STATE(7886), 1,
      sym_interface_requirements,
    STATE(7954), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11290), 7,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [289191] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(11294), 1,
      anon_sym_LBRACK,
    ACTIONS(12065), 1,
      anon_sym_COMMA,
    ACTIONS(12067), 1,
      anon_sym_EQ,
    STATE(7722), 1,
      sym_interface_requirements,
    STATE(7974), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11290), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [289221] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(6313), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    ACTIONS(10347), 1,
      anon_sym_COLON_COLON,
    STATE(2682), 1,
      sym_template_type,
    STATE(2705), 1,
      sym_enumerator_list,
    STATE(8086), 1,
      sym__scope_resolution,
    STATE(3144), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [289257] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6789), 1,
      anon_sym_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    STATE(3131), 1,
      sym_parameter_list,
    STATE(7757), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6808), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_try,
  [289285] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10138), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(9512), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [289307] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10232), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(10062), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [289329] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10478), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(10277), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [289351] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11255), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(10674), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [289373] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11756), 1,
      anon_sym_COMMA,
    ACTIONS(12069), 1,
      anon_sym_EQ,
    STATE(7661), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 9,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [289397] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7782), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(7220), 1,
      sym_where_clause,
    ACTIONS(9512), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [289421] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11627), 1,
      anon_sym_LBRACK,
    ACTIONS(11982), 1,
      anon_sym_COMMA,
    ACTIONS(12071), 1,
      anon_sym_EQ,
    STATE(7708), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 8,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_GT2,
      anon_sym_try,
  [289447] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11627), 1,
      anon_sym_LBRACK,
    ACTIONS(11982), 1,
      anon_sym_COMMA,
    STATE(7710), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [289471] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11541), 1,
      anon_sym_where,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(10966), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [289493] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12073), 1,
      anon_sym_where,
    STATE(7168), 1,
      sym_where_clause,
    ACTIONS(11490), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [289515] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12078), 1,
      anon_sym_LBRACK,
    STATE(6730), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(12076), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [289539] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6846), 1,
      anon_sym_LBRACK,
    ACTIONS(12080), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7619), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6848), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [289563] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11480), 1,
      anon_sym_COLON,
    ACTIONS(12083), 1,
      anon_sym_EQ,
    STATE(7838), 1,
      sym_interface_requirements,
    ACTIONS(11444), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_GT2,
      anon_sym_try,
  [289587] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12088), 1,
      anon_sym_COLON,
    ACTIONS(12091), 1,
      anon_sym_LBRACK,
    STATE(7735), 1,
      sym_semantics,
    ACTIONS(12086), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [289611] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3764), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11341), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [289637] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3764), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11331), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [289663] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(7020), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(11308), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(11310), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [289685] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6789), 1,
      anon_sym_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    STATE(3131), 1,
      sym_parameter_list,
    STATE(7757), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6804), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_try,
  [289713] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11398), 1,
      anon_sym_EQ,
    ACTIONS(11463), 1,
      anon_sym_COLON,
    ACTIONS(11465), 1,
      anon_sym_SEMI,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    STATE(9348), 1,
      aux_sym_declaration_repeat1,
    STATE(7572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [289751] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(6750), 1,
      anon_sym_LBRACE,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10360), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(6198), 1,
      sym_enumerator_list,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(6022), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [289787] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12093), 1,
      anon_sym_AMP_AMP,
    ACTIONS(12095), 1,
      anon_sym_and,
    ACTIONS(6206), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACK,
    ACTIONS(6204), 6,
      anon_sym_or,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [289811] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(3066), 1,
      anon_sym_LBRACE,
    ACTIONS(10146), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10392), 1,
      sym_identifier,
    STATE(309), 1,
      sym_template_type,
    STATE(647), 1,
      sym_enumerator_list,
    STATE(8117), 1,
      sym__scope_resolution,
    STATE(421), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [289847] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11990), 1,
      anon_sym_COMMA,
    STATE(7636), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11440), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [289869] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11990), 1,
      anon_sym_COMMA,
    STATE(7630), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [289891] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11990), 1,
      anon_sym_COMMA,
    STATE(7636), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [289913] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(3709), 1,
      anon_sym_LBRACE,
    ACTIONS(10130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10377), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(931), 1,
      sym_enumerator_list,
    STATE(8132), 1,
      sym__scope_resolution,
    STATE(573), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [289949] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6789), 1,
      anon_sym_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    STATE(3131), 1,
      sym_parameter_list,
    STATE(7757), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6800), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_try,
  [289977] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6313), 1,
      anon_sym_LBRACE,
    ACTIONS(10345), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2705), 1,
      sym_enumerator_list,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(2774), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [290013] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12097), 1,
      anon_sym_COMMA,
    STATE(7636), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11444), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [290035] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11368), 1,
      anon_sym_COLON,
    ACTIONS(12100), 1,
      anon_sym_COMMA,
    ACTIONS(12102), 1,
      anon_sym_EQ,
    STATE(7741), 1,
      sym_interface_requirements,
    STATE(7938), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11290), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [290063] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11990), 1,
      anon_sym_COMMA,
    STATE(7636), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [290085] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11990), 1,
      anon_sym_COMMA,
    STATE(7632), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [290107] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11368), 1,
      anon_sym_COLON,
    ACTIONS(12104), 1,
      anon_sym_COMMA,
    ACTIONS(12106), 1,
      anon_sym_EQ,
    STATE(7897), 1,
      aux_sym_where_clause_repeat1,
    STATE(7900), 1,
      sym_interface_requirements,
    ACTIONS(11290), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(11294), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [290137] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6789), 1,
      anon_sym_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    STATE(3131), 1,
      sym_parameter_list,
    STATE(7757), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6796), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_try,
  [290165] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11990), 1,
      anon_sym_COMMA,
    ACTIONS(12108), 1,
      anon_sym_EQ,
    STATE(7638), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_GT2,
      anon_sym_try,
  [290189] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(5024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6313), 1,
      anon_sym_LBRACE,
    ACTIONS(10355), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_template_type,
    STATE(2705), 1,
      sym_enumerator_list,
    STATE(8090), 1,
      sym__scope_resolution,
    STATE(2822), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [290225] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2169), 1,
      anon_sym_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    STATE(2816), 1,
      sym_template_argument_list,
    ACTIONS(2176), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_final,
      anon_sym_override,
  [290251] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11398), 1,
      anon_sym_EQ,
    ACTIONS(11783), 1,
      anon_sym_SEMI,
    ACTIONS(12110), 1,
      anon_sym_COLON,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    STATE(9581), 1,
      aux_sym_declaration_repeat1,
    STATE(7572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [290289] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3764), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11333), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [290315] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4240), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11376), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [290341] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11368), 1,
      anon_sym_COLON,
    ACTIONS(12112), 1,
      anon_sym_COMMA,
    ACTIONS(12114), 1,
      anon_sym_EQ,
    STATE(7945), 1,
      sym_interface_requirements,
    STATE(8038), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11290), 7,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [290369] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7782), 1,
      anon_sym_where,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    STATE(7240), 1,
      sym_where_clause,
    ACTIONS(10277), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [290393] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(6750), 1,
      anon_sym_LBRACE,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10360), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(3134), 1,
      sym_enumerator_list,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(6004), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [290429] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9474), 1,
      anon_sym_LBRACE,
    ACTIONS(10351), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(6182), 1,
      sym_enumerator_list,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(6019), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [290465] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3709), 1,
      anon_sym_LBRACE,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(12116), 1,
      anon_sym_COLON,
    STATE(388), 1,
      sym_attribute_specifier,
    STATE(6020), 1,
      sym__enum_base_clause,
    STATE(6092), 1,
      sym_enumerator_list,
    ACTIONS(3062), 6,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [290495] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3709), 1,
      anon_sym_LBRACE,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(12116), 1,
      anon_sym_COLON,
    STATE(438), 1,
      sym_attribute_specifier,
    STATE(6015), 1,
      sym__enum_base_clause,
    STATE(6071), 1,
      sym_enumerator_list,
    ACTIONS(3350), 6,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [290525] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2349), 1,
      anon_sym_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    STATE(2816), 1,
      sym_template_argument_list,
    ACTIONS(2347), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_final,
      anon_sym_override,
  [290551] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(6615), 1,
      anon_sym_LBRACE,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10353), 1,
      sym_identifier,
    STATE(2947), 1,
      sym_template_type,
    STATE(3026), 1,
      sym_enumerator_list,
    STATE(8070), 1,
      sym__scope_resolution,
    STATE(3148), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [290587] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11756), 1,
      anon_sym_COMMA,
    STATE(7660), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11440), 10,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [290609] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3764), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11286), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [290635] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11756), 1,
      anon_sym_COMMA,
    STATE(7656), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 10,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [290657] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11756), 1,
      anon_sym_COMMA,
    STATE(7660), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 10,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [290679] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12118), 1,
      anon_sym_COMMA,
    STATE(7660), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11444), 10,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [290701] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11756), 1,
      anon_sym_COMMA,
    STATE(7660), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 10,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [290723] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11756), 1,
      anon_sym_COMMA,
    STATE(7659), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 10,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [290745] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11756), 1,
      anon_sym_COMMA,
    STATE(7660), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 10,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [290767] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(6750), 1,
      anon_sym_LBRACE,
    ACTIONS(9875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10396), 1,
      sym_identifier,
    STATE(2855), 1,
      sym_template_type,
    STATE(3134), 1,
      sym_enumerator_list,
    STATE(8113), 1,
      sym__scope_resolution,
    STATE(4683), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [290803] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11392), 1,
      anon_sym_COLON,
    ACTIONS(11394), 1,
      anon_sym_SEMI,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11398), 1,
      anon_sym_EQ,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    STATE(9433), 1,
      aux_sym_declaration_repeat1,
    STATE(7572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [290841] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4240), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11341), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [290867] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(11547), 1,
      anon_sym_LBRACK,
    ACTIONS(12121), 1,
      anon_sym_EQ,
    STATE(7993), 1,
      sym_interface_requirements,
    ACTIONS(11444), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [290893] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3764), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11280), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [290919] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9474), 1,
      anon_sym_LBRACE,
    ACTIONS(10366), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5600), 1,
      sym_enumerator_list,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(6025), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [290955] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3764), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11335), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [290981] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9468), 1,
      anon_sym_LBRACE,
    ACTIONS(10349), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(5725), 1,
      sym_enumerator_list,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(5704), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [291017] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3764), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11337), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [291043] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8379), 1,
      anon_sym_LBRACE,
    ACTIONS(9994), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10394), 1,
      sym_identifier,
    STATE(4552), 1,
      sym_template_type,
    STATE(4734), 1,
      sym_enumerator_list,
    STATE(8035), 1,
      sym__scope_resolution,
    STATE(4467), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [291079] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(3709), 1,
      anon_sym_LBRACE,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10349), 1,
      sym_identifier,
    STATE(195), 1,
      sym_template_type,
    STATE(6095), 1,
      sym_enumerator_list,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(5893), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [291115] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11398), 1,
      anon_sym_EQ,
    ACTIONS(11453), 1,
      anon_sym_COLON,
    ACTIONS(11455), 1,
      anon_sym_SEMI,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    STATE(9513), 1,
      aux_sym_declaration_repeat1,
    STATE(7572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [291153] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4240), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11331), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [291179] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3764), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11376), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [291205] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(11294), 1,
      anon_sym_LBRACK,
    ACTIONS(12123), 1,
      anon_sym_COMMA,
    ACTIONS(12125), 1,
      anon_sym_EQ,
    STATE(7796), 1,
      sym_interface_requirements,
    STATE(7797), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11290), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [291235] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4240), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11333), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [291261] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6789), 1,
      anon_sym_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    STATE(3131), 1,
      sym_parameter_list,
    STATE(7757), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6783), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_try,
  [291289] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11398), 1,
      anon_sym_EQ,
    ACTIONS(11535), 1,
      anon_sym_COLON,
    ACTIONS(11537), 1,
      anon_sym_SEMI,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    STATE(9236), 1,
      aux_sym_declaration_repeat1,
    STATE(7572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [291327] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(8570), 1,
      anon_sym_LBRACE,
    ACTIONS(9938), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10362), 1,
      sym_identifier,
    STATE(4812), 1,
      sym_template_type,
    STATE(4931), 1,
      sym_enumerator_list,
    STATE(8098), 1,
      sym__scope_resolution,
    STATE(4790), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [291363] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4240), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11335), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [291389] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4240), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11337), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [291415] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12093), 1,
      anon_sym_AMP_AMP,
    ACTIONS(12095), 1,
      anon_sym_and,
    ACTIONS(12127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(12129), 1,
      anon_sym_or,
    ACTIONS(6194), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(6192), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [291443] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9474), 1,
      anon_sym_LBRACE,
    ACTIONS(10375), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_template_type,
    STATE(5600), 1,
      sym_enumerator_list,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(5949), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [291479] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4356), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11376), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(12131), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [291507] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11398), 1,
      anon_sym_EQ,
    ACTIONS(12133), 1,
      anon_sym_COLON,
    ACTIONS(12135), 1,
      anon_sym_SEMI,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    STATE(9358), 1,
      aux_sym_declaration_repeat1,
    STATE(7572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [291545] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4356), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11337), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(12137), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [291573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6686), 6,
      anon_sym_AMP,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(6688), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
  [291593] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4240), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11286), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [291619] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4240), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11280), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [291645] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4356), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11335), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(12139), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [291673] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4356), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11280), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(12141), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [291701] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4356), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11286), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(12143), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [291729] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(3709), 1,
      anon_sym_LBRACE,
    ACTIONS(10377), 1,
      sym_identifier,
    ACTIONS(10384), 1,
      anon_sym_COLON_COLON,
    STATE(195), 1,
      sym_template_type,
    STATE(6095), 1,
      sym_enumerator_list,
    STATE(8061), 1,
      sym__scope_resolution,
    STATE(7653), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [291765] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4356), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11331), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(12145), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [291793] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4356), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11333), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(12147), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [291821] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11398), 1,
      anon_sym_EQ,
    ACTIONS(11781), 1,
      anon_sym_COLON,
    ACTIONS(11783), 1,
      anon_sym_SEMI,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    STATE(9581), 1,
      aux_sym_declaration_repeat1,
    STATE(7572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [291859] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4356), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11341), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(12149), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [291887] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11591), 1,
      anon_sym_LBRACK,
    ACTIONS(11982), 1,
      anon_sym_COMMA,
    STATE(7710), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11440), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [291911] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7325), 1,
      anon_sym_LBRACE,
    ACTIONS(9836), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10382), 1,
      sym_identifier,
    STATE(3393), 1,
      sym_template_type,
    STATE(3491), 1,
      sym_enumerator_list,
    STATE(8075), 1,
      sym__scope_resolution,
    STATE(3375), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [291947] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7396), 1,
      anon_sym_LBRACE,
    ACTIONS(9895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10368), 1,
      sym_identifier,
    STATE(3457), 1,
      sym_template_type,
    STATE(3613), 1,
      sym_enumerator_list,
    STATE(8115), 1,
      sym__scope_resolution,
    STATE(3463), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [291983] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11544), 1,
      anon_sym_COLON,
    ACTIONS(11547), 1,
      anon_sym_LBRACK,
    ACTIONS(12151), 1,
      anon_sym_EQ,
    STATE(7782), 1,
      sym_interface_requirements,
    ACTIONS(11444), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_GT2,
      anon_sym_try,
  [292009] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    ACTIONS(10024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10364), 1,
      sym_identifier,
    STATE(3345), 1,
      sym_template_type,
    STATE(3439), 1,
      sym_enumerator_list,
    STATE(8107), 1,
      sym__scope_resolution,
    STATE(3358), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [292045] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11634), 1,
      anon_sym_LBRACK,
    ACTIONS(11982), 1,
      anon_sym_COMMA,
    STATE(7601), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [292069] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12156), 1,
      anon_sym_LT,
    ACTIONS(12158), 1,
      anon_sym_LBRACK,
    STATE(7740), 1,
      sym_template_argument_list,
    ACTIONS(12154), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [292093] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11634), 1,
      anon_sym_LBRACK,
    ACTIONS(11982), 1,
      anon_sym_COMMA,
    STATE(7710), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [292117] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12156), 1,
      anon_sym_LT,
    ACTIONS(12162), 1,
      anon_sym_LBRACK,
    STATE(7800), 1,
      sym_template_argument_list,
    ACTIONS(12160), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [292141] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11547), 1,
      anon_sym_LBRACK,
    ACTIONS(12164), 1,
      anon_sym_COMMA,
    STATE(7710), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11444), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [292165] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4454), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11333), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [292190] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11368), 1,
      anon_sym_COLON,
    ACTIONS(12167), 1,
      anon_sym_EQ,
    STATE(8137), 1,
      sym_interface_requirements,
    ACTIONS(11444), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(11547), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [292215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12158), 1,
      anon_sym_LBRACK,
    ACTIONS(12154), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [292234] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1219), 1,
      anon_sym_LBRACE,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11467), 1,
      anon_sym_try,
    STATE(946), 1,
      sym_try_statement,
    STATE(947), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [292269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7186), 1,
      anon_sym_LBRACK,
    ACTIONS(7188), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [292288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6867), 1,
      anon_sym_LBRACK,
    ACTIONS(6869), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [292307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6810), 1,
      anon_sym_LBRACK,
    ACTIONS(6812), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [292326] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(309), 1,
      anon_sym_LBRACE,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11539), 1,
      anon_sym_try,
    STATE(524), 1,
      sym_try_statement,
    STATE(525), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [292361] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(11197), 1,
      sym_identifier,
    ACTIONS(11234), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12169), 1,
      sym_virtual,
    STATE(195), 1,
      sym_template_type,
    STATE(8127), 1,
      sym__scope_resolution,
    STATE(8526), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [292394] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11341), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [292419] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12171), 1,
      sym_identifier,
    STATE(6901), 1,
      sym__scope_resolution,
    STATE(10876), 1,
      sym_qualified_identifier,
    ACTIONS(12173), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [292450] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11627), 1,
      anon_sym_LBRACK,
    ACTIONS(12065), 1,
      anon_sym_COMMA,
    ACTIONS(12175), 1,
      anon_sym_EQ,
    STATE(8009), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [292475] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1219), 1,
      anon_sym_LBRACE,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11467), 1,
      anon_sym_try,
    STATE(871), 1,
      sym_try_statement,
    STATE(919), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [292510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6895), 1,
      anon_sym_LBRACK,
    ACTIONS(6897), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [292529] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11333), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [292554] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11331), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [292579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12179), 1,
      anon_sym_LBRACK,
    ACTIONS(12177), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [292598] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12183), 1,
      anon_sym_LBRACK,
    ACTIONS(12181), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [292617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12187), 1,
      anon_sym_LBRACK,
    ACTIONS(12185), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [292636] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1219), 1,
      anon_sym_LBRACE,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11467), 1,
      anon_sym_try,
    STATE(920), 1,
      sym_try_statement,
    STATE(921), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [292671] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12189), 1,
      sym_identifier,
    ACTIONS(12192), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(12198), 1,
      sym_preproc_directive,
    ACTIONS(12201), 1,
      anon_sym_RBRACE,
    ACTIONS(12195), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10728), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(7731), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [292700] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11286), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [292725] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11400), 1,
      anon_sym_try,
    STATE(1061), 1,
      sym_try_statement,
    STATE(1079), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [292760] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11280), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [292785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12205), 1,
      anon_sym_LBRACK,
    ACTIONS(12203), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [292804] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11335), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [292829] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11337), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [292854] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11376), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [292879] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10606), 1,
      anon_sym_try,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11560), 1,
      anon_sym_LBRACE,
    STATE(2192), 1,
      sym_try_statement,
    STATE(2193), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [292914] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6974), 1,
      anon_sym_LBRACK,
    ACTIONS(6976), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [292933] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12100), 1,
      anon_sym_COMMA,
    ACTIONS(12207), 1,
      anon_sym_EQ,
    STATE(7942), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 8,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [292956] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10606), 1,
      anon_sym_try,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11560), 1,
      anon_sym_LBRACE,
    STATE(2187), 1,
      sym_try_statement,
    STATE(2189), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [292991] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10183), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(9512), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [293012] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1219), 1,
      anon_sym_LBRACE,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11467), 1,
      anon_sym_try,
    STATE(925), 1,
      sym_try_statement,
    STATE(926), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [293047] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12209), 1,
      sym_identifier,
    STATE(6901), 1,
      sym__scope_resolution,
    STATE(10426), 1,
      sym_qualified_identifier,
    ACTIONS(12211), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [293078] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(309), 1,
      anon_sym_LBRACE,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11539), 1,
      anon_sym_try,
    STATE(469), 1,
      sym_try_statement,
    STATE(513), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [293113] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(309), 1,
      anon_sym_LBRACE,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11539), 1,
      anon_sym_try,
    STATE(511), 1,
      sym_compound_statement,
    STATE(512), 1,
      sym_try_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [293148] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11480), 1,
      anon_sym_COLON,
    ACTIONS(12213), 1,
      anon_sym_EQ,
    STATE(7970), 1,
      sym_interface_requirements,
    ACTIONS(11444), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(11547), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [293173] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10606), 1,
      anon_sym_try,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11560), 1,
      anon_sym_LBRACE,
    STATE(2159), 1,
      sym_try_statement,
    STATE(2161), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [293208] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(655), 1,
      anon_sym_LBRACE,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11457), 1,
      anon_sym_try,
    STATE(824), 1,
      sym_compound_statement,
    STATE(825), 1,
      sym_try_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [293243] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11398), 1,
      anon_sym_EQ,
    ACTIONS(12218), 1,
      anon_sym_COLON,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    ACTIONS(12216), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(7572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [293276] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1219), 1,
      anon_sym_LBRACE,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11467), 1,
      anon_sym_try,
    STATE(948), 1,
      sym_try_statement,
    STATE(949), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [293311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12222), 1,
      anon_sym_LBRACK,
    ACTIONS(12220), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [293330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6871), 1,
      anon_sym_LBRACK,
    ACTIONS(6873), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [293349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12226), 1,
      anon_sym_LBRACK,
    ACTIONS(12224), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [293368] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(309), 1,
      anon_sym_LBRACE,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11539), 1,
      anon_sym_try,
    STATE(502), 1,
      sym_compound_statement,
    STATE(503), 1,
      sym_try_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [293403] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6855), 1,
      anon_sym_LBRACK,
    STATE(7619), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6857), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_try,
  [293426] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11722), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [293455] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7766), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(7220), 1,
      sym_where_clause,
    ACTIONS(9512), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [293478] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11480), 1,
      anon_sym_COLON,
    ACTIONS(12228), 1,
      anon_sym_EQ,
    STATE(8008), 1,
      sym_interface_requirements,
    ACTIONS(11444), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [293501] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12230), 1,
      anon_sym_where,
    STATE(7168), 1,
      sym_where_clause,
    ACTIONS(11492), 4,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(11490), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [293524] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11667), 1,
      anon_sym_where,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(10968), 4,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(10966), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [293547] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4454), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11341), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [293572] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11361), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(10676), 4,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(10674), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [293595] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11480), 1,
      anon_sym_COLON,
    ACTIONS(12233), 1,
      anon_sym_EQ,
    STATE(7965), 1,
      sym_interface_requirements,
    ACTIONS(11444), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [293618] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11400), 1,
      anon_sym_try,
    STATE(1051), 1,
      sym_compound_statement,
    STATE(1055), 1,
      sym_try_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [293653] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10487), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(10279), 4,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(10277), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [293676] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4454), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11331), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [293701] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12235), 1,
      sym_identifier,
    STATE(6901), 1,
      sym__scope_resolution,
    STATE(10285), 1,
      sym_qualified_identifier,
    ACTIONS(12237), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [293732] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10305), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(10064), 4,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(10062), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [293755] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10172), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(9514), 4,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(9512), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [293778] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1219), 1,
      anon_sym_LBRACE,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11467), 1,
      anon_sym_try,
    STATE(950), 1,
      sym_try_statement,
    STATE(952), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [293813] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(10277), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [293834] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11400), 1,
      anon_sym_try,
    STATE(1050), 1,
      sym_try_statement,
    STATE(1052), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [293869] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4454), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11286), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [293894] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4454), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11280), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [293919] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(655), 1,
      anon_sym_LBRACE,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11457), 1,
      anon_sym_try,
    STATE(904), 1,
      sym_try_statement,
    STATE(905), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [293954] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4454), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11335), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [293979] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4454), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11337), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [294004] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11400), 1,
      anon_sym_try,
    STATE(1001), 1,
      sym_try_statement,
    STATE(1046), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [294039] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10311), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(10062), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [294060] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11701), 1,
      anon_sym_LBRACK,
    ACTIONS(12239), 1,
      anon_sym_EQ,
    ACTIONS(11699), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_GT2,
      anon_sym_try,
  [294081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6838), 1,
      anon_sym_LBRACK,
    ACTIONS(6840), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [294100] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4454), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11376), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [294125] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10598), 1,
      anon_sym_try,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11617), 1,
      anon_sym_LBRACE,
    STATE(1657), 1,
      sym_compound_statement,
    STATE(1659), 1,
      sym_try_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [294160] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(11197), 1,
      sym_identifier,
    ACTIONS(11234), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12242), 1,
      sym_virtual,
    STATE(195), 1,
      sym_template_type,
    STATE(8127), 1,
      sym__scope_resolution,
    STATE(8541), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [294193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12246), 1,
      anon_sym_LBRACK,
    ACTIONS(12244), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [294212] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(309), 1,
      anon_sym_LBRACE,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11539), 1,
      anon_sym_try,
    STATE(447), 1,
      sym_try_statement,
    STATE(487), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [294247] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10598), 1,
      anon_sym_try,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11617), 1,
      anon_sym_LBRACE,
    STATE(1663), 1,
      sym_try_statement,
    STATE(1664), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [294282] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11670), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [294311] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11400), 1,
      anon_sym_try,
    STATE(1040), 1,
      sym_try_statement,
    STATE(1057), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [294346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12250), 1,
      anon_sym_LBRACK,
    ACTIONS(12248), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [294365] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10606), 1,
      anon_sym_try,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11560), 1,
      anon_sym_LBRACE,
    STATE(2057), 1,
      sym_try_statement,
    STATE(2061), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [294400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12254), 1,
      anon_sym_LBRACK,
    ACTIONS(12252), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [294419] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10606), 1,
      anon_sym_try,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11560), 1,
      anon_sym_LBRACE,
    STATE(2048), 1,
      sym_try_statement,
    STATE(2049), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [294454] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11627), 1,
      anon_sym_LBRACK,
    ACTIONS(12123), 1,
      anon_sym_COMMA,
    ACTIONS(12256), 1,
      anon_sym_EQ,
    STATE(7806), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 7,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [294479] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11627), 1,
      anon_sym_LBRACK,
    ACTIONS(12123), 1,
      anon_sym_COMMA,
    STATE(7807), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 8,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [294502] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10606), 1,
      anon_sym_try,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11560), 1,
      anon_sym_LBRACE,
    STATE(2043), 1,
      sym_try_statement,
    STATE(2046), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [294537] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(12258), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(12260), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(12262), 1,
      aux_sym_preproc_elif_token1,
    STATE(8173), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(10290), 1,
      sym_enumerator,
    ACTIONS(12264), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(10292), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [294568] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6939), 1,
      anon_sym_LBRACK,
    ACTIONS(6941), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [294587] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(12260), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(12262), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(12266), 1,
      aux_sym_preproc_if_token2,
    STATE(8173), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(10290), 1,
      sym_enumerator,
    ACTIONS(12264), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(10729), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [294618] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6887), 1,
      anon_sym_LBRACK,
    ACTIONS(6889), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [294637] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10598), 1,
      anon_sym_try,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11617), 1,
      anon_sym_LBRACE,
    STATE(1636), 1,
      sym_try_statement,
    STATE(1637), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [294672] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12270), 1,
      anon_sym_LBRACK,
    ACTIONS(12268), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [294691] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11634), 1,
      anon_sym_LBRACK,
    ACTIONS(12123), 1,
      anon_sym_COMMA,
    STATE(7808), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 8,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [294714] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11634), 1,
      anon_sym_LBRACK,
    ACTIONS(12123), 1,
      anon_sym_COMMA,
    STATE(7807), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 8,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [294737] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11547), 1,
      anon_sym_LBRACK,
    ACTIONS(12272), 1,
      anon_sym_COMMA,
    STATE(7807), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11444), 8,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [294760] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11593), 1,
      anon_sym_LBRACK,
    ACTIONS(12123), 1,
      anon_sym_COMMA,
    STATE(7807), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 8,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [294783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6875), 1,
      anon_sym_LBRACK,
    ACTIONS(6877), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [294802] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11593), 1,
      anon_sym_LBRACK,
    ACTIONS(12123), 1,
      anon_sym_COMMA,
    STATE(7813), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 8,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [294825] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(655), 1,
      anon_sym_LBRACE,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11457), 1,
      anon_sym_try,
    STATE(909), 1,
      sym_try_statement,
    STATE(910), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [294860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6688), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6686), 8,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
  [294879] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11591), 1,
      anon_sym_LBRACK,
    ACTIONS(12123), 1,
      anon_sym_COMMA,
    STATE(7807), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11440), 8,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [294902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12277), 1,
      anon_sym_LBRACK,
    ACTIONS(12275), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [294921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12281), 1,
      anon_sym_LBRACK,
    ACTIONS(12279), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [294940] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12283), 1,
      sym_identifier,
    STATE(6901), 1,
      sym__scope_resolution,
    STATE(10709), 1,
      sym_qualified_identifier,
    ACTIONS(12285), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [294971] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12287), 1,
      sym_identifier,
    STATE(6901), 1,
      sym__scope_resolution,
    STATE(10619), 1,
      sym_qualified_identifier,
    ACTIONS(12289), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [295002] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11908), 1,
      anon_sym_COMMA,
    STATE(7821), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [295023] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11908), 1,
      anon_sym_COMMA,
    STATE(7822), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [295044] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11908), 1,
      anon_sym_COMMA,
    STATE(7821), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [295065] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12291), 1,
      anon_sym_COMMA,
    STATE(7821), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11444), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [295086] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11908), 1,
      anon_sym_COMMA,
    STATE(7821), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [295107] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11908), 1,
      anon_sym_COMMA,
    STATE(7824), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [295128] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11908), 1,
      anon_sym_COMMA,
    STATE(7821), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11440), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [295149] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12294), 1,
      anon_sym_where,
    STATE(7168), 1,
      sym_where_clause,
    ACTIONS(11490), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [295170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12299), 1,
      anon_sym_LBRACK,
    ACTIONS(12297), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [295189] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(309), 1,
      anon_sym_LBRACE,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11539), 1,
      anon_sym_try,
    STATE(465), 1,
      sym_try_statement,
    STATE(466), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [295224] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(309), 1,
      anon_sym_LBRACE,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11539), 1,
      anon_sym_try,
    STATE(442), 1,
      sym_compound_statement,
    STATE(468), 1,
      sym_try_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [295259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12303), 1,
      anon_sym_LBRACK,
    ACTIONS(12301), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [295278] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12305), 1,
      sym_identifier,
    STATE(6901), 1,
      sym__scope_resolution,
    STATE(10325), 1,
      sym_qualified_identifier,
    ACTIONS(12307), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [295309] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11712), 1,
      sym_identifier,
    ACTIONS(12309), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(12311), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(12313), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(12315), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8165), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(10730), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [295338] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(655), 1,
      anon_sym_LBRACE,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11457), 1,
      anon_sym_try,
    STATE(888), 1,
      sym_try_statement,
    STATE(889), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [295373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6830), 1,
      anon_sym_LBRACK,
    ACTIONS(6832), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [295392] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11742), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(12260), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(12262), 1,
      aux_sym_preproc_elif_token1,
    STATE(7801), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(10290), 1,
      sym_enumerator,
    ACTIONS(12264), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(10071), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [295423] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11627), 1,
      anon_sym_LBRACK,
    ACTIONS(12002), 1,
      anon_sym_COMMA,
    ACTIONS(12317), 1,
      anon_sym_EQ,
    STATE(7925), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [295448] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11544), 1,
      anon_sym_COLON,
    ACTIONS(11547), 1,
      anon_sym_LBRACK,
    ACTIONS(12319), 1,
      anon_sym_EQ,
    STATE(7930), 1,
      sym_interface_requirements,
    ACTIONS(11444), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [295473] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(655), 1,
      anon_sym_LBRACE,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11457), 1,
      anon_sym_try,
    STATE(817), 1,
      sym_try_statement,
    STATE(818), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [295508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12321), 1,
      anon_sym_EQ,
    ACTIONS(11699), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_GT2,
      anon_sym_try,
  [295527] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(11197), 1,
      sym_identifier,
    ACTIONS(11234), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12324), 1,
      sym_virtual,
    STATE(195), 1,
      sym_template_type,
    STATE(8127), 1,
      sym__scope_resolution,
    STATE(8758), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [295560] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11712), 1,
      sym_identifier,
    ACTIONS(12311), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(12313), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(12326), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(12315), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8165), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(10281), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [295589] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10598), 1,
      anon_sym_try,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11617), 1,
      anon_sym_LBRACE,
    STATE(1592), 1,
      sym_try_statement,
    STATE(1595), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [295624] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11690), 1,
      anon_sym_where,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(10966), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [295645] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11712), 1,
      sym_identifier,
    ACTIONS(12311), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(12313), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(12328), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(12315), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(7831), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(10075), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [295674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 1,
      anon_sym_LBRACK,
    ACTIONS(2171), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [295693] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1219), 1,
      anon_sym_LBRACE,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11467), 1,
      anon_sym_try,
    STATE(814), 1,
      sym_try_statement,
    STATE(907), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [295728] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10598), 1,
      anon_sym_try,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11617), 1,
      anon_sym_LBRACE,
    STATE(1589), 1,
      sym_try_statement,
    STATE(1590), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [295763] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10598), 1,
      anon_sym_try,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11617), 1,
      anon_sym_LBRACE,
    STATE(1576), 1,
      sym_try_statement,
    STATE(1577), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [295798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6816), 1,
      anon_sym_LBRACK,
    ACTIONS(6818), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [295817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6842), 1,
      anon_sym_LBRACK,
    ACTIONS(6844), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [295836] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7766), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    STATE(7152), 1,
      sym_where_clause,
    ACTIONS(10062), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [295859] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10590), 1,
      anon_sym_try,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11521), 1,
      anon_sym_LBRACE,
    STATE(2218), 1,
      sym_compound_statement,
    STATE(2219), 1,
      sym_try_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [295894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12332), 1,
      anon_sym_LBRACK,
    ACTIONS(12330), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [295913] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12334), 1,
      sym_identifier,
    STATE(6901), 1,
      sym__scope_resolution,
    STATE(10784), 1,
      sym_qualified_identifier,
    ACTIONS(12336), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [295944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6613), 1,
      anon_sym_LBRACK,
    ACTIONS(6611), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [295963] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(655), 1,
      anon_sym_LBRACE,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11457), 1,
      anon_sym_try,
    STATE(837), 1,
      sym_try_statement,
    STATE(838), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [295998] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(11197), 1,
      sym_identifier,
    ACTIONS(11234), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12338), 1,
      sym_virtual,
    STATE(195), 1,
      sym_template_type,
    STATE(8127), 1,
      sym__scope_resolution,
    STATE(8681), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [296031] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11693), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [296060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12340), 1,
      anon_sym_EQ,
    ACTIONS(11699), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [296079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LBRACK,
    ACTIONS(6826), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [296098] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11400), 1,
      anon_sym_try,
    STATE(1009), 1,
      sym_try_statement,
    STATE(1010), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [296133] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(12260), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(12262), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(12343), 1,
      aux_sym_preproc_if_token2,
    STATE(7799), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(10290), 1,
      sym_enumerator,
    ACTIONS(12264), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(10771), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [296164] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12104), 1,
      anon_sym_COMMA,
    STATE(7888), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11440), 4,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(11591), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [296187] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12104), 1,
      anon_sym_COMMA,
    STATE(7862), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 4,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(11593), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [296210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 1,
      anon_sym_LBRACK,
    ACTIONS(2171), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [296229] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10590), 1,
      anon_sym_try,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11521), 1,
      anon_sym_LBRACE,
    STATE(2173), 1,
      sym_compound_statement,
    STATE(2180), 1,
      sym_try_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [296264] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12347), 1,
      anon_sym_LBRACK,
    ACTIONS(12345), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [296283] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10590), 1,
      anon_sym_try,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11521), 1,
      anon_sym_LBRACE,
    STATE(2163), 1,
      sym_compound_statement,
    STATE(2165), 1,
      sym_try_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [296318] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7766), 1,
      anon_sym_where,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    STATE(7240), 1,
      sym_where_clause,
    ACTIONS(10277), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [296341] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4485), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11341), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [296366] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12104), 1,
      anon_sym_COMMA,
    STATE(7888), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 4,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(11593), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [296389] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10598), 1,
      anon_sym_try,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11617), 1,
      anon_sym_LBRACE,
    STATE(1554), 1,
      sym_try_statement,
    STATE(1556), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [296424] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4485), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11333), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [296449] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4485), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11331), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [296474] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4485), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11286), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [296499] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4485), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11280), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [296524] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4485), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11335), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [296549] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4485), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11337), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [296574] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4485), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11376), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [296599] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(655), 1,
      anon_sym_LBRACE,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11457), 1,
      anon_sym_try,
    STATE(815), 1,
      sym_try_statement,
    STATE(816), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [296634] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10590), 1,
      anon_sym_try,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11521), 1,
      anon_sym_LBRACE,
    STATE(2137), 1,
      sym_compound_statement,
    STATE(2140), 1,
      sym_try_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [296669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 1,
      anon_sym_LBRACK,
    ACTIONS(2171), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [296688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6590), 1,
      anon_sym_LBRACK,
    ACTIONS(6165), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [296707] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11400), 1,
      anon_sym_try,
    STATE(1038), 1,
      sym_try_statement,
    STATE(1039), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [296742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12351), 1,
      anon_sym_LBRACK,
    ACTIONS(12349), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [296761] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11544), 1,
      anon_sym_COLON,
    ACTIONS(11547), 1,
      anon_sym_LBRACK,
    ACTIONS(12353), 1,
      anon_sym_EQ,
    STATE(8030), 1,
      sym_interface_requirements,
    ACTIONS(11444), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [296786] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12061), 1,
      anon_sym_COMMA,
    ACTIONS(12356), 1,
      anon_sym_EQ,
    STATE(7950), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 8,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [296809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 1,
      anon_sym_LBRACK,
    ACTIONS(2171), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [296828] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12358), 1,
      anon_sym_COMMA,
    STATE(7888), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11444), 4,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(11547), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [296851] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12104), 1,
      anon_sym_COMMA,
    STATE(7888), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 4,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(11634), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [296874] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10590), 1,
      anon_sym_try,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11521), 1,
      anon_sym_LBRACE,
    STATE(1998), 1,
      sym_compound_statement,
    STATE(1999), 1,
      sym_try_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [296909] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 1,
      anon_sym_LBRACK,
    ACTIONS(2171), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [296928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 1,
      anon_sym_LBRACK,
    ACTIONS(2171), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [296947] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10590), 1,
      anon_sym_try,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11521), 1,
      anon_sym_LBRACE,
    STATE(1970), 1,
      sym_compound_statement,
    STATE(1972), 1,
      sym_try_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [296982] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11712), 1,
      sym_identifier,
    ACTIONS(12311), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(12313), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(12361), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(12315), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(7920), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(10716), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [297011] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10590), 1,
      anon_sym_try,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11521), 1,
      anon_sym_LBRACE,
    STATE(1946), 1,
      sym_compound_statement,
    STATE(1949), 1,
      sym_try_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [297046] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12104), 1,
      anon_sym_COMMA,
    STATE(7870), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 4,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(11634), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [297069] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12104), 1,
      anon_sym_COMMA,
    STATE(7888), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 4,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(11627), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [297092] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11368), 1,
      anon_sym_COLON,
    ACTIONS(12363), 1,
      anon_sym_EQ,
    STATE(8093), 1,
      sym_interface_requirements,
    ACTIONS(11444), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [297115] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11677), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [297144] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12104), 1,
      anon_sym_COMMA,
    ACTIONS(12365), 1,
      anon_sym_EQ,
    STATE(7889), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
    ACTIONS(11627), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [297169] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(12260), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(12262), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(12367), 1,
      aux_sym_preproc_if_token2,
    STATE(7905), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(10290), 1,
      sym_enumerator,
    ACTIONS(12264), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(10314), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [297200] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11675), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [297229] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(4569), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11376), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [297254] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11726), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(12260), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(12262), 1,
      aux_sym_preproc_elif_token1,
    STATE(7913), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(10290), 1,
      sym_enumerator,
    ACTIONS(12264), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(10665), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [297285] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(12260), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(12262), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(12369), 1,
      aux_sym_preproc_if_token2,
    STATE(8173), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(10290), 1,
      sym_enumerator,
    ACTIONS(12264), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(10097), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [297316] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11712), 1,
      sym_identifier,
    ACTIONS(12311), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(12313), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(12371), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(12315), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8165), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(10090), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [297345] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10606), 1,
      anon_sym_try,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11560), 1,
      anon_sym_LBRACE,
    STATE(2010), 1,
      sym_try_statement,
    STATE(2011), 1,
      sym_compound_statement,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [297380] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11352), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(10674), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [297401] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(4569), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11337), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [297426] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(4569), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11341), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [297451] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(4569), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11335), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [297476] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(4569), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11280), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [297501] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(12260), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(12262), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(12373), 1,
      aux_sym_preproc_if_token2,
    STATE(8173), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(10290), 1,
      sym_enumerator,
    ACTIONS(12264), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(10790), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [297532] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(4569), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11286), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [297557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12375), 1,
      anon_sym_EQ,
    ACTIONS(11699), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [297576] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(4569), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11331), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [297601] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7766), 1,
      anon_sym_where,
    ACTIONS(11492), 1,
      anon_sym_LBRACK,
    STATE(7170), 1,
      sym_where_clause,
    ACTIONS(11490), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [297624] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7766), 1,
      anon_sym_where,
    ACTIONS(10676), 1,
      anon_sym_LBRACK,
    STATE(7187), 1,
      sym_where_clause,
    ACTIONS(10674), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [297647] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(4569), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11333), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [297672] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11712), 1,
      sym_identifier,
    ACTIONS(12311), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(12313), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(12377), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(12315), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8165), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(10791), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [297701] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7766), 1,
      anon_sym_where,
    ACTIONS(10968), 1,
      anon_sym_LBRACK,
    STATE(7172), 1,
      sym_where_clause,
    ACTIONS(10966), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [297724] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12383), 1,
      anon_sym_delete,
    ACTIONS(12385), 1,
      anon_sym_new,
    ACTIONS(12381), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(12379), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [297746] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12061), 1,
      anon_sym_COMMA,
    STATE(7946), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 8,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [297766] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11547), 1,
      anon_sym_LBRACK,
    ACTIONS(12387), 1,
      anon_sym_COMMA,
    STATE(7924), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11444), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [297788] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11634), 1,
      anon_sym_LBRACK,
    ACTIONS(12002), 1,
      anon_sym_COMMA,
    STATE(7924), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [297810] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11634), 1,
      anon_sym_LBRACK,
    ACTIONS(12002), 1,
      anon_sym_COMMA,
    STATE(7973), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [297832] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2252), 1,
      anon_sym_LBRACK,
    ACTIONS(2254), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [297850] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11627), 1,
      anon_sym_LBRACK,
    ACTIONS(12002), 1,
      anon_sym_COMMA,
    STATE(7924), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [297872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2206), 1,
      anon_sym_LBRACK,
    ACTIONS(2208), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [297890] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11701), 1,
      anon_sym_LBRACK,
    ACTIONS(12390), 1,
      anon_sym_EQ,
    ACTIONS(11699), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [297910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 1,
      anon_sym_LBRACK,
    ACTIONS(2246), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [297928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2202), 1,
      anon_sym_LBRACK,
    ACTIONS(2204), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [297946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2236), 1,
      anon_sym_LBRACK,
    ACTIONS(2238), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [297964] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12385), 1,
      anon_sym_new,
    ACTIONS(12392), 1,
      anon_sym_delete,
    ACTIONS(12381), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(12379), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [297986] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4930), 1,
      anon_sym_LBRACE,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(12394), 1,
      anon_sym_EQ,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(10536), 1,
      sym_initializer_list,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [298018] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11801), 1,
      anon_sym_LBRACK,
    STATE(7754), 1,
      sym_parameter_list,
    STATE(7580), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(12396), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
  [298044] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11593), 1,
      anon_sym_LBRACK,
    ACTIONS(12065), 1,
      anon_sym_COMMA,
    STATE(8012), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [298066] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12100), 1,
      anon_sym_COMMA,
    STATE(7943), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 8,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [298086] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12100), 1,
      anon_sym_COMMA,
    STATE(7944), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 8,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [298106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2240), 1,
      anon_sym_LBRACK,
    ACTIONS(2242), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [298124] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12398), 1,
      anon_sym_delete,
    ACTIONS(12400), 1,
      anon_sym_new,
    ACTIONS(12381), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(12379), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [298146] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12100), 1,
      anon_sym_COMMA,
    STATE(7943), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 8,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [298166] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12402), 1,
      anon_sym_COMMA,
    STATE(7943), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11444), 8,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [298186] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12100), 1,
      anon_sym_COMMA,
    STATE(7943), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 8,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [298206] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12112), 1,
      anon_sym_COMMA,
    ACTIONS(12405), 1,
      anon_sym_EQ,
    STATE(8042), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 7,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [298228] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12061), 1,
      anon_sym_COMMA,
    STATE(7949), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11440), 8,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [298248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2198), 1,
      anon_sym_LBRACK,
    ACTIONS(2200), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [298266] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12061), 1,
      anon_sym_COMMA,
    STATE(7949), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 8,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [298286] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12407), 1,
      anon_sym_COMMA,
    STATE(7949), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11444), 8,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [298306] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12061), 1,
      anon_sym_COMMA,
    STATE(7949), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 8,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [298326] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12061), 1,
      anon_sym_COMMA,
    STATE(7948), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 8,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [298346] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10210), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(9512), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [298366] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10336), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(10062), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [298386] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12061), 1,
      anon_sym_COMMA,
    STATE(7949), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 8,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [298406] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12410), 1,
      anon_sym_delete,
    ACTIONS(12412), 1,
      anon_sym_new,
    ACTIONS(12381), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(12379), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [298428] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12100), 1,
      anon_sym_COMMA,
    STATE(7959), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 8,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [298448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2224), 1,
      anon_sym_LBRACK,
    ACTIONS(2226), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [298466] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(11197), 1,
      sym_identifier,
    ACTIONS(11234), 1,
      anon_sym_COLON_COLON,
    STATE(195), 1,
      sym_template_type,
    STATE(8127), 1,
      sym__scope_resolution,
    STATE(8590), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [298496] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12100), 1,
      anon_sym_COMMA,
    STATE(7943), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11440), 8,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [298516] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12049), 1,
      anon_sym_COLON,
    ACTIONS(12091), 1,
      anon_sym_LBRACK,
    STATE(7735), 1,
      sym_semantics,
    ACTIONS(12086), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [298538] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10507), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(10277), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [298558] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12414), 1,
      anon_sym_delete,
    ACTIONS(12416), 1,
      anon_sym_new,
    ACTIONS(12381), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(12379), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [298580] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11646), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(10674), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [298600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2258), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [298618] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12418), 1,
      anon_sym_EQ,
    ACTIONS(11699), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [298636] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12420), 1,
      anon_sym_delete,
    ACTIONS(12422), 1,
      anon_sym_new,
    ACTIONS(12381), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(12379), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [298658] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    ACTIONS(10245), 1,
      anon_sym_where,
    STATE(7220), 1,
      sym_where_clause,
    ACTIONS(9512), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [298680] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11368), 1,
      anon_sym_COLON,
    ACTIONS(12424), 1,
      anon_sym_COMMA,
    ACTIONS(12426), 1,
      anon_sym_EQ,
    STATE(8212), 1,
      sym_interface_requirements,
    STATE(8235), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11290), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [298706] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12430), 1,
      anon_sym_LBRACK,
    STATE(8604), 1,
      sym_gnu_asm_output_operand,
    STATE(10505), 1,
      sym_string_literal,
    ACTIONS(12428), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [298730] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12432), 1,
      anon_sym_EQ,
    ACTIONS(11699), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
    ACTIONS(11701), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [298750] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12435), 1,
      anon_sym_delete,
    ACTIONS(12437), 1,
      anon_sym_new,
    ACTIONS(12381), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(12379), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [298772] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11807), 1,
      anon_sym_where,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(10966), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [298792] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11593), 1,
      anon_sym_LBRACK,
    ACTIONS(12002), 1,
      anon_sym_COMMA,
    STATE(7924), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [298814] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11627), 1,
      anon_sym_LBRACK,
    ACTIONS(12065), 1,
      anon_sym_COMMA,
    STATE(8012), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [298836] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12439), 1,
      anon_sym_where,
    STATE(7168), 1,
      sym_where_clause,
    ACTIONS(11490), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [298856] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    ACTIONS(10389), 1,
      anon_sym_where,
    STATE(7152), 1,
      sym_where_clause,
    ACTIONS(10062), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [298878] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6789), 1,
      anon_sym_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(12442), 1,
      anon_sym_COMMA,
    STATE(3131), 1,
      sym_parameter_list,
    STATE(8916), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(12444), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
    STATE(7757), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [298908] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12053), 1,
      anon_sym_COMMA,
    ACTIONS(12446), 1,
      anon_sym_EQ,
    STATE(8079), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(11627), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [298932] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4574), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11376), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [298956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2186), 1,
      anon_sym_LBRACK,
    ACTIONS(2188), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [298974] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12448), 1,
      anon_sym_delete,
    ACTIONS(12450), 1,
      anon_sym_new,
    ACTIONS(12381), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(12379), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [298996] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(12452), 1,
      sym_identifier,
    ACTIONS(12454), 1,
      anon_sym_COLON_COLON,
    STATE(3628), 1,
      sym_template_type,
    STATE(8106), 1,
      sym__scope_resolution,
    STATE(3649), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [299026] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11847), 1,
      anon_sym_where,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(10966), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [299046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_LBRACK,
    ACTIONS(2196), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [299064] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(11197), 1,
      sym_identifier,
    ACTIONS(11234), 1,
      anon_sym_COLON_COLON,
    STATE(195), 1,
      sym_template_type,
    STATE(8127), 1,
      sym__scope_resolution,
    STATE(8526), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [299094] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    ACTIONS(10565), 1,
      anon_sym_where,
    STATE(7240), 1,
      sym_where_clause,
    ACTIONS(10277), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [299116] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11591), 1,
      anon_sym_LBRACK,
    ACTIONS(12065), 1,
      anon_sym_COMMA,
    STATE(8012), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11440), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [299138] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12456), 1,
      anon_sym_where,
    STATE(7168), 1,
      sym_where_clause,
    ACTIONS(11490), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [299158] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11593), 1,
      anon_sym_LBRACK,
    ACTIONS(12065), 1,
      anon_sym_COMMA,
    STATE(7987), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [299180] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11593), 1,
      anon_sym_LBRACK,
    ACTIONS(12002), 1,
      anon_sym_COMMA,
    STATE(8001), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [299202] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11409), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(10674), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [299222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LBRACK,
    ACTIONS(2234), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [299240] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11701), 1,
      anon_sym_LBRACK,
    ACTIONS(12459), 1,
      anon_sym_EQ,
    ACTIONS(11699), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [299260] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    ACTIONS(11376), 1,
      anon_sym_COMMA,
    STATE(4577), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(12131), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [299286] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11368), 1,
      anon_sym_COLON,
    ACTIONS(12461), 1,
      anon_sym_COMMA,
    ACTIONS(12463), 1,
      anon_sym_EQ,
    STATE(8191), 1,
      aux_sym_where_clause_repeat1,
    STATE(8194), 1,
      sym_interface_requirements,
    ACTIONS(11290), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_try,
  [299312] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4574), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11337), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [299336] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10676), 1,
      anon_sym_LBRACK,
    ACTIONS(11573), 1,
      anon_sym_where,
    STATE(7187), 1,
      sym_where_clause,
    ACTIONS(10674), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [299358] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10968), 1,
      anon_sym_LBRACK,
    ACTIONS(11883), 1,
      anon_sym_where,
    STATE(7172), 1,
      sym_where_clause,
    ACTIONS(10966), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [299380] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10499), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(10277), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [299400] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(11197), 1,
      sym_identifier,
    ACTIONS(11234), 1,
      anon_sym_COLON_COLON,
    STATE(195), 1,
      sym_template_type,
    STATE(8127), 1,
      sym__scope_resolution,
    STATE(8749), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [299430] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11591), 1,
      anon_sym_LBRACK,
    ACTIONS(12002), 1,
      anon_sym_COMMA,
    STATE(7924), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11440), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [299452] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12029), 1,
      anon_sym_LBRACK,
    STATE(7619), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(12027), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [299474] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11337), 1,
      anon_sym_COMMA,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4577), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(12137), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [299500] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12465), 1,
      anon_sym_delete,
    ACTIONS(12467), 1,
      anon_sym_new,
    ACTIONS(12381), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(12379), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [299522] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(11197), 1,
      sym_identifier,
    ACTIONS(11234), 1,
      anon_sym_COLON_COLON,
    STATE(195), 1,
      sym_template_type,
    STATE(8127), 1,
      sym__scope_resolution,
    STATE(8681), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(10765), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [299552] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12469), 1,
      anon_sym_delete,
    ACTIONS(12471), 1,
      anon_sym_new,
    ACTIONS(12381), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(12379), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [299574] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11335), 1,
      anon_sym_COMMA,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4577), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(12139), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [299600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12473), 1,
      anon_sym_EQ,
    ACTIONS(11699), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [299618] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11634), 1,
      anon_sym_LBRACK,
    ACTIONS(12065), 1,
      anon_sym_COMMA,
    STATE(8012), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [299640] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11280), 1,
      anon_sym_COMMA,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4577), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(12141), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [299666] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11286), 1,
      anon_sym_COMMA,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4577), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(12143), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [299692] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11547), 1,
      anon_sym_LBRACK,
    ACTIONS(12475), 1,
      anon_sym_COMMA,
    STATE(8012), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11444), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [299714] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2228), 1,
      anon_sym_LBRACK,
    ACTIONS(2230), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [299732] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10342), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(10062), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [299752] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11331), 1,
      anon_sym_COMMA,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4577), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(12145), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [299778] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11333), 1,
      anon_sym_COMMA,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4577), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(12147), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [299804] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4574), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11335), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [299828] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12400), 1,
      anon_sym_new,
    ACTIONS(12478), 1,
      anon_sym_delete,
    ACTIONS(12381), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(12379), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [299850] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4574), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11280), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [299874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2190), 1,
      anon_sym_LBRACK,
    ACTIONS(2192), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [299892] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12385), 1,
      anon_sym_new,
    ACTIONS(12480), 1,
      anon_sym_delete,
    ACTIONS(12381), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(12379), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [299914] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12484), 1,
      anon_sym_LBRACK,
    STATE(8698), 1,
      sym_gnu_asm_input_operand,
    STATE(10188), 1,
      sym_string_literal,
    ACTIONS(12482), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [299938] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10207), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(9512), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [299958] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4574), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11286), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [299982] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11492), 1,
      anon_sym_LBRACK,
    ACTIONS(12486), 1,
      anon_sym_where,
    STATE(7170), 1,
      sym_where_clause,
    ACTIONS(11490), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [300004] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11341), 1,
      anon_sym_COMMA,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4577), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(12149), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [300030] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4574), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11331), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [300054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [300072] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11634), 1,
      anon_sym_LBRACK,
    ACTIONS(12065), 1,
      anon_sym_COMMA,
    STATE(7937), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [300094] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11701), 1,
      anon_sym_LBRACK,
    ACTIONS(12489), 1,
      anon_sym_EQ,
    ACTIONS(11699), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [300114] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4574), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11333), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [300138] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12471), 1,
      anon_sym_new,
    ACTIONS(12492), 1,
      anon_sym_delete,
    ACTIONS(12381), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(12379), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [300160] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4574), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11341), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [300184] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12112), 1,
      anon_sym_COMMA,
    STATE(8073), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 7,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [300203] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(9994), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12494), 1,
      sym_identifier,
    ACTIONS(12496), 1,
      anon_sym_template,
    STATE(4408), 1,
      sym_template_type,
    STATE(4544), 1,
      sym_dependent_type_identifier,
    STATE(4570), 1,
      sym_qualified_type_identifier,
    STATE(8035), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [300234] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8193), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(10062), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [300253] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4083), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11337), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [300276] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12112), 1,
      anon_sym_COMMA,
    STATE(8049), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 7,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [300295] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(8044), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12498), 1,
      sym_identifier,
    ACTIONS(12500), 1,
      anon_sym_template,
    STATE(196), 1,
      sym_template_type,
    STATE(197), 1,
      sym_dependent_type_identifier,
    STATE(201), 1,
      sym_qualified_type_identifier,
    STATE(8039), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [300326] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12502), 1,
      sym_identifier,
    ACTIONS(12506), 1,
      sym_system_lib_string,
    STATE(10657), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(12504), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [300347] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12053), 1,
      anon_sym_COMMA,
    STATE(8101), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11440), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(11591), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [300368] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12112), 1,
      anon_sym_COMMA,
    STATE(8049), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 7,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [300387] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10372), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(10062), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [300406] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8193), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(10277), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [300425] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12508), 1,
      sym_identifier,
    ACTIONS(12510), 1,
      sym_system_lib_string,
    STATE(10549), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(12504), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [300446] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(10664), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12512), 1,
      sym_identifier,
    ACTIONS(12514), 1,
      anon_sym_template,
    STATE(3355), 1,
      sym_dependent_type_identifier,
    STATE(3365), 1,
      sym_template_type,
    STATE(3383), 1,
      sym_qualified_type_identifier,
    STATE(8046), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [300477] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12516), 1,
      sym_identifier,
    STATE(6901), 1,
      sym__scope_resolution,
    STATE(10760), 1,
      sym_qualified_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [300504] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    STATE(3505), 1,
      sym_template_argument_list,
    ACTIONS(6590), 2,
      anon_sym_COLON,
      anon_sym_LBRACK,
    ACTIONS(6165), 4,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [300527] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12518), 1,
      anon_sym_COMMA,
    STATE(8049), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11444), 7,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [300546] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(11168), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12521), 1,
      sym_identifier,
    ACTIONS(12523), 1,
      anon_sym_template,
    STATE(242), 1,
      sym_template_type,
    STATE(248), 1,
      sym_qualified_type_identifier,
    STATE(262), 1,
      sym_dependent_type_identifier,
    STATE(8050), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [300577] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10518), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(10277), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [300596] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6236), 1,
      anon_sym_AMP,
    ACTIONS(6238), 2,
      anon_sym_if,
      anon_sym_for,
    ACTIONS(6234), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [300615] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8193), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(10674), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [300634] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8193), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(9512), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [300653] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      sym_identifier,
    ACTIONS(12527), 1,
      sym_system_lib_string,
    STATE(10762), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(12504), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [300674] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11684), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(10674), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [300693] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    ACTIONS(11670), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [300720] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11971), 1,
      anon_sym_where,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(10966), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [300739] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12529), 1,
      anon_sym_where,
    STATE(7168), 1,
      sym_where_clause,
    ACTIONS(11490), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [300758] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8193), 1,
      anon_sym_where,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(10966), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [300777] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(10384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12532), 1,
      sym_identifier,
    ACTIONS(12534), 1,
      anon_sym_template,
    STATE(196), 1,
      sym_template_type,
    STATE(197), 1,
      sym_dependent_type_identifier,
    STATE(2791), 1,
      sym_qualified_type_identifier,
    STATE(8061), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [300808] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11733), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(10674), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(10676), 4,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [300829] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4083), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11331), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [300852] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(11199), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12536), 1,
      sym_identifier,
    STATE(196), 1,
      sym_template_type,
    STATE(197), 1,
      sym_dependent_type_identifier,
    STATE(2844), 1,
      sym_qualified_type_identifier,
    STATE(8064), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [300883] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(11294), 1,
      anon_sym_LBRACK,
    ACTIONS(12538), 1,
      anon_sym_COMMA,
    ACTIONS(12540), 1,
      anon_sym_EQ,
    STATE(8297), 1,
      sym_interface_requirements,
    STATE(8524), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11290), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [300910] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(7863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12542), 1,
      sym_identifier,
    ACTIONS(12544), 1,
      anon_sym_template,
    STATE(5027), 1,
      sym_template_type,
    STATE(5108), 1,
      sym_dependent_type_identifier,
    STATE(5177), 1,
      sym_qualified_type_identifier,
    STATE(8066), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [300941] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(10089), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12532), 1,
      sym_identifier,
    ACTIONS(12534), 1,
      anon_sym_template,
    STATE(196), 1,
      sym_template_type,
    STATE(197), 1,
      sym_dependent_type_identifier,
    STATE(201), 1,
      sym_qualified_type_identifier,
    STATE(8067), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [300972] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6236), 1,
      anon_sym_AMP,
    ACTIONS(6240), 2,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(6234), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [300991] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11368), 1,
      anon_sym_COLON,
    ACTIONS(12546), 1,
      anon_sym_EQ,
    STATE(8332), 1,
      sym_interface_requirements,
    ACTIONS(11444), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [301012] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(9968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12548), 1,
      sym_identifier,
    ACTIONS(12550), 1,
      anon_sym_template,
    STATE(2954), 1,
      sym_template_type,
    STATE(2958), 1,
      sym_dependent_type_identifier,
    STATE(2970), 1,
      sym_qualified_type_identifier,
    STATE(8070), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [301043] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(7815), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12552), 1,
      sym_identifier,
    ACTIONS(12554), 1,
      anon_sym_template,
    STATE(5027), 1,
      sym_template_type,
    STATE(5108), 1,
      sym_dependent_type_identifier,
    STATE(5177), 1,
      sym_qualified_type_identifier,
    STATE(8071), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [301074] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    STATE(3505), 1,
      sym_template_argument_list,
    ACTIONS(2181), 2,
      anon_sym_COLON,
      anon_sym_LBRACK,
    ACTIONS(2171), 4,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [301097] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12112), 1,
      anon_sym_COMMA,
    STATE(8049), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 7,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [301116] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12112), 1,
      anon_sym_COMMA,
    STATE(8084), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 7,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [301135] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(9836), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12556), 1,
      sym_identifier,
    ACTIONS(12558), 1,
      anon_sym_template,
    STATE(3381), 1,
      sym_template_type,
    STATE(3382), 1,
      sym_dependent_type_identifier,
    STATE(3396), 1,
      sym_qualified_type_identifier,
    STATE(8075), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [301166] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5156), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12560), 1,
      sym_identifier,
    ACTIONS(12562), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12564), 1,
      anon_sym_inline,
    STATE(821), 1,
      sym_declaration_list,
    STATE(8290), 1,
      sym_attribute_declaration,
    STATE(9770), 1,
      sym_nested_namespace_specifier,
    STATE(10327), 1,
      sym__namespace_specifier,
  [301197] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8193), 1,
      anon_sym_where,
    STATE(7168), 1,
      sym_where_clause,
    ACTIONS(11490), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [301216] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5148), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12562), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12564), 1,
      anon_sym_inline,
    ACTIONS(12566), 1,
      sym_identifier,
    STATE(1060), 1,
      sym_declaration_list,
    STATE(8238), 1,
      sym_attribute_declaration,
    STATE(10054), 1,
      sym_nested_namespace_specifier,
    STATE(10327), 1,
      sym__namespace_specifier,
  [301247] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12053), 1,
      anon_sym_COMMA,
    STATE(8101), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(11634), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [301268] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    ACTIONS(11675), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [301295] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5154), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12562), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12564), 1,
      anon_sym_inline,
    ACTIONS(12568), 1,
      sym_identifier,
    STATE(467), 1,
      sym_declaration_list,
    STATE(8347), 1,
      sym_attribute_declaration,
    STATE(9859), 1,
      sym_nested_namespace_specifier,
    STATE(10327), 1,
      sym__namespace_specifier,
  [301326] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(11221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12570), 1,
      sym_identifier,
    ACTIONS(12572), 1,
      anon_sym_template,
    STATE(1236), 1,
      sym_template_type,
    STATE(1237), 1,
      sym_dependent_type_identifier,
    STATE(1245), 1,
      sym_qualified_type_identifier,
    STATE(8082), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [301357] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12574), 1,
      sym_identifier,
    STATE(6901), 1,
      sym__scope_resolution,
    STATE(10220), 1,
      sym_qualified_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [301384] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12112), 1,
      anon_sym_COMMA,
    STATE(8049), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11440), 7,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [301403] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12576), 1,
      anon_sym_where,
    STATE(7168), 1,
      sym_where_clause,
    ACTIONS(11490), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(11492), 4,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [301424] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(10347), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12579), 1,
      sym_identifier,
    ACTIONS(12581), 1,
      anon_sym_template,
    STATE(2675), 1,
      sym_dependent_type_identifier,
    STATE(2680), 1,
      sym_template_type,
    STATE(2791), 1,
      sym_qualified_type_identifier,
    STATE(8086), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [301455] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5152), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12562), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12564), 1,
      anon_sym_inline,
    ACTIONS(12583), 1,
      sym_identifier,
    STATE(989), 1,
      sym_declaration_list,
    STATE(8242), 1,
      sym_attribute_declaration,
    STATE(9765), 1,
      sym_nested_namespace_specifier,
    STATE(10327), 1,
      sym__namespace_specifier,
  [301486] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12053), 1,
      anon_sym_COMMA,
    STATE(8041), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(11593), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [301507] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(8163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12498), 1,
      sym_identifier,
    ACTIONS(12500), 1,
      anon_sym_template,
    STATE(196), 1,
      sym_template_type,
    STATE(197), 1,
      sym_dependent_type_identifier,
    STATE(2791), 1,
      sym_qualified_type_identifier,
    STATE(8089), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [301538] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(5024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12585), 1,
      sym_identifier,
    ACTIONS(12587), 1,
      anon_sym_template,
    STATE(2675), 1,
      sym_dependent_type_identifier,
    STATE(2679), 1,
      sym_qualified_type_identifier,
    STATE(2680), 1,
      sym_template_type,
    STATE(8090), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [301569] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12589), 1,
      sym_identifier,
    ACTIONS(12591), 1,
      sym_system_lib_string,
    STATE(10298), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(12504), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [301590] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(11195), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12593), 1,
      sym_identifier,
    ACTIONS(12595), 1,
      anon_sym_template,
    STATE(505), 1,
      sym_dependent_type_identifier,
    STATE(506), 1,
      sym_template_type,
    STATE(510), 1,
      sym_qualified_type_identifier,
    STATE(8092), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [301621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12597), 1,
      anon_sym_EQ,
    ACTIONS(11699), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [301638] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12579), 1,
      sym_identifier,
    ACTIONS(12581), 1,
      anon_sym_template,
    STATE(2675), 1,
      sym_dependent_type_identifier,
    STATE(2679), 1,
      sym_qualified_type_identifier,
    STATE(2680), 1,
      sym_template_type,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [301669] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12053), 1,
      anon_sym_COMMA,
    STATE(8101), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(11593), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [301690] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(797), 1,
      sym_field_declaration_list,
    STATE(8609), 1,
      sym_virtual_specifier,
    STATE(10030), 1,
      sym_base_class_clause,
    ACTIONS(2485), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
  [301717] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4083), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11341), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [301740] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(9938), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12599), 1,
      sym_identifier,
    ACTIONS(12601), 1,
      anon_sym_template,
    STATE(4792), 1,
      sym_dependent_type_identifier,
    STATE(4796), 1,
      sym_template_type,
    STATE(4831), 1,
      sym_qualified_type_identifier,
    STATE(8098), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [301771] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12015), 1,
      anon_sym_where,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(10966), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(10968), 4,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [301792] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(679), 1,
      sym_field_declaration_list,
    STATE(8640), 1,
      sym_virtual_specifier,
    STATE(9901), 1,
      sym_base_class_clause,
    ACTIONS(2475), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(6625), 2,
      anon_sym_final,
      anon_sym_override,
  [301819] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12603), 1,
      anon_sym_COMMA,
    STATE(8101), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11444), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(11547), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [301840] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(7791), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12534), 1,
      anon_sym_template,
    ACTIONS(12606), 1,
      sym_identifier,
    STATE(196), 1,
      sym_template_type,
    STATE(197), 1,
      sym_dependent_type_identifier,
    STATE(2791), 1,
      sym_qualified_type_identifier,
    STATE(8102), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [301871] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10237), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(9512), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [301890] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(8066), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12512), 1,
      sym_identifier,
    ACTIONS(12554), 1,
      anon_sym_template,
    STATE(5027), 1,
      sym_template_type,
    STATE(5108), 1,
      sym_dependent_type_identifier,
    STATE(5177), 1,
      sym_qualified_type_identifier,
    STATE(8104), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [301921] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12608), 1,
      sym_identifier,
    STATE(6901), 1,
      sym__scope_resolution,
    STATE(10838), 1,
      sym_qualified_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [301948] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(12454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12610), 1,
      sym_identifier,
    ACTIONS(12612), 1,
      anon_sym_template,
    STATE(3619), 1,
      sym_qualified_type_identifier,
    STATE(3663), 1,
      sym_dependent_type_identifier,
    STATE(3675), 1,
      sym_template_type,
    STATE(8106), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [301979] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(10024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12614), 1,
      sym_identifier,
    ACTIONS(12616), 1,
      anon_sym_template,
    STATE(3360), 1,
      sym_template_type,
    STATE(3364), 1,
      sym_dependent_type_identifier,
    STATE(3376), 1,
      sym_qualified_type_identifier,
    STATE(8107), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [302010] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12053), 1,
      anon_sym_COMMA,
    STATE(8101), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(11627), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [302031] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    ACTIONS(11677), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [302058] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    ACTIONS(11693), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [302085] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10401), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(10062), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(10064), 4,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [302106] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12618), 1,
      sym_identifier,
    STATE(6901), 1,
      sym__scope_resolution,
    STATE(10347), 1,
      sym_qualified_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [302133] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(9875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12620), 1,
      sym_identifier,
    ACTIONS(12622), 1,
      anon_sym_template,
    STATE(2844), 1,
      sym_qualified_type_identifier,
    STATE(2859), 1,
      sym_dependent_type_identifier,
    STATE(2861), 1,
      sym_template_type,
    STATE(8113), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [302164] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12624), 1,
      sym_identifier,
    STATE(6901), 1,
      sym__scope_resolution,
    STATE(10170), 1,
      sym_qualified_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [302191] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(9895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12626), 1,
      sym_identifier,
    ACTIONS(12628), 1,
      anon_sym_template,
    STATE(3355), 1,
      sym_dependent_type_identifier,
    STATE(3365), 1,
      sym_template_type,
    STATE(3383), 1,
      sym_qualified_type_identifier,
    STATE(8115), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [302222] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12630), 1,
      sym_identifier,
    STATE(6901), 1,
      sym__scope_resolution,
    STATE(10652), 1,
      sym_qualified_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [302249] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(10146), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12632), 1,
      sym_identifier,
    ACTIONS(12634), 1,
      anon_sym_template,
    STATE(322), 1,
      sym_template_type,
    STATE(325), 1,
      sym_dependent_type_identifier,
    STATE(326), 1,
      sym_qualified_type_identifier,
    STATE(8117), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [302280] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10229), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(9512), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(9514), 4,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [302301] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(10626), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12636), 1,
      sym_identifier,
    ACTIONS(12638), 1,
      anon_sym_template,
    STATE(2602), 1,
      sym_template_type,
    STATE(2611), 1,
      sym_qualified_type_identifier,
    STATE(2614), 1,
      sym_dependent_type_identifier,
    STATE(8119), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [302332] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(7855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12544), 1,
      anon_sym_template,
    ACTIONS(12640), 1,
      sym_identifier,
    STATE(5027), 1,
      sym_template_type,
    STATE(5108), 1,
      sym_dependent_type_identifier,
    STATE(5177), 1,
      sym_qualified_type_identifier,
    STATE(8120), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [302363] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6789), 1,
      anon_sym_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    STATE(3131), 1,
      sym_parameter_list,
    STATE(7757), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(12642), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [302388] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5148), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12562), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12564), 1,
      anon_sym_inline,
    ACTIONS(12644), 1,
      sym_identifier,
    STATE(1029), 1,
      sym_declaration_list,
    STATE(8339), 1,
      sym_attribute_declaration,
    STATE(9798), 1,
      sym_nested_namespace_specifier,
    STATE(10327), 1,
      sym__namespace_specifier,
  [302419] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5156), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12562), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12564), 1,
      anon_sym_inline,
    ACTIONS(12646), 1,
      sym_identifier,
    STATE(959), 1,
      sym_declaration_list,
    STATE(8341), 1,
      sym_attribute_declaration,
    STATE(10014), 1,
      sym_nested_namespace_specifier,
    STATE(10327), 1,
      sym__namespace_specifier,
  [302450] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12053), 1,
      anon_sym_COMMA,
    STATE(8095), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(11634), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [302471] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11368), 1,
      anon_sym_COLON,
    ACTIONS(12648), 1,
      anon_sym_EQ,
    STATE(8295), 1,
      sym_interface_requirements,
    ACTIONS(11444), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_try,
  [302492] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(7677), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12622), 1,
      anon_sym_template,
    ACTIONS(12651), 1,
      sym_identifier,
    STATE(2844), 1,
      sym_qualified_type_identifier,
    STATE(2859), 1,
      sym_dependent_type_identifier,
    STATE(2861), 1,
      sym_template_type,
    STATE(8126), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [302523] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(11234), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12536), 1,
      sym_identifier,
    STATE(196), 1,
      sym_template_type,
    STATE(197), 1,
      sym_dependent_type_identifier,
    STATE(201), 1,
      sym_qualified_type_identifier,
    STATE(8127), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [302554] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10524), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(10277), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(10279), 4,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [302575] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5154), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12562), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12564), 1,
      anon_sym_inline,
    ACTIONS(12653), 1,
      sym_identifier,
    STATE(522), 1,
      sym_declaration_list,
    STATE(8308), 1,
      sym_attribute_declaration,
    STATE(9830), 1,
      sym_nested_namespace_specifier,
    STATE(10327), 1,
      sym__namespace_specifier,
  [302606] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4083), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11335), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [302629] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5152), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12562), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12564), 1,
      anon_sym_inline,
    ACTIONS(12655), 1,
      sym_identifier,
    STATE(863), 1,
      sym_declaration_list,
    STATE(8359), 1,
      sym_attribute_declaration,
    STATE(9874), 1,
      sym_nested_namespace_specifier,
    STATE(10327), 1,
      sym__namespace_specifier,
  [302660] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(10130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12534), 1,
      anon_sym_template,
    ACTIONS(12606), 1,
      sym_identifier,
    STATE(196), 1,
      sym_template_type,
    STATE(197), 1,
      sym_dependent_type_identifier,
    STATE(201), 1,
      sym_qualified_type_identifier,
    STATE(8132), 1,
      sym__scope_resolution,
    STATE(10765), 1,
      sym_decltype,
  [302691] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4083), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11376), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [302714] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1578), 1,
      anon_sym_template,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12657), 1,
      sym_identifier,
    STATE(6901), 1,
      sym__scope_resolution,
    STATE(10769), 1,
      sym_qualified_identifier,
    STATE(10765), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [302741] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4083), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11280), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [302764] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4083), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11286), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [302787] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12659), 1,
      anon_sym_EQ,
    ACTIONS(11699), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(11701), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [302806] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    ACTIONS(11722), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [302833] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4083), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11333), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [302856] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4302), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11335), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
  [302878] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(12661), 1,
      anon_sym_SEMI,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [302904] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(12663), 1,
      anon_sym_SEMI,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [302930] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12667), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(12669), 1,
      anon_sym_EQ,
    ACTIONS(12665), 6,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [302948] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11286), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [302970] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(12671), 1,
      anon_sym_SEMI,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [302996] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    ACTIONS(12049), 1,
      anon_sym_COLON,
    STATE(4541), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    STATE(9055), 1,
      sym_semantics,
    ACTIONS(12047), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [303022] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11368), 1,
      anon_sym_COLON,
    ACTIONS(12673), 1,
      anon_sym_COMMA,
    ACTIONS(12675), 1,
      anon_sym_EQ,
    STATE(8312), 1,
      sym_interface_requirements,
    STATE(8315), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11290), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      sym_identifier,
  [303046] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8299), 1,
      anon_sym_where,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(10966), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [303064] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11368), 1,
      anon_sym_COLON,
    ACTIONS(12677), 1,
      anon_sym_COMMA,
    ACTIONS(12679), 1,
      anon_sym_EQ,
    STATE(8322), 1,
      sym_interface_requirements,
    STATE(8378), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11290), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [303088] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11801), 1,
      anon_sym_LBRACK,
    STATE(7754), 1,
      sym_parameter_list,
    ACTIONS(6783), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(8275), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [303112] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11677), 1,
      anon_sym_COLON,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    STATE(7572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [303138] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    ACTIONS(12681), 1,
      anon_sym_SEMI,
    ACTIONS(12683), 1,
      anon_sym_EQ,
    STATE(2816), 1,
      sym_template_argument_list,
    STATE(8868), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [303164] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10586), 1,
      anon_sym_LBRACK,
    ACTIONS(11896), 1,
      anon_sym_RPAREN,
    STATE(4588), 1,
      sym_parameter_list,
    STATE(7787), 1,
      sym__function_declarator_seq,
    STATE(8512), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [303190] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8295), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      sym_identifier,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(9512), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [303210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12687), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(12685), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [303226] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12461), 1,
      anon_sym_COMMA,
    STATE(8163), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11440), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [303244] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    ACTIONS(12689), 1,
      anon_sym_SEMI,
    ACTIONS(12691), 1,
      anon_sym_EQ,
    STATE(2816), 1,
      sym_template_argument_list,
    STATE(8726), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [303270] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(12693), 1,
      anon_sym_COLON,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    STATE(7572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [303296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12461), 1,
      anon_sym_COMMA,
    STATE(8156), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [303314] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10586), 1,
      anon_sym_LBRACK,
    ACTIONS(11898), 1,
      anon_sym_RPAREN,
    STATE(4588), 1,
      sym_parameter_list,
    STATE(7787), 1,
      sym__function_declarator_seq,
    STATE(8512), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [303340] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(11547), 1,
      anon_sym_LBRACK,
    ACTIONS(12695), 1,
      anon_sym_EQ,
    STATE(8374), 1,
      sym_interface_requirements,
    ACTIONS(11444), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [303362] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12461), 1,
      anon_sym_COMMA,
    STATE(8163), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [303380] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12697), 1,
      anon_sym_COMMA,
    STATE(8163), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11444), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [303398] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(12700), 1,
      anon_sym_RPAREN,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [303424] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12702), 1,
      sym_identifier,
    ACTIONS(12707), 1,
      aux_sym_preproc_elif_token1,
    STATE(8165), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    ACTIONS(12705), 4,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [303444] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11693), 1,
      anon_sym_COLON,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    STATE(7572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [303470] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(12709), 1,
      anon_sym_RPAREN,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [303496] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12461), 1,
      anon_sym_COMMA,
    STATE(8163), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [303514] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11801), 1,
      anon_sym_LBRACK,
    STATE(7754), 1,
      sym_parameter_list,
    ACTIONS(6804), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(8275), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [303538] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11801), 1,
      anon_sym_LBRACK,
    STATE(7754), 1,
      sym_parameter_list,
    ACTIONS(6796), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(8275), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [303562] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11675), 1,
      anon_sym_COLON,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    STATE(7572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [303588] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11333), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [303610] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12711), 1,
      sym_identifier,
    ACTIONS(12716), 1,
      aux_sym_preproc_elif_token1,
    STATE(8173), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(10290), 1,
      sym_enumerator,
    ACTIONS(12714), 4,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [303632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12720), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(12718), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [303648] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12461), 1,
      anon_sym_COMMA,
    STATE(8162), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [303666] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11280), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [303688] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11341), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [303710] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    ACTIONS(12722), 1,
      anon_sym_SEMI,
    ACTIONS(12724), 1,
      anon_sym_EQ,
    STATE(2816), 1,
      sym_template_argument_list,
    STATE(8661), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [303736] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8295), 1,
      anon_sym_where,
    ACTIONS(11492), 1,
      sym_identifier,
    STATE(7168), 1,
      sym_where_clause,
    ACTIONS(11490), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [303756] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10586), 1,
      anon_sym_LBRACK,
    ACTIONS(12726), 1,
      anon_sym_RPAREN,
    STATE(4588), 1,
      sym_parameter_list,
    STATE(7787), 1,
      sym__function_declarator_seq,
    STATE(8512), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [303782] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11722), 1,
      anon_sym_COLON,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    STATE(7572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [303808] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11376), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [303830] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8295), 1,
      anon_sym_where,
    ACTIONS(10968), 1,
      sym_identifier,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(10966), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [303850] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10586), 1,
      anon_sym_LBRACK,
    ACTIONS(12728), 1,
      anon_sym_RPAREN,
    STATE(4588), 1,
      sym_parameter_list,
    STATE(7787), 1,
      sym__function_declarator_seq,
    STATE(8512), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [303876] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(11670), 1,
      anon_sym_COLON,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    STATE(7572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [303902] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    ACTIONS(12730), 1,
      anon_sym_SEMI,
    ACTIONS(12732), 1,
      anon_sym_EQ,
    STATE(2816), 1,
      sym_template_argument_list,
    STATE(8908), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [303928] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11368), 1,
      anon_sym_COLON,
    ACTIONS(12734), 1,
      anon_sym_COMMA,
    ACTIONS(12736), 1,
      anon_sym_EQ,
    STATE(8246), 1,
      sym_interface_requirements,
    STATE(8448), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11290), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [303952] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11368), 1,
      anon_sym_COLON,
    ACTIONS(12738), 1,
      anon_sym_COMMA,
    ACTIONS(12740), 1,
      anon_sym_EQ,
    STATE(8482), 1,
      sym_interface_requirements,
    STATE(8551), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11290), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      sym_identifier,
  [303976] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11368), 1,
      anon_sym_COLON,
    ACTIONS(12742), 1,
      anon_sym_COMMA,
    ACTIONS(12744), 1,
      anon_sym_EQ,
    STATE(8507), 1,
      sym_interface_requirements,
    STATE(8598), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11290), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [304000] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11801), 1,
      anon_sym_LBRACK,
    STATE(7754), 1,
      sym_parameter_list,
    ACTIONS(6800), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(8275), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [304024] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12461), 1,
      anon_sym_COMMA,
    STATE(8163), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [304042] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(12746), 1,
      anon_sym_SEMI,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [304068] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4302), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11376), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
  [304090] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12461), 1,
      anon_sym_COMMA,
    ACTIONS(12748), 1,
      anon_sym_EQ,
    STATE(8168), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_try,
  [304110] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8299), 1,
      anon_sym_where,
    STATE(7168), 1,
      sym_where_clause,
    ACTIONS(11490), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [304128] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4302), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11337), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
  [304150] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4302), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11280), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
  [304172] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4302), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11286), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
  [304194] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4302), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11331), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
  [304216] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4302), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11333), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
  [304238] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11337), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [304260] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4302), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11341), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
  [304282] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8299), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(10674), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [304300] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8295), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      sym_identifier,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(10062), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [304320] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    ACTIONS(6590), 1,
      anon_sym_LBRACK,
    STATE(7603), 1,
      sym_template_argument_list,
    ACTIONS(6165), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [304342] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8295), 1,
      anon_sym_where,
    ACTIONS(10676), 1,
      sym_identifier,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(10674), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [304362] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    ACTIONS(12750), 1,
      anon_sym_SEMI,
    ACTIONS(12752), 1,
      anon_sym_EQ,
    STATE(2816), 1,
      sym_template_argument_list,
    STATE(8799), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [304388] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(12754), 1,
      anon_sym_SEMI,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [304414] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11801), 1,
      anon_sym_LBRACK,
    STATE(7754), 1,
      sym_parameter_list,
    ACTIONS(6808), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(8275), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [304438] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8299), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(9512), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [304456] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(12756), 1,
      anon_sym_SEMI,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [304482] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12424), 1,
      anon_sym_COMMA,
    ACTIONS(12758), 1,
      anon_sym_EQ,
    STATE(8324), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [304502] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4083), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(12760), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [304524] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11331), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [304546] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8295), 1,
      anon_sym_where,
    ACTIONS(10279), 1,
      sym_identifier,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(10277), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [304566] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12430), 1,
      anon_sym_LBRACK,
    STATE(9110), 1,
      sym_gnu_asm_output_operand,
    STATE(10505), 1,
      sym_string_literal,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [304586] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    ACTIONS(12762), 1,
      anon_sym_SEMI,
    ACTIONS(12764), 1,
      anon_sym_EQ,
    STATE(2816), 1,
      sym_template_argument_list,
    STATE(8793), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [304612] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10586), 1,
      anon_sym_LBRACK,
    ACTIONS(11862), 1,
      anon_sym_RPAREN,
    STATE(4588), 1,
      sym_parameter_list,
    STATE(7787), 1,
      sym__function_declarator_seq,
    STATE(8512), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [304638] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11335), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [304660] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(12766), 1,
      anon_sym_SEMI,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [304686] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8299), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(10277), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [304704] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10586), 1,
      anon_sym_LBRACK,
    ACTIONS(11825), 1,
      anon_sym_RPAREN,
    STATE(4588), 1,
      sym_parameter_list,
    STATE(7787), 1,
      sym__function_declarator_seq,
    STATE(8512), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [304730] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(10586), 1,
      anon_sym_LBRACK,
    ACTIONS(11830), 1,
      anon_sym_RPAREN,
    STATE(4588), 1,
      sym_parameter_list,
    STATE(7787), 1,
      sym__function_declarator_seq,
    STATE(8512), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [304756] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12484), 1,
      anon_sym_LBRACK,
    STATE(9586), 1,
      sym_gnu_asm_input_operand,
    STATE(10188), 1,
      sym_string_literal,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [304776] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8299), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(10062), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [304794] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 1,
      anon_sym_LT,
    ACTIONS(6996), 1,
      anon_sym_LBRACK,
    STATE(3505), 1,
      sym_template_argument_list,
    ACTIONS(6998), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [304814] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    ACTIONS(12049), 1,
      anon_sym_COLON,
    STATE(4478), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    STATE(9055), 1,
      sym_semantics,
    ACTIONS(12047), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [304840] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    ACTIONS(12768), 1,
      anon_sym_SEMI,
    ACTIONS(12770), 1,
      anon_sym_EQ,
    STATE(2816), 1,
      sym_template_argument_list,
    STATE(8828), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [304866] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    ACTIONS(12772), 1,
      anon_sym_SEMI,
    STATE(3748), 1,
      sym_parameter_list,
    STATE(7960), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [304892] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2181), 1,
      anon_sym_LBRACK,
    ACTIONS(3487), 1,
      anon_sym_LT,
    STATE(7603), 1,
      sym_template_argument_list,
    ACTIONS(2171), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [304914] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8468), 1,
      anon_sym_where,
    ACTIONS(10968), 1,
      anon_sym_LBRACK,
    STATE(7172), 1,
      sym_where_clause,
    ACTIONS(10966), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [304933] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(12774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12776), 1,
      anon_sym_EQ,
    ACTIONS(12778), 1,
      anon_sym_GT2,
    STATE(8910), 1,
      sym_interface_requirements,
    STATE(9064), 1,
      aux_sym_template_argument_list_repeat1,
  [304958] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6236), 1,
      anon_sym_AMP,
    ACTIONS(6234), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [304973] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12782), 1,
      anon_sym_COMMA,
    ACTIONS(12784), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(12780), 5,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [304990] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12424), 1,
      anon_sym_COMMA,
    STATE(8352), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [305007] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6789), 1,
      anon_sym_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(12786), 1,
      anon_sym_RPAREN,
    STATE(3131), 1,
      sym_parameter_list,
    STATE(7757), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [305030] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6789), 1,
      anon_sym_LBRACK,
    ACTIONS(6808), 1,
      anon_sym_COLON,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    STATE(3131), 1,
      sym_parameter_list,
    STATE(8361), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [305053] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5148), 1,
      anon_sym_LBRACE,
    ACTIONS(12562), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12564), 1,
      anon_sym_inline,
    ACTIONS(12788), 1,
      sym_identifier,
    STATE(1012), 1,
      sym_declaration_list,
    STATE(10056), 1,
      sym_nested_namespace_specifier,
    STATE(10327), 1,
      sym__namespace_specifier,
  [305078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12792), 1,
      anon_sym_AMP,
    ACTIONS(12790), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [305093] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(12774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12794), 1,
      anon_sym_EQ,
    ACTIONS(12796), 1,
      anon_sym_GT2,
    STATE(8606), 1,
      sym_interface_requirements,
    STATE(8944), 1,
      aux_sym_template_argument_list_repeat1,
  [305118] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(12774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12798), 1,
      anon_sym_EQ,
    ACTIONS(12800), 1,
      anon_sym_GT2,
    STATE(8637), 1,
      sym_interface_requirements,
    STATE(9169), 1,
      aux_sym_template_argument_list_repeat1,
  [305143] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5152), 1,
      anon_sym_LBRACE,
    ACTIONS(12562), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12564), 1,
      anon_sym_inline,
    ACTIONS(12802), 1,
      sym_identifier,
    STATE(962), 1,
      sym_declaration_list,
    STATE(9679), 1,
      sym_nested_namespace_specifier,
    STATE(10327), 1,
      sym__namespace_specifier,
  [305168] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(12774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12804), 1,
      anon_sym_EQ,
    ACTIONS(12806), 1,
      anon_sym_GT2,
    STATE(8678), 1,
      sym_interface_requirements,
    STATE(9445), 1,
      aux_sym_template_argument_list_repeat1,
  [305193] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(12774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12808), 1,
      anon_sym_EQ,
    ACTIONS(12810), 1,
      anon_sym_GT2,
    STATE(8687), 1,
      sym_interface_requirements,
    STATE(9497), 1,
      aux_sym_template_argument_list_repeat1,
  [305218] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8468), 1,
      anon_sym_where,
    ACTIONS(10279), 1,
      anon_sym_LBRACK,
    STATE(7240), 1,
      sym_where_clause,
    ACTIONS(10277), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [305237] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12734), 1,
      anon_sym_COMMA,
    ACTIONS(12812), 1,
      anon_sym_EQ,
    STATE(8465), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 4,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [305256] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4541), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11376), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [305277] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8393), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(9512), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [305294] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4541), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11337), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [305315] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6789), 1,
      anon_sym_LBRACK,
    ACTIONS(6800), 1,
      anon_sym_COLON,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    STATE(3131), 1,
      sym_parameter_list,
    STATE(8361), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [305338] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(12774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12814), 1,
      anon_sym_EQ,
    ACTIONS(12816), 1,
      anon_sym_GT2,
    STATE(8717), 1,
      sym_interface_requirements,
    STATE(9618), 1,
      aux_sym_template_argument_list_repeat1,
  [305363] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6789), 1,
      anon_sym_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(12818), 1,
      anon_sym_RPAREN,
    STATE(3131), 1,
      sym_parameter_list,
    STATE(7757), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [305386] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(12774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12820), 1,
      anon_sym_EQ,
    ACTIONS(12822), 1,
      anon_sym_GT2,
    STATE(8707), 1,
      sym_interface_requirements,
    STATE(9592), 1,
      aux_sym_template_argument_list_repeat1,
  [305411] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12824), 1,
      anon_sym_LBRACK,
    ACTIONS(12826), 1,
      anon_sym_EQ,
    ACTIONS(12828), 1,
      anon_sym_DOT,
    STATE(8331), 4,
      sym_subscript_designator,
      sym_subscript_range_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
  [305430] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6789), 1,
      anon_sym_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(12830), 1,
      anon_sym_RPAREN,
    STATE(3131), 1,
      sym_parameter_list,
    STATE(7757), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [305453] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6783), 1,
      anon_sym_COLON,
    ACTIONS(6789), 1,
      anon_sym_LBRACK,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    STATE(3131), 1,
      sym_parameter_list,
    STATE(8361), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [305476] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(12774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12832), 1,
      anon_sym_EQ,
    ACTIONS(12834), 1,
      anon_sym_GT2,
    STATE(8751), 1,
      sym_interface_requirements,
    STATE(9505), 1,
      aux_sym_template_argument_list_repeat1,
  [305501] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4478), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11341), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_GT2,
  [305522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6211), 1,
      anon_sym_AMP,
    ACTIONS(6213), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [305537] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(4588), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11341), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
  [305558] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4478), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11331), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_GT2,
  [305579] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(12774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12836), 1,
      anon_sym_EQ,
    ACTIONS(12838), 1,
      anon_sym_GT2,
    STATE(8884), 1,
      sym_interface_requirements,
    STATE(9155), 1,
      aux_sym_template_argument_list_repeat1,
  [305604] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12424), 1,
      anon_sym_COMMA,
    STATE(8352), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11440), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [305621] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4478), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11335), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_GT2,
  [305642] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4541), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11333), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [305663] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4478), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11337), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_GT2,
  [305684] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(12774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12840), 1,
      anon_sym_EQ,
    ACTIONS(12842), 1,
      anon_sym_GT2,
    STATE(8781), 1,
      sym_interface_requirements,
    STATE(9416), 1,
      aux_sym_template_argument_list_repeat1,
  [305709] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12844), 1,
      anon_sym_COMMA,
    STATE(8268), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11444), 5,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      sym_identifier,
  [305726] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8385), 1,
      anon_sym_where,
    STATE(7168), 1,
      sym_where_clause,
    ACTIONS(11490), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [305743] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8393), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(10062), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [305760] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(12774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12847), 1,
      anon_sym_EQ,
    ACTIONS(12849), 1,
      anon_sym_GT2,
    STATE(8615), 1,
      sym_interface_requirements,
    STATE(9040), 1,
      aux_sym_template_argument_list_repeat1,
  [305785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6215), 1,
      anon_sym_AMP,
    ACTIONS(6217), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [305800] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(12774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12851), 1,
      anon_sym_EQ,
    ACTIONS(12853), 1,
      anon_sym_GT2,
    STATE(8677), 1,
      sym_interface_requirements,
    STATE(9453), 1,
      aux_sym_template_argument_list_repeat1,
  [305825] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12424), 1,
      anon_sym_COMMA,
    STATE(8329), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [305842] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6855), 1,
      anon_sym_LBRACK,
    STATE(7619), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6857), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [305861] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(12774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12855), 1,
      anon_sym_EQ,
    ACTIONS(12857), 1,
      anon_sym_GT2,
    STATE(8808), 1,
      sym_interface_requirements,
    STATE(9361), 1,
      aux_sym_template_argument_list_repeat1,
  [305886] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(4588), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11333), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
  [305907] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(12774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12859), 1,
      anon_sym_EQ,
    ACTIONS(12861), 1,
      anon_sym_GT2,
    STATE(8831), 1,
      sym_interface_requirements,
    STATE(9290), 1,
      aux_sym_template_argument_list_repeat1,
  [305932] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11396), 1,
      anon_sym_LBRACK,
    STATE(3514), 1,
      sym_parameter_list,
    STATE(7621), 1,
      sym__function_declarator_seq,
    STATE(8002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [305955] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11480), 1,
      anon_sym_COLON,
    ACTIONS(12863), 1,
      anon_sym_EQ,
    STATE(8492), 1,
      sym_interface_requirements,
    ACTIONS(11444), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [305974] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(12774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12865), 1,
      anon_sym_EQ,
    ACTIONS(12867), 1,
      anon_sym_GT2,
    STATE(8861), 1,
      sym_interface_requirements,
    STATE(9199), 1,
      aux_sym_template_argument_list_repeat1,
  [305999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12871), 1,
      anon_sym_AMP,
    ACTIONS(12869), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [306014] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6789), 1,
      anon_sym_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(12873), 1,
      anon_sym_RPAREN,
    STATE(3131), 1,
      sym_parameter_list,
    STATE(7757), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [306037] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6789), 1,
      anon_sym_LBRACK,
    ACTIONS(6804), 1,
      anon_sym_COLON,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    STATE(3131), 1,
      sym_parameter_list,
    STATE(8361), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [306060] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8468), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      anon_sym_LBRACK,
    STATE(7152), 1,
      sym_where_clause,
    ACTIONS(10062), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [306079] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(4588), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11331), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
  [306100] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(12774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12875), 1,
      anon_sym_EQ,
    ACTIONS(12877), 1,
      anon_sym_GT2,
    STATE(8853), 1,
      sym_interface_requirements,
    STATE(9222), 1,
      aux_sym_template_argument_list_repeat1,
  [306125] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(12774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12879), 1,
      anon_sym_EQ,
    ACTIONS(12881), 1,
      anon_sym_GT2,
    STATE(8894), 1,
      sym_interface_requirements,
    STATE(9101), 1,
      aux_sym_template_argument_list_repeat1,
  [306150] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(4588), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11286), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
  [306171] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5156), 1,
      anon_sym_LBRACE,
    ACTIONS(12562), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12564), 1,
      anon_sym_inline,
    ACTIONS(12883), 1,
      sym_identifier,
    STATE(936), 1,
      sym_declaration_list,
    STATE(10067), 1,
      sym_nested_namespace_specifier,
    STATE(10327), 1,
      sym__namespace_specifier,
  [306196] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(4588), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11280), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
  [306217] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(12774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12885), 1,
      anon_sym_EQ,
    ACTIONS(12887), 1,
      anon_sym_GT2,
    STATE(8849), 1,
      sym_interface_requirements,
    STATE(9240), 1,
      aux_sym_template_argument_list_repeat1,
  [306242] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8393), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(10277), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [306259] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(12774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12889), 1,
      anon_sym_EQ,
    ACTIONS(12891), 1,
      anon_sym_GT2,
    STATE(8875), 1,
      sym_interface_requirements,
    STATE(9161), 1,
      aux_sym_template_argument_list_repeat1,
  [306284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12893), 1,
      anon_sym_EQ,
    ACTIONS(11699), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_try,
  [306299] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(4588), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11335), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
  [306320] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11627), 1,
      anon_sym_LBRACK,
    ACTIONS(12538), 1,
      anon_sym_COMMA,
    ACTIONS(12896), 1,
      anon_sym_EQ,
    STATE(8497), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [306341] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(12774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12898), 1,
      anon_sym_EQ,
    ACTIONS(12900), 1,
      anon_sym_GT2,
    STATE(8746), 1,
      sym_interface_requirements,
    STATE(9523), 1,
      aux_sym_template_argument_list_repeat1,
  [306366] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8393), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(10674), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [306383] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(4588), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11337), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
  [306404] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(12774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12902), 1,
      anon_sym_EQ,
    ACTIONS(12904), 1,
      anon_sym_GT2,
    STATE(8897), 1,
      sym_interface_requirements,
    STATE(9096), 1,
      aux_sym_template_argument_list_repeat1,
  [306429] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11282), 1,
      anon_sym_LBRACK,
    STATE(4588), 1,
      sym_parameter_list,
    STATE(7227), 1,
      sym__function_declarator_seq,
    ACTIONS(11376), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
  [306450] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8393), 1,
      anon_sym_where,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(10966), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [306467] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8385), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(10674), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [306484] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4541), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11331), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [306505] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(12774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12906), 1,
      anon_sym_EQ,
    ACTIONS(12908), 1,
      anon_sym_GT2,
    STATE(8919), 1,
      sym_interface_requirements,
    STATE(9044), 1,
      aux_sym_template_argument_list_repeat1,
  [306530] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4478), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11333), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_GT2,
  [306551] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5154), 1,
      anon_sym_LBRACE,
    ACTIONS(12562), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12564), 1,
      anon_sym_inline,
    ACTIONS(12568), 1,
      sym_identifier,
    STATE(467), 1,
      sym_declaration_list,
    STATE(9859), 1,
      sym_nested_namespace_specifier,
    STATE(10327), 1,
      sym__namespace_specifier,
  [306576] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(12774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12910), 1,
      anon_sym_EQ,
    ACTIONS(12912), 1,
      anon_sym_GT2,
    STATE(8933), 1,
      sym_interface_requirements,
    STATE(8948), 1,
      aux_sym_template_argument_list_repeat1,
  [306601] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4478), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11286), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_GT2,
  [306622] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8385), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(10277), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [306639] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COMMA,
    ACTIONS(12914), 1,
      anon_sym_EQ,
    STATE(8338), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 4,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      sym_identifier,
  [306658] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12424), 1,
      anon_sym_COMMA,
    STATE(8263), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [306675] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11368), 1,
      anon_sym_COLON,
    ACTIONS(12916), 1,
      anon_sym_EQ,
    STATE(8550), 1,
      sym_interface_requirements,
    ACTIONS(11444), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [306694] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COMMA,
    STATE(8268), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 5,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      sym_identifier,
  [306711] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4478), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11280), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_GT2,
  [306732] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8385), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(10062), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [306749] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8468), 1,
      anon_sym_where,
    ACTIONS(11492), 1,
      anon_sym_LBRACK,
    STATE(7170), 1,
      sym_where_clause,
    ACTIONS(11490), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [306768] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8385), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(9512), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [306785] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8468), 1,
      anon_sym_where,
    ACTIONS(10676), 1,
      anon_sym_LBRACK,
    STATE(7187), 1,
      sym_where_clause,
    ACTIONS(10674), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [306804] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11480), 1,
      anon_sym_COLON,
    ACTIONS(12918), 1,
      anon_sym_EQ,
    STATE(8389), 1,
      sym_interface_requirements,
    ACTIONS(11444), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [306823] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12677), 1,
      anon_sym_COMMA,
    ACTIONS(12920), 1,
      anon_sym_EQ,
    STATE(8414), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 4,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [306842] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11368), 1,
      anon_sym_COLON,
    ACTIONS(12922), 1,
      anon_sym_EQ,
    STATE(8599), 1,
      sym_interface_requirements,
    ACTIONS(11444), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      sym_identifier,
  [306861] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12424), 1,
      anon_sym_COMMA,
    STATE(8352), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [306878] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(12774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12924), 1,
      anon_sym_EQ,
    ACTIONS(12926), 1,
      anon_sym_GT2,
    STATE(8935), 1,
      sym_interface_requirements,
    STATE(8966), 1,
      aux_sym_template_argument_list_repeat1,
  [306903] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6789), 1,
      anon_sym_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(12928), 1,
      anon_sym_RPAREN,
    STATE(3131), 1,
      sym_parameter_list,
    STATE(7757), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [306926] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4478), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11376), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_GT2,
  [306947] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    ACTIONS(4930), 1,
      anon_sym_LBRACE,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    STATE(3186), 1,
      sym_template_argument_list,
    STATE(9598), 2,
      sym_argument_list,
      sym_initializer_list,
  [306970] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12424), 1,
      anon_sym_COMMA,
    STATE(8352), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [306987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6219), 1,
      anon_sym_AMP,
    ACTIONS(6221), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [307002] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12930), 1,
      anon_sym_LBRACK,
    ACTIONS(12933), 1,
      anon_sym_EQ,
    ACTIONS(12935), 1,
      anon_sym_DOT,
    STATE(8331), 4,
      sym_subscript_designator,
      sym_subscript_range_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
  [307021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12938), 1,
      anon_sym_EQ,
    ACTIONS(11699), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [307036] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COMMA,
    STATE(8346), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 5,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      sym_identifier,
  [307053] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(12774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12940), 1,
      anon_sym_EQ,
    ACTIONS(12942), 1,
      anon_sym_GT2,
    STATE(8814), 1,
      sym_interface_requirements,
    STATE(9333), 1,
      aux_sym_template_argument_list_repeat1,
  [307078] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8393), 1,
      anon_sym_where,
    STATE(7168), 1,
      sym_where_clause,
    ACTIONS(11490), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [307095] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11480), 1,
      anon_sym_COLON,
    ACTIONS(12944), 1,
      anon_sym_EQ,
    STATE(8522), 1,
      sym_interface_requirements,
    ACTIONS(11444), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      sym_identifier,
  [307114] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4541), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11335), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [307135] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COMMA,
    STATE(8268), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 5,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      sym_identifier,
  [307152] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5148), 1,
      anon_sym_LBRACE,
    ACTIONS(12562), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12564), 1,
      anon_sym_inline,
    ACTIONS(12566), 1,
      sym_identifier,
    STATE(1060), 1,
      sym_declaration_list,
    STATE(10054), 1,
      sym_nested_namespace_specifier,
    STATE(10327), 1,
      sym__namespace_specifier,
  [307177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5658), 1,
      anon_sym_AMP,
    ACTIONS(5656), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [307192] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5156), 1,
      anon_sym_LBRACE,
    ACTIONS(12560), 1,
      sym_identifier,
    ACTIONS(12562), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12564), 1,
      anon_sym_inline,
    STATE(821), 1,
      sym_declaration_list,
    STATE(9770), 1,
      sym_nested_namespace_specifier,
    STATE(10327), 1,
      sym__namespace_specifier,
  [307217] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(12774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12947), 1,
      anon_sym_EQ,
    ACTIONS(12949), 1,
      anon_sym_GT2,
    STATE(8930), 1,
      sym_interface_requirements,
    STATE(8996), 1,
      aux_sym_template_argument_list_repeat1,
  [307242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12953), 1,
      anon_sym_AMP,
    ACTIONS(12951), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [307257] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4541), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11341), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [307278] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6789), 1,
      anon_sym_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(12955), 1,
      anon_sym_RPAREN,
    STATE(3131), 1,
      sym_parameter_list,
    STATE(7757), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [307301] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COMMA,
    STATE(8268), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 5,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      sym_identifier,
  [307318] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5154), 1,
      anon_sym_LBRACE,
    ACTIONS(12562), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12564), 1,
      anon_sym_inline,
    ACTIONS(12957), 1,
      sym_identifier,
    STATE(485), 1,
      sym_declaration_list,
    STATE(9959), 1,
      sym_nested_namespace_specifier,
    STATE(10327), 1,
      sym__namespace_specifier,
  [307343] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COMMA,
    STATE(8357), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 5,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      sym_identifier,
  [307360] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4541), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11280), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [307381] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6789), 1,
      anon_sym_LBRACK,
    ACTIONS(6796), 1,
      anon_sym_COLON,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    STATE(3131), 1,
      sym_parameter_list,
    STATE(8361), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [307404] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4541), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11286), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [307425] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12959), 1,
      anon_sym_COMMA,
    STATE(8352), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11444), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [307442] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8385), 1,
      anon_sym_where,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(10966), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [307459] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8468), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      anon_sym_LBRACK,
    STATE(7220), 1,
      sym_where_clause,
    ACTIONS(9512), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [307478] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6789), 1,
      anon_sym_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(12962), 1,
      anon_sym_RPAREN,
    STATE(3131), 1,
      sym_parameter_list,
    STATE(7757), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [307501] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 1,
      anon_sym_LT,
    ACTIONS(6996), 1,
      anon_sym_LBRACK,
    STATE(7603), 1,
      sym_template_argument_list,
    ACTIONS(6998), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [307520] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COMMA,
    STATE(8268), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11440), 5,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      sym_identifier,
  [307537] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6789), 1,
      anon_sym_LBRACK,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(12964), 1,
      anon_sym_RPAREN,
    STATE(3131), 1,
      sym_parameter_list,
    STATE(7757), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [307560] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5152), 1,
      anon_sym_LBRACE,
    ACTIONS(12562), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12564), 1,
      anon_sym_inline,
    ACTIONS(12583), 1,
      sym_identifier,
    STATE(989), 1,
      sym_declaration_list,
    STATE(9765), 1,
      sym_nested_namespace_specifier,
    STATE(10327), 1,
      sym__namespace_specifier,
  [307585] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12966), 1,
      anon_sym_LPAREN2,
    STATE(8415), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(12968), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [307601] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6855), 1,
      anon_sym_LBRACK,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6857), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(6730), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [307619] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4571), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11341), 2,
      anon_sym_COMMA,
      sym_identifier,
  [307639] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym___attribute__,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6577), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6642), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [307657] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10598), 1,
      anon_sym_try,
    ACTIONS(11617), 1,
      anon_sym_LBRACE,
    ACTIONS(12970), 1,
      anon_sym_SEMI,
    ACTIONS(12972), 1,
      anon_sym_EQ,
    STATE(1547), 2,
      sym_compound_statement,
      sym_try_statement,
  [307677] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8410), 1,
      anon_sym_where,
    ACTIONS(9514), 1,
      sym_identifier,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(9512), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [307695] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(655), 1,
      anon_sym_LBRACE,
    ACTIONS(11457), 1,
      anon_sym_try,
    ACTIONS(12974), 1,
      anon_sym_SEMI,
    ACTIONS(12976), 1,
      anon_sym_EQ,
    STATE(969), 2,
      sym_compound_statement,
      sym_try_statement,
  [307715] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8417), 1,
      anon_sym_where,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(10674), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [307731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12978), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(12980), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [307745] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12982), 1,
      anon_sym_RBRACE,
    ACTIONS(12984), 1,
      anon_sym_get,
    ACTIONS(12986), 1,
      anon_sym_set,
    STATE(8514), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9509), 2,
      sym_property_get,
      sym_property_set,
  [307765] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12984), 1,
      anon_sym_get,
    ACTIONS(12986), 1,
      anon_sym_set,
    ACTIONS(12988), 1,
      anon_sym_RBRACE,
    STATE(8510), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9509), 2,
      sym_property_get,
      sym_property_set,
  [307785] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10590), 1,
      anon_sym_try,
    ACTIONS(11521), 1,
      anon_sym_LBRACE,
    ACTIONS(12990), 1,
      anon_sym_SEMI,
    ACTIONS(12992), 1,
      anon_sym_EQ,
    STATE(2116), 2,
      sym_compound_statement,
      sym_try_statement,
  [307805] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12984), 1,
      anon_sym_get,
    ACTIONS(12986), 1,
      anon_sym_set,
    ACTIONS(12994), 1,
      anon_sym_RBRACE,
    STATE(8384), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9509), 2,
      sym_property_get,
      sym_property_set,
  [307825] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12984), 1,
      anon_sym_get,
    ACTIONS(12986), 1,
      anon_sym_set,
    ACTIONS(12996), 1,
      anon_sym_RBRACE,
    STATE(8384), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9509), 2,
      sym_property_get,
      sym_property_set,
  [307845] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11701), 1,
      anon_sym_LBRACK,
    ACTIONS(12998), 1,
      anon_sym_EQ,
    ACTIONS(11699), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [307861] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8410), 1,
      anon_sym_where,
    ACTIONS(10968), 1,
      sym_identifier,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(10966), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [307879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12716), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(12714), 5,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [307893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13000), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(13002), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [307907] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12677), 1,
      anon_sym_COMMA,
    STATE(8416), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 4,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [307923] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(13004), 1,
      anon_sym_EQ,
    ACTIONS(13006), 1,
      anon_sym_GT2,
    STATE(8610), 1,
      sym_interface_requirements,
    STATE(9016), 1,
      aux_sym_template_argument_list_repeat1,
  [307945] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(13008), 1,
      anon_sym_EQ,
    ACTIONS(13010), 1,
      anon_sym_GT2,
    STATE(8895), 1,
      sym_interface_requirements,
    STATE(9046), 1,
      aux_sym_template_argument_list_repeat1,
  [307967] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12984), 1,
      anon_sym_get,
    ACTIONS(12986), 1,
      anon_sym_set,
    ACTIONS(13012), 1,
      anon_sym_RBRACE,
    STATE(8384), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9509), 2,
      sym_property_get,
      sym_property_set,
  [307987] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13014), 1,
      anon_sym_LPAREN2,
    STATE(8360), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(12968), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [308003] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10606), 1,
      anon_sym_try,
    ACTIONS(11560), 1,
      anon_sym_LBRACE,
    ACTIONS(13016), 1,
      anon_sym_SEMI,
    ACTIONS(13018), 1,
      anon_sym_EQ,
    STATE(2571), 2,
      sym_compound_statement,
      sym_try_statement,
  [308023] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13020), 1,
      anon_sym_RBRACE,
    ACTIONS(13022), 1,
      anon_sym_get,
    ACTIONS(13025), 1,
      anon_sym_set,
    STATE(8384), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9509), 2,
      sym_property_get,
      sym_property_set,
  [308043] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13028), 1,
      anon_sym_LPAREN2,
    STATE(8415), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(12968), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [308059] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(13030), 1,
      anon_sym_EQ,
    ACTIONS(13032), 1,
      anon_sym_GT2,
    STATE(8635), 1,
      sym_interface_requirements,
    STATE(9162), 1,
      aux_sym_template_argument_list_repeat1,
  [308081] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12984), 1,
      anon_sym_get,
    ACTIONS(12986), 1,
      anon_sym_set,
    ACTIONS(13034), 1,
      anon_sym_RBRACE,
    STATE(8384), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9509), 2,
      sym_property_get,
      sym_property_set,
  [308101] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12984), 1,
      anon_sym_get,
    ACTIONS(12986), 1,
      anon_sym_set,
    ACTIONS(13036), 1,
      anon_sym_RBRACE,
    STATE(8381), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9509), 2,
      sym_property_get,
      sym_property_set,
  [308121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13038), 1,
      anon_sym_EQ,
    ACTIONS(11699), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [308135] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12734), 1,
      anon_sym_COMMA,
    STATE(8489), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11440), 4,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [308151] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4576), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11333), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [308171] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13040), 1,
      anon_sym_LPAREN2,
    STATE(8415), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(12968), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [308187] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13042), 1,
      anon_sym_LPAREN2,
    STATE(8415), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(12968), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [308203] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8410), 1,
      anon_sym_where,
    ACTIONS(10676), 1,
      sym_identifier,
    STATE(7133), 1,
      sym_where_clause,
    ACTIONS(10674), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [308221] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12984), 1,
      anon_sym_get,
    ACTIONS(12986), 1,
      anon_sym_set,
    ACTIONS(13044), 1,
      anon_sym_RBRACE,
    STATE(8384), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9509), 2,
      sym_property_get,
      sym_property_set,
  [308241] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12984), 1,
      anon_sym_get,
    ACTIONS(12986), 1,
      anon_sym_set,
    ACTIONS(13046), 1,
      anon_sym_RBRACE,
    STATE(8509), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9509), 2,
      sym_property_get,
      sym_property_set,
  [308261] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4571), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11376), 2,
      anon_sym_COMMA,
      sym_identifier,
  [308281] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(11400), 1,
      anon_sym_try,
    ACTIONS(13048), 1,
      anon_sym_SEMI,
    ACTIONS(13050), 1,
      anon_sym_EQ,
    STATE(1072), 2,
      sym_compound_statement,
      sym_try_statement,
  [308301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(10820), 1,
      sym_string_literal,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [308315] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(309), 1,
      anon_sym_LBRACE,
    ACTIONS(11539), 1,
      anon_sym_try,
    ACTIONS(13052), 1,
      anon_sym_SEMI,
    ACTIONS(13054), 1,
      anon_sym_EQ,
    STATE(501), 2,
      sym_compound_statement,
      sym_try_statement,
  [308335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13056), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(13058), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [308349] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(13060), 1,
      anon_sym_EQ,
    ACTIONS(13062), 1,
      anon_sym_GT2,
    STATE(8826), 1,
      sym_interface_requirements,
    STATE(9319), 1,
      aux_sym_template_argument_list_repeat1,
  [308371] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13066), 1,
      anon_sym_DOT,
    ACTIONS(13064), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(9097), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [308387] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(13068), 1,
      anon_sym_EQ,
    ACTIONS(13070), 1,
      anon_sym_GT2,
    STATE(8932), 1,
      sym_interface_requirements,
    STATE(8985), 1,
      aux_sym_template_argument_list_repeat1,
  [308409] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4576), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11376), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [308429] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(655), 1,
      anon_sym_LBRACE,
    ACTIONS(11457), 1,
      anon_sym_try,
    ACTIONS(13072), 1,
      anon_sym_SEMI,
    ACTIONS(13074), 1,
      anon_sym_EQ,
    STATE(914), 2,
      sym_compound_statement,
      sym_try_statement,
  [308449] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(13076), 1,
      anon_sym_EQ,
    ACTIONS(13078), 1,
      anon_sym_GT2,
    STATE(8641), 1,
      sym_interface_requirements,
    STATE(9204), 1,
      aux_sym_template_argument_list_repeat1,
  [308471] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6728), 1,
      anon_sym___attribute__,
    STATE(6982), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7344), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [308489] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12677), 1,
      anon_sym_COMMA,
    STATE(8425), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 4,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [308505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13080), 1,
      anon_sym_EQ,
    ACTIONS(11507), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [308519] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4571), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11333), 2,
      anon_sym_COMMA,
      sym_identifier,
  [308539] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13082), 1,
      anon_sym___attribute__,
    STATE(6642), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7033), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [308557] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1219), 1,
      anon_sym_LBRACE,
    ACTIONS(11467), 1,
      anon_sym_try,
    ACTIONS(13084), 1,
      anon_sym_SEMI,
    ACTIONS(13086), 1,
      anon_sym_EQ,
    STATE(891), 2,
      sym_compound_statement,
      sym_try_statement,
  [308577] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12677), 1,
      anon_sym_COMMA,
    STATE(8416), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 4,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [308593] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13088), 1,
      anon_sym_LPAREN2,
    STATE(8415), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(13090), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [308609] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13093), 1,
      anon_sym_COMMA,
    STATE(8416), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11444), 4,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [308625] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13066), 1,
      anon_sym_DOT,
    ACTIONS(3850), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(9097), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [308641] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4571), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11337), 2,
      anon_sym_COMMA,
      sym_identifier,
  [308661] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1219), 1,
      anon_sym_LBRACE,
    ACTIONS(11467), 1,
      anon_sym_try,
    ACTIONS(13096), 1,
      anon_sym_SEMI,
    ACTIONS(13098), 1,
      anon_sym_EQ,
    STATE(867), 2,
      sym_compound_statement,
      sym_try_statement,
  [308681] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(13100), 1,
      anon_sym_EQ,
    ACTIONS(13102), 1,
      anon_sym_GT2,
    STATE(8822), 1,
      sym_interface_requirements,
    STATE(9305), 1,
      aux_sym_template_argument_list_repeat1,
  [308703] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12984), 1,
      anon_sym_get,
    ACTIONS(12986), 1,
      anon_sym_set,
    ACTIONS(13104), 1,
      anon_sym_RBRACE,
    STATE(8373), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9509), 2,
      sym_property_get,
      sym_property_set,
  [308723] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4576), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11337), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [308743] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(13106), 1,
      anon_sym_EQ,
    ACTIONS(13108), 1,
      anon_sym_GT2,
    STATE(8937), 1,
      sym_interface_requirements,
    STATE(8968), 1,
      aux_sym_template_argument_list_repeat1,
  [308765] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(309), 1,
      anon_sym_LBRACE,
    ACTIONS(11539), 1,
      anon_sym_try,
    ACTIONS(13110), 1,
      anon_sym_SEMI,
    ACTIONS(13112), 1,
      anon_sym_EQ,
    STATE(446), 2,
      sym_compound_statement,
      sym_try_statement,
  [308785] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12677), 1,
      anon_sym_COMMA,
    STATE(8416), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 4,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [308801] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12984), 1,
      anon_sym_get,
    ACTIONS(12986), 1,
      anon_sym_set,
    ACTIONS(13114), 1,
      anon_sym_RBRACE,
    STATE(8463), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9509), 2,
      sym_property_get,
      sym_property_set,
  [308821] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12677), 1,
      anon_sym_COMMA,
    STATE(8431), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 4,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [308837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13116), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(13118), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [308851] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4576), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11335), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [308871] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12984), 1,
      anon_sym_get,
    ACTIONS(12986), 1,
      anon_sym_set,
    ACTIONS(13120), 1,
      anon_sym_RBRACE,
    STATE(8384), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9509), 2,
      sym_property_get,
      sym_property_set,
  [308891] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12677), 1,
      anon_sym_COMMA,
    STATE(8416), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11440), 4,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [308907] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10598), 1,
      anon_sym_try,
    ACTIONS(11617), 1,
      anon_sym_LBRACE,
    ACTIONS(13122), 1,
      anon_sym_SEMI,
    ACTIONS(13124), 1,
      anon_sym_EQ,
    STATE(1572), 2,
      sym_compound_statement,
      sym_try_statement,
  [308927] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6343), 1,
      anon_sym_LT,
    ACTIONS(6996), 1,
      anon_sym_LBRACK,
    STATE(2944), 1,
      sym_template_argument_list,
    ACTIONS(6998), 3,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [308945] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13066), 1,
      anon_sym_DOT,
    ACTIONS(3892), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(9097), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [308961] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    STATE(6783), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6982), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [308979] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(13126), 1,
      anon_sym_EQ,
    ACTIONS(13128), 1,
      anon_sym_GT2,
    STATE(8936), 1,
      sym_interface_requirements,
    STATE(8950), 1,
      aux_sym_template_argument_list_repeat1,
  [309001] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13130), 1,
      anon_sym_LPAREN2,
    STATE(8385), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(12968), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [309017] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4576), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11331), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [309037] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 1,
      anon_sym_LT,
    ACTIONS(12162), 1,
      anon_sym_LBRACK,
    STATE(7800), 1,
      sym_template_argument_list,
    ACTIONS(12160), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [309055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13132), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(13134), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [309069] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(13136), 1,
      anon_sym_EQ,
    ACTIONS(13138), 1,
      anon_sym_GT2,
    STATE(8682), 1,
      sym_interface_requirements,
    STATE(9461), 1,
      aux_sym_template_argument_list_repeat1,
  [309091] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13066), 1,
      anon_sym_DOT,
    ACTIONS(13140), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(9097), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [309107] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12984), 1,
      anon_sym_get,
    ACTIONS(12986), 1,
      anon_sym_set,
    ACTIONS(13142), 1,
      anon_sym_RBRACE,
    STATE(8430), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9509), 2,
      sym_property_get,
      sym_property_set,
  [309127] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(13144), 1,
      anon_sym_EQ,
    ACTIONS(13146), 1,
      anon_sym_GT2,
    STATE(8922), 1,
      sym_interface_requirements,
    STATE(9041), 1,
      aux_sym_template_argument_list_repeat1,
  [309149] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12984), 1,
      anon_sym_get,
    ACTIONS(12986), 1,
      anon_sym_set,
    ACTIONS(13148), 1,
      anon_sym_RBRACE,
    STATE(8395), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9509), 2,
      sym_property_get,
      sym_property_set,
  [309169] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4576), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11280), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [309189] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(13150), 1,
      anon_sym_EQ,
    ACTIONS(13152), 1,
      anon_sym_GT2,
    STATE(8899), 1,
      sym_interface_requirements,
    STATE(9093), 1,
      aux_sym_template_argument_list_repeat1,
  [309211] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12734), 1,
      anon_sym_COMMA,
    STATE(8489), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 4,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [309227] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4576), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11286), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [309247] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13154), 1,
      anon_sym_LPAREN2,
    STATE(8393), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(12968), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [309263] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8417), 1,
      anon_sym_where,
    STATE(7168), 1,
      sym_where_clause,
    ACTIONS(11490), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [309279] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(13156), 1,
      anon_sym_EQ,
    ACTIONS(13158), 1,
      anon_sym_GT2,
    STATE(8689), 1,
      sym_interface_requirements,
    STATE(9538), 1,
      aux_sym_template_argument_list_repeat1,
  [309301] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4576), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11341), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [309321] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(13160), 1,
      anon_sym_EQ,
    ACTIONS(13162), 1,
      anon_sym_GT2,
    STATE(8900), 1,
      sym_interface_requirements,
    STATE(9094), 1,
      aux_sym_template_argument_list_repeat1,
  [309343] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(13164), 1,
      anon_sym_EQ,
    ACTIONS(13166), 1,
      anon_sym_GT2,
    STATE(8762), 1,
      sym_interface_requirements,
    STATE(9484), 1,
      aux_sym_template_argument_list_repeat1,
  [309365] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12984), 1,
      anon_sym_get,
    ACTIONS(12986), 1,
      anon_sym_set,
    ACTIONS(13168), 1,
      anon_sym_RBRACE,
    STATE(8458), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9509), 2,
      sym_property_get,
      sym_property_set,
  [309385] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12734), 1,
      anon_sym_COMMA,
    STATE(8390), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 4,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [309401] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12984), 1,
      anon_sym_get,
    ACTIONS(12986), 1,
      anon_sym_set,
    ACTIONS(13170), 1,
      anon_sym_RBRACE,
    STATE(8384), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9509), 2,
      sym_property_get,
      sym_property_set,
  [309421] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13172), 1,
      anon_sym_LPAREN2,
    STATE(8473), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(12968), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [309437] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8410), 1,
      anon_sym_where,
    ACTIONS(11492), 1,
      sym_identifier,
    STATE(7168), 1,
      sym_where_clause,
    ACTIONS(11490), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [309455] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(13174), 1,
      anon_sym_EQ,
    ACTIONS(13176), 1,
      anon_sym_GT2,
    STATE(8878), 1,
      sym_interface_requirements,
    STATE(9154), 1,
      aux_sym_template_argument_list_repeat1,
  [309477] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12734), 1,
      anon_sym_COMMA,
    STATE(8515), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 4,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [309493] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12984), 1,
      anon_sym_get,
    ACTIONS(12986), 1,
      anon_sym_set,
    ACTIONS(13178), 1,
      anon_sym_RBRACE,
    STATE(8384), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9509), 2,
      sym_property_get,
      sym_property_set,
  [309513] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12984), 1,
      anon_sym_get,
    ACTIONS(12986), 1,
      anon_sym_set,
    ACTIONS(13180), 1,
      anon_sym_RBRACE,
    STATE(8387), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9509), 2,
      sym_property_get,
      sym_property_set,
  [309533] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12734), 1,
      anon_sym_COMMA,
    STATE(8489), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 4,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [309549] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4571), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11335), 2,
      anon_sym_COMMA,
      sym_identifier,
  [309569] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(11400), 1,
      anon_sym_try,
    ACTIONS(13182), 1,
      anon_sym_SEMI,
    ACTIONS(13184), 1,
      anon_sym_EQ,
    STATE(1034), 2,
      sym_compound_statement,
      sym_try_statement,
  [309589] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8417), 1,
      anon_sym_where,
    STATE(7153), 1,
      sym_where_clause,
    ACTIONS(10966), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [309605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(10768), 1,
      sym_string_literal,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [309619] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(12774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(13188), 1,
      anon_sym_EQ,
    STATE(9612), 1,
      sym_interface_requirements,
    ACTIONS(13186), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [309639] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13190), 1,
      anon_sym_LPAREN2,
    STATE(8392), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(12968), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [309655] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12984), 1,
      anon_sym_get,
    ACTIONS(12986), 1,
      anon_sym_set,
    ACTIONS(13192), 1,
      anon_sym_RBRACE,
    STATE(8384), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9509), 2,
      sym_property_get,
      sym_property_set,
  [309675] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13194), 1,
      anon_sym_LPAREN2,
    STATE(8415), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(12968), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [309691] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11591), 1,
      anon_sym_LBRACK,
    ACTIONS(12538), 1,
      anon_sym_COMMA,
    STATE(8490), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11440), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [309709] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(13196), 1,
      anon_sym_EQ,
    ACTIONS(13198), 1,
      anon_sym_GT2,
    STATE(8704), 1,
      sym_interface_requirements,
    STATE(9614), 1,
      aux_sym_template_argument_list_repeat1,
  [309731] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(13200), 1,
      anon_sym_EQ,
    ACTIONS(13202), 1,
      anon_sym_GT2,
    STATE(8721), 1,
      sym_interface_requirements,
    STATE(9608), 1,
      aux_sym_template_argument_list_repeat1,
  [309753] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(13204), 1,
      anon_sym_EQ,
    ACTIONS(13206), 1,
      anon_sym_GT2,
    STATE(8856), 1,
      sym_interface_requirements,
    STATE(9211), 1,
      aux_sym_template_argument_list_repeat1,
  [309775] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(13208), 1,
      anon_sym_EQ,
    ACTIONS(13210), 1,
      anon_sym_GT2,
    STATE(8846), 1,
      sym_interface_requirements,
    STATE(9293), 1,
      aux_sym_template_argument_list_repeat1,
  [309797] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8417), 1,
      anon_sym_where,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(10277), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [309813] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10606), 1,
      anon_sym_try,
    ACTIONS(11560), 1,
      anon_sym_LBRACE,
    ACTIONS(13212), 1,
      anon_sym_SEMI,
    ACTIONS(13214), 1,
      anon_sym_EQ,
    STATE(2296), 2,
      sym_compound_statement,
      sym_try_statement,
  [309833] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8410), 1,
      anon_sym_where,
    ACTIONS(10279), 1,
      sym_identifier,
    STATE(7088), 1,
      sym_where_clause,
    ACTIONS(10277), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [309851] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12738), 1,
      anon_sym_COMMA,
    ACTIONS(13216), 1,
      anon_sym_EQ,
    STATE(8595), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      sym_identifier,
  [309869] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4571), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11286), 2,
      anon_sym_COMMA,
      sym_identifier,
  [309889] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 1,
      anon_sym_LT,
    ACTIONS(6996), 1,
      anon_sym_LBRACK,
    STATE(2944), 1,
      sym_template_argument_list,
    ACTIONS(6998), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [309907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13218), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(13220), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [309921] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(13222), 1,
      anon_sym_EQ,
    ACTIONS(13224), 1,
      anon_sym_GT2,
    STATE(8834), 1,
      sym_interface_requirements,
    STATE(9270), 1,
      aux_sym_template_argument_list_repeat1,
  [309943] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11593), 1,
      anon_sym_LBRACK,
    ACTIONS(12538), 1,
      anon_sym_COMMA,
    STATE(8474), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [309961] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11593), 1,
      anon_sym_LBRACK,
    ACTIONS(12538), 1,
      anon_sym_COMMA,
    STATE(8490), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [309979] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13226), 1,
      anon_sym_COMMA,
    STATE(8489), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11444), 4,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [309995] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11547), 1,
      anon_sym_LBRACK,
    ACTIONS(13229), 1,
      anon_sym_COMMA,
    STATE(8490), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11444), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [310013] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(13232), 1,
      anon_sym_EQ,
    ACTIONS(13234), 1,
      anon_sym_GT2,
    STATE(8811), 1,
      sym_interface_requirements,
    STATE(9350), 1,
      aux_sym_template_argument_list_repeat1,
  [310035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13236), 1,
      anon_sym_EQ,
    ACTIONS(11699), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [310049] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 1,
      anon_sym_LT,
    ACTIONS(12158), 1,
      anon_sym_LBRACK,
    STATE(7740), 1,
      sym_template_argument_list,
    ACTIONS(12154), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [310067] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(13238), 1,
      anon_sym_EQ,
    ACTIONS(13240), 1,
      anon_sym_GT2,
    STATE(8651), 1,
      sym_interface_requirements,
    STATE(9286), 1,
      aux_sym_template_argument_list_repeat1,
  [310089] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4571), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11280), 2,
      anon_sym_COMMA,
      sym_identifier,
  [310109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13132), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(13134), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [310123] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11634), 1,
      anon_sym_LBRACK,
    ACTIONS(12538), 1,
      anon_sym_COMMA,
    STATE(8490), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [310141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13242), 1,
      anon_sym_EQ,
    ACTIONS(11507), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [310155] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8417), 1,
      anon_sym_where,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(10062), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [310171] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8410), 1,
      anon_sym_where,
    ACTIONS(10064), 1,
      sym_identifier,
    STATE(7196), 1,
      sym_where_clause,
    ACTIONS(10062), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [310189] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11634), 1,
      anon_sym_LBRACK,
    ACTIONS(12538), 1,
      anon_sym_COMMA,
    STATE(8488), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [310207] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(13244), 1,
      anon_sym_EQ,
    ACTIONS(13246), 1,
      anon_sym_GT2,
    STATE(8784), 1,
      sym_interface_requirements,
    STATE(9413), 1,
      aux_sym_template_argument_list_repeat1,
  [310229] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13248), 1,
      anon_sym_LPAREN2,
    STATE(8516), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(12968), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [310245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13218), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(13220), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [310259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13250), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(13252), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [310273] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13254), 1,
      anon_sym_LPAREN2,
    STATE(8520), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(12968), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [310289] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12742), 1,
      anon_sym_COMMA,
    ACTIONS(13256), 1,
      anon_sym_EQ,
    STATE(8589), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [310307] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10590), 1,
      anon_sym_try,
    ACTIONS(11521), 1,
      anon_sym_LBRACE,
    ACTIONS(13258), 1,
      anon_sym_SEMI,
    ACTIONS(13260), 1,
      anon_sym_EQ,
    STATE(2245), 2,
      sym_compound_statement,
      sym_try_statement,
  [310327] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12984), 1,
      anon_sym_get,
    ACTIONS(12986), 1,
      anon_sym_set,
    ACTIONS(13262), 1,
      anon_sym_RBRACE,
    STATE(8384), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9509), 2,
      sym_property_get,
      sym_property_set,
  [310347] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12984), 1,
      anon_sym_get,
    ACTIONS(12986), 1,
      anon_sym_set,
    ACTIONS(13264), 1,
      anon_sym_RBRACE,
    STATE(8384), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9509), 2,
      sym_property_get,
      sym_property_set,
  [310367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12201), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(13266), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [310381] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12078), 1,
      anon_sym_LBRACK,
    ACTIONS(12076), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(7619), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [310399] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12984), 1,
      anon_sym_get,
    ACTIONS(12986), 1,
      anon_sym_set,
    ACTIONS(13268), 1,
      anon_sym_RBRACE,
    STATE(8472), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9509), 2,
      sym_property_get,
      sym_property_set,
  [310419] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12984), 1,
      anon_sym_get,
    ACTIONS(12986), 1,
      anon_sym_set,
    ACTIONS(13270), 1,
      anon_sym_RBRACE,
    STATE(8384), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9509), 2,
      sym_property_get,
      sym_property_set,
  [310439] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12734), 1,
      anon_sym_COMMA,
    STATE(8489), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 4,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [310455] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_LPAREN2,
    STATE(8415), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(12968), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [310471] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4571), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
    ACTIONS(11331), 2,
      anon_sym_COMMA,
      sym_identifier,
  [310491] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(13274), 1,
      anon_sym_EQ,
    ACTIONS(13276), 1,
      anon_sym_GT2,
    STATE(8864), 1,
      sym_interface_requirements,
    STATE(9192), 1,
      aux_sym_template_argument_list_repeat1,
  [310513] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8417), 1,
      anon_sym_where,
    STATE(7092), 1,
      sym_where_clause,
    ACTIONS(9512), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [310529] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13278), 1,
      anon_sym_LPAREN2,
    STATE(8415), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(12968), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [310545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13280), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(13282), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [310559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13284), 1,
      anon_sym_EQ,
    ACTIONS(11699), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      sym_identifier,
  [310573] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(13287), 1,
      anon_sym_EQ,
    ACTIONS(13289), 1,
      anon_sym_GT2,
    STATE(8755), 1,
      sym_interface_requirements,
    STATE(9498), 1,
      aux_sym_template_argument_list_repeat1,
  [310595] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11627), 1,
      anon_sym_LBRACK,
    ACTIONS(12538), 1,
      anon_sym_COMMA,
    STATE(8490), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [310613] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12984), 1,
      anon_sym_get,
    ACTIONS(12986), 1,
      anon_sym_set,
    ACTIONS(13291), 1,
      anon_sym_RBRACE,
    STATE(8372), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9509), 2,
      sym_property_get,
      sym_property_set,
  [310633] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13293), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(13295), 1,
      anon_sym_COMMA,
    STATE(8761), 1,
      aux_sym_base_class_clause_repeat1,
    ACTIONS(13297), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [310650] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(13299), 1,
      anon_sym_SEMI,
    STATE(8580), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10461), 1,
      sym_attribute_specifier,
  [310669] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12738), 1,
      anon_sym_COMMA,
    STATE(8596), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      sym_identifier,
  [310684] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(13301), 1,
      anon_sym_SEMI,
    STATE(8725), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10189), 1,
      sym_attribute_specifier,
  [310703] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12562), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12564), 1,
      anon_sym_inline,
    ACTIONS(13303), 1,
      sym_identifier,
    STATE(10327), 1,
      sym__namespace_specifier,
    STATE(10599), 1,
      sym_nested_namespace_specifier,
  [310722] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12562), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12564), 1,
      anon_sym_inline,
    ACTIONS(13305), 1,
      sym_identifier,
    STATE(9250), 1,
      sym__namespace_specifier,
    STATE(9824), 1,
      sym_nested_namespace_specifier,
  [310741] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(11398), 1,
      anon_sym_EQ,
    ACTIONS(13307), 1,
      anon_sym_COLON,
    ACTIONS(13309), 1,
      anon_sym_SEMI,
    STATE(9120), 1,
      aux_sym_declaration_repeat1,
  [310760] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12738), 1,
      anon_sym_COMMA,
    STATE(8594), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      sym_identifier,
  [310775] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12742), 1,
      anon_sym_COMMA,
    STATE(8588), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11440), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [310790] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    STATE(3186), 1,
      sym_template_argument_list,
    ACTIONS(6930), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
  [310807] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11292), 1,
      anon_sym_COLON,
    ACTIONS(13313), 1,
      anon_sym_EQ,
    STATE(9126), 1,
      sym_interface_requirements,
    ACTIONS(13311), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [310824] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(13315), 1,
      anon_sym_SEMI,
    STATE(8725), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10215), 1,
      sym_attribute_specifier,
  [310843] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13295), 1,
      anon_sym_COMMA,
    ACTIONS(13317), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(8740), 1,
      aux_sym_base_class_clause_repeat1,
    ACTIONS(13319), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [310860] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(13321), 1,
      anon_sym_SEMI,
    STATE(8557), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10175), 1,
      sym_attribute_specifier,
  [310879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13323), 2,
      anon_sym_class,
      anon_sym_typename,
    STATE(9665), 3,
      sym_type_parameter_declaration,
      sym_variadic_type_parameter_declaration,
      sym_optional_type_parameter_declaration,
  [310892] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13295), 1,
      anon_sym_COMMA,
    ACTIONS(13325), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(8798), 1,
      aux_sym_base_class_clause_repeat1,
    ACTIONS(13327), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [310909] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(13329), 1,
      anon_sym_SEMI,
    STATE(8578), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10187), 1,
      sym_attribute_specifier,
  [310928] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(13331), 1,
      sym_identifier,
    STATE(194), 1,
      sym_template_type,
    STATE(3234), 1,
      sym_template_method,
    STATE(9802), 1,
      sym_operator_name,
  [310947] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    ACTIONS(13333), 1,
      anon_sym_RPAREN,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
  [310966] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(13335), 1,
      sym_identifier,
    STATE(194), 1,
      sym_template_type,
    STATE(4249), 1,
      sym_template_method,
    STATE(9841), 1,
      sym_operator_name,
  [310985] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(13337), 1,
      anon_sym_SEMI,
    STATE(8537), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10199), 1,
      sym_attribute_specifier,
  [311004] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    ACTIONS(13339), 1,
      anon_sym_RPAREN,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
  [311023] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(13341), 1,
      anon_sym_SEMI,
    STATE(8725), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10214), 1,
      sym_attribute_specifier,
  [311042] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(13343), 1,
      anon_sym_SEMI,
    STATE(8725), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10465), 1,
      sym_attribute_specifier,
  [311061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13345), 1,
      anon_sym_EQ,
    ACTIONS(11699), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [311074] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12738), 1,
      anon_sym_COMMA,
    STATE(8594), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      sym_identifier,
  [311089] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(13347), 1,
      anon_sym_SEMI,
    STATE(8592), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10258), 1,
      sym_attribute_specifier,
  [311108] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9586), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9590), 1,
      anon_sym_EQ,
    ACTIONS(13349), 1,
      sym_identifier,
    ACTIONS(9588), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [311125] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(13351), 1,
      anon_sym_SEMI,
    STATE(8582), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10463), 1,
      sym_attribute_specifier,
  [311144] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(11398), 1,
      anon_sym_EQ,
    ACTIONS(13353), 1,
      anon_sym_COLON,
    ACTIONS(13355), 1,
      anon_sym_SEMI,
    STATE(9559), 1,
      aux_sym_declaration_repeat1,
  [311163] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12742), 1,
      anon_sym_COMMA,
    STATE(8588), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [311178] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(13357), 1,
      anon_sym_SEMI,
    STATE(8725), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10203), 1,
      sym_attribute_specifier,
  [311197] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12562), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12564), 1,
      anon_sym_inline,
    ACTIONS(13359), 1,
      sym_identifier,
    STATE(10327), 1,
      sym__namespace_specifier,
    STATE(10813), 1,
      sym_nested_namespace_specifier,
  [311216] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(11398), 1,
      anon_sym_EQ,
    ACTIONS(13361), 1,
      anon_sym_COLON,
    ACTIONS(13363), 1,
      anon_sym_SEMI,
    STATE(9214), 1,
      aux_sym_declaration_repeat1,
  [311235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13365), 4,
      sym_identifier,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_template,
  [311248] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12738), 1,
      anon_sym_COMMA,
    STATE(8533), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      sym_identifier,
  [311263] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(11398), 1,
      anon_sym_EQ,
    ACTIONS(13369), 1,
      anon_sym_COLON,
    ACTIONS(13371), 1,
      anon_sym_SEMI,
    STATE(9454), 1,
      aux_sym_declaration_repeat1,
  [311282] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(11398), 1,
      anon_sym_EQ,
    ACTIONS(13373), 1,
      anon_sym_COLON,
    ACTIONS(13375), 1,
      anon_sym_SEMI,
    STATE(9499), 1,
      aux_sym_declaration_repeat1,
  [311301] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(11398), 1,
      anon_sym_EQ,
    ACTIONS(13377), 1,
      anon_sym_COLON,
    ACTIONS(13379), 1,
      anon_sym_SEMI,
    STATE(9355), 1,
      aux_sym_declaration_repeat1,
  [311320] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(13381), 1,
      sym_identifier,
    STATE(194), 1,
      sym_template_type,
    STATE(4412), 1,
      sym_template_method,
    STATE(9650), 1,
      sym_operator_name,
  [311339] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(13383), 1,
      sym_identifier,
    STATE(194), 1,
      sym_template_type,
    STATE(3234), 1,
      sym_template_method,
    STATE(9711), 1,
      sym_operator_name,
  [311358] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11712), 1,
      sym_identifier,
    ACTIONS(13385), 1,
      aux_sym_preproc_if_token2,
    STATE(8234), 1,
      sym_enumerator,
    STATE(8778), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8825), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
  [311377] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(13387), 1,
      anon_sym_SEMI,
    STATE(8725), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10763), 1,
      sym_attribute_specifier,
  [311396] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(13389), 1,
      anon_sym_SEMI,
    STATE(8583), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10260), 1,
      sym_attribute_specifier,
  [311415] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(13391), 1,
      anon_sym_SEMI,
    STATE(8573), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10479), 1,
      sym_attribute_specifier,
  [311434] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6343), 1,
      anon_sym_LT,
    ACTIONS(6996), 1,
      anon_sym_LBRACK,
    STATE(2899), 1,
      sym_template_argument_list,
    ACTIONS(6998), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [311451] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2808), 1,
      anon_sym_operator,
    ACTIONS(13331), 1,
      sym_identifier,
    STATE(194), 1,
      sym_template_type,
    STATE(3234), 1,
      sym_template_method,
    STATE(9833), 1,
      sym_operator_name,
  [311470] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(13393), 1,
      anon_sym_SEMI,
    STATE(8725), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10467), 1,
      sym_attribute_specifier,
  [311489] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    ACTIONS(13395), 1,
      anon_sym_RPAREN,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
  [311508] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(13397), 1,
      anon_sym_SEMI,
    STATE(8725), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10489), 1,
      sym_attribute_specifier,
  [311527] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(13399), 1,
      anon_sym_SEMI,
    STATE(8597), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10306), 1,
      sym_attribute_specifier,
  [311546] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12562), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12564), 1,
      anon_sym_inline,
    ACTIONS(13401), 1,
      sym_identifier,
    STATE(10327), 1,
      sym__namespace_specifier,
    STATE(10424), 1,
      sym_nested_namespace_specifier,
  [311565] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(13403), 1,
      anon_sym_SEMI,
    STATE(8725), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10200), 1,
      sym_attribute_specifier,
  [311584] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12562), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12564), 1,
      anon_sym_inline,
    ACTIONS(13405), 1,
      sym_identifier,
    STATE(10114), 1,
      sym_nested_namespace_specifier,
    STATE(10327), 1,
      sym__namespace_specifier,
  [311603] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(13407), 1,
      anon_sym_SEMI,
    STATE(8725), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10480), 1,
      sym_attribute_specifier,
  [311622] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    ACTIONS(13409), 1,
      anon_sym_RPAREN,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
  [311641] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(13411), 1,
      anon_sym_SEMI,
    STATE(8725), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10484), 1,
      sym_attribute_specifier,
  [311660] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(13413), 1,
      anon_sym_SEMI,
    STATE(8725), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10370), 1,
      sym_attribute_specifier,
  [311679] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(13415), 1,
      anon_sym_SEMI,
    STATE(8725), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10257), 1,
      sym_attribute_specifier,
  [311698] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(11398), 1,
      anon_sym_EQ,
    ACTIONS(13417), 1,
      anon_sym_COLON,
    ACTIONS(13419), 1,
      anon_sym_SEMI,
    STATE(9234), 1,
      aux_sym_declaration_repeat1,
  [311717] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(11398), 1,
      anon_sym_EQ,
    ACTIONS(13421), 1,
      anon_sym_COLON,
    ACTIONS(13423), 1,
      anon_sym_SEMI,
    STATE(9353), 1,
      aux_sym_declaration_repeat1,
  [311736] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6343), 1,
      anon_sym_LT,
    ACTIONS(6996), 1,
      anon_sym_LBRACK,
    STATE(3322), 1,
      sym_template_argument_list,
    ACTIONS(6998), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [311753] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13425), 1,
      anon_sym_COMMA,
    STATE(8588), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11444), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [311768] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12742), 1,
      anon_sym_COMMA,
    STATE(8588), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [311783] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13295), 1,
      anon_sym_COMMA,
    ACTIONS(13428), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(8674), 1,
      aux_sym_base_class_clause_repeat1,
    ACTIONS(13430), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [311800] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12742), 1,
      anon_sym_COMMA,
    STATE(8556), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [311815] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(13432), 1,
      anon_sym_SEMI,
    STATE(8725), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10375), 1,
      sym_attribute_specifier,
  [311834] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12562), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12564), 1,
      anon_sym_inline,
    ACTIONS(13305), 1,
      sym_identifier,
    STATE(9289), 1,
      sym__namespace_specifier,
    STATE(9851), 1,
      sym_nested_namespace_specifier,
  [311853] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13434), 1,
      anon_sym_COMMA,
    STATE(8594), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11444), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      sym_identifier,
  [311868] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12738), 1,
      anon_sym_COMMA,
    STATE(8594), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11449), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      sym_identifier,
  [311883] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12738), 1,
      anon_sym_COMMA,
    STATE(8594), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11440), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      sym_identifier,
  [311898] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(13437), 1,
      anon_sym_SEMI,
    STATE(8725), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10764), 1,
      sym_attribute_specifier,
  [311917] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12742), 1,
      anon_sym_COMMA,
    STATE(8588), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11451), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [311932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13439), 1,
      anon_sym_EQ,
    ACTIONS(11699), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      sym_identifier,
  [311945] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(11398), 1,
      anon_sym_EQ,
    ACTIONS(13441), 1,
      anon_sym_COLON,
    ACTIONS(13443), 1,
      anon_sym_SEMI,
    STATE(9589), 1,
      aux_sym_declaration_repeat1,
  [311964] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    ACTIONS(13447), 1,
      anon_sym_COLON_COLON,
    STATE(10041), 1,
      sym_argument_list,
    ACTIONS(13445), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [311981] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12742), 1,
      anon_sym_COMMA,
    STATE(8534), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(11442), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [311996] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(13449), 1,
      anon_sym_SEMI,
    STATE(8820), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [312010] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13451), 1,
      anon_sym_COMMA,
    STATE(8709), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(13453), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [312024] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13455), 1,
      anon_sym___except,
    ACTIONS(13457), 1,
      anon_sym___finally,
    STATE(719), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [312038] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13459), 1,
      anon_sym_EQ,
    ACTIONS(13461), 1,
      anon_sym_GT2,
    STATE(9018), 1,
      aux_sym_template_argument_list_repeat1,
  [312054] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(726), 1,
      sym_field_declaration_list,
    STATE(10016), 1,
      sym_base_class_clause,
  [312070] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(747), 1,
      sym_field_declaration_list,
    STATE(9817), 1,
      sym_base_class_clause,
  [312086] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(742), 1,
      sym_field_declaration_list,
    STATE(9899), 1,
      sym_base_class_clause,
  [312102] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13463), 1,
      anon_sym_EQ,
    ACTIONS(13465), 1,
      anon_sym_GT2,
    STATE(9027), 1,
      aux_sym_template_argument_list_repeat1,
  [312118] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13467), 1,
      anon_sym_COMMA,
    STATE(8611), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(13470), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [312132] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(740), 1,
      sym_field_declaration_list,
    STATE(9900), 1,
      sym_base_class_clause,
  [312148] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    STATE(9351), 1,
      sym_compound_statement,
    STATE(10028), 1,
      sym_field_initializer_list,
  [312164] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13472), 1,
      anon_sym_DQUOTE,
    ACTIONS(13474), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13476), 1,
      sym_escape_sequence,
    STATE(8634), 1,
      aux_sym_string_literal_repeat1,
  [312180] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13478), 1,
      anon_sym_EQ,
    ACTIONS(13480), 1,
      anon_sym_GT2,
    STATE(9315), 1,
      aux_sym_template_argument_list_repeat1,
  [312196] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(13482), 1,
      anon_sym_SEMI,
    STATE(8914), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [312210] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5033), 1,
      anon_sym_LT,
    ACTIONS(13484), 1,
      sym_identifier,
    STATE(194), 1,
      sym_template_type,
    STATE(1083), 1,
      sym_template_parameter_list,
  [312226] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(13486), 1,
      anon_sym_SEMI,
    STATE(5675), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [312240] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13488), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13490), 1,
      anon_sym_LPAREN,
    ACTIONS(13492), 1,
      sym_preproc_arg,
    STATE(9890), 1,
      sym_preproc_params,
  [312256] = 4,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13494), 1,
      anon_sym_SQUOTE,
    STATE(8638), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(13496), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [312270] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(918), 1,
      sym_field_declaration_list,
    STATE(9810), 1,
      sym_base_class_clause,
  [312286] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13498), 1,
      anon_sym_DQUOTE,
    ACTIONS(13500), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13502), 1,
      sym_escape_sequence,
    STATE(8627), 1,
      aux_sym_string_literal_repeat1,
  [312302] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(13504), 1,
      anon_sym_SEMI,
    STATE(8673), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [312316] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(13506), 1,
      anon_sym_SEMI,
    STATE(5675), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [312330] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13508), 1,
      anon_sym_DQUOTE,
    ACTIONS(13510), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13512), 1,
      sym_escape_sequence,
    STATE(8639), 1,
      aux_sym_string_literal_repeat1,
  [312346] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4737), 1,
      anon_sym_LBRACE,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    STATE(4462), 1,
      sym_argument_list,
    STATE(4538), 1,
      sym_initializer_list,
  [312362] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13510), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13512), 1,
      sym_escape_sequence,
    ACTIONS(13514), 1,
      anon_sym_DQUOTE,
    STATE(8639), 1,
      aux_sym_string_literal_repeat1,
  [312378] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5033), 1,
      anon_sym_LT,
    ACTIONS(13484), 1,
      sym_identifier,
    STATE(194), 1,
      sym_template_type,
    STATE(1082), 1,
      sym_template_parameter_list,
  [312394] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11304), 1,
      anon_sym_LBRACE,
    STATE(4402), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [312408] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    STATE(9555), 1,
      sym_compound_statement,
    STATE(9967), 1,
      sym_field_initializer_list,
  [312424] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(6478), 1,
      anon_sym_LBRACE,
    STATE(3025), 1,
      sym_field_declaration_list,
    STATE(9835), 1,
      sym_base_class_clause,
  [312440] = 4,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13516), 1,
      anon_sym_SQUOTE,
    STATE(8638), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(13496), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [312454] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11304), 1,
      anon_sym_LBRACE,
    STATE(4270), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [312468] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13510), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13512), 1,
      sym_escape_sequence,
    ACTIONS(13518), 1,
      anon_sym_DQUOTE,
    STATE(8639), 1,
      aux_sym_string_literal_repeat1,
  [312484] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13520), 1,
      anon_sym_EQ,
    ACTIONS(13522), 1,
      anon_sym_GT2,
    STATE(9050), 1,
      aux_sym_template_argument_list_repeat1,
  [312500] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13524), 1,
      anon_sym_LPAREN2,
    ACTIONS(13526), 1,
      anon_sym_LBRACE,
    STATE(1829), 1,
      sym_requirement_seq,
    STATE(9790), 1,
      sym_requires_parameter_list,
  [312516] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13528), 1,
      anon_sym_EQ,
    ACTIONS(13530), 1,
      anon_sym_GT2,
    STATE(9213), 1,
      aux_sym_template_argument_list_repeat1,
  [312532] = 4,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13532), 1,
      anon_sym_SQUOTE,
    STATE(8638), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(13534), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [312546] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13537), 1,
      anon_sym_DQUOTE,
    ACTIONS(13539), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13542), 1,
      sym_escape_sequence,
    STATE(8639), 1,
      aux_sym_string_literal_repeat1,
  [312562] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(747), 1,
      sym_field_declaration_list,
    STATE(9809), 1,
      sym_base_class_clause,
  [312578] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13545), 1,
      anon_sym_EQ,
    ACTIONS(13547), 1,
      anon_sym_GT2,
    STATE(9221), 1,
      aux_sym_template_argument_list_repeat1,
  [312594] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11364), 1,
      anon_sym_LBRACE,
    STATE(4647), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [312608] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2479), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(327), 1,
      sym_field_declaration_list,
    STATE(9990), 1,
      sym_base_class_clause,
  [312624] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5033), 1,
      anon_sym_LT,
    ACTIONS(13484), 1,
      sym_identifier,
    STATE(194), 1,
      sym_template_type,
    STATE(8540), 1,
      sym_template_parameter_list,
  [312640] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(13549), 1,
      anon_sym_SEMI,
    STATE(8665), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [312654] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5033), 1,
      anon_sym_LT,
    ACTIONS(13484), 1,
      sym_identifier,
    STATE(194), 1,
      sym_template_type,
    STATE(1087), 1,
      sym_template_parameter_list,
  [312670] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13551), 1,
      anon_sym___except,
    ACTIONS(13553), 1,
      anon_sym___finally,
    STATE(1322), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [312684] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    STATE(9367), 1,
      sym_compound_statement,
    STATE(9894), 1,
      sym_field_initializer_list,
  [312700] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2828), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(755), 1,
      sym_field_declaration_list,
    STATE(9799), 1,
      sym_base_class_clause,
  [312716] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(13555), 1,
      anon_sym_SEMI,
    STATE(5675), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [312730] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13557), 1,
      anon_sym_EQ,
    ACTIONS(13559), 1,
      anon_sym_GT2,
    STATE(9431), 1,
      aux_sym_template_argument_list_repeat1,
  [312746] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(6478), 1,
      anon_sym_LBRACE,
    STATE(3014), 1,
      sym_field_declaration_list,
    STATE(9788), 1,
      sym_base_class_clause,
  [312762] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    ACTIONS(13561), 1,
      anon_sym_SEMI,
    STATE(2816), 1,
      sym_template_argument_list,
  [312778] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13295), 1,
      anon_sym_COMMA,
    STATE(8798), 1,
      aux_sym_base_class_clause_repeat1,
    ACTIONS(13327), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [312792] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11339), 1,
      anon_sym_LBRACE,
    STATE(4971), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [312806] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    ACTIONS(13563), 1,
      anon_sym_SEMI,
    STATE(2816), 1,
      sym_template_argument_list,
  [312822] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11347), 1,
      anon_sym_LBRACE,
    STATE(3857), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [312836] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13510), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13512), 1,
      sym_escape_sequence,
    ACTIONS(13565), 1,
      anon_sym_DQUOTE,
    STATE(8639), 1,
      aux_sym_string_literal_repeat1,
  [312852] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13567), 1,
      anon_sym_DQUOTE,
    ACTIONS(13569), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13571), 1,
      sym_escape_sequence,
    STATE(8668), 1,
      aux_sym_string_literal_repeat1,
  [312868] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13573), 1,
      anon_sym_DQUOTE,
    ACTIONS(13575), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13577), 1,
      sym_escape_sequence,
    STATE(8851), 1,
      aux_sym_string_literal_repeat1,
  [312884] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13579), 1,
      anon_sym_EQ,
    STATE(7619), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [312898] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11364), 1,
      anon_sym_LBRACE,
    STATE(4621), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [312912] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13581), 1,
      anon_sym_COMMA,
    STATE(8663), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(13584), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [312926] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(13586), 1,
      anon_sym_SEMI,
    STATE(8685), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [312940] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(13588), 1,
      anon_sym_SEMI,
    STATE(5675), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [312954] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13590), 1,
      anon_sym_DQUOTE,
    ACTIONS(13592), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13594), 1,
      sym_escape_sequence,
    STATE(8658), 1,
      aux_sym_string_literal_repeat1,
  [312970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13596), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [312980] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13510), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13512), 1,
      sym_escape_sequence,
    ACTIONS(13598), 1,
      anon_sym_DQUOTE,
    STATE(8639), 1,
      aux_sym_string_literal_repeat1,
  [312996] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2828), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(661), 1,
      sym_field_declaration_list,
    STATE(9731), 1,
      sym_base_class_clause,
  [313012] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2828), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(662), 1,
      sym_field_declaration_list,
    STATE(9730), 1,
      sym_base_class_clause,
  [313028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13596), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [313038] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13600), 1,
      anon_sym_COMMA,
    STATE(8718), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(13602), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [313052] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(13604), 1,
      anon_sym_SEMI,
    STATE(5675), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [313066] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13295), 1,
      anon_sym_COMMA,
    STATE(8917), 1,
      aux_sym_base_class_clause_repeat1,
    ACTIONS(13606), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [313080] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13608), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
  [313090] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11347), 1,
      anon_sym_LBRACE,
    STATE(3811), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [313104] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13610), 1,
      anon_sym_EQ,
    ACTIONS(13612), 1,
      anon_sym_GT2,
    STATE(9540), 1,
      aux_sym_template_argument_list_repeat1,
  [313120] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13614), 1,
      anon_sym_EQ,
    ACTIONS(13616), 1,
      anon_sym_GT2,
    STATE(9496), 1,
      aux_sym_template_argument_list_repeat1,
  [313136] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(4322), 1,
      sym_parameter_list,
    STATE(7199), 1,
      sym__function_declarator_seq,
  [313152] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5033), 1,
      anon_sym_LT,
    ACTIONS(13484), 1,
      sym_identifier,
    STATE(194), 1,
      sym_template_type,
    STATE(1084), 1,
      sym_template_parameter_list,
  [313168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13618), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(13620), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [313180] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13622), 1,
      anon_sym_EQ,
    ACTIONS(13624), 1,
      anon_sym_GT2,
    STATE(9514), 1,
      aux_sym_template_argument_list_repeat1,
  [313196] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    STATE(9620), 1,
      sym_compound_statement,
    STATE(9780), 1,
      sym_field_initializer_list,
  [313212] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11364), 1,
      anon_sym_LBRACE,
    STATE(4607), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [313226] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(13626), 1,
      anon_sym_SEMI,
    STATE(5675), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [313240] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2828), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(691), 1,
      sym_field_declaration_list,
    STATE(9704), 1,
      sym_base_class_clause,
  [313256] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13628), 1,
      anon_sym_EQ,
    ACTIONS(13630), 1,
      anon_sym_GT2,
    STATE(9156), 1,
      aux_sym_template_argument_list_repeat1,
  [313272] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    STATE(9625), 1,
      sym_compound_statement,
    STATE(9656), 1,
      sym_field_initializer_list,
  [313288] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13632), 1,
      anon_sym_EQ,
    ACTIONS(13634), 1,
      anon_sym_GT2,
    STATE(9562), 1,
      aux_sym_template_argument_list_repeat1,
  [313304] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13636), 1,
      anon_sym_COMMA,
    STATE(8719), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(13638), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [313318] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    STATE(6187), 1,
      sym_field_declaration_list,
    STATE(9750), 1,
      sym_base_class_clause,
  [313334] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13295), 1,
      anon_sym_COMMA,
    STATE(8748), 1,
      aux_sym_base_class_clause_repeat1,
    ACTIONS(13606), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [313348] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    STATE(6171), 1,
      sym_field_declaration_list,
    STATE(9715), 1,
      sym_base_class_clause,
  [313364] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2479), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(412), 1,
      sym_field_declaration_list,
    STATE(9897), 1,
      sym_base_class_clause,
  [313380] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2479), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(413), 1,
      sym_field_declaration_list,
    STATE(9895), 1,
      sym_base_class_clause,
  [313396] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13640), 1,
      anon_sym_DQUOTE,
    ACTIONS(13642), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13644), 1,
      sym_escape_sequence,
    STATE(8714), 1,
      aux_sym_string_literal_repeat1,
  [313412] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    ACTIONS(13646), 1,
      anon_sym_SEMI,
    STATE(2816), 1,
      sym_template_argument_list,
  [313428] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13636), 1,
      anon_sym_COMMA,
    STATE(8690), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(13648), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [313442] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(13650), 1,
      anon_sym_SEMI,
    STATE(5675), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [313456] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13652), 1,
      anon_sym_DQUOTE,
    ACTIONS(13654), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13656), 1,
      sym_escape_sequence,
    STATE(8708), 1,
      aux_sym_string_literal_repeat1,
  [313472] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(13658), 1,
      anon_sym_SEMI,
    STATE(8650), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [313486] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13490), 1,
      anon_sym_LPAREN,
    ACTIONS(13660), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13662), 1,
      sym_preproc_arg,
    STATE(9648), 1,
      sym_preproc_params,
  [313502] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    STATE(6169), 1,
      sym_field_declaration_list,
    STATE(9671), 1,
      sym_base_class_clause,
  [313518] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13664), 1,
      anon_sym_EQ,
    ACTIONS(13666), 1,
      anon_sym_GT2,
    STATE(9634), 1,
      aux_sym_template_argument_list_repeat1,
  [313534] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    STATE(6174), 1,
      sym_field_declaration_list,
    STATE(9668), 1,
      sym_base_class_clause,
  [313550] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 1,
      anon_sym_LBRACE,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    STATE(9621), 2,
      sym_argument_list,
      sym_initializer_list,
  [313564] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13668), 1,
      anon_sym_EQ,
    ACTIONS(13670), 1,
      anon_sym_GT2,
    STATE(9633), 1,
      aux_sym_template_argument_list_repeat1,
  [313580] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13510), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13512), 1,
      sym_escape_sequence,
    ACTIONS(13672), 1,
      anon_sym_DQUOTE,
    STATE(8639), 1,
      aux_sym_string_literal_repeat1,
  [313596] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13451), 1,
      anon_sym_COMMA,
    STATE(8906), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(13674), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [313610] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4867), 1,
      anon_sym_LBRACE,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    STATE(4288), 1,
      sym_argument_list,
    STATE(4646), 1,
      sym_initializer_list,
  [313626] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11339), 1,
      anon_sym_LBRACE,
    STATE(4978), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [313640] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    STATE(5604), 1,
      sym_field_declaration_list,
    STATE(9694), 1,
      sym_base_class_clause,
  [313656] = 4,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13676), 1,
      anon_sym_SQUOTE,
    STATE(8638), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(13496), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [313670] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13510), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13512), 1,
      sym_escape_sequence,
    ACTIONS(13678), 1,
      anon_sym_DQUOTE,
    STATE(8639), 1,
      aux_sym_string_literal_repeat1,
  [313686] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10545), 1,
      anon_sym_LBRACE,
    ACTIONS(13524), 1,
      anon_sym_LPAREN2,
    STATE(3841), 1,
      sym_requirement_seq,
    STATE(9657), 1,
      sym_requires_parameter_list,
  [313702] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10572), 1,
      anon_sym_LBRACE,
    ACTIONS(13524), 1,
      anon_sym_LPAREN2,
    STATE(4650), 1,
      sym_requirement_seq,
    STATE(9911), 1,
      sym_requires_parameter_list,
  [313718] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13680), 1,
      anon_sym_EQ,
    ACTIONS(13682), 1,
      anon_sym_GT2,
    STATE(9597), 1,
      aux_sym_template_argument_list_repeat1,
  [313734] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13600), 1,
      anon_sym_COMMA,
    STATE(8663), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(13684), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [313748] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13686), 1,
      anon_sym_COMMA,
    STATE(8719), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(13689), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [313762] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11327), 1,
      anon_sym_LBRACE,
    STATE(4495), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [313776] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13691), 1,
      anon_sym_EQ,
    ACTIONS(13693), 1,
      anon_sym_GT2,
    STATE(9588), 1,
      aux_sym_template_argument_list_repeat1,
  [313792] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(13695), 1,
      anon_sym_SEMI,
    STATE(8737), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [313806] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11712), 1,
      sym_identifier,
    ACTIONS(13697), 1,
      aux_sym_preproc_if_token2,
    STATE(8778), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [313820] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4577), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(1329), 1,
      sym_field_declaration_list,
    STATE(9714), 1,
      sym_base_class_clause,
  [313836] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13699), 1,
      anon_sym_COMMA,
    STATE(8725), 1,
      aux_sym_field_declaration_repeat1,
    ACTIONS(13702), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [313850] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13704), 1,
      anon_sym_EQ,
    STATE(7619), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [313864] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(9718), 1,
      sym_base_class_clause,
  [313880] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    STATE(3147), 1,
      sym_field_declaration_list,
    STATE(10033), 1,
      sym_base_class_clause,
  [313896] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5033), 1,
      anon_sym_LT,
    ACTIONS(13484), 1,
      sym_identifier,
    STATE(194), 1,
      sym_template_type,
    STATE(1088), 1,
      sym_template_parameter_list,
  [313912] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    ACTIONS(13706), 1,
      anon_sym_SEMI,
    STATE(2816), 1,
      sym_template_argument_list,
  [313928] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    STATE(9196), 1,
      sym_compound_statement,
    STATE(9643), 1,
      sym_field_initializer_list,
  [313944] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    ACTIONS(13708), 1,
      anon_sym_SEMI,
    STATE(2816), 1,
      sym_template_argument_list,
  [313960] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11327), 1,
      anon_sym_LBRACE,
    STATE(4466), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [313974] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(13710), 1,
      anon_sym_SEMI,
    STATE(8752), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [313988] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(7760), 1,
      anon_sym_LBRACE,
    STATE(4712), 1,
      sym_field_declaration_list,
    STATE(9661), 1,
      sym_base_class_clause,
  [314004] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13712), 1,
      anon_sym_DQUOTE,
    ACTIONS(13714), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13716), 1,
      sym_escape_sequence,
    STATE(8742), 1,
      aux_sym_string_literal_repeat1,
  [314020] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(13718), 1,
      anon_sym_SEMI,
    STATE(5675), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [314034] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13720), 1,
      anon_sym_EQ,
    STATE(8840), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [314048] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    STATE(3128), 1,
      sym_field_declaration_list,
    STATE(9689), 1,
      sym_base_class_clause,
  [314064] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13295), 1,
      anon_sym_COMMA,
    STATE(8917), 1,
      aux_sym_base_class_clause_repeat1,
    ACTIONS(13327), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [314078] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4577), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(1320), 1,
      sym_field_declaration_list,
    STATE(9746), 1,
      sym_base_class_clause,
  [314094] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13510), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13512), 1,
      sym_escape_sequence,
    ACTIONS(13722), 1,
      anon_sym_DQUOTE,
    STATE(8639), 1,
      aux_sym_string_literal_repeat1,
  [314110] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4577), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(1326), 1,
      sym_field_declaration_list,
    STATE(9747), 1,
      sym_base_class_clause,
  [314126] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11347), 1,
      anon_sym_LBRACE,
    STATE(4166), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [314140] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13724), 1,
      anon_sym_EQ,
    STATE(8817), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [314154] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13726), 1,
      anon_sym_EQ,
    ACTIONS(13728), 1,
      anon_sym_GT2,
    STATE(9480), 1,
      aux_sym_template_argument_list_repeat1,
  [314170] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5033), 1,
      anon_sym_LT,
    ACTIONS(13484), 1,
      sym_identifier,
    STATE(194), 1,
      sym_template_type,
    STATE(1085), 1,
      sym_template_parameter_list,
  [314186] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13295), 1,
      anon_sym_COMMA,
    STATE(8917), 1,
      aux_sym_base_class_clause_repeat1,
    ACTIONS(13730), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [314200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13732), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(13734), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [314212] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11327), 1,
      anon_sym_LBRACE,
    STATE(4449), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [314226] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13736), 1,
      anon_sym_EQ,
    ACTIONS(13738), 1,
      anon_sym_GT2,
    STATE(9493), 1,
      aux_sym_template_argument_list_repeat1,
  [314242] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(13740), 1,
      anon_sym_SEMI,
    STATE(5675), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [314256] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4577), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(1289), 1,
      sym_field_declaration_list,
    STATE(9757), 1,
      sym_base_class_clause,
  [314272] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13510), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13512), 1,
      sym_escape_sequence,
    ACTIONS(13742), 1,
      anon_sym_DQUOTE,
    STATE(8639), 1,
      aux_sym_string_literal_repeat1,
  [314288] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13744), 1,
      anon_sym_EQ,
    ACTIONS(13746), 1,
      anon_sym_GT2,
    STATE(9488), 1,
      aux_sym_template_argument_list_repeat1,
  [314304] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(6961), 1,
      anon_sym_LBRACE,
    STATE(3448), 1,
      sym_field_declaration_list,
    STATE(9683), 1,
      sym_base_class_clause,
  [314320] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11398), 1,
      anon_sym_EQ,
    ACTIONS(12218), 1,
      anon_sym_COLON,
    ACTIONS(12216), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [314334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13748), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(13750), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [314346] = 4,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13752), 1,
      anon_sym_SQUOTE,
    STATE(8638), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(13496), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [314360] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13295), 1,
      anon_sym_COMMA,
    STATE(8674), 1,
      aux_sym_base_class_clause_repeat1,
    ACTIONS(13430), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [314374] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13295), 1,
      anon_sym_COMMA,
    STATE(8917), 1,
      aux_sym_base_class_clause_repeat1,
    ACTIONS(13430), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [314388] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13754), 1,
      anon_sym_EQ,
    ACTIONS(13756), 1,
      anon_sym_GT2,
    STATE(9469), 1,
      aux_sym_template_argument_list_repeat1,
  [314404] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13490), 1,
      anon_sym_LPAREN,
    ACTIONS(13758), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13760), 1,
      sym_preproc_arg,
    STATE(9842), 1,
      sym_preproc_params,
  [314420] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2479), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(396), 1,
      sym_field_declaration_list,
    STATE(9676), 1,
      sym_base_class_clause,
  [314436] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(7760), 1,
      anon_sym_LBRACE,
    STATE(4691), 1,
      sym_field_declaration_list,
    STATE(9703), 1,
      sym_base_class_clause,
  [314452] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13762), 1,
      anon_sym_DQUOTE,
    ACTIONS(13764), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13766), 1,
      sym_escape_sequence,
    STATE(8809), 1,
      aux_sym_string_literal_repeat1,
  [314468] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(13385), 1,
      aux_sym_preproc_if_token2,
    STATE(8825), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(10290), 1,
      sym_enumerator,
  [314484] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13768), 1,
      anon_sym_DQUOTE,
    ACTIONS(13770), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13772), 1,
      sym_escape_sequence,
    STATE(8785), 1,
      aux_sym_string_literal_repeat1,
  [314500] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13774), 1,
      anon_sym_DQUOTE,
    ACTIONS(13776), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13778), 1,
      sym_escape_sequence,
    STATE(8772), 1,
      aux_sym_string_literal_repeat1,
  [314516] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13780), 1,
      anon_sym___except,
    ACTIONS(13782), 1,
      anon_sym___finally,
    STATE(724), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [314530] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13784), 1,
      anon_sym_DQUOTE,
    ACTIONS(13786), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13788), 1,
      sym_escape_sequence,
    STATE(8625), 1,
      aux_sym_string_literal_repeat1,
  [314546] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13510), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13512), 1,
      sym_escape_sequence,
    ACTIONS(13790), 1,
      anon_sym_DQUOTE,
    STATE(8639), 1,
      aux_sym_string_literal_repeat1,
  [314562] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13490), 1,
      anon_sym_LPAREN,
    ACTIONS(13792), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13794), 1,
      sym_preproc_arg,
    STATE(9801), 1,
      sym_preproc_params,
  [314578] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(13796), 1,
      anon_sym_SEMI,
    STATE(8699), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [314592] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13490), 1,
      anon_sym_LPAREN,
    ACTIONS(13798), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13800), 1,
      sym_preproc_arg,
    STATE(9846), 1,
      sym_preproc_params,
  [314608] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(6073), 1,
      sym_field_declaration_list,
    STATE(9774), 1,
      sym_base_class_clause,
  [314624] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13802), 1,
      anon_sym_DQUOTE,
    ACTIONS(13804), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13806), 1,
      sym_escape_sequence,
    STATE(8754), 1,
      aux_sym_string_literal_repeat1,
  [314640] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11712), 1,
      sym_identifier,
    ACTIONS(13808), 1,
      aux_sym_preproc_if_token2,
    STATE(8165), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [314654] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(638), 1,
      sym_field_declaration_list,
    STATE(9816), 1,
      sym_base_class_clause,
  [314670] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(726), 1,
      sym_field_declaration_list,
    STATE(10026), 1,
      sym_base_class_clause,
  [314686] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13810), 1,
      anon_sym_EQ,
    ACTIONS(13812), 1,
      anon_sym_GT2,
    STATE(9410), 1,
      aux_sym_template_argument_list_repeat1,
  [314702] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13814), 1,
      anon_sym___except,
    ACTIONS(13816), 1,
      anon_sym___finally,
    STATE(602), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [314716] = 4,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13818), 1,
      anon_sym_SQUOTE,
    STATE(8638), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(13496), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [314730] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13820), 1,
      anon_sym_EQ,
    ACTIONS(13822), 1,
      anon_sym_GT2,
    STATE(9406), 1,
      aux_sym_template_argument_list_repeat1,
  [314746] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13510), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13512), 1,
      sym_escape_sequence,
    ACTIONS(13824), 1,
      anon_sym_DQUOTE,
    STATE(8639), 1,
      aux_sym_string_literal_repeat1,
  [314762] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(6066), 1,
      sym_field_declaration_list,
    STATE(9775), 1,
      sym_base_class_clause,
  [314778] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13524), 1,
      anon_sym_LPAREN2,
    ACTIONS(13826), 1,
      anon_sym_LBRACE,
    STATE(6895), 1,
      sym_requirement_seq,
    STATE(9879), 1,
      sym_requires_parameter_list,
  [314794] = 4,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13828), 1,
      anon_sym_SQUOTE,
    STATE(8638), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(13496), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [314808] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11325), 1,
      anon_sym_LBRACE,
    STATE(1909), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [314822] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13295), 1,
      anon_sym_COMMA,
    STATE(8761), 1,
      aux_sym_base_class_clause_repeat1,
    ACTIONS(13297), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [314836] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4583), 1,
      anon_sym_LBRACE,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    STATE(4288), 1,
      sym_argument_list,
    STATE(4291), 1,
      sym_initializer_list,
  [314852] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(13830), 1,
      anon_sym_SEMI,
    STATE(8813), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [314866] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13832), 1,
      anon_sym_EQ,
    STATE(7619), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [314880] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(13834), 1,
      anon_sym_SEMI,
    STATE(8618), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [314894] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 1,
      anon_sym_LBRACE,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    STATE(3305), 1,
      sym_argument_list,
    STATE(4688), 1,
      sym_initializer_list,
  [314910] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12764), 1,
      anon_sym_EQ,
    STATE(8793), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [314924] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13836), 1,
      anon_sym_DQUOTE,
    ACTIONS(13838), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13840), 1,
      sym_escape_sequence,
    STATE(8800), 1,
      aux_sym_string_literal_repeat1,
  [314940] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13295), 1,
      anon_sym_COMMA,
    STATE(8917), 1,
      aux_sym_base_class_clause_repeat1,
    ACTIONS(13297), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [314954] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13842), 1,
      anon_sym_EQ,
    STATE(7619), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [314968] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13510), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13512), 1,
      sym_escape_sequence,
    ACTIONS(13844), 1,
      anon_sym_DQUOTE,
    STATE(8639), 1,
      aux_sym_string_literal_repeat1,
  [314984] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2171), 1,
      anon_sym_SEMI,
    ACTIONS(3487), 1,
      anon_sym_LT,
    STATE(2836), 1,
      sym_template_argument_list,
  [315000] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12752), 1,
      anon_sym_EQ,
    STATE(8799), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [315014] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(617), 1,
      sym_field_declaration_list,
    STATE(9832), 1,
      sym_base_class_clause,
  [315030] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(2700), 1,
      sym_field_declaration_list,
    STATE(9870), 1,
      sym_base_class_clause,
  [315046] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    ACTIONS(13846), 1,
      anon_sym_SEMI,
    STATE(2816), 1,
      sym_template_argument_list,
  [315062] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13490), 1,
      anon_sym_LPAREN,
    ACTIONS(13848), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13850), 1,
      sym_preproc_arg,
    STATE(9867), 1,
      sym_preproc_params,
  [315078] = 4,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13852), 1,
      anon_sym_SQUOTE,
    STATE(8638), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(13496), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [315092] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13854), 1,
      anon_sym_EQ,
    ACTIONS(13856), 1,
      anon_sym_GT2,
    STATE(9346), 1,
      aux_sym_template_argument_list_repeat1,
  [315108] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13510), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13512), 1,
      sym_escape_sequence,
    ACTIONS(13858), 1,
      anon_sym_DQUOTE,
    STATE(8639), 1,
      aux_sym_string_literal_repeat1,
  [315124] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11325), 1,
      anon_sym_LBRACE,
    STATE(1921), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [315138] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13860), 1,
      anon_sym_EQ,
    ACTIONS(13862), 1,
      anon_sym_GT2,
    STATE(9334), 1,
      aux_sym_template_argument_list_repeat1,
  [315154] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5154), 1,
      anon_sym_LBRACE,
    ACTIONS(13864), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13866), 1,
      anon_sym_EQ,
    STATE(543), 1,
      sym_declaration_list,
  [315170] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(13868), 1,
      anon_sym_SEMI,
    STATE(5675), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [315184] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13870), 1,
      anon_sym_EQ,
    ACTIONS(13872), 1,
      anon_sym_GT2,
    STATE(9299), 1,
      aux_sym_template_argument_list_repeat1,
  [315200] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10512), 1,
      anon_sym_LBRACE,
    ACTIONS(13524), 1,
      anon_sym_LPAREN2,
    STATE(3286), 1,
      sym_requirement_seq,
    STATE(9838), 1,
      sym_requires_parameter_list,
  [315216] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12770), 1,
      anon_sym_EQ,
    STATE(8828), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [315230] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13874), 1,
      anon_sym_EQ,
    STATE(7619), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [315244] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11325), 1,
      anon_sym_LBRACE,
    STATE(1849), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [315258] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11284), 1,
      anon_sym_LBRACE,
    STATE(3265), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [315272] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(13876), 1,
      anon_sym_SEMI,
    STATE(5675), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [315286] = 4,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13878), 1,
      anon_sym_SQUOTE,
    STATE(8638), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(13496), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [315300] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13880), 1,
      anon_sym_EQ,
    ACTIONS(13882), 1,
      anon_sym_GT2,
    STATE(9292), 1,
      aux_sym_template_argument_list_repeat1,
  [315316] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(13884), 1,
      anon_sym_SEMI,
    STATE(8887), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [315330] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5148), 1,
      anon_sym_LBRACE,
    ACTIONS(13864), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13886), 1,
      anon_sym_EQ,
    STATE(1073), 1,
      sym_declaration_list,
  [315346] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(13888), 1,
      aux_sym_preproc_if_token2,
    STATE(8173), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(10290), 1,
      sym_enumerator,
  [315362] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13890), 1,
      anon_sym_EQ,
    ACTIONS(13892), 1,
      anon_sym_GT2,
    STATE(9090), 1,
      aux_sym_template_argument_list_repeat1,
  [315378] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11339), 1,
      anon_sym_LBRACE,
    STATE(4970), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [315392] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13894), 1,
      anon_sym_EQ,
    STATE(7619), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [315406] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13896), 1,
      anon_sym___except,
    ACTIONS(13898), 1,
      anon_sym___finally,
    STATE(395), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [315420] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(601), 1,
      sym_field_declaration_list,
    STATE(9952), 1,
      sym_base_class_clause,
  [315436] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13900), 1,
      anon_sym_EQ,
    ACTIONS(13902), 1,
      anon_sym_GT2,
    STATE(9263), 1,
      aux_sym_template_argument_list_repeat1,
  [315452] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(2703), 1,
      sym_field_declaration_list,
    STATE(9982), 1,
      sym_base_class_clause,
  [315468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13904), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(13906), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [315480] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13908), 1,
      anon_sym_EQ,
    ACTIONS(13910), 1,
      anon_sym_GT2,
    STATE(9260), 1,
      aux_sym_template_argument_list_repeat1,
  [315496] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10529), 1,
      anon_sym_LBRACE,
    ACTIONS(13524), 1,
      anon_sym_LPAREN2,
    STATE(4995), 1,
      sym_requirement_seq,
    STATE(9872), 1,
      sym_requires_parameter_list,
  [315512] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5152), 1,
      anon_sym_LBRACE,
    ACTIONS(13864), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13912), 1,
      anon_sym_EQ,
    STATE(980), 1,
      sym_declaration_list,
  [315528] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13914), 1,
      anon_sym_DQUOTE,
    ACTIONS(13916), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13918), 1,
      sym_escape_sequence,
    STATE(8844), 1,
      aux_sym_string_literal_repeat1,
  [315544] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12683), 1,
      anon_sym_EQ,
    STATE(8868), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [315558] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13510), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13512), 1,
      sym_escape_sequence,
    ACTIONS(13920), 1,
      anon_sym_DQUOTE,
    STATE(8639), 1,
      aux_sym_string_literal_repeat1,
  [315574] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13922), 1,
      anon_sym_EQ,
    STATE(7619), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [315588] = 4,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13924), 1,
      anon_sym_SQUOTE,
    STATE(8638), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(13496), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [315602] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(8483), 1,
      anon_sym_LBRACE,
    STATE(4919), 1,
      sym_field_declaration_list,
    STATE(9887), 1,
      sym_base_class_clause,
  [315618] = 4,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13926), 1,
      anon_sym_SQUOTE,
    STATE(8638), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(13496), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [315632] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13510), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13512), 1,
      sym_escape_sequence,
    ACTIONS(13928), 1,
      anon_sym_DQUOTE,
    STATE(8639), 1,
      aux_sym_string_literal_repeat1,
  [315648] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3487), 1,
      anon_sym_LT,
    ACTIONS(13930), 1,
      anon_sym_SEMI,
    STATE(2816), 1,
      sym_template_argument_list,
  [315664] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13932), 1,
      anon_sym_EQ,
    ACTIONS(13934), 1,
      anon_sym_GT2,
    STATE(9363), 1,
      aux_sym_template_argument_list_repeat1,
  [315680] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10553), 1,
      anon_sym_LBRACE,
    ACTIONS(13524), 1,
      anon_sym_LPAREN2,
    STATE(4537), 1,
      sym_requirement_seq,
    STATE(9654), 1,
      sym_requires_parameter_list,
  [315696] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11378), 1,
      anon_sym_LBRACE,
    STATE(6767), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [315710] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13936), 1,
      anon_sym_EQ,
    ACTIONS(13938), 1,
      anon_sym_GT2,
    STATE(9304), 1,
      aux_sym_template_argument_list_repeat1,
  [315726] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(13940), 1,
      anon_sym_SEMI,
    STATE(8858), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [315740] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13510), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13512), 1,
      sym_escape_sequence,
    ACTIONS(13942), 1,
      anon_sym_DQUOTE,
    STATE(8639), 1,
      aux_sym_string_literal_repeat1,
  [315756] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(8483), 1,
      anon_sym_LBRACE,
    STATE(4895), 1,
      sym_field_declaration_list,
    STATE(9896), 1,
      sym_base_class_clause,
  [315772] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13944), 1,
      anon_sym_EQ,
    ACTIONS(13946), 1,
      anon_sym_GT2,
    STATE(9209), 1,
      aux_sym_template_argument_list_repeat1,
  [315788] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(6961), 1,
      anon_sym_LBRACE,
    STATE(3412), 1,
      sym_field_declaration_list,
    STATE(9738), 1,
      sym_base_class_clause,
  [315804] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11378), 1,
      anon_sym_LBRACE,
    STATE(6869), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [315818] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13948), 1,
      anon_sym_EQ,
    ACTIONS(13950), 1,
      anon_sym_GT2,
    STATE(9174), 1,
      aux_sym_template_argument_list_repeat1,
  [315834] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(13952), 1,
      anon_sym_SEMI,
    STATE(8863), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [315848] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(13954), 1,
      anon_sym_SEMI,
    STATE(5675), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [315862] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13956), 4,
      anon_sym_LPAREN2,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [315872] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11304), 1,
      anon_sym_LBRACE,
    STATE(4404), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [315886] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13958), 1,
      anon_sym_EQ,
    ACTIONS(13960), 1,
      anon_sym_GT2,
    STATE(9188), 1,
      aux_sym_template_argument_list_repeat1,
  [315902] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11378), 1,
      anon_sym_LBRACE,
    STATE(6769), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [315916] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(13962), 1,
      anon_sym_SEMI,
    STATE(5675), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [315930] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13964), 1,
      anon_sym_EQ,
    ACTIONS(13966), 1,
      anon_sym_GT2,
    STATE(9185), 1,
      aux_sym_template_argument_list_repeat1,
  [315946] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5156), 1,
      anon_sym_LBRACE,
    ACTIONS(13864), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13968), 1,
      anon_sym_EQ,
    STATE(861), 1,
      sym_declaration_list,
  [315962] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12732), 1,
      anon_sym_EQ,
    STATE(8908), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [315976] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym_LBRACE,
    ACTIONS(7352), 1,
      anon_sym_LPAREN2,
    STATE(4462), 1,
      sym_argument_list,
    STATE(5743), 1,
      sym_initializer_list,
  [315992] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13970), 1,
      anon_sym_EQ,
    STATE(7619), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [316006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13972), 1,
      sym_identifier,
    ACTIONS(13974), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [316018] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13976), 1,
      anon_sym_DQUOTE,
    ACTIONS(13978), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13980), 1,
      sym_escape_sequence,
    STATE(8876), 1,
      aux_sym_string_literal_repeat1,
  [316034] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11284), 1,
      anon_sym_LBRACE,
    STATE(3309), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [316048] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(7278), 1,
      anon_sym_LBRACE,
    STATE(3617), 1,
      sym_field_declaration_list,
    STATE(9934), 1,
      sym_base_class_clause,
  [316064] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(7067), 1,
      anon_sym_LBRACE,
    STATE(3506), 1,
      sym_field_declaration_list,
    STATE(9903), 1,
      sym_base_class_clause,
  [316080] = 4,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13982), 1,
      anon_sym_SQUOTE,
    STATE(8638), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(13496), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [316094] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13984), 1,
      anon_sym_EQ,
    ACTIONS(13986), 1,
      anon_sym_GT2,
    STATE(9148), 1,
      aux_sym_template_argument_list_repeat1,
  [316110] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13510), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13512), 1,
      sym_escape_sequence,
    ACTIONS(13988), 1,
      anon_sym_DQUOTE,
    STATE(8639), 1,
      aux_sym_string_literal_repeat1,
  [316126] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13524), 1,
      anon_sym_LPAREN2,
    ACTIONS(13990), 1,
      anon_sym_LBRACE,
    STATE(6842), 1,
      sym_requirement_seq,
    STATE(9923), 1,
      sym_requires_parameter_list,
  [316142] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13992), 1,
      anon_sym_EQ,
    ACTIONS(13994), 1,
      anon_sym_GT2,
    STATE(9147), 1,
      aux_sym_template_argument_list_repeat1,
  [316158] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11343), 1,
      anon_sym_LBRACE,
    STATE(6886), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [316172] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(13996), 1,
      anon_sym_SEMI,
    STATE(8893), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [316186] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4418), 1,
      anon_sym_LBRACE,
    ACTIONS(6568), 1,
      anon_sym_LPAREN2,
    STATE(3305), 1,
      sym_argument_list,
    STATE(3325), 1,
      sym_initializer_list,
  [316202] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(965), 1,
      sym_field_declaration_list,
    STATE(9981), 1,
      sym_base_class_clause,
  [316218] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12724), 1,
      anon_sym_EQ,
    STATE(8661), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [316232] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13998), 1,
      anon_sym_EQ,
    ACTIONS(14000), 1,
      anon_sym_GT2,
    STATE(9088), 1,
      aux_sym_template_argument_list_repeat1,
  [316248] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(7278), 1,
      anon_sym_LBRACE,
    STATE(3667), 1,
      sym_field_declaration_list,
    STATE(9980), 1,
      sym_base_class_clause,
  [316264] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(14002), 1,
      anon_sym_SEMI,
    STATE(8938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [316278] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(14004), 1,
      anon_sym_SEMI,
    STATE(5675), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [316292] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14006), 1,
      anon_sym_SEMI,
    ACTIONS(14008), 1,
      anon_sym_DASH_GT,
    ACTIONS(14010), 1,
      anon_sym_noexcept,
    STATE(10172), 1,
      sym_trailing_return_type,
  [316308] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(582), 1,
      sym_field_declaration_list,
    STATE(9995), 1,
      sym_base_class_clause,
  [316324] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(581), 1,
      sym_field_declaration_list,
    STATE(10048), 1,
      sym_base_class_clause,
  [316340] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11343), 1,
      anon_sym_LBRACE,
    STATE(6849), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [316354] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(14012), 1,
      anon_sym_SEMI,
    STATE(8898), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [316368] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(14014), 1,
      anon_sym_SEMI,
    STATE(5675), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [316382] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14016), 1,
      anon_sym_EQ,
    ACTIONS(14018), 1,
      anon_sym_GT2,
    STATE(9091), 1,
      aux_sym_template_argument_list_repeat1,
  [316398] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14020), 1,
      anon_sym_EQ,
    ACTIONS(14022), 1,
      anon_sym_GT2,
    STATE(9601), 1,
      aux_sym_template_argument_list_repeat1,
  [316414] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11343), 1,
      anon_sym_LBRACE,
    STATE(6828), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [316428] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14024), 1,
      anon_sym_EQ,
    ACTIONS(14026), 1,
      anon_sym_GT2,
    STATE(9076), 1,
      aux_sym_template_argument_list_repeat1,
  [316444] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(14028), 1,
      anon_sym_SEMI,
    STATE(5675), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [316458] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14030), 1,
      anon_sym_EQ,
    ACTIONS(14032), 1,
      anon_sym_GT2,
    STATE(9085), 1,
      aux_sym_template_argument_list_repeat1,
  [316474] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14034), 1,
      anon_sym_EQ,
    ACTIONS(14036), 1,
      anon_sym_GT2,
    STATE(9075), 1,
      aux_sym_template_argument_list_repeat1,
  [316490] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5033), 1,
      anon_sym_LT,
    ACTIONS(13484), 1,
      sym_identifier,
    STATE(194), 1,
      sym_template_type,
    STATE(1086), 1,
      sym_template_parameter_list,
  [316506] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10537), 1,
      anon_sym_LBRACE,
    ACTIONS(13524), 1,
      anon_sym_LPAREN2,
    STATE(4300), 1,
      sym_requirement_seq,
    STATE(9994), 1,
      sym_requires_parameter_list,
  [316522] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(14038), 1,
      anon_sym_DQUOTE,
    ACTIONS(14040), 1,
      aux_sym_string_literal_token1,
    ACTIONS(14042), 1,
      sym_escape_sequence,
    STATE(8839), 1,
      aux_sym_string_literal_repeat1,
  [316538] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13510), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13512), 1,
      sym_escape_sequence,
    ACTIONS(14044), 1,
      anon_sym_DQUOTE,
    STATE(8639), 1,
      aux_sym_string_literal_repeat1,
  [316554] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14046), 1,
      anon_sym___except,
    ACTIONS(14048), 1,
      anon_sym___finally,
    STATE(719), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [316568] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14050), 1,
      anon_sym_COMMA,
    STATE(8906), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(14053), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [316582] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12691), 1,
      anon_sym_EQ,
    STATE(8726), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [316596] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(14055), 1,
      anon_sym_EQ,
    STATE(7619), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [316610] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13510), 1,
      aux_sym_string_literal_token1,
    ACTIONS(13512), 1,
      sym_escape_sequence,
    ACTIONS(14057), 1,
      anon_sym_DQUOTE,
    STATE(8639), 1,
      aux_sym_string_literal_repeat1,
  [316626] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14059), 1,
      anon_sym_EQ,
    ACTIONS(14061), 1,
      anon_sym_GT2,
    STATE(9378), 1,
      aux_sym_template_argument_list_repeat1,
  [316642] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(14063), 1,
      anon_sym_SEMI,
    STATE(8624), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [316656] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(14065), 1,
      anon_sym_DQUOTE,
    ACTIONS(14067), 1,
      aux_sym_string_literal_token1,
    ACTIONS(14069), 1,
      sym_escape_sequence,
    STATE(8909), 1,
      aux_sym_string_literal_repeat1,
  [316672] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(740), 1,
      sym_field_declaration_list,
    STATE(10050), 1,
      sym_base_class_clause,
  [316688] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(14071), 1,
      anon_sym_SEMI,
    STATE(5675), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [316702] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(7067), 1,
      anon_sym_LBRACE,
    STATE(3497), 1,
      sym_field_declaration_list,
    STATE(9910), 1,
      sym_base_class_clause,
  [316718] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12442), 1,
      anon_sym_COMMA,
    STATE(8611), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(14073), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [316732] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14075), 1,
      anon_sym_COMMA,
    STATE(8917), 1,
      aux_sym_base_class_clause_repeat1,
    ACTIONS(13906), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [316746] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    STATE(10022), 1,
      sym_argument_list,
    ACTIONS(14078), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [316760] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14080), 1,
      anon_sym_EQ,
    ACTIONS(14082), 1,
      anon_sym_GT2,
    STATE(9037), 1,
      aux_sym_template_argument_list_repeat1,
  [316776] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    STATE(9374), 1,
      sym_compound_statement,
    STATE(9965), 1,
      sym_field_initializer_list,
  [316792] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    STATE(5654), 1,
      sym_field_declaration_list,
    STATE(10040), 1,
      sym_base_class_clause,
  [316808] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14084), 1,
      anon_sym_EQ,
    ACTIONS(14086), 1,
      anon_sym_GT2,
    STATE(9021), 1,
      aux_sym_template_argument_list_repeat1,
  [316824] = 4,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(14088), 1,
      anon_sym_SQUOTE,
    STATE(8638), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(13496), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [316838] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(13490), 1,
      anon_sym_LPAREN,
    ACTIONS(14090), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(14092), 1,
      sym_preproc_arg,
    STATE(9807), 1,
      sym_preproc_params,
  [316854] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(1909), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [316868] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(742), 1,
      sym_field_declaration_list,
    STATE(10055), 1,
      sym_base_class_clause,
  [316884] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11284), 1,
      anon_sym_LBRACE,
    STATE(3297), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [316898] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    STATE(5731), 1,
      sym_field_declaration_list,
    STATE(10046), 1,
      sym_base_class_clause,
  [316914] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(1921), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [316928] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14094), 1,
      anon_sym_EQ,
    ACTIONS(14096), 1,
      anon_sym_GT2,
    STATE(8982), 1,
      aux_sym_template_argument_list_repeat1,
  [316944] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(1849), 1,
      sym_compound_statement,
    ACTIONS(11507), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [316958] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14098), 1,
      anon_sym_EQ,
    ACTIONS(14100), 1,
      anon_sym_GT2,
    STATE(8981), 1,
      aux_sym_template_argument_list_repeat1,
  [316974] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14102), 1,
      anon_sym_EQ,
    ACTIONS(14104), 1,
      anon_sym_GT2,
    STATE(8952), 1,
      aux_sym_template_argument_list_repeat1,
  [316990] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    STATE(554), 1,
      sym_field_declaration_list,
    STATE(9674), 1,
      sym_base_class_clause,
  [317006] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14106), 1,
      anon_sym_EQ,
    ACTIONS(14108), 1,
      anon_sym_GT2,
    STATE(8970), 1,
      aux_sym_template_argument_list_repeat1,
  [317022] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14110), 1,
      anon_sym_EQ,
    ACTIONS(14112), 1,
      anon_sym_GT2,
    STATE(8953), 1,
      aux_sym_template_argument_list_repeat1,
  [317038] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14114), 1,
      anon_sym_EQ,
    ACTIONS(14116), 1,
      anon_sym_GT2,
    STATE(8972), 1,
      aux_sym_template_argument_list_repeat1,
  [317054] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym___attribute__,
    ACTIONS(14118), 1,
      anon_sym_SEMI,
    STATE(5675), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [317068] = 5,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(14120), 1,
      anon_sym_DQUOTE,
    ACTIONS(14122), 1,
      aux_sym_string_literal_token1,
    ACTIONS(14124), 1,
      sym_escape_sequence,
    STATE(8904), 1,
      aux_sym_string_literal_repeat1,
  [317084] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11116), 1,
      anon_sym_RPAREN,
    ACTIONS(14126), 1,
      anon_sym_COMMA,
    STATE(8940), 1,
      aux_sym_preproc_argument_list_repeat1,
  [317097] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14129), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317110] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14131), 1,
      anon_sym_RPAREN,
    ACTIONS(14133), 1,
      anon_sym_COLON,
    STATE(9546), 1,
      sym_gnu_asm_clobber_list,
  [317123] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5156), 1,
      anon_sym_LBRACE,
    ACTIONS(13864), 1,
      anon_sym_COLON_COLON,
    STATE(873), 1,
      sym_declaration_list,
  [317136] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13461), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317149] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5389), 1,
      anon_sym_RBRACE,
    ACTIONS(14135), 1,
      anon_sym_COMMA,
    STATE(9342), 1,
      aux_sym_initializer_list_repeat1,
  [317162] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14137), 1,
      anon_sym_GT2,
    STATE(8949), 1,
      aux_sym_template_argument_list_repeat1,
  [317175] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14139), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317188] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14104), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317201] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14141), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317214] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14112), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317227] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14143), 1,
      anon_sym_GT2,
    STATE(8954), 1,
      aux_sym_template_argument_list_repeat1,
  [317240] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14143), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317253] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9339), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317266] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14145), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317279] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14145), 1,
      anon_sym_GT2,
    STATE(8958), 1,
      aux_sym_template_argument_list_repeat1,
  [317292] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9265), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317305] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14147), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317318] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14149), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317331] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14151), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317344] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(14153), 1,
      anon_sym_RPAREN,
    STATE(9011), 1,
      aux_sym_argument_list_repeat1,
  [317357] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14155), 1,
      anon_sym_COMMA,
    ACTIONS(14158), 1,
      anon_sym_GT2,
    STATE(8961), 1,
      aux_sym_template_parameter_list_repeat1,
  [317370] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14160), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317383] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14162), 1,
      anon_sym_GT2,
    STATE(8967), 1,
      aux_sym_template_argument_list_repeat1,
  [317396] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14164), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317409] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14166), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317422] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14108), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317435] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14168), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317448] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14116), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317461] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14170), 1,
      anon_sym_GT2,
    STATE(8973), 1,
      aux_sym_template_argument_list_repeat1,
  [317474] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14170), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317487] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9345), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317500] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9261), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317513] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14172), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317526] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14172), 1,
      anon_sym_GT2,
    STATE(8977), 1,
      aux_sym_template_argument_list_repeat1,
  [317539] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9257), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317552] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    STATE(8874), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(14174), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [317563] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14176), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317576] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14178), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317589] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14180), 1,
      anon_sym_GT2,
    STATE(8964), 1,
      aux_sym_template_argument_list_repeat1,
  [317602] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14180), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317615] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9343), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317628] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14182), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317641] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14182), 1,
      anon_sym_GT2,
    STATE(8980), 1,
      aux_sym_template_argument_list_repeat1,
  [317654] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5232), 1,
      anon_sym_RBRACE,
    ACTIONS(14184), 1,
      anon_sym_COMMA,
    STATE(9342), 1,
      aux_sym_initializer_list_repeat1,
  [317667] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14100), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317680] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6638), 1,
      anon_sym_COMMA,
    ACTIONS(14186), 1,
      anon_sym_RBRACK,
    STATE(9010), 1,
      aux_sym_structured_binding_declarator_repeat1,
  [317693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14188), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [317702] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    ACTIONS(14192), 1,
      anon_sym_constexpr,
    STATE(1128), 1,
      sym_condition_clause,
  [317715] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9059), 1,
      anon_sym_COMMA,
    ACTIONS(14194), 1,
      anon_sym_RBRACK,
    STATE(9003), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [317728] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14196), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317741] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14198), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317754] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14200), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317767] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    STATE(8620), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(14202), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [317778] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14204), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317791] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5148), 1,
      anon_sym_LBRACE,
    ACTIONS(13864), 1,
      anon_sym_COLON_COLON,
    STATE(1004), 1,
      sym_declaration_list,
  [317804] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14096), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317817] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    STATE(8843), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(14206), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [317828] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10811), 1,
      anon_sym_COMMA,
    ACTIONS(14208), 1,
      anon_sym_RPAREN,
    STATE(8940), 1,
      aux_sym_preproc_argument_list_repeat1,
  [317841] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(14210), 1,
      anon_sym_SEMI,
    STATE(10157), 1,
      sym_base_class_clause,
  [317854] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14212), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317867] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5148), 1,
      anon_sym_LBRACE,
    ACTIONS(13864), 1,
      anon_sym_COLON_COLON,
    STATE(1035), 1,
      sym_declaration_list,
  [317880] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14214), 1,
      anon_sym_COMMA,
    ACTIONS(14216), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(9034), 1,
      aux_sym_attribute_declaration_repeat1,
  [317893] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9525), 1,
      anon_sym_RBRACK,
    ACTIONS(14218), 1,
      anon_sym_COMMA,
    STATE(9003), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [317906] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14221), 1,
      anon_sym_RPAREN,
    ACTIONS(14223), 1,
      anon_sym_COLON,
    STATE(10782), 1,
      sym_gnu_asm_goto_list,
  [317919] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9289), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [317932] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8998), 1,
      anon_sym_RBRACE,
    ACTIONS(9115), 1,
      anon_sym_COMMA,
    STATE(8984), 1,
      aux_sym_initializer_list_repeat1,
  [317945] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14225), 1,
      anon_sym_GT2,
    STATE(8994), 1,
      aux_sym_template_argument_list_repeat1,
  [317958] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14227), 1,
      anon_sym_GT2,
    STATE(9583), 1,
      aux_sym_template_argument_list_repeat1,
  [317971] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    STATE(8923), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(14229), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [317982] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14231), 1,
      anon_sym_COMMA,
    ACTIONS(14234), 1,
      anon_sym_RBRACK,
    STATE(9010), 1,
      aux_sym_structured_binding_declarator_repeat1,
  [317995] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9617), 1,
      anon_sym_RPAREN,
    ACTIONS(14236), 1,
      anon_sym_COMMA,
    STATE(9011), 1,
      aux_sym_argument_list_repeat1,
  [318008] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14239), 1,
      anon_sym_GT2,
    STATE(8992), 1,
      aux_sym_template_argument_list_repeat1,
  [318021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14241), 1,
      anon_sym_EQ,
    ACTIONS(12665), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [318032] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2838), 1,
      anon_sym_while,
    ACTIONS(14243), 1,
      anon_sym_else,
    STATE(557), 1,
      sym_else_clause,
  [318045] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14239), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318058] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13465), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318071] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14245), 1,
      anon_sym_GT2,
    STATE(9035), 1,
      aux_sym_template_argument_list_repeat1,
  [318084] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14245), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318097] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14247), 1,
      sym_identifier,
    STATE(194), 1,
      sym_template_type,
    STATE(3789), 1,
      sym_template_function,
  [318110] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    STATE(8788), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(14249), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [318121] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9293), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318134] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14251), 1,
      anon_sym_RPAREN,
    ACTIONS(14253), 1,
      anon_sym_COLON,
    STATE(9275), 1,
      sym_gnu_asm_input_operand_list,
  [318147] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9139), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318160] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14255), 1,
      anon_sym_RPAREN,
    ACTIONS(14257), 1,
      anon_sym_COLON,
    STATE(9277), 1,
      sym_gnu_asm_output_operand_list,
  [318173] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14223), 1,
      anon_sym_COLON,
    ACTIONS(14259), 1,
      anon_sym_RPAREN,
    STATE(10869), 1,
      sym_gnu_asm_goto_list,
  [318186] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14261), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [318195] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9408), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318208] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14263), 1,
      anon_sym_default,
    ACTIONS(14265), 1,
      anon_sym_delete,
    ACTIONS(14267), 1,
      anon_sym_0,
  [318221] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14269), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318234] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(9221), 1,
      anon_sym_RPAREN,
    STATE(9011), 1,
      aux_sym_argument_list_repeat1,
  [318247] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(9165), 1,
      anon_sym_RPAREN,
    STATE(9011), 1,
      aux_sym_argument_list_repeat1,
  [318260] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9147), 1,
      anon_sym_COMMA,
    ACTIONS(14271), 1,
      anon_sym_RBRACK,
    STATE(9324), 1,
      aux_sym_subscript_argument_list_repeat1,
  [318273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14273), 1,
      anon_sym_catch,
    STATE(276), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [318284] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14275), 1,
      anon_sym_COMMA,
    ACTIONS(14278), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(9034), 1,
      aux_sym_attribute_declaration_repeat1,
  [318297] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14280), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318310] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14280), 1,
      anon_sym_GT2,
    STATE(9078), 1,
      aux_sym_template_argument_list_repeat1,
  [318323] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14282), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318336] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14284), 1,
      anon_sym_COMMA,
    ACTIONS(14286), 1,
      anon_sym_RPAREN,
    STATE(9232), 1,
      aux_sym_parameter_list_repeat1,
  [318349] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14282), 1,
      anon_sym_GT2,
    STATE(9015), 1,
      aux_sym_template_argument_list_repeat1,
  [318362] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13480), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318375] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14086), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318388] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14288), 1,
      anon_sym_default,
    ACTIONS(14290), 1,
      anon_sym_delete,
    ACTIONS(14292), 1,
      anon_sym_0,
  [318401] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14294), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318414] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14082), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318427] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14296), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318440] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14022), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318453] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14298), 1,
      anon_sym_GT2,
    STATE(9166), 1,
      aux_sym_template_argument_list_repeat1,
  [318466] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 1,
      anon_sym_LT,
    ACTIONS(6998), 1,
      anon_sym_SEMI,
    STATE(2836), 1,
      sym_template_argument_list,
  [318479] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14298), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318492] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9135), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318505] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14253), 1,
      anon_sym_COLON,
    ACTIONS(14300), 1,
      anon_sym_RPAREN,
    STATE(9639), 1,
      sym_gnu_asm_input_operand_list,
  [318518] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    STATE(8783), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(14302), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [318529] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14304), 1,
      anon_sym_GT2,
    STATE(9043), 1,
      aux_sym_template_argument_list_repeat1,
  [318542] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14133), 1,
      anon_sym_COLON,
    ACTIONS(14306), 1,
      anon_sym_RPAREN,
    STATE(9025), 1,
      sym_gnu_asm_clobber_list,
  [318555] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14308), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [318564] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14253), 1,
      anon_sym_COLON,
    ACTIONS(14310), 1,
      anon_sym_RPAREN,
    STATE(8942), 1,
      sym_gnu_asm_input_operand_list,
  [318577] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14223), 1,
      anon_sym_COLON,
    ACTIONS(14312), 1,
      anon_sym_RPAREN,
    STATE(10941), 1,
      sym_gnu_asm_goto_list,
  [318590] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9410), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318603] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14314), 1,
      sym_identifier,
    STATE(194), 1,
      sym_template_type,
    STATE(3475), 1,
      sym_template_function,
  [318616] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    ACTIONS(14316), 1,
      anon_sym_constexpr,
    STATE(1098), 1,
      sym_condition_clause,
  [318629] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14318), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318642] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14257), 1,
      anon_sym_COLON,
    ACTIONS(14320), 1,
      anon_sym_RPAREN,
    STATE(9051), 1,
      sym_gnu_asm_output_operand_list,
  [318655] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14322), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318668] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14061), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318681] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14324), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318694] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14326), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318707] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14328), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318720] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9299), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318733] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14330), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318746] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14257), 1,
      anon_sym_COLON,
    ACTIONS(14332), 1,
      anon_sym_RPAREN,
    STATE(9261), 1,
      sym_gnu_asm_output_operand_list,
  [318759] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14253), 1,
      anon_sym_COLON,
    ACTIONS(14334), 1,
      anon_sym_RPAREN,
    STATE(9249), 1,
      sym_gnu_asm_input_operand_list,
  [318772] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14336), 1,
      anon_sym_GT2,
    STATE(9067), 1,
      aux_sym_template_argument_list_repeat1,
  [318785] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14336), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318798] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14338), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318811] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9303), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318824] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14340), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318837] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14340), 1,
      anon_sym_GT2,
    STATE(9073), 1,
      aux_sym_template_argument_list_repeat1,
  [318850] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14342), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318863] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9059), 1,
      anon_sym_COMMA,
    ACTIONS(14344), 1,
      anon_sym_RBRACK,
    STATE(9003), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [318876] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9333), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318889] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14346), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318902] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14348), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318915] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14350), 1,
      anon_sym_GT2,
    STATE(9074), 1,
      aux_sym_template_argument_list_repeat1,
  [318928] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14350), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318941] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9331), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318954] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14352), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [318967] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14354), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [318980] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14227), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [318993] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14214), 1,
      anon_sym_COMMA,
    ACTIONS(14356), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(9393), 1,
      aux_sym_attribute_declaration_repeat1,
  [319006] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9245), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [319019] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14358), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [319032] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14358), 1,
      anon_sym_GT2,
    STATE(9084), 1,
      aux_sym_template_argument_list_repeat1,
  [319045] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14032), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [319058] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14036), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [319071] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14360), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [319084] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14026), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [319097] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    STATE(8759), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(14362), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [319108] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14364), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [319121] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14366), 1,
      anon_sym_SEMI,
    STATE(9511), 1,
      aux_sym_declaration_repeat1,
  [319134] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14368), 1,
      anon_sym_COMMA,
    ACTIONS(14370), 1,
      anon_sym_GT2,
    STATE(8961), 1,
      aux_sym_template_parameter_list_repeat1,
  [319147] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14018), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [319160] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14372), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [319173] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14374), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [319186] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6638), 1,
      anon_sym_COMMA,
    ACTIONS(14376), 1,
      anon_sym_RBRACK,
    STATE(8986), 1,
      aux_sym_structured_binding_declarator_repeat1,
  [319199] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(14378), 1,
      anon_sym_SEMI,
    STATE(10444), 1,
      sym_base_class_clause,
  [319212] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14284), 1,
      anon_sym_COMMA,
    ACTIONS(14380), 1,
      anon_sym_RPAREN,
    STATE(9232), 1,
      aux_sym_parameter_list_repeat1,
  [319225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14382), 1,
      anon_sym_catch,
    STATE(559), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [319236] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14384), 1,
      anon_sym_GT2,
    STATE(9095), 1,
      aux_sym_template_argument_list_repeat1,
  [319249] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9147), 1,
      anon_sym_COMMA,
    ACTIONS(14386), 1,
      anon_sym_RBRACK,
    STATE(9324), 1,
      aux_sym_subscript_argument_list_repeat1,
  [319262] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14388), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [319271] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14390), 1,
      sym_identifier,
    STATE(2873), 1,
      sym_template_type,
    STATE(4378), 1,
      sym_template_function,
  [319284] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14392), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [319297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14394), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [319306] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5403), 1,
      anon_sym_RBRACE,
    ACTIONS(14396), 1,
      anon_sym_COMMA,
    STATE(9342), 1,
      aux_sym_initializer_list_repeat1,
  [319319] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14398), 1,
      anon_sym_COMMA,
    ACTIONS(14401), 1,
      anon_sym_RPAREN,
    STATE(9115), 1,
      aux_sym_requires_parameter_list_repeat1,
  [319332] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14214), 1,
      anon_sym_COMMA,
    ACTIONS(14403), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(9244), 1,
      aux_sym_attribute_declaration_repeat1,
  [319345] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5154), 1,
      anon_sym_LBRACE,
    ACTIONS(13864), 1,
      anon_sym_COLON_COLON,
    STATE(475), 1,
      sym_declaration_list,
  [319358] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14405), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [319371] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14407), 3,
      anon_sym_RBRACE,
      anon_sym_get,
      anon_sym_set,
  [319380] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14409), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [319393] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14411), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [319406] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14413), 1,
      sym_identifier,
    STATE(2672), 1,
      sym_template_type,
    STATE(3301), 1,
      sym_template_function,
  [319419] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14415), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [319432] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14417), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [319445] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14419), 1,
      anon_sym_GT2,
    STATE(9440), 1,
      aux_sym_template_argument_list_repeat1,
  [319458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14423), 1,
      anon_sym_EQ,
    ACTIONS(14421), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [319469] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14425), 1,
      anon_sym_default,
    ACTIONS(14427), 1,
      anon_sym_delete,
    ACTIONS(14429), 1,
      anon_sym_0,
  [319482] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14431), 1,
      anon_sym_COMMA,
    ACTIONS(14433), 1,
      anon_sym_RPAREN,
    STATE(9356), 1,
      aux_sym_preproc_params_repeat1,
  [319495] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14435), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [319508] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(9325), 1,
      anon_sym_RPAREN,
    STATE(9011), 1,
      aux_sym_argument_list_repeat1,
  [319521] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10811), 1,
      anon_sym_COMMA,
    ACTIONS(14437), 1,
      anon_sym_RPAREN,
    STATE(8940), 1,
      aux_sym_preproc_argument_list_repeat1,
  [319534] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14439), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [319547] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14441), 1,
      anon_sym_GT2,
    STATE(9098), 1,
      aux_sym_template_argument_list_repeat1,
  [319560] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14443), 1,
      anon_sym_COMMA,
    ACTIONS(14446), 1,
      anon_sym_RPAREN,
    STATE(9134), 1,
      aux_sym_throw_specifier_repeat1,
  [319573] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9121), 1,
      anon_sym_COMMA,
    ACTIONS(14448), 1,
      anon_sym_RPAREN,
    STATE(9483), 1,
      aux_sym_generic_expression_repeat1,
  [319586] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14450), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [319599] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14452), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [319612] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    STATE(8713), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(14454), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [319623] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14456), 1,
      sym_identifier,
    STATE(2672), 1,
      sym_template_type,
    STATE(3475), 1,
      sym_template_function,
  [319636] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14008), 1,
      anon_sym_DASH_GT,
    ACTIONS(14458), 1,
      anon_sym_LBRACE,
    STATE(10380), 1,
      sym_trailing_return_type,
  [319649] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14460), 1,
      anon_sym_GT2,
    STATE(9170), 1,
      aux_sym_template_argument_list_repeat1,
  [319662] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9309), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [319675] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14462), 1,
      anon_sym_GT2,
    STATE(9137), 1,
      aux_sym_template_argument_list_repeat1,
  [319688] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14462), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [319701] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9053), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [319714] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14214), 1,
      anon_sym_COMMA,
    ACTIONS(14464), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(9034), 1,
      aux_sym_attribute_declaration_repeat1,
  [319727] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9315), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [319740] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14466), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [319753] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10811), 1,
      anon_sym_COMMA,
    ACTIONS(14468), 1,
      anon_sym_RPAREN,
    STATE(8940), 1,
      aux_sym_preproc_argument_list_repeat1,
  [319766] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14470), 1,
      sym_identifier,
    STATE(194), 1,
      sym_template_type,
    STATE(4378), 1,
      sym_template_function,
  [319779] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14466), 1,
      anon_sym_GT2,
    STATE(9144), 1,
      aux_sym_template_argument_list_repeat1,
  [319792] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14472), 1,
      anon_sym_SEMI,
    STATE(9121), 1,
      aux_sym_declaration_repeat1,
  [319805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14474), 1,
      anon_sym_catch,
    STATE(1681), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [319816] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13994), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [319829] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14000), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [319842] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14476), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [319855] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14476), 1,
      anon_sym_GT2,
    STATE(9049), 1,
      aux_sym_template_argument_list_repeat1,
  [319868] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14478), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [319881] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14480), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [319894] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14257), 1,
      anon_sym_COLON,
    ACTIONS(14482), 1,
      anon_sym_RPAREN,
    STATE(9056), 1,
      sym_gnu_asm_output_operand_list,
  [319907] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13986), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [319920] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13522), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [319933] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14484), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [319946] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14214), 1,
      anon_sym_COMMA,
    ACTIONS(14486), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(9146), 1,
      aux_sym_attribute_declaration_repeat1,
  [319959] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14488), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [319972] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14490), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [319985] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14253), 1,
      anon_sym_COLON,
    ACTIONS(14492), 1,
      anon_sym_RPAREN,
    STATE(9054), 1,
      sym_gnu_asm_input_operand_list,
  [319998] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14494), 1,
      anon_sym_GT2,
    STATE(9159), 1,
      aux_sym_template_argument_list_repeat1,
  [320011] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13530), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [320024] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14496), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [320037] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14133), 1,
      anon_sym_COLON,
    ACTIONS(14498), 1,
      anon_sym_RPAREN,
    STATE(9057), 1,
      sym_gnu_asm_clobber_list,
  [320050] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14500), 1,
      anon_sym_SEMI,
    STATE(9352), 1,
      aux_sym_declaration_repeat1,
  [320063] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14214), 1,
      anon_sym_COMMA,
    ACTIONS(14502), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(9002), 1,
      aux_sym_attribute_declaration_repeat1,
  [320076] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9335), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [320089] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14504), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [320098] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14506), 1,
      anon_sym_GT2,
    STATE(9242), 1,
      aux_sym_template_argument_list_repeat1,
  [320111] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14508), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [320124] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14214), 1,
      anon_sym_COMMA,
    ACTIONS(14510), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(9436), 1,
      aux_sym_attribute_declaration_repeat1,
  [320137] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14512), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [320150] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14514), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [320163] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9317), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [320176] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14516), 1,
      anon_sym_GT2,
    STATE(9180), 1,
      aux_sym_template_argument_list_repeat1,
  [320189] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14516), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [320202] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14518), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [320215] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9313), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [320228] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14520), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [320241] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14522), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [320254] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14524), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [320267] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14524), 1,
      anon_sym_GT2,
    STATE(9183), 1,
      aux_sym_template_argument_list_repeat1,
  [320280] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14526), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [320289] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9147), 1,
      anon_sym_COMMA,
    ACTIONS(9363), 1,
      anon_sym_RBRACK,
    STATE(9032), 1,
      aux_sym_subscript_argument_list_repeat1,
  [320302] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13966), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [320315] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(14528), 1,
      anon_sym_RPAREN,
    STATE(9011), 1,
      aux_sym_argument_list_repeat1,
  [320328] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9323), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [320341] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14530), 1,
      anon_sym_GT2,
    STATE(9184), 1,
      aux_sym_template_argument_list_repeat1,
  [320354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14273), 1,
      anon_sym_catch,
    STATE(269), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [320365] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14532), 1,
      anon_sym_GT2,
    STATE(9158), 1,
      aux_sym_template_argument_list_repeat1,
  [320378] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14534), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [320391] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13960), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [320404] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14530), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [320417] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14536), 1,
      anon_sym_GT2,
    STATE(9375), 1,
      aux_sym_template_argument_list_repeat1,
  [320430] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14538), 1,
      sym_identifier,
    STATE(2873), 1,
      sym_template_type,
    STATE(3789), 1,
      sym_template_function,
  [320443] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    ACTIONS(14540), 1,
      anon_sym_constexpr,
    STATE(1105), 1,
      sym_condition_clause,
  [320456] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13547), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [320469] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14542), 1,
      anon_sym_GT2,
    STATE(9239), 1,
      aux_sym_template_argument_list_repeat1,
  [320482] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14544), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [320495] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14546), 1,
      sym_identifier,
    STATE(2672), 1,
      sym_template_type,
    STATE(3475), 1,
      sym_template_function,
  [320508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14548), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [320517] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14550), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [320530] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14550), 1,
      anon_sym_GT2,
    STATE(9200), 1,
      aux_sym_template_argument_list_repeat1,
  [320543] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13950), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [320556] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14552), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [320569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14542), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [320582] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14554), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [320595] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14556), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [320608] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14558), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [320621] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14504), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [320630] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14560), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [320643] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14562), 1,
      anon_sym_GT2,
    STATE(9198), 1,
      aux_sym_template_argument_list_repeat1,
  [320656] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(14564), 1,
      anon_sym_RPAREN,
    STATE(9011), 1,
      aux_sym_argument_list_repeat1,
  [320669] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9414), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [320682] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13946), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [320695] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14566), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [320704] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14568), 1,
      anon_sym_COMMA,
    ACTIONS(14570), 1,
      anon_sym_RPAREN,
    STATE(9345), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [320717] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14572), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [320730] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14214), 1,
      anon_sym_COMMA,
    ACTIONS(14574), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(9034), 1,
      aux_sym_attribute_declaration_repeat1,
  [320743] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14368), 1,
      anon_sym_COMMA,
    ACTIONS(14576), 1,
      anon_sym_GT2,
    STATE(8961), 1,
      aux_sym_template_parameter_list_repeat1,
  [320756] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14578), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [320769] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    ACTIONS(14580), 1,
      anon_sym_constexpr,
    STATE(1167), 1,
      sym_condition_clause,
  [320782] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14284), 1,
      anon_sym_COMMA,
    ACTIONS(14582), 1,
      anon_sym_RPAREN,
    STATE(9038), 1,
      aux_sym_parameter_list_repeat1,
  [320795] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14584), 1,
      sym_identifier,
    STATE(194), 1,
      sym_template_type,
    STATE(7715), 1,
      sym_template_function,
  [320808] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14586), 1,
      anon_sym_COMMA,
    ACTIONS(14589), 1,
      anon_sym_RPAREN,
    STATE(9232), 1,
      aux_sym_parameter_list_repeat1,
  [320821] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14591), 1,
      anon_sym_GT2,
    STATE(9212), 1,
      aux_sym_template_argument_list_repeat1,
  [320834] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14593), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [320847] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14595), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [320860] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14597), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [320873] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14368), 1,
      anon_sym_COMMA,
    ACTIONS(14599), 1,
      anon_sym_GT2,
    STATE(9227), 1,
      aux_sym_template_parameter_list_repeat1,
  [320886] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14601), 1,
      anon_sym_SEMI,
    STATE(9215), 1,
      aux_sym_declaration_repeat1,
  [320899] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14603), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [320912] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13938), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [320925] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14257), 1,
      anon_sym_COLON,
    ACTIONS(14605), 1,
      anon_sym_RPAREN,
    STATE(9167), 1,
      sym_gnu_asm_output_operand_list,
  [320938] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14607), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [320951] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14609), 1,
      anon_sym_COMMA,
    ACTIONS(14611), 1,
      anon_sym_RPAREN,
    STATE(9321), 1,
      aux_sym_throw_specifier_repeat1,
  [320964] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14214), 1,
      anon_sym_COMMA,
    ACTIONS(14613), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(9034), 1,
      aux_sym_attribute_declaration_repeat1,
  [320977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14615), 1,
      anon_sym_catch,
    STATE(1687), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [320988] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14617), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [321001] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14619), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [321014] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(9155), 1,
      anon_sym_RPAREN,
    STATE(9541), 1,
      aux_sym_argument_list_repeat1,
  [321027] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14133), 1,
      anon_sym_COLON,
    ACTIONS(14621), 1,
      anon_sym_RPAREN,
    STATE(9343), 1,
      sym_gnu_asm_clobber_list,
  [321040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14625), 1,
      anon_sym_COLON_COLON,
    ACTIONS(14623), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [321051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14627), 1,
      sym_identifier,
    ACTIONS(14629), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [321062] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14214), 1,
      anon_sym_COMMA,
    ACTIONS(14631), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(9226), 1,
      aux_sym_attribute_declaration_repeat1,
  [321075] = 4,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(14633), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(14635), 1,
      anon_sym_LPAREN2,
    STATE(10171), 1,
      sym_preproc_argument_list,
  [321088] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9347), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [321101] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14603), 1,
      anon_sym_GT2,
    STATE(9282), 1,
      aux_sym_template_argument_list_repeat1,
  [321114] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14637), 1,
      anon_sym_GT2,
    STATE(9061), 1,
      aux_sym_template_argument_list_repeat1,
  [321127] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14639), 1,
      anon_sym_GT2,
    STATE(9247), 1,
      aux_sym_template_argument_list_repeat1,
  [321140] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14639), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [321153] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14133), 1,
      anon_sym_COLON,
    ACTIONS(14641), 1,
      anon_sym_RPAREN,
    STATE(9280), 1,
      sym_gnu_asm_clobber_list,
  [321166] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9349), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [321179] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14253), 1,
      anon_sym_COLON,
    ACTIONS(14643), 1,
      anon_sym_RPAREN,
    STATE(9274), 1,
      sym_gnu_asm_input_operand_list,
  [321192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14645), 1,
      anon_sym_catch,
    STATE(477), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [321203] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14647), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [321216] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14257), 1,
      anon_sym_COLON,
    ACTIONS(14649), 1,
      anon_sym_RPAREN,
    STATE(9071), 1,
      sym_gnu_asm_output_operand_list,
  [321229] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14651), 1,
      anon_sym_default,
    ACTIONS(14653), 1,
      anon_sym_delete,
    ACTIONS(14655), 1,
      anon_sym_0,
  [321242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14657), 1,
      anon_sym_catch,
    STATE(288), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [321253] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14647), 1,
      anon_sym_GT2,
    STATE(9258), 1,
      aux_sym_template_argument_list_repeat1,
  [321266] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9416), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [321279] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14659), 1,
      anon_sym_SEMI,
    STATE(9585), 1,
      aux_sym_declaration_repeat1,
  [321292] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13910), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [321305] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9147), 1,
      anon_sym_COMMA,
    ACTIONS(9161), 1,
      anon_sym_RBRACK,
    STATE(9109), 1,
      aux_sym_subscript_argument_list_repeat1,
  [321318] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14661), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [321331] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14663), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [321344] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14133), 1,
      anon_sym_COLON,
    ACTIONS(14665), 1,
      anon_sym_RPAREN,
    STATE(9443), 1,
      sym_gnu_asm_clobber_list,
  [321357] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14133), 1,
      anon_sym_COLON,
    ACTIONS(14667), 1,
      anon_sym_RPAREN,
    STATE(9418), 1,
      sym_gnu_asm_clobber_list,
  [321370] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14669), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [321383] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14253), 1,
      anon_sym_COLON,
    ACTIONS(14671), 1,
      anon_sym_RPAREN,
    STATE(9423), 1,
      sym_gnu_asm_input_operand_list,
  [321396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9187), 3,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
  [321405] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9287), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [321418] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14223), 1,
      anon_sym_COLON,
    ACTIONS(14673), 1,
      anon_sym_RPAREN,
    STATE(10620), 1,
      sym_gnu_asm_goto_list,
  [321431] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13864), 3,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
  [321440] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14675), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [321453] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9398), 1,
      anon_sym_COMMA,
    ACTIONS(9400), 1,
      anon_sym_RBRACE,
    STATE(9114), 1,
      aux_sym_initializer_list_repeat1,
  [321466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14677), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [321475] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14679), 1,
      anon_sym_GT2,
    STATE(9273), 1,
      aux_sym_template_argument_list_repeat1,
  [321488] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13559), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [321501] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14679), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [321514] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5154), 1,
      anon_sym_LBRACE,
    ACTIONS(13864), 1,
      anon_sym_COLON_COLON,
    STATE(486), 1,
      sym_declaration_list,
  [321527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14625), 1,
      anon_sym_COLON_COLON,
    ACTIONS(14681), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [321538] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13902), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [321551] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14683), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [321564] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9285), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [321577] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13934), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [321590] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14223), 1,
      anon_sym_COLON,
    ACTIONS(14685), 1,
      anon_sym_RPAREN,
    STATE(10624), 1,
      sym_gnu_asm_goto_list,
  [321603] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14687), 1,
      anon_sym_GT2,
    STATE(9276), 1,
      aux_sym_template_argument_list_repeat1,
  [321616] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14689), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [321629] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14691), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [321642] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(9396), 1,
      anon_sym_RPAREN,
    STATE(9130), 1,
      aux_sym_argument_list_repeat1,
  [321655] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14693), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [321668] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14214), 1,
      anon_sym_COMMA,
    ACTIONS(14695), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(9034), 1,
      aux_sym_attribute_declaration_repeat1,
  [321681] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14693), 1,
      anon_sym_GT2,
    STATE(9287), 1,
      aux_sym_template_argument_list_repeat1,
  [321694] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9157), 1,
      anon_sym_COMMA,
    ACTIONS(9159), 1,
      anon_sym_RBRACE,
    STATE(9400), 1,
      aux_sym_initializer_list_repeat1,
  [321707] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14697), 1,
      sym_identifier,
    STATE(194), 1,
      sym_template_type,
    STATE(4493), 1,
      sym_template_function,
  [321720] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14536), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [321733] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13882), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [321746] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    STATE(8632), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(14699), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [321757] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14701), 1,
      anon_sym_GT2,
    STATE(9447), 1,
      aux_sym_template_argument_list_repeat1,
  [321770] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14253), 1,
      anon_sym_COLON,
    ACTIONS(14703), 1,
      anon_sym_RPAREN,
    STATE(9259), 1,
      sym_gnu_asm_input_operand_list,
  [321783] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14705), 1,
      anon_sym_COMMA,
    ACTIONS(14708), 1,
      anon_sym_RPAREN,
    STATE(9309), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [321796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14710), 3,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
  [321805] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14712), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [321818] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14133), 1,
      anon_sym_COLON,
    ACTIONS(14714), 1,
      anon_sym_RPAREN,
    STATE(9294), 1,
      sym_gnu_asm_clobber_list,
  [321831] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14716), 1,
      sym_identifier,
    STATE(194), 1,
      sym_template_type,
    STATE(3475), 1,
      sym_template_function,
  [321844] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(14718), 1,
      anon_sym_RPAREN,
    STATE(9011), 1,
      aux_sym_argument_list_repeat1,
  [321857] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14701), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [321870] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    ACTIONS(14720), 1,
      anon_sym_constexpr,
    STATE(1138), 1,
      sym_condition_clause,
  [321883] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14722), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [321896] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14724), 1,
      sym_identifier,
    STATE(194), 1,
      sym_template_type,
    STATE(3301), 1,
      sym_template_function,
  [321909] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13892), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [321922] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14726), 1,
      anon_sym_COMMA,
    ACTIONS(14729), 1,
      anon_sym_LBRACE,
    STATE(9320), 1,
      aux_sym_field_initializer_list_repeat1,
  [321935] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14609), 1,
      anon_sym_COMMA,
    ACTIONS(14731), 1,
      anon_sym_RPAREN,
    STATE(9134), 1,
      aux_sym_throw_specifier_repeat1,
  [321948] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9357), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [321961] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14733), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [321974] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9488), 1,
      anon_sym_RBRACK,
    ACTIONS(14735), 1,
      anon_sym_COMMA,
    STATE(9324), 1,
      aux_sym_subscript_argument_list_repeat1,
  [321987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14615), 1,
      anon_sym_catch,
    STATE(1727), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [321998] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14738), 1,
      anon_sym_GT2,
    STATE(9317), 1,
      aux_sym_template_argument_list_repeat1,
  [322011] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14738), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [322024] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14740), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [322037] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14742), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [322050] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14744), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [322063] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14746), 1,
      anon_sym_SEMI,
    STATE(9235), 1,
      aux_sym_declaration_repeat1,
  [322076] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9121), 1,
      anon_sym_COMMA,
    ACTIONS(14748), 1,
      anon_sym_RPAREN,
    STATE(9483), 1,
      aux_sym_generic_expression_repeat1,
  [322089] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13872), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [322102] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9361), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [322115] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14257), 1,
      anon_sym_COLON,
    ACTIONS(14750), 1,
      anon_sym_RPAREN,
    STATE(9405), 1,
      sym_gnu_asm_output_operand_list,
  [322128] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14752), 1,
      anon_sym_GT2,
    STATE(9376), 1,
      aux_sym_template_argument_list_repeat1,
  [322141] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14754), 1,
      anon_sym_GT2,
    STATE(8957), 1,
      aux_sym_template_argument_list_repeat1,
  [322154] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14756), 1,
      anon_sym_GT2,
    STATE(9465), 1,
      aux_sym_template_argument_list_repeat1,
  [322167] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14758), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [322180] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14257), 1,
      anon_sym_COLON,
    ACTIONS(14760), 1,
      anon_sym_RPAREN,
    STATE(9308), 1,
      sym_gnu_asm_output_operand_list,
  [322193] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14253), 1,
      anon_sym_COLON,
    ACTIONS(14762), 1,
      anon_sym_RPAREN,
    STATE(9312), 1,
      sym_gnu_asm_input_operand_list,
  [322206] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9270), 1,
      anon_sym_RBRACE,
    ACTIONS(14764), 1,
      anon_sym_COMMA,
    STATE(9342), 1,
      aux_sym_initializer_list_repeat1,
  [322219] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14223), 1,
      anon_sym_COLON,
    ACTIONS(14767), 1,
      anon_sym_RPAREN,
    STATE(10487), 1,
      sym_gnu_asm_goto_list,
  [322232] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(9277), 1,
      anon_sym_RPAREN,
    STATE(9011), 1,
      aux_sym_argument_list_repeat1,
  [322245] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14568), 1,
      anon_sym_COMMA,
    ACTIONS(14769), 1,
      anon_sym_RPAREN,
    STATE(9309), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [322258] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14771), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [322271] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(9109), 1,
      anon_sym_RPAREN,
    STATE(9030), 1,
      aux_sym_argument_list_repeat1,
  [322284] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14773), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [322297] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14771), 1,
      anon_sym_GT2,
    STATE(9327), 1,
      aux_sym_template_argument_list_repeat1,
  [322310] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13862), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [322323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14615), 1,
      anon_sym_catch,
    STATE(1689), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [322334] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14775), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [322347] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14777), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [322360] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14273), 1,
      anon_sym_catch,
    STATE(243), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [322371] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14779), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [322384] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14781), 1,
      anon_sym_COMMA,
    ACTIONS(14784), 1,
      anon_sym_RPAREN,
    STATE(9356), 1,
      aux_sym_preproc_params_repeat1,
  [322397] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14786), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [322410] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14788), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [322423] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14790), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [322432] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14792), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [322445] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13856), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [322458] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14794), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [322471] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9355), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [322484] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    STATE(8821), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(14796), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [322495] = 4,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(14635), 1,
      anon_sym_LPAREN2,
    ACTIONS(14798), 1,
      aux_sym_preproc_include_token2,
    STATE(10171), 1,
      sym_preproc_argument_list,
  [322508] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_COLON,
    ACTIONS(14800), 1,
      anon_sym_SEMI,
    STATE(10590), 1,
      sym_base_class_clause,
  [322521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14645), 1,
      anon_sym_catch,
    STATE(571), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [322532] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14802), 1,
      anon_sym_GT2,
    STATE(9330), 1,
      aux_sym_template_argument_list_repeat1,
  [322545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14474), 1,
      anon_sym_catch,
    STATE(1719), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [322556] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14804), 1,
      anon_sym_GT2,
    STATE(9360), 1,
      aux_sym_template_argument_list_repeat1,
  [322569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14284), 1,
      anon_sym_COMMA,
    ACTIONS(14806), 1,
      anon_sym_RPAREN,
    STATE(9232), 1,
      aux_sym_parameter_list_repeat1,
  [322582] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14257), 1,
      anon_sym_COLON,
    ACTIONS(14808), 1,
      anon_sym_RPAREN,
    STATE(9341), 1,
      sym_gnu_asm_output_operand_list,
  [322595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14812), 1,
      anon_sym_RPAREN,
    ACTIONS(14810), 2,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [322606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14382), 1,
      anon_sym_catch,
    STATE(593), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [322617] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14814), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [322630] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14419), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [322643] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14008), 1,
      anon_sym_DASH_GT,
    ACTIONS(14816), 1,
      anon_sym_SEMI,
    STATE(10538), 1,
      sym_trailing_return_type,
  [322656] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14752), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [322669] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14008), 1,
      anon_sym_DASH_GT,
    ACTIONS(14818), 1,
      anon_sym_LBRACE,
    STATE(10653), 1,
      sym_trailing_return_type,
  [322682] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14820), 1,
      sym_identifier,
    STATE(194), 1,
      sym_template_type,
    STATE(3475), 1,
      sym_template_function,
  [322695] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14814), 1,
      anon_sym_GT2,
    STATE(9389), 1,
      aux_sym_template_argument_list_repeat1,
  [322708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6240), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [322717] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14214), 1,
      anon_sym_COMMA,
    ACTIONS(14822), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(9300), 1,
      aux_sym_attribute_declaration_repeat1,
  [322730] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14824), 1,
      sym_identifier,
    STATE(4493), 1,
      sym_template_function,
    STATE(5090), 1,
      sym_template_type,
  [322743] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9359), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [322756] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(9251), 1,
      anon_sym_RPAREN,
    STATE(9344), 1,
      aux_sym_argument_list_repeat1,
  [322769] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14214), 1,
      anon_sym_COMMA,
    ACTIONS(14826), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(9034), 1,
      aux_sym_attribute_declaration_repeat1,
  [322782] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14828), 1,
      anon_sym_COMMA,
    ACTIONS(14831), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [322795] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14833), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [322808] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14835), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [322821] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14837), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [322834] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14839), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [322847] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14214), 1,
      anon_sym_COMMA,
    ACTIONS(14841), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(9034), 1,
      aux_sym_attribute_declaration_repeat1,
  [322860] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9376), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [322873] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14843), 1,
      anon_sym_COMMA,
    ACTIONS(14845), 1,
      anon_sym_RPAREN,
    STATE(9442), 1,
      aux_sym_requires_parameter_list_repeat1,
  [322886] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    ACTIONS(14847), 1,
      anon_sym_constexpr,
    STATE(1140), 1,
      sym_condition_clause,
  [322899] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14849), 1,
      sym_identifier,
    STATE(194), 1,
      sym_template_type,
    STATE(3475), 1,
      sym_template_function,
  [322912] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14851), 1,
      anon_sym_GT2,
    STATE(9391), 1,
      aux_sym_template_argument_list_repeat1,
  [322925] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14851), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [322938] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5379), 1,
      anon_sym_RBRACE,
    ACTIONS(14853), 1,
      anon_sym_COMMA,
    STATE(9342), 1,
      aux_sym_initializer_list_repeat1,
  [322951] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14855), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [322964] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14857), 1,
      anon_sym_SEMI,
    STATE(9357), 1,
      aux_sym_declaration_repeat1,
  [322977] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14859), 1,
      anon_sym_SEMI,
    ACTIONS(14861), 1,
      anon_sym_DOT,
    STATE(9452), 1,
      aux_sym_import_statement_repeat1,
  [322990] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14863), 1,
      sym_identifier,
    STATE(194), 1,
      sym_template_type,
    STATE(3475), 1,
      sym_template_function,
  [323003] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14253), 1,
      anon_sym_COLON,
    ACTIONS(14865), 1,
      anon_sym_RPAREN,
    STATE(9534), 1,
      sym_gnu_asm_input_operand_list,
  [323016] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9378), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323029] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14431), 1,
      anon_sym_COMMA,
    ACTIONS(14867), 1,
      anon_sym_RPAREN,
    STATE(9128), 1,
      aux_sym_preproc_params_repeat1,
  [323042] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14859), 1,
      anon_sym_SEMI,
    ACTIONS(14861), 1,
      anon_sym_DOT,
    STATE(9449), 1,
      aux_sym_import_statement_repeat1,
  [323055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14869), 1,
      anon_sym_catch,
    STATE(1517), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [323066] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14871), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323079] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14257), 1,
      anon_sym_COLON,
    ACTIONS(14873), 1,
      anon_sym_RPAREN,
    STATE(9536), 1,
      sym_gnu_asm_output_operand_list,
  [323092] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14871), 1,
      anon_sym_GT2,
    STATE(9399), 1,
      aux_sym_template_argument_list_repeat1,
  [323105] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13822), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323118] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(9129), 1,
      anon_sym_RPAREN,
    STATE(9031), 1,
      aux_sym_argument_list_repeat1,
  [323131] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14875), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323144] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13812), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323157] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14877), 1,
      anon_sym_GT2,
    STATE(9451), 1,
      aux_sym_template_argument_list_repeat1,
  [323170] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14223), 1,
      anon_sym_COLON,
    ACTIONS(14879), 1,
      anon_sym_RPAREN,
    STATE(10210), 1,
      sym_gnu_asm_goto_list,
  [323183] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14881), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323196] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14883), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323209] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14885), 1,
      anon_sym_GT2,
    STATE(9468), 1,
      aux_sym_template_argument_list_repeat1,
  [323222] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14887), 1,
      anon_sym_GT2,
    STATE(9415), 1,
      aux_sym_template_argument_list_repeat1,
  [323235] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14133), 1,
      anon_sym_COLON,
    ACTIONS(14889), 1,
      anon_sym_RPAREN,
    STATE(9524), 1,
      sym_gnu_asm_clobber_list,
  [323248] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14891), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323261] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14214), 1,
      anon_sym_COMMA,
    ACTIONS(14893), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(9387), 1,
      aux_sym_attribute_declaration_repeat1,
  [323274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14308), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [323283] = 4,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(14635), 1,
      anon_sym_LPAREN2,
    ACTIONS(14895), 1,
      aux_sym_preproc_include_token2,
    STATE(10171), 1,
      sym_preproc_argument_list,
  [323296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5156), 1,
      anon_sym_LBRACE,
    ACTIONS(13864), 1,
      anon_sym_COLON_COLON,
    STATE(937), 1,
      sym_declaration_list,
  [323309] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14897), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14899), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323335] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9189), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323348] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13620), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [323357] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14901), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [323370] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14903), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323383] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14905), 1,
      sym_identifier,
    STATE(2672), 1,
      sym_template_type,
    STATE(4378), 1,
      sym_template_function,
  [323396] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14214), 1,
      anon_sym_COMMA,
    ACTIONS(14907), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(9034), 1,
      aux_sym_attribute_declaration_repeat1,
  [323409] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14909), 1,
      sym_identifier,
    STATE(2672), 1,
      sym_template_type,
    STATE(3475), 1,
      sym_template_function,
  [323422] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14911), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [323435] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(9013), 1,
      anon_sym_RPAREN,
    STATE(9629), 1,
      aux_sym_argument_list_repeat1,
  [323448] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14913), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323461] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9239), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323474] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14843), 1,
      anon_sym_COMMA,
    ACTIONS(14915), 1,
      anon_sym_RPAREN,
    STATE(9115), 1,
      aux_sym_requires_parameter_list_repeat1,
  [323487] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14223), 1,
      anon_sym_COLON,
    ACTIONS(14917), 1,
      anon_sym_RPAREN,
    STATE(10491), 1,
      sym_gnu_asm_goto_list,
  [323500] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14919), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323513] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13616), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323526] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14921), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323539] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14923), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323552] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14923), 1,
      anon_sym_GT2,
    STATE(9529), 1,
      aux_sym_template_argument_list_repeat1,
  [323565] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14925), 1,
      anon_sym_SEMI,
    ACTIONS(14927), 1,
      anon_sym_DOT,
    STATE(9449), 1,
      aux_sym_import_statement_repeat1,
  [323578] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14284), 1,
      anon_sym_COMMA,
    ACTIONS(14930), 1,
      anon_sym_RPAREN,
    STATE(9106), 1,
      aux_sym_parameter_list_repeat1,
  [323591] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14932), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323604] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14861), 1,
      anon_sym_DOT,
    ACTIONS(14934), 1,
      anon_sym_SEMI,
    STATE(9449), 1,
      aux_sym_import_statement_repeat1,
  [323617] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13612), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323630] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14936), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [323643] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9151), 1,
      anon_sym_COMMA,
    ACTIONS(9153), 1,
      anon_sym_RBRACE,
    STATE(9610), 1,
      aux_sym_initializer_list_repeat1,
  [323656] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9404), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323669] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14938), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323682] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9121), 1,
      anon_sym_COMMA,
    ACTIONS(14940), 1,
      anon_sym_RPAREN,
    STATE(9483), 1,
      aux_sym_generic_expression_repeat1,
  [323695] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14942), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323708] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    ACTIONS(14944), 1,
      anon_sym_constexpr,
    STATE(1153), 1,
      sym_condition_clause,
  [323721] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13624), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323734] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9247), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323747] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14223), 1,
      anon_sym_COLON,
    ACTIONS(14946), 1,
      anon_sym_RPAREN,
    STATE(10740), 1,
      sym_gnu_asm_goto_list,
  [323760] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    ACTIONS(14948), 1,
      anon_sym_constexpr,
    STATE(1155), 1,
      sym_condition_clause,
  [323773] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14950), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323786] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14952), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [323795] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14954), 1,
      anon_sym_GT2,
    STATE(9459), 1,
      aux_sym_template_argument_list_repeat1,
  [323808] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14954), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323821] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9237), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323834] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5152), 1,
      anon_sym_LBRACE,
    ACTIONS(13864), 1,
      anon_sym_COLON_COLON,
    STATE(963), 1,
      sym_declaration_list,
  [323847] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14133), 1,
      anon_sym_COLON,
    ACTIONS(14956), 1,
      anon_sym_RPAREN,
    STATE(9463), 1,
      sym_gnu_asm_clobber_list,
  [323860] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14223), 1,
      anon_sym_COLON,
    ACTIONS(14958), 1,
      anon_sym_RPAREN,
    STATE(10743), 1,
      sym_gnu_asm_goto_list,
  [323873] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14960), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [323882] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    ACTIONS(14962), 1,
      anon_sym_constexpr,
    STATE(1170), 1,
      sym_condition_clause,
  [323895] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14284), 1,
      anon_sym_COMMA,
    ACTIONS(14964), 1,
      anon_sym_RPAREN,
    STATE(9549), 1,
      aux_sym_parameter_list_repeat1,
  [323908] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14966), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [323921] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14968), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [323934] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9382), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323947] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    ACTIONS(9133), 1,
      anon_sym_RBRACE,
    STATE(8945), 1,
      aux_sym_initializer_list_repeat1,
  [323960] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14885), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [323973] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14970), 1,
      anon_sym_GT2,
    STATE(9516), 1,
      aux_sym_template_argument_list_repeat1,
  [323986] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14972), 1,
      anon_sym_default,
    ACTIONS(14974), 1,
      anon_sym_delete,
    ACTIONS(14976), 1,
      anon_sym_0,
  [323999] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14978), 1,
      anon_sym_COMMA,
    ACTIONS(14981), 1,
      anon_sym_RPAREN,
    STATE(9483), 1,
      aux_sym_generic_expression_repeat1,
  [324012] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13756), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [324025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14645), 1,
      anon_sym_catch,
    STATE(562), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [324036] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14983), 1,
      anon_sym_GT2,
    STATE(9446), 1,
      aux_sym_template_argument_list_repeat1,
  [324049] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14983), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [324062] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9384), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [324075] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14253), 1,
      anon_sym_COLON,
    ACTIONS(14985), 1,
      anon_sym_RPAREN,
    STATE(9471), 1,
      sym_gnu_asm_input_operand_list,
  [324088] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14133), 1,
      anon_sym_COLON,
    ACTIONS(14987), 1,
      anon_sym_RPAREN,
    STATE(9472), 1,
      sym_gnu_asm_clobber_list,
  [324101] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13734), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [324110] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13750), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [324119] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14989), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [324132] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14989), 1,
      anon_sym_GT2,
    STATE(9487), 1,
      aux_sym_template_argument_list_repeat1,
  [324145] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14991), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [324158] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(14970), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [324171] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13630), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [324184] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13746), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [324197] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(14993), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [324210] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(14995), 1,
      anon_sym_RPAREN,
    STATE(9011), 1,
      aux_sym_argument_list_repeat1,
  [324223] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(14997), 1,
      anon_sym_SEMI,
    STATE(9119), 1,
      sym_compound_statement,
  [324236] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(14999), 1,
      anon_sym_SEMI,
    STATE(9611), 1,
      sym_compound_statement,
  [324249] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15001), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [324262] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15003), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [324275] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13738), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [324288] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(15005), 1,
      anon_sym_RPAREN,
    STATE(9011), 1,
      aux_sym_argument_list_repeat1,
  [324301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14869), 1,
      anon_sym_catch,
    STATE(1516), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [324312] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15007), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [324325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15009), 3,
      anon_sym_RBRACE,
      anon_sym_get,
      anon_sym_set,
  [324334] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15011), 1,
      sym_identifier,
    STATE(2873), 1,
      sym_template_type,
    STATE(3301), 1,
      sym_template_function,
  [324347] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(15013), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [324360] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14257), 1,
      anon_sym_COLON,
    ACTIONS(15015), 1,
      anon_sym_RPAREN,
    STATE(9574), 1,
      sym_gnu_asm_output_operand_list,
  [324373] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(15017), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [324386] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9420), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [324399] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    ACTIONS(15019), 1,
      anon_sym_constexpr,
    STATE(1113), 1,
      sym_condition_clause,
  [324412] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15021), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [324425] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    STATE(8841), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(15023), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [324436] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15021), 1,
      anon_sym_GT2,
    STATE(9575), 1,
      aux_sym_template_argument_list_repeat1,
  [324449] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15025), 1,
      anon_sym_GT2,
    STATE(9503), 1,
      aux_sym_template_argument_list_repeat1,
  [324462] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    STATE(8807), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(15027), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [324473] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15029), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [324486] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    ACTIONS(15031), 1,
      anon_sym_constexpr,
    STATE(1139), 1,
      sym_condition_clause,
  [324499] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13728), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [324512] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14223), 1,
      anon_sym_COLON,
    ACTIONS(15033), 1,
      anon_sym_RPAREN,
    STATE(10216), 1,
      sym_gnu_asm_goto_list,
  [324525] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15035), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [324538] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(15037), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [324551] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9193), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [324564] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14257), 1,
      anon_sym_COLON,
    ACTIONS(15039), 1,
      anon_sym_RPAREN,
    STATE(9489), 1,
      sym_gnu_asm_output_operand_list,
  [324577] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15041), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [324590] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14253), 1,
      anon_sym_COLON,
    ACTIONS(15043), 1,
      anon_sym_RPAREN,
    STATE(9490), 1,
      sym_gnu_asm_input_operand_list,
  [324603] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15045), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [324616] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15047), 1,
      anon_sym_default,
    ACTIONS(15049), 1,
      anon_sym_delete,
    ACTIONS(15051), 1,
      anon_sym_0,
  [324629] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5391), 1,
      anon_sym_RBRACE,
    ACTIONS(15053), 1,
      anon_sym_COMMA,
    STATE(9342), 1,
      aux_sym_initializer_list_repeat1,
  [324642] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14133), 1,
      anon_sym_COLON,
    ACTIONS(15055), 1,
      anon_sym_RPAREN,
    STATE(9550), 1,
      sym_gnu_asm_clobber_list,
  [324655] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15057), 1,
      sym_identifier,
    STATE(330), 1,
      sym_template_type,
    STATE(3475), 1,
      sym_template_function,
  [324668] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14253), 1,
      anon_sym_COLON,
    ACTIONS(15059), 1,
      anon_sym_RPAREN,
    STATE(9551), 1,
      sym_gnu_asm_input_operand_list,
  [324681] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9422), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [324694] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13634), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [324707] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15061), 1,
      anon_sym_GT2,
    STATE(9564), 1,
      aux_sym_template_argument_list_repeat1,
  [324720] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15061), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [324733] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(9167), 1,
      anon_sym_RPAREN,
    STATE(9011), 1,
      aux_sym_argument_list_repeat1,
  [324746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15063), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [324755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6426), 1,
      anon_sym_EQ,
    ACTIONS(6424), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [324766] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(9219), 1,
      anon_sym_RPAREN,
    STATE(9011), 1,
      aux_sym_argument_list_repeat1,
  [324779] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15065), 1,
      anon_sym_GT2,
    STATE(9495), 1,
      aux_sym_template_argument_list_repeat1,
  [324792] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14223), 1,
      anon_sym_COLON,
    ACTIONS(15067), 1,
      anon_sym_RPAREN,
    STATE(10468), 1,
      sym_gnu_asm_goto_list,
  [324805] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(15069), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [324818] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(15071), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [324831] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14284), 1,
      anon_sym_COMMA,
    ACTIONS(15073), 1,
      anon_sym_RPAREN,
    STATE(9232), 1,
      aux_sym_parameter_list_repeat1,
  [324844] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14223), 1,
      anon_sym_COLON,
    ACTIONS(15075), 1,
      anon_sym_RPAREN,
    STATE(10808), 1,
      sym_gnu_asm_goto_list,
  [324857] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14133), 1,
      anon_sym_COLON,
    ACTIONS(15077), 1,
      anon_sym_RPAREN,
    STATE(9577), 1,
      sym_gnu_asm_clobber_list,
  [324870] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9055), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [324879] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15079), 1,
      anon_sym_default,
    ACTIONS(15081), 1,
      anon_sym_delete,
    ACTIONS(15083), 1,
      anon_sym_0,
  [324892] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15085), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [324905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14869), 1,
      anon_sym_catch,
    STATE(1518), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [324916] = 4,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(14635), 1,
      anon_sym_LPAREN2,
    ACTIONS(15087), 1,
      aux_sym_preproc_include_token2,
    STATE(10171), 1,
      sym_preproc_argument_list,
  [324929] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9121), 1,
      anon_sym_COMMA,
    ACTIONS(15089), 1,
      anon_sym_RPAREN,
    STATE(9483), 1,
      aux_sym_generic_expression_repeat1,
  [324942] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    ACTIONS(15091), 1,
      anon_sym_constexpr,
    STATE(1154), 1,
      sym_condition_clause,
  [324955] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(15093), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [324968] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(15095), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [324981] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(15097), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [324994] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9177), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [325007] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15099), 1,
      anon_sym_COMMA,
    ACTIONS(15102), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [325020] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15104), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [325033] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15106), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [325046] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15104), 1,
      anon_sym_GT2,
    STATE(9582), 1,
      aux_sym_template_argument_list_repeat1,
  [325059] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9388), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [325072] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9121), 1,
      anon_sym_COMMA,
    ACTIONS(15108), 1,
      anon_sym_RPAREN,
    STATE(9483), 1,
      aux_sym_generic_expression_repeat1,
  [325085] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15110), 1,
      anon_sym_GT2,
    STATE(9521), 1,
      aux_sym_template_argument_list_repeat1,
  [325098] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14257), 1,
      anon_sym_COLON,
    ACTIONS(15112), 1,
      anon_sym_RPAREN,
    STATE(9530), 1,
      sym_gnu_asm_output_operand_list,
  [325111] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15114), 1,
      anon_sym_GT2,
    STATE(9424), 1,
      aux_sym_template_argument_list_repeat1,
  [325124] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15116), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [325137] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15118), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [325146] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14253), 1,
      anon_sym_COLON,
    ACTIONS(15120), 1,
      anon_sym_RPAREN,
    STATE(9171), 1,
      sym_gnu_asm_input_operand_list,
  [325159] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15122), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [325172] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15124), 1,
      anon_sym_GT2,
    STATE(9081), 1,
      aux_sym_template_argument_list_repeat1,
  [325185] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14223), 1,
      anon_sym_COLON,
    ACTIONS(15126), 1,
      anon_sym_RPAREN,
    STATE(10804), 1,
      sym_gnu_asm_goto_list,
  [325198] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15128), 1,
      anon_sym_GT2,
    STATE(9554), 1,
      aux_sym_template_argument_list_repeat1,
  [325211] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9147), 1,
      anon_sym_COMMA,
    ACTIONS(9149), 1,
      anon_sym_RBRACK,
    STATE(9613), 1,
      aux_sym_subscript_argument_list_repeat1,
  [325224] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9181), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [325237] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(15130), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [325250] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15132), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [325263] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15124), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [325276] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9203), 1,
      anon_sym_COMMA,
    ACTIONS(9205), 1,
      anon_sym_RBRACE,
    STATE(9533), 1,
      aux_sym_initializer_list_repeat1,
  [325289] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(15134), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [325302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15136), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [325311] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15128), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [325324] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9390), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [325337] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(15138), 1,
      anon_sym_SEMI,
    STATE(9563), 1,
      aux_sym_declaration_repeat1,
  [325350] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9121), 1,
      anon_sym_COMMA,
    ACTIONS(15140), 1,
      anon_sym_RPAREN,
    STATE(9483), 1,
      aux_sym_generic_expression_repeat1,
  [325363] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15142), 1,
      anon_sym_GT2,
    STATE(9596), 1,
      aux_sym_template_argument_list_repeat1,
  [325376] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13670), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [325389] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5152), 1,
      anon_sym_LBRACE,
    ACTIONS(13864), 1,
      anon_sym_COLON_COLON,
    STATE(941), 1,
      sym_declaration_list,
  [325402] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(9011), 1,
      anon_sym_RPAREN,
    STATE(9544), 1,
      aux_sym_argument_list_repeat1,
  [325415] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14214), 1,
      anon_sym_COMMA,
    ACTIONS(15144), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(9034), 1,
      aux_sym_attribute_declaration_repeat1,
  [325428] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15146), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [325441] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15148), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [325454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15150), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(15152), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [325465] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15148), 1,
      anon_sym_GT2,
    STATE(9587), 1,
      aux_sym_template_argument_list_repeat1,
  [325478] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14284), 1,
      anon_sym_COMMA,
    ACTIONS(15154), 1,
      anon_sym_RPAREN,
    STATE(9371), 1,
      aux_sym_parameter_list_repeat1,
  [325491] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9195), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [325504] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15156), 1,
      anon_sym_COMMA,
    ACTIONS(15158), 1,
      anon_sym_LBRACE,
    STATE(9617), 1,
      aux_sym_field_initializer_list_repeat1,
  [325517] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2848), 1,
      anon_sym_while,
    ACTIONS(14243), 1,
      anon_sym_else,
    STATE(579), 1,
      sym_else_clause,
  [325530] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15160), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [325539] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2852), 1,
      anon_sym_while,
    ACTIONS(14243), 1,
      anon_sym_else,
    STATE(576), 1,
      sym_else_clause,
  [325552] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15162), 1,
      sym_identifier,
    STATE(2672), 1,
      sym_template_type,
    STATE(3475), 1,
      sym_template_function,
  [325565] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(15164), 1,
      anon_sym_RPAREN,
    STATE(9011), 1,
      aux_sym_argument_list_repeat1,
  [325578] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13693), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [325591] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14008), 1,
      anon_sym_DASH_GT,
    ACTIONS(15166), 1,
      anon_sym_LBRACE,
    STATE(10241), 1,
      sym_trailing_return_type,
  [325604] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_RBRACE,
    ACTIONS(15168), 1,
      anon_sym_COMMA,
    STATE(9342), 1,
      aux_sym_initializer_list_repeat1,
  [325617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15170), 3,
      anon_sym_RBRACE,
      anon_sym_get,
      anon_sym_set,
  [325626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15174), 1,
      anon_sym_EQ,
    ACTIONS(15172), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [325637] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9147), 1,
      anon_sym_COMMA,
    ACTIONS(15176), 1,
      anon_sym_RBRACK,
    STATE(9324), 1,
      aux_sym_subscript_argument_list_repeat1,
  [325650] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13666), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [325663] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(15178), 1,
      anon_sym_SEMI,
    STATE(9560), 1,
      aux_sym_declaration_repeat1,
  [325676] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15180), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [325689] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15156), 1,
      anon_sym_COMMA,
    ACTIONS(15182), 1,
      anon_sym_LBRACE,
    STATE(9320), 1,
      aux_sym_field_initializer_list_repeat1,
  [325702] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(13682), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [325715] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14257), 1,
      anon_sym_COLON,
    ACTIONS(15184), 1,
      anon_sym_RPAREN,
    STATE(9022), 1,
      sym_gnu_asm_output_operand_list,
  [325728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14474), 1,
      anon_sym_catch,
    STATE(1716), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [325739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15186), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(15188), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [325750] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15190), 1,
      anon_sym_GT2,
    STATE(9045), 1,
      aux_sym_template_argument_list_repeat1,
  [325763] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15192), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [325776] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15194), 1,
      anon_sym_GT2,
    STATE(9640), 1,
      aux_sym_template_argument_list_repeat1,
  [325789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14657), 1,
      anon_sym_catch,
    STATE(900), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [325800] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14368), 1,
      anon_sym_COMMA,
    ACTIONS(15196), 1,
      anon_sym_GT2,
    STATE(9100), 1,
      aux_sym_template_parameter_list_repeat1,
  [325813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14382), 1,
      anon_sym_catch,
    STATE(546), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [325824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15198), 1,
      anon_sym_catch,
    STATE(1234), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [325835] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(9111), 1,
      anon_sym_RPAREN,
    STATE(9011), 1,
      aux_sym_argument_list_repeat1,
  [325848] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14861), 1,
      anon_sym_DOT,
    ACTIONS(15200), 1,
      anon_sym_SEMI,
    STATE(9408), 1,
      aux_sym_import_statement_repeat1,
  [325861] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14657), 1,
      anon_sym_catch,
    STATE(923), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [325872] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15202), 1,
      anon_sym_GT2,
    STATE(9616), 1,
      aux_sym_template_argument_list_repeat1,
  [325885] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15194), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [325898] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9394), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [325911] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15204), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [325924] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15206), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [325937] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COMMA,
    ACTIONS(15208), 1,
      anon_sym_SEMI,
    STATE(9438), 1,
      aux_sym_declaration_repeat1,
  [325950] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14214), 1,
      anon_sym_COMMA,
    ACTIONS(15210), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(9595), 1,
      aux_sym_attribute_declaration_repeat1,
  [325963] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14133), 1,
      anon_sym_COLON,
    ACTIONS(15212), 1,
      anon_sym_RPAREN,
    STATE(9004), 1,
      sym_gnu_asm_clobber_list,
  [325976] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(15114), 1,
      anon_sym_GT2,
    STATE(9388), 1,
      aux_sym_template_argument_list_repeat1,
  [325989] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15214), 1,
      sym_identifier,
    STATE(2672), 1,
      sym_template_type,
    STATE(3475), 1,
      sym_template_function,
  [326002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6961), 1,
      anon_sym_LBRACE,
    STATE(3448), 1,
      sym_field_declaration_list,
  [326012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(9033), 1,
      sym_compound_statement,
  [326022] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7098), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [326030] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7118), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [326038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    STATE(1156), 1,
      sym_condition_clause,
  [326048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15216), 1,
      anon_sym_LT,
    STATE(2955), 1,
      sym_template_argument_list,
  [326058] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(15218), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(15220), 1,
      sym_preproc_arg,
  [326068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15222), 1,
      anon_sym_LPAREN2,
    STATE(10066), 1,
      sym_parenthesized_expression,
  [326078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15224), 1,
      anon_sym_LT,
    STATE(4447), 1,
      sym_template_argument_list,
  [326088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    STATE(9140), 1,
      sym_parameter_list,
  [326098] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15226), 1,
      anon_sym_COMMA,
    ACTIONS(15228), 1,
      anon_sym_RBRACE,
  [326108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11617), 1,
      anon_sym_LBRACE,
    STATE(1566), 1,
      sym_compound_statement,
  [326118] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10553), 1,
      anon_sym_LBRACE,
    STATE(4505), 1,
      sym_requirement_seq,
  [326128] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7206), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [326136] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(9631), 1,
      sym_compound_statement,
  [326146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10545), 1,
      anon_sym_LBRACE,
    STATE(4100), 1,
      sym_requirement_seq,
  [326156] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7212), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [326164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    STATE(1105), 1,
      sym_condition_clause,
  [326174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    STATE(5604), 1,
      sym_field_declaration_list,
  [326184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7760), 1,
      anon_sym_LBRACE,
    STATE(4731), 1,
      sym_field_declaration_list,
  [326194] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11560), 1,
      anon_sym_LBRACE,
    STATE(2477), 1,
      sym_compound_statement,
  [326204] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15230), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [326212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4579), 1,
      anon_sym_LT,
    STATE(1246), 1,
      sym_template_argument_list,
  [326222] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15232), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [326230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    STATE(6174), 1,
      sym_field_declaration_list,
  [326240] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    STATE(6169), 1,
      sym_field_declaration_list,
  [326250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    STATE(6168), 1,
      sym_field_declaration_list,
  [326260] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15234), 1,
      sym_identifier,
    STATE(330), 1,
      sym_template_type,
  [326270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(8905), 1,
      sym_compound_statement,
  [326280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    STATE(6165), 1,
      sym_field_declaration_list,
  [326290] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15236), 1,
      sym_identifier,
    STATE(3352), 1,
      sym_template_type,
  [326300] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4737), 1,
      anon_sym_LBRACE,
    STATE(4538), 1,
      sym_initializer_list,
  [326310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    STATE(560), 1,
      sym_field_declaration_list,
  [326320] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(309), 1,
      anon_sym_LBRACE,
    STATE(419), 1,
      sym_compound_statement,
  [326330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2479), 1,
      anon_sym_LBRACE,
    STATE(413), 1,
      sym_field_declaration_list,
  [326340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2479), 1,
      anon_sym_LBRACE,
    STATE(412), 1,
      sym_field_declaration_list,
  [326350] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(15238), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(15240), 1,
      sym_preproc_arg,
  [326360] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5152), 1,
      anon_sym_LBRACE,
    STATE(940), 1,
      sym_declaration_list,
  [326370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15226), 1,
      anon_sym_COMMA,
    ACTIONS(15242), 1,
      anon_sym_RBRACE,
  [326380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    STATE(6187), 1,
      sym_field_declaration_list,
  [326390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15216), 1,
      anon_sym_LT,
    STATE(3186), 1,
      sym_template_argument_list,
  [326400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6961), 1,
      anon_sym_LBRACE,
    STATE(3467), 1,
      sym_field_declaration_list,
  [326410] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9559), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [326418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7256), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [326426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11945), 1,
      anon_sym_RBRACE,
    ACTIONS(15226), 1,
      anon_sym_COMMA,
  [326436] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4577), 1,
      anon_sym_LBRACE,
    STATE(1329), 1,
      sym_field_declaration_list,
  [326446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11965), 1,
      anon_sym_RBRACE,
    ACTIONS(15226), 1,
      anon_sym_COMMA,
  [326456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    STATE(3135), 1,
      sym_field_declaration_list,
  [326466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    STATE(3147), 1,
      sym_field_declaration_list,
  [326476] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    STATE(10001), 1,
      sym_parameter_list,
  [326486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(610), 1,
      sym_compound_statement,
  [326496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    STATE(5608), 1,
      sym_field_declaration_list,
  [326506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    STATE(5609), 1,
      sym_field_declaration_list,
  [326516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    STATE(3128), 1,
      sym_field_declaration_list,
  [326526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    STATE(6171), 1,
      sym_field_declaration_list,
  [326536] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7110), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [326544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15222), 1,
      anon_sym_LPAREN2,
    STATE(10412), 1,
      sym_parenthesized_expression,
  [326554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    STATE(9973), 1,
      sym_parameter_list,
  [326564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 1,
      anon_sym_LBRACE,
    STATE(4688), 1,
      sym_initializer_list,
  [326574] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7106), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [326582] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9209), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [326590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7760), 1,
      anon_sym_LBRACE,
    STATE(4715), 1,
      sym_field_declaration_list,
  [326600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2828), 1,
      anon_sym_LBRACE,
    STATE(698), 1,
      sym_field_declaration_list,
  [326610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7760), 1,
      anon_sym_LBRACE,
    STATE(4712), 1,
      sym_field_declaration_list,
  [326620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15244), 1,
      sym_identifier,
    STATE(4548), 1,
      sym_template_type,
  [326630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11947), 1,
      anon_sym_RBRACE,
    ACTIONS(15226), 1,
      anon_sym_COMMA,
  [326640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2013), 1,
      anon_sym_LBRACE,
    STATE(1333), 1,
      sym_compound_statement,
  [326650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15246), 1,
      anon_sym_if,
    ACTIONS(15248), 1,
      anon_sym_for,
  [326660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    STATE(1154), 1,
      sym_condition_clause,
  [326670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 1,
      anon_sym_LT,
    STATE(3202), 1,
      sym_template_argument_list,
  [326680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(8829), 1,
      sym_compound_statement,
  [326690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    STATE(10331), 1,
      sym_argument_list,
  [326700] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4577), 1,
      anon_sym_LBRACE,
    STATE(1320), 1,
      sym_field_declaration_list,
  [326710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    STATE(6155), 1,
      sym_field_declaration_list,
  [326720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4577), 1,
      anon_sym_LBRACE,
    STATE(1326), 1,
      sym_field_declaration_list,
  [326730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15226), 1,
      anon_sym_COMMA,
    ACTIONS(15250), 1,
      anon_sym_RBRACE,
  [326740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    STATE(5611), 1,
      sym_field_declaration_list,
  [326750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15252), 1,
      sym_identifier,
    STATE(194), 1,
      sym_template_type,
  [326760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15254), 1,
      sym_identifier,
    STATE(9178), 1,
      sym_attribute,
  [326770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15224), 1,
      anon_sym_LT,
    STATE(3392), 1,
      sym_template_argument_list,
  [326780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15256), 1,
      anon_sym_LT,
    STATE(3472), 1,
      sym_template_argument_list,
  [326790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    STATE(9888), 1,
      sym_condition_clause,
  [326800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(9354), 1,
      sym_compound_statement,
  [326810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    STATE(1144), 1,
      sym_condition_clause,
  [326820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(1030), 1,
      sym_compound_statement,
  [326830] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    STATE(1112), 1,
      sym_condition_clause,
  [326840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2013), 1,
      anon_sym_LBRACE,
    STATE(1268), 1,
      sym_compound_statement,
  [326850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(9262), 1,
      sym_compound_statement,
  [326860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2828), 1,
      anon_sym_LBRACE,
    STATE(693), 1,
      sym_field_declaration_list,
  [326870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2828), 1,
      anon_sym_LBRACE,
    STATE(692), 1,
      sym_field_declaration_list,
  [326880] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2828), 1,
      anon_sym_LBRACE,
    STATE(691), 1,
      sym_field_declaration_list,
  [326890] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    STATE(9822), 1,
      sym_condition_clause,
  [326900] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(15258), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(15260), 1,
      sym_preproc_arg,
  [326910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1219), 1,
      anon_sym_LBRACE,
    STATE(690), 1,
      sym_compound_statement,
  [326920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15254), 1,
      sym_identifier,
    STATE(9383), 1,
      sym_attribute,
  [326930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    STATE(1123), 1,
      sym_condition_clause,
  [326940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6961), 1,
      anon_sym_LBRACE,
    STATE(3450), 1,
      sym_field_declaration_list,
  [326950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    STATE(10721), 1,
      sym_argument_list,
  [326960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(8770), 1,
      sym_compound_statement,
  [326970] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    STATE(965), 1,
      sym_field_declaration_list,
  [326980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    STATE(1170), 1,
      sym_condition_clause,
  [326990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15262), 1,
      anon_sym_if,
    ACTIONS(15264), 1,
      anon_sym_for,
  [327000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2013), 1,
      anon_sym_LBRACE,
    STATE(1290), 1,
      sym_compound_statement,
  [327010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4577), 1,
      anon_sym_LBRACE,
    STATE(1289), 1,
      sym_field_declaration_list,
  [327020] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4577), 1,
      anon_sym_LBRACE,
    STATE(1284), 1,
      sym_field_declaration_list,
  [327030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4577), 1,
      anon_sym_LBRACE,
    STATE(1283), 1,
      sym_field_declaration_list,
  [327040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1219), 1,
      anon_sym_LBRACE,
    STATE(652), 1,
      sym_compound_statement,
  [327050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13864), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15266), 1,
      anon_sym_SEMI,
  [327060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8978), 1,
      anon_sym_LBRACE,
    STATE(6153), 1,
      sym_field_declaration_list,
  [327070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7760), 1,
      anon_sym_LBRACE,
    STATE(4691), 1,
      sym_field_declaration_list,
  [327080] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8790), 1,
      anon_sym_LT,
    STATE(5082), 1,
      sym_template_argument_list,
  [327090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11617), 1,
      anon_sym_LBRACE,
    STATE(1633), 1,
      sym_compound_statement,
  [327100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11961), 1,
      anon_sym_RBRACE,
    ACTIONS(15226), 1,
      anon_sym_COMMA,
  [327110] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(15268), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(15270), 1,
      sym_preproc_arg,
  [327120] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12216), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [327128] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4577), 1,
      anon_sym_LBRACE,
    STATE(1306), 1,
      sym_field_declaration_list,
  [327138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11560), 1,
      anon_sym_LBRACE,
    STATE(1863), 1,
      sym_compound_statement,
  [327148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15272), 1,
      sym_identifier,
    ACTIONS(15274), 1,
      anon_sym_LPAREN2,
  [327158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(1002), 1,
      sym_compound_statement,
  [327168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    STATE(1152), 1,
      sym_condition_clause,
  [327178] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8616), 1,
      anon_sym_LT,
    STATE(2816), 1,
      sym_template_argument_list,
  [327188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15222), 1,
      anon_sym_LPAREN2,
    STATE(10803), 1,
      sym_parenthesized_expression,
  [327198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13484), 1,
      sym_identifier,
    STATE(194), 1,
      sym_template_type,
  [327208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5152), 1,
      anon_sym_LBRACE,
    STATE(961), 1,
      sym_declaration_list,
  [327218] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(15276), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(15278), 1,
      sym_preproc_arg,
  [327228] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    STATE(1151), 1,
      sym_condition_clause,
  [327238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2479), 1,
      anon_sym_LBRACE,
    STATE(396), 1,
      sym_field_declaration_list,
  [327248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    STATE(9748), 1,
      sym_parameter_list,
  [327258] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5156), 1,
      anon_sym_LBRACE,
    STATE(934), 1,
      sym_declaration_list,
  [327268] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14925), 2,
      anon_sym_SEMI,
      anon_sym_DOT,
  [327276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15280), 1,
      sym_identifier,
    STATE(3650), 1,
      sym_template_type,
  [327286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15282), 1,
      sym_identifier,
    STATE(241), 1,
      sym_template_type,
  [327296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    STATE(6063), 1,
      sym_field_declaration_list,
  [327306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    STATE(6077), 1,
      sym_field_declaration_list,
  [327316] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4418), 1,
      anon_sym_LBRACE,
    STATE(3325), 1,
      sym_initializer_list,
  [327326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    STATE(6073), 1,
      sym_field_declaration_list,
  [327336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 1,
      anon_sym_LT,
    STATE(2686), 1,
      sym_template_argument_list,
  [327346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15284), 1,
      sym_identifier,
    STATE(2672), 1,
      sym_template_type,
  [327356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(9369), 1,
      sym_compound_statement,
  [327366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    STATE(1186), 1,
      sym_condition_clause,
  [327376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    STATE(638), 1,
      sym_field_declaration_list,
  [327386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    STATE(726), 1,
      sym_field_declaration_list,
  [327396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    STATE(6066), 1,
      sym_field_declaration_list,
  [327406] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [327414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15222), 1,
      anon_sym_LPAREN2,
    STATE(9886), 1,
      sym_parenthesized_expression,
  [327424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15286), 1,
      anon_sym_LPAREN2,
    ACTIONS(15288), 1,
      sym_raw_string_delimiter,
  [327434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6478), 1,
      anon_sym_LBRACE,
    STATE(3001), 1,
      sym_field_declaration_list,
  [327444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(9266), 1,
      sym_compound_statement,
  [327454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13526), 1,
      anon_sym_LBRACE,
    STATE(1859), 1,
      sym_requirement_seq,
  [327464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15226), 1,
      anon_sym_COMMA,
    ACTIONS(15290), 1,
      anon_sym_RBRACE,
  [327474] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(15292), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(15294), 1,
      sym_preproc_arg,
  [327484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6343), 1,
      anon_sym_LT,
    STATE(2686), 1,
      sym_template_argument_list,
  [327494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(655), 1,
      anon_sym_LBRACE,
    STATE(809), 1,
      sym_compound_statement,
  [327504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11521), 1,
      anon_sym_LBRACE,
    STATE(2553), 1,
      sym_compound_statement,
  [327514] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2828), 1,
      anon_sym_LBRACE,
    STATE(662), 1,
      sym_field_declaration_list,
  [327524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 1,
      anon_sym_LT,
    STATE(212), 1,
      sym_template_argument_list,
  [327534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5148), 1,
      anon_sym_LBRACE,
    STATE(1070), 1,
      sym_declaration_list,
  [327544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2828), 1,
      anon_sym_LBRACE,
    STATE(661), 1,
      sym_field_declaration_list,
  [327554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15296), 1,
      anon_sym_LPAREN2,
    ACTIONS(15298), 1,
      sym_raw_string_delimiter,
  [327564] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(15300), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(15302), 1,
      sym_preproc_arg,
  [327574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15216), 1,
      anon_sym_LT,
    STATE(3202), 1,
      sym_template_argument_list,
  [327584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2738), 1,
      anon_sym_LT,
    STATE(337), 1,
      sym_template_argument_list,
  [327594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1219), 1,
      anon_sym_LBRACE,
    STATE(659), 1,
      sym_compound_statement,
  [327604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15304), 1,
      anon_sym_LT,
    STATE(3372), 1,
      sym_template_argument_list,
  [327614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11560), 1,
      anon_sym_LBRACE,
    STATE(2517), 1,
      sym_compound_statement,
  [327624] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(15306), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(15308), 1,
      sym_preproc_arg,
  [327634] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15310), 1,
      sym_identifier,
    STATE(460), 1,
      sym_template_type,
  [327644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    STATE(734), 1,
      sym_field_declaration_list,
  [327654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    STATE(822), 1,
      sym_field_declaration_list,
  [327664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1219), 1,
      anon_sym_LBRACE,
    STATE(840), 1,
      sym_compound_statement,
  [327674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11986), 1,
      anon_sym_RBRACE,
    ACTIONS(15226), 1,
      anon_sym_COMMA,
  [327684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4583), 1,
      anon_sym_LBRACE,
    STATE(4291), 1,
      sym_initializer_list,
  [327694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(309), 1,
      anon_sym_LBRACE,
    STATE(527), 1,
      sym_compound_statement,
  [327704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    STATE(617), 1,
      sym_field_declaration_list,
  [327714] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    STATE(621), 1,
      sym_field_declaration_list,
  [327724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    STATE(734), 1,
      sym_field_declaration_list,
  [327734] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    STATE(2700), 1,
      sym_field_declaration_list,
  [327744] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7194), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [327752] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15312), 1,
      sym_identifier,
    STATE(3394), 1,
      sym_template_type,
  [327762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    STATE(1138), 1,
      sym_condition_clause,
  [327772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(309), 1,
      anon_sym_LBRACE,
    STATE(293), 1,
      sym_compound_statement,
  [327782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15224), 1,
      anon_sym_LT,
    STATE(4354), 1,
      sym_template_argument_list,
  [327792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14623), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [327800] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(15314), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(15316), 1,
      sym_preproc_arg,
  [327810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14784), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [327818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    STATE(1140), 1,
      sym_condition_clause,
  [327828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11521), 1,
      anon_sym_LBRACE,
    STATE(2004), 1,
      sym_compound_statement,
  [327838] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15318), 1,
      sym_identifier,
    STATE(2672), 1,
      sym_template_type,
  [327848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5154), 1,
      anon_sym_LBRACE,
    STATE(542), 1,
      sym_declaration_list,
  [327858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15226), 1,
      anon_sym_COMMA,
    ACTIONS(15320), 1,
      anon_sym_RBRACE,
  [327868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    STATE(653), 1,
      sym_field_declaration_list,
  [327878] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15322), 1,
      anon_sym_LT,
    STATE(3202), 1,
      sym_template_argument_list,
  [327888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15324), 1,
      anon_sym_LPAREN2,
    ACTIONS(15326), 1,
      sym_raw_string_delimiter,
  [327898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6478), 1,
      anon_sym_LBRACE,
    STATE(3013), 1,
      sym_field_declaration_list,
  [327908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6478), 1,
      anon_sym_LBRACE,
    STATE(3014), 1,
      sym_field_declaration_list,
  [327918] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14589), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [327926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10512), 1,
      anon_sym_LBRACE,
    STATE(3258), 1,
      sym_requirement_seq,
  [327936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11617), 1,
      anon_sym_LBRACE,
    STATE(1525), 1,
      sym_compound_statement,
  [327946] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15328), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [327954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15304), 1,
      anon_sym_LT,
    STATE(4253), 1,
      sym_template_argument_list,
  [327964] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(15330), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(15332), 1,
      sym_preproc_arg,
  [327974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9488), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [327982] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15334), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [327990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14729), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [327998] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(15336), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(15338), 1,
      sym_preproc_arg,
  [328008] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    STATE(1169), 1,
      sym_condition_clause,
  [328018] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15340), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [328026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15254), 1,
      sym_identifier,
    STATE(9116), 1,
      sym_attribute,
  [328036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    STATE(9940), 1,
      sym_condition_clause,
  [328046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14681), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [328054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11963), 1,
      anon_sym_RBRACE,
    ACTIONS(15226), 1,
      anon_sym_COMMA,
  [328064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2351), 1,
      anon_sym_LT,
    STATE(212), 1,
      sym_template_argument_list,
  [328074] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(9153), 1,
      sym_compound_statement,
  [328084] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15342), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [328092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15344), 1,
      anon_sym_LT,
    STATE(4549), 1,
      sym_template_argument_list,
  [328102] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    STATE(601), 1,
      sym_field_declaration_list,
  [328112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15346), 1,
      anon_sym_LPAREN2,
    ACTIONS(15348), 1,
      sym_raw_string_delimiter,
  [328122] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5154), 1,
      anon_sym_LBRACE,
    STATE(481), 1,
      sym_declaration_list,
  [328132] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12020), 1,
      anon_sym_RBRACE,
    ACTIONS(15226), 1,
      anon_sym_COMMA,
  [328142] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15350), 1,
      sym_identifier,
    ACTIONS(15352), 1,
      anon_sym_LPAREN2,
  [328152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    STATE(10815), 1,
      sym_argument_list,
  [328162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(8647), 1,
      sym_compound_statement,
  [328172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    STATE(9881), 1,
      sym_parameter_list,
  [328182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15354), 1,
      anon_sym_if,
    ACTIONS(15356), 1,
      anon_sym_for,
  [328192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    STATE(9692), 1,
      sym_condition_clause,
  [328202] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(15358), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(15360), 1,
      sym_preproc_arg,
  [328212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    STATE(2703), 1,
      sym_field_declaration_list,
  [328222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2828), 1,
      anon_sym_LBRACE,
    STATE(755), 1,
      sym_field_declaration_list,
  [328232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    STATE(2710), 1,
      sym_field_declaration_list,
  [328242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11560), 1,
      anon_sym_LBRACE,
    STATE(2514), 1,
      sym_compound_statement,
  [328252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10529), 1,
      anon_sym_LBRACE,
    STATE(4980), 1,
      sym_requirement_seq,
  [328262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15362), 1,
      sym_identifier,
    STATE(5090), 1,
      sym_template_type,
  [328272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5152), 1,
      anon_sym_LBRACE,
    STATE(979), 1,
      sym_declaration_list,
  [328282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15364), 1,
      sym_identifier,
    STATE(2873), 1,
      sym_template_type,
  [328292] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8483), 1,
      anon_sym_LBRACE,
    STATE(4919), 1,
      sym_field_declaration_list,
  [328302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13864), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15366), 1,
      anon_sym_SEMI,
  [328312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    STATE(10079), 1,
      sym_argument_list,
  [328322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13826), 1,
      anon_sym_LBRACE,
    STATE(6741), 1,
      sym_requirement_seq,
  [328332] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15222), 1,
      anon_sym_LPAREN2,
    STATE(10827), 1,
      sym_parenthesized_expression,
  [328342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(492), 1,
      sym_compound_statement,
  [328352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2487), 1,
      anon_sym_LT,
    STATE(251), 1,
      sym_template_argument_list,
  [328362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12037), 1,
      anon_sym_RBRACE,
    ACTIONS(15226), 1,
      anon_sym_COMMA,
  [328372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    STATE(9758), 1,
      sym_parameter_list,
  [328382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8483), 1,
      anon_sym_LBRACE,
    STATE(4895), 1,
      sym_field_declaration_list,
  [328392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(309), 1,
      anon_sym_LBRACE,
    STATE(323), 1,
      sym_compound_statement,
  [328402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8483), 1,
      anon_sym_LBRACE,
    STATE(4948), 1,
      sym_field_declaration_list,
  [328412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1219), 1,
      anon_sym_LBRACE,
    STATE(715), 1,
      sym_compound_statement,
  [328422] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15254), 1,
      sym_identifier,
    STATE(9173), 1,
      sym_attribute,
  [328432] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(15368), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(15370), 1,
      sym_preproc_arg,
  [328442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6961), 1,
      anon_sym_LBRACE,
    STATE(3412), 1,
      sym_field_declaration_list,
  [328452] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15226), 1,
      anon_sym_COMMA,
    ACTIONS(15372), 1,
      anon_sym_RBRACE,
  [328462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2479), 1,
      anon_sym_LBRACE,
    STATE(327), 1,
      sym_field_declaration_list,
  [328472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(9485), 1,
      sym_compound_statement,
  [328482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2479), 1,
      anon_sym_LBRACE,
    STATE(328), 1,
      sym_field_declaration_list,
  [328492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8483), 1,
      anon_sym_LBRACE,
    STATE(4946), 1,
      sym_field_declaration_list,
  [328502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2479), 1,
      anon_sym_LBRACE,
    STATE(329), 1,
      sym_field_declaration_list,
  [328512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15222), 1,
      anon_sym_LPAREN2,
    STATE(9735), 1,
      sym_parenthesized_expression,
  [328522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    STATE(799), 1,
      sym_field_declaration_list,
  [328532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    STATE(802), 1,
      sym_field_declaration_list,
  [328542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    STATE(747), 1,
      sym_field_declaration_list,
  [328552] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9275), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [328560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7067), 1,
      anon_sym_LBRACE,
    STATE(3487), 1,
      sym_field_declaration_list,
  [328570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(655), 1,
      anon_sym_LBRACE,
    STATE(990), 1,
      sym_compound_statement,
  [328580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1219), 1,
      anon_sym_LBRACE,
    STATE(876), 1,
      sym_compound_statement,
  [328590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(800), 1,
      sym_compound_statement,
  [328600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11521), 1,
      anon_sym_LBRACE,
    STATE(1844), 1,
      sym_compound_statement,
  [328610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15374), 1,
      anon_sym_LPAREN2,
    ACTIONS(15376), 1,
      sym_raw_string_delimiter,
  [328620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15226), 1,
      anon_sym_COMMA,
    ACTIONS(15378), 1,
      anon_sym_RBRACE,
  [328630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7067), 1,
      anon_sym_LBRACE,
    STATE(3509), 1,
      sym_field_declaration_list,
  [328640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10572), 1,
      anon_sym_LBRACE,
    STATE(4672), 1,
      sym_requirement_seq,
  [328650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 1,
      anon_sym_LT,
    STATE(3604), 1,
      sym_template_argument_list,
  [328660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7067), 1,
      anon_sym_LBRACE,
    STATE(3506), 1,
      sym_field_declaration_list,
  [328670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15380), 1,
      sym_identifier,
    STATE(3373), 1,
      sym_template_type,
  [328680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(8605), 1,
      sym_compound_statement,
  [328690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15236), 1,
      sym_identifier,
    STATE(5090), 1,
      sym_template_type,
  [328700] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15382), 1,
      sym_identifier,
    STATE(4776), 1,
      sym_template_type,
  [328710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7278), 1,
      anon_sym_LBRACE,
    STATE(3617), 1,
      sym_field_declaration_list,
  [328720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    STATE(1124), 1,
      sym_condition_clause,
  [328730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(309), 1,
      anon_sym_LBRACE,
    STATE(448), 1,
      sym_compound_statement,
  [328740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15384), 1,
      anon_sym_if,
    ACTIONS(15386), 1,
      anon_sym_for,
  [328750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15388), 1,
      anon_sym_LPAREN2,
    ACTIONS(15390), 1,
      sym_raw_string_delimiter,
  [328760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13990), 1,
      anon_sym_LBRACE,
    STATE(6873), 1,
      sym_requirement_seq,
  [328770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9869), 1,
      anon_sym_LT,
    STATE(5082), 1,
      sym_template_argument_list,
  [328780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12031), 1,
      anon_sym_RBRACE,
    ACTIONS(15226), 1,
      anon_sym_COMMA,
  [328790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11974), 1,
      anon_sym_RBRACE,
    ACTIONS(15226), 1,
      anon_sym_COMMA,
  [328800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    STATE(1178), 1,
      sym_condition_clause,
  [328810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15392), 2,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [328818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    STATE(10460), 1,
      sym_argument_list,
  [328828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(655), 1,
      anon_sym_LBRACE,
    STATE(887), 1,
      sym_compound_statement,
  [328838] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15254), 1,
      sym_identifier,
    STATE(9638), 1,
      sym_attribute,
  [328848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7278), 1,
      anon_sym_LBRACE,
    STATE(3667), 1,
      sym_field_declaration_list,
  [328858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(9628), 1,
      sym_compound_statement,
  [328868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7278), 1,
      anon_sym_LBRACE,
    STATE(3669), 1,
      sym_field_declaration_list,
  [328878] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 1,
      anon_sym_LT,
    STATE(2816), 1,
      sym_template_argument_list,
  [328888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15222), 1,
      anon_sym_LPAREN2,
    STATE(9906), 1,
      sym_parenthesized_expression,
  [328898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    STATE(10778), 1,
      sym_argument_list,
  [328908] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(15394), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(15396), 1,
      sym_preproc_arg,
  [328918] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15398), 1,
      anon_sym_if,
    ACTIONS(15400), 1,
      anon_sym_for,
  [328928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2013), 1,
      anon_sym_LBRACE,
    STATE(1282), 1,
      sym_compound_statement,
  [328938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6478), 1,
      anon_sym_LBRACE,
    STATE(3025), 1,
      sym_field_declaration_list,
  [328948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    STATE(9945), 1,
      sym_parameter_list,
  [328958] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(585), 1,
      sym_compound_statement,
  [328968] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15402), 1,
      anon_sym_LPAREN2,
    ACTIONS(15404), 1,
      sym_raw_string_delimiter,
  [328978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11617), 1,
      anon_sym_LBRACE,
    STATE(1620), 1,
      sym_compound_statement,
  [328988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym_LBRACE,
    STATE(5743), 1,
      sym_initializer_list,
  [328998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    STATE(1172), 1,
      sym_condition_clause,
  [329008] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15406), 1,
      anon_sym_LPAREN2,
    ACTIONS(15408), 1,
      sym_raw_string_delimiter,
  [329018] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15410), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [329026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2834), 1,
      anon_sym_LT,
    STATE(526), 1,
      sym_template_argument_list,
  [329036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15412), 1,
      anon_sym_LPAREN2,
    ACTIONS(15414), 1,
      sym_raw_string_delimiter,
  [329046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    STATE(582), 1,
      sym_field_declaration_list,
  [329056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15226), 1,
      anon_sym_COMMA,
    ACTIONS(15416), 1,
      anon_sym_RBRACE,
  [329066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15418), 1,
      anon_sym_LPAREN2,
    ACTIONS(15420), 1,
      sym_raw_string_delimiter,
  [329076] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15422), 1,
      anon_sym_LPAREN2,
    ACTIONS(15424), 1,
      sym_raw_string_delimiter,
  [329086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    STATE(581), 1,
      sym_field_declaration_list,
  [329096] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    STATE(9728), 1,
      sym_parameter_list,
  [329106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15304), 1,
      anon_sym_LT,
    STATE(4112), 1,
      sym_template_argument_list,
  [329116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5154), 1,
      anon_sym_LBRACE,
    STATE(476), 1,
      sym_declaration_list,
  [329126] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15222), 1,
      anon_sym_LPAREN2,
    STATE(10495), 1,
      sym_parenthesized_expression,
  [329136] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15426), 1,
      anon_sym_LPAREN2,
    ACTIONS(15428), 1,
      sym_raw_string_delimiter,
  [329146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6160), 1,
      anon_sym_LT,
    STATE(2609), 1,
      sym_template_argument_list,
  [329156] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    STATE(10477), 1,
      sym_argument_list,
  [329166] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9117), 1,
      anon_sym_RPAREN,
    ACTIONS(9119), 1,
      anon_sym_SEMI,
  [329176] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(9107), 1,
      sym_compound_statement,
  [329186] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15430), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [329194] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(9507), 1,
      sym_compound_statement,
  [329204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15226), 1,
      anon_sym_COMMA,
    ACTIONS(15432), 1,
      anon_sym_RBRACE,
  [329214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15434), 1,
      sym_identifier,
    ACTIONS(15436), 1,
      anon_sym_RPAREN,
  [329224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15438), 1,
      sym_identifier,
    STATE(1242), 1,
      sym_template_type,
  [329234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15222), 1,
      anon_sym_LPAREN2,
    STATE(9744), 1,
      sym_parenthesized_expression,
  [329244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15440), 1,
      anon_sym_LPAREN2,
    ACTIONS(15442), 1,
      sym_raw_string_delimiter,
  [329254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11521), 1,
      anon_sym_LBRACE,
    STATE(1964), 1,
      sym_compound_statement,
  [329264] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15444), 1,
      anon_sym_LPAREN2,
    ACTIONS(15446), 1,
      sym_raw_string_delimiter,
  [329274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15448), 1,
      anon_sym_LPAREN2,
    ACTIONS(15450), 1,
      sym_raw_string_delimiter,
  [329284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    STATE(10486), 1,
      sym_argument_list,
  [329294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13864), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15452), 1,
      anon_sym_SEMI,
  [329304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(655), 1,
      anon_sym_LBRACE,
    STATE(623), 1,
      sym_compound_statement,
  [329314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15454), 1,
      anon_sym_LPAREN2,
    ACTIONS(15456), 1,
      sym_raw_string_delimiter,
  [329324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7278), 1,
      anon_sym_LBRACE,
    STATE(3651), 1,
      sym_field_declaration_list,
  [329334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    STATE(902), 1,
      sym_field_declaration_list,
  [329344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6230), 1,
      anon_sym_LBRACE,
    STATE(2711), 1,
      sym_field_declaration_list,
  [329354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15458), 1,
      sym_identifier,
    STATE(2953), 1,
      sym_template_type,
  [329364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15460), 1,
      anon_sym_LPAREN2,
    ACTIONS(15462), 1,
      sym_raw_string_delimiter,
  [329374] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    STATE(918), 1,
      sym_field_declaration_list,
  [329384] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14446), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [329392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    STATE(9978), 1,
      sym_parameter_list,
  [329402] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14401), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [329410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15222), 1,
      anon_sym_LPAREN2,
    STATE(10092), 1,
      sym_parenthesized_expression,
  [329420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2479), 1,
      anon_sym_LBRACE,
    STATE(360), 1,
      sym_field_declaration_list,
  [329430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4867), 1,
      anon_sym_LBRACE,
    STATE(4646), 1,
      sym_initializer_list,
  [329440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    STATE(9379), 1,
      sym_parameter_list,
  [329450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    STATE(9806), 1,
      sym_parameter_list,
  [329460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10537), 1,
      anon_sym_LBRACE,
    STATE(4349), 1,
      sym_requirement_seq,
  [329470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    STATE(555), 1,
      sym_field_declaration_list,
  [329480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    STATE(9609), 1,
      sym_parameter_list,
  [329490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7067), 1,
      anon_sym_LBRACE,
    STATE(3497), 1,
      sym_field_declaration_list,
  [329500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15254), 1,
      sym_identifier,
    STATE(9425), 1,
      sym_attribute,
  [329510] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(15464), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(15466), 1,
      sym_preproc_arg,
  [329520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(9409), 1,
      sym_compound_statement,
  [329530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(309), 1,
      anon_sym_LBRACE,
    STATE(281), 1,
      sym_compound_statement,
  [329540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5809), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [329548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13864), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15468), 1,
      anon_sym_SEMI,
  [329558] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    STATE(10659), 1,
      sym_argument_list,
  [329568] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15470), 1,
      sym_identifier,
    STATE(2616), 1,
      sym_template_type,
  [329578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9107), 1,
      anon_sym_RBRACK,
    ACTIONS(15472), 1,
      anon_sym_COMMA,
  [329588] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    STATE(5654), 1,
      sym_field_declaration_list,
  [329598] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7216), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [329606] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14278), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [329614] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14158), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [329622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15226), 1,
      anon_sym_COMMA,
    ACTIONS(15474), 1,
      anon_sym_RBRACE,
  [329632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15222), 1,
      anon_sym_LPAREN2,
    STATE(10039), 1,
      sym_parenthesized_expression,
  [329642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(655), 1,
      anon_sym_LBRACE,
    STATE(723), 1,
      sym_compound_statement,
  [329652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5156), 1,
      anon_sym_LBRACE,
    STATE(884), 1,
      sym_declaration_list,
  [329662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15476), 1,
      anon_sym_if,
    ACTIONS(15478), 1,
      anon_sym_for,
  [329672] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    STATE(740), 1,
      sym_field_declaration_list,
  [329682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    STATE(1098), 1,
      sym_condition_clause,
  [329692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    STATE(10497), 1,
      sym_argument_list,
  [329702] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    STATE(9839), 1,
      sym_parameter_list,
  [329712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9270), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [329720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 1,
      anon_sym_LT,
    STATE(3186), 1,
      sym_template_argument_list,
  [329730] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15480), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [329738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(723), 1,
      sym_compound_statement,
  [329748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(8782), 1,
      sym_compound_statement,
  [329758] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(15482), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(15484), 1,
      sym_preproc_arg,
  [329768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    STATE(740), 1,
      sym_field_declaration_list,
  [329778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9869), 1,
      anon_sym_LT,
    STATE(4775), 1,
      sym_template_argument_list,
  [329788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(9325), 1,
      sym_compound_statement,
  [329798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    STATE(742), 1,
      sym_field_declaration_list,
  [329808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    STATE(742), 1,
      sym_field_declaration_list,
  [329818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12006), 1,
      anon_sym_RBRACE,
    ACTIONS(15226), 1,
      anon_sym_COMMA,
  [329828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    STATE(10310), 1,
      sym_argument_list,
  [329838] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym_LBRACE,
    STATE(3105), 1,
      sym_field_declaration_list,
  [329848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9617), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [329856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12000), 1,
      anon_sym_RBRACE,
    ACTIONS(15226), 1,
      anon_sym_COMMA,
  [329866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    STATE(10515), 1,
      sym_argument_list,
  [329876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14234), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [329884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    STATE(5731), 1,
      sym_field_declaration_list,
  [329894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(655), 1,
      anon_sym_LBRACE,
    STATE(800), 1,
      sym_compound_statement,
  [329904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    STATE(5724), 1,
      sym_field_declaration_list,
  [329914] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15486), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [329922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15488), 1,
      sym_identifier,
    STATE(194), 1,
      sym_template_type,
  [329932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15254), 1,
      sym_identifier,
    STATE(10009), 1,
      sym_attribute,
  [329942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    STATE(747), 1,
      sym_field_declaration_list,
  [329952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15226), 1,
      anon_sym_COMMA,
    ACTIONS(15490), 1,
      anon_sym_RBRACE,
  [329962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    STATE(5681), 1,
      sym_field_declaration_list,
  [329972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15254), 1,
      sym_identifier,
    STATE(9252), 1,
      sym_attribute,
  [329982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    STATE(556), 1,
      sym_field_declaration_list,
  [329992] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(9245), 1,
      sym_compound_statement,
  [330002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    STATE(802), 1,
      sym_field_declaration_list,
  [330012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    STATE(10591), 1,
      sym_argument_list,
  [330022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      anon_sym_LPAREN2,
    STATE(9907), 1,
      sym_parameter_list,
  [330032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15226), 1,
      anon_sym_COMMA,
    ACTIONS(15492), 1,
      anon_sym_RBRACE,
  [330042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5148), 1,
      anon_sym_LBRACE,
    STATE(1045), 1,
      sym_declaration_list,
  [330052] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    STATE(799), 1,
      sym_field_declaration_list,
  [330062] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5148), 1,
      anon_sym_LBRACE,
    STATE(1037), 1,
      sym_declaration_list,
  [330072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(9627), 1,
      sym_compound_statement,
  [330082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    STATE(1134), 1,
      sym_condition_clause,
  [330092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_LPAREN2,
    STATE(9794), 1,
      sym_condition_clause,
  [330102] = 3,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(15494), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(15496), 1,
      sym_preproc_arg,
  [330112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LBRACE,
    STATE(726), 1,
      sym_field_declaration_list,
  [330122] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15254), 1,
      sym_identifier,
    STATE(9164), 1,
      sym_attribute,
  [330132] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15254), 1,
      sym_identifier,
    STATE(9089), 1,
      sym_attribute,
  [330142] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8528), 1,
      anon_sym_LPAREN2,
    STATE(10548), 1,
      sym_argument_list,
  [330152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15498), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [330160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(553), 1,
      sym_compound_statement,
  [330170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5156), 1,
      anon_sym_LBRACE,
    STATE(872), 1,
      sym_declaration_list,
  [330180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15500), 1,
      sym_identifier,
    STATE(3352), 1,
      sym_template_type,
  [330190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    STATE(554), 1,
      sym_field_declaration_list,
  [330200] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15502), 1,
      anon_sym_RPAREN,
  [330207] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15504), 1,
      aux_sym_preproc_if_token2,
  [330214] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15506), 1,
      anon_sym_SEMI,
  [330221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15492), 1,
      anon_sym_RBRACE,
  [330228] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15508), 1,
      sym_raw_string_delimiter,
  [330235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15510), 1,
      aux_sym_preproc_if_token2,
  [330242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15512), 1,
      sym_identifier,
  [330249] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15514), 1,
      anon_sym_RPAREN,
  [330256] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8998), 1,
      anon_sym_RBRACE,
  [330263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15516), 1,
      anon_sym_RPAREN,
  [330270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15518), 1,
      anon_sym_RPAREN,
  [330277] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15520), 1,
      anon_sym_RPAREN,
  [330284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11937), 1,
      anon_sym_RPAREN,
  [330291] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15522), 1,
      sym_identifier,
  [330298] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15524), 1,
      sym_raw_string_delimiter,
  [330305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15526), 1,
      sym_raw_string_delimiter,
  [330312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15528), 1,
      sym_identifier,
  [330319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15530), 1,
      anon_sym_RPAREN,
  [330326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15532), 1,
      anon_sym_SEMI,
  [330333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15534), 1,
      sym_identifier,
  [330340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15536), 1,
      aux_sym_preproc_if_token2,
  [330347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15538), 1,
      anon_sym_RPAREN,
  [330354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15540), 1,
      anon_sym_SEMI,
  [330361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12006), 1,
      anon_sym_RBRACE,
  [330368] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15542), 1,
      anon_sym_LPAREN2,
  [330375] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15544), 1,
      sym_raw_string_delimiter,
  [330382] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15546), 1,
      anon_sym_RBRACE,
  [330389] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15548), 1,
      aux_sym_preproc_if_token2,
  [330396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15550), 1,
      anon_sym_RPAREN,
  [330403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15552), 1,
      anon_sym_RPAREN,
  [330410] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15554), 1,
      anon_sym_SEMI,
  [330417] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15556), 1,
      sym_identifier,
  [330424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15558), 1,
      anon_sym_RPAREN,
  [330431] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15560), 1,
      anon_sym_RBRACE,
  [330438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15562), 1,
      sym_identifier,
  [330445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15564), 1,
      sym_identifier,
  [330452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15566), 1,
      sym_raw_string_delimiter,
  [330459] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15568), 1,
      sym_identifier,
  [330466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15570), 1,
      anon_sym_COLON,
  [330473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15572), 1,
      sym_raw_string_delimiter,
  [330480] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12025), 1,
      anon_sym_RPAREN,
  [330487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15574), 1,
      sym_identifier,
  [330494] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15576), 1,
      anon_sym_RPAREN,
  [330501] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15578), 1,
      sym_identifier,
  [330508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15580), 1,
      anon_sym_SEMI,
  [330515] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15582), 1,
      anon_sym_SEMI,
  [330522] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15584), 1,
      sym_raw_string_delimiter,
  [330529] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15586), 1,
      anon_sym_SEMI,
  [330536] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15588), 1,
      anon_sym_DQUOTE,
  [330543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9117), 1,
      anon_sym_RPAREN,
  [330550] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15590), 1,
      anon_sym_RPAREN,
  [330557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15592), 1,
      anon_sym_RPAREN,
  [330564] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15594), 1,
      sym_identifier,
  [330571] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15596), 1,
      anon_sym_RPAREN,
  [330578] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15598), 1,
      sym_raw_string_delimiter,
  [330585] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15600), 1,
      aux_sym_preproc_if_token2,
  [330592] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15602), 1,
      aux_sym_preproc_if_token2,
  [330599] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15604), 1,
      anon_sym_RPAREN,
  [330606] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15606), 1,
      anon_sym_DOT_DOT_DOT,
  [330613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_DOT_DOT_DOT,
  [330620] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15611), 1,
      aux_sym_preproc_if_token2,
  [330627] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15613), 1,
      sym_raw_string_delimiter,
  [330634] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15615), 1,
      anon_sym_RPAREN,
  [330641] = 2,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(15617), 1,
      aux_sym_preproc_include_token2,
  [330648] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15619), 1,
      anon_sym_RPAREN,
  [330655] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9578), 1,
      anon_sym_SEMI,
  [330662] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15621), 1,
      anon_sym_RPAREN,
  [330669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15623), 1,
      sym_identifier,
  [330676] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15625), 1,
      sym_raw_string_delimiter,
  [330683] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15627), 1,
      anon_sym_RPAREN,
  [330690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15629), 1,
      aux_sym_preproc_if_token2,
  [330697] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15631), 1,
      anon_sym_RPAREN,
  [330704] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15633), 1,
      sym_identifier,
  [330711] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15635), 1,
      aux_sym_preproc_if_token2,
  [330718] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15637), 1,
      sym_identifier,
  [330725] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15639), 1,
      sym_raw_string_delimiter,
  [330732] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15641), 1,
      anon_sym_RPAREN,
  [330739] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15643), 1,
      anon_sym_COMMA,
  [330746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15645), 1,
      anon_sym_RPAREN,
  [330753] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9725), 1,
      anon_sym_RPAREN,
  [330760] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15647), 1,
      sym_raw_string_content,
  [330767] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15649), 1,
      anon_sym_RBRACE,
  [330774] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15651), 1,
      sym_raw_string_delimiter,
  [330781] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15653), 1,
      sym_raw_string_delimiter,
  [330788] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11959), 1,
      anon_sym_RPAREN,
  [330795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15655), 1,
      sym_identifier,
  [330802] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15657), 1,
      aux_sym_preproc_if_token2,
  [330809] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15659), 1,
      anon_sym_SEMI,
  [330816] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15661), 1,
      anon_sym_RPAREN,
  [330823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9641), 1,
      anon_sym_COLON,
  [330830] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15663), 1,
      anon_sym_SEMI,
  [330837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15665), 1,
      sym_identifier,
  [330844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15667), 1,
      anon_sym_RPAREN,
  [330851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15669), 1,
      anon_sym_SEMI,
  [330858] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15671), 1,
      anon_sym_STAR,
  [330865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15673), 1,
      sym_identifier,
  [330872] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15675), 1,
      sym_identifier,
  [330879] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15677), 1,
      sym_identifier,
  [330886] = 2,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(15679), 1,
      aux_sym_preproc_include_token2,
  [330893] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15681), 1,
      anon_sym_SEMI,
  [330900] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13561), 1,
      anon_sym_SEMI,
  [330907] = 2,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(11130), 1,
      aux_sym_preproc_include_token2,
  [330914] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14816), 1,
      anon_sym_SEMI,
  [330921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15683), 1,
      anon_sym_SEMI,
  [330928] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15685), 1,
      anon_sym_SEMI,
  [330935] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15687), 1,
      anon_sym_SEMI,
  [330942] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15689), 1,
      anon_sym_RPAREN,
  [330949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15691), 1,
      aux_sym_preproc_if_token2,
  [330956] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15693), 1,
      anon_sym_DQUOTE,
  [330963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15695), 1,
      aux_sym_preproc_if_token2,
  [330970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15697), 1,
      anon_sym_LBRACE,
  [330977] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15699), 1,
      sym_raw_string_delimiter,
  [330984] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12010), 1,
      anon_sym_RPAREN,
  [330991] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15701), 1,
      anon_sym_STAR,
  [330998] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15703), 1,
      anon_sym_RPAREN,
  [331005] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15705), 1,
      sym_identifier,
  [331012] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15707), 1,
      sym_identifier,
  [331019] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15709), 1,
      anon_sym_SEMI,
  [331026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15711), 1,
      anon_sym_LPAREN2,
  [331033] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15713), 1,
      anon_sym_SEMI,
  [331040] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15715), 1,
      anon_sym_RPAREN,
  [331047] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15717), 1,
      sym_identifier,
  [331054] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15719), 1,
      sym_identifier,
  [331061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15721), 1,
      anon_sym_RPAREN,
  [331068] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15723), 1,
      anon_sym_RPAREN,
  [331075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15725), 1,
      anon_sym_SEMI,
  [331082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15727), 1,
      anon_sym_DQUOTE,
  [331089] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15729), 1,
      aux_sym_preproc_if_token2,
  [331096] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15731), 1,
      anon_sym_SEMI,
  [331103] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15733), 1,
      anon_sym_SEMI,
  [331110] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15735), 1,
      anon_sym_SEMI,
  [331117] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15737), 1,
      anon_sym_STAR,
  [331124] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15739), 1,
      anon_sym_LPAREN2,
  [331131] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15741), 1,
      anon_sym_SEMI,
  [331138] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15743), 1,
      anon_sym_LPAREN2,
  [331145] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15745), 1,
      anon_sym_LPAREN2,
  [331152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15747), 1,
      anon_sym_LPAREN2,
  [331159] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15749), 1,
      anon_sym_LPAREN2,
  [331166] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15751), 1,
      sym_identifier,
  [331173] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15753), 1,
      anon_sym_LPAREN2,
  [331180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15755), 1,
      anon_sym_RPAREN,
  [331187] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15757), 1,
      anon_sym_LPAREN2,
  [331194] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15759), 1,
      sym_identifier,
  [331201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15761), 1,
      sym_identifier,
  [331208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15763), 1,
      anon_sym_SEMI,
  [331215] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15765), 1,
      anon_sym_SEMI,
  [331222] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15767), 1,
      anon_sym_RPAREN,
  [331229] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15769), 1,
      anon_sym_RPAREN,
  [331236] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15771), 1,
      sym_identifier,
  [331243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15773), 1,
      sym_identifier,
  [331250] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13646), 1,
      anon_sym_SEMI,
  [331257] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15775), 1,
      sym_identifier,
  [331264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15777), 1,
      anon_sym_RPAREN,
  [331271] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15779), 1,
      aux_sym_preproc_if_token2,
  [331278] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15781), 1,
      aux_sym_preproc_if_token2,
  [331285] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15783), 1,
      anon_sym_while,
  [331292] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15785), 1,
      sym_identifier,
  [331299] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15787), 1,
      anon_sym_LPAREN2,
  [331306] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9545), 1,
      anon_sym_RPAREN,
  [331313] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15789), 1,
      anon_sym_LBRACE,
  [331320] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15791), 1,
      anon_sym_SEMI,
  [331327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15793), 1,
      sym_identifier,
  [331334] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15795), 1,
      anon_sym_SEMI,
  [331341] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15797), 1,
      sym_raw_string_delimiter,
  [331348] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15799), 1,
      anon_sym_EQ,
  [331355] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15801), 1,
      sym_raw_string_content,
  [331362] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11924), 1,
      anon_sym_RPAREN,
  [331369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15803), 1,
      anon_sym_SEMI,
  [331376] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15805), 1,
      anon_sym_LBRACE,
  [331383] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15807), 1,
      anon_sym_STAR,
  [331390] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15809), 1,
      anon_sym_LPAREN2,
  [331397] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15811), 1,
      anon_sym_LBRACE,
  [331404] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15813), 1,
      anon_sym_RPAREN,
  [331411] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15815), 1,
      anon_sym_RBRACK,
  [331418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15817), 1,
      anon_sym_RPAREN,
  [331425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15819), 1,
      anon_sym_RPAREN,
  [331432] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15821), 1,
      anon_sym_RPAREN,
  [331439] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15823), 1,
      anon_sym_RPAREN,
  [331446] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9549), 1,
      anon_sym_RPAREN,
  [331453] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8920), 1,
      anon_sym_RPAREN,
  [331460] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15825), 1,
      sym_identifier,
  [331467] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9547), 1,
      anon_sym_RPAREN,
  [331474] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15827), 1,
      sym_identifier,
  [331481] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15829), 1,
      anon_sym_RPAREN,
  [331488] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15831), 1,
      anon_sym_COMMA,
  [331495] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9452), 1,
      anon_sym_COLON,
  [331502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15833), 1,
      sym_raw_string_content,
  [331509] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15835), 1,
      anon_sym_SEMI,
  [331516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15837), 1,
      anon_sym_SEMI,
  [331523] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15839), 1,
      anon_sym_RPAREN,
  [331530] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15841), 1,
      anon_sym_SEMI,
  [331537] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9539), 1,
      anon_sym_COLON,
  [331544] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15843), 1,
      sym_identifier,
  [331551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15845), 1,
      anon_sym_LPAREN2,
  [331558] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15847), 1,
      anon_sym_RPAREN,
  [331565] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15849), 1,
      anon_sym_RPAREN,
  [331572] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15851), 1,
      sym_identifier,
  [331579] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15853), 1,
      sym_identifier,
  [331586] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15855), 1,
      anon_sym_COLON,
  [331593] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15857), 1,
      sym_identifier,
  [331600] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9533), 1,
      anon_sym_COLON,
  [331607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15859), 1,
      anon_sym_RPAREN,
  [331614] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15861), 1,
      anon_sym_LBRACE,
  [331621] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15863), 1,
      anon_sym_STAR,
  [331628] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15865), 1,
      sym_identifier,
  [331635] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15867), 1,
      anon_sym_RPAREN,
  [331642] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15869), 1,
      sym_identifier,
  [331649] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15871), 1,
      sym_identifier,
  [331656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15873), 1,
      aux_sym_preproc_if_token2,
  [331663] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11961), 1,
      anon_sym_RBRACE,
  [331670] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15875), 1,
      aux_sym_preproc_if_token2,
  [331677] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15877), 1,
      aux_sym_preproc_if_token2,
  [331684] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9133), 1,
      anon_sym_RBRACE,
  [331691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15879), 1,
      anon_sym_COLON,
  [331698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15881), 1,
      anon_sym_EQ,
  [331705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12722), 1,
      anon_sym_SEMI,
  [331712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15883), 1,
      sym_identifier,
  [331719] = 2,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(10982), 1,
      aux_sym_preproc_include_token2,
  [331726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9679), 1,
      anon_sym_RPAREN,
  [331733] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15885), 1,
      anon_sym_RBRACE,
  [331740] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12782), 1,
      anon_sym_COMMA,
  [331747] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15887), 1,
      anon_sym_COLON,
  [331754] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15889), 1,
      aux_sym_preproc_if_token2,
  [331761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15891), 1,
      anon_sym_SEMI,
  [331768] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15893), 1,
      anon_sym_SEMI,
  [331775] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15895), 1,
      sym_identifier,
  [331782] = 2,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(11012), 1,
      aux_sym_preproc_include_token2,
  [331789] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15897), 1,
      anon_sym_RBRACE,
  [331796] = 2,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(14895), 1,
      aux_sym_preproc_include_token2,
  [331803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7624), 1,
      anon_sym_RPAREN,
  [331810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15899), 1,
      anon_sym_RPAREN,
  [331817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15901), 1,
      anon_sym_RPAREN,
  [331824] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15903), 1,
      anon_sym_RPAREN,
  [331831] = 2,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(15905), 1,
      aux_sym_preproc_include_token2,
  [331838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15907), 1,
      anon_sym_RPAREN,
  [331845] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15909), 1,
      anon_sym_COLON,
  [331852] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15911), 1,
      anon_sym_SEMI,
  [331859] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15913), 1,
      anon_sym_RPAREN,
  [331866] = 2,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(15915), 1,
      aux_sym_preproc_include_token2,
  [331873] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15917), 1,
      sym_identifier,
  [331880] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15919), 1,
      anon_sym_RPAREN,
  [331887] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15921), 1,
      aux_sym_preproc_if_token2,
  [331894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15923), 1,
      anon_sym_STAR,
  [331901] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15925), 1,
      anon_sym_RPAREN,
  [331908] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15927), 1,
      aux_sym_preproc_if_token2,
  [331915] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15929), 1,
      anon_sym_SEMI,
  [331922] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15931), 1,
      anon_sym_SEMI,
  [331929] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9502), 1,
      anon_sym_SEMI,
  [331936] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15933), 1,
      aux_sym_preproc_if_token2,
  [331943] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9498), 1,
      anon_sym_SEMI,
  [331950] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15935), 1,
      anon_sym_SEMI,
  [331957] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15937), 1,
      aux_sym_preproc_if_token2,
  [331964] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15939), 1,
      aux_sym_preproc_if_token2,
  [331971] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7681), 1,
      sym_identifier,
  [331978] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15941), 1,
      aux_sym_preproc_if_token2,
  [331985] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12730), 1,
      anon_sym_SEMI,
  [331992] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15943), 1,
      anon_sym_STAR,
  [331999] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14625), 1,
      anon_sym_COLON_COLON,
  [332006] = 2,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(15945), 1,
      aux_sym_preproc_include_token2,
  [332013] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15947), 1,
      aux_sym_preproc_if_token2,
  [332020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15949), 1,
      sym_identifier,
  [332027] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15951), 1,
      anon_sym_RPAREN,
  [332034] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15953), 1,
      aux_sym_preproc_if_token2,
  [332041] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9824), 1,
      anon_sym_RPAREN,
  [332048] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9400), 1,
      anon_sym_RBRACE,
  [332055] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_LT_LT_EQ,
  [332062] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15957), 1,
      anon_sym_RPAREN,
  [332069] = 2,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(15959), 1,
      aux_sym_preproc_include_token2,
  [332076] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15961), 1,
      anon_sym_RPAREN,
  [332083] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15963), 1,
      anon_sym_RPAREN,
  [332090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_DASH,
  [332097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15965), 1,
      anon_sym_RPAREN,
  [332104] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_PLUS,
  [332111] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11836), 1,
      sym_identifier,
  [332118] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_STAR,
  [332125] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15967), 1,
      anon_sym_SLASH,
  [332132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_PERCENT,
  [332139] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13930), 1,
      anon_sym_SEMI,
  [332146] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_PIPE_PIPE,
  [332153] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_AMP_AMP,
  [332160] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_PIPE,
  [332167] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_CARET,
  [332174] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_AMP,
  [332181] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_EQ_EQ,
  [332188] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15969), 1,
      anon_sym_STAR,
  [332195] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15971), 1,
      anon_sym_SEMI,
  [332202] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15973), 1,
      anon_sym_SEMI,
  [332209] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_BANG_EQ,
  [332216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15975), 1,
      anon_sym_LPAREN2,
  [332223] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15977), 1,
      anon_sym_SEMI,
  [332230] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_GT,
  [332237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15979), 1,
      anon_sym_SEMI,
  [332244] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_GT_EQ,
  [332251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_LT_EQ,
  [332258] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15981), 1,
      anon_sym_SEMI,
  [332265] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_LT,
  [332272] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_LT_LT,
  [332279] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15983), 1,
      anon_sym_LBRACE,
  [332286] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9470), 1,
      anon_sym_COLON,
  [332293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9531), 1,
      anon_sym_SEMI,
  [332300] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15985), 1,
      anon_sym_SEMI,
  [332307] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_GT_GT,
  [332314] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_EQ,
  [332321] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15987), 1,
      sym_raw_string_delimiter,
  [332328] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12045), 1,
      anon_sym_RPAREN,
  [332335] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15989), 1,
      anon_sym_SEMI,
  [332342] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9582), 1,
      anon_sym_RPAREN,
  [332349] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9723), 1,
      anon_sym_RPAREN,
  [332356] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_STAR_EQ,
  [332363] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15991), 1,
      anon_sym_LBRACE,
  [332370] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15993), 1,
      anon_sym_LBRACE,
  [332377] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15995), 1,
      anon_sym_RPAREN,
  [332384] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_COMMA,
  [332391] = 2,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(15997), 1,
      aux_sym_preproc_include_token2,
  [332398] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15999), 1,
      aux_sym_preproc_if_token2,
  [332405] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12020), 1,
      anon_sym_RBRACE,
  [332412] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16001), 1,
      aux_sym_preproc_if_token2,
  [332419] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_PERCENT_EQ,
  [332426] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_PLUS_EQ,
  [332433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_DASH_EQ,
  [332440] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16003), 1,
      sym_identifier,
  [332447] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16005), 1,
      sym_identifier,
  [332454] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9703), 1,
      anon_sym_RPAREN,
  [332461] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16007), 1,
      anon_sym_STAR,
  [332468] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_GT_GT_EQ,
  [332475] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_AMP_EQ,
  [332482] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_SLASH_EQ,
  [332489] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9553), 1,
      anon_sym_COLON,
  [332496] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_PIPE_EQ,
  [332503] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15474), 1,
      anon_sym_RBRACE,
  [332510] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16009), 1,
      anon_sym_LBRACE,
  [332517] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16011), 1,
      anon_sym_SEMI,
  [332524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16013), 1,
      anon_sym_SEMI,
  [332531] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_or,
  [332538] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_and,
  [332545] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_bitor,
  [332552] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_xor,
  [332559] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_bitand,
  [332566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16015), 1,
      anon_sym_RPAREN,
  [332573] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_not_eq,
  [332580] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_DOT_STAR,
  [332587] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_DASH_GT_STAR,
  [332594] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16017), 1,
      anon_sym_SEMI,
  [332601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16019), 1,
      anon_sym_RPAREN,
  [332608] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16021), 1,
      sym_identifier,
  [332615] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16023), 1,
      anon_sym_RPAREN,
  [332622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16025), 1,
      anon_sym_RPAREN,
  [332629] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16027), 1,
      anon_sym_RPAREN,
  [332636] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16029), 1,
      sym_identifier,
  [332643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16031), 1,
      sym_identifier,
  [332650] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16033), 1,
      anon_sym_RPAREN,
  [332657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16035), 1,
      anon_sym_RPAREN,
  [332664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16037), 1,
      sym_identifier,
  [332671] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16039), 1,
      sym_raw_string_delimiter,
  [332678] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16041), 1,
      anon_sym_SEMI,
  [332685] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16043), 1,
      anon_sym_SEMI,
  [332692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12689), 1,
      anon_sym_SEMI,
  [332699] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16045), 1,
      anon_sym_SEMI,
  [332706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16047), 1,
      anon_sym_DQUOTE,
  [332713] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15955), 1,
      anon_sym_CARET_EQ,
  [332720] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16049), 1,
      anon_sym_RPAREN,
  [332727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16051), 1,
      aux_sym_preproc_if_token2,
  [332734] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16053), 1,
      anon_sym_while,
  [332741] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11976), 1,
      anon_sym_RPAREN,
  [332748] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16055), 1,
      anon_sym_RPAREN,
  [332755] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16057), 1,
      anon_sym_STAR,
  [332762] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16059), 1,
      aux_sym_preproc_if_token2,
  [332769] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16061), 1,
      sym_identifier,
  [332776] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16063), 1,
      sym_identifier,
  [332783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16065), 1,
      anon_sym_RPAREN,
  [332790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16067), 1,
      anon_sym_RBRACK,
  [332797] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16069), 1,
      sym_identifier,
  [332804] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16071), 1,
      anon_sym_SEMI,
  [332811] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16073), 1,
      anon_sym_DQUOTE,
  [332818] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16075), 1,
      anon_sym_SEMI,
  [332825] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16077), 1,
      anon_sym_SEMI,
  [332832] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15416), 1,
      anon_sym_RBRACE,
  [332839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16079), 1,
      anon_sym_RPAREN,
  [332846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16081), 1,
      sym_identifier,
  [332853] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16083), 1,
      anon_sym_SEMI,
  [332860] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16085), 1,
      anon_sym_DQUOTE,
  [332867] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16087), 1,
      anon_sym_DQUOTE,
  [332874] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16089), 1,
      anon_sym_DQUOTE,
  [332881] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16091), 1,
      anon_sym_DQUOTE,
  [332888] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16093), 1,
      aux_sym_preproc_if_token2,
  [332895] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7671), 1,
      sym_identifier,
  [332902] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16095), 1,
      aux_sym_preproc_if_token2,
  [332909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16097), 1,
      anon_sym_DQUOTE,
  [332916] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16099), 1,
      anon_sym_DQUOTE,
  [332923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16101), 1,
      anon_sym_SEMI,
  [332930] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16103), 1,
      anon_sym_STAR,
  [332937] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16105), 1,
      anon_sym_SEMI,
  [332944] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16107), 1,
      sym_identifier,
  [332951] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16109), 1,
      anon_sym_SEMI,
  [332958] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16111), 1,
      anon_sym_RPAREN,
  [332965] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16113), 1,
      anon_sym_SEMI,
  [332972] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16115), 1,
      anon_sym_DQUOTE,
  [332979] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16117), 1,
      anon_sym_SEMI,
  [332986] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16119), 1,
      anon_sym_RPAREN,
  [332993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16121), 1,
      anon_sym_SEMI,
  [333000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16123), 1,
      anon_sym_SEMI,
  [333007] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16125), 1,
      anon_sym_STAR,
  [333014] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16127), 1,
      anon_sym_SEMI,
  [333021] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9561), 1,
      anon_sym_SEMI,
  [333028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16129), 1,
      anon_sym_DQUOTE,
  [333035] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16131), 1,
      aux_sym_preproc_if_token2,
  [333042] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16133), 1,
      anon_sym_DQUOTE,
  [333049] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16135), 1,
      anon_sym_RPAREN,
  [333056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16137), 1,
      anon_sym_SEMI,
  [333063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16139), 1,
      anon_sym_SEMI,
  [333070] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16141), 1,
      anon_sym_SEMI,
  [333077] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16143), 1,
      anon_sym_DQUOTE,
  [333084] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16145), 1,
      anon_sym_DQUOTE,
  [333091] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15228), 1,
      anon_sym_RBRACE,
  [333098] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16147), 1,
      anon_sym_SEMI,
  [333105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11947), 1,
      anon_sym_RBRACE,
  [333112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16149), 1,
      anon_sym_RPAREN,
  [333119] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16151), 1,
      anon_sym_RPAREN,
  [333126] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16153), 1,
      anon_sym_DQUOTE,
  [333133] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16155), 1,
      anon_sym_SEMI,
  [333140] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16157), 1,
      anon_sym_RPAREN,
  [333147] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16159), 1,
      anon_sym_RPAREN,
  [333154] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16161), 1,
      anon_sym_DQUOTE,
  [333161] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16163), 1,
      anon_sym_DQUOTE,
  [333168] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15378), 1,
      anon_sym_RBRACE,
  [333175] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16165), 1,
      anon_sym_SEMI,
  [333182] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11974), 1,
      anon_sym_RBRACE,
  [333189] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16167), 1,
      anon_sym_RPAREN,
  [333196] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9476), 1,
      anon_sym_SEMI,
  [333203] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16169), 1,
      anon_sym_LPAREN2,
  [333210] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16171), 1,
      anon_sym_LPAREN2,
  [333217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16173), 1,
      anon_sym_LPAREN2,
  [333224] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16175), 1,
      anon_sym_LPAREN2,
  [333231] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9478), 1,
      anon_sym_SEMI,
  [333238] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16177), 1,
      anon_sym_LPAREN2,
  [333245] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16179), 1,
      anon_sym_LPAREN2,
  [333252] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16181), 1,
      anon_sym_COLON,
  [333259] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16183), 1,
      anon_sym_RPAREN,
  [333266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16185), 1,
      anon_sym_DQUOTE,
  [333273] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16187), 1,
      anon_sym_DQUOTE,
  [333280] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16189), 1,
      anon_sym_while,
  [333287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15490), 1,
      anon_sym_RBRACE,
  [333294] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16191), 1,
      anon_sym_LPAREN2,
  [333301] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9464), 1,
      anon_sym_RPAREN,
  [333308] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12000), 1,
      anon_sym_RBRACE,
  [333315] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16193), 1,
      anon_sym_RPAREN,
  [333322] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16195), 1,
      anon_sym_RPAREN,
  [333329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16197), 1,
      anon_sym_EQ,
  [333336] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16199), 1,
      sym_raw_string_content,
  [333343] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16201), 1,
      anon_sym_STAR,
  [333350] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16203), 1,
      anon_sym_LPAREN2,
  [333357] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16205), 1,
      sym_identifier,
  [333364] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9621), 1,
      anon_sym_SEMI,
  [333371] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9557), 1,
      anon_sym_SEMI,
  [333378] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9623), 1,
      anon_sym_RPAREN,
  [333385] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16207), 1,
      anon_sym_RPAREN,
  [333392] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16209), 1,
      anon_sym_COMMA,
  [333399] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9615), 1,
      anon_sym_RPAREN,
  [333406] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16211), 1,
      anon_sym_COLON,
  [333413] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16213), 1,
      sym_identifier,
  [333420] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16215), 1,
      anon_sym_SEMI,
  [333427] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16217), 1,
      anon_sym_RPAREN,
  [333434] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16219), 1,
      anon_sym_RPAREN,
  [333441] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16221), 1,
      anon_sym_SEMI,
  [333448] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8996), 1,
      anon_sym_SEMI,
  [333455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16223), 1,
      anon_sym_COLON,
  [333462] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16225), 1,
      anon_sym_RPAREN,
  [333469] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16227), 1,
      anon_sym_SEMI,
  [333476] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16229), 1,
      anon_sym_SEMI,
  [333483] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16231), 1,
      anon_sym_DQUOTE,
  [333490] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16233), 1,
      anon_sym_SEMI,
  [333497] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16235), 1,
      anon_sym_DQUOTE,
  [333504] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16237), 1,
      anon_sym_SEMI,
  [333511] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15432), 1,
      anon_sym_RBRACE,
  [333518] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16239), 1,
      sym_identifier,
  [333525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16241), 1,
      sym_identifier,
  [333532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16243), 1,
      anon_sym_RPAREN,
  [333539] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12031), 1,
      anon_sym_RBRACE,
  [333546] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16245), 1,
      anon_sym_RPAREN,
  [333553] = 2,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(14633), 1,
      aux_sym_preproc_include_token2,
  [333560] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16247), 1,
      anon_sym_RPAREN,
  [333567] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16249), 1,
      anon_sym_SEMI,
  [333574] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16251), 1,
      anon_sym_RPAREN,
  [333581] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16253), 1,
      anon_sym_RPAREN,
  [333588] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16255), 1,
      anon_sym_SEMI,
  [333595] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16257), 1,
      anon_sym_LPAREN2,
  [333602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16259), 1,
      anon_sym_LPAREN2,
  [333609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16261), 1,
      anon_sym_LPAREN2,
  [333616] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16263), 1,
      anon_sym_RPAREN,
  [333623] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16265), 1,
      anon_sym_LPAREN2,
  [333630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16267), 1,
      anon_sym_SEMI,
  [333637] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16269), 1,
      anon_sym_RPAREN,
  [333644] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16271), 1,
      anon_sym_while,
  [333651] = 2,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(16273), 1,
      aux_sym_preproc_include_token2,
  [333658] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16275), 1,
      anon_sym_LPAREN2,
  [333665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16277), 1,
      anon_sym_RPAREN,
  [333672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16279), 1,
      sym_identifier,
  [333679] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16281), 1,
      anon_sym_EQ,
  [333686] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16283), 1,
      sym_raw_string_content,
  [333693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16285), 1,
      anon_sym_RPAREN,
  [333700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16287), 1,
      anon_sym_COMMA,
  [333707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16289), 1,
      anon_sym_RPAREN,
  [333714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16291), 1,
      anon_sym_RPAREN,
  [333721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16293), 1,
      anon_sym_SEMI,
  [333728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16295), 1,
      sym_identifier,
  [333735] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16297), 1,
      anon_sym_RPAREN,
  [333742] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16299), 1,
      anon_sym_RPAREN,
  [333749] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16301), 1,
      anon_sym_COLON,
  [333756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7532), 1,
      anon_sym_RPAREN,
  [333763] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16303), 1,
      anon_sym_SEMI,
  [333770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16305), 1,
      anon_sym_DQUOTE,
  [333777] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16307), 1,
      anon_sym_SEMI,
  [333784] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16309), 1,
      anon_sym_SEMI,
  [333791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9551), 1,
      anon_sym_SEMI,
  [333798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16311), 1,
      anon_sym_DQUOTE,
  [333805] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16313), 1,
      anon_sym_SEMI,
  [333812] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15372), 1,
      anon_sym_RBRACE,
  [333819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9496), 1,
      anon_sym_COLON,
  [333826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16315), 1,
      anon_sym_RPAREN,
  [333833] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12037), 1,
      anon_sym_RBRACE,
  [333840] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16317), 1,
      anon_sym_SEMI,
  [333847] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16319), 1,
      anon_sym_RPAREN,
  [333854] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16321), 1,
      anon_sym_LBRACE,
  [333861] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9535), 1,
      anon_sym_SEMI,
  [333868] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16323), 1,
      anon_sym_LPAREN2,
  [333875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16325), 1,
      anon_sym_LPAREN2,
  [333882] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16327), 1,
      anon_sym_LPAREN2,
  [333889] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16329), 1,
      anon_sym_SEMI,
  [333896] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16331), 1,
      anon_sym_LPAREN2,
  [333903] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16333), 1,
      anon_sym_SEMI,
  [333910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16335), 1,
      anon_sym_SEMI,
  [333917] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16337), 1,
      anon_sym_while,
  [333924] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16339), 1,
      anon_sym_LPAREN2,
  [333931] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16341), 1,
      anon_sym_RPAREN,
  [333938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16343), 1,
      anon_sym_RPAREN,
  [333945] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16345), 1,
      anon_sym_EQ,
  [333952] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_raw_string_content,
  [333959] = 2,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(16349), 1,
      aux_sym_preproc_include_token2,
  [333966] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16351), 1,
      anon_sym_COMMA,
  [333973] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16353), 1,
      anon_sym_RPAREN,
  [333980] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5823), 1,
      anon_sym_DOT_DOT_DOT,
  [333987] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16355), 1,
      aux_sym_preproc_if_token2,
  [333994] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16357), 1,
      anon_sym_RPAREN,
  [334001] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16359), 1,
      anon_sym_COLON,
  [334008] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16361), 1,
      sym_identifier,
  [334015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16363), 1,
      anon_sym_SEMI,
  [334022] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7027), 1,
      sym_identifier,
  [334029] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16365), 1,
      anon_sym_RPAREN,
  [334036] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16367), 1,
      anon_sym_DQUOTE,
  [334043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12681), 1,
      anon_sym_SEMI,
  [334050] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16369), 1,
      anon_sym_RPAREN,
  [334057] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16371), 1,
      anon_sym_LPAREN2,
  [334064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16373), 1,
      anon_sym_LPAREN2,
  [334071] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16375), 1,
      anon_sym_LPAREN2,
  [334078] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16377), 1,
      anon_sym_RPAREN,
  [334085] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16379), 1,
      anon_sym_LPAREN2,
  [334092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16381), 1,
      anon_sym_DQUOTE,
  [334099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16383), 1,
      anon_sym_SEMI,
  [334106] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16385), 1,
      anon_sym_LPAREN2,
  [334113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16387), 1,
      anon_sym_SEMI,
  [334120] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16389), 1,
      anon_sym_DQUOTE,
  [334127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16391), 1,
      anon_sym_EQ,
  [334134] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16393), 1,
      sym_raw_string_content,
  [334141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16395), 1,
      sym_identifier,
  [334148] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16397), 1,
      anon_sym_COMMA,
  [334155] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16399), 1,
      anon_sym_STAR,
  [334162] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16401), 1,
      anon_sym_SEMI,
  [334169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16403), 1,
      anon_sym_SEMI,
  [334176] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16405), 1,
      anon_sym_RPAREN,
  [334183] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16407), 1,
      anon_sym_COLON,
  [334190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16409), 1,
      anon_sym_SEMI,
  [334197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15320), 1,
      anon_sym_RBRACE,
  [334204] = 2,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(16411), 1,
      aux_sym_preproc_include_token2,
  [334211] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9504), 1,
      anon_sym_COLON,
  [334218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16413), 1,
      anon_sym_SEMI,
  [334225] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5879), 1,
      anon_sym_SEMI,
  [334232] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16415), 1,
      sym_identifier,
  [334239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16417), 1,
      anon_sym_LPAREN2,
  [334246] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16419), 1,
      anon_sym_LPAREN2,
  [334253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16421), 1,
      anon_sym_SEMI,
  [334260] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16423), 1,
      anon_sym_LPAREN2,
  [334267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16425), 1,
      anon_sym_LBRACE,
  [334274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13846), 1,
      anon_sym_SEMI,
  [334281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16427), 1,
      anon_sym_LBRACE,
  [334288] = 2,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(16429), 1,
      aux_sym_preproc_include_token2,
  [334295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16431), 1,
      anon_sym_EQ,
  [334302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16433), 1,
      sym_raw_string_content,
  [334309] = 2,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(14798), 1,
      aux_sym_preproc_include_token2,
  [334316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16435), 1,
      anon_sym_RPAREN,
  [334323] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16437), 1,
      anon_sym_RPAREN,
  [334330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 1,
      anon_sym_DOT_DOT_DOT,
  [334337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16439), 1,
      anon_sym_RPAREN,
  [334344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16441), 1,
      anon_sym_RBRACE,
  [334351] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16443), 1,
      anon_sym_LPAREN2,
  [334358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16445), 1,
      anon_sym_LPAREN2,
  [334365] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16447), 1,
      aux_sym_preproc_if_token2,
  [334372] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16449), 1,
      sym_raw_string_content,
  [334379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11986), 1,
      anon_sym_RBRACE,
  [334386] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9772), 1,
      anon_sym_RPAREN,
  [334393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16451), 1,
      anon_sym_RPAREN,
  [334400] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16453), 1,
      aux_sym_preproc_if_token2,
  [334407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16455), 1,
      anon_sym_LPAREN2,
  [334414] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16457), 1,
      anon_sym_LPAREN2,
  [334421] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16459), 1,
      anon_sym_RPAREN,
  [334428] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16461), 1,
      sym_raw_string_content,
  [334435] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5741), 1,
      anon_sym_DOT_DOT_DOT,
  [334442] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16463), 1,
      anon_sym_RPAREN,
  [334449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16465), 1,
      anon_sym_LPAREN2,
  [334456] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16467), 1,
      anon_sym_LPAREN2,
  [334463] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16469), 1,
      sym_raw_string_content,
  [334470] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16471), 1,
      anon_sym_RPAREN,
  [334477] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16473), 1,
      anon_sym_LPAREN2,
  [334484] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16475), 1,
      anon_sym_LPAREN2,
  [334491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16477), 1,
      sym_raw_string_content,
  [334498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16479), 1,
      anon_sym_RPAREN,
  [334505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16481), 1,
      anon_sym_LPAREN2,
  [334512] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16483), 1,
      sym_raw_string_content,
  [334519] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16485), 1,
      anon_sym_RPAREN,
  [334526] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16487), 1,
      anon_sym_LPAREN2,
  [334533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16489), 1,
      sym_raw_string_content,
  [334540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16491), 1,
      anon_sym_RPAREN,
  [334547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16493), 1,
      sym_raw_string_content,
  [334554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16495), 1,
      anon_sym_RPAREN,
  [334561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16497), 1,
      sym_raw_string_content,
  [334568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16499), 1,
      anon_sym_RPAREN,
  [334575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16501), 1,
      sym_raw_string_content,
  [334582] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16503), 1,
      anon_sym_RPAREN,
  [334589] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16505), 1,
      sym_raw_string_content,
  [334596] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16507), 1,
      anon_sym_RPAREN,
  [334603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16509), 1,
      anon_sym_SEMI,
  [334610] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16511), 1,
      anon_sym_RPAREN,
  [334617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16513), 1,
      anon_sym_LPAREN2,
  [334624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16515), 1,
      anon_sym_LPAREN2,
  [334631] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16517), 1,
      sym_identifier,
  [334638] = 2,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(16519), 1,
      aux_sym_preproc_include_token2,
  [334645] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16521), 1,
      anon_sym_RPAREN,
  [334652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5753), 1,
      anon_sym_DOT_DOT_DOT,
  [334659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5702), 1,
      anon_sym_DOT_DOT_DOT,
  [334666] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16523), 1,
      anon_sym_RPAREN,
  [334673] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12762), 1,
      anon_sym_SEMI,
  [334680] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 1,
      anon_sym_DOT_DOT_DOT,
  [334687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5761), 1,
      anon_sym_DOT_DOT_DOT,
  [334694] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5764), 1,
      anon_sym_DOT_DOT_DOT,
  [334701] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16525), 1,
      anon_sym_RPAREN,
  [334708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5769), 1,
      anon_sym_DOT_DOT_DOT,
  [334715] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7620), 1,
      anon_sym_RPAREN,
  [334722] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16527), 1,
      aux_sym_preproc_if_token2,
  [334729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16529), 1,
      anon_sym_LPAREN2,
  [334736] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_DOT_DOT_DOT,
  [334743] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5775), 1,
      anon_sym_DOT_DOT_DOT,
  [334750] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5778), 1,
      anon_sym_DOT_DOT_DOT,
  [334757] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16531), 1,
      anon_sym_RPAREN,
  [334764] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16533), 1,
      sym_identifier,
  [334771] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16535), 1,
      sym_raw_string_content,
  [334778] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16537), 1,
      anon_sym_RPAREN,
  [334785] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16539), 1,
      anon_sym_RPAREN,
  [334792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16541), 1,
      anon_sym_RPAREN,
  [334799] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16543), 1,
      anon_sym_RPAREN,
  [334806] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15226), 1,
      anon_sym_COMMA,
  [334813] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16545), 1,
      aux_sym_preproc_if_token2,
  [334820] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16547), 1,
      aux_sym_preproc_if_token2,
  [334827] = 2,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(16549), 1,
      aux_sym_preproc_include_token2,
  [334834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16551), 1,
      sym_identifier,
  [334841] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16553), 1,
      sym_identifier,
  [334848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16555), 1,
      anon_sym_SEMI,
  [334855] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16557), 1,
      anon_sym_SEMI,
  [334862] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16559), 1,
      anon_sym_import,
  [334869] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_RPAREN,
  [334876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9153), 1,
      anon_sym_RBRACE,
  [334883] = 2,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(16561), 1,
      aux_sym_preproc_include_token2,
  [334890] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16563), 1,
      anon_sym_RPAREN,
  [334897] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16565), 1,
      anon_sym_COLON,
  [334904] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11965), 1,
      anon_sym_RBRACE,
  [334911] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16567), 1,
      anon_sym_RPAREN,
  [334918] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16569), 1,
      anon_sym_DQUOTE,
  [334925] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16571), 1,
      anon_sym_SEMI,
  [334932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5971), 1,
      anon_sym_SEMI,
  [334939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16573), 1,
      anon_sym_RPAREN,
  [334946] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16575), 1,
      anon_sym_RPAREN,
  [334953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16577), 1,
      anon_sym_RPAREN,
  [334960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16579), 1,
      aux_sym_preproc_if_token2,
  [334967] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16581), 1,
      aux_sym_preproc_if_token2,
  [334974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16583), 1,
      anon_sym_DQUOTE,
  [334981] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16585), 1,
      anon_sym_SEMI,
  [334988] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16587), 1,
      anon_sym_SEMI,
  [334995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16589), 1,
      anon_sym_RPAREN,
  [335002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16591), 1,
      anon_sym_SEMI,
  [335009] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15250), 1,
      anon_sym_RBRACE,
  [335016] = 2,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(16593), 1,
      aux_sym_preproc_include_token2,
  [335023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9529), 1,
      anon_sym_COLON,
  [335030] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13708), 1,
      anon_sym_SEMI,
  [335037] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16595), 1,
      anon_sym_SEMI,
  [335044] = 2,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(15087), 1,
      aux_sym_preproc_include_token2,
  [335051] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16597), 1,
      anon_sym_SEMI,
  [335058] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16599), 1,
      anon_sym_SEMI,
  [335065] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COLON_COLON,
  [335072] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6054), 1,
      anon_sym_SEMI,
  [335079] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16601), 1,
      anon_sym_SEMI,
  [335086] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16603), 1,
      anon_sym_LPAREN2,
  [335093] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13706), 1,
      anon_sym_SEMI,
  [335100] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16605), 1,
      aux_sym_preproc_if_token2,
  [335107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16607), 1,
      aux_sym_preproc_if_token2,
  [335114] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16609), 1,
      anon_sym_RPAREN,
  [335121] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16611), 1,
      anon_sym_RPAREN,
  [335128] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11945), 1,
      anon_sym_RBRACE,
  [335135] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9205), 1,
      anon_sym_RBRACE,
  [335142] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9729), 1,
      anon_sym_RPAREN,
  [335149] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16613), 1,
      sym_identifier,
  [335156] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16615), 1,
      anon_sym_RPAREN,
  [335163] = 2,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(16617), 1,
      aux_sym_preproc_include_token2,
  [335170] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16619), 1,
      anon_sym_SEMI,
  [335177] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16621), 1,
      anon_sym_SEMI,
  [335184] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16623), 1,
      anon_sym_RPAREN,
  [335191] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16625), 1,
      anon_sym_SEMI,
  [335198] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12750), 1,
      anon_sym_SEMI,
  [335205] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8262), 1,
      sym_identifier,
  [335212] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9537), 1,
      anon_sym_COLON,
  [335219] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9119), 1,
      anon_sym_SEMI,
  [335226] = 2,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(16627), 1,
      aux_sym_preproc_include_token2,
  [335233] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16629), 1,
      sym_identifier,
  [335240] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16631), 1,
      aux_sym_preproc_if_token2,
  [335247] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16633), 1,
      aux_sym_preproc_if_token2,
  [335254] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16635), 1,
      aux_sym_preproc_if_token2,
  [335261] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16637), 1,
      aux_sym_preproc_if_token2,
  [335268] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16639), 1,
      anon_sym_RPAREN,
  [335275] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16641), 1,
      anon_sym_RPAREN,
  [335282] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16643), 1,
      anon_sym_RPAREN,
  [335289] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16645), 1,
      anon_sym_RPAREN,
  [335296] = 2,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(16647), 1,
      aux_sym_preproc_include_token2,
  [335303] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16649), 1,
      anon_sym_RPAREN,
  [335310] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15242), 1,
      anon_sym_RBRACE,
  [335317] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16651), 1,
      anon_sym_SEMI,
  [335324] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16653), 1,
      aux_sym_preproc_if_token2,
  [335331] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16655), 1,
      anon_sym_SEMI,
  [335338] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16657), 1,
      anon_sym_RPAREN,
  [335345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16659), 1,
      anon_sym_COLON,
  [335352] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9472), 1,
      anon_sym_COLON,
  [335359] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16661), 1,
      anon_sym_RPAREN,
  [335366] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16663), 1,
      anon_sym_RPAREN,
  [335373] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16665), 1,
      anon_sym_DQUOTE,
  [335380] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16667), 1,
      anon_sym_SEMI,
  [335387] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16669), 1,
      anon_sym_SEMI,
  [335394] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16671), 1,
      anon_sym_RPAREN,
  [335401] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16673), 1,
      anon_sym_SEMI,
  [335408] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16675), 1,
      anon_sym_STAR,
  [335415] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16677), 1,
      anon_sym_RPAREN,
  [335422] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16679), 1,
      ts_builtin_sym_end,
  [335429] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16681), 1,
      sym_identifier,
  [335436] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16683), 1,
      anon_sym_DQUOTE,
  [335443] = 2,
    ACTIONS(6462), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(10845), 1,
      sym_comment,
  [335450] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16685), 1,
      anon_sym_LPAREN2,
  [335457] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16687), 1,
      anon_sym_SEMI,
  [335464] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16689), 1,
      anon_sym_SEMI,
  [335471] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16691), 1,
      anon_sym_SEMI,
  [335478] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16693), 1,
      sym_identifier,
  [335485] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16695), 1,
      anon_sym_LPAREN2,
  [335492] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16697), 1,
      anon_sym_RPAREN,
  [335499] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16699), 1,
      anon_sym_SEMI,
  [335506] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16701), 1,
      anon_sym_SEMI,
  [335513] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15290), 1,
      anon_sym_RBRACE,
  [335520] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16703), 1,
      anon_sym_DQUOTE,
  [335527] = 2,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(16705), 1,
      aux_sym_preproc_include_token2,
  [335534] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16707), 1,
      anon_sym_LPAREN2,
  [335541] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9643), 1,
      anon_sym_COLON,
  [335548] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16709), 1,
      sym_identifier,
  [335555] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16711), 1,
      anon_sym_SEMI,
  [335562] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16713), 1,
      anon_sym_SEMI,
  [335569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16715), 1,
      anon_sym_SEMI,
  [335576] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13563), 1,
      anon_sym_SEMI,
  [335583] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16717), 1,
      anon_sym_LPAREN2,
  [335590] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16719), 1,
      anon_sym_RPAREN,
  [335597] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9462), 1,
      anon_sym_COLON,
  [335604] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16721), 1,
      anon_sym_LPAREN2,
  [335611] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16723), 1,
      anon_sym_LPAREN2,
  [335618] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16725), 1,
      anon_sym_LPAREN2,
  [335625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16727), 1,
      anon_sym_LPAREN2,
  [335632] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16729), 1,
      sym_identifier,
  [335639] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16731), 1,
      anon_sym_RPAREN,
  [335646] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16733), 1,
      sym_identifier,
  [335653] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16735), 1,
      anon_sym_SEMI,
  [335660] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16737), 1,
      anon_sym_LPAREN2,
  [335667] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16739), 1,
      anon_sym_SEMI,
  [335674] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16741), 1,
      sym_identifier,
  [335681] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16743), 1,
      sym_raw_string_content,
  [335688] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16745), 1,
      anon_sym_RPAREN,
  [335695] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16747), 1,
      anon_sym_LPAREN2,
  [335702] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16749), 1,
      aux_sym_preproc_if_token2,
  [335709] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16751), 1,
      anon_sym_RPAREN,
  [335716] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16753), 1,
      anon_sym_COLON,
  [335723] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16755), 1,
      anon_sym_LPAREN2,
  [335730] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16757), 1,
      anon_sym_LPAREN2,
  [335737] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16759), 1,
      sym_identifier,
  [335744] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11963), 1,
      anon_sym_RBRACE,
  [335751] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9159), 1,
      anon_sym_RBRACE,
  [335758] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16761), 1,
      anon_sym_LPAREN2,
  [335765] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16763), 1,
      sym_identifier,
  [335772] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16765), 1,
      sym_raw_string_content,
  [335779] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9659), 1,
      anon_sym_RPAREN,
  [335786] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9619), 1,
      anon_sym_SEMI,
  [335793] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16767), 1,
      anon_sym_RPAREN,
  [335800] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16769), 1,
      anon_sym_LPAREN2,
  [335807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16771), 1,
      sym_identifier,
  [335814] = 2,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(16773), 1,
      aux_sym_preproc_include_token2,
  [335821] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16775), 1,
      anon_sym_RPAREN,
  [335828] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16777), 1,
      sym_identifier,
  [335835] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16779), 1,
      sym_raw_string_content,
  [335842] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12768), 1,
      anon_sym_SEMI,
  [335849] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16781), 1,
      anon_sym_LPAREN2,
  [335856] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16783), 1,
      anon_sym_LPAREN2,
  [335863] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16785), 1,
      sym_identifier,
  [335870] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8191), 1,
      sym_identifier,
  [335877] = 2,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(11083), 1,
      aux_sym_preproc_include_token2,
  [335884] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16787), 1,
      sym_identifier,
  [335891] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16789), 1,
      sym_raw_string_content,
  [335898] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16791), 1,
      anon_sym_LPAREN2,
  [335905] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16793), 1,
      anon_sym_SEMI,
  [335912] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16795), 1,
      anon_sym_LPAREN2,
  [335919] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16797), 1,
      sym_identifier,
  [335926] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9635), 1,
      anon_sym_SEMI,
  [335933] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16799), 1,
      sym_identifier,
  [335940] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16801), 1,
      sym_raw_string_content,
  [335947] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16803), 1,
      anon_sym_SEMI,
  [335954] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16805), 1,
      aux_sym_preproc_if_token2,
  [335961] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16807), 1,
      sym_identifier,
  [335968] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16809), 1,
      sym_raw_string_content,
  [335975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16811), 1,
      anon_sym_LPAREN2,
  [335982] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9633), 1,
      anon_sym_SEMI,
  [335989] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16813), 1,
      sym_raw_string_content,
  [335996] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16815), 1,
      aux_sym_preproc_if_token2,
  [336003] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16817), 1,
      sym_raw_string_content,
  [336010] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16819), 1,
      anon_sym_SEMI,
  [336017] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16821), 1,
      sym_raw_string_content,
  [336024] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16823), 1,
      anon_sym_SEMI,
  [336031] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16825), 1,
      sym_raw_string_content,
  [336038] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16827), 1,
      sym_identifier,
  [336045] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16829), 1,
      sym_raw_string_content,
  [336052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16831), 1,
      anon_sym_RPAREN,
  [336059] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16833), 1,
      sym_raw_string_content,
  [336066] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16835), 1,
      anon_sym_RPAREN,
  [336073] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16837), 1,
      sym_raw_string_content,
  [336080] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16839), 1,
      anon_sym_RPAREN,
  [336087] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16841), 1,
      sym_raw_string_content,
  [336094] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
  [336101] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16845), 1,
      sym_raw_string_content,
  [336108] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16847), 1,
      anon_sym_LPAREN2,
  [336115] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16849), 1,
      anon_sym_LPAREN2,
  [336122] = 2,
    ACTIONS(6433), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(10845), 1,
      sym_comment,
  [336129] = 2,
    ACTIONS(10845), 1,
      sym_comment,
    ACTIONS(16851), 1,
      aux_sym_preproc_include_token2,
  [336136] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16853), 1,
      anon_sym_LPAREN2,
  [336143] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16855), 1,
      anon_sym_LPAREN2,
  [336150] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16857), 1,
      anon_sym_SEMI,
  [336157] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16859), 1,
      anon_sym_LPAREN2,
  [336164] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16861), 1,
      anon_sym_LPAREN2,
  [336171] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16863), 1,
      anon_sym_DQUOTE,
  [336178] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16865), 1,
      anon_sym_LPAREN2,
  [336185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16867), 1,
      anon_sym_LPAREN2,
  [336192] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16869), 1,
      anon_sym_SEMI,
  [336199] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16871), 1,
      anon_sym_LPAREN2,
  [336206] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16873), 1,
      anon_sym_LPAREN2,
  [336213] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16875), 1,
      anon_sym_SEMI,
  [336220] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16877), 1,
      anon_sym_LPAREN2,
  [336227] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16879), 1,
      anon_sym_LPAREN2,
  [336234] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16881), 1,
      anon_sym_LPAREN2,
  [336241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16883), 1,
      anon_sym_LPAREN2,
  [336248] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16885), 1,
      anon_sym_LPAREN2,
  [336255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16887), 1,
      anon_sym_LPAREN2,
  [336262] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16889), 1,
      anon_sym_LPAREN2,
  [336269] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16891), 1,
      anon_sym_LPAREN2,
  [336276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16893), 1,
      anon_sym_LPAREN2,
  [336283] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16895), 1,
      anon_sym_LPAREN2,
  [336290] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16897), 1,
      anon_sym_LPAREN2,
  [336297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16899), 1,
      anon_sym_RPAREN,
  [336304] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16901), 1,
      anon_sym_COLON,
  [336311] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16903), 1,
      sym_identifier,
  [336318] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_COLON,
  [336325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16905), 1,
      sym_identifier,
  [336332] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16907), 1,
      anon_sym_LPAREN2,
  [336339] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16909), 1,
      anon_sym_LPAREN2,
  [336346] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16911), 1,
      anon_sym_LPAREN2,
  [336353] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16913), 1,
      anon_sym_LPAREN2,
  [336360] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16915), 1,
      anon_sym_LPAREN2,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(3239)] = 0,
  [SMALL_STATE(3240)] = 77,
  [SMALL_STATE(3241)] = 204,
  [SMALL_STATE(3242)] = 275,
  [SMALL_STATE(3243)] = 354,
  [SMALL_STATE(3244)] = 425,
  [SMALL_STATE(3245)] = 500,
  [SMALL_STATE(3246)] = 571,
  [SMALL_STATE(3247)] = 646,
  [SMALL_STATE(3248)] = 717,
  [SMALL_STATE(3249)] = 792,
  [SMALL_STATE(3250)] = 863,
  [SMALL_STATE(3251)] = 934,
  [SMALL_STATE(3252)] = 1005,
  [SMALL_STATE(3253)] = 1076,
  [SMALL_STATE(3254)] = 1147,
  [SMALL_STATE(3255)] = 1218,
  [SMALL_STATE(3256)] = 1289,
  [SMALL_STATE(3257)] = 1360,
  [SMALL_STATE(3258)] = 1431,
  [SMALL_STATE(3259)] = 1502,
  [SMALL_STATE(3260)] = 1573,
  [SMALL_STATE(3261)] = 1648,
  [SMALL_STATE(3262)] = 1719,
  [SMALL_STATE(3263)] = 1794,
  [SMALL_STATE(3264)] = 1865,
  [SMALL_STATE(3265)] = 1940,
  [SMALL_STATE(3266)] = 2011,
  [SMALL_STATE(3267)] = 2082,
  [SMALL_STATE(3268)] = 2153,
  [SMALL_STATE(3269)] = 2224,
  [SMALL_STATE(3270)] = 2295,
  [SMALL_STATE(3271)] = 2366,
  [SMALL_STATE(3272)] = 2437,
  [SMALL_STATE(3273)] = 2508,
  [SMALL_STATE(3274)] = 2579,
  [SMALL_STATE(3275)] = 2650,
  [SMALL_STATE(3276)] = 2721,
  [SMALL_STATE(3277)] = 2792,
  [SMALL_STATE(3278)] = 2863,
  [SMALL_STATE(3279)] = 2934,
  [SMALL_STATE(3280)] = 3005,
  [SMALL_STATE(3281)] = 3076,
  [SMALL_STATE(3282)] = 3147,
  [SMALL_STATE(3283)] = 3218,
  [SMALL_STATE(3284)] = 3297,
  [SMALL_STATE(3285)] = 3368,
  [SMALL_STATE(3286)] = 3495,
  [SMALL_STATE(3287)] = 3566,
  [SMALL_STATE(3288)] = 3637,
  [SMALL_STATE(3289)] = 3708,
  [SMALL_STATE(3290)] = 3779,
  [SMALL_STATE(3291)] = 3854,
  [SMALL_STATE(3292)] = 3929,
  [SMALL_STATE(3293)] = 4000,
  [SMALL_STATE(3294)] = 4071,
  [SMALL_STATE(3295)] = 4142,
  [SMALL_STATE(3296)] = 4213,
  [SMALL_STATE(3297)] = 4284,
  [SMALL_STATE(3298)] = 4355,
  [SMALL_STATE(3299)] = 4426,
  [SMALL_STATE(3300)] = 4497,
  [SMALL_STATE(3301)] = 4568,
  [SMALL_STATE(3302)] = 4639,
  [SMALL_STATE(3303)] = 4718,
  [SMALL_STATE(3304)] = 4799,
  [SMALL_STATE(3305)] = 4870,
  [SMALL_STATE(3306)] = 4941,
  [SMALL_STATE(3307)] = 5012,
  [SMALL_STATE(3308)] = 5083,
  [SMALL_STATE(3309)] = 5154,
  [SMALL_STATE(3310)] = 5225,
  [SMALL_STATE(3311)] = 5296,
  [SMALL_STATE(3312)] = 5379,
  [SMALL_STATE(3313)] = 5450,
  [SMALL_STATE(3314)] = 5521,
  [SMALL_STATE(3315)] = 5592,
  [SMALL_STATE(3316)] = 5663,
  [SMALL_STATE(3317)] = 5734,
  [SMALL_STATE(3318)] = 5805,
  [SMALL_STATE(3319)] = 5876,
  [SMALL_STATE(3320)] = 5947,
  [SMALL_STATE(3321)] = 6018,
  [SMALL_STATE(3322)] = 6089,
  [SMALL_STATE(3323)] = 6164,
  [SMALL_STATE(3324)] = 6235,
  [SMALL_STATE(3325)] = 6306,
  [SMALL_STATE(3326)] = 6377,
  [SMALL_STATE(3327)] = 6448,
  [SMALL_STATE(3328)] = 6519,
  [SMALL_STATE(3329)] = 6590,
  [SMALL_STATE(3330)] = 6661,
  [SMALL_STATE(3331)] = 6744,
  [SMALL_STATE(3332)] = 6815,
  [SMALL_STATE(3333)] = 6886,
  [SMALL_STATE(3334)] = 6957,
  [SMALL_STATE(3335)] = 7034,
  [SMALL_STATE(3336)] = 7105,
  [SMALL_STATE(3337)] = 7179,
  [SMALL_STATE(3338)] = 7249,
  [SMALL_STATE(3339)] = 7327,
  [SMALL_STATE(3340)] = 7397,
  [SMALL_STATE(3341)] = 7475,
  [SMALL_STATE(3342)] = 7561,
  [SMALL_STATE(3343)] = 7639,
  [SMALL_STATE(3344)] = 7717,
  [SMALL_STATE(3345)] = 7793,
  [SMALL_STATE(3346)] = 7865,
  [SMALL_STATE(3347)] = 7939,
  [SMALL_STATE(3348)] = 8013,
  [SMALL_STATE(3349)] = 8089,
  [SMALL_STATE(3350)] = 8171,
  [SMALL_STATE(3351)] = 8241,
  [SMALL_STATE(3352)] = 8311,
  [SMALL_STATE(3353)] = 8381,
  [SMALL_STATE(3354)] = 8455,
  [SMALL_STATE(3355)] = 8531,
  [SMALL_STATE(3356)] = 8603,
  [SMALL_STATE(3357)] = 8673,
  [SMALL_STATE(3358)] = 8751,
  [SMALL_STATE(3359)] = 8833,
  [SMALL_STATE(3360)] = 8907,
  [SMALL_STATE(3361)] = 8979,
  [SMALL_STATE(3362)] = 9049,
  [SMALL_STATE(3363)] = 9119,
  [SMALL_STATE(3364)] = 9189,
  [SMALL_STATE(3365)] = 9261,
  [SMALL_STATE(3366)] = 9333,
  [SMALL_STATE(3367)] = 9407,
  [SMALL_STATE(3368)] = 9481,
  [SMALL_STATE(3369)] = 9555,
  [SMALL_STATE(3370)] = 9629,
  [SMALL_STATE(3371)] = 9699,
  [SMALL_STATE(3372)] = 9771,
  [SMALL_STATE(3373)] = 9841,
  [SMALL_STATE(3374)] = 9911,
  [SMALL_STATE(3375)] = 9980,
  [SMALL_STATE(3376)] = 10061,
  [SMALL_STATE(3377)] = 10130,
  [SMALL_STATE(3378)] = 10199,
  [SMALL_STATE(3379)] = 10272,
  [SMALL_STATE(3380)] = 10341,
  [SMALL_STATE(3381)] = 10414,
  [SMALL_STATE(3382)] = 10485,
  [SMALL_STATE(3383)] = 10556,
  [SMALL_STATE(3384)] = 10625,
  [SMALL_STATE(3385)] = 10698,
  [SMALL_STATE(3386)] = 10771,
  [SMALL_STATE(3387)] = 10844,
  [SMALL_STATE(3388)] = 10913,
  [SMALL_STATE(3389)] = 10986,
  [SMALL_STATE(3390)] = 11065,
  [SMALL_STATE(3391)] = 11146,
  [SMALL_STATE(3392)] = 11219,
  [SMALL_STATE(3393)] = 11288,
  [SMALL_STATE(3394)] = 11359,
  [SMALL_STATE(3395)] = 11428,
  [SMALL_STATE(3396)] = 11502,
  [SMALL_STATE(3397)] = 11570,
  [SMALL_STATE(3398)] = 11642,
  [SMALL_STATE(3399)] = 11722,
  [SMALL_STATE(3400)] = 11794,
  [SMALL_STATE(3401)] = 11866,
  [SMALL_STATE(3402)] = 11938,
  [SMALL_STATE(3403)] = 12014,
  [SMALL_STATE(3404)] = 12086,
  [SMALL_STATE(3405)] = 12166,
  [SMALL_STATE(3406)] = 12242,
  [SMALL_STATE(3407)] = 12314,
  [SMALL_STATE(3408)] = 12388,
  [SMALL_STATE(3409)] = 12460,
  [SMALL_STATE(3410)] = 12540,
  [SMALL_STATE(3411)] = 12620,
  [SMALL_STATE(3412)] = 12687,
  [SMALL_STATE(3413)] = 12758,
  [SMALL_STATE(3414)] = 12829,
  [SMALL_STATE(3415)] = 12896,
  [SMALL_STATE(3416)] = 12975,
  [SMALL_STATE(3417)] = 13088,
  [SMALL_STATE(3418)] = 13155,
  [SMALL_STATE(3419)] = 13234,
  [SMALL_STATE(3420)] = 13325,
  [SMALL_STATE(3421)] = 13420,
  [SMALL_STATE(3422)] = 13499,
  [SMALL_STATE(3423)] = 13566,
  [SMALL_STATE(3424)] = 13633,
  [SMALL_STATE(3425)] = 13704,
  [SMALL_STATE(3426)] = 13779,
  [SMALL_STATE(3427)] = 13880,
  [SMALL_STATE(3428)] = 13983,
  [SMALL_STATE(3429)] = 14088,
  [SMALL_STATE(3430)] = 14155,
  [SMALL_STATE(3431)] = 14264,
  [SMALL_STATE(3432)] = 14331,
  [SMALL_STATE(3433)] = 14398,
  [SMALL_STATE(3434)] = 14465,
  [SMALL_STATE(3435)] = 14532,
  [SMALL_STATE(3436)] = 14599,
  [SMALL_STATE(3437)] = 14670,
  [SMALL_STATE(3438)] = 14745,
  [SMALL_STATE(3439)] = 14824,
  [SMALL_STATE(3440)] = 14895,
  [SMALL_STATE(3441)] = 14962,
  [SMALL_STATE(3442)] = 15075,
  [SMALL_STATE(3443)] = 15146,
  [SMALL_STATE(3444)] = 15213,
  [SMALL_STATE(3445)] = 15330,
  [SMALL_STATE(3446)] = 15413,
  [SMALL_STATE(3447)] = 15526,
  [SMALL_STATE(3448)] = 15611,
  [SMALL_STATE(3449)] = 15682,
  [SMALL_STATE(3450)] = 15769,
  [SMALL_STATE(3451)] = 15840,
  [SMALL_STATE(3452)] = 15907,
  [SMALL_STATE(3453)] = 16024,
  [SMALL_STATE(3454)] = 16091,
  [SMALL_STATE(3455)] = 16162,
  [SMALL_STATE(3456)] = 16241,
  [SMALL_STATE(3457)] = 16308,
  [SMALL_STATE(3458)] = 16377,
  [SMALL_STATE(3459)] = 16444,
  [SMALL_STATE(3460)] = 16561,
  [SMALL_STATE(3461)] = 16632,
  [SMALL_STATE(3462)] = 16703,
  [SMALL_STATE(3463)] = 16820,
  [SMALL_STATE(3464)] = 16899,
  [SMALL_STATE(3465)] = 16998,
  [SMALL_STATE(3466)] = 17065,
  [SMALL_STATE(3467)] = 17178,
  [SMALL_STATE(3468)] = 17249,
  [SMALL_STATE(3469)] = 17324,
  [SMALL_STATE(3470)] = 17441,
  [SMALL_STATE(3471)] = 17508,
  [SMALL_STATE(3472)] = 17579,
  [SMALL_STATE(3473)] = 17646,
  [SMALL_STATE(3474)] = 17712,
  [SMALL_STATE(3475)] = 17778,
  [SMALL_STATE(3476)] = 17844,
  [SMALL_STATE(3477)] = 17910,
  [SMALL_STATE(3478)] = 17976,
  [SMALL_STATE(3479)] = 18042,
  [SMALL_STATE(3480)] = 18108,
  [SMALL_STATE(3481)] = 18178,
  [SMALL_STATE(3482)] = 18246,
  [SMALL_STATE(3483)] = 18318,
  [SMALL_STATE(3484)] = 18384,
  [SMALL_STATE(3485)] = 18454,
  [SMALL_STATE(3486)] = 18524,
  [SMALL_STATE(3487)] = 18592,
  [SMALL_STATE(3488)] = 18662,
  [SMALL_STATE(3489)] = 18728,
  [SMALL_STATE(3490)] = 18848,
  [SMALL_STATE(3491)] = 18916,
  [SMALL_STATE(3492)] = 18986,
  [SMALL_STATE(3493)] = 19056,
  [SMALL_STATE(3494)] = 19126,
  [SMALL_STATE(3495)] = 19192,
  [SMALL_STATE(3496)] = 19262,
  [SMALL_STATE(3497)] = 19332,
  [SMALL_STATE(3498)] = 19402,
  [SMALL_STATE(3499)] = 19522,
  [SMALL_STATE(3500)] = 19588,
  [SMALL_STATE(3501)] = 19654,
  [SMALL_STATE(3502)] = 19720,
  [SMALL_STATE(3503)] = 19790,
  [SMALL_STATE(3504)] = 19856,
  [SMALL_STATE(3505)] = 19926,
  [SMALL_STATE(3506)] = 19994,
  [SMALL_STATE(3507)] = 20064,
  [SMALL_STATE(3508)] = 20130,
  [SMALL_STATE(3509)] = 20202,
  [SMALL_STATE(3510)] = 20272,
  [SMALL_STATE(3511)] = 20337,
  [SMALL_STATE(3512)] = 20448,
  [SMALL_STATE(3513)] = 20521,
  [SMALL_STATE(3514)] = 20598,
  [SMALL_STATE(3515)] = 20717,
  [SMALL_STATE(3516)] = 20782,
  [SMALL_STATE(3517)] = 20847,
  [SMALL_STATE(3518)] = 20958,
  [SMALL_STATE(3519)] = 21073,
  [SMALL_STATE(3520)] = 21148,
  [SMALL_STATE(3521)] = 21231,
  [SMALL_STATE(3522)] = 21394,
  [SMALL_STATE(3523)] = 21557,
  [SMALL_STATE(3524)] = 21622,
  [SMALL_STATE(3525)] = 21699,
  [SMALL_STATE(3526)] = 21772,
  [SMALL_STATE(3527)] = 21841,
  [SMALL_STATE(3528)] = 21906,
  [SMALL_STATE(3529)] = 21971,
  [SMALL_STATE(3530)] = 22046,
  [SMALL_STATE(3531)] = 22111,
  [SMALL_STATE(3532)] = 22176,
  [SMALL_STATE(3533)] = 22241,
  [SMALL_STATE(3534)] = 22306,
  [SMALL_STATE(3535)] = 22371,
  [SMALL_STATE(3536)] = 22436,
  [SMALL_STATE(3537)] = 22501,
  [SMALL_STATE(3538)] = 22566,
  [SMALL_STATE(3539)] = 22631,
  [SMALL_STATE(3540)] = 22696,
  [SMALL_STATE(3541)] = 22761,
  [SMALL_STATE(3542)] = 22826,
  [SMALL_STATE(3543)] = 22941,
  [SMALL_STATE(3544)] = 23104,
  [SMALL_STATE(3545)] = 23181,
  [SMALL_STATE(3546)] = 23246,
  [SMALL_STATE(3547)] = 23361,
  [SMALL_STATE(3548)] = 23436,
  [SMALL_STATE(3549)] = 23509,
  [SMALL_STATE(3550)] = 23628,
  [SMALL_STATE(3551)] = 23693,
  [SMALL_STATE(3552)] = 23758,
  [SMALL_STATE(3553)] = 23823,
  [SMALL_STATE(3554)] = 23888,
  [SMALL_STATE(3555)] = 23953,
  [SMALL_STATE(3556)] = 24026,
  [SMALL_STATE(3557)] = 24113,
  [SMALL_STATE(3558)] = 24178,
  [SMALL_STATE(3559)] = 24243,
  [SMALL_STATE(3560)] = 24308,
  [SMALL_STATE(3561)] = 24373,
  [SMALL_STATE(3562)] = 24438,
  [SMALL_STATE(3563)] = 24505,
  [SMALL_STATE(3564)] = 24570,
  [SMALL_STATE(3565)] = 24661,
  [SMALL_STATE(3566)] = 24726,
  [SMALL_STATE(3567)] = 24841,
  [SMALL_STATE(3568)] = 24906,
  [SMALL_STATE(3569)] = 24999,
  [SMALL_STATE(3570)] = 25114,
  [SMALL_STATE(3571)] = 25191,
  [SMALL_STATE(3572)] = 25306,
  [SMALL_STATE(3573)] = 25371,
  [SMALL_STATE(3574)] = 25438,
  [SMALL_STATE(3575)] = 25507,
  [SMALL_STATE(3576)] = 25604,
  [SMALL_STATE(3577)] = 25703,
  [SMALL_STATE(3578)] = 25770,
  [SMALL_STATE(3579)] = 25835,
  [SMALL_STATE(3580)] = 25938,
  [SMALL_STATE(3581)] = 26003,
  [SMALL_STATE(3582)] = 26072,
  [SMALL_STATE(3583)] = 26137,
  [SMALL_STATE(3584)] = 26202,
  [SMALL_STATE(3585)] = 26277,
  [SMALL_STATE(3586)] = 26352,
  [SMALL_STATE(3587)] = 26463,
  [SMALL_STATE(3588)] = 26578,
  [SMALL_STATE(3589)] = 26643,
  [SMALL_STATE(3590)] = 26754,
  [SMALL_STATE(3591)] = 26819,
  [SMALL_STATE(3592)] = 26926,
  [SMALL_STATE(3593)] = 27011,
  [SMALL_STATE(3594)] = 27076,
  [SMALL_STATE(3595)] = 27141,
  [SMALL_STATE(3596)] = 27222,
  [SMALL_STATE(3597)] = 27287,
  [SMALL_STATE(3598)] = 27351,
  [SMALL_STATE(3599)] = 27415,
  [SMALL_STATE(3600)] = 27479,
  [SMALL_STATE(3601)] = 27543,
  [SMALL_STATE(3602)] = 27607,
  [SMALL_STATE(3603)] = 27675,
  [SMALL_STATE(3604)] = 27747,
  [SMALL_STATE(3605)] = 27811,
  [SMALL_STATE(3606)] = 27875,
  [SMALL_STATE(3607)] = 27943,
  [SMALL_STATE(3608)] = 28011,
  [SMALL_STATE(3609)] = 28075,
  [SMALL_STATE(3610)] = 28139,
  [SMALL_STATE(3611)] = 28211,
  [SMALL_STATE(3612)] = 28283,
  [SMALL_STATE(3613)] = 28347,
  [SMALL_STATE(3614)] = 28415,
  [SMALL_STATE(3615)] = 28483,
  [SMALL_STATE(3616)] = 28551,
  [SMALL_STATE(3617)] = 28625,
  [SMALL_STATE(3618)] = 28693,
  [SMALL_STATE(3619)] = 28757,
  [SMALL_STATE(3620)] = 28821,
  [SMALL_STATE(3621)] = 28891,
  [SMALL_STATE(3622)] = 28959,
  [SMALL_STATE(3623)] = 29023,
  [SMALL_STATE(3624)] = 29093,
  [SMALL_STATE(3625)] = 29157,
  [SMALL_STATE(3626)] = 29221,
  [SMALL_STATE(3627)] = 29295,
  [SMALL_STATE(3628)] = 29367,
  [SMALL_STATE(3629)] = 29433,
  [SMALL_STATE(3630)] = 29497,
  [SMALL_STATE(3631)] = 29565,
  [SMALL_STATE(3632)] = 29639,
  [SMALL_STATE(3633)] = 29703,
  [SMALL_STATE(3634)] = 29777,
  [SMALL_STATE(3635)] = 29841,
  [SMALL_STATE(3636)] = 29911,
  [SMALL_STATE(3637)] = 29975,
  [SMALL_STATE(3638)] = 30039,
  [SMALL_STATE(3639)] = 30103,
  [SMALL_STATE(3640)] = 30167,
  [SMALL_STATE(3641)] = 30231,
  [SMALL_STATE(3642)] = 30295,
  [SMALL_STATE(3643)] = 30359,
  [SMALL_STATE(3644)] = 30423,
  [SMALL_STATE(3645)] = 30487,
  [SMALL_STATE(3646)] = 30551,
  [SMALL_STATE(3647)] = 30619,
  [SMALL_STATE(3648)] = 30683,
  [SMALL_STATE(3649)] = 30747,
  [SMALL_STATE(3650)] = 30811,
  [SMALL_STATE(3651)] = 30875,
  [SMALL_STATE(3652)] = 30943,
  [SMALL_STATE(3653)] = 31017,
  [SMALL_STATE(3654)] = 31085,
  [SMALL_STATE(3655)] = 31149,
  [SMALL_STATE(3656)] = 31217,
  [SMALL_STATE(3657)] = 31281,
  [SMALL_STATE(3658)] = 31345,
  [SMALL_STATE(3659)] = 31409,
  [SMALL_STATE(3660)] = 31473,
  [SMALL_STATE(3661)] = 31537,
  [SMALL_STATE(3662)] = 31601,
  [SMALL_STATE(3663)] = 31665,
  [SMALL_STATE(3664)] = 31731,
  [SMALL_STATE(3665)] = 31795,
  [SMALL_STATE(3666)] = 31859,
  [SMALL_STATE(3667)] = 31923,
  [SMALL_STATE(3668)] = 31991,
  [SMALL_STATE(3669)] = 32055,
  [SMALL_STATE(3670)] = 32123,
  [SMALL_STATE(3671)] = 32187,
  [SMALL_STATE(3672)] = 32251,
  [SMALL_STATE(3673)] = 32315,
  [SMALL_STATE(3674)] = 32379,
  [SMALL_STATE(3675)] = 32443,
  [SMALL_STATE(3676)] = 32509,
  [SMALL_STATE(3677)] = 32573,
  [SMALL_STATE(3678)] = 32637,
  [SMALL_STATE(3679)] = 32701,
  [SMALL_STATE(3680)] = 32767,
  [SMALL_STATE(3681)] = 32831,
  [SMALL_STATE(3682)] = 32895,
  [SMALL_STATE(3683)] = 32959,
  [SMALL_STATE(3684)] = 33023,
  [SMALL_STATE(3685)] = 33087,
  [SMALL_STATE(3686)] = 33151,
  [SMALL_STATE(3687)] = 33215,
  [SMALL_STATE(3688)] = 33283,
  [SMALL_STATE(3689)] = 33353,
  [SMALL_STATE(3690)] = 33420,
  [SMALL_STATE(3691)] = 33497,
  [SMALL_STATE(3692)] = 33562,
  [SMALL_STATE(3693)] = 33675,
  [SMALL_STATE(3694)] = 33740,
  [SMALL_STATE(3695)] = 33853,
  [SMALL_STATE(3696)] = 33930,
  [SMALL_STATE(3697)] = 34007,
  [SMALL_STATE(3698)] = 34078,
  [SMALL_STATE(3699)] = 34153,
  [SMALL_STATE(3700)] = 34262,
  [SMALL_STATE(3701)] = 34337,
  [SMALL_STATE(3702)] = 34448,
  [SMALL_STATE(3703)] = 34557,
  [SMALL_STATE(3704)] = 34666,
  [SMALL_STATE(3705)] = 34775,
  [SMALL_STATE(3706)] = 34838,
  [SMALL_STATE(3707)] = 34903,
  [SMALL_STATE(3708)] = 34966,
  [SMALL_STATE(3709)] = 35033,
  [SMALL_STATE(3710)] = 35104,
  [SMALL_STATE(3711)] = 35217,
  [SMALL_STATE(3712)] = 35326,
  [SMALL_STATE(3713)] = 35395,
  [SMALL_STATE(3714)] = 35458,
  [SMALL_STATE(3715)] = 35571,
  [SMALL_STATE(3716)] = 35634,
  [SMALL_STATE(3717)] = 35697,
  [SMALL_STATE(3718)] = 35814,
  [SMALL_STATE(3719)] = 35877,
  [SMALL_STATE(3720)] = 35990,
  [SMALL_STATE(3721)] = 36059,
  [SMALL_STATE(3722)] = 36144,
  [SMALL_STATE(3723)] = 36233,
  [SMALL_STATE(3724)] = 36302,
  [SMALL_STATE(3725)] = 36393,
  [SMALL_STATE(3726)] = 36488,
  [SMALL_STATE(3727)] = 36567,
  [SMALL_STATE(3728)] = 36664,
  [SMALL_STATE(3729)] = 36765,
  [SMALL_STATE(3730)] = 36870,
  [SMALL_STATE(3731)] = 36937,
  [SMALL_STATE(3732)] = 37004,
  [SMALL_STATE(3733)] = 37113,
  [SMALL_STATE(3734)] = 37192,
  [SMALL_STATE(3735)] = 37269,
  [SMALL_STATE(3736)] = 37350,
  [SMALL_STATE(3737)] = 37433,
  [SMALL_STATE(3738)] = 37542,
  [SMALL_STATE(3739)] = 37647,
  [SMALL_STATE(3740)] = 37716,
  [SMALL_STATE(3741)] = 37795,
  [SMALL_STATE(3742)] = 37896,
  [SMALL_STATE(3743)] = 37993,
  [SMALL_STATE(3744)] = 38088,
  [SMALL_STATE(3745)] = 38159,
  [SMALL_STATE(3746)] = 38250,
  [SMALL_STATE(3747)] = 38339,
  [SMALL_STATE(3748)] = 38424,
  [SMALL_STATE(3749)] = 38541,
  [SMALL_STATE(3750)] = 38618,
  [SMALL_STATE(3751)] = 38699,
  [SMALL_STATE(3752)] = 38812,
  [SMALL_STATE(3753)] = 38875,
  [SMALL_STATE(3754)] = 38944,
  [SMALL_STATE(3755)] = 39027,
  [SMALL_STATE(3756)] = 39140,
  [SMALL_STATE(3757)] = 39209,
  [SMALL_STATE(3758)] = 39280,
  [SMALL_STATE(3759)] = 39389,
  [SMALL_STATE(3760)] = 39454,
  [SMALL_STATE(3761)] = 39521,
  [SMALL_STATE(3762)] = 39632,
  [SMALL_STATE(3763)] = 39699,
  [SMALL_STATE(3764)] = 39816,
  [SMALL_STATE(3765)] = 39933,
  [SMALL_STATE(3766)] = 40000,
  [SMALL_STATE(3767)] = 40062,
  [SMALL_STATE(3768)] = 40170,
  [SMALL_STATE(3769)] = 40280,
  [SMALL_STATE(3770)] = 40390,
  [SMALL_STATE(3771)] = 40500,
  [SMALL_STATE(3772)] = 40610,
  [SMALL_STATE(3773)] = 40672,
  [SMALL_STATE(3774)] = 40782,
  [SMALL_STATE(3775)] = 40892,
  [SMALL_STATE(3776)] = 41002,
  [SMALL_STATE(3777)] = 41064,
  [SMALL_STATE(3778)] = 41174,
  [SMALL_STATE(3779)] = 41236,
  [SMALL_STATE(3780)] = 41346,
  [SMALL_STATE(3781)] = 41456,
  [SMALL_STATE(3782)] = 41566,
  [SMALL_STATE(3783)] = 41676,
  [SMALL_STATE(3784)] = 41750,
  [SMALL_STATE(3785)] = 41860,
  [SMALL_STATE(3786)] = 41926,
  [SMALL_STATE(3787)] = 42002,
  [SMALL_STATE(3788)] = 42064,
  [SMALL_STATE(3789)] = 42174,
  [SMALL_STATE(3790)] = 42236,
  [SMALL_STATE(3791)] = 42312,
  [SMALL_STATE(3792)] = 42374,
  [SMALL_STATE(3793)] = 42482,
  [SMALL_STATE(3794)] = 42556,
  [SMALL_STATE(3795)] = 42618,
  [SMALL_STATE(3796)] = 42728,
  [SMALL_STATE(3797)] = 42790,
  [SMALL_STATE(3798)] = 42898,
  [SMALL_STATE(3799)] = 42960,
  [SMALL_STATE(3800)] = 43022,
  [SMALL_STATE(3801)] = 43134,
  [SMALL_STATE(3802)] = 43244,
  [SMALL_STATE(3803)] = 43354,
  [SMALL_STATE(3804)] = 43416,
  [SMALL_STATE(3805)] = 43494,
  [SMALL_STATE(3806)] = 43570,
  [SMALL_STATE(3807)] = 43674,
  [SMALL_STATE(3808)] = 43736,
  [SMALL_STATE(3809)] = 43798,
  [SMALL_STATE(3810)] = 43906,
  [SMALL_STATE(3811)] = 43968,
  [SMALL_STATE(3812)] = 44030,
  [SMALL_STATE(3813)] = 44100,
  [SMALL_STATE(3814)] = 44200,
  [SMALL_STATE(3815)] = 44270,
  [SMALL_STATE(3816)] = 44378,
  [SMALL_STATE(3817)] = 44488,
  [SMALL_STATE(3818)] = 44596,
  [SMALL_STATE(3819)] = 44692,
  [SMALL_STATE(3820)] = 44802,
  [SMALL_STATE(3821)] = 44870,
  [SMALL_STATE(3822)] = 44932,
  [SMALL_STATE(3823)] = 45042,
  [SMALL_STATE(3824)] = 45152,
  [SMALL_STATE(3825)] = 45262,
  [SMALL_STATE(3826)] = 45372,
  [SMALL_STATE(3827)] = 45482,
  [SMALL_STATE(3828)] = 45590,
  [SMALL_STATE(3829)] = 45748,
  [SMALL_STATE(3830)] = 45858,
  [SMALL_STATE(3831)] = 45924,
  [SMALL_STATE(3832)] = 46034,
  [SMALL_STATE(3833)] = 46144,
  [SMALL_STATE(3834)] = 46206,
  [SMALL_STATE(3835)] = 46316,
  [SMALL_STATE(3836)] = 46410,
  [SMALL_STATE(3837)] = 46500,
  [SMALL_STATE(3838)] = 46610,
  [SMALL_STATE(3839)] = 46698,
  [SMALL_STATE(3840)] = 46806,
  [SMALL_STATE(3841)] = 46890,
  [SMALL_STATE(3842)] = 46952,
  [SMALL_STATE(3843)] = 47032,
  [SMALL_STATE(3844)] = 47114,
  [SMALL_STATE(3845)] = 47224,
  [SMALL_STATE(3846)] = 47334,
  [SMALL_STATE(3847)] = 47444,
  [SMALL_STATE(3848)] = 47554,
  [SMALL_STATE(3849)] = 47664,
  [SMALL_STATE(3850)] = 47774,
  [SMALL_STATE(3851)] = 47884,
  [SMALL_STATE(3852)] = 47994,
  [SMALL_STATE(3853)] = 48070,
  [SMALL_STATE(3854)] = 48178,
  [SMALL_STATE(3855)] = 48290,
  [SMALL_STATE(3856)] = 48352,
  [SMALL_STATE(3857)] = 48414,
  [SMALL_STATE(3858)] = 48476,
  [SMALL_STATE(3859)] = 48586,
  [SMALL_STATE(3860)] = 48656,
  [SMALL_STATE(3861)] = 48718,
  [SMALL_STATE(3862)] = 48828,
  [SMALL_STATE(3863)] = 48938,
  [SMALL_STATE(3864)] = 49008,
  [SMALL_STATE(3865)] = 49070,
  [SMALL_STATE(3866)] = 49180,
  [SMALL_STATE(3867)] = 49290,
  [SMALL_STATE(3868)] = 49400,
  [SMALL_STATE(3869)] = 49510,
  [SMALL_STATE(3870)] = 49572,
  [SMALL_STATE(3871)] = 49680,
  [SMALL_STATE(3872)] = 49790,
  [SMALL_STATE(3873)] = 49898,
  [SMALL_STATE(3874)] = 50008,
  [SMALL_STATE(3875)] = 50118,
  [SMALL_STATE(3876)] = 50228,
  [SMALL_STATE(3877)] = 50338,
  [SMALL_STATE(3878)] = 50450,
  [SMALL_STATE(3879)] = 50560,
  [SMALL_STATE(3880)] = 50670,
  [SMALL_STATE(3881)] = 50780,
  [SMALL_STATE(3882)] = 50842,
  [SMALL_STATE(3883)] = 50952,
  [SMALL_STATE(3884)] = 51062,
  [SMALL_STATE(3885)] = 51172,
  [SMALL_STATE(3886)] = 51282,
  [SMALL_STATE(3887)] = 51392,
  [SMALL_STATE(3888)] = 51502,
  [SMALL_STATE(3889)] = 51612,
  [SMALL_STATE(3890)] = 51722,
  [SMALL_STATE(3891)] = 51832,
  [SMALL_STATE(3892)] = 51942,
  [SMALL_STATE(3893)] = 52052,
  [SMALL_STATE(3894)] = 52162,
  [SMALL_STATE(3895)] = 52272,
  [SMALL_STATE(3896)] = 52338,
  [SMALL_STATE(3897)] = 52448,
  [SMALL_STATE(3898)] = 52510,
  [SMALL_STATE(3899)] = 52572,
  [SMALL_STATE(3900)] = 52682,
  [SMALL_STATE(3901)] = 52792,
  [SMALL_STATE(3902)] = 52902,
  [SMALL_STATE(3903)] = 53012,
  [SMALL_STATE(3904)] = 53078,
  [SMALL_STATE(3905)] = 53188,
  [SMALL_STATE(3906)] = 53250,
  [SMALL_STATE(3907)] = 53312,
  [SMALL_STATE(3908)] = 53422,
  [SMALL_STATE(3909)] = 53484,
  [SMALL_STATE(3910)] = 53594,
  [SMALL_STATE(3911)] = 53704,
  [SMALL_STATE(3912)] = 53814,
  [SMALL_STATE(3913)] = 53924,
  [SMALL_STATE(3914)] = 54034,
  [SMALL_STATE(3915)] = 54144,
  [SMALL_STATE(3916)] = 54254,
  [SMALL_STATE(3917)] = 54370,
  [SMALL_STATE(3918)] = 54478,
  [SMALL_STATE(3919)] = 54588,
  [SMALL_STATE(3920)] = 54746,
  [SMALL_STATE(3921)] = 54856,
  [SMALL_STATE(3922)] = 54966,
  [SMALL_STATE(3923)] = 55028,
  [SMALL_STATE(3924)] = 55090,
  [SMALL_STATE(3925)] = 55200,
  [SMALL_STATE(3926)] = 55310,
  [SMALL_STATE(3927)] = 55420,
  [SMALL_STATE(3928)] = 55530,
  [SMALL_STATE(3929)] = 55638,
  [SMALL_STATE(3930)] = 55700,
  [SMALL_STATE(3931)] = 55810,
  [SMALL_STATE(3932)] = 55920,
  [SMALL_STATE(3933)] = 55982,
  [SMALL_STATE(3934)] = 56092,
  [SMALL_STATE(3935)] = 56202,
  [SMALL_STATE(3936)] = 56312,
  [SMALL_STATE(3937)] = 56422,
  [SMALL_STATE(3938)] = 56532,
  [SMALL_STATE(3939)] = 56642,
  [SMALL_STATE(3940)] = 56752,
  [SMALL_STATE(3941)] = 56862,
  [SMALL_STATE(3942)] = 56972,
  [SMALL_STATE(3943)] = 57038,
  [SMALL_STATE(3944)] = 57148,
  [SMALL_STATE(3945)] = 57258,
  [SMALL_STATE(3946)] = 57368,
  [SMALL_STATE(3947)] = 57478,
  [SMALL_STATE(3948)] = 57588,
  [SMALL_STATE(3949)] = 57698,
  [SMALL_STATE(3950)] = 57808,
  [SMALL_STATE(3951)] = 57870,
  [SMALL_STATE(3952)] = 57942,
  [SMALL_STATE(3953)] = 58052,
  [SMALL_STATE(3954)] = 58162,
  [SMALL_STATE(3955)] = 58224,
  [SMALL_STATE(3956)] = 58382,
  [SMALL_STATE(3957)] = 58444,
  [SMALL_STATE(3958)] = 58506,
  [SMALL_STATE(3959)] = 58616,
  [SMALL_STATE(3960)] = 58678,
  [SMALL_STATE(3961)] = 58788,
  [SMALL_STATE(3962)] = 58850,
  [SMALL_STATE(3963)] = 58926,
  [SMALL_STATE(3964)] = 59036,
  [SMALL_STATE(3965)] = 59146,
  [SMALL_STATE(3966)] = 59256,
  [SMALL_STATE(3967)] = 59366,
  [SMALL_STATE(3968)] = 59428,
  [SMALL_STATE(3969)] = 59490,
  [SMALL_STATE(3970)] = 59600,
  [SMALL_STATE(3971)] = 59710,
  [SMALL_STATE(3972)] = 59820,
  [SMALL_STATE(3973)] = 59930,
  [SMALL_STATE(3974)] = 60040,
  [SMALL_STATE(3975)] = 60150,
  [SMALL_STATE(3976)] = 60212,
  [SMALL_STATE(3977)] = 60320,
  [SMALL_STATE(3978)] = 60382,
  [SMALL_STATE(3979)] = 60444,
  [SMALL_STATE(3980)] = 60506,
  [SMALL_STATE(3981)] = 60568,
  [SMALL_STATE(3982)] = 60630,
  [SMALL_STATE(3983)] = 60692,
  [SMALL_STATE(3984)] = 60754,
  [SMALL_STATE(3985)] = 60864,
  [SMALL_STATE(3986)] = 60972,
  [SMALL_STATE(3987)] = 61082,
  [SMALL_STATE(3988)] = 61144,
  [SMALL_STATE(3989)] = 61254,
  [SMALL_STATE(3990)] = 61316,
  [SMALL_STATE(3991)] = 61426,
  [SMALL_STATE(3992)] = 61536,
  [SMALL_STATE(3993)] = 61646,
  [SMALL_STATE(3994)] = 61756,
  [SMALL_STATE(3995)] = 61872,
  [SMALL_STATE(3996)] = 61982,
  [SMALL_STATE(3997)] = 62048,
  [SMALL_STATE(3998)] = 62110,
  [SMALL_STATE(3999)] = 62172,
  [SMALL_STATE(4000)] = 62282,
  [SMALL_STATE(4001)] = 62392,
  [SMALL_STATE(4002)] = 62550,
  [SMALL_STATE(4003)] = 62660,
  [SMALL_STATE(4004)] = 62770,
  [SMALL_STATE(4005)] = 62832,
  [SMALL_STATE(4006)] = 62894,
  [SMALL_STATE(4007)] = 63004,
  [SMALL_STATE(4008)] = 63114,
  [SMALL_STATE(4009)] = 63224,
  [SMALL_STATE(4010)] = 63334,
  [SMALL_STATE(4011)] = 63444,
  [SMALL_STATE(4012)] = 63554,
  [SMALL_STATE(4013)] = 63620,
  [SMALL_STATE(4014)] = 63730,
  [SMALL_STATE(4015)] = 63840,
  [SMALL_STATE(4016)] = 63950,
  [SMALL_STATE(4017)] = 64018,
  [SMALL_STATE(4018)] = 64084,
  [SMALL_STATE(4019)] = 64194,
  [SMALL_STATE(4020)] = 64304,
  [SMALL_STATE(4021)] = 64414,
  [SMALL_STATE(4022)] = 64524,
  [SMALL_STATE(4023)] = 64586,
  [SMALL_STATE(4024)] = 64696,
  [SMALL_STATE(4025)] = 64806,
  [SMALL_STATE(4026)] = 64916,
  [SMALL_STATE(4027)] = 65026,
  [SMALL_STATE(4028)] = 65136,
  [SMALL_STATE(4029)] = 65246,
  [SMALL_STATE(4030)] = 65312,
  [SMALL_STATE(4031)] = 65374,
  [SMALL_STATE(4032)] = 65442,
  [SMALL_STATE(4033)] = 65504,
  [SMALL_STATE(4034)] = 65614,
  [SMALL_STATE(4035)] = 65690,
  [SMALL_STATE(4036)] = 65752,
  [SMALL_STATE(4037)] = 65862,
  [SMALL_STATE(4038)] = 65972,
  [SMALL_STATE(4039)] = 66082,
  [SMALL_STATE(4040)] = 66192,
  [SMALL_STATE(4041)] = 66302,
  [SMALL_STATE(4042)] = 66412,
  [SMALL_STATE(4043)] = 66522,
  [SMALL_STATE(4044)] = 66632,
  [SMALL_STATE(4045)] = 66742,
  [SMALL_STATE(4046)] = 66852,
  [SMALL_STATE(4047)] = 66962,
  [SMALL_STATE(4048)] = 67072,
  [SMALL_STATE(4049)] = 67182,
  [SMALL_STATE(4050)] = 67256,
  [SMALL_STATE(4051)] = 67366,
  [SMALL_STATE(4052)] = 67476,
  [SMALL_STATE(4053)] = 67586,
  [SMALL_STATE(4054)] = 67648,
  [SMALL_STATE(4055)] = 67806,
  [SMALL_STATE(4056)] = 67916,
  [SMALL_STATE(4057)] = 67980,
  [SMALL_STATE(4058)] = 68086,
  [SMALL_STATE(4059)] = 68196,
  [SMALL_STATE(4060)] = 68306,
  [SMALL_STATE(4061)] = 68416,
  [SMALL_STATE(4062)] = 68526,
  [SMALL_STATE(4063)] = 68636,
  [SMALL_STATE(4064)] = 68698,
  [SMALL_STATE(4065)] = 68808,
  [SMALL_STATE(4066)] = 68870,
  [SMALL_STATE(4067)] = 68934,
  [SMALL_STATE(4068)] = 69002,
  [SMALL_STATE(4069)] = 69078,
  [SMALL_STATE(4070)] = 69154,
  [SMALL_STATE(4071)] = 69264,
  [SMALL_STATE(4072)] = 69374,
  [SMALL_STATE(4073)] = 69484,
  [SMALL_STATE(4074)] = 69594,
  [SMALL_STATE(4075)] = 69662,
  [SMALL_STATE(4076)] = 69724,
  [SMALL_STATE(4077)] = 69834,
  [SMALL_STATE(4078)] = 69940,
  [SMALL_STATE(4079)] = 70014,
  [SMALL_STATE(4080)] = 70124,
  [SMALL_STATE(4081)] = 70234,
  [SMALL_STATE(4082)] = 70300,
  [SMALL_STATE(4083)] = 70410,
  [SMALL_STATE(4084)] = 70526,
  [SMALL_STATE(4085)] = 70636,
  [SMALL_STATE(4086)] = 70744,
  [SMALL_STATE(4087)] = 70854,
  [SMALL_STATE(4088)] = 70964,
  [SMALL_STATE(4089)] = 71074,
  [SMALL_STATE(4090)] = 71138,
  [SMALL_STATE(4091)] = 71248,
  [SMALL_STATE(4092)] = 71356,
  [SMALL_STATE(4093)] = 71426,
  [SMALL_STATE(4094)] = 71536,
  [SMALL_STATE(4095)] = 71646,
  [SMALL_STATE(4096)] = 71756,
  [SMALL_STATE(4097)] = 71818,
  [SMALL_STATE(4098)] = 71928,
  [SMALL_STATE(4099)] = 72038,
  [SMALL_STATE(4100)] = 72148,
  [SMALL_STATE(4101)] = 72210,
  [SMALL_STATE(4102)] = 72320,
  [SMALL_STATE(4103)] = 72430,
  [SMALL_STATE(4104)] = 72492,
  [SMALL_STATE(4105)] = 72602,
  [SMALL_STATE(4106)] = 72712,
  [SMALL_STATE(4107)] = 72822,
  [SMALL_STATE(4108)] = 72884,
  [SMALL_STATE(4109)] = 72994,
  [SMALL_STATE(4110)] = 73104,
  [SMALL_STATE(4111)] = 73214,
  [SMALL_STATE(4112)] = 73324,
  [SMALL_STATE(4113)] = 73388,
  [SMALL_STATE(4114)] = 73498,
  [SMALL_STATE(4115)] = 73560,
  [SMALL_STATE(4116)] = 73670,
  [SMALL_STATE(4117)] = 73732,
  [SMALL_STATE(4118)] = 73842,
  [SMALL_STATE(4119)] = 73904,
  [SMALL_STATE(4120)] = 73976,
  [SMALL_STATE(4121)] = 74086,
  [SMALL_STATE(4122)] = 74192,
  [SMALL_STATE(4123)] = 74302,
  [SMALL_STATE(4124)] = 74364,
  [SMALL_STATE(4125)] = 74426,
  [SMALL_STATE(4126)] = 74536,
  [SMALL_STATE(4127)] = 74646,
  [SMALL_STATE(4128)] = 74756,
  [SMALL_STATE(4129)] = 74866,
  [SMALL_STATE(4130)] = 74976,
  [SMALL_STATE(4131)] = 75086,
  [SMALL_STATE(4132)] = 75196,
  [SMALL_STATE(4133)] = 75306,
  [SMALL_STATE(4134)] = 75416,
  [SMALL_STATE(4135)] = 75480,
  [SMALL_STATE(4136)] = 75544,
  [SMALL_STATE(4137)] = 75654,
  [SMALL_STATE(4138)] = 75720,
  [SMALL_STATE(4139)] = 75878,
  [SMALL_STATE(4140)] = 75988,
  [SMALL_STATE(4141)] = 76098,
  [SMALL_STATE(4142)] = 76208,
  [SMALL_STATE(4143)] = 76318,
  [SMALL_STATE(4144)] = 76428,
  [SMALL_STATE(4145)] = 76538,
  [SMALL_STATE(4146)] = 76648,
  [SMALL_STATE(4147)] = 76758,
  [SMALL_STATE(4148)] = 76868,
  [SMALL_STATE(4149)] = 76940,
  [SMALL_STATE(4150)] = 77050,
  [SMALL_STATE(4151)] = 77112,
  [SMALL_STATE(4152)] = 77222,
  [SMALL_STATE(4153)] = 77330,
  [SMALL_STATE(4154)] = 77392,
  [SMALL_STATE(4155)] = 77502,
  [SMALL_STATE(4156)] = 77612,
  [SMALL_STATE(4157)] = 77722,
  [SMALL_STATE(4158)] = 77784,
  [SMALL_STATE(4159)] = 77894,
  [SMALL_STATE(4160)] = 77958,
  [SMALL_STATE(4161)] = 78020,
  [SMALL_STATE(4162)] = 78130,
  [SMALL_STATE(4163)] = 78240,
  [SMALL_STATE(4164)] = 78350,
  [SMALL_STATE(4165)] = 78460,
  [SMALL_STATE(4166)] = 78618,
  [SMALL_STATE(4167)] = 78680,
  [SMALL_STATE(4168)] = 78742,
  [SMALL_STATE(4169)] = 78808,
  [SMALL_STATE(4170)] = 78918,
  [SMALL_STATE(4171)] = 78980,
  [SMALL_STATE(4172)] = 79042,
  [SMALL_STATE(4173)] = 79152,
  [SMALL_STATE(4174)] = 79262,
  [SMALL_STATE(4175)] = 79372,
  [SMALL_STATE(4176)] = 79482,
  [SMALL_STATE(4177)] = 79592,
  [SMALL_STATE(4178)] = 79670,
  [SMALL_STATE(4179)] = 79746,
  [SMALL_STATE(4180)] = 79848,
  [SMALL_STATE(4181)] = 79946,
  [SMALL_STATE(4182)] = 80040,
  [SMALL_STATE(4183)] = 80132,
  [SMALL_STATE(4184)] = 80220,
  [SMALL_STATE(4185)] = 80306,
  [SMALL_STATE(4186)] = 80390,
  [SMALL_STATE(4187)] = 80470,
  [SMALL_STATE(4188)] = 80580,
  [SMALL_STATE(4189)] = 80662,
  [SMALL_STATE(4190)] = 80724,
  [SMALL_STATE(4191)] = 80834,
  [SMALL_STATE(4192)] = 80944,
  [SMALL_STATE(4193)] = 81052,
  [SMALL_STATE(4194)] = 81118,
  [SMALL_STATE(4195)] = 81228,
  [SMALL_STATE(4196)] = 81336,
  [SMALL_STATE(4197)] = 81442,
  [SMALL_STATE(4198)] = 81552,
  [SMALL_STATE(4199)] = 81662,
  [SMALL_STATE(4200)] = 81772,
  [SMALL_STATE(4201)] = 81882,
  [SMALL_STATE(4202)] = 81958,
  [SMALL_STATE(4203)] = 82024,
  [SMALL_STATE(4204)] = 82134,
  [SMALL_STATE(4205)] = 82244,
  [SMALL_STATE(4206)] = 82354,
  [SMALL_STATE(4207)] = 82464,
  [SMALL_STATE(4208)] = 82574,
  [SMALL_STATE(4209)] = 82684,
  [SMALL_STATE(4210)] = 82794,
  [SMALL_STATE(4211)] = 82862,
  [SMALL_STATE(4212)] = 82970,
  [SMALL_STATE(4213)] = 83080,
  [SMALL_STATE(4214)] = 83190,
  [SMALL_STATE(4215)] = 83348,
  [SMALL_STATE(4216)] = 83456,
  [SMALL_STATE(4217)] = 83566,
  [SMALL_STATE(4218)] = 83676,
  [SMALL_STATE(4219)] = 83786,
  [SMALL_STATE(4220)] = 83896,
  [SMALL_STATE(4221)] = 84006,
  [SMALL_STATE(4222)] = 84116,
  [SMALL_STATE(4223)] = 84226,
  [SMALL_STATE(4224)] = 84336,
  [SMALL_STATE(4225)] = 84446,
  [SMALL_STATE(4226)] = 84556,
  [SMALL_STATE(4227)] = 84622,
  [SMALL_STATE(4228)] = 84732,
  [SMALL_STATE(4229)] = 84840,
  [SMALL_STATE(4230)] = 84950,
  [SMALL_STATE(4231)] = 85108,
  [SMALL_STATE(4232)] = 85218,
  [SMALL_STATE(4233)] = 85328,
  [SMALL_STATE(4234)] = 85438,
  [SMALL_STATE(4235)] = 85548,
  [SMALL_STATE(4236)] = 85656,
  [SMALL_STATE(4237)] = 85766,
  [SMALL_STATE(4238)] = 85876,
  [SMALL_STATE(4239)] = 85937,
  [SMALL_STATE(4240)] = 86002,
  [SMALL_STATE(4241)] = 86117,
  [SMALL_STATE(4242)] = 86224,
  [SMALL_STATE(4243)] = 86285,
  [SMALL_STATE(4244)] = 86346,
  [SMALL_STATE(4245)] = 86407,
  [SMALL_STATE(4246)] = 86472,
  [SMALL_STATE(4247)] = 86533,
  [SMALL_STATE(4248)] = 86594,
  [SMALL_STATE(4249)] = 86701,
  [SMALL_STATE(4250)] = 86762,
  [SMALL_STATE(4251)] = 86823,
  [SMALL_STATE(4252)] = 86886,
  [SMALL_STATE(4253)] = 86993,
  [SMALL_STATE(4254)] = 87054,
  [SMALL_STATE(4255)] = 87119,
  [SMALL_STATE(4256)] = 87186,
  [SMALL_STATE(4257)] = 87247,
  [SMALL_STATE(4258)] = 87308,
  [SMALL_STATE(4259)] = 87369,
  [SMALL_STATE(4260)] = 87430,
  [SMALL_STATE(4261)] = 87491,
  [SMALL_STATE(4262)] = 87552,
  [SMALL_STATE(4263)] = 87615,
  [SMALL_STATE(4264)] = 87676,
  [SMALL_STATE(4265)] = 87737,
  [SMALL_STATE(4266)] = 87844,
  [SMALL_STATE(4267)] = 87905,
  [SMALL_STATE(4268)] = 87966,
  [SMALL_STATE(4269)] = 88027,
  [SMALL_STATE(4270)] = 88088,
  [SMALL_STATE(4271)] = 88149,
  [SMALL_STATE(4272)] = 88218,
  [SMALL_STATE(4273)] = 88279,
  [SMALL_STATE(4274)] = 88340,
  [SMALL_STATE(4275)] = 88447,
  [SMALL_STATE(4276)] = 88554,
  [SMALL_STATE(4277)] = 88615,
  [SMALL_STATE(4278)] = 88676,
  [SMALL_STATE(4279)] = 88737,
  [SMALL_STATE(4280)] = 88798,
  [SMALL_STATE(4281)] = 88859,
  [SMALL_STATE(4282)] = 88920,
  [SMALL_STATE(4283)] = 88981,
  [SMALL_STATE(4284)] = 89042,
  [SMALL_STATE(4285)] = 89103,
  [SMALL_STATE(4286)] = 89170,
  [SMALL_STATE(4287)] = 89233,
  [SMALL_STATE(4288)] = 89294,
  [SMALL_STATE(4289)] = 89355,
  [SMALL_STATE(4290)] = 89420,
  [SMALL_STATE(4291)] = 89483,
  [SMALL_STATE(4292)] = 89544,
  [SMALL_STATE(4293)] = 89605,
  [SMALL_STATE(4294)] = 89666,
  [SMALL_STATE(4295)] = 89727,
  [SMALL_STATE(4296)] = 89788,
  [SMALL_STATE(4297)] = 89895,
  [SMALL_STATE(4298)] = 90002,
  [SMALL_STATE(4299)] = 90067,
  [SMALL_STATE(4300)] = 90128,
  [SMALL_STATE(4301)] = 90189,
  [SMALL_STATE(4302)] = 90258,
  [SMALL_STATE(4303)] = 90371,
  [SMALL_STATE(4304)] = 90432,
  [SMALL_STATE(4305)] = 90493,
  [SMALL_STATE(4306)] = 90554,
  [SMALL_STATE(4307)] = 90615,
  [SMALL_STATE(4308)] = 90676,
  [SMALL_STATE(4309)] = 90737,
  [SMALL_STATE(4310)] = 90798,
  [SMALL_STATE(4311)] = 90859,
  [SMALL_STATE(4312)] = 90920,
  [SMALL_STATE(4313)] = 90981,
  [SMALL_STATE(4314)] = 91042,
  [SMALL_STATE(4315)] = 91149,
  [SMALL_STATE(4316)] = 91210,
  [SMALL_STATE(4317)] = 91271,
  [SMALL_STATE(4318)] = 91332,
  [SMALL_STATE(4319)] = 91393,
  [SMALL_STATE(4320)] = 91454,
  [SMALL_STATE(4321)] = 91561,
  [SMALL_STATE(4322)] = 91622,
  [SMALL_STATE(4323)] = 91737,
  [SMALL_STATE(4324)] = 91798,
  [SMALL_STATE(4325)] = 91859,
  [SMALL_STATE(4326)] = 91920,
  [SMALL_STATE(4327)] = 91981,
  [SMALL_STATE(4328)] = 92042,
  [SMALL_STATE(4329)] = 92103,
  [SMALL_STATE(4330)] = 92164,
  [SMALL_STATE(4331)] = 92225,
  [SMALL_STATE(4332)] = 92332,
  [SMALL_STATE(4333)] = 92399,
  [SMALL_STATE(4334)] = 92460,
  [SMALL_STATE(4335)] = 92567,
  [SMALL_STATE(4336)] = 92628,
  [SMALL_STATE(4337)] = 92689,
  [SMALL_STATE(4338)] = 92750,
  [SMALL_STATE(4339)] = 92811,
  [SMALL_STATE(4340)] = 92872,
  [SMALL_STATE(4341)] = 92933,
  [SMALL_STATE(4342)] = 93040,
  [SMALL_STATE(4343)] = 93147,
  [SMALL_STATE(4344)] = 93254,
  [SMALL_STATE(4345)] = 93361,
  [SMALL_STATE(4346)] = 93468,
  [SMALL_STATE(4347)] = 93529,
  [SMALL_STATE(4348)] = 93590,
  [SMALL_STATE(4349)] = 93651,
  [SMALL_STATE(4350)] = 93712,
  [SMALL_STATE(4351)] = 93819,
  [SMALL_STATE(4352)] = 93926,
  [SMALL_STATE(4353)] = 93987,
  [SMALL_STATE(4354)] = 94054,
  [SMALL_STATE(4355)] = 94117,
  [SMALL_STATE(4356)] = 94178,
  [SMALL_STATE(4357)] = 94291,
  [SMALL_STATE(4358)] = 94352,
  [SMALL_STATE(4359)] = 94421,
  [SMALL_STATE(4360)] = 94482,
  [SMALL_STATE(4361)] = 94589,
  [SMALL_STATE(4362)] = 94650,
  [SMALL_STATE(4363)] = 94711,
  [SMALL_STATE(4364)] = 94772,
  [SMALL_STATE(4365)] = 94833,
  [SMALL_STATE(4366)] = 94894,
  [SMALL_STATE(4367)] = 94959,
  [SMALL_STATE(4368)] = 95020,
  [SMALL_STATE(4369)] = 95081,
  [SMALL_STATE(4370)] = 95142,
  [SMALL_STATE(4371)] = 95207,
  [SMALL_STATE(4372)] = 95272,
  [SMALL_STATE(4373)] = 95337,
  [SMALL_STATE(4374)] = 95404,
  [SMALL_STATE(4375)] = 95511,
  [SMALL_STATE(4376)] = 95572,
  [SMALL_STATE(4377)] = 95633,
  [SMALL_STATE(4378)] = 95694,
  [SMALL_STATE(4379)] = 95755,
  [SMALL_STATE(4380)] = 95816,
  [SMALL_STATE(4381)] = 95877,
  [SMALL_STATE(4382)] = 95938,
  [SMALL_STATE(4383)] = 95999,
  [SMALL_STATE(4384)] = 96060,
  [SMALL_STATE(4385)] = 96125,
  [SMALL_STATE(4386)] = 96190,
  [SMALL_STATE(4387)] = 96251,
  [SMALL_STATE(4388)] = 96312,
  [SMALL_STATE(4389)] = 96373,
  [SMALL_STATE(4390)] = 96434,
  [SMALL_STATE(4391)] = 96495,
  [SMALL_STATE(4392)] = 96560,
  [SMALL_STATE(4393)] = 96667,
  [SMALL_STATE(4394)] = 96774,
  [SMALL_STATE(4395)] = 96835,
  [SMALL_STATE(4396)] = 96896,
  [SMALL_STATE(4397)] = 96963,
  [SMALL_STATE(4398)] = 97024,
  [SMALL_STATE(4399)] = 97093,
  [SMALL_STATE(4400)] = 97200,
  [SMALL_STATE(4401)] = 97307,
  [SMALL_STATE(4402)] = 97372,
  [SMALL_STATE(4403)] = 97433,
  [SMALL_STATE(4404)] = 97494,
  [SMALL_STATE(4405)] = 97555,
  [SMALL_STATE(4406)] = 97616,
  [SMALL_STATE(4407)] = 97677,
  [SMALL_STATE(4408)] = 97738,
  [SMALL_STATE(4409)] = 97800,
  [SMALL_STATE(4410)] = 97860,
  [SMALL_STATE(4411)] = 97920,
  [SMALL_STATE(4412)] = 97980,
  [SMALL_STATE(4413)] = 98040,
  [SMALL_STATE(4414)] = 98108,
  [SMALL_STATE(4415)] = 98172,
  [SMALL_STATE(4416)] = 98232,
  [SMALL_STATE(4417)] = 98292,
  [SMALL_STATE(4418)] = 98360,
  [SMALL_STATE(4419)] = 98434,
  [SMALL_STATE(4420)] = 98494,
  [SMALL_STATE(4421)] = 98554,
  [SMALL_STATE(4422)] = 98656,
  [SMALL_STATE(4423)] = 98716,
  [SMALL_STATE(4424)] = 98776,
  [SMALL_STATE(4425)] = 98872,
  [SMALL_STATE(4426)] = 98936,
  [SMALL_STATE(4427)] = 98996,
  [SMALL_STATE(4428)] = 99056,
  [SMALL_STATE(4429)] = 99124,
  [SMALL_STATE(4430)] = 99184,
  [SMALL_STATE(4431)] = 99244,
  [SMALL_STATE(4432)] = 99304,
  [SMALL_STATE(4433)] = 99396,
  [SMALL_STATE(4434)] = 99456,
  [SMALL_STATE(4435)] = 99544,
  [SMALL_STATE(4436)] = 99604,
  [SMALL_STATE(4437)] = 99664,
  [SMALL_STATE(4438)] = 99750,
  [SMALL_STATE(4439)] = 99810,
  [SMALL_STATE(4440)] = 99870,
  [SMALL_STATE(4441)] = 99930,
  [SMALL_STATE(4442)] = 99990,
  [SMALL_STATE(4443)] = 100050,
  [SMALL_STATE(4444)] = 100110,
  [SMALL_STATE(4445)] = 100214,
  [SMALL_STATE(4446)] = 100274,
  [SMALL_STATE(4447)] = 100334,
  [SMALL_STATE(4448)] = 100394,
  [SMALL_STATE(4449)] = 100454,
  [SMALL_STATE(4450)] = 100514,
  [SMALL_STATE(4451)] = 100578,
  [SMALL_STATE(4452)] = 100660,
  [SMALL_STATE(4453)] = 100720,
  [SMALL_STATE(4454)] = 100780,
  [SMALL_STATE(4455)] = 100894,
  [SMALL_STATE(4456)] = 100954,
  [SMALL_STATE(4457)] = 101014,
  [SMALL_STATE(4458)] = 101086,
  [SMALL_STATE(4459)] = 101146,
  [SMALL_STATE(4460)] = 101206,
  [SMALL_STATE(4461)] = 101266,
  [SMALL_STATE(4462)] = 101326,
  [SMALL_STATE(4463)] = 101386,
  [SMALL_STATE(4464)] = 101446,
  [SMALL_STATE(4465)] = 101506,
  [SMALL_STATE(4466)] = 101566,
  [SMALL_STATE(4467)] = 101626,
  [SMALL_STATE(4468)] = 101698,
  [SMALL_STATE(4469)] = 101770,
  [SMALL_STATE(4470)] = 101830,
  [SMALL_STATE(4471)] = 101890,
  [SMALL_STATE(4472)] = 101954,
  [SMALL_STATE(4473)] = 102014,
  [SMALL_STATE(4474)] = 102078,
  [SMALL_STATE(4475)] = 102138,
  [SMALL_STATE(4476)] = 102198,
  [SMALL_STATE(4477)] = 102258,
  [SMALL_STATE(4478)] = 102318,
  [SMALL_STATE(4479)] = 102432,
  [SMALL_STATE(4480)] = 102492,
  [SMALL_STATE(4481)] = 102600,
  [SMALL_STATE(4482)] = 102660,
  [SMALL_STATE(4483)] = 102720,
  [SMALL_STATE(4484)] = 102780,
  [SMALL_STATE(4485)] = 102840,
  [SMALL_STATE(4486)] = 102954,
  [SMALL_STATE(4487)] = 103014,
  [SMALL_STATE(4488)] = 103074,
  [SMALL_STATE(4489)] = 103134,
  [SMALL_STATE(4490)] = 103206,
  [SMALL_STATE(4491)] = 103266,
  [SMALL_STATE(4492)] = 103326,
  [SMALL_STATE(4493)] = 103386,
  [SMALL_STATE(4494)] = 103446,
  [SMALL_STATE(4495)] = 103506,
  [SMALL_STATE(4496)] = 103566,
  [SMALL_STATE(4497)] = 103626,
  [SMALL_STATE(4498)] = 103686,
  [SMALL_STATE(4499)] = 103746,
  [SMALL_STATE(4500)] = 103822,
  [SMALL_STATE(4501)] = 103882,
  [SMALL_STATE(4502)] = 103942,
  [SMALL_STATE(4503)] = 104002,
  [SMALL_STATE(4504)] = 104062,
  [SMALL_STATE(4505)] = 104126,
  [SMALL_STATE(4506)] = 104186,
  [SMALL_STATE(4507)] = 104246,
  [SMALL_STATE(4508)] = 104306,
  [SMALL_STATE(4509)] = 104366,
  [SMALL_STATE(4510)] = 104426,
  [SMALL_STATE(4511)] = 104486,
  [SMALL_STATE(4512)] = 104546,
  [SMALL_STATE(4513)] = 104606,
  [SMALL_STATE(4514)] = 104666,
  [SMALL_STATE(4515)] = 104726,
  [SMALL_STATE(4516)] = 104786,
  [SMALL_STATE(4517)] = 104846,
  [SMALL_STATE(4518)] = 104906,
  [SMALL_STATE(4519)] = 104966,
  [SMALL_STATE(4520)] = 105026,
  [SMALL_STATE(4521)] = 105086,
  [SMALL_STATE(4522)] = 105146,
  [SMALL_STATE(4523)] = 105206,
  [SMALL_STATE(4524)] = 105266,
  [SMALL_STATE(4525)] = 105326,
  [SMALL_STATE(4526)] = 105386,
  [SMALL_STATE(4527)] = 105446,
  [SMALL_STATE(4528)] = 105506,
  [SMALL_STATE(4529)] = 105566,
  [SMALL_STATE(4530)] = 105626,
  [SMALL_STATE(4531)] = 105686,
  [SMALL_STATE(4532)] = 105746,
  [SMALL_STATE(4533)] = 105820,
  [SMALL_STATE(4534)] = 105894,
  [SMALL_STATE(4535)] = 105998,
  [SMALL_STATE(4536)] = 106072,
  [SMALL_STATE(4537)] = 106144,
  [SMALL_STATE(4538)] = 106204,
  [SMALL_STATE(4539)] = 106264,
  [SMALL_STATE(4540)] = 106324,
  [SMALL_STATE(4541)] = 106384,
  [SMALL_STATE(4542)] = 106498,
  [SMALL_STATE(4543)] = 106562,
  [SMALL_STATE(4544)] = 106622,
  [SMALL_STATE(4545)] = 106684,
  [SMALL_STATE(4546)] = 106744,
  [SMALL_STATE(4547)] = 106804,
  [SMALL_STATE(4548)] = 106864,
  [SMALL_STATE(4549)] = 106924,
  [SMALL_STATE(4550)] = 106984,
  [SMALL_STATE(4551)] = 107088,
  [SMALL_STATE(4552)] = 107196,
  [SMALL_STATE(4553)] = 107258,
  [SMALL_STATE(4554)] = 107362,
  [SMALL_STATE(4555)] = 107462,
  [SMALL_STATE(4556)] = 107522,
  [SMALL_STATE(4557)] = 107582,
  [SMALL_STATE(4558)] = 107642,
  [SMALL_STATE(4559)] = 107704,
  [SMALL_STATE(4560)] = 107812,
  [SMALL_STATE(4561)] = 107892,
  [SMALL_STATE(4562)] = 107970,
  [SMALL_STATE(4563)] = 108030,
  [SMALL_STATE(4564)] = 108090,
  [SMALL_STATE(4565)] = 108150,
  [SMALL_STATE(4566)] = 108210,
  [SMALL_STATE(4567)] = 108269,
  [SMALL_STATE(4568)] = 108328,
  [SMALL_STATE(4569)] = 108387,
  [SMALL_STATE(4570)] = 108500,
  [SMALL_STATE(4571)] = 108559,
  [SMALL_STATE(4572)] = 108670,
  [SMALL_STATE(4573)] = 108729,
  [SMALL_STATE(4574)] = 108790,
  [SMALL_STATE(4575)] = 108903,
  [SMALL_STATE(4576)] = 108964,
  [SMALL_STATE(4577)] = 109077,
  [SMALL_STATE(4578)] = 109188,
  [SMALL_STATE(4579)] = 109247,
  [SMALL_STATE(4580)] = 109308,
  [SMALL_STATE(4581)] = 109403,
  [SMALL_STATE(4582)] = 109462,
  [SMALL_STATE(4583)] = 109527,
  [SMALL_STATE(4584)] = 109622,
  [SMALL_STATE(4585)] = 109685,
  [SMALL_STATE(4586)] = 109750,
  [SMALL_STATE(4587)] = 109815,
  [SMALL_STATE(4588)] = 109910,
  [SMALL_STATE(4589)] = 110023,
  [SMALL_STATE(4590)] = 110090,
  [SMALL_STATE(4591)] = 110185,
  [SMALL_STATE(4592)] = 110252,
  [SMALL_STATE(4593)] = 110322,
  [SMALL_STATE(4594)] = 110380,
  [SMALL_STATE(4595)] = 110438,
  [SMALL_STATE(4596)] = 110496,
  [SMALL_STATE(4597)] = 110554,
  [SMALL_STATE(4598)] = 110612,
  [SMALL_STATE(4599)] = 110670,
  [SMALL_STATE(4600)] = 110740,
  [SMALL_STATE(4601)] = 110798,
  [SMALL_STATE(4602)] = 110856,
  [SMALL_STATE(4603)] = 110914,
  [SMALL_STATE(4604)] = 110972,
  [SMALL_STATE(4605)] = 111030,
  [SMALL_STATE(4606)] = 111088,
  [SMALL_STATE(4607)] = 111146,
  [SMALL_STATE(4608)] = 111204,
  [SMALL_STATE(4609)] = 111262,
  [SMALL_STATE(4610)] = 111320,
  [SMALL_STATE(4611)] = 111388,
  [SMALL_STATE(4612)] = 111446,
  [SMALL_STATE(4613)] = 111504,
  [SMALL_STATE(4614)] = 111562,
  [SMALL_STATE(4615)] = 111620,
  [SMALL_STATE(4616)] = 111692,
  [SMALL_STATE(4617)] = 111750,
  [SMALL_STATE(4618)] = 111812,
  [SMALL_STATE(4619)] = 111870,
  [SMALL_STATE(4620)] = 111928,
  [SMALL_STATE(4621)] = 111986,
  [SMALL_STATE(4622)] = 112044,
  [SMALL_STATE(4623)] = 112114,
  [SMALL_STATE(4624)] = 112172,
  [SMALL_STATE(4625)] = 112242,
  [SMALL_STATE(4626)] = 112300,
  [SMALL_STATE(4627)] = 112358,
  [SMALL_STATE(4628)] = 112416,
  [SMALL_STATE(4629)] = 112474,
  [SMALL_STATE(4630)] = 112532,
  [SMALL_STATE(4631)] = 112590,
  [SMALL_STATE(4632)] = 112650,
  [SMALL_STATE(4633)] = 112720,
  [SMALL_STATE(4634)] = 112778,
  [SMALL_STATE(4635)] = 112836,
  [SMALL_STATE(4636)] = 112894,
  [SMALL_STATE(4637)] = 112952,
  [SMALL_STATE(4638)] = 113010,
  [SMALL_STATE(4639)] = 113068,
  [SMALL_STATE(4640)] = 113138,
  [SMALL_STATE(4641)] = 113196,
  [SMALL_STATE(4642)] = 113254,
  [SMALL_STATE(4643)] = 113312,
  [SMALL_STATE(4644)] = 113370,
  [SMALL_STATE(4645)] = 113444,
  [SMALL_STATE(4646)] = 113502,
  [SMALL_STATE(4647)] = 113560,
  [SMALL_STATE(4648)] = 113618,
  [SMALL_STATE(4649)] = 113684,
  [SMALL_STATE(4650)] = 113746,
  [SMALL_STATE(4651)] = 113804,
  [SMALL_STATE(4652)] = 113868,
  [SMALL_STATE(4653)] = 113926,
  [SMALL_STATE(4654)] = 113984,
  [SMALL_STATE(4655)] = 114056,
  [SMALL_STATE(4656)] = 114114,
  [SMALL_STATE(4657)] = 114172,
  [SMALL_STATE(4658)] = 114230,
  [SMALL_STATE(4659)] = 114288,
  [SMALL_STATE(4660)] = 114346,
  [SMALL_STATE(4661)] = 114404,
  [SMALL_STATE(4662)] = 114462,
  [SMALL_STATE(4663)] = 114520,
  [SMALL_STATE(4664)] = 114578,
  [SMALL_STATE(4665)] = 114636,
  [SMALL_STATE(4666)] = 114694,
  [SMALL_STATE(4667)] = 114760,
  [SMALL_STATE(4668)] = 114818,
  [SMALL_STATE(4669)] = 114884,
  [SMALL_STATE(4670)] = 114942,
  [SMALL_STATE(4671)] = 115000,
  [SMALL_STATE(4672)] = 115058,
  [SMALL_STATE(4673)] = 115116,
  [SMALL_STATE(4674)] = 115182,
  [SMALL_STATE(4675)] = 115240,
  [SMALL_STATE(4676)] = 115334,
  [SMALL_STATE(4677)] = 115406,
  [SMALL_STATE(4678)] = 115478,
  [SMALL_STATE(4679)] = 115572,
  [SMALL_STATE(4680)] = 115642,
  [SMALL_STATE(4681)] = 115700,
  [SMALL_STATE(4682)] = 115758,
  [SMALL_STATE(4683)] = 115816,
  [SMALL_STATE(4684)] = 115886,
  [SMALL_STATE(4685)] = 115944,
  [SMALL_STATE(4686)] = 116005,
  [SMALL_STATE(4687)] = 116066,
  [SMALL_STATE(4688)] = 116123,
  [SMALL_STATE(4689)] = 116180,
  [SMALL_STATE(4690)] = 116237,
  [SMALL_STATE(4691)] = 116294,
  [SMALL_STATE(4692)] = 116355,
  [SMALL_STATE(4693)] = 116416,
  [SMALL_STATE(4694)] = 116473,
  [SMALL_STATE(4695)] = 116530,
  [SMALL_STATE(4696)] = 116587,
  [SMALL_STATE(4697)] = 116644,
  [SMALL_STATE(4698)] = 116701,
  [SMALL_STATE(4699)] = 116762,
  [SMALL_STATE(4700)] = 116819,
  [SMALL_STATE(4701)] = 116876,
  [SMALL_STATE(4702)] = 116933,
  [SMALL_STATE(4703)] = 116990,
  [SMALL_STATE(4704)] = 117047,
  [SMALL_STATE(4705)] = 117104,
  [SMALL_STATE(4706)] = 117161,
  [SMALL_STATE(4707)] = 117218,
  [SMALL_STATE(4708)] = 117279,
  [SMALL_STATE(4709)] = 117336,
  [SMALL_STATE(4710)] = 117429,
  [SMALL_STATE(4711)] = 117486,
  [SMALL_STATE(4712)] = 117543,
  [SMALL_STATE(4713)] = 117604,
  [SMALL_STATE(4714)] = 117665,
  [SMALL_STATE(4715)] = 117722,
  [SMALL_STATE(4716)] = 117783,
  [SMALL_STATE(4717)] = 117840,
  [SMALL_STATE(4718)] = 117897,
  [SMALL_STATE(4719)] = 117954,
  [SMALL_STATE(4720)] = 118011,
  [SMALL_STATE(4721)] = 118068,
  [SMALL_STATE(4722)] = 118129,
  [SMALL_STATE(4723)] = 118186,
  [SMALL_STATE(4724)] = 118253,
  [SMALL_STATE(4725)] = 118318,
  [SMALL_STATE(4726)] = 118375,
  [SMALL_STATE(4727)] = 118432,
  [SMALL_STATE(4728)] = 118489,
  [SMALL_STATE(4729)] = 118546,
  [SMALL_STATE(4730)] = 118639,
  [SMALL_STATE(4731)] = 118696,
  [SMALL_STATE(4732)] = 118757,
  [SMALL_STATE(4733)] = 118814,
  [SMALL_STATE(4734)] = 118871,
  [SMALL_STATE(4735)] = 118932,
  [SMALL_STATE(4736)] = 118994,
  [SMALL_STATE(4737)] = 119054,
  [SMALL_STATE(4738)] = 119116,
  [SMALL_STATE(4739)] = 119178,
  [SMALL_STATE(4740)] = 119234,
  [SMALL_STATE(4741)] = 119296,
  [SMALL_STATE(4742)] = 119356,
  [SMALL_STATE(4743)] = 119412,
  [SMALL_STATE(4744)] = 119472,
  [SMALL_STATE(4745)] = 119528,
  [SMALL_STATE(4746)] = 119584,
  [SMALL_STATE(4747)] = 119644,
  [SMALL_STATE(4748)] = 119706,
  [SMALL_STATE(4749)] = 119774,
  [SMALL_STATE(4750)] = 119834,
  [SMALL_STATE(4751)] = 119902,
  [SMALL_STATE(4752)] = 119958,
  [SMALL_STATE(4753)] = 120016,
  [SMALL_STATE(4754)] = 120084,
  [SMALL_STATE(4755)] = 120146,
  [SMALL_STATE(4756)] = 120206,
  [SMALL_STATE(4757)] = 120262,
  [SMALL_STATE(4758)] = 120318,
  [SMALL_STATE(4759)] = 120378,
  [SMALL_STATE(4760)] = 120446,
  [SMALL_STATE(4761)] = 120501,
  [SMALL_STATE(4762)] = 120556,
  [SMALL_STATE(4763)] = 120615,
  [SMALL_STATE(4764)] = 120700,
  [SMALL_STATE(4765)] = 120759,
  [SMALL_STATE(4766)] = 120814,
  [SMALL_STATE(4767)] = 120869,
  [SMALL_STATE(4768)] = 120924,
  [SMALL_STATE(4769)] = 120979,
  [SMALL_STATE(4770)] = 121034,
  [SMALL_STATE(4771)] = 121093,
  [SMALL_STATE(4772)] = 121148,
  [SMALL_STATE(4773)] = 121211,
  [SMALL_STATE(4774)] = 121266,
  [SMALL_STATE(4775)] = 121321,
  [SMALL_STATE(4776)] = 121376,
  [SMALL_STATE(4777)] = 121431,
  [SMALL_STATE(4778)] = 121486,
  [SMALL_STATE(4779)] = 121541,
  [SMALL_STATE(4780)] = 121596,
  [SMALL_STATE(4781)] = 121681,
  [SMALL_STATE(4782)] = 121736,
  [SMALL_STATE(4783)] = 121791,
  [SMALL_STATE(4784)] = 121846,
  [SMALL_STATE(4785)] = 121905,
  [SMALL_STATE(4786)] = 121960,
  [SMALL_STATE(4787)] = 122015,
  [SMALL_STATE(4788)] = 122074,
  [SMALL_STATE(4789)] = 122159,
  [SMALL_STATE(4790)] = 122250,
  [SMALL_STATE(4791)] = 122317,
  [SMALL_STATE(4792)] = 122408,
  [SMALL_STATE(4793)] = 122465,
  [SMALL_STATE(4794)] = 122520,
  [SMALL_STATE(4795)] = 122575,
  [SMALL_STATE(4796)] = 122660,
  [SMALL_STATE(4797)] = 122717,
  [SMALL_STATE(4798)] = 122808,
  [SMALL_STATE(4799)] = 122863,
  [SMALL_STATE(4800)] = 122918,
  [SMALL_STATE(4801)] = 122973,
  [SMALL_STATE(4802)] = 123028,
  [SMALL_STATE(4803)] = 123083,
  [SMALL_STATE(4804)] = 123138,
  [SMALL_STATE(4805)] = 123229,
  [SMALL_STATE(4806)] = 123284,
  [SMALL_STATE(4807)] = 123339,
  [SMALL_STATE(4808)] = 123394,
  [SMALL_STATE(4809)] = 123449,
  [SMALL_STATE(4810)] = 123516,
  [SMALL_STATE(4811)] = 123571,
  [SMALL_STATE(4812)] = 123662,
  [SMALL_STATE(4813)] = 123719,
  [SMALL_STATE(4814)] = 123774,
  [SMALL_STATE(4815)] = 123865,
  [SMALL_STATE(4816)] = 123920,
  [SMALL_STATE(4817)] = 123986,
  [SMALL_STATE(4818)] = 124052,
  [SMALL_STATE(4819)] = 124142,
  [SMALL_STATE(4820)] = 124234,
  [SMALL_STATE(4821)] = 124326,
  [SMALL_STATE(4822)] = 124418,
  [SMALL_STATE(4823)] = 124506,
  [SMALL_STATE(4824)] = 124568,
  [SMALL_STATE(4825)] = 124628,
  [SMALL_STATE(4826)] = 124716,
  [SMALL_STATE(4827)] = 124800,
  [SMALL_STATE(4828)] = 124854,
  [SMALL_STATE(4829)] = 124920,
  [SMALL_STATE(4830)] = 125010,
  [SMALL_STATE(4831)] = 125102,
  [SMALL_STATE(4832)] = 125156,
  [SMALL_STATE(4833)] = 125248,
  [SMALL_STATE(4834)] = 125340,
  [SMALL_STATE(4835)] = 125432,
  [SMALL_STATE(4836)] = 125524,
  [SMALL_STATE(4837)] = 125584,
  [SMALL_STATE(4838)] = 125676,
  [SMALL_STATE(4839)] = 125768,
  [SMALL_STATE(4840)] = 125858,
  [SMALL_STATE(4841)] = 125948,
  [SMALL_STATE(4842)] = 126040,
  [SMALL_STATE(4843)] = 126132,
  [SMALL_STATE(4844)] = 126198,
  [SMALL_STATE(4845)] = 126290,
  [SMALL_STATE(4846)] = 126374,
  [SMALL_STATE(4847)] = 126466,
  [SMALL_STATE(4848)] = 126520,
  [SMALL_STATE(4849)] = 126612,
  [SMALL_STATE(4850)] = 126701,
  [SMALL_STATE(4851)] = 126754,
  [SMALL_STATE(4852)] = 126837,
  [SMALL_STATE(4853)] = 126940,
  [SMALL_STATE(4854)] = 127003,
  [SMALL_STATE(4855)] = 127098,
  [SMALL_STATE(4856)] = 127181,
  [SMALL_STATE(4857)] = 127288,
  [SMALL_STATE(4858)] = 127351,
  [SMALL_STATE(4859)] = 127418,
  [SMALL_STATE(4860)] = 127507,
  [SMALL_STATE(4861)] = 127596,
  [SMALL_STATE(4862)] = 127699,
  [SMALL_STATE(4863)] = 127752,
  [SMALL_STATE(4864)] = 127841,
  [SMALL_STATE(4865)] = 127930,
  [SMALL_STATE(4866)] = 127995,
  [SMALL_STATE(4867)] = 128102,
  [SMALL_STATE(4868)] = 128191,
  [SMALL_STATE(4869)] = 128280,
  [SMALL_STATE(4870)] = 128387,
  [SMALL_STATE(4871)] = 128440,
  [SMALL_STATE(4872)] = 128503,
  [SMALL_STATE(4873)] = 128556,
  [SMALL_STATE(4874)] = 128621,
  [SMALL_STATE(4875)] = 128728,
  [SMALL_STATE(4876)] = 128831,
  [SMALL_STATE(4877)] = 128938,
  [SMALL_STATE(4878)] = 129045,
  [SMALL_STATE(4879)] = 129134,
  [SMALL_STATE(4880)] = 129199,
  [SMALL_STATE(4881)] = 129292,
  [SMALL_STATE(4882)] = 129381,
  [SMALL_STATE(4883)] = 129468,
  [SMALL_STATE(4884)] = 129551,
  [SMALL_STATE(4885)] = 129630,
  [SMALL_STATE(4886)] = 129703,
  [SMALL_STATE(4887)] = 129778,
  [SMALL_STATE(4888)] = 129843,
  [SMALL_STATE(4889)] = 129904,
  [SMALL_STATE(4890)] = 130007,
  [SMALL_STATE(4891)] = 130078,
  [SMALL_STATE(4892)] = 130177,
  [SMALL_STATE(4893)] = 130238,
  [SMALL_STATE(4894)] = 130326,
  [SMALL_STATE(4895)] = 130382,
  [SMALL_STATE(4896)] = 130438,
  [SMALL_STATE(4897)] = 130526,
  [SMALL_STATE(4898)] = 130614,
  [SMALL_STATE(4899)] = 130702,
  [SMALL_STATE(4900)] = 130790,
  [SMALL_STATE(4901)] = 130846,
  [SMALL_STATE(4902)] = 130904,
  [SMALL_STATE(4903)] = 130958,
  [SMALL_STATE(4904)] = 131018,
  [SMALL_STATE(4905)] = 131106,
  [SMALL_STATE(4906)] = 131160,
  [SMALL_STATE(4907)] = 131248,
  [SMALL_STATE(4908)] = 131304,
  [SMALL_STATE(4909)] = 131360,
  [SMALL_STATE(4910)] = 131448,
  [SMALL_STATE(4911)] = 131536,
  [SMALL_STATE(4912)] = 131624,
  [SMALL_STATE(4913)] = 131680,
  [SMALL_STATE(4914)] = 131738,
  [SMALL_STATE(4915)] = 131796,
  [SMALL_STATE(4916)] = 131884,
  [SMALL_STATE(4917)] = 131946,
  [SMALL_STATE(4918)] = 132004,
  [SMALL_STATE(4919)] = 132092,
  [SMALL_STATE(4920)] = 132148,
  [SMALL_STATE(4921)] = 132204,
  [SMALL_STATE(4922)] = 132262,
  [SMALL_STATE(4923)] = 132350,
  [SMALL_STATE(4924)] = 132410,
  [SMALL_STATE(4925)] = 132466,
  [SMALL_STATE(4926)] = 132554,
  [SMALL_STATE(4927)] = 132642,
  [SMALL_STATE(4928)] = 132730,
  [SMALL_STATE(4929)] = 132818,
  [SMALL_STATE(4930)] = 132906,
  [SMALL_STATE(4931)] = 132994,
  [SMALL_STATE(4932)] = 133050,
  [SMALL_STATE(4933)] = 133138,
  [SMALL_STATE(4934)] = 133190,
  [SMALL_STATE(4935)] = 133242,
  [SMALL_STATE(4936)] = 133330,
  [SMALL_STATE(4937)] = 133418,
  [SMALL_STATE(4938)] = 133504,
  [SMALL_STATE(4939)] = 133592,
  [SMALL_STATE(4940)] = 133680,
  [SMALL_STATE(4941)] = 133768,
  [SMALL_STATE(4942)] = 133866,
  [SMALL_STATE(4943)] = 133918,
  [SMALL_STATE(4944)] = 134006,
  [SMALL_STATE(4945)] = 134094,
  [SMALL_STATE(4946)] = 134182,
  [SMALL_STATE(4947)] = 134238,
  [SMALL_STATE(4948)] = 134294,
  [SMALL_STATE(4949)] = 134350,
  [SMALL_STATE(4950)] = 134406,
  [SMALL_STATE(4951)] = 134494,
  [SMALL_STATE(4952)] = 134580,
  [SMALL_STATE(4953)] = 134668,
  [SMALL_STATE(4954)] = 134726,
  [SMALL_STATE(4955)] = 134803,
  [SMALL_STATE(4956)] = 134854,
  [SMALL_STATE(4957)] = 134935,
  [SMALL_STATE(4958)] = 134986,
  [SMALL_STATE(4959)] = 135041,
  [SMALL_STATE(4960)] = 135146,
  [SMALL_STATE(4961)] = 135227,
  [SMALL_STATE(4962)] = 135278,
  [SMALL_STATE(4963)] = 135331,
  [SMALL_STATE(4964)] = 135382,
  [SMALL_STATE(4965)] = 135433,
  [SMALL_STATE(4966)] = 135488,
  [SMALL_STATE(4967)] = 135539,
  [SMALL_STATE(4968)] = 135590,
  [SMALL_STATE(4969)] = 135641,
  [SMALL_STATE(4970)] = 135692,
  [SMALL_STATE(4971)] = 135743,
  [SMALL_STATE(4972)] = 135794,
  [SMALL_STATE(4973)] = 135881,
  [SMALL_STATE(4974)] = 135940,
  [SMALL_STATE(4975)] = 135991,
  [SMALL_STATE(4976)] = 136044,
  [SMALL_STATE(4977)] = 136095,
  [SMALL_STATE(4978)] = 136176,
  [SMALL_STATE(4979)] = 136227,
  [SMALL_STATE(4980)] = 136278,
  [SMALL_STATE(4981)] = 136329,
  [SMALL_STATE(4982)] = 136380,
  [SMALL_STATE(4983)] = 136461,
  [SMALL_STATE(4984)] = 136542,
  [SMALL_STATE(4985)] = 136647,
  [SMALL_STATE(4986)] = 136724,
  [SMALL_STATE(4987)] = 136777,
  [SMALL_STATE(4988)] = 136858,
  [SMALL_STATE(4989)] = 136963,
  [SMALL_STATE(4990)] = 137014,
  [SMALL_STATE(4991)] = 137065,
  [SMALL_STATE(4992)] = 137116,
  [SMALL_STATE(4993)] = 137181,
  [SMALL_STATE(4994)] = 137234,
  [SMALL_STATE(4995)] = 137285,
  [SMALL_STATE(4996)] = 137336,
  [SMALL_STATE(4997)] = 137413,
  [SMALL_STATE(4998)] = 137464,
  [SMALL_STATE(4999)] = 137515,
  [SMALL_STATE(5000)] = 137592,
  [SMALL_STATE(5001)] = 137679,
  [SMALL_STATE(5002)] = 137756,
  [SMALL_STATE(5003)] = 137833,
  [SMALL_STATE(5004)] = 137890,
  [SMALL_STATE(5005)] = 137967,
  [SMALL_STATE(5006)] = 138018,
  [SMALL_STATE(5007)] = 138095,
  [SMALL_STATE(5008)] = 138146,
  [SMALL_STATE(5009)] = 138203,
  [SMALL_STATE(5010)] = 138254,
  [SMALL_STATE(5011)] = 138304,
  [SMALL_STATE(5012)] = 138354,
  [SMALL_STATE(5013)] = 138408,
  [SMALL_STATE(5014)] = 138458,
  [SMALL_STATE(5015)] = 138542,
  [SMALL_STATE(5016)] = 138592,
  [SMALL_STATE(5017)] = 138642,
  [SMALL_STATE(5018)] = 138692,
  [SMALL_STATE(5019)] = 138742,
  [SMALL_STATE(5020)] = 138792,
  [SMALL_STATE(5021)] = 138842,
  [SMALL_STATE(5022)] = 138892,
  [SMALL_STATE(5023)] = 138942,
  [SMALL_STATE(5024)] = 138992,
  [SMALL_STATE(5025)] = 139094,
  [SMALL_STATE(5026)] = 139144,
  [SMALL_STATE(5027)] = 139198,
  [SMALL_STATE(5028)] = 139250,
  [SMALL_STATE(5029)] = 139304,
  [SMALL_STATE(5030)] = 139354,
  [SMALL_STATE(5031)] = 139404,
  [SMALL_STATE(5032)] = 139454,
  [SMALL_STATE(5033)] = 139508,
  [SMALL_STATE(5034)] = 139604,
  [SMALL_STATE(5035)] = 139690,
  [SMALL_STATE(5036)] = 139740,
  [SMALL_STATE(5037)] = 139820,
  [SMALL_STATE(5038)] = 139870,
  [SMALL_STATE(5039)] = 139920,
  [SMALL_STATE(5040)] = 139992,
  [SMALL_STATE(5041)] = 140042,
  [SMALL_STATE(5042)] = 140112,
  [SMALL_STATE(5043)] = 140186,
  [SMALL_STATE(5044)] = 140240,
  [SMALL_STATE(5045)] = 140318,
  [SMALL_STATE(5046)] = 140398,
  [SMALL_STATE(5047)] = 140490,
  [SMALL_STATE(5048)] = 140574,
  [SMALL_STATE(5049)] = 140624,
  [SMALL_STATE(5050)] = 140674,
  [SMALL_STATE(5051)] = 140734,
  [SMALL_STATE(5052)] = 140784,
  [SMALL_STATE(5053)] = 140838,
  [SMALL_STATE(5054)] = 140924,
  [SMALL_STATE(5055)] = 140978,
  [SMALL_STATE(5056)] = 141032,
  [SMALL_STATE(5057)] = 141086,
  [SMALL_STATE(5058)] = 141182,
  [SMALL_STATE(5059)] = 141266,
  [SMALL_STATE(5060)] = 141354,
  [SMALL_STATE(5061)] = 141408,
  [SMALL_STATE(5062)] = 141498,
  [SMALL_STATE(5063)] = 141574,
  [SMALL_STATE(5064)] = 141640,
  [SMALL_STATE(5065)] = 141716,
  [SMALL_STATE(5066)] = 141784,
  [SMALL_STATE(5067)] = 141860,
  [SMALL_STATE(5068)] = 141952,
  [SMALL_STATE(5069)] = 142002,
  [SMALL_STATE(5070)] = 142078,
  [SMALL_STATE(5071)] = 142132,
  [SMALL_STATE(5072)] = 142182,
  [SMALL_STATE(5073)] = 142232,
  [SMALL_STATE(5074)] = 142324,
  [SMALL_STATE(5075)] = 142374,
  [SMALL_STATE(5076)] = 142424,
  [SMALL_STATE(5077)] = 142474,
  [SMALL_STATE(5078)] = 142524,
  [SMALL_STATE(5079)] = 142604,
  [SMALL_STATE(5080)] = 142654,
  [SMALL_STATE(5081)] = 142708,
  [SMALL_STATE(5082)] = 142758,
  [SMALL_STATE(5083)] = 142808,
  [SMALL_STATE(5084)] = 142858,
  [SMALL_STATE(5085)] = 142938,
  [SMALL_STATE(5086)] = 142988,
  [SMALL_STATE(5087)] = 143068,
  [SMALL_STATE(5088)] = 143118,
  [SMALL_STATE(5089)] = 143202,
  [SMALL_STATE(5090)] = 143256,
  [SMALL_STATE(5091)] = 143306,
  [SMALL_STATE(5092)] = 143390,
  [SMALL_STATE(5093)] = 143474,
  [SMALL_STATE(5094)] = 143554,
  [SMALL_STATE(5095)] = 143604,
  [SMALL_STATE(5096)] = 143700,
  [SMALL_STATE(5097)] = 143750,
  [SMALL_STATE(5098)] = 143800,
  [SMALL_STATE(5099)] = 143850,
  [SMALL_STATE(5100)] = 143900,
  [SMALL_STATE(5101)] = 143984,
  [SMALL_STATE(5102)] = 144068,
  [SMALL_STATE(5103)] = 144120,
  [SMALL_STATE(5104)] = 144222,
  [SMALL_STATE(5105)] = 144276,
  [SMALL_STATE(5106)] = 144368,
  [SMALL_STATE(5107)] = 144422,
  [SMALL_STATE(5108)] = 144472,
  [SMALL_STATE(5109)] = 144524,
  [SMALL_STATE(5110)] = 144608,
  [SMALL_STATE(5111)] = 144688,
  [SMALL_STATE(5112)] = 144738,
  [SMALL_STATE(5113)] = 144792,
  [SMALL_STATE(5114)] = 144842,
  [SMALL_STATE(5115)] = 144934,
  [SMALL_STATE(5116)] = 144984,
  [SMALL_STATE(5117)] = 145068,
  [SMALL_STATE(5118)] = 145118,
  [SMALL_STATE(5119)] = 145202,
  [SMALL_STATE(5120)] = 145256,
  [SMALL_STATE(5121)] = 145342,
  [SMALL_STATE(5122)] = 145396,
  [SMALL_STATE(5123)] = 145446,
  [SMALL_STATE(5124)] = 145496,
  [SMALL_STATE(5125)] = 145546,
  [SMALL_STATE(5126)] = 145596,
  [SMALL_STATE(5127)] = 145695,
  [SMALL_STATE(5128)] = 145782,
  [SMALL_STATE(5129)] = 145881,
  [SMALL_STATE(5130)] = 145980,
  [SMALL_STATE(5131)] = 146075,
  [SMALL_STATE(5132)] = 146174,
  [SMALL_STATE(5133)] = 146273,
  [SMALL_STATE(5134)] = 146352,
  [SMALL_STATE(5135)] = 146427,
  [SMALL_STATE(5136)] = 146502,
  [SMALL_STATE(5137)] = 146577,
  [SMALL_STATE(5138)] = 146662,
  [SMALL_STATE(5139)] = 146761,
  [SMALL_STATE(5140)] = 146846,
  [SMALL_STATE(5141)] = 146945,
  [SMALL_STATE(5142)] = 147044,
  [SMALL_STATE(5143)] = 147143,
  [SMALL_STATE(5144)] = 147242,
  [SMALL_STATE(5145)] = 147341,
  [SMALL_STATE(5146)] = 147440,
  [SMALL_STATE(5147)] = 147539,
  [SMALL_STATE(5148)] = 147638,
  [SMALL_STATE(5149)] = 147737,
  [SMALL_STATE(5150)] = 147836,
  [SMALL_STATE(5151)] = 147911,
  [SMALL_STATE(5152)] = 147970,
  [SMALL_STATE(5153)] = 148061,
  [SMALL_STATE(5154)] = 148160,
  [SMALL_STATE(5155)] = 148259,
  [SMALL_STATE(5156)] = 148358,
  [SMALL_STATE(5157)] = 148457,
  [SMALL_STATE(5158)] = 148556,
  [SMALL_STATE(5159)] = 148655,
  [SMALL_STATE(5160)] = 148754,
  [SMALL_STATE(5161)] = 148849,
  [SMALL_STATE(5162)] = 148948,
  [SMALL_STATE(5163)] = 149015,
  [SMALL_STATE(5164)] = 149104,
  [SMALL_STATE(5165)] = 149203,
  [SMALL_STATE(5166)] = 149262,
  [SMALL_STATE(5167)] = 149347,
  [SMALL_STATE(5168)] = 149430,
  [SMALL_STATE(5169)] = 149509,
  [SMALL_STATE(5170)] = 149586,
  [SMALL_STATE(5171)] = 149659,
  [SMALL_STATE(5172)] = 149758,
  [SMALL_STATE(5173)] = 149827,
  [SMALL_STATE(5174)] = 149926,
  [SMALL_STATE(5175)] = 150025,
  [SMALL_STATE(5176)] = 150096,
  [SMALL_STATE(5177)] = 150175,
  [SMALL_STATE(5178)] = 150224,
  [SMALL_STATE(5179)] = 150323,
  [SMALL_STATE(5180)] = 150414,
  [SMALL_STATE(5181)] = 150493,
  [SMALL_STATE(5182)] = 150592,
  [SMALL_STATE(5183)] = 150691,
  [SMALL_STATE(5184)] = 150790,
  [SMALL_STATE(5185)] = 150869,
  [SMALL_STATE(5186)] = 150948,
  [SMALL_STATE(5187)] = 151047,
  [SMALL_STATE(5188)] = 151146,
  [SMALL_STATE(5189)] = 151241,
  [SMALL_STATE(5190)] = 151332,
  [SMALL_STATE(5191)] = 151427,
  [SMALL_STATE(5192)] = 151526,
  [SMALL_STATE(5193)] = 151625,
  [SMALL_STATE(5194)] = 151724,
  [SMALL_STATE(5195)] = 151777,
  [SMALL_STATE(5196)] = 151836,
  [SMALL_STATE(5197)] = 151933,
  [SMALL_STATE(5198)] = 152032,
  [SMALL_STATE(5199)] = 152131,
  [SMALL_STATE(5200)] = 152230,
  [SMALL_STATE(5201)] = 152329,
  [SMALL_STATE(5202)] = 152414,
  [SMALL_STATE(5203)] = 152469,
  [SMALL_STATE(5204)] = 152568,
  [SMALL_STATE(5205)] = 152653,
  [SMALL_STATE(5206)] = 152752,
  [SMALL_STATE(5207)] = 152849,
  [SMALL_STATE(5208)] = 152948,
  [SMALL_STATE(5209)] = 153013,
  [SMALL_STATE(5210)] = 153092,
  [SMALL_STATE(5211)] = 153187,
  [SMALL_STATE(5212)] = 153278,
  [SMALL_STATE(5213)] = 153377,
  [SMALL_STATE(5214)] = 153476,
  [SMALL_STATE(5215)] = 153561,
  [SMALL_STATE(5216)] = 153640,
  [SMALL_STATE(5217)] = 153739,
  [SMALL_STATE(5218)] = 153838,
  [SMALL_STATE(5219)] = 153893,
  [SMALL_STATE(5220)] = 153952,
  [SMALL_STATE(5221)] = 154051,
  [SMALL_STATE(5222)] = 154150,
  [SMALL_STATE(5223)] = 154249,
  [SMALL_STATE(5224)] = 154348,
  [SMALL_STATE(5225)] = 154447,
  [SMALL_STATE(5226)] = 154546,
  [SMALL_STATE(5227)] = 154645,
  [SMALL_STATE(5228)] = 154730,
  [SMALL_STATE(5229)] = 154789,
  [SMALL_STATE(5230)] = 154888,
  [SMALL_STATE(5231)] = 154987,
  [SMALL_STATE(5232)] = 155086,
  [SMALL_STATE(5233)] = 155185,
  [SMALL_STATE(5234)] = 155284,
  [SMALL_STATE(5235)] = 155383,
  [SMALL_STATE(5236)] = 155482,
  [SMALL_STATE(5237)] = 155581,
  [SMALL_STATE(5238)] = 155680,
  [SMALL_STATE(5239)] = 155779,
  [SMALL_STATE(5240)] = 155878,
  [SMALL_STATE(5241)] = 155933,
  [SMALL_STATE(5242)] = 156032,
  [SMALL_STATE(5243)] = 156131,
  [SMALL_STATE(5244)] = 156230,
  [SMALL_STATE(5245)] = 156329,
  [SMALL_STATE(5246)] = 156428,
  [SMALL_STATE(5247)] = 156527,
  [SMALL_STATE(5248)] = 156626,
  [SMALL_STATE(5249)] = 156725,
  [SMALL_STATE(5250)] = 156824,
  [SMALL_STATE(5251)] = 156923,
  [SMALL_STATE(5252)] = 157022,
  [SMALL_STATE(5253)] = 157121,
  [SMALL_STATE(5254)] = 157220,
  [SMALL_STATE(5255)] = 157319,
  [SMALL_STATE(5256)] = 157418,
  [SMALL_STATE(5257)] = 157517,
  [SMALL_STATE(5258)] = 157616,
  [SMALL_STATE(5259)] = 157715,
  [SMALL_STATE(5260)] = 157814,
  [SMALL_STATE(5261)] = 157913,
  [SMALL_STATE(5262)] = 157992,
  [SMALL_STATE(5263)] = 158091,
  [SMALL_STATE(5264)] = 158146,
  [SMALL_STATE(5265)] = 158245,
  [SMALL_STATE(5266)] = 158344,
  [SMALL_STATE(5267)] = 158443,
  [SMALL_STATE(5268)] = 158542,
  [SMALL_STATE(5269)] = 158641,
  [SMALL_STATE(5270)] = 158740,
  [SMALL_STATE(5271)] = 158839,
  [SMALL_STATE(5272)] = 158938,
  [SMALL_STATE(5273)] = 159037,
  [SMALL_STATE(5274)] = 159136,
  [SMALL_STATE(5275)] = 159235,
  [SMALL_STATE(5276)] = 159334,
  [SMALL_STATE(5277)] = 159433,
  [SMALL_STATE(5278)] = 159532,
  [SMALL_STATE(5279)] = 159631,
  [SMALL_STATE(5280)] = 159730,
  [SMALL_STATE(5281)] = 159829,
  [SMALL_STATE(5282)] = 159928,
  [SMALL_STATE(5283)] = 160027,
  [SMALL_STATE(5284)] = 160126,
  [SMALL_STATE(5285)] = 160225,
  [SMALL_STATE(5286)] = 160324,
  [SMALL_STATE(5287)] = 160379,
  [SMALL_STATE(5288)] = 160438,
  [SMALL_STATE(5289)] = 160537,
  [SMALL_STATE(5290)] = 160636,
  [SMALL_STATE(5291)] = 160735,
  [SMALL_STATE(5292)] = 160834,
  [SMALL_STATE(5293)] = 160933,
  [SMALL_STATE(5294)] = 161032,
  [SMALL_STATE(5295)] = 161131,
  [SMALL_STATE(5296)] = 161186,
  [SMALL_STATE(5297)] = 161285,
  [SMALL_STATE(5298)] = 161384,
  [SMALL_STATE(5299)] = 161483,
  [SMALL_STATE(5300)] = 161582,
  [SMALL_STATE(5301)] = 161681,
  [SMALL_STATE(5302)] = 161780,
  [SMALL_STATE(5303)] = 161879,
  [SMALL_STATE(5304)] = 161978,
  [SMALL_STATE(5305)] = 162077,
  [SMALL_STATE(5306)] = 162176,
  [SMALL_STATE(5307)] = 162275,
  [SMALL_STATE(5308)] = 162374,
  [SMALL_STATE(5309)] = 162473,
  [SMALL_STATE(5310)] = 162572,
  [SMALL_STATE(5311)] = 162671,
  [SMALL_STATE(5312)] = 162770,
  [SMALL_STATE(5313)] = 162869,
  [SMALL_STATE(5314)] = 162968,
  [SMALL_STATE(5315)] = 163028,
  [SMALL_STATE(5316)] = 163124,
  [SMALL_STATE(5317)] = 163202,
  [SMALL_STATE(5318)] = 163252,
  [SMALL_STATE(5319)] = 163348,
  [SMALL_STATE(5320)] = 163408,
  [SMALL_STATE(5321)] = 163504,
  [SMALL_STATE(5322)] = 163576,
  [SMALL_STATE(5323)] = 163644,
  [SMALL_STATE(5324)] = 163692,
  [SMALL_STATE(5325)] = 163766,
  [SMALL_STATE(5326)] = 163842,
  [SMALL_STATE(5327)] = 163920,
  [SMALL_STATE(5328)] = 164002,
  [SMALL_STATE(5329)] = 164086,
  [SMALL_STATE(5330)] = 164176,
  [SMALL_STATE(5331)] = 164262,
  [SMALL_STATE(5332)] = 164350,
  [SMALL_STATE(5333)] = 164412,
  [SMALL_STATE(5334)] = 164478,
  [SMALL_STATE(5335)] = 164538,
  [SMALL_STATE(5336)] = 164634,
  [SMALL_STATE(5337)] = 164730,
  [SMALL_STATE(5338)] = 164786,
  [SMALL_STATE(5339)] = 164882,
  [SMALL_STATE(5340)] = 164978,
  [SMALL_STATE(5341)] = 165060,
  [SMALL_STATE(5342)] = 165138,
  [SMALL_STATE(5343)] = 165232,
  [SMALL_STATE(5344)] = 165314,
  [SMALL_STATE(5345)] = 165408,
  [SMALL_STATE(5346)] = 165464,
  [SMALL_STATE(5347)] = 165558,
  [SMALL_STATE(5348)] = 165620,
  [SMALL_STATE(5349)] = 165714,
  [SMALL_STATE(5350)] = 165764,
  [SMALL_STATE(5351)] = 165854,
  [SMALL_STATE(5352)] = 165948,
  [SMALL_STATE(5353)] = 166008,
  [SMALL_STATE(5354)] = 166102,
  [SMALL_STATE(5355)] = 166164,
  [SMALL_STATE(5356)] = 166260,
  [SMALL_STATE(5357)] = 166322,
  [SMALL_STATE(5358)] = 166382,
  [SMALL_STATE(5359)] = 166478,
  [SMALL_STATE(5360)] = 166568,
  [SMALL_STATE(5361)] = 166658,
  [SMALL_STATE(5362)] = 166754,
  [SMALL_STATE(5363)] = 166848,
  [SMALL_STATE(5364)] = 166938,
  [SMALL_STATE(5365)] = 167032,
  [SMALL_STATE(5366)] = 167122,
  [SMALL_STATE(5367)] = 167192,
  [SMALL_STATE(5368)] = 167286,
  [SMALL_STATE(5369)] = 167376,
  [SMALL_STATE(5370)] = 167444,
  [SMALL_STATE(5371)] = 167516,
  [SMALL_STATE(5372)] = 167612,
  [SMALL_STATE(5373)] = 167708,
  [SMALL_STATE(5374)] = 167784,
  [SMALL_STATE(5375)] = 167844,
  [SMALL_STATE(5376)] = 167896,
  [SMALL_STATE(5377)] = 167990,
  [SMALL_STATE(5378)] = 168050,
  [SMALL_STATE(5379)] = 168110,
  [SMALL_STATE(5380)] = 168200,
  [SMALL_STATE(5381)] = 168278,
  [SMALL_STATE(5382)] = 168368,
  [SMALL_STATE(5383)] = 168450,
  [SMALL_STATE(5384)] = 168544,
  [SMALL_STATE(5385)] = 168638,
  [SMALL_STATE(5386)] = 168722,
  [SMALL_STATE(5387)] = 168816,
  [SMALL_STATE(5388)] = 168902,
  [SMALL_STATE(5389)] = 168956,
  [SMALL_STATE(5390)] = 169044,
  [SMALL_STATE(5391)] = 169110,
  [SMALL_STATE(5392)] = 169204,
  [SMALL_STATE(5393)] = 169266,
  [SMALL_STATE(5394)] = 169316,
  [SMALL_STATE(5395)] = 169406,
  [SMALL_STATE(5396)] = 169500,
  [SMALL_STATE(5397)] = 169590,
  [SMALL_STATE(5398)] = 169686,
  [SMALL_STATE(5399)] = 169782,
  [SMALL_STATE(5400)] = 169878,
  [SMALL_STATE(5401)] = 169974,
  [SMALL_STATE(5402)] = 170070,
  [SMALL_STATE(5403)] = 170132,
  [SMALL_STATE(5404)] = 170226,
  [SMALL_STATE(5405)] = 170322,
  [SMALL_STATE(5406)] = 170412,
  [SMALL_STATE(5407)] = 170508,
  [SMALL_STATE(5408)] = 170570,
  [SMALL_STATE(5409)] = 170636,
  [SMALL_STATE(5410)] = 170724,
  [SMALL_STATE(5411)] = 170810,
  [SMALL_STATE(5412)] = 170894,
  [SMALL_STATE(5413)] = 170984,
  [SMALL_STATE(5414)] = 171080,
  [SMALL_STATE(5415)] = 171176,
  [SMALL_STATE(5416)] = 171258,
  [SMALL_STATE(5417)] = 171354,
  [SMALL_STATE(5418)] = 171432,
  [SMALL_STATE(5419)] = 171508,
  [SMALL_STATE(5420)] = 171570,
  [SMALL_STATE(5421)] = 171642,
  [SMALL_STATE(5422)] = 171710,
  [SMALL_STATE(5423)] = 171806,
  [SMALL_STATE(5424)] = 171902,
  [SMALL_STATE(5425)] = 171962,
  [SMALL_STATE(5426)] = 172032,
  [SMALL_STATE(5427)] = 172128,
  [SMALL_STATE(5428)] = 172222,
  [SMALL_STATE(5429)] = 172316,
  [SMALL_STATE(5430)] = 172406,
  [SMALL_STATE(5431)] = 172484,
  [SMALL_STATE(5432)] = 172578,
  [SMALL_STATE(5433)] = 172668,
  [SMALL_STATE(5434)] = 172726,
  [SMALL_STATE(5435)] = 172822,
  [SMALL_STATE(5436)] = 172916,
  [SMALL_STATE(5437)] = 173010,
  [SMALL_STATE(5438)] = 173106,
  [SMALL_STATE(5439)] = 173200,
  [SMALL_STATE(5440)] = 173294,
  [SMALL_STATE(5441)] = 173390,
  [SMALL_STATE(5442)] = 173442,
  [SMALL_STATE(5443)] = 173538,
  [SMALL_STATE(5444)] = 173634,
  [SMALL_STATE(5445)] = 173730,
  [SMALL_STATE(5446)] = 173824,
  [SMALL_STATE(5447)] = 173914,
  [SMALL_STATE(5448)] = 174010,
  [SMALL_STATE(5449)] = 174102,
  [SMALL_STATE(5450)] = 174198,
  [SMALL_STATE(5451)] = 174282,
  [SMALL_STATE(5452)] = 174378,
  [SMALL_STATE(5453)] = 174436,
  [SMALL_STATE(5454)] = 174530,
  [SMALL_STATE(5455)] = 174624,
  [SMALL_STATE(5456)] = 174718,
  [SMALL_STATE(5457)] = 174814,
  [SMALL_STATE(5458)] = 174908,
  [SMALL_STATE(5459)] = 174992,
  [SMALL_STATE(5460)] = 175088,
  [SMALL_STATE(5461)] = 175184,
  [SMALL_STATE(5462)] = 175278,
  [SMALL_STATE(5463)] = 175374,
  [SMALL_STATE(5464)] = 175430,
  [SMALL_STATE(5465)] = 175526,
  [SMALL_STATE(5466)] = 175622,
  [SMALL_STATE(5467)] = 175718,
  [SMALL_STATE(5468)] = 175814,
  [SMALL_STATE(5469)] = 175910,
  [SMALL_STATE(5470)] = 175988,
  [SMALL_STATE(5471)] = 176084,
  [SMALL_STATE(5472)] = 176177,
  [SMALL_STATE(5473)] = 176270,
  [SMALL_STATE(5474)] = 176343,
  [SMALL_STATE(5475)] = 176416,
  [SMALL_STATE(5476)] = 176509,
  [SMALL_STATE(5477)] = 176564,
  [SMALL_STATE(5478)] = 176621,
  [SMALL_STATE(5479)] = 176714,
  [SMALL_STATE(5480)] = 176791,
  [SMALL_STATE(5481)] = 176884,
  [SMALL_STATE(5482)] = 176937,
  [SMALL_STATE(5483)] = 177030,
  [SMALL_STATE(5484)] = 177123,
  [SMALL_STATE(5485)] = 177216,
  [SMALL_STATE(5486)] = 177309,
  [SMALL_STATE(5487)] = 177402,
  [SMALL_STATE(5488)] = 177495,
  [SMALL_STATE(5489)] = 177568,
  [SMALL_STATE(5490)] = 177661,
  [SMALL_STATE(5491)] = 177754,
  [SMALL_STATE(5492)] = 177847,
  [SMALL_STATE(5493)] = 177940,
  [SMALL_STATE(5494)] = 177997,
  [SMALL_STATE(5495)] = 178090,
  [SMALL_STATE(5496)] = 178183,
  [SMALL_STATE(5497)] = 178276,
  [SMALL_STATE(5498)] = 178353,
  [SMALL_STATE(5499)] = 178426,
  [SMALL_STATE(5500)] = 178519,
  [SMALL_STATE(5501)] = 178592,
  [SMALL_STATE(5502)] = 178685,
  [SMALL_STATE(5503)] = 178778,
  [SMALL_STATE(5504)] = 178871,
  [SMALL_STATE(5505)] = 178964,
  [SMALL_STATE(5506)] = 179037,
  [SMALL_STATE(5507)] = 179130,
  [SMALL_STATE(5508)] = 179223,
  [SMALL_STATE(5509)] = 179316,
  [SMALL_STATE(5510)] = 179371,
  [SMALL_STATE(5511)] = 179464,
  [SMALL_STATE(5512)] = 179557,
  [SMALL_STATE(5513)] = 179612,
  [SMALL_STATE(5514)] = 179701,
  [SMALL_STATE(5515)] = 179794,
  [SMALL_STATE(5516)] = 179887,
  [SMALL_STATE(5517)] = 179934,
  [SMALL_STATE(5518)] = 180027,
  [SMALL_STATE(5519)] = 180120,
  [SMALL_STATE(5520)] = 180213,
  [SMALL_STATE(5521)] = 180306,
  [SMALL_STATE(5522)] = 180355,
  [SMALL_STATE(5523)] = 180408,
  [SMALL_STATE(5524)] = 180501,
  [SMALL_STATE(5525)] = 180594,
  [SMALL_STATE(5526)] = 180687,
  [SMALL_STATE(5527)] = 180780,
  [SMALL_STATE(5528)] = 180837,
  [SMALL_STATE(5529)] = 180930,
  [SMALL_STATE(5530)] = 180983,
  [SMALL_STATE(5531)] = 181076,
  [SMALL_STATE(5532)] = 181169,
  [SMALL_STATE(5533)] = 181262,
  [SMALL_STATE(5534)] = 181355,
  [SMALL_STATE(5535)] = 181448,
  [SMALL_STATE(5536)] = 181541,
  [SMALL_STATE(5537)] = 181634,
  [SMALL_STATE(5538)] = 181681,
  [SMALL_STATE(5539)] = 181774,
  [SMALL_STATE(5540)] = 181867,
  [SMALL_STATE(5541)] = 181960,
  [SMALL_STATE(5542)] = 182053,
  [SMALL_STATE(5543)] = 182146,
  [SMALL_STATE(5544)] = 182239,
  [SMALL_STATE(5545)] = 182288,
  [SMALL_STATE(5546)] = 182381,
  [SMALL_STATE(5547)] = 182474,
  [SMALL_STATE(5548)] = 182567,
  [SMALL_STATE(5549)] = 182640,
  [SMALL_STATE(5550)] = 182713,
  [SMALL_STATE(5551)] = 182806,
  [SMALL_STATE(5552)] = 182899,
  [SMALL_STATE(5553)] = 182992,
  [SMALL_STATE(5554)] = 183085,
  [SMALL_STATE(5555)] = 183158,
  [SMALL_STATE(5556)] = 183231,
  [SMALL_STATE(5557)] = 183324,
  [SMALL_STATE(5558)] = 183417,
  [SMALL_STATE(5559)] = 183510,
  [SMALL_STATE(5560)] = 183603,
  [SMALL_STATE(5561)] = 183696,
  [SMALL_STATE(5562)] = 183769,
  [SMALL_STATE(5563)] = 183862,
  [SMALL_STATE(5564)] = 183909,
  [SMALL_STATE(5565)] = 184002,
  [SMALL_STATE(5566)] = 184095,
  [SMALL_STATE(5567)] = 184188,
  [SMALL_STATE(5568)] = 184281,
  [SMALL_STATE(5569)] = 184328,
  [SMALL_STATE(5570)] = 184421,
  [SMALL_STATE(5571)] = 184514,
  [SMALL_STATE(5572)] = 184607,
  [SMALL_STATE(5573)] = 184696,
  [SMALL_STATE(5574)] = 184789,
  [SMALL_STATE(5575)] = 184882,
  [SMALL_STATE(5576)] = 184975,
  [SMALL_STATE(5577)] = 185068,
  [SMALL_STATE(5578)] = 185161,
  [SMALL_STATE(5579)] = 185254,
  [SMALL_STATE(5580)] = 185347,
  [SMALL_STATE(5581)] = 185440,
  [SMALL_STATE(5582)] = 185533,
  [SMALL_STATE(5583)] = 185626,
  [SMALL_STATE(5584)] = 185719,
  [SMALL_STATE(5585)] = 185812,
  [SMALL_STATE(5586)] = 185905,
  [SMALL_STATE(5587)] = 185998,
  [SMALL_STATE(5588)] = 186091,
  [SMALL_STATE(5589)] = 186184,
  [SMALL_STATE(5590)] = 186277,
  [SMALL_STATE(5591)] = 186370,
  [SMALL_STATE(5592)] = 186463,
  [SMALL_STATE(5593)] = 186512,
  [SMALL_STATE(5594)] = 186585,
  [SMALL_STATE(5595)] = 186678,
  [SMALL_STATE(5596)] = 186771,
  [SMALL_STATE(5597)] = 186822,
  [SMALL_STATE(5598)] = 186915,
  [SMALL_STATE(5599)] = 187008,
  [SMALL_STATE(5600)] = 187059,
  [SMALL_STATE(5601)] = 187110,
  [SMALL_STATE(5602)] = 187161,
  [SMALL_STATE(5603)] = 187254,
  [SMALL_STATE(5604)] = 187305,
  [SMALL_STATE(5605)] = 187356,
  [SMALL_STATE(5606)] = 187407,
  [SMALL_STATE(5607)] = 187500,
  [SMALL_STATE(5608)] = 187551,
  [SMALL_STATE(5609)] = 187602,
  [SMALL_STATE(5610)] = 187653,
  [SMALL_STATE(5611)] = 187704,
  [SMALL_STATE(5612)] = 187755,
  [SMALL_STATE(5613)] = 187848,
  [SMALL_STATE(5614)] = 187941,
  [SMALL_STATE(5615)] = 188034,
  [SMALL_STATE(5616)] = 188081,
  [SMALL_STATE(5617)] = 188174,
  [SMALL_STATE(5618)] = 188267,
  [SMALL_STATE(5619)] = 188360,
  [SMALL_STATE(5620)] = 188453,
  [SMALL_STATE(5621)] = 188541,
  [SMALL_STATE(5622)] = 188587,
  [SMALL_STATE(5623)] = 188637,
  [SMALL_STATE(5624)] = 188683,
  [SMALL_STATE(5625)] = 188729,
  [SMALL_STATE(5626)] = 188801,
  [SMALL_STATE(5627)] = 188847,
  [SMALL_STATE(5628)] = 188919,
  [SMALL_STATE(5629)] = 188965,
  [SMALL_STATE(5630)] = 189011,
  [SMALL_STATE(5631)] = 189057,
  [SMALL_STATE(5632)] = 189103,
  [SMALL_STATE(5633)] = 189175,
  [SMALL_STATE(5634)] = 189229,
  [SMALL_STATE(5635)] = 189281,
  [SMALL_STATE(5636)] = 189329,
  [SMALL_STATE(5637)] = 189375,
  [SMALL_STATE(5638)] = 189447,
  [SMALL_STATE(5639)] = 189493,
  [SMALL_STATE(5640)] = 189539,
  [SMALL_STATE(5641)] = 189625,
  [SMALL_STATE(5642)] = 189713,
  [SMALL_STATE(5643)] = 189771,
  [SMALL_STATE(5644)] = 189855,
  [SMALL_STATE(5645)] = 189901,
  [SMALL_STATE(5646)] = 189989,
  [SMALL_STATE(5647)] = 190077,
  [SMALL_STATE(5648)] = 190125,
  [SMALL_STATE(5649)] = 190171,
  [SMALL_STATE(5650)] = 190217,
  [SMALL_STATE(5651)] = 190305,
  [SMALL_STATE(5652)] = 190351,
  [SMALL_STATE(5653)] = 190397,
  [SMALL_STATE(5654)] = 190443,
  [SMALL_STATE(5655)] = 190493,
  [SMALL_STATE(5656)] = 190569,
  [SMALL_STATE(5657)] = 190615,
  [SMALL_STATE(5658)] = 190661,
  [SMALL_STATE(5659)] = 190707,
  [SMALL_STATE(5660)] = 190753,
  [SMALL_STATE(5661)] = 190799,
  [SMALL_STATE(5662)] = 190845,
  [SMALL_STATE(5663)] = 190895,
  [SMALL_STATE(5664)] = 190941,
  [SMALL_STATE(5665)] = 191017,
  [SMALL_STATE(5666)] = 191063,
  [SMALL_STATE(5667)] = 191109,
  [SMALL_STATE(5668)] = 191181,
  [SMALL_STATE(5669)] = 191227,
  [SMALL_STATE(5670)] = 191277,
  [SMALL_STATE(5671)] = 191349,
  [SMALL_STATE(5672)] = 191399,
  [SMALL_STATE(5673)] = 191471,
  [SMALL_STATE(5674)] = 191517,
  [SMALL_STATE(5675)] = 191563,
  [SMALL_STATE(5676)] = 191613,
  [SMALL_STATE(5677)] = 191701,
  [SMALL_STATE(5678)] = 191757,
  [SMALL_STATE(5679)] = 191803,
  [SMALL_STATE(5680)] = 191879,
  [SMALL_STATE(5681)] = 191963,
  [SMALL_STATE(5682)] = 192013,
  [SMALL_STATE(5683)] = 192097,
  [SMALL_STATE(5684)] = 192187,
  [SMALL_STATE(5685)] = 192233,
  [SMALL_STATE(5686)] = 192305,
  [SMALL_STATE(5687)] = 192355,
  [SMALL_STATE(5688)] = 192427,
  [SMALL_STATE(5689)] = 192477,
  [SMALL_STATE(5690)] = 192529,
  [SMALL_STATE(5691)] = 192579,
  [SMALL_STATE(5692)] = 192625,
  [SMALL_STATE(5693)] = 192671,
  [SMALL_STATE(5694)] = 192733,
  [SMALL_STATE(5695)] = 192779,
  [SMALL_STATE(5696)] = 192863,
  [SMALL_STATE(5697)] = 192913,
  [SMALL_STATE(5698)] = 192963,
  [SMALL_STATE(5699)] = 193009,
  [SMALL_STATE(5700)] = 193081,
  [SMALL_STATE(5701)] = 193131,
  [SMALL_STATE(5702)] = 193189,
  [SMALL_STATE(5703)] = 193239,
  [SMALL_STATE(5704)] = 193311,
  [SMALL_STATE(5705)] = 193369,
  [SMALL_STATE(5706)] = 193423,
  [SMALL_STATE(5707)] = 193469,
  [SMALL_STATE(5708)] = 193553,
  [SMALL_STATE(5709)] = 193599,
  [SMALL_STATE(5710)] = 193687,
  [SMALL_STATE(5711)] = 193737,
  [SMALL_STATE(5712)] = 193787,
  [SMALL_STATE(5713)] = 193833,
  [SMALL_STATE(5714)] = 193921,
  [SMALL_STATE(5715)] = 193971,
  [SMALL_STATE(5716)] = 194021,
  [SMALL_STATE(5717)] = 194067,
  [SMALL_STATE(5718)] = 194113,
  [SMALL_STATE(5719)] = 194163,
  [SMALL_STATE(5720)] = 194251,
  [SMALL_STATE(5721)] = 194297,
  [SMALL_STATE(5722)] = 194385,
  [SMALL_STATE(5723)] = 194435,
  [SMALL_STATE(5724)] = 194519,
  [SMALL_STATE(5725)] = 194569,
  [SMALL_STATE(5726)] = 194619,
  [SMALL_STATE(5727)] = 194665,
  [SMALL_STATE(5728)] = 194753,
  [SMALL_STATE(5729)] = 194803,
  [SMALL_STATE(5730)] = 194849,
  [SMALL_STATE(5731)] = 194895,
  [SMALL_STATE(5732)] = 194945,
  [SMALL_STATE(5733)] = 194995,
  [SMALL_STATE(5734)] = 195045,
  [SMALL_STATE(5735)] = 195095,
  [SMALL_STATE(5736)] = 195183,
  [SMALL_STATE(5737)] = 195235,
  [SMALL_STATE(5738)] = 195281,
  [SMALL_STATE(5739)] = 195365,
  [SMALL_STATE(5740)] = 195453,
  [SMALL_STATE(5741)] = 195541,
  [SMALL_STATE(5742)] = 195597,
  [SMALL_STATE(5743)] = 195649,
  [SMALL_STATE(5744)] = 195695,
  [SMALL_STATE(5745)] = 195741,
  [SMALL_STATE(5746)] = 195787,
  [SMALL_STATE(5747)] = 195833,
  [SMALL_STATE(5748)] = 195921,
  [SMALL_STATE(5749)] = 195983,
  [SMALL_STATE(5750)] = 196033,
  [SMALL_STATE(5751)] = 196083,
  [SMALL_STATE(5752)] = 196133,
  [SMALL_STATE(5753)] = 196221,
  [SMALL_STATE(5754)] = 196293,
  [SMALL_STATE(5755)] = 196381,
  [SMALL_STATE(5756)] = 196457,
  [SMALL_STATE(5757)] = 196545,
  [SMALL_STATE(5758)] = 196590,
  [SMALL_STATE(5759)] = 196639,
  [SMALL_STATE(5760)] = 196710,
  [SMALL_STATE(5761)] = 196755,
  [SMALL_STATE(5762)] = 196830,
  [SMALL_STATE(5763)] = 196875,
  [SMALL_STATE(5764)] = 196920,
  [SMALL_STATE(5765)] = 196991,
  [SMALL_STATE(5766)] = 197066,
  [SMALL_STATE(5767)] = 197137,
  [SMALL_STATE(5768)] = 197208,
  [SMALL_STATE(5769)] = 197253,
  [SMALL_STATE(5770)] = 197298,
  [SMALL_STATE(5771)] = 197343,
  [SMALL_STATE(5772)] = 197388,
  [SMALL_STATE(5773)] = 197459,
  [SMALL_STATE(5774)] = 197530,
  [SMALL_STATE(5775)] = 197611,
  [SMALL_STATE(5776)] = 197682,
  [SMALL_STATE(5777)] = 197753,
  [SMALL_STATE(5778)] = 197836,
  [SMALL_STATE(5779)] = 197881,
  [SMALL_STATE(5780)] = 197926,
  [SMALL_STATE(5781)] = 197971,
  [SMALL_STATE(5782)] = 198016,
  [SMALL_STATE(5783)] = 198061,
  [SMALL_STATE(5784)] = 198132,
  [SMALL_STATE(5785)] = 198177,
  [SMALL_STATE(5786)] = 198252,
  [SMALL_STATE(5787)] = 198297,
  [SMALL_STATE(5788)] = 198342,
  [SMALL_STATE(5789)] = 198387,
  [SMALL_STATE(5790)] = 198432,
  [SMALL_STATE(5791)] = 198477,
  [SMALL_STATE(5792)] = 198522,
  [SMALL_STATE(5793)] = 198567,
  [SMALL_STATE(5794)] = 198612,
  [SMALL_STATE(5795)] = 198657,
  [SMALL_STATE(5796)] = 198702,
  [SMALL_STATE(5797)] = 198773,
  [SMALL_STATE(5798)] = 198818,
  [SMALL_STATE(5799)] = 198905,
  [SMALL_STATE(5800)] = 198950,
  [SMALL_STATE(5801)] = 198995,
  [SMALL_STATE(5802)] = 199040,
  [SMALL_STATE(5803)] = 199085,
  [SMALL_STATE(5804)] = 199166,
  [SMALL_STATE(5805)] = 199211,
  [SMALL_STATE(5806)] = 199256,
  [SMALL_STATE(5807)] = 199301,
  [SMALL_STATE(5808)] = 199346,
  [SMALL_STATE(5809)] = 199395,
  [SMALL_STATE(5810)] = 199476,
  [SMALL_STATE(5811)] = 199521,
  [SMALL_STATE(5812)] = 199592,
  [SMALL_STATE(5813)] = 199647,
  [SMALL_STATE(5814)] = 199728,
  [SMALL_STATE(5815)] = 199773,
  [SMALL_STATE(5816)] = 199818,
  [SMALL_STATE(5817)] = 199863,
  [SMALL_STATE(5818)] = 199910,
  [SMALL_STATE(5819)] = 199955,
  [SMALL_STATE(5820)] = 200000,
  [SMALL_STATE(5821)] = 200045,
  [SMALL_STATE(5822)] = 200116,
  [SMALL_STATE(5823)] = 200203,
  [SMALL_STATE(5824)] = 200248,
  [SMALL_STATE(5825)] = 200293,
  [SMALL_STATE(5826)] = 200338,
  [SMALL_STATE(5827)] = 200383,
  [SMALL_STATE(5828)] = 200428,
  [SMALL_STATE(5829)] = 200473,
  [SMALL_STATE(5830)] = 200518,
  [SMALL_STATE(5831)] = 200563,
  [SMALL_STATE(5832)] = 200638,
  [SMALL_STATE(5833)] = 200683,
  [SMALL_STATE(5834)] = 200728,
  [SMALL_STATE(5835)] = 200773,
  [SMALL_STATE(5836)] = 200818,
  [SMALL_STATE(5837)] = 200863,
  [SMALL_STATE(5838)] = 200908,
  [SMALL_STATE(5839)] = 200953,
  [SMALL_STATE(5840)] = 200998,
  [SMALL_STATE(5841)] = 201043,
  [SMALL_STATE(5842)] = 201114,
  [SMALL_STATE(5843)] = 201185,
  [SMALL_STATE(5844)] = 201260,
  [SMALL_STATE(5845)] = 201331,
  [SMALL_STATE(5846)] = 201402,
  [SMALL_STATE(5847)] = 201447,
  [SMALL_STATE(5848)] = 201492,
  [SMALL_STATE(5849)] = 201537,
  [SMALL_STATE(5850)] = 201624,
  [SMALL_STATE(5851)] = 201699,
  [SMALL_STATE(5852)] = 201744,
  [SMALL_STATE(5853)] = 201789,
  [SMALL_STATE(5854)] = 201834,
  [SMALL_STATE(5855)] = 201879,
  [SMALL_STATE(5856)] = 201924,
  [SMALL_STATE(5857)] = 201969,
  [SMALL_STATE(5858)] = 202014,
  [SMALL_STATE(5859)] = 202059,
  [SMALL_STATE(5860)] = 202112,
  [SMALL_STATE(5861)] = 202157,
  [SMALL_STATE(5862)] = 202202,
  [SMALL_STATE(5863)] = 202247,
  [SMALL_STATE(5864)] = 202292,
  [SMALL_STATE(5865)] = 202379,
  [SMALL_STATE(5866)] = 202424,
  [SMALL_STATE(5867)] = 202502,
  [SMALL_STATE(5868)] = 202584,
  [SMALL_STATE(5869)] = 202666,
  [SMALL_STATE(5870)] = 202748,
  [SMALL_STATE(5871)] = 202830,
  [SMALL_STATE(5872)] = 202912,
  [SMALL_STATE(5873)] = 202994,
  [SMALL_STATE(5874)] = 203076,
  [SMALL_STATE(5875)] = 203154,
  [SMALL_STATE(5876)] = 203236,
  [SMALL_STATE(5877)] = 203318,
  [SMALL_STATE(5878)] = 203400,
  [SMALL_STATE(5879)] = 203482,
  [SMALL_STATE(5880)] = 203554,
  [SMALL_STATE(5881)] = 203636,
  [SMALL_STATE(5882)] = 203718,
  [SMALL_STATE(5883)] = 203774,
  [SMALL_STATE(5884)] = 203856,
  [SMALL_STATE(5885)] = 203936,
  [SMALL_STATE(5886)] = 204016,
  [SMALL_STATE(5887)] = 204098,
  [SMALL_STATE(5888)] = 204170,
  [SMALL_STATE(5889)] = 204244,
  [SMALL_STATE(5890)] = 204326,
  [SMALL_STATE(5891)] = 204408,
  [SMALL_STATE(5892)] = 204490,
  [SMALL_STATE(5893)] = 204562,
  [SMALL_STATE(5894)] = 204618,
  [SMALL_STATE(5895)] = 204690,
  [SMALL_STATE(5896)] = 204746,
  [SMALL_STATE(5897)] = 204828,
  [SMALL_STATE(5898)] = 204906,
  [SMALL_STATE(5899)] = 204988,
  [SMALL_STATE(5900)] = 205066,
  [SMALL_STATE(5901)] = 205138,
  [SMALL_STATE(5902)] = 205210,
  [SMALL_STATE(5903)] = 205292,
  [SMALL_STATE(5904)] = 205364,
  [SMALL_STATE(5905)] = 205446,
  [SMALL_STATE(5906)] = 205518,
  [SMALL_STATE(5907)] = 205592,
  [SMALL_STATE(5908)] = 205674,
  [SMALL_STATE(5909)] = 205752,
  [SMALL_STATE(5910)] = 205834,
  [SMALL_STATE(5911)] = 205912,
  [SMALL_STATE(5912)] = 205984,
  [SMALL_STATE(5913)] = 206066,
  [SMALL_STATE(5914)] = 206138,
  [SMALL_STATE(5915)] = 206220,
  [SMALL_STATE(5916)] = 206292,
  [SMALL_STATE(5917)] = 206374,
  [SMALL_STATE(5918)] = 206426,
  [SMALL_STATE(5919)] = 206508,
  [SMALL_STATE(5920)] = 206590,
  [SMALL_STATE(5921)] = 206638,
  [SMALL_STATE(5922)] = 206690,
  [SMALL_STATE(5923)] = 206772,
  [SMALL_STATE(5924)] = 206858,
  [SMALL_STATE(5925)] = 206940,
  [SMALL_STATE(5926)] = 207018,
  [SMALL_STATE(5927)] = 207100,
  [SMALL_STATE(5928)] = 207180,
  [SMALL_STATE(5929)] = 207262,
  [SMALL_STATE(5930)] = 207340,
  [SMALL_STATE(5931)] = 207418,
  [SMALL_STATE(5932)] = 207490,
  [SMALL_STATE(5933)] = 207562,
  [SMALL_STATE(5934)] = 207644,
  [SMALL_STATE(5935)] = 207726,
  [SMALL_STATE(5936)] = 207804,
  [SMALL_STATE(5937)] = 207886,
  [SMALL_STATE(5938)] = 207968,
  [SMALL_STATE(5939)] = 208040,
  [SMALL_STATE(5940)] = 208122,
  [SMALL_STATE(5941)] = 208194,
  [SMALL_STATE(5942)] = 208268,
  [SMALL_STATE(5943)] = 208350,
  [SMALL_STATE(5944)] = 208398,
  [SMALL_STATE(5945)] = 208480,
  [SMALL_STATE(5946)] = 208562,
  [SMALL_STATE(5947)] = 208632,
  [SMALL_STATE(5948)] = 208714,
  [SMALL_STATE(5949)] = 208792,
  [SMALL_STATE(5950)] = 208848,
  [SMALL_STATE(5951)] = 208930,
  [SMALL_STATE(5952)] = 209012,
  [SMALL_STATE(5953)] = 209094,
  [SMALL_STATE(5954)] = 209166,
  [SMALL_STATE(5955)] = 209248,
  [SMALL_STATE(5956)] = 209330,
  [SMALL_STATE(5957)] = 209408,
  [SMALL_STATE(5958)] = 209490,
  [SMALL_STATE(5959)] = 209570,
  [SMALL_STATE(5960)] = 209652,
  [SMALL_STATE(5961)] = 209734,
  [SMALL_STATE(5962)] = 209790,
  [SMALL_STATE(5963)] = 209862,
  [SMALL_STATE(5964)] = 209944,
  [SMALL_STATE(5965)] = 210014,
  [SMALL_STATE(5966)] = 210100,
  [SMALL_STATE(5967)] = 210178,
  [SMALL_STATE(5968)] = 210250,
  [SMALL_STATE(5969)] = 210328,
  [SMALL_STATE(5970)] = 210410,
  [SMALL_STATE(5971)] = 210462,
  [SMALL_STATE(5972)] = 210522,
  [SMALL_STATE(5973)] = 210592,
  [SMALL_STATE(5974)] = 210670,
  [SMALL_STATE(5975)] = 210752,
  [SMALL_STATE(5976)] = 210830,
  [SMALL_STATE(5977)] = 210912,
  [SMALL_STATE(5978)] = 210994,
  [SMALL_STATE(5979)] = 211076,
  [SMALL_STATE(5980)] = 211158,
  [SMALL_STATE(5981)] = 211240,
  [SMALL_STATE(5982)] = 211310,
  [SMALL_STATE(5983)] = 211392,
  [SMALL_STATE(5984)] = 211444,
  [SMALL_STATE(5985)] = 211526,
  [SMALL_STATE(5986)] = 211608,
  [SMALL_STATE(5987)] = 211680,
  [SMALL_STATE(5988)] = 211752,
  [SMALL_STATE(5989)] = 211830,
  [SMALL_STATE(5990)] = 211908,
  [SMALL_STATE(5991)] = 211978,
  [SMALL_STATE(5992)] = 212030,
  [SMALL_STATE(5993)] = 212086,
  [SMALL_STATE(5994)] = 212168,
  [SMALL_STATE(5995)] = 212246,
  [SMALL_STATE(5996)] = 212324,
  [SMALL_STATE(5997)] = 212406,
  [SMALL_STATE(5998)] = 212454,
  [SMALL_STATE(5999)] = 212502,
  [SMALL_STATE(6000)] = 212572,
  [SMALL_STATE(6001)] = 212642,
  [SMALL_STATE(6002)] = 212712,
  [SMALL_STATE(6003)] = 212794,
  [SMALL_STATE(6004)] = 212872,
  [SMALL_STATE(6005)] = 212928,
  [SMALL_STATE(6006)] = 213010,
  [SMALL_STATE(6007)] = 213092,
  [SMALL_STATE(6008)] = 213164,
  [SMALL_STATE(6009)] = 213246,
  [SMALL_STATE(6010)] = 213320,
  [SMALL_STATE(6011)] = 213402,
  [SMALL_STATE(6012)] = 213480,
  [SMALL_STATE(6013)] = 213535,
  [SMALL_STATE(6014)] = 213604,
  [SMALL_STATE(6015)] = 213689,
  [SMALL_STATE(6016)] = 213740,
  [SMALL_STATE(6017)] = 213791,
  [SMALL_STATE(6018)] = 213842,
  [SMALL_STATE(6019)] = 213911,
  [SMALL_STATE(6020)] = 213966,
  [SMALL_STATE(6021)] = 214017,
  [SMALL_STATE(6022)] = 214072,
  [SMALL_STATE(6023)] = 214127,
  [SMALL_STATE(6024)] = 214212,
  [SMALL_STATE(6025)] = 214267,
  [SMALL_STATE(6026)] = 214322,
  [SMALL_STATE(6027)] = 214391,
  [SMALL_STATE(6028)] = 214438,
  [SMALL_STATE(6029)] = 214523,
  [SMALL_STATE(6030)] = 214592,
  [SMALL_STATE(6031)] = 214677,
  [SMALL_STATE(6032)] = 214755,
  [SMALL_STATE(6033)] = 214833,
  [SMALL_STATE(6034)] = 214911,
  [SMALL_STATE(6035)] = 214979,
  [SMALL_STATE(6036)] = 215057,
  [SMALL_STATE(6037)] = 215125,
  [SMALL_STATE(6038)] = 215175,
  [SMALL_STATE(6039)] = 215243,
  [SMALL_STATE(6040)] = 215327,
  [SMALL_STATE(6041)] = 215395,
  [SMALL_STATE(6042)] = 215463,
  [SMALL_STATE(6043)] = 215531,
  [SMALL_STATE(6044)] = 215599,
  [SMALL_STATE(6045)] = 215677,
  [SMALL_STATE(6046)] = 215727,
  [SMALL_STATE(6047)] = 215811,
  [SMALL_STATE(6048)] = 215879,
  [SMALL_STATE(6049)] = 215947,
  [SMALL_STATE(6050)] = 216025,
  [SMALL_STATE(6051)] = 216093,
  [SMALL_STATE(6052)] = 216177,
  [SMALL_STATE(6053)] = 216245,
  [SMALL_STATE(6054)] = 216291,
  [SMALL_STATE(6055)] = 216359,
  [SMALL_STATE(6056)] = 216437,
  [SMALL_STATE(6057)] = 216483,
  [SMALL_STATE(6058)] = 216551,
  [SMALL_STATE(6059)] = 216635,
  [SMALL_STATE(6060)] = 216685,
  [SMALL_STATE(6061)] = 216775,
  [SMALL_STATE(6062)] = 216843,
  [SMALL_STATE(6063)] = 216921,
  [SMALL_STATE(6064)] = 216966,
  [SMALL_STATE(6065)] = 217019,
  [SMALL_STATE(6066)] = 217086,
  [SMALL_STATE(6067)] = 217131,
  [SMALL_STATE(6068)] = 217214,
  [SMALL_STATE(6069)] = 217265,
  [SMALL_STATE(6070)] = 217332,
  [SMALL_STATE(6071)] = 217415,
  [SMALL_STATE(6072)] = 217460,
  [SMALL_STATE(6073)] = 217505,
  [SMALL_STATE(6074)] = 217550,
  [SMALL_STATE(6075)] = 217627,
  [SMALL_STATE(6076)] = 217680,
  [SMALL_STATE(6077)] = 217729,
  [SMALL_STATE(6078)] = 217774,
  [SMALL_STATE(6079)] = 217819,
  [SMALL_STATE(6080)] = 217902,
  [SMALL_STATE(6081)] = 217955,
  [SMALL_STATE(6082)] = 217996,
  [SMALL_STATE(6083)] = 218073,
  [SMALL_STATE(6084)] = 218118,
  [SMALL_STATE(6085)] = 218159,
  [SMALL_STATE(6086)] = 218226,
  [SMALL_STATE(6087)] = 218303,
  [SMALL_STATE(6088)] = 218380,
  [SMALL_STATE(6089)] = 218429,
  [SMALL_STATE(6090)] = 218496,
  [SMALL_STATE(6091)] = 218563,
  [SMALL_STATE(6092)] = 218646,
  [SMALL_STATE(6093)] = 218691,
  [SMALL_STATE(6094)] = 218758,
  [SMALL_STATE(6095)] = 218799,
  [SMALL_STATE(6096)] = 218844,
  [SMALL_STATE(6097)] = 218927,
  [SMALL_STATE(6098)] = 218968,
  [SMALL_STATE(6099)] = 219017,
  [SMALL_STATE(6100)] = 219062,
  [SMALL_STATE(6101)] = 219111,
  [SMALL_STATE(6102)] = 219178,
  [SMALL_STATE(6103)] = 219223,
  [SMALL_STATE(6104)] = 219290,
  [SMALL_STATE(6105)] = 219373,
  [SMALL_STATE(6106)] = 219440,
  [SMALL_STATE(6107)] = 219507,
  [SMALL_STATE(6108)] = 219552,
  [SMALL_STATE(6109)] = 219619,
  [SMALL_STATE(6110)] = 219670,
  [SMALL_STATE(6111)] = 219711,
  [SMALL_STATE(6112)] = 219778,
  [SMALL_STATE(6113)] = 219854,
  [SMALL_STATE(6114)] = 219920,
  [SMALL_STATE(6115)] = 219968,
  [SMALL_STATE(6116)] = 220044,
  [SMALL_STATE(6117)] = 220096,
  [SMALL_STATE(6118)] = 220172,
  [SMALL_STATE(6119)] = 220212,
  [SMALL_STATE(6120)] = 220288,
  [SMALL_STATE(6121)] = 220328,
  [SMALL_STATE(6122)] = 220372,
  [SMALL_STATE(6123)] = 220448,
  [SMALL_STATE(6124)] = 220514,
  [SMALL_STATE(6125)] = 220566,
  [SMALL_STATE(6126)] = 220636,
  [SMALL_STATE(6127)] = 220706,
  [SMALL_STATE(6128)] = 220776,
  [SMALL_STATE(6129)] = 220820,
  [SMALL_STATE(6130)] = 220864,
  [SMALL_STATE(6131)] = 220930,
  [SMALL_STATE(6132)] = 220996,
  [SMALL_STATE(6133)] = 221040,
  [SMALL_STATE(6134)] = 221116,
  [SMALL_STATE(6135)] = 221182,
  [SMALL_STATE(6136)] = 221258,
  [SMALL_STATE(6137)] = 221324,
  [SMALL_STATE(6138)] = 221376,
  [SMALL_STATE(6139)] = 221446,
  [SMALL_STATE(6140)] = 221512,
  [SMALL_STATE(6141)] = 221554,
  [SMALL_STATE(6142)] = 221598,
  [SMALL_STATE(6143)] = 221650,
  [SMALL_STATE(6144)] = 221694,
  [SMALL_STATE(6145)] = 221764,
  [SMALL_STATE(6146)] = 221808,
  [SMALL_STATE(6147)] = 221852,
  [SMALL_STATE(6148)] = 221918,
  [SMALL_STATE(6149)] = 221994,
  [SMALL_STATE(6150)] = 222038,
  [SMALL_STATE(6151)] = 222108,
  [SMALL_STATE(6152)] = 222151,
  [SMALL_STATE(6153)] = 222194,
  [SMALL_STATE(6154)] = 222237,
  [SMALL_STATE(6155)] = 222280,
  [SMALL_STATE(6156)] = 222323,
  [SMALL_STATE(6157)] = 222366,
  [SMALL_STATE(6158)] = 222409,
  [SMALL_STATE(6159)] = 222484,
  [SMALL_STATE(6160)] = 222527,
  [SMALL_STATE(6161)] = 222570,
  [SMALL_STATE(6162)] = 222643,
  [SMALL_STATE(6163)] = 222716,
  [SMALL_STATE(6164)] = 222791,
  [SMALL_STATE(6165)] = 222860,
  [SMALL_STATE(6166)] = 222903,
  [SMALL_STATE(6167)] = 222946,
  [SMALL_STATE(6168)] = 223021,
  [SMALL_STATE(6169)] = 223064,
  [SMALL_STATE(6170)] = 223107,
  [SMALL_STATE(6171)] = 223150,
  [SMALL_STATE(6172)] = 223193,
  [SMALL_STATE(6173)] = 223268,
  [SMALL_STATE(6174)] = 223311,
  [SMALL_STATE(6175)] = 223354,
  [SMALL_STATE(6176)] = 223397,
  [SMALL_STATE(6177)] = 223466,
  [SMALL_STATE(6178)] = 223509,
  [SMALL_STATE(6179)] = 223582,
  [SMALL_STATE(6180)] = 223655,
  [SMALL_STATE(6181)] = 223724,
  [SMALL_STATE(6182)] = 223797,
  [SMALL_STATE(6183)] = 223840,
  [SMALL_STATE(6184)] = 223915,
  [SMALL_STATE(6185)] = 223990,
  [SMALL_STATE(6186)] = 224059,
  [SMALL_STATE(6187)] = 224132,
  [SMALL_STATE(6188)] = 224175,
  [SMALL_STATE(6189)] = 224250,
  [SMALL_STATE(6190)] = 224319,
  [SMALL_STATE(6191)] = 224392,
  [SMALL_STATE(6192)] = 224465,
  [SMALL_STATE(6193)] = 224538,
  [SMALL_STATE(6194)] = 224581,
  [SMALL_STATE(6195)] = 224624,
  [SMALL_STATE(6196)] = 224667,
  [SMALL_STATE(6197)] = 224736,
  [SMALL_STATE(6198)] = 224779,
  [SMALL_STATE(6199)] = 224822,
  [SMALL_STATE(6200)] = 224865,
  [SMALL_STATE(6201)] = 224940,
  [SMALL_STATE(6202)] = 225020,
  [SMALL_STATE(6203)] = 225100,
  [SMALL_STATE(6204)] = 225180,
  [SMALL_STATE(6205)] = 225260,
  [SMALL_STATE(6206)] = 225340,
  [SMALL_STATE(6207)] = 225420,
  [SMALL_STATE(6208)] = 225500,
  [SMALL_STATE(6209)] = 225580,
  [SMALL_STATE(6210)] = 225660,
  [SMALL_STATE(6211)] = 225740,
  [SMALL_STATE(6212)] = 225820,
  [SMALL_STATE(6213)] = 225900,
  [SMALL_STATE(6214)] = 225980,
  [SMALL_STATE(6215)] = 226060,
  [SMALL_STATE(6216)] = 226140,
  [SMALL_STATE(6217)] = 226220,
  [SMALL_STATE(6218)] = 226300,
  [SMALL_STATE(6219)] = 226342,
  [SMALL_STATE(6220)] = 226422,
  [SMALL_STATE(6221)] = 226496,
  [SMALL_STATE(6222)] = 226576,
  [SMALL_STATE(6223)] = 226656,
  [SMALL_STATE(6224)] = 226730,
  [SMALL_STATE(6225)] = 226804,
  [SMALL_STATE(6226)] = 226884,
  [SMALL_STATE(6227)] = 226964,
  [SMALL_STATE(6228)] = 227044,
  [SMALL_STATE(6229)] = 227124,
  [SMALL_STATE(6230)] = 227204,
  [SMALL_STATE(6231)] = 227284,
  [SMALL_STATE(6232)] = 227364,
  [SMALL_STATE(6233)] = 227444,
  [SMALL_STATE(6234)] = 227524,
  [SMALL_STATE(6235)] = 227604,
  [SMALL_STATE(6236)] = 227684,
  [SMALL_STATE(6237)] = 227764,
  [SMALL_STATE(6238)] = 227844,
  [SMALL_STATE(6239)] = 227924,
  [SMALL_STATE(6240)] = 228004,
  [SMALL_STATE(6241)] = 228084,
  [SMALL_STATE(6242)] = 228164,
  [SMALL_STATE(6243)] = 228244,
  [SMALL_STATE(6244)] = 228324,
  [SMALL_STATE(6245)] = 228404,
  [SMALL_STATE(6246)] = 228484,
  [SMALL_STATE(6247)] = 228564,
  [SMALL_STATE(6248)] = 228644,
  [SMALL_STATE(6249)] = 228718,
  [SMALL_STATE(6250)] = 228792,
  [SMALL_STATE(6251)] = 228872,
  [SMALL_STATE(6252)] = 228952,
  [SMALL_STATE(6253)] = 229032,
  [SMALL_STATE(6254)] = 229112,
  [SMALL_STATE(6255)] = 229192,
  [SMALL_STATE(6256)] = 229272,
  [SMALL_STATE(6257)] = 229352,
  [SMALL_STATE(6258)] = 229426,
  [SMALL_STATE(6259)] = 229506,
  [SMALL_STATE(6260)] = 229586,
  [SMALL_STATE(6261)] = 229666,
  [SMALL_STATE(6262)] = 229746,
  [SMALL_STATE(6263)] = 229826,
  [SMALL_STATE(6264)] = 229906,
  [SMALL_STATE(6265)] = 229986,
  [SMALL_STATE(6266)] = 230066,
  [SMALL_STATE(6267)] = 230146,
  [SMALL_STATE(6268)] = 230226,
  [SMALL_STATE(6269)] = 230300,
  [SMALL_STATE(6270)] = 230380,
  [SMALL_STATE(6271)] = 230460,
  [SMALL_STATE(6272)] = 230540,
  [SMALL_STATE(6273)] = 230620,
  [SMALL_STATE(6274)] = 230700,
  [SMALL_STATE(6275)] = 230780,
  [SMALL_STATE(6276)] = 230860,
  [SMALL_STATE(6277)] = 230940,
  [SMALL_STATE(6278)] = 231020,
  [SMALL_STATE(6279)] = 231100,
  [SMALL_STATE(6280)] = 231180,
  [SMALL_STATE(6281)] = 231222,
  [SMALL_STATE(6282)] = 231302,
  [SMALL_STATE(6283)] = 231382,
  [SMALL_STATE(6284)] = 231456,
  [SMALL_STATE(6285)] = 231536,
  [SMALL_STATE(6286)] = 231616,
  [SMALL_STATE(6287)] = 231696,
  [SMALL_STATE(6288)] = 231776,
  [SMALL_STATE(6289)] = 231818,
  [SMALL_STATE(6290)] = 231898,
  [SMALL_STATE(6291)] = 231940,
  [SMALL_STATE(6292)] = 232020,
  [SMALL_STATE(6293)] = 232100,
  [SMALL_STATE(6294)] = 232180,
  [SMALL_STATE(6295)] = 232260,
  [SMALL_STATE(6296)] = 232334,
  [SMALL_STATE(6297)] = 232414,
  [SMALL_STATE(6298)] = 232494,
  [SMALL_STATE(6299)] = 232574,
  [SMALL_STATE(6300)] = 232654,
  [SMALL_STATE(6301)] = 232734,
  [SMALL_STATE(6302)] = 232814,
  [SMALL_STATE(6303)] = 232894,
  [SMALL_STATE(6304)] = 232974,
  [SMALL_STATE(6305)] = 233054,
  [SMALL_STATE(6306)] = 233134,
  [SMALL_STATE(6307)] = 233214,
  [SMALL_STATE(6308)] = 233294,
  [SMALL_STATE(6309)] = 233374,
  [SMALL_STATE(6310)] = 233454,
  [SMALL_STATE(6311)] = 233534,
  [SMALL_STATE(6312)] = 233614,
  [SMALL_STATE(6313)] = 233694,
  [SMALL_STATE(6314)] = 233774,
  [SMALL_STATE(6315)] = 233848,
  [SMALL_STATE(6316)] = 233928,
  [SMALL_STATE(6317)] = 234008,
  [SMALL_STATE(6318)] = 234088,
  [SMALL_STATE(6319)] = 234168,
  [SMALL_STATE(6320)] = 234248,
  [SMALL_STATE(6321)] = 234328,
  [SMALL_STATE(6322)] = 234408,
  [SMALL_STATE(6323)] = 234488,
  [SMALL_STATE(6324)] = 234568,
  [SMALL_STATE(6325)] = 234648,
  [SMALL_STATE(6326)] = 234728,
  [SMALL_STATE(6327)] = 234808,
  [SMALL_STATE(6328)] = 234888,
  [SMALL_STATE(6329)] = 234968,
  [SMALL_STATE(6330)] = 235048,
  [SMALL_STATE(6331)] = 235128,
  [SMALL_STATE(6332)] = 235208,
  [SMALL_STATE(6333)] = 235288,
  [SMALL_STATE(6334)] = 235330,
  [SMALL_STATE(6335)] = 235404,
  [SMALL_STATE(6336)] = 235444,
  [SMALL_STATE(6337)] = 235524,
  [SMALL_STATE(6338)] = 235604,
  [SMALL_STATE(6339)] = 235684,
  [SMALL_STATE(6340)] = 235764,
  [SMALL_STATE(6341)] = 235844,
  [SMALL_STATE(6342)] = 235924,
  [SMALL_STATE(6343)] = 236004,
  [SMALL_STATE(6344)] = 236084,
  [SMALL_STATE(6345)] = 236158,
  [SMALL_STATE(6346)] = 236238,
  [SMALL_STATE(6347)] = 236318,
  [SMALL_STATE(6348)] = 236398,
  [SMALL_STATE(6349)] = 236478,
  [SMALL_STATE(6350)] = 236558,
  [SMALL_STATE(6351)] = 236625,
  [SMALL_STATE(6352)] = 236692,
  [SMALL_STATE(6353)] = 236731,
  [SMALL_STATE(6354)] = 236798,
  [SMALL_STATE(6355)] = 236865,
  [SMALL_STATE(6356)] = 236932,
  [SMALL_STATE(6357)] = 236999,
  [SMALL_STATE(6358)] = 237066,
  [SMALL_STATE(6359)] = 237133,
  [SMALL_STATE(6360)] = 237200,
  [SMALL_STATE(6361)] = 237277,
  [SMALL_STATE(6362)] = 237344,
  [SMALL_STATE(6363)] = 237411,
  [SMALL_STATE(6364)] = 237450,
  [SMALL_STATE(6365)] = 237517,
  [SMALL_STATE(6366)] = 237584,
  [SMALL_STATE(6367)] = 237651,
  [SMALL_STATE(6368)] = 237728,
  [SMALL_STATE(6369)] = 237767,
  [SMALL_STATE(6370)] = 237806,
  [SMALL_STATE(6371)] = 237883,
  [SMALL_STATE(6372)] = 237950,
  [SMALL_STATE(6373)] = 238027,
  [SMALL_STATE(6374)] = 238104,
  [SMALL_STATE(6375)] = 238143,
  [SMALL_STATE(6376)] = 238182,
  [SMALL_STATE(6377)] = 238249,
  [SMALL_STATE(6378)] = 238326,
  [SMALL_STATE(6379)] = 238393,
  [SMALL_STATE(6380)] = 238470,
  [SMALL_STATE(6381)] = 238537,
  [SMALL_STATE(6382)] = 238614,
  [SMALL_STATE(6383)] = 238691,
  [SMALL_STATE(6384)] = 238730,
  [SMALL_STATE(6385)] = 238797,
  [SMALL_STATE(6386)] = 238864,
  [SMALL_STATE(6387)] = 238931,
  [SMALL_STATE(6388)] = 238998,
  [SMALL_STATE(6389)] = 239065,
  [SMALL_STATE(6390)] = 239132,
  [SMALL_STATE(6391)] = 239199,
  [SMALL_STATE(6392)] = 239276,
  [SMALL_STATE(6393)] = 239315,
  [SMALL_STATE(6394)] = 239382,
  [SMALL_STATE(6395)] = 239449,
  [SMALL_STATE(6396)] = 239516,
  [SMALL_STATE(6397)] = 239583,
  [SMALL_STATE(6398)] = 239650,
  [SMALL_STATE(6399)] = 239689,
  [SMALL_STATE(6400)] = 239730,
  [SMALL_STATE(6401)] = 239797,
  [SMALL_STATE(6402)] = 239874,
  [SMALL_STATE(6403)] = 239941,
  [SMALL_STATE(6404)] = 240018,
  [SMALL_STATE(6405)] = 240085,
  [SMALL_STATE(6406)] = 240124,
  [SMALL_STATE(6407)] = 240163,
  [SMALL_STATE(6408)] = 240204,
  [SMALL_STATE(6409)] = 240281,
  [SMALL_STATE(6410)] = 240320,
  [SMALL_STATE(6411)] = 240359,
  [SMALL_STATE(6412)] = 240426,
  [SMALL_STATE(6413)] = 240493,
  [SMALL_STATE(6414)] = 240560,
  [SMALL_STATE(6415)] = 240599,
  [SMALL_STATE(6416)] = 240638,
  [SMALL_STATE(6417)] = 240715,
  [SMALL_STATE(6418)] = 240782,
  [SMALL_STATE(6419)] = 240849,
  [SMALL_STATE(6420)] = 240916,
  [SMALL_STATE(6421)] = 240983,
  [SMALL_STATE(6422)] = 241022,
  [SMALL_STATE(6423)] = 241089,
  [SMALL_STATE(6424)] = 241128,
  [SMALL_STATE(6425)] = 241195,
  [SMALL_STATE(6426)] = 241262,
  [SMALL_STATE(6427)] = 241329,
  [SMALL_STATE(6428)] = 241368,
  [SMALL_STATE(6429)] = 241435,
  [SMALL_STATE(6430)] = 241512,
  [SMALL_STATE(6431)] = 241589,
  [SMALL_STATE(6432)] = 241656,
  [SMALL_STATE(6433)] = 241733,
  [SMALL_STATE(6434)] = 241772,
  [SMALL_STATE(6435)] = 241849,
  [SMALL_STATE(6436)] = 241916,
  [SMALL_STATE(6437)] = 241955,
  [SMALL_STATE(6438)] = 242032,
  [SMALL_STATE(6439)] = 242071,
  [SMALL_STATE(6440)] = 242138,
  [SMALL_STATE(6441)] = 242177,
  [SMALL_STATE(6442)] = 242254,
  [SMALL_STATE(6443)] = 242293,
  [SMALL_STATE(6444)] = 242332,
  [SMALL_STATE(6445)] = 242371,
  [SMALL_STATE(6446)] = 242412,
  [SMALL_STATE(6447)] = 242479,
  [SMALL_STATE(6448)] = 242546,
  [SMALL_STATE(6449)] = 242585,
  [SMALL_STATE(6450)] = 242662,
  [SMALL_STATE(6451)] = 242701,
  [SMALL_STATE(6452)] = 242778,
  [SMALL_STATE(6453)] = 242845,
  [SMALL_STATE(6454)] = 242886,
  [SMALL_STATE(6455)] = 242953,
  [SMALL_STATE(6456)] = 242997,
  [SMALL_STATE(6457)] = 243063,
  [SMALL_STATE(6458)] = 243129,
  [SMALL_STATE(6459)] = 243173,
  [SMALL_STATE(6460)] = 243239,
  [SMALL_STATE(6461)] = 243305,
  [SMALL_STATE(6462)] = 243371,
  [SMALL_STATE(6463)] = 243437,
  [SMALL_STATE(6464)] = 243502,
  [SMALL_STATE(6465)] = 243567,
  [SMALL_STATE(6466)] = 243632,
  [SMALL_STATE(6467)] = 243697,
  [SMALL_STATE(6468)] = 243762,
  [SMALL_STATE(6469)] = 243827,
  [SMALL_STATE(6470)] = 243892,
  [SMALL_STATE(6471)] = 243957,
  [SMALL_STATE(6472)] = 244022,
  [SMALL_STATE(6473)] = 244087,
  [SMALL_STATE(6474)] = 244152,
  [SMALL_STATE(6475)] = 244217,
  [SMALL_STATE(6476)] = 244281,
  [SMALL_STATE(6477)] = 244345,
  [SMALL_STATE(6478)] = 244409,
  [SMALL_STATE(6479)] = 244459,
  [SMALL_STATE(6480)] = 244497,
  [SMALL_STATE(6481)] = 244547,
  [SMALL_STATE(6482)] = 244611,
  [SMALL_STATE(6483)] = 244675,
  [SMALL_STATE(6484)] = 244739,
  [SMALL_STATE(6485)] = 244803,
  [SMALL_STATE(6486)] = 244867,
  [SMALL_STATE(6487)] = 244925,
  [SMALL_STATE(6488)] = 244989,
  [SMALL_STATE(6489)] = 245047,
  [SMALL_STATE(6490)] = 245105,
  [SMALL_STATE(6491)] = 245169,
  [SMALL_STATE(6492)] = 245233,
  [SMALL_STATE(6493)] = 245291,
  [SMALL_STATE(6494)] = 245355,
  [SMALL_STATE(6495)] = 245418,
  [SMALL_STATE(6496)] = 245479,
  [SMALL_STATE(6497)] = 245542,
  [SMALL_STATE(6498)] = 245605,
  [SMALL_STATE(6499)] = 245668,
  [SMALL_STATE(6500)] = 245731,
  [SMALL_STATE(6501)] = 245794,
  [SMALL_STATE(6502)] = 245855,
  [SMALL_STATE(6503)] = 245916,
  [SMALL_STATE(6504)] = 245977,
  [SMALL_STATE(6505)] = 246040,
  [SMALL_STATE(6506)] = 246103,
  [SMALL_STATE(6507)] = 246166,
  [SMALL_STATE(6508)] = 246227,
  [SMALL_STATE(6509)] = 246290,
  [SMALL_STATE(6510)] = 246353,
  [SMALL_STATE(6511)] = 246414,
  [SMALL_STATE(6512)] = 246477,
  [SMALL_STATE(6513)] = 246540,
  [SMALL_STATE(6514)] = 246603,
  [SMALL_STATE(6515)] = 246666,
  [SMALL_STATE(6516)] = 246715,
  [SMALL_STATE(6517)] = 246776,
  [SMALL_STATE(6518)] = 246839,
  [SMALL_STATE(6519)] = 246902,
  [SMALL_STATE(6520)] = 246965,
  [SMALL_STATE(6521)] = 247013,
  [SMALL_STATE(6522)] = 247067,
  [SMALL_STATE(6523)] = 247138,
  [SMALL_STATE(6524)] = 247209,
  [SMALL_STATE(6525)] = 247280,
  [SMALL_STATE(6526)] = 247311,
  [SMALL_STATE(6527)] = 247357,
  [SMALL_STATE(6528)] = 247409,
  [SMALL_STATE(6529)] = 247461,
  [SMALL_STATE(6530)] = 247513,
  [SMALL_STATE(6531)] = 247565,
  [SMALL_STATE(6532)] = 247617,
  [SMALL_STATE(6533)] = 247669,
  [SMALL_STATE(6534)] = 247721,
  [SMALL_STATE(6535)] = 247767,
  [SMALL_STATE(6536)] = 247813,
  [SMALL_STATE(6537)] = 247859,
  [SMALL_STATE(6538)] = 247911,
  [SMALL_STATE(6539)] = 247963,
  [SMALL_STATE(6540)] = 248007,
  [SMALL_STATE(6541)] = 248059,
  [SMALL_STATE(6542)] = 248129,
  [SMALL_STATE(6543)] = 248181,
  [SMALL_STATE(6544)] = 248233,
  [SMALL_STATE(6545)] = 248279,
  [SMALL_STATE(6546)] = 248325,
  [SMALL_STATE(6547)] = 248369,
  [SMALL_STATE(6548)] = 248421,
  [SMALL_STATE(6549)] = 248467,
  [SMALL_STATE(6550)] = 248511,
  [SMALL_STATE(6551)] = 248563,
  [SMALL_STATE(6552)] = 248597,
  [SMALL_STATE(6553)] = 248641,
  [SMALL_STATE(6554)] = 248693,
  [SMALL_STATE(6555)] = 248763,
  [SMALL_STATE(6556)] = 248809,
  [SMALL_STATE(6557)] = 248861,
  [SMALL_STATE(6558)] = 248913,
  [SMALL_STATE(6559)] = 248983,
  [SMALL_STATE(6560)] = 249035,
  [SMALL_STATE(6561)] = 249087,
  [SMALL_STATE(6562)] = 249139,
  [SMALL_STATE(6563)] = 249191,
  [SMALL_STATE(6564)] = 249237,
  [SMALL_STATE(6565)] = 249289,
  [SMALL_STATE(6566)] = 249341,
  [SMALL_STATE(6567)] = 249387,
  [SMALL_STATE(6568)] = 249425,
  [SMALL_STATE(6569)] = 249477,
  [SMALL_STATE(6570)] = 249529,
  [SMALL_STATE(6571)] = 249575,
  [SMALL_STATE(6572)] = 249619,
  [SMALL_STATE(6573)] = 249689,
  [SMALL_STATE(6574)] = 249733,
  [SMALL_STATE(6575)] = 249777,
  [SMALL_STATE(6576)] = 249821,
  [SMALL_STATE(6577)] = 249873,
  [SMALL_STATE(6578)] = 249911,
  [SMALL_STATE(6579)] = 249981,
  [SMALL_STATE(6580)] = 250033,
  [SMALL_STATE(6581)] = 250085,
  [SMALL_STATE(6582)] = 250137,
  [SMALL_STATE(6583)] = 250189,
  [SMALL_STATE(6584)] = 250241,
  [SMALL_STATE(6585)] = 250293,
  [SMALL_STATE(6586)] = 250345,
  [SMALL_STATE(6587)] = 250397,
  [SMALL_STATE(6588)] = 250449,
  [SMALL_STATE(6589)] = 250501,
  [SMALL_STATE(6590)] = 250553,
  [SMALL_STATE(6591)] = 250605,
  [SMALL_STATE(6592)] = 250657,
  [SMALL_STATE(6593)] = 250709,
  [SMALL_STATE(6594)] = 250761,
  [SMALL_STATE(6595)] = 250804,
  [SMALL_STATE(6596)] = 250863,
  [SMALL_STATE(6597)] = 250922,
  [SMALL_STATE(6598)] = 250967,
  [SMALL_STATE(6599)] = 251026,
  [SMALL_STATE(6600)] = 251085,
  [SMALL_STATE(6601)] = 251144,
  [SMALL_STATE(6602)] = 251203,
  [SMALL_STATE(6603)] = 251262,
  [SMALL_STATE(6604)] = 251321,
  [SMALL_STATE(6605)] = 251380,
  [SMALL_STATE(6606)] = 251425,
  [SMALL_STATE(6607)] = 251470,
  [SMALL_STATE(6608)] = 251529,
  [SMALL_STATE(6609)] = 251588,
  [SMALL_STATE(6610)] = 251647,
  [SMALL_STATE(6611)] = 251706,
  [SMALL_STATE(6612)] = 251765,
  [SMALL_STATE(6613)] = 251810,
  [SMALL_STATE(6614)] = 251855,
  [SMALL_STATE(6615)] = 251914,
  [SMALL_STATE(6616)] = 251973,
  [SMALL_STATE(6617)] = 252032,
  [SMALL_STATE(6618)] = 252061,
  [SMALL_STATE(6619)] = 252120,
  [SMALL_STATE(6620)] = 252179,
  [SMALL_STATE(6621)] = 252238,
  [SMALL_STATE(6622)] = 252297,
  [SMALL_STATE(6623)] = 252356,
  [SMALL_STATE(6624)] = 252415,
  [SMALL_STATE(6625)] = 252474,
  [SMALL_STATE(6626)] = 252533,
  [SMALL_STATE(6627)] = 252592,
  [SMALL_STATE(6628)] = 252651,
  [SMALL_STATE(6629)] = 252710,
  [SMALL_STATE(6630)] = 252769,
  [SMALL_STATE(6631)] = 252828,
  [SMALL_STATE(6632)] = 252857,
  [SMALL_STATE(6633)] = 252916,
  [SMALL_STATE(6634)] = 252975,
  [SMALL_STATE(6635)] = 253034,
  [SMALL_STATE(6636)] = 253093,
  [SMALL_STATE(6637)] = 253152,
  [SMALL_STATE(6638)] = 253211,
  [SMALL_STATE(6639)] = 253270,
  [SMALL_STATE(6640)] = 253329,
  [SMALL_STATE(6641)] = 253374,
  [SMALL_STATE(6642)] = 253433,
  [SMALL_STATE(6643)] = 253466,
  [SMALL_STATE(6644)] = 253529,
  [SMALL_STATE(6645)] = 253588,
  [SMALL_STATE(6646)] = 253631,
  [SMALL_STATE(6647)] = 253690,
  [SMALL_STATE(6648)] = 253749,
  [SMALL_STATE(6649)] = 253808,
  [SMALL_STATE(6650)] = 253867,
  [SMALL_STATE(6651)] = 253922,
  [SMALL_STATE(6652)] = 253981,
  [SMALL_STATE(6653)] = 254040,
  [SMALL_STATE(6654)] = 254099,
  [SMALL_STATE(6655)] = 254158,
  [SMALL_STATE(6656)] = 254217,
  [SMALL_STATE(6657)] = 254276,
  [SMALL_STATE(6658)] = 254335,
  [SMALL_STATE(6659)] = 254364,
  [SMALL_STATE(6660)] = 254423,
  [SMALL_STATE(6661)] = 254456,
  [SMALL_STATE(6662)] = 254515,
  [SMALL_STATE(6663)] = 254574,
  [SMALL_STATE(6664)] = 254633,
  [SMALL_STATE(6665)] = 254692,
  [SMALL_STATE(6666)] = 254751,
  [SMALL_STATE(6667)] = 254796,
  [SMALL_STATE(6668)] = 254855,
  [SMALL_STATE(6669)] = 254914,
  [SMALL_STATE(6670)] = 254973,
  [SMALL_STATE(6671)] = 255032,
  [SMALL_STATE(6672)] = 255091,
  [SMALL_STATE(6673)] = 255124,
  [SMALL_STATE(6674)] = 255183,
  [SMALL_STATE(6675)] = 255238,
  [SMALL_STATE(6676)] = 255297,
  [SMALL_STATE(6677)] = 255328,
  [SMALL_STATE(6678)] = 255387,
  [SMALL_STATE(6679)] = 255446,
  [SMALL_STATE(6680)] = 255505,
  [SMALL_STATE(6681)] = 255550,
  [SMALL_STATE(6682)] = 255609,
  [SMALL_STATE(6683)] = 255668,
  [SMALL_STATE(6684)] = 255727,
  [SMALL_STATE(6685)] = 255786,
  [SMALL_STATE(6686)] = 255845,
  [SMALL_STATE(6687)] = 255904,
  [SMALL_STATE(6688)] = 255963,
  [SMALL_STATE(6689)] = 256022,
  [SMALL_STATE(6690)] = 256069,
  [SMALL_STATE(6691)] = 256128,
  [SMALL_STATE(6692)] = 256161,
  [SMALL_STATE(6693)] = 256220,
  [SMALL_STATE(6694)] = 256279,
  [SMALL_STATE(6695)] = 256308,
  [SMALL_STATE(6696)] = 256367,
  [SMALL_STATE(6697)] = 256426,
  [SMALL_STATE(6698)] = 256469,
  [SMALL_STATE(6699)] = 256528,
  [SMALL_STATE(6700)] = 256557,
  [SMALL_STATE(6701)] = 256616,
  [SMALL_STATE(6702)] = 256661,
  [SMALL_STATE(6703)] = 256720,
  [SMALL_STATE(6704)] = 256779,
  [SMALL_STATE(6705)] = 256838,
  [SMALL_STATE(6706)] = 256897,
  [SMALL_STATE(6707)] = 256956,
  [SMALL_STATE(6708)] = 257015,
  [SMALL_STATE(6709)] = 257074,
  [SMALL_STATE(6710)] = 257133,
  [SMALL_STATE(6711)] = 257192,
  [SMALL_STATE(6712)] = 257251,
  [SMALL_STATE(6713)] = 257310,
  [SMALL_STATE(6714)] = 257369,
  [SMALL_STATE(6715)] = 257428,
  [SMALL_STATE(6716)] = 257487,
  [SMALL_STATE(6717)] = 257546,
  [SMALL_STATE(6718)] = 257605,
  [SMALL_STATE(6719)] = 257664,
  [SMALL_STATE(6720)] = 257719,
  [SMALL_STATE(6721)] = 257778,
  [SMALL_STATE(6722)] = 257837,
  [SMALL_STATE(6723)] = 257896,
  [SMALL_STATE(6724)] = 257955,
  [SMALL_STATE(6725)] = 258014,
  [SMALL_STATE(6726)] = 258073,
  [SMALL_STATE(6727)] = 258132,
  [SMALL_STATE(6728)] = 258177,
  [SMALL_STATE(6729)] = 258236,
  [SMALL_STATE(6730)] = 258295,
  [SMALL_STATE(6731)] = 258328,
  [SMALL_STATE(6732)] = 258387,
  [SMALL_STATE(6733)] = 258446,
  [SMALL_STATE(6734)] = 258474,
  [SMALL_STATE(6735)] = 258538,
  [SMALL_STATE(6736)] = 258582,
  [SMALL_STATE(6737)] = 258610,
  [SMALL_STATE(6738)] = 258642,
  [SMALL_STATE(6739)] = 258686,
  [SMALL_STATE(6740)] = 258726,
  [SMALL_STATE(6741)] = 258754,
  [SMALL_STATE(6742)] = 258782,
  [SMALL_STATE(6743)] = 258832,
  [SMALL_STATE(6744)] = 258872,
  [SMALL_STATE(6745)] = 258912,
  [SMALL_STATE(6746)] = 258952,
  [SMALL_STATE(6747)] = 258992,
  [SMALL_STATE(6748)] = 259032,
  [SMALL_STATE(6749)] = 259072,
  [SMALL_STATE(6750)] = 259116,
  [SMALL_STATE(6751)] = 259156,
  [SMALL_STATE(6752)] = 259196,
  [SMALL_STATE(6753)] = 259236,
  [SMALL_STATE(6754)] = 259280,
  [SMALL_STATE(6755)] = 259330,
  [SMALL_STATE(6756)] = 259370,
  [SMALL_STATE(6757)] = 259420,
  [SMALL_STATE(6758)] = 259460,
  [SMALL_STATE(6759)] = 259488,
  [SMALL_STATE(6760)] = 259516,
  [SMALL_STATE(6761)] = 259566,
  [SMALL_STATE(6762)] = 259616,
  [SMALL_STATE(6763)] = 259666,
  [SMALL_STATE(6764)] = 259716,
  [SMALL_STATE(6765)] = 259768,
  [SMALL_STATE(6766)] = 259832,
  [SMALL_STATE(6767)] = 259872,
  [SMALL_STATE(6768)] = 259900,
  [SMALL_STATE(6769)] = 259940,
  [SMALL_STATE(6770)] = 259968,
  [SMALL_STATE(6771)] = 260018,
  [SMALL_STATE(6772)] = 260046,
  [SMALL_STATE(6773)] = 260074,
  [SMALL_STATE(6774)] = 260118,
  [SMALL_STATE(6775)] = 260158,
  [SMALL_STATE(6776)] = 260198,
  [SMALL_STATE(6777)] = 260238,
  [SMALL_STATE(6778)] = 260282,
  [SMALL_STATE(6779)] = 260346,
  [SMALL_STATE(6780)] = 260386,
  [SMALL_STATE(6781)] = 260426,
  [SMALL_STATE(6782)] = 260466,
  [SMALL_STATE(6783)] = 260516,
  [SMALL_STATE(6784)] = 260552,
  [SMALL_STATE(6785)] = 260592,
  [SMALL_STATE(6786)] = 260632,
  [SMALL_STATE(6787)] = 260696,
  [SMALL_STATE(6788)] = 260732,
  [SMALL_STATE(6789)] = 260760,
  [SMALL_STATE(6790)] = 260788,
  [SMALL_STATE(6791)] = 260828,
  [SMALL_STATE(6792)] = 260868,
  [SMALL_STATE(6793)] = 260912,
  [SMALL_STATE(6794)] = 260962,
  [SMALL_STATE(6795)] = 261008,
  [SMALL_STATE(6796)] = 261058,
  [SMALL_STATE(6797)] = 261122,
  [SMALL_STATE(6798)] = 261162,
  [SMALL_STATE(6799)] = 261202,
  [SMALL_STATE(6800)] = 261246,
  [SMALL_STATE(6801)] = 261286,
  [SMALL_STATE(6802)] = 261336,
  [SMALL_STATE(6803)] = 261364,
  [SMALL_STATE(6804)] = 261408,
  [SMALL_STATE(6805)] = 261436,
  [SMALL_STATE(6806)] = 261476,
  [SMALL_STATE(6807)] = 261504,
  [SMALL_STATE(6808)] = 261548,
  [SMALL_STATE(6809)] = 261576,
  [SMALL_STATE(6810)] = 261604,
  [SMALL_STATE(6811)] = 261634,
  [SMALL_STATE(6812)] = 261686,
  [SMALL_STATE(6813)] = 261736,
  [SMALL_STATE(6814)] = 261776,
  [SMALL_STATE(6815)] = 261816,
  [SMALL_STATE(6816)] = 261860,
  [SMALL_STATE(6817)] = 261910,
  [SMALL_STATE(6818)] = 261948,
  [SMALL_STATE(6819)] = 261988,
  [SMALL_STATE(6820)] = 262028,
  [SMALL_STATE(6821)] = 262078,
  [SMALL_STATE(6822)] = 262142,
  [SMALL_STATE(6823)] = 262180,
  [SMALL_STATE(6824)] = 262218,
  [SMALL_STATE(6825)] = 262258,
  [SMALL_STATE(6826)] = 262296,
  [SMALL_STATE(6827)] = 262336,
  [SMALL_STATE(6828)] = 262376,
  [SMALL_STATE(6829)] = 262404,
  [SMALL_STATE(6830)] = 262468,
  [SMALL_STATE(6831)] = 262532,
  [SMALL_STATE(6832)] = 262560,
  [SMALL_STATE(6833)] = 262600,
  [SMALL_STATE(6834)] = 262640,
  [SMALL_STATE(6835)] = 262680,
  [SMALL_STATE(6836)] = 262718,
  [SMALL_STATE(6837)] = 262756,
  [SMALL_STATE(6838)] = 262820,
  [SMALL_STATE(6839)] = 262848,
  [SMALL_STATE(6840)] = 262886,
  [SMALL_STATE(6841)] = 262926,
  [SMALL_STATE(6842)] = 262964,
  [SMALL_STATE(6843)] = 262992,
  [SMALL_STATE(6844)] = 263036,
  [SMALL_STATE(6845)] = 263064,
  [SMALL_STATE(6846)] = 263104,
  [SMALL_STATE(6847)] = 263132,
  [SMALL_STATE(6848)] = 263172,
  [SMALL_STATE(6849)] = 263200,
  [SMALL_STATE(6850)] = 263228,
  [SMALL_STATE(6851)] = 263266,
  [SMALL_STATE(6852)] = 263330,
  [SMALL_STATE(6853)] = 263358,
  [SMALL_STATE(6854)] = 263386,
  [SMALL_STATE(6855)] = 263414,
  [SMALL_STATE(6856)] = 263442,
  [SMALL_STATE(6857)] = 263470,
  [SMALL_STATE(6858)] = 263498,
  [SMALL_STATE(6859)] = 263536,
  [SMALL_STATE(6860)] = 263576,
  [SMALL_STATE(6861)] = 263640,
  [SMALL_STATE(6862)] = 263668,
  [SMALL_STATE(6863)] = 263696,
  [SMALL_STATE(6864)] = 263728,
  [SMALL_STATE(6865)] = 263768,
  [SMALL_STATE(6866)] = 263796,
  [SMALL_STATE(6867)] = 263824,
  [SMALL_STATE(6868)] = 263888,
  [SMALL_STATE(6869)] = 263916,
  [SMALL_STATE(6870)] = 263944,
  [SMALL_STATE(6871)] = 263972,
  [SMALL_STATE(6872)] = 264022,
  [SMALL_STATE(6873)] = 264050,
  [SMALL_STATE(6874)] = 264078,
  [SMALL_STATE(6875)] = 264128,
  [SMALL_STATE(6876)] = 264178,
  [SMALL_STATE(6877)] = 264226,
  [SMALL_STATE(6878)] = 264276,
  [SMALL_STATE(6879)] = 264322,
  [SMALL_STATE(6880)] = 264386,
  [SMALL_STATE(6881)] = 264426,
  [SMALL_STATE(6882)] = 264478,
  [SMALL_STATE(6883)] = 264518,
  [SMALL_STATE(6884)] = 264558,
  [SMALL_STATE(6885)] = 264586,
  [SMALL_STATE(6886)] = 264626,
  [SMALL_STATE(6887)] = 264654,
  [SMALL_STATE(6888)] = 264694,
  [SMALL_STATE(6889)] = 264734,
  [SMALL_STATE(6890)] = 264768,
  [SMALL_STATE(6891)] = 264804,
  [SMALL_STATE(6892)] = 264848,
  [SMALL_STATE(6893)] = 264890,
  [SMALL_STATE(6894)] = 264930,
  [SMALL_STATE(6895)] = 264958,
  [SMALL_STATE(6896)] = 264986,
  [SMALL_STATE(6897)] = 265013,
  [SMALL_STATE(6898)] = 265050,
  [SMALL_STATE(6899)] = 265097,
  [SMALL_STATE(6900)] = 265152,
  [SMALL_STATE(6901)] = 265197,
  [SMALL_STATE(6902)] = 265254,
  [SMALL_STATE(6903)] = 265311,
  [SMALL_STATE(6904)] = 265350,
  [SMALL_STATE(6905)] = 265395,
  [SMALL_STATE(6906)] = 265450,
  [SMALL_STATE(6907)] = 265489,
  [SMALL_STATE(6908)] = 265538,
  [SMALL_STATE(6909)] = 265583,
  [SMALL_STATE(6910)] = 265610,
  [SMALL_STATE(6911)] = 265653,
  [SMALL_STATE(6912)] = 265692,
  [SMALL_STATE(6913)] = 265721,
  [SMALL_STATE(6914)] = 265760,
  [SMALL_STATE(6915)] = 265807,
  [SMALL_STATE(6916)] = 265846,
  [SMALL_STATE(6917)] = 265891,
  [SMALL_STATE(6918)] = 265938,
  [SMALL_STATE(6919)] = 265971,
  [SMALL_STATE(6920)] = 266018,
  [SMALL_STATE(6921)] = 266045,
  [SMALL_STATE(6922)] = 266090,
  [SMALL_STATE(6923)] = 266135,
  [SMALL_STATE(6924)] = 266178,
  [SMALL_STATE(6925)] = 266225,
  [SMALL_STATE(6926)] = 266274,
  [SMALL_STATE(6927)] = 266331,
  [SMALL_STATE(6928)] = 266378,
  [SMALL_STATE(6929)] = 266423,
  [SMALL_STATE(6930)] = 266464,
  [SMALL_STATE(6931)] = 266509,
  [SMALL_STATE(6932)] = 266554,
  [SMALL_STATE(6933)] = 266609,
  [SMALL_STATE(6934)] = 266664,
  [SMALL_STATE(6935)] = 266691,
  [SMALL_STATE(6936)] = 266730,
  [SMALL_STATE(6937)] = 266777,
  [SMALL_STATE(6938)] = 266804,
  [SMALL_STATE(6939)] = 266859,
  [SMALL_STATE(6940)] = 266898,
  [SMALL_STATE(6941)] = 266937,
  [SMALL_STATE(6942)] = 266984,
  [SMALL_STATE(6943)] = 267023,
  [SMALL_STATE(6944)] = 267050,
  [SMALL_STATE(6945)] = 267077,
  [SMALL_STATE(6946)] = 267112,
  [SMALL_STATE(6947)] = 267139,
  [SMALL_STATE(6948)] = 267186,
  [SMALL_STATE(6949)] = 267231,
  [SMALL_STATE(6950)] = 267276,
  [SMALL_STATE(6951)] = 267303,
  [SMALL_STATE(6952)] = 267342,
  [SMALL_STATE(6953)] = 267399,
  [SMALL_STATE(6954)] = 267444,
  [SMALL_STATE(6955)] = 267501,
  [SMALL_STATE(6956)] = 267528,
  [SMALL_STATE(6957)] = 267557,
  [SMALL_STATE(6958)] = 267602,
  [SMALL_STATE(6959)] = 267633,
  [SMALL_STATE(6960)] = 267660,
  [SMALL_STATE(6961)] = 267705,
  [SMALL_STATE(6962)] = 267762,
  [SMALL_STATE(6963)] = 267807,
  [SMALL_STATE(6964)] = 267854,
  [SMALL_STATE(6965)] = 267899,
  [SMALL_STATE(6966)] = 267926,
  [SMALL_STATE(6967)] = 267965,
  [SMALL_STATE(6968)] = 268012,
  [SMALL_STATE(6969)] = 268059,
  [SMALL_STATE(6970)] = 268086,
  [SMALL_STATE(6971)] = 268133,
  [SMALL_STATE(6972)] = 268188,
  [SMALL_STATE(6973)] = 268226,
  [SMALL_STATE(6974)] = 268256,
  [SMALL_STATE(6975)] = 268286,
  [SMALL_STATE(6976)] = 268334,
  [SMALL_STATE(6977)] = 268374,
  [SMALL_STATE(6978)] = 268412,
  [SMALL_STATE(6979)] = 268450,
  [SMALL_STATE(6980)] = 268490,
  [SMALL_STATE(6981)] = 268520,
  [SMALL_STATE(6982)] = 268558,
  [SMALL_STATE(6983)] = 268588,
  [SMALL_STATE(6984)] = 268628,
  [SMALL_STATE(6985)] = 268666,
  [SMALL_STATE(6986)] = 268696,
  [SMALL_STATE(6987)] = 268738,
  [SMALL_STATE(6988)] = 268768,
  [SMALL_STATE(6989)] = 268798,
  [SMALL_STATE(6990)] = 268838,
  [SMALL_STATE(6991)] = 268886,
  [SMALL_STATE(6992)] = 268934,
  [SMALL_STATE(6993)] = 268972,
  [SMALL_STATE(6994)] = 269012,
  [SMALL_STATE(6995)] = 269050,
  [SMALL_STATE(6996)] = 269080,
  [SMALL_STATE(6997)] = 269110,
  [SMALL_STATE(6998)] = 269148,
  [SMALL_STATE(6999)] = 269186,
  [SMALL_STATE(7000)] = 269226,
  [SMALL_STATE(7001)] = 269256,
  [SMALL_STATE(7002)] = 269286,
  [SMALL_STATE(7003)] = 269324,
  [SMALL_STATE(7004)] = 269372,
  [SMALL_STATE(7005)] = 269402,
  [SMALL_STATE(7006)] = 269432,
  [SMALL_STATE(7007)] = 269472,
  [SMALL_STATE(7008)] = 269512,
  [SMALL_STATE(7009)] = 269543,
  [SMALL_STATE(7010)] = 269592,
  [SMALL_STATE(7011)] = 269623,
  [SMALL_STATE(7012)] = 269664,
  [SMALL_STATE(7013)] = 269699,
  [SMALL_STATE(7014)] = 269748,
  [SMALL_STATE(7015)] = 269797,
  [SMALL_STATE(7016)] = 269832,
  [SMALL_STATE(7017)] = 269871,
  [SMALL_STATE(7018)] = 269920,
  [SMALL_STATE(7019)] = 269963,
  [SMALL_STATE(7020)] = 270012,
  [SMALL_STATE(7021)] = 270043,
  [SMALL_STATE(7022)] = 270072,
  [SMALL_STATE(7023)] = 270103,
  [SMALL_STATE(7024)] = 270130,
  [SMALL_STATE(7025)] = 270179,
  [SMALL_STATE(7026)] = 270204,
  [SMALL_STATE(7027)] = 270253,
  [SMALL_STATE(7028)] = 270302,
  [SMALL_STATE(7029)] = 270329,
  [SMALL_STATE(7030)] = 270378,
  [SMALL_STATE(7031)] = 270409,
  [SMALL_STATE(7032)] = 270442,
  [SMALL_STATE(7033)] = 270473,
  [SMALL_STATE(7034)] = 270506,
  [SMALL_STATE(7035)] = 270555,
  [SMALL_STATE(7036)] = 270596,
  [SMALL_STATE(7037)] = 270627,
  [SMALL_STATE(7038)] = 270676,
  [SMALL_STATE(7039)] = 270715,
  [SMALL_STATE(7040)] = 270764,
  [SMALL_STATE(7041)] = 270795,
  [SMALL_STATE(7042)] = 270844,
  [SMALL_STATE(7043)] = 270875,
  [SMALL_STATE(7044)] = 270924,
  [SMALL_STATE(7045)] = 270973,
  [SMALL_STATE(7046)] = 271012,
  [SMALL_STATE(7047)] = 271053,
  [SMALL_STATE(7048)] = 271094,
  [SMALL_STATE(7049)] = 271133,
  [SMALL_STATE(7050)] = 271164,
  [SMALL_STATE(7051)] = 271213,
  [SMALL_STATE(7052)] = 271262,
  [SMALL_STATE(7053)] = 271311,
  [SMALL_STATE(7054)] = 271350,
  [SMALL_STATE(7055)] = 271389,
  [SMALL_STATE(7056)] = 271414,
  [SMALL_STATE(7057)] = 271455,
  [SMALL_STATE(7058)] = 271504,
  [SMALL_STATE(7059)] = 271545,
  [SMALL_STATE(7060)] = 271586,
  [SMALL_STATE(7061)] = 271635,
  [SMALL_STATE(7062)] = 271678,
  [SMALL_STATE(7063)] = 271727,
  [SMALL_STATE(7064)] = 271768,
  [SMALL_STATE(7065)] = 271817,
  [SMALL_STATE(7066)] = 271850,
  [SMALL_STATE(7067)] = 271899,
  [SMALL_STATE(7068)] = 271942,
  [SMALL_STATE(7069)] = 271981,
  [SMALL_STATE(7070)] = 272010,
  [SMALL_STATE(7071)] = 272051,
  [SMALL_STATE(7072)] = 272082,
  [SMALL_STATE(7073)] = 272123,
  [SMALL_STATE(7074)] = 272154,
  [SMALL_STATE(7075)] = 272185,
  [SMALL_STATE(7076)] = 272216,
  [SMALL_STATE(7077)] = 272265,
  [SMALL_STATE(7078)] = 272296,
  [SMALL_STATE(7079)] = 272327,
  [SMALL_STATE(7080)] = 272358,
  [SMALL_STATE(7081)] = 272389,
  [SMALL_STATE(7082)] = 272420,
  [SMALL_STATE(7083)] = 272469,
  [SMALL_STATE(7084)] = 272518,
  [SMALL_STATE(7085)] = 272561,
  [SMALL_STATE(7086)] = 272600,
  [SMALL_STATE(7087)] = 272640,
  [SMALL_STATE(7088)] = 272680,
  [SMALL_STATE(7089)] = 272704,
  [SMALL_STATE(7090)] = 272728,
  [SMALL_STATE(7091)] = 272778,
  [SMALL_STATE(7092)] = 272806,
  [SMALL_STATE(7093)] = 272830,
  [SMALL_STATE(7094)] = 272868,
  [SMALL_STATE(7095)] = 272908,
  [SMALL_STATE(7096)] = 272946,
  [SMALL_STATE(7097)] = 272986,
  [SMALL_STATE(7098)] = 273010,
  [SMALL_STATE(7099)] = 273050,
  [SMALL_STATE(7100)] = 273090,
  [SMALL_STATE(7101)] = 273114,
  [SMALL_STATE(7102)] = 273138,
  [SMALL_STATE(7103)] = 273178,
  [SMALL_STATE(7104)] = 273204,
  [SMALL_STATE(7105)] = 273230,
  [SMALL_STATE(7106)] = 273256,
  [SMALL_STATE(7107)] = 273282,
  [SMALL_STATE(7108)] = 273308,
  [SMALL_STATE(7109)] = 273334,
  [SMALL_STATE(7110)] = 273360,
  [SMALL_STATE(7111)] = 273394,
  [SMALL_STATE(7112)] = 273444,
  [SMALL_STATE(7113)] = 273478,
  [SMALL_STATE(7114)] = 273518,
  [SMALL_STATE(7115)] = 273542,
  [SMALL_STATE(7116)] = 273582,
  [SMALL_STATE(7117)] = 273632,
  [SMALL_STATE(7118)] = 273660,
  [SMALL_STATE(7119)] = 273702,
  [SMALL_STATE(7120)] = 273742,
  [SMALL_STATE(7121)] = 273770,
  [SMALL_STATE(7122)] = 273804,
  [SMALL_STATE(7123)] = 273844,
  [SMALL_STATE(7124)] = 273884,
  [SMALL_STATE(7125)] = 273924,
  [SMALL_STATE(7126)] = 273952,
  [SMALL_STATE(7127)] = 273976,
  [SMALL_STATE(7128)] = 274000,
  [SMALL_STATE(7129)] = 274024,
  [SMALL_STATE(7130)] = 274064,
  [SMALL_STATE(7131)] = 274104,
  [SMALL_STATE(7132)] = 274142,
  [SMALL_STATE(7133)] = 274180,
  [SMALL_STATE(7134)] = 274204,
  [SMALL_STATE(7135)] = 274242,
  [SMALL_STATE(7136)] = 274266,
  [SMALL_STATE(7137)] = 274290,
  [SMALL_STATE(7138)] = 274340,
  [SMALL_STATE(7139)] = 274364,
  [SMALL_STATE(7140)] = 274388,
  [SMALL_STATE(7141)] = 274412,
  [SMALL_STATE(7142)] = 274446,
  [SMALL_STATE(7143)] = 274470,
  [SMALL_STATE(7144)] = 274508,
  [SMALL_STATE(7145)] = 274536,
  [SMALL_STATE(7146)] = 274560,
  [SMALL_STATE(7147)] = 274584,
  [SMALL_STATE(7148)] = 274624,
  [SMALL_STATE(7149)] = 274648,
  [SMALL_STATE(7150)] = 274682,
  [SMALL_STATE(7151)] = 274732,
  [SMALL_STATE(7152)] = 274756,
  [SMALL_STATE(7153)] = 274780,
  [SMALL_STATE(7154)] = 274804,
  [SMALL_STATE(7155)] = 274832,
  [SMALL_STATE(7156)] = 274866,
  [SMALL_STATE(7157)] = 274900,
  [SMALL_STATE(7158)] = 274930,
  [SMALL_STATE(7159)] = 274970,
  [SMALL_STATE(7160)] = 275010,
  [SMALL_STATE(7161)] = 275048,
  [SMALL_STATE(7162)] = 275072,
  [SMALL_STATE(7163)] = 275110,
  [SMALL_STATE(7164)] = 275148,
  [SMALL_STATE(7165)] = 275186,
  [SMALL_STATE(7166)] = 275210,
  [SMALL_STATE(7167)] = 275260,
  [SMALL_STATE(7168)] = 275284,
  [SMALL_STATE(7169)] = 275308,
  [SMALL_STATE(7170)] = 275336,
  [SMALL_STATE(7171)] = 275360,
  [SMALL_STATE(7172)] = 275384,
  [SMALL_STATE(7173)] = 275408,
  [SMALL_STATE(7174)] = 275442,
  [SMALL_STATE(7175)] = 275482,
  [SMALL_STATE(7176)] = 275506,
  [SMALL_STATE(7177)] = 275540,
  [SMALL_STATE(7178)] = 275578,
  [SMALL_STATE(7179)] = 275618,
  [SMALL_STATE(7180)] = 275644,
  [SMALL_STATE(7181)] = 275668,
  [SMALL_STATE(7182)] = 275696,
  [SMALL_STATE(7183)] = 275722,
  [SMALL_STATE(7184)] = 275756,
  [SMALL_STATE(7185)] = 275782,
  [SMALL_STATE(7186)] = 275822,
  [SMALL_STATE(7187)] = 275848,
  [SMALL_STATE(7188)] = 275872,
  [SMALL_STATE(7189)] = 275898,
  [SMALL_STATE(7190)] = 275922,
  [SMALL_STATE(7191)] = 275962,
  [SMALL_STATE(7192)] = 275988,
  [SMALL_STATE(7193)] = 276016,
  [SMALL_STATE(7194)] = 276044,
  [SMALL_STATE(7195)] = 276074,
  [SMALL_STATE(7196)] = 276104,
  [SMALL_STATE(7197)] = 276128,
  [SMALL_STATE(7198)] = 276162,
  [SMALL_STATE(7199)] = 276202,
  [SMALL_STATE(7200)] = 276226,
  [SMALL_STATE(7201)] = 276250,
  [SMALL_STATE(7202)] = 276290,
  [SMALL_STATE(7203)] = 276314,
  [SMALL_STATE(7204)] = 276344,
  [SMALL_STATE(7205)] = 276394,
  [SMALL_STATE(7206)] = 276418,
  [SMALL_STATE(7207)] = 276458,
  [SMALL_STATE(7208)] = 276482,
  [SMALL_STATE(7209)] = 276506,
  [SMALL_STATE(7210)] = 276534,
  [SMALL_STATE(7211)] = 276564,
  [SMALL_STATE(7212)] = 276598,
  [SMALL_STATE(7213)] = 276626,
  [SMALL_STATE(7214)] = 276654,
  [SMALL_STATE(7215)] = 276694,
  [SMALL_STATE(7216)] = 276724,
  [SMALL_STATE(7217)] = 276748,
  [SMALL_STATE(7218)] = 276772,
  [SMALL_STATE(7219)] = 276796,
  [SMALL_STATE(7220)] = 276836,
  [SMALL_STATE(7221)] = 276860,
  [SMALL_STATE(7222)] = 276890,
  [SMALL_STATE(7223)] = 276930,
  [SMALL_STATE(7224)] = 276960,
  [SMALL_STATE(7225)] = 277000,
  [SMALL_STATE(7226)] = 277040,
  [SMALL_STATE(7227)] = 277068,
  [SMALL_STATE(7228)] = 277092,
  [SMALL_STATE(7229)] = 277130,
  [SMALL_STATE(7230)] = 277168,
  [SMALL_STATE(7231)] = 277206,
  [SMALL_STATE(7232)] = 277244,
  [SMALL_STATE(7233)] = 277274,
  [SMALL_STATE(7234)] = 277314,
  [SMALL_STATE(7235)] = 277344,
  [SMALL_STATE(7236)] = 277368,
  [SMALL_STATE(7237)] = 277398,
  [SMALL_STATE(7238)] = 277438,
  [SMALL_STATE(7239)] = 277478,
  [SMALL_STATE(7240)] = 277506,
  [SMALL_STATE(7241)] = 277530,
  [SMALL_STATE(7242)] = 277568,
  [SMALL_STATE(7243)] = 277608,
  [SMALL_STATE(7244)] = 277643,
  [SMALL_STATE(7245)] = 277682,
  [SMALL_STATE(7246)] = 277713,
  [SMALL_STATE(7247)] = 277750,
  [SMALL_STATE(7248)] = 277779,
  [SMALL_STATE(7249)] = 277818,
  [SMALL_STATE(7250)] = 277861,
  [SMALL_STATE(7251)] = 277896,
  [SMALL_STATE(7252)] = 277925,
  [SMALL_STATE(7253)] = 277962,
  [SMALL_STATE(7254)] = 277995,
  [SMALL_STATE(7255)] = 278032,
  [SMALL_STATE(7256)] = 278065,
  [SMALL_STATE(7257)] = 278108,
  [SMALL_STATE(7258)] = 278137,
  [SMALL_STATE(7259)] = 278176,
  [SMALL_STATE(7260)] = 278209,
  [SMALL_STATE(7261)] = 278238,
  [SMALL_STATE(7262)] = 278269,
  [SMALL_STATE(7263)] = 278300,
  [SMALL_STATE(7264)] = 278335,
  [SMALL_STATE(7265)] = 278368,
  [SMALL_STATE(7266)] = 278405,
  [SMALL_STATE(7267)] = 278448,
  [SMALL_STATE(7268)] = 278485,
  [SMALL_STATE(7269)] = 278522,
  [SMALL_STATE(7270)] = 278557,
  [SMALL_STATE(7271)] = 278600,
  [SMALL_STATE(7272)] = 278629,
  [SMALL_STATE(7273)] = 278658,
  [SMALL_STATE(7274)] = 278687,
  [SMALL_STATE(7275)] = 278720,
  [SMALL_STATE(7276)] = 278753,
  [SMALL_STATE(7277)] = 278784,
  [SMALL_STATE(7278)] = 278817,
  [SMALL_STATE(7279)] = 278844,
  [SMALL_STATE(7280)] = 278877,
  [SMALL_STATE(7281)] = 278906,
  [SMALL_STATE(7282)] = 278933,
  [SMALL_STATE(7283)] = 278976,
  [SMALL_STATE(7284)] = 279013,
  [SMALL_STATE(7285)] = 279046,
  [SMALL_STATE(7286)] = 279073,
  [SMALL_STATE(7287)] = 279106,
  [SMALL_STATE(7288)] = 279143,
  [SMALL_STATE(7289)] = 279170,
  [SMALL_STATE(7290)] = 279201,
  [SMALL_STATE(7291)] = 279240,
  [SMALL_STATE(7292)] = 279267,
  [SMALL_STATE(7293)] = 279306,
  [SMALL_STATE(7294)] = 279349,
  [SMALL_STATE(7295)] = 279378,
  [SMALL_STATE(7296)] = 279417,
  [SMALL_STATE(7297)] = 279460,
  [SMALL_STATE(7298)] = 279487,
  [SMALL_STATE(7299)] = 279514,
  [SMALL_STATE(7300)] = 279539,
  [SMALL_STATE(7301)] = 279570,
  [SMALL_STATE(7302)] = 279597,
  [SMALL_STATE(7303)] = 279630,
  [SMALL_STATE(7304)] = 279657,
  [SMALL_STATE(7305)] = 279684,
  [SMALL_STATE(7306)] = 279715,
  [SMALL_STATE(7307)] = 279744,
  [SMALL_STATE(7308)] = 279775,
  [SMALL_STATE(7309)] = 279802,
  [SMALL_STATE(7310)] = 279841,
  [SMALL_STATE(7311)] = 279864,
  [SMALL_STATE(7312)] = 279897,
  [SMALL_STATE(7313)] = 279940,
  [SMALL_STATE(7314)] = 279975,
  [SMALL_STATE(7315)] = 280014,
  [SMALL_STATE(7316)] = 280047,
  [SMALL_STATE(7317)] = 280074,
  [SMALL_STATE(7318)] = 280107,
  [SMALL_STATE(7319)] = 280136,
  [SMALL_STATE(7320)] = 280171,
  [SMALL_STATE(7321)] = 280206,
  [SMALL_STATE(7322)] = 280249,
  [SMALL_STATE(7323)] = 280284,
  [SMALL_STATE(7324)] = 280323,
  [SMALL_STATE(7325)] = 280352,
  [SMALL_STATE(7326)] = 280391,
  [SMALL_STATE(7327)] = 280426,
  [SMALL_STATE(7328)] = 280457,
  [SMALL_STATE(7329)] = 280488,
  [SMALL_STATE(7330)] = 280519,
  [SMALL_STATE(7331)] = 280550,
  [SMALL_STATE(7332)] = 280589,
  [SMALL_STATE(7333)] = 280616,
  [SMALL_STATE(7334)] = 280659,
  [SMALL_STATE(7335)] = 280698,
  [SMALL_STATE(7336)] = 280729,
  [SMALL_STATE(7337)] = 280768,
  [SMALL_STATE(7338)] = 280807,
  [SMALL_STATE(7339)] = 280846,
  [SMALL_STATE(7340)] = 280873,
  [SMALL_STATE(7341)] = 280904,
  [SMALL_STATE(7342)] = 280947,
  [SMALL_STATE(7343)] = 280978,
  [SMALL_STATE(7344)] = 281017,
  [SMALL_STATE(7345)] = 281048,
  [SMALL_STATE(7346)] = 281087,
  [SMALL_STATE(7347)] = 281118,
  [SMALL_STATE(7348)] = 281151,
  [SMALL_STATE(7349)] = 281186,
  [SMALL_STATE(7350)] = 281225,
  [SMALL_STATE(7351)] = 281259,
  [SMALL_STATE(7352)] = 281289,
  [SMALL_STATE(7353)] = 281315,
  [SMALL_STATE(7354)] = 281341,
  [SMALL_STATE(7355)] = 281367,
  [SMALL_STATE(7356)] = 281407,
  [SMALL_STATE(7357)] = 281447,
  [SMALL_STATE(7358)] = 281487,
  [SMALL_STATE(7359)] = 281527,
  [SMALL_STATE(7360)] = 281553,
  [SMALL_STATE(7361)] = 281593,
  [SMALL_STATE(7362)] = 281631,
  [SMALL_STATE(7363)] = 281669,
  [SMALL_STATE(7364)] = 281713,
  [SMALL_STATE(7365)] = 281751,
  [SMALL_STATE(7366)] = 281791,
  [SMALL_STATE(7367)] = 281817,
  [SMALL_STATE(7368)] = 281843,
  [SMALL_STATE(7369)] = 281883,
  [SMALL_STATE(7370)] = 281909,
  [SMALL_STATE(7371)] = 281949,
  [SMALL_STATE(7372)] = 281989,
  [SMALL_STATE(7373)] = 282019,
  [SMALL_STATE(7374)] = 282041,
  [SMALL_STATE(7375)] = 282081,
  [SMALL_STATE(7376)] = 282121,
  [SMALL_STATE(7377)] = 282149,
  [SMALL_STATE(7378)] = 282179,
  [SMALL_STATE(7379)] = 282211,
  [SMALL_STATE(7380)] = 282243,
  [SMALL_STATE(7381)] = 282275,
  [SMALL_STATE(7382)] = 282307,
  [SMALL_STATE(7383)] = 282339,
  [SMALL_STATE(7384)] = 282377,
  [SMALL_STATE(7385)] = 282415,
  [SMALL_STATE(7386)] = 282443,
  [SMALL_STATE(7387)] = 282469,
  [SMALL_STATE(7388)] = 282495,
  [SMALL_STATE(7389)] = 282535,
  [SMALL_STATE(7390)] = 282561,
  [SMALL_STATE(7391)] = 282587,
  [SMALL_STATE(7392)] = 282613,
  [SMALL_STATE(7393)] = 282639,
  [SMALL_STATE(7394)] = 282663,
  [SMALL_STATE(7395)] = 282703,
  [SMALL_STATE(7396)] = 282735,
  [SMALL_STATE(7397)] = 282765,
  [SMALL_STATE(7398)] = 282793,
  [SMALL_STATE(7399)] = 282817,
  [SMALL_STATE(7400)] = 282839,
  [SMALL_STATE(7401)] = 282871,
  [SMALL_STATE(7402)] = 282903,
  [SMALL_STATE(7403)] = 282935,
  [SMALL_STATE(7404)] = 282967,
  [SMALL_STATE(7405)] = 282993,
  [SMALL_STATE(7406)] = 283017,
  [SMALL_STATE(7407)] = 283045,
  [SMALL_STATE(7408)] = 283083,
  [SMALL_STATE(7409)] = 283115,
  [SMALL_STATE(7410)] = 283143,
  [SMALL_STATE(7411)] = 283175,
  [SMALL_STATE(7412)] = 283215,
  [SMALL_STATE(7413)] = 283253,
  [SMALL_STATE(7414)] = 283291,
  [SMALL_STATE(7415)] = 283323,
  [SMALL_STATE(7416)] = 283355,
  [SMALL_STATE(7417)] = 283387,
  [SMALL_STATE(7418)] = 283419,
  [SMALL_STATE(7419)] = 283451,
  [SMALL_STATE(7420)] = 283479,
  [SMALL_STATE(7421)] = 283519,
  [SMALL_STATE(7422)] = 283541,
  [SMALL_STATE(7423)] = 283573,
  [SMALL_STATE(7424)] = 283611,
  [SMALL_STATE(7425)] = 283639,
  [SMALL_STATE(7426)] = 283671,
  [SMALL_STATE(7427)] = 283703,
  [SMALL_STATE(7428)] = 283741,
  [SMALL_STATE(7429)] = 283769,
  [SMALL_STATE(7430)] = 283809,
  [SMALL_STATE(7431)] = 283841,
  [SMALL_STATE(7432)] = 283873,
  [SMALL_STATE(7433)] = 283905,
  [SMALL_STATE(7434)] = 283933,
  [SMALL_STATE(7435)] = 283955,
  [SMALL_STATE(7436)] = 283995,
  [SMALL_STATE(7437)] = 284025,
  [SMALL_STATE(7438)] = 284065,
  [SMALL_STATE(7439)] = 284105,
  [SMALL_STATE(7440)] = 284135,
  [SMALL_STATE(7441)] = 284175,
  [SMALL_STATE(7442)] = 284213,
  [SMALL_STATE(7443)] = 284253,
  [SMALL_STATE(7444)] = 284293,
  [SMALL_STATE(7445)] = 284321,
  [SMALL_STATE(7446)] = 284355,
  [SMALL_STATE(7447)] = 284389,
  [SMALL_STATE(7448)] = 284423,
  [SMALL_STATE(7449)] = 284457,
  [SMALL_STATE(7450)] = 284495,
  [SMALL_STATE(7451)] = 284533,
  [SMALL_STATE(7452)] = 284567,
  [SMALL_STATE(7453)] = 284607,
  [SMALL_STATE(7454)] = 284639,
  [SMALL_STATE(7455)] = 284669,
  [SMALL_STATE(7456)] = 284701,
  [SMALL_STATE(7457)] = 284739,
  [SMALL_STATE(7458)] = 284773,
  [SMALL_STATE(7459)] = 284811,
  [SMALL_STATE(7460)] = 284845,
  [SMALL_STATE(7461)] = 284879,
  [SMALL_STATE(7462)] = 284913,
  [SMALL_STATE(7463)] = 284943,
  [SMALL_STATE(7464)] = 284983,
  [SMALL_STATE(7465)] = 285021,
  [SMALL_STATE(7466)] = 285051,
  [SMALL_STATE(7467)] = 285089,
  [SMALL_STATE(7468)] = 285127,
  [SMALL_STATE(7469)] = 285160,
  [SMALL_STATE(7470)] = 285187,
  [SMALL_STATE(7471)] = 285214,
  [SMALL_STATE(7472)] = 285241,
  [SMALL_STATE(7473)] = 285266,
  [SMALL_STATE(7474)] = 285291,
  [SMALL_STATE(7475)] = 285318,
  [SMALL_STATE(7476)] = 285351,
  [SMALL_STATE(7477)] = 285382,
  [SMALL_STATE(7478)] = 285409,
  [SMALL_STATE(7479)] = 285436,
  [SMALL_STATE(7480)] = 285461,
  [SMALL_STATE(7481)] = 285486,
  [SMALL_STATE(7482)] = 285513,
  [SMALL_STATE(7483)] = 285552,
  [SMALL_STATE(7484)] = 285579,
  [SMALL_STATE(7485)] = 285606,
  [SMALL_STATE(7486)] = 285639,
  [SMALL_STATE(7487)] = 285664,
  [SMALL_STATE(7488)] = 285691,
  [SMALL_STATE(7489)] = 285724,
  [SMALL_STATE(7490)] = 285751,
  [SMALL_STATE(7491)] = 285784,
  [SMALL_STATE(7492)] = 285815,
  [SMALL_STATE(7493)] = 285850,
  [SMALL_STATE(7494)] = 285873,
  [SMALL_STATE(7495)] = 285906,
  [SMALL_STATE(7496)] = 285937,
  [SMALL_STATE(7497)] = 285958,
  [SMALL_STATE(7498)] = 285983,
  [SMALL_STATE(7499)] = 286016,
  [SMALL_STATE(7500)] = 286039,
  [SMALL_STATE(7501)] = 286062,
  [SMALL_STATE(7502)] = 286085,
  [SMALL_STATE(7503)] = 286110,
  [SMALL_STATE(7504)] = 286143,
  [SMALL_STATE(7505)] = 286176,
  [SMALL_STATE(7506)] = 286207,
  [SMALL_STATE(7507)] = 286228,
  [SMALL_STATE(7508)] = 286251,
  [SMALL_STATE(7509)] = 286282,
  [SMALL_STATE(7510)] = 286315,
  [SMALL_STATE(7511)] = 286352,
  [SMALL_STATE(7512)] = 286383,
  [SMALL_STATE(7513)] = 286414,
  [SMALL_STATE(7514)] = 286447,
  [SMALL_STATE(7515)] = 286478,
  [SMALL_STATE(7516)] = 286513,
  [SMALL_STATE(7517)] = 286544,
  [SMALL_STATE(7518)] = 286575,
  [SMALL_STATE(7519)] = 286606,
  [SMALL_STATE(7520)] = 286639,
  [SMALL_STATE(7521)] = 286664,
  [SMALL_STATE(7522)] = 286699,
  [SMALL_STATE(7523)] = 286732,
  [SMALL_STATE(7524)] = 286765,
  [SMALL_STATE(7525)] = 286792,
  [SMALL_STATE(7526)] = 286815,
  [SMALL_STATE(7527)] = 286838,
  [SMALL_STATE(7528)] = 286861,
  [SMALL_STATE(7529)] = 286888,
  [SMALL_STATE(7530)] = 286919,
  [SMALL_STATE(7531)] = 286946,
  [SMALL_STATE(7532)] = 286979,
  [SMALL_STATE(7533)] = 287012,
  [SMALL_STATE(7534)] = 287041,
  [SMALL_STATE(7535)] = 287074,
  [SMALL_STATE(7536)] = 287107,
  [SMALL_STATE(7537)] = 287142,
  [SMALL_STATE(7538)] = 287181,
  [SMALL_STATE(7539)] = 287208,
  [SMALL_STATE(7540)] = 287241,
  [SMALL_STATE(7541)] = 287276,
  [SMALL_STATE(7542)] = 287303,
  [SMALL_STATE(7543)] = 287336,
  [SMALL_STATE(7544)] = 287369,
  [SMALL_STATE(7545)] = 287402,
  [SMALL_STATE(7546)] = 287437,
  [SMALL_STATE(7547)] = 287464,
  [SMALL_STATE(7548)] = 287491,
  [SMALL_STATE(7549)] = 287522,
  [SMALL_STATE(7550)] = 287555,
  [SMALL_STATE(7551)] = 287582,
  [SMALL_STATE(7552)] = 287615,
  [SMALL_STATE(7553)] = 287642,
  [SMALL_STATE(7554)] = 287669,
  [SMALL_STATE(7555)] = 287694,
  [SMALL_STATE(7556)] = 287721,
  [SMALL_STATE(7557)] = 287756,
  [SMALL_STATE(7558)] = 287789,
  [SMALL_STATE(7559)] = 287822,
  [SMALL_STATE(7560)] = 287861,
  [SMALL_STATE(7561)] = 287886,
  [SMALL_STATE(7562)] = 287923,
  [SMALL_STATE(7563)] = 287962,
  [SMALL_STATE(7564)] = 287995,
  [SMALL_STATE(7565)] = 288022,
  [SMALL_STATE(7566)] = 288047,
  [SMALL_STATE(7567)] = 288080,
  [SMALL_STATE(7568)] = 288105,
  [SMALL_STATE(7569)] = 288140,
  [SMALL_STATE(7570)] = 288175,
  [SMALL_STATE(7571)] = 288200,
  [SMALL_STATE(7572)] = 288233,
  [SMALL_STATE(7573)] = 288258,
  [SMALL_STATE(7574)] = 288293,
  [SMALL_STATE(7575)] = 288318,
  [SMALL_STATE(7576)] = 288353,
  [SMALL_STATE(7577)] = 288386,
  [SMALL_STATE(7578)] = 288419,
  [SMALL_STATE(7579)] = 288440,
  [SMALL_STATE(7580)] = 288465,
  [SMALL_STATE(7581)] = 288490,
  [SMALL_STATE(7582)] = 288529,
  [SMALL_STATE(7583)] = 288562,
  [SMALL_STATE(7584)] = 288587,
  [SMALL_STATE(7585)] = 288620,
  [SMALL_STATE(7586)] = 288653,
  [SMALL_STATE(7587)] = 288678,
  [SMALL_STATE(7588)] = 288705,
  [SMALL_STATE(7589)] = 288727,
  [SMALL_STATE(7590)] = 288763,
  [SMALL_STATE(7591)] = 288799,
  [SMALL_STATE(7592)] = 288823,
  [SMALL_STATE(7593)] = 288859,
  [SMALL_STATE(7594)] = 288883,
  [SMALL_STATE(7595)] = 288913,
  [SMALL_STATE(7596)] = 288937,
  [SMALL_STATE(7597)] = 288973,
  [SMALL_STATE(7598)] = 289009,
  [SMALL_STATE(7599)] = 289033,
  [SMALL_STATE(7600)] = 289057,
  [SMALL_STATE(7601)] = 289093,
  [SMALL_STATE(7602)] = 289117,
  [SMALL_STATE(7603)] = 289141,
  [SMALL_STATE(7604)] = 289163,
  [SMALL_STATE(7605)] = 289191,
  [SMALL_STATE(7606)] = 289221,
  [SMALL_STATE(7607)] = 289257,
  [SMALL_STATE(7608)] = 289285,
  [SMALL_STATE(7609)] = 289307,
  [SMALL_STATE(7610)] = 289329,
  [SMALL_STATE(7611)] = 289351,
  [SMALL_STATE(7612)] = 289373,
  [SMALL_STATE(7613)] = 289397,
  [SMALL_STATE(7614)] = 289421,
  [SMALL_STATE(7615)] = 289447,
  [SMALL_STATE(7616)] = 289471,
  [SMALL_STATE(7617)] = 289493,
  [SMALL_STATE(7618)] = 289515,
  [SMALL_STATE(7619)] = 289539,
  [SMALL_STATE(7620)] = 289563,
  [SMALL_STATE(7621)] = 289587,
  [SMALL_STATE(7622)] = 289611,
  [SMALL_STATE(7623)] = 289637,
  [SMALL_STATE(7624)] = 289663,
  [SMALL_STATE(7625)] = 289685,
  [SMALL_STATE(7626)] = 289713,
  [SMALL_STATE(7627)] = 289751,
  [SMALL_STATE(7628)] = 289787,
  [SMALL_STATE(7629)] = 289811,
  [SMALL_STATE(7630)] = 289847,
  [SMALL_STATE(7631)] = 289869,
  [SMALL_STATE(7632)] = 289891,
  [SMALL_STATE(7633)] = 289913,
  [SMALL_STATE(7634)] = 289949,
  [SMALL_STATE(7635)] = 289977,
  [SMALL_STATE(7636)] = 290013,
  [SMALL_STATE(7637)] = 290035,
  [SMALL_STATE(7638)] = 290063,
  [SMALL_STATE(7639)] = 290085,
  [SMALL_STATE(7640)] = 290107,
  [SMALL_STATE(7641)] = 290137,
  [SMALL_STATE(7642)] = 290165,
  [SMALL_STATE(7643)] = 290189,
  [SMALL_STATE(7644)] = 290225,
  [SMALL_STATE(7645)] = 290251,
  [SMALL_STATE(7646)] = 290289,
  [SMALL_STATE(7647)] = 290315,
  [SMALL_STATE(7648)] = 290341,
  [SMALL_STATE(7649)] = 290369,
  [SMALL_STATE(7650)] = 290393,
  [SMALL_STATE(7651)] = 290429,
  [SMALL_STATE(7652)] = 290465,
  [SMALL_STATE(7653)] = 290495,
  [SMALL_STATE(7654)] = 290525,
  [SMALL_STATE(7655)] = 290551,
  [SMALL_STATE(7656)] = 290587,
  [SMALL_STATE(7657)] = 290609,
  [SMALL_STATE(7658)] = 290635,
  [SMALL_STATE(7659)] = 290657,
  [SMALL_STATE(7660)] = 290679,
  [SMALL_STATE(7661)] = 290701,
  [SMALL_STATE(7662)] = 290723,
  [SMALL_STATE(7663)] = 290745,
  [SMALL_STATE(7664)] = 290767,
  [SMALL_STATE(7665)] = 290803,
  [SMALL_STATE(7666)] = 290841,
  [SMALL_STATE(7667)] = 290867,
  [SMALL_STATE(7668)] = 290893,
  [SMALL_STATE(7669)] = 290919,
  [SMALL_STATE(7670)] = 290955,
  [SMALL_STATE(7671)] = 290981,
  [SMALL_STATE(7672)] = 291017,
  [SMALL_STATE(7673)] = 291043,
  [SMALL_STATE(7674)] = 291079,
  [SMALL_STATE(7675)] = 291115,
  [SMALL_STATE(7676)] = 291153,
  [SMALL_STATE(7677)] = 291179,
  [SMALL_STATE(7678)] = 291205,
  [SMALL_STATE(7679)] = 291235,
  [SMALL_STATE(7680)] = 291261,
  [SMALL_STATE(7681)] = 291289,
  [SMALL_STATE(7682)] = 291327,
  [SMALL_STATE(7683)] = 291363,
  [SMALL_STATE(7684)] = 291389,
  [SMALL_STATE(7685)] = 291415,
  [SMALL_STATE(7686)] = 291443,
  [SMALL_STATE(7687)] = 291479,
  [SMALL_STATE(7688)] = 291507,
  [SMALL_STATE(7689)] = 291545,
  [SMALL_STATE(7690)] = 291573,
  [SMALL_STATE(7691)] = 291593,
  [SMALL_STATE(7692)] = 291619,
  [SMALL_STATE(7693)] = 291645,
  [SMALL_STATE(7694)] = 291673,
  [SMALL_STATE(7695)] = 291701,
  [SMALL_STATE(7696)] = 291729,
  [SMALL_STATE(7697)] = 291765,
  [SMALL_STATE(7698)] = 291793,
  [SMALL_STATE(7699)] = 291821,
  [SMALL_STATE(7700)] = 291859,
  [SMALL_STATE(7701)] = 291887,
  [SMALL_STATE(7702)] = 291911,
  [SMALL_STATE(7703)] = 291947,
  [SMALL_STATE(7704)] = 291983,
  [SMALL_STATE(7705)] = 292009,
  [SMALL_STATE(7706)] = 292045,
  [SMALL_STATE(7707)] = 292069,
  [SMALL_STATE(7708)] = 292093,
  [SMALL_STATE(7709)] = 292117,
  [SMALL_STATE(7710)] = 292141,
  [SMALL_STATE(7711)] = 292165,
  [SMALL_STATE(7712)] = 292190,
  [SMALL_STATE(7713)] = 292215,
  [SMALL_STATE(7714)] = 292234,
  [SMALL_STATE(7715)] = 292269,
  [SMALL_STATE(7716)] = 292288,
  [SMALL_STATE(7717)] = 292307,
  [SMALL_STATE(7718)] = 292326,
  [SMALL_STATE(7719)] = 292361,
  [SMALL_STATE(7720)] = 292394,
  [SMALL_STATE(7721)] = 292419,
  [SMALL_STATE(7722)] = 292450,
  [SMALL_STATE(7723)] = 292475,
  [SMALL_STATE(7724)] = 292510,
  [SMALL_STATE(7725)] = 292529,
  [SMALL_STATE(7726)] = 292554,
  [SMALL_STATE(7727)] = 292579,
  [SMALL_STATE(7728)] = 292598,
  [SMALL_STATE(7729)] = 292617,
  [SMALL_STATE(7730)] = 292636,
  [SMALL_STATE(7731)] = 292671,
  [SMALL_STATE(7732)] = 292700,
  [SMALL_STATE(7733)] = 292725,
  [SMALL_STATE(7734)] = 292760,
  [SMALL_STATE(7735)] = 292785,
  [SMALL_STATE(7736)] = 292804,
  [SMALL_STATE(7737)] = 292829,
  [SMALL_STATE(7738)] = 292854,
  [SMALL_STATE(7739)] = 292879,
  [SMALL_STATE(7740)] = 292914,
  [SMALL_STATE(7741)] = 292933,
  [SMALL_STATE(7742)] = 292956,
  [SMALL_STATE(7743)] = 292991,
  [SMALL_STATE(7744)] = 293012,
  [SMALL_STATE(7745)] = 293047,
  [SMALL_STATE(7746)] = 293078,
  [SMALL_STATE(7747)] = 293113,
  [SMALL_STATE(7748)] = 293148,
  [SMALL_STATE(7749)] = 293173,
  [SMALL_STATE(7750)] = 293208,
  [SMALL_STATE(7751)] = 293243,
  [SMALL_STATE(7752)] = 293276,
  [SMALL_STATE(7753)] = 293311,
  [SMALL_STATE(7754)] = 293330,
  [SMALL_STATE(7755)] = 293349,
  [SMALL_STATE(7756)] = 293368,
  [SMALL_STATE(7757)] = 293403,
  [SMALL_STATE(7758)] = 293426,
  [SMALL_STATE(7759)] = 293455,
  [SMALL_STATE(7760)] = 293478,
  [SMALL_STATE(7761)] = 293501,
  [SMALL_STATE(7762)] = 293524,
  [SMALL_STATE(7763)] = 293547,
  [SMALL_STATE(7764)] = 293572,
  [SMALL_STATE(7765)] = 293595,
  [SMALL_STATE(7766)] = 293618,
  [SMALL_STATE(7767)] = 293653,
  [SMALL_STATE(7768)] = 293676,
  [SMALL_STATE(7769)] = 293701,
  [SMALL_STATE(7770)] = 293732,
  [SMALL_STATE(7771)] = 293755,
  [SMALL_STATE(7772)] = 293778,
  [SMALL_STATE(7773)] = 293813,
  [SMALL_STATE(7774)] = 293834,
  [SMALL_STATE(7775)] = 293869,
  [SMALL_STATE(7776)] = 293894,
  [SMALL_STATE(7777)] = 293919,
  [SMALL_STATE(7778)] = 293954,
  [SMALL_STATE(7779)] = 293979,
  [SMALL_STATE(7780)] = 294004,
  [SMALL_STATE(7781)] = 294039,
  [SMALL_STATE(7782)] = 294060,
  [SMALL_STATE(7783)] = 294081,
  [SMALL_STATE(7784)] = 294100,
  [SMALL_STATE(7785)] = 294125,
  [SMALL_STATE(7786)] = 294160,
  [SMALL_STATE(7787)] = 294193,
  [SMALL_STATE(7788)] = 294212,
  [SMALL_STATE(7789)] = 294247,
  [SMALL_STATE(7790)] = 294282,
  [SMALL_STATE(7791)] = 294311,
  [SMALL_STATE(7792)] = 294346,
  [SMALL_STATE(7793)] = 294365,
  [SMALL_STATE(7794)] = 294400,
  [SMALL_STATE(7795)] = 294419,
  [SMALL_STATE(7796)] = 294454,
  [SMALL_STATE(7797)] = 294479,
  [SMALL_STATE(7798)] = 294502,
  [SMALL_STATE(7799)] = 294537,
  [SMALL_STATE(7800)] = 294568,
  [SMALL_STATE(7801)] = 294587,
  [SMALL_STATE(7802)] = 294618,
  [SMALL_STATE(7803)] = 294637,
  [SMALL_STATE(7804)] = 294672,
  [SMALL_STATE(7805)] = 294691,
  [SMALL_STATE(7806)] = 294714,
  [SMALL_STATE(7807)] = 294737,
  [SMALL_STATE(7808)] = 294760,
  [SMALL_STATE(7809)] = 294783,
  [SMALL_STATE(7810)] = 294802,
  [SMALL_STATE(7811)] = 294825,
  [SMALL_STATE(7812)] = 294860,
  [SMALL_STATE(7813)] = 294879,
  [SMALL_STATE(7814)] = 294902,
  [SMALL_STATE(7815)] = 294921,
  [SMALL_STATE(7816)] = 294940,
  [SMALL_STATE(7817)] = 294971,
  [SMALL_STATE(7818)] = 295002,
  [SMALL_STATE(7819)] = 295023,
  [SMALL_STATE(7820)] = 295044,
  [SMALL_STATE(7821)] = 295065,
  [SMALL_STATE(7822)] = 295086,
  [SMALL_STATE(7823)] = 295107,
  [SMALL_STATE(7824)] = 295128,
  [SMALL_STATE(7825)] = 295149,
  [SMALL_STATE(7826)] = 295170,
  [SMALL_STATE(7827)] = 295189,
  [SMALL_STATE(7828)] = 295224,
  [SMALL_STATE(7829)] = 295259,
  [SMALL_STATE(7830)] = 295278,
  [SMALL_STATE(7831)] = 295309,
  [SMALL_STATE(7832)] = 295338,
  [SMALL_STATE(7833)] = 295373,
  [SMALL_STATE(7834)] = 295392,
  [SMALL_STATE(7835)] = 295423,
  [SMALL_STATE(7836)] = 295448,
  [SMALL_STATE(7837)] = 295473,
  [SMALL_STATE(7838)] = 295508,
  [SMALL_STATE(7839)] = 295527,
  [SMALL_STATE(7840)] = 295560,
  [SMALL_STATE(7841)] = 295589,
  [SMALL_STATE(7842)] = 295624,
  [SMALL_STATE(7843)] = 295645,
  [SMALL_STATE(7844)] = 295674,
  [SMALL_STATE(7845)] = 295693,
  [SMALL_STATE(7846)] = 295728,
  [SMALL_STATE(7847)] = 295763,
  [SMALL_STATE(7848)] = 295798,
  [SMALL_STATE(7849)] = 295817,
  [SMALL_STATE(7850)] = 295836,
  [SMALL_STATE(7851)] = 295859,
  [SMALL_STATE(7852)] = 295894,
  [SMALL_STATE(7853)] = 295913,
  [SMALL_STATE(7854)] = 295944,
  [SMALL_STATE(7855)] = 295963,
  [SMALL_STATE(7856)] = 295998,
  [SMALL_STATE(7857)] = 296031,
  [SMALL_STATE(7858)] = 296060,
  [SMALL_STATE(7859)] = 296079,
  [SMALL_STATE(7860)] = 296098,
  [SMALL_STATE(7861)] = 296133,
  [SMALL_STATE(7862)] = 296164,
  [SMALL_STATE(7863)] = 296187,
  [SMALL_STATE(7864)] = 296210,
  [SMALL_STATE(7865)] = 296229,
  [SMALL_STATE(7866)] = 296264,
  [SMALL_STATE(7867)] = 296283,
  [SMALL_STATE(7868)] = 296318,
  [SMALL_STATE(7869)] = 296341,
  [SMALL_STATE(7870)] = 296366,
  [SMALL_STATE(7871)] = 296389,
  [SMALL_STATE(7872)] = 296424,
  [SMALL_STATE(7873)] = 296449,
  [SMALL_STATE(7874)] = 296474,
  [SMALL_STATE(7875)] = 296499,
  [SMALL_STATE(7876)] = 296524,
  [SMALL_STATE(7877)] = 296549,
  [SMALL_STATE(7878)] = 296574,
  [SMALL_STATE(7879)] = 296599,
  [SMALL_STATE(7880)] = 296634,
  [SMALL_STATE(7881)] = 296669,
  [SMALL_STATE(7882)] = 296688,
  [SMALL_STATE(7883)] = 296707,
  [SMALL_STATE(7884)] = 296742,
  [SMALL_STATE(7885)] = 296761,
  [SMALL_STATE(7886)] = 296786,
  [SMALL_STATE(7887)] = 296809,
  [SMALL_STATE(7888)] = 296828,
  [SMALL_STATE(7889)] = 296851,
  [SMALL_STATE(7890)] = 296874,
  [SMALL_STATE(7891)] = 296909,
  [SMALL_STATE(7892)] = 296928,
  [SMALL_STATE(7893)] = 296947,
  [SMALL_STATE(7894)] = 296982,
  [SMALL_STATE(7895)] = 297011,
  [SMALL_STATE(7896)] = 297046,
  [SMALL_STATE(7897)] = 297069,
  [SMALL_STATE(7898)] = 297092,
  [SMALL_STATE(7899)] = 297115,
  [SMALL_STATE(7900)] = 297144,
  [SMALL_STATE(7901)] = 297169,
  [SMALL_STATE(7902)] = 297200,
  [SMALL_STATE(7903)] = 297229,
  [SMALL_STATE(7904)] = 297254,
  [SMALL_STATE(7905)] = 297285,
  [SMALL_STATE(7906)] = 297316,
  [SMALL_STATE(7907)] = 297345,
  [SMALL_STATE(7908)] = 297380,
  [SMALL_STATE(7909)] = 297401,
  [SMALL_STATE(7910)] = 297426,
  [SMALL_STATE(7911)] = 297451,
  [SMALL_STATE(7912)] = 297476,
  [SMALL_STATE(7913)] = 297501,
  [SMALL_STATE(7914)] = 297532,
  [SMALL_STATE(7915)] = 297557,
  [SMALL_STATE(7916)] = 297576,
  [SMALL_STATE(7917)] = 297601,
  [SMALL_STATE(7918)] = 297624,
  [SMALL_STATE(7919)] = 297647,
  [SMALL_STATE(7920)] = 297672,
  [SMALL_STATE(7921)] = 297701,
  [SMALL_STATE(7922)] = 297724,
  [SMALL_STATE(7923)] = 297746,
  [SMALL_STATE(7924)] = 297766,
  [SMALL_STATE(7925)] = 297788,
  [SMALL_STATE(7926)] = 297810,
  [SMALL_STATE(7927)] = 297832,
  [SMALL_STATE(7928)] = 297850,
  [SMALL_STATE(7929)] = 297872,
  [SMALL_STATE(7930)] = 297890,
  [SMALL_STATE(7931)] = 297910,
  [SMALL_STATE(7932)] = 297928,
  [SMALL_STATE(7933)] = 297946,
  [SMALL_STATE(7934)] = 297964,
  [SMALL_STATE(7935)] = 297986,
  [SMALL_STATE(7936)] = 298018,
  [SMALL_STATE(7937)] = 298044,
  [SMALL_STATE(7938)] = 298066,
  [SMALL_STATE(7939)] = 298086,
  [SMALL_STATE(7940)] = 298106,
  [SMALL_STATE(7941)] = 298124,
  [SMALL_STATE(7942)] = 298146,
  [SMALL_STATE(7943)] = 298166,
  [SMALL_STATE(7944)] = 298186,
  [SMALL_STATE(7945)] = 298206,
  [SMALL_STATE(7946)] = 298228,
  [SMALL_STATE(7947)] = 298248,
  [SMALL_STATE(7948)] = 298266,
  [SMALL_STATE(7949)] = 298286,
  [SMALL_STATE(7950)] = 298306,
  [SMALL_STATE(7951)] = 298326,
  [SMALL_STATE(7952)] = 298346,
  [SMALL_STATE(7953)] = 298366,
  [SMALL_STATE(7954)] = 298386,
  [SMALL_STATE(7955)] = 298406,
  [SMALL_STATE(7956)] = 298428,
  [SMALL_STATE(7957)] = 298448,
  [SMALL_STATE(7958)] = 298466,
  [SMALL_STATE(7959)] = 298496,
  [SMALL_STATE(7960)] = 298516,
  [SMALL_STATE(7961)] = 298538,
  [SMALL_STATE(7962)] = 298558,
  [SMALL_STATE(7963)] = 298580,
  [SMALL_STATE(7964)] = 298600,
  [SMALL_STATE(7965)] = 298618,
  [SMALL_STATE(7966)] = 298636,
  [SMALL_STATE(7967)] = 298658,
  [SMALL_STATE(7968)] = 298680,
  [SMALL_STATE(7969)] = 298706,
  [SMALL_STATE(7970)] = 298730,
  [SMALL_STATE(7971)] = 298750,
  [SMALL_STATE(7972)] = 298772,
  [SMALL_STATE(7973)] = 298792,
  [SMALL_STATE(7974)] = 298814,
  [SMALL_STATE(7975)] = 298836,
  [SMALL_STATE(7976)] = 298856,
  [SMALL_STATE(7977)] = 298878,
  [SMALL_STATE(7978)] = 298908,
  [SMALL_STATE(7979)] = 298932,
  [SMALL_STATE(7980)] = 298956,
  [SMALL_STATE(7981)] = 298974,
  [SMALL_STATE(7982)] = 298996,
  [SMALL_STATE(7983)] = 299026,
  [SMALL_STATE(7984)] = 299046,
  [SMALL_STATE(7985)] = 299064,
  [SMALL_STATE(7986)] = 299094,
  [SMALL_STATE(7987)] = 299116,
  [SMALL_STATE(7988)] = 299138,
  [SMALL_STATE(7989)] = 299158,
  [SMALL_STATE(7990)] = 299180,
  [SMALL_STATE(7991)] = 299202,
  [SMALL_STATE(7992)] = 299222,
  [SMALL_STATE(7993)] = 299240,
  [SMALL_STATE(7994)] = 299260,
  [SMALL_STATE(7995)] = 299286,
  [SMALL_STATE(7996)] = 299312,
  [SMALL_STATE(7997)] = 299336,
  [SMALL_STATE(7998)] = 299358,
  [SMALL_STATE(7999)] = 299380,
  [SMALL_STATE(8000)] = 299400,
  [SMALL_STATE(8001)] = 299430,
  [SMALL_STATE(8002)] = 299452,
  [SMALL_STATE(8003)] = 299474,
  [SMALL_STATE(8004)] = 299500,
  [SMALL_STATE(8005)] = 299522,
  [SMALL_STATE(8006)] = 299552,
  [SMALL_STATE(8007)] = 299574,
  [SMALL_STATE(8008)] = 299600,
  [SMALL_STATE(8009)] = 299618,
  [SMALL_STATE(8010)] = 299640,
  [SMALL_STATE(8011)] = 299666,
  [SMALL_STATE(8012)] = 299692,
  [SMALL_STATE(8013)] = 299714,
  [SMALL_STATE(8014)] = 299732,
  [SMALL_STATE(8015)] = 299752,
  [SMALL_STATE(8016)] = 299778,
  [SMALL_STATE(8017)] = 299804,
  [SMALL_STATE(8018)] = 299828,
  [SMALL_STATE(8019)] = 299850,
  [SMALL_STATE(8020)] = 299874,
  [SMALL_STATE(8021)] = 299892,
  [SMALL_STATE(8022)] = 299914,
  [SMALL_STATE(8023)] = 299938,
  [SMALL_STATE(8024)] = 299958,
  [SMALL_STATE(8025)] = 299982,
  [SMALL_STATE(8026)] = 300004,
  [SMALL_STATE(8027)] = 300030,
  [SMALL_STATE(8028)] = 300054,
  [SMALL_STATE(8029)] = 300072,
  [SMALL_STATE(8030)] = 300094,
  [SMALL_STATE(8031)] = 300114,
  [SMALL_STATE(8032)] = 300138,
  [SMALL_STATE(8033)] = 300160,
  [SMALL_STATE(8034)] = 300184,
  [SMALL_STATE(8035)] = 300203,
  [SMALL_STATE(8036)] = 300234,
  [SMALL_STATE(8037)] = 300253,
  [SMALL_STATE(8038)] = 300276,
  [SMALL_STATE(8039)] = 300295,
  [SMALL_STATE(8040)] = 300326,
  [SMALL_STATE(8041)] = 300347,
  [SMALL_STATE(8042)] = 300368,
  [SMALL_STATE(8043)] = 300387,
  [SMALL_STATE(8044)] = 300406,
  [SMALL_STATE(8045)] = 300425,
  [SMALL_STATE(8046)] = 300446,
  [SMALL_STATE(8047)] = 300477,
  [SMALL_STATE(8048)] = 300504,
  [SMALL_STATE(8049)] = 300527,
  [SMALL_STATE(8050)] = 300546,
  [SMALL_STATE(8051)] = 300577,
  [SMALL_STATE(8052)] = 300596,
  [SMALL_STATE(8053)] = 300615,
  [SMALL_STATE(8054)] = 300634,
  [SMALL_STATE(8055)] = 300653,
  [SMALL_STATE(8056)] = 300674,
  [SMALL_STATE(8057)] = 300693,
  [SMALL_STATE(8058)] = 300720,
  [SMALL_STATE(8059)] = 300739,
  [SMALL_STATE(8060)] = 300758,
  [SMALL_STATE(8061)] = 300777,
  [SMALL_STATE(8062)] = 300808,
  [SMALL_STATE(8063)] = 300829,
  [SMALL_STATE(8064)] = 300852,
  [SMALL_STATE(8065)] = 300883,
  [SMALL_STATE(8066)] = 300910,
  [SMALL_STATE(8067)] = 300941,
  [SMALL_STATE(8068)] = 300972,
  [SMALL_STATE(8069)] = 300991,
  [SMALL_STATE(8070)] = 301012,
  [SMALL_STATE(8071)] = 301043,
  [SMALL_STATE(8072)] = 301074,
  [SMALL_STATE(8073)] = 301097,
  [SMALL_STATE(8074)] = 301116,
  [SMALL_STATE(8075)] = 301135,
  [SMALL_STATE(8076)] = 301166,
  [SMALL_STATE(8077)] = 301197,
  [SMALL_STATE(8078)] = 301216,
  [SMALL_STATE(8079)] = 301247,
  [SMALL_STATE(8080)] = 301268,
  [SMALL_STATE(8081)] = 301295,
  [SMALL_STATE(8082)] = 301326,
  [SMALL_STATE(8083)] = 301357,
  [SMALL_STATE(8084)] = 301384,
  [SMALL_STATE(8085)] = 301403,
  [SMALL_STATE(8086)] = 301424,
  [SMALL_STATE(8087)] = 301455,
  [SMALL_STATE(8088)] = 301486,
  [SMALL_STATE(8089)] = 301507,
  [SMALL_STATE(8090)] = 301538,
  [SMALL_STATE(8091)] = 301569,
  [SMALL_STATE(8092)] = 301590,
  [SMALL_STATE(8093)] = 301621,
  [SMALL_STATE(8094)] = 301638,
  [SMALL_STATE(8095)] = 301669,
  [SMALL_STATE(8096)] = 301690,
  [SMALL_STATE(8097)] = 301717,
  [SMALL_STATE(8098)] = 301740,
  [SMALL_STATE(8099)] = 301771,
  [SMALL_STATE(8100)] = 301792,
  [SMALL_STATE(8101)] = 301819,
  [SMALL_STATE(8102)] = 301840,
  [SMALL_STATE(8103)] = 301871,
  [SMALL_STATE(8104)] = 301890,
  [SMALL_STATE(8105)] = 301921,
  [SMALL_STATE(8106)] = 301948,
  [SMALL_STATE(8107)] = 301979,
  [SMALL_STATE(8108)] = 302010,
  [SMALL_STATE(8109)] = 302031,
  [SMALL_STATE(8110)] = 302058,
  [SMALL_STATE(8111)] = 302085,
  [SMALL_STATE(8112)] = 302106,
  [SMALL_STATE(8113)] = 302133,
  [SMALL_STATE(8114)] = 302164,
  [SMALL_STATE(8115)] = 302191,
  [SMALL_STATE(8116)] = 302222,
  [SMALL_STATE(8117)] = 302249,
  [SMALL_STATE(8118)] = 302280,
  [SMALL_STATE(8119)] = 302301,
  [SMALL_STATE(8120)] = 302332,
  [SMALL_STATE(8121)] = 302363,
  [SMALL_STATE(8122)] = 302388,
  [SMALL_STATE(8123)] = 302419,
  [SMALL_STATE(8124)] = 302450,
  [SMALL_STATE(8125)] = 302471,
  [SMALL_STATE(8126)] = 302492,
  [SMALL_STATE(8127)] = 302523,
  [SMALL_STATE(8128)] = 302554,
  [SMALL_STATE(8129)] = 302575,
  [SMALL_STATE(8130)] = 302606,
  [SMALL_STATE(8131)] = 302629,
  [SMALL_STATE(8132)] = 302660,
  [SMALL_STATE(8133)] = 302691,
  [SMALL_STATE(8134)] = 302714,
  [SMALL_STATE(8135)] = 302741,
  [SMALL_STATE(8136)] = 302764,
  [SMALL_STATE(8137)] = 302787,
  [SMALL_STATE(8138)] = 302806,
  [SMALL_STATE(8139)] = 302833,
  [SMALL_STATE(8140)] = 302856,
  [SMALL_STATE(8141)] = 302878,
  [SMALL_STATE(8142)] = 302904,
  [SMALL_STATE(8143)] = 302930,
  [SMALL_STATE(8144)] = 302948,
  [SMALL_STATE(8145)] = 302970,
  [SMALL_STATE(8146)] = 302996,
  [SMALL_STATE(8147)] = 303022,
  [SMALL_STATE(8148)] = 303046,
  [SMALL_STATE(8149)] = 303064,
  [SMALL_STATE(8150)] = 303088,
  [SMALL_STATE(8151)] = 303112,
  [SMALL_STATE(8152)] = 303138,
  [SMALL_STATE(8153)] = 303164,
  [SMALL_STATE(8154)] = 303190,
  [SMALL_STATE(8155)] = 303210,
  [SMALL_STATE(8156)] = 303226,
  [SMALL_STATE(8157)] = 303244,
  [SMALL_STATE(8158)] = 303270,
  [SMALL_STATE(8159)] = 303296,
  [SMALL_STATE(8160)] = 303314,
  [SMALL_STATE(8161)] = 303340,
  [SMALL_STATE(8162)] = 303362,
  [SMALL_STATE(8163)] = 303380,
  [SMALL_STATE(8164)] = 303398,
  [SMALL_STATE(8165)] = 303424,
  [SMALL_STATE(8166)] = 303444,
  [SMALL_STATE(8167)] = 303470,
  [SMALL_STATE(8168)] = 303496,
  [SMALL_STATE(8169)] = 303514,
  [SMALL_STATE(8170)] = 303538,
  [SMALL_STATE(8171)] = 303562,
  [SMALL_STATE(8172)] = 303588,
  [SMALL_STATE(8173)] = 303610,
  [SMALL_STATE(8174)] = 303632,
  [SMALL_STATE(8175)] = 303648,
  [SMALL_STATE(8176)] = 303666,
  [SMALL_STATE(8177)] = 303688,
  [SMALL_STATE(8178)] = 303710,
  [SMALL_STATE(8179)] = 303736,
  [SMALL_STATE(8180)] = 303756,
  [SMALL_STATE(8181)] = 303782,
  [SMALL_STATE(8182)] = 303808,
  [SMALL_STATE(8183)] = 303830,
  [SMALL_STATE(8184)] = 303850,
  [SMALL_STATE(8185)] = 303876,
  [SMALL_STATE(8186)] = 303902,
  [SMALL_STATE(8187)] = 303928,
  [SMALL_STATE(8188)] = 303952,
  [SMALL_STATE(8189)] = 303976,
  [SMALL_STATE(8190)] = 304000,
  [SMALL_STATE(8191)] = 304024,
  [SMALL_STATE(8192)] = 304042,
  [SMALL_STATE(8193)] = 304068,
  [SMALL_STATE(8194)] = 304090,
  [SMALL_STATE(8195)] = 304110,
  [SMALL_STATE(8196)] = 304128,
  [SMALL_STATE(8197)] = 304150,
  [SMALL_STATE(8198)] = 304172,
  [SMALL_STATE(8199)] = 304194,
  [SMALL_STATE(8200)] = 304216,
  [SMALL_STATE(8201)] = 304238,
  [SMALL_STATE(8202)] = 304260,
  [SMALL_STATE(8203)] = 304282,
  [SMALL_STATE(8204)] = 304300,
  [SMALL_STATE(8205)] = 304320,
  [SMALL_STATE(8206)] = 304342,
  [SMALL_STATE(8207)] = 304362,
  [SMALL_STATE(8208)] = 304388,
  [SMALL_STATE(8209)] = 304414,
  [SMALL_STATE(8210)] = 304438,
  [SMALL_STATE(8211)] = 304456,
  [SMALL_STATE(8212)] = 304482,
  [SMALL_STATE(8213)] = 304502,
  [SMALL_STATE(8214)] = 304524,
  [SMALL_STATE(8215)] = 304546,
  [SMALL_STATE(8216)] = 304566,
  [SMALL_STATE(8217)] = 304586,
  [SMALL_STATE(8218)] = 304612,
  [SMALL_STATE(8219)] = 304638,
  [SMALL_STATE(8220)] = 304660,
  [SMALL_STATE(8221)] = 304686,
  [SMALL_STATE(8222)] = 304704,
  [SMALL_STATE(8223)] = 304730,
  [SMALL_STATE(8224)] = 304756,
  [SMALL_STATE(8225)] = 304776,
  [SMALL_STATE(8226)] = 304794,
  [SMALL_STATE(8227)] = 304814,
  [SMALL_STATE(8228)] = 304840,
  [SMALL_STATE(8229)] = 304866,
  [SMALL_STATE(8230)] = 304892,
  [SMALL_STATE(8231)] = 304914,
  [SMALL_STATE(8232)] = 304933,
  [SMALL_STATE(8233)] = 304958,
  [SMALL_STATE(8234)] = 304973,
  [SMALL_STATE(8235)] = 304990,
  [SMALL_STATE(8236)] = 305007,
  [SMALL_STATE(8237)] = 305030,
  [SMALL_STATE(8238)] = 305053,
  [SMALL_STATE(8239)] = 305078,
  [SMALL_STATE(8240)] = 305093,
  [SMALL_STATE(8241)] = 305118,
  [SMALL_STATE(8242)] = 305143,
  [SMALL_STATE(8243)] = 305168,
  [SMALL_STATE(8244)] = 305193,
  [SMALL_STATE(8245)] = 305218,
  [SMALL_STATE(8246)] = 305237,
  [SMALL_STATE(8247)] = 305256,
  [SMALL_STATE(8248)] = 305277,
  [SMALL_STATE(8249)] = 305294,
  [SMALL_STATE(8250)] = 305315,
  [SMALL_STATE(8251)] = 305338,
  [SMALL_STATE(8252)] = 305363,
  [SMALL_STATE(8253)] = 305386,
  [SMALL_STATE(8254)] = 305411,
  [SMALL_STATE(8255)] = 305430,
  [SMALL_STATE(8256)] = 305453,
  [SMALL_STATE(8257)] = 305476,
  [SMALL_STATE(8258)] = 305501,
  [SMALL_STATE(8259)] = 305522,
  [SMALL_STATE(8260)] = 305537,
  [SMALL_STATE(8261)] = 305558,
  [SMALL_STATE(8262)] = 305579,
  [SMALL_STATE(8263)] = 305604,
  [SMALL_STATE(8264)] = 305621,
  [SMALL_STATE(8265)] = 305642,
  [SMALL_STATE(8266)] = 305663,
  [SMALL_STATE(8267)] = 305684,
  [SMALL_STATE(8268)] = 305709,
  [SMALL_STATE(8269)] = 305726,
  [SMALL_STATE(8270)] = 305743,
  [SMALL_STATE(8271)] = 305760,
  [SMALL_STATE(8272)] = 305785,
  [SMALL_STATE(8273)] = 305800,
  [SMALL_STATE(8274)] = 305825,
  [SMALL_STATE(8275)] = 305842,
  [SMALL_STATE(8276)] = 305861,
  [SMALL_STATE(8277)] = 305886,
  [SMALL_STATE(8278)] = 305907,
  [SMALL_STATE(8279)] = 305932,
  [SMALL_STATE(8280)] = 305955,
  [SMALL_STATE(8281)] = 305974,
  [SMALL_STATE(8282)] = 305999,
  [SMALL_STATE(8283)] = 306014,
  [SMALL_STATE(8284)] = 306037,
  [SMALL_STATE(8285)] = 306060,
  [SMALL_STATE(8286)] = 306079,
  [SMALL_STATE(8287)] = 306100,
  [SMALL_STATE(8288)] = 306125,
  [SMALL_STATE(8289)] = 306150,
  [SMALL_STATE(8290)] = 306171,
  [SMALL_STATE(8291)] = 306196,
  [SMALL_STATE(8292)] = 306217,
  [SMALL_STATE(8293)] = 306242,
  [SMALL_STATE(8294)] = 306259,
  [SMALL_STATE(8295)] = 306284,
  [SMALL_STATE(8296)] = 306299,
  [SMALL_STATE(8297)] = 306320,
  [SMALL_STATE(8298)] = 306341,
  [SMALL_STATE(8299)] = 306366,
  [SMALL_STATE(8300)] = 306383,
  [SMALL_STATE(8301)] = 306404,
  [SMALL_STATE(8302)] = 306429,
  [SMALL_STATE(8303)] = 306450,
  [SMALL_STATE(8304)] = 306467,
  [SMALL_STATE(8305)] = 306484,
  [SMALL_STATE(8306)] = 306505,
  [SMALL_STATE(8307)] = 306530,
  [SMALL_STATE(8308)] = 306551,
  [SMALL_STATE(8309)] = 306576,
  [SMALL_STATE(8310)] = 306601,
  [SMALL_STATE(8311)] = 306622,
  [SMALL_STATE(8312)] = 306639,
  [SMALL_STATE(8313)] = 306658,
  [SMALL_STATE(8314)] = 306675,
  [SMALL_STATE(8315)] = 306694,
  [SMALL_STATE(8316)] = 306711,
  [SMALL_STATE(8317)] = 306732,
  [SMALL_STATE(8318)] = 306749,
  [SMALL_STATE(8319)] = 306768,
  [SMALL_STATE(8320)] = 306785,
  [SMALL_STATE(8321)] = 306804,
  [SMALL_STATE(8322)] = 306823,
  [SMALL_STATE(8323)] = 306842,
  [SMALL_STATE(8324)] = 306861,
  [SMALL_STATE(8325)] = 306878,
  [SMALL_STATE(8326)] = 306903,
  [SMALL_STATE(8327)] = 306926,
  [SMALL_STATE(8328)] = 306947,
  [SMALL_STATE(8329)] = 306970,
  [SMALL_STATE(8330)] = 306987,
  [SMALL_STATE(8331)] = 307002,
  [SMALL_STATE(8332)] = 307021,
  [SMALL_STATE(8333)] = 307036,
  [SMALL_STATE(8334)] = 307053,
  [SMALL_STATE(8335)] = 307078,
  [SMALL_STATE(8336)] = 307095,
  [SMALL_STATE(8337)] = 307114,
  [SMALL_STATE(8338)] = 307135,
  [SMALL_STATE(8339)] = 307152,
  [SMALL_STATE(8340)] = 307177,
  [SMALL_STATE(8341)] = 307192,
  [SMALL_STATE(8342)] = 307217,
  [SMALL_STATE(8343)] = 307242,
  [SMALL_STATE(8344)] = 307257,
  [SMALL_STATE(8345)] = 307278,
  [SMALL_STATE(8346)] = 307301,
  [SMALL_STATE(8347)] = 307318,
  [SMALL_STATE(8348)] = 307343,
  [SMALL_STATE(8349)] = 307360,
  [SMALL_STATE(8350)] = 307381,
  [SMALL_STATE(8351)] = 307404,
  [SMALL_STATE(8352)] = 307425,
  [SMALL_STATE(8353)] = 307442,
  [SMALL_STATE(8354)] = 307459,
  [SMALL_STATE(8355)] = 307478,
  [SMALL_STATE(8356)] = 307501,
  [SMALL_STATE(8357)] = 307520,
  [SMALL_STATE(8358)] = 307537,
  [SMALL_STATE(8359)] = 307560,
  [SMALL_STATE(8360)] = 307585,
  [SMALL_STATE(8361)] = 307601,
  [SMALL_STATE(8362)] = 307619,
  [SMALL_STATE(8363)] = 307639,
  [SMALL_STATE(8364)] = 307657,
  [SMALL_STATE(8365)] = 307677,
  [SMALL_STATE(8366)] = 307695,
  [SMALL_STATE(8367)] = 307715,
  [SMALL_STATE(8368)] = 307731,
  [SMALL_STATE(8369)] = 307745,
  [SMALL_STATE(8370)] = 307765,
  [SMALL_STATE(8371)] = 307785,
  [SMALL_STATE(8372)] = 307805,
  [SMALL_STATE(8373)] = 307825,
  [SMALL_STATE(8374)] = 307845,
  [SMALL_STATE(8375)] = 307861,
  [SMALL_STATE(8376)] = 307879,
  [SMALL_STATE(8377)] = 307893,
  [SMALL_STATE(8378)] = 307907,
  [SMALL_STATE(8379)] = 307923,
  [SMALL_STATE(8380)] = 307945,
  [SMALL_STATE(8381)] = 307967,
  [SMALL_STATE(8382)] = 307987,
  [SMALL_STATE(8383)] = 308003,
  [SMALL_STATE(8384)] = 308023,
  [SMALL_STATE(8385)] = 308043,
  [SMALL_STATE(8386)] = 308059,
  [SMALL_STATE(8387)] = 308081,
  [SMALL_STATE(8388)] = 308101,
  [SMALL_STATE(8389)] = 308121,
  [SMALL_STATE(8390)] = 308135,
  [SMALL_STATE(8391)] = 308151,
  [SMALL_STATE(8392)] = 308171,
  [SMALL_STATE(8393)] = 308187,
  [SMALL_STATE(8394)] = 308203,
  [SMALL_STATE(8395)] = 308221,
  [SMALL_STATE(8396)] = 308241,
  [SMALL_STATE(8397)] = 308261,
  [SMALL_STATE(8398)] = 308281,
  [SMALL_STATE(8399)] = 308301,
  [SMALL_STATE(8400)] = 308315,
  [SMALL_STATE(8401)] = 308335,
  [SMALL_STATE(8402)] = 308349,
  [SMALL_STATE(8403)] = 308371,
  [SMALL_STATE(8404)] = 308387,
  [SMALL_STATE(8405)] = 308409,
  [SMALL_STATE(8406)] = 308429,
  [SMALL_STATE(8407)] = 308449,
  [SMALL_STATE(8408)] = 308471,
  [SMALL_STATE(8409)] = 308489,
  [SMALL_STATE(8410)] = 308505,
  [SMALL_STATE(8411)] = 308519,
  [SMALL_STATE(8412)] = 308539,
  [SMALL_STATE(8413)] = 308557,
  [SMALL_STATE(8414)] = 308577,
  [SMALL_STATE(8415)] = 308593,
  [SMALL_STATE(8416)] = 308609,
  [SMALL_STATE(8417)] = 308625,
  [SMALL_STATE(8418)] = 308641,
  [SMALL_STATE(8419)] = 308661,
  [SMALL_STATE(8420)] = 308681,
  [SMALL_STATE(8421)] = 308703,
  [SMALL_STATE(8422)] = 308723,
  [SMALL_STATE(8423)] = 308743,
  [SMALL_STATE(8424)] = 308765,
  [SMALL_STATE(8425)] = 308785,
  [SMALL_STATE(8426)] = 308801,
  [SMALL_STATE(8427)] = 308821,
  [SMALL_STATE(8428)] = 308837,
  [SMALL_STATE(8429)] = 308851,
  [SMALL_STATE(8430)] = 308871,
  [SMALL_STATE(8431)] = 308891,
  [SMALL_STATE(8432)] = 308907,
  [SMALL_STATE(8433)] = 308927,
  [SMALL_STATE(8434)] = 308945,
  [SMALL_STATE(8435)] = 308961,
  [SMALL_STATE(8436)] = 308979,
  [SMALL_STATE(8437)] = 309001,
  [SMALL_STATE(8438)] = 309017,
  [SMALL_STATE(8439)] = 309037,
  [SMALL_STATE(8440)] = 309055,
  [SMALL_STATE(8441)] = 309069,
  [SMALL_STATE(8442)] = 309091,
  [SMALL_STATE(8443)] = 309107,
  [SMALL_STATE(8444)] = 309127,
  [SMALL_STATE(8445)] = 309149,
  [SMALL_STATE(8446)] = 309169,
  [SMALL_STATE(8447)] = 309189,
  [SMALL_STATE(8448)] = 309211,
  [SMALL_STATE(8449)] = 309227,
  [SMALL_STATE(8450)] = 309247,
  [SMALL_STATE(8451)] = 309263,
  [SMALL_STATE(8452)] = 309279,
  [SMALL_STATE(8453)] = 309301,
  [SMALL_STATE(8454)] = 309321,
  [SMALL_STATE(8455)] = 309343,
  [SMALL_STATE(8456)] = 309365,
  [SMALL_STATE(8457)] = 309385,
  [SMALL_STATE(8458)] = 309401,
  [SMALL_STATE(8459)] = 309421,
  [SMALL_STATE(8460)] = 309437,
  [SMALL_STATE(8461)] = 309455,
  [SMALL_STATE(8462)] = 309477,
  [SMALL_STATE(8463)] = 309493,
  [SMALL_STATE(8464)] = 309513,
  [SMALL_STATE(8465)] = 309533,
  [SMALL_STATE(8466)] = 309549,
  [SMALL_STATE(8467)] = 309569,
  [SMALL_STATE(8468)] = 309589,
  [SMALL_STATE(8469)] = 309605,
  [SMALL_STATE(8470)] = 309619,
  [SMALL_STATE(8471)] = 309639,
  [SMALL_STATE(8472)] = 309655,
  [SMALL_STATE(8473)] = 309675,
  [SMALL_STATE(8474)] = 309691,
  [SMALL_STATE(8475)] = 309709,
  [SMALL_STATE(8476)] = 309731,
  [SMALL_STATE(8477)] = 309753,
  [SMALL_STATE(8478)] = 309775,
  [SMALL_STATE(8479)] = 309797,
  [SMALL_STATE(8480)] = 309813,
  [SMALL_STATE(8481)] = 309833,
  [SMALL_STATE(8482)] = 309851,
  [SMALL_STATE(8483)] = 309869,
  [SMALL_STATE(8484)] = 309889,
  [SMALL_STATE(8485)] = 309907,
  [SMALL_STATE(8486)] = 309921,
  [SMALL_STATE(8487)] = 309943,
  [SMALL_STATE(8488)] = 309961,
  [SMALL_STATE(8489)] = 309979,
  [SMALL_STATE(8490)] = 309995,
  [SMALL_STATE(8491)] = 310013,
  [SMALL_STATE(8492)] = 310035,
  [SMALL_STATE(8493)] = 310049,
  [SMALL_STATE(8494)] = 310067,
  [SMALL_STATE(8495)] = 310089,
  [SMALL_STATE(8496)] = 310109,
  [SMALL_STATE(8497)] = 310123,
  [SMALL_STATE(8498)] = 310141,
  [SMALL_STATE(8499)] = 310155,
  [SMALL_STATE(8500)] = 310171,
  [SMALL_STATE(8501)] = 310189,
  [SMALL_STATE(8502)] = 310207,
  [SMALL_STATE(8503)] = 310229,
  [SMALL_STATE(8504)] = 310245,
  [SMALL_STATE(8505)] = 310259,
  [SMALL_STATE(8506)] = 310273,
  [SMALL_STATE(8507)] = 310289,
  [SMALL_STATE(8508)] = 310307,
  [SMALL_STATE(8509)] = 310327,
  [SMALL_STATE(8510)] = 310347,
  [SMALL_STATE(8511)] = 310367,
  [SMALL_STATE(8512)] = 310381,
  [SMALL_STATE(8513)] = 310399,
  [SMALL_STATE(8514)] = 310419,
  [SMALL_STATE(8515)] = 310439,
  [SMALL_STATE(8516)] = 310455,
  [SMALL_STATE(8517)] = 310471,
  [SMALL_STATE(8518)] = 310491,
  [SMALL_STATE(8519)] = 310513,
  [SMALL_STATE(8520)] = 310529,
  [SMALL_STATE(8521)] = 310545,
  [SMALL_STATE(8522)] = 310559,
  [SMALL_STATE(8523)] = 310573,
  [SMALL_STATE(8524)] = 310595,
  [SMALL_STATE(8525)] = 310613,
  [SMALL_STATE(8526)] = 310633,
  [SMALL_STATE(8527)] = 310650,
  [SMALL_STATE(8528)] = 310669,
  [SMALL_STATE(8529)] = 310684,
  [SMALL_STATE(8530)] = 310703,
  [SMALL_STATE(8531)] = 310722,
  [SMALL_STATE(8532)] = 310741,
  [SMALL_STATE(8533)] = 310760,
  [SMALL_STATE(8534)] = 310775,
  [SMALL_STATE(8535)] = 310790,
  [SMALL_STATE(8536)] = 310807,
  [SMALL_STATE(8537)] = 310824,
  [SMALL_STATE(8538)] = 310843,
  [SMALL_STATE(8539)] = 310860,
  [SMALL_STATE(8540)] = 310879,
  [SMALL_STATE(8541)] = 310892,
  [SMALL_STATE(8542)] = 310909,
  [SMALL_STATE(8543)] = 310928,
  [SMALL_STATE(8544)] = 310947,
  [SMALL_STATE(8545)] = 310966,
  [SMALL_STATE(8546)] = 310985,
  [SMALL_STATE(8547)] = 311004,
  [SMALL_STATE(8548)] = 311023,
  [SMALL_STATE(8549)] = 311042,
  [SMALL_STATE(8550)] = 311061,
  [SMALL_STATE(8551)] = 311074,
  [SMALL_STATE(8552)] = 311089,
  [SMALL_STATE(8553)] = 311108,
  [SMALL_STATE(8554)] = 311125,
  [SMALL_STATE(8555)] = 311144,
  [SMALL_STATE(8556)] = 311163,
  [SMALL_STATE(8557)] = 311178,
  [SMALL_STATE(8558)] = 311197,
  [SMALL_STATE(8559)] = 311216,
  [SMALL_STATE(8560)] = 311235,
  [SMALL_STATE(8561)] = 311248,
  [SMALL_STATE(8562)] = 311263,
  [SMALL_STATE(8563)] = 311282,
  [SMALL_STATE(8564)] = 311301,
  [SMALL_STATE(8565)] = 311320,
  [SMALL_STATE(8566)] = 311339,
  [SMALL_STATE(8567)] = 311358,
  [SMALL_STATE(8568)] = 311377,
  [SMALL_STATE(8569)] = 311396,
  [SMALL_STATE(8570)] = 311415,
  [SMALL_STATE(8571)] = 311434,
  [SMALL_STATE(8572)] = 311451,
  [SMALL_STATE(8573)] = 311470,
  [SMALL_STATE(8574)] = 311489,
  [SMALL_STATE(8575)] = 311508,
  [SMALL_STATE(8576)] = 311527,
  [SMALL_STATE(8577)] = 311546,
  [SMALL_STATE(8578)] = 311565,
  [SMALL_STATE(8579)] = 311584,
  [SMALL_STATE(8580)] = 311603,
  [SMALL_STATE(8581)] = 311622,
  [SMALL_STATE(8582)] = 311641,
  [SMALL_STATE(8583)] = 311660,
  [SMALL_STATE(8584)] = 311679,
  [SMALL_STATE(8585)] = 311698,
  [SMALL_STATE(8586)] = 311717,
  [SMALL_STATE(8587)] = 311736,
  [SMALL_STATE(8588)] = 311753,
  [SMALL_STATE(8589)] = 311768,
  [SMALL_STATE(8590)] = 311783,
  [SMALL_STATE(8591)] = 311800,
  [SMALL_STATE(8592)] = 311815,
  [SMALL_STATE(8593)] = 311834,
  [SMALL_STATE(8594)] = 311853,
  [SMALL_STATE(8595)] = 311868,
  [SMALL_STATE(8596)] = 311883,
  [SMALL_STATE(8597)] = 311898,
  [SMALL_STATE(8598)] = 311917,
  [SMALL_STATE(8599)] = 311932,
  [SMALL_STATE(8600)] = 311945,
  [SMALL_STATE(8601)] = 311964,
  [SMALL_STATE(8602)] = 311981,
  [SMALL_STATE(8603)] = 311996,
  [SMALL_STATE(8604)] = 312010,
  [SMALL_STATE(8605)] = 312024,
  [SMALL_STATE(8606)] = 312038,
  [SMALL_STATE(8607)] = 312054,
  [SMALL_STATE(8608)] = 312070,
  [SMALL_STATE(8609)] = 312086,
  [SMALL_STATE(8610)] = 312102,
  [SMALL_STATE(8611)] = 312118,
  [SMALL_STATE(8612)] = 312132,
  [SMALL_STATE(8613)] = 312148,
  [SMALL_STATE(8614)] = 312164,
  [SMALL_STATE(8615)] = 312180,
  [SMALL_STATE(8616)] = 312196,
  [SMALL_STATE(8617)] = 312210,
  [SMALL_STATE(8618)] = 312226,
  [SMALL_STATE(8619)] = 312240,
  [SMALL_STATE(8620)] = 312256,
  [SMALL_STATE(8621)] = 312270,
  [SMALL_STATE(8622)] = 312286,
  [SMALL_STATE(8623)] = 312302,
  [SMALL_STATE(8624)] = 312316,
  [SMALL_STATE(8625)] = 312330,
  [SMALL_STATE(8626)] = 312346,
  [SMALL_STATE(8627)] = 312362,
  [SMALL_STATE(8628)] = 312378,
  [SMALL_STATE(8629)] = 312394,
  [SMALL_STATE(8630)] = 312408,
  [SMALL_STATE(8631)] = 312424,
  [SMALL_STATE(8632)] = 312440,
  [SMALL_STATE(8633)] = 312454,
  [SMALL_STATE(8634)] = 312468,
  [SMALL_STATE(8635)] = 312484,
  [SMALL_STATE(8636)] = 312500,
  [SMALL_STATE(8637)] = 312516,
  [SMALL_STATE(8638)] = 312532,
  [SMALL_STATE(8639)] = 312546,
  [SMALL_STATE(8640)] = 312562,
  [SMALL_STATE(8641)] = 312578,
  [SMALL_STATE(8642)] = 312594,
  [SMALL_STATE(8643)] = 312608,
  [SMALL_STATE(8644)] = 312624,
  [SMALL_STATE(8645)] = 312640,
  [SMALL_STATE(8646)] = 312654,
  [SMALL_STATE(8647)] = 312670,
  [SMALL_STATE(8648)] = 312684,
  [SMALL_STATE(8649)] = 312700,
  [SMALL_STATE(8650)] = 312716,
  [SMALL_STATE(8651)] = 312730,
  [SMALL_STATE(8652)] = 312746,
  [SMALL_STATE(8653)] = 312762,
  [SMALL_STATE(8654)] = 312778,
  [SMALL_STATE(8655)] = 312792,
  [SMALL_STATE(8656)] = 312806,
  [SMALL_STATE(8657)] = 312822,
  [SMALL_STATE(8658)] = 312836,
  [SMALL_STATE(8659)] = 312852,
  [SMALL_STATE(8660)] = 312868,
  [SMALL_STATE(8661)] = 312884,
  [SMALL_STATE(8662)] = 312898,
  [SMALL_STATE(8663)] = 312912,
  [SMALL_STATE(8664)] = 312926,
  [SMALL_STATE(8665)] = 312940,
  [SMALL_STATE(8666)] = 312954,
  [SMALL_STATE(8667)] = 312970,
  [SMALL_STATE(8668)] = 312980,
  [SMALL_STATE(8669)] = 312996,
  [SMALL_STATE(8670)] = 313012,
  [SMALL_STATE(8671)] = 313028,
  [SMALL_STATE(8672)] = 313038,
  [SMALL_STATE(8673)] = 313052,
  [SMALL_STATE(8674)] = 313066,
  [SMALL_STATE(8675)] = 313080,
  [SMALL_STATE(8676)] = 313090,
  [SMALL_STATE(8677)] = 313104,
  [SMALL_STATE(8678)] = 313120,
  [SMALL_STATE(8679)] = 313136,
  [SMALL_STATE(8680)] = 313152,
  [SMALL_STATE(8681)] = 313168,
  [SMALL_STATE(8682)] = 313180,
  [SMALL_STATE(8683)] = 313196,
  [SMALL_STATE(8684)] = 313212,
  [SMALL_STATE(8685)] = 313226,
  [SMALL_STATE(8686)] = 313240,
  [SMALL_STATE(8687)] = 313256,
  [SMALL_STATE(8688)] = 313272,
  [SMALL_STATE(8689)] = 313288,
  [SMALL_STATE(8690)] = 313304,
  [SMALL_STATE(8691)] = 313318,
  [SMALL_STATE(8692)] = 313334,
  [SMALL_STATE(8693)] = 313348,
  [SMALL_STATE(8694)] = 313364,
  [SMALL_STATE(8695)] = 313380,
  [SMALL_STATE(8696)] = 313396,
  [SMALL_STATE(8697)] = 313412,
  [SMALL_STATE(8698)] = 313428,
  [SMALL_STATE(8699)] = 313442,
  [SMALL_STATE(8700)] = 313456,
  [SMALL_STATE(8701)] = 313472,
  [SMALL_STATE(8702)] = 313486,
  [SMALL_STATE(8703)] = 313502,
  [SMALL_STATE(8704)] = 313518,
  [SMALL_STATE(8705)] = 313534,
  [SMALL_STATE(8706)] = 313550,
  [SMALL_STATE(8707)] = 313564,
  [SMALL_STATE(8708)] = 313580,
  [SMALL_STATE(8709)] = 313596,
  [SMALL_STATE(8710)] = 313610,
  [SMALL_STATE(8711)] = 313626,
  [SMALL_STATE(8712)] = 313640,
  [SMALL_STATE(8713)] = 313656,
  [SMALL_STATE(8714)] = 313670,
  [SMALL_STATE(8715)] = 313686,
  [SMALL_STATE(8716)] = 313702,
  [SMALL_STATE(8717)] = 313718,
  [SMALL_STATE(8718)] = 313734,
  [SMALL_STATE(8719)] = 313748,
  [SMALL_STATE(8720)] = 313762,
  [SMALL_STATE(8721)] = 313776,
  [SMALL_STATE(8722)] = 313792,
  [SMALL_STATE(8723)] = 313806,
  [SMALL_STATE(8724)] = 313820,
  [SMALL_STATE(8725)] = 313836,
  [SMALL_STATE(8726)] = 313850,
  [SMALL_STATE(8727)] = 313864,
  [SMALL_STATE(8728)] = 313880,
  [SMALL_STATE(8729)] = 313896,
  [SMALL_STATE(8730)] = 313912,
  [SMALL_STATE(8731)] = 313928,
  [SMALL_STATE(8732)] = 313944,
  [SMALL_STATE(8733)] = 313960,
  [SMALL_STATE(8734)] = 313974,
  [SMALL_STATE(8735)] = 313988,
  [SMALL_STATE(8736)] = 314004,
  [SMALL_STATE(8737)] = 314020,
  [SMALL_STATE(8738)] = 314034,
  [SMALL_STATE(8739)] = 314048,
  [SMALL_STATE(8740)] = 314064,
  [SMALL_STATE(8741)] = 314078,
  [SMALL_STATE(8742)] = 314094,
  [SMALL_STATE(8743)] = 314110,
  [SMALL_STATE(8744)] = 314126,
  [SMALL_STATE(8745)] = 314140,
  [SMALL_STATE(8746)] = 314154,
  [SMALL_STATE(8747)] = 314170,
  [SMALL_STATE(8748)] = 314186,
  [SMALL_STATE(8749)] = 314200,
  [SMALL_STATE(8750)] = 314212,
  [SMALL_STATE(8751)] = 314226,
  [SMALL_STATE(8752)] = 314242,
  [SMALL_STATE(8753)] = 314256,
  [SMALL_STATE(8754)] = 314272,
  [SMALL_STATE(8755)] = 314288,
  [SMALL_STATE(8756)] = 314304,
  [SMALL_STATE(8757)] = 314320,
  [SMALL_STATE(8758)] = 314334,
  [SMALL_STATE(8759)] = 314346,
  [SMALL_STATE(8760)] = 314360,
  [SMALL_STATE(8761)] = 314374,
  [SMALL_STATE(8762)] = 314388,
  [SMALL_STATE(8763)] = 314404,
  [SMALL_STATE(8764)] = 314420,
  [SMALL_STATE(8765)] = 314436,
  [SMALL_STATE(8766)] = 314452,
  [SMALL_STATE(8767)] = 314468,
  [SMALL_STATE(8768)] = 314484,
  [SMALL_STATE(8769)] = 314500,
  [SMALL_STATE(8770)] = 314516,
  [SMALL_STATE(8771)] = 314530,
  [SMALL_STATE(8772)] = 314546,
  [SMALL_STATE(8773)] = 314562,
  [SMALL_STATE(8774)] = 314578,
  [SMALL_STATE(8775)] = 314592,
  [SMALL_STATE(8776)] = 314608,
  [SMALL_STATE(8777)] = 314624,
  [SMALL_STATE(8778)] = 314640,
  [SMALL_STATE(8779)] = 314654,
  [SMALL_STATE(8780)] = 314670,
  [SMALL_STATE(8781)] = 314686,
  [SMALL_STATE(8782)] = 314702,
  [SMALL_STATE(8783)] = 314716,
  [SMALL_STATE(8784)] = 314730,
  [SMALL_STATE(8785)] = 314746,
  [SMALL_STATE(8786)] = 314762,
  [SMALL_STATE(8787)] = 314778,
  [SMALL_STATE(8788)] = 314794,
  [SMALL_STATE(8789)] = 314808,
  [SMALL_STATE(8790)] = 314822,
  [SMALL_STATE(8791)] = 314836,
  [SMALL_STATE(8792)] = 314852,
  [SMALL_STATE(8793)] = 314866,
  [SMALL_STATE(8794)] = 314880,
  [SMALL_STATE(8795)] = 314894,
  [SMALL_STATE(8796)] = 314910,
  [SMALL_STATE(8797)] = 314924,
  [SMALL_STATE(8798)] = 314940,
  [SMALL_STATE(8799)] = 314954,
  [SMALL_STATE(8800)] = 314968,
  [SMALL_STATE(8801)] = 314984,
  [SMALL_STATE(8802)] = 315000,
  [SMALL_STATE(8803)] = 315014,
  [SMALL_STATE(8804)] = 315030,
  [SMALL_STATE(8805)] = 315046,
  [SMALL_STATE(8806)] = 315062,
  [SMALL_STATE(8807)] = 315078,
  [SMALL_STATE(8808)] = 315092,
  [SMALL_STATE(8809)] = 315108,
  [SMALL_STATE(8810)] = 315124,
  [SMALL_STATE(8811)] = 315138,
  [SMALL_STATE(8812)] = 315154,
  [SMALL_STATE(8813)] = 315170,
  [SMALL_STATE(8814)] = 315184,
  [SMALL_STATE(8815)] = 315200,
  [SMALL_STATE(8816)] = 315216,
  [SMALL_STATE(8817)] = 315230,
  [SMALL_STATE(8818)] = 315244,
  [SMALL_STATE(8819)] = 315258,
  [SMALL_STATE(8820)] = 315272,
  [SMALL_STATE(8821)] = 315286,
  [SMALL_STATE(8822)] = 315300,
  [SMALL_STATE(8823)] = 315316,
  [SMALL_STATE(8824)] = 315330,
  [SMALL_STATE(8825)] = 315346,
  [SMALL_STATE(8826)] = 315362,
  [SMALL_STATE(8827)] = 315378,
  [SMALL_STATE(8828)] = 315392,
  [SMALL_STATE(8829)] = 315406,
  [SMALL_STATE(8830)] = 315420,
  [SMALL_STATE(8831)] = 315436,
  [SMALL_STATE(8832)] = 315452,
  [SMALL_STATE(8833)] = 315468,
  [SMALL_STATE(8834)] = 315480,
  [SMALL_STATE(8835)] = 315496,
  [SMALL_STATE(8836)] = 315512,
  [SMALL_STATE(8837)] = 315528,
  [SMALL_STATE(8838)] = 315544,
  [SMALL_STATE(8839)] = 315558,
  [SMALL_STATE(8840)] = 315574,
  [SMALL_STATE(8841)] = 315588,
  [SMALL_STATE(8842)] = 315602,
  [SMALL_STATE(8843)] = 315618,
  [SMALL_STATE(8844)] = 315632,
  [SMALL_STATE(8845)] = 315648,
  [SMALL_STATE(8846)] = 315664,
  [SMALL_STATE(8847)] = 315680,
  [SMALL_STATE(8848)] = 315696,
  [SMALL_STATE(8849)] = 315710,
  [SMALL_STATE(8850)] = 315726,
  [SMALL_STATE(8851)] = 315740,
  [SMALL_STATE(8852)] = 315756,
  [SMALL_STATE(8853)] = 315772,
  [SMALL_STATE(8854)] = 315788,
  [SMALL_STATE(8855)] = 315804,
  [SMALL_STATE(8856)] = 315818,
  [SMALL_STATE(8857)] = 315834,
  [SMALL_STATE(8858)] = 315848,
  [SMALL_STATE(8859)] = 315862,
  [SMALL_STATE(8860)] = 315872,
  [SMALL_STATE(8861)] = 315886,
  [SMALL_STATE(8862)] = 315902,
  [SMALL_STATE(8863)] = 315916,
  [SMALL_STATE(8864)] = 315930,
  [SMALL_STATE(8865)] = 315946,
  [SMALL_STATE(8866)] = 315962,
  [SMALL_STATE(8867)] = 315976,
  [SMALL_STATE(8868)] = 315992,
  [SMALL_STATE(8869)] = 316006,
  [SMALL_STATE(8870)] = 316018,
  [SMALL_STATE(8871)] = 316034,
  [SMALL_STATE(8872)] = 316048,
  [SMALL_STATE(8873)] = 316064,
  [SMALL_STATE(8874)] = 316080,
  [SMALL_STATE(8875)] = 316094,
  [SMALL_STATE(8876)] = 316110,
  [SMALL_STATE(8877)] = 316126,
  [SMALL_STATE(8878)] = 316142,
  [SMALL_STATE(8879)] = 316158,
  [SMALL_STATE(8880)] = 316172,
  [SMALL_STATE(8881)] = 316186,
  [SMALL_STATE(8882)] = 316202,
  [SMALL_STATE(8883)] = 316218,
  [SMALL_STATE(8884)] = 316232,
  [SMALL_STATE(8885)] = 316248,
  [SMALL_STATE(8886)] = 316264,
  [SMALL_STATE(8887)] = 316278,
  [SMALL_STATE(8888)] = 316292,
  [SMALL_STATE(8889)] = 316308,
  [SMALL_STATE(8890)] = 316324,
  [SMALL_STATE(8891)] = 316340,
  [SMALL_STATE(8892)] = 316354,
  [SMALL_STATE(8893)] = 316368,
  [SMALL_STATE(8894)] = 316382,
  [SMALL_STATE(8895)] = 316398,
  [SMALL_STATE(8896)] = 316414,
  [SMALL_STATE(8897)] = 316428,
  [SMALL_STATE(8898)] = 316444,
  [SMALL_STATE(8899)] = 316458,
  [SMALL_STATE(8900)] = 316474,
  [SMALL_STATE(8901)] = 316490,
  [SMALL_STATE(8902)] = 316506,
  [SMALL_STATE(8903)] = 316522,
  [SMALL_STATE(8904)] = 316538,
  [SMALL_STATE(8905)] = 316554,
  [SMALL_STATE(8906)] = 316568,
  [SMALL_STATE(8907)] = 316582,
  [SMALL_STATE(8908)] = 316596,
  [SMALL_STATE(8909)] = 316610,
  [SMALL_STATE(8910)] = 316626,
  [SMALL_STATE(8911)] = 316642,
  [SMALL_STATE(8912)] = 316656,
  [SMALL_STATE(8913)] = 316672,
  [SMALL_STATE(8914)] = 316688,
  [SMALL_STATE(8915)] = 316702,
  [SMALL_STATE(8916)] = 316718,
  [SMALL_STATE(8917)] = 316732,
  [SMALL_STATE(8918)] = 316746,
  [SMALL_STATE(8919)] = 316760,
  [SMALL_STATE(8920)] = 316776,
  [SMALL_STATE(8921)] = 316792,
  [SMALL_STATE(8922)] = 316808,
  [SMALL_STATE(8923)] = 316824,
  [SMALL_STATE(8924)] = 316838,
  [SMALL_STATE(8925)] = 316854,
  [SMALL_STATE(8926)] = 316868,
  [SMALL_STATE(8927)] = 316884,
  [SMALL_STATE(8928)] = 316898,
  [SMALL_STATE(8929)] = 316914,
  [SMALL_STATE(8930)] = 316928,
  [SMALL_STATE(8931)] = 316944,
  [SMALL_STATE(8932)] = 316958,
  [SMALL_STATE(8933)] = 316974,
  [SMALL_STATE(8934)] = 316990,
  [SMALL_STATE(8935)] = 317006,
  [SMALL_STATE(8936)] = 317022,
  [SMALL_STATE(8937)] = 317038,
  [SMALL_STATE(8938)] = 317054,
  [SMALL_STATE(8939)] = 317068,
  [SMALL_STATE(8940)] = 317084,
  [SMALL_STATE(8941)] = 317097,
  [SMALL_STATE(8942)] = 317110,
  [SMALL_STATE(8943)] = 317123,
  [SMALL_STATE(8944)] = 317136,
  [SMALL_STATE(8945)] = 317149,
  [SMALL_STATE(8946)] = 317162,
  [SMALL_STATE(8947)] = 317175,
  [SMALL_STATE(8948)] = 317188,
  [SMALL_STATE(8949)] = 317201,
  [SMALL_STATE(8950)] = 317214,
  [SMALL_STATE(8951)] = 317227,
  [SMALL_STATE(8952)] = 317240,
  [SMALL_STATE(8953)] = 317253,
  [SMALL_STATE(8954)] = 317266,
  [SMALL_STATE(8955)] = 317279,
  [SMALL_STATE(8956)] = 317292,
  [SMALL_STATE(8957)] = 317305,
  [SMALL_STATE(8958)] = 317318,
  [SMALL_STATE(8959)] = 317331,
  [SMALL_STATE(8960)] = 317344,
  [SMALL_STATE(8961)] = 317357,
  [SMALL_STATE(8962)] = 317370,
  [SMALL_STATE(8963)] = 317383,
  [SMALL_STATE(8964)] = 317396,
  [SMALL_STATE(8965)] = 317409,
  [SMALL_STATE(8966)] = 317422,
  [SMALL_STATE(8967)] = 317435,
  [SMALL_STATE(8968)] = 317448,
  [SMALL_STATE(8969)] = 317461,
  [SMALL_STATE(8970)] = 317474,
  [SMALL_STATE(8971)] = 317487,
  [SMALL_STATE(8972)] = 317500,
  [SMALL_STATE(8973)] = 317513,
  [SMALL_STATE(8974)] = 317526,
  [SMALL_STATE(8975)] = 317539,
  [SMALL_STATE(8976)] = 317552,
  [SMALL_STATE(8977)] = 317563,
  [SMALL_STATE(8978)] = 317576,
  [SMALL_STATE(8979)] = 317589,
  [SMALL_STATE(8980)] = 317602,
  [SMALL_STATE(8981)] = 317615,
  [SMALL_STATE(8982)] = 317628,
  [SMALL_STATE(8983)] = 317641,
  [SMALL_STATE(8984)] = 317654,
  [SMALL_STATE(8985)] = 317667,
  [SMALL_STATE(8986)] = 317680,
  [SMALL_STATE(8987)] = 317693,
  [SMALL_STATE(8988)] = 317702,
  [SMALL_STATE(8989)] = 317715,
  [SMALL_STATE(8990)] = 317728,
  [SMALL_STATE(8991)] = 317741,
  [SMALL_STATE(8992)] = 317754,
  [SMALL_STATE(8993)] = 317767,
  [SMALL_STATE(8994)] = 317778,
  [SMALL_STATE(8995)] = 317791,
  [SMALL_STATE(8996)] = 317804,
  [SMALL_STATE(8997)] = 317817,
  [SMALL_STATE(8998)] = 317828,
  [SMALL_STATE(8999)] = 317841,
  [SMALL_STATE(9000)] = 317854,
  [SMALL_STATE(9001)] = 317867,
  [SMALL_STATE(9002)] = 317880,
  [SMALL_STATE(9003)] = 317893,
  [SMALL_STATE(9004)] = 317906,
  [SMALL_STATE(9005)] = 317919,
  [SMALL_STATE(9006)] = 317932,
  [SMALL_STATE(9007)] = 317945,
  [SMALL_STATE(9008)] = 317958,
  [SMALL_STATE(9009)] = 317971,
  [SMALL_STATE(9010)] = 317982,
  [SMALL_STATE(9011)] = 317995,
  [SMALL_STATE(9012)] = 318008,
  [SMALL_STATE(9013)] = 318021,
  [SMALL_STATE(9014)] = 318032,
  [SMALL_STATE(9015)] = 318045,
  [SMALL_STATE(9016)] = 318058,
  [SMALL_STATE(9017)] = 318071,
  [SMALL_STATE(9018)] = 318084,
  [SMALL_STATE(9019)] = 318097,
  [SMALL_STATE(9020)] = 318110,
  [SMALL_STATE(9021)] = 318121,
  [SMALL_STATE(9022)] = 318134,
  [SMALL_STATE(9023)] = 318147,
  [SMALL_STATE(9024)] = 318160,
  [SMALL_STATE(9025)] = 318173,
  [SMALL_STATE(9026)] = 318186,
  [SMALL_STATE(9027)] = 318195,
  [SMALL_STATE(9028)] = 318208,
  [SMALL_STATE(9029)] = 318221,
  [SMALL_STATE(9030)] = 318234,
  [SMALL_STATE(9031)] = 318247,
  [SMALL_STATE(9032)] = 318260,
  [SMALL_STATE(9033)] = 318273,
  [SMALL_STATE(9034)] = 318284,
  [SMALL_STATE(9035)] = 318297,
  [SMALL_STATE(9036)] = 318310,
  [SMALL_STATE(9037)] = 318323,
  [SMALL_STATE(9038)] = 318336,
  [SMALL_STATE(9039)] = 318349,
  [SMALL_STATE(9040)] = 318362,
  [SMALL_STATE(9041)] = 318375,
  [SMALL_STATE(9042)] = 318388,
  [SMALL_STATE(9043)] = 318401,
  [SMALL_STATE(9044)] = 318414,
  [SMALL_STATE(9045)] = 318427,
  [SMALL_STATE(9046)] = 318440,
  [SMALL_STATE(9047)] = 318453,
  [SMALL_STATE(9048)] = 318466,
  [SMALL_STATE(9049)] = 318479,
  [SMALL_STATE(9050)] = 318492,
  [SMALL_STATE(9051)] = 318505,
  [SMALL_STATE(9052)] = 318518,
  [SMALL_STATE(9053)] = 318529,
  [SMALL_STATE(9054)] = 318542,
  [SMALL_STATE(9055)] = 318555,
  [SMALL_STATE(9056)] = 318564,
  [SMALL_STATE(9057)] = 318577,
  [SMALL_STATE(9058)] = 318590,
  [SMALL_STATE(9059)] = 318603,
  [SMALL_STATE(9060)] = 318616,
  [SMALL_STATE(9061)] = 318629,
  [SMALL_STATE(9062)] = 318642,
  [SMALL_STATE(9063)] = 318655,
  [SMALL_STATE(9064)] = 318668,
  [SMALL_STATE(9065)] = 318681,
  [SMALL_STATE(9066)] = 318694,
  [SMALL_STATE(9067)] = 318707,
  [SMALL_STATE(9068)] = 318720,
  [SMALL_STATE(9069)] = 318733,
  [SMALL_STATE(9070)] = 318746,
  [SMALL_STATE(9071)] = 318759,
  [SMALL_STATE(9072)] = 318772,
  [SMALL_STATE(9073)] = 318785,
  [SMALL_STATE(9074)] = 318798,
  [SMALL_STATE(9075)] = 318811,
  [SMALL_STATE(9076)] = 318824,
  [SMALL_STATE(9077)] = 318837,
  [SMALL_STATE(9078)] = 318850,
  [SMALL_STATE(9079)] = 318863,
  [SMALL_STATE(9080)] = 318876,
  [SMALL_STATE(9081)] = 318889,
  [SMALL_STATE(9082)] = 318902,
  [SMALL_STATE(9083)] = 318915,
  [SMALL_STATE(9084)] = 318928,
  [SMALL_STATE(9085)] = 318941,
  [SMALL_STATE(9086)] = 318954,
  [SMALL_STATE(9087)] = 318967,
  [SMALL_STATE(9088)] = 318980,
  [SMALL_STATE(9089)] = 318993,
  [SMALL_STATE(9090)] = 319006,
  [SMALL_STATE(9091)] = 319019,
  [SMALL_STATE(9092)] = 319032,
  [SMALL_STATE(9093)] = 319045,
  [SMALL_STATE(9094)] = 319058,
  [SMALL_STATE(9095)] = 319071,
  [SMALL_STATE(9096)] = 319084,
  [SMALL_STATE(9097)] = 319097,
  [SMALL_STATE(9098)] = 319108,
  [SMALL_STATE(9099)] = 319121,
  [SMALL_STATE(9100)] = 319134,
  [SMALL_STATE(9101)] = 319147,
  [SMALL_STATE(9102)] = 319160,
  [SMALL_STATE(9103)] = 319173,
  [SMALL_STATE(9104)] = 319186,
  [SMALL_STATE(9105)] = 319199,
  [SMALL_STATE(9106)] = 319212,
  [SMALL_STATE(9107)] = 319225,
  [SMALL_STATE(9108)] = 319236,
  [SMALL_STATE(9109)] = 319249,
  [SMALL_STATE(9110)] = 319262,
  [SMALL_STATE(9111)] = 319271,
  [SMALL_STATE(9112)] = 319284,
  [SMALL_STATE(9113)] = 319297,
  [SMALL_STATE(9114)] = 319306,
  [SMALL_STATE(9115)] = 319319,
  [SMALL_STATE(9116)] = 319332,
  [SMALL_STATE(9117)] = 319345,
  [SMALL_STATE(9118)] = 319358,
  [SMALL_STATE(9119)] = 319371,
  [SMALL_STATE(9120)] = 319380,
  [SMALL_STATE(9121)] = 319393,
  [SMALL_STATE(9122)] = 319406,
  [SMALL_STATE(9123)] = 319419,
  [SMALL_STATE(9124)] = 319432,
  [SMALL_STATE(9125)] = 319445,
  [SMALL_STATE(9126)] = 319458,
  [SMALL_STATE(9127)] = 319469,
  [SMALL_STATE(9128)] = 319482,
  [SMALL_STATE(9129)] = 319495,
  [SMALL_STATE(9130)] = 319508,
  [SMALL_STATE(9131)] = 319521,
  [SMALL_STATE(9132)] = 319534,
  [SMALL_STATE(9133)] = 319547,
  [SMALL_STATE(9134)] = 319560,
  [SMALL_STATE(9135)] = 319573,
  [SMALL_STATE(9136)] = 319586,
  [SMALL_STATE(9137)] = 319599,
  [SMALL_STATE(9138)] = 319612,
  [SMALL_STATE(9139)] = 319623,
  [SMALL_STATE(9140)] = 319636,
  [SMALL_STATE(9141)] = 319649,
  [SMALL_STATE(9142)] = 319662,
  [SMALL_STATE(9143)] = 319675,
  [SMALL_STATE(9144)] = 319688,
  [SMALL_STATE(9145)] = 319701,
  [SMALL_STATE(9146)] = 319714,
  [SMALL_STATE(9147)] = 319727,
  [SMALL_STATE(9148)] = 319740,
  [SMALL_STATE(9149)] = 319753,
  [SMALL_STATE(9150)] = 319766,
  [SMALL_STATE(9151)] = 319779,
  [SMALL_STATE(9152)] = 319792,
  [SMALL_STATE(9153)] = 319805,
  [SMALL_STATE(9154)] = 319816,
  [SMALL_STATE(9155)] = 319829,
  [SMALL_STATE(9156)] = 319842,
  [SMALL_STATE(9157)] = 319855,
  [SMALL_STATE(9158)] = 319868,
  [SMALL_STATE(9159)] = 319881,
  [SMALL_STATE(9160)] = 319894,
  [SMALL_STATE(9161)] = 319907,
  [SMALL_STATE(9162)] = 319920,
  [SMALL_STATE(9163)] = 319933,
  [SMALL_STATE(9164)] = 319946,
  [SMALL_STATE(9165)] = 319959,
  [SMALL_STATE(9166)] = 319972,
  [SMALL_STATE(9167)] = 319985,
  [SMALL_STATE(9168)] = 319998,
  [SMALL_STATE(9169)] = 320011,
  [SMALL_STATE(9170)] = 320024,
  [SMALL_STATE(9171)] = 320037,
  [SMALL_STATE(9172)] = 320050,
  [SMALL_STATE(9173)] = 320063,
  [SMALL_STATE(9174)] = 320076,
  [SMALL_STATE(9175)] = 320089,
  [SMALL_STATE(9176)] = 320098,
  [SMALL_STATE(9177)] = 320111,
  [SMALL_STATE(9178)] = 320124,
  [SMALL_STATE(9179)] = 320137,
  [SMALL_STATE(9180)] = 320150,
  [SMALL_STATE(9181)] = 320163,
  [SMALL_STATE(9182)] = 320176,
  [SMALL_STATE(9183)] = 320189,
  [SMALL_STATE(9184)] = 320202,
  [SMALL_STATE(9185)] = 320215,
  [SMALL_STATE(9186)] = 320228,
  [SMALL_STATE(9187)] = 320241,
  [SMALL_STATE(9188)] = 320254,
  [SMALL_STATE(9189)] = 320267,
  [SMALL_STATE(9190)] = 320280,
  [SMALL_STATE(9191)] = 320289,
  [SMALL_STATE(9192)] = 320302,
  [SMALL_STATE(9193)] = 320315,
  [SMALL_STATE(9194)] = 320328,
  [SMALL_STATE(9195)] = 320341,
  [SMALL_STATE(9196)] = 320354,
  [SMALL_STATE(9197)] = 320365,
  [SMALL_STATE(9198)] = 320378,
  [SMALL_STATE(9199)] = 320391,
  [SMALL_STATE(9200)] = 320404,
  [SMALL_STATE(9201)] = 320417,
  [SMALL_STATE(9202)] = 320430,
  [SMALL_STATE(9203)] = 320443,
  [SMALL_STATE(9204)] = 320456,
  [SMALL_STATE(9205)] = 320469,
  [SMALL_STATE(9206)] = 320482,
  [SMALL_STATE(9207)] = 320495,
  [SMALL_STATE(9208)] = 320508,
  [SMALL_STATE(9209)] = 320517,
  [SMALL_STATE(9210)] = 320530,
  [SMALL_STATE(9211)] = 320543,
  [SMALL_STATE(9212)] = 320556,
  [SMALL_STATE(9213)] = 320569,
  [SMALL_STATE(9214)] = 320582,
  [SMALL_STATE(9215)] = 320595,
  [SMALL_STATE(9216)] = 320608,
  [SMALL_STATE(9217)] = 320621,
  [SMALL_STATE(9218)] = 320630,
  [SMALL_STATE(9219)] = 320643,
  [SMALL_STATE(9220)] = 320656,
  [SMALL_STATE(9221)] = 320669,
  [SMALL_STATE(9222)] = 320682,
  [SMALL_STATE(9223)] = 320695,
  [SMALL_STATE(9224)] = 320704,
  [SMALL_STATE(9225)] = 320717,
  [SMALL_STATE(9226)] = 320730,
  [SMALL_STATE(9227)] = 320743,
  [SMALL_STATE(9228)] = 320756,
  [SMALL_STATE(9229)] = 320769,
  [SMALL_STATE(9230)] = 320782,
  [SMALL_STATE(9231)] = 320795,
  [SMALL_STATE(9232)] = 320808,
  [SMALL_STATE(9233)] = 320821,
  [SMALL_STATE(9234)] = 320834,
  [SMALL_STATE(9235)] = 320847,
  [SMALL_STATE(9236)] = 320860,
  [SMALL_STATE(9237)] = 320873,
  [SMALL_STATE(9238)] = 320886,
  [SMALL_STATE(9239)] = 320899,
  [SMALL_STATE(9240)] = 320912,
  [SMALL_STATE(9241)] = 320925,
  [SMALL_STATE(9242)] = 320938,
  [SMALL_STATE(9243)] = 320951,
  [SMALL_STATE(9244)] = 320964,
  [SMALL_STATE(9245)] = 320977,
  [SMALL_STATE(9246)] = 320988,
  [SMALL_STATE(9247)] = 321001,
  [SMALL_STATE(9248)] = 321014,
  [SMALL_STATE(9249)] = 321027,
  [SMALL_STATE(9250)] = 321040,
  [SMALL_STATE(9251)] = 321051,
  [SMALL_STATE(9252)] = 321062,
  [SMALL_STATE(9253)] = 321075,
  [SMALL_STATE(9254)] = 321088,
  [SMALL_STATE(9255)] = 321101,
  [SMALL_STATE(9256)] = 321114,
  [SMALL_STATE(9257)] = 321127,
  [SMALL_STATE(9258)] = 321140,
  [SMALL_STATE(9259)] = 321153,
  [SMALL_STATE(9260)] = 321166,
  [SMALL_STATE(9261)] = 321179,
  [SMALL_STATE(9262)] = 321192,
  [SMALL_STATE(9263)] = 321203,
  [SMALL_STATE(9264)] = 321216,
  [SMALL_STATE(9265)] = 321229,
  [SMALL_STATE(9266)] = 321242,
  [SMALL_STATE(9267)] = 321253,
  [SMALL_STATE(9268)] = 321266,
  [SMALL_STATE(9269)] = 321279,
  [SMALL_STATE(9270)] = 321292,
  [SMALL_STATE(9271)] = 321305,
  [SMALL_STATE(9272)] = 321318,
  [SMALL_STATE(9273)] = 321331,
  [SMALL_STATE(9274)] = 321344,
  [SMALL_STATE(9275)] = 321357,
  [SMALL_STATE(9276)] = 321370,
  [SMALL_STATE(9277)] = 321383,
  [SMALL_STATE(9278)] = 321396,
  [SMALL_STATE(9279)] = 321405,
  [SMALL_STATE(9280)] = 321418,
  [SMALL_STATE(9281)] = 321431,
  [SMALL_STATE(9282)] = 321440,
  [SMALL_STATE(9283)] = 321453,
  [SMALL_STATE(9284)] = 321466,
  [SMALL_STATE(9285)] = 321475,
  [SMALL_STATE(9286)] = 321488,
  [SMALL_STATE(9287)] = 321501,
  [SMALL_STATE(9288)] = 321514,
  [SMALL_STATE(9289)] = 321527,
  [SMALL_STATE(9290)] = 321538,
  [SMALL_STATE(9291)] = 321551,
  [SMALL_STATE(9292)] = 321564,
  [SMALL_STATE(9293)] = 321577,
  [SMALL_STATE(9294)] = 321590,
  [SMALL_STATE(9295)] = 321603,
  [SMALL_STATE(9296)] = 321616,
  [SMALL_STATE(9297)] = 321629,
  [SMALL_STATE(9298)] = 321642,
  [SMALL_STATE(9299)] = 321655,
  [SMALL_STATE(9300)] = 321668,
  [SMALL_STATE(9301)] = 321681,
  [SMALL_STATE(9302)] = 321694,
  [SMALL_STATE(9303)] = 321707,
  [SMALL_STATE(9304)] = 321720,
  [SMALL_STATE(9305)] = 321733,
  [SMALL_STATE(9306)] = 321746,
  [SMALL_STATE(9307)] = 321757,
  [SMALL_STATE(9308)] = 321770,
  [SMALL_STATE(9309)] = 321783,
  [SMALL_STATE(9310)] = 321796,
  [SMALL_STATE(9311)] = 321805,
  [SMALL_STATE(9312)] = 321818,
  [SMALL_STATE(9313)] = 321831,
  [SMALL_STATE(9314)] = 321844,
  [SMALL_STATE(9315)] = 321857,
  [SMALL_STATE(9316)] = 321870,
  [SMALL_STATE(9317)] = 321883,
  [SMALL_STATE(9318)] = 321896,
  [SMALL_STATE(9319)] = 321909,
  [SMALL_STATE(9320)] = 321922,
  [SMALL_STATE(9321)] = 321935,
  [SMALL_STATE(9322)] = 321948,
  [SMALL_STATE(9323)] = 321961,
  [SMALL_STATE(9324)] = 321974,
  [SMALL_STATE(9325)] = 321987,
  [SMALL_STATE(9326)] = 321998,
  [SMALL_STATE(9327)] = 322011,
  [SMALL_STATE(9328)] = 322024,
  [SMALL_STATE(9329)] = 322037,
  [SMALL_STATE(9330)] = 322050,
  [SMALL_STATE(9331)] = 322063,
  [SMALL_STATE(9332)] = 322076,
  [SMALL_STATE(9333)] = 322089,
  [SMALL_STATE(9334)] = 322102,
  [SMALL_STATE(9335)] = 322115,
  [SMALL_STATE(9336)] = 322128,
  [SMALL_STATE(9337)] = 322141,
  [SMALL_STATE(9338)] = 322154,
  [SMALL_STATE(9339)] = 322167,
  [SMALL_STATE(9340)] = 322180,
  [SMALL_STATE(9341)] = 322193,
  [SMALL_STATE(9342)] = 322206,
  [SMALL_STATE(9343)] = 322219,
  [SMALL_STATE(9344)] = 322232,
  [SMALL_STATE(9345)] = 322245,
  [SMALL_STATE(9346)] = 322258,
  [SMALL_STATE(9347)] = 322271,
  [SMALL_STATE(9348)] = 322284,
  [SMALL_STATE(9349)] = 322297,
  [SMALL_STATE(9350)] = 322310,
  [SMALL_STATE(9351)] = 322323,
  [SMALL_STATE(9352)] = 322334,
  [SMALL_STATE(9353)] = 322347,
  [SMALL_STATE(9354)] = 322360,
  [SMALL_STATE(9355)] = 322371,
  [SMALL_STATE(9356)] = 322384,
  [SMALL_STATE(9357)] = 322397,
  [SMALL_STATE(9358)] = 322410,
  [SMALL_STATE(9359)] = 322423,
  [SMALL_STATE(9360)] = 322432,
  [SMALL_STATE(9361)] = 322445,
  [SMALL_STATE(9362)] = 322458,
  [SMALL_STATE(9363)] = 322471,
  [SMALL_STATE(9364)] = 322484,
  [SMALL_STATE(9365)] = 322495,
  [SMALL_STATE(9366)] = 322508,
  [SMALL_STATE(9367)] = 322521,
  [SMALL_STATE(9368)] = 322532,
  [SMALL_STATE(9369)] = 322545,
  [SMALL_STATE(9370)] = 322556,
  [SMALL_STATE(9371)] = 322569,
  [SMALL_STATE(9372)] = 322582,
  [SMALL_STATE(9373)] = 322595,
  [SMALL_STATE(9374)] = 322606,
  [SMALL_STATE(9375)] = 322617,
  [SMALL_STATE(9376)] = 322630,
  [SMALL_STATE(9377)] = 322643,
  [SMALL_STATE(9378)] = 322656,
  [SMALL_STATE(9379)] = 322669,
  [SMALL_STATE(9380)] = 322682,
  [SMALL_STATE(9381)] = 322695,
  [SMALL_STATE(9382)] = 322708,
  [SMALL_STATE(9383)] = 322717,
  [SMALL_STATE(9384)] = 322730,
  [SMALL_STATE(9385)] = 322743,
  [SMALL_STATE(9386)] = 322756,
  [SMALL_STATE(9387)] = 322769,
  [SMALL_STATE(9388)] = 322782,
  [SMALL_STATE(9389)] = 322795,
  [SMALL_STATE(9390)] = 322808,
  [SMALL_STATE(9391)] = 322821,
  [SMALL_STATE(9392)] = 322834,
  [SMALL_STATE(9393)] = 322847,
  [SMALL_STATE(9394)] = 322860,
  [SMALL_STATE(9395)] = 322873,
  [SMALL_STATE(9396)] = 322886,
  [SMALL_STATE(9397)] = 322899,
  [SMALL_STATE(9398)] = 322912,
  [SMALL_STATE(9399)] = 322925,
  [SMALL_STATE(9400)] = 322938,
  [SMALL_STATE(9401)] = 322951,
  [SMALL_STATE(9402)] = 322964,
  [SMALL_STATE(9403)] = 322977,
  [SMALL_STATE(9404)] = 322990,
  [SMALL_STATE(9405)] = 323003,
  [SMALL_STATE(9406)] = 323016,
  [SMALL_STATE(9407)] = 323029,
  [SMALL_STATE(9408)] = 323042,
  [SMALL_STATE(9409)] = 323055,
  [SMALL_STATE(9410)] = 323066,
  [SMALL_STATE(9411)] = 323079,
  [SMALL_STATE(9412)] = 323092,
  [SMALL_STATE(9413)] = 323105,
  [SMALL_STATE(9414)] = 323118,
  [SMALL_STATE(9415)] = 323131,
  [SMALL_STATE(9416)] = 323144,
  [SMALL_STATE(9417)] = 323157,
  [SMALL_STATE(9418)] = 323170,
  [SMALL_STATE(9419)] = 323183,
  [SMALL_STATE(9420)] = 323196,
  [SMALL_STATE(9421)] = 323209,
  [SMALL_STATE(9422)] = 323222,
  [SMALL_STATE(9423)] = 323235,
  [SMALL_STATE(9424)] = 323248,
  [SMALL_STATE(9425)] = 323261,
  [SMALL_STATE(9426)] = 323274,
  [SMALL_STATE(9427)] = 323283,
  [SMALL_STATE(9428)] = 323296,
  [SMALL_STATE(9429)] = 323309,
  [SMALL_STATE(9430)] = 323322,
  [SMALL_STATE(9431)] = 323335,
  [SMALL_STATE(9432)] = 323348,
  [SMALL_STATE(9433)] = 323357,
  [SMALL_STATE(9434)] = 323370,
  [SMALL_STATE(9435)] = 323383,
  [SMALL_STATE(9436)] = 323396,
  [SMALL_STATE(9437)] = 323409,
  [SMALL_STATE(9438)] = 323422,
  [SMALL_STATE(9439)] = 323435,
  [SMALL_STATE(9440)] = 323448,
  [SMALL_STATE(9441)] = 323461,
  [SMALL_STATE(9442)] = 323474,
  [SMALL_STATE(9443)] = 323487,
  [SMALL_STATE(9444)] = 323500,
  [SMALL_STATE(9445)] = 323513,
  [SMALL_STATE(9446)] = 323526,
  [SMALL_STATE(9447)] = 323539,
  [SMALL_STATE(9448)] = 323552,
  [SMALL_STATE(9449)] = 323565,
  [SMALL_STATE(9450)] = 323578,
  [SMALL_STATE(9451)] = 323591,
  [SMALL_STATE(9452)] = 323604,
  [SMALL_STATE(9453)] = 323617,
  [SMALL_STATE(9454)] = 323630,
  [SMALL_STATE(9455)] = 323643,
  [SMALL_STATE(9456)] = 323656,
  [SMALL_STATE(9457)] = 323669,
  [SMALL_STATE(9458)] = 323682,
  [SMALL_STATE(9459)] = 323695,
  [SMALL_STATE(9460)] = 323708,
  [SMALL_STATE(9461)] = 323721,
  [SMALL_STATE(9462)] = 323734,
  [SMALL_STATE(9463)] = 323747,
  [SMALL_STATE(9464)] = 323760,
  [SMALL_STATE(9465)] = 323773,
  [SMALL_STATE(9466)] = 323786,
  [SMALL_STATE(9467)] = 323795,
  [SMALL_STATE(9468)] = 323808,
  [SMALL_STATE(9469)] = 323821,
  [SMALL_STATE(9470)] = 323834,
  [SMALL_STATE(9471)] = 323847,
  [SMALL_STATE(9472)] = 323860,
  [SMALL_STATE(9473)] = 323873,
  [SMALL_STATE(9474)] = 323882,
  [SMALL_STATE(9475)] = 323895,
  [SMALL_STATE(9476)] = 323908,
  [SMALL_STATE(9477)] = 323921,
  [SMALL_STATE(9478)] = 323934,
  [SMALL_STATE(9479)] = 323947,
  [SMALL_STATE(9480)] = 323960,
  [SMALL_STATE(9481)] = 323973,
  [SMALL_STATE(9482)] = 323986,
  [SMALL_STATE(9483)] = 323999,
  [SMALL_STATE(9484)] = 324012,
  [SMALL_STATE(9485)] = 324025,
  [SMALL_STATE(9486)] = 324036,
  [SMALL_STATE(9487)] = 324049,
  [SMALL_STATE(9488)] = 324062,
  [SMALL_STATE(9489)] = 324075,
  [SMALL_STATE(9490)] = 324088,
  [SMALL_STATE(9491)] = 324101,
  [SMALL_STATE(9492)] = 324110,
  [SMALL_STATE(9493)] = 324119,
  [SMALL_STATE(9494)] = 324132,
  [SMALL_STATE(9495)] = 324145,
  [SMALL_STATE(9496)] = 324158,
  [SMALL_STATE(9497)] = 324171,
  [SMALL_STATE(9498)] = 324184,
  [SMALL_STATE(9499)] = 324197,
  [SMALL_STATE(9500)] = 324210,
  [SMALL_STATE(9501)] = 324223,
  [SMALL_STATE(9502)] = 324236,
  [SMALL_STATE(9503)] = 324249,
  [SMALL_STATE(9504)] = 324262,
  [SMALL_STATE(9505)] = 324275,
  [SMALL_STATE(9506)] = 324288,
  [SMALL_STATE(9507)] = 324301,
  [SMALL_STATE(9508)] = 324312,
  [SMALL_STATE(9509)] = 324325,
  [SMALL_STATE(9510)] = 324334,
  [SMALL_STATE(9511)] = 324347,
  [SMALL_STATE(9512)] = 324360,
  [SMALL_STATE(9513)] = 324373,
  [SMALL_STATE(9514)] = 324386,
  [SMALL_STATE(9515)] = 324399,
  [SMALL_STATE(9516)] = 324412,
  [SMALL_STATE(9517)] = 324425,
  [SMALL_STATE(9518)] = 324436,
  [SMALL_STATE(9519)] = 324449,
  [SMALL_STATE(9520)] = 324462,
  [SMALL_STATE(9521)] = 324473,
  [SMALL_STATE(9522)] = 324486,
  [SMALL_STATE(9523)] = 324499,
  [SMALL_STATE(9524)] = 324512,
  [SMALL_STATE(9525)] = 324525,
  [SMALL_STATE(9526)] = 324538,
  [SMALL_STATE(9527)] = 324551,
  [SMALL_STATE(9528)] = 324564,
  [SMALL_STATE(9529)] = 324577,
  [SMALL_STATE(9530)] = 324590,
  [SMALL_STATE(9531)] = 324603,
  [SMALL_STATE(9532)] = 324616,
  [SMALL_STATE(9533)] = 324629,
  [SMALL_STATE(9534)] = 324642,
  [SMALL_STATE(9535)] = 324655,
  [SMALL_STATE(9536)] = 324668,
  [SMALL_STATE(9537)] = 324681,
  [SMALL_STATE(9538)] = 324694,
  [SMALL_STATE(9539)] = 324707,
  [SMALL_STATE(9540)] = 324720,
  [SMALL_STATE(9541)] = 324733,
  [SMALL_STATE(9542)] = 324746,
  [SMALL_STATE(9543)] = 324755,
  [SMALL_STATE(9544)] = 324766,
  [SMALL_STATE(9545)] = 324779,
  [SMALL_STATE(9546)] = 324792,
  [SMALL_STATE(9547)] = 324805,
  [SMALL_STATE(9548)] = 324818,
  [SMALL_STATE(9549)] = 324831,
  [SMALL_STATE(9550)] = 324844,
  [SMALL_STATE(9551)] = 324857,
  [SMALL_STATE(9552)] = 324870,
  [SMALL_STATE(9553)] = 324879,
  [SMALL_STATE(9554)] = 324892,
  [SMALL_STATE(9555)] = 324905,
  [SMALL_STATE(9556)] = 324916,
  [SMALL_STATE(9557)] = 324929,
  [SMALL_STATE(9558)] = 324942,
  [SMALL_STATE(9559)] = 324955,
  [SMALL_STATE(9560)] = 324968,
  [SMALL_STATE(9561)] = 324981,
  [SMALL_STATE(9562)] = 324994,
  [SMALL_STATE(9563)] = 325007,
  [SMALL_STATE(9564)] = 325020,
  [SMALL_STATE(9565)] = 325033,
  [SMALL_STATE(9566)] = 325046,
  [SMALL_STATE(9567)] = 325059,
  [SMALL_STATE(9568)] = 325072,
  [SMALL_STATE(9569)] = 325085,
  [SMALL_STATE(9570)] = 325098,
  [SMALL_STATE(9571)] = 325111,
  [SMALL_STATE(9572)] = 325124,
  [SMALL_STATE(9573)] = 325137,
  [SMALL_STATE(9574)] = 325146,
  [SMALL_STATE(9575)] = 325159,
  [SMALL_STATE(9576)] = 325172,
  [SMALL_STATE(9577)] = 325185,
  [SMALL_STATE(9578)] = 325198,
  [SMALL_STATE(9579)] = 325211,
  [SMALL_STATE(9580)] = 325224,
  [SMALL_STATE(9581)] = 325237,
  [SMALL_STATE(9582)] = 325250,
  [SMALL_STATE(9583)] = 325263,
  [SMALL_STATE(9584)] = 325276,
  [SMALL_STATE(9585)] = 325289,
  [SMALL_STATE(9586)] = 325302,
  [SMALL_STATE(9587)] = 325311,
  [SMALL_STATE(9588)] = 325324,
  [SMALL_STATE(9589)] = 325337,
  [SMALL_STATE(9590)] = 325350,
  [SMALL_STATE(9591)] = 325363,
  [SMALL_STATE(9592)] = 325376,
  [SMALL_STATE(9593)] = 325389,
  [SMALL_STATE(9594)] = 325402,
  [SMALL_STATE(9595)] = 325415,
  [SMALL_STATE(9596)] = 325428,
  [SMALL_STATE(9597)] = 325441,
  [SMALL_STATE(9598)] = 325454,
  [SMALL_STATE(9599)] = 325465,
  [SMALL_STATE(9600)] = 325478,
  [SMALL_STATE(9601)] = 325491,
  [SMALL_STATE(9602)] = 325504,
  [SMALL_STATE(9603)] = 325517,
  [SMALL_STATE(9604)] = 325530,
  [SMALL_STATE(9605)] = 325539,
  [SMALL_STATE(9606)] = 325552,
  [SMALL_STATE(9607)] = 325565,
  [SMALL_STATE(9608)] = 325578,
  [SMALL_STATE(9609)] = 325591,
  [SMALL_STATE(9610)] = 325604,
  [SMALL_STATE(9611)] = 325617,
  [SMALL_STATE(9612)] = 325626,
  [SMALL_STATE(9613)] = 325637,
  [SMALL_STATE(9614)] = 325650,
  [SMALL_STATE(9615)] = 325663,
  [SMALL_STATE(9616)] = 325676,
  [SMALL_STATE(9617)] = 325689,
  [SMALL_STATE(9618)] = 325702,
  [SMALL_STATE(9619)] = 325715,
  [SMALL_STATE(9620)] = 325728,
  [SMALL_STATE(9621)] = 325739,
  [SMALL_STATE(9622)] = 325750,
  [SMALL_STATE(9623)] = 325763,
  [SMALL_STATE(9624)] = 325776,
  [SMALL_STATE(9625)] = 325789,
  [SMALL_STATE(9626)] = 325800,
  [SMALL_STATE(9627)] = 325813,
  [SMALL_STATE(9628)] = 325824,
  [SMALL_STATE(9629)] = 325835,
  [SMALL_STATE(9630)] = 325848,
  [SMALL_STATE(9631)] = 325861,
  [SMALL_STATE(9632)] = 325872,
  [SMALL_STATE(9633)] = 325885,
  [SMALL_STATE(9634)] = 325898,
  [SMALL_STATE(9635)] = 325911,
  [SMALL_STATE(9636)] = 325924,
  [SMALL_STATE(9637)] = 325937,
  [SMALL_STATE(9638)] = 325950,
  [SMALL_STATE(9639)] = 325963,
  [SMALL_STATE(9640)] = 325976,
  [SMALL_STATE(9641)] = 325989,
  [SMALL_STATE(9642)] = 326002,
  [SMALL_STATE(9643)] = 326012,
  [SMALL_STATE(9644)] = 326022,
  [SMALL_STATE(9645)] = 326030,
  [SMALL_STATE(9646)] = 326038,
  [SMALL_STATE(9647)] = 326048,
  [SMALL_STATE(9648)] = 326058,
  [SMALL_STATE(9649)] = 326068,
  [SMALL_STATE(9650)] = 326078,
  [SMALL_STATE(9651)] = 326088,
  [SMALL_STATE(9652)] = 326098,
  [SMALL_STATE(9653)] = 326108,
  [SMALL_STATE(9654)] = 326118,
  [SMALL_STATE(9655)] = 326128,
  [SMALL_STATE(9656)] = 326136,
  [SMALL_STATE(9657)] = 326146,
  [SMALL_STATE(9658)] = 326156,
  [SMALL_STATE(9659)] = 326164,
  [SMALL_STATE(9660)] = 326174,
  [SMALL_STATE(9661)] = 326184,
  [SMALL_STATE(9662)] = 326194,
  [SMALL_STATE(9663)] = 326204,
  [SMALL_STATE(9664)] = 326212,
  [SMALL_STATE(9665)] = 326222,
  [SMALL_STATE(9666)] = 326230,
  [SMALL_STATE(9667)] = 326240,
  [SMALL_STATE(9668)] = 326250,
  [SMALL_STATE(9669)] = 326260,
  [SMALL_STATE(9670)] = 326270,
  [SMALL_STATE(9671)] = 326280,
  [SMALL_STATE(9672)] = 326290,
  [SMALL_STATE(9673)] = 326300,
  [SMALL_STATE(9674)] = 326310,
  [SMALL_STATE(9675)] = 326320,
  [SMALL_STATE(9676)] = 326330,
  [SMALL_STATE(9677)] = 326340,
  [SMALL_STATE(9678)] = 326350,
  [SMALL_STATE(9679)] = 326360,
  [SMALL_STATE(9680)] = 326370,
  [SMALL_STATE(9681)] = 326380,
  [SMALL_STATE(9682)] = 326390,
  [SMALL_STATE(9683)] = 326400,
  [SMALL_STATE(9684)] = 326410,
  [SMALL_STATE(9685)] = 326418,
  [SMALL_STATE(9686)] = 326426,
  [SMALL_STATE(9687)] = 326436,
  [SMALL_STATE(9688)] = 326446,
  [SMALL_STATE(9689)] = 326456,
  [SMALL_STATE(9690)] = 326466,
  [SMALL_STATE(9691)] = 326476,
  [SMALL_STATE(9692)] = 326486,
  [SMALL_STATE(9693)] = 326496,
  [SMALL_STATE(9694)] = 326506,
  [SMALL_STATE(9695)] = 326516,
  [SMALL_STATE(9696)] = 326526,
  [SMALL_STATE(9697)] = 326536,
  [SMALL_STATE(9698)] = 326544,
  [SMALL_STATE(9699)] = 326554,
  [SMALL_STATE(9700)] = 326564,
  [SMALL_STATE(9701)] = 326574,
  [SMALL_STATE(9702)] = 326582,
  [SMALL_STATE(9703)] = 326590,
  [SMALL_STATE(9704)] = 326600,
  [SMALL_STATE(9705)] = 326610,
  [SMALL_STATE(9706)] = 326620,
  [SMALL_STATE(9707)] = 326630,
  [SMALL_STATE(9708)] = 326640,
  [SMALL_STATE(9709)] = 326650,
  [SMALL_STATE(9710)] = 326660,
  [SMALL_STATE(9711)] = 326670,
  [SMALL_STATE(9712)] = 326680,
  [SMALL_STATE(9713)] = 326690,
  [SMALL_STATE(9714)] = 326700,
  [SMALL_STATE(9715)] = 326710,
  [SMALL_STATE(9716)] = 326720,
  [SMALL_STATE(9717)] = 326730,
  [SMALL_STATE(9718)] = 326740,
  [SMALL_STATE(9719)] = 326750,
  [SMALL_STATE(9720)] = 326760,
  [SMALL_STATE(9721)] = 326770,
  [SMALL_STATE(9722)] = 326780,
  [SMALL_STATE(9723)] = 326790,
  [SMALL_STATE(9724)] = 326800,
  [SMALL_STATE(9725)] = 326810,
  [SMALL_STATE(9726)] = 326820,
  [SMALL_STATE(9727)] = 326830,
  [SMALL_STATE(9728)] = 326840,
  [SMALL_STATE(9729)] = 326850,
  [SMALL_STATE(9730)] = 326860,
  [SMALL_STATE(9731)] = 326870,
  [SMALL_STATE(9732)] = 326880,
  [SMALL_STATE(9733)] = 326890,
  [SMALL_STATE(9734)] = 326900,
  [SMALL_STATE(9735)] = 326910,
  [SMALL_STATE(9736)] = 326920,
  [SMALL_STATE(9737)] = 326930,
  [SMALL_STATE(9738)] = 326940,
  [SMALL_STATE(9739)] = 326950,
  [SMALL_STATE(9740)] = 326960,
  [SMALL_STATE(9741)] = 326970,
  [SMALL_STATE(9742)] = 326980,
  [SMALL_STATE(9743)] = 326990,
  [SMALL_STATE(9744)] = 327000,
  [SMALL_STATE(9745)] = 327010,
  [SMALL_STATE(9746)] = 327020,
  [SMALL_STATE(9747)] = 327030,
  [SMALL_STATE(9748)] = 327040,
  [SMALL_STATE(9749)] = 327050,
  [SMALL_STATE(9750)] = 327060,
  [SMALL_STATE(9751)] = 327070,
  [SMALL_STATE(9752)] = 327080,
  [SMALL_STATE(9753)] = 327090,
  [SMALL_STATE(9754)] = 327100,
  [SMALL_STATE(9755)] = 327110,
  [SMALL_STATE(9756)] = 327120,
  [SMALL_STATE(9757)] = 327128,
  [SMALL_STATE(9758)] = 327138,
  [SMALL_STATE(9759)] = 327148,
  [SMALL_STATE(9760)] = 327158,
  [SMALL_STATE(9761)] = 327168,
  [SMALL_STATE(9762)] = 327178,
  [SMALL_STATE(9763)] = 327188,
  [SMALL_STATE(9764)] = 327198,
  [SMALL_STATE(9765)] = 327208,
  [SMALL_STATE(9766)] = 327218,
  [SMALL_STATE(9767)] = 327228,
  [SMALL_STATE(9768)] = 327238,
  [SMALL_STATE(9769)] = 327248,
  [SMALL_STATE(9770)] = 327258,
  [SMALL_STATE(9771)] = 327268,
  [SMALL_STATE(9772)] = 327276,
  [SMALL_STATE(9773)] = 327286,
  [SMALL_STATE(9774)] = 327296,
  [SMALL_STATE(9775)] = 327306,
  [SMALL_STATE(9776)] = 327316,
  [SMALL_STATE(9777)] = 327326,
  [SMALL_STATE(9778)] = 327336,
  [SMALL_STATE(9779)] = 327346,
  [SMALL_STATE(9780)] = 327356,
  [SMALL_STATE(9781)] = 327366,
  [SMALL_STATE(9782)] = 327376,
  [SMALL_STATE(9783)] = 327386,
  [SMALL_STATE(9784)] = 327396,
  [SMALL_STATE(9785)] = 327406,
  [SMALL_STATE(9786)] = 327414,
  [SMALL_STATE(9787)] = 327424,
  [SMALL_STATE(9788)] = 327434,
  [SMALL_STATE(9789)] = 327444,
  [SMALL_STATE(9790)] = 327454,
  [SMALL_STATE(9791)] = 327464,
  [SMALL_STATE(9792)] = 327474,
  [SMALL_STATE(9793)] = 327484,
  [SMALL_STATE(9794)] = 327494,
  [SMALL_STATE(9795)] = 327504,
  [SMALL_STATE(9796)] = 327514,
  [SMALL_STATE(9797)] = 327524,
  [SMALL_STATE(9798)] = 327534,
  [SMALL_STATE(9799)] = 327544,
  [SMALL_STATE(9800)] = 327554,
  [SMALL_STATE(9801)] = 327564,
  [SMALL_STATE(9802)] = 327574,
  [SMALL_STATE(9803)] = 327584,
  [SMALL_STATE(9804)] = 327594,
  [SMALL_STATE(9805)] = 327604,
  [SMALL_STATE(9806)] = 327614,
  [SMALL_STATE(9807)] = 327624,
  [SMALL_STATE(9808)] = 327634,
  [SMALL_STATE(9809)] = 327644,
  [SMALL_STATE(9810)] = 327654,
  [SMALL_STATE(9811)] = 327664,
  [SMALL_STATE(9812)] = 327674,
  [SMALL_STATE(9813)] = 327684,
  [SMALL_STATE(9814)] = 327694,
  [SMALL_STATE(9815)] = 327704,
  [SMALL_STATE(9816)] = 327714,
  [SMALL_STATE(9817)] = 327724,
  [SMALL_STATE(9818)] = 327734,
  [SMALL_STATE(9819)] = 327744,
  [SMALL_STATE(9820)] = 327752,
  [SMALL_STATE(9821)] = 327762,
  [SMALL_STATE(9822)] = 327772,
  [SMALL_STATE(9823)] = 327782,
  [SMALL_STATE(9824)] = 327792,
  [SMALL_STATE(9825)] = 327800,
  [SMALL_STATE(9826)] = 327810,
  [SMALL_STATE(9827)] = 327818,
  [SMALL_STATE(9828)] = 327828,
  [SMALL_STATE(9829)] = 327838,
  [SMALL_STATE(9830)] = 327848,
  [SMALL_STATE(9831)] = 327858,
  [SMALL_STATE(9832)] = 327868,
  [SMALL_STATE(9833)] = 327878,
  [SMALL_STATE(9834)] = 327888,
  [SMALL_STATE(9835)] = 327898,
  [SMALL_STATE(9836)] = 327908,
  [SMALL_STATE(9837)] = 327918,
  [SMALL_STATE(9838)] = 327926,
  [SMALL_STATE(9839)] = 327936,
  [SMALL_STATE(9840)] = 327946,
  [SMALL_STATE(9841)] = 327954,
  [SMALL_STATE(9842)] = 327964,
  [SMALL_STATE(9843)] = 327974,
  [SMALL_STATE(9844)] = 327982,
  [SMALL_STATE(9845)] = 327990,
  [SMALL_STATE(9846)] = 327998,
  [SMALL_STATE(9847)] = 328008,
  [SMALL_STATE(9848)] = 328018,
  [SMALL_STATE(9849)] = 328026,
  [SMALL_STATE(9850)] = 328036,
  [SMALL_STATE(9851)] = 328046,
  [SMALL_STATE(9852)] = 328054,
  [SMALL_STATE(9853)] = 328064,
  [SMALL_STATE(9854)] = 328074,
  [SMALL_STATE(9855)] = 328084,
  [SMALL_STATE(9856)] = 328092,
  [SMALL_STATE(9857)] = 328102,
  [SMALL_STATE(9858)] = 328112,
  [SMALL_STATE(9859)] = 328122,
  [SMALL_STATE(9860)] = 328132,
  [SMALL_STATE(9861)] = 328142,
  [SMALL_STATE(9862)] = 328152,
  [SMALL_STATE(9863)] = 328162,
  [SMALL_STATE(9864)] = 328172,
  [SMALL_STATE(9865)] = 328182,
  [SMALL_STATE(9866)] = 328192,
  [SMALL_STATE(9867)] = 328202,
  [SMALL_STATE(9868)] = 328212,
  [SMALL_STATE(9869)] = 328222,
  [SMALL_STATE(9870)] = 328232,
  [SMALL_STATE(9871)] = 328242,
  [SMALL_STATE(9872)] = 328252,
  [SMALL_STATE(9873)] = 328262,
  [SMALL_STATE(9874)] = 328272,
  [SMALL_STATE(9875)] = 328282,
  [SMALL_STATE(9876)] = 328292,
  [SMALL_STATE(9877)] = 328302,
  [SMALL_STATE(9878)] = 328312,
  [SMALL_STATE(9879)] = 328322,
  [SMALL_STATE(9880)] = 328332,
  [SMALL_STATE(9881)] = 328342,
  [SMALL_STATE(9882)] = 328352,
  [SMALL_STATE(9883)] = 328362,
  [SMALL_STATE(9884)] = 328372,
  [SMALL_STATE(9885)] = 328382,
  [SMALL_STATE(9886)] = 328392,
  [SMALL_STATE(9887)] = 328402,
  [SMALL_STATE(9888)] = 328412,
  [SMALL_STATE(9889)] = 328422,
  [SMALL_STATE(9890)] = 328432,
  [SMALL_STATE(9891)] = 328442,
  [SMALL_STATE(9892)] = 328452,
  [SMALL_STATE(9893)] = 328462,
  [SMALL_STATE(9894)] = 328472,
  [SMALL_STATE(9895)] = 328482,
  [SMALL_STATE(9896)] = 328492,
  [SMALL_STATE(9897)] = 328502,
  [SMALL_STATE(9898)] = 328512,
  [SMALL_STATE(9899)] = 328522,
  [SMALL_STATE(9900)] = 328532,
  [SMALL_STATE(9901)] = 328542,
  [SMALL_STATE(9902)] = 328552,
  [SMALL_STATE(9903)] = 328560,
  [SMALL_STATE(9904)] = 328570,
  [SMALL_STATE(9905)] = 328580,
  [SMALL_STATE(9906)] = 328590,
  [SMALL_STATE(9907)] = 328600,
  [SMALL_STATE(9908)] = 328610,
  [SMALL_STATE(9909)] = 328620,
  [SMALL_STATE(9910)] = 328630,
  [SMALL_STATE(9911)] = 328640,
  [SMALL_STATE(9912)] = 328650,
  [SMALL_STATE(9913)] = 328660,
  [SMALL_STATE(9914)] = 328670,
  [SMALL_STATE(9915)] = 328680,
  [SMALL_STATE(9916)] = 328690,
  [SMALL_STATE(9917)] = 328700,
  [SMALL_STATE(9918)] = 328710,
  [SMALL_STATE(9919)] = 328720,
  [SMALL_STATE(9920)] = 328730,
  [SMALL_STATE(9921)] = 328740,
  [SMALL_STATE(9922)] = 328750,
  [SMALL_STATE(9923)] = 328760,
  [SMALL_STATE(9924)] = 328770,
  [SMALL_STATE(9925)] = 328780,
  [SMALL_STATE(9926)] = 328790,
  [SMALL_STATE(9927)] = 328800,
  [SMALL_STATE(9928)] = 328810,
  [SMALL_STATE(9929)] = 328818,
  [SMALL_STATE(9930)] = 328828,
  [SMALL_STATE(9931)] = 328838,
  [SMALL_STATE(9932)] = 328848,
  [SMALL_STATE(9933)] = 328858,
  [SMALL_STATE(9934)] = 328868,
  [SMALL_STATE(9935)] = 328878,
  [SMALL_STATE(9936)] = 328888,
  [SMALL_STATE(9937)] = 328898,
  [SMALL_STATE(9938)] = 328908,
  [SMALL_STATE(9939)] = 328918,
  [SMALL_STATE(9940)] = 328928,
  [SMALL_STATE(9941)] = 328938,
  [SMALL_STATE(9942)] = 328948,
  [SMALL_STATE(9943)] = 328958,
  [SMALL_STATE(9944)] = 328968,
  [SMALL_STATE(9945)] = 328978,
  [SMALL_STATE(9946)] = 328988,
  [SMALL_STATE(9947)] = 328998,
  [SMALL_STATE(9948)] = 329008,
  [SMALL_STATE(9949)] = 329018,
  [SMALL_STATE(9950)] = 329026,
  [SMALL_STATE(9951)] = 329036,
  [SMALL_STATE(9952)] = 329046,
  [SMALL_STATE(9953)] = 329056,
  [SMALL_STATE(9954)] = 329066,
  [SMALL_STATE(9955)] = 329076,
  [SMALL_STATE(9956)] = 329086,
  [SMALL_STATE(9957)] = 329096,
  [SMALL_STATE(9958)] = 329106,
  [SMALL_STATE(9959)] = 329116,
  [SMALL_STATE(9960)] = 329126,
  [SMALL_STATE(9961)] = 329136,
  [SMALL_STATE(9962)] = 329146,
  [SMALL_STATE(9963)] = 329156,
  [SMALL_STATE(9964)] = 329166,
  [SMALL_STATE(9965)] = 329176,
  [SMALL_STATE(9966)] = 329186,
  [SMALL_STATE(9967)] = 329194,
  [SMALL_STATE(9968)] = 329204,
  [SMALL_STATE(9969)] = 329214,
  [SMALL_STATE(9970)] = 329224,
  [SMALL_STATE(9971)] = 329234,
  [SMALL_STATE(9972)] = 329244,
  [SMALL_STATE(9973)] = 329254,
  [SMALL_STATE(9974)] = 329264,
  [SMALL_STATE(9975)] = 329274,
  [SMALL_STATE(9976)] = 329284,
  [SMALL_STATE(9977)] = 329294,
  [SMALL_STATE(9978)] = 329304,
  [SMALL_STATE(9979)] = 329314,
  [SMALL_STATE(9980)] = 329324,
  [SMALL_STATE(9981)] = 329334,
  [SMALL_STATE(9982)] = 329344,
  [SMALL_STATE(9983)] = 329354,
  [SMALL_STATE(9984)] = 329364,
  [SMALL_STATE(9985)] = 329374,
  [SMALL_STATE(9986)] = 329384,
  [SMALL_STATE(9987)] = 329392,
  [SMALL_STATE(9988)] = 329402,
  [SMALL_STATE(9989)] = 329410,
  [SMALL_STATE(9990)] = 329420,
  [SMALL_STATE(9991)] = 329430,
  [SMALL_STATE(9992)] = 329440,
  [SMALL_STATE(9993)] = 329450,
  [SMALL_STATE(9994)] = 329460,
  [SMALL_STATE(9995)] = 329470,
  [SMALL_STATE(9996)] = 329480,
  [SMALL_STATE(9997)] = 329490,
  [SMALL_STATE(9998)] = 329500,
  [SMALL_STATE(9999)] = 329510,
  [SMALL_STATE(10000)] = 329520,
  [SMALL_STATE(10001)] = 329530,
  [SMALL_STATE(10002)] = 329540,
  [SMALL_STATE(10003)] = 329548,
  [SMALL_STATE(10004)] = 329558,
  [SMALL_STATE(10005)] = 329568,
  [SMALL_STATE(10006)] = 329578,
  [SMALL_STATE(10007)] = 329588,
  [SMALL_STATE(10008)] = 329598,
  [SMALL_STATE(10009)] = 329606,
  [SMALL_STATE(10010)] = 329614,
  [SMALL_STATE(10011)] = 329622,
  [SMALL_STATE(10012)] = 329632,
  [SMALL_STATE(10013)] = 329642,
  [SMALL_STATE(10014)] = 329652,
  [SMALL_STATE(10015)] = 329662,
  [SMALL_STATE(10016)] = 329672,
  [SMALL_STATE(10017)] = 329682,
  [SMALL_STATE(10018)] = 329692,
  [SMALL_STATE(10019)] = 329702,
  [SMALL_STATE(10020)] = 329712,
  [SMALL_STATE(10021)] = 329720,
  [SMALL_STATE(10022)] = 329730,
  [SMALL_STATE(10023)] = 329738,
  [SMALL_STATE(10024)] = 329748,
  [SMALL_STATE(10025)] = 329758,
  [SMALL_STATE(10026)] = 329768,
  [SMALL_STATE(10027)] = 329778,
  [SMALL_STATE(10028)] = 329788,
  [SMALL_STATE(10029)] = 329798,
  [SMALL_STATE(10030)] = 329808,
  [SMALL_STATE(10031)] = 329818,
  [SMALL_STATE(10032)] = 329828,
  [SMALL_STATE(10033)] = 329838,
  [SMALL_STATE(10034)] = 329848,
  [SMALL_STATE(10035)] = 329856,
  [SMALL_STATE(10036)] = 329866,
  [SMALL_STATE(10037)] = 329876,
  [SMALL_STATE(10038)] = 329884,
  [SMALL_STATE(10039)] = 329894,
  [SMALL_STATE(10040)] = 329904,
  [SMALL_STATE(10041)] = 329914,
  [SMALL_STATE(10042)] = 329922,
  [SMALL_STATE(10043)] = 329932,
  [SMALL_STATE(10044)] = 329942,
  [SMALL_STATE(10045)] = 329952,
  [SMALL_STATE(10046)] = 329962,
  [SMALL_STATE(10047)] = 329972,
  [SMALL_STATE(10048)] = 329982,
  [SMALL_STATE(10049)] = 329992,
  [SMALL_STATE(10050)] = 330002,
  [SMALL_STATE(10051)] = 330012,
  [SMALL_STATE(10052)] = 330022,
  [SMALL_STATE(10053)] = 330032,
  [SMALL_STATE(10054)] = 330042,
  [SMALL_STATE(10055)] = 330052,
  [SMALL_STATE(10056)] = 330062,
  [SMALL_STATE(10057)] = 330072,
  [SMALL_STATE(10058)] = 330082,
  [SMALL_STATE(10059)] = 330092,
  [SMALL_STATE(10060)] = 330102,
  [SMALL_STATE(10061)] = 330112,
  [SMALL_STATE(10062)] = 330122,
  [SMALL_STATE(10063)] = 330132,
  [SMALL_STATE(10064)] = 330142,
  [SMALL_STATE(10065)] = 330152,
  [SMALL_STATE(10066)] = 330160,
  [SMALL_STATE(10067)] = 330170,
  [SMALL_STATE(10068)] = 330180,
  [SMALL_STATE(10069)] = 330190,
  [SMALL_STATE(10070)] = 330200,
  [SMALL_STATE(10071)] = 330207,
  [SMALL_STATE(10072)] = 330214,
  [SMALL_STATE(10073)] = 330221,
  [SMALL_STATE(10074)] = 330228,
  [SMALL_STATE(10075)] = 330235,
  [SMALL_STATE(10076)] = 330242,
  [SMALL_STATE(10077)] = 330249,
  [SMALL_STATE(10078)] = 330256,
  [SMALL_STATE(10079)] = 330263,
  [SMALL_STATE(10080)] = 330270,
  [SMALL_STATE(10081)] = 330277,
  [SMALL_STATE(10082)] = 330284,
  [SMALL_STATE(10083)] = 330291,
  [SMALL_STATE(10084)] = 330298,
  [SMALL_STATE(10085)] = 330305,
  [SMALL_STATE(10086)] = 330312,
  [SMALL_STATE(10087)] = 330319,
  [SMALL_STATE(10088)] = 330326,
  [SMALL_STATE(10089)] = 330333,
  [SMALL_STATE(10090)] = 330340,
  [SMALL_STATE(10091)] = 330347,
  [SMALL_STATE(10092)] = 330354,
  [SMALL_STATE(10093)] = 330361,
  [SMALL_STATE(10094)] = 330368,
  [SMALL_STATE(10095)] = 330375,
  [SMALL_STATE(10096)] = 330382,
  [SMALL_STATE(10097)] = 330389,
  [SMALL_STATE(10098)] = 330396,
  [SMALL_STATE(10099)] = 330403,
  [SMALL_STATE(10100)] = 330410,
  [SMALL_STATE(10101)] = 330417,
  [SMALL_STATE(10102)] = 330424,
  [SMALL_STATE(10103)] = 330431,
  [SMALL_STATE(10104)] = 330438,
  [SMALL_STATE(10105)] = 330445,
  [SMALL_STATE(10106)] = 330452,
  [SMALL_STATE(10107)] = 330459,
  [SMALL_STATE(10108)] = 330466,
  [SMALL_STATE(10109)] = 330473,
  [SMALL_STATE(10110)] = 330480,
  [SMALL_STATE(10111)] = 330487,
  [SMALL_STATE(10112)] = 330494,
  [SMALL_STATE(10113)] = 330501,
  [SMALL_STATE(10114)] = 330508,
  [SMALL_STATE(10115)] = 330515,
  [SMALL_STATE(10116)] = 330522,
  [SMALL_STATE(10117)] = 330529,
  [SMALL_STATE(10118)] = 330536,
  [SMALL_STATE(10119)] = 330543,
  [SMALL_STATE(10120)] = 330550,
  [SMALL_STATE(10121)] = 330557,
  [SMALL_STATE(10122)] = 330564,
  [SMALL_STATE(10123)] = 330571,
  [SMALL_STATE(10124)] = 330578,
  [SMALL_STATE(10125)] = 330585,
  [SMALL_STATE(10126)] = 330592,
  [SMALL_STATE(10127)] = 330599,
  [SMALL_STATE(10128)] = 330606,
  [SMALL_STATE(10129)] = 330613,
  [SMALL_STATE(10130)] = 330620,
  [SMALL_STATE(10131)] = 330627,
  [SMALL_STATE(10132)] = 330634,
  [SMALL_STATE(10133)] = 330641,
  [SMALL_STATE(10134)] = 330648,
  [SMALL_STATE(10135)] = 330655,
  [SMALL_STATE(10136)] = 330662,
  [SMALL_STATE(10137)] = 330669,
  [SMALL_STATE(10138)] = 330676,
  [SMALL_STATE(10139)] = 330683,
  [SMALL_STATE(10140)] = 330690,
  [SMALL_STATE(10141)] = 330697,
  [SMALL_STATE(10142)] = 330704,
  [SMALL_STATE(10143)] = 330711,
  [SMALL_STATE(10144)] = 330718,
  [SMALL_STATE(10145)] = 330725,
  [SMALL_STATE(10146)] = 330732,
  [SMALL_STATE(10147)] = 330739,
  [SMALL_STATE(10148)] = 330746,
  [SMALL_STATE(10149)] = 330753,
  [SMALL_STATE(10150)] = 330760,
  [SMALL_STATE(10151)] = 330767,
  [SMALL_STATE(10152)] = 330774,
  [SMALL_STATE(10153)] = 330781,
  [SMALL_STATE(10154)] = 330788,
  [SMALL_STATE(10155)] = 330795,
  [SMALL_STATE(10156)] = 330802,
  [SMALL_STATE(10157)] = 330809,
  [SMALL_STATE(10158)] = 330816,
  [SMALL_STATE(10159)] = 330823,
  [SMALL_STATE(10160)] = 330830,
  [SMALL_STATE(10161)] = 330837,
  [SMALL_STATE(10162)] = 330844,
  [SMALL_STATE(10163)] = 330851,
  [SMALL_STATE(10164)] = 330858,
  [SMALL_STATE(10165)] = 330865,
  [SMALL_STATE(10166)] = 330872,
  [SMALL_STATE(10167)] = 330879,
  [SMALL_STATE(10168)] = 330886,
  [SMALL_STATE(10169)] = 330893,
  [SMALL_STATE(10170)] = 330900,
  [SMALL_STATE(10171)] = 330907,
  [SMALL_STATE(10172)] = 330914,
  [SMALL_STATE(10173)] = 330921,
  [SMALL_STATE(10174)] = 330928,
  [SMALL_STATE(10175)] = 330935,
  [SMALL_STATE(10176)] = 330942,
  [SMALL_STATE(10177)] = 330949,
  [SMALL_STATE(10178)] = 330956,
  [SMALL_STATE(10179)] = 330963,
  [SMALL_STATE(10180)] = 330970,
  [SMALL_STATE(10181)] = 330977,
  [SMALL_STATE(10182)] = 330984,
  [SMALL_STATE(10183)] = 330991,
  [SMALL_STATE(10184)] = 330998,
  [SMALL_STATE(10185)] = 331005,
  [SMALL_STATE(10186)] = 331012,
  [SMALL_STATE(10187)] = 331019,
  [SMALL_STATE(10188)] = 331026,
  [SMALL_STATE(10189)] = 331033,
  [SMALL_STATE(10190)] = 331040,
  [SMALL_STATE(10191)] = 331047,
  [SMALL_STATE(10192)] = 331054,
  [SMALL_STATE(10193)] = 331061,
  [SMALL_STATE(10194)] = 331068,
  [SMALL_STATE(10195)] = 331075,
  [SMALL_STATE(10196)] = 331082,
  [SMALL_STATE(10197)] = 331089,
  [SMALL_STATE(10198)] = 331096,
  [SMALL_STATE(10199)] = 331103,
  [SMALL_STATE(10200)] = 331110,
  [SMALL_STATE(10201)] = 331117,
  [SMALL_STATE(10202)] = 331124,
  [SMALL_STATE(10203)] = 331131,
  [SMALL_STATE(10204)] = 331138,
  [SMALL_STATE(10205)] = 331145,
  [SMALL_STATE(10206)] = 331152,
  [SMALL_STATE(10207)] = 331159,
  [SMALL_STATE(10208)] = 331166,
  [SMALL_STATE(10209)] = 331173,
  [SMALL_STATE(10210)] = 331180,
  [SMALL_STATE(10211)] = 331187,
  [SMALL_STATE(10212)] = 331194,
  [SMALL_STATE(10213)] = 331201,
  [SMALL_STATE(10214)] = 331208,
  [SMALL_STATE(10215)] = 331215,
  [SMALL_STATE(10216)] = 331222,
  [SMALL_STATE(10217)] = 331229,
  [SMALL_STATE(10218)] = 331236,
  [SMALL_STATE(10219)] = 331243,
  [SMALL_STATE(10220)] = 331250,
  [SMALL_STATE(10221)] = 331257,
  [SMALL_STATE(10222)] = 331264,
  [SMALL_STATE(10223)] = 331271,
  [SMALL_STATE(10224)] = 331278,
  [SMALL_STATE(10225)] = 331285,
  [SMALL_STATE(10226)] = 331292,
  [SMALL_STATE(10227)] = 331299,
  [SMALL_STATE(10228)] = 331306,
  [SMALL_STATE(10229)] = 331313,
  [SMALL_STATE(10230)] = 331320,
  [SMALL_STATE(10231)] = 331327,
  [SMALL_STATE(10232)] = 331334,
  [SMALL_STATE(10233)] = 331341,
  [SMALL_STATE(10234)] = 331348,
  [SMALL_STATE(10235)] = 331355,
  [SMALL_STATE(10236)] = 331362,
  [SMALL_STATE(10237)] = 331369,
  [SMALL_STATE(10238)] = 331376,
  [SMALL_STATE(10239)] = 331383,
  [SMALL_STATE(10240)] = 331390,
  [SMALL_STATE(10241)] = 331397,
  [SMALL_STATE(10242)] = 331404,
  [SMALL_STATE(10243)] = 331411,
  [SMALL_STATE(10244)] = 331418,
  [SMALL_STATE(10245)] = 331425,
  [SMALL_STATE(10246)] = 331432,
  [SMALL_STATE(10247)] = 331439,
  [SMALL_STATE(10248)] = 331446,
  [SMALL_STATE(10249)] = 331453,
  [SMALL_STATE(10250)] = 331460,
  [SMALL_STATE(10251)] = 331467,
  [SMALL_STATE(10252)] = 331474,
  [SMALL_STATE(10253)] = 331481,
  [SMALL_STATE(10254)] = 331488,
  [SMALL_STATE(10255)] = 331495,
  [SMALL_STATE(10256)] = 331502,
  [SMALL_STATE(10257)] = 331509,
  [SMALL_STATE(10258)] = 331516,
  [SMALL_STATE(10259)] = 331523,
  [SMALL_STATE(10260)] = 331530,
  [SMALL_STATE(10261)] = 331537,
  [SMALL_STATE(10262)] = 331544,
  [SMALL_STATE(10263)] = 331551,
  [SMALL_STATE(10264)] = 331558,
  [SMALL_STATE(10265)] = 331565,
  [SMALL_STATE(10266)] = 331572,
  [SMALL_STATE(10267)] = 331579,
  [SMALL_STATE(10268)] = 331586,
  [SMALL_STATE(10269)] = 331593,
  [SMALL_STATE(10270)] = 331600,
  [SMALL_STATE(10271)] = 331607,
  [SMALL_STATE(10272)] = 331614,
  [SMALL_STATE(10273)] = 331621,
  [SMALL_STATE(10274)] = 331628,
  [SMALL_STATE(10275)] = 331635,
  [SMALL_STATE(10276)] = 331642,
  [SMALL_STATE(10277)] = 331649,
  [SMALL_STATE(10278)] = 331656,
  [SMALL_STATE(10279)] = 331663,
  [SMALL_STATE(10280)] = 331670,
  [SMALL_STATE(10281)] = 331677,
  [SMALL_STATE(10282)] = 331684,
  [SMALL_STATE(10283)] = 331691,
  [SMALL_STATE(10284)] = 331698,
  [SMALL_STATE(10285)] = 331705,
  [SMALL_STATE(10286)] = 331712,
  [SMALL_STATE(10287)] = 331719,
  [SMALL_STATE(10288)] = 331726,
  [SMALL_STATE(10289)] = 331733,
  [SMALL_STATE(10290)] = 331740,
  [SMALL_STATE(10291)] = 331747,
  [SMALL_STATE(10292)] = 331754,
  [SMALL_STATE(10293)] = 331761,
  [SMALL_STATE(10294)] = 331768,
  [SMALL_STATE(10295)] = 331775,
  [SMALL_STATE(10296)] = 331782,
  [SMALL_STATE(10297)] = 331789,
  [SMALL_STATE(10298)] = 331796,
  [SMALL_STATE(10299)] = 331803,
  [SMALL_STATE(10300)] = 331810,
  [SMALL_STATE(10301)] = 331817,
  [SMALL_STATE(10302)] = 331824,
  [SMALL_STATE(10303)] = 331831,
  [SMALL_STATE(10304)] = 331838,
  [SMALL_STATE(10305)] = 331845,
  [SMALL_STATE(10306)] = 331852,
  [SMALL_STATE(10307)] = 331859,
  [SMALL_STATE(10308)] = 331866,
  [SMALL_STATE(10309)] = 331873,
  [SMALL_STATE(10310)] = 331880,
  [SMALL_STATE(10311)] = 331887,
  [SMALL_STATE(10312)] = 331894,
  [SMALL_STATE(10313)] = 331901,
  [SMALL_STATE(10314)] = 331908,
  [SMALL_STATE(10315)] = 331915,
  [SMALL_STATE(10316)] = 331922,
  [SMALL_STATE(10317)] = 331929,
  [SMALL_STATE(10318)] = 331936,
  [SMALL_STATE(10319)] = 331943,
  [SMALL_STATE(10320)] = 331950,
  [SMALL_STATE(10321)] = 331957,
  [SMALL_STATE(10322)] = 331964,
  [SMALL_STATE(10323)] = 331971,
  [SMALL_STATE(10324)] = 331978,
  [SMALL_STATE(10325)] = 331985,
  [SMALL_STATE(10326)] = 331992,
  [SMALL_STATE(10327)] = 331999,
  [SMALL_STATE(10328)] = 332006,
  [SMALL_STATE(10329)] = 332013,
  [SMALL_STATE(10330)] = 332020,
  [SMALL_STATE(10331)] = 332027,
  [SMALL_STATE(10332)] = 332034,
  [SMALL_STATE(10333)] = 332041,
  [SMALL_STATE(10334)] = 332048,
  [SMALL_STATE(10335)] = 332055,
  [SMALL_STATE(10336)] = 332062,
  [SMALL_STATE(10337)] = 332069,
  [SMALL_STATE(10338)] = 332076,
  [SMALL_STATE(10339)] = 332083,
  [SMALL_STATE(10340)] = 332090,
  [SMALL_STATE(10341)] = 332097,
  [SMALL_STATE(10342)] = 332104,
  [SMALL_STATE(10343)] = 332111,
  [SMALL_STATE(10344)] = 332118,
  [SMALL_STATE(10345)] = 332125,
  [SMALL_STATE(10346)] = 332132,
  [SMALL_STATE(10347)] = 332139,
  [SMALL_STATE(10348)] = 332146,
  [SMALL_STATE(10349)] = 332153,
  [SMALL_STATE(10350)] = 332160,
  [SMALL_STATE(10351)] = 332167,
  [SMALL_STATE(10352)] = 332174,
  [SMALL_STATE(10353)] = 332181,
  [SMALL_STATE(10354)] = 332188,
  [SMALL_STATE(10355)] = 332195,
  [SMALL_STATE(10356)] = 332202,
  [SMALL_STATE(10357)] = 332209,
  [SMALL_STATE(10358)] = 332216,
  [SMALL_STATE(10359)] = 332223,
  [SMALL_STATE(10360)] = 332230,
  [SMALL_STATE(10361)] = 332237,
  [SMALL_STATE(10362)] = 332244,
  [SMALL_STATE(10363)] = 332251,
  [SMALL_STATE(10364)] = 332258,
  [SMALL_STATE(10365)] = 332265,
  [SMALL_STATE(10366)] = 332272,
  [SMALL_STATE(10367)] = 332279,
  [SMALL_STATE(10368)] = 332286,
  [SMALL_STATE(10369)] = 332293,
  [SMALL_STATE(10370)] = 332300,
  [SMALL_STATE(10371)] = 332307,
  [SMALL_STATE(10372)] = 332314,
  [SMALL_STATE(10373)] = 332321,
  [SMALL_STATE(10374)] = 332328,
  [SMALL_STATE(10375)] = 332335,
  [SMALL_STATE(10376)] = 332342,
  [SMALL_STATE(10377)] = 332349,
  [SMALL_STATE(10378)] = 332356,
  [SMALL_STATE(10379)] = 332363,
  [SMALL_STATE(10380)] = 332370,
  [SMALL_STATE(10381)] = 332377,
  [SMALL_STATE(10382)] = 332384,
  [SMALL_STATE(10383)] = 332391,
  [SMALL_STATE(10384)] = 332398,
  [SMALL_STATE(10385)] = 332405,
  [SMALL_STATE(10386)] = 332412,
  [SMALL_STATE(10387)] = 332419,
  [SMALL_STATE(10388)] = 332426,
  [SMALL_STATE(10389)] = 332433,
  [SMALL_STATE(10390)] = 332440,
  [SMALL_STATE(10391)] = 332447,
  [SMALL_STATE(10392)] = 332454,
  [SMALL_STATE(10393)] = 332461,
  [SMALL_STATE(10394)] = 332468,
  [SMALL_STATE(10395)] = 332475,
  [SMALL_STATE(10396)] = 332482,
  [SMALL_STATE(10397)] = 332489,
  [SMALL_STATE(10398)] = 332496,
  [SMALL_STATE(10399)] = 332503,
  [SMALL_STATE(10400)] = 332510,
  [SMALL_STATE(10401)] = 332517,
  [SMALL_STATE(10402)] = 332524,
  [SMALL_STATE(10403)] = 332531,
  [SMALL_STATE(10404)] = 332538,
  [SMALL_STATE(10405)] = 332545,
  [SMALL_STATE(10406)] = 332552,
  [SMALL_STATE(10407)] = 332559,
  [SMALL_STATE(10408)] = 332566,
  [SMALL_STATE(10409)] = 332573,
  [SMALL_STATE(10410)] = 332580,
  [SMALL_STATE(10411)] = 332587,
  [SMALL_STATE(10412)] = 332594,
  [SMALL_STATE(10413)] = 332601,
  [SMALL_STATE(10414)] = 332608,
  [SMALL_STATE(10415)] = 332615,
  [SMALL_STATE(10416)] = 332622,
  [SMALL_STATE(10417)] = 332629,
  [SMALL_STATE(10418)] = 332636,
  [SMALL_STATE(10419)] = 332643,
  [SMALL_STATE(10420)] = 332650,
  [SMALL_STATE(10421)] = 332657,
  [SMALL_STATE(10422)] = 332664,
  [SMALL_STATE(10423)] = 332671,
  [SMALL_STATE(10424)] = 332678,
  [SMALL_STATE(10425)] = 332685,
  [SMALL_STATE(10426)] = 332692,
  [SMALL_STATE(10427)] = 332699,
  [SMALL_STATE(10428)] = 332706,
  [SMALL_STATE(10429)] = 332713,
  [SMALL_STATE(10430)] = 332720,
  [SMALL_STATE(10431)] = 332727,
  [SMALL_STATE(10432)] = 332734,
  [SMALL_STATE(10433)] = 332741,
  [SMALL_STATE(10434)] = 332748,
  [SMALL_STATE(10435)] = 332755,
  [SMALL_STATE(10436)] = 332762,
  [SMALL_STATE(10437)] = 332769,
  [SMALL_STATE(10438)] = 332776,
  [SMALL_STATE(10439)] = 332783,
  [SMALL_STATE(10440)] = 332790,
  [SMALL_STATE(10441)] = 332797,
  [SMALL_STATE(10442)] = 332804,
  [SMALL_STATE(10443)] = 332811,
  [SMALL_STATE(10444)] = 332818,
  [SMALL_STATE(10445)] = 332825,
  [SMALL_STATE(10446)] = 332832,
  [SMALL_STATE(10447)] = 332839,
  [SMALL_STATE(10448)] = 332846,
  [SMALL_STATE(10449)] = 332853,
  [SMALL_STATE(10450)] = 332860,
  [SMALL_STATE(10451)] = 332867,
  [SMALL_STATE(10452)] = 332874,
  [SMALL_STATE(10453)] = 332881,
  [SMALL_STATE(10454)] = 332888,
  [SMALL_STATE(10455)] = 332895,
  [SMALL_STATE(10456)] = 332902,
  [SMALL_STATE(10457)] = 332909,
  [SMALL_STATE(10458)] = 332916,
  [SMALL_STATE(10459)] = 332923,
  [SMALL_STATE(10460)] = 332930,
  [SMALL_STATE(10461)] = 332937,
  [SMALL_STATE(10462)] = 332944,
  [SMALL_STATE(10463)] = 332951,
  [SMALL_STATE(10464)] = 332958,
  [SMALL_STATE(10465)] = 332965,
  [SMALL_STATE(10466)] = 332972,
  [SMALL_STATE(10467)] = 332979,
  [SMALL_STATE(10468)] = 332986,
  [SMALL_STATE(10469)] = 332993,
  [SMALL_STATE(10470)] = 333000,
  [SMALL_STATE(10471)] = 333007,
  [SMALL_STATE(10472)] = 333014,
  [SMALL_STATE(10473)] = 333021,
  [SMALL_STATE(10474)] = 333028,
  [SMALL_STATE(10475)] = 333035,
  [SMALL_STATE(10476)] = 333042,
  [SMALL_STATE(10477)] = 333049,
  [SMALL_STATE(10478)] = 333056,
  [SMALL_STATE(10479)] = 333063,
  [SMALL_STATE(10480)] = 333070,
  [SMALL_STATE(10481)] = 333077,
  [SMALL_STATE(10482)] = 333084,
  [SMALL_STATE(10483)] = 333091,
  [SMALL_STATE(10484)] = 333098,
  [SMALL_STATE(10485)] = 333105,
  [SMALL_STATE(10486)] = 333112,
  [SMALL_STATE(10487)] = 333119,
  [SMALL_STATE(10488)] = 333126,
  [SMALL_STATE(10489)] = 333133,
  [SMALL_STATE(10490)] = 333140,
  [SMALL_STATE(10491)] = 333147,
  [SMALL_STATE(10492)] = 333154,
  [SMALL_STATE(10493)] = 333161,
  [SMALL_STATE(10494)] = 333168,
  [SMALL_STATE(10495)] = 333175,
  [SMALL_STATE(10496)] = 333182,
  [SMALL_STATE(10497)] = 333189,
  [SMALL_STATE(10498)] = 333196,
  [SMALL_STATE(10499)] = 333203,
  [SMALL_STATE(10500)] = 333210,
  [SMALL_STATE(10501)] = 333217,
  [SMALL_STATE(10502)] = 333224,
  [SMALL_STATE(10503)] = 333231,
  [SMALL_STATE(10504)] = 333238,
  [SMALL_STATE(10505)] = 333245,
  [SMALL_STATE(10506)] = 333252,
  [SMALL_STATE(10507)] = 333259,
  [SMALL_STATE(10508)] = 333266,
  [SMALL_STATE(10509)] = 333273,
  [SMALL_STATE(10510)] = 333280,
  [SMALL_STATE(10511)] = 333287,
  [SMALL_STATE(10512)] = 333294,
  [SMALL_STATE(10513)] = 333301,
  [SMALL_STATE(10514)] = 333308,
  [SMALL_STATE(10515)] = 333315,
  [SMALL_STATE(10516)] = 333322,
  [SMALL_STATE(10517)] = 333329,
  [SMALL_STATE(10518)] = 333336,
  [SMALL_STATE(10519)] = 333343,
  [SMALL_STATE(10520)] = 333350,
  [SMALL_STATE(10521)] = 333357,
  [SMALL_STATE(10522)] = 333364,
  [SMALL_STATE(10523)] = 333371,
  [SMALL_STATE(10524)] = 333378,
  [SMALL_STATE(10525)] = 333385,
  [SMALL_STATE(10526)] = 333392,
  [SMALL_STATE(10527)] = 333399,
  [SMALL_STATE(10528)] = 333406,
  [SMALL_STATE(10529)] = 333413,
  [SMALL_STATE(10530)] = 333420,
  [SMALL_STATE(10531)] = 333427,
  [SMALL_STATE(10532)] = 333434,
  [SMALL_STATE(10533)] = 333441,
  [SMALL_STATE(10534)] = 333448,
  [SMALL_STATE(10535)] = 333455,
  [SMALL_STATE(10536)] = 333462,
  [SMALL_STATE(10537)] = 333469,
  [SMALL_STATE(10538)] = 333476,
  [SMALL_STATE(10539)] = 333483,
  [SMALL_STATE(10540)] = 333490,
  [SMALL_STATE(10541)] = 333497,
  [SMALL_STATE(10542)] = 333504,
  [SMALL_STATE(10543)] = 333511,
  [SMALL_STATE(10544)] = 333518,
  [SMALL_STATE(10545)] = 333525,
  [SMALL_STATE(10546)] = 333532,
  [SMALL_STATE(10547)] = 333539,
  [SMALL_STATE(10548)] = 333546,
  [SMALL_STATE(10549)] = 333553,
  [SMALL_STATE(10550)] = 333560,
  [SMALL_STATE(10551)] = 333567,
  [SMALL_STATE(10552)] = 333574,
  [SMALL_STATE(10553)] = 333581,
  [SMALL_STATE(10554)] = 333588,
  [SMALL_STATE(10555)] = 333595,
  [SMALL_STATE(10556)] = 333602,
  [SMALL_STATE(10557)] = 333609,
  [SMALL_STATE(10558)] = 333616,
  [SMALL_STATE(10559)] = 333623,
  [SMALL_STATE(10560)] = 333630,
  [SMALL_STATE(10561)] = 333637,
  [SMALL_STATE(10562)] = 333644,
  [SMALL_STATE(10563)] = 333651,
  [SMALL_STATE(10564)] = 333658,
  [SMALL_STATE(10565)] = 333665,
  [SMALL_STATE(10566)] = 333672,
  [SMALL_STATE(10567)] = 333679,
  [SMALL_STATE(10568)] = 333686,
  [SMALL_STATE(10569)] = 333693,
  [SMALL_STATE(10570)] = 333700,
  [SMALL_STATE(10571)] = 333707,
  [SMALL_STATE(10572)] = 333714,
  [SMALL_STATE(10573)] = 333721,
  [SMALL_STATE(10574)] = 333728,
  [SMALL_STATE(10575)] = 333735,
  [SMALL_STATE(10576)] = 333742,
  [SMALL_STATE(10577)] = 333749,
  [SMALL_STATE(10578)] = 333756,
  [SMALL_STATE(10579)] = 333763,
  [SMALL_STATE(10580)] = 333770,
  [SMALL_STATE(10581)] = 333777,
  [SMALL_STATE(10582)] = 333784,
  [SMALL_STATE(10583)] = 333791,
  [SMALL_STATE(10584)] = 333798,
  [SMALL_STATE(10585)] = 333805,
  [SMALL_STATE(10586)] = 333812,
  [SMALL_STATE(10587)] = 333819,
  [SMALL_STATE(10588)] = 333826,
  [SMALL_STATE(10589)] = 333833,
  [SMALL_STATE(10590)] = 333840,
  [SMALL_STATE(10591)] = 333847,
  [SMALL_STATE(10592)] = 333854,
  [SMALL_STATE(10593)] = 333861,
  [SMALL_STATE(10594)] = 333868,
  [SMALL_STATE(10595)] = 333875,
  [SMALL_STATE(10596)] = 333882,
  [SMALL_STATE(10597)] = 333889,
  [SMALL_STATE(10598)] = 333896,
  [SMALL_STATE(10599)] = 333903,
  [SMALL_STATE(10600)] = 333910,
  [SMALL_STATE(10601)] = 333917,
  [SMALL_STATE(10602)] = 333924,
  [SMALL_STATE(10603)] = 333931,
  [SMALL_STATE(10604)] = 333938,
  [SMALL_STATE(10605)] = 333945,
  [SMALL_STATE(10606)] = 333952,
  [SMALL_STATE(10607)] = 333959,
  [SMALL_STATE(10608)] = 333966,
  [SMALL_STATE(10609)] = 333973,
  [SMALL_STATE(10610)] = 333980,
  [SMALL_STATE(10611)] = 333987,
  [SMALL_STATE(10612)] = 333994,
  [SMALL_STATE(10613)] = 334001,
  [SMALL_STATE(10614)] = 334008,
  [SMALL_STATE(10615)] = 334015,
  [SMALL_STATE(10616)] = 334022,
  [SMALL_STATE(10617)] = 334029,
  [SMALL_STATE(10618)] = 334036,
  [SMALL_STATE(10619)] = 334043,
  [SMALL_STATE(10620)] = 334050,
  [SMALL_STATE(10621)] = 334057,
  [SMALL_STATE(10622)] = 334064,
  [SMALL_STATE(10623)] = 334071,
  [SMALL_STATE(10624)] = 334078,
  [SMALL_STATE(10625)] = 334085,
  [SMALL_STATE(10626)] = 334092,
  [SMALL_STATE(10627)] = 334099,
  [SMALL_STATE(10628)] = 334106,
  [SMALL_STATE(10629)] = 334113,
  [SMALL_STATE(10630)] = 334120,
  [SMALL_STATE(10631)] = 334127,
  [SMALL_STATE(10632)] = 334134,
  [SMALL_STATE(10633)] = 334141,
  [SMALL_STATE(10634)] = 334148,
  [SMALL_STATE(10635)] = 334155,
  [SMALL_STATE(10636)] = 334162,
  [SMALL_STATE(10637)] = 334169,
  [SMALL_STATE(10638)] = 334176,
  [SMALL_STATE(10639)] = 334183,
  [SMALL_STATE(10640)] = 334190,
  [SMALL_STATE(10641)] = 334197,
  [SMALL_STATE(10642)] = 334204,
  [SMALL_STATE(10643)] = 334211,
  [SMALL_STATE(10644)] = 334218,
  [SMALL_STATE(10645)] = 334225,
  [SMALL_STATE(10646)] = 334232,
  [SMALL_STATE(10647)] = 334239,
  [SMALL_STATE(10648)] = 334246,
  [SMALL_STATE(10649)] = 334253,
  [SMALL_STATE(10650)] = 334260,
  [SMALL_STATE(10651)] = 334267,
  [SMALL_STATE(10652)] = 334274,
  [SMALL_STATE(10653)] = 334281,
  [SMALL_STATE(10654)] = 334288,
  [SMALL_STATE(10655)] = 334295,
  [SMALL_STATE(10656)] = 334302,
  [SMALL_STATE(10657)] = 334309,
  [SMALL_STATE(10658)] = 334316,
  [SMALL_STATE(10659)] = 334323,
  [SMALL_STATE(10660)] = 334330,
  [SMALL_STATE(10661)] = 334337,
  [SMALL_STATE(10662)] = 334344,
  [SMALL_STATE(10663)] = 334351,
  [SMALL_STATE(10664)] = 334358,
  [SMALL_STATE(10665)] = 334365,
  [SMALL_STATE(10666)] = 334372,
  [SMALL_STATE(10667)] = 334379,
  [SMALL_STATE(10668)] = 334386,
  [SMALL_STATE(10669)] = 334393,
  [SMALL_STATE(10670)] = 334400,
  [SMALL_STATE(10671)] = 334407,
  [SMALL_STATE(10672)] = 334414,
  [SMALL_STATE(10673)] = 334421,
  [SMALL_STATE(10674)] = 334428,
  [SMALL_STATE(10675)] = 334435,
  [SMALL_STATE(10676)] = 334442,
  [SMALL_STATE(10677)] = 334449,
  [SMALL_STATE(10678)] = 334456,
  [SMALL_STATE(10679)] = 334463,
  [SMALL_STATE(10680)] = 334470,
  [SMALL_STATE(10681)] = 334477,
  [SMALL_STATE(10682)] = 334484,
  [SMALL_STATE(10683)] = 334491,
  [SMALL_STATE(10684)] = 334498,
  [SMALL_STATE(10685)] = 334505,
  [SMALL_STATE(10686)] = 334512,
  [SMALL_STATE(10687)] = 334519,
  [SMALL_STATE(10688)] = 334526,
  [SMALL_STATE(10689)] = 334533,
  [SMALL_STATE(10690)] = 334540,
  [SMALL_STATE(10691)] = 334547,
  [SMALL_STATE(10692)] = 334554,
  [SMALL_STATE(10693)] = 334561,
  [SMALL_STATE(10694)] = 334568,
  [SMALL_STATE(10695)] = 334575,
  [SMALL_STATE(10696)] = 334582,
  [SMALL_STATE(10697)] = 334589,
  [SMALL_STATE(10698)] = 334596,
  [SMALL_STATE(10699)] = 334603,
  [SMALL_STATE(10700)] = 334610,
  [SMALL_STATE(10701)] = 334617,
  [SMALL_STATE(10702)] = 334624,
  [SMALL_STATE(10703)] = 334631,
  [SMALL_STATE(10704)] = 334638,
  [SMALL_STATE(10705)] = 334645,
  [SMALL_STATE(10706)] = 334652,
  [SMALL_STATE(10707)] = 334659,
  [SMALL_STATE(10708)] = 334666,
  [SMALL_STATE(10709)] = 334673,
  [SMALL_STATE(10710)] = 334680,
  [SMALL_STATE(10711)] = 334687,
  [SMALL_STATE(10712)] = 334694,
  [SMALL_STATE(10713)] = 334701,
  [SMALL_STATE(10714)] = 334708,
  [SMALL_STATE(10715)] = 334715,
  [SMALL_STATE(10716)] = 334722,
  [SMALL_STATE(10717)] = 334729,
  [SMALL_STATE(10718)] = 334736,
  [SMALL_STATE(10719)] = 334743,
  [SMALL_STATE(10720)] = 334750,
  [SMALL_STATE(10721)] = 334757,
  [SMALL_STATE(10722)] = 334764,
  [SMALL_STATE(10723)] = 334771,
  [SMALL_STATE(10724)] = 334778,
  [SMALL_STATE(10725)] = 334785,
  [SMALL_STATE(10726)] = 334792,
  [SMALL_STATE(10727)] = 334799,
  [SMALL_STATE(10728)] = 334806,
  [SMALL_STATE(10729)] = 334813,
  [SMALL_STATE(10730)] = 334820,
  [SMALL_STATE(10731)] = 334827,
  [SMALL_STATE(10732)] = 334834,
  [SMALL_STATE(10733)] = 334841,
  [SMALL_STATE(10734)] = 334848,
  [SMALL_STATE(10735)] = 334855,
  [SMALL_STATE(10736)] = 334862,
  [SMALL_STATE(10737)] = 334869,
  [SMALL_STATE(10738)] = 334876,
  [SMALL_STATE(10739)] = 334883,
  [SMALL_STATE(10740)] = 334890,
  [SMALL_STATE(10741)] = 334897,
  [SMALL_STATE(10742)] = 334904,
  [SMALL_STATE(10743)] = 334911,
  [SMALL_STATE(10744)] = 334918,
  [SMALL_STATE(10745)] = 334925,
  [SMALL_STATE(10746)] = 334932,
  [SMALL_STATE(10747)] = 334939,
  [SMALL_STATE(10748)] = 334946,
  [SMALL_STATE(10749)] = 334953,
  [SMALL_STATE(10750)] = 334960,
  [SMALL_STATE(10751)] = 334967,
  [SMALL_STATE(10752)] = 334974,
  [SMALL_STATE(10753)] = 334981,
  [SMALL_STATE(10754)] = 334988,
  [SMALL_STATE(10755)] = 334995,
  [SMALL_STATE(10756)] = 335002,
  [SMALL_STATE(10757)] = 335009,
  [SMALL_STATE(10758)] = 335016,
  [SMALL_STATE(10759)] = 335023,
  [SMALL_STATE(10760)] = 335030,
  [SMALL_STATE(10761)] = 335037,
  [SMALL_STATE(10762)] = 335044,
  [SMALL_STATE(10763)] = 335051,
  [SMALL_STATE(10764)] = 335058,
  [SMALL_STATE(10765)] = 335065,
  [SMALL_STATE(10766)] = 335072,
  [SMALL_STATE(10767)] = 335079,
  [SMALL_STATE(10768)] = 335086,
  [SMALL_STATE(10769)] = 335093,
  [SMALL_STATE(10770)] = 335100,
  [SMALL_STATE(10771)] = 335107,
  [SMALL_STATE(10772)] = 335114,
  [SMALL_STATE(10773)] = 335121,
  [SMALL_STATE(10774)] = 335128,
  [SMALL_STATE(10775)] = 335135,
  [SMALL_STATE(10776)] = 335142,
  [SMALL_STATE(10777)] = 335149,
  [SMALL_STATE(10778)] = 335156,
  [SMALL_STATE(10779)] = 335163,
  [SMALL_STATE(10780)] = 335170,
  [SMALL_STATE(10781)] = 335177,
  [SMALL_STATE(10782)] = 335184,
  [SMALL_STATE(10783)] = 335191,
  [SMALL_STATE(10784)] = 335198,
  [SMALL_STATE(10785)] = 335205,
  [SMALL_STATE(10786)] = 335212,
  [SMALL_STATE(10787)] = 335219,
  [SMALL_STATE(10788)] = 335226,
  [SMALL_STATE(10789)] = 335233,
  [SMALL_STATE(10790)] = 335240,
  [SMALL_STATE(10791)] = 335247,
  [SMALL_STATE(10792)] = 335254,
  [SMALL_STATE(10793)] = 335261,
  [SMALL_STATE(10794)] = 335268,
  [SMALL_STATE(10795)] = 335275,
  [SMALL_STATE(10796)] = 335282,
  [SMALL_STATE(10797)] = 335289,
  [SMALL_STATE(10798)] = 335296,
  [SMALL_STATE(10799)] = 335303,
  [SMALL_STATE(10800)] = 335310,
  [SMALL_STATE(10801)] = 335317,
  [SMALL_STATE(10802)] = 335324,
  [SMALL_STATE(10803)] = 335331,
  [SMALL_STATE(10804)] = 335338,
  [SMALL_STATE(10805)] = 335345,
  [SMALL_STATE(10806)] = 335352,
  [SMALL_STATE(10807)] = 335359,
  [SMALL_STATE(10808)] = 335366,
  [SMALL_STATE(10809)] = 335373,
  [SMALL_STATE(10810)] = 335380,
  [SMALL_STATE(10811)] = 335387,
  [SMALL_STATE(10812)] = 335394,
  [SMALL_STATE(10813)] = 335401,
  [SMALL_STATE(10814)] = 335408,
  [SMALL_STATE(10815)] = 335415,
  [SMALL_STATE(10816)] = 335422,
  [SMALL_STATE(10817)] = 335429,
  [SMALL_STATE(10818)] = 335436,
  [SMALL_STATE(10819)] = 335443,
  [SMALL_STATE(10820)] = 335450,
  [SMALL_STATE(10821)] = 335457,
  [SMALL_STATE(10822)] = 335464,
  [SMALL_STATE(10823)] = 335471,
  [SMALL_STATE(10824)] = 335478,
  [SMALL_STATE(10825)] = 335485,
  [SMALL_STATE(10826)] = 335492,
  [SMALL_STATE(10827)] = 335499,
  [SMALL_STATE(10828)] = 335506,
  [SMALL_STATE(10829)] = 335513,
  [SMALL_STATE(10830)] = 335520,
  [SMALL_STATE(10831)] = 335527,
  [SMALL_STATE(10832)] = 335534,
  [SMALL_STATE(10833)] = 335541,
  [SMALL_STATE(10834)] = 335548,
  [SMALL_STATE(10835)] = 335555,
  [SMALL_STATE(10836)] = 335562,
  [SMALL_STATE(10837)] = 335569,
  [SMALL_STATE(10838)] = 335576,
  [SMALL_STATE(10839)] = 335583,
  [SMALL_STATE(10840)] = 335590,
  [SMALL_STATE(10841)] = 335597,
  [SMALL_STATE(10842)] = 335604,
  [SMALL_STATE(10843)] = 335611,
  [SMALL_STATE(10844)] = 335618,
  [SMALL_STATE(10845)] = 335625,
  [SMALL_STATE(10846)] = 335632,
  [SMALL_STATE(10847)] = 335639,
  [SMALL_STATE(10848)] = 335646,
  [SMALL_STATE(10849)] = 335653,
  [SMALL_STATE(10850)] = 335660,
  [SMALL_STATE(10851)] = 335667,
  [SMALL_STATE(10852)] = 335674,
  [SMALL_STATE(10853)] = 335681,
  [SMALL_STATE(10854)] = 335688,
  [SMALL_STATE(10855)] = 335695,
  [SMALL_STATE(10856)] = 335702,
  [SMALL_STATE(10857)] = 335709,
  [SMALL_STATE(10858)] = 335716,
  [SMALL_STATE(10859)] = 335723,
  [SMALL_STATE(10860)] = 335730,
  [SMALL_STATE(10861)] = 335737,
  [SMALL_STATE(10862)] = 335744,
  [SMALL_STATE(10863)] = 335751,
  [SMALL_STATE(10864)] = 335758,
  [SMALL_STATE(10865)] = 335765,
  [SMALL_STATE(10866)] = 335772,
  [SMALL_STATE(10867)] = 335779,
  [SMALL_STATE(10868)] = 335786,
  [SMALL_STATE(10869)] = 335793,
  [SMALL_STATE(10870)] = 335800,
  [SMALL_STATE(10871)] = 335807,
  [SMALL_STATE(10872)] = 335814,
  [SMALL_STATE(10873)] = 335821,
  [SMALL_STATE(10874)] = 335828,
  [SMALL_STATE(10875)] = 335835,
  [SMALL_STATE(10876)] = 335842,
  [SMALL_STATE(10877)] = 335849,
  [SMALL_STATE(10878)] = 335856,
  [SMALL_STATE(10879)] = 335863,
  [SMALL_STATE(10880)] = 335870,
  [SMALL_STATE(10881)] = 335877,
  [SMALL_STATE(10882)] = 335884,
  [SMALL_STATE(10883)] = 335891,
  [SMALL_STATE(10884)] = 335898,
  [SMALL_STATE(10885)] = 335905,
  [SMALL_STATE(10886)] = 335912,
  [SMALL_STATE(10887)] = 335919,
  [SMALL_STATE(10888)] = 335926,
  [SMALL_STATE(10889)] = 335933,
  [SMALL_STATE(10890)] = 335940,
  [SMALL_STATE(10891)] = 335947,
  [SMALL_STATE(10892)] = 335954,
  [SMALL_STATE(10893)] = 335961,
  [SMALL_STATE(10894)] = 335968,
  [SMALL_STATE(10895)] = 335975,
  [SMALL_STATE(10896)] = 335982,
  [SMALL_STATE(10897)] = 335989,
  [SMALL_STATE(10898)] = 335996,
  [SMALL_STATE(10899)] = 336003,
  [SMALL_STATE(10900)] = 336010,
  [SMALL_STATE(10901)] = 336017,
  [SMALL_STATE(10902)] = 336024,
  [SMALL_STATE(10903)] = 336031,
  [SMALL_STATE(10904)] = 336038,
  [SMALL_STATE(10905)] = 336045,
  [SMALL_STATE(10906)] = 336052,
  [SMALL_STATE(10907)] = 336059,
  [SMALL_STATE(10908)] = 336066,
  [SMALL_STATE(10909)] = 336073,
  [SMALL_STATE(10910)] = 336080,
  [SMALL_STATE(10911)] = 336087,
  [SMALL_STATE(10912)] = 336094,
  [SMALL_STATE(10913)] = 336101,
  [SMALL_STATE(10914)] = 336108,
  [SMALL_STATE(10915)] = 336115,
  [SMALL_STATE(10916)] = 336122,
  [SMALL_STATE(10917)] = 336129,
  [SMALL_STATE(10918)] = 336136,
  [SMALL_STATE(10919)] = 336143,
  [SMALL_STATE(10920)] = 336150,
  [SMALL_STATE(10921)] = 336157,
  [SMALL_STATE(10922)] = 336164,
  [SMALL_STATE(10923)] = 336171,
  [SMALL_STATE(10924)] = 336178,
  [SMALL_STATE(10925)] = 336185,
  [SMALL_STATE(10926)] = 336192,
  [SMALL_STATE(10927)] = 336199,
  [SMALL_STATE(10928)] = 336206,
  [SMALL_STATE(10929)] = 336213,
  [SMALL_STATE(10930)] = 336220,
  [SMALL_STATE(10931)] = 336227,
  [SMALL_STATE(10932)] = 336234,
  [SMALL_STATE(10933)] = 336241,
  [SMALL_STATE(10934)] = 336248,
  [SMALL_STATE(10935)] = 336255,
  [SMALL_STATE(10936)] = 336262,
  [SMALL_STATE(10937)] = 336269,
  [SMALL_STATE(10938)] = 336276,
  [SMALL_STATE(10939)] = 336283,
  [SMALL_STATE(10940)] = 336290,
  [SMALL_STATE(10941)] = 336297,
  [SMALL_STATE(10942)] = 336304,
  [SMALL_STATE(10943)] = 336311,
  [SMALL_STATE(10944)] = 336318,
  [SMALL_STATE(10945)] = 336325,
  [SMALL_STATE(10946)] = 336332,
  [SMALL_STATE(10947)] = 336339,
  [SMALL_STATE(10948)] = 336346,
  [SMALL_STATE(10949)] = 336353,
  [SMALL_STATE(10950)] = 336360,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8055),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10945),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6776),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10943),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10060),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2179),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2179),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6358),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1453),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2747),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3861),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2776),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2668),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10895),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7941),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9889),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10884),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9929),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3017),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(886),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1696),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2785),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2743),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2582),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10877),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(624),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7452),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6337),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6330),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6329),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9229),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9866),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2482),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10858),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9847),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1181),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10855),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1618),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10851),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10849),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10848),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2549),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1851),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10843),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10842),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10839),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8503),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5671),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9364),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8660),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5817),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4710),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(435),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10832),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3371),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5936),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1372),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1080),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9789),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2506),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1902),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8122),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7769),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10825),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10824),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1876),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2343),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9787),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1938),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5676),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6503),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2778),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6318),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6317),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10736),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10817),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1260),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8040),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10441),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10078),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6885),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10438),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9734),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2724),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4015),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2664),
  [191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2632),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1709),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2722),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2692),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7437),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6239),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6238),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6237),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9464),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10059),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2258),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10741),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9761),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1109),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10206),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10735),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10734),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10437),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9915),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10560),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10083),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4993),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4704),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2716),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10504),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5881),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1370),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10057),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1837),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8123),
  [257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7745),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10702),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10703),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1836),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2045),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10554),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6933),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6229),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6228),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1272),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8091),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10277),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6797),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(488),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10276),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6814),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10144),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9755),
  [301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2719),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3894),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2669),
  [309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2760),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8988),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9733),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2380),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10528),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10058),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1175),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10701),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1586),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10293),
  [331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10294),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10274),
  [335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9712),
  [337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10315),
  [339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1373),
  [341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9724),
  [343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1824),
  [345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8129),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7830),
  [349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10845),
  [351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10846),
  [353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1823),
  [355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2503),
  [357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10316),
  [359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6905),
  [361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1015),
  [363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1044),
  [365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(857),
  [367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef, 3, 0, 10),
  [369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef, 2, 0, 10),
  [375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(968),
  [377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif, 3, 0, 77),
  [379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif, 4, 0, 77),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(964),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1064),
  [387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(974),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(951),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1053),
  [397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [399] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1272),
  [402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8091),
  [405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10277),
  [408] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6797),
  [411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0),
  [413] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10276),
  [416] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9755),
  [419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(272),
  [422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2179),
  [425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2132),
  [428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2179),
  [431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1335),
  [434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6358),
  [437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1453),
  [440] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(380),
  [443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2719),
  [446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3894),
  [449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2776),
  [452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2669),
  [455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10895),
  [458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7941),
  [461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9889),
  [464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10884),
  [467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9929),
  [470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3017),
  [473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(74),
  [476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2632),
  [479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1696),
  [482] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2785),
  [485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2760),
  [488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2582),
  [491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10877),
  [494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2692),
  [497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7437),
  [500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6239),
  [503] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6238),
  [506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6237),
  [509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8988),
  [512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9733),
  [515] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2380),
  [518] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10528),
  [521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10058),
  [524] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1175),
  [527] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10701),
  [530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1586),
  [533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10293),
  [536] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10294),
  [539] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10274),
  [542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9712),
  [545] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10315),
  [548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2549),
  [551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1851),
  [554] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10843),
  [557] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10842),
  [560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10839),
  [563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8503),
  [566] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(4993),
  [569] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9364),
  [572] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8660),
  [575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(4704),
  [578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(4710),
  [581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2716),
  [584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10504),
  [587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3371),
  [590] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5881),
  [593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1373),
  [596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1080),
  [599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9724),
  [602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2506),
  [605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1824),
  [608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8129),
  [611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7830),
  [614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10845),
  [617] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10846),
  [620] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1823),
  [623] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2503),
  [626] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9787),
  [629] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1938),
  [632] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5676),
  [635] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6503),
  [638] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10316),
  [641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2778),
  [644] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6905),
  [647] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6229),
  [650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6228),
  [653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1271),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4440),
  [661] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1271),
  [664] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8040),
  [667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10441),
  [670] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6885),
  [673] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10438),
  [676] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9734),
  [679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(780),
  [682] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2724),
  [685] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(4015),
  [688] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2664),
  [691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(72),
  [694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0),
  [696] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2722),
  [699] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9464),
  [702] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10059),
  [705] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2258),
  [708] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10741),
  [711] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9761),
  [714] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1109),
  [717] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10206),
  [720] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1564),
  [723] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10735),
  [726] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10734),
  [729] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10437),
  [732] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9915),
  [735] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10560),
  [738] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1370),
  [741] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10057),
  [744] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1837),
  [747] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8123),
  [750] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7745),
  [753] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10702),
  [756] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10703),
  [759] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1836),
  [762] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2045),
  [765] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10554),
  [768] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6933),
  [771] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(102),
  [774] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8040),
  [777] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10441),
  [780] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6885),
  [783] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10438),
  [786] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9734),
  [789] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(272),
  [792] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2179),
  [795] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2132),
  [798] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2179),
  [801] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1335),
  [804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6358),
  [807] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1453),
  [810] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(780),
  [813] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2724),
  [816] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4015),
  [819] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2776),
  [822] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2664),
  [825] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10895),
  [828] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7941),
  [831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9889),
  [834] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10884),
  [837] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9929),
  [840] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3017),
  [843] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(72),
  [846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0),
  [848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(644),
  [851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1696),
  [854] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2785),
  [857] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2722),
  [860] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2582),
  [863] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10877),
  [866] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(532),
  [869] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7374),
  [872] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6336),
  [875] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6348),
  [878] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6349),
  [881] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9464),
  [884] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10059),
  [887] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2258),
  [890] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10741),
  [893] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9761),
  [896] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1109),
  [899] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10206),
  [902] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1564),
  [905] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10735),
  [908] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10734),
  [911] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10437),
  [914] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9915),
  [917] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10560),
  [920] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2549),
  [923] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1851),
  [926] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10843),
  [929] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10842),
  [932] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10839),
  [935] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8503),
  [938] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4993),
  [941] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9364),
  [944] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8660),
  [947] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4704),
  [950] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4710),
  [953] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(743),
  [956] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10650),
  [959] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3371),
  [962] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5982),
  [965] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1370),
  [968] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1080),
  [971] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10057),
  [974] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2506),
  [977] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1837),
  [980] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8123),
  [983] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7745),
  [986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10702),
  [989] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10703),
  [992] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1836),
  [995] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2045),
  [998] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9787),
  [1001] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1938),
  [1004] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5676),
  [1007] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6503),
  [1010] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10554),
  [1013] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2778),
  [1016] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6933),
  [1019] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6319),
  [1022] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6320),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [1029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [1031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4377),
  [1033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4998),
  [1035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [1039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [1041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(644),
  [1043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7374),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6336),
  [1049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6348),
  [1051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6349),
  [1053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(743),
  [1055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10650),
  [1057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5982),
  [1059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6319),
  [1061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6320),
  [1063] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1270),
  [1066] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8045),
  [1069] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10167),
  [1072] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6785),
  [1075] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10212),
  [1078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10025),
  [1081] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(756),
  [1084] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2750),
  [1087] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3984),
  [1090] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2667),
  [1093] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(69),
  [1096] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2744),
  [1099] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9515),
  [1102] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9723),
  [1105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2126),
  [1108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10942),
  [1111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9727),
  [1114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1188),
  [1117] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10844),
  [1120] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1565),
  [1123] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10530),
  [1126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10551),
  [1129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10208),
  [1132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9740),
  [1135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10579),
  [1138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1371),
  [1141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9729),
  [1144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1808),
  [1147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8131),
  [1150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7721),
  [1153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10870),
  [1156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10861),
  [1159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1822),
  [1162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2369),
  [1165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10581),
  [1168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6932),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [1173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6788),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6861),
  [1181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3989),
  [1183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6838),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [1187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [1189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [1191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [1193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2603),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1270),
  [1199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8045),
  [1201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10167),
  [1203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6785),
  [1205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else, 2, 0, 0),
  [1207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10212),
  [1209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10025),
  [1211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [1213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2750),
  [1215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3984),
  [1217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2667),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [1221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2744),
  [1223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9515),
  [1225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9723),
  [1227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2126),
  [1229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10942),
  [1231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9727),
  [1233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1188),
  [1235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10844),
  [1237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1565),
  [1239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10530),
  [1241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10551),
  [1243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10208),
  [1245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9740),
  [1247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10579),
  [1249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1371),
  [1251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9729),
  [1253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1808),
  [1255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8131),
  [1257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7721),
  [1259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10870),
  [1261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10861),
  [1263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1822),
  [1265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2369),
  [1267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10581),
  [1269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6932),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4096),
  [1273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4429),
  [1275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [1281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3295),
  [1283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [1285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [1287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else, 1, 0, 0),
  [1289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4652),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4991),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4640),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4259),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3320),
  [1307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6740),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [1313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0),
  [1315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(103),
  [1318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8055),
  [1321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10945),
  [1324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6776),
  [1327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10943),
  [1330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10060),
  [1333] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(272),
  [1336] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2179),
  [1339] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2132),
  [1342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2179),
  [1345] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1335),
  [1348] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6358),
  [1351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1453),
  [1354] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2747),
  [1357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3861),
  [1360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2776),
  [1363] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2668),
  [1366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10895),
  [1369] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7941),
  [1372] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9889),
  [1375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10884),
  [1378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9929),
  [1381] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3017),
  [1384] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(32),
  [1387] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(886),
  [1390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1696),
  [1393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2785),
  [1396] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2743),
  [1399] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2582),
  [1402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10877),
  [1405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(624),
  [1408] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7452),
  [1411] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6337),
  [1414] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6330),
  [1417] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6329),
  [1420] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9229),
  [1423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9866),
  [1426] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2482),
  [1429] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10858),
  [1432] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9847),
  [1435] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1181),
  [1438] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10855),
  [1441] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1618),
  [1444] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10851),
  [1447] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10849),
  [1450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10848),
  [1453] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2549),
  [1456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1851),
  [1459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10843),
  [1462] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10842),
  [1465] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10839),
  [1468] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8503),
  [1471] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5671),
  [1474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9364),
  [1477] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8660),
  [1480] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5817),
  [1483] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4710),
  [1486] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(435),
  [1489] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10832),
  [1492] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3371),
  [1495] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5936),
  [1498] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1372),
  [1501] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1080),
  [1504] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9789),
  [1507] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2506),
  [1510] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1902),
  [1513] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8122),
  [1516] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7769),
  [1519] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10825),
  [1522] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10824),
  [1525] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1876),
  [1528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2343),
  [1531] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9787),
  [1534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1938),
  [1537] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5676),
  [1540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6503),
  [1543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2778),
  [1546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6318),
  [1549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6317),
  [1552] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10736),
  [1555] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10817),
  [1558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 1, 0, 0),
  [1560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1342),
  [1562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3, 0, 14),
  [1564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [1566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [1568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3, 0, 14),
  [1570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2012),
  [1572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2038),
  [1574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9849),
  [1576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1706),
  [1578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9764),
  [1580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1342),
  [1583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0),
  [1585] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1114),
  [1588] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2179),
  [1591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2179),
  [1594] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2012),
  [1597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0),
  [1599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2012),
  [1602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(380),
  [1605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2719),
  [1608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3894),
  [1611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2038),
  [1614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2785),
  [1617] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10895),
  [1620] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7941),
  [1623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9849),
  [1626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10884),
  [1629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(74),
  [1632] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2632),
  [1635] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1706),
  [1638] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2582),
  [1641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10877),
  [1644] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2692),
  [1647] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7437),
  [1650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6239),
  [1653] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6238),
  [1656] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6237),
  [1659] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8988),
  [1662] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9733),
  [1665] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10058),
  [1668] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1175),
  [1671] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10701),
  [1674] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1586),
  [1677] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10293),
  [1680] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10294),
  [1683] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10274),
  [1686] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9712),
  [1689] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10315),
  [1692] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2549),
  [1695] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1851),
  [1698] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10843),
  [1701] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10842),
  [1704] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10839),
  [1707] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8503),
  [1710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4993),
  [1713] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9364),
  [1716] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8660),
  [1719] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4704),
  [1722] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4710),
  [1725] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2716),
  [1728] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10504),
  [1731] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5881),
  [1734] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9764),
  [1737] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9724),
  [1740] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2506),
  [1743] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1824),
  [1746] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1823),
  [1749] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2503),
  [1752] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9787),
  [1755] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1938),
  [1758] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5676),
  [1761] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6503),
  [1764] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10316),
  [1767] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2778),
  [1770] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6905),
  [1773] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6229),
  [1776] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6228),
  [1779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 4, 0, 14),
  [1781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 4, 0, 14),
  [1783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 2, 0, 0),
  [1785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 2, 0, 0),
  [1787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3, 0, 0),
  [1789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3, 0, 0),
  [1791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1341),
  [1793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [1795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10024),
  [1797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10537),
  [1799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10533),
  [1801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6899),
  [1803] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1341),
  [1806] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(600),
  [1809] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2747),
  [1812] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3861),
  [1815] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(32),
  [1818] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9229),
  [1821] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9866),
  [1824] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9847),
  [1827] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1181),
  [1830] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10855),
  [1833] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1618),
  [1836] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10851),
  [1839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10849),
  [1842] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10848),
  [1845] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10024),
  [1848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10537),
  [1851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9789),
  [1854] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1902),
  [1857] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1876),
  [1860] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2343),
  [1863] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10533),
  [1866] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6899),
  [1869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1343),
  [1871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1339),
  [1873] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1343),
  [1876] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(756),
  [1879] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2750),
  [1882] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3984),
  [1885] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(69),
  [1888] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9515),
  [1891] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9723),
  [1894] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9727),
  [1897] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1188),
  [1900] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10844),
  [1903] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1565),
  [1906] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10530),
  [1909] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10551),
  [1912] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10208),
  [1915] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9740),
  [1918] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10579),
  [1921] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9729),
  [1924] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1808),
  [1927] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1822),
  [1930] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2369),
  [1933] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10581),
  [1936] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6932),
  [1939] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1339),
  [1942] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(780),
  [1945] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2724),
  [1948] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4015),
  [1951] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(72),
  [1954] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9464),
  [1957] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10059),
  [1960] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9761),
  [1963] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1109),
  [1966] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10206),
  [1969] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1564),
  [1972] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10735),
  [1975] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10734),
  [1978] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10437),
  [1981] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9915),
  [1984] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10560),
  [1987] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10057),
  [1990] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1837),
  [1993] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1836),
  [1996] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2045),
  [1999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10554),
  [2002] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6933),
  [2005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1338),
  [2007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [2009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2977),
  [2011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3960),
  [2013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [2015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9522),
  [2017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9850),
  [2019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9725),
  [2021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1115),
  [2023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10859),
  [2025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1585),
  [2027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10929),
  [2029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10926),
  [2031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10166),
  [2033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9863),
  [2035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10902),
  [2037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9933),
  [2039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1817),
  [2041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1812),
  [2043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2118),
  [2045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10900),
  [2047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6971),
  [2049] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1338),
  [2052] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1308),
  [2055] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2977),
  [2058] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3960),
  [2061] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(48),
  [2064] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9522),
  [2067] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9850),
  [2070] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9725),
  [2073] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1115),
  [2076] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10859),
  [2079] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1585),
  [2082] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10929),
  [2085] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10926),
  [2088] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10166),
  [2091] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9863),
  [2094] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10902),
  [2097] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9933),
  [2100] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1817),
  [2103] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1812),
  [2106] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2118),
  [2109] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10900),
  [2112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6971),
  [2115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 1),
  [2117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [2119] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0),
  [2123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 1),
  [2125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0),
  [2128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [2130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0),
  [2133] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1212),
  [2136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1146),
  [2138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8155),
  [2140] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1),
  [2143] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym__class_name, 1, 0, 1),
  [2146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(630),
  [2148] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0),
  [2152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1804),
  [2154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [2156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8696),
  [2158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9858),
  [2160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1218),
  [2163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [2165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [2167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [2169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35),
  [2171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_identifier, 2, 0, 34),
  [2173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_qualified_identifier, 2, 0, 34), REDUCE(sym_qualified_type_identifier, 2, 0, 35),
  [2176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35),
  [2178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34), REDUCE(sym_qualified_type_identifier, 2, 0, 35),
  [2181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34),
  [2183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34), SHIFT(1230),
  [2186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 3, 2, 0),
  [2188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 3, 2, 0),
  [2190] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 6, 4, 0),
  [2192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 6, 4, 0),
  [2194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 5, 3, 0),
  [2196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 5, 3, 0),
  [2198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 3, 3, 0),
  [2200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 3, 3, 0),
  [2202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 4, 2, 0),
  [2204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 4, 2, 0),
  [2206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 4, 3, 0),
  [2208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 4, 3, 0),
  [2210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_type, 2, 0, 16),
  [2212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_function, 2, 0, 17),
  [2214] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_template_type, 2, 0, 16), REDUCE(sym_template_function, 2, 0, 17),
  [2217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_type, 2, 0, 16),
  [2219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_template_type, 2, 0, 16), REDUCE(sym_template_function, 2, 0, 17),
  [2222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_function, 2, 0, 17),
  [2224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 4, 4, 0),
  [2226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 4, 4, 0),
  [2228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 8, 4, 0),
  [2230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 8, 4, 0),
  [2232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 7, 3, 0),
  [2234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 7, 3, 0),
  [2236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 4, 1, 0),
  [2238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 4, 1, 0),
  [2240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 5, 4, 0),
  [2242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 5, 4, 0),
  [2244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 7, 4, 0),
  [2246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 7, 4, 0),
  [2248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 2, 0, 0),
  [2250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 2, 0, 0),
  [2252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 6, 3, 0),
  [2254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 6, 3, 0),
  [2256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 3, 1, 0),
  [2258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 3, 1, 0),
  [2260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34), SHIFT(1232),
  [2263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1340),
  [2265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [2267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2984),
  [2269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3972),
  [2271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9720),
  [2273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1691),
  [2275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10722),
  [2277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10111),
  [2279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1337),
  [2281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5592),
  [2283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10180),
  [2285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [2287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [2289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2338),
  [2291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [2293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2299),
  [2295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7971),
  [2297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2769),
  [2299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7429),
  [2301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6211),
  [2303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6212),
  [2305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6214),
  [2307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [2309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1888),
  [2311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10596),
  [2313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10924),
  [2315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10949),
  [2317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8450),
  [2319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4573),
  [2321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9052),
  [2323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8912),
  [2325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4638),
  [2327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4625),
  [2329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5944),
  [2331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2386),
  [2333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9948),
  [2335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2385),
  [2337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5646),
  [2339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6516),
  [2341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6215),
  [2343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6217),
  [2345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [2347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_name, 1, 0, 1),
  [2349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_name, 1, 0, 1),
  [2351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [2353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 3, 0, 0),
  [2355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 3, 0, 0),
  [2357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 2, 0, 0),
  [2359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 2, 0, 0),
  [2361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_type_identifier, 2, 0, 0),
  [2363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_type_identifier, 2, 0, 0),
  [2365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_name, 1, 0, 0),
  [2367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_name, 1, 0, 0),
  [2369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8174),
  [2371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34),
  [2373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34),
  [2375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2959),
  [2377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10142),
  [2379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6882),
  [2381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1649),
  [2383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10419),
  [2385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [2387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6813),
  [2389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10614),
  [2391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9678),
  [2393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6003),
  [2395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10646),
  [2397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3976),
  [2399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6358),
  [2401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2731),
  [2403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4003),
  [2405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6554),
  [2407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10633),
  [2409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2671),
  [2411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7411),
  [2413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6276),
  [2415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6266),
  [2417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6201),
  [2419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5898),
  [2421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8680),
  [2423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1457),
  [2425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10944),
  [2427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7853),
  [2429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10878),
  [2431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6300),
  [2433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6252),
  [2435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9942),
  [2437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9651),
  [2439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4055),
  [2441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10418),
  [2443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, 0, 77),
  [2445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 3, 0, 10),
  [2447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1658),
  [2449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 3, 0, 77),
  [2451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2511),
  [2453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2387),
  [2455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2062),
  [2457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1661),
  [2459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 2, 0, 10),
  [2461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2526),
  [2463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2138),
  [2465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1617),
  [2467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2059),
  [2469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1962),
  [2471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2489),
  [2473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 3, 0, 47),
  [2475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 3, 0, 47),
  [2477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6975),
  [2479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [2481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7145),
  [2483] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 2, 0, 10),
  [2485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 2, 0, 10),
  [2487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [2489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 2, 0, 0),
  [2491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 2, 0, 0),
  [2493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declaration_specifiers, 1, 0, 2), REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0),
  [2496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0),
  [2498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declaration_specifiers, 1, 0, 2), REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0),
  [2501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0),
  [2503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0), SHIFT(922),
  [2506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0), SHIFT(2647),
  [2509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0), SHIFT(2666),
  [2512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0), SHIFT(2815),
  [2515] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0), SHIFT(10202),
  [2518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0), SHIFT(10063),
  [2521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0), SHIFT(10204),
  [2524] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0), SHIFT(10500),
  [2527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6006),
  [2529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [2531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0), SHIFT(2809),
  [2534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 3, 0, 0),
  [2536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 3, 0, 0),
  [2538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [2540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2959),
  [2543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10142),
  [2546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6882),
  [2549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0),
  [2551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10419),
  [2554] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9678),
  [2557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6003),
  [2560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10646),
  [2563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3976),
  [2566] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6358),
  [2569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6358),
  [2572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2731),
  [2575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4003),
  [2578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2776),
  [2581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2785),
  [2584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10895),
  [2587] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6554),
  [2590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9720),
  [2593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10884),
  [2596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9929),
  [2599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2632),
  [2602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10633),
  [2605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2582),
  [2608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10877),
  [2611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2671),
  [2614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7411),
  [2617] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6276),
  [2620] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6266),
  [2623] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6201),
  [2626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2716),
  [2629] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10504),
  [2632] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3371),
  [2635] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5898),
  [2638] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8680),
  [2641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1080),
  [2644] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1457),
  [2647] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10944),
  [2650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7853),
  [2653] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10878),
  [2656] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2778),
  [2659] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6300),
  [2662] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6252),
  [2665] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9942),
  [2668] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9651),
  [2671] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4055),
  [2674] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10418),
  [2677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, 0, 9),
  [2679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, 0, 9),
  [2681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9691),
  [2683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 1, 0, 6),
  [2685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 1, 0, 6),
  [2687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10671),
  [2689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [2691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_statement, 1, 0, 0),
  [2693] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declaration_specifiers, 1, 0, 2), REDUCE(sym__top_level_statement, 1, 0, 0),
  [2696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_statement, 1, 0, 0),
  [2698] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declaration_specifiers, 1, 0, 2), REDUCE(sym__top_level_statement, 1, 0, 0),
  [2701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [2703] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__top_level_statement, 1, 0, 0), SHIFT(2647),
  [2706] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__top_level_statement, 1, 0, 0), SHIFT(2666),
  [2709] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__top_level_statement, 1, 0, 0), SHIFT(2815),
  [2712] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__top_level_statement, 1, 0, 0), SHIFT(10202),
  [2715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__top_level_statement, 1, 0, 0), SHIFT(10063),
  [2718] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__top_level_statement, 1, 0, 0), SHIFT(10204),
  [2721] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__top_level_statement, 1, 0, 0), SHIFT(10500),
  [2724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5976),
  [2726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [2728] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__top_level_statement, 1, 0, 0), SHIFT(2809),
  [2731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0),
  [2733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0),
  [2735] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9691),
  [2738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [2740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0),
  [2742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 0),
  [2744] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_try_statement, 3, 0, 9),
  [2746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_try_statement, 3, 0, 9),
  [2748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2596),
  [2750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [2752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [2754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [2756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2167),
  [2758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [2760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1449),
  [2762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7981),
  [2764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7690),
  [2766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2892),
  [2768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [2770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6142),
  [2772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7438),
  [2774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6246),
  [2776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6245),
  [2778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6235),
  [2780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2184),
  [2782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1840),
  [2784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10209),
  [2786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10914),
  [2788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10946),
  [2790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8506),
  [2792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4066),
  [2794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9520),
  [2796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8766),
  [2798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4324),
  [2800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4269),
  [2802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2909),
  [2804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10211),
  [2806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5952),
  [2808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4017),
  [2810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2461),
  [2812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9800),
  [2814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1940),
  [2816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5756),
  [2818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6502),
  [2820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6226),
  [2822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6225),
  [2824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decltype, 4, 0, 0),
  [2826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decltype, 4, 0, 0),
  [2828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [2830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_try_statement, 4, 0, 46),
  [2832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_try_statement, 4, 0, 46),
  [2834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [2836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 102),
  [2838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 102),
  [2840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [2842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 3, 0, 158),
  [2844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 3, 0, 158),
  [2846] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, 0, 51),
  [2848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, 0, 51),
  [2850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 172),
  [2852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 172),
  [2854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [2856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [2858] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(285),
  [2861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10499),
  [2863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9864),
  [2865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9864),
  [2868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10213),
  [2870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6747),
  [2872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10105),
  [2874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9999),
  [2876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2759),
  [2878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3935),
  [2880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3483),
  [2882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8617),
  [2884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1460),
  [2886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7817),
  [2888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10860),
  [2890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9993),
  [2892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9992),
  [2894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3896),
  [2896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10107),
  [2898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [2900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [2902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, 0, 52),
  [2904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, 0, 52),
  [2906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [2908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 5, 0, 140),
  [2910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 5, 0, 140),
  [2912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10104),
  [2914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6791),
  [2916] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else_in_field_declaration_list, 2, 0, 0),
  [2918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10267),
  [2920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9766),
  [2922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2732),
  [2924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4014),
  [2926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8628),
  [2928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1459),
  [2930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7816),
  [2932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10886),
  [2934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9699),
  [2936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9996),
  [2938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4011),
  [2940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10266),
  [2942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 6, 0, 139),
  [2944] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 6, 0, 139),
  [2946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 4, 0, 101),
  [2948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 4, 0, 101),
  [2950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, 0, 52),
  [2952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, 0, 52),
  [2954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3, 0, 0),
  [2956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3, 0, 0),
  [2958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2894),
  [2960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [2962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 4, 0, 141),
  [2964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 4, 0, 141),
  [2966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [2968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2761),
  [2970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [2972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 3, 0, 53),
  [2974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 3, 0, 53),
  [2976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [2978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, 0, 54),
  [2980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, 0, 54),
  [2982] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 6, 0, 129),
  [2984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 6, 0, 129),
  [2986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_specifier, 2, 0, 12),
  [2988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_specifier, 2, 0, 12),
  [2990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4990),
  [2992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4997),
  [2994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_specifier, 2, 0, 12),
  [2996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_specifier, 2, 0, 12),
  [2998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extension_specifier, 2, 0, 12),
  [3000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extension_specifier, 2, 0, 12),
  [3002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3, 0, 0),
  [3004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3, 0, 0),
  [3006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2929),
  [3008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_except_clause, 3, 0, 177),
  [3010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_except_clause, 3, 0, 177),
  [3012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [3014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 5, 0, 178),
  [3016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 5, 0, 178),
  [3018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 5, 0, 179),
  [3020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 5, 0, 179),
  [3022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 5, 0, 180),
  [3024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 5, 0, 180),
  [3026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_return_statement, 3, 0, 0),
  [3028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_return_statement, 3, 0, 0),
  [3030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_yield_statement, 3, 0, 0),
  [3032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_yield_statement, 3, 0, 0),
  [3034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 3, 0, 66),
  [3036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 3, 0, 66),
  [3038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 6, 0, 199),
  [3040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 6, 0, 199),
  [3042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3713),
  [3044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [3046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 1, 0, 13),
  [3048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 1, 0, 13),
  [3050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3718),
  [3052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 3, 0, 100),
  [3054] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 3, 0, 100),
  [3056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_placeholder_type_specifier, 2, 0, 27),
  [3058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_placeholder_type_specifier, 2, 0, 27),
  [3060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 2, 0, 10),
  [3062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 2, 0, 10),
  [3064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7233),
  [3066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7522),
  [3068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 98),
  [3070] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 98),
  [3072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 200),
  [3074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 200),
  [3076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 2, 0, 0),
  [3078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 2, 0, 0),
  [3080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, 0, 9),
  [3082] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, 0, 9),
  [3084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, 0, 201),
  [3086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, 0, 201),
  [3088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, 0, 50),
  [3090] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, 0, 50),
  [3092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 6, 0, 203),
  [3094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 6, 0, 203),
  [3096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 2, 0, 12),
  [3098] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 2, 0, 12),
  [3100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 4, 0, 46),
  [3102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 4, 0, 46),
  [3104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else_in_field_declaration_list, 1, 0, 0),
  [3106] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10213),
  [3109] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6747),
  [3112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10105),
  [3115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9999),
  [3118] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2759),
  [3121] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3935),
  [3124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0),
  [3126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8617),
  [3129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1460),
  [3132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7817),
  [3135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10860),
  [3138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9993),
  [3141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9992),
  [3144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3896),
  [3147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10107),
  [3150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 2, 0, 12),
  [3152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 2, 0, 12),
  [3154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 95),
  [3156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 95),
  [3158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [3160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [3162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 2, 0, 9),
  [3164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 2, 0, 9),
  [3166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3593),
  [3168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2745),
  [3170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 93),
  [3172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 93),
  [3174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 2, 0, 0),
  [3176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 2, 0, 0),
  [3178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [3180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [3182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 5, 0, 165),
  [3184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 5, 0, 165),
  [3186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3051),
  [3188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5855),
  [3190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 9),
  [3192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 9),
  [3194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5837),
  [3196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_discard_statement, 2, 0, 0),
  [3198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_discard_statement, 2, 0, 0),
  [3200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 10),
  [3202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 10),
  [3204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 4, 0, 0),
  [3206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 4, 0, 0),
  [3208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [3210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_range_loop, 5, 0, 150),
  [3212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_range_loop, 5, 0, 150),
  [3214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2, 0, 0),
  [3216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2, 0, 0),
  [3218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_leave_statement, 2, 0, 0),
  [3220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_leave_statement, 2, 0, 0),
  [3222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 4, 0, 84),
  [3224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 4, 0, 84),
  [3226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_try_statement, 3, 0, 9),
  [3228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_try_statement, 3, 0, 9),
  [3230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 3, 0, 46),
  [3232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 3, 0, 46),
  [3234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_return_statement, 2, 0, 0),
  [3236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_return_statement, 2, 0, 0),
  [3238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 3, 0, 48),
  [3240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 3, 0, 48),
  [3242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 5, 0, 149),
  [3244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, 0, 149),
  [3246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, 0, 145),
  [3248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, 0, 145),
  [3250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2, 0, 0),
  [3252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2, 0, 0),
  [3254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5737),
  [3256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10104),
  [3259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6791),
  [3262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10267),
  [3265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9766),
  [3268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2732),
  [3271] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4014),
  [3274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8628),
  [3277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1459),
  [3280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7816),
  [3283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10886),
  [3286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9699),
  [3289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9996),
  [3292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4011),
  [3295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10266),
  [3298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, 0, 0),
  [3300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0),
  [3302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 103),
  [3304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 103),
  [3306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5691),
  [3308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3040),
  [3310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 144),
  [3312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 144),
  [3314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2, 0, 0),
  [3316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [3318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 4, 0, 133),
  [3320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 4, 0, 133),
  [3322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 4, 0, 92),
  [3324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 4, 0, 92),
  [3326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [3328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [3330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 4, 0, 93),
  [3332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 4, 0, 93),
  [3334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3545),
  [3336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 2, 0, 12),
  [3338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 2, 0, 12),
  [3340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_finally_clause, 2, 0, 9),
  [3342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_finally_clause, 2, 0, 9),
  [3344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 4, 0, 112),
  [3346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 4, 0, 112),
  [3348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 47),
  [3350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 47),
  [3352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4744),
  [3354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4756),
  [3356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 49),
  [3358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 49),
  [3360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, 0, 11),
  [3362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, 0, 11),
  [3364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, 0, 6),
  [3366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, 0, 6),
  [3368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, 0, 84),
  [3370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, 0, 84),
  [3372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3488),
  [3374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, 0, 129),
  [3376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, 0, 129),
  [3378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_statement, 2, 0, 0),
  [3380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_statement, 2, 0, 0),
  [3382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 48),
  [3384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 48),
  [3386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_placeholder_type_specifier, 1, 0, 0),
  [3388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_placeholder_type_specifier, 1, 0, 0),
  [3390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_base_clause, 2, 0, 96),
  [3392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__enum_base_clause, 2, 0, 96),
  [3394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 47),
  [3396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 47),
  [3398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 46),
  [3400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 46),
  [3402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 3, 0, 0),
  [3404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 3, 0, 0),
  [3406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_declaration, 5, 0, 161),
  [3408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_declaration, 5, 0, 161),
  [3410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, 0, 110),
  [3412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, 0, 110),
  [3414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 2, 0, 26),
  [3416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 2, 0, 26),
  [3418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 4, 0, 119),
  [3420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 4, 0, 119),
  [3422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9769),
  [3425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_definition, 2, 0, 25),
  [3427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_definition, 2, 0, 25),
  [3429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, 0, 114),
  [3431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, 0, 114),
  [3433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 4, 0, 123),
  [3435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 4, 0, 123),
  [3437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_function_def, 5, 0, 124),
  [3439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_function_def, 5, 0, 124),
  [3441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_declaration, 2, 0, 26),
  [3443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_declaration, 2, 0, 26),
  [3445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_friend_declaration, 2, 0, 0),
  [3447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_friend_declaration, 2, 0, 0),
  [3449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, 0, 125),
  [3451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, 0, 125),
  [3453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1174),
  [3455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, 0, 77),
  [3457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, 0, 77),
  [3459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 5, 0, 126),
  [3461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 5, 0, 126),
  [3463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_include, 3, 0, 37),
  [3465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_include, 3, 0, 37),
  [3467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pure_virtual_clause, 3, 0, 0),
  [3469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pure_virtual_clause, 3, 0, 0),
  [3471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_method_clause, 3, 0, 0),
  [3473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_method_clause, 3, 0, 0),
  [3475] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_def, 3, 0, 10),
  [3477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_def, 3, 0, 10),
  [3479] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 3, 0, 10),
  [3481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 3, 0, 10),
  [3483] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__enum_base_clause, 2, 0, 97),
  [3485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_base_clause, 2, 0, 97),
  [3487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [3489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_method_clause, 3, 0, 0),
  [3491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_method_clause, 3, 0, 0),
  [3493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, 0, 46),
  [3495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, 0, 46),
  [3497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, 0, 173),
  [3499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, 0, 173),
  [3501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_declaration, 4, 0, 0),
  [3503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_declaration, 4, 0, 0),
  [3505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call, 3, 0, 38),
  [3507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call, 3, 0, 38),
  [3509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 3, 0, 0),
  [3511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 3, 0, 0),
  [3513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_declaration, 4, 0, 57),
  [3515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_declaration, 4, 0, 57),
  [3517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_instantiation, 4, 0, 58),
  [3519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_instantiation, 4, 0, 58),
  [3521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 5, 0, 134),
  [3523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 5, 0, 134),
  [3525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 5, 0, 135),
  [3527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 5, 0, 135),
  [3529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9769),
  [3531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_friend_declaration, 3, 0, 0),
  [3533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_friend_declaration, 3, 0, 0),
  [3535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_assert_declaration, 5, 0, 162),
  [3537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_assert_declaration, 5, 0, 162),
  [3539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__empty_declaration, 2, 0, 0),
  [3541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__empty_declaration, 2, 0, 0),
  [3543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 4, 0, 93),
  [3545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 4, 0, 93),
  [3547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 2, 0, 26),
  [3549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 2, 0, 26),
  [3551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_linkage_specification, 3, 0, 44),
  [3553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_linkage_specification, 3, 0, 44),
  [3555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 2, 0, 25),
  [3557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 2, 0, 25),
  [3559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 4, 0, 92),
  [3561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 4, 0, 92),
  [3563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 4, 0, 91),
  [3565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 4, 0, 91),
  [3567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 4, 0, 10),
  [3569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, 0, 10),
  [3571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 4, 0, 78),
  [3573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, 0, 78),
  [3575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 4, 0, 77),
  [3577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 4, 0, 77),
  [3579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_alias_definition, 5, 0, 159),
  [3581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_alias_definition, 5, 0, 159),
  [3583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_alias_definition, 5, 0, 160),
  [3585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_alias_definition, 5, 0, 160),
  [3587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_function_def, 4, 0, 76),
  [3589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_function_def, 4, 0, 76),
  [3591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__block_item, 1, 0, 0), REDUCE(sym_statement, 1, 0, 0),
  [3594] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__block_item, 1, 0, 0), REDUCE(sym_statement, 1, 0, 0),
  [3597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_declaration, 3, 0, 5),
  [3599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_declaration, 3, 0, 5),
  [3601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concept_definition, 5, 0, 10),
  [3603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concept_definition, 5, 0, 10),
  [3605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_def, 4, 0, 75),
  [3607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_def, 4, 0, 75),
  [3609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_definition, 3, 0, 74),
  [3611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_definition, 3, 0, 74),
  [3613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, 0, 167),
  [3615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, 0, 167),
  [3617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 3, 0, 5),
  [3619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 3, 0, 5),
  [3621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 5),
  [3623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 5),
  [3625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 74),
  [3627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 74),
  [3629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call, 2, 0, 3),
  [3631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call, 2, 0, 3),
  [3633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_friend_declaration, 4, 0, 0),
  [3635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_friend_declaration, 4, 0, 0),
  [3637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_assert_declaration, 7, 0, 216),
  [3639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_assert_declaration, 7, 0, 216),
  [3641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 2, 0, 9),
  [3643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 2, 0, 9),
  [3645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, 0, 202),
  [3647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, 0, 202),
  [3649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 68),
  [3651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 68),
  [3653] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9987),
  [3656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(1534),
  [3659] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(1484),
  [3662] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(629),
  [3665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 3, 0, 67),
  [3667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 3, 0, 67),
  [3669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_declaration, 6, 0, 197),
  [3671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_declaration, 6, 0, 197),
  [3673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_declaration, 3, 0, 0),
  [3675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_declaration, 3, 0, 0),
  [3677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, 0, 48),
  [3679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, 0, 48),
  [3681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, 0, 60),
  [3683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, 0, 60),
  [3685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 2, 0, 0),
  [3687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 2, 0, 0),
  [3689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9987),
  [3691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_declaration, 3, 0, 57),
  [3693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_declaration, 3, 0, 57),
  [3695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_instantiation, 3, 0, 5),
  [3697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_instantiation, 3, 0, 5),
  [3699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 6, 0, 175),
  [3701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 6, 0, 175),
  [3703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 5, 0, 174),
  [3705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 5, 0, 174),
  [3707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7102),
  [3709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7539),
  [3711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 49),
  [3713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 49),
  [3715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 95),
  [3717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 95),
  [3719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 48),
  [3721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 48),
  [3723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1173),
  [3725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, 0, 101),
  [3727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, 0, 101),
  [3729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1189),
  [3731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 98),
  [3733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 98),
  [3735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, 0, 46),
  [3737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, 0, 46),
  [3739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(846),
  [3742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 2, 0, 9),
  [3744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 2, 0, 9),
  [3746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 1, 0, 11),
  [3748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 1, 0, 11),
  [3750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 2),
  [3752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 2),
  [3754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 2), SHIFT(637),
  [3757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 18),
  [3759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, -1, 18),
  [3761] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 18), SHIFT(637),
  [3764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 20),
  [3766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 20),
  [3768] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 20), SHIFT(643),
  [3771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 36),
  [3773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, -1, 36),
  [3775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 36), SHIFT(641),
  [3778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [3781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [3784] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT(637),
  [3788] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(637),
  [3791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, 0, 9),
  [3793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, 0, 9),
  [3795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 93),
  [3797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 93),
  [3799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, 0, 50),
  [3801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, 0, 50),
  [3803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 36),
  [3805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, -1, 36),
  [3807] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 36), SHIFT(637),
  [3810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 20),
  [3812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, 0, 20),
  [3814] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 20), SHIFT(637),
  [3817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(633),
  [3820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0),
  [3822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 1, 0, 0),
  [3824] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(635),
  [3827] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(631),
  [3830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 46),
  [3832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 46),
  [3834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 2, 0, 0),
  [3836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 139),
  [3838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 139),
  [3840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 4, 0, 140),
  [3842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 4, 0, 140),
  [3844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_specifier, 4, 0, 0),
  [3846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_specifier, 4, 0, 0),
  [3848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_associatedtype_specifier, 3, 0, 0),
  [3850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associatedtype_specifier, 3, 0, 0),
  [3852] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(2981),
  [3855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [3857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0),
  [3859] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(7941),
  [3862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_statement, 1, 0, 0),
  [3864] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(8795),
  [3867] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(10832),
  [3870] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(9764),
  [3873] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(2981),
  [3876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [3878] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(7941),
  [3881] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(8795),
  [3884] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(10832),
  [3887] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(9764),
  [3890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_type, 2, -1, 0),
  [3892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_type, 2, -1, 0),
  [3894] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(2981),
  [3897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [3899] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(7941),
  [3902] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(8795),
  [3905] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(10832),
  [3908] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(9764),
  [3911] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0), REDUCE(sym__class_name, 1, 0, 0),
  [3914] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 20), SHIFT(285),
  [3917] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 36), SHIFT(285),
  [3920] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 2), SHIFT(285),
  [3923] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 18), SHIFT(285),
  [3926] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(933),
  [3929] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(935),
  [3932] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(932),
  [3935] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 20), SHIFT(827),
  [3938] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 36), SHIFT(828),
  [3941] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT(285),
  [3945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3, 0, 0),
  [3947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3, 0, 0),
  [3949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_expression_statement, 2, 0, 0),
  [3951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_expression_statement, 2, 0, 0),
  [3953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 5, 0, 0),
  [3955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 5, 0, 0),
  [3957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, 0, 0),
  [3959] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, 0, 0),
  [3961] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__top_level_item, 1, 0, 0), REDUCE(sym__top_level_statement, 1, 0, 0),
  [3964] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__top_level_item, 1, 0, 0), REDUCE(sym__top_level_statement, 1, 0, 0),
  [3967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2709),
  [3969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7578),
  [3971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7578),
  [3973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2191),
  [3975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8094),
  [3977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3133),
  [3979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7375),
  [3981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6010),
  [3983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7405),
  [3985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10343),
  [3987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4063),
  [3989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4063),
  [3991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3691),
  [3993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10455),
  [3995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2707),
  [3997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6578),
  [3999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2099),
  [4001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10893),
  [4003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10887),
  [4005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6586),
  [4007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10874),
  [4009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10871),
  [4011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10889),
  [4013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10879),
  [4015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8747),
  [4017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1456),
  [4019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10252),
  [4021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8901),
  [4023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1454),
  [4025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10852),
  [4027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8646),
  [4029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1455),
  [4031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10882),
  [4033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8729),
  [4035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1458),
  [4037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10865),
  [4039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2978),
  [4041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9736),
  [4043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8795),
  [4045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2598),
  [4047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [4049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [4051] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(3022),
  [4054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1114),
  [4057] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2179),
  [4060] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2179),
  [4063] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2012),
  [4066] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(756),
  [4069] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7941),
  [4072] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9736),
  [4075] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(69),
  [4078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1706),
  [4081] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8795),
  [4084] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9515),
  [4087] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9723),
  [4090] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2126),
  [4093] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10942),
  [4096] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9727),
  [4099] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1188),
  [4102] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10844),
  [4105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1565),
  [4108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10530),
  [4111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10551),
  [4114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10208),
  [4117] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9740),
  [4120] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10579),
  [4123] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2549),
  [4126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1851),
  [4129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10843),
  [4132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10842),
  [4135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10839),
  [4138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8503),
  [4141] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(4993),
  [4144] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9364),
  [4147] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8660),
  [4150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(4704),
  [4153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(4710),
  [4156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10832),
  [4159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9764),
  [4162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9729),
  [4165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2506),
  [4168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1808),
  [4171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1822),
  [4174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2369),
  [4177] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9787),
  [4180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1938),
  [4183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(5676),
  [4186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6503),
  [4189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10581),
  [4192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6932),
  [4195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3028),
  [4197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3005),
  [4199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3022),
  [4201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3012),
  [4203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9460),
  [4205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2499),
  [4207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10291),
  [4209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9767),
  [4211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10501),
  [4213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9670),
  [4215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6938),
  [4217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2978),
  [4220] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(780),
  [4223] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(72),
  [4226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9464),
  [4229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10059),
  [4232] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2258),
  [4235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10741),
  [4238] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9761),
  [4241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1109),
  [4244] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10206),
  [4247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1564),
  [4250] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10735),
  [4253] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10734),
  [4256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10437),
  [4259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9915),
  [4262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10560),
  [4265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10057),
  [4268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1837),
  [4271] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1836),
  [4274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2045),
  [4277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10554),
  [4280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6933),
  [4283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2998),
  [4285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(3012),
  [4288] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(32),
  [4291] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9460),
  [4294] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9866),
  [4297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2499),
  [4300] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10291),
  [4303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9767),
  [4306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1181),
  [4309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10501),
  [4312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1618),
  [4315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10851),
  [4318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10849),
  [4321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10848),
  [4324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9670),
  [4327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9789),
  [4330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1902),
  [4333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1876),
  [4336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2343),
  [4339] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6938),
  [4342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(3028),
  [4345] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(380),
  [4348] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(74),
  [4351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8988),
  [4354] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9733),
  [4357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2380),
  [4360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10528),
  [4363] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10058),
  [4366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1175),
  [4369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10701),
  [4372] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1586),
  [4375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10293),
  [4378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10294),
  [4381] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10274),
  [4384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9712),
  [4387] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10315),
  [4390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9724),
  [4393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1824),
  [4396] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1823),
  [4399] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2503),
  [4402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10316),
  [4405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6905),
  [4408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 4, 0, 45),
  [4410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 4, 0, 45),
  [4412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2171),
  [4414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2171),
  [4416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7962),
  [4418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [4420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8881),
  [4422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1846),
  [4424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10502),
  [4426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10918),
  [4428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10947),
  [4430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8437),
  [4432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3481),
  [4434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9097),
  [4436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8837),
  [4438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3316),
  [4440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3315),
  [4442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2021),
  [4444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9922),
  [4446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2051),
  [4448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5721),
  [4450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6495),
  [4452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2998),
  [4455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1308),
  [4458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(48),
  [4461] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9522),
  [4464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9850),
  [4467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9725),
  [4470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1115),
  [4473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10859),
  [4476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1585),
  [4479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10929),
  [4482] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10926),
  [4485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10166),
  [4488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9863),
  [4491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10902),
  [4494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9933),
  [4497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1817),
  [4500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1812),
  [4503] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2118),
  [4506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10900),
  [4509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6971),
  [4512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(3005),
  [4515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(600),
  [4518] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9229),
  [4521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2482),
  [4524] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10858),
  [4527] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9847),
  [4530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10855),
  [4533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10024),
  [4536] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10537),
  [4539] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10533),
  [4542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6899),
  [4545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_declaration, 4, 0, 0),
  [4547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_declaration, 4, 0, 0),
  [4549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2784),
  [4551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2424),
  [4553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [4555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8021),
  [4557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1828),
  [4559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3577),
  [4561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9517),
  [4563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8903),
  [4565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2447),
  [4567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9834),
  [4569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2446),
  [4571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5752),
  [4573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_declaration, 3, 0, 0),
  [4575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_declaration, 3, 0, 0),
  [4577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [4579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [4581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2991),
  [4583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [4585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8791),
  [4587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3023),
  [4589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2130),
  [4591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [4593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7934),
  [4595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1854),
  [4597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4134),
  [4599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9020),
  [4601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8736),
  [4603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2560),
  [4605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9975),
  [4607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2562),
  [4609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2211),
  [4611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [4613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7922),
  [4615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1811),
  [4617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2018),
  [4619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2054),
  [4621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2599),
  [4623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [4625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [4627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2236),
  [4629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [4631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7966),
  [4633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4903),
  [4635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5882),
  [4637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7394),
  [4639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6258),
  [4641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6261),
  [4643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6262),
  [4645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [4647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1816),
  [4649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10557),
  [4651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10921),
  [4653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10948),
  [4655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8471),
  [4657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5544),
  [4659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9138),
  [4661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8870),
  [4663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5717),
  [4665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5708),
  [4667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5830),
  [4669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6375),
  [4671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10625),
  [4673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5942),
  [4675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2885),
  [4677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2206),
  [4679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9944),
  [4681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2207),
  [4683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5709),
  [4685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6501),
  [4687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6270),
  [4689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6281),
  [4691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6405),
  [4693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2832),
  [4695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6444),
  [4697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [4699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6415),
  [4701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [4703] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declaration_modifiers, 1, 0, 0), REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [4706] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declaration_modifiers, 1, 0, 0), REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [4709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [4711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [4713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_modifiers, 1, 0, 0),
  [4715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_modifiers, 1, 0, 0),
  [4717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6374),
  [4719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [4721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6433),
  [4723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2624),
  [4725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6406),
  [4727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [4729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3080),
  [4731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2088),
  [4733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [4735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8004),
  [4737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [4739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8626),
  [4741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1894),
  [4743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10623),
  [4745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10927),
  [4747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10950),
  [4749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8459),
  [4751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4286),
  [4753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8997),
  [4755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8777),
  [4757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4545),
  [4759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4547),
  [4761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1976),
  [4763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9954),
  [4765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1973),
  [4767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5620),
  [4769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6507),
  [4771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6398),
  [4773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [4775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6369),
  [4777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2657),
  [4779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6448),
  [4781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4474),
  [4783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6443),
  [4785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [4787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6450),
  [4789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [4791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6414),
  [4793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8028),
  [4795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6410),
  [4797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [4799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6442),
  [4801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [4803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6440),
  [4805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3677),
  [4807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6383),
  [4809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3161),
  [4811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6427),
  [4813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5037),
  [4815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6368),
  [4817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2799),
  [4819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6409),
  [4821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [4823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6423),
  [4825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2824),
  [4827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6421),
  [4829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4539),
  [4831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6438),
  [4833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3429),
  [4835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6436),
  [4837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [4839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6392),
  [4841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [4843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6352),
  [4845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [4847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9957),
  [4849] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9957),
  [4852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6363),
  [4854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2627),
  [4856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6137),
  [4858] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1207),
  [4861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1089),
  [4863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2639),
  [4865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2993),
  [4867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [4869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8710),
  [4871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1179),
  [4873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1106),
  [4875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1164),
  [4877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2781),
  [4879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9475),
  [4881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5516),
  [4883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [4885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3240),
  [4887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5640),
  [4889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5640),
  [4891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6829),
  [4893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1408),
  [4895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2972),
  [4897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [4899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [4901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5665),
  [4903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4963),
  [4905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4957),
  [4907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10205),
  [4909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2422),
  [4911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2969),
  [4913] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1226),
  [4916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [4918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8622),
  [4920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9961),
  [4922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1157),
  [4924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2042),
  [4926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [4928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7955),
  [4930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [4932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1905),
  [4934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4905),
  [4936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9009),
  [4938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2420),
  [4940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2418),
  [4942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5735),
  [4944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6510),
  [4946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2981),
  [4948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2996),
  [4950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1988),
  [4952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [4954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8018),
  [4956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1922),
  [4958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5393),
  [4960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8976),
  [4962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8700),
  [4964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2185),
  [4966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9974),
  [4968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2186),
  [4970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3066),
  [4972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2513),
  [4974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [4976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8032),
  [4978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1925),
  [4980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2096),
  [4982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2559),
  [4984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5641),
  [4986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3077),
  [4988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2347),
  [4990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [4992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8006),
  [4994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1838),
  [4996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2334),
  [4998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2330),
  [5000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3047),
  [5002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [5004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8867),
  [5006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_pack_expansion, 2, 0, 28),
  [5008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [5010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_pack_expansion, 2, 0, 28),
  [5012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2342),
  [5014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2733),
  [5016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [5018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5120),
  [5020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7070),
  [5022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7070),
  [5024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8090),
  [5026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1407),
  [5028] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34), SHIFT(1231),
  [5031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2882),
  [5033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [5035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6830),
  [5037] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34), SHIFT(1214),
  [5040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [5042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2994),
  [5044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2940),
  [5046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3107),
  [5048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10595),
  [5050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [5052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7205),
  [5054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [5056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1409),
  [5058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7794),
  [5060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [5062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4305),
  [5064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [5066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7717),
  [5068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [5070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1399),
  [5072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4303),
  [5074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [5076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1395),
  [5078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3132),
  [5080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [5082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7100),
  [5084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [5086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3808),
  [5088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [5090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1400),
  [5092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7809),
  [5094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [5096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1414),
  [5098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7216),
  [5100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [5102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1396),
  [5104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7189),
  [5106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2995),
  [5108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [5110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7728),
  [5112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [5114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1404),
  [5116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4150),
  [5118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [5120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1403),
  [5122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7200),
  [5124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [5126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7146),
  [5128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [5130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1412),
  [5132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7180),
  [5134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [5136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7217),
  [5138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [5140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1416),
  [5142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7804),
  [5144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [5146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7814),
  [5148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [5150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2231),
  [5152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [5154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [5156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [5158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2699),
  [5160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6327),
  [5162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6326),
  [5164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6324),
  [5166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6227),
  [5168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6230),
  [5170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6231),
  [5172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6297),
  [5174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6291),
  [5176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6289),
  [5178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6250),
  [5180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6303),
  [5182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6304),
  [5184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6222),
  [5186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6221),
  [5188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6219),
  [5190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6265),
  [5192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6267),
  [5194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6269),
  [5196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6343),
  [5198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6341),
  [5200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6325),
  [5202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3664),
  [5204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2233),
  [5206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6872),
  [5208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7982),
  [5210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3276),
  [5212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2982),
  [5214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10334),
  [5216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [5218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [5220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4994),
  [5222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10738),
  [5224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5716),
  [5226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4030),
  [5228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5005),
  [5230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4293),
  [5232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4664),
  [5234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4348),
  [5236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10282),
  [5238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4329),
  [5240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10863),
  [5242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4671),
  [5244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4680),
  [5246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9060),
  [5248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10717),
  [5250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4107),
  [5252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9203),
  [5254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10240),
  [5256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4627),
  [5258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9396),
  [5260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10094),
  [5262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10775),
  [5264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4513),
  [5266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4508),
  [5268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4479),
  [5270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9558),
  [5272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10850),
  [5274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4643),
  [5276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6868),
  [5278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6866),
  [5280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6736),
  [5282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [5284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [5286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3271),
  [5288] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(2981),
  [5291] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1114),
  [5294] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(2179),
  [5297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(2179),
  [5300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(2012),
  [5303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(3664),
  [5306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(7941),
  [5309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(2233),
  [5312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0),
  [5314] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1691),
  [5317] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(8795),
  [5320] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(2549),
  [5323] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1851),
  [5326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(10843),
  [5329] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(10842),
  [5332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(10839),
  [5335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(8503),
  [5338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(4993),
  [5341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(9364),
  [5344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(8660),
  [5347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(4704),
  [5350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(4710),
  [5353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(10832),
  [5356] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(7982),
  [5359] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(9764),
  [5362] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(2506),
  [5365] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(9787),
  [5368] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1938),
  [5371] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(5676),
  [5374] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(6503),
  [5377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4446),
  [5379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4613),
  [5381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4388),
  [5383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5623),
  [5385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4616),
  [5387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5652),
  [5389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4357),
  [5391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4459),
  [5393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3319),
  [5395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6060),
  [5397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5448),
  [5399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8644),
  [5401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8272),
  [5403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3243),
  [5405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [5407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4604),
  [5409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10019),
  [5412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10019),
  [5414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9600),
  [5416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4326),
  [5418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 2, 0, 0),
  [5420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9450),
  [5422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3216),
  [5424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9230),
  [5426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4189),
  [5428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4669),
  [5430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2001),
  [5432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [5434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5684),
  [5436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1958),
  [5438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4850),
  [5440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2300),
  [5442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9837),
  [5444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4433),
  [5446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2079),
  [5448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3333),
  [5450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2242),
  [5452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3339),
  [5454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2135),
  [5456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4267),
  [5458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2551),
  [5460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 7, 0, 220),
  [5462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 7, 0, 220),
  [5464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, 0, 66),
  [5466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 66),
  [5468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [5470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [5472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2382),
  [5474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, 0, 56),
  [5476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, 0, 56),
  [5478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declaration_list_item, 2, 0, 0),
  [5480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declaration_list_item, 2, 0, 0),
  [5482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [5484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [5486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [5488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [5490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10767),
  [5492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [5494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5393),
  [5496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1919),
  [5498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10761),
  [5500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 7, 0, 226),
  [5502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 7, 0, 226),
  [5504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10649),
  [5506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1825),
  [5508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10644),
  [5510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, 0, 209),
  [5512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, 0, 209),
  [5514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, 0, 208),
  [5516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, 0, 208),
  [5518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, 0, 220),
  [5520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, 0, 220),
  [5522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, 0, 196),
  [5524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, 0, 196),
  [5526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, 0, 10),
  [5528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, 0, 10),
  [5530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [5532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 6, 0, 218),
  [5534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 6, 0, 218),
  [5536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_init_declaration, 3, 0, 0),
  [5538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_declaration, 3, 0, 0),
  [5540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 6, 0, 219),
  [5542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 6, 0, 219),
  [5544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_associatedtype_declaration, 3, 0, 106),
  [5546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associatedtype_declaration, 3, 0, 106),
  [5548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_declaration, 6, 0, 218),
  [5550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_declaration, 6, 0, 218),
  [5552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, 0, 56),
  [5554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, 0, 56),
  [5556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, 0, 66),
  [5558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, 0, 66),
  [5560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 6, 0, 175),
  [5562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 6, 0, 175),
  [5564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_method_definition, 3, 0, 67),
  [5566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_method_definition, 3, 0, 67),
  [5568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 183),
  [5570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 183),
  [5572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_method_definition, 3, 0, 66),
  [5574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_method_definition, 3, 0, 66),
  [5576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10780),
  [5578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1866),
  [5580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10783),
  [5582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 209),
  [5584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 209),
  [5586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 182),
  [5588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 182),
  [5590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 208),
  [5592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 208),
  [5594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 66),
  [5596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 66),
  [5598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 196),
  [5600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 196),
  [5602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 5, 0, 206),
  [5604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, 0, 206),
  [5606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_declaration, 5, 0, 206),
  [5608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_declaration, 5, 0, 206),
  [5610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_declaration, 5, 0, 205),
  [5612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_declaration, 5, 0, 205),
  [5614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, 0, 126),
  [5616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, 0, 126),
  [5618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 77),
  [5620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 77),
  [5622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 125),
  [5624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 125),
  [5626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, 0, 77),
  [5628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, 0, 77),
  [5630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 78),
  [5632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 78),
  [5634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 10),
  [5636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 10),
  [5638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_declaration, 4, 0, 181),
  [5640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_declaration, 4, 0, 181),
  [5642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_associatedtype_declaration, 4, 0, 106),
  [5644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associatedtype_declaration, 4, 0, 106),
  [5646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, 0, 183),
  [5648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 183),
  [5650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, 0, 182),
  [5652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 182),
  [5654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3279),
  [5656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 2, 0, 0),
  [5658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 2, 0, 0),
  [5660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2515),
  [5662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [5664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [5666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10002),
  [5668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [5670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8340),
  [5672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3008),
  [5674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [5676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [5678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [5680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9884),
  [5682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [5684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [5686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [5688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4439),
  [5690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [5692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10052),
  [5694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [5696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [5698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [5700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [5702] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10387),
  [5705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2898),
  [5707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2044),
  [5709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [5711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [5713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [5715] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9884),
  [5718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [5720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [5722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [5724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [5726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4380),
  [5728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [5730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [5732] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10372),
  [5735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [5737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [5739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [5741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10378),
  [5744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [5746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [5748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [5750] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10052),
  [5753] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10396),
  [5756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [5758] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10388),
  [5761] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10389),
  [5764] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10335),
  [5767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [5769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10394),
  [5772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10395),
  [5775] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10429),
  [5778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10398),
  [5781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [5783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [5785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [5787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [5789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2164),
  [5791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 148),
  [5793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2552),
  [5795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [5797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [5799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2151),
  [5801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 2, 1, 104),
  [5803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2505),
  [5805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 2, 1, 0),
  [5807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2407),
  [5809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_default_capture, 1, 0, 0),
  [5811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 77),
  [5813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2227),
  [5815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2228),
  [5817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2089),
  [5819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [5821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2518),
  [5823] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10382),
  [5826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2434),
  [5828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [5830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2508),
  [5832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2353),
  [5834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [5836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2203),
  [5838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 1, 190),
  [5840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 104),
  [5842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3150),
  [5844] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10407),
  [5847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [5849] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10360),
  [5852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10512),
  [5854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [5856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [5858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fold_expression, 3, 0, 40),
  [5860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fold_expression, 3, 0, 40),
  [5862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10357),
  [5865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10564),
  [5867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [5869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [5871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7729),
  [5873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [5875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [5877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [5879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1984),
  [5881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [5883] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10406),
  [5886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__requirement_clause_constraint, 3, 0, 0),
  [5888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__requirement_clause_constraint, 3, 0, 0),
  [5890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [5892] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requires_expression, 2, 0, 21),
  [5894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_expression, 2, 0, 21),
  [5896] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint_conjunction, 3, 0, 55),
  [5898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_conjunction, 3, 0, 55),
  [5900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7792),
  [5902] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10405),
  [5905] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10404),
  [5908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [5910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [5912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10358),
  [5914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [5916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10227),
  [5918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [5920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7724),
  [5922] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10403),
  [5925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 3, 0, 72),
  [5927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 3, 0, 72),
  [5929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7218),
  [5931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [5933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 2, 0, 32),
  [5935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 2, 0, 32),
  [5937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 5, 0, 171),
  [5939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 5, 0, 171),
  [5941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requirement_seq, 3, 0, 0),
  [5943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requirement_seq, 3, 0, 0),
  [5945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [5947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4315),
  [5949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7140),
  [5951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [5953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requirement_seq, 2, 0, 0),
  [5955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requirement_seq, 2, 0, 0),
  [5957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7136),
  [5959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7114),
  [5961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requires_expression, 3, 0, 65),
  [5963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_expression, 3, 0, 65),
  [5965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7783),
  [5967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7826),
  [5969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4246),
  [5971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [5973] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10409),
  [5976] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10371),
  [5979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [5981] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10366),
  [5984] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10365),
  [5987] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10363),
  [5990] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10362),
  [5993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7126),
  [5995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7089),
  [5997] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10353),
  [6000] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10352),
  [6003] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10351),
  [6006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10602),
  [6008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [6010] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10350),
  [6013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3807),
  [6015] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10349),
  [6018] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10348),
  [6021] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10346),
  [6024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10628),
  [6026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [6028] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10340),
  [6031] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10345),
  [6034] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10344),
  [6037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10342),
  [6040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [6042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [6044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 3, 0, 71),
  [6046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 3, 0, 71),
  [6048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3115),
  [6050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7097),
  [6052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3869),
  [6054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [6056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 4, 0, 122),
  [6058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 4, 0, 122),
  [6060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 4, 0, 121),
  [6062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 4, 0, 121),
  [6064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [6066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7208),
  [6068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [6070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7829),
  [6072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6699),
  [6074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [6076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [6078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [6080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [6082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [6084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [6086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2777),
  [6088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [6090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [6092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [6094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [6096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2980),
  [6098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2973),
  [6100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [6102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [6104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [6106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [6108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [6110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [6112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [6114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [6116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [6118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [6120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2976),
  [6122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [6124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [6126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [6128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [6130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [6132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0),
  [6134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0),
  [6136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alignas_qualifier, 4, 0, 0),
  [6138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alignas_qualifier, 4, 0, 0),
  [6140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8048),
  [6142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2647),
  [6144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2862),
  [6146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2815),
  [6148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10202),
  [6150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6643),
  [6152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10063),
  [6154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10204),
  [6156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10500),
  [6158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2809),
  [6160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [6162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1214),
  [6165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0),
  [6167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2949),
  [6169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8768),
  [6171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9908),
  [6173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1225),
  [6176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1223),
  [6179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5032),
  [6181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [6183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1771),
  [6185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8666),
  [6187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9955),
  [6189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2605),
  [6192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requires_clause, 2, 0, 22),
  [6194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_clause, 2, 0, 22),
  [6196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6530),
  [6198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6540),
  [6200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6530),
  [6202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6540),
  [6204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint_disjunction, 3, 0, 55),
  [6206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_disjunction, 3, 0, 55),
  [6208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1205),
  [6211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_parameter_list, 3, 0, 0),
  [6213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter_list, 3, 0, 0),
  [6215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_parameter_list, 2, 0, 0),
  [6217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter_list, 2, 0, 0),
  [6219] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_parameter_list, 4, 0, 0),
  [6221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter_list, 4, 0, 0),
  [6223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(2648),
  [6226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2638),
  [6228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2651),
  [6230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [6232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hlsl_attribute, 3, 0, 0),
  [6234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 3, 0, 0),
  [6236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 3, 0, 0),
  [6238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hlsl_attribute, 3, 0, 0),
  [6240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_designator, 3, 0, 0),
  [6242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2658),
  [6244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2656),
  [6246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2650),
  [6248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2658),
  [6251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2661),
  [6253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_storage_class_specifier, 1, 0, 0),
  [6255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_storage_class_specifier, 1, 0, 0),
  [6257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8614),
  [6259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0),
  [6261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0),
  [6263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2647),
  [6266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2665),
  [6269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2815),
  [6272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(10202),
  [6275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(10063),
  [6278] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(10204),
  [6281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(10500),
  [6284] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2809),
  [6287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 2, 0, 2),
  [6289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 2, 0, 2),
  [6291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2665),
  [6293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 3, 0, 20),
  [6295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 3, 0, 20),
  [6297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 1, 0, 2),
  [6299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 1, 0, 2),
  [6301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [6303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2666),
  [6305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5960),
  [6307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2749),
  [6309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [6311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [6313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7532),
  [6315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [6317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [6319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [6321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 2, 0, 20),
  [6323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 2, 0, 20),
  [6325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2670),
  [6327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5945),
  [6329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [6331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [6333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [6335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [6337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [6339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2540),
  [6341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [6343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [6345] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1),
  [6348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3904),
  [6350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8076),
  [6352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3777),
  [6354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4008),
  [6356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3889),
  [6358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [6360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2738),
  [6363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8078),
  [6365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8087),
  [6367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3969),
  [6369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3990),
  [6371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_declspec_modifier, 4, 0, 0),
  [6373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_declspec_modifier, 4, 0, 0),
  [6375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3949),
  [6377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8081),
  [6379] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(1536),
  [6382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7122),
  [6384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__constructor_specifiers, 1, 0, 0), REDUCE(aux_sym__declaration_specifiers_repeat1, 1, 0, 0),
  [6387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constructor_specifiers, 1, 0, 0),
  [6389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__constructor_specifiers, 1, 0, 0),
  [6391] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__constructor_specifiers, 1, 0, 0), REDUCE(aux_sym__declaration_specifiers_repeat1, 1, 0, 0),
  [6394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 1, 0, 0),
  [6396] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2582),
  [6399] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2777),
  [6402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2785),
  [6405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(10895),
  [6408] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(9720),
  [6411] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(10884),
  [6414] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(10877),
  [6417] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2778),
  [6420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualifiers, 1, 0, 0),
  [6422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualifiers, 1, 0, 0),
  [6424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_declaration, 2, 0, 106),
  [6426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5984),
  [6428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1215),
  [6431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 2, 0, 0),
  [6433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 2, 0, 0),
  [6435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2804),
  [6437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 2, 0, 0),
  [6439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 2, 0, 0),
  [6441] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2801),
  [6444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0),
  [6446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0),
  [6448] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8837),
  [6451] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(9922),
  [6454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2801),
  [6456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 3, 0, 0),
  [6458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 3, 0, 0),
  [6460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 3, 0, 0),
  [6462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 3, 0, 0),
  [6464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7086),
  [6466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_condition_clause, 3, 0, 14),
  [6468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_clause, 3, 0, 14),
  [6470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_condition_clause, 4, 0, 143),
  [6472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_clause, 4, 0, 143),
  [6474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6975),
  [6476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10647),
  [6478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [6480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0),
  [6482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0),
  [6484] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2647),
  [6487] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2862),
  [6490] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2815),
  [6493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(10202),
  [6496] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(10063),
  [6499] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(10204),
  [6502] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(10500),
  [6505] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(3371),
  [6508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2809),
  [6511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_string_literal, 7, 0, 217),
  [6513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_string_literal, 7, 0, 217),
  [6515] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34), SHIFT(1227),
  [6518] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34), SHIFT(1225),
  [6521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2872),
  [6524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_string_literal, 5, 0, 0),
  [6526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_string_literal, 5, 0, 0),
  [6528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2968),
  [6530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2903),
  [6532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2965),
  [6534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1216),
  [6537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1803),
  [6539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [6541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(1215),
  [6544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0),
  [6546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0),
  [6548] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(2994),
  [6551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(2940),
  [6554] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(10595),
  [6557] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34), SHIFT(1215),
  [6560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1215),
  [6562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5896),
  [6564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, 0, 20),
  [6566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, 0, 20),
  [6568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [6570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2574),
  [6572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3054),
  [6574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2962),
  [6576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2738),
  [6578] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 45),
  [6580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 45),
  [6582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 63),
  [6584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 63),
  [6586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 89),
  [6588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 89),
  [6590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0),
  [6592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3314),
  [6594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string, 1, 0, 0),
  [6596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string, 1, 0, 0),
  [6598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2967),
  [6600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2961),
  [6602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_expression, 1, 0, 0),
  [6605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_expression, 1, 0, 0),
  [6608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1231),
  [6611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_destructor_name, 2, 0, 0),
  [6613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_destructor_name, 2, 0, 0),
  [6615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7513),
  [6617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3044),
  [6619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3963),
  [6621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10594),
  [6623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [6625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7145),
  [6627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1794),
  [6629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3974),
  [6631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3125),
  [6633] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1229),
  [6636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [6638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10076),
  [6640] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(7727),
  [6643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1780),
  [6645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [6647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1802),
  [6649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [6651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8769),
  [6653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9979),
  [6655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3009),
  [6657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3108),
  [6659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2999),
  [6661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3112),
  [6663] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(3006),
  [6666] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8797),
  [6669] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(9984),
  [6672] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(10076),
  [6675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3031),
  [6677] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(3046),
  [6680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3021),
  [6682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3045),
  [6684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1145),
  [6686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_call_modifier, 1, 0, 0),
  [6688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_call_modifier, 1, 0, 0),
  [6690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3006),
  [6692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8797),
  [6694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9984),
  [6696] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(3031),
  [6699] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8768),
  [6702] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(9908),
  [6705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3019),
  [6707] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(3037),
  [6710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8659),
  [6713] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(9972),
  [6716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3088),
  [6718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3050),
  [6720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3056),
  [6722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2647),
  [6724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2670),
  [6726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2815),
  [6728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10202),
  [6730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10204),
  [6732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10500),
  [6734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5950),
  [6736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2749),
  [6738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2809),
  [6740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3062),
  [6742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8659),
  [6744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9972),
  [6746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3057),
  [6748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3037),
  [6750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7534),
  [6752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1776),
  [6754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [6756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2666),
  [6758] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1227),
  [6761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7385),
  [6763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 1, 1, 0),
  [6765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3083),
  [6767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5067),
  [6769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5067),
  [6771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 1, 1, 0),
  [6773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6926),
  [6775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [6777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 2, 1, 0),
  [6779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 2, 1, 0),
  [6781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 2, 1, 5),
  [6783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 2, 1, 5),
  [6785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [6787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9998),
  [6789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1402),
  [6791] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(3088),
  [6794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 3, 1, 41),
  [6796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 3, 1, 41),
  [6798] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 4, 1, 83),
  [6800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 4, 1, 83),
  [6802] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_type_declarator, 2, 1, 0),
  [6804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_type_declarator, 2, 1, 0),
  [6806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 5, 1, 166),
  [6808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 5, 1, 166),
  [6810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 4, 0, 26),
  [6812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 4, 0, 26),
  [6814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3139),
  [6816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 42),
  [6818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 42),
  [6820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 62),
  [6822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 62),
  [6824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 0),
  [6826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 0),
  [6828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3138),
  [6830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 43),
  [6832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 43),
  [6834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 109),
  [6836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 109),
  [6838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 5, 0, 168),
  [6840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 5, 0, 168),
  [6842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 1),
  [6844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 1),
  [6846] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0),
  [6848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0),
  [6850] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(9998),
  [6853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4295),
  [6855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_type_declarator, 2, 0, 0),
  [6857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_type_declarator, 2, 0, 0),
  [6859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 88),
  [6861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 88),
  [6863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3126),
  [6865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2872),
  [6867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type_declarator, 4, -10, 0),
  [6869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type_declarator, 4, -10, 0),
  [6871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type_declarator, 2, 0, 85),
  [6873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type_declarator, 2, 0, 85),
  [6875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 3, 0, 26),
  [6877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 3, 0, 26),
  [6879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2648),
  [6881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2858),
  [6883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, 0, 132),
  [6885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, 0, 132),
  [6887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type_declarator, 3, -10, 0),
  [6889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type_declarator, 3, -10, 0),
  [6891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7122),
  [6893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7222),
  [6895] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 4, 0, 115),
  [6897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 4, 0, 115),
  [6899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3291),
  [6901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3193),
  [6903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3290),
  [6905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3185),
  [6907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5379),
  [6909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5379),
  [6911] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(3160),
  [6914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3163),
  [6916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5446),
  [6918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5446),
  [6920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3182),
  [6922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4461),
  [6924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_declarator, 3, 0, 163),
  [6926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_declarator, 3, 0, 163),
  [6928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 1, 117),
  [6930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_field_identifier, 2, 1, 117),
  [6932] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 1, 117), SHIFT(1215),
  [6935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3260),
  [6937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3188),
  [6939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_method, 2, 0, 116),
  [6941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_method, 2, 0, 116),
  [6943] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(3188),
  [6946] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8622),
  [6949] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(9961),
  [6952] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, 1, 69),
  [6954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, 1, 69),
  [6956] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_field_expression, 3, 1, 69), SHIFT(1215),
  [6959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10621),
  [6961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [6963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7094),
  [6965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10647),
  [6967] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(3214),
  [6970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_declarator, 4, 0, 163),
  [6972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_declarator, 4, 0, 163),
  [6974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_method, 2, 0, 17),
  [6976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_method, 2, 0, 17),
  [6978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3336),
  [6980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3199),
  [6982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3359),
  [6984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 4, 0, 82),
  [6986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 4, 0, 82),
  [6988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [6990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3278),
  [6992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7334),
  [6994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7334),
  [6996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 73),
  [6998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_identifier, 3, 0, 73),
  [7000] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 73), SHIFT(1215),
  [7003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 0, 34),
  [7005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_field_identifier, 2, 0, 34),
  [7007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 55),
  [7009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 55),
  [7011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 4),
  [7013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 4),
  [7015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_expression, 2, 0, 4),
  [7017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_expression, 2, 0, 4),
  [7019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [7021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [7023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_name, 2, 0, 0),
  [7025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_name, 2, 0, 0),
  [7027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3306),
  [7029] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 40),
  [7031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 40),
  [7033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [7035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [7037] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 4),
  [7039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, 0, 4),
  [7041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 2, 0, 14),
  [7043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 2, 0, 14),
  [7045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_await_expression, 2, 0, 4),
  [7047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_await_expression, 2, 0, 4),
  [7049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 4, 0, 0),
  [7051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4, 0, 0),
  [7053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3369),
  [7055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_field_identifier, 2, 0, 0),
  [7057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_field_identifier, 2, 0, 0),
  [7059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 3, 0, 0),
  [7061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3, 0, 0),
  [7063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [7065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10685),
  [7067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [7069] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(1225),
  [7072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6961),
  [7074] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_argument_list, 4, 0, 0),
  [7076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_argument_list, 4, 0, 0),
  [7078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 4, 0, 0),
  [7080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 4, 0, 0),
  [7082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3160),
  [7084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, 0, 70),
  [7086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, 0, 70),
  [7088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 87),
  [7090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 87),
  [7092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_offsetof_expression, 6, 0, 191),
  [7094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_offsetof_expression, 6, 0, 191),
  [7096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 6, 0, 193),
  [7098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 6, 0, 193),
  [7100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 5, 0, 151),
  [7102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 5, 0, 151),
  [7104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 5, 0, 153),
  [7106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 5, 0, 153),
  [7108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 5, 0, 154),
  [7110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 5, 0, 154),
  [7112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_expression, 8, 0, 0),
  [7114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_expression, 8, 0, 0),
  [7116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 6, 0, 194),
  [7118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 6, 0, 194),
  [7120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3248),
  [7122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6532),
  [7124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6532),
  [7126] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_literal_expression, 4, 0, 82),
  [7128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_literal_expression, 4, 0, 82),
  [7130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 29),
  [7132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, 0, 29),
  [7134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_argument_list, 2, 0, 0),
  [7136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_argument_list, 2, 0, 0),
  [7138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, 0, 164),
  [7140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, 0, 164),
  [7142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6591),
  [7144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6591),
  [7146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 108),
  [7148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 108),
  [7150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 107),
  [7152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 107),
  [7154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, 0, 7),
  [7156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, 0, 7),
  [7158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 61),
  [7160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 61),
  [7162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3244),
  [7164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3246),
  [7166] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 2, 0, 30),
  [7168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 2, 0, 30),
  [7170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, 0, 0),
  [7172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, 0, 0),
  [7174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 0),
  [7176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 0),
  [7178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, 0, 55),
  [7180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, 0, 55),
  [7182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 3, 0, 0),
  [7184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 3, 0, 0),
  [7186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_identifier, 2, 0, 0),
  [7188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_identifier, 2, 0, 0),
  [7190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1227),
  [7192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 9, 0, 229),
  [7194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 9, 0, 229),
  [7196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_name, 3, 0, 0),
  [7198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_name, 3, 0, 0),
  [7200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_expression, 9, 0, 0),
  [7202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_expression, 9, 0, 0),
  [7204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 7, 0, 214),
  [7206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 7, 0, 214),
  [7208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7119),
  [7210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 7, 0, 215),
  [7212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 7, 0, 215),
  [7214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 4, 0, 105),
  [7216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 4, 0, 105),
  [7218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_user_defined_literal, 2, 0, 0),
  [7220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_user_defined_literal, 2, 0, 0),
  [7222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_null, 1, 0, 0),
  [7224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_null, 1, 0, 0),
  [7226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alignof_expression, 4, 0, 45),
  [7228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alignof_expression, 4, 0, 45),
  [7230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 6, 0, 176),
  [7232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 6, 0, 176),
  [7234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 5, 0, 0),
  [7236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 5, 0, 0),
  [7238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_argument_list, 3, 0, 0),
  [7240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_argument_list, 3, 0, 0),
  [7242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_literal_expression, 2, 0, 8),
  [7244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_literal_expression, 2, 0, 8),
  [7246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, 0, 131),
  [7248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, 0, 131),
  [7250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 8, 0, 225),
  [7252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 8, 0, 225),
  [7254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 8, 0, 224),
  [7256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 8, 0, 224),
  [7258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5, 0, 0),
  [7260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5, 0, 0),
  [7262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, 0, 130),
  [7264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, 0, 130),
  [7266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2, 0, 0),
  [7268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2, 0, 0),
  [7270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3368),
  [7272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3357),
  [7274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3406),
  [7276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10681),
  [7278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [7280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3338),
  [7282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3397),
  [7284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3354),
  [7286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3400),
  [7288] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(3346),
  [7291] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(1227),
  [7294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7113),
  [7296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7585),
  [7298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3214),
  [7300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_function_specifier, 4, 0, 0),
  [7302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_function_specifier, 4, 0, 0),
  [7304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(3357),
  [7307] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8696),
  [7310] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(9858),
  [7313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3367),
  [7315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3353),
  [7317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_function_specifier, 1, 0, 0),
  [7319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [7321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_function_specifier, 1, 0, 0),
  [7323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7238),
  [7325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7523),
  [7327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5872),
  [7329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6002),
  [7331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3054),
  [7333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1229),
  [7335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3401),
  [7337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [7339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [7341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3553),
  [7343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3346),
  [7345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3399),
  [7347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3408),
  [7349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(1229),
  [7352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [7354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [7356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3624),
  [7358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 4, 0, 0),
  [7360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 4, 0, 0),
  [7362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2106),
  [7364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2105),
  [7366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [7368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [7370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2101),
  [7372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2098),
  [7374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2095),
  [7376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [7378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2092),
  [7380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2092),
  [7382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2091),
  [7384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [7386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2104),
  [7388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2102),
  [7390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2094),
  [7392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2539),
  [7394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7096),
  [7396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7584),
  [7398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 2, 0, 0),
  [7400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 2, 0, 0),
  [7402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3280),
  [7404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [7406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 3, 0, 0),
  [7408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 3, 0, 0),
  [7410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 4, 0, 118),
  [7412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 4, 0, 118),
  [7414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 5, 0, 169),
  [7416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5, 0, 169),
  [7418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 3, 1, 0),
  [7420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 3, 1, 0),
  [7422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 5, 0, 0),
  [7424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 5, 0, 0),
  [7426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_char_literal, 3, 0, 0),
  [7428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_char_literal, 3, 0, 0),
  [7430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [7432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23),
  [7434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6525),
  [7436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6525),
  [7438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4847),
  [7440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10555),
  [7442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9931),
  [7444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 1, 0, 23),
  [7446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4847),
  [7448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10556),
  [7450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8382),
  [7452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3899),
  [7454] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(7165),
  [7457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6676),
  [7459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10207),
  [7461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(6527),
  [7464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(4232),
  [7467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7165),
  [7469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6527),
  [7471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3948),
  [7473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2024),
  [7475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2025),
  [7477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [7479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [7481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2028),
  [7483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2029),
  [7485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2030),
  [7487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [7489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2032),
  [7491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [7493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2033),
  [7495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [7497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2026),
  [7499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2027),
  [7501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [7503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [7505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [7507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [7509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3950),
  [7511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(9931),
  [7514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4073),
  [7516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6562),
  [7518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4071),
  [7520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [7522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [7524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10047),
  [7526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1410),
  [7528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4306),
  [7530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [7532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4316),
  [7534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1895),
  [7536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1901),
  [7538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1903),
  [7540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1904),
  [7542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1911),
  [7544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [7546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [7548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1918),
  [7550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1924),
  [7552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1934),
  [7554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [7556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [7558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1810),
  [7560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [7562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1933),
  [7564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [7566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1927),
  [7568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1926),
  [7570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [7572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1720),
  [7574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [7576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [7578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [7580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [7582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [7584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [7586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [7588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [7590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [7592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [7594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [7596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [7598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [7600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1842),
  [7602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1834),
  [7604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [7606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1826),
  [7608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [7610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [7612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4308),
  [7614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7345),
  [7616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7118),
  [7618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10129),
  [7620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3219),
  [7622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5877),
  [7624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4443),
  [7626] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(7145),
  [7629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(6562),
  [7632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(3876),
  [7635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5955),
  [7637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [7639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10062),
  [7641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1401),
  [7643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_requirement, 4, 0, 0),
  [7645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_requirement, 4, 0, 0),
  [7647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_requirement, 5, 0, 0),
  [7649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_requirement, 5, 0, 0),
  [7651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_requirement, 2, 0, 0),
  [7653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_requirement, 2, 0, 0),
  [7655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_requirement, 6, 0, 0),
  [7657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_requirement, 6, 0, 0),
  [7659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__requirement, 1, 0, 64),
  [7661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__requirement, 1, 0, 64),
  [7663] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(10047),
  [7666] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 73), SHIFT(1231),
  [7669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7345),
  [7671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3787),
  [7673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5433),
  [7675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6694),
  [7677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8126),
  [7679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2948),
  [7681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4153),
  [7683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2432),
  [7685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2427),
  [7687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2416),
  [7689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [7691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2409),
  [7693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2397),
  [7695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2384),
  [7697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [7699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2370),
  [7701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [7703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2354),
  [7705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [7707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [7709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2416),
  [7711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2410),
  [7713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [7715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [7717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2348),
  [7719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2346),
  [7721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [7723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [7725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2335),
  [7727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2321),
  [7729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2318),
  [7731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [7733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2315),
  [7735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2315),
  [7737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2314),
  [7739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2345),
  [7741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2344),
  [7743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [7745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [7747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4133),
  [7749] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(6537),
  [7752] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(4027),
  [7755] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 73), SHIFT(1214),
  [7758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10594),
  [7760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [7762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4370),
  [7764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6537),
  [7766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3773),
  [7768] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 1, 117), SHIFT(1225),
  [7771] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_field_expression, 3, 1, 69), SHIFT(1225),
  [7774] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(10555),
  [7777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3875),
  [7779] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(3768),
  [7782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4026),
  [7784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(10062),
  [7787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10633),
  [7789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4853),
  [7791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8102),
  [7793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4923),
  [7795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5052),
  [7797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7355),
  [7799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6279),
  [7801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6285),
  [7803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6296),
  [7805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5757),
  [7807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5891),
  [7809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6298),
  [7811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6299),
  [7813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5741),
  [7815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8071),
  [7817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5194),
  [7819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7440),
  [7821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6236),
  [7823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6240),
  [7825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6242),
  [7827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5889),
  [7829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6243),
  [7831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6244),
  [7833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6109),
  [7835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6114),
  [7837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6218),
  [7839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7420),
  [7841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6309),
  [7843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6312),
  [7845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6313),
  [7847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5926),
  [7849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6315),
  [7851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6316),
  [7853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4916),
  [7855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8120),
  [7857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7343),
  [7859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7343),
  [7861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5527),
  [7863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8066),
  [7865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5512),
  [7867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5920),
  [7869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7360),
  [7871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6271),
  [7873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6272),
  [7875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6273),
  [7877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5916),
  [7879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6274),
  [7881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6275),
  [7883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5978),
  [7885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1955),
  [7887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1950),
  [7889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [7891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1947),
  [7893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1943),
  [7895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1991),
  [7897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1996),
  [7899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [7901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2008),
  [7903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [7905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2013),
  [7907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [7909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1948),
  [7911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1947),
  [7913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [7915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [7917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [7919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4192),
  [7921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6424),
  [7923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6424),
  [7925] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(4372),
  [7928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2906),
  [7930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4371),
  [7932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3859),
  [7934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8205),
  [7936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3839),
  [7938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6426),
  [7940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6426),
  [7942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6952),
  [7944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3817),
  [7946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6411),
  [7948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6411),
  [7950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6954),
  [7952] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 1, 117), SHIFT(1227),
  [7955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4658),
  [7957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10610),
  [7959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3281),
  [7961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1899),
  [7963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1898),
  [7965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1897),
  [7967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1896),
  [7969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1893),
  [7971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [7973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [7975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1889),
  [7977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1887),
  [7979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1886),
  [7981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [7983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [7985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1883),
  [7987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [7989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1879),
  [7991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1878),
  [7993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1877),
  [7995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1875),
  [7997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10660),
  [7999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [8001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10675),
  [8003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10706),
  [8005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10707),
  [8007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10710),
  [8009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10711),
  [8011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10712),
  [8013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10714),
  [8015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10718),
  [8017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10719),
  [8019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10720),
  [8021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2329),
  [8023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [8025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [8027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [8029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [8031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [8033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [8035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4659),
  [8037] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 73), SHIFT(1225),
  [8040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4092),
  [8042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5677),
  [8044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8039),
  [8046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5463),
  [8048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5997),
  [8050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7443),
  [8052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6286),
  [8054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6287),
  [8056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6292),
  [8058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5875),
  [8060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6293),
  [8062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6294),
  [8064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6064),
  [8066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8104),
  [8068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5859),
  [8070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7371),
  [8072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6203),
  [8074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6204),
  [8076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6205),
  [8078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5924),
  [8080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6209),
  [8082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6213),
  [8084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [8086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [8088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3917),
  [8090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6420),
  [8092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6420),
  [8094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6902),
  [8096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6870),
  [8098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3324),
  [8100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3324),
  [8102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3217),
  [8104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10616),
  [8106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4514),
  [8108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4531),
  [8110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2002),
  [8112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1977),
  [8114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [8116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [8118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1966),
  [8120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2401),
  [8122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2129),
  [8124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [8126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2507),
  [8128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2538),
  [8130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [8132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [8134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1967),
  [8136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1975),
  [8138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1968),
  [8140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1966),
  [8142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [8144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4529),
  [8146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7338),
  [8148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7338),
  [8150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [8152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10895),
  [8154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10877),
  [8156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4190),
  [8158] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(4009),
  [8161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5050),
  [8163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8089),
  [8165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7442),
  [8167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6202),
  [8169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6277),
  [8171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6278),
  [8173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5880),
  [8175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6282),
  [8177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6284),
  [8179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6808),
  [8181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6080),
  [8183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3691),
  [8185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7405),
  [8187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4633),
  [8189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6075),
  [8191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4257),
  [8193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3933),
  [8195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(4092),
  [8198] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8769),
  [8201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(9979),
  [8204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [8206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5812),
  [8208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4415),
  [8210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4415),
  [8212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4262),
  [8214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10785),
  [8216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4004),
  [8218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1205),
  [8220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [8222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4075),
  [8224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4075),
  [8226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3693),
  [8228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10323),
  [8230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4283),
  [8232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4283),
  [8234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4056),
  [8236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10880),
  [8238] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_field_expression, 3, 1, 69), SHIFT(1227),
  [8241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4294),
  [8243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 73), SHIFT(1230),
  [8246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5009),
  [8248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(4239),
  [8251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3893),
  [8253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(6538),
  [8256] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(3986),
  [8259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 73), SHIFT(1227),
  [8262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4436),
  [8264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4398),
  [8266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(1216),
  [8269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6557),
  [8271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6557),
  [8273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6556),
  [8275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6556),
  [8277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6084),
  [8279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10688),
  [8281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10648),
  [8283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8382),
  [8285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3826),
  [8287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7165),
  [8289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6676),
  [8291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10207),
  [8293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6585),
  [8295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4047),
  [8297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6538),
  [8299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3892),
  [8301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(7165),
  [8304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(6585),
  [8307] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(4221),
  [8310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(4358),
  [8313] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8666),
  [8316] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(9955),
  [8319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4239),
  [8321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4391),
  [8323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4385),
  [8325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4366),
  [8327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4358),
  [8329] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 73), SHIFT(1232),
  [8332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__binary_fold_operator, 3, 0, 127),
  [8334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__binary_fold_operator, 3, 0, 127),
  [8336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2256),
  [8338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2257),
  [8340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2261),
  [8342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2265),
  [8344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2267),
  [8346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2283),
  [8348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [8350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2292),
  [8352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [8354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2293),
  [8356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2265),
  [8358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2267),
  [8360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [8362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6531),
  [8364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6533),
  [8366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6531),
  [8368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6533),
  [8370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [8372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3867),
  [8374] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(4132),
  [8377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7242),
  [8379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7498),
  [8381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3993),
  [8383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6547),
  [8385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4173),
  [8387] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(6547),
  [8390] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(4205),
  [8393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3782),
  [8395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(10063),
  [8398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3938),
  [8400] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(6564),
  [8403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(3953),
  [8406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4216),
  [8408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6581),
  [8410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4217),
  [8412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3801),
  [8414] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(4058),
  [8417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3901),
  [8419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(6581),
  [8422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(4194),
  [8425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [8427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4580),
  [8429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6480),
  [8431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6480),
  [8433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5745),
  [8435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5745),
  [8437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5744),
  [8439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1406),
  [8441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [8443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(1205),
  [8446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4587),
  [8448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6478),
  [8450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6478),
  [8452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6094),
  [8454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4933),
  [8456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4933),
  [8458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4942),
  [8460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [8462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6094),
  [8464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10622),
  [8466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6564),
  [8468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4129),
  [8470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4732),
  [8472] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(4617),
  [8475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [8477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4794),
  [8479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6588),
  [8481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10677),
  [8483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [8485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4758),
  [8487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4651),
  [8489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4749),
  [8491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6589),
  [8493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4755),
  [8495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4675),
  [8497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6515),
  [8499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6515),
  [8501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7214),
  [8503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4709),
  [8505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6520),
  [8507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6520),
  [8509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1223),
  [8511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0),
  [8513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0),
  [8515] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4847),
  [8518] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(10556),
  [8521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(1223),
  [8524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4617),
  [8526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4746),
  [8528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [8530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [8532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4736),
  [8534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4741),
  [8536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5912),
  [8538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 1, 0, 2),
  [8540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5870),
  [8542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5784),
  [8544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5928),
  [8546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0),
  [8548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0),
  [8550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(4933),
  [8553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(4942),
  [8556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, 0, 20),
  [8558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5947),
  [8560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5852),
  [8562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4789),
  [8564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6536),
  [8566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6536),
  [8568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7159),
  [8570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7577),
  [8572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4797),
  [8574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6544),
  [8576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6544),
  [8578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4814),
  [8580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6555),
  [8582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6555),
  [8584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5665),
  [8586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4963),
  [8588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4957),
  [8590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10205),
  [8592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4818),
  [8594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6701),
  [8596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6701),
  [8598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4822),
  [8600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6689),
  [8602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6689),
  [8604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6118),
  [8606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6120),
  [8608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10622),
  [8610] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(4963),
  [8613] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(4957),
  [8616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [8618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4839),
  [8620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6612),
  [8622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6612),
  [8624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4849),
  [8626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6773),
  [8628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6773),
  [8630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5876),
  [8632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2462),
  [8634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2454),
  [8636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2454),
  [8638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [8640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2512),
  [8642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2374),
  [8644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [8646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2255),
  [8648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [8650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2224),
  [8652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [8654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [8656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [8658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2430),
  [8660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2512),
  [8662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2263),
  [8664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2244),
  [8666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2134),
  [8668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5121),
  [8670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8869),
  [8672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 1, 0, 56),
  [8674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4941),
  [8676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4941),
  [8678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10221),
  [8680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2336),
  [8682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_start, 1, 0, 0),
  [8684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_start, 1, 0, 0),
  [8686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4860),
  [8688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6843),
  [8690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6843),
  [8692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4864),
  [8694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6735),
  [8696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6735),
  [8698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [8700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [8702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5124),
  [8704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator, 3, 0, 138),
  [8706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4728),
  [8708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 3, 0, 138),
  [8710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [8712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4867),
  [8714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6815),
  [8716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6815),
  [8718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [8720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3116),
  [8722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6486),
  [8724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4932),
  [8726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6924),
  [8728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6924),
  [8730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4942),
  [8732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3109),
  [8734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10556),
  [8736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3111),
  [8738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4277),
  [8740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6488),
  [8742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4896),
  [8744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6968),
  [8746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6968),
  [8748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4273),
  [8750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4276),
  [8752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4897),
  [8754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6898),
  [8756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6898),
  [8758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4899),
  [8760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6927),
  [8762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6927),
  [8764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5026),
  [8766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4914),
  [8768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5028),
  [8770] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(4908),
  [8773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3957),
  [8775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6489),
  [8777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4915),
  [8779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6936),
  [8781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6936),
  [8783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3961),
  [8785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3959),
  [8787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(4912),
  [8790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [8792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5104),
  [8794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4917),
  [8796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5106),
  [8798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7849),
  [8800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6492),
  [8802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4929),
  [8804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6947),
  [8806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6947),
  [8808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7848),
  [8810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7859),
  [8812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4927),
  [8814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6941),
  [8816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6941),
  [8818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_pointer_modifier, 1, 0, 0),
  [8820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_pointer_modifier, 1, 0, 0),
  [8822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4937),
  [8824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6948),
  [8826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6948),
  [8828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4945),
  [8830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6910),
  [8832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6910),
  [8834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_reference_declarator, 1, 0, 0),
  [8836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_reference_declarator, 1, 0, 0),
  [8838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_unaligned_ptr_modifier, 1, 0, 0),
  [8840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_unaligned_ptr_modifier, 1, 0, 0),
  [8842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, 0, 20),
  [8844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6590),
  [8846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6584),
  [8848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7061),
  [8850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2266),
  [8852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [8854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2268),
  [8856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [8858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [8860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2279),
  [8862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [8864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2286),
  [8866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2290),
  [8868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2307),
  [8870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2307),
  [8872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2310),
  [8874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [8876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [8878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [8880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [8882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2286),
  [8884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6582),
  [8886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6582),
  [8888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4972),
  [8890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6986),
  [8892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6986),
  [8894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6583),
  [8896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6583),
  [8898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5870),
  [8900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [8902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, 0, 2),
  [8904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [8906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5070),
  [8908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8439),
  [8910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6521),
  [8912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5109),
  [8914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7067),
  [8916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7067),
  [8918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6191),
  [8920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_range_loop_body, 4, 0, 188),
  [8922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2360),
  [8924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [8926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2363),
  [8928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [8930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [8932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2371),
  [8934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [8936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2390),
  [8938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [8940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2399),
  [8942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2399),
  [8944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2400),
  [8946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [8948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [8950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [8952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2371),
  [8954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [8956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5060),
  [8958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5089),
  [8960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5119),
  [8962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5980),
  [8964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5112),
  [8966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4908),
  [8968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5922),
  [8970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5058),
  [8972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7011),
  [8974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7011),
  [8976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10663),
  [8978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [8980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 1, 0, 2),
  [8982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5883),
  [8984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5784),
  [8986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7709),
  [8988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5118),
  [8990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7018),
  [8992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7018),
  [8994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [8996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [8998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4598),
  [9000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5054),
  [9002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5055),
  [9004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 2, 0, 20),
  [9006] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(5119),
  [9009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [9011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5726),
  [9013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4872),
  [9015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5730),
  [9017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [9019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2522),
  [9021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2527),
  [9023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2527),
  [9025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [9027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [9029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2531),
  [9031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2532),
  [9033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2533),
  [9035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2534),
  [9037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2483),
  [9039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [9041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2536),
  [9043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [9045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2294),
  [9047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [9049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [9051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5621),
  [9053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [9055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 4, 0, 174),
  [9057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [9059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [9061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2309),
  [9063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [9065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2312),
  [9067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [9069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [9071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2325),
  [9073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [9075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2327),
  [9077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [9079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2332),
  [9081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [9083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [9085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2663),
  [9087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [9089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [9091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [9093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [9095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5873),
  [9097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [9099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5139),
  [9101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7178),
  [9103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7178),
  [9105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [9107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8233),
  [9109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3370),
  [9111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4862),
  [9113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8052),
  [9115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [9117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2833),
  [9119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [9121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4155),
  [9123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4690),
  [9125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [9127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [9129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3294),
  [9131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [9133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4368),
  [9135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [9137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5666),
  [9139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [9141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [9143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [9145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2637),
  [9147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [9149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3321),
  [9151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [9153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5658),
  [9155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4441),
  [9157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [9159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4635),
  [9161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4250),
  [9163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5890),
  [9165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3293),
  [9167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4460),
  [9169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [9171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [9173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [9175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [9177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [9179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4594),
  [9181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [9183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_start, 2, 0, 0),
  [9185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_start, 2, 0, 0),
  [9187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comma_expression, 3, 0, 80),
  [9189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [9191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4363),
  [9193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [9195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [9197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5201),
  [9199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7206),
  [9201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7206),
  [9203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [9205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4487),
  [9207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [9209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_declarator, 3, 0, 111),
  [9211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_declaration, 4, 0, 185),
  [9213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [9215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [9217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitfield_clause, 2, 0, 0),
  [9219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5692),
  [9221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3363),
  [9223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5214),
  [9225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7201),
  [9227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7201),
  [9229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [9231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2445),
  [9233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5728),
  [9235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [9237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [9239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2871),
  [9241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4430),
  [9243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3255),
  [9245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2865),
  [9247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [9249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5710),
  [9251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4636),
  [9253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8239),
  [9255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8068),
  [9257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4472),
  [9259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [9261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4564),
  [9263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4475),
  [9265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [9267] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2, 0, 0), SHIFT(1913),
  [9270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2, 0, 0),
  [9272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_initializer_pair, 3, 0, 136), SHIFT(1913),
  [9275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_pair, 3, 0, 136),
  [9277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4614),
  [9279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4321),
  [9281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4327),
  [9283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [9285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [9287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [9289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [9291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [9293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [9295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2788),
  [9297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [9299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3658),
  [9301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [9303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3660),
  [9305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [9307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3674),
  [9309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3440),
  [9311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [9313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2800),
  [9315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3451),
  [9317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2803),
  [9319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2641),
  [9321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3414),
  [9323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [9325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4394),
  [9327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2377),
  [9329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [9331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2654),
  [9333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [9335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [9337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [9339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [9341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [9343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [9345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [9347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2600),
  [9349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2601),
  [9351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3155),
  [9353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [9355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3190),
  [9357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5023),
  [9359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3170),
  [9361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5019),
  [9363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4416),
  [9365] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(5745),
  [9368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(5745),
  [9371] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(5744),
  [9374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5035),
  [9376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2812),
  [9378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2814),
  [9380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2825),
  [9382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4409),
  [9384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4502),
  [9386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4530),
  [9388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7931),
  [9390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8020),
  [9392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2850),
  [9394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2846),
  [9396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4242),
  [9398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [9400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3300),
  [9402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2856),
  [9404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2839),
  [9406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [9408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [9410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [9412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [9414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [9416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [9418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [9420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [9422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [9424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7964),
  [9426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [9428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2341),
  [9430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2204),
  [9432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2204),
  [9434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [9436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [9438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2406),
  [9440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [9442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2429),
  [9444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2433),
  [9446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2436),
  [9448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2436),
  [9450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [9452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2301),
  [9454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [9456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2501),
  [9458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2406),
  [9460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2429),
  [9462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [9464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2835),
  [9466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7087),
  [9468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7551),
  [9470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [9472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [9474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7475),
  [9476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [9478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [9480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5343),
  [9482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7349),
  [9484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7349),
  [9486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5985),
  [9488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_subscript_argument_list_repeat1, 2, 0, 0),
  [9490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 6, 4, 0),
  [9492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 4, 0, 0),
  [9494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 5, 4, 0),
  [9496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [9498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [9500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 3, 0, 0),
  [9502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [9504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1993),
  [9506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter_declaration, 3, 0, 157),
  [9508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7130),
  [9510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10663),
  [9512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23),
  [9514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 2, 0, 23),
  [9516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(7165),
  [9519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(6527),
  [9522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(4232),
  [9525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_lambda_capture_specifier_repeat1, 2, 0, 0),
  [9527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 1, 0),
  [9529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2557),
  [9531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [9533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [9535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [9537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2481),
  [9539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2396),
  [9541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7444),
  [9543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10117),
  [9545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 1, 186),
  [9547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 1, 187),
  [9549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 1, 189),
  [9551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3612),
  [9553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [9555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter_declaration, 4, 0, 196),
  [9557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [9559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_pair, 3, 0, 137),
  [9561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [9563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0),
  [9565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0),
  [9567] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(10555),
  [9570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7428),
  [9572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10636),
  [9574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7424),
  [9576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10753),
  [9578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [9580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 4, 0, 198),
  [9582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 5, 1, 210),
  [9584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2782),
  [9586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9251),
  [9588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_declaration, 1, 0, 0),
  [9590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5878),
  [9592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7409),
  [9594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10822),
  [9596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5450),
  [9598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7290),
  [9600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7290),
  [9602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7397),
  [9604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10821),
  [9606] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(2582),
  [9609] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(2582),
  [9612] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(10877),
  [9615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 146),
  [9617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0),
  [9619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [9621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [9623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 147),
  [9625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5734),
  [9627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5733),
  [9629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7376),
  [9631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10427),
  [9633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [9635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [9637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7406),
  [9639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10615),
  [9641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [9643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [9645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3996),
  [9647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [9649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [9651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [9653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3010),
  [9655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [9657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [9659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3020),
  [9661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [9663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [9665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [9667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [9669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3708),
  [9671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [9673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [9675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2883),
  [9677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4450),
  [9679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5631),
  [9681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [9683] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(5700),
  [9686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5481),
  [9688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5697),
  [9690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(9931),
  [9693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unary_left_fold, 3, 0, 55),
  [9695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3356),
  [9697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [9699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2451),
  [9701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3913),
  [9703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_range_loop_body, 5, 0, 211),
  [9705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5375),
  [9707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [9709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [9711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [9713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [9715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [9717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6658),
  [9719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [9721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9382),
  [9723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assignment_expression_lhs, 3, 0, 55),
  [9725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [9727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [9729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6097),
  [9731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5678),
  [9733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [9735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [9737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__binary_fold, 3, 0, 81),
  [9739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [9741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [9743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [9745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [9747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [9749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3884),
  [9751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [9753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2851),
  [9755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [9757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2723),
  [9759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [9761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8888),
  [9763] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(7145),
  [9766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(6562),
  [9769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(3876),
  [9772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6081),
  [9774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [9776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9113),
  [9778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [9780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [9782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3534),
  [9784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [9786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2181),
  [9788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [9790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4584),
  [9792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4827),
  [9794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [9796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9473),
  [9798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [9800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5007),
  [9802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [9804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [9806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2492),
  [9808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2492),
  [9810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3173),
  [9812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [9814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9208),
  [9816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [9818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3705),
  [9820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4742),
  [9822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [9824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [9826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4060),
  [9828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4010),
  [9830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3970),
  [9832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3925),
  [9834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3303),
  [9836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8075),
  [9838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3203),
  [9840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3385),
  [9842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7356),
  [9844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6302),
  [9846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6305),
  [9848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6306),
  [9850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3600),
  [9852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10678),
  [9854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5993),
  [9856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6307),
  [9858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6308),
  [9860] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(5622),
  [9863] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5665),
  [9866] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(10205),
  [9869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [9871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6576),
  [9873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4148),
  [9875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8113),
  [9877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7388),
  [9879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6347),
  [9881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6346),
  [9883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6345),
  [9885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5937),
  [9887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6342),
  [9889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6340),
  [9891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7476),
  [9893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3389),
  [9895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8115),
  [9897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3343),
  [9899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3424),
  [9901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7357),
  [9903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6255),
  [9905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6256),
  [9907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6259),
  [9909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3864),
  [9911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10672),
  [9913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5977),
  [9915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6263),
  [9917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6264),
  [9919] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 2, 0, 2),
  [9921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [9923] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(10895),
  [9926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 3, 0, 20),
  [9928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5714),
  [9930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5715),
  [9932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7147),
  [9934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5622),
  [9936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4723),
  [9938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8098),
  [9940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4648),
  [9942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4787),
  [9944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7368),
  [9946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6301),
  [9948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6232),
  [9950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6241),
  [9952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5011),
  [9954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10664),
  [9956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6008),
  [9958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6251),
  [9960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6253),
  [9962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5722),
  [9964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5702),
  [9966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2989),
  [9968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8070),
  [9970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3011),
  [9972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3122),
  [9974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7370),
  [9976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6216),
  [9978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6210),
  [9980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6208),
  [9982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3055),
  [9984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10598),
  [9986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5939),
  [9988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6207),
  [9990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6206),
  [9992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4119),
  [9994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8035),
  [9996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3812),
  [9998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4542),
  [10000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7365),
  [10002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6328),
  [10004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6331),
  [10006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6332),
  [10008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4774),
  [10010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10682),
  [10012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5867),
  [10014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6338),
  [10016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6339),
  [10018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5732),
  [10020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5669),
  [10022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3236),
  [10024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8107),
  [10026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3153),
  [10028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3347),
  [10030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7463),
  [10032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6260),
  [10034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6254),
  [10036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6247),
  [10038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3515),
  [10040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10559),
  [10042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5919),
  [10044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6234),
  [10046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6233),
  [10048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2992),
  [10050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3003),
  [10052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3127),
  [10054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7435),
  [10056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5974),
  [10058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10555),
  [10060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6592),
  [10062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23),
  [10064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 3, 0, 23),
  [10066] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(7165),
  [10069] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(6527),
  [10072] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(4232),
  [10075] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(10555),
  [10078] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(3768),
  [10081] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(6537),
  [10084] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(4027),
  [10087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7465),
  [10089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8067),
  [10091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7358),
  [10093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6310),
  [10095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6311),
  [10097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6321),
  [10099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5902),
  [10101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6322),
  [10103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6323),
  [10105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(1533),
  [10108] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(9931),
  [10111] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(7145),
  [10114] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(6562),
  [10117] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(3876),
  [10120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7123),
  [10122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6084),
  [10125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(10648),
  [10128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(646),
  [10130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8132),
  [10132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [10134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7158),
  [10136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7098),
  [10138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(4009),
  [10141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(10877),
  [10144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [10146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8117),
  [10148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(628),
  [10150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6094),
  [10153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(10622),
  [10156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7129),
  [10158] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(6118),
  [10161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(6120),
  [10164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7224),
  [10166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(7165),
  [10169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(6585),
  [10172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(4221),
  [10175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7099),
  [10177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(10688),
  [10180] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(6538),
  [10183] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(3986),
  [10186] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(10555),
  [10189] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(3768),
  [10192] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(6537),
  [10195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(4027),
  [10198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(2647),
  [10201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(10500),
  [10204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(6547),
  [10207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(4205),
  [10210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(4132),
  [10213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2818),
  [10215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4125),
  [10217] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(10063),
  [10220] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5665),
  [10223] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(10205),
  [10226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(6581),
  [10229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(4194),
  [10232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(4009),
  [10235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3775),
  [10237] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(4058),
  [10240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3926),
  [10242] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(6564),
  [10245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(3953),
  [10248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(10202),
  [10251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6128),
  [10253] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(6149),
  [10256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(6146),
  [10259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(6141),
  [10262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 1, 0, 2),
  [10264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 1, 0, 2),
  [10266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5909),
  [10268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2926),
  [10270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 2), SHIFT(2738),
  [10273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 2, 0, 20),
  [10275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 2, 0, 20),
  [10277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23),
  [10279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 4, 0, 23),
  [10281] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(7165),
  [10284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(6527),
  [10287] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(4232),
  [10290] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 18), SHIFT(2738),
  [10293] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 20), SHIFT(2738),
  [10296] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 36), SHIFT(2738),
  [10299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(7165),
  [10302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(6585),
  [10305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(4221),
  [10308] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(6538),
  [10311] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(3986),
  [10314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 20), SHIFT(6129),
  [10317] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT(2738),
  [10321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 36), SHIFT(6132),
  [10324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(9931),
  [10327] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(7145),
  [10330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(6562),
  [10333] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(3876),
  [10336] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(4132),
  [10339] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(6547),
  [10342] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(4205),
  [10345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2742),
  [10347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8086),
  [10349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5218),
  [10351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5689),
  [10353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2943),
  [10355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2807),
  [10357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(6121),
  [10360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4836),
  [10362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4747),
  [10364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3334),
  [10366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5736),
  [10368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3395),
  [10370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5003),
  [10372] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(4058),
  [10375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5522),
  [10377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [10379] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(10063),
  [10382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3344),
  [10384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8061),
  [10386] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(6564),
  [10389] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(3953),
  [10392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(277),
  [10394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4255),
  [10396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4582),
  [10398] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(6581),
  [10401] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(4194),
  [10404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8420),
  [10406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8536),
  [10408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8518),
  [10410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8447),
  [10412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8404),
  [10414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8402),
  [10416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8478),
  [10418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8386),
  [10420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8494),
  [10422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8475),
  [10424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8379),
  [10426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8407),
  [10428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8441),
  [10430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8476),
  [10432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8455),
  [10434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8523),
  [10436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8502),
  [10438] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(6537),
  [10441] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(4027),
  [10444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8491),
  [10446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8486),
  [10448] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(10555),
  [10451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8477),
  [10453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8461),
  [10455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(3768),
  [10458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8454),
  [10460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8444),
  [10462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8436),
  [10464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8452),
  [10466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8423),
  [10468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8380),
  [10470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 3, 0, 20),
  [10472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 3, 0, 20),
  [10474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 2, 0, 2),
  [10476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 2, 0, 2),
  [10478] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(4009),
  [10481] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(7165),
  [10484] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(6585),
  [10487] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(4221),
  [10490] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(6538),
  [10493] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(3986),
  [10496] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(6547),
  [10499] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(4205),
  [10502] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(10063),
  [10505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7812),
  [10507] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(4132),
  [10510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [10512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [10514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3283),
  [10516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8815),
  [10518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(4058),
  [10521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(6581),
  [10524] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(4194),
  [10527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [10529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [10531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5751),
  [10533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8835),
  [10535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [10537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [10539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4301),
  [10541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8902),
  [10543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [10545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [10547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4958),
  [10549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8715),
  [10551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [10553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [10555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4428),
  [10557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8847),
  [10559] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(10063),
  [10562] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(6564),
  [10565] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(3953),
  [10568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4973),
  [10570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [10572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [10574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4649),
  [10576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8716),
  [10578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [10580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [10582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [10584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [10586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1415),
  [10588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [10590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10049),
  [10592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [10594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [10596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [10598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10000),
  [10600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2558),
  [10602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [10604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [10606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9854),
  [10608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ref_qualifier, 1, 0, 0),
  [10610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_qualifier, 1, 0, 0),
  [10612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [10614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6956),
  [10616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8877),
  [10618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7404),
  [10620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6862),
  [10622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2597),
  [10624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [10626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8119),
  [10628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2610),
  [10630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8636),
  [10632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [10634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4504),
  [10636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [10638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3256),
  [10640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4490),
  [10642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [10644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7021),
  [10646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8787),
  [10648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [10650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7069),
  [10652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1830),
  [10654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [10656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10545),
  [10658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6541),
  [10660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9535),
  [10662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [10664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8046),
  [10666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4032),
  [10668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7628),
  [10670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [10672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7493),
  [10674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23),
  [10676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 5, 0, 23),
  [10678] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(7145),
  [10681] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(6562),
  [10684] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(3876),
  [10687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7525),
  [10689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__preproc_expression, 1, 0, 0),
  [10691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6594),
  [10693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__preproc_expression, 1, 0, 0),
  [10695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3154),
  [10697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9139),
  [10699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [10701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4289),
  [10703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4279),
  [10705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [10707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6558),
  [10709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9404),
  [10711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6810),
  [10713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4955),
  [10715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7506),
  [10717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6737),
  [10719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7497),
  [10721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6733),
  [10723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_end, 1, 0, 0),
  [10725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_end, 1, 0, 0),
  [10727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7023),
  [10729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1361),
  [10731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6572),
  [10733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9207),
  [10735] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(7165),
  [10738] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(6527),
  [10741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(4232),
  [10744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_end, 2, 0, 0),
  [10746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_end, 2, 0, 0),
  [10748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2848),
  [10750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9641),
  [10752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6896),
  [10754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7685),
  [10756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4965),
  [10758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7439),
  [10760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2607),
  [10762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [10764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4626),
  [10766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4631),
  [10768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4986),
  [10770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3264),
  [10772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5635),
  [10774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7028),
  [10776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6551),
  [10778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6809),
  [10780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6824),
  [10782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9861),
  [10784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6781),
  [10786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6781),
  [10788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6719),
  [10790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9306),
  [10792] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(3768),
  [10795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_specifier, 4, 0, 0),
  [10797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_specifier, 4, 0, 0),
  [10799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_specifier, 5, 0, 0),
  [10801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_specifier, 5, 0, 0),
  [10803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8072),
  [10805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9313),
  [10807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10296),
  [10809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6650),
  [10811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6766),
  [10813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10881),
  [10815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6757),
  [10817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6755),
  [10819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6755),
  [10821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6752),
  [10823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6751),
  [10825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6750),
  [10827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6748),
  [10829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6746),
  [10831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6744),
  [10833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6743),
  [10835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6743),
  [10837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6739),
  [10839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_noexcept, 4, 0, 0),
  [10841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_noexcept, 4, 0, 0),
  [10843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6697),
  [10845] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [10847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_end, 3, 0, 0),
  [10849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_end, 3, 0, 0),
  [10851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6955),
  [10853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_noexcept, 1, 0, 0),
  [10855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_noexcept, 1, 0, 0),
  [10857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [10859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_specifier, 3, 0, 0),
  [10861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_specifier, 3, 0, 0),
  [10863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6937),
  [10865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6674),
  [10867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_noexcept, 3, 0, 0),
  [10869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_noexcept, 3, 0, 0),
  [10871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6856),
  [10873] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(9931),
  [10876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2849),
  [10878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10309),
  [10880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6734),
  [10882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9202),
  [10884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4168),
  [10886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6559),
  [10888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6565),
  [10890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6889),
  [10892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6890),
  [10894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6893),
  [10896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6660),
  [10898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6774),
  [10900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9759),
  [10902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6775),
  [10904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6775),
  [10906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6949),
  [10908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8993),
  [10910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6892),
  [10912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6931),
  [10914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6891),
  [10916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6794),
  [10918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6878),
  [10920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6876),
  [10922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6865),
  [10924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6863),
  [10926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_unary_expression, 2, 0, 4),
  [10928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_unary_expression, 2, 0, 4),
  [10930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_defined, 2, 0, 0),
  [10932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_defined, 2, 0, 0),
  [10934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2200),
  [10936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3603),
  [10938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10904),
  [10940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6765),
  [10942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9150),
  [10944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4202),
  [10946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6874),
  [10948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6922),
  [10950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6907),
  [10952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6944),
  [10954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6964),
  [10956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3548),
  [10958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6778),
  [10960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9019),
  [10962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6921),
  [10964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6758),
  [10966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23),
  [10968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 6, 0, 23),
  [10970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6953),
  [10972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3121),
  [10974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10574),
  [10976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6786),
  [10978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9318),
  [10980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3942),
  [10982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 4, 0, 0),
  [10984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 4, 0, 0),
  [10986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6930),
  [10988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6904),
  [10990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_binary_expression, 3, 0, 55),
  [10992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_binary_expression, 3, 0, 55),
  [10994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2870),
  [10996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6796),
  [10998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9111),
  [11000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6960),
  [11002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6908),
  [11004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6928),
  [11006] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(6537),
  [11009] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(4027),
  [11012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 2, 0, 0),
  [11014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 2, 0, 0),
  [11016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [11018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6962),
  [11020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6957),
  [11022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6958),
  [11024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6918),
  [11026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2942),
  [11028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6821),
  [11030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9510),
  [11032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6925),
  [11034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6945),
  [11036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6897),
  [11038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2905),
  [11040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9437),
  [11042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2988),
  [11044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9606),
  [11046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_defined, 4, 0, 0),
  [11048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_defined, 4, 0, 0),
  [11050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6939),
  [11052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6929),
  [11054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6923),
  [11056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1379),
  [11058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6837),
  [11060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9122),
  [11062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6920),
  [11064] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(7165),
  [11067] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(6527),
  [11070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(4232),
  [11073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6912),
  [11075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3525),
  [11077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6851),
  [11079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9059),
  [11081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4012),
  [11083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 3, 0, 0),
  [11085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 3, 0, 0),
  [11087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_parenthesized_expression, 3, 0, 0),
  [11089] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_parenthesized_expression, 3, 0, 0),
  [11091] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(7145),
  [11094] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(6562),
  [11097] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(3876),
  [11100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2869),
  [11102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10789),
  [11104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6860),
  [11106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9384),
  [11108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4137),
  [11110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1375),
  [11112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6867),
  [11114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9435),
  [11116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_argument_list_repeat1, 2, 0, 0),
  [11118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3757),
  [11120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6879),
  [11122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9303),
  [11124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [11126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6916),
  [11128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6900),
  [11130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call_expression, 2, 0, 7),
  [11132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call_expression, 2, 0, 7),
  [11134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6580),
  [11136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6845),
  [11138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6840),
  [11140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6826),
  [11142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6819),
  [11144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6818),
  [11146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [11148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6768),
  [11150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6834),
  [11152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6833),
  [11154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6832),
  [11156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6827),
  [11158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8801),
  [11160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6901),
  [11162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9397),
  [11164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [11166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [11168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8050),
  [11170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6969),
  [11172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7894),
  [11174] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(3768),
  [11177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [11179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7323),
  [11181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6857),
  [11183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7419),
  [11185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9231),
  [11187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7904),
  [11189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7901),
  [11191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [11193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [11195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8092),
  [11197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7654),
  [11199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8064),
  [11201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7337),
  [11203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8230),
  [11205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9380),
  [11207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [11209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6579),
  [11211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [11213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [11215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [11217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [11219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1202),
  [11221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8082),
  [11223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__function_postfix_repeat1, 2, 0, 0),
  [11225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__function_postfix_repeat1, 2, 0, 0),
  [11227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__function_postfix_repeat1, 2, 0, 0), SHIFT_REPEAT(7165),
  [11230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_postfix, 1, 0, 0),
  [11232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_postfix, 1, 0, 0),
  [11234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8127),
  [11236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7384),
  [11238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8560),
  [11240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_requirements, 2, 0, 0),
  [11242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_requirements, 2, 0, 0),
  [11244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10191),
  [11246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10219),
  [11248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_postfix_repeat1, 2, 0, 0), SHIFT_REPEAT(7145),
  [11251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7441),
  [11253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7412),
  [11255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(4009),
  [11258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_requirements, 3, 0, 0),
  [11260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_requirements, 3, 0, 0),
  [11262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(6537),
  [11265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(4027),
  [11268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interface_requirements_repeat1, 2, 0, 0),
  [11270] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_requirements_repeat1, 2, 0, 0), SHIFT_REPEAT(10219),
  [11273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_interface_requirements_repeat1, 2, 0, 0),
  [11275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7361),
  [11277] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_requirements_repeat1, 2, 0, 0), SHIFT_REPEAT(10191),
  [11280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, 0, 79),
  [11282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1411),
  [11284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [11286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, 0, 62),
  [11288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3850),
  [11290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 2, 0, 0),
  [11292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10544),
  [11294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_where_clause, 2, 0, 0),
  [11296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4146),
  [11298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [11300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7624),
  [11302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 1, 0, 0),
  [11304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [11306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7049),
  [11308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8939),
  [11310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9951),
  [11312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6568),
  [11314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6569),
  [11316] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7022),
  [11319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8939),
  [11322] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(9951),
  [11325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [11327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [11329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6587),
  [11331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 3, 1, 41),
  [11333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 4, 0, 128),
  [11335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_reference_declarator, 2, 0, 0),
  [11337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 2, 1, 5),
  [11339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [11341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 4, 1, 83),
  [11343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [11345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7022),
  [11347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [11349] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(6538),
  [11352] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(3986),
  [11355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(7165),
  [11358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(6585),
  [11361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(4221),
  [11364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [11366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3991),
  [11368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10101),
  [11370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4225),
  [11372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6593),
  [11374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [11376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, 0, 39),
  [11378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [11380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2631),
  [11382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2659),
  [11384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4871),
  [11386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5043),
  [11388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, 0, 115),
  [11390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 4, 0, 115),
  [11392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [11394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [11396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1397),
  [11398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [11400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9789),
  [11402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2990),
  [11404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3124),
  [11406] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(6547),
  [11409] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(4205),
  [11412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3340),
  [11414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3403),
  [11416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 5, 0, 168),
  [11418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 5, 0, 168),
  [11420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5165),
  [11422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2964),
  [11424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4857),
  [11426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5012),
  [11428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, 0, 26),
  [11430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 4, 0, 26),
  [11432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_parenthesized_declarator, 3, 0, 0),
  [11434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_parenthesized_declarator, 3, 0, 0),
  [11436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [11438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(977),
  [11440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 6, 0, 0),
  [11442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 5, 0, 0),
  [11444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0),
  [11446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3991),
  [11449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 4, 0, 0),
  [11451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 3, 0, 0),
  [11453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [11455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [11457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10057),
  [11459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3180),
  [11461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3262),
  [11463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [11465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [11467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9729),
  [11469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3939),
  [11471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3756),
  [11473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10410),
  [11476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7581),
  [11478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8545),
  [11480] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(10101),
  [11483] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3937),
  [11486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5219),
  [11488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5711),
  [11490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, 0, 23),
  [11492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 7, 0, 23),
  [11494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, 0, 23), SHIFT(3876),
  [11497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, 0, 170),
  [11499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 4, 0, 170),
  [11501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_parenthesized_declarator, 4, 0, 0),
  [11503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_parenthesized_declarator, 4, 0, 0),
  [11505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__abstract_declarator, 1, 0, 0),
  [11507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__abstract_declarator, 1, 0, 0),
  [11509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5228),
  [11511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5718),
  [11513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_function_declarator, 1, 0, 33),
  [11515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_function_declarator, 1, 0, 33),
  [11517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [11519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [11521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [11523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trailing_return_type, 2, 0, 0),
  [11525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trailing_return_type, 2, 0, 0),
  [11527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_virtual_specifier, 1, 0, 0),
  [11529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_virtual_specifier, 1, 0, 0),
  [11531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_where_clause_repeat1, 4, 0, 0),
  [11533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 4, 0, 0),
  [11535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2577),
  [11537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [11539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9724),
  [11541] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(4009),
  [11544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(10544),
  [11547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0),
  [11549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4162),
  [11552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4673),
  [11554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4743),
  [11556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [11558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [11560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [11562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_where_clause_repeat1, 5, 0, 0),
  [11564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 5, 0, 0),
  [11566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 8, 0, 23),
  [11568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 8, 0, 23),
  [11570] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(6564),
  [11573] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(3953),
  [11576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 3, 0, 26),
  [11578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, 0, 26),
  [11580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4164),
  [11582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4044),
  [11584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 2, 0, 0),
  [11586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 2, 0, 0),
  [11588] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, 0, 23), SHIFT(4232),
  [11591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_where_clause, 6, 0, 0),
  [11593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_where_clause, 5, 0, 0),
  [11595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__class_declaration_repeat1, 2, 0, 0),
  [11597] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__class_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(10202),
  [11600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__class_declaration_repeat1, 2, 0, 0),
  [11602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__class_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(10500),
  [11605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4144),
  [11607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3831),
  [11609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_function_declarator, 2, 0, 24),
  [11611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_function_declarator, 2, 0, 24),
  [11613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [11615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [11617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [11619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 3, 0, 0),
  [11621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, 0, 0),
  [11623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 3, 0, 120),
  [11625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, 0, 120),
  [11627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_where_clause, 3, 0, 0),
  [11629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4147),
  [11631] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3850),
  [11634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_where_clause, 4, 0, 0),
  [11636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3863),
  [11638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2975),
  [11640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3058),
  [11642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6016),
  [11644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6140),
  [11646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(4132),
  [11649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [11651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [11653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3233),
  [11655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3366),
  [11657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3744),
  [11659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4384),
  [11661] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(7165),
  [11664] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(6585),
  [11667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(4221),
  [11670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 5, 1, 166),
  [11672] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3845),
  [11675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 3, 1, 41),
  [11677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 2, 1, 5),
  [11679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, 0, 23), SHIFT(3768),
  [11682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4007),
  [11684] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(4058),
  [11687] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(6538),
  [11690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(3986),
  [11693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_declarator, 2, 1, 0),
  [11695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 5),
  [11697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [11699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 3, 0, 0),
  [11701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_where_clause_repeat1, 3, 0, 0),
  [11703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 3, 0, 0), SHIFT_REPEAT(4163),
  [11706] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4144),
  [11709] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 3, 0, 0), SHIFT_REPEAT(3921),
  [11712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8143),
  [11714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8504),
  [11716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8567),
  [11718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6780),
  [11720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10777),
  [11722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 4, 1, 83),
  [11724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3837),
  [11726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 3, 0, 77),
  [11728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4002),
  [11730] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(6581),
  [11733] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(4194),
  [11736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3194),
  [11738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7559),
  [11740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8543),
  [11742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 2, 0, 10),
  [11744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8496),
  [11746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4210),
  [11748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7562),
  [11750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8565),
  [11752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7537),
  [11754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8572),
  [11756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4033),
  [11758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4209),
  [11760] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4164),
  [11763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7590),
  [11765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7702),
  [11767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7703),
  [11769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7696),
  [11771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7686),
  [11773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7561),
  [11775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [11777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9532),
  [11779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8688),
  [11781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2273),
  [11783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [11785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [11787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2510),
  [11789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9482),
  [11791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8683),
  [11793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7673),
  [11795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7682),
  [11797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7655),
  [11799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7651),
  [11801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1405),
  [11803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7629),
  [11805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7597),
  [11807] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(4132),
  [11810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [11812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9042),
  [11814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8920),
  [11816] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, 0, 23), SHIFT(4027),
  [11819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7664),
  [11821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3999),
  [11823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7600),
  [11825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_field_declarator, 2, 1, 0),
  [11827] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 3, 0, 0), SHIFT_REPEAT(3865),
  [11830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 2, 1, 5),
  [11832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6529),
  [11834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6529),
  [11836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7496),
  [11838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [11840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7606),
  [11842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [11844] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(6547),
  [11847] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(4205),
  [11850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7627),
  [11852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [11854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9028),
  [11856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8613),
  [11858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [11860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7643),
  [11862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 4, 1, 83),
  [11864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7589),
  [11866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7635),
  [11868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7650),
  [11870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6528),
  [11872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6528),
  [11874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7669),
  [11876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7671),
  [11878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7674),
  [11880] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(6564),
  [11883] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(3953),
  [11886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [11888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [11890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9265),
  [11892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8648),
  [11894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7633),
  [11896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 3, 1, 41),
  [11898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 5, 1, 166),
  [11900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [11902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [11904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9553),
  [11906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8731),
  [11908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3907),
  [11910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3880),
  [11912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7705),
  [11914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [11916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [11918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9127),
  [11920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8630),
  [11922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [11924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10469),
  [11926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9013),
  [11928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6745),
  [11930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10089),
  [11932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5746),
  [11934] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0), SHIFT(6914),
  [11937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10627),
  [11939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8535),
  [11941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7482),
  [11943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8566),
  [11945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5706),
  [11947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4757),
  [11949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6561),
  [11951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6560),
  [11953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6550),
  [11955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6553),
  [11957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4739),
  [11959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10781),
  [11961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2916),
  [11963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3093),
  [11965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3494),
  [11967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8328),
  [11969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3069),
  [11971] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(4058),
  [11974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3563),
  [11976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10100),
  [11978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [11980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3537),
  [11982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3834),
  [11984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3844),
  [11986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [11988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2768),
  [11990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3871),
  [11992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3847),
  [11994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2919),
  [11996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3179),
  [11998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [12000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5799),
  [12002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3992),
  [12004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4041),
  [12006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [12008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5806),
  [12010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10920),
  [12012] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(6581),
  [12015] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(4194),
  [12018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3820),
  [12020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2772),
  [12022] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4219),
  [12025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10745),
  [12027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_declarator, 2, 0, 0),
  [12029] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_declarator, 2, 0, 0),
  [12031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3716),
  [12033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4989),
  [12035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3753),
  [12037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4974),
  [12039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3883),
  [12041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3752),
  [12043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3474),
  [12045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10195),
  [12047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 2, 0, 66),
  [12049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10221),
  [12051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2457),
  [12053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4072),
  [12055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4172),
  [12057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [12059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3882),
  [12061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3944),
  [12063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3909),
  [12065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4236),
  [12067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4120),
  [12069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4213),
  [12071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4231),
  [12073] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, 0, 23), SHIFT(4009),
  [12076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_field_declarator, 2, 0, 0),
  [12078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_field_declarator, 2, 0, 0),
  [12080] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(9889),
  [12083] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3816),
  [12086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declarator, 2, 1, 24),
  [12088] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_declarator, 2, 1, 24), SHIFT(10221),
  [12091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declarator, 2, 1, 24),
  [12093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6542),
  [12095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6542),
  [12097] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3871),
  [12100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3918),
  [12102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4117),
  [12104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3886),
  [12106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4019),
  [12108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3823),
  [12110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [12112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4203),
  [12114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4102),
  [12116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7185),
  [12118] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4033),
  [12121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4039),
  [12123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4136),
  [12125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3940),
  [12127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6543),
  [12129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6543),
  [12131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 2, 0, 39),
  [12133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [12135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4281),
  [12137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 2, 1, 5),
  [12139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_reference_declarator, 2, 0, 0),
  [12141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 3, 0, 79),
  [12143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 3, 0, 62),
  [12145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 3, 1, 41),
  [12147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 4, 0, 128),
  [12149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 4, 1, 83),
  [12151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4187),
  [12154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declarator, 1, 0, 0),
  [12156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [12158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declarator, 1, 0, 0),
  [12160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declarator, 1, 0, 99),
  [12162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declarator, 1, 0, 99),
  [12164] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3834),
  [12167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4139),
  [12169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7958),
  [12171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8228),
  [12173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8105),
  [12175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4106),
  [12177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structured_binding_declarator, 3, -1, 0),
  [12179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_structured_binding_declarator, 3, -1, 0),
  [12181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 4, 0, 26),
  [12183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 4, 0, 26),
  [12185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 4, 0, 115),
  [12187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 4, 0, 115),
  [12189] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9013),
  [12192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6790),
  [12195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10733),
  [12198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10060),
  [12201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0),
  [12203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declarator, 3, 1, 24),
  [12205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declarator, 3, 1, 24),
  [12207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4115),
  [12209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8157),
  [12211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8083),
  [12213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3866),
  [12216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, 0, 5),
  [12218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [12220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structured_binding_declarator, 4, -1, 0),
  [12222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_structured_binding_declarator, 4, -1, 0),
  [12224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_field_declarator, 4, -10, 0),
  [12226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_field_declarator, 4, -10, 0),
  [12228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4113),
  [12230] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 7, 0, 23), SHIFT(4221),
  [12233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3911),
  [12235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8178),
  [12237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8114),
  [12239] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 3, 0, 0), SHIFT_REPEAT(4141),
  [12242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7985),
  [12244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_field_declarator, 2, 1, 24),
  [12246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_field_declarator, 2, 1, 24),
  [12248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 5, 0, 168),
  [12250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 5, 0, 168),
  [12252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 3, 0, 26),
  [12254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 3, 0, 26),
  [12256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4088),
  [12258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8368),
  [12260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8767),
  [12262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6805),
  [12264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10295),
  [12266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 3, 0, 10),
  [12268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 3, 0, 26),
  [12270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 3, 0, 26),
  [12272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4136),
  [12275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 4, 0, 26),
  [12277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 4, 0, 26),
  [12279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_field_declarator, 3, -10, 0),
  [12281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_field_declarator, 3, -10, 0),
  [12283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8217),
  [12285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8116),
  [12287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8152),
  [12289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8047),
  [12291] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3907),
  [12294] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, 0, 23), SHIFT(3986),
  [12297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 4, 0, 115),
  [12299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 4, 0, 115),
  [12301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 5, 0, 168),
  [12303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 5, 0, 168),
  [12305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8186),
  [12307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8112),
  [12309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 3, 0, 10),
  [12311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8723),
  [12313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6798),
  [12315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10286),
  [12317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4040),
  [12319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4080),
  [12321] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 3, 0, 0), SHIFT_REPEAT(3802),
  [12324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8005),
  [12326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10289),
  [12328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 2, 0, 10),
  [12330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_semantics, 2, 0, 0),
  [12332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_semantics, 2, 0, 0),
  [12334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8207),
  [12336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8134),
  [12338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8000),
  [12340] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 3, 0, 0), SHIFT_REPEAT(4220),
  [12343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8485),
  [12345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_declarator, 3, -10, 0),
  [12347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_declarator, 3, -10, 0),
  [12349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_declarator, 4, -10, 0),
  [12351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_declarator, 4, -10, 0),
  [12353] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3943),
  [12356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3910),
  [12358] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3886),
  [12361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 3, 0, 77),
  [12363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4013),
  [12365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3924),
  [12367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8440),
  [12369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8401),
  [12371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10096),
  [12373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 4, 0, 77),
  [12375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3890),
  [12377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 4, 0, 77),
  [12379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__scope_resolution, 1, 0, 0),
  [12381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scope_resolution, 1, 0, 0),
  [12383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2056),
  [12385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5740),
  [12387] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3992),
  [12390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4070),
  [12392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1992),
  [12394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2556),
  [12396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_hint, 2, 0, 0),
  [12398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2122),
  [12400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5747),
  [12402] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3918),
  [12405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4084),
  [12407] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3944),
  [12410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2355),
  [12412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5727),
  [12414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2542),
  [12416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5719),
  [12418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3912),
  [12420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2222),
  [12422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5713),
  [12424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3964),
  [12426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3769),
  [12428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 1, 0, 0),
  [12430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10448),
  [12432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 3, 0, 0), SHIFT_REPEAT(3888),
  [12435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2372),
  [12437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5650),
  [12439] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, 0, 23), SHIFT(4205),
  [12442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6967),
  [12444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_declarators, 1, 0, 26),
  [12446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4161),
  [12448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1965),
  [12450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5739),
  [12452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3508),
  [12454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8106),
  [12456] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, 0, 23), SHIFT(4132),
  [12459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4038),
  [12461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4105),
  [12463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3971),
  [12465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1961),
  [12467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5754),
  [12469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2272),
  [12471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5645),
  [12473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4110),
  [12475] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4236),
  [12478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2213),
  [12480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2419),
  [12482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 1, 0, 0),
  [12484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10226),
  [12486] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, 0, 23), SHIFT(3953),
  [12489] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 3, 0, 0), SHIFT_REPEAT(3945),
  [12492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2100),
  [12494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4285),
  [12496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9706),
  [12498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5202),
  [12500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9719),
  [12502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9365),
  [12504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8771),
  [12506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10657),
  [12508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9253),
  [12510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10549),
  [12512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5634),
  [12514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9672),
  [12516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8732),
  [12518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4203),
  [12521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(235),
  [12523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9773),
  [12525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9556),
  [12527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10762),
  [12529] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, 0, 23), SHIFT(4058),
  [12532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7433),
  [12534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10042),
  [12536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7644),
  [12538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4156),
  [12540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4130),
  [12542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5529),
  [12544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9873),
  [12546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3874),
  [12548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2937),
  [12550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9983),
  [12552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5742),
  [12554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9916),
  [12556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3348),
  [12558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9820),
  [12560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9428),
  [12562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8593),
  [12564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10330),
  [12566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8995),
  [12568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9288),
  [12570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1200),
  [12572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9970),
  [12574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8697),
  [12576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 7, 0, 23), SHIFT(4194),
  [12579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2752),
  [12581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9779),
  [12583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9470),
  [12585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2798),
  [12587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9829),
  [12589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9427),
  [12591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10298),
  [12593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [12595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9808),
  [12597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4023),
  [12599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4735),
  [12601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9917),
  [12603] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4072),
  [12606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [12608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8656),
  [12610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3482),
  [12612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9772),
  [12614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3239),
  [12616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9914),
  [12618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8845),
  [12620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4585),
  [12622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9875),
  [12624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8653),
  [12626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3407),
  [12628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10068),
  [12630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8805),
  [12632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [12634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9669),
  [12636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2595),
  [12638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10005),
  [12640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5008),
  [12642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 5),
  [12644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8824),
  [12646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8865),
  [12648] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4208),
  [12651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4824),
  [12653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8812),
  [12655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8836),
  [12657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8730),
  [12659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4126),
  [12661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [12663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [12665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 1, 0, 6),
  [12667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator, 1, 0, 6),
  [12669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [12671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [12673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4024),
  [12675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3788),
  [12677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4212),
  [12679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3995),
  [12681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2426),
  [12683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3941),
  [12685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__scope_resolution, 2, 0, 15),
  [12687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scope_resolution, 2, 0, 15),
  [12689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [12691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4079),
  [12693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [12695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4064),
  [12697] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4105),
  [12700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7866),
  [12702] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2, 0, 0), SHIFT_REPEAT(8143),
  [12705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2, 0, 0),
  [12707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2, 0, 0),
  [12709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7884),
  [12711] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9013),
  [12714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2, 0, 0),
  [12716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2, 0, 0),
  [12718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__scope_resolution, 2, 0, 31),
  [12720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scope_resolution, 2, 0, 31),
  [12722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [12724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4176),
  [12726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7815),
  [12728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7755),
  [12730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [12732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3873),
  [12734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4140),
  [12736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4095),
  [12738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3784),
  [12740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4237),
  [12742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3965),
  [12744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4062),
  [12746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [12748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4234),
  [12750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [12752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4036),
  [12754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [12756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [12758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3858),
  [12760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast, 3, 0, 58),
  [12762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [12764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4229),
  [12766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [12768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [12770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3952),
  [12772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [12774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9949),
  [12776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3927),
  [12778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2863),
  [12780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 1, 0, 0),
  [12782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8376),
  [12784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 1, 0, 0),
  [12786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4238),
  [12788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9001),
  [12790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 5, 0, 0),
  [12792] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 5, 0, 0),
  [12794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4046),
  [12796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [12798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4020),
  [12800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [12802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9593),
  [12804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3779),
  [12806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [12808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4098),
  [12810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [12812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4094),
  [12814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3862),
  [12816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7947),
  [12818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3796),
  [12820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4051),
  [12822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2845),
  [12824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [12826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [12828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10083),
  [12830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4247),
  [12832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3770),
  [12834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4526),
  [12836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3920),
  [12838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [12840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3914),
  [12842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2826),
  [12844] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4024),
  [12847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4175),
  [12849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [12851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4061),
  [12853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [12855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4018),
  [12857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5029),
  [12859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4076),
  [12861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [12863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4090),
  [12865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4045),
  [12867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2789),
  [12869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 6, 0, 0),
  [12871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 6, 0, 0),
  [12873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7802),
  [12875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4104),
  [12877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [12879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4154),
  [12881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2640),
  [12883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8943),
  [12885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4127),
  [12887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3176),
  [12889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4109),
  [12891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3433),
  [12893] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 3, 0, 0), SHIFT_REPEAT(4198),
  [12896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3891),
  [12898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3771),
  [12900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [12902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3868),
  [12904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3673),
  [12906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4174),
  [12908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [12910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3795),
  [12912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [12914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3824),
  [12916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3878),
  [12918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4042),
  [12920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4021),
  [12922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4191),
  [12924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3887),
  [12926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4476),
  [12928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7716),
  [12930] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2, 0, 0), SHIFT_REPEAT(2253),
  [12933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2, 0, 0),
  [12935] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2, 0, 0), SHIFT_REPEAT(10083),
  [12938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3930),
  [12940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3966),
  [12942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [12944] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3825),
  [12947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4204),
  [12949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [12951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 4, 0, 0),
  [12953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 4, 0, 0),
  [12955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4065),
  [12957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9117),
  [12959] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3964),
  [12962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3130),
  [12964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3140),
  [12966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7340),
  [12968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8859),
  [12970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [12972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [12974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [12976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2378),
  [12978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 10),
  [12980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 10),
  [12982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [12984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9501),
  [12986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9502),
  [12988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [12990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [12992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [12994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [12996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [12998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4143),
  [13000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 6, 0, 175),
  [13002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 6, 0, 175),
  [13004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [13006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [13008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [13010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [13012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2368),
  [13014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7307),
  [13016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [13018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [13020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_subscript_declaration_repeat1, 2, 0, 0),
  [13022] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subscript_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(9501),
  [13025] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subscript_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(9502),
  [13028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7328),
  [13030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [13032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [13034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [13036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [13038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4043),
  [13040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7245),
  [13042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7327),
  [13044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [13046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [13048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [13050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [13052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [13054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2580),
  [13056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 77),
  [13058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 77),
  [13060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2502),
  [13062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2880),
  [13064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type_parameter_declaration, 4, 0, 195),
  [13066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5957),
  [13068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [13070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [13072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [13074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [13076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [13078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [13080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2458),
  [13082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10688),
  [13084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [13086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [13088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_expression_repeat1, 2, 0, 0),
  [13090] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(8859),
  [13093] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4212),
  [13096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [13098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [13100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [13102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [13104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [13106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2414),
  [13108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4500),
  [13110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [13112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [13114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [13116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 78),
  [13118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 78),
  [13120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [13122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [13124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [13126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [13128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [13130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7300),
  [13132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 4, 0, 77),
  [13134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 4, 0, 77),
  [13136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [13138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [13140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type_parameter_declaration, 3, 0, 156),
  [13142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [13144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2450),
  [13146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [13148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [13150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [13152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2655),
  [13154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7289),
  [13156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [13158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [13160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [13162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3671),
  [13164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2495),
  [13166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [13168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [13170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [13172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7330),
  [13174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [13176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3453),
  [13178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [13180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [13182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [13184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [13186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 3, 0),
  [13188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4128),
  [13190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7329),
  [13192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2145),
  [13194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7261),
  [13196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [13198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2834),
  [13200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [13202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7957),
  [13204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [13206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [13208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [13210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3178),
  [13212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2295),
  [13214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2304),
  [13216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4197),
  [13218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 3, 0, 10),
  [13220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 3, 0, 10),
  [13222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2469),
  [13224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2604),
  [13226] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4140),
  [13229] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4156),
  [13232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [13234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5048),
  [13236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4082),
  [13238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [13240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [13242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2247),
  [13244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2475),
  [13246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2829),
  [13248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7305),
  [13250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 5, 0, 126),
  [13252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 5, 0, 126),
  [13254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7346),
  [13256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4223),
  [13258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [13260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [13262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [13264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [13266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0),
  [13268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [13270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [13272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7335),
  [13274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [13276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2793),
  [13278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7262),
  [13280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 125),
  [13282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 125),
  [13284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 3, 0, 0), SHIFT_REPEAT(3829),
  [13287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [13289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4516),
  [13291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [13293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8760),
  [13295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6991),
  [13297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 4, 0, 0),
  [13299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [13301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [13303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9877),
  [13305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9281),
  [13307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [13309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [13311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 3, 4, 0),
  [13313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2225),
  [13315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [13317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8654),
  [13319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 2, 0, 0),
  [13321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [13323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8553),
  [13325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8790),
  [13327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 3, 0, 0),
  [13329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [13331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9682),
  [13333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7127),
  [13335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9958),
  [13337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [13339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7235),
  [13341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [13343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [13345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3879),
  [13347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2563),
  [13349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9543),
  [13351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [13353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1941),
  [13355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2201),
  [13357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [13359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9749),
  [13361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [13363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [13365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_access_specifier, 1, 0, 0),
  [13367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_access_specifier, 1, 0, 0),
  [13369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [13371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [13373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [13375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [13377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [13379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4263),
  [13381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9823),
  [13383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10021),
  [13385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list, 1, 0, 0),
  [13387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [13389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [13391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [13393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [13395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7101),
  [13397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2175),
  [13399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [13401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10003),
  [13403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [13405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9977),
  [13407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [13409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7151),
  [13411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2150),
  [13413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [13415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [13417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2578),
  [13419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [13421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [13423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [13425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3965),
  [13428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8692),
  [13430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 5, 0, 0),
  [13432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [13434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3784),
  [13437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [13439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4131),
  [13441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [13443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [13445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, 0, 6),
  [13447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10086),
  [13449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [13451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8216),
  [13453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 2, 0, 152),
  [13455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10012),
  [13457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10013),
  [13459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4037),
  [13461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [13463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2395),
  [13465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [13467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 113), SHIFT_REPEAT(6967),
  [13470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 113),
  [13472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2786),
  [13474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8634),
  [13476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8634),
  [13478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4151),
  [13480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [13482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [13484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9935),
  [13486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [13488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [13490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9373),
  [13492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10872),
  [13494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6943),
  [13496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8638),
  [13498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3337),
  [13500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8627),
  [13502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8627),
  [13504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [13506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [13508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10819),
  [13510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8639),
  [13512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8639),
  [13514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3362),
  [13516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6772),
  [13518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2808),
  [13520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [13522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [13524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [13526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [13528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3781),
  [13530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [13532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_char_literal_repeat1, 2, 0, 0),
  [13534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_char_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(8638),
  [13537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0),
  [13539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(8639),
  [13542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(8639),
  [13545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2500),
  [13547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [13549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [13551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9971),
  [13553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9708),
  [13555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2449),
  [13557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [13559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [13561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [13563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [13565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4595),
  [13567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3221),
  [13569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8668),
  [13571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8668),
  [13573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4376),
  [13575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8851),
  [13577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8851),
  [13579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3973),
  [13581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, 0, 227), SHIFT_REPEAT(7276),
  [13584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, 0, 227),
  [13586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [13588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [13590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4600),
  [13592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8658),
  [13594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8658),
  [13596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_operator_cast_identifier, 2, 0, 34),
  [13598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3232),
  [13600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7276),
  [13602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 2, 0, 213),
  [13604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [13606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 6, 0, 0),
  [13608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_hinted_declarator, 2, 0, 0),
  [13610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4224),
  [13612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [13614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3774),
  [13616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [13618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9491),
  [13620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 4, 0, 0),
  [13622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2493),
  [13624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [13626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [13628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4142),
  [13630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [13632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [13634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [13636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8224),
  [13638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 3, 0, 192),
  [13640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3417),
  [13642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8714),
  [13644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8714),
  [13646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [13648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 2, 0, 152),
  [13650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2473),
  [13652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4670),
  [13654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8708),
  [13656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8708),
  [13658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [13660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [13662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10779),
  [13664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [13666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2853),
  [13668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4048),
  [13670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2840),
  [13672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4653),
  [13674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 3, 0, 192),
  [13676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5568),
  [13678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3432),
  [13680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4087),
  [13682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7929),
  [13684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 3, 0, 222),
  [13686] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, 0, 212), SHIFT_REPEAT(8224),
  [13689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, 0, 212),
  [13691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [13693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7940),
  [13695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3002),
  [13697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list_no_comma, 1, 0, 0),
  [13699] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 184), SHIFT_REPEAT(7061),
  [13702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 184),
  [13704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4158),
  [13706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [13708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [13710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3024),
  [13712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3227),
  [13714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8742),
  [13716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8742),
  [13718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3027),
  [13720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4200),
  [13722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3201),
  [13724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3848),
  [13726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3947),
  [13728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [13730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 7, 0, 0),
  [13732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9604),
  [13734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 5, 0, 0),
  [13736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3915),
  [13738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4512),
  [13740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2987),
  [13742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3323),
  [13744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2478),
  [13746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4506),
  [13748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9432),
  [13750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 3, 0, 0),
  [13752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3477),
  [13754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [13756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [13758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [13760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10168),
  [13762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3226),
  [13764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8809),
  [13766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8809),
  [13768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3172),
  [13770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8785),
  [13772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8785),
  [13774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4572),
  [13776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8772),
  [13778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8772),
  [13780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9898),
  [13782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9804),
  [13784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10916),
  [13786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8625),
  [13788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8625),
  [13790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4578),
  [13792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [13794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10704),
  [13796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2544),
  [13798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [13800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10328),
  [13802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3266),
  [13804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8754),
  [13806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8754),
  [13808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list_no_comma, 2, 0, 0),
  [13810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3946),
  [13812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2823),
  [13814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9649),
  [13816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9943),
  [13818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4581),
  [13820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [13822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2819),
  [13824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3168),
  [13826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [13828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4053),
  [13830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [13832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4222),
  [13834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [13836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3164),
  [13838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8800),
  [13840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8800),
  [13842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4207),
  [13844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3158),
  [13846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1963),
  [13848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [13850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10337),
  [13852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4103),
  [13854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4028),
  [13856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5113),
  [13858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3198),
  [13860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2470),
  [13862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5010),
  [13864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__namespace_specifier, 1, 0, 19),
  [13866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8577),
  [13868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [13870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4000),
  [13872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [13874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3780),
  [13876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [13878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4964),
  [13880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [13882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [13884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [13886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8530),
  [13888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list, 2, 0, 0),
  [13890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2463),
  [13892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2878),
  [13894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3988),
  [13896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9786),
  [13898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9675),
  [13900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4099),
  [13902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2623),
  [13904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9492),
  [13906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 2, 0, 0),
  [13908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2468),
  [13910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2620),
  [13912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8558),
  [13914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2884),
  [13916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8844),
  [13918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8844),
  [13920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3036),
  [13922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4059),
  [13924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3554),
  [13926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4381),
  [13928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2867),
  [13930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [13932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [13934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3196),
  [13936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4097),
  [13938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3189),
  [13940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [13942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4284),
  [13944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4108),
  [13946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [13948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [13950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [13952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [13954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [13956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_qualifier, 1, 0, 0),
  [13958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4218),
  [13960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2795),
  [13962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [13964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [13966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2787),
  [13968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8579),
  [13970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4101),
  [13972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9542),
  [13974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_declarator, 1, 0, 0),
  [13976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4702),
  [13978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8876),
  [13980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8876),
  [13982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5323),
  [13984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4111),
  [13986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3470),
  [13988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4730),
  [13990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [13992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2456),
  [13994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3458),
  [13996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [13998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3819),
  [14000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [14002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [14004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [14006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3638),
  [14008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4122),
  [14010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9377),
  [14012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2441),
  [14014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [14016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4206),
  [14018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2643),
  [14020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2524),
  [14022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [14024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4169),
  [14026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3666),
  [14028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [14030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [14032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2660),
  [14034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [14036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3662),
  [14038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3041),
  [14040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8839),
  [14042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8839),
  [14044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7373),
  [14046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9936),
  [14048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10023),
  [14050] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, 0, 212), SHIFT_REPEAT(8216),
  [14053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, 0, 212),
  [14055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3902),
  [14057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3374),
  [14059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3936),
  [14061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2877),
  [14063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [14065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3387),
  [14067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8909),
  [14069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8909),
  [14071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [14073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_declarators, 2, 0, 86),
  [14075] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(6991),
  [14078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, 0, 90),
  [14080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4052),
  [14082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [14084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [14086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [14088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4934),
  [14090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [14092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10654),
  [14094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4145),
  [14096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [14098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [14100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [14102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3822),
  [14104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [14106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3934),
  [14108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4543),
  [14110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [14112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [14114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [14116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4555),
  [14118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [14120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7434),
  [14122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8904),
  [14124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8904),
  [14126] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6766),
  [14129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2621),
  [14131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4733),
  [14133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7015),
  [14135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [14137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [14139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [14141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [14143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [14145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [14147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [14149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [14151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [14153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4287),
  [14155] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1513),
  [14158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_parameter_list_repeat1, 2, 0, 0),
  [14160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [14162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4496),
  [14164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [14166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4507),
  [14168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4546),
  [14170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4562),
  [14172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4477),
  [14174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8874),
  [14176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4469),
  [14178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4456),
  [14180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [14182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [14184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [14186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7753),
  [14188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_designator, 2, 0, 94),
  [14190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [14192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10017),
  [14194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8343),
  [14196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [14198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [14200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [14202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8620),
  [14204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [14206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8843),
  [14208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6789),
  [14210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [14212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [14214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10043),
  [14216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [14218] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_lambda_capture_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2075),
  [14221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4711),
  [14223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9969),
  [14225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [14227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [14229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8923),
  [14231] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_structured_binding_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(10076),
  [14234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_structured_binding_declarator_repeat1, 2, 0, 0),
  [14236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1581),
  [14239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [14241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [14243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [14245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [14247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3731),
  [14249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8788),
  [14251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4403),
  [14253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8022),
  [14255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4244),
  [14257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7969),
  [14259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5659),
  [14261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand, 7, 0, 231),
  [14263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10649),
  [14265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10645),
  [14267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10644),
  [14269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [14271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4410),
  [14273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9691),
  [14275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(10043),
  [14278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_declaration_repeat1, 2, 0, 0),
  [14280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [14282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [14284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [14286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3968),
  [14288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10163),
  [14290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10174),
  [14292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10173),
  [14294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [14296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [14298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [14300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4722),
  [14302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8783),
  [14304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [14306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5661),
  [14308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 3, 0, 66),
  [14310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4720),
  [14312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5660),
  [14314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3689),
  [14316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9947),
  [14318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2875),
  [14320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4717),
  [14322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [14324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3656),
  [14326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2879),
  [14328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3657),
  [14330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2646),
  [14332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3253),
  [14334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3252),
  [14336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3659),
  [14338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [14340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3661),
  [14342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [14344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8282),
  [14346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [14348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [14350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2642),
  [14352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2302),
  [14354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [14356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2633),
  [14358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2662),
  [14360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3665),
  [14362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8759),
  [14364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2653),
  [14366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [14368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [14370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8330),
  [14372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3670),
  [14374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2652),
  [14376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7727),
  [14378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [14380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3230),
  [14382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9987),
  [14384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3672),
  [14386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4383),
  [14388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, 0, 152),
  [14390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4029),
  [14392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [14394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_range_designator, 5, 0, 204),
  [14396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [14398] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requires_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1552),
  [14401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_requires_parameter_list_repeat1, 2, 0, 0),
  [14403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [14405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [14407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_get, 2, 0, 0),
  [14409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2442),
  [14411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2443),
  [14413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3895),
  [14415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2487),
  [14417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [14419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2866),
  [14421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 4, 4, 0),
  [14423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [14425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10767),
  [14427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10766),
  [14429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10761),
  [14431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9928),
  [14433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9825),
  [14435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [14437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6909),
  [14439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3422),
  [14441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2649),
  [14443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_throw_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(4233),
  [14446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_throw_specifier_repeat1, 2, 0, 0),
  [14448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5673),
  [14450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [14452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3423),
  [14454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8713),
  [14456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8587),
  [14458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8421),
  [14460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [14462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3443),
  [14464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4359),
  [14466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3411),
  [14468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10287),
  [14470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3830),
  [14472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2545),
  [14474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9884),
  [14476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [14478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [14480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3465),
  [14482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4718),
  [14484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3456),
  [14486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4406),
  [14488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [14490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [14492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5657),
  [14494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3434),
  [14496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [14498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5656),
  [14500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [14502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [14504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter_declaration, 2, 0, 66),
  [14506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3174),
  [14508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [14510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2783),
  [14512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2806),
  [14514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2805),
  [14516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2802),
  [14518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [14520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [14522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [14524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2797),
  [14526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_reference_declarator, 2, 0, 0),
  [14528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3329),
  [14530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [14532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [14534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2796),
  [14536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3191),
  [14538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3762),
  [14540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9927),
  [14542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [14544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2794),
  [14546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3760),
  [14548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand, 7, 0, 231),
  [14550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [14552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [14554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [14556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [14558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [14560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [14562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2790),
  [14564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4870),
  [14566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 2, 0, 56),
  [14568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10834),
  [14570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 2, 0, 223),
  [14572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [14574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3998),
  [14576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2630),
  [14578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3187),
  [14580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9827),
  [14582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3898),
  [14584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7565),
  [14586] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1530),
  [14589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0),
  [14591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [14593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [14595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [14597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [14599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2628),
  [14601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [14603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [14605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5629),
  [14607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3192),
  [14609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4233),
  [14611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6617),
  [14613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [14615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10052),
  [14617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [14619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2608),
  [14621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3250),
  [14623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_namespace_specifier, 3, 0, 0),
  [14625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8531),
  [14627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9966),
  [14629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_type_parameter_declaration, 2, 0, 0),
  [14631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3794),
  [14633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [14635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6645),
  [14637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2864),
  [14639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [14641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4419),
  [14643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3259),
  [14645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9769),
  [14647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2619),
  [14649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3313),
  [14651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10837),
  [14653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10836),
  [14655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10835),
  [14657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9864),
  [14659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [14661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [14663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [14665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3312),
  [14667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4382),
  [14669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2622),
  [14671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4379),
  [14673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4565),
  [14675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [14677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 3, 0, 207),
  [14679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [14681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_namespace_specifier, 2, 0, 0),
  [14683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [14685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4420),
  [14687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2615),
  [14689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4362),
  [14691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4361),
  [14693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [14695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2841),
  [14697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4298),
  [14699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8632),
  [14701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [14703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4556),
  [14705] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, 0, 230), SHIFT_REPEAT(10834),
  [14708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, 0, 230),
  [14710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__namespace_specifier, 2, 0, 59),
  [14712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5031),
  [14714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4557),
  [14716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8226),
  [14718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4605),
  [14720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9919),
  [14722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5030),
  [14724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3207),
  [14726] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_initializer_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7510),
  [14729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_initializer_list_repeat1, 2, 0, 0),
  [14731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6631),
  [14733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [14735] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subscript_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1778),
  [14738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5021),
  [14740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [14742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [14744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [14746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [14748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3308),
  [14750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4630),
  [14752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2876),
  [14754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [14756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [14758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [14760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4483),
  [14762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4486),
  [14764] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1509),
  [14767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3310),
  [14769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 3, 0, 228),
  [14771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5017),
  [14773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [14775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [14777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [14779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4282),
  [14781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_params_repeat1, 2, 0, 0), SHIFT_REPEAT(9928),
  [14784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_params_repeat1, 2, 0, 0),
  [14786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4280),
  [14788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4272),
  [14790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 3, 0, 5),
  [14792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5077),
  [14794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5125),
  [14796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8821),
  [14798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [14800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [14802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [14804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5015),
  [14806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4256),
  [14808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4520),
  [14810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9407),
  [14812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9792),
  [14814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3177),
  [14816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3641),
  [14818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8388),
  [14820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8356),
  [14822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2852),
  [14824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4245),
  [14826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3223),
  [14828] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1255),
  [14831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 0, 0),
  [14833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3162),
  [14835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2810),
  [14837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2811),
  [14839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3159),
  [14841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2636),
  [14843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [14845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10651),
  [14847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9737),
  [14849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9048),
  [14851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [14853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [14855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2838),
  [14857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4264),
  [14859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [14861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10185),
  [14863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4401),
  [14865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4611),
  [14867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9938),
  [14869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10019),
  [14871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2817),
  [14873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4609),
  [14875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2820),
  [14877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [14879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4365),
  [14881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2827),
  [14883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2854),
  [14885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [14887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2828),
  [14889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4364),
  [14891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [14893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3237),
  [14895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [14897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8013),
  [14899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [14901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [14903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [14905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3903),
  [14907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2775),
  [14909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8484),
  [14911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [14913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2874),
  [14915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10400),
  [14917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [14919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4497),
  [14921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4498),
  [14923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [14925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_statement_repeat1, 2, 0, 0),
  [14927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10185),
  [14930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3235),
  [14932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [14934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [14936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [14938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [14940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4426),
  [14942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [14944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9821),
  [14946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9785),
  [14948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9659),
  [14950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [14952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, 0, 213),
  [14954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [14956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9658),
  [14958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9655),
  [14960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand, 4, 0, 221),
  [14962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9781),
  [14964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5537),
  [14966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [14968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2297),
  [14970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [14972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10780),
  [14974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10746),
  [14976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10783),
  [14978] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(4155),
  [14981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 2, 0, 0),
  [14983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4501),
  [14985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9645),
  [14987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9644),
  [14989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4503),
  [14991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [14993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [14995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5649),
  [14997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9119),
  [14999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9611),
  [15001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4511),
  [15003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [15005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4470),
  [15007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4515),
  [15009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_subscript_declaration_repeat1, 1, 0, 0),
  [15011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4471),
  [15013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [15015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5639),
  [15017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [15019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9710),
  [15021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [15023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8841),
  [15025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4517),
  [15027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8807),
  [15029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [15031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9742),
  [15033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4325),
  [15035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [15037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [15039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9697),
  [15041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [15043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9701),
  [15045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [15047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10230),
  [15049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10232),
  [15051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10237),
  [15053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [15055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4602),
  [15057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4226),
  [15059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4601),
  [15061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [15063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_declarator, 2, 0, 0),
  [15065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [15067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4700),
  [15069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [15071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [15073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5615),
  [15075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4597),
  [15077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4596),
  [15079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10355),
  [15081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10356),
  [15083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10359),
  [15085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7992),
  [15087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [15089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4706),
  [15091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9646),
  [15093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2521),
  [15095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [15097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [15099] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, 0, 113), SHIFT_REPEAT(6191),
  [15102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, 0, 113),
  [15104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [15106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [15108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4330),
  [15110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [15112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10008),
  [15114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2842),
  [15116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [15118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand, 4, 0, 221),
  [15120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5628),
  [15122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [15124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [15126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4684),
  [15128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7927),
  [15130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [15132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [15134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [15136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, 0, 152),
  [15138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [15140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4663),
  [15142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2843),
  [15144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6959),
  [15146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2831),
  [15148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7984),
  [15150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9848),
  [15152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 2, 0, 99),
  [15154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4397),
  [15156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7510),
  [15158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 2, 0, 0),
  [15160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 6, 0, 0),
  [15162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8433),
  [15164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3350),
  [15166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8456),
  [15168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [15170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_set, 2, 0, 0),
  [15172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 3, 3, 0),
  [15174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4199),
  [15176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3241),
  [15178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2196),
  [15180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7932),
  [15182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 3, 0, 0),
  [15184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4304),
  [15186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9844),
  [15188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 2, 0, 0),
  [15190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [15192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7933),
  [15194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2847),
  [15196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8259),
  [15198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9957),
  [15200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [15202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7980),
  [15204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [15206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2837),
  [15208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [15210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6946),
  [15212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4694),
  [15214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8571),
  [15216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [15218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [15220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10758),
  [15222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [15224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [15226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8511),
  [15228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4745),
  [15230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 5, 3, 0),
  [15232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_template_parameter_declaration, 3, 0, 57),
  [15234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9803),
  [15236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9924),
  [15238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [15240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10798),
  [15242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3479),
  [15244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9856),
  [15246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9203),
  [15248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10240),
  [15250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5644),
  [15252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9797),
  [15254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8601),
  [15256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [15258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [15260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10607),
  [15262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9060),
  [15264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10717),
  [15266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [15268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [15270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10303),
  [15272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6965),
  [15274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10165),
  [15276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [15278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10731),
  [15280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9912),
  [15282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9882),
  [15284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9793),
  [15286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10256),
  [15288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10263),
  [15290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3087),
  [15292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 2, 0, 0),
  [15294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 2, 0, 0),
  [15296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10235),
  [15298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10915),
  [15300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2212),
  [15302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10642),
  [15304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [15306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [15308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10788),
  [15310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9950),
  [15312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9721),
  [15314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 4, 0, 0),
  [15316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 4, 0, 0),
  [15318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9778),
  [15320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [15322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [15324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10518),
  [15326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10919),
  [15328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, 0, 223),
  [15330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [15332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10308),
  [15334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 3, 0, 0),
  [15336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [15338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10383),
  [15340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 3, 0, 99),
  [15342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 2, 0),
  [15344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [15346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10568),
  [15348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10922),
  [15350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6759),
  [15352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10422),
  [15354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9474),
  [15356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10864),
  [15358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [15360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10133),
  [15362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9752),
  [15364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9762),
  [15366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [15368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [15370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10831),
  [15372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4979),
  [15374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10606),
  [15376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10925),
  [15378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3590),
  [15380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9805),
  [15382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10027),
  [15384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9316),
  [15386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10520),
  [15388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10632),
  [15390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10928),
  [15392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9826),
  [15394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 3, 0, 0),
  [15396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 3, 0, 0),
  [15398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9558),
  [15400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10850),
  [15402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10656),
  [15404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10930),
  [15406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10666),
  [15408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10931),
  [15410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_pack_expansion, 2, 0, 28),
  [15412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10674),
  [15414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10932),
  [15416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [15418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10679),
  [15420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10933),
  [15422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10683),
  [15424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10934),
  [15426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10686),
  [15428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10935),
  [15430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_type_parameter_declaration, 3, 0, 155),
  [15432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3707),
  [15434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9224),
  [15436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 1, 0, 0),
  [15438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9664),
  [15440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10689),
  [15442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10936),
  [15444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10691),
  [15446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10937),
  [15448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10693),
  [15450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10938),
  [15452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [15454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10695),
  [15456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10939),
  [15458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9647),
  [15460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10697),
  [15462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10940),
  [15464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [15466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10563),
  [15468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [15470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9962),
  [15472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [15474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2765),
  [15476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9396),
  [15478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10094),
  [15480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 4, 0, 90),
  [15482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [15484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10917),
  [15486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, 0, 6),
  [15488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9853),
  [15490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5815),
  [15492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2924),
  [15494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [15496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10739),
  [15498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 4, 3, 0),
  [15500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9722),
  [15502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6853),
  [15504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 3, 0, 78),
  [15506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [15508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10580),
  [15510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 3, 0, 78),
  [15512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10037),
  [15514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10541),
  [15516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [15518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10584),
  [15520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2780),
  [15522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8987),
  [15524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10539),
  [15526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10626),
  [15528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8918),
  [15530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [15532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [15534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7314),
  [15536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10662),
  [15538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10509),
  [15540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [15542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [15544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10508),
  [15546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 5, 0, 77),
  [15548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8377),
  [15550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10630),
  [15552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4395),
  [15554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [15556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6985),
  [15558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10493),
  [15560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 5, 0, 125),
  [15562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8773),
  [15564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [15566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10492),
  [15568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9366),
  [15570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [15572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10744),
  [15574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8738),
  [15576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10482),
  [15578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10747),
  [15580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [15582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [15584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10481),
  [15586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [15588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3231),
  [15590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10476),
  [15592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10752),
  [15594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10755),
  [15596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [15598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10474),
  [15600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [15602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 5, 0, 175),
  [15604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10450),
  [15606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10417),
  [15608] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10411),
  [15611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [15613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10466),
  [15615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6831),
  [15617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [15619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10458),
  [15621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [15623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10490),
  [15625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10457),
  [15627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [15629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [15631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10453),
  [15633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8702),
  [15635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [15637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [15639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10452),
  [15641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4719),
  [15643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10521),
  [15645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10451),
  [15647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10617),
  [15649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 5, 0, 126),
  [15651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10443),
  [15653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10809),
  [15655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10812),
  [15657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [15659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [15661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10818),
  [15663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [15665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10826),
  [15667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4387),
  [15669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [15671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4195),
  [15673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10313),
  [15675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10885),
  [15677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8619),
  [15679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [15681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [15683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [15685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [15687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [15689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10618),
  [15691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [15693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4243),
  [15695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [15697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_parameter_list, 2, 0, 0),
  [15699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10923),
  [15701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4936),
  [15703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [15705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9771),
  [15707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10873),
  [15709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [15711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [15713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [15715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10830),
  [15717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7055),
  [15719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10807),
  [15721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [15723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [15725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [15727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3204),
  [15729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [15731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [15733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [15735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [15737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4235),
  [15739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10032),
  [15741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [15743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10391),
  [15745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [15747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [15749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3692),
  [15751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10597),
  [15753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3846),
  [15755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4407),
  [15757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2291),
  [15759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [15761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8924),
  [15763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [15765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [15767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4328),
  [15769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [15771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10420),
  [15773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7025),
  [15775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7852),
  [15777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [15779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [15781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 3, 0, 78),
  [15783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9989),
  [15785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10440),
  [15787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10414),
  [15789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8396),
  [15791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [15793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9403),
  [15795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [15797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10488),
  [15799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [15801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10408),
  [15803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [15805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8443),
  [15807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4904),
  [15809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [15811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8445),
  [15813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [15815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8469),
  [15817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4312),
  [15819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [15821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [15823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [15825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10447),
  [15827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8883),
  [15829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [15831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10390),
  [15833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10176),
  [15835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [15837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [15839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10428),
  [15841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2289),
  [15843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10421),
  [15845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10150),
  [15847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [15849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [15851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9105),
  [15853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [15855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [15857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10379),
  [15859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3257),
  [15861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8464),
  [15863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3872),
  [15865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10320),
  [15867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10373),
  [15869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [15871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8775),
  [15873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2375),
  [15875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [15877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10151),
  [15879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [15881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [15883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7843),
  [15885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 4, 0, 10),
  [15887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [15889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8505),
  [15891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [15893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [15895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7834),
  [15897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 4, 0, 78),
  [15899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [15901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3263),
  [15903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3261),
  [15905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [15907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4442),
  [15909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [15911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [15913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2754),
  [15915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [15917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4118),
  [15919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2612),
  [15921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10103),
  [15923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4952),
  [15925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6934),
  [15927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8521),
  [15929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [15931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [15933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [15935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [15937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef, 4, 0, 126),
  [15939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 4, 0, 125),
  [15941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [15943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4944),
  [15945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [15947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [15949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9310),
  [15951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [15953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [15955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4411),
  [15957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [15959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [15961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [15963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [15965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3317),
  [15967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4411),
  [15969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4911),
  [15971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [15973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [15975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10137),
  [15977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [15979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [15981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [15983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8525),
  [15985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [15987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10196),
  [15989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [15991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8369),
  [15993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8370),
  [15995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [15997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [15999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [16001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [16003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10162),
  [16005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10307),
  [16007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5091),
  [16009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_parameter_list, 4, 0, 0),
  [16011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [16013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [16015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10118),
  [16017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [16019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [16021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10099),
  [16023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [16025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [16027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unary_right_fold, 3, 0, 55),
  [16029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8999),
  [16031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [16033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9573),
  [16035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3251),
  [16037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10132),
  [16039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10178),
  [16041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [16043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [16045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [16047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3052),
  [16049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [16051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [16053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9960),
  [16055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [16057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4211),
  [16059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [16061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10472),
  [16063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [16065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4317),
  [16067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8399),
  [16069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8806),
  [16071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [16073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3181),
  [16075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2065),
  [16077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [16079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3249),
  [16081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10243),
  [16083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [16085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4656),
  [16087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3184),
  [16089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4567),
  [16091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4568),
  [16093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [16095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [16097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3222),
  [16099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3228),
  [16101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [16103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_based_modifier, 2, 0, 0),
  [16105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [16107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10592),
  [16109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [16111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [16113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [16115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4657),
  [16117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [16119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4716),
  [16121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [16123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [16125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5100),
  [16127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [16129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3206),
  [16131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [16133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3208),
  [16135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6110),
  [16137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [16139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [16141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [16143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3361),
  [16145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3351),
  [16147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [16149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3644),
  [16151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3328),
  [16153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3086),
  [16155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2198),
  [16157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4703),
  [16159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3304),
  [16161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4645),
  [16163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4655),
  [16165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [16167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [16169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9713),
  [16171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [16173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [16175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3832),
  [16177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [16179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10218),
  [16181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2547),
  [16183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [16185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3269),
  [16187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3296),
  [16189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9698),
  [16191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10262),
  [16193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5094),
  [16195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6852),
  [16197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [16199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10259),
  [16201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4893),
  [16203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [16205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10531),
  [16207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [16209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10250),
  [16211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [16213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10238),
  [16215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [16217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4726),
  [16219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10233),
  [16221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [16223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2466),
  [16225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_declaration, 3, 0, 142),
  [16227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [16229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3654),
  [16231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7421),
  [16233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [16235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7399),
  [16237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [16239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6987),
  [16241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3856),
  [16243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [16245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [16247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4352),
  [16249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [16251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4319),
  [16253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4318),
  [16255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [16257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9739),
  [16259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [16261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4086),
  [16263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6854),
  [16265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [16267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [16269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [16271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9763),
  [16273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [16275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10192),
  [16277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [16279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10081),
  [16281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2275),
  [16283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10190),
  [16285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4969),
  [16287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10186),
  [16289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4968),
  [16291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4967),
  [16293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [16295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3332),
  [16297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10181),
  [16299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [16301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [16303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [16305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3379),
  [16307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [16309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [16311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3377),
  [16313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [16315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [16317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [16319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5829),
  [16321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8513),
  [16323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9862),
  [16325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [16327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4227),
  [16329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [16331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [16333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [16335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [16337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9880),
  [16339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10161),
  [16341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6802),
  [16343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6804),
  [16345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [16347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10158),
  [16349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [16351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10155),
  [16353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6806),
  [16355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2525),
  [16357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10153),
  [16359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [16361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [16363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [16365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10423),
  [16367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4405),
  [16369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4488),
  [16371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9937),
  [16373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [16375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3900),
  [16377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4563),
  [16379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [16381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4693),
  [16383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [16385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10122),
  [16387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [16389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4701),
  [16391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [16393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10121),
  [16395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9104),
  [16397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10113),
  [16399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4906),
  [16401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [16403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [16405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10109),
  [16407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [16409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [16411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [16413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [16415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7854),
  [16417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10004),
  [16419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [16421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [16423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [16425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_parameter_list, 3, 0, 0),
  [16427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8426),
  [16429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [16431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [16433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10098),
  [16435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [16437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3059),
  [16439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10085),
  [16441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 6, 0, 175),
  [16443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10051),
  [16445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [16447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 4, 0, 125),
  [16449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10080),
  [16451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10074),
  [16453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [16455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10064),
  [16457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [16459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3218),
  [16461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10077),
  [16463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10084),
  [16465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10036),
  [16467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [16469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10091),
  [16471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10095),
  [16473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10018),
  [16475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [16477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10102),
  [16479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10106),
  [16481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9976),
  [16483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10112),
  [16485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10116),
  [16487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9963),
  [16489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10120),
  [16491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10124),
  [16493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10127),
  [16495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10131),
  [16497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10134),
  [16499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10138),
  [16501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10141),
  [16503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10145),
  [16505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10148),
  [16507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10152),
  [16509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3030),
  [16511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4035),
  [16513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [16515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [16517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10234),
  [16519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [16521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3929),
  [16523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4022),
  [16525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [16527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 4, 0, 125),
  [16529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [16531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4623),
  [16533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8745),
  [16535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10275),
  [16537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [16539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [16541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [16543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [16545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 4, 0, 126),
  [16547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 4, 0, 126),
  [16549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [16551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10840),
  [16553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7861),
  [16555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [16557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [16559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10231),
  [16561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [16563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9819),
  [16565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [16567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9685),
  [16569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2868),
  [16571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [16573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4445),
  [16575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [16577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5648),
  [16579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, 0, 125),
  [16581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 4, 0, 126),
  [16583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2881),
  [16585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [16587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3029),
  [16589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4458),
  [16591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [16593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [16595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [16597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [16599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [16601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [16603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10732),
  [16605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10297),
  [16607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8428),
  [16609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4435),
  [16611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [16613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7336),
  [16615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3567),
  [16617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [16619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [16621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [16623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4699),
  [16625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2484),
  [16627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2476),
  [16629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4431),
  [16631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 5, 0, 175),
  [16633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 5, 0, 175),
  [16635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [16637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [16639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4518),
  [16641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4519),
  [16643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4521),
  [16645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [16647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [16649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [16651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [16653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 5, 0, 175),
  [16655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [16657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4662),
  [16659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [16661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5729),
  [16663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4660),
  [16665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3156),
  [16667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2460),
  [16669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [16671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4603),
  [16673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [16675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3928),
  [16677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2939),
  [16679] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [16681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9630),
  [16683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3175),
  [16685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [16687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2459),
  [16689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [16691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [16693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10284),
  [16695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [16697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4612),
  [16699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [16701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [16703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3435),
  [16705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [16707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [16709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9840),
  [16711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [16713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [16715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [16717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [16719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9026),
  [16721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3849),
  [16723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3851),
  [16725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [16727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [16729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10517),
  [16731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4634),
  [16733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10364),
  [16735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [16737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [16739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [16741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8907),
  [16743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10532),
  [16745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [16747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [16749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [16751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [16753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [16755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [16757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [16759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10567),
  [16761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [16763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8866),
  [16765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10575),
  [16767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5674),
  [16769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [16771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10605),
  [16773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [16775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5698),
  [16777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8838),
  [16779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10612),
  [16781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [16783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [16785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10631),
  [16787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8816),
  [16789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10638),
  [16791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10566),
  [16793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [16795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [16797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10655),
  [16799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8802),
  [16801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10661),
  [16803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2428),
  [16805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [16807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8796),
  [16809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10669),
  [16811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9878),
  [16813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10676),
  [16815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef, 3, 0, 78),
  [16817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10680),
  [16819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [16821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10684),
  [16823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [16825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10687),
  [16827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4268),
  [16829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10690),
  [16831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4667),
  [16833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10692),
  [16835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4665),
  [16837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10694),
  [16839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4661),
  [16841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10696),
  [16843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [16845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10698),
  [16847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4050),
  [16849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10723),
  [16851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [16853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4025),
  [16855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10853),
  [16857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [16859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4006),
  [16861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10866),
  [16863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3431),
  [16865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3931),
  [16867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10875),
  [16869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [16871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3885),
  [16873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10883),
  [16875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [16877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10890),
  [16879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10894),
  [16881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10897),
  [16883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10899),
  [16885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10901),
  [16887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10903),
  [16889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10905),
  [16891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10907),
  [16893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10909),
  [16895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10911),
  [16897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10913),
  [16899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5668),
  [16901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [16903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [16905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8763),
  [16907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [16909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [16911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [16913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [16915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token_raw_string_delimiter = 0,
  ts_external_token_raw_string_content = 1,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_raw_string_delimiter] = sym_raw_string_delimiter,
  [ts_external_token_raw_string_content] = sym_raw_string_content,
};

static const bool ts_external_scanner_states[4][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_raw_string_delimiter] = true,
    [ts_external_token_raw_string_content] = true,
  },
  [2] = {
    [ts_external_token_raw_string_delimiter] = true,
  },
  [3] = {
    [ts_external_token_raw_string_content] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_slang_external_scanner_create(void);
void tree_sitter_slang_external_scanner_destroy(void *);
bool tree_sitter_slang_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_slang_external_scanner_serialize(void *, char *);
void tree_sitter_slang_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_slang(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_slang_external_scanner_create,
      tree_sitter_slang_external_scanner_destroy,
      tree_sitter_slang_external_scanner_scan,
      tree_sitter_slang_external_scanner_serialize,
      tree_sitter_slang_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
